CREATE TABLE `dsb_access_levels` (
  `level_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `level_code` varchar(30) NOT NULL,
  `level_diz` varchar(255) NOT NULL,
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `disabled_level` int(10) unsigned NOT NULL DEFAULT '0',
  `allow_na` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `is_visible` tinyint(1) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`level_id`),
  UNIQUE KEY `level_code` (`level_code`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_access_levels` (`level_id`, `level_code`, `level_diz`, `level`, `disabled_level`, `allow_na`, `is_visible`) VALUES
(1, 'login', 'when someone tries to login', 1, 65534, 0, 1),
(2, 'profile_view', 'View member profiles', 7, 0, 0, 0),
(21, 'search_photo', 'Search browse member photos', 7, 0, 0, 0),
(4, 'message_read', 'Read messages', 6, 1, 0, 0),
(5, 'message_write', 'Write messages', 6, 1, 0, 0),
(6, 'flirt_read', 'Read flirts', 6, 1, 0, 0),
(7, 'flirt_send', 'Send flirts', 6, 1, 0, 0),
(8, 'upload_photos', 'Upload photos', 6, 1, 0, 0),
(9, 'write_comments', 'Post comments', 6, 0, 0, 0),
(10, 'read_blogs', 'Read blogs', 7, 0, 0, 0),
(11, 'write_blogs', 'Write own blogs', 6, 1, 0, 0),
(13, 'view_photo', 'View larger single photos', 7, 0, 0, 0),
(14, 'manage_folders', 'Manage personal mail folders', 6, 1, 0, 0),
(15, 'saved_messages', 'Use saved responses feature', 6, 1, 0, 0),
(16, 'search_basic', 'Use the basic quick search forms', 7, 0, 0, 0),
(17, 'search_advanced', 'Use the advanced search form', 7, 0, 0, 0),
(18, 'manage_networks', 'Manage members in your networks', 6, 1, 0, 0),
(19, 'save_searches', 'Save personal searches', 6, 1, 0, 0),
(22, 'inbox', 'View messages in inbox', 6, 1, 0, 0),
(23, 'search_blog', 'Search browse blogs', 7, 0, 0, 0),
(24, 'contact', 'Use site contact form', 7, 0, 0, 1),
(25, 'message_reply', 'Reply to messages', 6, 1, 0, 0),
(26, 'flirt_reply', 'Reply to flirts', 6, 1, 0, 0),
(27, 'private_photos', 'Access to Member''s Private Photos', 6, 0, 0, 0),
(28, 'paid', 'Paid Access Only', 0, 0, 0, 1);

CREATE TABLE `dsb_admin_accounts` (
  `admin_id` int(3) unsigned NOT NULL AUTO_INCREMENT,
  `user` varchar(20) NOT NULL,
  `pass` varchar(32) NOT NULL,
  `name` varchar(50) NOT NULL,
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `dept_id` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `email` varchar(64) NOT NULL,
  PRIMARY KEY (`admin_id`),
  UNIQUE KEY `user` (`user`)
) ENGINE=MyISAM pack_keys=0;

INSERT INTO `dsb_admin_accounts` (`admin_id`, `user`, `pass`, `name`, `status`, `dept_id`, `email`) VALUES
(1, 'admin', 'fe01ce2a7fbac8fafaed7c982a04e229', 'Main Admin', 15, 4, '');

CREATE TABLE `dsb_admin_menu` (
  `link_id` int(3) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) NOT NULL,
  `link_text` varchar(100) NOT NULL,
  `link_type` tinyint(2) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`link_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE `dsb_admin_mtpls` (
  `amtpl_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `amtpl_name` varchar(40) NOT NULL,
  `subject` varchar(100) NOT NULL,
  `message_body` text NOT NULL,
  `amtpl_type` tinyint(2) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`amtpl_id`),
  KEY `amtpl_type` (`amtpl_type`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=5 ;

INSERT INTO `dsb_admin_mtpls` (`amtpl_id`, `amtpl_name`, `subject`, `message_body`, `amtpl_type`) VALUES
(1, 'Reject member profile', 'Your profile was not approved', '<html><head><title>Your profile has not been approved</title>   <link href="{tplvars.baseurl}/skins/def/styles/common.css" media="screen" type="text/css" rel="stylesheet" /> </head><body> <div id="trim"> 	<div id="content"> 		<p>Thank you for joining <a href="{tplvars.baseurl}">{tplvars.sitename}</a>.</p> 		<p>Unfortunately we are unable to publish your profile on the site yet because it doesn''t contain enough information to be of interest to other members.</p><p>Please update your profile with relevant information.<br /></p> 	</div> </div> </body></html>', 1),
(2, 'Reject photo', 'One of your photos was not approved', '<html><head><title>Your photo has not been approved</title>                       <link href="{tplvars.baseurl}/skins/def/styles/common.css" media="screen" type="text/css" rel="stylesheet" />     </head><body spellcheck="false"><p>Unfortunately we are unable to publish your photo on the site yet because</p>         <p>&nbsp;</p>         <p>Regards,<br />{tplvars.sitename} admin</p></body></html>', 2),
(3, 'Reject blog', 'One of your blog posts was not approved', '<html><head><title>Your blog post has not been approved</title>                       <link rel="stylesheet" type="text/css" media="screen" href="{tplvars.baseurl}/skins/def/styles/common.css" />     </head><body spellcheck="false"><p>Unfortunately we are unable to publish your blog post on the site yet because</p>         <p>&nbsp;</p>         <p>Regards,<br />         {tplvars.sitename} admin</p></body></html>', 3),
(4, 'Reject comment', 'One of your comments was not approved', '<html><head><title>Your comment has not been approved</title>                       <link rel="stylesheet" type="text/css" media="screen" href="{tplvars.baseurl}/skins/def/styles/common.css" />     </head><body spellcheck="false"><p>Unfortunately we are unable to publish your comment on the site yet because</p>         <p>&nbsp;</p>         <p>Regards,<br />         {tplvars.sitename} admin</p></body></html>', 4);

CREATE TABLE `dsb_banned_words` (
  `word_id` int(5) unsigned NOT NULL AUTO_INCREMENT,
  `word` varchar(100) NOT NULL,
  PRIMARY KEY (`word_id`),
  UNIQUE KEY `word` (`word`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_banned_words` (`word_id`, `word`) VALUES
(5, 'fuck'),
(6, 'suck'),
(7, 'sucks'),
(8, 'dick'),
(9, 'cock'),
(10, 'penis');

CREATE TABLE `dsb_blog_posts` (
  `post_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `date_posted` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `_user` varchar(48) NOT NULL,
  `fk_blog_id` int(10) unsigned NOT NULL DEFAULT '0',
  `is_public` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `title` varchar(200) NOT NULL,
  `post_content` text NOT NULL,
  `allow_comments` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `alt_url` text NOT NULL,
  `stat_views` int(5) unsigned NOT NULL DEFAULT '0',
  `stat_votes` int(4) unsigned NOT NULL DEFAULT '0',
  `stat_votes_total` int(5) unsigned NOT NULL DEFAULT '0',
  `stat_comments` int(5) unsigned NOT NULL DEFAULT '0',
  `last_changed` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reject_reason` text NOT NULL,
  `processed` tinyint(2) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`post_id`),
  KEY `is_public` (`is_public`),
  KEY `date_posted` (`date_posted`),
  KEY `uid_pub_stat` (`fk_user_id`,`is_public`,`status`),
  KEY `bid_pub_stat` (`fk_blog_id`,`is_public`,`status`),
  FULLTEXT KEY `text_key` (`title`,`post_content`)
) ENGINE=MyISAM pack_keys=0;

CREATE TABLE `dsb_comments_blog` (
  `comment_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fk_parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `_user` varchar(48) NOT NULL,
  `comment` text NOT NULL,
  `date_posted` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `last_changed` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `processed` tinyint(2) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_id`),
  KEY `fk_user_id` (`fk_user_id`),
  KEY `date_posted` (`date_posted`),
  KEY `pid_stat` (`fk_parent_id`,`status`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_comments_photo` (
  `comment_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fk_parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `_user` varchar(48) NOT NULL,
  `comment` text NOT NULL,
  `date_posted` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `last_changed` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `processed` tinyint(2) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_id`),
  KEY `fk_user_id` (`fk_user_id`),
  KEY `date_posted` (`date_posted`),
  KEY `pid_stat` (`fk_parent_id`,`status`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_comments_profile` (
  `comment_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fk_parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `_user` varchar(48) NOT NULL,
  `comment` text NOT NULL,
  `date_posted` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `last_changed` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `processed` tinyint(2) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_id`),
  KEY `fk_user_id` (`fk_user_id`),
  KEY `date_posted` (`date_posted`),
  KEY `pid_stat` (`fk_parent_id`,`status`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_error_log` (
  `log_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `module` varchar(48) NOT NULL,
  `error` text NOT NULL,
  `error_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`log_id`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_feed_cache` (
  `module_code` varchar(32) NOT NULL,
  `feed_xml` text NOT NULL,
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`module_code`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_flirts` (
  `flirt_id` int(3) unsigned NOT NULL AUTO_INCREMENT,
  `flirt_text` text NOT NULL,
  `flirt_type` tinyint(2) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`flirt_id`),
  KEY `flirt_type` (`flirt_type`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_flirts` (`flirt_id`, `flirt_text`, `flirt_type`) VALUES
(5, 'Hey sexy!', 0),
(6, 'Whaaadddup!', 0),
(4, 'I hope you know CPR, cuz you take my breath away...', 0),
(7, 'Hello? Hello? Anybody there?', 0),
(8, 'In your dreams', 1),
(9, 'Maybe later', 1),
(10, 'Sure, let''s go', 1);

CREATE TABLE `dsb_lang_keys` (
  `lk_id` int(5) unsigned NOT NULL AUTO_INCREMENT,
  `alt_id_text` varchar(40) NOT NULL,
  `lk_type` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `lk_diz` varchar(255) NOT NULL,
  `lk_use` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `save_file` varchar(100) NOT NULL,
  PRIMARY KEY (`lk_id`,`lk_use`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_lang_keys` (`lk_id`, `alt_id_text`, `lk_type`, `lk_diz`, `lk_use`, `save_file`) VALUES
(1, '', 2, 'account not found', 2, 'join.inc.php'),
(2, '', 2, 'invalid blog', 2, 'blogs.inc.php'),
(3, '', 2, 'email changed ok', 2, 'email_change.inc.php'),
(4, '', 2, 'invalid email change request', 2, 'email_change.inc.php'),
(5, '', 2, 'no such message', 2, 'mailbox.inc.php'),
(6, '', 2, 'invalid photo', 2, 'photos.inc.php'),
(7, '', 2, 'Member not found.', 2, ''),
(8, '', 2, 'no search for less than 4 chars', 2, ''),
(9, '', 2, 'just one vote a day for a photo', 2, 'rating.inc.php'),
(10, '', 2, 'no vote for own photos', 2, 'rating.inc.php'),
(11, '', 2, 'invalid vote', 2, 'rating.inc.php'),
(12, '', 2, 'login to rate', 2, 'rating.inc.php'),
(13, '', 2, 'enter blog title', 2, 'blogs.inc.php'),
(14, '', 2, 'blog changed ok', 2, 'blogs.inc.php'),
(15, '', 2, 'blog added ok', 2, 'blogs.inc.php'),
(16, '', 2, 'blog deleted ok', 2, 'blogs.inc.php'),
(17, '', 2, 'add blog post title', 2, 'blogs.inc.php'),
(18, '', 2, 'add blog post content', 2, 'blogs.inc.php'),
(19, '', 2, 'blog post changed ok', 2, 'blogs.inc.php'),
(20, '', 2, 'blog post added ok', 2, 'blogs.inc.php'),
(21, '', 2, 'blog post added ok but needs approval', 2, 'blogs.inc.php'),
(22, '', 2, 'blog post deleted ok', 2, 'blogs.inc.php'),
(23, '', 2, 'enter comment', 2, 'comments.inc.php'),
(24, '', 2, 'bad captcha entered', 2, ''),
(25, '', 2, 'comment changed ok', 2, 'comments.inc.php'),
(26, '', 2, 'comment changed ok but needs approval', 2, 'comments.inc.php'),
(27, '', 2, 'not allowed to edit comments', 2, 'comments.inc.php'),
(28, '', 2, 'comment added ok', 2, 'comments.inc.php'),
(29, '', 2, 'comment added ok but needs approval', 2, 'comments.inc.php'),
(30, '', 2, 'comment deleted ok', 2, 'comments.inc.php'),
(31, '', 2, 'not allowed to delete comment', 2, 'comments.inc.php'),
(32, '', 2, 'enter subject', 2, 'contact.inc.php'),
(33, '', 2, 'need email to contact you back', 2, 'contact.inc.php'),
(34, '', 2, 'enter message', 2, 'contact.inc.php'),
(35, '', 2, 'message not sent', 2, 'contact.inc.php'),
(36, '', 2, 'message sent ok', 2, 'contact.inc.php'),
(37, '', 2, 'emails don''t match', 2, 'join.inc.php'),
(38, '', 2, 'enter new email address', 2, 'email_change.inc.php'),
(39, '', 2, 'email change confirmation sent ok', 2, 'email_change.inc.php'),
(40, '', 2, 'email subject: email change confirmation', 2, 'email_change.inc.php'),
(41, '', 2, 'filter not saved because no such user', 2, 'mailbox.inc.php'),
(42, '', 2, 'filter changed ok', 2, 'mailbox.inc.php'),
(43, '', 2, 'filter not changed', 2, 'mailbox.inc.php'),
(44, '', 2, 'filter added ok', 2, 'mailbox.inc.php'),
(45, '', 2, 'filter not added', 2, 'mailbox.inc.php'),
(46, '', 2, 'filter deleted ok', 2, 'mailbox.inc.php'),
(47, '', 2, 'flirt not sent because no receiver', 2, 'mailbox.inc.php'),
(48, '', 2, 'select a flirt', 2, 'mailbox.inc.php'),
(49, '', 2, 'no such flirt in db', 2, 'mailbox.inc.php'),
(50, '', 2, 'flirt sent ok', 2, 'mailbox.inc.php'),
(51, '', 2, 'folder renamed', 2, 'mailbox.inc.php'),
(52, '', 2, 'folder exists', 2, 'mailbox.inc.php'),
(53, '', 2, 'folder added ok', 2, 'mailbox.inc.php'),
(54, '', 2, 'folder exists, not added', 2, 'mailbox.inc.php'),
(55, '', 2, 'folder deleted ok', 2, 'mailbox.inc.php'),
(56, '', 2, 'passwords don''t match', 2, 'pass_change.inc.php'),
(57, '', 2, 'enter password', 2, 'pass_change.inc.php'),
(58, '', 2, 'invalid params', 2, 'pass_change.inc.php'),
(59, '', 2, 'password changed ok', 2, 'pass_change.inc.php'),
(60, '', 2, 'password not changed, invalid user', 2, 'pass_change.inc.php'),
(61, '', 2, 'x connections added', 2, 'net.inc.php'),
(62, '', 2, 'x connections declined', 2, 'net.inc.php'),
(63, '', 2, 'invalid user', 2, 'join.inc.php'),
(64, '', 2, 'account exists', 2, 'join.inc.php'),
(65, '', 2, 'invalid password', 2, 'join.inc.php'),
(66, '', 2, 'invalid email', 2, 'join.inc.php'),
(67, '', 2, 'email already exists', 2, 'join.inc.php'),
(68, '', 2, 'must agree to terms', 2, 'join.inc.php'),
(69, '', 2, 'fields must not be empty', 2, ''),
(70, '', 2, 'email subject: user registration', 2, 'join.inc.php'),
(71, '', 2, 'account suspended', 2, 'login.inc.php'),
(72, '', 2, 'invalid user or pass', 2, 'login.inc.php'),
(73, '', 2, 'x messages deleted', 2, 'mailbox.inc.php'),
(74, '', 2, 'x messages moved', 2, 'mailbox.inc.php'),
(75, '', 2, 'message not sent, no receiver', 2, 'mailbox.inc.php'),
(76, '', 2, 'response deleted ok', 2, 'mailbox.inc.php'),
(77, '', 2, 'ok', 2, ''),
(78, '', 2, 'enter title for search', 2, 'my_searches.inc.php'),
(79, '', 2, 'search title saved', 2, 'my_searches.inc.php'),
(80, '', 2, 'preferences saved ok', 2, 'my_settings.inc.php'),
(81, '', 2, 'invalid user to add/del to/from network', 2, 'net.inc.php'),
(82, '', 2, 'invalid network', 2, 'net.inc.php'),
(83, '', 2, 'confirmation request sent', 2, 'net.inc.php'),
(84, '', 2, 'message subject: confirmation request', 2, 'net.inc.php'),
(85, '', 2, 'confirmation request message', 2, 'net.inc.php'),
(86, '', 2, 'member added to network', 2, 'net.inc.php'),
(87, '', 2, 'member removed from network', 2, 'net.inc.php'),
(88, '', 2, 'password changed ok', 2, 'pass_change.inc.php'),
(89, '', 2, 'pass reset email sent', 2, 'pass_change.inc.php'),
(90, '', 2, 'entered email not found', 2, 'pass_change.inc.php'),
(91, '', 2, 'photo deleted ok', 2, 'photos.inc.php'),
(92, '', 2, 'photo settings changed ok', 2, 'photos.inc.php'),
(93, '', 2, 'photo upload error', 2, 'photos.inc.php'),
(94, '', 2, 'photo not uploaded because of min size', 2, 'photos.inc.php'),
(95, '', 2, 'photo not uploaded because of max size', 2, 'photos.inc.php'),
(96, '', 2, 'x photos uploaded ok', 2, 'photos.inc.php'),
(97, '', 2, 'no photo uploaded', 2, 'photos.inc.php'),
(98, '', 2, 'no search selected', 2, 'my_searches.inc.php'),
(99, '', 2, 'search saved', 2, 'my_searches.inc.php'),
(100, '', 2, 'profile changed ok', 2, ''),
(101, '', 2, 'search deleted ok', 2, 'my_searches.inc.php'),
(102, '', 2, 'is online', 2, ''),
(103, '', 2, 'is offline', 2, ''),
(104, '', 2, 'title: latest blogs', 2, 'blogs.inc.php'),
(105, '', 2, 'title: most popular blogs', 2, 'blogs.inc.php'),
(106, '', 2, 'title: most discussed blogs', 2, 'blogs.inc.php'),
(107, '', 2, 'title: search results', 2, ''),
(108, '', 2, 'title: ***''s blogs', 2, 'blogs.inc.php'),
(109, '', 2, 'title: blog posts', 2, 'blogs.inc.php'),
(110, '', 2, 'inbox', 2, 'mailbox.inc.php'),
(111, '', 2, 'sent', 2, 'mailbox.inc.php'),
(112, '', 2, 'Trash', 2, 'mailbox.inc.php'),
(113, '', 2, 'spambox', 2, 'mailbox.inc.php'),
(114, '', 2, 'user: x', 2, 'mailbox.inc.php'),
(115, '', 2, 'title: manage your filters', 2, 'mailbox.inc.php'),
(116, '', 2, 'title: message filters', 2, 'mailbox.inc.php'),
(117, '', 2, 'user', 2, ''),
(118, '', 2, 'users with x', 2, 'mailbox.inc.php'),
(119, '', 2, 'title: add/edit a filter', 2, 'mailbox.inc.php'),
(120, '', 2, 'no receiver specified', 2, 'mailbox.inc.php'),
(121, '', 2, 'title: send a flirt', 2, 'mailbox.inc.php'),
(122, '', 2, 'title: my personal folders', 2, 'mailbox.inc.php'),
(123, '', 2, 'never', 2, 'home.php'),
(124, '', 2, 'title: my home', 2, 'home.php'),
(125, '', 2, 'remaining chars', 2, ''),
(126, '', 2, 'country', 2, ''),
(127, '', 2, 'state', 2, ''),
(128, '', 2, 'city', 2, ''),
(129, '', 2, 'zip code', 2, ''),
(130, '', 2, 'title: registration', 2, 'join.inc.php'),
(131, '', 2, 'day', 2, ''),
(132, '', 2, 'year', 2, ''),
(133, '', 2, 'state', 2, ''),
(134, '', 2, 'select city', 2, ''),
(135, '', 2, 'SYSTEM', 2, 'mailbox.inc.php'),
(136, '', 2, 'title: read message', 2, 'mailbox.inc.php'),
(137, '', 2, 'title: write to x', 2, 'mailbox.inc.php'),
(138, '', 2, 'private', 2, 'photos.inc.php'),
(139, '', 2, 'public', 2, 'photos.inc.php'),
(140, '', 2, 'title: my photos', 2, 'photos.inc.php'),
(141, '', 2, 'title: my profile', 2, ''),
(142, '', 2, 'title: Saved Responses', 2, 'mailbox.inc.php'),
(143, '', 2, 'title: ***''s photos', 2, 'photos.inc.php'),
(144, '', 2, 'title: Newest Photos', 2, 'photos.inc.php'),
(145, '', 2, 'title: Most Popular Photos', 2, 'photos.inc.php'),
(146, '', 2, 'title: Most Voted Photos', 2, 'photos.inc.php'),
(147, '', 2, 'title: Most Discussed Photos', 2, 'photos.inc.php'),
(148, '', 2, 'title: results for "search"', 2, ''),
(149, '', 2, 'upload unlimited num of photos', 2, 'photos.inc.php'),
(150, '', 2, 'upload x more photos', 2, 'photos.inc.php'),
(151, '', 2, 'title: upload photos', 2, 'photos.inc.php'),
(152, '', 2, 'title: ***''s profile', 2, ''),
(153, '', 2, 'online now', 2, ''),
(154, '', 2, 'today', 2, ''),
(155, '', 2, 'yesterday', 2, ''),
(156, '', 2, 'last week', 2, ''),
(157, '', 2, 'last month', 2, ''),
(158, '', 2, 'more than a month ago', 2, ''),
(159, '', 2, 'any', 2, ''),
(160, '', 2, 'subject for new comment on blog notif', 2, 'comments.inc.php'),
(161, '', 2, 'message for new comment on blog notif', 2, 'comments.inc.php'),
(162, '', 2, 'subject for new comment on photo notif', 2, 'comments.inc.php'),
(163, '', 2, 'message for new comment on photo notif', 2, 'comments.inc.php'),
(164, '', 2, 'subject for new comment on profile notif', 2, 'comments.inc.php'),
(165, '', 2, 'message for new comment on profile notif', 2, 'comments.inc.php'),
(166, '', 2, 'month', 2, ''),
(167, '', 2, 'jan', 2, ''),
(168, '', 2, 'feb', 2, ''),
(169, '', 2, 'mar', 2, ''),
(170, '', 2, 'apr', 2, ''),
(171, '', 2, 'may', 2, ''),
(172, '', 2, 'jun', 2, ''),
(173, '', 2, 'jul', 2, ''),
(174, '', 2, 'aug', 2, ''),
(175, '', 2, 'sep', 2, ''),
(176, '', 2, 'oct', 2, ''),
(177, '', 2, 'nov', 2, ''),
(178, '', 2, 'dec', 2, ''),
(179, '', 2, 'pager: pages', 2, ''),
(180, '', 2, 'pager: results to show', 2, ''),
(181, '', 2, 'pager: go to first page', 2, ''),
(182, '', 2, 'pager: go to last page', 2, ''),
(183, '', 2, 'pager: go to next page', 2, ''),
(184, '', 2, 'pager: go to previous page', 2, ''),
(185, '', 2, 'distance', 2, ''),
(186, '', 2, 'miles from zip', 2, ''),
(187, '', 2, 'error processing payment', 2, 'payment.inc.php'),
(188, '', 2, 'error: paid amount doesn''t match subscription price', 2, 'payment.inc.php'),
(189, '', 2, 'error: invalid subscription', 2, 'payment.inc.php'),
(190, '', 2, 'paypal error: payment still pending', 2, 'payment.inc.php'),
(191, '', 2, 'paypal error: unhandled transaction type', 2, 'payment.inc.php'),
(192, '', 2, 'error: user not found', 2, 'payment.inc.php'),
(193, '', 2, 'error: invalid payment type', 2, 'payment.inc.php'),
(194, '', 2, 'emails don''t match', 2, 'email_change.inc.php'),
(195, '', 2, 'select country', 2, ''),
(196, '', 2, 'enter subject', 2, 'mailbox.inc.php'),
(197, '', 2, 'enter message', 2, 'mailbox.inc.php'),
(198, '', 2, 'message sent ok', 2, 'mailbox.inc.php'),
(199, '', 2, 'error: failed internal validation', 2, 'payment.inc.php'),
(200, '', 2, 'error trying to process the credit card', 2, 'payment.inc.php'),
(201, '', 2, 'error trying to process the credit card', 2, 'payment.inc.php'),
(202, '', 2, 'page title: Browse Blogs', 2, 'blogs.inc.php'),
(203, '', 2, 'last edited by xx on yy', 2, 'comments.inc.php'),
(204, '', 2, 'email already exists', 2, 'email_change.inc.php'),
(205, '', 2, 'More Blogs', 2, 'blogs.inc.php'),
(206, '', 2, 'title: Contact Us', 2, 'contact.inc.php'),
(207, '', 2, 'title: latest comments', 2, 'blogs.inc.php'),
(208, '', 2, 'title: Newest Members', 2, ''),
(209, '', 2, 'title: Most Voted Members', 2, ''),
(210, '', 2, 'title: Most Popular Members', 2, ''),
(211, '', 2, 'title: Most Discussed Members', 2, ''),
(212, '', 2, 'title: OS tech feed', 2, 'plugins/widget/osignal_feed/osignal_feed.class.php'),
(213, '', 2, 'title: Photos', 2, 'photos.inc.php'),
(214, '', 2, 'more photos', 2, 'photos.inc.php'),
(215, '', 2, 'title: site news', 2, 'plugins/widget/site_news/site_news.class.php'),
(216, '', 2, 'message subject: x sent you a kiss', 2, 'mailbox.inc.php'),
(217, '', 2, 'email subject: new matches', 2, ''),
(218, '', 2, 'email subject: subscription is about to expire', 2, ''),
(219, '', 2, 'More Members', 2, ''),
(220, '', 2, 'title: Add/Edit a Blog', 2, 'blogs.inc.php'),
(221, '', 2, 'title: blog name : post title', 2, 'blogs.inc.php'),
(222, '', 2, 'title: blog name - post title', 2, 'blogs.inc.php'),
(223, '', 2, 'title: Add/Edit a Post in blog', 2, 'blogs.inc.php'),
(224, '', 2, 'title: Change Password', 2, 'pass_change.inc.php'),
(225, '', 2, 'email subject: password reset confirmation', 2, 'pass_change.inc.php'),
(226, '', 2, 'title: Friendship Requests', 2, 'net.inc.php'),
(227, '', 2, 'title: Information', 2, 'info.php'),
(228, '', 2, 'title: Signup successful', 2, 'info.php'),
(229, '', 2, 'title: Upgrade', 2, 'info.php'),
(230, '', 2, 'title: Email sent', 2, 'info.php'),
(231, '', 2, 'title: Activate your account', 2, 'info.php'),
(232, '', 2, 'title: Account successfully confirmed', 2, 'info.php'),
(233, '', 2, 'title: No access until approved', 2, 'info.php'),
(234, '', 2, 'title: Subscribe', 2, 'info.php'),
(235, '', 2, 'title: Message', 2, 'info.php'),
(236, '', 2, 'title: Login', 2, 'login.inc.php'),
(237, '', 2, 'title: Login to continue', 2, 'login.inc.php'),
(238, '', 2, 'title: Posts in blog', 2, 'blogs.inc.php'),
(239, '', 2, 'title: My Blogs', 2, 'blogs.inc.php'),
(240, '', 2, 'title: How I am connected', 2, 'net.inc.php'),
(241, '', 2, 'title: Photo Settings', 2, 'photos.inc.php'),
(242, '', 2, 'title: My Searches', 2, 'my_searches.inc.php'),
(243, '', 2, 'title: My Settings', 2, 'my_settings.inc.php'),
(244, '', 2, 'title: Lost Password', 2, 'pass_change.inc.php'),
(245, '', 2, 'title: Compare Memberships', 2, 'payment.inc.php'),
(246, '', 2, 'title: Privacy', 2, 'privacy.php'),
(247, '', 2, 'title: Advanced Search', 2, ''),
(248, '', 2, 'title: Upgrade Your Membership', 2, 'payment.inc.php'),
(249, '', 2, 'title: Thank you for your payment', 2, 'payment.inc.php'),
(250, '', 2, 'title: Terms of Service', 2, 'tos.php'),
(251, '', 2, 'Subscribe to latest blog comments feed', 2, 'blogs.inc.php'),
(252, '', 2, 'You are not allowed to edit this comment', 2, 'comments.inc.php'),
(253, '', 2, 'Please enter a name to remember this search:', 2, ''),
(254, '', 2, 'error saving search', 2, ''),
(255, '', 2, 'Thank you for your vote', 2, 'rating.inc.php'),
(256, '', 2, 'comment remove confirmation', 2, ''),
(257, '', 2, 'Please select at least one photo to upload!', 2, 'photos.inc.php'),
(258, '', 2, 'please enter your email address', 2, 'pass_change.inc.php'),
(259, '', 2, 'enter captcha code', 2, ''),
(260, '', 2, 'Please enter the new password', 2, 'my_settings.inc.php'),
(261, '', 2, 'The passwords do not match', 2, 'my_settings.inc.php'),
(262, '', 2, 'delete blog and all posts?', 2, 'blogs.inc.php'),
(263, '', 2, 'Message saved as template', 2, 'mailbox.inc.php'),
(264, '', 2, 'not allowed to save message templates', 2, 'mailbox.inc.php'),
(265, '', 2, 'enter the new password', 2, 'pass_change.inc.php'),
(266, '', 2, 'The passwords do not match.', 2, 'pass_change.inc.php'),
(267, '', 2, 'enter folder name', 2, 'mailbox.inc.php'),
(268, '', 2, 'delete folder and all messages?', 2, 'mailbox.inc.php'),
(269, '', 2, 'enter new folder name', 2, 'mailbox.inc.php'),
(270, '', 2, 'delete this filter?', 2, 'mailbox.inc.php'),
(271, '', 2, 'enter a search term', 2, 'blogs.inc.php'),
(272, '', 2, 'Username is OK.', 2, 'join.inc.php'),
(273, '', 2, 'block this member?', 2, ''),
(274, '', 2, 'unblock this member?', 2, ''),
(275, '', 2, 'thanks for cancelling', 2, ''),
(276, '', 2, 'you sure you want to cancel?', 2, ''),
(2275, '', 2, 'Category name', 1, ''),
(2276, '', 2, 'Category name', 1, ''),
(2277, '', 2, 'Category name', 1, ''),
(2278, '', 2, 'Category name', 1, ''),
(2279, '', 2, 'Category name', 1, ''),
(2280, '', 2, 'Field value', 1, ''),
(2281, '', 2, 'Field value', 1, ''),
(2282, '', 2, 'Label for f1 field', 1, ''),
(2283, '', 2, 'Search label for f1 field', 1, ''),
(2284, '', 4, 'Help text for f1 field', 1, ''),
(2285, '', 2, 'Field value', 1, ''),
(2286, '', 2, 'Field value', 1, ''),
(2287, '', 2, 'Label for f2 field', 1, ''),
(2288, '', 2, 'Search label for f2 field', 1, ''),
(2289, '', 4, 'Help text for f2 field', 1, ''),
(2290, '', 2, 'Label for f3 field', 1, ''),
(2291, '', 2, 'Search label for f3 field', 1, ''),
(2292, '', 4, 'Help text for f3 field', 1, ''),
(2293, '', 2, 'Label for f4 field', 1, ''),
(2294, '', 2, 'Search label for f4 field', 1, ''),
(2295, '', 4, 'Help text for f4 field', 1, ''),
(2296, '', 2, 'Label for f5 field', 1, ''),
(2297, '', 2, 'Search label for f5 field', 1, ''),
(2298, '', 4, 'Help text for f5 field', 1, ''),
(2299, '', 2, 'Field value', 1, ''),
(2300, '', 2, 'Field value', 1, ''),
(2301, '', 2, 'Field value', 1, ''),
(2302, '', 2, 'Field value', 1, ''),
(2303, '', 2, 'Field value', 1, ''),
(2304, '', 2, 'Field value', 1, ''),
(2305, '', 2, 'Field value', 1, ''),
(2306, '', 2, 'Field value', 1, ''),
(2307, '', 2, 'Field value', 1, ''),
(2308, '', 2, 'Label for f6 field', 1, ''),
(2309, '', 2, 'Search label for f6 field', 1, ''),
(2310, '', 4, 'Help text for f6 field', 1, ''),
(2311, '', 2, 'Field value', 1, ''),
(2312, '', 2, 'Field value', 1, ''),
(2313, '', 2, 'Field value', 1, ''),
(2314, '', 2, 'Field value', 1, ''),
(2315, '', 2, 'Field value', 1, ''),
(2316, '', 2, 'Field value', 1, ''),
(2317, '', 2, 'Field value', 1, ''),
(2318, '', 2, 'Field value', 1, ''),
(2319, '', 2, 'Field value', 1, ''),
(2320, '', 2, 'Field value', 1, ''),
(2321, '', 2, 'Field value', 1, ''),
(2322, '', 2, 'Field value', 1, ''),
(2323, '', 2, 'Label for f7 field', 1, ''),
(2324, '', 2, 'Search label for f7 field', 1, ''),
(2325, '', 4, 'Help text for f7 field', 1, ''),
(2326, '', 2, 'Field value', 1, ''),
(2327, '', 2, 'Field value', 1, ''),
(2328, '', 2, 'Field value', 1, ''),
(2329, '', 2, 'Field value', 1, ''),
(2330, '', 2, 'Field value', 1, ''),
(2331, '', 2, 'Field value', 1, ''),
(2332, '', 2, 'Field value', 1, ''),
(2333, '', 2, 'Field value', 1, ''),
(2334, '', 2, 'Field value', 1, ''),
(2335, '', 2, 'Field value', 1, ''),
(2336, '', 2, 'Field value', 1, ''),
(2337, '', 2, 'Label for f8 field', 1, ''),
(2338, '', 2, 'Search label for f8 field', 1, ''),
(2339, '', 4, 'Help text for f8 field', 1, ''),
(2340, '', 2, 'Field value', 1, ''),
(2341, '', 2, 'Field value', 1, ''),
(2342, '', 2, 'Field value', 1, ''),
(2343, '', 2, 'Field value', 1, ''),
(2344, '', 2, 'Field value', 1, ''),
(2345, '', 2, 'Field value', 1, ''),
(2346, '', 2, 'Label for f9 field', 1, ''),
(2347, '', 2, 'Search label for f9 field', 1, ''),
(2348, '', 4, 'Help text for f9 field', 1, ''),
(2349, '', 2, 'Field value', 1, ''),
(2350, '', 2, 'Field value', 1, ''),
(2351, '', 2, 'Field value', 1, ''),
(2352, '', 2, 'Field value', 1, ''),
(2353, '', 2, 'Field value', 1, ''),
(2354, '', 2, 'Field value', 1, ''),
(2355, '', 2, 'Field value', 1, ''),
(2356, '', 2, 'Field value', 1, ''),
(2357, '', 2, 'Field value', 1, ''),
(2358, '', 2, 'Label for f10 field', 1, ''),
(2359, '', 2, 'Search label for f10 field', 1, ''),
(2360, '', 4, 'Help text for f10 field', 1, ''),
(2361, '', 2, 'Field value', 1, ''),
(2362, '', 2, 'Field value', 1, ''),
(2363, '', 2, 'Field value', 1, ''),
(2364, '', 2, 'Label for f11 field', 1, ''),
(2365, '', 2, 'Search label for f11 field', 1, ''),
(2366, '', 4, 'Help text for f11 field', 1, ''),
(2367, '', 2, 'Field value', 1, ''),
(2368, '', 2, 'Field value', 1, ''),
(2369, '', 2, 'Field value', 1, ''),
(2370, '', 2, 'Label for f12 field', 1, ''),
(2371, '', 2, 'Search label for f12 field', 1, ''),
(2372, '', 4, 'Help text for f12 field', 1, ''),
(2373, '', 2, 'Field value', 1, ''),
(2374, '', 2, 'Field value', 1, ''),
(2375, '', 2, 'Field value', 1, ''),
(2376, '', 2, 'Field value', 1, ''),
(2377, '', 2, 'Field value', 1, ''),
(2378, '', 2, 'Label for f13 field', 1, ''),
(2379, '', 2, 'Search label for f13 field', 1, ''),
(2380, '', 4, 'Help text for f13 field', 1, ''),
(2381, '', 2, 'Field value', 1, ''),
(2382, '', 2, 'Field value', 1, ''),
(2383, '', 2, 'Field value', 1, ''),
(2384, '', 2, 'Field value', 1, ''),
(2385, '', 2, 'Label for f14 field', 1, ''),
(2386, '', 2, 'Search label for f14 field', 1, ''),
(2387, '', 4, 'Help text for f14 field', 1, ''),
(2388, '', 2, 'Field value', 1, ''),
(2389, '', 2, 'Field value', 1, ''),
(2390, '', 2, 'Field value', 1, ''),
(2391, '', 2, 'Field value', 1, ''),
(2392, '', 2, 'Field value', 1, ''),
(2393, '', 2, 'Field value', 1, ''),
(2394, '', 2, 'Field value', 1, ''),
(2395, '', 2, 'Label for f15 field', 1, ''),
(2396, '', 2, 'Search label for f15 field', 1, ''),
(2397, '', 4, 'Help text for f15 field', 1, ''),
(280, '', 2, 'you are already connected to **', 2, 'net.inc.php'),
(279, '', 2, 'Private Photos from ***', 2, 'photos.inc.php'),
(278, '', 2, 'no photos found', 2, 'photos.inc.php'),
(277, '', 2, 'must be friends to see photos', 2, 'photos.inc.php'),
(2433, '', 2, 'Field value', 1, ''),
(2432, '', 2, 'Field value', 1, ''),
(2427, '', 2, 'Field value', 1, ''),
(2428, '', 2, 'Field value', 1, ''),
(2429, '', 2, 'Field value', 1, ''),
(2430, '', 2, 'Field value', 1, ''),
(2431, '', 2, 'Field value', 1, ''),
(2434, '', 2, 'message subject: friendship request accepted', 2, 'net.inc.php'),
(2435, '', 2, 'message body: friendship request accepted', 2, 'net.inc.php'),
(2436, 'rndi_str1', 2, 'title: Random Members', 2, 'plugins/widget/members/members.class.php'),
(2437, 'rndi_str2', 2, 'title: Random Photos', 2, 'plugins/widget/members/members.class.php');

CREATE TABLE `dsb_lang_strings` (
  `ls_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `fk_lk_id` int(5) unsigned NOT NULL DEFAULT '0',
  `skin` varchar(32) NOT NULL,
  `lang_value` text NOT NULL,
  PRIMARY KEY (`ls_id`),
  UNIQUE KEY `lkid_skin` (`fk_lk_id`,`skin`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_lang_strings` (`ls_id`, `fk_lk_id`, `skin`, `lang_value`) VALUES
(1, 1, 'skin_def', 'Sorry, your account has not been found. Maybe you have already activated your account?'),
(2, 2, 'skin_def', 'Invalid blog selected.'),
(3, 3, 'skin_def', 'Your email address has been changed.'),
(4, 4, 'skin_def', 'Invalid email change request.'),
(5, 5, 'skin_def', 'No such message.'),
(6, 6, 'skin_def', 'Invalid photo selected.'),
(7, 7, 'skin_def', 'Member not found.'),
(8, 8, 'skin_def', 'You are not allowed to search for less than 4 chars.'),
(9, 9, 'skin_def', 'You cannot vote more than once a day for the same photo.'),
(10, 10, 'skin_def', 'You are not allowed to vote for your own items.'),
(11, 11, 'skin_def', 'Invalid vote received.'),
(12, 12, 'skin_def', 'You must be logged in to rate photos.'),
(13, 13, 'skin_def', 'Please enter the title of the blog.'),
(14, 14, 'skin_def', 'Blog details changed.'),
(15, 15, 'skin_def', 'Blog created.'),
(16, 16, 'skin_def', 'Blog and all related posts and comments deleted.'),
(17, 17, 'skin_def', 'Please add a title for this post.'),
(18, 18, 'skin_def', 'Please write something in this post.'),
(19, 19, 'skin_def', 'Post changed successfully.'),
(20, 20, 'skin_def', 'Post added.'),
(21, 21, 'skin_def', 'Post added. It will be reviewed and published shortly.'),
(22, 22, 'skin_def', 'Post deleted.'),
(23, 23, 'skin_def', 'Please enter your comment.'),
(24, 24, 'skin_def', 'The verification code doesn''t match. Please enter the new code.'),
(25, 25, 'skin_def', 'Comment changed successfully.'),
(26, 26, 'skin_def', 'Comment changed but needs to be reviewed first.'),
(27, 27, 'skin_def', 'You are not allowed to edit comments.'),
(28, 28, 'skin_def', 'Comment added.'),
(29, 29, 'skin_def', 'Comment added but needs to be reviewed first.'),
(30, 30, 'skin_def', 'Comment deleted.'),
(31, 31, 'skin_def', 'You are not allowed to delete this comment.'),
(32, 32, 'skin_def', 'Please enter the message subject.'),
(33, 33, 'skin_def', 'Please enter your email address where we can contact you back.'),
(34, 34, 'skin_def', 'Please enter the message.'),
(35, 35, 'skin_def', 'Your message could not be sent: %s'),
(36, 36, 'skin_def', 'Message sent successfully.'),
(37, 37, 'skin_def', 'The emails do not match.'),
(38, 38, 'skin_def', 'Please enter the new email address you wish to use.'),
(39, 39, 'skin_def', 'An email has been sent to the email address you specified.'),
(40, 40, 'skin_def', '%1$s email change confirmation'),
(41, 41, 'skin_def', 'User %1$s doesn''t exist. Filter not saved.'),
(42, 42, 'skin_def', 'Filter changed successfully.'),
(43, 43, 'skin_def', 'Filter not changed. A similar filter already exists.'),
(44, 44, 'skin_def', 'Filter added.'),
(45, 45, 'skin_def', 'Filter not added. A similar filter already exists.'),
(46, 46, 'skin_def', 'Filter deleted.'),
(47, 47, 'skin_def', 'Flirt not sent because there was no receiver specified.'),
(48, 48, 'skin_def', 'Please select a flirt to send.'),
(49, 49, 'skin_def', 'Could not find flirt in database. Please select another flirt.'),
(50, 50, 'skin_def', 'Flirt sent.'),
(51, 51, 'skin_def', 'Folder renamed.'),
(52, 52, 'skin_def', 'Folder not changed. This folder name already exists.'),
(53, 53, 'skin_def', 'Folder added.'),
(54, 54, 'skin_def', 'Folder not added. This folder name already exists.'),
(55, 55, 'skin_def', 'Folder deleted.'),
(56, 56, 'skin_def', 'The passwords do not match.'),
(57, 57, 'skin_def', 'Please enter the password.'),
(58, 58, 'skin_def', 'Invalid parameters received.'),
(59, 59, 'skin_def', 'Password changed, please login below.'),
(60, 60, 'skin_def', 'Invalid username specified. Password not changed.'),
(61, 61, 'skin_def', '%s connections added.'),
(62, 62, 'skin_def', '%s connections declined.'),
(63, 63, 'skin_def', 'Please only use letters, numerals, dashes and underscores for your username. Dashes and underscores can not be added at the start or end of your username. Length of username must be 4-20 characters.'),
(64, 64, 'skin_def', 'This account already exists. Please choose another one.'),
(65, 65, 'skin_def', 'Password cannot be empty. Please enter your password.'),
(66, 66, 'skin_def', 'Invalid email entered. Please check your email.'),
(67, 67, 'skin_def', 'The email address %s is already in use.'),
(68, 68, 'skin_def', 'You must agree to the terms of services before joining the site.'),
(69, 69, 'skin_def', 'The fields outlined below are required and must not be empty.'),
(70, 70, 'skin_def', '%s user registration confirmation'),
(71, 71, 'skin_def', 'Your account is suspended.'),
(72, 72, 'skin_def', 'Invalid user name or password. Please try again.'),
(73, 73, 'skin_def', '%s message(s) deleted.'),
(74, 74, 'skin_def', '%s message(s) moved.'),
(75, 75, 'skin_def', 'Message not sent because there was no receiver specified.'),
(76, 76, 'skin_def', 'Response deleted.'),
(77, 77, 'skin_def', 'Ok'),
(78, 78, 'skin_def', 'Please enter a title for this search.'),
(79, 79, 'skin_def', 'Search title saved.'),
(80, 80, 'skin_def', 'Your preferences were saved.'),
(81, 81, 'skin_def', 'Invalid user.'),
(82, 82, 'skin_def', 'Invalid network selected.'),
(83, 83, 'skin_def', 'A confirmation request has been sent to %1$s.'),
(84, 84, 'skin_def', 'Connection request from %s'),
(85, 85, 'skin_def', '%1$s wants to add you to their %2$s network.<br><a class="content-link simple" href="friendship_requests.php">Click here</a> to approve/deny this request and to see any other friendship requests.'),
(86, 86, 'skin_def', '%1$s has been added to your %2$s.'),
(87, 87, 'skin_def', '%1$s has been removed from your %2$s.'),
(88, 88, 'skin_def', 'Password changed.'),
(89, 89, 'skin_def', 'An email with steps required to reset your password has been sent to your address.'),
(90, 90, 'skin_def', 'The email address you entered was not found.'),
(91, 91, 'skin_def', 'Photo deleted.'),
(92, 92, 'skin_def', 'Settings changed.'),
(93, 93, 'skin_def', 'Sorry, an error has occured. Try uploading less photos at once or smaller photos.'),
(94, 94, 'skin_def', 'Photo %1$s was not uploaded because the minimum allowed size for photos is %2$s bytes.'),
(95, 95, 'skin_def', 'Photo %1$s was not uploaded because the maximum allowed size for photos is %2$s bytes.'),
(96, 96, 'skin_def', '%1u photos uploaded.'),
(97, 97, 'skin_def', 'No photo uploaded.'),
(98, 98, 'skin_def', 'No search selected.'),
(99, 99, 'skin_def', 'Search saved.'),
(100, 100, 'skin_def', 'Your profile has been changed.'),
(101, 101, 'skin_def', 'Your search has been deleted.'),
(102, 102, 'skin_def', 'is online'),
(103, 103, 'skin_def', 'is offline'),
(104, 104, 'skin_def', 'Latest Blogs'),
(105, 105, 'skin_def', 'Most Popular Blogs'),
(106, 106, 'skin_def', 'Most Discussed Blogs'),
(107, 107, 'skin_def', 'Search Results'),
(108, 108, 'skin_def', '%1$s''s Blogs'),
(109, 109, 'skin_def', 'Blog Posts'),
(110, 110, 'skin_def', 'INBOX'),
(111, 111, 'skin_def', 'SENT'),
(112, 112, 'skin_def', 'Trash'),
(113, 113, 'skin_def', 'SPAMBOX'),
(114, 114, 'skin_def', 'User: %1$s'),
(115, 115, 'skin_def', 'Manage your filters'),
(116, 116, 'skin_def', 'Message Filters'),
(117, 117, 'skin_def', 'user'),
(118, 118, 'skin_def', 'users with %1$s'),
(119, 119, 'skin_def', 'Add/Edit a Filter'),
(120, 120, 'skin_def', 'No receiver specified'),
(121, 121, 'skin_def', 'Send a Flirt'),
(122, 122, 'skin_def', 'My Personal Folders'),
(123, 123, 'skin_def', 'Never'),
(124, 124, 'skin_def', 'My Home'),
(125, 125, 'skin_def', 'Remaining chars:'),
(126, 126, 'skin_def', 'Any Country'),
(127, 127, 'skin_def', 'State'),
(128, 128, 'skin_def', 'City'),
(129, 129, 'skin_def', 'Zip'),
(130, 130, 'skin_def', 'Registration'),
(131, 131, 'skin_def', 'day'),
(132, 132, 'skin_def', 'year'),
(133, 133, 'skin_def', 'Select state'),
(134, 134, 'skin_def', 'Select city'),
(135, 135, 'skin_def', 'SYSTEM'),
(136, 136, 'skin_def', 'Read Message'),
(137, 137, 'skin_def', 'Write to %1$s'),
(138, 138, 'skin_def', 'private'),
(139, 139, 'skin_def', 'public'),
(140, 140, 'skin_def', 'My Photos'),
(141, 141, 'skin_def', 'My Profile'),
(142, 142, 'skin_def', 'Saved Responses'),
(143, 143, 'skin_def', '%1$s''s Photos'),
(144, 144, 'skin_def', 'Newest Photos'),
(145, 145, 'skin_def', 'Most Popular Photos'),
(146, 146, 'skin_def', 'Most Voted Photos'),
(147, 147, 'skin_def', 'Most Discussed Photos'),
(148, 148, 'skin_def', 'Results for "%1$s"'),
(149, 149, 'skin_def', 'You can upload an unlimited number of photos.'),
(150, 150, 'skin_def', 'You can upload %1$s more photos.'),
(151, 151, 'skin_def', 'Upload Photos'),
(152, 152, 'skin_def', '%1$s''s Profile'),
(153, 153, 'skin_def', 'Online now!'),
(154, 154, 'skin_def', 'Today'),
(155, 155, 'skin_def', 'Yesterday'),
(156, 156, 'skin_def', 'Last week'),
(157, 157, 'skin_def', 'Last month'),
(158, 158, 'skin_def', 'More than a month ago'),
(159, 159, 'skin_def', 'Any'),
(160, 160, 'skin_def', 'New comment on one of your blogs'),
(161, 161, 'skin_def', '%1$s posted a comment on one of your blog posts.<br><a class="content-link simple" href="blog_post_view.php?pid=%2$s#comm%3$s">Click here</a> to view the comment'),
(162, 162, 'skin_def', 'New comment on one of your photos'),
(163, 163, 'skin_def', '%1$s posted a comment on one of your photos.<br><a class="content-link simple" href="photo_view.php?photo_id=%2$s#comm%3$s">Click here</a> to view the comment'),
(164, 164, 'skin_def', 'New comment on your profile'),
(165, 165, 'skin_def', '%1$s posted a comment on your profile.<br><a class="content-link simple" href="my_comments.php#comm%2$s">Click here</a> to view the comment'),
(166, 166, 'skin_def', 'month'),
(167, 167, 'skin_def', 'jan'),
(168, 168, 'skin_def', 'feb'),
(169, 169, 'skin_def', 'mar'),
(170, 170, 'skin_def', 'apr'),
(171, 171, 'skin_def', 'may'),
(172, 172, 'skin_def', 'jun'),
(173, 173, 'skin_def', 'jul'),
(174, 174, 'skin_def', 'aug'),
(175, 175, 'skin_def', 'sep'),
(176, 176, 'skin_def', 'oct'),
(177, 177, 'skin_def', 'nov'),
(178, 178, 'skin_def', 'dec'),
(179, 179, 'skin_def', 'Pages:'),
(180, 180, 'skin_def', 'Results to show:'),
(181, 181, 'skin_def', 'Go to first page'),
(182, 182, 'skin_def', 'Go to last page'),
(183, 183, 'skin_def', 'Go to next page'),
(184, 184, 'skin_def', 'Go to previous page'),
(185, 185, 'skin_def', 'Distance'),
(186, 186, 'skin_def', 'miles from zip'),
(187, 187, 'skin_def', 'We''re sorry but there were some problems processing your payment. Please contact us to upgrade your subscription.'),
(188, 188, 'skin_def', 'We''re sorry but the price you''ve paid doesn''t match the subscription price. Please contact us to upgrade your subscription.'),
(189, 189, 'skin_def', 'We''re sorry but the system doesn''t recognize the subscription for the payment you''ve made. Please contact us to upgrade your subscription.'),
(190, 190, 'skin_def', 'Thank you for your payment. The transaction is still <strong>pending</strong> at the moment. As soon as the payment clears, a receipt for your purchase will be emailed to you and your membership will be upgraded.<br>You may log into your account at http://www.paypal.com to view details of this transaction.'),
(191, 191, 'skin_def', 'Error: Unhandled transaction type received from Paypal.'),
(192, 192, 'skin_def', 'Error: Sorry, your username could not be found. Please contact us to upgrade your membership.'),
(193, 193, 'skin_def', 'Invalid payment received. Please contact us if you feel this is an error.'),
(194, 194, 'skin_def', 'The emails do not match.'),
(195, 195, 'skin_def', 'Select country'),
(196, 196, 'skin_def', 'Please enter the message subject.'),
(197, 197, 'skin_def', 'Please enter the message.'),
(198, 198, 'skin_def', 'Message sent successfully.'),
(199, 199, 'skin_def', 'We''re sorry but this transaction failed internal validation. Please try again.'),
(200, 200, 'skin_def', 'We''re sorry, but an error occurred when trying to process your Credit Card: %1$s (%2$s)'),
(201, 201, 'skin_def', 'We''re sorry, but an error occurred when trying to process your Credit Card. Please contact us for details or try again.'),
(202, 202, 'skin_def', 'Browse Blogs'),
(203, 203, 'skin_def', ''),
(204, 204, 'skin_def', 'The email address %s is already in use.'),
(205, 205, 'skin_def', 'More Blogs'),
(206, 206, 'skin_def', 'Contact Us'),
(207, 207, 'skin_def', 'Latest Comments'),
(208, 208, 'skin_def', 'Newest Members'),
(209, 209, 'skin_def', 'Most Voted Members'),
(210, 210, 'skin_def', 'Most Popular Members'),
(211, 211, 'skin_def', 'Most Discussed Members'),
(212, 212, 'skin_def', 'Original Signal Tech Feed'),
(213, 213, 'skin_def', 'Photos'),
(214, 214, 'skin_def', 'More Photos'),
(215, 215, 'skin_def', 'News'),
(216, 216, 'skin_def', '%s sent you a flirt'),
(217, 217, 'skin_def', 'New matches for you on %1$s'),
(218, 218, 'skin_def', 'Your %s subscription is about to expire'),
(219, 219, 'skin_def', 'More Members'),
(220, 220, 'skin_def', 'Add/Edit a Blog'),
(221, 221, 'skin_def', '%2$s'),
(222, 222, 'skin_def', 'Blogs - %1$s - %2$s'),
(223, 223, 'skin_def', 'Add/Edit a Post in %1$s'),
(224, 224, 'skin_def', 'Change Password'),
(225, 225, 'skin_def', '%1$s password reset confirmation'),
(226, 226, 'skin_def', 'Friendship Requests'),
(227, 227, 'skin_def', 'Information'),
(228, 228, 'skin_def', 'Signup successful!'),
(229, 229, 'skin_def', 'Upgrade'),
(230, 230, 'skin_def', 'Email sent'),
(231, 231, 'skin_def', 'Activate your account'),
(232, 232, 'skin_def', 'Account successfully confirmed!'),
(233, 233, 'skin_def', 'No access until approved!'),
(234, 234, 'skin_def', 'Subscribe'),
(235, 235, 'skin_def', 'Message'),
(236, 236, 'skin_def', 'Login'),
(237, 237, 'skin_def', 'Login to continue...'),
(238, 238, 'skin_def', 'Posts in %1$s'),
(239, 239, 'skin_def', 'My Blogs'),
(240, 240, 'skin_def', 'How I am connected'),
(241, 241, 'skin_def', 'Photo Settings'),
(242, 242, 'skin_def', 'My Searches'),
(243, 243, 'skin_def', 'My Settings'),
(244, 244, 'skin_def', 'Lost Password'),
(245, 245, 'skin_def', 'Compare Memberships'),
(246, 246, 'skin_def', 'Privacy'),
(247, 247, 'skin_def', 'Advanced Search'),
(248, 248, 'skin_def', 'Upgrade Your Membership'),
(249, 249, 'skin_def', 'Thank you for your payment'),
(250, 250, 'skin_def', 'Terms of Service'),
(251, 251, 'skin_def', 'Subscribe to latest blog comments feed'),
(503, 252, 'skin_def', 'You are not allowed to edit this comment.'),
(504, 253, 'skin_def', 'Please enter a name to remember this search:'),
(505, 254, 'skin_def', 'There has been an error saving your search. Please try again later.'),
(506, 255, 'skin_def', 'Thank you for your vote.'),
(507, 256, 'skin_def', 'Are you sure you want to remove this comment?'),
(508, 257, 'skin_def', 'Please select at least one photo to upload!'),
(509, 258, 'skin_def', 'Please enter the email address you used to register with us.'),
(510, 259, 'skin_def', 'Please enter the code from the image.'),
(511, 260, 'skin_def', 'Please enter the new password.'),
(512, 261, 'skin_def', 'The passwords do not match.'),
(513, 262, 'skin_def', 'Are you sure you want to permanently delete this blog? All posts in this blog will also be deleted!'),
(514, 263, 'skin_def', 'Message saved as template.'),
(515, 264, 'skin_def', 'You are not allowed to save message templates.'),
(516, 265, 'skin_def', 'Please enter the new password.'),
(517, 266, 'skin_def', 'The passwords do not match.'),
(518, 267, 'skin_def', 'Please enter the folder name.'),
(519, 268, 'skin_def', 'Are you sure you want to delete this folder? All messages inside this folder will be moved to Trash and all the filters associated with this folder will be deleted!'),
(520, 269, 'skin_def', 'Please enter the new folder name.'),
(521, 270, 'skin_def', 'Are you sure you want to delete this filter?'),
(522, 271, 'skin_def', 'Please enter a search term.'),
(523, 272, 'skin_def', 'The chosen username is OK and can be used.'),
(524, 273, 'skin_def', 'Are you sure you want to block this member?'),
(525, 274, 'skin_def', 'Are you sure you want to unblock this member?'),
(526, 2275, 'skin_def', 'Basic Info'),
(527, 2276, 'skin_def', 'Appearance'),
(528, 2277, 'skin_def', 'Lifestyle'),
(529, 2278, 'skin_def', 'Home Life'),
(530, 2279, 'skin_def', 'Personality'),
(531, 2280, 'skin_def', 'Man'),
(532, 2281, 'skin_def', 'Woman'),
(1216, 2282, 'skin_def', 'I am a'),
(1217, 2283, 'skin_def', 'Find a'),
(1218, 2284, 'skin_def', ''),
(536, 2285, 'skin_def', 'Men'),
(537, 2286, 'skin_def', 'Women'),
(1219, 2287, 'skin_def', 'Seeking'),
(1220, 2288, 'skin_def', 'Seeking'),
(1221, 2289, 'skin_def', ''),
(1135, 2293, 'skin_def', 'Country'),
(1136, 2294, 'skin_def', 'From'),
(1137, 2295, 'skin_def', ''),
(1265, 2296, 'skin_def', 'About me'),
(1266, 2297, 'skin_def', ''),
(1267, 2298, 'skin_def', ''),
(550, 2299, 'skin_def', 'African American (black)'),
(551, 2300, 'skin_def', 'Asian'),
(552, 2301, 'skin_def', 'Caucasian (white)'),
(553, 2302, 'skin_def', 'East Indian'),
(554, 2303, 'skin_def', 'Hispanic/Latino'),
(555, 2304, 'skin_def', 'Middle Eastern'),
(556, 2305, 'skin_def', 'Native American'),
(557, 2306, 'skin_def', 'Pacific Islander'),
(558, 2307, 'skin_def', 'Inter-racial'),
(1171, 2308, 'skin_def', 'My ethnicity is'),
(1172, 2309, 'skin_def', 'Having ethnicity'),
(1173, 2310, 'skin_def', ''),
(562, 2311, 'skin_def', '4''0" or less'),
(563, 2312, 'skin_def', '4''1" - 4''3"'),
(564, 2313, 'skin_def', '4''4" - 4''6"'),
(565, 2314, 'skin_def', '4''7" - 4''9"'),
(566, 2315, 'skin_def', '4''10" - 5''0"'),
(567, 2316, 'skin_def', '5''1" - 5''3"'),
(568, 2317, 'skin_def', '5''4" - 5''6"'),
(569, 2318, 'skin_def', '5''7" - 5''9"'),
(570, 2319, 'skin_def', '5''10" - 6''0"'),
(571, 2320, 'skin_def', '6''1" - 6''3"'),
(572, 2321, 'skin_def', '6''4" - 6''6"'),
(573, 2322, 'skin_def', '6''7" - 6''9"'),
(577, 2326, 'skin_def', '6''10" - 7''0"'),
(578, 2327, 'skin_def', '7''1" or more'),
(1249, 2323, 'skin_def', 'My height is'),
(1250, 2324, 'skin_def', 'Height'),
(1251, 2325, 'skin_def', ''),
(585, 2328, 'skin_def', 'Slim'),
(586, 2329, 'skin_def', 'Slender'),
(587, 2330, 'skin_def', 'Average'),
(588, 2331, 'skin_def', 'Athletic'),
(589, 2332, 'skin_def', 'Fit'),
(590, 2333, 'skin_def', 'Thick'),
(591, 2334, 'skin_def', 'A few extra pounds'),
(592, 2335, 'skin_def', 'Large'),
(593, 2336, 'skin_def', 'Voluptous'),
(1222, 2337, 'skin_def', 'My body type is'),
(1223, 2338, 'skin_def', 'Body'),
(1224, 2339, 'skin_def', ''),
(597, 2340, 'skin_def', 'Black'),
(598, 2341, 'skin_def', 'Blue'),
(599, 2342, 'skin_def', 'Brown'),
(600, 2343, 'skin_def', 'Gray'),
(601, 2344, 'skin_def', 'Green'),
(602, 2345, 'skin_def', 'Hazel'),
(1180, 2346, 'skin_def', 'My eyes are'),
(1181, 2347, 'skin_def', 'Eyes'),
(1182, 2348, 'skin_def', ''),
(606, 2349, 'skin_def', 'Auburn'),
(607, 2350, 'skin_def', 'Black'),
(608, 2351, 'skin_def', 'Blonde'),
(609, 2352, 'skin_def', 'Light Brown'),
(610, 2353, 'skin_def', 'Dark Brown'),
(611, 2354, 'skin_def', 'Red'),
(612, 2355, 'skin_def', 'White/Gray'),
(613, 2356, 'skin_def', 'Bald'),
(614, 2357, 'skin_def', 'A little gray'),
(1183, 2358, 'skin_def', 'My hair is'),
(1184, 2359, 'skin_def', 'Hair'),
(1185, 2360, 'skin_def', ''),
(618, 2361, 'skin_def', 'No'),
(619, 2362, 'skin_def', 'Socially'),
(620, 2363, 'skin_def', 'Daily'),
(1186, 2364, 'skin_def', 'I smoke'),
(1187, 2365, 'skin_def', 'Smoke'),
(1188, 2366, 'skin_def', ''),
(624, 2367, 'skin_def', 'No'),
(625, 2368, 'skin_def', 'Socially'),
(626, 2369, 'skin_def', 'Daily'),
(1189, 2370, 'skin_def', 'I drink'),
(1190, 2371, 'skin_def', 'Drink'),
(1191, 2372, 'skin_def', ''),
(630, 2373, 'skin_def', 'Some High School'),
(631, 2374, 'skin_def', 'High School Grad'),
(632, 2375, 'skin_def', 'Some College'),
(633, 2376, 'skin_def', 'College Grad'),
(634, 2377, 'skin_def', 'Post-Graduate'),
(1192, 2378, 'skin_def', 'My education is'),
(1193, 2379, 'skin_def', 'Education'),
(1194, 2380, 'skin_def', ''),
(638, 2381, 'skin_def', 'Single, never married'),
(639, 2382, 'skin_def', 'Divorced'),
(640, 2383, 'skin_def', 'Widowed'),
(641, 2384, 'skin_def', 'Separated'),
(1195, 2385, 'skin_def', 'My marital status is'),
(1196, 2386, 'skin_def', 'Marital status'),
(1197, 2387, 'skin_def', ''),
(645, 2388, 'skin_def', 'Alone'),
(646, 2389, 'skin_def', 'With kids'),
(647, 2390, 'skin_def', 'With parents'),
(648, 2391, 'skin_def', 'With pets'),
(649, 2392, 'skin_def', 'With roommate(s)'),
(650, 2393, 'skin_def', 'Family and friends visit often'),
(651, 2394, 'skin_def', 'There is a party every night'),
(1198, 2395, 'skin_def', 'I am currently living'),
(1199, 2396, 'skin_def', 'Living'),
(1200, 2397, 'skin_def', ''),
(1269, 2290, 'skin_def', 'Birthdate'),
(1270, 2291, 'skin_def', 'Age'),
(1271, 2292, 'skin_def', ''),
(658, 275, 'skin_def', 'Your account has been marked for deletion and it will be deleted in the next couple of hours. Thank you for using our site.'),
(659, 276, 'skin_def', 'Are you sure you want to cancel your account?'),
(1268, 280, 'skin_def', 'You''re already connected to %1$s'),
(1261, 2433, 'skin_def', ''),
(1260, 2432, 'skin_def', ''),
(1259, 2431, 'skin_def', ''),
(1258, 2430, 'skin_def', ''),
(1257, 2429, 'skin_def', ''),
(1256, 2428, 'skin_def', ''),
(1255, 2427, 'skin_def', ''),
(1254, 279, 'skin_def', 'Private Photos from %1$s'),
(1253, 278, 'skin_def', 'No photos found matching your search criteria. Please refine your search and try again.'),
(1252, 277, 'skin_def', 'You must be friends with <a class="content-link" href="%1$s" title="%2$s">%2$s</a> in order to view the private photos.'),
(1272, 2434, 'skin_def', 'Friendship Request Accepted'),
(1273, 2435, 'skin_def', '%1$s has accepted your Friendship Request! You are friends now.'),
(1274, 2436, 'skin_def', 'Random Members'),
(1275, 2437, 'skin_def', 'Random Photos');

CREATE TABLE `dsb_locales` (
  `locale_id` int(4) unsigned NOT NULL AUTO_INCREMENT,
  `locale_name` varchar(100) NOT NULL,
  `codes` varchar(50) NOT NULL,
  PRIMARY KEY (`locale_id`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_locales` (`locale_id`, `locale_name`, `codes`) VALUES
(1, 'Arabic (Algeria)', 'ar_DZ,arabic'),
(2, 'Arabic (Saudi Arabia)', 'ar_SA,arabic'),
(3, 'Bulgarian (Bulgaria)', 'bg_BG,bulgarian'),
(4, 'Chinese, Simplified (China)', 'zh_CN,chinese'),
(5, 'Chinese, Traditional (Hong Kong)', 'zh_HK,chinese'),
(6, 'Chinese, Traditional (Taiwan)', 'zh_TW,chinese'),
(7, 'Czech (Czech Republic)', 'cs_CZ,czech'),
(8, 'Danish (Denmark)', 'da_DK,danish'),
(9, 'Dutch (Netherlands)', 'nl_NL,dutch'),
(10, 'English (United Kingdom)', 'en_GB,english'),
(11, 'English (United States)', 'en_US,english'),
(12, 'Finnish (Finland)', 'fi_FI,finnish'),
(13, 'French (Canada)', 'fr_CA,french'),
(14, 'French (France)', 'fr_FR,french'),
(15, 'German (Germany)', 'de_DE,german'),
(16, 'Greek (Greece)', 'el_GR,greek'),
(17, 'Hebrew (Israel)', 'iw_IL,hebrew'),
(18, 'Hungarian (Hungary)', 'hu_HU,hungarian'),
(19, 'Icelandic (Iceland)', 'is_IS,icelandic'),
(20, 'Italian (Italy)', 'it_IT,italian'),
(21, 'Japanese (Japan)', 'ja_JP,japanese'),
(22, 'Korean (Korea)', 'ko_KR,korean'),
(23, 'Norwegian (Norway)', 'no_NO,norwegian'),
(24, 'Polish (Poland)', 'pl_PL,polish'),
(25, 'Portuguese (Brazil)', 'pt_BR,portuguese'),
(26, 'Portuguese (Portugal)', 'pt_PT,portuguese'),
(27, 'Romanian (Romania)', 'ro_RO,romanian'),
(28, 'Russian (Russia)', 'ru_RU,russian'),
(29, 'Serbocroatian (Croatia)', 'hr_HR,croatian'),
(30, 'Slovak (Slovakia)', 'sk_SK,slovak'),
(31, 'Slovene (Slovenia)', 'sl_SI,sloven'),
(32, 'Spanish (Argentina)', 'es_AR,spanish'),
(33, 'Spanish (Bolivia)', 'es_BO,spanish'),
(34, 'Spanish (Chile)', 'es_CL,spanish'),
(35, 'Spanish (Colombia)', 'es_CO,spanish'),
(36, 'Spanish (Costa Rica)', 'es_CR,spanish'),
(37, 'Spanish (Ecuador)', 'es_EC,spanish'),
(38, 'Spanish (El Salvador)', 'es_SV,spanish'),
(39, 'Spanish (Guatemala)', 'es_GT,spanish'),
(40, 'Spanish (Mexico)', 'es_MX,spanish'),
(41, 'Spanish (Nicaragua)', 'es_NI,spanish'),
(42, 'Spanish (Panama)', 'es_PA,spanish'),
(43, 'Spanish (Paraguay)', 'es_PY,spanish'),
(44, 'Spanish (Peru)', 'es_PE,spanish'),
(45, 'Spanish (Puerto Rico)', 'es_PR,spanish'),
(46, 'Spanish (Spain)', 'es_ES,spanish'),
(47, 'Spanish (Uruguay)', 'es_UY,spanish'),
(48, 'Spanish (Venezuela)', 'es_VE,spanish'),
(49, 'Swedish (Sweden)', 'sv_SE,spanish'),
(50, 'Thai (Thailand)', 'th_TH,thai'),
(51, 'Turkish (Turkey)', 'tr_TR,turkish');

CREATE TABLE `dsb_loc_cities` (
  `city_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `city` varchar(200) NOT NULL,
  `latitude` double NOT NULL DEFAULT '0',
  `rad_latitude` double NOT NULL DEFAULT '0',
  `longitude` double NOT NULL DEFAULT '0',
  `rad_longitude` double NOT NULL DEFAULT '0',
  `fk_country_id` int(3) unsigned NOT NULL DEFAULT '0',
  `fk_state_id` int(10) unsigned NOT NULL DEFAULT '0',
  `feature_code` varchar(10) NOT NULL,
  `feature_class` char(1) NOT NULL,
  PRIMARY KEY (`city_id`),
  KEY `fk_country_id` (`fk_country_id`),
  KEY `sid_city` (`fk_state_id`,`city`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(92071, '107 West Colonia', 26.318000793457, 0.459335766388305, -98.2649993896484, -1.71504777881958, 218, 51, 'PPL', 'P'),
(92072, '11 North-Victoria Road-FM 493 Colonia', 26.2129993438721, 0.457503145373681, -98.0309982299805, -1.71096368812989, 218, 51, 'PPL', 'P'),
(92073, '13 1/2 North-FM 493 Colonia', 26.2490005493164, 0.458131484943371, -98.0400009155273, -1.71112081463421, 218, 51, 'PPL', 'P'),
(92074, '13 North-2 West Colonia', 26.2439994812012, 0.458044199838644, -97.9390029907227, -1.70935806830868, 218, 51, 'PPL', 'P'),
(92075, '15 1/2 North-FM 491 Colonia', 26.2810001373291, 0.458689983113475, -97.9179992675781, -1.70899148418463, 218, 51, 'PPL', 'P'),
(92076, '17 1/2 North-6 West Colonia', 26.3090000152588, 0.459178673173504, -98.0199966430664, -1.7107716742153, 218, 51, 'PPL', 'P'),
(92077, '1st, 2nd, and 3rd Street Area Colonia', 28.4330005645752, 0.496249476073244, -97.7109985351563, -1.70537863984983, 218, 51, 'PPL', 'P'),
(92078, '21 Subdivision Colonia', 25.8899993896484, 0.451865732688688, -97.4280014038086, -1.70043940813412, 218, 51, 'PPL', 'P'),
(202810, '214 North Temple Condominium', 40.7719383239746, 0.711604566173415, -111.900283813477, -1.95302838646128, 218, 52, 'PPL', 'P'),
(92079, '281 Estates Colonia', 26.3780002593994, 0.460382954618438, -98.1520004272461, -1.71307557487433, 218, 51, 'PPL', 'P'),
(92080, '665 Site Colonia', 27.7299995422363, 0.483979793588544, -98.0329971313477, -1.71099857554017, 218, 51, 'PPL', 'P'),
(92081, '9 North-East FM 493 Colonia', 26.1149997711182, 0.455792730163578, -98.0660018920898, -1.71157461728396, 218, 51, 'PPL', 'P'),
(195829, 'A and B Trailer Court Number One', 48.5525016784668, 0.847401014369319, -109.680557250977, -1.91428684945168, 218, 31, 'PPL', 'P'),
(195830, 'A and B Trailer Court Number Two', 48.5499992370605, 0.847357338527442, -109.683326721191, -1.91433518582547, 218, 31, 'PPL', 'P'),
(92085, 'A and E Ramirez Colonia', 26.0949993133545, 0.455443656323695, -97.9509963989258, -1.70956739277036, 218, 51, 'PPL', 'P'),
(92086, 'A and E Ramirez Colonia Number 2', 26.0990009307861, 0.455513497723283, -97.9530029296875, -1.7096024133387, 218, 51, 'PPL', 'P'),
(192981, 'A and F Trailer Court', 33.2958297729492, 0.58112185672152, -111.841110229492, -1.95199561259055, 218, 5, 'PPL', 'P'),
(192980, 'A and F Trailer Park', 33.4944381713867, 0.584588227196367, -112.110282897949, -1.9566935619115, 218, 5, 'PPL', 'P'),
(99269, 'A Country Place', 38.9550018310547, 0.679893042072324, -77.2763900756836, -1.34872744087615, 218, 53, 'PPL', 'P'),
(144710, 'A Country Place', 40.0883293151855, 0.699673338173751, -74.2291717529297, -1.29554344811699, 218, 37, 'PPL', 'P'),
(92082, 'A F Pierce Colonia', 26.9039993286133, 0.469563370238646, -99.2740020751953, -1.73265819784384, 218, 51, 'PPL', 'P'),
(92083, 'A Sherton', 28.4416694641113, 0.496400776912674, -99.7600021362305, -1.7411404990738, 218, 51, 'PPL', 'P'),
(92084, 'A T Martinez Colonia', 26.3899993896484, 0.460592378948659, -98.8430023193359, -1.7251358330288, 218, 51, 'PPL', 'P'),
(192982, 'A-1 Trailer Park', 33.4486083984375, 0.583788346762962, -112.008331298828, -1.95491417082917, 218, 5, 'PPL', 'P'),
(7014, 'Aa Junction', 36.079719543457, 0.629709899229471, -90.9397201538086, -1.5871975375262, 218, 4, 'PPL', 'P'),
(195831, 'AA Westside Mobile Estates', 46.0022201538086, 0.802890204911252, -112.54167175293, -1.96422271778732, 218, 31, 'PPL', 'P'),
(18707, 'Aaron', 32.5680618286133, 0.568419909902387, -81.9925003051758, -1.43103909226777, 218, 13, 'PPL', 'P'),
(29057, 'Aaron', 38.8830604553223, 0.678637428197379, -85.1258316040039, -1.48572603998811, 218, 19, 'PPL', 'P'),
(34495, 'Aaron', 36.8125, 0.642499330890413, -85.1808319091797, -1.48668597640303, 218, 21, 'PPL', 'P'),
(53114, 'Aaron', 38.4230613708496, 0.670608929617172, -94.1536102294922, -1.64329050114405, 218, 29, 'PPL', 'P'),
(107898, 'Aarons', 38.4930610656738, 0.671830654767246, -81.5344390869141, -1.42304441583341, 218, 58, 'PPL', 'P'),
(62422, 'Aarons Corner', 36.5380592346191, 0.637709435932823, -80.2961120605469, -1.40143153200687, 218, 33, 'PPL', 'P'),
(99270, 'Aarons Creek', 36.6611099243164, 0.63985707561489, -78.7222213745117, -1.37396195746909, 218, 53, 'PPL', 'P'),
(158517, 'Aaronsburg', 40.8997192382813, 0.713834763849275, -77.45361328125, -1.35182056932422, 218, 45, 'PPL', 'P'),
(154000, 'Aaronsburg (historical)', 40.3983306884766, 0.705083882823384, -82.6952819824219, -1.44330494645841, 218, 41, 'PPL', 'P'),
(53115, 'Abadyl', 37.038330078125, 0.64644080930373, -92.9469375610352, -1.62223009008565, 218, 29, 'PPL', 'P'),
(154001, 'Abanaka', 40.7599983215332, 0.711396173818117, -84.6983337402344, -1.47826479472009, 218, 41, 'PPL', 'P'),
(112666, 'Abanda', 33.100830078125, 0.577718470006453, -85.5297164916992, -1.49277516107744, 218, 2, 'PPL', 'P'),
(186306, 'Abarr', 39.8505592346191, 0.695523467405135, -102.706672668457, -1.79256960183265, 218, 7, 'PPL', 'P'),
(53116, 'Abattis (historical)', 38.8169403076172, 0.67748341391802, -91.3916702270508, -1.59508555435891, 218, 29, 'PPL', 'P'),
(18711, 'Abba', 31.7566699981689, 0.55425845093735, -83.3705596923828, -1.45509076586255, 218, 13, 'PPL', 'P'),
(179597, 'Abbato (historical)', 37.0538902282715, 0.646712385155891, -120.826667785645, -2.10882317707286, 218, 6, 'PPL', 'P'),
(18708, 'Abbeville', 31.9919395446777, 0.558364679153602, -83.3069381713867, -1.45398036084604, 218, 13, 'PPL', 'P'),
(39022, 'Abbeville', 29.9744396209717, 0.523152662826197, -92.1341705322266, -1.60804462938129, 218, 22, 'PPL', 'P'),
(58400, 'Abbeville', 34.503059387207, 0.6021919883179, -89.503059387207, -1.56212307691478, 218, 30, 'PPL', 'P'),
(79480, 'Abbeville', 34.1780586242676, 0.596519654933113, -82.3791732788086, -1.43778780878614, 218, 48, 'PPL', 'P'),
(112667, 'Abbeville', 31.5716705322266, 0.551029601142224, -85.2505569458008, -1.48790290786314, 218, 2, 'PPL', 'P'),
(194487, 'Abbey (historical)', 42.6316719055176, 0.744063040381247, -114.755279541016, -2.00285746203721, 218, 17, 'PPL', 'P'),
(154002, 'Abbeyville', 41.1972198486328, 0.719027129026602, -81.8869400024414, -1.42919671742566, 218, 41, 'PPL', 'P'),
(186307, 'Abbeyville', 38.7775001525879, 0.676795053355262, -106.491668701172, -1.85863024477844, 218, 7, 'PPL', 'P'),
(39023, 'Abbie Joe (historical)', 30.4916706085205, 0.532180046552266, -93.3030624389648, -1.62844564175379, 218, 22, 'PPL', 'P'),
(26325, 'Abbot', 37.5572204589844, 0.655497154906653, -88.6988906860352, -1.54808768533785, 218, 18, 'PPL', 'P'),
(112668, 'Abbot Springs', 33.3608283996582, 0.582256296766866, -86.4816665649414, -1.50938982417012, 218, 2, 'PPL', 'P'),
(126726, 'Abbot Village', 45.1863899230957, 0.788651281248007, -69.4524993896484, -1.21217478808872, 218, 26, 'PPL', 'P'),
(172827, 'Abbotsford', 44.9463882446289, 0.784462461748449, -90.3158264160156, -1.57630853761914, 218, 57, 'PPL', 'P'),
(158519, 'Abbotsford Homes', 40.0133285522461, 0.69836432791895, -75.1750030517578, -1.31205131844996, 218, 45, 'PPL', 'P'),
(7015, 'Abbott', 35.0733299255371, 0.61214508683888, -94.1936111450195, -1.64398864882382, 218, 4, 'PPL', 'P'),
(58402, 'Abbott', 33.6800003051758, 0.587826897398012, -88.7744369506836, -1.54940621639354, 218, 30, 'PPL', 'P'),
(92087, 'Abbott', 31.8847198486328, 0.556493342434631, -97.0730590820313, -1.69424449596443, 218, 51, 'PPL', 'P'),
(99271, 'Abbott', 37.4291687011719, 0.653262230119859, -80.1397171020508, -1.39870192504759, 218, 53, 'PPL', 'P'),
(107899, 'Abbott', 38.9216690063477, 0.679311274532196, -80.3216705322266, -1.40187761148946, 218, 58, 'PPL', 'P'),
(114336, 'Abbott', 42.485279083252, 0.741508003631425, -93.0661087036133, -1.624310018897, 218, 16, 'PPL', 'P'),
(141123, 'Abbott', 40.9747200012207, 0.715143774104076, -98.4811096191406, -1.71881961387146, 218, 35, 'PPL', 'P'),
(158518, 'Abbott', 41.582218170166, 0.725746617352009, -77.7847213745117, -1.35759949573164, 218, 45, 'PPL', 'P'),
(179598, 'Abbott', 39.0205612182617, 0.681037269234677, -121.624443054199, -2.12274698220012, 218, 6, 'PPL', 'P'),
(187974, 'Abbott', 36.3055610656738, 0.63365157737987, -104.258331298828, -1.81965115379961, 218, 38, 'PPL', 'P'),
(114337, 'Abbott Crossing (historical)', 42.4930610656738, 0.741643824847019, -93.070556640625, -1.62438765004278, 218, 16, 'PPL', 'P'),
(195834, 'Abbott Lake (historical)', 48.4097213745117, 0.844909027958304, -112.228332519531, -1.95875391648884, 218, 31, 'PPL', 'P'),
(169247, 'Abbott Run', 41.9552803039551, 0.732257779901143, -71.3894424438477, -1.24598082180813, 218, 47, 'PPL', 'P'),
(146697, 'Abbotts', 42.2569389343262, 0.737522716218176, -78.3188934326172, -1.36692255691773, 218, 40, 'PPL', 'P'),
(13258, 'Abbotts Mill', 38.8863906860352, 0.67869555168817, -75.476936340332, -1.31732104845695, 218, 10, 'PPL', 'P'),
(126728, 'Abbotts Mill', 44.475830078125, 0.776249672420808, -70.6324996948242, -1.23276967858857, 218, 26, 'PPL', 'P'),
(62426, 'Abbottsburg', 34.5169410705566, 0.60243426939807, -78.7252807617188, -1.37401535384894, 218, 33, 'PPL', 'P'),
(18710, 'Abbottsford', 33.0472183227539, 0.576782768357454, -85.1797180175781, -1.48666653532708, 218, 13, 'PPL', 'P'),
(129414, 'Abbottsford', 43.0200004577637, 0.750840652197444, -82.6333312988281, -1.44222370305583, 218, 27, 'PPL', 'P'),
(77757, 'Abbottstown', 39.8863906860352, 0.696148844208113, -76.9850006103516, -1.34364173530048, 218, 45, 'PPL', 'P'),
(154003, 'Abbottsville', 40.0374984741211, 0.698786172635619, -84.5783309936523, -1.4761703516808, 218, 41, 'PPL', 'P'),
(99272, 'Abbs Valley', 37.2438888549805, 0.65002848676623, -81.4524993896484, -1.42161429832804, 218, 53, 'PPL', 'P'),
(107900, 'Abbs Valley (historical)', 37.3036117553711, 0.651070848016887, -81.3030624389648, -1.41900613151447, 218, 58, 'PPL', 'P'),
(39024, 'Abby Plantation', 29.8116703033447, 0.520311802312382, -90.8408279418945, -1.58547154282372, 218, 22, 'PPL', 'P'),
(31591, 'Abbyville', 37.9708290100098, 0.662715985936449, -98.2038879394531, -1.71398118280301, 218, 20, 'PPL', 'P'),
(7016, 'Abco', 34.3488883972168, 0.599501196931511, -92.8291702270508, -1.62017466235633, 218, 4, 'PPL', 'P'),
(141124, 'Abdal (historical)', 40.1222190856934, 0.700264826251858, -98.1230621337891, -1.71257050637359, 218, 35, 'PPL', 'P'),
(58401, 'Abdan', 32.6138916015625, 0.569219790335792, -89.5666732788086, -1.56323334877324, 218, 30, 'PPL', 'P'),
(158523, 'Abdera', 41.0305595397949, 0.716118357904991, -77.5611114501953, -1.35369676631218, 218, 45, 'PPL', 'P'),
(154004, 'Abe', 40.165828704834, 0.701025957691403, -84.3744430541992, -1.47261183583224, 218, 41, 'PPL', 'P'),
(195832, 'Abe (historical)', 45.0433311462402, 0.786154434568004, -111.683326721191, -1.94924177086535, 218, 31, 'PPL', 'P'),
(14933, 'Abe Springs', 30.3655605316162, 0.529979010490343, -85.1474990844727, -1.48610420886291, 218, 12, 'PPL', 'P'),
(187975, 'Abe Yarbrough', 31.6519393920898, 0.55243055703366, -108.845001220703, -1.89970364563852, 218, 38, 'PPL', 'P'),
(62427, 'Abecrumby (historical)', 35.1438903808594, 0.61337659910596, -80.1402816772461, -1.39871177874363, 218, 33, 'PPL', 'P'),
(112671, 'Abel', 33.5486106872559, 0.585533715962372, -85.7125015258789, -1.49596536174725, 218, 2, 'PPL', 'P'),
(141125, 'Abel', 41.0741691589355, 0.716879489344535, -96.3550033569336, -1.68171205934868, 218, 35, 'PPL', 'P'),
(7019, 'Abeles (historical)', 34.4327812194824, 0.600965402898836, -91.6152801513672, -1.59898828377837, 218, 4, 'PPL', 'P'),
(44260, 'Abell', 38.2541694641113, 0.667661209764618, -76.7438888549805, -1.33943354130399, 218, 25, 'PPL', 'P'),
(191028, 'Abell', 35.3933296203613, 0.61773013511894, -101.45832824707, -1.77078188148054, 218, 51, 'PPL', 'P'),
(99273, 'Abell (historical)', 37.0713882446289, 0.647017783153895, -78.8511123657227, -1.37621152964188, 218, 53, 'PPL', 'P'),
(191029, 'Abell City', 31.25, 0.545415391248228, -102.658332824707, -1.79172591239931, 218, 51, 'PPL', 'P'),
(146698, 'Abell Corners', 42.8983306884766, 0.748717114123242, -75.82861328125, -1.32345896897931, 218, 40, 'PPL', 'P'),
(172829, 'Abells Corners', 42.7261085510254, 0.745711270779897, -88.5425033569336, -1.54535821153662, 218, 57, 'PPL', 'P'),
(39025, 'Aben', 30.107780456543, 0.525479899434276, -90.9427795410156, -1.58725093390606, 218, 22, 'PPL', 'P'),
(18719, 'Abercorn Heights', 32.0325012207031, 0.559072613950372, -81.1069412231445, -1.41558317056539, 218, 13, 'PPL', 'P'),
(92089, 'Abercrombie', 30.3386096954346, 0.529508629662807, -97.7252807617188, -1.70562791172786, 218, 51, 'PPL', 'P'),
(112670, 'Abercrombie', 32.8486099243164, 0.573316397882607, -87.1650009155273, -1.52131625847982, 218, 2, 'PPL', 'P'),
(139553, 'Abercrombie', 46.4477806091309, 0.810666701873311, -96.7300033569336, -1.68825704404366, 218, 34, 'PPL', 'P'),
(7017, 'Aberdeen', 34.603328704834, 0.603942018049218, -91.341667175293, -1.59421283646969, 218, 4, 'PPL', 'P'),
(14934, 'Aberdeen', 26.5502796173096, 0.463389796647192, -80.1488876342773, -1.39886198102911, 218, 12, 'PPL', 'P'),
(18712, 'Aberdeen', 33.4088897705078, 0.583095125931214, -84.601936340332, -1.47658234270144, 218, 13, 'PPL', 'P'),
(34496, 'Aberdeen', 37.2538909912109, 0.650203056975685, -86.6816711425781, -1.51288056256894, 218, 21, 'PPL', 'P'),
(44261, 'Aberdeen', 39.5094413757324, 0.689569837630209, -76.164436340332, -1.32932018706441, 218, 25, 'PPL', 'P'),
(58403, 'Aberdeen', 33.8250007629395, 0.590357632802887, -88.5436096191406, -1.54537751945453, 218, 30, 'PPL', 'P'),
(62428, 'Aberdeen', 35.1313896179199, 0.613158419633655, -79.4297180175781, -1.3863101033374, 218, 33, 'PPL', 'P'),
(71620, 'Aberdeen', 38.6555595397949, 0.674666788170125, -83.7611083984375, -1.46190712667261, 218, 41, 'PPL', 'P'),
(107901, 'Aberdeen', 39.0583305358887, 0.681696468183499, -80.3161087036133, -1.40178053926773, 218, 58, 'PPL', 'P'),
(122102, 'Aberdeen', 41.4388885498047, 0.72324504356107, -87.1113891601563, -1.52038055683082, 218, 19, 'PPL', 'P'),
(124073, 'Aberdeen', 42.3444404602051, 0.739049905945282, -71.1500015258789, -1.24180178942558, 218, 23, 'PPL', 'P'),
(158522, 'Aberdeen', 40.1766700744629, 0.701215175286853, -76.6236114501953, -1.33733430457474, 218, 45, 'PPL', 'P'),
(169688, 'Aberdeen', 45.4647216796875, 0.793509086813394, -98.4861068725586, -1.71890683239716, 218, 49, 'PPL', 'P'),
(179599, 'Aberdeen', 36.9780616760254, 0.645388927252176, -118.252502441406, -2.06389551632517, 218, 6, 'PPL', 'P'),
(191030, 'Aberdeen', 35.0377807617188, 0.611524636883919, -100.148887634277, -1.74792783142797, 218, 51, 'PPL', 'P'),
(194488, 'Aberdeen', 42.9441719055176, 0.749517194293729, -112.837501525879, -1.96938592135071, 218, 17, 'PPL', 'P'),
(195833, 'Aberdeen', 45.0544395446777, 0.786348312695361, -107.356391906738, -1.87372251183398, 218, 31, 'PPL', 'P'),
(206636, 'Aberdeen', 46.9755592346191, 0.819878176609731, -123.814437866211, -2.16096960227132, 218, 56, 'PPL', 'P'),
(7018, 'Aberdeen (historical)', 35.3611106872559, 0.61716780865477, -91.0047225952148, -1.58833204415058, 218, 4, 'PPL', 'P'),
(18713, 'Aberdeen Estates', 33.6624984741211, 0.58752143282098, -84.8133316040039, -1.48027188607563, 218, 13, 'PPL', 'P'),
(99274, 'Aberdeen Gardens', 37.0322189331055, 0.646334149702072, -76.3988876342773, -1.33341213407932, 218, 53, 'PPL', 'P'),
(206637, 'Aberdeen Gardens', 47.0627784729004, 0.821400439488821, -123.778327941895, -2.16033936519936, 218, 56, 'PPL', 'P'),
(58404, 'Aberdeen Junction', 33.0325012207031, 0.576525906470316, -89.8775024414063, -1.56865834107178, 218, 30, 'PPL', 'P'),
(194489, 'Aberdeen Junction', 43.2230606079102, 0.754384720397094, -112.470001220703, -1.96297183102331, 218, 17, 'PPL', 'P'),
(206638, 'Aberdeen Junction', 46.978889465332, 0.819936300100522, -123.761672973633, -2.16004868116637, 218, 56, 'PPL', 'P'),
(84572, 'Aberdeen Park', 35.9283294677734, 0.627067643953948, -86.5199966430664, -1.51005881023595, 218, 50, 'PPL', 'P'),
(112593, 'Aberfoil', 32.0702781677246, 0.559731946057249, -85.6877822875977, -1.49553392965066, 218, 2, 'PPL', 'P'),
(92090, 'Aberfoyle', 33.3050003051758, 0.581281912703034, -96.0250015258789, -1.67595244085917, 218, 51, 'PPL', 'P'),
(112673, 'Abernant', 33.2902793884277, 0.581024984236868, -87.1980590820313, -1.52189323232999, 218, 2, 'PPL', 'P'),
(112672, 'Abernathy', 33.6505584716797, 0.587313040465682, -85.4075012207031, -1.49064210220235, 218, 2, 'PPL', 'P'),
(191031, 'Abernathy', 33.832218170166, 0.590483600322448, -101.842498779297, -1.77748692215704, 218, 51, 'PPL', 'P'),
(58405, 'Abernathy (historical)', 32.3916702270508, 0.565341295682255, -89.8472213745117, -1.56812983675345, 218, 30, 'PPL', 'P'),
(84571, 'Abernathy (historical)', 35.8061103820801, 0.624934518499822, -89.4722213745117, -1.56158485205848, 218, 50, 'PPL', 'P'),
(112674, 'Abernathy (historical)', 33.7966690063477, 0.589863150367487, -85.565559387207, -1.4934007376175, 218, 2, 'PPL', 'P'),
(18714, 'Abernathys Mill', 33.8641700744629, 0.591041266254711, -85.209716796875, -1.48719011279739, 218, 13, 'PPL', 'P'),
(99275, 'Abert', 37.4980583190918, 0.654464580773002, -79.225830078125, -1.38275158748884, 218, 53, 'PPL', 'P'),
(144712, 'Abertown', 41.2508316040039, 0.719962830675602, -74.7850036621094, -1.30524454501983, 218, 37, 'PPL', 'P'),
(53118, 'Abesville', 36.8397216796875, 0.642974438828883, -93.3705596923828, -1.62962369106198, 218, 29, 'PPL', 'P'),
(186308, 'Abeyta', 37.079719543457, 0.647163191749414, -104.185829162598, -1.81838575280766, 218, 7, 'PPL', 'P'),
(187976, 'Abeytas', 34.4674987792969, 0.601571338625857, -106.810829162598, -1.86420064567251, 218, 38, 'PPL', 'P'),
(18715, 'Abide Awhile', 33.5805587768555, 0.586091315315608, -83.9638900756836, -1.46544633460327, 218, 13, 'PPL', 'P'),
(141126, 'Abie', 41.334171295166, 0.721417382683976, -96.9486083984375, -1.69207242177936, 218, 35, 'PPL', 'P'),
(84573, 'Abiff', 35.9761085510254, 0.62790154627028, -87.317497253418, -1.52397782167325, 218, 50, 'PPL', 'P'),
(34497, 'Abigail', 38.5766716003418, 0.673289933886554, -83.9822235107422, -1.46576631340824, 218, 21, 'PPL', 'P'),
(112675, 'Abihka (historical)', 33.2999992370605, 0.581194627598306, -86.1611099243164, -1.50379505535208, 218, 2, 'PPL', 'P'),
(18716, 'Abilene', 33.649169921875, 0.587288805699762, -85.0497207641602, -1.48439765523638, 218, 13, 'PPL', 'P'),
(31592, 'Abilene', 38.9172210693359, 0.679233643386421, -97.2136077880859, -1.6966975336445, 218, 20, 'PPL', 'P'),
(92091, 'Abilene', 32.4486083984375, 0.566335054243018, -99.732780456543, -1.74066539113533, 218, 51, 'PPL', 'P'),
(99276, 'Abilene', 37.1413917541504, 0.648239574882997, -78.5444412231445, -1.37085910848303, 218, 53, 'PPL', 'P'),
(179600, 'Abilene', 36.1455612182617, 0.63085905323984, -119.052780151367, -2.07786299729431, 218, 6, 'PPL', 'P'),
(44263, 'Abingdon', 39.4622192382813, 0.688745655851857, -76.2794418334961, -1.33132741157801, 218, 25, 'PPL', 'P'),
(62429, 'Abingdon', 35.9111099243164, 0.626767106224933, -81.5961074829102, -1.42412073238797, 218, 33, 'PPL', 'P'),
(79481, 'Abingdon', 34.9922218322754, 0.610729483561449, -81.4997177124023, -1.42243841352736, 218, 48, 'PPL', 'P'),
(99277, 'Abingdon', 36.7097206115723, 0.640705492159162, -81.9775009155273, -1.43077730353262, 218, 53, 'PPL', 'P'),
(114338, 'Abingdon', 41.082218170166, 0.717019971092037, -92.1388931274414, -1.60812705421703, 218, 16, 'PPL', 'P'),
(118561, 'Abingdon', 40.8044395446777, 0.712171819485602, -90.4016723632813, -1.57780683204842, 218, 18, 'PPL', 'P'),
(44264, 'Abingdon Reserve', 39.4658317565918, 0.688808706190664, -76.283332824707, -1.3313953221858, 218, 25, 'PPL', 'P'),
(29060, 'Abington', 39.7330589294434, 0.69347270020772, -84.9630584716797, -1.48288511289527, 218, 19, 'PPL', 'P'),
(39026, 'Abington', 32.1113891601563, 0.560449468233943, -93.4786071777344, -1.63150947542987, 218, 22, 'PPL', 'P'),
(124074, 'Abington', 42.1047210693359, 0.73486601329374, -70.9458312988281, -1.238238346729, 218, 23, 'PPL', 'P'),
(158524, 'Abington', 40.1205596923828, 0.700235864375003, -75.1183319091797, -1.3110622204211, 218, 45, 'PPL', 'P'),
(177429, 'Abington', 41.8605613708496, 0.730604622654477, -72.0072174072266, -1.25676302895548, 218, 8, 'PPL', 'P'),
(191032, 'Abington', 34.5444412231445, 0.602914237605529, -100.206939697266, -1.7489410310647, 218, 51, 'PPL', 'P'),
(18717, 'Abington Green', 34.0519409179688, 0.594318485713135, -84.5833282470703, -1.4762575702065, 218, 13, 'PPL', 'P'),
(44265, 'Abington Shores', 38.5852813720703, 0.673440202751062, -76.6680603027344, -1.33811008340028, 218, 25, 'PPL', 'P'),
(187977, 'Abiquiu', 36.207218170166, 0.631935170057313, -106.318061828613, -1.8556002332482, 218, 38, 'PPL', 'P'),
(39037, 'Abita Springs', 30.4783306121826, 0.531947219693966, -90.0374984741211, -1.57145079863278, 218, 22, 'PPL', 'P'),
(186309, 'Able', 38.0605583190918, 0.66428205781547, -102.869171142578, -1.79540573523553, 218, 7, 'PPL', 'P'),
(92092, 'Ables Springs', 32.8147087097168, 0.572724710067418, -96.1208724975586, -1.67762570497206, 218, 51, 'PPL', 'P'),
(70449, 'Ablett Village', 39.9486083984375, 0.697234748142593, -75.102783203125, -1.31079084430602, 218, 37, 'PPL', 'P'),
(62430, 'Abner', 35.4980583190918, 0.619557995733116, -79.9080581665039, -1.39465871388064, 218, 33, 'PPL', 'P'),
(92093, 'Abner', 32.6277809143066, 0.569462204574017, -96.1913909912109, -1.67885648486984, 218, 51, 'PPL', 'P'),
(7020, 'Abner (historical)', 34.1833305358887, 0.596611667148775, -93.710563659668, -1.63555787976095, 218, 4, 'PPL', 'P'),
(58406, 'Abney', 34.2133293151855, 0.597135244619085, -88.4869384765625, -1.54438842142567, 218, 30, 'PPL', 'P'),
(107902, 'Abney', 37.6883316040039, 0.657785476073304, -81.2041702270508, -1.41728013681199, 218, 58, 'PPL', 'P'),
(79482, 'Abney Crossroads', 34.5086097717285, 0.602288860802551, -80.5141677856445, -1.40523732236265, 218, 48, 'PPL', 'P'),
(644, 'Abo', 37.6977806091309, 0.657950392323807, -92.4649963378906, -1.61381862894069, 218, 29, 'PPL', 'P'),
(187978, 'Abo', 34.4558296203613, 0.601367673381493, -106.332496643066, -1.85585216828733, 218, 38, 'PPL', 'P'),
(122103, 'Aboite', 41.0008316040039, 0.715599507545616, -85.3180618286133, -1.4890810903294, 218, 19, 'PPL', 'P'),
(62431, 'Abotts Creek (historical)', 36.0047187805176, 0.628400888974669, -80.084716796875, -1.39774198863268, 218, 33, 'PPL', 'P'),
(192983, 'Abra', 34.9019393920898, 0.609153757723476, -112.446113586426, -1.96255491315466, 218, 5, 'PPL', 'P'),
(107903, 'Abraham', 37.7905616760254, 0.65956972742463, -80.9552764892578, -1.4129361215999, 218, 58, 'PPL', 'P'),
(192462, 'Abraham', 39.396671295166, 0.687601628426586, -112.717216491699, -1.9672865514634, 218, 52, 'PPL', 'P'),
(158527, 'Abrahams', 40.1127815246582, 0.700100109738437, -75.3775024414063, -1.3155855995326, 218, 45, 'PPL', 'P'),
(158528, 'Abrahamsville', 41.7641716003418, 0.728922303793874, -75.123893737793, -1.31115929264284, 218, 45, 'PPL', 'P'),
(92094, 'Abram', 26.1994400024414, 0.457266490221314, -98.4108276367188, -1.71759296187337, 218, 51, 'PPL', 'P'),
(92095, 'Abram North Colonia', 26.2870006561279, 0.458794711923342, -98.3860015869141, -1.71715966556402, 218, 51, 'PPL', 'P'),
(172830, 'Abrams', 44.7791709899902, 0.781543970088858, -88.0597229003906, -1.53693210300567, 218, 57, 'PPL', 'P'),
(193334, 'Abrams Lake Mobile Estates', 41.3380584716797, 0.721485226712746, -122.35417175293, -2.13548315063926, 218, 6, 'PPL', 'P'),
(146699, 'Abrams Landing', 40.9925003051758, 0.715454098950098, -72.1061096191406, -1.25848902365796, 218, 40, 'PPL', 'P'),
(18720, 'Absalom (historical)', 34.2733306884766, 0.598182466138731, -83.915283203125, -1.46459798463802, 218, 13, 'PPL', 'P'),
(139556, 'Absaraka', 46.9780616760254, 0.819921852451609, -97.394172668457, -1.69984898532045, 218, 34, 'PPL', 'P'),
(195835, 'Absarokee', 45.5205612182617, 0.794483670614308, -109.442222595215, -1.91012712498703, 218, 31, 'PPL', 'P'),
(70450, 'Absecon', 39.4283294677734, 0.68815416777375, -74.4961090087891, -1.30020238212798, 218, 37, 'PPL', 'P'),
(70451, 'Absecon Highlands', 39.4466705322266, 0.688474279736777, -74.4744415283203, -1.29982421325319, 218, 37, 'PPL', 'P'),
(34498, 'Absher', 37.1686096191406, 0.64871461624244, -85.2591705322266, -1.48805324330668, 218, 21, 'PPL', 'P'),
(195836, 'Absher (historical)', 46.5583305358887, 0.812596162083073, -107.983329772949, -1.88466464180478, 218, 31, 'PPL', 'P'),
(62433, 'Abshers', 36.3686103820801, 0.63475199554229, -81.1111068725586, -1.41565587486315, 218, 33, 'PPL', 'P'),
(92096, 'Abshier Settlement', 29.9152793884277, 0.52212012198206, -94.6236114501953, -1.65149356993371, 218, 51, 'PPL', 'P'),
(194490, 'Abstein Place', 44.9708290100098, 0.784889033576052, -115.485832214355, -2.01560801154624, 218, 17, 'PPL', 'P'),
(187979, 'Abuelo', 35.9449996948242, 0.62735859430304, -105.360282897949, -1.83888383740189, 218, 38, 'PPL', 'P'),
(29061, 'Abydel', 38.5705604553223, 0.673183274284897, -86.5611114501953, -1.51077639899167, 218, 19, 'PPL', 'P'),
(92097, 'Acacia Colonia', 26.2509994506836, 0.458166372353652, -98.1880035400391, -1.71370394773353, 218, 51, 'PPL', 'P'),
(154006, 'Academia', 40.4136085510254, 0.705350531827528, -82.4683303833008, -1.43934389381108, 218, 41, 'PPL', 'P'),
(158529, 'Academia', 40.4963912963867, 0.706795363297923, -77.4761123657227, -1.35221325242695, 218, 45, 'PPL', 'P'),
(122104, 'Academie', 41.1708297729492, 0.718566535316073, -85.1458282470703, -1.48607504724897, 218, 19, 'PPL', 'P'),
(77759, 'Academy', 39.9055595397949, 0.696483403820055, -75.2624969482422, -1.31357837501901, 218, 45, 'PPL', 'P'),
(92098, 'Academy', 30.9808292388916, 0.540717475216787, -97.3413925170898, -1.69892779789939, 218, 51, 'PPL', 'P'),
(169691, 'Academy', 43.4563903808594, 0.758457093177989, -99.0794372558594, -1.72926240113788, 218, 49, 'PPL', 'P'),
(7021, 'Academy (historical)', 33.8005599975586, 0.589931060975284, -93.7333297729492, -1.63595522339559, 218, 4, 'PPL', 'P'),
(99279, 'Academy (historical)', 37.1272201538086, 0.647992233796756, -77.3125, -1.34935767794812, 218, 53, 'PPL', 'P'),
(18721, 'Academy Acres', 30.8955593109131, 0.539229234220624, -83.2491683959961, -1.45297208805734, 218, 13, 'PPL', 'P'),
(44267, 'Academy Acres', 39.4594383239746, 0.68869711974099, -77.0344390869141, -1.34450459949366, 218, 25, 'PPL', 'P'),
(79485, 'Academy Estates', 32.4327812194824, 0.56605881785895, -80.6352767944336, -1.40735107331985, 218, 48, 'PPL', 'P'),
(158530, 'Academy Garden', 40.0616683959961, 0.699208017352287, -74.9966735839844, -1.30893888208398, 218, 45, 'PPL', 'P'),
(44268, 'Academy Heights', 39.2819404602051, 0.685599197602955, -76.7230606079102, -1.33907001981519, 218, 25, 'PPL', 'P'),
(44269, 'Academy Hill', 38.6597213745117, 0.674739425888857, -76.6619415283203, -1.33800329064056, 218, 25, 'PPL', 'P'),
(44270, 'Academy Hills', 39.6566696166992, 0.692139455186999, -75.8555603027344, -1.32392928322782, 218, 25, 'PPL', 'P'),
(44271, 'Academy Junction', 39.0894393920898, 0.682239420150738, -76.6986083984375, -1.33864324825051, 218, 25, 'PPL', 'P'),
(44272, 'Academy Lane', 39.4355583190918, 0.688280335030392, -76.7866668701172, -1.34018015851559, 218, 25, 'PPL', 'P'),
(99281, 'Academy Park', 36.8055610656738, 0.642378223639841, -76.3511123657227, -1.33257829834202, 218, 53, 'PPL', 'P'),
(112685, 'Academy Park', 33.2000007629395, 0.579449324977923, -87.1566696166992, -1.52117084988431, 218, 2, 'PPL', 'P'),
(158531, 'Academyville', 40.0105590820313, 0.698315991545165, -75.2430572509766, -1.31323908829613, 218, 45, 'PPL', 'P'),
(39029, 'Acadia', 29.7686100006104, 0.519560258252762, -90.8013916015625, -1.58478324883999, 218, 22, 'PPL', 'P'),
(126729, 'Acadia', 46.9861106872559, 0.82006233419911, -68.0322189331055, -1.18738621782031, 218, 26, 'PPL', 'P'),
(39033, 'Acadian Villa', 29.7666702270508, 0.519526402817404, -90.8199996948242, -1.58510802133493, 218, 22, 'PPL', 'P'),
(191033, 'Acala', 31.333890914917, 0.54687956392604, -105.913887023926, -1.8485460521528, 218, 51, 'PPL', 'P'),
(92099, 'Acampo', 32.7127799987793, 0.570945718459245, -99.4433288574219, -1.7356135077055, 218, 51, 'PPL', 'P'),
(179602, 'Acampo', 38.1747207641602, 0.66627456836404, -121.277496337891, -2.11669161967156, 218, 6, 'PPL', 'P'),
(124076, 'Acapesket', 41.5499992370605, 0.725184290887838, -70.5763931274414, -1.23179043425575, 218, 23, 'PPL', 'P'),
(79483, 'Acapulco', 34.0641708374023, 0.594531938074505, -81.4730606079102, -1.42197315928493, 218, 48, 'PPL', 'P'),
(138995, 'Acasto', 40.5980606079102, 0.708569827532243, -91.8338928222656, -1.60280379467212, 218, 29, 'PPL', 'P'),
(99280, 'Acca', 37.5783309936523, 0.655865603243466, -77.4702835083008, -1.35211151967331, 218, 53, 'PPL', 'P'),
(179603, 'Accent Homes Mobile Home Park', 37.4300003051758, 0.6532767443478, -122.429168701172, -2.13679209431504, 218, 6, 'PPL', 'P'),
(141127, 'Accent Mobile Home Parks', 41.0166702270508, 0.715875943666766, -95.9069366455078, -1.67389181996572, 218, 35, 'PPL', 'P'),
(34499, 'Access', 38.209171295166, 0.666875843559153, -83.0711135864258, -1.44986444538133, 218, 21, 'PPL', 'P'),
(7022, 'Accident', 36.2277793884277, 0.632294031014202, -94.1013870239258, -1.64237903426097, 218, 4, 'PPL', 'P'),
(44273, 'Accident', 39.6286087036133, 0.691649699862533, -79.3199996948242, -1.38439515735558, 218, 25, 'PPL', 'P'),
(44274, 'Acco Park', 38.6738891601563, 0.674986700396071, -77.0002822875977, -1.34390845088365, 218, 25, 'PPL', 'P'),
(44275, 'Accokeek', 38.6674995422363, 0.674875180525424, -77.0286102294922, -1.34440286674002, 218, 25, 'PPL', 'P'),
(44276, 'Accokeek Acres', 38.6686096191406, 0.674894555022354, -76.9936065673828, -1.34379193758596, 218, 25, 'PPL', 'P'),
(44277, 'Accokeek Lawn', 38.6694412231445, 0.674909069250295, -77.0388870239258, -1.34458223063944, 218, 25, 'PPL', 'P'),
(195837, 'Accola', 45.9497184753418, 0.801973877759183, -111.184440612793, -1.94053456568134, 218, 31, 'PPL', 'P'),
(99284, 'Accomac', 37.7194404602051, 0.658328428040544, -75.6658325195313, -1.32061790872842, 218, 53, 'PPL', 'P'),
(158532, 'Accomac', 40.0449981689453, 0.698917067003196, -76.5638885498047, -1.33629194332408, 218, 45, 'PPL', 'P'),
(124077, 'Accord', 42.1744384765625, 0.736082811595797, -70.8841705322266, -1.23716216333249, 218, 23, 'PPL', 'P'),
(146700, 'Accord', 41.7855606079102, 0.729295612399676, -74.2294387817383, -1.2955481086489, 218, 40, 'PPL', 'P'),
(99283, 'Accotink', 38.7083282470703, 0.675587775854102, -77.1597213745117, -1.34669118790667, 218, 53, 'PPL', 'P'),
(99285, 'Accotink Heights', 38.8352813720703, 0.677803525881048, -77.2130584716797, -1.34762209586571, 218, 53, 'PPL', 'P'),
(107904, 'Accoville', 37.7686080932617, 0.659186565122795, -81.8372192382813, -1.42832892638445, 218, 58, 'PPL', 'P'),
(92100, 'Ace', 30.5361099243164, 0.532955658930238, -94.8241729736328, -1.65499402887051, 218, 51, 'PPL', 'P'),
(18723, 'Ace Mobile Home Park', 33.5605583190918, 0.585742241475726, -84.2663879394531, -1.4707259183063, 218, 13, 'PPL', 'P'),
(114339, 'Ace Mobile Home Park', 42.4833297729492, 0.741473981748499, -90.716667175293, -1.58330452864473, 218, 16, 'PPL', 'P'),
(179604, 'Acebedo', 35.8319396972656, 0.625385325093345, -120.200828552246, -2.0979002218619, 218, 6, 'PPL', 'P'),
(186310, 'Acequia', 39.523609161377, 0.689817112137423, -105.027496337891, -1.83307561622248, 218, 7, 'PPL', 'P'),
(194491, 'Acequia', 42.6680603027344, 0.744698137722203, -113.59610748291, -1.98262609302615, 218, 17, 'PPL', 'P'),
(92101, 'Acevedo Colonia Number 4', 26.2089996337891, 0.457433337263607, -98.3690032958984, -1.71686298941858, 218, 51, 'PPL', 'P'),
(92102, 'Acevedo Number 3 Colonia', 26.288890838623, 0.458827701831345, -98.3755569458008, -1.7169773721874, 218, 51, 'PPL', 'P'),
(14935, 'Achackwaithle (historical)', 29.8250007629395, 0.520544462723114, -85.0166702270508, -1.48382081454427, 218, 12, 'PPL', 'P'),
(14936, 'Achan', 27.8591709136963, 0.486234259319837, -81.9686126708984, -1.43062217439912, 218, 12, 'PPL', 'P'),
(99286, 'Achash', 38.3319396972656, 0.669018556393204, -78.1655578613281, -1.36424634633831, 218, 53, 'PPL', 'P'),
(177430, 'Achenbach', 41.5872192382813, 0.725833902456736, -72.7074966430664, -1.26898520730423, 218, 8, 'PPL', 'P'),
(158533, 'Acheson', 40.1949996948242, 0.701535087512799, -80.4513931274414, -1.40414169789019, 218, 45, 'PPL', 'P'),
(193087, 'Achi', 32.3444404602051, 0.564516980745849, -112.014167785645, -1.95501603674086, 218, 5, 'PPL', 'P'),
(74929, 'Achille', 33.8333282470703, 0.590502974819379, -96.3869400024414, -1.68226945896483, 218, 42, 'PPL', 'P'),
(99287, 'Achilles', 37.2799987792969, 0.650658723838197, -76.440559387207, -1.33413944337302, 218, 53, 'PPL', 'P'),
(187569, 'Achilles', 39.7119407653809, 0.693104118712853, -100.835830688477, -1.75991724949746, 218, 20, 'PPL', 'P'),
(154007, 'Achor', 40.774169921875, 0.711643514904358, -80.5419387817383, -1.40572201768104, 218, 41, 'PPL', 'P'),
(18724, 'Achord', 32.1061096191406, 0.560357322860227, -82.9688873291016, -1.44808026060903, 218, 13, 'PPL', 'P'),
(146701, 'Acidalia', 41.8994407653809, 0.731283196100229, -75.0336074829102, -1.30958350022584, 218, 40, 'PPL', 'P'),
(112677, 'Acipcoville', 33.5561103820801, 0.58566461032995, -86.8430633544922, -1.51569738805392, 218, 2, 'PPL', 'P'),
(158534, 'Acker', 40.4972190856934, 0.706809810946837, -77.0602798461914, -1.34495560582427, 218, 45, 'PPL', 'P'),
(58412, 'Acker (historical)', 33.9166717529297, 0.59195759340678, -88.4833297729492, -1.54432543766589, 218, 30, 'PPL', 'P'),
(191036, 'Ackerly', 32.5263900756836, 0.567692600608686, -101.715560913086, -1.7752714384462, 218, 51, 'PPL', 'P'),
(58408, 'Ackerman', 33.310001373291, 0.581369197807761, -89.1727828979492, -1.5563586647353, 218, 30, 'PPL', 'P'),
(107905, 'Ackerman (historical)', 39.5855598449707, 0.690898355539995, -78.8208312988281, -1.37568302532355, 218, 58, 'PPL', 'P'),
(144723, 'Ackermans Mills', 41.0272216796875, 0.716060101256145, -74.1691665649414, -1.29449616001832, 218, 37, 'PPL', 'P'),
(158535, 'Ackermanville', 40.839168548584, 0.712777954949704, -75.2197189331055, -1.31283175780741, 218, 45, 'PPL', 'P'),
(144713, 'Ackers Corner', 40.3347206115723, 0.703973677543957, -74.8494415283203, -1.30636919794817, 218, 37, 'PPL', 'P'),
(144714, 'Ackerson', 41.082218170166, 0.717019971092037, -74.668327331543, -1.3032081588923, 218, 37, 'PPL', 'P'),
(112678, 'Ackerville', 32.0294418334961, 0.559019217570516, -87.0663909912109, -1.51959519062536, 218, 2, 'PPL', 'P'),
(172832, 'Ackerville', 43.310001373291, 0.755902123007194, -88.258056640625, -1.54039367979055, 218, 57, 'PPL', 'P'),
(84574, 'Acklena', 35.0063896179199, 0.610976758068662, -90.0680618286133, -1.57198422979913, 218, 50, 'PPL', 'P'),
(114340, 'Ackley', 42.5541687011719, 0.742710354284568, -93.0530624389648, -1.6240823186238, 218, 16, 'PPL', 'P'),
(7023, 'Acklin Gap (historical)', 35.1366691589355, 0.613250565007372, -92.3188934326172, -1.61126865219694, 218, 4, 'PPL', 'P'),
(14937, 'Acklocknayke (historical)', 28.0833301544189, 0.490146576119218, -82.783332824707, -1.44484172356544, 218, 12, 'PPL', 'P'),
(114341, 'Ackworth', 41.3669395446777, 0.72198929652807, -93.4725036621094, -1.63140294898627, 218, 16, 'PPL', 'P'),
(158536, 'Ackworth', 40.0077781677246, 0.698267455434299, -75.6686096191406, -1.32066637826026, 218, 45, 'PPL', 'P'),
(14938, 'Acline', 26.8847198486328, 0.469226879834914, -82.0152816772461, -1.43143670221852, 218, 12, 'PPL', 'P'),
(112679, 'Acmar', 33.6213912963867, 0.586803977223313, -86.4961090087891, -1.5096418923673, 218, 2, 'PPL', 'P'),
(726, 'Acme', 34.3255615234375, 0.599094066179865, -78.2050018310547, -1.3649347734801, 218, 33, 'PPL', 'P'),
(29070, 'Acme', 38.9780616760254, 0.680295512292062, -86.0588912963867, -1.50201100373784, 218, 19, 'PPL', 'P'),
(31594, 'Acme', 38.8424987792969, 0.677929493400609, -97.2605590820313, -1.69751698831192, 218, 20, 'PPL', 'P'),
(39035, 'Acme', 31.2855606079102, 0.546036040940271, -91.8202819824219, -1.60256624070289, 218, 22, 'PPL', 'P'),
(53119, 'Acme', 39.2308311462402, 0.684707171795833, -94.5447235107422, -1.65011671565014, 218, 29, 'PPL', 'P'),
(58410, 'Acme', 31.9675006866455, 0.557938140615512, -89.1733322143555, -1.55636825211523, 218, 30, 'PPL', 'P'),
(74930, 'Acme', 34.7988891601563, 0.607355191881291, -98.0188903808594, -1.71075236629739, 218, 42, 'PPL', 'P'),
(107906, 'Acme', 38.0366706848145, 0.663865139946819, -81.4558334350586, -1.42167248839786, 218, 58, 'PPL', 'P'),
(129415, 'Acme', 44.7719383239746, 0.781417736253189, -85.5013885498047, -1.49228074522107, 218, 27, 'PPL', 'P'),
(154008, 'Acme', 41.0247192382813, 0.716016425414268, -81.79638671875, -1.42761626447675, 218, 41, 'PPL', 'P'),
(158537, 'Acme', 40.1266708374023, 0.700342523976661, -79.4288864135742, -1.38629558910946, 218, 45, 'PPL', 'P'),
(187980, 'Acme', 33.5922203063965, 0.586294847401917, -104.328056335449, -1.82086808525972, 218, 38, 'PPL', 'P'),
(193195, 'Acme', 43.9799995422363, 0.767595797037623, -124.059722900391, -2.16525063372363, 218, 43, 'PPL', 'P'),
(193241, 'Acme', 48.7172203063965, 0.850275896766059, -122.203887939453, -2.13286020328165, 218, 56, 'PPL', 'P'),
(209251, 'Acme', 44.9105606079102, 0.783837151524498, -106.984443664551, -1.8672307903608, 218, 59, 'PPL', 'P'),
(92105, 'Acme (historical)', 34.3166694641113, 0.598938870467341, -99.8236083984375, -1.7422506377742, 218, 51, 'PPL', 'P'),
(179605, 'Acme (historical)', 35.7869415283203, 0.624599958887881, -116.199996948242, -2.02807253755419, 218, 6, 'PPL', 'P'),
(189853, 'Acme (historical)', 38.5374984741211, 0.672606233855704, -118.294166564941, -2.06462269246082, 218, 39, 'PPL', 'P'),
(84575, 'Acme Mill', 35.5499992370605, 0.620464535768179, -84.5683288574219, -1.47599578147135, 218, 50, 'PPL', 'P'),
(158538, 'Acmetonia', 40.540828704834, 0.707570942386381, -79.8161087036133, -1.39305389300775, 218, 45, 'PPL', 'P'),
(124078, 'Acoaxet', 41.5069389343262, 0.724432746828218, -71.0972213745117, -1.24088060200452, 218, 23, 'PPL', 'P'),
(99288, 'Acodale', 38.2150001525879, 0.666977576312794, -77.2444381713867, -1.34816977494389, 218, 53, 'PPL', 'P'),
(179606, 'Acolita', 33.0711097717285, 0.577199752805133, -115.183891296387, -2.01033814838119, 218, 6, 'PPL', 'P'),
(189852, 'Acoma', 37.5483283996582, 0.655341959194129, -114.171669006348, -1.99267153665793, 218, 39, 'PPL', 'P'),
(187981, 'Acoma Pueblo', 34.8963890075684, 0.609056885238824, -107.581108093262, -1.87764454917134, 218, 38, 'PPL', 'P'),
(187986, 'Acoma Village', 34.898609161377, 0.609095634232685, -107.586387634277, -1.87773669454505, 218, 38, 'PPL', 'P'),
(187984, 'Acomita', 35.0552787780762, 0.611830034881924, -107.571113586426, -1.87747011211994, 218, 38, 'PPL', 'P'),
(187985, 'Acomita Lake', 35.0702781677246, 0.612091823617079, -107.613059997559, -1.8782022151036, 218, 38, 'PPL', 'P'),
(58411, 'Acona', 33.271671295166, 0.580700211741933, -90.01611328125, -1.57107755660601, 218, 30, 'PPL', 'P'),
(7024, 'Acorn', 34.6427803039551, 0.604630578349058, -94.2008285522461, -1.64411461634338, 218, 4, 'PPL', 'P'),
(34500, 'Acorn', 37.1330604553223, 0.648094166287478, -84.3777770996094, -1.47267002590206, 218, 21, 'PPL', 'P'),
(84576, 'Acorn', 35.4674987792969, 0.6190246311458, -84.2255630493164, -1.47001338955665, 218, 50, 'PPL', 'P'),
(99290, 'Acorn', 38.0191688537598, 0.663559675369786, -76.6494369506836, -1.33778504458923, 218, 53, 'PPL', 'P'),
(158539, 'Acorn', 40.1930618286133, 0.701501265366955, -75.2944412231445, -1.31413590779322, 218, 45, 'PPL', 'P'),
(179607, 'Acorn', 34.6527786254883, 0.604805081979486, -120.492218017578, -2.10298592743757, 218, 6, 'PPL', 'P'),
(99291, 'Acorn Acres', 36.7683296203613, 0.641728412333862, -76.6750030517578, -1.33823125722987, 218, 53, 'PPL', 'P'),
(143444, 'Acorn Acres', 43.0180587768555, 0.750806763472573, -70.7666702270508, -1.23511139613508, 218, 36, 'PPL', 'P'),
(53120, 'Acorn Corner', 36.0883293151855, 0.629860168093978, -89.7705612182617, -1.5667918646218, 218, 29, 'PPL', 'P'),
(62434, 'Acorn Hill', 36.4425010681152, 0.636041631300161, -76.5480575561523, -1.33601564036098, 218, 33, 'PPL', 'P'),
(84577, 'Acorn Hill', 36.1113891601563, 0.630262638313716, -87.2708282470703, -1.52316329385385, 218, 50, 'PPL', 'P'),
(18731, 'Acorn Pond', 31.8102798461914, 0.555194119296835, -83.8552780151367, -1.46355069653935, 218, 13, 'PPL', 'P'),
(53121, 'Acorn Ridge', 36.913330078125, 0.644259147738737, -90.0580596923828, -1.57180965958967, 218, 29, 'PPL', 'P'),
(124079, 'Acorn Terrace', 42.0944404602051, 0.734686582815296, -71.3722229003906, -1.24568028407911, 218, 23, 'PPL', 'P'),
(18725, 'Acorn Tree', 33.9577789306641, 0.592675049004447, -84.7927780151367, -1.4799131582768, 218, 13, 'PPL', 'P'),
(99292, 'Acors Corner', 38.0900001525879, 0.664795914747801, -77.3263931274414, -1.34960015876537, 218, 53, 'PPL', 'P'),
(158540, 'Acosta', 40.110279083252, 0.700056433896559, -79.0691680908203, -1.38001731999765, 218, 45, 'PPL', 'P'),
(92103, 'Acosta Colonia', 26.3169994354248, 0.459318289393652, -98.2750015258789, -1.71522234902904, 218, 51, 'PPL', 'P'),
(177431, 'Acquidaneck (historical)', 41.7874984741211, 0.72932943454552, -71.8686065673828, -1.25434381342125, 218, 8, 'PPL', 'P'),
(146702, 'Acra', 42.3108291625977, 0.738463278136164, -74.0558319091797, -1.29251809711866, 218, 40, 'PPL', 'P'),
(92104, 'Acre Tract Colonia', 26.2280006408691, 0.457764967398349, -97.9580001831055, -1.7096896318644, 218, 51, 'PPL', 'P'),
(44278, 'Acredale', 39.0027809143066, 0.680726944388655, -76.9430618286133, -1.34290976547487, 218, 25, 'PPL', 'P'),
(99293, 'Acredale', 36.7969398498535, 0.642227755038252, -76.1747207641602, -1.32949968412189, 218, 53, 'PPL', 'P'),
(18726, 'Acree', 31.5552806854248, 0.550743544351636, -83.9961090087891, -1.46600866106744, 218, 13, 'PPL', 'P'),
(99294, 'Acree Acres', 37.1755599975586, 0.648835923230093, -76.4688873291016, -1.33463385922939, 218, 53, 'PPL', 'P'),
(186311, 'Acres Green', 39.5566711425781, 0.690394152566616, -104.895561218262, -1.83077291398594, 218, 7, 'PPL', 'P'),
(44279, 'Acresville', 39.1777801513672, 0.68378125726384, -76.6116714477539, -1.33712591221944, 218, 25, 'PPL', 'P'),
(177432, 'Acropolis (historical)', 41.5363883972168, 0.724946736918603, -73.2061080932617, -1.27768761879829, 218, 8, 'PPL', 'P'),
(179608, 'Actis', 34.958610534668, 0.610142855752331, -118.14778137207, -2.06206778886905, 218, 6, 'PPL', 'P'),
(112681, 'Active', 32.8677787780762, 0.573650957494548, -86.976936340332, -1.5180339124363, 218, 2, 'PPL', 'P'),
(29062, 'Acton', 39.6555595397949, 0.692120080690069, -85.9669418334961, -1.50040618286496, 218, 19, 'PPL', 'P'),
(34501, 'Acton', 37.3469390869141, 0.651827052608415, -85.2480621337891, -1.48785936517932, 218, 21, 'PPL', 'P'),
(62435, 'Acton', 35.5613899230957, 0.620663340743553, -82.6391677856445, -1.44232556896753, 218, 33, 'PPL', 'P'),
(70453, 'Acton', 39.584171295166, 0.690874120774075, -75.4136123657227, -1.31621583660457, 218, 37, 'PPL', 'P'),
(84578, 'Acton', 35.0080604553223, 0.611005919682599, -88.4594421386719, -1.54390851979724, 218, 50, 'PPL', 'P'),
(92106, 'Acton', 32.4466705322266, 0.566301232097174, -97.6900024414063, -1.70501218888384, 218, 51, 'PPL', 'P'),
(112683, 'Acton', 33.3561096191406, 0.582173938510156, -86.8069381713867, -1.51506688466584, 218, 2, 'PPL', 'P'),
(124080, 'Acton', 42.4850006103516, 0.741503143362435, -71.4333267211914, -1.24674674693764, 218, 23, 'PPL', 'P'),
(126730, 'Acton', 43.5341682434082, 0.759814572964629, -70.9102783203125, -1.23761783019501, 218, 26, 'PPL', 'P'),
(133848, 'Acton', 45.084171295166, 0.786867229633763, -94.6605606079102, -1.65213845439168, 218, 28, 'PPL', 'P'),
(179609, 'Acton', 34.4700012207031, 0.601615014467734, -118.195831298828, -2.06290641829632, 218, 6, 'PPL', 'P'),
(195838, 'Acton', 45.9305610656738, 0.801639517884324, -108.680000305176, -1.89682383639376, 218, 31, 'PPL', 'P'),
(18727, 'Acton (historical)', 32.6527786254883, 0.569898496939599, -85.0100021362305, -1.48370443440463, 218, 13, 'PPL', 'P'),
(44280, 'Acton Village', 38.6405601501465, 0.674404999434971, -76.9055633544922, -1.34225529363698, 218, 25, 'PPL', 'P'),
(84579, 'Acuff', 36.3158302307129, 0.633830808121232, -83.7200012207031, -1.46118967107494, 218, 50, 'PPL', 'P'),
(191034, 'Acuff', 33.5950012207031, 0.586343383512784, -101.619720458984, -1.77359870696552, 218, 51, 'PPL', 'P'),
(107907, 'Acup', 38.3619384765625, 0.669542133863513, -81.3422164916992, -1.41968949865018, 218, 58, 'PPL', 'P'),
(124082, 'Acushnet', 41.6805610656738, 0.727463024674565, -70.908332824707, -1.23758387489111, 218, 23, 'PPL', 'P'),
(124083, 'Acushnet Station (historical)', 41.6749992370605, 0.727365952452831, -70.9400024414063, -1.23813661397535, 218, 23, 'PPL', 'P'),
(18728, 'Acworth', 34.0658302307129, 0.59456089995136, -84.6769409179688, -1.47789141953526, 218, 13, 'PPL', 'P'),
(92107, 'Acworth', 33.774169921875, 0.589470467264755, -94.9494400024414, -1.65718035096742, 218, 51, 'PPL', 'P'),
(143445, 'Acworth', 43.2177810668945, 0.754292575023377, -72.2925033569336, -1.26174220808754, 218, 36, 'PPL', 'P'),
(18729, 'Acworth Beach', 34.0608291625977, 0.594473614846632, -84.682502746582, -1.477988491757, 218, 13, 'PPL', 'P'),
(39036, 'Acy', 30.2186107635498, 0.527414253202542, -90.8202819824219, -1.58511294818294, 218, 22, 'PPL', 'P'),
(7026, 'Ada', 35.1069412231445, 0.612731714647997, -92.8733291625977, -1.6209453811758, 218, 4, 'PPL', 'P'),
(31595, 'Ada', 39.1513900756836, 0.683320663553311, -97.8888931274414, -1.7084834862067, 218, 20, 'PPL', 'P'),
(39038, 'Ada', 32.5458297729492, 0.568031887331562, -93.1402816772461, -1.62560458150289, 218, 22, 'PPL', 'P'),
(74931, 'Ada', 34.7744407653809, 0.606928486895633, -96.6780624389648, -1.6873505040086, 218, 42, 'PPL', 'P'),
(92108, 'Ada', 30.4877490997314, 0.532111603312251, -95.4911804199219, -1.66663550494358, 218, 51, 'PPL', 'P'),
(99295, 'Ada', 38.8369407653809, 0.677832487757903, -77.9186096191406, -1.35993628643013, 218, 53, 'PPL', 'P'),
(107908, 'Ada', 37.2947196960449, 0.650915652304363, -81.1469421386719, -1.41628131824515, 218, 58, 'PPL', 'P'),
(112684, 'Ada', 32.105281829834, 0.560342875211313, -86.2763900756836, -1.50580707355564, 218, 2, 'PPL', 'P'),
(129417, 'Ada', 42.9541702270508, 0.749691697924156, -85.4888916015625, -1.49206263232779, 218, 27, 'PPL', 'P'),
(133850, 'Ada', 47.2997207641602, 0.825535862608523, -96.5149993896484, -1.68450451690968, 218, 28, 'PPL', 'P'),
(154009, 'Ada', 40.7694396972656, 0.711560956910565, -83.8227767944336, -1.46298344322716, 218, 41, 'PPL', 'P'),
(172834, 'Ada', 43.8769416809082, 0.765797098037383, -87.8955612182617, -1.53406694114691, 218, 57, 'PPL', 'P'),
(79484, 'Ada (historical)', 34.5661087036133, 0.603292406480321, -81.5286102294922, -1.42294268307977, 218, 48, 'PPL', 'P'),
(18732, 'Adabelle', 32.291389465332, 0.563591066213855, -81.9272232055664, -1.42989979195344, 218, 13, 'PPL', 'P'),
(515, 'Adaburg', 37.5916709899902, 0.656098430101766, -86.8477783203125, -1.5157796797316, 218, 21, 'PPL', 'P'),
(77760, 'Adah', 39.8963890075684, 0.696323347838541, -79.9222183227539, -1.3949058552298, 218, 45, 'PPL', 'P'),
(34502, 'Adair', 37.9505615234375, 0.66236225156466, -86.8266677856445, -1.51541123139479, 218, 21, 'PPL', 'P'),
(58414, 'Adair', 33.3136100769043, 0.581432181567541, -90.0905609130859, -1.57237691290186, 218, 30, 'PPL', 'P'),
(74932, 'Adair', 36.4366683959961, 0.635939831967493, -95.271110534668, -1.66279456086141, 218, 42, 'PPL', 'P'),
(84580, 'Adair', 35.714168548584, 0.623329830784995, -88.9608306884766, -1.55265940082313, 218, 50, 'PPL', 'P'),
(114342, 'Adair', 41.500560760498, 0.724321426694653, -94.6433334350586, -1.65183778350461, 218, 16, 'PPL', 'P'),
(118564, 'Adair', 40.4188919067383, 0.705442743780272, -90.4966735839844, -1.5794649161431, 218, 18, 'PPL', 'P'),
(129419, 'Adair', 42.7980613708496, 0.746967084391924, -82.6338882446289, -1.44223342359381, 218, 27, 'PPL', 'P'),
(138996, 'Adair', 40.2522201538086, 0.702533772921578, -92.3763885498047, -1.61227213129568, 218, 29, 'PPL', 'P'),
(154010, 'Adair', 40.7936096191406, 0.711982801627234, -80.9561080932617, -1.41295063582785, 218, 41, 'PPL', 'P'),
(191035, 'Adair', 32.9627799987793, 0.575309041589231, -102.254173278809, -1.78467199762002, 218, 51, 'PPL', 'P'),
(194493, 'Adair', 47.3422203063965, 0.826277619551137, -115.611106872559, -2.01779446680119, 218, 17, 'PPL', 'P'),
(200292, 'Adair Village', 44.6708297729492, 0.779653059135875, -123.216667175293, -2.15053653554288, 218, 43, 'PPL', 'P'),
(18733, 'Adairsville', 34.3686103820801, 0.599845410502404, -84.9341735839844, -1.48238097650092, 218, 13, 'PPL', 'P'),
(34504, 'Adairville', 36.6674995422363, 0.639968595485538, -86.851936340332, -1.51585225087131, 218, 21, 'PPL', 'P'),
(212251, 'Adak', 51.8800010681152, 0.905476834576786, -176.658065795898, -3.0832648983432, 218, 1, 'PPL', 'P'),
(62436, 'Adako', 35.9041709899902, 0.626645998974362, -81.7041702270508, -1.42600678307196, 218, 33, 'PPL', 'P'),
(107909, 'Adaland', 39.208610534668, 0.68431934896209, -80.0769424438477, -1.39760630057514, 218, 58, 'PPL', 'P'),
(107910, 'Adaline', 39.7652816772461, 0.694035093250917, -80.6466674804688, -1.40754987829522, 218, 58, 'PPL', 'P'),
(126732, 'Adaline', 46.7619400024414, 0.816149817662648, -68.1244430541992, -1.18899583238316, 218, 26, 'PPL', 'P'),
(14940, 'Adam', 29.4911098480225, 0.514716966915316, -82.5063934326172, -1.440008219345, 218, 12, 'PPL', 'P'),
(107911, 'Adam', 38.8300018310547, 0.677711380507331, -81.1719436645508, -1.41671767718976, 218, 58, 'PPL', 'P'),
(99297, 'Adam Acres', 37.2144393920898, 0.649514496675845, -80.0219421386719, -1.39664636416022, 218, 53, 'PPL', 'P'),
(53123, 'Adam Ford', 37.6283302307129, 0.656738254553657, -92.32861328125, -1.61143829555838, 218, 29, 'PPL', 'P'),
(92109, 'Adam Lee Colonia', 26.3759994506836, 0.460348033918644, -98.1669998168945, -1.71333736360948, 218, 51, 'PPL', 'P'),
(192984, 'Adamana', 34.9766693115234, 0.610458040867342, -109.821670532227, -1.91674974082779, 218, 5, 'PPL', 'P'),
(171670, 'Adamant', 44.3291702270508, 0.773689975139078, -72.5033264160156, -1.26542176460765, 218, 55, 'PPL', 'P'),
(14941, 'Adams', 30.4650001525879, 0.531714559283234, -83.0461120605469, -1.44942808643672, 218, 12, 'PPL', 'P'),
(26326, 'Adams', 39.8652801513672, 0.695780395871301, -91.1980590820313, -1.59170640240976, 218, 18, 'PPL', 'P'),
(29064, 'Adams', 39.4822196960449, 0.689094729691739, -86.3555603027344, -1.50718885468723, 218, 19, 'PPL', 'P'),
(31596, 'Adams', 37.458610534668, 0.65377608705219, -97.9772186279297, -1.71002505700369, 218, 20, 'PPL', 'P'),
(34505, 'Adams', 38.0544395446777, 0.664175265055758, -82.7077789306641, -1.44352305935168, 218, 21, 'PPL', 'P'),
(53124, 'Adams', 39.0916709899902, 0.682278368881681, -94.3375015258789, -1.64650000973176, 218, 29, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(58413, 'Adams', 32.1597213745117, 0.561293024509226, -90.5605621337891, -1.58057998169152, 218, 30, 'PPL', 'P'),
(84581, 'Adams', 36.582218170166, 0.638480154752292, -87.065559387207, -1.51958067639742, 218, 50, 'PPL', 'P'),
(107913, 'Adams', 38.1699981689453, 0.666192143528302, -81.8525009155273, -1.42859564196763, 218, 58, 'PPL', 'P'),
(112665, 'Adams', 32.7394409179688, 0.571411039280709, -86.8327789306641, -1.51551789099645, 218, 2, 'PPL', 'P'),
(124086, 'Adams', 42.6241683959961, 0.743932079434642, -73.1180572509766, -1.27615084169125, 218, 23, 'PPL', 'P'),
(126733, 'Adams', 45.3274993896484, 0.791114106045085, -68.9011077880859, -1.20255118917361, 218, 26, 'PPL', 'P'),
(133852, 'Adams', 43.5652809143066, 0.760357591510897, -92.7191696166992, -1.61825478952649, 218, 28, 'PPL', 'P'),
(139559, 'Adams', 48.4213905334473, 0.845112693202668, -98.07861328125, -1.71179472754805, 218, 34, 'PPL', 'P'),
(141128, 'Adams', 40.4594383239746, 0.706150412260933, -96.5097198486328, -1.68441237153597, 218, 35, 'PPL', 'P'),
(144715, 'Adams', 40.4508285522461, 0.706000143396425, -74.4936065673828, -1.3001587062861, 218, 37, 'PPL', 'P'),
(146703, 'Adams', 43.8091697692871, 0.764614255039225, -76.0244369506836, -1.32687673676427, 218, 40, 'PPL', 'P'),
(158542, 'Adams', 40.3594398498535, 0.70440510964055, -77.8619384765625, -1.35894718840127, 218, 45, 'PPL', 'P'),
(172836, 'Adams', 42.8005599975586, 0.747010693654774, -88.5327835083008, -1.54518856817519, 218, 57, 'PPL', 'P'),
(179610, 'Adams', 38.8563919067383, 0.67817197421786, -122.718612670898, -2.14184384458681, 218, 6, 'PPL', 'P'),
(190950, 'Adams', 36.7563896179199, 0.641520019978563, -101.076667785645, -1.76412064980398, 218, 42, 'PPL', 'P'),
(191037, 'Adams', 30.934440612793, 0.53990784095589, -100.264442443848, -1.74994464332149, 218, 51, 'PPL', 'P'),
(200293, 'Adams', 45.7675018310547, 0.798793597364438, -118.561393737793, -2.06928668647787, 218, 43, 'PPL', 'P'),
(18734, 'Adams (historical)', 33.4097213745117, 0.583109640159155, -82.0111083984375, -1.43136386476271, 218, 13, 'PPL', 'P'),
(118565, 'Adams (historical)', 41.0994415283203, 0.71732057540008, -88.584716796875, -1.54609497505219, 218, 18, 'PPL', 'P'),
(138998, 'Adams (historical)', 40.5152816772461, 0.707125062640875, -94.2544403076172, -1.64505031799238, 218, 29, 'PPL', 'P'),
(146704, 'Adams Basin', 43.1974983215332, 0.753938574335479, -77.8541717529297, -1.35881163350179, 218, 40, 'PPL', 'P'),
(172837, 'Adams Beach', 44.6861114501953, 0.779919774719046, -88.6680603027344, -1.54754959363959, 218, 57, 'PPL', 'P'),
(146705, 'Adams Center', 43.8600006103516, 0.765501420577357, -76.0058288574219, -1.32655196426933, 218, 40, 'PPL', 'P'),
(172838, 'Adams Center (historical)', 43.9161109924316, 0.766480731489207, -89.7972183227539, -1.56725711886424, 218, 57, 'PPL', 'P'),
(44281, 'Adams Chance', 39.5758285522461, 0.690728512441475, -76.8819427490234, -1.34184303630024, 218, 25, 'PPL', 'P'),
(26327, 'Adams Corner', 38.5130615234375, 0.672179728607128, -87.741943359375, -1.53138580371947, 218, 18, 'PPL', 'P'),
(31597, 'Adams Corner', 38.0574989318848, 0.664228661435614, -98.0869369506836, -1.71194000298552, 218, 20, 'PPL', 'P'),
(126734, 'Adams Corner', 43.4124984741211, 0.757691034890427, -70.4416732788086, -1.22943912932932, 218, 26, 'PPL', 'P'),
(146706, 'Adams Corner', 42.4266700744629, 0.740485083456725, -75.7286071777344, -1.32171353320088, 218, 40, 'PPL', 'P'),
(146707, 'Adams Corners', 41.353328704834, 0.721751742558835, -73.8399963378906, -1.28875105575675, 218, 40, 'PPL', 'P'),
(146708, 'Adams Cove', 44.0063896179199, 0.768056390748152, -76.1588897705078, -1.32922338115879, 218, 40, 'PPL', 'P'),
(79486, 'Adams Crossing', 34.6522216796875, 0.604795361441507, -82.8663864135742, -1.44629128214677, 218, 48, 'PPL', 'P'),
(158543, 'Adams Crossing', 40.5424995422363, 0.707600104000318, -78.8802795410156, -1.37672059288424, 218, 45, 'PPL', 'P'),
(13259, 'Adams Crossroads', 38.7972183227539, 0.677139200347128, -75.7016677856445, -1.32124335211042, 218, 10, 'PPL', 'P'),
(18736, 'Adams Crossroads', 33.964168548584, 0.592786568875094, -84.1397171020508, -1.46851509512737, 218, 13, 'PPL', 'P'),
(84582, 'Adams Crossroads', 36.1813888549805, 0.63148436346379, -87.5208282470703, -1.52752661698383, 218, 50, 'PPL', 'P'),
(112686, 'Adams Crossroads', 34.0774993896484, 0.594764565195723, -85.4877777099609, -1.49204319125184, 218, 2, 'PPL', 'P'),
(92111, 'Adams Gardens', 26.1681499481201, 0.456720375750279, -97.7921524047852, -1.70679504207559, 218, 51, 'PPL', 'P'),
(84583, 'Adams Grove', 36.1072196960449, 0.63018986743693, -86.2655563354492, -1.50561798911824, 218, 50, 'PPL', 'P'),
(99298, 'Adams Grove', 36.6930618286133, 0.640414741547153, -77.3855590820313, -1.35063279947805, 218, 53, 'PPL', 'P'),
(44285, 'Adams Heights', 39.5377807617188, 0.690064453223664, -76.1805572509766, -1.32960155003358, 218, 25, 'PPL', 'P'),
(124087, 'Adams Junction', 42.4583282470703, 0.741037622803889, -73.2083282470703, -1.27772636779215, 218, 23, 'PPL', 'P'),
(58416, 'Adams Landing', 32.5702781677246, 0.56845859231722, -90.7266693115234, -1.58347909885418, 218, 30, 'PPL', 'P'),
(79487, 'Adams Landing', 33.5275001525879, 0.58516526762556, -80.4383316040039, -1.40391373130088, 218, 48, 'PPL', 'P'),
(171671, 'Adams Landing', 44.7361106872559, 0.780792426029238, -73.3324966430664, -1.2798935151292, 218, 55, 'PPL', 'P'),
(84584, 'Adams Mill', 36.1402816772461, 0.630766907866123, -82.5980606079102, -1.44160811336986, 218, 50, 'PPL', 'P'),
(122106, 'Adams Mill', 40.4805603027344, 0.706519060334827, -86.5088882446289, -1.50986493210859, 218, 19, 'PPL', 'P'),
(154011, 'Adams Mills', 40.1566696166992, 0.700866101446971, -81.9469375610352, -1.43024387236628, 218, 41, 'PPL', 'P'),
(44282, 'Adams Mobile Home Park', 39.5297203063965, 0.68992377173908, -76.1263885498047, -1.3286561278466, 218, 25, 'PPL', 'P'),
(13028, 'Adams Morgan', 38.9213905334473, 0.679306414263207, -77.0425033569336, -1.34464534755728, 218, 9, 'PPL', 'P'),
(129420, 'Adams Park', 42.1538887023926, 0.735724150375991, -85.4727783203125, -1.49178140251668, 218, 27, 'PPL', 'P'),
(202818, 'Adams Park', 40.6355590820313, 0.70922429937013, -111.855560302734, -1.95224781394578, 218, 52, 'PPL', 'P'),
(154012, 'Adams Ridge', 41.398609161377, 0.722542035612316, -84.2655563354492, -1.47071140407836, 218, 41, 'PPL', 'P'),
(79489, 'Adams Run', 32.7205581665039, 0.571081473095812, -80.3483276367188, -1.4023428657319, 218, 48, 'PPL', 'P'),
(124088, 'Adams Shore', 42.2638893127441, 0.737644023205829, -70.9847183227539, -1.2389170533328, 218, 23, 'PPL', 'P'),
(179611, 'Adams Square', 34.1336097717285, 0.595743876107573, -118.240280151367, -2.06368219712186, 218, 6, 'PPL', 'P'),
(193335, 'Adams Station', 41.8427810668945, 0.730294297808455, -123.991386413574, -2.16405793702943, 218, 6, 'PPL', 'P'),
(143447, 'Adams Trailer Park', 42.9033317565918, 0.748804399227969, -70.8641662597656, -1.23681302291359, 218, 36, 'PPL', 'P'),
(122112, 'Adamsboro', 40.7844390869141, 0.71182274564572, -86.2669372558594, -1.50564209072611, 218, 19, 'PPL', 'P'),
(79490, 'Adamsburg', 34.7911109924316, 0.607219437244724, -81.5430603027344, -1.423194884435, 218, 48, 'PPL', 'P'),
(112689, 'Adamsburg', 34.3988914489746, 0.60037391482073, -85.6722183227539, -1.49526228721947, 218, 2, 'PPL', 'P'),
(158547, 'Adamsburg', 40.3116683959961, 0.703571340482273, -79.6563873291016, -1.39026622913671, 218, 45, 'PPL', 'P'),
(124090, 'Adamsdale', 41.9277801513672, 0.731777811693684, -71.3708267211914, -1.24565591615514, 218, 23, 'PPL', 'P'),
(158549, 'Adamsdale', 40.6361083984375, 0.709233886750054, -76.1283264160156, -1.32868994999245, 218, 45, 'PPL', 'P'),
(18738, 'Adamson', 33.2677803039551, 0.580632301134136, -85.2322235107422, -1.48758292905817, 218, 13, 'PPL', 'P'),
(34506, 'Adamson', 37.2016716003418, 0.649291656671632, -82.5791702270508, -1.44127841402691, 218, 21, 'PPL', 'P'),
(74936, 'Adamson', 34.9238891601563, 0.609536853446284, -95.5469436645508, -1.66760875716395, 218, 42, 'PPL', 'P'),
(107914, 'Adamston', 39.2905616760254, 0.685749666204545, -80.3580627441406, -1.40251277540944, 218, 58, 'PPL', 'P'),
(144716, 'Adamston', 40.045280456543, 0.698921993851213, -74.0955581665039, -1.29321145110847, 218, 37, 'PPL', 'P'),
(44283, 'Adamstown', 39.3108291625977, 0.686103400576334, -77.4749984741211, -1.352193811351, 218, 25, 'PPL', 'P'),
(158550, 'Adamstown', 40.2411117553711, 0.702339894794221, -76.0566711425781, -1.32743932954455, 218, 45, 'PPL', 'P'),
(44284, 'Adamstown Village', 39.3166694641113, 0.686205333067057, -77.5066680908203, -1.35274655043524, 218, 25, 'PPL', 'P'),
(13260, 'Adamsville', 38.8313903808594, 0.677735615273251, -75.6894378662109, -1.32102989974905, 218, 10, 'PPL', 'P'),
(14944, 'Adamsville', 28.7994403839111, 0.502645057431069, -82.0208282470703, -1.43153350812415, 218, 12, 'PPL', 'P'),
(18740, 'Adamsville', 33.3752784729004, 0.582508498122097, -82.3702774047852, -1.43763254649459, 218, 13, 'PPL', 'P'),
(31599, 'Adamsville', 37.1733283996582, 0.64879697449915, -97.1761093139648, -1.69604306180661, 218, 20, 'PPL', 'P'),
(62441, 'Adamsville', 35.3708305358887, 0.617337452016208, -77.95361328125, -1.36054721558419, 218, 33, 'PPL', 'P'),
(84585, 'Adamsville', 35.2358283996582, 0.61498122024176, -88.3905563354492, -1.54270623572312, 218, 50, 'PPL', 'P'),
(92112, 'Adamsville', 31.3011093139648, 0.54630741705535, -98.1686096191406, -1.71336545995898, 218, 51, 'PPL', 'P'),
(107915, 'Adamsville', 39.3952789306641, 0.687577327081639, -80.2447204589844, -1.40053457935173, 218, 58, 'PPL', 'P'),
(112688, 'Adamsville', 33.600830078125, 0.586445116266425, -86.9561080932617, -1.51767039094751, 218, 2, 'PPL', 'P'),
(124091, 'Adamsville', 42.6813888549805, 0.744930764843422, -72.7486114501953, -1.26970279605996, 218, 23, 'PPL', 'P'),
(129424, 'Adamsville', 41.7852783203125, 0.729290685551659, -85.9938888549805, -1.50087649711347, 218, 27, 'PPL', 'P'),
(146710, 'Adamsville', 43.3208312988281, 0.756091140865562, -73.4736099243164, -1.2823564065053, 218, 40, 'PPL', 'P'),
(154020, 'Adamsville', 40.0697212219238, 0.699348565678816, -81.8824996948242, -1.42911921943793, 218, 41, 'PPL', 'P'),
(158552, 'Adamsville', 41.5111083984375, 0.724505517705004, -80.370002746582, -1.40272116776474, 218, 45, 'PPL', 'P'),
(169248, 'Adamsville', 41.5544395446777, 0.72526178887556, -71.1316680908203, -1.2414818106206, 218, 47, 'PPL', 'P'),
(192463, 'Adamsville', 38.2583312988281, 0.667733847483349, -112.793060302734, -1.96861027568323, 218, 52, 'PPL', 'P'),
(192987, 'Adamsville', 33.0127792358398, 0.576181692899423, -111.441390991211, -1.94501919579898, 218, 5, 'PPL', 'P'),
(58417, 'Adamsville (historical)', 31.2930603027344, 0.546166935307848, -88.5458297729492, -1.54541626844839, 218, 30, 'PPL', 'P'),
(124092, 'Adamsville (historical)', 42.2425003051758, 0.737270714600027, -71.0711135864258, -1.24042493514201, 218, 23, 'PPL', 'P'),
(79491, 'Adamsville Crossroads', 34.688060760498, 0.605420871402539, -79.595832824707, -1.38920935365812, 218, 48, 'PPL', 'P'),
(154021, 'Adario', 40.934440612793, 0.714440766155323, -82.4502792358398, -1.43902884185412, 218, 41, 'PPL', 'P'),
(18741, 'Adasburg', 33.7061080932617, 0.588282564260525, -82.5483322143555, -1.4407401891706, 218, 13, 'PPL', 'P'),
(58418, 'Adaton', 33.4772186279297, 0.584287689467352, -88.92138671875, -1.55197097368134, 218, 30, 'PPL', 'P'),
(199134, 'Adaton (historical)', 42.8847198486328, 0.748479560154007, -102.762222290039, -1.79353912562749, 218, 35, 'PPL', 'P'),
(189854, 'Adaven', 38.1322212219238, 0.665532811421426, -115.59944152832, -2.01759086813586, 218, 39, 'PPL', 'P'),
(114350, 'Adaville', 42.7508316040039, 0.746142769455517, -96.404167175293, -1.6825701298519, 218, 16, 'PPL', 'P'),
(114351, 'Adaza', 42.1952781677246, 0.736446532821675, -94.4941711425781, -1.649234410381, 218, 16, 'PPL', 'P'),
(206640, 'Adco', 47.4174995422363, 0.827591490074928, -119.361389160156, -2.083249240599, 218, 56, 'PPL', 'P'),
(62439, 'Adcock Crossroads', 36.3294410705566, 0.634068362090467, -78.3552780151367, -1.36755758767966, 218, 33, 'PPL', 'P'),
(13261, 'Addick Estates', 39.8027801513672, 0.694689565088804, -75.4499969482422, -1.3168508673665, 218, 10, 'PPL', 'P'),
(92113, 'Addicks', 29.7822208404541, 0.519797812221997, -95.642219543457, -1.66927163494859, 218, 51, 'PPL', 'P'),
(58419, 'Addie', 32.9872207641602, 0.575735613416835, -91.0758285522461, -1.58957307721855, 218, 30, 'PPL', 'P'),
(62440, 'Addie', 35.4058303833008, 0.617948314591245, -83.1600036621094, -1.45141586987435, 218, 33, 'PPL', 'P'),
(194495, 'Addie', 48.9536094665527, 0.85440166592681, -116.165283203125, -2.0274666684062, 218, 17, 'PPL', 'P'),
(84586, 'Addie (historical)', 36.3791694641113, 0.634936286289724, -86.9086074829102, -1.51684134890016, 218, 50, 'PPL', 'P'),
(74937, 'Addielee', 35.9588890075684, 0.627601008541264, -94.6366729736328, -1.65172153652303, 218, 42, 'PPL', 'P'),
(92114, 'Addielou', 33.8147201538086, 0.590178202324443, -95.2163925170898, -1.66183955129451, 218, 51, 'PPL', 'P'),
(26329, 'Addieville', 38.3913917541504, 0.670056190532926, -89.4899978637695, -1.56189511032547, 218, 18, 'PPL', 'P'),
(77763, 'Addingham', 39.9422187805176, 0.697123228271946, -75.3050003051758, -1.31432019854065, 218, 45, 'PPL', 'P'),
(74938, 'Addington', 34.2444381713867, 0.597678196586324, -97.966667175293, -1.70984089941432, 218, 42, 'PPL', 'P'),
(99299, 'Addington', 36.9766693115234, 0.645364625907229, -82.6213912963867, -1.44201531070053, 218, 53, 'PPL', 'P'),
(62443, 'Addington Mill', 35.1133308410645, 0.612843234518644, -83.398063659668, -1.45557080064904, 218, 33, 'PPL', 'P'),
(39039, 'Addis', 30.353609085083, 0.529770418397962, -91.2652816772461, -1.592879658028, 218, 22, 'PPL', 'P'),
(34507, 'Addison', 37.9161109924316, 0.661760976369547, -86.5650024414063, -1.51084430959947, 218, 21, 'PPL', 'P'),
(71626, 'Addison', 38.8861083984375, 0.678690624840153, -82.1463928222656, -1.43372502338517, 218, 41, 'PPL', 'P'),
(77764, 'Addison', 39.7472190856934, 0.693719841556879, -79.3394393920898, -1.38473444407846, 218, 45, 'PPL', 'P'),
(84587, 'Addison', 35.3783302307129, 0.617468346383785, -84.5213928222656, -1.47517659312004, 218, 50, 'PPL', 'P'),
(92115, 'Addison', 32.961669921875, 0.575289667092301, -96.8288879394531, -1.68998290558808, 218, 51, 'PPL', 'P'),
(99300, 'Addison', 37.1974983215332, 0.649218819215819, -77.5027770996094, -1.35267863982744, 218, 53, 'PPL', 'P'),
(112690, 'Addison', 34.202220916748, 0.596941366491727, -87.1813888549805, -1.5216022819809, 218, 2, 'PPL', 'P'),
(118567, 'Addison', 41.9316711425781, 0.731845722301481, -87.9888916015625, -1.53569586362765, 218, 18, 'PPL', 'P'),
(126735, 'Addison', 44.6183280944824, 0.778736731983806, -67.7447204589844, -1.18236842285244, 218, 26, 'PPL', 'P'),
(129425, 'Addison', 41.9863891601563, 0.732800731868383, -84.3472213745117, -1.47213672789377, 218, 27, 'PPL', 'P'),
(146711, 'Addison', 42.1027793884277, 0.734832124568868, -77.23388671875, -1.34798561735451, 218, 40, 'PPL', 'P'),
(171672, 'Addison', 44.0886116027832, 0.769491435101541, -73.3030624389648, -1.27937979135492, 218, 55, 'PPL', 'P'),
(172844, 'Addison', 43.422779083252, 0.757870465368871, -88.3744430541992, -1.54242500591201, 218, 57, 'PPL', 'P'),
(177433, 'Addison', 41.7183303833008, 0.728122223623387, -72.5772171020508, -1.26671140036552, 218, 8, 'PPL', 'P'),
(18742, 'Addison Heights', 34.0327796936035, 0.593984059259248, -84.5341720581055, -1.47539963286133, 218, 13, 'PPL', 'P'),
(99301, 'Addison Heights', 38.8555603027344, 0.67815745998992, -77.0605621337891, -1.34496053267229, 218, 53, 'PPL', 'P'),
(129426, 'Addison Junction', 41.9936103820801, 0.732926765966971, -84.3255615234375, -1.47175869217703, 218, 27, 'PPL', 'P'),
(62442, 'Addor', 35.0777816772461, 0.612222784563683, -79.4622192382813, -1.38687735664959, 218, 33, 'PPL', 'P'),
(92116, 'Addran', 33.2941703796387, 0.581092894844665, -95.602783203125, -1.66858334096486, 218, 51, 'PPL', 'P'),
(206641, 'Addy', 48.3561096191406, 0.843973326309305, -117.836387634277, -2.05663294287447, 218, 56, 'PPL', 'P'),
(71628, 'Addyston', 39.1366691589355, 0.683063735087145, -84.7091674804688, -1.47845387915749, 218, 41, 'PPL', 'P'),
(122113, 'Ade', 40.8683280944824, 0.713286885034018, -87.4447174072266, -1.5261982322321, 218, 19, 'PPL', 'P'),
(18743, 'Adel', 31.1369400024414, 0.543442122038534, -83.4236068725586, -1.45601661381552, 218, 13, 'PPL', 'P'),
(29071, 'Adel', 39.1919403076172, 0.684028398612999, -86.7958297729492, -1.51487300653849, 218, 19, 'PPL', 'P'),
(74939, 'Adel', 34.5791702270508, 0.603520373069631, -95.5941696166992, -1.66843300552133, 218, 42, 'PPL', 'P'),
(92117, 'Adel', 29.3494396209717, 0.512244355001232, -97.1727828979492, -1.69598500489485, 218, 51, 'PPL', 'P'),
(114352, 'Adel', 41.6144409179688, 0.726309010395206, -94.017219543457, -1.64091003460369, 218, 16, 'PPL', 'P'),
(139000, 'Adel', 40.5313911437988, 0.70740622587296, -93.6688919067383, -1.63483057046725, 218, 29, 'PPL', 'P'),
(195839, 'Adel', 47.0277786254883, 0.820789576913784, -111.623062133789, -1.94818995539283, 218, 31, 'PPL', 'P'),
(200294, 'Adel', 42.1775016784668, 0.73613627455468, -119.897499084473, -2.09260612393093, 218, 43, 'PPL', 'P'),
(179614, 'Adela', 37.7886085510254, 0.659535638962677, -120.86222076416, -2.10944369360685, 218, 6, 'PPL', 'P'),
(179612, 'Adelaida', 35.6455612182617, 0.622132406979868, -120.872497558594, -2.10962305750627, 218, 6, 'PPL', 'P'),
(18744, 'Adelaide', 31.2666702270508, 0.545706341597319, -84.1486129760742, -1.46867035741892, 218, 13, 'PPL', 'P'),
(158553, 'Adelaide', 40.0433311462402, 0.698887971968287, -79.6241683959961, -1.38970390267254, 218, 45, 'PPL', 'P'),
(186315, 'Adelaide', 39.2472190856934, 0.684993195296908, -106.257499694824, -1.85454322461155, 218, 7, 'PPL', 'P'),
(194496, 'Adelaide', 42.8072204589844, 0.747126940636356, -113.72110748291, -1.98480775459114, 218, 17, 'PPL', 'P'),
(206643, 'Adelaide', 47.6500015258789, 0.831649415206909, -122.087501525879, -2.13082887716019, 218, 56, 'PPL', 'P'),
(7027, 'Adelaide (historical)', 35.4952812194824, 0.619509526201276, -91.5299987792969, -1.59749984304512, 218, 4, 'PPL', 'P'),
(199801, 'Adelaide (historical)', 40.8166694641113, 0.712385271846972, -117.524719238281, -2.05119330318993, 218, 39, 'PPL', 'P'),
(179613, 'Adelanto', 34.5827789306641, 0.603583356829412, -117.408332824707, -2.04916197706847, 218, 6, 'PPL', 'P'),
(53126, 'Adelbert (historical)', 37.9708290100098, 0.662715985936449, -90.7099990844727, -1.58318814850509, 218, 29, 'PPL', 'P'),
(34509, 'Adele', 37.7572212219238, 0.658987826726447, -83.3011093139648, -1.4538786280924, 218, 21, 'PPL', 'P'),
(77767, 'Adele', 39.9772186279297, 0.697734090846983, -75.3338928222656, -1.31482446809306, 218, 45, 'PPL', 'P'),
(112565, 'Adelia (historical)', 33.9111099243164, 0.591860521185046, -85.7777786254883, -1.49710466206159, 218, 2, 'PPL', 'P'),
(44286, 'Adelina', 38.4805603027344, 0.671612475294941, -76.6216735839844, -1.33730048242889, 218, 25, 'PPL', 'P'),
(39050, 'Adeline', 29.8727798461914, 0.521378365039445, -91.5908279418945, -1.59856151221368, 218, 22, 'PPL', 'P'),
(118569, 'Adeline', 42.1433296203613, 0.735539859628557, -89.4902801513672, -1.56190003717349, 218, 18, 'PPL', 'P'),
(187987, 'Adelino', 34.7158317565918, 0.605905566720934, -106.730560302734, -1.86279968978107, 218, 38, 'PPL', 'P'),
(92118, 'Adell', 32.8844413757324, 0.573941774685584, -97.9219436645508, -1.70906032689881, 218, 51, 'PPL', 'P'),
(172845, 'Adell', 43.6191711425781, 0.761298153428885, -87.9519424438477, -1.53505097916969, 218, 57, 'PPL', 'P'),
(172847, 'Adella Beach', 44.142219543457, 0.770427070171513, -88.461669921875, -1.54394740194915, 218, 57, 'PPL', 'P'),
(58420, 'Adelle', 32.5055618286133, 0.567329079119891, -90.4055633544922, -1.57787474265622, 218, 30, 'PPL', 'P'),
(206644, 'Adelma Beach', 48.0494384765625, 0.838620905150464, -122.827781677246, -2.14374920318871, 218, 56, 'PPL', 'P'),
(44287, 'Adelphi', 39.003059387207, 0.680731804657645, -76.9722213745117, -1.34341869555918, 218, 25, 'PPL', 'P'),
(71629, 'Adelphi', 39.4666709899902, 0.68882335357666, -82.7472229003906, -1.44421148649347, 218, 41, 'PPL', 'P'),
(114354, 'Adelphi', 41.5333290100098, 0.724893340538747, -93.4261093139648, -1.63059321485683, 218, 16, 'PPL', 'P'),
(44288, 'Adelphi Park', 38.9863891601563, 0.680440854308554, -76.9683303833008, -1.34335078495139, 218, 25, 'PPL', 'P'),
(144717, 'Adelphia', 40.2180595397949, 0.701937557732537, -74.2566680908203, -1.29602334974543, 218, 37, 'PPL', 'P'),
(26330, 'Aden', 38.2416687011719, 0.667443030292313, -88.4583282470703, -1.54388907872128, 218, 18, 'PPL', 'P'),
(34508, 'Aden', 38.2794418334961, 0.668102295820162, -83.0472183227539, -1.44944739435462, 218, 21, 'PPL', 'P'),
(99302, 'Aden', 38.6549987792969, 0.674657001053119, -77.5374984741211, -1.35328464213349, 218, 53, 'PPL', 'P'),
(112687, 'Aden', 33.1586112976074, 0.578726942532239, -86.9966735839844, -1.5183783923233, 218, 2, 'PPL', 'P'),
(146714, 'Aden', 41.8605613708496, 0.730604622654477, -74.6736068725586, -1.30330030426601, 218, 40, 'PPL', 'P'),
(187988, 'Aden', 32.1527786254883, 0.561171850679627, -107.126937866211, -1.86971778334477, 218, 38, 'PPL', 'P'),
(154022, 'Adena', 40.2186088562012, 0.701947145112461, -80.8730621337891, -1.41150121040457, 218, 41, 'PPL', 'P'),
(194079, 'Adena', 40.0083312988281, 0.69827710939325, -103.886108398438, -1.81315463863647, 218, 7, 'PPL', 'P'),
(26331, 'Adenmoor', 39.3658294677734, 0.687063336991254, -87.7966690063477, -1.53234094644442, 218, 18, 'PPL', 'P'),
(187989, 'Adero Az', 35.3536109924316, 0.617036914287192, -104.458610534668, -1.82314668588839, 218, 38, 'PPL', 'P'),
(18745, 'Adgateville', 33.2230606079102, 0.579851795197661, -83.6711120605469, -1.46033639426168, 218, 13, 'PPL', 'P'),
(79493, 'Adger', 34.4363899230957, 0.601028386658617, -81.1258316040039, -1.41591286990834, 218, 48, 'PPL', 'P'),
(112554, 'Adger', 33.3769416809082, 0.582537526577979, -87.0936126708984, -1.52007029856383, 218, 2, 'PPL', 'P'),
(99303, 'Adial', 37.8647193908691, 0.660864023714408, -78.8305587768555, -1.37585280184304, 218, 53, 'PPL', 'P'),
(44289, 'Adil Meadows', 39.2938919067383, 0.685807789695336, -76.7555618286133, -1.33963727312738, 218, 25, 'PPL', 'P'),
(193336, 'Adin', 41.1938896179199, 0.718969005535812, -120.94416809082, -2.11087394427028, 218, 6, 'PPL', 'P'),
(92119, 'Adina', 30.4213905334473, 0.530953427843689, -97.1722183227539, -1.69597515119882, 218, 51, 'PPL', 'P'),
(146716, 'Adirondack', 43.7638893127441, 0.763823961985744, -73.7588882446289, -1.28733545247932, 218, 40, 'PPL', 'P'),
(189855, 'Adits Mill (historical)', 39.2275009155273, 0.684649048305042, -117.135559082031, -2.04440117714579, 218, 39, 'PPL', 'P'),
(112692, 'Adkin Hill', 32.6088905334473, 0.569132505231065, -86.3111114501953, -1.50641307586169, 218, 2, 'PPL', 'P'),
(92120, 'Adkins', 29.3927803039551, 0.513000792619356, -98.2369384765625, -1.71455802349512, 218, 51, 'PPL', 'P'),
(206645, 'Adkins', 46.252498626709, 0.807258388310227, -118.70361328125, -2.07176888577188, 218, 56, 'PPL', 'P'),
(92121, 'Adkins Colonia', 26.19700050354, 0.457223912933386, -98.120002746582, -1.71251710999374, 218, 51, 'PPL', 'P'),
(84588, 'Adkins Mill', 36.1816711425781, 0.631489290311807, -84.8619384765625, -1.48112023604088, 218, 50, 'PPL', 'P'),
(107920, 'Adlai', 39.3377799987793, 0.68657378140387, -81.0633316040039, -1.41482203912584, 218, 58, 'PPL', 'P'),
(112691, 'Adler', 32.7630615234375, 0.571823296617454, -87.168327331543, -1.52137431539159, 218, 2, 'PPL', 'P'),
(62444, 'Adley', 36.1336097717285, 0.630650461147459, -81.2125015258789, -1.41742554540751, 218, 33, 'PPL', 'P'),
(107916, 'Adma (historical)', 39.0758285522461, 0.682001866181503, -80.0380630493164, -1.39692772712938, 218, 58, 'PPL', 'P'),
(141134, 'Admah (historical)', 41.6694412231445, 0.727268946810125, -96.3958282470703, -1.68242458809833, 218, 35, 'PPL', 'P'),
(92122, 'Admiral', 32.2963905334473, 0.563678351318583, -99.2975006103516, -1.73306832465171, 218, 51, 'PPL', 'P'),
(44298, 'Admiral (historical)', 39.0900001525879, 0.682249207267745, -76.7347183227539, -1.33927348532248, 218, 25, 'PPL', 'P'),
(107917, 'Admiral (historical)', 39.2830581665039, 0.68561870525794, -81.0250015258789, -1.41415305306002, 218, 58, 'PPL', 'P'),
(44290, 'Admiral Heights', 38.9847183227539, 0.680411692694617, -76.5188903808594, -1.33550657711861, 218, 25, 'PPL', 'P'),
(192986, 'Admiral Trailer Park', 33.4508285522461, 0.583827095756822, -111.991668701172, -1.95462335363813, 218, 5, 'PPL', 'P'),
(124093, 'Admirals Hill', 42.3899993896484, 0.739845059267752, -71.0480575561523, -1.24002253150129, 218, 23, 'PPL', 'P'),
(44291, 'Admirals Walk', 39.0344390869141, 0.681279483735819, -76.4475021362305, -1.33426061720262, 218, 25, 'PPL', 'P'),
(126737, 'Admiralty Village', 43.0924987792969, 0.752105986610368, -70.7302780151367, -1.2344762322151, 218, 26, 'PPL', 'P'),
(31600, 'Admire', 38.6411094665527, 0.674414586814895, -96.102783203125, -1.67730998722483, 218, 20, 'PPL', 'P'),
(77768, 'Admire', 39.9619407653809, 0.697467441842839, -76.8708267211914, -1.34164902501483, 218, 45, 'PPL', 'P'),
(193242, 'Adna', 46.6291694641113, 0.813832534619143, -123.059997558594, -2.14780213489364, 218, 56, 'PPL', 'P'),
(194080, 'Adna', 40.3394393920898, 0.704056035800668, -104.827781677246, -1.82958993782973, 218, 7, 'PPL', 'P'),
(39040, 'Adner', 32.5669403076172, 0.568400335668375, -93.607780456543, -1.63376397445068, 218, 22, 'PPL', 'P'),
(99304, 'Adner', 37.4986114501953, 0.654474234731954, -76.6336135864258, -1.33750887478419, 218, 53, 'PPL', 'P'),
(192985, 'Adobe', 33.6891708374023, 0.587986953379526, -112.121940612793, -1.95689702741879, 218, 5, 'PPL', 'P'),
(191038, 'Adobe Colonia', 31.6509990692139, 0.552414145303443, -106.302001953125, -1.85531993554347, 218, 51, 'PPL', 'P'),
(179615, 'Adobe Corner', 37.4261093139648, 0.653208833740003, -122.265281677246, -2.13393172614624, 218, 6, 'PPL', 'P'),
(191039, 'Adobe Crossing', 31.0527801513672, 0.541973255539301, -102.306938171387, -1.78559291872497, 218, 51, 'PPL', 'P'),
(192988, 'Adobe Mountain Trailer Park', 33.6861114501953, 0.58793355699967, -112.114440917969, -1.95676613305121, 218, 5, 'PPL', 'P'),
(187990, 'Adobe Ranch', 33.8622207641602, 0.591007244371785, -106.304443359375, -1.85536254612092, 218, 38, 'PPL', 'P'),
(191040, 'Adobes', 29.7590408325195, 0.5193932447629, -104.553131103516, -1.82479638102564, 218, 51, 'PPL', 'P'),
(39041, 'Adois (historical)', 31.6944408416748, 0.553172347265788, -93.3180618286133, -1.62870743048894, 218, 22, 'PPL', 'P'),
(107918, 'Adolph', 38.7444381713867, 0.676218012926069, -80.0458297729492, -1.39706328202887, 218, 58, 'PPL', 'P'),
(133854, 'Adolph', 46.7786102294922, 0.816440768011739, -92.2799987792969, -1.61058981243508, 218, 28, 'PPL', 'P'),
(34510, 'Adolphus', 36.651668548584, 0.639692292522442, -86.2613906860352, -1.50554528482048, 218, 21, 'PPL', 'P'),
(84589, 'Adolphus', 35.7411117553711, 0.623800078454476, -84.4255599975586, -1.47350399479741, 218, 50, 'PPL', 'P'),
(209252, 'Adon', 44.5183296203613, 0.776991429363422, -105.232498168945, -1.836653573147, 218, 59, 'PPL', 'P'),
(7028, 'Adona', 35.0380592346191, 0.611529497152908, -92.8977813720703, -1.62137215274048, 218, 4, 'PPL', 'P'),
(107919, 'Adonijah', 38.3338890075684, 0.669052578276129, -81.1947174072266, -1.41711515398246, 218, 58, 'PPL', 'P'),
(53127, 'Adonis', 37.7963905334473, 0.659671460178271, -93.3630599975586, -1.62949279669441, 218, 29, 'PPL', 'P'),
(107929, 'Adonis', 39.5055618286133, 0.689502126759494, -80.9869384765625, -1.4134887275261, 218, 58, 'PPL', 'P'),
(99305, 'Adria', 37.1686096191406, 0.64871461624244, -81.5461120605469, -1.4232481476568, 218, 53, 'PPL', 'P'),
(18746, 'Adrian', 32.5305595397949, 0.567765371485473, -82.5894393920898, -1.44145764476827, 218, 13, 'PPL', 'P'),
(53128, 'Adrian', 38.3974990844727, 0.670162783555556, -94.3513870239258, -1.64674235739096, 218, 29, 'PPL', 'P'),
(79492, 'Adrian', 33.9466705322266, 0.592481170877089, -79.0177764892578, -1.37912036734251, 218, 48, 'PPL', 'P'),
(107921, 'Adrian', 38.9052810668945, 0.679025251031122, -80.2758331298828, -1.401077597898, 218, 58, 'PPL', 'P'),
(118570, 'Adrian', 40.5208282470703, 0.707221868546499, -91.1669387817383, -1.59116325070544, 218, 18, 'PPL', 'P'),
(129428, 'Adrian', 41.8974990844727, 0.731249307375358, -84.0372161865234, -1.46672611666511, 218, 27, 'PPL', 'P'),
(133855, 'Adrian', 43.6349983215332, 0.761574389812954, -95.932502746582, -1.67433803260636, 218, 28, 'PPL', 'P'),
(139565, 'Adrian', 46.5999984741211, 0.813323404797747, -98.5530624389648, -1.72007542748349, 218, 34, 'PPL', 'P'),
(146715, 'Adrian', 42.2544403076172, 0.737479106955326, -77.521110534668, -1.35299861863242, 218, 40, 'PPL', 'P'),
(154023, 'Adrian', 41.0013885498047, 0.715609228083595, -83.3230590820313, -1.45426172381521, 218, 41, 'PPL', 'P'),
(158554, 'Adrian', 40.8847198486328, 0.71357297511412, -79.5380630493164, -1.38820108086941, 218, 45, 'PPL', 'P'),
(191041, 'Adrian', 35.2747192382813, 0.615659993424594, -102.66471862793, -1.79183736569093, 218, 51, 'PPL', 'P'),
(200295, 'Adrian', 43.7408294677734, 0.763421491766005, -117.070831298828, -2.04327146421138, 218, 43, 'PPL', 'P'),
(206646, 'Adrian', 47.3911094665527, 0.827130896364399, -119.916389465332, -2.09293582327389, 218, 56, 'PPL', 'P'),
(158555, 'Adrian Furnace', 41.1319389343262, 0.717887762133239, -78.7838897705078, -1.37503827402364, 218, 45, 'PPL', 'P'),
(158556, 'Adrian Mines', 40.9847183227539, 0.715318277734504, -78.960563659668, -1.37812181509179, 218, 45, 'PPL', 'P'),
(99306, 'Adsit', 36.827220916748, 0.642756259356578, -77.6983337402344, -1.35609174708049, 218, 53, 'PPL', 'P'),
(92123, 'Adsul', 30.6427803039551, 0.534817408269285, -93.8427810668945, -1.63786550884551, 218, 51, 'PPL', 'P'),
(7029, 'Advance', 36.1552810668945, 0.631028696601278, -92.3822174072266, -1.61237386404932, 218, 4, 'PPL', 'P'),
(26333, 'Advance', 39.1566696166992, 0.683412808927027, -88.0288925170898, -1.53639401130742, 218, 18, 'PPL', 'P'),
(29072, 'Advance', 39.9958305358887, 0.698058929920945, -86.620002746582, -1.51180424601439, 218, 19, 'PPL', 'P'),
(53129, 'Advance', 37.1044387817383, 0.647594623846007, -89.9105606079102, -1.56923531492195, 218, 29, 'PPL', 'P'),
(62448, 'Advance', 35.9411087036133, 0.627290683695243, -80.4094390869141, -1.40340946174847, 218, 33, 'PPL', 'P'),
(92124, 'Advance', 32.9411087036133, 0.574930806135413, -97.9269409179688, -1.70914754542451, 218, 51, 'PPL', 'P'),
(129431, 'Advance', 45.2213897705078, 0.789262143823044, -85.0774993896484, -1.48488248371283, 218, 27, 'PPL', 'P'),
(154024, 'Advance', 41.6405601501465, 0.726764876994801, -84.1127777099609, -1.46804491403691, 218, 41, 'PPL', 'P'),
(158559, 'Advance', 40.708610534668, 0.710499287742005, -79.2622222900391, -1.38338675140882, 218, 45, 'PPL', 'P'),
(172849, 'Advance', 44.7877807617188, 0.781694238953366, -88.3322219848633, -1.54168810923839, 218, 57, 'PPL', 'P'),
(179617, 'Advance', 36.5158309936523, 0.637321479941026, -118.901672363281, -2.07522566886681, 218, 6, 'PPL', 'P'),
(99307, 'Advance Mills', 38.1830596923828, 0.666420110117613, -78.4388885498047, -1.36901686679897, 218, 53, 'PPL', 'P'),
(99308, 'Advance Mills Village', 38.1972198486328, 0.666667251466773, -78.4250030517578, -1.36877451913977, 218, 53, 'PPL', 'P'),
(107922, 'Advent', 38.610279083252, 0.673876495116644, -81.5588912963867, -1.42347118739809, 218, 58, 'PPL', 'P'),
(62445, 'Advent Crossroads', 35.6691703796387, 0.622544464579531, -81.4261093139648, -1.42115370461751, 218, 33, 'PPL', 'P'),
(194497, 'Advent Hollow (historical)', 46.8375015258789, 0.817468615034455, -116.983329772949, -2.04174427448427, 218, 17, 'PPL', 'P'),
(14945, 'Adventura', 25.9650001525879, 0.453174742943489, -80.1430587768555, -1.39876024827547, 218, 12, 'PPL', 'P'),
(18747, 'Adventure (historical)', 33.3933296203613, 0.582823550079053, -82.019172668457, -1.43150461282632, 218, 13, 'PPL', 'P'),
(202821, 'Adventure Condominium', 40.6091690063477, 0.708763705659601, -111.794998168945, -1.95119080530913, 218, 52, 'PPL', 'P'),
(189856, 'Adverse', 39.3813896179199, 0.687334912843414, -114.774719238281, -2.00319674876009, 218, 39, 'PPL', 'P'),
(112693, 'Adville', 33.8838882446289, 0.591385413246576, -86.6447219848633, -1.51223567811098, 218, 2, 'PPL', 'P'),
(44292, 'Advocate Hill Farms', 39.5994415283203, 0.691140636620165, -76.4613876342773, -1.33450296486182, 218, 25, 'PPL', 'P'),
(44293, 'Advocates Choice', 39.6416702270508, 0.691877666451844, -76.9833297729492, -1.34361257368654, 218, 25, 'PPL', 'P'),
(99309, 'Adwolf', 36.7891693115234, 0.642092133559739, -81.5822219848633, -1.42387838472877, 218, 53, 'PPL', 'P'),
(44294, 'Ady', 39.6386108398438, 0.691824270071988, -76.3330612182617, -1.33226324638506, 218, 25, 'PPL', 'P'),
(191042, 'Ady', 35.4855613708496, 0.619339882839838, -102.131942749023, -1.78253867242881, 218, 51, 'PPL', 'P'),
(44295, 'Ady Estates', 39.667781829834, 0.692333399893384, -76.3541717529297, -1.33263169472187, 218, 25, 'PPL', 'P'),
(29073, 'Adyeville', 38.1908302307129, 0.666555731596126, -86.7694396972656, -1.51441241282796, 218, 19, 'PPL', 'P'),
(53130, 'Aeiker Ford', 38.3788909912109, 0.669838011060621, -91.0727767944336, -1.58951981399675, 218, 29, 'PPL', 'P'),
(206647, 'Aeneas', 48.5475006103516, 0.847313729264591, -118.977500915527, -2.07654912677052, 218, 56, 'PPL', 'P'),
(18748, 'Aerial', 34.6644401550293, 0.605008614065795, -83.6444396972656, -1.45987087370313, 218, 13, 'PPL', 'P'),
(179618, 'Aerial Acres', 35.0877799987793, 0.612397288194111, -117.791107177734, -2.05584264982099, 218, 6, 'PPL', 'P'),
(44296, 'Aero Acres', 39.332218170166, 0.686476709182136, -76.4533309936523, -1.33436234995626, 218, 25, 'PPL', 'P'),
(191043, 'Aero Vista', 31.8241691589355, 0.55543653353506, -106.388061523438, -1.85682195839828, 218, 51, 'PPL', 'P'),
(84591, 'Aethra', 35.5611114501953, 0.620658480474564, -87.3241729736328, -1.52409433497094, 218, 50, 'PPL', 'P'),
(7031, 'Aetna', 35.9363899230957, 0.627208325438532, -91.4400024414063, -1.59592911063419, 218, 4, 'PPL', 'P'),
(31602, 'Aetna', 37.0838890075684, 0.6472359626262, -98.9625015258789, -1.7272214876365, 218, 20, 'PPL', 'P'),
(84590, 'Aetna', 35.6549987792969, 0.622297123493289, -87.5047225952148, -1.52724552033078, 218, 50, 'PPL', 'P'),
(122114, 'Aetna', 41.5919418334961, 0.725916327292474, -87.289436340332, -1.52348806634878, 218, 19, 'PPL', 'P'),
(129432, 'Aetna', 43.5677795410156, 0.760401200773747, -85.9208297729492, -1.49960137558354, 218, 27, 'PPL', 'P'),
(179619, 'Aetna Springs', 38.6536102294922, 0.6746327662872, -122.481666564941, -2.13770835488808, 218, 6, 'PPL', 'P'),
(34511, 'Aetnaville', 37.672779083252, 0.657514033379198, -86.7905578613281, -1.51478099432282, 218, 21, 'PPL', 'P'),
(154025, 'Aetnaville', 40.0833282470703, 0.699586053069024, -80.7375030517578, -1.40913525809214, 218, 41, 'PPL', 'P'),
(39042, 'Afeman', 31.1025009155273, 0.542841046580503, -92.8183288574219, -1.61998544476088, 218, 22, 'PPL', 'P'),
(107923, 'Affinity', 37.7127799987793, 0.658212181058962, -81.2261123657227, -1.41766309937674, 218, 58, 'PPL', 'P'),
(53131, 'Affton', 38.5505599975586, 0.672834200445015, -90.3330612182617, -1.57660934166427, 218, 29, 'PPL', 'P'),
(34512, 'Aflex', 37.6580581665039, 0.657257104913032, -82.2474975585938, -1.43548963392346, 218, 21, 'PPL', 'P'),
(212252, 'Afognak', 58.0077781677246, 1.01242672079328, -152.76806640625, -2.6663057506944, 218, 1, 'PPL', 'P'),
(118572, 'Afolkey', 42.4324989318848, 0.740586816210366, -89.5744400024414, -1.56336890367272, 218, 18, 'PPL', 'P'),
(99310, 'Afredton', 37.1305618286133, 0.648050557024628, -81.783332824707, -1.42738843104549, 218, 53, 'PPL', 'P'),
(29074, 'Africa', 37.8402786254883, 0.660437451886805, -87.0727767944336, -1.51970664391698, 218, 19, 'PPL', 'P'),
(154026, 'Africa', 40.1822204589844, 0.701312047771504, -82.9572219848633, -1.44787666194369, 218, 41, 'PPL', 'P'),
(58421, 'Africa (historical)', 34.0638885498047, 0.594527011226488, -90.6513900756836, -1.58216522833039, 218, 30, 'PPL', 'P'),
(570, 'Afton', 32.2447204589844, 0.562776538394455, -91.1913909912109, -1.59159002227013, 218, 22, 'PPL', 'P'),
(800, 'Afton', 39.0613899230957, 0.681749864563355, -84.1002807617188, -1.46782680114364, 218, 41, 'PPL', 'P'),
(13262, 'Afton', 39.8269386291504, 0.695111210068391, -75.4811096191406, -1.31739388591277, 218, 10, 'PPL', 'P'),
(18749, 'Afton', 34.5002784729004, 0.602143452207033, -84.2455596923828, -1.4703623968175, 218, 13, 'PPL', 'P'),
(62446, 'Afton', 36.3386116027832, 0.634228418071981, -78.2163925170898, -1.36513357845547, 218, 33, 'PPL', 'P'),
(74940, 'Afton', 36.6936111450195, 0.640424328927077, -94.9627838134766, -1.65741324440474, 218, 42, 'PPL', 'P'),
(84592, 'Afton', 36.1938896179199, 0.631702542936095, -82.7388916015625, -1.44406607789795, 218, 50, 'PPL', 'P'),
(99312, 'Afton', 38.0322189331055, 0.663787442222015, -78.8394393920898, -1.37600779781848, 218, 53, 'PPL', 'P'),
(107924, 'Afton', 39.535831451416, 0.690030431340738, -79.5388870239258, -1.3882154619393, 218, 58, 'PPL', 'P'),
(114355, 'Afton', 41.0275001525879, 0.716064961525135, -94.1977767944336, -1.64406135312158, 218, 16, 'PPL', 'P'),
(129434, 'Afton', 45.3738899230957, 0.791923773595497, -84.4966735839844, -1.47474516102344, 218, 27, 'PPL', 'P'),
(133859, 'Afton', 44.9027786254883, 0.783701330308904, -92.783332824707, -1.61937464876487, 218, 28, 'PPL', 'P'),
(144718, 'Afton', 40.7724990844727, 0.711614353290421, -74.3899993896484, -1.29835041990594, 218, 37, 'PPL', 'P'),
(146717, 'Afton', 42.2280616760254, 0.737018712981878, -75.5269393920898, -1.31819376634617, 218, 40, 'PPL', 'P'),
(172850, 'Afton', 42.603889465332, 0.74357814532577, -89.0711135864258, -1.55458420050098, 218, 57, 'PPL', 'P'),
(179621, 'Afton', 35.0363883972168, 0.611500335538972, -116.378890991211, -2.0311948276162, 218, 6, 'PPL', 'P'),
(187991, 'Afton', 32.0727806091309, 0.559775621899126, -106.94361114502, -1.86651812845309, 218, 38, 'PPL', 'P'),
(191044, 'Afton', 33.7627792358398, 0.58927166228938, -100.816390991211, -1.75957796277458, 218, 51, 'PPL', 'P'),
(209253, 'Afton', 42.7249984741211, 0.745691896282966, -110.931106567383, -1.93611305248154, 218, 59, 'PPL', 'P'),
(199802, 'Afton (historical)', 41.4777793884277, 0.723923816743904, -115.113891601563, -2.00911642323111, 218, 39, 'PPL', 'P'),
(118573, 'Afton Center', 41.8491706848145, 0.730405817679102, -88.7736129760742, -1.54939183532366, 218, 18, 'PPL', 'P'),
(114356, 'Afton Junction (historical)', 41.0166702270508, 0.715875943666766, -94.1233291625977, -1.64276199682573, 218, 16, 'PPL', 'P'),
(126738, 'Agamenticus Station', 43.2438888549805, 0.75474824188589, -70.7755584716797, -1.23526652526858, 218, 26, 'PPL', 'P'),
(126739, 'Agamenticus Village', 43.2152786254883, 0.7542488991815, -70.6705627441406, -1.23343400412249, 218, 26, 'PPL', 'P'),
(201849, 'Agar', 44.8383293151855, 0.782576477643482, -100.074172973633, -1.74662381460022, 218, 49, 'PPL', 'P'),
(129435, 'Agate', 46.4741706848145, 0.81112729558384, -89.0699996948242, -1.55456475942503, 218, 27, 'PPL', 'P'),
(139568, 'Agate', 48.6227798461914, 0.848627599788382, -99.4927825927734, -1.7364766382148, 218, 34, 'PPL', 'P'),
(186316, 'Agate', 39.461669921875, 0.688736068471932, -103.941673278809, -1.81412442874742, 218, 7, 'PPL', 'P'),
(192464, 'Agate', 39.0149993896484, 0.680940197012943, -109.243057250977, -1.90665103397421, 218, 52, 'PPL', 'P'),
(199135, 'Agate', 42.4199981689453, 0.740368636738062, -103.793327331543, -1.81153530353565, 218, 35, 'PPL', 'P'),
(206648, 'Agate', 47.2136116027832, 0.824032974226364, -123.011108398438, -2.14694885808038, 218, 56, 'PPL', 'P'),
(206649, 'Agate Bay', 48.7561111450195, 0.850954669948893, -122.35417175293, -2.13548315063926, 218, 56, 'PPL', 'P'),
(200296, 'Agate Beach', 44.6775016784668, 0.779769505854539, -124.060562133789, -2.16526528110962, 218, 43, 'PPL', 'P'),
(206650, 'Agate Point', 47.714168548584, 0.832769341024315, -122.551940917969, -2.13893487372812, 218, 56, 'PPL', 'P'),
(194498, 'Agatha', 46.5108299255371, 0.811767120035732, -116.575828552246, -2.03463203647711, 218, 17, 'PPL', 'P'),
(34513, 'Agawam', 37.9144401550293, 0.66173181475561, -84.0880584716797, -1.46761348194032, 218, 21, 'PPL', 'P'),
(74942, 'Agawam', 34.8733291625977, 0.608654415019086, -97.9458312988281, -1.70947724476746, 218, 42, 'PPL', 'P'),
(124094, 'Agawam', 42.0694389343262, 0.734250223870686, -72.6152801513672, -1.26737572589944, 218, 23, 'PPL', 'P'),
(195840, 'Agawam', 48, 0.837758040957278, -112.16667175293, -1.95767773309234, 218, 31, 'PPL', 'P'),
(84594, 'Agee', 36.2999992370605, 0.633554505158136, -84.033332824707, -1.46665833921536, 218, 50, 'PPL', 'P'),
(84593, 'Agee (historical)', 36.2986106872559, 0.633530270392216, -84.0236129760742, -1.46648869585393, 218, 50, 'PPL', 'P'),
(53132, 'Agency', 39.644718170166, 0.691930863094619, -94.7397232055664, -1.65352010236521, 218, 29, 'PPL', 'P'),
(114359, 'Agency', 40.9949989318848, 0.715497708212948, -92.3066711425781, -1.61105533299362, 218, 16, 'PPL', 'P'),
(195841, 'Agency', 47.3280601501465, 0.826030478201978, -114.292503356934, -1.99478049392516, 218, 31, 'PPL', 'P'),
(31605, 'Agenda', 39.7077789306641, 0.693031480994121, -97.4313888549805, -1.70049853031032, 218, 20, 'PPL', 'P'),
(193337, 'Ager', 41.8663902282715, 0.730706355408118, -122.459442138672, -2.13732046547531, 218, 6, 'PPL', 'P'),
(34514, 'Ages', 36.857780456543, 0.643289623943894, -83.2463912963867, -1.4529236185255, 218, 21, 'PPL', 'P'),
(141135, 'Aggies Acres', 41.8672218322754, 0.730720869636059, -99.267219543457, -1.73253982033339, 218, 35, 'PPL', 'P'),
(107925, 'Aggregates', 38.9361114501953, 0.679563342729372, -79.9188919067383, -1.39484779831803, 218, 58, 'PPL', 'P'),
(44297, 'Agner', 38.7555618286133, 0.676412157369536, -75.7897186279297, -1.32278012921745, 218, 25, 'PPL', 'P'),
(34515, 'Agnes', 37.0483283996582, 0.646615312934157, -87.0202789306641, -1.51879038334394, 218, 21, 'PPL', 'P'),
(53134, 'Agnes', 37.5122184753418, 0.654711722122162, -92.4983291625977, -1.61440039648082, 218, 29, 'PPL', 'P'),
(92125, 'Agnes', 32.9791717529297, 0.575595131669333, -97.788330078125, -1.70672832989029, 218, 51, 'PPL', 'P'),
(18750, 'Agnes (historical)', 33.7458305358887, 0.5889758516713, -82.4286117553711, -1.43865067297933, 218, 13, 'PPL', 'P'),
(146719, 'Agnes Corners', 43.1758308410645, 0.753560405460687, -75.6066665649414, -1.31958526801574, 218, 40, 'PPL', 'P'),
(200297, 'Agness', 42.5566711425781, 0.742754030126445, -124.067779541016, -2.16539124862918, 218, 43, 'PPL', 'P'),
(107926, 'Agnew', 38.2125015258789, 0.666933967049944, -81.1430587768555, -1.41621354079541, 218, 58, 'PPL', 'P'),
(118575, 'Agnew', 41.7866706848145, 0.729314986896606, -89.8000030517578, -1.56730572155413, 218, 18, 'PPL', 'P'),
(129436, 'Agnew', 42.9650001525879, 0.749880715782525, -86.1766662597656, -1.50406656462522, 218, 27, 'PPL', 'P'),
(141136, 'Agnew', 41.0169410705566, 0.715880670777701, -96.8144378662109, -1.68973070423285, 218, 35, 'PPL', 'P'),
(179622, 'Agnew', 37.394718170166, 0.652660954924746, -121.958061218262, -2.12856971760747, 218, 6, 'PPL', 'P'),
(206651, 'Agnew', 48.1058311462402, 0.83960514291033, -123.247222900391, -2.15106983355117, 218, 56, 'PPL', 'P'),
(99314, 'Agnewville', 38.6691703796387, 0.67490434213936, -77.2861099243164, -1.34889708423759, 218, 53, 'PPL', 'P'),
(7033, 'Agnos', 36.2772216796875, 0.633156961786415, -91.6913909912109, -1.6003166685301, 218, 4, 'PPL', 'P'),
(179623, 'Agoura', 34.1430587768555, 0.595908792358076, -118.736938476563, -2.07235052015396, 218, 6, 'PPL', 'P'),
(179624, 'Agoura Hills', 34.1363906860352, 0.595792412218439, -118.773612976074, -2.07299061092196, 218, 6, 'PPL', 'P'),
(31607, 'Agra', 39.7616691589355, 0.69397204291211, -99.1188888549805, -1.72995096143772, 218, 20, 'PPL', 'P'),
(74944, 'Agra', 35.894718170166, 0.626481016144831, -96.871940612793, -1.69073431648965, 218, 42, 'PPL', 'P'),
(179625, 'Agra', 33.3333282470703, 0.581776328559407, -117.499168395996, -2.0507473568654, 218, 6, 'PPL', 'P'),
(84595, 'Agreeable (historical)', 36.1916694641113, 0.631663793942234, -83.6166687011719, -1.45938617838474, 218, 50, 'PPL', 'P'),
(14947, 'Agricola', 27.7875003814697, 0.484983372555827, -81.8916702270508, -1.42927927541945, 218, 12, 'PPL', 'P'),
(18751, 'Agricola', 33.1944389343262, 0.57935225275619, -82.7205581665039, -1.44374609909298, 218, 13, 'PPL', 'P'),
(31608, 'Agricola', 38.4194412231445, 0.67054574612031, -95.5347213745117, -1.66739543796063, 218, 20, 'PPL', 'P'),
(58422, 'Agricola', 30.8075008392334, 0.537692323955539, -88.5199966430664, -1.54496539527584, 218, 30, 'PPL', 'P'),
(99315, 'Agricola', 37.5311088562012, 0.655041421465113, -79.2441711425781, -1.38307169945187, 218, 53, 'PPL', 'P'),
(112695, 'Agricola', 32.7683296203613, 0.571915242254089, -85.7386093139648, -1.49642102860976, 218, 2, 'PPL', 'P'),
(114361, 'Agricola (historical)', 41.4991683959961, 0.724297125349706, -92.4749984741211, -1.61399319915015, 218, 16, 'PPL', 'P'),
(187992, 'Agua (historical)', 35.2452812194824, 0.61514620307129, -106.245002746582, -1.85432511171828, 218, 38, 'PPL', 'P'),
(179628, 'Agua Caliente', 38.3241691589355, 0.668882934914691, -122.486938476563, -2.13780036710374, 218, 6, 'PPL', 'P'),
(192989, 'Agua Caliente', 32.985279083252, 0.575701724691963, -113.323608398438, -1.97787008679343, 218, 5, 'PPL', 'P'),
(179629, 'Agua Dulce', 34.4963912963867, 0.602075608178263, -118.324722290039, -2.06515599046911, 218, 6, 'PPL', 'P'),
(191045, 'Agua Dulce', 31.6550006866455, 0.55248398670303, -106.138328552246, -1.8524632958002, 218, 51, 'PPL', 'P'),
(191046, 'Agua Dulce Colonia', 31.6609992980957, 0.552588682223384, -106.144996643066, -1.85257967593984, 218, 51, 'PPL', 'P'),
(191047, 'Agua Dulce Number 2 Colonia', 31.6569995880127, 0.55251887411331, -106.141998291016, -1.85252734482442, 218, 51, 'PPL', 'P'),
(191048, 'Agua Dulce Number 3 Colonia', 31.6620006561279, 0.552606159218037, -106.141998291016, -1.85252734482442, 218, 51, 'PPL', 'P'),
(191049, 'Agua Dulce Number 4 Colonia', 31.6660003662109, 0.552675967328111, -106.141998291016, -1.85252734482442, 218, 51, 'PPL', 'P'),
(191050, 'Agua Dulce Number 5 Colonia', 31.6609992980957, 0.552588682223384, -106.138999938965, -1.852475013709, 218, 51, 'PPL', 'P'),
(92128, 'Agua Dulce Ranch Number 1 Colonia', 27.9699993133545, 0.488168579798589, -98.0270004272461, -1.71089391330933, 218, 51, 'PPL', 'P'),
(92129, 'Agua Dulce Ranch Number 2 Colonia', 27.94700050354, 0.487767174843287, -98.0309982299805, -1.71096368812989, 218, 51, 'PPL', 'P'),
(92130, 'Agua Dulce Ranch Number 3 Colonia', 27.9599990844727, 0.487994042878648, -98.0299987792969, -1.71094624442475, 218, 51, 'PPL', 'P'),
(179631, 'Agua Fria', 34.2388916015625, 0.5975813906807, -117.217498779297, -2.04583129465116, 218, 6, 'PPL', 'P'),
(187994, 'Agua Fria', 36.4300003051758, 0.635823451827856, -105.298332214355, -1.83780259399931, 218, 38, 'PPL', 'P'),
(192990, 'Agua Fria', 33.6055603027344, 0.586527674260217, -112.313888549805, -1.96024715091205, 218, 5, 'PPL', 'P'),
(192991, 'Agua Linda', 31.6788902282715, 0.552900937861195, -111.061111450195, -1.93838206573028, 218, 5, 'PPL', 'P'),
(187995, 'Agua Negra (historical)', 34.8772201538086, 0.608722325626883, -104.693893432617, -1.82725314713124, 218, 38, 'PPL', 'P'),
(92131, 'Agua Nueva', 26.9013900756836, 0.469517830184005, -98.5999984741211, -1.7208946158348, 218, 51, 'PPL', 'P'),
(187998, 'Agua Zarca', 35.5633316040039, 0.620697229468424, -105.271392822266, -1.83733241290886, 218, 38, 'PPL', 'P'),
(179637, 'Aguanga', 33.4427795410156, 0.583686614009321, -116.864166259766, -2.03966447883098, 218, 6, 'PPL', 'P'),
(187999, 'Agudo', 34.4052810668945, 0.600485434691377, -104.303062438965, -1.82043185947316, 218, 38, 'PPL', 'P'),
(212253, 'Aguikchuk', 60.4749984741211, 1.05548783851196, -164.435562133789, -2.86994196660233, 218, 1, 'PPL', 'P'),
(192993, 'Aguila', 33.9427795410156, 0.592413260269292, -113.173332214355, -1.97524727259387, 218, 5, 'PPL', 'P'),
(186317, 'Aguilar', 37.4027786254883, 0.65280163640933, -104.652778625488, -1.82653555837552, 218, 7, 'PPL', 'P'),
(92132, 'Aguilares', 27.4483299255371, 0.479063731374313, -99.0869369506836, -1.72939329550546, 218, 51, 'PPL', 'P'),
(92133, 'Aguilares Acres Colonia', 27.4519996643066, 0.479127780398529, -99.0920028686523, -1.72948171245365, 218, 51, 'PPL', 'P'),
(211642, 'Ah Fong Village', 20.8533306121826, 0.363959279189511, -156.464721679688, -2.7308245565271, 218, 15, 'PPL', 'P'),
(133864, 'Ah-gwah-ching', 47.0741691589355, 0.821599244464195, -94.5625, -1.65042697391714, 218, 28, 'PPL', 'P'),
(18752, 'Ahaluna', 34.3125, 0.598866099590554, -83.8627777099609, -1.46368159090693, 218, 13, 'PPL', 'P'),
(193088, 'Ahan Owuch', 32.1425018310547, 0.56099248678021, -112.342781066895, -1.96075142046446, 218, 5, 'PPL', 'P'),
(118576, 'Ahern', 41.1541709899902, 0.718275784704064, -87.6047210693359, -1.52899082295116, 218, 18, 'PPL', 'P'),
(195842, 'Ahern Trailer Court', 46.7538909912109, 0.816009335915146, -114.086112976074, -1.99117830223472, 218, 31, 'PPL', 'P'),
(129437, 'Ahgosatown', 45.0811080932617, 0.78681376667488, -85.591667175293, -1.49385640448002, 218, 27, 'PPL', 'P'),
(195843, 'Ahles', 46.478889465332, 0.811209653840551, -107.163887023926, -1.87036266780273, 218, 31, 'PPL', 'P'),
(74945, 'Ahloso', 34.7350006103516, 0.606240126332875, -96.6372222900391, -1.68663770894284, 218, 42, 'PPL', 'P'),
(129438, 'Ahmeek', 47.2988891601563, 0.825521348380582, -88.3963928222656, -1.54280810163482, 218, 27, 'PPL', 'P'),
(169698, 'Ahnberg', 44.3041687011719, 0.773253616194469, -97.0566711425781, -1.69395847246336, 218, 49, 'PPL', 'P'),
(62447, 'Aho', 36.1591682434082, 0.631096540630048, -81.6166687011719, -1.42447959334485, 218, 33, 'PPL', 'P'),
(53135, 'Aholt', 39.2644386291504, 0.685293733025923, -92.9047164916992, -1.62149319341203, 218, 29, 'PPL', 'P'),
(62449, 'Ahoskie', 36.2866706848145, 0.633321878036918, -76.9850006103516, -1.34364173530048, 218, 33, 'PPL', 'P'),
(14948, 'Ahosulga (historical)', 30.4333305358887, 0.531161820198988, -83.6833267211914, -1.46054958030694, 218, 12, 'PPL', 'P'),
(99316, 'Ahoy Acres', 36.8008308410645, 0.642295665646049, -76.3974990844727, -1.3333878993134, 218, 53, 'PPL', 'P'),
(99317, 'Ahoy Shores', 36.7986106872559, 0.642256916652188, -76.3897171020508, -1.33325207809781, 218, 53, 'PPL', 'P'),
(158557, 'Ahrensville', 41.4544410705566, 0.723516486255176, -79.6458282470703, -1.39008193838928, 218, 45, 'PPL', 'P'),
(194499, 'Ahsahka', 46.5022201538086, 0.811616851171224, -116.323059082031, -2.03022037697334, 218, 17, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(206652, 'Ahtanum', 46.5597190856934, 0.812620396848993, -120.620826721191, -2.10523057276235, 218, 56, 'PPL', 'P'),
(179639, 'Ahwahnee', 37.3655586242676, 0.652152024840432, -119.725280761719, -2.08960034716662, 218, 6, 'PPL', 'P'),
(179640, 'Ahwahnee Estates', 37.3708305358887, 0.652244037056094, -119.702781677246, -2.08920766406388, 218, 6, 'PPL', 'P'),
(193089, 'Ahwatukee', 33.3416709899902, 0.581921936892007, -111.983329772949, -1.95447781188456, 218, 5, 'PPL', 'P'),
(179641, 'Ahwin (historical)', 34.4602813720703, 0.601445371106296, -120.023330688477, -2.09480229972387, 218, 6, 'PPL', 'P'),
(18753, 'Ai', 34.833610534668, 0.607961194187338, -84.4527816772461, -1.47397910273588, 218, 13, 'PPL', 'P'),
(62451, 'Ai', 36.3199996948242, 0.633903578998018, -78.9619369506836, -1.3781457835416, 218, 33, 'PPL', 'P'),
(112697, 'Ai', 33.6500015258789, 0.587303319927703, -85.4472198486328, -1.49133532303409, 218, 2, 'PPL', 'P'),
(154027, 'Ai', 41.628059387207, 0.726546697522496, -83.9352798461914, -1.46494699189888, 218, 41, 'PPL', 'P'),
(53147, 'Aid', 36.8769416809082, 0.64362405039778, -90.0411071777344, -1.57151378239256, 218, 29, 'PPL', 'P'),
(71630, 'Aid', 38.5961112976074, 0.673629220609431, -82.4933319091797, -1.43978025275569, 218, 41, 'PPL', 'P'),
(146720, 'Aiden Lair', 43.8716697692871, 0.765705085821721, -74.003059387207, -1.29159704285566, 218, 40, 'PPL', 'P'),
(58423, 'Aiken', 34.6308288574219, 0.604421986256678, -89.7397232055664, -1.56625363976549, 218, 30, 'PPL', 'P'),
(79494, 'Aiken', 33.5602798461914, 0.585737381206736, -81.7197189331055, -1.42627815918704, 218, 48, 'PPL', 'P'),
(118577, 'Aiken', 42.3525009155273, 0.739190587429865, -90.415283203125, -1.57804438601766, 218, 18, 'PPL', 'P'),
(158558, 'Aiken', 41.878059387207, 0.730910020652482, -78.5780563354492, -1.37144580287118, 218, 45, 'PPL', 'P'),
(177732, 'Aiken', 34.142219543457, 0.59589414497208, -101.525283813477, -1.77195047656687, 218, 51, 'PPL', 'P'),
(194500, 'Aiken', 43.209171295166, 0.75414230615887, -112.405830383301, -1.96185183862688, 218, 17, 'PPL', 'P'),
(99318, 'Aiken Summit', 36.5950012207031, 0.638703261072614, -79.7050018310547, -1.39111471226001, 218, 53, 'PPL', 'P'),
(18755, 'Aikenton', 33.3722190856934, 0.582455101742241, -83.5486068725586, -1.45819827538051, 218, 13, 'PPL', 'P'),
(44311, 'Aikin', 39.5738906860352, 0.690694690295631, -76.0680618286133, -1.32763813451992, 218, 25, 'PPL', 'P'),
(92135, 'Aikin Grove', 33.5555610656738, 0.585655022950025, -95.0483322143555, -1.6589063456699, 218, 51, 'PPL', 'P'),
(31609, 'Aikins', 39.3680610656738, 0.687102285722196, -96.1161117553711, -1.67754261434605, 218, 20, 'PPL', 'P'),
(53136, 'Aikinsville', 38.5580596923828, 0.672965094812592, -92.8361129760742, -1.62029583618593, 218, 29, 'PPL', 'P'),
(31610, 'Aikman', 37.9897193908691, 0.663045685279401, -96.6805572509766, -1.68739404669242, 218, 20, 'PPL', 'P'),
(194501, 'Aikman (historical)', 43.8166694641113, 0.764745149406802, -116.404167175293, -2.03163598025077, 218, 17, 'PPL', 'P'),
(18756, 'Ailey', 32.1872215270996, 0.561772992716685, -82.5658264160156, -1.44104552058958, 218, 13, 'PPL', 'P'),
(84596, 'Ailor (historical)', 36.2425003051758, 0.632550959480367, -83.7336120605469, -1.46142722504418, 218, 50, 'PPL', 'P'),
(179642, 'Ailsa (historical)', 34.0666694641113, 0.594575547337355, -117.434722900391, -2.049622570779, 218, 6, 'PPL', 'P'),
(77769, 'Ailston', 39.7441711425781, 0.693666644914105, -76.3158264160156, -1.33196244233994, 218, 45, 'PPL', 'P'),
(99319, 'Aily', 37.0869407653809, 0.647289225848002, -82.2855606079102, -1.43615395945738, 218, 53, 'PPL', 'P'),
(18757, 'Aimar', 31.7527809143066, 0.554190573619066, -81.6716690063477, -1.42543952975977, 218, 13, 'PPL', 'P'),
(92136, 'Aimee Acres Colonia', 27.9330005645752, 0.487522829813272, -98.0339965820313, -1.71101601924531, 218, 51, 'PPL', 'P'),
(92137, 'Aimee Acres Number 2 Colonia', 27.9370002746582, 0.487592637923346, -98.036003112793, -1.71105103981365, 218, 51, 'PPL', 'P'),
(200298, 'Aims', 45.4508285522461, 0.793266605996142, -122.206672668457, -2.13290880597154, 218, 43, 'PPL', 'P'),
(39044, 'Aimwell', 31.7833309173584, 0.554723771758814, -91.9933319091797, -1.60558653169515, 218, 22, 'PPL', 'P'),
(112698, 'Aimwell', 32.1213912963867, 0.560624038443398, -87.9061126708984, -1.53425109873628, 218, 2, 'PPL', 'P'),
(7034, 'Ain', 34.2083282470703, 0.597047959514357, -92.3375015258789, -1.61159342469188, 218, 4, 'PPL', 'P'),
(211650, 'Ainaloa', 19.5269393920898, 0.340809385229348, -154.993057250977, -2.70513916676161, 218, 15, 'PPL', 'P'),
(129440, 'Ainger', 42.482780456543, 0.741464394368575, -84.934440612793, -1.48238563703283, 218, 27, 'PPL', 'P'),
(154028, 'Ainger', 41.639720916748, 0.726750229608805, -84.6838912963867, -1.47801272652292, 218, 41, 'PPL', 'P'),
(13265, 'Ainsley Woods', 39.7625007629395, 0.693986557140051, -75.7083282470703, -1.321359599092, 218, 10, 'PPL', 'P'),
(18758, 'Ainslie (historical)', 32.4483299255371, 0.566330193974029, -83.4716720581055, -1.45685550955889, 218, 13, 'PPL', 'P'),
(92138, 'Ainsworth', 30.3138904571533, 0.529077197566215, -95.0305633544922, -1.65859622056096, 218, 51, 'PPL', 'P'),
(114362, 'Ainsworth', 41.288890838623, 0.720627089630495, -91.5522232055664, -1.59788773245789, 218, 16, 'PPL', 'P'),
(122116, 'Ainsworth', 41.4877815246582, 0.724098386953359, -87.2586135864258, -1.52295010780859, 218, 19, 'PPL', 'P'),
(141137, 'Ainsworth', 42.5499992370605, 0.742637583407782, -99.8622207641602, -1.74292455068804, 218, 35, 'PPL', 'P'),
(193338, 'Ainsworth Corner', 41.9986114501953, 0.733014051071699, -121.558609008789, -2.12159796134781, 218, 6, 'PPL', 'P'),
(206653, 'Ainsworth Junction', 46.2097206115723, 0.806511771098624, -119.036666870117, -2.0775817674832, 218, 56, 'PPL', 'P'),
(209254, 'Air Base Acres', 42.8822212219238, 0.748435950891157, -106.440559387207, -1.85773821897132, 218, 59, 'PPL', 'P'),
(188000, 'Air Base City', 32.769718170166, 0.571939477020008, -103.194717407227, -1.80108758942121, 218, 38, 'PPL', 'P'),
(79498, 'Air Base Heights', 34.1980590820313, 0.596868728772995, -79.7402801513672, -1.39173043510404, 218, 48, 'PPL', 'P'),
(177373, 'Air City', 43.2200012207031, 0.754331324017238, -75.4227828979492, -1.31637589258608, 218, 40, 'PPL', 'P'),
(53137, 'Air Line Junction', 39.121940612793, 0.682806673462925, -94.4974975585938, -1.64929246729276, 218, 29, 'PPL', 'P'),
(154029, 'Air Line Junction', 41.6386108398438, 0.726730855111875, -83.5824966430664, -1.45878976345862, 218, 41, 'PPL', 'P'),
(62452, 'Airboro', 35.3591690063477, 0.617133919929898, -77.9916687011719, -1.36121140796006, 218, 33, 'PPL', 'P'),
(192994, 'Aire Libre Mobile Home Park', 33.6377792358398, 0.587090000724387, -112.017219543457, -1.95506929996266, 218, 5, 'PPL', 'P'),
(34516, 'Airedale', 37.6025009155273, 0.656287447960134, -83.6394424438477, -1.45978365517743, 218, 21, 'PPL', 'P'),
(44299, 'Airedele', 38.1183280944824, 0.665290330604174, -76.3483276367188, -1.33252969565212, 218, 25, 'PPL', 'P'),
(44300, 'Airey', 38.5227813720703, 0.672349371968566, -75.9930572509766, -1.32632905768609, 218, 25, 'PPL', 'P'),
(58424, 'Airey', 30.6483306884766, 0.534914280753937, -89.0772171020508, -1.55469072694459, 218, 30, 'PPL', 'P'),
(71632, 'Airhill', 39.8194389343262, 0.694980315700814, -84.3672180175781, -1.47248573515462, 218, 41, 'PPL', 'P'),
(71633, 'Airington (historical)', 39.7333297729492, 0.693477427318655, -81.809440612793, -1.427844097908, 218, 41, 'PPL', 'P'),
(79499, 'Airlee', 34.7480583190918, 0.606468026343158, -81.1999969482422, -1.41720729935617, 218, 48, 'PPL', 'P'),
(99320, 'Airlee Court', 37.3183288574219, 0.651327709904025, -79.9541702270508, -1.39546352116206, 218, 53, 'PPL', 'P'),
(62454, 'Airlie', 34.2150001525879, 0.597164406233021, -77.8269424438477, -1.35833639240526, 218, 33, 'PPL', 'P'),
(99321, 'Airlie', 38.7569389343262, 0.676436192398374, -77.7919387817383, -1.3577254632512, 218, 53, 'PPL', 'P'),
(133866, 'Airlie', 44.0200004577637, 0.768293944717387, -96.4377822875977, -1.68315682424005, 218, 28, 'PPL', 'P'),
(200299, 'Airlie', 44.750560760498, 0.781044627384469, -123.330276489258, -2.1525193921325, 218, 43, 'PPL', 'P'),
(53138, 'Airline Acres', 36.8033294677734, 0.642339274908899, -89.3580627441406, -1.55959240808893, 218, 29, 'PPL', 'P'),
(39046, 'Airline Park Estates', 32.579719543457, 0.568623375409669, -93.7130584716797, -1.63560142244478, 218, 22, 'PPL', 'P'),
(99322, 'Airmont', 39.0847206115723, 0.682157061894028, -77.7872161865234, -1.35764303841546, 218, 53, 'PPL', 'P'),
(146721, 'Airmont', 41.100830078125, 0.717344810165999, -74.1166687011719, -1.29357989944528, 218, 40, 'PPL', 'P'),
(13264, 'Airmont Acres', 39.5311088562012, 0.689948006505, -75.6744384765625, -1.3207681110139, 218, 10, 'PPL', 'P'),
(99323, 'Airpoint', 37.1711082458496, 0.64875822550529, -80.1144409179688, -1.39826077241302, 218, 53, 'PPL', 'P'),
(44301, 'Airport Acres', 39.4638900756836, 0.688774817465793, -77.0158309936523, -1.34417982699873, 218, 25, 'PPL', 'P'),
(99324, 'Airport Acres', 38.1369400024414, 0.665615169678137, -78.4355621337891, -1.36895880988721, 218, 53, 'PPL', 'P'),
(191051, 'Airport Addition Colonia', 28.8610000610352, 0.503719476483348, -100.542999267578, -1.75480637704949, 218, 51, 'PPL', 'P'),
(44302, 'Airport Beach (historical)', 39.2633285522461, 0.685274358528993, -76.438606262207, -1.33410535491107, 218, 25, 'PPL', 'P'),
(92139, 'Airport City', 29.5327796936035, 0.515444242919504, -98.3011093139648, -1.71567801589155, 218, 51, 'PPL', 'P'),
(53139, 'Airport Drive', 37.1425018310547, 0.648258949379927, -94.5105590820313, -1.64952043388207, 218, 29, 'PPL', 'P'),
(34517, 'Airport Gardens', 37.2869415283203, 0.650779897667796, -83.2030563354492, -1.45216728077592, 218, 21, 'PPL', 'P'),
(18759, 'Airport Grove', 33.6469383239746, 0.587249856968819, -83.8450012207031, -1.46337133263993, 218, 13, 'PPL', 'P'),
(92140, 'Airport Heights Colonia', 26.4090003967285, 0.460924009083401, -98.8359985351563, -1.72501359393477, 218, 51, 'PPL', 'P'),
(112694, 'Airport Highlands', 33.5849990844727, 0.586168813303329, -86.7416687011719, -1.51392771750956, 218, 2, 'PPL', 'P'),
(84597, 'Airport Plaza', 35.8175010681152, 0.625133323475197, -83.9786071777344, -1.46570319649041, 218, 50, 'PPL', 'P'),
(209255, 'Airport Road', 43.9933280944824, 0.767828424158841, -107.948608398438, -1.88405863949874, 218, 59, 'PPL', 'P'),
(92141, 'Airport Road Addition', 27.2197208404541, 0.475073750139642, -98.0991668701172, -1.71215345534689, 218, 51, 'PPL', 'P'),
(92142, 'Airport Road Addition Colonia', 27.2140007019043, 0.474973914888278, -98.1119995117188, -1.71237742719456, 218, 51, 'PPL', 'P'),
(18760, 'Airport Subdivision', 31.5194396972656, 0.55011800110109, -84.2041702270508, -1.46964001437182, 218, 13, 'PPL', 'P'),
(7035, 'Airport Village', 35.6377792358398, 0.621996585764274, -91.1949996948242, -1.59165300602991, 218, 4, 'PPL', 'P'),
(107927, 'Airport Village', 38.3666687011719, 0.669624691857306, -81.5819396972656, -1.42387345788075, 218, 58, 'PPL', 'P'),
(126740, 'Airport Village', 43.4700012207031, 0.758694647147224, -70.4841690063477, -1.23018081969291, 218, 26, 'PPL', 'P'),
(211651, 'Airport Village', 20.8222198486328, 0.363416293932758, -156.454162597656, -2.73064026577967, 218, 15, 'PPL', 'P'),
(99326, 'Airview Court', 37.2486114501953, 0.650110911601968, -80.0258331298828, -1.39671427476801, 218, 53, 'PPL', 'P'),
(77770, 'Airville', 39.832218170166, 0.695203355442108, -76.4066696166992, -1.33354795529492, 218, 45, 'PPL', 'P'),
(92143, 'Airville', 31.076940536499, 0.542394933808401, -97.163330078125, -1.69582002206532, 218, 51, 'PPL', 'P'),
(206654, 'Airway Heights', 47.644718170166, 0.831557203254165, -117.592216491699, -2.05237135249813, 218, 56, 'PPL', 'P'),
(44303, 'Airy Estates', 39.4058303833008, 0.687761484671018, -77.1341705322266, -1.34624524158214, 218, 25, 'PPL', 'P'),
(158560, 'Airydale', 40.4844398498535, 0.706586771205543, -77.8677825927734, -1.35904918747102, 218, 45, 'PPL', 'P'),
(158561, 'Aitch', 40.3741683959961, 0.70466217126477, -78.1594390869141, -1.3641395535786, 218, 45, 'PPL', 'P'),
(133867, 'Aitkin', 46.5330581665039, 0.812155076027529, -93.7099990844727, -1.63554802606492, 218, 28, 'PPL', 'P'),
(122117, 'Aix', 41.041389465332, 0.716307375763359, -87.1513900756836, -1.52107870451059, 218, 19, 'PPL', 'P'),
(79500, 'Aix (historical)', 34.0791702270508, 0.59479372680966, -82.1708297729492, -1.43415152863375, 218, 48, 'PPL', 'P'),
(202826, 'Aix La Chapelle Condominium', 40.6666717529297, 0.709767317916397, -111.824996948242, -1.95171438277944, 218, 52, 'PPL', 'P'),
(39048, 'Ajax', 31.8763904571533, 0.556347967128626, -93.3897171020508, -1.62995805093684, 218, 22, 'PPL', 'P'),
(99327, 'Ajax', 36.9808311462402, 0.645437263625961, -79.5772171020508, -1.38888444800513, 218, 53, 'PPL', 'P'),
(107928, 'Ajax', 37.8025016784668, 0.659778119779928, -82.3047180175781, -1.43648831933224, 218, 58, 'PPL', 'P'),
(158562, 'Ajax', 41.3544387817383, 0.721771117055766, -79.7908325195313, -1.39261274037318, 218, 45, 'PPL', 'P'),
(201851, 'Ajax', 43.8974990844727, 0.766155892415244, -103.18138885498, -1.80085496229999, 218, 49, 'PPL', 'P'),
(206655, 'Ajlune', 46.5155601501465, 0.811849678029524, -122.433609008789, -2.13686959230276, 218, 56, 'PPL', 'P'),
(192995, 'Ajo', 32.3716697692871, 0.564992221842373, -112.860000610352, -1.96977860445344, 218, 5, 'PPL', 'P'),
(192997, 'Ak Chin', 33.0327796936035, 0.576530766739305, -112.07250213623, -1.9560341632256, 218, 5, 'PPL', 'P'),
(192998, 'Ak Chut Vaya', 31.6305599212646, 0.552057414875426, -111.808891296387, -1.95143328612638, 218, 5, 'PPL', 'P'),
(192996, 'Ak Komelik', 31.7177791595459, 0.553579677754516, -112.200561523438, -1.95826922117045, 218, 5, 'PPL', 'P'),
(192999, 'Ak-Chin Village', 33.0283317565918, 0.576453135593529, -112.086936950684, -1.95628609826472, 218, 5, 'PPL', 'P'),
(84598, 'Akard Addition', 36.5580596923828, 0.638058509772705, -82.2786102294922, -1.43603265246973, 218, 50, 'PPL', 'P'),
(201852, 'Akaska', 45.3325004577637, 0.791201391149813, -100.120277404785, -1.74742848872358, 218, 49, 'PPL', 'P'),
(188001, 'Akela', 32.2458305358887, 0.562795912891385, -107.404998779297, -1.87457086179922, 218, 38, 'PPL', 'P'),
(133871, 'Akeley', 47.0041694641113, 0.820377519314121, -94.7266693115234, -1.65329226893395, 218, 28, 'PPL', 'P'),
(158563, 'Akeley', 41.9647216796875, 0.732422562993592, -79.1311111450195, -1.38109843024217, 218, 45, 'PPL', 'P'),
(84599, 'Akeman Crossroad', 35.6266708374023, 0.621802707636916, -84.7513885498047, -1.47919077583111, 218, 50, 'PPL', 'P'),
(158564, 'Akerly', 41.8905601501465, 0.731128200124786, -80.4877777099609, -1.40477672865212, 218, 45, 'PPL', 'P'),
(39049, 'Akers', 30.2900009155273, 0.528660246408049, -90.4016723632813, -1.57780683204842, 218, 22, 'PPL', 'P'),
(53141, 'Akers', 37.3761100769043, 0.652336182429811, -91.5536117553711, -1.59791196722381, 218, 29, 'PPL', 'P'),
(179643, 'Akers', 37.9983291625977, 0.663195954143909, -121.282501220703, -2.11677897135531, 218, 6, 'PPL', 'P'),
(44304, 'Akers Acres', 39.4452781677246, 0.688449978391831, -77.477783203125, -1.35224241404089, 218, 25, 'PPL', 'P'),
(34523, 'Akersville', 36.6474990844727, 0.639619521645655, -85.9377822875977, -1.49989725278064, 218, 21, 'PPL', 'P'),
(77771, 'Akersville', 39.978328704834, 0.697753465343913, -78.1980590820313, -1.3648135996505, 218, 45, 'PPL', 'P'),
(195844, 'Akerville (historical)', 47.0638885498047, 0.821419813985751, -109.41667175293, -1.9096811786625, 218, 31, 'PPL', 'P'),
(18761, 'Akes', 33.9672203063965, 0.592839832096896, -85.3180618286133, -1.4890810903294, 218, 13, 'PPL', 'P'),
(212254, 'Akhiok', 56.9455604553223, 0.993887524338855, -154.170272827148, -2.69077886953169, 218, 1, 'PPL', 'P'),
(212255, 'Akiachak', 60.9094390869141, 1.06307025760958, -161.431396484375, -2.81750938474474, 218, 1, 'PPL', 'P'),
(212256, 'Akiak', 60.9122200012207, 1.06311879372045, -161.213882446289, -2.81371304861083, 218, 1, 'PPL', 'P'),
(18762, 'Akin', 31.4558296203613, 0.549007795821663, -81.7044372558594, -1.42601144360387, 218, 13, 'PPL', 'P'),
(26334, 'Akin', 37.9880599975586, 0.663016723402547, -88.7474975585938, -1.54893603530309, 218, 18, 'PPL', 'P'),
(186318, 'Akin', 39.2547187805176, 0.685124089664485, -108.262496948242, -1.88953702817714, 218, 7, 'PPL', 'P'),
(92153, 'Akin Development Colonia', 26.2369995117188, 0.457922027323637, -98.3840026855469, -1.71712477815374, 218, 51, 'PPL', 'P'),
(26335, 'Akin Junction', 38.0099983215332, 0.663399619388273, -88.7613906860352, -1.54917851612034, 218, 18, 'PPL', 'P'),
(18763, 'Akins', 32.3061103820801, 0.563847994680021, -81.6205596923828, -1.42454750395265, 218, 13, 'PPL', 'P'),
(74947, 'Akins', 35.5069389343262, 0.619712991708558, -94.690559387207, -1.65266203186199, 218, 42, 'PPL', 'P'),
(84600, 'Akins Chapel', 35.788890838623, 0.624633980770807, -88.086669921875, -1.53740241725417, 218, 50, 'PPL', 'P'),
(84601, 'Akins Corner', 35.4866714477539, 0.619359257336769, -89.769172668457, -1.56676762985588, 218, 50, 'PPL', 'P'),
(18764, 'Akins Mill', 32.5141716003418, 0.567479347984398, -81.8161087036133, -1.42796047804764, 218, 13, 'PPL', 'P'),
(112700, 'Akinsville', 31.6355590820313, 0.55214466669064, -85.6111068725586, -1.49419569120289, 218, 2, 'PPL', 'P'),
(112699, 'Akka', 30.7772197723389, 0.537163819637213, -88.023063659668, -1.53629227855378, 218, 2, 'PPL', 'P'),
(212257, 'Akokpak', 59.6333312988281, 1.04079797509714, -157.133331298828, -2.74249399579161, 218, 1, 'PPL', 'P'),
(211654, 'Akolea Plantation Estates *', 19.7033290863037, 0.343887966159966, -155.13444519043, -2.70760685182768, 218, 15, 'PPL', 'P'),
(211523, 'Akona', 20.103609085083, 0.350874170068543, -155.611663818359, -2.7159358881369, 218, 15, 'PPL', 'P'),
(139570, 'Akra', 48.7752799987793, 0.851289229560835, -97.7266693115234, -1.70565214649378, 218, 34, 'PPL', 'P'),
(18765, 'Akridge', 30.983060836792, 0.54075642394773, -84.1605606079102, -1.46887888293227, 218, 13, 'PPL', 'P'),
(18766, 'Akridge (historical)', 31.2255592346191, 0.544988819420624, -84.022216796875, -1.46646432792995, 218, 13, 'PPL', 'P'),
(215, 'Akron', 32.8763885498047, 0.573801226359056, -87.7425003051758, -1.53139552425745, 218, 2, 'PPL', 'P'),
(31611, 'Akron', 37.3516693115234, 0.651909610602208, -97.0147171020508, -1.69322623632164, 218, 20, 'PPL', 'P'),
(58425, 'Akron', 32.7408294677734, 0.571435274046629, -88.5247192382813, -1.54504782011157, 218, 30, 'PPL', 'P'),
(107930, 'Akron', 39.4147186279297, 0.687916613804515, -80.8058319091797, -1.41032782162828, 218, 58, 'PPL', 'P'),
(114363, 'Akron', 42.8288917541504, 0.747505176090174, -96.5591735839844, -1.68527550204526, 218, 16, 'PPL', 'P'),
(118578, 'Akron', 40.9038887023926, 0.713907534726062, -89.6538925170898, -1.56475561165232, 218, 18, 'PPL', 'P'),
(122118, 'Akron', 41.038330078125, 0.716253979383503, -86.0280609130859, -1.50147291203959, 218, 19, 'PPL', 'P'),
(129441, 'Akron', 43.5680618286133, 0.760406127621763, -83.5141677856445, -1.45759719992248, 218, 27, 'PPL', 'P'),
(139001, 'Akron', 40.5194396972656, 0.70719763378058, -93.8172225952148, -1.63741942936292, 218, 29, 'PPL', 'P'),
(141139, 'Akron', 41.7413902282715, 0.728524693843125, -98.241943359375, -1.71464537517887, 218, 35, 'PPL', 'P'),
(146722, 'Akron', 43.0208282470703, 0.750855099846358, -78.4955596923828, -1.37000596482783, 218, 40, 'PPL', 'P'),
(154030, 'Akron', 41.0813903808594, 0.717005523443123, -81.519172668457, -1.42277796656635, 218, 41, 'PPL', 'P'),
(158565, 'Akron', 40.1566696166992, 0.700866101446971, -76.2024993896484, -1.32998451259833, 218, 45, 'PPL', 'P'),
(194081, 'Akron', 40.1605606079102, 0.700934012054768, -103.213890075684, -1.80142221561218, 218, 7, 'PPL', 'P'),
(202827, 'Akron', 40.6308288574219, 0.709141741376337, -111.854438781738, -1.95222823971177, 218, 52, 'PPL', 'P'),
(7045, 'Akron (historical)', 35.6661109924316, 0.622491068199674, -91.4486083984375, -1.59607931291967, 218, 4, 'PPL', 'P'),
(146723, 'Akron Junction', 43.0047187805176, 0.750573936614272, -78.5347213745117, -1.3706894651216, 218, 40, 'PPL', 'P'),
(141140, 'Aksarben Mobile Home Park', 41.2361106872559, 0.719705902209436, -96.0111083984375, -1.67570996004191, 218, 35, 'PPL', 'P'),
(212259, 'Akulurak', 60.2775001525879, 1.05204084253404, -162.441390991211, -2.83513711431609, 218, 1, 'PPL', 'P'),
(212258, 'Akumsuk', 62.7230606079102, 1.09472392453599, -164.472213745117, -2.87058165789617, 218, 1, 'PPL', 'P'),
(211655, 'Akupu', 21.3941707611084, 0.373398720515243, -158.103057861328, -2.75941891715128, 218, 15, 'PPL', 'P'),
(212260, 'Akutan', 54.1355590820313, 0.944843748389364, -165.773056030273, -2.89328563882131, 218, 1, 'PPL', 'P'),
(71634, 'Al Bar Meadows', 39.1680603027344, 0.683611613902402, -84.3688888549805, -1.47251489676856, 218, 41, 'PPL', 'P'),
(92144, 'Ala Blanca Colonia', 26.4099998474121, 0.460941452788541, -98.9980010986328, -1.72784107206411, 218, 51, 'PPL', 'P'),
(92145, 'Ala Blanca Colonia Number 1', 26.2220001220703, 0.457660238588482, -98.3550033569336, -1.71661864438857, 218, 51, 'PPL', 'P'),
(92146, 'Ala Blanca Colonia Number 2', 26.2199993133545, 0.457625317888688, -98.3529968261719, -1.71658362382023, 218, 51, 'PPL', 'P'),
(92147, 'Ala Blanca Colonia Number 3', 26.2199993133545, 0.457625317888688, -98.3539962768555, -1.71660106752537, 218, 51, 'PPL', 'P'),
(92148, 'Ala Blanca Colonia Number 4', 26.2199993133545, 0.457625317888688, -98.3550033569336, -1.71661864438857, 218, 51, 'PPL', 'P'),
(92149, 'Ala Blanca Norte Number 1 Colonia', 26.2229995727539, 0.457677682293622, -98.3519973754883, -1.71656618011509, 218, 51, 'PPL', 'P'),
(92150, 'Ala Blanca Norte Number 2 Colonia', 26.2280006408691, 0.457764967398349, -98.3509979248047, -1.71654873640995, 218, 51, 'PPL', 'P'),
(92151, 'Ala Blanca Norte Number 3 Colonia', 26.2250003814697, 0.457712602993416, -98.3539962768555, -1.71660106752537, 218, 51, 'PPL', 'P'),
(92152, 'Ala Blanca Norte Number 4 Colonia', 26.2269992828369, 0.457747490403696, -98.3529968261719, -1.71658362382023, 218, 51, 'PPL', 'P'),
(7036, 'Alabam', 36.1525001525879, 0.630980160490411, -93.6811065673828, -1.63504375651251, 218, 4, 'PPL', 'P'),
(112706, 'Alabama', 32.7502784729004, 0.571600190297132, -86.7502822875977, -1.5140780529531, 218, 2, 'ADM1', 'A'),
(146735, 'Alabama', 43.0963897705078, 0.752173897218165, -78.39111328125, -1.36818303106167, 218, 40, 'PPL', 'P'),
(112702, 'Alabama City', 34.0222206115723, 0.593799768511815, -86.0455627441406, -1.50177837661662, 218, 2, 'PPL', 'P'),
(112701, 'Alabama Fork', 34.851390838623, 0.60827151903336, -86.9738922119141, -1.51798078237255, 218, 2, 'PPL', 'P'),
(71635, 'Alabama Hill', 39.6344413757324, 0.691751499195202, -82.0516662597656, -1.43207173298045, 218, 41, 'PPL', 'P'),
(179645, 'Alabama Hill', 38.3549995422363, 0.669421026612942, -120.590827941895, -2.10470699529204, 218, 6, 'PPL', 'P'),
(179646, 'Alabama Hills', 36.5677795410156, 0.638228153134143, -118.088890075684, -2.06103994184633, 218, 6, 'PPL', 'P'),
(18767, 'Alabama Junction', 32.0758285522461, 0.5598288185419, -81.1402816772461, -1.41616507126357, 218, 13, 'PPL', 'P'),
(39051, 'Alabama Landing', 32.8736114501953, 0.573752756827216, -92.0844421386719, -1.60717670518203, 218, 22, 'PPL', 'P'),
(112704, 'Alabama Port', 30.3627796173096, 0.529930474379476, -88.1147232055664, -1.53789203942059, 218, 2, 'PPL', 'P'),
(112703, 'Alabama Shores', 34.7963905334473, 0.607311582618441, -87.5524978637695, -1.52807935606808, 218, 2, 'PPL', 'P'),
(211656, 'Alabama Village', 20.8658294677734, 0.364177425372303, -156.454162597656, -2.73064026577967, 218, 15, 'PPL', 'P'),
(92154, 'Alabama-Arkansas Colonia', 25.8649997711182, 0.451429407033592, -97.383056640625, -1.69965497403503, 218, 51, 'PPL', 'P'),
(112705, 'Alabaster', 33.2441711425781, 0.580220243534474, -86.8163909912109, -1.51523186749537, 218, 2, 'PPL', 'P'),
(129443, 'Alabaster', 44.1863899230957, 0.771197988728064, -83.5580596923828, -1.45836325821004, 218, 27, 'PPL', 'P'),
(129444, 'Alabaster Junction', 44.2458305358887, 0.772235423130704, -83.563606262207, -1.45846006411566, 218, 27, 'PPL', 'P'),
(14953, 'Alachua', 29.7513904571533, 0.519259720523746, -82.4250030517578, -1.43858768921955, 218, 12, 'PPL', 'P'),
(14950, 'Alachua II (historical)', 29.6166706085205, 0.516908415597315, -82.3666687011719, -1.43756956273481, 218, 12, 'PPL', 'P'),
(14951, 'Alackaway Tolofa (historical)', 29.5333309173584, 0.515453863588941, -82.283332824707, -1.43611507730546, 218, 12, 'PPL', 'P'),
(18768, 'Alaculsy', 34.9886093139648, 0.610666433222641, -84.633056640625, -1.47712549440576, 218, 13, 'PPL', 'P'),
(26342, 'Aladdin', 39.7163887023926, 0.693181749858629, -91.3230590820313, -1.59388806397476, 218, 18, 'PPL', 'P'),
(158567, 'Aladdin', 40.6916694641113, 0.710203610281979, -79.6569366455078, -1.39027581651664, 218, 45, 'PPL', 'P'),
(206657, 'Aladdin', 48.7286109924316, 0.850474701741434, -117.670280456543, -2.05373382571181, 218, 56, 'PPL', 'P'),
(209256, 'Aladdin', 44.6399993896484, 0.779114967437624, -104.183059692383, -1.81833741643387, 218, 59, 'PPL', 'P'),
(14952, 'Aladdin City', 25.5702800750732, 0.446285577967131, -80.4544372558594, -1.40419482795394, 218, 12, 'PPL', 'P'),
(44305, 'Aladdin Village Trailer Park', 39.1744384765625, 0.683722934035967, -76.7836074829102, -1.34012676213574, 218, 25, 'PPL', 'P'),
(112707, 'Alaga', 31.1261100769043, 0.543253104180165, -85.0725021362305, -1.48479526518713, 218, 2, 'PPL', 'P'),
(212262, 'Alaganik', 60.4441719055176, 1.05494981339274, -145.215835571289, -2.53449445675369, 218, 1, 'PPL', 'P'),
(212261, 'Alakanuk', 62.6888885498047, 1.09412750960987, -164.615280151367, -2.87307863773423, 218, 1, 'PPL', 'P'),
(14954, 'Alamana', 28.9427795410156, 0.505146797669576, -81.102783203125, -1.41551059942568, 218, 12, 'PPL', 'P'),
(62455, 'Alamance', 36.0349998474121, 0.628929393292996, -79.4861068725586, -1.38729427451824, 218, 33, 'PPL', 'P'),
(62458, 'Alamance Hills Subdivision', 36.0986099243164, 0.630039598572422, -79.3977813720703, -1.38575270372125, 218, 33, 'PPL', 'P'),
(129446, 'Alamando', 43.7427787780762, 0.763455513648931, -84.5266723632813, -1.47526873849375, 218, 27, 'PPL', 'P'),
(14955, 'Alameda', 25.7630596160889, 0.449650215688337, -80.2977828979492, -1.40146069362081, 218, 12, 'PPL', 'P'),
(31612, 'Alameda', 37.5611114501953, 0.65556506551445, -98.0611114501953, -1.71148926297102, 218, 20, 'PPL', 'P'),
(179648, 'Alameda', 35.2377815246582, 0.615015308703713, -119.002220153809, -2.07698055886711, 218, 6, 'PPL', 'P'),
(188002, 'Alameda', 35.1866683959961, 0.614123216317564, -106.617500305176, -1.86082642057138, 218, 38, 'PPL', 'P'),
(200300, 'Alameda', 45.5552787780762, 0.795089606341328, -122.629440307617, -2.14028749324577, 218, 43, 'PPL', 'P'),
(191052, 'Alameda Estates Colonia', 31.6469993591309, 0.552344337193369, -106.294998168945, -1.85519769644944, 218, 51, 'PPL', 'P'),
(188004, 'Alamillo', 34.2547187805176, 0.597857627064769, -106.915557861328, -1.86602850628668, 218, 38, 'PPL', 'P'),
(188005, 'Alamito', 35.8224983215332, 0.625220542000897, -104.436943054199, -1.8227685170136, 218, 38, 'PPL', 'P'),
(179650, 'Alamitos', 37.250560760498, 0.650144933484894, -121.866111755371, -2.12696489673459, 218, 6, 'PPL', 'P'),
(7039, 'Alamo', 34.4738883972168, 0.601682858496504, -93.4686126708984, -1.63133503837847, 218, 4, 'PPL', 'P'),
(18769, 'Alamo', 32.1469383239746, 0.561069918188905, -82.7780609130859, -1.44474971134977, 218, 13, 'PPL', 'P'),
(29076, 'Alamo', 39.9819412231445, 0.697816515682721, -87.0572204589844, -1.51943513464385, 218, 19, 'PPL', 'P'),
(84602, 'Alamo', 35.7847213745117, 0.62456120989402, -89.1172180175781, -1.55538887462435, 218, 50, 'PPL', 'P'),
(92160, 'Alamo', 26.1833305358887, 0.456985326989229, -98.1227798461914, -1.71256557952558, 218, 51, 'PPL', 'P'),
(129447, 'Alamo', 42.3752784729004, 0.739588130801587, -85.7077789306641, -1.49588293691151, 218, 27, 'PPL', 'P'),
(179651, 'Alamo', 37.8502807617188, 0.660612022096259, -122.031112670898, -2.12984470597935, 218, 6, 'PPL', 'P'),
(186319, 'Alamo', 37.6555595397949, 0.657213495650182, -104.958061218262, -1.83186374476844, 218, 7, 'PPL', 'P'),
(188008, 'Alamo', 34.4208297729492, 0.600756810806456, -107.510276794434, -1.87640830979332, 218, 38, 'PPL', 'P'),
(189857, 'Alamo', 37.3650016784668, 0.652142304302453, -115.163612365723, -2.00998421427232, 218, 39, 'PPL', 'P'),
(197916, 'Alamo', 48.5816688537598, 0.847910077611687, -103.469436645508, -1.80588234464779, 218, 34, 'PPL', 'P'),
(188007, 'Alamo (historical)', 34.8375015258789, 0.608029104795136, -104.277496337891, -1.81998564683252, 218, 38, 'PPL', 'P'),
(191053, 'Alamo Alto', 31.4050006866455, 0.548120663573044, -106.023330688477, -1.85045620444466, 218, 51, 'PPL', 'P'),
(92155, 'Alamo Beach', 28.5798301696777, 0.498812136121686, -96.5860595703125, -1.68574475102933, 218, 51, 'PPL', 'P'),
(193090, 'Alamo Crossing (historical)', 34.2605590820313, 0.597959559555491, -113.581939697266, -1.98237881851894, 218, 5, 'PPL', 'P'),
(92156, 'Alamo Heights', 29.4847202301025, 0.514605447044669, -98.4655609130859, -1.71854823775638, 218, 51, 'PPL', 'P'),
(188009, 'Alamo Hueco', 31.440559387207, 0.548741279975573, -108.426940917969, -1.89240711688392, 218, 38, 'PPL', 'P'),
(179652, 'Alamo Oaks', 37.8394393920898, 0.660422804500809, -121.991943359375, -2.12916107252753, 218, 6, 'PPL', 'P'),
(92157, 'Alamo Orchards Colonia', 26.1620006561279, 0.456613050358349, -98.1289978027344, -1.71267410334, 218, 51, 'PPL', 'P'),
(186320, 'Alamo Placita', 39.7208290100098, 0.69325924784635, -104.975280761719, -1.83216428249745, 218, 7, 'PPL', 'P'),
(191054, 'Alamo Ranchettes Colonia', 30.8570003509521, 0.538556253413161, -102.902000427246, -1.79597871434406, 218, 51, 'PPL', 'P'),
(92158, 'Alamo Rose RV Resort Colonia', 26.1690006256104, 0.456735222873357, -98.1230010986328, -1.71256944110916, 218, 51, 'PPL', 'P'),
(191055, 'Alamo Village', 29.4277801513672, 0.513611655194393, -100.394721984863, -1.7522184502602, 218, 51, 'PPL', 'P'),
(53142, 'Alamode (historical)', 37.313060760498, 0.65123576426739, -90.9961090087891, -1.58818170870704, 218, 29, 'PPL', 'P'),
(188010, 'Alamogordo', 32.8994407653809, 0.574203563420739, -105.959716796875, -1.84934593258621, 218, 38, 'PPL', 'P'),
(179653, 'Alamorio', 32.9791717529297, 0.575595131669333, -115.460563659668, -2.01516699206972, 218, 6, 'PPL', 'P'),
(188011, 'Alamorosa', 33.0055618286133, 0.576055725379862, -105.991668701172, -1.84990359851847, 218, 38, 'PPL', 'P'),
(186321, 'Alamosa', 37.4694404602051, 0.653965104910558, -105.869438171387, -1.84777027332726, 218, 7, 'PPL', 'P'),
(187572, 'Alamota', 38.461109161377, 0.671272988834983, -100.309722900391, -1.75073493637497, 218, 20, 'PPL', 'P'),
(58427, 'Alamucha', 32.3586082458496, 0.564764255253062, -88.4686126708984, -1.54406857577875, 218, 30, 'PPL', 'P'),
(18770, 'Alandale', 34.2058296203613, 0.597004350251507, -83.82861328125, -1.46308530913886, 218, 13, 'PPL', 'P'),
(26336, 'Alandale', 38.9388885498047, 0.679611812261212, -90.2291717529297, -1.57479612843609, 218, 18, 'PPL', 'P'),
(124096, 'Alander', 42.0561103820801, 0.734017596749468, -73.466667175293, -1.2822352326757, 218, 23, 'PPL', 'P'),
(191056, 'Alanreed', 35.2125015258789, 0.614574089490114, -100.73388671875, -1.75813799157317, 218, 51, 'PPL', 'P'),
(129449, 'Alanson', 45.4441719055176, 0.793150425593587, -84.7866668701172, -1.47980649867514, 218, 27, 'PPL', 'P'),
(99328, 'Alanthus', 38.5419387817383, 0.672683731843425, -77.9330596923828, -1.36018848778536, 218, 53, 'PPL', 'P'),
(187574, 'Alanthus', 38.7000007629395, 0.675442433837611, -100.16667175293, -1.74823822285302, 218, 20, 'PPL', 'P'),
(139002, 'Alanthus Grove', 40.3069381713867, 0.703488782488481, -94.5438919067383, -1.6501022014222, 218, 29, 'PPL', 'P'),
(84603, 'Alanthus Hill', 36.5652809143066, 0.638184543871293, -83.3916702270508, -1.45545921419936, 218, 50, 'PPL', 'P'),
(99329, 'Alantic City', 36.8566703796387, 0.643270249446963, -76.3022232055664, -1.33172502152876, 218, 53, 'PPL', 'P'),
(99330, 'Alanton', 36.8824996948242, 0.643721056040486, -76.022216796875, -1.32683798777041, 218, 53, 'PPL', 'P'),
(18771, 'Alapaha', 31.3850002288818, 0.547771589733162, -83.2230606079102, -1.45251642119483, 218, 13, 'PPL', 'P'),
(14956, 'Alapaha (historical)', 30.6000003814697, 0.534070757768168, -83.0500030517578, -1.44949599704451, 218, 12, 'PPL', 'P'),
(13266, 'Alapocas', 39.7708282470703, 0.694131899156542, -75.5597229003906, -1.31876594650638, 218, 10, 'PPL', 'P'),
(62460, 'Alarka', 35.3530616760254, 0.617027326907268, -83.445556640625, -1.45639970953833, 218, 33, 'PPL', 'P'),
(29077, 'Alaska', 39.4702796936035, 0.68888633733644, -86.6413879394531, -1.51217748804116, 218, 19, 'PPL', 'P'),
(129450, 'Alaska', 42.8400001525879, 0.747699054217532, -85.4780578613281, -1.4918735478904, 218, 27, 'PPL', 'P'),
(158569, 'Alaska', 40.7836112976074, 0.711808297996806, -76.4377822875977, -1.33409097384118, 218, 45, 'PPL', 'P'),
(172855, 'Alaska', 44.5405616760254, 0.777379451934247, -87.501106262207, -1.52718240341294, 218, 57, 'PPL', 'P'),
(188012, 'Alaska', 35.0527801513672, 0.611786425619074, -107.595558166504, -1.87789675052657, 218, 38, 'PPL', 'P'),
(212264, 'Alaska', 64.0002822875977, 1.11701564812439, -150.000274658203, -2.61799867168146, 218, 1, 'ADM1', 'A'),
(107931, 'Alaska (historical)', 37.9144401550293, 0.66173181475561, -81.039436340332, -1.41440498809914, 218, 58, 'PPL', 'P'),
(212263, 'Alatna', 66.5572204589844, 1.16164263798501, -152.707214355469, -2.66524368205168, 218, 1, 'PPL', 'P'),
(92161, 'Alazan', 31.5830593109131, 0.551228372828085, -94.7858276367188, -1.65432477648858, 218, 51, 'PPL', 'P'),
(199803, 'Alazon', 41.1336097717285, 0.717916923747176, -115.029167175293, -2.00763770303585, 218, 39, 'PPL', 'P'),
(53143, 'Alba', 37.2383308410645, 0.649931481123524, -94.4172210693359, -1.64789137824327, 218, 29, 'PPL', 'P'),
(92162, 'Alba', 32.792781829834, 0.572342013818774, -95.6341705322266, -1.66913115320109, 218, 51, 'PPL', 'P'),
(129451, 'Alba', 44.9747200012207, 0.784956944183849, -84.9686126708984, -1.48298205195895, 218, 27, 'PPL', 'P'),
(158570, 'Alba', 41.7050018310547, 0.727889596502168, -76.82861328125, -1.34091226149926, 218, 45, 'PPL', 'P'),
(179654, 'Alba', 37.7980613708496, 0.659700621792207, -121.038612365723, -2.11252230782698, 218, 6, 'PPL', 'P'),
(172856, 'Alban', 44.6277809143066, 0.778901714813336, -89.2847213745117, -1.55831235971099, 218, 57, 'PPL', 'P'),
(13267, 'Alban Park', 39.7291717529297, 0.69340485617895, -75.5749969482422, -1.31903252893149, 218, 10, 'PPL', 'P'),
(99331, 'Albano', 38.207218170166, 0.6668417550972, -78.304443359375, -1.3666703555625, 218, 53, 'PPL', 'P'),
(44306, 'Albantown', 39.6408309936523, 0.691863019065849, -76.8091735839844, -1.34057297477638, 218, 25, 'PPL', 'P'),
(18772, 'Albany', 31.5783290863037, 0.551145814834292, -84.1558303833008, -1.46879632493848, 218, 13, 'PPL', 'P'),
(34518, 'Albany', 36.6908302307129, 0.640375792816211, -85.1347198486328, -1.48588116912161, 218, 21, 'PPL', 'P'),
(39052, 'Albany', 30.5041694641113, 0.532398192735057, -90.5822219848633, -1.58095801740826, 218, 22, 'PPL', 'P'),
(71636, 'Albany', 39.2275009155273, 0.684649048305042, -82.2024993896484, -1.43470426771799, 218, 41, 'PPL', 'P'),
(74950, 'Albany', 33.8813896179199, 0.591341803983726, -96.1624984741211, -1.67835221531744, 218, 42, 'PPL', 'P'),
(84604, 'Albany', 36.2419395446777, 0.632541172363361, -82.9111099243164, -1.44707185466227, 218, 50, 'PPL', 'P'),
(92163, 'Albany', 32.723331451416, 0.571129876048624, -99.2969436645508, -1.73305860411374, 218, 51, 'PPL', 'P'),
(114364, 'Albany', 42.8658294677734, 0.748149860811055, -91.7586135864258, -1.60148992414833, 218, 16, 'PPL', 'P'),
(118581, 'Albany', 41.7894401550293, 0.729363323270391, -90.2191696166992, -1.57462155822663, 218, 18, 'PPL', 'P'),
(122119, 'Albany', 40.3008308410645, 0.70338218946585, -85.241943359375, -1.48775257241961, 218, 19, 'PPL', 'P'),
(133878, 'Albany', 45.6300010681152, 0.79639375632714, -94.5697174072266, -1.6505529414367, 218, 28, 'PPL', 'P'),
(139003, 'Albany', 40.2486114501953, 0.702470789161798, -94.3308334350586, -1.64638362959213, 218, 29, 'PPL', 'P'),
(143448, 'Albany', 43.9577789306641, 0.76720797420388, -71.1680603027344, -1.24211697454059, 218, 36, 'PPL', 'P'),
(146725, 'Albany', 42.6525001525879, 0.744426561870043, -73.7566680908203, -1.28729670348545, 218, 40, 'PPL', 'P'),
(158573, 'Albany', 40.0377807617188, 0.698791099483635, -79.8716735839844, -1.39402368311871, 218, 45, 'PPL', 'P'),
(171675, 'Albany', 44.7308311462402, 0.780700280655521, -72.3802795410156, -1.26327419150461, 218, 55, 'PPL', 'P'),
(172858, 'Albany', 42.7077789306641, 0.745391358553951, -89.4369430541992, -1.56096912921445, 218, 57, 'PPL', 'P'),
(179655, 'Albany', 37.8869400024414, 0.661251846548151, -122.296669006348, -2.13447953838247, 218, 6, 'PPL', 'P'),
(200301, 'Albany', 44.6366691589355, 0.779056843946833, -123.104721069336, -2.14858270740915, 218, 43, 'PPL', 'P'),
(209257, 'Albany', 41.1841697692871, 0.718799362174373, -106.131393432617, -1.85234225512866, 218, 59, 'PPL', 'P'),
(39053, 'Albany (historical)', 32.6124992370605, 0.569195488990845, -93.8319396972656, -1.63767629125006, 218, 22, 'PPL', 'P'),
(199136, 'Albany (historical)', 42.9583282470703, 0.749764269063861, -102.288887023926, -1.78527786676801, 218, 35, 'PPL', 'P'),
(171676, 'Albany Center', 44.7366714477539, 0.780802213146244, -72.3499984741211, -1.26274568718629, 218, 55, 'PPL', 'P'),
(139004, 'Albany Junction', 40.2269401550293, 0.702092553707979, -94.3688888549805, -1.64704782196799, 218, 29, 'PPL', 'P'),
(114365, 'Albaton', 42.1855583190918, 0.736276889460237, -96.2905578613281, -1.68058727326229, 218, 16, 'PPL', 'P'),
(53145, 'Albatross', 37.1891708374023, 0.649073477199328, -93.8388900756836, -1.63779759823771, 218, 29, 'PPL', 'P'),
(44307, 'Albatross Mobile Home Park', 38.3525009155273, 0.669377417350092, -75.1580581665039, -1.31175557441091, 218, 25, 'PPL', 'P'),
(18773, 'Albaugh', 32.5455589294434, 0.568027160220627, -83.8258285522461, -1.46303670644897, 218, 13, 'PPL', 'P'),
(169700, 'Albee', 45.0522193908691, 0.786309563701501, -96.5530624389648, -1.6851688424436, 218, 49, 'PPL', 'P'),
(200302, 'Albee (historical)', 45.2127799987793, 0.789111874958537, -118.908058166504, -2.07533712215842, 218, 43, 'PPL', 'P'),
(58426, 'Albeison', 31.4911098480225, 0.549623551955203, -89.279167175293, -1.55821542064731, 218, 30, 'PPL', 'P'),
(39054, 'Albemarle', 29.8824996948242, 0.521548008400883, -90.9747161865234, -1.58780833352221, 218, 22, 'PPL', 'P'),
(62462, 'Albemarle', 35.3499984741211, 0.616973863948385, -80.2002792358398, -1.39975893368425, 218, 33, 'PPL', 'P'),
(62463, 'Albemarle Beach', 35.9358291625977, 0.627198538321526, -76.6416702270508, -1.33764948968975, 218, 33, 'PPL', 'P'),
(99333, 'Alberene', 37.8863906860352, 0.661242259168227, -78.6166687011719, -1.37211971578502, 218, 53, 'PPL', 'P'),
(179656, 'Alberhill', 33.7272186279297, 0.588651012597337, -117.398887634277, -2.048997127397, 218, 6, 'PPL', 'P'),
(26337, 'Albers', 38.5433311462402, 0.672708033188372, -89.6122207641602, -1.56402830235862, 218, 18, 'PPL', 'P'),
(7042, 'Albert', 34.3711090087891, 0.599889019765254, -93.8744430541992, -1.6384181147717, 218, 4, 'PPL', 'P'),
(31621, 'Albert', 38.4527816772461, 0.671127646818492, -99.0111083984375, -1.72806983760174, 218, 20, 'PPL', 'P'),
(74952, 'Albert', 35.232780456543, 0.614928023598986, -98.4111099243164, -1.71759788872139, 218, 42, 'PPL', 'P'),
(92170, 'Albert', 30.1936092376709, 0.526977894257932, -98.6013870239258, -1.72091885060072, 218, 51, 'PPL', 'P'),
(158576, 'Albert', 41.1202812194824, 0.717684296625957, -75.9313888549805, -1.32525274113154, 218, 45, 'PPL', 'P'),
(188013, 'Albert', 35.934440612793, 0.627174303555606, -103.864723205566, -1.81278139660969, 218, 38, 'PPL', 'P'),
(18774, 'Albert (historical)', 34.4613914489746, 0.601464745603226, -83.9433288574219, -1.46508747364638, 218, 13, 'PPL', 'P'),
(114366, 'Albert City', 42.7819404602051, 0.746685721422757, -94.9483337402344, -1.65716104304951, 218, 16, 'PPL', 'P'),
(133881, 'Albert Lea', 43.6480598449707, 0.761802356402264, -93.3680572509766, -1.62958001522011, 218, 28, 'PPL', 'P'),
(34519, 'Alberta', 38.4000015258789, 0.670206459397433, -84.4741668701172, -1.47435234476266, 218, 21, 'PPL', 'P'),
(39055, 'Alberta', 32.232780456543, 0.562568146039156, -93.1536102294922, -1.62583720862411, 218, 22, 'PPL', 'P'),
(53146, 'Alberta', 38.3638916015625, 0.669576222325466, -93.6694412231445, -1.63484015784718, 218, 29, 'PPL', 'P'),
(99334, 'Alberta', 36.8655586242676, 0.64342537858046, -77.8866729736328, -1.35937888681398, 218, 53, 'PPL', 'P'),
(112709, 'Alberta', 32.2319412231445, 0.56255349865316, -87.4100036621094, -1.52559236308411, 218, 2, 'PPL', 'P'),
(129455, 'Alberta', 46.6436080932617, 0.814084536237291, -88.4794387817383, -1.54425752705809, 218, 27, 'PPL', 'P'),
(133884, 'Alberta', 45.5733299255371, 0.795404658298285, -96.0472183227539, -1.67634019711388, 218, 28, 'PPL', 'P'),
(92164, 'Alberta Acres Colonia', 26.2469997406006, 0.458096564243578, -98.1050033569336, -1.71225532125858, 218, 51, 'PPL', 'P'),
(92165, 'Alberta Estates Number 2 Colonia', 26.2490005493164, 0.458131484943371, -98.1520004272461, -1.71307557487433, 218, 51, 'PPL', 'P'),
(44308, 'Alberta Heights', 39.1513900756836, 0.683320663553311, -76.6680603027344, -1.33811008340028, 218, 25, 'PPL', 'P'),
(84605, 'Alberton', 35.6997184753418, 0.623077629429764, -88.3163909912109, -1.54141180627529, 218, 50, 'PPL', 'P'),
(112713, 'Alberton', 31.2777805328369, 0.545900253014191, -86.1258316040039, -1.50317933250806, 218, 2, 'PPL', 'P'),
(195845, 'Alberton', 47.0016708374023, 0.820333910051271, -114.472503662109, -1.99792209190508, 218, 31, 'PPL', 'P'),
(44309, 'Alberton (historical)', 39.3175010681152, 0.686219847294998, -76.8138885498047, -1.34065526645406, 218, 25, 'PPL', 'P'),
(146728, 'Alberts Landing', 41.0033302307129, 0.715643116808466, -72.120002746582, -1.25873150447521, 218, 40, 'PPL', 'P'),
(13268, 'Albertson', 39.7402801513672, 0.693598734306308, -75.6277770996094, -1.31995371635255, 218, 10, 'PPL', 'P'),
(62464, 'Albertson', 35.1141700744629, 0.61285788190464, -77.8191680908203, -1.35820070434772, 218, 33, 'PPL', 'P'),
(146729, 'Albertson', 40.7733306884766, 0.711628867518362, -73.6436080932617, -1.28532343427576, 218, 40, 'PPL', 'P'),
(13269, 'Albertson Park', 39.7416687011719, 0.693622969072228, -75.6277770996094, -1.31995371635255, 218, 10, 'PPL', 'P'),
(202832, 'Albertsons Center', 41.2299995422363, 0.719599242607779, -111.945281982422, -1.95381375266675, 218, 52, 'PPL', 'P'),
(112712, 'Albertville', 34.2675018310547, 0.59808073338509, -86.2088928222656, -1.50462902424744, 218, 2, 'PPL', 'P'),
(133887, 'Albertville', 45.2377815246582, 0.789548233903146, -93.654167175293, -1.63457357542206, 218, 28, 'PPL', 'P'),
(172862, 'Albertville', 44.9599990844727, 0.784700015717684, -91.6002807617188, -1.59872649504321, 218, 57, 'PPL', 'P'),
(44310, 'Albeth Heights', 39.3019409179688, 0.685948271442837, -76.9013900756836, -1.34218245618117, 218, 25, 'PPL', 'P'),
(34520, 'Albia', 37.3047218322754, 0.651090222513817, -84.5933303833008, -1.47643214041596, 218, 21, 'PPL', 'P'),
(114367, 'Albia', 41.026668548584, 0.716050447297194, -92.8055572509766, -1.61976253817764, 218, 16, 'PPL', 'P'),
(146730, 'Albia', 42.7033309936523, 0.745313727408175, -73.6522216796875, -1.2854737697193, 218, 40, 'PPL', 'P'),
(58428, 'Albin', 33.913330078125, 0.591899270178907, -90.329719543457, -1.57655101843639, 218, 30, 'PPL', 'P'),
(99335, 'Albin', 39.2216682434082, 0.684547248972374, -78.1988906860352, -1.36482811387844, 218, 53, 'PPL', 'P'),
(209259, 'Albin', 41.417781829834, 0.722876661803285, -104.097778320313, -1.81684897570063, 218, 59, 'PPL', 'P'),
(200303, 'Albina', 45.5438919067383, 0.794890867944981, -122.673889160156, -2.14106327207131, 218, 43, 'PPL', 'P'),
(92166, 'Albino Rodriguez Estates Colonia', 26.257999420166, 0.458288544868659, -98.1380004882813, -1.71283122984431, 218, 51, 'PPL', 'P'),
(7043, 'Albion', 35.3424987792969, 0.616842969580807, -91.789436340332, -1.60202788268853, 218, 4, 'PPL', 'P'),
(13270, 'Albion', 39.7138900756836, 0.693138140595779, -75.6624984741211, -1.3205597186586, 218, 10, 'PPL', 'P'),
(26338, 'Albion', 38.377498626709, 0.669813709715674, -88.0561065673828, -1.53686898608783, 218, 18, 'PPL', 'P'),
(62465, 'Albion', 36.5191688537598, 0.637379736589871, -80.4491729736328, -1.40410294889633, 218, 33, 'PPL', 'P'),
(70454, 'Albion', 39.7786102294922, 0.694267720372136, -74.9552764892578, -1.30821636648024, 218, 37, 'PPL', 'P'),
(74953, 'Albion', 34.6627807617188, 0.60497965218894, -95.0997161865234, -1.65980316516698, 218, 42, 'PPL', 'P'),
(92167, 'Albion', 33.8588905334473, 0.590949120880994, -95.0305633544922, -1.65859622056096, 218, 51, 'PPL', 'P'),
(114368, 'Albion', 42.1124992370605, 0.735001767930307, -92.9883270263672, -1.62295247253134, 218, 16, 'PPL', 'P'),
(122120, 'Albion', 41.3955612182617, 0.722488838969542, -85.4244384765625, -1.49093771308334, 218, 19, 'PPL', 'P'),
(126742, 'Albion', 44.5322189331055, 0.777233843601647, -69.4430618286133, -1.2120100715753, 218, 26, 'PPL', 'P'),
(129456, 'Albion', 42.2430610656738, 0.737280501717033, -84.753059387207, -1.47921993744505, 218, 27, 'PPL', 'P'),
(141143, 'Albion', 41.6908302307129, 0.727642255415927, -98.0033264160156, -1.71048072386621, 218, 35, 'PPL', 'P'),
(146731, 'Albion', 43.2463912963867, 0.754791917727767, -78.1938934326172, -1.36474089535274, 218, 40, 'PPL', 'P'),
(154032, 'Albion', 40.9741706848145, 0.715134186724152, -82.1638870239258, -1.43403035480415, 218, 41, 'PPL', 'P'),
(158578, 'Albion', 40.9588890075684, 0.71486747114098, -78.9472198486328, -1.37788892165446, 218, 45, 'PPL', 'P'),
(169249, 'Albion', 41.9511108398438, 0.732185009024357, -71.4550018310547, -1.24712504897048, 218, 47, 'PPL', 'P'),
(172863, 'Albion', 42.8794403076172, 0.74838741478029, -89.0697174072266, -1.55455983257701, 218, 57, 'PPL', 'P'),
(179657, 'Albion', 39.2236099243164, 0.684581137697245, -123.767501831055, -2.16015041392001, 218, 6, 'PPL', 'P'),
(194503, 'Albion', 42.4127807617188, 0.740242669218501, -113.577217102051, -1.9822963936832, 218, 17, 'PPL', 'P'),
(195846, 'Albion', 45.1872215270996, 0.788665795475948, -104.276390075684, -1.81996633891462, 218, 31, 'PPL', 'P'),
(206658, 'Albion', 46.7911109924316, 0.816658947484044, -117.249443054199, -2.04638882742537, 218, 56, 'PPL', 'P'),
(107932, 'Albion (historical)', 38.2158317565918, 0.666992090540735, -81.0169372558594, -1.41401230499641, 218, 58, 'PPL', 'P'),
(202833, 'Albion Alps', 40.5805587768555, 0.708264362955211, -111.617782592773, -1.94809781001911, 218, 52, 'PPL', 'P'),
(202834, 'Albion Basin', 40.5805587768555, 0.708264362955211, -111.617782592773, -1.94809781001911, 218, 52, 'PPL', 'P'),
(133890, 'Albion Center', 45.1769409179688, 0.788486364997504, -94.0733337402344, -1.64188941209456, 218, 28, 'PPL', 'P'),
(146732, 'Albion Center', 43.4886093139648, 0.759019419642159, -76.0419387817383, -1.3271822013413, 218, 40, 'PPL', 'P'),
(129457, 'Albion Landing', 42.3819389343262, 0.739704377783169, -84.7841720581055, -1.47976295599132, 218, 27, 'PPL', 'P'),
(144719, 'Albion Place', 40.8911094665527, 0.713684494984767, -74.1761093139648, -1.29461733384792, 218, 37, 'PPL', 'P'),
(133892, 'Alborn', 46.9730606079102, 0.819834567346881, -92.5758285522461, -1.61575301599847, 218, 28, 'PPL', 'P'),
(179658, 'Albrae', 37.4955596923828, 0.654420971510152, -121.988327026367, -2.12909795560969, 218, 6, 'PPL', 'P'),
(107933, 'Albright', 39.4938888549805, 0.689298394936102, -79.6430587768555, -1.3900336020155, 218, 58, 'PPL', 'P'),
(133895, 'Albright', 45.1294403076172, 0.787657322950163, -94.1141662597656, -1.64260207400227, 218, 28, 'PPL', 'P'),
(195848, 'Albright (historical)', 46.2844390869141, 0.807815854505408, -106.487503051758, -1.85855754048068, 218, 31, 'PPL', 'P'),
(158580, 'Albrightsville', 41.0144386291504, 0.715836994935824, -75.6013870239258, -1.31949312264202, 218, 45, 'PPL', 'P'),
(7047, 'Albritton (historical)', 33.0525016784668, 0.576874980310198, -91.4375, -1.59588543479232, 218, 4, 'PPL', 'P'),
(62467, 'Albrittons', 35.1977806091309, 0.614317161023949, -77.665283203125, -1.35551490638838, 218, 33, 'PPL', 'P'),
(188014, 'Albuquerque', 35.0844383239746, 0.612338964966238, -106.65055847168, -1.86140339442154, 218, 38, 'PPL', 'P'),
(146742, 'Alburg', 44.7772216796875, 0.781509948205933, -74.5819396972656, -1.30170041024115, 218, 40, 'PPL', 'P'),
(171678, 'Alburg', 44.9749984741211, 0.784961804452839, -73.3005599975586, -1.27933611551304, 218, 55, 'PPL', 'P'),
(171679, 'Alburg Center', 44.9536094665527, 0.784588495847037, -73.2702789306641, -1.27880761119472, 218, 55, 'PPL', 'P'),
(171680, 'Alburg Springs', 44.9919395446777, 0.785257481912865, -73.2233276367188, -1.2779881565273, 218, 55, 'PPL', 'P'),
(171681, 'Alburg Travel Trailer Park', 44.9622192382813, 0.784738764711545, -73.2486114501953, -1.27842944231993, 218, 55, 'PPL', 'P'),
(114371, 'Alburnett', 42.1483306884766, 0.735627144733284, -91.6183319091797, -1.59904154700017, 218, 16, 'PPL', 'P'),
(158581, 'Alburtis', 40.5108299255371, 0.707047364916072, -75.6033325195313, -1.31952707794592, 218, 45, 'PPL', 'P'),
(34521, 'Alcalde', 37.0550003051758, 0.646731759652821, -84.5513916015625, -1.47570017059035, 218, 21, 'PPL', 'P'),
(188015, 'Alcalde', 36.0888900756836, 0.629869955210984, -106.053062438965, -1.85097512138306, 218, 38, 'PPL', 'P'),
(212265, 'Alcan', 62.7230606079102, 1.09472392453599, -141.188064575195, -2.46419659135553, 218, 1, 'PPL', 'P'),
(188016, 'Alcatraz', 36.7563896179199, 0.641520019978563, -107.756393432617, -1.88070385547356, 218, 38, 'PPL', 'P'),
(169703, 'Alcester', 43.0213890075684, 0.750864886963364, -96.6305618286133, -1.68652146196125, 218, 49, 'PPL', 'P'),
(99336, 'Alchie', 36.892219543457, 0.643890699401924, -79.0166702270508, -1.37910105942461, 218, 53, 'PPL', 'P'),
(7046, 'Alco', 35.8875007629395, 0.62635504862527, -92.366943359375, -1.61210728162421, 218, 4, 'PPL', 'P'),
(39057, 'Alco', 31.3341693878174, 0.546884424195029, -93.1305618286133, -1.62543493814145, 218, 22, 'PPL', 'P'),
(92168, 'Alco', 31.3519401550293, 0.547194582593483, -94.5702819824219, -1.65056279513273, 218, 51, 'PPL', 'P'),
(84606, 'Alcoa', 35.7894401550293, 0.624643568150731, -83.9738922119141, -1.46562090481272, 218, 50, 'PPL', 'P'),
(92169, 'Alcoa', 30.5641708374023, 0.533445414254703, -97.0663909912109, -1.69412811582479, 218, 51, 'PPL', 'P'),
(158583, 'Alcoa Center', 40.538330078125, 0.707527333123531, -79.6452789306641, -1.39007235100936, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(158584, 'Alcola', 41.0122184753418, 0.715798245941963, -79.2891693115234, -1.38385706565733, 218, 45, 'PPL', 'P'),
(79502, 'Alcolu', 33.7508316040039, 0.589063136776027, -80.2144393920898, -1.40000607503341, 218, 48, 'PPL', 'P'),
(14957, 'Alcoma', 27.8947200775146, 0.486854709274798, -81.4824981689453, -1.42213787579835, 218, 12, 'PPL', 'P'),
(99337, 'Alcoma', 37.5486106872559, 0.655346886042146, -78.5924987792969, -1.37169787106835, 218, 53, 'PPL', 'P'),
(129460, 'Alcona', 44.7599983215332, 0.78120934389789, -83.2977828979492, -1.45382057118064, 218, 27, 'PPL', 'P'),
(154033, 'Alcony', 40.0113906860352, 0.698330505773106, -84.0580596923828, -1.46708990447001, 218, 41, 'PPL', 'P'),
(34522, 'Alcorn', 37.5613899230957, 0.65556992578344, -84.0488891601563, -1.4669298484885, 218, 21, 'PPL', 'P'),
(58429, 'Alcorn', 31.8777809143066, 0.556372235184059, -91.1391677856445, -1.59067855538705, 218, 30, 'PPL', 'P'),
(74954, 'Alcorn', 36.6130599975586, 0.639018446187624, -97.3927764892578, -1.69982461739647, 218, 42, 'PPL', 'P'),
(18775, 'Alcorns', 32.4094390869141, 0.565651420791195, -83.1102828979492, -1.45054807883315, 218, 13, 'PPL', 'P'),
(79501, 'Alcot', 34.250560760498, 0.597785055925064, -80.1802825927734, -1.39940992642339, 218, 48, 'PPL', 'P'),
(209260, 'Alcova', 42.5522193908691, 0.742676332401642, -106.715827941895, -1.86254256157782, 218, 59, 'PPL', 'P'),
(99339, 'Alcova Heights', 38.8644409179688, 0.678312455965362, -77.0975036621094, -1.34560528397219, 218, 53, 'PPL', 'P'),
(209261, 'Alcova Po', 42.560001373291, 0.742812153617237, -106.722778320313, -1.86266386856548, 218, 59, 'PPL', 'P'),
(146736, 'Alcove', 42.4686088562012, 0.741217053282334, -73.9261093139648, -1.29025401071793, 218, 40, 'PPL', 'P'),
(31618, 'Alcove Spring', 39.7608299255371, 0.693957395526114, -96.6777801513672, -1.68734557716058, 218, 20, 'PPL', 'P'),
(18776, 'Alcovy', 33.639720916748, 0.587123889449259, -83.7869415283203, -1.46235799984516, 218, 13, 'PPL', 'P'),
(18777, 'Alcovy Forest', 33.961109161377, 0.592733172495238, -83.9161071777344, -1.46461236570791, 218, 13, 'PPL', 'P'),
(18778, 'Alcovy Mobile Home Park', 33.5527801513672, 0.585606486839159, -83.845832824707, -1.46338584686788, 218, 13, 'PPL', 'P'),
(18779, 'Alcovy Mountain', 33.7405586242676, 0.588883839455638, -83.7663879394531, -1.46199927204633, 218, 13, 'PPL', 'P'),
(18782, 'Alcovy Shores', 33.3894386291504, 0.582755639471256, -83.8327789306641, -1.46315801343662, 218, 13, 'PPL', 'P'),
(26349, 'Alda', 38.4627799987793, 0.671302150448919, -89.2366714477539, -1.55747373028372, 218, 18, 'PPL', 'P'),
(177364, 'Alda', 40.8711090087891, 0.713335421144885, -98.4677810668945, -1.71858698675024, 218, 35, 'PPL', 'P'),
(191057, 'Aldama Estates Colonia', 31.6359996795654, 0.552152356568288, -106.271003723145, -1.85477891436802, 218, 51, 'PPL', 'P'),
(77772, 'Aldan', 39.9213905334473, 0.69675970678315, -75.288330078125, -1.31402924819156, 218, 45, 'PPL', 'P'),
(796, 'Alden', 39.4833297729492, 0.689114104188669, -81.5022201538086, -1.42248208936924, 218, 41, 'PPL', 'P'),
(31619, 'Alden', 38.2422218322754, 0.667452684251264, -98.3116683959961, -1.71586230663898, 218, 20, 'PPL', 'P'),
(74955, 'Alden', 34.9752807617188, 0.610433806101423, -98.5849990844727, -1.72063282709964, 218, 42, 'PPL', 'P'),
(99338, 'Alden', 38.274169921875, 0.6680102836045, -77.0722198486328, -1.34516399817957, 218, 53, 'PPL', 'P'),
(112714, 'Alden', 33.6388893127441, 0.587109375221318, -86.9652786254883, -1.51783044692902, 218, 2, 'PPL', 'P'),
(114372, 'Alden', 42.5202789306641, 0.742118866206462, -93.3758316040039, -1.62971570327765, 218, 16, 'PPL', 'P'),
(118584, 'Alden', 42.4588890075684, 0.741047409920895, -88.5177764892578, -1.54492664628198, 218, 18, 'PPL', 'P'),
(129463, 'Alden', 44.8811111450195, 0.783323161434113, -85.2755584716797, -1.48833926680775, 218, 27, 'PPL', 'P'),
(133896, 'Alden', 43.670280456543, 0.762190179236007, -93.5758285522461, -1.63320630851841, 218, 28, 'PPL', 'P'),
(146737, 'Alden', 42.9000015258789, 0.748746275737178, -78.4922180175781, -1.36994764159995, 218, 40, 'PPL', 'P'),
(158585, 'Alden', 41.1819381713867, 0.718760413443431, -76.0127792358398, -1.32667327125698, 218, 45, 'PPL', 'P'),
(194082, 'Alden', 40.4575004577637, 0.706116590115089, -104.581390380859, -1.82528959845952, 218, 7, 'PPL', 'P'),
(199137, 'Alden', 41.5613899230957, 0.725383095863213, -103.035827636719, -1.79831443977811, 218, 35, 'PPL', 'P'),
(39056, 'Alden Bridge', 32.7750015258789, 0.572031688972752, -93.7200012207031, -1.63572259627437, 218, 22, 'PPL', 'P'),
(146738, 'Alden Center', 42.9111099243164, 0.748940153864536, -78.5236129760742, -1.37049558699424, 218, 40, 'PPL', 'P'),
(146739, 'Alden Manor', 40.6941719055176, 0.710247286123857, -73.7180633544922, -1.28662292372966, 218, 40, 'PPL', 'P'),
(114373, 'Alden Station (historical)', 42.5041694641113, 0.741837702974376, -93.3805618286133, -1.62979826127144, 218, 16, 'PPL', 'P'),
(144720, 'Aldene', 40.663330078125, 0.709708994688524, -74.2733306884766, -1.29631416693646, 218, 37, 'PPL', 'P'),
(58431, 'Aldens', 34.9333305358887, 0.609701636538732, -90.0247192382813, -1.57122775889149, 218, 30, 'PPL', 'P'),
(172868, 'Aldens Corners', 43.2213897705078, 0.754355558783158, -89.6399993896484, -1.56451313083507, 218, 57, 'PPL', 'P'),
(124097, 'Aldenville', 42.172779083252, 0.736053849718942, -72.5986099243164, -1.26708477555035, 218, 23, 'PPL', 'P'),
(158586, 'Aldenville', 41.646671295166, 0.726871536596458, -75.3641662597656, -1.31535283925333, 218, 45, 'PPL', 'P'),
(84607, 'Aldenwood Park', 35.8941688537598, 0.626471428764907, -84.0274963378906, -1.46655647330367, 218, 50, 'PPL', 'P'),
(84608, 'Alder', 36.3474998474121, 0.634383547205478, -83.9899978637695, -1.46590200146578, 218, 50, 'PPL', 'P'),
(129464, 'Alder', 46.7894401550293, 0.816629785870107, -87.6972198486328, -1.53060523120397, 218, 27, 'PPL', 'P'),
(133900, 'Alder', 47.5616683959961, 0.830107711251862, -93.70361328125, -1.6354365727733, 218, 28, 'PPL', 'P'),
(186322, 'Alder', 38.3694381713867, 0.669673028231091, -106.038887023926, -1.8507277137178, 218, 7, 'PPL', 'P'),
(195849, 'Alder', 45.3238906860352, 0.791051122285305, -112.106391906738, -1.95662565130371, 218, 31, 'PPL', 'P'),
(200304, 'Alder', 44.5825004577637, 0.778111421759855, -123.507781982422, -2.15561744742859, 218, 43, 'PPL', 'P'),
(206659, 'Alder', 46.8005599975586, 0.816823863734547, -122.288887023926, -2.13434371716687, 218, 56, 'PPL', 'P'),
(200305, 'Alder (historical)', 45.3980598449707, 0.792345618312165, -117.296112060547, -2.04720335524477, 218, 43, 'PPL', 'P'),
(146741, 'Alder Bend', 44.8480606079102, 0.782746320742002, -73.7213897705078, -1.28668098064143, 218, 40, 'PPL', 'P'),
(62468, 'Alder Branch', 36.2516708374023, 0.632711015461881, -76.0311126708984, -1.32699325006196, 218, 33, 'PPL', 'P'),
(84609, 'Alder Branch', 35.9216690063477, 0.626951396972366, -83.5550003051758, -1.45830986183018, 218, 50, 'PPL', 'P'),
(146743, 'Alder Brook', 44.5133285522461, 0.776904144258695, -73.9438934326172, -1.29056440214298, 218, 40, 'PPL', 'P'),
(194504, 'Alder City (historical)', 43.872501373291, 0.765719600049662, -113.519439697266, -1.98128798773644, 218, 17, 'PPL', 'P'),
(146744, 'Alder Creek', 43.4233283996582, 0.757880052748796, -75.2283325195313, -1.31298209325094, 218, 40, 'PPL', 'P'),
(179659, 'Alder Creek', 38.6347198486328, 0.674303066944248, -121.200561523438, -2.11534885384994, 218, 6, 'PPL', 'P'),
(194505, 'Alder Creek', 47.2227783203125, 0.824192963628851, -116.606666564941, -2.03517026133341, 218, 17, 'PPL', 'P'),
(200306, 'Alder Creek', 45.378059387207, 0.791996544472283, -122.100563049316, -2.1310568437495, 218, 43, 'PPL', 'P'),
(206660, 'Alder Grove', 46.9658317565918, 0.819708400090239, -123.637496948242, -2.15788140067127, 218, 56, 'PPL', 'P'),
(58432, 'Alder Grove (historical)', 33.1936111450195, 0.579337805107276, -90.9097213745117, -1.58667396005589, 218, 30, 'PPL', 'P'),
(84611, 'Alder Springs', 36.3691711425781, 0.634761782659296, -84.0063934326172, -1.46618815812491, 218, 50, 'PPL', 'P'),
(112730, 'Alder Springs', 34.3430595397949, 0.59939946417787, -86.2158279418945, -1.50475006491899, 218, 2, 'PPL', 'P'),
(179661, 'Alder Springs', 39.6511116027832, 0.692042449544293, -122.72444152832, -2.14194557734045, 218, 6, 'PPL', 'P'),
(997, 'Alderbranch', 31.6886100769043, 0.553070581222634, -95.4577789306641, -1.66605253898096, 218, 51, 'PPL', 'P'),
(143450, 'Alderbrook', 44.3266716003418, 0.773646365876228, -71.6969375610352, -1.25134762403686, 218, 36, 'PPL', 'P'),
(179663, 'Aldercroft Heights', 37.160831451416, 0.648578861605873, -121.967781066895, -2.12873936096891, 218, 6, 'PPL', 'P'),
(206661, 'Alderdale', 45.8349990844727, 0.799971646672634, -119.919723510742, -2.0929940133437, 218, 56, 'PPL', 'P'),
(14958, 'Alderene Park', 28.8111095428467, 0.502848722675433, -81.3658294677734, -1.42010162282887, 218, 12, 'PPL', 'P'),
(179662, 'Alderglen Springs', 38.8352813720703, 0.677803525881048, -123.051666259766, -2.14765672629813, 218, 6, 'PPL', 'P'),
(172869, 'Alderley', 43.2174987792969, 0.754287648175361, -88.4497222900391, -1.5437388764358, 218, 57, 'PPL', 'P'),
(14959, 'Alderman', 28.4902801513672, 0.497249193456946, -82.165283203125, -1.43405472272812, 218, 12, 'PPL', 'P'),
(14960, 'Aldermans Ford', 27.8622207641602, 0.486287489252125, -82.1458282470703, -1.43371516968914, 218, 12, 'PPL', 'P'),
(193339, 'Alderpoint', 40.1763916015625, 0.701210315017863, -123.610557556152, -2.15741121958081, 218, 6, 'PPL', 'P'),
(62469, 'Aldersgate', 34.7872200012207, 0.607151526636927, -77.4166717529297, -1.35117581802431, 218, 33, 'PPL', 'P'),
(74956, 'Alderson', 34.9000015258789, 0.609119935577632, -95.6916732788086, -1.67013476545789, 218, 42, 'PPL', 'P'),
(107934, 'Alderson', 37.725830078125, 0.658439947911191, -80.642219543457, -1.40747224714944, 218, 58, 'PPL', 'P'),
(206662, 'Alderton', 47.1697196960449, 0.823266915938803, -122.228057861328, -2.13328204799831, 218, 56, 'PPL', 'P'),
(200307, 'Aldervale', 45.7686080932617, 0.798812905282341, -123.843063354492, -2.16146921129182, 218, 43, 'PPL', 'P'),
(206663, 'Alderwood Manor', 47.8222198486328, 0.834655191971227, -122.280830383301, -2.13420310226132, 218, 56, 'PPL', 'P'),
(158587, 'Aldham', 40.0905609130859, 0.699712286904694, -75.5416717529297, -1.31845089454942, 218, 45, 'PPL', 'P'),
(99341, 'Aldie', 38.9755592346191, 0.680251836450185, -77.6416702270508, -1.35510278220969, 218, 53, 'PPL', 'P'),
(70455, 'Aldine', 39.5688896179199, 0.690607405190904, -75.2752838134766, -1.31380154791836, 218, 37, 'PPL', 'P'),
(92171, 'Aldine', 29.9322204589844, 0.522415799442086, -95.379997253418, -1.66469499261529, 218, 51, 'PPL', 'P'),
(122122, 'Aldine', 41.2008285522461, 0.719090112786383, -86.6744384765625, -1.51275432873327, 218, 19, 'PPL', 'P'),
(44312, 'Aldino', 39.5638885498047, 0.690520120086176, -76.1961135864258, -1.32987305930671, 218, 25, 'PPL', 'P'),
(18780, 'Aldora', 33.0519409179688, 0.576865193193192, -84.1758270263672, -1.46914533219934, 218, 13, 'PPL', 'P'),
(158588, 'Aldovin', 41.6172218322754, 0.726357546506073, -75.938606262207, -1.3253787086511, 218, 45, 'PPL', 'P'),
(18781, 'Aldreds', 32.9494400024414, 0.575076214730931, -82.3930587768555, -1.43803015644534, 218, 13, 'PPL', 'P'),
(53148, 'Aldrich', 37.5475006103516, 0.655327511545215, -93.554443359375, -1.63283306649164, 218, 29, 'PPL', 'P'),
(112717, 'Aldrich', 33.1074981689453, 0.57783485014609, -86.89111328125, -1.51653601748119, 218, 2, 'PPL', 'P'),
(133901, 'Aldrich', 46.3763885498047, 0.80942067537829, -94.936393737793, -1.65695265069421, 218, 28, 'PPL', 'P'),
(146746, 'Aldrich', 44.148609161377, 0.77053859004216, -75.1116714477539, -1.31094597343952, 218, 40, 'PPL', 'P'),
(124098, 'Aldrich Mills', 42.2819404602051, 0.737959075162785, -72.538330078125, -1.26603269376172, 218, 23, 'PPL', 'P'),
(26343, 'Aldridge', 37.5583305358887, 0.655516529403584, -89.4700012207031, -1.56154610306462, 218, 18, 'PPL', 'P'),
(58433, 'Aldridge', 33.3619384765625, 0.582275671263797, -90.9097213745117, -1.58667396005589, 218, 30, 'PPL', 'P'),
(107935, 'Aldridge', 39.3011093139648, 0.685933757214896, -77.9227828979492, -1.36000912388594, 218, 58, 'PPL', 'P'),
(112718, 'Aldridge', 33.7069396972656, 0.588297078488466, -87.241943359375, -1.5226591574595, 218, 2, 'PPL', 'P'),
(195850, 'Aldridge', 45.0869407653809, 0.786915566007548, -110.820831298828, -1.93418838596173, 218, 31, 'PPL', 'P'),
(112715, 'Aldridge Grove', 34.4230613708496, 0.600795759537399, -87.2405624389648, -1.52263505585163, 218, 2, 'PPL', 'P'),
(99342, 'Aldwyck', 37.7388916015625, 0.658667914500502, -77.879997253418, -1.35926237351628, 218, 53, 'PPL', 'P'),
(200308, 'Ale (historical)', 44.788890838623, 0.781713613450296, -122.851387023926, -2.14416119420934, 218, 43, 'PPL', 'P'),
(74958, 'Aledo', 35.827220916748, 0.625302966836635, -99.123893737793, -1.73003831312148, 218, 42, 'PPL', 'P'),
(92172, 'Aledo', 32.6958312988281, 0.570649907841165, -97.601936340332, -1.7034751454607, 218, 51, 'PPL', 'P'),
(118587, 'Aledo', 41.1997184753418, 0.719070738289453, -90.7491683959961, -1.58387178195691, 218, 18, 'PPL', 'P'),
(202836, 'Alegre Vista', 40.5944404602051, 0.708506644035381, -111.874168395996, -1.95257258644072, 218, 52, 'PPL', 'P'),
(92173, 'Alejandrenas', 26.7769393920898, 0.467345755998937, -99.1399993896484, -1.73031940977453, 218, 51, 'PPL', 'P'),
(212266, 'Aleknagik', 59.2730598449707, 1.03451005202638, -158.617782592773, -2.76840255845644, 218, 1, 'PPL', 'P'),
(212268, 'Aleksashkina', 57.7799987792969, 1.00845122049703, -152.355285644531, -2.65910136731352, 218, 1, 'PPL', 'P'),
(92174, 'Aleman', 31.6322193145752, 0.552086376752281, -98.0419387817383, -1.71115463678005, 218, 51, 'PPL', 'P'),
(179665, 'Alemandra', 39.1488914489746, 0.683277054290461, -121.686943054199, -2.12383781298262, 218, 6, 'PPL', 'P'),
(129465, 'Alembic', 43.5974998474121, 0.760919917975067, -84.668327331543, -1.47774108409173, 218, 27, 'PPL', 'P'),
(84612, 'Alena (historical)', 36.0763893127441, 0.62965177573868, -83.5069427490234, -1.45747109924486, 218, 50, 'PPL', 'P'),
(146745, 'Alene', 43.0122184753418, 0.75070483098185, -75.7372207641602, -1.32186386864441, 218, 40, 'PPL', 'P'),
(212267, 'Aleneva', 58.060001373291, 1.01333818767636, -152.909713745117, -2.66877796313432, 218, 1, 'PPL', 'P'),
(77774, 'Aleppo', 39.8238906860352, 0.695058013425617, -80.4463882446289, -1.40405434620644, 218, 45, 'PPL', 'P'),
(727, 'Alert', 36.2308311462402, 0.632347294236003, -78.2227783203125, -1.36524503174709, 218, 33, 'PPL', 'P'),
(29079, 'Alert', 39.1602783203125, 0.683475792686808, -85.6783294677734, -1.49536894682113, 218, 19, 'PPL', 'P'),
(71637, 'Alert', 39.3250007629395, 0.686350741662576, -84.7752838134766, -1.47960782685782, 218, 41, 'PPL', 'P'),
(58437, 'Ales (historical)', 34.0244407653809, 0.593838517505676, -88.3944396972656, -1.54277401317286, 218, 30, 'PPL', 'P'),
(44313, 'Alesia', 39.6830596923828, 0.692600048897528, -76.8291702270508, -1.34092198203724, 218, 25, 'PPL', 'P'),
(44314, 'Alesia Heights', 39.6847190856934, 0.692629010774383, -76.8219375610352, -1.34079574820157, 218, 25, 'PPL', 'P'),
(179664, 'Alessandro', 33.8861083984375, 0.591424162240437, -117.269439697266, -2.04673783468623, 218, 6, 'PPL', 'P'),
(58434, 'Alesville', 34.3650016784668, 0.599782426742623, -89.6041717529297, -1.56388782061112, 218, 30, 'PPL', 'P'),
(126743, 'Alewife', 43.4527816772461, 0.758394109418208, -70.6102828979492, -1.23238192233386, 218, 26, 'PPL', 'P'),
(146756, 'Alewife Brook Landing', 41.0322189331055, 0.716147319781845, -72.2399978637695, -1.26082581435645, 218, 40, 'PPL', 'P'),
(74959, 'Alex', 34.9147186279297, 0.60937679746477, -97.7783279418945, -1.70655375968083, 218, 42, 'PPL', 'P'),
(195851, 'Alex Boggio Place', 45.3158302307129, 0.790910440800722, -109.436943054199, -1.91003497961332, 218, 31, 'PPL', 'P'),
(92176, 'Alex Cavazos Colonia', 26.2600002288818, 0.458323465568453, -98.3420028686523, -1.71639174306369, 218, 51, 'PPL', 'P'),
(7048, 'Alexander', 34.6294403076172, 0.604397751490758, -92.4411087036133, -1.61340171107204, 218, 4, 'PPL', 'P'),
(18783, 'Alexander', 33.0219383239746, 0.576341549143855, -81.8769378662109, -1.4290221472162, 218, 13, 'PPL', 'P'),
(26344, 'Alexander', 39.7244415283203, 0.693322298185158, -90.0380630493164, -1.57146065232882, 218, 18, 'PPL', 'P'),
(31620, 'Alexander', 38.4694404602051, 0.671418397430501, -99.5527801513672, -1.73752379315542, 218, 20, 'PPL', 'P'),
(92175, 'Alexander', 32.0588912963867, 0.559533207660902, -98.2058334350586, -1.71401513810691, 218, 51, 'PPL', 'P'),
(107936, 'Alexander', 38.7827796936035, 0.676887198728979, -80.2227783203125, -1.40015161678698, 218, 58, 'PPL', 'P'),
(114375, 'Alexander', 42.8058280944824, 0.747102639291409, -93.4763870239258, -1.63147072643601, 218, 16, 'PPL', 'P'),
(126744, 'Alexander', 45.0886116027832, 0.786944727621485, -67.4688873291016, -1.17755422654991, 218, 26, 'PPL', 'P'),
(146747, 'Alexander', 42.9011116027832, 0.748765650234109, -78.2569427490234, -1.36584131351516, 218, 40, 'PPL', 'P'),
(154034, 'Alexander', 41.3563919067383, 0.721805205517719, -81.5961074829102, -1.42412073238797, 218, 41, 'PPL', 'P'),
(194506, 'Alexander', 42.6511116027832, 0.744402327104123, -111.70832824707, -1.94967812980996, 218, 17, 'PPL', 'P'),
(197917, 'Alexander', 47.8430595397949, 0.835018913197104, -103.642219543457, -1.80889797510814, 218, 34, 'PPL', 'P'),
(58435, 'Alexander (historical)', 32.8675003051758, 0.573646097225558, -91.0827789306641, -1.58969438420621, 218, 30, 'PPL', 'P'),
(206664, 'Alexander Beach', 48.4752807617188, 0.846053255120657, -122.658889770508, -2.14080148333615, 218, 56, 'PPL', 'P'),
(112720, 'Alexander City', 32.9438896179199, 0.574979342246279, -85.9538879394531, -1.5001783494337, 218, 2, 'PPL', 'P'),
(99343, 'Alexander Corner', 36.814998626709, 0.642542940153263, -76.3566665649414, -1.3326752374057, 218, 53, 'PPL', 'P'),
(79503, 'Alexander Crossroads', 34.1969413757324, 0.59684922111801, -79.9305572509766, -1.39505139698337, 218, 48, 'PPL', 'P'),
(84613, 'Alexander Mill', 36.1375007629395, 0.630718371755256, -82.7594375610352, -1.44442467253873, 218, 50, 'PPL', 'P'),
(62471, 'Alexander Mills', 35.3105583190918, 0.616285503385626, -81.85888671875, -1.42870709525924, 218, 33, 'PPL', 'P'),
(188017, 'Alexander Place', 34.6861114501953, 0.605386849519613, -106.253608703613, -1.85447531400376, 218, 38, 'PPL', 'P'),
(14963, 'Alexander Springs', 29.0799999237061, 0.50754174514837, -81.5783309936523, -1.42381047412097, 218, 12, 'PPL', 'P'),
(84614, 'Alexander Springs', 35.3772201538086, 0.617448971886855, -87.269172668457, -1.52313439855602, 218, 50, 'PPL', 'P'),
(158590, 'Alexander Springs', 40.6283302307129, 0.709098132113487, -77.6744384765625, -1.35567469605378, 218, 45, 'PPL', 'P'),
(99344, 'Alexanders Corner', 37.586669921875, 0.656011144997039, -77.2233276367188, -1.34780132660707, 218, 53, 'PPL', 'P'),
(18784, 'Alexanders Mill', 34.9738883972168, 0.610409504756475, -83.8819427490234, -1.46401608393984, 218, 13, 'PPL', 'P'),
(92177, 'Alexanders Store', 31.6169300079346, 0.551819528011055, -93.9264678955078, -1.63932611954536, 218, 51, 'PPL', 'P'),
(212271, 'Alexanders Village', 66.788330078125, 1.16567626177204, -145.436935424805, -2.53835337717322, 218, 1, 'PPL', 'P'),
(34525, 'Alexandria', 38.8230590820313, 0.677590206677733, -84.4280624389648, -1.47354767063929, 218, 21, 'PPL', 'P'),
(39061, 'Alexandria', 31.3111095428467, 0.546481953975291, -92.4449996948242, -1.61346962167984, 218, 22, 'PPL', 'P'),
(84615, 'Alexandria', 36.0774993896484, 0.62967115023561, -86.033332824707, -1.50156492425525, 218, 50, 'PPL', 'P'),
(99345, 'Alexandria', 38.8047218322754, 0.677270161293732, -77.0472183227539, -1.34472763923496, 218, 53, 'PPL', 'P'),
(112723, 'Alexandria', 33.7738914489746, 0.589465606995765, -85.8855590820313, -1.49898578589756, 218, 2, 'PPL', 'P'),
(122123, 'Alexandria', 40.2627792358398, 0.702718063669012, -85.6758270263672, -1.49532527097925, 218, 19, 'PPL', 'P'),
(133904, 'Alexandria', 45.8852806091309, 0.800849224830843, -95.3772201538086, -1.66464652308345, 218, 28, 'PPL', 'P'),
(139005, 'Alexandria', 40.3594398498535, 0.70440510964055, -91.4552764892578, -1.59619569305931, 218, 29, 'PPL', 'P'),
(141145, 'Alexandria', 40.2452812194824, 0.702412665671007, -97.3888931274414, -1.69975683994673, 218, 35, 'PPL', 'P'),
(143451, 'Alexandria', 43.6113891601563, 0.761162332213291, -71.793327331543, -1.25302994289746, 218, 36, 'PPL', 'P'),
(154035, 'Alexandria', 40.0888900756836, 0.699683125290757, -82.6125030517578, -1.44186018156704, 218, 41, 'PPL', 'P'),
(158600, 'Alexandria', 40.5563888549805, 0.707842518238542, -78.0980606079102, -1.36306829703012, 218, 45, 'PPL', 'P'),
(169707, 'Alexandria', 43.6536102294922, 0.761899228886916, -97.7825012207031, -1.70662659713664, 218, 49, 'PPL', 'P'),
(146749, 'Alexandria Bay', 44.3358306884766, 0.77380622212066, -75.9180603027344, -1.32502011401032, 218, 40, 'PPL', 'P'),
(146750, 'Alexandria Center', 44.3074989318848, 0.77331173968526, -75.8763885498047, -1.32429280471662, 218, 40, 'PPL', 'P'),
(39058, 'Alexandria Junction', 31.2908306121826, 0.54612801986642, -92.4433288574219, -1.6134404600659, 218, 22, 'PPL', 'P'),
(133905, 'Alexandria Mobile Estates', 45.8886108398438, 0.800907348321634, -95.3766708374023, -1.66463693570353, 218, 28, 'PPL', 'P'),
(144722, 'Alexauken', 40.3894386291504, 0.704928687110859, -74.9394378662109, -1.30793993035909, 218, 37, 'PPL', 'P'),
(402, 'Alexis', 30.7419395446777, 0.536548063503673, -82.9186096191406, -1.44720274902985, 218, 13, 'PPL', 'P'),
(62472, 'Alexis', 35.3997192382813, 0.617841654989587, -81.1180572509766, -1.4157771818508, 218, 33, 'PPL', 'P'),
(71640, 'Alexis', 39.6363906860352, 0.691785521078128, -81.0313873291016, -1.41426450635164, 218, 41, 'PPL', 'P'),
(112726, 'Alexis', 34.1788902282715, 0.596534169161054, -85.5122222900391, -1.49246982965847, 218, 2, 'PPL', 'P'),
(118588, 'Alexis', 41.0633316040039, 0.716690338328112, -90.5558319091797, -1.58049742369773, 218, 18, 'PPL', 'P'),
(154036, 'Alexis Addition', 41.7197189331055, 0.728146458389306, -83.5269393920898, -1.45782010650572, 218, 41, 'PPL', 'P'),
(118589, 'Alexis Junction', 41.0672187805176, 0.716758182356882, -90.6383285522461, -1.58193726174108, 218, 18, 'PPL', 'P'),
(92178, 'Aley', 32.3216094970703, 0.564118505267745, -96.2568588256836, -1.67999911413554, 218, 51, 'PPL', 'P'),
(7050, 'Alf', 34.4897193908691, 0.6019591614596, -93.8702774047852, -1.63834541047394, 218, 4, 'PPL', 'P'),
(179666, 'Alfac (historical)', 36.0319404602051, 0.628875996913139, -119.307220458984, -2.08230381841202, 218, 6, 'PPL', 'P'),
(39059, 'Alfalfa', 31.3694400787354, 0.547500013881001, -92.6183319091797, -1.61649483952011, 218, 22, 'PPL', 'P'),
(74961, 'Alfalfa', 35.2188911437988, 0.614685609360761, -98.6069412231445, -1.7210157896644, 218, 42, 'PPL', 'P'),
(112725, 'Alfalfa', 32.5102806091309, 0.567411437376601, -87.7644424438477, -1.5317784868222, 218, 2, 'PPL', 'P'),
(191058, 'Alfalfa', 31.7552795410156, 0.554234182881916, -106.38111114502, -1.85670065141063, 218, 51, 'PPL', 'P'),
(200309, 'Alfalfa', 44.0774993896484, 0.769297490395156, -121.015830993652, -2.11212469787623, 218, 43, 'PPL', 'P'),
(206665, 'Alfalfa', 46.3305587768555, 0.808620794944885, -120.237777709961, -2.09854510631987, 218, 56, 'PPL', 'P'),
(53150, 'Alfalfa Center', 36.9630584716797, 0.645127071937994, -89.2072219848633, -1.55695974019334, 218, 29, 'PPL', 'P'),
(141148, 'Alfalfa Center', 40.6922187805176, 0.710213197661903, -99.1788864135742, -1.73099811637834, 218, 35, 'PPL', 'P'),
(158593, 'Alfarata', 40.6624984741211, 0.709694480460583, -77.4572219848633, -1.351883553084, 218, 45, 'PPL', 'P'),
(31624, 'Alfmil', 39.1319389343262, 0.682981177093353, -97.7219390869141, -1.70556958849999, 218, 20, 'PPL', 'P'),
(99347, 'Alfonso', 37.8086090087891, 0.659884712802559, -76.5083312988281, -1.33532228637118, 218, 53, 'PPL', 'P'),
(29080, 'Alfont', 39.9513893127441, 0.69728328425346, -85.8147201538086, -1.49774941336149, 218, 19, 'PPL', 'P'),
(14964, 'Alford', 30.6936092376709, 0.535704540517904, -85.392219543457, -1.49037538661917, 218, 12, 'PPL', 'P'),
(29081, 'Alford', 38.4913902282715, 0.671801493153309, -87.2427825927734, -1.52267380484549, 218, 19, 'PPL', 'P'),
(124099, 'Alford', 42.2355613708496, 0.737149607349455, -73.4138870239258, -1.28131404525465, 218, 23, 'PPL', 'P'),
(133908, 'Alford', 46.6319389343262, 0.813880870992928, -92.3833312988281, -1.61239330512528, 218, 28, 'PPL', 'P'),
(158594, 'Alford', 41.8066711425781, 0.729664060736488, -75.7750015258789, -1.32252326733031, 218, 45, 'PPL', 'P'),
(39060, 'Alford Acres', 30.5233306884766, 0.532732619188944, -91.0097198486328, -1.58841926267628, 218, 22, 'PPL', 'P'),
(193340, 'Alford Place', 40.2183303833008, 0.701942284843472, -122.665557861328, -2.14091786347579, 218, 6, 'PPL', 'P'),
(18785, 'Alfords', 31.4622192382813, 0.54911931569231, -83.9238891601563, -1.46474818692351, 218, 13, 'PPL', 'P'),
(39062, 'Alfords', 30.5691699981689, 0.533532666069917, -91.3188934326172, -1.593815359677, 218, 22, 'PPL', 'P'),
(29082, 'Alfordsville', 38.5605583190918, 0.673008704075442, -86.9483337402344, -1.51753470288997, 218, 19, 'PPL', 'P'),
(62473, 'Alfordsville', 34.5800018310547, 0.603534887297572, -79.3186111450195, -1.38437092258966, 218, 33, 'PPL', 'P'),
(171683, 'Alfrecha', 43.5641708374023, 0.760338217013966, -72.9730606079102, -1.27362017286541, 218, 55, 'PPL', 'P'),
(71641, 'Alfred', 39.1725006103516, 0.683689111890123, -81.9211120605469, -1.42979313235178, 218, 41, 'PPL', 'P'),
(92179, 'Alfred', 27.8802795410156, 0.486602674367136, -97.9844436645508, -1.71015115768131, 218, 51, 'PPL', 'P'),
(113088, 'Alfred', 43.476390838623, 0.758806167017871, -70.7188873291016, -1.23427742723972, 218, 26, 'PPL', 'P'),
(129479, 'Alfred', 46.0838890075684, 0.80431559530569, -87.6324996948242, -1.52947565142761, 218, 27, 'PPL', 'P'),
(139579, 'Alfred', 46.6030616760254, 0.81337686775663, -98.998893737793, -1.72785665155648, 218, 34, 'PPL', 'P'),
(146752, 'Alfred', 42.2541694641113, 0.737474379844391, -77.7908325195313, -1.3577061553333, 218, 40, 'PPL', 'P'),
(92180, 'Alfred Acres Colonia', 27.886999130249, 0.48671995332364, -97.9779968261719, -1.71003863912525, 218, 51, 'PPL', 'P'),
(92181, 'Alfred Hilltop Estates Colonia', 27.9080009460449, 0.487086504158176, -97.9609985351563, -1.70974196297982, 218, 51, 'PPL', 'P'),
(126746, 'Alfred Mills', 43.4638900756836, 0.758587987545566, -70.7024993896484, -1.23399140373865, 218, 26, 'PPL', 'P'),
(146753, 'Alfred Station', 42.269718170166, 0.73774575595947, -77.7594375610352, -1.35715820993901, 218, 40, 'PPL', 'P'),
(92182, 'Alfredo Garza Colonia', 26.2229995727539, 0.457677682293622, -97.4879989624023, -1.70148656307474, 218, 51, 'PPL', 'P'),
(7052, 'Alfrey', 34.8288917541504, 0.607878835930628, -91.1549987792969, -1.59095485835014, 218, 4, 'PPL', 'P'),
(129466, 'Algansee', 41.8325004577637, 0.730114867330011, -84.8808288574219, -1.48144993538383, 218, 27, 'PPL', 'P'),
(79504, 'Algary (historical)', 34.3655586242676, 0.599792147280602, -82.279167175293, -1.4360423730077, 218, 48, 'PPL', 'P'),
(34526, 'Alger', 37.313060760498, 0.65123576426739, -83.7316665649414, -1.46139326974028, 218, 21, 'PPL', 'P'),
(129468, 'Alger', 44.125560760498, 0.770136319559504, -84.1211090087891, -1.46819032263243, 218, 27, 'PPL', 'P'),
(133910, 'Alger', 47.1472206115723, 0.822874232836071, -91.692497253418, -1.600335976448, 218, 28, 'PPL', 'P'),
(154037, 'Alger', 40.7061080932617, 0.710455611900128, -83.8438873291016, -1.46335189156398, 218, 41, 'PPL', 'P'),
(206666, 'Alger', 48.6199989318848, 0.848579063677515, -122.339996337891, -2.135235742974, 218, 56, 'PPL', 'P'),
(107937, 'Algeria (historical)', 39.4180603027344, 0.687974937032388, -81.0527801513672, -1.41463788153647, 218, 58, 'PPL', 'P'),
(124101, 'Algerie Four Corners', 42.2186088562012, 0.736853730152348, -73.0311126708984, -1.27463337250213, 218, 23, 'PPL', 'P'),
(179667, 'Algerine', 37.9111099243164, 0.66167369126482, -120.382217407227, -2.10106605460774, 218, 6, 'PPL', 'P'),
(92183, 'Algerita', 31.2277793884277, 0.545027568414485, -98.852783203125, -1.72530654165468, 218, 51, 'PPL', 'P'),
(18786, 'Algernon (historical)', 34.064998626709, 0.594546385723419, -83.7844390869141, -1.46231432400328, 218, 13, 'PPL', 'P'),
(124102, 'Algers Corner', 42.0105590820313, 0.733222576585052, -71.0666732788086, -1.24034743715428, 218, 23, 'PPL', 'P'),
(144724, 'Algers Mills', 40.1652793884277, 0.701016370311478, -74.0749969482422, -1.29285259015158, 218, 37, 'PPL', 'P'),
(29083, 'Algiers', 38.4872207641602, 0.671728722276523, -87.1750030517578, -1.52149082868928, 218, 19, 'PPL', 'P'),
(39063, 'Algiers', 29.9447193145752, 0.522633945624877, -90.0466690063477, -1.5716108546143, 218, 22, 'PPL', 'P'),
(171684, 'Algiers (historical)', 42.8166694641113, 0.747291856886859, -72.5666732788086, -1.2665273759342, 218, 55, 'PPL', 'P'),
(7053, 'Algoa', 35.5058288574219, 0.619693617211628, -91.1166687011719, -1.59028587228431, 218, 4, 'PPL', 'P'),
(92184, 'Algoa', 29.4022197723389, 0.513165542422291, -95.1691665649414, -1.66101530293713, 218, 51, 'PPL', 'P'),
(179668, 'Algodon (historical)', 38.9902801513672, 0.68050876491635, -121.541938781738, -2.12130701099872, 218, 6, 'PPL', 'P'),
(191059, 'Algodon Colonia', 31.6569995880127, 0.55251887411331, -106.302001953125, -1.85531993554347, 218, 51, 'PPL', 'P'),
(188019, 'Algodones', 35.3805618286133, 0.617507295114727, -106.478607177734, -1.85840227818913, 218, 38, 'PPL', 'P'),
(58438, 'Algoma', 34.1761093139648, 0.596485633050187, -89.0311126708984, -1.55388605282122, 218, 30, 'PPL', 'P'),
(99348, 'Algoma', 37.0558280944824, 0.646746207301735, -80.0875015258789, -1.39779059132257, 218, 53, 'PPL', 'P'),
(107938, 'Algoma', 37.4188919067383, 0.653082866220442, -81.4261093139648, -1.42115370461751, 218, 58, 'PPL', 'P'),
(172870, 'Algoma', 44.6088905334473, 0.778572015470384, -87.432502746582, -1.52598504618684, 218, 57, 'PPL', 'P'),
(194507, 'Algoma', 48.1969413757324, 0.841195316397216, -116.571113586426, -2.03454974479943, 218, 17, 'PPL', 'P'),
(200310, 'Algoma', 42.3472213745117, 0.739098442056148, -121.814437866211, -2.12606301723144, 218, 43, 'PPL', 'P'),
(99349, 'Algoma Park', 37.2208290100098, 0.649626016546492, -79.9944381713867, -1.39616632937373, 218, 53, 'PPL', 'P'),
(114376, 'Algona', 43.0699996948242, 0.751713303507636, -94.232780456543, -1.64467228227564, 218, 16, 'PPL', 'P'),
(206667, 'Algona', 47.2791709899902, 0.825177201388717, -122.250831604004, -2.13367952479101, 218, 56, 'PPL', 'P'),
(129471, 'Algonac', 42.6183280944824, 0.743830146943919, -82.5311126708984, -1.44043965144159, 218, 27, 'PPL', 'P'),
(44315, 'Algonquin', 38.5827789306641, 0.673396526909185, -76.1061096191406, -1.32830219373773, 218, 25, 'PPL', 'P'),
(118590, 'Algonquin', 42.1655616760254, 0.735927882199382, -88.2941665649414, -1.54102391686252, 218, 18, 'PPL', 'P'),
(107939, 'Algonquin (historical)', 37.452220916748, 0.653664567181543, -81.2997207641602, -1.4189478082866, 218, 58, 'PPL', 'P'),
(99350, 'Algonquin Hills', 38.6863899230957, 0.675204879868376, -77.4272232055664, -1.35135997561369, 218, 53, 'PPL', 'P'),
(99351, 'Algonquin Park', 36.9086112976074, 0.644176789482026, -76.2930603027344, -1.3315650987053, 218, 53, 'PPL', 'P'),
(84616, 'Algood', 36.1958312988281, 0.631736431660966, -85.4486083984375, -1.49135955780001, 218, 50, 'PPL', 'P'),
(179669, 'Algoso', 35.3597183227539, 0.617143507309823, -118.924171447754, -2.07561835196954, 218, 6, 'PPL', 'P'),
(99352, 'Algren', 36.7747192382813, 0.641839932204509, -76.4466705322266, -1.33424610297468, 218, 53, 'PPL', 'P'),
(26347, 'Alhambra', 38.8883285522461, 0.678729373834014, -89.7313919067383, -1.56610823116998, 218, 18, 'PPL', 'P'),
(34527, 'Alhambra', 38.4902801513672, 0.671782118656379, -83.945556640625, -1.4651263557983, 218, 21, 'PPL', 'P'),
(39064, 'Alhambra', 30.1763896942139, 0.526677356528917, -91.1230621337891, -1.59039745873399, 218, 22, 'PPL', 'P'),
(58440, 'Alhambra', 33.0277786254883, 0.576443481634578, -91.0599975585938, -1.58929677425546, 218, 30, 'PPL', 'P'),
(99353, 'Alhambra', 37.7866706848145, 0.659501816816833, -79.0899963378906, -1.38038084148645, 218, 53, 'PPL', 'P'),
(179670, 'Alhambra', 34.0952796936035, 0.595074890041745, -118.126106262207, -2.06168948683621, 218, 6, 'PPL', 'P'),
(193001, 'Alhambra', 33.4983291625977, 0.584656137804164, -112.133613586426, -1.95710075924218, 218, 5, 'PPL', 'P'),
(195852, 'Alhambra', 46.4513893127441, 0.810729685633091, -111.987503051758, -1.95455064934037, 218, 31, 'PPL', 'P'),
(188020, 'Alhambra (historical)', 32.7213897705078, 0.571095987323753, -108.509437561035, -1.89384695492727, 218, 38, 'PPL', 'P'),
(193000, 'Ali Ak Chin', 31.858060836792, 0.55602805490268, -112.540000915527, -1.96419355617339, 218, 5, 'PPL', 'P'),
(193002, 'Ali Chuk', 31.8150005340576, 0.55527651084306, -112.556106567383, -1.96447465282644, 218, 5, 'PPL', 'P'),
(193004, 'Ali Chukson', 31.913610458374, 0.556997578697523, -111.798606872559, -1.95125378906891, 218, 5, 'PPL', 'P'),
(193003, 'Ali Molina', 31.8999996185303, 0.556760024728288, -111.773612976074, -1.95081756328235, 218, 5, 'PPL', 'P'),
(193091, 'Ali Oidak', 32.3041687011719, 0.563814105955149, -112.025001525879, -1.95520512117826, 218, 5, 'PPL', 'P'),
(158595, 'Alica', 40.0080604553223, 0.698272382282315, -79.9286117553711, -1.39501744167947, 218, 45, 'PPL', 'P'),
(39065, 'Alice', 30.9197196960449, 0.539650912489724, -91.2975006103516, -1.59344198449217, 218, 22, 'PPL', 'P'),
(53151, 'Alice', 37.2983283996582, 0.650978636064143, -92.188606262207, -1.60899471210018, 218, 29, 'PPL', 'P'),
(58439, 'Alice', 32.910831451416, 0.574402368396114, -89.2799987792969, -1.55822993487525, 218, 30, 'PPL', 'P'),
(71642, 'Alice', 39.021110534668, 0.681046856614601, -82.3727798461914, -1.43767622233647, 218, 41, 'PPL', 'P'),
(92186, 'Alice', 27.7519397735596, 0.484362722863784, -98.0694427490234, -1.71163467156654, 218, 51, 'PPL', 'P'),
(107940, 'Alice', 38.997501373291, 0.680634799014939, -80.8161087036133, -1.4105071855277, 218, 58, 'PPL', 'P'),
(112728, 'Alice', 34.1291694641113, 0.595666378119851, -86.2402801513672, -1.50517683648367, 218, 2, 'PPL', 'P'),
(114378, 'Alice', 42.1974983215332, 0.736485281815535, -91.695556640625, -1.60038937282786, 218, 16, 'PPL', 'P'),
(139580, 'Alice', 46.7619400024414, 0.816149817662648, -97.5555572509766, -1.70266567764737, 218, 34, 'PPL', 'P'),
(146755, 'Alice', 42.0208282470703, 0.733401807326414, -77.6141662597656, -1.3546227474232, 218, 40, 'PPL', 'P'),
(158597, 'Alice', 40.1641693115234, 0.700996995814548, -79.4599990844727, -1.38683860765573, 218, 45, 'PPL', 'P'),
(186323, 'Alice', 39.8183288574219, 0.694960941203884, -105.642219543457, -1.84380456014803, 218, 7, 'PPL', 'P'),
(195853, 'Alice (historical)', 46.9472198486328, 0.819383561016277, -107.578330993652, -1.8775960796395, 218, 31, 'PPL', 'P'),
(92187, 'Alice Acres', 27.7283306121826, 0.483950665264122, -98.1144409179688, -1.712420037772, 218, 51, 'PPL', 'P'),
(92188, 'Alice Acres Colonia', 27.7250003814697, 0.483892541773331, -98.1179962158203, -1.7124820894254, 218, 51, 'PPL', 'P'),
(39066, 'Alice B', 29.7761096954346, 0.519691152620339, -91.7569427490234, -1.6014607625344, 218, 22, 'PPL', 'P'),
(18789, 'Alice Ingram Subdivision', 32.5286102294922, 0.567731349602547, -83.892219543457, -1.46419544783926, 218, 13, 'PPL', 'P'),
(200311, 'Alicel', 45.4044418334961, 0.792457005024758, -117.978889465332, -2.0591200690165, 218, 43, 'PPL', 'P'),
(34528, 'Aliceton', 37.5908317565918, 0.656083782715771, -85.0299987792969, -1.48405344166549, 218, 21, 'PPL', 'P'),
(31625, 'Aliceville', 38.1544418334961, 0.665920634255169, -95.5516662597656, -1.66769118199969, 218, 20, 'PPL', 'P'),
(112727, 'Aliceville', 33.1294403076172, 0.578217812710843, -88.1513900756836, -1.53853199703053, 218, 2, 'PPL', 'P'),
(118592, 'Aliceville', 41.5522193908691, 0.725223039881699, -89.8794403076172, -1.56869216321762, 218, 18, 'PPL', 'P'),
(7054, 'Alicia', 35.8930587768555, 0.626452054267977, -91.0827789306641, -1.58969438420621, 218, 4, 'PPL', 'P'),
(129473, 'Alicia', 43.2708282470703, 0.755218422976343, -84.0325012207031, -1.46664382498742, 218, 27, 'PPL', 'P'),
(179671, 'Alicia', 39.1027793884277, 0.682472247009039, -121.580558776855, -2.12198105707062, 218, 6, 'PPL', 'P'),
(179672, 'Alico', 36.5697212219238, 0.638262041859015, -117.962219238281, -2.05882911866741, 218, 6, 'PPL', 'P'),
(31626, 'Alida', 39.0958290100098, 0.682350940021386, -96.9400024414063, -1.69192221949388, 218, 20, 'PPL', 'P'),
(122124, 'Alida', 41.5105590820313, 0.72449593032508, -86.9030609130859, -1.51674454299454, 218, 19, 'PPL', 'P'),
(133911, 'Alida', 47.3836097717285, 0.827000001996821, -95.2344436645508, -1.66215460325147, 218, 28, 'PPL', 'P'),
(92189, 'Alief', 29.7108306884766, 0.51855181901649, -95.5961074829102, -1.66846682766717, 218, 51, 'PPL', 'P'),
(211459, 'Alii Kai', 19.6155605316162, 0.342356115900952, -155.978057861328, -2.7223306705464, 218, 15, 'PPL', 'P'),
(154038, 'Alikanna', 40.3875007629395, 0.704894864965015, -80.6361083984375, -1.40736558754779, 218, 41, 'PPL', 'P'),
(74966, 'Alikchi', 34.1627807617188, 0.596253005928969, -95.0688934326172, -1.65926520662678, 218, 42, 'PPL', 'P'),
(179673, 'Alimur Park Mobile Home Park', 36.9866714477539, 0.645539196116684, -121.960563659668, -2.12861339344935, 218, 6, 'PPL', 'P'),
(158598, 'Alinda', 40.3463897705078, 0.704177342788321, -77.2847213745117, -1.34887284947167, 218, 45, 'PPL', 'P'),
(18787, 'Aline', 32.3608283996582, 0.564803004246923, -82.1605606079102, -1.43397229789239, 218, 13, 'PPL', 'P'),
(39067, 'Aline', 30.6130599975586, 0.534298691067965, -91.64111328125, -1.59943915695092, 218, 22, 'PPL', 'P'),
(74967, 'Aline', 36.5097198486328, 0.637214820339368, -98.4486083984375, -1.71825236055928, 218, 42, 'PPL', 'P'),
(158599, 'Aline', 40.6805610656738, 0.710009732154621, -76.9875030517578, -1.34368541114236, 218, 45, 'PPL', 'P'),
(18788, 'Aline Estates', 33.6624984741211, 0.58752143282098, -84.7986068725586, -1.48001489103044, 218, 13, 'PPL', 'P'),
(158602, 'Aliquippa', 40.6366691589355, 0.70924367386706, -80.2402801513672, -1.40045708136401, 218, 45, 'PPL', 'P'),
(188021, 'Alire', 36.476390838623, 0.636633119378268, -106.580276489258, -1.86017674242345, 218, 38, 'PPL', 'P'),
(13271, 'Alisa Estates', 39.3461112976074, 0.686719189999388, -75.6383285522461, -1.32013787394193, 218, 10, 'PPL', 'P'),
(179675, 'Aliso', 33.7269401550293, 0.588646152328348, -117.832221984863, -2.05656023857671, 218, 6, 'PPL', 'P'),
(179676, 'Aliso Viejo', 33.6083297729492, 0.586576010634002, -117.744438171387, -2.05502812200159, 218, 6, 'PPL', 'P'),
(188022, 'Alivio', 32.836669921875, 0.573108005527308, -107.020278930664, -1.8678562337428, 218, 38, 'PPL', 'P'),
(7055, 'Alix', 35.4247207641602, 0.618278013934196, -93.7302780151367, -1.63590196017379, 218, 4, 'PPL', 'P'),
(191060, 'Aljo Estates Colonia', 31.6229991912842, 0.551925455243413, -106.26000213623, -1.85458690045343, 218, 51, 'PPL', 'P'),
(99359, 'Alka (historical)', 37.0311088562012, 0.646314775205142, -82.4741668701172, -1.43944575972277, 218, 53, 'PPL', 'P'),
(197921, 'Alkabo', 48.8627815246582, 0.852816419287941, -103.889717102051, -1.81321762239625, 218, 34, 'PPL', 'P'),
(189859, 'Alkali', 37.8258285522461, 0.660185250531574, -117.336669921875, -2.04791122346252, 218, 39, 'PPL', 'P'),
(112729, 'Alkehatchee (historical)', 32.8666687011719, 0.573631582997618, -85.9097213745117, -1.49940749745618, 218, 2, 'PPL', 'P'),
(206668, 'Alki', 47.5763893127441, 0.830364639718027, -122.40860748291, -2.13643323335815, 218, 56, 'PPL', 'P'),
(107941, 'Alkires Mills', 38.978328704834, 0.68030017282397, -80.4516677856445, -1.40414649158015, 218, 58, 'PPL', 'P'),
(107942, 'Alkol', 38.1627807617188, 0.666066176008742, -81.9250030517578, -1.42986104295958, 218, 58, 'PPL', 'P'),
(53152, 'All', 37.1805610656738, 0.64892320833482, -93.0358276367188, -1.62378151457868, 218, 29, 'PPL', 'P'),
(53153, 'All Saints Village', 38.7605590820313, 0.676499375895236, -90.6613922119141, -1.58233979853985, 218, 29, 'PPL', 'P'),
(179678, 'Alla', 33.9811096191406, 0.59308224633512, -118.428886413574, -2.06697399738725, 218, 6, 'PPL', 'P'),
(146757, 'Allaben', 42.1166687011719, 0.735074538807093, -74.3708267211914, -1.29801579371497, 218, 40, 'PPL', 'P'),
(126748, 'Allagash', 47.0833282470703, 0.821759100708627, -69.0416717529297, -1.20500449316979, 218, 26, 'PPL', 'P'),
(193005, 'Allah', 33.9280586242676, 0.592156331803127, -112.690002441406, -1.96681157668299, 218, 5, 'PPL', 'P'),
(144725, 'Allaire', 40.1583290100098, 0.700895063323825, -74.1258316040039, -1.29373982226874, 218, 37, 'PPL', 'P'),
(34529, 'Allais', 37.2666702270508, 0.650426096716979, -83.1822204589844, -1.45180362612907, 218, 21, 'PPL', 'P'),
(212272, 'Allakaket', 66.565559387207, 1.16178817973858, -152.645553588867, -2.66416749865518, 218, 1, 'PPL', 'P'),
(191061, 'Allamoore', 31.0780601501465, 0.5424144747529, -105.003059387207, -1.8326491109739, 218, 51, 'PPL', 'P'),
(144726, 'Allamuchy', 40.9216690063477, 0.714217859572083, -74.8105621337891, -1.30569062450241, 218, 37, 'PPL', 'P'),
(193093, 'Allan Lake Landing', 34.8252792358398, 0.60781578559182, -111.435829162598, -1.94492212357724, 218, 5, 'PPL', 'P'),
(44316, 'Allana Acres', 39.7136116027832, 0.693133280326789, -76.915283203125, -1.34242493699842, 218, 25, 'PPL', 'P'),
(14965, 'Allandale', 29.1213893890381, 0.508264127594054, -80.9766693115234, -1.41330949678473, 218, 12, 'PPL', 'P'),
(44317, 'Allandale', 39.6286087036133, 0.691649699862533, -77.0647201538086, -1.34503310381199, 218, 25, 'PPL', 'P'),
(71643, 'Allandale (historical)', 39.2011108398438, 0.684188454594513, -84.3397216796875, -1.47200583352619, 218, 41, 'PPL', 'P'),
(133912, 'Allansons Park', 44.5283317565918, 0.777165999572877, -93.9075012207031, -1.63899508862186, 218, 28, 'PPL', 'P'),
(14966, 'Allanton', 30.0313892364502, 0.524146621124042, -85.4577789306641, -1.49151961378153, 218, 12, 'PPL', 'P'),
(44318, 'Allanwood', 39.1105613708496, 0.682608068224633, -77.0366668701172, -1.34454348164558, 218, 25, 'PPL', 'P'),
(14967, 'Allapattah', 25.8141708374023, 0.450542274784973, -80.2241668701172, -1.4001758515529, 218, 12, 'PPL', 'P'),
(195854, 'Allard', 47.038890838623, 0.820983521620169, -104.566673278809, -1.82503273657238, 218, 31, 'PPL', 'P'),
(195855, 'Allard (historical)', 47.7483291625977, 0.833365556213356, -114.023612976074, -1.99008747145223, 218, 31, 'PPL', 'P'),
(84618, 'Allardt', 36.3808288574219, 0.634965248166578, -84.8844375610352, -1.48151291914361, 218, 50, 'PPL', 'P'),
(18790, 'Allatoona', 34.1080589294434, 0.595297929783039, -84.7113876342773, -1.47849262815135, 218, 13, 'PPL', 'P'),
(18791, 'Allatoona Bay', 34.0486106872559, 0.594260362222344, -84.7238922119141, -1.47871087420268, 218, 13, 'PPL', 'P'),
(18792, 'Allatoona Beach', 34.1108283996582, 0.595346266156824, -84.7074966430664, -1.47842471754355, 218, 13, 'PPL', 'P'),
(18793, 'Allatoona Heights', 34.0558280944824, 0.594386329741905, -84.7399978637695, -1.47899197085574, 218, 13, 'PPL', 'P'),
(18794, 'Allatoona Pass', 34.1150016784668, 0.595419103612638, -84.5994415283203, -1.47653880001761, 218, 13, 'PPL', 'P'),
(18796, 'Allatoona Ridge', 34.0433311462402, 0.594168216848627, -84.7002792358398, -1.47829875002399, 218, 13, 'PPL', 'P'),
(53154, 'Allbright', 37.3288917541504, 0.651512067230486, -90.2266693115234, -1.57475245259421, 218, 29, 'PPL', 'P'),
(7057, 'Allbrook', 33.7999992370605, 0.589921273858278, -93.8886108398438, -1.63866538927891, 218, 4, 'PPL', 'P'),
(71644, 'Alledonia', 39.898609161377, 0.696362096832401, -80.9694366455078, -1.41318326294906, 218, 41, 'PPL', 'P'),
(7058, 'Alleene', 33.7700004577637, 0.589397696387968, -94.2602767944336, -1.64515218390407, 218, 4, 'PPL', 'P'),
(129474, 'Allegan', 42.5291709899902, 0.742274061918986, -85.8552780151367, -1.49845728157924, 218, 27, 'PPL', 'P'),
(146758, 'Allegany', 42.0900001525879, 0.734609084827574, -78.4944381713867, -1.36998639059382, 218, 40, 'PPL', 'P'),
(200312, 'Allegany', 43.4261093139648, 0.757928588859663, -124.031112670898, -2.16475129101924, 218, 43, 'PPL', 'P'),
(44320, 'Allegany Grove', 39.6399993896484, 0.691848504837908, -78.8283309936523, -1.37581391969113, 218, 25, 'PPL', 'P'),
(99354, 'Alleghany', 37.7472190856934, 0.658813256516993, -80.2405624389648, -1.40046200821203, 218, 53, 'PPL', 'P'),
(179679, 'Alleghany', 39.4697189331055, 0.688876550219434, -120.842216491699, -2.10909455318794, 218, 6, 'PPL', 'P'),
(84619, 'Alleghany (historical)', 35.6650009155273, 0.622471693702744, -84.1983337402344, -1.46953814846012, 218, 50, 'PPL', 'P'),
(99358, 'Alleghany Springs', 37.128059387207, 0.648006881182751, -80.2652816772461, -1.40089344030862, 218, 53, 'PPL', 'P'),
(62477, 'Allegheny', 35.9883308410645, 0.628114865473595, -82.6675033569336, -1.44282011798196, 218, 33, 'PPL', 'P'),
(158603, 'Allegheny (historical)', 40.4505615234375, 0.705995482864518, -80.0163879394531, -1.39654942509654, 218, 45, 'PPL', 'P'),
(158604, 'Allegheny Acres', 40.6152801513672, 0.708870365261258, -79.8702774047852, -1.39399931519473, 218, 45, 'PPL', 'P'),
(158608, 'Allegheny Furnace', 40.4897193908691, 0.706678916579259, -78.4075012207031, -1.36846905456274, 218, 45, 'PPL', 'P'),
(158609, 'Allegheny Springs', 41.8266716003418, 0.73001313457637, -79.3041687011719, -1.38411885439248, 218, 45, 'PPL', 'P'),
(84620, 'Allegheny Springs (historical)', 35.5852813720703, 0.621080325191232, -84.0438919067383, -1.4668426299628, 218, 50, 'PPL', 'P'),
(158610, 'Allegheny West', 40.0083312988281, 0.69827710939325, -75.1783294677734, -1.31210937536172, 218, 45, 'PPL', 'P'),
(158617, 'Alleghenyville', 40.2341690063477, 0.702218720964622, -75.9888916015625, -1.32625635338833, 218, 45, 'PPL', 'P'),
(34530, 'Allegre', 36.9286117553711, 0.644525863321908, -87.2172164916992, -1.52222759220485, 218, 21, 'PPL', 'P'),
(114380, 'Alleman', 41.8199996948242, 0.729896687857706, -93.6113891601563, -1.63382695821046, 218, 16, 'PPL', 'P'),
(39068, 'Allemand', 29.6599998474121, 0.517664653478357, -90.7655563354492, -1.58415780545799, 218, 22, 'PPL', 'P'),
(39070, 'Allemania', 30.2611103057861, 0.528156010145156, -91.2183303833008, -1.59206020336058, 218, 22, 'PPL', 'P'),
(158618, 'Allemans', 40.7266693115234, 0.710814472857016, -78.404167175293, -1.36841086449292, 218, 45, 'PPL', 'P'),
(18798, 'Allen', 33.9455604553223, 0.592461796380159, -83.5438919067383, -1.45811598370283, 218, 13, 'PPL', 'P'),
(31627, 'Allen', 38.6561088562012, 0.67467637555005, -96.1694412231445, -1.67847338914703, 218, 20, 'PPL', 'P'),
(39071, 'Allen', 31.8352794647217, 0.555630444951931, -93.288330078125, -1.62818851355054, 218, 22, 'PPL', 'P'),
(44321, 'Allen', 38.2872200012207, 0.668238050456729, -75.6883316040039, -1.32101059183115, 218, 25, 'PPL', 'P'),
(58444, 'Allen', 31.7483291625977, 0.554112875894263, -90.658332824707, -1.58228640215999, 218, 30, 'PPL', 'P'),
(62478, 'Allen', 35.225830078125, 0.614806716611333, -80.6141662597656, -1.40698262498303, 218, 33, 'PPL', 'P'),
(74969, 'Allen', 34.8788909912109, 0.608751487240819, -96.4122161865234, -1.68271061159941, 218, 42, 'PPL', 'P'),
(79505, 'Allen', 33.9211082458496, 0.592035024815474, -79.0408325195313, -1.37952277098323, 218, 48, 'PPL', 'P'),
(84621, 'Allen', 35.435001373291, 0.618457444412641, -84.8522186279297, -1.48095059267944, 218, 50, 'PPL', 'P'),
(92190, 'Allen', 33.1030616760254, 0.577757418737396, -96.670280456543, -1.687214682793, 218, 51, 'PPL', 'P'),
(114381, 'Allen', 41.8050003051758, 0.729634899122552, -95.8183288574219, -1.67234532232071, 218, 16, 'PPL', 'P'),
(118593, 'Allen', 40.3050003051758, 0.703454960342637, -89.6494369506836, -1.56467784734849, 218, 18, 'PPL', 'P'),
(122125, 'Allen', 41.2000007629395, 0.719075665137469, -85.1958312988281, -1.48694776513819, 218, 19, 'PPL', 'P'),
(129478, 'Allen', 41.9569396972656, 0.732286741777998, -84.7677764892578, -1.47947679933219, 218, 27, 'PPL', 'P'),
(133913, 'Allen', 47.5163917541504, 0.829317484777408, -92.0986099243164, -1.60742397968925, 218, 28, 'PPL', 'P'),
(141150, 'Allen', 42.416389465332, 0.740305652978281, -96.8450012207031, -1.6902641353992, 218, 35, 'PPL', 'P'),
(158620, 'Allen', 41.8827781677246, 0.730992378909192, -78.5733337402344, -1.37136337803544, 218, 45, 'PPL', 'P'),
(172873, 'Allen', 44.6613883972168, 0.779488276043426, -91.3666687011719, -1.5946491954143, 218, 57, 'PPL', 'P'),
(179681, 'Allen', 38.6172218322754, 0.673997668946243, -120.109718322754, -2.09631004837502, 218, 6, 'PPL', 'P'),
(193239, 'Allen', 48.5166702270508, 0.846775637566341, -122.375831604004, -2.135861186356, 218, 56, 'PPL', 'P'),
(201854, 'Allen', 43.2808303833008, 0.755392993185798, -101.923889160156, -1.77890745228248, 218, 49, 'PPL', 'P'),
(107943, 'Allen (historical)', 38.122501373291, 0.665363168059988, -82.0755615234375, -1.43248878400716, 218, 58, 'PPL', 'P'),
(188023, 'Allen (historical)', 35.0122184753418, 0.611078490822303, -103.138061523438, -1.80009875770846, 218, 38, 'PPL', 'P'),
(195856, 'Allen (historical)', 47.0722198486328, 0.821565222581269, -106.484443664551, -1.85850414410083, 218, 31, 'PPL', 'P'),
(62479, 'Allen Acres', 35.3177795410156, 0.616411537484214, -81.5169372558594, -1.42273895125638, 218, 33, 'PPL', 'P'),
(146762, 'Allen Center', 42.3861083984375, 0.739777148659955, -78.0155563354492, -1.36162832582871, 218, 40, 'PPL', 'P'),
(154039, 'Allen Center', 40.2416687011719, 0.702349615332199, -83.4780578613281, -1.45696696285051, 218, 41, 'PPL', 'P'),
(92191, 'Allen Chapel', 31.3722190856934, 0.547548516702354, -95.1502838134766, -1.66068573675223, 218, 51, 'PPL', 'P'),
(34531, 'Allen City', 37.6094398498535, 0.656408555210706, -82.727783203125, -1.44387219977059, 218, 21, 'PPL', 'P'),
(146763, 'Allen Corners', 41.4705581665039, 0.723797782645316, -73.7491683959961, -1.28716580911788, 218, 40, 'PPL', 'P'),
(29085, 'Allen Crossing', 39.103889465332, 0.682491621505969, -85.3169403076172, -1.48906151609538, 218, 19, 'PPL', 'P'),
(53155, 'Allen Ford', 36.5372200012207, 0.637694788546828, -91.5177764892578, -1.59728652384181, 218, 29, 'PPL', 'P'),
(62481, 'Allen Grove', 36.3052787780762, 0.633646650531853, -77.6447219848633, -1.35515604543149, 218, 33, 'PPL', 'P'),
(84622, 'Allen Grove', 35.8411102294922, 0.625545381074859, -83.2174987792969, -1.45241934897309, 218, 50, 'PPL', 'P'),
(62483, 'Allen Jay', 35.9238891601563, 0.626990145966227, -79.9655609130859, -1.39566232613743, 218, 33, 'PPL', 'P'),
(107944, 'Allen Junction', 37.589168548584, 0.656054754259889, -81.350830078125, -1.41983983409372, 218, 58, 'PPL', 'P'),
(158621, 'Allen Junction', 40.6319389343262, 0.709161115873268, -75.39111328125, -1.31582315350184, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(39072, 'Allen Landing', 30.500560760498, 0.532335208975277, -91.2708282470703, -1.59297646393362, 218, 22, 'PPL', 'P'),
(158622, 'Allen Lane', 40.0563888549805, 0.699115871978571, -75.1977767944336, -1.31244879524265, 218, 45, 'PPL', 'P'),
(18799, 'Allen Mill (historical)', 33.0497207641602, 0.576826444199331, -83.1013870239258, -1.4503928165416, 218, 13, 'PPL', 'P'),
(53156, 'Allen Mills', 37.5044403076172, 0.654575967485595, -90.6947174072266, -1.58292143292192, 218, 29, 'PPL', 'P'),
(129480, 'Allen Park', 42.2574996948242, 0.737532503335182, -83.2111129760742, -1.45230789568147, 218, 27, 'PPL', 'P'),
(92192, 'Allen Point', 33.644718170166, 0.587211107974959, -95.9075012207031, -1.67390167366175, 218, 51, 'PPL', 'P'),
(99360, 'Allen Shop Corner', 37.7055587768555, 0.658086146960374, -76.8450012207031, -1.34119828500033, 218, 53, 'PPL', 'P'),
(34533, 'Allen Springs', 36.8316688537598, 0.642833890502354, -86.3150024414063, -1.50648098646948, 218, 21, 'PPL', 'P'),
(84623, 'Allenbridge (historical)', 36.0697212219238, 0.629535395599043, -82.9000015258789, -1.44687797653491, 218, 50, 'PPL', 'P'),
(99361, 'Allencrest', 38.8933296203613, 0.678816658938741, -77.1505584716797, -1.34653126508321, 218, 53, 'PPL', 'P'),
(7060, 'Allendale', 34.8102798461914, 0.607553996856665, -91.2663879394531, -1.5928989659459, 218, 4, 'PPL', 'P'),
(18801, 'Allendale', 32.5277786254883, 0.567716835374606, -84.9255599975586, -1.48223064105738, 218, 13, 'PPL', 'P'),
(26350, 'Allendale', 38.526668548584, 0.672417215997336, -87.709716796875, -1.53082334409724, 218, 18, 'PPL', 'P'),
(29084, 'Allendale', 39.3916702270508, 0.687514343321858, -87.3958282470703, -1.52534495541884, 218, 19, 'PPL', 'P'),
(34535, 'Allendale', 37.3711090087891, 0.652248897325084, -85.5830612182617, -1.49370620219454, 218, 21, 'PPL', 'P'),
(39074, 'Allendale', 30.4963893890381, 0.532262404808976, -91.2727813720703, -1.59301055239557, 218, 22, 'PPL', 'P'),
(62484, 'Allendale', 35.3147201538086, 0.616358141104358, -81.5136108398438, -1.42268089434461, 218, 33, 'PPL', 'P'),
(79510, 'Allendale', 34.4297218322754, 0.60091200651898, -82.7583312988281, -1.44440536462083, 218, 48, 'PPL', 'P'),
(92194, 'Allendale', 33.8574981689453, 0.590924819536047, -98.5933303833008, -1.72077823569516, 218, 51, 'PPL', 'P'),
(129484, 'Allendale', 42.9722213745117, 0.750006749881113, -85.95361328125, -1.50017355574374, 218, 27, 'PPL', 'P'),
(139007, 'Allendale', 40.4855613708496, 0.706606345439555, -94.288330078125, -1.64564180607048, 218, 29, 'PPL', 'P'),
(144728, 'Allendale', 41.041389465332, 0.716307375763359, -74.1294403076172, -1.29380280602852, 218, 37, 'PPL', 'P'),
(146765, 'Allendale', 43.7805595397949, 0.764114912334835, -76.0169372558594, -1.32674584239669, 218, 40, 'PPL', 'P'),
(158625, 'Allendale', 40.2238883972168, 0.702039290486178, -76.8905563354492, -1.34199337174377, 218, 45, 'PPL', 'P'),
(169250, 'Allendale', 41.8499984741211, 0.730420265328016, -71.4711074829102, -1.24740614562354, 218, 47, 'PPL', 'P'),
(177179, 'Allendale', 40.0186080932617, 0.698456473292667, -80.70361328125, -1.40854377001404, 218, 58, 'PPL', 'P'),
(179682, 'Allendale', 38.4447212219238, 0.670986965333908, -121.941940307617, -2.12828835463831, 218, 6, 'PPL', 'P'),
(194508, 'Allendale', 43.6763916015625, 0.762296838837665, -116.873893737793, -2.03983425535047, 218, 17, 'PPL', 'P'),
(209263, 'Allendale', 42.8147201538086, 0.747257835003933, -106.309997558594, -1.85545948518459, 218, 59, 'PPL', 'P'),
(58445, 'Allendale (historical)', 33.3944396972656, 0.582842924575984, -88.5311126708984, -1.54515940656125, 218, 30, 'PPL', 'P'),
(195857, 'Allendale (historical)', 46.0327796936035, 0.803423569498568, -112.533332824707, -1.96407717603375, 218, 31, 'PPL', 'P'),
(44322, 'Allendale Estates', 39.5811080932617, 0.690820657815192, -76.2525024414063, -1.33085723048755, 218, 25, 'PPL', 'P'),
(18802, 'Allendale Heights', 33.5763893127441, 0.586018544438821, -84.2966690063477, -1.47125442262462, 218, 13, 'PPL', 'P'),
(114385, 'Allendorf', 43.4147186279297, 0.757729783884288, -95.6430587768555, -1.66928628233459, 218, 16, 'PPL', 'P'),
(31631, 'Allendorph', 38.9927787780762, 0.680552374179201, -96.2708282470703, -1.68024292653334, 218, 20, 'PPL', 'P'),
(92195, 'Allenfarm', 30.399169921875, 0.530565605009946, -96.2436065673828, -1.67976781859487, 218, 51, 'PPL', 'P'),
(44323, 'Allenford', 39.3108291625977, 0.686103400576334, -76.8608322143555, -1.34147458796343, 218, 25, 'PPL', 'P'),
(14968, 'Allenhurst', 28.7361106872559, 0.501539745710145, -80.7558288574219, -1.40945510373906, 218, 12, 'PPL', 'P'),
(18803, 'Allenhurst', 31.7838897705078, 0.554733525586306, -81.607780456543, -1.42432446421136, 218, 13, 'PPL', 'P'),
(92196, 'Allenhurst', 29.0091705322266, 0.506305539059869, -95.8444366455078, -1.67280098918322, 218, 51, 'PPL', 'P'),
(144730, 'Allenhurst', 40.2361106872559, 0.702252609689493, -74.001106262207, -1.29156295439371, 218, 37, 'PPL', 'P'),
(158627, 'Allenport', 40.3736114501953, 0.704652450726791, -77.8702774047852, -1.35909273015485, 218, 45, 'PPL', 'P'),
(84624, 'Allens', 35.6411094665527, 0.622054709255065, -89.190559387207, -1.5566689230023, 218, 50, 'PPL', 'P'),
(158628, 'Allens', 41.2419395446777, 0.719807634963078, -76.9797210693359, -1.34354958992676, 218, 45, 'PPL', 'P'),
(92197, 'Allens Chapel', 33.6472091674805, 0.587254584079754, -95.9599533081055, -1.67481713528647, 218, 51, 'PPL', 'P'),
(144732, 'Allens Corner', 40.5466690063477, 0.707672874877104, -74.9388885498047, -1.30793034297917, 218, 37, 'PPL', 'P'),
(118595, 'Allens Corners', 42.0994415283203, 0.734773867920023, -88.4813919067383, -1.54429161552005, 218, 18, 'PPL', 'P'),
(99363, 'Allens Creek', 37.5466690063477, 0.655312997317274, -78.8688888549805, -1.37652178790887, 218, 53, 'PPL', 'P'),
(84627, 'Allens Creek (historical)', 35.4269409179688, 0.618316762928057, -87.595832824707, -1.52883569381766, 218, 50, 'PPL', 'P'),
(62487, 'Allens Crossroads', 34.9119415283203, 0.609328327932931, -80.4077835083008, -1.40338056645065, 218, 33, 'PPL', 'P'),
(112734, 'Allens Crossroads', 34.4277801513672, 0.600878117794109, -86.5419387817383, -1.5104417728007, 218, 2, 'PPL', 'P'),
(158629, 'Allens Crossroads', 40.1361083984375, 0.700507240490083, -79.8430633544922, -1.39352434041432, 218, 45, 'PPL', 'P'),
(112733, 'Allens Factory', 34.2788887023926, 0.598279471781437, -87.7213897705078, -1.53102707592063, 218, 2, 'PPL', 'P'),
(44324, 'Allens Fresh', 38.413890838623, 0.670448873635658, -76.9408264160156, -1.3428707501649, 218, 25, 'PPL', 'P'),
(172874, 'Allens Grove', 42.5802803039551, 0.743166087726108, -88.7624969482422, -1.54919782403824, 218, 57, 'PPL', 'P'),
(146768, 'Allens Hill', 42.8408317565918, 0.747713568445473, -77.5152816772461, -1.35289688587878, 218, 40, 'PPL', 'P'),
(62488, 'Allens Level', 36.3252792358398, 0.633995724371735, -79.021110534668, -1.37917855741233, 218, 33, 'PPL', 'P'),
(99362, 'Allens Mill', 37.2802810668945, 0.650663650686214, -78.5524978637695, -1.37099972338859, 218, 53, 'PPL', 'P'),
(126750, 'Allens Mills', 44.7161102294922, 0.780443352189356, -70.081672668457, -1.2231559333695, 218, 26, 'PPL', 'P'),
(143453, 'Allens Mills', 43.4083290100098, 0.757618264013641, -71.4519424438477, -1.24707165259063, 218, 36, 'PPL', 'P'),
(144733, 'Allens Mills', 40.7400016784668, 0.711047166557262, -75.1188888549805, -1.31107194095908, 218, 37, 'PPL', 'P'),
(158630, 'Allens Mills', 41.1994400024414, 0.719065878020463, -78.9077835083008, -1.37720062767073, 218, 45, 'PPL', 'P'),
(26351, 'Allens Spring', 37.3688888549805, 0.652210148331223, -88.6569366455078, -1.54735544919613, 218, 18, 'PPL', 'P'),
(194509, 'Allens Spur', 48.7405586242676, 0.850683227254787, -116.365280151367, -2.03095727364696, 218, 17, 'PPL', 'P'),
(71645, 'Allensburg', 39.2044410705566, 0.684246578085304, -83.7772216796875, -1.46218835648372, 218, 41, 'PPL', 'P'),
(99365, 'Allenslevel', 37.5616683959961, 0.655574786052429, -78.4897232055664, -1.36990409891613, 218, 53, 'PPL', 'P'),
(194083, 'Allenspark', 40.1944389343262, 0.701525300395793, -105.525001525879, -1.84175871979863, 218, 7, 'PPL', 'P'),
(62489, 'Allenstand', 35.9727783203125, 0.627843422779488, -82.753059387207, -1.44431335240516, 218, 33, 'PPL', 'P'),
(143454, 'Allenstown Elementary School', 43.1577796936035, 0.753245353503731, -71.4061126708984, -1.24627177215722, 218, 36, 'PPL', 'P'),
(29086, 'Allensville', 38.8730583190918, 0.678462857987924, -85.0202789306641, -1.48388379830405, 218, 19, 'PPL', 'P'),
(34534, 'Allensville', 36.7166709899902, 0.640826799146816, -87.0661087036133, -1.51959026377734, 218, 21, 'PPL', 'P'),
(62490, 'Allensville', 36.3902816772461, 0.635130230996109, -78.8888931274414, -1.37687092832778, 218, 33, 'PPL', 'P'),
(71646, 'Allensville', 39.2724990844727, 0.685434414510507, -82.6069412231445, -1.4417631093453, 218, 41, 'PPL', 'P'),
(107945, 'Allensville', 39.5830612182617, 0.690854746277145, -77.9933319091797, -1.36124043641594, 218, 58, 'PPL', 'P'),
(158634, 'Allensville', 40.535831451416, 0.707483723860681, -77.8172225952148, -1.35816674904383, 218, 45, 'PPL', 'P'),
(84625, 'Allensville (historical)', 35.9124984741211, 0.626791340990853, -83.4872207641602, -1.45712688567397, 218, 50, 'PPL', 'P'),
(179683, 'Allensworth', 35.8636093139648, 0.625938064177591, -119.388061523438, -2.08371476115754, 218, 6, 'PPL', 'P'),
(53157, 'Allenton', 38.5036087036133, 0.672014745777597, -90.6758270263672, -1.58259173357897, 218, 29, 'PPL', 'P'),
(62492, 'Allenton', 34.5922203063965, 0.60374813992186, -78.9263916015625, -1.37752540016567, 218, 33, 'PPL', 'P'),
(112735, 'Allenton', 31.9366703033447, 0.557400048917262, -87.0533294677734, -1.51936722403605, 218, 2, 'PPL', 'P'),
(129487, 'Allenton', 42.9194412231445, 0.749085562460054, -82.945556640625, -1.44767306327835, 218, 27, 'PPL', 'P'),
(169251, 'Allenton', 41.5438919067383, 0.725077697865208, -71.4683303833008, -1.2473576760917, 218, 47, 'PPL', 'P'),
(172875, 'Allenton', 43.4205589294434, 0.757831716375011, -88.3408279418945, -1.54183831152387, 218, 57, 'PPL', 'P'),
(112522, 'Allenton Station', 31.9297199249268, 0.557278741929609, -87.0236129760742, -1.51884857341376, 218, 2, 'PPL', 'P'),
(14969, 'Allentown', 30.7625007629395, 0.536906924460561, -87.0422210693359, -1.51917334590869, 218, 12, 'PPL', 'P'),
(18805, 'Allentown', 32.5930595397949, 0.568856202267969, -83.225830078125, -1.45256475756861, 218, 13, 'PPL', 'P'),
(58446, 'Allentown', 34.8572196960449, 0.608373251787001, -88.6050033569336, -1.54644904231912, 218, 30, 'PPL', 'P'),
(79512, 'Allentown', 33.6258316040039, 0.586881475211034, -79.3505630493164, -1.38492858852192, 218, 48, 'PPL', 'P'),
(99364, 'Allentown', 37.6955604553223, 0.657911643329946, -75.6894378662109, -1.32102989974905, 218, 53, 'PPL', 'P'),
(107946, 'Allentown', 38.764720916748, 0.676572013613968, -81.5127792358398, -1.42266638011667, 218, 58, 'PPL', 'P'),
(118597, 'Allentown', 40.5558280944824, 0.707832731121536, -89.3966674804688, -1.56026618784472, 218, 18, 'PPL', 'P'),
(144734, 'Allentown', 40.1777801513672, 0.701234549783783, -74.5838928222656, -1.3017344987031, 218, 37, 'PPL', 'P'),
(146767, 'Allentown', 43.3250007629395, 0.756163911742349, -73.9552764892578, -1.2907630739603, 218, 40, 'PPL', 'P'),
(154045, 'Allentown', 40.7547187805176, 0.7113040284444, -84.1947174072266, -1.46947503154229, 218, 41, 'PPL', 'P'),
(158632, 'Allentown', 40.6083297729492, 0.708749058273605, -75.4905624389648, -1.3175588687423, 218, 45, 'PPL', 'P'),
(177434, 'Allentown', 41.6488914489746, 0.726910285590319, -72.9908294677734, -1.27393029797435, 218, 8, 'PPL', 'P'),
(193094, 'Allentown', 35.2919387817383, 0.615960531153609, -109.157783508301, -1.90516272639902, 218, 5, 'PPL', 'P'),
(195858, 'Allentown', 47.440559387207, 0.827993960294666, -114.095558166504, -1.9913431519062, 218, 31, 'PPL', 'P'),
(206670, 'Allentown', 47.4944381713867, 0.828934322475573, -122.275001525879, -2.13410136950768, 218, 56, 'PPL', 'P'),
(200313, 'Allentown (historical)', 42.0444412231445, 0.733813931505104, -123.625, -2.15766328777799, 218, 43, 'PPL', 'P'),
(158635, 'Allenvale', 40.0800018310547, 0.69952799615726, -79.142219543457, -1.38129230836953, 218, 45, 'PPL', 'P'),
(158636, 'Allenview', 40.1783294677734, 0.701244137163707, -76.9700012207031, -1.34337994656532, 218, 45, 'PPL', 'P'),
(18806, 'Allenville', 31.1288890838623, 0.543301607001518, -83.2141723632813, -1.45236129206133, 218, 13, 'PPL', 'P'),
(26352, 'Allenville', 39.5555610656738, 0.690374778069685, -88.5297164916992, -1.54513503863727, 218, 18, 'PPL', 'P'),
(44325, 'Allenville', 39.0602798461914, 0.681730490066424, -76.523063659668, -1.33557941457443, 218, 25, 'PPL', 'P'),
(53158, 'Allenville', 37.2216682434082, 0.649640663932487, -89.7574996948242, -1.56656389803249, 218, 29, 'PPL', 'P'),
(112737, 'Allenville', 30.7027797698975, 0.535864596499418, -88.0788879394531, -1.53726659603858, 218, 2, 'PPL', 'P'),
(129488, 'Allenville', 45.9847183227539, 0.80258474033422, -84.820556640625, -1.48039798675325, 218, 27, 'PPL', 'P'),
(172876, 'Allenville', 44.1330604553223, 0.770267213927081, -88.6188888549805, -1.54669138997832, 218, 57, 'PPL', 'P'),
(193095, 'Allenville', 33.3519401550293, 0.582101167633369, -112.585830688477, -1.96499343660679, 218, 5, 'PPL', 'P'),
(18807, 'Allenwood', 33.0697212219238, 0.577175518039213, -83.2613906860352, -1.45318540726065, 218, 13, 'PPL', 'P'),
(144736, 'Allenwood', 40.1413917541504, 0.700599452442827, -74.1002807617188, -1.2932938759442, 218, 37, 'PPL', 'P'),
(158637, 'Allenwood', 41.1074981689453, 0.717461190305636, -76.8986129760742, -1.34213398664933, 218, 45, 'PPL', 'P'),
(26353, 'Allerton', 39.9116706848145, 0.696590063421712, -87.936393737793, -1.53477960305461, 218, 18, 'PPL', 'P'),
(114387, 'Allerton', 40.7063903808594, 0.710460538748145, -93.3649978637695, -1.62952661884025, 218, 16, 'PPL', 'P'),
(124103, 'Allerton', 42.3041687011719, 0.738347031154582, -70.8838882446289, -1.23715723648448, 218, 23, 'PPL', 'P'),
(144737, 'Allerton', 40.6111106872559, 0.708797594384472, -74.8788909912109, -1.30688318803855, 218, 37, 'PPL', 'P'),
(53159, 'Alley', 37.1522216796875, 0.648428592741365, -91.4433288574219, -1.59598716754596, 218, 29, 'PPL', 'P'),
(107947, 'Alley Grove', 39.9608306884766, 0.697448067345908, -80.5263900756836, -1.40545064156596, 218, 58, 'PPL', 'P'),
(188024, 'Alley Place', 34.9724998474121, 0.610385269990556, -106.249717712402, -1.85440740339596, 218, 38, 'PPL', 'P'),
(53160, 'Alley Spring', 37.1441688537598, 0.648288044414836, -91.4438934326172, -1.59599702124199, 218, 29, 'PPL', 'P'),
(92198, 'Alleyton', 29.7063903808594, 0.518474321028768, -96.4861068725586, -1.68400024735728, 218, 51, 'PPL', 'P'),
(7062, 'Allfriend (historical)', 36.1108283996582, 0.63025285119671, -93.4105606079102, -1.63032183874175, 218, 4, 'PPL', 'P'),
(112738, 'Allgood', 33.9119415283203, 0.591875035412987, -86.5094375610352, -1.50987451948852, 218, 2, 'PPL', 'P'),
(58447, 'Allgoods Mill (historical)', 33.225830078125, 0.579900131571446, -88.7013931274414, -1.54813136117972, 218, 30, 'PPL', 'P'),
(14970, 'Alliance', 30.6097202301025, 0.534240401129606, -85.1136093139648, -1.4855127207848, 218, 12, 'PPL', 'P'),
(39077, 'Alliance', 31.5316696166992, 0.55033145346246, -93.6500015258789, -1.6345008711243, 218, 22, 'PPL', 'P'),
(53161, 'Alliance', 37.5622215270996, 0.655584440011381, -89.9966735839844, -1.57073826988313, 218, 29, 'PPL', 'P'),
(62493, 'Alliance', 35.144718170166, 0.613391046754874, -76.8024978637695, -1.34045646147869, 218, 33, 'PPL', 'P'),
(70456, 'Alliance', 39.5186080932617, 0.689729827032695, -75.0922164916992, -1.31060642040054, 218, 37, 'PPL', 'P'),
(99372, 'Alliance', 37.1380615234375, 0.648181451392206, -76.7838897705078, -1.34013168898375, 218, 53, 'PPL', 'P'),
(107948, 'Alliance', 39.4563903808594, 0.688643923098216, -80.4811096191406, -1.40466034851248, 218, 58, 'PPL', 'P'),
(112743, 'Alliance', 33.547779083252, 0.585519201734432, -87.1263885498047, -1.52064234556598, 218, 2, 'PPL', 'P'),
(122129, 'Alliance', 40.0333290100098, 0.698713401758832, -85.6500015258789, -1.49487453096475, 218, 19, 'PPL', 'P'),
(154046, 'Alliance', 40.9152793884277, 0.714106339701436, -81.1061096191406, -1.41556865633745, 218, 41, 'PPL', 'P'),
(193341, 'Alliance', 40.8886108398438, 0.713640885721917, -124.086669921875, -2.16572094797213, 218, 6, 'PPL', 'P'),
(199139, 'Alliance', 42.1016693115234, 0.734812750071938, -102.871673583984, -1.7954494110774, 218, 35, 'PPL', 'P'),
(158638, 'Alliance Furnace', 40.1138916015625, 0.700119484235367, -79.7188873291016, -1.39135705991921, 218, 45, 'PPL', 'P'),
(154047, 'Alliance Junction', 40.9208297729492, 0.714203212186088, -81.0425033569336, -1.41445851763705, 218, 41, 'PPL', 'P'),
(179684, 'Alliance Redwood', 38.4338912963867, 0.67079794747554, -122.971939086914, -2.14626522462856, 218, 6, 'PPL', 'P'),
(44326, 'Allibone (historical)', 39.6161117553711, 0.691431586969256, -76.3147201538086, -1.33194313442203, 218, 25, 'PPL', 'P'),
(18808, 'Allie', 33.0991706848145, 0.577689508129599, -84.728889465332, -1.47879809272838, 218, 13, 'PPL', 'P'),
(107949, 'Allied', 39.3891716003418, 0.687470734059008, -80.2752838134766, -1.40106801051808, 218, 58, 'PPL', 'P'),
(58448, 'Alligator', 34.0894393920898, 0.594972957551022, -90.7194366455078, -1.58335286501851, 218, 30, 'PPL', 'P'),
(62494, 'Alligator', 35.9144401550293, 0.626825229715724, -76.1127777099609, -1.32841857387737, 218, 33, 'PPL', 'P'),
(79513, 'Alligator Lake', 34.1252784729004, 0.595598467512054, -79.804443359375, -1.39285029434242, 218, 48, 'PPL', 'P'),
(146769, 'Alligerville', 41.7958297729492, 0.729474843141038, -74.179443359375, -1.29467552391774, 218, 40, 'PPL', 'P'),
(18809, 'Alligood', 32.4361114501953, 0.566116941349741, -83.0041732788086, -1.44869611661111, 218, 13, 'PPL', 'P'),
(62499, 'Alligoods', 35.5597190856934, 0.620634179129617, -76.9463882446289, -1.34296782238663, 218, 33, 'PPL', 'P'),
(62497, 'Allin (historical)', 36.2316703796387, 0.632361941621999, -80.9574966430664, -1.41297487059377, 218, 33, 'PPL', 'P'),
(107950, 'Allingdale', 38.3572196960449, 0.669459775606802, -80.6116714477539, -1.40693908229921, 218, 58, 'PPL', 'P'),
(84628, 'Allingham', 36.0275001525879, 0.628798498925418, -84.3405609130859, -1.47202048091218, 218, 50, 'PPL', 'P'),
(177435, 'Allingtown', 41.2975006103516, 0.720777358495003, -72.960563659668, -1.27340205997213, 218, 8, 'PPL', 'P'),
(7063, 'Allis', 33.6277809143066, 0.58691549709396, -91.9049987792969, -1.6040448277401, 218, 4, 'PPL', 'P'),
(158639, 'Allis Hollow', 41.8433303833008, 0.73030388518838, -76.3061065673828, -1.3317927989785, 218, 45, 'PPL', 'P'),
(7064, 'Allison', 35.9366683959961, 0.627213185707521, -92.1172180175781, -1.60774875218418, 218, 4, 'PPL', 'P'),
(62498, 'Allison', 36.4088897705078, 0.635455003491044, -79.4644393920898, -1.38691610564345, 218, 33, 'PPL', 'P'),
(74972, 'Allison', 33.8958282470703, 0.591593805601875, -96.3713912963867, -1.68199808284975, 218, 42, 'PPL', 'P'),
(77776, 'Allison', 39.9888916015625, 0.697937822670374, -79.8649978637695, -1.39390716982102, 218, 45, 'PPL', 'P'),
(99366, 'Allison', 36.9305610656738, 0.644559885204834, -80.8363876342773, -1.41086111963657, 218, 53, 'PPL', 'P'),
(112741, 'Allison', 32.7866706848145, 0.572235354217116, -87.975830078125, -1.53546789703834, 218, 2, 'PPL', 'P'),
(114388, 'Allison', 42.7527809143066, 0.746176791338443, -92.7949981689453, -1.61957824743021, 218, 16, 'PPL', 'P'),
(139008, 'Allison', 40.5322189331055, 0.707420673521874, -94.7063903808594, -1.65293833482508, 218, 29, 'PPL', 'P'),
(186324, 'Allison', 37.0244407653809, 0.646198395065505, -107.487503051758, -1.87601083300063, 218, 7, 'PPL', 'P'),
(187575, 'Allison', 39.5750007629395, 0.690714064792561, -100.263893127441, -1.74993505594157, 218, 20, 'PPL', 'P'),
(188025, 'Allison', 35.524169921875, 0.620013729174656, -108.784439086914, -1.89864663700186, 218, 38, 'PPL', 'P'),
(191062, 'Allison', 35.6058311462402, 0.621438986411039, -100.100280761719, -1.74707948146273, 218, 51, 'PPL', 'P'),
(206669, 'Allison', 47.1405601501465, 0.822757985854489, -122.394439697266, -2.13618595885094, 218, 56, 'PPL', 'P'),
(201856, 'Allison Crossing', 45.1988906860352, 0.788869460720312, -101.916938781738, -1.77878614529483, 218, 49, 'PPL', 'P'),
(62500, 'Allison Ferry', 35.3886108398438, 0.617647776862229, -80.9577789306641, -1.41297979744178, 218, 33, 'PPL', 'P'),
(99367, 'Allison Gap', 36.8941688537598, 0.64392472128485, -81.7769393920898, -1.42727684459582, 218, 53, 'PPL', 'P'),
(77777, 'Allison Heights', 39.9861106872559, 0.697889286559507, -79.8788909912109, -1.39414965063827, 218, 45, 'PPL', 'P'),
(112742, 'Allison Mills', 33.389720916748, 0.582760566319273, -86.1149978637695, -1.50299024807066, 218, 2, 'PPL', 'P'),
(158646, 'Allison Park', 40.559440612793, 0.707895781460344, -79.9588928222656, -1.3955459459978, 218, 45, 'PPL', 'P'),
(84629, 'Allisona', 35.7547187805176, 0.624037565844684, -86.6919403076172, -1.51305979331031, 218, 50, 'PPL', 'P'),
(99368, 'Allisonia', 36.9391708374023, 0.644710154069342, -80.7363891601563, -1.40911581701619, 218, 53, 'PPL', 'P'),
(29087, 'Allisonville', 39.9049987792969, 0.696473616703049, -86.0783309936523, -1.50235029046072, 218, 19, 'PPL', 'P'),
(107951, 'Allister', 39.601390838623, 0.691174658503091, -80.6941680908203, -1.40837892034256, 218, 58, 'PPL', 'P'),
(29088, 'Allman', 39.6172218322754, 0.691450961466186, -86.4311065673828, -1.50850738574292, 218, 19, 'PPL', 'P'),
(191063, 'Allmon', 33.8813896179199, 0.591341803983726, -101.51277923584, -1.77173223051554, 218, 51, 'PPL', 'P'),
(99369, 'Allmondsville', 37.3933296203613, 0.652636720158826, -76.6511077880859, -1.33781420620317, 218, 53, 'PPL', 'P'),
(99370, 'Allnut', 38.3080596923828, 0.668601771682606, -77.1061096191406, -1.34575548625767, 218, 53, 'PPL', 'P'),
(44327, 'Allnut Farms Estates', 39.1972198486328, 0.684120543986716, -76.9691696166992, -1.34336543233738, 218, 25, 'PPL', 'P'),
(34536, 'Allock', 37.228889465332, 0.649766698031075, -83.0733337402344, -1.44990319437519, 218, 21, 'PPL', 'P'),
(18811, 'Allon', 32.6375007629395, 0.569631847935455, -83.98388671875, -1.46579534186412, 218, 13, 'PPL', 'P'),
(39097, 'Allon', 30.6411094665527, 0.534788246655349, -91.4938888549805, -1.59686960597315, 218, 22, 'PPL', 'P'),
(84630, 'Allons', 36.4419403076172, 0.636031844183155, -85.3447189331055, -1.48954634457183, 218, 50, 'PPL', 'P'),
(129490, 'Allouez', 47.2872200012207, 0.825317683136218, -88.4094390869141, -1.54303580190802, 218, 27, 'PPL', 'P'),
(172878, 'Allouez', 46.6886100769043, 0.814869969021783, -92.0244369506836, -1.60612941708336, 218, 57, 'PPL', 'P'),
(44328, 'Alloway', 39.1408309936523, 0.683136372805877, -76.478889465332, -1.33480842943885, 218, 25, 'PPL', 'P'),
(70457, 'Alloway', 39.5608291625977, 0.69046672370632, -75.3627777099609, -1.31532860448741, 218, 37, 'PPL', 'P'),
(84631, 'Alloway', 35.7999992370605, 0.624827858898165, -84.8755569458008, -1.48135792316817, 218, 50, 'PPL', 'P'),
(146770, 'Alloway', 43.023609161377, 0.750903635957224, -76.9888916015625, -1.34370964590828, 218, 40, 'PPL', 'P'),
(70458, 'Alloway Junction', 39.5813903808594, 0.690825584663208, -75.3633270263672, -1.31533819186733, 218, 37, 'PPL', 'P'),
(107952, 'Alloy', 38.1375007629395, 0.665624956795143, -81.2744369506836, -1.41850652249397, 218, 58, 'PPL', 'P'),
(7065, 'Allport', 34.5419387817383, 0.602870561763652, -91.7838897705078, -1.6019310767829, 218, 4, 'PPL', 'P'),
(158645, 'Allport', 40.9669418334961, 0.715008019467509, -78.2016677856445, -1.36487658341028, 218, 45, 'PPL', 'P'),
(84632, 'Allred', 36.3305587768555, 0.634087869745452, -85.1897201538086, -1.48684110553653, 218, 50, 'PPL', 'P'),
(112739, 'Allred', 31.7716693878174, 0.554520239672505, -86.0083312988281, -1.50112856531064, 218, 2, 'PPL', 'P'),
(191064, 'Allred', 32.9861106872559, 0.575716238919904, -102.887496948242, -1.79572558088244, 218, 51, 'PPL', 'P'),
(189860, 'Allred (historical)', 38.6783294677734, 0.675064198383793, -115.547782897949, -2.01668925494881, 218, 39, 'PPL', 'P'),
(62501, 'Allreds', 35.4530601501465, 0.618772629527651, -79.8058319091797, -1.39287452910834, 218, 33, 'PPL', 'P'),
(26355, 'Allright', 39.2972183227539, 0.685865846607099, -87.748893737793, -1.53150711070712, 218, 18, 'PPL', 'P'),
(112511, 'Allsboro', 34.6941719055176, 0.605527531004197, -88.1102828979492, -1.53781454143286, 218, 2, 'PPL', 'P'),
(79514, 'Allsbrook', 34.0200004577637, 0.593761019517954, -78.9466705322266, -1.37787933427454, 218, 48, 'PPL', 'P'),
(112745, 'Allsop', 33.9411087036133, 0.592384098655356, -85.7163925170898, -1.49603327235505, 218, 2, 'PPL', 'P'),
(124104, 'Allston', 42.3583297729492, 0.739292320183506, -71.1263885498047, -1.24138966524689, 218, 23, 'PPL', 'P'),
(39078, 'Alluvial City', 29.8411102294922, 0.520825625955199, -89.6913909912109, -1.56541008349021, 218, 22, 'PPL', 'P'),
(70460, 'Alluvium', 39.8349990844727, 0.695251891552975, -74.9422225952148, -1.30798853304899, 218, 37, 'PPL', 'P'),
(74974, 'Alluwe', 36.610279083252, 0.638969910076758, -95.4869384765625, -1.66656146906527, 218, 42, 'PPL', 'P'),
(44329, 'Allview Estates', 39.1941719055176, 0.684067347343942, -76.8597183227539, -1.34145514688747, 218, 25, 'PPL', 'P'),
(44330, 'Allwood', 39.1800003051758, 0.6838200062577, -76.648063659668, -1.33776107613942, 218, 25, 'PPL', 'P'),
(99371, 'Allwood', 37.6494407653809, 0.65710670289047, -79.2211074829102, -1.3826691626531, 218, 53, 'PPL', 'P'),
(177371, 'Allwood', 40.8424987792969, 0.712836078440495, -74.1591720581055, -1.29432172296692, 218, 37, 'PPL', 'P'),
(206671, 'Allyn', 47.3858299255371, 0.827038750990682, -122.826393127441, -2.14372496842279, 218, 56, 'PPL', 'P'),
(177436, 'Allyn Point', 41.4416694641113, 0.723293579671937, -72.0791702270508, -1.25801884256751, 218, 8, 'PPL', 'P'),
(44331, 'Allyson Gardens', 39.4297218322754, 0.688178469118697, -76.7886123657227, -1.34021411381949, 218, 25, 'PPL', 'P'),
(7066, 'Alma', 35.4777793884277, 0.619204061624244, -94.2216720581055, -1.64447840414828, 218, 4, 'PPL', 'P'),
(14971, 'Alma', 30.6108303070068, 0.534259775626536, -83.9063873291016, -1.46444272234647, 218, 12, 'PPL', 'P'),
(18812, 'Alma', 31.5391693115234, 0.550462347830037, -82.4625015258789, -1.43924216105743, 218, 13, 'PPL', 'P'),
(26356, 'Alma', 38.7216682434082, 0.675820602712402, -88.9091720581055, -1.55175778763608, 218, 18, 'PPL', 'P'),
(31632, 'Alma', 39.0166702270508, 0.68096935862688, -96.2888870239258, -1.68055811164835, 218, 20, 'PPL', 'P'),
(39079, 'Alma', 30.5961093902588, 0.534002847160371, -91.3894424438477, -1.59504667220699, 218, 22, 'PPL', 'P'),
(53162, 'Alma', 39.0952796936035, 0.682341352641461, -93.5449981689453, -1.63266821682016, 218, 29, 'PPL', 'P'),
(62510, 'Alma', 34.7236099243164, 0.6060413213575, -79.3127822875977, -1.38426918983602, 218, 33, 'PPL', 'P'),
(71648, 'Alma', 39.188060760498, 0.683960687742284, -82.978889465332, -1.44825483081848, 218, 41, 'PPL', 'P'),
(74976, 'Alma', 34.4194412231445, 0.600732576040536, -97.6119384765625, -1.70364971567015, 218, 42, 'PPL', 'P'),
(92201, 'Alma', 32.2852783203125, 0.563484406612198, -96.5458297729492, -1.68504260860793, 218, 51, 'PPL', 'P'),
(99376, 'Alma', 38.5911102294922, 0.673541935504703, -78.5577774047852, -1.37109186876231, 218, 53, 'PPL', 'P'),
(112746, 'Alma', 31.4638900756836, 0.549148477306247, -87.7538909912109, -1.53159432923282, 218, 2, 'PPL', 'P'),
(129492, 'Alma', 43.3788909912109, 0.757104473660338, -84.6597213745117, -1.47759088180625, 218, 27, 'PPL', 'P'),
(141152, 'Alma', 40.0974998474121, 0.699833394155265, -99.3616714477539, -1.73418831704815, 218, 35, 'PPL', 'P'),
(146771, 'Alma', 42.0125007629395, 0.733256465309923, -78.0580596923828, -1.36237014935035, 218, 40, 'PPL', 'P'),
(172880, 'Alma', 44.3199996948242, 0.773529919157565, -91.9147186279297, -1.60421447110154, 218, 57, 'PPL', 'P'),
(186325, 'Alma', 39.2838897705078, 0.685633219485881, -106.062217712402, -1.85113491104847, 218, 7, 'PPL', 'P'),
(188026, 'Alma', 33.3794403076172, 0.582581135840829, -108.902778625488, -1.90071205158528, 218, 38, 'PPL', 'P'),
(200314, 'Alma', 43.8911094665527, 0.766044372544597, -123.473609924316, -2.15502103250247, 218, 43, 'PPL', 'P'),
(179686, 'Alma (historical)', 37.1852798461914, 0.649005566591531, -121.986106872559, -2.12905920661583, 218, 6, 'PPL', 'P'),
(195859, 'Alma (historical)', 48.8211097717285, 0.85208910999424, -110.818061828613, -1.93414004958795, 218, 31, 'PPL', 'P'),
(172881, 'Alma Center', 44.4372215270996, 0.775575826085991, -90.9111099243164, -1.58669819482181, 218, 57, 'PPL', 'P'),
(133915, 'Alma City', 44.0224990844727, 0.768337553980237, -93.727783203125, -1.63585841748997, 218, 28, 'PPL', 'P'),
(92202, 'Alma Colonia', 26.3360004425049, 0.459649919528394, -98.1859970092773, -1.7136689271652, 218, 51, 'PPL', 'P'),
(193006, 'Alma Gardens', 33.4047203063965, 0.583022355054428, -111.853889465332, -1.95221865233184, 218, 5, 'PPL', 'P'),
(186326, 'Alma Junction', 39.2675018310547, 0.685347195984806, -106.044723510742, -1.85082957962949, 218, 7, 'PPL', 'P'),
(29089, 'Alma Lake', 39.6083297729492, 0.691295765753662, -87.0194396972656, -1.51877573595794, 218, 19, 'PPL', 'P'),
(44332, 'Alma Meadows', 39.5863914489746, 0.690912869767936, -76.8625030517578, -1.34150374957736, 218, 25, 'PPL', 'P'),
(193007, 'Alma Meadows Mobile Home Park', 33.4047203063965, 0.583022355054428, -111.856941223145, -1.95227191555365, 218, 5, 'PPL', 'P'),
(39080, 'Almadane', 30.9416694641113, 0.540034008212532, -93.5047225952148, -1.63196527545044, 218, 22, 'PPL', 'P'),
(158673, 'Almaden', 40.7627792358398, 0.711444709928983, -78.4000015258789, -1.36833816019517, 218, 45, 'PPL', 'P'),
(99373, 'Almagro', 36.5705604553223, 0.63827668924501, -79.3886108398438, -1.38559264773973, 218, 53, 'PPL', 'P'),
(193342, 'Almanor', 40.2174987792969, 0.701927770615531, -121.173057556152, -2.11486881906345, 218, 6, 'PPL', 'P'),
(193343, 'Almanor West', 40.2363891601563, 0.702257469958483, -121.203330993652, -2.11539719022372, 218, 6, 'PPL', 'P'),
(44333, 'Almar Estates', 38.811939239502, 0.677396128813293, -76.5999984741211, -1.33692218039605, 218, 25, 'PPL', 'P'),
(53163, 'Almartha', 36.7641716003418, 0.641655841194157, -92.5169372558594, -1.61472516897575, 218, 29, 'PPL', 'P'),
(84633, 'Almaville', 35.8652801513672, 0.625967225791528, -86.5811080932617, -1.51112540625253, 218, 50, 'PPL', 'P'),
(79515, 'Almeda', 32.829719543457, 0.572986698539655, -81.0494384765625, -1.41457955830859, 218, 48, 'PPL', 'P'),
(92203, 'Almeda', 29.603889465332, 0.516685342566508, -95.4169387817383, -1.6653397439152, 218, 51, 'PPL', 'P'),
(129494, 'Almeda Beach', 43.8175010681152, 0.764759663634743, -83.9230575561523, -1.46473367269556, 218, 27, 'PPL', 'P'),
(92204, 'Almeda Plaza', 29.6341705322266, 0.517213846884834, -95.418327331543, -1.66536397868112, 218, 51, 'PPL', 'P'),
(39081, 'Almedia', 29.9733295440674, 0.523133288329267, -90.3005599975586, -1.57604208835208, 218, 22, 'PPL', 'P'),
(158647, 'Almedia', 41.0144386291504, 0.715836994935824, -76.3813934326172, -1.33310680266034, 218, 45, 'PPL', 'P'),
(133917, 'Almelund', 45.4913902282715, 0.793974540792912, -92.7852783203125, -1.61940860406877, 218, 28, 'PPL', 'P'),
(31634, 'Almena', 39.892219543457, 0.696250576961754, -99.706672668457, -1.74020972427282, 218, 20, 'PPL', 'P'),
(129495, 'Almena', 42.264720916748, 0.73765853743377, -85.8252792358398, -1.49793370410893, 218, 27, 'PPL', 'P'),
(172886, 'Almena', 45.4169387817383, 0.792675117918035, -92.0327835083008, -1.60627509199499, 218, 57, 'PPL', 'P'),
(112744, 'Almeria', 32.0263900756836, 0.558965954348715, -85.8505630493164, -1.49837498990155, 218, 2, 'PPL', 'P'),
(141155, 'Almeria', 41.8258285522461, 0.729998420611347, -99.5216674804688, -1.73698077460915, 218, 35, 'PPL', 'P'),
(18819, 'Almira', 32.9447212219238, 0.57499385647422, -82.5261077880859, -1.44035229975783, 218, 13, 'PPL', 'P'),
(92205, 'Almira', 33.0999984741211, 0.577703955778512, -94.4452819824219, -1.64838113356774, 218, 51, 'PPL', 'P'),
(99374, 'Almira', 37.1419410705566, 0.648249162262921, -82.6222229003906, -1.44202982492848, 218, 53, 'PPL', 'P'),
(206672, 'Almira', 47.711109161377, 0.832715944644458, -118.939720153809, -2.07588972808462, 218, 56, 'PPL', 'P'),
(34540, 'Almo', 36.6947212219238, 0.640443703424008, -88.2783279418945, -1.54074748074137, 218, 21, 'PPL', 'P'),
(194510, 'Almo', 42.1002807617188, 0.734788515306019, -113.632781982422, -1.98326618379415, 218, 17, 'PPL', 'P'),
(34537, 'Almo Heights', 36.6927795410156, 0.640409814699136, -88.2958297729492, -1.5410529453184, 218, 21, 'PPL', 'P'),
(18813, 'Almon', 33.6191711425781, 0.586765228229452, -83.9222183227539, -1.46471902530957, 218, 13, 'PPL', 'P'),
(53164, 'Almon', 37.9580612182617, 0.662493145932237, -93.0944366455078, -1.62480443475338, 218, 29, 'PPL', 'P'),
(172889, 'Almon', 44.9063911437988, 0.783764380647712, -88.9916687011719, -1.55319762567943, 218, 57, 'PPL', 'P'),
(7068, 'Almond', 35.6958312988281, 0.623009785400995, -91.7983322143555, -1.60218314498008, 218, 4, 'PPL', 'P'),
(62502, 'Almond', 35.3697204589844, 0.617318077519277, -83.5652770996094, -1.4584892257296, 218, 33, 'PPL', 'P'),
(112748, 'Almond', 33.1463890075684, 0.578513623328924, -85.6216735839844, -1.49438011510838, 218, 2, 'PPL', 'P'),
(146773, 'Almond', 42.3222198486328, 0.738662083111539, -77.7386093139648, -1.35679468845022, 218, 40, 'PPL', 'P'),
(172891, 'Almond', 44.2588882446289, 0.772463323140988, -89.4069366455078, -1.56044541858609, 218, 57, 'PPL', 'P'),
(179687, 'Almond', 33.8588905334473, 0.590949120880994, -117.98388671875, -2.0592072875422, 218, 6, 'PPL', 'P'),
(99375, 'Almond (historical)', 38.3375015258789, 0.669115628614937, -78.7161102294922, -1.37385529786743, 218, 53, 'PPL', 'P'),
(44334, 'Almond Valley', 39.4544410705566, 0.68860990121529, -76.9263916015625, -1.34261881512578, 218, 25, 'PPL', 'P'),
(70461, 'Almonesson', 39.8188896179199, 0.694970728320889, -75.0988922119141, -1.31072293369823, 218, 37, 'PPL', 'P'),
(112747, 'Almont', 33.1144409179688, 0.577956023975688, -86.8791732788086, -1.51632762512589, 218, 2, 'PPL', 'P'),
(114391, 'Almont', 41.9752807617188, 0.732606853741026, -90.1988906860352, -1.57426762411776, 218, 16, 'PPL', 'P'),
(129499, 'Almont', 42.9205589294434, 0.749105070115039, -83.0449981689453, -1.44940864536076, 218, 27, 'PPL', 'P'),
(158648, 'Almont', 40.3641700744629, 0.704487667634342, -75.334716796875, -1.31483884916295, 218, 45, 'PPL', 'P'),
(186327, 'Almont', 38.6647186279297, 0.674826644414557, -106.845558166504, -1.86480678113661, 218, 7, 'PPL', 'P'),
(197924, 'Almont', 46.7252807617188, 0.815509993210756, -101.502220153809, -1.77154793976811, 218, 34, 'PPL', 'P'),
(7069, 'Almont (historical)', 35.1672210693359, 0.613783796436633, -90.1580581665039, -1.57355496221006, 218, 4, 'PPL', 'P'),
(179688, 'Almonte', 37.8899993896484, 0.661305242928007, -122.523887634277, -2.13844525156171, 218, 6, 'PPL', 'P'),
(118599, 'Almora', 42.0608291625977, 0.734099955006179, -88.3361129760742, -1.54175601984618, 218, 18, 'PPL', 'P'),
(133919, 'Almora', 46.2463912963867, 0.807151795287597, -95.3652801513672, -1.66443813072815, 218, 28, 'PPL', 'P'),
(118600, 'Almora Heights', 42.042781829834, 0.733784969628249, -88.3438873291016, -1.54189170790372, 218, 18, 'PPL', 'P'),
(114392, 'Almoral', 42.5355606079102, 0.742385581789633, -91.2897186279297, -1.59330616327657, 218, 16, 'PPL', 'P'),
(114393, 'Almoral Siding (historical)', 42.5163917541504, 0.742051022177692, -91.2724990844727, -1.59300562554756, 218, 16, 'PPL', 'P'),
(206673, 'Almota', 46.7030601501465, 0.815122170377013, -117.468330383301, -2.05020913200909, 218, 56, 'PPL', 'P'),
(124105, 'Alms House', 41.6674995422363, 0.727235058085254, -70.7633285522461, -1.23505307290721, 218, 23, 'PPL', 'P'),
(58450, 'Almy', 33.3491706848145, 0.582052831259584, -90.8791732788086, -1.58614079520566, 218, 30, 'PPL', 'P'),
(209264, 'Almy', 41.3316688537598, 0.721373706842099, -111.003890991211, -1.9373833803215, 218, 59, 'PPL', 'P'),
(7070, 'Almyra', 34.4061088562012, 0.600499882340291, -91.4094390869141, -1.59539567946785, 218, 4, 'PPL', 'P'),
(177437, 'Almyville', 41.7180595397949, 0.728117496512452, -71.8666687011719, -1.25430999127541, 218, 8, 'PPL', 'P'),
(126751, 'Alna', 44.1061096191406, 0.769796833099546, -69.6041717529297, -1.21482197021226, 218, 26, 'PPL', 'P'),
(126752, 'Alna Center', 44.0808296203613, 0.769355613885947, -69.6186065673828, -1.21507390525138, 218, 26, 'PPL', 'P'),
(84634, 'Alnwick', 35.7480583190918, 0.623921318863102, -84.0377807617188, -1.46673597036114, 218, 50, 'PPL', 'P'),
(158649, 'Alnwick', 40.1288909912109, 0.700381272970522, -75.0733337402344, -1.31027685421564, 218, 45, 'PPL', 'P'),
(92206, 'Aloe', 28.7663898468018, 0.502068216738958, -97.0758285522461, -1.69429283233821, 218, 51, 'PPL', 'P'),
(195860, 'Aloe', 48.6572189331055, 0.849228675246413, -112.004997253418, -1.95485598075935, 218, 31, 'PPL', 'P'),
(39082, 'Aloha', 31.5830593109131, 0.551228372828085, -92.772216796875, -1.61918063747946, 218, 22, 'PPL', 'P'),
(129501, 'Aloha', 45.5263900756836, 0.794585403367949, -84.466667175293, -1.47422145039508, 218, 27, 'PPL', 'P'),
(200315, 'Aloha', 45.4944381713867, 0.794027737435687, -122.865829467773, -2.14441326240652, 218, 43, 'PPL', 'P'),
(206674, 'Aloha', 47.2011108398438, 0.823814794754059, -124.16667175293, -2.16711724333166, 218, 56, 'PPL', 'P'),
(211667, 'Aloha Kona', 19.6408290863037, 0.342797135377469, -155.985565185547, -2.72246169807203, 218, 15, 'PPL', 'P'),
(92207, 'Aloha Village Colonia', 26.2929992675781, 0.458899407443696, -98.3190002441406, -1.71599027152936, 218, 51, 'PPL', 'P'),
(14972, 'Aloma', 28.6005592346191, 0.499173926555773, -81.3066711425781, -1.41906911527425, 218, 12, 'PPL', 'P'),
(179690, 'Alondra Park', 33.8894386291504, 0.591482285731228, -118.330001831055, -2.06524813584282, 218, 6, 'PPL', 'P'),
(99377, 'Alonzaville', 38.9286117553711, 0.679432448361795, -78.5466690063477, -1.37089799063495, 218, 53, 'PPL', 'P'),
(34538, 'Alonzo', 36.6930618286133, 0.640414741547153, -86.3447189331055, -1.50699963709178, 218, 21, 'PPL', 'P'),
(58451, 'Alonzo', 32.0502815246582, 0.559382938796394, -90.2152786254883, -1.57455364761883, 218, 30, 'PPL', 'P'),
(118601, 'Alonzo', 40.5666694641113, 0.708021948716986, -87.7311096191406, -1.53119671928207, 218, 18, 'PPL', 'P'),
(39083, 'Alonzo (historical)', 31.8638896942139, 0.556129787656321, -92.7050018310547, -1.61800751501928, 218, 22, 'PPL', 'P'),
(146775, 'Aloquin', 42.8608283996582, 0.748062575706328, -77.1452789306641, -1.3464391197095, 218, 40, 'PPL', 'P'),
(26358, 'Alorton', 38.5897216796875, 0.673517700738783, -90.120002746582, -1.57289076983419, 218, 18, 'PPL', 'P'),
(141156, 'Aloys', 41.8294410705566, 0.730061470950155, -96.9030609130859, -1.69127746819397, 218, 35, 'PPL', 'P'),
(179691, 'Alpaugh', 35.8877792358398, 0.62635990889426, -119.486389160156, -2.08543090216399, 218, 6, 'PPL', 'P'),
(7071, 'Alpena', 36.2947196960449, 0.633462359784419, -93.2919387817383, -1.62825149731032, 218, 4, 'PPL', 'P'),
(107953, 'Alpena', 38.9097213745117, 0.679102749018843, -79.6513900756836, -1.39017901061101, 218, 58, 'PPL', 'P'),
(129503, 'Alpena', 45.0616683959961, 0.786474479952004, -83.4327774047852, -1.45617666979703, 218, 27, 'PPL', 'P'),
(169713, 'Alpena', 44.1813888549805, 0.771110703623337, -98.3652801513672, -1.71679800828798, 218, 49, 'PPL', 'P'),
(129505, 'Alpena Junction', 45.0586090087891, 0.786421083572148, -83.4561080932617, -1.4565838671277, 218, 27, 'PPL', 'P'),
(74977, 'Alpers', 34.4925003051758, 0.602007697570466, -97.3869400024414, -1.69972275148478, 218, 42, 'PPL', 'P'),
(7072, 'Alpha', 35.1155586242676, 0.61288211667056, -93.2805633544922, -1.62805295865106, 218, 4, 'PPL', 'P'),
(34539, 'Alpha', 36.7622184753418, 0.641621752732204, -85.0102767944336, -1.4837092280946, 218, 21, 'PPL', 'P'),
(44335, 'Alpha', 39.3211097717285, 0.686282831054779, -76.9280624389648, -1.34264797673972, 218, 25, 'PPL', 'P'),
(53165, 'Alpha', 39.985279083252, 0.697874772331566, -93.4208297729492, -1.63050106948311, 218, 29, 'PPL', 'P'),
(71649, 'Alpha', 39.711669921875, 0.693099391601918, -84.0233306884766, -1.46648376900591, 218, 41, 'PPL', 'P'),
(74978, 'Alpha', 35.8702812194824, 0.626054510896255, -98.0999984741211, -1.71216796957483, 218, 42, 'PPL', 'P'),
(84635, 'Alpha', 36.1769409179688, 0.631406732318014, -83.3827819824219, -1.45530408506587, 218, 50, 'PPL', 'P'),
(99382, 'Alpha', 37.5827789306641, 0.655943234389242, -78.4175033569336, -1.3686436247722, 218, 53, 'PPL', 'P'),
(114394, 'Alpha', 42.9966697692871, 0.750433454866771, -92.0475006103516, -1.60653195388212, 218, 16, 'PPL', 'P'),
(118602, 'Alpha', 41.1916694641113, 0.718930256541951, -90.379997253418, -1.57742853001558, 218, 18, 'PPL', 'P'),
(129507, 'Alpha', 46.0438919067383, 0.803617514204953, -88.3769378662109, -1.54246854859583, 218, 27, 'PPL', 'P'),
(133920, 'Alpha', 43.6388893127441, 0.761642300420751, -94.8705596923828, -1.6558036298419, 218, 28, 'PPL', 'P'),
(144744, 'Alpha', 40.6669387817383, 0.709771978448305, -75.1577835083008, -1.31175078072094, 218, 37, 'PPL', 'P'),
(172894, 'Alpha', 45.7724990844727, 0.798880815890138, -92.5794372558594, -1.61581599975825, 218, 57, 'PPL', 'P'),
(194511, 'Alpha', 44.3911094665527, 0.774771018804569, -116.006942749023, -2.02470310614302, 218, 17, 'PPL', 'P'),
(197926, 'Alpha', 46.6583290100098, 0.814341464703457, -103.819442749023, -1.81199110355621, 218, 34, 'PPL', 'P'),
(199805, 'Alpha', 40.0102806091309, 0.698311131276176, -116.192222595215, -2.02793684949665, 218, 39, 'PPL', 'P'),
(200316, 'Alpha', 44.1644401550293, 0.770814893005256, -123.699440002441, -2.15896251091579, 218, 43, 'PPL', 'P'),
(206675, 'Alpha', 46.6116714477539, 0.813527136621138, -122.60417175293, -2.13984647376925, 218, 56, 'PPL', 'P'),
(179692, 'Alpha (historical)', 39.3305587768555, 0.686447747305282, -120.781387329102, -2.10803288401938, 218, 6, 'PPL', 'P'),
(206676, 'Alpha (historical)', 47.6758308410645, 0.832100221800432, -117.16667175293, -2.04494419569206, 218, 56, 'PPL', 'P'),
(84636, 'Alpha Heights', 36.1847190856934, 0.631542486954581, -83.3880615234375, -1.45539623043958, 218, 50, 'PPL', 'P'),
(39084, 'Alpha Mobile Home Park', 32.3894386291504, 0.565302346951313, -93.7655563354492, -1.63651768301782, 218, 22, 'PPL', 'P'),
(58452, 'Alphaba', 34.7738914489746, 0.606918899515709, -89.8736114501953, -1.56859043046398, 218, 30, 'PPL', 'P'),
(144739, 'Alphano', 40.9022216796875, 0.713878439691152, -74.8619384765625, -1.30658731084144, 218, 37, 'PPL', 'P'),
(18815, 'Alpharetta', 34.0752792358398, 0.594725816201863, -84.2941665649414, -1.47121074678275, 218, 13, 'PPL', 'P'),
(18816, 'Alpharetta Woods', 34.1572189331055, 0.596155933707235, -84.2747192382813, -1.47087132690182, 218, 13, 'PPL', 'P'),
(18817, 'Alpharette', 34.0750007629395, 0.594720955932873, -84.2125015258789, -1.46978542296734, 218, 13, 'PPL', 'P'),
(39085, 'Alphenia Landing', 31.8194408416748, 0.555354008830781, -91.570556640625, -1.59820771126286, 218, 22, 'PPL', 'P'),
(107954, 'Alpheus', 37.3680610656738, 0.652195700682309, -81.5611114501953, -1.42350993639196, 218, 58, 'PPL', 'P'),
(179693, 'Alphine Village', 38.7730598449707, 0.676717555367541, -119.816940307617, -2.09120010803343, 218, 6, 'PPL', 'P'),
(34541, 'Alphoretta', 37.563060760498, 0.655599087397376, -82.7644424438477, -1.44451202422248, 218, 21, 'PPL', 'P'),
(146776, 'Alpina', 44.1691703796387, 0.770897450999049, -75.4269409179688, -1.31644846372579, 218, 40, 'PPL', 'P'),
(7074, 'Alpine', 34.7238883972168, 0.60604618162649, -92.4602813720703, -1.61373633726301, 218, 4, 'PPL', 'P'),
(14973, 'Alpine', 27.6319408416748, 0.482268346403519, -81.4763870239258, -1.42203121619669, 218, 12, 'PPL', 'P'),
(18818, 'Alpine', 34.4558296203613, 0.601367673381493, -85.4916687011719, -1.49211110185963, 218, 13, 'PPL', 'P'),
(29090, 'Alpine', 39.5538902282715, 0.690345616455749, -85.1758270263672, -1.48659862471928, 218, 19, 'PPL', 'P'),
(34542, 'Alpine', 36.9249992370605, 0.644462812983101, -84.5208282470703, -1.475166739424, 218, 21, 'PPL', 'P'),
(44336, 'Alpine', 39.4130592346191, 0.68788765192766, -77.3233337402344, -1.34954676238551, 218, 25, 'PPL', 'P'),
(58453, 'Alpine', 34.4952812194824, 0.602056233681333, -88.7977828979492, -1.54981368004033, 218, 30, 'PPL', 'P'),
(84637, 'Alpine', 36.394718170166, 0.635207662404803, -85.2169418334961, -1.487316213475, 218, 50, 'PPL', 'P'),
(99380, 'Alpine', 38.6705589294434, 0.67492857690528, -78.6350021362305, -1.37243969459, 218, 53, 'PPL', 'P'),
(112751, 'Alpine', 34.5052795410156, 0.60223073731176, -85.6102828979492, -1.49418131013301, 218, 2, 'PPL', 'P'),
(118603, 'Alpine', 41.5863914489746, 0.725819454807822, -87.8813934326172, -1.53381966663969, 218, 18, 'PPL', 'P'),
(129508, 'Alpine', 43.0727806091309, 0.751761839618502, -85.6849975585938, -1.49548532696076, 218, 27, 'PPL', 'P'),
(144740, 'Alpine', 40.9558296203613, 0.714814074761124, -73.9316711425781, -1.29035108293967, 218, 37, 'PPL', 'P'),
(146777, 'Alpine', 42.313060760498, 0.738502226867107, -76.7244415283203, -1.33909412142306, 218, 40, 'PPL', 'P'),
(158651, 'Alpine', 40.0786094665527, 0.699503694812313, -76.8730621337891, -1.3416880403248, 218, 45, 'PPL', 'P'),
(179696, 'Alpine', 32.8349990844727, 0.573078843913372, -116.765556335449, -2.03794341097651, 218, 6, 'PPL', 'P'),
(186328, 'Alpine', 37.6891708374023, 0.657800123459299, -106.588333129883, -1.86031735732901, 218, 7, 'PPL', 'P'),
(191065, 'Alpine', 30.3583297729492, 0.529852809944186, -103.66056060791, -1.80921808707117, 218, 51, 'PPL', 'P'),
(193008, 'Alpine', 33.8480606079102, 0.590760103022626, -109.142501831055, -1.90489601081584, 218, 5, 'PPL', 'P'),
(194512, 'Alpine', 44.5936088562012, 0.778305299887213, -116.49388885498, -2.03320191897174, 218, 17, 'PPL', 'P'),
(195861, 'Alpine', 45.2013893127441, 0.788913069983162, -109.640556335449, -1.91358870177192, 218, 31, 'PPL', 'P'),
(200317, 'Alpine', 44.3302803039551, 0.773709349636009, -123.359169006348, -2.15302366168491, 218, 43, 'PPL', 'P'),
(202867, 'Alpine', 40.4533309936523, 0.706043819238303, -111.777221679688, -1.95088054704213, 218, 52, 'PPL', 'P'),
(206677, 'Alpine', 45.788330078125, 0.799157118853234, -122.423057556152, -2.13668543471338, 218, 56, 'PPL', 'P'),
(209265, 'Alpine', 43.1752815246582, 0.753550818080763, -111.033889770508, -1.93790695779181, 218, 59, 'PPL', 'P'),
(212273, 'Alpine', 70.3280563354492, 1.22745613958165, -150.977493286133, -2.63505435425065, 218, 1, 'PPL', 'P'),
(179697, 'Alpine (historical)', 34.4375, 0.601047761155547, -118.336387634277, -2.06535958913444, 218, 6, 'PPL', 'P'),
(186329, 'Alpine (historical)', 38.711109161377, 0.675636311964969, -106.276390075684, -1.8548729239545, 218, 7, 'PPL', 'P'),
(189862, 'Alpine (historical)', 38.0269393920898, 0.663695296848299, -117.563606262207, -2.05187200979374, 218, 39, 'PPL', 'P'),
(84638, 'Alpine Acres', 36.1022186279297, 0.630102582332203, -84.9000015258789, -1.4817845615748, 218, 50, 'PPL', 'P'),
(112754, 'Alpine Bay', 33.4480590820313, 0.583778759383037, -86.295280456543, -1.50613677289859, 218, 2, 'PPL', 'P'),
(188027, 'Alpine Cellars Village', 33.374439239502, 0.582493850736101, -105.691390991211, -1.8446627638093, 218, 38, 'PPL', 'P'),
(14974, 'Alpine Heights', 30.7447204589844, 0.53659659961454, -86.2099990844727, -1.50464833216535, 218, 12, 'PPL', 'P'),
(158652, 'Alpine Heights', 40.2533302307129, 0.702553147418509, -76.6766662597656, -1.33826028568576, 218, 45, 'PPL', 'P'),
(179717, 'Alpine Heights', 32.8180618286133, 0.572783233032373, -116.779998779297, -2.03819547917369, 218, 6, 'PPL', 'P'),
(99381, 'Alpine Hills', 37.3455581665039, 0.65180295100055, -79.9680633544922, -1.39570600197931, 218, 53, 'PPL', 'P'),
(146778, 'Alpine Junction', 42.2936096191406, 0.738162740407149, -76.710563659668, -1.33885190692192, 218, 40, 'PPL', 'P'),
(209266, 'Alpine Junction', 43.1725006103516, 0.753502281969896, -111.017776489258, -1.9376257279807, 218, 59, 'PPL', 'P'),
(107955, 'Alpine Lake', 39.4747200012207, 0.688963835324161, -79.5008316040039, -1.38755126956343, 218, 58, 'PPL', 'P'),
(179699, 'Alpine Meadows', 39.1786117553711, 0.683795771491781, -120.226669311523, -2.09835122819251, 218, 6, 'PPL', 'P'),
(195862, 'Alpine Mobile Manor', 48.2000007629395, 0.841248712777072, -114.300003051758, -1.99491138829274, 218, 31, 'PPL', 'P'),
(202844, 'Alpine Ranchettes', 41.209171295166, 0.719235721118983, -112.047218322754, -1.95559287743297, 218, 52, 'PPL', 'P'),
(202845, 'Alpine Ranchettes Two', 41.2058296203613, 0.71917739789111, -112.047218322754, -1.95559287743297, 218, 52, 'PPL', 'P'),
(112755, 'Alpine Shores', 34.2166709899902, 0.597193567846957, -85.5263900756836, -1.49271710416568, 218, 2, 'PPL', 'P'),
(71650, 'Alpine Terrace', 39.0905609130859, 0.682258994384751, -84.2919387817383, -1.47117186463083, 218, 41, 'PPL', 'P'),
(195863, 'Alpine Trailer Court', 45.6805610656738, 0.797276194754338, -111.022216796875, -1.93770322596842, 218, 31, 'PPL', 'P'),
(44337, 'Alpine View', 39.5338897705078, 0.689996542615867, -77.5708312988281, -1.35386640967362, 218, 25, 'PPL', 'P'),
(171685, 'Alpine Village', 44.0686111450195, 0.769142361261659, -72.834716796875, -1.27120561786309, 218, 55, 'PPL', 'P'),
(179700, 'Alpine Village', 33.6061096191406, 0.586537261640142, -116.468887329102, -2.03276556002713, 218, 6, 'PPL', 'P'),
(146779, 'Alplaus', 42.855281829834, 0.747965769800703, -73.8994369506836, -1.28978849015939, 218, 40, 'PPL', 'P'),
(107956, 'Alpoca', 37.5436096191406, 0.655259600937418, -81.3891677856445, -1.4205089533176, 218, 58, 'PPL', 'P'),
(206678, 'Alpowa', 46.4194412231445, 0.810172086279856, -117.195556640625, -2.04544833208641, 218, 56, 'PPL', 'P'),
(18820, 'Alps', 33.1480598449707, 0.57854278494286, -84.6033325195313, -1.47660671062541, 218, 13, 'PPL', 'P'),
(158653, 'Alpsville', 40.3055610656738, 0.703464747459643, -79.7958297729492, -1.39269995889888, 218, 45, 'PPL', 'P'),
(29091, 'Alquina', 39.6127815246582, 0.691373463478465, -85.0547180175781, -1.48448487376208, 218, 19, 'PPL', 'P'),
(179701, 'Alray', 34.3283309936523, 0.59914240255365, -117.481941223145, -2.05044668597833, 218, 6, 'PPL', 'P'),
(7076, 'Alread', 35.6327781677246, 0.621909300659547, -92.6797180175781, -1.61756622922665, 218, 4, 'PPL', 'P'),
(194513, 'Alridge', 43.2113914489746, 0.75418105515273, -112.004173278809, -1.95484159968946, 218, 17, 'PPL', 'P'),
(92208, 'Alsa', 32.8183288574219, 0.57278789356428, -96.0336074829102, -1.67610264314465, 218, 51, 'PPL', 'P'),
(179702, 'Alsace', 33.9786109924316, 0.59303863707227, -118.41471862793, -2.06672672288004, 218, 6, 'PPL', 'P'),
(158654, 'Alsace Manor', 40.3997192382813, 0.705108117589303, -75.8608322143555, -1.32402129544348, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(39086, 'Alsatia', 32.6127815246582, 0.569200415838862, -91.1822204589844, -1.59142996628861, 218, 22, 'PPL', 'P'),
(92209, 'Alsdorf', 32.4049987792969, 0.565573922803474, -96.5355606079102, -1.68486337786657, 218, 51, 'PPL', 'P'),
(200318, 'Alsea', 44.3816719055176, 0.774606302291147, -123.595283508301, -2.1571446371557, 218, 43, 'PPL', 'P'),
(200319, 'Alsea Rivera', 44.4055595397949, 0.775023220159799, -123.897216796875, -2.16241436716269, 218, 43, 'PPL', 'P'),
(39087, 'Alsen', 30.5711097717285, 0.533566521505275, -91.2041702270508, -1.59181306201142, 218, 22, 'PPL', 'P'),
(139588, 'Alsen', 48.6305618286133, 0.848763421003976, -98.7044372558594, -1.7227174164429, 218, 34, 'PPL', 'P'),
(146780, 'Alsen', 42.1580581665039, 0.735796921252777, -73.9197235107422, -1.29014255742631, 218, 40, 'PPL', 'P'),
(169717, 'Alsen', 42.961109161377, 0.749812805174728, -96.8052825927734, -1.68957091456745, 218, 49, 'PPL', 'P'),
(39088, 'Alsen Heights', 30.5755596160889, 0.533644185940564, -91.2058334350586, -1.5918420904673, 218, 22, 'PPL', 'P'),
(26359, 'Alsey', 39.5605583190918, 0.690461996595385, -90.4338912963867, -1.57836915851259, 218, 18, 'PPL', 'P'),
(118604, 'Alsip', 41.6688919067383, 0.727259359430201, -87.7386093139648, -1.53132761364965, 218, 18, 'PPL', 'P'),
(92210, 'Alsonia Colonia', 26.4379997253418, 0.461430142848571, -98.1460037231445, -1.71297091264349, 218, 51, 'PPL', 'P'),
(99387, 'Alsop', 38.2069396972656, 0.666836894828211, -77.6497192382813, -1.35524326395719, 218, 53, 'PPL', 'P'),
(177438, 'Alsop Corner', 41.8052787780762, 0.729639759391541, -72.8180618286133, -1.2709149338301, 218, 8, 'PPL', 'P'),
(62504, 'Alspaugh', 36.1452789306641, 0.630854126391823, -80.2558288574219, -1.40072845747909, 218, 33, 'PPL', 'P'),
(143456, 'Alstead', 43.1488914489746, 0.753090224370234, -72.3611068725586, -1.26293956531364, 218, 36, 'PPL', 'P'),
(143457, 'Alstead Center', 43.1186103820801, 0.752561720051908, -72.3263931274414, -1.26233369616565, 218, 36, 'PPL', 'P'),
(18821, 'Alston', 32.0805587768555, 0.559911376535693, -82.477783203125, -1.43950887664061, 218, 13, 'PPL', 'P'),
(74979, 'Alston', 36.4361114501953, 0.635930111429514, -99.2900009155273, -1.73293743028414, 218, 42, 'PPL', 'P'),
(79516, 'Alston', 34.2433280944824, 0.597658822089394, -81.3169403076172, -1.41924834601561, 218, 48, 'PPL', 'P'),
(129510, 'Alston', 46.7683296203613, 0.816261337533295, -88.753059387207, -1.54903310752482, 218, 27, 'PPL', 'P'),
(200320, 'Alston', 46.0994415283203, 0.804587037999796, -123.045829772949, -2.14755486038643, 218, 43, 'PPL', 'P'),
(206679, 'Alstown', 47.5611114501953, 0.830097990713883, -119.99388885498, -2.09428844279154, 218, 56, 'PPL', 'P'),
(74980, 'Alsuma', 36.0950012207031, 0.629976614812642, -95.8633270263672, -1.67313068852617, 218, 42, 'PPL', 'P'),
(53167, 'Alsup', 37.3980598449707, 0.652719278152619, -93.3052825927734, -1.62848439074765, 218, 29, 'PPL', 'P'),
(113361, 'Alsville', 44.586669921875, 0.778184192636642, -97.1277770996094, -1.69519950553133, 218, 49, 'PPL', 'P'),
(29092, 'Alta', 39.7722206115723, 0.694156200501489, -87.3866729736328, -1.52518516575344, 218, 19, 'PPL', 'P'),
(107959, 'Alta', 37.8694381713867, 0.660946381971119, -80.5430603027344, -1.40574159191506, 218, 58, 'PPL', 'P'),
(112758, 'Alta', 33.6708297729492, 0.587666841416499, -87.5316696166992, -1.52771583457928, 218, 2, 'PPL', 'P'),
(114395, 'Alta', 42.6736106872559, 0.744795010206855, -95.290283203125, -1.66312918705238, 218, 16, 'PPL', 'P'),
(118605, 'Alta', 40.8108291625977, 0.712283339356249, -89.6341705322266, -1.56441139808143, 218, 18, 'PPL', 'P'),
(154049, 'Alta', 40.7324981689453, 0.710916205610657, -82.5697174072266, -1.44111343119738, 218, 41, 'PPL', 'P'),
(179703, 'Alta', 39.2066688537598, 0.684285460237219, -120.810279846191, -2.10853715357179, 218, 6, 'PPL', 'P'),
(186330, 'Alta', 37.8863906860352, 0.661242259168227, -107.85221862793, -1.88237632063813, 218, 7, 'PPL', 'P'),
(195864, 'Alta', 45.6188888549805, 0.796199811620755, -114.298889160156, -1.99489194721678, 218, 31, 'PPL', 'P'),
(202846, 'Alta', 40.5888900756836, 0.708409771550729, -111.637222290039, -1.94843709674199, 218, 52, 'PPL', 'P'),
(209267, 'Alta', 43.7538909912109, 0.763649458355316, -111.036109924316, -1.93794570678567, 218, 59, 'PPL', 'P'),
(179704, 'Alta (historical)', 32.7797203063965, 0.572114047229463, -116.988059997559, -2.04182683247807, 218, 6, 'PPL', 'P'),
(179705, 'Alta Hill', 39.2299995422363, 0.684692657567892, -121.075561523438, -2.11316719228495, 218, 6, 'PPL', 'P'),
(202852, 'Alta Hills', 40.5930595397949, 0.708482542427516, -111.801109313965, -1.95129746491079, 218, 52, 'PPL', 'P'),
(179706, 'Alta Loma', 34.1222190856934, 0.595545071132198, -117.597221374512, -2.05245870418188, 218, 6, 'PPL', 'P'),
(158656, 'Alta Manor', 40.5316696166992, 0.707411086141949, -78.4047164916992, -1.36842045187285, 218, 45, 'PPL', 'P'),
(179707, 'Alta Mesa', 37.3988914489746, 0.65273379238056, -122.133613586426, -2.13163368444161, 218, 6, 'PPL', 'P'),
(31636, 'Alta Mills', 38.1177787780762, 0.66528074322425, -97.591667175293, -1.70329591471934, 218, 20, 'PPL', 'P'),
(193010, 'Alta Mira', 33.3255615234375, 0.581640773659922, -111.906936645508, -1.95314450028481, 218, 5, 'PPL', 'P'),
(179709, 'Alta Sierra', 39.1416702270508, 0.683151020191873, -121.052780151367, -2.1127695823342, 218, 6, 'PPL', 'P'),
(179710, 'Alta Sierra Estates', 39.1141700744629, 0.682671051984413, -121.054168701172, -2.11279381710012, 218, 6, 'PPL', 'P'),
(179711, 'Alta Sierra Ranches', 39.1044387817383, 0.682501208885893, -121.023612976074, -2.11226051909183, 218, 6, 'PPL', 'P'),
(99383, 'Alta View', 37.2783317565918, 0.650629628803288, -80.0780563354492, -1.39762574165109, 218, 53, 'PPL', 'P'),
(18822, 'Alta Vista', 32.4813919067383, 0.566907234403222, -84.9250030517578, -1.48222092051941, 218, 13, 'PPL', 'P'),
(31637, 'Alta Vista', 38.8638916015625, 0.678302868585438, -96.4888916015625, -1.68404885004717, 218, 20, 'PPL', 'P'),
(44338, 'Alta Vista', 39.0088882446289, 0.680833537411286, -77.10888671875, -1.34580395578951, 218, 25, 'PPL', 'P'),
(53168, 'Alta Vista', 39.9091682434082, 0.696546387579835, -94.2050018310547, -1.64418745379919, 218, 29, 'PPL', 'P'),
(84641, 'Alta Vista', 35.4638900756836, 0.61896164738602, -84.6161117553711, -1.4768297503667, 218, 50, 'PPL', 'P'),
(112757, 'Alta Vista', 32.6547203063965, 0.56993238566447, -85.3938903808594, -1.49040454823311, 218, 2, 'PPL', 'P'),
(114396, 'Alta Vista', 43.1986083984375, 0.753957948832409, -92.4169387817383, -1.61297986635537, 218, 16, 'PPL', 'P'),
(179712, 'Alta Vista', 37.4127807617188, 0.652976206618784, -118.54167175293, -2.06894247290698, 218, 6, 'PPL', 'P'),
(186331, 'Alta Vista', 39.0269393920898, 0.681148589368242, -104.111938476563, -1.81709611704978, 218, 7, 'PPL', 'P'),
(188028, 'Alta Vista', 35.5349998474121, 0.620202747033024, -104.743057250977, -1.82811121763446, 218, 38, 'PPL', 'P'),
(206680, 'Alta Vista', 46.4997215270996, 0.811573241908374, -122.371109008789, -2.13577876152026, 218, 56, 'PPL', 'P'),
(179713, 'Alta Vista (historical)', 36.0550003051758, 0.629278467132878, -118.96305847168, -2.07629705857334, 218, 6, 'PPL', 'P'),
(92212, 'Alta Vista Colonia', 26.3020000457764, 0.459056500658497, -98.3519973754883, -1.71656618011509, 218, 51, 'PPL', 'P'),
(179714, 'Alta Vista Park', 39.2275009155273, 0.684649048305042, -121.065559387207, -2.11299262207549, 218, 6, 'PPL', 'P'),
(202856, 'Alta Vista Subdivision Number 1', 40.5666694641113, 0.708021948716986, -111.816673278809, -1.95156910734197, 218, 52, 'PPL', 'P'),
(44339, 'Alta Vista Terrace', 39.0052795410156, 0.680770553651505, -77.1208267211914, -1.34601234814481, 218, 25, 'PPL', 'P'),
(179715, 'Altacanyada', 34.2222213745117, 0.597290440331609, -118.211112976074, -2.06317313387949, 218, 6, 'PPL', 'P'),
(179716, 'Altadena', 34.1897201538086, 0.596723187019422, -118.130279541016, -2.06176232429202, 218, 6, 'PPL', 'P'),
(112756, 'Altadena Ridge Estates', 33.4333305358887, 0.583521697758818, -86.7466735839844, -1.51401506919332, 218, 2, 'PPL', 'P'),
(112762, 'Altadena Woods', 33.4052810668945, 0.583032142171434, -86.7474975585938, -1.5140294502632, 218, 2, 'PPL', 'P'),
(92213, 'Altair', 29.5711097717285, 0.516113228985331, -96.4538879394531, -1.68343792089311, 218, 51, 'PPL', 'P'),
(18824, 'Altamaha', 31.961389541626, 0.557831481013854, -82.2074966430664, -1.43479148624369, 218, 13, 'PPL', 'P'),
(18825, 'Altamaha Park', 31.4263896942139, 0.548493972178846, -81.6072235107422, -1.42431474367338, 218, 13, 'PPL', 'P'),
(62505, 'Altamahaw', 36.1841697692871, 0.631532899574657, -79.5074996948242, -1.38766764970307, 218, 33, 'PPL', 'P'),
(92214, 'Altamira West Number 2 Colonia', 26.2900009155273, 0.458847076328276, -98.1869964599609, -1.71368637087034, 218, 51, 'PPL', 'P'),
(26362, 'Altamont', 38.9230613708496, 0.679335575877143, -90.209716796875, -1.5744565753971, 218, 18, 'PPL', 'P'),
(31639, 'Altamont', 37.1902809143066, 0.649092851696258, -95.2969436645508, -1.66324543403396, 218, 20, 'PPL', 'P'),
(44340, 'Altamont', 39.4275016784668, 0.688139720124836, -79.2822189331055, -1.38373575866968, 218, 25, 'PPL', 'P'),
(53169, 'Altamont', 39.8886108398438, 0.696187593201974, -94.0888900756836, -1.6421609213677, 218, 29, 'PPL', 'P'),
(62506, 'Altamont', 35.9908294677734, 0.628158474736445, -81.9444427490234, -1.43020032968245, 218, 33, 'PPL', 'P'),
(84640, 'Altamont', 35.4294395446777, 0.618360372190907, -85.7230606079102, -1.49614965249468, 218, 50, 'PPL', 'P'),
(146781, 'Altamont', 42.7005615234375, 0.74526539103439, -74.0341720581055, -1.29214006140193, 218, 40, 'PPL', 'P'),
(154050, 'Altamont', 40.3333282470703, 0.70394937619901, -80.6177825927734, -1.40704574190087, 218, 41, 'PPL', 'P'),
(158657, 'Altamont', 40.7861099243164, 0.711851907259657, -76.2252807617188, -1.33038212254908, 218, 45, 'PPL', 'P'),
(169718, 'Altamont', 44.8397216796875, 0.782600778988429, -96.6891708374023, -1.68754438213595, 218, 49, 'PPL', 'P'),
(179720, 'Altamont', 37.7438888549805, 0.658755133026202, -121.661666870117, -2.12339666034805, 218, 6, 'PPL', 'P'),
(200321, 'Altamont', 42.2069396972656, 0.736650064907984, -121.736106872559, -2.12469588348584, 218, 43, 'PPL', 'P'),
(202857, 'Altamont', 40.3594398498535, 0.70440510964055, -110.28556060791, -1.92484615001579, 218, 52, 'PPL', 'P'),
(209268, 'Altamont', 41.1922187805176, 0.718939843921875, -110.788887023926, -1.93363085318753, 218, 59, 'PPL', 'P'),
(112764, 'Altamont Park', 33.5094413757324, 0.584850082510549, -86.7655563354492, -1.51434463537821, 218, 2, 'PPL', 'P'),
(44341, 'Altamont Place', 39.6027793884277, 0.69119889326901, -75.934440612793, -1.32530600435334, 218, 25, 'PPL', 'P'),
(122130, 'Altamont Switch', 40.3786087036133, 0.704739669252491, -86.8744430541992, -1.5162450671321, 218, 19, 'PPL', 'P'),
(14975, 'Altamonte Springs', 28.6608295440674, 0.500225841896841, -81.3658294677734, -1.42010162282887, 218, 12, 'PPL', 'P'),
(62508, 'Altapass', 35.8933296203613, 0.626456781378911, -82.0180587768555, -1.43148517175036, 218, 33, 'PPL', 'P'),
(179718, 'Altaville', 38.0838890075684, 0.664689255146144, -120.560829162598, -2.10418341782173, 218, 6, 'PPL', 'P'),
(99384, 'Altavista', 37.1116714477539, 0.647720857681676, -79.2858276367188, -1.38379874242946, 218, 53, 'PPL', 'P'),
(202860, 'Altawood', 40.5811080932617, 0.708273950335135, -111.802780151367, -1.95132662652472, 218, 52, 'PPL', 'P'),
(202862, 'Altawood Subdivision Number 3', 40.5791702270508, 0.708240128189291, -111.804168701172, -1.95135086129064, 218, 52, 'PPL', 'P'),
(146782, 'Altay', 42.4394416809082, 0.740707990039965, -77.0202789306641, -1.34425745814451, 218, 40, 'PPL', 'P'),
(179719, 'Alten', 38.3813896179199, 0.669881620323471, -122.805282592773, -2.14335652008598, 218, 6, 'PPL', 'P'),
(53180, 'Altenburg', 37.6308288574219, 0.656781863816507, -89.5852813720703, -1.56355812126817, 218, 29, 'PPL', 'P'),
(77780, 'Altenwald', 39.8450012207031, 0.695426461762429, -77.603889465332, -1.35444338352379, 218, 45, 'PPL', 'P'),
(118606, 'Altgeld Gardens', 41.6544418334961, 0.727007158074971, -87.601936340332, -1.52894222026127, 218, 18, 'PPL', 'P'),
(14976, 'Altha', 30.5702800750732, 0.533552040566847, -85.1272201538086, -1.48575027475403, 218, 12, 'PPL', 'P'),
(7077, 'Altharp (historical)', 34.5933303833008, 0.603767514418791, -92.370002746582, -1.61216067800406, 218, 4, 'PPL', 'P'),
(53170, 'Althea', 36.6413917541504, 0.639512928623025, -92.2286071777344, -1.60969285977994, 218, 29, 'PPL', 'P'),
(79517, 'Althea (historical)', 33.8122215270996, 0.590134593061593, -81.4638900756836, -1.42181310330341, 218, 48, 'PPL', 'P'),
(53171, 'Altheim', 38.6313896179199, 0.674244943453457, -90.4877777099609, -1.57930965385155, 218, 29, 'PPL', 'P'),
(7078, 'Altheimer', 34.3191719055176, 0.598982546309218, -91.8472213745117, -1.60303642179334, 218, 4, 'PPL', 'P'),
(158658, 'Althom', 41.7533302307129, 0.728733086198424, -79.3030624389648, -1.38409954647458, 218, 45, 'PPL', 'P'),
(77778, 'Althouse', 39.8880615234375, 0.69617800582205, -79.0311126708984, -1.37935312762179, 218, 45, 'PPL', 'P'),
(200322, 'Althouse (historical)', 42.1263885498047, 0.735244182168531, -123.576393127441, -2.15681493781275, 218, 43, 'PPL', 'P'),
(58454, 'Altitude', 34.6683311462402, 0.605076524673592, -88.4430618286133, -1.54362262945422, 218, 30, 'PPL', 'P'),
(71651, 'Altitude', 39.753059387207, 0.693821774047602, -81.0236129760742, -1.4141288182941, 218, 41, 'PPL', 'P'),
(107960, 'Altizer', 38.827220916748, 0.677662844396465, -81.148063659668, -1.41630089247917, 218, 58, 'PPL', 'P'),
(18827, 'Altman', 32.7255592346191, 0.571168758200539, -81.6305618286133, -1.4247220741621, 218, 13, 'PPL', 'P'),
(107962, 'Altman', 38.1644401550293, 0.666095137885596, -81.8680572509766, -1.42886715124076, 218, 58, 'PPL', 'P'),
(158659, 'Altman', 40.9755592346191, 0.715158421490072, -80.2788925170898, -1.40113099427786, 218, 45, 'PPL', 'P'),
(186332, 'Altman (historical)', 38.7361106872559, 0.676072670909578, -105.133331298828, -1.83492278475456, 218, 7, 'PPL', 'P'),
(118607, 'Altmar', 41.1419410705566, 0.718062332342694, -88.8925018310547, -1.55146683728699, 218, 18, 'PPL', 'P'),
(146783, 'Altmar', 43.5099983215332, 0.759392728247961, -76.0025024414063, -1.32649390735757, 218, 40, 'PPL', 'P'),
(18828, 'Alto', 34.4672203063965, 0.601566478356867, -83.5738906860352, -1.45863956117314, 218, 13, 'PPL', 'P'),
(39089, 'Alto', 32.3574981689453, 0.564744880756132, -91.8597183227539, -1.60325453468662, 218, 22, 'PPL', 'P'),
(84642, 'Alto', 35.2705612182617, 0.615587422284889, -85.9530563354492, -1.50016383520576, 218, 50, 'PPL', 'P'),
(92215, 'Alto', 31.6502799987793, 0.552401595156806, -95.0725021362305, -1.65932819038656, 218, 51, 'PPL', 'P'),
(99385, 'Alto', 37.7719383239746, 0.659244688613586, -79.2280578613281, -1.38279046964075, 218, 53, 'PPL', 'P'),
(112220, 'Alto', 35.5699996948242, 0.620813609608061, -90.3311080932617, -1.57657525320231, 218, 4, 'PPL', 'P'),
(122131, 'Alto', 40.439998626709, 0.705811125538057, -86.1655578613281, -1.50387268649786, 218, 19, 'PPL', 'P'),
(129511, 'Alto', 42.8566703796387, 0.747990004566623, -85.3802795410156, -1.49016699426388, 218, 27, 'PPL', 'P'),
(172895, 'Alto', 43.6766700744629, 0.762301699106654, -88.7949981689453, -1.54976507735043, 218, 57, 'PPL', 'P'),
(188029, 'Alto', 33.398609161377, 0.58291569545277, -105.680282592773, -1.84446888568195, 218, 38, 'PPL', 'P'),
(192889, 'Alto', 37.9044418334961, 0.661557311125183, -122.524436950684, -2.13845483894163, 218, 6, 'PPL', 'P'),
(193009, 'Alto', 31.6044406890869, 0.551601548275832, -110.877502441406, -1.93517748399059, 218, 5, 'PPL', 'P'),
(201855, 'Alto', 44.3300018310547, 0.773704489367019, -100.126937866211, -1.74754473570517, 218, 49, 'PPL', 'P'),
(206681, 'Alto', 46.3863906860352, 0.809595245587745, -118.110557556152, -2.06141811072113, 218, 56, 'PPL', 'P'),
(92216, 'Alto Bonito', 26.3072204589844, 0.459147614057291, -98.6399993896484, -1.72159276351456, 218, 51, 'PPL', 'P'),
(92217, 'Alto Bonito Colonia', 26.3040008544922, 0.459091421358291, -98.6399993896484, -1.72159276351456, 218, 51, 'PPL', 'P'),
(92218, 'Alto Bonito Heights Colonia', 26.3150005340576, 0.459283401983372, -98.640998840332, -1.7216102072197, 218, 51, 'PPL', 'P'),
(92219, 'Alto Colorado', 27.1563892364502, 0.473968405129205, -98.1266708374023, -1.71263349013337, 218, 51, 'PPL', 'P'),
(158660, 'Alto Grandview Acres', 40.2666702270508, 0.702785974276809, -75.5999984741211, -1.3194688878761, 218, 45, 'PPL', 'P'),
(26363, 'Alto Pass', 37.5702781677246, 0.655725054916937, -89.317497253418, -1.55888440671314, 218, 18, 'PPL', 'P'),
(92220, 'Alto Real Colonia', 26.1490001678467, 0.456386149033474, -97.8570022583008, -1.70792688553888, 218, 51, 'PPL', 'P'),
(92221, 'Alto Springs', 31.2858295440674, 0.546040734761692, -96.670280456543, -1.687214682793, 218, 51, 'PPL', 'P'),
(44342, 'Alto Vista', 39.5541687011719, 0.690350476724738, -76.9905624389648, -1.34373880752221, 218, 25, 'PPL', 'P'),
(92222, 'Altoga', 33.2497215270996, 0.580317116019125, -96.4891662597656, -1.68405364373713, 218, 51, 'PPL', 'P'),
(14977, 'Alton', 30.0527801513672, 0.524519963019357, -83.1380615234375, -1.4510329073096, 218, 12, 'PPL', 'P'),
(26365, 'Alton', 38.8905601501465, 0.678768322564956, -90.1841735839844, -1.57401076223062, 218, 18, 'PPL', 'P'),
(29093, 'Alton', 38.122501373291, 0.665363168059988, -86.4177780151367, -1.50827475862171, 218, 19, 'PPL', 'P'),
(31640, 'Alton', 39.4708290100098, 0.688895924716364, -98.9477767944336, -1.72696449259131, 218, 20, 'PPL', 'P'),
(34546, 'Alton', 38.0888900756836, 0.664776540250871, -84.9349975585938, -1.48239535757081, 218, 21, 'PPL', 'P'),
(39090, 'Alton', 30.3305606842041, 0.529368147915306, -89.7619400024414, -1.56664139602021, 218, 22, 'PPL', 'P'),
(53172, 'Alton', 36.6941719055176, 0.640434116044083, -91.399169921875, -1.59521644872649, 218, 29, 'PPL', 'P'),
(62509, 'Alton', 34.8808288574219, 0.608785309386663, -80.5419387817383, -1.40572201768104, 218, 33, 'PPL', 'P'),
(71652, 'Alton', 39.9502792358398, 0.69726390975653, -83.1747207641602, -1.45167273176149, 218, 41, 'PPL', 'P'),
(92223, 'Alton', 26.2869396209717, 0.458793646658906, -98.3130569458008, -1.7158865414049, 218, 51, 'PPL', 'P'),
(99386, 'Alton', 36.5730590820313, 0.63832029850786, -79.003059387207, -1.37886350545538, 218, 53, 'PPL', 'P'),
(107963, 'Alton', 38.8191719055176, 0.677522362648963, -80.2141723632813, -1.4000014145015, 218, 58, 'PPL', 'P'),
(112763, 'Alton', 33.5791702270508, 0.586067080549688, -86.6374969482422, -1.51210957743337, 218, 2, 'PPL', 'P'),
(114397, 'Alton', 42.9874992370605, 0.750273398885257, -96.0102767944336, -1.67569544581397, 218, 16, 'PPL', 'P'),
(126754, 'Alton', 45.0313911437988, 0.785946042212705, -68.7291717529297, -1.19955033925731, 218, 26, 'PPL', 'P'),
(129513, 'Alton', 43.0163917541504, 0.750777668437663, -85.3516693115234, -1.48966765155949, 218, 27, 'PPL', 'P'),
(139591, 'Alton', 47.3555603027344, 0.826510446409437, -97.045280456543, -1.69375966748798, 218, 34, 'PPL', 'P'),
(143459, 'Alton', 43.452220916748, 0.758384322301202, -71.2180633544922, -1.24298969242981, 218, 36, 'PPL', 'P'),
(146784, 'Alton', 43.211109161377, 0.754176128304714, -76.980827331543, -1.34356889784467, 218, 40, 'PPL', 'P'),
(169252, 'Alton', 41.4375, 0.72322080879515, -71.7177810668945, -1.25171141184176, 218, 47, 'PPL', 'P'),
(193082, 'Alton', 37.4377784729004, 0.653412498984366, -112.481941223145, -1.96318022337861, 218, 52, 'PPL', 'P'),
(193344, 'Alton', 40.5475006103516, 0.707687389105045, -124.139717102051, -2.1666467959251, 218, 6, 'PPL', 'P'),
(194514, 'Alton', 42.2275009155273, 0.737008925864872, -111.150833129883, -1.93994800445125, 218, 17, 'PPL', 'P'),
(7079, 'Alton (historical)', 33.5625, 0.585776130200597, -93.5897216796875, -1.63344878933566, 218, 4, 'PPL', 'P'),
(18829, 'Alton (historical)', 31.8969402313232, 0.556706628348432, -81.9094390869141, -1.42958940052839, 218, 13, 'PPL', 'P'),
(39091, 'Alton (historical)', 31.4422206878662, 0.548770275141942, -91.8119430541992, -1.60242069894932, 218, 22, 'PPL', 'P'),
(143460, 'Alton Bay', 43.4686088562012, 0.758670345802277, -71.2324981689453, -1.24324162746893, 218, 36, 'PPL', 'P'),
(92224, 'Alton North', 26.2950000762939, 0.45893432814349, -98.3041687011719, -1.71573141227141, 218, 51, 'PPL', 'P'),
(84644, 'Alton Park', 35.003059387207, 0.610918634577871, -85.3166732788086, -1.48905685556348, 218, 50, 'PPL', 'P'),
(34543, 'Alton Station', 38.0780601501465, 0.664587522392503, -84.9422225952148, -1.48252145824842, 218, 21, 'PPL', 'P'),
(34544, 'Altona', 37.0522193908691, 0.646683223541954, -88.396110534668, -1.5428031747868, 218, 21, 'PPL', 'P'),
(53173, 'Altona', 38.3997192382813, 0.670201532549417, -94.2347183227539, -1.64470610442148, 218, 29, 'PPL', 'P'),
(74981, 'Altona', 35.7830581665039, 0.624532181438138, -98.1708297729492, -1.71340420895284, 218, 42, 'PPL', 'P'),
(118609, 'Altona', 41.1147193908691, 0.717587224404224, -90.164436340332, -1.57366628234362, 218, 18, 'PPL', 'P'),
(122132, 'Altona', 41.351390838623, 0.721717920412991, -85.1549987792969, -1.48623510323048, 218, 19, 'PPL', 'P'),
(129514, 'Altona', 43.5397186279297, 0.759911445449281, -85.313606262207, -1.48900332602557, 218, 27, 'PPL', 'P'),
(141157, 'Altona', 42.1049995422363, 0.734870873562729, -96.991943359375, -1.69282875952894, 218, 35, 'PPL', 'P'),
(146785, 'Altona', 44.8883285522461, 0.783449128953674, -73.6561126708984, -1.28554168032709, 218, 40, 'PPL', 'P'),
(194084, 'Altona', 40.1338882446289, 0.700468491496222, -105.282218933105, -1.8375213641882, 218, 7, 'PPL', 'P'),
(158662, 'Altonah', 40.6561088562012, 0.709582960589936, -75.3613891601563, -1.31530436972149, 218, 45, 'PPL', 'P'),
(202863, 'Altonah', 40.4013900756836, 0.70513727920324, -110.293060302734, -1.92497704438337, 218, 52, 'PPL', 'P'),
(84643, 'Altonville', 36.3980598449707, 0.635265985632676, -83.1236114501953, -1.45078070595437, 218, 50, 'PPL', 'P'),
(14978, 'Altoona', 28.9655609130859, 0.505544407620325, -81.6488876342773, -1.42504191980902, 218, 12, 'PPL', 'P'),
(31641, 'Altoona', 37.5238914489746, 0.654915453945553, -95.6611099243164, -1.66960133429154, 218, 20, 'PPL', 'P'),
(39092, 'Altoona', 32.4544410705566, 0.566436853575687, -91.45361328125, -1.59616666460343, 218, 22, 'PPL', 'P'),
(71653, 'Altoona', 39.1133308410645, 0.682656404598418, -82.586669921875, -1.44140930839449, 218, 41, 'PPL', 'P'),
(112765, 'Altoona', 34.0261116027832, 0.593867679119612, -86.3261108398438, -1.50667486459684, 218, 2, 'PPL', 'P'),
(114398, 'Altoona', 41.6441688537598, 0.726827860754581, -93.4644393920898, -1.63126220092266, 218, 16, 'PPL', 'P'),
(158663, 'Altoona', 40.5186080932617, 0.707183119552639, -78.3949966430664, -1.36825080851141, 218, 45, 'PPL', 'P'),
(172897, 'Altoona', 44.8047218322754, 0.781989916413392, -91.4430618286133, -1.59598250701405, 218, 57, 'PPL', 'P'),
(206682, 'Altoona', 46.2669410705566, 0.807510456507404, -123.654998779297, -2.1581868652483, 218, 56, 'PPL', 'P'),
(44345, 'Altoona Beach', 39.1591682434082, 0.683456418189877, -76.5405578613281, -1.33588474599341, 218, 25, 'PPL', 'P'),
(99388, 'Altoona Mines (historical)', 37.0819396972656, 0.647201940743275, -80.8686065673828, -1.41142344610074, 218, 53, 'PPL', 'P'),
(77779, 'Altor', 39.9702796936035, 0.697612983596412, -75.6699981689453, -1.32069061302618, 218, 45, 'PPL', 'P'),
(118610, 'Altorf', 41.1902809143066, 0.718906021776031, -87.9622192382813, -1.53523034306911, 218, 18, 'PPL', 'P'),
(34545, 'Altro', 37.3808288574219, 0.652418540686522, -83.3822174072266, -1.45529423136983, 218, 21, 'PPL', 'P'),
(191066, 'Altuda', 30.3019409179688, 0.528868638763348, -103.457496643066, -1.80567395229249, 218, 51, 'PPL', 'P'),
(133925, 'Altura', 44.0716705322266, 0.769195757641515, -91.9394378662109, -1.60464590319813, 218, 28, 'PPL', 'P'),
(144742, 'Altura', 40.2675018310547, 0.70280048850475, -74.8166732788086, -1.30579728410407, 218, 37, 'PPL', 'P'),
(186334, 'Altura', 37.1833305358887, 0.648971544708605, -107.190559387207, -1.87082818836128, 218, 7, 'PPL', 'P'),
(14979, 'Alturas', 27.8713893890381, 0.486447511944125, -81.7152786254883, -1.42620066119932, 218, 12, 'PPL', 'P'),
(193345, 'Alturas', 41.4872207641602, 0.724088599836353, -120.541389465332, -2.10384413109885, 218, 6, 'PPL', 'P'),
(194515, 'Alturas City (historical)', 43.8008308410645, 0.764468713285652, -115.159439086914, -2.0099113768165, 218, 17, 'PPL', 'P'),
(92225, 'Alturas de Azahares Colonia', 26.2479991912842, 0.458114007948718, -98.2939987182617, -1.71555391258475, 218, 51, 'PPL', 'P'),
(7080, 'Altus', 35.4461097717285, 0.618651322539998, -93.7622222900391, -1.636459492948, 218, 4, 'PPL', 'P'),
(58455, 'Altus', 34.3408317565918, 0.599360582025955, -89.396110534668, -1.56025646730674, 218, 30, 'PPL', 'P'),
(74983, 'Altus', 34.6380615234375, 0.604548220092347, -99.333610534668, -1.73369856172368, 218, 42, 'PPL', 'P'),
(202864, 'Altus', 40.752498626709, 0.711265279450539, -111.617500305176, -1.94809288317109, 218, 52, 'PPL', 'P'),
(209269, 'Altvan', 41.1230583190918, 0.717732766157797, -104.699440002441, -1.82734995303686, 218, 59, 'PPL', 'P'),
(195865, 'Altyn (historical)', 48.7999992370605, 0.851720661657427, -113.623611450195, -1.98310612781264, 218, 31, 'PPL', 'P'),
(92226, 'Alum', 29.2950000762939, 0.511294205703319, -97.9644393920898, -1.7098020172624, 218, 51, 'PPL', 'P'),
(7081, 'Alum (historical)', 34.5944404602051, 0.603786888915721, -92.727783203125, -1.61840512497003, 218, 4, 'PPL', 'P'),
(189864, 'Alum (historical)', 37.9086112976074, 0.661630082001969, -117.665832519531, -2.05365619456604, 218, 39, 'PPL', 'P'),
(158665, 'Alum Bank', 40.1805610656738, 0.70128308589465, -78.6138916015625, -1.37207124625318, 218, 45, 'PPL', 'P'),
(107964, 'Alum Bridge', 39.0391693115234, 0.681362041729612, -80.6552810668945, -1.40770021373875, 218, 58, 'PPL', 'P'),
(92227, 'Alum Creek', 30.0674991607666, 0.524776858196009, -97.2172164916992, -1.69676051740428, 218, 51, 'PPL', 'P'),
(107965, 'Alum Creek', 38.2866706848145, 0.668228463076804, -81.8052825927734, -1.4277715267683, 218, 58, 'PPL', 'P'),
(154051, 'Alum Creek', 40.267219543457, 0.702795561656733, -82.9444427490234, -1.4476536222024, 218, 41, 'PPL', 'P'),
(158666, 'Alum Rock', 41.1672210693359, 0.718503551556293, -79.6213912963867, -1.3896554331407, 218, 45, 'PPL', 'P'),
(179721, 'Alum Rock', 37.3661117553711, 0.652161678799384, -121.826110839844, -2.12626674905483, 218, 6, 'PPL', 'P'),
(34547, 'Alum Springs', 37.5966682434082, 0.656185648627466, -84.8405609130859, -1.48074712717216, 218, 21, 'PPL', 'P'),
(99389, 'Alum Springs', 37.1597213745117, 0.648559487108942, -80.8047180175781, -1.41030838055232, 218, 53, 'PPL', 'P'),
(107966, 'Alum Springs (historical)', 37.8613891601563, 0.660805900223617, -80.3727798461914, -1.40276963729658, 218, 58, 'PPL', 'P'),
(99390, 'Alum Wells', 36.7577781677246, 0.641544254744483, -82.1836090087891, -1.43437456837504, 218, 53, 'PPL', 'P'),
(34548, 'Alumbaugh', 37.5974998474121, 0.656200162855407, -83.9300003051758, -1.46485484652516, 218, 21, 'PPL', 'P'),
(84645, 'Alumwell', 36.4811096191406, 0.636715477634978, -83.0019378662109, -1.44865710130114, 218, 50, 'PPL', 'P'),
(192465, 'Alunite', 38.3791694641113, 0.66984287132961, -112.245826721191, -1.95905924790782, 218, 52, 'PPL', 'P'),
(158667, 'Aluta', 40.7708282470703, 0.711585191676485, -75.3172225952148, -1.31453351774397, 218, 45, 'PPL', 'P'),
(14980, 'Alva', 26.7152805328369, 0.466269605891949, -81.6102828979492, -1.42436814005323, 218, 12, 'PPL', 'P'),
(34549, 'Alva', 36.7350006103516, 0.641146711372761, -83.4244384765625, -1.45603112804346, 218, 21, 'PPL', 'P'),
(58456, 'Alva', 33.6377792358398, 0.587090000724387, -89.5072174072266, -1.56219564805449, 218, 30, 'PPL', 'P'),
(74984, 'Alva', 36.8050003051758, 0.642368436522835, -98.6661071777344, -1.72204843037707, 218, 42, 'PPL', 'P'),
(209270, 'Alva', 44.6947212219238, 0.780070043583554, -104.440826416016, -1.82283629446334, 218, 59, 'PPL', 'P'),
(92228, 'Alvacan Colonia', 26.3320007324219, 0.45958011141832, -98.1829986572266, -1.71361659604977, 218, 51, 'PPL', 'P'),
(154052, 'Alvada', 41.0502815246582, 0.716462571475883, -83.4019393920898, -1.45563844494073, 218, 41, 'PPL', 'P'),
(200323, 'Alvadore', 44.1269416809082, 0.770160421167369, -123.263328552246, -2.15135093020423, 218, 43, 'PPL', 'P'),
(158668, 'Alvan', 40.146110534668, 0.700681810699537, -78.1494369506836, -1.36396498336915, 218, 45, 'PPL', 'P'),
(92229, 'Alvarado', 32.4063911437988, 0.565598224148421, -97.2113876342773, -1.69665878465064, 218, 51, 'PPL', 'P'),
(99391, 'Alvarado', 36.6505584716797, 0.639672918025512, -81.8869400024414, -1.42919671742566, 218, 53, 'PPL', 'P'),
(122133, 'Alvarado', 41.5766716003418, 0.725649811446384, -84.8377838134766, -1.48069865764032, 218, 19, 'PPL', 'P'),
(133927, 'Alvarado', 48.1941719055176, 0.841146980023431, -96.9958267211914, -1.69289653697869, 218, 28, 'PPL', 'P'),
(188030, 'Alvarado', 32.1363906860352, 0.560885827178553, -106.236671447754, -1.85417970312276, 218, 38, 'PPL', 'P'),
(192958, 'Alvarez Colonia', 31.5890007019043, 0.55133206966303, -106.271003723145, -1.85477891436802, 218, 51, 'PPL', 'P'),
(144743, 'Alvater Corner', 40.5658302307129, 0.708007301330991, -74.9702835083008, -1.30847828837345, 218, 37, 'PPL', 'P'),
(18830, 'Alvaton', 33.1708297729492, 0.578940195156527, -84.5805587768555, -1.47620923383272, 218, 13, 'PPL', 'P'),
(34550, 'Alvaton', 36.8733291625977, 0.643561000058973, -86.3530578613281, -1.50714517884535, 218, 21, 'PPL', 'P'),
(158669, 'Alverda', 40.6302795410156, 0.709132153996413, -78.8572235107422, -1.37631818924353, 218, 45, 'PPL', 'P'),
(129515, 'Alverno', 45.5586090087891, 0.795147729832119, -84.3916702270508, -1.47291250671931, 218, 27, 'PPL', 'P'),
(172899, 'Alverno', 44.0849990844727, 0.769428384762734, -87.7397232055664, -1.53134705472561, 218, 57, 'PPL', 'P'),
(146787, 'Alverson', 43.9477806091309, 0.767033470573453, -76.0244369506836, -1.32687673676427, 218, 40, 'PPL', 'P'),
(158670, 'Alverton', 40.1399993896484, 0.700575151097879, -79.5875015258789, -1.3890639450626, 218, 45, 'PPL', 'P'),
(191067, 'Alvery Junction', 31.4813899993896, 0.549453908593765, -100.416938781738, -1.75260620651492, 218, 51, 'PPL', 'P'),
(200324, 'Alville (historical)', 45.2955589294434, 0.790556639849905, -120.33332824707, -2.10021277779447, 218, 43, 'PPL', 'P'),
(18831, 'Alvin', 34.2341690063477, 0.597498965844962, -83.3241729736328, -1.45428116489117, 218, 13, 'PPL', 'P'),
(34551, 'Alvin', 37.6366691589355, 0.65688379630723, -82.6949996948242, -1.44330001961039, 218, 21, 'PPL', 'P'),
(79519, 'Alvin', 33.3488883972168, 0.582047904411568, -79.8163909912109, -1.39305881985577, 218, 48, 'PPL', 'P'),
(92230, 'Alvin', 29.4236106872559, 0.513538884317606, -95.2438888549805, -1.66231945292294, 218, 51, 'PPL', 'P'),
(118611, 'Alvin', 40.3083305358887, 0.703513083833428, -87.6083297729492, -1.52905380671094, 218, 18, 'PPL', 'P'),
(129516, 'Alvin', 44.5244407653809, 0.77709808896508, -83.442497253418, -1.45634631315847, 218, 27, 'PPL', 'P'),
(172900, 'Alvin', 45.9850006103516, 0.802589667182237, -88.8291702270508, -1.55036149227656, 218, 57, 'PPL', 'P'),
(194085, 'Alvin', 40.3077812194824, 0.703503496453503, -102.07527923584, -1.78154970755801, 218, 7, 'PPL', 'P'),
(158671, 'Alvira (historical)', 41.1341705322266, 0.717926710864182, -76.9555587768555, -1.34312787836815, 218, 45, 'PPL', 'P'),
(7082, 'Alvis (historical)', 35.9388885498047, 0.627251934701382, -91.7172164916992, -1.60076740854459, 218, 4, 'PPL', 'P'),
(179724, 'Alviso', 37.4261093139648, 0.653208833740003, -121.974166870117, -2.12885081426053, 218, 6, 'PPL', 'P'),
(113153, 'Alvo', 40.871940612793, 0.713349935372826, -96.3872222900391, -1.68227438581285, 218, 35, 'PPL', 'P'),
(107974, 'Alvon', 37.9049987792969, 0.661567031663162, -80.2144393920898, -1.40000607503341, 218, 58, 'PPL', 'P'),
(92231, 'Alvord', 33.3583297729492, 0.582212687504016, -97.6944427490234, -1.70508968687156, 218, 51, 'PPL', 'P'),
(107967, 'Alvord', 38.8074989318848, 0.677318630825572, -81.3491668701172, -1.41981080563784, 218, 58, 'PPL', 'P'),
(114399, 'Alvord', 43.3422203063965, 0.756464449471364, -96.3008270263672, -1.68076650400365, 218, 16, 'PPL', 'P'),
(139009, 'Alvord (historical)', 40.4555587768555, 0.706082701390218, -93.5952835083008, -1.6335458615574, 218, 29, 'PPL', 'P'),
(154053, 'Alvordton', 41.665828704834, 0.727205896471318, -84.4369430541992, -1.47370266661473, 218, 41, 'PPL', 'P'),
(133929, 'Alvwood', 47.7305603027344, 0.833055431104416, -94.2677764892578, -1.64528307827165, 218, 28, 'PPL', 'P'),
(99405, 'Alwington', 38.7044410705566, 0.675519931825332, -77.7880630493164, -1.35765781895951, 218, 53, 'PPL', 'P'),
(118612, 'Alworth', 42.2436103820801, 0.737290089096957, -89.2455596923828, -1.55762885941722, 218, 18, 'PPL', 'P'),
(7085, 'Aly', 34.7905616760254, 0.6072098498648, -93.4861068725586, -1.63164036979745, 218, 4, 'PPL', 'P'),
(212274, 'Alyeska', 60.9608306884766, 1.06396721026472, -149.110824584961, -2.60247483937128, 218, 1, 'PPL', 'P'),
(14981, 'Alys Beach', 30.2833309173584, 0.528543832978899, -86.0305633544922, -1.50151658788147, 218, 12, 'PPL', 'P'),
(92232, 'Alysonders Estates Colonia', 26.2259998321533, 0.457730046698556, -98.3610000610352, -1.71672330661941, 218, 51, 'PPL', 'P'),
(195866, 'Alzada', 45.0230598449707, 0.785800633617187, -104.41194152832, -1.82233215806899, 218, 31, 'PPL', 'P'),
(71654, 'Am-Beth Acres', 39.0855598449707, 0.682171709280023, -84.2808303833008, -1.47097798650347, 218, 41, 'PPL', 'P'),
(39093, 'Ama', 29.951940536499, 0.522759979723465, -90.29638671875, -1.57596925089627, 218, 22, 'PPL', 'P'),
(74986, 'Amabel', 36.0108299255371, 0.628507548576327, -96.8377838134766, -1.69013816787964, 218, 42, 'PPL', 'P'),
(92233, 'Amada Acres Colonia', 26.3430004119873, 0.459772092043401, -98.7409973144531, -1.72335550984009, 218, 51, 'PPL', 'P'),
(193011, 'Amado', 31.7077808380127, 0.553405174124088, -111.063888549805, -1.93843053526212, 218, 5, 'PPL', 'P'),
(189867, 'Amador (historical)', 39.5597190856934, 0.69044734920939, -117.080833435059, -2.04344603442083, 218, 39, 'PPL', 'P'),
(195867, 'Amador (historical)', 47.1761093139648, 0.82337843580945, -114.86888885498, -2.00484031862683, 218, 31, 'PPL', 'P'),
(179722, 'Amador City', 38.4194412231445, 0.67054574612031, -120.823059082031, -2.10876019331308, 218, 6, 'PPL', 'P'),
(129517, 'Amadore', 43.1949996948242, 0.753894965072628, -82.5858306884766, -1.44139466100849, 218, 27, 'PPL', 'P'),
(146788, 'Amagansett', 40.9736099243164, 0.715124399607146, -72.144172668457, -1.25915334919188, 218, 40, 'PPL', 'P'),
(7083, 'Amagon', 35.561939239502, 0.620672928123477, -91.1102828979492, -1.59017441899269, 218, 4, 'PPL', 'P'),
(194517, 'Amalga', 42.5769386291504, 0.743107764498235, -113.723892211914, -1.98485635728104, 218, 17, 'PPL', 'P'),
(202865, 'Amalga', 41.8611106872559, 0.730614210034401, -111.894996643066, -1.95293610792951, 218, 52, 'PPL', 'P'),
(188031, 'Amalia', 36.9419403076172, 0.644758490443127, -105.453887939453, -1.8405175535726, 218, 38, 'PPL', 'P'),
(79520, 'Aman (historical)', 34.0869407653809, 0.594929348288172, -80.3333282470703, -1.40208107699674, 218, 48, 'PPL', 'P'),
(114400, 'Amana', 41.7999992370605, 0.729547614017824, -91.8705596923828, -1.60344375228207, 218, 16, 'PPL', 'P'),
(7084, 'Amanca', 35.1083297729492, 0.612755949413917, -90.2297210693359, -1.57480571581601, 218, 4, 'PPL', 'P'),
(53174, 'Amanda', 38.059440612793, 0.664262550160486, -91.4119415283203, -1.59543935530973, 218, 29, 'PPL', 'P'),
(71655, 'Amanda', 39.6494407653809, 0.692013287930357, -82.7444381713867, -1.44416288380357, 218, 41, 'PPL', 'P'),
(191068, 'Amanda', 29.3716697692871, 0.512632344282543, -100.657501220703, -1.75680481313148, 218, 51, 'PPL', 'P'),
(44346, 'Amanda Hills', 39.5999984741211, 0.691150357158144, -77.0536117553711, -1.34483922568463, 218, 25, 'PPL', 'P'),
(206683, 'Amanda Park', 47.4633293151855, 0.828391370508333, -123.884719848633, -2.16219625426941, 218, 56, 'PPL', 'P'),
(34553, 'Amandaville', 36.896671295166, 0.643968397126727, -85.3111114501953, -1.48895978334174, 218, 21, 'PPL', 'P'),
(107968, 'Amandaville', 38.3972206115723, 0.670157923286567, -81.8561096191406, -1.42865862572741, 218, 58, 'PPL', 'P'),
(18832, 'Amandaville (historical)', 34.2266693115234, 0.597368071477385, -82.9638900756836, -1.44799304208333, 218, 13, 'PPL', 'P'),
(62511, 'Amantha', 36.2786102294922, 0.633181196552334, -81.7799987792969, -1.42733024097567, 218, 33, 'PPL', 'P'),
(13272, 'Amaranth', 39.7138900756836, 0.693138140595779, -75.783332824707, -1.32266867592583, 218, 10, 'PPL', 'P'),
(77785, 'Amaranth', 39.7975006103516, 0.694597419715088, -78.2783279418945, -1.36621455554194, 218, 45, 'PPL', 'P'),
(188032, 'Amargo', 36.9377784729004, 0.644685852724395, -106.89111328125, -1.86560186788005, 218, 38, 'PPL', 'P'),
(189868, 'Amargosa (historical)', 36.5697212219238, 0.638262041859015, -116.157501220703, -2.0273308471906, 218, 39, 'PPL', 'P'),
(92234, 'Amargosa Colonia', 27.8859996795654, 0.4867025096185, -98.1070022583008, -1.71229020866886, 218, 51, 'PPL', 'P'),
(92251, 'Amargosa Number 2 Colonia', 27.8840007781982, 0.48666762220822, -98.1039962768555, -1.71223774439539, 218, 51, 'PPL', 'P'),
(189869, 'Amargosa Valley', 36.6438903808594, 0.639556537885875, -116.399436950684, -2.03155342225698, 218, 39, 'PPL', 'P'),
(191069, 'Amarillo', 35.2219390869141, 0.614738806003536, -101.830833435059, -1.7772833234917, 218, 51, 'PPL', 'P'),
(129518, 'Amasa', 46.232780456543, 0.806914241318362, -88.4486083984375, -1.54371943535984, 218, 27, 'PPL', 'P'),
(7095, 'Amateur (historical)', 36.0166702270508, 0.62860948106705, -91.5361099243164, -1.59760650264678, 218, 4, 'PPL', 'P'),
(77781, 'Amatus', 39.964168548584, 0.697506323994754, -77.0441665649414, -1.34467437601316, 218, 45, 'PPL', 'P'),
(146789, 'Amawalk', 41.288330078125, 0.720617302513489, -73.7666702270508, -1.28747127369491, 218, 40, 'PPL', 'P'),
(92235, 'Amaya Colonia', 28.7099990844727, 0.501084012268605, -99.8349990844727, -1.74244944274957, 218, 51, 'PPL', 'P'),
(195868, 'Amazon', 46.3202781677246, 0.808441364466441, -112.106391906738, -1.95662565130371, 218, 31, 'PPL', 'P'),
(53175, 'Amazonia', 39.8861083984375, 0.696143917360097, -94.8916702270508, -1.65617207817871, 218, 29, 'PPL', 'P'),
(34552, 'Amba', 37.5297203063965, 0.655017186699194, -82.6430587768555, -1.44239347957533, 218, 21, 'PPL', 'P'),
(99392, 'Ambar', 38.3250007629395, 0.668897449142632, -77.1783294677734, -1.34701596040161, 218, 53, 'PPL', 'P'),
(193096, 'Ambassador Downs Mobile Home Park', 33.4066696166992, 0.583056376937353, -111.780281066895, -1.95093394342199, 218, 5, 'PPL', 'P'),
(77782, 'Ambau', 39.851390838623, 0.695537981633076, -76.8933334350586, -1.34204184127561, 218, 45, 'PPL', 'P'),
(74987, 'Amber', 35.1602783203125, 0.613662622607035, -97.8788909912109, -1.70830891599725, 218, 42, 'PPL', 'P'),
(129519, 'Amber', 43.9555587768555, 0.767169225210019, -86.3194427490234, -1.5065584844572, 218, 27, 'PPL', 'P'),
(146790, 'Amber', 42.8872184753418, 0.748523169416857, -76.2969436645508, -1.33163287615504, 218, 40, 'PPL', 'P'),
(177314, 'Amber', 42.128059387207, 0.735273343782467, -91.1800003051758, -1.59139121729475, 218, 16, 'PPL', 'P'),
(189870, 'Amber', 36.6080589294434, 0.638931161082897, -114.49333190918, -1.99828561339387, 218, 39, 'PPL', 'P'),
(206684, 'Amber', 47.3519401550293, 0.826447262912575, -117.710563659668, -2.05443690023959, 218, 56, 'PPL', 'P'),
(7086, 'Amber (historical)', 34.3769416809082, 0.599990819097922, -92.2375030517578, -1.60984812207149, 218, 4, 'PPL', 'P'),
(179726, 'Amber Hills', 34.142219543457, 0.59589414497208, -117.207778930664, -2.04566165128973, 218, 6, 'PPL', 'P'),
(99393, 'Amber Lake', 37.6622200012207, 0.657329742631764, -77.7736129760742, -1.35740561760428, 218, 53, 'PPL', 'P'),
(92236, 'Amber Land Colonia', 26.2749996185303, 0.458585254303607, -98.2850036621094, -1.71539691923849, 218, 51, 'PPL', 'P'),
(44347, 'Amber Meadows', 39.452220916748, 0.688571152221429, -77.408332824707, -1.35103027627074, 218, 25, 'PPL', 'P'),
(84647, 'Amber Meadows', 36.086669921875, 0.629831206217124, -85.5569381713867, -1.49325026901591, 218, 50, 'PPL', 'P'),
(202868, 'Amber Way Condominium', 41.1749992370605, 0.71863930619286, -111.974998474121, -1.95433240328904, 218, 52, 'PPL', 'P'),
(18834, 'Amber Wood Estates', 33.5869407653809, 0.5862027020282, -84.288330078125, -1.47110888087105, 218, 13, 'PPL', 'P'),
(44348, 'Amber Woode', 38.7105598449707, 0.675626724585044, -76.5899963378906, -1.33674761018659, 218, 25, 'PPL', 'P'),
(44349, 'Amberfield', 39.0191688537598, 0.68101296788973, -76.6930618286133, -1.33854644234489, 218, 25, 'PPL', 'P'),
(172902, 'Amberg', 45.503059387207, 0.794178206037276, -87.9936065673828, -1.53577815530534, 218, 57, 'PPL', 'P'),
(44350, 'Amberleigh Farms', 38.4944381713867, 0.671854689796084, -76.8691711425781, -1.341620129717, 218, 25, 'PPL', 'P'),
(71657, 'Amberley', 39.204719543457, 0.684251438354293, -84.4280624389648, -1.47354767063929, 218, 41, 'PPL', 'P'),
(44352, 'Amberly', 39.3738899230957, 0.687204018475837, -76.9377822875977, -1.34281762010115, 218, 25, 'PPL', 'P'),
(158672, 'Amberson', 40.170280456543, 0.701103655416206, -77.6774978637695, -1.35572809243364, 218, 45, 'PPL', 'P'),
(158680, 'Amberson Valley Estates', 40.2036094665527, 0.701685356377306, -77.6324996948242, -1.35494272622818, 218, 45, 'PPL', 'P'),
(193097, 'Amberwood', 33.3616714477539, 0.582271010731889, -111.868606567383, -1.95247551421898, 218, 5, 'PPL', 'P'),
(193013, 'Amberwood II', 33.3458290100098, 0.581994508031712, -111.844718933105, -1.95205859635033, 218, 5, 'PPL', 'P'),
(193014, 'Amberwood North', 33.6597213745117, 0.587472963289141, -112.14582824707, -1.95731394528744, 218, 5, 'PPL', 'P'),
(92237, 'Ambia', 33.5927810668945, 0.586304634518923, -95.6588897705078, -1.66956258529768, 218, 51, 'PPL', 'P'),
(122134, 'Ambia', 40.4900016784668, 0.706683843427276, -87.5169372558594, -1.52745870637604, 218, 19, 'PPL', 'P'),
(129521, 'Amble', 43.4313888549805, 0.758020734233379, -85.3886108398438, -1.49031240285939, 218, 27, 'PPL', 'P'),
(122135, 'Ambler', 41.7158317565918, 0.728078614360537, -86.7966690063477, -1.51488765392448, 218, 19, 'PPL', 'P'),
(158674, 'Ambler', 40.1544418334961, 0.700827219295056, -75.2219390869141, -1.31287050680127, 218, 45, 'PPL', 'P'),
(212275, 'Ambler', 67.0861129760742, 1.17087355379739, -157.85139465332, -2.75502656556541, 218, 1, 'PPL', 'P'),
(154056, 'Ambler Heights', 41.4972190856934, 0.72426310346678, -81.6011123657227, -1.42420808407172, 218, 41, 'PPL', 'P'),
(179727, 'Ambler Park', 36.5763893127441, 0.638378421998651, -121.719169616699, -2.12440027260485, 218, 6, 'PPL', 'P'),
(146791, 'Amblers Crossing', 42.6733283996582, 0.744790083358838, -75.2630615234375, -1.31358822871504, 218, 40, 'PPL', 'P'),
(107969, 'Amblersburg', 39.3863906860352, 0.687422197948142, -79.6294403076172, -1.38979591488821, 218, 58, 'PPL', 'P'),
(146792, 'Amblerville', 42.5411109924316, 0.742482454274285, -75.4002838134766, -1.31598320948335, 218, 40, 'PPL', 'P'),
(18835, 'Ambleside', 33.5888900756836, 0.586236723911126, -84.2683334350586, -1.4707598736102, 218, 13, 'PPL', 'P'),
(7087, 'Amboy', 34.8058280944824, 0.607476299131862, -92.291389465332, -1.61078861741045, 218, 4, 'PPL', 'P'),
(107970, 'Amboy', 39.348331451416, 0.686757938993249, -79.5686111450195, -1.38873424571965, 218, 58, 'PPL', 'P'),
(118613, 'Amboy', 41.714168548584, 0.728049585904655, -89.32861328125, -1.55907841799855, 218, 18, 'PPL', 'P'),
(122136, 'Amboy', 40.601390838623, 0.708627951023034, -85.9288864135742, -1.49974199048909, 218, 19, 'PPL', 'P'),
(133932, 'Amboy', 43.8880615234375, 0.765991175901823, -94.1563873291016, -1.64333897067589, 218, 28, 'PPL', 'P'),
(141158, 'Amboy', 40.0902786254883, 0.699707360056677, -98.4383316040039, -1.71807299665986, 218, 35, 'PPL', 'P'),
(146793, 'Amboy', 43.0694389343262, 0.751703516390629, -76.2727813720703, -1.33121116459643, 218, 40, 'PPL', 'P'),
(154057, 'Amboy', 41.9272193908691, 0.731768024576678, -80.6152801513672, -1.40700206605899, 218, 41, 'PPL', 'P'),
(179728, 'Amboy', 34.5577812194824, 0.603147064463829, -115.743606567383, -2.02010702273376, 218, 6, 'PPL', 'P'),
(206685, 'Amboy', 45.9102783203125, 0.801285517196425, -122.445281982422, -2.13707332412615, 218, 56, 'PPL', 'P'),
(146794, 'Amboy Center', 43.3688888549805, 0.756929903450883, -75.9422225952148, -1.32544182556893, 218, 40, 'PPL', 'P'),
(158676, 'Ambridge', 40.589168548584, 0.708414631819719, -80.2252807617188, -1.40019529262886, 218, 45, 'PPL', 'P'),
(172904, 'Ambridge', 46.6366691589355, 0.81396342898672, -92.0702819824219, -1.60692956383287, 218, 57, 'PPL', 'P'),
(158677, 'Ambridge Heights', 40.5916709899902, 0.708458307661596, -80.2119369506836, -1.39996239919153, 218, 45, 'PPL', 'P'),
(84648, 'Ambro (historical)', 36.2608299255371, 0.632870871706313, -83.6547164916992, -1.46005023760255, 218, 50, 'PPL', 'P'),
(18836, 'Ambrose', 31.5936107635498, 0.551412530417464, -83.0144424438477, -1.44887534735247, 218, 13, 'PPL', 'P'),
(92238, 'Ambrose', 33.690559387207, 0.588011188145446, -96.3850021362305, -1.68223563681899, 218, 51, 'PPL', 'P'),
(114402, 'Ambrose', 41.5313911437988, 0.724859518392903, -92.2333297729492, -1.60977528461568, 218, 16, 'PPL', 'P'),
(158679, 'Ambrose', 40.7724990844727, 0.711614353290421, -79.1086120605469, -1.38070574713944, 218, 45, 'PPL', 'P'),
(193346, 'Ambrose', 41.5019416809082, 0.724345528302518, -120.980278015137, -2.11150418134225, 218, 6, 'PPL', 'P'),
(197927, 'Ambrose', 48.9538917541504, 0.854406592774827, -103.482223510742, -1.80610551754714, 218, 34, 'PPL', 'P'),
(179729, 'Ambrose (historical)', 38.0352783203125, 0.663840838601872, -121.948890686035, -2.12840966162596, 218, 6, 'PPL', 'P'),
(107971, 'Ambrosia', 38.8055610656738, 0.677284808679728, -82.0527801513672, -1.43209117405641, 218, 58, 'PPL', 'P'),
(39094, 'Ambrosia (historical)', 30.6547203063965, 0.535025800624584, -91.1933288574219, -1.59162384441597, 218, 22, 'PPL', 'P'),
(188033, 'Ambrosia Lake', 35.4188919067383, 0.618176281180555, -107.821113586426, -1.88183343524992, 218, 38, 'PPL', 'P'),
(193012, 'Ambrosia Mill', 33.7997207641602, 0.589916413589289, -113.181671142578, -1.97539281434744, 218, 5, 'PPL', 'P'),
(99394, 'Amburg', 37.5536117553711, 0.655434171146873, -76.3586120605469, -1.33270919270959, 218, 53, 'PPL', 'P'),
(34554, 'Amburgey', 37.2613906860352, 0.650333951343262, -82.9986114501953, -1.44859904438937, 218, 21, 'PPL', 'P'),
(44358, 'Amcelle', 39.607780456543, 0.691286178373738, -78.815559387207, -1.37559101310789, 218, 25, 'PPL', 'P'),
(44353, 'Amcelle Acres', 39.5888900756836, 0.690956479030786, -78.8494415283203, -1.37618236802794, 218, 25, 'PPL', 'P'),
(1, 'Amchitka', 51.5672187805176, 0.900017753816287, 178.877502441406, 3.12200137534673, 218, 1, 'PPL', 'P'),
(107972, 'Ameagle', 37.9497184753418, 0.662347537599637, -81.4188919067383, -1.42102773709795, 218, 58, 'PPL', 'P'),
(53176, 'Ameera (historical)', 36.7669410705566, 0.641704177567942, -93.0947189331055, -1.62480936160139, 218, 29, 'PPL', 'P'),
(39095, 'Amehe (historical)', 30.0013904571533, 0.523623043653732, -91.0758285522461, -1.58957307721855, 218, 22, 'PPL', 'P'),
(44354, 'Amelano Manor', 39.4752807617188, 0.688973622441167, -77.4302825927734, -1.35141337199355, 218, 25, 'PPL', 'P'),
(39096, 'Amelia', 29.666109085083, 0.517771279790501, -91.101936340332, -1.59002874408107, 218, 22, 'PPL', 'P'),
(62513, 'Amelia', 36.5424995422363, 0.637786933920545, -81.2033309936523, -1.41726548942599, 218, 33, 'PPL', 'P'),
(71659, 'Amelia', 39.0283317565918, 0.681172890713189, -84.2177810668945, -1.46987756834105, 218, 41, 'PPL', 'P'),
(92239, 'Amelia', 30.0697193145752, 0.52481560718987, -94.1908264160156, -1.64394004613392, 218, 51, 'PPL', 'P'),
(107973, 'Amelia', 38.2891693115234, 0.668272072339654, -81.2961120605469, -1.41888482452681, 218, 58, 'PPL', 'P'),
(141159, 'Amelia', 42.2355613708496, 0.737149607349455, -98.9116668701172, -1.72633425551934, 218, 35, 'PPL', 'P'),
(14983, 'Amelia City', 30.5900001525879, 0.533896220848227, -81.4574966430664, -1.42170151685374, 218, 12, 'PPL', 'P'),
(99396, 'Amelia Court House', 37.3427810668945, 0.65175448146871, -77.980827331543, -1.36102219036461, 218, 53, 'PPL', 'P'),
(99397, 'Amelia Springs (historical)', 37.3313903808594, 0.651555676493336, -78.1025009155273, -1.36314579501784, 218, 53, 'PPL', 'P'),
(44355, 'Amelung Estates', 39.3019409179688, 0.685948271442837, -77.4044418334961, -1.35096236566294, 218, 25, 'PPL', 'P'),
(77783, 'Amend', 39.8727798461914, 0.695911290238878, -79.789436340332, -1.39258837244921, 218, 45, 'PPL', 'P'),
(118615, 'Amenia', 40.0219383239746, 0.698514596783458, -88.666389465332, -1.54752043202566, 218, 18, 'PPL', 'P'),
(139592, 'Amenia', 47.0050010681152, 0.820392033542062, -97.2186126708984, -1.69678488532826, 218, 34, 'PPL', 'P'),
(146796, 'Amenia', 41.8491706848145, 0.730405817679102, -73.5572204589844, -1.28381568562461, 218, 40, 'PPL', 'P'),
(146797, 'Amenia Union', 41.8244400024414, 0.729974185845428, -73.5055618286133, -1.28291407243757, 218, 40, 'PPL', 'P'),
(118616, 'Ament Corners', 41.5972213745117, 0.726008472666191, -88.4358291625977, -1.54349639561855, 218, 18, 'PPL', 'P'),
(84649, 'Amerene (historical)', 35.7658309936523, 0.624231510551069, -83.8969421386719, -1.464277872675, 218, 50, 'PPL', 'P'),
(26367, 'America', 37.1383285522461, 0.648186111924113, -89.1236114501953, -1.55550046107403, 218, 18, 'PPL', 'P'),
(74989, 'America', 33.8152809143066, 0.590187989441449, -94.5483322143555, -1.65017969940992, 218, 42, 'PPL', 'P'),
(112766, 'America', 33.7377815246582, 0.588835369923798, -87.2525024414063, -1.52284344820693, 218, 2, 'PPL', 'P'),
(122137, 'America', 40.6791687011719, 0.709985430809674, -85.7019424438477, -1.49578107099982, 218, 19, 'PPL', 'P'),
(31642, 'America City', 39.5736083984375, 0.690689763447614, -96.0316696166992, -1.6760688209988, 218, 20, 'PPL', 'P'),
(14984, 'American Beach', 30.5747203826904, 0.533629538554569, -81.4441680908203, -1.42146888973252, 218, 12, 'PPL', 'P'),
(179730, 'American Canyon', 38.1749992370605, 0.66627942863303, -122.259719848633, -2.13383465392451, 218, 6, 'PPL', 'P'),
(186335, 'American City', 39.872501373291, 0.695906429969889, -105.586669921875, -1.84283503635318, 218, 7, 'PPL', 'P'),
(189871, 'American City (historical)', 39.2700004577637, 0.685390805247657, -119.660278320313, -2.08846584054224, 218, 39, 'PPL', 'P'),
(44356, 'American Corner', 38.767219543457, 0.676615622876818, -75.8194427490234, -1.3232989129978, 218, 25, 'PPL', 'P'),
(194518, 'American Falls', 42.7861099243164, 0.746758492299543, -112.853607177734, -1.96966701800377, 218, 17, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(189872, 'American Flat (historical)', 39.2708282470703, 0.68540525289657, -119.665283203125, -2.088553192226, 218, 39, 'PPL', 'P'),
(209908, 'American Fork', 40.3769416809082, 0.704710574217582, -111.794998168945, -1.95119080530913, 218, 52, 'PPL', 'P'),
(84650, 'American Heritage', 35.1563911437988, 0.613594778578265, -84.7819366455078, -1.47972394068135, 218, 50, 'PPL', 'P'),
(179731, 'American Hill (historical)', 39.4838905334473, 0.689123891305675, -120.758331298828, -2.10763048037867, 218, 6, 'PPL', 'P'),
(206686, 'American Lake Garden Tract', 47.122501373291, 0.822442800739478, -122.534172058105, -2.13862474861918, 218, 56, 'PPL', 'P'),
(202870, 'American Plaza Condominium', 40.7663917541504, 0.711507760267791, -111.891670227051, -1.95287805101775, 218, 52, 'PPL', 'P'),
(206687, 'American River', 46.9761085510254, 0.819887763989656, -121.16056060791, -2.11465070617017, 218, 56, 'PPL', 'P'),
(202871, 'American Towers Condominium', 40.7655601501465, 0.71149324603985, -111.891670227051, -1.95287805101775, 218, 52, 'PPL', 'P'),
(13029, 'American University Park', 38.9513893127441, 0.679829991733517, -77.0902786254883, -1.34547918329458, 218, 9, 'PPL', 'P'),
(92240, 'Americana Colonia', 26.3589992523193, 0.460051324483696, -98.1389999389648, -1.71284867354945, 218, 51, 'PPL', 'P'),
(92241, 'Americana Grove Colonia', 26.2099990844727, 0.457450780968747, -98.3769989013672, -1.7170025390597, 218, 51, 'PPL', 'P'),
(92242, 'Americana Grove Number 2 Colonia', 26.2099990844727, 0.457450780968747, -98.3769989013672, -1.7170025390597, 218, 51, 'PPL', 'P'),
(18837, 'Americus', 32.0722198486328, 0.55976583478212, -84.232780456543, -1.47013935707621, 218, 13, 'PPL', 'P'),
(31643, 'Americus', 38.5069389343262, 0.672072869268388, -96.2616729736328, -1.68008313686793, 218, 20, 'PPL', 'P'),
(53177, 'Americus', 38.7802810668945, 0.676843589466129, -91.5638885498047, -1.59809133112323, 218, 29, 'PPL', 'P'),
(122138, 'Americus', 40.5258293151855, 0.707309153651227, -86.758056640625, -1.51421374101064, 218, 19, 'PPL', 'P'),
(186336, 'Americus', 38.9025001525879, 0.678976714920255, -106.165000915527, -1.85292881635875, 218, 7, 'PPL', 'P'),
(84651, 'Amersham', 36.5305595397949, 0.637578541565246, -82.6022186279297, -1.44168068450957, 218, 50, 'PPL', 'P'),
(172905, 'Amery', 45.3069381713867, 0.790755245088197, -92.3619384765625, -1.61201992994045, 218, 57, 'PPL', 'P'),
(7089, 'Ames', 33.5747184753418, 0.585989382824885, -93.2169418334961, -1.62694255363455, 218, 4, 'PPL', 'P'),
(26369, 'Ames', 38.146671295166, 0.665785012776657, -90.054443359375, -1.57174654267184, 218, 18, 'PPL', 'P'),
(31645, 'Ames', 39.5694389343262, 0.690616992570828, -97.4416732788086, -1.70067802736779, 218, 20, 'PPL', 'P'),
(74990, 'Ames', 36.2458305358887, 0.632609082971158, -98.1849975585938, -1.71365148346005, 218, 42, 'PPL', 'P'),
(92244, 'Ames', 30.0536098480225, 0.524534443957785, -94.7433319091797, -1.65358308612499, 218, 51, 'PPL', 'P'),
(107975, 'Ames', 38.086109161377, 0.664728004140004, -81.0861129760742, -1.41521964907659, 218, 58, 'PPL', 'P'),
(114404, 'Ames', 42.0347213745117, 0.733644288143666, -93.6197204589844, -1.63397236680597, 218, 16, 'PPL', 'P'),
(122139, 'Ames', 40.0333290100098, 0.698713401758832, -86.8869400024414, -1.51646318002537, 218, 19, 'PPL', 'P'),
(141160, 'Ames', 41.452220916748, 0.723477737261316, -96.6241683959961, -1.68640987551158, 218, 35, 'PPL', 'P'),
(143462, 'Ames', 43.5625, 0.76030905540003, -71.3352813720703, -1.24503553277921, 218, 36, 'PPL', 'P'),
(146799, 'Ames', 42.8375015258789, 0.747655444954682, -74.601936340332, -1.302049417502, 218, 40, 'PPL', 'P'),
(169726, 'Ames', 44.2691688537598, 0.772642753619432, -99.0844421386719, -1.72934975282164, 218, 49, 'PPL', 'P'),
(186337, 'Ames', 37.8647193908691, 0.660864023714408, -107.88166809082, -1.88289031072852, 218, 7, 'PPL', 'P'),
(99399, 'Ames Cove', 36.8611106872559, 0.643347747434685, -76.4897232055664, -1.33499751387625, 218, 53, 'PPL', 'P'),
(107976, 'Ames Heights', 38.0852813720703, 0.664713556491091, -81.0758285522461, -1.41504015201912, 218, 58, 'PPL', 'P'),
(171686, 'Ames Hill', 42.8547210693359, 0.747955982683697, -72.6880569458008, -1.26864592058136, 218, 55, 'PPL', 'P'),
(206688, 'Ames Lake', 47.6330604553223, 0.831353737746883, -121.964996337891, -2.12869075827902, 218, 56, 'PPL', 'P'),
(124106, 'Amesbury', 42.8583297729492, 0.748018966443478, -70.9305572509766, -1.23797176430388, 218, 23, 'PPL', 'P'),
(179733, 'Amesti', 36.9636116027832, 0.645136725896945, -121.778060913086, -2.12542811962756, 218, 6, 'PPL', 'P'),
(71661, 'Amesville', 39.4005584716797, 0.687669472455355, -81.9558334350586, -1.43039913465783, 218, 41, 'PPL', 'P'),
(158681, 'Amesville', 40.8308296203613, 0.712632413196131, -78.4005584716797, -1.36834788073314, 218, 45, 'PPL', 'P'),
(177439, 'Amesville', 41.9627799987793, 0.732388674268721, -73.3763885498047, -1.28065957341676, 218, 8, 'PPL', 'P'),
(62514, 'Amherst', 35.7988891601563, 0.624808484401234, -81.5963897705078, -1.42412565923598, 218, 33, 'PPL', 'P'),
(84652, 'Amherst', 35.958610534668, 0.627596148272275, -84.0316696166992, -1.46662931075948, 218, 50, 'PPL', 'P'),
(99400, 'Amherst', 37.5849990844727, 0.655981983383102, -79.0516662597656, -1.37971185542062, 218, 53, 'PPL', 'P'),
(124108, 'Amherst', 42.3802795410156, 0.739675415906314, -72.5236129760742, -1.26577583187458, 218, 23, 'PPL', 'P'),
(126756, 'Amherst', 44.8333282470703, 0.782489192538755, -68.3647232055664, -1.19318951215171, 218, 26, 'PPL', 'P'),
(133935, 'Amherst', 43.6086082458496, 0.761113796102424, -91.8947219848633, -1.60386546384068, 218, 28, 'PPL', 'P'),
(141161, 'Amherst', 40.7688903808594, 0.711551369530641, -99.2694396972656, -1.73257856932725, 218, 35, 'PPL', 'P'),
(143463, 'Amherst', 42.8613891601563, 0.748072362823334, -71.6258316040039, -1.25010659096888, 218, 36, 'PPL', 'P'),
(146800, 'Amherst', 42.978328704834, 0.750113342903743, -78.8000030517578, -1.37531950383475, 218, 40, 'PPL', 'P'),
(154060, 'Amherst', 41.3977813720703, 0.722527587963403, -82.2225036621094, -1.4350534081369, 218, 41, 'PPL', 'P'),
(169727, 'Amherst', 45.7380599975586, 0.798279740432107, -97.9208297729492, -1.70904088582286, 218, 49, 'PPL', 'P'),
(172907, 'Amherst', 44.4508285522461, 0.775813313476199, -89.2847213745117, -1.55831235971099, 218, 57, 'PPL', 'P'),
(191070, 'Amherst', 34.0102806091309, 0.593591376156516, -102.415000915527, -1.78747896940896, 218, 51, 'PPL', 'P'),
(194086, 'Amherst', 40.6827812194824, 0.710048481148482, -102.165557861328, -1.78312536681695, 218, 7, 'PPL', 'P'),
(195869, 'Amherst', 47.1497192382813, 0.822917842098921, -109.624168395996, -1.91330267827084, 218, 31, 'PPL', 'P'),
(124109, 'Amherst Center', 42.3752784729004, 0.739588130801587, -72.5197219848633, -1.26570792126678, 218, 23, 'PPL', 'P'),
(154061, 'Amherst Heights', 40.8300018310547, 0.712617965547218, -81.51611328125, -1.42272457018649, 218, 41, 'PPL', 'P'),
(172908, 'Amherst Junction', 44.4688911437988, 0.776128565170237, -89.3125, -1.55879718818744, 218, 57, 'PPL', 'P'),
(107977, 'Amherstdale', 37.7852783203125, 0.659477515471886, -81.809440612793, -1.427844097908, 218, 58, 'PPL', 'P'),
(18838, 'Amicalola', 34.5547218322754, 0.603093668083973, -84.2525024414063, -1.4704835706471, 218, 13, 'PPL', 'P'),
(99402, 'Amicus', 38.2555618286133, 0.667685511109564, -78.4802780151367, -1.36973924924466, 218, 53, 'PPL', 'P'),
(197930, 'Amidon', 46.4822196960449, 0.811267777331342, -103.321388244629, -1.80329841260014, 218, 34, 'PPL', 'P'),
(107978, 'Amigo', 37.5963897705078, 0.656180788358477, -81.3211135864258, -1.41932118347142, 218, 58, 'PPL', 'P'),
(92246, 'Amigo Park Colonia Number 1', 26.238000869751, 0.45793950431829, -98.265998840332, -1.71506522252472, 218, 51, 'PPL', 'P'),
(92247, 'Amigo Park Number 3 Colonia', 26.2390003204346, 0.45795694802343, -98.2679977416992, -1.715100109935, 218, 51, 'PPL', 'P'),
(133937, 'Amiret', 44.3166694641113, 0.773471795666774, -95.6966705322266, -1.67022198398359, 218, 28, 'PPL', 'P'),
(84653, 'Amis', 36.4183311462402, 0.635619786583493, -82.9524993896484, -1.44779423710795, 218, 50, 'PPL', 'P'),
(114406, 'Amish', 41.535831451416, 0.724937016380625, -91.7863922119141, -1.60197475262478, 218, 16, 'PPL', 'P'),
(99403, 'Amissville', 38.6713905334473, 0.674943091133221, -77.9958267211914, -1.36128397909976, 218, 53, 'PPL', 'P'),
(188034, 'Amistad', 35.9188919067383, 0.626902927440527, -103.153327941895, -1.80036520697553, 218, 38, 'PPL', 'P'),
(191071, 'Amistad Acres', 29.5149993896484, 0.515133918073482, -101.166938781738, -1.76569617590487, 218, 51, 'PPL', 'P'),
(191072, 'Amistad Village', 29.461109161377, 0.514193356155493, -101.028610229492, -1.76328188721866, 218, 51, 'PPL', 'P'),
(39098, 'Amite', 30.726390838623, 0.536276687388594, -90.5088882446289, -1.57967810218837, 218, 22, 'PPL', 'P'),
(7091, 'Amity', 34.264720916748, 0.598032197274223, -93.4608306884766, -1.63119921716287, 218, 4, 'PPL', 'P'),
(18839, 'Amity', 33.6758308410645, 0.587754126521226, -82.4897232055664, -1.43971726899591, 218, 13, 'PPL', 'P'),
(26370, 'Amity', 38.7763900756836, 0.676775678858332, -87.9241714477539, -1.5345662838513, 218, 18, 'PPL', 'P'),
(29094, 'Amity', 39.4261093139648, 0.688115418779889, -86.001106262207, -1.50100246463303, 218, 19, 'PPL', 'P'),
(53178, 'Amity', 39.8708305358887, 0.695877268355953, -94.4355621337891, -1.6482114902063, 218, 29, 'PPL', 'P'),
(84654, 'Amity', 35.6988906860352, 0.623063181780851, -86.0599975585938, -1.50203031165574, 218, 50, 'PPL', 'P'),
(92248, 'Amity', 32.0591697692871, 0.559538067929891, -98.8833312988281, -1.72583970650491, 218, 51, 'PPL', 'P'),
(146803, 'Amity', 41.2680587768555, 0.720263501562672, -74.4552764892578, -1.29948972022027, 218, 40, 'PPL', 'P'),
(154065, 'Amity', 40.0686111450195, 0.699329191181886, -83.2513885498047, -1.4530108370512, 218, 41, 'PPL', 'P'),
(158682, 'Amity', 40.0394401550293, 0.69882006136049, -80.2052764892578, -1.39984615220995, 218, 45, 'PPL', 'P'),
(200325, 'Amity', 45.1158294677734, 0.787419768980927, -123.206108093262, -2.15035224479545, 218, 43, 'PPL', 'P'),
(7092, 'Amity (historical)', 33.9269409179688, 0.592136824148142, -93.8786087036133, -1.63849081906946, 218, 4, 'PPL', 'P'),
(158683, 'Amity Gardens', 40.274169921875, 0.702916868644386, -75.7355575561523, -1.32183484018853, 218, 45, 'PPL', 'P'),
(146804, 'Amity Harbor', 40.663330078125, 0.709708994688524, -73.3986129760742, -1.28104746282953, 218, 40, 'PPL', 'P'),
(62515, 'Amity Hill', 35.6972198486328, 0.623034020166914, -80.7736129760742, -1.40976549516411, 218, 33, 'PPL', 'P'),
(146806, 'Amityville', 40.6788902282715, 0.709980570540685, -73.4175033569336, -1.28137716217248, 218, 40, 'PPL', 'P'),
(158686, 'Amityville', 40.2999992370605, 0.703367675237909, -75.7366714477539, -1.32185428126449, 218, 45, 'PPL', 'P'),
(77784, 'Amleyn Gardens', 39.8911094665527, 0.696231202464824, -76.6486129760742, -1.33777066351934, 218, 45, 'PPL', 'P'),
(154066, 'Amlin', 40.0769386291504, 0.699474533198377, -83.1811065673828, -1.45178418505311, 218, 41, 'PPL', 'P'),
(107979, 'Amma', 38.5686111450195, 0.673149252401971, -81.2658309936523, -1.41835632020849, 218, 58, 'PPL', 'P'),
(92249, 'Ammannsville', 29.788890838623, 0.519914225651147, -96.8583297729492, -1.69049676252042, 218, 51, 'PPL', 'P'),
(92250, 'Ammans Crossing', 29.8947200775146, 0.521761294314685, -98.6708297729492, -1.72213085521281, 218, 51, 'PPL', 'P'),
(44357, 'Ammendale', 39.0508308410645, 0.681565573815921, -76.8969421386719, -1.34210482503539, 218, 25, 'PPL', 'P'),
(34555, 'Ammie', 37.2663917541504, 0.65042123644799, -83.6922225952148, -1.46070484259849, 218, 21, 'PPL', 'P'),
(725, 'Ammon', 34.7999992370605, 0.607374566378221, -78.5805587768555, -1.37148947871306, 218, 33, 'PPL', 'P'),
(99404, 'Ammon', 37.211109161377, 0.649456373185054, -77.7683334350586, -1.35731347223056, 218, 53, 'PPL', 'P'),
(194519, 'Ammon', 43.4697189331055, 0.758689720299207, -111.965827941895, -1.95417234730753, 218, 17, 'PPL', 'P'),
(209271, 'Ammon', 42.6263885498047, 0.743970828428503, -105.129722595215, -1.83485980099478, 218, 59, 'PPL', 'P'),
(62516, 'Ammon Ford', 34.7924995422363, 0.607243672010644, -78.5869369506836, -1.37160079884662, 218, 33, 'PPL', 'P'),
(34556, 'Ammons', 37.9511108398438, 0.662371838944584, -86.4938888549805, -1.50960314337344, 218, 21, 'PPL', 'P'),
(172912, 'Amnicon Falls', 46.603889465332, 0.813391315405544, -91.8897171020508, -1.60377811215693, 218, 57, 'PPL', 'P'),
(29095, 'Amo', 39.688060760498, 0.692687334002256, -86.6136093139648, -1.51169265956471, 218, 19, 'PPL', 'P'),
(99406, 'Amonate', 37.1908302307129, 0.649102439076182, -81.6388931274414, -1.42486748275762, 218, 53, 'PPL', 'P'),
(133940, 'Amor', 46.4124984741211, 0.810050912450257, -95.745002746582, -1.67106554025887, 218, 28, 'PPL', 'P'),
(643, 'Amoret', 38.2552795410156, 0.667680584261548, -94.5875015258789, -1.65086333286175, 218, 29, 'PPL', 'P'),
(74991, 'Amorita', 36.9244384765625, 0.644453025866095, -98.291389465332, -1.71550837253011, 218, 42, 'PPL', 'P'),
(58458, 'Amory', 33.9841690063477, 0.593135642714976, -88.4880599975586, -1.54440799565968, 218, 30, 'PPL', 'P'),
(7094, 'Amos', 36.3658294677734, 0.634703459431424, -92.5547180175781, -1.61538456766166, 218, 4, 'PPL', 'P'),
(34557, 'Amos', 36.6525001525879, 0.639706806750383, -86.0883331298828, -1.50252486067017, 218, 21, 'PPL', 'P'),
(39099, 'Amos', 30.3394393920898, 0.529523110601235, -89.7988891601563, -1.56728628047817, 218, 22, 'PPL', 'P'),
(53179, 'Amos', 38.0158309936523, 0.663501418720941, -94.5800018310547, -1.65073243849417, 218, 29, 'PPL', 'P'),
(179734, 'Amos', 33.1180610656738, 0.57801920747255, -115.254997253418, -2.01157918144916, 218, 6, 'PPL', 'P'),
(199806, 'Amos (historical)', 41.3899993896484, 0.722391766747809, -117.808326721191, -2.05614318755001, 218, 39, 'PPL', 'P'),
(200326, 'Amos (historical)', 43.6083297729492, 0.761108935833435, -123.08332824707, -2.14820933222432, 218, 43, 'PPL', 'P'),
(18840, 'Amos Mill', 34.7174987792969, 0.605934661755843, -85.5188903808594, -1.4925862097981, 218, 13, 'PPL', 'P'),
(44359, 'Amos Mill', 39.7002792358398, 0.692900586626544, -76.5013885498047, -1.33520111254158, 218, 25, 'PPL', 'P'),
(18841, 'Amoskeag (historical)', 32.1694412231445, 0.561462667870664, -83.1561126708984, -1.45134795926655, 218, 13, 'PPL', 'P'),
(44360, 'Amoss', 39.5280609130859, 0.689894809862226, -76.4105606079102, -1.33361586590271, 218, 25, 'PPL', 'P'),
(62518, 'Amostown', 36.524169921875, 0.637467021694599, -80.054443359375, -1.3972136174724, 218, 33, 'PPL', 'P'),
(124111, 'Amostown', 42.1263885498047, 0.735244182168531, -72.6597213745117, -1.26815137156693, 218, 23, 'PPL', 'P'),
(139596, 'Amourdale', 48.8713912963867, 0.852966688152448, -99.3724975585938, -1.73437726832749, 218, 34, 'PPL', 'P'),
(154067, 'Amoy', 40.8286094665527, 0.712593664202271, -82.5533294677734, -1.4408274076963, 218, 41, 'PPL', 'P'),
(144745, 'Ampere', 40.7666702270508, 0.71151262053678, -74.1952819824219, -1.29495196003889, 218, 37, 'PPL', 'P'),
(179735, 'Ampere', 38.1025009155273, 0.665014094220106, -121.242218017578, -2.11607589682753, 218, 6, 'PPL', 'P'),
(92252, 'Amphion', 28.9983291625977, 0.506116321464419, -98.6352767944336, -1.72151033867882, 218, 51, 'PPL', 'P'),
(193015, 'Amphitheater', 32.2722206115723, 0.563256506601914, -110.971672058105, -1.93682105385733, 218, 5, 'PPL', 'P'),
(99407, 'Ampt Hill', 37.4516716003418, 0.653654979801618, -77.4449996948242, -1.35167023388069, 218, 53, 'PPL', 'P'),
(84655, 'Amqui', 36.2761116027832, 0.633137587289484, -86.7091674804688, -1.51336046419738, 218, 50, 'PPL', 'P'),
(124112, 'Amrita', 41.6597213745117, 0.727099303448687, -70.6194381713867, -1.23254171199926, 218, 23, 'PPL', 'P'),
(158687, 'Amsbry', 40.5363883972168, 0.70749344439866, -78.5563888549805, -1.37106763399639, 218, 45, 'PPL', 'P'),
(194521, 'Amsco', 43.764720916748, 0.763838476213685, -116.648330688477, -2.03589743746906, 218, 17, 'PPL', 'P'),
(113229, 'Amsden', 41.2161102294922, 0.719356828369554, -83.32861328125, -1.45435866287889, 218, 41, 'PPL', 'P'),
(129523, 'Amsden', 43.1705589294434, 0.753468393245025, -85.1236114501953, -1.48568729099425, 218, 27, 'PPL', 'P'),
(171687, 'Amsden', 43.4058303833008, 0.757574654750791, -72.5063934326172, -1.26547529414556, 218, 55, 'PPL', 'P'),
(18842, 'Amsterdam', 30.7272205352783, 0.536291168327021, -84.4358291625977, -1.47368322553878, 218, 13, 'PPL', 'P'),
(53185, 'Amsterdam', 38.3497200012207, 0.669328881239225, -94.5888900756836, -1.65088756762767, 218, 29, 'PPL', 'P'),
(99409, 'Amsterdam', 37.4272193908691, 0.653228208236933, -79.9063873291016, -1.3946295522667, 218, 53, 'PPL', 'P'),
(144746, 'Amsterdam', 40.5875015258789, 0.708385536784809, -75.1588897705078, -1.31177008863885, 218, 37, 'PPL', 'P'),
(146807, 'Amsterdam', 42.9386100769043, 0.749420122071996, -74.188606262207, -1.2948354467412, 218, 40, 'PPL', 'P'),
(154068, 'Amsterdam', 40.4736099243164, 0.706397753347174, -80.9230575561523, -1.41237379513573, 218, 41, 'PPL', 'P'),
(158688, 'Amsterdam', 41.1338882446289, 0.717921784016165, -80.1338882446289, -1.39860019229395, 218, 45, 'PPL', 'P'),
(179736, 'Amsterdam', 37.4302787780762, 0.653281604616789, -120.541107177734, -2.10383920425083, 218, 6, 'PPL', 'P'),
(194520, 'Amsterdam', 42.2958297729492, 0.738201489401009, -114.583892822266, -1.99986619950083, 218, 17, 'PPL', 'P'),
(195870, 'Amsterdam', 45.7580604553223, 0.798628814271989, -111.31916809082, -1.94288600376582, 218, 31, 'PPL', 'P'),
(177440, 'Amston', 41.6252784729004, 0.726498161411629, -72.3436126708984, -1.26263423389467, 218, 8, 'PPL', 'P'),
(114409, 'Amund', 43.473331451416, 0.758752770638015, -93.7930603027344, -1.6369977178043, 218, 16, 'PPL', 'P'),
(144747, 'Amwell', 40.4313888549805, 0.705660856673549, -74.7525024414063, -1.30467729170764, 218, 37, 'PPL', 'P'),
(7096, 'Amy', 33.7319412231445, 0.588733437433075, -92.8152770996094, -1.61993218153908, 218, 4, 'PPL', 'P'),
(53181, 'Amy', 36.6055603027344, 0.638887551820047, -92.0036087036133, -1.60576589559456, 218, 29, 'PPL', 'P'),
(58459, 'Amy', 31.7772197723389, 0.554617112157156, -89.2583312988281, -1.55785176600046, 218, 30, 'PPL', 'P'),
(187579, 'Amy', 38.4819412231445, 0.671636576902806, -100.601387023926, -1.7558254356406, 218, 20, 'PPL', 'P'),
(44361, 'Amyclae Estates', 39.5497207641602, 0.690272845578963, -76.3222198486328, -1.33207402878961, 218, 25, 'PPL', 'P'),
(44362, 'Amys Acres', 38.4594383239746, 0.671243827221047, -76.8974990844727, -1.34211454557337, 218, 25, 'PPL', 'P'),
(39100, 'Anabel', 32.2930603027344, 0.563620227827792, -92.2508316040039, -1.61008074919271, 218, 22, 'PPL', 'P'),
(53182, 'Anabel', 39.7458305358887, 0.69369560679096, -92.3330612182617, -1.61151592670415, 218, 29, 'PPL', 'P'),
(191073, 'Anacacho', 29.1908302307129, 0.509476098916636, -100.300277709961, -1.7505700867035, 218, 51, 'PPL', 'P'),
(172914, 'Anacker', 43.625560760498, 0.761409673299532, -89.4436111450195, -1.56108550935409, 218, 57, 'PPL', 'P'),
(39101, 'Anacoco', 31.2519397735596, 0.545449246683586, -93.3411102294922, -1.6291097009716, 218, 22, 'PPL', 'P'),
(53183, 'Anaconda', 38.3016700744629, 0.668490251811959, -91.0405578613281, -1.58895748753258, 218, 29, 'PPL', 'P'),
(195871, 'Anaconda', 46.1286087036133, 0.805096101242165, -112.941390991211, -1.97119913457889, 218, 31, 'PPL', 'P'),
(186338, 'Anaconda (historical)', 38.7319412231445, 0.675999900032792, -108.162498474121, -1.88779172555676, 218, 7, 'PPL', 'P'),
(195872, 'Anaconda Trailer Court', 46.1458282470703, 0.80539663897118, -112.985557556152, -1.97196998655642, 218, 31, 'PPL', 'P'),
(206689, 'Anacortes', 48.5127792358398, 0.846707726958544, -122.611389160156, -2.13997244128881, 218, 56, 'PPL', 'P'),
(206690, 'Anacortes Crossing', 48.7833290100098, 0.851429711308336, -120.82861328125, -2.10885713237676, 218, 56, 'PPL', 'P'),
(13030, 'Anacostia', 38.8663902282715, 0.678346477848288, -76.9841690063477, -1.34362722107254, 218, 9, 'PPL', 'P'),
(92253, 'Anacua Colonia', 26.3859996795654, 0.460522570838586, -98.9199981689453, -1.72647966411486, 218, 51, 'PPL', 'P'),
(195873, 'Anad (historical)', 47.2275009155273, 0.824275388464588, -107.332221984863, -1.87330066711731, 218, 31, 'PPL', 'P'),
(74995, 'Anadarko', 35.0724983215332, 0.612130572610939, -98.2433319091797, -1.71466960994479, 218, 42, 'PPL', 'P'),
(92254, 'Anadarko', 31.9280605316162, 0.557249780052754, -94.876106262207, -1.65590043574752, 218, 51, 'PPL', 'P'),
(211669, 'Anaehoomalu', 19.9169406890869, 0.347616191948995, -155.890274047852, -2.72079855397128, 218, 15, 'PPL', 'P'),
(179737, 'Anaheim', 33.8352813720703, 0.590537063281331, -117.913612365723, -2.05798076870216, 218, 6, 'PPL', 'P'),
(179738, 'Anaheim Hills', 33.8444404602051, 0.590696919525764, -117.776390075684, -2.05558578793385, 218, 6, 'PPL', 'P'),
(211670, 'Anahola', 22.1452808380127, 0.386508064402131, -159.315567016602, -2.78058119412138, 218, 15, 'PPL', 'P'),
(92255, 'Anahuac', 29.7727794647217, 0.519633029129548, -94.682502746582, -1.65252141695643, 218, 51, 'PPL', 'P'),
(212277, 'Anaktuvuk Pass', 68.1433334350586, 1.18932553172611, -151.735824584961, -2.64828973223613, 218, 1, 'PPL', 'P'),
(188035, 'Analco (historical)', 35.6833305358887, 0.62279160592869, -105.943061828613, -1.84905524855323, 218, 38, 'PPL', 'P'),
(158690, 'Analomink', 41.0511093139648, 0.716477019124797, -75.220832824707, -1.31285119888336, 218, 45, 'PPL', 'P'),
(197935, 'Anamoose', 47.8824996948242, 0.835707273759863, -100.240829467773, -1.7495325191428, 218, 34, 'PPL', 'P'),
(114410, 'Anamosa', 42.1083297729492, 0.73492899705352, -91.2850036621094, -1.59322387159889, 218, 16, 'PPL', 'P'),
(141162, 'Anan', 40.4666709899902, 0.706276646096603, -98.1838912963867, -1.71363217554215, 218, 35, 'PPL', 'P'),
(39102, 'Anandale', 31.2549991607666, 0.545502643063442, -92.4538879394531, -1.61362475081333, 218, 22, 'PPL', 'P'),
(18843, 'Anandale (historical)', 34.6327781677246, 0.604456008139603, -83.478889465332, -1.45698147707845, 218, 13, 'PPL', 'P'),
(188036, 'Anapra', 31.7841701507568, 0.554738419144809, -106.563331604004, -1.8598809983844, 218, 38, 'PPL', 'P'),
(92256, 'Anaqua Addition Colonia', 26.1620006561279, 0.456613050358349, -98.0149993896484, -1.7106844556896, 218, 51, 'PPL', 'P'),
(146810, 'Anaquassacook', 43.0747184753418, 0.751795661764346, -73.3127822875977, -1.27954943471636, 218, 40, 'PPL', 'P'),
(92257, 'Anarene', 33.4850006103516, 0.584423510682946, -98.6658325195313, -1.72204363668711, 218, 51, 'PPL', 'P'),
(84656, 'Anark', 35.9047203063965, 0.626655586354286, -88.4008331298828, -1.54288559962254, 218, 50, 'PPL', 'P'),
(188037, 'Anasazi Trails', 35.3163909912109, 0.616387302718295, -106.511940002441, -1.85898404572926, 218, 38, 'PPL', 'P'),
(14985, 'Anastasia', 29.8875007629395, 0.521635293505611, -81.2897186279297, -1.41877323807714, 218, 12, 'PPL', 'P'),
(206691, 'Anatone', 46.1349983215332, 0.805207621112812, -117.131393432617, -2.04432847284803, 218, 56, 'PPL', 'P'),
(107982, 'Anawalt', 37.3358306884766, 0.651633174481057, -81.4366683959961, -1.42133799536494, 218, 58, 'PPL', 'P'),
(195874, 'Anceney', 45.648609161377, 0.796718528822075, -111.353889465332, -1.94349200607187, 218, 31, 'PPL', 'P'),
(177707, 'Ancho', 33.9377784729004, 0.592325975164565, -105.739166259766, -1.84549659954661, 218, 38, 'PPL', 'P'),
(39103, 'Anchor', 30.6833305358887, 0.535525143328974, -91.3550033569336, -1.59444559674896, 218, 22, 'PPL', 'P'),
(58460, 'Anchor', 33.8266716003418, 0.590386794416824, -89.0380630493164, -1.55400735980887, 218, 30, 'PPL', 'P'),
(74992, 'Anchor', 35.8355598449707, 0.625448508590208, -95.4027786254883, -1.66509260256604, 218, 42, 'PPL', 'P'),
(107980, 'Anchor', 37.996940612793, 0.663171719377989, -81.915283203125, -1.42969139959814, 218, 58, 'PPL', 'P'),
(118619, 'Anchor', 40.5680618286133, 0.708046250061933, -88.5355606079102, -1.54523703770702, 218, 18, 'PPL', 'P'),
(158691, 'Anchor', 40.1372184753418, 0.700526614987013, -76.581672668457, -1.33660233474913, 218, 45, 'PPL', 'P'),
(188038, 'Anchor (historical)', 36.7627792358398, 0.64163153984921, -105.338890075684, -1.83851046221706, 218, 38, 'PPL', 'P'),
(200327, 'Anchor (historical)', 42.8486099243164, 0.74784932308204, -123.163887023926, -2.14961534812183, 218, 43, 'PPL', 'P'),
(179742, 'Anchor Bay', 38.8027801513672, 0.677236272568861, -123.576667785645, -2.15681973150271, 218, 6, 'PPL', 'P'),
(129524, 'Anchor Bay Gardens', 42.6427803039551, 0.744256918508604, -82.8125, -1.4453507868078, 218, 27, 'PPL', 'P'),
(129525, 'Anchor Bay Harbor', 42.6552810668945, 0.744475097980909, -82.7991714477539, -1.44511815968659, 218, 27, 'PPL', 'P'),
(129526, 'Anchor Bay Shores', 42.6355590820313, 0.744130884410016, -82.8166732788086, -1.44542362426362, 218, 27, 'PPL', 'P'),
(39104, 'Anchor Landing', 31.8497200012207, 0.555882479859594, -91.5697174072266, -1.59819306387687, 218, 22, 'PPL', 'P'),
(84657, 'Anchor Mill', 35.5380592346191, 0.62025614341288, -86.533332824707, -1.51029157051522, 218, 50, 'PPL', 'P'),
(212279, 'Anchor Point', 59.776668548584, 1.04329968204613, -151.831390380859, -2.64995767002684, 218, 1, 'PPL', 'P'),
(34559, 'Anchorage', 38.2666702270508, 0.667879389236922, -85.5330581665039, -1.49283348430532, 218, 21, 'PPL', 'P'),
(39105, 'Anchorage', 30.4825000762939, 0.532019990570752, -91.2102813720703, -1.59191972161308, 218, 22, 'PPL', 'P'),
(44364, 'Anchorage', 38.7955589294434, 0.677110238470273, -76.1386108398438, -1.32886944704992, 218, 25, 'PPL', 'P'),
(58461, 'Anchorage', 32.9313888549805, 0.574761162773975, -90.6141662597656, -1.58151555018247, 218, 30, 'PPL', 'P'),
(92258, 'Anchorage', 29.0672206878662, 0.507318705407076, -98.7055587768555, -1.72273699067691, 218, 51, 'PPL', 'P'),
(144748, 'Anchorage', 40.0013885498047, 0.698155935563652, -74.1430587768555, -1.29404049315581, 218, 37, 'PPL', 'P'),
(202875, 'Anchorage', 41.0880584716797, 0.71712190358276, -112.023330688477, -1.95517595956432, 218, 52, 'PPL', 'P'),
(212278, 'Anchorage', 61.2180595397949, 1.06845670065135, -149.900283813477, -2.61625350221913, 218, 1, 'PPL', 'P'),
(172915, 'Anchorage (historical)', 44.2686080932617, 0.772632966502426, -91.7569427490234, -1.6014607625344, 218, 57, 'PPL', 'P'),
(44365, 'Anchorage Anchors', 38.3172187805176, 0.668761627927038, -76.9052810668945, -1.34225036678897, 218, 25, 'PPL', 'P'),
(44366, 'Anchorage Park Mobile Home Park', 38.5086097717285, 0.672102030882325, -76.6624984741211, -1.33801301117854, 218, 25, 'PPL', 'P'),
(129527, 'Anchorville', 42.6911087036133, 0.74510040820486, -82.688606262207, -1.44318843316071, 218, 27, 'PPL', 'P'),
(31646, 'Anchorway', 38.3488883972168, 0.669314367011284, -98.8158264160156, -1.72466152403866, 218, 20, 'PPL', 'P'),
(44367, 'Ancient Oak', 39.1116714477539, 0.682627442721563, -77.2708282470703, -1.34863036865442, 218, 25, 'PPL', 'P'),
(44368, 'Ancient Oak North', 39.1227798461914, 0.682821320848921, -77.2724990844727, -1.34865953026835, 218, 25, 'PPL', 'P'),
(44369, 'Ancient Oak West', 39.1080589294434, 0.682564392382755, -77.2786102294922, -1.34876618987001, 218, 25, 'PPL', 'P'),
(44370, 'Ancient Oaks', 38.1699981689453, 0.666192143528302, -76.4124984741211, -1.33364968804856, 218, 25, 'PPL', 'P'),
(158692, 'Ancient Oaks', 40.5472183227539, 0.707682462257028, -75.5897216796875, -1.31928952397669, 218, 45, 'PPL', 'P'),
(14986, 'Anclote', 28.1758308410645, 0.491761017661538, -82.7808303833008, -1.44479804772356, 218, 12, 'PPL', 'P'),
(34558, 'Anco', 37.2497215270996, 0.650130286098898, -83.054443359375, -1.44957349503223, 218, 21, 'PPL', 'P'),
(188039, 'Ancon', 35.7152786254883, 0.623349205281925, -104.425003051758, -1.8225601246583, 218, 38, 'PPL', 'P'),
(118622, 'Ancona', 41.0405616760254, 0.716292928114445, -88.8724975585938, -1.55111769686808, 218, 18, 'PPL', 'P'),
(188040, 'Ancones', 36.4238891601563, 0.635716792226199, -106.0625, -1.85113983789649, 218, 38, 'PPL', 'P'),
(71665, 'Ancor', 39.1372184753418, 0.68307332246707, -84.3177795410156, -1.47162287096144, 218, 41, 'PPL', 'P'),
(70462, 'Ancora', 39.6944389343262, 0.692798654135821, -74.841667175293, -1.30623350989063, 218, 37, 'PPL', 'P'),
(146811, 'Ancram', 42.0505599975586, 0.733920724264816, -73.6366729736328, -1.28520239360422, 218, 40, 'PPL', 'P'),
(146813, 'Ancramdale', 42.0180587768555, 0.733353470952629, -73.591667175293, -1.2844168942407, 218, 40, 'PPL', 'P'),
(31647, 'Andale', 37.7905616760254, 0.65956972742463, -97.6291732788086, -1.70395051971528, 218, 20, 'PPL', 'P'),
(14987, 'Andalusia', 29.499719619751, 0.514867235779824, -81.4850006103516, -1.42218155164022, 218, 12, 'PPL', 'P'),
(112767, 'Andalusia', 31.3083305358887, 0.546433451153938, -86.4833297729492, -1.509418852626, 218, 2, 'PPL', 'P'),
(118623, 'Andalusia', 41.4391708374023, 0.723249970409087, -90.7174987792969, -1.58331904287267, 218, 18, 'PPL', 'P'),
(158693, 'Andalusia', 40.0694389343262, 0.6993436388308, -74.9716720581055, -1.30850252313937, 218, 45, 'PPL', 'P'),
(193016, 'Andalusia', 33.5694389343262, 0.585897237451168, -111.869438171387, -1.95249002844692, 218, 5, 'PPL', 'P'),
(99411, 'Anden at The Woods', 38.5855598449707, 0.673445063020052, -77.3105621337891, -1.34932385580227, 218, 53, 'PPL', 'P'),
(112577, 'Ander', 28.8575000762939, 0.503658390225844, -97.3419418334961, -1.69893738527931, 218, 51, 'PPL', 'P'),
(7099, 'Anderson', 34.9122200012207, 0.60933318820192, -94.1213912963867, -1.64272817467988, 218, 4, 'PPL', 'P'),
(26372, 'Anderson', 39.3438911437988, 0.686680441005527, -89.8450012207031, -1.56809108775959, 218, 18, 'PPL', 'P'),
(34561, 'Anderson', 37.0180587768555, 0.646087008352913, -86.7997207641602, -1.51494091714628, 218, 21, 'PPL', 'P'),
(39106, 'Anderson', 32.2669410705566, 0.563164361228197, -93.1763916015625, -1.62623481857486, 218, 22, 'PPL', 'P'),
(53184, 'Anderson', 36.6505584716797, 0.639672918025512, -94.4433288574219, -1.64834704510579, 218, 29, 'PPL', 'P'),
(58462, 'Anderson', 32.5591697692871, 0.568264714189863, -90.245002746582, -1.57507243139918, 218, 30, 'PPL', 'P'),
(62517, 'Anderson', 36.2669410705566, 0.632977531307971, -79.3455581665039, -1.38484123683817, 218, 33, 'PPL', 'P'),
(74994, 'Anderson', 35.0872192382813, 0.612387501077105, -96.9841690063477, -1.6926930714714, 218, 42, 'PPL', 'P'),
(79521, 'Anderson', 34.5033302307129, 0.602196715428835, -82.6502838134766, -1.44251958025294, 218, 48, 'PPL', 'P'),
(84661, 'Anderson', 36.5402793884277, 0.637748184926684, -82.3213882446289, -1.43677926968133, 218, 50, 'PPL', 'P'),
(92259, 'Anderson', 30.4869403839111, 0.532097488558473, -95.9866714477539, -1.67528345479334, 218, 51, 'PPL', 'P'),
(107981, 'Anderson', 39.3899993896484, 0.687485181707922, -79.7197189331055, -1.39137157414715, 218, 58, 'PPL', 'P'),
(112769, 'Anderson', 34.9283294677734, 0.609614351434005, -87.2663879394531, -1.52308579586613, 218, 2, 'PPL', 'P'),
(114411, 'Anderson', 40.8013916015625, 0.712118622842828, -95.603889465332, -1.66860264888277, 218, 16, 'PPL', 'P'),
(122140, 'Anderson', 40.105281829834, 0.699969215370859, -85.6802825927734, -1.49540303528308, 218, 19, 'PPL', 'P'),
(129528, 'Anderson', 42.4708290100098, 0.741255802276194, -84.0061111450195, -1.46618323127689, 218, 27, 'PPL', 'P'),
(144749, 'Anderson', 40.7705612182617, 0.711580531144577, -74.9194412231445, -1.30759092309824, 218, 37, 'PPL', 'P'),
(146814, 'Anderson', 41.9030609130859, 0.731346379597091, -74.7072219848633, -1.30388699865416, 218, 40, 'PPL', 'P'),
(158695, 'Anderson', 41.0583305358887, 0.716603053223385, -78.6608276367188, -1.37289043460449, 218, 45, 'PPL', 'P'),
(172916, 'Anderson', 42.7169418334961, 0.74555128137741, -89.0166702270508, -1.55363398462404, 218, 57, 'PPL', 'P'),
(177395, 'Anderson', 41.3888893127441, 0.722372392250878, -82.529167175293, -1.44040569613769, 218, 41, 'PPL', 'P'),
(193347, 'Anderson', 40.4483299255371, 0.705956534133575, -122.296669006348, -2.13447953838247, 218, 6, 'PPL', 'P'),
(194522, 'Anderson', 42.0205612182617, 0.733397146794507, -111.956108093262, -1.95400270394609, 218, 17, 'PPL', 'P'),
(195875, 'Anderson', 48.3455581665039, 0.843789168719926, -104.931938171387, -1.83140781158982, 218, 31, 'PPL', 'P'),
(212280, 'Anderson', 64.3441696166992, 1.1230176142731, -149.186935424805, -2.60380322412301, 218, 1, 'PPL', 'P'),
(7097, 'Anderson (historical)', 34.1597213745117, 0.596199609549112, -93.5041732788086, -1.63195568807051, 218, 4, 'PPL', 'P'),
(154069, 'Anderson (historical)', 41.7388916015625, 0.728481084580275, -80.6224975585938, -1.40712803357855, 218, 41, 'PPL', 'P'),
(199807, 'Anderson (historical)', 41.4672203063965, 0.723739525996471, -116.101112365723, -2.02634667600976, 218, 39, 'PPL', 'P'),
(18844, 'Anderson Acres', 33.538890838623, 0.585364072600934, -83.8494415283203, -1.46344883062766, 218, 13, 'PPL', 'P'),
(129529, 'Anderson Bayview', 44.2366714477539, 0.772075566886272, -83.545280456543, -1.45814021846875, 218, 27, 'PPL', 'P'),
(18845, 'Anderson City', 31.3713893890381, 0.547534035763927, -83.8547210693359, -1.46354097600137, 218, 13, 'PPL', 'P'),
(34562, 'Anderson City', 38.0072212219238, 0.663351149856433, -85.0258331298828, -1.48398073736773, 218, 21, 'PPL', 'P'),
(133942, 'Anderson Court', 44.7708282470703, 0.781398361756258, -94.1413879394531, -1.64307718194074, 218, 28, 'PPL', 'P'),
(62519, 'Anderson Creek', 35.2833290100098, 0.615810262289102, -78.9172210693359, -1.37736534418415, 218, 33, 'PPL', 'P'),
(158696, 'Anderson Creek', 41.1458282470703, 0.718130176371464, -78.5469436645508, -1.37090278432491, 218, 45, 'PPL', 'P'),
(13273, 'Anderson Crossroads', 38.8586082458496, 0.678210656632694, -75.3702774047852, -1.31545949885499, 218, 10, 'PPL', 'P'),
(71667, 'Anderson Ferry', 39.0780601501465, 0.682040814912446, -84.621940612793, -1.47693148312035, 218, 41, 'PPL', 'P'),
(62521, 'Anderson Heights', 35.3424987792969, 0.616842969580807, -80.1524963378906, -1.39892496478889, 218, 33, 'PPL', 'P'),
(192466, 'Anderson Junction', 37.2841682434082, 0.650731494714984, -113.304718017578, -1.97754038745048, 218, 52, 'PPL', 'P'),
(58463, 'Anderson Landing', 34.139720916748, 0.59585053570923, -90.8666687011719, -1.58592254915433, 218, 30, 'PPL', 'P'),
(18846, 'Anderson Mill', 32.2197189331055, 0.562340179449845, -81.8038864135742, -1.42774715884433, 218, 13, 'PPL', 'P'),
(92261, 'Anderson Mill', 30.454719543457, 0.531535128804789, -97.8055572509766, -1.70702900077736, 218, 51, 'PPL', 'P'),
(188041, 'Anderson Place', 34.6805610656738, 0.605289977034962, -106.348892211914, -1.85613832494646, 218, 38, 'PPL', 'P'),
(194523, 'Anderson Place', 42.2447204589844, 0.737309463593887, -114.949996948242, -2.00625592190426, 218, 17, 'PPL', 'P'),
(169728, 'Anderson Subdivision', 43.5163917541504, 0.759504314697635, -96.6247177124023, -1.6864194628915, 218, 49, 'PPL', 'P'),
(172917, 'Anderson Trailer Court', 45.4691696166992, 0.793586717959169, -91.7058334350586, -1.60056873672727, 218, 57, 'PPL', 'P'),
(7100, 'Anderson Tully', 35.485279083252, 0.619334955991822, -90.6016693115234, -1.58129743728919, 218, 4, 'PPL', 'P'),
(92262, 'Anderson Ways', 29.2605590820313, 0.510693096955775, -94.9061126708984, -1.65642414637589, 218, 51, 'PPL', 'P'),
(202876, 'Anderson West Acres', 41.2144393920898, 0.719327666755618, -112.074996948242, -1.95607770590942, 218, 52, 'PPL', 'P'),
(158697, 'Andersonburg', 40.3499984741211, 0.704240326548101, -77.4686126708984, -1.35208235805938, 218, 45, 'PPL', 'P'),
(179743, 'Andersonia', 39.9780616760254, 0.697748804812006, -123.806106567383, -2.16082419367581, 218, 6, 'PPL', 'P'),
(189873, 'Andersons (historical)', 39.4697189331055, 0.688876550219434, -119.796112060547, -2.09083658654463, 218, 39, 'PPL', 'P'),
(13274, 'Andersons Corner', 38.6986083984375, 0.675418132492664, -75.2597198486328, -1.31352990548717, 218, 10, 'PPL', 'P'),
(18847, 'Andersons Corner', 32.8766708374023, 0.573806153207072, -84.9516677856445, -1.4826863079199, 218, 13, 'PPL', 'P'),
(44371, 'Andersons Corner', 39.0569381713867, 0.681672166838552, -76.6555633544922, -1.337891970507, 218, 25, 'PPL', 'P'),
(99412, 'Andersons Corner', 37.4211082458496, 0.653121548635275, -76.8244400024414, -1.34083942404344, 218, 53, 'PPL', 'P'),
(158698, 'Andersons Corner', 41.7944412231445, 0.729450608375118, -80.0238876342773, -1.39668031946412, 218, 45, 'PPL', 'P'),
(62524, 'Andersons Crossroads', 36.3619384765625, 0.634635548823627, -77.741943359375, -1.35685287852004, 218, 33, 'PPL', 'P'),
(99413, 'Andersons Mill', 36.8819389343262, 0.64371126892348, -79.539436340332, -1.38822504931922, 218, 53, 'PPL', 'P'),
(44372, 'Andersontown', 38.8377799987793, 0.677847135143898, -75.7836074829102, -1.32267346961579, 218, 25, 'PPL', 'P'),
(158700, 'Andersontown', 40.1522216796875, 0.700788470301195, -76.9319381713867, -1.3427156210314, 218, 45, 'PPL', 'P'),
(18849, 'Andersonville', 32.1958312988281, 0.561923261581193, -84.1399993896484, -1.46852002197538, 218, 13, 'PPL', 'P'),
(71670, 'Andersonville', 39.4277801513672, 0.688144580393826, -83.0097198486328, -1.44879292251673, 218, 41, 'PPL', 'P'),
(84663, 'Andersonville', 36.1986083984375, 0.631784901192806, -84.0372161865234, -1.46672611666511, 218, 50, 'PPL', 'P'),
(99414, 'Andersonville', 37.4672203063965, 0.653926355916697, -78.5691680908203, -1.37129067373768, 218, 53, 'PPL', 'P'),
(107983, 'Andersonville', 39.7799987792969, 0.694291955138056, -80.5219421386719, -1.40537301042019, 218, 58, 'PPL', 'P'),
(122142, 'Andersonville', 40.2186088562012, 0.701947145112461, -85.4311065673828, -1.49105409322298, 218, 19, 'PPL', 'P'),
(129530, 'Andersonville', 42.7299995422363, 0.745779181387694, -83.4925003051758, -1.45721903104769, 218, 27, 'PPL', 'P'),
(194087, 'Andersonville', 40.5938911437988, 0.708497056655456, -105.056671142578, -1.8335848126229, 218, 7, 'PPL', 'P'),
(79525, 'Andersonville (historical)', 34.4472198486328, 0.601217404516985, -82.8552780151367, -1.44609740401941, 218, 48, 'PPL', 'P'),
(195876, 'Andersonville (historical)', 47.186939239502, 0.823567453667818, -109.283889770508, -1.90736369588191, 218, 31, 'PPL', 'P'),
(146815, 'Andes', 42.1886100769043, 0.736330152682038, -74.7861099243164, -1.30526385293773, 218, 40, 'PPL', 'P'),
(195877, 'Andes', 47.9555587768555, 0.836982395289793, -104.548332214355, -1.82471262460936, 218, 31, 'PPL', 'P'),
(193348, 'Andesite', 41.5325012207031, 0.724878892889834, -122.20361328125, -2.13285540959168, 218, 6, 'PPL', 'P'),
(92263, 'Andice', 30.7819404602051, 0.537246211183437, -97.851936340332, -1.70783846859068, 218, 51, 'PPL', 'P'),
(58464, 'Anding', 32.6919403076172, 0.570581997233368, -90.3977813720703, -1.57773892144062, 218, 30, 'PPL', 'P'),
(71671, 'Andis', 38.5508308410645, 0.67283892755595, -82.5233306884766, -1.440303830226, 218, 41, 'PPL', 'P'),
(202878, 'Andlor', 40.663330078125, 0.709708994688524, -111.814720153809, -1.95153501888002, 218, 52, 'PPL', 'P'),
(44373, 'Andora', 39.6847190856934, 0.692629010774383, -75.8611068725586, -1.32402608913345, 218, 25, 'PPL', 'P'),
(44374, 'Andora Acres', 39.6858291625977, 0.692648385271313, -75.8655624389648, -1.32410385343728, 218, 25, 'PPL', 'P'),
(44375, 'Andorick Acres', 39.1349983215332, 0.683034573473209, -76.6916732788086, -1.33852220757897, 218, 25, 'PPL', 'P'),
(158702, 'Andorra Woods', 40.082218170166, 0.699566678572094, -75.2666702270508, -1.31365121247482, 218, 45, 'PPL', 'P'),
(14988, 'Andover', 25.9680595397949, 0.453228139323345, -80.2130584716797, -1.39998197342554, 218, 12, 'PPL', 'P'),
(31654, 'Andover', 37.7138900756836, 0.658231555555892, -97.1361083984375, -1.69534491412685, 218, 20, 'PPL', 'P'),
(77786, 'Andover', 39.9463882446289, 0.697195999148732, -78.0841674804688, -1.36282581621286, 218, 45, 'PPL', 'P'),
(99415, 'Andover', 36.9236106872559, 0.644438578217181, -82.7966690063477, -1.44507448384471, 218, 53, 'PPL', 'P'),
(113024, 'Andover', 41.2938919067383, 0.720714374735222, -90.2919387817383, -1.57589161975049, 218, 18, 'PPL', 'P'),
(114413, 'Andover', 41.9791717529297, 0.732674764348823, -90.2516708374023, -1.57518881153882, 218, 16, 'PPL', 'P'),
(124113, 'Andover', 42.6583290100098, 0.744528294623684, -71.1374969482422, -1.24158354337424, 218, 23, 'PPL', 'P'),
(126759, 'Andover', 44.6355590820313, 0.779037469449903, -70.7516708374023, -1.23484960739992, 218, 26, 'PPL', 'P'),
(133943, 'Andover', 45.2333297729492, 0.789470536178343, -93.2911071777344, -1.62823698308238, 218, 28, 'PPL', 'P'),
(139010, 'Andover', 40.564998626709, 0.70799278710305, -93.8949966430664, -1.63877684257053, 218, 29, 'PPL', 'P'),
(143465, 'Andover', 43.436939239502, 0.758117606718031, -71.8238906860352, -1.2535633740638, 218, 36, 'PPL', 'P'),
(144750, 'Andover', 40.9858283996582, 0.715337652231434, -74.7425003051758, -1.30450272149818, 218, 37, 'PPL', 'P'),
(146817, 'Andover', 42.1563911437988, 0.735767826217868, -77.7958297729492, -1.357793373859, 218, 40, 'PPL', 'P'),
(154071, 'Andover', 41.6066703796387, 0.726173388916694, -80.5725021362305, -1.40625544884739, 218, 41, 'PPL', 'P'),
(169729, 'Andover', 45.4102783203125, 0.792558870936453, -97.9022216796875, -1.70871611332792, 218, 49, 'PPL', 'P'),
(171688, 'Andover', 43.2772216796875, 0.755330009426018, -72.6972198486328, -1.26880584340482, 218, 55, 'PPL', 'P'),
(177442, 'Andover', 41.7372207641602, 0.728451922966338, -72.3708267211914, -1.26310920867508, 218, 8, 'PPL', 'P'),
(179744, 'Andover', 39.3105583190918, 0.6860986734654, -120.246109008789, -2.09869051491538, 218, 6, 'PPL', 'P'),
(79526, 'Andover (historical)', 35.0791702270508, 0.612247019329603, -82.2058334350586, -1.43476245778781, 218, 48, 'PPL', 'P'),
(179745, 'Andover (historical)', 39.3019409179688, 0.685948271442837, -120.256393432617, -2.09887001197286, 218, 6, 'PPL', 'P'),
(44377, 'Andover Estates', 38.1686096191406, 0.666167908762383, -76.5047225952148, -1.3352593026114, 218, 25, 'PPL', 'P'),
(14989, 'Andover Golf Estates', 25.9638900756836, 0.453155368446558, -80.208610534668, -1.39990434227977, 218, 12, 'PPL', 'P'),
(144751, 'Andover Junction', 40.996940612793, 0.715531596937819, -74.7461090087891, -1.30456570525796, 218, 37, 'PPL', 'P'),
(14990, 'Andover Lakes Estates', 25.9658298492432, 0.453189223881916, -80.2022171020508, -1.39979275583009, 218, 12, 'PPL', 'P'),
(179746, 'Andrade Corner', 34.648609161377, 0.604732311102699, -118.376106262207, -2.06605280996619, 218, 6, 'PPL', 'P'),
(71672, 'Andre', 38.7472190856934, 0.676266549036936, -82.7347183227539, -1.44399324044214, 218, 41, 'PPL', 'P'),
(84664, 'Andrea Heights', 35.0563888549805, 0.611849409378854, -85.3533325195313, -1.48969668001537, 218, 50, 'PPL', 'P'),
(158703, 'Andreas', 40.7516708374023, 0.711250831801626, -75.7927780151367, -1.32283352559731, 218, 45, 'PPL', 'P'),
(133947, 'Andree', 45.728328704834, 0.798109897333587, -93.2236099243164, -1.62705893377418, 218, 28, 'PPL', 'P'),
(118626, 'Andres', 41.3716697692871, 0.722071854521863, -87.8824996948242, -1.53383897455759, 218, 18, 'PPL', 'P'),
(14991, 'Andrew', 30.3997192382813, 0.53057519238987, -84.4102783203125, -1.47323727921424, 218, 12, 'PPL', 'P'),
(26374, 'Andrew', 39.8955612182617, 0.696308900189627, -89.6399993896484, -1.56451313083507, 218, 18, 'PPL', 'P'),
(39107, 'Andrew', 30.0847206115723, 0.525077429214538, -92.2427825927734, -1.60994026744521, 218, 22, 'PPL', 'P'),
(107984, 'Andrew', 38.0999984741211, 0.664970418378229, -81.7174987792969, -1.42623941019318, 218, 58, 'PPL', 'P'),
(114414, 'Andrew', 42.1536102294922, 0.735719290107001, -90.5922164916992, -1.58113245445966, 218, 16, 'PPL', 'P'),
(99416, 'Andrew Lewis', 37.2825012207031, 0.650702399680075, -80.1255569458008, -1.39845478369844, 218, 53, 'PPL', 'P'),
(114415, 'Andrew Mobile Home Park', 41.6144409179688, 0.726309010395206, -93.7055587768555, -1.6354705280772, 218, 16, 'PPL', 'P'),
(7102, 'Andrews', 35.1838912963867, 0.614074746785724, -91.5680618286133, -1.59816416857904, 218, 4, 'PPL', 'P'),
(14997, 'Andrews', 30.7350006103516, 0.536426956253102, -81.9480590820313, -1.43026344660029, 218, 12, 'PPL', 'P'),
(44376, 'Andrews', 38.3566703796387, 0.669450188226878, -76.1102828979492, -1.32837503119355, 218, 25, 'PPL', 'P'),
(62526, 'Andrews', 35.2016716003418, 0.614385071631746, -83.8241729736328, -1.46300781115114, 218, 33, 'PPL', 'P'),
(70463, 'Andrews', 39.7238883972168, 0.693312644226206, -74.9594421386719, -1.308289070778, 218, 37, 'PPL', 'P'),
(79527, 'Andrews', 33.4511108398438, 0.583832022604839, -79.5611114501953, -1.38860335135207, 218, 48, 'PPL', 'P'),
(114416, 'Andrews', 41.7533302307129, 0.728733086198424, -93.7569427490234, -1.63636734757428, 218, 16, 'PPL', 'P'),
(122143, 'Andrews', 40.8624992370605, 0.713185152280377, -85.6016693115234, -1.49403097468947, 218, 19, 'PPL', 'P'),
(191074, 'Andrews', 32.3186111450195, 0.564066174152325, -102.545280456543, -1.78975277634767, 218, 51, 'PPL', 'P'),
(199142, 'Andrews', 42.6313896179199, 0.74405811353323, -103.733329772949, -1.81048814859503, 218, 35, 'PPL', 'P'),
(209889, 'Andrews', 42.464168548584, 0.741139555294612, -118.61222076416, -2.07017378543698, 218, 43, 'PPL', 'P'),
(118627, 'Andrews and Hurds Subdivision', 41.6666717529297, 0.72722061043634, -87.6319427490234, -1.52946593088963, 218, 18, 'PPL', 'P'),
(112773, 'Andrews Chapel', 34.3380584716797, 0.599312179073143, -87.0844421386719, -1.51991024258232, 218, 2, 'PPL', 'P'),
(18852, 'Andrews Crossroads', 32.9833297729492, 0.575667702809038, -84.6611099243164, -1.47761511657217, 218, 13, 'PPL', 'P'),
(13275, 'Andrews Lake Estates', 39.0208282470703, 0.681041929766584, -75.5258331298828, -1.31817445842827, 218, 10, 'PPL', 'P'),
(44381, 'Andrews Manor', 38.8138885498047, 0.677430150696219, -76.8983306884766, -1.34212905980131, 218, 25, 'PPL', 'P'),
(188042, 'Andrews Place', 32.0325012207031, 0.559072613950372, -103.397499084473, -1.80462679735187, 218, 38, 'PPL', 'P'),
(158705, 'Andrews Settlement', 41.9000015258789, 0.731292983217235, -77.9044418334961, -1.35968901192292, 218, 45, 'PPL', 'P'),
(79529, 'Andrews Subdivision', 33.4772186279297, 0.584287689467352, -80.8236083984375, -1.41063807989528, 218, 48, 'PPL', 'P'),
(13276, 'Andrewsville', 38.8613891601563, 0.678259192743561, -75.6352767944336, -1.32008461072013, 218, 10, 'PPL', 'P'),
(186339, 'Andrix', 37.2794418334961, 0.650649003300219, -103.192222595215, -1.80104404673739, 218, 7, 'PPL', 'P'),
(206692, 'Andron', 48.2627792358398, 0.842344403828558, -121.605003356934, -2.12240769547725, 218, 56, 'PPL', 'P'),
(133948, 'Andrusia', 47.4861106872559, 0.828788980459082, -94.6636123657227, -1.65219171761348, 218, 28, 'PPL', 'P'),
(122144, 'Andry', 41.7177810668945, 0.728112636243462, -86.758056640625, -1.51421374101064, 218, 19, 'PPL', 'P'),
(107985, 'Andy (historical)', 39.6713905334473, 0.692396383653164, -80.7572174072266, -1.40947933850498, 218, 58, 'PPL', 'P'),
(62527, 'Andy Cove', 35.894718170166, 0.626481016144831, -82.7130584716797, -1.4436152047254, 218, 33, 'PPL', 'P'),
(169733, 'Andys Acres', 43.6294403076172, 0.761477384170248, -96.6897201538086, -1.68755396951588, 218, 49, 'PPL', 'P'),
(199808, 'Andys Place', 41.7944412231445, 0.729450608375118, -119.384437561035, -2.08365151108165, 218, 39, 'PPL', 'P'),
(14998, 'Andytown', 26.1455593109131, 0.456326094750893, -80.4419403076172, -1.40397671506066, 218, 12, 'PPL', 'P'),
(34564, 'Andyville', 38.0338897705078, 0.663816603835952, -86.3724975585938, -1.50748446556822, 218, 21, 'PPL', 'P'),
(133949, 'Andyville', 43.7238883972168, 0.763125814305979, -92.9894409179688, -1.62297191360729, 218, 28, 'PPL', 'P'),
(177626, 'Anegam', 32.3727798461914, 0.565011596339304, -112.030281066895, -1.95529726655198, 218, 5, 'PPL', 'P'),
(84665, 'Anes', 35.5586090087891, 0.620614804632686, -86.7508316040039, -1.51408764033302, 218, 50, 'PPL', 'P'),
(139598, 'Aneta', 47.6794395446777, 0.832163205560213, -97.9877777099609, -1.71020934775113, 218, 34, 'PPL', 'P'),
(192467, 'Aneth', 37.2161102294922, 0.649543658289781, -109.186393737793, -1.90566206910341, 218, 52, 'PPL', 'P'),
(71673, 'Angel', 38.7208290100098, 0.675805955326407, -82.2694396972656, -1.43587259648821, 218, 41, 'PPL', 'P'),
(112775, 'Angel', 33.8352813720703, 0.590537063281331, -85.8369369506836, -1.49813716961621, 218, 2, 'PPL', 'P'),
(129531, 'Angel', 44.8325004577637, 0.782474744889841, -85.4150009155273, -1.49077299656992, 218, 27, 'PPL', 'P'),
(14999, 'Angel City', 28.3441696166992, 0.49469908355514, -80.6608276367188, -1.40779701964438, 218, 12, 'PPL', 'P'),
(92264, 'Angel City', 28.7163906097412, 0.501195565428766, -97.5408325195313, -1.70240868260218, 218, 51, 'PPL', 'P'),
(188043, 'Angel Fire', 36.3930587768555, 0.635178700527948, -105.284439086914, -1.83756011318206, 218, 38, 'PPL', 'P'),
(92265, 'Angel Haven Colonia', 25.8669395446777, 0.451463262468949, -97.4300003051758, -1.7004742955444, 218, 51, 'PPL', 'P'),
(202879, 'Angel Street', 40.6022186279297, 0.708642398671948, -111.882781982422, -1.95272292188425, 218, 52, 'PPL', 'P'),
(195878, 'Angela', 46.7299995422363, 0.815592351467467, -106.200561523438, -1.85354946605079, 218, 31, 'PPL', 'P'),
(92266, 'Angela Colonia', 26.1280002593994, 0.456019631488452, -97.9800033569336, -1.71007365969359, 218, 51, 'PPL', 'P'),
(191076, 'Angeles', 31.9013900756836, 0.556784292783722, -103.961936950684, -1.81447809654018, 218, 51, 'PPL', 'P'),
(44378, 'Angelica', 38.5852813720703, 0.673440202751062, -76.5250015258789, -1.33561323672027, 218, 25, 'PPL', 'P'),
(146819, 'Angelica', 42.3066711425781, 0.73839070699646, -78.01611328125, -1.36163804636669, 218, 40, 'PPL', 'P'),
(158704, 'Angelica', 40.2613906860352, 0.702693828903092, -75.9538879394531, -1.32564542423427, 218, 45, 'PPL', 'P'),
(172919, 'Angelica', 44.6738891601563, 0.779706455515731, -88.313606262207, -1.5413632035854, 218, 57, 'PPL', 'P'),
(99417, 'Angelico', 36.7169418334961, 0.64083152625775, -77.2369384765625, -1.34803888057631, 218, 53, 'PPL', 'P'),
(39108, 'Angelina', 30.0577793121338, 0.524607214834571, -90.6344375610352, -1.58186935113328, 218, 22, 'PPL', 'P'),
(39109, 'Angelique Estates', 29.9233303070068, 0.522260637019075, -89.9000015258789, -1.56905102417451, 218, 22, 'PPL', 'P'),
(193017, 'Angell', 35.1955604553223, 0.614278412030088, -111.303329467773, -1.94260956764467, 218, 5, 'PPL', 'P'),
(146820, 'Angells Corner', 43.0275001525879, 0.750971546565021, -76.8625030517578, -1.34150374957736, 218, 40, 'PPL', 'P'),
(99418, 'Angelo', 37.5438919067383, 0.655264527785435, -79.0744400024414, -1.38010933221332, 218, 53, 'PPL', 'P'),
(172921, 'Angelo', 43.9708290100098, 0.767435741056109, -90.7777786254883, -1.5843711246613, 218, 57, 'PPL', 'P'),
(158706, 'Angels', 41.2780609130859, 0.720438071772126, -75.3677825927734, -1.31541595617117, 218, 45, 'PPL', 'P'),
(18857, 'Angels Acres', 32.7694396972656, 0.571934616751019, -83.7594375610352, -1.46187796505867, 218, 13, 'PPL', 'P'),
(179749, 'Angels Camp', 38.0683288574219, 0.664417679293983, -120.538612365723, -2.10379566156701, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(202880, 'Angels Grove', 40.5213890075684, 0.707231655663505, -112.260276794434, -1.95931144926305, 218, 52, 'PPL', 'P'),
(84666, 'Angeltown', 36.5472183227539, 0.637869292177255, -86.3497161865234, -1.50708685561748, 218, 50, 'PPL', 'P'),
(885, 'Angelus', 34.5966682434082, 0.603825771067636, -80.3199996948242, -1.40184844987552, 218, 48, 'PPL', 'P'),
(187580, 'Angelus', 39.1911087036133, 0.684013884385058, -100.683891296387, -1.75726540684201, 218, 20, 'PPL', 'P'),
(179750, 'Angelus Oaks', 34.1458282470703, 0.595957128731861, -116.981666564941, -2.04171524602839, 218, 6, 'PPL', 'P'),
(18853, 'Angelville', 34.5888900756836, 0.603690016431069, -84.8899993896484, -1.48160999136534, 218, 13, 'PPL', 'P'),
(107986, 'Angerona', 38.8305587768555, 0.67772110104531, -81.804443359375, -1.4277568793823, 218, 58, 'PPL', 'P'),
(39110, 'Angie', 30.9663906097412, 0.540465473598639, -89.809440612793, -1.56747043806755, 218, 22, 'PPL', 'P'),
(202881, 'Angie Circle Condominium', 40.6522216796875, 0.709515116561167, -111.872497558594, -1.95254342482678, 218, 52, 'PPL', 'P'),
(191077, 'Angie Colonia', 31.6140003204346, 0.551768395318126, -106.279998779297, -1.85493590771428, 218, 51, 'PPL', 'P'),
(62529, 'Angier', 35.5069389343262, 0.619712991708558, -78.7394409179688, -1.3742624951981, 218, 33, 'PPL', 'P'),
(179751, 'Angiola', 35.9891700744629, 0.62812951285959, -119.474998474121, -2.08523209718861, 218, 6, 'PPL', 'P'),
(192468, 'Angle', 38.2491683959961, 0.66757392465989, -111.975830078125, -1.95434691751698, 218, 52, 'PPL', 'P'),
(189874, 'Angle City', 37.0433311462402, 0.646528094408457, -114.587501525879, -1.99992918326061, 218, 39, 'PPL', 'P'),
(133950, 'Angle Inlet', 49.3452796936035, 0.86123760097088, -95.0625, -1.65915362017711, 218, 28, 'PPL', 'P'),
(202882, 'Angle View', 40.6377792358398, 0.709263048363991, -111.944442749023, -1.95379910528075, 218, 52, 'PPL', 'P'),
(92268, 'Angler', 32.5938911437988, 0.56887071649591, -95.2533264160156, -1.66248416943636, 218, 51, 'PPL', 'P'),
(84667, 'Anglers Cove', 35.8202781677246, 0.625181793007036, -84.5319366455078, -1.47536061755136, 218, 50, 'PPL', 'P'),
(79530, 'Anglers Haven', 34.2249984741211, 0.597338909863448, -81.945556640625, -1.43021977075841, 218, 48, 'PPL', 'P'),
(15000, 'Anglers Park', 25.139720916748, 0.438770903029741, -80.3974990844727, -1.40320106939317, 218, 12, 'PPL', 'P'),
(70464, 'Anglesea', 39.0186080932617, 0.681003180772724, -74.795280456543, -1.30542390891924, 218, 37, 'PPL', 'P'),
(13288, 'Anglesey', 39.7588882446289, 0.693923506801243, -75.6163864135742, -1.31975491137718, 218, 10, 'PPL', 'P'),
(92271, 'Angleton', 29.1691703796387, 0.509098063199899, -95.4316711425781, -1.66559687211845, 218, 51, 'PPL', 'P'),
(15001, 'Anglevillas', 27.4599990844727, 0.479267396618676, -80.3722229003906, -1.4027599167586, 218, 12, 'PPL', 'P'),
(79531, 'Anglewood', 34.9186096191406, 0.609444708072567, -81.9938888549805, -1.43106332703369, 218, 48, 'PPL', 'P'),
(133951, 'Anglim', 47.7949981689453, 0.834180084032757, -96.5975036621094, -1.68594448811109, 218, 28, 'PPL', 'P'),
(206693, 'Anglin', 48.6569404602051, 0.849223814977424, -119.288063049316, -2.08196945853716, 218, 56, 'PPL', 'P'),
(129532, 'Angling', 44.6699981689453, 0.779638544907934, -85.0091705322266, -1.48368992017669, 218, 27, 'PPL', 'P'),
(31649, 'Angola', 37.1055603027344, 0.647614198080019, -95.4491729736328, -1.66590233669548, 218, 20, 'PPL', 'P'),
(39111, 'Angola', 30.9502792358398, 0.54018427707704, -91.5691680908203, -1.59818347649694, 218, 22, 'PPL', 'P'),
(62530, 'Angola', 34.7097206115723, 0.605798907119276, -77.6352767944336, -1.35499119576002, 218, 33, 'PPL', 'P'),
(99419, 'Angola', 37.4013900756836, 0.65277740164341, -78.2402801513672, -1.36555049632412, 218, 53, 'PPL', 'P'),
(122145, 'Angola', 41.6347198486328, 0.726662944504078, -84.9994430541992, -1.4835201436572, 218, 19, 'PPL', 'P'),
(146829, 'Angola', 42.6383285522461, 0.744179220783801, -79.0280609130859, -1.37929986439999, 218, 40, 'PPL', 'P'),
(71674, 'Angola (historical)', 38.6938896179199, 0.675335774235953, -82.1913909912109, -1.43451038959064, 218, 41, 'PPL', 'P'),
(13277, 'Angola Acres II Mobile Home Park', 38.6730613708496, 0.674972252747157, -75.1580581665039, -1.31175557441091, 218, 10, 'PPL', 'P'),
(13278, 'Angola Beach Mobile Home Park', 38.6530609130859, 0.674623178907275, -75.1650009155273, -1.3118767482405, 218, 10, 'PPL', 'P'),
(13283, 'Angola by the Bay', 38.6708297729492, 0.674933304016215, -75.1750030517578, -1.31205131844996, 218, 10, 'PPL', 'P'),
(13279, 'Angola Crest II Mobile Home Park', 38.6683311462402, 0.674889694753365, -75.1533279418945, -1.31167301641711, 218, 10, 'PPL', 'P'),
(13280, 'Angola Crest Mobile Home Park', 38.6694412231445, 0.674909069250295, -75.1561126708984, -1.31172161910701, 218, 10, 'PPL', 'P'),
(146822, 'Angola Lake Shore Addition', 42.6180610656738, 0.743825486412012, -79.0986099243164, -1.38053117692998, 218, 40, 'PPL', 'P'),
(13281, 'Angola Landing', 38.6438903808594, 0.674463122925762, -75.1272201538086, -1.3112173495546, 218, 10, 'PPL', 'P'),
(39112, 'Angola Landing', 30.9438896179199, 0.540072757206393, -91.647216796875, -1.59954568339452, 218, 22, 'PPL', 'P'),
(13282, 'Angola Neck Park Mobile Home Park', 38.6708297729492, 0.674933304016215, -75.1511077880859, -1.31163426742325, 218, 10, 'PPL', 'P'),
(146823, 'Angola on the Lake', 42.6547203063965, 0.744465310863903, -79.0491714477539, -1.3796683127368, 218, 40, 'PPL', 'P'),
(146824, 'Angola-on-the-Lake', 42.6502799987793, 0.744387812876182, -79.0550003051758, -1.37977004549044, 218, 40, 'PPL', 'P'),
(209933, 'Angoon', 57.5033302307129, 1.00362244338753, -134.583892822266, -2.3489320498997, 218, 1, 'PPL', 'P'),
(77787, 'Angora', 39.9438896179199, 0.697152389885882, -75.2380599975586, -1.31315186977043, 218, 45, 'PPL', 'P'),
(133952, 'Angora', 47.7750015258789, 0.833831076771902, -92.6338882446289, -1.61676634879324, 218, 28, 'PPL', 'P'),
(194088, 'Angora', 40.1766700744629, 0.701215175286853, -108.574996948242, -1.89499118208962, 218, 7, 'PPL', 'P'),
(199144, 'Angora', 41.8519401550293, 0.730454154052887, -103.124717712402, -1.79986586427114, 218, 35, 'PPL', 'P'),
(188047, 'Angostura', 32.6519393920898, 0.569883849553603, -107.092498779297, -1.86911670788674, 218, 38, 'PPL', 'P'),
(18854, 'Anguilla', 31.2552795410156, 0.545507536621945, -81.6036071777344, -1.42425162675554, 218, 13, 'PPL', 'P'),
(58465, 'Anguilla', 32.9738883972168, 0.575502919716589, -90.8244400024414, -1.58518551932265, 218, 30, 'PPL', 'P'),
(53193, 'Angus', 36.6344413757324, 0.639391621635372, -90.4836120605469, -1.57923694955379, 218, 29, 'PPL', 'P'),
(92269, 'Angus', 32.0061111450195, 0.558612020239843, -96.4327774047852, -1.68306947255629, 218, 51, 'PPL', 'P'),
(114417, 'Angus', 41.8833312988281, 0.731002032868144, -94.1572189331055, -1.64335348490383, 218, 16, 'PPL', 'P'),
(133954, 'Angus', 48.0811080932617, 0.83917364423471, -96.7027816772461, -1.68778193610519, 218, 28, 'PPL', 'P'),
(141165, 'Angus', 40.2822189331055, 0.703057350391888, -97.9791717529297, -1.71005914546565, 218, 35, 'PPL', 'P'),
(146825, 'Angus', 42.7347183227539, 0.745861539644404, -76.9730606079102, -1.34343334294518, 218, 40, 'PPL', 'P'),
(154072, 'Angus', 41.1966705322266, 0.719017541646678, -83.2850036621094, -1.45359753143934, 218, 41, 'PPL', 'P'),
(172924, 'Angus', 45.6477813720703, 0.796704081173162, -91.6016693115234, -1.59875072980913, 218, 57, 'PPL', 'P'),
(188048, 'Angus', 33.4452781677246, 0.583730223272171, -105.665000915527, -1.84420217009878, 218, 38, 'PPL', 'P'),
(179752, 'Angwin', 38.5758285522461, 0.673275219921532, -122.448890686035, -2.13713630788593, 218, 6, 'PPL', 'P'),
(92270, 'Anhalt', 29.7938899993896, 0.520001477466361, -98.4752807617188, -1.71871788111782, 218, 51, 'PPL', 'P'),
(212281, 'Aniak', 61.5783309936523, 1.0747446237221, -159.522216796875, -2.78418791318567, 218, 1, 'PPL', 'P'),
(7103, 'Anice (historical)', 35.4294395446777, 0.618360372190907, -94.0208282470703, -1.64097301836347, 218, 4, 'PPL', 'P'),
(200328, 'Anidem (historical)', 44.6055603027344, 0.778513891979593, -122.391670227051, -2.13613762247715, 218, 43, 'PPL', 'P'),
(13284, 'Aniline Village', 39.8138885498047, 0.694883443216162, -75.4430618286133, -1.31672982669496, 218, 10, 'PPL', 'P'),
(188049, 'Animas', 31.9488906860352, 0.557613334831063, -108.806671142578, -1.89903465957269, 218, 38, 'PPL', 'P'),
(186340, 'Animas Forks', 37.9311103820801, 0.662022765104702, -107.570831298828, -1.87746518527192, 218, 7, 'PPL', 'P'),
(158707, 'Anise', 40.3263893127441, 0.703828268948439, -75.5341720581055, -1.31832000018184, 218, 45, 'PPL', 'P'),
(29102, 'Anita', 39.4258308410645, 0.6881105585109, -86.1913909912109, -1.50432355967041, 218, 19, 'PPL', 'P'),
(112776, 'Anita', 33.1741714477539, 0.5789985183844, -86.9802780151367, -1.51809223566417, 218, 2, 'PPL', 'P'),
(114418, 'Anita', 41.4452781677246, 0.723356563431717, -94.7644424438477, -1.6539515344618, 218, 16, 'PPL', 'P'),
(158708, 'Anita', 41.0013885498047, 0.715609228083595, -78.9633331298828, -1.37817015146557, 218, 45, 'PPL', 'P'),
(179753, 'Anita', 39.8108291625977, 0.694830046836306, -121.97721862793, -2.12890407748233, 218, 6, 'PPL', 'P'),
(195879, 'Anita', 45.9441719055176, 0.801877071853559, -108.021392822266, -1.88532896733871, 218, 31, 'PPL', 'P'),
(212282, 'Aniuk (historical)', 68, 1.18682389135614, -158, -2.75762021815104, 218, 1, 'PPL', 'P'),
(172925, 'Aniwa', 45.0086097717285, 0.785548432261956, -89.2141723632813, -1.55708104718099, 218, 57, 'PPL', 'P'),
(107988, 'Anjean', 38.0200004577637, 0.663574189597727, -80.6333312988281, -1.40731711801595, 218, 58, 'PPL', 'P'),
(114419, 'Ankeny', 41.7297210693359, 0.728321028598761, -93.6055603027344, -1.63372522545681, 218, 16, 'PPL', 'P'),
(158709, 'Ankeny', 40.1377792358398, 0.700536402104019, -79.1102828979492, -1.38073490875338, 218, 45, 'PPL', 'P'),
(206694, 'Ankeny', 46.8499984741211, 0.817686727927732, -118.153610229492, -2.06216952162269, 218, 56, 'PPL', 'P'),
(154073, 'Ankenytown', 40.5341682434082, 0.707454695404799, -82.504997253418, -1.43998385142102, 218, 41, 'PPL', 'P'),
(15002, 'Ankona', 27.3402805328369, 0.477177913716914, -80.2752838134766, -1.40106801051808, 218, 12, 'PPL', 'P'),
(99420, 'Ankum', 36.603328704834, 0.638848603089105, -77.8811111450195, -1.35928181459224, 218, 53, 'PPL', 'P'),
(200329, 'Anlauf', 43.711109161377, 0.762902774564685, -123.222503662109, -2.15063840145458, 218, 43, 'PPL', 'P'),
(71675, 'Anlo', 39.9397201538086, 0.697079619009096, -83.9466705322266, -1.46514579687425, 218, 41, 'PPL', 'P'),
(107989, 'Anmoore', 39.2566719055176, 0.685158178126438, -80.2925033569336, -1.40136854824709, 218, 58, 'PPL', 'P'),
(53190, 'Ann', 37.0308303833008, 0.646309914936152, -92.1972198486328, -1.60914504754371, 218, 29, 'PPL', 'P'),
(129533, 'Ann Arbor', 42.2708282470703, 0.7377651304564, -83.7263870239258, -1.46130112436656, 218, 27, 'PPL', 'P'),
(99421, 'Ann Wrights Corner', 38.0900001525879, 0.664795914747801, -77.5263900756836, -1.35309076400613, 218, 53, 'PPL', 'P'),
(26375, 'Anna', 37.4602813720703, 0.653805248666126, -89.246940612793, -1.55765296102508, 218, 18, 'PPL', 'P'),
(34565, 'Anna', 37.1163902282715, 0.647803215938387, -86.4230575561523, -1.50836690399542, 218, 21, 'PPL', 'P'),
(58466, 'Anna', 31.6966705322266, 0.553211262707217, -91.3513870239258, -1.59438247983113, 218, 30, 'PPL', 'P'),
(92272, 'Anna', 33.3488883972168, 0.582047904411568, -96.5483322143555, -1.68508628444981, 218, 51, 'PPL', 'P'),
(154074, 'Anna', 40.3944396972656, 0.705015972215587, -84.1727828979492, -1.46909220213559, 218, 41, 'PPL', 'P'),
(7104, 'Anna (historical)', 35.7272186279297, 0.623557597637224, -94.2861099243164, -1.64560305707662, 218, 4, 'PPL', 'P'),
(18855, 'Anna Bella Estates', 33.7986106872559, 0.589897039092358, -84.6708297729492, -1.47778475993361, 218, 13, 'PPL', 'P'),
(92273, 'Anna Lisa Colonia', 26.3020000457764, 0.459056500658497, -98.2839965820313, -1.7153793423753, 218, 51, 'PPL', 'P'),
(34566, 'Anna Lynne', 36.5469398498535, 0.637864431908266, -89.2538909912109, -1.55777426801274, 218, 21, 'PPL', 'P'),
(15003, 'Anna Maria', 27.5308303833008, 0.480503635996691, -82.7336120605469, -1.44397393252423, 218, 12, 'PPL', 'P'),
(192469, 'Annabella', 38.709171295166, 0.675602489819125, -112.059173583984, -1.95580153610438, 218, 52, 'PPL', 'P'),
(53191, 'Annada', 39.2611083984375, 0.685235609535132, -90.8274993896484, -1.58523891570251, 218, 29, 'PPL', 'P'),
(39113, 'Annadale', 30.1319408416748, 0.525901577703377, -91.1311111450195, -1.59053794048149, 218, 22, 'PPL', 'P'),
(84668, 'Annadale', 35.165828704834, 0.613759495091686, -84.8850021362305, -1.48152277283964, 218, 50, 'PPL', 'P'),
(146826, 'Annadale', 40.5444412231445, 0.707633992725189, -74.1769409179688, -1.29463184807586, 218, 40, 'PPL', 'P'),
(84669, 'Annadel', 36.1766700744629, 0.63140200520708, -84.6658325195313, -1.47769754140791, 218, 50, 'PPL', 'P'),
(99422, 'Annalee Heights', 38.8597183227539, 0.678230031129624, -77.1808319091797, -1.34705963624349, 218, 53, 'PPL', 'P'),
(107990, 'Annamoriah', 38.940559387207, 0.679640973875148, -81.2272186279297, -1.41768240729464, 218, 58, 'PPL', 'P'),
(44379, 'Annandale', 39.3233299255371, 0.686321580048639, -76.9749984741211, -1.34346716509102, 218, 25, 'PPL', 'P'),
(58467, 'Annandale', 32.514720916748, 0.567488935364323, -90.1883316040039, -1.57408333337033, 218, 30, 'PPL', 'P'),
(99423, 'Annandale', 38.8302803039551, 0.677716240776321, -77.1966705322266, -1.34733607236464, 218, 53, 'PPL', 'P'),
(133967, 'Annandale', 45.2627792358398, 0.789984526268728, -94.1241683959961, -1.64277664421172, 218, 28, 'PPL', 'P'),
(144754, 'Annandale', 40.6408309936523, 0.709316311585792, -74.8816680908203, -1.30693165757039, 218, 37, 'PPL', 'P'),
(158710, 'Annandale', 41.0911102294922, 0.717175166804561, -79.8930587768555, -1.39439692514548, 218, 45, 'PPL', 'P'),
(99424, 'Annandale Acres', 38.8186111450195, 0.677512575531957, -77.1933288574219, -1.34727774913676, 218, 53, 'PPL', 'P'),
(29100, 'Annandale Estates', 39.2177810668945, 0.684479404943604, -86.26611328125, -1.50562770965622, 218, 19, 'PPL', 'P'),
(99425, 'Annandale Terrace', 38.8238906860352, 0.677604720905674, -77.2069396972656, -1.347515303106, 218, 53, 'PPL', 'P'),
(146827, 'Annandale-on-Hudson', 42.0127792358398, 0.733261325578913, -73.9086074829102, -1.2899485461409, 218, 40, 'PPL', 'P'),
(26382, 'Annapolis', 39.1444396972656, 0.683199356565658, -87.8166732788086, -1.53269008686333, 218, 18, 'PPL', 'P'),
(29101, 'Annapolis', 39.8525009155273, 0.695557356130007, -87.2505569458008, -1.52280949290303, 218, 19, 'PPL', 'P'),
(44380, 'Annapolis', 38.978328704834, 0.68030017282397, -76.4925003051758, -1.33504598340808, 218, 25, 'PPL', 'P'),
(53192, 'Annapolis', 37.360279083252, 0.652059879466715, -90.6975021362305, -1.58297003561181, 218, 29, 'PPL', 'P'),
(154075, 'Annapolis', 40.4111099243164, 0.705306922564678, -80.8633270263672, -1.41133130072702, 218, 41, 'PPL', 'P'),
(179754, 'Annapolis', 38.7219390869141, 0.675825329823337, -123.368606567383, -2.15318837819833, 218, 6, 'PPL', 'P'),
(206695, 'Annapolis', 47.547779083252, 0.829865297013638, -122.619438171387, -2.14011292303631, 218, 56, 'PPL', 'P'),
(44382, 'Annapolis Cove', 38.9394416809082, 0.679621466220163, -76.4608306884766, -1.33449324432384, 218, 25, 'PPL', 'P'),
(44383, 'Annapolis Landing', 38.939998626709, 0.679631186758142, -76.5833282470703, -1.33663123004695, 218, 25, 'PPL', 'P'),
(44385, 'Annapolis Roads', 38.9511108398438, 0.679825131464527, -76.4752807617188, -1.33474544567907, 218, 25, 'PPL', 'P'),
(44386, 'Annapolis Rock', 39.2816696166992, 0.68559447049202, -77.1319427490234, -1.34620635943023, 218, 25, 'PPL', 'P'),
(169253, 'Annaquatucket', 41.5513916015625, 0.725208592232785, -71.4486083984375, -1.24701346252081, 218, 47, 'PPL', 'P'),
(172928, 'Annaton', 42.9113883972168, 0.748945014133525, -90.5374984741211, -1.58017744489276, 218, 57, 'PPL', 'P'),
(92275, 'Annaville', 33.1169395446777, 0.577999633238538, -97.5716705322266, -1.70294690745848, 218, 51, 'PPL', 'P'),
(118628, 'Annawan', 41.3972206115723, 0.722517800846397, -89.9044418334961, -1.56912852216223, 218, 18, 'PPL', 'P'),
(169254, 'Annawomscutt', 41.7402801513672, 0.728505319346195, -71.3444366455078, -1.24519532244461, 218, 47, 'PPL', 'P'),
(141166, 'Anncar', 42.8072204589844, 0.747126940636356, -98.7430572509766, -1.7233914625148, 218, 35, 'PPL', 'P'),
(79532, 'Anne', 33.4727783203125, 0.58421019147963, -79.2538909912109, -1.3832413428133, 218, 48, 'PPL', 'P'),
(13285, 'Anne Acres', 38.7002792358398, 0.6754472941066, -75.0830612182617, -1.31044663073513, 218, 10, 'PPL', 'P'),
(18856, 'Anne Heights', 33.7213897705078, 0.588549279843696, -82.7050018310547, -1.44347458981984, 218, 13, 'PPL', 'P'),
(112506, 'Anne Manie', 32.0527801513672, 0.559426548059244, -87.5708312988281, -1.52839933487305, 218, 2, 'PPL', 'P'),
(18858, 'Anneewakee', 33.6802787780762, 0.587831757667002, -84.7333297729492, -1.4788755907161, 218, 13, 'PPL', 'P'),
(18879, 'Anneewakee Estates', 33.7125015258789, 0.588394150710199, -84.6647186279297, -1.47767810033195, 218, 13, 'PPL', 'P'),
(31650, 'Annelly', 37.9722213745117, 0.662740287281396, -97.2008285522461, -1.69647449390321, 218, 20, 'PPL', 'P'),
(44388, 'Annemessix Towne (historical)', 38.038890838623, 0.663903888940679, -75.779167175293, -1.32259597162807, 218, 25, 'PPL', 'P'),
(44397, 'Annes Delight', 39.4269409179688, 0.68812993300783, -76.3475036621094, -1.33251531458224, 218, 25, 'PPL', 'P'),
(44389, 'Anneslie', 39.3758316040039, 0.687237907200708, -76.6047210693359, -1.33700460523178, 218, 25, 'PPL', 'P'),
(31651, 'Anness', 37.4819412231445, 0.654183284382863, -97.7283325195313, -1.70568117494967, 218, 20, 'PPL', 'P'),
(34567, 'Anneta', 37.3708305358887, 0.652244037056094, -86.2452774047852, -1.50526405500937, 218, 21, 'PPL', 'P'),
(92276, 'Annetta', 32.709171295166, 0.570882734699465, -97.6758270263672, -1.70476478121857, 218, 51, 'PPL', 'P'),
(44390, 'Annetta Gardens', 39.1883316040039, 0.683965414853219, -76.8030624389648, -1.34046631517472, 218, 25, 'PPL', 'P'),
(92277, 'Annetta North', 32.7191696166992, 0.571057238329892, -97.6755599975586, -1.70476012068666, 218, 51, 'PPL', 'P'),
(92278, 'Annetta South', 32.6680603027344, 0.57016521252277, -97.6602783203125, -1.70449340510349, 218, 51, 'PPL', 'P'),
(179755, 'Annette', 35.6508293151855, 0.622224352616503, -120.178062438965, -2.09750287822726, 218, 6, 'PPL', 'P'),
(209934, 'Annette', 55.0616683959961, 0.961007405151437, -131.54167175293, -2.29583527566624, 218, 1, 'PPL', 'P'),
(13286, 'Anneville', 39.1291694641113, 0.682932840719568, -75.5194396972656, -1.3180628719786, 218, 10, 'PPL', 'P'),
(99426, 'Annex', 38.1611099243164, 0.666037014394805, -78.9858322143555, -1.37856283456831, 218, 53, 'PPL', 'P'),
(200330, 'Annex', 44.2402801513672, 0.772138550646053, -116.983329772949, -2.04174427448427, 218, 43, 'PPL', 'P'),
(107991, 'Annfred', 38.3041687011719, 0.668533861074809, -81.4138870239258, -1.42094038541419, 218, 58, 'PPL', 'P'),
(44391, 'Annie Hall', 38.6755599975586, 0.675015862010008, -76.5711135864258, -1.33641804400169, 218, 25, 'PPL', 'P'),
(18860, 'Anniedelle', 34.2174987792969, 0.597208015495871, -85.3974990844727, -1.49046753199289, 218, 13, 'PPL', 'P'),
(7105, 'Annieville', 36.1549987792969, 0.631023769753261, -91.2402801513672, -1.59244329908339, 218, 4, 'PPL', 'P'),
(79534, 'Annieville', 33.4805603027344, 0.584346012695224, -79.1022186279297, -1.38059416068976, 218, 48, 'PPL', 'P'),
(158711, 'Annin Creek', 41.9013900756836, 0.731317217983155, -78.2605590820313, -1.365904430433, 218, 45, 'PPL', 'P'),
(194524, 'Annis', 43.728328704834, 0.763203312293701, -111.935279846191, -1.95363918245729, 218, 17, 'PPL', 'P'),
(124115, 'Annisquam', 42.6583290100098, 0.744528294623684, -70.6777801513672, -1.23355997164205, 218, 23, 'PPL', 'P'),
(53195, 'Anniston', 36.8258285522461, 0.642731958011631, -89.3277816772461, -1.55906390377061, 218, 29, 'PPL', 'P'),
(112777, 'Anniston', 33.6597213745117, 0.587472963289141, -85.831672668457, -1.4980452905586, 218, 2, 'PPL', 'P'),
(188050, 'Anniston (historical)', 35.3738899230957, 0.617390848396064, -103.321937561035, -1.80330799998006, 218, 38, 'PPL', 'P'),
(158713, 'Annisville', 41.0825004577637, 0.717024897940054, -79.7972183227539, -1.3927241936648, 218, 45, 'PPL', 'P'),
(92279, 'Annona', 33.5805587768555, 0.586091315315608, -94.915283203125, -1.6565842023574, 218, 51, 'PPL', 'P'),
(7107, 'Annover (historical)', 33.7733306884766, 0.589455819878759, -91.9930572509766, -1.60558173800518, 218, 4, 'PPL', 'P'),
(146828, 'Annsville', 41.3074989318848, 0.72095186212543, -73.9283294677734, -1.29029275971179, 218, 40, 'PPL', 'P'),
(34568, 'Annville', 37.3191719055176, 0.651342423869048, -83.9705581665039, -1.46556271474291, 218, 21, 'PPL', 'P'),
(158714, 'Annville', 40.3294410705566, 0.70388153217024, -76.5155563354492, -1.3354483870488, 218, 45, 'PPL', 'P'),
(34569, 'Ano', 37.1133308410645, 0.647749819558531, -84.3363876342773, -1.47194764345637, 218, 21, 'PPL', 'P'),
(212283, 'Anogok', 59.8211097717285, 1.04407532771362, -164.028610229492, -2.86283931597509, 218, 1, 'PPL', 'P'),
(122146, 'Anoka', 40.7219390869141, 0.710731914863224, -86.2825012207031, -1.5059137331573, 218, 19, 'PPL', 'P'),
(133959, 'Anoka', 45.1977806091309, 0.788850086223382, -93.3869400024414, -1.629909581405, 218, 28, 'PPL', 'P'),
(141167, 'Anoka', 42.9469413757324, 0.749565530667514, -98.8305587768555, -1.72491865224191, 218, 35, 'PPL', 'P'),
(18861, 'Anon (historical)', 33.8683280944824, 0.591113837394415, -82.9258270263672, -1.44732871654941, 218, 13, 'PPL', 'P'),
(369, 'Anona', 27.8950004577637, 0.486859602833301, -82.8308334350586, -1.44567076561278, 218, 12, 'PPL', 'P'),
(44392, 'Another Place', 38.4416694641113, 0.670933702112107, -76.5236129760742, -1.33558900195435, 218, 25, 'PPL', 'P'),
(7108, 'Anrep (historical)', 34.2222213745117, 0.597290440331609, -91.5680618286133, -1.59816416857904, 218, 4, 'PPL', 'P'),
(44393, 'Anscroft', 39.1252784729004, 0.682864930111771, -77.0541687011719, -1.34484894622261, 218, 25, 'PPL', 'P'),
(692, 'Anse', 32.1188888549805, 0.560580362601521, -90.100830078125, -1.57255614364322, 218, 30, 'PPL', 'P'),
(39114, 'Anse La Butte', 30.2594394683838, 0.52812684853122, -91.9680633544922, -1.60514551221863, 218, 22, 'PPL', 'P'),
(34570, 'Ansel', 37.1961097717285, 0.649194584449899, -84.7091674804688, -1.47845387915749, 218, 21, 'PPL', 'P'),
(179756, 'Ansel', 34.9049987792969, 0.609207154103332, -118.153327941895, -2.06216459477468, 218, 6, 'PPL', 'P'),
(186341, 'Ansel', 37.7030601501465, 0.658042537697524, -106.101936340332, -1.85182813188022, 218, 7, 'PPL', 'P'),
(139600, 'Anselm', 46.5286102294922, 0.812077444881753, -97.4952774047852, -1.70161359585873, 218, 34, 'PPL', 'P'),
(158716, 'Anselma', 40.0813903808594, 0.69955223092318, -75.642219543457, -1.32020578454973, 218, 45, 'PPL', 'P'),
(141168, 'Anselmo', 41.6186103820801, 0.726381781271993, -99.8647232055664, -1.74296822652992, 218, 35, 'PPL', 'P'),
(195880, 'Anselmo (historical)', 46.0166702270508, 0.803142406266483, -112.547218322754, -1.96431952369295, 218, 31, 'PPL', 'P'),
(18862, 'Ansley', 33.3186111450195, 0.581519466672269, -82.7750015258789, -1.44469631496992, 218, 13, 'PPL', 'P'),
(39115, 'Ansley', 32.3955612182617, 0.565409206290052, -92.6927795410156, -1.61779419581596, 218, 22, 'PPL', 'P'),
(58468, 'Ansley', 30.2250003814697, 0.527525773073189, -89.4836120605469, -1.56178365703385, 218, 30, 'PPL', 'P'),
(112779, 'Ansley', 31.8861103057861, 0.556517610490064, -86.1158294677734, -1.5030047622986, 218, 2, 'PPL', 'P'),
(141169, 'Ansley', 41.2877807617188, 0.720607715133565, -99.3813934326172, -1.73453253061904, 218, 35, 'PPL', 'P'),
(122147, 'Ansley Acres', 41.0783309936523, 0.716952127063267, -85.2122192382813, -1.48723378863926, 218, 19, 'PPL', 'P'),
(18863, 'Ansley Brook', 33.9047203063965, 0.591749001314399, -84.0583267211914, -1.46709456500192, 218, 13, 'PPL', 'P'),
(62534, 'Ansley Heights', 36.1380615234375, 0.630728158872262, -81.7130584716797, -1.42616191220546, 218, 33, 'PPL', 'P'),
(18865, 'Ansley Mill', 33.5194396972656, 0.585024586140977, -82.4136123657227, -1.43838888424417, 218, 13, 'PPL', 'P'),
(18867, 'Ansley Park', 33.7988891601563, 0.589901899361348, -84.6602783203125, -1.47760060234423, 218, 13, 'PPL', 'P'),
(79535, 'Ansley Park', 33.5319404602051, 0.585242765613281, -81.684440612793, -1.42566243634301, 218, 48, 'PPL', 'P'),
(191078, 'Ansley Place', 30.2433300018311, 0.527845685299135, -103.138061523438, -1.80009875770846, 218, 51, 'PPL', 'P'),
(18869, 'Ansley Pointe', 33.5188903808594, 0.585014998761052, -84.4138870239258, -1.47330026297402, 218, 13, 'PPL', 'P'),
(31652, 'Anson', 37.3652801513672, 0.652147164571443, -97.5294418334961, -1.7022098776268, 218, 20, 'PPL', 'P'),
(92280, 'Anson', 32.7563896179199, 0.57170684989879, -99.8958282470703, -1.74351111191813, 218, 51, 'PPL', 'P'),
(126762, 'Anson', 44.7983283996582, 0.781878329963718, -69.8897171020508, -1.21980567671818, 218, 26, 'PPL', 'P'),
(139011, 'Anson', 40.577220916748, 0.708206106306365, -91.7658309936523, -1.60161589166789, 218, 29, 'PPL', 'P'),
(172929, 'Anson', 44.9808311462402, 0.785063603785507, -91.2866668701172, -1.59325290005477, 218, 57, 'PPL', 'P'),
(154076, 'Ansonia', 40.2144393920898, 0.701874374235675, -84.6369400024414, -1.4771932718555, 218, 41, 'PPL', 'P'),
(158717, 'Ansonia', 41.7463912963867, 0.728611978947852, -77.4286117553711, -1.35138421037961, 218, 45, 'PPL', 'P'),
(177441, 'Ansonia', 41.3461112976074, 0.721625775039275, -73.0794372558594, -1.27547679561936, 218, 8, 'PPL', 'P'),
(62532, 'Ansonville', 35.1044387817383, 0.61268803880612, -80.1094436645508, -1.39817355388732, 218, 33, 'PPL', 'P'),
(158718, 'Ansonville', 40.8474998474121, 0.712923363545223, -78.5658264160156, -1.37123235050981, 218, 45, 'PPL', 'P'),
(107992, 'Ansted', 38.1361083984375, 0.665600655450196, -81.0997161865234, -1.41545706988777, 218, 58, 'PPL', 'P'),
(77788, 'Anstine', 39.7541694641113, 0.693841148544532, -76.6352767944336, -1.33753790324007, 218, 45, 'PPL', 'P'),
(172931, 'Anston', 44.6172218322754, 0.778717424065903, -88.1602783203125, -1.53868712616403, 218, 57, 'PPL', 'P'),
(195881, 'Ant Flat', 48.7241706848145, 0.850397203753713, -114.875556945801, -2.00495669876646, 218, 31, 'PPL', 'P'),
(193018, 'Antares', 35.4197196960449, 0.618190728829469, -113.807777404785, -1.98632043009031, 218, 5, 'PPL', 'P'),
(124116, 'Antassawamock', 41.6252784729004, 0.726498161411629, -70.8077774047852, -1.23582885173275, 218, 23, 'PPL', 'P'),
(99427, 'Ante', 36.6647186279297, 0.639920059374671, -77.7194366455078, -1.35646006225925, 218, 53, 'PPL', 'P'),
(18870, 'Antebellum North', 32.6713905334473, 0.570223336013561, -83.7050018310547, -1.46092788233979, 218, 13, 'PPL', 'P'),
(18871, 'Antebellum Plateau', 32.663330078125, 0.570082654528978, -83.6977767944336, -1.46080178166217, 218, 13, 'PPL', 'P'),
(31653, 'Antelope', 38.4361114501953, 0.670836696469401, -96.9736099243164, -1.69250878072397, 218, 20, 'PPL', 'P'),
(92281, 'Antelope', 33.4416694641113, 0.58366723951239, -98.3694381713867, -1.71687057942769, 218, 51, 'PPL', 'P'),
(179757, 'Antelope', 38.7083282470703, 0.675587775854102, -121.328887939453, -2.1175885723267, 218, 6, 'PPL', 'P'),
(188051, 'Antelope', 31.9569396972656, 0.557753816578565, -108.713333129883, -1.89740560393389, 218, 38, 'PPL', 'P'),
(195882, 'Antelope', 48.6897201538086, 0.8497959285586, -104.457778930664, -1.82313217166045, 218, 31, 'PPL', 'P'),
(197938, 'Antelope', 46.8558311462402, 0.817788527260401, -102.202217102051, -1.78376519126884, 218, 34, 'PPL', 'P'),
(200331, 'Antelope', 44.910831451416, 0.783841878635433, -120.721672058105, -2.10699065592678, 218, 43, 'PPL', 'P'),
(201859, 'Antelope', 43.3030586242676, 0.755780949177595, -100.628890991211, -1.75630547042709, 218, 49, 'PPL', 'P'),
(209272, 'Antelope', 41.4211082458496, 0.722934718715049, -110.529441833496, -1.92910268038606, 218, 59, 'PPL', 'P'),
(179758, 'Antelope (historical)', 39.7069396972656, 0.693016833608126, -120.035278320313, -2.09501082523722, 218, 6, 'PPL', 'P'),
(189875, 'Antelope (historical)', 38.8211097717285, 0.677556184794807, -116.471672058105, -2.03281416271702, 218, 39, 'PPL', 'P'),
(194525, 'Antelope (historical)', 43.6722183227539, 0.762224001381851, -113.64111328125, -1.98341159238967, 218, 17, 'PPL', 'P'),
(179759, 'Antelope Acres', 34.7544403076172, 0.606579413055751, -118.288612365723, -2.06452575339714, 218, 6, 'PPL', 'P'),
(179760, 'Antelope Center', 34.5800018310547, 0.603534887297572, -117.968330383301, -2.05893577826906, 218, 6, 'PPL', 'P'),
(92282, 'Antelope Crossing', 31.2466697692871, 0.545357267757437, -97.8716735839844, -1.70818294847769, 218, 51, 'PPL', 'P'),
(201860, 'Antelope Development Area', 43.3022193908691, 0.7557663017916, -100.634170532227, -1.75639761580081, 218, 49, 'PPL', 'P'),
(191079, 'Antelope Flats', 34.6058082580566, 0.603985294416932, -100.985702514648, -1.76253300632013, 218, 51, 'PPL', 'P'),
(179761, 'Antelope Hills', 33.6055603027344, 0.586527674260217, -117.166107177734, -2.04493434199603, 218, 6, 'PPL', 'P'),
(209273, 'Antelope Hills', 43.0816688537598, 0.751916968751999, -106.323608398438, -1.85569703915383, 218, 59, 'PPL', 'P'),
(188052, 'Antelope Springs', 34.832218170166, 0.607936892842392, -106.067497253418, -1.85122705642219, 218, 38, 'PPL', 'P'),
(189877, 'Antelope Springs (historical)', 37.6086082458496, 0.656394040982765, -116.728332519531, -2.03729373282859, 218, 39, 'PPL', 'P'),
(188053, 'Antelope Wells', 31.3488903045654, 0.547141352661195, -108.508331298828, -1.89382764700937, 218, 38, 'PPL', 'P'),
(186342, 'Antero Junction', 38.9233283996582, 0.679340236409051, -105.964721679688, -1.84943328426996, 218, 7, 'PPL', 'P'),
(179762, 'Antes', 36.3086090087891, 0.633704774022644, -119.129722595215, -2.07920589627398, 218, 6, 'PPL', 'P'),
(158722, 'Antes Fort', 41.1916694641113, 0.718930256541951, -77.2241668701172, -1.34781597399307, 218, 45, 'PPL', 'P'),
(107993, 'Anthem', 39.646671295166, 0.691964951556572, -80.5286102294922, -1.40548939055983, 218, 58, 'PPL', 'P'),
(193019, 'Anthem', 33.8672218322754, 0.591094529476512, -112.146110534668, -1.95731887213545, 218, 5, 'PPL', 'P'),
(74997, 'Anthon', 35.7402801513672, 0.623785564226535, -99.0127792358398, -1.72809899921568, 218, 42, 'PPL', 'P'),
(114420, 'Anthon', 42.3883285522461, 0.739815897653816, -95.8663864135742, -1.67318408490603, 218, 16, 'PPL', 'P'),
(53194, 'Anthonies Mill', 38.079719543457, 0.664616484269357, -91.0861129760742, -1.58975257427603, 218, 29, 'PPL', 'P'),
(15007, 'Anthony', 29.2891693115234, 0.511192439660165, -82.1119384765625, -1.43312368161103, 218, 12, 'PPL', 'P'),
(31655, 'Anthony', 37.1533317565918, 0.648447967238295, -98.0308303833008, -1.71096075865269, 218, 20, 'PPL', 'P'),
(44394, 'Anthony', 38.8777809143066, 0.678545282823662, -75.7886123657227, -1.32276082129955, 218, 25, 'PPL', 'P'),
(71676, 'Anthony', 39.2361106872559, 0.68479931716955, -81.9824981689453, -1.43086452205832, 218, 41, 'PPL', 'P'),
(107994, 'Anthony', 37.8958282470703, 0.661406975681648, -80.3322219848633, -1.40206176907884, 218, 58, 'PPL', 'P'),
(122148, 'Anthony', 40.2777786254883, 0.702979852404167, -85.4361114501953, -1.49114144490674, 218, 19, 'PPL', 'P'),
(133963, 'Anthony', 47.3461112976074, 0.826345530158934, -96.6658325195313, -1.68713705164723, 218, 28, 'PPL', 'P'),
(144755, 'Anthony', 40.7483291625977, 0.711192508573753, -74.8816680908203, -1.30693165757039, 218, 37, 'PPL', 'P'),
(169255, 'Anthony', 41.6949996948242, 0.727715026292714, -71.5497207641602, -1.24877820621715, 218, 47, 'PPL', 'P'),
(188054, 'Anthony', 32.0038909912109, 0.558573271245982, -106.605278015137, -1.86061310136806, 218, 38, 'PPL', 'P'),
(191080, 'Anthony', 31.9991703033447, 0.558490879699758, -106.605003356934, -1.8606083076781, 218, 51, 'PPL', 'P'),
(18872, 'Anthony Crossroads', 33.5897216796875, 0.586251238139067, -82.5416717529297, -1.44062394218902, 218, 13, 'PPL', 'P'),
(92284, 'Anthony Harbor', 31.2652797698975, 0.545682073541886, -94.1230621337891, -1.64275733629382, 218, 51, 'PPL', 'P'),
(84672, 'Anthony Hill', 35.1358299255371, 0.613235917621377, -87.1072235107422, -1.52030785253307, 218, 50, 'PPL', 'P'),
(7109, 'Anthony Subdivision', 35.0397186279297, 0.611558459029763, -90.3402786254883, -1.57673530918383, 218, 4, 'PPL', 'P'),
(122149, 'Anthony Wayne Village', 41.0394401550293, 0.716273353880433, -85.1055603027344, -1.4853722390373, 218, 19, 'PPL', 'P'),
(7110, 'Anthonyville', 35.0394401550293, 0.611553598760774, -90.3408279418945, -1.57674489656375, 218, 4, 'PPL', 'P'),
(44395, 'Anthonyville', 39.3377799987793, 0.68657378140387, -76.5522232055664, -1.33608834465874, 218, 25, 'PPL', 'P'),
(34571, 'Anthoston', 37.7594413757324, 0.659026575720308, -87.538330078125, -1.52783208156087, 218, 21, 'PPL', 'P'),
(158721, 'Anthracite', 40.274169921875, 0.702916868644386, -76.3983306884766, -1.33340241354134, 218, 45, 'PPL', 'P'),
(84673, 'Anthras', 36.5458297729492, 0.637845057411336, -83.9902801513672, -1.4659069283138, 218, 50, 'PPL', 'P'),
(44396, 'Antietam', 39.4161109924316, 0.687940915149462, -77.7425003051758, -1.35686259905801, 218, 25, 'PPL', 'P'),
(154077, 'Antietam (historical)', 41.3325004577637, 0.72138822107004, -80.5986099243164, -1.4067111157099, 218, 41, 'PPL', 'P'),
(44398, 'Antietam Farmettes', 39.523609161377, 0.689817112137423, -77.7119369506836, -1.35632916789167, 218, 25, 'PPL', 'P'),
(44399, 'Antietam Heights', 39.476390838623, 0.688992996938098, -77.6952819824219, -1.35603848385869, 218, 25, 'PPL', 'P'),
(44400, 'Antietam Manor', 39.5291709899902, 0.689914184359156, -77.7455596923828, -1.35691599543787, 218, 25, 'PPL', 'P'),
(44401, 'Antietam Overlook', 39.5213890075684, 0.689778363143562, -77.6986083984375, -1.35609654077045, 218, 25, 'PPL', 'P'),
(172932, 'Antigo', 45.1402816772461, 0.787846540545613, -89.1522216796875, -1.55599980377842, 218, 57, 'PPL', 'P'),
(192470, 'Antimony', 38.1169395446777, 0.665266095838255, -111.998893737793, -1.95474945431575, 218, 52, 'PPL', 'P'),
(7111, 'Antimony (historical)', 34.1930618286133, 0.596781510247295, -94.2058334350586, -1.64420196802713, 218, 4, 'PPL', 'P'),
(7116, 'Antioch', 35.1355590820313, 0.613231190510442, -91.9169387817383, -1.6042532200954, 218, 4, 'PPL', 'P'),
(15008, 'Antioch', 28.0466709136963, 0.489506751667327, -82.2491683959961, -1.4355187955374, 218, 12, 'PPL', 'P'),
(18877, 'Antioch', 33.1074981689453, 0.57783485014609, -85.1699981689453, -1.48649689196564, 218, 13, 'PPL', 'P'),
(31658, 'Antioch', 38.723331451416, 0.675849631168284, -94.9452819824219, -1.65710777982771, 218, 20, 'PPL', 'P'),
(34572, 'Antioch', 38.5663909912109, 0.67311050340811, -84.2927780151367, -1.47118651201683, 218, 21, 'PPL', 'P'),
(39118, 'Antioch', 32.586109161377, 0.568734895280316, -92.7388916015625, -1.61859900309738, 218, 22, 'PPL', 'P'),
(58473, 'Antioch', 31.6336097717285, 0.552110644807714, -89.0580596923828, -1.55435636706973, 218, 30, 'PPL', 'P'),
(62539, 'Antioch', 36.1533317565918, 0.630994674718352, -81.0213928222656, -1.41409006930024, 218, 33, 'PPL', 'P'),
(71678, 'Antioch', 39.6599998474121, 0.69219757867779, -81.0680618286133, -1.41490459711964, 218, 41, 'PPL', 'P'),
(74999, 'Antioch', 34.0999984741211, 0.595157248298456, -96.8280563354492, -1.68996839136014, 218, 42, 'PPL', 'P'),
(79542, 'Antioch', 33.4797210693359, 0.584331365309229, -79.5966720581055, -1.38922400104411, 218, 48, 'PPL', 'P'),
(84685, 'Antioch', 36.3558311462402, 0.634528955800996, -86.254997253418, -1.50543369837081, 218, 50, 'PPL', 'P'),
(92293, 'Antioch', 32.2019386291504, 0.562029854603824, -95.2586135864258, -1.66257644796813, 218, 51, 'PPL', 'P'),
(99429, 'Antioch', 38.8588905334473, 0.678215583480711, -77.686393737793, -1.35588335472519, 218, 53, 'PPL', 'P'),
(107996, 'Antioch', 39.3236083984375, 0.686326440317629, -79.0177764892578, -1.37912036734251, 218, 58, 'PPL', 'P'),
(112785, 'Antioch', 32.3499984741211, 0.564613986388555, -86.4552764892578, -1.50892923045959, 218, 2, 'PPL', 'P'),
(118630, 'Antioch', 42.4772186279297, 0.741367322146841, -88.0955581665039, -1.53755754638767, 218, 18, 'PPL', 'P'),
(122151, 'Antioch', 40.3677787780762, 0.704550651394123, -84.9422225952148, -1.48252145824842, 218, 19, 'PPL', 'P'),
(139012, 'Antioch', 40.3247184753418, 0.703799107334502, -91.6930618286133, -1.60034583014403, 218, 29, 'PPL', 'P'),
(179763, 'Antioch', 38.0050010681152, 0.663312400862573, -121.804718017578, -2.12589337387, 218, 6, 'PPL', 'P'),
(199148, 'Antioch', 42.0683288574219, 0.734230849373756, -102.581672668457, -1.79038794026765, 218, 35, 'PPL', 'P'),
(7117, 'Antioch (historical)', 34.1722183227539, 0.59641772244239, -94.3591690063477, -1.64687817860655, 218, 4, 'PPL', 'P'),
(18878, 'Antioch (historical)', 30.7708301544189, 0.537052299766566, -83.8436126708984, -1.46334709787401, 218, 13, 'PPL', 'P'),
(58472, 'Antioch (historical)', 32.8380584716797, 0.573132240293228, -88.5800018310547, -1.54601268337451, 218, 30, 'PPL', 'P'),
(84686, 'Antioch (historical)', 36.2125015258789, 0.632027382010057, -87.4199981689453, -1.52576680013551, 218, 50, 'PPL', 'P'),
(92294, 'Antioch (historical)', 31.0972194671631, 0.542748867917273, -95.5038909912109, -1.66685734626238, 218, 51, 'PPL', 'P'),
(79543, 'Antioch Acres', 34.707218170166, 0.605755231277399, -80.6547164916992, -1.40769036004272, 218, 48, 'PPL', 'P'),
(112790, 'Antioch Estates', 34.2458305358887, 0.597702497931272, -85.6430587768555, -1.49475335713516, 218, 2, 'PPL', 'P'),
(99430, 'Antioch Fork', 38.0175018310547, 0.663530580334877, -77.3380584716797, -1.3498037574307, 218, 53, 'PPL', 'P'),
(29106, 'Antioch Grange', 38.7372207641602, 0.676092045406509, -85.4702835083008, -1.49173785983286, 218, 19, 'PPL', 'P'),
(84687, 'Antioch Harbor Resort', 36.3608283996582, 0.634616174326696, -88.128059387207, -1.53812479969986, 218, 50, 'PPL', 'P'),
(39119, 'Antioch Villa', 30.3786106109619, 0.530206777342572, -91.0038909912109, -1.58831752992264, 218, 22, 'PPL', 'P'),
(71679, 'Antiquity', 38.9469413757324, 0.679752360587741, -81.9063873291016, -1.42953613730659, 218, 41, 'PPL', 'P'),
(122152, 'Antiville', 40.497501373291, 0.706814737794853, -84.9786071777344, -1.48315648901035, 218, 19, 'PPL', 'P'),
(107995, 'Antler', 37.4533309936523, 0.653683941678473, -81.623893737793, -1.42460569402247, 218, 58, 'PPL', 'P'),
(197944, 'Antler', 48.9708290100098, 0.854702203655826, -101.281936645508, -1.76770326726041, 218, 34, 'PPL', 'P'),
(53196, 'Antler (historical)', 37.2166709899902, 0.649553445406787, -92.293327331543, -1.6108224395563, 218, 29, 'PPL', 'P'),
(75000, 'Antlers', 34.2311096191406, 0.597445569465106, -95.620002746582, -1.66888387869388, 218, 42, 'PPL', 'P'),
(99431, 'Antlers', 36.6705589294434, 0.640021991865394, -78.320556640625, -1.36695158537362, 218, 53, 'PPL', 'P'),
(129537, 'Antlers', 46.7544403076172, 0.81601892329507, -87.6558303833008, -1.52988284875828, 218, 27, 'PPL', 'P'),
(186343, 'Antlers', 39.5433311462402, 0.690161325708315, -107.72721862793, -1.88019465907314, 218, 7, 'PPL', 'P'),
(193349, 'Antlers', 40.8955612182617, 0.71376219270957, -122.370002746582, -2.13575945360236, 218, 6, 'PPL', 'P'),
(133965, 'Antlers Park', 44.6630592346191, 0.779517437657363, -93.2652816772461, -1.62778624306788, 218, 28, 'PPL', 'P'),
(7121, 'Antoine', 34.0361099243164, 0.594042182750039, -93.4205627441406, -1.6304964089512, 218, 4, 'PPL', 'P'),
(129538, 'Antoine', 45.8375015258789, 0.800015322514512, -88.0619430541992, -1.53697085199953, 218, 27, 'PPL', 'P'),
(34573, 'Anton', 37.3519401550293, 0.651914337713142, -87.3947219848633, -1.52532564750094, 218, 21, 'PPL', 'P'),
(172935, 'Anton', 46.6191711425781, 0.813658030988715, -92.2352828979492, -1.60980937307763, 218, 57, 'PPL', 'P'),
(186344, 'Anton', 39.7416687011719, 0.693622969072228, -103.216667175293, -1.80147068514402, 218, 7, 'PPL', 'P'),
(192959, 'Anton', 33.8111114501953, 0.590115218564663, -102.163330078125, -1.78308648466504, 218, 51, 'PPL', 'P'),
(188055, 'Anton Chico', 35.2000007629395, 0.614355910017809, -105.141670227051, -1.83506832650813, 218, 38, 'PPL', 'P'),
(44447, 'Anton North', 39.4019393920898, 0.687693574063221, -76.7244415283203, -1.33909412142306, 218, 25, 'PPL', 'P'),
(44403, 'Anton Woods', 39.4000015258789, 0.687659751917377, -76.7261123657227, -1.339123283037, 218, 25, 'PPL', 'P'),
(200332, 'Antone (historical)', 44.4716682434082, 0.776177034702076, -119.808891296387, -2.09105962628593, 218, 43, 'PPL', 'P'),
(39120, 'Antonia', 31.5641708374023, 0.550898706774647, -92.4091720581055, -1.61284431145589, 218, 22, 'PPL', 'P'),
(53197, 'Antonia', 38.3624992370605, 0.669551920980519, -90.4655609130859, -1.57892189759684, 218, 29, 'PPL', 'P'),
(31659, 'Antonino', 38.7838897705078, 0.676906573225909, -99.392219543457, -1.73472148189838, 218, 20, 'PPL', 'P'),
(39121, 'Antonio', 30.4061107635498, 0.530686745550031, -91.2247161865234, -1.5921716566522, 218, 22, 'PPL', 'P'),
(179764, 'Antonio', 34.8352813720703, 0.607990355801275, -120.568893432617, -2.10432416588534, 218, 6, 'PPL', 'P'),
(92295, 'Antonio Santos Colonia', 27.6509990692139, 0.482600975223669, -99.6190032958984, -1.73867960506851, 218, 51, 'PPL', 'P'),
(71680, 'Antonis', 39.1838912963867, 0.683887916865498, -82.9274978637695, -1.44735787816334, 218, 41, 'PPL', 'P'),
(186345, 'Antonito', 37.0791702270508, 0.64715360436949, -106.008056640625, -1.85018962201955, 218, 7, 'PPL', 'P'),
(77789, 'Antram', 39.9116706848145, 0.696590063421712, -79.9169387817383, -1.39481370985608, 218, 45, 'PPL', 'P'),
(79544, 'Antreville', 34.3038902282715, 0.598715830726047, -82.5425033569336, -1.44063845641696, 218, 48, 'PPL', 'P'),
(7123, 'Antrey (historical)', 34.098331451416, 0.595128153263546, -94.4180603027344, -1.64790602562927, 218, 4, 'PPL', 'P'),
(39122, 'Antrim', 32.8772201538086, 0.573815740586996, -93.7050018310547, -1.63546080753922, 218, 22, 'PPL', 'P'),
(53198, 'Antrim', 37.189998626709, 0.649087924848241, -92.6483306884766, -1.61701841699042, 218, 29, 'PPL', 'P'),
(99432, 'Antrim', 38.8936080932617, 0.678821519207731, -77.1941680908203, -1.34729239652276, 218, 53, 'PPL', 'P'),
(129541, 'Antrim', 44.8899993896484, 0.78347829056761, -85.0738906860352, -1.48481949995305, 218, 27, 'PPL', 'P'),
(143467, 'Antrim', 43.0308303833008, 0.751029670055812, -71.9394378662109, -1.25558005279926, 218, 36, 'PPL', 'P'),
(146831, 'Antrim', 41.1238899230957, 0.717747280385738, -74.1416702270508, -1.29401625838989, 218, 40, 'PPL', 'P'),
(154078, 'Antrim', 40.1202812194824, 0.700231004106014, -81.3586120605469, -1.41997565530931, 218, 41, 'PPL', 'P'),
(158723, 'Antrim', 41.6338882446289, 0.726648430276137, -77.2872161865234, -1.34891639215549, 218, 45, 'PPL', 'P'),
(129539, 'Antrim Center', 42.8136100769043, 0.747238460507003, -84.1144409179688, -1.4680739424928, 218, 27, 'PPL', 'P'),
(143468, 'Antrim Center', 43.0502815246582, 0.75136915651577, -71.9661102294922, -1.25604557335781, 218, 36, 'PPL', 'P'),
(146832, 'Antwerp', 44.1991691589355, 0.771421028469358, -75.6072235107422, -1.31959498855372, 218, 40, 'PPL', 'P'),
(154080, 'Antwerp', 41.1813888549805, 0.718750826063507, -84.7405624389648, -1.47900182455177, 218, 41, 'PPL', 'P'),
(53199, 'Anutt', 37.7158317565918, 0.658265444280763, -91.7197189331055, -1.60081108438647, 218, 29, 'PPL', 'P'),
(212284, 'Anvik', 62.6561088562012, 1.09355539602869, -160.206665039063, -2.79613378857133, 218, 1, 'PPL', 'P'),
(71681, 'Anvil', 39.9913902282715, 0.697981431933224, -80.834716796875, -1.41083195802263, 218, 41, 'PPL', 'P'),
(129544, 'Anvil', 46.4702796936035, 0.811059384976043, -90.0183334350586, -1.57111630559987, 218, 27, 'PPL', 'P'),
(186346, 'Anvil Points', 39.5161094665527, 0.689686217769845, -107.922218322754, -1.88359804578821, 218, 7, 'PPL', 'P'),
(79545, 'Anvil Rock', 34.5730590820313, 0.603413713467974, -80.7169418334961, -1.40877639713526, 218, 48, 'PPL', 'P'),
(179766, 'Anza', 32.8002815246582, 0.572472908186351, -115.497497558594, -2.01581161021157, 218, 6, 'PPL', 'P'),
(188063, 'Anzac', 35.0686111450195, 0.612062728582169, -107.726112365723, -1.88017535115524, 218, 38, 'PPL', 'P'),
(18880, 'Aonia', 33.6752815246582, 0.587744539141302, -82.6233291625977, -1.44204913284638, 218, 13, 'PPL', 'P'),
(75002, 'Apache', 34.8936080932617, 0.609008349127958, -98.3655624389648, -1.716802935136, 218, 42, 'PPL', 'P'),
(188062, 'Apache', 33.3252792358398, 0.581635846811905, -105.902221679688, -1.84834245348747, 218, 38, 'PPL', 'P'),
(193021, 'Apache', 31.6902809143066, 0.55309974283657, -109.13166809082, -1.90470692637845, 218, 5, 'PPL', 'P'),
(193020, 'Apache Acres Trailer Park', 33.4172210693359, 0.583240534526732, -111.601387023926, -1.94781165335998, 218, 5, 'PPL', 'P'),
(186347, 'Apache City', 37.8583297729492, 0.660752503843761, -104.830558776855, -1.82963840736157, 218, 7, 'PPL', 'P'),
(188064, 'Apache Creek', 33.8330612182617, 0.590498314287471, -108.624443054199, -1.89585417944086, 218, 38, 'PPL', 'P'),
(53200, 'Apache Flats', 38.583610534668, 0.673411041137126, -92.2994384765625, -1.61092909915795, 218, 29, 'PPL', 'P'),
(193098, 'Apache Flats', 31.5580596923828, 0.550792047172989, -110.361938476563, -1.92617919529943, 218, 5, 'PPL', 'P'),
(193023, 'Apache Grove', 32.8697204589844, 0.573684846219419, -109.189720153809, -1.90572012601517, 218, 5, 'PPL', 'P'),
(193024, 'Apache Junction', 33.4150009155273, 0.583201785532872, -111.548889160156, -1.94689539278694, 218, 5, 'PPL', 'P'),
(188065, 'Apache Springs', 35.3722190856934, 0.617361686782127, -105.192497253418, -1.83595542546724, 218, 38, 'PPL', 'P'),
(193026, 'Apache Wells', 33.4594383239746, 0.58397736462133, -111.71028137207, -1.94971221827192, 218, 5, 'PPL', 'P'),
(193100, 'Apache West Mobile Village', 33.413890838623, 0.583182411035941, -111.853889465332, -1.95221865233184, 218, 5, 'PPL', 'P'),
(75003, 'Apache Wye', 35.0436096191406, 0.61162636963756, -98.3563919067383, -1.71664287915449, 218, 42, 'PPL', 'P'),
(79546, 'Apalache', 34.961109161377, 0.610186465015181, -82.2122192382813, -1.43487391107943, 218, 48, 'PPL', 'P'),
(18881, 'Apalachee', 33.6863899230957, 0.587938417268659, -83.4311065673828, -1.45614750818309, 218, 13, 'PPL', 'P'),
(84690, 'Apalachia', 35.1680603027344, 0.613798443822629, -84.3227767944336, -1.47171008948714, 218, 50, 'PPL', 'P'),
(15013, 'Apalachicola', 29.7255592346191, 0.51880888064071, -84.9833297729492, -1.48323891384609, 218, 12, 'PPL', 'P'),
(146834, 'Apalachin', 42.0694389343262, 0.734250223870686, -76.1549987792969, -1.32915547055099, 218, 40, 'PPL', 'P'),
(7124, 'Apalco', 33.3583297729492, 0.582212687504016, -93.4599990844727, -1.63118470293493, 218, 4, 'PPL', 'P'),
(29105, 'Apalona', 38.1544418334961, 0.665920634255169, -86.6322174072266, -1.51201743205965, 218, 19, 'PPL', 'P'),
(146835, 'Apaquogue', 40.9427795410156, 0.714586307908895, -72.2125015258789, -1.26034591272802, 218, 40, 'PPL', 'P'),
(7125, 'Apex', 34.9997215270996, 0.610860377929026, -94.4358291625977, -1.64821615073821, 218, 4, 'PPL', 'P'),
(34574, 'Apex', 37.0974998474121, 0.647473516595435, -87.3411102294922, -1.52438994585194, 218, 21, 'PPL', 'P'),
(53201, 'Apex', 39.1108283996582, 0.68261272875654, -90.754997253418, -1.58397351471055, 218, 29, 'PPL', 'P'),
(62543, 'Apex', 35.7324981689453, 0.623649743010941, -78.8505630493164, -1.37620194226195, 218, 33, 'PPL', 'P'),
(146836, 'Apex', 42.0672187805176, 0.734211474876826, -75.2494430541992, -1.31335054158775, 218, 40, 'PPL', 'P'),
(154081, 'Apex', 40.4102783203125, 0.705292408336737, -80.9094390869141, -1.41213610800844, 218, 41, 'PPL', 'P'),
(179767, 'Apex', 38.7269401550293, 0.675912614928064, -120.822219848633, -2.10874554592709, 218, 6, 'PPL', 'P'),
(189880, 'Apex', 36.3291702270508, 0.634063634979532, -114.926940917969, -2.00585351826355, 218, 39, 'PPL', 'P'),
(193101, 'Apex', 35.9430618286133, 0.627324772157196, -112.184997558594, -1.95799757873926, 218, 5, 'PPL', 'P'),
(195883, 'Apex', 45.3819389343262, 0.792064255342998, -112.706390380859, -1.96709760018406, 218, 31, 'PPL', 'P'),
(107997, 'Apgah (historical)', 38.4252815246582, 0.670647678611032, -81.3027801513672, -1.41900120466645, 218, 58, 'PPL', 'P'),
(195884, 'Apgar', 48.5277786254883, 0.846969515693699, -113.992218017578, -1.98953952605794, 218, 31, 'PPL', 'P'),
(79547, 'Apia (historical)', 33.5033302307129, 0.584743422908891, -81.540283203125, -1.42314641490316, 218, 48, 'PPL', 'P'),
(200333, 'Apiary', 46.0141716003418, 0.803098797003633, -123.02889251709, -2.14725924950543, 218, 43, 'PPL', 'P'),
(84689, 'Apison', 35.0238914489746, 0.611282222645695, -85.0238876342773, -1.48394678206383, 218, 50, 'PPL', 'P'),
(7126, 'Aplin', 34.9738883972168, 0.610409504756475, -92.9786071777344, -1.6227828291699, 218, 4, 'PPL', 'P'),
(107998, 'Aplin (historical)', 38.7472190856934, 0.676266549036936, -81.5897216796875, -1.42400927909635, 218, 58, 'PPL', 'P'),
(129545, 'Aplin Beach', 43.6508293151855, 0.761850692776049, -83.8708267211914, -1.46382207265443, 218, 27, 'PPL', 'P'),
(114421, 'Aplington', 42.584171295166, 0.743233998333905, -92.8841705322266, -1.62113459877125, 218, 16, 'PPL', 'P'),
(188066, 'Apodaca', 36.1986083984375, 0.631784901192806, -105.861671447754, -1.84763471842778, 218, 38, 'PPL', 'P'),
(158725, 'Apollo', 40.5813903808594, 0.708278877183152, -79.5666732788086, -1.3887004235738, 218, 45, 'PPL', 'P'),
(179768, 'Apollo', 35.3416709899902, 0.616828521931894, -116.873611450195, -2.03982932850245, 218, 6, 'PPL', 'P'),
(18882, 'Apollo (historical)', 33.3652801513672, 0.582333994491669, -83.5277786254883, -1.45783475389171, 218, 13, 'PPL', 'P'),
(15014, 'Apollo Beach', 27.7727794647217, 0.484726444089662, -82.4077835083008, -1.43828715149053, 218, 12, 'PPL', 'P'),
(193027, 'Apollo Mobile Home Park', 33.5830612182617, 0.586134991157485, -112.268333435059, -1.95945206416861, 218, 5, 'PPL', 'P'),
(84691, 'Apollo Shores', 35.7461090087891, 0.623887296980176, -84.7491683959961, -1.47915202683725, 218, 50, 'PPL', 'P'),
(172936, 'Apollonia', 45.4500007629395, 0.793252158347228, -91.3013916015625, -1.59350989509996, 218, 57, 'PPL', 'P'),
(92296, 'Apolonia', 30.4930591583252, 0.532204281318186, -95.9097213745117, -1.67394042265561, 218, 51, 'PPL', 'P'),
(58474, 'Aponaug (historical)', 33.0583305358887, 0.576976713063839, -89.6194381713867, -1.56415426987818, 218, 30, 'PPL', 'P'),
(193028, 'Aponi-vi', 35.8813896179199, 0.626248389023613, -110.713333129883, -1.93231218897377, 218, 5, 'PPL', 'P'),
(15015, 'Apopka', 28.6802806854248, 0.500565328356799, -81.5097198486328, -1.42261298373682, 218, 12, 'PPL', 'P'),
(99433, 'Appalachia', 36.9066696166992, 0.644142900757155, -82.7819366455078, -1.44481735564146, 218, 53, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(143470, 'Appalachia', 44.3711090087891, 0.774421944964687, -71.2897186279297, -1.24424031287771, 218, 36, 'PPL', 'P'),
(112794, 'Appalachian', 33.8847198486328, 0.591399927474517, -86.4019393920898, -1.50799832250056, 218, 2, 'PPL', 'P'),
(26383, 'Appalokia (historical)', 39.5902786254883, 0.690980713796706, -89.9877777099609, -1.57058300759158, 218, 18, 'PPL', 'P'),
(118632, 'Appaloosa West', 41.9025001525879, 0.731336592480085, -88.4161071777344, -1.54315218204766, 218, 18, 'PPL', 'P'),
(197943, 'Appam', 48.5699996948242, 0.847706412367324, -103.588333129883, -1.80795747976918, 218, 34, 'PPL', 'P'),
(44404, 'Appeal', 38.3675003051758, 0.669639206085247, -76.4486083984375, -1.33427992512052, 218, 25, 'PPL', 'P'),
(92297, 'Appelt Hill', 29.5180606842041, 0.515187347742852, -96.9086074829102, -1.6913742740996, 218, 51, 'PPL', 'P'),
(158727, 'Appenzell', 40.9927787780762, 0.715458959219087, -75.3555603027344, -1.31520263696785, 218, 45, 'PPL', 'P'),
(75004, 'Apperson', 36.7511100769043, 0.641427874604846, -96.7658309936523, -1.68888235426761, 218, 42, 'PPL', 'P'),
(99434, 'Appersons Store', 37.6358299255371, 0.656869148921235, -77.1747207641602, -1.34695297664183, 218, 53, 'PPL', 'P'),
(62544, 'Appie', 35.5958290100098, 0.621264416201584, -77.7452774047852, -1.35691106858985, 218, 33, 'PPL', 'P'),
(838, 'Apple', 34.127498626709, 0.595637216505915, -95.4172210693359, -1.66534467076322, 218, 42, 'PPL', 'P'),
(71682, 'Apple', 39.4027786254883, 0.687708221449216, -82.7072219848633, -1.4435133388137, 218, 41, 'PPL', 'P'),
(195885, 'Apple Blossom Court', 46.5038909912109, 0.81164601278516, -114.08528137207, -1.99116378800678, 218, 31, 'PPL', 'P'),
(53207, 'Apple Creek', 37.5825004577637, 0.655938374120252, -89.7377777099609, -1.5662196844616, 218, 29, 'PPL', 'P'),
(154082, 'Apple Creek', 40.7516708374023, 0.711250831801626, -81.8394393920898, -1.42836767537831, 218, 41, 'PPL', 'P'),
(172937, 'Apple Creek', 44.3255615234375, 0.773626991379298, -88.3744430541992, -1.54242500591201, 218, 57, 'PPL', 'P'),
(44405, 'Apple Greene', 38.7161102294922, 0.675723597069696, -76.654167175293, -1.33786760258302, 218, 25, 'PPL', 'P'),
(34575, 'Apple Grove', 37.0552787780762, 0.64673661992181, -86.0727767944336, -1.50225335139704, 218, 21, 'PPL', 'P'),
(44406, 'Apple Grove', 38.788330078125, 0.676984071213631, -76.9611129760742, -1.34322481743183, 218, 25, 'PPL', 'P'),
(62546, 'Apple Grove', 36.5286102294922, 0.63754451968232, -81.5849990844727, -1.42392685426061, 218, 33, 'PPL', 'P'),
(71683, 'Apple Grove', 38.8866691589355, 0.678700411957159, -81.8677825927734, -1.4288623575508, 218, 41, 'PPL', 'P'),
(99437, 'Apple Grove', 37.8927803039551, 0.661353779038874, -77.897216796875, -1.3595629112453, 218, 53, 'PPL', 'P'),
(108000, 'Apple Grove', 37.4375, 0.653407638715377, -81.8050003051758, -1.42776659992028, 218, 58, 'PPL', 'P'),
(112797, 'Apple Grove', 34.398609161377, 0.600368987972713, -86.6102828979492, -1.51163460265295, 218, 2, 'PPL', 'P'),
(99438, 'Apple Mountain Lake', 38.9241714477539, 0.679354950374074, -78.1016693115234, -1.3631312807899, 218, 53, 'PPL', 'P'),
(99439, 'Apple Mountain Lake West', 38.934440612793, 0.679534181115436, -78.1197204589844, -1.36344633274685, 218, 53, 'PPL', 'P'),
(44407, 'Apple Ridge', 39.3791694641113, 0.687296163849554, -76.5111083984375, -1.33537075590302, 218, 25, 'PPL', 'P'),
(62547, 'Apple Ridge', 36.1100006103516, 0.630238403547797, -81.6427764892578, -1.42493526020737, 218, 33, 'PPL', 'P'),
(118644, 'Apple River', 42.5050010681152, 0.741852217202317, -90.0986099243164, -1.57251739464936, 218, 18, 'PPL', 'P'),
(92298, 'Apple Springs', 31.2233295440674, 0.544949903979196, -94.9661102294922, -1.65747130131651, 218, 51, 'PPL', 'P'),
(7129, 'Apple Spur', 36.3561096191406, 0.634533816069986, -94.1613922119141, -1.64342632235965, 218, 4, 'PPL', 'P'),
(99442, 'Apple Tree Village', 37.3555603027344, 0.651977521210005, -79.898063659668, -1.39448427682924, 218, 53, 'PPL', 'P'),
(18883, 'Apple Valley', 34.1586112976074, 0.596180235052182, -83.5094375610352, -1.45751464192869, 218, 13, 'PPL', 'P'),
(79550, 'Apple Valley', 34.0550003051758, 0.594371882092991, -81.0983276367188, -1.41543283512185, 218, 48, 'PPL', 'P'),
(133968, 'Apple Valley', 44.7319412231445, 0.780719655152452, -93.2174987792969, -1.62695227417253, 218, 28, 'PPL', 'P'),
(179769, 'Apple Valley', 34.5008316040039, 0.602153106165985, -117.184997558594, -2.04526404133898, 218, 6, 'PPL', 'P'),
(194526, 'Apple Valley', 43.8400001525879, 0.765152346737475, -116.995559692383, -2.04195772684564, 218, 17, 'PPL', 'P'),
(197946, 'Apple Valley', 46.8216705322266, 0.817192312071359, -100.597503662109, -1.75575765819086, 218, 34, 'PPL', 'P'),
(202889, 'Apple Valley', 40.6177787780762, 0.708913974524108, -111.793060302734, -1.95115698316328, 218, 52, 'PPL', 'P'),
(84692, 'Apple Valley Estates', 36.1477813720703, 0.6308978022337, -85.5527801513672, -1.49317769787621, 218, 50, 'PPL', 'P'),
(179770, 'Apple Valley Estates', 38.0111083984375, 0.663418993885203, -120.327781677246, -2.10011597188885, 218, 6, 'PPL', 'P'),
(179771, 'Apple Valley Highlands', 34.3911094665527, 0.600238093605136, -117.216667175293, -2.04581678042322, 218, 6, 'PPL', 'P'),
(99441, 'Apple View Estates', 39.2611083984375, 0.685235609535132, -78.1138916015625, -1.36334459999321, 218, 53, 'PPL', 'P'),
(158729, 'Applebachsville', 40.4824981689453, 0.706552882480671, -75.2733306884766, -1.31376745945641, 218, 45, 'PPL', 'P'),
(7130, 'Appleby', 36.021110534668, 0.628686979054771, -94.2461090087891, -1.64490490939686, 218, 4, 'PPL', 'P'),
(92299, 'Appleby', 31.7161102294922, 0.553550549430093, -94.6047210693359, -1.65116387059076, 218, 51, 'PPL', 'P'),
(169739, 'Appleby', 44.8169403076172, 0.78220316903768, -97.0502777099609, -1.69384688601368, 218, 49, 'PPL', 'P'),
(206696, 'Appledale', 47.3544387817383, 0.826490872175425, -119.973327636719, -2.09392958183465, 218, 56, 'PPL', 'P'),
(144756, 'Applegarth', 40.2783317565918, 0.702989506363118, -74.4730606079102, -1.29980011164532, 218, 37, 'PPL', 'P'),
(44408, 'Applegarth (historical)', 38.2447204589844, 0.667496293514114, -76.1402816772461, -1.32889860866385, 218, 25, 'PPL', 'P'),
(26384, 'Applegate', 38.792781829834, 0.677061768938434, -87.7966690063477, -1.53234094644442, 218, 18, 'PPL', 'P'),
(129546, 'Applegate', 43.355281829834, 0.756692416060675, -82.6372222900391, -1.44229161366363, 218, 27, 'PPL', 'P'),
(179772, 'Applegate', 39.0008316040039, 0.680692922505729, -120.991386413574, -2.1116980594696, 218, 6, 'PPL', 'P'),
(200334, 'Applegate', 42.2572212219238, 0.737527643066192, -123.167221069336, -2.14967353819164, 218, 43, 'PPL', 'P'),
(202891, 'Applegate Condo', 40.6561088562012, 0.709582960589936, -111.911109924316, -1.95321733774062, 218, 52, 'PPL', 'P'),
(146837, 'Applegate Corner', 42.4513893127441, 0.740916515553318, -76.6116714477539, -1.33712591221944, 218, 40, 'PPL', 'P'),
(7132, 'Appleton', 35.4252815246582, 0.618287801051202, -92.8741683959961, -1.62096002856179, 218, 4, 'PPL', 'P'),
(44410, 'Appleton', 39.6983299255371, 0.692866564743618, -75.8144378662109, -1.32321156131405, 218, 25, 'PPL', 'P'),
(53204, 'Appleton', 37.5972213745117, 0.656195302586418, -89.7127838134766, -1.56578345867504, 218, 29, 'PPL', 'P'),
(77791, 'Appleton', 39.9130592346191, 0.696614298187632, -76.6316680908203, -1.33747491948029, 218, 45, 'PPL', 'P'),
(79549, 'Appleton', 33.0433311462402, 0.576714924328684, -81.3630599975586, -1.42005328645509, 218, 48, 'PPL', 'P'),
(84693, 'Appleton', 35.023609161377, 0.611277295797678, -87.2333297729492, -1.52250882201596, 218, 50, 'PPL', 'P'),
(112798, 'Appleton', 31.2208309173584, 0.544906294716346, -87.1213912963867, -1.52055512704028, 218, 2, 'PPL', 'P'),
(118635, 'Appleton', 40.9358291625977, 0.714465000921242, -90.1608276367188, -1.57360329858384, 218, 18, 'PPL', 'P'),
(126764, 'Appleton', 44.2891693115234, 0.772991827459314, -69.2513885498047, -1.20866474177199, 218, 26, 'PPL', 'P'),
(133970, 'Appleton', 45.1969413757324, 0.788835438837386, -96.0194396972656, -1.67585536863743, 218, 28, 'PPL', 'P'),
(146838, 'Appleton', 43.3274993896484, 0.756207521005199, -78.6483306884766, -1.37267232171121, 218, 40, 'PPL', 'P'),
(154083, 'Appleton', 40.209171295166, 0.70178242859904, -82.6163864135742, -1.44192795901678, 218, 41, 'PPL', 'P'),
(172939, 'Appleton', 44.2619400024414, 0.77251658636279, -88.415283203125, -1.54313780097777, 218, 57, 'PPL', 'P'),
(186348, 'Appleton', 39.1208305358887, 0.682787298965995, -108.607498168945, -1.89555843540181, 218, 7, 'PPL', 'P'),
(194527, 'Appleton', 42.7480583190918, 0.746094366502705, -114.634437561035, -2.00074837161192, 218, 17, 'PPL', 'P'),
(206697, 'Appleton', 45.811939239502, 0.799569176452896, -121.269996643066, -2.11656072530398, 218, 56, 'PPL', 'P'),
(44411, 'Appleton Acres', 39.7013893127441, 0.692919961123474, -75.8172225952148, -1.32326016400394, 218, 25, 'PPL', 'P'),
(53205, 'Appleton City', 38.190559387207, 0.666551004485191, -94.029167175293, -1.64111856011704, 218, 29, 'PPL', 'P'),
(44412, 'Appleton Glen', 39.7041702270508, 0.692968497234341, -75.8152770996094, -1.32322620870004, 218, 25, 'PPL', 'P'),
(44413, 'Appletown', 39.4805603027344, 0.689065767814884, -77.6477813720703, -1.35520944181135, 218, 25, 'PPL', 'P'),
(158730, 'Appletree Hill', 40.1602783203125, 0.700929085206751, -74.8438873291016, -1.30627225888449, 218, 45, 'PPL', 'P'),
(84694, 'Applewalk Park', 36.4630584716797, 0.636400425678022, -82.5069427490234, -1.44001780672492, 218, 50, 'PPL', 'P'),
(158734, 'Applewold', 40.8086090087891, 0.712244590362389, -79.5219421386719, -1.38791971790025, 218, 45, 'PPL', 'P'),
(18884, 'Applewood', 34.0944404602051, 0.595060242655749, -84.4674987792969, -1.47423596462302, 218, 13, 'PPL', 'P'),
(58475, 'Applewood', 34.2897186279297, 0.598468489639805, -88.7225036621094, -1.54849980951654, 218, 30, 'PPL', 'P'),
(84695, 'Applewood', 35.1480598449707, 0.613449369982746, -85.3363876342773, -1.48940093597631, 218, 50, 'PPL', 'P'),
(99448, 'Applewood', 37.3269386291504, 0.651477978768533, -79.8777770996094, -1.39413020956231, 218, 53, 'PPL', 'P'),
(186349, 'Applewood', 39.7472190856934, 0.693719841556879, -105.162216186523, -1.83542692114891, 218, 7, 'PPL', 'P'),
(202892, 'Applewood', 40.6450004577637, 0.709389082462578, -111.829170227051, -1.95178722023525, 218, 52, 'PPL', 'P'),
(141177, 'Applewood Mobile Home Park', 40.6827812194824, 0.710048481148482, -95.8647232055664, -1.67315505645015, 218, 35, 'PPL', 'P'),
(206698, 'Appleyard', 47.3977813720703, 0.827247343083062, -120.301940917969, -2.09966496555824, 218, 56, 'PPL', 'P'),
(18885, 'Appling', 33.5458297729492, 0.585485179851506, -82.3161087036133, -1.43668712430761, 218, 13, 'PPL', 'P'),
(44414, 'Appolds', 39.6272201538086, 0.691625465096614, -77.3219375610352, -1.34952239446154, 218, 25, 'PPL', 'P'),
(99444, 'Appomattoc (historical)', 37.3416709899902, 0.65173510697178, -77.2736129760742, -1.34867897134431, 218, 53, 'PPL', 'P'),
(99445, 'Appomattox', 37.3569412231445, 0.65200162281787, -78.8255615234375, -1.37576558331734, 218, 53, 'PPL', 'P'),
(99446, 'Appomattox (historical)', 37.3772201538086, 0.652355556926741, -78.7966690063477, -1.37526131376494, 218, 53, 'PPL', 'P'),
(124117, 'Apponagansett', 41.601390838623, 0.726081243542977, -70.9625015258789, -1.23852929707809, 218, 23, 'PPL', 'P'),
(169256, 'Apponaug', 41.7002792358398, 0.72780717166643, -71.4602813720703, -1.2472171943442, 218, 47, 'PPL', 'P'),
(158732, 'Apps', 40.7661094665527, 0.711502833419774, -75.5819396972656, -1.31915370276109, 218, 45, 'PPL', 'P'),
(206699, 'Apricot', 46.2366714477539, 0.806982151926159, -119.856391906738, -2.09188866833327, 218, 56, 'PPL', 'P'),
(202894, 'April Acres', 40.7019386291504, 0.710382841023342, -112.080558776855, -1.95617477813116, 218, 52, 'PPL', 'P'),
(44415, 'April Estates', 38.660831451416, 0.674758800385788, -76.620002746582, -1.33727132081495, 218, 25, 'PPL', 'P'),
(202895, 'April Meadows', 40.6349983215332, 0.709214512253124, -111.990280151367, -1.95459911887221, 218, 52, 'PPL', 'P'),
(193029, 'Apron Crossing', 34.4833297729492, 0.601847641588953, -113.046943664551, -1.97304137626296, 218, 5, 'PPL', 'P'),
(144757, 'Apshawa', 41.0175018310547, 0.715890457894707, -74.3633270263672, -1.29788489934739, 218, 37, 'PPL', 'P'),
(7133, 'Apt', 35.774169921875, 0.624377052304641, -90.6722183227539, -1.58252874981919, 218, 4, 'PPL', 'P'),
(118636, 'Aptakisic', 42.1824989318848, 0.73622349308038, -87.9472198486328, -1.53496855433395, 218, 18, 'PPL', 'P'),
(143471, 'Apthorp', 44.3077812194824, 0.773316666533277, -71.7427825927734, -1.25214777078637, 218, 36, 'PPL', 'P'),
(179774, 'Aptos', 36.9772186279297, 0.645374213287153, -121.898330688477, -2.12752722319876, 218, 6, 'PPL', 'P'),
(53208, 'Aptus', 38.0402793884277, 0.663928123706599, -90.8483276367188, -1.5856024371913, 218, 29, 'PPL', 'P'),
(146839, 'Apulia', 42.8238906860352, 0.747417890985447, -76.0538864135742, -1.32739072685465, 218, 40, 'PPL', 'P'),
(146840, 'Apulia Station', 42.8186111450195, 0.74732574561173, -76.0727767944336, -1.3277204261976, 218, 40, 'PPL', 'P'),
(124118, 'Aqawam (historical)', 42.6791687011719, 0.744892015849561, -70.841667175293, -1.23642033981085, 218, 23, 'PPL', 'P'),
(77792, 'Aqua', 39.9119415283203, 0.696594790532647, -77.6172180175781, -1.354676010645, 218, 45, 'PPL', 'P'),
(18887, 'Aqua (historical)', 33.5161094665527, 0.584966462650185, -83.4902801513672, -1.45718028205383, 218, 13, 'PPL', 'P'),
(75005, 'Aqua Park', 35.6202812194824, 0.621691187766269, -95.0758285522461, -1.65938624729833, 218, 42, 'PPL', 'P'),
(112799, 'Aqua Vista', 34.8302803039551, 0.607903070696547, -87.4852828979492, -1.5269062336079, 218, 2, 'PPL', 'P'),
(177446, 'Aqua Vista', 41.4461097717285, 0.723371077659658, -73.4444427490234, -1.28184734326293, 218, 8, 'PPL', 'P'),
(62549, 'Aquadale', 35.2272186279297, 0.614830951377252, -80.225830078125, -1.40020488000878, 218, 33, 'PPL', 'P'),
(44416, 'Aquahart Manor', 39.1500015258789, 0.683296428787391, -76.628059387207, -1.33741193572051, 218, 25, 'PPL', 'P'),
(44417, 'Aquasco', 38.5849990844727, 0.673435275903046, -76.7252807617188, -1.33910876880906, 218, 25, 'PPL', 'P'),
(158733, 'Aquashicola', 40.8111114501953, 0.712288266204266, -75.5905609130859, -1.31930417136268, 218, 45, 'PPL', 'P'),
(146841, 'Aquebogue', 40.9444389343262, 0.71461526978575, -72.6275024414063, -1.26758904510276, 218, 40, 'PPL', 'P'),
(146842, 'Aqueduct', 42.8480606079102, 0.747839735702115, -73.8894424438477, -1.28961405310799, 218, 40, 'PPL', 'P'),
(158735, 'Aquetong', 40.351390838623, 0.704264627893048, -75.0036087036133, -1.30905992275553, 218, 45, 'PPL', 'P'),
(146843, 'Aquetuck', 42.4605598449707, 0.741076571534832, -73.8388900756836, -1.28873174783884, 218, 40, 'PPL', 'P'),
(15016, 'Aqui Esta', 26.9061107635498, 0.46960022173023, -82.0472183227539, -1.43199410183468, 218, 12, 'PPL', 'P'),
(99449, 'Aquia', 38.4822196960449, 0.671641437171795, -77.3869400024414, -1.35065690108591, 218, 53, 'PPL', 'P'),
(99450, 'Aquia Harbour', 38.4625015258789, 0.67129729017993, -77.3891677856445, -1.35069578323783, 218, 53, 'PPL', 'P'),
(53209, 'Aquilla', 36.9469413757324, 0.644845775547854, -89.9147186279297, -1.56930788606165, 218, 29, 'PPL', 'P'),
(92300, 'Aquilla', 31.851390838623, 0.55591164147353, -97.2177810668945, -1.69677037110032, 218, 51, 'PPL', 'P'),
(112192, 'Aquilla', 31.7122192382813, 0.553482638822296, -88.4138870239258, -1.5431134330538, 218, 2, 'PPL', 'P'),
(154084, 'Aquilla', 41.5724983215332, 0.725576973990571, -81.1544418334961, -1.41641221261273, 218, 41, 'PPL', 'P'),
(62550, 'Aquone', 35.207218170166, 0.61448187753737, -83.6272201538086, -1.45957033597412, 218, 33, 'PPL', 'P'),
(194089, 'Ara', 40.0250015258789, 0.698568059742341, -105.249717712402, -1.83695411087602, 218, 7, 'PPL', 'P'),
(53211, 'Arab', 37.0708312988281, 0.647008062615917, -90.1194381713867, -1.57288091613816, 218, 29, 'PPL', 'P'),
(112801, 'Arab', 34.3180618286133, 0.598963171812288, -86.4958267211914, -1.50963696551928, 218, 2, 'PPL', 'P'),
(188067, 'Arabela', 33.5869407653809, 0.5862027020282, -105.172782897949, -1.8356113450544, 218, 38, 'PPL', 'P'),
(188068, 'Arabella', 34.8636093139648, 0.608484771657648, -104.78360748291, -1.82881895269415, 218, 38, 'PPL', 'P'),
(18888, 'Arabi', 31.8313903808594, 0.555562567633648, -83.7380599975586, -1.46150485618995, 218, 13, 'PPL', 'P'),
(39123, 'Arabi', 29.9541702270508, 0.522798895164894, -90.0052795410156, -1.57088847216861, 218, 22, 'PPL', 'P'),
(29107, 'Arabia', 39.7661094665527, 0.694049540899831, -87.3219375610352, -1.52405531966097, 218, 19, 'PPL', 'P'),
(62551, 'Arabia', 34.9500007629395, 0.609992586887824, -79.1258316040039, -1.38100628486845, 218, 33, 'PPL', 'P'),
(71684, 'Arabia', 38.6580581665039, 0.674710397432975, -82.4736099243164, -1.43943603918479, 218, 41, 'PPL', 'P'),
(146845, 'Arabia', 42.5338897705078, 0.742356420175697, -74.6361083984375, -1.30264583242813, 218, 40, 'PPL', 'P'),
(199149, 'Arabia', 42.7311096191406, 0.745798555884624, -100.372222900391, -1.75182576715747, 218, 35, 'PPL', 'P'),
(199811, 'Arabia', 40.3636093139648, 0.704477880517336, -118.391670227051, -2.06632445239738, 218, 39, 'PPL', 'P'),
(13289, 'Arabian Acres', 38.7355613708496, 0.676063083529654, -75.2266693115234, -1.31295306479506, 218, 10, 'PPL', 'P'),
(179775, 'Arabian Gardens Mobile Home Park', 33.7305603027344, 0.58870933582521, -116.240562438965, -2.02878053892999, 218, 6, 'PPL', 'P'),
(193025, 'Araby', 32.6755599975586, 0.570296106890348, -114.521392822266, -1.99877536871834, 218, 5, 'PPL', 'P'),
(44418, 'Araby View', 39.353889465332, 0.686854944635955, -77.3858337402344, -1.35063759316801, 218, 25, 'PPL', 'P'),
(108001, 'Aracoma', 37.8588905334473, 0.660762290960767, -81.9922180175781, -1.43103416541976, 218, 58, 'PPL', 'P'),
(133973, 'Arago', 47.0511093139648, 0.821196774244457, -95.1613922119141, -1.66087961487959, 218, 28, 'PPL', 'P'),
(200335, 'Arago', 43.1022186279297, 0.752275629971806, -124.191108703613, -2.16754374858024, 218, 43, 'PPL', 'P'),
(141178, 'Arago (historical)', 40.1525001525879, 0.700793330570184, -95.477783203125, -1.66640167939987, 218, 35, 'PPL', 'P'),
(18889, 'Aragon', 34.0455589294434, 0.594207099000542, -85.0561065673828, -1.484509108528, 218, 13, 'PPL', 'P'),
(188070, 'Aragon', 33.8811111450195, 0.591336943714737, -108.538330078125, -1.89435122447968, 218, 38, 'PPL', 'P'),
(193031, 'Aragon Place', 32.9722213745117, 0.57547382468168, -109.356941223145, -1.90863868425379, 218, 5, 'PPL', 'P'),
(62552, 'Aragona Village', 34.7641716003418, 0.606749256154271, -77.3466720581055, -1.34995409287424, 218, 33, 'PPL', 'P'),
(99452, 'Aragona Village', 36.8488883972168, 0.643134428231369, -76.1494369506836, -1.32905839832926, 218, 53, 'PPL', 'P'),
(202896, 'Aragonite', 40.7427787780762, 0.711095636089101, -113.001937866211, -1.97225587689944, 218, 52, 'PPL', 'P'),
(191081, 'Arah', 32.7580604553223, 0.571736011512726, -101.134719848633, -1.7651338494407, 218, 51, 'PPL', 'P'),
(129547, 'Aral (historical)', 44.7622184753418, 0.781248092891751, -86.0747222900391, -1.50228730670094, 218, 27, 'PPL', 'P'),
(92302, 'Aransas Pass', 27.9091701507568, 0.487106910630029, -97.1497192382813, -1.69558246809609, 218, 51, 'PPL', 'P'),
(75006, 'Arapaho', 35.5777816772461, 0.620949430823655, -98.9641723632813, -1.72725064925044, 218, 42, 'PPL', 'P'),
(62553, 'Arapahoe', 35.0255584716797, 0.611311317680604, -76.8258285522461, -1.34086365880936, 218, 33, 'PPL', 'P'),
(141181, 'Arapahoe', 40.3041687011719, 0.703440446114696, -99.9000015258789, -1.74358394937395, 218, 35, 'PPL', 'P'),
(186350, 'Arapahoe', 38.8499984741211, 0.678060387768186, -102.181671142578, -1.78340659662806, 218, 7, 'PPL', 'P'),
(209274, 'Arapahoe', 42.9622192382813, 0.749832179671658, -108.489166259766, -1.89349315397645, 218, 59, 'PPL', 'P'),
(15017, 'Araquey', 29.9461097717285, 0.52265821368031, -81.3375015258789, -1.4196072069725, 218, 12, 'PPL', 'P'),
(18891, 'Ararat', 32.0611114501953, 0.559571956654762, -83.1263885498047, -1.45082917548621, 218, 13, 'PPL', 'P'),
(39124, 'Ararat', 30.3002796173096, 0.528839643596979, -93.1997222900391, -1.62664201590553, 218, 22, 'PPL', 'P'),
(62554, 'Ararat', 36.4038887023926, 0.635367718386317, -80.5608291625977, -1.406051717024, 218, 33, 'PPL', 'P'),
(79559, 'Ararat', 32.978328704834, 0.57558041770431, -80.0036087036133, -1.39632638535524, 218, 48, 'PPL', 'P'),
(99453, 'Ararat', 36.5988883972168, 0.638771105101383, -80.5108337402344, -1.40517913229283, 218, 53, 'PPL', 'P'),
(112803, 'Ararat', 31.9680595397949, 0.557947894443005, -88.1466674804688, -1.53844957219479, 218, 2, 'PPL', 'P'),
(158736, 'Ararat', 41.8294410705566, 0.730061470950155, -75.5250015258789, -1.31815994420033, 218, 45, 'PPL', 'P'),
(179776, 'Arastraville', 37.9980583190918, 0.663191227032974, -120.225830078125, -2.09833658080651, 218, 6, 'PPL', 'P'),
(34576, 'Arat', 36.7566719055176, 0.64152494682658, -85.4652786254883, -1.4916505081491, 218, 21, 'PPL', 'P'),
(193032, 'Aravaipa', 32.957218170166, 0.575211969367498, -110.354438781738, -1.92604830093185, 218, 5, 'PPL', 'P'),
(179777, 'Araz Junction', 32.7472190856934, 0.571546793917276, -114.713607788086, -2.00213015274351, 218, 6, 'PPL', 'P'),
(729, 'Arba', 35.4011116027832, 0.617865956334534, -77.7024993896484, -1.35616445137825, 218, 33, 'PPL', 'P'),
(122153, 'Arba', 40.0108299255371, 0.6983207186561, -84.866943359375, -1.48120758772463, 218, 19, 'PPL', 'P'),
(112802, 'Arbacoochee (historical)', 33.5761108398438, 0.586013684169832, -85.517219543457, -1.49255704818417, 218, 2, 'PPL', 'P'),
(92303, 'Arbala', 32.9874992370605, 0.575740473685824, -95.6530609130859, -1.66946085254404, 218, 51, 'PPL', 'P'),
(7134, 'Arbaugh', 35.7816696166992, 0.624507946672219, -93.5013885498047, -1.63190708538062, 218, 4, 'PPL', 'P'),
(71685, 'Arbaugh', 39.1733283996582, 0.683703559539037, -82.3377838134766, -1.43706542634046, 218, 41, 'PPL', 'P'),
(179785, 'Arbee', 39.211109161377, 0.68436295822494, -121.994720458984, -2.12920954205937, 218, 6, 'PPL', 'P'),
(139013, 'Arbela', 40.4625015258789, 0.706203875219817, -92.0166702270508, -1.60599386218387, 218, 29, 'PPL', 'P'),
(154085, 'Arbela', 40.4816703796387, 0.706538434831758, -83.4069366455078, -1.45572566346643, 218, 41, 'PPL', 'P'),
(179778, 'Arbios', 36.776668548584, 0.641873954087435, -120.396942138672, -2.10132304965293, 218, 6, 'PPL', 'P'),
(58476, 'Arbo', 31.7266693115234, 0.553734840177527, -89.6338882446289, -1.56440647123341, 218, 30, 'PPL', 'P'),
(71688, 'Arbocrest Acres', 39.2133293151855, 0.684401707218801, -84.414436340332, -1.47330985035395, 218, 41, 'PPL', 'P'),
(179779, 'Arboga', 39.0513916015625, 0.681575360932927, -121.554718017578, -2.12153005074001, 218, 6, 'PPL', 'P'),
(179780, 'Arbolada', 34.4497184753418, 0.601261013779835, -119.257217407227, -2.0814311005228, 218, 6, 'PPL', 'P'),
(186352, 'Arboles', 37.0280609130859, 0.646261578562368, -107.418609619141, -1.87480841576846, 218, 7, 'PPL', 'P'),
(194528, 'Arbon', 42.4558296203613, 0.740994013541039, -112.567497253418, -1.96467345780182, 218, 17, 'PPL', 'P'),
(53212, 'Arbor', 37.1591682434082, 0.648549833149991, -89.8022232055664, -1.56734447054799, 218, 29, 'PPL', 'P'),
(77793, 'Arbor', 39.8802795410156, 0.696042184606456, -76.6227798461914, -1.33731979034679, 218, 45, 'PPL', 'P'),
(92308, 'Arbor', 31.2941703796387, 0.546186309804779, -95.2944412231445, -1.66320175819208, 218, 51, 'PPL', 'P'),
(141184, 'Arbor', 40.8955612182617, 0.71376219270957, -96.6727828979492, -1.68725835863488, 218, 35, 'PPL', 'P'),
(179781, 'Arbor', 37.961669921875, 0.662556129692017, -121.722221374512, -2.12445353582665, 218, 6, 'PPL', 'P'),
(62562, 'Arbor Acres', 35.7986106872559, 0.624803624132245, -80.2272186279297, -1.4002291147747, 218, 33, 'PPL', 'P'),
(202897, 'Arbor Estates', 40.6644401550293, 0.709728369185455, -111.826393127441, -1.95173875070341, 218, 52, 'PPL', 'P'),
(202898, 'Arbor Estates Condominium', 40.6644401550293, 0.709728369185455, -111.826393127441, -1.95173875070341, 218, 52, 'PPL', 'P'),
(18892, 'Arbor Forest', 33.9333305358887, 0.592248344018789, -84.6180572509766, -1.4768637056706, 218, 13, 'PPL', 'P'),
(44419, 'Arbor Greene', 38.6911087036133, 0.675287238125087, -76.6313934326172, -1.33747012579033, 218, 25, 'PPL', 'P'),
(7136, 'Arbor Grove', 36.0183296203613, 0.628638442943904, -91.0475006103516, -1.58907866136218, 218, 4, 'PPL', 'P'),
(206700, 'Arbor Heights', 47.5175018310547, 0.829336859274339, -122.375556945801, -2.13585639266604, 218, 56, 'PPL', 'P'),
(99454, 'Arbor Hill', 38.0997200012207, 0.664965558109239, -79.1527786254883, -1.38147659911696, 218, 53, 'PPL', 'P'),
(114423, 'Arbor Hill', 41.3666687011719, 0.721984569417136, -94.3180618286133, -1.64616072300889, 218, 16, 'PPL', 'P'),
(114424, 'Arbor Lake Mobile Home Community', 41.7355613708496, 0.728422961089484, -92.7297210693359, -1.61843894711587, 218, 16, 'PPL', 'P'),
(99456, 'Arbor Meadows', 36.8697204589844, 0.643498016299192, -76.4638900756836, -1.33454664070369, 218, 53, 'PPL', 'P'),
(99457, 'Arbor Park', 38.1222190856934, 0.665358241211971, -78.5088882446289, -1.37023859194905, 218, 53, 'PPL', 'P'),
(13290, 'Arbor Pointe Apartments', 39.7113914489746, 0.693094531332929, -75.6477813720703, -1.32030285677146, 218, 10, 'PPL', 'P'),
(18893, 'Arbor Ridge', 33.7869415283203, 0.589693373847994, -84.105827331543, -1.46792360704926, 218, 13, 'PPL', 'P'),
(53213, 'Arbor Terrace', 38.7000007629395, 0.675442433837611, -90.283332824707, -1.57574141746501, 218, 29, 'PPL', 'P'),
(18894, 'Arbor Trace', 34.0166702270508, 0.593702896027163, -84.0366668701172, -1.46671652928518, 218, 13, 'PPL', 'P'),
(172941, 'Arbor Vitae', 45.9205589294434, 0.801464947674869, -89.663330078125, -1.56492032816575, 218, 57, 'PPL', 'P'),
(18895, 'Arbor Walk', 33.8311080932617, 0.590464225825518, -84.8694381713867, -1.48125113040845, 218, 13, 'PPL', 'P'),
(18896, 'Arbor West', 33.5530586242676, 0.585611347108148, -84.4697189331055, -1.47427471361688, 218, 13, 'PPL', 'P'),
(44420, 'Arboranda Estates', 39.6833305358887, 0.692604776008463, -77.7888870239258, -1.3576722000294, 218, 25, 'PPL', 'P'),
(44421, 'Arbordale', 39.1452789306641, 0.683214003951653, -76.6166687011719, -1.33721313074514, 218, 25, 'PPL', 'P'),
(108002, 'Arborland Acres', 38.3913917541504, 0.670056190532926, -81.8638916015625, -1.428794446943, 218, 58, 'PPL', 'P'),
(44422, 'Arborview', 38.4972190856934, 0.67190322590695, -76.7827835083008, -1.34011238106585, 218, 25, 'PPL', 'P'),
(79552, 'Arborville', 34.2922210693359, 0.598512165481683, -82.3475036621094, -1.4372350697019, 218, 48, 'PPL', 'P'),
(141185, 'Arborville', 41.0227813720703, 0.715982603268424, -97.774169921875, -1.70648118854113, 218, 35, 'PPL', 'P'),
(44423, 'Arborwood', 39.4638900756836, 0.688774817465793, -76.791389465332, -1.34026258335133, 218, 25, 'PPL', 'P'),
(202899, 'Arborwood Park', 40.6605606079102, 0.709660658314739, -111.828330993652, -1.95177257284926, 218, 52, 'PPL', 'P'),
(44424, 'Arbour Green', 39.398609161377, 0.68763545057243, -76.4569396972656, -1.33442533371604, 218, 25, 'PPL', 'P'),
(44425, 'Arbour Manor', 39.2430610656738, 0.684920624157203, -76.6997222900391, -1.33866268932647, 218, 25, 'PPL', 'P'),
(13291, 'Arbour Park', 39.6541709899902, 0.692095845924149, -75.7652816772461, -1.32235362396888, 218, 10, 'PPL', 'P'),
(108003, 'Arbovale', 38.4352798461914, 0.67082218224146, -79.8177795410156, -1.39308305462169, 218, 58, 'PPL', 'P'),
(13292, 'Arbre Park Mobile Home Park', 38.7099990844727, 0.675616937468038, -75.2038879394531, -1.31255545484431, 218, 10, 'PPL', 'P'),
(39126, 'Arbroth', 30.610279083252, 0.534250154957098, -91.3188934326172, -1.593815359677, 218, 22, 'PPL', 'P'),
(108004, 'Arbuckle', 38.7127799987793, 0.675665473578905, -81.9483337402344, -1.43026824029025, 218, 58, 'PPL', 'P'),
(158738, 'Arbuckle', 41.982780456543, 0.732737748108603, -79.8641662597656, -1.39389265559308, 218, 45, 'PPL', 'P'),
(179782, 'Arbuckle', 39.0175018310547, 0.680983872854821, -122.056671142578, -2.13029078546194, 218, 6, 'PPL', 'P'),
(99458, 'Arbuckle Landing', 36.5927810668945, 0.638664512078753, -76.3850021362305, -1.33316978642012, 218, 53, 'PPL', 'P'),
(118638, 'Arbury Hills', 41.5355606079102, 0.72493228926969, -87.8475036621094, -1.53322817856158, 218, 18, 'PPL', 'P'),
(44426, 'Arbutus', 39.2544403076172, 0.685119229395496, -76.7002792358398, -1.33867240986445, 218, 25, 'PPL', 'P'),
(133976, 'Arbutus', 48.3069381713867, 0.843115122648027, -93.0475006103516, -1.62398524640207, 218, 28, 'PPL', 'P'),
(113104, 'Arbutus Beach', 44.9461097717285, 0.78445760147946, -84.6833267211914, -1.47800287282688, 218, 27, 'PPL', 'P'),
(108006, 'Arbutus Park', 39.2663917541504, 0.685327821487876, -80.3238906860352, -1.40191636048332, 218, 58, 'PPL', 'P'),
(53214, 'Arbyrd', 36.0508308410645, 0.629205696256091, -90.2386093139648, -1.57496084494951, 218, 29, 'PPL', 'P'),
(18897, 'Arcade', 34.0777816772461, 0.59476949204374, -83.5616683959961, -1.45842624196982, 218, 13, 'PPL', 'P'),
(146846, 'Arcade', 42.5338897705078, 0.742356420175697, -78.4233322143555, -1.36874535752584, 218, 40, 'PPL', 'P'),
(179783, 'Arcade', 38.475830078125, 0.671529917301148, -121.57861328125, -2.12194710176672, 218, 6, 'PPL', 'P'),
(191082, 'Arcade', 31.8027801513672, 0.555063224929258, -102.445556640625, -1.78801226741725, 218, 51, 'PPL', 'P'),
(179784, 'Arcade (historical)', 38.6366691589355, 0.674337088827174, -121.406936645508, -2.11895077922427, 218, 6, 'PPL', 'P'),
(172943, 'Arcade Acres', 43.8586082458496, 0.76547711923241, -88.8708267211914, -1.55108853525415, 218, 57, 'PPL', 'P'),
(7137, 'Arcadia', 33.8422203063965, 0.590658170531903, -93.4658279418945, -1.63128643568857, 218, 4, 'PPL', 'P'),
(15018, 'Arcadia', 27.2155609130859, 0.475001145710424, -81.8586120605469, -1.42870230156928, 218, 12, 'PPL', 'P'),
(26385, 'Arcadia', 39.839168548584, 0.695324662429761, -90.2447204589844, -1.57506750455117, 218, 18, 'PPL', 'P'),
(31663, 'Arcadia', 37.6419410705566, 0.656975808522893, -94.6236114501953, -1.65149356993371, 218, 20, 'PPL', 'P'),
(39127, 'Arcadia', 32.5488891601563, 0.568085283711419, -92.9199981689453, -1.6217599089952, 218, 22, 'PPL', 'P'),
(44427, 'Arcadia', 39.0958290100098, 0.682350940021386, -76.4291687011719, -1.33394063839765, 218, 25, 'PPL', 'P'),
(53215, 'Arcadia', 37.5880584716797, 0.656035379762958, -90.6288909912109, -1.58177254522766, 218, 29, 'PPL', 'P'),
(62557, 'Arcadia', 36.0708312988281, 0.629554770095973, -80.2461090087891, -1.40055881411765, 218, 33, 'PPL', 'P'),
(75009, 'Arcadia', 35.6666717529297, 0.622500855316681, -97.3263931274414, -1.69866600916423, 218, 42, 'PPL', 'P'),
(79553, 'Arcadia', 34.9580612182617, 0.610133268372407, -81.9908294677734, -1.43100993065384, 218, 48, 'PPL', 'P'),
(84697, 'Arcadia', 36.5852813720703, 0.638533617711176, -82.4580612182617, -1.43916466306971, 218, 50, 'PPL', 'P'),
(92306, 'Arcadia', 31.7630596160889, 0.554369970807997, -94.3402786254883, -1.6465484792636, 218, 51, 'PPL', 'P'),
(99460, 'Arcadia', 38.1063919067383, 0.665082004827903, -77.5299987792969, -1.35315374776592, 218, 53, 'PPL', 'P'),
(114425, 'Arcadia', 42.0872192382813, 0.734560548716708, -95.0458297729492, -1.65886266982802, 218, 16, 'PPL', 'P'),
(122154, 'Arcadia', 40.1758308410645, 0.701200527900857, -86.0216674804688, -1.50136132558991, 218, 19, 'PPL', 'P'),
(129550, 'Arcadia', 44.4930610656738, 0.776550409886905, -86.2316665649414, -1.50502650104014, 218, 27, 'PPL', 'P'),
(141188, 'Arcadia', 41.4233283996582, 0.722973467708909, -99.1258316040039, -1.73007213526732, 218, 35, 'PPL', 'P'),
(154089, 'Arcadia', 41.1083297729492, 0.717475704533577, -83.5169372558594, -1.45764553629626, 218, 41, 'PPL', 'P'),
(158739, 'Arcadia', 40.7811088562012, 0.711764622154929, -78.852783203125, -1.37624069125581, 218, 45, 'PPL', 'P'),
(169257, 'Arcadia', 41.5555610656738, 0.725281363109572, -71.6972198486328, -1.25135255088487, 218, 47, 'PPL', 'P'),
(172944, 'Arcadia', 44.2527809143066, 0.772356730118357, -91.5013885498047, -1.59700050034073, 218, 57, 'PPL', 'P'),
(179786, 'Arcadia', 34.139720916748, 0.59585053570923, -118.034439086914, -2.06008959281134, 218, 6, 'PPL', 'P'),
(200336, 'Arcadia', 43.9244384765625, 0.766626073505698, -116.984443664551, -2.04176371556023, 218, 43, 'PPL', 'P'),
(202904, 'Arcadia', 40.2224998474121, 0.702015055720258, -110.236671447754, -1.92399287320253, 218, 52, 'PPL', 'P'),
(206702, 'Arcadia', 47.1980590820313, 0.823761531532258, -122.938331604004, -2.14567866339847, 218, 56, 'PPL', 'P'),
(58477, 'Arcadia (historical)', 32.648609161377, 0.569825726062813, -91.1255569458008, -1.59044100141781, 218, 30, 'PPL', 'P'),
(99461, 'Arcadia Farm', 39.1313896179199, 0.682971589713429, -77.9141693115234, -1.35985878844241, 218, 53, 'PPL', 'P'),
(79554, 'Arcadia Heights', 34.9561080932617, 0.610099179910454, -82, -1.43116998663535, 218, 48, 'PPL', 'P'),
(79555, 'Arcadia Lakes', 34.0536117553711, 0.594347647327071, -80.9613876342773, -1.41304278120156, 218, 48, 'PPL', 'P'),
(99462, 'Arcadia Mobile Home Park', 39.1972198486328, 0.684120543986716, -78.1372222900391, -1.36375179732389, 218, 53, 'PPL', 'P'),
(92307, 'Arcadia Park', 32.749439239502, 0.571585542911137, -96.9102783203125, -1.69140343571353, 218, 51, 'PPL', 'P'),
(44428, 'Arcadia Shores', 38.7638893127441, 0.676557499386027, -76.1608276367188, -1.32925720330463, 218, 25, 'PPL', 'P'),
(84698, 'Arcadia Shores', 35.3638916015625, 0.617216344765636, -85.0583267211914, -1.48454785752186, 218, 50, 'PPL', 'P'),
(129553, 'Arcadian', 47.1558303833008, 0.823024501700578, -88.5558319091797, -1.54559083865784, 218, 27, 'PPL', 'P'),
(79556, 'Arcadian Shores', 33.773609161377, 0.589460680147749, -78.7755584716797, -1.37489286542812, 218, 48, 'PPL', 'P'),
(122155, 'Arcana', 40.5386085510254, 0.707532193392521, -85.5033264160156, -1.49231456736692, 218, 19, 'PPL', 'P'),
(71686, 'Arcanum', 39.9900016784668, 0.697957197167304, -84.5533294677734, -1.47573399273619, 218, 41, 'PPL', 'P'),
(193350, 'Arcata', 40.8666687011719, 0.713257923157164, -124.081672668457, -2.16563372944643, 218, 6, 'PPL', 'P'),
(39128, 'Arceneaux', 30.2902793884277, 0.528665106677038, -92.2280578613281, -1.60968327240002, 218, 22, 'PPL', 'P'),
(75010, 'Arch', 34.7744407653809, 0.606928486895633, -95.6608276367188, -1.66959640744353, 218, 42, 'PPL', 'P'),
(188071, 'Arch', 34.1133308410645, 0.595389941998701, -103.141937255859, -1.80016640200015, 218, 38, 'PPL', 'P'),
(44429, 'Arch Bridge', 39.4477806091309, 0.688493654233708, -77.501106262207, -1.35264947821351, 218, 25, 'PPL', 'P'),
(200337, 'Arch Cape', 45.8291702270508, 0.799869913918993, -123.960830688477, -2.16352463902115, 218, 43, 'PPL', 'P'),
(158740, 'Arch Rock', 40.6074981689453, 0.708734544045664, -77.4186096191406, -1.35120964017016, 218, 45, 'PPL', 'P'),
(158741, 'Arch Spring', 40.6058311462402, 0.708705449010755, -78.2030563354492, -1.3649008181762, 218, 45, 'PPL', 'P'),
(194529, 'Archabal', 44.8469390869141, 0.78272674650799, -116.121109008789, -2.02669568327062, 218, 17, 'PPL', 'P'),
(158742, 'Archbald', 41.4947204589844, 0.72421949420393, -75.5372161865234, -1.31837313024559, 218, 45, 'PPL', 'P'),
(15019, 'Archbold', 27.1811103820801, 0.474399870515311, -81.3522186279297, -1.41986406885964, 218, 12, 'PPL', 'P'),
(154087, 'Archbold', 41.5213890075684, 0.724684948183449, -84.3072204589844, -1.471438580214, 218, 41, 'PPL', 'P'),
(62560, 'Archdale', 35.9144401550293, 0.626825229715724, -79.9722213745117, -1.39577857311901, 218, 33, 'PPL', 'P'),
(79558, 'Archdale', 33.9497184753418, 0.592534367519864, -80.366943359375, -1.40266777138489, 218, 48, 'PPL', 'P'),
(146849, 'Archdale', 43.0330581665039, 0.751068552207727, -73.4813919067383, -1.2824922277209, 218, 40, 'PPL', 'P'),
(44430, 'Arched Bow Valley', 39.6233291625977, 0.691557554488817, -76.8308334350586, -1.34095101049312, 218, 25, 'PPL', 'P'),
(15020, 'Archer', 29.5297203063965, 0.515390846539647, -82.519172668457, -1.44023125908629, 218, 12, 'PPL', 'P'),
(26387, 'Archer', 39.7813911437988, 0.694316256483003, -89.7358322143555, -1.5661857291577, 218, 18, 'PPL', 'P'),
(84699, 'Archer', 35.3280601501465, 0.616590967962658, -86.7597198486328, -1.51424276946652, 218, 50, 'PPL', 'P'),
(108007, 'Archer', 39.5105590820313, 0.689589345285194, -80.5952835083008, -1.40665305879814, 218, 58, 'PPL', 'P'),
(112400, 'Archer', 33.2972183227539, 0.58114609148744, -88.2216720581055, -1.53975864902862, 218, 2, 'PPL', 'P'),
(114427, 'Archer', 43.1152801513672, 0.752503596561117, -95.7455596923828, -1.67107526079685, 218, 16, 'PPL', 'P'),
(141190, 'Archer', 41.1652793884277, 0.718469662831422, -98.1355590820313, -1.71278861926687, 218, 35, 'PPL', 'P'),
(179787, 'Archer', 34.4205589294434, 0.600752083695521, -115.364723205566, -2.01349426058904, 218, 6, 'PPL', 'P'),
(186353, 'Archer', 39.5333290100098, 0.689986755498861, -105.076393127441, -1.83392902619379, 218, 7, 'PPL', 'P'),
(194530, 'Archer', 43.7136116027832, 0.762946450406563, -111.781936645508, -1.95096283871982, 218, 17, 'PPL', 'P'),
(195886, 'Archer', 48.792781829834, 0.851594694137867, -104.810279846191, -1.8292844732527, 218, 31, 'PPL', 'P'),
(141191, 'Archer (historical)', 40.0875015258789, 0.699658890524838, -95.5666732788086, -1.66795310389289, 218, 35, 'PPL', 'P'),
(99463, 'Archer Bluff', 37.2605590820313, 0.650319437115321, -77.3824996948242, -1.35057940309819, 218, 53, 'PPL', 'P'),
(92309, 'Archer City', 33.5955581665039, 0.586353104050763, -98.6252822875977, -1.72133590162742, 218, 51, 'PPL', 'P'),
(177180, 'Archer Heights', 40.3608283996582, 0.704429344406469, -80.6002807617188, -1.40674027732384, 218, 58, 'PPL', 'P'),
(144758, 'Archers Corner', 40.0883293151855, 0.699673338173751, -74.4558334350586, -1.29949944075825, 218, 37, 'PPL', 'P'),
(126766, 'Archers Corners', 44.8313903808594, 0.782455370392911, -68.4449996948242, -1.1945906012012, 218, 26, 'PPL', 'P'),
(71687, 'Archers Fork', 39.4833297729492, 0.689114104188669, -81.2058334350586, -1.41730916526787, 218, 41, 'PPL', 'P'),
(62564, 'Archers Lodge', 35.6938896179199, 0.622975896676123, -78.3758316040039, -1.3679163154785, 218, 33, 'PPL', 'P'),
(144759, 'Archertown', 40.0652809143066, 0.699271067691095, -74.5002822875977, -1.30027521958379, 218, 37, 'PPL', 'P'),
(18898, 'Archery', 32.026668548584, 0.558970814617704, -84.4483337402344, -1.47390147159011, 218, 13, 'PPL', 'P'),
(7138, 'Archey (historical)', 35.6483306884766, 0.622180743353653, -92.5258331298828, -1.61488043126731, 218, 4, 'PPL', 'P'),
(7151, 'Archey Valley', 35.6963882446289, 0.623019505938973, -92.7252807617188, -1.61836144912815, 218, 4, 'PPL', 'P'),
(39129, 'Archibald', 32.3488883972168, 0.564594611891624, -91.7772216796875, -1.60181469664327, 218, 22, 'PPL', 'P'),
(26388, 'Archie', 39.8941688537598, 0.69628459884468, -87.8283309936523, -1.53289355237062, 218, 18, 'PPL', 'P'),
(39130, 'Archie', 31.579719543457, 0.551170082889726, -91.9672164916992, -1.60513073167458, 218, 22, 'PPL', 'P'),
(53223, 'Archie', 38.4816703796387, 0.671631849791871, -94.3541717529297, -1.64679096008085, 218, 29, 'PPL', 'P'),
(188072, 'Archuleta', 36.7941703796387, 0.642179418664467, -107.70832824707, -1.87986495973019, 218, 38, 'PPL', 'P'),
(84700, 'Archville', 35.1327781677246, 0.613182654399575, -84.5255584716797, -1.4752492974178, 218, 50, 'PPL', 'P'),
(146850, 'Archville', 41.1216697692871, 0.717708531391877, -73.8616714477539, -1.28912935778959, 218, 40, 'PPL', 'P'),
(179788, 'Arcilla', 33.7833290100098, 0.589630323509187, -117.478607177734, -2.05038849590851, 218, 6, 'PPL', 'P'),
(18899, 'Arco', 31.2011108398438, 0.544562114434967, -81.5063934326172, -1.42255492682505, 218, 13, 'PPL', 'P'),
(99486, 'Arco', 38.8600006103516, 0.678234957977641, -78.1750030517578, -1.36441119600979, 218, 53, 'PPL', 'P'),
(133977, 'Arco', 44.3836097717285, 0.774640124436991, -96.1833267211914, -1.67871573680623, 218, 28, 'PPL', 'P'),
(194531, 'Arco', 43.6366691589355, 0.76160355142689, -113.299438476563, -1.97744824207676, 218, 17, 'PPL', 'P'),
(92311, 'Arco Iris Colonia', 26.2520008087158, 0.458183849348305, -98.3610000610352, -1.71672330661941, 218, 51, 'PPL', 'P'),
(92312, 'Arco Iris Number 2 Colonia', 26.2409992218018, 0.45799183543371, -98.1439971923828, -1.71293589207515, 218, 51, 'PPL', 'P'),
(18900, 'Arcola', 32.3433303833008, 0.564497606248918, -81.6022186279297, -1.42422739198962, 218, 13, 'PPL', 'P'),
(26389, 'Arcola', 39.6847190856934, 0.692629010774383, -88.3063888549805, -1.54123723606583, 218, 18, 'PPL', 'P'),
(31664, 'Arcola', 38.7508316040039, 0.676329599375744, -97.9333267211914, -1.70925899871613, 218, 20, 'PPL', 'P'),
(39131, 'Arcola', 30.7763900756836, 0.537149338698786, -90.5102767944336, -1.57970233695429, 218, 22, 'PPL', 'P'),
(44431, 'Arcola', 39.047779083252, 0.68151231059412, -77.0519409179688, -1.3448100640707, 218, 25, 'PPL', 'P'),
(53217, 'Arcola', 37.5491714477539, 0.655356673159152, -93.875, -1.63842783530968, 218, 29, 'PPL', 'P'),
(58478, 'Arcola', 33.269718170166, 0.58066612327998, -90.8797225952148, -1.58615038258558, 218, 30, 'PPL', 'P'),
(62565, 'Arcola', 36.2894401550293, 0.633370214410703, -77.9802780151367, -1.36101260298468, 218, 33, 'PPL', 'P'),
(92313, 'Arcola', 29.4958305358887, 0.514799358461541, -95.4655609130859, -1.66618836019655, 218, 51, 'PPL', 'P'),
(99464, 'Arcola', 38.9516716003418, 0.679834918581533, -77.5344390869141, -1.35323124575364, 218, 53, 'PPL', 'P'),
(108008, 'Arcola', 38.4666709899902, 0.671370061056716, -80.5194396972656, -1.40532933457831, 218, 58, 'PPL', 'P'),
(112810, 'Arcola', 32.5569381713867, 0.56822576545892, -87.7675018310547, -1.53183188320206, 218, 2, 'PPL', 'P'),
(122156, 'Arcola', 41.1036109924316, 0.717393346276866, -85.2941665649414, -1.48866403930269, 218, 19, 'PPL', 'P'),
(133979, 'Arcola', 45.1233291625977, 0.787550663348505, -92.7663879394531, -1.61907890472582, 218, 28, 'PPL', 'P'),
(144760, 'Arcola', 40.9258308410645, 0.714290497290815, -74.0897216796875, -1.29310958519677, 218, 37, 'PPL', 'P'),
(158749, 'Arcola', 40.1525001525879, 0.700793330570184, -75.4569396972656, -1.3169720411961, 218, 45, 'PPL', 'P'),
(209275, 'Arcola', 41.100830078125, 0.717344810165999, -104.456672668457, -1.82311286374255, 218, 59, 'PPL', 'P'),
(92314, 'Arcola Junction', 29.5027809143066, 0.514920665449194, -95.4622192382813, -1.66613003696868, 218, 51, 'PPL', 'P'),
(193034, 'Arcosanti', 34.3430595397949, 0.59939946417787, -112.099998474121, -1.95651406485403, 218, 5, 'PPL', 'P'),
(84701, 'Arcott', 36.5200004577637, 0.637394250817812, -85.5550003051758, -1.49321644687007, 218, 50, 'PPL', 'P'),
(146851, 'Arctic', 42.1855583190918, 0.736276889460237, -75.4147186279297, -1.31623514452247, 218, 40, 'PPL', 'P'),
(169258, 'Arctic', 41.7030601501465, 0.727855707777297, -71.5288925170898, -1.24841468472835, 218, 47, 'PPL', 'P'),
(29108, 'Arctic Springs', 38.2830581665039, 0.668165412737997, -85.7113876342773, -1.49594592067129, 218, 19, 'PPL', 'P'),
(212285, 'Arctic Village', 68.1269378662109, 1.18903937506698, -145.537780761719, -2.54011346033765, 218, 1, 'PPL', 'P'),
(99465, 'Arcturus', 38.7386093139648, 0.676116280172428, -77.0449981689453, -1.3446888902411, 218, 53, 'PPL', 'P'),
(112808, 'Arcus', 31.5136108398438, 0.550016268347449, -85.9752807617188, -1.50055172461853, 218, 2, 'PPL', 'P'),
(7141, 'Ard', 35.144718170166, 0.613391046754874, -93.1916732788086, -1.62650153415803, 218, 4, 'PPL', 'P'),
(79566, 'Ard Crossroads', 33.7836112976074, 0.589635250357203, -79.4366683959961, -1.38643141032505, 218, 48, 'PPL', 'P'),
(29109, 'Arda', 38.517219543457, 0.672252299746832, -87.2505569458008, -1.52280949290303, 218, 19, 'PPL', 'P'),
(158745, 'Ardara', 40.357780456543, 0.704376147763695, -79.7352828979492, -1.39164321657834, 218, 45, 'PPL', 'P'),
(53218, 'Ardath', 37.6100006103516, 0.656418342327712, -94.6050033569336, -1.65116879743878, 218, 29, 'PPL', 'P'),
(84702, 'Ardee (historical)', 36.5430603027344, 0.637796721037551, -87.6263885498047, -1.52936899182595, 218, 50, 'PPL', 'P'),
(108009, 'Ardel', 38.2705612182617, 0.667947299844719, -82.4555587768555, -1.43912098722784, 218, 58, 'PPL', 'P'),
(31665, 'Ardell', 37.901668548584, 0.661508908172371, -99.4961090087891, -1.73653469512656, 218, 20, 'PPL', 'P'),
(112809, 'Ardell', 33.9952812194824, 0.593329587421361, -87.0986099243164, -1.52015751708953, 218, 2, 'PPL', 'P'),
(7142, 'Arden', 33.6894416809082, 0.587991680490461, -94.2855606079102, -1.6455934696967, 218, 4, 'PPL', 'P'),
(13293, 'Arden', 39.8091697692871, 0.694801084959451, -75.4869384765625, -1.31749561866641, 218, 10, 'PPL', 'P'),
(53219, 'Arden', 36.985279083252, 0.645514894771737, -92.804443359375, -1.61974309710168, 218, 29, 'PPL', 'P'),
(62566, 'Arden', 35.4661102294922, 0.61900039637988, -82.5166702270508, -1.44018758324441, 218, 33, 'PPL', 'P'),
(84703, 'Arden', 35.4216690063477, 0.618224750712395, -84.4094390869141, -1.47322263182825, 218, 50, 'PPL', 'P'),
(108011, 'Arden', 39.4155616760254, 0.687931327769538, -78.0436096191406, -1.36211794799512, 218, 58, 'PPL', 'P'),
(129554, 'Arden', 41.9858283996582, 0.732790944751377, -86.3919372558594, -1.5078237522911, 218, 27, 'PPL', 'P'),
(146852, 'Arden', 41.2744407653809, 0.720374888275264, -74.1533279418945, -1.29421972389717, 218, 40, 'PPL', 'P'),
(158746, 'Arden', 40.2050018310547, 0.701709657722253, -80.2591705322266, -1.40078678070696, 218, 45, 'PPL', 'P'),
(189881, 'Arden', 36.0180587768555, 0.62863371583297, -115.230003356934, -2.01114295566261, 218, 39, 'PPL', 'P'),
(191083, 'Arden', 31.4436092376709, 0.548794509907861, -100.766670227051, -1.75871017173338, 218, 51, 'PPL', 'P'),
(206703, 'Arden', 48.4602813720703, 0.845791466385502, -117.875282287598, -2.05731178263633, 218, 56, 'PPL', 'P'),
(133981, 'Arden Hills', 45.0502815246582, 0.786275741555657, -93.1563873291016, -1.62588567815595, 218, 28, 'PPL', 'P'),
(18901, 'Arden Lake', 34.059440612793, 0.594449380080712, -84.5741729736328, -1.4760977805411, 218, 13, 'PPL', 'P'),
(158747, 'Arden Mines', 40.2186088562012, 0.701947145112461, -80.2647171020508, -1.40088358661259, 218, 45, 'PPL', 'P'),
(44433, 'Arden on the Severn', 39.0658302307129, 0.681827362551076, -76.5791702270508, -1.33655865890725, 218, 25, 'PPL', 'P'),
(179789, 'Arden Town', 38.5741691589355, 0.673246258044677, -121.381942749023, -2.11851455343772, 218, 6, 'PPL', 'P'),
(44432, 'Arden Valley', 39.5736083984375, 0.690689763447614, -76.6888885498047, -1.33847360488907, 218, 25, 'PPL', 'P'),
(144761, 'Ardena', 40.2113914489746, 0.7018211775929, -74.2330627441406, -1.29561135872479, 218, 37, 'PPL', 'P'),
(13294, 'Ardencroft', 39.8041687011719, 0.694713799854724, -75.4916687011719, -1.3175781766602, 218, 10, 'PPL', 'P'),
(158748, 'Ardenheim', 40.464168548584, 0.706232970254726, -77.9833297729492, -1.36106586620649, 218, 45, 'PPL', 'P'),
(13295, 'Ardentown', 39.8083305358887, 0.694786437573456, -75.4833297729492, -1.31743263490663, 218, 10, 'PPL', 'P'),
(206704, 'Ardenvoir', 47.7374992370605, 0.833176538354988, -120.367782592773, -2.10081411956861, 218, 56, 'PPL', 'P'),
(200338, 'Ardenwald', 45.4555587768555, 0.793349163989934, -122.628608703613, -2.14027297901783, 218, 43, 'PPL', 'P'),
(53220, 'Ardeola', 37.0011100769043, 0.645791197734832, -89.852783203125, -1.56822690897519, 218, 29, 'PPL', 'P'),
(18902, 'Ardick', 31.461109161377, 0.54909994119538, -81.4336090087891, -1.42128459898509, 218, 13, 'PPL', 'P'),
(112812, 'Ardilla', 31.1413898468018, 0.543519786473823, -85.1513900756836, -1.4861721194707, 218, 2, 'PPL', 'P'),
(92315, 'Ardis Heights', 33.1391716003418, 0.578387655809363, -96.0727767944336, -1.67678627659647, 218, 51, 'PPL', 'P'),
(53221, 'Arditta', 36.6163902282715, 0.639076569678416, -92.0625, -1.60679374261728, 218, 29, 'PPL', 'P'),
(18903, 'Ardmore', 32.4949989318848, 0.56714472179343, -81.4288864135742, -1.42120217414935, 218, 13, 'PPL', 'P'),
(44434, 'Ardmore', 38.9333305358887, 0.679514806618506, -76.8522186279297, -1.34132425251989, 218, 25, 'PPL', 'P'),
(53222, 'Ardmore', 39.6430587768555, 0.691901901217764, -92.5355606079102, -1.6150502077868, 218, 29, 'PPL', 'P'),
(62568, 'Ardmore', 36.0847206115723, 0.629797184334198, -80.274169921875, -1.40104856944212, 218, 33, 'PPL', 'P'),
(75011, 'Ardmore', 34.1741714477539, 0.596451810904343, -97.1433334350586, -1.69547101480447, 218, 42, 'PPL', 'P'),
(84704, 'Ardmore', 34.9919395446777, 0.610724556713432, -86.8466720581055, -1.5157603718137, 218, 50, 'PPL', 'P'),
(99467, 'Ardmore', 37.3480606079102, 0.651846626842427, -79.9330596923828, -1.39509507282525, 218, 53, 'PPL', 'P'),
(112813, 'Ardmore', 34.9919395446777, 0.610724556713432, -86.8469390869141, -1.51576503234561, 218, 2, 'PPL', 'P'),
(122157, 'Ardmore', 41.6891708374023, 0.727613293539072, -86.317497253418, -1.50652452915331, 218, 19, 'PPL', 'P'),
(158753, 'Ardmore', 40.0066719055176, 0.698248147516396, -75.2858276367188, -1.31398557234968, 218, 45, 'PPL', 'P'),
(201865, 'Ardmore', 43.0194396972656, 0.750830865080438, -103.655830383301, -1.80913552907737, 218, 49, 'PPL', 'P'),
(144762, 'Ardmore Estates', 40.2061080932617, 0.701728965640156, -74.2249984741211, -1.29547061066118, 218, 37, 'PPL', 'P'),
(77794, 'Ardmore Park', 39.9938888549805, 0.698025041196074, -75.2977828979492, -1.31419423102109, 218, 45, 'PPL', 'P'),
(139602, 'Ardoch', 48.207218170166, 0.841374680296633, -97.3419418334961, -1.69893738527931, 218, 34, 'PPL', 'P'),
(114428, 'Ardon', 41.3950004577637, 0.722479051852536, -91.1883316040039, -1.59153662589027, 218, 16, 'PPL', 'P'),
(146853, 'Ardonia', 41.6758308410645, 0.727380466680772, -74.0730590820313, -1.29281876800573, 218, 40, 'PPL', 'P'),
(39133, 'Ardoyne', 29.646390914917, 0.517427132798636, -90.8216705322266, -1.58513718294886, 218, 22, 'PPL', 'P'),
(195887, 'Ardrum (historical)', 46.9949989318848, 0.820217463332608, -114.124443054199, -1.99184728830055, 218, 31, 'PPL', 'P'),
(15021, 'Ards Crossroads', 30.9591693878174, 0.540339439500051, -85.6933288574219, -1.49563073555628, 218, 12, 'PPL', 'P'),
(146854, 'Ardsley', 41.0105590820313, 0.715769284065109, -73.8441696166992, -1.28882389321256, 218, 40, 'PPL', 'P'),
(158750, 'Ardsley', 40.1211090087891, 0.700245451754928, -75.1555633544922, -1.31171203172708, 218, 45, 'PPL', 'P'),
(146855, 'Ardsley-on-Hudson', 41.0250015258789, 0.716021352262285, -73.8708267211914, -1.289289147455, 218, 40, 'PPL', 'P'),
(62569, 'Ardulusa', 34.9627799987793, 0.610215626629118, -78.9172210693359, -1.37736534418415, 218, 33, 'PPL', 'P'),
(44435, 'Ardwick', 38.9455604553223, 0.679728258979876, -76.8811111450195, -1.3418285220723, 218, 25, 'PPL', 'P'),
(44436, 'Ardwick Park', 38.9419403076172, 0.679665075483013, -76.871940612793, -1.34166846609078, 218, 25, 'PPL', 'P'),
(99468, 'Ardwood', 38.1122207641602, 0.665183737581544, -78.4888916015625, -1.36988958468819, 218, 53, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(141192, 'Area Mobile Park', 40.7386093139648, 0.711022865212315, -99.5372161865234, -1.73725215072423, 218, 35, 'PPL', 'P'),
(99469, 'Areanum', 37.4474983215332, 0.653582142345805, -78.5100021362305, -1.370258033025, 218, 53, 'PPL', 'P'),
(114429, 'Aredale', 42.8330612182617, 0.747577946966961, -93.0052795410156, -1.62324834972844, 218, 16, 'PPL', 'P'),
(146856, 'Arena', 42.1155586242676, 0.735055164310163, -74.7377777099609, -1.30442029666245, 218, 40, 'PPL', 'P'),
(172947, 'Arena', 43.1655616760254, 0.753381174719325, -89.9127807617188, -1.56927406391581, 218, 57, 'PPL', 'P'),
(179790, 'Arena', 37.3708305358887, 0.652244037056094, -120.675277709961, -2.10618092179734, 218, 6, 'PPL', 'P'),
(188073, 'Arena', 31.8019409179688, 0.555048577543263, -107.415000915527, -1.87474543200868, 218, 38, 'PPL', 'P'),
(197947, 'Arena', 47.1272201538086, 0.822525158996189, -100.16194152832, -1.74815566485923, 218, 34, 'PPL', 'P'),
(154095, 'Arena (historical)', 41.1352806091309, 0.717946085361112, -84.6313934326172, -1.47709646594988, 218, 41, 'PPL', 'P'),
(129555, 'Arenac', 44.0055618286133, 0.768041943099238, -83.8580627441406, -1.46359929922925, 218, 27, 'PPL', 'P'),
(188075, 'Arenal', 35.0533294677734, 0.611796012998998, -106.70361328125, -1.86232937553256, 218, 38, 'PPL', 'P'),
(188074, 'Arenas Valley', 32.7938919067383, 0.572361388315704, -108.183609008789, -1.88816017389357, 218, 38, 'PPL', 'P'),
(133985, 'Arendahl', 43.8252792358398, 0.76489541827131, -91.9094390869141, -1.60412232572782, 218, 28, 'PPL', 'P'),
(77795, 'Arendtsville', 39.9230613708496, 0.696788868397087, -77.2988891601563, -1.34912012397888, 218, 45, 'PPL', 'P'),
(77797, 'Arensburg', 39.9527816772461, 0.697307585598407, -79.9499969482422, -1.39539068370624, 218, 45, 'PPL', 'P'),
(26391, 'Arenzville', 39.8769416809082, 0.69598392795761, -90.3733291625977, -1.57731214987594, 218, 18, 'PPL', 'P'),
(126767, 'Arey', 44.7227783203125, 0.780559732328992, -68.8722229003906, -1.20204705277926, 218, 26, 'PPL', 'P'),
(114430, 'Argand', 42.2816696166992, 0.73795434805185, -91.3452835083008, -1.59427595338753, 218, 16, 'PPL', 'P'),
(39134, 'Argent', 31.7383308410645, 0.553938372263836, -91.4061126708984, -1.59533762255609, 218, 22, 'PPL', 'P'),
(26393, 'Argenta', 39.9819412231445, 0.697816515682721, -88.8227767944336, -1.55024990582688, 218, 18, 'PPL', 'P'),
(92316, 'Argenta', 28.1697196960449, 0.49165435805988, -97.8469390869141, -1.70775125006498, 218, 51, 'PPL', 'P'),
(195888, 'Argenta', 45.2797203063965, 0.790280203728754, -112.861106872559, -1.96979791237135, 218, 31, 'PPL', 'P'),
(199812, 'Argenta', 40.6744384765625, 0.709902872815882, -116.704719543457, -2.0368816086499, 218, 39, 'PPL', 'P'),
(31666, 'Argentine', 39.0750007629395, 0.68198741853259, -94.6722183227539, -1.65234191989896, 218, 20, 'PPL', 'P'),
(129558, 'Argentine', 42.791389465332, 0.74685063767326, -83.8463897705078, -1.46339556740585, 218, 27, 'PPL', 'P'),
(158751, 'Argentine', 41.0941696166992, 0.717228563184418, -79.8194427490234, -1.39311208307757, 218, 45, 'PPL', 'P'),
(179791, 'Argentine (historical)', 39.9247207641602, 0.696817830273941, -120.771392822266, -2.10785844696798, 218, 6, 'PPL', 'P'),
(189883, 'Argentum (historical)', 38.1183280944824, 0.665290330604174, -117.992218017578, -2.05935269613771, 218, 39, 'PPL', 'P'),
(53234, 'Argentville', 39.0161094665527, 0.680959571509874, -90.7980575561523, -1.58472505877017, 218, 29, 'PPL', 'P'),
(34582, 'Argillite', 38.4897193908691, 0.671772331539373, -82.8283309936523, -1.4456270897709, 218, 21, 'PPL', 'P'),
(34577, 'Argo', 37.4805603027344, 0.654159182774998, -82.0633316040039, -1.43227533164579, 218, 21, 'PPL', 'P'),
(39135, 'Argo', 31.3305606842041, 0.546821440435249, -91.8858337402344, -1.60371033470719, 218, 22, 'PPL', 'P'),
(53224, 'Argo', 38.1838912963867, 0.666434624345554, -91.3302764892578, -1.59401403149432, 218, 29, 'PPL', 'P'),
(92317, 'Argo', 33.2550010681152, 0.580409261392842, -94.8947219848633, -1.65622534140051, 218, 51, 'PPL', 'P'),
(112815, 'Argo', 33.8013916015625, 0.589945575203225, -87.116943359375, -1.5204774958945, 218, 2, 'PPL', 'P'),
(114431, 'Argo', 41.6258316040039, 0.726507815370581, -90.432502746582, -1.57834492374667, 218, 16, 'PPL', 'P'),
(177723, 'Argo', 39.5974998474121, 0.691106747895294, -119.162780761719, -2.07978287012415, 218, 39, 'PPL', 'P'),
(18904, 'Argo (historical)', 34.6911087036133, 0.605474068045313, -84.1413879394531, -1.4685442567413, 218, 13, 'PPL', 'P'),
(141193, 'Argo (historical)', 41.7236099243164, 0.728214368997103, -96.4438934326172, -1.68326348384171, 218, 35, 'PPL', 'P'),
(13296, 'Argo Corners', 38.8713912963867, 0.678433762953015, -75.345832824707, -1.31503286044836, 218, 10, 'PPL', 'P'),
(118642, 'Argo Fay', 42.0041694641113, 0.733111056714405, -90.017219543457, -1.57109686452391, 218, 18, 'PPL', 'P'),
(186355, 'Argo Mill', 39.7427787780762, 0.693642343569158, -105.50611114502, -1.84142902045568, 218, 7, 'PPL', 'P'),
(53225, 'Argola', 39.997501373291, 0.698088091534882, -91.7869415283203, -1.60198434000471, 218, 29, 'PPL', 'P'),
(31667, 'Argonia', 37.2658309936523, 0.650411449330983, -97.7652816772461, -1.70632605940763, 218, 20, 'PPL', 'P'),
(133987, 'Argonne', 44.6958312988281, 0.780089418080484, -93.2855606079102, -1.62814017717676, 218, 28, 'PPL', 'P'),
(169744, 'Argonne', 44.0733299255371, 0.76922471951837, -97.6383285522461, -1.70411030938068, 218, 49, 'PPL', 'P'),
(172950, 'Argonne', 45.6597213745117, 0.79691247352846, -88.8791732788086, -1.55123421016577, 218, 57, 'PPL', 'P'),
(44437, 'Argonne Hills', 39.1144409179688, 0.682675779095348, -76.7655563354492, -1.33981171017878, 218, 25, 'PPL', 'P'),
(122158, 'Argos', 41.6972198486328, 0.727753775286574, -86.245002746582, -1.50525926131941, 218, 19, 'PPL', 'P'),
(179792, 'Argos', 34.725830078125, 0.606080070351361, -116.25, -2.02894525544341, 218, 6, 'PPL', 'P'),
(13297, 'Argos Choice', 38.9500007629395, 0.679805756967597, -75.5100021362305, -1.31789815546517, 218, 10, 'PPL', 'P'),
(7144, 'Argosy (historical)', 36.3833312988281, 0.635008924008456, -92.0736083984375, -1.60698762074464, 218, 4, 'PPL', 'P'),
(179794, 'Arguello', 34.5783309936523, 0.603505725683636, -120.641937255859, -2.10559902109916, 218, 6, 'PPL', 'P'),
(92318, 'Arguello Colonia', 26.2140007019043, 0.457520622368335, -98.1490020751953, -1.71302324375891, 218, 51, 'PPL', 'P'),
(92319, 'Arguello Number 2 Colonia', 26.2140007019043, 0.457520622368335, -98.1490020751953, -1.71302324375891, 218, 51, 'PPL', 'P'),
(62570, 'Argura', 35.2675018310547, 0.615534025905033, -83.0411071777344, -1.44934073475296, 218, 33, 'PPL', 'P'),
(158752, 'Argus', 40.3663902282715, 0.704526416628203, -75.3833312988281, -1.31568733228624, 218, 45, 'PPL', 'P'),
(179793, 'Argus', 35.7472190856934, 0.623906671477106, -117.394439697266, -2.04891949625122, 218, 6, 'PPL', 'P'),
(139605, 'Argusville', 47.0522193908691, 0.821216148741387, -96.9341735839844, -1.69182048674024, 218, 34, 'PPL', 'P'),
(146878, 'Argusville', 42.7905616760254, 0.746836190024346, -74.5194396972656, -1.30060957945865, 218, 40, 'PPL', 'P'),
(112816, 'Arguta', 31.5691699981689, 0.55098595858986, -85.5952835083008, -1.49391952139785, 218, 2, 'PPL', 'P'),
(15022, 'Argyle', 30.7194404602051, 0.536155380400941, -86.0444412231445, -1.50175880238261, 218, 12, 'PPL', 'P'),
(18905, 'Argyle', 31.0738906860352, 0.542341703876113, -82.6486129760742, -1.442490418639, 218, 13, 'PPL', 'P'),
(34578, 'Argyle', 37.225830078125, 0.649713301651219, -84.807502746582, -1.48017015332199, 218, 21, 'PPL', 'P'),
(39137, 'Argyle', 29.5719394683838, 0.516127709923759, -90.746940612793, -1.583832899805, 218, 22, 'PPL', 'P'),
(53226, 'Argyle', 38.2944412231445, 0.668364084555317, -92.0236129760742, -1.60611503601347, 218, 29, 'PPL', 'P'),
(79560, 'Argyle', 34.4888916015625, 0.601944713810686, -79.682502746582, -1.39072202915728, 218, 48, 'PPL', 'P'),
(92320, 'Argyle', 33.1211090087891, 0.578072404115325, -97.1830596923828, -1.69616436879427, 218, 51, 'PPL', 'P'),
(108017, 'Argyle', 37.8255615234375, 0.660180589999667, -81.8769378662109, -1.4290221472162, 218, 58, 'PPL', 'P'),
(114448, 'Argyle', 40.5316696166992, 0.707411086141949, -91.5661087036133, -1.59813008011709, 218, 16, 'PPL', 'P'),
(118643, 'Argyle', 42.3600006103516, 0.739321481797442, -88.9400024414063, -1.55229587933433, 218, 18, 'PPL', 'P'),
(126768, 'Argyle', 45.0541687011719, 0.786343585584426, -68.6727828979492, -1.19856616807647, 218, 26, 'PPL', 'P'),
(129559, 'Argyle', 43.5641708374023, 0.760338217013966, -82.9361114501953, -1.44750821360688, 218, 27, 'PPL', 'P'),
(133988, 'Argyle', 48.3327789306641, 0.843566128978632, -96.820556640625, -1.68983749699257, 218, 28, 'PPL', 'P'),
(146857, 'Argyle', 43.2377815246582, 0.754641648863259, -73.491943359375, -1.28267638531028, 218, 40, 'PPL', 'P'),
(172962, 'Argyle', 42.7011108398438, 0.745274978414314, -89.866943359375, -1.56847405032435, 218, 57, 'PPL', 'P'),
(201867, 'Argyle', 43.5349998474121, 0.75982908719257, -103.647499084473, -1.80899012048186, 218, 49, 'PPL', 'P'),
(206705, 'Argyle', 48.514720916748, 0.846741615683415, -123.018333435059, -2.147074958758, 218, 56, 'PPL', 'P'),
(15023, 'Argyle Forest', 30.1936092376709, 0.526977894257932, -81.754997253418, -1.42689388203106, 218, 12, 'PPL', 'P'),
(99470, 'Argyle Heights', 38.2869415283203, 0.668233190187739, -77.432502746582, -1.35145212098741, 218, 53, 'PPL', 'P'),
(39138, 'Argyle Plantation', 30.6594390869141, 0.535108158881294, -91.6413879394531, -1.59944395064088, 218, 22, 'PPL', 'P'),
(122159, 'Ari', 41.2636108398438, 0.720185870416896, -85.2494430541992, -1.48788346678719, 218, 19, 'PPL', 'P'),
(79561, 'Arial', 34.8458290100098, 0.608174446811627, -82.6416702270508, -1.44236924480941, 218, 48, 'PPL', 'P'),
(186356, 'Arickaree', 39.6991691589355, 0.692881212129613, -103.065559387207, -1.79883335671651, 218, 7, 'PPL', 'P'),
(15024, 'Ariel', 28.9002799987793, 0.504405040726962, -80.8638916015625, -1.41134115442306, 218, 12, 'PPL', 'P'),
(58479, 'Ariel', 31.1005592346191, 0.542807157855632, -90.9872207641602, -1.58802657957355, 218, 30, 'PPL', 'P'),
(206706, 'Ariel', 45.9569396972656, 0.802099911857771, -122.569717407227, -2.13924513199511, 218, 56, 'PPL', 'P'),
(79562, 'Ariel Cross Road', 34.0761108398438, 0.594740330429804, -79.3030624389648, -1.38409954647458, 218, 48, 'PPL', 'P'),
(92321, 'Ariel Hinojosa Colonia', 26.238000869751, 0.45793950431829, -98.3639984130859, -1.71677563773483, 218, 51, 'PPL', 'P'),
(92322, 'Ariel Hinojosa Colonia Number 3', 26.2789993286133, 0.458655062413681, -98.3649978637695, -1.71679308143997, 218, 51, 'PPL', 'P'),
(146859, 'Arietta', 43.2461090087891, 0.754786990879751, -74.5180587768555, -1.30058547785079, 218, 40, 'PPL', 'P'),
(194532, 'Arimo', 42.560001373291, 0.742812153617237, -112.170562744141, -1.95774564370014, 218, 17, 'PPL', 'P'),
(71689, 'Arion', 38.8461112976074, 0.677992543739416, -83.103889465332, -1.45043649238347, 218, 41, 'PPL', 'P'),
(114432, 'Arion', 41.9491691589355, 0.732151120299486, -95.4633331298828, -1.66614947804464, 218, 16, 'PPL', 'P'),
(77798, 'Ariosa', 39.9772186279297, 0.697734090846983, -77.1750030517578, -1.34695790348985, 218, 45, 'PPL', 'P'),
(15025, 'Aripeka', 28.4319400787354, 0.496230967103668, -82.664436340332, -1.44276658844405, 218, 12, 'PPL', 'P'),
(193033, 'Aripine', 34.4083290100098, 0.600538631334151, -110.430282592773, -1.92737202515168, 218, 5, 'PPL', 'P'),
(114433, 'Arispe', 40.9494400024414, 0.714702554890477, -94.2188873291016, -1.64442980145839, 218, 16, 'PPL', 'P'),
(191084, 'Arispe', 31.1511096954346, 0.543689429835261, -105.274436950684, -1.83738554297261, 218, 51, 'PPL', 'P'),
(34579, 'Arista', 37.3686103820801, 0.652205288062234, -85.3047180175781, -1.48884819689207, 218, 21, 'PPL', 'P'),
(108012, 'Arista', 37.4724998474121, 0.654018501290414, -81.2608337402344, -1.41826910168279, 218, 58, 'PPL', 'P'),
(158754, 'Aristes', 40.8183288574219, 0.712414233723827, -76.3386077880859, -1.33236005229069, 218, 45, 'PPL', 'P'),
(194090, 'Aristocrat Ranchettes', 40.1091690063477, 0.700037059399629, -104.761940002441, -1.82844078381936, 218, 7, 'PPL', 'P'),
(193030, 'Aristocrat Trailer Park', 33.4947204589844, 0.584593154044384, -112.0625, -1.95585959301615, 218, 5, 'PPL', 'P'),
(146861, 'Aristotle', 42.3497200012207, 0.739142051318998, -78.0141677856445, -1.36160409106279, 218, 40, 'PPL', 'P'),
(112194, 'Ariton', 31.6000003814697, 0.551524050288111, -85.7188873291016, -1.49607681503887, 218, 2, 'PPL', 'P'),
(193035, 'Arivaca', 31.5747203826904, 0.551082831074512, -111.331672668457, -1.94310424981716, 218, 5, 'PPL', 'P'),
(193036, 'Arivaca Junction', 31.7272205352783, 0.553744460846964, -111.060562133789, -1.93837247835036, 218, 5, 'PPL', 'P'),
(193038, 'Arizola', 32.8511085510254, 0.573360007145457, -111.713607788086, -1.94977027518368, 218, 5, 'PPL', 'P'),
(39139, 'Arizona', 32.788890838623, 0.572274103210977, -92.9574966430664, -1.62241438083308, 218, 22, 'PPL', 'P'),
(92323, 'Arizona', 30.7894401550293, 0.537377105551015, -95.4677810668945, -1.66622710919041, 218, 51, 'PPL', 'P'),
(141194, 'Arizona', 41.8144416809082, 0.729799682215, -96.1333312988281, -1.67784315207507, 218, 35, 'PPL', 'P'),
(193042, 'Arizona', 34.5002784729004, 0.602143452207033, -111.500282287598, -1.94604704282169, 218, 5, 'ADM1', 'A'),
(193037, 'Arizona Acres Mobile Home Resort', 33.4127807617188, 0.583163036539011, -111.626388549805, -1.94824801230459, 218, 5, 'PPL', 'P'),
(193039, 'Arizona City', 32.7558288574219, 0.571697062781784, -111.670280456543, -1.94901407059215, 218, 5, 'PPL', 'P'),
(193040, 'Arizona Sun Sites', 31.9166698455811, 0.55705097507738, -109.95832824707, -1.91913486790006, 218, 5, 'PPL', 'P'),
(193041, 'Arizona Village', 34.8530616760254, 0.608300680647296, -114.583610534668, -1.99986127265282, 218, 5, 'PPL', 'P'),
(34580, 'Arjay', 36.8047218322754, 0.642363576253846, -83.6458282470703, -1.45989510846905, 218, 21, 'PPL', 'P'),
(53227, 'Ark', 37.6811103820801, 0.657659441974716, -91.3358306884766, -1.594110970558, 218, 29, 'PPL', 'P'),
(99471, 'Ark', 37.4383316040039, 0.653422152943318, -76.5761108398438, -1.33650526252739, 218, 53, 'PPL', 'P'),
(58480, 'Arkabutla', 34.6988906860352, 0.605609889260908, -90.1222229003906, -1.57292951882805, 218, 30, 'PPL', 'P'),
(7145, 'Arkadelphia', 34.1208305358887, 0.595520836366279, -93.0536117553711, -1.62409190600373, 218, 4, 'PPL', 'P'),
(112817, 'Arkadelphia', 33.9049987792969, 0.591753861583389, -86.9625015258789, -1.51778197739718, 218, 2, 'PPL', 'P'),
(187582, 'Arkalon', 37.1430587768555, 0.648268669917906, -100.806938171387, -1.75941297994505, 218, 20, 'PPL', 'P'),
(7146, 'Arkana', 36.2383308410645, 0.632478188603581, -92.3163909912109, -1.61122497635506, 218, 4, 'PPL', 'P'),
(39140, 'Arkana', 33.0183296203613, 0.576278565384075, -93.6744384765625, -1.63492737637288, 218, 22, 'PPL', 'P'),
(7152, 'Arkansas', 34.7502784729004, 0.606506775337019, -92.5002822875977, -1.61443448494277, 218, 4, 'ADM1', 'A'),
(34581, 'Arkansas', 37.5827789306641, 0.655943234389242, -82.7324981689453, -1.44395449144828, 218, 21, 'PPL', 'P'),
(108013, 'Arkansas', 39.0744400024414, 0.681977631415584, -78.7294387817383, -1.37408792498865, 218, 58, 'PPL', 'P'),
(7147, 'Arkansas (historical)', 34.026668548584, 0.593877399657591, -91.3430633544922, -1.59423720439367, 218, 4, 'PPL', 'P'),
(7148, 'Arkansas City', 33.6086082458496, 0.586580870902992, -91.206672668457, -1.5918567378533, 218, 4, 'PPL', 'P'),
(31669, 'Arkansas City', 37.061939239502, 0.646852866903392, -97.0380630493164, -1.69363369996842, 218, 20, 'PPL', 'P'),
(92324, 'Arkansas City', 26.6611099243164, 0.465324150415457, -98.4338912963867, -1.71799549867214, 218, 51, 'PPL', 'P'),
(188076, 'Arkansas Junction', 32.6966705322266, 0.57066455522716, -103.350563049316, -1.80380760900056, 218, 38, 'PPL', 'P'),
(7150, 'Arkansas Post', 34.023609161377, 0.593824003277735, -91.3436126708984, -1.59424679177359, 218, 4, 'PPL', 'P'),
(172954, 'Arkansaw', 44.6338882446289, 0.779008307835967, -92.0311126708984, -1.60624593038105, 218, 57, 'PPL', 'P'),
(7154, 'Arkawana', 36.4036102294922, 0.635362858117327, -92.4608306884766, -1.61374592464293, 218, 4, 'PPL', 'P'),
(172955, 'Arkdale', 44.0272216796875, 0.768419978815975, -89.8877792358398, -1.5688377049712, 218, 57, 'PPL', 'P'),
(112818, 'Arkdell', 34.9597206115723, 0.610162230249262, -87.4297180175781, -1.52593644349695, 218, 2, 'PPL', 'P'),
(99472, 'Arkendale', 38.4383316040039, 0.670875445463261, -77.3427810668945, -1.34988618226644, 218, 53, 'PPL', 'P'),
(7155, 'Arkinda', 33.7802810668945, 0.589577126866412, -94.4686126708984, -1.64878833089841, 218, 4, 'PPL', 'P'),
(7157, 'Arkins (historical)', 35.9847183227539, 0.628051815134787, -92.0827789306641, -1.60714767672615, 218, 4, 'PPL', 'P'),
(84705, 'Arkland', 35.6758308410645, 0.622660711561113, -87.2005615234375, -1.52193690817187, 218, 50, 'PPL', 'P'),
(34583, 'Arkle', 36.9191703796387, 0.64436108022946, -83.976936340332, -1.46567403487647, 218, 21, 'PPL', 'P'),
(7158, 'Arkmo', 35.9966697692871, 0.628260407227168, -90.2474975585938, -1.57511597408301, 218, 4, 'PPL', 'P'),
(71690, 'Arkoe', 39.0444412231445, 0.681454053945274, -83.2324981689453, -1.45268113770825, 218, 41, 'PPL', 'P'),
(139014, 'Arkoe', 40.2580604553223, 0.702635705412301, -94.8274993896484, -1.65505208578228, 218, 29, 'PPL', 'P'),
(7159, 'Arkola', 35.0847206115723, 0.612343891814255, -94.3088912963867, -1.64600066702737, 218, 4, 'PPL', 'P'),
(75012, 'Arkoma', 35.3544387817383, 0.617051361936106, -94.4338912963867, -1.64818232859236, 218, 42, 'PPL', 'P'),
(146862, 'Arkport', 42.3944396972656, 0.739922557255473, -77.6969375610352, -1.35606737915652, 218, 40, 'PPL', 'P'),
(99473, 'Arkton', 38.5730590820313, 0.673226883547747, -78.695556640625, -1.37349657006859, 218, 53, 'PPL', 'P'),
(146863, 'Arkville', 42.1477813720703, 0.73561755735336, -74.6202774047852, -1.30236952946503, 218, 40, 'PPL', 'P'),
(18912, 'Arkwright', 32.9327812194824, 0.574785464118922, -83.7030563354492, -1.46089392703589, 218, 13, 'PPL', 'P'),
(79563, 'Arkwright', 34.9238891601563, 0.609536853446284, -81.9330596923828, -1.43000165786513, 218, 48, 'PPL', 'P'),
(112820, 'Arkwright', 33.3713912963867, 0.582440654093327, -86.4024963378906, -1.50800804303853, 218, 2, 'PPL', 'P'),
(146864, 'Arkwright', 42.4069404602051, 0.740140736727778, -79.2366714477539, -1.38294080508429, 218, 40, 'PPL', 'P'),
(169259, 'Arkwright', 41.7286109924316, 0.728301654101831, -71.5488891601563, -1.24876369198921, 218, 47, 'PPL', 'P'),
(92325, 'Arlam', 31.8761100769043, 0.556343073570123, -94.5338897705078, -1.64992763121275, 218, 51, 'PPL', 'P'),
(172956, 'Arland', 45.3383293151855, 0.791303123903454, -92.0227813720703, -1.60610052178553, 218, 57, 'PPL', 'P'),
(99474, 'Arlandria', 38.8411102294922, 0.677905258634689, -77.0672225952148, -1.34507677965387, 218, 53, 'PPL', 'P'),
(179797, 'Arlanza', 33.9427795410156, 0.592413260269292, -117.464721679688, -2.05014614824931, 218, 6, 'PPL', 'P'),
(39141, 'Arlatex', 32.6777801513672, 0.570334855884208, -93.9533309936523, -1.63979496905527, 218, 22, 'PPL', 'P'),
(7160, 'Arlberg', 35.7336082458496, 0.623669117507871, -92.3891677856445, -1.61249517103698, 218, 4, 'PPL', 'P'),
(133990, 'Arlberg', 46.9233283996582, 0.818966576568597, -92.6138916015625, -1.61641734153239, 218, 28, 'PPL', 'P'),
(108014, 'Arlee', 38.7324981689453, 0.676009620570771, -82.0947189331055, -1.43282314388202, 218, 58, 'PPL', 'P'),
(195889, 'Arlee', 47.1619415283203, 0.823131161302236, -114.084167480469, -1.99114434693082, 218, 31, 'PPL', 'P'),
(189884, 'Arlemont (historical)', 37.8244400024414, 0.660161015765655, -118.078056335449, -2.06085085740894, 218, 39, 'PPL', 'P'),
(129561, 'Arlene', 44.3899993896484, 0.774751644307639, -85.2866668701172, -1.48853314493511, 218, 27, 'PPL', 'P'),
(18907, 'Arles', 32.1180610656738, 0.560565914952607, -84.1975021362305, -1.46952363423218, 218, 13, 'PPL', 'P'),
(200339, 'Arleta', 45.4888916015625, 0.793930931530062, -122.592216491699, -2.13963781509784, 218, 43, 'PPL', 'P'),
(206707, 'Arletta', 47.2902793884277, 0.825371079516074, -122.666389465332, -2.14093237770373, 218, 56, 'PPL', 'P'),
(53228, 'Arley', 39.4044418334961, 0.687737249905098, -94.4449996948242, -1.64837620671972, 218, 29, 'PPL', 'P'),
(112821, 'Arley', 34.0788917541504, 0.59478886654067, -87.2122192382813, -1.52214037367915, 218, 2, 'PPL', 'P'),
(112822, 'Arley Landing', 34.0441703796387, 0.594182864234623, -87.2658309936523, -1.52307607532815, 218, 2, 'PPL', 'P'),
(191085, 'Arlie', 34.7177810668945, 0.605939588603859, -100.090560913086, -1.74690983810129, 218, 51, 'PPL', 'P'),
(179795, 'Arlight', 34.5777816772461, 0.603496138303712, -120.638328552246, -2.10553603733938, 218, 6, 'PPL', 'P'),
(84706, 'Arline', 35.7938919067383, 0.624721265875534, -84.0947189331055, -1.4677297289219, 218, 50, 'PPL', 'P'),
(194533, 'Arling', 44.6252784729004, 0.778858038971459, -116.049171447754, -2.0254401359747, 218, 17, 'PPL', 'P'),
(158764, 'Arlingham', 40.1152801513672, 0.700143719001287, -75.20361328125, -1.31255066115435, 218, 45, 'PPL', 'P'),
(15027, 'Arlington', 30.3355598449707, 0.529455399730519, -81.6030578613281, -1.42424203937562, 218, 12, 'PPL', 'P'),
(18908, 'Arlington', 31.4397201538086, 0.548726632589578, -84.7249984741211, -1.47873018212058, 218, 13, 'PPL', 'P'),
(29111, 'Arlington', 39.6425018310547, 0.691892180679785, -85.5763931274414, -1.4935898220549, 218, 19, 'PPL', 'P'),
(31671, 'Arlington', 37.896671295166, 0.661421689646671, -98.1783294677734, -1.71353510332042, 218, 20, 'PPL', 'P'),
(34585, 'Arlington', 36.7902793884277, 0.64211150805667, -89.0127792358398, -1.55356607401625, 218, 21, 'PPL', 'P'),
(39143, 'Arlington', 32.8208312988281, 0.572831569406158, -91.1755599975586, -1.59131371930703, 218, 22, 'PPL', 'P'),
(44438, 'Arlington', 39.3394393920898, 0.686602743280724, -76.6841735839844, -1.33839131321139, 218, 25, 'PPL', 'P'),
(53229, 'Arlington', 37.920280456543, 0.661833747246333, -91.970832824707, -1.60519384859241, 218, 29, 'PPL', 'P'),
(58482, 'Arlington', 32.8766708374023, 0.573806153207072, -89.1772232055664, -1.55643616272303, 218, 30, 'PPL', 'P'),
(62571, 'Arlington', 36.2272186279297, 0.632284243897196, -80.833610534668, -1.41081265010473, 218, 33, 'PPL', 'P'),
(75013, 'Arlington', 35.5788917541504, 0.620968805320585, -96.679443359375, -1.68737460561646, 218, 42, 'PPL', 'P'),
(84709, 'Arlington', 35.2961082458496, 0.616033302030396, -89.6613922119141, -1.5648865060199, 218, 50, 'PPL', 'P'),
(92326, 'Arlington', 32.7355613708496, 0.571343328409994, -97.107780456543, -1.69485049827048, 218, 51, 'PPL', 'P'),
(99477, 'Arlington', 37.226390838623, 0.649723088768225, -76.0016708374023, -1.32647939312963, 218, 53, 'PPL', 'P'),
(108016, 'Arlington', 38.7999992370605, 0.677187736457994, -80.3433303833008, -1.4022556472062, 218, 58, 'PPL', 'P'),
(112824, 'Arlington', 32.0569381713867, 0.559499119198949, -87.5886077880859, -1.52870959314005, 218, 2, 'PPL', 'P'),
(114434, 'Arlington', 42.7491683959961, 0.746113740999635, -91.6711120605469, -1.59996273442123, 218, 16, 'PPL', 'P'),
(118646, 'Arlington', 41.4736099243164, 0.723851045867118, -89.2491683959961, -1.557691843177, 218, 18, 'PPL', 'P'),
(124120, 'Arlington', 42.4152793884277, 0.740286278481351, -71.1569366455078, -1.24192283009712, 218, 23, 'PPL', 'P'),
(133991, 'Arlington', 44.6083297729492, 0.778562228353378, -94.0802764892578, -1.64201058592416, 218, 28, 'PPL', 'P'),
(141196, 'Arlington', 41.4524993896484, 0.723482597530305, -96.350830078125, -1.68163922189287, 218, 35, 'PPL', 'P'),
(144763, 'Arlington', 40.7775001525879, 0.711701638395149, -74.1386108398438, -1.29396286201003, 218, 37, 'PPL', 'P'),
(146867, 'Arlington', 40.6322212219238, 0.709166042721284, -74.1655578613281, -1.29443317625854, 218, 40, 'PPL', 'P'),
(154091, 'Arlington', 41.0802803039551, 0.716986148946193, -81.4936065673828, -1.4223317539257, 218, 41, 'PPL', 'P'),
(158755, 'Arlington', 41.4119415283203, 0.722774729312562, -75.3261108398438, -1.31468864687746, 218, 45, 'PPL', 'P'),
(169745, 'Arlington', 44.3644409179688, 0.77430556482505, -97.1327819824219, -1.69528685721509, 218, 49, 'PPL', 'P'),
(171693, 'Arlington', 43.0747184753418, 0.751795661764346, -73.1544418334961, -1.27678587245318, 218, 55, 'PPL', 'P'),
(172958, 'Arlington', 43.3380584716797, 0.756391811752632, -89.3802795410156, -1.55998016434365, 218, 57, 'PPL', 'P'),
(179796, 'Arlington', 33.920280456543, 0.59202057716656, -117.445556640625, -2.0498116552164, 218, 6, 'PPL', 'P'),
(186358, 'Arlington', 38.336109161377, 0.66909132726999, -103.342781066895, -1.80367178778497, 218, 7, 'PPL', 'P'),
(193102, 'Arlington', 33.3255615234375, 0.581640773659922, -112.763328552246, -1.96809135874483, 218, 5, 'PPL', 'P'),
(200340, 'Arlington', 45.7169418334961, 0.79791115893724, -120.199722290039, -2.097880913944, 218, 43, 'PPL', 'P'),
(206710, 'Arlington', 48.1988906860352, 0.841229338280142, -122.123893737793, -2.13146404108017, 218, 56, 'PPL', 'P'),
(209276, 'Arlington', 41.5947189331055, 0.725964796824313, -106.207778930664, -1.85367543357035, 218, 59, 'PPL', 'P'),
(169747, 'Arlington Beach', 44.5338897705078, 0.777263005215583, -97.0975036621094, -1.69467113437106, 218, 49, 'PPL', 'P'),
(79564, 'Arlington Estates', 34.1211090087891, 0.595525696635268, -81.0469436645508, -1.41453601562477, 218, 48, 'PPL', 'P'),
(99480, 'Arlington Forest', 37.2099990844727, 0.649436998688123, -80.019172668457, -1.39659802778643, 218, 53, 'PPL', 'P'),
(71692, 'Arlington Heights', 39.2150001525879, 0.684430868832737, -84.4555587768555, -1.47402757226772, 218, 41, 'PPL', 'P'),
(92327, 'Arlington Heights', 27.8347206115723, 0.485807521044666, -97.5663909912109, -1.70285476208476, 218, 51, 'PPL', 'P'),
(99481, 'Arlington Heights', 38.8694381713867, 0.678399674491062, -77.0924987792969, -1.34551793228844, 218, 53, 'PPL', 'P'),
(118647, 'Arlington Heights', 42.0883293151855, 0.734579923213638, -87.9805603027344, -1.53555045503213, 218, 18, 'PPL', 'P'),
(124121, 'Arlington Heights', 42.420280456543, 0.740373563586078, -71.1805572509766, -1.24233508743386, 218, 23, 'PPL', 'P'),
(158757, 'Arlington Heights', 40.9900016784668, 0.715410489687248, -75.216667175293, -1.31277849458561, 218, 45, 'PPL', 'P'),
(206708, 'Arlington Heights', 48.202220916748, 0.841287461770933, -122.060829162598, -2.13036335660164, 218, 56, 'PPL', 'P'),
(99482, 'Arlington Hills', 37.2119407653809, 0.649470887412995, -80.0180587768555, -1.39657858671047, 218, 53, 'PPL', 'P'),
(206709, 'Arlington Junction', 48.2061080932617, 0.841355305799703, -122.127777099609, -2.13153181852991, 218, 56, 'PPL', 'P'),
(158758, 'Arlington Knolls', 40.6566696166992, 0.709592747706942, -75.4972229003906, -1.31767511572388, 218, 45, 'PPL', 'P'),
(133992, 'Arlington Mobile Home Park', 44.6069412231445, 0.778537993587459, -94.0691680908203, -1.6418167077968, 218, 28, 'PPL', 'P'),
(15028, 'Arlington Park', 26.3066692352295, 0.459137993387853, -80.1072235107422, -1.39813480489346, 218, 12, 'PPL', 'P'),
(18909, 'Arlington Park', 32.8169403076172, 0.572763658798361, -83.6797180175781, -1.46048659654716, 218, 13, 'PPL', 'P'),
(77799, 'Arlington Park', 39.9049987792969, 0.696473616703049, -76.6858291625977, -1.33842020850922, 218, 45, 'PPL', 'P'),
(143472, 'Arlington Park', 42.8302803039551, 0.747529410856094, -71.2244415283203, -1.24310101256337, 218, 36, 'PPL', 'P'),
(179798, 'Arlington Station', 33.9141693115234, 0.591913917564903, -117.440277099609, -2.04971950984268, 218, 6, 'PPL', 'P'),
(99483, 'Arlington Village', 38.8616714477539, 0.678264119591577, -77.085563659668, -1.3453968916169, 218, 53, 'PPL', 'P'),
(154093, 'Arlington Woods', 41.2874984741211, 0.720602788285548, -83.6527786254883, -1.46001641545671, 218, 41, 'PPL', 'P'),
(99484, 'Arlingwood', 38.9275016784668, 0.679413073864865, -77.1222229003906, -1.34603671606879, 218, 53, 'PPL', 'P'),
(171691, 'Arlins', 44.922779083252, 0.784050404148786, -71.5116729736328, -1.24811414699934, 218, 55, 'PPL', 'P'),
(193351, 'Arlynda Corners', 40.5950012207031, 0.708516431152387, -124.253890991211, -2.16863950621075, 218, 6, 'PPL', 'P'),
(58483, 'Arm', 31.5027809143066, 0.549827250489081, -90.01611328125, -1.57107755660601, 218, 30, 'PPL', 'P'),
(31673, 'Arma', 37.5438919067383, 0.655264527785435, -94.6999969482422, -1.65282674837541, 218, 20, 'PPL', 'P'),
(44439, 'Armacost', 39.6133308410645, 0.691383050858389, -76.8041687011719, -1.34048562309263, 218, 25, 'PPL', 'P'),
(129563, 'Armada', 42.8441696166992, 0.747771825094318, -82.8844375610352, -1.44660633410372, 218, 27, 'PPL', 'P'),
(7161, 'Armada (historical)', 35.7166709899902, 0.623373506626872, -94.1952819824219, -1.64401781043775, 218, 4, 'PPL', 'P'),
(71695, 'Armadale', 39.3958282470703, 0.687586914461563, -81.9230575561523, -1.42982708765568, 218, 41, 'PPL', 'P'),
(39144, 'Armagh', 31.4283294677734, 0.548527827614204, -91.7508316040039, -1.60135410293274, 218, 22, 'PPL', 'P'),
(44440, 'Armagh', 39.3811111450195, 0.687330052574425, -76.6202774047852, -1.33727611450492, 218, 25, 'PPL', 'P'),
(158759, 'Armagh', 40.4536094665527, 0.706048679507292, -79.0322189331055, -1.37937243553969, 218, 45, 'PPL', 'P'),
(114436, 'Armah', 41.5313911437988, 0.724859518392903, -92.2091674804688, -1.60935357305706, 218, 16, 'PPL', 'P'),
(39145, 'Armant', 29.9961109161377, 0.523530898280015, -90.7300033569336, -1.583537288924, 218, 22, 'PPL', 'P'),
(84710, 'Armathwaite', 36.3741683959961, 0.634849001184996, -84.7822189331055, -1.47972886752936, 218, 50, 'PPL', 'P'),
(146868, 'Armawalk', 41.2877807617188, 0.720607715133565, -73.7713928222656, -1.28755369853065, 218, 40, 'PPL', 'P'),
(18910, 'Armboy', 31.7922191619873, 0.554878900892311, -83.5875015258789, -1.45887711514237, 218, 13, 'PPL', 'P'),
(158762, 'Armbrust', 40.2236099243164, 0.702034430217188, -79.5513916015625, -1.38843370799063, 218, 45, 'PPL', 'P'),
(99485, 'Armel', 39.0791702270508, 0.682060189409376, -78.1438903808594, -1.36386817746352, 218, 53, 'PPL', 'P'),
(186357, 'Armel', 39.7972183227539, 0.694592492867071, -102.107780456543, -1.78211696087019, 218, 7, 'PPL', 'P'),
(114437, 'Armel Acres Mobile Home Estates', 42.7880592346191, 0.746792514182469, -96.1805572509766, -1.67866740043245, 218, 16, 'PPL', 'P'),
(195890, 'Armells (historical)', 47.315559387207, 0.825812298729673, -109.183326721191, -1.90560853956549, 218, 31, 'PPL', 'P'),
(18911, 'Armena', 31.6808300018311, 0.552934793296553, -84.2847213745117, -1.47104589711127, 218, 13, 'PPL', 'P'),
(79565, 'Armenia', 34.7683296203613, 0.606821827293975, -81.2930603027344, -1.41883156130501, 218, 48, 'PPL', 'P'),
(71696, 'Armenia (historical)', 39.2249984741211, 0.684605372463165, -81.7013931274414, -1.42595831354012, 218, 41, 'PPL', 'P'),
(188077, 'Armenta Plaza (historical)', 35.8247184753418, 0.625259290994757, -104.370002746582, -1.82160018824338, 218, 38, 'PPL', 'P'),
(29114, 'Armiesburg', 39.7633285522461, 0.694001004788964, -87.3511123657227, -1.52456451606139, 218, 19, 'PPL', 'P'),
(44441, 'Armiger', 39.125, 0.682860069842781, -76.5350036621094, -1.33578780692973, 218, 25, 'PPL', 'P'),
(188078, 'Armijo', 35.0536117553711, 0.611800939847015, -106.676666259766, -1.86185906128405, 218, 38, 'PPL', 'P'),
(108018, 'Armilda', 38.1836090087891, 0.666429697497538, -82.4016723632813, -1.43818049188887, 218, 58, 'PPL', 'P'),
(200341, 'Armin (historical)', 45.3402786254883, 0.791337145786379, -116.987503051758, -2.04181711194009, 218, 43, 'PPL', 'P'),
(84711, 'Arminda', 36.0508308410645, 0.629205696256091, -83.79638671875, -1.46252284951664, 218, 50, 'PPL', 'P'),
(118648, 'Armington', 40.3388900756836, 0.704046448420743, -89.311393737793, -1.55877788026953, 218, 18, 'PPL', 'P'),
(195891, 'Armington', 47.3663902282715, 0.826699464267806, -110.902778625488, -1.93561863662516, 218, 31, 'PPL', 'P'),
(169261, 'Armington Corner', 41.7980613708496, 0.72951379187198, -71.3638916015625, -1.24553487548359, 218, 47, 'PPL', 'P'),
(195892, 'Armington Junction', 47.3480606079102, 0.82637955204186, -110.893608093262, -1.93545858064365, 218, 31, 'PPL', 'P'),
(209277, 'Arminto', 43.1788902282715, 0.753613801840543, -107.256942749023, -1.87198679659352, 218, 59, 'PPL', 'P'),
(39147, 'Armistead', 32.0052795410156, 0.558597506011902, -93.3802795410156, -1.62979333442342, 218, 22, 'PPL', 'P'),
(58484, 'Armistead', 34.3641700744629, 0.599767912514682, -90.6122207641602, -1.58148159487857, 218, 30, 'PPL', 'P'),
(179799, 'Armistead', 35.547779083252, 0.620425786774318, -117.926666259766, -2.05820860213342, 218, 6, 'PPL', 'P'),
(99487, 'Armistead Forest', 36.8727798461914, 0.643551412679048, -76.4116668701172, -1.33363517382062, 218, 53, 'PPL', 'P'),
(44442, 'Armistead Gardens', 39.3016700744629, 0.685943544331902, -76.5497207641602, -1.33604466881686, 218, 25, 'PPL', 'P'),
(44443, 'Armistead Homes', 39.3069381713867, 0.686035489968537, -76.557502746582, -1.33618049003246, 218, 25, 'PPL', 'P'),
(71697, 'Armitage', 39.3455581665039, 0.686709536040437, -82.0961074829102, -1.43284737864794, 218, 41, 'PPL', 'P'),
(58485, 'Armitage (historical)', 33.1783294677734, 0.579071089524104, -88.6111068725586, -1.54655556876272, 218, 30, 'PPL', 'P'),
(84712, 'Armona', 35.7872200012207, 0.62460481915687, -84.0141677856445, -1.46632384618245, 218, 50, 'PPL', 'P'),
(179800, 'Armona', 36.3158302307129, 0.633830808121232, -119.707496643066, -2.08928995574157, 218, 6, 'PPL', 'P'),
(146869, 'Armonk', 41.1263885498047, 0.717790889648588, -73.7144393920898, -1.28655967365378, 218, 40, 'PPL', 'P'),
(146870, 'Armor', 42.7405586242676, 0.745963472135127, -78.7991714477539, -1.37530498960681, 218, 40, 'PPL', 'P'),
(7162, 'Armorel', 35.9199981689453, 0.62692223535843, -89.7980575561523, -1.56727176625023, 218, 4, 'PPL', 'P'),
(177444, 'Armoryville (historical)', 41.3369407653809, 0.721465719057761, -72.9124984741211, -1.27256316422875, 218, 8, 'PPL', 'P'),
(53231, 'Armour', 39.5486106872559, 0.690253471082032, -95.0461120605469, -1.65886759667604, 218, 29, 'PPL', 'P'),
(62573, 'Armour', 34.3469390869141, 0.599467175048585, -78.2544403076172, -1.36579763767328, 218, 33, 'PPL', 'P'),
(114438, 'Armour', 42.5127792358398, 0.741987971838884, -92.254997253418, -1.61015345349047, 218, 16, 'PPL', 'P'),
(169750, 'Armour', 43.3186111450195, 0.756052391871702, -98.3463897705078, -1.71646830894503, 218, 49, 'PPL', 'P'),
(141199, 'Armour (historical)', 40.1194381713867, 0.700216290140991, -96.4199981689453, -1.682846432815, 218, 35, 'PPL', 'P'),
(133996, 'Armour Number Two Mine', 46.4850006103516, 0.811316313442208, -93.9683303833008, -1.64005675779042, 218, 28, 'PPL', 'P'),
(84713, 'Armour Village', 35.6327781677246, 0.621909300659547, -87.1580581665039, -1.52119508465023, 218, 50, 'PPL', 'P'),
(118651, 'Armsby (historical)', 42.4736099243164, 0.741304338387061, -88.4111099243164, -1.54306496352196, 218, 18, 'PPL', 'P'),
(13031, 'Armsleigh Park (historical)', 38.9452781677246, 0.679723332131859, -77.0772171020508, -1.34525121670527, 218, 9, 'PPL', 'P'),
(112827, 'Armstead', 33.8819389343262, 0.59135139136365, -86.5247192382813, -1.51014123507169, 218, 2, 'PPL', 'P'),
(195893, 'Armstead (historical)', 44.9724998474121, 0.784918195189989, -112.863327026367, -1.96983666136521, 218, 31, 'PPL', 'P'),
(7163, 'Armstrong', 36.3727798461914, 0.634824766419077, -91.3172225952148, -1.59378619806306, 218, 4, 'PPL', 'P'),
(13298, 'Armstrong', 39.4805603027344, 0.689065767814884, -75.7169418334961, -1.32150993453554, 218, 10, 'PPL', 'P'),
(15029, 'Armstrong', 29.7619400024414, 0.519443844823612, -81.4480590820313, -1.42153680034032, 218, 12, 'PPL', 'P'),
(29112, 'Armstrong', 38.1091690063477, 0.665130474359742, -87.647216796875, -1.52973251331475, 218, 19, 'PPL', 'P'),
(53232, 'Armstrong', 39.269718170166, 0.68538587839964, -92.7011108398438, -1.61793960441148, 218, 29, 'PPL', 'P'),
(75014, 'Armstrong', 34.0513916015625, 0.594308898333211, -96.3450012207031, -1.68153748913923, 218, 42, 'PPL', 'P'),
(92329, 'Armstrong', 26.9241695404053, 0.46991540684524, -97.7911071777344, -1.70677679942212, 218, 51, 'PPL', 'P'),
(99488, 'Armstrong', 38.1119384765625, 0.665178810733527, -79.5216674804688, -1.38791492421028, 218, 53, 'PPL', 'P'),
(112825, 'Armstrong', 32.2394409179688, 0.562684393020738, -85.6577835083008, -1.49501035218035, 218, 2, 'PPL', 'P'),
(114439, 'Armstrong', 43.396110534668, 0.757405011389353, -94.4780578613281, -1.64895318056989, 218, 16, 'PPL', 'P'),
(118652, 'Armstrong', 40.3063888549805, 0.703479195108556, -87.8777770996094, -1.53375654972186, 218, 18, 'PPL', 'P'),
(133998, 'Armstrong', 45.0113906860352, 0.785596968372823, -93.6866683959961, -1.63514082873425, 218, 28, 'PPL', 'P'),
(144764, 'Armstrong', 41.1494407653809, 0.718193226710271, -74.6902770996094, -1.3035912546151, 218, 37, 'PPL', 'P'),
(154094, 'Armstrong', 40.9122200012207, 0.71405294332158, -82.0111083984375, -1.43136386476271, 218, 41, 'PPL', 'P'),
(158766, 'Armstrong', 41.0941696166992, 0.717228563184418, -80.0519409179688, -1.39716994163053, 218, 45, 'PPL', 'P'),
(172963, 'Armstrong', 43.7102813720703, 0.762888326915772, -88.1947174072266, -1.53928820162206, 218, 57, 'PPL', 'P'),
(179802, 'Armstrong', 38.089168548584, 0.66478140051986, -121.273612976074, -2.11662384222181, 218, 6, 'PPL', 'P'),
(206711, 'Armstrong', 46.7602806091309, 0.816120855785793, -117.22444152832, -2.04595246848076, 218, 56, 'PPL', 'P'),
(18913, 'Armstrong (historical)', 33.810001373291, 0.590095844067733, -82.7624969482422, -1.44447806891859, 218, 13, 'PPL', 'P'),
(172964, 'Armstrong Creek', 45.6583290100098, 0.796888172183513, -88.4461135864258, -1.54367589267602, 218, 57, 'PPL', 'P'),
(99489, 'Armstrong Gardens', 37.0080604553223, 0.645912504722485, -76.3594436645508, -1.33272370693754, 218, 53, 'PPL', 'P'),
(92330, 'Armstrong Landing', 33.2272186279297, 0.579924366337366, -94.2786102294922, -1.64547216270905, 218, 51, 'PPL', 'P'),
(53233, 'Armstrong Quarry', 36.519718170166, 0.637389323969796, -94.4830627441406, -1.64904053225364, 218, 29, 'PPL', 'P'),
(92331, 'Armstrong''s Alton Colonia', 26.2880001068115, 0.458812155628482, -98.3119964599609, -1.71586803243533, 218, 51, 'PPL', 'P'),
(71698, 'Armstrongs Mills', 39.9080581665039, 0.696527013082905, -80.9349975585938, -1.41258218749103, 218, 41, 'PPL', 'P'),
(18914, 'Armuchee', 34.3888893127441, 0.600199344611275, -85.1819381713867, -1.48670528432094, 218, 13, 'PPL', 'P'),
(172966, 'Army Lake (historical)', 42.8066711425781, 0.747117353256431, -88.3752822875977, -1.54243965329801, 218, 57, 'PPL', 'P'),
(99490, 'Arna Valley', 38.8441696166992, 0.677958655014545, -77.0766677856445, -1.34524162932534, 218, 53, 'PPL', 'P'),
(39148, 'Arnaudville', 30.3974990844727, 0.53053644339601, -91.9313888549805, -1.60450542145063, 218, 22, 'PPL', 'P'),
(18915, 'Arnco Mills', 33.4147186279297, 0.583196858684855, -84.8536071777344, -1.48097482744536, 218, 13, 'PPL', 'P'),
(139608, 'Arndt', 48.6300010681152, 0.84875363388697, -99.2350006103516, -1.73197749386922, 218, 34, 'PPL', 'P'),
(158769, 'Arndts', 40.7994384765625, 0.712084534380875, -75.4772186279297, -1.31732597530497, 218, 45, 'PPL', 'P'),
(92332, 'Arneckeville', 28.9922199249268, 0.506009695152275, -97.2719421386719, -1.69771566012924, 218, 51, 'PPL', 'P'),
(112828, 'Arnedra Subdivision', 33.2911109924316, 0.581039498464809, -87.7022171020508, -1.53069244972967, 218, 2, 'PPL', 'P'),
(197949, 'Arnegard', 47.8077812194824, 0.834403190353078, -103.440559387207, -1.80537834141149, 218, 34, 'PPL', 'P'),
(134000, 'Arnesen', 48.9575004577637, 0.854469576534607, -95.0672225952148, -1.65923604501285, 218, 28, 'PPL', 'P'),
(7164, 'Arnett', 35.8950004577637, 0.626485942992848, -94.039436340332, -1.6412977908584, 218, 4, 'PPL', 'P'),
(34586, 'Arnett', 37.4102783203125, 0.652932530776907, -83.5686111450195, -1.45854741579942, 218, 21, 'PPL', 'P'),
(53235, 'Arnett', 36.5625, 0.638136007760427, -94.2219390869141, -1.64448306468019, 218, 29, 'PPL', 'P'),
(75016, 'Arnett', 34.7472190856934, 0.606453378957163, -99.9647216796875, -1.7447135291503, 218, 42, 'PPL', 'P'),
(108020, 'Arnett', 37.8333282470703, 0.660316144899152, -81.4302825927734, -1.42122654207332, 218, 58, 'PPL', 'P'),
(146871, 'Arnett', 43.1438903808594, 0.753002939265506, -77.6408309936523, -1.35508813482369, 218, 40, 'PPL', 'P'),
(191087, 'Arnett', 33.4925003051758, 0.584554405050523, -102.291389465332, -1.78532154260989, 218, 51, 'PPL', 'P'),
(108021, 'Arnettsville', 39.5855598449707, 0.690898355539995, -80.0924987792969, -1.39787780984827, 218, 58, 'PPL', 'P'),
(29115, 'Arney', 39.2186088562012, 0.684493852592518, -86.9316711425781, -1.51724388569893, 218, 19, 'PPL', 'P'),
(191088, 'Arney', 34.6872215270996, 0.605406224016544, -102.102500915527, -1.78202481549648, 218, 51, 'PPL', 'P'),
(144767, 'Arneys Mount', 40.0097198486328, 0.69830134415917, -74.6969375610352, -1.30370750159669, 218, 37, 'PPL', 'P'),
(144765, 'Arneytown', 40.101390838623, 0.699901304763062, -74.5663909912109, -1.30142903412607, 218, 37, 'PPL', 'P'),
(71701, 'Arnheim', 38.9333305358887, 0.679514806618506, -83.8274993896484, -1.4630658680629, 218, 41, 'PPL', 'P'),
(129566, 'Arnheim', 46.9169387817383, 0.81885505669795, -88.4824981689453, -1.54431092343795, 218, 27, 'PPL', 'P'),
(53236, 'Arnica', 37.7516708374023, 0.658890954241796, -93.7083282470703, -1.63551886445098, 218, 29, 'PPL', 'P'),
(15030, 'Arno', 29.7716693878174, 0.519613654632618, -82.5555572509766, -1.44086628984822, 218, 12, 'PPL', 'P'),
(53237, 'Arno', 36.9397201538086, 0.644719741449266, -92.746940612793, -1.61873948484488, 218, 29, 'PPL', 'P'),
(84714, 'Arno', 35.8030586242676, 0.624881255278021, -86.7416687011719, -1.51392771750956, 218, 50, 'PPL', 'P'),
(99491, 'Arno', 36.9272193908691, 0.644501561976961, -82.8122177124023, -1.44534585995979, 218, 53, 'PPL', 'P'),
(191089, 'Arno', 31.6630592346191, 0.5526246348981, -103.635559082031, -1.80878172812656, 218, 51, 'PPL', 'P'),
(179803, 'Arno (historical)', 38.3333282470703, 0.669042791159123, -121.335563659668, -2.11770508562439, 218, 6, 'PPL', 'P'),
(34588, 'Arnold', 37.3913917541504, 0.652602898012982, -86.6588897705078, -1.51248295261819, 218, 21, 'PPL', 'P'),
(44444, 'Arnold', 39.0319404602051, 0.681235874472969, -76.503059387207, -1.33523027415552, 218, 25, 'PPL', 'P'),
(53238, 'Arnold', 38.4327812194824, 0.67077857297861, -90.3775024414063, -1.57738498733175, 218, 29, 'PPL', 'P'),
(62574, 'Arnold', 35.8933296203613, 0.626456781378911, -80.2808303833008, -1.4011648164237, 218, 33, 'PPL', 'P'),
(92334, 'Arnold', 33.269718170166, 0.58066612327998, -96.3308334350586, -1.68129021463201, 218, 51, 'PPL', 'P'),
(114441, 'Arnold', 42.8108291625977, 0.747189924396136, -94.1983337402344, -1.64407107365955, 218, 16, 'PPL', 'P'),
(118653, 'Arnold', 42.1699981689453, 0.736005313608076, -90.2263870239258, -1.57474752574619, 218, 18, 'PPL', 'P'),
(129567, 'Arnold', 46.0508308410645, 0.803738621455524, -87.491943359375, -1.52702248058948, 218, 27, 'PPL', 'P'),
(134001, 'Arnold', 46.8802795410156, 0.818215232246059, -92.0902786254883, -1.60727857109373, 218, 28, 'PPL', 'P'),
(154096, 'Arnold', 40.1419410705566, 0.700609039822751, -83.2508316040039, -1.45300111651322, 218, 41, 'PPL', 'P'),
(158770, 'Arnold', 40.5800018310547, 0.708254642417232, -79.7669372558594, -1.39219568934648, 218, 45, 'PPL', 'P'),
(172967, 'Arnold', 45.2488899230957, 0.789742112030504, -91.0041732788086, -1.58832245677065, 218, 57, 'PPL', 'P'),
(177181, 'Arnold', 40.2986106872559, 0.70334344047199, -80.5802764892578, -1.40639113690493, 218, 58, 'PPL', 'P'),
(179805, 'Arnold', 39.5188903808594, 0.689734753880712, -123.392501831055, -2.15360542922504, 218, 6, 'PPL', 'P'),
(192927, 'Arnold', 38.6402816772461, 0.674400139165981, -100.045829772949, -1.74612913242773, 218, 20, 'PPL', 'P'),
(195894, 'Arnold', 45.7144393920898, 0.797867483095363, -111.35417175293, -1.94349693291989, 218, 31, 'PPL', 'P'),
(197952, 'Arnold', 46.9238891601563, 0.818976363685603, -100.753059387207, -1.75847261776414, 218, 34, 'PPL', 'P'),
(199150, 'Arnold', 41.4225006103516, 0.722959020059996, -100.193061828613, -1.74869881656355, 218, 35, 'PPL', 'P'),
(179806, 'Arnold (historical)', 37.7630615234375, 0.65908975921717, -120.740829467773, -2.10732501580164, 218, 6, 'PPL', 'P'),
(158771, 'Arnold City', 40.1163902282715, 0.700163093498217, -79.8252792358398, -1.39321394898927, 218, 45, 'PPL', 'P'),
(126770, 'Arnold Corner', 44.7383308410645, 0.780831175023099, -69.0652770996094, -1.20541648419042, 218, 26, 'PPL', 'P'),
(44445, 'Arnold Heights', 38.8536109924316, 0.678123438106994, -76.9366683959961, -1.3427981790252, 218, 25, 'PPL', 'P'),
(179807, 'Arnold Heights', 33.8936080932617, 0.591555056608014, -117.278060913086, -2.04688830328782, 218, 6, 'PPL', 'P'),
(108023, 'Arnold Hill', 38.8833312988281, 0.678642155308314, -79.8638916015625, -1.39388786190311, 218, 58, 'PPL', 'P'),
(58486, 'Arnold Line', 31.3349990844727, 0.546898905133457, -89.3733291625977, -1.559858857356, 218, 30, 'PPL', 'P'),
(18916, 'Arnold Mill', 34.1175003051758, 0.595462712875488, -84.3880615234375, -1.47284952295953, 218, 13, 'PPL', 'P'),
(169262, 'Arnold Mills', 41.978328704834, 0.7326600503838, -71.3925018310547, -1.24603421818798, 218, 47, 'PPL', 'P'),
(193044, 'Arnold Place', 34.4533309936523, 0.601324064118643, -111.917503356934, -1.9533289241903, 218, 5, 'PPL', 'P'),
(177447, 'Arnolds', 41.4658317565918, 0.723715291230551, -72.5149993896484, -1.26562549643104, 218, 8, 'PPL', 'P'),
(99492, 'Arnolds Corner', 38.2761116027832, 0.668044172329371, -77.2041702270508, -1.34746696673221, 218, 53, 'PPL', 'P'),
(126771, 'Arnolds Landing', 44.9566688537598, 0.784641892226893, -69.870002746582, -1.21946159630534, 218, 26, 'PPL', 'P'),
(146872, 'Arnolds Mill', 42.3413887023926, 0.73899664272348, -73.5955581665039, -1.28448480484849, 218, 40, 'PPL', 'P'),
(114442, 'Arnolds Park', 43.3727798461914, 0.75699781405868, -95.1236114501953, -1.66022021619369, 218, 16, 'PPL', 'P'),
(108024, 'Arnoldsburg', 38.788890838623, 0.676993858330637, -81.1277770996094, -1.41594682521224, 218, 58, 'PPL', 'P'),
(18918, 'Arnoldsville', 33.9049987792969, 0.591753861583389, -83.2169418334961, -1.45240962843511, 218, 13, 'PPL', 'P'),
(44446, 'Arnoldtown', 39.4094390869141, 0.687824468430798, -77.6061096191406, -1.35448213251765, 218, 25, 'PPL', 'P'),
(124123, 'Arnoldville', 42.5880584716797, 0.743301842362675, -73.1341705322266, -1.27643207150237, 218, 23, 'PPL', 'P'),
(58487, 'Arnot', 31.2555599212646, 0.545512430180448, -91.6083297729492, -1.59886697679071, 218, 30, 'PPL', 'P'),
(158773, 'Arnot', 41.6624984741211, 0.727147772980527, -77.1233291625977, -1.34605602398669, 218, 45, 'PPL', 'P'),
(112830, 'Arnot (historical)', 34.9191703796387, 0.609454495189573, -87.5708312988281, -1.52839933487305, 218, 2, 'PPL', 'P'),
(158778, 'Arnots Addition', 40.7180595397949, 0.710664203992508, -76.2002792358398, -1.32994576360447, 218, 45, 'PPL', 'P'),
(172968, 'Arnott', 44.457218170166, 0.775924833346846, -89.4466705322266, -1.56113890573394, 218, 57, 'PPL', 'P'),
(53239, 'Arnsberg', 37.5697212219238, 0.655715334378958, -89.7774963378906, -1.56691290529334, 218, 29, 'PPL', 'P'),
(193043, 'Arntz', 34.9358291625977, 0.609745245801583, -110.041938781738, -1.92059414701937, 218, 5, 'PPL', 'P'),
(200342, 'Arock', 42.9141693115234, 0.748993550244392, -117.524169921875, -2.05118371581001, 218, 43, 'PPL', 'P'),
(99493, 'Aroda', 38.3263893127441, 0.668921683908552, -78.2324981689453, -1.36541467510853, 218, 53, 'PPL', 'P'),
(212286, 'Arolokovik', 62.3847198486328, 1.0888187642929, -163.800567626953, -2.85885922172597, 218, 1, 'PPL', 'P'),
(53240, 'Aroma', 36.8636093139648, 0.643391356697535, -94.2644424438477, -1.64522488820183, 218, 29, 'PPL', 'P'),
(122160, 'Aroma', 40.1994400024414, 0.70161258550052, -85.8741683959961, -1.49878698092219, 218, 19, 'PPL', 'P'),
(118654, 'Aroma Park', 41.079719543457, 0.716976361829187, -87.811393737793, -1.53259794148962, 218, 18, 'PPL', 'P'),
(179808, 'Aromas', 36.8886108398438, 0.643827715642144, -121.641937255859, -2.1230523136191, 218, 6, 'PPL', 'P'),
(75017, 'Aron', 35.6824989318848, 0.622777091700749, -96.5119400024414, -1.68445112052983, 218, 42, 'PPL', 'P'),
(112831, 'Arona', 34.2216682434082, 0.597280786372657, -86.0819396972656, -1.5024132742205, 218, 2, 'PPL', 'P'),
(158774, 'Arona', 40.2691688537598, 0.702829583539659, -79.6616668701172, -1.39035837451043, 218, 45, 'PPL', 'P'),
(77800, 'Aronimink', 39.9505615234375, 0.697268836604546, -75.3188934326172, -1.3145626793579, 218, 45, 'PPL', 'P'),
(158776, 'Aronwold', 40.014720916748, 0.698388629263897, -75.414436340332, -1.31623021767446, 218, 45, 'PPL', 'P'),
(186359, 'Aroya', 38.8541717529297, 0.678133225224, -103.125, -1.79987079111915, 218, 7, 'PPL', 'P'),
(18920, 'Arp', 31.7558307647705, 0.554243803551354, -83.4069366455078, -1.45572566346643, 218, 13, 'PPL', 'P'),
(84715, 'Arp', 35.7733306884766, 0.624362404918646, -89.6025009155273, -1.56385865899719, 218, 50, 'PPL', 'P'),
(92335, 'Arp', 32.2252807617188, 0.562437251671578, -95.057502746582, -1.65906640165141, 218, 51, 'PPL', 'P'),
(7165, 'Arp (historical)', 34.1061096191406, 0.595263907900113, -93.6316680908203, -1.63418089231933, 218, 4, 'PPL', 'P'),
(201868, 'Arpan', 44.788330078125, 0.78170382633329, -103.648612976074, -1.80900956155781, 218, 49, 'PPL', 'P'),
(118656, 'Arpee', 41.1830596923828, 0.718779987677443, -90.9469375610352, -1.58732350504576, 218, 18, 'PPL', 'P'),
(75018, 'Arpelar', 34.9419403076172, 0.60985190540324, -95.9652786254883, -1.67491007960851, 218, 42, 'PPL', 'P'),
(172969, 'Arpin', 44.5405616760254, 0.777379451934247, -90.0350036621094, -1.57140725594896, 218, 57, 'PPL', 'P'),
(15031, 'Arran', 30.1902809143066, 0.526919804056655, -84.4161071777344, -1.47333901196788, 218, 12, 'PPL', 'P'),
(15032, 'Arrant Settlement', 30.8591709136963, 0.538594136879667, -85.9741668701172, -1.50053228354257, 218, 12, 'PPL', 'P'),
(15033, 'Arredondo', 29.6047191619873, 0.516699823504935, -82.4094390869141, -1.43831604678836, 218, 12, 'PPL', 'P'),
(92345, 'Arredondo Colonia', 26.3840007781982, 0.460487683428305, -98.8369979858398, -1.72503103763991, 218, 51, 'PPL', 'P'),
(15034, 'Arredondo Estates', 29.6047191619873, 0.516699823504935, -82.416389465332, -1.43843735377601, 218, 12, 'PPL', 'P'),
(188079, 'Arrey', 32.8486099243164, 0.573316397882607, -107.31861114502, -1.87306311314807, 218, 38, 'PPL', 'P'),
(92336, 'Arriaga Colonia', 26.2210006713867, 0.457642794883342, -98.0859985351563, -1.71192362454481, 218, 51, 'PPL', 'P'),
(186361, 'Arriba', 39.2861099243164, 0.685671968479742, -103.275001525879, -1.80248881162875, 218, 7, 'PPL', 'P'),
(188080, 'Arriba', 35.6233291625977, 0.621744384409044, -105.20027923584, -1.83609124668283, 218, 38, 'PPL', 'P'),
(62579, 'Arringdale', 36.5311088562012, 0.63758812894517, -76.184440612793, -1.32966932748332, 218, 33, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(99494, 'Arringdale', 36.7177810668945, 0.640846173643746, -77.3363876342773, -1.34977459581677, 218, 53, 'PPL', 'P'),
(31674, 'Arrington', 39.4627799987793, 0.688755442968863, -95.5361099243164, -1.66741967272655, 218, 20, 'PPL', 'P'),
(84716, 'Arrington', 35.8680610656738, 0.626015761902394, -86.7091674804688, -1.51336046419738, 218, 50, 'PPL', 'P'),
(99495, 'Arrington', 37.6838912963867, 0.657707978085583, -78.9013900756836, -1.37708904122106, 218, 53, 'PPL', 'P'),
(112829, 'Arrington (historical)', 32.4844398498535, 0.566960431045996, -88.1191711425781, -1.53796967056636, 218, 2, 'PPL', 'P'),
(34589, 'Arrington Corner', 37.7747192382813, 0.659293224724452, -86.7486114501953, -1.51404889133916, 218, 21, 'PPL', 'P'),
(99496, 'Arrington Court', 37.2930603027344, 0.650886690427508, -79.9024963378906, -1.3945616416589, 218, 53, 'PPL', 'P'),
(44458, 'Arrington Estates', 39.3902816772461, 0.687490108555939, -76.9341735839844, -1.34275463634137, 218, 25, 'PPL', 'P'),
(186360, 'Arriola', 37.4425010681152, 0.653494923820104, -108.645561218262, -1.89622276093573, 218, 7, 'PPL', 'P'),
(146873, 'Arrochar', 40.598331451416, 0.708574554643178, -74.0730590820313, -1.29281876800573, 218, 40, 'PPL', 'P'),
(189885, 'Arrolime', 36.351390838623, 0.634451457813275, -114.908332824707, -2.00552874576861, 218, 39, 'PPL', 'P'),
(53241, 'Arroll', 37.1074981689453, 0.647648020225863, -91.7263870239258, -1.60092746452611, 218, 29, 'PPL', 'P'),
(84717, 'Arrow', 35.5122184753418, 0.619805137082275, -87.1930618286133, -1.52180601380429, 218, 50, 'PPL', 'P'),
(194534, 'Arrow', 46.4780616760254, 0.811195206191637, -116.766937255859, -2.03796751258438, 218, 17, 'PPL', 'P'),
(195895, 'Arrow Creek', 47.3444404602051, 0.826316368544998, -110.174438476563, -1.92290670295194, 218, 31, 'PPL', 'P'),
(18921, 'Arrow Head', 33.4983291625977, 0.584656137804164, -82.1041717529297, -1.43298812671155, 218, 13, 'PPL', 'P'),
(84718, 'Arrow Hills', 36.1733283996582, 0.631343681979207, -83.408332824707, -1.4557500313904, 218, 50, 'PPL', 'P'),
(53242, 'Arrow Point', 36.5447196960449, 0.637825682914405, -93.6191711425781, -1.63396277942605, 218, 29, 'PPL', 'P'),
(118657, 'Arrow Ridge Mobile Home Park', 41.6777801513672, 0.727414488563698, -87.7763900756836, -1.53198701233555, 218, 18, 'PPL', 'P'),
(53243, 'Arrow Rock', 39.0697212219238, 0.681895273158873, -92.9463882446289, -1.62222050270573, 218, 29, 'PPL', 'P'),
(99497, 'Arrow Wood', 37.3208312988281, 0.651371385745903, -79.9916687011719, -1.39611799299995, 218, 53, 'PPL', 'P'),
(179809, 'Arrowbear Lake', 34.2108306884766, 0.597091635356235, -117.082496643066, -2.04347506287672, 218, 6, 'PPL', 'P'),
(44449, 'Arrowhead', 39.1875, 0.683950900625278, -76.8625030517578, -1.34150374957736, 218, 25, 'PPL', 'P'),
(53245, 'Arrowhead', 38.1811103820801, 0.666386088234687, -92.628059387207, -1.6166646160396, 218, 29, 'PPL', 'P'),
(84719, 'Arrowhead', 35.8855590820313, 0.626321159900399, -83.9375, -1.46498574089274, 218, 50, 'PPL', 'P'),
(99501, 'Arrowhead', 36.834171295166, 0.642877566344231, -76.1872177124023, -1.32971779701516, 218, 53, 'PPL', 'P'),
(112972, 'Arrowhead', 33.6586112976074, 0.587453588792211, -86.6680603027344, -1.51264300859971, 218, 2, 'PPL', 'P'),
(154097, 'Arrowhead', 40.5536117553711, 0.707794048706703, -81.248893737793, -1.41806070932749, 218, 41, 'PPL', 'P'),
(189886, 'Arrowhead', 36.6588897705078, 0.63981832662103, -114.574996948242, -1.99971093720928, 218, 39, 'PPL', 'P'),
(194091, 'Arrowhead', 40.5791702270508, 0.708240128189291, -105.023887634277, -1.8330126324627, 218, 7, 'PPL', 'P'),
(44450, 'Arrowhead Acres', 39.6022186279297, 0.691189106152004, -76.0736083984375, -1.32773494042554, 218, 25, 'PPL', 'P'),
(53246, 'Arrowhead Beach', 38.1800003051758, 0.666366713737757, -92.6294403076172, -1.61668871764747, 218, 29, 'PPL', 'P'),
(62582, 'Arrowhead Beach', 36.2230606079102, 0.632211672757491, -76.709716796875, -1.33883712637787, 218, 33, 'PPL', 'P'),
(154098, 'Arrowhead Beach', 41.6988906860352, 0.727782936900511, -81.3891677856445, -1.4205089533176, 218, 41, 'PPL', 'P'),
(179811, 'Arrowhead Equestrian Estates', 34.357780456543, 0.599656392644035, -117.248893737793, -2.04637924004545, 218, 6, 'PPL', 'P'),
(201869, 'Arrowhead Estates', 44.0361099243164, 0.768575107949472, -103.276390075684, -1.80251304639467, 218, 49, 'PPL', 'P'),
(44451, 'Arrowhead Farms Estates', 38.982780456543, 0.680377870548773, -76.6936111450195, -1.33855602972481, 218, 25, 'PPL', 'P'),
(179813, 'Arrowhead Highlands', 34.2299995422363, 0.597426194968176, -117.261940002441, -2.04660694031865, 218, 6, 'PPL', 'P'),
(179814, 'Arrowhead Junction', 34.9427795410156, 0.609866552789236, -114.823608398438, -2.00405002557335, 218, 6, 'PPL', 'P'),
(158777, 'Arrowhead Lake', 41.1508293151855, 0.718217461476191, -75.5741729736328, -1.31901814786161, 218, 45, 'PPL', 'P'),
(114443, 'Arrowhead Mobile Home Park', 41.9861106872559, 0.732795871599394, -92.5908279418945, -1.61601480473362, 218, 16, 'PPL', 'P'),
(122161, 'Arrowhead Park', 41.2788887023926, 0.72045251942104, -85.7900009155273, -1.4973179812649, 218, 19, 'PPL', 'P'),
(84720, 'Arrowhead Point', 35.2077789306641, 0.614491664654376, -84.8186111450195, -1.48036403144935, 218, 50, 'PPL', 'P'),
(193045, 'Arrowhead Ranch', 33.6683311462402, 0.587623232153649, -112.191673278809, -1.95811409203695, 218, 5, 'PPL', 'P'),
(179815, 'Arrowhead Springs', 34.1866683959961, 0.596669923797621, -117.260833740234, -2.04658763240075, 218, 6, 'PPL', 'P'),
(209278, 'Arrowhead Springs', 41.5069389343262, 0.724432746828218, -109.156936645508, -1.90514794585497, 218, 59, 'PPL', 'P'),
(144766, 'Arrowhead Village', 40.0763893127441, 0.699464945818453, -74.1041717529297, -1.293361786552, 218, 37, 'PPL', 'P'),
(79568, 'Arrowood', 34.1733283996582, 0.59643709693932, -79.841667175293, -1.39349997249034, 218, 48, 'PPL', 'P'),
(194092, 'Arrowood', 40.1872215270996, 0.701399332876232, -105.510276794434, -1.84150172475343, 218, 7, 'PPL', 'P'),
(79569, 'Arrowood Estates', 34.7597198486328, 0.606671558429468, -80.7930603027344, -1.41010491504504, 218, 48, 'PPL', 'P'),
(126773, 'Arrowsic', 43.8497200012207, 0.765321990098913, -69.7786102294922, -1.21786649597043, 218, 26, 'PPL', 'P'),
(118658, 'Arrowsmith', 40.4494400024414, 0.705975908630506, -88.6316680908203, -1.54691442971961, 218, 18, 'PPL', 'P'),
(79570, 'Arrowwood', 35.1672210693359, 0.613783796436633, -81.8847198486328, -1.4291579684318, 218, 48, 'PPL', 'P'),
(158783, 'Arroyo', 41.3908309936523, 0.72240628097575, -78.8805618286133, -1.37672551973226, 218, 45, 'PPL', 'P'),
(92337, 'Arroyo Alto', 26.1352806091309, 0.456146697561963, -97.8216705322266, -1.70731023058847, 218, 51, 'PPL', 'P'),
(92338, 'Arroyo Alto Colonia', 26.1350002288818, 0.45614180400346, -97.8219985961914, -1.70731595638481, 218, 51, 'PPL', 'P'),
(92339, 'Arroyo City', 26.3374195098877, 0.459674686926532, -97.4339294433594, -1.70054287194247, 218, 51, 'PPL', 'P'),
(92340, 'Arroyo City Subdivision Colonia', 26.3449993133545, 0.459806979453681, -97.4189987182617, -1.7002822816298, 218, 51, 'PPL', 'P'),
(92341, 'Arroyo Colorado Estates Colonia', 26.1889991760254, 0.457084263423725, -97.6080017089844, -1.70358100611403, 218, 51, 'PPL', 'P'),
(188085, 'Arroyo del Agua', 36.1594390869141, 0.631101267740982, -106.651672363281, -1.8614228354975, 218, 38, 'PPL', 'P'),
(179820, 'Arroyo Fairways Mobile Home Club', 33.7458305358887, 0.5889758516713, -116.911109924316, -2.04048380034034, 218, 6, 'PPL', 'P'),
(92342, 'Arroyo Gardens Number 1 Colonia', 26.1949996948242, 0.457188992233592, -97.5029983520508, -1.70174835180989, 218, 51, 'PPL', 'P'),
(92343, 'Arroyo Gardens Number 2 Colonia', 26.2369995117188, 0.457922027323637, -97.4980010986328, -1.70166113328419, 218, 51, 'PPL', 'P'),
(92344, 'Arroyo Gardens Number 4 Colonia', 26.2439994812012, 0.458044199838644, -97.4800033569336, -1.70134701343362, 218, 51, 'PPL', 'P'),
(179821, 'Arroyo Grande', 35.1186103820801, 0.612935379892361, -120.589721679688, -2.10468768737413, 218, 6, 'PPL', 'P'),
(206712, 'Arroyo Heights', 47.5063896179199, 0.829142914567954, -122.380279541016, -2.13593881750178, 218, 56, 'PPL', 'P'),
(188081, 'Arroyo Hondo', 36.535831451416, 0.637670553780908, -105.669166564941, -1.84427487439653, 218, 38, 'PPL', 'P'),
(179823, 'Arroyo Mobile Home Park', 34.3733291625977, 0.599927768759114, -119.306106567383, -2.08228437733606, 218, 6, 'PPL', 'P'),
(188084, 'Arroyo Seco', 35.9652786254883, 0.627712528411911, -106.029998779297, -1.8505725845843, 218, 38, 'PPL', 'P'),
(179826, 'Arroyo Vista', 38.723331451416, 0.675849631168284, -121.053611755371, -2.11278409656214, 218, 6, 'PPL', 'P'),
(179827, 'Arroz', 38.6208305358887, 0.674060652706023, -121.970001220703, -2.12877810996277, 218, 6, 'PPL', 'P'),
(62584, 'Arrwood Mill', 35.1105613708496, 0.61279489814486, -83.9408264160156, -1.4650437978045, 218, 33, 'PPL', 'P'),
(202912, 'Arsenal', 41.1341705322266, 0.717926710864182, -112.022216796875, -1.95515651848836, 218, 52, 'PPL', 'P'),
(146874, 'Arsenal Hill', 42.8833312988281, 0.748455325388087, -77.2966690063477, -1.34908137498502, 218, 40, 'PPL', 'P'),
(202913, 'Arsenal Villa', 41.1597213745117, 0.718372657188716, -112.033332824707, -1.95535052977378, 218, 52, 'PPL', 'P'),
(99502, 'Arsenic Mine (historical)', 37.0572204589844, 0.646770508646682, -80.2547225952148, -1.40070914956119, 218, 53, 'PPL', 'P'),
(146875, 'Arshamonaque', 41.0894393920898, 0.717146005190625, -72.39111328125, -1.26346327594201, 218, 40, 'PPL', 'P'),
(29116, 'Art', 39.4027786254883, 0.687708221449216, -87.1552810668945, -1.52114661511839, 218, 19, 'PPL', 'P'),
(92346, 'Art', 30.7383308410645, 0.536485079743892, -99.1111068725586, -1.72981514022213, 218, 51, 'PPL', 'P'),
(146876, 'Art Village', 40.8838882446289, 0.713558460886179, -72.4236068725586, -1.26403039609614, 218, 40, 'PPL', 'P'),
(154099, 'Artanna', 40.3219413757324, 0.703750637802663, -82.3105621337891, -1.43659031840199, 218, 41, 'PPL', 'P'),
(169757, 'Artas', 45.8880615234375, 0.80089776094171, -99.8061065673828, -1.74194517319717, 218, 49, 'PPL', 'P'),
(77801, 'Artemas', 39.746940612793, 0.69371498128789, -78.4391708374023, -1.36902179364699, 218, 45, 'PPL', 'P'),
(34590, 'Artemus', 36.8333282470703, 0.642862852379208, -83.841667175293, -1.46331314257012, 218, 21, 'PPL', 'P'),
(44452, 'Arters Mill', 39.6650009155273, 0.692284863782517, -77.0719375610352, -1.34515907133155, 218, 25, 'PPL', 'P'),
(44453, 'Arters Mill Estates', 39.688060760498, 0.692687334002256, -77.0730590820313, -1.34517864556556, 218, 25, 'PPL', 'P'),
(193047, 'Artesa', 31.8994407653809, 0.556750270900796, -111.851669311523, -1.95217990333798, 218, 5, 'PPL', 'P'),
(58490, 'Artesia', 33.4152793884277, 0.583206645801861, -88.6438903808594, -1.54712774892293, 218, 30, 'PPL', 'P'),
(62586, 'Artesia', 34.3222198486328, 0.599035742951992, -78.5752792358398, -1.37139733333934, 218, 33, 'PPL', 'P'),
(179828, 'Artesia', 33.8658294677734, 0.591070228131565, -118.082221984863, -2.0609235617067, 218, 6, 'PPL', 'P'),
(188086, 'Artesia', 32.8422203063965, 0.57320487801196, -104.402778625488, -1.82217223524553, 218, 38, 'PPL', 'P'),
(193048, 'Artesia', 32.6980590820313, 0.57068878999308, -109.706939697266, -1.91474731000416, 218, 5, 'PPL', 'P'),
(18924, 'Artesia (historical)', 31.5499992370605, 0.550651365688406, -83.9674987792969, -1.46550931836305, 218, 13, 'PPL', 'P'),
(189888, 'Artesia (historical)', 38.9538917541504, 0.679873667575394, -119.374443054199, -2.08347707403025, 218, 39, 'PPL', 'P'),
(129568, 'Artesia Beach', 44.3563919067383, 0.774165083077549, -84.4916687011719, -1.47465780933969, 218, 27, 'PPL', 'P'),
(172972, 'Artesia Beach', 43.9347190856934, 0.766805503984142, -88.3150024414063, -1.54138757150937, 218, 57, 'PPL', 'P'),
(92347, 'Artesia Wells', 28.2797203063965, 0.493574230889718, -99.2841720581055, -1.7328356975305, 218, 51, 'PPL', 'P'),
(7166, 'Artesian', 33.401668548584, 0.582969091832626, -92.4688873291016, -1.61388653954849, 218, 4, 'PPL', 'P'),
(114444, 'Artesian', 42.728328704834, 0.745750019773757, -92.3369369506836, -1.61158357099584, 218, 16, 'PPL', 'P'),
(169754, 'Artesian', 44.0091705322266, 0.768104926859019, -97.9205627441406, -1.70903622529095, 218, 49, 'PPL', 'P'),
(206713, 'Artesian', 46.5522193908691, 0.812489502481416, -120.353332519531, -2.10056191821338, 218, 56, 'PPL', 'P'),
(209856, 'Artesian City', 42.4172210693359, 0.740320167206222, -114.160278320313, -1.99247273168256, 218, 17, 'PPL', 'P'),
(212287, 'Artesian Village', 61.2275009155273, 1.06862148374379, -149.781387329102, -2.61417836709774, 218, 1, 'PPL', 'P'),
(7167, 'Artex', 33.3875007629395, 0.582721817325412, -93.8319396972656, -1.63767629125006, 218, 4, 'PPL', 'P'),
(7168, 'Arthur', 35.3013916015625, 0.61612551398314, -92.6427764892578, -1.61692147792674, 218, 4, 'PPL', 'P'),
(26397, 'Arthur', 39.7147216796875, 0.69315265482372, -88.4722213745117, -1.54413155953853, 218, 18, 'PPL', 'P'),
(29118, 'Arthur', 38.3405609130859, 0.669169024994793, -87.2458267211914, -1.52272693490924, 218, 19, 'PPL', 'P'),
(34591, 'Arthur', 37.1755599975586, 0.648835923230093, -86.206672668457, -1.50459027525358, 218, 21, 'PPL', 'P'),
(53247, 'Arthur', 38.0130615234375, 0.663453082347156, -94.3691711425781, -1.64705274881601, 218, 29, 'PPL', 'P'),
(79572, 'Arthur', 33.9716682434082, 0.592917463242672, -81.1377792358398, -1.41612139542169, 218, 48, 'PPL', 'P'),
(84728, 'Arthur', 36.5480613708496, 0.637884006142278, -83.6708297729492, -1.46033146741366, 218, 50, 'PPL', 'P'),
(108025, 'Arthur', 39.0672187805176, 0.681851597316996, -79.1122207641602, -1.38076873089922, 218, 58, 'PPL', 'P'),
(114445, 'Arthur', 42.3347206115723, 0.738880262583843, -95.3472213745117, -1.66412294561314, 218, 16, 'PPL', 'P'),
(139611, 'Arthur', 47.1041717529297, 0.822122888513532, -97.2177810668945, -1.69677037110032, 218, 34, 'PPL', 'P'),
(146877, 'Arthur', 43.4949989318848, 0.759130939512806, -76.2483291625977, -1.33078439303174, 218, 40, 'PPL', 'P'),
(154100, 'Arthur', 41.1947212219238, 0.718983519763753, -84.3608322143555, -1.472374281863, 218, 41, 'PPL', 'P'),
(172973, 'Arthur', 42.8466682434082, 0.747815434357168, -90.4463882446289, -1.57858727140587, 218, 57, 'PPL', 'P'),
(199152, 'Arthur', 41.5716705322266, 0.725562526341657, -101.691108703613, -1.77484466688151, 218, 35, 'PPL', 'P'),
(199815, 'Arthur', 40.7966690063477, 0.71203619800709, -115.190002441406, -2.01044480798285, 218, 39, 'PPL', 'P'),
(202914, 'Arthur', 40.7172203063965, 0.710649556606513, -112.135833740234, -1.95713950823604, 218, 52, 'PPL', 'P'),
(7170, 'Arthur (historical)', 35.4555587768555, 0.618816238790501, -90.600830078125, -1.58128278990319, 218, 4, 'PPL', 'P'),
(195896, 'Arthur (historical)', 48.0611114501953, 0.838824636973855, -105.172218322754, -1.83560149135836, 218, 31, 'PPL', 'P'),
(129569, 'Arthur Bay', 45.3088912963867, 0.79078933355015, -87.4355621337891, -1.5260384425667, 218, 27, 'PPL', 'P'),
(92348, 'Arthur City', 33.8702812194824, 0.591147925856368, -95.5061111450195, -1.66689609525624, 218, 51, 'PPL', 'P'),
(31675, 'Arthur Heights', 37.769718170166, 0.659205939619725, -97.2647171020508, -1.69758955945162, 218, 20, 'PPL', 'P'),
(146883, 'Arthur Manor', 40.9766693115234, 0.715177795987002, -73.793327331543, -1.28793652793735, 218, 40, 'PPL', 'P'),
(44454, 'Arthur Ridge', 39.4172210693359, 0.687960289646392, -77.0277786254883, -1.34438835251208, 218, 25, 'PPL', 'P'),
(53248, 'Arthur Spring Ford', 38.2058296203613, 0.66681752033128, -91.5677795410156, -1.59815924173102, 218, 29, 'PPL', 'P'),
(108026, 'Arthurdale', 39.4949989318848, 0.689317769433033, -79.8152770996094, -1.39303937877981, 218, 58, 'PPL', 'P'),
(34592, 'Arthurmabel', 37.5950012207031, 0.656156553592557, -82.9475021362305, -1.44770701858225, 218, 21, 'PPL', 'P'),
(158779, 'Arthurs', 41.2708282470703, 0.720311837936457, -79.3908309936523, -1.38563139673359, 218, 45, 'PPL', 'P'),
(146879, 'Arthursburg', 41.6283302307129, 0.726551424633431, -73.7719421386719, -1.28756328591057, 218, 40, 'PPL', 'P'),
(79573, 'Arthurtown', 33.9613914489746, 0.592738099343255, -81.0002822875977, -1.41372162096342, 218, 48, 'PPL', 'P'),
(134005, 'Arthyde', 46.3561096191406, 0.809066741269418, -93.0891723632813, -1.62471255569577, 218, 28, 'PPL', 'P'),
(99503, 'Artia', 37.3247184753418, 0.651439229774672, -82.1641693115234, -1.43403528165217, 218, 53, 'PPL', 'P'),
(122162, 'Artic', 41.4736099243164, 0.723851045867118, -84.8147201538086, -1.48029612084155, 218, 19, 'PPL', 'P'),
(206714, 'Artic', 46.8891716003418, 0.818370427958583, -123.713333129883, -2.15920499173304, 218, 56, 'PPL', 'P'),
(134006, 'Artichoke', 45.399169921875, 0.792364992809096, -96.1572189331055, -1.67826006994372, 218, 28, 'PPL', 'P'),
(108027, 'Artie', 37.9324989318848, 0.662046999870621, -81.3597183227539, -1.41999496322721, 218, 58, 'PPL', 'P'),
(99504, 'Artillery Ridge', 38.2516708374023, 0.667617600501767, -77.4786071777344, -1.35225679511078, 218, 53, 'PPL', 'P'),
(75019, 'Artillery Village', 34.6388893127441, 0.604562667741261, -98.4136123657227, -1.71764156456327, 218, 42, 'PPL', 'P'),
(7172, 'Artist Point', 35.7197189331055, 0.623426703269647, -94.1372222900391, -1.64300447764298, 218, 4, 'PPL', 'P'),
(29117, 'Artist Point', 38.160831451416, 0.666032154125816, -86.3705596923828, -1.50745064342238, 218, 19, 'PPL', 'P'),
(202917, 'Artists View Heights', 40.6074981689453, 0.708734544045664, -111.803886413574, -1.95134593444262, 218, 52, 'PPL', 'P'),
(179829, 'Artois', 39.6197204589844, 0.691494570729036, -122.192779541016, -2.13266632515429, 218, 6, 'PPL', 'P'),
(206715, 'Artondale', 47.2997207641602, 0.825535862608523, -122.619438171387, -2.14011292303631, 218, 56, 'PPL', 'P'),
(58491, 'Artonish', 31.1897201538086, 0.544363309459592, -91.583610534668, -1.59843554469412, 218, 30, 'PPL', 'P'),
(99505, 'Artrip', 36.9638900756836, 0.645141586165935, -82.1186065673828, -1.43324006175067, 218, 53, 'PPL', 'P'),
(179830, 'Arts Trailer Court', 34.2236099243164, 0.597314675097529, -119.139717102051, -2.07938033332538, 218, 6, 'PPL', 'P'),
(34593, 'Artville', 37.9236106872559, 0.661891870737124, -83.4627838134766, -1.45670038042539, 218, 21, 'PPL', 'P'),
(58492, 'Arunde', 32.3030586242676, 0.563794731458219, -88.7622222900391, -1.54919303034828, 218, 30, 'PPL', 'P'),
(13299, 'Arundel', 39.7361106872559, 0.693525963429522, -75.6680603027344, -1.32065679088033, 218, 10, 'PPL', 'P'),
(15036, 'Arundel', 27.0877799987793, 0.472770948034564, -80.2986068725586, -1.40147507469069, 218, 12, 'PPL', 'P'),
(44455, 'Arundel', 39.5658302307129, 0.690554008811048, -75.8733291625977, -1.32423940833676, 218, 25, 'PPL', 'P'),
(126775, 'Arundel', 43.3824996948242, 0.757167457420118, -70.4783325195313, -1.23007895378121, 218, 26, 'PPL', 'P'),
(179831, 'Arundel (historical)', 37.4486083984375, 0.653601516842735, -120.598327636719, -2.10483788965961, 218, 6, 'PPL', 'P'),
(44456, 'Arundel Acres', 39.0763893127441, 0.682011653298509, -76.6763916015625, -1.33825549199579, 218, 25, 'PPL', 'P'),
(44457, 'Arundel Beach', 39.0769386291504, 0.682021240678434, -76.5188903808594, -1.33550657711861, 218, 25, 'PPL', 'P'),
(44459, 'Arundel Gardens', 39.2125015258789, 0.684387259569887, -76.6191711425781, -1.33725680658701, 218, 25, 'PPL', 'P'),
(44460, 'Arundel Hills', 39.202220916748, 0.684207829091443, -76.6377792358398, -1.33758157908195, 218, 25, 'PPL', 'P'),
(44463, 'Arundel on the Bay', 38.9205589294434, 0.679291900035266, -76.4630584716797, -1.33453212647575, 218, 25, 'PPL', 'P'),
(44461, 'Arundel View', 39.0705604553223, 0.681909920544868, -76.6788864135742, -1.33829903467962, 218, 25, 'PPL', 'P'),
(186362, 'Arvada', 39.8027801513672, 0.694689565088804, -105.086936950684, -1.83411305062512, 218, 7, 'PPL', 'P'),
(209279, 'Arvada', 44.6536102294922, 0.779352521406859, -106.130561828613, -1.85232774090072, 218, 59, 'PPL', 'P'),
(193072, 'Arvana', 32.8097190856934, 0.572637624699773, -101.914436340332, -1.77874246945295, 218, 51, 'PPL', 'P'),
(34594, 'Arvel', 37.5183296203613, 0.654818381723819, -83.8852767944336, -1.46407427400966, 218, 21, 'PPL', 'P'),
(146880, 'Arverne', 40.5911102294922, 0.70844852054459, -73.79638671875, -1.2879899243172, 218, 40, 'PPL', 'P'),
(108028, 'Arvilla', 39.4352798461914, 0.688275474761403, -81.0711135864258, -1.41495786034144, 218, 58, 'PPL', 'P'),
(139614, 'Arvilla', 47.9191703796387, 0.836347297948836, -97.4944381713867, -1.70159894847274, 218, 34, 'PPL', 'P'),
(179832, 'Arvin', 35.209171295166, 0.614515965999323, -118.827499389648, -2.07393110626092, 218, 6, 'PPL', 'P'),
(99506, 'Arvins Store', 37.019718170166, 0.646115970229767, -78.3430633544922, -1.3673444016344, 218, 53, 'PPL', 'P'),
(108029, 'Arvondale', 38.6944389343262, 0.675345361615878, -80.2666702270508, -1.40091767507454, 218, 58, 'PPL', 'P'),
(31676, 'Arvonia', 38.4805603027344, 0.671612475294941, -95.8694381713867, -1.67323734812783, 218, 20, 'PPL', 'P'),
(99507, 'Arvonia', 37.6833305358887, 0.657698190968577, -78.341667175293, -1.36732003371043, 218, 53, 'PPL', 'P'),
(34595, 'Ary', 37.3663902282715, 0.652166539068373, -83.1508331298828, -1.45125581389284, 218, 21, 'PPL', 'P'),
(206716, 'Arzina', 48.439998626709, 0.845437465697603, -118.117500305176, -2.06153928455072, 218, 56, 'PPL', 'P'),
(34596, 'Asa', 37.7677803039551, 0.659172117473881, -82.904167175293, -1.44695068083267, 218, 21, 'PPL', 'P'),
(58493, 'Asa', 34.2688903808594, 0.59810496815101, -90.0711135864258, -1.57203749302093, 218, 30, 'PPL', 'P'),
(92349, 'Asa', 31.4141693115234, 0.548280686265044, -97.0538864135742, -1.69390986977346, 218, 51, 'PPL', 'P'),
(112835, 'Asahel', 31.8677806854248, 0.556197698264118, -87.4208297729492, -1.52578131436345, 218, 2, 'PPL', 'P'),
(158780, 'Asaph', 41.7708282470703, 0.729038484196428, -77.4052810668945, -1.35097701304894, 218, 45, 'PPL', 'P'),
(112832, 'Asberry', 33.8944396972656, 0.591569570835955, -85.7447204589844, -1.49652768821142, 218, 2, 'PPL', 'P'),
(44464, 'Asberry (historical)', 39.0269393920898, 0.681148589368242, -76.5055618286133, -1.3352739499974, 218, 25, 'PPL', 'P'),
(99508, 'Asberrys', 37.0113906860352, 0.645970628213276, -81.5388870239258, -1.42312204697919, 218, 53, 'PPL', 'P'),
(193199, 'Asbestos (historical)', 42.6666717529297, 0.744673902956284, -122.9375, -2.14566414917053, 218, 43, 'PPL', 'P'),
(194535, 'Asbestos Point', 45.8180618286133, 0.799676035791636, -115.939720153809, -2.02352985052479, 218, 17, 'PPL', 'P'),
(44465, 'Asbury', 38.8569412231445, 0.678181561597785, -75.8569412231445, -1.32395338483569, 218, 25, 'PPL', 'P'),
(53249, 'Asbury', 37.2744407653809, 0.650561718195491, -94.6052780151367, -1.65117359112874, 218, 29, 'PPL', 'P'),
(62590, 'Asbury', 35.7900009155273, 0.624653355267737, -78.7377777099609, -1.37423346674222, 218, 33, 'PPL', 'P'),
(71699, 'Asbury', 39.0605583190918, 0.681735350335414, -84.3422164916992, -1.47204937621001, 218, 41, 'PPL', 'P'),
(79574, 'Asbury', 34.9263916015625, 0.609580529288161, -81.6311111450195, -1.42473166154203, 218, 48, 'PPL', 'P'),
(84727, 'Asbury', 36.3208312988281, 0.633918093225959, -82.3944396972656, -1.43805425805321, 218, 50, 'PPL', 'P'),
(108030, 'Asbury', 37.8197212219238, 0.660078657508944, -80.559440612793, -1.40602748225808, 218, 58, 'PPL', 'P'),
(112839, 'Asbury', 34.378059387207, 0.600010326752907, -86.126106262207, -1.50318412619802, 218, 2, 'PPL', 'P'),
(114446, 'Asbury', 42.5144386291504, 0.742016933715739, -90.7513885498047, -1.58391053095077, 218, 16, 'PPL', 'P'),
(134008, 'Asbury', 44.8788909912109, 0.783284412440252, -95.5336074829102, -1.66737599688467, 218, 28, 'PPL', 'P'),
(144768, 'Asbury', 40.6958312988281, 0.710276248000711, -75.0105590820313, -1.30918122974318, 218, 37, 'PPL', 'P'),
(146882, 'Asbury', 42.1411094665527, 0.735501110634696, -73.9583282470703, -1.2908163371821, 218, 40, 'PPL', 'P'),
(158782, 'Asbury', 42.0719413757324, 0.734293899712564, -80.1822204589844, -1.39944374856924, 218, 45, 'PPL', 'P'),
(18925, 'Asbury (historical)', 33.0222206115723, 0.576346475991872, -81.9263916015625, -1.4298852777255, 218, 13, 'PPL', 'P'),
(71700, 'Asbury (historical)', 39.6824989318848, 0.692590261780522, -82.2930603027344, -1.43628485382496, 218, 41, 'PPL', 'P'),
(84730, 'Asbury Estates', 35.7705612182617, 0.624314068544861, -83.9263916015625, -1.46479186276538, 218, 50, 'PPL', 'P'),
(124124, 'Asbury Grove', 42.6222190856934, 0.743898057551716, -70.8847198486328, -1.23717175071242, 218, 23, 'PPL', 'P'),
(15037, 'Asbury Lake', 30.0488891601563, 0.52445205241156, -81.8216705322266, -1.42805755026937, 218, 12, 'PPL', 'P'),
(112841, 'Asbury Park', 33.4627799987793, 0.584035687849203, -86.7372207641602, -1.51385008636379, 218, 2, 'PPL', 'P'),
(144769, 'Asbury Park', 40.2202796936035, 0.701976306726397, -74.0124969482422, -1.29176175936908, 218, 37, 'PPL', 'P'),
(84729, 'Asbury Prk', 35.8883285522461, 0.626369496274184, -86.4583282470703, -1.50898249368139, 218, 50, 'PPL', 'P'),
(582, 'Asbury Woods', 39.1469383239746, 0.683242965828508, -76.8180618286133, -1.34072810390988, 218, 25, 'PPL', 'P'),
(18926, 'Asbury Woods', 33.8186111450195, 0.59024611293224, -84.8061065673828, -1.48014578539802, 218, 13, 'PPL', 'P'),
(79575, 'Ascaga Heights', 33.5625, 0.585776130200597, -81.897216796875, -1.42937608132507, 218, 48, 'PPL', 'P'),
(18927, 'Ascalon', 34.8394393920898, 0.608062926940979, -85.4247207641602, -1.49094263993136, 218, 13, 'PPL', 'P'),
(53250, 'Ascalon', 38.7008285522461, 0.675456881486525, -90.4094390869141, -1.57794238694791, 218, 29, 'PPL', 'P'),
(191090, 'Ascencion Park Estates Colonia', 31.621000289917, 0.551890567833133, -106.142997741699, -1.85254478852956, 218, 51, 'PPL', 'P'),
(148, 'Asco', 37.5019416809082, 0.654532358222745, -81.626106262207, -1.42464430985827, 218, 58, 'PPL', 'P'),
(179834, 'Asco', 37.6830596923828, 0.657693463857642, -121.871673583984, -2.12706196895633, 218, 6, 'PPL', 'P'),
(114447, 'Ascot', 41.4136085510254, 0.722803824347471, -95.898063659668, -1.67373695714833, 218, 16, 'PPL', 'P'),
(44466, 'Ascot Estates', 39.5205612182617, 0.689763915494648, -76.5647201538086, -1.33630645755202, 218, 25, 'PPL', 'P'),
(171692, 'Ascutney', 43.4069404602051, 0.757594029247721, -72.4075012207031, -1.26374929944308, 218, 55, 'PPL', 'P'),
(70466, 'Aserdaten (historical)', 39.8563919067383, 0.695625266737804, -74.3383331298828, -1.29744867356084, 218, 37, 'PPL', 'P'),
(18928, 'Ash', 33.8036117553711, 0.589984324197086, -84.8502807617188, -1.48091677053359, 218, 13, 'PPL', 'P'),
(53251, 'Ash', 39.5149993896484, 0.689666843272915, -92.2897186279297, -1.61075945579652, 218, 29, 'PPL', 'P'),
(62592, 'Ash', 34.0666694641113, 0.594575547337355, -78.5266723632813, -1.37054898337409, 218, 33, 'PPL', 'P'),
(92350, 'Ash', 31.1949996948242, 0.544455454833309, -95.6919403076172, -1.6701394259898, 218, 51, 'PPL', 'P'),
(108031, 'Ash', 38.8325004577637, 0.677754989770181, -81.9736099243164, -1.43070939292482, 218, 58, 'PPL', 'P'),
(154102, 'Ash', 40.0552787780762, 0.69909649748164, -82.6691665649414, -1.44284914643784, 218, 41, 'PPL', 'P'),
(200343, 'Ash', 43.5525016784668, 0.760134551769602, -123.820556640625, -2.16107639503104, 218, 43, 'PPL', 'P'),
(206717, 'Ash', 46.2533302307129, 0.807272902538168, -118.842216491699, -2.07418796814806, 218, 56, 'PPL', 'P'),
(179835, 'Ash (historical)', 37.0688896179199, 0.646974173891046, -120.303062438965, -2.09968453979226, 218, 6, 'PPL', 'P'),
(129572, 'Ash Acres', 44.0377807617188, 0.768604269563409, -84.8119430541992, -1.48024765130971, 218, 27, 'PPL', 'P'),
(134009, 'Ash Creek', 43.538330078125, 0.759887210683361, -96.1938934326172, -1.67890016071172, 218, 28, 'PPL', 'P'),
(193352, 'Ash Creek Junction', 41.2675018310547, 0.720253781024693, -122.076667785645, -2.13063979272279, 218, 6, 'PPL', 'P'),
(193353, 'Ash Creek Station (historical)', 41.2686080932617, 0.720273088942596, -121.94361114502, -2.12831751625224, 218, 6, 'PPL', 'P'),
(7173, 'Ash Flat', 36.2238883972168, 0.632226120406405, -91.6083297729492, -1.59886697679071, 218, 4, 'PPL', 'P'),
(193049, 'Ash Fork', 35.2249984741211, 0.614792202383392, -112.483329772949, -1.96320445814453, 218, 5, 'PPL', 'P'),
(31678, 'Ash Grove', 39.1613883972168, 0.683495167183738, -98.3616714477539, -1.7167350245282, 218, 20, 'PPL', 'P'),
(53252, 'Ash Grove', 37.3152809143066, 0.651274513261251, -93.5849990844727, -1.63336636449993, 218, 29, 'PPL', 'P'),
(99509, 'Ash Grove', 38.9283294677734, 0.679427521513778, -77.2416687011719, -1.3481214385701, 218, 53, 'PPL', 'P'),
(114449, 'Ash Grove', 40.8708305358887, 0.713330560875896, -92.5527801513672, -1.61535074551581, 218, 16, 'PPL', 'P'),
(122163, 'Ash Grove', 40.547779083252, 0.707692249374035, -86.8477783203125, -1.5157796797316, 218, 19, 'PPL', 'P'),
(146884, 'Ash Grove', 43.0319404602051, 0.751049044552743, -73.331672668457, -1.27987913405931, 218, 40, 'PPL', 'P'),
(53253, 'Ash Hill', 36.7755584716797, 0.641854579590504, -90.2330627441406, -1.57486403904388, 218, 29, 'PPL', 'P'),
(62599, 'Ash Hill', 36.3930587768555, 0.635178700527948, -80.5733337402344, -1.40626996307533, 218, 33, 'PPL', 'P'),
(179836, 'Ash Hill', 34.7069396972656, 0.605750371008409, -116.054168701172, -2.0255273545004, 218, 6, 'PPL', 'P'),
(99510, 'Ash Hollow Estates', 39.1838912963867, 0.683887916865498, -78.1319427490234, -1.36365965195017, 218, 53, 'PPL', 'P'),
(29126, 'Ash Iron Springs', 38.0352783203125, 0.663840838601872, -87.1866683959961, -1.52169442735462, 218, 19, 'PPL', 'P'),
(134011, 'Ash Lake', 48.2188911437988, 0.841578412120024, -92.9158325195313, -1.62168720469744, 218, 28, 'PPL', 'P'),
(18930, 'Ash Manor', 33.639720916748, 0.587123889449259, -84.279167175293, -1.47094895804759, 218, 13, 'PPL', 'P'),
(126777, 'Ash Point', 44.0555610656738, 0.76891459440943, -69.0872192382813, -1.20579944675518, 218, 26, 'PPL', 'P'),
(71702, 'Ash Ridge', 38.9077796936035, 0.679068860293972, -83.7588882446289, -1.46186837767875, 218, 41, 'PPL', 'P'),
(189890, 'Ash Springs', 37.4605598449707, 0.653810108935115, -115.192222595215, -2.01048355697671, 218, 39, 'PPL', 'P'),
(31679, 'Ash Valley', 38.3050003051758, 0.66854837530275, -99.2161102294922, -1.73164779452627, 218, 20, 'PPL', 'P'),
(146885, 'Ashantee', 42.8969383239746, 0.748692812778295, -77.7649993896484, -1.35725528216075, 218, 40, 'PPL', 'P'),
(146886, 'Asharoken', 40.9277801513672, 0.714324519173741, -73.3602828979492, -1.2803784767637, 218, 40, 'PPL', 'P'),
(114450, 'Ashawa', 41.5722198486328, 0.725572113721581, -93.7561111450195, -1.63635283334634, 218, 16, 'PPL', 'P'),
(169263, 'Ashaway', 41.4233283996582, 0.722973467708909, -71.7861099243164, -1.2529039753779, 218, 47, 'PPL', 'P'),
(112836, 'Ashbank', 34.0102806091309, 0.593591376156516, -87.4875030517578, -1.52694498260176, 218, 2, 'PPL', 'P'),
(29119, 'Ashboro', 39.3988914489746, 0.687640377420446, -87.105827331543, -1.52028348460909, 218, 19, 'PPL', 'P'),
(79576, 'Ashborough', 32.9599990844727, 0.575260505478364, -80.1877822875977, -1.39954082079097, 218, 48, 'PPL', 'P'),
(79577, 'Ashborough East', 32.9602813720703, 0.575265432326381, -80.1800003051758, -1.39940499957538, 218, 48, 'PPL', 'P'),
(158785, 'Ashbourne', 40.0675010681152, 0.699309816684956, -75.1305618286133, -1.31127567278247, 218, 45, 'PPL', 'P'),
(13300, 'Ashbourne Hills', 39.8097190856934, 0.694810672339376, -75.4680633544922, -1.31716618563957, 218, 10, 'PPL', 'P'),
(44467, 'Ashbox', 38.6711082458496, 0.674938164285204, -76.7972183227539, -1.34036431610497, 218, 25, 'PPL', 'P'),
(34597, 'Ashbrook', 37.9319381713867, 0.662037212753615, -85.0458297729492, -1.48432974462859, 218, 21, 'PPL', 'P'),
(202919, 'Ashbrook Condominium', 40.625560760498, 0.709049795739702, -111.881942749023, -1.95270827449825, 218, 52, 'PPL', 'P'),
(62593, 'Ashbrook Park', 35.7752799987793, 0.624396426801572, -80.9511108398438, -1.41286341730215, 218, 33, 'PPL', 'P'),
(18929, 'Ashburn', 31.7058296203613, 0.553371118951649, -83.6533279418945, -1.46002600283663, 218, 13, 'PPL', 'P'),
(53255, 'Ashburn', 39.5447196960449, 0.690185560474235, -91.1686096191406, -1.59119241231938, 218, 29, 'PPL', 'P'),
(84731, 'Ashburn', 36.6211090087891, 0.639158927935126, -86.82861328125, -1.51544518669869, 218, 50, 'PPL', 'P'),
(99511, 'Ashburn', 39.0436096191406, 0.681439539717333, -77.4877777099609, -1.35241685109229, 218, 53, 'PPL', 'P'),
(99512, 'Ashburn Farm', 39.0355606079102, 0.681299057969831, -77.5013885498047, -1.35265440506153, 218, 53, 'PPL', 'P'),
(99513, 'Ashburn Junction', 39.0708312988281, 0.681914647655803, -77.4800033569336, -1.35228116303475, 218, 53, 'PPL', 'P'),
(99514, 'Ashburn Village', 39.0436096191406, 0.681439539717333, -77.4744415283203, -1.35218409081302, 218, 53, 'PPL', 'P'),
(124125, 'Ashburnham', 42.6361083984375, 0.744140471789941, -71.908332824707, -1.25503716741105, 218, 23, 'PPL', 'P'),
(44468, 'Ashburton', 39.0127792358398, 0.680901448019083, -77.128059387207, -1.34613858198048, 218, 25, 'PPL', 'P'),
(92351, 'Ashby', 28.8289203643799, 0.503159580153672, -96.1239776611328, -1.67767990030025, 218, 51, 'PPL', 'P'),
(99516, 'Ashby', 39.0108299255371, 0.680867426136157, -78.1355590820313, -1.363722768868, 218, 53, 'PPL', 'P'),
(112843, 'Ashby', 33.0208282470703, 0.576322174646925, -86.9194412231445, -1.51703043333756, 218, 2, 'PPL', 'P'),
(124127, 'Ashby', 42.6777801513672, 0.744867781083641, -71.8208312988281, -1.25350997768395, 218, 23, 'PPL', 'P'),
(134013, 'Ashby', 46.0930595397949, 0.804475651287204, -95.8172225952148, -1.6723260144028, 218, 28, 'PPL', 'P'),
(199155, 'Ashby', 42.0219383239746, 0.733421181823345, -101.927223205566, -1.7789656423523, 218, 35, 'PPL', 'P'),
(206718, 'Ashby', 47.1522216796875, 0.822961517940798, -118.066673278809, -2.06065218559162, 218, 56, 'PPL', 'P'),
(29120, 'Ashby (historical)', 39.3300018310547, 0.686438026767303, -84.9016723632813, -1.48181372318873, 218, 19, 'PPL', 'P'),
(84732, 'Ashby (historical)', 36.292781829834, 0.633428537638575, -83.6816711425781, -1.46052068500911, 218, 50, 'PPL', 'P'),
(99517, 'Ashby Gap Estates', 39.014720916748, 0.680935336743954, -77.9652786254883, -1.36075081424953, 218, 53, 'PPL', 'P'),
(44470, 'Ashby Place', 39.4252815246582, 0.688100971130976, -76.3144378662109, -1.33193820757402, 218, 25, 'PPL', 'P'),
(108032, 'Ashby Ridge Estates', 39.2944412231445, 0.68581737707526, -81.4672164916992, -1.42187116021518, 218, 58, 'PPL', 'P'),
(99520, 'Ashby Run', 39.0688896179199, 0.681880758930932, -77.9236068725586, -1.36002350495583, 218, 53, 'PPL', 'P'),
(29121, 'Ashby Yards', 38.4744415283203, 0.671505682535229, -87.2847213745117, -1.5234057746711, 218, 19, 'PPL', 'P'),
(34598, 'Ashbyburg', 37.5352783203125, 0.6551141923419, -87.3688888549805, -1.52487477432839, 218, 21, 'PPL', 'P'),
(99521, 'Ashbys Corner', 38.6319389343262, 0.674254530833381, -78.2344436645508, -1.36544863041243, 218, 53, 'PPL', 'P'),
(99522, 'Ashcake', 37.6916694641113, 0.657843732722149, -77.4027786254883, -1.35093333720706, 218, 53, 'PPL', 'P'),
(112330, 'Ashcamp', 37.2661094665527, 0.650416309599973, -82.4349975585938, -1.43876212627095, 218, 21, 'PPL', 'P'),
(158784, 'Ashcom', 40.0036087036133, 0.698194684557512, -78.4194412231445, -1.36867744691804, 218, 45, 'PPL', 'P'),
(112844, 'Ashcraft Corner', 33.526668548584, 0.585150753397619, -87.9005584716797, -1.53415415967261, 218, 2, 'PPL', 'P'),
(44471, 'Ashcroft', 39.024169921875, 0.681100252994457, -76.5027770996094, -1.3352253473075, 218, 25, 'PPL', 'P'),
(99523, 'Ashcroft', 38.0311088562012, 0.663768067725085, -78.4361114501953, -1.36896839726713, 218, 53, 'PPL', 'P'),
(124129, 'Ashcroft', 42.2333297729492, 0.737110658618513, -71.1500015258789, -1.24180178942558, 218, 23, 'PPL', 'P'),
(186363, 'Ashcroft', 39.0536117553711, 0.681614109926788, -106.799171447754, -1.86399718016522, 218, 7, 'PPL', 'P'),
(53256, 'Ashcroft Addition', 36.7441711425781, 0.641306767354275, -90.3894424438477, -1.57759337968705, 218, 29, 'PPL', 'P'),
(71703, 'Ashdale', 39.1722183227539, 0.683684185042106, -84.1519393920898, -1.46872841433068, 218, 41, 'PPL', 'P'),
(79580, 'Ashdale', 32.4480590820313, 0.566325466863094, -80.6194381713867, -1.40707463719869, 218, 48, 'PPL', 'P'),
(126778, 'Ashdale', 43.7675018310547, 0.763887012324551, -69.8394393920898, -1.21892816513899, 218, 26, 'PPL', 'P'),
(118664, 'Ashdale Junction', 42.0849990844727, 0.734521799722847, -89.9244384765625, -1.56947752942309, 218, 18, 'PPL', 'P'),
(124130, 'Ashdod', 42.0686111450195, 0.734235776221773, -70.7513885498047, -1.23484468055191, 218, 23, 'PPL', 'P'),
(7174, 'Ashdown', 33.6741714477539, 0.587725164644371, -94.1311111450195, -1.64289781804132, 218, 4, 'PPL', 'P'),
(62596, 'Asheboro', 35.7077789306641, 0.623218310914348, -79.8138885498047, -1.39301514401389, 218, 33, 'PPL', 'P'),
(18931, 'Ashebrook', 33.9752807617188, 0.592980513581479, -84.466667175293, -1.47422145039508, 218, 13, 'PPL', 'P'),
(62598, 'Ashebrook Park', 35.3422203063965, 0.616838109311818, -81.2263870239258, -1.4176678930667, 218, 33, 'PPL', 'P'),
(79578, 'Ashepoo', 32.7400016784668, 0.571420826397716, -80.5505599975586, -1.40587248628263, 218, 48, 'PPL', 'P'),
(79579, 'Ashepoo Crossing', 32.7574996948242, 0.57172622439572, -80.6191711425781, -1.40706997666679, 218, 48, 'PPL', 'P'),
(79597, 'Ashepoo Siding', 32.6366691589355, 0.569617333707514, -80.5008316040039, -1.40500456208338, 218, 48, 'PPL', 'P'),
(7175, 'Asher', 35.9425010681152, 0.62731498504019, -93.8502807617188, -1.63799640321308, 218, 4, 'PPL', 'P'),
(34599, 'Asher', 37.0441703796387, 0.646542741794453, -83.404167175293, -1.45567732709264, 218, 21, 'PPL', 'P'),
(75021, 'Asher', 34.9894409179688, 0.610680947450582, -96.9233322143555, -1.69163126914479, 218, 42, 'PPL', 'P'),
(193051, 'Asher', 32.6755599975586, 0.570296106890348, -114.072776794434, -1.99094554195545, 218, 5, 'PPL', 'P'),
(44472, 'Asher Glade', 39.7038917541504, 0.692963636965351, -79.4475021362305, -1.38662049476245, 218, 25, 'PPL', 'P'),
(34600, 'Ashers Fork', 37.0083312988281, 0.64591723183342, -83.5955581665039, -1.45901773004793, 218, 21, 'PPL', 'P'),
(92352, 'Asherton', 28.4433307647705, 0.496429772079042, -99.7586135864258, -1.74111626430788, 218, 51, 'PPL', 'P'),
(158786, 'Asherton', 40.7880592346191, 0.711885929142582, -76.8241729736328, -1.34083476351154, 218, 45, 'PPL', 'P'),
(29122, 'Asherville', 39.4747200012207, 0.688963835324161, -87.0622177124023, -1.51952235316955, 218, 19, 'PPL', 'P'),
(31715, 'Asherville', 39.4058303833008, 0.687761484671018, -97.9766693115234, -1.71001546962377, 218, 20, 'PPL', 'P'),
(53258, 'Asherville', 36.898609161377, 0.644002219272572, -90.1872177124023, -1.57406389229437, 218, 29, 'PPL', 'P'),
(79581, 'Asheton', 34.8250007629395, 0.607810925322831, -82.2541732788086, -1.43560614722115, 218, 48, 'PPL', 'P'),
(62601, 'Asheville', 35.600830078125, 0.621351701306311, -82.5541687011719, -1.4408420550823, 218, 33, 'PPL', 'P'),
(124131, 'Ashfield', 42.5263900756836, 0.742225525808119, -72.7888870239258, -1.27040573742968, 218, 23, 'PPL', 'P'),
(158787, 'Ashfield', 40.7844390869141, 0.71182274564572, -75.7138900756836, -1.32145667131374, 218, 45, 'PPL', 'P'),
(195897, 'Ashfield', 48.4619407653809, 0.845820428262357, -107.473327636719, -1.87576342533536, 218, 31, 'PPL', 'P'),
(728, 'Ashford', 35.8713912963867, 0.626073885393185, -81.9480590820313, -1.43026344660029, 218, 33, 'PPL', 'P'),
(44473, 'Ashford', 38.6436080932617, 0.674458196077745, -76.9438934326172, -1.34292427970281, 218, 25, 'PPL', 'P'),
(108033, 'Ashford', 38.1791687011719, 0.666352199509816, -81.7111129760742, -1.42612795690156, 218, 58, 'PPL', 'P'),
(112845, 'Ashford', 31.1827793121338, 0.544242168919507, -85.2363891601563, -1.48765563335593, 218, 2, 'PPL', 'P'),
(146887, 'Ashford', 42.3202781677246, 0.738628194386667, -78.6083297729492, -1.37197417403145, 218, 40, 'PPL', 'P'),
(172975, 'Ashford', 43.5869407653809, 0.760735627227633, -88.3705596923828, -1.54235722846227, 218, 57, 'PPL', 'P'),
(177449, 'Ashford', 41.8730583190918, 0.730822735547754, -72.121940612793, -1.25876532662105, 218, 8, 'PPL', 'P'),
(206719, 'Ashford', 46.7586097717285, 0.816091694171857, -122.029716491699, -2.12982033805537, 218, 56, 'PPL', 'P'),
(172976, 'Ashford (historical)', 43.3466682434082, 0.75654208061714, -90.4680633544922, -1.57896557343871, 218, 57, 'PPL', 'P'),
(202920, 'Ashford Acres', 40.5694389343262, 0.708070285090771, -111.981666564941, -1.95444878342868, 218, 52, 'PPL', 'P'),
(146888, 'Ashford Hollow', 42.4033317565918, 0.740077752967998, -78.6855621337891, -1.37332213301719, 218, 40, 'PPL', 'P'),
(179839, 'Ashford Junction', 35.9097213745117, 0.626742871459013, -116.672500610352, -2.03631928218573, 218, 6, 'PPL', 'P'),
(179837, 'Ashford Mill (historical)', 35.9188919067383, 0.626902927440527, -116.683891296387, -2.0365180871611, 218, 6, 'PPL', 'P'),
(18932, 'Ashintilly', 31.3936100006104, 0.54792185859767, -81.4091720581055, -1.42085809373651, 218, 13, 'PPL', 'P'),
(172978, 'Ashippun', 43.2119407653809, 0.754190642532655, -88.51611328125, -1.54489761782609, 218, 57, 'PPL', 'P'),
(118665, 'Ashkum', 40.8802795410156, 0.713495477126399, -87.9550018310547, -1.53510437554955, 218, 18, 'PPL', 'P'),
(13301, 'Ashland', 39.7997207641602, 0.694636168708948, -75.6575012207031, -1.3204725001329, 218, 10, 'PPL', 'P'),
(18934, 'Ashland', 33.9005584716797, 0.591676363595667, -83.5805587768555, -1.45875594131277, 218, 13, 'PPL', 'P'),
(26400, 'Ashland', 39.8877792358398, 0.696173078974033, -90.0077819824219, -1.57093214801049, 218, 18, 'PPL', 'P'),
(29123, 'Ashland', 39.9261093139648, 0.696842065039861, -85.304443359375, -1.48884340320211, 218, 19, 'PPL', 'P'),
(31683, 'Ashland', 37.1886100769043, 0.649063690082322, -99.7652816772461, -1.74123264444752, 218, 20, 'PPL', 'P'),
(34601, 'Ashland', 38.478328704834, 0.671573526563998, -82.6380615234375, -1.44230626104963, 218, 21, 'PPL', 'P'),
(39154, 'Ashland', 31.2858295440674, 0.546040734761692, -91.5811080932617, -1.59839186885224, 218, 22, 'PPL', 'P'),
(44474, 'Ashland', 39.4952812194824, 0.689322696281049, -76.6402816772461, -1.33762525492383, 218, 25, 'PPL', 'P'),
(53261, 'Ashland', 38.7744407653809, 0.676741656975406, -92.2569427490234, -1.61018740879437, 218, 29, 'PPL', 'P'),
(58496, 'Ashland', 31.7999992370605, 0.555014688818391, -91.3480606079102, -1.59432442291937, 218, 30, 'PPL', 'P'),
(62604, 'Ashland', 36.4408302307129, 0.636012469686225, -81.6597213745117, -1.42523100424642, 218, 33, 'PPL', 'P'),
(70467, 'Ashland', 39.8630599975586, 0.69574164687744, -75.0063934326172, -1.30910852544542, 218, 37, 'PPL', 'P'),
(75022, 'Ashland', 34.7677803039551, 0.606812239914051, -96.0694427490234, -1.67672808652665, 218, 42, 'PPL', 'P'),
(79582, 'Ashland', 34.3397216796875, 0.599341207529024, -80.1983337402344, -1.39972497838035, 218, 48, 'PPL', 'P'),
(84734, 'Ashland', 35.4361114501953, 0.618476818909571, -87.6675033569336, -1.53008658058167, 218, 50, 'PPL', 'P'),
(92353, 'Ashland', 32.690559387207, 0.570557895625503, -94.7041702270508, -1.65289958583122, 218, 51, 'PPL', 'P'),
(99524, 'Ashland', 37.7588882446289, 0.659016921761357, -77.4802780151367, -1.35228595672471, 218, 53, 'PPL', 'P'),
(108034, 'Ashland', 37.4083290100098, 0.652898508893981, -81.352783203125, -1.41987392255567, 218, 58, 'PPL', 'P'),
(112846, 'Ashland', 33.273609161377, 0.580734033887777, -85.8361129760742, -1.49812278854632, 218, 2, 'PPL', 'P'),
(114482, 'Ashland', 40.958610534668, 0.714862610871991, -92.2363891601563, -1.60982868099553, 218, 16, 'PPL', 'P'),
(124133, 'Ashland', 42.2611083984375, 0.737595487094962, -71.4638900756836, -1.24728017810398, 218, 23, 'PPL', 'P'),
(126781, 'Ashland', 46.6311111450195, 0.813866423344014, -68.4066696166992, -1.19392161513537, 218, 26, 'PPL', 'P'),
(129575, 'Ashland', 43.3077812194824, 0.755863374013333, -85.8111114501953, -1.49768642960171, 218, 27, 'PPL', 'P'),
(141201, 'Ashland', 41.0391693115234, 0.716268626769498, -96.3680572509766, -1.68193989277994, 218, 35, 'PPL', 'P'),
(143473, 'Ashland', 43.6952781677246, 0.762626471601589, -71.6311111450195, -1.2501987363426, 218, 36, 'PPL', 'P'),
(146891, 'Ashland', 42.3036117553711, 0.738337310616604, -74.3338928222656, -1.29737117557312, 218, 40, 'PPL', 'P'),
(154103, 'Ashland', 40.8686103820801, 0.713291811882035, -82.3183288574219, -1.43672587330147, 218, 41, 'PPL', 'P'),
(158789, 'Ashland', 40.7816696166992, 0.711774409271935, -76.3461074829102, -1.33249094665826, 218, 45, 'PPL', 'P'),
(172979, 'Ashland', 46.5924987792969, 0.813192510430169, -90.8836135864258, -1.58621829319338, 218, 57, 'PPL', 'P'),
(179838, 'Ashland', 37.6947212219238, 0.657896995943951, -122.112777709961, -2.13127002979476, 218, 6, 'PPL', 'P'),
(195898, 'Ashland', 45.5944404602051, 0.795773106635097, -106.270278930664, -1.85476626435285, 218, 31, 'PPL', 'P'),
(200344, 'Ashland', 42.1947212219238, 0.736436812283696, -122.70832824707, -2.14166434752934, 218, 43, 'PPL', 'P'),
(53259, 'Ashland (historical)', 38.4563903808594, 0.671190630578272, -90.6816711425781, -1.58269373264872, 218, 29, 'PPL', 'P'),
(58497, 'Ashland (historical)', 33.7705612182617, 0.589407483504974, -88.4519424438477, -1.54377762542966, 218, 30, 'PPL', 'P'),
(169265, 'Ashland (historical)', 41.7874984741211, 0.72932943454552, -71.6011123657227, -1.24967515887229, 218, 47, 'PPL', 'P'),
(129576, 'Ashland Center', 43.3363914489746, 0.756362716717723, -85.8516693115234, -1.49839429781946, 218, 27, 'PPL', 'P'),
(84735, 'Ashland City', 36.274169921875, 0.633103698564613, -87.0641708374023, -1.5195564416315, 218, 50, 'PPL', 'P'),
(18935, 'Ashland Estates', 33.5724983215332, 0.585950633831024, -84.4544372558594, -1.47400799803371, 218, 13, 'PPL', 'P'),
(201874, 'Ashland Heights', 44.1297187805176, 0.770208890699209, -103.124717712402, -1.79986586427114, 218, 49, 'PPL', 'P'),
(84736, 'Ashland Hills', 36.5063896179199, 0.637156696848577, -87.2966690063477, -1.52361430018445, 218, 50, 'PPL', 'P'),
(172981, 'Ashland Junction', 46.5738906860352, 0.812867737935234, -90.9711074829102, -1.58774534976243, 218, 57, 'PPL', 'P'),
(44475, 'Ashland Landing', 39.1202812194824, 0.682777711586071, -76.0972213745117, -1.32814706460423, 218, 25, 'PPL', 'P'),
(99526, 'Ashland Mill', 37.8063888549805, 0.659845963808698, -77.4733276367188, -1.35216464973706, 218, 53, 'PPL', 'P'),
(34602, 'Ashland Park', 38.0250015258789, 0.663661474702455, -84.4775009155273, -1.47441053483248, 218, 21, 'PPL', 'P'),
(44476, 'Ashlar Hill', 39.3791694641113, 0.687296163849554, -76.5736083984375, -1.33646158668552, 218, 25, 'PPL', 'P'),
(44477, 'Ashleigh', 39.0169410705566, 0.680974085737815, -77.1608276367188, -1.34671049582458, 218, 25, 'PPL', 'P'),
(79583, 'Ashleigh', 33.3008308410645, 0.581209141826247, -81.3177795410156, -1.41926299340161, 218, 48, 'PPL', 'P'),
(13302, 'Ashley', 39.7291717529297, 0.69340485617895, -75.5833282470703, -1.31917793752701, 218, 10, 'PPL', 'P'),
(26402, 'Ashley', 38.3294410705566, 0.668974947130354, -89.1908264160156, -1.55667358353421, 218, 18, 'PPL', 'P'),
(44478, 'Ashley', 38.9216690063477, 0.679311274532196, -76.6188888549805, -1.337251879739, 218, 25, 'PPL', 'P'),
(53260, 'Ashley', 39.2511100769043, 0.685061105904705, -91.2202835083008, -1.59209429182253, 218, 29, 'PPL', 'P'),
(58499, 'Ashley', 31.8019409179688, 0.555048577543263, -90.2630615234375, -1.57538761651419, 218, 30, 'PPL', 'P'),
(75023, 'Ashley', 36.8044395446777, 0.642358649405829, -98.5244369506836, -1.71957581846299, 218, 42, 'PPL', 'P'),
(79584, 'Ashley', 34.9055595397949, 0.609216941220338, -82.0013885498047, -1.43119422140127, 218, 48, 'PPL', 'P'),
(99527, 'Ashley', 37.2158317565918, 0.649538798020792, -77.4766693115234, -1.35222297296493, 218, 53, 'PPL', 'P'),
(108035, 'Ashley', 39.4044418334961, 0.687737249905098, -80.6761093139648, -1.40806373522755, 218, 58, 'PPL', 'P'),
(122180, 'Ashley', 41.5272216796875, 0.724786747516117, -85.065559387207, -1.48467409135753, 218, 19, 'PPL', 'P'),
(129578, 'Ashley', 43.1866683959961, 0.75374955647711, -84.4744415283203, -1.47435713845262, 218, 27, 'PPL', 'P'),
(139617, 'Ashley', 46.0341682434082, 0.803447804264488, -99.3711090087891, -1.73435303356157, 218, 34, 'PPL', 'P'),
(154106, 'Ashley', 40.4088897705078, 0.705268173570817, -82.9555587768555, -1.44784763348781, 218, 41, 'PPL', 'P'),
(158793, 'Ashley', 41.2102813720703, 0.719255095615913, -75.8969421386719, -1.32465153251545, 218, 45, 'PPL', 'P'),
(172984, 'Ashley', 44.6927795410156, 0.780036154858683, -89.6080627441406, -1.56395573121892, 218, 57, 'PPL', 'P'),
(195899, 'Ashley (historical)', 48.1916694641113, 0.841103304181554, -114.331939697266, -1.99546878790889, 218, 31, 'PPL', 'P'),
(18936, 'Ashley Acres', 33.8388900756836, 0.590600047041112, -84.7608337402344, -1.47935562550259, 218, 13, 'PPL', 'P'),
(44480, 'Ashley Acres', 39.3236083984375, 0.686326440317629, -77.2433319091797, -1.34815046702598, 218, 25, 'PPL', 'P'),
(112479, 'Ashley Corner', 38.7694396972656, 0.676654371870679, -82.7863922119141, -1.44489511994529, 218, 41, 'PPL', 'P'),
(53262, 'Ashley Creek', 37.4030609130859, 0.652806563257346, -91.6883316040039, -1.60026327215024, 218, 29, 'PPL', 'P'),
(79586, 'Ashley Creek Village', 33.8813896179199, 0.591341803983726, -80.3836135864258, -1.40295872173398, 218, 48, 'PPL', 'P'),
(58500, 'Ashley Crossing', 33.4174995422363, 0.583245394795722, -90.9888916015625, -1.58805574118748, 218, 30, 'PPL', 'P'),
(79587, 'Ashley Downs', 34.577220916748, 0.603486351186706, -82.6549987792969, -1.44260187193062, 218, 48, 'PPL', 'P'),
(124135, 'Ashley Falls', 42.0561103820801, 0.734017596749468, -73.335563659668, -1.27994704466711, 218, 23, 'PPL', 'P'),
(18942, 'Ashley Forest', 34.0763893127441, 0.594745190698793, -84.5702819824219, -1.4760298699333, 218, 13, 'PPL', 'P'),
(79590, 'Ashley Forest', 32.9655609130859, 0.575357577700098, -80.2002792358398, -1.39975893368425, 218, 48, 'PPL', 'P'),
(18937, 'Ashley Grove', 33.711669921875, 0.588379636482258, -83.8905563354492, -1.46416641938338, 218, 13, 'PPL', 'P'),
(79592, 'Ashley Harbor', 32.8236083984375, 0.572880038937997, -80.0250015258789, -1.39669976054007, 218, 48, 'PPL', 'P'),
(13303, 'Ashley Heights', 39.7252807617188, 0.693336945571153, -75.5794372558594, -1.31911002691921, 218, 10, 'PPL', 'P'),
(62607, 'Ashley Heights', 35.3858299255371, 0.617599240751362, -80.206672668457, -1.39987052013392, 218, 33, 'PPL', 'P'),
(79593, 'Ashley Heights', 32.9324989318848, 0.574780537270905, -80.054443359375, -1.3972136174724, 218, 48, 'PPL', 'P'),
(124136, 'Ashley Heights', 41.7791709899902, 0.729184092529028, -70.9208297729492, -1.23780198778439, 218, 23, 'PPL', 'P'),
(79594, 'Ashley Junction', 32.8688888549805, 0.573670331991478, -79.9958267211914, -1.39619056413965, 218, 48, 'PPL', 'P'),
(44481, 'Ashley Manor', 39.1333312988281, 0.6830054784383, -77.0347213745117, -1.34450952634168, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(44482, 'Ashley Mobile Home Park', 39.4097213745117, 0.687829395278815, -77.0552825927734, -1.34486838729857, 218, 25, 'PPL', 'P'),
(84739, 'Ashley Oaks', 35.9086112976074, 0.626723496962083, -84.102783203125, -1.46787047698551, 218, 50, 'PPL', 'P'),
(18938, 'Ashley Park', 33.5072212219238, 0.584811333516688, -84.476936340332, -1.47440068113644, 218, 13, 'PPL', 'P'),
(79595, 'Ashley Place (historical)', 33.1680603027344, 0.578891858782742, -81.6458282470703, -1.42498852342917, 218, 48, 'PPL', 'P'),
(79596, 'Ashley Retreat', 32.9661102294922, 0.575367165080022, -80.2452774047852, -1.40054429988971, 218, 48, 'PPL', 'P'),
(99528, 'Ashleys', 36.702220916748, 0.640574597791585, -81.914436340332, -1.42967661905409, 218, 53, 'PPL', 'P'),
(195900, 'Ashleys Settlement (historical)', 47.5763893127441, 0.830364639718027, -115.245826721191, -2.01141912546765, 218, 31, 'PPL', 'P'),
(79600, 'Ashleyville', 32.7930603027344, 0.572346874087763, -79.9847183227539, -1.39599668601229, 218, 48, 'PPL', 'P'),
(124137, 'Ashleyville', 42.1583290100098, 0.735801648363712, -72.6333312988281, -1.2676907778564, 218, 23, 'PPL', 'P'),
(18939, 'Ashling Place', 33.0883293151855, 0.577500290534148, -85.0541687011719, -1.48447528638216, 218, 13, 'PPL', 'P'),
(34603, 'Ashlock', 36.624439239502, 0.639217051425917, -85.432502746582, -1.49107846114696, 218, 21, 'PPL', 'P'),
(39158, 'Ashly', 32.4413909912109, 0.566209086723458, -91.1230621337891, -1.59039745873399, 218, 22, 'PPL', 'P'),
(44483, 'Ashmead', 39.1569404602051, 0.683417536037962, -76.9916687011719, -1.34375811544012, 218, 25, 'PPL', 'P'),
(158795, 'Ashmead Village', 40.0616683959961, 0.699208017352287, -75.0994415283203, -1.31073252107815, 218, 45, 'PPL', 'P'),
(189891, 'Ashmeadow (historical)', 36.3616714477539, 0.634630888291719, -116.293327331543, -2.02970146003494, 218, 39, 'PPL', 'P'),
(99529, 'Ashmere', 37.9819412231445, 0.662909930642834, -78.4049987792969, -1.36842537872087, 218, 53, 'PPL', 'P'),
(62611, 'Ashmont', 35.0702781677246, 0.612091823617079, -79.3552780151367, -1.38501088019961, 218, 33, 'PPL', 'P'),
(124138, 'Ashmont', 42.2833290100098, 0.737983309928705, -71.0694427490234, -1.24039577352807, 218, 23, 'PPL', 'P'),
(154108, 'Ashmont (historical)', 41.3761100769043, 0.722149352509584, -82.4400024414063, -1.4388494779547, 218, 41, 'PPL', 'P'),
(195901, 'Ashmoor (historical)', 48.0633316040039, 0.838863385967716, -111.324996948242, -1.94298773651947, 218, 31, 'PPL', 'P'),
(15038, 'Ashmore', 30.0852794647217, 0.525087183042031, -84.4702835083008, -1.47428456731292, 218, 12, 'PPL', 'P'),
(26404, 'Ashmore', 39.5330581665039, 0.689982028387926, -88.022216796875, -1.53627749800973, 218, 18, 'PPL', 'P'),
(191091, 'Ashmore', 32.9152793884277, 0.57447999954189, -102.278060913086, -1.78508891548867, 218, 51, 'PPL', 'P'),
(146894, 'Ashokan', 41.9755592346191, 0.732611714010015, -74.1972198486328, -1.29498578218473, 218, 40, 'PPL', 'P'),
(84737, 'Ashport', 35.7599983215332, 0.6241297112184, -89.7855606079102, -1.56705365335695, 218, 50, 'PPL', 'P'),
(84738, 'Ashport Landing', 35.7602806091309, 0.624134638066417, -89.789436340332, -1.56712129764864, 218, 50, 'PPL', 'P'),
(179840, 'Ashrama', 37.3072204589844, 0.651133831776668, -121.468612670898, -2.12002722893688, 218, 6, 'PPL', 'P'),
(112848, 'Ashridge', 34.2347183227539, 0.597508553224886, -87.4686126708984, -1.52661528325881, 218, 2, 'PPL', 'P'),
(568, 'Ashridge (historical)', 31.0680599212646, 0.542239937832958, -91.6302795410156, -1.59925007251352, 218, 22, 'PPL', 'P'),
(154109, 'Ashtabula', 41.8650016784668, 0.730682120642198, -80.7900009155273, -1.41005151866519, 218, 41, 'PPL', 'P'),
(139619, 'Ashtabula (historical)', 47.1416702270508, 0.822777360351419, -98.0313873291016, -1.71097047919067, 218, 34, 'PPL', 'P'),
(158796, 'Ashtola', 40.1969413757324, 0.70156897623767, -78.7799987792969, -1.37497036341584, 218, 45, 'PPL', 'P'),
(191092, 'Ashtola', 35.0063896179199, 0.610976758068662, -101.043060302734, -1.76353408857389, 218, 51, 'PPL', 'P'),
(7180, 'Ashton', 33.3127784729004, 0.5814176673396, -91.3391723632813, -1.59416929378587, 218, 4, 'PPL', 'P'),
(15039, 'Ashton', 28.2461109161377, 0.492987636370115, -81.2441711425781, -1.41797828449175, 218, 12, 'PPL', 'P'),
(18948, 'Ashton', 31.704719543457, 0.553351744454719, -83.1561126708984, -1.45134795926655, 218, 13, 'PPL', 'P'),
(31685, 'Ashton', 37.0830612182617, 0.647221514977287, -97.2383270263672, -1.69712896574109, 218, 20, 'PPL', 'P'),
(39155, 'Ashton', 29.8358306884766, 0.520733480581483, -91.6080627441406, -1.59886231625881, 218, 22, 'PPL', 'P'),
(44485, 'Ashton', 39.6300010681152, 0.69167400120748, -77.915283203125, -1.35987822951837, 218, 25, 'PPL', 'P'),
(62612, 'Ashton', 34.4752807617188, 0.601707159841451, -77.9013900756836, -1.35963574870111, 218, 33, 'PPL', 'P'),
(71704, 'Ashton', 39.714168548584, 0.693143000864768, -81.4647216796875, -1.42182761753135, 218, 41, 'PPL', 'P'),
(79601, 'Ashton', 33.0158309936523, 0.576234956121224, -80.970832824707, -1.41320763087304, 218, 48, 'PPL', 'P'),
(108036, 'Ashton', 38.6241683959961, 0.674118909354869, -82.1647186279297, -1.43404486903209, 218, 58, 'PPL', 'P'),
(114451, 'Ashton', 43.3113899230957, 0.755926357773114, -95.7908325195313, -1.67186542069228, 218, 16, 'PPL', 'P'),
(118667, 'Ashton', 41.8661117553711, 0.730701495139128, -89.2211074829102, -1.55720208785253, 218, 18, 'PPL', 'P'),
(129579, 'Ashton', 43.9730606079102, 0.767474689787051, -85.5036087036133, -1.49231949421493, 218, 27, 'PPL', 'P'),
(139015, 'Ashton', 40.4461097717285, 0.705917785139715, -91.807502746582, -1.60234320096159, 218, 29, 'PPL', 'P'),
(141203, 'Ashton', 41.2480583190918, 0.71991442772279, -98.7938919067383, -1.72427869463196, 218, 35, 'PPL', 'P'),
(169264, 'Ashton', 41.9388885498047, 0.731971689821042, -71.4311065673828, -1.24670799794378, 218, 47, 'PPL', 'P'),
(169759, 'Ashton', 44.9949989318848, 0.785310878292721, -98.4974975585938, -1.71910563737254, 218, 49, 'PPL', 'P'),
(172985, 'Ashton', 43.1405601501465, 0.752944815774715, -89.541389465332, -1.56279206298061, 218, 57, 'PPL', 'P'),
(189892, 'Ashton', 36.7202796936035, 0.640889782906596, -116.671669006348, -2.03630476795779, 218, 39, 'PPL', 'P'),
(194536, 'Ashton', 44.0716705322266, 0.769195757641515, -111.44750213623, -1.94512585540064, 218, 17, 'PPL', 'P'),
(53277, 'Ashton (historical)', 39.7219390869141, 0.69327862234328, -94.8341674804688, -1.65516846592192, 218, 29, 'PPL', 'P'),
(172986, 'Ashton Corners', 43.1402816772461, 0.752939955505726, -89.5205612182617, -1.56242854149181, 218, 57, 'PPL', 'P'),
(99530, 'Ashton Glen', 38.7605590820313, 0.676499375895236, -77.5033264160156, -1.35268822720737, 218, 53, 'PPL', 'P'),
(44486, 'Ashton Manor', 39.1444396972656, 0.683199356565658, -77.0111083984375, -1.34409740216299, 218, 25, 'PPL', 'P'),
(18943, 'Ashton Place', 33.9113883972168, 0.591865381454036, -83.3363876342773, -1.45449435093643, 218, 13, 'PPL', 'P'),
(44487, 'Ashton Pond', 39.1505584716797, 0.68330614932537, -76.9883270263672, -1.34369979221224, 218, 25, 'PPL', 'P'),
(44488, 'Ashton River Estates', 39.1761093139648, 0.683752095649903, -77.0263900756836, -1.34436411774616, 218, 25, 'PPL', 'P'),
(158797, 'Ashton Wooden Bridge', 40.0716705322266, 0.699382587561742, -75.0233306884766, -1.30940413632642, 218, 45, 'PPL', 'P'),
(77802, 'Ashtree', 39.7727813720703, 0.694165987618495, -80.3627777099609, -1.40259506708713, 218, 45, 'PPL', 'P'),
(206723, 'Ashue', 46.4044418334961, 0.809910297544701, -120.45832824707, -2.10239443935947, 218, 56, 'PPL', 'P'),
(143475, 'Ashuelot', 42.7775001525879, 0.746608223435035, -72.4241714477539, -1.26404024979217, 218, 36, 'PPL', 'P'),
(195902, 'Ashuelot', 47.5572204589844, 0.830030080106086, -111.810562133789, -1.95146244774032, 218, 31, 'PPL', 'P'),
(193052, 'Ashurst', 32.9841690063477, 0.575682350195033, -109.931671142578, -1.91866961365763, 218, 5, 'PPL', 'P'),
(15040, 'Ashville', 30.6163902282715, 0.534356814558756, -83.6466674804688, -1.45990975585505, 218, 12, 'PPL', 'P'),
(34604, 'Ashville', 38.1347198486328, 0.665576420684276, -85.5805587768555, -1.49366252635266, 218, 21, 'PPL', 'P'),
(71705, 'Ashville', 39.7155609130859, 0.693167302209715, -82.9530563354492, -1.44780395764593, 218, 41, 'PPL', 'P'),
(99532, 'Ashville', 38.8805618286133, 0.678593818934529, -77.934440612793, -1.36021258939322, 218, 53, 'PPL', 'P'),
(112850, 'Ashville', 33.8369407653809, 0.590566025158186, -86.2544403076172, -1.50542397783283, 218, 2, 'PPL', 'P'),
(126780, 'Ashville', 44.4877815246582, 0.776458264513189, -68.1216735839844, -1.18894749600937, 218, 26, 'PPL', 'P'),
(146895, 'Ashville', 42.0963897705078, 0.734720604698221, -79.3758316040039, -1.38536960799844, 218, 40, 'PPL', 'P'),
(158798, 'Ashville', 40.560001373291, 0.70790556857735, -78.5488891601563, -1.37093673962881, 218, 45, 'PPL', 'P'),
(39156, 'Ashville (historical)', 32.1527786254883, 0.561171850679627, -91.1791687011719, -1.59137670306681, 218, 22, 'PPL', 'P'),
(172987, 'Ashwaubenon', 44.4822196960449, 0.776361192291455, -88.0699996948242, -1.53711146690508, 218, 57, 'PPL', 'P'),
(58501, 'Ashwood', 31.0447196960449, 0.541832574054717, -91.2969436645508, -1.59343226395419, 218, 30, 'PPL', 'P'),
(62613, 'Ashwood', 35.0738906860352, 0.612154873955886, -76.7163925170898, -1.33895363967556, 218, 33, 'PPL', 'P'),
(79602, 'Ashwood', 34.1088905334473, 0.59531244401098, -80.3166732788086, -1.40179039296376, 218, 48, 'PPL', 'P'),
(84741, 'Ashwood', 36.0652809143066, 0.629457897611322, -86.4630584716797, -1.50906505167519, 218, 50, 'PPL', 'P'),
(92354, 'Ashwood', 29.103889465332, 0.507958696306536, -95.8711090087891, -1.67326650974177, 218, 51, 'PPL', 'P'),
(99536, 'Ashwood', 37.9724998474121, 0.662745147550386, -79.8505630493164, -1.39365523478189, 218, 53, 'PPL', 'P'),
(146896, 'Ashwood', 43.3277816772461, 0.756212447853215, -78.3102798461914, -1.3667722214742, 218, 40, 'PPL', 'P'),
(200345, 'Ashwood', 44.7338905334473, 0.780753677035377, -120.753326416016, -2.10754312869492, 218, 43, 'PPL', 'P'),
(58502, 'Ashwood (historical)', 33.4472198486328, 0.583764111997042, -91.1166687011719, -1.59028587228431, 218, 30, 'PPL', 'P'),
(154112, 'Ashwood (historical)', 41.2558288574219, 0.720050049201302, -84.4572219848633, -1.4740566007236, 218, 41, 'PPL', 'P'),
(79603, 'Ashwood Estates', 34.1277809143066, 0.595642143353932, -79.7744369506836, -1.39232658371405, 218, 48, 'PPL', 'P'),
(44489, 'Ashwood Manor', 38.7402801513672, 0.676145441786365, -76.6680603027344, -1.33811008340028, 218, 25, 'PPL', 'P'),
(99533, 'Ashwoods', 37.6155586242676, 0.656515347970418, -77.7169418334961, -1.35641651957543, 218, 53, 'PPL', 'P'),
(84742, 'Asia', 35.2438888549805, 0.615121901726344, -86.0902786254883, -1.50255881597407, 218, 50, 'PPL', 'P'),
(92355, 'Asia', 30.9979190826416, 0.541015749258876, -94.8691101074219, -1.65577832981154, 218, 51, 'PPL', 'P'),
(18944, 'Aska', 34.7677803039551, 0.606812239914051, -84.2622222900391, -1.47065321400854, 218, 13, 'PPL', 'P'),
(158800, 'Askam', 41.1986083984375, 0.719051363792522, -75.954719543457, -1.32565993846221, 218, 45, 'PPL', 'P'),
(112851, 'Askea Grove', 34.2852783203125, 0.598390991652084, -86.4594421386719, -1.50900193475735, 218, 2, 'PPL', 'P'),
(172990, 'Askeaton', 44.2700004577637, 0.772657267847373, -88.1108322143555, -1.53782412881279, 218, 57, 'PPL', 'P'),
(58503, 'Askew', 34.5369415283203, 0.602783343237952, -90.1933288574219, -1.57417055189603, 218, 30, 'PPL', 'P'),
(7181, 'Askew (historical)', 34.7744407653809, 0.606928486895633, -90.5508270263672, -1.58041007201397, 218, 4, 'PPL', 'P'),
(62614, 'Askewville', 36.1097183227539, 0.63023347669978, -76.9402770996094, -1.34286116278498, 218, 33, 'PPL', 'P'),
(34611, 'Askin', 37.6383285522461, 0.656912758184085, -86.6399993896484, -1.51215325327524, 218, 21, 'PPL', 'P'),
(112448, 'Askin', 35.2202796936035, 0.614709844126681, -77.0669403076172, -1.34507185280585, 218, 33, 'PPL', 'P'),
(134017, 'Askov', 46.1866683959961, 0.80610943403694, -92.7822189331055, -1.61935520768891, 218, 28, 'PPL', 'P'),
(118669, 'Askvig Addition', 41.9438896179199, 0.732058974925769, -89.0741729736328, -1.55463759688084, 218, 18, 'PPL', 'P'),
(206721, 'Asotin', 46.3394393920898, 0.808775790920327, -117.047218322754, -2.04285934003269, 218, 56, 'PPL', 'P'),
(112852, 'Aspel', 34.6208305358887, 0.60424748262625, -86.1655578613281, -1.50387268649786, 218, 2, 'PPL', 'P'),
(44490, 'Aspen', 39.4186096191406, 0.687984524412312, -77.3188934326172, -1.34946926439779, 218, 25, 'PPL', 'P'),
(99534, 'Aspen', 37.040828704834, 0.64648441856658, -78.8269424438477, -1.37578968492521, 218, 53, 'PPL', 'P'),
(186364, 'Aspen', 39.1911087036133, 0.684013884385058, -106.816940307617, -1.86430730527416, 218, 7, 'PPL', 'P'),
(209280, 'Aspen', 41.2058296203613, 0.71917739789111, -110.751106262207, -1.93297145450162, 218, 59, 'PPL', 'P'),
(18945, 'Aspen Acres', 33.5819396972656, 0.586115416923473, -84.4286117553711, -1.47355725801921, 218, 13, 'PPL', 'P'),
(202923, 'Aspen Glen Condominium', 40.6494407653809, 0.7094665804503, -111.883888244629, -1.95274222980215, 218, 52, 'PPL', 'P'),
(34605, 'Aspen Grove', 38.8963890075684, 0.678870055318597, -84.3858337402344, -1.47281064080761, 218, 21, 'PPL', 'P'),
(193225, 'Aspen Grove', 40.4033317565918, 0.705171167928111, -111.601669311523, -1.947816580208, 218, 52, 'PPL', 'P'),
(79604, 'Aspen Heights', 34.2150001525879, 0.597164406233021, -82.1138916015625, -1.43315777007299, 218, 48, 'PPL', 'P'),
(44491, 'Aspen Hill', 39.0794410705566, 0.682064916520311, -77.0733337402344, -1.34518343925553, 218, 25, 'PPL', 'P'),
(84743, 'Aspen Hill', 35.1005592346191, 0.612620327935405, -87.0038909912109, -1.51850435984286, 218, 50, 'PPL', 'P'),
(44492, 'Aspen Hill Park', 39.0719413757324, 0.681934022152734, -77.0947189331055, -1.3455566812823, 218, 25, 'PPL', 'P'),
(44493, 'Aspen Knolls', 39.0833282470703, 0.682132760549081, -77.0886077880859, -1.34545002168064, 218, 25, 'PPL', 'P'),
(13309, 'Aspen Meadows', 38.7347183227539, 0.676048369564631, -75.1308288574219, -1.31128033331438, 218, 10, 'PPL', 'P'),
(186365, 'Aspen Meadows', 39.976390838623, 0.697719643198069, -105.412780761719, -1.83980009797493, 218, 7, 'PPL', 'P'),
(188087, 'Aspen Mountain', 33.6980590820313, 0.588142082513023, -108.964996337891, -1.90179795551976, 218, 38, 'PPL', 'P'),
(44494, 'Aspen Park', 39.1352806091309, 0.683039500321226, -76.5500030517578, -1.33604959566488, 218, 25, 'PPL', 'P'),
(186366, 'Aspen Park', 39.5391693115234, 0.690088687989584, -105.294166564941, -1.83772988970156, 218, 7, 'PPL', 'P'),
(202926, 'Aspen Park Condo', 40.624439239502, 0.70903022150569, -111.807220458984, -1.95140412451244, 218, 52, 'PPL', 'P'),
(44495, 'Aspen Run', 39.5794410705566, 0.690791562780283, -76.899169921875, -1.34214370718731, 218, 25, 'PPL', 'P'),
(179841, 'Aspen Springs', 37.5547218322754, 0.655453545643803, -118.712219238281, -2.07191908805736, 218, 6, 'PPL', 'P'),
(179842, 'Aspen Valley', 37.8274993896484, 0.660214412145511, -119.770278930664, -2.09038571337208, 218, 6, 'PPL', 'P'),
(194537, 'Aspendale', 46.6769409179688, 0.814666303777419, -116.496391296387, -2.03324559481361, 218, 17, 'PPL', 'P'),
(179843, 'Aspendell', 37.2380599975586, 0.649926754012589, -118.597503662109, -2.06991692354984, 218, 6, 'PPL', 'P'),
(53264, 'Aspenhoff', 38.7013893127441, 0.675466668603531, -91.1513900756836, -1.59089187459036, 218, 29, 'PPL', 'P'),
(99535, 'Aspenwall', 37.0205612182617, 0.64613068419479, -78.8238906860352, -1.37573642170341, 218, 53, 'PPL', 'P'),
(44530, 'Aspenwood', 39.1500015258789, 0.683296428787391, -76.8197174072266, -1.34075699920771, 218, 25, 'PPL', 'P'),
(53265, 'Asper', 39.6055603027344, 0.691247429379877, -93.4775009155273, -1.63149016751197, 218, 29, 'PPL', 'P'),
(191093, 'Aspermont', 33.1333312988281, 0.57828572331864, -100.226936340332, -1.74929003832555, 218, 51, 'PPL', 'P'),
(77803, 'Aspers', 39.9794387817383, 0.697772839840844, -77.2230606079102, -1.34779666607517, 218, 45, 'PPL', 'P'),
(177450, 'Aspetuck', 41.2180595397949, 0.71939085025248, -73.3213882446289, -1.27969963700184, 218, 8, 'PPL', 'P'),
(34606, 'Asphalt', 37.1908302307129, 0.649102439076182, -86.3499984741211, -1.50709178246549, 218, 21, 'PPL', 'P'),
(179844, 'Asphalt Mines (historical)', 35.1936111450195, 0.614244390147162, -120.609443664551, -2.10503190094503, 218, 6, 'PPL', 'P'),
(179845, 'Asphalto (historical)', 35.3047218322754, 0.616183637473931, -119.599998474121, -2.08741375875361, 218, 6, 'PPL', 'P'),
(75025, 'Asphaltum', 34.2599983215332, 0.597949772438485, -97.6747207641602, -1.70474547330067, 218, 42, 'PPL', 'P'),
(122164, 'Asphaltum', 41.1002807617188, 0.717335222786075, -86.9980621337891, -1.51840262708922, 218, 19, 'PPL', 'P'),
(108043, 'Aspinall', 38.9261093139648, 0.679388772519918, -80.6044387817383, -1.40681284846354, 218, 58, 'PPL', 'P'),
(18946, 'Aspinwall', 31.4347190856934, 0.548639347484851, -82.1741714477539, -1.43420985186162, 218, 13, 'PPL', 'P'),
(114453, 'Aspinwall', 41.9119415283203, 0.731501375572534, -95.1352767944336, -1.66042381485902, 218, 16, 'PPL', 'P'),
(158801, 'Aspinwall', 40.4913902282715, 0.706708078193196, -79.9049987792969, -1.39460531750078, 218, 45, 'PPL', 'P'),
(31686, 'Assaria', 38.6802787780762, 0.675098220266718, -97.6041717529297, -1.70351416077067, 218, 20, 'PPL', 'P'),
(146897, 'Assembly Park', 42.7797203063965, 0.746646972428896, -76.1305618286133, -1.32872896530242, 218, 40, 'PPL', 'P'),
(129580, 'Assinins', 46.8102798461914, 0.816993507095985, -88.4772186279297, -1.54421877806423, 218, 27, 'PPL', 'P'),
(124139, 'Assinippi', 42.1583290100098, 0.735801648363712, -70.8513870239258, -1.23658998317229, 218, 23, 'PPL', 'P'),
(124140, 'Assonet', 41.7958297729492, 0.729474843141038, -71.0683288574219, -1.24037633245211, 218, 23, 'PPL', 'P'),
(124141, 'Assonet Bay Shores', 41.7958297729492, 0.729474843141038, -71.0902786254883, -1.24075942817492, 218, 23, 'PPL', 'P'),
(26406, 'Assumption', 39.5202789306641, 0.689758988646632, -89.0488891601563, -1.55419631108821, 218, 18, 'PPL', 'P'),
(134019, 'Assumption', 44.688060760498, 0.779953796601972, -93.8886108398438, -1.63866538927891, 218, 28, 'PPL', 'P'),
(141206, 'Assumption', 40.5099983215332, 0.707032850688131, -98.5719375610352, -1.72040486051033, 218, 35, 'PPL', 'P'),
(154113, 'Assumption', 41.6719398498535, 0.727312556072975, -83.9116668701172, -1.46453486772019, 218, 41, 'PPL', 'P'),
(108037, 'Assurance', 37.4955596923828, 0.654420971510152, -80.6730575561523, -1.40801047200575, 218, 58, 'PPL', 'P'),
(129581, 'Assyria', 42.4644393920898, 0.741144282405547, -85.1313934326172, -1.48582311220985, 218, 27, 'PPL', 'P'),
(18947, 'Asta Village', 33.1300010681152, 0.578227599827849, -84.975830078125, -1.48310801947851, 218, 13, 'PPL', 'P'),
(15041, 'Astatula', 28.7094402313232, 0.501074258441113, -81.7330627441406, -1.42651105262437, 218, 12, 'PPL', 'P'),
(179846, 'Asti', 38.7630615234375, 0.676543051737113, -122.971939086914, -2.14626522462856, 218, 6, 'PPL', 'P'),
(172991, 'Astico', 43.3330612182617, 0.756304593226932, -88.9397201538086, -1.55229095248632, 218, 57, 'PPL', 'P'),
(126782, 'Asticou', 44.3038902282715, 0.77324875592548, -68.2822189331055, -1.1917495409503, 218, 26, 'PPL', 'P'),
(92356, 'Astin', 30.7066707611084, 0.535932507107215, -96.5630569458008, -1.685343279495, 218, 51, 'PPL', 'P'),
(77804, 'Aston Mills', 39.8741683959961, 0.695935525004798, -75.4486083984375, -1.31682663260058, 218, 45, 'PPL', 'P'),
(15042, 'Astor', 29.1622200012207, 0.508976756212246, -81.5255584716797, -1.42288941985797, 218, 12, 'PPL', 'P'),
(108038, 'Astor', 39.2402801513672, 0.684872088046336, -80.1413879394531, -1.39873108666153, 218, 58, 'PPL', 'P'),
(114454, 'Astor', 41.8699989318848, 0.730769339167898, -95.2663879394531, -1.66271213602567, 218, 16, 'PPL', 'P'),
(187583, 'Astor', 38.4727783203125, 0.671476654079347, -101.902496337891, -1.77853407709766, 218, 20, 'PPL', 'P'),
(186367, 'Astor City (historical)', 39.5499992370605, 0.690277705847952, -106.408332824707, -1.8571757593491, 218, 7, 'PPL', 'P'),
(15043, 'Astor Farms', 28.8291702270508, 0.503163941079957, -81.3633270263672, -1.42005794698699, 218, 12, 'PPL', 'P'),
(15044, 'Astor Park', 29.1533298492432, 0.508821593789235, -81.5722198486328, -1.42370381451931, 218, 12, 'PPL', 'P'),
(18949, 'Astoria', 31.1483306884766, 0.543640927013908, -82.2919387817383, -1.43626527959094, 218, 13, 'PPL', 'P'),
(53266, 'Astoria', 37.3797187805176, 0.652399166189591, -92.2886123657227, -1.61074014787861, 218, 29, 'PPL', 'P'),
(71714, 'Astoria', 39.5591697692871, 0.690437761829466, -84.466667175293, -1.47422145039508, 218, 41, 'PPL', 'P'),
(118670, 'Astoria', 40.2275009155273, 0.702102340824985, -90.3594436645508, -1.57706980221674, 218, 18, 'PPL', 'P'),
(146898, 'Astoria', 40.7719383239746, 0.711604566173415, -73.9305572509766, -1.29033164186371, 218, 40, 'PPL', 'P'),
(169762, 'Astoria', 44.5583305358887, 0.777689577043187, -96.5469436645508, -1.68506204968389, 218, 49, 'PPL', 'P'),
(200346, 'Astoria', 46.188060760498, 0.806133735381887, -123.830001831055, -2.16124124470251, 218, 43, 'PPL', 'P'),
(158803, 'Astral', 41.3438911437988, 0.721587026045414, -79.772216796875, -1.39228783472019, 218, 45, 'PPL', 'P'),
(179847, 'Asuncion', 35.5149993896484, 0.619853673193142, -120.678329467773, -2.10623418501914, 218, 6, 'PPL', 'P'),
(158804, 'Asylum', 41.7130584716797, 0.728030211407724, -76.3338928222656, -1.332277760613, 218, 45, 'PPL', 'P'),
(179849, 'Asylum', 39.1336097717285, 0.683010338707289, -123.199440002441, -2.15023586465581, 218, 6, 'PPL', 'P'),
(44496, 'Asylum (historical)', 39.2669410705566, 0.6853374088678, -76.7249984741211, -1.33910384196104, 218, 25, 'PPL', 'P'),
(114455, 'Atalissa', 41.5711097717285, 0.725552739224651, -91.1658325195313, -1.59114394278754, 218, 16, 'PPL', 'P'),
(62615, 'Atando Junction', 35.2608299255371, 0.61541757918637, -80.8169403076172, -1.41052169975564, 218, 33, 'PPL', 'P'),
(188088, 'Atarque', 34.7363891601563, 0.606264361098794, -108.702499389648, -1.89721651949649, 218, 38, 'PPL', 'P'),
(179850, 'Atascadero', 35.4894409179688, 0.619407593710554, -120.669723510742, -2.10608398273366, 218, 6, 'PPL', 'P'),
(92357, 'Atascocita', 29.9986095428467, 0.523574507542866, -95.1763916015625, -1.66114140361474, 218, 51, 'PPL', 'P'),
(92358, 'Atascosa', 29.2666702270508, 0.510799756557433, -98.7316665649414, -1.72319265753943, 218, 51, 'PPL', 'P'),
(92360, 'Atascosito', 30.0916690826416, 0.525198702912678, -94.7624969482422, -1.6539175791579, 218, 51, 'PPL', 'P'),
(92361, 'Atascosito Crossing (historical)', 29.6619396209717, 0.517698508913715, -96.4502792358398, -1.68337493713333, 218, 51, 'PPL', 'P'),
(15045, 'Atawalia (historical)', 30.0833301544189, 0.525053161159105, -83.8833312988281, -1.46404031870576, 218, 12, 'PPL', 'P'),
(39159, 'Atchafalaya', 30.3458309173584, 0.529634663761395, -91.7230606079102, -1.60086940761434, 218, 22, 'PPL', 'P'),
(186368, 'Atchee', 39.563060760498, 0.690505672437263, -108.912216186523, -1.9008767680987, 218, 7, 'PPL', 'P'),
(31687, 'Atchison', 39.563060760498, 0.690505672437263, -95.1213912963867, -1.66018146719983, 218, 20, 'PPL', 'P'),
(34607, 'Atchison', 37.3074989318848, 0.651138692045657, -85.3005599975586, -1.48877562575236, 218, 21, 'PPL', 'P'),
(177451, 'Atchison Cove', 41.5741691589355, 0.725606135604507, -73.4847183227539, -1.28255028463266, 218, 8, 'PPL', 'P'),
(53268, 'Atchley (historical)', 37.7366714477539, 0.658629165506641, -92.7063903808594, -1.6180317497852, 218, 29, 'PPL', 'P'),
(18950, 'Atco', 34.1805610656738, 0.59656333077499, -84.8199996948242, -1.48038826621527, 218, 13, 'PPL', 'P'),
(70468, 'Atco', 39.769718170166, 0.694112524659611, -74.8877792358398, -1.30703831717205, 218, 37, 'PPL', 'P'),
(92364, 'Atco', 31.4797191619873, 0.549424746979829, -97.245002746582, -1.69724547903879, 218, 51, 'PPL', 'P'),
(158805, 'Atco', 41.6211090087891, 0.726425390534843, -75.0861129760742, -1.31049989395693, 218, 45, 'PPL', 'P'),
(197954, 'Atcoal', 48.9013900756836, 0.853490265622758, -102.911392211914, -1.79614263190915, 218, 34, 'PPL', 'P'),
(141207, 'Aten', 42.8400001525879, 0.747699054217532, -97.440559387207, -1.70065858629183, 218, 35, 'PPL', 'P'),
(188089, 'Atencio', 36.7713890075684, 0.641781808713718, -103.125282287598, -1.79987571796717, 218, 38, 'PPL', 'P'),
(108039, 'Atenville', 38.0480613708496, 0.664063944922193, -82.1430587768555, -1.43366683331535, 218, 58, 'PPL', 'P'),
(92362, 'Ater', 31.5230598449707, 0.550181184597952, -97.8608322143555, -1.70799373088224, 218, 51, 'PPL', 'P'),
(77806, 'Atglen', 39.9491691589355, 0.697244535259599, -75.9738922119141, -1.32599456465318, 218, 45, 'PPL', 'P'),
(71706, 'Athalia', 38.5161094665527, 0.672232925249902, -82.3066711425781, -1.43652240779419, 218, 41, 'PPL', 'P'),
(201875, 'Athboy', 45.5741691589355, 0.79541930568428, -101.922218322754, -1.77887829066855, 218, 49, 'PPL', 'P'),
(126783, 'Athearns Corner', 44.2730598449707, 0.772710664227229, -69.166389465332, -1.20718122788676, 218, 26, 'PPL', 'P'),
(79605, 'Athelone Heights', 34.7819404602051, 0.60705938126321, -82.3952789306641, -1.4380689054392, 218, 48, 'PPL', 'P'),
(7184, 'Athelstan', 35.6980590820313, 0.62304866755291, -90.1783294677734, -1.57390876316087, 218, 4, 'PPL', 'P'),
(114456, 'Athelstan', 40.5722198486328, 0.708118821201638, -94.5372161865234, -1.64998568812451, 218, 16, 'PPL', 'P'),
(172992, 'Athelstane', 45.4238891601563, 0.792796424905688, -88.0952835083008, -1.53755275269771, 218, 57, 'PPL', 'P'),
(15046, 'Athena', 29.9877796173096, 0.523385489684497, -83.4944381713867, -1.45725285319353, 218, 12, 'PPL', 'P'),
(200347, 'Athena', 45.811939239502, 0.799569176452896, -118.489440917969, -2.06803087286585, 218, 43, 'PPL', 'P'),
(191094, 'Athena West Colonia', 31.6159992218018, 0.551803282728406, -106.221000671387, -1.85390619647881, 218, 51, 'PPL', 'P'),
(84744, 'Athendale', 35.6744384765625, 0.622636410216166, -87.0780563354492, -1.5197987892907, 218, 50, 'PPL', 'P'),
(144771, 'Athenia', 40.8666687011719, 0.713257923157164, -74.1547164916992, -1.29424395866309, 218, 37, 'PPL', 'P'),
(7182, 'Athens', 34.3144416809082, 0.598899988315426, -93.9766693115234, -1.640202299544, 218, 4, 'PPL', 'P'),
(18951, 'Athens', 33.9608306884766, 0.592728312226249, -83.378059387207, -1.45522166023013, 218, 13, 'PPL', 'P'),
(26408, 'Athens', 39.9608306884766, 0.697448067345908, -89.7238922119141, -1.5659773368024, 218, 18, 'PPL', 'P'),
(31691, 'Athens', 37.9069404602051, 0.661600920388033, -95.6136093139648, -1.6687722922442, 218, 20, 'PPL', 'P'),
(34608, 'Athens', 37.9491691589355, 0.662337950219713, -84.3641662597656, -1.47243247193282, 218, 21, 'PPL', 'P'),
(39160, 'Athens', 32.6502799987793, 0.569854887676749, -93.0255584716797, -1.62360228383731, 218, 22, 'PPL', 'P'),
(58504, 'Athens', 33.8722190856934, 0.591181748002212, -88.4416732788086, -1.5435983946883, 218, 30, 'PPL', 'P'),
(71707, 'Athens', 39.3291702270508, 0.686423512539362, -82.1013870239258, -1.43293952402165, 218, 41, 'PPL', 'P'),
(84745, 'Athens', 35.4427795410156, 0.618593199049207, -84.5930633544922, -1.47642747988405, 218, 50, 'PPL', 'P'),
(92363, 'Athens', 32.204719543457, 0.56207839071469, -95.8552780151367, -1.67299020677867, 218, 51, 'PPL', 'P'),
(108040, 'Athens', 37.4222183227539, 0.653140923132206, -81.0163879394531, -1.41400271761648, 218, 58, 'PPL', 'P'),
(112607, 'Athens', 37.9925003051758, 0.663094221390268, -77.4175033569336, -1.35119033225225, 218, 53, 'PPL', 'P'),
(112842, 'Athens', 34.8027801513672, 0.607423102489088, -86.9716720581055, -1.51794203337869, 218, 2, 'PPL', 'P'),
(122165, 'Athens', 41.0536117553711, 0.716520694966674, -86.1252822875977, -1.50316974512813, 218, 19, 'PPL', 'P'),
(126784, 'Athens', 44.9230613708496, 0.784055330996803, -69.6733322143555, -1.21602904797633, 218, 26, 'PPL', 'P'),
(129583, 'Athens', 42.0886116027832, 0.734584850061655, -85.2347183227539, -1.48762647174199, 218, 27, 'PPL', 'P'),
(139018, 'Athens', 40.5825004577637, 0.708298251680082, -91.6983337402344, -1.6004378423597, 218, 29, 'PPL', 'P'),
(146899, 'Athens', 42.2602806091309, 0.737581039446048, -73.8099975585938, -1.28822747828644, 218, 40, 'PPL', 'P'),
(158806, 'Athens', 41.957218170166, 0.732291602046987, -76.5183334350586, -1.33549685658064, 218, 45, 'PPL', 'P'),
(171694, 'Athens', 43.1336097717285, 0.752823508787062, -72.5683288574219, -1.26655627123203, 218, 55, 'PPL', 'P'),
(172994, 'Athens', 45.0330581665039, 0.785975137247614, -90.0738906860352, -1.57208596255277, 218, 57, 'PPL', 'P'),
(179852, 'Athens', 33.9199981689453, 0.592015650318544, -118.280281066895, -2.06438034480162, 218, 6, 'PPL', 'P'),
(202928, 'Athens', 40.7277793884277, 0.710833847353947, -112.066940307617, -1.95593709100387, 218, 52, 'PPL', 'P'),
(141208, 'Athens (historical)', 40.0444412231445, 0.698907346465217, -95.9861068725586, -1.6752736010973, 218, 35, 'PPL', 'P'),
(26411, 'Athensville', 39.4555587768555, 0.688629408870275, -90.1891708374023, -1.57409798075632, 218, 18, 'PPL', 'P'),
(29125, 'Atherton', 39.6080589294434, 0.691291038642727, -87.3619384765625, -1.52475346734073, 218, 19, 'PPL', 'P'),
(39161, 'Atherton', 32.6983299255371, 0.570693517104015, -91.170280456543, -1.59122157393331, 218, 22, 'PPL', 'P'),
(53269, 'Atherton', 39.1861114501953, 0.683926665859358, -94.3052825927734, -1.64593768326759, 218, 29, 'PPL', 'P'),
(71710, 'Atherton', 39.9605598449707, 0.697443340234974, -82.4361114501953, -1.43878156734691, 218, 41, 'PPL', 'P'),
(179853, 'Atherton', 37.4613914489746, 0.653824623163056, -122.196670532227, -2.13273423576209, 218, 6, 'PPL', 'P'),
(34609, 'Athertonville', 37.6355590820313, 0.6568644218103, -85.6041717529297, -1.49407465053135, 218, 21, 'PPL', 'P'),
(39162, 'Athlone', 31.610279083252, 0.551703447477041, -91.7375030517578, -1.60112147581152, 218, 22, 'PPL', 'P'),
(99537, 'Athlone', 38.535831451416, 0.672577138820795, -78.7063903808594, -1.37368565450599, 218, 53, 'PPL', 'P'),
(179854, 'Athlone', 37.2080612182617, 0.64940317654228, -120.356941223145, -2.10062490197316, 218, 6, 'PPL', 'P'),
(71711, 'Athlone (historical)', 39.357780456543, 0.686922855243752, -84.5194396972656, -1.47514250465808, 218, 41, 'PPL', 'P'),
(31693, 'Athol', 39.7649993896484, 0.694030166402901, -98.9191665649414, -1.72646514988692, 218, 20, 'PPL', 'P'),
(34610, 'Athol', 37.5525016784668, 0.655414796649943, -83.5627822875977, -1.45844568304578, 218, 21, 'PPL', 'P'),
(44497, 'Athol', 38.4263916015625, 0.670667053107963, -75.7888870239258, -1.32276561498951, 218, 25, 'PPL', 'P'),
(53271, 'Athol', 39.1072196960449, 0.68254974499676, -94.4830627441406, -1.64904053225364, 218, 29, 'PPL', 'P'),
(124142, 'Athol', 42.5958290100098, 0.743437463841187, -72.2272186279297, -1.26060277461515, 218, 23, 'PPL', 'P'),
(146901, 'Athol', 43.4925003051758, 0.759087330249956, -73.8433303833008, -1.28880924582657, 218, 40, 'PPL', 'P'),
(169764, 'Athol', 45.0088882446289, 0.785553292530945, -98.5961074829102, -1.720826705227, 218, 49, 'PPL', 'P'),
(194538, 'Athol', 47.9480590820313, 0.836851500922215, -116.706939697266, -2.03692035764376, 218, 17, 'PPL', 'P'),
(209281, 'Athol', 41.0127792358398, 0.715808033058969, -104.827781677246, -1.82958993782973, 218, 59, 'PPL', 'P'),
(124143, 'Athol Junction', 42.1277809143066, 0.735268483513478, -72.5625, -1.26645453847839, 218, 23, 'PPL', 'P'),
(146902, 'Athol Springs', 42.769718170166, 0.746472402219441, -78.8666687011719, -1.37648303891501, 218, 40, 'PPL', 'P'),
(18952, 'Athon (historical)', 33.3950004577637, 0.58285271169299, -83.5555572509766, -1.45831958236816, 218, 13, 'PPL', 'P'),
(193057, 'Athos', 34.9500007629395, 0.609992586887824, -114.138610839844, -1.99209456280776, 218, 5, 'PPL', 'P'),
(212288, 'Atka', 52.1961097717285, 0.910993972249048, -174.200561523438, -3.04037335740693, 218, 1, 'PPL', 'P'),
(112854, 'Atkeison', 31.9652805328369, 0.557899391621652, -87.686393737793, -1.53041627992462, 218, 2, 'PPL', 'P'),
(7186, 'Atkins', 35.2463912963867, 0.615165577568221, -92.936393737793, -1.62204606565433, 218, 4, 'PPL', 'P'),
(39163, 'Atkins', 32.309440612793, 0.563906118170812, -93.5147171020508, -1.63213971250184, 218, 22, 'PPL', 'P'),
(79606, 'Atkins', 34.0377807617188, 0.594071344363976, -80.1155624389648, -1.39828034664704, 218, 48, 'PPL', 'P'),
(84746, 'Atkins', 36.523609161377, 0.637457234577593, -87.7305603027344, -1.53118713190215, 218, 50, 'PPL', 'P'),
(99538, 'Atkins', 36.8672218322754, 0.643454407036342, -81.4236068725586, -1.42111002877563, 218, 53, 'PPL', 'P'),
(114458, 'Atkins', 41.996940612793, 0.732984889457762, -91.8619384765625, -1.60329328368048, 218, 16, 'PPL', 'P'),
(129585, 'Atkins', 43.063060760498, 0.751592196257064, -82.5769424438477, -1.44123953187499, 218, 27, 'PPL', 'P'),
(172996, 'Atkins', 45.6652793884277, 0.797009479171166, -89.023063659668, -1.55374557107372, 218, 57, 'PPL', 'P'),
(195903, 'Atkins', 45.6213912963867, 0.796243487462633, -111.196388244629, -1.94074309119469, 218, 31, 'PPL', 'P'),
(199157, 'Atkins', 41.7238883972168, 0.728219229266093, -103.214721679688, -1.80143672984012, 218, 35, 'PPL', 'P'),
(84747, 'Atkins (historical)', 35.7477798461914, 0.623916458594112, -88.5250015258789, -1.54505274695959, 218, 50, 'PPL', 'P'),
(44498, 'Atkins Acres', 39.3791694641113, 0.687296163849554, -77.1158294677734, -1.34592512961911, 218, 25, 'PPL', 'P'),
(7185, 'Atkins Lake', 34.2097206115723, 0.597072260859304, -91.8802795410156, -1.60361339564351, 218, 4, 'PPL', 'P'),
(18953, 'Atkinson', 31.2230606079102, 0.544945210157775, -81.852783203125, -1.42860056881564, 218, 13, 'PPL', 'P'),
(62616, 'Atkinson', 34.5283317565918, 0.602633074373444, -78.17138671875, -1.36434807909195, 218, 33, 'PPL', 'P'),
(118672, 'Atkinson', 41.4208297729492, 0.722929858446059, -90.0149993896484, -1.57105811553005, 218, 18, 'PPL', 'P'),
(122166, 'Atkinson', 40.5627784729004, 0.707954038109189, -87.2466735839844, -1.52274171545329, 218, 19, 'PPL', 'P'),
(134022, 'Atkinson', 46.6122207641602, 0.813536724001062, -92.5652770996094, -1.61556885840909, 218, 28, 'PPL', 'P'),
(141209, 'Atkinson', 42.5313911437988, 0.742312810912847, -98.977783203125, -1.72748820321967, 218, 35, 'PPL', 'P'),
(143476, 'Atkinson', 42.8383293151855, 0.747669892603596, -71.1474990844727, -1.2417581135837, 218, 36, 'PPL', 'P'),
(202929, 'Atkinson', 40.7405586242676, 0.711056887095241, -111.474166870117, -1.94559124280113, 218, 52, 'PPL', 'P'),
(206724, 'Atkinson', 47.4088897705078, 0.82744122121042, -122.015556335449, -2.12957319670622, 218, 56, 'PPL', 'P'),
(143477, 'Atkinson Heights', 42.8233299255371, 0.747408103868441, -71.1658325195313, -1.24207809238867, 218, 36, 'PPL', 'P'),
(126786, 'Atkinson Mills', 45.1597213745117, 0.788185827268489, -69.0827789306641, -1.20572194876746, 218, 26, 'PPL', 'P'),
(158810, 'Atkinson Mills', 40.4552803039551, 0.706077841121229, -77.8183288574219, -1.35818605696173, 218, 45, 'PPL', 'P'),
(29127, 'Atkinsonville', 39.3777809143066, 0.687271929083634, -86.8733291625977, -1.51622562605614, 218, 19, 'PPL', 'P'),
(34612, 'Atkinstown', 37.3830604553223, 0.652457489417464, -83.9627838134766, -1.46542702668537, 218, 21, 'PPL', 'P'),
(192472, 'Atkinville', 37.0299987792969, 0.646295400708212, -113.626937866211, -1.9831641847244, 218, 52, 'PPL', 'P'),
(7187, 'Atlanta', 33.1186103820801, 0.578028794852475, -93.0524978637695, -1.62407246492777, 218, 4, 'PPL', 'P'),
(13304, 'Atlanta', 38.708610534668, 0.675592702702119, -75.6783294677734, -1.32083602162169, 218, 10, 'PPL', 'P'),
(18955, 'Atlanta', 33.7488899230957, 0.589029248051156, -84.3880615234375, -1.47284952295953, 218, 13, 'PPL', 'P'),
(31694, 'Atlanta', 37.4363899230957, 0.653388264218447, -96.7644424438477, -1.68885811950169, 218, 20, 'PPL', 'P'),
(34613, 'Atlanta', 37.2324981689453, 0.649829681790856, -84.0494384765625, -1.46693943586842, 218, 21, 'PPL', 'P'),
(39164, 'Atlanta', 31.8050003051758, 0.555101973923119, -92.7380599975586, -1.61858448886944, 218, 22, 'PPL', 'P'),
(53272, 'Atlanta', 39.898609161377, 0.696362096832401, -92.480827331543, -1.61409493190379, 218, 29, 'PPL', 'P'),
(58505, 'Atlanta', 33.7983283996582, 0.589892112244342, -89.1474990844727, -1.55591737894268, 218, 30, 'PPL', 'P'),
(71712, 'Atlanta', 39.5613899230957, 0.690476510823326, -83.190559387207, -1.45194916788264, 218, 41, 'PPL', 'P'),
(92365, 'Atlanta', 33.1136093139648, 0.577941509747747, -94.1641693115234, -1.64347479189149, 218, 51, 'PPL', 'P'),
(118674, 'Atlanta', 40.2594413757324, 0.702659807020166, -89.2333297729492, -1.55741540705585, 218, 18, 'PPL', 'P'),
(122167, 'Atlanta', 40.2152786254883, 0.70188902162167, -86.0263900756836, -1.50144375042565, 218, 19, 'PPL', 'P'),
(129586, 'Atlanta', 45.0047187805176, 0.785480521654159, -84.1438903808594, -1.46858793258318, 218, 27, 'PPL', 'P'),
(141211, 'Atlanta', 40.3666687011719, 0.704531276897192, -99.4727783203125, -1.73612749779589, 218, 35, 'PPL', 'P'),
(146903, 'Atlanta', 42.5541687011719, 0.742710354284568, -77.4727783203125, -1.35215506235714, 218, 40, 'PPL', 'P'),
(179855, 'Atlanta', 37.813060760498, 0.659962410527362, -121.119720458984, -2.11393791110442, 218, 6, 'PPL', 'P'),
(186369, 'Atlanta', 37.5036087036133, 0.654561453257654, -102.995559692383, -1.79761163156644, 218, 7, 'PPL', 'P'),
(189895, 'Atlanta', 38.4652786254883, 0.671345759711769, -114.330558776855, -1.99544468630103, 218, 39, 'PPL', 'P'),
(194539, 'Atlanta', 43.8016700744629, 0.764483360671647, -115.125831604004, -2.00932481558641, 218, 17, 'PPL', 'P'),
(206725, 'Atlanta (historical)', 48.6091690063477, 0.848390045819147, -122.433326721191, -2.13686466545474, 218, 56, 'PPL', 'P'),
(13305, 'Atlanta Estates', 38.663890838623, 0.674812196765644, -75.6333312988281, -1.32005065541623, 218, 10, 'PPL', 'P'),
(18956, 'Atlanta Junction', 34.2138900756836, 0.597145031736091, -85.1827774047852, -1.48671993170693, 218, 13, 'PPL', 'P'),
(62617, 'Atlantic', 34.8847198486328, 0.608853219994461, -76.3408279418945, -1.33239880128455, 218, 33, 'PPL', 'P'),
(99541, 'Atlantic', 37.9005584716797, 0.661489533675441, -75.508056640625, -1.31786420016128, 218, 53, 'PPL', 'P'),
(114459, 'Atlantic', 41.4036102294922, 0.722629320717044, -95.0136108398438, -1.65830034336385, 218, 16, 'PPL', 'P'),
(124146, 'Atlantic', 42.2669410705566, 0.73769728642763, -70.8483276367188, -1.23653658679244, 218, 23, 'PPL', 'P'),
(126788, 'Atlantic', 44.1716690063477, 0.770941060261899, -68.4247207641602, -1.19423666709233, 218, 26, 'PPL', 'P'),
(143480, 'Atlantic', 42.8711090087891, 0.748242006184772, -70.8616714477539, -1.23676948022976, 218, 36, 'PPL', 'P'),
(158813, 'Atlantic', 40.3574981689453, 0.704371220915679, -79.3197174072266, -1.38439023050756, 218, 45, 'PPL', 'P'),
(108041, 'Atlantic (historical)', 39.3899993896484, 0.687485181707922, -79.7241668701172, -1.39144920529293, 218, 58, 'PPL', 'P'),
(15047, 'Atlantic Beach', 30.3341693878174, 0.529431131675086, -81.3988876342773, -1.42067859667904, 218, 12, 'PPL', 'P'),
(62618, 'Atlantic Beach', 34.6988906860352, 0.605609889260908, -76.7405624389648, -1.33937548439223, 218, 33, 'PPL', 'P'),
(79607, 'Atlantic Beach', 33.8025016784668, 0.589964949700155, -78.716667175293, -1.37386501840541, 218, 48, 'PPL', 'P'),
(146904, 'Atlantic Beach', 40.5888900756836, 0.708409771550729, -73.7294387817383, -1.28682146238893, 218, 40, 'PPL', 'P'),
(70469, 'Atlantic City', 39.3641700744629, 0.687034375114399, -74.4233322143555, -1.29893218744607, 218, 37, 'PPL', 'P'),
(209282, 'Atlantic City', 42.4966697692871, 0.741706808606799, -108.730003356934, -1.89769655428298, 218, 59, 'PPL', 'P'),
(195904, 'Atlantic City (historical)', 46.7855606079102, 0.816562074999392, -112.41667175293, -1.96204105622233, 218, 31, 'PPL', 'P'),
(15048, 'Atlantic Heights', 25.8549995422363, 0.451254870113651, -80.1208267211914, -1.39837222570464, 218, 12, 'PPL', 'P'),
(143481, 'Atlantic Heights', 43.0922203063965, 0.752101126341378, -70.773063659668, -1.23522298258475, 218, 36, 'PPL', 'P'),
(144772, 'Atlantic Highlands', 40.4077796936035, 0.705248799073887, -74.0347213745117, -1.29214964878185, 218, 37, 'PPL', 'P'),
(129587, 'Atlantic Mine', 47.0972213745117, 0.822001581525879, -88.6275024414063, -1.54684172542185, 218, 27, 'PPL', 'P'),
(99542, 'Atlantic Park', 36.8433303833008, 0.643037422588663, -76.0108337402344, -1.32663931595309, 218, 53, 'PPL', 'P'),
(146905, 'Atlantique', 40.6416702270508, 0.709330958971788, -73.1711120605469, -1.27707682280228, 218, 40, 'PPL', 'P'),
(15049, 'Atlantis', 26.5905609130859, 0.464092837885459, -80.1011123657227, -1.3980281452918, 218, 12, 'PPL', 'P'),
(44499, 'Atlantis', 39.0463905334473, 0.6814880758282, -76.4550018310547, -1.3343915115702, 218, 25, 'PPL', 'P'),
(26413, 'Atlas', 39.5138893127441, 0.689647468775985, -90.9694366455078, -1.5877161881485, 218, 18, 'PPL', 'P'),
(31696, 'Atlas', 37.3672218322754, 0.652181053296314, -94.7222213745117, -1.65321463778818, 218, 20, 'PPL', 'P'),
(53273, 'Atlas', 37.0950012207031, 0.647429907332585, -94.3858337402344, -1.64734356600704, 218, 29, 'PPL', 'P'),
(92366, 'Atlas', 33.5686111450195, 0.585882789802255, -95.6166687011719, -1.66882568862406, 218, 51, 'PPL', 'P'),
(108042, 'Atlas', 38.9775009155273, 0.680285725175056, -80.2799987792969, -1.40115030219576, 218, 58, 'PPL', 'P'),
(129588, 'Atlas', 42.9377784729004, 0.749405607844055, -83.5344390869141, -1.4579510008733, 218, 27, 'PPL', 'P'),
(158814, 'Atlas', 40.7997207641602, 0.712089461228892, -76.4280624389648, -1.33392133047974, 218, 45, 'PPL', 'P'),
(172998, 'Atlas', 45.6355590820313, 0.796490761969846, -92.5905609130859, -1.61601014420172, 218, 57, 'PPL', 'P'),
(179856, 'Atlas', 38.4291687011719, 0.670715522639802, -122.246940612793, -2.13361161418321, 218, 6, 'PPL', 'P'),
(194540, 'Atlas', 47.7005615234375, 0.832531853634107, -116.82861328125, -2.03904396229699, 218, 17, 'PPL', 'P'),
(112856, 'Atlas (historical)', 34.9119415283203, 0.609328327932931, -87.5088882446289, -1.52731822462854, 218, 2, 'PPL', 'P'),
(112261, 'Atlas Circle', 34.2830581665039, 0.598352242658224, -83.8574981689453, -1.46358944553321, 218, 13, 'PPL', 'P'),
(202930, 'Atlas Hills', 40.5980606079102, 0.708569827532243, -111.795829772949, -1.95120531953707, 218, 52, 'PPL', 'P'),
(158815, 'Atlasburg', 40.3411102294922, 0.704085197414604, -80.383056640625, -1.402949001196, 218, 45, 'PPL', 'P'),
(75027, 'Atlee', 34.0933303833008, 0.595040868158819, -97.6322174072266, -1.70400364977903, 218, 42, 'PPL', 'P'),
(99543, 'Atlee', 37.6575012207031, 0.657247384375053, -77.4072189331055, -1.35101083519478, 218, 53, 'PPL', 'P'),
(99544, 'Atlee Manor', 37.6594390869141, 0.657281206520897, -77.4124984741211, -1.3511029805685, 218, 53, 'PPL', 'P'),
(99545, 'Atlee Ridge', 37.6797218322754, 0.657635207208796, -77.4266662597656, -1.35135025507571, 218, 53, 'PPL', 'P'),
(99546, 'Atlee Station', 37.6500015258789, 0.657116490007476, -77.4022216796875, -1.35092361666908, 218, 53, 'PPL', 'P'),
(212289, 'Atmautluak', 60.8669395446777, 1.06232850066696, -162.273056030273, -2.83219911500151, 218, 1, 'PPL', 'P'),
(112855, 'Atmore', 31.023609161377, 0.541464125717905, -87.4938888549805, -1.52705643589338, 218, 2, 'PPL', 'P'),
(34614, 'Atoka', 37.6500015258789, 0.657116490007476, -84.8622207641602, -1.48112516288889, 218, 21, 'PPL', 'P'),
(75028, 'Atoka', 34.3858299255371, 0.600145948231419, -96.128059387207, -1.67775113985941, 218, 42, 'PPL', 'P'),
(84752, 'Atoka', 35.4411087036133, 0.618564037435271, -89.7780609130859, -1.56692275898938, 218, 50, 'PPL', 'P'),
(99547, 'Atoka', 38.9755592346191, 0.680251836450185, -77.8097229003906, -1.35803585467625, 218, 53, 'PPL', 'P'),
(188090, 'Atoka', 32.7694396972656, 0.571934616751019, -104.388328552246, -1.8219200338903, 218, 38, 'PPL', 'P'),
(179858, 'Atolia', 35.3147201538086, 0.616358141104358, -117.608329772949, -2.05265258230924, 218, 6, 'PPL', 'P'),
(194541, 'Atomic City', 43.4449996948242, 0.758258288202614, -112.811943054199, -1.96893984186812, 218, 17, 'PPL', 'P'),
(112579, 'Atoy', 31.773889541626, 0.554558988666365, -95.0130615234375, -1.65829075598392, 218, 51, 'PPL', 'P'),
(212290, 'Atqasuk', 70.4694366455078, 1.22992369148966, -157.39582824707, -2.74707543181487, 218, 1, 'PPL', 'P'),
(92367, 'Atreco', 29.9794406890869, 0.523239947930924, -93.8824996948242, -1.63855872967725, 218, 51, 'PPL', 'P'),
(188091, 'Atrisco', 35.0811080932617, 0.612280841475447, -106.686943054199, -1.86203842518347, 218, 38, 'PPL', 'P'),
(70472, 'Atsion', 39.7425003051758, 0.693637483300169, -74.7263870239258, -1.30422149168707, 218, 37, 'PPL', 'P'),
(39165, 'Attakapas Canal', 29.8916702270508, 0.521708064382397, -91.0911102294922, -1.58983979280173, 218, 22, 'PPL', 'P'),
(39166, 'Attakapas Landing', 29.850830078125, 0.520995269316637, -91.1030578613281, -1.59004831831508, 218, 22, 'PPL', 'P'),
(58507, 'Attalaville (historical)', 33.0097198486328, 0.576128296519567, -89.7888870239258, -1.56711171026872, 218, 30, 'PPL', 'P'),
(206726, 'Attalia', 46.1080589294434, 0.804737440022358, -118.918891906738, -2.07552620659582, 218, 56, 'PPL', 'P'),
(112857, 'Attalla', 34.021671295166, 0.593790181131891, -86.0886077880859, -1.50252965436013, 218, 2, 'PPL', 'P'),
(15050, 'Attapulgas (historical)', 30.6166706085205, 0.534361708117259, -84.5666732788086, -1.47596688617352, 218, 12, 'PPL', 'P'),
(18957, 'Attapulgus', 30.7488899230957, 0.536669370491326, -84.48388671875, -1.4745219881241, 218, 13, 'PPL', 'P'),
(177453, 'Attawan Beach', 41.3030586242676, 0.720874364137709, -72.2072219848633, -1.2602537673543, 218, 8, 'PPL', 'P'),
(177452, 'Attawaugan', 41.8672218322754, 0.730720869636059, -71.8816680908203, -1.25457178001056, 218, 8, 'PPL', 'P'),
(79608, 'Attaway', 32.4674987792969, 0.56666475358597, -80.6302795410156, -1.40726385479415, 218, 48, 'PPL', 'P'),
(126789, 'Attean (historical)', 45.5747184753418, 0.795428893064205, -70.3186111450195, -1.22729128991017, 218, 26, 'PPL', 'P'),
(126790, 'Attean Landing', 45.5875015258789, 0.795651999384526, -70.2780609130859, -1.22658355485048, 218, 26, 'PPL', 'P'),
(118676, 'Atterberry', 40.0608291625977, 0.699193369966292, -89.9236068725586, -1.56946301519515, 218, 18, 'PPL', 'P'),
(34615, 'Atterson', 37.3383293151855, 0.651676783743907, -85.0780563354492, -1.48489220425081, 218, 21, 'PPL', 'P'),
(7188, 'Attica', 36.350830078125, 0.634441670696269, -90.9952774047852, -1.5881671944791, 218, 4, 'PPL', 'P'),
(18959, 'Attica', 34.0186080932617, 0.593736718173007, -83.491943359375, -1.45720931050971, 218, 13, 'PPL', 'P'),
(31697, 'Attica', 37.2413902282715, 0.64998487750338, -98.2263870239258, -1.71437386590574, 218, 20, 'PPL', 'P'),
(114460, 'Attica', 41.2297210693359, 0.719594382338789, -93.0158309936523, -1.62343250731782, 218, 16, 'PPL', 'P'),
(122168, 'Attica', 40.2941703796387, 0.703265942484268, -87.248893737793, -1.52278046444715, 218, 19, 'PPL', 'P'),
(129590, 'Attica', 43.0302810668945, 0.751020082675888, -83.1661071777344, -1.45152239631795, 218, 27, 'PPL', 'P'),
(146906, 'Attica', 42.8641700744629, 0.7481208989342, -78.2805633544922, -1.36625357085191, 218, 40, 'PPL', 'P'),
(154115, 'Attica', 41.0647201538086, 0.716714573094032, -82.8877792358398, -1.44666465733159, 218, 41, 'PPL', 'P'),
(172999, 'Attica', 42.7700004577637, 0.746477329067458, -89.4805603027344, -1.56173039381205, 218, 57, 'PPL', 'P'),
(146907, 'Attica Center', 42.815559387207, 0.747272482389928, -78.2347183227539, -1.36545342410239, 218, 40, 'PPL', 'P'),
(154116, 'Attica Junction', 41.0869407653809, 0.717102395927775, -82.8772201538086, -1.44648036658416, 218, 41, 'PPL', 'P'),
(26414, 'Attila', 37.769718170166, 0.659205939619725, -88.771110534668, -1.54934815948178, 218, 18, 'PPL', 'P'),
(34616, 'Attilla', 37.5033302307129, 0.654556592988665, -85.5063934326172, -1.49236809690483, 218, 21, 'PPL', 'P'),
(124147, 'Attleboro', 41.9444389343262, 0.732068562305693, -71.2861099243164, -1.24417732911793, 218, 23, 'PPL', 'P'),
(124148, 'Attleboro Falls', 41.9708290100098, 0.732529156016222, -71.3166732788086, -1.24471076028427, 218, 23, 'PPL', 'P'),
(124150, 'Attleborough City', 41.9249992370605, 0.731729275582817, -71.3499984741211, -1.24529239466634, 218, 23, 'PPL', 'P'),
(146909, 'Attlebury', 41.9172210693359, 0.73159352094625, -73.6688919067383, -1.28576472006839, 218, 40, 'PPL', 'P'),
(99548, 'Attoway', 36.8133316040039, 0.642513845118354, -81.4674987792969, -1.42187608706319, 218, 53, 'PPL', 'P'),
(92368, 'Attoyac', 31.5586109161377, 0.550801667842427, -94.357780456543, -1.64685394384063, 218, 51, 'PPL', 'P'),
(2, 'Attu', 52.9375, 0.923933672774498, 173.237503051758, 3.0235648161869, 218, 1, 'PPL', 'P'),
(18960, 'Atwater', 32.9683303833008, 0.575405914073883, -84.3694381713867, -1.47252448414848, 218, 13, 'PPL', 'P'),
(26415, 'Atwater', 39.3327789306641, 0.686486496299142, -89.7249984741211, -1.5659966447203, 218, 18, 'PPL', 'P'),
(134025, 'Atwater', 45.1388893127441, 0.787822239200666, -94.7777786254883, -1.65418429474108, 218, 28, 'PPL', 'P'),
(154117, 'Atwater', 41.0238914489746, 0.716001977765354, -81.1636123657227, -1.41657226859424, 218, 41, 'PPL', 'P'),
(173000, 'Atwater', 43.5608291625977, 0.760279893786093, -88.7344436645508, -1.54870820187183, 218, 57, 'PPL', 'P'),
(179860, 'Atwater', 37.3477783203125, 0.651841699994411, -120.608062744141, -2.10500779933716, 218, 6, 'PPL', 'P'),
(154118, 'Atwater Center', 41.023609161377, 0.715997050917338, -81.148063659668, -1.41630089247917, 218, 41, 'PPL', 'P'),
(146910, 'Atwaters', 42.6308288574219, 0.744048326416224, -76.6500015258789, -1.33779489828526, 218, 40, 'PPL', 'P'),
(58508, 'Atway', 34.8658294677734, 0.608523520651509, -89.4127807617188, -1.56054741765584, 218, 30, 'PPL', 'P'),
(18961, 'Atwell', 33.1405601501465, 0.578411890575283, -82.2863922119141, -1.43616847368532, 218, 13, 'PPL', 'P'),
(53274, 'Atwell', 38.038330078125, 0.663894101823673, -92.2125015258789, -1.60941176312688, 218, 29, 'PPL', 'P'),
(92369, 'Atwell', 32.2611083984375, 0.563062561895529, -99.1338882446289, -1.73021275017288, 218, 51, 'PPL', 'P'),
(108044, 'Atwell', 37.3491706848145, 0.651866001339357, -81.7627792358398, -1.42702970324666, 218, 58, 'PPL', 'P'),
(146911, 'Atwell', 43.5238914489746, 0.759635209065213, -74.9447174072266, -1.30803207573281, 218, 40, 'PPL', 'P'),
(146912, 'Atwell Corners', 42.9247207641602, 0.749177707833771, -75.9066696166992, -1.32482130903494, 218, 40, 'PPL', 'P'),
(158816, 'Atwells Crossing', 41.1049995422363, 0.717417581042786, -79.9205627441406, -1.39487695993197, 218, 45, 'PPL', 'P'),
(7189, 'Atwood', 34.098331451416, 0.595128153263546, -94.0725021362305, -1.64187489786662, 218, 4, 'PPL', 'P'),
(26416, 'Atwood', 39.7994384765625, 0.694631241860932, -88.4622192382813, -1.54395698932908, 218, 18, 'PPL', 'P'),
(34617, 'Atwood', 38.8722190856934, 0.678448210601929, -84.538330078125, -1.47547220400104, 218, 21, 'PPL', 'P'),
(62621, 'Atwood', 36.0497207641602, 0.629186321759161, -80.3266677856445, -1.40196483001516, 218, 33, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(75030, 'Atwood', 34.9561080932617, 0.610099179910454, -96.3383331298828, -1.68142110899959, 218, 42, 'PPL', 'P'),
(84748, 'Atwood', 35.9730606079102, 0.627848349627505, -88.6780624389648, -1.54772416384905, 218, 50, 'PPL', 'P'),
(108045, 'Atwood', 39.5113906860352, 0.689603859513135, -80.7425003051758, -1.40922247661784, 218, 58, 'PPL', 'P'),
(112858, 'Atwood', 34.3605613708496, 0.599704928754902, -87.995002746582, -1.53580252322931, 218, 2, 'PPL', 'P'),
(114461, 'Atwood', 41.3250007629395, 0.721257326702462, -92.4058303833008, -1.61278598822801, 218, 16, 'PPL', 'P'),
(122169, 'Atwood', 41.2608299255371, 0.720137334306029, -85.9752807617188, -1.50055172461853, 218, 19, 'PPL', 'P'),
(129592, 'Atwood', 45.1791687011719, 0.788525247149419, -85.3452835083008, -1.48955619826787, 218, 27, 'PPL', 'P'),
(134027, 'Atwood', 44.8630599975586, 0.783008109477157, -93.3636093139648, -1.62950238407433, 218, 28, 'PPL', 'P'),
(146913, 'Atwood', 41.8927803039551, 0.731166949118647, -74.1602783203125, -1.29434103088482, 218, 40, 'PPL', 'P'),
(158817, 'Atwood', 40.7547187805176, 0.7113040284444, -79.2666702270508, -1.3834643825546, 218, 45, 'PPL', 'P'),
(173001, 'Atwood', 44.8861083984375, 0.783410379959813, -90.4816665649414, -1.5792029942499, 218, 57, 'PPL', 'P'),
(179862, 'Atwood', 33.8655586242676, 0.59106550102063, -117.830001831055, -2.05652148958285, 218, 6, 'PPL', 'P'),
(187584, 'Atwood', 39.8066711425781, 0.694757475696601, -101.04167175293, -1.76350985380797, 218, 20, 'PPL', 'P'),
(194093, 'Atwood', 40.547779083252, 0.707692249374035, -103.269172668457, -1.80238707887511, 218, 7, 'PPL', 'P'),
(202932, 'Atwood', 40.6327781677246, 0.709175763259263, -111.897499084473, -1.95297978377139, 218, 52, 'PPL', 'P'),
(206727, 'Atwood', 47.1005592346191, 0.822059838174724, -119.123062133789, -2.0790896492924, 218, 56, 'PPL', 'P'),
(99549, 'Atwood (historical)', 36.6399993896484, 0.639488627278078, -80.2119369506836, -1.39996239919153, 218, 53, 'PPL', 'P'),
(154120, 'Atwood (historical)', 40.5525016784668, 0.707774674209772, -81.2425003051758, -1.41794912287782, 218, 41, 'PPL', 'P'),
(189897, 'Atwood (historical)', 38.7480583190918, 0.676281196422932, -117.855278015137, -2.05696264221742, 218, 39, 'PPL', 'P'),
(62622, 'Atwood Acres', 36.0491714477539, 0.629176734379237, -80.3055572509766, -1.40159638167835, 218, 33, 'PPL', 'P'),
(154121, 'Atwood Cove', 40.5466690063477, 0.707672874877104, -81.2441711425781, -1.41797828449175, 218, 41, 'PPL', 'P'),
(154122, 'Atwood Crossing', 40.5486106872559, 0.707706763601975, -81.2372207641602, -1.4178569775041, 218, 41, 'PPL', 'P'),
(154123, 'Atwood Pines', 40.5530586242676, 0.707784394747751, -81.2302780151367, -1.4177358036745, 218, 41, 'PPL', 'P'),
(154124, 'Atwood Valley', 40.5550003051758, 0.707818283472623, -81.2163925170898, -1.4174934560153, 218, 41, 'PPL', 'P'),
(154125, 'Atwood Village', 40.535831451416, 0.707483723860681, -81.2486114501953, -1.41805578247947, 218, 41, 'PPL', 'P'),
(177454, 'Atwoodville', 41.7847213745117, 0.72928096501368, -72.1750030517578, -1.25969144089013, 218, 8, 'PPL', 'P'),
(129593, 'Au Gres', 44.0486106872559, 0.768793287421777, -83.6958312988281, -1.46076782635827, 218, 27, 'PPL', 'P'),
(129596, 'Au Sable', 44.410831451416, 0.775115232375462, -83.3322219848633, -1.45442164663867, 218, 27, 'PPL', 'P'),
(146914, 'Au Sable Forks', 44.4416694641113, 0.775653457231767, -73.6750030517578, -1.28587137967004, 218, 40, 'PPL', 'P'),
(129600, 'Au Sable River Park', 44.4033317565918, 0.774984338007884, -84.4602813720703, -1.47410999710346, 218, 27, 'PPL', 'P'),
(129599, 'Au Train', 46.4302787780762, 0.810361237296279, -86.836669921875, -1.51558580160425, 218, 27, 'PPL', 'P'),
(179863, 'Auberry', 37.0808296203613, 0.647182566246344, -119.484443664551, -2.08539694686009, 218, 6, 'PPL', 'P'),
(39167, 'Aubin', 30.4191703796387, 0.530914678849828, -91.0630569458008, -1.58935017063532, 218, 22, 'PPL', 'P'),
(7206, 'Aubrey', 34.7166709899902, 0.605920214106929, -90.9002838134766, -1.58650924354247, 218, 4, 'PPL', 'P'),
(18963, 'Aubrey', 33.1988906860352, 0.579429950480993, -85.1361083984375, -1.48590540388753, 218, 13, 'PPL', 'P'),
(39168, 'Aubrey', 31.9319400787354, 0.557317490923469, -91.320556640625, -1.59384438813288, 218, 22, 'PPL', 'P'),
(58509, 'Aubrey', 33.1474990844727, 0.578532997825854, -88.3322219848633, -1.54168810923839, 218, 30, 'PPL', 'P'),
(92370, 'Aubrey', 33.3041687011719, 0.581267398475093, -96.9858322143555, -1.69272209992729, 218, 51, 'PPL', 'P'),
(112859, 'Aubrey', 32.6669387817383, 0.570145638288758, -85.4524993896484, -1.49142746840781, 218, 2, 'PPL', 'P'),
(173002, 'Aubrey', 43.3147201538086, 0.755984481263905, -90.293327331543, -1.57591585451641, 218, 57, 'PPL', 'P'),
(195905, 'Aubrey Crossing', 48.3377799987793, 0.843653414083359, -112.410278320313, -1.96192946977265, 218, 31, 'PPL', 'P'),
(112860, 'Aubrey Isle', 34.1527786254883, 0.596078435719514, -85.7750015258789, -1.49705619252975, 218, 2, 'PPL', 'P'),
(31699, 'Aubry', 38.7708282470703, 0.676678606636599, -94.6708297729492, -1.65231768513304, 218, 20, 'PPL', 'P'),
(13306, 'Auburn', 39.8083305358887, 0.694786437573456, -75.6888885498047, -1.32102031236913, 218, 10, 'PPL', 'P'),
(15051, 'Auburn', 30.8199996948242, 0.53791047013833, -86.5377807617188, -1.510369201661, 218, 12, 'PPL', 'P'),
(18964, 'Auburn', 34.0136108398438, 0.593649499647307, -83.8277816772461, -1.46307079491092, 218, 13, 'PPL', 'P'),
(26417, 'Auburn', 39.5916709899902, 0.691005015141653, -89.7463912963867, -1.56637001990513, 218, 18, 'PPL', 'P'),
(31701, 'Auburn', 38.9061088562012, 0.679039698680036, -95.8158264160156, -1.67230164647883, 218, 20, 'PPL', 'P'),
(34618, 'Auburn', 36.8641700744629, 0.643401143814541, -86.7102813720703, -1.51337990527333, 218, 21, 'PPL', 'P'),
(44500, 'Auburn', 38.6822204589844, 0.675132108991589, -77.023063659668, -1.3443060608344, 218, 25, 'PPL', 'P'),
(53275, 'Auburn', 39.1266708374023, 0.682889231456718, -90.9738922119141, -1.58779395245233, 218, 29, 'PPL', 'P'),
(58511, 'Auburn', 31.3591709136963, 0.547320783139639, -90.607780456543, -1.58140409689085, 218, 30, 'PPL', 'P'),
(62624, 'Auburn', 35.6930618286133, 0.62296144902721, -78.5555572509766, -1.37105311976845, 218, 33, 'PPL', 'P'),
(70473, 'Auburn', 39.7108306884766, 0.693084744215923, -75.3680572509766, -1.31542074986113, 218, 37, 'PPL', 'P'),
(71713, 'Auburn', 39.3911094665527, 0.687504556204852, -84.7022171020508, -1.47833257216984, 218, 41, 'PPL', 'P'),
(79609, 'Auburn', 34.3752784729004, 0.59996179064204, -79.9761123657227, -1.39584648372681, 218, 48, 'PPL', 'P'),
(92371, 'Auburn', 32.2972183227539, 0.563692798967496, -97.0769424438477, -1.69431227341417, 218, 51, 'PPL', 'P'),
(99553, 'Auburn', 38.7027816772461, 0.675490969948478, -77.7011108398438, -1.35614021661233, 218, 53, 'PPL', 'P'),
(108046, 'Auburn', 39.0955581665039, 0.682346212910451, -80.8563919067383, -1.41121026005548, 218, 58, 'PPL', 'P'),
(112861, 'Auburn', 32.6097183227539, 0.569146952879979, -85.480827331543, -1.49192188426418, 218, 2, 'PPL', 'P'),
(114462, 'Auburn', 42.2513885498047, 0.737425843733524, -94.8775024414063, -1.6559248036715, 218, 16, 'PPL', 'P'),
(122171, 'Auburn', 41.3669395446777, 0.72198929652807, -85.0588912963867, -1.4845577112179, 218, 19, 'PPL', 'P'),
(124151, 'Auburn', 42.1944389343262, 0.736431885435679, -71.8361129760742, -1.25377669326712, 218, 23, 'PPL', 'P'),
(126791, 'Auburn', 44.0977783203125, 0.769651424504028, -70.2316665649414, -1.22577382072104, 218, 26, 'PPL', 'P'),
(129602, 'Auburn', 43.603328704834, 0.761021650728708, -84.0697174072266, -1.46729336997729, 218, 27, 'PPL', 'P'),
(139623, 'Auburn', 48.5069389343262, 0.846605794467821, -97.4394378662109, -1.70063901205782, 218, 34, 'PPL', 'P'),
(141214, 'Auburn', 40.3927803039551, 0.704987010338732, -95.8386077880859, -1.67269925642958, 218, 35, 'PPL', 'P'),
(143482, 'Auburn', 43.0044403076172, 0.750569076345283, -71.3488922119141, -1.24527308674844, 218, 36, 'PPL', 'P'),
(146916, 'Auburn', 42.9316711425781, 0.749299014821424, -76.5663909912109, -1.33633561916596, 218, 40, 'PPL', 'P'),
(158819, 'Auburn', 40.598331451416, 0.708574554643178, -76.0936126708984, -1.32808408084445, 218, 45, 'PPL', 'P'),
(169266, 'Auburn', 41.7738914489746, 0.729091947155312, -71.4283294677734, -1.24665952841194, 218, 47, 'PPL', 'P'),
(179864, 'Auburn', 38.896671295166, 0.678874982166614, -121.075828552246, -2.11317185281685, 218, 6, 'PPL', 'P'),
(194094, 'Auburn', 40.3680610656738, 0.704555578242139, -104.636108398438, -1.82624460802643, 218, 7, 'PPL', 'P'),
(206728, 'Auburn', 47.3074989318848, 0.82567161724509, -122.22721862793, -2.13326740061232, 218, 56, 'PPL', 'P'),
(209283, 'Auburn', 42.7922210693359, 0.746865151901201, -111.002502441406, -1.93735914555558, 218, 59, 'PPL', 'P'),
(7190, 'Auburn (historical)', 35.2544403076172, 0.615306059315722, -94.1297225952148, -1.6428735832754, 218, 4, 'PPL', 'P'),
(200348, 'Auburn (historical)', 44.6994400024414, 0.780152401840265, -117.94416809082, -2.05851406671045, 218, 43, 'PPL', 'P'),
(154127, 'Auburn Center', 41.3872184753418, 0.722343230636942, -81.2463912963867, -1.41801703348561, 218, 41, 'PPL', 'P'),
(158820, 'Auburn Center', 41.6897201538086, 0.727622880918997, -76.0369415283203, -1.3270949828156, 218, 45, 'PPL', 'P'),
(99550, 'Auburn Chase', 37.6402816772461, 0.656946846646038, -77.7286071777344, -1.35662011824076, 218, 53, 'PPL', 'P'),
(154128, 'Auburn Corners', 41.3872184753418, 0.722343230636942, -81.2163925170898, -1.4174934560153, 218, 41, 'PPL', 'P'),
(158821, 'Auburn Four Corners', 41.7200012207031, 0.728151385237323, -75.9805603027344, -1.32611094479281, 218, 45, 'PPL', 'P'),
(129603, 'Auburn Heights', 42.6336097717285, 0.744096862527091, -83.2227783203125, -1.45251149434681, 218, 27, 'PPL', 'P'),
(202935, 'Auburn Heights', 40.6111106872559, 0.708797594384472, -111.823059082031, -1.95168056063359, 218, 52, 'PPL', 'P'),
(13307, 'Auburn Hills', 39.8041687011719, 0.694713799854724, -75.6930618286133, -1.32109314982494, 218, 10, 'PPL', 'P'),
(129604, 'Auburn Hills', 42.6875, 0.745037424445079, -83.2341690063477, -1.45271029932218, 218, 27, 'PPL', 'P'),
(179865, 'Auburn Hills Mobile Estates', 38.9261093139648, 0.679388772519918, -121.087219238281, -2.11337065779223, 218, 6, 'PPL', 'P'),
(122172, 'Auburn Junction', 41.3519401550293, 0.721727507792916, -85.0747222900391, -1.48483401418099, 218, 19, 'PPL', 'P'),
(179866, 'Auburn Lake Trails', 38.9144401550293, 0.679185107275554, -120.951393127441, -2.11100004494789, 218, 6, 'PPL', 'P'),
(126792, 'Auburn Plains', 44.1758308410645, 0.771013697980631, -70.2322235107422, -1.22578354125902, 218, 26, 'PPL', 'P'),
(15052, 'Auburndale', 28.0650005340576, 0.489826663893272, -81.7888870239258, -1.42748537010917, 218, 12, 'PPL', 'P'),
(34619, 'Auburndale', 38.1427803039551, 0.66571710216886, -85.7744369506836, -1.49704633883371, 218, 21, 'PPL', 'P'),
(124153, 'Auburndale', 42.3472213745117, 0.739098442056148, -71.25, -1.24354709204596, 218, 23, 'PPL', 'P'),
(154132, 'Auburndale', 41.6872215270996, 0.727579271656147, -83.5941696166992, -1.45899349528201, 218, 41, 'PPL', 'P'),
(173005, 'Auburndale', 44.6269416809082, 0.778887067427341, -90.0074996948242, -1.57092722116247, 218, 57, 'PPL', 'P'),
(84749, 'Auburntown', 35.9474983215332, 0.62740220356589, -86.0972213745117, -1.50267998980367, 218, 50, 'PPL', 'P'),
(124154, 'Auburnville', 42.0694389343262, 0.734250223870686, -70.9638900756836, -1.23855353184401, 218, 23, 'PPL', 'P'),
(112862, 'Aucheucaula (historical)', 33.0208282470703, 0.576322174646925, -86.5111083984375, -1.50990368110245, 218, 2, 'PPL', 'P'),
(158824, 'Aucheys', 40.5750007629395, 0.708167357312505, -76.1666717529297, -1.32935920237438, 218, 45, 'PPL', 'P'),
(15053, 'Aucilla', 30.4797191619873, 0.531971454459885, -83.7544403076172, -1.46179074653297, 218, 12, 'PPL', 'P'),
(15054, 'Aucilla (historical)', 30.4166698455811, 0.530871036297465, -83.7666702270508, -1.46200419889434, 218, 12, 'PPL', 'P'),
(18965, 'Aucilla (historical)', 30.6652793884277, 0.535210091372017, -83.8013916015625, -1.46261020120039, 218, 13, 'PPL', 'P'),
(192887, 'Auckland', 36.5880584716797, 0.638582087243015, -119.105827331543, -2.07878884524728, 218, 6, 'PPL', 'P'),
(53276, 'Aud', 38.5802803039551, 0.673352917646335, -91.7205581665039, -1.60082573177247, 218, 29, 'PPL', 'P'),
(92372, 'Audelia', 32.9091682434082, 0.574373339940232, -96.7169418334961, -1.68802907745435, 218, 51, 'PPL', 'P'),
(158825, 'Audenried', 40.9105606079102, 0.714023981444725, -75.991943359375, -1.32630961661013, 218, 45, 'PPL', 'P'),
(193062, 'Audley', 35.401668548584, 0.617875676872513, -113.038330078125, -1.97289104081942, 218, 5, 'PPL', 'P'),
(158826, 'Audobon Gardens', 40.1283302307129, 0.700371485853516, -75.4366683959961, -1.31661824024528, 218, 45, 'PPL', 'P'),
(108047, 'Audra', 39.0419387817383, 0.681410378103397, -80.0669403076172, -1.39743173036568, 218, 58, 'PPL', 'P'),
(206729, 'Audrey', 46.627498626709, 0.813803373005206, -119.614166259766, -2.08766103326082, 218, 56, 'PPL', 'P'),
(200349, 'Audrey (historical)', 44.5688896179199, 0.77787386779062, -118.218063354492, -2.06329444086714, 218, 43, 'PPL', 'P'),
(39169, 'Audrey Park', 32.5544395446777, 0.56818215619607, -93.8288879394531, -1.63762302802825, 218, 22, 'PPL', 'P'),
(15055, 'Audubon', 28.436939239502, 0.496318218918881, -80.6600036621094, -1.40778263857449, 218, 12, 'PPL', 'P'),
(18966, 'Audubon', 34.5661087036133, 0.603292406480321, -84.8191680908203, -1.48037375198733, 218, 13, 'PPL', 'P'),
(39170, 'Audubon', 30.4088897705078, 0.530735248371384, -89.7838897705078, -1.56702449174302, 218, 22, 'PPL', 'P'),
(70474, 'Audubon', 39.8908309936523, 0.696226342195835, -75.0733337402344, -1.31027685421564, 218, 37, 'PPL', 'P'),
(114464, 'Audubon', 41.7180595397949, 0.728117496512452, -94.9322204589844, -1.6568798132384, 218, 16, 'PPL', 'P'),
(134028, 'Audubon', 46.8633308410645, 0.817919421627978, -95.9813919067383, -1.67519130941962, 218, 28, 'PPL', 'P'),
(158827, 'Audubon', 40.1277809143066, 0.700361898473591, -75.4322204589844, -1.31654060909951, 218, 45, 'PPL', 'P'),
(18969, 'Audubon Forest', 33.7158317565918, 0.58845227420099, -84.7763900756836, -1.47962713477572, 218, 13, 'PPL', 'P'),
(79610, 'Audubon Homes', 33.5200004577637, 0.585034373257983, -81.9347229003906, -1.43003068632101, 218, 48, 'PPL', 'P'),
(34620, 'Audubon Park', 38.2038917541504, 0.666783698185436, -85.7252807617188, -1.49618840148854, 218, 21, 'PPL', 'P'),
(39171, 'Audubon Park', 32.5869407653809, 0.568749409508257, -91.9813919067383, -1.60537813933985, 218, 22, 'PPL', 'P'),
(70475, 'Audubon Park', 39.8963890075684, 0.696323347838541, -75.0880584716797, -1.31053384926083, 218, 37, 'PPL', 'P'),
(79611, 'Audubon Park', 33.9269409179688, 0.592136824148142, -80.3838882446289, -1.40296351542394, 218, 48, 'PPL', 'P'),
(154133, 'Augerburg', 41.1630592346191, 0.718430913837561, -81.1675033569336, -1.41664017920204, 218, 41, 'PPL', 'P'),
(118681, 'Augerville', 40.139720916748, 0.70057029082889, -88.1716690063477, -1.5388859311394, 218, 18, 'PPL', 'P'),
(177455, 'Augerville', 41.371940612793, 0.722076581632798, -72.9063873291016, -1.2724565046271, 218, 8, 'PPL', 'P'),
(158829, 'Aughwick', 40.336669921875, 0.704007699426883, -77.8605575561523, -1.35892308679341, 218, 45, 'PPL', 'P'),
(7192, 'Augsburg', 35.4144401550293, 0.618098583455752, -93.2380599975586, -1.62731113512941, 218, 4, 'PPL', 'P'),
(26422, 'Augsburg', 38.8666687011719, 0.678351338117277, -89.0133285522461, -1.55357566139617, 218, 18, 'PPL', 'P'),
(179867, 'August', 37.978889465332, 0.662856667421033, -121.261108398438, -2.11640559617048, 218, 6, 'PPL', 'P'),
(7193, 'Augusta', 35.2822189331055, 0.615790887792171, -91.3652801513672, -1.59462496064838, 218, 4, 'PPL', 'P'),
(18970, 'Augusta', 33.4708290100098, 0.584176169596704, -81.9749984741211, -1.43073362769074, 218, 13, 'PPL', 'P'),
(29129, 'Augusta', 38.3313903808594, 0.669008969013279, -87.1908264160156, -1.52176699849432, 218, 19, 'PPL', 'P'),
(31703, 'Augusta', 37.6866683959961, 0.657756447617422, -96.9763870239258, -1.69255725025581, 218, 20, 'PPL', 'P'),
(34625, 'Augusta', 38.771671295166, 0.676693320601621, -84.0058288574219, -1.46617830442888, 218, 21, 'PPL', 'P'),
(39177, 'Augusta', 30.1897201538086, 0.526910016939649, -91.2152786254883, -1.59200694013878, 218, 22, 'PPL', 'P'),
(44501, 'Augusta', 39.3677787780762, 0.687097358874179, -77.6750030517578, -1.35568454974982, 218, 25, 'PPL', 'P'),
(53280, 'Augusta', 38.5724983215332, 0.673217096430741, -90.8819427490234, -1.58618913157945, 218, 29, 'PPL', 'P'),
(92373, 'Augusta', 31.5313892364502, 0.550326559903957, -95.3305587768555, -1.66383212842211, 218, 51, 'PPL', 'P'),
(108048, 'Augusta', 39.295280456543, 0.685832024461255, -78.6380615234375, -1.37249309096985, 218, 58, 'PPL', 'P'),
(113122, 'Augusta', 44.8050003051758, 0.781994776682381, -93.6877822875977, -1.6351602698102, 218, 28, 'PPL', 'P'),
(114467, 'Augusta', 40.7580604553223, 0.711362351672273, -91.2755584716797, -1.59305902192741, 218, 16, 'PPL', 'P'),
(118682, 'Augusta', 40.2299995422363, 0.702145950087836, -90.9499969482422, -1.58737690142562, 218, 18, 'PPL', 'P'),
(126795, 'Augusta', 44.3105583190918, 0.773365136065116, -69.7799987792969, -1.21789073073635, 218, 26, 'PPL', 'P'),
(129607, 'Augusta', 42.3363914489746, 0.73890942419778, -85.3522186279297, -1.48967723893941, 218, 27, 'PPL', 'P'),
(144774, 'Augusta', 41.1288909912109, 0.717834565490465, -74.7286071777344, -1.30426024068093, 218, 37, 'PPL', 'P'),
(146918, 'Augusta', 42.9747200012207, 0.750050359143963, -75.5016708374023, -1.31775274686966, 218, 40, 'PPL', 'P'),
(154137, 'Augusta', 40.6858291625977, 0.710101677791256, -81.021110534668, -1.41408514245222, 218, 41, 'PPL', 'P'),
(173008, 'Augusta', 44.6802787780762, 0.779817975386378, -91.1197204589844, -1.59033913550612, 218, 57, 'PPL', 'P'),
(195906, 'Augusta', 47.4927787780762, 0.828905360598719, -112.391387939453, -1.9615997704297, 218, 31, 'PPL', 'P'),
(44502, 'Augusta Acres', 39.1269416809082, 0.682893958567653, -76.6155624389648, -1.33719382282723, 218, 25, 'PPL', 'P'),
(79612, 'Augusta Acres', 34.7811088562012, 0.607044867035269, -82.3630599975586, -1.43750657897503, 218, 48, 'PPL', 'P'),
(79613, 'Augusta Fields', 34.1430587768555, 0.595908792358076, -82.1377792358398, -1.43357468794164, 218, 48, 'PPL', 'P'),
(99552, 'Augusta Springs', 38.1019401550293, 0.6650043071031, -79.3183288574219, -1.38436599574164, 218, 53, 'PPL', 'P'),
(79614, 'Augusta View Heights', 33.5066719055176, 0.584801746136764, -81.9199981689453, -1.42977369127582, 218, 48, 'PPL', 'P'),
(158830, 'Augustaville', 40.8072204589844, 0.712220355596469, -76.7416687011719, -1.33939479231013, 218, 45, 'PPL', 'P'),
(112865, 'Augustin', 32.5061111450195, 0.567338666499815, -87.107780456543, -1.52031757307104, 218, 2, 'PPL', 'P'),
(13308, 'Augustine', 39.7638893127441, 0.69401079190597, -75.5541687011719, -1.3186690074427, 218, 10, 'PPL', 'P'),
(188092, 'Augustine', 34.936939239502, 0.609764620298513, -106.19361114502, -1.85342815906314, 218, 38, 'PPL', 'P'),
(188093, 'Augustine (historical)', 34.1133308410645, 0.595389941998701, -107.669441223145, -1.87918625312638, 218, 38, 'PPL', 'P'),
(13312, 'Augustine Hills', 39.7636108398438, 0.694005931636981, -75.5508270263672, -1.31861068421482, 218, 10, 'PPL', 'P'),
(191095, 'Augustus', 33.1305618286133, 0.578237386944855, -101.299171447754, -1.76800407130554, 218, 51, 'PPL', 'P'),
(209935, 'Auke Bay', 58.3833312988281, 1.01898135944721, -134.659713745117, -2.35025537464536, 218, 1, 'PPL', 'P'),
(154139, 'Aukerman', 40.9597206115723, 0.714881985368921, -82.0250015258789, -1.43160634557996, 218, 41, 'PPL', 'P'),
(179868, 'Aukum', 38.5572204589844, 0.672950447426597, -120.725563049316, -2.10705856653458, 218, 6, 'PPL', 'P'),
(62625, 'Aulander', 36.2294387817383, 0.632322992891056, -77.1144409179688, -1.34590089485319, 218, 33, 'PPL', 'P'),
(179869, 'Auld (historical)', 33.586109161377, 0.586188187800259, -117.060562133789, -2.04309223347002, 218, 6, 'PPL', 'P'),
(62626, 'Auld Farm', 35.9711112976074, 0.627814327744579, -81.4308319091797, -1.42123612945325, 218, 33, 'PPL', 'P'),
(39179, 'Aulds (historical)', 32.3691711425781, 0.564948612579523, -93.7172164916992, -1.63567399358448, 218, 22, 'PPL', 'P'),
(53281, 'Aullville', 39.0177803039551, 0.68098873312381, -93.6777801513672, -1.63498569960075, 218, 29, 'PPL', 'P'),
(31706, 'Aulne', 38.2761116027832, 0.668044172329371, -97.0763931274414, -1.69430268603425, 218, 20, 'PPL', 'P'),
(84751, 'Aulon', 35.1375007629395, 0.613265079235313, -89.961669921875, -1.57012734072907, 218, 50, 'PPL', 'P'),
(34621, 'Ault', 38.1952781677246, 0.666633362741901, -83.2108306884766, -1.45230296883346, 218, 21, 'PPL', 'P'),
(194095, 'Ault', 40.5825004577637, 0.708298251680082, -104.731391906738, -1.82790761896913, 218, 7, 'PPL', 'P'),
(154140, 'Aultman', 40.9283294677734, 0.714334106553665, -81.4175033569336, -1.42100350233203, 218, 41, 'PPL', 'P'),
(158831, 'Aultman', 40.5638885498047, 0.70797341260612, -79.2611083984375, -1.38336731033286, 218, 45, 'PPL', 'P'),
(193104, 'Aultman', 34.6163902282715, 0.604169984638529, -111.913612365723, -1.9532610135825, 218, 5, 'PPL', 'P'),
(18971, 'Aultman Pines', 32.7344398498535, 0.571323754175982, -83.6916732788086, -1.46069525521857, 218, 13, 'PPL', 'P'),
(18972, 'Aultmans (historical)', 31.6847190856934, 0.553002670614836, -83.9263916015625, -1.46479186276538, 218, 13, 'PPL', 'P'),
(122173, 'Aultshire', 40.2119407653809, 0.701830764972825, -85.3461074829102, -1.48957057933775, 218, 19, 'PPL', 'P'),
(62627, 'Aumans Crossroads', 35.5586090087891, 0.620614804632686, -79.8394393920898, -1.39346109033843, 218, 33, 'PPL', 'P'),
(200352, 'Aumsville', 44.8411102294922, 0.782625013754349, -122.869720458984, -2.14448117301432, 218, 43, 'PPL', 'P'),
(84753, 'Aunt (historical)', 36.5152816772461, 0.637311892561102, -82.892219543457, -1.44674215531932, 218, 50, 'PPL', 'P'),
(70478, 'Aura', 39.672779083252, 0.692420618419084, -75.1377792358398, -1.31140164030203, 218, 37, 'PPL', 'P'),
(129609, 'Aura', 46.8627815246582, 0.817909834248054, -88.3186111450195, -1.54145055526915, 218, 27, 'PPL', 'P'),
(179870, 'Aurant', 34.0780601501465, 0.594774352312729, -118.163330078125, -2.06233916498413, 218, 6, 'PPL', 'P'),
(15056, 'Aurantia', 28.7277793884277, 0.501394337114627, -80.8877792358398, -1.41175807229171, 218, 12, 'PPL', 'P'),
(18989, 'Auraria', 34.4744415283203, 0.601692512455455, -84.0233306884766, -1.46648376900591, 218, 13, 'PPL', 'P'),
(134035, 'Aure', 47.6733283996582, 0.832056545958555, -95.1202774047852, -1.66016202612387, 218, 28, 'PPL', 'P'),
(114468, 'Aurelia', 42.7127799987793, 0.745478643658678, -95.436393737793, -1.66567929695419, 218, 16, 'PPL', 'P'),
(197956, 'Aurelia', 48.4666709899902, 0.845902986256149, -101.901672363281, -1.77851969602777, 218, 34, 'PPL', 'P'),
(62630, 'Aurelian Springs', 36.3641700744629, 0.634674497554569, -77.8072204589844, -1.35799217883437, 218, 33, 'PPL', 'P'),
(129610, 'Aurelius', 42.524169921875, 0.742186776814259, -84.522216796875, -1.47519097418992, 218, 27, 'PPL', 'P'),
(7195, 'Aurelle', 33.0480613708496, 0.576797482322476, -92.4055633544922, -1.6127813276961, 218, 4, 'PPL', 'P'),
(114469, 'Aureola', 42.9683303833008, 0.749938839273316, -92.8777770996094, -1.62102301232157, 218, 16, 'PPL', 'P'),
(146924, 'Auriesville', 42.9294395446777, 0.749260066090482, -74.3169403076172, -1.29707529837601, 218, 40, 'PPL', 'P'),
(112427, 'Auris (historical)', 33.2333297729492, 0.580031025939023, -89.695556640625, -1.56548278778797, 218, 30, 'PPL', 'P'),
(474, 'Aurora', 39.0569381713867, 0.681672166838552, -84.9013900756836, -1.48180879634072, 218, 19, 'PPL', 'P'),
(7196, 'Aurora', 35.9972190856934, 0.628269994607092, -93.7024993896484, -1.63541713169734, 218, 4, 'PPL', 'P'),
(15057, 'Aurora', 28.1355590820313, 0.491058142870839, -80.6849975585938, -1.40821886436105, 218, 12, 'PPL', 'P'),
(31707, 'Aurora', 39.4519386291504, 0.688566225373413, -97.5269393920898, -1.70216620178492, 218, 20, 'PPL', 'P'),
(34622, 'Aurora', 36.776668548584, 0.641873954087435, -88.144172668457, -1.53840602951097, 218, 21, 'PPL', 'P'),
(53283, 'Aurora', 36.9708290100098, 0.645262693416506, -93.7177810668945, -1.63568384728051, 218, 29, 'PPL', 'P'),
(62628, 'Aurora', 35.3052787780762, 0.61619335801191, -76.7888870239258, -1.34021890750945, 218, 33, 'PPL', 'P'),
(92374, 'Aurora', 33.0605583190918, 0.577015595215754, -97.503059387207, -1.70174941707433, 218, 51, 'PPL', 'P'),
(108050, 'Aurora', 39.3241691589355, 0.686336227434635, -79.5547180175781, -1.38849176490239, 218, 58, 'PPL', 'P'),
(112866, 'Aurora', 34.1166687011719, 0.595448198647547, -86.192497253418, -1.50434286758831, 218, 2, 'PPL', 'P'),
(114471, 'Aurora', 41.4958305358887, 0.72423886870086, -92.2394409179688, -1.60988194421734, 218, 16, 'PPL', 'P'),
(118684, 'Aurora', 41.7605590820313, 0.728859253455066, -88.3199996948242, -1.54147479003507, 218, 18, 'PPL', 'P'),
(126796, 'Aurora', 44.8541717529297, 0.78285298034366, -68.32861328125, -1.19255927507974, 218, 26, 'PPL', 'P'),
(129612, 'Aurora', 46.4488906860352, 0.810686076370241, -90.1458282470703, -1.57334150984869, 218, 27, 'PPL', 'P'),
(134036, 'Aurora', 47.5299987792969, 0.829554972167616, -92.2369384765625, -1.60983826837546, 218, 28, 'PPL', 'P'),
(141215, 'Aurora', 40.8672218322754, 0.713267577116115, -98.0038909912109, -1.71049057756224, 218, 35, 'PPL', 'P'),
(146921, 'Aurora', 42.7538909912109, 0.746196165835373, -76.7027816772461, -1.33871608570632, 218, 40, 'PPL', 'P'),
(154141, 'Aurora', 41.3175010681152, 0.721126432334885, -81.3455581665039, -1.41974782187805, 218, 41, 'PPL', 'P'),
(169767, 'Aurora', 44.2841682434082, 0.772904542354587, -96.6852798461914, -1.68747647152816, 218, 49, 'PPL', 'P'),
(173011, 'Aurora', 43.4275016784668, 0.757952890204609, -88.3016662597656, -1.5411548112301, 218, 57, 'PPL', 'P'),
(179871, 'Aurora', 37.6599998474121, 0.657290993637903, -121.001670837402, -2.11187755652708, 218, 6, 'PPL', 'P'),
(186370, 'Aurora', 39.7294387817383, 0.693409516710858, -104.831390380859, -1.82965292158951, 218, 7, 'PPL', 'P'),
(188094, 'Aurora', 35.146671295166, 0.613425135216827, -105.448608398438, -1.84042540819888, 218, 38, 'PPL', 'P'),
(192474, 'Aurora', 38.9222183227539, 0.679320861912121, -111.933326721191, -1.95360509399534, 218, 52, 'PPL', 'P'),
(200350, 'Aurora', 45.2311096191406, 0.789431787184482, -122.754722595215, -2.14247408165878, 218, 43, 'PPL', 'P'),
(212291, 'Aurora', 64.8569412231445, 1.13196716711631, -147.758605957031, -2.5788741721071, 218, 1, 'PPL', 'P'),
(189898, 'Aurora (historical)', 38.2872200012207, 0.668238050456729, -118.899719238281, -2.07519158040485, 218, 39, 'PPL', 'P'),
(169768, 'Aurora Center', 43.5269393920898, 0.759688405707987, -98.5894393920898, -1.72071032508736, 218, 49, 'PPL', 'P'),
(44503, 'Aurora Hills', 39.0872192382813, 0.682200671156878, -76.6477813720703, -1.3377561492914, 218, 25, 'PPL', 'P'),
(99554, 'Aurora Hills', 38.851390838623, 0.678084689113133, -77.0644378662109, -1.34502817696397, 218, 53, 'PPL', 'P'),
(212292, 'Aurora Lodge', 64.4705581665039, 1.12522351060401, -146.938613891602, -2.56456261072513, 218, 1, 'PPL', 'P'),
(92375, 'Aurora Longoria Colonia', 26.2129993438721, 0.457503145373681, -97.8259963989258, -1.70738573120537, 218, 51, 'PPL', 'P'),
(53284, 'Aurora Springs', 38.3247184753418, 0.668892522294616, -92.5849990844727, -1.61591307197998, 218, 29, 'PPL', 'P'),
(173015, 'Auroraville', 44.0519409179688, 0.768851410912568, -88.9925003051758, -1.55321213990738, 218, 57, 'PPL', 'P'),
(189903, 'Aurum (historical)', 39.7033309936523, 0.692953849848345, -114.583892822266, -1.99986619950083, 218, 39, 'PPL', 'P'),
(146923, 'Ausable Chasm', 44.5224990844727, 0.777064200240209, -73.4655609130859, -1.2822159247578, 218, 40, 'PPL', 'P'),
(62629, 'Ausbon (historical)', 35.8047218322754, 0.624910283733902, -76.7644424438477, -1.33979226910282, 218, 33, 'PPL', 'P'),
(18973, 'Ausmac', 30.9961109161377, 0.540984190799959, -84.6241683959961, -1.47697036527226, 218, 13, 'PPL', 'P'),
(18974, 'Austell', 33.8125, 0.590139453330583, -84.6344375610352, -1.47714959601362, 218, 13, 'PPL', 'P'),
(108049, 'Austen', 39.3880615234375, 0.687451359562078, -79.8011093139648, -1.3927921042726, 218, 58, 'PPL', 'P'),
(34623, 'Austerlitz', 38.0905609130859, 0.664805701864807, -84.2169418334961, -1.46986292095506, 218, 21, 'PPL', 'P'),
(146927, 'Austerlitz', 42.3116683959961, 0.73847792552216, -73.4736099243164, -1.2823564065053, 218, 40, 'PPL', 'P'),
(7199, 'Austin', 35.5305595397949, 0.620125249045303, -92.7905578613281, -1.61950074944248, 218, 4, 'PPL', 'P'),
(29130, 'Austin', 38.7583312988281, 0.676460493743321, -85.8080596923828, -1.49763316637991, 218, 19, 'PPL', 'P'),
(34624, 'Austin', 36.8252792358398, 0.642722370631707, -86.019172668457, -1.50131778290609, 218, 21, 'PPL', 'P'),
(53287, 'Austin', 36.160831451416, 0.631125569085929, -90.1591720581055, -1.57357440328601, 218, 29, 'PPL', 'P'),
(58513, 'Austin', 34.6405601501465, 0.604591829355197, -90.4491729736328, -1.57863587409576, 218, 30, 'PPL', 'P'),
(62631, 'Austin', 36.3236083984375, 0.633966562757799, -80.9772186279297, -1.41331908416466, 218, 33, 'PPL', 'P'),
(71728, 'Austin', 39.4366683959961, 0.688299709527323, -83.2225036621094, -1.45250670065685, 218, 41, 'PPL', 'P'),
(84754, 'Austin', 35.2016716003418, 0.614385071631746, -88.2391662597656, -1.5400639804476, 218, 50, 'PPL', 'P'),
(92376, 'Austin', 30.266939163208, 0.528257742898797, -97.7427825927734, -1.7059333763049, 218, 51, 'PPL', 'P'),
(118686, 'Austin', 41.8875007629395, 0.73107480374493, -87.7647171020508, -1.53178328051216, 218, 18, 'PPL', 'P'),
(129614, 'Austin', 46.2844390869141, 0.807815854505408, -87.4569396972656, -1.52641155143542, 218, 27, 'PPL', 'P'),
(134038, 'Austin', 43.6666717529297, 0.762127195476227, -92.9744415283203, -1.62271012487214, 218, 28, 'PPL', 'P'),
(146926, 'Austin', 42.8108291625977, 0.747189924396136, -76.4711074829102, -1.33467260822326, 218, 40, 'PPL', 'P'),
(158832, 'Austin', 41.6311111450195, 0.726599960744297, -78.091667175293, -1.36295671058044, 218, 45, 'PPL', 'P'),
(169267, 'Austin', 41.5905609130859, 0.725892225684609, -71.6555633544922, -1.25062550790728, 218, 47, 'PPL', 'P'),
(179873, 'Austin', 37.2425003051758, 0.65000425200031, -121.997222900391, -2.12925321790124, 218, 6, 'PPL', 'P'),
(186371, 'Austin', 38.7811088562012, 0.676858037115043, -107.95027923584, -1.88408780111267, 218, 7, 'PPL', 'P'),
(189902, 'Austin', 39.4933280944824, 0.689288607819097, -117.06861114502, -2.04323271521752, 218, 39, 'PPL', 'P'),
(192473, 'Austin', 38.6722183227539, 0.674957538782135, -112.120826721191, -1.95687758634283, 218, 52, 'PPL', 'P'),
(195907, 'Austin', 46.6391716003418, 0.814007104828597, -112.244438171387, -1.9590350131419, 218, 31, 'PPL', 'P'),
(200351, 'Austin', 44.6027793884277, 0.778465355868727, -118.495559692383, -2.06813766562556, 218, 43, 'PPL', 'P'),
(206731, 'Austin', 47.685001373291, 0.832260277781946, -117.163612365723, -2.0448907993122, 218, 56, 'PPL', 'P'),
(79615, 'Austin (historical)', 34.4777793884277, 0.601750769104301, -82.1638870239258, -1.43403035480415, 218, 48, 'PPL', 'P'),
(194542, 'Austin (historical)', 42.6563911437988, 0.74449447247784, -114.848327636719, -2.00448145766994, 218, 17, 'PPL', 'P'),
(79616, 'Austin Acres', 33.9097213745117, 0.591836286419127, -80.4241714477539, -1.40366658995172, 218, 48, 'PPL', 'P'),
(134039, 'Austin Acres', 43.6522216796875, 0.761874994120996, -93.001106262207, -1.62317551227263, 218, 28, 'PPL', 'P'),
(129615, 'Austin Center', 43.622501373291, 0.761356276919676, -82.9375, -1.4475324483728, 218, 27, 'PPL', 'P'),
(129616, 'Austin Corners', 42.7877807617188, 0.746787653913479, -83.508056640625, -1.45749054032082, 218, 27, 'PPL', 'P'),
(143484, 'Austin Corners', 42.9111099243164, 0.748940153864536, -70.9647216796875, -1.23856804607195, 218, 36, 'PPL', 'P'),
(92378, 'Austin Gardens Colonia', 26.3460006713867, 0.459824456448335, -98.197998046875, -1.71387838478493, 218, 51, 'PPL', 'P'),
(158833, 'Austin Heights', 41.3827781677246, 0.722265732649221, -75.7433319091797, -1.32197052824607, 218, 45, 'PPL', 'P'),
(134040, 'Austin Mobile Home Park', 43.6666717529297, 0.762127195476227, -92.9749984741211, -1.62271984541012, 218, 28, 'PPL', 'P'),
(84757, 'Austin Springs', 36.4916687011719, 0.636899768382412, -88.6344375610352, -1.5469627660934, 218, 50, 'PPL', 'P'),
(112864, 'Austin Subdivision', 33.209171295166, 0.579609380959437, -87.495002746582, -1.52707587696934, 218, 2, 'PPL', 'P'),
(154143, 'Austin Village', 41.2425003051758, 0.719817422080084, -80.8594436645508, -1.41126352327728, 218, 41, 'PPL', 'P'),
(154144, 'Austinburg', 41.7719383239746, 0.729057858693359, -80.8547210693359, -1.41118109844154, 218, 41, 'PPL', 'P'),
(158834, 'Austinburg', 41.9930610656738, 0.732917178587047, -77.495002746582, -1.35254295176991, 218, 45, 'PPL', 'P'),
(84759, 'Austins Mill', 36.3733291625977, 0.634834353799001, -83.0066680908203, -1.44873965929493, 218, 50, 'PPL', 'P'),
(154146, 'Austintown', 41.1016693115234, 0.717359457551995, -80.7647171020508, -1.40961023287256, 218, 41, 'PPL', 'P'),
(99555, 'Austinville', 36.8511085510254, 0.64317317722523, -80.9122161865234, -1.41218457754028, 218, 53, 'PPL', 'P'),
(112853, 'Austinville', 34.5747184753418, 0.603442675344828, -87.0086135864258, -1.5185867846786, 218, 2, 'PPL', 'P'),
(114472, 'Austinville', 42.5858306884766, 0.74326296021076, -92.9569396972656, -1.62240466029511, 218, 16, 'PPL', 'P'),
(158835, 'Austinville', 41.8388900756836, 0.730226387200658, -76.8741683959961, -1.3417073482427, 218, 45, 'PPL', 'P'),
(92379, 'Austonio', 31.1855602264404, 0.544290705030374, -95.6383285522461, -1.6692037243408, 218, 51, 'PPL', 'P'),
(84760, 'Austral', 35.2338905334473, 0.614947398095916, -84.545280456543, -1.47559351098869, 218, 50, 'PPL', 'P'),
(58514, 'Australia Landing', 34.065559387207, 0.594556172840425, -90.8777770996094, -1.58611642728169, 218, 30, 'PPL', 'P'),
(53289, 'Austria (historical)', 37.8494415283203, 0.660597374710264, -91.5547180175781, -1.59793127514171, 218, 29, 'PPL', 'P'),
(92380, 'Austwell', 28.3899993896484, 0.495498963988546, -96.8419418334961, -1.69021073901934, 218, 51, 'PPL', 'P'),
(112870, 'Autaugaville', 32.4338912963867, 0.56607819235588, -86.6547164916992, -1.51241011516238, 218, 2, 'PPL', 'P'),
(58515, 'Auter', 33.042781829834, 0.57670533694876, -90.710563659668, -1.58319800220112, 218, 30, 'PPL', 'P'),
(44504, 'Auth Village', 38.8208312988281, 0.677551324525817, -76.9024963378906, -1.34220176409907, 218, 25, 'PPL', 'P'),
(92381, 'Authon', 32.8683280944824, 0.573660544874472, -97.9436111450195, -1.7094384957736, 218, 51, 'PPL', 'P'),
(18975, 'Autney', 33.3472213745117, 0.582018809376659, -82.4391708374023, -1.43883496372676, 218, 13, 'PPL', 'P'),
(134043, 'Automba', 46.5208282470703, 0.811941623666159, -93.0183334350586, -1.6234761831597, 218, 28, 'PPL', 'P'),
(18976, 'Autreyville', 31.062219619751, 0.542138005342236, -83.7649993896484, -1.46197503728041, 218, 13, 'PPL', 'P'),
(62633, 'Autryville', 34.9977798461914, 0.610826489204155, -78.6427764892578, -1.37257538264754, 218, 33, 'PPL', 'P'),
(71716, 'Autumn Acres', 39.2238883972168, 0.684585997966235, -84.6052780151367, -1.47664066592931, 218, 41, 'PPL', 'P'),
(18977, 'Autumn Chase', 33.6230583190918, 0.586833072258222, -84.2227783203125, -1.46996478686675, 218, 13, 'PPL', 'P'),
(44505, 'Autumn Chase At Riva Trace', 38.964168548584, 0.680053031474811, -76.5625, -1.33626770855816, 218, 25, 'PPL', 'P'),
(44506, 'Autumn Estates', 38.7027816772461, 0.675490969948478, -76.5627822875977, -1.33627263540618, 218, 25, 'PPL', 'P'),
(44507, 'Autumn Grove', 38.3638916015625, 0.669576222325466, -75.5416717529297, -1.31845089454942, 218, 25, 'PPL', 'P'),
(44508, 'Autumn Hill', 39.2572212219238, 0.685167765506362, -76.8119430541992, -1.34062131115017, 218, 25, 'PPL', 'P'),
(177458, 'Autumn HIll', 41.517219543457, 0.724612177306662, -72.8724975585938, -1.27186501654899, 218, 8, 'PPL', 'P'),
(158836, 'Autumn Leaves', 41.9288902282715, 0.731797186190614, -75.334716796875, -1.31483884916295, 218, 45, 'PPL', 'P'),
(79617, 'Autumn Oaks', 34.5433311462402, 0.602894863108599, -82.6252822875977, -1.44208322130833, 218, 48, 'PPL', 'P'),
(99556, 'Autumn Oaks', 37.3708305358887, 0.652244037056094, -77.4749984741211, -1.352193811351, 218, 53, 'PPL', 'P'),
(44509, 'Autumn Ridge', 39.5950012207031, 0.691063138632444, -76.9913864135742, -1.3437531885921, 218, 25, 'PPL', 'P'),
(193069, 'Autumn Ridge', 33.6530609130859, 0.587356716307559, -112.153060913086, -1.95744017912311, 218, 5, 'PPL', 'P'),
(39180, 'Autumn Run', 30.3527793884277, 0.529755937459535, -91.1180572509766, -1.59031010705023, 218, 22, 'PPL', 'P'),
(44510, 'Autumn Wind', 39.4644393920898, 0.688784404845717, -76.7266693115234, -1.33913300357497, 218, 25, 'PPL', 'P'),
(202938, 'Autumn Wood', 40.6555595397949, 0.709573373210012, -111.949996948242, -1.95389604434443, 218, 52, 'PPL', 'P'),
(202939, 'Autumn Wood Circle', 40.6566696166992, 0.709592747706942, -111.949996948242, -1.95389604434443, 218, 52, 'PPL', 'P'),
(44511, 'Autumn Woods', 39.1441688537598, 0.683194629454723, -76.8172225952148, -1.34071345652388, 218, 25, 'PPL', 'P'),
(75034, 'Autwine', 36.7219390869141, 0.640918744783451, -97.2297210693359, -1.69697876345561, 218, 42, 'PPL', 'P'),
(7202, 'Auvergne', 35.5136108398438, 0.619829438427222, -91.2305603027344, -1.59227365572195, 218, 4, 'PPL', 'P'),
(108052, 'Auvil', 39.1777801513672, 0.68378125726384, -79.7238922119141, -1.39144441160297, 218, 58, 'PPL', 'P'),
(129622, 'Auvinen Corner', 46.5202789306641, 0.811932036286235, -90.0961074829102, -1.57247371880748, 218, 27, 'PPL', 'P'),
(113023, 'Aux Sable', 41.394718170166, 0.722474125004519, -88.32861328125, -1.5416251254786, 218, 18, 'PPL', 'P'),
(34626, 'Auxier', 37.7369384765625, 0.658633826038549, -82.7583312988281, -1.44440536462083, 218, 21, 'PPL', 'P'),
(53290, 'Auxvasse', 39.0180587768555, 0.680993593392799, -91.8969421386719, -1.60390421283454, 218, 29, 'PPL', 'P'),
(7203, 'Ava', 34.8694381713867, 0.608586504411289, -93.2052764892578, -1.62673895496921, 218, 4, 'PPL', 'P'),
(26424, 'Ava', 37.8883285522461, 0.661276081314071, -89.4947204589844, -1.56197753516121, 218, 18, 'PPL', 'P'),
(53291, 'Ava', 36.9519386291504, 0.644932994073554, -92.6602783203125, -1.61722694250377, 218, 29, 'PPL', 'P'),
(71717, 'Ava', 39.8316688537598, 0.695193768062184, -81.5749969482422, -1.42375228405115, 218, 41, 'PPL', 'P'),
(112872, 'Ava', 33.3430595397949, 0.581946171657927, -85.4780578613281, -1.4918735478904, 218, 2, 'PPL', 'P'),
(146928, 'Ava', 43.4188919067383, 0.757802621340102, -75.4797210693359, -1.31736965114685, 218, 40, 'PPL', 'P'),
(173016, 'Avalanche', 43.6022186279297, 0.761002276231777, -90.7802810668945, -1.58441480050318, 218, 57, 'PPL', 'P'),
(194097, 'Avalo', 40.8033294677734, 0.712152444988672, -103.649719238281, -1.80902886947572, 218, 7, 'PPL', 'P'),
(13310, 'Avalon', 39.7305603027344, 0.69342909094487, -75.6222229003906, -1.31985677728887, 218, 10, 'PPL', 'P'),
(18981, 'Avalon', 34.5019416809082, 0.602172480662915, -83.1952819824219, -1.45203159271838, 218, 13, 'PPL', 'P'),
(39181, 'Avalon', 29.7177791595459, 0.518673092714629, -91.3308334350586, -1.5940237520323, 218, 22, 'PPL', 'P'),
(44513, 'Avalon', 38.709171295166, 0.675602489819125, -76.3386077880859, -1.33236005229069, 218, 25, 'PPL', 'P'),
(53292, 'Avalon', 39.6591682434082, 0.692183064449849, -93.4413909912109, -1.63085993044, 218, 29, 'PPL', 'P'),
(58516, 'Avalon', 33.6549987792969, 0.587390538453403, -90.085563659668, -1.57228969437616, 218, 30, 'PPL', 'P'),
(70479, 'Avalon', 39.1011085510254, 0.682443085395102, -74.7180633544922, -1.30407621624961, 218, 37, 'PPL', 'P'),
(71718, 'Avalon', 39.5308303833008, 0.689943146236011, -84.3788909912109, -1.47268946697801, 218, 41, 'PPL', 'P'),
(92382, 'Avalon', 32.2052803039551, 0.562088177831696, -96.7897186279297, -1.68929927213626, 218, 51, 'PPL', 'P'),
(99558, 'Avalon', 37.9066696166992, 0.661596193277098, -76.4241714477539, -1.33385341987195, 218, 53, 'PPL', 'P'),
(122174, 'Avalon', 41.0161094665527, 0.71586615654976, -85.1577835083008, -1.48628370592038, 218, 19, 'PPL', 'P'),
(134045, 'Avalon', 44.1888885498047, 0.771241597990914, -94.0513916015625, -1.64150644952981, 218, 28, 'PPL', 'P'),
(158837, 'Avalon', 40.5008316040039, 0.706872861285644, -80.0677795410156, -1.39744637775168, 218, 45, 'PPL', 'P'),
(173017, 'Avalon', 42.6327781677246, 0.74408234829915, -88.8675003051758, -1.55103047834238, 218, 57, 'PPL', 'P'),
(179874, 'Avalon', 33.3427810668945, 0.581941311388937, -118.326942443848, -2.06519473946297, 218, 6, 'PPL', 'P'),
(188095, 'Avalon', 32.497501373291, 0.567188397635307, -104.236106872559, -1.81926326438684, 218, 38, 'PPL', 'P'),
(189905, 'Avalon', 38.7630615234375, 0.676543051737113, -118.755279541016, -2.07267063211698, 218, 39, 'PPL', 'P'),
(15058, 'Avalon Beach', 30.5300006866455, 0.532849032618094, -87.1016693115234, -1.52021091346939, 218, 12, 'PPL', 'P'),
(129620, 'Avalon Beach', 42.6888885498047, 0.745061659210999, -82.5083312988281, -1.44004204149084, 218, 27, 'PPL', 'P'),
(171696, 'Avalon Beach', 43.6399993896484, 0.761661674917681, -73.2255630493164, -1.27802717183727, 218, 55, 'PPL', 'P'),
(62635, 'Avalon Bench', 36.0424995422363, 0.629060287660573, -75.6783294677734, -1.32083602162169, 218, 33, 'PPL', 'P'),
(71719, 'Avalon Heights', 39.4208297729492, 0.688023273406173, -84.2138900756836, -1.46980965773326, 218, 41, 'PPL', 'P'),
(29131, 'Avalon Hills', 39.878059387207, 0.696003435612595, -86.0558319091797, -1.50195760735798, 218, 19, 'PPL', 'P'),
(99559, 'Avalon Hills', 36.8108291625977, 0.642470169276476, -76.1894378662109, -1.32975654600902, 218, 53, 'PPL', 'P'),
(44514, 'Avalon Park', 38.4191703796387, 0.670541019009375, -75.5569381713867, -1.31871734381648, 218, 25, 'PPL', 'P'),
(53293, 'Avalon Park', 37.3261108398438, 0.651463531119619, -93.2624969482422, -1.62773764037799, 218, 29, 'PPL', 'P'),
(112875, 'Avalon Park', 33.4305610656738, 0.583473361385033, -86.9902801513672, -1.51826680587363, 218, 2, 'PPL', 'P'),
(13311, 'Avalon Park Mobile Home Park', 38.6577796936035, 0.674705537163986, -75.2666702270508, -1.31365121247482, 218, 10, 'PPL', 'P'),
(44515, 'Avalon Shores', 38.8375015258789, 0.677842274874909, -76.5180587768555, -1.33549206289067, 218, 25, 'PPL', 'P'),
(99560, 'Avalon Terrace', 36.8161087036133, 0.642562314650193, -76.1927795410156, -1.3298148692369, 218, 53, 'PPL', 'P'),
(179876, 'Avalon Village', 33.8127784729004, 0.590144313599572, -118.263061523438, -2.06407980707261, 218, 6, 'PPL', 'P'),
(201877, 'Avance (historical)', 44.9183311462402, 0.783972773003011, -102.247222900391, -1.78455069063236, 218, 49, 'PPL', 'P'),
(18983, 'Avans', 34.8852806091309, 0.608863007111467, -85.5441665649414, -1.49302736243268, 218, 13, 'PPL', 'P'),
(7204, 'Avant', 34.6458282470703, 0.604683774991832, -93.3397216796875, -1.62908546620568, 218, 4, 'PPL', 'P'),
(75035, 'Avant', 36.4894409179688, 0.636860886230497, -96.0619430541992, -1.67659719215907, 218, 42, 'PPL', 'P'),
(112876, 'Avant', 31.6213893890381, 0.551897358893913, -86.7013931274414, -1.51322477613984, 218, 2, 'PPL', 'P'),
(92383, 'Avant Prairie', 31.6094398498535, 0.551688800091046, -96.1805572509766, -1.67866740043245, 218, 51, 'PPL', 'P'),
(18984, 'Avants', 32.1100006103516, 0.560425233468024, -82.8594436645508, -1.44617010831717, 218, 13, 'PPL', 'P'),
(75036, 'Avard', 36.6988906860352, 0.640516474300794, -98.7886123657227, -1.72418654925824, 218, 42, 'PPL', 'P'),
(34627, 'Avawam', 37.2244415283203, 0.649689066885299, -83.2752838134766, -1.45342788807791, 218, 21, 'PPL', 'P'),
(15059, 'Ave Maria', 26.3333301544189, 0.459603314209317, -81.4416732788086, -1.4214253470487, 218, 12, 'PPL', 'P'),
(44516, 'Aveley', 38.7791709899902, 0.676824214969199, -76.1391677856445, -1.3288791675879, 218, 25, 'PPL', 'P'),
(158839, 'Avella', 40.2750015258789, 0.702931382872327, -80.4608306884766, -1.40430641440361, 218, 45, 'PPL', 'P'),
(158840, 'Avella Highlands', 40.2733306884766, 0.702902221258391, -80.4649963378906, -1.40437911870137, 218, 45, 'PPL', 'P'),
(26425, 'Avena', 39.0074996948242, 0.680809302645366, -88.9277801513672, -1.55208256013102, 218, 18, 'PPL', 'P'),
(179877, 'Avena', 37.8430595397949, 0.660485987997671, -121.065277099609, -2.11298769522747, 218, 6, 'PPL', 'P'),
(179878, 'Avenal', 36.0041694641113, 0.628391301594745, -120.128059387207, -2.09663016033804, 218, 6, 'PPL', 'P'),
(77809, 'Avendale', 39.8855590820313, 0.696134329980172, -75.3633270263672, -1.31533819186733, 218, 45, 'PPL', 'P'),
(99561, 'Avendale', 37.2947196960449, 0.650915652304363, -79.934440612793, -1.39511917443311, 218, 53, 'PPL', 'P'),
(44518, 'Avenel', 39.002498626709, 0.680722017540639, -76.9802780151367, -1.34355931046474, 218, 25, 'PPL', 'P'),
(144775, 'Avenel', 40.5802803039551, 0.708259502686221, -74.2855606079102, -1.29652761929783, 218, 37, 'PPL', 'P'),
(191096, 'Avenger Village', 32.4594383239746, 0.566524072101387, -100.455276489258, -1.7532753257388, 218, 51, 'PPL', 'P'),
(34628, 'Avenstoke', 38.1083297729492, 0.665115826973747, -85.0005569458008, -1.48353958473316, 218, 21, 'PPL', 'P'),
(58517, 'Avent', 30.9813899993896, 0.540727262333793, -88.779167175293, -1.54948877438734, 218, 30, 'PPL', 'P'),
(62637, 'Aventon', 36.1527786254883, 0.6309850207594, -77.9499969482422, -1.36048409866636, 218, 33, 'PPL', 'P'),
(15060, 'Aventura', 25.9561100006104, 0.453019580520478, -80.1394424438477, -1.39869713135763, 218, 12, 'PPL', 'P'),
(44519, 'Avenue', 38.2561111450195, 0.667695098489489, -76.7680587768555, -1.33985538602066, 218, 25, 'PPL', 'P'),
(53294, 'Avenue City', 39.8633308410645, 0.695746373988375, -94.7569427490234, -1.65382064009423, 218, 29, 'PPL', 'P'),
(79618, 'Avenue of Oaks', 32.9638900756836, 0.575328416086161, -80.1474990844727, -1.39883774626319, 218, 48, 'PPL', 'P'),
(18985, 'Avera', 33.1938896179199, 0.579342665376265, -82.5272216796875, -1.44037174083379, 218, 13, 'PPL', 'P'),
(58518, 'Avera', 31.2958297729492, 0.546215271681633, -88.7413864135742, -1.54882937570143, 218, 30, 'PPL', 'P'),
(99562, 'Averett', 36.5747184753418, 0.638349260384715, -78.6516723632813, -1.37273064493909, 218, 53, 'PPL', 'P'),
(79619, 'Averill', 33.0741691589355, 0.577253149184989, -81.5136108398438, -1.42268089434461, 218, 48, 'PPL', 'P'),
(129621, 'Averill', 43.6655616760254, 0.762107820979297, -84.3419418334961, -1.47204458252005, 218, 27, 'PPL', 'P'),
(134046, 'Averill', 46.9708290100098, 0.819795618615939, -96.5469436645508, -1.68506204968389, 218, 28, 'PPL', 'P'),
(171697, 'Averill', 44.9980583190918, 0.785364274672577, -71.7108306884766, -1.25159010485411, 218, 55, 'PPL', 'P'),
(146930, 'Averill Park', 42.6338882446289, 0.74410172279608, -73.5541687011719, -1.28376242240281, 218, 40, 'PPL', 'P'),
(39184, 'Averit (historical)', 32.5166702270508, 0.567522957247248, -92.4333267211914, -1.61326588985644, 218, 22, 'PPL', 'P'),
(53295, 'Avert', 36.9294395446777, 0.644540310970822, -89.8477783203125, -1.56813955729143, 218, 29, 'PPL', 'P'),
(7205, 'Avery', 33.9297218322754, 0.592185360259009, -91.6569366455078, -1.59971532675596, 218, 4, 'PPL', 'P'),
(18988, 'Avery', 34.1955604553223, 0.596825119510145, -84.4225006103516, -1.47345059841756, 218, 13, 'PPL', 'P'),
(44520, 'Avery', 39.1094398498535, 0.682588493990621, -77.121940612793, -1.34603178922077, 218, 25, 'PPL', 'P'),
(53296, 'Avery', 38.0677795410156, 0.664408091914058, -93.3600006103516, -1.62943940031455, 218, 29, 'PPL', 'P'),
(75038, 'Avery', 35.8841705322266, 0.626296925134479, -96.7519378662109, -1.68863987345036, 218, 42, 'PPL', 'P'),
(92384, 'Avery', 33.5519409179688, 0.585591839453163, -94.7808303833008, -1.65423755796288, 218, 51, 'PPL', 'P'),
(112877, 'Avery', 34.1083297729492, 0.595302656893974, -86.0361099243164, -1.50161339378709, 218, 2, 'PPL', 'P'),
(113230, 'Avery', 41.3277816772461, 0.721305862813329, -82.6208267211914, -1.4420054570045, 218, 41, 'PPL', 'P'),
(114473, 'Avery', 41.0652809143066, 0.716724360211038, -92.7141723632813, -1.61816757100079, 218, 16, 'PPL', 'P'),
(122175, 'Avery', 40.3088912963867, 0.703522870950434, -86.440559387207, -1.50867236857245, 218, 19, 'PPL', 'P'),
(129623, 'Avery', 44.9575004577637, 0.784656406454834, -84.0313873291016, -1.46662438391147, 218, 27, 'PPL', 'P'),
(141217, 'Avery', 41.1636085510254, 0.718440501217485, -95.9222183227539, -1.67415853554889, 218, 35, 'PPL', 'P'),
(158841, 'Avery', 41.6386108398438, 0.726730855111875, -75.9313888549805, -1.32525274113154, 218, 45, 'PPL', 'P'),
(179879, 'Avery', 38.2044410705566, 0.666793285565361, -120.36888885498, -2.10083342748652, 218, 6, 'PPL', 'P'),
(194543, 'Avery', 47.250560760498, 0.824677858684327, -115.804168701172, -2.02116403137041, 218, 17, 'PPL', 'P'),
(53297, 'Avery (historical)', 38.0533294677734, 0.664155890558828, -91.2827835083008, -1.59318512260503, 218, 29, 'PPL', 'P'),
(177459, 'Avery Corner', 41.5988883972168, 0.7260375677011, -72.2113876342773, -1.26032647165206, 218, 8, 'PPL', 'P'),
(62640, 'Avery Creek', 35.4633293151855, 0.618951860269014, -82.5827789306641, -1.44134139778669, 218, 33, 'PPL', 'P'),
(26427, 'Avery Hill', 38.5530586242676, 0.672877809707865, -90.0269393920898, -1.57126650788535, 218, 18, 'PPL', 'P'),
(39186, 'Avery Island', 29.9033298492432, 0.521911563179193, -91.9102783203125, -1.60413697311382, 218, 22, 'PPL', 'P'),
(18990, 'Avery Landing', 33.4925003051758, 0.584554405050523, -82.1397171020508, -1.43360851008748, 218, 13, 'PPL', 'P'),
(193356, 'Avery Place', 40.1819381713867, 0.701307120923488, -121.779441833496, -2.12545222123543, 218, 6, 'PPL', 'P'),
(146931, 'Averys Place', 43.2941703796387, 0.755625820044098, -74.5550003051758, -1.30123022915069, 218, 40, 'PPL', 'P'),
(129625, 'Averytown (historical)', 44.6725006103516, 0.779682220749811, -86.0400009155273, -1.50168130439489, 218, 27, 'PPL', 'P'),
(118690, 'Averyville', 40.7166709899902, 0.710639969226589, -89.5622177124023, -1.5631555844694, 218, 18, 'PPL', 'P'),
(146932, 'Averyville', 44.2438888549805, 0.772201534405833, -74.0519409179688, -1.29245018651087, 218, 40, 'PPL', 'P'),
(31709, 'Avian', 37.0958290100098, 0.647444354981499, -95.6013870239258, -1.66855897304089, 218, 20, 'PPL', 'P'),
(44521, 'Avila', 38.9083290100098, 0.679078447673896, -76.6144409179688, -1.33717424859322, 218, 25, 'PPL', 'P'),
(179881, 'Avila Beach', 35.1800003051758, 0.614006836177927, -120.730827331543, -2.10715044559218, 218, 6, 'PPL', 'P'),
(193354, 'Avila Place', 41.0430603027344, 0.716336537377296, -120.866668701172, -2.10952132475263, 218, 6, 'PPL', 'P'),
(7212, 'Avilla', 34.6824989318848, 0.605323799180806, -92.5849990844727, -1.61591307197998, 218, 4, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(53299, 'Avilla', 37.1952781677246, 0.649180070221958, -94.1294403076172, -1.64286865642738, 218, 29, 'PPL', 'P'),
(122176, 'Avilla', 41.3658294677734, 0.72196992203114, -85.2388916015625, -1.48769930919781, 218, 19, 'PPL', 'P'),
(44522, 'Avilton', 39.6502799987793, 0.692027935316352, -79.0425033569336, -1.37955193259716, 218, 25, 'PPL', 'P'),
(92385, 'Avinger', 32.8997192382813, 0.574208423689729, -94.5561065673828, -1.65031538746746, 218, 51, 'PPL', 'P'),
(179880, 'Avinsino Corner', 38.6936111450195, 0.675330913966964, -120.675559997559, -2.10618584864536, 218, 6, 'PPL', 'P'),
(99563, 'Avis', 38.0433311462402, 0.6639813869284, -79.0941696166992, -1.38045367894226, 218, 53, 'PPL', 'P'),
(108053, 'Avis', 37.666389465332, 0.657402513508551, -80.8880615234375, -1.41176299913972, 218, 58, 'PPL', 'P'),
(154149, 'Avis', 41.0208282470703, 0.715948514806471, -84.1691665649414, -1.46902908521775, 218, 41, 'PPL', 'P'),
(158843, 'Avis', 41.1847190856934, 0.718808949554298, -77.3141708374023, -1.34938683956205, 218, 45, 'PPL', 'P'),
(188096, 'Avis', 32.7002792358398, 0.570727538986941, -105.454170227051, -1.84052248042061, 218, 38, 'PPL', 'P'),
(70481, 'Avis Mills', 39.665828704834, 0.692299311431431, -75.2486114501953, -1.31333602735981, 218, 37, 'PPL', 'P'),
(26430, 'Aviston', 38.6066703796387, 0.673813511356864, -89.6074981689453, -1.56394587752289, 218, 18, 'PPL', 'P'),
(71720, 'Avlon', 39.7438888549805, 0.693661718066088, -82.3850021362305, -1.43788954153978, 218, 41, 'PPL', 'P'),
(7207, 'Avoca', 36.4019393920898, 0.635333696503391, -94.070556640625, -1.64184094256272, 218, 4, 'PPL', 'P'),
(15061, 'Avoca', 30.5777797698975, 0.533682934934425, -83.0269393920898, -1.44909346024575, 218, 12, 'PPL', 'P'),
(29132, 'Avoca', 38.9119415283203, 0.679141498012704, -86.5477828979492, -1.51054377187045, 218, 19, 'PPL', 'P'),
(34629, 'Avoca', 38.2591705322266, 0.667748494869345, -85.4986114501953, -1.49223227568923, 218, 21, 'PPL', 'P'),
(39187, 'Avoca', 29.6838893890381, 0.518081604636523, -91.1902770996094, -1.59157058119417, 218, 22, 'PPL', 'P'),
(62642, 'Avoca', 36.002498626709, 0.628362139980809, -76.7119369506836, -1.33887587537173, 218, 33, 'PPL', 'P'),
(75039, 'Avoca', 35.0138893127441, 0.61110765243624, -96.9302825927734, -1.69175257613244, 218, 42, 'PPL', 'P'),
(84762, 'Avoca', 36.5316696166992, 0.637597916062176, -82.2463912963867, -1.43547032600556, 218, 50, 'PPL', 'P'),
(92386, 'Avoca', 32.8655586242676, 0.573612208500687, -99.7155609130859, -1.74036485340631, 218, 51, 'PPL', 'P'),
(108054, 'Avoca', 38.4530601501465, 0.671132507087481, -81.0508270263672, -1.41460379307451, 218, 58, 'PPL', 'P'),
(114476, 'Avoca', 41.4766693115234, 0.723904442246974, -95.3377838134766, -1.66395822909972, 218, 16, 'PPL', 'P'),
(129626, 'Avoca', 43.061939239502, 0.751572622023052, -82.6911087036133, -1.44323210900259, 218, 27, 'PPL', 'P'),
(134047, 'Avoca', 43.9486083984375, 0.767047918222366, -95.6452789306641, -1.66932503132845, 218, 28, 'PPL', 'P'),
(141218, 'Avoca', 40.7961082458496, 0.712026410890084, -96.1172180175781, -1.67756192226396, 218, 35, 'PPL', 'P'),
(146933, 'Avoca', 42.4094390869141, 0.740184345990628, -77.4216690063477, -1.35126303655001, 218, 40, 'PPL', 'P'),
(158845, 'Avoca', 41.3397216796875, 0.721514255168628, -75.7366714477539, -1.32185428126449, 218, 45, 'PPL', 'P'),
(173018, 'Avoca', 43.1819381713867, 0.753666998483318, -90.3244400024414, -1.57645887306268, 218, 57, 'PPL', 'P'),
(197959, 'Avoca', 48.185001373291, 0.840986924041918, -103.523612976074, -1.80682789999282, 218, 34, 'PPL', 'P'),
(112879, 'Avoca (historical)', 34.5750007629395, 0.603447602192845, -87.5055618286133, -1.52726016771677, 218, 2, 'PPL', 'P'),
(118691, 'Avoca (historical)', 40.8061103820801, 0.712200981099539, -88.5180587768555, -1.54493157312999, 218, 18, 'PPL', 'P'),
(71721, 'Avoca Park', 39.1388893127441, 0.683102484081006, -84.3411102294922, -1.47203006829211, 218, 41, 'PPL', 'P'),
(179882, 'Avocado Heights', 34.0361099243164, 0.594042182750039, -117.990280151367, -2.05931887399187, 218, 6, 'PPL', 'P'),
(7208, 'Avon', 34.0747184753418, 0.594716029084857, -94.3227767944336, -1.64624301468657, 218, 4, 'PPL', 'P'),
(29133, 'Avon', 39.7627792358398, 0.69399141740904, -86.3997192382813, -1.5079595735067, 218, 19, 'PPL', 'P'),
(34630, 'Avon', 38.0716705322266, 0.664476002521855, -84.3186111450195, -1.47163738518938, 218, 21, 'PPL', 'P'),
(53301, 'Avon', 37.7513885498047, 0.658886027393779, -90.2233276367188, -1.57469412936634, 218, 29, 'PPL', 'P'),
(58519, 'Avon', 33.2299995422363, 0.579972902448232, -91.0472183227539, -1.58907373451417, 218, 30, 'PPL', 'P'),
(62643, 'Avon', 35.3519401550293, 0.617007752673256, -75.5108337402344, -1.31791266969311, 218, 33, 'PPL', 'P'),
(99564, 'Avon', 37.9997215270996, 0.663220255488856, -78.8266677856445, -1.37578489123524, 218, 53, 'PPL', 'P'),
(108055, 'Avon', 39.1952781677246, 0.684086655261845, -80.649169921875, -1.4075935541371, 218, 58, 'PPL', 'P'),
(112878, 'Avon', 31.1891708374023, 0.544353722079668, -85.2861099243164, -1.48852342439713, 218, 2, 'PPL', 'P'),
(114477, 'Avon', 41.5286102294922, 0.724810982282037, -93.523063659668, -1.63228538741346, 218, 16, 'PPL', 'P'),
(118693, 'Avon', 40.6641693115234, 0.70972364207452, -90.4347229003906, -1.57838367274053, 218, 18, 'PPL', 'P'),
(124155, 'Avon', 42.1305618286133, 0.735317019624345, -71.0416717529297, -1.23991107820967, 218, 23, 'PPL', 'P'),
(126798, 'Avon', 44.8061103820801, 0.782014151179312, -70.2716674804688, -1.22647196840081, 218, 26, 'PPL', 'P'),
(134049, 'Avon', 45.6091690063477, 0.796030168259317, -94.4513931274414, -1.6484877931694, 218, 28, 'PPL', 'P'),
(146935, 'Avon', 42.9119415283203, 0.748954668092477, -77.7458267211914, -1.35692065596978, 218, 40, 'PPL', 'P'),
(154150, 'Avon', 41.4516716003418, 0.723468149881391, -82.0355606079102, -1.43179063632739, 218, 41, 'PPL', 'P'),
(158847, 'Avon', 40.3455581665039, 0.70416282856038, -76.3902816772461, -1.33326193179384, 218, 45, 'PPL', 'P'),
(169773, 'Avon', 43.0050010681152, 0.750578863462289, -98.059440612793, -1.71146010135708, 218, 49, 'PPL', 'P'),
(173021, 'Avon', 42.5433311462402, 0.742521203268145, -89.3313903808594, -1.55912688753039, 218, 57, 'PPL', 'P'),
(177461, 'Avon', 41.8097190856934, 0.729717257379262, -72.8311080932617, -1.27114263410331, 218, 8, 'PPL', 'P'),
(179883, 'Avon', 38.0327796936035, 0.663797229339022, -122.074172973633, -2.13059625003897, 218, 6, 'PPL', 'P'),
(186372, 'Avon', 39.6313896179199, 0.6916982359734, -106.521667480469, -1.85915382224875, 218, 7, 'PPL', 'P'),
(194544, 'Avon', 46.8261108398438, 0.817269810059081, -116.612777709961, -2.03527692093507, 218, 17, 'PPL', 'P'),
(195908, 'Avon', 46.5972213745117, 0.813274935265907, -112.601112365723, -1.96526015218996, 218, 31, 'PPL', 'P'),
(202952, 'Avon', 41.5330581665039, 0.724888613427812, -111.8125, -1.95149626988616, 218, 52, 'PPL', 'P'),
(206732, 'Avon', 48.4425010681152, 0.845481141539481, -122.377220153809, -2.13588542112192, 218, 56, 'PPL', 'P'),
(154151, 'Avon Center', 41.4597206115723, 0.723608631628893, -82.0197219848633, -1.43151420020624, 218, 41, 'PPL', 'P'),
(126799, 'Avon Corner', 44.8002815246582, 0.781912418425671, -70.26611328125, -1.22637502933713, 218, 26, 'PPL', 'P'),
(44523, 'Avon Crest', 38.586669921875, 0.673464437516982, -77.0105590820313, -1.34408781478307, 218, 25, 'PPL', 'P'),
(99565, 'Avon Forest', 38.7719383239746, 0.676697981133529, -77.3058319091797, -1.34924129780848, 218, 53, 'PPL', 'P'),
(158848, 'Avon Heights', 40.3525009155273, 0.704284002389978, -76.3752822875977, -1.33300014305869, 218, 45, 'PPL', 'P'),
(114478, 'Avon Lake', 41.5219383239746, 0.724694535563373, -93.5008316040039, -1.63189736484264, 218, 16, 'PPL', 'P'),
(154152, 'Avon Lake', 41.5052795410156, 0.724403784951363, -82.0283279418945, -1.43166440249172, 218, 41, 'PPL', 'P'),
(15063, 'Avon Park', 27.5955600738525, 0.481633382220616, -81.5063934326172, -1.42255492682505, 218, 12, 'PPL', 'P'),
(18991, 'Avon Park', 32.0555610656738, 0.559475084170111, -81.0599975585938, -1.41476384905603, 218, 13, 'PPL', 'P'),
(112874, 'Avon Park', 33.5461082458496, 0.585490040120495, -86.7713928222656, -1.51444650128991, 218, 2, 'PPL', 'P'),
(144776, 'Avon Park', 40.5930595397949, 0.708482542427516, -74.4000015258789, -1.29852499011539, 218, 37, 'PPL', 'P'),
(15064, 'Avon Park Lakes', 27.628059387207, 0.48220060224329, -81.5486068725586, -1.42329169034062, 218, 12, 'PPL', 'P'),
(177460, 'Avon Park North', 41.8125, 0.729765793490129, -72.8358306884766, -1.27122505893904, 218, 8, 'PPL', 'P'),
(177456, 'Avon Park South', 41.8063888549805, 0.729659133888471, -72.8411102294922, -1.27131720431276, 218, 8, 'PPL', 'P'),
(154154, 'Avon Point', 41.5133285522461, 0.724544266698865, -82.0177764892578, -1.43148024490234, 218, 41, 'PPL', 'P'),
(144777, 'Avon-by-the-Sea', 40.1922187805176, 0.701486551401932, -74.0163879394531, -1.29182966997688, 218, 37, 'PPL', 'P'),
(92387, 'Avonak', 30.0944404602051, 0.525247072575976, -95.5066680908203, -1.66690581579422, 218, 51, 'PPL', 'P'),
(29134, 'Avonburg', 38.8863906860352, 0.67869555168817, -85.1722183227539, -1.4865356409595, 218, 19, 'PPL', 'P'),
(15066, 'Avondale', 30.4516696929932, 0.531481898872502, -87.3066711425781, -1.52378887039391, 218, 12, 'PPL', 'P'),
(18996, 'Avondale', 33.5113906860352, 0.584884104393475, -82.0602798461914, -1.43222206842399, 218, 13, 'PPL', 'P'),
(39189, 'Avondale', 31.9402809143066, 0.557463065966556, -91.2816696166992, -1.59316568152907, 218, 22, 'PPL', 'P'),
(44525, 'Avondale', 38.9486083984375, 0.67978145562265, -76.9755630493164, -1.34347701878706, 218, 25, 'PPL', 'P'),
(53302, 'Avondale', 39.1541709899902, 0.683369199664177, -94.5466690063477, -1.65015067095404, 218, 29, 'PPL', 'P'),
(62644, 'Avondale', 35.2694396972656, 0.615567848050877, -81.7908325195313, -1.42751932541307, 218, 33, 'PPL', 'P'),
(79623, 'Avondale', 33.9111099243164, 0.591860521185046, -80.4061126708984, -1.40335140483671, 218, 48, 'PPL', 'P'),
(84767, 'Avondale', 36.3319396972656, 0.634111971353317, -86.5494384765625, -1.51057266716828, 218, 50, 'PPL', 'P'),
(92389, 'Avondale', 32.9677810668945, 0.575396326693959, -97.420280456543, -1.70030465218296, 218, 51, 'PPL', 'P'),
(99566, 'Avondale', 37.6575012207031, 0.657247384375053, -77.3619384765625, -1.3502205421413, 218, 53, 'PPL', 'P'),
(108057, 'Avondale', 37.4124984741211, 0.652971279770768, -81.7844390869141, -1.4274077389634, 218, 58, 'PPL', 'P'),
(112880, 'Avondale', 33.521671295166, 0.585063534871919, -86.7780609130859, -1.51456288142955, 218, 2, 'PPL', 'P'),
(129627, 'Avondale', 44.0158309936523, 0.768221173840601, -85.2266693115234, -1.48748598999449, 218, 27, 'PPL', 'P'),
(144779, 'Avondale', 40.8147201538086, 0.712351249964046, -74.1505584716797, -1.29417138752339, 218, 37, 'PPL', 'P'),
(154157, 'Avondale', 40.8263893127441, 0.71255491520841, -81.414436340332, -1.42094997279412, 218, 41, 'PPL', 'P'),
(158849, 'Avondale', 41.2227783203125, 0.719473208509191, -75.9822235107422, -1.3261399732487, 218, 45, 'PPL', 'P'),
(169268, 'Avondale', 41.3344383239746, 0.721422043215884, -71.8358306884766, -1.2537717664191, 218, 47, 'PPL', 'P'),
(186373, 'Avondale', 38.2374992370605, 0.667370259415526, -104.350563049316, -1.82126090152051, 218, 7, 'PPL', 'P'),
(193074, 'Avondale', 33.4355583190918, 0.583560579910733, -112.348892211914, -1.96085808006612, 218, 5, 'PPL', 'P'),
(206733, 'Avondale', 47.7033309936523, 0.832580190007892, -122.091667175293, -2.13090158145795, 218, 56, 'PPL', 'P'),
(195909, 'Avondale (historical)', 48.6650009155273, 0.849364496462007, -106.184722900391, -1.85327302992964, 218, 31, 'PPL', 'P'),
(202946, 'Avondale Condo', 40.610279083252, 0.708783080156531, -111.790283203125, -1.95110851363144, 218, 52, 'PPL', 'P'),
(18999, 'Avondale Estates', 33.7713890075684, 0.589421931153888, -84.267219543457, -1.47074043253424, 218, 13, 'PPL', 'P'),
(34631, 'Avondale Heights', 37.0722198486328, 0.647032297381836, -88.6500015258789, -1.54723440852458, 218, 21, 'PPL', 'P'),
(158850, 'Avondale Hill', 41.2272186279297, 0.719550706496912, -75.9836120605469, -1.32616420801462, 218, 45, 'PPL', 'P'),
(84769, 'Avondale Springs', 36.3105583190918, 0.63373879590557, -83.4625015258789, -1.45669545357738, 218, 50, 'PPL', 'P'),
(44528, 'Avondale Terrace', 38.9533309936523, 0.679863880458388, -76.9763870239258, -1.34349139985694, 218, 25, 'PPL', 'P'),
(112887, 'Avondale Village', 33.5930595397949, 0.586309494787913, -86.2761077880859, -1.50580214670762, 218, 2, 'PPL', 'P'),
(158851, 'Avonia', 42.0455589294434, 0.733833439160089, -80.2699966430664, -1.4009757319863, 218, 45, 'PPL', 'P'),
(158852, 'Avonmore', 40.5288887023926, 0.707362550031083, -79.461669921875, -1.38686776926966, 218, 45, 'PPL', 'P'),
(44529, 'Avonvue', 38.7069396972656, 0.675563541088182, -76.1811065673828, -1.32961113741351, 218, 25, 'PPL', 'P'),
(84770, 'Avoton (historical)', 36.2825012207031, 0.633249107160131, -85.4844436645508, -1.49198500118202, 218, 50, 'PPL', 'P'),
(158854, 'Avoy', 41.4447212219238, 0.723346842893738, -75.3399963378906, -1.31493099453666, 218, 45, 'PPL', 'P'),
(193068, 'Avra', 32.3277816772461, 0.564226230133839, -111.217498779297, -1.9411115395315, 218, 5, 'PPL', 'P'),
(193079, 'Avra Valley', 32.4377784729004, 0.56614603638465, -111.314720153809, -1.94280837262005, 218, 5, 'PPL', 'P'),
(84771, 'Avreet', 35.6202812194824, 0.621691187766269, -89.6666717529297, -1.56497865139362, 218, 50, 'PPL', 'P'),
(199817, 'Awakening', 41.2755584716797, 0.720394395930249, -117.952499389648, -2.05865947530597, 218, 39, 'PPL', 'P'),
(84772, 'Awalt (historical)', 35.2583312988281, 0.615373969923519, -86.2547225952148, -1.50542890468085, 218, 50, 'PPL', 'P'),
(34632, 'Awe', 38.4213905334473, 0.670579768003235, -83.3438873291016, -1.45462524530401, 218, 21, 'PPL', 'P'),
(79627, 'Awendaw', 33.0374984741211, 0.576613124996016, -79.6133270263672, -1.38951468507709, 218, 48, 'PPL', 'P'),
(112881, 'Awin', 31.8377799987793, 0.555674087504295, -86.9488906860352, -1.51754442342794, 218, 2, 'PPL', 'P'),
(144780, 'Awosting', 41.1544418334961, 0.718280511814999, -74.3369369506836, -1.29742430563686, 218, 37, 'PPL', 'P'),
(146939, 'Awosting', 41.6691703796387, 0.72726421969919, -74.2916717529297, -1.29663427889949, 218, 40, 'PPL', 'P'),
(200353, 'Axehandle (historical)', 44.7508316040039, 0.781049354495403, -120.650001525879, -2.10573976916277, 218, 43, 'PPL', 'P'),
(158855, 'Axemann', 40.8899993896484, 0.713665120487837, -77.7605590820313, -1.35717778417302, 218, 45, 'PPL', 'P'),
(146937, 'Axeville', 42.2491683959961, 0.737387094739663, -78.9594421386719, -1.37810224085778, 218, 40, 'PPL', 'P'),
(206734, 'Axford', 47.1944389343262, 0.823698348035396, -123.944999694824, -2.16324833605805, 218, 56, 'PPL', 'P'),
(194096, 'Axial', 40.2852783203125, 0.703110746771744, -107.791389465332, -1.88131465146957, 218, 7, 'PPL', 'P'),
(129628, 'Axin', 44.2099990844727, 0.771610046327727, -85.5475006103516, -1.49308555250249, 218, 27, 'PPL', 'P'),
(112873, 'Axis', 30.9297199249268, 0.539825449409665, -88.0272216796875, -1.53636484969348, 218, 2, 'PPL', 'P'),
(112868, 'Axle', 31.5955600738525, 0.55144655230039, -87.329719543457, -1.52419114087656, 218, 2, 'PPL', 'P'),
(19001, 'Axson', 31.2761096954346, 0.545871091400254, -82.7344436645508, -1.44398844675217, 218, 13, 'PPL', 'P'),
(34634, 'Axtel', 37.6441688537598, 0.657014690674808, -86.475830078125, -1.50928795825843, 218, 21, 'PPL', 'P'),
(154158, 'Axtel', 41.3686103820801, 0.722018458142007, -82.3638916015625, -1.43752109320297, 218, 41, 'PPL', 'P'),
(31713, 'Axtell', 39.8716697692871, 0.695891915741948, -96.2586135864258, -1.68002974048808, 218, 20, 'PPL', 'P'),
(53303, 'Axtell', 39.8244400024414, 0.695067600805541, -92.4727783203125, -1.61395445015628, 218, 29, 'PPL', 'P'),
(62645, 'Axtell', 36.3624992370605, 0.634645335940633, -78.2566680908203, -1.3658365198252, 218, 33, 'PPL', 'P'),
(92390, 'Axtell', 31.6580600738525, 0.552537383082886, -96.9711074829102, -1.69246510488209, 218, 51, 'PPL', 'P'),
(99567, 'Axtell', 37.7011108398438, 0.658008515814598, -78.6016693115234, -1.37185792704987, 218, 53, 'PPL', 'P'),
(141221, 'Axtell', 40.478328704834, 0.706480111603885, -99.1263885498047, -1.7300818558053, 218, 35, 'PPL', 'P'),
(192476, 'Axtell', 39.0552787780762, 0.681643204961697, -111.821113586426, -1.95164660532969, 218, 52, 'PPL', 'P'),
(124158, 'Axtell Corner', 42.2319412231445, 0.737086423852593, -71.6841735839844, -1.25112485061167, 218, 23, 'PPL', 'P'),
(99568, 'Axton', 36.6594390869141, 0.639827914000954, -79.7122192382813, -1.39124067977957, 218, 53, 'PPL', 'P'),
(146938, 'Axton Landing', 44.2027816772461, 0.771484078808166, -74.3291702270508, -1.29728875073738, 218, 40, 'PPL', 'P'),
(58521, 'Ayanabi (historical)', 32.6944389343262, 0.570625606496218, -88.7422180175781, -1.54884388992937, 218, 30, 'PPL', 'P'),
(39191, 'Aycock', 32.7080612182617, 0.570863360202535, -92.9175033569336, -1.62171636631138, 218, 22, 'PPL', 'P'),
(62646, 'Aycock Crossing', 35.6266708374023, 0.621802707636916, -78.054443359375, -1.36230703243252, 218, 33, 'PPL', 'P'),
(19002, 'Aycock Mill', 31.6372203826904, 0.552173661857008, -84.6130599975586, -1.4767764871449, 218, 13, 'PPL', 'P'),
(75041, 'Aydelotte', 35.4441719055176, 0.618617500394154, -96.9113922119141, -1.69142287678949, 218, 42, 'PPL', 'P'),
(62647, 'Ayden', 35.4724998474121, 0.619111916250527, -77.4158325195313, -1.35116117063832, 218, 33, 'PPL', 'P'),
(62649, 'Aydlett', 36.3258285522461, 0.634005311751659, -75.9072189331055, -1.32483089641487, 218, 33, 'PPL', 'P'),
(124162, 'Ayer', 42.5611114501953, 0.742831528114167, -71.5902786254883, -1.24948607443489, 218, 23, 'PPL', 'P'),
(186374, 'Ayer', 37.7580604553223, 0.659002474112443, -103.845832824707, -1.81245169726674, 218, 7, 'PPL', 'P'),
(206735, 'Ayer', 46.5963897705078, 0.813260421037966, -118.347221374512, -2.06554867357184, 218, 56, 'PPL', 'P'),
(15067, 'Ayers', 28.4630603790283, 0.496774118807989, -82.4438934326172, -1.4389173885625, 218, 12, 'PPL', 'P'),
(34633, 'Ayers', 36.6308288574219, 0.639328571296564, -84.2286071777344, -1.47006651962039, 218, 21, 'PPL', 'P'),
(84773, 'Ayers', 36.0791702270508, 0.629700311849546, -89.6419372558594, -1.56454695298092, 218, 50, 'PPL', 'P'),
(108058, 'Ayers', 38.9780616760254, 0.680295512292062, -81.0986099243164, -1.41543776196987, 218, 58, 'PPL', 'P'),
(118696, 'Ayers', 42.0538902282715, 0.733978847755607, -90.1155624389648, -1.57281327184647, 218, 18, 'PPL', 'P'),
(126801, 'Ayers', 44.9844398498535, 0.785126587545287, -67.2386093139648, -1.17353511699081, 218, 26, 'PPL', 'P'),
(79628, 'Ayers (historical)', 34.6105613708496, 0.604068251884888, -79.7027816772461, -1.39107596326615, 218, 48, 'PPL', 'P'),
(158856, 'Ayers Crossroads', 41.8613891601563, 0.73061907030339, -76.6672210693359, -1.33809543601428, 218, 45, 'PPL', 'P'),
(158857, 'Ayers Hill', 41.7286109924316, 0.728301654101831, -77.9658279418945, -1.36076040162945, 218, 45, 'PPL', 'P'),
(195910, 'Ayers Ranch Colony', 47.0513916015625, 0.821201701092474, -108.948890686035, -1.9015168588667, 218, 31, 'PPL', 'P'),
(124160, 'Ayers Village', 42.7869415283203, 0.746773006527484, -71.1694412231445, -1.24214107614845, 218, 23, 'PPL', 'P'),
(19003, 'Ayersville', 34.5608291625977, 0.603200261106604, -83.413330078125, -1.4558372499161, 218, 13, 'PPL', 'P'),
(62650, 'Ayersville', 36.4869384765625, 0.636817210388619, -80.0252838134766, -1.39670468738809, 218, 33, 'PPL', 'P'),
(154159, 'Ayersville', 41.2386093139648, 0.719749511472287, -84.2855606079102, -1.47106054449727, 218, 41, 'PPL', 'P'),
(75042, 'Aylesworth', 34.0280609130859, 0.593901701002538, -96.6263885498047, -1.68644862450544, 218, 42, 'PPL', 'P'),
(122178, 'Aylesworth', 41.3183288574219, 0.721140879983798, -87.1133270263672, -1.52041437897667, 218, 19, 'PPL', 'P'),
(99569, 'Aylett', 37.785831451416, 0.659487169430837, -77.1052780151367, -1.34574097202973, 218, 53, 'PPL', 'P'),
(99575, 'Aylett Mill', 37.7619400024414, 0.659070184983158, -77.0927810668945, -1.34552285913646, 218, 53, 'PPL', 'P'),
(197960, 'Aylmer', 47.9341697692871, 0.836609086683991, -100.192497253418, -1.74868896286752, 218, 34, 'PPL', 'P'),
(19004, 'Aylmer (historical)', 34.1916694641113, 0.596757208902348, -84.9252777099609, -1.48222571420937, 218, 13, 'PPL', 'P'),
(44531, 'Aylor', 39.3833312988281, 0.687368801568286, -77.3694381713867, -1.35035143650888, 218, 25, 'PPL', 'P'),
(99570, 'Aylor', 38.4347190856934, 0.670812395124454, -78.3022232055664, -1.36663160656864, 218, 53, 'PPL', 'P'),
(84774, 'Aymett Town', 35.1761093139648, 0.61393892557013, -86.959716796875, -1.51773337470729, 218, 50, 'PPL', 'P'),
(79629, 'Aynor', 33.9997215270996, 0.593407085409083, -79.1997222900391, -1.38229592062633, 218, 48, 'PPL', 'P'),
(44532, 'Aynsley', 39.4619407653809, 0.688740795582867, -77.459716796875, -1.35192709576782, 218, 25, 'PPL', 'P'),
(206736, 'Ayock', 47.5074996948242, 0.829162289064884, -123.055557250977, -2.14772463690592, 218, 56, 'PPL', 'P'),
(129630, 'Ayr', 45.4922218322754, 0.793989055020853, -84.8533325195313, -1.4809700337554, 218, 27, 'PPL', 'P'),
(139626, 'Ayr', 47.0411109924316, 0.821022270614029, -97.4902801513672, -1.70152637733303, 218, 34, 'PPL', 'P'),
(141222, 'Ayr', 40.4375, 0.705767516275207, -98.4400024414063, -1.7181021582738, 218, 35, 'PPL', 'P'),
(141223, 'Ayr Junction', 40.4577789306641, 0.706121450384079, -98.4313888549805, -1.71795182283026, 218, 35, 'PPL', 'P'),
(44533, 'Ayres', 38.6641693115234, 0.674817057034633, -77.0194396972656, -1.34424281075851, 218, 25, 'PPL', 'P'),
(112883, 'Ayres', 33.7313919067383, 0.588723850053151, -86.563606262207, -1.51081994167549, 218, 2, 'PPL', 'P'),
(124161, 'Ayres City', 42.625, 0.743946593662583, -71.3125, -1.24463792282846, 218, 23, 'PPL', 'P'),
(112882, 'Ayres Estates', 33.7269401550293, 0.588646152328348, -86.5583267211914, -1.51072779630178, 218, 2, 'PPL', 'P'),
(44534, 'Ayres Lane Estates', 38.1216697692871, 0.665348653832047, -75.3375015258789, -1.31488745185284, 218, 25, 'PPL', 'P'),
(114479, 'Ayresville', 41.6847190856934, 0.727535595814269, -91.0138931274414, -1.58849210013209, 218, 16, 'PPL', 'P'),
(29135, 'Ayrshire', 38.371940612793, 0.669716704072968, -87.2408294677734, -1.52263971638354, 218, 19, 'PPL', 'P'),
(114480, 'Ayrshire', 43.0391693115234, 0.751175211809385, -94.8324966430664, -1.65513930430798, 218, 16, 'PPL', 'P'),
(724, 'Azalea', 35.5800018310547, 0.620988179817516, -82.4713897705078, -1.43939729019093, 218, 33, 'PPL', 'P'),
(193355, 'Azalea', 41.2783317565918, 0.720442798883061, -122.301109313965, -2.13455703637019, 218, 6, 'PPL', 'P'),
(200354, 'Azalea', 42.7955589294434, 0.746923408550046, -123.259170532227, -2.15127835906452, 218, 43, 'PPL', 'P'),
(99572, 'Azalea Acres', 36.7355613708496, 0.641156498489767, -76.5933303833008, -1.33680580025641, 218, 53, 'PPL', 'P'),
(19005, 'Azalea Gardens', 31.1972198486328, 0.54449420382717, -81.4749984741211, -1.42200698143077, 218, 13, 'PPL', 'P'),
(99573, 'Azalea Mobile Home Park', 38.6297187805176, 0.67421578183952, -77.4111099243164, -1.35107874580258, 218, 53, 'PPL', 'P'),
(15068, 'Azalea Park', 28.5408306121826, 0.498131465436575, -81.3008270263672, -1.4189671162045, 218, 12, 'PPL', 'P'),
(19006, 'Azalea Park', 32.8372192382813, 0.573117592907232, -83.6900024414063, -1.46066609360463, 218, 13, 'PPL', 'P'),
(19007, 'Azalea Plaza Mobile Home Park', 32.041389465332, 0.559227743083869, -81.1813888549805, -1.41688252686124, 218, 13, 'PPL', 'P'),
(15069, 'Azalea Terrace', 30.2869396209717, 0.528606816738679, -81.5611114501953, -1.42350993639196, 218, 12, 'PPL', 'P'),
(79631, 'Azalea Trailer Park', 33.9688911437988, 0.592868993710832, -80.3905563354492, -1.40307989556358, 218, 48, 'PPL', 'P'),
(29136, 'Azalia', 39.0916709899902, 0.682278368881681, -85.8472213745117, -1.49831666667368, 218, 19, 'PPL', 'P'),
(129629, 'Azalia', 42.0188903808594, 0.73336798518057, -83.6658325195313, -1.46024424888796, 218, 27, 'PPL', 'P'),
(158858, 'Azelta', 41.8394393920898, 0.730235974580583, -77.4852828979492, -1.35237330840847, 218, 45, 'PPL', 'P'),
(39192, 'Azema (historical)', 30.2244396209717, 0.527515985956183, -91.8727798461914, -1.60348250127593, 218, 22, 'PPL', 'P'),
(99574, 'Azen', 36.6580581665039, 0.639803812393089, -81.6361083984375, -1.42481888006773, 218, 53, 'PPL', 'P'),
(139020, 'Azen', 40.5597190856934, 0.707900641729333, -92.0380630493164, -1.6063672373687, 218, 29, 'PPL', 'P'),
(92391, 'Azle', 32.8950004577637, 0.574126065433018, -97.5455627441406, -1.70249124059597, 218, 51, 'PPL', 'P'),
(195911, 'Aznoe (historical)', 47.9583282470703, 0.837030731663578, -111.323059082031, -1.94295391437362, 218, 31, 'PPL', 'P'),
(7210, 'Azor', 33.5916709899902, 0.586285260021993, -93.4247207641602, -1.63056898009091, 218, 4, 'PPL', 'P'),
(173023, 'Aztalan', 43.0727806091309, 0.751761839618502, -88.8622207641602, -1.55093833296867, 218, 57, 'PPL', 'P'),
(188097, 'Aztec', 36.8222198486328, 0.642668974251851, -107.992218017578, -1.88481977093828, 218, 38, 'PPL', 'P'),
(193083, 'Aztec', 32.8244400024414, 0.572894553165938, -113.449172973633, -1.98006160205446, 218, 5, 'PPL', 'P'),
(193084, 'Aztec Lodge', 33.8450012207031, 0.59070670664277, -110.968330383301, -1.93676273062946, 218, 5, 'PPL', 'P'),
(114481, 'Aztec Mobile Home Park', 40.6347198486328, 0.709209651984134, -91.3625030517578, -1.59457649111654, 218, 16, 'PPL', 'P'),
(154160, 'Aztec Subdivision', 41.6172218322754, 0.726357546506073, -83.4641723632813, -1.45672461519131, 218, 41, 'PPL', 'P'),
(92392, 'Azteca Acres Colonia', 26.2099990844727, 0.457450780968747, -98.1539993286133, -1.71311046228461, 218, 51, 'PPL', 'P'),
(39193, 'Azucena', 31.7777805328369, 0.554626899274162, -91.4377822875977, -1.59589036164033, 218, 22, 'PPL', 'P'),
(188098, 'Azul', 34.6938896179199, 0.60552260415618, -106.757781982422, -1.86327479771954, 218, 38, 'PPL', 'P'),
(179884, 'Azure Vista', 32.7194404602051, 0.571061965440827, -117.262222290039, -2.04661186716667, 218, 6, 'PPL', 'P'),
(179885, 'Azusa', 34.1336097717285, 0.595743876107573, -117.906669616699, -2.05785959487256, 218, 6, 'PPL', 'P'),
(206737, 'Azwell', 47.9372215270996, 0.836662349905792, -119.875282287598, -2.09221836767622, 218, 56, 'PPL', 'P'),
(211665, 'Ãƒâ€žliamanu', 21.3547191619873, 0.372710160215403, -157.927505493164, -2.75635495031714, 218, 15, 'PPL', 'P'),
(211570, 'Ã‚â€˜Aiea', 21.3822193145752, 0.373190128422862, -157.933609008789, -2.75646147676075, 218, 15, 'PPL', 'P'),
(211649, 'Ã‚â€˜Aiea Heights', 21.3908290863037, 0.37334039728737, -157.920272827148, -2.75622871648147, 218, 15, 'PPL', 'P'),
(211544, 'Ã‚â€˜AinapÃƒÂ¶', 19.3591709136963, 0.337881272900319, -155.424163818359, -2.71266339578941, 218, 15, 'PPL', 'P'),
(211581, 'Ã‚â€˜Ãƒâ€žhuimanu', 21.4447193145752, 0.374280959205359, -157.837783813477, -2.75478901159618, 218, 15, 'PPL', 'P'),
(211554, 'Ã‚â€˜Ãƒâ€žina Haina', 21.2819404602051, 0.371439932243976, -157.752502441406, -2.75330057086293, 218, 15, 'PPL', 'P'),
(211692, 'Ã‚â€˜Ãƒâ€žlewa Heights', 21.3430595397949, 0.372506661418607, -157.852783203125, -2.75505080033133, 218, 15, 'PPL', 'P'),
(211412, 'Ã‚â€˜Ãƒâ€žpua (historical)', 19.2613906860352, 0.336174685984283, -155.196105957031, -2.70868303522418, 218, 15, 'PPL', 'P'),
(210830, 'Ã‚â€˜Ãƒâ€“Ã‚â€˜ÃƒÂ¶kala', 20.0174999237061, 0.349371281686384, -155.287216186523, -2.71027320871107, 218, 15, 'PPL', 'P'),
(210820, 'Ã‚â€˜Ãƒâ€“maÃ‚â€˜opio', 20.7999992370605, 0.363028471099015, -156.328063964844, -2.72843942945482, 218, 15, 'PPL', 'P'),
(211326, 'Ã‚â€˜Ewa', 21.3425006866455, 0.372496907591115, -158.040283203125, -2.75832329267882, 218, 15, 'PPL', 'P'),
(211325, 'Ã‚â€˜Ewa Beach', 21.315559387207, 0.372026693211148, -158.007217407227, -2.7577461856706, 218, 15, 'PPL', 'P'),
(211327, 'Ã‚â€˜Ewa Gentry', 21.3441696166992, 0.372526035915537, -158.030822753906, -2.75815817669124, 218, 15, 'PPL', 'P'),
(211328, 'Ã‚â€˜Ewa Villages', 21.3455600738525, 0.372550303970971, -158.040832519531, -2.75833288005875, 218, 15, 'PPL', 'P'),
(211329, 'Ã‚â€˜Ewa-Schofield Junction', 21.3994407653809, 0.373490699441391, -157.981384277344, -2.75729531249805, 218, 15, 'PPL', 'P'),
(211109, 'Ã‚â€˜UalapuÃ‚â€˜e', 21.0658302307129, 0.367668097192097, -156.832504272461, -2.73724357370252, 218, 15, 'PPL', 'P'),
(211113, 'Ã‚â€˜UlaÃ‚â€˜ino (historical)', 20.8086109161377, 0.363178773253036, -156.058883666992, -2.72374134697582, 218, 15, 'PPL', 'P'),
(211121, 'Ã‚â€˜Umikoa', 19.9825000762939, 0.348760419111347, -155.38444519043, -2.71197017495767, 218, 15, 'PPL', 'P'),
(211122, 'Ã‚â€˜UmipaÃ‚â€˜a', 21.1097202301025, 0.368434122190144, -157.055557250977, -2.741136582584, 218, 15, 'PPL', 'P'),
(92393, 'B and E Colonia', 26.3560009002686, 0.459998993368276, -98.7539978027344, -1.72358241116496, 218, 51, 'PPL', 'P'),
(44535, 'B and J Trailer Park', 39.5180587768555, 0.689720239652771, -76.146110534668, -1.3290003414175, 218, 25, 'PPL', 'P'),
(92394, 'B and P Bridge Colonia', 26.0669994354248, 0.454954966263666, -97.9499969482422, -1.70954994906522, 218, 51, 'PPL', 'P'),
(195913, 'B and R Subdivision', 45.9127807617188, 0.801329193038302, -106.644439697266, -1.86129660166183, 218, 31, 'PPL', 'P'),
(39194, 'B and S Park Subdivision', 33.0108299255371, 0.576147671016497, -93.4561080932617, -1.63111679232714, 218, 22, 'PPL', 'P'),
(7211, 'B B Junction', 34.5813903808594, 0.603559122063492, -91.1047210693359, -1.59007734677096, 218, 4, 'PPL', 'P'),
(31714, 'B N Junction', 38.5616683959961, 0.673028078572372, -95.271110534668, -1.66279456086141, 218, 20, 'PPL', 'P'),
(206738, 'B Z Corner', 45.8502807617188, 0.800238362255806, -121.507781982422, -2.1207108623887, 218, 56, 'PPL', 'P'),
(195912, 'Babb', 48.860279083252, 0.852772743446063, -113.435829162598, -1.97982870861713, 218, 31, 'PPL', 'P'),
(206739, 'Babb', 47.4583282470703, 0.828304085403606, -117.656669616699, -2.05349627174258, 218, 56, 'PPL', 'P'),
(126802, 'Babb Corner', 43.6297187805176, 0.761482244439237, -70.4505615234375, -1.22959425846282, 218, 26, 'PPL', 'P'),
(124163, 'Babbatasset Village', 42.6666717529297, 0.744673902956284, -71.5791702270508, -1.24929219630753, 218, 23, 'PPL', 'P'),
(112885, 'Babbie', 31.2794399261475, 0.545929214891045, -86.3255615234375, -1.50666527721692, 218, 2, 'PPL', 'P'),
(193086, 'Babbit Winter', 34.6252784729004, 0.604325113772026, -110.832496643066, -1.93439198462707, 218, 5, 'PPL', 'P'),
(129631, 'Babbits Resort', 44.6674995422363, 0.779594935645084, -84.6127777099609, -1.47677156029689, 218, 27, 'PPL', 'P'),
(134052, 'Babbitt', 47.708610534668, 0.832672335381608, -91.9444427490234, -1.60473325488189, 218, 28, 'PPL', 'P'),
(144781, 'Babbitt', 40.8097190856934, 0.712263964859319, -74.0202789306641, -1.29189758058468, 218, 37, 'PPL', 'P'),
(189906, 'Babbitt', 38.5394401550293, 0.672640122580575, -118.636672973633, -2.07060055700166, 218, 39, 'PPL', 'P'),
(146941, 'Babbitt Corner', 42.836109161377, 0.747631143609735, -77.1847229003906, -1.34712754685128, 218, 40, 'PPL', 'P'),
(75043, 'Babbs', 34.9483299255371, 0.609963425273887, -99.0591735839844, -1.72890873334512, 218, 42, 'PPL', 'P'),
(84776, 'Babbs Mill', 36.2636108398438, 0.632919407817179, -82.7772216796875, -1.44473506396378, 218, 50, 'PPL', 'P'),
(53304, 'Babbtown', 38.3388900756836, 0.669139863380857, -92.1383285522461, -1.60811720052099, 218, 29, 'PPL', 'P'),
(71726, 'Babbtown (historical)', 39.9702796936035, 0.697612983596412, -84.1394424438477, -1.46851030143741, 218, 41, 'PPL', 'P'),
(19009, 'Babcock', 31.1122207641602, 0.543010689941941, -84.6416702270508, -1.47727582984929, 218, 13, 'PPL', 'P'),
(108059, 'Babcock', 38.0825004577637, 0.664665020380224, -80.8886108398438, -1.41177258651965, 218, 58, 'PPL', 'P'),
(118697, 'Babcock', 41.5294418334961, 0.724825496509978, -90.3958282470703, -1.57770483297867, 218, 18, 'PPL', 'P'),
(122179, 'Babcock', 41.5724983215332, 0.725576973990571, -87.1050033569336, -1.5202691035392, 218, 19, 'PPL', 'P'),
(129632, 'Babcock', 42.2172203063965, 0.736829495386428, -84.8000030517578, -1.48003925895441, 218, 27, 'PPL', 'P'),
(173025, 'Babcock', 44.3016700744629, 0.773210006931619, -90.1111068725586, -1.57273550754264, 218, 57, 'PPL', 'P'),
(206740, 'Babcock', 46.3258285522461, 0.808538236951092, -118.592216491699, -2.06982464501807, 218, 56, 'PPL', 'P'),
(146942, 'Babcock Hill', 42.9316711425781, 0.749299014821424, -75.2211074829102, -1.31285599257333, 218, 40, 'PPL', 'P'),
(146943, 'Babcock Lake', 42.8133316040039, 0.747233600238013, -73.4049987792969, -1.28115891612115, 218, 40, 'PPL', 'P'),
(44536, 'Babel Heights', 39.4880599975586, 0.689196662182461, -76.9686126708984, -1.3433557117994, 218, 25, 'PPL', 'P'),
(108060, 'Baber', 38.0083312988281, 0.663370524353364, -82.0458297729492, -1.43196986706876, 218, 58, 'PPL', 'P'),
(58522, 'Babington (historical)', 31.0541706085205, 0.541997523594734, -90.1788864135742, -1.57391848369885, 218, 30, 'PPL', 'P'),
(108061, 'Bablin', 38.7649993896484, 0.676576873882958, -80.4369430541992, -1.40388949653496, 218, 58, 'PPL', 'P'),
(15070, 'Babson Park', 27.8316707611084, 0.485754291112378, -81.5224990844727, -1.42283602347811, 218, 12, 'PPL', 'P'),
(124164, 'Babson Park', 42.2986106872559, 0.738250025511876, -71.2600021362305, -1.24372166225541, 218, 23, 'PPL', 'P'),
(92396, 'Baby Head (historical)', 30.8880596160889, 0.539098339853046, -98.6527786254883, -1.72181580325586, 218, 51, 'PPL', 'P'),
(206741, 'Baby Island Heights', 48.0963897705078, 0.839440359817881, -122.520278930664, -2.13838226780193, 218, 56, 'PPL', 'P'),
(193105, 'Baby Rocks', 36.7752799987793, 0.641849719321515, -110.008331298828, -1.92000758578928, 218, 5, 'PPL', 'P'),
(118698, 'Babylon', 40.5908317565918, 0.7084436602756, -90.3491668701172, -1.57689043831733, 218, 18, 'PPL', 'P'),
(146946, 'Babylon', 40.6955604553223, 0.710271520889776, -73.3261108398438, -1.27978206183758, 218, 40, 'PPL', 'P'),
(189907, 'Babylon (historical)', 39.2441711425781, 0.684939998654133, -115.513061523438, -2.01608325264276, 218, 39, 'PPL', 'P'),
(44537, 'Babylon Heights', 39.7069396972656, 0.693016833608126, -77.0888900756836, -1.34545494852866, 218, 25, 'PPL', 'P'),
(188100, 'Baca (historical)', 33.5366706848145, 0.585325323607074, -105.362777709961, -1.83892738008571, 218, 38, 'PPL', 'P'),
(193092, 'Bacavi', 35.9236106872559, 0.626985285697238, -110.656669616699, -1.93132322410297, 218, 5, 'PPL', 'P'),
(188103, 'Bacaville', 34.642219543457, 0.604620791232052, -106.779998779297, -1.86366255397426, 218, 38, 'PPL', 'P'),
(62652, 'Bacchus', 35.9277801513672, 0.627058056574024, -82.2055587768555, -1.43475766409785, 218, 33, 'PPL', 'P'),
(84777, 'Bacchus', 36.5091705322266, 0.637205232959444, -83.603889465332, -1.45916313864345, 218, 50, 'PPL', 'P'),
(202950, 'Bacchus', 40.6630592346191, 0.709704267577589, -112.095283508301, -1.95643177317635, 218, 52, 'PPL', 'P'),
(39195, 'Baccus', 32.9366683959961, 0.574853308147691, -93.4555587768555, -1.63110720494721, 218, 22, 'PPL', 'P'),
(129633, 'Bach', 43.6830596923828, 0.762413218977301, -83.355827331543, -1.4548336376593, 218, 27, 'PPL', 'P'),
(75044, 'Bache', 34.8941688537598, 0.609018136244964, -95.6483306884766, -1.66937829455025, 218, 42, 'PPL', 'P'),
(84778, 'Bachelder', 35.542781829834, 0.620338568248618, -87.3211135864258, -1.52404093859108, 218, 50, 'PPL', 'P'),
(53305, 'Bachelor', 38.9933280944824, 0.680561961559125, -91.7719421386719, -1.60172255126955, 218, 29, 'PPL', 'P'),
(62653, 'Bachelor', 34.9077796936035, 0.609255690214199, -76.7538909912109, -1.33960811151345, 218, 33, 'PPL', 'P'),
(200355, 'Bachelor Flat (historical)', 45.8480606079102, 0.800199613261945, -122.866668701172, -2.14442790979251, 218, 43, 'PPL', 'P'),
(112886, 'Bachelors Chapel', 34.0194396972656, 0.593751232400948, -85.870002746582, -1.49871427662443, 218, 2, 'PPL', 'P'),
(99576, 'Bachelors Hall', 36.6030616760254, 0.638843942557197, -79.5313873291016, -1.38808456757172, 218, 53, 'PPL', 'P'),
(34635, 'Bachelors Rest', 38.644718170166, 0.674477570574675, -84.2358322143555, -1.47019262029801, 218, 21, 'PPL', 'P'),
(19010, 'Bachlott', 31.1144409179688, 0.543049438935802, -82.0036087036133, -1.43123297039513, 218, 13, 'PPL', 'P'),
(71727, 'Bachman', 39.8627815246582, 0.695736786608451, -84.4572219848633, -1.4740566007236, 218, 41, 'PPL', 'P'),
(108062, 'Bachman', 38.0994415283203, 0.66496069784025, -81.1222229003906, -1.41584988614856, 218, 58, 'PPL', 'P'),
(79632, 'Bachman Chapel', 34.2519416809082, 0.597809157532929, -81.5077819824219, -1.42257916159097, 218, 48, 'PPL', 'P'),
(44538, 'Bachman Mills', 39.6624984741211, 0.69224118794064, -76.9472198486328, -1.34298233661458, 218, 25, 'PPL', 'P'),
(44539, 'Bachman Valley Estates', 39.6650009155273, 0.692284863782517, -76.9388885498047, -1.34283692801906, 218, 25, 'PPL', 'P'),
(158859, 'Bachmanville', 40.2425003051758, 0.70236412956014, -76.5950012207031, -1.33683496187035, 218, 45, 'PPL', 'P'),
(191097, 'Back', 35.3647193908691, 0.61723079241455, -100.609443664551, -1.75596605054616, 218, 51, 'PPL', 'P'),
(44540, 'Back Bay', 38.8305587768555, 0.67772110104531, -76.5388870239258, -1.33585558437947, 218, 25, 'PPL', 'P'),
(124165, 'Back Bay', 42.3499984741211, 0.739146911587988, -71.0875015258789, -1.24071095864308, 218, 23, 'PPL', 'P'),
(44541, 'Back Bay Beach', 38.8313903808594, 0.677735615273251, -76.5355606079102, -1.33579752746771, 218, 25, 'PPL', 'P'),
(7213, 'Back Gate', 33.9324989318848, 0.592233829790848, -91.3927764892578, -1.59510486227681, 218, 4, 'PPL', 'P'),
(19011, 'Back Landing', 31.1502799987793, 0.543674948896834, -81.4772186279297, -1.42204573042463, 218, 13, 'PPL', 'P'),
(158860, 'Back Mountain', 41.3358306884766, 0.72144634456083, -75.9966735839844, -1.32639217460393, 218, 45, 'PPL', 'P'),
(126803, 'Back Narrows', 43.8927803039551, 0.766073534158534, -69.5924987792969, -1.21461823838887, 218, 26, 'PPL', 'P'),
(44542, 'Back River', 39.3005599975586, 0.685924169834972, -76.4936065673828, -1.33506529132599, 218, 25, 'PPL', 'P'),
(99578, 'Back River', 37.0602798461914, 0.646823905026538, -76.3386077880859, -1.33236005229069, 218, 53, 'PPL', 'P'),
(44543, 'Back River Highlands', 39.3147201538086, 0.686171311184131, -76.480827331543, -1.33484225158469, 218, 25, 'PPL', 'P'),
(126805, 'Back Settlement', 45.5386085510254, 0.794798655992237, -68.3191680908203, -1.19239442540826, 218, 26, 'PPL', 'P'),
(79633, 'Back Swamp', 34.273609161377, 0.59818732640772, -79.7261123657227, -1.39148316059683, 218, 48, 'PPL', 'P'),
(99579, 'Back Swamp', 39.2055587768555, 0.684266085740289, -77.5369415283203, -1.35327492159551, 218, 53, 'PPL', 'P'),
(99580, 'Backbone', 37.7730598449707, 0.659264262847598, -80.1555633544922, -1.3989784943268, 218, 53, 'PPL', 'P'),
(112890, 'Backems Crossroads', 31.2416706085205, 0.545270015942223, -85.6305618286133, -1.49453524424188, 218, 2, 'PPL', 'P'),
(112889, 'Backers Landing', 31.8083305358887, 0.55516009741391, -87.4577789306641, -1.52642619882141, 218, 2, 'PPL', 'P'),
(139629, 'Backoo', 48.836669921875, 0.852360685846401, -97.7099990844727, -1.70536119614469, 218, 34, 'PPL', 'P'),
(158861, 'Backup Corners', 41.9172210693359, 0.73159352094625, -79.1502838134766, -1.38143305643314, 218, 45, 'PPL', 'P'),
(108063, 'Backus', 37.8541717529297, 0.660679932704056, -80.9749984741211, -1.4132803351708, 218, 58, 'PPL', 'P'),
(134054, 'Backus', 46.8202781677246, 0.817168010726412, -94.51611328125, -1.64961737294575, 218, 28, 'PPL', 'P'),
(146945, 'Backus', 44.1694412231445, 0.770902178109984, -75.2813873291016, -1.31390807436196, 218, 40, 'PPL', 'P'),
(158862, 'Backus', 41.8022193908691, 0.729586363011685, -78.5641708374023, -1.37120345521198, 218, 45, 'PPL', 'P'),
(129634, 'Backus Beach', 44.7599983215332, 0.78120934389789, -83.5461120605469, -1.45815473269669, 218, 27, 'PPL', 'P'),
(177463, 'Backus Corner', 41.5144386291504, 0.724563641195796, -72.1050033569336, -1.25846971574006, 218, 8, 'PPL', 'P'),
(34636, 'Backusburg', 36.7058296203613, 0.640637581551365, -88.4683303833008, -1.54406364893074, 218, 21, 'PPL', 'P'),
(84779, 'Backwoods', 36.1761093139648, 0.631392218090074, -82.1502838134766, -1.43379293399297, 218, 50, 'PPL', 'P'),
(92397, 'Bacliff', 29.5066699981689, 0.514988542767477, -94.9922180175781, -1.65792696817902, 218, 51, 'PPL', 'P'),
(29137, 'Bacon', 38.4105606079102, 0.670390750144867, -86.4333267211914, -1.50854613473679, 218, 19, 'PPL', 'P'),
(53306, 'Bacon', 38.708610534668, 0.675592702702119, -92.4533309936523, -1.61361503027535, 218, 29, 'PPL', 'P'),
(92398, 'Bacon', 33.9933280944824, 0.593295498959408, -98.5449981689453, -1.71993467941988, 218, 51, 'PPL', 'P'),
(154161, 'Bacon', 40.2208290100098, 0.701985894106322, -81.7755584716797, -1.42725274298795, 218, 41, 'PPL', 'P'),
(194545, 'Bacon', 44.6361083984375, 0.779047056829827, -116.546943664551, -2.03412790008276, 218, 17, 'PPL', 'P'),
(206742, 'Bacon', 47.5008316040039, 0.829045908925247, -119.329170227051, -2.08268691413483, 218, 56, 'PPL', 'P'),
(58523, 'Bacon (historical)', 33.985279083252, 0.593155017211907, -88.8402786254883, -1.55055537040391, 218, 30, 'PPL', 'P'),
(71729, 'Bacon Flat', 38.961669921875, 0.680009422211961, -83.3627777099609, -1.45495494464696, 218, 41, 'PPL', 'P'),
(112379, 'Bacon Hall', 39.5713882446289, 0.690651014453754, -76.6822204589844, -1.33835722474943, 218, 25, 'PPL', 'P'),
(44544, 'Bacon Hill', 39.603889465332, 0.691218267765941, -75.8927764892578, -1.32457882821769, 218, 25, 'PPL', 'P'),
(146947, 'Bacon Hill', 43.1333312988281, 0.752818648518073, -73.6061096191406, -1.28466896243787, 218, 40, 'PPL', 'P'),
(112888, 'Bacon Level', 33.1286087036133, 0.578203298482902, -85.2908325195313, -1.48860584923287, 218, 2, 'PPL', 'P'),
(112512, 'Bacon Mill', 39.8175010681152, 0.69494649355497, -76.5363922119141, -1.33581204169565, 218, 45, 'PPL', 'P'),
(58524, 'Bacon Springs', 34.8711090087891, 0.608615666025225, -88.1361083984375, -1.53826528144736, 218, 30, 'PPL', 'P'),
(200356, 'Bacona', 45.7775001525879, 0.798968100994865, -123.120826721191, -2.1488638040622, 218, 43, 'PPL', 'P'),
(75045, 'Bacone', 35.7669410705566, 0.624250885047999, -95.3399963378906, -1.66399684493553, 218, 42, 'PPL', 'P'),
(13314, 'Bacons', 38.5083312988281, 0.672097170613335, -75.5699996948242, -1.31894531040579, 218, 10, 'PPL', 'P'),
(99583, 'Bacons Fork', 36.8522186279297, 0.64319255172216, -78.0602798461914, -1.36240889834421, 218, 53, 'PPL', 'P'),
(99586, 'Bacons Quarters (historical)', 37.4911117553711, 0.654343340364376, -76.605827331543, -1.33702391314969, 218, 53, 'PPL', 'P'),
(19013, 'Baconton', 31.3794403076172, 0.547674550800942, -84.1611099243164, -1.4688884703122, 218, 13, 'PPL', 'P'),
(124166, 'Baconville', 42.4230613708496, 0.740422099696945, -72.4422225952148, -1.26435530174913, 218, 23, 'PPL', 'P'),
(58526, 'Bacots', 31.2124996185303, 0.544760886120827, -90.3841705322266, -1.57750136747139, 218, 30, 'PPL', 'P'),
(99584, 'Bacova', 38.0538902282715, 0.664165677675834, -79.8438873291016, -1.3935387214842, 218, 53, 'PPL', 'P'),
(99585, 'Bacova Junction', 38.0102806091309, 0.663404546236289, -79.8747177124023, -1.39407681318245, 218, 53, 'PPL', 'P'),
(158863, 'Bacton', 40.0566711425781, 0.699120798826587, -75.586669921875, -1.31923626075488, 218, 45, 'PPL', 'P'),
(114484, 'Baculis Mobile Home Park', 41.6319389343262, 0.726614408393211, -91.5361099243164, -1.59760650264678, 218, 16, 'PPL', 'P'),
(129636, 'Bad Axe', 43.8019409179688, 0.764488087782582, -83.0008316040039, -1.44863779338323, 218, 27, 'PPL', 'P'),
(201880, 'Bad Wound', 43.3002815246582, 0.755732479645756, -101.759437561035, -1.77603723041765, 218, 49, 'PPL', 'P'),
(154162, 'Baddow Pass (historical)', 40.4944381713867, 0.70676127483597, -82.148063659668, -1.43375418499911, 218, 41, 'PPL', 'P'),
(19014, 'Baden', 30.7172203063965, 0.53611663140708, -83.5652770996094, -1.4584892257296, 218, 13, 'PPL', 'P'),
(44545, 'Baden', 38.6591682434082, 0.674729771929906, -76.7780609130859, -1.34002995623011, 218, 25, 'PPL', 'P'),
(53308, 'Baden', 38.7055587768555, 0.675539439480317, -90.2300033569336, -1.57481064266403, 218, 29, 'PPL', 'P'),
(99587, 'Baden', 37.1344413757324, 0.648118267895344, -82.5325012207031, -1.44046388620751, 218, 53, 'PPL', 'P'),
(108064, 'Baden', 38.7983283996582, 0.677158574844058, -81.8874969482422, -1.42920643796363, 218, 58, 'PPL', 'P'),
(134058, 'Baden', 47.0102806091309, 0.820484178915779, -92.5883331298828, -1.6159712620498, 218, 28, 'PPL', 'P'),
(158864, 'Baden', 40.6349983215332, 0.709214512253124, -80.2283325195313, -1.40024855585066, 218, 45, 'PPL', 'P'),
(197961, 'Baden', 48.5872192382813, 0.848006950096339, -102.003608703613, -1.780298820794, 218, 34, 'PPL', 'P'),
(44546, 'Baden Estates', 38.5911102294922, 0.673541935504703, -76.5305633544922, -1.33571030894201, 218, 25, 'PPL', 'P'),
(92400, 'Bader', 29.3713893890381, 0.51262745072404, -98.9544372558594, -1.72708073957289, 218, 51, 'PPL', 'P'),
(118700, 'Bader', 40.1730613708496, 0.701152191527072, -90.3686065673828, -1.5772297250402, 218, 18, 'PPL', 'P'),
(53309, 'Baderville', 36.5544395446777, 0.637995326275843, -89.7369384765625, -1.5662050370756, 218, 29, 'PPL', 'P'),
(31716, 'Badger', 37.1583290100098, 0.648535185763995, -94.6324996948242, -1.65164869906721, 218, 20, 'PPL', 'P'),
(34637, 'Badger', 37.4544410705566, 0.653703316175403, -85.5313873291016, -1.49280432269138, 218, 21, 'PPL', 'P'),
(114483, 'Badger', 42.6144409179688, 0.743762302915149, -94.1458282470703, -1.64315467992846, 218, 16, 'PPL', 'P'),
(134057, 'Badger', 48.7825012207031, 0.851415263659423, -96.0141677856445, -1.67576335642177, 218, 28, 'PPL', 'P'),
(141225, 'Badger', 40.0883293151855, 0.699673338173751, -96.5952835083008, -1.68590573911723, 218, 35, 'PPL', 'P'),
(169777, 'Badger', 44.485279083252, 0.776414588671311, -97.2044372558594, -1.69653747766299, 218, 49, 'PPL', 'P'),
(179888, 'Badger', 36.6313896179199, 0.63933835841357, -119.012222290039, -2.07715512907657, 218, 6, 'PPL', 'P'),
(191098, 'Badger', 31.728889465332, 0.553773589171387, -102.613891601563, -1.79095026673182, 218, 51, 'PPL', 'P'),
(206743, 'Badger', 46.2002792358398, 0.806346988006175, -119.358329772949, -2.08319584421914, 218, 56, 'PPL', 'P'),
(209284, 'Badger Basin', 44.9258308410645, 0.784103667370588, -109.07250213623, -1.90367428566577, 218, 59, 'PPL', 'P'),
(200357, 'Badger Corner', 44.9502792358398, 0.784530372356246, -122.982223510742, -2.14644472168603, 218, 43, 'PPL', 'P'),
(122181, 'Badger Grove', 40.583610534668, 0.708317626177012, -86.9636077880859, -1.51780128531508, 218, 19, 'PPL', 'P'),
(179889, 'Badger Hill (historical)', 39.3836097717285, 0.687373661837275, -121.024436950684, -2.11227490016172, 218, 6, 'PPL', 'P'),
(186376, 'Badger House Community (historical)', 37.1886100769043, 0.649063690082322, -108.533889770508, -1.89427372649195, 218, 7, 'PPL', 'P'),
(154165, 'Badgertown', 40.0297203063965, 0.698650417999052, -81.0822219848633, -1.4151517384688, 218, 41, 'PPL', 'P'),
(79634, 'Badham', 33.1955604553223, 0.579371826990202, -80.6113891601563, -1.40693415545119, 218, 48, 'PPL', 'P'),
(62656, 'Badin', 35.4058303833008, 0.617948314591245, -80.116943359375, -1.3983044482549, 218, 33, 'PPL', 'P'),
(186377, 'Badito', 37.7272186279297, 0.658464182677111, -105.013610839844, -1.83283326856328, 218, 7, 'PPL', 'P'),
(201882, 'Badnation', 43.651668548584, 0.761865340162045, -100.369438171387, -1.75177716446757, 218, 49, 'PPL', 'P'),
(53311, 'Bado', 37.2691688537598, 0.650469705979829, -92.1233291625977, -1.60785541178584, 218, 29, 'PPL', 'P'),
(75046, 'Bado', 36.2169418334961, 0.632104879997779, -98.7425003051758, -1.72338174197682, 218, 42, 'PPL', 'P'),
(134060, 'Badoura', 46.8622207641602, 0.817900047131048, -94.7658309936523, -1.65397576922772, 218, 28, 'PPL', 'P'),
(179890, 'Badwater', 36.2297210693359, 0.632327919739073, -116.76611328125, -2.03795313151449, 218, 6, 'PPL', 'P'),
(209285, 'Badwater', 43.3227806091309, 0.756125162748488, -107.426940917969, -1.87495382436397, 218, 59, 'PPL', 'P'),
(158869, 'Baederwood', 40.1066703796387, 0.699993450136779, -75.1425018310547, -1.31148406513777, 218, 45, 'PPL', 'P'),
(58527, 'Bafrick (historical)', 32.1694412231445, 0.561462667870664, -89.845832824707, -1.56810560198754, 218, 30, 'PPL', 'P'),
(92399, 'Bagby', 33.4844398498535, 0.58441372356594, -95.9191665649414, -1.67410527232709, 218, 51, 'PPL', 'P'),
(99588, 'Bagby', 37.9261093139648, 0.661935479999974, -77.2316665649414, -1.34794686836065, 218, 53, 'PPL', 'P'),
(15071, 'Bagdad', 30.5986099243164, 0.534046489712734, -87.0311126708984, -1.51897946778133, 218, 12, 'PPL', 'P'),
(34638, 'Bagdad', 38.2622184753418, 0.667801691512119, -85.0577774047852, -1.48453827014194, 218, 21, 'PPL', 'P'),
(39196, 'Bagdad', 31.4663906097412, 0.54919211985861, -92.5936126708984, -1.61606340742352, 218, 22, 'PPL', 'P'),
(99589, 'Bagdad', 37.9052810668945, 0.661571958511179, -77.4236068725586, -1.35129685869586, 218, 53, 'PPL', 'P'),
(146949, 'Bagdad', 42.482780456543, 0.741464394368575, -78.920280456543, -1.37741874056401, 218, 40, 'PPL', 'P'),
(158867, 'Bagdad', 40.6530609130859, 0.709529763947162, -79.6444396972656, -1.39005770362336, 218, 45, 'PPL', 'P'),
(179891, 'Bagdad', 34.5827789306641, 0.603583356829412, -115.874717712402, -2.02239534390041, 218, 6, 'PPL', 'P'),
(193099, 'Bagdad', 34.5811080932617, 0.603554195215475, -113.203887939453, -1.97578057060216, 218, 5, 'PPL', 'P'),
(84780, 'Bagdad (historical)', 36.3694381713867, 0.634766443191204, -85.8277816772461, -1.49797737995081, 218, 50, 'PPL', 'P'),
(206744, 'Bagdad Junction', 47.8738899230957, 0.835557004895355, -118.936393737793, -2.07583167117285, 218, 56, 'PPL', 'P'),
(158868, 'Baggaley', 40.2683296203613, 0.702814936153663, -79.3727798461914, -1.38531634477664, 218, 45, 'PPL', 'P'),
(191099, 'Bagge Estates Colonia', 31.6700000762939, 0.552745775438185, -106.283996582031, -1.85500568253484, 218, 51, 'PPL', 'P'),
(39197, 'Baggett (historical)', 30.7638893127441, 0.536931159226481, -93.0027770996094, -1.62320467388657, 218, 22, 'PPL', 'P'),
(79636, 'Baggette Crossroads', 33.6266708374023, 0.58689612259703, -80.1374969482422, -1.39866317605373, 218, 48, 'PPL', 'P'),
(84781, 'Baggettsville', 36.4766693115234, 0.636637979647257, -86.7302780151367, -1.51372891253419, 218, 50, 'PPL', 'P'),
(209286, 'Baggs', 41.035831451416, 0.716210370120653, -107.656936645508, -1.87896800707505, 218, 59, 'PPL', 'P'),
(146948, 'Baggs Corner', 43.9569396972656, 0.767193326817885, -76.0580596923828, -1.32746356431047, 218, 40, 'PPL', 'P'),
(143485, 'Baglett Grove', 42.8830604553223, 0.748450598277152, -71.1797180175781, -1.24232044004787, 218, 36, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(44547, 'Bagley', 39.4983291625977, 0.689375892923824, -76.398063659668, -1.33339775300943, 218, 25, 'PPL', 'P'),
(62657, 'Bagley', 35.5763893127441, 0.620925129478708, -78.1697235107422, -1.36431905063607, 218, 33, 'PPL', 'P'),
(112891, 'Bagley', 33.7555618286133, 0.58914569476982, -87.0016708374023, -1.518465610849, 218, 2, 'PPL', 'P'),
(114486, 'Bagley', 41.8461112976074, 0.730352421299246, -94.4297180175781, -1.64810949113655, 218, 16, 'PPL', 'P'),
(129638, 'Bagley', 45.5513916015625, 0.795021762312559, -87.5755615234375, -1.52848189286685, 218, 27, 'PPL', 'P'),
(134062, 'Bagley', 47.521671295166, 0.829409630151125, -95.398063659668, -1.66501031088836, 218, 28, 'PPL', 'P'),
(143486, 'Bagley', 43.2666702270508, 0.755145851836639, -71.779167175293, -1.2527828015483, 218, 36, 'PPL', 'P'),
(173026, 'Bagley', 42.9055595397949, 0.748843281379884, -91.1011123657227, -1.59001436301118, 218, 57, 'PPL', 'P'),
(173027, 'Bagley Junction', 45.1383285522461, 0.78781245208366, -87.751106262207, -1.53154572654293, 218, 57, 'PPL', 'P'),
(206745, 'Bagley Junction', 47.3936080932617, 0.827174505627249, -121.845001220703, -2.12659644839778, 218, 56, 'PPL', 'P'),
(112892, 'Bagley Meadows', 33.7538909912109, 0.589116533155883, -86.9938888549805, -1.51832978963341, 218, 2, 'PPL', 'P'),
(99590, 'Bagleys Mills', 36.8400001525879, 0.642979299097872, -78.1900024414063, -1.36467298474494, 218, 53, 'PPL', 'P'),
(44548, 'Bagleys Venture', 39.4963912963867, 0.68934207077798, -76.3952789306641, -1.33334915031954, 218, 25, 'PPL', 'P'),
(129640, 'Bagnall', 44.4272193908691, 0.775401255876536, -85.7586135864258, -1.49677016902867, 218, 27, 'PPL', 'P'),
(53312, 'Bagnell', 38.2266693115234, 0.667181241557158, -92.6013870239258, -1.61619909548106, 218, 29, 'PPL', 'P'),
(200358, 'Bagnell Ferry', 42.4666709899902, 0.74118323113649, -124.366668701172, -2.17060784857243, 218, 43, 'PPL', 'P'),
(44549, 'Bagtown', 39.5816688537598, 0.690830444932198, -77.6108322143555, -1.35456455735338, 218, 25, 'PPL', 'P'),
(92401, 'Bagwell', 33.6619415283203, 0.587511712283001, -95.1605606079102, -1.66086510065165, 218, 51, 'PPL', 'P'),
(62658, 'Bahama', 36.165828704834, 0.631212787611629, -78.8769378662109, -1.37666226965637, 218, 33, 'PPL', 'P'),
(15072, 'Bahama Beach', 30.1972198486328, 0.527040911307226, -85.8424987792969, -1.49823424183794, 218, 12, 'PPL', 'P'),
(62659, 'Bahama Park', 35.3227806091309, 0.616498822588942, -80.8591690063477, -1.41125872958732, 218, 33, 'PPL', 'P'),
(44550, 'Bahama View', 38.8286094665527, 0.677687079162384, -76.543327331543, -1.33593308236719, 218, 25, 'PPL', 'P'),
(179892, 'Bahia', 38.0966682434082, 0.664912294887438, -122.101936340332, -2.13108081219931, 218, 6, 'PPL', 'P'),
(169269, 'Bahia Corner', 41.4944381713867, 0.724214567355913, -71.1622161865234, -1.24201497547084, 218, 47, 'PPL', 'P'),
(15073, 'Bahia Oaks', 29.1263904571533, 0.508351412698782, -82.216667175293, -1.43495154222521, 218, 12, 'PPL', 'P'),
(15074, 'Bahia Shores', 27.735559463501, 0.484076832520764, -82.7388916015625, -1.44406607789795, 218, 12, 'PPL', 'P'),
(15075, 'Bahia Subdivision', 28.7772197723389, 0.502257234597326, -81.3633270263672, -1.42005794698699, 218, 12, 'PPL', 'P'),
(53314, 'Bahner', 38.5694389343262, 0.673163700050885, -93.1283264160156, -1.62539592283148, 218, 29, 'PPL', 'P'),
(15076, 'Bahoma', 30.8144397735596, 0.53781343120611, -85.508056640625, -1.49239712536071, 218, 12, 'PPL', 'P'),
(177465, 'Bahre Corner', 41.8450012207031, 0.730333046802316, -72.9005584716797, -1.27235477187346, 218, 8, 'PPL', 'P'),
(158871, 'Baidland', 40.1947212219238, 0.701530227243809, -79.9711074829102, -1.39575913204306, 218, 45, 'PPL', 'P'),
(129641, 'Baie de Wasai', 46.4613914489746, 0.810904255842546, -84.2447204589844, -1.47034774943151, 218, 27, 'PPL', 'P'),
(44551, 'Baie Holm', 38.8480606079102, 0.678026565622342, -76.3675003051758, -1.33286432184309, 218, 25, 'PPL', 'P'),
(44552, 'Baile', 39.5149993896484, 0.689666843272915, -77.0583267211914, -1.34492151736232, 218, 25, 'PPL', 'P'),
(7215, 'Bailes (historical)', 35.1347198486328, 0.613216543124446, -90.5638885498047, -1.58063803860328, 218, 4, 'PPL', 'P'),
(44553, 'Bailes Mill', 39.5311088562012, 0.689948006505, -77.0583267211914, -1.34492151736232, 218, 25, 'PPL', 'P'),
(7216, 'Bailey', 35.541389465332, 0.620314266903671, -91.4958267211914, -1.596903428119, 218, 4, 'PPL', 'P'),
(15077, 'Bailey', 30.5680599212646, 0.533513291572987, -83.5919418334961, -1.45895461313009, 218, 12, 'PPL', 'P'),
(19015, 'Bailey', 34.274169921875, 0.598197113524726, -83.7747192382813, -1.46214468064184, 218, 13, 'PPL', 'P'),
(39198, 'Bailey', 30.8788890838623, 0.538938283871533, -90.3383331298828, -1.57670135387993, 218, 22, 'PPL', 'P'),
(53313, 'Bailey', 38.2249984741211, 0.667152079943222, -90.4313888549805, -1.57832548267071, 218, 29, 'PPL', 'P'),
(58528, 'Bailey', 32.4674987792969, 0.56666475358597, -88.7227783203125, -1.5485046032065, 218, 30, 'PPL', 'P'),
(62661, 'Bailey', 35.7805595397949, 0.624488572175288, -78.1191711425781, -1.36343674536693, 218, 33, 'PPL', 'P'),
(75047, 'Bailey', 34.7161102294922, 0.605910426989923, -97.7977828979492, -1.70689331271982, 218, 42, 'PPL', 'P'),
(84782, 'Bailey', 35.0508308410645, 0.611752403736148, -89.7286071777344, -1.56605962848008, 218, 50, 'PPL', 'P'),
(92402, 'Bailey', 33.4319381713867, 0.583497396413871, -96.1655578613281, -1.67840561169729, 218, 51, 'PPL', 'P'),
(99591, 'Bailey', 37.2241706848145, 0.649684339774365, -81.3861083984375, -1.42045555693774, 218, 53, 'PPL', 'P'),
(114487, 'Bailey', 43.4650001525879, 0.758607362042496, -92.607780456543, -1.61631068193073, 218, 16, 'PPL', 'P'),
(129642, 'Bailey', 43.2777786254883, 0.755339729963996, -85.8102798461914, -1.49767191537377, 218, 27, 'PPL', 'P'),
(134064, 'Bailey', 45.3169403076172, 0.790929815297652, -93.6650009155273, -1.63476265985946, 218, 28, 'PPL', 'P'),
(146950, 'Bailey', 43.0724983215332, 0.751756912770486, -77.6602783203125, -1.35542755470462, 218, 40, 'PPL', 'P'),
(154163, 'Bailey', 41.4619407653809, 0.723647380622754, -83.7877807617188, -1.46237264723115, 218, 41, 'PPL', 'P'),
(158870, 'Bailey', 40.473331451416, 0.706392893078185, -77.0716705322266, -1.34515441079964, 218, 45, 'PPL', 'P'),
(186378, 'Bailey', 39.4055595397949, 0.687756757560083, -105.472778320313, -1.84084725291555, 218, 7, 'PPL', 'P'),
(199819, 'Bailey (historical)', 40.3875007629395, 0.704894864965015, -117.052223205566, -2.04294669171645, 218, 39, 'PPL', 'P'),
(7217, 'Bailey Addition', 35.0369415283203, 0.611509989497924, -92.0374984741211, -1.60635738367267, 218, 4, 'PPL', 'P'),
(177466, 'Bailey Beach', 41.4952812194824, 0.724229281320936, -72.4244384765625, -1.26404491032408, 218, 8, 'PPL', 'P'),
(62662, 'Bailey Camp', 36.1044387817383, 0.630141331326063, -81.646110534668, -1.42499345027718, 218, 33, 'PPL', 'P'),
(126806, 'Bailey Corner', 44.1722183227539, 0.770950647641823, -69.745002746582, -1.21727993474034, 218, 26, 'PPL', 'P'),
(112893, 'Bailey Cove Estates', 34.6650009155273, 0.605018401182801, -86.5441665649414, -1.51048065495262, 218, 2, 'PPL', 'P'),
(34639, 'Bailey Creek', 36.8788909912109, 0.643658072280706, -83.190559387207, -1.45194916788264, 218, 21, 'PPL', 'P'),
(112895, 'Bailey Crossroads', 31.1908302307129, 0.544382683956523, -85.5938873291016, -1.49389515347388, 218, 2, 'PPL', 'P'),
(7219, 'Bailey Estates', 34.9022216796875, 0.609158684571493, -92.0188903808594, -1.60603261117774, 218, 4, 'PPL', 'P'),
(118704, 'Bailey Falls (historical)', 41.2772216796875, 0.720423424386131, -89.0441665649414, -1.55411388625248, 218, 18, 'PPL', 'P'),
(179894, 'Bailey Flats (historical)', 37.3430595397949, 0.6517593417377, -119.811111450195, -2.09109837527979, 218, 6, 'PPL', 'P'),
(15078, 'Bailey Hall', 27.2830600738525, 0.476179228308134, -82.5630569458008, -1.4409971842158, 218, 12, 'PPL', 'P'),
(126807, 'Bailey Island', 43.7275009155273, 0.763188864644787, -69.9955596923828, -1.22165297840831, 218, 26, 'PPL', 'P'),
(154164, 'Bailey Lake', 40.9458312988281, 0.714639571130697, -82.3597183227539, -1.43744825574716, 218, 41, 'PPL', 'P'),
(171701, 'Bailey Mills', 43.5052795410156, 0.75931036999125, -72.5702819824219, -1.26659035969398, 218, 55, 'PPL', 'P'),
(92403, 'Bailey Prairie', 29.1516704559326, 0.508792631912381, -95.5086135864258, -1.66693977109812, 218, 51, 'PPL', 'P'),
(112902, 'Bailey Springs', 34.8955612182617, 0.609042437589911, -87.5713882446289, -1.52840905541103, 218, 2, 'PPL', 'P'),
(62663, 'Bailey Town', 36.3194389343262, 0.633893791881012, -80.1425018310547, -1.39875052773749, 218, 33, 'PPL', 'P'),
(84783, 'Bailey Town', 35.957218170166, 0.627571846927328, -83.2808303833008, -1.45352469398353, 218, 50, 'PPL', 'P'),
(79637, 'Bailey Town (historical)', 34.8061103820801, 0.607481225979879, -81.540283203125, -1.42314641490316, 218, 48, 'PPL', 'P'),
(191101, 'Baileyboro', 34.026668548584, 0.593877399657591, -102.81916809082, -1.79453301734631, 218, 51, 'PPL', 'P'),
(99592, 'Baileys', 37.3863906860352, 0.652515612908255, -76.4625015258789, -1.33452240593778, 218, 53, 'PPL', 'P'),
(143487, 'Baileys', 44.4072189331055, 0.775052182036654, -71.5055618286133, -1.24800748739768, 218, 36, 'PPL', 'P'),
(99593, 'Baileys Beach', 37.083610534668, 0.647231102357211, -76.6641693115234, -1.33804217279248, 218, 53, 'PPL', 'P'),
(113066, 'Baileys Corner', 42.0250015258789, 0.733474644782228, -70.6980590820313, -1.23391390575093, 218, 23, 'PPL', 'P'),
(122182, 'Baileys Corner', 41.0708312988281, 0.71682123269569, -86.9983291625977, -1.51840728762113, 218, 19, 'PPL', 'P'),
(143488, 'Baileys Corner', 43.1055603027344, 0.752333953199679, -71.581672668457, -1.24933587214941, 218, 36, 'PPL', 'P'),
(144782, 'Baileys Corner', 40.1527786254883, 0.700798190839174, -74.0725021362305, -1.29280904746775, 218, 37, 'PPL', 'P'),
(99594, 'Baileys Crossroads', 38.8502807617188, 0.678065314616203, -77.129997253418, -1.34617240412633, 218, 53, 'PPL', 'P'),
(146951, 'Baileys Gap', 41.6919403076172, 0.727661629912857, -74.0005569458008, -1.29155336701378, 218, 40, 'PPL', 'P'),
(173030, 'Baileys Harbor', 45.064998626709, 0.786532603442795, -87.1241683959961, -1.52060359657212, 218, 57, 'PPL', 'P'),
(13313, 'Baileys Landing', 38.5722198486328, 0.673212236161751, -75.6438903808594, -1.32023494616366, 218, 10, 'PPL', 'P'),
(79638, 'Baileys Landing', 32.3458290100098, 0.564541215511768, -80.8874969482422, -1.41175314544369, 218, 48, 'PPL', 'P'),
(112907, 'Baileys Landing', 31.4147205352783, 0.548290306934482, -87.5933303833008, -1.52879201797579, 218, 2, 'PPL', 'P'),
(71730, 'Baileys Mills', 39.9558296203613, 0.697360782241181, -81.228889465332, -1.41771156890858, 218, 41, 'PPL', 'P'),
(171700, 'Baileys Mills', 43.297779083252, 0.755688803803879, -72.6052780151367, -1.26720115568999, 218, 55, 'PPL', 'P'),
(19016, 'Baileys Park', 32.3113899230957, 0.563940140053737, -83.3525009155273, -1.45477558074754, 218, 13, 'PPL', 'P'),
(146952, 'Baileys Settlement', 42.8869400024414, 0.748518309147868, -76.1563873291016, -1.32917970531691, 218, 40, 'PPL', 'P'),
(206746, 'Baileysburg', 46.2991714477539, 0.808072982708655, -117.951667785645, -2.05864496107803, 218, 56, 'PPL', 'P'),
(108065, 'Baileysville', 37.589168548584, 0.656054754259889, -81.679443359375, -1.42557521781731, 218, 58, 'PPL', 'P'),
(84784, 'Baileyton', 36.334171295166, 0.634150920084259, -82.8369369506836, -1.44577729205638, 218, 50, 'PPL', 'P'),
(112901, 'Baileyton', 34.2622184753418, 0.597988521432346, -86.6127777099609, -1.51167814533677, 218, 2, 'PPL', 'P'),
(70482, 'Baileytown', 39.3194389343262, 0.686253669440842, -75.0733337402344, -1.31027685421564, 218, 37, 'PPL', 'P'),
(99595, 'Baileytown', 36.8047218322754, 0.642363576253846, -76.5113906860352, -1.33537568275104, 218, 53, 'PPL', 'P'),
(112909, 'Baileytown', 34.1636085510254, 0.596267453577882, -86.6597213745117, -1.51249746684614, 218, 2, 'PPL', 'P'),
(146953, 'Baileytown', 41.3080596923828, 0.720961649242436, -74.081672668457, -1.29296910344927, 218, 40, 'PPL', 'P'),
(31717, 'Baileyville', 39.8444404602051, 0.695416674645423, -96.1847229003906, -1.67874010473021, 218, 20, 'PPL', 'P'),
(92404, 'Baileyville', 31.0524997711182, 0.541968361980798, -96.8283309936523, -1.68997318505011, 218, 51, 'PPL', 'P'),
(118701, 'Baileyville', 42.1972198486328, 0.736480421546546, -89.5933303833008, -1.56369860301567, 218, 18, 'PPL', 'P'),
(146954, 'Baileyville', 41.4722213745117, 0.723826811101198, -74.48388671875, -1.29998906292466, 218, 40, 'PPL', 'P'),
(158872, 'Baileyville', 40.7080612182617, 0.710489700362081, -77.9855575561523, -1.3611047483584, 218, 45, 'PPL', 'P'),
(177464, 'Baileyville', 41.5130615234375, 0.724539606166958, -72.7249984741211, -1.26929067188127, 218, 8, 'PPL', 'P'),
(99596, 'Baileyville (historical)', 37.0961112976074, 0.647449281829516, -78.8405609130859, -1.3760273720525, 218, 53, 'PPL', 'P'),
(179895, 'Bailhache', 38.6036109924316, 0.673760114977008, -122.853607177734, -2.1441999432032, 218, 6, 'PPL', 'P'),
(84785, 'Bain', 36.1669387817383, 0.63123216210856, -88.148063659668, -1.53847394011877, 218, 50, 'PPL', 'P'),
(134065, 'Bain', 46.790828704834, 0.816654020636027, -93.5894393920898, -1.63344386248765, 218, 28, 'PPL', 'P'),
(31718, 'Bain City', 39.2838897705078, 0.685633219485881, -94.9036102294922, -1.65638047053401, 218, 20, 'PPL', 'P'),
(209288, 'Bain Place', 43.5013885498047, 0.759242459383453, -109.465560913086, -1.91053445547576, 218, 59, 'PPL', 'P'),
(19017, 'Bainbridge', 30.9036102294922, 0.539369749257639, -84.5755615234375, -1.47612201530702, 218, 13, 'PPL', 'P'),
(26431, 'Bainbridge', 37.7338905334473, 0.658580629395774, -88.9930572509766, -1.55322186044535, 218, 18, 'PPL', 'P'),
(29138, 'Bainbridge', 39.7611083984375, 0.693962255795104, -86.8119430541992, -1.5151542363496, 218, 19, 'PPL', 'P'),
(34640, 'Bainbridge', 36.9955596923828, 0.645694325250181, -87.6611099243164, -1.529974994132, 218, 21, 'PPL', 'P'),
(44554, 'Bainbridge', 38.3916702270508, 0.670061050801915, -75.1738891601563, -1.312031877374, 218, 25, 'PPL', 'P'),
(53315, 'Bainbridge', 37.4105606079102, 0.652937457624924, -89.4369430541992, -1.56096912921445, 218, 29, 'PPL', 'P'),
(146955, 'Bainbridge', 42.2933311462402, 0.73815788013816, -75.4797210693359, -1.31736965114685, 218, 40, 'PPL', 'P'),
(154166, 'Bainbridge', 41.3863906860352, 0.722328782988028, -81.3397216796875, -1.41964595596636, 218, 41, 'PPL', 'P'),
(158873, 'Bainbridge', 40.0908317565918, 0.699717014015629, -76.6677780151367, -1.33810515655226, 218, 45, 'PPL', 'P'),
(206747, 'Bainbridge', 47.6552810668945, 0.831741560580626, -122.516670227051, -2.13831928404215, 218, 56, 'PPL', 'P'),
(112911, 'Bainbridge (historical)', 34.8008308410645, 0.607389080606162, -87.5899963378906, -1.52873382790597, 218, 2, 'PPL', 'P'),
(129643, 'Bainbridge Center', 42.1155586242676, 0.735055164310163, -86.2816696166992, -1.50589921892936, 218, 27, 'PPL', 'P'),
(206748, 'Bainbridge Grange', 47.6561088562012, 0.831756008229539, -122.519439697266, -2.13836762041593, 218, 56, 'PPL', 'P'),
(191102, 'Bainer', 33.8611106872559, 0.590987869874855, -102.239440917969, -1.78441486941677, 218, 51, 'PPL', 'P'),
(39199, 'Bains', 30.8305606842041, 0.538094794175277, -91.3866729736328, -1.59499833583321, 218, 22, 'PPL', 'P'),
(146957, 'Bains Corner', 41.7388916015625, 0.728481084580275, -73.5625, -1.28390783099833, 218, 40, 'PPL', 'P'),
(122183, 'Bainter Town', 41.5169410705566, 0.724607317037673, -85.8172225952148, -1.49779308920337, 218, 19, 'PPL', 'P'),
(92407, 'Bainville', 28.7452793121338, 0.501699768402145, -97.932502746582, -1.70924461764625, 218, 51, 'PPL', 'P'),
(195914, 'Bainville', 48.1399993896484, 0.840201491257426, -104.222221374512, -1.81902091672764, 218, 31, 'PPL', 'P'),
(77819, 'Bair', 39.9052810668945, 0.696478543551065, -76.8280563354492, -1.34090254096128, 218, 45, 'PPL', 'P'),
(202956, 'Bair Estates', 40.6022186279297, 0.708642398671948, -111.797218322754, -1.95122955430299, 218, 52, 'PPL', 'P'),
(15079, 'Baird', 27.687219619751, 0.483233143087427, -81.9561080932617, -1.43040392834779, 218, 12, 'PPL', 'P'),
(53316, 'Baird', 36.4474983215332, 0.636128849825861, -90.0036087036133, -1.57085931055468, 218, 29, 'PPL', 'P'),
(58529, 'Baird', 33.4249992370605, 0.583376289163299, -90.5833282470703, -1.58097732532616, 218, 30, 'PPL', 'P'),
(92405, 'Baird', 32.3938903808594, 0.565380044676116, -99.3938903808594, -1.73475064351232, 218, 51, 'PPL', 'P'),
(114488, 'Baird', 41.7986106872559, 0.729523379251905, -95.654167175293, -1.66948016046195, 218, 16, 'PPL', 'P'),
(62666, 'Baird (historical)', 35.7880592346191, 0.624619466542866, -81.4055633544922, -1.42079510997673, 218, 33, 'PPL', 'P'),
(193357, 'Baird (historical)', 40.7924995422363, 0.711963427130304, -122.295280456543, -2.13445530361655, 218, 6, 'PPL', 'P'),
(195915, 'Baird (historical)', 46.7166709899902, 0.815359724346248, -113.516670227051, -1.98123965136266, 218, 31, 'PPL', 'P'),
(206749, 'Baird (historical)', 47.6202812194824, 0.831130698005589, -119.468612670898, -2.08512064389699, 218, 56, 'PPL', 'P'),
(146958, 'Baird Corners', 43.2222213745117, 0.754370073011099, -76.460563659668, -1.33448858379193, 218, 40, 'PPL', 'P'),
(124167, 'Baird Four Corners', 42.1208305358887, 0.735147176525825, -72.9319381713867, -1.27290245095163, 218, 23, 'PPL', 'P'),
(188104, 'Baird Place', 32.160831451416, 0.561312399006156, -103.42749786377, -1.80515037482218, 218, 38, 'PPL', 'P'),
(158875, 'Bairdford', 40.6311111450195, 0.709146668224354, -79.8816680908203, -1.39419812017011, 218, 45, 'PPL', 'P'),
(84786, 'Bairds Mill', 36.1022186279297, 0.630102582332203, -86.331672668457, -1.50677193681857, 218, 50, 'PPL', 'P'),
(139021, 'Bairdston', 40.2847213745117, 0.703101026233765, -93.1958312988281, -1.62657410529773, 218, 29, 'PPL', 'P'),
(19018, 'Bairdstown', 33.6980590820313, 0.588142082513023, -83.1188888549805, -1.45069828111863, 218, 13, 'PPL', 'P'),
(154168, 'Bairdstown', 41.172779083252, 0.718600557198999, -83.6080627441406, -1.45923597609926, 218, 41, 'PPL', 'P'),
(158874, 'Bairdstown', 40.4324989318848, 0.70568023117048, -79.279167175293, -1.38368249544787, 218, 45, 'PPL', 'P'),
(144783, 'Bairdsville', 40.2419395446777, 0.702354342443134, -74.3841705322266, -1.2982486871523, 218, 37, 'PPL', 'P'),
(209287, 'Bairoil', 42.2444381713867, 0.737304536745871, -107.558891296387, -1.87725679291662, 218, 59, 'PPL', 'P'),
(15080, 'Bairs Den', 27.2080593109131, 0.474870218053333, -81.32861328125, -1.419452077839, 218, 12, 'PPL', 'P'),
(108067, 'Baisden', 37.5838890075684, 0.655962608886172, -81.9052810668945, -1.42951682938868, 218, 58, 'PPL', 'P'),
(146959, 'Baiting Hollow', 40.9561080932617, 0.714818935030114, -72.7447204589844, -1.26963488545216, 218, 40, 'PPL', 'P'),
(34641, 'Baizetown', 37.3705596923828, 0.652239309945159, -86.7108306884766, -1.51338949265326, 218, 21, 'PPL', 'P'),
(179896, 'Bak', 38.4575004577637, 0.671210005075203, -122.670280456543, -2.14100028831153, 218, 6, 'PPL', 'P'),
(200359, 'Bakeoven', 45.086669921875, 0.786910838896613, -120.838607788086, -2.10903156942816, 218, 43, 'PPL', 'P'),
(7223, 'Baker', 36.2805595397949, 0.63321521843526, -91.4138870239258, -1.59547331061363, 218, 4, 'PPL', 'P'),
(15082, 'Baker', 30.7969398498535, 0.537507999918592, -86.6813888549805, -1.51287563572093, 218, 12, 'PPL', 'P'),
(29140, 'Baker', 39.1305618286133, 0.682957142064515, -87.3125, -1.52389060314755, 218, 19, 'PPL', 'P'),
(31719, 'Baker', 39.7541694641113, 0.693841148544532, -95.5627822875977, -1.6678851932851, 218, 20, 'PPL', 'P'),
(39200, 'Baker', 30.5880603790283, 0.533862365412869, -91.1680603027344, -1.59118282493945, 218, 22, 'PPL', 'P'),
(44560, 'Baker', 39.0077781677246, 0.680814162914355, -76.1388931274414, -1.32887437389794, 218, 25, 'PPL', 'P'),
(53317, 'Baker', 36.7727813720703, 0.641806110058665, -89.7641677856445, -1.56668027817212, 218, 29, 'PPL', 'P'),
(58530, 'Baker', 34.502498626709, 0.602182201200894, -88.9472198486328, -1.55242184685389, 218, 30, 'PPL', 'P'),
(77814, 'Baker', 39.8355598449707, 0.695261678669981, -75.8069381713867, -1.32308066694647, 218, 45, 'PPL', 'P'),
(108068, 'Baker', 39.0416717529297, 0.681405717571489, -78.745002746582, -1.37435956741983, 218, 58, 'PPL', 'P'),
(118703, 'Baker', 41.5555610656738, 0.725281363109572, -88.8111114501953, -1.55004630716154, 218, 18, 'PPL', 'P'),
(134067, 'Baker', 46.7130584716797, 0.815296674007441, -96.5516662597656, -1.68514447451963, 218, 28, 'PPL', 'P'),
(139631, 'Baker', 48.1605606079102, 0.840560352214314, -99.647216796875, -1.73917202355407, 218, 34, 'PPL', 'P'),
(146960, 'Baker', 42.9772186279297, 0.750093968406813, -77.7922210693359, -1.35773039009922, 218, 40, 'PPL', 'P'),
(154169, 'Baker', 40.0558280944824, 0.699106084861565, -84.7013931274414, -1.47831819109995, 218, 41, 'PPL', 'P'),
(179898, 'Baker', 35.2649993896484, 0.615490350063156, -116.073608398438, -2.02586664122328, 218, 6, 'PPL', 'P'),
(189909, 'Baker', 39.0133285522461, 0.680911035399007, -114.121940612793, -1.99180361245867, 218, 39, 'PPL', 'P'),
(190951, 'Baker', 36.8694381713867, 0.643493089451176, -101.017501831055, -1.76308800909131, 218, 42, 'PPL', 'P'),
(191103, 'Baker', 34.2013893127441, 0.596926852263786, -100.110832214355, -1.74726363905211, 218, 51, 'PPL', 'P'),
(194546, 'Baker', 45.0947189331055, 0.787051320644115, -113.733612060547, -1.98502600064248, 218, 17, 'PPL', 'P'),
(195916, 'Baker', 46.3669395446777, 0.809255759127787, -104.284172058105, -1.82010216013021, 218, 31, 'PPL', 'P'),
(206750, 'Baker', 45.7547187805176, 0.798570491044116, -122.660278320313, -2.14082571810207, 218, 56, 'PPL', 'P'),
(212293, 'Baker', 64.9669418334961, 1.13388703994615, -150.459716796875, -2.62601744972369, 218, 1, 'PPL', 'P'),
(53318, 'Baker (historical)', 38.1980590820313, 0.666681898852768, -93.5897216796875, -1.63344878933566, 218, 29, 'PPL', 'P'),
(141226, 'Baker (historical)', 42.9888916015625, 0.750297700230204, -98.7305603027344, -1.72317334962152, 218, 35, 'PPL', 'P'),
(84787, 'Baker Bluff Subdivision', 36.4666709899902, 0.63646347601683, -82.4663925170898, -1.43931007166523, 218, 50, 'PPL', 'P'),
(124168, 'Baker Bridge', 42.4277801513672, 0.740504457953656, -71.3369369506836, -1.24506442807703, 218, 23, 'PPL', 'P'),
(200360, 'Baker City', 44.7750015258789, 0.781471199212072, -117.83332824707, -2.05657954649462, 218, 43, 'PPL', 'P'),
(126809, 'Baker Corner', 43.8247184753418, 0.764885631154304, -70.3888931274414, -1.22851794190826, 218, 26, 'PPL', 'P'),
(143489, 'Baker Corner', 43.1375007629395, 0.752891419394859, -72.2494430541992, -1.26099066402792, 218, 36, 'PPL', 'P'),
(146961, 'Baker Corner', 41.5875015258789, 0.725838829304753, -73.5633316040039, -1.28392234522627, 218, 40, 'PPL', 'P'),
(146962, 'Baker Corners', 43.1094398498535, 0.752401664070394, -75.1425018310547, -1.31148406513777, 218, 40, 'PPL', 'P'),
(7226, 'Baker Creek (historical)', 35.336109161377, 0.61673144971016, -93.1327819824219, -1.62547368713531, 218, 4, 'PPL', 'P'),
(62667, 'Baker Crossroads', 35.3925018310547, 0.617715687470026, -81.4527816772461, -1.42161922517605, 218, 33, 'PPL', 'P'),
(79642, 'Baker Crossroads', 33.9936103820801, 0.593300425807425, -79.0566711425781, -1.37979920710438, 218, 48, 'PPL', 'P'),
(84788, 'Baker Crossroads', 35.9961090087891, 0.628250620110162, -85.1105575561523, -1.485459457563, 218, 50, 'PPL', 'P'),
(7225, 'Baker Den (historical)', 36.4555587768555, 0.636269531310445, -91.1388931274414, -1.59067376169708, 218, 4, 'PPL', 'P'),
(7227, 'Baker Ford', 36.3763885498047, 0.634887750178857, -91.5611114501953, -1.59804286159139, 218, 4, 'PPL', 'P'),
(108069, 'Baker Heights', 39.4233283996582, 0.688066882669023, -77.9255599975586, -1.36005759341778, 218, 58, 'PPL', 'P'),
(206751, 'Baker Heights', 48.4355583190918, 0.845359967709882, -122.251670837402, -2.133694172177, 218, 56, 'PPL', 'P'),
(79640, 'Baker Hill', 32.3730583190918, 0.565016456608293, -81.1213912963867, -1.41583537192062, 218, 48, 'PPL', 'P'),
(112912, 'Baker Hill', 31.7811107635498, 0.554685022764953, -85.3022232055664, -1.48880465420825, 218, 2, 'PPL', 'P'),
(7228, 'Baker Hollow', 35.9347190856934, 0.627179163824595, -92.710563659668, -1.61810458724101, 218, 4, 'PPL', 'P'),
(79641, 'Baker Place', 34.7077789306641, 0.605765018394405, -80.6975021362305, -1.40843711041238, 218, 48, 'PPL', 'P'),
(19026, 'Baker Ridge', 34.0688896179199, 0.594614296331216, -84.6288909912109, -1.477052790108, 218, 13, 'PPL', 'P'),
(108071, 'Baker Ridge', 39.6738891601563, 0.692439992916014, -79.9480590820313, -1.3953568615604, 218, 58, 'PPL', 'P'),
(15084, 'Baker Settlement', 30.8669395446777, 0.538729725068666, -85.9049987792969, -1.49932507262044, 218, 12, 'PPL', 'P'),
(7232, 'Baker Springs', 34.3125, 0.598866099590554, -94.1675033569336, -1.6435329819613, 218, 4, 'PPL', 'P'),
(158878, 'Baker Station', 40.0752792358398, 0.699445571321522, -80.2263870239258, -1.40021460054676, 218, 45, 'PPL', 'P'),
(19022, 'Baker Village', 32.4244384765625, 0.56591320952635, -84.9388885498047, -1.4824632681786, 218, 13, 'PPL', 'P'),
(206752, 'Baker-Langdon', 46.0247192382813, 0.803282888013984, -118.323608398438, -2.06513654939315, 218, 56, 'PPL', 'P'),
(383, 'Bakerfield (historical)', 32.1805610656738, 0.561656745735103, -83.9855575561523, -1.46582450347806, 218, 13, 'PPL', 'P'),
(34645, 'Bakers', 37.1838912963867, 0.648981331825611, -88.0355606079102, -1.53651039144705, 218, 21, 'PPL', 'P'),
(39204, 'Bakers', 32.3411102294922, 0.564458857255058, -91.521110534668, -1.59734471391162, 218, 22, 'PPL', 'P'),
(62668, 'Bakers', 35.0272216796875, 0.611340346136485, -80.603889465332, -1.40680326108362, 218, 33, 'PPL', 'P'),
(84789, 'Bakers', 36.3722190856934, 0.634814979302071, -86.7600021362305, -1.51424769631454, 218, 50, 'PPL', 'P'),
(158876, 'Bakers', 40.047779083252, 0.698965603114063, -80.1613922119141, -1.39908022708044, 218, 45, 'PPL', 'P'),
(195917, 'Bakers (historical)', 48.3208312988281, 0.843357603465279, -105.887222290039, -1.84808066475231, 218, 31, 'PPL', 'P'),
(118705, 'Bakers Acres', 41.9474983215332, 0.732121958685549, -88.3466720581055, -1.54194031059362, 218, 18, 'PPL', 'P'),
(19023, 'Bakers Bridge Estates', 33.8152809143066, 0.590187989441449, -84.8147201538086, -1.48029612084155, 218, 13, 'PPL', 'P'),
(122184, 'Bakers Corner', 40.1305618286133, 0.700410434584458, -86.1374969482422, -1.50338293117339, 218, 19, 'PPL', 'P'),
(173032, 'Bakers Corners', 43.2677803039551, 0.755165226333569, -89.1869430541992, -1.55660580608446, 218, 57, 'PPL', 'P'),
(19024, 'Bakers Crossing', 31.9869403839111, 0.558277427338388, -81.0722198486328, -1.41497716825934, 218, 13, 'PPL', 'P'),
(99597, 'Bakers Crossing', 36.6719398498535, 0.640046093473259, -76.67138671875, -1.33816814031204, 218, 53, 'PPL', 'P'),
(191104, 'Bakers Crossing', 29.9619407653809, 0.522934516643406, -101.147499084473, -1.765356889182, 218, 51, 'PPL', 'P'),
(158877, 'Bakers Crossroad', 40.6241683959961, 0.709025494394755, -78.6952819824219, -1.37349177637863, 218, 45, 'PPL', 'P'),
(26432, 'Bakers Crossroads', 37.628059387207, 0.656733527442723, -89.1147232055664, -1.55534533194053, 218, 18, 'PPL', 'P'),
(34642, 'Bakers Crossroads', 36.5522193908691, 0.637956577281983, -88.3569412231445, -1.54211954133498, 218, 21, 'PPL', 'P'),
(62669, 'Bakers Crossroads', 36.3669395446777, 0.634722833928354, -79.8099975585938, -1.3929472334061, 218, 33, 'PPL', 'P'),
(84790, 'Bakers Crossroads', 36.0133285522461, 0.628551157839177, -85.5522232055664, -1.49316797733823, 218, 50, 'PPL', 'P'),
(124169, 'Bakers Grove', 42.5352783203125, 0.742380654941616, -71.8833312988281, -1.25460080846644, 218, 23, 'PPL', 'P'),
(15085, 'Bakers Mill', 30.579439163208, 0.533711896811279, -82.9394378662109, -1.44756627051864, 218, 12, 'PPL', 'P'),
(146963, 'Bakers Mills', 43.6147193908691, 0.761220455704082, -74.0252838134766, -1.29198493226843, 218, 40, 'PPL', 'P'),
(108073, 'Bakers Run', 38.6349983215332, 0.674307927213237, -80.5930633544922, -1.40661430980427, 218, 58, 'PPL', 'P'),
(158886, 'Bakers Summit', 40.2625007629395, 0.702713203400022, -78.4216690063477, -1.36871632906996, 218, 45, 'PPL', 'P'),
(44555, 'Bakersfield', 39.563060760498, 0.690505672437263, -76.4888916015625, -1.3349829996483, 218, 25, 'PPL', 'P'),
(53320, 'Bakersfield', 36.5224990844727, 0.637437860080663, -92.1419372558594, -1.60818018428077, 218, 29, 'PPL', 'P'),
(171702, 'Bakersfield', 44.7819404602051, 0.781592306462643, -72.8033294677734, -1.27065780562686, 218, 55, 'PPL', 'P'),
(179904, 'Bakersfield', 35.3733291625977, 0.617381061279058, -119.017776489258, -2.07725206814025, 218, 6, 'PPL', 'P'),
(191105, 'Bakersfield', 30.8911094665527, 0.539151569785334, -102.297500610352, -1.78542820221154, 218, 51, 'PPL', 'P'),
(34643, 'Bakersport', 37.2077789306641, 0.649398249694263, -87.3447189331055, -1.52445292961172, 218, 21, 'PPL', 'P'),
(146964, 'Bakerstand', 42.3505592346191, 0.739156698704994, -78.5488891601563, -1.37093673962881, 218, 40, 'PPL', 'P'),
(15086, 'Bakerstown', 29.3477802276611, 0.512215393124378, -81.4916687011719, -1.42229793177986, 218, 12, 'PPL', 'P'),
(158879, 'Bakerstown', 40.6508293151855, 0.70949081521622, -79.9366683959961, -1.39515805658503, 218, 45, 'PPL', 'P'),
(158880, 'Bakerstown Station', 40.6552810668945, 0.709568512941023, -79.9727783203125, -1.39578829365699, 218, 45, 'PPL', 'P'),
(15087, 'Bakersville', 29.9058303833008, 0.521955205731557, -81.4913864135742, -1.42229300493184, 218, 12, 'PPL', 'P'),
(44556, 'Bakersville', 39.514720916748, 0.689661983003926, -77.7577819824219, -1.35712931464119, 218, 25, 'PPL', 'P'),
(62670, 'Bakersville', 36.0155601501465, 0.628590106570119, -82.1588897705078, -1.43394313627845, 218, 33, 'PPL', 'P'),
(129645, 'Bakersville', 42.4900016784668, 0.741590428467163, -86.0697174072266, -1.50219995501718, 218, 27, 'PPL', 'P'),
(144784, 'Bakersville', 40.2747192382813, 0.70292645602431, -74.706672668457, -1.30387741127423, 218, 37, 'PPL', 'P'),
(154170, 'Bakersville', 40.3555603027344, 0.704337398769834, -81.6458282470703, -1.42498852342917, 218, 41, 'PPL', 'P'),
(158882, 'Bakersville', 40.0422210693359, 0.698868597471357, -79.216667175293, -1.38259166466538, 218, 45, 'PPL', 'P'),
(177467, 'Bakersville', 41.8319396972656, 0.730105080213005, -73.0305633544922, -1.2746237851222, 218, 8, 'PPL', 'P'),
(53321, 'Bakersville (historical)', 38.5694389343262, 0.673163700050885, -92.022216796875, -1.6060906680895, 218, 29, 'PPL', 'P'),
(84791, 'Bakersworks', 36.077220916748, 0.62966628996662, -87.2633285522461, -1.52303239948627, 218, 50, 'PPL', 'P'),
(34644, 'Bakerton', 36.848331451416, 0.64312470769339, -85.333610534668, -1.48935246644447, 218, 21, 'PPL', 'P'),
(84792, 'Bakerton', 36.5127792358398, 0.637268216719224, -85.8047180175781, -1.49757484315204, 218, 50, 'PPL', 'P'),
(108072, 'Bakerton', 39.3627815246582, 0.687010140348479, -77.7633285522461, -1.35722612054681, 218, 58, 'PPL', 'P'),
(158883, 'Bakerton', 40.6027793884277, 0.708652185788954, -78.745002746582, -1.37435956741983, 218, 45, 'PPL', 'P'),
(62672, 'Bakertown', 35.9300003051758, 0.627096805567885, -79.9674987792969, -1.39569614828328, 218, 33, 'PPL', 'P'),
(84794, 'Bakertown', 35.2586097717285, 0.615378830192509, -86.3302764892578, -1.5067475688946, 218, 50, 'PPL', 'P'),
(122185, 'Bakertown', 41.3663902282715, 0.721979709148146, -85.3572235107422, -1.48976459062316, 218, 19, 'PPL', 'P'),
(129646, 'Bakertown', 41.8050003051758, 0.729634899122552, -86.3908309936523, -1.5078044443732, 218, 27, 'PPL', 'P'),
(146965, 'Bakertown', 43.399169921875, 0.757458407769209, -74.1313934326172, -1.29383689449047, 218, 40, 'PPL', 'P'),
(53322, 'Bakerville', 36.2338905334473, 0.632400690615859, -89.9177780151367, -1.56936128244151, 218, 29, 'PPL', 'P'),
(84795, 'Bakerville', 35.9436111450195, 0.62733435953712, -87.8741683959961, -1.53369356596208, 218, 50, 'PPL', 'P'),
(118706, 'Bakerville', 40.063060760498, 0.699232318697234, -89.1966705322266, -1.55677558260396, 218, 18, 'PPL', 'P'),
(173033, 'Bakerville', 44.6272201538086, 0.77889192769633, -90.2180633544922, -1.57460225030873, 218, 57, 'PPL', 'P'),
(186379, 'Bakerville', 39.6913909912109, 0.692745457493047, -105.804443359375, -1.84663589986094, 218, 7, 'PPL', 'P'),
(193103, 'Bakerville', 31.422779083252, 0.548430955129552, -109.886672973633, -1.91788424745216, 218, 5, 'PPL', 'P'),
(84796, 'Bakewell', 35.3433303833008, 0.616857483808748, -85.133056640625, -1.48585214066573, 218, 50, 'PPL', 'P'),
(15088, 'Bal Harbour', 25.8913898468018, 0.451890000744121, -80.1272201538086, -1.39848381215432, 218, 12, 'PPL', 'P'),
(31724, 'Bala', 39.3097190856934, 0.686084026079404, -96.9494400024414, -1.6920869360073, 218, 20, 'PPL', 'P'),
(77815, 'Bala', 39.9991683959961, 0.698117186569791, -75.2333297729492, -1.31306931177664, 218, 45, 'PPL', 'P'),
(158884, 'Bala-Cynwyd', 40.0074996948242, 0.698262595165309, -75.2344436645508, -1.3130887528526, 218, 45, 'PPL', 'P'),
(179899, 'Balance Rock', 35.8061103820801, 0.624934518499822, -118.651107788086, -2.07085249204079, 218, 6, 'PPL', 'P'),
(194098, 'Balarat', 40.1591682434082, 0.700909710709821, -105.39582824707, -1.83950422077782, 218, 7, 'PPL', 'P'),
(134069, 'Balaton', 44.2333297729492, 0.7720172436584, -95.871940612793, -1.67328102396971, 218, 28, 'PPL', 'P'),
(122186, 'Balbec', 40.5308303833008, 0.707396438755954, -85.1488876342773, -1.48612844362882, 218, 19, 'PPL', 'P'),
(179900, 'Balboa', 33.5869407653809, 0.5862027020282, -117.900001525879, -2.05774321473293, 218, 6, 'PPL', 'P'),
(7233, 'Balboa (historical)', 36.0325012207031, 0.628885784030146, -91.5002822875977, -1.59698119242283, 218, 4, 'PPL', 'P'),
(179901, 'Balboa Island', 33.5944404602051, 0.586333596395778, -117.890830993652, -2.05758315875141, 218, 6, 'PPL', 'P'),
(7234, 'Balch', 35.5316696166992, 0.620144623542233, -91.065559387207, -1.58939384647719, 218, 4, 'PPL', 'P'),
(179902, 'Balch', 35.042781829834, 0.611611921988646, -116.026672363281, -2.02504745287197, 218, 6, 'PPL', 'P'),
(206753, 'Balch', 46.8147201538086, 0.817071005083706, -123.241943359375, -2.15097768817746, 218, 56, 'PPL', 'P'),
(179903, 'Balch Camp', 36.9030609130859, 0.644079916997375, -119.122222900391, -2.07907500190641, 218, 6, 'PPL', 'P'),
(92408, 'Balch Springs', 32.7286109924316, 0.571222021422341, -96.6224975585938, -1.68638071389764, 218, 51, 'PPL', 'P'),
(39205, 'Balco', 29.7199993133545, 0.51871184170849, -91.4411087036133, -1.5959484185521, 218, 22, 'PPL', 'P'),
(26434, 'Balcom', 37.4130592346191, 0.652981066887774, -89.2061080932617, -1.55694029911738, 218, 18, 'PPL', 'P'),
(146966, 'Balcom', 42.3697204589844, 0.73949112515888, -79.0966720581055, -1.38049735478414, 218, 40, 'PPL', 'P'),
(146967, 'Balcom Beach', 42.3863906860352, 0.739782075507972, -78.2016677856445, -1.36487658341028, 218, 40, 'PPL', 'P'),
(146968, 'Balcom Corners', 42.3697204589844, 0.73949112515888, -79.0905609130859, -1.38039069518248, 218, 40, 'PPL', 'P'),
(92410, 'Balcones Heights', 29.4877796173096, 0.514658843424526, -98.5513916015625, -1.72004626586955, 218, 51, 'PPL', 'P'),
(99598, 'Balcony Falls', 37.6277809143066, 0.656728667173733, -79.4561080932617, -1.38677069704793, 218, 53, 'PPL', 'P'),
(118707, 'Bald Bluff', 41.0186080932617, 0.71590976581261, -90.8536071777344, -1.58569458256502, 218, 18, 'PPL', 'P'),
(195918, 'Bald Butte', 46.7241706848145, 0.815490618713826, -112.345558166504, -1.9607998899963, 218, 31, 'PPL', 'P'),
(62674, 'Bald Creek', 35.9119415283203, 0.626781620452874, -82.4227828979492, -1.43854894022569, 218, 33, 'PPL', 'P'),
(84797, 'Bald Crossing', 36.2625007629395, 0.632900033320249, -82.5180587768555, -1.44021181801033, 218, 50, 'PPL', 'P'),
(44557, 'Bald Eagle', 38.6763916015625, 0.675030376237948, -76.7227783203125, -1.33906509296718, 218, 25, 'PPL', 'P'),
(134071, 'Bald Eagle', 45.1019401550293, 0.787177354742703, -93.0136108398438, -1.62339375832396, 218, 28, 'PPL', 'P'),
(158885, 'Bald Eagle', 40.7219390869141, 0.710731914863224, -78.1855621337891, -1.36459548675722, 218, 45, 'PPL', 'P'),
(134072, 'Bald Eagle Center', 47.4011116027832, 0.827305466573853, -94.4186096191406, -1.64791561300919, 218, 28, 'PPL', 'P'),
(13315, 'Bald Eagle Village', 38.7058296203613, 0.675544166591252, -75.0988922119141, -1.31072293369823, 218, 10, 'PPL', 'P'),
(44558, 'Bald Friar (historical)', 39.7027816772461, 0.692944262468421, -76.2102813720703, -1.33012033381393, 218, 25, 'PPL', 'P'),
(126810, 'Bald Head', 43.2208290100098, 0.754345771666152, -70.5777816772461, -1.23181466902167, 218, 26, 'PPL', 'P'),
(62675, 'Bald Head Island', 33.8616714477539, 0.590997656991861, -77.9947204589844, -1.36126467118186, 218, 33, 'PPL', 'P'),
(34646, 'Bald Hill', 38.3569412231445, 0.669454915337813, -83.7147216796875, -1.46109752570122, 218, 21, 'PPL', 'P'),
(44559, 'Bald Hill', 39.6858291625977, 0.692648385271313, -76.228889465332, -1.33044510630886, 218, 25, 'PPL', 'P'),
(58532, 'Bald Hill', 34.4130592346191, 0.600621189327944, -89.0852813720703, -1.5548314750082, 218, 30, 'PPL', 'P'),
(75048, 'Bald Hill', 35.7402801513672, 0.623785564226535, -95.8369369506836, -1.67267009481564, 218, 42, 'PPL', 'P'),
(92409, 'Bald Hill', 31.2394409179688, 0.545231100500794, -94.6447219848633, -1.65186201827053, 218, 51, 'PPL', 'P'),
(112914, 'Bald Hill', 31.163610458374, 0.543907609307566, -85.6355590820313, -1.49462246276758, 218, 2, 'PPL', 'P'),
(158888, 'Bald Hill', 41.079719543457, 0.716976361829187, -78.293327331543, -1.36647634427709, 218, 45, 'PPL', 'P'),
(84798, 'Bald Hill (historical)', 36.4880599975586, 0.636836784622632, -83.5625, -1.45844075619776, 218, 50, 'PPL', 'P'),
(126811, 'Bald Hill Crossing', 43.3424987792969, 0.756469309740354, -70.6733322143555, -1.23348234049628, 218, 26, 'PPL', 'P'),
(7236, 'Bald Knob', 35.3097190856934, 0.616270855999631, -91.5677795410156, -1.59815924173102, 218, 4, 'PPL', 'P'),
(71732, 'Bald Knob', 38.5724983215332, 0.673217096430741, -82.5130615234375, -1.44012459948463, 218, 41, 'PPL', 'P'),
(108075, 'Bald Knob', 37.8708305358887, 0.660970683316066, -81.6358337402344, -1.42481408637777, 218, 58, 'PPL', 'P'),
(802, 'Bald Knobs', 39.0250015258789, 0.681114767222398, -81.8338928222656, -1.42827086947269, 218, 41, 'PPL', 'P'),
(29142, 'Bald Knobs', 39.0200004577637, 0.681027482117671, -86.1705627441406, -1.50396003818161, 218, 19, 'PPL', 'P'),
(118709, 'Bald Mound', 41.8461112976074, 0.730352421299246, -88.4063873291016, -1.54298253868622, 218, 18, 'PPL', 'P'),
(62676, 'Bald Mountain', 35.9644393920898, 0.627697881025916, -82.4719390869141, -1.43940687757086, 218, 33, 'PPL', 'P'),
(126812, 'Bald Mountain', 44.954719543457, 0.784607870343967, -70.7911071777344, -1.23553790138366, 218, 26, 'PPL', 'P'),
(146969, 'Bald Mountain', 43.1294403076172, 0.752750737910276, -73.5386123657227, -1.28349091312968, 218, 40, 'PPL', 'P'),
(84799, 'Bald Point', 36.4111099243164, 0.635493752484905, -83.3608322143555, -1.45492098934306, 218, 50, 'PPL', 'P'),
(92411, 'Bald Prairie', 31.2233295440674, 0.544949903979196, -96.432502746582, -1.68306467886633, 218, 51, 'PPL', 'P'),
(206754, 'Balder', 47.1827812194824, 0.823494882528114, -117.404441833496, -2.04909406646067, 218, 56, 'PPL', 'P'),
(108074, 'Balderson (historical)', 39.1594390869141, 0.683461145300812, -81.6722183227539, -1.4254491171397, 218, 58, 'PPL', 'P'),
(179905, 'Balderson Station', 38.9347190856934, 0.679539041384425, -120.753059387207, -2.10753846816301, 218, 6, 'PPL', 'P'),
(79643, 'Baldock', 33.0791702270508, 0.577340434289716, -81.4236068725586, -1.42111002877563, 218, 48, 'PPL', 'P'),
(29144, 'Baldridge', 39.2230606079102, 0.684571550317321, -87.3722229003906, -1.52493296439821, 218, 19, 'PPL', 'P'),
(75050, 'Baldridge', 35.3619384765625, 0.617182256303683, -94.6197204589844, -1.65142565932592, 218, 42, 'PPL', 'P'),
(191106, 'Baldridge', 31.0277805328369, 0.541536929884205, -102.620002746582, -1.79105692633348, 218, 51, 'PPL', 'P'),
(34647, 'Baldrock', 36.9902801513672, 0.645602179876464, -84.2836074829102, -1.47102645603531, 218, 21, 'PPL', 'P'),
(722, 'Baldwin', 36.3474998474121, 0.634383547205478, -81.5330581665039, -1.42302031422554, 218, 33, 'PPL', 'P'),
(7240, 'Baldwin', 36.0483283996582, 0.629162020414214, -94.0966720581055, -1.64229674258329, 218, 4, 'PPL', 'P'),
(15089, 'Baldwin', 30.3024997711182, 0.52887839259084, -81.9755630493164, -1.43074348138677, 218, 12, 'PPL', 'P'),
(19027, 'Baldwin', 34.4916687011719, 0.601993183342525, -83.5374984741211, -1.45800439725315, 218, 13, 'PPL', 'P'),
(26437, 'Baldwin', 38.1830596923828, 0.666420110117613, -89.8424987792969, -1.56804741191772, 218, 18, 'PPL', 'P'),
(34648, 'Baldwin', 37.7966690063477, 0.65967632044726, -84.4252777099609, -1.4734990679494, 218, 21, 'PPL', 'P'),
(39206, 'Baldwin', 29.8377799987793, 0.520767502464408, -91.5441665649414, -1.59774711755234, 218, 22, 'PPL', 'P'),
(44561, 'Baldwin', 39.4947204589844, 0.689312909164043, -76.4705581665039, -1.33466302084333, 218, 25, 'PPL', 'P'),
(79644, 'Baldwin', 34.3811111450195, 0.600063589974708, -82.1466674804688, -1.43372981707513, 218, 48, 'PPL', 'P'),
(92412, 'Baldwin', 32.7058296203613, 0.570824411471592, -94.2341690063477, -1.64469651704156, 218, 51, 'PPL', 'P'),
(99599, 'Baldwin', 37.7397193908691, 0.658682362149415, -79.850830078125, -1.3936598953138, 218, 53, 'PPL', 'P'),
(108076, 'Baldwin', 38.9727783203125, 0.680203300339318, -80.7547225952148, -1.40943579582116, 218, 58, 'PPL', 'P'),
(112915, 'Baldwin', 34.1891708374023, 0.596713599639498, -86.9169387817383, -1.51698675749568, 218, 2, 'PPL', 'P'),
(114492, 'Baldwin', 42.0741691589355, 0.734332781864479, -90.8413925170898, -1.58548139651976, 218, 16, 'PPL', 'P'),
(129647, 'Baldwin', 43.9011116027832, 0.766218942754052, -85.8516693115234, -1.49839429781946, 218, 27, 'PPL', 'P'),
(146971, 'Baldwin', 40.6563911437988, 0.709587887437953, -73.6097183227539, -1.28473194619765, 218, 40, 'PPL', 'P'),
(154171, 'Baldwin', 41.0188903808594, 0.715914692660627, -84.8019409179688, -1.48007308110026, 218, 41, 'PPL', 'P'),
(158889, 'Baldwin', 40.3380584716797, 0.704031934192802, -79.9791717529297, -1.39589988010667, 218, 45, 'PPL', 'P'),
(173034, 'Baldwin', 44.9666709899902, 0.784816462436348, -92.3741683959961, -1.61223338230182, 218, 57, 'PPL', 'P'),
(186380, 'Baldwin', 38.7638893127441, 0.676557499386027, -107.047218322754, -1.86832641483326, 218, 7, 'PPL', 'P'),
(197966, 'Baldwin', 47.026668548584, 0.820770202416854, -100.749168395996, -1.75840470715635, 218, 34, 'PPL', 'P'),
(154172, 'Baldwin (historical)', 41.5830612182617, 0.725761331317031, -84.4972229003906, -1.47475474840337, 218, 41, 'PPL', 'P'),
(44562, 'Baldwin Acres', 38.9597206115723, 0.679975400329035, -76.3341674804688, -1.33228255430296, 218, 25, 'PPL', 'P'),
(118711, 'Baldwin Beach', 40.3458290100098, 0.704167555671315, -90.0319366455078, -1.57135372641105, 218, 18, 'PPL', 'P'),
(31723, 'Baldwin City', 38.7750015258789, 0.676751444092412, -95.1861114501953, -1.66131104697618, 218, 20, 'PPL', 'P'),
(146973, 'Baldwin Corner', 43.3875007629395, 0.757254742524845, -73.4938888549805, -1.28271034061417, 218, 40, 'PPL', 'P'),
(126815, 'Baldwin Corners', 44.246940612793, 0.772254797627635, -68.3591690063477, -1.19309257308803, 218, 26, 'PPL', 'P'),
(44563, 'Baldwin Estates', 39.4836082458496, 0.689118964457658, -76.4499969482422, -1.33430415988644, 218, 25, 'PPL', 'P'),
(34649, 'Baldwin Ford', 37.3455581665039, 0.65180295100055, -87.8213882446289, -1.53277237854102, 218, 21, 'PPL', 'P'),
(158890, 'Baldwin Furnace', 40.351390838623, 0.704264627893048, -79.0505599975586, -1.37969254750272, 218, 45, 'PPL', 'P'),
(146974, 'Baldwin Harbor', 40.6394386291504, 0.709292010240845, -73.60888671875, -1.28471743196971, 218, 40, 'PPL', 'P'),
(26439, 'Baldwin Heights', 38.4497184753418, 0.671074183859608, -89.1447219848633, -1.55586890941084, 218, 18, 'PPL', 'P'),
(29143, 'Baldwin Heights', 38.3413887023926, 0.669183472643707, -87.5713882446289, -1.52840905541103, 218, 19, 'PPL', 'P'),
(146975, 'Baldwin Heights', 42.0991706848145, 0.734769140809088, -78.4227828979492, -1.36873577014591, 218, 40, 'PPL', 'P'),
(19029, 'Baldwin Hills', 33.8347206115723, 0.590527276164325, -84.8708267211914, -1.48127536517437, 218, 13, 'PPL', 'P'),
(44565, 'Baldwin Hills', 39.5666694641113, 0.690568656197043, -76.4636077880859, -1.33454171385568, 218, 25, 'PPL', 'P'),
(44566, 'Baldwin Hills South', 39.0394401550293, 0.681366768840547, -76.6452789306641, -1.33771247344953, 218, 25, 'PPL', 'P'),
(179907, 'Baldwin Lake', 34.2794418334961, 0.598289125740389, -116.79638671875, -2.03848150267476, 218, 6, 'PPL', 'P'),
(44568, 'Baldwin Mill Terrace', 39.5088882446289, 0.689560183671257, -76.477783203125, -1.33478912152095, 218, 25, 'PPL', 'P'),
(53323, 'Baldwin Park', 38.7938919067383, 0.677081143435364, -94.2452774047852, -1.64489039516892, 218, 29, 'PPL', 'P'),
(179908, 'Baldwin Park', 34.0852813720703, 0.594900386411317, -117.959999084473, -2.05879036967354, 218, 6, 'PPL', 'P'),
(146976, 'Baldwin Place', 41.3474998474121, 0.721650009805194, -73.7624969482422, -1.2873984362391, 218, 40, 'PPL', 'P'),
(193106, 'Baldwin Place', 34.2855606079102, 0.598395918500101, -112.484718322754, -1.96322869291045, 218, 5, 'PPL', 'P'),
(62678, 'Baldwin Woods', 34.3424987792969, 0.599389677060864, -78.6894378662109, -1.37338977730888, 218, 33, 'PPL', 'P'),
(144785, 'Baldwins Corner', 40.3138885498047, 0.703610089476134, -74.7863922119141, -1.30526877978575, 218, 37, 'PPL', 'P'),
(177468, 'Baldwins Crossing', 41.2400016784668, 0.719773812817234, -73.0933303833008, -1.27571927643661, 218, 8, 'PPL', 'P'),
(193107, 'Baldwins Crossing', 34.8238906860352, 0.6077915508259, -111.806938171387, -1.95139919766443, 218, 5, 'PPL', 'P'),
(173037, 'Baldwins Mill', 44.3880615234375, 0.774717822161795, -88.9608306884766, -1.55265940082313, 218, 57, 'PPL', 'P'),
(146978, 'Baldwinsville', 43.1586112976074, 0.753259867731672, -76.3330612182617, -1.33226324638506, 218, 40, 'PPL', 'P'),
(19030, 'Baldwinville', 32.6505584716797, 0.569859747945738, -84.4497222900391, -1.47392570635603, 218, 13, 'PPL', 'P'),
(124170, 'Baldwinville', 42.6083297729492, 0.743655643313492, -72.0763931274414, -1.25797037303567, 218, 23, 'PPL', 'P'),
(58533, 'Baldwyn', 34.5094413757324, 0.602303375030492, -88.6352767944336, -1.54697741347939, 218, 30, 'PPL', 'P'),
(179909, 'Baldy Mesa', 34.459171295166, 0.601425996609366, -117.45027923584, -2.04989408005213, 218, 6, 'PPL', 'P'),
(179910, 'Bale', 38.5541687011719, 0.672897184204795, -122.509437561035, -2.13819305020648, 218, 6, 'PPL', 'P'),
(19031, 'Bales (historical)', 32.5800018310547, 0.568628302257686, -82.7255630493164, -1.44383345077673, 218, 13, 'PPL', 'P'),
(144786, 'Balesville', 41.1041717529297, 0.717403133393872, -74.7600021362305, -1.30480818607522, 218, 37, 'PPL', 'P'),
(206755, 'Balford', 48.9347190856934, 0.854071966583858, -122.149169921875, -2.13190519371474, 218, 56, 'PPL', 'P'),
(62680, 'Balfour', 35.3463897705078, 0.616910880188604, -82.4722213745117, -1.43941180441887, 218, 33, 'PPL', 'P'),
(114493, 'Balfour', 41.0488891601563, 0.716438270130937, -95.6675033569336, -1.66971292074122, 218, 16, 'PPL', 'P'),
(186381, 'Balfour', 38.9072189331055, 0.679059073176966, -105.723892211914, -1.84523001712149, 218, 7, 'PPL', 'P'),
(197967, 'Balfour', 47.9516716003418, 0.836914551261023, -100.534172058105, -1.75465231318042, 218, 34, 'PPL', 'P'),
(99600, 'Bali Hai', 37.288890838623, 0.650813919550722, -79.8775024414063, -1.39412541587235, 218, 53, 'PPL', 'P'),
(202959, 'Bali Hai', 40.6144409179688, 0.708855717875263, -111.867500305176, -1.95245620630108, 218, 52, 'PPL', 'P'),
(114494, 'Bali Hai Estates Mobile Home Park', 42.0527801513672, 0.733959473258677, -91.6672210693359, -1.59989482381343, 218, 16, 'PPL', 'P'),
(129650, 'Balitmore', 46.5347213745117, 0.812184104483411, -89.228889465332, -1.55733790906813, 218, 27, 'PPL', 'P'),
(39207, 'Balize (historical)', 29.1222190856934, 0.508278608532482, -89.1072235107422, -1.55521443757295, 218, 22, 'PPL', 'P'),
(34650, 'Balkan', 36.7591705322266, 0.64156855608943, -83.5444412231445, -1.45812557108275, 218, 21, 'PPL', 'P'),
(190952, 'Balko', 36.6300010681152, 0.639314123647651, -100.684440612793, -1.75727499422193, 218, 42, 'PPL', 'P'),
(112917, 'Balkum', 31.4174995422363, 0.548338809755835, -85.2275009155273, -1.48750050422243, 218, 2, 'PPL', 'P'),
(7241, 'Ball', 35.5200004577637, 0.619940958297869, -94.2666702270508, -1.64526377035375, 218, 4, 'PPL', 'P'),
(39208, 'Ball', 31.4152793884277, 0.548300060761975, -92.4116668701172, -1.61288785413971, 218, 22, 'PPL', 'P'),
(7242, 'Ball (historical)', 34.0069389343262, 0.593533052928643, -93.7083282470703, -1.63551886445098, 218, 4, 'PPL', 'P'),
(134076, 'Ball Bluff', 46.954719543457, 0.819514455383854, -93.273063659668, -1.62792206428348, 218, 28, 'PPL', 'P'),
(84800, 'Ball Camp', 35.9527816772461, 0.627494415518634, -84.121940612793, -1.46820483686037, 218, 50, 'PPL', 'P'),
(134078, 'Ball Club', 47.3258285522461, 0.825991529471036, -93.9358291625977, -1.63948950447824, 218, 28, 'PPL', 'P'),
(112918, 'Ball Flat', 34.0177803039551, 0.593722270524094, -85.73388671875, -1.49633860377403, 218, 2, 'PPL', 'P'),
(19033, 'Ball Ground', 34.6519393920898, 0.60479043459349, -84.7602767944336, -1.47934590496461, 218, 13, 'PPL', 'P'),
(58534, 'Ball Hill', 32.3152809143066, 0.564008050661534, -89.355827331543, -1.55955339277896, 218, 30, 'PPL', 'P'),
(195919, 'Ball Place', 45.1413917541504, 0.787865915042543, -112.151107788086, -1.95740609066115, 218, 31, 'PPL', 'P'),
(84801, 'Ball Play', 35.0291709899902, 0.611374368019411, -84.7022171020508, -1.47833257216984, 218, 50, 'PPL', 'P'),
(177469, 'Ball Pond', 41.4555587768555, 0.723535993910161, -73.523063659668, -1.2832195370146, 218, 8, 'PPL', 'P'),
(154173, 'Ball Subdivision', 41.1883316040039, 0.718871999893105, -84.4491729736328, -1.4739161189761, 218, 41, 'PPL', 'P'),
(195920, 'Ballantine', 45.9488906860352, 0.80195943011027, -108.144439697266, -1.88747654044174, 218, 31, 'PPL', 'P'),
(179912, 'Ballarat', 36.047779083252, 0.62915243303429, -117.222503662109, -2.04591864633492, 218, 6, 'PPL', 'P'),
(7245, 'Ballard', 36.2350006103516, 0.63242006511279, -91.6686096191406, -1.59991905857935, 218, 4, 'PPL', 'P'),
(34651, 'Ballard', 37.9302787780762, 0.662008250876761, -84.9905624389648, -1.48336514768176, 218, 21, 'PPL', 'P'),
(44569, 'Ballard', 38.7666702270508, 0.676606035496894, -76.8813934326172, -1.34183344892032, 218, 25, 'PPL', 'P'),
(53324, 'Ballard', 38.3613891601563, 0.669532546483589, -94.1430587768555, -1.64310634355467, 218, 29, 'PPL', 'P'),
(58535, 'Ballard', 32.6027793884277, 0.569025845629407, -90.07861328125, -1.57216838738851, 218, 30, 'PPL', 'P'),
(62681, 'Ballard', 35.9036102294922, 0.626636211857356, -77.149169921875, -1.3465070303173, 218, 33, 'PPL', 'P'),
(75052, 'Ballard', 36.0944404602051, 0.629966827695636, -94.5891723632813, -1.65089249447568, 218, 42, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(108077, 'Ballard', 37.4747200012207, 0.654057250284275, -80.7794418334961, -1.40986722791775, 218, 58, 'PPL', 'P'),
(179913, 'Ballard', 34.6358299255371, 0.604509271361405, -120.11222076416, -2.09635372421689, 218, 6, 'PPL', 'P'),
(202961, 'Ballard', 40.2894401550293, 0.703183384490476, -109.942497253418, -1.91885856493697, 218, 52, 'PPL', 'P'),
(206756, 'Ballard', 47.6761093139648, 0.832105082069421, -122.386108398438, -2.13604055025542, 218, 56, 'PPL', 'P'),
(146979, 'Ballard Corners', 43.1530609130859, 0.75316299524702, -73.6819381713867, -1.28599242034159, 218, 40, 'PPL', 'P'),
(92413, 'Ballard Crossing', 31.5397205352783, 0.550471968499475, -98.0883331298828, -1.71196437090949, 218, 51, 'PPL', 'P'),
(62682, 'Ballard Crossroads', 36.4102783203125, 0.635479238256964, -76.7991714477539, -1.34039840456693, 218, 33, 'PPL', 'P'),
(44570, 'Ballard Gardens', 39.3363914489746, 0.68654954663795, -76.4441680908203, -1.3342024271328, 218, 25, 'PPL', 'P'),
(202964, 'Ballard Junction', 41.7852783203125, 0.729290685551659, -111.986106872559, -1.9545262814164, 218, 52, 'PPL', 'P'),
(15090, 'Ballard Pines', 27.9155597686768, 0.487218430500676, -80.4786071777344, -1.40461667267061, 218, 12, 'PPL', 'P'),
(99601, 'Ballard Woods', 38.077220916748, 0.664572875006507, -78.5758285522461, -1.37140692071926, 218, 53, 'PPL', 'P'),
(129651, 'Ballards Corners', 43.1169395446777, 0.752532558437971, -85.7099990844727, -1.49592168590537, 218, 27, 'PPL', 'P'),
(62683, 'Ballards Crossroad', 35.547779083252, 0.620425786774318, -77.5036087036133, -1.35269315405539, 218, 33, 'PPL', 'P'),
(34654, 'Ballardsville', 38.3613891601563, 0.669532546483589, -85.345832824707, -1.48956578564779, 218, 21, 'PPL', 'P'),
(58536, 'Ballardsville', 34.2425003051758, 0.59764437444048, -88.5380630493164, -1.5452807135489, 218, 30, 'PPL', 'P'),
(124171, 'Ballardvale', 42.625, 0.743946593662583, -71.1611099243164, -1.24199566755293, 218, 23, 'PPL', 'P'),
(58537, 'Ballaston', 33.7861099243164, 0.589678859620054, -90.533332824707, -1.580104740595, 218, 30, 'PPL', 'P'),
(7246, 'Balle (historical)', 34.6838912963867, 0.605348100525753, -91.5458297729492, -1.59777614600822, 218, 4, 'PPL', 'P'),
(179914, 'Ballena', 33.0652809143066, 0.577098020051492, -116.745826721191, -2.03759906424757, 218, 6, 'PPL', 'P'),
(108078, 'Ballengee', 37.6169395446777, 0.656539449578283, -80.7383270263672, -1.40914963916203, 218, 58, 'PPL', 'P'),
(44580, 'Ballenger Creek', 39.372501373291, 0.687179783709917, -77.4355621337891, -1.35150551736727, 218, 25, 'PPL', 'P'),
(44571, 'Ballenger Creek Meadows', 39.3875007629395, 0.687441572445072, -77.4502792358398, -1.3517623792544, 218, 25, 'PPL', 'P'),
(44572, 'Ballenger Heights', 39.3616714477539, 0.686990765851549, -77.4997177124023, -1.35262524344759, 218, 25, 'PPL', 'P'),
(58538, 'Ballentine', 34.3941688537598, 0.600291489984992, -90.0963897705078, -1.5724786456555, 218, 30, 'PPL', 'P'),
(79645, 'Ballentine', 34.1241683959961, 0.595579093015124, -81.2375030517578, -1.41786190435212, 218, 48, 'PPL', 'P'),
(79646, 'Ballentine Landing', 34.1122207641602, 0.595370567501771, -81.245002746582, -1.41799279871969, 218, 48, 'PPL', 'P'),
(15091, 'Ballentine Manor', 27.4011096954346, 0.478239582885474, -82.565559387207, -1.44104086005767, 218, 12, 'PPL', 'P'),
(99602, 'Ballentine Place', 36.8691711425781, 0.643488428919268, -76.2527770996094, -1.33086202417752, 218, 53, 'PPL', 'P'),
(19034, 'Ballew Mill', 34.839168548584, 0.608058199830045, -84.3491668701172, -1.47217068319767, 218, 13, 'PPL', 'P'),
(112937, 'Ballfield Landing', 31.6124992370605, 0.551742196470902, -88.0747222900391, -1.53719389174082, 218, 2, 'PPL', 'P'),
(58539, 'Ballground', 32.5374984741211, 0.567886478736044, -90.7466735839844, -1.58382823927309, 218, 30, 'PPL', 'P'),
(92414, 'Balli Colonia Number 1', 26.1580009460449, 0.456543242248275, -98.0410003662109, -1.71113825833935, 218, 51, 'PPL', 'P'),
(92415, 'Balli Estates Colonia', 26.1410007476807, 0.456246532813327, -98.0380020141602, -1.71108592722393, 218, 51, 'PPL', 'P'),
(92416, 'Balli Number 2 Colonia', 26.1620006561279, 0.456613050358349, -98.0260009765625, -1.71087646960419, 218, 51, 'PPL', 'P'),
(179915, 'Ballico', 37.4544410705566, 0.653703316175403, -120.705001831055, -2.10669970557769, 218, 6, 'PPL', 'P'),
(158893, 'Balliet', 40.7786102294922, 0.711721012892079, -75.7113876342773, -1.32141299547186, 218, 45, 'PPL', 'P'),
(158894, 'Balliettsville', 40.6783294677734, 0.709970783423679, -75.5741729736328, -1.31901814786161, 218, 45, 'PPL', 'P'),
(39209, 'Ballina', 31.666109085083, 0.552677864830388, -91.6791687011719, -1.60010334932678, 218, 22, 'PPL', 'P'),
(146980, 'Ballina', 42.8977813720703, 0.748707526743318, -75.8475036621094, -1.32378866832227, 218, 40, 'PPL', 'P'),
(92417, 'Ballinger', 31.7380599975586, 0.553933645152901, -99.9469375610352, -1.74440313772525, 218, 51, 'PPL', 'P'),
(70483, 'Ballingers Mill', 39.5763893127441, 0.690738299558481, -75.2694396972656, -1.31369954884861, 218, 37, 'PPL', 'P'),
(143490, 'Balloch', 43.4322204589844, 0.75803524846132, -72.3925018310547, -1.26348751070793, 218, 36, 'PPL', 'P'),
(75054, 'Ballou', 36.1458282470703, 0.630863713771747, -95.1900024414063, -1.66137895758398, 218, 42, 'PPL', 'P'),
(118712, 'Ballou', 41.2775001525879, 0.72042828465512, -88.101936340332, -1.53766886652124, 218, 18, 'PPL', 'P'),
(154177, 'Ballou', 40.1997184753418, 0.701617445769509, -84.0602798461914, -1.46712865346387, 218, 41, 'PPL', 'P'),
(173038, 'Ballou', 46.3175010681152, 0.808392894934601, -90.5844421386719, -1.58099676640212, 218, 57, 'PPL', 'P'),
(179917, 'Ballou', 34.0491714477539, 0.59427014933935, -117.606109619141, -2.05261383331538, 218, 6, 'PPL', 'P'),
(177470, 'Ballouville', 41.8766708374023, 0.730885785886562, -71.8616714477539, -1.25422277274971, 218, 8, 'PPL', 'P'),
(206757, 'Ballow', 47.2405586242676, 0.824503288474872, -122.865829467773, -2.14441326240652, 218, 56, 'PPL', 'P'),
(84802, 'Ballplay', 35.4638900756836, 0.61896164738602, -84.2055587768555, -1.46966424913774, 218, 50, 'PPL', 'P'),
(112913, 'Ballplay', 34.0586090087891, 0.594434865852772, -85.8080596923828, -1.49763316637991, 218, 2, 'PPL', 'P'),
(99606, 'Balls Hill', 38.9411087036133, 0.679650561255072, -77.1944427490234, -1.34729719021272, 218, 53, 'PPL', 'P'),
(99603, 'Balls Mill', 38.6302795410156, 0.674225568956527, -77.7394409179688, -1.35680920267816, 218, 53, 'PPL', 'P'),
(158895, 'Balls Mills', 41.3180618286133, 0.721136219451891, -77.0272216796875, -1.3443786319741, 218, 45, 'PPL', 'P'),
(202965, 'Ballstaedt Estates', 40.6197204589844, 0.70894786324898, -111.805557250977, -1.95137509605656, 218, 52, 'PPL', 'P'),
(99604, 'Ballston', 38.8800010681152, 0.678584031817523, -77.1141662597656, -1.34589610116323, 218, 53, 'PPL', 'P'),
(200362, 'Ballston', 45.0669403076172, 0.786566492167666, -123.319717407227, -2.15233510138507, 218, 43, 'PPL', 'P'),
(146981, 'Ballston Center', 42.9558296203613, 0.749720659801011, -73.8658294677734, -1.2892019289293, 218, 40, 'PPL', 'P'),
(146982, 'Ballston Lake', 42.9116706848145, 0.748949940981542, -73.8686065673828, -1.28925039846114, 218, 40, 'PPL', 'P'),
(146983, 'Ballston Spa', 43.0008316040039, 0.750506092585503, -73.8494415283203, -1.28891590542822, 218, 40, 'PPL', 'P'),
(29147, 'Ballstown', 39.250560760498, 0.68505151852478, -85.2441711425781, -1.48779145457153, 218, 19, 'PPL', 'P'),
(99605, 'Ballsville', 37.4983291625977, 0.654469307883937, -78.0672225952148, -1.36253007217381, 218, 53, 'PPL', 'P'),
(34656, 'Balltown', 36.7238883972168, 0.640952766666376, -84.1677780151367, -1.46900485045183, 218, 21, 'PPL', 'P'),
(79647, 'Balltown', 33.5913887023926, 0.586280333173976, -81.7247161865234, -1.42636537771274, 218, 48, 'PPL', 'P'),
(84803, 'Balltown', 35.3097190856934, 0.616270855999631, -84.5438919067383, -1.47556927622277, 218, 50, 'PPL', 'P'),
(114495, 'Balltown', 42.6380615234375, 0.744174560251894, -90.8686065673828, -1.58595637130017, 218, 16, 'PPL', 'P'),
(146985, 'Balltown', 42.4905586242676, 0.741600149005141, -79.0766677856445, -1.38014821436523, 218, 40, 'PPL', 'P'),
(158896, 'Balltown', 41.601390838623, 0.726081243542977, -79.1725006103516, -1.38182081268785, 218, 45, 'PPL', 'P'),
(186382, 'Balltown', 39.0777816772461, 0.682035954643456, -106.280563354492, -1.85494576141032, 218, 7, 'PPL', 'P'),
(154174, 'Ballville', 41.3277816772461, 0.721305862813329, -83.1322174072266, -1.45093090823985, 218, 41, 'PPL', 'P'),
(53325, 'Ballwin', 38.5950012207031, 0.6736098461125, -90.5461120605469, -1.58032778033629, 218, 29, 'PPL', 'P'),
(158897, 'Bally', 40.4022216796875, 0.705151793431181, -75.5875015258789, -1.31925077498282, 218, 45, 'PPL', 'P'),
(114496, 'Ballyclough', 42.4258308410645, 0.74047043607073, -90.7180633544922, -1.5833288965687, 218, 16, 'PPL', 'P'),
(99610, 'Ballylynn Shores', 36.8311080932617, 0.642824103385348, -76.2213897705078, -1.33031421194129, 218, 53, 'PPL', 'P'),
(15092, 'Balm', 27.7591705322266, 0.48448892340994, -82.2613906860352, -1.43573211474071, 218, 12, 'PPL', 'P'),
(62684, 'Balm', 36.1697196960449, 0.631280698219427, -81.8525009155273, -1.42859564196763, 218, 33, 'PPL', 'P'),
(92418, 'Balm', 33.7466697692871, 0.588990499057295, -96.9763870239258, -1.69255725025581, 218, 51, 'PPL', 'P'),
(200363, 'Balm Grove', 45.5969390869141, 0.795816715897947, -123.217216491699, -2.15054612292281, 218, 43, 'PPL', 'P'),
(146987, 'Balmat', 44.2483291625977, 0.772279032393554, -75.3952789306641, -1.3158958577996, 218, 40, 'PPL', 'P'),
(195921, 'Balmont', 45.628059387207, 0.796359867602269, -111.104438781738, -1.93913827032181, 218, 31, 'PPL', 'P'),
(39210, 'Balmoral', 32.1147193908691, 0.560507591724734, -91.2238922119141, -1.59215727558231, 218, 22, 'PPL', 'P'),
(44573, 'Balmoral', 39.4208297729492, 0.688023273406173, -77.3008270263672, -1.34915394612473, 218, 25, 'PPL', 'P'),
(84804, 'Balmoral', 35.1072196960449, 0.612736574916987, -85.3466720581055, -1.48958043303379, 218, 50, 'PPL', 'P'),
(173039, 'Balmoral', 43.225830078125, 0.754433056770879, -90.4638900756836, -1.5788927359829, 218, 57, 'PPL', 'P'),
(191107, 'Balmorhea', 30.9841709136963, 0.54077579844466, -103.744171142578, -1.81067736619048, 218, 51, 'PPL', 'P'),
(146986, 'Balmville', 41.5347213745117, 0.724917641883694, -74.0152816772461, -1.29181036205898, 218, 40, 'PPL', 'P'),
(62685, 'Balsam', 35.4266700744629, 0.618312035817122, -83.0852813720703, -1.45011171988854, 218, 33, 'PPL', 'P'),
(129652, 'Balsam', 46.2077789306641, 0.806477882373753, -88.3808288574219, -1.54253645920363, 218, 27, 'PPL', 'P'),
(134079, 'Balsam', 46.7811088562012, 0.816484377274589, -93.1558303833008, -1.62587595761797, 218, 28, 'PPL', 'P'),
(158899, 'Balsam', 41.7030601501465, 0.727855707777297, -77.3488922119141, -1.3499928418681, 218, 45, 'PPL', 'P'),
(62686, 'Balsam Grove', 35.2294387817383, 0.614869700371113, -82.873893737793, -1.4464223096724, 218, 33, 'PPL', 'P'),
(173040, 'Balsam Lake', 45.452220916748, 0.793290907341089, -92.4544372558594, -1.61363433819326, 218, 57, 'PPL', 'P'),
(77820, 'Balsinger', 39.896110534668, 0.696318487569551, -79.7991714477539, -1.39275828212676, 218, 45, 'PPL', 'P'),
(92419, 'Balsora', 33.1161117553711, 0.577985185589625, -97.8516693115234, -1.70783380805878, 218, 51, 'PPL', 'P'),
(31725, 'Balta', 38.8847198486328, 0.678666390074234, -98.915283203125, -1.72639737243717, 218, 20, 'PPL', 'P'),
(84806, 'Balta', 35.7688903808594, 0.624284906930925, -84.8763885498047, -1.48137243739611, 218, 50, 'PPL', 'P'),
(197969, 'Balta', 48.1666717529297, 0.840667011815972, -100.036666870117, -1.74596920960428, 218, 34, 'PPL', 'P'),
(62687, 'Baltic', 34.9936103820801, 0.610753718327368, -78.1600036621094, -1.36414940727463, 218, 33, 'PPL', 'P'),
(112921, 'Baltic', 31.6516704559326, 0.552425863212239, -86.0041732788086, -1.50105599417094, 218, 2, 'PPL', 'P'),
(129653, 'Baltic', 47.0675010681152, 0.821482864324559, -88.6333312988281, -1.54694345817549, 218, 27, 'PPL', 'P'),
(154176, 'Baltic', 40.439998626709, 0.705811125538057, -81.6991729736328, -1.42591956454626, 218, 41, 'PPL', 'P'),
(169785, 'Baltic', 43.7613906860352, 0.763780352722894, -96.7399978637695, -1.68843148109506, 218, 49, 'PPL', 'P'),
(177312, 'Baltic', 41.6169395446777, 0.726352619658056, -72.0849990844727, -1.25812057532115, 218, 8, 'PPL', 'P'),
(34657, 'Baltimore', 36.6875, 0.64031766932542, -88.8058319091797, -1.54995416178783, 218, 21, 'PPL', 'P'),
(44574, 'Baltimore', 39.2902793884277, 0.685744739356528, -76.6125030517578, -1.33714042644738, 218, 25, 'PPL', 'P'),
(62689, 'Baltimore', 36.1477813720703, 0.6308978022337, -80.5299987792969, -1.40551362532574, 218, 33, 'PPL', 'P'),
(71733, 'Baltimore', 39.8452796936035, 0.695431322031419, -82.600830078125, -1.44165644974365, 218, 41, 'PPL', 'P'),
(84807, 'Baltimore', 35.9841690063477, 0.628042227754863, -83.059440612793, -1.44966071355793, 218, 50, 'PPL', 'P'),
(146988, 'Baltimore', 42.735279083252, 0.74587132676141, -76.126106262207, -1.32865120099859, 218, 40, 'PPL', 'P'),
(171704, 'Baltimore', 43.360279083252, 0.756779634586375, -72.5736083984375, -1.26664841660574, 218, 55, 'PPL', 'P'),
(112920, 'Baltimore (historical)', 33.9174995422363, 0.591972041055693, -86.8869400024414, -1.51646318002537, 218, 2, 'PPL', 'P'),
(114497, 'Baltimore (historical)', 40.857780456543, 0.713102794023667, -91.459716796875, -1.59627319104703, 218, 16, 'PPL', 'P'),
(179918, 'Baltimore (historical)', 39.0152816772461, 0.68094512386096, -120.829170227051, -2.10886685291474, 218, 6, 'PPL', 'P'),
(186383, 'Baltimore (historical)', 39.9033317565918, 0.696444521668139, -105.573890686035, -1.84261199661189, 218, 7, 'PPL', 'P'),
(99607, 'Baltimore Corner', 37.0988883972168, 0.647497751361355, -77.7272186279297, -1.35659588347484, 218, 53, 'PPL', 'P'),
(112384, 'Baltimore Corner', 39.0580596923828, 0.681691741072564, -75.8450012207031, -1.32374499248039, 218, 25, 'PPL', 'P'),
(44576, 'Baltimore Highlands', 39.2330589294434, 0.684746053947748, -76.6369400024414, -1.33756693169595, 218, 25, 'PPL', 'P'),
(112922, 'Baltimore Hill', 34.836669921875, 0.608014590567195, -86.5422210693359, -1.51044669964872, 218, 2, 'PPL', 'P'),
(189912, 'Baltimore Mill', 39.2844390869141, 0.685642806865805, -114.868057250977, -2.00482580439889, 218, 39, 'PPL', 'P'),
(179919, 'Baltimore Park', 37.9308280944824, 0.662017838256685, -122.531387329102, -2.13857614592928, 218, 6, 'PPL', 'P'),
(53326, 'Baltimore Settlement', 38.6097183227539, 0.673866707999638, -91.2416687011719, -1.59246753384931, 218, 29, 'PPL', 'P'),
(179926, 'Baltimore Town', 39.3877792358398, 0.687446432714061, -120.539169311523, -2.10380538210499, 218, 6, 'PPL', 'P'),
(144787, 'Baltusrol', 40.7244415283203, 0.710775590705101, -74.3283309936523, -1.29727410335138, 218, 37, 'PPL', 'P'),
(99608, 'Balty', 37.997501373291, 0.663181506494995, -77.4452819824219, -1.3516751607287, 218, 53, 'PPL', 'P'),
(58540, 'Baltzer', 33.9819412231445, 0.593096760563061, -90.5947189331055, -1.58117613030154, 218, 30, 'PPL', 'P'),
(19035, 'Balus Creek', 34.2477798461914, 0.597736519814197, -83.9088897705078, -1.46448639818835, 218, 13, 'PPL', 'P'),
(194099, 'Balzac', 40.4069404602051, 0.705234151687891, -103.470832824707, -1.80590671257176, 218, 7, 'PPL', 'P'),
(112925, 'Bama Dale', 31.267219543457, 0.545715928977243, -85.376106262207, -1.49009415680806, 218, 2, 'PPL', 'P'),
(112924, 'Bama Park', 32.7161102294922, 0.571003841950036, -85.851936340332, -1.49839895835137, 218, 2, 'PPL', 'P'),
(19036, 'Bamah (historical)', 32.8808288574219, 0.573878724346777, -83.9302825927734, -1.46485977337318, 218, 13, 'PPL', 'P'),
(70484, 'Bamber Lake', 39.8905601501465, 0.6962216150849, -74.3125, -1.29699780038829, 218, 37, 'PPL', 'P'),
(79648, 'Bamberg', 33.2969398498535, 0.58114123121845, -81.0350036621094, -1.41432762326947, 218, 48, 'PPL', 'P'),
(70485, 'Bamberry Estates', 39.9936103820801, 0.698020180927085, -74.2180633544922, -1.29534956998964, 218, 37, 'PPL', 'P'),
(15093, 'Bamboo', 28.8225002288818, 0.503047527650807, -81.9658279418945, -1.43057357170923, 218, 12, 'PPL', 'P'),
(62690, 'Bamboo', 36.1936111450195, 0.631697682667106, -81.6080627441406, -1.42432939105937, 218, 33, 'PPL', 'P'),
(19037, 'Bamburg', 30.7772197723389, 0.537163819637213, -82.9141693115234, -1.44712525104212, 218, 13, 'PPL', 'P'),
(112933, 'Bamford', 33.2758293151855, 0.580772782881638, -86.9319381713867, -1.51724854623084, 218, 2, 'PPL', 'P'),
(158900, 'Bamford', 40.0849990844727, 0.699615214682961, -76.3891677856445, -1.33324249071788, 218, 45, 'PPL', 'P'),
(92420, 'Bammel', 30.0066699981689, 0.523715189027449, -95.4633331298828, -1.66614947804464, 218, 51, 'PPL', 'P'),
(179920, 'Bamom (historical)', 38.6652793884277, 0.674836431531563, -120.925003051758, -2.11053945123737, 218, 6, 'PPL', 'P'),
(179921, 'Banadelle Ranchos', 36.9666709899902, 0.645190122276801, -119.893058776855, -2.09252862594321, 218, 6, 'PPL', 'P'),
(62691, 'Banalsburg (historical)', 35.1230583190918, 0.613013011038137, -80.9916687011719, -1.41357128551989, 218, 33, 'PPL', 'P'),
(129655, 'Banat', 45.5177803039551, 0.794435134503441, -87.6975021362305, -1.53061015805198, 218, 27, 'PPL', 'P'),
(39211, 'Bancker', 29.8850002288818, 0.521591650953247, -92.1241683959961, -1.60787005917184, 218, 22, 'PPL', 'P'),
(99609, 'Banco', 38.4511108398438, 0.671098485204556, -78.2819366455078, -1.36627753930172, 218, 53, 'PPL', 'P'),
(108079, 'Banco', 38.002498626709, 0.663268725020695, -82.0086135864258, -1.43132032207889, 218, 58, 'PPL', 'P'),
(19038, 'Bancroft', 31.4147205352783, 0.548290306934482, -84.8399963378906, -1.48073727347612, 218, 13, 'PPL', 'P'),
(31726, 'Bancroft', 39.6083297729492, 0.691295765753662, -95.9000015258789, -1.67377077929417, 218, 20, 'PPL', 'P'),
(34659, 'Bancroft', 37.165828704834, 0.648666080131573, -87.2474975585938, -1.52275609652318, 218, 21, 'PPL', 'P'),
(39212, 'Bancroft', 30.5650005340576, 0.533459895193131, -93.6852798461914, -1.63511659396833, 218, 22, 'PPL', 'P'),
(44578, 'Bancroft', 39.0183296203613, 0.680998320503734, -76.5086135864258, -1.3353272132192, 218, 25, 'PPL', 'P'),
(92421, 'Bancroft', 30.1111106872559, 0.525538022925067, -93.7988891601563, -1.63709945055795, 218, 51, 'PPL', 'P'),
(108080, 'Bancroft', 38.5094413757324, 0.672116545110266, -81.8399963378906, -1.42837739591629, 218, 58, 'PPL', 'P'),
(114499, 'Bancroft', 43.292781829834, 0.755601585278178, -94.2177810668945, -1.64441049354049, 218, 16, 'PPL', 'P'),
(124172, 'Bancroft', 42.3091697692871, 0.73843431625931, -73.029167175293, -1.27459941719823, 218, 23, 'PPL', 'P'),
(126816, 'Bancroft', 45.6736106872559, 0.797154887766685, -68.0313873291016, -1.18737170359237, 218, 26, 'PPL', 'P'),
(129656, 'Bancroft', 42.8786087036133, 0.748372900552349, -84.0638885498047, -1.46719163722365, 218, 27, 'PPL', 'P'),
(134082, 'Bancroft', 43.7016716003418, 0.762738058051264, -93.3550033569336, -1.62935218178885, 218, 28, 'PPL', 'P'),
(139022, 'Bancroft', 40.1191711425781, 0.700211629609084, -93.8583297729492, -1.63813688496059, 218, 29, 'PPL', 'P'),
(141229, 'Bancroft', 42.0127792358398, 0.733261325578913, -96.5725021362305, -1.68550812916648, 218, 35, 'PPL', 'P'),
(169787, 'Bancroft', 44.4880599975586, 0.776463124782178, -97.7497177124023, -1.70605441697644, 218, 49, 'PPL', 'P'),
(173043, 'Bancroft', 44.3097190856934, 0.773350488679121, -89.5136108398438, -1.56230723450416, 218, 57, 'PPL', 'P'),
(179922, 'Bancroft', 37.9338912963867, 0.662071301215568, -122.046112060547, -2.1301064947145, 218, 6, 'PPL', 'P'),
(194547, 'Bancroft', 42.7202796936035, 0.745609538026256, -111.88500213623, -1.95276167087811, 218, 17, 'PPL', 'P'),
(200364, 'Bancroft', 42.9397201538086, 0.749439496568926, -124.005828857422, -2.16431000522661, 218, 43, 'PPL', 'P'),
(118713, 'Bancroft Corners', 42.4211082458496, 0.740388011234992, -87.8619384765625, -1.53348011360071, 218, 18, 'PPL', 'P'),
(179923, 'Bancroft Point', 32.7369384765625, 0.571367363438832, -116.984718322754, -2.04176850925019, 218, 6, 'PPL', 'P'),
(7247, 'Band Mill', 36.1336097717285, 0.630650461147459, -91.978889465332, -1.60533446349797, 218, 4, 'PPL', 'P'),
(84808, 'Band Mill', 36.0458297729492, 0.629118411151364, -89.4994430541992, -1.56205995999695, 218, 50, 'PPL', 'P'),
(34660, 'Bandana', 37.146110534668, 0.648321933139707, -88.9458312988281, -1.55239761208798, 218, 21, 'PPL', 'P'),
(62692, 'Bandana', 35.9730606079102, 0.627848349627505, -82.1761093139648, -1.43424367400747, 218, 33, 'PPL', 'P'),
(77821, 'Bandanna', 39.7386093139648, 0.693569572692372, -76.9375, -1.34281269325314, 218, 45, 'PPL', 'P'),
(92422, 'Bandera', 29.726390838623, 0.51882339486865, -99.0733337402344, -1.72915587469428, 218, 51, 'PPL', 'P'),
(206758, 'Bandera', 47.3869400024414, 0.827058125487612, -121.532501220703, -2.1211422944853, 218, 56, 'PPL', 'P'),
(92424, 'Bandera Falls', 29.6769409179688, 0.517960330938383, -98.9630584716797, -1.72723120817448, 218, 51, 'PPL', 'P'),
(179925, 'Bandini', 34.0066719055176, 0.593528392396736, -118.166938781738, -2.06240214874391, 218, 6, 'PPL', 'P'),
(29145, 'Bandmill', 38.538330078125, 0.672620748083645, -87.602783203125, -1.52895700080532, 218, 19, 'PPL', 'P'),
(112293, 'Bando', 39.8274993896484, 0.695120997185397, -89.7094421386719, -1.56572513544717, 218, 18, 'PPL', 'P'),
(29146, 'Bandon', 38.1372184753418, 0.665620029947126, -86.6002807617188, -1.5114600324435, 218, 19, 'PPL', 'P'),
(200365, 'Bandon', 43.1191711425781, 0.752571507168914, -124.407218933105, -2.17131558363212, 218, 43, 'PPL', 'P'),
(19039, 'Bandy', 30.8705596923828, 0.538792908565528, -83.1750030517578, -1.45167765860951, 218, 13, 'PPL', 'P'),
(62693, 'Bandy', 35.6419410705566, 0.622069223483006, -81.0899963378906, -1.41528742652634, 218, 33, 'PPL', 'P'),
(99611, 'Bandy', 37.1427803039551, 0.648263809648916, -81.7011108398438, -1.4259533866921, 218, 53, 'PPL', 'P'),
(108081, 'Bandytown', 37.940559387207, 0.662187681355205, -81.6399993896484, -1.42488679067553, 218, 58, 'PPL', 'P'),
(99612, 'Bane', 37.267219543457, 0.650435684096903, -80.7127838134766, -1.40870382599555, 218, 53, 'PPL', 'P'),
(108082, 'Bane', 39.5044403076172, 0.689482552525482, -80.5877838134766, -1.40652216443056, 218, 58, 'PPL', 'P'),
(84809, 'Baneberry', 36.0636100769043, 0.629428735997385, -83.2958297729492, -1.45378648271868, 218, 50, 'PPL', 'P'),
(158901, 'Banetown', 40.0783309936523, 0.699498834543324, -80.2283325195313, -1.40024855585066, 218, 45, 'PPL', 'P'),
(158902, 'Baney Settlement', 41.0680618286133, 0.716772896321905, -78.4250030517578, -1.36877451913977, 218, 45, 'PPL', 'P'),
(199158, 'Baney Trailer Park', 40.0491714477539, 0.69898990445901, -101.532501220703, -1.77207644408643, 218, 35, 'PPL', 'P'),
(129657, 'Banfield', 42.4636116027832, 0.741129834756633, -85.2886123657227, -1.48856710023901, 218, 27, 'PPL', 'P'),
(158903, 'Banfield', 40.6363906860352, 0.709238813598071, -79.605827331543, -1.38938379070952, 218, 45, 'PPL', 'P'),
(193358, 'Banfield Place', 40.086669921875, 0.699644376296897, -122.607498168945, -2.13990453068101, 218, 6, 'PPL', 'P'),
(146992, 'Bangall', 41.875560760498, 0.730866411389631, -73.6916732788086, -1.28616233001914, 218, 40, 'PPL', 'P'),
(53327, 'Bangert', 37.771110534668, 0.659230240964672, -91.5158309936523, -1.59725256853791, 218, 29, 'PPL', 'P'),
(84810, 'Bangham', 36.2472190856934, 0.632633317737078, -85.470832824707, -1.49174744721278, 218, 50, 'PPL', 'P'),
(84811, 'Bangham Village', 36.2502784729004, 0.632686714116934, -85.45361328125, -1.49144690948377, 218, 50, 'PPL', 'P'),
(179927, 'Bangle', 33.8244400024414, 0.590347845685881, -118.227783203125, -2.06346408422858, 218, 6, 'PPL', 'P'),
(34662, 'Bangor', 38.0433311462402, 0.6639813869284, -83.4388885498047, -1.45628332939869, 218, 21, 'PPL', 'P'),
(112923, 'Bangor', 33.9744415283203, 0.592965866195484, -86.7566680908203, -1.51418950624472, 218, 2, 'PPL', 'P'),
(114500, 'Bangor', 42.1733283996582, 0.736063437098867, -93.0933303833008, -1.62478512683547, 218, 16, 'PPL', 'P'),
(126818, 'Bangor', 44.8011093139648, 0.781926866074585, -68.7783279418945, -1.20040827660247, 218, 26, 'PPL', 'P'),
(129658, 'Bangor', 42.3125, 0.738492439750101, -86.1130599975586, -1.50295642592482, 218, 27, 'PPL', 'P'),
(146990, 'Bangor', 44.8122215270996, 0.78212081078097, -74.3977813720703, -1.29848624112153, 218, 40, 'PPL', 'P'),
(158904, 'Bangor', 40.8655586242676, 0.713238548660234, -75.2069396972656, -1.31260871806611, 218, 45, 'PPL', 'P'),
(173044, 'Bangor', 43.8930587768555, 0.766078394427523, -90.9902801513672, -1.5880799759534, 218, 57, 'PPL', 'P'),
(179928, 'Bangor', 39.3886108398438, 0.687460946942002, -121.404167175293, -2.11890244285049, 218, 6, 'PPL', 'P'),
(206759, 'Bangor', 47.7211112976074, 0.832890514853913, -122.744720458984, -2.14229951144932, 218, 56, 'PPL', 'P'),
(154178, 'Bangorville', 40.564998626709, 0.70799278710305, -82.5641708374023, -1.44101662529175, 218, 41, 'PPL', 'P'),
(92425, 'Bangs', 31.7169399261475, 0.55356503036852, -99.1322174072266, -1.73018358855894, 218, 51, 'PPL', 'P'),
(154179, 'Bangs', 40.3522186279297, 0.704279075541962, -82.5524978637695, -1.44081289346836, 218, 41, 'PPL', 'P'),
(99613, 'Bangs (historical)', 37.1411094665527, 0.64823464803498, -80.4019393920898, -1.4032785673809, 218, 53, 'PPL', 'P'),
(126820, 'Bangs Beach', 44.4724998474121, 0.776191548930017, -69.7752838134766, -1.21780843905867, 218, 26, 'PPL', 'P'),
(158906, 'Banian Junction', 40.8138885498047, 0.712336735736105, -78.4366683959961, -1.36897811780511, 218, 45, 'PPL', 'P'),
(194549, 'Banida', 42.2311096191406, 0.737071909624652, -111.941673278809, -1.95375076890697, 218, 17, 'PPL', 'P'),
(99614, 'Banister', 36.771671295166, 0.641786735561735, -79.5344390869141, -1.38813783079352, 218, 53, 'PPL', 'P'),
(99616, 'Banister Town', 36.774169921875, 0.641830344824585, -78.9205627441406, -1.37742366741203, 218, 53, 'PPL', 'P'),
(143491, 'Bank', 42.7502784729004, 0.746133115496565, -71.8375015258789, -1.25380092803304, 218, 36, 'PPL', 'P'),
(44579, 'Bank (historical)', 39.6561088562012, 0.692129668069993, -75.8199996948242, -1.32330863353578, 218, 25, 'PPL', 'P'),
(84812, 'Bank (historical)', 35.8088912963867, 0.624983054610689, -83.8772201538086, -1.4639336591041, 218, 50, 'PPL', 'P'),
(13317, 'Bank Harbor Retreat', 38.5588912963867, 0.672979609040533, -75.0986099243164, -1.31071800685021, 218, 10, 'PPL', 'P'),
(34661, 'Bank Lick', 38.9097213745117, 0.679102749018843, -84.579719543457, -1.47619458644672, 218, 21, 'PPL', 'P'),
(154180, 'Banker Heights', 40.7611083984375, 0.711415548315047, -81.4194412231445, -1.42103732447787, 218, 41, 'PPL', 'P'),
(39213, 'Banker Plantation', 30.1352806091309, 0.525959867641736, -91.7799987792969, -1.60186316617511, 218, 22, 'PPL', 'P'),
(39214, 'Bankers', 30.1391696929932, 0.526027744960019, -91.7425003051758, -1.60120869433722, 218, 22, 'PPL', 'P'),
(129662, 'Bankers', 41.8977813720703, 0.731254234223374, -84.6913909912109, -1.47814362089049, 218, 27, 'PPL', 'P'),
(92426, 'Bankersmith', 30.125560760498, 0.525790224280298, -98.8211135864258, -1.72475380257043, 218, 51, 'PPL', 'P'),
(112927, 'Bankhead', 34.5602798461914, 0.603190673726679, -85.5530624389648, -1.49318262472423, 218, 2, 'PPL', 'P'),
(177649, 'Bankhead Springs', 32.6497192382813, 0.569845100559743, -116.243057250977, -2.02882408161381, 218, 6, 'PPL', 'P'),
(26441, 'Banklick', 37.827220916748, 0.660209551876521, -88.7022171020508, -1.54814574224961, 218, 18, 'PPL', 'P'),
(7248, 'Banks', 33.5747184753418, 0.585989382824885, -92.2688903808594, -1.61039593430772, 218, 4, 'PPL', 'P'),
(34663, 'Banks', 37.084171295166, 0.647240889474217, -83.0219421386719, -1.44900624172005, 218, 21, 'PPL', 'P'),
(58541, 'Banks', 34.8258285522461, 0.607825372971744, -90.2297210693359, -1.57480571581601, 218, 30, 'PPL', 'P'),
(62695, 'Banks', 35.6355590820313, 0.621957836770413, -78.7144393920898, -1.37382613625349, 218, 33, 'PPL', 'P'),
(112929, 'Banks', 33.1513900756836, 0.578600908433651, -87.1891708374023, -1.52173810319649, 218, 2, 'PPL', 'P'),
(194548, 'Banks', 44.0805587768555, 0.769350886775012, -116.123062133789, -2.02672977173257, 218, 17, 'PPL', 'P'),
(197971, 'Banks', 48.0386085510254, 0.838431887292096, -103.19416809082, -1.80107800204129, 218, 34, 'PPL', 'P'),
(200366, 'Banks', 45.6188888549805, 0.796199811620755, -123.113059997559, -2.14872824916272, 218, 43, 'PPL', 'P'),
(13318, 'Banks Acres', 38.5569381713867, 0.67294552057858, -75.1113891601563, -1.31094104659151, 218, 10, 'PPL', 'P'),
(19042, 'Banks Crossing', 34.2566719055176, 0.597891715526722, -83.4641723632813, -1.45672461519131, 218, 13, 'PPL', 'P'),
(13319, 'Banks Development', 38.5533294677734, 0.6728825368188, -75.1138916015625, -1.31098472243338, 218, 10, 'PPL', 'P'),
(13320, 'Banks Harbor Estates', 38.5577812194824, 0.672960234543603, -75.0972213745117, -1.31069377208429, 218, 10, 'PPL', 'P'),
(206760, 'Banks Lake South', 47.6266708374023, 0.831242217876236, -119.274436950684, -2.08173163825181, 218, 56, 'PPL', 'P'),
(39215, 'Banks Springs', 32.0819396972656, 0.559935478143558, -92.0927810668945, -1.60732224693561, 218, 22, 'PPL', 'P'),
(112930, 'Bankston', 33.6713905334473, 0.587676628533505, -87.67138671875, -1.53015435803142, 218, 2, 'PPL', 'P'),
(114503, 'Bankston', 42.5186080932617, 0.742089704592525, -90.9611129760742, -1.58757091271103, 218, 16, 'PPL', 'P'),
(146993, 'Banksville', 41.1411094665527, 0.718047818114753, -73.6399993896484, -1.28526045051598, 218, 40, 'PPL', 'P'),
(158908, 'Banksville', 40.4083290100098, 0.705258386453811, -80.0338897705078, -1.39685488967357, 218, 45, 'PPL', 'P'),
(13321, 'Banksville Park', 38.5555610656738, 0.672921485549742, -75.1186065673828, -1.31106701411107, 218, 10, 'PPL', 'P'),
(195922, 'Bannack', 45.1611099243164, 0.788210062034408, -112.994720458984, -1.97212990937988, 218, 31, 'PPL', 'P'),
(92427, 'Bannas Junction', 31.6030597686768, 0.551577446667967, -97.1944427490234, -1.69636304061159, 218, 51, 'PPL', 'P'),
(108084, 'Bannen', 39.728328704834, 0.693390142213927, -80.5869369506836, -1.40650738388651, 218, 58, 'PPL', 'P'),
(7249, 'Banner', 35.6416702270508, 0.622064496372071, -91.8313903808594, -1.60276011883025, 218, 4, 'PPL', 'P'),
(34664, 'Banner', 37.5991706848145, 0.656229324469343, -82.7013931274414, -1.44341160606006, 218, 21, 'PPL', 'P'),
(53328, 'Banner', 37.6969413757324, 0.657935744937812, -90.8344421386719, -1.5853600895321, 218, 29, 'PPL', 'P'),
(58542, 'Banner', 34.0886116027832, 0.594958509902108, -89.3847198486328, -1.56005766233137, 218, 30, 'PPL', 'P'),
(71737, 'Banner', 38.939998626709, 0.679631186758142, -82.5950012207031, -1.44155471699001, 218, 41, 'PPL', 'P'),
(75055, 'Banner', 35.5127792358398, 0.619814924199281, -97.8486099243164, -1.70778041167892, 218, 42, 'PPL', 'P'),
(99617, 'Banner', 36.9494400024414, 0.644889384810704, -82.4297180175781, -1.43866998089723, 218, 53, 'PPL', 'P'),
(118714, 'Banner', 40.5169410705566, 0.707154024517729, -89.908332824707, -1.56919643277003, 218, 18, 'PPL', 'P'),
(173047, 'Banner', 43.7730598449707, 0.763984017967257, -88.2094421386719, -1.53954519666725, 218, 57, 'PPL', 'P'),
(179930, 'Banner', 33.0688896179199, 0.577161003811272, -116.545280456543, -2.03409887162687, 218, 6, 'PPL', 'P'),
(194550, 'Banner', 44.0200004577637, 0.768293944717387, -115.534721374512, -2.0164612883595, 218, 17, 'PPL', 'P'),
(206761, 'Banner', 47.4888916015625, 0.828837516569949, -122.54167175293, -2.13875564298675, 218, 56, 'PPL', 'P'),
(209289, 'Banner', 44.601390838623, 0.778441121102807, -106.864723205566, -1.86514127416952, 218, 59, 'PPL', 'P'),
(7250, 'Banner (historical)', 35.6113891601563, 0.621535992053745, -92.3894424438477, -1.61249996472694, 218, 4, 'PPL', 'P'),
(112919, 'Banner (historical)', 34.0083312988281, 0.59355735427359, -85.7763900756836, -1.49708042729567, 218, 2, 'PPL', 'P'),
(179931, 'Banner (historical)', 36.371940612793, 0.634810119033081, -119.663063049316, -2.08851444323214, 218, 6, 'PPL', 'P'),
(44597, 'Banner Country', 39.232780456543, 0.684741193678759, -77.2083282470703, -1.34753953787192, 218, 25, 'PPL', 'P'),
(179932, 'Banner Crest', 39.2355613708496, 0.684789729789626, -121.018058776855, -2.11216358002815, 218, 6, 'PPL', 'P'),
(62696, 'Banner Elk', 36.1630592346191, 0.631164451237845, -81.8716735839844, -1.42893026815859, 218, 33, 'PPL', 'P'),
(84813, 'Banner Hill', 36.1305618286133, 0.630597264504685, -82.4247207641602, -1.43858276237153, 218, 50, 'PPL', 'P'),
(29149, 'Banner Mills', 39.9327812194824, 0.696958511758525, -87.1011123657227, -1.52020119293141, 218, 19, 'PPL', 'P'),
(84814, 'Banner Springs', 36.2477798461914, 0.632643104854084, -84.9311065673828, -1.48232744696301, 218, 50, 'PPL', 'P'),
(173049, 'Bannerman', 43.9966697692871, 0.767886747386714, -89.2249984741211, -1.55726999846033, 218, 57, 'PPL', 'P'),
(99618, 'Banners Corner', 36.8716697692871, 0.643532038182118, -82.3002777099609, -1.43641082134452, 218, 53, 'PPL', 'P'),
(62700, 'Bannertown', 36.4855613708496, 0.636793175359782, -80.5902786254883, -1.40656570711438, 218, 33, 'PPL', 'P'),
(158910, 'Bannerville', 40.7322196960449, 0.710911345341668, -77.3480606079102, -1.34997832764016, 218, 45, 'PPL', 'P'),
(99619, 'Bannerwood', 38.7649993896484, 0.676576873882958, -77.5038909912109, -1.3526980809034, 218, 53, 'PPL', 'P'),
(19043, 'Banning', 33.5119400024414, 0.584893691773399, -84.9311065673828, -1.48232744696301, 218, 13, 'PPL', 'P'),
(134086, 'Banning', 46.1605606079102, 0.805653767174427, -92.8516693115234, -1.62056734545906, 218, 28, 'PPL', 'P'),
(158911, 'Banning', 40.1194381713867, 0.700216290140991, -79.7516708374023, -1.39192924007941, 218, 45, 'PPL', 'P'),
(179933, 'Banning', 33.9255599975586, 0.592112722540277, -116.875556945801, -2.03986328380635, 218, 6, 'PPL', 'P'),
(122187, 'Banning Corner', 40.3663902282715, 0.704526416628203, -87.1624984741211, -1.52127258263795, 218, 19, 'PPL', 'P'),
(19044, 'Banning Mills', 33.5261116027832, 0.58514103285964, -84.9244384765625, -1.48221106682337, 218, 13, 'PPL', 'P'),
(188105, 'Banning Place', 36.9222183227539, 0.644414276872234, -105.128608703613, -1.83484035991882, 218, 38, 'PPL', 'P'),
(26443, 'Bannister', 38.6188888549805, 0.674026763981152, -88.8597183227539, -1.55089465712679, 218, 18, 'PPL', 'P'),
(44581, 'Bannister', 38.5947189331055, 0.673604919264484, -76.9027786254883, -1.34220669094709, 218, 25, 'PPL', 'P'),
(53329, 'Bannister', 38.0349998474121, 0.663835978332882, -92.9880599975586, -1.62294781199943, 218, 29, 'PPL', 'P'),
(129664, 'Bannister', 43.1324996948242, 0.752804134290132, -84.4216690063477, -1.47343608418962, 218, 27, 'PPL', 'P'),
(179934, 'Bannister', 35.2655601501465, 0.615500137180162, -119.099716186523, -2.07868218564562, 218, 6, 'PPL', 'P'),
(39216, 'Bannister (historical)', 30.7072200775146, 0.535942094487139, -93.2491683959961, -1.62750501325677, 218, 22, 'PPL', 'P'),
(19045, 'Bannister Acres', 33.8283309936523, 0.590415756293678, -84.6833267211914, -1.47800287282688, 218, 13, 'PPL', 'P'),
(53330, 'Bannister Ford', 38.0416717529297, 0.663952425051546, -92.9847183227539, -1.62288948877156, 218, 29, 'PPL', 'P'),
(154181, 'Bannock', 40.0986099243164, 0.699852768652195, -80.9772186279297, -1.41331908416466, 218, 41, 'PPL', 'P'),
(179935, 'Bannock', 34.9366683959961, 0.609759893187578, -114.863059997559, -2.00473858587319, 218, 6, 'PPL', 'P'),
(194551, 'Bannock', 42.8613891601563, 0.748072362823334, -112.721939086914, -1.96736897629914, 218, 17, 'PPL', 'P'),
(199821, 'Bannock', 40.5166702270508, 0.707149297406795, -117.100280761719, -2.04378545430177, 218, 39, 'PPL', 'P'),
(209290, 'Bannock Ford', 44.8936080932617, 0.783541274327391, -110.376106262207, -1.92642646980664, 218, 59, 'PPL', 'P'),
(19046, 'Bannockburn', 31.2847194671631, 0.546021360264762, -83.057502746582, -1.44962689141209, 218, 13, 'PPL', 'P'),
(44582, 'Bannockburn', 38.973331451416, 0.68021295429827, -77.1419372558594, -1.34638079648163, 218, 25, 'PPL', 'P'),
(79650, 'Bannockburn', 34.1344413757324, 0.595758390335514, -79.7591705322266, -1.39206013444699, 218, 48, 'PPL', 'P'),
(118716, 'Bannockburn', 42.1933288574219, 0.736412510938749, -87.8663864135742, -1.53355774474648, 218, 18, 'PPL', 'P'),
(44583, 'Bannockburn Estates', 38.9836082458496, 0.680392318197687, -77.1474990844727, -1.34647786870336, 218, 25, 'PPL', 'P'),
(44584, 'Bannockburn Heights', 38.9811096191406, 0.680348708934837, -77.1427764892578, -1.34639544386762, 218, 25, 'PPL', 'P'),
(71735, 'Bannon', 39.920280456543, 0.69674033228622, -82.9469375610352, -1.44769716488622, 218, 41, 'PPL', 'P'),
(62701, 'Banoak', 35.586109161377, 0.621094772840146, -81.4091720581055, -1.42085809373651, 218, 33, 'PPL', 'P'),
(34665, 'Banock', 37.350830078125, 0.651894963216212, -86.6555633544922, -1.51242489570643, 218, 21, 'PPL', 'P'),
(92428, 'Banquete', 27.8058300018311, 0.485303284781773, -97.7958297729492, -1.70685922425786, 218, 51, 'PPL', 'P'),
(122188, 'Banquo', 40.6963882446289, 0.71028596853869, -85.6197204589844, -1.49434602664643, 218, 19, 'PPL', 'P'),
(29148, 'Banta', 39.5238914489746, 0.689822038985439, -86.2502822875977, -1.50535140669313, 218, 19, 'PPL', 'P'),
(179937, 'Banta', 37.7544403076172, 0.658939290615581, -121.369720458984, -2.1183012342344, 218, 6, 'PPL', 'P'),
(71736, 'Bantam', 38.9986114501953, 0.680654173511869, -84.1413879394531, -1.4685442567413, 218, 41, 'PPL', 'P'),
(177471, 'Bantam', 41.7244415283203, 0.728228883225044, -73.2366714477539, -1.27822104996463, 218, 8, 'PPL', 'P'),
(197973, 'Bantry', 48.4983291625977, 0.846455525603314, -100.610000610352, -1.75597577108414, 218, 34, 'PPL', 'P'),
(75062, 'Banty', 34.0697212219238, 0.594628810559157, -96.0947189331055, -1.67716923916122, 218, 42, 'PPL', 'P'),
(7253, 'Banty (historical)', 34.7411117553711, 0.606346785934532, -92.4958267211914, -1.61435672063894, 218, 4, 'PPL', 'P'),
(7254, 'Banyard', 35.7599983215332, 0.6241297112184, -94.206672668457, -1.64421661541313, 218, 4, 'PPL', 'P'),
(75063, 'Banzet', 36.9427795410156, 0.644773137829122, -95.2513885498047, -1.66245034729052, 218, 42, 'PPL', 'P'),
(158912, 'Baoba', 41.4813919067383, 0.723986867082712, -75.091667175293, -1.31059683302061, 218, 45, 'PPL', 'P'),
(193109, 'Bapchule', 33.1363906860352, 0.578339119698496, -111.872497558594, -1.95254342482678, 218, 5, 'PPL', 'P'),
(134087, 'Baptism Crossing', 47.5297203063965, 0.829550111898627, -91.3411102294922, -1.59420311593171, 218, 28, 'PPL', 'P'),
(34666, 'Baptist', 37.7313919067383, 0.658537020132924, -83.4791717529297, -1.45698640392647, 218, 21, 'PPL', 'P'),
(39217, 'Baptist', 30.5047206878662, 0.532407813404495, -90.5330581665039, -1.58009994690503, 218, 22, 'PPL', 'P'),
(124173, 'Baptist Corner', 42.5519409179688, 0.742671472132653, -72.7633285522461, -1.26995965794709, 218, 23, 'PPL', 'P'),
(124174, 'Baptist Corners', 42.6994400024414, 0.745245816800378, -72.2699966430664, -1.26134939182676, 218, 23, 'PPL', 'P'),
(146994, 'Baptist Corners', 42.9036102294922, 0.748809259496959, -76.4686126708984, -1.33462906553943, 218, 40, 'PPL', 'P'),
(79651, 'Baptist Hill', 32.7330589294434, 0.571299652568117, -80.2688903808594, -1.4009564240684, 218, 48, 'PPL', 'P'),
(112934, 'Baptist Hill', 32.5158309936523, 0.567508309861253, -87.8313903808594, -1.53294694875047, 218, 2, 'PPL', 'P'),
(171706, 'Baptist Hill', 44.4419403076172, 0.775658184342702, -71.7244415283203, -1.25182765882334, 218, 55, 'PPL', 'P'),
(84815, 'Baptist Ridge', 36.4838905334473, 0.636764013745845, -85.524169921875, -1.49267835517182, 218, 50, 'PPL', 'P'),
(124175, 'Baptist Village', 42.0472183227539, 0.733862401036943, -72.470832824707, -1.26485464445352, 218, 23, 'PPL', 'P'),
(144790, 'Baptistown', 40.521671295166, 0.707236582511522, -75.0063934326172, -1.30910852544542, 218, 37, 'PPL', 'P'),
(92429, 'Bar Colonia Number 6', 26.3379993438721, 0.459684806938674, -98.1989974975586, -1.71389582849007, 218, 51, 'PPL', 'P'),
(44585, 'Bar Harbor', 39.1575012207031, 0.683427323154968, -76.508056640625, -1.33531749268122, 218, 25, 'PPL', 'P'),
(126821, 'Bar Harbor', 44.3875007629395, 0.774708035044788, -68.2044372558594, -1.19039199458463, 218, 26, 'PPL', 'P'),
(44586, 'Bar Harbor Manor', 39.1552810668945, 0.683388574161108, -76.5094375610352, -1.33534159428908, 218, 25, 'PPL', 'P'),
(179938, 'Bar J Ranch', 38.6619415283203, 0.674778174882718, -121.009719848633, -2.11201803827458, 218, 6, 'PPL', 'P'),
(129665, 'Bar Lake', 44.2975006103516, 0.773137236054833, -86.3069381713867, -1.50634023840587, 218, 27, 'PPL', 'P'),
(126823, 'Bar Mills', 43.6130599975586, 0.761191493827228, -70.5502777099609, -1.23133463423518, 218, 26, 'PPL', 'P'),
(92430, 'Bar Number 2 Colonia', 26.3360004425049, 0.459649919528394, -98.1240005493164, -1.7125868848143, 218, 51, 'PPL', 'P'),
(92431, 'Bar Number 3 Colonia', 26.318000793457, 0.459335766388305, -97.9769973754883, -1.71002119542011, 218, 51, 'PPL', 'P'),
(92432, 'Bar Number 4 Colonia', 26.2229995727539, 0.457677682293622, -98.1419982910156, -1.71290100466487, 218, 51, 'PPL', 'P'),
(92433, 'Bar Number 5 Colonia', 26.3400001525879, 0.459719727638467, -98.1190032958984, -1.7124996662886, 218, 51, 'PPL', 'P'),
(92434, 'Bar Number 7 Colonia', 26.201000213623, 0.45729372104346, -98.0879974365234, -1.71195851195509, 218, 51, 'PPL', 'P'),
(209291, 'Bar Nunn', 42.9136085510254, 0.748983763127386, -106.342781066895, -1.8560316653448, 218, 59, 'PPL', 'P'),
(122189, 'Bar-Barry Heights', 40.4561080932617, 0.706092288770142, -86.9158325195313, -1.51696744957778, 218, 19, 'PPL', 'P'),
(114505, 'Bar-Jac Mobile Estates', 41.8597183227539, 0.730589908689454, -94.1083297729492, -1.64250020809057, 218, 16, 'PPL', 'P'),
(44588, 'Bar-Klee Estates', 39.452220916748, 0.688571152221429, -76.9963912963867, -1.34384054027585, 218, 25, 'PPL', 'P'),
(173048, 'Baraboo', 43.4711112976074, 0.758714021644154, -89.7441711425781, -1.56633127091127, 218, 57, 'PPL', 'P'),
(112936, 'Barachias', 32.2994384765625, 0.563731547961357, -86.1963882446289, -1.50441077819611, 218, 2, 'PPL', 'P'),
(141231, 'Barada', 40.2186088562012, 0.701947145112461, -95.5774993896484, -1.66814205517224, 218, 35, 'PPL', 'P'),
(92435, 'Barado', 30.6238899230957, 0.534487708926333, -95.4794387817383, -1.6664305746977, 218, 51, 'PPL', 'P'),
(129666, 'Baraga', 46.7786102294922, 0.816440768011739, -88.4888916015625, -1.54442250988762, 218, 27, 'PPL', 'P'),
(34667, 'Baralto', 37.9813919067383, 0.66290034326291, -84.5155563354492, -1.47507472720834, 218, 21, 'PPL', 'P'),
(209936, 'Baranof', 57.0894393920898, 0.996398685509718, -134.833053588867, -2.35328072564369, 218, 1, 'PPL', 'P'),
(39218, 'Barataria', 29.7230606079102, 0.51876527137786, -90.1236114501953, -1.57295375359397, 218, 22, 'PPL', 'P'),
(58543, 'Barbara', 30.9919395446777, 0.540911386633659, -88.9783325195313, -1.55296486540016, 218, 30, 'PPL', 'P'),
(7255, 'Barbara (historical)', 36.0916709899902, 0.629918491321851, -94.1616668701172, -1.64343111604961, 218, 4, 'PPL', 'P'),
(92436, 'Barbarosa', 29.7011108398438, 0.518382175655052, -98.0027770996094, -1.71047113648628, 218, 51, 'PPL', 'P'),
(129669, 'Barbeau', 46.2886085510254, 0.807888625382195, -84.2811126708984, -1.47098291335149, 218, 27, 'PPL', 'P'),
(62702, 'Barbecue', 35.3358306884766, 0.616726589441171, -79.0388870239258, -1.37948881567933, 218, 33, 'PPL', 'P'),
(58544, 'Barbee', 34.4311103820801, 0.6009362412849, -90.459716796875, -1.57881989852709, 218, 30, 'PPL', 'P'),
(122190, 'Barbee', 41.290828704834, 0.720660911776339, -85.7122192382813, -1.49596043489923, 218, 19, 'PPL', 'P'),
(7256, 'Barber', 35.1283302307129, 0.613105023253799, -94.0533294677734, -1.64154027167565, 218, 4, 'PPL', 'P'),
(31731, 'Barber', 37.5677795410156, 0.655681445654087, -94.6483306884766, -1.65192500203031, 218, 20, 'PPL', 'P'),
(44589, 'Barber', 38.6419410705566, 0.674429101042836, -76.0202789306641, -1.32680416562456, 218, 25, 'PPL', 'P'),
(62705, 'Barber', 36.122501373291, 0.630456583020102, -76.5927810668945, -1.33679621287648, 218, 33, 'PPL', 'P'),
(75065, 'Barber', 35.7572212219238, 0.624081241686561, -94.8675003051758, -1.65575023346204, 218, 42, 'PPL', 'P'),
(112939, 'Barber', 31.2341709136963, 0.545139121574646, -85.2355575561523, -1.48764111912799, 218, 2, 'PPL', 'P'),
(144788, 'Barber', 40.5305595397949, 0.707391711645019, -74.2583312988281, -1.29605237820131, 218, 37, 'PPL', 'P'),
(179939, 'Barber', 39.7147216796875, 0.69315265482372, -121.834442138672, -2.12641215765035, 218, 6, 'PPL', 'P'),
(194553, 'Barber', 43.5652809143066, 0.760357591510897, -116.11222076416, -2.02654055413712, 218, 17, 'PPL', 'P'),
(195923, 'Barber', 46.3133316040039, 0.808320124057815, -109.384437561035, -1.90911858588222, 218, 31, 'PPL', 'P'),
(7257, 'Barber (historical)', 35.1647186279297, 0.613740120594756, -91.5250015258789, -1.59741262451942, 218, 4, 'PPL', 'P'),
(179940, 'Barber City', 33.7588882446289, 0.589203751681583, -118.023330688477, -2.05989571468398, 218, 6, 'PPL', 'P'),
(177472, 'Barber Corner (historical)', 41.8061103820801, 0.729654273619482, -72.751106262207, -1.26974633874378, 218, 8, 'PPL', 'P'),
(19047, 'Barber Creek Estates', 33.9033317565918, 0.59172476654848, -83.461669921875, -1.45668093934944, 218, 13, 'PPL', 'P'),
(188106, 'Barber Crossing', 32.485279083252, 0.566975078431992, -104.396110534668, -1.82205585510589, 218, 38, 'PPL', 'P'),
(15094, 'Barber Quarters', 27.2522201538086, 0.475640970162315, -80.8394393920898, -1.41091438285837, 218, 12, 'PPL', 'P'),
(39219, 'Barber Spur', 30.6908302307129, 0.535656037696551, -92.4266662597656, -1.61314964287486, 218, 22, 'PPL', 'P'),
(19048, 'Barbers', 31.2216701507568, 0.544920942102341, -83.7213897705078, -1.46121390584086, 218, 13, 'PPL', 'P'),
(202973, 'Barbers', 40.6763916015625, 0.709936961277835, -111.939170837402, -1.95370709306509, 218, 52, 'PPL', 'P'),
(118717, 'Barbers Corners', 41.7108306884766, 0.727991329255809, -88.0683288574219, -1.53708230529115, 218, 18, 'PPL', 'P'),
(44590, 'Barbers Quarter', 38.374439239502, 0.669760313335818, -76.8411102294922, -1.34113037439253, 218, 25, 'PPL', 'P'),
(29150, 'Barbersville', 38.9058303833008, 0.679034838411046, -85.2808303833008, -1.48843127902342, 218, 19, 'PPL', 'P'),
(44591, 'Barbersville Trailer Park', 39.0902786254883, 0.682254067536734, -76.8249969482422, -1.34084914458142, 218, 25, 'PPL', 'P'),
(154182, 'Barberton', 41.0127792358398, 0.715808033058969, -81.6052780151367, -1.42428078836948, 218, 41, 'PPL', 'P'),
(206762, 'Barberton', 45.6933288574219, 0.79749903475855, -122.597778320313, -2.13973488731958, 218, 56, 'PPL', 'P'),
(144789, 'Barbertown', 40.485279083252, 0.706601418591538, -75.0274963378906, -1.30947684062418, 218, 37, 'PPL', 'P'),
(158916, 'Barbertown (historical)', 41.3711090087891, 0.722062067404857, -75.7350006103516, -1.32182511965055, 218, 45, 'PPL', 'P'),
(15095, 'Barberville', 29.186939239502, 0.509408188308839, -81.4211120605469, -1.42106648609181, 218, 12, 'PPL', 'P'),
(79655, 'Barberville', 35.0325012207031, 0.611432491510202, -80.8763885498047, -1.41155926731633, 218, 48, 'PPL', 'P'),
(146995, 'Barberville', 42.6833305358887, 0.744964653568293, -73.5411071777344, -1.2835344558135, 218, 40, 'PPL', 'P'),
(169270, 'Barberville', 41.5391693115234, 0.72499527302947, -71.6991729736328, -1.25138663934683, 218, 47, 'PPL', 'P'),
(92439, 'Barbosa-Lopez Colonia Number 1', 26.1900005340576, 0.457101740418379, -98.0139999389648, -1.71066701198446, 218, 51, 'PPL', 'P'),
(34668, 'Barbourmeade', 38.2972183227539, 0.668412554087156, -85.6033325195313, -1.49406000314535, 218, 21, 'PPL', 'P'),
(158913, 'Barbours', 41.3930587768555, 0.722445163127665, -76.7997207641602, -1.34040799194685, 218, 45, 'PPL', 'P'),
(99620, 'Barbours Creek', 37.5552787780762, 0.655463266181782, -80.0530624389648, -1.39718951586454, 218, 53, 'PPL', 'P'),
(99621, 'Barboursville', 38.1708297729492, 0.666206657756243, -78.2819366455078, -1.36627753930172, 218, 53, 'PPL', 'P'),
(108086, 'Barboursville', 38.4094390869141, 0.670371175910855, -82.2947235107422, -1.43631388228084, 218, 58, 'PPL', 'P'),
(34669, 'Barbourville', 36.8663902282715, 0.643439892808401, -83.8888931274414, -1.4641373909275, 218, 21, 'PPL', 'P'),
(146996, 'Barbourville', 42.1372184753418, 0.735433200026899, -75.3566665649414, -1.31522194488575, 218, 40, 'PPL', 'P'),
(39220, 'Barbreck', 30.8099994659424, 0.537735933218389, -92.1986083984375, -1.60916928230963, 218, 22, 'PPL', 'P'),
(122191, 'Barce', 40.6208305358887, 0.70896723774591, -87.2766723632813, -1.5232652929236, 218, 19, 'PPL', 'P'),
(7266, 'Barcelona', 35.6205596923828, 0.621696048035259, -94.4558334350586, -1.64856529115712, 218, 4, 'PPL', 'P'),
(39222, 'Barcelona', 31.8525009155273, 0.55593101597046, -91.4227828979492, -1.59562857290518, 218, 22, 'PPL', 'P'),
(146997, 'Barcelona', 42.3402786254883, 0.73897726822655, -79.5961074829102, -1.38921414734808, 218, 40, 'PPL', 'P'),
(189918, 'Barcelona (historical)', 38.648609161377, 0.674545481182472, -116.959442138672, -2.04132735661562, 218, 39, 'PPL', 'P'),
(19050, 'Barcelona Estates', 33.5233306884766, 0.585092496748774, -84.3338928222656, -1.47190410077255, 218, 13, 'PPL', 'P'),
(189914, 'Barcelona Summit', 38.6508293151855, 0.674584230176333, -116.957221984863, -2.04128860762176, 218, 39, 'PPL', 'P'),
(19049, 'Barch Estates', 33.8824996948242, 0.591361178480657, -83.3083267211914, -1.45400459561196, 218, 13, 'PPL', 'P'),
(26444, 'Barclay', 39.8747215270996, 0.69594517896375, -89.5177764892578, -1.56237993880192, 218, 18, 'PPL', 'P'),
(31733, 'Barclay', 38.577220916748, 0.673299521266479, -95.879997253418, -1.67342163887526, 218, 20, 'PPL', 'P'),
(44592, 'Barclay', 39.1441688537598, 0.683194629454723, -75.8644409179688, -1.32408427920326, 218, 25, 'PPL', 'P'),
(92437, 'Barclay', 31.0763893127441, 0.542385313138963, -97.1091690063477, -1.6948747330364, 218, 51, 'PPL', 'P'),
(112941, 'Barclay', 33.4191703796387, 0.583274556409658, -86.1669387817383, -1.50389678810572, 218, 2, 'PPL', 'P'),
(154184, 'Barclay', 41.4541702270508, 0.723511759144241, -80.6255569458008, -1.40718142995841, 218, 41, 'PPL', 'P'),
(158914, 'Barclay', 41.6558303833008, 0.72703139284089, -76.6266708374023, -1.33738770095459, 218, 45, 'PPL', 'P'),
(189915, 'Barclay', 37.5133285522461, 0.654731096619092, -114.250831604004, -1.99405318463146, 218, 39, 'PPL', 'P'),
(62707, 'Barclay Downs', 35.1572189331055, 0.613609226227179, -80.8344421386719, -1.41082716433267, 218, 33, 'PPL', 'P'),
(79652, 'Barclay Estates', 33.5561103820801, 0.58566461032995, -81.9216690063477, -1.42980285288976, 218, 48, 'PPL', 'P'),
(70486, 'Barclay Farm', 39.9058303833008, 0.696488130930989, -74.9941711425781, -1.30889520624211, 218, 37, 'PPL', 'P'),
(79653, 'Barclay Park', 33.5297203063965, 0.585204016619421, -81.6836090087891, -1.42564792211507, 218, 48, 'PPL', 'P'),
(62710, 'Barclaysville', 35.4686088562012, 0.61904400564273, -78.6944427490234, -1.37347712899264, 218, 33, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(62711, 'Barco', 36.3916702270508, 0.635154465762029, -75.9800033569336, -1.32610122425484, 218, 33, 'PPL', 'P'),
(206766, 'Barco', 48.2805595397949, 0.84265472867458, -121.67138671875, -2.12356630370949, 218, 56, 'PPL', 'P'),
(15096, 'Barcola', 27.8341693878174, 0.485797900375228, -81.8827819824219, -1.42912414628595, 218, 12, 'PPL', 'P'),
(34670, 'Barcreek', 37.2272186279297, 0.649737536417139, -83.64111328125, -1.45981281679137, 218, 21, 'PPL', 'P'),
(99622, 'Barcroft', 38.8558311462402, 0.678162187100854, -77.1041717529297, -1.34572166411183, 218, 53, 'PPL', 'P'),
(99623, 'Barcroft Hill', 38.8405609130859, 0.677895671254765, -77.1705627441406, -1.34688040550212, 218, 53, 'PPL', 'P'),
(99624, 'Barcroft Woods', 38.8416709899902, 0.677915045751695, -77.1708297729492, -1.34688506603403, 218, 53, 'PPL', 'P'),
(7259, 'Bard', 36.0744400024414, 0.629617753855754, -90.3769378662109, -1.57737513363572, 218, 4, 'PPL', 'P'),
(77822, 'Bard', 39.9277801513672, 0.696871226653797, -78.6594390869141, -1.37286619983857, 218, 45, 'PPL', 'P'),
(114507, 'Bard', 41.2402801513672, 0.719778673086223, -91.2874984741211, -1.59326741428271, 218, 16, 'PPL', 'P'),
(179941, 'Bard', 32.7891693115234, 0.572278963479966, -114.555282592773, -1.99936685679644, 218, 6, 'PPL', 'P'),
(188107, 'Bard', 35.1286087036133, 0.613109883522789, -103.245277404785, -1.80197002784841, 218, 38, 'PPL', 'P'),
(189916, 'Bard', 35.9877815246582, 0.628105278093671, -115.236671447754, -2.01125933580225, 218, 39, 'PPL', 'P'),
(108087, 'Bardane', 39.3627815246582, 0.687010140348479, -77.8655624389648, -1.35901043847716, 218, 58, 'PPL', 'P'),
(146999, 'Bardeen Corners', 43.3452796936035, 0.75651784585122, -76.1522216796875, -1.32910700101915, 218, 40, 'PPL', 'P'),
(39221, 'Bardel', 32.5508308410645, 0.56811917243629, -91.7574996948242, -1.60147048307237, 218, 22, 'PPL', 'P'),
(134090, 'Barden', 44.7905616760254, 0.781742775064233, -93.4102783203125, -1.63031691189373, 218, 28, 'PPL', 'P'),
(179942, 'Bardi', 37.764720916748, 0.659118721094025, -121.164169311523, -2.11471368992996, 218, 6, 'PPL', 'P'),
(7260, 'Bardill (historical)', 34.5838890075684, 0.603602731326342, -91.4483337402344, -1.59607451922971, 218, 4, 'PPL', 'P'),
(368, 'Bardin', 29.7141704559326, 0.518610108954849, -81.7249984741211, -1.42637030456076, 218, 12, 'PPL', 'P'),
(53331, 'Bardley', 36.6941719055176, 0.640434116044083, -91.1216735839844, -1.59037322396807, 218, 29, 'PPL', 'P'),
(34671, 'Bardo', 36.7597198486328, 0.641578143469354, -83.3444366455078, -1.45463483268393, 218, 21, 'PPL', 'P'),
(118718, 'Bardolph', 40.4949989318848, 0.706771061952976, -90.5644378662109, -1.58064762598321, 218, 18, 'PPL', 'P'),
(146998, 'Bardonia', 41.1094398498535, 0.717495079030507, -73.9966735839844, -1.29148558956404, 218, 40, 'PPL', 'P'),
(179943, 'Bardsdale', 34.3716697692871, 0.59989880688226, -118.931938171387, -2.07575390686902, 218, 6, 'PPL', 'P'),
(7261, 'Bardstown', 35.5355606079102, 0.62021253415003, -90.1600036621094, -1.57358891751395, 218, 4, 'PPL', 'P'),
(34672, 'Bardstown', 37.8091697692871, 0.659894499919565, -85.4669418334961, -1.49167953660499, 218, 21, 'PPL', 'P'),
(34673, 'Bardstown Junction', 37.939998626709, 0.662177894238199, -85.6994400024414, -1.49573739515794, 218, 21, 'PPL', 'P'),
(34674, 'Bardwell', 36.8705596923828, 0.643512663685188, -89.0097198486328, -1.55351267763639, 218, 21, 'PPL', 'P'),
(71738, 'Bardwell', 39.047779083252, 0.68151231059412, -83.9219436645508, -1.46471423161961, 218, 41, 'PPL', 'P'),
(92438, 'Bardwell', 32.2688903808594, 0.563198383111123, -96.6958312988281, -1.68766062911754, 218, 51, 'PPL', 'P'),
(124177, 'Bardwell', 42.2183303833008, 0.736848869883358, -72.3694381713867, -1.26308497390916, 218, 23, 'PPL', 'P'),
(158918, 'Bardwell', 41.5611114501953, 0.725378235594224, -75.8625030517578, -1.32405045705742, 218, 45, 'PPL', 'P'),
(173052, 'Bardwell', 42.5869407653809, 0.74328233470769, -88.7505569458008, -1.54898943168295, 218, 57, 'PPL', 'P'),
(44593, 'Bare Hills', 39.3811111450195, 0.687330052574425, -76.6536102294922, -1.33785788204504, 218, 25, 'PPL', 'P'),
(7262, 'Bare Stone', 35.4280586242676, 0.618336270583042, -91.6388931274414, -1.59940040795706, 218, 4, 'PPL', 'P'),
(112940, 'Barefield Crossroads', 31.5516700744629, 0.550680527302342, -85.4524993896484, -1.49142746840781, 218, 2, 'PPL', 'P'),
(884, 'Barefoot', 33.7033309936523, 0.588234094728685, -81.4775009155273, -1.42205065727265, 218, 48, 'PPL', 'P'),
(34675, 'Barefoot', 38.4236106872559, 0.670618516997096, -84.116943359375, -1.46811761833467, 218, 21, 'PPL', 'P'),
(84817, 'Barefoot', 36.6358299255371, 0.639415856401292, -86.1922225952148, -1.50433807389835, 218, 50, 'PPL', 'P'),
(44594, 'Barefoot Acres', 38.2874984741211, 0.668242910725718, -76.5072174072266, -1.33530284529522, 218, 25, 'PPL', 'P'),
(44595, 'Barefoot Park', 38.6897201538086, 0.675263003359167, -76.5788879394531, -1.33655373205923, 218, 25, 'PPL', 'P'),
(186384, 'Barela', 37.1155586242676, 0.647788701710446, -104.261108398438, -1.81969962333145, 218, 7, 'PPL', 'P'),
(188108, 'Barelas', 35.0730590820313, 0.612140359727945, -106.656112670898, -1.86150033348522, 218, 38, 'PPL', 'P'),
(158917, 'Bareville', 40.0922203063965, 0.699741248781548, -76.1561126708984, -1.32917491162695, 218, 45, 'PPL', 'P'),
(7263, 'Barfield', 35.9049987792969, 0.626660446623275, -89.7677764892578, -1.56674326193191, 218, 4, 'PPL', 'P'),
(84819, 'Barfield', 35.7849998474121, 0.62456607016301, -86.4266662597656, -1.5084298877552, 218, 50, 'PPL', 'P'),
(112942, 'Barfield', 33.3611106872559, 0.582261223614883, -85.7158279418945, -1.49602341865901, 218, 2, 'PPL', 'P'),
(84818, 'Barfield Meadows', 35.7911109924316, 0.624672729764667, -86.442497253418, -1.5087061907183, 218, 50, 'PPL', 'P'),
(79654, 'Barfield Mill', 34.4838905334473, 0.601857428705959, -80.5299987792969, -1.40551362532574, 218, 48, 'PPL', 'P'),
(58545, 'Barfoot', 32.5808296203613, 0.568642749906599, -89.1800003051758, -1.55648463225487, 218, 30, 'PPL', 'P'),
(99625, 'Barfoot', 36.978328704834, 0.645393587784083, -79.9297180175781, -1.39503674959737, 218, 53, 'PPL', 'P'),
(70487, 'Bargaintown', 39.3624992370605, 0.687005213500463, -74.5813903808594, -1.30169082286122, 218, 37, 'PPL', 'P'),
(7264, 'Barger Addition', 34.9861106872559, 0.610622823959791, -92.1097183227539, -1.6076178578166, 218, 4, 'PPL', 'P'),
(108088, 'Bargers Springs', 37.6141700744629, 0.656491113204498, -80.758056640625, -1.40949398589098, 218, 58, 'PPL', 'P'),
(29151, 'Bargersville', 39.5208282470703, 0.689768576026556, -86.1677780151367, -1.50391143549172, 218, 19, 'PPL', 'P'),
(84820, 'Bargerton', 35.7319412231445, 0.623640022472962, -88.4855575561523, -1.54436431981781, 218, 50, 'PPL', 'P'),
(177474, 'Bargytown', 41.5125007629395, 0.724529819049952, -72.1655578613281, -1.25952659121865, 218, 8, 'PPL', 'P'),
(7265, 'Barham', 33.7236099243164, 0.588588028837557, -93.0538864135742, -1.62409669969369, 218, 4, 'PPL', 'P'),
(39223, 'Barham', 31.3191699981689, 0.546622635459875, -93.392219543457, -1.63000172677872, 218, 22, 'PPL', 'P'),
(62712, 'Barham', 35.9419403076172, 0.627305197923184, -78.4044418334961, -1.36841565818289, 218, 33, 'PPL', 'P'),
(99627, 'Barham', 37.1411094665527, 0.64823464803498, -77.1130599975586, -1.34587679324533, 218, 53, 'PPL', 'P'),
(206763, 'Barham', 47.084171295166, 0.82177381467365, -119.011940002441, -2.07715020222855, 218, 56, 'PPL', 'P'),
(99626, 'Barhamsville', 37.4544410705566, 0.653703316175403, -76.8405609130859, -1.34112078701261, 218, 53, 'PPL', 'P'),
(19052, 'Barin', 32.5888900756836, 0.568783431391183, -84.9463882446289, -1.48259416254618, 218, 13, 'PPL', 'P'),
(126824, 'Baring', 45.1361083984375, 0.787773703089799, -67.3172225952148, -1.17490717758442, 218, 26, 'PPL', 'P'),
(139023, 'Baring', 40.2441711425781, 0.702393291174077, -92.2055587768555, -1.60929058929728, 218, 29, 'PPL', 'P'),
(206764, 'Baring', 47.7733306884766, 0.833801915157965, -121.484169006348, -2.12029873821001, 218, 56, 'PPL', 'P'),
(194554, 'Barite', 43.5563888549805, 0.760202395798372, -114.325561523438, -1.99535746777533, 218, 17, 'PPL', 'P'),
(195924, 'Barite', 46.9452781677246, 0.819349672291405, -113.437782287598, -1.97986279707908, 218, 31, 'PPL', 'P'),
(62713, 'Barium Springs', 35.7188911437988, 0.623412255620733, -80.8983306884766, -1.41194222988109, 218, 33, 'PPL', 'P'),
(53332, 'Bark Camp (historical)', 36.252498626709, 0.632725463110794, -90.0888900756836, -1.57234775128792, 218, 29, 'PPL', 'P'),
(19054, 'Bark Camp Place', 34.3794403076172, 0.600034428360772, -83.8880615234375, -1.46412287669955, 218, 13, 'PPL', 'P'),
(44596, 'Bark Hill', 39.586669921875, 0.690917730036925, -77.1527786254883, -1.34657001407708, 218, 25, 'PPL', 'P'),
(173053, 'Bark Point', 46.8875007629395, 0.818341266344647, -91.1833267211914, -1.59144927420652, 218, 57, 'PPL', 'P'),
(194101, 'Bark Ranch', 40.1175003051758, 0.700182467995147, -105.438888549805, -1.84025576483744, 218, 7, 'PPL', 'P'),
(129670, 'Bark River', 45.7102813720703, 0.797794911955658, -87.3047180175781, -1.52375478193196, 218, 27, 'PPL', 'P'),
(7268, 'Barkada', 33.6730613708496, 0.587705790147441, -91.9022216796875, -1.60399635820826, 218, 4, 'PPL', 'P'),
(202970, 'Barke Circle', 40.6647186279297, 0.709733229454444, -111.927223205566, -1.95349856755174, 218, 52, 'PPL', 'P'),
(19053, 'Barker', 33.0119400024414, 0.576167045513427, -84.4702835083008, -1.47428456731292, 218, 13, 'PPL', 'P'),
(92440, 'Barker', 29.7841701507568, 0.519831834104923, -95.6847229003906, -1.67001345847023, 218, 51, 'PPL', 'P'),
(108089, 'Barker', 39.5794410705566, 0.690791562780283, -80.6605606079102, -1.40779235911247, 218, 58, 'PPL', 'P'),
(147000, 'Barker', 43.3300018310547, 0.756251196847076, -78.5550003051758, -1.37104339923047, 218, 40, 'PPL', 'P'),
(195926, 'Barker', 46.5344390869141, 0.812179177635394, -111.488609313965, -1.9458433109983, 218, 31, 'PPL', 'P'),
(206765, 'Barker', 48.5774993896484, 0.847837306734901, -119.480827331543, -2.08533382994226, 218, 56, 'PPL', 'P'),
(129672, 'Barker Creek', 44.7802810668945, 0.781563344585789, -85.3133316040039, -1.4889985323356, 218, 27, 'PPL', 'P'),
(99630, 'Barker Crossroads', 36.6197204589844, 0.639134693169206, -78.0119400024414, -1.36156520891088, 218, 53, 'PPL', 'P'),
(62714, 'Barker Heights', 35.3111114501953, 0.616295157344578, -82.4441680908203, -1.43892218225246, 218, 33, 'PPL', 'P'),
(99628, 'Barker Land', 39.0736083984375, 0.681963117187643, -77.8897171020508, -1.35943201687772, 218, 53, 'PPL', 'P'),
(99629, 'Barker Mill', 36.7005615234375, 0.64054563591473, -82.3197174072266, -1.43675010806739, 218, 53, 'PPL', 'P'),
(19057, 'Barker Spring', 32.9213905334473, 0.574586659143547, -84.4383316040039, -1.47372690138065, 218, 13, 'PPL', 'P'),
(15097, 'Barker Store', 30.9141693115234, 0.539554040005073, -85.9161071777344, -1.4995189507478, 218, 12, 'PPL', 'P'),
(62715, 'Barker Ten Mile', 34.6797218322754, 0.605275329648966, -78.9888916015625, -1.37861623094816, 218, 33, 'PPL', 'P'),
(19055, 'Barkers Crossroads', 33.3738899230957, 0.582484263356177, -85.1711120605469, -1.48651633304159, 218, 13, 'PPL', 'P'),
(99631, 'Barkers Crossroads', 38.7583312988281, 0.676460493743321, -77.2163925170898, -1.34768028593553, 218, 53, 'PPL', 'P'),
(147001, 'Barkers Grove', 42.9877815246582, 0.750278325733274, -73.5522232055664, -1.28372846709891, 218, 40, 'PPL', 'P'),
(13322, 'Barkers Landing', 39.0849990844727, 0.682161922163017, -75.4574966430664, -1.31698176173408, 218, 10, 'PPL', 'P'),
(34677, 'Barkers Mill', 36.6680603027344, 0.639978382602544, -87.3477783203125, -1.52450632599158, 218, 21, 'PPL', 'P'),
(99632, 'Barkers Mill', 37.5605583190918, 0.655555411555499, -77.258056640625, -1.34840746207118, 218, 53, 'PPL', 'P'),
(147002, 'Barkersville', 43.0883293151855, 0.752033215733581, -74.0400009155273, -1.29224179415557, 218, 40, 'PPL', 'P'),
(84821, 'Barkertown', 35.3916702270508, 0.617701173242085, -85.5530624389648, -1.49318262472423, 218, 50, 'PPL', 'P'),
(147003, 'Barkertown', 42.5513916015625, 0.742661884752729, -77.9002838134766, -1.35961644078321, 218, 40, 'PPL', 'P'),
(79657, 'Barkerville', 32.7055587768555, 0.570819684360657, -80.9369430541992, -1.41261614279493, 218, 48, 'PPL', 'P'),
(124178, 'Barkerville', 42.4225006103516, 0.740412312579939, -73.3091735839844, -1.27948645095658, 218, 23, 'PPL', 'P'),
(193111, 'Barkerville', 32.8316688537598, 0.573020720422581, -110.944717407227, -1.93635060645077, 218, 5, 'PPL', 'P'),
(179944, 'Barkerville (historical)', 39.1544418334961, 0.683373926775112, -122.561393737793, -2.13909985655765, 218, 6, 'PPL', 'P'),
(158919, 'Barkeyville', 41.1919403076172, 0.718934983652886, -79.975830078125, -1.3958415568788, 218, 45, 'PPL', 'P'),
(177475, 'Barkhampsted Center', 41.9288902282715, 0.731797186190614, -72.9669418334961, -1.27351338010569, 218, 8, 'PPL', 'P'),
(177476, 'Barkhamsted', 41.9291687011719, 0.731802046459604, -72.914436340332, -1.2725969863746, 218, 8, 'PPL', 'P'),
(158921, 'Barking', 40.5327796936035, 0.70743046063888, -79.7822189331055, -1.39246240492965, 218, 45, 'PPL', 'P'),
(13323, 'Barkley', 39.8319396972656, 0.695198495173118, -75.5188903808594, -1.31805328459867, 218, 10, 'PPL', 'P'),
(53333, 'Barkley', 39.7363891601563, 0.693530823698511, -91.5094375610352, -1.59714098208823, 218, 29, 'PPL', 'P'),
(200367, 'Barkley (historical)', 42.3819389343262, 0.739704377783169, -121.809722900391, -2.12598072555375, 218, 43, 'PPL', 'P'),
(39224, 'Barkley Place', 30.3677806854248, 0.530017759484203, -91.0819396972656, -1.58967973682021, 218, 22, 'PPL', 'P'),
(34676, 'Barkley Shores', 36.7574996948242, 0.641539394475493, -87.9641723632813, -1.53526443153106, 218, 21, 'PPL', 'P'),
(92441, 'Barkman', 33.5252799987793, 0.585126518631699, -94.2441711425781, -1.64487108725101, 218, 51, 'PPL', 'P'),
(19056, 'Barko Village', 30.9041690826416, 0.539379503085132, -83.3349990844727, -1.45447011617051, 218, 13, 'PPL', 'P'),
(44600, 'Barksdale', 39.6688919067383, 0.692352774390314, -75.8150024414063, -1.32322141501008, 218, 25, 'PPL', 'P'),
(58546, 'Barksdale', 34.2238883972168, 0.597319535366518, -90.3947219848633, -1.57768552506077, 218, 30, 'PPL', 'P'),
(79658, 'Barksdale', 34.5694389343262, 0.603350529971111, -82.0875015258789, -1.43269717636246, 218, 48, 'PPL', 'P'),
(99636, 'Barksdale', 36.6150016784668, 0.639052334912496, -79.1563873291016, -1.38153958287674, 218, 53, 'PPL', 'P'),
(108090, 'Barksdale', 37.7075004577637, 0.658120035685245, -80.8866729736328, -1.41173876437381, 218, 58, 'PPL', 'P'),
(173055, 'Barksdale', 46.6213912963867, 0.813696779982576, -90.9319381713867, -1.58706171631061, 218, 57, 'PPL', 'P'),
(191108, 'Barksdale', 29.7250003814697, 0.518799126813217, -100.03360748291, -1.74591581322442, 218, 51, 'PPL', 'P'),
(44598, 'Barksdale Farms', 39.6655616760254, 0.692294650899523, -75.8127822875977, -1.32318266601622, 218, 25, 'PPL', 'P'),
(58547, 'Barland', 31.8875007629395, 0.556541878545497, -90.8105621337891, -1.58494330482151, 218, 30, 'PPL', 'P'),
(99634, 'Barlett', 36.9408302307129, 0.644739115946196, -76.5374984741211, -1.33583134961355, 218, 53, 'PPL', 'P'),
(99635, 'Barley', 36.5638885498047, 0.638160242526347, -77.7244415283203, -1.356547413943, 218, 53, 'PPL', 'P'),
(13324, 'Barley Woods', 39.7727813720703, 0.694165987618495, -75.6133270263672, -1.31970151499732, 218, 10, 'PPL', 'P'),
(7270, 'Barling', 35.3255615234375, 0.616547358699808, -94.3013916015625, -1.64586977265979, 218, 4, 'PPL', 'P'),
(34678, 'Barlow', 37.0516700744629, 0.64667363616203, -89.0466690063477, -1.55415756209435, 218, 21, 'PPL', 'P'),
(58548, 'Barlow', 31.8225002288818, 0.555407405210637, -90.649169921875, -1.58212647933653, 218, 30, 'PPL', 'P'),
(71739, 'Barlow', 39.398609161377, 0.68763545057243, -81.6650009155273, -1.42532314962014, 218, 41, 'PPL', 'P'),
(77823, 'Barlow', 39.7552795410156, 0.693860523041463, -77.2302780151367, -1.34792263359473, 218, 45, 'PPL', 'P'),
(112944, 'Barlow', 31.5666694641113, 0.550942316037497, -88.3236083984375, -1.54153777379485, 218, 2, 'PPL', 'P'),
(139636, 'Barlow', 47.5697212219238, 0.830248259578391, -99.1374969482422, -1.73027573393266, 218, 34, 'PPL', 'P'),
(179945, 'Barlow', 38.4249992370605, 0.670642751763016, -122.857498168945, -2.144267853811, 218, 6, 'PPL', 'P'),
(194555, 'Barlow', 43.6711082458496, 0.762204626884921, -112.012222290039, -1.95498208143696, 218, 17, 'PPL', 'P'),
(200368, 'Barlow', 45.2519416809082, 0.789795375252305, -122.719436645508, -2.1418582256567, 218, 43, 'PPL', 'P'),
(53334, 'Barlow (historical)', 37.0138893127441, 0.646014237476126, -90.6138916015625, -1.5815107564925, 218, 29, 'PPL', 'P'),
(108091, 'Barlow (historical)', 38.3944396972656, 0.6701093871757, -81.5827789306641, -1.42388810526675, 218, 58, 'PPL', 'P'),
(112943, 'Barlow Bend', 31.454439163208, 0.54898352776623, -87.6347198486328, -1.52951440042147, 218, 2, 'PPL', 'P'),
(158922, 'Barlow Heights', 40.211669921875, 0.70182603786189, -75.5449981689453, -1.31850895146118, 218, 45, 'PPL', 'P'),
(77824, 'Barlow Knoll', 39.8452796936035, 0.695431322031419, -77.2263870239258, -1.34785472298693, 218, 45, 'PPL', 'P'),
(112945, 'Barlow Landing', 30.9572200775146, 0.540305417617125, -87.8724975585938, -1.53366440434814, 218, 2, 'PPL', 'P'),
(118719, 'Barlow Park', 40.309440612793, 0.703532458330358, -87.6230621337891, -1.52931093491419, 218, 18, 'PPL', 'P'),
(62717, 'Barlowes', 34.4455604553223, 0.601188442640131, -77.5977783203125, -1.35433672392213, 218, 33, 'PPL', 'P'),
(99637, 'Barlows Corner', 37.3586082458496, 0.652030717852779, -76.7172164916992, -1.33896802074544, 218, 53, 'PPL', 'P'),
(124179, 'Barlows Landing', 41.6908302307129, 0.727642255415927, -70.6255569458008, -1.23264850475897, 218, 23, 'PPL', 'P'),
(39226, 'Barmen', 30.1622200012207, 0.526430048732189, -90.8161087036133, -1.58504011072713, 218, 22, 'PPL', 'P'),
(108092, 'Barnabus', 37.7438888549805, 0.658755133026202, -82.0094375610352, -1.43133470314877, 218, 58, 'PPL', 'P'),
(44599, 'Barnaby Manor Oaks', 38.8180618286133, 0.677502988152033, -76.9680633544922, -1.34334612441948, 218, 25, 'PPL', 'P'),
(13032, 'Barnaby Terrace', 38.8333282470703, 0.677769437419095, -76.9894409179688, -1.3437192332882, 218, 9, 'PPL', 'P'),
(13033, 'Barnaby Woods', 38.9747200012207, 0.68023718906419, -77.0599975585938, -1.34495067897625, 218, 9, 'PPL', 'P'),
(29152, 'Barnard', 39.8486099243164, 0.69548944552221, -86.7005615234375, -1.5132102619119, 218, 19, 'PPL', 'P'),
(31735, 'Barnard', 39.190559387207, 0.684004297005134, -98.0416717529297, -1.71114997624814, 218, 20, 'PPL', 'P'),
(62718, 'Barnard', 35.8394393920898, 0.625516219460923, -82.7541732788086, -1.44433279348112, 218, 33, 'PPL', 'P'),
(70488, 'Barnard', 39.6208305358887, 0.691513945225967, -74.7847213745117, -1.30523961817181, 218, 37, 'PPL', 'P'),
(126826, 'Barnard', 45.3663902282715, 0.791792879227919, -69.2074966430664, -1.20789868348443, 218, 26, 'PPL', 'P'),
(129673, 'Barnard', 45.2511100769043, 0.789780861024364, -85.3011093139648, -1.48878521313229, 218, 27, 'PPL', 'P'),
(139024, 'Barnard', 40.1744384765625, 0.70117622655591, -94.8236083984375, -1.65498417517448, 218, 29, 'PPL', 'P'),
(147004, 'Barnard', 43.2125015258789, 0.754200429649661, -77.6430587768555, -1.35512701697561, 218, 40, 'PPL', 'P'),
(169793, 'Barnard', 45.7324981689453, 0.798182668210374, -98.4961090087891, -1.71908140260662, 218, 49, 'PPL', 'P'),
(171707, 'Barnard', 43.7286109924316, 0.763208239141717, -72.6194381713867, -1.26744829703915, 218, 55, 'PPL', 'P'),
(126828, 'Barnard Corner', 45.3072204589844, 0.790760171936214, -69.1236114501953, -1.20643461067516, 218, 26, 'PPL', 'P'),
(118720, 'Barnard Mill (historical)', 42.4172210693359, 0.740320167206222, -88.3608322143555, -1.54218745194278, 218, 18, 'PPL', 'P'),
(158923, 'Barnards', 40.8252792358398, 0.71253554071148, -79.2300033569336, -1.38282442494465, 218, 45, 'PPL', 'P'),
(62719, 'Barnardsville', 35.7775001525879, 0.624435175795432, -82.4550018310547, -1.43911126668986, 218, 33, 'PPL', 'P'),
(84823, 'Barnardsville', 35.7611083984375, 0.624149085715331, -84.5991668701172, -1.47653400632765, 218, 50, 'PPL', 'P'),
(70489, 'Barnegat', 39.753059387207, 0.693821774047602, -74.2233276367188, -1.29544144904724, 218, 37, 'PPL', 'P'),
(147006, 'Barnegat', 41.6319389343262, 0.726614408393211, -73.9472198486328, -1.29062245905475, 218, 40, 'PPL', 'P'),
(200369, 'Barnegat (historical)', 45.5055618286133, 0.794221881879153, -123.943061828613, -2.16321451391221, 218, 43, 'PPL', 'P'),
(70490, 'Barnegat Bay', 39.7580604553223, 0.693909059152329, -74.1919403076172, -1.29489363681101, 218, 37, 'PPL', 'P'),
(70491, 'Barnegat Bay Estates', 39.9708290100098, 0.697622570976336, -74.129997253418, -1.2938125265665, 218, 37, 'PPL', 'P'),
(70492, 'Barnegat Beach', 39.7786102294922, 0.694267720372136, -74.1911087036133, -1.29487912258307, 218, 37, 'PPL', 'P'),
(70493, 'Barnegat Estates', 39.7611083984375, 0.693962255795104, -74.2594375610352, -1.29607168611921, 218, 37, 'PPL', 'P'),
(70494, 'Barnegat Light', 39.7574996948242, 0.693899272035323, -74.1066665649414, -1.29340532923582, 218, 37, 'PPL', 'P'),
(70496, 'Barnegat Pines', 39.896110534668, 0.696318487569551, -74.2102813720703, -1.29521374877404, 218, 37, 'PPL', 'P'),
(158924, 'Barners Hill', 40.3480606079102, 0.704206504402257, -79.7386093139648, -1.3917012734901, 218, 45, 'PPL', 'P'),
(147007, 'Barnerville', 42.6875, 0.745037424445079, -74.4269409179688, -1.29899517120585, 218, 40, 'PPL', 'P'),
(7271, 'Barnes', 35.6352806091309, 0.621952976501424, -93.8202819824219, -1.63747282574277, 218, 4, 'PPL', 'P'),
(19058, 'Barnes', 34.2730598449707, 0.598177739027796, -83.9166717529297, -1.46462221940394, 218, 13, 'PPL', 'P'),
(31736, 'Barnes', 39.7119407653809, 0.693104118712853, -96.8741683959961, -1.69077319864157, 218, 20, 'PPL', 'P'),
(39225, 'Barnes', 32.3791694641113, 0.565123116209951, -91.1230621337891, -1.59039745873399, 218, 22, 'PPL', 'P'),
(58549, 'Barnes', 32.9022216796875, 0.574252099531606, -89.5016708374023, -1.56209884214886, 218, 30, 'PPL', 'P'),
(84825, 'Barnes', 36.3530616760254, 0.634480619427211, -82.3105621337891, -1.43659031840199, 218, 50, 'PPL', 'P'),
(92442, 'Barnes', 30.8930606842041, 0.539185624957774, -94.6966705322266, -1.65276869146364, 218, 51, 'PPL', 'P'),
(99638, 'Barnes', 38.2208290100098, 0.667079309066435, -78.4486083984375, -1.36918651016041, 218, 53, 'PPL', 'P'),
(112932, 'Barnes', 31.4677791595459, 0.54921635462453, -85.1188888549805, -1.48560486615852, 218, 2, 'PPL', 'P'),
(118721, 'Barnes', 40.5027809143066, 0.70690688316857, -88.9016723632813, -1.55162689326851, 218, 18, 'PPL', 'P'),
(158927, 'Barnes', 41.6780586242676, 0.727419348832687, -79.0280609130859, -1.37929986439999, 218, 45, 'PPL', 'P'),
(202975, 'Barnes', 41.100830078125, 0.717344810165999, -112.064437866211, -1.95589341516199, 218, 52, 'PPL', 'P'),
(62720, 'Barnes (historical)', 35.7122192382813, 0.623295808902069, -78.6580581665039, -1.37284209823071, 218, 33, 'PPL', 'P'),
(189919, 'Barnes (historical)', 38.9513893127441, 0.679829991733517, -115.138893127441, -2.00955278217572, 218, 39, 'PPL', 'P'),
(114508, 'Barnes City', 41.5083312988281, 0.724457048173165, -92.4680633544922, -1.6138721584786, 218, 16, 'PPL', 'P'),
(44601, 'Barnes Corner', 39.6749992370605, 0.692459367412945, -76.0658264160156, -1.32759911920995, 218, 25, 'PPL', 'P'),
(147008, 'Barnes Corners', 43.8169403076172, 0.764749876517737, -75.8180618286133, -1.32327481138993, 218, 40, 'PPL', 'P'),
(154185, 'Barnes Corners', 41.5097198486328, 0.724481282939085, -81.0519409179688, -1.41462323415047, 218, 41, 'PPL', 'P'),
(154186, 'Barnes Corners (historical)', 41.6780586242676, 0.727419348832687, -80.9105606079102, -1.41215568224246, 218, 41, 'PPL', 'P'),
(19059, 'Barnes Crossroads', 32.9669418334961, 0.575381679307963, -84.6902770996094, -1.47812417981454, 218, 13, 'PPL', 'P'),
(77825, 'Barnes Gap', 39.7436103820801, 0.693656857797099, -78.355827331543, -1.36756717505959, 218, 45, 'PPL', 'P'),
(200370, 'Barnes Heights', 45.5325012207031, 0.794692062969607, -122.752777099609, -2.14244012635488, 218, 43, 'PPL', 'P'),
(147009, 'Barnes Hole', 40.9991683959961, 0.715570479089734, -72.133056640625, -1.25895933790647, 218, 40, 'PPL', 'P'),
(99639, 'Barnes Junction', 36.8205604553223, 0.642640012374996, -78.595832824707, -1.37175606113817, 218, 53, 'PPL', 'P'),
(44602, 'Barnes Landing', 38.3902816772461, 0.670036816035995, -76.1052780151367, -1.32828767950979, 218, 25, 'PPL', 'P'),
(147010, 'Barnes Landing', 41.0044403076172, 0.715662491305396, -72.1255569458008, -1.25882844353889, 218, 40, 'PPL', 'P'),
(108093, 'Barnes Mill', 39.3511085510254, 0.686806408525088, -78.6366729736328, -1.37246885620393, 218, 58, 'PPL', 'P'),
(58550, 'Barnes Prairie', 32.4213905334473, 0.565860012883576, -90.0141677856445, -1.57104360130211, 218, 30, 'PPL', 'P'),
(79660, 'Barnes Station', 34.2591705322266, 0.597935324789572, -82.6808319091797, -1.44305274510317, 218, 48, 'PPL', 'P'),
(158934, 'Barnesboro (historical)', 40.6624984741211, 0.709694480460583, -78.7802810668945, -1.37497529026386, 218, 45, 'PPL', 'P'),
(34679, 'Barnesburg', 37.1477813720703, 0.648351094753644, -84.5327835083008, -1.47537539809541, 218, 21, 'PPL', 'P'),
(71741, 'Barnesburg', 39.228889465332, 0.684673283070962, -84.6222229003906, -1.47693640996836, 218, 41, 'PPL', 'P'),
(19060, 'Barnesdale', 31.1863899230957, 0.544305185968801, -83.3733291625977, -1.45513910223634, 218, 13, 'PPL', 'P'),
(200371, 'Barnesdale', 45.6394386291504, 0.796558472840562, -123.853332519531, -2.16164844203318, 218, 43, 'PPL', 'P'),
(141234, 'Barneston', 40.0483283996582, 0.698975190493987, -96.5766677856445, -1.68558083346424, 218, 35, 'PPL', 'P'),
(158929, 'Barneston', 40.1044387817383, 0.699954501405837, -75.8102798461914, -1.32313899017434, 218, 45, 'PPL', 'P'),
(206767, 'Barneston', 47.3877792358398, 0.827072772873608, -121.860000610352, -2.12685823713293, 218, 56, 'PPL', 'P'),
(19061, 'Barnesville', 33.0544395446777, 0.576908802456042, -84.1558303833008, -1.46879632493848, 218, 13, 'PPL', 'P'),
(31738, 'Barnesville', 38.0152816772461, 0.663491831341017, -94.6611099243164, -1.6521480417716, 218, 20, 'PPL', 'P'),
(44606, 'Barnesville', 39.2205581665039, 0.684527874475444, -77.3777770996094, -1.35049697826245, 218, 25, 'PPL', 'P'),
(53336, 'Barnesville', 39.8994407653809, 0.696376611060342, -92.5897216796875, -1.61599549681572, 218, 29, 'PPL', 'P'),
(58551, 'Barnesville', 34.9938888549805, 0.610758578596358, -90.095832824707, -1.57246892511752, 218, 30, 'PPL', 'P'),
(62721, 'Barnesville', 34.4086112976074, 0.600543558182168, -79.0469436645508, -1.37962943058488, 218, 33, 'PPL', 'P'),
(71742, 'Barnesville', 39.9880599975586, 0.697923308442433, -81.1766662597656, -1.4168001020255, 218, 41, 'PPL', 'P'),
(84826, 'Barnesville', 35.4352798461914, 0.61846230468163, -87.3855590820313, -1.52516572467748, 218, 50, 'PPL', 'P'),
(112947, 'Barnesville', 34.139720916748, 0.59585053570923, -88.0777816772461, -1.53724728812068, 218, 2, 'PPL', 'P'),
(134091, 'Barnesville', 46.6522216796875, 0.814234871680826, -96.4194412231445, -1.68283671227702, 218, 28, 'PPL', 'P'),
(158930, 'Barnesville', 40.8144416809082, 0.712346389695057, -76.0311126708984, -1.32699325006196, 218, 45, 'PPL', 'P'),
(177477, 'Barnesville', 41.3086090087891, 0.72097123662236, -72.9102783203125, -1.27252441523489, 218, 8, 'PPL', 'P'),
(194100, 'Barnesville', 40.4791717529297, 0.706494825568908, -104.47917175293, -1.82350554684528, 218, 7, 'PPL', 'P'),
(171709, 'Barnet', 44.2969398498535, 0.773127448937826, -72.0497207641602, -1.25750485247712, 218, 55, 'PPL', 'P'),
(39227, 'Barnet Springs', 32.5074996948242, 0.567362901265735, -92.6758270263672, -1.61749831861885, 218, 22, 'PPL', 'P'),
(19062, 'Barnett', 33.5038909912109, 0.584753210025897, -82.8077774047852, -1.44526836197207, 218, 13, 'PPL', 'P'),
(26446, 'Barnett', 39.2644386291504, 0.685293733025923, -89.6972198486328, -1.56551181624385, 218, 18, 'PPL', 'P'),
(44603, 'Barnett', 39.4049987792969, 0.687746970443077, -77.2225036621094, -1.34778694553719, 218, 25, 'PPL', 'P'),
(53337, 'Barnett', 38.3783302307129, 0.669828223943615, -92.6744384765625, -1.61747408385293, 218, 29, 'PPL', 'P'),
(58552, 'Barnett', 31.9866695404053, 0.558272700227453, -88.9049987792969, -1.55168495018027, 218, 30, 'PPL', 'P'),
(99640, 'Barnett', 36.9236106872559, 0.644438578217181, -82.001106262207, -1.43118929455325, 218, 53, 'PPL', 'P'),
(19063, 'Barnett Bluffs', 33.8591690063477, 0.590953981149983, -83.3213882446289, -1.45423256220127, 218, 13, 'PPL', 'P'),
(112949, 'Barnett Chapel', 34.1619415283203, 0.596238358542973, -87.2994384765625, -1.52366263655824, 218, 2, 'PPL', 'P'),
(112948, 'Barnett Crossroads', 31.2211093902588, 0.544911154985335, -87.304443359375, -1.52374998824199, 218, 2, 'PPL', 'P'),
(34680, 'Barnett Springs', 37.2419395446777, 0.649994464883304, -85.0913925170898, -1.48512496453008, 218, 21, 'PPL', 'P'),
(108094, 'Barnettown', 37.6974983215332, 0.65794546547579, -80.6772232055664, -1.40808317630351, 218, 58, 'PPL', 'P'),
(84827, 'Barnetts', 36.4524993896484, 0.636216134930589, -82.2111129760742, -1.43485460316153, 218, 50, 'PPL', 'P'),
(99641, 'Barnetts', 37.3669395446777, 0.652176126448297, -77.1580581665039, -1.34666215945079, 218, 53, 'PPL', 'P'),
(34681, 'Barnetts Creek', 37.8277816772461, 0.660219338993527, -82.8797225952148, -1.44652404242604, 218, 21, 'PPL', 'P'),
(158933, 'Barnettstown', 40.211109161377, 0.701816250744884, -78.1772232055664, -1.36444994500365, 218, 45, 'PPL', 'P'),
(147011, 'Barneveld', 43.2722206115723, 0.75524272432129, -75.1902770996094, -1.31231790087508, 218, 40, 'PPL', 'P'),
(173057, 'Barneveld', 43.0155601501465, 0.750763154209723, -89.8952789306641, -1.56896859933878, 218, 57, 'PPL', 'P'),
(7274, 'Barney', 35.2516708374023, 0.615257722941937, -92.206672668457, -1.60931003037324, 218, 4, 'PPL', 'P'),
(19064, 'Barney', 31.0080604553223, 0.541192749602826, -83.5130615234375, -1.45757789200458, 218, 13, 'PPL', 'P'),
(112952, 'Barney', 33.7161102294922, 0.58845713446998, -87.1586074829102, -1.52120467203015, 218, 2, 'PPL', 'P'),
(114510, 'Barney', 41.1666717529297, 0.718493964176369, -94.0036087036133, -1.64067248063445, 218, 16, 'PPL', 'P'),
(139639, 'Barney', 46.267219543457, 0.807515316776393, -97.0002822875977, -1.69297430128252, 218, 34, 'PPL', 'P'),
(92443, 'Barney Groves Colonia', 26.2940006256104, 0.458916884438349, -98.3440017700195, -1.71642663047397, 218, 51, 'PPL', 'P'),
(147014, 'Barney Mills', 42.0922203063965, 0.734647833821435, -77.7058334350586, -1.35622264144807, 218, 40, 'PPL', 'P'),
(79661, 'Barney Ridge', 32.9694404602051, 0.575425288570813, -80.1944427490234, -1.39965706777255, 218, 48, 'PPL', 'P'),
(112951, 'Barneys Lower Landing', 31.9922199249268, 0.558369572712105, -88.0755615234375, -1.53720853912682, 218, 2, 'PPL', 'P'),
(19065, 'Barneyville', 31.2138900756836, 0.544785154176261, -83.4541702270508, -1.45655004498186, 218, 13, 'PPL', 'P'),
(124180, 'Barneyville', 41.771671295166, 0.729053198161451, -71.2861099243164, -1.24417732911793, 218, 23, 'PPL', 'P'),
(53338, 'Barnhart', 38.3441696166992, 0.669232008754573, -90.3933334350586, -1.57766129029485, 218, 29, 'PPL', 'P'),
(191109, 'Barnhart', 31.1277809143066, 0.543282265794102, -101.170280456543, -1.76575449913275, 218, 51, 'PPL', 'P'),
(29153, 'Barnhart Town', 39.5038909912109, 0.689472965145557, -87.4355621337891, -1.5260384425667, 218, 19, 'PPL', 'P'),
(19066, 'Barnhill', 32.3263893127441, 0.564201928788892, -82.6691665649414, -1.44284914643784, 218, 13, 'PPL', 'P'),
(26447, 'Barnhill', 38.2844390869141, 0.668189514345862, -88.3641662597656, -1.54224564201259, 218, 18, 'PPL', 'P'),
(79662, 'Barnhill', 33.702220916748, 0.588214720231755, -79.3758316040039, -1.38536960799844, 218, 48, 'PPL', 'P'),
(154187, 'Barnhill', 40.4480590820313, 0.70595180702264, -81.3691711425781, -1.42015994605674, 218, 41, 'PPL', 'P'),
(112953, 'Barnisdale Forest', 33.5900001525879, 0.586256098408056, -86.6786117553711, -1.51282716618909, 218, 2, 'PPL', 'P'),
(158935, 'Barnitz', 40.1213912963867, 0.700250378602944, -77.2266693115234, -1.34785964983495, 218, 45, 'PPL', 'P'),
(126829, 'Barnjum', 44.9413909912109, 0.784375243222749, -70.3655624389648, -1.22811074457759, 218, 26, 'PPL', 'P'),
(70498, 'Barnsboro', 39.7616691589355, 0.69397204291211, -75.1602783203125, -1.31179432340477, 218, 37, 'PPL', 'P'),
(39228, 'Barnsdall', 30.4805603027344, 0.531986135135394, -92.6549987792969, -1.61713479713006, 218, 22, 'PPL', 'P'),
(75068, 'Barnsdall', 36.561939239502, 0.638126220643421, -96.1613922119141, -1.67833290739953, 218, 42, 'PPL', 'P'),
(34682, 'Barnsley', 37.2569389343262, 0.650256253618459, -87.4897232055664, -1.52698373159562, 218, 21, 'PPL', 'P'),
(77826, 'Barnsley', 39.7655601501465, 0.694039953519907, -75.9891662597656, -1.32626114707829, 218, 45, 'PPL', 'P'),
(124181, 'Barnstable', 41.7000007629395, 0.727802311397441, -70.3000030517578, -1.22696651741524, 218, 23, 'PPL', 'P'),
(143492, 'Barnstead', 43.3338890075684, 0.756319040875846, -71.293327331543, -1.24430329663749, 218, 36, 'PPL', 'P'),
(92444, 'Barnum', 30.9447193145752, 0.54008723814482, -94.6725006103516, -1.65234684674698, 218, 51, 'PPL', 'P'),
(108095, 'Barnum', 39.4416694641113, 0.68838699463205, -79.1147232055664, -1.3808124067411, 218, 58, 'PPL', 'P'),
(114511, 'Barnum', 42.5086097717285, 0.741915200962098, -94.3649978637695, -1.64697991136019, 218, 16, 'PPL', 'P'),
(134095, 'Barnum', 46.503059387207, 0.811631498557219, -92.6883316040039, -1.61771656467019, 218, 28, 'PPL', 'P'),
(147012, 'Barnum', 42.0022201538086, 0.733077034831479, -78.4119415283203, -1.36854655255046, 218, 40, 'PPL', 'P'),
(173059, 'Barnum', 43.2188911437988, 0.754311949520308, -90.8394393920898, -1.5854473080578, 218, 57, 'PPL', 'P'),
(209292, 'Barnum', 43.6641693115234, 0.76208351963435, -106.908889770508, -1.86591212614705, 218, 59, 'PPL', 'P'),
(147013, 'Barnum Corners', 41.4588890075684, 0.723594117400952, -73.5561065673828, -1.28379624454865, 218, 40, 'PPL', 'P'),
(147018, 'Barnum Island', 40.6044387817383, 0.708681147665808, -73.6444396972656, -1.2853379485037, 218, 40, 'PPL', 'P'),
(53339, 'Barnumton', 38.1100006103516, 0.665144988587683, -92.936393737793, -1.62204606565433, 218, 29, 'PPL', 'P'),
(171711, 'Barnumtown', 44.2080612182617, 0.771576224181883, -73.1638870239258, -1.27695072212466, 218, 55, 'PPL', 'P'),
(171712, 'Barnumville', 43.1897201538086, 0.753802819698912, -73.0216674804688, -1.27446852283065, 218, 55, 'PPL', 'P'),
(79663, 'Barnwell', 33.2447204589844, 0.580229830914398, -81.35888671875, -1.41998044899927, 218, 48, 'PPL', 'P'),
(112950, 'Barnwell', 30.4247207641602, 0.53101155133448, -87.8794403076172, -1.53378557817774, 218, 2, 'PPL', 'P'),
(192891, 'Barnwell', 35.2930603027344, 0.615980105387621, -115.235000610352, -2.01123017418831, 218, 6, 'PPL', 'P'),
(129674, 'Baroda', 41.9575004577637, 0.732296528895004, -86.4855575561523, -1.50945773477792, 218, 27, 'PPL', 'P'),
(134098, 'Baroda', 43.7208290100098, 0.763072417926123, -93.6747207641602, -1.63493230322089, 218, 28, 'PPL', 'P'),
(179946, 'Baroda', 34.6866683959961, 0.605396570057592, -120.591667175293, -2.10472164267803, 218, 6, 'PPL', 'P'),
(75069, 'Baron', 35.9236106872559, 0.626985285697238, -94.6161117553711, -1.65136267556614, 218, 42, 'PPL', 'P'),
(179947, 'Barona', 32.9358291625977, 0.574838660761696, -116.867218017578, -2.03971774205278, 218, 6, 'PPL', 'P'),
(179948, 'Baronet Estates', 36.563060760498, 0.638145794877433, -121.753890991211, -2.12500627491089, 218, 6, 'PPL', 'P'),
(44604, 'Baronet Woods', 39.4261093139648, 0.688115418779889, -76.7444381713867, -1.33944312868391, 218, 25, 'PPL', 'P'),
(79666, 'Baronywood', 34.0519409179688, 0.594318485713135, -81.0519409179688, -1.41462323415047, 218, 48, 'PPL', 'P'),
(26450, 'Barr', 39.9619407653809, 0.697467441842839, -89.6969375610352, -1.56550688939584, 218, 18, 'PPL', 'P'),
(58555, 'Barr', 34.624439239502, 0.604310466386031, -89.7799987792969, -1.56695658113522, 218, 30, 'PPL', 'P'),
(75071, 'Barr', 36.2324981689453, 0.632376389270912, -98.033332824707, -1.71100443449457, 218, 42, 'PPL', 'P'),
(84828, 'Barr', 35.8822212219238, 0.626262903251554, -89.7311096191406, -1.56610330432196, 218, 50, 'PPL', 'P'),
(188109, 'Barr', 34.9775009155273, 0.610472555095283, -106.666938781738, -1.86168928476456, 218, 38, 'PPL', 'P'),
(195928, 'Barr (historical)', 48.7377815246582, 0.850634757722948, -107.053329467773, -1.86843307443492, 218, 31, 'PPL', 'P'),
(79667, 'Barr Crossing', 33.9394416809082, 0.592355003620447, -81.2930603027344, -1.41883156130501, 218, 48, 'PPL', 'P'),
(186385, 'Barr Lake', 39.9444389343262, 0.697161977265807, -104.774719238281, -1.82866382356065, 218, 7, 'PPL', 'P'),
(158936, 'Barr Slope', 40.7130584716797, 0.710576918887781, -79.01611328125, -1.37909133888663, 218, 45, 'PPL', 'P'),
(99642, 'Barracks', 38.0574989318848, 0.664228661435614, -78.5136108398438, -1.37032101678478, 218, 53, 'PPL', 'P'),
(108096, 'Barrackville', 39.5036087036133, 0.689468038297541, -80.1669387817383, -1.39917703298606, 218, 58, 'PPL', 'P'),
(34683, 'Barrallton', 38.038890838623, 0.663903888940679, -85.7988891601563, -1.4974731103984, 218, 21, 'PPL', 'P'),
(188111, 'Barranca', 36.2619400024414, 0.632890246203243, -105.867218017578, -1.8477315243334, 218, 38, 'PPL', 'P'),
(188112, 'Barranco', 35.3236083984375, 0.616513270237855, -105.41471862793, -1.83983392012077, 218, 38, 'PPL', 'P'),
(99643, 'Barranger', 37.2588882446289, 0.650290275501385, -80.0127792358398, -1.39648644133676, 218, 53, 'PPL', 'P'),
(124184, 'Barre', 42.422779083252, 0.740417172848928, -72.1055603027344, -1.25847943627803, 218, 23, 'PPL', 'P'),
(171713, 'Barre', 44.1969413757324, 0.771382146317443, -72.5025024414063, -1.26540738353777, 218, 55, 'PPL', 'P'),
(147015, 'Barre Center', 43.1861114501953, 0.753739835939131, -78.1944427490234, -1.36475048273267, 218, 40, 'PPL', 'P'),
(124185, 'Barre Falls', 42.4291687011719, 0.740528692719575, -72.0266723632813, -1.25710258199446, 218, 23, 'PPL', 'P'),
(173060, 'Barre Mills', 43.8413887023926, 0.765176581503395, -91.1138916015625, -1.59023740275248, 218, 57, 'PPL', 'P'),
(124186, 'Barre Plains', 42.3777809143066, 0.739631806643464, -72.1097183227539, -1.25855200741774, 218, 23, 'PPL', 'P'),
(158938, 'Barree', 40.5852813720703, 0.708346787790949, -78.100830078125, -1.3631166334039, 218, 45, 'PPL', 'P'),
(189920, 'Barrel Spring (historical)', 37.9552803039551, 0.66244460982137, -117.594436645508, -2.05241010149199, 218, 39, 'PPL', 'P'),
(114512, 'Barrell', 40.6980590820313, 0.710315130152626, -93.8672180175781, -1.63829201409408, 218, 16, 'PPL', 'P'),
(79668, 'Barrell Landing', 32.2949981689453, 0.563654049973636, -80.9308319091797, -1.41250948319327, 218, 48, 'PPL', 'P'),
(44605, 'Barrelville', 39.7016716003418, 0.692924887971491, -78.8427810668945, -1.37606612104636, 218, 25, 'PPL', 'P'),
(79669, 'Barrelville', 32.6861114501953, 0.570480264479727, -80.3511123657227, -1.40239146842179, 218, 48, 'PPL', 'P'),
(53340, 'Barren (historical)', 36.8280601501465, 0.642770906742573, -91.0141677856445, -1.58849689382205, 218, 29, 'PPL', 'P'),
(108097, 'Barren Creek', 38.480281829834, 0.671607615025951, -81.283332824707, -1.41866178478552, 218, 58, 'PPL', 'P'),
(158940, 'Barren Hill', 40.0872192382813, 0.699653963676821, -75.2633285522461, -1.31359288924695, 218, 45, 'PPL', 'P'),
(7276, 'Barren Hollow', 35.9452781677246, 0.627363454572029, -92.5536117553711, -1.61536525974375, 218, 4, 'PPL', 'P'),
(84829, 'Barren Plain', 36.601390838623, 0.638814780943261, -86.9194412231445, -1.51703043333756, 218, 50, 'PPL', 'P'),
(99644, 'Barren Ridge', 38.1624984741211, 0.666061249160725, -78.9502792358398, -1.37794231803432, 218, 53, 'PPL', 'P'),
(34685, 'Barren River', 37.0491714477539, 0.64663002689918, -86.5166702270508, -1.51000075332419, 218, 21, 'PPL', 'P'),
(99645, 'Barren Springs', 36.9080581665039, 0.644167135523075, -80.8008270263672, -1.41024046994453, 218, 53, 'PPL', 'P'),
(7280, 'Barrentine Corner', 35.0688896179199, 0.612067588851159, -91.9449996948242, -1.60474297541986, 218, 4, 'PPL', 'P'),
(92445, 'Barrera Colonia', 26.3929996490479, 0.460644743353593, -98.8990020751953, -1.72611321314886, 218, 51, 'PPL', 'P'),
(31739, 'Barret', 39.6708297729492, 0.692386596536158, -96.4499969482422, -1.68337001028531, 218, 20, 'PPL', 'P'),
(99646, 'Barrets Corner', 36.8125, 0.642499330890413, -76.2055587768555, -1.33003790897819, 218, 53, 'PPL', 'P'),
(149, 'Barrett', 37.8872184753418, 0.66125670681714, -81.670280456543, -1.42541529499385, 218, 58, 'PPL', 'P'),
(19067, 'Barrett', 34.336669921875, 0.599287944307223, -83.8161087036133, -1.46286706308753, 218, 13, 'PPL', 'P'),
(29155, 'Barrett', 38.2005615234375, 0.666725574694645, -87.8694381713867, -1.53361100796828, 218, 19, 'PPL', 'P'),
(39229, 'Barrett', 31.3669395446777, 0.547456371328637, -92.5133285522461, -1.61466218521597, 218, 22, 'PPL', 'P'),
(44607, 'Barrett', 39.4075012207031, 0.687790646284954, -77.0166702270508, -1.34419447438472, 218, 25, 'PPL', 'P'),
(62722, 'Barrett', 36.5272216796875, 0.6375202849164, -80.9683303833008, -1.41316395503116, 218, 33, 'PPL', 'P'),
(92446, 'Barrett', 29.8797206878662, 0.52149950557953, -95.0627822875977, -1.65915854702513, 218, 51, 'PPL', 'P'),
(112956, 'Barrett', 31.1919403076172, 0.544402058453453, -85.4208297729492, -1.49087472932356, 218, 2, 'PPL', 'P'),
(134099, 'Barrett', 45.9105606079102, 0.801290444044442, -95.8899993896484, -1.67359620908472, 218, 28, 'PPL', 'P'),
(143494, 'Barrett', 44.2580604553223, 0.772448875492074, -71.8291702270508, -1.25365551943752, 218, 36, 'PPL', 'P'),
(158941, 'Barrett', 41.0105590820313, 0.715769284065109, -78.3891677856445, -1.36814907575777, 218, 45, 'PPL', 'P'),
(179950, 'Barrett', 37.6399993896484, 0.656941919798021, -120.284721374512, -2.09936442782923, 218, 6, 'PPL', 'P'),
(31740, 'Barrett (historical)', 37.3333282470703, 0.65158949863918, -94.7777786254883, -1.65418429474108, 218, 20, 'PPL', 'P'),
(189921, 'Barrett (historical)', 39.0533294677734, 0.681609183078771, -117.424171447754, -2.04943841318962, 218, 39, 'PPL', 'P'),
(99647, 'Barrett Acres', 36.7200012207031, 0.640884922637607, -76.6408309936523, -1.33763484230375, 218, 53, 'PPL', 'P'),
(99648, 'Barrett Corner', 36.8833312988281, 0.643735570268427, -77.0422210693359, -1.34464042070926, 218, 53, 'PPL', 'P'),
(147017, 'Barrett Corners', 42.7186088562012, 0.745580376412319, -75.1733322143555, -1.31202215683602, 218, 40, 'PPL', 'P'),
(112955, 'Barrett Crossroads', 33.1952781677246, 0.579366900142185, -85.2938919067383, -1.48865924561273, 218, 2, 'PPL', 'P'),
(179951, 'Barrett Junction', 32.6113891601563, 0.569176114493915, -116.706390380859, -2.03691077026384, 218, 6, 'PPL', 'P'),
(199823, 'Barrett Springs (historical)', 41.0405616760254, 0.716292928114445, -117.914169311523, -2.05799048924014, 218, 39, 'PPL', 'P'),
(19068, 'Barretts', 31.0013904571533, 0.541076336173675, -83.1994400024414, -1.45210416385808, 218, 13, 'PPL', 'P'),
(53342, 'Barretts', 38.5716705322266, 0.673202648781827, -90.4599990844727, -1.5788248253751, 218, 29, 'PPL', 'P'),
(99649, 'Barretts', 37.5763893127441, 0.655831714518594, -76.4441680908203, -1.3342024271328, 218, 53, 'PPL', 'P'),
(126830, 'Barretts', 46.8974990844727, 0.818515769975074, -68.01611328125, -1.18710512116726, 218, 26, 'PPL', 'P'),
(195929, 'Barretts', 45.1313896179199, 0.787691344833088, -112.739723205566, -1.96767936772419, 218, 31, 'PPL', 'P'),
(62723, 'Barretts Crossroads', 36.4702796936035, 0.63652645977661, -77.0558319091797, -1.34487797467849, 218, 33, 'PPL', 'P'),
(19069, 'Barretts Mill', 34.0077781677246, 0.593547700314639, -83.3647232055664, -1.45498889995086, 218, 13, 'PPL', 'P'),
(71743, 'Barretts Mills', 39.2024993896484, 0.684212689360433, -83.3872222900391, -1.45538158305359, 218, 41, 'PPL', 'P'),
(7281, 'Barrettsville', 34.8597183227539, 0.608416861049851, -91.6694412231445, -1.59993357280729, 218, 4, 'PPL', 'P'),
(19070, 'Barrettsville', 34.3397216796875, 0.599341207529024, -84.1569366455078, -1.46881563285638, 218, 13, 'PPL', 'P'),
(84830, 'Barretville', 35.3736114501953, 0.617385988127074, -89.7633285522461, -1.56666563078613, 218, 50, 'PPL', 'P'),
(118723, 'Barreville', 42.2755584716797, 0.737847688450193, -88.2624969482422, -1.54047117777827, 218, 18, 'PPL', 'P'),
(154188, 'Barrick', 40.5327796936035, 0.70743046063888, -81.2525024414063, -1.41812369308727, 218, 41, 'PPL', 'P'),
(29156, 'Barrick Corner', 39.2561111450195, 0.685148391009432, -87.0733337402344, -1.51971636445496, 218, 19, 'PPL', 'P'),
(154189, 'Barrick Corners', 40.1908302307129, 0.701462316636012, -82.5508270263672, -1.44078373185443, 218, 41, 'PPL', 'P'),
(139642, 'Barrie', 46.5688896179199, 0.812780452830507, -97.1222229003906, -1.69510256646765, 218, 34, 'PPL', 'P'),
(34686, 'Barrier', 36.7688903808594, 0.641738199450868, -84.767219543457, -1.47946707879421, 218, 21, 'PPL', 'P'),
(62724, 'Barriers Mill', 35.3566703796387, 0.617090310667048, -80.4280624389648, -1.40373450055952, 218, 33, 'PPL', 'P'),
(79670, 'Barrineau Crossroads', 33.871940612793, 0.591176887733223, -79.9091720581055, -1.39467815495659, 218, 48, 'PPL', 'P'),
(15098, 'Barrineau Park', 30.6936092376709, 0.535704540517904, -87.4361114501953, -1.52604802994662, 218, 12, 'PPL', 'P'),
(7282, 'Barringer', 33.8480606079102, 0.590760103022626, -93.1338882446289, -1.62549299505322, 218, 4, 'PPL', 'P'),
(19072, 'Barrington', 33.5202789306641, 0.585039233526972, -84.0327835083008, -1.46664875183544, 218, 13, 'PPL', 'P'),
(44608, 'Barrington', 39.3547210693359, 0.686869458863896, -76.4683303833008, -1.33462413869142, 218, 25, 'PPL', 'P'),
(70500, 'Barrington', 39.8647193908691, 0.695770608754295, -75.0555572509766, -1.30996659594865, 218, 37, 'PPL', 'P'),
(118724, 'Barrington', 42.1538887023926, 0.735724150375991, -88.1361083984375, -1.53826528144736, 218, 18, 'PPL', 'P'),
(143495, 'Barrington', 43.2227783203125, 0.754379793549077, -71.0475006103516, -1.24001281096332, 218, 36, 'PPL', 'P'),
(147019, 'Barrington', 42.5469398498535, 0.742584187027926, -77.0563888549805, -1.34488769521647, 218, 40, 'PPL', 'P'),
(169271, 'Barrington', 41.7405586242676, 0.728510179615184, -71.3091735839844, -1.24457986591669, 218, 47, 'PPL', 'P'),
(118725, 'Barrington Center', 42.1105613708496, 0.734967945784463, -88.1941680908203, -1.53927861424214, 218, 18, 'PPL', 'P'),
(92447, 'Barrington Heights Colonia', 26.1730003356934, 0.45680503098343, -97.8270034790039, -1.70740330806857, 218, 51, 'PPL', 'P'),
(118727, 'Barrington Hills', 42.1686096191406, 0.735981078842156, -88.2574996948242, -1.54038395925257, 218, 18, 'PPL', 'P'),
(44609, 'Barrington Manor', 39.1175003051758, 0.682729175475204, -76.5388870239258, -1.33585558437947, 218, 25, 'PPL', 'P'),
(202978, 'Barrington Park', 40.6786117553711, 0.709975710271696, -111.924438476563, -1.95344996486184, 218, 52, 'PPL', 'P'),
(44610, 'Barrington Woods', 39.2202796936035, 0.684523014206454, -76.8091735839844, -1.34057297477638, 218, 25, 'PPL', 'P'),
(118728, 'Barrington Woods', 42.1522216796875, 0.735695055341081, -88.0558319091797, -1.53686419239787, 218, 18, 'PPL', 'P'),
(92448, 'Barrios Colonia', 25.9449996948242, 0.452825669103607, -97.4089965820313, -1.70010771142035, 218, 51, 'PPL', 'P'),
(92449, 'Barrios Number 2 Colonia', 26.2220001220703, 0.457660238588482, -98.1510009765625, -1.71305813116919, 218, 51, 'PPL', 'P'),
(99650, 'Barrister Estates', 37.3105583190918, 0.651192088425513, -80.0983276367188, -1.39797954260191, 218, 53, 'PPL', 'P'),
(158944, 'Barrisville', 40.7844390869141, 0.71182274564572, -80.2408294677734, -1.40046666874394, 218, 45, 'PPL', 'P'),
(179953, 'Barro', 38.5261116027832, 0.672407495459357, -122.491668701172, -2.13788292509754, 218, 6, 'PPL', 'P'),
(202977, 'Barro', 40.7269401550293, 0.710819199967951, -113.488059997559, -1.98074030865827, 218, 52, 'PPL', 'P'),
(39231, 'Barron', 31.336669921875, 0.546928066747393, -92.2494430541992, -1.61005651442679, 218, 22, 'PPL', 'P'),
(53343, 'Barron', 36.7713890075684, 0.641781808713718, -90.2630615234375, -1.57538761651419, 218, 29, 'PPL', 'P'),
(173062, 'Barron', 45.4013900756836, 0.792403741802956, -91.8488922119141, -1.60306558340728, 218, 57, 'PPL', 'P'),
(206768, 'Barron', 48.7533302307129, 0.850906133838027, -120.715278625488, -2.10687906947711, 218, 56, 'PPL', 'P'),
(200372, 'Barron (historical)', 42.1261100769043, 0.735239321899542, -122.610282897949, -2.13995313337091, 218, 43, 'PPL', 'P'),
(126831, 'Barron Corner', 44.8208312988281, 0.782271079645477, -69.8450012207031, -1.21902523736073, 218, 26, 'PPL', 'P'),
(58553, 'Barron Point', 31.1472206115723, 0.543621552516978, -89.165283203125, -1.55622777036773, 218, 30, 'PPL', 'P'),
(173066, 'Barronett', 45.6369400024414, 0.796514863577712, -91.9927825927734, -1.60557694431522, 218, 57, 'PPL', 'P'),
(112957, 'Barrons (historical)', 32.1286087036133, 0.560750005962959, -88.0027770996094, -1.53593821128685, 218, 2, 'PPL', 'P'),
(84831, 'Barrons Corner', 36.0699996948242, 0.629540255868033, -88.9352798461914, -1.5522134544986, 218, 50, 'PPL', 'P'),
(19073, 'Barrons Lane', 32.3666687011719, 0.564904936737646, -83.9963912963867, -1.46601358791546, 218, 13, 'PPL', 'P'),
(58554, 'Barrontown', 31.375280380249, 0.547601946371724, -89.2174987792969, -1.55713910409275, 218, 30, 'PPL', 'P'),
(77827, 'Barronvale', 39.9516716003418, 0.697288211101476, -79.2716674804688, -1.3835516010803, 218, 45, 'PPL', 'P'),
(26453, 'Barrow', 39.5061111450195, 0.689511714139418, -90.4013900756836, -1.5778019052004, 218, 18, 'PPL', 'P'),
(212294, 'Barrow', 71.2905578613281, 1.2442549602637, -156.788604736328, -2.7364773822569, 218, 1, 'PPL', 'P'),
(19075, 'Barrow Heights', 33.9916687011719, 0.593266537082554, -83.7444381713867, -1.46161617632352, 218, 13, 'PPL', 'P'),
(134101, 'Barrows', 46.3011093139648, 0.808106804854499, -94.2536087036133, -1.64503580376444, 218, 28, 'PPL', 'P'),
(99651, 'Barrows Store', 36.9347190856934, 0.644632456344539, -77.9791717529297, -1.36099329506678, 218, 53, 'PPL', 'P'),
(124188, 'Barrowsville', 41.9458312988281, 0.73209286365064, -71.2041702270508, -1.24274721161255, 218, 23, 'PPL', 'P'),
(39232, 'Barroza (historical)', 30.5055599212646, 0.53242246079049, -91.2938919067383, -1.59337900073239, 218, 22, 'PPL', 'P'),
(108098, 'Barrs', 38.8230590820313, 0.677590206677733, -81.3808288574219, -1.42036341156403, 218, 58, 'PPL', 'P'),
(158943, 'Barrs Corners', 41.2786102294922, 0.720447659152051, -79.7197189331055, -1.39137157414715, 218, 45, 'PPL', 'P'),
(58556, 'Barrs Mill', 33.7972183227539, 0.589872737747411, -88.852783203125, -1.55077361645524, 218, 30, 'PPL', 'P'),
(154190, 'Barrs Mills', 40.5486106872559, 0.707706763601975, -81.6236114501953, -1.42460076717445, 218, 41, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(71744, 'Barrsville', 39.1236114501953, 0.682835835076862, -84.5519409179688, -1.47570975797027, 218, 41, 'PPL', 'P'),
(158946, 'Barrville', 40.6630592346191, 0.709704267577589, -77.6769409179688, -1.35571837189566, 218, 45, 'PPL', 'P'),
(26454, 'Barry', 39.6941719055176, 0.692793993603913, -91.0388870239258, -1.58892832591865, 218, 18, 'PPL', 'P'),
(53344, 'Barry', 39.2463912963867, 0.684978747647994, -94.6005630493164, -1.65109129945106, 218, 29, 'PPL', 'P'),
(92450, 'Barry', 32.0991706848145, 0.560236215609655, -96.6358337402344, -1.68661347417692, 218, 51, 'PPL', 'P'),
(134102, 'Barry', 45.5580596923828, 0.795138142452195, -96.5588912963867, -1.68527057519724, 218, 28, 'PPL', 'P'),
(173068, 'Barry Corner', 44.5180587768555, 0.776986702252488, -92.179443359375, -1.60883478927672, 218, 57, 'PPL', 'P'),
(13034, 'Barry Farms', 38.8563919067383, 0.67817197421786, -76.9916687011719, -1.34375811544012, 218, 9, 'PPL', 'P'),
(112958, 'Barry Village', 30.9986095428467, 0.541027800062809, -88.0269393920898, -1.53635992284546, 218, 2, 'PPL', 'P'),
(194556, 'Barrymore', 42.6808280944824, 0.744920977726416, -114.462219238281, -1.9977425948476, 218, 17, 'PPL', 'P'),
(129677, 'Barryton', 43.752498626709, 0.763625157010369, -85.1469421386719, -1.48609448832493, 218, 27, 'PPL', 'P'),
(112954, 'Barrytown', 31.8372192382813, 0.555664300387289, -88.2527770996094, -1.54030153441684, 218, 2, 'PPL', 'P'),
(147022, 'Barrytown', 41.9983291625977, 0.733009124223682, -73.9244384765625, -1.290224849104, 218, 40, 'PPL', 'P'),
(53346, 'Barryville', 39.667781829834, 0.692333399893384, -92.6619415283203, -1.61725597095966, 218, 29, 'PPL', 'P'),
(147021, 'Barryville', 41.4775009155273, 0.723918956474915, -74.9113922119141, -1.30745044135074, 218, 40, 'PPL', 'P'),
(39233, 'Barso', 32.7447204589844, 0.571503184654426, -93.7275009155273, -1.63585349064195, 218, 22, 'PPL', 'P'),
(7283, 'Barson', 35.1513900756836, 0.613507493473538, -91.0730590820313, -1.58952474084477, 218, 4, 'PPL', 'P'),
(44611, 'Barstow', 38.5252799987793, 0.672392981231416, -76.6163864135742, -1.33720820389712, 218, 25, 'PPL', 'P'),
(118730, 'Barstow', 41.5183296203613, 0.724631551803593, -90.3569412231445, -1.57702612637486, 218, 18, 'PPL', 'P'),
(179955, 'Barstow', 34.898609161377, 0.609095634232685, -117.021942138672, -2.04241818739812, 218, 6, 'PPL', 'P'),
(191110, 'Barstow', 31.461109161377, 0.54909994119538, -103.393333435059, -1.80455409305411, 218, 51, 'PPL', 'P'),
(206769, 'Barstow', 48.7772216796875, 0.851323118285706, -118.141670227051, -2.06196112926739, 218, 56, 'PPL', 'P'),
(179956, 'Barstow Heights', 34.8697204589844, 0.608591431259306, -117.055282592773, -2.0430000880963, 218, 6, 'PPL', 'P'),
(179957, 'Barsug', 34.9575004577637, 0.610123481255401, -120.571937561035, -2.10437729594909, 218, 6, 'PPL', 'P'),
(79671, 'Bartell Crossroads', 33.7591705322266, 0.5892086785296, -79.57861328125, -1.3889088159291, 218, 48, 'PPL', 'P'),
(26456, 'Bartelso', 38.5363883972168, 0.672586859358773, -89.4663925170898, -1.56148311930484, 218, 18, 'PPL', 'P'),
(99653, 'Barterbrook', 38.0658302307129, 0.664374070031133, -78.4986114501953, -1.37005922804963, 218, 53, 'PPL', 'P'),
(34687, 'Barterville', 38.3788909912109, 0.669838011060621, -84.0688934326172, -1.46727898890741, 218, 21, 'PPL', 'P'),
(15099, 'Barth', 30.7613906860352, 0.536887549963631, -87.3302764892578, -1.52420086141454, 218, 12, 'PPL', 'P'),
(58557, 'Barth', 30.6722202301025, 0.535331231912102, -89.3644409179688, -1.5597037282225, 218, 30, 'PPL', 'P'),
(199824, 'Barth', 40.5816688537598, 0.708283737452141, -116.268333435059, -2.02926523424838, 218, 39, 'PPL', 'P'),
(84835, 'Barthelia', 36.3450012207031, 0.634339937942628, -86.2561111450195, -1.50545313944677, 218, 50, 'PPL', 'P'),
(34688, 'Barthell', 36.6863899230957, 0.640298294828489, -84.5252838134766, -1.47524450372783, 218, 21, 'PPL', 'P'),
(92451, 'Bartholomew Crossing', 33.0522193908691, 0.576870053462181, -99.3263931274414, -1.73357259420412, 218, 51, 'PPL', 'P'),
(44612, 'Bartholows', 39.3738899230957, 0.687204018475837, -77.2322235107422, -1.34795658889863, 218, 25, 'PPL', 'P'),
(29157, 'Bartle', 38.5602798461914, 0.673003843806453, -85.8874969482422, -1.49901960804341, 218, 19, 'PPL', 'P'),
(193359, 'Bartle', 41.2577781677246, 0.720084071084228, -121.819999694824, -2.12616008945317, 218, 6, 'PPL', 'P'),
(84832, 'Bartlebaugh', 35.1163902282715, 0.612896630898501, -85.1669387817383, -1.48644349558578, 218, 50, 'PPL', 'P'),
(84833, 'Bartlebaugh Subdivision', 35.1263885498047, 0.613071134528928, -85.1661071777344, -1.48642898135784, 218, 50, 'PPL', 'P'),
(71745, 'Bartles', 38.6616706848145, 0.674773447771783, -82.6600036621094, -1.44268922361438, 218, 41, 'PPL', 'P'),
(144791, 'Bartles Corners', 40.5366706848145, 0.707498371246677, -74.857780456543, -1.30651473970174, 218, 37, 'PPL', 'P'),
(75073, 'Bartlesville', 36.7472190856934, 0.641359963997049, -95.9805603027344, -1.67517679519168, 218, 42, 'PPL', 'P'),
(19076, 'Bartlett', 32.3355598449707, 0.564361984770406, -84.1152801513672, -1.46808858987879, 218, 13, 'PPL', 'P'),
(31741, 'Bartlett', 37.0547218322754, 0.646726899383832, -95.210563659668, -1.66173781854087, 218, 20, 'PPL', 'P'),
(53347, 'Bartlett', 37.0047187805176, 0.645854181494613, -91.4141693115234, -1.59547823746164, 218, 29, 'PPL', 'P'),
(58558, 'Bartlett', 32.2583312988281, 0.56301409236369, -89.3166732788086, -1.55887002564325, 218, 30, 'PPL', 'P'),
(62727, 'Bartlett', 36.2891693115234, 0.633365487299768, -76.084716796875, -1.3279288185529, 218, 33, 'PPL', 'P'),
(71746, 'Bartlett', 39.4194412231445, 0.687999038640253, -81.8158264160156, -1.42795555119962, 218, 41, 'PPL', 'P'),
(84834, 'Bartlett', 35.2044410705566, 0.614433408005531, -89.873893737793, -1.568595357312, 218, 50, 'PPL', 'P'),
(92452, 'Bartlett', 30.7947196960449, 0.537469250924731, -97.4252777099609, -1.70039187070866, 218, 51, 'PPL', 'P'),
(114513, 'Bartlett', 40.8849983215332, 0.71357783538311, -95.7947235107422, -1.67193333130007, 218, 16, 'PPL', 'P'),
(118731, 'Bartlett', 41.9949989318848, 0.732951000732891, -88.1855621337891, -1.53912841195666, 218, 18, 'PPL', 'P'),
(134106, 'Bartlett', 46.9124984741211, 0.818777558710229, -92.3411102294922, -1.61165640845166, 218, 28, 'PPL', 'P'),
(139644, 'Bartlett', 48.0447196960449, 0.838538546893753, -98.4319381713867, -1.71796141021018, 218, 34, 'PPL', 'P'),
(141236, 'Bartlett', 41.8852806091309, 0.73103605475107, -98.5519409179688, -1.72005585324948, 218, 35, 'PPL', 'P'),
(143497, 'Bartlett', 44.0780601501465, 0.769307277512162, -71.283332824707, -1.24412885958609, 218, 36, 'PPL', 'P'),
(147023, 'Bartlett', 43.1344413757324, 0.752838023015003, -75.4422225952148, -1.31671517930896, 218, 40, 'PPL', 'P'),
(177478, 'Bartlett', 41.4216690063477, 0.722944505832055, -72.1036071777344, -1.25844534781608, 218, 8, 'PPL', 'P'),
(179958, 'Bartlett', 36.4766693115234, 0.636637979647257, -118.029998779297, -2.06001209482362, 218, 6, 'PPL', 'P'),
(186386, 'Bartlett', 37.4333305358887, 0.653334867838591, -102.143608093262, -1.78274227109414, 218, 7, 'PPL', 'P'),
(200373, 'Bartlett', 45.9847183227539, 0.80258474033422, -117.457221984863, -2.05001525388173, 218, 43, 'PPL', 'P'),
(112960, 'Bartlett (historical)', 34.1877784729004, 0.596689298294551, -86.2577819824219, -1.5054823010607, 218, 2, 'PPL', 'P'),
(147024, 'Bartlett Corners', 43.3102798461914, 0.755906983276183, -77.7947235107422, -1.35777406594109, 218, 40, 'PPL', 'P'),
(209937, 'Bartlett Cove', 58.4500007629395, 1.02014496110649, -135.91667175293, -2.372193430441, 218, 1, 'PPL', 'P'),
(44613, 'Bartlett Heights', 39.4583282470703, 0.68867774524406, -77.4161071777344, -1.35116596432828, 218, 25, 'PPL', 'P'),
(147025, 'Bartlett Hollow', 42.3197212219238, 0.738618473848689, -75.1822204589844, -1.31217728596952, 218, 40, 'PPL', 'P'),
(126832, 'Bartlett Mills', 43.3994407653809, 0.757463134880144, -70.5297164916992, -1.2309757732783, 218, 26, 'PPL', 'P'),
(179959, 'Bartlett Springs', 39.1838912963867, 0.683887916865498, -122.703330993652, -2.14157712900364, 218, 6, 'PPL', 'P'),
(147026, 'Bartletts Corner', 44.2599983215332, 0.772482697637918, -75.7249984741211, -1.3216505494411, 218, 40, 'PPL', 'P'),
(29162, 'Bartlettsville', 38.9702796936035, 0.680159691076468, -86.4419403076172, -1.50869647018032, 218, 19, 'PPL', 'P'),
(108100, 'Bartley', 37.3405609130859, 0.65171573247485, -81.7377777099609, -1.42659334430205, 218, 58, 'PPL', 'P'),
(144792, 'Bartley', 40.8224983215332, 0.712487004600613, -74.7186126708984, -1.30408580362953, 218, 37, 'PPL', 'P'),
(199161, 'Bartley', 40.2491683959961, 0.702480509699777, -100.311668395996, -1.75076889167887, 218, 35, 'PPL', 'P'),
(19077, 'Bartley Road Estates', 32.9805603027344, 0.575619366435253, -85.0013885498047, -1.4835540989611, 218, 13, 'PPL', 'P'),
(92454, 'Bartley Woods', 33.4888916015625, 0.584491421290743, -96.0269393920898, -1.67598626300501, 218, 51, 'PPL', 'P'),
(99654, 'Bartlick', 37.246940612793, 0.650081749988032, -82.3247222900391, -1.43683745975115, 218, 53, 'PPL', 'P'),
(58559, 'Barto', 31.1755599975586, 0.544116168110433, -90.311393737793, -1.57623117278948, 218, 30, 'PPL', 'P'),
(158947, 'Barto', 40.3911094665527, 0.704957848724796, -75.6105575561523, -1.31965317862354, 218, 45, 'PPL', 'P'),
(179960, 'Bartolo', 34.0063896179199, 0.593523465548719, -118.061393737793, -2.0605600402179, 218, 6, 'PPL', 'P'),
(179961, 'Bartolo (historical)', 34.0194396972656, 0.593751232400948, -118.043060302734, -2.06024006141293, 218, 6, 'PPL', 'P'),
(7286, 'Barton', 34.5475006103516, 0.602967633985385, -90.7680587768555, -1.58420148129987, 218, 4, 'PPL', 'P'),
(31742, 'Barton', 38.9938888549805, 0.680571748676131, -98.0772171020508, -1.71177035962408, 218, 20, 'PPL', 'P'),
(39234, 'Barton', 30.086109161377, 0.525101663980458, -91.054443359375, -1.58919983519178, 218, 22, 'PPL', 'P'),
(44614, 'Barton', 39.5305595397949, 0.689938419125076, -79.0177764892578, -1.37912036734251, 218, 25, 'PPL', 'P'),
(58561, 'Barton', 34.9638900756836, 0.610235001126048, -89.6891708374023, -1.56537133449635, 218, 30, 'PPL', 'P'),
(79672, 'Barton', 32.9222183227539, 0.574601106792461, -81.2866668701172, -1.41871997485534, 218, 48, 'PPL', 'P'),
(92453, 'Barton', 30.9197196960449, 0.539650912489724, -96.7113876342773, -1.68793213839067, 218, 51, 'PPL', 'P'),
(112959, 'Barton', 34.7386093139648, 0.606303110092655, -87.89111328125, -1.53398931000113, 218, 2, 'PPL', 'P'),
(147027, 'Barton', 42.042781829834, 0.733784969628249, -76.4488906860352, -1.33428485196854, 218, 40, 'PPL', 'P'),
(154192, 'Barton', 40.1072196960449, 0.700003037516703, -80.8413925170898, -1.41094847132032, 218, 41, 'PPL', 'P'),
(158949, 'Barton', 40.7924995422363, 0.711963427130304, -79.0541687011719, -1.3797555312625, 218, 45, 'PPL', 'P'),
(171716, 'Barton', 44.7480583190918, 0.781000951542591, -72.1766662597656, -1.25972046934601, 218, 55, 'PPL', 'P'),
(173070, 'Barton', 43.4436111450195, 0.758234053436695, -88.1805572509766, -1.5390410602729, 218, 57, 'PPL', 'P'),
(179962, 'Barton', 38.454719543457, 0.671161468964336, -120.529167175293, -2.10363081189554, 218, 6, 'PPL', 'P'),
(188114, 'Barton', 35.0830612182617, 0.6123149299374, -106.246391296387, -1.85434934648419, 218, 38, 'PPL', 'P'),
(194557, 'Barton', 44.3844413757324, 0.774654638664932, -116.798889160156, -2.03852517851664, 218, 17, 'PPL', 'P'),
(197976, 'Barton', 48.5069389343262, 0.846605794467821, -100.175827026367, -1.74839801251843, 218, 34, 'PPL', 'P'),
(199162, 'Barton', 41.0338897705078, 0.716176481395782, -102.173889160156, -1.78327077541247, 218, 35, 'PPL', 'P'),
(200374, 'Barton', 45.3891716003418, 0.792190489178668, -122.405830383301, -2.13638476382631, 218, 43, 'PPL', 'P'),
(202985, 'Barton', 41.1599998474121, 0.718377517457705, -112.063888549805, -1.95588382778207, 218, 52, 'PPL', 'P'),
(108101, 'Barton (historical)', 38.5186080932617, 0.672276534512752, -81.170280456543, -1.41668864873388, 218, 58, 'PPL', 'P'),
(129679, 'Barton City', 44.6841697692871, 0.779885885994175, -83.6055603027344, -1.45919230025738, 218, 27, 'PPL', 'P'),
(191111, 'Barton Corners', 36.2019309997559, 0.631842891525542, -100.457809448242, -1.75331953421289, 218, 51, 'PPL', 'P'),
(92455, 'Barton Creek', 30.2849998474121, 0.528572961303322, -97.8688888549805, -1.70813434578779, 218, 51, 'PPL', 'P'),
(99655, 'Barton Crossroad', 36.6572189331055, 0.639789165007093, -81.3522186279297, -1.41986406885964, 218, 53, 'PPL', 'P'),
(158948, 'Barton Glen', 41.0055618286133, 0.715682065539409, -75.2980575561523, -1.31419902471105, 218, 45, 'PPL', 'P'),
(129680, 'Barton Hills', 42.3219413757324, 0.738657222842549, -83.7688903808594, -1.4620429478882, 218, 27, 'PPL', 'P'),
(84837, 'Barton Mill', 35.5191688537598, 0.619926444069928, -84.6094436645508, -1.47671337022707, 218, 50, 'PPL', 'P'),
(84836, 'Barton Springs', 36.2363891601563, 0.632444299878709, -83.2352828979492, -1.45272974039814, 218, 50, 'PPL', 'P'),
(19078, 'Barton Village', 33.4347190856934, 0.583545932524737, -82.0933303833008, -1.4327989091161, 218, 13, 'PPL', 'P'),
(44615, 'Barton Woods', 39.2088890075684, 0.68432420923108, -77.2133331298828, -1.34762688955567, 218, 25, 'PPL', 'P'),
(122193, 'Bartonia', 40.1152801513672, 0.700143719001287, -84.8511123657227, -1.48093128476154, 218, 19, 'PPL', 'P'),
(92456, 'Bartons Chapel', 33.0644416809082, 0.577083372665496, -98.2361068725586, -1.71454350926718, 218, 51, 'PPL', 'P'),
(169273, 'Bartons Corner', 41.6627807617188, 0.727152699828543, -71.4983291625977, -1.24788125356201, 218, 47, 'PPL', 'P'),
(29160, 'Bartons Location', 38.5291709899902, 0.672460891839213, -87.3394393920898, -1.524360784238, 218, 19, 'PPL', 'P'),
(44616, 'Bartonsville', 39.3925018310547, 0.687528857549799, -77.3583297729492, -1.35015755838152, 218, 25, 'PPL', 'P'),
(62729, 'Bartonsville', 36.4749984741211, 0.636608818033321, -76.9588928222656, -1.34318606843797, 218, 33, 'PPL', 'P'),
(99656, 'Bartonsville', 39.1113891601563, 0.682622515873546, -78.2122192382813, -1.36506074099966, 218, 53, 'PPL', 'P'),
(158951, 'Bartonsville', 41.0050010681152, 0.715672278422402, -75.2799987792969, -1.31388383959604, 218, 45, 'PPL', 'P'),
(171718, 'Bartonsville', 43.2255592346191, 0.754428329659944, -72.5361099243164, -1.26599394476786, 218, 55, 'PPL', 'P'),
(92457, 'Bartonville', 33.0730590820313, 0.577233774688059, -97.1313934326172, -1.69526262244917, 218, 51, 'PPL', 'P'),
(112962, 'Bartonville', 33.5747184753418, 0.585989382824885, -86.7805633544922, -1.51460655727142, 218, 2, 'PPL', 'P'),
(118732, 'Bartonville', 40.6502799987793, 0.709481227836295, -89.6519393920898, -1.56472152319037, 218, 18, 'PPL', 'P'),
(15101, 'Bartow', 27.896110534668, 0.486878977330232, -81.8433303833008, -1.42843558598611, 218, 12, 'PPL', 'P'),
(19080, 'Bartow', 32.8786087036133, 0.573839975352916, -82.4738922119141, -1.43944096603281, 218, 13, 'PPL', 'P'),
(108102, 'Bartow', 38.5411109924316, 0.672669284194511, -79.7844390869141, -1.39250115392351, 218, 58, 'PPL', 'P'),
(108103, 'Bartram (historical)', 38.2627792358398, 0.667811478629125, -82.3208312988281, -1.43676954914335, 218, 58, 'PPL', 'P'),
(71747, 'Bartramville', 38.4925003051758, 0.67182086765024, -82.3847198486328, -1.43788461469177, 218, 41, 'PPL', 'P'),
(77829, 'Bartville', 39.8911094665527, 0.696231202464824, -76.0686111450195, -1.32764772189984, 218, 45, 'PPL', 'P'),
(200376, 'Barview', 45.5699996948242, 0.795346534807494, -123.942222595215, -2.16319986652621, 218, 43, 'PPL', 'P'),
(15102, 'Barwal', 26.3086109161377, 0.459171882112725, -80.0899963378906, -1.39783413400639, 218, 12, 'PPL', 'P'),
(19082, 'Barwick', 30.8899993896484, 0.539132195288404, -83.7408294677734, -1.46155319256374, 218, 13, 'PPL', 'P'),
(34689, 'Barwick', 37.3666687011719, 0.652171399337362, -83.3663864135742, -1.45501792840674, 218, 21, 'PPL', 'P'),
(53351, 'Barwick', 39.7136116027832, 0.693133280326789, -94.1230621337891, -1.64275733629382, 218, 29, 'PPL', 'P'),
(191112, 'Barwise', 33.9972190856934, 0.593363409567205, -101.526107788086, -1.77196485763676, 218, 51, 'PPL', 'P'),
(880, 'Barwood', 39.9977798461914, 0.698092951803871, -76.6733322143555, -1.33820209561594, 218, 45, 'PPL', 'P'),
(801, 'Barwyn Acres', 39.2272186279297, 0.684644121457025, -84.3727798461914, -1.47258280737635, 218, 41, 'PPL', 'P'),
(99659, 'Barytes', 36.621940612793, 0.639173442163067, -82.1575012207031, -1.43391890151253, 218, 53, 'PPL', 'P'),
(53352, 'Baryties', 38.061939239502, 0.664306159423336, -90.658332824707, -1.58228640215999, 218, 29, 'PPL', 'P'),
(186387, 'Basalt', 39.3688888549805, 0.68711673337111, -107.032218933105, -1.8680646260981, 218, 7, 'PPL', 'P'),
(189922, 'Basalt', 38.0074996948242, 0.663356010125423, -118.272216796875, -2.06423959673801, 218, 39, 'PPL', 'P'),
(194558, 'Basalt', 43.315559387207, 0.7559991286499, -112.163612365723, -1.95762433671249, 218, 17, 'PPL', 'P'),
(118733, 'Basco', 40.3277816772461, 0.703852570293386, -91.1999969482422, -1.59174022455561, 218, 18, 'PPL', 'P'),
(173072, 'Basco', 42.9119415283203, 0.748954668092477, -89.5147171020508, -1.56232654242206, 218, 57, 'PPL', 'P'),
(15103, 'Bascom', 30.9277801513672, 0.539791593974308, -85.1186065673828, -1.4855999393105, 218, 12, 'PPL', 'P'),
(19083, 'Bascom', 32.8402786254883, 0.573170989287088, -81.668327331543, -1.4253812065319, 218, 13, 'PPL', 'P'),
(34690, 'Bascom', 38.0400009155273, 0.66392326343761, -83.1613922119141, -1.45144010464027, 218, 21, 'PPL', 'P'),
(92458, 'Bascom', 32.3227806091309, 0.564138945029112, -95.2172164916992, -1.6618539323644, 218, 51, 'PPL', 'P'),
(154194, 'Bascom', 41.1327781677246, 0.717902409519235, -83.2852783203125, -1.45360232512931, 218, 41, 'PPL', 'P'),
(195930, 'Bascom', 46.6261100769043, 0.813779138239286, -107.752777099609, -1.88064073855573, 218, 31, 'PPL', 'P'),
(29161, 'Bascom Corner', 38.9088897705078, 0.679088234790902, -84.9686126708984, -1.48298205195895, 218, 19, 'PPL', 'P'),
(19084, 'Bascombs Springs', 34.0933303833008, 0.595040868158819, -84.5472183227539, -1.47562733313453, 218, 13, 'PPL', 'P'),
(79673, 'Bascomville', 34.6988906860352, 0.605609889260908, -80.9766693115234, -1.41330949678473, 218, 48, 'PPL', 'P'),
(7288, 'Base Line', 34.6680603027344, 0.605071797562657, -92.3177795410156, -1.61124921112098, 218, 4, 'PPL', 'P'),
(31744, 'Basehor', 39.1416702270508, 0.683151020191873, -94.9383316040039, -1.65698647284006, 218, 20, 'PPL', 'P'),
(39235, 'Basel (historical)', 30.7369403839111, 0.536460811688459, -91.3452835083008, -1.59427595338753, 218, 22, 'PPL', 'P'),
(195931, 'Baseline', 45.7838897705078, 0.799079620865512, -108.702499389648, -1.89721651949649, 218, 31, 'PPL', 'P'),
(141238, 'Basford (historical)', 42.0041694641113, 0.733111056714405, -96.3652801513672, -1.6818914232481, 218, 35, 'PPL', 'P'),
(158950, 'Basforth Acres', 40.3438911437988, 0.704133733525471, -79.5763931274414, -1.38887006693524, 218, 45, 'PPL', 'P'),
(188116, 'Basgal Place', 35.3663902282715, 0.617259954028486, -108.472778320313, -1.89320713047538, 218, 38, 'PPL', 'P'),
(99657, 'Basham', 37.0361099243164, 0.646402060309869, -80.3427810668945, -1.40224605982627, 218, 53, 'PPL', 'P'),
(112195, 'Basham', 34.514720916748, 0.602395520404209, -87.0180587768555, -1.51875163435008, 218, 2, 'PPL', 'P'),
(92459, 'Basham Colonia (M and B)', 26.2660007476807, 0.45842819437832, -98.3430023193359, -1.71640918676883, 218, 51, 'PPL', 'P'),
(92460, 'Basham Number 1 Colonia', 26.2609996795654, 0.458340909273593, -98.3550033569336, -1.71661864438857, 218, 51, 'PPL', 'P'),
(92477, 'Basham Number 10 Colonia', 26.2630004882813, 0.458375829973386, -98.3369979858398, -1.71630439137994, 218, 51, 'PPL', 'P'),
(92461, 'Basham Number 11 Colonia', 26.2530002593994, 0.458201293053445, -98.3610000610352, -1.71672330661941, 218, 51, 'PPL', 'P'),
(92462, 'Basham Number 12 Colonia', 26.2689990997314, 0.45848052549374, -98.3820037841797, -1.71708989074346, 218, 51, 'PPL', 'P'),
(92463, 'Basham Number 13 Colonia', 26.2730007171631, 0.458550366893327, -98.3809967041016, -1.71707231388026, 218, 51, 'PPL', 'P'),
(92464, 'Basham Number 14 Colonia', 26.3199996948242, 0.459370653798585, -98.2770004272461, -1.71525723643932, 218, 51, 'PPL', 'P'),
(92465, 'Basham Number 15 Colonia', 26.2409992218018, 0.45799183543371, -98.3629989624023, -1.71675819402969, 218, 51, 'PPL', 'P'),
(92466, 'Basham Number 16 Colonia', 26.2719993591309, 0.458532889898674, -98.3820037841797, -1.71708989074346, 218, 51, 'PPL', 'P'),
(92467, 'Basham Number 18 Colonia', 26.2430000305176, 0.458026756133504, -98.3669967651367, -1.71682796885025, 218, 51, 'PPL', 'P'),
(92468, 'Basham Number 19 Colonia', 26.226110458374, 0.457731977490346, -98.3755569458008, -1.7169773721874, 218, 51, 'PPL', 'P'),
(92469, 'Basham Number 2 Colonia', 26.2600002288818, 0.458323465568453, -98.3410034179688, -1.71637429935855, 218, 51, 'PPL', 'P'),
(92470, 'Basham Number 3 Colonia', 26.3540000915527, 0.459964072668482, -98.3519973754883, -1.71656618011509, 218, 51, 'PPL', 'P'),
(92471, 'Basham Number 4 Colonia', 26.2770004272461, 0.458620175003401, -98.3610000610352, -1.71672330661941, 218, 51, 'PPL', 'P'),
(92472, 'Basham Number 5 Colonia', 26.2830009460449, 0.458724903813268, -98.3550033569336, -1.71661864438857, 218, 51, 'PPL', 'P'),
(92473, 'Basham Number 6 Colonia', 26.2549991607666, 0.458236180463725, -98.3420028686523, -1.71639174306369, 218, 51, 'PPL', 'P'),
(92474, 'Basham Number 7 Colonia', 26.2520008087158, 0.458183849348305, -98.3420028686523, -1.71639174306369, 218, 51, 'PPL', 'P'),
(92475, 'Basham Number 8 Colonia', 26.2830009460449, 0.458724903813268, -98.3600006103516, -1.71670586291427, 218, 51, 'PPL', 'P'),
(92476, 'Basham Number 9 Colonia', 26.3279991149902, 0.459510270018733, -98.3440017700195, -1.71642663047397, 218, 51, 'PPL', 'P'),
(71748, 'Bashan', 39.0433311462402, 0.681434679448344, -81.8652801513672, -1.42881868170892, 218, 41, 'PPL', 'P'),
(79674, 'Bashan', 32.5513916015625, 0.568128959553296, -80.9463882446289, -1.41278099246641, 218, 48, 'PPL', 'P'),
(177479, 'Bashan', 41.5130615234375, 0.724539606166958, -72.4338912963867, -1.26420989315361, 218, 8, 'PPL', 'P'),
(173073, 'Bashaw', 45.7691688537598, 0.798822692399347, -92.0630569458008, -1.60680346315526, 218, 57, 'PPL', 'P'),
(7289, 'Bashe', 35.3125, 0.616319392110498, -94.4341735839844, -1.64818725544038, 218, 4, 'PPL', 'P'),
(645, 'Basher', 36.9966697692871, 0.645713699747111, -92.605827331543, -1.61627659346878, 218, 29, 'PPL', 'P'),
(112963, 'Bashi', 31.9711093902588, 0.558001124375293, -87.8613891601563, -1.53347052622078, 218, 2, 'PPL', 'P'),
(112430, 'Basic', 32.2183303833008, 0.562315944683925, -88.769172668457, -1.54931433733594, 218, 30, 'PPL', 'P'),
(189923, 'Basic', 38.871940612793, 0.67844335033294, -117.899169921875, -2.05772870050498, 218, 39, 'PPL', 'P'),
(31745, 'Basil', 37.5163917541504, 0.654784559577975, -98.0899963378906, -1.71199339936537, 218, 20, 'PPL', 'P'),
(39236, 'Basile', 30.4850006103516, 0.532063633123116, -92.595832824707, -1.61610215641738, 218, 22, 'PPL', 'P'),
(108107, 'Basin', 37.5366706848145, 0.655138493686847, -81.2897186279297, -1.41877323807714, 218, 58, 'PPL', 'P'),
(112964, 'Basin', 31.3413906097412, 0.547010458293617, -86.1308288574219, -1.50326655103376, 218, 2, 'PPL', 'P'),
(179963, 'Basin', 35.0430603027344, 0.611616782257636, -116.294166564941, -2.02971610742093, 218, 6, 'PPL', 'P'),
(186388, 'Basin', 38.0658302307129, 0.664374070031133, -108.536109924316, -1.89431247548581, 218, 7, 'PPL', 'P'),
(194559, 'Basin', 42.2455596923828, 0.737324110979883, -113.78360748291, -1.98589858537364, 218, 17, 'PPL', 'P'),
(195932, 'Basin', 46.2713890075684, 0.807588087653179, -112.26277923584, -1.95935512510493, 218, 31, 'PPL', 'P'),
(209293, 'Basin', 44.3800010681152, 0.774577140677211, -108.038330078125, -1.8856245782197, 218, 59, 'PPL', 'P'),
(206770, 'Basin City', 46.5941696166992, 0.813221672044106, -119.151107788086, -2.07957913830076, 218, 56, 'PPL', 'P'),
(13325, 'Basin Corner', 39.6805610656738, 0.692556439634678, -75.5902786254883, -1.31929924451466, 218, 10, 'PPL', 'P'),
(191113, 'Basin Junction', 29.3341693878174, 0.511977839155143, -103.25611114502, -1.8021591122858, 218, 51, 'PPL', 'P'),
(126833, 'Basin Mills', 44.874439239502, 0.783206714715449, -68.6669387817383, -1.19846416900672, 218, 26, 'PPL', 'P'),
(34691, 'Basin Spring', 37.8419418334961, 0.660466480342687, -86.3066711425781, -1.50633557787396, 218, 21, 'PPL', 'P'),
(92478, 'Basin Springs', 33.7266693115234, 0.588641425217413, -96.836669921875, -1.69011872680368, 218, 51, 'PPL', 'P'),
(15104, 'Basinger', 27.3999996185303, 0.478220208388544, -81.0166702270508, -1.4140076444645, 218, 12, 'PPL', 'P'),
(99660, 'Baskerville', 36.6888885498047, 0.640341904091339, -78.2750015258789, -1.36615649863017, 218, 53, 'PPL', 'P'),
(99661, 'Baskerville Mill', 36.9755592346191, 0.645345251410299, -77.7697219848633, -1.35733770699648, 218, 53, 'PPL', 'P'),
(147029, 'Basket', 41.8488883972168, 0.730400890831086, -75.1102828979492, -1.3109217386736, 218, 40, 'PPL', 'P'),
(158952, 'Basket', 40.3899993896484, 0.704938474227865, -75.8263931274414, -1.32342021998545, 218, 45, 'PPL', 'P'),
(19085, 'Basket Creek', 33.5958290100098, 0.586357831161697, -84.820556640625, -1.48039798675325, 218, 13, 'PPL', 'P'),
(34692, 'Baskett', 37.8708305358887, 0.660970683316066, -87.4625015258789, -1.52650862365715, 218, 21, 'PPL', 'P'),
(15105, 'Baskin', 27.8966693878174, 0.486888731157724, -82.795280456543, -1.44505024907879, 218, 12, 'PPL', 'P'),
(39237, 'Baskin', 32.2588882446289, 0.563023812901668, -91.7474975585938, -1.60129591286292, 218, 22, 'PPL', 'P'),
(79675, 'Baskin Hills', 33.9930610656738, 0.593290838427501, -81.1941680908203, -1.41710556660253, 218, 48, 'PPL', 'P'),
(144793, 'Basking Ridge', 40.7061080932617, 0.710455611900128, -74.5497207641602, -1.30113808377698, 218, 37, 'PPL', 'P'),
(192992, 'Basking Ridge', 33.6394386291504, 0.587118962601242, -111.935829162598, -1.95364876983722, 218, 5, 'PPL', 'P'),
(39238, 'Baskinton', 32.3111114501953, 0.563935279784748, -91.6805572509766, -1.6001275840927, 218, 22, 'PPL', 'P'),
(108104, 'Basnettville', 39.586109161377, 0.690907942919919, -80.2358322143555, -1.40037945021824, 218, 58, 'PPL', 'P'),
(147030, 'Basom', 43.0672187805176, 0.751664767396769, -78.3916702270508, -1.36819275159965, 218, 40, 'PPL', 'P'),
(108105, 'Basore', 38.8636093139648, 0.678297941737421, -78.8305587768555, -1.37585280184304, 218, 58, 'PPL', 'P'),
(200377, 'Basque', 42.410831451416, 0.740208647335575, -117.867500305176, -2.05717596142074, 218, 43, 'PPL', 'P'),
(7290, 'Bass', 35.9041709899902, 0.626645998974362, -92.9977798461914, -1.62311745536087, 218, 4, 'PPL', 'P'),
(15106, 'Bass', 30.1083297729492, 0.525489486814201, -82.6961135864258, -1.44331946068635, 218, 12, 'PPL', 'P'),
(19086, 'Bass', 32.5855598449707, 0.568725307900392, -83.6666717529297, -1.46025889627396, 218, 13, 'PPL', 'P'),
(34693, 'Bass', 37.3386116027832, 0.651681710591924, -85.1447219848633, -1.48605573933107, 218, 21, 'PPL', 'P'),
(53353, 'Bass', 38.4319381713867, 0.670763859013587, -92.3249969482422, -1.61137517864054, 218, 29, 'PPL', 'P'),
(108106, 'Bass', 38.9483299255371, 0.67977659535366, -79.0025024414063, -1.3788537849174, 218, 58, 'PPL', 'P'),
(112966, 'Bass', 34.9319381713867, 0.609677335193786, -85.9130630493164, -1.49946582068405, 218, 2, 'PPL', 'P'),
(84838, 'Bass Bay', 36.2822189331055, 0.633244180312115, -87.975830078125, -1.53546789703834, 218, 50, 'PPL', 'P'),
(19087, 'Bass Crossroads', 33.1425018310547, 0.578445779300154, -84.9013900756836, -1.48180879634072, 218, 13, 'PPL', 'P'),
(62734, 'Bass Crossroads', 35.9841690063477, 0.628042227754863, -78.0788879394531, -1.36273367083915, 218, 33, 'PPL', 'P'),
(79677, 'Bass Crossroads', 33.9263916015625, 0.592127236768218, -79.648063659668, -1.39012095369925, 218, 48, 'PPL', 'P'),
(126834, 'Bass Harbor', 44.2400016784668, 0.772133690377063, -68.3444366455078, -1.19283544488478, 218, 26, 'PPL', 'P'),
(15107, 'Bass Haven', 29.9269409179688, 0.522323654068369, -81.5849990844727, -1.42392685426061, 218, 12, 'PPL', 'P'),
(122194, 'Bass Lake', 41.207218170166, 0.71920163265703, -86.601936340332, -1.51148892774132, 218, 19, 'PPL', 'P'),
(158953, 'Bass Lake', 40.1458282470703, 0.70067688385152, -76.7819366455078, -1.3400976005218, 218, 45, 'PPL', 'P'),
(179964, 'Bass Lake', 37.3247184753418, 0.651439229774672, -119.565277099609, -2.08680775644756, 218, 6, 'PPL', 'P'),
(179965, 'Bass Lake Annex', 37.2713890075684, 0.65050845497369, -119.533058166504, -2.08624542998339, 218, 6, 'PPL', 'P'),
(154195, 'Bass Landing', 40.5105590820313, 0.707042637805137, -84.5266723632813, -1.47526873849375, 218, 41, 'PPL', 'P'),
(134112, 'Bass Mobile Home Park', 43.8699989318848, 0.765675924207785, -93.0472183227539, -1.62398031955405, 218, 28, 'PPL', 'P'),
(70501, 'Bass River', 39.5924987792969, 0.691019462790566, -74.4430618286133, -1.29927653417501, 218, 37, 'PPL', 'P'),
(124189, 'Bass River', 41.6527786254883, 0.726978129619089, -70.2041702270508, -1.22529391909261, 218, 23, 'PPL', 'P'),
(124190, 'Bass Rocks', 42.6141700744629, 0.743757575804215, -70.6358337402344, -1.23282786865839, 218, 23, 'PPL', 'P'),
(122195, 'Bass Station', 41.1852798461914, 0.718818736671304, -86.6022186279297, -1.51149385458934, 218, 19, 'PPL', 'P'),
(19088, 'Bass Store', 31.6755599975586, 0.552842814370405, -84.8230590820313, -1.48044166259512, 218, 13, 'PPL', 'P'),
(39239, 'Bassa Bassa', 29.3636093139648, 0.51249166279796, -89.9944381713867, -1.57069925457316, 218, 22, 'PPL', 'P'),
(124191, 'Bassets Corner', 42.4813919067383, 0.741440159602655, -72.1291732788086, -1.25889156045672, 218, 23, 'PPL', 'P'),
(7292, 'Bassett', 35.5363883972168, 0.620226981798944, -90.1266708374023, -1.57300714997383, 218, 4, 'PPL', 'P'),
(31746, 'Bassett', 37.9027786254883, 0.661528282669301, -95.4038925170898, -1.665112043642, 218, 20, 'PPL', 'P'),
(92479, 'Bassett', 33.3166694641113, 0.581485577947397, -94.5608291625977, -1.6503978123032, 218, 51, 'PPL', 'P'),
(99662, 'Bassett', 36.7591705322266, 0.64156855608943, -79.9905624389648, -1.39609868508204, 218, 53, 'PPL', 'P'),
(114515, 'Bassett', 43.063060760498, 0.751592196257064, -92.5152816772461, -1.61469627367793, 218, 16, 'PPL', 'P'),
(134113, 'Bassett', 47.3872184753418, 0.827062985756602, -91.82861328125, -1.60271164929841, 218, 28, 'PPL', 'P'),
(141240, 'Bassett', 42.5858306884766, 0.74326296021076, -99.5374984741211, -1.73725707757224, 218, 35, 'PPL', 'P'),
(173077, 'Bassett', 42.5405616760254, 0.74247286689436, -88.227783203125, -1.53986530863028, 218, 57, 'PPL', 'P'),
(179967, 'Bassett', 34.0497207641602, 0.594279736719274, -117.995826721191, -2.0594156798975, 218, 6, 'PPL', 'P'),
(194560, 'Bassett', 43.6511116027832, 0.761855619624066, -112.087501525879, -1.95629595196076, 218, 17, 'PPL', 'P'),
(154196, 'Bassett (historical)', 41.2119407653809, 0.719284057492768, -83.6736068725586, -1.4603799369455, 218, 41, 'PPL', 'P'),
(189924, 'Bassett (historical)', 39.458610534668, 0.688682672092076, -114.511390686035, -1.99860079850888, 218, 39, 'PPL', 'P'),
(171719, 'Bassett Development', 43.6202812194824, 0.761317527925816, -72.9449996948242, -1.27313041754094, 218, 55, 'PPL', 'P'),
(99663, 'Bassett Forks', 36.7408294677734, 0.641248444126402, -79.934440612793, -1.39511917443311, 218, 53, 'PPL', 'P'),
(206771, 'Bassett Junction', 47.0424995422363, 0.821046505379949, -119.08805847168, -2.07847872013834, 218, 56, 'PPL', 'P'),
(179966, 'Bassetts', 39.6197204589844, 0.691494570729036, -120.586387634277, -2.10462949730432, 218, 6, 'PPL', 'P'),
(112967, 'Bassetts Creek', 31.4644393920898, 0.549158064686171, -88.0322189331055, -1.53645206821918, 218, 2, 'PPL', 'P'),
(58562, 'Bassfield', 31.4963893890381, 0.54971569732892, -89.7394409179688, -1.56624871291748, 218, 30, 'PPL', 'P'),
(53354, 'Bassinger Corner', 39.2808303833008, 0.685579823106025, -91.644172668457, -1.59949255333077, 218, 29, 'PPL', 'P'),
(62731, 'Basstown', 35.0869407653809, 0.612382640808115, -78.3566665649414, -1.36758182244558, 218, 33, 'PPL', 'P'),
(19089, 'Bassville', 31.7819404602051, 0.554699503703381, -82.370002746582, -1.43762775280463, 218, 13, 'PPL', 'P'),
(53355, 'Bassville', 37.3444404602051, 0.651783443345565, -93.1322174072266, -1.62546383343928, 218, 29, 'PPL', 'P'),
(15108, 'Bassville Park', 28.8402805328369, 0.503357852496829, -81.7688903808594, -1.42713636284832, 218, 12, 'PPL', 'P'),
(129682, 'Basswood', 46.1886100769043, 0.806143322761811, -88.8450012207031, -1.55063779523965, 218, 27, 'PPL', 'P'),
(134115, 'Basswood', 46.4555587768555, 0.810802456509878, -95.6930618286133, -1.67015900022381, 218, 28, 'PPL', 'P'),
(173078, 'Basswood', 43.2625007629395, 0.755073080959852, -90.4991683959961, -1.57950845882693, 218, 57, 'PPL', 'P'),
(15109, 'Basswood Estates', 27.2777805328369, 0.476087082934417, -80.8574981689453, -1.41122956797338, 218, 12, 'PPL', 'P'),
(134116, 'Basswood Grove', 44.827220916748, 0.782382599516124, -92.7991714477539, -1.61965108488602, 218, 28, 'PPL', 'P'),
(99664, 'Bastian', 37.1519393920898, 0.648423665893348, -81.1502838134766, -1.41633964147303, 218, 53, 'PPL', 'P'),
(19090, 'Bastonville', 33.3077812194824, 0.5813304488139, -82.5316696166992, -1.44044937197957, 218, 13, 'PPL', 'P'),
(158954, 'Bastress', 41.1758308410645, 0.718653820420801, -77.1374969482422, -1.3463032984939, 218, 45, 'PPL', 'P'),
(39240, 'Bastrop', 32.7561111450195, 0.571701989629801, -91.8722229003906, -1.60347278073795, 218, 22, 'PPL', 'P'),
(92480, 'Bastrop', 30.110279083252, 0.525523508697126, -97.3150024414063, -1.69846720418886, 218, 51, 'PPL', 'P'),
(92483, 'Bastrop Beach', 29.1116695404053, 0.508094484232616, -95.3722229003906, -1.66455930455775, 218, 51, 'PPL', 'P'),
(99665, 'Basye', 38.8069381713867, 0.677308843708566, -78.7925033569336, -1.37518860946718, 218, 53, 'PPL', 'P'),
(39241, 'Bat', 30.7166690826416, 0.536107010737642, -91.898063659668, -1.60392378706856, 218, 22, 'PPL', 'P'),
(62733, 'Bat Cave', 35.4513893127441, 0.618743467913715, -82.2872161865234, -1.43618285475521, 218, 33, 'PPL', 'P'),
(84840, 'Bat Harbor', 35.9324989318848, 0.627140414830735, -83.1308288574219, -1.45090667347393, 218, 50, 'PPL', 'P'),
(99666, 'Bataan Village', 38.7630615234375, 0.676543051737113, -77.5205612182617, -1.35298903125249, 218, 53, 'PPL', 'P'),
(709, 'Batarora', 34.2400016784668, 0.59760076517763, -78.1447219848633, -1.36388269169146, 218, 33, 'PPL', 'P'),
(7293, 'Batavia', 36.2550010681152, 0.632769138952672, -93.2225036621094, -1.62703962585628, 218, 4, 'PPL', 'P'),
(71749, 'Batavia', 39.0769386291504, 0.682021240678434, -84.1769409179688, -1.46916477327529, 218, 41, 'PPL', 'P'),
(114517, 'Batavia', 40.9941711425781, 0.715483260564034, -92.1672210693359, -1.6086214700734, 218, 16, 'PPL', 'P'),
(118734, 'Batavia', 41.8499984741211, 0.730420265328016, -88.3125, -1.54134389566749, 218, 18, 'PPL', 'P'),
(129683, 'Batavia', 41.9124984741211, 0.731511096110512, -85.0980606079102, -1.48524134466972, 218, 27, 'PPL', 'P'),
(147031, 'Batavia', 42.9980583190918, 0.75045768963269, -78.1877822875977, -1.36463423575108, 218, 40, 'PPL', 'P'),
(173079, 'Batavia', 43.5944404602051, 0.760866521595211, -88.0508270263672, -1.53677684071412, 218, 57, 'PPL', 'P'),
(179968, 'Batavia', 38.4063911437988, 0.670317979268081, -121.858612060547, -2.12683400236701, 218, 6, 'PPL', 'P'),
(195933, 'Batavia', 48.1819381713867, 0.840933461083034, -114.412216186523, -1.99686987695838, 218, 31, 'PPL', 'P'),
(129684, 'Batavia Center', 41.940559387207, 0.732000851434978, -85.1183319091797, -1.48559514562054, 218, 27, 'PPL', 'P'),
(118735, 'Batavia Junction', 41.795280456543, 0.729465255761114, -88.2405624389648, -1.54008834837157, 218, 18, 'PPL', 'P'),
(126835, 'Batchelders Crossing', 44.1897201538086, 0.771256112218855, -69.9402770996094, -1.22068811514537, 218, 26, 'PPL', 'P'),
(129686, 'Batcheller', 44.0041694641113, 0.768017641754291, -86.1308288574219, -1.50326655103376, 218, 27, 'PPL', 'P'),
(147041, 'Batchellerville', 43.211669921875, 0.75418591542172, -74.0822219848633, -1.29297869082919, 218, 40, 'PPL', 'P'),
(39242, 'Batchelor', 30.8402805328369, 0.538264437536715, -91.6613922119141, -1.59979309105979, 218, 22, 'PPL', 'P'),
(62736, 'Batchelor Crossroads', 35.9483299255371, 0.627416717793831, -78.0163879394531, -1.36164284005665, 218, 33, 'PPL', 'P'),
(112965, 'Batchelor Subdivision', 33.3469390869141, 0.582013882528642, -87.5888900756836, -1.52871451998806, 218, 2, 'PPL', 'P'),
(26457, 'Batchtown', 39.0330581665039, 0.681255382127954, -90.6575012207031, -1.58227188793205, 218, 18, 'PPL', 'P'),
(92482, 'Bateman', 29.9511108398438, 0.522745498785038, -97.4749984741211, -1.70125966174986, 218, 51, 'PPL', 'P'),
(173080, 'Bateman', 44.9311103820801, 0.784195812744305, -91.2677764892578, -1.59292320071182, 218, 57, 'PPL', 'P'),
(193360, 'Bateman Place', 40.6236114501953, 0.709015773856777, -121.737503051758, -2.12472025140982, 218, 6, 'PPL', 'P'),
(154205, 'Batemantown', 40.5258293151855, 0.707309153651227, -82.5961074829102, -1.44157402490791, 218, 41, 'PPL', 'P'),
(7296, 'Bates', 34.9080581665039, 0.609260550483188, -94.3866729736328, -1.64735821339304, 218, 4, 'PPL', 'P'),
(26458, 'Bates', 39.7241706848145, 0.693317571074223, -89.8494415283203, -1.56816858574732, 218, 18, 'PPL', 'P'),
(39243, 'Bates', 30.4213905334473, 0.530953427843689, -92.3983306884766, -1.61265509386043, 218, 22, 'PPL', 'P'),
(84841, 'Bates', 35.9099998474121, 0.626747731728003, -87.3744430541992, -1.52497171339207, 218, 50, 'PPL', 'P'),
(129687, 'Bates', 44.7727813720703, 0.781432450218211, -85.4441680908203, -1.49128205981229, 218, 27, 'PPL', 'P'),
(147035, 'Bates', 42.4463882446289, 0.740829230448591, -74.2747192382813, -1.29633840170238, 218, 40, 'PPL', 'P'),
(154197, 'Bates', 41.5905609130859, 0.725892225684609, -83.5783309936523, -1.45871705916086, 218, 41, 'PPL', 'P'),
(188117, 'Bates', 36.2958297729492, 0.63348173428135, -103.202499389648, -1.8012234106368, 218, 38, 'PPL', 'P'),
(194561, 'Bates', 43.6916694641113, 0.762563487841809, -111.199996948242, -1.94080607495447, 218, 17, 'PPL', 'P'),
(200378, 'Bates', 44.5930595397949, 0.778295712507289, -118.507499694824, -2.06834605798086, 218, 43, 'PPL', 'P'),
(206772, 'Bates', 45.7050018310547, 0.797702766581941, -120.425559997559, -2.10182252551537, 218, 56, 'PPL', 'P'),
(44622, 'Bates Acres', 38.211109161377, 0.666909665704997, -76.4855575561523, -1.33492480957849, 218, 25, 'PPL', 'P'),
(53356, 'Bates City', 39.0061111450195, 0.680785067879446, -94.0722198486328, -1.6418699710186, 218, 29, 'PPL', 'P'),
(53357, 'Bates Corner', 36.6541709899902, 0.639735968364319, -93.8086090087891, -1.63726909391938, 218, 29, 'PPL', 'P'),
(154198, 'Bates Corners', 41.0505599975586, 0.716467431744873, -81.6380615234375, -1.42485296852968, 218, 41, 'PPL', 'P'),
(62737, 'Bates Creek', 35.1130599975586, 0.61283850740771, -84.0530624389648, -1.46700268594431, 218, 33, 'PPL', 'P'),
(53359, 'Bates Creek Camp', 37.9061088562012, 0.661586406160092, -90.8213882446289, -1.58513225610085, 218, 29, 'PPL', 'P'),
(84842, 'Bates Hill', 35.7305603027344, 0.623615920865097, -85.9313888549805, -1.49978566633097, 218, 50, 'PPL', 'P'),
(129688, 'Bates Junction', 46.0863914489746, 0.804359271147567, -88.601936340332, -1.54639551278121, 218, 27, 'PPL', 'P'),
(129689, 'Bates Location', 46.1130599975586, 0.804824725127086, -88.6161117553711, -1.54664292044648, 218, 27, 'PPL', 'P'),
(70503, 'Bates Mill', 39.7069396972656, 0.693016833608126, -74.8655624389648, -1.30665056091733, 218, 37, 'PPL', 'P'),
(188118, 'Bates Place', 35.4944381713867, 0.619494812236254, -103.412780761719, -1.80489351293504, 218, 38, 'PPL', 'P'),
(79678, 'Batesburg', 33.9077796936035, 0.591802397694255, -81.5475006103516, -1.42327238242272, 218, 48, 'PPL', 'P'),
(79680, 'Batesburg-Leesville', 33.9099998474121, 0.591841146688116, -81.5374984741211, -1.42309781221327, 218, 48, 'PPL', 'P'),
(201886, 'Batesland', 43.1294403076172, 0.752750737910276, -102.101669311523, -1.78201030126854, 218, 49, 'PPL', 'P'),
(118737, 'Batestown', 40.1199989318848, 0.700226077257997, -87.6963882446289, -1.53059071697602, 218, 18, 'PPL', 'P'),
(7298, 'Batesville', 35.769718170166, 0.624299354579838, -91.6408309936523, -1.5994342301029, 218, 4, 'PPL', 'P'),
(19092, 'Batesville', 34.7480583190918, 0.606468026343158, -83.6113891601563, -1.45929403301102, 218, 13, 'PPL', 'P'),
(29163, 'Batesville', 39.2999992370605, 0.685914382717966, -85.2222213745117, -1.48740835884872, 218, 19, 'PPL', 'P'),
(31747, 'Batesville', 37.836109161377, 0.660364681010018, -95.8702774047852, -1.67325199551383, 218, 20, 'PPL', 'P'),
(53360, 'Batesville', 36.6988906860352, 0.640516474300794, -90.2461090087891, -1.57509173931709, 218, 29, 'PPL', 'P'),
(58564, 'Batesville', 34.3113899230957, 0.598846725093624, -89.9441680908203, -1.56982187615204, 218, 30, 'PPL', 'P'),
(71751, 'Batesville', 39.9141693115234, 0.696633672684562, -81.2813873291016, -1.41862782948162, 218, 41, 'PPL', 'P'),
(79681, 'Batesville', 34.8505592346191, 0.608257004805419, -82.230827331543, -1.43519868357437, 218, 48, 'PPL', 'P'),
(92485, 'Batesville', 28.9508304595947, 0.505287312706591, -99.6175003051758, -1.73865337293177, 218, 51, 'PPL', 'P'),
(99667, 'Batesville', 37.9955596923828, 0.663147617770124, -78.7225036621094, -1.3739668843171, 218, 53, 'PPL', 'P'),
(112969, 'Batesville', 32.0088882446289, 0.558660489771683, -85.3111114501953, -1.48895978334174, 218, 2, 'PPL', 'P'),
(126836, 'Batesville', 46.125560760498, 0.805042904599391, -68.3475036621094, -1.19288897442269, 218, 26, 'PPL', 'P'),
(19093, 'Bath', 33.3386116027832, 0.581868540512151, -82.1766662597656, -1.43425339454544, 218, 13, 'PPL', 'P'),
(29164, 'Bath', 39.5083312988281, 0.689550463133279, -84.8625030517578, -1.48113008973691, 218, 19, 'PPL', 'P'),
(34694, 'Bath', 37.2425003051758, 0.65000425200031, -82.9113922119141, -1.44707678151028, 218, 21, 'PPL', 'P'),
(62741, 'Bath', 35.4769401550293, 0.619189414238249, -76.8119430541992, -1.34062131115017, 218, 33, 'PPL', 'P'),
(79682, 'Bath', 33.5044403076172, 0.584762797405822, -81.8691711425781, -1.42888659231672, 218, 48, 'PPL', 'P'),
(92486, 'Bath', 30.5944404602051, 0.533973718835948, -95.6236114501953, -1.66894686245366, 218, 51, 'PPL', 'P'),
(118738, 'Bath', 40.1933288574219, 0.701505925898862, -90.1408309936523, -1.57325429132299, 218, 18, 'PPL', 'P'),
(126837, 'Bath', 43.9105606079102, 0.766383859004555, -69.8211135864258, -1.21860831949208, 218, 26, 'PPL', 'P'),
(129691, 'Bath', 42.8186111450195, 0.74732574561173, -84.4486083984375, -1.47390626528007, 218, 27, 'PPL', 'P'),
(134117, 'Bath', 43.8255615234375, 0.764900345119326, -93.3897171020508, -1.62995805093684, 218, 28, 'PPL', 'P'),
(143499, 'Bath', 44.1669387817383, 0.770858502268106, -71.966667175293, -1.25605529389579, 218, 36, 'PPL', 'P'),
(147036, 'Bath', 42.3369407653809, 0.738919011577704, -77.3180618286133, -1.34945475016985, 218, 40, 'PPL', 'P'),
(154199, 'Bath', 41.1888885498047, 0.718881720431084, -81.6363906860352, -1.42482380691575, 218, 41, 'PPL', 'P'),
(158960, 'Bath', 40.7255592346191, 0.710795098360086, -75.3944396972656, -1.3158812104136, 218, 45, 'PPL', 'P'),
(169798, 'Bath', 45.4683303833008, 0.793572070573174, -98.3233337402344, -1.71606590530432, 218, 49, 'PPL', 'P'),
(179969, 'Bath (historical)', 39.0361099243164, 0.681308645349756, -120.792221069336, -2.10822196845678, 218, 6, 'PPL', 'P'),
(158956, 'Bath Addition', 40.1074981689453, 0.700007897785693, -74.8655624389648, -1.30665056091733, 218, 45, 'PPL', 'P'),
(99668, 'Bath Alum', 38.0486106872559, 0.664073532302117, -79.7188873291016, -1.39135705991921, 218, 53, 'PPL', 'P'),
(147037, 'Bath Beach', 40.6044387817383, 0.708681147665808, -74.0047225952148, -1.29162607131154, 218, 40, 'PPL', 'P'),
(154200, 'Bath Center', 41.1686096191406, 0.718527786322213, -81.6369400024414, -1.42483339429567, 218, 41, 'PPL', 'P'),
(169799, 'Bath Corner', 45.459171295166, 0.793412214328742, -98.3291702270508, -1.71616777121602, 218, 49, 'PPL', 'P'),
(158957, 'Bath Junction', 40.7219390869141, 0.710731914863224, -75.3813934326172, -1.3156535101404, 218, 45, 'PPL', 'P'),
(84843, 'Bath Springs', 35.4397201538086, 0.618539802669351, -88.0877838134766, -1.53742185833013, 218, 50, 'PPL', 'P'),
(112971, 'Bath Springs', 34.1116714477539, 0.595360980121847, -85.8897171020508, -1.49905835703727, 218, 2, 'PPL', 'P'),
(139647, 'Bathgate', 48.8772201538086, 0.853068420906089, -97.475830078125, -1.7012741759778, 218, 34, 'PPL', 'P'),
(84844, 'Batley', 36.0291709899902, 0.628827660539355, -84.288330078125, -1.47110888087105, 218, 50, 'PPL', 'P'),
(99673, 'Batna', 38.4013900756836, 0.670230694163353, -77.8908309936523, -1.35945145795368, 218, 53, 'PPL', 'P'),
(62740, 'Baton', 35.8072204589844, 0.624953892996753, -81.5319366455078, -1.42300073999153, 218, 33, 'PPL', 'P'),
(39245, 'Baton Rouge', 30.4505596160889, 0.531462524375571, -91.1544418334961, -1.59094513781216, 218, 22, 'PPL', 'P'),
(79683, 'Baton Rouge', 34.6969413757324, 0.605575867377982, -81.3441696166992, -1.41972358711214, 218, 48, 'PPL', 'P'),
(39247, 'Batree', 29.999719619751, 0.523593882039796, -90.7863922119141, -1.58452146010484, 218, 22, 'PPL', 'P'),
(7299, 'Batson', 35.6222190856934, 0.621725009912113, -93.647216796875, -1.63445226843441, 218, 4, 'PPL', 'P'),
(19094, 'Batson', 32.3083305358887, 0.563886743673881, -83.0680618286133, -1.44981118215952, 218, 13, 'PPL', 'P'),
(58565, 'Batson', 31.2688903808594, 0.54574509059118, -89.1958312988281, -1.55676093521796, 218, 30, 'PPL', 'P'),
(92489, 'Batson', 30.2491703033447, 0.527947617789857, -94.6069412231445, -1.65120261958462, 218, 51, 'PPL', 'P'),
(154203, 'Batson', 41.0183296203613, 0.715904905543621, -84.745002746582, -1.47907932253949, 218, 41, 'PPL', 'P'),
(92487, 'Batson Gardens Colonia', 26.3239994049072, 0.459440461908659, -98.1890029907227, -1.71372139143867, 218, 51, 'PPL', 'P'),
(70504, 'Batsto', 39.6416702270508, 0.691877666451844, -74.648063659668, -1.30285449109953, 218, 37, 'PPL', 'P'),
(99670, 'Batt', 37.5686111450195, 0.655695959882028, -76.6488876342773, -1.33777545720931, 218, 53, 'PPL', 'P'),
(58566, 'Batt Place', 30.9752807617188, 0.540620636021649, -88.9791717529297, -1.55297951278616, 218, 30, 'PPL', 'P'),
(112970, 'Battelle', 34.6494407653809, 0.60474682533064, -85.5652770996094, -1.49339581076949, 218, 2, 'PPL', 'P'),
(112968, 'Battens Crossroads', 31.2608299255371, 0.545604409106596, -85.8899993896484, -1.49906328388529, 218, 2, 'PPL', 'P'),
(147039, 'Battenville', 43.1091690063477, 0.752396936959459, -73.4244384765625, -1.28149820284402, 218, 40, 'PPL', 'P'),
(44617, 'Batter Brook Farms', 39.4377784729004, 0.688319084024253, -76.438606262207, -1.33410535491107, 218, 25, 'PPL', 'P'),
(99671, 'Battersea', 37.2247200012207, 0.649693927154289, -77.4225006103516, -1.35127755077795, 218, 53, 'PPL', 'P'),
(44618, 'Battersea on the Bay', 38.7405586242676, 0.676150302055354, -77.0055618286133, -1.34400059625737, 218, 25, 'PPL', 'P'),
(200379, 'Batterson', 45.7013893127441, 0.797639716243134, -123.757217407227, -2.15997091686254, 218, 43, 'PPL', 'P'),
(99672, 'Battery', 37.9655609130859, 0.662624040299814, -77.024169921875, -1.3443253687523, 218, 53, 'PPL', 'P'),
(112973, 'Battery Hill', 34.9527816772461, 0.61004112299869, -85.7083282470703, -1.49589252429144, 218, 2, 'PPL', 'P'),
(79684, 'Battery Marina Village', 32.3786087036133, 0.565113329092945, -80.7197189331055, -1.40882486666709, 218, 48, 'PPL', 'P'),
(44619, 'Battery Park', 38.9894409179688, 0.680494117530355, -77.107780456543, -1.34578464787161, 218, 25, 'PPL', 'P'),
(99674, 'Battery Park', 36.9963912963867, 0.645708839478122, -76.5744400024414, -1.33647610091346, 218, 53, 'PPL', 'P'),
(79685, 'Battery Point', 32.7427787780762, 0.571469295929555, -79.9491729736328, -1.39537630263636, 218, 48, 'PPL', 'P'),
(44620, 'Battery Point Farms', 39.4680595397949, 0.688847588342579, -75.9044418334961, -1.32478242688303, 218, 25, 'PPL', 'P'),
(75075, 'Battiest', 34.3933296203613, 0.600276842598997, -94.9247207641602, -1.65674891887082, 218, 42, 'PPL', 'P'),
(200380, 'Battin', 45.4588890075684, 0.793407287480725, -122.576942443848, -2.13937123267273, 218, 43, 'PPL', 'P'),
(34696, 'Battle', 37.7786102294922, 0.659361135332249, -85.0286102294922, -1.48402920689957, 218, 21, 'PPL', 'P'),
(39246, 'Battle', 30.8263893127441, 0.538021990008977, -91.0813903808594, -1.58967014944029, 218, 22, 'PPL', 'P'),
(92488, 'Battle', 31.5524997711182, 0.550695008240769, -96.8891677856445, -1.69103498737672, 218, 51, 'PPL', 'P'),
(44621, 'Battle (historical)', 38.4519386291504, 0.671112932853469, -76.5888900756836, -1.33672830226869, 218, 25, 'PPL', 'P'),
(209294, 'Battle (historical)', 41.1558303833008, 0.718304746580919, -106.981666564941, -1.86718232082896, 218, 59, 'PPL', 'P'),
(58568, 'Battle Bluff', 32.7847213745117, 0.57220133233419, -89.4166717529297, -1.56061532826363, 218, 30, 'PPL', 'P'),
(79687, 'Battle Creek', 34.7480583190918, 0.606468026343158, -83.290283203125, -1.45368967681306, 218, 48, 'PPL', 'P'),
(99675, 'Battle Creek', 38.6063919067383, 0.673808651087875, -78.5861129760742, -1.37158641777674, 218, 53, 'PPL', 'P'),
(114518, 'Battle Creek', 42.315559387207, 0.738545836129957, -95.5983276367188, -1.66850557666103, 218, 16, 'PPL', 'P'),
(129693, 'Battle Creek', 42.3211097717285, 0.738642708614608, -85.1797180175781, -1.48666653532708, 218, 27, 'PPL', 'P'),
(141244, 'Battle Creek', 41.999439239502, 0.733028498720612, -97.5980606079102, -1.70340750116901, 218, 35, 'PPL', 'P'),
(194102, 'Battle Creek', 41.0013885498047, 0.715609228083595, -107.244438171387, -1.87176855054219, 218, 7, 'PPL', 'P'),
(122196, 'Battle Ground', 40.5083312988281, 0.707003755653222, -86.841667175293, -1.51567302012995, 218, 19, 'PPL', 'P'),
(206776, 'Battle Ground', 45.7811088562012, 0.799031084754646, -122.532218933105, -2.13859066015722, 218, 56, 'PPL', 'P'),
(15110, 'Battle Ground Forks', 30.5044403076172, 0.532402919845992, -85.9497222900391, -1.50010564513594, 218, 12, 'PPL', 'P'),
(44623, 'Battle Grove', 39.2719383239746, 0.685424627393501, -76.4775009155273, -1.33478419467293, 218, 25, 'PPL', 'P'),
(7302, 'Battle Hill (historical)', 34.2777786254883, 0.598260097284507, -94.1083297729492, -1.64250020809057, 218, 4, 'PPL', 'P'),
(19096, 'Battle Hill Haven', 33.7558288574219, 0.589150355301727, -84.4461135864258, -1.47386272259625, 218, 13, 'PPL', 'P'),
(158959, 'Battle Hollow', 41.0058288574219, 0.715686726071316, -78.996940612793, -1.37875671269566, 218, 45, 'PPL', 'P'),
(134119, 'Battle Lake', 46.2805595397949, 0.807748143634693, -95.7133331298828, -1.67051280117462, 218, 28, 'PPL', 'P'),
(199825, 'Battle Mountain', 40.642219543457, 0.709340546351712, -116.933326721191, -2.04087155659506, 218, 39, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(19097, 'Battle Park', 32.3844413757324, 0.565215128425613, -84.9494400024414, -1.48264742576798, 218, 13, 'PPL', 'P'),
(99676, 'Battle Park', 37.1974983215332, 0.649218819215819, -76.4930572509766, -1.33505570394606, 218, 53, 'PPL', 'P'),
(206774, 'Battle Point', 47.6575012207031, 0.831780309574486, -122.583610534668, -2.13948761281236, 218, 56, 'PPL', 'P'),
(34699, 'Battle Run', 38.3497200012207, 0.669328881239225, -83.8441696166992, -1.46335681841199, 218, 21, 'PPL', 'P'),
(62744, 'Battleboro', 36.0488891601563, 0.62917180753122, -77.7494430541992, -1.35698377288761, 218, 33, 'PPL', 'P'),
(7301, 'Battlefield', 33.5933303833008, 0.586314221898847, -93.6883316040039, -1.63516985719013, 218, 4, 'PPL', 'P'),
(53362, 'Battlefield', 37.1291694641113, 0.648026255679681, -93.3666687011719, -1.62955578045419, 218, 29, 'PPL', 'P'),
(58569, 'Battlefield (historical)', 32.5463905334473, 0.568041674448568, -88.9400024414063, -1.55229587933433, 218, 30, 'PPL', 'P'),
(99677, 'Battlefield Green', 37.628059387207, 0.656733527442723, -77.3105621337891, -1.34932385580227, 218, 53, 'PPL', 'P'),
(84775, 'BAttlefield Meadows', 35.9277801513672, 0.627058056574024, -86.4894409179688, -1.50952551222766, 218, 50, 'PPL', 'P'),
(99679, 'Battlefield Park', 37.1916694641113, 0.649117086462178, -77.3827819824219, -1.35058432994621, 218, 53, 'PPL', 'P'),
(62743, 'Battleground', 36.2422218322754, 0.632546099211378, -81.9316711425781, -1.42997742309921, 218, 33, 'PPL', 'P'),
(112975, 'Battleground', 34.3044395446777, 0.598725418105971, -86.9963912963867, -1.51837346547529, 218, 2, 'PPL', 'P'),
(186389, 'Battlement Mesa', 39.4413909912109, 0.688382134363061, -108.024436950684, -1.88538209740245, 218, 7, 'PPL', 'P'),
(58570, 'Battles', 31.5016708374023, 0.54980787599215, -88.5094375610352, -1.5447811045284, 218, 30, 'PPL', 'P'),
(112977, 'Battles Wharf', 30.4941692352295, 0.532223655815116, -87.9277801513672, -1.53462926761108, 218, 2, 'PPL', 'P'),
(154204, 'Battlesburg', 40.6980590820313, 0.710315130152626, -81.3702774047852, -1.42017925397465, 218, 41, 'PPL', 'P'),
(34697, 'Battletown', 38.0638885498047, 0.664340181306261, -86.2938919067383, -1.50611253813267, 218, 21, 'PPL', 'P'),
(99680, 'Battletown', 39.1480598449707, 0.68326254006252, -77.9694366455078, -1.36082338538923, 218, 53, 'PPL', 'P'),
(197978, 'Battleview', 48.5788917541504, 0.847861608079848, -102.791938781738, -1.79405777624978, 218, 34, 'PPL', 'P'),
(84847, 'Battlewood Estates', 35.9930610656738, 0.628197423467387, -86.8841705322266, -1.51641484365159, 218, 50, 'PPL', 'P'),
(84849, 'Battlewood Forest', 36.003059387207, 0.628371927097815, -86.8708267211914, -1.51618195021426, 218, 50, 'PPL', 'P'),
(179970, 'Batto', 38.2836112976074, 0.668175066696948, -122.435829162598, -2.13690834129662, 218, 6, 'PPL', 'P'),
(195934, 'Battrick (historical)', 46.9033317565918, 0.818617569307742, -108.736671447754, -1.89781293442261, 218, 31, 'PPL', 'P'),
(62745, 'Batts Court', 35.6044387817383, 0.621414685066092, -77.478889465332, -1.35226172195879, 218, 33, 'PPL', 'P'),
(62746, 'Batts Crossroads', 35.6902809143066, 0.622912912916343, -77.0802764892578, -1.34530461308512, 218, 33, 'PPL', 'P'),
(206775, 'Batum', 47.2336082458496, 0.824381981487219, -118.809173583984, -2.073611260614, 218, 56, 'PPL', 'P'),
(84848, 'Baucom', 35.5349998474121, 0.620202747033024, -86.2222213745117, -1.50486165136866, 218, 50, 'PPL', 'P'),
(7303, 'Baucum', 34.728889465332, 0.606133466731217, -92.129997253418, -1.60797179192548, 218, 4, 'PPL', 'P'),
(134123, 'Baudette', 48.7125015258789, 0.850193538509349, -94.5997161865234, -1.65107651890701, 218, 28, 'PPL', 'P'),
(34698, 'Bauer', 36.9322204589844, 0.644588847081689, -84.4472198486328, -1.47388203051415, 218, 21, 'PPL', 'P'),
(114520, 'Bauer', 41.2038917541504, 0.719143575745266, -93.3069381713867, -1.62851328604548, 218, 16, 'PPL', 'P'),
(129695, 'Bauer', 42.9213905334473, 0.74911958434298, -85.9022216796875, -1.4992766030886, 218, 27, 'PPL', 'P'),
(202986, 'Bauer', 40.4719390869141, 0.706368591733238, -112.361389160156, -1.96107619295939, 218, 52, 'PPL', 'P'),
(44624, 'Bauers Mobile Home Park', 39.4263916015625, 0.688120345627906, -76.2819366455078, -1.33137095426183, 218, 25, 'PPL', 'P'),
(158961, 'Bauerstown', 40.4958305358887, 0.706785576180917, -79.9766693115234, -1.39585620426479, 218, 45, 'PPL', 'P'),
(75077, 'Baugh', 36.2188911437988, 0.632138901880705, -96.3172225952148, -1.68105266066278, 218, 42, 'PPL', 'P'),
(84850, 'Baugh', 35.0730590820313, 0.612140359727945, -86.8505630493164, -1.5158282824215, 218, 50, 'PPL', 'P'),
(58571, 'Baugh (historical)', 34.1961097717285, 0.596834706890069, -90.7286071777344, -1.58351292100002, 218, 30, 'PPL', 'P'),
(29166, 'Baugh City', 38.0416717529297, 0.663952425051546, -87.4124984741211, -1.52563590576793, 218, 19, 'PPL', 'P'),
(84851, 'Baugh Spring', 35.1772193908691, 0.613958300067061, -84.9869384765625, -1.48330189760587, 218, 50, 'PPL', 'P'),
(44625, 'Baugher Woods', 39.5691719055176, 0.69061233203892, -77.4369430541992, -1.35152961897513, 218, 25, 'PPL', 'P'),
(34700, 'Baughman', 36.8647193908691, 0.643410731194465, -83.8002777099609, -1.46259076012443, 218, 21, 'PPL', 'P'),
(34701, 'Baughman Heights', 37.6319389343262, 0.656801238313438, -84.7724990844727, -1.47955922416793, 218, 21, 'PPL', 'P'),
(108110, 'Baughman Settlement', 39.0113906860352, 0.680877213253163, -78.7388916015625, -1.37425290781818, 218, 58, 'PPL', 'P'),
(19098, 'Baughs Crossroads', 32.915828704834, 0.574489586921814, -85.0199966430664, -1.48387887145603, 218, 13, 'PPL', 'P'),
(19099, 'Baughville', 32.6527786254883, 0.569898496939599, -84.6705627441406, -1.4777800994017, 218, 13, 'PPL', 'P'),
(15112, 'Baum', 30.5138893127441, 0.532567836096495, -84.0802764892578, -1.46747766072473, 218, 12, 'PPL', 'P'),
(26459, 'Baum', 39.3274993896484, 0.686394350925426, -90.315559387207, -1.57630387708723, 218, 18, 'PPL', 'P'),
(75078, 'Baum', 34.2680587768555, 0.598090453923069, -96.9805603027344, -1.69263008771162, 218, 42, 'PPL', 'P'),
(191114, 'Bauman Estates Colonia', 31.6359996795654, 0.552152356568288, -106.255996704102, -1.85451699247482, 218, 51, 'PPL', 'P'),
(191115, 'Bauman Estates Number 2 Colonia', 31.636999130249, 0.552169800273428, -106.262001037598, -1.85462178786371, 218, 51, 'PPL', 'P'),
(191116, 'Bauman Estates Number 3 Colonia', 31.6350002288818, 0.552134912863148, -106.264999389648, -1.85467411897913, 218, 51, 'PPL', 'P'),
(179971, 'Baumberg', 37.6208305358887, 0.65660736018608, -122.099166870117, -2.13103247582552, 218, 6, 'PPL', 'P'),
(77830, 'Baumgardner', 39.9605598449707, 0.697443340234974, -76.2811126708984, -1.33135657319194, 218, 45, 'PPL', 'P'),
(158962, 'Baumstown', 40.2802810668945, 0.703023528246044, -75.8052825927734, -1.32305177164864, 218, 45, 'PPL', 'P'),
(62747, 'Baumtown', 35.8502807617188, 0.625705437056373, -75.6544418334961, -1.32041910375304, 218, 33, 'PPL', 'P'),
(92490, 'Bausell and Ellis Colonia', 26.431999206543, 0.461325414038704, -97.7870025634766, -1.7067051603888, 218, 51, 'PPL', 'P'),
(158963, 'Bausman', 40.024169921875, 0.6985535455144, -76.3311080932617, -1.33222915792311, 218, 45, 'PPL', 'P'),
(191117, 'Bautista', 35.7200012207031, 0.623431630117663, -102.024436950684, -1.78066234228279, 218, 51, 'PPL', 'P'),
(92491, 'Bautista Colonia', 25.923999786377, 0.452459151558584, -97.4240036010742, -1.70036963331356, 218, 51, 'PPL', 'P'),
(199827, 'Bauvard (historical)', 41.2366714477539, 0.719715689326442, -114.239723205566, -1.9938593065041, 218, 39, 'PPL', 'P'),
(7304, 'Bauxippi (historical)', 35.1386108398438, 0.613284453732243, -90.1344375610352, -1.57314270487331, 218, 4, 'PPL', 'P'),
(4, 'Bauxite', 34.0472183227539, 0.594236060877397, -85.459716796875, -1.49155343592737, 218, 2, 'PPL', 'P'),
(7305, 'Bauxite', 34.5555610656738, 0.603108315469969, -92.521110534668, -1.61479800643157, 218, 4, 'PPL', 'P'),
(7306, 'Bauxite Junction', 34.5849990844727, 0.603622105823272, -92.5155563354492, -1.61470106736789, 218, 4, 'PPL', 'P'),
(31750, 'Bavaria', 38.7972183227539, 0.677139200347128, -97.7552795410156, -1.70615148919817, 218, 20, 'PPL', 'P'),
(173082, 'Bavaria', 45.3141708374023, 0.790881478923867, -89.3638916015625, -1.55969414084257, 218, 57, 'PPL', 'P'),
(158964, 'Bavington', 40.4258308410645, 0.705563851030843, -80.3647232055664, -1.40262902239103, 218, 45, 'PPL', 'P'),
(99681, 'Bavon', 37.3333282470703, 0.65158949863918, -76.2886123657227, -1.33148746755952, 218, 53, 'PPL', 'P'),
(39248, 'Bawcomville', 32.4702796936035, 0.566713289696837, -92.1672210693359, -1.6086214700734, 218, 22, 'PPL', 'P'),
(767, 'Baxley', 34.4277801513672, 0.600878117794109, -80.3619384765625, -1.40258041970113, 218, 48, 'PPL', 'P'),
(19100, 'Baxley', 31.7780609130859, 0.554631792832665, -82.3486099243164, -1.4372543776198, 218, 13, 'PPL', 'P'),
(7308, 'Baxter', 33.5291709899902, 0.585194429239496, -91.496940612793, -1.59692286919496, 218, 4, 'PPL', 'P'),
(15111, 'Baxter', 30.5133304595947, 0.532558082269003, -82.23388671875, -1.43525207995422, 218, 12, 'PPL', 'P'),
(19101, 'Baxter', 34.7386093139648, 0.606303110092655, -84.0747222900391, -1.46738072166105, 218, 13, 'PPL', 'P'),
(34702, 'Baxter', 36.8597183227539, 0.643323446089738, -83.3308334350586, -1.45439741187275, 218, 21, 'PPL', 'P'),
(53366, 'Baxter', 36.5661087036133, 0.638198991520207, -93.491943359375, -1.63174223570914, 218, 29, 'PPL', 'P'),
(58572, 'Baxter', 32.1911087036133, 0.561840836745455, -89.1697235107422, -1.55630526835545, 218, 30, 'PPL', 'P'),
(62748, 'Baxter', 35.3172187805176, 0.616401750367208, -82.3480606079102, -1.43724479023988, 218, 33, 'PPL', 'P'),
(84852, 'Baxter', 36.1536102294922, 0.630999534987341, -85.6436080932617, -1.49476294451508, 218, 50, 'PPL', 'P'),
(92492, 'Baxter', 32.1683311462402, 0.561443293373734, -95.748893737793, -1.67113345086667, 218, 51, 'PPL', 'P'),
(108112, 'Baxter', 39.5438919067383, 0.690171112825322, -80.1425018310547, -1.39875052773749, 218, 58, 'PPL', 'P'),
(114521, 'Baxter', 41.8261108398438, 0.730003347459364, -93.1513900756836, -1.62579845963025, 218, 16, 'PPL', 'P'),
(129696, 'Baxter', 44.5038909912109, 0.776739427745274, -85.5269393920898, -1.49272669154561, 218, 27, 'PPL', 'P'),
(134124, 'Baxter', 46.3433303833008, 0.808843701528124, -94.2863922119141, -1.64560798392464, 218, 28, 'PPL', 'P'),
(158965, 'Baxter', 41.1344413757324, 0.717931437975117, -79.1500015258789, -1.38142812958512, 218, 45, 'PPL', 'P'),
(173081, 'Baxter', 45.1072196960449, 0.78726950011642, -91.9458312988281, -1.60475748964781, 218, 57, 'PPL', 'P'),
(179972, 'Baxter', 39.2130584716797, 0.684396980107866, -120.779998779297, -2.10800864925346, 218, 6, 'PPL', 'P'),
(186390, 'Baxter', 38.2758293151855, 0.668039245481354, -104.491111755371, -1.82371393920058, 218, 7, 'PPL', 'P'),
(195935, 'Baxter', 47.1505584716797, 0.822932489484916, -109.438888549805, -1.91006893491721, 218, 31, 'PPL', 'P'),
(199163, 'Baxter', 41.8594398498535, 0.730585048420465, -103.47110748291, -1.80591150626172, 218, 35, 'PPL', 'P'),
(179973, 'Baxter (historical)', 35.0430603027344, 0.611616782257636, -116.288330078125, -2.02961424150924, 218, 6, 'PPL', 'P'),
(147049, 'Baxter Estates', 40.8347206115723, 0.712700323803929, -73.6958312988281, -1.28623490115884, 218, 40, 'PPL', 'P'),
(79686, 'Baxter Forks', 33.9738883972168, 0.592956212236532, -79.0177764892578, -1.37912036734251, 218, 48, 'PPL', 'P'),
(31751, 'Baxter Junction', 37.0286102294922, 0.646271165942292, -94.7461090087891, -1.65363155565683, 218, 20, 'PPL', 'P'),
(31752, 'Baxter Springs', 37.023609161377, 0.646183880837564, -94.7352828979492, -1.65344260437749, 218, 20, 'PPL', 'P'),
(6, 'Baxters', 31.7574996948242, 0.554272931875777, -85.5811080932617, -1.49367211373258, 218, 2, 'PPL', 'P'),
(58573, 'Baxterville', 31.083890914917, 0.542516240796054, -89.5902786254883, -1.56364533979387, 218, 30, 'PPL', 'P'),
(186391, 'Baxterville', 37.6741714477539, 0.657538334724145, -106.657218933105, -1.86151964140312, 218, 7, 'PPL', 'P'),
(7311, 'Bay', 35.7422218322754, 0.623819452951406, -90.5622177124023, -1.58060887698935, 218, 4, 'PPL', 'P'),
(19102, 'Bay', 31.1916694641113, 0.544397331342518, -83.9266662597656, -1.46479665645534, 218, 13, 'PPL', 'P'),
(53367, 'Bay', 38.5083312988281, 0.672097170613335, -91.5583267211914, -1.59799425890149, 218, 29, 'PPL', 'P'),
(202987, 'Bay', 40.6536102294922, 0.709539351327086, -111.836936950684, -1.95192277513474, 218, 52, 'PPL', 'P'),
(154207, 'Bay (historical)', 40.5541687011719, 0.707803769244682, -84.2780609130859, -1.47092965012969, 218, 41, 'PPL', 'P'),
(19103, 'Bay Branch', 32.0863914489746, 0.560013175868361, -81.975830078125, -1.43074814191868, 218, 13, 'PPL', 'P'),
(206781, 'Bay Center', 46.6316719055176, 0.81387621046102, -123.95361328125, -2.16339867150158, 218, 56, 'PPL', 'P'),
(206777, 'Bay Center Junction', 46.5991706848145, 0.813308957148833, -123.916938781738, -2.16275858073358, 218, 56, 'PPL', 'P'),
(15113, 'Bay City', 29.7563896179199, 0.51934697233896, -85.0205612182617, -1.48388872515207, 218, 12, 'PPL', 'P'),
(26460, 'Bay City', 37.2488899230957, 0.650115771870957, -88.4966735839844, -1.54455833110322, 218, 18, 'PPL', 'P'),
(44626, 'Bay City', 38.9669418334961, 0.680101434427623, -76.3427810668945, -1.3324328897465, 218, 25, 'PPL', 'P'),
(62749, 'Bay City', 35.1791687011719, 0.613992321949986, -76.7708282470703, -1.33990372239444, 218, 33, 'PPL', 'P'),
(112627, 'Bay City', 28.9825000762939, 0.505840051790837, -95.9691696166992, -1.67497799021631, 218, 51, 'PPL', 'P'),
(129697, 'Bay City', 43.5944404602051, 0.760866521595211, -83.8888931274414, -1.4641373909275, 218, 27, 'PPL', 'P'),
(173083, 'Bay City', 44.5855598449707, 0.778164818139711, -92.4502792358398, -1.61356176705355, 218, 57, 'PPL', 'P'),
(200381, 'Bay City', 45.5227813720703, 0.794522419608169, -123.888061523438, -2.16225457749729, 218, 43, 'PPL', 'P'),
(206778, 'Bay City', 46.8647193908691, 0.817943656393898, -124.058059692383, -2.16522160526774, 218, 56, 'PPL', 'P'),
(13326, 'Bay City Mobile Home Park', 38.6316719055176, 0.674249870301474, -75.133056640625, -1.3113192154663, 218, 10, 'PPL', 'P'),
(13327, 'Bay Colony', 38.586109161377, 0.673454650399976, -75.1444396972656, -1.31151788728362, 218, 10, 'PPL', 'P'),
(44627, 'Bay Colony', 38.3908309936523, 0.67004640341592, -75.1561126708984, -1.31172161910701, 218, 25, 'PPL', 'P'),
(99683, 'Bay Colony', 36.878059387207, 0.643643558052765, -76.0063934326172, -1.32656181796536, 218, 53, 'PPL', 'P'),
(147042, 'Bay Colony', 40.6294403076172, 0.709117506610418, -73.595832824707, -1.28448959853846, 218, 40, 'PPL', 'P'),
(44628, 'Bay Country', 38.7594413757324, 0.676479868240251, -76.6152801513672, -1.33718889597922, 218, 25, 'PPL', 'P'),
(44629, 'Bay Forest', 38.186939239502, 0.666487820988329, -76.3611068725586, -1.33275273539342, 218, 25, 'PPL', 'P'),
(79688, 'Bay Forest', 33.8633308410645, 0.591026618868715, -78.6619415283203, -1.37290987568045, 218, 48, 'PPL', 'P'),
(13328, 'Bay Harbor', 38.7052803039551, 0.675534579211328, -75.0986099243164, -1.31071800685021, 218, 10, 'PPL', 'P'),
(15116, 'Bay Harbor', 26.1505603790283, 0.45641337985562, -80.1180572509766, -1.39832388933086, 218, 12, 'PPL', 'P'),
(92493, 'Bay Harbor', 29.1272201538086, 0.508365893637209, -95.0683288574219, -1.65925535293075, 218, 51, 'PPL', 'P'),
(144794, 'Bay Harbor Estates', 40.0208282470703, 0.698495222286528, -74.1333312988281, -1.29387071663632, 218, 37, 'PPL', 'P'),
(15117, 'Bay Harbor Islands', 25.8872203826904, 0.451817229867334, -80.1313934326172, -1.39855664961013, 218, 12, 'PPL', 'P'),
(44630, 'Bay Harbour', 38.2611083984375, 0.667782317015189, -75.2558288574219, -1.31346199487937, 218, 25, 'PPL', 'P'),
(144795, 'Bay Head', 40.0716705322266, 0.699382587561742, -74.0547180175781, -1.29249865604271, 218, 37, 'PPL', 'P'),
(144796, 'Bay Head Junction', 40.0777816772461, 0.6994892471634, -74.04638671875, -1.29235324744719, 218, 37, 'PPL', 'P'),
(15131, 'Bay Heights', 25.7455596923828, 0.449344784400819, -80.2219390869141, -1.40013696940098, 218, 12, 'PPL', 'P'),
(15119, 'Bay Hill', 28.7099990844727, 0.501084012268605, -82.2399978637695, -1.43535873955588, 218, 12, 'PPL', 'P'),
(44631, 'Bay Hills', 39.0486106872559, 0.681526824822061, -76.482780456543, -1.33487634004665, 218, 25, 'PPL', 'P'),
(195936, 'Bay Horse', 45.0433311462402, 0.786154434568004, -105.566390991211, -1.84248110224431, 218, 31, 'PPL', 'P'),
(99682, 'Bay Island', 36.9088897705078, 0.644181649751016, -76.0491714477539, -1.32730843517697, 218, 53, 'PPL', 'P'),
(15122, 'Bay Lake', 28.3883304595947, 0.495469835664123, -81.5661087036133, -1.42359715491766, 218, 12, 'PPL', 'P'),
(134127, 'Bay Lake', 46.4094390869141, 0.809997516070401, -93.8736114501953, -1.63840360054376, 218, 28, 'PPL', 'P'),
(19104, 'Bay Meadows', 31.4597206115723, 0.54907570642946, -82.9166717529297, -1.447168926884, 218, 13, 'PPL', 'P'),
(129700, 'Bay Mills', 46.4372215270996, 0.810482411125877, -84.5838928222656, -1.47626742390253, 218, 27, 'PPL', 'P'),
(10, 'Bay Minette', 30.8827800750732, 0.53900619447933, -87.773063659668, -1.53192895542379, 218, 2, 'PPL', 'P'),
(92494, 'Bay Oaks', 29.6416702270508, 0.517344741252411, -95.0166702270508, -1.6583537397437, 218, 51, 'PPL', 'P'),
(129702, 'Bay Park', 43.6547203063965, 0.761918603383846, -83.5891723632813, -1.45890627675631, 218, 27, 'PPL', 'P'),
(147043, 'Bay Park', 40.6330604553223, 0.70918069010728, -73.6708297729492, -1.28579854221423, 218, 40, 'PPL', 'P'),
(179974, 'Bay Park', 32.7816696166992, 0.572148069112389, -117.205558776855, -2.04562290229587, 218, 6, 'PPL', 'P'),
(200382, 'Bay Park', 43.3491706848145, 0.756585756459017, -124.200561523438, -2.16770873140977, 218, 43, 'PPL', 'P'),
(15123, 'Bay Pines', 27.8138904571533, 0.485443966266356, -82.7783279418945, -1.44475437188168, 218, 12, 'PPL', 'P'),
(79689, 'Bay Pines', 32.1716690063477, 0.561501550022579, -80.7750015258789, -1.40978972993003, 218, 48, 'PPL', 'P'),
(7312, 'Bay Plantation', 34.9655609130859, 0.610264162739984, -91.3838882446289, -1.59494973314332, 218, 4, 'PPL', 'P'),
(15124, 'Bay Point', 24.6263904571533, 0.429811596359037, -81.5924987792969, -1.42405774862818, 218, 12, 'PPL', 'P'),
(126839, 'Bay Point', 43.7563896179199, 0.763693067618166, -69.7752838134766, -1.21780843905867, 218, 26, 'PPL', 'P'),
(147044, 'Bay Point', 41.0033302307129, 0.715643116808466, -72.315559387207, -1.26214461172826, 218, 40, 'PPL', 'P'),
(179975, 'Bay Point', 38.0291709899902, 0.663734245579241, -121.960563659668, -2.12861339344935, 218, 6, 'PPL', 'P'),
(179976, 'Bay Point (historical)', 38.0458297729492, 0.664024996191251, -122.028610229492, -2.12980103013747, 218, 6, 'PPL', 'P'),
(147045, 'Bay Pond', 44.4313888549805, 0.775474026753323, -74.4122161865234, -1.29873817616065, 218, 40, 'PPL', 'P'),
(129703, 'Bay Port', 43.8494415283203, 0.765317129829924, -83.3733291625977, -1.45513910223634, 218, 27, 'PPL', 'P'),
(15125, 'Bay Ridge', 28.7563896179199, 0.501893679819017, -81.5599975585938, -1.423490495316, 218, 12, 'PPL', 'P'),
(44633, 'Bay Ridge', 39.6952781677246, 0.692813301521816, -76.3369369506836, -1.33233089067675, 218, 25, 'PPL', 'P'),
(99684, 'Bay Ridge', 37.211109161377, 0.649456373185054, -76.0105590820313, -1.32663452226312, 218, 53, 'PPL', 'P'),
(147046, 'Bay Ridge', 40.6338882446289, 0.709195137756193, -74.0149993896484, -1.29180543521096, 218, 40, 'PPL', 'P'),
(44634, 'Bay Ridge Junction', 38.9786109924316, 0.680305099671987, -76.5047225952148, -1.3352593026114, 218, 25, 'PPL', 'P'),
(58574, 'Bay Saint Louis', 30.3086109161377, 0.528985052192498, -89.3300018310547, -1.55910265276447, 218, 30, 'PPL', 'P'),
(173085, 'Bay Settlement', 44.5530586242676, 0.777597564827524, -87.8905563354492, -1.53397958946315, 218, 57, 'PPL', 'P'),
(70505, 'Bay Shore', 39.9508285522461, 0.697273497136454, -74.1136093139648, -1.29352650306542, 218, 37, 'PPL', 'P'),
(129704, 'Bay Shore', 45.3583297729492, 0.791652197743336, -85.0972213745117, -1.48522669728372, 218, 27, 'PPL', 'P'),
(147047, 'Bay Shore', 40.7249984741211, 0.71078531124308, -73.2458267211914, -1.27838083963003, 218, 40, 'PPL', 'P'),
(44635, 'Bay Shore Acres', 38.3427810668945, 0.669207773988654, -75.103889465332, -1.31081015222393, 218, 25, 'PPL', 'P'),
(13329, 'Bay Shore Hills', 38.6949996948242, 0.675355148732884, -75.1449966430664, -1.31152760782159, 218, 10, 'PPL', 'P'),
(13330, 'Bay Shore Mobile Home Park', 38.5761108398438, 0.673280146769548, -75.0844421386719, -1.310470732343, 218, 10, 'PPL', 'P'),
(92495, 'Bay Shore Park', 29.6583309173584, 0.517635525153934, -95.0041732788086, -1.65813562685043, 218, 51, 'PPL', 'P'),
(44636, 'Bay Shore Park (historical)', 39.2075004577637, 0.68429997446516, -76.4274978637695, -1.33391147678371, 218, 25, 'PPL', 'P'),
(79690, 'Bay Shores', 34.7236099243164, 0.6060413213575, -82.8647232055664, -1.44626225369088, 218, 48, 'PPL', 'P'),
(147048, 'Bay Shores', 42.8622207641602, 0.748086877051275, -76.2744369506836, -1.33124005989425, 218, 40, 'PPL', 'P'),
(179977, 'Bay Shores', 33.6147193908691, 0.586687530504649, -117.910003662109, -2.05791778494238, 218, 6, 'PPL', 'P'),
(70507, 'Bay Side', 39.6686096191406, 0.692347847542298, -74.2136077880859, -1.29527180568581, 218, 37, 'PPL', 'P'),
(169274, 'Bay Spring', 41.7480583190918, 0.728641073982761, -71.3472213745117, -1.2452439251345, 218, 47, 'PPL', 'P'),
(16, 'Bay Springs', 34.1758308410645, 0.596480772781198, -85.7155609130859, -1.49601875812711, 218, 2, 'PPL', 'P'),
(15126, 'Bay Springs', 30.7733306884766, 0.537095942318929, -87.4791717529297, -1.52679957400624, 218, 12, 'PPL', 'P'),
(58575, 'Bay Springs', 31.978889465332, 0.558136912301373, -89.2872161865234, -1.55835590239481, 218, 30, 'PPL', 'P'),
(79692, 'Bay Springs', 33.899169921875, 0.591652128829748, -80.4097213745117, -1.40341438859649, 218, 48, 'PPL', 'P'),
(124192, 'Bay State', 42.3222198486328, 0.738662083111539, -72.6638870239258, -1.26822407586469, 218, 23, 'PPL', 'P'),
(44637, 'Bay Terrace', 38.5502815246582, 0.672829340176025, -76.5622177124023, -1.33626278171014, 218, 25, 'PPL', 'P'),
(18, 'Bay View', 33.5586090087891, 0.5857082195928, -86.9736099243164, -1.51797585552454, 218, 2, 'PPL', 'P'),
(15127, 'Bay View', 30.4594402313232, 0.531617520351014, -86.1772232055664, -1.5040762851632, 218, 12, 'PPL', 'P'),
(44638, 'Bay View', 39.6433296203613, 0.691906628328699, -75.961669921875, -1.32578124544986, 218, 25, 'PPL', 'P'),
(84853, 'Bay View', 35.7611083984375, 0.624149085715331, -84.6425018310547, -1.47729034407723, 218, 50, 'PPL', 'P'),
(124193, 'Bay View', 42.6699981689453, 0.744731959868047, -70.665283203125, -1.23334185874878, 218, 23, 'PPL', 'P'),
(126840, 'Bay View', 43.4877815246582, 0.759004971993245, -70.3874969482422, -1.22849357398429, 218, 26, 'PPL', 'P'),
(129705, 'Bay View', 45.3855590820313, 0.79212743883986, -84.9302825927734, -1.48231306589312, 218, 27, 'PPL', 'P'),
(147052, 'Bay View', 41.0411109924316, 0.71630251549437, -72.4211120605469, -1.26398685341232, 218, 40, 'PPL', 'P'),
(154209, 'Bay View', 41.4324989318848, 0.723133523690423, -82.960563659668, -1.44793498517156, 218, 41, 'PPL', 'P'),
(173086, 'Bay View', 44.6327781677246, 0.778988933339036, -87.7441711425781, -1.53142468587138, 218, 57, 'PPL', 'P'),
(206780, 'Bay View', 48.4838905334473, 0.846203523985165, -122.476387023926, -2.13761620951436, 218, 56, 'PPL', 'P'),
(99685, 'Bay View Beach', 36.9388885498047, 0.644705227221325, -76.2358322143555, -1.33056628013846, 218, 53, 'PPL', 'P'),
(13331, 'Bay View Estates', 38.4561080932617, 0.671185703730256, -75.129997253418, -1.31126581908644, 218, 10, 'PPL', 'P'),
(44639, 'Bay View Estates', 39.4249992370605, 0.688096044282959, -75.9991683959961, -1.32643571728775, 218, 25, 'PPL', 'P'),
(118740, 'Bay View Garden', 40.8088912963867, 0.712249517210405, -89.5205612182617, -1.56242854149181, 218, 18, 'PPL', 'P'),
(13332, 'Bay View Heights', 39.0547218322754, 0.681633484423718, -75.4019393920898, -1.31601210478118, 218, 10, 'PPL', 'P'),
(44641, 'Bay View Mobile Home Park', 39.4447212219238, 0.688440257853852, -76.2844390869141, -1.33141463010371, 218, 25, 'PPL', 'P'),
(13333, 'Bay View Park', 38.5074996948242, 0.672082656385394, -75.0597229003906, -1.3100393002464, 218, 10, 'PPL', 'P'),
(7313, 'Bay Village', 35.4497184753418, 0.618714306299779, -90.6758270263672, -1.58259173357897, 218, 4, 'PPL', 'P'),
(124194, 'Bay Village', 42.3505592346191, 0.739156698704994, -71.0702819824219, -1.24041042091406, 218, 23, 'PPL', 'P'),
(154210, 'Bay Village', 41.4847183227539, 0.724044923994475, -81.9222183227539, -1.42981244026968, 218, 41, 'PPL', 'P'),
(13334, 'Bay Vista', 38.6972198486328, 0.675393897726744, -75.0980606079102, -1.31070841947029, 218, 10, 'PPL', 'P'),
(147053, 'Bay Wood', 40.75, 0.711221670187689, -73.2916717529297, -1.27918098637955, 218, 40, 'PPL', 'P'),
(360, 'Bayard', 38.5002784729004, 0.671956622286806, -75.1319427490234, -1.31129977439034, 218, 10, 'PPL', 'P'),
(15128, 'Bayard', 30.1433296203613, 0.526100349389238, -81.5130615234375, -1.42267130696469, 218, 12, 'PPL', 'P'),
(31754, 'Bayard', 37.9936103820801, 0.663113595887198, -95.1627807617188, -1.66090384964551, 218, 20, 'PPL', 'P'),
(108111, 'Bayard', 39.2727813720703, 0.685439341358523, -79.3647232055664, -1.38517572987108, 218, 58, 'PPL', 'P'),
(114522, 'Bayard', 41.8519401550293, 0.730454154052887, -94.5580596923828, -1.65034947592942, 218, 16, 'PPL', 'P'),
(154213, 'Bayard', 40.750560760498, 0.711231457304695, -81.0650024414063, -1.41485120073978, 218, 41, 'PPL', 'P'),
(188119, 'Bayard', 32.7616691589355, 0.571798995272507, -108.129997253418, -1.88722447224457, 218, 38, 'PPL', 'P'),
(199164, 'Bayard', 41.7550010681152, 0.72876224781236, -103.323608398438, -1.803337161594, 218, 35, 'PPL', 'P'),
(19105, 'Bayard (historical)', 32.6736106872559, 0.570262085007422, -84.9069366455078, -1.48190560224634, 218, 13, 'PPL', 'P'),
(199828, 'Bayard (historical)', 41.6980590820313, 0.72776842267257, -115.509170532227, -2.01601534203496, 218, 39, 'PPL', 'P'),
(44642, 'Bayberry', 39.0613899230957, 0.681749864563355, -76.4736099243164, -1.33471628406513, 218, 25, 'PPL', 'P'),
(62751, 'Bayberry Bluffs', 36.1708297729492, 0.631300072716357, -75.753059387207, -1.32214030476556, 218, 33, 'PPL', 'P'),
(13335, 'Bayberry Dunes', 38.5713882446289, 0.67319772193381, -75.0605621337891, -1.3100539476324, 218, 10, 'PPL', 'P'),
(147055, 'Bayberry Dunes', 40.6897201538086, 0.710169588399054, -72.9897232055664, -1.27391099005644, 218, 40, 'PPL', 'P'),
(147056, 'Bayberry Park', 40.9466705322266, 0.714654218516692, -73.7744369506836, -1.28760682859439, 218, 40, 'PPL', 'P'),
(62752, 'Bayboro', 35.1427803039551, 0.61335722460903, -76.7705612182617, -1.33989906186254, 218, 33, 'PPL', 'P'),
(79693, 'Bayboro', 34.0094413757324, 0.593576728770521, -79.0224990844727, -1.37920279217825, 218, 48, 'PPL', 'P'),
(19106, 'Bayboro (historical)', 31.1658306121826, 0.543946358301427, -83.5680618286133, -1.4585378284195, 218, 13, 'PPL', 'P'),
(147057, 'Baychester', 40.8611106872559, 0.713160917514458, -73.841667175293, -1.28878021737068, 218, 40, 'PPL', 'P'),
(154214, 'Bayer Trailer Court', 41.5394401550293, 0.725000000140405, -83.581672668457, -1.45877538238873, 218, 41, 'PPL', 'P'),
(122197, 'Bayfield', 41.2747192382813, 0.720379748544254, -85.7069396972656, -1.49586828952552, 218, 19, 'PPL', 'P'),
(173087, 'Bayfield', 46.8108291625977, 0.817003094475909, -90.8180618286133, -1.58507419918908, 218, 57, 'PPL', 'P'),
(186392, 'Bayfield', 37.2255592346191, 0.649708574540284, -107.597503662109, -1.87793070583046, 218, 7, 'PPL', 'P'),
(53368, 'Bayfield (historical)', 39.7819404602051, 0.694325843862927, -94.595832824707, -1.65100874145727, 218, 29, 'PPL', 'P'),
(99686, 'Bayford', 37.4777793884277, 0.654110646664131, -75.9330596923828, -1.32528190274547, 218, 53, 'PPL', 'P'),
(79694, 'Bayfront', 32.7419395446777, 0.57145464854356, -79.9636077880859, -1.39562823767548, 218, 48, 'PPL', 'P'),
(193365, 'Bayha (historical)', 40.7297210693359, 0.710867736078818, -122.321113586426, -2.1349061767891, 218, 6, 'PPL', 'P'),
(15129, 'Bayhead', 30.3072204589844, 0.528960784137064, -85.5819396972656, -1.49368662796052, 218, 12, 'PPL', 'P'),
(44644, 'Bayhead', 39.042781829834, 0.68142509206842, -76.4244384765625, -1.33385808040385, 218, 25, 'PPL', 'P'),
(194562, 'Bayhorse', 44.3977813720703, 0.774887465523233, -114.310829162598, -1.99510033957208, 218, 17, 'PPL', 'P'),
(99687, 'Baylake Beach', 36.9111099243164, 0.644220398744876, -76.1080627441406, -1.32833628219968, 218, 53, 'PPL', 'P'),
(99688, 'Baylake Pines', 36.9086112976074, 0.644176789482026, -76.1155624389648, -1.32846717656726, 218, 53, 'PPL', 'P'),
(58576, 'Bayland', 32.8872184753418, 0.573990244217424, -90.658332824707, -1.58228640215999, 218, 30, 'PPL', 'P'),
(26461, 'Bayle City', 39.1138916015625, 0.682666191715424, -89.1661071777344, -1.55624215143761, 218, 18, 'PPL', 'P'),
(62753, 'Bayleaf', 35.9438896179199, 0.627339219806109, -78.6430587768555, -1.37258030949555, 218, 33, 'PPL', 'P'),
(193361, 'Bayles Place', 40.1494407653809, 0.700739934190328, -122.640556335449, -2.14048150453118, 218, 6, 'PPL', 'P'),
(298, 'Bayless', 34.8244400024414, 0.607801138205825, -91.2244415283203, -1.59216686296224, 218, 4, 'PPL', 'P'),
(84854, 'Bayless (historical)', 36.1736106872559, 0.631348608827224, -83.9444427490234, -1.46510691472234, 218, 50, 'PPL', 'P'),
(26462, 'Baylestown', 39.0913887023926, 0.682273442033664, -89.8794403076172, -1.56869216321762, 218, 18, 'PPL', 'P'),
(193362, 'Bayley (historical)', 41.288890838623, 0.720627089630495, -120.537216186523, -2.10377129364304, 218, 6, 'PPL', 'P'),
(20, 'Bayleys Corner', 30.4647197723389, 0.531709665724731, -88.1144409179688, -1.53788711257257, 218, 2, 'PPL', 'P'),
(99689, 'Bayleys Neck Farm', 37.4652786254883, 0.653892467191826, -75.915283203125, -1.32497164447848, 218, 53, 'PPL', 'P'),
(26463, 'Baylis', 39.728328704834, 0.693390142213927, -90.9080581665039, -1.58664493160001, 218, 18, 'PPL', 'P'),
(179978, 'Bayliss', 39.5827789306641, 0.690849819429128, -122.044723510742, -2.13008225994858, 218, 6, 'PPL', 'P'),
(195938, 'Baylor', 48.663330078125, 0.849335334848071, -106.478889465332, -1.85840720503715, 218, 31, 'PPL', 'P'),
(108113, 'Baylor (historical)', 37.7588882446289, 0.659016921761357, -81.2941665649414, -1.41885086922292, 218, 58, 'PPL', 'P'),
(99690, 'Baylortown', 38.0997200012207, 0.664965558109239, -77.3244400024414, -1.34956607030341, 218, 53, 'PPL', 'P'),
(62755, 'Baymount Meadows', 35.8450012207031, 0.625613291682656, -80.831672668457, -1.41077882795889, 218, 33, 'PPL', 'P'),
(44645, 'Baynard', 38.8455581665039, 0.677982889780465, -76.6774978637695, -1.3382747999137, 218, 25, 'PPL', 'P'),
(139650, 'Bayne', 46.1674995422363, 0.805774874424999, -96.9274978637695, -1.69170397344255, 218, 34, 'PPL', 'P'),
(206782, 'Bayne', 47.295280456543, 0.825458364620802, -121.908332824707, -2.12770179340822, 218, 56, 'PPL', 'P'),
(206783, 'Bayne Junction', 47.3011093139648, 0.825560097374443, -121.907501220703, -2.12768727918028, 218, 56, 'PPL', 'P'),
(62756, 'Baynes', 36.2688903808594, 0.633011553190896, -79.3050003051758, -1.38413336862043, 218, 33, 'PPL', 'P'),
(44646, 'Baynesville', 39.4000015258789, 0.687659751917377, -76.5622177124023, -1.33626278171014, 218, 25, 'PPL', 'P'),
(99691, 'Baynesville', 38.1477813720703, 0.665804387273587, -76.8827819824219, -1.34185768368623, 218, 53, 'PPL', 'P'),
(31755, 'Bayneville', 37.5541687011719, 0.655443891684852, -97.4436111450195, -1.70071184951363, 218, 20, 'PPL', 'P'),
(79695, 'Baynham (historical)', 33.7041702270508, 0.588248742114681, -81.7938919067383, -1.42757272179293, 218, 48, 'PPL', 'P'),
(179979, 'Bayo Vista', 38.0369415283203, 0.663869867057753, -122.260276794434, -2.13384437446248, 218, 6, 'PPL', 'P'),
(200383, 'Bayocean (historical)', 45.5277786254883, 0.794609638133869, -123.951110839844, -2.16335499565971, 218, 43, 'PPL', 'P'),
(15130, 'Bayonet Point', 28.3263893127441, 0.494388758709119, -82.6836090087891, -1.44310121463501, 218, 12, 'PPL', 'P'),
(144798, 'Bayonne', 40.6686096191406, 0.709801140062241, -74.1147232055664, -1.29354594414138, 218, 37, 'PPL', 'P'),
(199165, 'Bayonne', 42.7855606079102, 0.746748904919619, -101.97721862793, -1.77983822708347, 218, 35, 'PPL', 'P'),
(34703, 'Bayou', 37.2447204589844, 0.650043000994171, -88.4749984741211, -1.54418002907037, 218, 21, 'PPL', 'P'),
(39249, 'Bayou Barbary', 30.3408298492432, 0.529547378656668, -90.6736068725586, -1.58255298458511, 218, 22, 'PPL', 'P'),
(39251, 'Bayou Boeuf', 29.8691692352295, 0.521315347990151, -90.5966720581055, -1.58121021876349, 218, 22, 'PPL', 'P'),
(39254, 'Bayou Cane', 29.6238899230957, 0.51703441640639, -90.751106262207, -1.58390560410276, 218, 22, 'PPL', 'P'),
(39255, 'Bayou Chene', 30.1408290863037, 0.526056706836874, -91.5369415283203, -1.59762101687472, 218, 22, 'PPL', 'P'),
(39256, 'Bayou Chicot', 30.8169403076172, 0.537857073758474, -92.350830078125, -1.61182605181309, 218, 22, 'PPL', 'P'),
(39257, 'Bayou Corne', 30.014440536499, 0.523850810505961, -91.1549987792969, -1.59095485835014, 218, 22, 'PPL', 'P'),
(39258, 'Bayou Crab', 29.8672199249268, 0.521281326107226, -91.0761108398438, -1.58957800406657, 218, 22, 'PPL', 'P'),
(15133, 'Bayou Crossing', 30.7641696929932, 0.536936052784984, -85.9002838134766, -1.49924278094276, 218, 12, 'PPL', 'P'),
(39259, 'Bayou Current', 30.7975006103516, 0.537517787035598, -91.8016662597656, -1.6022413350499, 218, 22, 'PPL', 'P'),
(39260, 'Bayou Fountain', 30.3652801513672, 0.52997411693184, -91.1286087036133, -1.59049426463961, 218, 22, 'PPL', 'P'),
(39261, 'Bayou Gauche', 29.7872200012207, 0.519885064037211, -90.4130630493164, -1.5780056370238, 218, 22, 'PPL', 'P'),
(39262, 'Bayou Geneve', 29.8161106109619, 0.520389300300103, -91.1041717529297, -1.59006775939104, 218, 22, 'PPL', 'P'),
(15132, 'Bayou George', 30.2625007629395, 0.528180278200589, -85.5400009155273, -1.49295465813492, 218, 12, 'PPL', 'P'),
(39263, 'Bayou Goula', 30.2097206115723, 0.527259090779531, -91.1688919067383, -1.59119733916739, 218, 22, 'PPL', 'P'),
(39264, 'Bayou Jack', 30.8380603790283, 0.538225688542855, -91.9636077880859, -1.6050677479148, 218, 22, 'PPL', 'P'),
(22, 'Bayou La Batre', 30.4166698455811, 0.530871036297465, -88.2249984741211, -1.53981670594039, 218, 2, 'PPL', 'P'),
(7315, 'Bayou Macon (historical)', 33.3180618286133, 0.581509879292344, -91.3238906860352, -1.5939025782027, 218, 4, 'PPL', 'P'),
(7318, 'Bayou Meto', 34.708610534668, 0.605779532622346, -91.8713912963867, -1.60345826651001, 218, 4, 'PPL', 'P'),
(39269, 'Bayou Paul', 30.311939239502, 0.529043142393775, -91.1091690063477, -1.59015497791674, 218, 22, 'PPL', 'P'),
(39271, 'Bayou Pierre', 32.1483306884766, 0.561094219533852, -93.4800033569336, -1.63153384335384, 218, 22, 'PPL', 'P'),
(39272, 'Bayou Sale', 29.7438907623291, 0.519128826156169, -91.4361114501953, -1.5958612000264, 218, 22, 'PPL', 'P'),
(39273, 'Bayou Scie', 31.670280456543, 0.552750668996688, -93.5733337402344, -1.63316276583459, 218, 22, 'PPL', 'P'),
(39274, 'Bayou Sorrel', 30.1616706848145, 0.526420461352265, -91.335563659668, -1.59410631002609, 218, 22, 'PPL', 'P'),
(39277, 'Bayou Vista', 29.6894397735596, 0.518178477121174, -91.2708282470703, -1.59297646393362, 218, 22, 'PPL', 'P'),
(92506, 'Bayou Vista', 29.3261108398438, 0.511837190960073, -94.9383316040039, -1.65698647284006, 218, 51, 'PPL', 'P'),
(53369, 'Bayouville', 36.6511116027832, 0.639682571984463, -89.3641662597656, -1.55969893453254, 218, 29, 'PPL', 'P'),
(15140, 'Bayport', 28.545560836792, 0.498214023430368, -82.642219543457, -1.44237883218933, 218, 12, 'PPL', 'P'),
(99692, 'Bayport', 37.7544403076172, 0.658939290615581, -76.6738891601563, -1.33821181615392, 218, 53, 'PPL', 'P'),
(134129, 'Bayport', 45.0213890075684, 0.78577147200325, -92.7808303833008, -1.61933097292299, 218, 28, 'PPL', 'P'),
(147058, 'Bayport', 40.7383308410645, 0.711018004943325, -73.0511093139648, -1.27498237976298, 218, 40, 'PPL', 'P'),
(129708, 'Bayport Park', 42.8541717529297, 0.747946395303773, -83.7177810668945, -1.46115092208108, 218, 27, 'PPL', 'P'),
(92497, 'Bayridge Park', 29.6655597686768, 0.517761692410577, -95.0083312988281, -1.65820819799013, 218, 51, 'PPL', 'P'),
(34705, 'Bays', 37.646110534668, 0.657048579399679, -83.246940612793, -1.45293320590542, 218, 21, 'PPL', 'P'),
(154215, 'Bays', 41.2688903808594, 0.720278015790613, -83.6697235107422, -1.46031215949576, 218, 41, 'PPL', 'P'),
(34704, 'Bays Branch', 37.7227783203125, 0.658386684689389, -82.7680587768555, -1.44457514114032, 218, 21, 'PPL', 'P'),
(108116, 'Bays Heights', 37.9997215270996, 0.663220255488856, -81.1661071777344, -1.41661581127807, 218, 58, 'PPL', 'P'),
(84856, 'Bays Mountain Estates', 35.8555603027344, 0.62579758243009, -83.8050003051758, -1.46267318496017, 218, 50, 'PPL', 'P'),
(15135, 'Bayshore', 25.8286094665527, 0.450794276403121, -80.1855621337891, -1.39950207179711, 218, 12, 'PPL', 'P'),
(62757, 'Bayshore', 34.2894401550293, 0.598463629370816, -77.7877807617188, -1.35765289211149, 218, 33, 'PPL', 'P'),
(154216, 'Bayshore', 41.4194412231445, 0.722905623680139, -82.934440612793, -1.44747905199294, 218, 41, 'PPL', 'P'),
(200384, 'Bayshore', 44.4388885498047, 0.7756049211209, -124.073608398438, -2.16549298138282, 218, 43, 'PPL', 'P'),
(206784, 'Bayshore', 47.2463912963867, 0.82460508780754, -123.044998168945, -2.14754034615849, 218, 56, 'PPL', 'P'),
(44647, 'Bayshore (historical)', 39.2150001525879, 0.684430868832737, -76.4208297729492, -1.33379509664407, 218, 25, 'PPL', 'P'),
(15136, 'Bayshore Gardens', 27.4249992370605, 0.478656534043639, -82.5905609130859, -1.44147721900228, 218, 12, 'PPL', 'P'),
(15137, 'Bayshore Manor', 26.6766700744629, 0.465595726267618, -81.8647232055664, -1.42880896117094, 218, 12, 'PPL', 'P'),
(29, 'Bayside', 30.4083309173584, 0.530725494543892, -87.8236083984375, -1.53281112753488, 218, 2, 'PPL', 'P'),
(84857, 'Bayside', 35.7486114501953, 0.623930972822053, -84.6611099243164, -1.47761511657217, 218, 50, 'PPL', 'P'),
(92498, 'Bayside', 28.0936107635498, 0.490326006597662, -97.2144393920898, -1.69671204787244, 218, 51, 'PPL', 'P'),
(99696, 'Bayside', 38.1055603027344, 0.665067490599962, -76.6530609130859, -1.33784829466512, 218, 53, 'PPL', 'P'),
(124195, 'Bayside', 42.2999992370605, 0.738274260277796, -70.8833312988281, -1.2371475159465, 218, 23, 'PPL', 'P'),
(126842, 'Bayside', 44.3797187805176, 0.774572213829194, -68.9691696166992, -1.20373909217784, 218, 26, 'PPL', 'P'),
(143501, 'Bayside', 43.0513916015625, 0.7513885310127, -70.8680572509766, -1.23688093352138, 218, 36, 'PPL', 'P'),
(147059, 'Bayside', 40.7683296203613, 0.711541582413635, -73.7774963378906, -1.28766022497425, 218, 40, 'PPL', 'P'),
(169275, 'Bayside', 41.7011108398438, 0.727821685894371, -71.3766708374023, -1.24575791522489, 218, 47, 'PPL', 'P'),
(173091, 'Bayside', 43.1805610656738, 0.75364296345448, -87.9005584716797, -1.53415415967261, 218, 57, 'PPL', 'P'),
(193363, 'Bayside', 40.8424987792969, 0.712836078440495, -124.0625, -2.16529910325547, 218, 6, 'PPL', 'P'),
(44649, 'Bayside Beach', 39.1363906860352, 0.683058874818156, -76.4436111450195, -1.33419270659482, 218, 25, 'PPL', 'P'),
(70508, 'Bayside Beach', 39.8202781677246, 0.694994963086809, -74.1811065673828, -1.29470455237362, 218, 37, 'PPL', 'P'),
(124196, 'Bayside Beach', 41.8666687011719, 0.730711215677107, -70.5322189331055, -1.23101944912017, 218, 23, 'PPL', 'P'),
(200385, 'Bayside Gardens', 45.7138900756836, 0.797857895715439, -123.913887023926, -2.16270531751178, 218, 43, 'PPL', 'P'),
(13336, 'Bayside Hamlet', 38.5811080932617, 0.673367365295249, -75.0769424438477, -1.31033983797542, 218, 10, 'PPL', 'P'),
(58577, 'Bayside Park', 30.2824993133545, 0.528529318750958, -89.4366683959961, -1.56096433552449, 218, 30, 'PPL', 'P'),
(99697, 'Bayside Park', 38.6377792358398, 0.674356463324104, -77.2444381713867, -1.34816977494389, 218, 53, 'PPL', 'P'),
(92499, 'Bayside Terrace', 29.6269397735596, 0.517087646338678, -95.0136108398438, -1.65830034336385, 218, 51, 'PPL', 'P'),
(44651, 'Bayside Village', 39.4958305358887, 0.689332283660974, -76.1427764892578, -1.32894215134768, 218, 25, 'PPL', 'P'),
(179980, 'Bayside Village', 32.7813911437988, 0.5721432088434, -117.202499389648, -2.04556950591601, 218, 6, 'PPL', 'P'),
(92500, 'Baytown', 29.735279083252, 0.518978524002148, -94.9772186279297, -1.65766517944386, 218, 51, 'PPL', 'P'),
(19107, 'Bayvale', 33.4483299255371, 0.583783486493972, -82.0519409179688, -1.43207652667041, 218, 13, 'PPL', 'P'),
(15139, 'Bayview', 27.9594402313232, 0.487984289051156, -82.7111129760742, -1.4435812494215, 218, 12, 'PPL', 'P'),
(62761, 'Bayview', 35.4366683959961, 0.61848653944755, -76.7922210693359, -1.34027709757927, 218, 33, 'PPL', 'P'),
(84860, 'Bayview', 35.8569412231445, 0.625821684037955, -83.8125, -1.46280407932775, 218, 50, 'PPL', 'P'),
(92502, 'Bayview', 29.514720916748, 0.515129057804493, -95.0041732788086, -1.65813562685043, 218, 51, 'PPL', 'P'),
(99698, 'Bayview', 37.276668548584, 0.650600600347406, -75.9677810668945, -1.32588790505152, 218, 53, 'PPL', 'P'),
(124197, 'Bayview', 41.5736083984375, 0.725596348487501, -70.9499969482422, -1.23831105102676, 218, 23, 'PPL', 'P'),
(134133, 'Bayview', 46.7472190856934, 0.815892889196482, -92.1952819824219, -1.60911122539787, 218, 28, 'PPL', 'P'),
(147061, 'Bayview', 44.0552787780762, 0.768909667561413, -76.2594375610352, -1.3309782711591, 218, 40, 'PPL', 'P'),
(177481, 'Bayview', 41.2122192382813, 0.719288917761757, -73.0305633544922, -1.2746237851222, 218, 8, 'PPL', 'P'),
(193364, 'Bayview', 40.7727813720703, 0.711619280138438, -124.182777404785, -2.16739833998472, 218, 6, 'PPL', 'P'),
(194563, 'Bayview', 47.980281829834, 0.837413893965413, -116.559173583984, -2.03434135244413, 218, 17, 'PPL', 'P'),
(200386, 'Bayview', 44.4425010681152, 0.775667971459708, -124.033889770508, -2.16479976055108, 218, 43, 'PPL', 'P'),
(206785, 'Bayview', 47.2797203063965, 0.825186788768641, -122.604438781738, -2.13985113430116, 218, 56, 'PPL', 'P'),
(44653, 'Bayview (historical)', 38.0872192382813, 0.664747378636935, -75.3744430541992, -1.31553220315275, 218, 25, 'PPL', 'P'),
(92503, 'Bayview Estates Colonia', 28.0139999389648, 0.488936535588427, -97.2170028686523, -1.69675678897876, 218, 51, 'PPL', 'P'),
(70509, 'Bayview Harbors', 39.9636116027832, 0.697496603456775, -74.1208267211914, -1.29365247058498, 218, 37, 'PPL', 'P'),
(13337, 'Bayview Manor', 39.6388893127441, 0.691829130340978, -75.6125030517578, -1.31968713392743, 218, 10, 'PPL', 'P'),
(44655, 'Bayview Manor Mobile Home Park', 38.5972213745117, 0.673648595106361, -76.517219543457, -1.33547741550468, 218, 25, 'PPL', 'P'),
(13338, 'Bayville', 38.4683303833008, 0.671399022933571, -75.0891723632813, -1.31055329033679, 218, 10, 'PPL', 'P'),
(70510, 'Bayville', 39.9091682434082, 0.696546387579835, -74.1552810668945, -1.29425381235912, 218, 37, 'PPL', 'P'),
(99699, 'Bayville', 36.9033317565918, 0.644084644108309, -76.1180572509766, -1.32851071925108, 218, 53, 'PPL', 'P'),
(126843, 'Bayville', 43.8597183227539, 0.765496493729341, -69.6033325195313, -1.21480732282626, 218, 26, 'PPL', 'P'),
(147062, 'Bayville', 40.9105606079102, 0.714023981444725, -73.5625, -1.28390783099833, 218, 40, 'PPL', 'P'),
(99700, 'Bayville Park', 36.9022216796875, 0.644065269611379, -76.1241683959961, -1.32861737885274, 218, 53, 'PPL', 'P'),
(44656, 'Baywalker Village', 38.7733306884766, 0.676722282478476, -76.5758285522461, -1.33650033567938, 218, 25, 'PPL', 'P'),
(15141, 'Bayway', 27.7124996185303, 0.483674362301026, -82.6972198486328, -1.44333876860425, 218, 12, 'PPL', 'P'),
(144800, 'Bayway', 40.6388893127441, 0.709282422860921, -74.2127838134766, -1.29525742461592, 218, 37, 'PPL', 'P'),
(15142, 'Baywood', 29.7188892364502, 0.518692467211559, -81.8163909912109, -1.42796540489566, 218, 12, 'PPL', 'P'),
(39279, 'Baywood', 30.6908302307129, 0.535656037696551, -90.883056640625, -1.5862085726554, 218, 22, 'PPL', 'P'),
(62762, 'Baywood', 35.5466690063477, 0.620406412277388, -77.3908309936523, -1.35072481169371, 218, 33, 'PPL', 'P'),
(99701, 'Baywood', 36.610279083252, 0.638969910076758, -81.0122222900391, -1.41393001331872, 218, 53, 'PPL', 'P'),
(144801, 'Baywood', 40.0227813720703, 0.698529310748481, -74.0894393920898, -1.29310465834875, 218, 37, 'PPL', 'P'),
(44657, 'Baywood Manor', 39.2397193908691, 0.68486230092933, -76.1675033569336, -1.32937371660233, 218, 25, 'PPL', 'P'),
(179983, 'Baywood Park', 35.3263893127441, 0.616561806348722, -120.834167480469, -2.10895407144044, 218, 6, 'PPL', 'P'),
(31756, 'Bazaar', 38.2719383239746, 0.667971334873557, -96.5350036621094, -1.68485365732859, 218, 20, 'PPL', 'P'),
(84859, 'Bazel Town', 35.9619407653809, 0.627654271763066, -84.5336074829102, -1.4753897791653, 218, 50, 'PPL', 'P'),
(28, 'Bazemore', 33.8944396972656, 0.591569570835955, -87.6999969482422, -1.53065370073581, 218, 2, 'PPL', 'P'),
(79697, 'Bazen Crossroads', 33.9119415283203, 0.591875035412987, -79.5327835083008, -1.3881089354957, 218, 48, 'PPL', 'P'),
(112580, 'Bazette', 32.1833305358887, 0.561705082108888, -96.2719421386719, -1.6802623676093, 218, 51, 'PPL', 'P'),
(141247, 'Bazile Mills', 42.5127792358398, 0.741987971838884, -97.9047164916992, -1.70875965601174, 218, 35, 'PPL', 'P'),
(31758, 'Bazine', 38.4444389343262, 0.670982038485892, -99.6916732788086, -1.73994793553766, 218, 20, 'PPL', 'P'),
(39280, 'Beabois Place', 30.5902805328369, 0.533901114406729, -91.0566711425781, -1.5892387173437, 218, 22, 'PPL', 'P'),
(19108, 'Beach', 31.4397201538086, 0.548726632589578, -82.5038909912109, -1.43996454350312, 218, 13, 'PPL', 'P'),
(53371, 'Beach', 37.4311103820801, 0.65329611884473, -92.9588928222656, -1.62243874875706, 218, 29, 'PPL', 'P'),
(58578, 'Beach', 32.4963912963867, 0.567169023138377, -89.6549987792969, -1.56477491957023, 218, 30, 'PPL', 'P'),
(92504, 'Beach', 30.3197193145752, 0.529178930319856, -95.4211120605469, -1.66541258137101, 218, 51, 'PPL', 'P'),
(193179, 'Beach', 46.9180603027344, 0.818874630931962, -104.003890991211, -1.8152103326819, 218, 34, 'PPL', 'P'),
(206786, 'Beach', 48.7161102294922, 0.850256522269129, -122.682502746582, -2.14121360751484, 218, 56, 'PPL', 'P'),
(124198, 'Beach Bluff', 42.4791717529297, 0.741401410608794, -70.8861083984375, -1.23719598547834, 218, 23, 'PPL', 'P'),
(92505, 'Beach City', 29.6619396209717, 0.517698508913715, -94.8897171020508, -1.65613798971676, 218, 51, 'PPL', 'P'),
(154218, 'Beach City', 40.6530609130859, 0.709529763947162, -81.5811080932617, -1.42385894365281, 218, 41, 'PPL', 'P'),
(144802, 'Beach Glen', 40.9297218322754, 0.714358407898612, -74.4866714477539, -1.30003766561456, 218, 37, 'PPL', 'P'),
(7324, 'Beach Grove', 35.6786117553711, 0.622709247671979, -93.7416687011719, -1.63610076514917, 218, 4, 'PPL', 'P'),
(62763, 'Beach Grove', 35.2622184753418, 0.615441813952289, -76.8058319091797, -1.34051465154851, 218, 33, 'PPL', 'P'),
(129709, 'Beach Grove', 45.2994384765625, 0.79062435072062, -87.4375, -1.52607226471254, 218, 27, 'PPL', 'P'),
(30, 'Beach Grove (historical)', 34.8402786254883, 0.608077574326975, -87.4602813720703, -1.52646987466329, 218, 2, 'PPL', 'P'),
(147063, 'Beach Hampton', 40.9780616760254, 0.715202097331949, -72.1080627441406, -1.25852311211991, 218, 40, 'PPL', 'P'),
(44658, 'Beach Harbor Mobile Home Park', 38.9655609130859, 0.680077332819758, -76.2158279418945, -1.33021713971955, 218, 25, 'PPL', 'P'),
(15143, 'Beach Haven', 30.3847198486328, 0.530313403654716, -87.3077774047852, -1.52380817831181, 218, 12, 'PPL', 'P'),
(70511, 'Beach Haven', 39.5591697692871, 0.690437761829466, -74.2436065673828, -1.29579538315612, 218, 37, 'PPL', 'P'),
(158967, 'Beach Haven', 41.0683288574219, 0.716777556853813, -76.1761093139648, -1.32952391888781, 218, 45, 'PPL', 'P'),
(206787, 'Beach Haven', 48.6922187805176, 0.84983953782145, -122.949440002441, -2.14587254152583, 218, 56, 'PPL', 'P'),
(70512, 'Beach Haven Crest', 39.6124992370605, 0.691368536630448, -74.2033309936523, -1.29509244178639, 218, 37, 'PPL', 'P'),
(70513, 'Beach Haven Gardens', 39.582218170166, 0.690840032312122, -74.2275009155273, -1.29551428650306, 218, 37, 'PPL', 'P'),
(19109, 'Beach Haven Heights', 34.2627792358398, 0.597998308549352, -83.9391708374023, -1.46501490250668, 218, 13, 'PPL', 'P'),
(70514, 'Beach Haven Heights', 39.5344390869141, 0.690006129995791, -74.2608337402344, -1.29609605404319, 218, 37, 'PPL', 'P'),
(70515, 'Beach Haven Park', 39.5974998474121, 0.691106747895294, -74.2130584716797, -1.29526221830588, 218, 37, 'PPL', 'P'),
(70516, 'Beach Haven Terrace', 39.586109161377, 0.690907942919919, -74.2238922119141, -1.29545130274328, 218, 37, 'PPL', 'P'),
(70517, 'Beach Haven West', 39.6697196960449, 0.692367222039228, -74.2322235107422, -1.2955967113388, 218, 37, 'PPL', 'P'),
(15144, 'Beach Highlands', 30.3527793884277, 0.529755937459535, -86.2494430541992, -1.50533675930713, 218, 12, 'PPL', 'P'),
(158968, 'Beach Lake', 41.6016693115234, 0.726086103811967, -75.1502838134766, -1.31161988635337, 218, 45, 'PPL', 'P'),
(62764, 'Beach Land Landing', 35.7924995422363, 0.624696964530587, -75.9088897705078, -1.3248600580288, 218, 33, 'PPL', 'P'),
(118741, 'Beach Park', 42.4222183227539, 0.740407385731922, -87.8572235107422, -1.53339782192302, 218, 18, 'PPL', 'P'),
(124199, 'Beach Park', 41.9402809143066, 0.731995991165989, -70.6205596923828, -1.23256128623327, 218, 23, 'PPL', 'P'),
(124200, 'Beach Point', 42.0547218322754, 0.733993361983548, -70.1322174072266, -1.22403810548058, 218, 23, 'PPL', 'P'),
(147064, 'Beach Ridge', 43.0847206115723, 0.751970231973801, -78.8233337402344, -1.37572670116543, 218, 40, 'PPL', 'P'),
(62765, 'Beach Springs', 36.209171295166, 0.631969258519267, -76.5149993896484, -1.33543866651082, 218, 33, 'PPL', 'P'),
(118742, 'Beach Station', 42.4211082458496, 0.740388011234992, -87.8491668701172, -1.53325720701747, 218, 18, 'PPL', 'P'),
(169276, 'Beach Terrace', 41.7169418334961, 0.728097988857467, -71.2841720581055, -1.24414350697208, 218, 47, 'PPL', 'P'),
(70519, 'Beach View', 39.7247200012207, 0.693327158454147, -74.2430572509766, -1.29578579577619, 218, 37, 'PPL', 'P'),
(33, 'Beachboro (historical)', 34.8527793884277, 0.60829575379928, -86.2077789306641, -1.50460958317148, 218, 2, 'PPL', 'P'),
(206788, 'Beachcrest', 47.1083297729492, 0.822195459653237, -122.747497558594, -2.14234798098116, 218, 56, 'PPL', 'P'),
(77831, 'Beachdale', 39.9036102294922, 0.696449381937129, -79.0124969482422, -1.3790282219688, 218, 45, 'PPL', 'P'),
(177480, 'Beachdale', 41.5777816772461, 0.725669185943315, -71.8622207641602, -1.25423236012963, 218, 8, 'PPL', 'P'),
(114523, 'Beaches Resort', 43.4283294677734, 0.757967337853523, -95.1736068725586, -1.66109280092485, 218, 16, 'PPL', 'P'),
(13339, 'Beachfield', 38.7249984741211, 0.675878726203193, -75.1222229003906, -1.3111301310289, 218, 10, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(99702, 'Beachland', 37.0852813720703, 0.647260263971147, -76.8161087036133, -1.34069401544792, 218, 53, 'PPL', 'P'),
(44659, 'Beachley', 39.3963890075684, 0.687596701578569, -77.5236129760742, -1.3530422944743, 218, 25, 'PPL', 'P'),
(77832, 'Beachly', 39.7738914489746, 0.694185362115425, -79.3080596923828, -1.38418676500028, 218, 45, 'PPL', 'P'),
(124201, 'Beachmont', 42.3958282470703, 0.739946792021393, -70.9875030517578, -1.2389656560227, 218, 23, 'PPL', 'P'),
(129710, 'Beachmont', 42.6463890075684, 0.744319902268385, -86.2236099243164, -1.50488588613458, 218, 27, 'PPL', 'P'),
(44660, 'Beachmont Estates', 39.3836097717285, 0.687373661837275, -76.9833297729492, -1.34361257368654, 218, 25, 'PPL', 'P'),
(194564, 'Beachs Corner', 43.5424995422363, 0.759959981560148, -111.963333129883, -1.9541288046237, 218, 17, 'PPL', 'P'),
(173094, 'Beachs Corners', 44.2013893127441, 0.771459777463219, -91.2372207641602, -1.59238990270353, 218, 57, 'PPL', 'P'),
(19110, 'Beachton', 30.7269401550293, 0.536286274768518, -84.1397171020508, -1.46851509512737, 218, 13, 'PPL', 'P'),
(75079, 'Beachton', 34.4905586242676, 0.601973808845595, -94.5663909912109, -1.65049488452494, 218, 42, 'PPL', 'P'),
(15145, 'Beachville', 29.9977798461914, 0.523560026604438, -82.8613891601563, -1.44620406362107, 218, 12, 'PPL', 'P'),
(44661, 'Beachville', 38.148609161377, 0.665818834922501, -76.4161071777344, -1.33371267180834, 218, 25, 'PPL', 'P'),
(147065, 'Beachville', 42.4558296203613, 0.740994013541039, -77.633056640625, -1.35495244676615, 218, 40, 'PPL', 'P'),
(84861, 'Beachville (historical)', 36.0394401550293, 0.629006891280717, -86.8694381713867, -1.51615771544834, 218, 50, 'PPL', 'P'),
(13340, 'Beachwood', 38.4958305358887, 0.67187899114103, -75.1580581665039, -1.31175557441091, 218, 10, 'PPL', 'P'),
(39281, 'Beachwood', 30.8597202301025, 0.538603724259591, -91.3686065673828, -1.59468301756014, 218, 22, 'PPL', 'P'),
(44662, 'Beachwood', 39.274169921875, 0.685463576124443, -76.4550018310547, -1.3343915115702, 218, 25, 'PPL', 'P'),
(70520, 'Beachwood', 39.9388885498047, 0.697065104781155, -74.1933288574219, -1.29491787157693, 218, 37, 'PPL', 'P'),
(124202, 'Beachwood', 42.3250007629395, 0.738710619222405, -73.3208312988281, -1.27968991646386, 218, 23, 'PPL', 'P'),
(154219, 'Beachwood', 41.4644393920898, 0.723690989885604, -81.5088882446289, -1.42259846950888, 218, 41, 'PPL', 'P'),
(44668, 'Beachwood Forest', 39.1016693115234, 0.682452872512108, -76.5277786254883, -1.33566170625211, 218, 25, 'PPL', 'P'),
(44663, 'Beachwood Glen', 39.3624992370605, 0.687005213500463, -75.8619384765625, -1.32404060336139, 218, 25, 'PPL', 'P'),
(44664, 'Beachwood Grove', 39.1058311462402, 0.68252551023084, -76.5325012207031, -1.33574413108785, 218, 25, 'PPL', 'P'),
(71753, 'Beachwood Lake Estates', 39.3016700744629, 0.685943544331902, -82.1338882446289, -1.43350677733384, 218, 41, 'PPL', 'P'),
(179987, 'Beachwood Trailer Park', 33.4666709899902, 0.584103598457, -117.674171447754, -2.05380173631961, 218, 6, 'PPL', 'P'),
(34, 'Beacon', 31.7144393920898, 0.553521387816157, -86.8230590820313, -1.51534824763501, 218, 2, 'PPL', 'P'),
(84862, 'Beacon', 35.6283302307129, 0.621831669513771, -88.1830596923828, -1.53908473611478, 218, 50, 'PPL', 'P'),
(92507, 'Beacon', 31.1825008392334, 0.544237308650518, -96.811393737793, -1.68967757416911, 218, 51, 'PPL', 'P'),
(114524, 'Beacon', 41.2769393920898, 0.720418497538114, -92.679443359375, -1.61756143553669, 218, 16, 'PPL', 'P'),
(129711, 'Beacon', 46.5102806091309, 0.811757532655807, -87.9855575561523, -1.53563767355783, 218, 27, 'PPL', 'P'),
(147066, 'Beacon', 41.5047187805176, 0.724393997834357, -73.9700012207031, -1.29102006900549, 218, 40, 'PPL', 'P'),
(7323, 'Beacon Addition', 36.3333282470703, 0.634136206119237, -93.9983291625977, -1.64058033526073, 218, 4, 'PPL', 'P'),
(15146, 'Beacon Beach', 30.0963897705078, 0.525281094458902, -85.6474990844727, -1.49483085512288, 218, 12, 'PPL', 'P'),
(126844, 'Beacon Corner', 43.4291687011719, 0.757981985239519, -70.4544372558594, -1.2296619027545, 218, 26, 'PPL', 'P'),
(177482, 'Beacon Falls', 41.4427795410156, 0.723312954168867, -73.0630569458008, -1.27519090527634, 218, 8, 'PPL', 'P'),
(19115, 'Beacon Heights', 33.5780601501465, 0.586047706052758, -83.4775009155273, -1.45695724231253, 218, 13, 'PPL', 'P'),
(13341, 'Beacon Hill', 39.8244400024414, 0.695067600805541, -75.5072174072266, -1.31784955277528, 218, 10, 'PPL', 'P'),
(15147, 'Beacon Hill', 29.922779083252, 0.522251016349637, -85.3858337402344, -1.49026393332755, 218, 12, 'PPL', 'P'),
(19111, 'Beacon Hill', 33.5958290100098, 0.586357831161697, -83.779167175293, -1.46222231178762, 218, 13, 'PPL', 'P'),
(44666, 'Beacon Hill', 39.4766693115234, 0.688997857207087, -76.6311111450195, -1.33746519894231, 218, 25, 'PPL', 'P'),
(58579, 'Beacon Hill', 34.4569396972656, 0.601387047878423, -88.975830078125, -1.55292118955828, 218, 30, 'PPL', 'P'),
(79698, 'Beacon Hill', 34.8588905334473, 0.608402413400937, -82.2677764892578, -1.43584356803233, 218, 48, 'PPL', 'P'),
(99703, 'Beacon Hill', 37.7144393920898, 0.658241142935816, -77.7769393920898, -1.35746367451604, 218, 53, 'PPL', 'P'),
(124203, 'Beacon Hill', 42.3586082458496, 0.739297180452495, -71.0683288574219, -1.24037633245211, 218, 23, 'PPL', 'P'),
(129712, 'Beacon Hill', 47.1391716003418, 0.822733751088569, -88.8066711425781, -1.54996880917382, 218, 27, 'PPL', 'P'),
(154221, 'Beacon Hill', 41.375560760498, 0.72213976512966, -81.3388900756836, -1.41963144173842, 218, 41, 'PPL', 'P'),
(186393, 'Beacon Hill', 38.7224998474121, 0.675835116940343, -105.164436340332, -1.83546567014277, 218, 7, 'PPL', 'P'),
(206790, 'Beacon Hill', 47.5777816772461, 0.830388941062974, -122.308609008789, -2.13468793073777, 218, 56, 'PPL', 'P'),
(370, 'Beacon Hills', 30.3822193145752, 0.530269761102352, -81.5074996948242, -1.42257423474296, 218, 12, 'PPL', 'P'),
(62766, 'Beacon Hills', 36.0013885498047, 0.628342765483878, -81.5380630493164, -1.4231076659093, 218, 33, 'PPL', 'P'),
(84863, 'Beacon Hills', 36.1674995422363, 0.631241949225566, -83.4236068725586, -1.45601661381552, 218, 50, 'PPL', 'P'),
(99704, 'Beacon Hills', 37.3222198486328, 0.651395620511822, -80.0111083984375, -1.39645727972282, 218, 53, 'PPL', 'P'),
(147067, 'Beacon Hills', 41.5094413757324, 0.724476422670095, -73.9288864135742, -1.29030248024977, 218, 40, 'PPL', 'P'),
(84865, 'Beacon Junction', 35.639720916748, 0.622030474489145, -88.1808319091797, -1.53904585396286, 218, 50, 'PPL', 'P'),
(15148, 'Beacon Lakes', 28.211109161377, 0.492376740505564, -82.7458267211914, -1.44418711856949, 218, 12, 'PPL', 'P'),
(158973, 'Beacon Lodge', 40.3741683959961, 0.70466217126477, -77.8130569458008, -1.35809404474607, 218, 45, 'PPL', 'P'),
(195937, 'Beacon Point', 45.3888893127441, 0.792185562330652, -111.358329772949, -1.94356950405959, 218, 31, 'PPL', 'P'),
(15149, 'Beacon Square', 28.2083301544189, 0.492328237684211, -82.7555618286133, -1.44435702824704, 218, 12, 'PPL', 'P'),
(179988, 'Beacon Station', 35.1324996948242, 0.613177794130586, -116.208061218262, -2.0282132856178, 218, 6, 'PPL', 'P'),
(44667, 'Beacon View', 39.0402793884277, 0.681381416226542, -76.4288864135742, -1.33393571154963, 218, 25, 'PPL', 'P'),
(141249, 'Beacon View', 41.0672187805176, 0.716758182356882, -96.3261108398438, -1.68120778979627, 218, 35, 'PPL', 'P'),
(99705, 'Beaconsdale', 37.0641708374023, 0.646891815634335, -76.4730606079102, -1.33470669668521, 218, 53, 'PPL', 'P'),
(114525, 'Beaconsfield', 40.8077812194824, 0.712230142713475, -94.0502777099609, -1.64148700845385, 218, 16, 'PPL', 'P'),
(124204, 'Beaconsfield', 42.336669921875, 0.738914284466769, -71.1416702270508, -1.24165638083006, 218, 23, 'PPL', 'P'),
(13342, 'Beades Estate', 39.1141700744629, 0.682671051984413, -75.5299987792969, -1.31824716272603, 218, 10, 'PPL', 'P'),
(129713, 'Beadle Lake', 42.267219543457, 0.73770214669662, -85.1494369506836, -1.48613803100875, 218, 27, 'PPL', 'P'),
(158969, 'Beadling', 40.360279083252, 0.704419757026545, -80.0725021362305, -1.39752880258741, 218, 45, 'PPL', 'P'),
(31760, 'Beagle', 38.4180603027344, 0.670521644512444, -94.954719543457, -1.65727249634113, 218, 20, 'PPL', 'P'),
(34706, 'Beagle', 38.9008293151855, 0.678947553306319, -84.2547225952148, -1.47052231964096, 218, 21, 'PPL', 'P'),
(200387, 'Beagle', 42.5347213745117, 0.742370934403638, -122.924171447754, -2.14543152204931, 218, 43, 'PPL', 'P'),
(154222, 'Beagle (historical)', 40.9355583190918, 0.714460273810307, -83.6425018310547, -1.45983705155729, 218, 41, 'PPL', 'P'),
(29167, 'Beal', 38.5766716003418, 0.673289933886554, -87.629997253418, -1.52943197558573, 218, 19, 'PPL', 'P'),
(53372, 'Beal', 37.1136093139648, 0.64775467982752, -91.095832824707, -1.58992221763746, 218, 29, 'PPL', 'P'),
(129714, 'Beal City', 43.6691703796387, 0.762170804739077, -84.9086074829102, -1.48193476386028, 218, 27, 'PPL', 'P'),
(39285, 'Beal Crossing', 31.7538890838623, 0.554209914826483, -92.6930618286133, -1.61779912266398, 218, 22, 'PPL', 'P'),
(193366, 'Beal Place', 40.5977783203125, 0.708564900684226, -121.748611450195, -2.12491412953718, 218, 6, 'PPL', 'P'),
(39284, 'Beale', 30.8291702270508, 0.538070526119844, -92.4194412231445, -1.61302354219725, 218, 22, 'PPL', 'P'),
(108114, 'Beale', 38.767219543457, 0.676615622876818, -82.1972198486328, -1.43461212234428, 218, 58, 'PPL', 'P'),
(84866, 'Beale (historical)', 35.829719543457, 0.625346576099485, -87.2708282470703, -1.52316329385385, 218, 50, 'PPL', 'P'),
(99706, 'Beale (historical)', 37.9888916015625, 0.663031237630487, -77.2441711425781, -1.34816511441198, 218, 53, 'PPL', 'P'),
(99707, 'Beales', 36.7972183227539, 0.642232615307241, -77.0344390869141, -1.34450459949366, 218, 53, 'PPL', 'P'),
(99708, 'Beales Corner', 36.6500015258789, 0.639663197487533, -76.8494415283203, -1.34127578298805, 218, 53, 'PPL', 'P'),
(99709, 'Bealeton', 38.5716705322266, 0.673202648781827, -77.7641677856445, -1.35724076793281, 218, 53, 'PPL', 'P'),
(19112, 'Beall', 32.7377815246582, 0.571382077403855, -84.5533294677734, -1.47573399273619, 218, 13, 'PPL', 'P'),
(193367, 'Beall Place', 40.0275001525879, 0.698611669005191, -123.82861328125, -2.16121700993659, 218, 6, 'PPL', 'P'),
(19113, 'Beall Springs', 33.3088912963867, 0.581349823310831, -82.7163925170898, -1.44367339479522, 218, 13, 'PPL', 'P'),
(112385, 'Beallmount', 39.060001373291, 0.681725629797435, -77.2744369506836, -1.3486933524142, 218, 25, 'PPL', 'P'),
(108115, 'Bealls Mills', 38.9683303833008, 0.680125669193543, -80.6113891601563, -1.40693415545119, 218, 58, 'PPL', 'P'),
(44669, 'Beallsville', 39.1788902282715, 0.68380063176077, -77.4130630493164, -1.35111283426453, 218, 25, 'PPL', 'P'),
(71754, 'Beallsville', 39.848331451416, 0.69548458525322, -81.0369415283203, -1.41436144541532, 218, 41, 'PPL', 'P'),
(158971, 'Beallsville', 40.0652809143066, 0.699271067691095, -80.0238876342773, -1.39668031946412, 218, 45, 'PPL', 'P'),
(34707, 'Beals', 37.8666687011719, 0.660898045597334, -87.4027786254883, -1.52546626240649, 218, 21, 'PPL', 'P'),
(71755, 'Beals', 39.8877792358398, 0.696173078974033, -82.7494430541992, -1.44425023548733, 218, 41, 'PPL', 'P'),
(126845, 'Beals', 44.519718170166, 0.777015664129342, -67.6155624389648, -1.18011419014774, 218, 26, 'PPL', 'P'),
(195939, 'Beals', 45.7441711425781, 0.798386400033765, -111.816390991211, -1.95156418049396, 218, 31, 'PPL', 'P'),
(70522, 'Beals Mill', 39.5286102294922, 0.68990439724215, -75.26611328125, -1.31364149193685, 218, 37, 'PPL', 'P'),
(199166, 'Beals Trailer Court', 41.0941696166992, 0.717228563184418, -101.887496948242, -1.7782722883625, 218, 35, 'PPL', 'P'),
(15151, 'Bealsville', 27.9452800750732, 0.487737147701996, -82.079719543457, -1.43256135514686, 218, 12, 'PPL', 'P'),
(179989, 'Bealville', 35.2722206115723, 0.615616384161744, -118.625282287598, -2.07040175202629, 218, 6, 'PPL', 'P'),
(62768, 'Beam Mill', 35.3899993896484, 0.617672011628149, -81.4972229003906, -1.42239487084354, 218, 33, 'PPL', 'P'),
(112404, 'Beaman', 38.7572212219238, 0.676441119246391, -93.1333312988281, -1.62548327451524, 218, 29, 'PPL', 'P'),
(114526, 'Beaman', 42.2197189331055, 0.736873104649278, -92.8233337402344, -1.62007279644463, 218, 16, 'PPL', 'P'),
(62769, 'Beaman Crossroads', 35.1191711425781, 0.612945167009367, -78.4141693115234, -1.36858543470238, 218, 33, 'PPL', 'P'),
(99710, 'Beamantown', 36.8680610656738, 0.643469054422338, -82.7630615234375, -1.44448792261462, 218, 53, 'PPL', 'P'),
(29168, 'Beamer', 39.3666687011719, 0.687077984377249, -86.9375, -1.51734561845257, 218, 19, 'PPL', 'P'),
(99711, 'Beamertown', 39.2099990844727, 0.68434358372801, -77.688606262207, -1.355921970561, 218, 53, 'PPL', 'P'),
(26464, 'Beamington', 39.6708297729492, 0.692386596536158, -89.591667175293, -1.56366957455979, 218, 18, 'PPL', 'P'),
(44, 'Beamon', 31.5188903808594, 0.550108413721166, -85.5861129760742, -1.49375946541634, 218, 2, 'PPL', 'P'),
(99712, 'Beamon', 36.7949981689453, 0.64219386631338, -76.5277786254883, -1.33566170625211, 218, 53, 'PPL', 'P'),
(92508, 'Beamsley Colonia', 26.2339992523193, 0.457869662918703, -98.1959991455078, -1.71384349737465, 218, 51, 'PPL', 'P'),
(154223, 'Beamsville', 40.1872215270996, 0.701399332876232, -84.585563659668, -1.47629658551647, 218, 41, 'PPL', 'P'),
(179990, 'Bean (historical)', 36.1377792358398, 0.630723232024246, -119.584167480469, -2.08713745579051, 218, 6, 'PPL', 'P'),
(15150, 'Bean City', 26.6816692352295, 0.465682978082832, -80.7619400024414, -1.40956176334072, 218, 12, 'PPL', 'P'),
(147069, 'Bean Hill Crossing', 44.3305587768555, 0.773714209904998, -75.788330078125, -1.32275589445153, 218, 40, 'PPL', 'P'),
(143502, 'Bean Island', 43.063060760498, 0.751592196257064, -71.2433319091797, -1.24343071190632, 218, 36, 'PPL', 'P'),
(53373, 'Bean Lake Station', 39.4977798461914, 0.6893663055439, -95.0038909912109, -1.65813070000241, 218, 29, 'PPL', 'P'),
(108117, 'Bean Settlement', 39.1150016784668, 0.682685566212354, -78.8261108398438, -1.37577517069727, 218, 58, 'PPL', 'P'),
(84867, 'Bean Station', 36.3436088562012, 0.634315636597681, -83.2841720581055, -1.4535830172114, 218, 50, 'PPL', 'P'),
(29170, 'Beanblossom', 39.2669410705566, 0.6853374088678, -86.2491683959961, -1.50533196561717, 218, 19, 'PPL', 'P'),
(84868, 'Beans', 36.3313903808594, 0.634102383973393, -83.3680572509766, -1.45504709002067, 218, 50, 'PPL', 'P'),
(126847, 'Beans Corner', 44.4569396972656, 0.775919973077856, -69.2624969482422, -1.20885861989935, 218, 26, 'PPL', 'P'),
(77833, 'Beans Cove', 39.7936096191406, 0.694529509107291, -78.5763931274414, -1.3714167744153, 218, 45, 'PPL', 'P'),
(84869, 'Beans Creek', 35.0616683959961, 0.611941554752571, -86.2466735839844, -1.50528842293335, 218, 50, 'PPL', 'P'),
(47, 'Beans Crossroads', 31.9991703033447, 0.558490879699758, -85.8536071777344, -1.4984281199653, 218, 2, 'PPL', 'P'),
(58580, 'Beans Ferry', 34.2097206115723, 0.597072260859304, -88.3850021362305, -1.54260929665944, 218, 30, 'PPL', 'P'),
(44670, 'Beans Landing', 38.1166687011719, 0.66526136872732, -76.3963928222656, -1.3333685913955, 218, 25, 'PPL', 'P'),
(45, 'Beans Mill', 32.6969413757324, 0.570669282338095, -85.2675018310547, -1.4881986519022, 218, 2, 'PPL', 'P'),
(108118, 'Beans Mill', 38.8319396972656, 0.677745202653175, -80.2008285522461, -1.39976852106417, 218, 58, 'PPL', 'P'),
(44672, 'Beantown', 39.0952796936035, 0.682341352641461, -77.1402816772461, -1.3463519011838, 218, 25, 'PPL', 'P'),
(171721, 'Beanville', 43.9008293151855, 0.766214015906035, -72.6563873291016, -1.26809318149711, 218, 55, 'PPL', 'P'),
(7325, 'Bear', 34.5344390869141, 0.602739667396075, -93.2736129760742, -1.6279316516634, 218, 4, 'PPL', 'P'),
(13343, 'Bear', 39.6291694641113, 0.69165948697954, -75.6586074829102, -1.3204918080508, 218, 10, 'PPL', 'P'),
(193046, 'Bear', 34.9425010681152, 0.609861692520246, -112.246673583984, -1.95907402845187, 218, 5, 'PPL', 'P'),
(194565, 'Bear', 45.0244407653809, 0.785824735225052, -116.671112060547, -2.03629504741981, 218, 17, 'PPL', 'P'),
(206791, 'Bear', 48.7108306884766, 0.850164376895412, -118.043060302734, -2.06024006141293, 218, 56, 'PPL', 'P'),
(84870, 'Bear (historical)', 35.9491691589355, 0.627431365179826, -84.3144378662109, -1.47156454773356, 218, 50, 'PPL', 'P'),
(29171, 'Bear Branch', 38.9127807617188, 0.679156145398699, -85.0749969482422, -1.48483880787095, 218, 19, 'PPL', 'P'),
(53374, 'Bear Branch', 39.9413909912109, 0.697108780623032, -93.0336074829102, -1.62374276558482, 218, 29, 'PPL', 'P'),
(112329, 'Bear Branch', 37.163330078125, 0.648622470868723, -83.5488891601563, -1.45820320222853, 218, 21, 'PPL', 'P'),
(112553, 'Bear Branch (historical)', 35.8569412231445, 0.625821684037955, -85.7980575561523, -1.49745859617046, 218, 50, 'PPL', 'P'),
(201888, 'Bear Butte', 44.4744415283203, 0.776225437654888, -103.306938171387, -1.80304621124491, 218, 49, 'PPL', 'P'),
(193050, 'Bear Canyon Junction', 33.5363883972168, 0.585320396759057, -110.393608093262, -1.92673193438368, 218, 5, 'PPL', 'P'),
(56, 'Bear Creek', 34.2747192382813, 0.598206700904651, -87.7005615234375, -1.53066355443184, 218, 2, 'PPL', 'P'),
(7327, 'Bear Creek', 35.8313903808594, 0.625375737713421, -92.7680587768555, -1.61910806633975, 218, 4, 'PPL', 'P'),
(39287, 'Bear Creek', 32.3144416809082, 0.563993403275539, -92.7586135864258, -1.61894321666828, 218, 22, 'PPL', 'P'),
(58581, 'Bear Creek', 32.0636100769043, 0.559615565917612, -90.5194396972656, -1.57986225977774, 218, 30, 'PPL', 'P'),
(62772, 'Bear Creek', 34.6627807617188, 0.60497965218894, -77.1808319091797, -1.34705963624349, 218, 33, 'PPL', 'P'),
(71756, 'Bear Creek', 38.9311103820801, 0.679476057624645, -83.0658264160156, -1.44977216684955, 218, 41, 'PPL', 'P'),
(84871, 'Bear Creek', 35.648609161377, 0.622185603622642, -88.1488876342773, -1.53848832118865, 218, 50, 'PPL', 'P'),
(92511, 'Bear Creek', 30.4491691589355, 0.531438256320138, -95.220832824707, -1.66191704928223, 218, 51, 'PPL', 'P'),
(147070, 'Bear Creek', 43.2763900756836, 0.755315495198077, -77.2777786254883, -1.34875167564207, 218, 40, 'PPL', 'P'),
(173096, 'Bear Creek', 44.5313911437988, 0.777219395952733, -88.7263870239258, -1.54856758696628, 218, 57, 'PPL', 'P'),
(179992, 'Bear Creek', 38.0838890075684, 0.664689255146144, -121.241668701172, -2.11606630944761, 218, 6, 'PPL', 'P'),
(201889, 'Bear Creek', 45.0622215270996, 0.786484133910955, -101.445556640625, -1.7705589748973, 218, 49, 'PPL', 'P'),
(212295, 'Bear Creek', 60.1641693115234, 1.05006284621341, -149.395004272461, -2.60743471058544, 218, 1, 'PPL', 'P'),
(58582, 'Bear Creek (historical)', 33.2411117553711, 0.580166847154617, -89.3555603027344, -1.55954873224706, 218, 30, 'PPL', 'P'),
(173097, 'Bear Creek Corners', 44.5313911437988, 0.777219395952733, -88.746940612793, -1.54892631476511, 218, 57, 'PPL', 'P'),
(19118, 'Bear Creek Estates', 33.565559387207, 0.585829526580453, -83.7727813720703, -1.462110858496, 218, 13, 'PPL', 'P'),
(44673, 'Bear Creek Junction', 39.2447204589844, 0.684949586034058, -76.4672164916992, -1.33460469761546, 218, 25, 'PPL', 'P'),
(158974, 'Bear Creek Junction', 41.0952796936035, 0.717247937681348, -75.7819366455078, -1.32264430800186, 218, 45, 'PPL', 'P'),
(19119, 'Bear Creek Landing', 33.3722190856934, 0.582455101742241, -84.3863906860352, -1.47282036134559, 218, 13, 'PPL', 'P'),
(7329, 'Bear Creek Springs', 36.2975006103516, 0.633510895895286, -93.1830596923828, -1.62635119871449, 218, 4, 'PPL', 'P'),
(194566, 'Bear Creek Summer Home Area', 44.1666717529297, 0.770853841736199, -115.193061828613, -2.0104982043627, 218, 17, 'PPL', 'P'),
(158975, 'Bear Creek Village', 41.1786117553711, 0.718702356531667, -75.7566680908203, -1.32220328852534, 218, 45, 'PPL', 'P'),
(195940, 'Bear Creek Village', 48.0777816772461, 0.839115587322946, -113.977783203125, -1.98928759101882, 218, 31, 'PPL', 'P'),
(195941, 'Bear Dance', 47.9166717529297, 0.836303688685986, -114.027778625488, -1.99016017574998, 218, 31, 'PPL', 'P'),
(193053, 'Bear Flat', 34.2930603027344, 0.598526812867678, -111.066940307617, -1.93848379848392, 218, 5, 'PPL', 'P'),
(158978, 'Bear Gap', 40.832218170166, 0.712656647962051, -76.5061111450195, -1.33528353737732, 218, 45, 'PPL', 'P'),
(62774, 'Bear Grass', 35.7661094665527, 0.624236370820058, -77.1277770996094, -1.34613365513247, 218, 33, 'PPL', 'P'),
(15152, 'Bear Hollow', 27.2083301544189, 0.474874945164268, -81.2880630493164, -1.41874434277931, 218, 12, 'PPL', 'P'),
(143505, 'Bear Island', 43.6572189331055, 0.761962212646697, -71.4177780151367, -1.24647537082256, 218, 36, 'PPL', 'P'),
(129716, 'Bear Lake', 44.4208297729492, 0.775289736005889, -86.148063659668, -1.50356735507888, 218, 27, 'PPL', 'P'),
(158979, 'Bear Lake', 41.9933280944824, 0.732921839118955, -79.503059387207, -1.38759015171535, 218, 45, 'PPL', 'P'),
(194568, 'Bear Lake Hot Springs', 42.1086082458496, 0.73493385732251, -111.264442443848, -1.94193086104087, 218, 17, 'PPL', 'P'),
(194569, 'Bear Lake Sands', 42.0516700744629, 0.733940098761746, -111.252777099609, -1.94172726237553, 218, 17, 'PPL', 'P'),
(77834, 'Bear Lick', 39.8936080932617, 0.696274811727674, -77.9430618286133, -1.36036305799481, 218, 45, 'PPL', 'P'),
(158981, 'Bear Loop', 40.6672210693359, 0.709776905296321, -78.4277801513672, -1.36882298867161, 218, 45, 'PPL', 'P'),
(108119, 'Bear Mountain', 39.2172203063965, 0.684469617826598, -80.1669387817383, -1.39917703298606, 218, 58, 'PPL', 'P'),
(62775, 'Bear Pond', 36.2769393920898, 0.633152034938398, -78.4061126708984, -1.36844481979682, 218, 33, 'PPL', 'P'),
(62776, 'Bear Poplar', 35.6758308410645, 0.622660711561113, -80.6936111450195, -1.40836919980458, 218, 33, 'PPL', 'P'),
(134137, 'Bear River', 47.7777786254883, 0.833879546303741, -93.0827789306641, -1.62460096924609, 218, 28, 'PPL', 'P'),
(209295, 'Bear River', 41.3841705322266, 0.722290033994168, -111.02555847168, -1.93776154919629, 218, 59, 'PPL', 'P'),
(194103, 'Bear River (historical)', 40.4838905334473, 0.706577183825618, -107.116668701172, -1.86953855260341, 218, 7, 'PPL', 'P'),
(202991, 'Bear River City', 41.6147193908691, 0.726313870664196, -112.125831604004, -1.95696493802658, 218, 52, 'PPL', 'P'),
(179993, 'Bear River Pines', 39.1694412231445, 0.683635715510267, -120.966941833496, -2.11127142106297, 218, 6, 'PPL', 'P'),
(99713, 'Bear Rock', 37.2833290100098, 0.650716847328988, -80.1338882446289, -1.39860019229395, 218, 53, 'PPL', 'P'),
(158982, 'Bear Rocks', 40.1227798461914, 0.700274613368864, -79.4619369506836, -1.38687242980157, 218, 45, 'PPL', 'P'),
(44674, 'Bear Run', 39.6305618286133, 0.691683788324487, -77.1069412231445, -1.34577000048562, 218, 25, 'PPL', 'P'),
(158983, 'Bear Run Junction', 40.8022193908691, 0.712133070491742, -76.1913909912109, -1.32979063447098, 218, 45, 'PPL', 'P'),
(39288, 'Bear Skin', 32.6816711425781, 0.570402766492006, -91.5961074829102, -1.5986536575874, 218, 22, 'PPL', 'P'),
(84872, 'Bear Spring', 36.4752807617188, 0.636613744881337, -87.7547225952148, -1.53160884346076, 218, 50, 'PPL', 'P'),
(99714, 'Bear Spring', 37.247501373291, 0.650091537105038, -80.6338882446289, -1.40732683855393, 218, 53, 'PPL', 'P'),
(84873, 'Bear Stand', 36.2786102294922, 0.633181196552334, -82.0883331298828, -1.4327116905904, 218, 50, 'PPL', 'P'),
(158984, 'Bear Swamp', 41.1411094665527, 0.718047818114753, -77.6505584716797, -1.35525791134319, 218, 45, 'PPL', 'P'),
(144803, 'Bear Tavern', 40.3088912963867, 0.703522870950434, -74.8488922119141, -1.30635961056824, 218, 37, 'PPL', 'P'),
(58583, 'Bear Town', 31.2227802276611, 0.544940316599271, -90.4602813720703, -1.57882975222312, 218, 30, 'PPL', 'P'),
(129719, 'Bear Town', 46.8088912963867, 0.816969272330065, -88.5097198486328, -1.54478603137642, 218, 27, 'PPL', 'P'),
(126848, 'Bear Trap Landing', 45.2436103820801, 0.789649966656787, -67.793327331543, -1.18321677281769, 218, 26, 'PPL', 'P'),
(134138, 'Bear Valley', 44.3033294677734, 0.773238968808474, -92.4772186279297, -1.61403194814401, 218, 28, 'PPL', 'P'),
(158985, 'Bear Valley', 40.7724990844727, 0.711614353290421, -76.5777816772461, -1.33653442414133, 218, 45, 'PPL', 'P'),
(173102, 'Bear Valley', 43.3080596923828, 0.755868234282323, -90.1949996948242, -1.57419971350996, 218, 57, 'PPL', 'P'),
(179995, 'Bear Valley', 37.5688896179199, 0.655700820151017, -120.11833190918, -2.09646038381855, 218, 6, 'PPL', 'P'),
(179996, 'Bear Valley (historical)', 39.309440612793, 0.686079165810415, -120.683326721191, -2.10632140354484, 218, 6, 'PPL', 'P'),
(192477, 'Bear Valley Junction', 37.9652786254883, 0.662619113451798, -112.411666870117, -1.96195370453857, 218, 52, 'PPL', 'P'),
(179997, 'Bear Valley Springs', 35.1591682434082, 0.613643248110104, -118.627502441406, -2.07044050102015, 218, 6, 'PPL', 'P'),
(29172, 'Bear Wallow', 39.3236083984375, 0.686326440317629, -86.3688888549805, -1.50742148180844, 218, 19, 'PPL', 'P'),
(34708, 'Bear Wallow', 37.151668548584, 0.648418938782413, -85.8561096191406, -1.49847179580718, 218, 21, 'PPL', 'P'),
(84874, 'Bear Wallow', 35.6891708374023, 0.622893538419413, -86.7608337402344, -1.51426221054248, 218, 50, 'PPL', 'P'),
(62777, 'Bear Wallow Hollow', 35.1097183227539, 0.612780184179837, -82.9561080932617, -1.44785722086773, 218, 33, 'PPL', 'P'),
(62778, 'Bear Wallow Springs', 35.1116714477539, 0.61281427264179, -82.9591674804688, -1.44791061724759, 218, 33, 'PPL', 'P'),
(53377, 'Bearcreek', 37.6572189331055, 0.657242457527037, -93.6580581665039, -1.63464148602986, 218, 29, 'PPL', 'P'),
(195942, 'Bearcreek', 45.160831451416, 0.788205201765419, -109.156387329102, -1.90513835847504, 218, 31, 'PPL', 'P'),
(151, 'Beard', 38.0766716003418, 0.664563287626583, -80.2275009155273, -1.40023404162272, 218, 58, 'PPL', 'P'),
(19120, 'Beard', 34.1472206115723, 0.595981430076808, -83.9805603027344, -1.46573728495236, 218, 13, 'PPL', 'P'),
(62779, 'Beard', 35.1163902282715, 0.612896630898501, -78.7991714477539, -1.37530498960681, 218, 33, 'PPL', 'P'),
(92512, 'Beard', 29.6772193908691, 0.517965191207373, -96.2508316040039, -1.67989391927248, 218, 51, 'PPL', 'P'),
(122200, 'Beard', 40.3736114501953, 0.704652450726791, -86.4505615234375, -1.50884693878191, 218, 19, 'PPL', 'P'),
(7334, 'Beard (historical)', 35.151668548584, 0.613512353742527, -91.2805633544922, -1.59314637361117, 218, 4, 'PPL', 'P'),
(108120, 'Beard Heights', 38.207218170166, 0.6668417550972, -80.1074981689453, -1.39813959858342, 218, 58, 'PPL', 'P'),
(7335, 'Bearden', 33.7244415283203, 0.588602543065498, -92.6155624389648, -1.61644650314633, 218, 4, 'PPL', 'P'),
(75081, 'Bearden', 35.3480606079102, 0.616940041802541, -96.3883285522461, -1.68229369373075, 218, 42, 'PPL', 'P'),
(84875, 'Bearden', 35.9327812194824, 0.627145341678751, -84.0027770996094, -1.46612504120708, 218, 50, 'PPL', 'P'),
(58584, 'Beardens', 31.1827793121338, 0.544242168919507, -90.3300018310547, -1.57655594528441, 218, 30, 'PPL', 'P'),
(186394, 'Beards Corner', 38.0658302307129, 0.664374070031133, -108.611389160156, -1.89562634600961, 218, 7, 'PPL', 'P'),
(19121, 'Beards Creek', 31.8661098480225, 0.556168536650182, -81.8855590820313, -1.42917261581779, 218, 13, 'PPL', 'P'),
(79699, 'Beards Crossroads', 33.8613891601563, 0.590992730143844, -80.0405578613281, -1.39697126981321, 218, 48, 'PPL', 'P'),
(108121, 'Beards Fork', 38.0636100769043, 0.664335321037272, -81.2275009155273, -1.41768733414266, 218, 58, 'PPL', 'P'),
(147071, 'Beards Hollow', 42.6063919067383, 0.743621821167648, -74.554443359375, -1.30122050861272, 218, 40, 'PPL', 'P'),
(77, 'Beards Mill', 33.3655586242676, 0.582338854760659, -88.1197204589844, -1.53797925794629, 218, 2, 'PPL', 'P'),
(134139, 'Beardsley', 45.5583305358887, 0.79514286956313, -96.7119369506836, -1.68794172577059, 218, 28, 'PPL', 'P'),
(169803, 'Beardsley', 43.2983283996582, 0.755698391183803, -97.9819412231445, -1.71010748183943, 218, 49, 'PPL', 'P'),
(187592, 'Beardsley', 39.8144416809082, 0.694893097175114, -101.22721862793, -1.76674825769351, 218, 20, 'PPL', 'P'),
(193108, 'Beardsley', 33.6613883972168, 0.58750205832405, -112.378326416016, -1.96137180384039, 218, 5, 'PPL', 'P'),
(154224, 'Beardsley (historical)', 41.5486106872559, 0.725160056121919, -81.0719375610352, -1.41497224141132, 218, 41, 'PPL', 'P'),
(84876, 'Beardstown', 35.7122192382813, 0.623295808902069, -87.7991714477539, -1.5323846222863, 218, 50, 'PPL', 'P'),
(118745, 'Beardstown', 40.0175018310547, 0.698437165374764, -90.4241714477539, -1.57819951515115, 218, 18, 'PPL', 'P'),
(122201, 'Beardstown', 41.1380615234375, 0.717994621471979, -86.6025009155273, -1.51149878143736, 218, 19, 'PPL', 'P'),
(195943, 'Bearmouth', 46.7102813720703, 0.815248204475601, -113.330558776855, -1.97799139378109, 218, 31, 'PPL', 'P'),
(195944, 'Bearpaw (historical)', 48.2277793884277, 0.841733541253521, -109.522216796875, -1.91152328718851, 218, 31, 'PPL', 'P'),
(79700, 'Bears Bluff', 32.644718170166, 0.569757815455015, -80.2538909912109, -1.40069463533325, 218, 48, 'PPL', 'P'),
(158986, 'Bears Crossroads', 40.1983299255371, 0.70159321100359, -77.3399963378906, -1.34983757957655, 218, 45, 'PPL', 'P'),
(154225, 'Bears Mill', 40.1108283996582, 0.700066021276484, -84.5408325195313, -1.47551587984291, 218, 41, 'PPL', 'P'),
(26467, 'Bearsdale', 39.8969383239746, 0.696332935218465, -89.0111083984375, -1.55353691240231, 218, 18, 'PPL', 'P'),
(62782, 'Bearskin', 35.0538902282715, 0.611805800116004, -78.4369430541992, -1.36898291149507, 218, 33, 'PPL', 'P'),
(108122, 'Bearsville', 39.4075012207031, 0.687790646284954, -80.9138870239258, -1.41221373915422, 218, 58, 'PPL', 'P'),
(147072, 'Bearsville', 42.0405616760254, 0.733746220634389, -74.1555633544922, -1.29425873920714, 218, 40, 'PPL', 'P'),
(34709, 'Beartown', 38.1861114501953, 0.666473373339415, -83.188606262207, -1.45191507942069, 218, 21, 'PPL', 'P'),
(84877, 'Beartown', 36.5699996948242, 0.638266902128004, -82.5955581665039, -1.44156443752798, 218, 50, 'PPL', 'P'),
(108123, 'Beartown', 37.3861083984375, 0.652510686060238, -81.8116683959961, -1.42788298005992, 218, 58, 'PPL', 'P'),
(147075, 'Beartown', 43.3286094665527, 0.756226895502129, -73.7655563354492, -1.28745183261895, 218, 40, 'PPL', 'P'),
(154227, 'Beartown', 41.3583297729492, 0.721839027663563, -81.290283203125, -1.41878309177317, 218, 41, 'PPL', 'P'),
(158987, 'Beartown', 40.1113891601563, 0.70007580839349, -75.977783203125, -1.32606247526097, 218, 45, 'PPL', 'P'),
(171722, 'Beartown', 43.1897201538086, 0.753802819698912, -73.129997253418, -1.27635923404655, 218, 55, 'PPL', 'P'),
(195945, 'Beartown', 46.7933311462402, 0.816697696477904, -113.339172363281, -1.97814172922462, 218, 31, 'PPL', 'P'),
(209296, 'Beartown', 41.1566696166992, 0.718319393966914, -110.847221374512, -1.93464897967226, 218, 59, 'PPL', 'P'),
(186395, 'Beartown (historical)', 37.7227783203125, 0.658386684689389, -107.503326416016, -1.87628700280567, 218, 7, 'PPL', 'P'),
(34710, 'Bearville', 37.3691711425781, 0.65221507517924, -83.067497253418, -1.44980132846349, 218, 21, 'PPL', 'P'),
(34711, 'Bearwallow', 37.7036094665527, 0.658052125077448, -85.317497253418, -1.48907123663336, 218, 21, 'PPL', 'P'),
(62783, 'Bearwallow', 35.4630584716797, 0.618947133158079, -82.3163909912109, -1.43669205115563, 218, 33, 'PPL', 'P'),
(84878, 'Bearwallow', 36.2983283996582, 0.6335253435442, -86.9952774047852, -1.51835402439933, 218, 50, 'PPL', 'P'),
(99715, 'Bearwallow', 37.2413902282715, 0.64998487750338, -81.7444381713867, -1.42670959128363, 218, 53, 'PPL', 'P'),
(83, 'Beasley', 33.2119407653809, 0.579657717333222, -88.0999984741211, -1.53763504437539, 218, 2, 'PPL', 'P'),
(998, 'Beasley', 29.4972190856934, 0.514823593227461, -95.9177780151367, -1.67408103756117, 218, 51, 'PPL', 'P'),
(7338, 'Beasley', 35.4677810668945, 0.619029557993817, -90.3227767944336, -1.5764298446068, 218, 4, 'PPL', 'P'),
(58585, 'Beasley', 33.6847190856934, 0.587909255654723, -88.9291687011719, -1.55210679489694, 218, 30, 'PPL', 'P'),
(62785, 'Beasley', 35.9155616760254, 0.626844803949736, -76.5491714477539, -1.33603508143694, 218, 33, 'PPL', 'P'),
(84879, 'Beasley', 35.6800003051758, 0.622733482437899, -86.6519393920898, -1.51236164563054, 218, 50, 'PPL', 'P'),
(82, 'Beasley (historical)', 33.7574996948242, 0.589179516915664, -85.9816665649414, -1.50066317791015, 218, 2, 'PPL', 'P'),
(84880, 'Beasley (historical)', 36.0011100769043, 0.628337905214889, -87.5169372558594, -1.52745870637604, 218, 50, 'PPL', 'P'),
(92513, 'Beasley Crossing', 31.4561100006104, 0.549012689380166, -99.1083297729492, -1.72976667069029, 218, 51, 'PPL', 'P'),
(84881, 'Beasley Crossroads', 35.8677787780762, 0.626010835054378, -87.147216796875, -1.52100586705478, 218, 50, 'PPL', 'P'),
(71758, 'Beasley Fork', 38.7497215270996, 0.676310224878813, -83.5163879394531, -1.45763594891634, 218, 41, 'PPL', 'P'),
(19122, 'Beasley Gap', 34.3488883972168, 0.599501196931511, -84.5972213745117, -1.47650005102375, 218, 13, 'PPL', 'P'),
(84882, 'Beasley Road', 35.8458290100098, 0.62562773933157, -86.4930572509766, -1.5095886291455, 218, 50, 'PPL', 'P'),
(118747, 'Beason', 40.1436080932617, 0.70063813485766, -89.1933288574219, -1.55671725937608, 218, 18, 'PPL', 'P'),
(99716, 'Beaties Mill', 37.6216697692871, 0.656622007572076, -77.253059387207, -1.34832024354548, 218, 53, 'PPL', 'P'),
(691, 'Beatline', 32.6730613708496, 0.570252497627498, -89.0749969482422, -1.55465197795073, 218, 30, 'PPL', 'P'),
(7340, 'Beaton', 34.3052787780762, 0.598740065491966, -93.2613906860352, -1.62771833246009, 218, 4, 'PPL', 'P'),
(129721, 'Beaton', 46.2958297729492, 0.808014659480783, -89.3391723632813, -1.55926270874598, 218, 27, 'PPL', 'P'),
(90, 'Beatrice', 31.7333297729492, 0.553851087159108, -87.204719543457, -1.52200947931157, 218, 2, 'PPL', 'P'),
(19123, 'Beatrice', 32.0069389343262, 0.558626467888757, -84.9049987792969, -1.4818717801005, 218, 13, 'PPL', 'P'),
(58587, 'Beatrice', 30.7388896942139, 0.536494833571385, -88.9469375610352, -1.55241692000588, 218, 30, 'PPL', 'P'),
(108124, 'Beatrice', 39.0838890075684, 0.682142547666087, -81.1399993896484, -1.41616014441555, 218, 58, 'PPL', 'P'),
(122202, 'Beatrice', 41.4269409179688, 0.723036518047717, -87.1894378662109, -1.5217427637284, 218, 19, 'PPL', 'P'),
(141250, 'Beatrice', 40.2680587768555, 0.702810209042729, -96.7466735839844, -1.68854799439275, 218, 35, 'PPL', 'P'),
(193368, 'Beatrice', 40.6699981689453, 0.709825374828161, -124.201393127441, -2.16772324563771, 218, 6, 'PPL', 'P'),
(206792, 'Beatrice', 46.8819389343262, 0.818244194122913, -118.765830993652, -2.07285478970636, 218, 56, 'PPL', 'P'),
(31763, 'Beattie', 39.8611106872559, 0.695707624994514, -96.4194412231445, -1.68283671227702, 218, 20, 'PPL', 'P'),
(92514, 'Beattie', 32.0380592346191, 0.559169619593078, -98.6922225952148, -1.72250423039764, 218, 51, 'PPL', 'P'),
(143506, 'Beatties', 44.7077789306641, 0.780297943593838, -71.5952835083008, -1.24957342611865, 218, 36, 'PPL', 'P'),
(58588, 'Beatty', 33.269718170166, 0.58066612327998, -89.7388916015625, -1.56623912553755, 218, 30, 'PPL', 'P'),
(71759, 'Beatty', 39.8816719055176, 0.696066485951403, -83.8402786254883, -1.4632889078042, 218, 41, 'PPL', 'P'),
(158988, 'Beatty', 40.3016700744629, 0.703396836851846, -79.4186096191406, -1.38611622521004, 218, 45, 'PPL', 'P'),
(192951, 'Beatty', 36.9086112976074, 0.644176789482026, -116.758331298828, -2.0378173102989, 218, 39, 'PPL', 'P'),
(200388, 'Beatty', 42.4419403076172, 0.740751599302815, -121.269721984863, -2.11655593161402, 218, 43, 'PPL', 'P'),
(209857, 'Beatty', 43.6083297729492, 0.761108935833435, -116.339996337891, -2.03051598785434, 218, 17, 'PPL', 'P'),
(180000, 'Beatty Junction', 36.5880584716797, 0.638582087243015, -116.942222595215, -2.04102681888661, 218, 6, 'PPL', 'P'),
(191118, 'Beatty Place', 30.3691692352295, 0.530041994250123, -103.33528137207, -1.80354089341739, 218, 51, 'PPL', 'P'),
(188120, 'Beatty Wells', 33.725830078125, 0.588626777831418, -103.949722290039, -1.81426491049492, 218, 38, 'PPL', 'P'),
(112257, 'Beattys Corner', 27.9666690826416, 0.488110456307798, -82.1708297729492, -1.43415152863375, 218, 12, 'PPL', 'P'),
(122203, 'Beattys Corner', 41.6222190856934, 0.726444765031773, -86.8938903808594, -1.51658448701303, 218, 19, 'PPL', 'P'),
(171723, 'Beattys Four Corners', 44.9394416809082, 0.784341221339823, -72.8627777099609, -1.27169537318755, 218, 55, 'PPL', 'P'),
(144804, 'Beattystown', 40.813060760498, 0.712322288087192, -74.8433303833008, -1.30626253834651, 218, 37, 'PPL', 'P'),
(34717, 'Beattyville', 37.5716705322266, 0.655749356261884, -83.7069396972656, -1.46096170448563, 218, 21, 'PPL', 'P'),
(19126, 'Beatum', 34.5791702270508, 0.603520373069631, -85.149169921875, -1.48613337047684, 218, 13, 'PPL', 'P'),
(7342, 'Beaty', 36.4513893127441, 0.636196760433658, -94.5250015258789, -1.64977250207925, 218, 4, 'PPL', 'P'),
(118748, 'Beaty', 40.2750015258789, 0.702931382872327, -90.2458267211914, -1.57508681246907, 218, 18, 'PPL', 'P'),
(112193, 'Beaty Crossroads', 34.6955604553223, 0.605551765770116, -85.6694412231445, -1.49521381768763, 218, 2, 'PPL', 'P'),
(122204, 'Beatys Beach', 41.6841697692871, 0.727526008434345, -85.6036071777344, -1.49406479683532, 218, 19, 'PPL', 'P'),
(108125, 'Beatysville (historical)', 39.0369415283203, 0.681323159577697, -81.6272201538086, -1.42466375093423, 218, 58, 'PPL', 'P'),
(44675, 'Beau Monde Estates', 39.2130584716797, 0.684396980107866, -77.2594375610352, -1.34843156367904, 218, 25, 'PPL', 'P'),
(99719, 'Beau Ridge', 38.9505615234375, 0.679815544084603, -77.2774963378906, -1.34874674879405, 218, 53, 'PPL', 'P'),
(7343, 'Beau-O-Rama', 36.1463890075684, 0.630873500888753, -94.0597229003906, -1.64165185812533, 218, 4, 'PPL', 'P'),
(7344, 'Beauchamp', 34.8050003051758, 0.607461851482949, -94.2705612182617, -1.64533168096154, 218, 4, 'PPL', 'P'),
(15153, 'Beauclerc', 30.2000007629395, 0.527089447418093, -81.6333312988281, -1.42477041053589, 218, 12, 'PPL', 'P'),
(15154, 'Beauclerc Gardens', 30.1988906860352, 0.527070072921163, -81.6322174072266, -1.42475096945993, 218, 12, 'PPL', 'P'),
(26468, 'Beaucoup', 38.3497200012207, 0.669328881239225, -89.2919387817383, -1.55843832723055, 218, 18, 'PPL', 'P'),
(39292, 'Beaud', 30.7066707611084, 0.535932507107215, -91.4933319091797, -1.59685988543518, 218, 22, 'PPL', 'P'),
(7345, 'Beaudry (historical)', 34.7130584716797, 0.605857163768121, -92.9916687011719, -1.62301079575921, 218, 4, 'PPL', 'P'),
(99717, 'Beaufont Hills', 37.5113906860352, 0.654697274473248, -77.5083312988281, -1.35277557889112, 218, 53, 'PPL', 'P'),
(134142, 'Beauford', 44.0074996948242, 0.768075765245082, -93.9583282470703, -1.63988218758097, 218, 28, 'PPL', 'P'),
(53378, 'Beaufort', 38.4208297729492, 0.670569980886229, -91.1888885498047, -1.59154634642825, 218, 29, 'PPL', 'P'),
(62786, 'Beaufort', 34.7180595397949, 0.605944448872849, -76.6641693115234, -1.33804217279248, 218, 33, 'PPL', 'P'),
(79702, 'Beaufort', 32.4313888549805, 0.566034516514003, -80.6699981689453, -1.40795707562589, 218, 48, 'PPL', 'P'),
(144805, 'Beaufort', 40.8177795410156, 0.712404646343902, -74.3300018310547, -1.29730326496532, 218, 37, 'PPL', 'P'),
(79704, 'Beaufort County Landing', 32.3233299255371, 0.564148532409036, -80.6055603027344, -1.40683242269755, 218, 48, 'PPL', 'P'),
(99718, 'Beaufort Estates', 37.5102806091309, 0.654677899976318, -77.5441665649414, -1.35340102227313, 218, 53, 'PPL', 'P'),
(158990, 'Beaufort Farms', 40.3241691589355, 0.703789519954578, -76.8852767944336, -1.34190122637006, 218, 45, 'PPL', 'P'),
(44676, 'Beaufort Park', 39.1416702270508, 0.683151020191873, -76.9436111450195, -1.34291935285479, 218, 25, 'PPL', 'P'),
(39289, 'Beaujolais', 29.7855606079102, 0.519856102160356, -90.7680587768555, -1.58420148129987, 218, 22, 'PPL', 'P'),
(92515, 'Beaukiss', 30.4427795410156, 0.531326736449491, -97.2441711425781, -1.69723096481084, 218, 51, 'PPL', 'P'),
(19124, 'Beaulieu', 31.9325008392334, 0.557327278040475, -81.1130599975586, -1.4156899633251, 218, 13, 'PPL', 'P'),
(39290, 'Beaulieu', 30.4238891601563, 0.530997037106539, -91.2161102294922, -1.59202145436672, 218, 22, 'PPL', 'P'),
(134144, 'Beaulieu', 47.3355598449707, 0.826161372569555, -95.8041687011719, -1.67209818097155, 218, 28, 'PPL', 'P'),
(171724, 'Beaulieus Corner', 44.9466705322266, 0.784467388596466, -73.01611328125, -1.27437158376697, 218, 55, 'PPL', 'P'),
(31761, 'Beaumont', 37.6580581665039, 0.657257104913032, -96.5325012207031, -1.68480998148671, 218, 20, 'PPL', 'P'),
(34712, 'Beaumont', 36.875560760498, 0.643599948789915, -85.6519393920898, -1.4949083531106, 218, 21, 'PPL', 'P'),
(58589, 'Beaumont', 31.1691703796387, 0.544004648239786, -88.9199981689453, -1.55194673891542, 218, 30, 'PPL', 'P'),
(71760, 'Beaumont', 39.3855590820313, 0.687407683720201, -82.1383285522461, -1.43358427532156, 218, 41, 'PPL', 'P'),
(92516, 'Beaumont', 30.0858306884766, 0.525096803711468, -94.1016693115234, -1.64238396110899, 218, 51, 'PPL', 'P'),
(99720, 'Beaumont', 37.6652793884277, 0.65738313901162, -77.908332824707, -1.35975692253071, 218, 53, 'PPL', 'P'),
(158989, 'Beaumont', 41.4099998474121, 0.722740840587691, -75.9966735839844, -1.32639217460393, 218, 45, 'PPL', 'P'),
(173103, 'Beaumont', 42.7422218322754, 0.745992500591009, -88.1102828979492, -1.53781454143286, 218, 57, 'PPL', 'P'),
(179999, 'Beaumont', 33.9294395446777, 0.592180433410992, -116.976387023926, -2.04162310065468, 218, 6, 'PPL', 'P'),
(206793, 'Beaumont', 47.5883293151855, 0.830573032073326, -122.226387023926, -2.13325288638438, 218, 56, 'PPL', 'P'),
(34713, 'Beaumont Park', 38.0325012207031, 0.663792369070032, -84.5602798461914, -1.47585529972384, 218, 21, 'PPL', 'P'),
(44677, 'Beaumont Park', 39.3555603027344, 0.686884106249891, -76.6100006103516, -1.3370967506055, 218, 25, 'PPL', 'P'),
(92517, 'Beaumont Place', 29.8369407653809, 0.520752855078413, -95.1994400024414, -1.6615436740974, 218, 51, 'PPL', 'P'),
(19125, 'Beaumount', 34.8380584716797, 0.608038825333114, -85.1919403076172, -1.48687985453039, 218, 13, 'PPL', 'P'),
(94, 'Beauregard', 32.5430603027344, 0.567983550957777, -85.3708267211914, -1.49000201143435, 218, 2, 'PPL', 'P'),
(58590, 'Beauregard', 31.7216701507568, 0.553647588362313, -90.3822174072266, -1.57746727900944, 218, 30, 'PPL', 'P'),
(39293, 'Beauregard Town', 30.4449996948242, 0.531365485443351, -91.1875, -1.59152211166233, 218, 22, 'PPL', 'P'),
(62791, 'Beautancus', 35.1175003051758, 0.612916005395431, -78.0386123657227, -1.36203072946942, 218, 33, 'PPL', 'P'),
(34714, 'Beauty', 37.8400001525879, 0.660432591617815, -82.4391708374023, -1.43883496372676, 218, 21, 'PPL', 'P'),
(108126, 'Beauty', 38.0447196960449, 0.66400562169432, -81.0163879394531, -1.41400271761648, 218, 58, 'PPL', 'P'),
(44678, 'Beauty Beach', 39.1527786254883, 0.68334489831923, -76.5466690063477, -1.33599140559506, 218, 25, 'PPL', 'P'),
(84883, 'Beauty Hill', 35.2622184753418, 0.615441813952289, -88.5416717529297, -1.54534369730868, 218, 50, 'PPL', 'P'),
(79706, 'Beauty Spot (historical)', 34.8958282470703, 0.609047098121818, -81.470832824707, -1.42193427713301, 218, 48, 'PPL', 'P'),
(58591, 'Beauvoir', 30.3936100006104, 0.530468566077726, -88.9672164916992, -1.55277085411475, 218, 30, 'PPL', 'P'),
(44679, 'Beauvue', 38.2527809143066, 0.667636974998698, -76.6269378662109, -1.3373923614865, 218, 25, 'PPL', 'P'),
(62792, 'Beaux (historical)', 36.3405609130859, 0.634262439954907, -81.230827331543, -1.41774539105442, 218, 33, 'PPL', 'P'),
(206794, 'Beaux Arts Village', 47.5838890075684, 0.830495534085605, -122.194442749023, -2.13269535361017, 218, 56, 'PPL', 'P'),
(92518, 'Beauxart Gardens', 29.9605598449707, 0.522910415035541, -94.0347213745117, -1.64121549918072, 218, 51, 'PPL', 'P'),
(7346, 'Beaver', 36.4736099243164, 0.636584583267401, -93.767219543457, -1.6365467114737, 218, 4, 'PPL', 'P'),
(31762, 'Beaver', 38.6402816772461, 0.674400139165981, -98.6666717529297, -1.72205828407311, 218, 20, 'PPL', 'P'),
(34715, 'Beaver', 37.396671295166, 0.652695043386699, -82.6544418334961, -1.44259215139265, 218, 21, 'PPL', 'P'),
(39294, 'Beaver', 30.795560836792, 0.53748393160024, -92.5719375610352, -1.61568510539067, 218, 22, 'PPL', 'P'),
(71761, 'Beaver', 39.0305595397949, 0.681211772865104, -82.8244400024414, -1.4455591791631, 218, 41, 'PPL', 'P'),
(84884, 'Beaver', 35.502498626709, 0.619635493720837, -89.8108291625977, -1.56749467283347, 218, 50, 'PPL', 'P'),
(99721, 'Beaver', 36.9402809143066, 0.644729528566272, -81.274169921875, -1.41850186196206, 218, 53, 'PPL', 'P'),
(108128, 'Beaver', 37.747501373291, 0.658818183365009, -81.1425018310547, -1.41620382025743, 218, 58, 'PPL', 'P'),
(114530, 'Beaver', 42.038330078125, 0.733707271903446, -94.1419372558594, -1.64308676932066, 218, 16, 'PPL', 'P'),
(124205, 'Beaver', 42.047779083252, 0.73387218815395, -70.9783325195313, -1.23880560004118, 218, 23, 'PPL', 'P'),
(129724, 'Beaver', 45.9855613708496, 0.802599454299243, -87.1097183227539, -1.52035139521689, 218, 27, 'PPL', 'P'),
(134146, 'Beaver', 44.1533317565918, 0.770621014877898, -92.0122222900391, -1.6059162310381, 218, 28, 'PPL', 'P'),
(158991, 'Beaver', 40.6952781677246, 0.71026659404176, -80.3050003051758, -1.40158666114037, 218, 45, 'PPL', 'P'),
(173104, 'Beaver', 45.1375007629395, 0.787798004434746, -88.0177764892578, -1.536200000022, 218, 57, 'PPL', 'P'),
(190953, 'Beaver', 36.8161087036133, 0.642562314650193, -100.519439697266, -1.75439518497718, 218, 42, 'PPL', 'P'),
(192478, 'Beaver', 38.2769393920898, 0.668058619978285, -112.640281677246, -1.96594378564179, 218, 52, 'PPL', 'P'),
(200389, 'Beaver', 45.2769393920898, 0.790231667617888, -123.82527923584, -2.16115881986677, 218, 43, 'PPL', 'P'),
(206795, 'Beaver', 48.0574989318848, 0.838761586635047, -124.34610748291, -2.17024898761554, 218, 56, 'PPL', 'P'),
(212297, 'Beaver', 66.5, 1.16064395257623, -146.91667175293, -2.56417964816037, 218, 1, 'PPL', 'P'),
(199829, 'Beaver (historical)', 41.0805587768555, 0.716991009215182, -115.530563354492, -2.01638871721979, 218, 39, 'PPL', 'P'),
(134147, 'Beaver Bay', 47.2577781677246, 0.824803826203887, -91.3002777099609, -1.59349045402401, 218, 28, 'PPL', 'P'),
(34716, 'Beaver Bottom', 37.3147201538086, 0.651264726144245, -82.3605575561523, -1.43746290313315, 218, 21, 'PPL', 'P'),
(124206, 'Beaver Brook', 42.2638893127441, 0.737644023205829, -71.8291702270508, -1.25365551943752, 218, 23, 'PPL', 'P'),
(158996, 'Beaver Brook', 40.9180603027344, 0.714154875812303, -75.9897232055664, -1.32627086761627, 218, 45, 'PPL', 'P'),
(173106, 'Beaver Brook', 45.7533302307129, 0.798546256278197, -91.8388900756836, -1.60289101319782, 218, 57, 'PPL', 'P'),
(124207, 'Beaver Brook (historical)', 42.5791702270508, 0.743146713229178, -70.9583282470703, -1.23845645962227, 218, 23, 'PPL', 'P'),
(13344, 'Beaver Brook Apartments', 39.6402816772461, 0.691853431685925, -75.6230621337891, -1.31987142467487, 218, 10, 'PPL', 'P'),
(158992, 'Beaver Brook Manor', 40.3133316040039, 0.703600368938155, -76.7900009155273, -1.34023834858541, 218, 45, 'PPL', 'P'),
(124208, 'Beaver Brook Station', 42.3791694641113, 0.739656041409384, -71.220832824707, -1.24303802880359, 218, 23, 'PPL', 'P'),
(99722, 'Beaver Castle Mobile Home Park', 37.2897186279297, 0.650828367199635, -77.209716796875, -1.34756377263784, 218, 53, 'PPL', 'P'),
(158993, 'Beaver Center', 41.8022193908691, 0.729586363011685, -80.4674987792969, -1.40442279454325, 218, 45, 'PPL', 'P'),
(122205, 'Beaver City', 40.9069404602051, 0.713960797947863, -87.4155578613281, -1.52568930214779, 218, 19, 'PPL', 'P'),
(141252, 'Beaver City', 40.1375007629395, 0.70053154183503, -99.8291702270508, -1.74234770999593, 218, 35, 'PPL', 'P'),
(158994, 'Beaver City', 41.2236099243164, 0.719487722737132, -79.5558319091797, -1.38851120597835, 218, 45, 'PPL', 'P'),
(19127, 'Beaver Cove', 33.1199989318848, 0.578053029618394, -85.086669921875, -1.48504253969435, 218, 13, 'PPL', 'P'),
(15155, 'Beaver Creek', 30.8799991607666, 0.538957658368463, -86.7786102294922, -1.51457246880947, 218, 12, 'PPL', 'P'),
(19130, 'Beaver Creek', 33.5888900756836, 0.586236723911126, -83.9416732788086, -1.46505857834855, 218, 13, 'PPL', 'P'),
(26470, 'Beaver Creek', 38.7675018310547, 0.676620549724835, -89.3936080932617, -1.56021279146487, 218, 18, 'PPL', 'P'),
(44680, 'Beaver Creek', 39.5838890075684, 0.690869193926059, -77.642219543457, -1.35511236958961, 218, 25, 'PPL', 'P'),
(62794, 'Beaver Creek', 35.0936088562012, 0.612499020947752, -78.9863891601563, -1.37857255510629, 218, 33, 'PPL', 'P'),
(79708, 'Beaver Creek', 34.0833282470703, 0.594866297949364, -80.7263870239258, -1.40894124680673, 218, 48, 'PPL', 'P'),
(134150, 'Beaver Creek', 43.6141700744629, 0.761210868324158, -96.3641662597656, -1.68187198217214, 218, 28, 'PPL', 'P'),
(195947, 'Beaver Creek', 48.5544395446777, 0.847434836515163, -109.791389465332, -1.91622123650946, 218, 31, 'PPL', 'P'),
(200390, 'Beaver Creek', 45.2880592346191, 0.790425745482327, -122.534439086914, -2.13862940915108, 218, 43, 'PPL', 'P'),
(209297, 'Beaver Creek', 43.6872215270996, 0.762485856696033, -110.734718322754, -1.93268543100055, 218, 59, 'PPL', 'P'),
(44681, 'Beaver Creek Estates', 39.6055603027344, 0.691247429379877, -77.6202774047852, -1.35472940702486, 218, 25, 'PPL', 'P'),
(134152, 'Beaver Crossing', 47.2422218322754, 0.824532316930754, -91.5247192382813, -1.5974076976714, 218, 28, 'PPL', 'P'),
(141255, 'Beaver Crossing', 40.7786102294922, 0.711721012892079, -97.2819366455078, -1.69789009718064, 218, 35, 'PPL', 'P'),
(201892, 'Beaver Crossing', 44.3827781677246, 0.774625610209051, -104.003326416016, -1.81520047898587, 218, 49, 'PPL', 'P'),
(34718, 'Beaver Dam', 37.4019393920898, 0.652786989023334, -86.8758316040039, -1.51626930189801, 218, 21, 'PPL', 'P'),
(70523, 'Beaver Dam', 39.6502799987793, 0.692027935316352, -75.4925003051758, -1.31759269088814, 218, 37, 'PPL', 'P'),
(79709, 'Beaver Dam', 34.5394401550293, 0.602826952500802, -81.545280456543, -1.42323363342886, 218, 48, 'PPL', 'P'),
(122208, 'Beaver Dam', 41.086109161377, 0.717087881699834, -86.0133285522461, -1.50121578383634, 218, 19, 'PPL', 'P'),
(158997, 'Beaver Dam', 41.9272193908691, 0.731768024576678, -79.7505569458008, -1.39190979900346, 218, 45, 'PPL', 'P'),
(173107, 'Beaver Dam', 43.4577789306641, 0.758481327943908, -88.8372192382813, -1.55050197402406, 218, 57, 'PPL', 'P'),
(84885, 'Beaver Dam (historical)', 36.0111083984375, 0.628512408845316, -83.3452835083008, -1.45464961322798, 218, 50, 'PPL', 'P'),
(13345, 'Beaver Dam Acres', 38.6872215270996, 0.675219394096317, -75.2099990844727, -1.31266211444597, 218, 10, 'PPL', 'P'),
(154229, 'Beaver Dam Station', 40.8327789306641, 0.712666435079057, -83.9763870239258, -1.46566444749655, 218, 41, 'PPL', 'P'),
(147076, 'Beaver Dams', 42.2911109924316, 0.738119131144299, -76.9599990844727, -1.34320537635587, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(192480, 'Beaver Dams Summer Homes Area', 39.6458282470703, 0.691950237591549, -111.28971862793, -1.94237201367544, 218, 52, 'PPL', 'P'),
(173110, 'Beaver Edge', 43.4847183227539, 0.758951509034362, -88.834716796875, -1.55045829818218, 218, 57, 'PPL', 'P'),
(134153, 'Beaver Falls', 44.5830612182617, 0.778121208876861, -95.0469436645508, -1.65888211090398, 218, 28, 'PPL', 'P'),
(147077, 'Beaver Falls', 43.8869400024414, 0.765971601667811, -75.4277801513672, -1.31646311111178, 218, 40, 'PPL', 'P'),
(158998, 'Beaver Falls', 40.7519416809082, 0.711255558912561, -80.3194427490234, -1.40183872933754, 218, 45, 'PPL', 'P'),
(209938, 'Beaver Falls', 55.3833312988281, 0.966621481887378, -131.466674804688, -2.29452633199047, 218, 1, 'PPL', 'P'),
(195948, 'Beaver Flats (historical)', 45.8450012207031, 0.800146216882089, -104.700828552246, -1.82737418780278, 218, 31, 'PPL', 'P'),
(129726, 'Beaver Grove', 46.4811096191406, 0.811248402834411, -87.315559387207, -1.52394399952741, 218, 27, 'PPL', 'P'),
(177484, 'Beaver Head Corner', 41.3894386291504, 0.722381979630803, -72.7347183227539, -1.2694603152427, 218, 8, 'PPL', 'P'),
(84886, 'Beaver Hill', 36.2347183227539, 0.632415138264773, -85.293327331543, -1.48864939191669, 218, 50, 'PPL', 'P'),
(99724, 'Beaver Hill Mobile Home Park', 38.0705604553223, 0.664456628024925, -78.6672210693359, -1.37300202105417, 218, 53, 'PPL', 'P'),
(19131, 'Beaver Hills', 33.9172210693359, 0.591967180786704, -84.126106262207, -1.46827754115813, 218, 13, 'PPL', 'P'),
(200391, 'Beaver Homes', 46.0058288574219, 0.802953188671033, -122.925827026367, -2.14546041734714, 218, 43, 'PPL', 'P'),
(62796, 'Beaver Island', 36.4599990844727, 0.636347029298166, -79.9902801513672, -1.39609375823403, 218, 33, 'PPL', 'P'),
(34719, 'Beaver Junction', 37.6136093139648, 0.656481326087492, -82.7316665649414, -1.44393997722033, 218, 21, 'PPL', 'P'),
(144806, 'Beaver Lake', 41.1074981689453, 0.717461190305636, -74.5538864135742, -1.30121078807474, 218, 37, 'PPL', 'P'),
(159000, 'Beaver Lake', 41.2936096191406, 0.720709447887206, -76.5913925170898, -1.33677197811057, 218, 45, 'PPL', 'P'),
(19132, 'Beaver Lake Estates', 33.564998626709, 0.585819739463447, -84.4524993896484, -1.47397417588787, 218, 13, 'PPL', 'P'),
(147078, 'Beaver Meadow', 42.6594390869141, 0.744547669120614, -75.6805572509766, -1.32087490377361, 218, 40, 'PPL', 'P'),
(159001, 'Beaver Meadows', 40.9280586242676, 0.71432937944273, -75.9150009155273, -1.32496671763046, 218, 45, 'PPL', 'P'),
(71762, 'Beaver Mill', 39.1772193908691, 0.683771470146834, -83.4141693115234, -1.4558518973021, 218, 41, 'PPL', 'P'),
(159003, 'Beaver Mills', 40.8891716003418, 0.713650672838923, -78.038330078125, -1.3620258026214, 218, 45, 'PPL', 'P'),
(99725, 'Beaver Park', 36.663330078125, 0.639895824608751, -79.3455581665039, -1.38484123683817, 218, 53, 'PPL', 'P'),
(154228, 'Beaver Park', 41.4375, 0.72322080879515, -82.2472229003906, -1.4354848402335, 218, 41, 'PPL', 'P'),
(194104, 'Beaver Point', 40.3644409179688, 0.704492394745277, -105.543891906738, -1.84208841914158, 218, 7, 'PPL', 'P'),
(19133, 'Beaver Pond', 34.3911094665527, 0.600238093605136, -83.8033294677734, -1.46264402334623, 218, 13, 'PPL', 'P'),
(71763, 'Beaver Pond', 38.9394416809082, 0.679621466220163, -83.3463897705078, -1.45466892114588, 218, 41, 'PPL', 'P'),
(44682, 'Beaver Ridge', 39.5149993896484, 0.689666843272915, -76.9255599975586, -1.34260430089784, 218, 25, 'PPL', 'P'),
(147079, 'Beaver River', 43.9036102294922, 0.766262552016902, -74.9102783203125, -1.30743100027478, 218, 40, 'PPL', 'P'),
(19134, 'Beaver Run', 32.5438919067383, 0.567998065185718, -84.8608322143555, -1.48110092812297, 218, 13, 'PPL', 'P'),
(144807, 'Beaver Run', 41.1533317565918, 0.718261137318069, -74.620002746582, -1.30236473577507, 218, 37, 'PPL', 'P'),
(44683, 'Beaver Run Manor', 38.3786087036133, 0.669833084212604, -75.5305633544922, -1.31825701642206, 218, 25, 'PPL', 'P'),
(7348, 'Beaver Shores', 36.3227806091309, 0.633952115108885, -94.019172668457, -1.64094412306564, 218, 4, 'PPL', 'P'),
(159004, 'Beaver Springs', 40.7461090087891, 0.711153759579892, -77.209716796875, -1.34756377263784, 218, 45, 'PPL', 'P'),
(200392, 'Beaver Springs', 46.0461082458496, 0.803656196619786, -122.946937561035, -2.14582886568395, 218, 43, 'PPL', 'P'),
(124, 'Beaver Town', 33.1944389343262, 0.57935225275619, -88.1980590820313, -1.53934652484993, 218, 2, 'PPL', 'P'),
(13347, 'Beaver Valley', 39.839168548584, 0.695324662429761, -75.5644378662109, -1.31884823818406, 218, 10, 'PPL', 'P'),
(159006, 'Beaver Valley', 40.9222183227539, 0.714227446952007, -76.2827835083008, -1.33138573480588, 218, 45, 'PPL', 'P'),
(206796, 'Beaver Valley', 47.9261093139648, 0.836468405199407, -122.728889465332, -2.14202320848623, 218, 56, 'PPL', 'P'),
(193110, 'Beaver Valley Estates', 34.336109161377, 0.599278157190217, -111.296112060547, -1.94248360012511, 218, 5, 'PPL', 'P'),
(44684, 'Beaverbrook', 39.6388893127441, 0.691829130340978, -77.6030578613281, -1.35442886929584, 218, 25, 'PPL', 'P'),
(62799, 'Beaverbrook', 35.2783317565918, 0.615723043763402, -81.1941680908203, -1.41710556660253, 218, 33, 'PPL', 'P'),
(177485, 'Beaverbrook', 41.4111099243164, 0.722760215084621, -73.420280456543, -1.28142563170432, 218, 8, 'PPL', 'P'),
(71766, 'Beavercreek', 39.709171295166, 0.693055782339068, -84.0633316040039, -1.46718191668567, 218, 41, 'PPL', 'P'),
(19135, 'Beaverdale', 34.9211082458496, 0.609488317335417, -84.8424987792969, -1.480780949318, 218, 13, 'PPL', 'P'),
(114538, 'Beaverdale', 40.8466682434082, 0.712908849317282, -91.2083282470703, -1.59188563315113, 218, 16, 'PPL', 'P'),
(159014, 'Beaverdale', 40.7911109924316, 0.711939192364384, -76.4269409179688, -1.33390175624573, 218, 45, 'PPL', 'P'),
(53382, 'Beaverdam', 36.753059387207, 0.641461896487772, -90.6308288574219, -1.5818063673735, 218, 29, 'PPL', 'P'),
(62801, 'Beaverdam', 36.2705612182617, 0.633040714804833, -77.7072219848633, -1.35624687621399, 218, 33, 'PPL', 'P'),
(79710, 'Beaverdam', 35.0400009155273, 0.61156338587778, -81.7016677856445, -1.42596310723008, 218, 48, 'PPL', 'P'),
(92519, 'Beaverdam', 33.6363906860352, 0.587065765958468, -94.6711120605469, -1.65232261198106, 218, 51, 'PPL', 'P'),
(99726, 'Beaverdam', 37.9411087036133, 0.662197268735129, -77.6547164916992, -1.35533048248289, 218, 53, 'PPL', 'P'),
(108130, 'Beaverdam', 38.9127807617188, 0.679156145398699, -81.3380584716797, -1.41961692751048, 218, 58, 'PPL', 'P'),
(129729, 'Beaverdam', 42.848331451416, 0.74784446281305, -85.9599990844727, -1.50028500903536, 218, 27, 'PPL', 'P'),
(154231, 'Beaverdam', 40.8333282470703, 0.712676022458982, -83.9766693115234, -1.46566937434456, 218, 41, 'PPL', 'P'),
(159015, 'Beaverdam', 40.8413887023926, 0.712816703943565, -77.5477828979492, -1.35346413919096, 218, 45, 'PPL', 'P'),
(19136, 'Beaverdam (historical)', 33.9630584716797, 0.592767194378164, -84.1849975585938, -1.46930538818085, 218, 13, 'PPL', 'P'),
(84887, 'Beaverdam Creek Subdivision', 36.0541687011719, 0.629263952904937, -88.024169921875, -1.53631158647168, 218, 50, 'PPL', 'P'),
(84888, 'Beaverdam Springs', 35.6819381713867, 0.622767304583743, -87.6044387817383, -1.52898589610314, 218, 50, 'PPL', 'P'),
(147080, 'Beaverkill', 41.9813919067383, 0.732713513342683, -74.8358306884766, -1.30613164397893, 218, 40, 'PPL', 'P'),
(99728, 'Beaverlett', 37.4061088562012, 0.652859759900121, -76.3091735839844, -1.33184632851641, 218, 53, 'PPL', 'P'),
(34720, 'Beaverlick', 38.8788909912109, 0.678564657320593, -84.6944427490234, -1.4781968841123, 218, 21, 'PPL', 'P'),
(19137, 'Beaveroaks', 32.8536109924316, 0.573403682987334, -83.8125, -1.46280407932775, 218, 13, 'PPL', 'P'),
(159016, 'Beavers Mill', 40.3569412231445, 0.7043615003777, -75.8099975585938, -1.32313406332632, 218, 45, 'PPL', 'P'),
(134, 'Beaverton', 33.9311103820801, 0.592209595024929, -88.0202789306641, -1.53624367586388, 218, 2, 'PPL', 'P'),
(129730, 'Beaverton', 43.8822212219238, 0.7658892434111, -84.4847183227539, -1.47453650235204, 218, 27, 'PPL', 'P'),
(159017, 'Beaverton', 40.8433303833008, 0.712850592668436, -78.3061065673828, -1.36669938401839, 218, 45, 'PPL', 'P'),
(195950, 'Beaverton', 48.4236106872559, 0.845151442196529, -107.253326416016, -1.87192367967568, 218, 31, 'PPL', 'P'),
(200393, 'Beaverton', 45.4872207641602, 0.793901769916126, -122.80249786377, -2.14330791739608, 218, 43, 'PPL', 'P'),
(118751, 'Beaverton Crossroads', 42.4077796936035, 0.740155384113773, -88.8216705322266, -1.55023059790898, 218, 18, 'PPL', 'P'),
(71769, 'Beavertown', 39.4724998474121, 0.688925086330301, -81.1130599975586, -1.4156899633251, 218, 41, 'PPL', 'P'),
(159021, 'Beavertown', 40.107780456543, 0.700012824633709, -77.0530624389648, -1.34482963830471, 218, 45, 'PPL', 'P'),
(70524, 'Beaverville', 39.901668548584, 0.696415493212257, -74.7422180175781, -1.30449779465017, 218, 37, 'PPL', 'P'),
(118752, 'Beaverville', 40.9544410705566, 0.714789839995205, -87.6544418334961, -1.52985861399236, 218, 18, 'PPL', 'P'),
(99729, 'Beazley', 37.9647216796875, 0.662609392913819, -77.0702819824219, -1.34513017603372, 218, 53, 'PPL', 'P'),
(99730, 'Beazley (historical)', 38.2963905334473, 0.668398106438242, -78.5069427490234, -1.37020463664515, 218, 53, 'PPL', 'P'),
(92520, 'Bebe', 29.4150009155273, 0.513388615453099, -97.6369400024414, -1.70408607461476, 218, 51, 'PPL', 'P'),
(75087, 'Bebee', 34.8450012207031, 0.608159999162713, -96.791389465332, -1.6893284337502, 218, 42, 'PPL', 'P'),
(108135, 'Bebee', 39.651668548584, 0.692052170082272, -80.7227783203125, -1.40887826304695, 218, 58, 'PPL', 'P'),
(177401, 'Beccaria', 40.7700004577637, 0.711570744027571, -78.4483337402344, -1.36918171647045, 218, 45, 'PPL', 'P'),
(108131, 'Becco', 37.7833290100098, 0.65944349358896, -81.8144378662109, -1.4279313164337, 218, 58, 'PPL', 'P'),
(159024, 'Bechtelsville', 40.3733291625977, 0.704647523878774, -75.6294403076172, -1.31998274480843, 218, 45, 'PPL', 'P'),
(134159, 'Bechyn', 44.6505584716797, 0.779299258185058, -95.0758285522461, -1.65938624729833, 218, 28, 'PPL', 'P'),
(134160, 'Becida', 47.3541717529297, 0.826486211643518, -95.0808334350586, -1.65947359898208, 218, 28, 'PPL', 'P'),
(137, 'Beck', 31.2561092376709, 0.545522017560372, -86.584716796875, -1.51118839001231, 218, 2, 'PPL', 'P'),
(7353, 'Beck', 33.4091682434082, 0.583099986200204, -93.7444381713867, -1.63614910152295, 218, 4, 'PPL', 'P'),
(53383, 'Beck', 38.4116706848145, 0.670410124641797, -90.3827819824219, -1.57747713270547, 218, 29, 'PPL', 'P'),
(191119, 'Beck', 33.9563903808594, 0.592650814238527, -102.536392211914, -1.78959764721417, 218, 51, 'PPL', 'P'),
(199168, 'Beck', 41.1380615234375, 0.717994621471979, -100.693328857422, -1.75743012335543, 218, 35, 'PPL', 'P'),
(195951, 'Beck (historical)', 47.7849998474121, 0.834005580402329, -111.816390991211, -1.95156418049396, 218, 31, 'PPL', 'P'),
(15156, 'Beck Hammock', 28.7866706848145, 0.502422184137343, -81.2186126708984, -1.41753220500916, 218, 12, 'PPL', 'P'),
(79711, 'Beck Landing', 32.8044395446777, 0.572545479326056, -80.4188919067383, -1.403574444578, 218, 48, 'PPL', 'P'),
(209298, 'Beck Place', 43.1380615234375, 0.752901206511865, -106.711669921875, -1.86246999043812, 218, 59, 'PPL', 'P'),
(186397, 'Beck Sand Draw Crossing', 39.0269393920898, 0.681148589368242, -104.052780151367, -1.81606360949516, 218, 7, 'PPL', 'P'),
(26473, 'Beckemeyer', 38.6055603027344, 0.673794136859934, -89.4358291625977, -1.56094968813849, 218, 18, 'PPL', 'P'),
(15157, 'Becker', 30.6711101531982, 0.535311857415172, -81.6413879394531, -1.42491102544145, 218, 12, 'PPL', 'P'),
(58593, 'Becker', 33.9330596923828, 0.592243616907854, -88.4811096191406, -1.54428668867203, 218, 30, 'PPL', 'P'),
(92521, 'Becker', 32.4927787780762, 0.567105972799569, -96.206672668457, -1.67912320045301, 218, 51, 'PPL', 'P'),
(134161, 'Becker', 45.3933296203613, 0.792263060318373, -93.8766708374023, -1.63845699692361, 218, 28, 'PPL', 'P'),
(188121, 'Becker', 34.4961090087891, 0.602070681330247, -106.61499786377, -1.8607827447295, 218, 38, 'PPL', 'P'),
(147082, 'Beckers Corners', 42.5483283996582, 0.742608421793845, -73.811393737793, -1.28825184621041, 218, 40, 'PPL', 'P'),
(159026, 'Beckersville', 40.2311096191406, 0.702165324584766, -75.9077835083008, -1.3248407501109, 218, 45, 'PPL', 'P'),
(31770, 'Beckerville', 39.6097183227539, 0.691320000519582, -96.1636123657227, -1.67837165639339, 218, 20, 'PPL', 'P'),
(124209, 'Becket', 42.3319396972656, 0.738831726472977, -73.0833282470703, -1.27554470622715, 218, 23, 'PPL', 'P'),
(195952, 'Becket', 46.9919395446777, 0.820164066952751, -108.922782897949, -1.90106119200418, 218, 31, 'PPL', 'P'),
(71770, 'Becket (historical)', 39.9480590820313, 0.697225160762669, -80.9219436645508, -1.41235435405978, 218, 41, 'PPL', 'P'),
(124210, 'Becket Center', 42.2833290100098, 0.737983309928705, -73.0638885498047, -1.27520541950428, 218, 23, 'PPL', 'P'),
(70525, 'Beckett', 39.7538909912109, 0.693836288275543, -75.357780456543, -1.31524138596171, 218, 37, 'PPL', 'P'),
(71771, 'Beckett', 39.5844383239746, 0.690878781305983, -81.7080612182617, -1.42607469367976, 218, 41, 'PPL', 'P'),
(53384, 'Beckett (historical)', 38.9427795410156, 0.679679722869009, -90.434440612793, -1.57837874589252, 218, 29, 'PPL', 'P'),
(71772, 'Beckett Ridge', 39.3469390869141, 0.686733637648302, -84.4352798461914, -1.47367363815885, 218, 41, 'PPL', 'P'),
(177313, 'Beckettville', 41.3930587768555, 0.722445163127665, -73.4730606079102, -1.28234681912538, 218, 8, 'PPL', 'P'),
(62807, 'Beckford Junction', 36.3833312988281, 0.635008924008456, -76.5927810668945, -1.33679621287648, 218, 33, 'PPL', 'P'),
(99731, 'Beckham', 37.4911117553711, 0.654343340364376, -78.9049987792969, -1.37715202498084, 218, 53, 'PPL', 'P'),
(15158, 'Beckhamtown', 29.6558303833008, 0.517591882601571, -82.0772171020508, -1.43251767930498, 218, 12, 'PPL', 'P'),
(79712, 'Beckhamville', 34.5902786254883, 0.603714251196989, -80.9199981689453, -1.41232039875588, 218, 48, 'PPL', 'P'),
(34721, 'Beckley', 38.2508316040039, 0.667602953115772, -85.4763870239258, -1.49184438627646, 218, 21, 'PPL', 'P'),
(108132, 'Beckley', 37.7780609130859, 0.659351547952325, -81.1883316040039, -1.41700370069084, 218, 58, 'PPL', 'P'),
(44685, 'Beckley Estates', 39.5977783203125, 0.691111608164283, -76.5388870239258, -1.33585558437947, 218, 25, 'PPL', 'P'),
(108133, 'Beckley Junction', 37.7638893127441, 0.659104206866084, -81.1961135864258, -1.41713952190643, 218, 58, 'PPL', 'P'),
(139, 'Beckleys (historical)', 32.2827796936035, 0.563440797349348, -87.9280624389648, -1.53463419445909, 218, 2, 'PPL', 'P'),
(44686, 'Beckleysville', 39.6416702270508, 0.691877666451844, -76.7783279418945, -1.34003461676202, 218, 25, 'PPL', 'P'),
(92522, 'Beckmann', 29.6091709136963, 0.516777521229738, -98.601936340332, -1.72092843798064, 218, 51, 'PPL', 'P'),
(34722, 'Becknerville', 37.9663887023926, 0.662638487948728, -84.2794418334961, -1.47095375173755, 218, 21, 'PPL', 'P'),
(79713, 'Beckridge Park', 33.8916702270508, 0.59152123446217, -80.3888931274414, -1.40305086710769, 218, 48, 'PPL', 'P'),
(7354, 'Becks', 34.9880599975586, 0.610656845842717, -90.8525009155273, -1.58567527464711, 218, 4, 'PPL', 'P'),
(202992, 'Becks', 40.8166694641113, 0.712385271846972, -111.920829772949, -1.95338698110206, 218, 52, 'PPL', 'P'),
(29173, 'Becks Grove', 39.0791702270508, 0.682060189409376, -86.1166687011719, -1.5030194096846, 218, 19, 'PPL', 'P'),
(147081, 'Becks Grove', 43.2552795410156, 0.754947046861264, -75.6041717529297, -1.31954172533192, 218, 40, 'PPL', 'P'),
(13348, 'Becks Landing', 39.6236114501953, 0.691562481336833, -75.6988906860352, -1.32119488257858, 218, 10, 'PPL', 'P'),
(44687, 'Becks Landing', 39.1650009155273, 0.683558217522546, -76.1427764892578, -1.32894215134768, 218, 25, 'PPL', 'P'),
(29174, 'Becks Mill', 38.5352783203125, 0.672567484861843, -86.1555633544922, -1.50369824944646, 218, 19, 'PPL', 'P'),
(154233, 'Becks Mills', 40.4877815246582, 0.706645094433415, -81.8194427490234, -1.42801866811746, 218, 41, 'PPL', 'P'),
(34723, 'Beckton', 36.9841690063477, 0.645495520274806, -86.0363922119141, -1.50161832063511, 218, 21, 'PPL', 'P'),
(209299, 'Beckton', 44.7486114501953, 0.781010605501543, -107.129173278809, -1.86975679865474, 218, 59, 'PPL', 'P'),
(53385, 'Beckville', 37.1438903808594, 0.648283184145847, -90.7002792358398, -1.58301850514365, 218, 29, 'PPL', 'P'),
(92524, 'Beckville', 32.2427787780762, 0.562742649669583, -94.4552764892578, -1.64855557061914, 218, 51, 'PPL', 'P'),
(122209, 'Beckville', 40.0105590820313, 0.698315991545165, -86.709716796875, -1.5133700515773, 218, 19, 'PPL', 'P'),
(134166, 'Beckville', 45.0444412231445, 0.786173809064934, -94.563606262207, -1.65044628183504, 218, 28, 'PPL', 'P'),
(159027, 'Beckville', 40.6416702270508, 0.709330958971788, -76.1975021362305, -1.32989729407263, 218, 45, 'PPL', 'P'),
(58594, 'Beckville (historical)', 32.6777801513672, 0.570334855884208, -88.4250030517578, -1.54330744433921, 218, 30, 'PPL', 'P'),
(62808, 'Beckwith', 35.5291709899902, 0.620101014279383, -76.7811126708984, -1.34008321945192, 218, 33, 'PPL', 'P'),
(75089, 'Beckwith', 36.1969413757324, 0.631755806157897, -94.709716796875, -1.65299639173685, 218, 42, 'PPL', 'P'),
(84889, 'Beckwith', 36.2066688537598, 0.631925582677389, -86.4588928222656, -1.50899234737743, 218, 50, 'PPL', 'P'),
(108134, 'Beckwith', 38.0977783203125, 0.664931669384368, -81.1536102294922, -1.41639769838479, 218, 58, 'PPL', 'P'),
(114539, 'Beckwith', 41.0091705322266, 0.715745049299189, -91.8644409179688, -1.60333695952236, 218, 16, 'PPL', 'P'),
(79714, 'Beckwood', 33.9719390869141, 0.592922190353606, -80.3913879394531, -1.40309440979152, 218, 48, 'PPL', 'P'),
(180001, 'Beckwourth', 39.8202781677246, 0.694994963086809, -120.377777099609, -2.10098855662001, 218, 6, 'PPL', 'P'),
(188122, 'Beclabito', 36.8413887023926, 0.643003533863792, -109.018890380859, -1.90273858401677, 218, 38, 'PPL', 'P'),
(7355, 'Becton', 35.0641708374023, 0.611985230594448, -91.2483291625977, -1.59258378083089, 218, 4, 'PPL', 'P'),
(191120, 'Becton', 33.7836112976074, 0.589635250357203, -101.647216796875, -1.77407860859395, 218, 51, 'PPL', 'P'),
(145, 'Beda', 31.0508308410645, 0.541939233656375, -86.5827789306641, -1.51115456786646, 218, 2, 'PPL', 'P'),
(34725, 'Beda', 37.5077781677246, 0.65463422413444, -86.9494400024414, -1.51755401080787, 218, 21, 'PPL', 'P'),
(206797, 'Bedal', 48.0988883972168, 0.839483969080731, -121.394721984863, -2.11873759317901, 218, 56, 'PPL', 'P'),
(126852, 'Beddington', 44.8480606079102, 0.782746320742002, -68.0625, -1.18791472213864, 218, 26, 'PPL', 'P'),
(147083, 'Bedell', 42.1949996948242, 0.736441672552685, -74.5505599975586, -1.30115273116297, 218, 40, 'PPL', 'P'),
(126851, 'Bedell Crossing', 43.1027793884277, 0.752285417088812, -70.6761093139648, -1.23353081002812, 218, 26, 'PPL', 'P'),
(200394, 'Bedfield (historical)', 42.1277809143066, 0.735268483513478, -121.462501525879, -2.11992056933522, 218, 43, 'PPL', 'P'),
(146, 'Bedford', 33.7958297729492, 0.589848502981492, -88.2069396972656, -1.53950152082538, 218, 2, 'PPL', 'P'),
(26474, 'Bedford', 39.5291709899902, 0.689914184359156, -90.5841674804688, -1.58099197271216, 218, 18, 'PPL', 'P'),
(29175, 'Bedford', 38.8611106872559, 0.678254332474571, -86.4872207641602, -1.5094867632338, 218, 19, 'PPL', 'P'),
(34724, 'Bedford', 38.5924987792969, 0.673566170270623, -85.3177795410156, -1.48907616348138, 218, 21, 'PPL', 'P'),
(39296, 'Bedford', 32.2408294677734, 0.562708627786658, -91.0149993896484, -1.58851140804999, 218, 22, 'PPL', 'P'),
(53386, 'Bedford', 39.6961097717285, 0.692827815749757, -93.3727798461914, -1.62966244005584, 218, 29, 'PPL', 'P'),
(62809, 'Bedford', 35.5577812194824, 0.620600356983773, -77.3838882446289, -1.35060363786411, 218, 33, 'PPL', 'P'),
(84890, 'Bedford', 35.4636116027832, 0.61895678711703, -86.5736083984375, -1.51099451188495, 218, 50, 'PPL', 'P'),
(92523, 'Bedford', 32.8438911437988, 0.573234039625896, -97.1427764892578, -1.69546129426649, 218, 51, 'PPL', 'P'),
(99732, 'Bedford', 37.334171295166, 0.651604212604203, -79.5233306884766, -1.38794395266617, 218, 53, 'PPL', 'P'),
(114540, 'Bedford', 40.6669387817383, 0.709771978448305, -94.7211074829102, -1.65319519671222, 218, 16, 'PPL', 'P'),
(124212, 'Bedford', 42.4905586242676, 0.741600149005141, -71.2766723632813, -1.24401261260451, 218, 23, 'PPL', 'P'),
(129733, 'Bedford', 42.3952789306641, 0.739937204641469, -85.2322235107422, -1.48758292905817, 218, 27, 'PPL', 'P'),
(143507, 'Bedford', 42.9463882446289, 0.749555876708562, -71.5163879394531, -1.24819643867702, 218, 36, 'PPL', 'P'),
(147084, 'Bedford', 41.2041702270508, 0.719148436014256, -73.644172668457, -1.28533328797179, 218, 40, 'PPL', 'P'),
(154234, 'Bedford', 41.3930587768555, 0.722445163127665, -81.5366668701172, -1.42308329798532, 218, 41, 'PPL', 'P'),
(159028, 'Bedford', 40.0186080932617, 0.698456473292667, -78.5041732788086, -1.37015630027136, 218, 45, 'PPL', 'P'),
(195953, 'Bedford', 46.3630599975586, 0.809188048257072, -111.54972076416, -1.94690990701488, 218, 31, 'PPL', 'P'),
(206798, 'Bedford', 46.6613883972168, 0.814394861083313, -123.466667175293, -2.15489985867287, 218, 56, 'PPL', 'P'),
(209300, 'Bedford', 42.8994407653809, 0.748736488620172, -110.932502746582, -1.93613742040551, 218, 59, 'PPL', 'P'),
(147085, 'Bedford Center', 41.2200012207031, 0.719424738977351, -73.6586074829102, -1.28558522301092, 218, 40, 'PPL', 'P'),
(147086, 'Bedford Corners', 42.0544395446777, 0.733988435135531, -78.3116683959961, -1.36679645624012, 218, 40, 'PPL', 'P'),
(147091, 'Bedford Four Corners', 41.1983299255371, 0.719046503523533, -73.6786117553711, -1.28593436342982, 218, 40, 'PPL', 'P'),
(154235, 'Bedford Heights', 41.4169387817383, 0.722861947838262, -81.5274963378906, -1.42292324200381, 218, 41, 'PPL', 'P'),
(99734, 'Bedford Hills', 38.1236114501953, 0.665382542556918, -78.466667175293, -1.36950169527542, 218, 53, 'PPL', 'P'),
(147087, 'Bedford Hills', 41.2366714477539, 0.719715689326442, -73.6949996948242, -1.2862203869309, 218, 40, 'PPL', 'P'),
(19141, 'Bedford Park', 33.353328704834, 0.582125402399289, -84.5352783203125, -1.47541894077923, 218, 13, 'PPL', 'P'),
(118755, 'Bedford Park', 41.7627792358398, 0.728898002448927, -87.8000030517578, -1.53239913651424, 218, 18, 'PPL', 'P'),
(147088, 'Bedford Park', 40.8699989318848, 0.713316046647955, -73.8861083984375, -1.28955586303817, 218, 40, 'PPL', 'P'),
(77836, 'Bedford Springs', 39.9972190856934, 0.698083164686865, -78.5100021362305, -1.370258033025, 218, 45, 'PPL', 'P'),
(99735, 'Bedford Springs', 37.3055610656738, 0.651104869899813, -79.272216796875, -1.38356118846022, 218, 53, 'PPL', 'P'),
(124213, 'Bedford Springs', 42.5161094665527, 0.742046095329675, -71.2713928222656, -1.24392046723079, 218, 23, 'PPL', 'P'),
(19138, 'Bedgood', 31.851110458374, 0.555906747915027, -83.7063903808594, -1.46095211710571, 218, 13, 'PPL', 'P'),
(92525, 'Bedias', 30.7755603790283, 0.537134857760358, -95.9491729736328, -1.67462898295545, 218, 51, 'PPL', 'P'),
(39295, 'Bedico', 30.4361095428467, 0.531210323020341, -90.2516708374023, -1.57518881153882, 218, 22, 'PPL', 'P'),
(108136, 'Bedington', 39.5222206115723, 0.689792877371503, -77.9058303833008, -1.35971324668883, 218, 58, 'PPL', 'P'),
(139025, 'Bedison', 40.2933311462402, 0.703251295098273, -94.774169921875, -1.6541213109813, 218, 29, 'PPL', 'P'),
(177486, 'Bedlam Corner', 41.7797203063965, 0.729193679908953, -72.1549987792969, -1.25934230047122, 218, 8, 'PPL', 'P'),
(144809, 'Bedminster', 40.6805610656738, 0.710009732154621, -74.6458282470703, -1.30281547578956, 218, 37, 'PPL', 'P'),
(159031, 'Bedminster', 40.4258308410645, 0.705563851030843, -75.179443359375, -1.31212881643768, 218, 45, 'PPL', 'P'),
(129736, 'Bedore', 42.5577812194824, 0.742773404623376, -82.6130599975586, -1.44186990210502, 218, 27, 'PPL', 'P'),
(186398, 'Bedrock', 38.314998626709, 0.668722878933178, -108.890281677246, -1.900493938692, 218, 7, 'PPL', 'P'),
(194570, 'Bedstead Corner', 44.2758293151855, 0.772759000601014, -111.792221069336, -1.95114233577729, 218, 17, 'PPL', 'P'),
(53388, 'Bedwell', 37.2683296203613, 0.650455058593834, -91.019172668457, -1.58858424550581, 218, 29, 'PPL', 'P'),
(75092, 'Bedwell', 35.1597213745117, 0.613652902069056, -94.716667175293, -1.6531176987245, 218, 42, 'PPL', 'P'),
(34726, 'Bee', 37.2688903808594, 0.65046484571084, -86.084716796875, -1.50246174375234, 218, 21, 'PPL', 'P'),
(75091, 'Bee', 34.121940612793, 0.595540210863209, -96.5719375610352, -1.68549827547045, 218, 42, 'PPL', 'P'),
(99737, 'Bee', 37.1150016784668, 0.647778981172467, -82.1722183227539, -1.43417576339967, 218, 53, 'PPL', 'P'),
(134167, 'Bee', 43.5011100769043, 0.759237599114464, -91.570556640625, -1.59820771126286, 218, 28, 'PPL', 'P'),
(141266, 'Bee', 41.0063896179199, 0.715696513188322, -97.0569381713867, -1.69396313299526, 218, 35, 'PPL', 'P'),
(206799, 'Bee', 47.1930618286133, 0.823674313006558, -122.675003051758, -2.14108271314727, 218, 56, 'PPL', 'P'),
(71775, 'Bee (historical)', 39.2486114501953, 0.685017496641855, -82.6586074829102, -1.4426648556904, 218, 41, 'PPL', 'P'),
(39297, 'Bee Bayou', 32.4730606079102, 0.566761825807704, -91.695556640625, -1.60038937282786, 218, 22, 'PPL', 'P'),
(7357, 'Bee Branch', 35.4508285522461, 0.618733680796709, -92.3944396972656, -1.61258718325264, 218, 4, 'PPL', 'P'),
(92526, 'Bee Cave', 30.3083305358887, 0.528980158633995, -97.9447174072266, -1.70945780369151, 218, 51, 'PPL', 'P'),
(26476, 'Bee Creek', 39.4002799987793, 0.687664612186366, -90.6358337402344, -1.58189371905726, 218, 18, 'PPL', 'P'),
(92528, 'Bee Crest Colonia', 28.742000579834, 0.501642543728222, -99.8580017089844, -1.7428509142839, 218, 51, 'PPL', 'P'),
(53390, 'Bee Fork', 37.4413909912109, 0.653475549323174, -91.0844421386719, -1.58972341266209, 218, 29, 'PPL', 'P'),
(92529, 'Bee House', 31.402530670166, 0.548077553652898, -98.0809478759766, -1.71183547391273, 218, 51, 'PPL', 'P'),
(58597, 'Bee Lake', 33.0469398498535, 0.576777908088464, -90.3252792358398, -1.57647352044867, 218, 30, 'PPL', 'P'),
(520, 'Bee Lick', 37.3286094665527, 0.651507140382469, -84.5027770996094, -1.47485168746705, 218, 21, 'PPL', 'P'),
(62810, 'Bee Log', 35.9844398498535, 0.628046954865798, -82.4088897705078, -1.43830645940844, 218, 33, 'PPL', 'P'),
(15159, 'Bee Ridge', 27.2836093902588, 0.476188815688058, -82.480827331543, -1.43956200670435, 218, 12, 'PPL', 'P'),
(29176, 'Bee Ridge', 39.5369415283203, 0.690049805837668, -87.1694412231445, -1.52139375646755, 218, 19, 'PPL', 'P'),
(7358, 'Bee Rock', 35.2827796936035, 0.615800674909177, -91.7313919067383, -1.60101481620986, 218, 4, 'PPL', 'P'),
(180002, 'Bee Rock', 35.7872200012207, 0.62460481915687, -120.938056945801, -2.11076728466862, 218, 6, 'PPL', 'P'),
(34727, 'Bee Spring', 37.2894401550293, 0.650823506930646, -86.2847213745117, -1.50595248215116, 218, 21, 'PPL', 'P'),
(79715, 'Bee Tree (historical)', 34.3102798461914, 0.598827350596694, -80.6972198486328, -1.40843218356436, 218, 48, 'PPL', 'P'),
(7359, 'Beebe', 35.0705604553223, 0.612096750465095, -91.8794403076172, -1.60359874825751, 218, 4, 'PPL', 'P'),
(71776, 'Beebe', 39.3127784729004, 0.68613742245926, -81.8580627441406, -1.42869271418936, 218, 41, 'PPL', 'P'),
(108138, 'Beebe', 37.8263893127441, 0.66019503764858, -82.0625, -1.43226081741785, 218, 58, 'PPL', 'P'),
(129737, 'Beebe', 43.3352813720703, 0.756343342220793, -84.5480575561523, -1.47564198052053, 218, 27, 'PPL', 'P'),
(169807, 'Beebe', 45.4480590820313, 0.793218269622357, -99.1949996948242, -1.73127934618945, 218, 49, 'PPL', 'P'),
(173114, 'Beebe', 46.4072189331055, 0.809958767076541, -91.8391723632813, -1.60289594004584, 218, 57, 'PPL', 'P'),
(195954, 'Beebe', 46.0552787780762, 0.8038162526013, -105.568893432617, -1.84252477808619, 218, 31, 'PPL', 'P'),
(206800, 'Beebe', 47.839168548584, 0.834951002589307, -119.949722290039, -2.09351759081401, 218, 56, 'PPL', 'P'),
(171726, 'Beebe Plain', 45.0052795410156, 0.785490308771165, -72.14111328125, -1.25909995281202, 218, 55, 'PPL', 'P'),
(143509, 'Beebe River', 43.8286094665527, 0.764953541762101, -71.6513900756836, -1.25055267045147, 218, 36, 'PPL', 'P'),
(114542, 'Beebeetown', 41.521110534668, 0.724680087914459, -95.7552795410156, -1.67124490415829, 218, 16, 'PPL', 'P'),
(154242, 'Beebetown', 41.2747192382813, 0.720379748544254, -81.8783264160156, -1.42904638198212, 218, 41, 'PPL', 'P'),
(34728, 'Beech', 37.3697204589844, 0.652224662559164, -83.4288864135742, -1.45610875918923, 218, 21, 'PPL', 'P'),
(62811, 'Beech', 35.711669921875, 0.623286221522145, -82.4702835083008, -1.43937798227303, 218, 33, 'PPL', 'P'),
(108137, 'Beech', 38.7625007629395, 0.676533264620107, -81.1725006103516, -1.41672739772774, 218, 58, 'PPL', 'P'),
(114543, 'Beech', 41.3747215270996, 0.722125117743665, -93.351936340332, -1.62929865225094, 218, 16, 'PPL', 'P'),
(129738, 'Beech', 42.3777809143066, 0.739631806643464, -83.2955627441406, -1.45378182218678, 218, 27, 'PPL', 'P'),
(154239, 'Beech', 40.0791702270508, 0.699513481929319, -82.7536087036133, -1.44432293978509, 218, 41, 'PPL', 'P'),
(39298, 'Beech (historical)', 31.9361095428467, 0.557390261800256, -92.397216796875, -1.61263565278448, 218, 22, 'PPL', 'P'),
(154240, 'Beech (historical)', 40.5577812194824, 0.707866819583489, -82.976936340332, -1.44822074235653, 218, 41, 'PPL', 'P'),
(84892, 'Beech Bluff', 35.5963897705078, 0.62127420331859, -88.6313934326172, -1.54690963602965, 218, 50, 'PPL', 'P'),
(34729, 'Beech Bottom', 37.3702812194824, 0.65223444967617, -84.9352798461914, -1.48240028441882, 218, 21, 'PPL', 'P'),
(62812, 'Beech Bottom', 36.0719413757324, 0.629574144592904, -82.0091705322266, -1.43133004261686, 218, 33, 'PPL', 'P'),
(84891, 'Beech Bottom', 36.4652786254883, 0.636439174671883, -86.008056640625, -1.50112377162068, 218, 50, 'PPL', 'P'),
(177182, 'Beech Bottom', 40.226390838623, 0.702082966328055, -80.6516723632813, -1.40763722997897, 218, 58, 'PPL', 'P'),
(29177, 'Beech Brook', 39.5522193908691, 0.690316454841813, -85.7977828979492, -1.4974538024805, 218, 19, 'PPL', 'P'),
(19142, 'Beech Cove Vista', 34.9338912963867, 0.609711423655738, -83.7455596923828, -1.46163575055753, 218, 13, 'PPL', 'P'),
(7360, 'Beech Creek', 33.3994407653809, 0.582930209680711, -93.3388900756836, -1.62907095197774, 218, 4, 'PPL', 'P'),
(34730, 'Beech Creek', 37.1769409179688, 0.648860024837958, -87.0630569458008, -1.51953700055554, 218, 21, 'PPL', 'P'),
(44689, 'Beech Creek', 39.2336082458496, 0.684755641327673, -76.8872222900391, -1.34193518167396, 218, 25, 'PPL', 'P'),
(62814, 'Beech Creek', 36.2574996948242, 0.632812748215522, -81.9008331298828, -1.42943919824291, 218, 33, 'PPL', 'P'),
(159033, 'Beech Creek', 41.0758285522461, 0.71690845122139, -77.5888900756836, -1.35418159478863, 218, 45, 'PPL', 'P'),
(200395, 'Beech Creek', 44.6194381713867, 0.778756106480736, -119.14778137207, -2.07952108138899, 218, 43, 'PPL', 'P'),
(15160, 'Beech Creek (historical)', 29.3333301544189, 0.511963191769147, -83.0500030517578, -1.44949599704451, 218, 12, 'PPL', 'P'),
(7362, 'Beech Creek Crossing', 33.3183288574219, 0.581514539824252, -91.9369430541992, -1.60460236051431, 218, 4, 'PPL', 'P'),
(19143, 'Beech Creek Homes', 34.273609161377, 0.59818732640772, -85.2533264160156, -1.48795124423693, 218, 13, 'PPL', 'P'),
(44688, 'Beech Crest Mobile Estates', 39.1183280944824, 0.682743623124118, -76.831672668457, -1.34096565787911, 218, 25, 'PPL', 'P'),
(159036, 'Beech Flats', 41.6330604553223, 0.726633982627223, -76.815559387207, -1.340684428068, 218, 45, 'PPL', 'P'),
(84893, 'Beech Fork', 36.2344398498535, 0.632410277995784, -84.3050003051758, -1.47139983122014, 218, 50, 'PPL', 'P'),
(62815, 'Beech Glen', 35.8186111450195, 0.625152697972127, -82.5047225952148, -1.43997905773106, 218, 33, 'PPL', 'P'),
(108139, 'Beech Glen', 38.2272186279297, 0.667190828937082, -81.1555633544922, -1.41643178684674, 218, 58, 'PPL', 'P'),
(159037, 'Beech Glen', 41.3291702270508, 0.721330097579249, -76.5880584716797, -1.33671378804075, 218, 45, 'PPL', 'P'),
(7364, 'Beech Grove', 33.813060760498, 0.590149240447589, -92.4483337402344, -1.61352781174965, 218, 4, 'PPL', 'P'),
(29180, 'Beech Grove', 39.517219543457, 0.689705592266776, -86.4463882446289, -1.5087741013261, 218, 19, 'PPL', 'P'),
(34732, 'Beech Grove', 37.6161117553711, 0.656525001929369, -87.3963928222656, -1.52535480911487, 218, 21, 'PPL', 'P'),
(58599, 'Beech Grove', 31.9933300018311, 0.558388947209035, -90.2572174072266, -1.57528561744444, 218, 30, 'PPL', 'P'),
(84902, 'Beech Grove', 36.1294403076172, 0.630577690270673, -88.8177795410156, -1.55016268730118, 218, 50, 'PPL', 'P'),
(92530, 'Beech Grove', 30.8558292388916, 0.538535813651794, -94.1211090087891, -1.64272324783187, 218, 51, 'PPL', 'P'),
(99738, 'Beech Grove', 37.875560760498, 0.661053241309858, -78.9391708374023, -1.37774843990696, 218, 53, 'PPL', 'P'),
(108140, 'Beech Grove', 39.3230590820313, 0.686316852937704, -81.0047225952148, -1.41379911895115, 218, 58, 'PPL', 'P'),
(159041, 'Beech Grove', 41.3355598449707, 0.721441617449896, -78.6933288574219, -1.37345768791668, 218, 45, 'PPL', 'P'),
(84903, 'Beech Grove (historical)', 36.0072212219238, 0.628444564816547, -87.4216690063477, -1.52579596174945, 218, 50, 'PPL', 'P'),
(19146, 'Beech Gum Mobile Home Park', 33.8022193908691, 0.589960022852139, -84.6269378662109, -1.47701870164605, 218, 13, 'PPL', 'P'),
(13349, 'Beech Haven', 39.1958312988281, 0.684096309220796, -75.595832824707, -1.31939618357834, 218, 10, 'PPL', 'P'),
(13350, 'Beech Hill', 39.7502784729004, 0.693773237936735, -75.727783203125, -1.32169915213099, 218, 10, 'PPL', 'P'),
(19144, 'Beech Hill', 32.8222198486328, 0.572855804172077, -83.0091705322266, -1.44878333513681, 218, 13, 'PPL', 'P'),
(84905, 'Beech Hill', 36.4711112976074, 0.636540974004551, -86.1063919067383, -1.50284004578518, 218, 50, 'PPL', 'P'),
(108141, 'Beech Hill', 38.764720916748, 0.676572013613968, -82.0027770996094, -1.43121845616719, 218, 58, 'PPL', 'P'),
(147092, 'Beech Hill', 40.9863891601563, 0.71534743934844, -73.8169403076172, -1.28834865211604, 218, 40, 'PPL', 'P'),
(84906, 'Beech Hill (historical)', 36.2819404602051, 0.633239320043125, -85.8000030517578, -1.49749255147436, 218, 50, 'PPL', 'P'),
(159040, 'Beech Hills', 40.3355598449707, 0.703988324929952, -79.5736083984375, -1.38882146424535, 218, 45, 'PPL', 'P'),
(79716, 'Beech Island', 33.4272193908691, 0.58341503815716, -81.89111328125, -1.42926955488147, 218, 48, 'PPL', 'P'),
(62816, 'Beech Mountain', 36.2108306884766, 0.631998220396121, -81.8891677856445, -1.42923559957757, 218, 33, 'PPL', 'P'),
(154241, 'Beech Park', 41.5044403076172, 0.724389137565368, -82.0469436645508, -1.43198930814471, 218, 41, 'PPL', 'P'),
(126853, 'Beech Ridge', 43.1494407653809, 0.753099811750158, -70.7200012207031, -1.23429686831568, 218, 26, 'PPL', 'P'),
(84907, 'Beech River', 35.6902809143066, 0.622912912916343, -88.3905563354492, -1.54270623572312, 218, 50, 'PPL', 'P'),
(108144, 'Beech Run', 39.5369415283203, 0.690049805837668, -79.6611099243164, -1.39034865397245, 218, 58, 'PPL', 'P'),
(108145, 'Beech Run (historical)', 38.6891708374023, 0.675253415979243, -80.1205596923828, -1.39836756517274, 218, 58, 'PPL', 'P'),
(19145, 'Beech Springs', 32.7972183227539, 0.572419445227468, -84.9577789306641, -1.48279296752156, 218, 13, 'PPL', 'P'),
(39299, 'Beech Springs', 32.3066711425781, 0.563857781797027, -92.6466674804688, -1.61698938853454, 218, 22, 'PPL', 'P'),
(58598, 'Beech Springs', 34.3213882446289, 0.599021228724051, -88.7061080932617, -1.54821365285741, 218, 30, 'PPL', 'P'),
(84908, 'Beech Springs', 35.9633293151855, 0.627678506528985, -83.6172180175781, -1.45939576576466, 218, 50, 'PPL', 'P'),
(71782, 'Beech-Mar', 39.1030616760254, 0.682477173857055, -84.3874969482422, -1.47283966926349, 218, 41, 'PPL', 'P'),
(34733, 'Beechburg', 38.4466705322266, 0.671020987216834, -83.6402816772461, -1.45979830256343, 218, 21, 'PPL', 'P'),
(159042, 'Beechcliff', 40.4463882446289, 0.705922645408704, -80.1933288574219, -1.39963762669659, 218, 45, 'PPL', 'P'),
(118756, 'Beecher', 41.3405609130859, 0.721528902554623, -87.6213912963867, -1.52928177330025, 218, 18, 'PPL', 'P'),
(129739, 'Beecher', 43.0900001525879, 0.752062377347518, -83.6944427490234, -1.46074359159235, 218, 27, 'PPL', 'P'),
(173115, 'Beecher', 45.5883293151855, 0.79566644703344, -87.9947204589844, -1.53579759638129, 218, 57, 'PPL', 'P'),
(7366, 'Beecher (historical)', 34.5741691589355, 0.603433087964904, -91.5475006103516, -1.59780530762215, 218, 4, 'PPL', 'P'),
(26477, 'Beecher City', 39.188060760498, 0.683960687742284, -88.7866668701172, -1.54961966875491, 218, 18, 'PPL', 'P'),
(171725, 'Beecher Falls', 45.0080604553223, 0.785538844882032, -71.5083312988281, -1.24805582377146, 218, 55, 'PPL', 'P'),
(186399, 'Beecher Island', 39.8722190856934, 0.695901503121872, -102.183891296387, -1.78344534562193, 218, 7, 'PPL', 'P'),
(173116, 'Beecher Lake', 45.5691719055176, 0.79533208715858, -87.9974975585938, -1.53584606591313, 218, 57, 'PPL', 'P'),
(13351, 'Beechers Lot', 39.6438903808594, 0.691916415445705, -75.7041702270508, -1.3212870279523, 218, 10, 'PPL', 'P'),
(77838, 'Beechersville', 39.9172210693359, 0.696686935906364, -77.2897186279297, -1.34896006799737, 218, 45, 'PPL', 'P'),
(62819, 'Beechertown', 35.2733306884766, 0.615635758658674, -83.6800003051758, -1.46049152339518, 218, 33, 'PPL', 'P'),
(147093, 'Beechertown', 44.7019386291504, 0.780196011103115, -74.7888870239258, -1.30531232246957, 218, 40, 'PPL', 'P'),
(147094, 'Beecherville', 43.5786094665527, 0.760590218632115, -75.9086074829102, -1.32485513118079, 218, 40, 'PPL', 'P'),
(44690, 'Beechfield', 39.271671295166, 0.685419966861593, -76.6930618286133, -1.33854644234489, 218, 25, 'PPL', 'P'),
(147095, 'Beechford', 42.021110534668, 0.733406734174431, -74.2708282470703, -1.29627049109459, 218, 40, 'PPL', 'P'),
(71777, 'Beechgrove', 39.9894409179688, 0.697947410050298, -84.6161117553711, -1.4768297503667, 218, 41, 'PPL', 'P'),
(84910, 'Beechgrove', 35.6269416809082, 0.621807434747851, -86.2402801513672, -1.50517683648367, 218, 50, 'PPL', 'P'),
(147096, 'Beechhurst', 40.791389465332, 0.711944052633373, -73.8050003051758, -1.28814025976074, 218, 40, 'PPL', 'P'),
(34738, 'Beechland', 37.0416717529297, 0.646499132531603, -86.9124984741211, -1.51690925950796, 218, 21, 'PPL', 'P'),
(34735, 'Beechland Beach', 38.353889465332, 0.669401652116012, -85.6338882446289, -1.49459330115364, 218, 21, 'PPL', 'P'),
(34737, 'Beechmont', 37.1744384765625, 0.648816348996081, -87.0325012207031, -1.51900370254725, 218, 21, 'PPL', 'P'),
(99739, 'Beechmont', 37.1377792358398, 0.648176524544189, -76.5524978637695, -1.3360931383487, 218, 53, 'PPL', 'P'),
(147097, 'Beechmont', 40.9308280944824, 0.714377715816515, -73.7847213745117, -1.28778632565187, 218, 40, 'PPL', 'P'),
(159051, 'Beechmont', 40.3927803039551, 0.704987010338732, -80.1600036621094, -1.39905599231452, 218, 45, 'PPL', 'P'),
(147098, 'Beechmont Woods', 40.934440612793, 0.714440766155323, -73.7744369506836, -1.28760682859439, 218, 40, 'PPL', 'P'),
(99740, 'Beechnut Acres', 37.2322196960449, 0.649824821521866, -77.4702835083008, -1.35211151967331, 218, 53, 'PPL', 'P'),
(84911, 'Beechnut City', 36.5672187805176, 0.638218366017137, -82.3333282470703, -1.43698766203663, 218, 50, 'PPL', 'P'),
(159043, 'Beechton', 41.2347183227539, 0.71968160086449, -78.850830078125, -1.37620660279386, 218, 45, 'PPL', 'P'),
(159044, 'Beechtree', 41.2099990844727, 0.719250168767897, -78.8208312988281, -1.37568302532355, 218, 45, 'PPL', 'P'),
(159045, 'Beechview', 40.4105606079102, 0.705297335184754, -80.0250015258789, -1.39669976054007, 218, 45, 'PPL', 'P'),
(71778, 'Beechview Estates', 39.1016693115234, 0.682452872512108, -84.39111328125, -1.47290278618133, 218, 41, 'PPL', 'P'),
(26478, 'Beechville', 38.9713897705078, 0.680179065573399, -90.6474990844727, -1.58209731772259, 218, 18, 'PPL', 'P'),
(34739, 'Beechville', 37.0613899230957, 0.646843279523468, -85.6327819824219, -1.49457399323574, 218, 21, 'PPL', 'P'),
(13352, 'Beechwold', 39.7813911437988, 0.694316256483003, -75.5299987792969, -1.31824716272603, 218, 10, 'PPL', 'P'),
(178, 'Beechwood', 32.1258316040039, 0.560701536431119, -86.6561126708984, -1.51243448308636, 218, 2, 'PPL', 'P'),
(7367, 'Beechwood', 36.0080604553223, 0.628459212202542, -93.3688888549805, -1.62959452944805, 218, 4, 'PPL', 'P'),
(15161, 'Beechwood', 30.2916698455811, 0.528689374732472, -81.5169372558594, -1.42273895125638, 218, 12, 'PPL', 'P'),
(19149, 'Beechwood', 32.5488891601563, 0.568085283711419, -84.0694427490234, -1.46728857628733, 218, 13, 'PPL', 'P'),
(29183, 'Beechwood', 38.2066688537598, 0.666832167717276, -86.4244384765625, -1.50839100560329, 218, 19, 'PPL', 'P'),
(34742, 'Beechwood', 38.4122200012207, 0.670419712021722, -84.7461090087891, -1.4790986304574, 218, 21, 'PPL', 'P'),
(39300, 'Beechwood', 30.5566692352295, 0.533314486597612, -91.1611099243164, -1.5910615179518, 218, 22, 'PPL', 'P'),
(44691, 'Beechwood', 38.7463912963867, 0.676252101388022, -76.0625, -1.32754106229819, 218, 25, 'PPL', 'P'),
(58601, 'Beechwood', 32.3274993896484, 0.564221303285823, -90.8266677856445, -1.58522440147456, 218, 30, 'PPL', 'P'),
(79717, 'Beechwood', 34.1983299255371, 0.59687345588393, -82.1222229003906, -1.4333031786685, 218, 48, 'PPL', 'P'),
(84914, 'Beechwood', 35.8694381713867, 0.626039796931232, -83.9705581665039, -1.46556271474291, 218, 50, 'PPL', 'P'),
(99751, 'Beechwood', 36.6172218322754, 0.639091083906356, -78.2138900756836, -1.3650899026136, 218, 53, 'PPL', 'P'),
(108147, 'Beechwood', 37.5816688537598, 0.655923859892311, -81.3561096191406, -1.41993197946743, 218, 58, 'PPL', 'P'),
(124215, 'Beechwood', 42.2097206115723, 0.736698601018851, -70.8194427490234, -1.23603245039808, 218, 23, 'PPL', 'P'),
(129741, 'Beechwood', 42.7969398498535, 0.746947510157912, -86.1258316040039, -1.50317933250806, 218, 27, 'PPL', 'P'),
(141267, 'Beechwood', 41.3236083984375, 0.721233025357515, -95.9422225952148, -1.6745076759678, 218, 35, 'PPL', 'P'),
(154243, 'Beechwood', 40.8913917541504, 0.713689421832784, -81.1341705322266, -1.41605841166191, 218, 41, 'PPL', 'P'),
(159047, 'Beechwood', 41.9736099243164, 0.732577692127089, -78.6022186279297, -1.37186751442979, 218, 45, 'PPL', 'P'),
(173118, 'Beechwood', 43.5927810668945, 0.760837559718356, -88.1202774047852, -1.53798897848426, 218, 57, 'PPL', 'P'),
(71781, 'Beechwood (historical)', 39.1563911437988, 0.683407948658038, -84.2736129760742, -1.47085201898391, 218, 41, 'PPL', 'P'),
(99744, 'Beechwood (historical)', 36.9241714477539, 0.644448365334187, -82.8161087036133, -1.44541377056758, 218, 53, 'PPL', 'P'),
(180, 'Beechwood Acres', 34.7605590820313, 0.606686205815463, -87.1705627441406, -1.52141333070156, 218, 2, 'PPL', 'P'),
(159048, 'Beechwood Acres', 40.4583282470703, 0.706131037764003, -75.432502746582, -1.31654553594752, 218, 45, 'PPL', 'P'),
(39301, 'Beechwood Estates', 31.7486095428467, 0.554117769452766, -93.1347198486328, -1.62550750928116, 218, 22, 'PPL', 'P'),
(124216, 'Beechwood Estates', 42.4755592346191, 0.741338360269987, -73.1116714477539, -1.27603938839964, 218, 23, 'PPL', 'P'),
(99745, 'Beechwood Farms', 37.6755599975586, 0.657562569490064, -77.4291687011719, -1.35139393091759, 218, 53, 'PPL', 'P'),
(99746, 'Beechwood Gardens', 37.2458305358887, 0.650062375491101, -79.9638900756836, -1.3956331645235, 218, 53, 'PPL', 'P'),
(19147, 'Beechwood Hills', 33.776668548584, 0.589514076527605, -84.6444396972656, -1.47732416622308, 218, 13, 'PPL', 'P'),
(99748, 'Beechwood Hills', 37.3419418334961, 0.651739834082715, -79.2436065673828, -1.38306184575583, 218, 53, 'PPL', 'P'),
(99749, 'Beechwood Manor', 37.2933311462402, 0.650891417538443, -77.2063903808594, -1.34750571572608, 218, 53, 'PPL', 'P'),
(44692, 'Beechwood Mobile Home Park', 39.4636116027832, 0.688769957196804, -76.2605590820313, -1.33099784539311, 218, 25, 'PPL', 'P'),
(44693, 'Beechwood on the Burley', 38.9988899230957, 0.680659033780858, -76.4494400024414, -1.33429443934846, 218, 25, 'PPL', 'P'),
(62821, 'Beechwood Shores', 36.4736099243164, 0.636584583267401, -76.100830078125, -1.32821004836401, 218, 33, 'PPL', 'P'),
(99750, 'Beechwood Shores', 37.1413917541504, 0.648239574882997, -79.6561126708984, -1.39026143544675, 218, 53, 'PPL', 'P'),
(154245, 'Beechwood Trails', 40.023609161377, 0.698543758397394, -82.6508331298828, -1.44252916763287, 218, 41, 'PPL', 'P'),
(34740, 'Beechwood Village', 38.2547187805176, 0.667670797144542, -85.6313934326172, -1.49454975846982, 218, 21, 'PPL', 'P'),
(84916, 'Beechwood Village', 36.5208282470703, 0.637408698466726, -82.5261077880859, -1.44035229975783, 218, 50, 'PPL', 'P'),
(159049, 'Beechwoods', 41.1886100769043, 0.718876860162095, -78.8502807617188, -1.37619701541393, 218, 45, 'PPL', 'P'),
(34741, 'Beechy', 38.624439239502, 0.674123636465804, -82.9541702270508, -1.44782339872189, 218, 21, 'PPL', 'P'),
(7368, 'Beedeville', 35.4288902282715, 0.618350784810983, -91.1097183227539, -1.59016456529666, 218, 4, 'PPL', 'P'),
(34743, 'Beefhide', 37.2397193908691, 0.649955715889444, -82.6275024414063, -1.44212197030219, 218, 21, 'PPL', 'P'),
(15162, 'Beeghly Heights', 30.4905605316162, 0.532160672055335, -81.6741714477539, -1.42548320560165, 218, 12, 'PPL', 'P'),
(77839, 'Beegleton', 39.9147186279297, 0.696643260064487, -78.5155563354492, -1.37035497208868, 218, 45, 'PPL', 'P'),
(193369, 'Beegum', 40.3450012207031, 0.704153108022401, -122.856941223145, -2.14425813327302, 218, 6, 'PPL', 'P'),
(184, 'Beehive', 32.5536117553711, 0.568167708547156, -85.5780563354492, -1.49361885051078, 218, 2, 'PPL', 'P'),
(195955, 'Beehive', 45.4791717529297, 0.793761288168624, -109.720001220703, -1.91497527659347, 218, 31, 'PPL', 'P'),
(19150, 'Beehive (historical)', 32.2922210693359, 0.563605580441796, -83.1208267211914, -1.45073210326447, 218, 13, 'PPL', 'P'),
(147099, 'Beehive Crossing', 42.7938919067383, 0.746894313515137, -78.1527786254883, -1.36402330659702, 218, 40, 'PPL', 'P'),
(29181, 'Beehunter', 38.9561080932617, 0.679912349990227, -87.1211090087891, -1.52055020019226, 218, 19, 'PPL', 'P'),
(39302, 'Beekman', 32.9236106872559, 0.574625408137408, -91.8841705322266, -1.6036813062513, 218, 22, 'PPL', 'P'),
(147103, 'Beekman', 41.6108283996582, 0.726245960056399, -73.7133331298828, -1.28654036573587, 218, 40, 'PPL', 'P'),
(147101, 'Beekmantown', 44.7708282470703, 0.781398361756258, -73.4925003051758, -1.28268610584825, 218, 40, 'PPL', 'P'),
(19151, 'Beeks (historical)', 33.1686096191406, 0.578901446162666, -84.4080581665039, -1.47319853022038, 218, 13, 'PPL', 'P'),
(58602, 'Beeks (historical)', 33.851390838623, 0.590818226513417, -88.3652801513672, -1.54226508308855, 218, 30, 'PPL', 'P'),
(180003, 'Beeks Place', 33.8202781677246, 0.59027520796715, -117.63777923584, -2.05316657239962, 218, 6, 'PPL', 'P'),
(192931, 'Beeler', 38.4444389343262, 0.670982038485892, -100.194442749023, -1.74872291817142, 218, 20, 'PPL', 'P'),
(84917, 'Beeler Mill', 36.3241691589355, 0.633976349874805, -83.6216735839844, -1.45947353006849, 218, 50, 'PPL', 'P'),
(34744, 'Beelerton', 36.5941696166992, 0.638688746844673, -88.8822174072266, -1.55128734022952, 218, 21, 'PPL', 'P'),
(108148, 'Beelick Knob', 37.8741683959961, 0.661028939964911, -80.8675003051758, -1.41140413818284, 218, 58, 'PPL', 'P'),
(159050, 'Beeman', 41.9550018310547, 0.732252919632154, -77.1172180175781, -1.34594936438503, 218, 45, 'PPL', 'P'),
(194571, 'Beeman', 46.4055595397949, 0.809929805199686, -116.524169921875, -2.03373042329006, 218, 17, 'PPL', 'P'),
(141272, 'Beemer', 41.9300003051758, 0.731816560687545, -96.811393737793, -1.68967757416911, 218, 35, 'PPL', 'P'),
(144810, 'Beemerville', 41.2105598449707, 0.719259955884903, -74.6919403076172, -1.30362028307099, 218, 37, 'PPL', 'P'),
(53394, 'Beemont', 38.4805603027344, 0.671612475294941, -91.3591690063477, -1.59451830104672, 218, 29, 'PPL', 'P'),
(195956, 'Been (historical)', 47.2097206115723, 0.823965063618567, -104.171943664551, -1.81814340514846, 218, 31, 'PPL', 'P'),
(188123, 'Beenham', 36.2144393920898, 0.632061204155902, -103.633888244629, -1.80875256651262, 218, 38, 'PPL', 'P'),
(194572, 'Beer Bottle Crossing', 44.6086082458496, 0.778567088622368, -116.230003356934, -2.02859624818255, 218, 17, 'PPL', 'P'),
(79718, 'Beersheba', 35.0377807617188, 0.611524636883919, -81.3194427490234, -1.41929202185749, 218, 48, 'PPL', 'P'),
(84918, 'Beersheba Springs', 35.4666709899902, 0.619010183496886, -85.654167175293, -1.49494723526251, 218, 50, 'PPL', 'P'),
(147104, 'Beerston', 42.1252784729004, 0.735224807671601, -75.1630630493164, -1.31184292609466, 218, 40, 'PPL', 'P'),
(159053, 'Beersville', 40.7463912963867, 0.711158686427909, -75.4711074829102, -1.31721931570331, 218, 45, 'PPL', 'P'),
(206801, 'Bees Mill', 47.7625007629395, 0.833612897299597, -122.854721069336, -2.14421938427916, 218, 56, 'PPL', 'P'),
(70532, 'Beesleys Point', 39.276668548584, 0.685507185387293, -74.6366729736328, -1.30265568612416, 218, 37, 'PPL', 'P'),
(108149, 'Beeson', 37.4708290100098, 0.653989339676478, -81.1941680908203, -1.41710556660253, 218, 58, 'PPL', 'P'),
(62822, 'Beeson Crossroads', 36.086109161377, 0.629821419100118, -80.1013870239258, -1.39803293898177, 218, 33, 'PPL', 'P'),
(29182, 'Beesons', 39.7216682434082, 0.693273895232346, -85.133056640625, -1.48585214066573, 218, 19, 'PPL', 'P'),
(34745, 'Beetle', 38.1955604553223, 0.666638289589918, -82.9463882446289, -1.44768757750629, 218, 21, 'PPL', 'P'),
(173119, 'Beetown', 42.7949981689453, 0.74691362143304, -90.8852767944336, -1.58624732164926, 218, 57, 'PPL', 'P'),
(44694, 'Beetree', 39.6836090087891, 0.692609636277453, -76.6672210693359, -1.33809543601428, 218, 25, 'PPL', 'P'),
(15163, 'Beetree Ford', 29.2302799224854, 0.510164625926962, -82.6488876342773, -1.44249521232897, 218, 12, 'PPL', 'P'),
(44695, 'Beetree Manor', 39.7011108398438, 0.692915100854485, -76.6875, -1.33844937012315, 218, 25, 'PPL', 'P'),
(194573, 'Beetville', 42.4886093139648, 0.741566127122216, -113.830558776855, -1.98671804004106, 218, 17, 'PPL', 'P'),
(92532, 'Beeville', 28.4005603790283, 0.495683288025493, -97.7480621337891, -1.70602552167861, 218, 51, 'PPL', 'P'),
(39312, 'Beggs', 30.6802806854248, 0.535471913396686, -92.0527801513672, -1.60662409925584, 218, 22, 'PPL', 'P'),
(75093, 'Beggs', 35.7425003051758, 0.623824313220395, -96.0699996948242, -1.67673780706463, 218, 42, 'PPL', 'P'),
(7369, 'Begley (historical)', 35.8855590820313, 0.626321159900399, -92.5336074829102, -1.61501611932484, 218, 4, 'PPL', 'P'),
(62823, 'Begonia (historical)', 35.1552810668945, 0.613575404081334, -81.1152801513672, -1.41572871231896, 218, 33, 'PPL', 'P'),
(159052, 'Beham', 40.021671295166, 0.69850993625155, -80.5111083984375, -1.40518392598279, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(108150, 'Behler', 39.6458282470703, 0.691950237591549, -80.1399993896484, -1.39870685189561, 218, 58, 'PPL', 'P'),
(29184, 'Behlmer Corner', 39.2024993896484, 0.684212689360433, -85.1697235107422, -1.48649209827568, 218, 19, 'PPL', 'P'),
(84919, 'Beidlemans (historical)', 36.519718170166, 0.637389323969796, -82.1305618286133, -1.43344872042208, 218, 50, 'PPL', 'P'),
(202995, 'Beindneau Summer Home Area', 41.7652816772461, 0.728941678290804, -111.694717407227, -1.94944057584073, 218, 52, 'PPL', 'P'),
(7370, 'Beirne', 33.8886108398438, 0.591467838082314, -93.2038879394531, -1.62671472020329, 218, 4, 'PPL', 'P'),
(147113, 'Beixedon Estates', 41.0683288574219, 0.716777556853813, -72.4113922119141, -1.26381721005088, 218, 40, 'PPL', 'P'),
(191121, 'Bejar Estates Colonia', 31.6119995117188, 0.551733474618332, -106.25700378418, -1.85453456933801, 218, 51, 'PPL', 'P'),
(134168, 'Bejou', 47.4413909912109, 0.828008474522607, -95.975830078125, -1.67509423719789, 218, 28, 'PPL', 'P'),
(39303, 'Bel', 30.5197200775146, 0.53266960213965, -93.0844421386719, -1.62462999770198, 218, 22, 'PPL', 'P'),
(197, 'Bel Air', 33.5849990844727, 0.586168813303329, -86.7213897705078, -1.51357378340069, 218, 2, 'PPL', 'P'),
(19152, 'Bel Air', 31.2222194671631, 0.544930529482265, -81.4994430541992, -1.4224336198374, 218, 13, 'PPL', 'P'),
(34746, 'Bel Air', 38.0041694641113, 0.663297886634632, -84.2008285522461, -1.46958169114394, 218, 21, 'PPL', 'P'),
(44703, 'Bel Air', 39.5730590820313, 0.69068017606769, -78.8499984741211, -1.37619208856592, 218, 25, 'PPL', 'P'),
(84920, 'Bel Air', 35.6269416809082, 0.621807434747851, -87.045280456543, -1.51922674228855, 218, 50, 'PPL', 'P'),
(92531, 'Bel Air', 32.5183296203613, 0.567551919124103, -94.3733291625977, -1.64712531995571, 218, 51, 'PPL', 'P'),
(99756, 'Bel Air', 38.3355598449707, 0.669081739890066, -77.434440612793, -1.35148594313325, 218, 53, 'PPL', 'P'),
(180004, 'Bel Air', 34.0833282470703, 0.594866297949364, -118.447776794434, -2.0673036967302, 218, 6, 'PPL', 'P'),
(44698, 'Bel Air Acres', 39.5194396972656, 0.689744341260636, -76.3680572509766, -1.33287404238107, 218, 25, 'PPL', 'P'),
(191, 'Bel Air Estates', 33.2619400024414, 0.580530368643413, -87.6877822875977, -1.53044051469054, 218, 2, 'PPL', 'P'),
(19154, 'Bel Air Heights', 33.4541702270508, 0.583885418984695, -82.1236114501953, -1.43332741343442, 218, 13, 'PPL', 'P'),
(99753, 'Bel Air Mobile Home Park', 38.6425018310547, 0.674438888159842, -77.2683334350586, -1.34858682597059, 218, 53, 'PPL', 'P'),
(44699, 'Bel Alton', 38.4638900756836, 0.67132152494585, -76.9830627441406, -1.34360791315464, 218, 25, 'PPL', 'P'),
(44700, 'Bel Alton Estates', 38.4680595397949, 0.671394295822636, -76.9763870239258, -1.34349139985694, 218, 25, 'PPL', 'P'),
(44701, 'Bel Forest', 39.5400009155273, 0.690103202217524, -76.3824996948242, -1.33312611057825, 218, 25, 'PPL', 'P'),
(44702, 'Bel Hill (historical)', 39.6305618286133, 0.691683788324487, -75.8263931274414, -1.32342021998545, 218, 25, 'PPL', 'P'),
(180006, 'Bel Marin Keys', 38.082218170166, 0.664660093532207, -122.513610839844, -2.13826588766229, 218, 6, 'PPL', 'P'),
(15164, 'Bel Marra', 26.4058303833008, 0.460868681911755, -80.0722198486328, -1.3975238757394, 218, 12, 'PPL', 'P'),
(44704, 'Bel Pre Farms', 39.0911102294922, 0.682268581764675, -77.0625, -1.34499435481813, 218, 25, 'PPL', 'P'),
(202997, 'Bel Won Enterprise', 40.6583290100098, 0.709621709583797, -111.988609313965, -1.95456995725827, 218, 52, 'PPL', 'P'),
(15165, 'Bel-Air', 28.7947196960449, 0.502562665884845, -81.2547225952148, -1.41816244208113, 218, 12, 'PPL', 'P'),
(84923, 'Bel-Air Estates', 36.5694389343262, 0.638257115010998, -87.4000015258789, -1.52541779287465, 218, 50, 'PPL', 'P'),
(84924, 'Bel-Aire', 35.3608283996582, 0.617162881806753, -86.2372207641602, -1.50512344010382, 218, 50, 'PPL', 'P'),
(99754, 'Bel-Aire', 36.9194412231445, 0.644365807340395, -76.2322235107422, -1.33050329637868, 218, 53, 'PPL', 'P'),
(202998, 'Bel-Aire Condominium', 41.0980606079102, 0.717296473792215, -112.005561828613, -1.95486583445538, 218, 52, 'PPL', 'P'),
(84925, 'Bel-Aire Heights', 35.1986083984375, 0.614331608672863, -86.1047210693359, -1.50281088417124, 218, 50, 'PPL', 'P'),
(193113, 'Bel-Aire Trailer Park', 33.4847183227539, 0.584418583834929, -112.114440917969, -1.95676613305121, 218, 5, 'PPL', 'P'),
(53391, 'Bel-Nor', 38.7019386291504, 0.675476255983455, -90.3166732788086, -1.57632331816319, 218, 29, 'PPL', 'P'),
(53392, 'Bel-Ridge', 38.7094383239746, 0.675607150351032, -90.3252792358398, -1.57647352044867, 218, 29, 'PPL', 'P'),
(159054, 'Bela', 41.0499992370605, 0.716457644627867, -79.5777816772461, -1.38889430170116, 218, 45, 'PPL', 'P'),
(39305, 'Belah', 31.6458301544189, 0.552323930721516, -92.1813888549805, -1.60886874458061, 218, 22, 'PPL', 'P'),
(15166, 'Belair', 30.3799991607666, 0.530231012108491, -84.2683334350586, -1.4707598736102, 218, 12, 'PPL', 'P'),
(19156, 'Belair', 33.4419403076172, 0.583671966623325, -82.1213912963867, -1.43328866444056, 218, 13, 'PPL', 'P'),
(39306, 'Belair', 29.7202796936035, 0.518716735266993, -89.9822235107422, -1.5704860685279, 218, 22, 'PPL', 'P'),
(79719, 'Belair', 34.9530601501465, 0.61004598326768, -80.850830078125, -1.41111318783375, 218, 48, 'PPL', 'P'),
(79720, 'Belair Acres', 34.9608306884766, 0.610181604746192, -81.1013870239258, -1.41548623150171, 218, 48, 'PPL', 'P'),
(39307, 'Belair Cove', 30.6483306884766, 0.534914280753937, -92.2263870239258, -1.60965411078608, 218, 22, 'PPL', 'P'),
(62828, 'Belair Estates', 35.4627799987793, 0.618942272889089, -77.4124984741211, -1.3511029805685, 218, 33, 'PPL', 'P'),
(99755, 'Belair Springs', 36.6269416809082, 0.639260727267794, -80.4780578613281, -1.40460708529068, 218, 53, 'PPL', 'P'),
(19158, 'Belair Woods', 33.5736083984375, 0.585970008327955, -84.2130584716797, -1.46979514350531, 218, 13, 'PPL', 'P'),
(79722, 'Belaire Estates', 34.7919387817383, 0.607233884893638, -82.4458312988281, -1.43895121070834, 218, 48, 'PPL', 'P'),
(193112, 'Belaire Manor', 33.5152816772461, 0.584952015001272, -112.179168701172, -1.95789584598562, 218, 5, 'PPL', 'P'),
(75095, 'Beland', 35.6916694641113, 0.622937147682263, -95.5355606079102, -1.66741008534663, 218, 42, 'PPL', 'P'),
(15167, 'Belandville', 30.9816703796387, 0.540732155892296, -86.8488922119141, -1.51579912080756, 218, 12, 'PPL', 'P'),
(159055, 'Belardy', 40.1005592346191, 0.699886790535121, -74.8783264160156, -1.30687333434252, 218, 45, 'PPL', 'P'),
(499, 'Belcamp', 39.4688911437988, 0.68886210257052, -76.2336120605469, -1.3305275311446, 218, 25, 'PPL', 'P'),
(7373, 'Belcher', 35.0816688537598, 0.612290628592453, -91.601936340332, -1.59875539034104, 218, 4, 'PPL', 'P'),
(34747, 'Belcher', 37.3416709899902, 0.65173510697178, -82.3736114501953, -1.43769073656441, 218, 21, 'PPL', 'P'),
(39308, 'Belcher', 32.7486114501953, 0.571571095262223, -93.8327789306641, -1.63769093863605, 218, 22, 'PPL', 'P'),
(147105, 'Belcher', 43.2802810668945, 0.755383405805874, -73.3883285522461, -1.28086796577206, 218, 40, 'PPL', 'P'),
(53393, 'Belcher (historical)', 36.7236099243164, 0.640947906397387, -90.5752792358398, -1.58083684357866, 218, 29, 'PPL', 'P'),
(79723, 'Belcher Crossroads', 34.045280456543, 0.594202238731553, -82.4252777099609, -1.43859248290951, 218, 48, 'PPL', 'P'),
(124217, 'Belcher Square', 42.2000007629395, 0.736528957657413, -73.3472213745117, -1.28015051017439, 218, 23, 'PPL', 'P'),
(202, 'Belchers', 33.1094398498535, 0.577868738870961, -87.2088928222656, -1.52208231676739, 218, 2, 'PPL', 'P'),
(124218, 'Belchers Corner (historical)', 42.1333312988281, 0.73536535599813, -71.1097183227539, -1.2410987148978, 218, 23, 'PPL', 'P'),
(124219, 'Belchertown', 42.2769393920898, 0.737871790058058, -72.4013900756836, -1.26364263984143, 218, 23, 'PPL', 'P'),
(92534, 'Belcherville', 33.8025016784668, 0.589964949700155, -97.8319396972656, -1.70748946132983, 218, 51, 'PPL', 'P'),
(79724, 'Belclear', 33.5191688537598, 0.585019859030042, -81.9024963378906, -1.42946822669879, 218, 48, 'PPL', 'P'),
(92533, 'Belco', 31.1358299255371, 0.543422747541603, -97.3391723632813, -1.69888904890553, 218, 51, 'PPL', 'P'),
(147106, 'Belcoda', 43.0247192382813, 0.750923010454155, -77.8463897705078, -1.35867581228619, 218, 40, 'PPL', 'P'),
(139658, 'Belcourt', 48.839168548584, 0.852404295109251, -99.7444381713867, -1.74086885664261, 218, 34, 'PPL', 'P'),
(70526, 'Belcoville', 39.4372215270996, 0.688309363486274, -74.7363891601563, -1.30439606189653, 218, 37, 'PPL', 'P'),
(173121, 'Belcrest', 42.541389465332, 0.742487314543274, -89.0961074829102, -1.55502042628754, 218, 57, 'PPL', 'P'),
(62829, 'Belcross', 36.3477783203125, 0.634388407474467, -76.1549987792969, -1.32915547055099, 218, 33, 'PPL', 'P'),
(58605, 'Belden', 34.3102798461914, 0.598827350596694, -88.788330078125, -1.5496486972108, 218, 30, 'PPL', 'P'),
(118759, 'Belden', 42.4741706848145, 0.741314125504067, -88.3472213745117, -1.54194989797354, 218, 18, 'PPL', 'P'),
(134171, 'Belden', 46.3222198486328, 0.808475253191312, -92.3130569458008, -1.61116678628524, 218, 28, 'PPL', 'P'),
(141269, 'Belden', 42.4130592346191, 0.74024752948749, -97.2063903808594, -1.69657156612494, 218, 35, 'PPL', 'P'),
(147107, 'Belden', 42.2036094665527, 0.736591941417193, -75.6752777099609, -1.32078275839989, 218, 40, 'PPL', 'P'),
(154246, 'Belden', 41.2380599975586, 0.719739924092362, -82.0233306884766, -1.43157718396602, 218, 41, 'PPL', 'P'),
(159056, 'Belden', 40.0758285522461, 0.699455158701447, -78.5058288574219, -1.37018519556919, 218, 45, 'PPL', 'P'),
(186400, 'Belden', 39.5255584716797, 0.689851134020348, -106.385559082031, -1.8567782825564, 218, 7, 'PPL', 'P'),
(193370, 'Belden', 40.0061111450195, 0.698238360399389, -121.248062133789, -2.11617789589728, 218, 6, 'PPL', 'P'),
(197985, 'Belden', 48.1513900756836, 0.8404002962328, -102.356941223145, -1.78646563661418, 218, 34, 'PPL', 'P'),
(171727, 'Beldens', 44.0511093139648, 0.768836896684627, -73.1758270263672, -1.27715911447996, 218, 55, 'PPL', 'P'),
(173122, 'Beldenville', 44.7738914489746, 0.781451824715142, -92.5074996948242, -1.61456045246233, 218, 57, 'PPL', 'P'),
(129742, 'Belding', 43.0977783203125, 0.752198131984084, -85.228889465332, -1.48752473898835, 218, 27, 'PPL', 'P'),
(191122, 'Belding', 30.791109085083, 0.537406233875437, -103.024719238281, -1.79812056165075, 218, 51, 'PPL', 'P'),
(124221, 'Beldingville', 42.5374984741211, 0.742419403935477, -72.7702789306641, -1.27008096493475, 218, 23, 'PPL', 'P'),
(99757, 'Beldor', 38.3499984741211, 0.669333741508214, -78.6074981689453, -1.37195965980351, 218, 53, 'PPL', 'P'),
(58606, 'Belen', 34.2730598449707, 0.598177739027796, -90.3541717529297, -1.57697779000108, 218, 30, 'PPL', 'P'),
(188124, 'Belen', 34.6627807617188, 0.60497965218894, -106.775833129883, -1.8635898496765, 218, 38, 'PPL', 'P'),
(191123, 'Belen', 31.6858291625977, 0.553022045111767, -106.311943054199, -1.85549344048849, 218, 51, 'PPL', 'P'),
(191124, 'Belen Plaza Colonia', 31.6469993591309, 0.552344337193369, -106.269996643066, -1.85476133750483, 218, 51, 'PPL', 'P'),
(206, 'Belew (historical)', 34.9913902282715, 0.610714969333508, -87.4388885498047, -1.52609649947846, 218, 2, 'PPL', 'P'),
(53395, 'Belews Creek', 38.2991714477539, 0.668446642549109, -90.5666732788086, -1.58068664129318, 218, 29, 'PPL', 'P'),
(62830, 'Belews Creek', 36.2444381713867, 0.632584781626211, -80.0699996948242, -1.39748512674554, 218, 33, 'PPL', 'P'),
(206804, 'Belfair', 47.4508285522461, 0.828173191036028, -122.826110839844, -2.14372004157477, 218, 56, 'PPL', 'P'),
(99758, 'Belfair Crossroads', 38.5791702270508, 0.673333543149405, -77.4280624389648, -1.35137462299969, 218, 53, 'PPL', 'P'),
(92537, 'Belfalls', 31.173059463501, 0.544072525558069, -97.2033309936523, -1.69651816974508, 218, 51, 'PPL', 'P'),
(7375, 'Belfast', 34.4144401550293, 0.600645290935809, -92.4588928222656, -1.61371210249709, 218, 4, 'PPL', 'P'),
(19160, 'Belfast', 31.8241691589355, 0.55543653353506, -81.2919387817383, -1.418811987071, 218, 13, 'PPL', 'P'),
(44705, 'Belfast', 39.547779083252, 0.690238956854091, -76.6788864135742, -1.33829903467962, 218, 25, 'PPL', 'P'),
(53399, 'Belfast', 36.8663902282715, 0.643439892808401, -94.4541702270508, -1.64853626270124, 218, 29, 'PPL', 'P'),
(62831, 'Belfast', 35.4269409179688, 0.618316762928057, -77.9822235107422, -1.36104655828858, 218, 33, 'PPL', 'P'),
(71784, 'Belfast', 39.0627784729004, 0.681774099329274, -83.5325012207031, -1.45791717872745, 218, 41, 'PPL', 'P'),
(84927, 'Belfast', 35.4208297729492, 0.618210103326399, -86.7024993896484, -1.51324408405774, 218, 50, 'PPL', 'P'),
(99759, 'Belfast', 36.9836082458496, 0.6454857331578, -81.8544387817383, -1.42862946411347, 218, 53, 'PPL', 'P'),
(126854, 'Belfast', 44.4258308410645, 0.775377021110616, -69.0069427490234, -1.20439835770569, 218, 26, 'PPL', 'P'),
(141270, 'Belfast', 41.6375007629395, 0.726711480614944, -98.6163864135742, -1.72118063933587, 218, 35, 'PPL', 'P'),
(147108, 'Belfast', 42.3427810668945, 0.739020944068427, -78.1116714477539, -1.36330585099935, 218, 40, 'PPL', 'P'),
(159064, 'Belfast', 40.7805595397949, 0.711755034775005, -75.2783279418945, -1.31385467798211, 218, 45, 'PPL', 'P'),
(193371, 'Belfast', 40.4436111450195, 0.705874175876865, -120.450561523438, -2.10225888445998, 218, 6, 'PPL', 'P'),
(206805, 'Belfast', 48.5547218322754, 0.84743976336318, -122.333892822266, -2.13512921653039, 218, 56, 'PPL', 'P'),
(71785, 'Belfast (historical)', 39.836109161377, 0.695271266049905, -84.7786102294922, -1.47966588376958, 218, 41, 'PPL', 'P'),
(114544, 'Belfast (historical)', 40.9897193908691, 0.715405562839231, -91.6852798461914, -1.60021000892844, 218, 16, 'PPL', 'P'),
(180007, 'Belfast (historical)', 35.045280456543, 0.611655531251496, -116.100830078125, -2.02634174916175, 218, 6, 'PPL', 'P'),
(159057, 'Belfast Junction', 40.7677803039551, 0.711531995033711, -75.2727813720703, -1.31375787207648, 218, 45, 'PPL', 'P'),
(99760, 'Belfast Mills', 36.9797210693359, 0.64541788912903, -81.8399963378906, -1.42837739591629, 218, 53, 'PPL', 'P'),
(39310, 'Belfield', 30.3388900756836, 0.52951352322131, -93.2005615234375, -1.62665666329153, 218, 22, 'PPL', 'P'),
(197986, 'Belfield', 46.8852806091309, 0.818302517350786, -103.199172973633, -1.80116535372504, 218, 34, 'PPL', 'P'),
(108151, 'Belfont', 38.7036094665527, 0.675505417597391, -80.8630599975586, -1.41132664019512, 218, 58, 'PPL', 'P'),
(75096, 'Belfonte', 35.5441703796387, 0.620362803014538, -94.5547180175781, -1.65029115270154, 218, 42, 'PPL', 'P'),
(144814, 'Belford', 40.4258308410645, 0.705563851030843, -74.0872192382813, -1.29306590935489, 218, 37, 'PPL', 'P'),
(159058, 'Belford', 41.128059387207, 0.717820051262524, -78.0833282470703, -1.36281116882687, 218, 45, 'PPL', 'P'),
(13353, 'Belford Manor', 39.7333297729492, 0.693477427318655, -75.6522216796875, -1.32038035475918, 218, 10, 'PPL', 'P'),
(209, 'Belforest', 30.603609085083, 0.534133741527948, -87.8525009155273, -1.53331539708728, 218, 2, 'PPL', 'P'),
(147110, 'Belfort', 43.9280586242676, 0.76668925700256, -75.3324966430664, -1.31480010016908, 218, 40, 'PPL', 'P'),
(154247, 'Belfort', 40.8122215270996, 0.712307640701196, -81.2455596923828, -1.41800251925767, 218, 41, 'PPL', 'P'),
(180008, 'Belfort', 38.416389465332, 0.670492482898508, -119.26611328125, -2.08158636281435, 218, 6, 'PPL', 'P'),
(34750, 'Belfry', 37.6202812194824, 0.656597772806156, -82.269172668457, -1.4358679359563, 218, 21, 'PPL', 'P'),
(159059, 'Belfry', 40.1766700744629, 0.701215175286853, -75.3050003051758, -1.31432019854065, 218, 45, 'PPL', 'P'),
(195957, 'Belfry', 45.1419410705566, 0.787875502422467, -109.004722595215, -1.90249130950956, 218, 31, 'PPL', 'P'),
(195958, 'Belgian Colony (historical)', 48.3166694641113, 0.843284965746547, -112.033332824707, -1.95535052977378, 218, 31, 'PPL', 'P'),
(53396, 'Belgique', 37.8375015258789, 0.660388982354965, -89.7811126708984, -1.56697602221118, 218, 29, 'PPL', 'P'),
(108152, 'Belgium', 39.3236083984375, 0.686326440317629, -80.1163864135742, -1.39829472771692, 218, 58, 'PPL', 'P'),
(118760, 'Belgium', 40.0613899230957, 0.699203157083298, -87.6380615234375, -1.52957272364934, 218, 18, 'PPL', 'P'),
(147111, 'Belgium', 43.1763916015625, 0.753570192577693, -76.2750015258789, -1.33124991359029, 218, 40, 'PPL', 'P'),
(173123, 'Belgium', 43.4997215270996, 0.759213364348544, -87.8502807617188, -1.53327664809342, 218, 57, 'PPL', 'P'),
(15168, 'Belgium (historical)', 27.2372207641602, 0.475379181427161, -81.89111328125, -1.42926955488147, 218, 12, 'PPL', 'P'),
(118761, 'Belgium Row', 40.1330604553223, 0.700454043847308, -87.7536087036133, -1.5315894023848, 218, 18, 'PPL', 'P'),
(19162, 'Belglade', 33.4824981689453, 0.584379834841068, -82.1455612182617, -1.43371050915723, 218, 13, 'PPL', 'P'),
(53397, 'Belgrade', 37.7866706848145, 0.659501816816833, -90.8491668701172, -1.5856170845773, 218, 29, 'PPL', 'P'),
(62832, 'Belgrade', 34.8800010681152, 0.60877086173775, -77.2352828979492, -1.34800998527848, 218, 33, 'PPL', 'P'),
(92535, 'Belgrade', 30.6855602264404, 0.535564058770402, -93.663330078125, -1.63473349824552, 218, 51, 'PPL', 'P'),
(126856, 'Belgrade', 44.4472198486328, 0.775750329716418, -69.8330612182617, -1.21881684500543, 218, 26, 'PPL', 'P'),
(134175, 'Belgrade', 45.4530601501465, 0.793305554727084, -95.0041732788086, -1.65813562685043, 218, 28, 'PPL', 'P'),
(141271, 'Belgrade', 41.4730606079102, 0.723841458487193, -98.0680618286133, -1.71161056995867, 218, 35, 'PPL', 'P'),
(195959, 'Belgrade', 45.7761116027832, 0.798943866228946, -111.176109313965, -1.94038915708582, 218, 31, 'PPL', 'P'),
(195960, 'Belgrade Junction', 45.7797203063965, 0.799006849988726, -111.279167175293, -1.94218785608606, 218, 31, 'PPL', 'P'),
(126857, 'Belgrade Lakes', 44.5263900756836, 0.777132110848006, -69.8874969482422, -1.21976692772432, 218, 26, 'PPL', 'P'),
(195961, 'Belgrade Trailer Court', 45.7788887023926, 0.798992335760785, -111.180000305176, -1.94045706769362, 218, 31, 'PPL', 'P'),
(195962, 'Belgrade Village Mobile Home Park', 45.774169921875, 0.798909977504074, -111.169441223145, -1.94027277694618, 218, 31, 'PPL', 'P'),
(44706, 'Belgravia', 39.350830078125, 0.686801548256099, -76.5344390869141, -1.33577795323369, 218, 25, 'PPL', 'P'),
(213, 'Belgreen', 34.4747200012207, 0.601697372724445, -87.8663864135742, -1.53355774474648, 218, 2, 'PPL', 'P'),
(108153, 'Belgrove', 38.709171295166, 0.675602489819125, -81.5772171020508, -1.42379103304501, 218, 58, 'PPL', 'P'),
(62833, 'Belhaven', 35.5400009155273, 0.620290032137751, -76.6233291625977, -1.33732937772672, 218, 33, 'PPL', 'P'),
(44707, 'Belhaven Beach', 39.127498626709, 0.682903679105631, -76.4780578613281, -1.33479391521091, 218, 25, 'PPL', 'P'),
(44708, 'Belhaven Woods', 39.139720916748, 0.683116998308947, -76.4836120605469, -1.33489085427459, 218, 25, 'PPL', 'P'),
(159060, 'Belian Village', 41.3444404602051, 0.721596613425338, -75.7063903808594, -1.32132577694616, 218, 45, 'PPL', 'P'),
(79725, 'Belin', 33.5177803039551, 0.584995624264122, -79.1438903808594, -1.38132146998347, 218, 48, 'PPL', 'P'),
(99762, 'Belinda', 37.9113883972168, 0.661678551533809, -75.6622161865234, -1.32055479181058, 218, 53, 'PPL', 'P'),
(114545, 'Belinda', 41.1388893127441, 0.718009069120892, -93.1922225952148, -1.62651112153795, 218, 16, 'PPL', 'P'),
(84928, 'Belinda City', 36.1674995422363, 0.631241949225566, -86.4858322143555, -1.50946252846788, 218, 50, 'PPL', 'P'),
(108154, 'Belington', 39.0250015258789, 0.681114767222398, -79.9358291625977, -1.39514340919903, 218, 58, 'PPL', 'P'),
(221, 'Belk', 33.6474990844727, 0.587259644085826, -87.9313888549805, -1.53469225137086, 218, 2, 'PPL', 'P'),
(84929, 'Belk', 35.8424987792969, 0.625569615840779, -85.6994400024414, -1.49573739515794, 218, 50, 'PPL', 'P'),
(92536, 'Belk', 33.8450012207031, 0.59070670664277, -95.7147216796875, -1.67053703594054, 218, 51, 'PPL', 'P'),
(7376, 'Belk Corner', 35.0494384765625, 0.611728102391201, -92.4902801513672, -1.61425991473332, 218, 4, 'PPL', 'P'),
(218, 'Belknap', 32.2061080932617, 0.56210262548061, -87.0138931274414, -1.51867893005232, 218, 2, 'PPL', 'P'),
(26479, 'Belknap', 37.3250007629395, 0.651444156622689, -88.9388885498047, -1.55227643825838, 218, 18, 'PPL', 'P'),
(29185, 'Belknap', 37.9833297729492, 0.662934165408754, -87.6880569458008, -1.53044530838051, 218, 19, 'PPL', 'P'),
(34748, 'Belknap', 37.7211112976074, 0.65835758965448, -83.2941665649414, -1.4537574542628, 218, 21, 'PPL', 'P'),
(114546, 'Belknap', 40.8205604553223, 0.712453182454769, -92.4261093139648, -1.61313992233688, 218, 16, 'PPL', 'P'),
(129744, 'Belknap', 45.3319396972656, 0.791191604032807, -83.8433303833008, -1.463342171026, 218, 27, 'PPL', 'P'),
(154248, 'Belknap', 40.2305603027344, 0.702155737204842, -80.879997253418, -1.41162225107611, 218, 41, 'PPL', 'P'),
(159061, 'Belknap', 40.899169921875, 0.713825176469351, -79.3030624389648, -1.38409954647458, 218, 45, 'PPL', 'P'),
(192481, 'Belknap', 38.5149993896484, 0.672213550752972, -112.26277923584, -1.95935512510493, 218, 52, 'PPL', 'P'),
(195963, 'Belknap', 47.6622200012207, 0.831862667831197, -115.407783508301, -2.01424580464866, 218, 31, 'PPL', 'P'),
(7377, 'Belknap (historical)', 35.2666702270508, 0.615519511677092, -90.6149978637695, -1.58153006441041, 218, 4, 'PPL', 'P'),
(34749, 'Belknap Beach', 38.3827781677246, 0.669905855089391, -85.6233291625977, -1.49440901040621, 218, 21, 'PPL', 'P'),
(147112, 'Belknap Crossing', 42.8641700744629, 0.7481208989342, -78.1627807617188, -1.36419787680647, 218, 40, 'PPL', 'P'),
(200396, 'Belknap Springs', 44.190559387207, 0.77127075960485, -122.048057556152, -2.1301404500184, 218, 43, 'PPL', 'P'),
(212298, 'Belkofski', 55.0888900756836, 0.961482513089907, -162.030563354492, -2.82796681939716, 218, 1, 'PPL', 'P'),
(219, 'Bell', 33.3388900756836, 0.58187340078114, -87.960563659668, -1.53520144777128, 218, 2, 'PPL', 'P'),
(15169, 'Bell', 29.7552795410156, 0.51932759784203, -82.8627777099609, -1.44622829838699, 218, 12, 'PPL', 'P'),
(19161, 'Bell', 33.9883308410645, 0.593208280433708, -82.7763900756836, -1.44472054973584, 218, 13, 'PPL', 'P'),
(44709, 'Bell', 38.9700012207031, 0.680154830807479, -76.8016662597656, -1.34044194725075, 218, 25, 'PPL', 'P'),
(75097, 'Bell', 35.7180595397949, 0.623397741392792, -94.5758285522461, -1.65065960103836, 218, 42, 'PPL', 'P'),
(114548, 'Bell', 41.957218170166, 0.732291602046987, -95.4955596923828, -1.66671193766686, 218, 16, 'PPL', 'P'),
(118763, 'Bell', 40.1919403076172, 0.701481691132942, -89.3874969482422, -1.56010613186321, 218, 18, 'PPL', 'P'),
(129746, 'Bell', 45.2497215270996, 0.789756626258445, -83.4327774047852, -1.45617666979703, 218, 27, 'PPL', 'P'),
(180009, 'Bell', 33.9775009155273, 0.59301926257534, -118.186111450195, -2.06273677493488, 218, 6, 'PPL', 'P'),
(193114, 'Bell', 34.2722206115723, 0.598163091641801, -109.914169311523, -1.91836414908059, 218, 5, 'PPL', 'P'),
(159062, 'Bell Acres', 40.5900001525879, 0.70842914604766, -80.1666717529297, -1.39917237245416, 218, 45, 'PPL', 'P'),
(62834, 'Bell Arthur', 35.5902786254883, 0.621167543716932, -77.5138931274414, -1.35287265111286, 218, 33, 'PPL', 'P'),
(92538, 'Bell Branch', 32.2433280944824, 0.562752237049508, -96.9252777099609, -1.69166522444869, 218, 51, 'PPL', 'P'),
(84930, 'Bell Bridge', 36.017219543457, 0.628619068446974, -84.0502777099609, -1.46695408325442, 218, 50, 'PPL', 'P'),
(84931, 'Bell Buckle', 35.5916709899902, 0.621191845061879, -86.3541717529297, -1.50716461992131, 218, 50, 'PPL', 'P'),
(203000, 'Bell Canyon Estates', 40.5513916015625, 0.707755299712842, -111.858329772949, -1.95229615031957, 218, 52, 'PPL', 'P'),
(122210, 'Bell Center', 40.8686103820801, 0.713291811882035, -86.6391677856445, -1.5121387390473, 218, 19, 'PPL', 'P'),
(173126, 'Bell Center', 43.2916717529297, 0.755582210781248, -90.8266677856445, -1.58522440147456, 218, 57, 'PPL', 'P'),
(7378, 'Bell City', 36.2877807617188, 0.633341252533848, -90.121940612793, -1.57292459198003, 218, 4, 'PPL', 'P'),
(34752, 'Bell City', 36.5374984741211, 0.637699648815817, -88.5005569458008, -1.54462610855296, 218, 21, 'PPL', 'P'),
(39313, 'Bell City', 30.1130599975586, 0.525572044807993, -92.9625015258789, -1.62250173251684, 218, 22, 'PPL', 'P'),
(53400, 'Bell City', 37.023609161377, 0.646183880837564, -89.8197174072266, -1.56764980196697, 218, 29, 'PPL', 'P'),
(99765, 'Bell Creek North', 37.6258316040039, 0.656694645290807, -77.3502807617188, -1.35001707663402, 218, 53, 'PPL', 'P'),
(195964, 'Bell Crossing', 46.4433288574219, 0.810589004148508, -114.123062133789, -1.99182318669268, 218, 31, 'PPL', 'P'),
(241, 'Bell Factory', 34.8238906860352, 0.6077915508259, -86.4738922119141, -1.50925413611258, 218, 2, 'PPL', 'P'),
(44710, 'Bell Forest', 39.1188888549805, 0.682753410241124, -76.4997177124023, -1.33517195092765, 218, 25, 'PPL', 'P'),
(99763, 'Bell Forest', 38.6897201538086, 0.675263003359167, -77.45361328125, -1.35182056932422, 218, 53, 'PPL', 'P'),
(62838, 'Bell Fork', 34.7613906860352, 0.606700720043404, -77.4005584716797, -1.3508945882132, 218, 33, 'PPL', 'P'),
(62837, 'Bell Fork Homes', 34.7561111450195, 0.606608574669687, -77.4005584716797, -1.3508945882132, 218, 33, 'PPL', 'P'),
(180010, 'Bell Gardens', 33.9652786254883, 0.592805943372025, -118.15055847168, -2.06211625840089, 218, 6, 'PPL', 'P'),
(139027, 'Bell Grove', 40.3036117553711, 0.703430725576717, -94.913330078125, -1.65655011389545, 218, 29, 'PPL', 'P'),
(39315, 'Bell Grove Place', 30.3869400024414, 0.530352152648576, -91.0147171020508, -1.58850648120198, 218, 22, 'PPL', 'P'),
(134178, 'Bell Harbor', 47.3891716003418, 0.827097074218555, -91.1386108398438, -1.59066883484907, 218, 28, 'PPL', 'P'),
(44711, 'Bell Haven', 38.6072196960449, 0.673823098736788, -76.5833282470703, -1.33663123004695, 218, 25, 'PPL', 'P'),
(99764, 'Bell Haven', 38.1041717529297, 0.665043255834042, -78.4794387817383, -1.36972460185866, 218, 53, 'PPL', 'P'),
(173128, 'Bell Heights', 44.2805595397949, 0.772841558594806, -88.4158325195313, -1.54314738835769, 218, 57, 'PPL', 'P'),
(206814, 'Bell Hill', 48.0563888549805, 0.838742212138117, -123.083610534668, -2.14821425907233, 218, 56, 'PPL', 'P'),
(84932, 'Bell Hollow (historical)', 36.2416687011719, 0.632536445252426, -87.4047164916992, -1.52550008455234, 218, 50, 'PPL', 'P'),
(209939, 'Bell Island Hot Springs', 55.9316711425781, 0.976191817580687, -131.565277099609, -2.29624726668688, 218, 1, 'PPL', 'P'),
(129747, 'Bell Landing', 45.4894409179688, 0.793940518909987, -84.0741729736328, -1.46737113428112, 218, 27, 'PPL', 'P'),
(84933, 'Bell Meade Subdivision', 36.475830078125, 0.636623332261262, -88.85888671875, -1.55088014289885, 218, 50, 'PPL', 'P'),
(229, 'Bell Mills', 33.6163902282715, 0.586716692118586, -85.4747161865234, -1.49181522466253, 218, 2, 'PPL', 'P'),
(180012, 'Bell Mountain', 34.6241683959961, 0.604305739275096, -117.206108093262, -2.04563248967579, 218, 6, 'PPL', 'P'),
(129748, 'Bell Oak', 42.7286109924316, 0.745754946621774, -84.1736068725586, -1.46910658320547, 218, 27, 'PPL', 'P'),
(191130, 'Bell Place Windmill', 30.6197204589844, 0.534414938049547, -104.489723205566, -1.82368970443466, 218, 51, 'PPL', 'P'),
(159065, 'Bell Point', 40.5449981689453, 0.707643713263168, -79.5505599975586, -1.38841919376269, 218, 45, 'PPL', 'P'),
(195965, 'Bell Ranch Colony', 47.1297187805176, 0.822568768259038, -108.915283203125, -1.90093029763661, 218, 31, 'PPL', 'P'),
(26481, 'Bell Ridge', 39.5077781677246, 0.689540809174327, -87.7647171020508, -1.53178328051216, 218, 18, 'PPL', 'P'),
(77840, 'Bell Road (historical)', 39.9066696166992, 0.696502778316985, -75.2341690063477, -1.31308395916264, 218, 45, 'PPL', 'P'),
(122211, 'Bell Rohr Park', 41.3316688537598, 0.721373706842099, -85.7811126708984, -1.4971628521314, 218, 19, 'PPL', 'P'),
(84947, 'Bell Spring', 35.5469398498535, 0.620411139388323, -84.4877777099609, -1.47458989873189, 218, 50, 'PPL', 'P'),
(235, 'Bell Springs', 34.3172187805176, 0.598948457847265, -86.915283203125, -1.51695786219785, 218, 2, 'PPL', 'P'),
(180013, 'Bell Springs', 39.9519386291504, 0.697292871633384, -123.584167480469, -2.15695062587028, 218, 6, 'PPL', 'P'),
(237, 'Bell Station', 32.3300018310547, 0.5642649791277, -86.1938934326172, -1.50436723551229, 218, 2, 'PPL', 'P'),
(62839, 'Bell Swamp', 34.1330604553223, 0.595734288727648, -78.0963897705078, -1.36303913541618, 218, 33, 'PPL', 'P'),
(79727, 'Bell Town', 34.6319389343262, 0.604441360753608, -80.8469390869141, -1.41104527722595, 218, 48, 'PPL', 'P'),
(84934, 'Bell Town', 36.1127815246582, 0.630286939658663, -87.1580581665039, -1.52119508465023, 218, 50, 'PPL', 'P'),
(19163, 'Bell View (historical)', 30.9472198486328, 0.540130880697184, -81.5250015258789, -1.42287969931999, 218, 13, 'PPL', 'P'),
(239, 'Bell-Merrill', 31.2122192382813, 0.544755992562324, -85.4116668701172, -1.4907148065001, 218, 2, 'PPL', 'P'),
(84935, 'Bella Mara Estates', 35.7625007629395, 0.624173387060278, -84.7052764892578, -1.47838596854969, 218, 50, 'PPL', 'P'),
(53401, 'Bella Villa', 38.5411109924316, 0.672669284194511, -90.2799987792969, -1.57568322739519, 218, 29, 'PPL', 'P'),
(7380, 'Bella Vista', 36.4813919067383, 0.636720404482995, -94.273063659668, -1.64537535680342, 218, 4, 'PPL', 'P'),
(13354, 'Bella Vista', 39.7652816772461, 0.694035093250917, -75.6819381713867, -1.32089900538147, 218, 10, 'PPL', 'P'),
(99766, 'Bella Vista', 37.1066703796387, 0.647633572576949, -80.7869415283203, -1.40999812228533, 218, 53, 'PPL', 'P'),
(159069, 'Bella Vista', 41.2477798461914, 0.7199095674538, -76.8802795410156, -1.34181400784436, 218, 45, 'PPL', 'P'),
(193372, 'Bella Vista', 40.6408309936523, 0.709316311585792, -122.231391906738, -2.13334023806813, 218, 6, 'PPL', 'P'),
(84936, 'Bella Vista Acres', 35.024169921875, 0.611287082914684, -85.1611099243164, -1.48634176283214, 218, 50, 'PPL', 'P'),
(92540, 'Bella Vista Colonia', 26.3799991607666, 0.460417842028718, -98.8430023193359, -1.7251358330288, 218, 51, 'PPL', 'P'),
(92541, 'Bella Vista Estates Colonia', 26.2749996185303, 0.458585254303607, -98.3219985961914, -1.71604260264478, 218, 51, 'PPL', 'P'),
(180014, 'Bella Vista Park', 39.2444381713867, 0.684944659186041, -121.04972076416, -2.11271618595434, 218, 6, 'PPL', 'P'),
(7381, 'Bellair', 33.9000015258789, 0.591666643057689, -93.7738876342773, -1.63666309161334, 218, 4, 'PPL', 'P'),
(15170, 'Bellair', 30.1741695404053, 0.526638607535056, -81.7408294677734, -1.42664660752385, 218, 12, 'PPL', 'P'),
(26482, 'Bellair', 39.1419410705566, 0.683155747302807, -87.9452819824219, -1.53493473218811, 218, 18, 'PPL', 'P'),
(53402, 'Bellair', 38.8330612182617, 0.677764776887187, -92.8441696166992, -1.62043645109148, 218, 29, 'PPL', 'P'),
(62840, 'Bellair', 35.1652793884277, 0.613749907711762, -77.1213912963867, -1.34602220184085, 218, 33, 'PPL', 'P'),
(99767, 'Bellair', 38.0391693115234, 0.663908749209669, -78.5311126708984, -1.37062648136182, 218, 53, 'PPL', 'P'),
(114549, 'Bellair (historical)', 40.6916694641113, 0.710203610281979, -92.9791717529297, -1.62279268286593, 218, 16, 'PPL', 'P'),
(7382, 'Bellaire', 33.5041694641113, 0.584758070294887, -91.3591690063477, -1.59451830104672, 218, 4, 'PPL', 'P'),
(31775, 'Bellaire', 39.7983283996582, 0.694611867364001, -98.6758270263672, -1.72221807373851, 218, 20, 'PPL', 'P'),
(92542, 'Bellaire', 29.7055606842041, 0.518459840090341, -95.458610534668, -1.6660670532089, 218, 51, 'PPL', 'P'),
(129749, 'Bellaire', 44.980281829834, 0.785054016405583, -85.2111129760742, -1.48721448072136, 218, 27, 'PPL', 'P'),
(134179, 'Bellaire', 45.0697212219238, 0.786615028278533, -92.9944381713867, -1.62305913213299, 218, 28, 'PPL', 'P'),
(147114, 'Bellaire', 40.7138900756836, 0.710591433115722, -73.7544403076172, -1.28725782133354, 218, 40, 'PPL', 'P'),
(154249, 'Bellaire', 40.0161094665527, 0.698412864029817, -80.7425003051758, -1.40922247661784, 218, 41, 'PPL', 'P'),
(159070, 'Bellaire', 40.1913909912109, 0.701472103753018, -76.5752792358398, -1.33649074829945, 218, 45, 'PPL', 'P'),
(92543, 'Bellaire Colonia', 26.1280002593994, 0.456019631488452, -98.0090026855469, -1.71057979345876, 218, 51, 'PPL', 'P'),
(154250, 'Bellaire Gardens', 40.6202812194824, 0.708957650365986, -83.1322174072266, -1.45093090823985, 218, 41, 'PPL', 'P'),
(92544, 'Bellaire Junction', 29.7269401550293, 0.518832982248575, -95.4475021362305, -1.66587317508154, 218, 51, 'PPL', 'P'),
(92545, 'Bellaire West', 29.6963901519775, 0.518299784108827, -95.5749969482422, -1.66809837933036, 218, 51, 'PPL', 'P'),
(240, 'Bellamy', 32.4488906860352, 0.566339981091035, -88.1336135864258, -1.53822173876354, 218, 2, 'PPL', 'P'),
(53403, 'Bellamy', 37.685001373291, 0.657727352582513, -94.1802825927734, -1.6437560217026, 218, 29, 'PPL', 'P'),
(62841, 'Bellamy', 34.5855598449707, 0.603631892940278, -78.8877792358398, -1.37685148725182, 218, 33, 'PPL', 'P'),
(99769, 'Bellamy', 36.660831451416, 0.639852215345901, -82.6758270263672, -1.44296539341942, 218, 53, 'PPL', 'P'),
(39318, 'Bellamy (historical)', 30.9158306121826, 0.539583035171441, -89.8241729736328, -1.5677275662708, 218, 22, 'PPL', 'P'),
(84937, 'Bellamy (historical)', 36.4877815246582, 0.636831924353642, -87.5780563354492, -1.52852543555067, 218, 50, 'PPL', 'P'),
(200397, 'Bellamy (historical)', 44.6958312988281, 0.780089418080484, -123.945831298828, -2.16326285028599, 218, 43, 'PPL', 'P'),
(99772, 'Bellamytown', 36.603328704834, 0.638848603089105, -82.7624969482422, -1.44447806891859, 218, 53, 'PPL', 'P'),
(99770, 'Bellany Manor', 36.8113899230957, 0.642479956393482, -76.1577835083008, -1.32920407324089, 218, 53, 'PPL', 'P'),
(159084, 'Bellasylva', 41.4569396972656, 0.723560095518026, -76.2391662597656, -1.33062447020828, 218, 45, 'PPL', 'P'),
(71790, 'Bellbrook', 39.6355590820313, 0.691771006850187, -84.0708312988281, -1.46731281105325, 218, 41, 'PPL', 'P'),
(108155, 'Bellburn', 38.0416717529297, 0.663952425051546, -80.7333297729492, -1.40906242063633, 218, 58, 'PPL', 'P'),
(44712, 'Bellcar', 38.607780456543, 0.673832885853794, -76.5138931274414, -1.33541935859291, 218, 25, 'PPL', 'P'),
(191125, 'Bellco', 35.3805618286133, 0.617507295114727, -100.508888244629, -1.7542110273878, 218, 51, 'PPL', 'P'),
(34754, 'Bellcraft', 37.1352806091309, 0.648132915281339, -82.8252792358398, -1.4455738265491, 218, 21, 'PPL', 'P'),
(70527, 'Bellcrest Park', 39.9749984741211, 0.697695341853122, -74.1374969482422, -1.29394342093407, 218, 37, 'PPL', 'P'),
(53404, 'Belle', 38.285831451416, 0.668213815690809, -91.7202835083008, -1.6008209380825, 218, 29, 'PPL', 'P'),
(108156, 'Belle', 38.2319412231445, 0.66727325377282, -81.5377807617188, -1.42310273906128, 218, 58, 'PPL', 'P'),
(108157, 'Belle Acres', 38.4527816772461, 0.671127646818492, -81.897216796875, -1.42937608132507, 218, 58, 'PPL', 'P'),
(99771, 'Belle Aire', 37.2569389343262, 0.650256253618459, -80.022216796875, -1.39665115785018, 218, 53, 'PPL', 'P'),
(39319, 'Belle Alliance', 30.0511093139648, 0.524490801405421, -91.0202789306641, -1.58860355342371, 218, 22, 'PPL', 'P'),
(39320, 'Belle Amie', 29.4938907623291, 0.514765503026183, -90.3277816772461, -1.57651719629055, 218, 22, 'PPL', 'P'),
(29186, 'Belle Arbor', 39.7202796936035, 0.693249660466426, -85.9875030517578, -1.50076504382185, 218, 19, 'PPL', 'P'),
(147115, 'Belle Ayr', 42.0719413757324, 0.734293899712564, -74.6097183227539, -1.3021852387176, 218, 40, 'PPL', 'P'),
(39323, 'Belle Bower', 32.1111106872559, 0.560444607964954, -94.0283279418945, -1.64110391273104, 218, 22, 'PPL', 'P'),
(159071, 'Belle Bridge', 40.3005599975586, 0.703377462354915, -79.8658294677734, -1.39392168404896, 218, 45, 'PPL', 'P'),
(53405, 'Belle Center', 37.1011085510254, 0.647536500355216, -94.5824966430664, -1.65077598117799, 218, 29, 'PPL', 'P'),
(154251, 'Belle Center', 40.5066719055176, 0.706974793776367, -83.7480621337891, -1.46167942639941, 218, 41, 'PPL', 'P'),
(39321, 'Belle Chaney (historical)', 30.8877792358398, 0.539093446294543, -92.4194412231445, -1.61302354219725, 218, 22, 'PPL', 'P'),
(39322, 'Belle Chasse', 29.8547191619873, 0.521063146634921, -89.9905624389648, -1.57063161028148, 218, 22, 'PPL', 'P'),
(71786, 'Belle Court', 38.4569396972656, 0.671200217958197, -82.3475036621094, -1.4372350697019, 218, 41, 'PPL', 'P'),
(134180, 'Belle Creek', 44.4383316040039, 0.775595200582921, -92.7705612182617, -1.61915174218163, 218, 28, 'PPL', 'P'),
(195966, 'Belle Creek', 45.1391716003418, 0.787827166048682, -105.110282897949, -1.8345205142719, 218, 31, 'PPL', 'P'),
(39332, 'Belle d''Eau', 31.0841693878174, 0.542521101065043, -92.1916732788086, -1.60904824163809, 218, 22, 'PPL', 'P'),
(84940, 'Belle Eagle', 35.6852798461914, 0.622825627811616, -89.2297210693359, -1.55735242329607, 218, 50, 'PPL', 'P'),
(252, 'Belle Ellen', 33.124439239502, 0.578130527606116, -87.0572204589844, -1.51943513464385, 218, 2, 'PPL', 'P'),
(44713, 'Belle Farm Estates', 39.3722190856934, 0.687174856861901, -76.7569427490234, -1.33966137473525, 218, 25, 'PPL', 'P'),
(44714, 'Belle Farm Heritage', 39.6824989318848, 0.692590261780522, -76.3869400024414, -1.33320360856597, 218, 25, 'PPL', 'P'),
(173130, 'Belle Fountain', 43.6144409179688, 0.761215595435093, -89.2633285522461, -1.55793898452616, 218, 57, 'PPL', 'P'),
(201895, 'Belle Fourche', 44.6713905334473, 0.779662846252881, -103.851669311523, -1.81255356317844, 218, 49, 'PPL', 'P'),
(15171, 'Belle Glade', 26.6841697692871, 0.465726620635196, -80.6677780151367, -1.40791832663203, 218, 12, 'PPL', 'P'),
(15172, 'Belle Glade Camp', 26.6572208404541, 0.465256273097174, -80.6830596923828, -1.4081850422152, 218, 12, 'PPL', 'P'),
(19164, 'Belle Grove', 33.3958282470703, 0.582867159341903, -84.561393737793, -1.4758747407998, 218, 13, 'PPL', 'P'),
(147116, 'Belle Harbor', 40.5758285522461, 0.708181804961418, -73.8486099243164, -1.28890139120028, 218, 40, 'PPL', 'P'),
(245, 'Belle Haven', 33.4608306884766, 0.584001665966277, -86.8886108398438, -1.51649234163931, 218, 2, 'PPL', 'P'),
(99775, 'Belle Haven', 37.3511085510254, 0.651899823485201, -79.977783203125, -1.39587564534075, 218, 53, 'PPL', 'P'),
(134182, 'Belle Haven', 44.1655616760254, 0.770834467239268, -93.9611129760742, -1.63993079027086, 218, 28, 'PPL', 'P'),
(177510, 'Belle Haven', 41.0088882446289, 0.715740122451172, -73.6319427490234, -1.28511983561042, 218, 8, 'PPL', 'P'),
(180016, 'Belle Haven', 37.476390838623, 0.654086411898211, -122.158332824707, -2.1320651165382, 218, 6, 'PPL', 'P'),
(39324, 'Belle Helene', 30.1694393157959, 0.526556049541264, -90.9983291625977, -1.5882204577009, 218, 22, 'PPL', 'P'),
(15173, 'Belle Isle', 28.4580593109131, 0.496686833703262, -81.3594436645508, -1.41999016953725, 218, 12, 'PPL', 'P'),
(79728, 'Belle Isle Estates', 33.2999992370605, 0.581194627598306, -79.3005599975586, -1.3840558706327, 218, 48, 'PPL', 'P'),
(79729, 'Belle Isle Gardens', 33.3033294677734, 0.581252751089097, -79.2994384765625, -1.38403629639869, 218, 48, 'PPL', 'P'),
(144811, 'Belle Mead', 40.4666709899902, 0.706276646096603, -74.6611099243164, -1.30308219137274, 218, 37, 'PPL', 'P'),
(7383, 'Belle Meade', 34.9294395446777, 0.609633725930935, -90.434440612793, -1.57837874589252, 218, 4, 'PPL', 'P'),
(15174, 'Belle Meade', 26.0494403839111, 0.454648503001225, -81.6997222900391, -1.42592915192618, 218, 12, 'PPL', 'P'),
(39325, 'Belle Meade', 32.5611114501953, 0.568298602914734, -92.0197219848633, -1.60604712540568, 218, 22, 'PPL', 'P'),
(44717, 'Belle Meade', 39.5275001525879, 0.68988502274522, -76.415283203125, -1.33369829073845, 218, 25, 'PPL', 'P'),
(79732, 'Belle Meade', 34.8888893127441, 0.608925990871247, -81.0277786254883, -1.41420152259186, 218, 48, 'PPL', 'P'),
(84946, 'Belle Meade', 35.2186088562012, 0.614680682512745, -88.2263870239258, -1.53984094070631, 218, 50, 'PPL', 'P'),
(99778, 'Belle Meade', 37.2197189331055, 0.649606642049562, -80.0105590820313, -1.3964476923429, 218, 53, 'PPL', 'P'),
(203002, 'Belle Meadows', 40.6419410705566, 0.709335686082722, -111.860000610352, -1.9523253119335, 218, 52, 'PPL', 'P'),
(246, 'Belle Mina', 34.6566696166992, 0.604872992587283, -86.8791732788086, -1.51632762512589, 218, 2, 'PPL', 'P'),
(180017, 'Belle Monte', 37.5191688537598, 0.654833029109815, -122.295829772949, -2.13446489099647, 218, 6, 'PPL', 'P'),
(200398, 'Belle Passi (historical)', 45.1236114501953, 0.787555590196521, -122.85417175293, -2.14420979689924, 218, 43, 'PPL', 'P'),
(39326, 'Belle Place', 30.0155601501465, 0.52387035145046, -91.7266693115234, -1.60093239137412, 218, 22, 'PPL', 'P'),
(92557, 'Belle Plain', 32.3108291625977, 0.563930352936731, -99.3605575561523, -1.73416887597219, 218, 51, 'PPL', 'P'),
(31776, 'Belle Plaine', 37.3938903808594, 0.652646507275833, -97.2808303833008, -1.69787078926274, 218, 20, 'PPL', 'P'),
(114551, 'Belle Plaine', 41.8969383239746, 0.731239520258352, -92.2780609130859, -1.61055599028923, 218, 16, 'PPL', 'P'),
(134183, 'Belle Plaine', 44.6227798461914, 0.778814429708609, -93.7683334350586, -1.63656615254966, 218, 28, 'PPL', 'P'),
(173131, 'Belle Plaine', 44.7152786254883, 0.780428837961415, -88.6661071777344, -1.54751550517764, 218, 57, 'PPL', 'P'),
(34755, 'Belle Point', 37.5625, 0.65558930028037, -83.7480621337891, -1.46167942639941, 218, 21, 'PPL', 'P'),
(39327, 'Belle Point', 30.0616703033447, 0.524675125442368, -90.5352783203125, -1.58013869589889, 218, 22, 'PPL', 'P'),
(19170, 'Belle Point Estates', 31.2222194671631, 0.544930529482265, -81.4563903808594, -1.42168220893583, 218, 13, 'PPL', 'P'),
(44718, 'Belle Point Farm', 38.9425010681152, 0.679674862600019, -76.1677780151367, -1.32937851029229, 218, 25, 'PPL', 'P'),
(58608, 'Belle Prairie', 32.9949989318848, 0.575871368053401, -90.3811111450195, -1.57744797109153, 218, 30, 'PPL', 'P'),
(134186, 'Belle Prairie', 46.0338897705078, 0.803442943995498, -94.3372192382813, -1.64649508288374, 218, 28, 'PPL', 'P'),
(26483, 'Belle Prairie City', 38.2224998474121, 0.667108470680371, -88.5552825927734, -1.54558125127792, 218, 18, 'PPL', 'P'),
(44719, 'Belle Ridge Farms', 38.503059387207, 0.672005158397673, -76.8208312988281, -1.34077644028366, 218, 25, 'PPL', 'P'),
(26484, 'Belle Rive', 38.232780456543, 0.667287901158816, -88.7405624389648, -1.54881499463155, 218, 18, 'PPL', 'P'),
(99781, 'Belle Rive', 38.7000007629395, 0.675442433837611, -77.0999984741211, -1.34564882665602, 218, 53, 'PPL', 'P'),
(39328, 'Belle River', 29.8877792358398, 0.5216401537746, -91.2063903808594, -1.59185181100528, 218, 22, 'PPL', 'P'),
(129750, 'Belle River', 42.8236083984375, 0.74741296413743, -82.7002792358398, -1.44339216498411, 218, 27, 'PPL', 'P'),
(134188, 'Belle River', 45.9911117553711, 0.802696326783894, -95.2286071777344, -1.66205273733977, 218, 28, 'PPL', 'P'),
(39329, 'Belle Rose', 30.0502796173096, 0.524476320466994, -91.041389465332, -1.58897200176052, 218, 22, 'PPL', 'P'),
(39331, 'Belle Terre', 30.0916690826416, 0.525198702912678, -90.4938888549805, -1.57941631345321, 218, 22, 'PPL', 'P'),
(147117, 'Belle Terre', 40.9597206115723, 0.714881985368921, -73.0683288574219, -1.275282917492, 218, 40, 'PPL', 'P'),
(79734, 'Belle Terre Acres', 34.7244415283203, 0.606055835585441, -82.4169387817383, -1.43844694115594, 218, 48, 'PPL', 'P'),
(29187, 'Belle Union', 39.5730590820313, 0.69068017606769, -86.7061080932617, -1.51330706781752, 218, 19, 'PPL', 'P'),
(71787, 'Belle Valley', 39.7905616760254, 0.694476312464516, -81.5563888549805, -1.42342751155622, 218, 41, 'PPL', 'P'),
(159072, 'Belle Valley', 42.1041717529297, 0.734856425913816, -80.0216674804688, -1.39664157047025, 218, 45, 'PPL', 'P'),
(154252, 'Belle Vernon', 40.9263916015625, 0.714300284407821, -83.2019424438477, -1.45214783969996, 218, 41, 'PPL', 'P'),
(159073, 'Belle Vernon', 40.125, 0.700313362362725, -79.8666687011719, -1.39393633143495, 218, 45, 'PPL', 'P'),
(99782, 'Belle View', 38.7724990844727, 0.676707768250535, -77.0577774047852, -1.34491192998239, 218, 53, 'PPL', 'P'),
(250, 'Belle Vista', 33.3763885498047, 0.582527872619027, -86.3269424438477, -1.50668937882478, 218, 2, 'PPL', 'P'),
(19165, 'Belle Vista', 31.3575000762939, 0.547291621525702, -81.7375030517578, -1.42658855061209, 218, 13, 'PPL', 'P'),
(15175, 'Belle Vista Beach (historical)', 27.7183303833008, 0.48377612834418, -82.7380599975586, -1.44405156367001, 218, 12, 'PPL', 'P'),
(84950, 'Belle-Aire', 35.8699989318848, 0.626049584048238, -84.1655578613281, -1.46896610145797, 218, 50, 'PPL', 'P'),
(195967, 'Belle-Vue Court', 47.6925010681152, 0.832391172149523, -114.140556335449, -1.99212851811166, 218, 31, 'PPL', 'P'),
(15176, 'Belleair', 27.9355602264404, 0.487567504340558, -82.8063888549805, -1.44524412720615, 218, 12, 'PPL', 'P'),
(99783, 'Belleair', 38.7755584716797, 0.676761164630391, -77.2977828979492, -1.34910081606098, 218, 53, 'PPL', 'P'),
(15177, 'Belleair Beach', 27.922779083252, 0.48734443130975, -82.8433303833008, -1.44588887850605, 218, 12, 'PPL', 'P'),
(15178, 'Belleair Bluffs', 27.9211101531982, 0.487315302985328, -82.8172225952148, -1.44543321164354, 218, 12, 'PPL', 'P'),
(44720, 'Belleair Estates', 38.7466697692871, 0.676256961657012, -76.9686126708984, -1.3433557117994, 218, 25, 'PPL', 'P'),
(15179, 'Belleair Shores', 27.916389465332, 0.487232911439103, -82.8455581665039, -1.44592776065797, 218, 12, 'PPL', 'P'),
(134190, 'Bellechester', 44.3683280944824, 0.77437340885382, -92.5111083984375, -1.61462343622211, 218, 28, 'PPL', 'P'),
(159075, 'Bellefield', 40.4472198486328, 0.705937159636645, -79.942497253418, -1.39525978933867, 218, 45, 'PPL', 'P'),
(31778, 'Bellefont', 37.872501373291, 0.660999844930002, -99.6575012207031, -1.73935152061154, 218, 20, 'PPL', 'P'),
(251, 'Bellefontaine', 30.4933300018311, 0.53220900842912, -88.1036071777344, -1.53769802813517, 218, 2, 'PPL', 'P'),
(53419, 'Bellefontaine', 38.6569404602051, 0.674690889777991, -90.554443359375, -1.58047318893181, 218, 29, 'PPL', 'P'),
(58610, 'Bellefontaine', 33.648609161377, 0.587279018582756, -89.3099975585938, -1.55875351234556, 218, 30, 'PPL', 'P'),
(154253, 'Bellefontaine', 40.3611106872559, 0.704434271254486, -83.7597198486328, -1.46188289190669, 218, 41, 'PPL', 'P'),
(53407, 'Bellefontaine Neighbors', 38.7402801513672, 0.676145441786365, -90.2263870239258, -1.57474752574619, 218, 29, 'PPL', 'P'),
(253, 'Bellefonte', 34.711109161377, 0.605823141885196, -85.9452819824219, -1.50002814714822, 218, 2, 'PPL', 'P'),
(7385, 'Bellefonte', 36.2008285522461, 0.631823650186666, -93.0483322143555, -1.62399976063001, 218, 4, 'PPL', 'P'),
(13355, 'Bellefonte', 39.7661094665527, 0.694049540899831, -75.5097198486328, -1.31789322861716, 218, 10, 'PPL', 'P'),
(34756, 'Bellefonte', 38.4925003051758, 0.67182086765024, -82.6902770996094, -1.44321759477465, 218, 21, 'PPL', 'P'),
(159076, 'Bellefonte', 40.913330078125, 0.71407231781851, -77.7786102294922, -1.35749283612998, 218, 45, 'PPL', 'P'),
(169277, 'Bellefonte', 41.7686080932617, 0.728999735202568, -71.4100036621094, -1.24633968276502, 218, 47, 'PPL', 'P'),
(114553, 'Bellefountain', 41.2802810668945, 0.720476820765987, -92.8613891601563, -1.6207369888205, 218, 16, 'PPL', 'P'),
(84951, 'Bellefounte', 35.2455596923828, 0.61515106334028, -84.795280456543, -1.47995683411868, 218, 50, 'PPL', 'P'),
(44721, 'Bellegrove', 39.7066688537598, 0.693012106497191, -78.3383331298828, -1.36726184364061, 218, 25, 'PPL', 'P'),
(159078, 'Bellegrove', 40.3669395446777, 0.704536004008127, -76.5491714477539, -1.33603508143694, 218, 45, 'PPL', 'P'),
(189927, 'Bellehelen (historical)', 38.0683288574219, 0.664417679293983, -116.464996337891, -2.03269764941933, 218, 39, 'PPL', 'P'),
(19166, 'Bellemead', 33.4455604553223, 0.583735150120187, -82.0599975585938, -1.43221714157597, 218, 13, 'PPL', 'P'),
(44722, 'Bellemead', 38.9419403076172, 0.679665075483013, -76.8863906860352, -1.34192066744602, 218, 25, 'PPL', 'P'),
(256, 'Bellemeade', 34.8477783203125, 0.608208468694552, -87.5950012207031, -1.52882117958972, 218, 2, 'PPL', 'P'),
(34757, 'Bellemeade', 38.2522201538086, 0.667627187881692, -85.5922164916992, -1.49386599185994, 218, 21, 'PPL', 'P'),
(62843, 'Bellemeade', 35.7000007629395, 0.623082556277781, -80.4533309936523, -1.40417552003603, 218, 33, 'PPL', 'P'),
(44723, 'Bellemere Estates', 39.6291694641113, 0.69165948697954, -77.3886108398438, -1.35068606269985, 218, 25, 'PPL', 'P'),
(62844, 'Bellemont', 36.0255584716797, 0.628764610200547, -79.4433288574219, -1.38654765730664, 218, 33, 'PPL', 'P'),
(75099, 'Bellemont', 35.4630584716797, 0.618947133158079, -96.7708282470703, -1.68896957279331, 218, 42, 'PPL', 'P'),
(77842, 'Bellemont', 39.9947204589844, 0.698039555424015, -76.1016693115234, -1.32822469575001, 218, 45, 'PPL', 'P'),
(193115, 'Bellemont', 35.2380599975586, 0.615020168972703, -111.832778930664, -1.95185020399503, 218, 5, 'PPL', 'P'),
(44724, 'Bellemonte', 39.3972206115723, 0.68761121580651, -77.5972213745117, -1.35432700338415, 218, 25, 'PPL', 'P'),
(70528, 'Belleplain', 39.2686080932617, 0.685366503902709, -74.866943359375, -1.3066746625252, 218, 37, 'PPL', 'P'),
(108158, 'Bellepoint', 37.649169921875, 0.657101975779535, -80.8819427490234, -1.41165620638001, 218, 58, 'PPL', 'P'),
(154254, 'Bellepoint', 40.2458305358887, 0.702422253050931, -83.1516723632813, -1.45127046127883, 218, 41, 'PPL', 'P'),
(53408, 'Bellerive', 38.7113914489746, 0.675641238812985, -90.3138885498047, -1.5762747154733, 218, 29, 'PPL', 'P'),
(44725, 'Bellerive Village', 39.0424995422363, 0.681420165220403, -76.4722213745117, -1.33469204929921, 218, 25, 'PPL', 'P'),
(147118, 'Bellerose', 40.7241706848145, 0.710770863594166, -73.7155609130859, -1.28657924788779, 218, 40, 'PPL', 'P'),
(147119, 'Bellerose Terrace', 40.7205581665039, 0.710707813255358, -73.7263870239258, -1.28676819916713, 218, 40, 'PPL', 'P'),
(154255, 'Belleve', 40.2422218322754, 0.702359269291151, -80.8952789306641, -1.41188896665929, 218, 41, 'PPL', 'P'),
(15180, 'Belleview', 29.0550003051758, 0.507105419493275, -82.0625, -1.43226081741785, 218, 12, 'PPL', 'P'),
(19167, 'Belleview', 32.7719383239746, 0.571978226013869, -84.5577774047852, -1.47581162388197, 218, 13, 'PPL', 'P'),
(26485, 'Belleview', 39.350830078125, 0.686801548256099, -90.7811126708984, -1.58442931473112, 218, 18, 'PPL', 'P'),
(29188, 'Belleview', 38.8558311462402, 0.678162187100854, -85.378059387207, -1.49012824527001, 218, 19, 'PPL', 'P'),
(34758, 'Belleview', 38.9861106872559, 0.680435994039564, -84.8255615234375, -1.480485338437, 218, 21, 'PPL', 'P'),
(53409, 'Belleview', 37.6875, 0.657770961845363, -90.7402801513672, -1.58371665282342, 218, 29, 'PPL', 'P'),
(84969, 'Belleview', 36.1341705322266, 0.630660248264465, -87.3261108398438, -1.52412815711678, 218, 50, 'PPL', 'P'),
(99785, 'Belleview', 37.4838905334473, 0.654217306265788, -76.7347183227539, -1.33927348532248, 218, 53, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(147120, 'Belleview', 42.1291694641113, 0.735292718279398, -79.3388900756836, -1.38472485669853, 218, 40, 'PPL', 'P'),
(186401, 'Belleview', 38.5691719055176, 0.673159039518977, -106.036666870117, -1.85068896472394, 218, 7, 'PPL', 'P'),
(193373, 'Belleview', 40.5061111450195, 0.706965006659361, -124.119720458984, -2.16629778866424, 218, 6, 'PPL', 'P'),
(260, 'Belleview (historical)', 34.8111114501953, 0.607568511084606, -87.4097213745117, -1.52558743623609, 218, 2, 'PPL', 'P'),
(497, 'Belleview (historical)', 37.7963905334473, 0.659671460178271, -96.4538879394531, -1.68343792089311, 218, 20, 'PPL', 'P'),
(180019, 'Belleview Acres', 38.0158309936523, 0.663501418720941, -120.278060913086, -2.09924818084765, 218, 6, 'PPL', 'P'),
(44726, 'Belleview Estates', 39.0499992370605, 0.68155105958798, -76.5277786254883, -1.33566170625211, 218, 25, 'PPL', 'P'),
(84955, 'Belleview Estates', 35.2797203063965, 0.615747278529321, -84.5480575561523, -1.47564198052053, 218, 50, 'PPL', 'P'),
(15181, 'Belleview Heights', 29.0202808380127, 0.506499450476741, -82.0699996948242, -1.43239171178542, 218, 12, 'PPL', 'P'),
(71788, 'Belleview Heights', 39.3186111450195, 0.686239221791928, -83.0044403076172, -1.44870077714301, 218, 41, 'PPL', 'P'),
(159079, 'Belleview Heights', 42.0900001525879, 0.734609084827574, -80.0016708374023, -1.3962925632094, 218, 45, 'PPL', 'P'),
(263, 'Belleville', 31.4297199249268, 0.548552095669637, -87.1091690063477, -1.52034180783696, 218, 2, 'PPL', 'P'),
(7387, 'Belleville', 35.0930595397949, 0.612489433567827, -93.4483337402344, -1.6309811042696, 218, 4, 'PPL', 'P'),
(26515, 'Belleville', 38.5200004577637, 0.672300835857699, -89.98388671875, -1.57051509698378, 218, 18, 'PPL', 'P'),
(29189, 'Belleville', 39.6772193908691, 0.692498116406805, -86.4883270263672, -1.5095060711517, 218, 19, 'PPL', 'P'),
(31779, 'Belleville', 39.8244400024414, 0.695067600805541, -97.6322174072266, -1.70400364977903, 218, 20, 'PPL', 'P'),
(39334, 'Belleville', 31.1569404602051, 0.543791195878416, -92.0977783203125, -1.60740946546131, 218, 22, 'PPL', 'P'),
(53411, 'Belleville', 37.124439239502, 0.647943697685889, -94.5902786254883, -1.65091180239359, 218, 29, 'PPL', 'P'),
(58613, 'Belleville', 31.2122192382813, 0.544755992562324, -89.1263885498047, -1.55554893060587, 218, 30, 'PPL', 'P'),
(75100, 'Belleville', 33.9255599975586, 0.592112722540277, -97.543327331543, -1.702452225286, 218, 42, 'PPL', 'P'),
(84956, 'Belleville', 35.2727813720703, 0.61562617127875, -86.5538864135742, -1.51065029831406, 218, 50, 'PPL', 'P'),
(99786, 'Belleville', 36.8650016784668, 0.643415658042482, -76.4361114501953, -1.33406181222725, 218, 53, 'PPL', 'P'),
(108159, 'Belleville', 39.1241683959961, 0.682845555614841, -81.7355575561523, -1.42655459530819, 218, 58, 'PPL', 'P'),
(129751, 'Belleville', 42.204719543457, 0.736611315914123, -83.4852828979492, -1.45709306352813, 218, 27, 'PPL', 'P'),
(144812, 'Belleville', 40.7936096191406, 0.711982801627234, -74.1505584716797, -1.29417138752339, 218, 37, 'PPL', 'P'),
(147121, 'Belleville', 43.7833290100098, 0.76416324870862, -76.1197204589844, -1.32853974770697, 218, 40, 'PPL', 'P'),
(159080, 'Belleville', 40.6049995422363, 0.708690934782814, -77.725830078125, -1.35657164870892, 218, 45, 'PPL', 'P'),
(169278, 'Belleville', 41.5538902282715, 0.725252201495636, -71.4691696166992, -1.2473723234777, 218, 47, 'PPL', 'P'),
(173133, 'Belleville', 42.8597183227539, 0.748043201209397, -89.5380630493164, -1.56273400606885, 218, 57, 'PPL', 'P'),
(53412, 'Belleville (historical)', 38.500560760498, 0.671961549134823, -92.4572219848633, -1.61368294088315, 218, 29, 'PPL', 'P'),
(189929, 'Belleville (historical)', 38.2191696166992, 0.667050347189581, -118.178886413574, -2.06261067425726, 218, 39, 'PPL', 'P'),
(99792, 'Belleville Meadows', 36.8608283996582, 0.643342820586668, -76.4375, -1.33408604699317, 218, 53, 'PPL', 'P'),
(129752, 'Belleville North', 42.2227783203125, 0.736926501029134, -83.4819412231445, -1.45703474030025, 218, 27, 'PPL', 'P'),
(271, 'Bellevue', 34.0344390869141, 0.594013021136103, -86.0219421386719, -1.50136611927988, 218, 2, 'PPL', 'P'),
(13036, 'Bellevue', 38.8266716003418, 0.67765325701654, -77.0199966430664, -1.34425253129649, 218, 9, 'PPL', 'P'),
(13356, 'Bellevue', 39.7708282470703, 0.694131899156542, -75.48388671875, -1.31744235544461, 218, 10, 'PPL', 'P'),
(19169, 'Bellevue', 32.9302787780762, 0.574741788277044, -82.021110534668, -1.43153843497216, 218, 13, 'PPL', 'P'),
(34759, 'Bellevue', 39.1063919067383, 0.682535297347846, -84.478889465332, -1.4744347695984, 218, 21, 'PPL', 'P'),
(39337, 'Bellevue', 29.6183300018311, 0.51693737747417, -89.8902816772461, -1.56888138081308, 218, 22, 'PPL', 'P'),
(44727, 'Bellevue', 38.7033309936523, 0.675500557328402, -76.1847229003906, -1.32967425433134, 218, 25, 'PPL', 'P'),
(84958, 'Bellevue', 35.0888900756836, 0.612416662691041, -89.9647216796875, -1.57018060395087, 218, 50, 'PPL', 'P'),
(92546, 'Bellevue', 33.6363906860352, 0.587065765958468, -98.0136108398438, -1.71066022092368, 218, 51, 'PPL', 'P'),
(99788, 'Bellevue', 37.3597183227539, 0.652050092349709, -79.3722229003906, -1.38530662423866, 218, 53, 'PPL', 'P'),
(114554, 'Bellevue', 42.2586097717285, 0.737551877832112, -90.4227828979492, -1.57817528038523, 218, 16, 'PPL', 'P'),
(118766, 'Bellevue', 40.684440612793, 0.710077443025337, -89.6800003051758, -1.56521127851484, 218, 18, 'PPL', 'P'),
(124222, 'Bellevue', 42.2874984741211, 0.738056080805491, -71.1458282470703, -1.24172895196976, 218, 23, 'PPL', 'P'),
(129754, 'Bellevue', 42.4433288574219, 0.740775834068735, -85.0180587768555, -1.48384504931019, 218, 27, 'PPL', 'P'),
(141276, 'Bellevue', 41.1366691589355, 0.717970320127032, -95.8905563354492, -1.6736059296227, 218, 35, 'PPL', 'P'),
(147123, 'Bellevue', 42.7941703796387, 0.746899173784127, -73.9700012207031, -1.29102006900549, 218, 40, 'PPL', 'P'),
(154256, 'Bellevue', 41.273609161377, 0.720360374047323, -82.841667175293, -1.44585985005017, 218, 41, 'PPL', 'P'),
(159082, 'Bellevue', 40.1644401550293, 0.701001722925483, -80.2541732788086, -1.40069956218126, 218, 45, 'PPL', 'P'),
(173135, 'Bellevue', 44.4441719055176, 0.775697133073644, -87.9199981689453, -1.53449344639548, 218, 57, 'PPL', 'P'),
(180020, 'Bellevue', 38.4019393920898, 0.670240281543277, -122.712501525879, -2.14173718498515, 218, 6, 'PPL', 'P'),
(193116, 'Bellevue', 33.3319396972656, 0.581752093793487, -110.942779541016, -1.93631678430493, 218, 5, 'PPL', 'P'),
(194574, 'Bellevue', 43.4636116027832, 0.758583127276577, -114.259719848633, -1.99420831376496, 218, 17, 'PPL', 'P'),
(206806, 'Bellevue', 47.6105613708496, 0.830961054644151, -122.199440002441, -2.13278257213587, 218, 56, 'PPL', 'P'),
(209890, 'Bellevue', 45.1155586242676, 0.787415041869993, -123.315002441406, -2.15225280970739, 218, 43, 'PPL', 'P'),
(7388, 'Bellevue (historical)', 34.9316711425781, 0.609672674661878, -92.7013931274414, -1.6179445312595, 218, 4, 'PPL', 'P'),
(180021, 'Bellevue (historical)', 37.3611106872559, 0.652074393694656, -120.488891601563, -2.10292787052581, 218, 6, 'PPL', 'P'),
(44728, 'Bellevue Estates', 38.6622200012207, 0.674783035151707, -77.004997253418, -1.34399074256133, 218, 25, 'PPL', 'P'),
(99789, 'Bellevue Forest', 38.9141693115234, 0.679180380164619, -77.1138916015625, -1.34589130747327, 218, 53, 'PPL', 'P'),
(180022, 'Bellevue Heights', 34.5702781677246, 0.603365177357107, -117.279716491699, -2.04691719858564, 218, 6, 'PPL', 'P'),
(195968, 'Bellevue Manor Trailer Park', 48.4075012207031, 0.844870278964444, -115.593063354492, -2.01747954800229, 218, 31, 'PPL', 'P'),
(99790, 'Bellevue Park', 37.3005599975586, 0.651017584795086, -80.0261077880859, -1.39671906845798, 218, 53, 'PPL', 'P'),
(58614, 'Bellevule', 32.5730590820313, 0.568507128428087, -91.033332824707, -1.58883138685497, 218, 30, 'PPL', 'P'),
(13358, 'Bellewood', 39.7916717529297, 0.694495686961447, -75.5299987792969, -1.31824716272603, 218, 10, 'PPL', 'P'),
(34760, 'Bellewood', 38.2574996948242, 0.667719333255408, -85.6597213745117, -1.49504417432619, 218, 21, 'PPL', 'P'),
(39338, 'Bellewood', 29.9066696166992, 0.521969853117552, -91.0680618286133, -1.58943752231907, 218, 22, 'PPL', 'P'),
(44730, 'Bellewood', 38.6124992370605, 0.673915244110505, -76.8536071777344, -1.34134848728581, 218, 25, 'PPL', 'P'),
(58615, 'Bellewood', 33.2316703796387, 0.580002064062169, -90.5591735839844, -1.5805557469256, 218, 30, 'PPL', 'P'),
(79737, 'Bellfield (historical)', 34.2900009155273, 0.598473416487822, -80.8008270263672, -1.41024046994453, 218, 48, 'PPL', 'P'),
(53413, 'Bellflower', 39.0066719055176, 0.680794854996452, -91.3550033569336, -1.59444559674896, 218, 29, 'PPL', 'P'),
(118767, 'Bellflower', 40.3400001525879, 0.704065822917674, -88.5269393920898, -1.54508656910544, 218, 18, 'PPL', 'P'),
(180023, 'Bellflower', 33.8816719055176, 0.591346730831743, -118.116111755371, -2.0615150497848, 218, 6, 'PPL', 'P'),
(122212, 'Bellfountain', 40.4333305358887, 0.705694745398421, -84.8636093139648, -1.48114939765481, 218, 19, 'PPL', 'P'),
(200399, 'Bellfountain', 44.3638916015625, 0.774295977445126, -123.35417175293, -2.15293644315921, 218, 43, 'PPL', 'P'),
(194575, 'Bellgrove', 47.5338897705078, 0.829622882775413, -116.913887023926, -2.04053226987218, 218, 17, 'PPL', 'P'),
(173138, 'Bellinger', 45.0752792358398, 0.786712033921239, -90.8000030517578, -1.58475901407407, 218, 57, 'PPL', 'P'),
(79738, 'Bellingham', 34.7544403076172, 0.606579413055751, -82.246940612793, -1.43547991338548, 218, 48, 'PPL', 'P'),
(124223, 'Bellingham', 42.086669921875, 0.734550961336783, -71.4749984741211, -1.24747405623134, 218, 23, 'PPL', 'P'),
(134193, 'Bellingham', 45.1361083984375, 0.787773703089799, -96.2872161865234, -1.68052895003441, 218, 28, 'PPL', 'P'),
(206807, 'Bellingham', 48.7597198486328, 0.851017653708674, -122.486938476563, -2.13780036710374, 218, 56, 'PPL', 'P'),
(39340, 'Bellingrath', 30.5133304595947, 0.532558082269003, -90.9863891601563, -1.5880120653456, 218, 22, 'PPL', 'P'),
(39341, 'Bellingrath Hills', 30.5141696929932, 0.532572729654998, -90.9938888549805, -1.58814295971318, 218, 22, 'PPL', 'P'),
(70529, 'Bellmawr', 39.8675003051758, 0.695819144865162, -75.0950012207031, -1.31065502309043, 218, 37, 'PPL', 'P'),
(92547, 'Bellmead', 31.5938892364502, 0.551417390686453, -97.1086120605469, -1.69486501249842, 218, 51, 'PPL', 'P'),
(99791, 'Bellmeade', 37.3816719055176, 0.652433254651544, -77.4180603027344, -1.35120005279023, 218, 53, 'PPL', 'P'),
(108160, 'Bellmeade', 38.8805618286133, 0.678593818934529, -82.1275024414063, -1.43339532404222, 218, 58, 'PPL', 'P'),
(26488, 'Bellmont', 38.3844413757324, 0.669934883545273, -87.9113922119141, -1.53434324411, 218, 18, 'PPL', 'P'),
(147124, 'Bellmont Center', 44.8480606079102, 0.782746320742002, -74.1361083984375, -1.29391918616815, 218, 40, 'PPL', 'P'),
(29190, 'Bellmore', 39.7591705322266, 0.69392843364926, -87.1052780151367, -1.52027389722917, 218, 19, 'PPL', 'P'),
(147126, 'Bellmore', 40.6686096191406, 0.709801140062241, -73.5274963378906, -1.28329690184426, 218, 40, 'PPL', 'P'),
(147128, 'Bellona', 42.7569389343262, 0.746249362478147, -77.0149993896484, -1.34416531277079, 218, 40, 'PPL', 'P'),
(180024, 'Bellota', 38.0530586242676, 0.664151163447893, -121.01277923584, -2.11207143465443, 218, 6, 'PPL', 'P'),
(171732, 'Bellows Falls', 43.1333312988281, 0.752818648518073, -72.4444427490234, -1.26439405074299, 218, 55, 'PPL', 'P'),
(159085, 'Bellowsville', 40.6716690063477, 0.709854536442097, -80.3322219848633, -1.40206176907884, 218, 45, 'PPL', 'P'),
(147127, 'Bellport', 40.7569389343262, 0.711342777438261, -72.9397201538086, -1.27303827216722, 218, 40, 'PPL', 'P'),
(58616, 'Bells', 33.5419387817383, 0.585417269243709, -88.8841705322266, -1.55132142869147, 218, 30, 'PPL', 'P'),
(62846, 'Bells', 35.7513885498047, 0.623979442353893, -79.0086135864258, -1.37896044451906, 218, 33, 'PPL', 'P'),
(84959, 'Bells', 35.711109161377, 0.623276434405139, -89.0875015258789, -1.55487022400206, 218, 50, 'PPL', 'P'),
(92548, 'Bells', 33.610279083252, 0.586610032516928, -96.4105606079102, -1.68268171630158, 218, 51, 'PPL', 'P'),
(159086, 'Bells', 40.2547187805176, 0.702577382184428, -79.2622222900391, -1.38338675140882, 218, 45, 'PPL', 'P'),
(58617, 'Bells (historical)', 33.0625, 0.577049483940625, -88.5736083984375, -1.54590109692484, 218, 30, 'PPL', 'P'),
(71789, 'Bells (historical)', 39.6541709899902, 0.692095845924149, -82.956672668457, -1.44786707456377, 218, 41, 'PPL', 'P'),
(180025, 'Bells Bar (historical)', 39.8658294677734, 0.695789983251225, -120.750831604004, -2.10749958601109, 218, 6, 'PPL', 'P'),
(206808, 'Bells Beach', 48.0769386291504, 0.839100873357923, -122.467781066895, -2.13746600722888, 218, 56, 'PPL', 'P'),
(159087, 'Bells Camp', 41.9799995422363, 0.732689211997736, -78.5538864135742, -1.37102395815451, 218, 45, 'PPL', 'P'),
(144815, 'Bells Crossing', 40.7044410705566, 0.710426516865219, -74.9436111450195, -1.30801276781491, 218, 37, 'PPL', 'P'),
(99793, 'Bells Crossroad', 38.1580581665039, 0.665983751173004, -77.8241729736328, -1.35828805603148, 218, 53, 'PPL', 'P'),
(280, 'Bells Crossroads', 31.5224990844727, 0.550171397480946, -85.4508285522461, -1.49139830679387, 218, 2, 'PPL', 'P'),
(62868, 'Bells Crossroads', 35.6541709899902, 0.622282675844376, -80.8861083984375, -1.41172891067777, 218, 33, 'PPL', 'P'),
(79740, 'Bells Crossroads', 32.978889465332, 0.575590204821316, -80.8516693115234, -1.41112783521974, 218, 48, 'PPL', 'P'),
(99795, 'Bells Crossroads', 37.9622192382813, 0.662565717071942, -78.0819396972656, -1.36278693406095, 218, 53, 'PPL', 'P'),
(19171, 'Bells Ferry Place', 34.0786094665527, 0.594783939692654, -84.5805587768555, -1.47620923383272, 218, 13, 'PPL', 'P'),
(70531, 'Bells Lake', 39.7536087036133, 0.693831361427526, -75.0491714477539, -1.30985514265703, 218, 37, 'PPL', 'P'),
(159088, 'Bells Landing', 40.9169387817383, 0.714135301578291, -78.6497192382813, -1.37269655647713, 218, 45, 'PPL', 'P'),
(15182, 'Bells Mill', 30.6619396209717, 0.535151801433658, -85.5747222900391, -1.49356066044096, 218, 12, 'PPL', 'P'),
(44732, 'Bells Mill', 39.021110534668, 0.681046856614601, -77.1624984741211, -1.34673965743851, 218, 25, 'PPL', 'P'),
(84960, 'Bells Mill', 35.290828704834, 0.615941156656679, -85.8794403076172, -1.49887899313785, 218, 50, 'PPL', 'P'),
(99794, 'Bells Mill', 36.723331451416, 0.640943046128397, -76.2750015258789, -1.33124991359029, 218, 53, 'PPL', 'P'),
(159089, 'Bells Mills', 40.9527816772461, 0.71476087811835, -78.9230575561523, -1.37746721009585, 218, 45, 'PPL', 'P'),
(34761, 'Bells Run', 37.5950012207031, 0.656156553592557, -86.9283294677734, -1.51718556247106, 218, 21, 'PPL', 'P'),
(39342, 'Bells Store (historical)', 30.7611103057861, 0.536882656405128, -91.1741714477539, -1.59128948454111, 218, 22, 'PPL', 'P'),
(44733, 'Bells Trailer Park', 39.0955581665039, 0.682346212910451, -76.684440612793, -1.3383959737433, 218, 25, 'PPL', 'P'),
(99796, 'Bells Valley', 38.0275001525879, 0.663705083965305, -79.4488906860352, -1.38664472952837, 218, 53, 'PPL', 'P'),
(84961, 'Bellsburg', 36.2758293151855, 0.633132660441468, -87.1888885498047, -1.52173317634848, 218, 50, 'PPL', 'P'),
(84962, 'Bellshire', 36.2661094665527, 0.63296301708003, -86.7680587768555, -1.51438831122009, 218, 50, 'PPL', 'P'),
(19188, 'Bellton', 34.3833312988281, 0.600102338968569, -83.6624984741211, -1.46018605881815, 218, 13, 'PPL', 'P'),
(108161, 'Bellton', 39.7563896179199, 0.693879897538393, -80.5555572509766, -1.40595970480833, 218, 58, 'PPL', 'P'),
(159090, 'Bellton', 40.8300018310547, 0.712617965547218, -80.3069381713867, -1.40162048328621, 218, 45, 'PPL', 'P'),
(195969, 'Belltower', 45.6383285522461, 0.796539098343631, -104.376670837402, -1.82171656838302, 218, 31, 'PPL', 'P'),
(286, 'Belltown', 33.603328704834, 0.586488725529275, -85.6066665649414, -1.49411819321517, 218, 2, 'PPL', 'P'),
(13359, 'Belltown', 38.746940612793, 0.676261688767947, -75.1783294677734, -1.31210937536172, 218, 10, 'PPL', 'P'),
(26490, 'Belltown', 39.3824996948242, 0.687354287340345, -90.4077835083008, -1.57791349165008, 218, 18, 'PPL', 'P'),
(34762, 'Belltown', 37.5336112976074, 0.655085097306991, -85.3052825927734, -1.4888580505881, 218, 21, 'PPL', 'P'),
(44734, 'Belltown', 39.4269409179688, 0.68812993300783, -76.8052825927734, -1.34050506416858, 218, 25, 'PPL', 'P'),
(62849, 'Belltown', 36.2691688537598, 0.633016413459886, -78.6113891601563, -1.37202757041131, 218, 33, 'PPL', 'P'),
(84964, 'Belltown', 35.0047187805176, 0.610947596454726, -84.3563919067383, -1.47229678387528, 218, 50, 'PPL', 'P'),
(147134, 'Belltown', 42.6369400024414, 0.744154986017882, -76.5952835083008, -1.33683988871836, 218, 40, 'PPL', 'P'),
(159092, 'Belltown', 40.7127799987793, 0.710572058618792, -77.4169387817383, -1.35118047855622, 218, 45, 'PPL', 'P'),
(177488, 'Belltown', 41.0769386291504, 0.71692782571832, -73.529167175293, -1.2833260634582, 218, 8, 'PPL', 'P'),
(180026, 'Belltown', 34.0116691589355, 0.593615610922436, -117.382499694824, -2.04871110389592, 218, 6, 'PPL', 'P'),
(84965, 'Belltown Hill', 35.0250015258789, 0.611301597142625, -84.3322219848633, -1.47187493915861, 218, 50, 'PPL', 'P'),
(84966, 'Belltown Mill', 35.4249992370605, 0.618282874203186, -84.2547225952148, -1.47052231964096, 218, 50, 'PPL', 'P'),
(13363, 'Belltown Woods', 39.6111106872559, 0.691344301864529, -75.7233276367188, -1.32162138782716, 218, 10, 'PPL', 'P'),
(44735, 'Bellvale', 39.524169921875, 0.689826899254429, -76.4555587768555, -1.33440123210818, 218, 25, 'PPL', 'P'),
(147129, 'Bellvale', 41.2502784729004, 0.71995317671665, -74.3111114501953, -1.29697356562237, 218, 40, 'PPL', 'P'),
(180027, 'Bellvale', 37.311939239502, 0.651216190033378, -122.319999694824, -2.13488673571314, 218, 6, 'PPL', 'P'),
(289, 'Bellview', 31.8436107635498, 0.55577585354745, -87.3561096191406, -1.52465173458709, 218, 2, 'PPL', 'P'),
(15183, 'Bellview', 30.461389541626, 0.53165154223394, -87.3150024414063, -1.52393427898943, 218, 12, 'PPL', 'P'),
(19172, 'Bellview', 31.1572208404541, 0.543796089436919, -84.5994415283203, -1.47653880001761, 218, 13, 'PPL', 'P'),
(34763, 'Bellview', 38.3561096191406, 0.669440401109872, -85.1430587768555, -1.48602671087518, 218, 21, 'PPL', 'P'),
(44736, 'Bellview', 39.3444404602051, 0.686690028385452, -76.5397186279297, -1.33587009860741, 218, 25, 'PPL', 'P'),
(62850, 'Bellview', 34.9911117553711, 0.610710109064518, -84.0672225952148, -1.46724982729347, 218, 33, 'PPL', 'P'),
(84967, 'Bellview', 35.7461090087891, 0.623887296980176, -85.1777801513672, -1.48663271318123, 218, 50, 'PPL', 'P'),
(92549, 'Bellview', 32.7825012207031, 0.57216258334033, -95.6975021362305, -1.67023649821153, 218, 51, 'PPL', 'P'),
(108162, 'Bellview', 39.499439239502, 0.689395267420754, -80.1333312988281, -1.39859047175598, 218, 58, 'PPL', 'P'),
(144816, 'Bellview', 40.0208282470703, 0.698495222286528, -74.995002746582, -1.30890972047005, 218, 37, 'PPL', 'P'),
(188126, 'Bellview', 34.8211097717285, 0.607743014715034, -103.107223510742, -1.79956053285216, 218, 38, 'PPL', 'P'),
(77845, 'Bellview Acres', 39.9383316040039, 0.697055384243176, -76.6463928222656, -1.33773191452548, 218, 45, 'PPL', 'P'),
(79743, 'Bellview Acres', 35.0163917541504, 0.611151328278117, -81.8616714477539, -1.42875569794914, 218, 48, 'PPL', 'P'),
(147130, 'Bellview Beach', 40.7836112976074, 0.711808297996806, -72.7863922119141, -1.27036219474586, 218, 40, 'PPL', 'P'),
(99805, 'Bellview Gardens', 37.6680603027344, 0.657431675122487, -77.6600036621094, -1.35542276101466, 218, 53, 'PPL', 'P'),
(99799, 'Bellview Terrace', 37.2561111450195, 0.650241805969545, -79.9366683959961, -1.39515805658503, 218, 53, 'PPL', 'P'),
(7391, 'Bellville', 33.9386100769043, 0.592340489392506, -94.1747207641602, -1.64365894948087, 218, 4, 'PPL', 'P'),
(15184, 'Bellville', 30.5961093902588, 0.534002847160371, -83.2574996948242, -1.45311749665286, 218, 12, 'PPL', 'P'),
(19174, 'Bellville', 32.1522216796875, 0.561162130141649, -81.9744415283203, -1.43072390715276, 218, 13, 'PPL', 'P'),
(34764, 'Bellville', 37.3816719055176, 0.652433254651544, -87.7991714477539, -1.5323846222863, 218, 21, 'PPL', 'P'),
(53414, 'Bellville', 39.7744407653809, 0.694194949495349, -91.829719543457, -1.60273095721631, 218, 29, 'PPL', 'P'),
(92550, 'Bellville', 29.9500007629395, 0.522726124288107, -96.2569427490234, -1.68000057887414, 218, 51, 'PPL', 'P'),
(147131, 'Bellville', 42.3394393920898, 0.738962620840554, -78.2533264160156, -1.36577819659733, 218, 40, 'PPL', 'P'),
(154270, 'Bellville', 40.6199989318848, 0.708952723517969, -82.5108337402344, -1.44008571733272, 218, 41, 'PPL', 'P'),
(19175, 'Bellville Point', 31.5311107635498, 0.550321699634967, -81.3661117553711, -1.42010654967689, 218, 13, 'PPL', 'P'),
(75101, 'Bellvue', 35.9008293151855, 0.626587675746489, -96.3869400024414, -1.68226945896483, 218, 42, 'PPL', 'P'),
(79741, 'Bellvue', 35.0083312988281, 0.611010646793534, -82.4158325195313, -1.43842763323803, 218, 48, 'PPL', 'P'),
(99800, 'Bellvue', 38.2574996948242, 0.667719333255408, -77.4894409179688, -1.35244587954817, 218, 53, 'PPL', 'P'),
(194105, 'Bellvue', 40.6263885498047, 0.709064243388616, -105.171112060547, -1.83558218344046, 218, 7, 'PPL', 'P'),
(294, 'Bellwood', 31.173059463501, 0.544072525558069, -85.793327331543, -1.49737603817667, 218, 2, 'PPL', 'P'),
(15185, 'Bellwood', 28.5047206878662, 0.497501228364608, -80.7847213745117, -1.40995937329147, 218, 12, 'PPL', 'P'),
(19176, 'Bellwood', 33.7744407653809, 0.58947519437569, -84.4124984741211, -1.4732760282081, 218, 13, 'PPL', 'P'),
(34765, 'Bellwood', 37.7944412231445, 0.659637438295345, -85.5475006103516, -1.49308555250249, 218, 21, 'PPL', 'P'),
(39343, 'Bellwood', 31.5272197723389, 0.55025378902717, -93.2052764892578, -1.62673895496921, 218, 22, 'PPL', 'P'),
(62851, 'Bellwood', 35.7652816772461, 0.624221923171144, -80.8063888549805, -1.41033754216626, 218, 33, 'PPL', 'P'),
(84968, 'Bellwood', 36.2533302307129, 0.632739977338735, -86.147216796875, -1.50355257453483, 218, 50, 'PPL', 'P'),
(99801, 'Bellwood', 37.4216690063477, 0.653131335752281, -77.4377822875977, -1.35154426636113, 218, 53, 'PPL', 'P'),
(108163, 'Bellwood', 37.9216690063477, 0.661857982012253, -80.8302764892578, -1.41075446003491, 218, 58, 'PPL', 'P'),
(118769, 'Bellwood', 41.8813896179199, 0.730968144143273, -87.883056640625, -1.53384869509557, 218, 18, 'PPL', 'P'),
(141277, 'Bellwood', 41.3427810668945, 0.721567651548484, -97.2380599975586, -1.69712430520919, 218, 35, 'PPL', 'P'),
(147132, 'Bellwood', 43.8027801513672, 0.764502735168578, -75.6819381713867, -1.32089900538147, 218, 40, 'PPL', 'P'),
(159093, 'Bellwood', 40.603328704834, 0.708661773168878, -78.3249969482422, -1.36702908336134, 218, 45, 'PPL', 'P'),
(173139, 'Bellwood', 46.5719413757324, 0.812833716052308, -91.6374969482422, -1.59937604003308, 218, 57, 'PPL', 'P'),
(203007, 'Bellwood Acres', 40.6319389343262, 0.709161115873268, -111.821937561035, -1.95166098639958, 218, 52, 'PPL', 'P'),
(15186, 'Bellwood Estates', 30.5038890838623, 0.532393299176554, -84.3283309936523, -1.47180702855081, 218, 12, 'PPL', 'P'),
(79742, 'Bellwood Estates', 34.9230613708496, 0.60952240579737, -82.3372192382813, -1.43705557264443, 218, 48, 'PPL', 'P'),
(99802, 'Bellwood Estates', 37.413330078125, 0.652985793998709, -77.4219436645508, -1.35126783023998, 218, 53, 'PPL', 'P'),
(180029, 'Bellwood Estates', 38.0205612182617, 0.663583976714733, -120.29972076416, -2.09962621656438, 218, 6, 'PPL', 'P'),
(99803, 'Bellwood Manor', 37.3997192382813, 0.652748240029474, -77.4199981689453, -1.35123387493608, 218, 53, 'PPL', 'P'),
(99804, 'Bellwood Terrace', 37.4172210693359, 0.653053704606506, -77.4347229003906, -1.35149086998127, 218, 53, 'PPL', 'P'),
(44737, 'Belmar', 39.3455581665039, 0.686709536040437, -76.5408325195313, -1.33588953968337, 218, 25, 'PPL', 'P'),
(144817, 'Belmar', 40.1783294677734, 0.701244137163707, -74.022216796875, -1.29193140273052, 218, 37, 'PPL', 'P'),
(159096, 'Belmar', 41.3330612182617, 0.721398008187046, -79.7750015258789, -1.39233643741009, 218, 45, 'PPL', 'P'),
(197988, 'Belmar', 48.660831451416, 0.849291725585221, -100.327217102051, -1.75104026779395, 218, 34, 'PPL', 'P'),
(199169, 'Belmar', 41.2988891601563, 0.720801593260922, -101.916107177734, -1.77877163106689, 218, 35, 'PPL', 'P'),
(44738, 'Belmar Estates', 39.4388885498047, 0.688338458521183, -77.0999984741211, -1.34564882665602, 218, 25, 'PPL', 'P'),
(159097, 'Belmar Park', 41.0063896179199, 0.715696513188322, -80.3769378662109, -1.40284220843629, 218, 45, 'PPL', 'P'),
(92551, 'Belmares Trailer Park Colonia', 27.2080001831055, 0.474869186078411, -98.1790008544922, -1.71354682122921, 218, 51, 'PPL', 'P'),
(92552, 'Belmena', 30.9086093902588, 0.539457001072853, -96.908332824707, -1.69136948040963, 218, 51, 'PPL', 'P'),
(114557, 'Belmond', 42.8461112976074, 0.74780571381919, -93.6138916015625, -1.63387063405233, 218, 16, 'PPL', 'P'),
(303, 'Belmont', 32.5586090087891, 0.568254927072857, -87.942497253418, -1.53488612949821, 218, 2, 'PPL', 'P'),
(15187, 'Belmont', 30.4980602264404, 0.532291566422913, -82.7508316040039, -1.44427447025325, 218, 12, 'PPL', 'P'),
(19179, 'Belmont', 33.8394393920898, 0.590609634421036, -83.2877807617188, -1.45364600097118, 218, 13, 'PPL', 'P'),
(29194, 'Belmont', 39.1519393920898, 0.683330250933235, -86.3472213745117, -1.50704331293365, 218, 19, 'PPL', 'P'),
(31784, 'Belmont', 39.0472183227539, 0.681502523477114, -95.6333312988281, -1.6691165058151, 218, 20, 'PPL', 'P'),
(34767, 'Belmont', 37.8963890075684, 0.661416762798654, -85.7136077880859, -1.49598466966515, 218, 21, 'PPL', 'P'),
(39353, 'Belmont', 31.7161102294922, 0.553550549430093, -93.5088882446289, -1.6320379797482, 218, 22, 'PPL', 'P'),
(44740, 'Belmont', 38.3702812194824, 0.669687742196113, -75.5722198486328, -1.31898405939965, 218, 25, 'PPL', 'P'),
(58619, 'Belmont', 34.5097198486328, 0.602308235299482, -88.2091674804688, -1.53954040297729, 218, 30, 'PPL', 'P'),
(62854, 'Belmont', 35.7719383239746, 0.624338103573699, -80.8541717529297, -1.41117151106162, 218, 33, 'PPL', 'P'),
(79749, 'Belmont', 34.0658302307129, 0.59456089995136, -81.0138931274414, -1.41395917493266, 218, 48, 'PPL', 'P'),
(84973, 'Belmont', 36.0102806091309, 0.628497961196403, -83.317497253418, -1.45416465159348, 218, 50, 'PPL', 'P'),
(92553, 'Belmont', 29.5230598449707, 0.515274599558065, -97.6836090087891, -1.70490060243416, 218, 51, 'PPL', 'P'),
(99809, 'Belmont', 38.9022216796875, 0.678971854651266, -78.1999969482422, -1.36484742179634, 218, 53, 'PPL', 'P'),
(108164, 'Belmont', 39.3794403076172, 0.687300890960489, -81.2586135864258, -1.41823035268893, 218, 58, 'PPL', 'P'),
(118770, 'Belmont', 41.792781829834, 0.729421646498264, -88.0377807617188, -1.53654914044091, 218, 18, 'PPL', 'P'),
(124225, 'Belmont', 42.3958282470703, 0.739946792021393, -71.1791687011719, -1.24231085266794, 218, 23, 'PPL', 'P'),
(129756, 'Belmont', 43.0755615234375, 0.751810375729369, -85.6091690063477, -1.49416186905705, 218, 27, 'PPL', 'P'),
(143511, 'Belmont', 43.4452781677246, 0.758263148471604, -71.4783325195313, -1.24753224630115, 218, 36, 'PPL', 'P'),
(147133, 'Belmont', 42.2230606079102, 0.736931427877151, -78.0347213745117, -1.36196281886162, 218, 40, 'PPL', 'P'),
(154258, 'Belmont', 40.0291709899902, 0.698640830619128, -81.0391693115234, -1.41440032756723, 218, 41, 'PPL', 'P'),
(159099, 'Belmont', 40.7083282470703, 0.710494360893989, -76.1483306884766, -1.32903909041136, 218, 45, 'PPL', 'P'),
(171728, 'Belmont', 43.4155616760254, 0.757744497849311, -72.8227767944336, -1.27099722550779, 218, 55, 'PPL', 'P'),
(173140, 'Belmont', 42.7361106872559, 0.745885840989351, -90.3341674804688, -1.57662864958217, 218, 57, 'PPL', 'P'),
(180030, 'Belmont', 37.5202789306641, 0.654852403606745, -122.274719238281, -2.13409644265966, 218, 6, 'PPL', 'P'),
(189930, 'Belmont', 38.5961112976074, 0.673629220609431, -116.873329162598, -2.03982440165444, 218, 39, 'PPL', 'P'),
(194576, 'Belmont', 47.9261093139648, 0.836468405199407, -116.638610839844, -2.03572779410762, 218, 17, 'PPL', 'P'),
(195970, 'Belmont', 46.2313919067383, 0.806890006552442, -108.988059997559, -1.90220049231852, 218, 31, 'PPL', 'P'),
(199170, 'Belmont', 42.5497207641602, 0.742632723138792, -103.356109619141, -1.80390441490619, 218, 35, 'PPL', 'P'),
(209910, 'Belmont', 47.0880584716797, 0.82184165870242, -117.161392211914, -2.04485205031834, 218, 56, 'PPL', 'P'),
(7392, 'Belmont (historical)', 35.5597190856934, 0.620634179129617, -94.1783294677734, -1.64372193324065, 218, 4, 'PPL', 'P'),
(19180, 'Belmont (historical)', 31.8194408416748, 0.555354008830781, -84.458610534668, -1.47408083548952, 218, 13, 'PPL', 'P'),
(79744, 'Belmont (historical)', 35.0105590820313, 0.611049528945449, -81.0641708374023, -1.41483668651184, 218, 48, 'PPL', 'P'),
(195971, 'Belmont (historical)', 46.6624984741211, 0.814414235580243, -112.314720153809, -1.96026166513999, 218, 31, 'PPL', 'P'),
(44741, 'Belmont Acres', 38.6800003051758, 0.675093359997729, -75.9433288574219, -1.32546113348683, 218, 25, 'PPL', 'P'),
(99811, 'Belmont Acres', 37.3208312988281, 0.651371385745903, -79.2458267211914, -1.38310059474969, 218, 53, 'PPL', 'P'),
(159100, 'Belmont Acres', 40.3266716003418, 0.703833195796455, -76.8008270263672, -1.34042729986475, 218, 45, 'PPL', 'P'),
(126859, 'Belmont Corner', 44.3972206115723, 0.774877678406227, -69.1361083984375, -1.20665272356844, 218, 26, 'PPL', 'P'),
(159101, 'Belmont Corner', 41.7405586242676, 0.728510179615184, -75.456672668457, -1.31696738066419, 218, 45, 'PPL', 'P'),
(99812, 'Belmont Country Club', 39.0719413757324, 0.681934022152734, -77.4941711425781, -1.35252843754196, 218, 53, 'PPL', 'P'),
(79746, 'Belmont Estates', 34.0361099243164, 0.594042182750039, -81.0980606079102, -1.41542817458995, 218, 48, 'PPL', 'P'),
(99813, 'Belmont Estates', 37.1686096191406, 0.64871461624244, -80.4416732788086, -1.40397205452875, 218, 53, 'PPL', 'P'),
(99814, 'Belmont Farms', 37.1561088562012, 0.648496436770135, -80.4472198486328, -1.40406886043438, 218, 53, 'PPL', 'P'),
(154260, 'Belmont Farms', 41.5758285522461, 0.725635097481362, -83.585563659668, -1.45884329299653, 218, 41, 'PPL', 'P'),
(99815, 'Belmont Greene', 39.0638885498047, 0.681793473826205, -77.5105590820313, -1.35281446104304, 218, 53, 'PPL', 'P'),
(79748, 'Belmont Heights', 34.9533309936523, 0.610050710378615, -82.2597198486328, -1.43570295312677, 218, 48, 'PPL', 'P'),
(124226, 'Belmont Hill', 42.2708282470703, 0.7377651304564, -71.7972183227539, -1.25309785350526, 218, 23, 'PPL', 'P'),
(159102, 'Belmont Hills', 40.0341682434082, 0.698728049144828, -75.258056640625, -1.31350087703129, 218, 45, 'PPL', 'P'),
(39346, 'Belmont Landing', 30.5080604553223, 0.532466103342854, -91.2430572509766, -1.59249176861523, 218, 22, 'PPL', 'P'),
(44742, 'Belmont Landing', 38.6055603027344, 0.673794136859934, -76.0227813720703, -1.32684784146644, 218, 25, 'PPL', 'P'),
(53415, 'Belmont Landing', 36.7663917541504, 0.641694590188018, -89.1216735839844, -1.55546663892818, 218, 29, 'PPL', 'P'),
(99816, 'Belmont Park', 38.6624984741211, 0.674787895420697, -77.2052764892578, -1.34748627465012, 218, 53, 'PPL', 'P'),
(108165, 'Belmont Park', 38.3936080932617, 0.670094872947759, -82.3936080932617, -1.43803974382526, 218, 58, 'PPL', 'P'),
(154261, 'Belmont Park', 41.1808280944824, 0.718741038946501, -80.670280456543, -1.40796200247391, 218, 41, 'PPL', 'P'),
(154262, 'Belmont Ridge', 40.165828704834, 0.701025957691403, -81.1800003051758, -1.41685829209532, 218, 41, 'PPL', 'P'),
(180031, 'Belmont Shore', 33.7572212219238, 0.589174656646674, -118.136108398438, -2.06186405704566, 218, 6, 'PPL', 'P'),
(159103, 'Belmont Terrace', 40.1049995422363, 0.699964288522843, -75.366943359375, -1.31540130878517, 218, 45, 'PPL', 'P'),
(203009, 'Belmont Terrace', 40.6183280944824, 0.708923561904033, -111.834716796875, -1.95188402614088, 218, 52, 'PPL', 'P'),
(26491, 'Belmont Village', 38.9422187805176, 0.679669935752003, -90.184440612793, -1.57401542276253, 218, 18, 'PPL', 'P'),
(84978, 'Belmont West', 35.9358291625977, 0.627198538321526, -84.105827331543, -1.46792360704926, 218, 50, 'PPL', 'P'),
(154263, 'Belmont Woods', 41.5858306884766, 0.725809667690816, -83.57861328125, -1.45872198600887, 218, 41, 'PPL', 'P'),
(13360, 'Belmoor', 39.7249984741211, 0.693332018723137, -75.5930633544922, -1.31934784720456, 218, 10, 'PPL', 'P'),
(15188, 'Belmore', 29.8863906860352, 0.52161591900868, -81.8988876342773, -1.42940524293901, 218, 12, 'PPL', 'P'),
(154264, 'Belmore', 41.1533317565918, 0.718261137318069, -83.938606262207, -1.46500504881064, 218, 41, 'PPL', 'P'),
(206810, 'Belmore', 46.9874992370605, 0.82008656896503, -122.961112976074, -2.14607627334922, 218, 56, 'PPL', 'P'),
(19181, 'Belmount Farms', 33.6138916015625, 0.586673082855735, -84.2466735839844, -1.47038183789346, 218, 13, 'PPL', 'P'),
(108166, 'Belo', 37.774169921875, 0.659283637344528, -82.2377777099609, -1.43531999056202, 218, 58, 'PPL', 'P'),
(309, 'Beloit', 32.3541717529297, 0.564686823844368, -87.1486129760742, -1.52103023497875, 218, 2, 'PPL', 'P'),
(19182, 'Beloit', 31.6736106872559, 0.552808792487479, -84.0769424438477, -1.46741947065491, 218, 13, 'PPL', 'P'),
(31788, 'Beloit', 39.4561080932617, 0.688638996250199, -98.105827331543, -1.71226970232847, 218, 20, 'PPL', 'P'),
(114560, 'Beloit', 43.2813911437988, 0.755402780302804, -96.5744400024414, -1.68554195131232, 218, 16, 'PPL', 'P'),
(154265, 'Beloit', 40.9230613708496, 0.71424216091703, -80.9938888549805, -1.41361003451375, 218, 41, 'PPL', 'P'),
(173144, 'Beloit', 42.5083312988281, 0.741910340693108, -89.0316696166992, -1.5538957733592, 218, 57, 'PPL', 'P'),
(99817, 'Belona', 37.521110534668, 0.654866917834686, -78.0088882446289, -1.36151194568907, 218, 53, 'PPL', 'P'),
(92554, 'Belott', 31.4305591583252, 0.548566743055632, -95.3058319091797, -1.66340056316746, 218, 51, 'PPL', 'P'),
(58621, 'Belpine', 32.0550003051758, 0.559465297053105, -89.9972229003906, -1.57074785726306, 218, 30, 'PPL', 'P'),
(31791, 'Belpre', 37.9500007629395, 0.662352464447654, -99.0999984741211, -1.72962126209477, 218, 20, 'PPL', 'P'),
(71794, 'Belpre', 39.2738914489746, 0.685458715855453, -81.5730590820313, -1.42371846190531, 218, 41, 'PPL', 'P'),
(99818, 'Belroi', 37.3872184753418, 0.652530060557169, -76.5883331298828, -1.33671858173071, 218, 53, 'PPL', 'P'),
(113201, 'Belsano', 40.5194396972656, 0.70719763378058, -78.8713912963867, -1.37656546375075, 218, 45, 'PPL', 'P'),
(159104, 'Belsano Crossing', 40.5158309936523, 0.707134650020799, -78.8611068725586, -1.37638596669328, 218, 45, 'PPL', 'P'),
(129758, 'Belsay', 43.0263900756836, 0.750952172068091, -83.595832824707, -1.45902252373789, 218, 27, 'PPL', 'P'),
(159105, 'Belsena', 40.8488883972168, 0.712947598311142, -78.4433288574219, -1.36909436478669, 218, 45, 'PPL', 'P'),
(7393, 'Belser (historical)', 34.5469398498535, 0.602957846868379, -90.6938934326172, -1.58290705185203, 218, 4, 'PPL', 'P'),
(79752, 'Belser Crossroads', 33.6119384765625, 0.586638994393783, -80.3936080932617, -1.40313315878538, 218, 48, 'PPL', 'P'),
(79750, 'Belsers Crossroads', 33.648609161377, 0.587279018582756, -79.8874969482422, -1.39429985292375, 218, 48, 'PPL', 'P'),
(122213, 'Belshaw', 41.2563896179199, 0.720059836318308, -87.4533309936523, -1.52634856767564, 218, 19, 'PPL', 'P'),
(99819, 'Belspring', 37.1908302307129, 0.649102439076182, -80.6083297729492, -1.40688075907134, 218, 53, 'PPL', 'P'),
(15189, 'Belspur', 27.3416690826416, 0.477202148482834, -82.4533309936523, -1.43908210507592, 218, 12, 'PPL', 'P'),
(195972, 'Belt', 47.3861083984375, 0.827043611259671, -110.92472076416, -1.93600159918992, 218, 31, 'PPL', 'P'),
(195973, 'Belt Creek', 47.5530586242676, 0.829957442387354, -110.956672668457, -1.93655926512218, 218, 31, 'PPL', 'P'),
(92555, 'Belt Junction', 32.7000007629395, 0.570722678717951, -97.3533325195313, -1.69913619025469, 218, 51, 'PPL', 'P'),
(180032, 'Beltaine (historical)', 38.3880615234375, 0.669998067042135, -122.521667480469, -2.13840650256784, 218, 6, 'PPL', 'P'),
(19183, 'Belton', 34.3997192382813, 0.600388362469644, -83.6555633544922, -1.4600650181466, 218, 13, 'PPL', 'P'),
(34768, 'Belton', 37.1599998474121, 0.648564347377932, -87.0283279418945, -1.51893086509144, 218, 21, 'PPL', 'P'),
(53416, 'Belton', 38.811939239502, 0.677396128813293, -94.5316696166992, -1.64988888221889, 218, 29, 'PPL', 'P'),
(79751, 'Belton', 34.5227813720703, 0.602536201888793, -82.4944381713867, -1.43979956067359, 218, 48, 'PPL', 'P'),
(92556, 'Belton', 31.0558300018311, 0.542026485471588, -97.4641723632813, -1.70107071047052, 218, 51, 'PPL', 'P'),
(7394, 'Belton (historical)', 33.9486083984375, 0.592514993022933, -93.6986083984375, -1.63534922108955, 218, 4, 'PPL', 'P'),
(195974, 'Belton (historical)', 47.375560760498, 0.82685952024932, -110.925559997559, -1.93601624657591, 218, 31, 'PPL', 'P'),
(312, 'Beltona', 33.7983283996582, 0.589892112244342, -86.8486099243164, -1.51579419395954, 218, 2, 'PPL', 'P'),
(134196, 'Beltrami', 47.5424995422363, 0.829773151639921, -96.5299987792969, -1.68476630564484, 218, 28, 'PPL', 'P'),
(26492, 'Beltrees', 38.9594383239746, 0.679970473481018, -90.3255615234375, -1.57647844729669, 218, 18, 'PPL', 'P'),
(44743, 'Beltsville', 39.0347213745117, 0.681284410583836, -76.9077835083008, -1.34229404263084, 218, 25, 'PPL', 'P'),
(44746, 'Beltsville Heights', 39.0455589294434, 0.681473561600259, -76.908332824707, -1.34230363001077, 218, 25, 'PPL', 'P'),
(159108, 'Beltzhoover', 40.4197196960449, 0.705457191429186, -80.0022201538086, -1.39630215058932, 218, 45, 'PPL', 'P'),
(159106, 'Beltzville', 40.8400001525879, 0.712792469177645, -75.6358337402344, -1.32009433125811, 218, 45, 'PPL', 'P'),
(212300, 'Beluga', 61.1791687011719, 1.06777792746851, -151.02360534668, -2.63585916153207, 218, 1, 'PPL', 'P'),
(62858, 'Belva', 35.9341697692871, 0.627169576444671, -82.7430572509766, -1.44413878219571, 218, 33, 'PPL', 'P'),
(75102, 'Belva', 36.4988899230957, 0.637025802481, -98.9747161865234, -1.72743467368176, 218, 42, 'PPL', 'P'),
(108167, 'Belva', 38.2311096191406, 0.667258739544879, -81.1922225952148, -1.41707161129863, 218, 58, 'PPL', 'P'),
(44745, 'Belvedere', 39.0786094665527, 0.68205040229237, -77.2611083984375, -1.34846072529298, 218, 25, 'PPL', 'P'),
(62859, 'Belvedere', 35.5699996948242, 0.620813609608061, -77.3925018310547, -1.35075397330764, 218, 33, 'PPL', 'P'),
(79753, 'Belvedere', 33.5308303833008, 0.585223391116351, -81.9449996948242, -1.43021005022043, 218, 48, 'PPL', 'P'),
(99822, 'Belvedere', 38.2438888549805, 0.667481779286173, -77.3850021362305, -1.35062307894007, 218, 53, 'PPL', 'P'),
(154266, 'Belvedere', 40.357780456543, 0.704376147763695, -80.7652816772461, -1.40962008656859, 218, 41, 'PPL', 'P'),
(180034, 'Belvedere', 37.8727798461914, 0.661004705198992, -122.463333129883, -2.13738837608311, 218, 6, 'PPL', 'P'),
(206812, 'Belvedere', 48.0499992370605, 0.83863069226747, -118.98388671875, -2.07666058006214, 218, 56, 'PPL', 'P'),
(19184, 'Belvedere Acres', 34.3811111450195, 0.600063589974708, -83.8902816772461, -1.46416162569342, 218, 13, 'PPL', 'P'),
(99823, 'Belvedere Beach', 38.3349990844727, 0.66907195277306, -77.2713928222656, -1.34864022235045, 218, 53, 'PPL', 'P'),
(44747, 'Belvedere Heights', 39.0558280944824, 0.681652792341621, -76.5025024414063, -1.33522055361754, 218, 25, 'PPL', 'P'),
(108168, 'Belvedere Heights', 39.2783317565918, 0.685536213843175, -77.8472213745117, -1.35869032651414, 218, 58, 'PPL', 'P'),
(180036, 'Belvedere Heights', 33.9836082458496, 0.59312585559797, -117.309997558594, -2.04744570290397, 218, 6, 'PPL', 'P'),
(19186, 'Belvedere Park', 33.7547187805176, 0.589130980804797, -84.2675018310547, -1.47074535938225, 218, 13, 'PPL', 'P'),
(44748, 'Belvedere Woodland', 38.2394409179688, 0.667404148140398, -76.5666732788086, -1.33634054601397, 218, 25, 'PPL', 'P'),
(13361, 'Belvidere', 39.7219390869141, 0.69327862234328, -75.6158294677734, -1.3197451908392, 218, 10, 'PPL', 'P'),
(31793, 'Belvidere', 37.4502792358398, 0.653630678456671, -99.079719543457, -1.7292673279859, 218, 20, 'PPL', 'P'),
(53417, 'Belvidere', 38.8580589294434, 0.67820106925277, -94.5238876342773, -1.64975306100329, 218, 29, 'PPL', 'P'),
(62861, 'Belvidere', 36.2686080932617, 0.63300662634288, -76.5361099243164, -1.33580711484763, 218, 33, 'PPL', 'P'),
(84979, 'Belvidere', 35.1291694641113, 0.613119670639795, -86.1866683959961, -1.50424113483467, 218, 50, 'PPL', 'P'),
(118774, 'Belvidere', 42.2638893127441, 0.737644023205829, -88.8441696166992, -1.55062328101171, 218, 18, 'PPL', 'P'),
(124228, 'Belvidere', 42.6388893127441, 0.744189007900807, -71.290283203125, -1.24425016657374, 218, 23, 'PPL', 'P'),
(141279, 'Belvidere', 40.2519416809082, 0.702528912652589, -97.557502746582, -1.70269963295127, 218, 35, 'PPL', 'P'),
(144819, 'Belvidere', 40.829719543457, 0.712613038699201, -75.0780563354492, -1.31035927905138, 218, 37, 'PPL', 'P'),
(147135, 'Belvidere', 42.2541694641113, 0.737474379844391, -78.059440612793, -1.36239425095822, 218, 40, 'PPL', 'P'),
(159107, 'Belvidere', 40.0250015258789, 0.698568059742341, -75.6466674804688, -1.3202834156955, 218, 45, 'PPL', 'P'),
(194577, 'Belvidere', 44.4755592346191, 0.776244945309873, -116.032501220703, -2.02514918562561, 218, 17, 'PPL', 'P'),
(201897, 'Belvidere', 43.8319396972656, 0.765011665252892, -101.271110534668, -1.76751431598107, 218, 49, 'PPL', 'P'),
(171729, 'Belvidere Center', 44.75, 0.781034840267463, -72.6916732788086, -1.26870903749919, 218, 55, 'PPL', 'P'),
(171730, 'Belvidere Junction', 44.7369384765625, 0.780806873678152, -72.7430572509766, -1.26960585699628, 218, 55, 'PPL', 'P'),
(134199, 'Belvidere Mills', 44.4524993896484, 0.775842475090135, -92.5091705322266, -1.61458961407627, 218, 28, 'PPL', 'P'),
(7395, 'Belview', 36.0902786254883, 0.629894189976904, -91.9194412231445, -1.60429689593728, 218, 4, 'PPL', 'P'),
(134201, 'Belview', 44.605281829834, 0.778509031710604, -95.3291702270508, -1.66380789365619, 218, 28, 'PPL', 'P'),
(315, 'Belview Heights', 34.7150001525879, 0.605891052492993, -87.6916732788086, -1.53050842529834, 218, 2, 'PPL', 'P'),
(62863, 'Belville', 34.2305603027344, 0.597435982085182, -77.9661102294922, -1.36076532847747, 218, 33, 'PPL', 'P'),
(84980, 'Belvins', 36.4613914489746, 0.636371330643113, -82.9361114501953, -1.44750821360688, 218, 50, 'PPL', 'P'),
(62864, 'Belvoir', 35.7080612182617, 0.623223237762365, -77.4652786254883, -1.35202416798956, 218, 33, 'PPL', 'P'),
(99824, 'Belvoir', 38.8594398498535, 0.678225170860635, -77.820556640625, -1.35822493911364, 218, 53, 'PPL', 'P'),
(44749, 'Belvoir Farms', 39.0194396972656, 0.681017695000665, -76.5794372558594, -1.33656331943916, 218, 25, 'PPL', 'P'),
(44750, 'Belvoir Manor', 39.0233306884766, 0.681085605608462, -76.5827789306641, -1.33662164266703, 218, 25, 'PPL', 'P'),
(31794, 'Belvue', 39.2166709899902, 0.684460030446674, -96.1777801513672, -1.67861893090061, 218, 20, 'PPL', 'P'),
(320, 'Belwood', 33.4680595397949, 0.58412783322292, -86.9116668701172, -1.51689474528002, 218, 2, 'PPL', 'P'),
(62867, 'Belwood', 35.4769401550293, 0.619189414238249, -81.5236129760742, -1.42285546455407, 218, 33, 'PPL', 'P'),
(58620, 'Belzoni', 33.1841697692871, 0.579173022014827, -90.4891662597656, -1.57933388861747, 218, 30, 'PPL', 'P'),
(75103, 'Belzoni', 34.1855583190918, 0.59665054930069, -95.4652786254883, -1.66618343334854, 218, 42, 'PPL', 'P'),
(53418, 'Bem', 38.2658309936523, 0.667864741850927, -91.4697189331055, -1.59644776125649, 218, 29, 'PPL', 'P'),
(44751, 'Bembe Beach', 38.9636116027832, 0.680043310936832, -76.475830078125, -1.33475503305899, 218, 25, 'PPL', 'P'),
(84982, 'Bemberg', 36.336109161377, 0.634184742230103, -82.2416687011719, -1.43538790116982, 218, 50, 'PPL', 'P'),
(26493, 'Bement', 39.9219398498535, 0.696769294163075, -88.5719375610352, -1.5458719353109, 218, 18, 'PPL', 'P'),
(154268, 'Bement', 41.422779083252, 0.722963880328985, -81.9619369506836, -1.43050566110143, 218, 41, 'PPL', 'P'),
(134203, 'Bemidji', 47.4736099243164, 0.828570800986777, -94.879997253418, -1.65596834635532, 218, 28, 'PPL', 'P'),
(7396, 'Bemis', 35.1624984741211, 0.613701371600895, -91.067497253418, -1.58942766862304, 218, 4, 'PPL', 'P'),
(39348, 'Bemis', 32.9569396972656, 0.575207109098508, -92.1783294677734, -1.60881534820076, 218, 22, 'PPL', 'P'),
(84983, 'Bemis', 35.5761108398438, 0.620920269209719, -88.8213882446289, -1.55022567106096, 218, 50, 'PPL', 'P'),
(108170, 'Bemis', 38.811939239502, 0.677396128813293, -79.7391662597656, -1.39171099402808, 218, 58, 'PPL', 'P'),
(124229, 'Bemis', 42.3686103820801, 0.73947175066195, -71.2041702270508, -1.24274721161255, 218, 23, 'PPL', 'P'),
(126861, 'Bemis', 44.857780456543, 0.78291596410344, -70.730827331543, -1.23448581959502, 218, 26, 'PPL', 'P'),
(169816, 'Bemis', 44.8349990844727, 0.782518354152691, -96.8480606079102, -1.69031753177905, 218, 49, 'PPL', 'P'),
(206813, 'Bemis', 46.9238891601563, 0.818976363685603, -118.29972076416, -2.0647196315245, 218, 56, 'PPL', 'P'),
(147136, 'Bemis Heights', 42.9711112976074, 0.749987375384182, -73.6338882446289, -1.28515379091432, 218, 40, 'PPL', 'P'),
(19187, 'Bemiss', 30.9330596923828, 0.539883739348024, -83.2413864135742, -1.45283626684174, 218, 13, 'PPL', 'P'),
(321, 'Bemiston', 33.4099998474121, 0.583114500428144, -86.1208267211914, -1.5030919808243, 218, 2, 'PPL', 'P'),
(147137, 'Bemus Point', 42.1616706848145, 0.735859971591585, -79.3919372558594, -1.3856507046515, 218, 40, 'PPL', 'P'),
(7397, 'Ben', 35.7211112976074, 0.623451004614594, -91.9483337402344, -1.60480116548968, 218, 4, 'PPL', 'P'),
(92558, 'Ben', 32.6800003051758, 0.570373604878069, -95.5411071777344, -1.66750689125225, 218, 51, 'PPL', 'P'),
(154269, 'Ben', 40.0916709899902, 0.699731661401624, -82.3088912963867, -1.43656115678805, 218, 41, 'PPL', 'P'),
(84984, 'Ben (historical)', 35.6425018310547, 0.622079010600012, -87.1191711425781, -1.52051637804642, 218, 50, 'PPL', 'P'),
(203011, 'Ben Air Estates', 40.6369400024414, 0.709248400977995, -111.941108703613, -1.95374091521093, 218, 52, 'PPL', 'P'),
(180037, 'Ben Ali', 38.621940612793, 0.674080027202954, -121.42138671875, -2.1192029805795, 218, 6, 'PPL', 'P'),
(92559, 'Ben Arnold', 30.9636096954346, 0.540416937487772, -96.9877777099609, -1.69275605523118, 218, 51, 'PPL', 'P'),
(79756, 'Ben Avon', 34.9363899230957, 0.609755032918589, -81.8794403076172, -1.42906582305808, 218, 48, 'PPL', 'P'),
(159113, 'Ben Avon', 40.5080604553223, 0.706999028542287, -80.0833282470703, -1.39771775386676, 218, 45, 'PPL', 'P'),
(159110, 'Ben Avon Heights', 40.5136108398438, 0.707095901026939, -80.0733337402344, -1.39754331681536, 218, 45, 'PPL', 'P'),
(92560, 'Ben Bolt', 27.6472206115723, 0.482535028697176, -98.0811080932617, -1.71183827023187, 218, 51, 'PPL', 'P'),
(34769, 'Ben Bow', 37.9691696166992, 0.662687024059595, -82.6350021362305, -1.44225286466977, 218, 21, 'PPL', 'P'),
(108171, 'Ben Dale', 39.0155601501465, 0.680949984129949, -80.4775009155273, -1.4045973647527, 218, 58, 'PPL', 'P'),
(29193, 'Ben Davis', 39.7480583190918, 0.693734488942875, -86.2694396972656, -1.50568576656799, 218, 19, 'PPL', 'P'),
(19189, 'Ben Dowdy', 33.913330078125, 0.591899270178907, -83.4388885498047, -1.45628332939869, 218, 13, 'PPL', 'P'),
(92561, 'Ben Franklin', 33.4766693115234, 0.584278102087427, -95.7686080932617, -1.67147753127951, 218, 51, 'PPL', 'P'),
(114562, 'Ben Haven Mobile Home Park', 42.3916702270508, 0.739874220881688, -91.7577819824219, -1.60147540992039, 218, 16, 'PPL', 'P'),
(19190, 'Ben Hill', 33.690559387207, 0.588011188145446, -84.5113906860352, -1.47500202291058, 218, 13, 'PPL', 'P'),
(79, 'Ben Hur', 36.732780456543, 0.641107962378901, -83.0822219848633, -1.45005832350868, 218, 53, 'PPL', 'P'),
(7398, 'Ben Hur', 35.730281829834, 0.623611060596107, -92.9727783203125, -1.62268109641626, 218, 4, 'PPL', 'P'),
(92562, 'Ben Hur', 31.5102806091309, 0.549958144856658, -96.7275009155273, -1.68821336820178, 218, 51, 'PPL', 'P'),
(180038, 'Ben Hur', 37.3516693115234, 0.651909610602208, -119.956672668457, -2.09363889780167, 218, 6, 'PPL', 'P'),
(39349, 'Ben Hut (historical)', 30.3527793884277, 0.529755937459535, -91.1730575561523, -1.59127004346515, 218, 22, 'PPL', 'P'),
(44762, 'Ben Lee Estates', 39.1602783203125, 0.683475792686808, -75.9261093139648, -1.32516059575782, 218, 25, 'PPL', 'P'),
(134206, 'Ben Linn Landing', 48.250560760498, 0.84213115120427, -93.8852767944336, -1.63860719920909, 218, 28, 'PPL', 'P'),
(7399, 'Ben Lomond', 33.8352813720703, 0.590537063281331, -94.1183319091797, -1.64267477830003, 218, 4, 'PPL', 'P'),
(180039, 'Ben Lomond', 37.089168548584, 0.647328107999917, -122.08528137207, -2.13079012816633, 218, 6, 'PPL', 'P'),
(203014, 'Ben Lomond Suites Condominiums', 41.2200012207031, 0.719424738977351, -111.968063354492, -1.9542113626175, 218, 52, 'PPL', 'P'),
(99825, 'Ben Mar', 38.9541702270508, 0.679878527844383, -78.2319412231445, -1.36540495457055, 218, 53, 'PPL', 'P'),
(44752, 'Ben Oaks', 39.086109161377, 0.682181296659948, -76.6108322143555, -1.33711126483344, 218, 25, 'PPL', 'P'),
(203015, 'Ben Rancho Acres', 40.642219543457, 0.709340546351712, -111.949996948242, -1.95389604434443, 218, 52, 'PPL', 'P'),
(13362, 'Ben Robins Landing', 38.6580581665039, 0.674710397432975, -75.1569366455078, -1.31173600017689, 218, 10, 'PPL', 'P'),
(92563, 'Ben Wheeler', 32.4458312988281, 0.566286584711179, -95.70361328125, -1.67034315781319, 218, 51, 'PPL', 'P'),
(44753, 'Ben-Har Heights', 39.6055603027344, 0.691247429379877, -76.8802795410156, -1.34181400784436, 218, 25, 'PPL', 'P'),
(112621, 'Bena', 37.2708282470703, 0.650498667856684, -76.4558334350586, -1.33440602579814, 218, 53, 'PPL', 'P'),
(134208, 'Bena', 47.3408317565918, 0.826253384785218, -94.2069396972656, -1.64422127594504, 218, 28, 'PPL', 'P'),
(180040, 'Bena', 35.3266716003418, 0.616566733196739, -118.738891601563, -2.07238460861591, 218, 6, 'PPL', 'P'),
(62869, 'Benaja', 36.2497215270996, 0.632676993578955, -79.6774978637695, -1.39063467747353, 218, 33, 'PPL', 'P'),
(114563, 'Benan (historical)', 42.1230583190918, 0.73518605867774, -94.6477813720703, -1.65191541465038, 218, 16, 'PPL', 'P'),
(92564, 'Benavides', 27.5986099243164, 0.481686612152904, -98.4077835083008, -1.71753983180963, 218, 51, 'PPL', 'P'),
(92565, 'Benavides Colonia Number 2', 26.2810001373291, 0.458689983113475, -98.5650024414063, -1.72028381983879, 218, 51, 'PPL', 'P'),
(84985, 'Benbar', 36.0419387817383, 0.629050500543567, -86.7816696166992, -1.51462586518933, 218, 50, 'PPL', 'P'),
(99826, 'Benbolt', 37.1277809143066, 0.648002020913762, -81.4938888549805, -1.42233668077372, 218, 53, 'PPL', 'P'),
(15191, 'Benbow', 26.8147201538086, 0.46800515468484, -81.04638671875, -1.41452629508679, 218, 12, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(53420, 'Benbow', 39.9150009155273, 0.696648186912503, -91.7438888549805, -1.60123292910314, 218, 29, 'PPL', 'P'),
(99827, 'Benbow', 37.065559387207, 0.646916050400254, -81.5102767944336, -1.4226227042748, 218, 53, 'PPL', 'P'),
(193374, 'Benbow', 40.0686111450195, 0.699329191181886, -123.783332824707, -2.16042671688311, 218, 6, 'PPL', 'P'),
(92566, 'Benbrook', 32.6730613708496, 0.570252497627498, -97.4602813720703, -1.70100279986272, 218, 51, 'PPL', 'P'),
(53421, 'Benbush', 38.6908302307129, 0.675282377856097, -90.495002746582, -1.57943575452917, 218, 29, 'PPL', 'P'),
(108172, 'Benbush', 39.1586112976074, 0.683446697651899, -79.521110534668, -1.3879052036723, 218, 58, 'PPL', 'P'),
(159114, 'Bencetown', 40.7244415283203, 0.710775590705101, -78.9983291625977, -1.37878094746158, 218, 45, 'PPL', 'P'),
(194578, 'Bench', 42.5036087036133, 0.74182791585737, -111.679443359375, -1.94917399341561, 218, 17, 'PPL', 'P'),
(19192, 'Bench Mark', 33.5980606079102, 0.58639677989264, -84.5094375610352, -1.47496793444863, 218, 13, 'PPL', 'P'),
(195975, 'Benchland', 47.0794410705566, 0.821691256679857, -110.017501831055, -1.92016764177079, 218, 31, 'PPL', 'P'),
(92567, 'Benchley', 30.7483291625977, 0.53665958337432, -96.4583282470703, -1.68351541888083, 218, 51, 'PPL', 'P'),
(201900, 'Benchmark', 44.2252807617188, 0.771876761910898, -103.577781677246, -1.8077733221798, 218, 49, 'PPL', 'P'),
(169817, 'Benclare', 43.5055618286133, 0.759315296839267, -96.4786071777344, -1.6838693529897, 218, 49, 'PPL', 'P'),
(7406, 'Bend', 35.3541717529297, 0.617046701404198, -93.3872222900391, -1.62991450825302, 218, 4, 'PPL', 'P'),
(39350, 'Bend', 30.0208301544189, 0.523962330376608, -90.7525024414063, -1.58392997202673, 218, 22, 'PPL', 'P'),
(53422, 'Bend', 38.1944389343262, 0.666618715355906, -91.8463897705078, -1.6030219075654, 218, 29, 'PPL', 'P'),
(92569, 'Bend', 31.0990600585938, 0.542780992297922, -98.512580871582, -1.71936889084629, 218, 51, 'PPL', 'P'),
(193375, 'Bend', 40.2552795410156, 0.702587169301434, -122.207496643066, -2.13292318704143, 218, 6, 'PPL', 'P'),
(195976, 'Bend', 47.9094390869141, 0.836177454850316, -115.048606872559, -2.00797698975872, 218, 31, 'PPL', 'P'),
(200400, 'Bend', 44.0583305358887, 0.768962930783215, -121.314170837402, -2.11733171043956, 218, 43, 'PPL', 'P'),
(201901, 'Bend', 44.2277793884277, 0.771920371173748, -103.009719848633, -1.7978587729156, 218, 49, 'PPL', 'P'),
(99828, 'Bend (historical)', 38.0052795410156, 0.663317261131562, -77.7458267211914, -1.35692065596978, 218, 53, 'PPL', 'P'),
(329, 'Bendale', 33.561939239502, 0.585766343083591, -86.7811126708984, -1.51461614465135, 218, 2, 'PPL', 'P'),
(44754, 'Bendale', 39.079719543457, 0.6820697767893, -76.5808334350586, -1.33658768736313, 218, 25, 'PPL', 'P'),
(53423, 'Bendavis', 37.2983283996582, 0.650978636064143, -92.2072219848633, -1.60931961775317, 218, 29, 'PPL', 'P'),
(31796, 'Bendena', 39.7411117553711, 0.693613248534249, -95.1791687011719, -1.66118987314658, 218, 20, 'PPL', 'P'),
(75104, 'Bender', 36.9330596923828, 0.644603494467684, -97.1372222900391, -1.69536435520281, 218, 42, 'PPL', 'P'),
(19193, 'Bender (historical)', 32.5499992370605, 0.568104658208349, -83.1213912963867, -1.45074195696051, 218, 13, 'PPL', 'P'),
(26495, 'Bender (historical)', 37.3788909912109, 0.652384718540678, -88.8919372558594, -1.55145698359096, 218, 18, 'PPL', 'P'),
(180041, 'Bender (historical)', 36.4597206115723, 0.636342169029177, -119.934997558594, -2.09326059576882, 218, 6, 'PPL', 'P'),
(144821, 'Benders Corner', 40.6802787780762, 0.710004805306605, -74.4116668701172, -1.29872858878073, 218, 37, 'PPL', 'P'),
(44755, 'Benders Heights', 39.4494400024414, 0.688522616110562, -77.0008316040039, -1.34391803826357, 218, 25, 'PPL', 'P'),
(159115, 'Benders Junction', 40.8144416809082, 0.712346389695057, -75.3952789306641, -1.3158958577996, 218, 45, 'PPL', 'P'),
(77847, 'Bendersville', 39.9824981689453, 0.6978262362207, -77.2497177124023, -1.3482619203176, 218, 45, 'PPL', 'P'),
(159116, 'Bendertown', 41.148609161377, 0.718178712482331, -76.3172225952148, -1.33198681026391, 218, 45, 'PPL', 'P'),
(173148, 'Benderville', 44.6113891601563, 0.778615624733235, -87.8550033569336, -1.53335907292916, 218, 57, 'PPL', 'P'),
(92570, 'Bendetsen', 30.3233299255371, 0.52924194736915, -95.0994415283203, -1.65979837147702, 218, 51, 'PPL', 'P'),
(62870, 'Bending Brook', 35.6983299255371, 0.623053394663845, -80.2416687011719, -1.40048131612993, 218, 33, 'PPL', 'P'),
(108173, 'Bendolph', 39.4727783203125, 0.68892994659929, -80.1947174072266, -1.39966186146251, 218, 58, 'PPL', 'P'),
(129759, 'Bendon', 44.6330604553223, 0.778993860187053, -85.8377838134766, -1.49815195016026, 218, 27, 'PPL', 'P'),
(188127, 'Bene Dunagan', 31.7138900756836, 0.553511800436232, -108.822219848633, -1.89930603568777, 218, 38, 'PPL', 'P'),
(19195, 'Benedict', 33.9738883972168, 0.592956212236532, -85.2572174072266, -1.48801915484473, 218, 13, 'PPL', 'P'),
(31797, 'Benedict', 37.6252784729004, 0.656684991331856, -95.7502822875977, -1.67115768563259, 218, 20, 'PPL', 'P'),
(44756, 'Benedict', 38.5091705322266, 0.672111817999331, -76.6800003051758, -1.33831847575557, 218, 25, 'PPL', 'P'),
(99829, 'Benedict', 36.8430595397949, 0.643032695477728, -83.0299987792969, -1.4491468566256, 218, 53, 'PPL', 'P'),
(134210, 'Benedict', 47.1580581665039, 0.823063383852493, -94.6902770996094, -1.65265710501397, 218, 28, 'PPL', 'P'),
(141282, 'Benedict', 41.0058288574219, 0.715686726071316, -97.6061096191406, -1.70354798291651, 218, 35, 'PPL', 'P'),
(147138, 'Benedict', 43.1183280944824, 0.752556793203891, -74.1436080932617, -1.29405008053573, 218, 40, 'PPL', 'P'),
(197989, 'Benedict', 47.8302803039551, 0.83479587345581, -101.081939697266, -1.76421266201965, 218, 34, 'PPL', 'P'),
(147139, 'Benedict Beach', 43.3486099243164, 0.756575969342011, -77.8724975585938, -1.35913147914871, 218, 40, 'PPL', 'P'),
(31808, 'Benedict Junction', 37.610279083252, 0.656423202596701, -95.7708282470703, -1.67151628027337, 218, 20, 'PPL', 'P'),
(44757, 'Benedict Smiths', 38.1319389343262, 0.66552788457341, -76.3925018310547, -1.3333006807877, 218, 25, 'PPL', 'P'),
(44758, 'Benedict Woods', 39.6236114501953, 0.691562481336833, -76.9208297729492, -1.34252174290405, 218, 25, 'PPL', 'P'),
(126862, 'Benedicta', 45.8016700744629, 0.799389945711534, -68.4122161865234, -1.19401842104099, 218, 26, 'PPL', 'P'),
(159117, 'Benedicts', 40.026668548584, 0.69859715477725, -76.9283294677734, -1.34265263727162, 218, 45, 'PPL', 'P'),
(29195, 'Benefiel Corner', 39.1283302307129, 0.682918193333572, -87.4088897705078, -1.52557292200815, 218, 19, 'PPL', 'P'),
(19196, 'Benefit', 34.5574989318848, 0.603142137615813, -83.7300033569336, -1.4613642412844, 218, 13, 'PPL', 'P'),
(99830, 'Benefit', 36.6286087036133, 0.639289822302704, -76.2847213745117, -1.33141955695172, 218, 53, 'PPL', 'P'),
(62871, 'Benefit (historical)', 36.1552810668945, 0.631028696601278, -80.0611114501953, -1.39732999761204, 218, 33, 'PPL', 'P'),
(58622, 'Benela', 33.8300018310547, 0.590444917907615, -89.273063659668, -1.5581088942037, 218, 30, 'PPL', 'P'),
(173149, 'Benet Lake', 42.4980583190918, 0.741731043372719, -88.081672668457, -1.53731519872848, 218, 57, 'PPL', 'P'),
(92571, 'Benevides Colonia', 26.2719993591309, 0.458532889898674, -98.5579986572266, -1.72016158074475, 218, 51, 'PPL', 'P'),
(332, 'Benevola', 33.1091690063477, 0.577864011760026, -87.9649963378906, -1.53527881260095, 218, 2, 'PPL', 'P'),
(44759, 'Benevola', 39.5455589294434, 0.690200207860231, -77.6763916015625, -1.35570878451574, 218, 25, 'PPL', 'P'),
(19197, 'Benevolence', 31.8816699981689, 0.556440112502343, -84.7347183227539, -1.47889982548202, 218, 13, 'PPL', 'P'),
(194580, 'Benewah', 47.2277793884277, 0.824280248733578, -116.783332824707, -2.03825366924351, 218, 17, 'PPL', 'P'),
(159118, 'Benezette', 41.3166694641113, 0.721111918106944, -78.3866729736328, -1.36810553307395, 218, 45, 'PPL', 'P'),
(159120, 'Benfer', 40.7727813720703, 0.711619280138438, -77.2088928222656, -1.34754939156795, 218, 45, 'PPL', 'P'),
(44760, 'Benfield', 39.0886116027832, 0.682224972501825, -76.6224975585938, -1.33731486349878, 218, 25, 'PPL', 'P'),
(29196, 'Bengal', 39.473331451416, 0.688939600558242, -85.9227828979492, -1.49963546404549, 218, 19, 'PPL', 'P'),
(34770, 'Bengal', 37.3591690063477, 0.652040504969785, -85.4572219848633, -1.49150989324355, 218, 21, 'PPL', 'P'),
(53424, 'Bengal', 36.9005584716797, 0.644036241155497, -93.3097229003906, -1.62856188873537, 218, 29, 'PPL', 'P'),
(75105, 'Bengal', 34.8327789306641, 0.607946679959398, -95.0616683959961, -1.65913910594917, 218, 42, 'PPL', 'P'),
(134211, 'Bengal', 47.2683296203613, 0.824987983793266, -93.0658264160156, -1.62430509204899, 218, 28, 'PPL', 'P'),
(34771, 'Benge', 37.228328704834, 0.649756910914069, -83.9230575561523, -1.46473367269556, 218, 21, 'PPL', 'P'),
(206815, 'Benge', 46.9094390869141, 0.818724162330373, -118.101387023926, -2.06125805473961, 218, 56, 'PPL', 'P'),
(191126, 'Benge Corner', 31.7138900756836, 0.553511800436232, -102.009437561035, -1.78040055354764, 218, 51, 'PPL', 'P'),
(7402, 'Bengel', 35.4524993896484, 0.618762842410645, -91.3230590820313, -1.59388806397476, 218, 4, 'PPL', 'P'),
(44761, 'Bengies', 39.3450012207031, 0.686699815502458, -76.4269409179688, -1.33390175624573, 218, 25, 'PPL', 'P'),
(194581, 'Bengoechea Place', 42.3047218322754, 0.738356685113534, -115.846939086914, -2.02191051542396, 218, 17, 'PPL', 'P'),
(29197, 'Benham', 38.9836082458496, 0.680392318197687, -85.2502822875977, -1.48789811417318, 218, 19, 'PPL', 'P'),
(34772, 'Benham', 36.9647216796875, 0.645156100393876, -82.9486083984375, -1.44772632650015, 218, 21, 'PPL', 'P'),
(62872, 'Benham', 36.2902793884277, 0.633384861796698, -80.9177780151367, -1.41228164976202, 218, 33, 'PPL', 'P'),
(39352, 'Benham (historical)', 32.8680610656738, 0.573655884342565, -91.1041717529297, -1.59006775939104, 218, 22, 'PPL', 'P'),
(99831, 'Benhams', 36.6786117553711, 0.640162540191923, -82.2183303833008, -1.43498057068109, 218, 53, 'PPL', 'P'),
(159121, 'Benharts', 40.3777809143066, 0.704725221603577, -75.9113922119141, -1.32490373387068, 218, 45, 'PPL', 'P'),
(84986, 'Benhill', 35.8713912963867, 0.626073885393185, -86.7263870239258, -1.51366100192639, 218, 50, 'PPL', 'P'),
(180042, 'Benicia', 38.0494384765625, 0.664087979951031, -122.157501220703, -2.13205060231026, 218, 6, 'PPL', 'P'),
(92572, 'Benita Addition Colonia', 26.1730003356934, 0.45680503098343, -98.0739974975586, -1.71171416692508, 218, 51, 'PPL', 'P'),
(92573, 'Benitez Colonia', 26.5049991607666, 0.462599503593711, -97.7699966430664, -1.70640835108531, 218, 51, 'PPL', 'P'),
(34773, 'Benito', 36.9000015258789, 0.644026520617519, -83.1283264160156, -1.45086299763205, 218, 21, 'PPL', 'P'),
(180043, 'Benito', 36.8216705322266, 0.642659386871926, -120.435279846191, -2.10199216887681, 218, 6, 'PPL', 'P'),
(92574, 'Benjamin', 33.5838890075684, 0.586149438806399, -99.7919387817383, -1.74169789868995, 218, 51, 'PPL', 'P'),
(139028, 'Benjamin', 40.1619415283203, 0.700958113662633, -91.6341705322266, -1.59931798312132, 218, 29, 'PPL', 'P'),
(159122, 'Benjamin', 40.6336097717285, 0.709190277487204, -79.8399963378906, -1.39347081087641, 218, 45, 'PPL', 'P'),
(203017, 'Benjamin', 40.098331451416, 0.699847908383206, -111.730560302734, -1.95006615238079, 218, 52, 'PPL', 'P'),
(92575, 'Benjamin Perez Colonia', 26.4060001373291, 0.460871644678468, -98.9000015258789, -1.726130656854, 218, 51, 'PPL', 'P'),
(124230, 'Benjamins Landing', 42.083610534668, 0.734497564956927, -71.429443359375, -1.24667896948789, 218, 23, 'PPL', 'P'),
(84987, 'Benjestown', 35.2516708374023, 0.615257722941937, -90.0552825927734, -1.57176119005783, 218, 50, 'PPL', 'P'),
(58623, 'Benjoe', 31.0016708374023, 0.541081229732179, -88.773063659668, -1.54938224794373, 218, 30, 'PPL', 'P'),
(199171, 'Benkelman', 40.0491714477539, 0.69898990445901, -101.532501220703, -1.77207644408643, 218, 35, 'PPL', 'P'),
(26496, 'Benld', 39.0927810668945, 0.682297743378611, -89.8038864135742, -1.56737349900387, 218, 18, 'PPL', 'P'),
(34774, 'Benleo', 37.1138916015625, 0.647759606675537, -86.5441665649414, -1.51048065495262, 218, 21, 'PPL', 'P'),
(58624, 'Benmore', 31.2452793121338, 0.545332999702004, -88.9177780151367, -1.55190798992156, 218, 30, 'PPL', 'P'),
(58625, 'Benndale', 30.8713893890381, 0.538807389503955, -88.8069381713867, -1.54997346970573, 218, 30, 'PPL', 'P'),
(126864, 'Benner Corner', 44.1563911437988, 0.770674411257754, -69.3194427490234, -1.20985251161817, 218, 26, 'PPL', 'P'),
(141283, 'Bennet', 40.6800003051758, 0.709999945037615, -96.5061111450195, -1.68434938777619, 218, 35, 'PPL', 'P'),
(99832, 'Bennets Crossroads', 36.9044418334961, 0.64410401860524, -77.8874969482422, -1.35939326788386, 218, 53, 'PPL', 'P'),
(15192, 'Bennett', 30.3916702270508, 0.530434710642369, -85.5322189331055, -1.49281883691932, 218, 12, 'PPL', 'P'),
(53425, 'Bennett', 36.7336082458496, 0.641122410027814, -91.0044403076172, -1.58832711730256, 218, 29, 'PPL', 'P'),
(62873, 'Bennett', 35.5652809143066, 0.62073125135135, -79.5438919067383, -1.38830281362305, 218, 33, 'PPL', 'P'),
(70533, 'Bennett', 38.9833297729492, 0.680387457928697, -74.9016723632813, -1.3072807979893, 218, 37, 'PPL', 'P'),
(79758, 'Bennett', 32.8619384765625, 0.573549025003825, -80.0258331298828, -1.39671427476801, 218, 48, 'PPL', 'P'),
(92576, 'Bennett', 32.7188911437988, 0.571052378060903, -98.0475006103516, -1.71125170900178, 218, 51, 'PPL', 'P'),
(108174, 'Bennett', 38.8911094665527, 0.678777909944881, -80.565559387207, -1.40613427501779, 218, 58, 'PPL', 'P'),
(114564, 'Bennett', 41.7402801513672, 0.728505319346195, -90.9736099243164, -1.58778902560431, 218, 16, 'PPL', 'P'),
(118776, 'Bennett', 40.0641708374023, 0.699251693194165, -87.8061065673828, -1.53250566295785, 218, 18, 'PPL', 'P'),
(126863, 'Bennett', 46.1133308410645, 0.804829452238021, -68.1116714477539, -1.18877292579992, 218, 26, 'PPL', 'P'),
(134212, 'Bennett', 47.4161109924316, 0.827567255309008, -93.084716796875, -1.62463479139194, 218, 28, 'PPL', 'P'),
(173150, 'Bennett', 46.4486083984375, 0.810681149522225, -91.8533325195313, -1.603143081395, 218, 57, 'PPL', 'P'),
(186402, 'Bennett', 39.7588882446289, 0.693923506801243, -104.426940917969, -1.82259394680414, 218, 7, 'PPL', 'P'),
(188128, 'Bennett', 32.0677795410156, 0.559688336794399, -103.210563659668, -1.80136415870041, 218, 38, 'PPL', 'P'),
(203018, 'Bennett', 40.3738899230957, 0.70465731099578, -109.934722900391, -1.91872287687943, 218, 52, 'PPL', 'P'),
(7403, 'Bennett (historical)', 33.6011085510254, 0.586449976535414, -93.3686065673828, -1.62958960260003, 218, 4, 'PPL', 'P'),
(58626, 'Bennett (historical)', 30.5583305358887, 0.533343481763981, -89.4291687011719, -1.56083344115691, 218, 30, 'PPL', 'P'),
(108175, 'Bennett (historical)', 38.8166694641113, 0.677478686807086, -80.892219543457, -1.41183557027943, 218, 58, 'PPL', 'P'),
(84988, 'Bennett Acres', 35.100830078125, 0.61262505504634, -84.8708267211914, -1.48127536517437, 218, 50, 'PPL', 'P'),
(39354, 'Bennett Bay Landing', 30.9622192382813, 0.540392669432339, -92.461669921875, -1.61376057202893, 218, 22, 'PPL', 'P'),
(99833, 'Bennett Corner', 36.8316688537598, 0.642833890502354, -76.5091705322266, -1.33533693375718, 218, 53, 'PPL', 'P'),
(143517, 'Bennett Corners', 43.8274993896484, 0.76493416726517, -71.3283309936523, -1.24491422579155, 218, 36, 'PPL', 'P'),
(99834, 'Bennett Creek', 36.8638916015625, 0.643396283545551, -76.4861068725586, -1.33493439695841, 218, 53, 'PPL', 'P'),
(99835, 'Bennett Harbor', 36.8497200012207, 0.64314894245931, -76.5013885498047, -1.33520111254158, 218, 53, 'PPL', 'P'),
(26497, 'Bennett Landing', 37.5338897705078, 0.65508995757598, -89.4983291625977, -1.56204051892099, 218, 18, 'PPL', 'P'),
(44766, 'Bennett Manor', 39.3555603027344, 0.686884106249891, -77.1591720581055, -1.34668160052675, 218, 25, 'PPL', 'P'),
(191129, 'Bennett Place (historical)', 30.2241706848145, 0.527511292134762, -103.06861114502, -1.79888661993831, 218, 51, 'PPL', 'P'),
(53426, 'Bennett Springs', 37.7269401550293, 0.658459322408121, -92.8555603027344, -1.62063525606686, 218, 29, 'PPL', 'P'),
(99836, 'Bennett Springs', 37.3702812194824, 0.65223444967617, -80.0377807617188, -1.39692280028137, 218, 53, 'PPL', 'P'),
(79759, 'Bennetts', 35.1588897705078, 0.613638387841115, -82.1730575561523, -1.43419041078566, 218, 48, 'PPL', 'P'),
(147141, 'Bennetts', 42.1888885498047, 0.736335012951028, -77.6211090087891, -1.3547439212528, 218, 40, 'PPL', 'P'),
(7408, 'Bennetts (historical)', 36.4647216796875, 0.636429454133904, -92.1902770996094, -1.60902387371411, 218, 4, 'PPL', 'P'),
(124231, 'Bennetts Corner', 42.0186080932617, 0.733363058332554, -71.0147171020508, -1.23944063080311, 218, 23, 'PPL', 'P'),
(159124, 'Bennetts Corner', 40.2897186279297, 0.703188244759465, -75.100830078125, -1.31075675584407, 218, 45, 'PPL', 'P'),
(147144, 'Bennetts Corners', 43.1949996948242, 0.753894965072628, -78.0175018310547, -1.36166228113261, 218, 40, 'PPL', 'P'),
(154271, 'Bennetts Corners', 41.2763900756836, 0.72040891015819, -81.7852783203125, -1.42742238634939, 218, 41, 'PPL', 'P'),
(99837, 'Bennetts Creek Landing', 36.8777809143066, 0.643638697783776, -76.4899978637695, -1.33500230756621, 218, 53, 'PPL', 'P'),
(19198, 'Bennetts Landing', 32.8019409179688, 0.572501870063206, -82.0436096191406, -1.43193111807489, 218, 13, 'PPL', 'P'),
(70542, 'Bennetts Mill', 39.4244384765625, 0.688086257165953, -74.9116668701172, -1.3074552350407, 218, 37, 'PPL', 'P'),
(99838, 'Bennetts Mill', 37.2616691589355, 0.650338811612252, -80.3391723632813, -1.40218307606649, 218, 53, 'PPL', 'P'),
(144822, 'Bennetts Mills', 40.1288909912109, 0.700381272970522, -74.2755584716797, -1.29635304908838, 218, 37, 'PPL', 'P'),
(44763, 'Bennetts Point', 38.8925018310547, 0.678802211289828, -76.1897201538086, -1.32976147285704, 218, 25, 'PPL', 'P'),
(79760, 'Bennetts Point', 32.5608291625977, 0.568293676066717, -80.454719543457, -1.40419975480195, 218, 48, 'PPL', 'P'),
(122214, 'Bennetts Switch', 40.5849990844727, 0.708341860942932, -86.1127777099609, -1.5029514990768, 218, 19, 'PPL', 'P'),
(147146, 'Bennettsburg', 42.4252815246582, 0.740460848690806, -76.811393737793, -1.34061172377024, 218, 40, 'PPL', 'P'),
(34775, 'Bennettstown', 36.6955604553223, 0.640458350810003, -87.6113891601563, -1.5291072030908, 218, 21, 'PPL', 'P'),
(29199, 'Bennettsville', 38.4255599975586, 0.670652538880022, -85.8086090087891, -1.49764275375984, 218, 19, 'PPL', 'P'),
(79761, 'Bennettsville', 34.6172218322754, 0.60418449886647, -79.6849975585938, -1.3907655718411, 218, 48, 'PPL', 'P'),
(114565, 'Bennettsville', 42.3600006103516, 0.739321481797442, -90.7280578613281, -1.5835033336201, 218, 16, 'PPL', 'P'),
(147145, 'Bennettsville', 42.2555618286133, 0.737498681189338, -75.4469375610352, -1.31679747098664, 218, 40, 'PPL', 'P'),
(345, 'Bennettsville (historical)', 34.038890838623, 0.594090718860906, -86.0722198486328, -1.50224363085906, 218, 2, 'PPL', 'P'),
(134213, 'Bennettville', 46.4019393920898, 0.809866621702824, -93.7486114501953, -1.63622193897876, 218, 28, 'PPL', 'P'),
(13037, 'Benning', 38.8950004577637, 0.678845820552678, -76.9491729736328, -1.34301642507653, 218, 9, 'PPL', 'P'),
(134214, 'Benning', 44.2033309936523, 0.77149366618809, -93.9947204589844, -1.64051735150095, 218, 28, 'PPL', 'P'),
(13038, 'Benning Heights', 38.8816719055176, 0.678613193431459, -76.936393737793, -1.34279338533523, 218, 9, 'PPL', 'P'),
(19199, 'Benning Hills', 32.4119415283203, 0.565695096633072, -84.9352798461914, -1.48240028441882, 218, 13, 'PPL', 'P'),
(19200, 'Benning Park', 32.4322204589844, 0.566049030741944, -84.940559387207, -1.48249242979254, 218, 13, 'PPL', 'P'),
(26498, 'Bennington', 38.524169921875, 0.672373606734485, -88.1313934326172, -1.53818298976968, 218, 18, 'PPL', 'P'),
(29198, 'Bennington', 38.8588905334473, 0.678215583480711, -85.1405563354492, -1.48598303503331, 218, 19, 'PPL', 'P'),
(31799, 'Bennington', 39.0305595397949, 0.681211772865104, -97.5938873291016, -1.7033346637132, 218, 20, 'PPL', 'P'),
(75107, 'Bennington', 34.0044403076172, 0.593489443665793, -96.0374984741211, -1.67617055375244, 218, 42, 'PPL', 'P'),
(129761, 'Bennington', 42.9352798461914, 0.749361998581205, -84.241943359375, -1.47029927989967, 218, 27, 'PPL', 'P'),
(141285, 'Bennington', 41.3647193908691, 0.72195054753421, -96.1575012207031, -1.67826499679174, 218, 35, 'PPL', 'P'),
(143513, 'Bennington', 43.003059387207, 0.750544974737418, -71.9250030517578, -1.25532811776014, 218, 36, 'PPL', 'P'),
(147147, 'Bennington', 42.8369407653809, 0.747645657837676, -78.3977813720703, -1.3682994112013, 218, 40, 'PPL', 'P'),
(171733, 'Bennington', 42.878059387207, 0.748363313172425, -73.1972198486328, -1.27753248966479, 218, 55, 'PPL', 'P'),
(194582, 'Bennington', 42.3911094665527, 0.739864433764682, -111.320831298828, -1.94291503222171, 218, 17, 'PPL', 'P'),
(99839, 'Bennington Mill', 36.723331451416, 0.640943046128397, -81.2291717529297, -1.4177164957566, 218, 53, 'PPL', 'P'),
(203019, 'Bennion', 40.6386108398438, 0.709277562591931, -111.938056945801, -1.95368765198913, 218, 52, 'PPL', 'P'),
(203020, 'Bennion Court Estates', 40.639720916748, 0.709296937088862, -111.94361114502, -1.95378459105281, 218, 52, 'PPL', 'P'),
(203021, 'Bennion Cove', 40.6580581665039, 0.709616982472862, -111.954170227051, -1.95396888180024, 218, 52, 'PPL', 'P'),
(203025, 'Bennion Estates', 40.6341705322266, 0.70920006460421, -111.969436645508, -1.95423533106731, 218, 52, 'PPL', 'P'),
(203022, 'Bennion Park', 40.639720916748, 0.709296937088862, -111.950828552246, -1.95391055857237, 218, 52, 'PPL', 'P'),
(99840, 'Benns Church', 36.9377784729004, 0.644685852724395, -76.5863876342773, -1.33668462642681, 218, 53, 'PPL', 'P'),
(44765, 'Bennsville', 38.6091690063477, 0.673857120619714, -77.0124969482422, -1.34412163692891, 218, 25, 'PPL', 'P'),
(13364, 'Bennum', 38.711109161377, 0.675636311964969, -75.3144378662109, -1.31448491505407, 218, 10, 'PPL', 'P'),
(99841, 'Benny Megeath', 38.9599990844727, 0.679980260598024, -78.1597213745117, -1.36414448042662, 218, 53, 'PPL', 'P'),
(70534, 'Bennys Landing', 39.0672187805176, 0.681851597316996, -74.8130569458008, -1.30573416718624, 218, 37, 'PPL', 'P'),
(350, 'Benoit', 33.7538909912109, 0.589116533155883, -87.1572189331055, -1.52118043726423, 218, 2, 'PPL', 'P'),
(58628, 'Benoit', 33.6513900756836, 0.587327554693623, -91.0094375610352, -1.58841433582826, 218, 30, 'PPL', 'P'),
(92577, 'Benoit', 31.7827796936035, 0.554714151089376, -99.82861328125, -1.74233798945795, 218, 51, 'PPL', 'P'),
(134216, 'Benoit', 47.7016716003418, 0.832551228131037, -96.3944396972656, -1.68240035333241, 218, 28, 'PPL', 'P'),
(173152, 'Benoit', 46.5019416809082, 0.811611990902234, -91.0766677856445, -1.58958772460455, 218, 57, 'PPL', 'P'),
(192960, 'Benonine', 35.2269401550293, 0.614826091108263, -100.014167785645, -1.74557652650154, 218, 51, 'PPL', 'P'),
(77849, 'Benroy', 39.9452781677246, 0.697176624651802, -76.6727828979492, -1.33819250823601, 218, 45, 'PPL', 'P'),
(206816, 'Benroy', 47.2427787780762, 0.824542037468733, -122.245002746582, -2.13357779203737, 218, 56, 'PPL', 'P'),
(195977, 'Benrud (historical)', 48.4524993896484, 0.845655645169908, -105.534172058105, -1.84191877578014, 218, 31, 'PPL', 'P'),
(159126, 'Bens Creek', 40.2825012207031, 0.703062277239905, -78.9366683959961, -1.37770476406508, 218, 45, 'PPL', 'P'),
(108176, 'Bens Run', 39.4658317565918, 0.688808706190664, -81.1086120605469, -1.41561233217933, 218, 58, 'PPL', 'P'),
(159130, 'Bensalem', 40.1044387817383, 0.699954501405837, -74.9516677856445, -1.30815338272046, 218, 45, 'PPL', 'P'),
(118778, 'Bensenville', 41.9550018310547, 0.732252919632154, -87.9400024414063, -1.53484258681439, 218, 18, 'PPL', 'P'),
(99842, 'Bensley', 37.4466705322266, 0.653567694696891, -77.4436111450195, -1.35164599911477, 218, 53, 'PPL', 'P'),
(99843, 'Bensley Village', 37.4366683959961, 0.653393124487436, -77.4461135864258, -1.35168967495664, 218, 53, 'PPL', 'P'),
(642, 'Benson', 39.8974990844727, 0.696342722335471, -92.8583297729492, -1.62068359244064, 218, 29, 'PPL', 'P'),
(34776, 'Benson', 38.2069396972656, 0.666836894828211, -84.9594421386719, -1.48282199597744, 218, 21, 'PPL', 'P'),
(39355, 'Benson', 31.8661098480225, 0.556168536650182, -93.6936111450195, -1.63526200256385, 218, 22, 'PPL', 'P'),
(44768, 'Benson', 39.2738914489746, 0.685458715855453, -76.9508285522461, -1.34304532037436, 218, 25, 'PPL', 'P'),
(58629, 'Benson', 31.5483303070068, 0.550622237363983, -89.2188873291016, -1.55716333885867, 218, 30, 'PPL', 'P'),
(62874, 'Benson', 35.3819389343262, 0.617531330143565, -78.5488891601563, -1.37093673962881, 218, 33, 'PPL', 'P'),
(108177, 'Benson', 39.1619415283203, 0.68350482114269, -80.5519409179688, -1.4058965878905, 218, 58, 'PPL', 'P'),
(114568, 'Benson', 42.5424995422363, 0.742506689040204, -92.5419387817383, -1.61516152792036, 218, 16, 'PPL', 'P'),
(118779, 'Benson', 40.8505592346191, 0.712976759925079, -89.1222229003906, -1.55547622630811, 218, 18, 'PPL', 'P'),
(126865, 'Benson', 45.3594398498535, 0.791671572240266, -69.2961120605469, -1.2094453142875, 218, 26, 'PPL', 'P'),
(129764, 'Benson', 44.208610534668, 0.771585811561807, -85.496940612793, -1.4922031140753, 218, 27, 'PPL', 'P'),
(134217, 'Benson', 45.314998626709, 0.790895926572781, -95.5997161865234, -1.66852981142695, 218, 28, 'PPL', 'P'),
(147149, 'Benson', 43.2519416809082, 0.754888790212419, -74.2788925170898, -1.2964112391582, 218, 40, 'PPL', 'P'),
(159128, 'Benson', 40.2083282470703, 0.701767714634017, -78.9280624389648, -1.3775545617796, 218, 45, 'PPL', 'P'),
(171736, 'Benson', 43.7069396972656, 0.762830003687899, -73.3116683959961, -1.2795299936404, 218, 55, 'PPL', 'P'),
(173153, 'Benson', 45.7172203063965, 0.797916019206229, -92.8555603027344, -1.62063525606686, 218, 57, 'PPL', 'P'),
(193117, 'Benson', 31.9677791595459, 0.557943000884502, -110.293891906738, -1.92499155861131, 218, 5, 'PPL', 'P'),
(203024, 'Benson', 41.7874984741211, 0.72932943454552, -111.929443359375, -1.9535373165456, 218, 52, 'PPL', 'P'),
(347, 'Benson (historical)', 34.0472183227539, 0.594236060877397, -86.158332824707, -1.50374658582024, 218, 2, 'PPL', 'P'),
(188129, 'Benson (historical)', 34.2002792358398, 0.596907477766856, -103.78971862793, -1.81147231977586, 218, 38, 'PPL', 'P'),
(79762, 'Benson Acres', 34.165828704834, 0.596306202571743, -79.8472213745117, -1.39359691155402, 218, 48, 'PPL', 'P'),
(139674, 'Benson Corner', 46.4858283996582, 0.811330761091122, -98.2011108398438, -1.71393271327117, 218, 34, 'PPL', 'P'),
(159129, 'Benson East', 40.0888900756836, 0.699683125290757, -75.1291732788086, -1.31125143801655, 218, 45, 'PPL', 'P'),
(206817, 'Benson Hill', 47.4422187805176, 0.828022922171521, -122.189720153809, -2.13261292877443, 218, 56, 'PPL', 'P'),
(15193, 'Benson Junction', 28.8649997711182, 0.503789284593422, -81.329719543457, -1.4194713857569, 218, 12, 'PPL', 'P'),
(193118, 'Benson Junction', 31.7391700744629, 0.553953019649831, -110.19750213623, -1.92330923975071, 218, 5, 'PPL', 'P'),
(171737, 'Benson Landing', 43.728328704834, 0.763203312293701, -73.3680572509766, -1.28051416482124, 218, 55, 'PPL', 'P'),
(147150, 'Benson Mines', 44.1697196960449, 0.770907038378973, -75.0158309936523, -1.30927324195884, 218, 40, 'PPL', 'P'),
(134219, 'Benson Mobile Manor', 45.3191719055176, 0.790968764028594, -95.591667175293, -1.66838932967945, 218, 28, 'PPL', 'P'),
(129776, 'Benson Park', 44.2036094665527, 0.77149852645708, -83.554443359375, -1.45830014129221, 218, 27, 'PPL', 'P'),
(188130, 'Benson Place', 34.6955604553223, 0.605551765770116, -106.310562133789, -1.85546933888063, 218, 38, 'PPL', 'P'),
(53427, 'Benson Tourist City', 38.3052787780762, 0.66855323557174, -91.0672225952148, -1.58942287493307, 218, 29, 'PPL', 'P'),
(134220, 'Benson''s Mobile Home Park', 43.7619400024414, 0.763789940102818, -91.5744400024414, -1.59827548871261, 218, 28, 'PPL', 'P'),
(147152, 'Bensonhurst', 40.6016693115234, 0.708632811292023, -73.9944381713867, -1.29144657425407, 218, 40, 'PPL', 'P'),
(195978, 'Bensons Landing (historical)', 45.6902809143066, 0.797445838115776, -110.529167175293, -1.9290978866961, 218, 31, 'PPL', 'P'),
(177491, 'Bensted Corner', 41.7063903808594, 0.727913831268088, -72.8802795410156, -1.27200083776458, 218, 8, 'PPL', 'P'),
(34777, 'Bent', 37.1119384765625, 0.647725518213584, -84.4447174072266, -1.47383835467227, 218, 21, 'PPL', 'P'),
(188131, 'Bent', 33.1586112976074, 0.578726942532239, -105.856391906738, -1.84754257305406, 218, 38, 'PPL', 'P'),
(62876, 'Bent Creek', 35.5088882446289, 0.619747013591484, -82.6080627441406, -1.44178268357932, 218, 33, 'PPL', 'P'),
(99844, 'Bent Creek', 37.5347213745117, 0.655104471803921, -78.8272171020508, -1.37579447861517, 218, 53, 'PPL', 'P'),
(99845, 'Bent Mountain', 37.1411094665527, 0.64823464803498, -80.1194381713867, -1.39834799093872, 218, 53, 'PPL', 'P'),
(58630, 'Bent Oak', 33.4386100769043, 0.583613843132534, -88.5427780151367, -1.54536300522659, 218, 30, 'PPL', 'P'),
(19201, 'Bent Pine', 33.6944389343262, 0.588078899016161, -84.7647171020508, -1.47942340295233, 218, 13, 'PPL', 'P'),
(355, 'Bent Tree', 33.8791694641113, 0.591303054989866, -86.7688903808594, -1.51440282544803, 218, 2, 'PPL', 'P'),
(79763, 'Bent Tree', 34.6375007629395, 0.604538432975341, -82.9375, -1.4475324483728, 218, 48, 'PPL', 'P'),
(84990, 'Bent Tree', 35.7724990844727, 0.624347890690705, -84.0111083984375, -1.46627044980259, 218, 50, 'PPL', 'P'),
(84991, 'Bent Tree Acres', 35.2000007629395, 0.614355910017809, -84.9463882446289, -1.48259416254618, 218, 50, 'PPL', 'P'),
(99848, 'Bent Tree Estates', 38.7361106872559, 0.676072670909578, -77.4052810668945, -1.35097701304894, 218, 53, 'PPL', 'P'),
(19202, 'Bentbrook Farms', 33.524169921875, 0.585107144134769, -84.4786071777344, -1.47442984275038, 218, 13, 'PPL', 'P'),
(195979, 'Benteen', 45.4563903808594, 0.793363678217875, -107.39582824707, -1.87441080581771, 218, 31, 'PPL', 'P'),
(19203, 'Bentgrass Farms', 34.1627807617188, 0.596253005928969, -84.2780609130859, -1.47092965012969, 218, 13, 'PPL', 'P'),
(129765, 'Bentheim', 42.7094383239746, 0.745420320430806, -85.9188919067383, -1.49956755343769, 218, 27, 'PPL', 'P'),
(99846, 'Benthill', 37.6877784729004, 0.657775822114352, -77.3402786254883, -1.34984250642456, 218, 53, 'PPL', 'P'),
(99847, 'Bentivar', 38.0999984741211, 0.664970418378229, -78.4263916015625, -1.36879875390569, 218, 53, 'PPL', 'P'),
(31801, 'Bentley', 37.8861083984375, 0.66123733232021, -97.5166702270508, -1.70198697104356, 218, 20, 'PPL', 'P'),
(39357, 'Bentley', 31.5155601501465, 0.550050290230375, -92.4880599975586, -1.61422116573946, 218, 22, 'PPL', 'P'),
(75115, 'Bentley', 34.2147216796875, 0.597159545964032, -96.07861328125, -1.67688814250817, 218, 42, 'PPL', 'P'),
(114569, 'Bentley', 41.3769416809082, 0.722163866737525, -95.620002746582, -1.66888387869388, 218, 16, 'PPL', 'P'),
(118780, 'Bentley', 40.3444404602051, 0.704143320905395, -91.1116714477539, -1.59019865375861, 218, 18, 'PPL', 'P'),
(177352, 'Bentley', 43.9480590820313, 0.767038330842442, -84.1344375610352, -1.46842294975365, 218, 27, 'PPL', 'P'),
(197992, 'Bentley', 46.3291702270508, 0.808596560178965, -102.063056945801, -1.78133638835469, 218, 34, 'PPL', 'P'),
(209301, 'Bentley', 44.1236114501953, 0.770102297676578, -104.674438476563, -1.82691359409225, 218, 59, 'PPL', 'P'),
(154274, 'Bentley (historical)', 41.2097206115723, 0.719245308498907, -80.522216796875, -1.40537780411015, 218, 41, 'PPL', 'P'),
(159132, 'Bentley Creek', 41.9463882446289, 0.732102584188619, -76.7136077880859, -1.33890503698566, 218, 45, 'PPL', 'P'),
(44769, 'Bentley Estates', 39.6847190856934, 0.692629010774383, -76.6819381713867, -1.33835229790142, 218, 25, 'PPL', 'P'),
(356, 'Bentley Hills', 33.5133285522461, 0.584917926539319, -86.7444381713867, -1.51397605388335, 218, 2, 'PPL', 'P'),
(44770, 'Bentley Hills', 39.6827812194824, 0.692595188628539, -76.6819381713867, -1.33835229790142, 218, 25, 'PPL', 'P'),
(44771, 'Bentley Springs', 39.6736106872559, 0.692435132647025, -76.6711120605469, -1.33816334662208, 218, 25, 'PPL', 'P'),
(129767, 'Bentleys Corners', 42.1022186279297, 0.734822337451863, -84.8666687011719, -1.48120279403467, 218, 27, 'PPL', 'P'),
(147153, 'Bentleys Corners', 44.228889465332, 0.771939745670678, -75.6941680908203, -1.32111245774284, 218, 40, 'PPL', 'P'),
(357, 'Bentleyville', 32.9561080932617, 0.575192594870568, -86.2602767944336, -1.50552584374453, 218, 2, 'PPL', 'P'),
(154275, 'Bentleyville', 41.4130592346191, 0.722794236967547, -81.4111099243164, -1.42089191588235, 218, 41, 'PPL', 'P'),
(159138, 'Bentleyville', 40.1166687011719, 0.700167953767206, -80.0086135864258, -1.396413737039, 218, 45, 'PPL', 'P'),
(58632, 'Bently', 33.7574996948242, 0.589179516915664, -89.2324981689453, -1.55740089282791, 218, 30, 'PPL', 'P'),
(358, 'Benton', 32.3066711425781, 0.563857781797027, -86.8177795410156, -1.51525610226129, 218, 2, 'PPL', 'P'),
(7409, 'Benton', 34.5644416809082, 0.603263311445411, -92.586669921875, -1.61594223359392, 218, 4, 'PPL', 'P'),
(13365, 'Benton', 39.8111114501953, 0.694834973684323, -75.5188903808594, -1.31805328459867, 218, 10, 'PPL', 'P'),
(15194, 'Benton', 30.4863891601563, 0.532087867889035, -82.6608276367188, -1.44270360468427, 218, 12, 'PPL', 'P'),
(19204, 'Benton', 34.2619400024414, 0.597983661163357, -85.2983322143555, -1.48873674360045, 218, 13, 'PPL', 'P'),
(26499, 'Benton', 37.9966697692871, 0.663166992267054, -88.9199981689453, -1.55194673891542, 218, 18, 'PPL', 'P'),
(31802, 'Benton', 37.788890838623, 0.659540565810693, -97.1083297729492, -1.6948600856504, 218, 20, 'PPL', 'P'),
(34778, 'Benton', 36.8572196960449, 0.643279836826888, -88.3502807617188, -1.5420032943534, 218, 21, 'PPL', 'P'),
(39356, 'Benton', 32.6947212219238, 0.570630533344235, -93.7416687011719, -1.63610076514917, 218, 22, 'PPL', 'P'),
(53429, 'Benton', 38.6186103820801, 0.674021903712163, -90.3033294677734, -1.57609042472587, 218, 29, 'PPL', 'P'),
(58633, 'Benton', 32.8263893127441, 0.572928575048864, -90.2594375610352, -1.5753243664383, 218, 30, 'PPL', 'P'),
(84992, 'Benton', 35.1741714477539, 0.613905103424286, -84.6536102294922, -1.47748422220459, 218, 50, 'PPL', 'P'),
(114570, 'Benton', 40.7033309936523, 0.710407142368289, -94.3580627441406, -1.64685887068865, 218, 16, 'PPL', 'P'),
(122215, 'Benton', 41.5091705322266, 0.724471695559161, -85.7611083984375, -1.4968137117125, 218, 19, 'PPL', 'P'),
(126866, 'Benton', 44.586109161377, 0.778174405519636, -69.5513916015625, -1.2139007827912, 218, 26, 'PPL', 'P'),
(129768, 'Benton', 42.1288909912109, 0.735287858010408, -83.8622207641602, -1.46367187036895, 218, 27, 'PPL', 'P'),
(134223, 'Benton', 44.7761116027832, 0.781490573709002, -93.7808303833008, -1.63678426544293, 218, 28, 'PPL', 'P'),
(143515, 'Benton', 44.1030616760254, 0.769743636456772, -71.9022216796875, -1.25493050780939, 218, 36, 'PPL', 'P'),
(147154, 'Benton', 42.7174987792969, 0.745561001915389, -77.0438919067383, -1.3446695823232, 218, 40, 'PPL', 'P'),
(154278, 'Benton', 40.6025009155273, 0.708647325519964, -81.8469390869141, -1.42849856974589, 218, 41, 'PPL', 'P'),
(159134, 'Benton', 41.1949996948242, 0.718988380032742, -76.3838882446289, -1.33315034534417, 218, 45, 'PPL', 'P'),
(173154, 'Benton', 42.5697212219238, 0.742981796978675, -90.3805618286133, -1.57743838371161, 218, 57, 'PPL', 'P'),
(180045, 'Benton', 37.8191719055176, 0.66006907012902, -118.475563049316, -2.0677886583647, 218, 6, 'PPL', 'P'),
(186404, 'Benton', 37.9049987792969, 0.661567031663162, -103.656669616699, -1.80915017646337, 218, 7, 'PPL', 'P'),
(84993, 'Benton (historical)', 35.4124984741211, 0.618064694730881, -86.8041687011719, -1.51501854829206, 218, 50, 'PPL', 'P'),
(129769, 'Benton Center', 42.1238899230957, 0.735200572905681, -86.3786087036133, -1.50759112516988, 218, 27, 'PPL', 'P'),
(147155, 'Benton Center', 42.7172203063965, 0.7455561416464, -77.0669403076172, -1.34507185280585, 218, 40, 'PPL', 'P'),
(53430, 'Benton City', 39.1344413757324, 0.68302485293523, -91.7649993896484, -1.60160137743995, 218, 29, 'PPL', 'P'),
(206818, 'Benton City', 46.2633285522461, 0.807447406168596, -119.486671447754, -2.08543582901201, 218, 56, 'PPL', 'P'),
(114571, 'Benton City (historical)', 42.1583290100098, 0.735801648363712, -91.9336090087891, -1.60454417044449, 218, 16, 'PPL', 'P'),
(147156, 'Benton Corners', 41.6983299255371, 0.727773149783504, -74.192497253418, -1.29490335734899, 218, 40, 'PPL', 'P'),
(180046, 'Benton Crossing', 37.6991691589355, 0.657974627089727, -118.763061523438, -2.07280645333258, 218, 6, 'PPL', 'P'),
(19205, 'Benton Crossing (historical)', 33.2955589294434, 0.581117129610585, -83.6913909912109, -1.46069032837055, 218, 13, 'PPL', 'P'),
(84995, 'Benton Cut', 36.2483291625977, 0.632652692234008, -88.0336074829102, -1.5364763029851, 218, 50, 'PPL', 'P'),
(126867, 'Benton Falls', 44.577220916748, 0.778019276386139, -69.5536117553711, -1.21393953178506, 218, 26, 'PPL', 'P'),
(19206, 'Benton Harbor', 33.6833305358887, 0.587885020888803, -84.2094421386719, -1.46973202658748, 218, 13, 'PPL', 'P'),
(129770, 'Benton Harbor', 42.1166687011719, 0.735074538807093, -86.4541702270508, -1.50890992254169, 218, 27, 'PPL', 'P'),
(129772, 'Benton Heights', 42.1311111450195, 0.735326607004269, -86.4072189331055, -1.50809046787427, 218, 27, 'PPL', 'P'),
(180047, 'Benton Hot Springs', 37.8002815246582, 0.659739370786068, -118.528060913086, -2.06870491893775, 218, 6, 'PPL', 'P'),
(29203, 'Benton House', 39.764720916748, 0.694025306133911, -86.0763931274414, -1.50231646831487, 218, 19, 'PPL', 'P'),
(195980, 'Benton Lake (historical)', 47.6916694641113, 0.832376657921582, -111.29167175293, -1.94240610213739, 218, 31, 'PPL', 'P'),
(26501, 'Benton Park', 38.0597190856934, 0.664267410429475, -88.9147186279297, -1.55185459354171, 218, 18, 'PPL', 'P'),
(154279, 'Benton Ridge', 41.0047187805176, 0.715667351574386, -83.7941665649414, -1.46248410052277, 218, 41, 'PPL', 'P'),
(84996, 'Benton Springs', 35.146671295166, 0.613425135216827, -84.6213912963867, -1.47692189574042, 218, 50, 'PPL', 'P'),
(84997, 'Benton Station', 35.1875, 0.614137730545505, -84.6833267211914, -1.47800287282688, 218, 50, 'PPL', 'P'),
(126868, 'Benton Station', 44.589168548584, 0.778227801899492, -69.585563659668, -1.21449719771732, 218, 26, 'PPL', 'P'),
(114573, 'Benton Station (historical)', 42.1452789306641, 0.735573881511483, -92.1444396972656, -1.60822386012265, 218, 16, 'PPL', 'P'),
(44772, 'Benton Terrace', 39.2013893127441, 0.684193314863502, -76.647216796875, -1.33774629559537, 218, 25, 'PPL', 'P'),
(58635, 'Bentonia', 32.6408309936523, 0.569689971426246, -90.3647232055664, -1.57716194759046, 218, 30, 'PPL', 'P'),
(62880, 'Bentons Crossroads', 35.103889465332, 0.612678451426196, -80.5366668701172, -1.40563000546538, 218, 33, 'PPL', 'P'),
(108178, 'Bentons Ferry', 39.4377784729004, 0.688319084024253, -80.1677780151367, -1.39919168037206, 218, 58, 'PPL', 'P'),
(44773, 'Bentons Pleasure', 38.9530601501465, 0.679859153347453, -76.3024978637695, -1.33172981521872, 218, 25, 'PPL', 'P'),
(114583, 'Bentonsport', 40.7255592346191, 0.710795098360086, -91.8536071777344, -1.60314787508496, 218, 16, 'PPL', 'P'),
(647, 'Bentonville', 38.1005592346191, 0.664980205495235, -93.4488906860352, -1.63099082480758, 218, 29, 'PPL', 'P'),
(7414, 'Bentonville', 36.3727798461914, 0.634824766419077, -94.208610534668, -1.64425043755897, 218, 4, 'PPL', 'P'),
(29201, 'Bentonville', 39.7452812194824, 0.693686019411035, -85.1941680908203, -1.48691873668231, 218, 19, 'PPL', 'P'),
(62882, 'Bentonville', 35.3486099243164, 0.616949629182465, -78.2972183227539, -1.36654425488489, 218, 33, 'PPL', 'P'),
(71800, 'Bentonville', 38.749439239502, 0.676305298030797, -83.6133270263672, -1.45932785515687, 218, 41, 'PPL', 'P'),
(92578, 'Bentonville', 27.7755603790283, 0.484774980200528, -97.9577789306641, -1.70968577028082, 218, 51, 'PPL', 'P'),
(99849, 'Bentonville', 38.8316688537598, 0.67774047554224, -78.3166732788086, -1.36688380792387, 218, 53, 'PPL', 'P'),
(92579, 'Bentonville Acres Colonia', 27.7390003204346, 0.484136886803345, -97.9570007324219, -1.70967218815926, 218, 51, 'PPL', 'P'),
(118782, 'Bentown', 40.4719390869141, 0.706368591733238, -88.8063888549805, -1.54996388232581, 218, 18, 'PPL', 'P'),
(108179, 'Bentree', 38.2836112976074, 0.668175066696948, -81.1911087036133, -1.41705217022268, 218, 58, 'PPL', 'P'),
(92580, 'Bentsen Colonia', 26.2150001525879, 0.457538066073475, -98.2699966430664, -1.71513499734528, 218, 51, 'PPL', 'P'),
(92581, 'Bentsen Palm RV Park Number 2 Colonia', 26.2549991607666, 0.458236180463725, -98.370002746582, -1.71688043312372, 218, 51, 'PPL', 'P'),
(79765, 'Bentway Park', 34.9361114501953, 0.609750172649599, -81.8708267211914, -1.42891548761454, 218, 48, 'PPL', 'P'),
(44774, 'Bentwillow Heights', 39.1938896179199, 0.684062420495925, -76.6302795410156, -1.33745068471437, 218, 25, 'PPL', 'P'),
(19207, 'Bentwood', 34.2388916015625, 0.5975813906807, -83.8919372558594, -1.46419052099124, 218, 13, 'PPL', 'P'),
(15195, 'Bentwood Grove', 28.7569408416748, 0.501903300488455, -81.2719421386719, -1.41846297981015, 218, 12, 'PPL', 'P'),
(44775, 'Bentwoods', 39.1805610656738, 0.683829793374707, -76.7125015258789, -1.33888572906776, 218, 25, 'PPL', 'P'),
(159139, 'Benvenue', 40.4038887023926, 0.70518088846609, -77.0097198486328, -1.34407316739707, 218, 45, 'PPL', 'P'),
(177490, 'Benvenue (historical)', 41.5605583190918, 0.725368581635272, -72.5819396972656, -1.26679382520126, 218, 8, 'PPL', 'P'),
(26503, 'Benville', 39.8641700744629, 0.695761021374371, -90.8647232055664, -1.58588859385043, 218, 18, 'PPL', 'P'),
(29202, 'Benwood', 39.5611114501953, 0.690471650554337, -87.1141662597656, -1.52042902636266, 218, 19, 'PPL', 'P'),
(58636, 'Benwood', 33.940559387207, 0.592374511275432, -89.5158309936523, -1.56234598349802, 218, 30, 'PPL', 'P'),
(71801, 'Benwood', 39.6858291625977, 0.692648385271313, -81.0005569458008, -1.41372641465339, 218, 41, 'PPL', 'P'),
(177183, 'Benwood', 40.0180587768555, 0.698446885912743, -80.7344436645508, -1.40908186171229, 218, 58, 'PPL', 'P'),
(177184, 'Benwood Junction', 40.0055618286133, 0.698228773019465, -80.7344436645508, -1.40908186171229, 218, 58, 'PPL', 'P'),
(195981, 'Benz', 46.6597213745117, 0.814365766048404, -105.500831604004, -1.84133687508196, 218, 31, 'PPL', 'P'),
(7415, 'Benzal', 33.9988899230957, 0.593392571181142, -91.1613922119141, -1.59106644479982, 218, 4, 'PPL', 'P'),
(195982, 'Benzien', 47.2555618286133, 0.824765143789054, -107.679443359375, -1.87936082333584, 218, 31, 'PPL', 'P'),
(129777, 'Benzonia', 44.6213912963867, 0.778790194942689, -86.0991668701172, -1.50271394510757, 218, 27, 'PPL', 'P'),
(199832, 'Beowawe', 40.5927810668945, 0.708477682158526, -116.476387023926, -2.0328964543947, 218, 39, 'PPL', 'P'),
(58637, 'Beppo (historical)', 30.2444400787354, 0.527865059796065, -89.5194396972656, -1.5624089672578, 218, 30, 'PPL', 'P'),
(366, 'Bera (historical)', 33.7061080932617, 0.588282564260525, -85.9255599975586, -1.49968393357733, 218, 2, 'PPL', 'P'),
(39358, 'Berard', 29.9888896942139, 0.523404864181428, -91.788330078125, -1.60200857477063, 218, 22, 'PPL', 'P'),
(75110, 'Berch Hole', 35.827220916748, 0.625302966836635, -95.100830078125, -1.65982260624294, 218, 42, 'PPL', 'P'),
(19208, 'Berckman Hills', 33.4983291625977, 0.584656137804164, -82.033332824707, -1.43175175417548, 218, 13, 'PPL', 'P'),
(19209, 'Berckman Villas', 33.4963912963867, 0.58462231565832, -82.029167175293, -1.43167904987772, 218, 13, 'PPL', 'P'),
(58638, 'Berclair', 33.4716682434082, 0.5841908169827, -90.3649978637695, -1.57716674128042, 218, 30, 'PPL', 'P'),
(84998, 'Berclair', 35.148609161377, 0.613458957362671, -89.9077835083008, -1.56918684539011, 218, 50, 'PPL', 'P'),
(92582, 'Berclair', 28.5305595397949, 0.4979522014057, -97.5908279418945, -1.70328126733334, 218, 51, 'PPL', 'P'),
(26504, 'Berdan', 39.3650016784668, 0.68704888934234, -90.3952789306641, -1.57769524559875, 218, 18, 'PPL', 'P'),
(53440, 'Berdell Hills', 38.7180595397949, 0.675757618952622, -90.2916717529297, -1.57588695921858, 218, 29, 'PPL', 'P'),
(144823, 'Berdines Corners', 40.4672203063965, 0.706286233476527, -74.4538879394531, -1.29946548545435, 218, 37, 'PPL', 'P'),
(7416, 'Berea', 33.339168548584, 0.58187826105013, -91.7005615234375, -1.60047672451161, 218, 4, 'PPL', 'P'),
(34779, 'Berea', 37.5686111450195, 0.655695959882028, -84.29638671875, -1.47124949577661, 218, 21, 'PPL', 'P'),
(62883, 'Berea', 36.3205604553223, 0.633913366115024, -78.741943359375, -1.37430617103998, 218, 33, 'PPL', 'P'),
(79766, 'Berea', 34.8852806091309, 0.608863007111467, -82.4561080932617, -1.43913057460776, 218, 48, 'PPL', 'P'),
(85000, 'Berea', 35.8088912963867, 0.624983054610689, -85.7044372558594, -1.49582461368364, 218, 50, 'PPL', 'P'),
(92584, 'Berea', 32.8061103820801, 0.572574640939992, -94.4019393920898, -1.6476246626601, 218, 51, 'PPL', 'P'),
(99850, 'Berea', 38.3619384765625, 0.669542133863513, -77.5199966430664, -1.35297917755646, 218, 53, 'PPL', 'P'),
(108180, 'Berea', 39.1363906860352, 0.683058874818156, -80.9338912963867, -1.41256287957313, 218, 58, 'PPL', 'P'),
(114584, 'Berea', 41.3741683959961, 0.722115463784713, -94.6800003051758, -1.65247774111455, 218, 16, 'PPL', 'P'),
(139665, 'Berea', 46.9341697692871, 0.819155794164047, -98.0947189331055, -1.71207582420111, 218, 34, 'PPL', 'P'),
(147158, 'Berea', 41.524169921875, 0.724733484294315, -74.1800003051758, -1.29468524445572, 218, 40, 'PPL', 'P'),
(154282, 'Berea', 41.3661117553711, 0.721974848879157, -81.8544387817383, -1.42862946411347, 218, 41, 'PPL', 'P'),
(199176, 'Berea', 42.214168548584, 0.736776232164626, -102.979721069336, -1.79733519544529, 218, 35, 'PPL', 'P'),
(58639, 'Berea (historical)', 33.2388916015625, 0.580128098160757, -89.4388885498047, -1.56100308451835, 218, 30, 'PPL', 'P'),
(85001, 'Berea (historical)', 35.7916717529297, 0.624682516881673, -86.0875015258789, -1.50251034644223, 218, 50, 'PPL', 'P'),
(79768, 'Berea Heights', 34.8833312988281, 0.608828985228541, -82.4638900756836, -1.43926639582335, 218, 48, 'PPL', 'P'),
(15196, 'Bereah', 27.6608295440674, 0.482772549376898, -81.6258316040039, -1.42463951616831, 218, 12, 'PPL', 'P'),
(44776, 'Berean', 39.5711097717285, 0.690646154184764, -76.7405624389648, -1.33937548439223, 218, 25, 'PPL', 'P'),
(180048, 'Berenda', 37.0402793884277, 0.646474831186656, -120.152496337891, -2.09705666558662, 218, 6, 'PPL', 'P'),
(194583, 'Berenice', 43.8277816772461, 0.764939094113187, -112.973327636719, -1.97175653419505, 218, 17, 'PPL', 'P'),
(15197, 'Beresford', 29.0022201538086, 0.506184232072216, -81.3475036621094, -1.41978177718195, 218, 12, 'PPL', 'P'),
(169826, 'Beresford', 43.0805587768555, 0.751897594255069, -96.7733306884766, -1.68901324863519, 218, 49, 'PPL', 'P'),
(92585, 'Beretta Estates Colonia', 26.3299999237061, 0.459545190718526, -98.1729965209961, -1.71344202584032, 218, 51, 'PPL', 'P'),
(192892, 'Berg', 39.1808280944824, 0.683834453906614, -121.626388549805, -2.12278093750402, 218, 6, 'PPL', 'P'),
(159141, 'Berge Run', 41.4883308410645, 0.724107974333283, -78.0519409179688, -1.36226335659064, 218, 45, 'PPL', 'P'),
(134227, 'Bergen', 43.7900009155273, 0.764279695427283, -94.9944381713867, -1.65796571717288, 218, 28, 'PPL', 'P'),
(147159, 'Bergen', 43.0852813720703, 0.751980019090807, -77.942497253418, -1.36035320429878, 218, 40, 'PPL', 'P'),
(173157, 'Bergen', 42.4938888549805, 0.741658272495932, -88.8652801513672, -1.55099172934852, 218, 57, 'PPL', 'P'),
(197993, 'Bergen', 48.0016708374023, 0.837787202571215, -100.714172363281, -1.75779391116034, 218, 34, 'PPL', 'P'),
(147161, 'Bergen Beach', 42.6147193908691, 0.743767163184139, -76.6830596923828, -1.33837187213543, 218, 40, 'PPL', 'P'),
(173158, 'Bergen Beach', 43.8605613708496, 0.765511207694363, -88.3708267211914, -1.54236188899418, 218, 57, 'PPL', 'P'),
(144826, 'Bergen Mills', 40.2627792358398, 0.702718063669012, -74.4197235107422, -1.29886920368628, 218, 37, 'PPL', 'P'),
(186405, 'Bergen Park', 39.6913909912109, 0.692745457493047, -105.361106872559, -1.83889821847177, 218, 7, 'PPL', 'P'),
(144827, 'Bergen Point', 40.6474990844727, 0.709432691725429, -74.1416702270508, -1.29401625838989, 218, 37, 'PPL', 'P'),
(144828, 'Bergenfield', 40.9275016784668, 0.714319658904751, -73.9977798461914, -1.29150489748194, 218, 37, 'PPL', 'P'),
(7417, 'Berger', 34.6627807617188, 0.60497965218894, -92.3077774047852, -1.61107464091153, 218, 4, 'PPL', 'P'),
(53441, 'Berger', 38.6741714477539, 0.674991627244088, -91.3386077880859, -1.59415944008983, 218, 29, 'PPL', 'P'),
(112578, 'Berger', 31.163610458374, 0.543907609307566, -97.3194427490234, -1.69854470217658, 218, 51, 'PPL', 'P'),
(118783, 'Berger', 41.6236114501953, 0.72646906637672, -87.5919418334961, -1.52876778320987, 218, 18, 'PPL', 'P'),
(154284, 'Berger', 40.5361099243164, 0.707488584129671, -82.3777770996094, -1.43776344086217, 218, 41, 'PPL', 'P'),
(194584, 'Berger', 42.4697189331055, 0.741236427779264, -114.573890686035, -1.99969162929138, 218, 17, 'PPL', 'P'),
(144830, 'Bergerville', 40.2019386291504, 0.70165619476337, -74.2619400024414, -1.29611536196109, 218, 37, 'PPL', 'P'),
(159142, 'Bergey', 40.3022193908691, 0.70340642423177, -75.4230575561523, -1.31638068627605, 218, 45, 'PPL', 'P'),
(92586, 'Bergheim', 29.827220916748, 0.520583211716975, -98.5749969482422, -1.72045825689019, 218, 51, 'PPL', 'P'),
(147163, 'Bergholtz', 43.1030616760254, 0.752290343936828, -78.9069366455078, -1.37718584712668, 218, 40, 'PPL', 'P'),
(154285, 'Bergholz', 40.5194396972656, 0.70719763378058, -80.8841705322266, -1.41169508853193, 218, 41, 'PPL', 'P'),
(19210, 'Berginville', 32.2844390869141, 0.563469759226202, -84.5894393920898, -1.47636422980816, 218, 13, 'PPL', 'P'),
(129780, 'Bergland', 46.5924987792969, 0.813192510430169, -89.5730590820313, -1.56334480206485, 218, 27, 'PPL', 'P'),
(7418, 'Bergman', 36.3161087036133, 0.633835668390221, -93.0074996948242, -1.6232870987223, 218, 4, 'PPL', 'P'),
(85002, 'Bergmantown', 35.355281829834, 0.617066075901129, -85.7758331298828, -1.49707070675769, 218, 50, 'PPL', 'P'),
(108181, 'Bergoo', 38.4863891601563, 0.671714208048582, -80.3008270263672, -1.40151382368455, 218, 58, 'PPL', 'P'),
(92592, 'Bergs Mill', 29.3352794647217, 0.511997213652073, -98.4527816772461, -1.71832519801509, 218, 51, 'PPL', 'P'),
(134229, 'Bergs Mobile Home Park', 45.8136100769043, 0.799598338066833, -96.4997177124023, -1.68423780132651, 218, 28, 'PPL', 'P'),
(194585, 'Bergstrom Place', 42.1944389343262, 0.736431885435679, -114.935829162598, -2.00600864739705, 218, 17, 'PPL', 'P'),
(99851, 'Bergton', 38.7655601501465, 0.676586660999964, -78.9491729736328, -1.37792301011642, 218, 53, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(134230, 'Bergville', 47.7874984741211, 0.834049189665179, -94.2641677856445, -1.64522009451187, 218, 28, 'PPL', 'P'),
(92587, 'Bering', 30.8833293914795, 0.539015781859254, -94.8638916015625, -1.65568724970226, 218, 51, 'PPL', 'P'),
(188132, 'Berino', 32.0708312988281, 0.5597416000162, -106.620826721191, -1.86088447748314, 218, 38, 'PPL', 'P'),
(15198, 'Berkeley', 28.5025005340576, 0.497462479370748, -82.5888900756836, -1.44144805738835, 218, 12, 'PPL', 'P'),
(53442, 'Berkeley', 38.7544403076172, 0.676392583135524, -90.3311080932617, -1.57657525320231, 218, 29, 'PPL', 'P'),
(99853, 'Berkeley', 37.3180618286133, 0.651323049372118, -77.1797180175781, -1.34704019516753, 218, 53, 'PPL', 'P'),
(108182, 'Berkeley', 39.503059387207, 0.689458450917616, -77.9274978637695, -1.36009141556363, 218, 58, 'PPL', 'P'),
(118784, 'Berkeley', 41.8888893127441, 0.73109903851085, -87.9033279418945, -1.53420249604639, 218, 18, 'PPL', 'P'),
(169279, 'Berkeley', 41.9297218322754, 0.731811700418555, -71.4233322143555, -1.24657230988624, 218, 47, 'PPL', 'P'),
(180049, 'Berkeley', 37.8716697692871, 0.660985330702061, -122.271667480469, -2.13404317943786, 218, 6, 'PPL', 'P'),
(206820, 'Berkeley', 47.0741691589355, 0.821599244464195, -122.334167480469, -2.13513401022036, 218, 56, 'PPL', 'P'),
(79769, 'Berkeley Country Club Subdivision', 33.1472206115723, 0.578528137556865, -80.0097198486328, -1.3964330449569, 218, 48, 'PPL', 'P'),
(13366, 'Berkeley Farms', 39.7555618286133, 0.693865449889479, -75.7388916015625, -1.32189303025835, 218, 10, 'PPL', 'P'),
(144831, 'Berkeley Heights', 40.6833305358887, 0.710058068528406, -74.4430618286133, -1.29927653417501, 218, 37, 'PPL', 'P'),
(19211, 'Berkeley Hills', 33.9438896179199, 0.592432634766223, -84.1697235107422, -1.46903880575573, 218, 13, 'PPL', 'P'),
(79772, 'Berkeley Hills', 32.917781829834, 0.574523675383767, -80.0052795410156, -1.39635554696918, 218, 48, 'PPL', 'P'),
(99854, 'Berkeley Hills', 37.2597198486328, 0.650304789729326, -76.730827331543, -1.33920557471468, 218, 53, 'PPL', 'P'),
(159147, 'Berkeley Hills', 40.5316696166992, 0.707411086141949, -80.0038909912109, -1.39633131220326, 218, 45, 'PPL', 'P'),
(19212, 'Berkeley Lake', 33.9836082458496, 0.59312585559797, -84.1866683959961, -1.46933454979479, 218, 13, 'PPL', 'P'),
(19213, 'Berkeley Manor', 33.9672203063965, 0.592839832096896, -84.1638870239258, -1.46893693984404, 218, 13, 'PPL', 'P'),
(99857, 'Berkeley Manor', 37.1861114501953, 0.649020080819472, -77.3472213745117, -1.34996368025416, 218, 53, 'PPL', 'P'),
(108184, 'Berkeley Place', 39.4505615234375, 0.688542190344575, -77.9602813720703, -1.36066359572383, 218, 58, 'PPL', 'P'),
(13367, 'Berkeley Ridge', 39.7819404602051, 0.694325843862927, -75.6805572509766, -1.32087490377361, 218, 10, 'PPL', 'P'),
(70535, 'Berkeley Shores', 39.9124984741211, 0.696604511070626, -74.1333312988281, -1.29387071663632, 218, 37, 'PPL', 'P'),
(108185, 'Berkeley Springs', 39.6269416809082, 0.691620604827624, -78.2275009155273, -1.36532745658283, 218, 58, 'PPL', 'P'),
(154286, 'Berkey', 41.7155609130859, 0.728073887249602, -83.8394393920898, -1.4632742604182, 218, 41, 'PPL', 'P'),
(44777, 'Berkfield', 39.3283309936523, 0.686408865153367, -76.4980621337891, -1.33514305562982, 218, 25, 'PPL', 'P'),
(372, 'Berkley', 34.639720916748, 0.604577181969202, -86.4291687011719, -1.50847356359708, 218, 2, 'PPL', 'P'),
(34784, 'Berkley', 36.8036117553711, 0.642344201756915, -89.0822219848633, -1.55477807862834, 218, 21, 'PPL', 'P'),
(44778, 'Berkley', 39.6613883972168, 0.69222181344371, -76.2091674804688, -1.33010089273797, 218, 25, 'PPL', 'P'),
(99858, 'Berkley', 36.8316688537598, 0.642833890502354, -76.2841720581055, -1.3314099695718, 218, 53, 'PPL', 'P'),
(114585, 'Berkley', 41.9449996948242, 0.732078349422699, -94.1144409179688, -1.64260686769223, 218, 16, 'PPL', 'P'),
(124232, 'Berkley', 41.8458290100098, 0.73034749445123, -71.0833282470703, -1.24063812118727, 218, 23, 'PPL', 'P'),
(129782, 'Berkley', 42.503059387207, 0.741818328477446, -83.1836090087891, -1.45182786089499, 218, 27, 'PPL', 'P'),
(159143, 'Berkley', 40.4291687011719, 0.705622107679689, -75.9347229003906, -1.32531093120135, 218, 45, 'PPL', 'P'),
(186406, 'Berkley', 39.8044395446777, 0.694718526965659, -105.02555847168, -1.83304179407663, 218, 7, 'PPL', 'P'),
(124233, 'Berkley Bridge', 41.8333282470703, 0.730129314978925, -71.1066665649414, -1.24104545167599, 218, 23, 'PPL', 'P'),
(44779, 'Berkley Estates', 39.4049987792969, 0.687746970443077, -76.9583282470703, -1.34317621474193, 218, 25, 'PPL', 'P'),
(373, 'Berkley Hills', 33.6172218322754, 0.586731206346527, -86.6969375610352, -1.51314701183601, 218, 2, 'PPL', 'P'),
(19214, 'Berkley Hills', 33.9205589294434, 0.59202543743555, -83.3988876342773, -1.45558518171892, 218, 13, 'PPL', 'P'),
(77851, 'Berkleys Mill', 39.8452796936035, 0.695431322031419, -79, -1.37881010907552, 218, 45, 'PPL', 'P'),
(99859, 'Berkmar', 38.0811080932617, 0.664640719035277, -78.4786071777344, -1.36971008763072, 218, 53, 'PPL', 'P'),
(141290, 'Berks', 40.6586112976074, 0.709626636431814, -96.913330078125, -1.69145669893533, 218, 35, 'PPL', 'P'),
(44781, 'Berkshire', 38.8505592346191, 0.678070174885192, -76.894172668457, -1.34205648866161, 218, 25, 'PPL', 'P'),
(99860, 'Berkshire', 38.8977813720703, 0.678894356663544, -77.1516723632813, -1.34655070615917, 218, 53, 'PPL', 'P'),
(124235, 'Berkshire', 42.5125007629395, 0.741983111569895, -73.1933288574219, -1.27746457905699, 218, 23, 'PPL', 'P'),
(147165, 'Berkshire', 42.3041687011719, 0.738347031154582, -76.1869430541992, -1.3297130033252, 218, 40, 'PPL', 'P'),
(154287, 'Berkshire', 40.2652816772461, 0.702761739510889, -82.9088897705078, -1.44703310566841, 218, 41, 'PPL', 'P'),
(171739, 'Berkshire', 44.9716682434082, 0.784903680962048, -72.7758331298828, -1.27017790399843, 218, 55, 'PPL', 'P'),
(177489, 'Berkshire', 41.4086112976074, 0.722716605821771, -73.2600021362305, -1.2786282472953, 218, 8, 'PPL', 'P'),
(19215, 'Berkshire (historical)', 33.9122200012207, 0.591879895681977, -84.1324996948242, -1.46838912760781, 218, 13, 'PPL', 'P'),
(19216, 'Berkshire Estates', 34.269718170166, 0.598119415799923, -85.1297225952148, -1.48579395059591, 218, 13, 'PPL', 'P'),
(177492, 'Berkshire Estates', 41.4425010681152, 0.723308093899878, -73.2588882446289, -1.27860880621934, 218, 8, 'PPL', 'P'),
(85005, 'Berkshire Forest', 36.0083312988281, 0.628463939313477, -84.8583297729492, -1.4810572522811, 218, 50, 'PPL', 'P'),
(124237, 'Berkshire Heights', 42.1888885498047, 0.736335012951028, -73.3694381713867, -1.28053826642911, 218, 23, 'PPL', 'P'),
(62889, 'Berkshire Hills', 35.7811088562012, 0.624498159555213, -80.866943359375, -1.41139441764486, 218, 33, 'PPL', 'P'),
(159146, 'Berkshire Hills', 40.139720916748, 0.70057029082889, -77.0299987792969, -1.34442710150594, 218, 45, 'PPL', 'P'),
(99861, 'Berkshire Meadows', 36.7761116027832, 0.641864233549456, -76.5872192382813, -1.33669914065475, 218, 53, 'PPL', 'P'),
(147166, 'Berkshire Terrace', 41.4958305358887, 0.72423886870086, -73.7024993896484, -1.28635128129848, 218, 40, 'PPL', 'P'),
(144833, 'Berkshire Valley', 40.9300003051758, 0.714363268167601, -74.5911102294922, -1.30186046622266, 218, 37, 'PPL', 'P'),
(85003, 'Berkshire Wood', 35.9463882446289, 0.627382829068959, -84.0863876342773, -1.46758432032639, 218, 50, 'PPL', 'P'),
(129784, 'Berlamont', 42.3899993896484, 0.739845059267752, -85.9938888549805, -1.50087649711347, 218, 27, 'PPL', 'P'),
(122218, 'Berlien', 41.6366691589355, 0.726696966387003, -84.8766708374023, -1.48137736424412, 218, 19, 'PPL', 'P'),
(377, 'Berlin', 32.2591705322266, 0.563028739749685, -87.0083312988281, -1.51858185783059, 218, 2, 'PPL', 'P'),
(7419, 'Berlin', 33.0805587768555, 0.577364669055636, -91.7630615234375, -1.60156755529411, 218, 4, 'PPL', 'P'),
(19218, 'Berlin', 31.0680599212646, 0.542239937832958, -83.623893737793, -1.45951227906235, 218, 13, 'PPL', 'P'),
(26505, 'Berlin', 39.7588882446289, 0.693923506801243, -89.9030609130859, -1.56910442055437, 218, 18, 'PPL', 'P'),
(31806, 'Berlin', 37.9213905334473, 0.661853121743264, -94.8958282470703, -1.65624464931842, 218, 20, 'PPL', 'P'),
(34780, 'Berlin', 38.6947212219238, 0.675350288463894, -84.1624984741211, -1.46891270507812, 218, 21, 'PPL', 'P'),
(44782, 'Berlin', 38.3224983215332, 0.668853773300755, -75.2180633544922, -1.31280286250958, 218, 25, 'PPL', 'P'),
(70537, 'Berlin', 39.7911109924316, 0.694485899844441, -74.929443359375, -1.30776549330769, 218, 37, 'PPL', 'P'),
(75111, 'Berlin', 35.4505615234375, 0.618729020264801, -99.625, -1.73878426729935, 218, 42, 'PPL', 'P'),
(77852, 'Berlin', 39.9205589294434, 0.696745192555209, -78.9580612182617, -1.37807813924991, 218, 45, 'PPL', 'P'),
(79773, 'Berlin', 33.6736106872559, 0.587715377527365, -81.3038864135742, -1.41902051258435, 218, 48, 'PPL', 'P'),
(85004, 'Berlin', 35.5297203063965, 0.620110601659307, -86.8244400024414, -1.51537234924288, 218, 50, 'PPL', 'P'),
(92588, 'Berlin', 30.1711101531982, 0.5265852111552, -96.445556640625, -1.68329251229759, 218, 51, 'PPL', 'P'),
(99865, 'Berlin', 36.8574981689453, 0.643284697095877, -76.977783203125, -1.34351576778092, 218, 53, 'PPL', 'P'),
(108188, 'Berlin', 39.0525016784668, 0.681594735429857, -80.3552780151367, -1.40246417271955, 218, 58, 'PPL', 'P'),
(114586, 'Berlin', 42.4186096191406, 0.740344401972142, -93.1602783203125, -1.62595358876375, 218, 16, 'PPL', 'P'),
(124238, 'Berlin', 42.3811111450195, 0.739689930134255, -71.6374969482422, -1.25031018963422, 218, 23, 'PPL', 'P'),
(139035, 'Berlin', 40.0536117553711, 0.699067402446731, -94.350830078125, -1.64673263685298, 218, 29, 'PPL', 'P'),
(139667, 'Berlin', 46.3786087036133, 0.809459424372151, -98.4894409179688, -1.71896502246698, 218, 34, 'PPL', 'P'),
(143518, 'Berlin', 44.4686088562012, 0.77612363832222, -71.1855621337891, -1.24242243911762, 218, 36, 'PPL', 'P'),
(147168, 'Berlin', 42.6930618286133, 0.745134496666813, -73.3724975585938, -1.28059166280896, 218, 40, 'PPL', 'P'),
(154290, 'Berlin', 41.6094398498535, 0.726221725290479, -84.7544403076172, -1.47924403905292, 218, 41, 'PPL', 'P'),
(173161, 'Berlin', 43.9680595397949, 0.767387404682324, -88.9433288574219, -1.5523539362461, 218, 57, 'PPL', 'P'),
(177493, 'Berlin', 41.6213912963867, 0.726430317382859, -72.7461090087891, -1.26965912021808, 218, 8, 'PPL', 'P'),
(189933, 'Berlin', 38.8819389343262, 0.678617853963367, -117.606666564941, -2.05262355385336, 218, 39, 'PPL', 'P'),
(200402, 'Berlin', 44.4980583190918, 0.776637628412605, -122.746673583984, -2.14233359991128, 218, 43, 'PPL', 'P'),
(129785, 'Berlin Center', 42.9005584716797, 0.748755996275157, -85.1341705322266, -1.48587158174169, 218, 27, 'PPL', 'P'),
(154291, 'Berlin Center', 41.0244407653809, 0.716011565145279, -80.9477767944336, -1.41280522723233, 218, 41, 'PPL', 'P'),
(171741, 'Berlin Corners', 44.2099990844727, 0.771610046327727, -72.5763931274414, -1.26669701929564, 218, 55, 'PPL', 'P'),
(70538, 'Berlin Heights', 39.813060760498, 0.694868995567248, -74.8908309936523, -1.30709158039385, 218, 37, 'PPL', 'P'),
(154292, 'Berlin Heights', 41.3252792358398, 0.721262186971452, -82.4933319091797, -1.43978025275569, 218, 41, 'PPL', 'P'),
(154293, 'Berlin Heights Station', 41.3527793884277, 0.721742155178911, -82.4941711425781, -1.43979490014168, 218, 41, 'PPL', 'P'),
(77853, 'Berlin Junction', 39.8558311462402, 0.695615479620798, -77.0358276367188, -1.34452883425958, 218, 45, 'PPL', 'P'),
(44783, 'Berlin West', 38.3325004577637, 0.66902834351021, -75.3619384765625, -1.31531395710142, 218, 25, 'PPL', 'P'),
(159148, 'Berlinsville', 40.7686080932617, 0.711546442682624, -75.5741729736328, -1.31901814786161, 218, 45, 'PPL', 'P'),
(154299, 'Berlinville', 41.3025016784668, 0.72086464359973, -82.5147171020508, -1.44015349478246, 218, 41, 'PPL', 'P'),
(188133, 'Bermadez Place', 34.6761093139648, 0.605212279310159, -106.317222595215, -1.85558558586221, 218, 38, 'PPL', 'P'),
(15199, 'Bermont', 26.9452800750732, 0.470283855182053, -81.7608337402344, -1.42699574794276, 218, 12, 'PPL', 'P'),
(382, 'Bermuda', 31.4872207641602, 0.54955567463692, -87.1883316040039, -1.5217234558105, 218, 2, 'PPL', 'P'),
(19220, 'Bermuda', 33.7849998474121, 0.589659485123123, -84.1005630493164, -1.46783172799165, 218, 13, 'PPL', 'P'),
(39359, 'Bermuda', 31.6622200012207, 0.552609987512104, -93.0036087036133, -1.62321918811451, 218, 22, 'PPL', 'P'),
(180050, 'Bermuda Dunes', 33.7427787780762, 0.588922588449498, -116.288330078125, -2.02961424150924, 218, 6, 'PPL', 'P'),
(180051, 'Bermuda Palms Mobile Park', 33.7102813720703, 0.588355401716339, -116.253890991211, -2.02901316605121, 218, 6, 'PPL', 'P'),
(99864, 'Bermuda Place', 37.3433303833008, 0.651764068848635, -77.4011077880859, -1.35090417559313, 218, 53, 'PPL', 'P'),
(62891, 'Bermuda Run', 36.0036087036133, 0.628381514477739, -80.4222183227539, -1.40363250148977, 218, 33, 'PPL', 'P'),
(159149, 'Bermudian', 40.0194396972656, 0.698470987520608, -77.0358276367188, -1.34452883425958, 218, 45, 'PPL', 'P'),
(31807, 'Bern', 39.9622192382813, 0.697472302111828, -95.9716720581055, -1.67502166605818, 218, 20, 'PPL', 'P'),
(180052, 'Bern', 35.6891708374023, 0.622893538419413, -120.538612365723, -2.10379566156701, 218, 6, 'PPL', 'P'),
(194586, 'Bern', 42.3397216796875, 0.738967547688571, -111.385276794434, -1.9440398183081, 218, 17, 'PPL', 'P'),
(134232, 'Bernadotte', 44.4552803039551, 0.775891011201002, -94.3008270263672, -1.64585991896376, 218, 28, 'PPL', 'P'),
(118787, 'Bernadotte (historical)', 40.4019393920898, 0.705146866583164, -90.3202819824219, -1.57638630192297, 218, 18, 'PPL', 'P'),
(188135, 'Bernal', 35.3927803039551, 0.617720547739016, -105.316940307617, -1.83812736649425, 218, 38, 'PPL', 'P'),
(92589, 'Bernal Colonia', 26.2310009002686, 0.457817331803283, -97.9089965820313, -1.70883435768032, 218, 51, 'PPL', 'P'),
(92590, 'Bernal Heights Number 1 Colonia', 26.3159999847412, 0.459300845688512, -97.9830017089844, -1.71012599080901, 218, 51, 'PPL', 'P'),
(92591, 'Bernal Heights Number 2 Colonia', 26.3159999847412, 0.459300845688512, -97.9810028076172, -1.71009110339873, 218, 51, 'PPL', 'P'),
(188137, 'Bernalillo', 35.2999992370605, 0.616101212638193, -106.550559997559, -1.85965809180116, 218, 38, 'PPL', 'P'),
(39360, 'Bernard', 30.5966701507568, 0.534012634277377, -92.779167175293, -1.61930194446711, 218, 22, 'PPL', 'P'),
(58641, 'Bernard', 32.1130599975586, 0.56047862984788, -90.2586135864258, -1.57530998536842, 218, 30, 'PPL', 'P'),
(114587, 'Bernard', 42.3122215270996, 0.738487579481111, -90.831672668457, -1.58531175315832, 218, 16, 'PPL', 'P'),
(126870, 'Bernard', 44.2411117553711, 0.772153064873994, -68.3563919067383, -1.19304410355619, 218, 26, 'PPL', 'P'),
(171743, 'Bernard J Leddy Park', 44.5038909912109, 0.776739427745274, -73.258056640625, -1.2785942919914, 218, 55, 'PPL', 'P'),
(193119, 'Bernardino', 31.5105590820313, 0.549963005125647, -109.312217712402, -1.90785811173828, 218, 5, 'PPL', 'P'),
(92593, 'Bernardo', 29.7605590820313, 0.519419743215747, -96.3919372558594, -1.68235667749053, 218, 51, 'PPL', 'P'),
(188138, 'Bernardo', 34.4186096191406, 0.600718061812595, -106.833061218262, -1.86458866824333, 218, 38, 'PPL', 'P'),
(124240, 'Bernardston', 42.6708297729492, 0.744746474095988, -72.5500030517578, -1.26623642558511, 218, 23, 'PPL', 'P'),
(108186, 'Bernardstown', 38.5077781677246, 0.672087516654384, -80.3447189331055, -1.40227988197212, 218, 58, 'PPL', 'P'),
(144835, 'Bernardsville', 40.7186088562012, 0.710673791372433, -74.5697174072266, -1.30148709103783, 218, 37, 'PPL', 'P'),
(44784, 'Berndell Estates', 39.3472213745117, 0.686738564496318, -76.9530563354492, -1.34308420252627, 218, 25, 'PPL', 'P'),
(113160, 'Berne', 40.5238914489746, 0.707275331505383, -76.0019378662109, -1.32648405366153, 218, 45, 'PPL', 'P'),
(114588, 'Berne', 42.0811080932617, 0.73445388911505, -95.6524963378906, -1.66945099884801, 218, 16, 'PPL', 'P'),
(122219, 'Berne', 40.6577796936035, 0.709612122203873, -84.9519424438477, -1.48269110160986, 218, 19, 'PPL', 'P'),
(129789, 'Berne', 43.8447189331055, 0.765234704994186, -83.2694396972656, -1.45332588900816, 218, 27, 'PPL', 'P'),
(134234, 'Berne', 44.1636085510254, 0.770800378777315, -92.779167175293, -1.61930194446711, 218, 28, 'PPL', 'P'),
(147172, 'Berne', 42.6252784729004, 0.743951453931572, -74.1338882446289, -1.29388043717429, 218, 40, 'PPL', 'P'),
(201903, 'Berne', 43.8175010681152, 0.764759663634743, -103.638328552246, -1.80883006450034, 218, 49, 'PPL', 'P'),
(206821, 'Berne', 47.7700004577637, 0.833743791667174, -120.979721069336, -2.11149446080427, 218, 56, 'PPL', 'P'),
(191131, 'Bernecker', 32.5608291625977, 0.568293676066717, -100.561943054199, -1.75513700849882, 218, 51, 'PPL', 'P'),
(19221, 'Berner', 33.1547203063965, 0.578659031924442, -83.82861328125, -1.46308530913886, 218, 13, 'PPL', 'P'),
(134235, 'Berner', 47.8044395446777, 0.834344867125205, -95.4727783203125, -1.66631432771611, 218, 28, 'PPL', 'P'),
(384, 'Berney Points', 33.4863891601563, 0.584447745448865, -86.8625030517578, -1.5160366747768, 218, 2, 'PPL', 'P'),
(387, 'Berneys', 33.3436088562012, 0.581955759037851, -86.1494369506836, -1.50359132352869, 218, 2, 'PPL', 'P'),
(147171, 'Bernhards Bay', 43.2444381713867, 0.754757829265814, -75.9338912963867, -1.32529641697341, 218, 40, 'PPL', 'P'),
(114589, 'Bernhart', 41.0125007629395, 0.71580317278998, -92.0677795410156, -1.606885887991, 218, 16, 'PPL', 'P'),
(53443, 'Bernheimer', 38.6680603027344, 0.67488496764243, -91.2547225952148, -1.59269536728056, 218, 29, 'PPL', 'P'),
(7420, 'Bernice', 35.25, 0.615228561328001, -93.1294403076172, -1.62541536390744, 218, 4, 'PPL', 'P'),
(34781, 'Bernice', 37.2069396972656, 0.649383602308267, -83.7536087036133, -1.46177623230503, 218, 21, 'PPL', 'P'),
(39362, 'Bernice', 32.8219413757324, 0.572850943903088, -92.6577835083008, -1.61718339981995, 218, 22, 'PPL', 'P'),
(75113, 'Bernice', 36.6158294677734, 0.639066782561409, -94.9175033569336, -1.65662295135126, 218, 42, 'PPL', 'P'),
(118789, 'Bernice', 41.5791702270508, 0.725693420709234, -87.5480575561523, -1.52800185808036, 218, 18, 'PPL', 'P'),
(154300, 'Bernice', 40.2644386291504, 0.702747025545866, -81.5194396972656, -1.42278262709825, 218, 41, 'PPL', 'P'),
(159152, 'Bernice', 41.4702796936035, 0.723792922376327, -76.3819427490234, -1.33311639004027, 218, 45, 'PPL', 'P'),
(195983, 'Bernice', 46.2577781677246, 0.807350533683944, -112.336387634277, -1.96063983401478, 218, 31, 'PPL', 'P'),
(180053, 'Bernice (historical)', 33.1072196960449, 0.5778299898771, -115.508331298828, -2.01600069464897, 218, 6, 'PPL', 'P'),
(189934, 'Bernice (historical)', 39.7583312988281, 0.693913786263264, -117.780563354492, -2.05565862538967, 218, 39, 'PPL', 'P'),
(53444, 'Bernie', 36.6688919067383, 0.639992896830484, -89.9686126708984, -1.57024851455867, 218, 29, 'PPL', 'P'),
(108187, 'Bernie (historical)', 38.1802787780762, 0.666371574006747, -82.0119400024414, -1.43137837899065, 218, 58, 'PPL', 'P'),
(99866, 'Bernietown', 37.2941703796387, 0.650906064924438, -81.3613891601563, -1.42002412484115, 218, 53, 'PPL', 'P'),
(114590, 'Bernina', 41.4077796936035, 0.72270209159383, -92.7658309936523, -1.61906918418784, 218, 16, 'PPL', 'P'),
(134236, 'Berning Mill', 45.2069396972656, 0.789009942467814, -93.6241683959961, -1.63404999795175, 218, 28, 'PPL', 'P'),
(34782, 'Bernstadt', 37.1561088562012, 0.648496436770135, -84.1947174072266, -1.46947503154229, 218, 21, 'PPL', 'P'),
(191132, 'Bernstein', 36.3941688537598, 0.635198075024879, -101.356666564941, -1.76900755040428, 218, 51, 'PPL', 'P'),
(159153, 'Bernville', 40.4333305358887, 0.705694745398421, -76.1125030517578, -1.32841378018741, 218, 45, 'PPL', 'P'),
(134237, 'Beroun', 45.9102783203125, 0.801285517196425, -92.9550018310547, -1.62237083814926, 218, 28, 'PPL', 'P'),
(188139, 'Berrendo (historical)', 33.4527816772461, 0.583861184218775, -104.52278137207, -1.82426667828482, 218, 38, 'PPL', 'P'),
(44785, 'Berrett (historical)', 39.2852783203125, 0.685657454251801, -79.3513870239258, -1.38494296959181, 218, 25, 'PPL', 'P'),
(206822, 'Berrian', 45.9377784729004, 0.801765485403884, -119.150833129883, -2.0795743446108, 218, 56, 'PPL', 'P'),
(19222, 'Berrien (historical)', 31.1719398498535, 0.544052984613571, -83.4944381713867, -1.45725285319353, 218, 13, 'PPL', 'P'),
(129793, 'Berrien Center', 41.9566688537598, 0.732282014667063, -86.2766723632813, -1.50581200040366, 218, 27, 'PPL', 'P'),
(129791, 'Berrien Springs', 41.9463882446289, 0.732102584188619, -86.3388900756836, -1.50689790433814, 218, 27, 'PPL', 'P'),
(389, 'Berry', 33.6597213745117, 0.587472963289141, -87.5999984741211, -1.52890839811542, 218, 2, 'PPL', 'P'),
(15201, 'Berry', 28.3186092376709, 0.494252970783039, -81.8622207641602, -1.42876528532906, 218, 12, 'PPL', 'P'),
(26506, 'Berry', 39.7130584716797, 0.693123626367838, -89.470832824707, -1.56156061729256, 218, 18, 'PPL', 'P'),
(34783, 'Berry', 38.5205612182617, 0.672310622974705, -84.3844375610352, -1.47278627288364, 218, 21, 'PPL', 'P'),
(44786, 'Berry', 38.648609161377, 0.674545481182472, -76.9572219848633, -1.34315690682403, 218, 25, 'PPL', 'P'),
(85006, 'Berry', 36.1755599975586, 0.631382630710149, -87.3869400024414, -1.52518982628534, 218, 50, 'PPL', 'P'),
(193120, 'Berry', 35.2527809143066, 0.615277097438868, -113.97110748291, -1.98917107772113, 218, 5, 'PPL', 'P'),
(7421, 'Berry (historical)', 36.1680603027344, 0.631251736342572, -92.2233276367188, -1.60960071440622, 218, 4, 'PPL', 'P'),
(180054, 'Berry Creek', 39.6452789306641, 0.691940650211625, -121.402221679688, -2.11886848754659, 218, 6, 'PPL', 'P'),
(53445, 'Berry Ford (historical)', 37.8641700744629, 0.660854436334484, -92.8791732788086, -1.62104738024555, 218, 29, 'PPL', 'P'),
(193376, 'Berry Glenn', 41.3175010681152, 0.721126432334885, -124.040000915527, -2.16490642015273, 218, 6, 'PPL', 'P'),
(79775, 'Berry Hill', 32.7755584716797, 0.572041409510731, -80.1727828979492, -1.39927903205581, 218, 48, 'PPL', 'P'),
(85007, 'Berry Hill', 36.1169395446777, 0.630359510798368, -86.7663879394531, -1.51435914960616, 218, 50, 'PPL', 'P'),
(99867, 'Berry Hill', 36.5530586242676, 0.637971224667978, -79.6133270263672, -1.38951468507709, 218, 53, 'PPL', 'P'),
(44787, 'Berry Hill Manor', 38.6438903808594, 0.674463122925762, -77.0013885498047, -1.34392775880155, 218, 25, 'PPL', 'P'),
(129794, 'Berry Junction', 43.2963905334473, 0.755664569037959, -86.2611083984375, -1.50554035797247, 218, 27, 'PPL', 'P'),
(44788, 'Berry Lane', 38.8633308410645, 0.678293081468432, -76.8708267211914, -1.34164902501483, 218, 25, 'PPL', 'P'),
(62892, 'Berry Mill', 35.1694412231445, 0.613822545430494, -83.3030624389648, -1.45391271655435, 218, 33, 'PPL', 'P'),
(126871, 'Berry Mills', 44.6291694641113, 0.778925949579256, -70.4499969482422, -1.22958440476678, 218, 26, 'PPL', 'P'),
(206823, 'Berry Patch', 46.4669418334961, 0.811001128327198, -121.526390075684, -2.12103563488364, 218, 56, 'PPL', 'P'),
(395, 'Berry Springs', 34.4294395446777, 0.600907079670964, -85.5086135864258, -1.49240684589869, 218, 2, 'PPL', 'P'),
(34786, 'Berry Store', 36.9533309936523, 0.644957295418501, -86.1408309936523, -1.50344112124321, 218, 21, 'PPL', 'P'),
(108199, 'Berryburg', 39.2000007629395, 0.684169080097583, -80.084716796875, -1.39774198863268, 218, 58, 'PPL', 'P'),
(108189, 'Berryburg Junction', 39.1875, 0.683950900625278, -80.0316696166992, -1.39681614067971, 218, 58, 'PPL', 'P'),
(15202, 'Berrydale', 30.899169921875, 0.539292251269918, -87.0138931274414, -1.51867893005232, 218, 12, 'PPL', 'P'),
(206824, 'Berrydale', 47.3400001525879, 0.826238870557277, -122.126670837402, -2.13151251061201, 218, 56, 'PPL', 'P'),
(180056, 'Berryessa', 37.3863906860352, 0.652515612908255, -121.859443664551, -2.12684851659496, 218, 6, 'PPL', 'P'),
(180057, 'Berryessa Highlands', 38.514720916748, 0.672208690483982, -122.186668395996, -2.13255966555263, 218, 6, 'PPL', 'P'),
(19224, 'Berryhill', 34.2958297729492, 0.598575149241463, -85.2694396972656, -1.48823247404804, 218, 13, 'PPL', 'P'),
(44796, 'Berryhill', 39.3811111450195, 0.687330052574425, -76.4555587768555, -1.33440123210818, 218, 25, 'PPL', 'P'),
(62893, 'Berryhill', 35.2186088562012, 0.614680682512745, -80.9744415283203, -1.41327061463282, 218, 33, 'PPL', 'P'),
(92594, 'Berryhill', 32.9145698547363, 0.574467615842821, -99.5791168212891, -1.73798345475956, 218, 51, 'PPL', 'P'),
(70541, 'Berryland', 39.6111106872559, 0.691344301864529, -74.9061126708984, -1.30735829597702, 218, 37, 'PPL', 'P'),
(53447, 'Berryman', 37.4761085510254, 0.654081485050194, -90.6877822875977, -1.58280039225037, 218, 29, 'PPL', 'P'),
(206825, 'Berryman', 46.2216682434082, 0.806720296611977, -118.389999389648, -2.06629529078344, 218, 56, 'PPL', 'P'),
(124242, 'Berryman Corner', 41.6500015258789, 0.726929660087249, -71.0666732788086, -1.24034743715428, 218, 23, 'PPL', 'P'),
(99869, 'Berrymans Corner', 37.026668548584, 0.646237277217421, -76.8352813720703, -1.34102864163889, 218, 53, 'PPL', 'P'),
(99870, 'Berrys', 39.0386085510254, 0.681352254612606, -77.996940612793, -1.36130342017572, 218, 53, 'PPL', 'P'),
(397, 'Berrys (historical)', 34.7299995422363, 0.606152841228147, -86.045280456543, -1.5017734497686, 218, 2, 'PPL', 'P'),
(85008, 'Berrys Chapel', 35.978328704834, 0.62794029526414, -86.8880615234375, -1.51648275425938, 218, 50, 'PPL', 'P'),
(85013, 'Berrys Chapel Heights', 35.9769401550293, 0.62791606049822, -86.8925018310547, -1.51656025224711, 218, 50, 'PPL', 'P'),
(126872, 'Berrys Corner', 45.0980606079102, 0.787109643871988, -69.1772232055664, -1.20737031232416, 218, 26, 'PPL', 'P'),
(143520, 'Berrys Corner', 43.2750015258789, 0.755291260432157, -71.0694427490234, -1.24039577352807, 218, 36, 'PPL', 'P'),
(92598, 'Berrys Creek', 30.7150707244873, 0.536079114125224, -97.6597213745117, -1.70448368456551, 218, 51, 'PPL', 'P'),
(79787, 'Berrys Crossroads', 34.3188896179199, 0.598977619461201, -79.4913864135742, -1.38738641989196, 218, 48, 'PPL', 'P'),
(79777, 'Berrys Landing', 32.4219398498535, 0.5658696002635, -81.20361328125, -1.41727041627401, 218, 48, 'PPL', 'P'),
(159155, 'Berrysburg', 40.6019401550293, 0.708637538402958, -76.8122177124023, -1.34062610484013, 218, 45, 'PPL', 'P'),
(71810, 'Berrysville', 39.1283302307129, 0.682918193333572, -83.5586090087891, -1.45837284558996, 218, 41, 'PPL', 'P'),
(19225, 'Berryton', 34.4500007629395, 0.601265940627852, -85.3863906860352, -1.49027365386553, 218, 13, 'PPL', 'P'),
(31809, 'Berryton', 38.9408302307129, 0.679645700986083, -95.6313934326172, -1.66908268366925, 218, 20, 'PPL', 'P'),
(13368, 'Berrytown', 39.0125007629395, 0.680896587750093, -75.5944366455078, -1.31937181565437, 218, 10, 'PPL', 'P'),
(34785, 'Berrytown', 38.2691688537598, 0.667922998499772, -85.519172668457, -1.49259113664612, 218, 21, 'PPL', 'P'),
(99871, 'Berrytown', 38.3683280944824, 0.66965365373416, -78.6572189331055, -1.37282745084471, 218, 53, 'PPL', 'P'),
(159157, 'Berrytown', 41.8899993896484, 0.73111841300778, -76.767219543457, -1.33984073863466, 218, 45, 'PPL', 'P'),
(7422, 'Berryville', 36.3647193908691, 0.634684084934493, -93.5677795410156, -1.63306582677091, 218, 4, 'PPL', 'P'),
(19226, 'Berryville', 32.4283294677734, 0.565981120134147, -81.2588882446289, -1.41823514637889, 218, 13, 'PPL', 'P'),
(26509, 'Berryville', 37.4569396972656, 0.653746925438253, -89.2877807617188, -1.55836575609084, 218, 18, 'PPL', 'P'),
(58643, 'Berryville', 32.7486114501953, 0.571571095262223, -90.1661071777344, -1.57369544395756, 218, 30, 'PPL', 'P'),
(85009, 'Berryville', 36.2213897705078, 0.632182511143555, -86.623893737793, -1.51187215662218, 218, 50, 'PPL', 'P'),
(92595, 'Berryville', 32.0883293151855, 0.560046998014205, -95.4716720581055, -1.66629501979821, 218, 51, 'PPL', 'P'),
(99872, 'Berryville', 39.151668548584, 0.6833255238223, -77.9824981689453, -1.36105135197855, 218, 53, 'PPL', 'P'),
(108190, 'Berryville', 39.6155586242676, 0.691421933010304, -78.2300033569336, -1.36537113242471, 218, 58, 'PPL', 'P'),
(129795, 'Berryville', 42.4052810668945, 0.740111774850923, -84.4872207641602, -1.47458017819391, 218, 27, 'PPL', 'P'),
(147173, 'Berryville', 42.961669921875, 0.749822592291734, -74.4155578613281, -1.29879649938853, 218, 40, 'PPL', 'P'),
(44789, 'Berrywood', 39.0888900756836, 0.682229832770814, -76.543327331543, -1.33593308236719, 218, 25, 'PPL', 'P'),
(44790, 'Berrywood Village', 39.5069389343262, 0.689526161788331, -76.8730621337891, -1.3416880403248, 218, 25, 'PPL', 'P'),
(44791, 'Berrywood West', 39.0883293151855, 0.682220045653808, -76.5516662597656, -1.33607862412076, 218, 25, 'PPL', 'P'),
(143521, 'Bersum Gardens', 43.0830612182617, 0.751941270096946, -70.7705612182617, -1.23517930674288, 218, 36, 'PPL', 'P'),
(108191, 'Bert', 39.4508285522461, 0.688546850876482, -80.9588928222656, -1.41299923851774, 218, 58, 'PPL', 'P'),
(19227, 'Bert (historical)', 34.5963897705078, 0.603820910798647, -83.5527801513672, -1.45827111283632, 218, 13, 'PPL', 'P'),
(31810, 'Bert Wettar', 38.1913909912109, 0.666565518713132, -99.3680572509766, -1.73429977033977, 218, 20, 'PPL', 'P'),
(399, 'Bertha', 31.541109085083, 0.550496203265395, -85.4280624389648, -1.49100096315923, 218, 2, 'PPL', 'P'),
(7436, 'Bertha', 35.7063903808594, 0.623194076148428, -93.1533279418945, -1.62583228177609, 218, 4, 'PPL', 'P'),
(15203, 'Bertha', 28.6183300018311, 0.499484084954227, -81.2663879394531, -1.41836604074647, 218, 12, 'PPL', 'P'),
(44792, 'Bertha', 38.3905601501465, 0.670041676304985, -76.4333267211914, -1.33401320953735, 218, 25, 'PPL', 'P'),
(53448, 'Bertha', 36.8377799987793, 0.642940550104011, -92.3844375610352, -1.61241261304318, 218, 29, 'PPL', 'P'),
(62895, 'Bertha', 36.2730598449707, 0.633084324067683, -75.9108276367188, -1.32489388017465, 218, 33, 'PPL', 'P'),
(99873, 'Bertha', 36.9022216796875, 0.644065269611379, -80.82861328125, -1.41072543157903, 218, 53, 'PPL', 'P'),
(108192, 'Bertha', 37.5724983215332, 0.655763803910797, -80.8711090087891, -1.41146712194262, 218, 58, 'PPL', 'P'),
(134238, 'Bertha', 46.2666702270508, 0.807505729396469, -95.0625, -1.65915362017711, 218, 28, 'PPL', 'P'),
(141293, 'Bertha', 41.8869400024414, 0.731065016627924, -96.3469390869141, -1.68157131128507, 218, 35, 'PPL', 'P'),
(159158, 'Bertha', 40.377498626709, 0.704720294755561, -80.432502746582, -1.40381199854724, 218, 45, 'PPL', 'P'),
(200403, 'Bertha (historical)', 45.4777793884277, 0.793736986823677, -122.696937561035, -2.14146554255396, 218, 43, 'PPL', 'P'),
(92596, 'Bertha Acres Colonia', 26.2000007629395, 0.45727627733832, -98.0080032348633, -1.71056234975362, 218, 51, 'PPL', 'P'),
(108193, 'Bertha Hill', 39.6644401550293, 0.692275076665511, -79.9925003051758, -1.39613250722789, 218, 58, 'PPL', 'P'),
(99874, 'Berthaville', 38.3333282470703, 0.669042791159123, -77.126106262207, -1.34610449351853, 218, 53, 'PPL', 'P'),
(197996, 'Berthold', 48.313060760498, 0.843221981986766, -101.736671447754, -1.77563988678301, 218, 34, 'PPL', 'P'),
(194106, 'Berthoud', 40.3083305358887, 0.703513083833428, -105.080558776855, -1.83400173049155, 218, 7, 'PPL', 'P'),
(186407, 'Berthoud Falls', 39.7708282470703, 0.694131899156542, -105.808059692383, -1.84669901677878, 218, 7, 'PPL', 'P'),
(58644, 'Bertice', 32.6236114501953, 0.56938943369723, -89.6777801513672, -1.56517252952098, 218, 30, 'PPL', 'P'),
(39363, 'Bertie', 29.9191703796387, 0.522188032589857, -90.9877777099609, -1.58803630011152, 218, 22, 'PPL', 'P'),
(7423, 'Bertig', 36.0711097717285, 0.629559630364963, -90.3308334350586, -1.57657045951235, 218, 4, 'PPL', 'P'),
(99875, 'Berton', 37.2547187805176, 0.650217504624598, -80.6138916015625, -1.40697783129307, 218, 53, 'PPL', 'P'),
(92597, 'Bertram', 30.7436103820801, 0.536577225117609, -98.0552825927734, -1.71138753021738, 218, 51, 'PPL', 'P'),
(114591, 'Bertram', 41.9497184753418, 0.73216070767941, -91.5352783203125, -1.59759198841884, 218, 16, 'PPL', 'P'),
(180058, 'Bertram', 33.3783302307129, 0.582561761343898, -115.782501220703, -2.02078586249562, 218, 6, 'PPL', 'P'),
(53449, 'Bertrand', 36.9094390869141, 0.64419123713094, -89.4524993896484, -1.56124063848758, 218, 29, 'PPL', 'P'),
(99876, 'Bertrand', 37.6688919067383, 0.657446189350428, -76.5177764892578, -1.33548713604266, 218, 53, 'PPL', 'P'),
(129796, 'Bertrand', 41.7744407653809, 0.729101534535236, -86.2622222900391, -1.50555979904842, 218, 27, 'PPL', 'P'),
(141294, 'Bertrand', 40.526668548584, 0.707323801037222, -99.6333312988281, -1.73892967589487, 218, 35, 'PPL', 'P'),
(39364, 'Bertrandville', 29.7747192382813, 0.519666884564906, -90.0169372558594, -1.5710919376759, 218, 22, 'PPL', 'P'),
(194107, 'Berts Corner', 40.3077812194824, 0.703503496453503, -105.10221862793, -1.83437976620829, 218, 7, 'PPL', 'P'),
(195984, 'Berts Trailer Court', 45.392219543457, 0.792243685821442, -108.905830383301, -1.90076531480708, 218, 31, 'PPL', 'P'),
(129798, 'Berville', 42.9083290100098, 0.748891617753669, -82.883056640625, -1.44658223249586, 218, 27, 'PPL', 'P'),
(31811, 'Berwet', 37.7855606079102, 0.659482442319902, -97.4833297729492, -1.70140507034538, 218, 20, 'PPL', 'P'),
(400, 'Berwick', 33.2755584716797, 0.580768055770703, -85.6694412231445, -1.49521381768763, 218, 2, 'PPL', 'P'),
(31812, 'Berwick', 39.9333305358887, 0.696968099138449, -95.8444366455078, -1.67280098918322, 218, 20, 'PPL', 'P'),
(39365, 'Berwick', 29.6944408416748, 0.518265762225902, -91.2188873291016, -1.59206992389856, 218, 22, 'PPL', 'P'),
(53450, 'Berwick', 36.9330596923828, 0.644603494467684, -94.0944366455078, -1.64225772727332, 218, 29, 'PPL', 'P'),
(58645, 'Berwick', 31.1097202301025, 0.542967047389577, -90.929443359375, -1.58701817362679, 218, 30, 'PPL', 'P'),
(113090, 'Berwick', 43.2658309936523, 0.755131204450643, -70.8649978637695, -1.23682753714153, 218, 26, 'PPL', 'P'),
(114593, 'Berwick', 41.6650009155273, 0.727191448822404, -93.5447235107422, -1.6326634231302, 218, 16, 'PPL', 'P'),
(118798, 'Berwick', 40.7991714477539, 0.712079873848967, -90.538330078125, -1.5801919591207, 218, 18, 'PPL', 'P'),
(154301, 'Berwick', 41.0291709899902, 0.716094123139071, -83.2980575561523, -1.4538253648706, 218, 41, 'PPL', 'P'),
(159170, 'Berwick', 41.0544395446777, 0.716535142615588, -76.2336120605469, -1.3305275311446, 218, 45, 'PPL', 'P'),
(197999, 'Berwick', 48.3611106872559, 0.844060611414032, -100.246109008789, -1.74962466451652, 218, 34, 'PPL', 'P'),
(99877, 'Berwick Heights', 37.2402801513672, 0.64996550300645, -80.004997253418, -1.39635062012116, 218, 53, 'PPL', 'P'),
(159159, 'Berwick Heights', 41.0819396972656, 0.717015110823048, -76.2486114501953, -1.33078931987976, 218, 45, 'PPL', 'P'),
(19244, 'Berwicke', 33.8808288574219, 0.59133201686672, -84.3583297729492, -1.47233060602112, 218, 13, 'PPL', 'P'),
(19228, 'Berwin', 34.2961082458496, 0.598580009510453, -85.1177825927734, -1.48558555824061, 218, 13, 'PPL', 'P'),
(108194, 'Berwind', 37.2686080932617, 0.650459918862823, -81.6669387817383, -1.42535697176598, 218, 58, 'PPL', 'P'),
(159161, 'Berwinsdale', 40.8191719055176, 0.712428947688849, -78.5975036621094, -1.37178522275211, 218, 45, 'PPL', 'P'),
(44793, 'Berwyn', 38.9949989318848, 0.680591123173061, -76.9266662597656, -1.34262360881574, 218, 25, 'PPL', 'P'),
(99879, 'Berwyn', 36.8208312988281, 0.642644739485931, -76.4794387817383, -1.33481801681877, 218, 53, 'PPL', 'P'),
(118792, 'Berwyn', 41.8505592346191, 0.730430052445022, -87.7936096191406, -1.53228755006457, 218, 18, 'PPL', 'P'),
(141295, 'Berwyn', 41.3511085510254, 0.721712993564975, -99.4991683959961, -1.73658809150642, 218, 35, 'PPL', 'P'),
(147174, 'Berwyn', 42.8661117553711, 0.748154787659072, -76.0411071777344, -1.32716768711336, 218, 40, 'PPL', 'P'),
(159162, 'Berwyn', 40.0447196960449, 0.698912206734207, -75.4391708374023, -1.31666191608716, 218, 45, 'PPL', 'P'),
(154302, 'Berwyn (historical)', 40.2425003051758, 0.70236412956014, -81.4894409179688, -1.42225904962795, 218, 41, 'PPL', 'P'),
(44794, 'Berwyn Heights', 38.9938888549805, 0.680571748676131, -76.9108276367188, -1.34234717269459, 218, 25, 'PPL', 'P'),
(7424, 'Beryl', 35.0830612182617, 0.6123149299374, -92.2600021362305, -1.61024080517422, 218, 4, 'PPL', 'P'),
(108195, 'Beryl', 39.4722213745117, 0.688920226061311, -79.0638885498047, -1.37992517462394, 218, 58, 'PPL', 'P'),
(159163, 'Beryl', 40.4433288574219, 0.705869249028848, -78.3902816772461, -1.36816851683373, 218, 45, 'PPL', 'P'),
(192482, 'Beryl', 37.8958282470703, 0.661406975681648, -113.66056060791, -1.9837510122706, 218, 52, 'PPL', 'P'),
(192483, 'Beryl Junction', 37.7094383239746, 0.658153857831089, -113.655281066895, -1.98365886689688, 218, 52, 'PPL', 'P'),
(19229, 'Berzelia', 33.4066696166992, 0.583056376937353, -82.2516708374023, -1.43556247137927, 218, 13, 'PPL', 'P'),
(77856, 'Besco', 39.9850006103516, 0.697869912062577, -80.0238876342773, -1.39668031946412, 218, 45, 'PPL', 'P'),
(177487, 'Beseck Lake', 41.5186080932617, 0.724636412072582, -72.7352828979492, -1.26947016893874, 218, 8, 'PPL', 'P'),
(147175, 'Besemer', 42.396110534668, 0.73995171886941, -76.4102783203125, -1.3336109390547, 218, 40, 'PPL', 'P'),
(39366, 'Beshel', 29.5597190856934, 0.515914424009957, -89.7708282470703, -1.56679652515371, 218, 22, 'PPL', 'P'),
(186408, 'Beshoar', 37.2180595397949, 0.649577680172707, -104.406112670898, -1.82223042531535, 218, 7, 'PPL', 'P'),
(108196, 'Besoco', 37.627498626709, 0.656723740325717, -81.2411117553711, -1.4179248881119, 218, 58, 'PPL', 'P'),
(44795, 'Bess-Mar Estates', 38.603889465332, 0.673764975245997, -76.5755615234375, -1.33649567514747, 218, 25, 'PPL', 'P'),
(418, 'Bessemer', 33.401668548584, 0.582969091832626, -86.9544372558594, -1.51764122933357, 218, 2, 'PPL', 'P'),
(15204, 'Bessemer', 27.0072193145752, 0.471364898847543, -80.6013870239258, -1.40675958524174, 218, 12, 'PPL', 'P'),
(62897, 'Bessemer', 36.083610534668, 0.629777809837268, -79.7430572509766, -1.39177890463588, 218, 33, 'PPL', 'P'),
(71805, 'Bessemer', 39.4650001525879, 0.688794191962723, -82.1980590820313, -1.43462676973027, 218, 41, 'PPL', 'P'),
(99880, 'Bessemer', 37.6500015258789, 0.657116490007476, -79.8186111450195, -1.39309756884963, 218, 53, 'PPL', 'P'),
(108197, 'Bessemer', 39.5144386291504, 0.689657056155909, -77.9300003051758, -1.3601350914055, 218, 58, 'PPL', 'P'),
(129799, 'Bessemer', 46.4813919067383, 0.811253329682428, -90.0527801513672, -1.57171751421596, 218, 27, 'PPL', 'P'),
(159166, 'Bessemer', 40.128059387207, 0.700366758742581, -79.5552825927734, -1.38850161859843, 218, 45, 'PPL', 'P'),
(209303, 'Bessemer (historical)', 42.7752799987793, 0.746569474441175, -106.530830383301, -1.85931374507221, 218, 59, 'PPL', 'P'),
(209302, 'Bessemer Bend', 42.7580604553223, 0.746268936712159, -106.519721984863, -1.85911986694485, 218, 59, 'PPL', 'P'),
(62898, 'Bessemer City', 35.2847213745117, 0.615834563634049, -81.2841720581055, -1.41867643217152, 218, 33, 'PPL', 'P'),
(404, 'Bessemer Gardens', 33.4241714477539, 0.583361841514386, -86.9783325195313, -1.51805828036028, 218, 2, 'PPL', 'P'),
(405, 'Bessemer Homestead', 33.4036102294922, 0.583002980557497, -86.9388885498047, -1.51736985321849, 218, 2, 'PPL', 'P'),
(406, 'Bessemer Junction', 33.4247207641602, 0.58337142889431, -86.9691696166992, -1.51789835753682, 218, 2, 'PPL', 'P'),
(159167, 'Bessemer Junction', 40.3925018310547, 0.704982150069743, -79.8391723632813, -1.39345642980652, 218, 45, 'PPL', 'P'),
(44801, 'Bessen Landing', 38.0213890075684, 0.663598424363647, -75.3819427490234, -1.31566309752032, 218, 25, 'PPL', 'P'),
(15205, 'Bessent', 30.2211093902588, 0.527457862465392, -82.1147232055664, -1.43317228430093, 218, 12, 'PPL', 'P'),
(411, 'Bessie', 33.6497192382813, 0.587298393079686, -87.0330581665039, -1.51901342308523, 218, 2, 'PPL', 'P'),
(26510, 'Bessie', 37.9972190856934, 0.663176579646979, -88.8125, -1.55007054192746, 218, 18, 'PPL', 'P'),
(62899, 'Bessie', 35.1561088562012, 0.613589851730248, -83.1747207641602, -1.45167273176149, 218, 33, 'PPL', 'P'),
(75117, 'Bessie', 35.3858299255371, 0.617599240751362, -98.9877777099609, -1.72766264027107, 218, 42, 'PPL', 'P'),
(85010, 'Bessie', 36.4880599975586, 0.636836784622632, -89.4994430541992, -1.56205995999695, 218, 50, 'PPL', 'P'),
(7426, 'Bessie (historical)', 35.9197196960449, 0.626917375089441, -90.9702835083008, -1.58773096869255, 218, 4, 'PPL', 'P'),
(19230, 'Bessie (historical)', 33.8147201538086, 0.590178202324443, -82.8111114501953, -1.44532655204188, 218, 13, 'PPL', 'P'),
(44797, 'Bessie Clemson Heights', 39.4847183227539, 0.689138338954589, -77.2027816772461, -1.34744273196629, 218, 25, 'PPL', 'P'),
(92599, 'Bessie Heights', 30.0450000762939, 0.524384175093277, -93.9194412231445, -1.63920348097716, 218, 51, 'PPL', 'P'),
(413, 'Bessie Junction', 33.6369400024414, 0.587075353338392, -87.0363922119141, -1.51907161315505, 218, 2, 'PPL', 'P'),
(39367, 'Bessie K', 29.982780456543, 0.523298237869283, -90.7877807617188, -1.58454569487076, 218, 22, 'PPL', 'P'),
(212301, 'Bessie No. 5 Dredge Camp', 64.5500030517578, 1.12661008542556, -165.149993896484, -2.88241115314219, 218, 1, 'PPL', 'P'),
(194587, 'Besslen', 42.9086112976074, 0.748896544601686, -114.172782897949, -1.99269097773389, 218, 17, 'PPL', 'P'),
(92600, 'Bessmay', 30.4624996185303, 0.53167091673087, -93.9530563354492, -1.63979017536531, 218, 51, 'PPL', 'P'),
(53452, 'Bessville', 37.3713912963867, 0.6522538241731, -90.0888900756836, -1.57234775128792, 218, 29, 'PPL', 'P'),
(62900, 'Best', 35.3436088562012, 0.616862344077738, -77.8491668701172, -1.35872428181803, 218, 33, 'PPL', 'P'),
(147176, 'Best', 42.6155586242676, 0.743781810570134, -73.6377792358398, -1.28522170152212, 218, 40, 'PPL', 'P'),
(191133, 'Best', 31.2244396209717, 0.544969278476126, -101.620826721191, -1.77361801488342, 218, 51, 'PPL', 'P'),
(194588, 'Best Corner', 46.561939239502, 0.812659145842854, -116.149719238281, -2.02719502597501, 218, 17, 'PPL', 'P'),
(159169, 'Best Station', 40.7249984741211, 0.71078531124308, -75.6563873291016, -1.32045305905694, 218, 45, 'PPL', 'P'),
(203031, 'Best View', 40.6588897705078, 0.709631496700803, -111.938331604004, -1.95369244567909, 218, 52, 'PPL', 'P'),
(13369, 'Bestfield', 39.7194404602051, 0.69323501308043, -75.6083297729492, -1.31961429647162, 218, 10, 'PPL', 'P'),
(44798, 'Bestgate', 38.9916687011719, 0.68053299968227, -76.5469436645508, -1.33599619928502, 218, 25, 'PPL', 'P'),
(44799, 'Bestgate Terrace', 38.9930610656738, 0.680557301027217, -76.5380630493164, -1.33584120330958, 218, 25, 'PPL', 'P'),
(99881, 'Bestland', 37.8072204589844, 0.659860478036639, -76.8827819824219, -1.34185768368623, 218, 53, 'PPL', 'P'),
(44800, 'Bestpitch', 38.4169387817383, 0.670502070278432, -75.9911117553711, -1.32629510238219, 218, 25, 'PPL', 'P'),
(7427, 'Bests (historical)', 33.7311096191406, 0.588718923205134, -92.602783203125, -1.61622346340503, 218, 4, 'PPL', 'P'),
(85011, 'Bestview', 35.6730613708496, 0.622612375187328, -84.0013885498047, -1.46610080644116, 218, 50, 'PPL', 'P'),
(193377, 'Bestville', 41.3008308410645, 0.720835481985794, -123.141937255859, -2.14923225239902, 218, 6, 'PPL', 'P'),
(31814, 'Bestwall', 39.711109161377, 0.693089604484912, -96.647216796875, -1.68681214599424, 218, 20, 'PPL', 'P'),
(193378, 'Beswick', 41.9669418334961, 0.732461311987453, -122.201942443848, -2.13282624797775, 218, 6, 'PPL', 'P'),
(62901, 'Beta', 35.394718170166, 0.61775436988486, -83.190559387207, -1.45194916788264, 218, 33, 'PPL', 'P'),
(85012, 'Beta', 35.4263916015625, 0.618307175548133, -84.8708267211914, -1.48127536517437, 218, 50, 'PPL', 'P'),
(194108, 'Beta', 40.4661102294922, 0.706266858979597, -103.378326416016, -1.8042921711609, 218, 7, 'PPL', 'P'),
(180059, 'Betabel (historical)', 36.8974990844727, 0.643982844775641, -121.562217712402, -2.12166094510759, 218, 6, 'PPL', 'P'),
(193122, 'Betatakin Overlook', 36.6816711425781, 0.640215936571779, -110.530830383301, -1.92912691515198, 218, 5, 'PPL', 'P'),
(129801, 'Bete Grise', 47.3888893127441, 0.827092147370538, -87.9550018310547, -1.53510437554955, 218, 27, 'PPL', 'P'),
(79778, 'Beth Eden', 34.3530616760254, 0.599574034387325, -81.6227798461914, -1.42458625294651, 218, 48, 'PPL', 'P'),
(26511, 'Bethalto', 38.9091682434082, 0.679093095059892, -90.0405578613281, -1.57150419501264, 218, 18, 'PPL', 'P'),
(62902, 'Bethania', 36.1822204589844, 0.631498877691731, -80.3383331298828, -1.4021684286805, 218, 33, 'PPL', 'P'),
(62903, 'Bethania Station', 36.1694412231445, 0.631275837950437, -80.2905578613281, -1.40133459294319, 218, 33, 'PPL', 'P'),
(34787, 'Bethanna', 37.7752799987793, 0.659303011841458, -83.1836090087891, -1.45182786089499, 218, 21, 'PPL', 'P'),
(7428, 'Bethany', 34.0774993896484, 0.594764565195723, -94.0197219848633, -1.64095371044556, 218, 4, 'PPL', 'P'),
(15206, 'Bethany', 27.4738903045654, 0.479509844146414, -82.2644424438477, -1.43578537796251, 218, 12, 'PPL', 'P'),
(19234, 'Bethany', 33.5308303833008, 0.585223391116351, -83.4236068725586, -1.45601661381552, 218, 13, 'PPL', 'P'),
(26512, 'Bethany', 39.6455612182617, 0.691945577059641, -88.7380599975586, -1.54877131878967, 218, 18, 'PPL', 'P'),
(29206, 'Bethany', 39.8541717529297, 0.695586517743943, -87.147216796875, -1.52100586705478, 218, 19, 'PPL', 'P'),
(34790, 'Bethany', 38.098331451416, 0.66494132334332, -85.8722229003906, -1.49875302561829, 218, 21, 'PPL', 'P'),
(39368, 'Bethany', 32.3730583190918, 0.565016456608293, -94.0425033569336, -1.64135132039631, 218, 22, 'PPL', 'P'),
(58646, 'Bethany', 34.5052795410156, 0.60223073731176, -88.7291717529297, -1.54861618965617, 218, 30, 'PPL', 'P'),
(62905, 'Bethany', 36.3072204589844, 0.633680539256724, -79.85888671875, -1.39380051021936, 218, 33, 'PPL', 'P'),
(71806, 'Bethany', 39.3844413757324, 0.687388176065216, -84.3736114501953, -1.4725973216043, 218, 41, 'PPL', 'P'),
(75119, 'Bethany', 35.5186080932617, 0.619916656952922, -97.6319427490234, -1.70399885608906, 218, 42, 'PPL', 'P'),
(79779, 'Bethany', 35.1169395446777, 0.612906218278425, -81.3063888549805, -1.41906418842623, 218, 48, 'PPL', 'P'),
(85015, 'Bethany', 35.7063903808594, 0.623194076148428, -85.8541717529297, -1.49843797366133, 218, 50, 'PPL', 'P'),
(92601, 'Bethany', 32.3730583190918, 0.565016456608293, -94.0430603027344, -1.64136104093429, 218, 51, 'PPL', 'P'),
(99882, 'Bethany', 36.8436088562012, 0.643042282857652, -80.8805618286133, -1.41163210477215, 218, 53, 'PPL', 'P'),
(134242, 'Bethany', 44.024169921875, 0.768366715594174, -91.9113922119141, -1.60415641418977, 218, 28, 'PPL', 'P'),
(139036, 'Bethany', 40.2683296203613, 0.702814936153663, -94.0280609130859, -1.64109925219914, 218, 29, 'PPL', 'P'),
(141297, 'Bethany', 40.8325004577637, 0.712661574810068, -96.633056640625, -1.68656500464508, 218, 35, 'PPL', 'P'),
(159171, 'Bethany', 41.6130599975586, 0.726284908787341, -75.2847213745117, -1.31396626443178, 218, 45, 'PPL', 'P'),
(177185, 'Bethany', 40.2055587768555, 0.701719378260232, -80.5569381713867, -1.4059838064162, 218, 58, 'PPL', 'P'),
(177495, 'Bethany', 41.4216690063477, 0.722944505832055, -72.9974975585938, -1.27404667811398, 218, 8, 'PPL', 'P'),
(200405, 'Bethany', 45.5580596923828, 0.795138142452195, -122.866386413574, -2.1444229829445, 218, 43, 'PPL', 'P'),
(62906, 'Bethany (historical)', 35.957218170166, 0.627571846927328, -80.164436340332, -1.39913335714419, 218, 33, 'PPL', 'P'),
(79780, 'Bethany (historical)', 33.8494415283203, 0.590784204630491, -82.1508331298828, -1.43380252137289, 218, 48, 'PPL', 'P'),
(13370, 'Bethany Beach', 38.5394401550293, 0.672640122580575, -75.0555572509766, -1.30996659594865, 218, 10, 'PPL', 'P'),
(129802, 'Bethany Beach', 41.8913917541504, 0.731142714352727, -86.6180572509766, -1.51177029071049, 218, 27, 'PPL', 'P'),
(147177, 'Bethany Center', 42.9038887023926, 0.748814119765948, -78.1336135864258, -1.36368881356411, 218, 40, 'PPL', 'P'),
(39369, 'Bethany Cooperative Community', 30.5738906860352, 0.533615057616141, -91.1347198486328, -1.59060092424127, 218, 22, 'PPL', 'P'),
(62907, 'Bethany Crossroads', 35.0633316040039, 0.611970583208453, -78.6969375610352, -1.37352067167646, 218, 33, 'PPL', 'P'),
(13371, 'Bethany Dunes', 38.563060760498, 0.673052379917319, -75.0586090087891, -1.31001985917045, 218, 10, 'PPL', 'P'),
(193123, 'Bethany Grand Mobile Home Park', 33.5261116027832, 0.58514103285964, -112.164436340332, -1.95763871778237, 218, 5, 'PPL', 'P'),
(114594, 'Bethany Hall', 43.1772193908691, 0.753584640226607, -92.2397232055664, -1.60988687106535, 218, 16, 'PPL', 'P'),
(85016, 'Bethany Hills', 36.0344390869141, 0.62891960617599, -86.9533309936523, -1.51762192141567, 218, 50, 'PPL', 'P'),
(44802, 'Bethany Manor', 39.2922210693359, 0.685778628081399, -76.8605575561523, -1.34146979427346, 218, 25, 'PPL', 'P'),
(180060, 'Bethany Park', 37.0758285522461, 0.647095281141617, -121.991943359375, -2.12916107252753, 218, 6, 'PPL', 'P'),
(193121, 'Bethany Villa Adult Mobile Home Park', 33.5261116027832, 0.58514103285964, -112.163330078125, -1.95761940986447, 218, 5, 'PPL', 'P'),
(13372, 'Bethany Village', 38.5597190856934, 0.672994056689447, -75.0591735839844, -1.31002971286648, 218, 10, 'PPL', 'P'),
(177496, 'Bethany Wood', 41.4527816772461, 0.723487524378322, -72.9791717529297, -1.27372683246706, 218, 8, 'PPL', 'P'),
(92602, 'Bethard', 32.9036102294922, 0.574276334297526, -96.6911087036133, -1.6875782042818, 218, 51, 'PPL', 'P'),
(159173, 'Bethayres', 40.1138916015625, 0.700119484235367, -75.0713882446289, -1.31024289891174, 218, 45, 'PPL', 'P'),
(58647, 'Betheden', 33.2197189331055, 0.579793471969788, -88.9408264160156, -1.55231026040422, 218, 30, 'PPL', 'P'),
(7434, 'Bethel', 35.2255592346191, 0.614801989500398, -93.2227783203125, -1.62704441954624, 218, 4, 'PPL', 'P'),
(13375, 'Bethel', 38.4538917541504, 0.671147021315422, -75.355827331543, -1.31520729749976, 218, 10, 'PPL', 'P'),
(15207, 'Bethel', 30.2519397735596, 0.527995954163642, -84.3241729736328, -1.47173445741111, 218, 12, 'PPL', 'P'),
(19241, 'Bethel', 31.6583309173584, 0.552542110193821, -83.5666732788086, -1.45851359365358, 218, 13, 'PPL', 'P'),
(31816, 'Bethel', 39.1444396972656, 0.683199356565658, -94.7583312988281, -1.65384487486015, 218, 20, 'PPL', 'P'),
(34789, 'Bethel', 38.2449989318848, 0.667501153783104, -83.8680572509766, -1.46377373628065, 218, 21, 'PPL', 'P'),
(39371, 'Bethel', 30.9216709136963, 0.539684967662164, -92.7094421386719, -1.618085013007, 218, 22, 'PPL', 'P'),
(44807, 'Bethel', 39.4449996948242, 0.688445118122841, -79.1188888549805, -1.38088511103886, 218, 25, 'PPL', 'P'),
(53454, 'Bethel', 39.8766708374023, 0.695979200846675, -92.0238876342773, -1.60611982970344, 218, 29, 'PPL', 'P'),
(58652, 'Bethel', 32.2819404602051, 0.563426149963352, -89.1944427490234, -1.55673670045204, 218, 30, 'PPL', 'P'),
(62915, 'Bethel', 36.2933311462402, 0.6334381250185, -81.8494415283203, -1.42854224558777, 218, 33, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(71809, 'Bethel', 39.0094413757324, 0.680843191370237, -83.123893737793, -1.45078563280238, 218, 41, 'PPL', 'P'),
(75120, 'Bethel', 34.3597183227539, 0.599690214789879, -94.8372192382813, -1.65522172914372, 218, 42, 'PPL', 'P'),
(79782, 'Bethel', 33.4411087036133, 0.583657452395384, -79.4916687011719, -1.38739134673997, 218, 48, 'PPL', 'P'),
(85029, 'Bethel', 35.9313888549805, 0.627121040333805, -86.4302825927734, -1.50849300467304, 218, 50, 'PPL', 'P'),
(92609, 'Bethel', 32.9599990844727, 0.575260505478364, -96.9763870239258, -1.69255725025581, 218, 51, 'PPL', 'P'),
(99888, 'Bethel', 36.6752815246582, 0.640104416701132, -81.878059387207, -1.42904172145021, 218, 53, 'PPL', 'P'),
(112191, 'Bethel', 33.6430587768555, 0.587182146098104, -87.4000015258789, -1.52541779287465, 218, 2, 'PPL', 'P'),
(112294, 'Bethel', 39.7763900756836, 0.694228971378275, -90.4247207641602, -1.57820910253108, 218, 18, 'PPL', 'P'),
(114595, 'Bethel', 41.3730583190918, 0.722096089287783, -91.4833297729492, -1.59668531522572, 218, 16, 'PPL', 'P'),
(122220, 'Bethel', 40.25, 0.702495023927718, -85.5338897705078, -1.49284799853326, 218, 19, 'PPL', 'P'),
(126874, 'Bethel', 44.4041709899902, 0.77499898539388, -70.7911071777344, -1.23553790138366, 218, 26, 'PPL', 'P'),
(129804, 'Bethel', 41.8327789306641, 0.730119727599001, -85.0736083984375, -1.48481457310503, 218, 27, 'PPL', 'P'),
(134243, 'Bethel', 45.4038887023926, 0.792447351065806, -93.2675018310547, -1.62782499206174, 218, 28, 'PPL', 'P'),
(147180, 'Bethel', 41.6833305358887, 0.72751136104835, -74.8716735839844, -1.30675722051899, 218, 40, 'PPL', 'P'),
(159178, 'Bethel', 41.5638885498047, 0.725426705126063, -75.1900024414063, -1.31231310718511, 218, 45, 'PPL', 'P'),
(169280, 'Bethel', 41.4286117553711, 0.723065679661653, -71.7911071777344, -1.2529911939036, 218, 47, 'PPL', 'P'),
(171744, 'Bethel', 43.8333282470703, 0.765035900018812, -72.6344375610352, -1.2677100857743, 218, 55, 'PPL', 'P'),
(173167, 'Bethel', 44.5405616760254, 0.777379451934247, -90.0897216796875, -1.57236226551586, 218, 57, 'PPL', 'P'),
(177506, 'Bethel', 41.5469398498535, 0.725130894507982, -71.908332824707, -1.25503716741105, 218, 8, 'PPL', 'P'),
(188140, 'Bethel', 34.2286109924316, 0.597401960202256, -103.474166870117, -1.80596490264158, 218, 38, 'PPL', 'P'),
(200407, 'Bethel', 45.0405616760254, 0.786106098194219, -123.183609008789, -2.14995956169272, 218, 43, 'PPL', 'P'),
(206826, 'Bethel', 47.4941711425781, 0.828929661943665, -122.629997253418, -2.14029721378375, 218, 56, 'PPL', 'P'),
(212302, 'Bethel', 60.7922210693359, 1.06102441726018, -161.755828857422, -2.82317179785447, 218, 1, 'PPL', 'P'),
(441, 'Bethel (historical)', 32.7297210693359, 0.571241395919271, -88.279167175293, -1.54076212812736, 218, 2, 'PPL', 'P'),
(7435, 'Bethel (historical)', 34.2675018310547, 0.59808073338509, -94.0297164916992, -1.64112814749696, 218, 4, 'PPL', 'P'),
(19243, 'Bethel (historical)', 31.2177791595459, 0.544853031494544, -81.6638870239258, -1.42530370854418, 218, 13, 'PPL', 'P'),
(26514, 'Bethel (historical)', 38.7041702270508, 0.675515204714397, -88.6880569458008, -1.54789860090045, 218, 18, 'PPL', 'P'),
(44808, 'Bethel (historical)', 38.185001373291, 0.666453998842485, -75.8611068725586, -1.32402608913345, 218, 25, 'PPL', 'P'),
(58653, 'Bethel (historical)', 33.8494415283203, 0.590784204630491, -89.0016708374023, -1.55337219588889, 218, 30, 'PPL', 'P'),
(62916, 'Bethel (historical)', 36.1063919067383, 0.630175419788016, -76.5261077880859, -1.33563254463817, 218, 33, 'PPL', 'P'),
(79783, 'Bethel (historical)', 35.1011085510254, 0.612629915315329, -81.1502838134766, -1.41633964147303, 218, 48, 'PPL', 'P'),
(85030, 'Bethel (historical)', 36.3233299255371, 0.633961702488809, -89.3619384765625, -1.55966005238062, 218, 50, 'PPL', 'P'),
(108198, 'Bethel (historical)', 37.271110534668, 0.6505035947047, -81.1675033569336, -1.41664017920204, 218, 58, 'PPL', 'P'),
(75121, 'Bethel Acres', 35.3086090087891, 0.616251481502701, -97.0252838134766, -1.69341066022713, 218, 42, 'PPL', 'P'),
(7437, 'Bethel Chapel', 34.3930587768555, 0.600272115488062, -94.3291702270508, -1.64635460113624, 218, 4, 'PPL', 'P'),
(99889, 'Bethel Church', 36.9541702270508, 0.644971942804497, -76.7144393920898, -1.33891955121361, 218, 53, 'PPL', 'P'),
(147182, 'Bethel Corners', 43.5719413757324, 0.760473838492479, -76.1875, -1.32972272386318, 218, 40, 'PPL', 'P'),
(92610, 'Bethel Estates Number 1 Colonia', 27.9270000457764, 0.487418101003405, -97.5820007324219, -1.70312720346428, 218, 51, 'PPL', 'P'),
(92618, 'Bethel Estates Number 2 Colonia', 27.9330005645752, 0.487522829813272, -97.5810012817383, -1.70310975975914, 218, 51, 'PPL', 'P'),
(200408, 'Bethel Gospel Park', 45.0541687011719, 0.786343585584426, -122.950828552246, -2.14589677629175, 218, 43, 'PPL', 'P'),
(516, 'Bethel Grove', 34.9902801513672, 0.610695594836577, -87.7255630493164, -1.53109991337645, 218, 2, 'PPL', 'P'),
(147183, 'Bethel Grove', 42.4052810668945, 0.740111774850923, -76.4297180175781, -1.33395022577757, 218, 40, 'PPL', 'P'),
(7438, 'Bethel Heights', 36.214168548584, 0.632056477044967, -94.1291732788086, -1.64286399589548, 218, 4, 'PPL', 'P'),
(200409, 'Bethel Heights', 45.0447196960449, 0.786178669333923, -123.149436950684, -2.14936314676659, 218, 43, 'PPL', 'P'),
(62917, 'Bethel Hill', 36.5044403076172, 0.637122674965652, -78.9172210693359, -1.37736534418415, 218, 33, 'PPL', 'P'),
(159179, 'Bethel Hill', 40.1838912963867, 0.701341209385441, -75.3186111450195, -1.31455775250989, 218, 45, 'PPL', 'P'),
(180061, 'Bethel Island', 38.0149993896484, 0.663486904493, -121.639442443848, -2.12300877093528, 218, 6, 'PPL', 'P'),
(159180, 'Bethel Park', 40.3274993896484, 0.703847643445369, -80.0397186279297, -1.39695662242721, 218, 45, 'PPL', 'P'),
(206827, 'Bethel Park', 47.4736099243164, 0.828570800986777, -122.484718322754, -2.13776161810988, 218, 56, 'PPL', 'P'),
(44809, 'Bethel Ridge', 39.5475006103516, 0.690234096585102, -76.9208297729492, -1.34252174290405, 218, 25, 'PPL', 'P'),
(39372, 'Bethel Springs', 32.9608306884766, 0.575275019706305, -92.7111129760742, -1.61811417462093, 218, 22, 'PPL', 'P'),
(85031, 'Bethel Springs', 35.2336082458496, 0.614942471247899, -88.6063919067383, -1.54647327708504, 218, 50, 'PPL', 'P'),
(29208, 'Bethel Village', 39.1519393920898, 0.683330250933235, -85.9247207641602, -1.49966928619133, 218, 19, 'PPL', 'P'),
(77860, 'Bethelboro', 39.935001373291, 0.696997260752385, -79.6705627441406, -1.39051363680198, 218, 45, 'PPL', 'P'),
(114597, 'Bethelhem', 40.8413887023926, 0.712816703943565, -93.2119369506836, -1.62685520195079, 218, 16, 'PPL', 'P'),
(34791, 'Bethelridge', 37.2336082458496, 0.649849056287786, -84.7583312988281, -1.47931194966071, 218, 21, 'PPL', 'P'),
(79784, 'Bethera', 33.2013893127441, 0.579473559743843, -79.788330078125, -1.39256906453131, 218, 48, 'PPL', 'P'),
(7439, 'Bethesda', 35.791389465332, 0.624677590033657, -91.788330078125, -1.60200857477063, 218, 4, 'PPL', 'P'),
(13376, 'Bethesda', 39.1375007629395, 0.683078249315086, -75.6930618286133, -1.32109314982494, 218, 10, 'PPL', 'P'),
(19247, 'Bethesda', 33.9213905334473, 0.59203995166349, -84.0841674804688, -1.46754557133252, 218, 13, 'PPL', 'P'),
(34792, 'Bethesda', 36.790828704834, 0.642121095436594, -84.9058303833008, -1.48188629432844, 218, 21, 'PPL', 'P'),
(44810, 'Bethesda', 38.9805603027344, 0.680339121554912, -77.1005630493164, -1.34565868035205, 218, 25, 'PPL', 'P'),
(62922, 'Bethesda', 35.9422187805176, 0.627310058192173, -78.8386077880859, -1.37599328359054, 218, 33, 'PPL', 'P'),
(77861, 'Bethesda', 39.8458290100098, 0.695440909411343, -76.3041687011719, -1.33175897683265, 218, 45, 'PPL', 'P'),
(79785, 'Bethesda', 34.6411094665527, 0.604601416735122, -80.0477828979492, -1.39709737049082, 218, 48, 'PPL', 'P'),
(85033, 'Bethesda', 35.7611083984375, 0.624149085715331, -86.7930603027344, -1.5148246701647, 218, 50, 'PPL', 'P'),
(108200, 'Bethesda', 38.1894416809082, 0.666531496830206, -82.4227828979492, -1.43854894022569, 218, 58, 'PPL', 'P'),
(112429, 'Bethesda', 32.1369400024414, 0.560895414558477, -90.3702774047852, -1.57725888665414, 218, 30, 'PPL', 'P'),
(114598, 'Bethesda', 40.8430595397949, 0.712845865557501, -95.0994415283203, -1.65979837147702, 218, 16, 'PPL', 'P'),
(154303, 'Bethesda', 40.0161094665527, 0.698412864029817, -81.0727767944336, -1.41498688879732, 218, 41, 'PPL', 'P'),
(173168, 'Bethesda', 42.9877815246582, 0.750278325733274, -88.3183288574219, -1.54144562842113, 218, 57, 'PPL', 'P'),
(58654, 'Bethesda (historical)', 32.8305587768555, 0.57300134592565, -90.3249969482422, -1.57646859360066, 218, 30, 'PPL', 'P'),
(19248, 'Bethesda Woods South', 33.5077781677246, 0.584821054054667, -84.461669921875, -1.47413423186938, 218, 13, 'PPL', 'P'),
(122221, 'Bethevan', 40.5250015258789, 0.707294706002313, -85.6333312988281, -1.49458358061566, 218, 19, 'PPL', 'P'),
(44811, 'Bethgate', 39.2916717529297, 0.685769040701475, -76.8541717529297, -1.34135834098185, 218, 25, 'PPL', 'P'),
(79786, 'Bethiah', 34.0638885498047, 0.594527011226488, -82.3755569458008, -1.43772469186831, 218, 48, 'PPL', 'P'),
(553, 'Bethlehem', 33.5033302307129, 0.584743422908891, -85.9613876342773, -1.50030924380128, 218, 2, 'PPL', 'P'),
(7441, 'Bethlehem', 35.2836112976074, 0.615815189137118, -92.5875015258789, -1.61595674782186, 218, 4, 'PPL', 'P'),
(15208, 'Bethlehem', 30.9244403839111, 0.539733304035949, -85.7391662597656, -1.49643074914774, 218, 12, 'PPL', 'P'),
(19250, 'Bethlehem', 34.9019393920898, 0.609153757723476, -84.0774993896484, -1.46742919119289, 218, 13, 'PPL', 'P'),
(29210, 'Bethlehem', 38.5391693115234, 0.67263539546964, -85.4205627441406, -1.49087006879166, 218, 19, 'PPL', 'P'),
(34793, 'Bethlehem', 38.4005584716797, 0.670216179935412, -85.0694427490234, -1.48474186880728, 218, 21, 'PPL', 'P'),
(39373, 'Bethlehem', 32.0052795410156, 0.558597506011902, -92.7733306884766, -1.61920007855541, 218, 22, 'PPL', 'P'),
(44812, 'Bethlehem', 38.7461090087891, 0.676247174540006, -75.9444427490234, -1.32548057456279, 218, 25, 'PPL', 'P'),
(53456, 'Bethlehem', 36.7208290100098, 0.64089937028652, -94.1322174072266, -1.64291712595922, 218, 29, 'PPL', 'P'),
(58655, 'Bethlehem', 34.5783309936523, 0.603505725683636, -89.3274993896484, -1.55905897692259, 218, 30, 'PPL', 'P'),
(62925, 'Bethlehem', 36.4555587768555, 0.636269531310445, -79.7188873291016, -1.39135705991921, 218, 33, 'PPL', 'P'),
(85041, 'Bethlehem', 36.0008316040039, 0.6283330449459, -86.8850021362305, -1.51642935787953, 218, 50, 'PPL', 'P'),
(92613, 'Bethlehem', 32.6577796936035, 0.569985782044326, -94.7938919067383, -1.65446552455219, 218, 51, 'PPL', 'P'),
(143522, 'Bethlehem', 44.2802810668945, 0.772836698325817, -71.688606262207, -1.25120221544134, 218, 36, 'PPL', 'P'),
(154304, 'Bethlehem', 40.8386116027832, 0.712768234411726, -82.7200012207031, -1.443736378555, 218, 41, 'PPL', 'P'),
(159186, 'Bethlehem', 40.6258316040039, 0.709054522850637, -75.3708267211914, -1.31546908623491, 218, 45, 'PPL', 'P'),
(177186, 'Bethlehem', 40.0438919067383, 0.698897759085293, -80.6908264160156, -1.40832059711469, 218, 58, 'PPL', 'P'),
(177499, 'Bethlehem', 41.639720916748, 0.726750229608805, -73.2088928222656, -1.27773622148818, 218, 8, 'PPL', 'P'),
(85042, 'Bethlehem (historical)', 35.7622184753418, 0.624168460212261, -86.1136093139648, -1.50296601330474, 218, 50, 'PPL', 'P'),
(154305, 'Bethlehem (historical)', 40.4836082458496, 0.706572256977602, -83.1319427490234, -1.45092611454989, 218, 41, 'PPL', 'P'),
(147185, 'Bethlehem Center', 42.6019401550293, 0.743544123442845, -73.7919387817383, -1.28791229317143, 218, 40, 'PPL', 'P'),
(99890, 'Bethlehem Court', 36.7211112976074, 0.640904297134537, -76.6347198486328, -1.33752818270209, 218, 53, 'PPL', 'P'),
(99891, 'Bethlehem Fork', 38.0138893127441, 0.66346752999607, -77.0897216796875, -1.3454694627566, 218, 53, 'PPL', 'P'),
(147186, 'Bethlehem Heights', 42.5341682434082, 0.742361280444686, -73.8330612182617, -1.2886300150852, 218, 40, 'PPL', 'P'),
(99892, 'Bethlehem Terrace', 36.7255592346191, 0.640981928280313, -76.6427764892578, -1.33766879760765, 218, 53, 'PPL', 'P'),
(62926, 'Bethney Heights', 35.3994407653809, 0.617836794720597, -80.2099990844727, -1.39992857704569, 218, 33, 'PPL', 'P'),
(53458, 'Bethpage', 36.689998626709, 0.64036127858827, -94.2361068725586, -1.6447303391874, 218, 29, 'PPL', 'P'),
(85044, 'Bethpage', 36.4816703796387, 0.636725264751985, -86.3119430541992, -1.50642759008963, 218, 50, 'PPL', 'P'),
(147188, 'Bethpage', 40.7441711425781, 0.711119937434048, -73.4824981689453, -1.2825115356388, 218, 40, 'PPL', 'P'),
(599, 'Bethsaida', 34.5536117553711, 0.603074293587043, -87.5566711425781, -1.52815219352389, 218, 2, 'PPL', 'P'),
(58656, 'Bethsaida', 32.6761093139648, 0.570305694270272, -89.0347213745117, -1.553949036581, 218, 30, 'PPL', 'P'),
(92614, 'Bethsaida', 33.0355606079102, 0.576579302850172, -94.1877822875977, -1.64388691607018, 218, 51, 'PPL', 'P'),
(19251, 'Bethsaida West', 33.5611114501953, 0.585751895434677, -84.4861068725586, -1.47456073711796, 218, 13, 'PPL', 'P'),
(19252, 'Bethsaida Woods', 33.5613899230957, 0.585756755703666, -84.4433288574219, -1.47381411990635, 218, 13, 'PPL', 'P'),
(85045, 'Bethsalem', 35.389720916748, 0.61766715135916, -84.5672225952148, -1.47597647355344, 218, 50, 'PPL', 'P'),
(79788, 'Bethune', 34.4147186279297, 0.600650151204798, -80.3488922119141, -1.40235271942793, 218, 48, 'PPL', 'P'),
(180062, 'Bethune', 34.079719543457, 0.594803314189584, -117.30583190918, -2.04737299860621, 218, 6, 'PPL', 'P'),
(186410, 'Bethune', 39.3041687011719, 0.685987153594752, -102.424171447754, -1.78763902539047, 218, 7, 'PPL', 'P'),
(15209, 'Bethune Beach', 28.9488906860352, 0.505253457271234, -80.8380584716797, -1.41089028125051, 218, 12, 'PPL', 'P'),
(44813, 'Bethwood', 39.2891693115234, 0.685725364859598, -76.8513870239258, -1.34130973829195, 218, 25, 'PPL', 'P'),
(31817, 'Beto Junction', 38.4055595397949, 0.67030346504014, -95.6916732788086, -1.67013476545789, 218, 20, 'PPL', 'P'),
(92615, 'Beto''s Acres Colonia', 26.1159992218018, 0.455810173868718, -98.1989974975586, -1.71389582849007, 218, 51, 'PPL', 'P'),
(523, 'Betsey', 36.9036102294922, 0.644089504377299, -84.7430572509766, -1.4790453672356, 218, 21, 'PPL', 'P'),
(129807, 'Betsy', 47.2966690063477, 0.825482599386721, -88.059440612793, -1.53692717615765, 218, 27, 'PPL', 'P'),
(34794, 'Betsy Layne', 37.5513916015625, 0.655395422153012, -82.6336135864258, -1.44222862990385, 218, 21, 'PPL', 'P'),
(85046, 'Betsy Willis', 35.3319396972656, 0.616658678833374, -85.9219436645508, -1.49962081665949, 218, 50, 'PPL', 'P'),
(85047, 'Betsystown (historical)', 36.3194389343262, 0.633893791881012, -87.2263870239258, -1.52238764818636, 218, 50, 'PPL', 'P'),
(58660, 'Bett', 34.6922187805176, 0.605493442542244, -89.7574996948242, -1.56656389803249, 218, 30, 'PPL', 'P'),
(114599, 'Bettendorf', 41.5244407653809, 0.72473821140525, -90.5155563354492, -1.579794482328, 218, 16, 'PPL', 'P'),
(180063, 'Betteravia', 34.917781829834, 0.609430260423653, -120.513893127441, -2.10336422947042, 218, 6, 'PPL', 'P'),
(180064, 'Betteravia Junction', 34.9275016784668, 0.609599903785091, -120.532783508301, -2.10369392881337, 218, 6, 'PPL', 'P'),
(44814, 'Betterton', 39.3658294677734, 0.687063336991254, -76.0625, -1.32754106229819, 218, 25, 'PPL', 'P'),
(154308, 'Bettes Corners', 41.1027793884277, 0.717378832048925, -81.4888916015625, -1.42224946224802, 218, 41, 'PPL', 'P'),
(62927, 'Bettie', 34.7911109924316, 0.607219437244724, -76.5963897705078, -1.33685919663627, 218, 33, 'PPL', 'P'),
(92616, 'Bettie', 32.8083305358887, 0.572613389933853, -94.9611129760742, -1.65738408279081, 218, 51, 'PPL', 'P'),
(206828, 'Bettie', 46.6763916015625, 0.814656716397495, -119.527221679688, -2.08614356407169, 218, 56, 'PPL', 'P'),
(92617, 'Bettis', 33.7461090087891, 0.588980711940289, -96.1433334350586, -1.67801772228452, 218, 51, 'PPL', 'P'),
(212304, 'Bettles', 66.9188919067383, 1.16795499555877, -151.51611328125, -2.64445504658252, 218, 1, 'PPL', 'P'),
(15210, 'Betts', 30.5375003814697, 0.532979926985671, -85.3933334350586, -1.49039482769513, 218, 12, 'PPL', 'P'),
(19253, 'Betts', 32.9516716003418, 0.575115163461873, -84.5875015258789, -1.47633040766231, 218, 13, 'PPL', 'P'),
(169831, 'Betts', 43.7063903808594, 0.762820416307974, -98.1458282470703, -1.71296785000823, 218, 49, 'PPL', 'P'),
(609, 'Betts Lower Landing', 31.2075004577637, 0.544673634305614, -87.8497161865234, -1.53326679439739, 218, 2, 'PPL', 'P'),
(147189, 'Bettsburg', 42.2016716003418, 0.736558119271349, -75.5475006103516, -1.31855262730306, 218, 40, 'PPL', 'P'),
(154309, 'Bettsville', 41.2463912963867, 0.719885332687881, -83.2358322143555, -1.45273932777807, 218, 41, 'PPL', 'P'),
(34795, 'Betty', 37.4508285522461, 0.653640265836596, -82.8394393920898, -1.44582096789826, 218, 21, 'PPL', 'P'),
(92619, 'Betty Acres Colonia', 25.9099998474121, 0.45221480652857, -97.4130020141602, -1.70017761939896, 218, 51, 'PPL', 'P'),
(129808, 'Betty B Landing', 46.4005584716797, 0.809842520094959, -85.2777786254883, -1.48837801580161, 218, 27, 'PPL', 'P'),
(203033, 'Betty Heights', 40.6144409179688, 0.708855717875263, -111.873329162598, -1.95255793905472, 218, 52, 'PPL', 'P'),
(19254, 'Betty Mobile Home Park', 32.6369400024414, 0.569622060818449, -83.6888885498047, -1.46064665252867, 218, 13, 'PPL', 'P'),
(199836, 'Betty O''Neal (historical)', 40.4594383239746, 0.706150412260933, -116.892501831055, -2.0401590278454, 218, 39, 'PPL', 'P'),
(177187, 'Betty Zane', 40.1433296203613, 0.700633274588671, -80.6624984741211, -1.40782618125832, 218, 58, 'PPL', 'P'),
(159190, 'Betula', 41.6708297729492, 0.727293181576045, -78.3938903808594, -1.36823150059351, 218, 45, 'PPL', 'P'),
(19255, 'Between', 33.8175010681152, 0.59022673843531, -83.807502746582, -1.46271686080205, 218, 13, 'PPL', 'P'),
(122223, 'Between-The-Lakes Park', 41.3247184753418, 0.721252399854445, -85.7366714477539, -1.49638720646392, 218, 19, 'PPL', 'P'),
(159191, 'Betz', 40.8452796936035, 0.712884614551362, -78.4361114501953, -1.36896839726713, 218, 45, 'PPL', 'P'),
(129809, 'Betzer', 41.753059387207, 0.728728359087489, -84.475830078125, -1.47438137321854, 218, 27, 'PPL', 'P'),
(159192, 'Betzwood', 40.1105613708496, 0.700061360744576, -75.4199981689453, -1.31632728989619, 218, 45, 'PPL', 'P'),
(159193, 'Beuchler', 40.5491714477539, 0.707716550718982, -76.4388885498047, -1.33411028175909, 218, 45, 'PPL', 'P'),
(154310, 'Beudale (historical)', 41.4900016784668, 0.724137135947219, -81.2750015258789, -1.41851637619, 218, 41, 'PPL', 'P'),
(79789, 'Beufordtown', 33.2838897705078, 0.580913464366221, -79.7436065673828, -1.3917884920158, 218, 48, 'PPL', 'P'),
(159194, 'Beuhler Corner', 41.4077796936035, 0.72270209159383, -78.8847198486328, -1.37679809087197, 218, 45, 'PPL', 'P'),
(147190, 'Beukendaal', 42.8549995422363, 0.747960842952687, -73.980827331543, -1.29120902028484, 218, 40, 'PPL', 'P'),
(159195, 'Beula', 40.4766693115234, 0.70645114972703, -78.772216796875, -1.37483454220025, 218, 45, 'PPL', 'P'),
(618, 'Beulah', 32.711109161377, 0.570916556845309, -85.1822204589844, -1.48671021116895, 218, 2, 'PPL', 'P'),
(15212, 'Beulah', 28.5344390869141, 0.498019912276415, -81.5727767944336, -1.42371353505729, 218, 12, 'PPL', 'P'),
(19259, 'Beulah', 33.8786087036133, 0.59129326787286, -85.0041732788086, -1.48360270165099, 218, 13, 'PPL', 'P'),
(31820, 'Beulah', 37.4402809143066, 0.653456174826244, -94.8280563354492, -1.65506180632026, 218, 20, 'PPL', 'P'),
(34798, 'Beulah', 36.7677803039551, 0.641718824953938, -88.8680572509766, -1.55104019888036, 218, 21, 'PPL', 'P'),
(44815, 'Beulah', 38.6777801513672, 0.675054611003868, -75.8994369506836, -1.32469507519927, 218, 25, 'PPL', 'P'),
(53460, 'Beulah', 37.6241683959961, 0.656665616834926, -91.9169387817383, -1.6042532200954, 218, 29, 'PPL', 'P'),
(58658, 'Beulah', 32.5083312988281, 0.567377415493675, -89.0299987792969, -1.55386661174526, 218, 30, 'PPL', 'P'),
(62930, 'Beulah', 34.9500007629395, 0.609992586887824, -78.3369369506836, -1.36723747571664, 218, 33, 'PPL', 'P'),
(85049, 'Beulah', 36.1852798461914, 0.631552274071587, -83.9261093139648, -1.46478693591737, 218, 50, 'PPL', 'P'),
(92621, 'Beulah', 31.4575004577637, 0.549036957435599, -96.5516662597656, -1.68514447451963, 218, 51, 'PPL', 'P'),
(99894, 'Beulah', 37.3833312988281, 0.652462216528399, -76.442497253418, -1.33417326551887, 218, 53, 'PPL', 'P'),
(108202, 'Beulah', 38.7511100769043, 0.676334459644733, -79.758056640625, -1.39204069337103, 218, 58, 'PPL', 'P'),
(112222, 'Beulah', 33.4891700744629, 0.584496281559732, -91.853889465332, -1.60315280193298, 218, 4, 'PPL', 'P'),
(114600, 'Beulah', 43.0272216796875, 0.750966686296032, -91.3080596923828, -1.5936262752396, 218, 16, 'PPL', 'P'),
(129810, 'Beulah', 44.6319389343262, 0.778974285953041, -86.0908279418945, -1.50256840335399, 218, 27, 'PPL', 'P'),
(147192, 'Beulah', 43.0186080932617, 0.750816350852497, -77.8919372558594, -1.35947076587158, 218, 40, 'PPL', 'P'),
(159196, 'Beulah', 40.8086090087891, 0.712244590362389, -78.4102783203125, -1.36851752409458, 218, 45, 'PPL', 'P'),
(186413, 'Beulah', 38.0750007629395, 0.664534126012646, -104.986106872559, -1.83235323377679, 218, 7, 'PPL', 'P'),
(198005, 'Beulah', 47.2633285522461, 0.824900698688539, -101.777496337891, -1.77635241553266, 218, 34, 'PPL', 'P'),
(200410, 'Beulah', 43.9066696166992, 0.766315948396758, -118.151672363281, -2.06213569947685, 218, 43, 'PPL', 'P'),
(209304, 'Beulah', 44.5444412231445, 0.777447162804962, -104.088607788086, -1.81668891971911, 218, 59, 'PPL', 'P'),
(58659, 'Beulah (historical)', 32.9555587768555, 0.575183007490643, -89.4847183227539, -1.56180296495175, 218, 30, 'PPL', 'P'),
(199835, 'Beulah (historical)', 41.8163909912109, 0.729833704097926, -119.843063354492, -2.09165604121205, 218, 39, 'PPL', 'P'),
(206829, 'Beulah (historical)', 48.5922203063965, 0.848094235201066, -118.136672973633, -2.06187391074169, 218, 56, 'PPL', 'P'),
(154311, 'Beulah Beach', 41.3919410705566, 0.72242565547268, -82.4422225952148, -1.43888822694856, 218, 41, 'PPL', 'P'),
(124243, 'Beulah Corners', 41.6611099243164, 0.727123538214607, -71.084716796875, -1.24066235595319, 218, 23, 'PPL', 'P'),
(19260, 'Beulah Heights', 33.7350006103516, 0.588786833812931, -84.350830078125, -1.47219971165355, 218, 13, 'PPL', 'P'),
(34797, 'Beulah Heights', 36.8041687011719, 0.642353922294894, -84.4394378662109, -1.47374620929856, 218, 21, 'PPL', 'P'),
(99895, 'Beulah Heights', 37.226390838623, 0.649723088768225, -79.98388671875, -1.39598217178435, 218, 53, 'PPL', 'P'),
(108203, 'Beulah Hill', 39.1169395446777, 0.682719388358198, -81.4222183227539, -1.42108579400971, 218, 58, 'PPL', 'P'),
(7443, 'Beulah Island Landing', 33.8025016784668, 0.589964949700155, -91.0252838134766, -1.58869090510747, 218, 4, 'PPL', 'P'),
(646, 'Beulah Land', 34.6886100769043, 0.605430458782463, -87.0013885498047, -1.51846068400099, 218, 2, 'PPL', 'P'),
(44816, 'Beulah Land', 39.6591682434082, 0.692183064449849, -75.9452819824219, -1.32549522194879, 218, 25, 'PPL', 'P'),
(159197, 'Beulah Land', 41.478328704834, 0.723933404123828, -77.442497253418, -1.35162655803881, 218, 45, 'PPL', 'P'),
(180065, 'Beulah Park', 37.0113906860352, 0.645970628213276, -122.022499084473, -2.12969437053581, 218, 6, 'PPL', 'P'),
(180066, 'Beulah Picnic Ground', 32.8488883972168, 0.573321258151596, -116.54972076416, -2.0341763696146, 218, 6, 'PPL', 'P'),
(186411, 'Beulah Valley', 38.0722198486328, 0.66448558990178, -104.965827941895, -1.83199929966792, 218, 7, 'PPL', 'P'),
(99896, 'Beulah Village', 37.416389465332, 0.653039190378565, -77.4649963378906, -1.35201924114154, 218, 53, 'PPL', 'P'),
(99897, 'Beulahland', 37.5486106872559, 0.655346886042146, -76.6833267211914, -1.33837653266734, 218, 53, 'PPL', 'P'),
(62932, 'Beulahtown', 35.5936088562012, 0.621225667207723, -78.1716690063477, -1.36435300593997, 218, 33, 'PPL', 'P'),
(99898, 'Beulahville', 37.8547210693359, 0.660689520083981, -77.1788864135742, -1.34702568093959, 218, 53, 'PPL', 'P'),
(62933, 'Beulaville', 34.9236106872559, 0.609531993177294, -77.774169921875, -1.35741533814226, 218, 33, 'PPL', 'P'),
(108204, 'Beury', 37.9594383239746, 0.662517180961075, -81.0408325195313, -1.41442935602311, 218, 58, 'PPL', 'P'),
(159198, 'Beurys Lake', 40.7186088562012, 0.710673791372433, -76.3783264160156, -1.33305327312243, 218, 45, 'PPL', 'P'),
(108205, 'Beurytown', 37.827220916748, 0.660209551876521, -80.9052810668945, -1.41206353686874, 218, 58, 'PPL', 'P'),
(71814, 'Bevan', 39.4116706848145, 0.687863417161741, -81.2324981689453, -1.41777455266836, 218, 41, 'PPL', 'P'),
(144838, 'Bevans', 41.1963882446289, 0.719012614798662, -74.8511123657227, -1.3063983595621, 218, 37, 'PPL', 'P'),
(44817, 'Bevansville', 39.6541709899902, 0.692095845924149, -79.1930618286133, -1.38217967364474, 218, 25, 'PPL', 'P'),
(15213, 'Bevell Place', 28.4797191619873, 0.497064869419999, -82.043327331543, -1.43192619122688, 218, 12, 'PPL', 'P'),
(648, 'Bevelle', 32.9258308410645, 0.574664157131269, -85.9388885498047, -1.49991656069855, 218, 2, 'PPL', 'P'),
(15214, 'Bevens', 28.9663906097412, 0.505558888558752, -82.4011077880859, -1.43817063819284, 218, 12, 'PPL', 'P'),
(173169, 'Bevent', 44.7705612182617, 0.781393701224351, -89.3894424438477, -1.56014008716711, 218, 57, 'PPL', 'P'),
(180067, 'Beveridge', 36.7044410705566, 0.640613346785446, -117.914169311523, -2.05799048924014, 218, 6, 'PPL', 'P'),
(15215, 'Beverley Beach', 25.9947204589844, 0.453693460144809, -80.1186065673828, -1.39833347671078, 218, 12, 'PPL', 'P'),
(99911, 'Beverley Hills', 38.8377799987793, 0.677847135143898, -77.0727767944336, -1.34517371871755, 218, 53, 'PPL', 'P'),
(99900, 'Beverley Mill', 38.8241691589355, 0.677609581174663, -77.7111129760742, -1.35631478682178, 218, 53, 'PPL', 'P'),
(15216, 'Beverley Terrace', 27.3688907623291, 0.477677256421304, -82.5072174072266, -1.44002260041488, 218, 12, 'PPL', 'P'),
(7444, 'Beverly', 35.3647193908691, 0.61723079241455, -94.0963897705078, -1.64229181573527, 218, 4, 'PPL', 'P'),
(15217, 'Beverly', 29.8527793884277, 0.521029291199563, -84.9686126708984, -1.48298205195895, 218, 12, 'PPL', 'P'),
(19271, 'Beverly', 34.0955581665039, 0.595079750310734, -82.728889465332, -1.4438915076885, 218, 13, 'PPL', 'P'),
(26517, 'Beverly', 39.7933311462402, 0.694524648838301, -90.9908294677734, -1.58808956333333, 218, 18, 'PPL', 'P'),
(31818, 'Beverly', 39.0127792358398, 0.680901448019083, -97.9752807617188, -1.70999123485785, 218, 20, 'PPL', 'P'),
(34802, 'Beverly', 36.9302787780762, 0.644554958356818, -83.5327835083008, -1.45792210557547, 218, 21, 'PPL', 'P'),
(53461, 'Beverly', 39.3680610656738, 0.687102285722196, -94.866943359375, -1.65574051292406, 218, 29, 'PPL', 'P'),
(58661, 'Beverly', 34.1738891601563, 0.596446884056326, -90.6419372558594, -1.58200024550086, 218, 30, 'PPL', 'P'),
(71815, 'Beverly', 39.547779083252, 0.690238956854091, -81.6397171020508, -1.42488186382751, 218, 41, 'PPL', 'P'),
(79790, 'Beverly', 34.8061103820801, 0.607481225979879, -82.668327331543, -1.44283449905184, 218, 48, 'PPL', 'P'),
(85050, 'Beverly', 36.0316696166992, 0.628871269802205, -83.9011077880859, -1.46435057697276, 218, 50, 'PPL', 'P'),
(92622, 'Beverly', 31.5249996185303, 0.55021504003331, -97.1416702270508, -1.69544198634858, 218, 51, 'PPL', 'P'),
(99902, 'Beverly', 37.3027801513672, 0.651056333788946, -75.9336090087891, -1.3252914901254, 218, 53, 'PPL', 'P'),
(108206, 'Beverly', 38.8405609130859, 0.677895671254765, -79.8755569458008, -1.39409146056845, 218, 58, 'PPL', 'P'),
(124244, 'Beverly', 42.5583305358887, 0.7427829920033, -70.8805618286133, -1.23709917957271, 218, 23, 'PPL', 'P'),
(144839, 'Beverly', 40.0652809143066, 0.699271067691095, -74.9194412231445, -1.30759092309824, 218, 37, 'PPL', 'P'),
(159199, 'Beverly', 40.1827812194824, 0.701321834888511, -76.6119384765625, -1.33713057275134, 218, 45, 'PPL', 'P'),
(199178, 'Beverly', 40.2808303833008, 0.703033115625968, -100.973609924316, -1.76232195080374, 218, 35, 'PPL', 'P'),
(206830, 'Beverly', 46.8369407653809, 0.817458827917449, -119.931938171387, -2.09320719938897, 218, 56, 'PPL', 'P'),
(19261, 'Beverly (historical)', 30.7819404602051, 0.537246211183437, -83.9658279418945, -1.46548015674911, 218, 13, 'PPL', 'P'),
(62934, 'Beverly (historical)', 35.061939239502, 0.611946281863506, -80.0977783203125, -1.39796995522199, 218, 33, 'PPL', 'P'),
(85051, 'Beverly Acres', 36.0580596923828, 0.629331863512734, -83.9024963378906, -1.46437481173868, 218, 50, 'PPL', 'P'),
(99903, 'Beverly Acres', 37.2361106872559, 0.649892732129663, -77.5097198486328, -1.35279981365704, 218, 53, 'PPL', 'P'),
(206831, 'Beverly Acres', 47.8466682434082, 0.835081896956885, -122.30249786377, -2.13458127113611, 218, 56, 'PPL', 'P'),
(15218, 'Beverly Beach', 29.514440536499, 0.51512416424599, -81.1447219848633, -1.41624256925129, 218, 12, 'PPL', 'P'),
(44818, 'Beverly Beach', 38.8752784729004, 0.678501606981785, -76.5083312988281, -1.33532228637118, 218, 25, 'PPL', 'P'),
(200411, 'Beverly Beach', 44.7205581665039, 0.780520983335132, -124.05638885498, -2.16519244365381, 218, 43, 'PPL', 'P'),
(206832, 'Beverly Beach', 48.0611114501953, 0.838824636973855, -122.511390686035, -2.13822713866843, 218, 56, 'PPL', 'P'),
(124245, 'Beverly Cove', 42.5533294677734, 0.742695706898573, -70.8541717529297, -1.23663858586219, 218, 23, 'PPL', 'P'),
(114601, 'Beverly Depot', 41.9322204589844, 0.731855309681405, -91.725830078125, -1.60091774398813, 218, 16, 'PPL', 'P'),
(19262, 'Beverly Estates', 33.9683303833008, 0.592859206593826, -84.7972183227539, -1.47999065626452, 218, 13, 'PPL', 'P'),
(44819, 'Beverly Estates', 38.4077796936035, 0.670342214034, -76.772216796875, -1.33992795716036, 218, 25, 'PPL', 'P'),
(159200, 'Beverly Estates', 40.0741691589355, 0.699426196824592, -76.3022232055664, -1.33172502152876, 218, 45, 'PPL', 'P'),
(44820, 'Beverly Farms', 39.0536117553711, 0.681614109926788, -77.1808319091797, -1.34705963624349, 218, 25, 'PPL', 'P'),
(124246, 'Beverly Farms', 42.5638885498047, 0.742879997646006, -70.8111114501953, -1.23588704180256, 218, 23, 'PPL', 'P'),
(99904, 'Beverly Forest', 38.7616691589355, 0.676518750392166, -77.1875, -1.34717601638312, 218, 53, 'PPL', 'P'),
(180068, 'Beverly Glen', 34.107780456543, 0.595293069514049, -118.444717407227, -2.06725030035034, 218, 6, 'PPL', 'P'),
(19264, 'Beverly Heights', 33.5175018310547, 0.584990763995133, -82.0522232055664, -1.43208145351843, 218, 13, 'PPL', 'P'),
(62935, 'Beverly Heights', 35.8091697692871, 0.624987914879678, -80.9044418334961, -1.41204888948274, 218, 33, 'PPL', 'P'),
(99906, 'Beverly Heights', 37.2869415283203, 0.650779897667796, -80.1122207641602, -1.39822202341916, 218, 53, 'PPL', 'P'),
(159201, 'Beverly Heights', 40.4058303833008, 0.705214777190961, -76.4749984741211, -1.33474051883105, 218, 45, 'PPL', 'P'),
(99908, 'Beverly Heights North', 37.290828704834, 0.650847741696566, -80.116943359375, -1.3983044482549, 218, 53, 'PPL', 'P'),
(92623, 'Beverly Hill', 33.0691719055176, 0.577165930659289, -96.4894409179688, -1.68405843742709, 218, 51, 'PPL', 'P'),
(122224, 'Beverly Hill', 41.5488891601563, 0.725164916390908, -86.9855575561523, -1.51818438103789, 218, 19, 'PPL', 'P'),
(15220, 'Beverly Hills', 30.4108295440674, 0.530769103806742, -81.7080612182617, -1.42607469367976, 218, 12, 'PPL', 'P'),
(19267, 'Beverly Hills', 34.9691696166992, 0.610327146499765, -85.271110534668, -1.48826163566198, 218, 13, 'PPL', 'P'),
(31819, 'Beverly Hills', 39.1577796936035, 0.683432183423958, -94.7350006103516, -1.65343767752947, 218, 20, 'PPL', 'P'),
(34800, 'Beverly Hills', 37.644718170166, 0.657024278054732, -84.7594375610352, -1.47933125757862, 218, 21, 'PPL', 'P'),
(44821, 'Beverly Hills', 39.339168548584, 0.686598016169789, -76.570556640625, -1.33640832346371, 218, 25, 'PPL', 'P'),
(53462, 'Beverly Hills', 38.7000007629395, 0.675442433837611, -90.2922210693359, -1.57589654659851, 218, 29, 'PPL', 'P'),
(62936, 'Beverly Hills', 35.5855598449707, 0.621085185460222, -82.5047225952148, -1.43997905773106, 218, 33, 'PPL', 'P'),
(71817, 'Beverly Hills', 39.1902809143066, 0.683999436736145, -84.2736129760742, -1.47085201898391, 218, 41, 'PPL', 'P'),
(79796, 'Beverly Hills', 34.4930610656738, 0.602017484687472, -82.6819381713867, -1.44307205302108, 218, 48, 'PPL', 'P'),
(85053, 'Beverly Hills', 36.1472206115723, 0.630888015116694, -85.466667175293, -1.49167474291502, 218, 50, 'PPL', 'P'),
(92624, 'Beverly Hills', 31.521390914917, 0.550152056273529, -97.1536102294922, -1.69565037870388, 218, 51, 'PPL', 'P'),
(99909, 'Beverly Hills', 37.0774993896484, 0.647124442755553, -76.5152816772461, -1.33544359335883, 218, 53, 'PPL', 'P'),
(108208, 'Beverly Hills', 39.4797210693359, 0.689051120428889, -80.1688919067383, -1.39921112144802, 218, 58, 'PPL', 'P'),
(129812, 'Beverly Hills', 42.5238914489746, 0.742181916545269, -83.2233276367188, -1.45252108172673, 218, 27, 'PPL', 'P'),
(159202, 'Beverly Hills', 40.5311088562012, 0.707401299024943, -78.414436340332, -1.36859009523429, 218, 45, 'PPL', 'P'),
(180069, 'Beverly Hills', 34.0736083984375, 0.594696654587926, -118.399436950684, -2.06646000729686, 218, 6, 'PPL', 'P'),
(186412, 'Beverly Hills', 39.4749984741211, 0.688968695593151, -104.879173278809, -1.83048689048487, 218, 7, 'PPL', 'P'),
(206833, 'Beverly Junction', 46.8313903808594, 0.817361955432797, -119.948608398438, -2.09349814973806, 218, 56, 'PPL', 'P'),
(39375, 'Beverly Knoll', 29.9819393157959, 0.523283557193774, -90.154167175293, -1.57348705160226, 218, 22, 'PPL', 'P'),
(44822, 'Beverly Knolls', 38.6041717529297, 0.673769902094014, -76.607780456543, -1.33705800161164, 218, 25, 'PPL', 'P'),
(19269, 'Beverly Manor', 33.4777793884277, 0.584297476584358, -84.4916687011719, -1.47465780933969, 218, 13, 'PPL', 'P'),
(118797, 'Beverly Manor', 40.6949996948242, 0.71026173377277, -89.4674987792969, -1.56150242722274, 218, 18, 'PPL', 'P'),
(206834, 'Beverly Park', 47.4963912963867, 0.828968410937526, -122.330276489258, -2.13506609961256, 218, 56, 'PPL', 'P'),
(124247, 'Beverly Road', 42.2986106872559, 0.738250025511876, -71.783332824707, -1.25285550584606, 218, 23, 'PPL', 'P'),
(19270, 'Beverly Shores', 31.2041702270508, 0.544615510814823, -81.4722213745117, -1.42195851189893, 218, 13, 'PPL', 'P'),
(122225, 'Beverly Shores', 41.6925010681152, 0.727671417029863, -86.9775009155273, -1.51804376613233, 218, 19, 'PPL', 'P'),
(651, 'Beverly Station', 33.4838905334473, 0.584404136186015, -86.8533325195313, -1.51587661879528, 218, 2, 'PPL', 'P'),
(193124, 'Beverly Trailer Park', 33.4061088562012, 0.583046589820347, -111.853607177734, -1.95221372548383, 218, 5, 'PPL', 'P'),
(13377, 'Beverly Woods', 39.8199996948242, 0.69499010281782, -75.4800033569336, -1.31737457799486, 218, 10, 'PPL', 'P'),
(79794, 'Beverly Woods', 35.0052795410156, 0.610957383571732, -81.9124984741211, -1.42964279690824, 218, 48, 'PPL', 'P'),
(80, 'Beverlytown', 37.6519393920898, 0.65715031215332, -79.3036117553711, -1.38410913385451, 218, 53, 'PPL', 'P'),
(99916, 'Beverlyville', 37.8650016784668, 0.660868950562425, -76.2813873291016, -1.33136136688191, 218, 53, 'PPL', 'P'),
(99913, 'Bevers Store (historical)', 37.148609161377, 0.648365542402557, -81.6486129760742, -1.42503712611906, 218, 53, 'PPL', 'P'),
(34801, 'Bevier', 37.2444381713867, 0.650038074146154, -87.0819396972656, -1.51986656674044, 218, 21, 'PPL', 'P'),
(53463, 'Bevier', 39.746940612793, 0.69371498128789, -92.5638885498047, -1.61554462364317, 218, 29, 'PPL', 'P'),
(92625, 'Bevil Oaks', 30.1499996185303, 0.526216762818388, -94.2694396972656, -1.64531210672753, 218, 51, 'PPL', 'P'),
(15221, 'Beville Heights', 29.6563892364502, 0.517601636429063, -82.3997192382813, -1.43814640342692, 218, 12, 'PPL', 'P'),
(15222, 'Bevilles Corner', 28.6494407653809, 0.50002707021098, -82.0547180175781, -1.43212499620225, 218, 12, 'PPL', 'P'),
(92626, 'Bevilport', 30.923059463501, 0.539709202428083, -94.1549987792969, -1.64331473590997, 218, 51, 'PPL', 'P'),
(114602, 'Bevington', 41.3605613708496, 0.721877976394505, -93.7905578613281, -1.63695404196243, 218, 16, 'PPL', 'P'),
(19272, 'Bevinwood', 32.7227783203125, 0.571120222089673, -83.6927795410156, -1.46071456313647, 218, 13, 'PPL', 'P'),
(71818, 'Bevis', 39.2574996948242, 0.685172625775352, -84.6016693115234, -1.47657768216953, 218, 41, 'PPL', 'P'),
(7448, 'Bevis Corner', 34.7205581665039, 0.605988058135699, -92.0069427490234, -1.60582408566438, 218, 4, 'PPL', 'P'),
(58662, 'Bew Springs', 33.7861099243164, 0.589678859620054, -89.8947219848633, -1.5689588788008, 218, 30, 'PPL', 'P'),
(58663, 'Bewelcome', 31.2186107635498, 0.544867545722485, -90.938606262207, -1.58717809645025, 218, 30, 'PPL', 'P'),
(34803, 'Bewleyville', 37.8400001525879, 0.660432591617815, -86.2444381713867, -1.50524940762338, 218, 21, 'PPL', 'P'),
(681, 'Bexar', 34.1908302307129, 0.596742561516352, -88.147216796875, -1.53845915957472, 218, 2, 'PPL', 'P'),
(7449, 'Bexar', 36.2866706848145, 0.633321878036918, -91.9955596923828, -1.60562541384706, 218, 4, 'PPL', 'P'),
(92628, 'Bexar', 29.2252807617188, 0.510077374111749, -98.6875, -1.7224218055619, 218, 51, 'PPL', 'P'),
(58664, 'Bexley', 30.9663906097412, 0.540465473598639, -88.6741714477539, -1.54765625324125, 218, 30, 'PPL', 'P'),
(71819, 'Bexley', 39.9688911437988, 0.697588748830492, -82.9377822875977, -1.44753737522081, 218, 41, 'PPL', 'P'),
(99915, 'Bexley Trailer Park', 37.0755615234375, 0.647090620609709, -77.3597183227539, -1.35018179314744, 218, 53, 'PPL', 'P'),
(19273, 'Bexton', 33.2633285522461, 0.580554603409333, -84.7366714477539, -1.47893391394398, 218, 13, 'PPL', 'P'),
(159203, 'Beyer', 40.7863883972168, 0.711856767528646, -79.2013931274414, -1.38232508224026, 218, 45, 'PPL', 'P'),
(92630, 'Beyer Crossing', 30.9013900756836, 0.539331000263778, -99.9150009155273, -1.7438457381091, 218, 51, 'PPL', 'P'),
(147191, 'Beyers Corners', 42.9980583190918, 0.75045768963269, -74.1152801513672, -1.29355566467936, 218, 40, 'PPL', 'P'),
(92631, 'Beyersville', 30.5097198486328, 0.532495065219709, -97.3294372558594, -1.69871913922798, 218, 51, 'PPL', 'P'),
(193125, 'Beyerville', 31.3902797698975, 0.547863735106879, -110.877777099609, -1.93518227768055, 218, 5, 'PPL', 'P'),
(58665, 'Bezer', 31.9708309173584, 0.557996264106303, -89.4902801513672, -1.56190003717349, 218, 30, 'PPL', 'P'),
(92632, 'Bi-Stone', 31.6861095428467, 0.55302693867027, -96.4225006103516, -1.68289010865688, 218, 51, 'PPL', 'P'),
(92633, 'Biardstown', 33.5386085510254, 0.585359145752918, -95.5052795410156, -1.6668815810283, 218, 51, 'PPL', 'P'),
(108211, 'Bias', 37.7411117553711, 0.658706663494362, -82.1949996948242, -1.43457337335042, 218, 58, 'PPL', 'P'),
(19274, 'Bibb (historical)', 33.2841682434082, 0.580918324635211, -83.9233322143555, -1.46473846638553, 218, 13, 'PPL', 'P'),
(19275, 'Bibb City', 32.4955596923828, 0.567154508910436, -84.991943359375, -1.48338924928962, 218, 13, 'PPL', 'P'),
(664, 'Bibb Mill', 32.9472198486328, 0.57503746573707, -86.9102783203125, -1.5168705105141, 218, 2, 'PPL', 'P'),
(667, 'Bibbville', 33.1933288574219, 0.579332878259259, -87.1763916015625, -1.5215150634552, 218, 2, 'PPL', 'P'),
(26519, 'Bible Grove', 38.871940612793, 0.67844335033294, -88.4461135864258, -1.54367589267602, 218, 18, 'PPL', 'P'),
(139038, 'Bible Grove', 40.3527793884277, 0.704288862658968, -92.3041687011719, -1.61101165715175, 218, 29, 'PPL', 'P'),
(85054, 'Bible Hill', 35.7030601501465, 0.623135952657637, -88.1438903808594, -1.53840110266295, 218, 50, 'PPL', 'P'),
(188141, 'Bibo', 35.1741714477539, 0.613905103424286, -107.388061523438, -1.87427525091822, 218, 38, 'PPL', 'P'),
(44823, 'Bicentennial Estates', 39.334171295166, 0.686510797644089, -77.2125015258789, -1.34761237532773, 218, 25, 'PPL', 'P'),
(13378, 'Bicentennial Village', 39.1652793884277, 0.683563077791535, -75.5541687011719, -1.3186690074427, 218, 10, 'PPL', 'P'),
(194589, 'Bickel (historical)', 42.5280609130859, 0.742254687422056, -114.209716796875, -1.99333559587574, 218, 17, 'PPL', 'P'),
(108212, 'Bickel Estates', 39.2486114501953, 0.685017496641855, -81.5833282470703, -1.42389769264667, 218, 58, 'PPL', 'P'),
(126876, 'Bickfords Corner', 44.3627815246582, 0.774276602948196, -69.149169921875, -1.20688069015775, 218, 26, 'PPL', 'P'),
(39376, 'Bickham', 30.8672199249268, 0.538734618627169, -90.2155609130859, -1.57455857446685, 218, 22, 'PPL', 'P'),
(206835, 'Bickleton', 45.9980583190918, 0.80281756719252, -120.299438476563, -2.09962128971637, 218, 56, 'PPL', 'P'),
(19277, 'Bickley', 31.4052791595459, 0.548125523842034, -82.6030578613281, -1.44169533189556, 218, 13, 'PPL', 'P'),
(81, 'Bickley Mill', 36.8888893127441, 0.643832575911134, -82.2777786254883, -1.43601813824178, 218, 53, 'PPL', 'P'),
(108213, 'Bickmore', 38.3813896179199, 0.669881620323471, -81.1122207641602, -1.41567531593911, 218, 58, 'PPL', 'P'),
(29212, 'Bicknell', 38.774169921875, 0.676736929864471, -87.3077774047852, -1.52380817831181, 218, 19, 'PPL', 'P'),
(180072, 'Bicknell', 34.8166694641113, 0.607665516727312, -120.392219543457, -2.10124062481719, 218, 6, 'PPL', 'P'),
(192484, 'Bicknell', 38.3408317565918, 0.669173752105728, -111.543327331543, -1.94679832056521, 218, 52, 'PPL', 'P'),
(15223, 'Bid-A-Wee', 30.2024993896484, 0.527133056680943, -85.8499984741211, -1.49836513620552, 218, 12, 'PPL', 'P'),
(193126, 'Bidahochi', 35.4102783203125, 0.61802594573702, -110.061111450195, -1.92092877321034, 218, 5, 'PPL', 'P'),
(126879, 'Biddeford', 43.4925003051758, 0.759087330249956, -70.4538879394531, -1.22965231537458, 218, 26, 'PPL', 'P'),
(126877, 'Biddeford Pool', 43.4447212219238, 0.758253427933625, -70.3419418334961, -1.22769848724084, 218, 26, 'PPL', 'P'),
(114603, 'Biddick (historical)', 41.0777816772461, 0.716942539683343, -95.0791702270508, -1.6594445705262, 218, 16, 'PPL', 'P'),
(7450, 'Biddle', 34.7194404602051, 0.605968550480714, -92.2591705322266, -1.61022629094628, 218, 4, 'PPL', 'P'),
(34804, 'Biddle', 38.3494415283203, 0.669324020970236, -84.6074981689453, -1.47667941492317, 218, 21, 'PPL', 'P'),
(195985, 'Biddle', 45.0994415283203, 0.787133745479853, -105.337783813477, -1.83849115429915, 218, 31, 'PPL', 'P'),
(79795, 'Biddle (historical)', 34.4647216796875, 0.601522869094017, -80.89111328125, -1.41181626236153, 218, 48, 'PPL', 'P'),
(154314, 'Biddle (historical)', 40.8402786254883, 0.712797329446635, -82.8183288574219, -1.44545251956145, 218, 41, 'PPL', 'P'),
(200412, 'Biddle (historical)', 46.1330604553223, 0.805173798966968, -123.659439086914, -2.15826436323602, 218, 43, 'PPL', 'P'),
(679, 'Biddle Crossroads', 34.6580581665039, 0.604897227353202, -85.6936111450195, -1.4956356624043, 218, 2, 'PPL', 'P'),
(26521, 'Biddleborn', 38.297779083252, 0.668422341204162, -89.6847229003906, -1.56529370335057, 218, 18, 'PPL', 'P'),
(13379, 'Biddles Corner', 39.5250015258789, 0.68984141348237, -75.6494369506836, -1.32033175206929, 218, 10, 'PPL', 'P'),
(70543, 'Biddles Landing', 39.6755599975586, 0.692469154529951, -75.4658279418945, -1.3171271703296, 218, 37, 'PPL', 'P'),
(44824, 'Bidle Hill Acres', 39.4833297729492, 0.689114104188669, -77.5536117553711, -1.3535658719446, 218, 25, 'PPL', 'P'),
(7451, 'Bidville', 35.7397193908691, 0.623775777109529, -93.9816665649414, -1.6402895180697, 218, 4, 'PPL', 'P'),
(53465, 'Bidwell', 37.8716697692871, 0.660985330702061, -92.7094421386719, -1.618085013007, 218, 29, 'PPL', 'P'),
(71821, 'Bidwell', 38.9186096191406, 0.67925787815234, -82.2991714477539, -1.43639151342661, 218, 41, 'PPL', 'P'),
(77864, 'Bidwell', 39.8561096191406, 0.695620339889787, -79.4247207641602, -1.3862228848117, 218, 45, 'PPL', 'P'),
(85055, 'Bidwell', 35.2752799987793, 0.6156697805416, -86.6283264160156, -1.51194952145185, 218, 50, 'PPL', 'P'),
(114604, 'Bidwell', 41.0188903808594, 0.715914692660627, -92.538330078125, -1.61509854416058, 218, 16, 'PPL', 'P'),
(180070, 'Bidwell (historical)', 39.5569381713867, 0.690398813098523, -121.46443939209, -2.11995439148107, 218, 6, 'PPL', 'P'),
(180071, 'Bidwell Bar (historical)', 39.5566711425781, 0.690394152566616, -121.440277099609, -2.11953267992245, 218, 6, 'PPL', 'P'),
(159204, 'Bidwell Hill', 41.3805618286133, 0.722227050234387, -75.3763885498047, -1.31556615845665, 218, 45, 'PPL', 'P'),
(193379, 'Bieber', 41.1213912963867, 0.717703671122888, -121.143058776855, -2.11434524159314, 218, 6, 'PPL', 'P'),
(169834, 'Bieglers First Addition', 45.5502815246582, 0.795002387815628, -98.6133270263672, -1.72112724295602, 218, 49, 'PPL', 'P'),
(53466, 'Biehle', 37.605281829834, 0.656335984071001, -89.8411102294922, -1.5680231771518, 218, 29, 'PPL', 'P'),
(195986, 'Biem', 48.4833297729492, 0.846193736868159, -104.941673278809, -1.83157772126736, 218, 31, 'PPL', 'P'),
(39379, 'Bienville', 32.3566703796387, 0.564730433107218, -92.9802780151367, -1.62281199078383, 218, 22, 'PPL', 'P'),
(44825, 'Bier', 39.5419387817383, 0.690137024363368, -78.876106262207, -1.37664775542843, 218, 25, 'PPL', 'P'),
(77865, 'Biesecker Gap', 39.7874984741211, 0.694422849505633, -77.5341720581055, -1.35322658522173, 218, 45, 'PPL', 'P'),
(39378, 'Big A Plenty Landing', 31.8941707611084, 0.556658291974647, -91.5719375610352, -1.59823181287073, 218, 22, 'PPL', 'P'),
(195987, 'Big Arm', 47.7980613708496, 0.83423354699164, -114.293891906738, -1.99480472869108, 218, 31, 'PPL', 'P'),
(195988, 'Big Arm Mobile Home Park', 47.7986106872559, 0.834243134371564, -114.294441223145, -1.99481431607101, 218, 31, 'PPL', 'P'),
(193380, 'Big Bar', 40.7411117553711, 0.711066541054192, -123.254722595215, -2.15120072791875, 218, 6, 'PPL', 'P'),
(85056, 'Big Barren', 36.3891716003418, 0.635110856499179, -83.7077789306641, -1.46097635187163, 218, 50, 'PPL', 'P'),
(108214, 'Big Battle (historical)', 39.351390838623, 0.686811335373105, -80.6263885498047, -1.40719594418635, 218, 58, 'PPL', 'P'),
(26522, 'Big Bay', 37.3166694641113, 0.651298748027171, -88.7216720581055, -1.54848529528859, 218, 18, 'PPL', 'P'),
(129813, 'Big Bay', 46.8158302307129, 0.817090379580636, -87.7283325195313, -1.53114824975023, 218, 27, 'PPL', 'P'),
(147193, 'Big Bay', 43.2461090087891, 0.754786990879751, -76.1205596923828, -1.32855439509296, 218, 40, 'PPL', 'P'),
(180075, 'Big Bear City', 34.2611083984375, 0.597969146935416, -116.844169616699, -2.03931547157012, 218, 6, 'PPL', 'P'),
(180076, 'Big Bear Lake', 34.2438888549805, 0.5976686092064, -116.91056060791, -2.04047421296042, 218, 6, 'PPL', 'P'),
(134246, 'Big Bear Landing', 47.336669921875, 0.826180747066486, -95.4766693115234, -1.66638223832391, 218, 28, 'PPL', 'P'),
(129814, 'Big Beaver', 42.5627784729004, 0.742860623149076, -83.1241683959961, -1.45079042649235, 218, 27, 'PPL', 'P'),
(159205, 'Big Beaver', 40.8244400024414, 0.712520893325484, -80.3630599975586, -1.40259999393514, 218, 45, 'PPL', 'P'),
(39380, 'Big Bend', 31.0736103057861, 0.54233681031761, -91.7919387817383, -1.60207155853041, 218, 22, 'PPL', 'P'),
(53468, 'Big Bend', 38.0541687011719, 0.664170537944823, -92.0322189331055, -1.60626523829895, 218, 29, 'PPL', 'P'),
(129815, 'Big Bend', 43.523609161377, 0.759630282217196, -85.5827789306641, -1.49370127534652, 218, 27, 'PPL', 'P'),
(147194, 'Big Bend', 42.877498626709, 0.748353526055419, -76.0899963378906, -1.32802096392662, 218, 40, 'PPL', 'P'),
(159210, 'Big Bend', 41.8408317565918, 0.73026027592553, -79.0044403076172, -1.37888760706324, 218, 45, 'PPL', 'P'),
(173171, 'Big Bend', 42.8813896179199, 0.748421436663216, -88.206672668457, -1.53949686029347, 218, 57, 'PPL', 'P'),
(186414, 'Big Bend', 38.2013893127441, 0.666740022343559, -102.750282287598, -1.79333073327219, 218, 7, 'PPL', 'P'),
(193381, 'Big Bend', 41.0208282470703, 0.715948514806471, -121.910003662109, -2.12773095502215, 218, 6, 'PPL', 'P'),
(201905, 'Big Bend', 44.065559387207, 0.769089098039858, -103.414169311523, -1.80491774770096, 218, 49, 'PPL', 'P'),
(53469, 'Big Bend Acres', 38.2661094665527, 0.667869602119916, -93.0622177124023, -1.62424210828921, 218, 29, 'PPL', 'P'),
(134247, 'Big Bend City', 45.1430587768555, 0.787895010077452, -95.7716674804688, -1.67153092765936, 218, 28, 'PPL', 'P'),
(99917, 'Big Bethel', 37.0897216796875, 0.647337761958869, -76.4238891601563, -1.33384849302393, 218, 53, 'PPL', 'P'),
(58666, 'Big Black', 32.2155609130859, 0.56226760831014, -90.8397216796875, -1.58545223490582, 218, 30, 'PPL', 'P'),
(15224, 'Big Blackjack Landing', 29.916389465332, 0.52213949647899, -84.583610534668, -1.47626249705452, 218, 12, 'PPL', 'P'),
(34805, 'Big Bone', 38.8886108398438, 0.678734300682031, -84.7519378662109, -1.47920036321104, 218, 21, 'PPL', 'P'),
(187597, 'Big Bow', 37.564998626709, 0.65563290954322, -101.561111450195, -1.77257578679082, 218, 20, 'PPL', 'P'),
(85057, 'Big Boy Junction', 36.0361099243164, 0.628948767789926, -89.4997177124023, -1.56206475368691, 218, 50, 'PPL', 'P'),
(34806, 'Big Branch', 37.3061103820801, 0.651114457279737, -82.4755630493164, -1.43947012764675, 218, 21, 'PPL', 'P'),
(39381, 'Big Branch', 30.333610534668, 0.529421377847594, -89.9927825927734, -1.57067035927534, 218, 22, 'PPL', 'P'),
(108215, 'Big Branch', 37.5875015258789, 0.65602565922498, -81.772216796875, -1.42719441976008, 218, 58, 'PPL', 'P'),
(147195, 'Big Brook', 43.3222198486328, 0.756115375631482, -75.3272171020508, -1.31470795479537, 218, 40, 'PPL', 'P'),
(180080, 'Big Bunch', 36.7572212219238, 0.641534534206504, -119.537216186523, -2.08631800112309, 218, 6, 'PPL', 'P'),
(75123, 'Big Cabin', 36.5377807617188, 0.637704575663834, -95.2211074829102, -1.66192184297219, 218, 42, 'PPL', 'P'),
(39382, 'Big Cane', 30.8202800750732, 0.537915363696833, -92.0094375610352, -1.6058676283482, 218, 22, 'PPL', 'P'),
(75124, 'Big Cedar', 34.6458282470703, 0.604683774991832, -94.6486129760742, -1.65192992887832, 218, 42, 'PPL', 'P'),
(194590, 'Big Cedar', 46.0811080932617, 0.804267059194823, -115.813331604004, -2.02132395419387, 218, 17, 'PPL', 'P'),
(85058, 'Big Cherokee', 36.2361106872559, 0.63243943960972, -82.4636077880859, -1.43926146897534, 218, 50, 'PPL', 'P'),
(108216, 'Big Chimney', 38.4055595397949, 0.67030346504014, -81.5358276367188, -1.42306865059933, 218, 58, 'PPL', 'P'),
(34807, 'Big Clifty', 37.5455589294434, 0.655293622820344, -86.1536102294922, -1.50366416098451, 218, 21, 'PPL', 'P'),
(79797, 'Big Cone Ridge', 33.5791702270508, 0.586067080549688, -81.9044418334961, -1.42950218200269, 218, 48, 'PPL', 'P'),
(15225, 'Big Coppitt Key', 24.5961093902588, 0.429283092040711, -81.6602783203125, -1.4252407247844, 218, 12, 'PPL', 'P'),
(702, 'Big Cove', 34.6672210693359, 0.605057150176662, -86.4888916015625, -1.50951592484774, 218, 2, 'PPL', 'P'),
(77866, 'Big Cove Tannery', 39.8488883972168, 0.695494305791199, -78.0497207641602, -1.36222460759678, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(707, 'Big Creek', 31.0683307647705, 0.542244664943893, -85.4338912963867, -1.49110269591288, 218, 2, 'PPL', 'P'),
(19280, 'Big Creek', 34.7350006103516, 0.606240126332875, -84.2808303833008, -1.47097798650347, 218, 13, 'PPL', 'P'),
(34808, 'Big Creek', 37.1622200012207, 0.648603096371792, -83.5688934326172, -1.45855234264744, 218, 21, 'PPL', 'P'),
(39383, 'Big Creek', 32.2916717529297, 0.563595993061872, -91.7630615234375, -1.60156755529411, 218, 22, 'PPL', 'P'),
(53470, 'Big Creek', 37.2355613708496, 0.649883144749739, -91.8441696166992, -1.60298315857154, 218, 29, 'PPL', 'P'),
(58667, 'Big Creek', 33.8525009155273, 0.590837601010347, -89.4111099243164, -1.5605182560419, 218, 30, 'PPL', 'P'),
(79798, 'Big Creek', 34.0658302307129, 0.59456089995136, -81.8486099243164, -1.42852773135983, 218, 48, 'PPL', 'P'),
(85062, 'Big Creek', 35.464168548584, 0.618966507655009, -84.2991714477539, -1.4712980984665, 218, 50, 'PPL', 'P'),
(92635, 'Big Creek', 30.452220916748, 0.531491519541939, -94.8625030517578, -1.65566301493634, 218, 51, 'PPL', 'P'),
(108217, 'Big Creek', 38.0041694641113, 0.663297886634632, -82.040283203125, -1.43187306116313, 218, 58, 'PPL', 'P'),
(147196, 'Big Creek', 42.3688888549805, 0.73947661093094, -77.5752792358398, -1.3539440408194, 218, 40, 'PPL', 'P'),
(159211, 'Big Creek', 40.8455581665039, 0.712889474820351, -75.6483306884766, -1.32031244415138, 218, 45, 'PPL', 'P'),
(180081, 'Big Creek', 37.2050018310547, 0.649349780162423, -119.245002746582, -2.08121791447754, 218, 6, 'PPL', 'P'),
(194591, 'Big Creek', 45.1272201538086, 0.787618573956302, -115.323333740234, -2.01277187814336, 218, 17, 'PPL', 'P'),
(85063, 'Big Creek (historical)', 36.5175018310547, 0.637350641554962, -82.0808334350586, -1.43258079622282, 218, 50, 'PPL', 'P'),
(7453, 'Big Creek Corner', 34.672779083252, 0.605154155819368, -90.8899993896484, -1.586329746485, 218, 4, 'PPL', 'P'),
(62942, 'Big Curve', 34.2183303833008, 0.597222529723812, -78.4297180175781, -1.36885681081746, 218, 33, 'PPL', 'P'),
(129817, 'Big Cut', 45.327220916748, 0.791109245776096, -83.9997177124023, -1.46607164482722, 218, 27, 'PPL', 'P'),
(212305, 'Big Delta', 64.1524963378906, 1.1196722844698, -145.842224121094, -2.54542699934458, 218, 1, 'PPL', 'P'),
(62943, 'Big East Fork', 35.3641700744629, 0.617221205034626, -82.8202819824219, -1.4454866080234, 218, 33, 'PPL', 'P'),
(34809, 'Big Eddy', 38.1699981689453, 0.666192143528302, -84.8583297729492, -1.4810572522811, 218, 21, 'PPL', 'P'),
(194592, 'Big Eddy', 44.2161102294922, 0.771716705929384, -116.106391906738, -2.02643882138348, 218, 17, 'PPL', 'P'),
(717, 'Big Eddy (historical)', 31.9902801513672, 0.558335717276747, -85.1374969482422, -1.48592963865345, 218, 2, 'PPL', 'P'),
(58668, 'Big Eddy Landing', 32.9394416809082, 0.574901711100504, -90.7702789306641, -1.58424023029373, 218, 30, 'PPL', 'P'),
(194109, 'Big Elk Meadows', 40.2619400024414, 0.702703416283016, -105.429718017578, -1.84009570885593, 218, 7, 'PPL', 'P'),
(134249, 'Big Falls', 48.1911087036133, 0.841093517064548, -93.8063888549805, -1.63723034492552, 218, 28, 'PPL', 'P'),
(173174, 'Big Falls', 44.6155586242676, 0.778688395610021, -89.01611328125, -1.55362426408607, 218, 57, 'PPL', 'P'),
(7466, 'Big Flat', 36.0050010681152, 0.628405815822686, -92.404167175293, -1.61275695977213, 218, 4, 'PPL', 'P'),
(147197, 'Big Flats', 42.1372184753418, 0.735433200026899, -76.9372177124023, -1.34280776640512, 218, 40, 'PPL', 'P'),
(173177, 'Big Flats', 44.1119384765625, 0.769898565853187, -89.8077774047852, -1.56744140961167, 218, 57, 'PPL', 'P'),
(195989, 'Big Foot (historical)', 46.124439239502, 0.805023330365378, -112.150001525879, -1.95738678274325, 218, 31, 'PPL', 'P'),
(92636, 'Big Foot Colonia', 29.05299949646, 0.507070498793481, -98.8659973144531, -1.72553717140508, 218, 51, 'PPL', 'P'),
(118799, 'Big Foot Prairie', 42.4949989318848, 0.741677646992863, -88.5988922119141, -1.54634238271746, 218, 18, 'PPL', 'P'),
(7468, 'Big Fork', 34.4863891601563, 0.601901037968809, -93.9697189331055, -1.64008099255634, 218, 4, 'PPL', 'P'),
(34810, 'Big Fork', 37.0499992370605, 0.646644474548094, -83.248893737793, -1.45296729436738, 218, 21, 'PPL', 'P'),
(99918, 'Big Fork', 36.6713905334473, 0.640036506093335, -78.2130584716797, -1.36507538838565, 218, 53, 'PPL', 'P'),
(108219, 'Big Four', 37.4147186279297, 0.653010028764628, -81.5208282470703, -1.42280686186417, 218, 58, 'PPL', 'P'),
(29213, 'Big Four Yard', 39.7611083984375, 0.693962255795104, -86.3583297729492, -1.50723719106101, 218, 19, 'PPL', 'P'),
(194593, 'Big George', 46.5027809143066, 0.81162663828823, -116.491943359375, -2.03316796366784, 218, 17, 'PPL', 'P'),
(15226, 'Big Hammock', 30.4663906097412, 0.531738827338667, -86.3680572509766, -1.5074069675805, 218, 12, 'PPL', 'P'),
(15227, 'Big Hammock (historical)', 28.7999992370605, 0.502654811258561, -82.4499969482422, -1.4390239150061, 218, 12, 'PPL', 'P'),
(7471, 'Big Hill', 33.6655616760254, 0.587574895779864, -92.415283203125, -1.61295097105754, 218, 4, 'PPL', 'P'),
(92637, 'Big Hill', 31.4675006866455, 0.549211494355541, -96.6733322143555, -1.6872679460148, 218, 51, 'PPL', 'P'),
(99919, 'Big Hill', 36.6494407653809, 0.639653410370527, -81.6374969482422, -1.42484311483365, 218, 53, 'PPL', 'P'),
(122227, 'Big Hill', 41.045280456543, 0.716375286371156, -86.1958312988281, -1.50440105765813, 218, 19, 'PPL', 'P'),
(147199, 'Big Hollow', 43.4333305358887, 0.75805462295825, -73.7561111450195, -1.28728698294748, 218, 40, 'PPL', 'P'),
(188142, 'Big Horn', 36.9891700744629, 0.645582805379534, -106.181671142578, -1.85321976670784, 218, 38, 'PPL', 'P'),
(193127, 'Big Horn', 32.8594398498535, 0.573505415740975, -112.391937255859, -1.96160935780963, 218, 5, 'PPL', 'P'),
(209305, 'Big Horn', 44.6833305358887, 0.77987123860818, -106.991668701172, -1.86735689103841, 218, 59, 'PPL', 'P'),
(147200, 'Big Indian', 42.1025009155273, 0.734827264299879, -74.4441680908203, -1.29929584209292, 218, 40, 'PPL', 'P'),
(108220, 'Big Isaac', 39.2000007629395, 0.684169080097583, -80.5388870239258, -1.40566875445924, 218, 58, 'PPL', 'P'),
(39384, 'Big Island', 31.3369407653809, 0.546932793858328, -92.165283203125, -1.60858764792756, 218, 22, 'PPL', 'P'),
(99920, 'Big Island', 37.5336112976074, 0.655085097306991, -79.3600006103516, -1.38509330503534, 218, 53, 'PPL', 'P'),
(147201, 'Big Island', 41.3205604553223, 0.721179828714741, -74.4047164916992, -1.29860728179308, 218, 40, 'PPL', 'P'),
(154316, 'Big Island', 40.6122207641602, 0.708816968881402, -83.2169418334961, -1.45240962843511, 218, 41, 'PPL', 'P'),
(154318, 'Big Italy', 41.4908294677734, 0.724151583596133, -81.6655578613281, -1.42533287015811, 218, 41, 'PPL', 'P'),
(85064, 'Big Ivy', 35.1175003051758, 0.612916005395431, -88.0505599975586, -1.53677218018221, 218, 50, 'PPL', 'P'),
(92638, 'Big John Colonia', 26.2609996795654, 0.458340909273593, -98.0070037841797, -1.71054490604848, 218, 51, 'PPL', 'P'),
(193382, 'Big Lagoon', 41.1605606079102, 0.718387304574711, -124.132499694824, -2.16652082840554, 218, 6, 'PPL', 'P'),
(7472, 'Big Lake', 35.8519401550293, 0.625734398933227, -90.1408309936523, -1.57325429132299, 218, 4, 'PPL', 'P'),
(134251, 'Big Lake', 45.3325004577637, 0.791201391149813, -93.7458267211914, -1.63617333628887, 218, 28, 'PPL', 'P'),
(139039, 'Big Lake', 40.0819396972656, 0.699561818303104, -95.3497161865234, -1.66416648829697, 218, 29, 'PPL', 'P'),
(191134, 'Big Lake', 31.1913890838623, 0.544392437784015, -101.459999084473, -1.77081104309448, 218, 51, 'PPL', 'P'),
(206836, 'Big Lake', 48.4030609130859, 0.844792780976723, -122.23999786377, -2.13349044035361, 218, 56, 'PPL', 'P'),
(212306, 'Big Lake', 61.5499992370605, 1.0742501412867, -149.866668701172, -2.61566680783098, 218, 1, 'PPL', 'P'),
(58669, 'Big Lake (historical)', 33.0491714477539, 0.576816856819407, -88.3930587768555, -1.542749911565, 218, 30, 'PPL', 'P'),
(134252, 'Big Lake Chapel', 46.7216682434082, 0.815446942871949, -92.5966720581055, -1.61611680380337, 218, 28, 'PPL', 'P'),
(134253, 'Big Lake Estates', 45.3263893127441, 0.791094731548155, -93.7444381713867, -1.63614910152295, 218, 28, 'PPL', 'P'),
(34811, 'Big Laurel', 36.9797210693359, 0.64541788912903, -83.2172164916992, -1.45241442212508, 218, 21, 'PPL', 'P'),
(62945, 'Big Laurel', 35.339168548584, 0.616784846090016, -83.351936340332, -1.45476572705151, 218, 33, 'PPL', 'P'),
(99921, 'Big Laurel', 37.0125007629395, 0.645990002710207, -82.621940612793, -1.44202489808046, 218, 53, 'PPL', 'P'),
(58670, 'Big Level', 30.8113899230957, 0.537760201273823, -89.0513916015625, -1.55423998693009, 218, 30, 'PPL', 'P'),
(62946, 'Big Lick', 35.2413902282715, 0.615078292463493, -80.3441696166992, -1.40227029459219, 218, 33, 'PPL', 'P'),
(85065, 'Big Lick', 35.8072204589844, 0.624953892996753, -85.0213928222656, -1.48390323938001, 218, 50, 'PPL', 'P'),
(180082, 'Big Meadow', 38.4150009155273, 0.670468248132588, -120.114166259766, -2.09638767952079, 218, 6, 'PPL', 'P'),
(99922, 'Big Meadows', 38.5263900756836, 0.672412355728346, -78.4400024414063, -1.36903630787493, 218, 53, 'PPL', 'P'),
(188143, 'Big Mill', 32.6588897705078, 0.570005156541257, -107.991111755371, -1.88480046302038, 218, 38, 'PPL', 'P'),
(113275, 'Big Mine Run', 40.7874984741211, 0.711876142025576, -76.3177795410156, -1.33199653080189, 218, 45, 'PPL', 'P'),
(147202, 'Big Moose', 43.8183288574219, 0.764774111283657, -74.9155578613281, -1.3075231456485, 218, 40, 'PPL', 'P'),
(108221, 'Big Moses', 39.4313888549805, 0.688207564153606, -80.7844390869141, -1.40995444644345, 218, 58, 'PPL', 'P'),
(114608, 'Big Mound', 40.7555618286133, 0.711318742409423, -91.6999969482422, -1.60046687081558, 218, 16, 'PPL', 'P'),
(159212, 'Big Mountain', 40.7705612182617, 0.711580531144577, -76.5338897705078, -1.33576836585377, 218, 45, 'PPL', 'P'),
(195991, 'Big Mountain Trailer Park', 48.4249992370605, 0.845175676962449, -114.341667175293, -1.99563856442839, 218, 31, 'PPL', 'P'),
(734, 'Big Oak', 34.850830078125, 0.608261731916354, -87.4533309936523, -1.52634856767564, 218, 2, 'PPL', 'P'),
(19282, 'Big Oak', 31.0599994659424, 0.542099256348375, -81.936393737793, -1.43005984793495, 218, 13, 'PPL', 'P'),
(44826, 'Big Oak', 38.4630584716797, 0.671307010717909, -76.7041702270508, -1.33874032047224, 218, 25, 'PPL', 'P'),
(70544, 'Big Oak', 39.4861106872559, 0.689162640299536, -75.2088928222656, -1.31264280652807, 218, 37, 'PPL', 'P'),
(13380, 'Big Oak Corners', 39.2694396972656, 0.68538101813065, -75.5888900756836, -1.31927500974874, 218, 10, 'PPL', 'P'),
(180083, 'Big Oak Flat', 37.8236083984375, 0.660146501537714, -120.257217407227, -2.09888439304274, 218, 6, 'PPL', 'P'),
(99923, 'Big Otter Mill', 37.3902816772461, 0.652583523516052, -79.504997253418, -1.38762397386119, 218, 53, 'PPL', 'P'),
(193128, 'Big Palm Trailer Park', 33.4625015258789, 0.584030827580213, -111.97917175293, -1.95440524074485, 218, 5, 'PPL', 'P'),
(193129, 'Big Park', 34.7802810668945, 0.607030419386356, -111.761940002441, -1.95061383145896, 218, 5, 'PPL', 'P'),
(13381, 'Big Pine', 38.8505592346191, 0.678070174885192, -75.6947174072266, -1.32112204512277, 218, 10, 'PPL', 'P'),
(15228, 'Big Pine', 24.6722202301025, 0.430611476792442, -81.3494415283203, -1.4198155993278, 218, 12, 'PPL', 'P'),
(62948, 'Big Pine', 35.790828704834, 0.624667802916651, -82.8086090087891, -1.44528287620001, 218, 33, 'PPL', 'P'),
(180084, 'Big Pine', 37.1650009155273, 0.648651632482659, -118.288612365723, -2.06452575339714, 218, 6, 'PPL', 'P'),
(15229, 'Big Pine Key', 24.6694393157959, 0.430562940681576, -81.3541717529297, -1.41989815732159, 218, 12, 'PPL', 'P'),
(193130, 'Big Pine Mobile Home Park', 33.4605598449707, 0.583996938855342, -111.97917175293, -1.95440524074485, 218, 5, 'PPL', 'P'),
(44827, 'Big Pines', 39.0844383239746, 0.682152135046011, -77.2266693115234, -1.34785964983495, 218, 25, 'PPL', 'P'),
(180085, 'Big Pines', 34.3788909912109, 0.600024840980848, -117.689170837402, -2.05406352505476, 218, 6, 'PPL', 'P'),
(195992, 'Big Pines Mobile Court', 46.8813896179199, 0.818234606742989, -113.898887634277, -1.98791060357719, 218, 31, 'PPL', 'P'),
(53476, 'Big Piney', 37.6719398498535, 0.657499385993202, -92.0977783203125, -1.60740946546131, 218, 29, 'PPL', 'P'),
(85066, 'Big Piney', 35.6875, 0.622864376805476, -84.3333282470703, -1.47189424707651, 218, 50, 'PPL', 'P'),
(209307, 'Big Piney', 42.538330078125, 0.742433918163418, -110.113609313965, -1.92184503378338, 218, 59, 'PPL', 'P'),
(71822, 'Big Plain', 39.8386116027832, 0.695314941891782, -83.2891693115234, -1.4536702357371, 218, 41, 'PPL', 'P'),
(192485, 'Big Plain Junction', 37.0488891601563, 0.646625100051163, -113.105827331543, -1.97406909012762, 218, 52, 'PPL', 'P'),
(58671, 'Big Point', 30.586669921875, 0.533838097357435, -88.4819412231445, -1.54430120289997, 218, 30, 'PPL', 'P'),
(159213, 'Big Pond', 41.8827781677246, 0.730992378909192, -76.7050018310547, -1.33875483470018, 218, 45, 'PPL', 'P'),
(44828, 'Big Pool', 39.6236114501953, 0.691562481336833, -78.01611328125, -1.36163804636669, 218, 25, 'PPL', 'P'),
(129818, 'Big Prairie', 43.5186080932617, 0.759542997112469, -85.6425018310547, -1.49474363659718, 218, 27, 'PPL', 'P'),
(154319, 'Big Prairie', 40.6672210693359, 0.709776905296321, -82.0952835083008, -1.43283299757805, 218, 41, 'PPL', 'P'),
(85067, 'Big Q Estates', 36.2666702270508, 0.632972804197036, -83.4197235107422, -1.45594883636577, 218, 50, 'PPL', 'P'),
(129820, 'Big Rapids', 43.6980590820313, 0.762675007712456, -85.4836120605469, -1.49197048695408, 218, 27, 'PPL', 'P'),
(34812, 'Big Reedy', 37.2691688537598, 0.650469705979829, -86.4355621337891, -1.50858515004675, 218, 21, 'PPL', 'P'),
(192933, 'Big Reef Mill', 33.9647216796875, 0.592796222834046, -112.484169006348, -1.96321910553053, 218, 5, 'PPL', 'P'),
(736, 'Big Ridge', 33.7447204589844, 0.58895647717437, -87.2366714477539, -1.52256714524383, 218, 2, 'PPL', 'P'),
(53478, 'Big Ridge', 36.7275009155273, 0.641015817005184, -89.6627807617188, -1.56491074078582, 218, 29, 'PPL', 'P'),
(62949, 'Big Ridge', 35.2063903808594, 0.614467429888456, -83.0899963378906, -1.45019401156622, 218, 33, 'PPL', 'P'),
(180086, 'Big Ripples (historical)', 39.6272201538086, 0.691625465096614, -121.491386413574, -2.12042470572958, 218, 6, 'PPL', 'P'),
(180087, 'Big River', 34.1399993896484, 0.59585539597822, -114.360557556152, -1.99596826377134, 218, 6, 'PPL', 'P'),
(191135, 'Big River Park Colonia', 28.681999206543, 0.500595322208576, -100.475997924805, -1.75363698301483, 218, 51, 'PPL', 'P'),
(7474, 'Big Rock', 35.1744384765625, 0.613909763956194, -94.2780609130859, -1.64546257532912, 218, 4, 'PPL', 'P'),
(34813, 'Big Rock', 37.0430603027344, 0.646523367297522, -83.2072219848633, -1.45223998507368, 218, 21, 'PPL', 'P'),
(71823, 'Big Rock', 39.1016693115234, 0.682452872512108, -82.7763900756836, -1.44472054973584, 218, 41, 'PPL', 'P'),
(85068, 'Big Rock', 36.5805587768555, 0.638451192875438, -87.7600021362305, -1.53170098883448, 218, 50, 'PPL', 'P'),
(92639, 'Big Rock', 32.3591690063477, 0.564774042370068, -95.9408264160156, -1.67448330804382, 218, 51, 'PPL', 'P'),
(99924, 'Big Rock', 37.3583297729492, 0.65202585758379, -82.1875, -1.43444247898284, 218, 53, 'PPL', 'P'),
(114610, 'Big Rock', 41.7702789306641, 0.729028896816504, -90.8261108398438, -1.58521468093659, 218, 16, 'PPL', 'P'),
(118801, 'Big Rock', 41.7638893127441, 0.728917376945857, -88.5469436645508, -1.54543570952434, 218, 18, 'PPL', 'P'),
(143524, 'Big Rock Corner', 43.7811088562012, 0.764124499714759, -71.4497222900391, -1.24703290359676, 218, 36, 'PPL', 'P'),
(180088, 'Big Rock Springs', 34.4352798461914, 0.601009012161687, -117.834716796875, -2.05660378126053, 218, 6, 'PPL', 'P'),
(75126, 'Big Rocks', 34.2294387817383, 0.59741640785117, -95.5727767944336, -1.6680596303365, 218, 42, 'PPL', 'P'),
(71824, 'Big Run', 39.355281829834, 0.686879245980902, -81.8727798461914, -1.4289495760765, 218, 41, 'PPL', 'P'),
(112636, 'Big Run', 39.4708290100098, 0.688895924716364, -80.3775024414063, -1.40285206213232, 218, 58, 'PPL', 'P'),
(177404, 'Big Run', 41.0813903808594, 0.717005523443123, -77.6680603027344, -1.35556337592022, 218, 45, 'PPL', 'P'),
(118803, 'Big Run Acres', 41.6469383239746, 0.726876197128366, -88.0252838134766, -1.53633102754764, 218, 18, 'PPL', 'P'),
(195993, 'Big Sag', 47.5977783203125, 0.830737948323829, -110.712783813477, -1.93230260159385, 218, 31, 'PPL', 'P'),
(85070, 'Big Sandy', 36.2347183227539, 0.632415138264773, -88.0852813720703, -1.53737818248826, 218, 50, 'PPL', 'P'),
(92640, 'Big Sandy', 32.583610534668, 0.568691286017466, -95.1086120605469, -1.65995842745853, 218, 51, 'PPL', 'P'),
(108225, 'Big Sandy', 37.464168548584, 0.653873092694896, -81.6983337402344, -1.42590491716026, 218, 58, 'PPL', 'P'),
(195994, 'Big Sandy', 48.1786117553711, 0.84087540417127, -110.111389160156, -1.92180628478952, 218, 31, 'PPL', 'P'),
(209308, 'Big Sandy', 42.6333312988281, 0.744092002258101, -109.464996337891, -1.91052460177973, 218, 59, 'PPL', 'P'),
(34814, 'Big Sandy Junction', 38.415828704834, 0.670482695781502, -82.5997161865234, -1.44163700866769, 218, 21, 'PPL', 'P'),
(195995, 'Big Sandy Trailer Court', 48.1786117553711, 0.84087540417127, -110.111389160156, -1.92180628478952, 218, 31, 'PPL', 'P'),
(134256, 'Big Sauk Lake Mobile Home Park', 45.7583312988281, 0.798633541382924, -94.9291687011719, -1.6568265500166, 218, 28, 'PPL', 'P'),
(15230, 'Big Scrub', 29.0113906860352, 0.50634428805373, -81.8013916015625, -1.4277036161605, 218, 12, 'PPL', 'P'),
(159217, 'Big Shanty', 41.8375015258789, 0.730202152434739, -78.6549987792969, -1.37278870185085, 218, 45, 'PPL', 'P'),
(19283, 'Big Shanty Hills', 34.0338897705078, 0.594003433756179, -84.6355590820313, -1.47716917024763, 218, 13, 'PPL', 'P'),
(196003, 'Big Sky', 45.2847213745117, 0.790367488833482, -111.367500305176, -1.94372956004111, 218, 31, 'PPL', 'P'),
(195996, 'Big Sky Canyon Village', 45.2638893127441, 0.790003900765659, -111.252777099609, -1.94172726237553, 218, 31, 'PPL', 'P'),
(195997, 'Big Sky Colonial Manor', 48.3666687011719, 0.844157617056739, -114.199996948242, -1.9931659525143, 218, 31, 'PPL', 'P'),
(195998, 'Big Sky Colony', 48.8480606079102, 0.852559490821775, -112.783332824707, -1.96844049916373, 218, 31, 'PPL', 'P'),
(203043, 'Big Sky Estates', 41.2980613708496, 0.720787145612009, -111.851387023926, -1.95217497648997, 218, 52, 'PPL', 'P'),
(195999, 'Big Sky Meadow Village', 45.2675018310547, 0.790066951104466, -111.301109313965, -1.94257081865081, 218, 31, 'PPL', 'P'),
(196000, 'Big Sky Mobile Home Court', 45.2661094665527, 0.790042649759519, -111.330558776855, -1.9430848087412, 218, 31, 'PPL', 'P'),
(196001, 'Big Sky Mobile Home Park', 46.2097206115723, 0.806511771098624, -114.144439697266, -1.9921962955614, 218, 31, 'PPL', 'P'),
(196002, 'Big Sky Mountain Village', 45.2897186279297, 0.790454707359182, -111.39778137207, -1.94425806435943, 218, 31, 'PPL', 'P'),
(34815, 'Big South Fork (historical)', 36.7172203063965, 0.64083638652674, -84.5447235107422, -1.47558379045071, 218, 21, 'PPL', 'P'),
(34816, 'Big Spring', 37.7991714477539, 0.659719996289137, -86.1522216796875, -1.50363992621859, 218, 21, 'PPL', 'P'),
(44831, 'Big Spring', 39.4952812194824, 0.689322696281049, -76.7402801513672, -1.33937055754421, 218, 25, 'PPL', 'P'),
(53481, 'Big Spring', 38.8025016784668, 0.677231412299872, -91.4775009155273, -1.59658358247208, 218, 29, 'PPL', 'P'),
(85072, 'Big Spring', 35.3930587768555, 0.617725408008005, -84.9005584716797, -1.48179428211278, 218, 50, 'PPL', 'P'),
(99925, 'Big Spring', 38.7249984741211, 0.675878726203193, -78.4236068725586, -1.3687501512158, 218, 53, 'PPL', 'P'),
(134257, 'Big Spring', 43.5666694641113, 0.760381826276816, -92.0522232055664, -1.60661437871786, 218, 28, 'PPL', 'P'),
(159219, 'Big Spring', 40.1297187805176, 0.700395720619435, -77.4055633544922, -1.35098193989696, 218, 45, 'PPL', 'P'),
(173179, 'Big Spring', 43.6694412231445, 0.762175531850012, -89.6436080932617, -1.56457611459485, 218, 57, 'PPL', 'P'),
(191136, 'Big Spring', 32.2502784729004, 0.562873544037161, -101.478332519531, -1.77113102189945, 218, 51, 'PPL', 'P'),
(749, 'Big Spring (historical)', 34.225830078125, 0.597353424091389, -86.4066696166992, -1.50808088049435, 218, 2, 'PPL', 'P'),
(19284, 'Big Spring (historical)', 34.478328704834, 0.601760356484225, -84.8311080932617, -1.48058214434263, 218, 13, 'PPL', 'P'),
(85073, 'Big Spring (historical)', 36.2488899230957, 0.632662479351014, -86.1772232055664, -1.5040762851632, 218, 50, 'PPL', 'P'),
(114611, 'Big Spring (historical)', 40.6833305358887, 0.710058068528406, -93.5266723632813, -1.63234837117324, 218, 16, 'PPL', 'P'),
(7477, 'Big Spring Mill', 35.827220916748, 0.625302966836635, -91.7236099243164, -1.60087899499427, 218, 4, 'PPL', 'P'),
(753, 'Big Springs', 33.2825012207031, 0.580889229600301, -85.3063888549805, -1.488877358506, 218, 2, 'PPL', 'P'),
(19285, 'Big Springs', 32.9949989318848, 0.575871368053401, -84.9049987792969, -1.4818717801005, 218, 13, 'PPL', 'P'),
(31825, 'Big Springs', 39.0130615234375, 0.680906374867099, -95.4847183227539, -1.66652272007141, 218, 20, 'PPL', 'P'),
(79799, 'Big Springs', 34.4208297729492, 0.600756810806456, -80.309440612793, -1.40166415912809, 218, 48, 'PPL', 'P'),
(85078, 'Big Springs', 35.7108306884766, 0.623271574136149, -86.2727813720703, -1.50574408979586, 218, 50, 'PPL', 'P'),
(92641, 'Big Springs', 32.0672187805176, 0.559678549677393, -94.9672164916992, -1.65749060923441, 218, 51, 'PPL', 'P'),
(108226, 'Big Springs', 38.985279083252, 0.680421479811623, -81.0722198486328, -1.41497716825934, 218, 58, 'PPL', 'P'),
(122228, 'Big Springs', 40.0702781677246, 0.699358286216795, -86.2605590820313, -1.50553077059254, 218, 19, 'PPL', 'P'),
(144841, 'Big Springs', 41.1277809143066, 0.717815190993535, -74.6222229003906, -1.30240348476893, 218, 37, 'PPL', 'P'),
(154321, 'Big Springs', 40.500560760498, 0.70686813417471, -83.6355590820313, -1.45971587772769, 218, 41, 'PPL', 'P'),
(169836, 'Big Springs', 42.938060760498, 0.749410534692071, -96.6072235107422, -1.68611413147253, 218, 49, 'PPL', 'P'),
(177634, 'Big Springs', 36.6016693115234, 0.63881964121225, -112.349166870117, -1.96086287375608, 218, 5, 'PPL', 'P'),
(193383, 'Big Springs', 41.5955581665039, 0.725979444210309, -122.40389251709, -2.13635094168047, 218, 6, 'PPL', 'P'),
(194594, 'Big Springs', 44.4983291625977, 0.77664235552354, -111.254997253418, -1.94176601136939, 218, 17, 'PPL', 'P'),
(199179, 'Big Springs', 41.0613899230957, 0.716656449603241, -102.073890686035, -1.78152547279209, 218, 35, 'PPL', 'P'),
(191137, 'Big Square', 34.3847198486328, 0.600126573734489, -102.469169616699, -1.78842439159594, 218, 51, 'PPL', 'P'),
(108227, 'Big Stick', 37.6944389343262, 0.657892069095934, -81.2538909912109, -1.41814792785319, 218, 58, 'PPL', 'P'),
(169838, 'Big Stone City', 45.2916717529297, 0.790488795821135, -96.4625015258789, -1.68358825633664, 218, 49, 'PPL', 'P'),
(134258, 'Big Stone Colony', 45.5291709899902, 0.794633939478816, -96.4738922119141, -1.68378706131202, 218, 28, 'PPL', 'P'),
(196004, 'Big Stone Colony', 47.4000015258789, 0.827286092076923, -111.216667175293, -1.94109702530356, 218, 31, 'PPL', 'P'),
(99926, 'Big Stone Gap', 36.8816719055176, 0.643706608391573, -82.7472229003906, -1.44421148649347, 218, 53, 'PPL', 'P'),
(180089, 'Big Sur', 36.2702789306641, 0.633035787956816, -121.80638885498, -2.12592253548394, 218, 6, 'PPL', 'P'),
(92642, 'Big Thicket Creekmore Village', 30.4772205352783, 0.531927845197035, -94.7750015258789, -1.65413582520924, 218, 51, 'PPL', 'P'),
(92643, 'Big Thicket Loblolly', 30.2861099243164, 0.528592335800252, -94.6750030517578, -1.65239052258885, 218, 51, 'PPL', 'P'),
(196005, 'Big Timber', 45.8349990844727, 0.799971646672634, -109.954719543457, -1.91907188414028, 218, 31, 'PPL', 'P'),
(147203, 'Big Tree', 42.769718170166, 0.746472402219441, -78.8116683959961, -1.37552310250009, 218, 40, 'PPL', 'P'),
(180091, 'Big Trees', 38.2775001525879, 0.668068407095291, -120.309440612793, -2.09979585992582, 218, 6, 'PPL', 'P'),
(189937, 'Big Trees', 37.9027786254883, 0.661528282669301, -114.559722900391, -1.99944435478416, 218, 39, 'PPL', 'P'),
(180092, 'Big Trees Village', 38.3097190856934, 0.668630733559461, -120.260559082031, -2.09894271627061, 218, 6, 'PPL', 'P'),
(92644, 'Big Valley', 31.3895397186279, 0.547850818775592, -98.6520919799805, -1.72180381903095, 218, 51, 'PPL', 'P'),
(180093, 'Big Valley', 38.1319389343262, 0.66552788457341, -120.426940917969, -2.10184662712324, 218, 6, 'PPL', 'P'),
(99927, 'Big Vein', 37.2961082458496, 0.650939887070283, -81.3569412231445, -1.41994649369537, 218, 53, 'PPL', 'P'),
(71825, 'Big Walnut (historical)', 39.9761085510254, 0.697714716350053, -82.8752822875977, -1.44644654443832, 218, 41, 'PPL', 'P'),
(196006, 'Big Warm (historical)', 48.0202789306641, 0.83811197506615, -108.448608398438, -1.89278528575871, 218, 31, 'PPL', 'P'),
(192486, 'Big Water', 37.0825004577637, 0.64721172786028, -111.663612365723, -1.94889769045251, 218, 52, 'PPL', 'P'),
(92645, 'Big Wells', 28.5730590820313, 0.498693958348314, -99.5683288574219, -1.7377951692705, 218, 51, 'PPL', 'P'),
(34817, 'Big Windy', 37.3186111450195, 0.651332636752042, -86.0944366455078, -1.50263138711377, 218, 21, 'PPL', 'P'),
(34818, 'Big Woods', 37.9891700744629, 0.663036097899477, -83.4766693115234, -1.45694272808459, 218, 21, 'PPL', 'P'),
(39385, 'Big Woods', 30.2855606079102, 0.528582748420328, -93.5630569458008, -1.63298340193517, 218, 22, 'PPL', 'P'),
(112383, 'Big Woods', 39.560001373291, 0.690452276057407, -76.3108291625977, -1.33187522381424, 218, 25, 'PPL', 'P'),
(134261, 'Big Woods', 48.3113899230957, 0.84319282037283, -97.107780456543, -1.69485049827048, 218, 28, 'PPL', 'P'),
(44830, 'Big Woods Acres', 39.1911087036133, 0.684013884385058, -77.4033279418945, -1.35094292458699, 218, 25, 'PPL', 'P'),
(44832, 'Big Woods Estates', 39.3250007629395, 0.686350741662576, -77.3249969482422, -1.34957579084139, 218, 25, 'PPL', 'P'),
(763, 'Bigbee', 31.6138896942139, 0.551766464526335, -88.166389465332, -1.53879378576569, 218, 2, 'PPL', 'P'),
(58672, 'Bigbee', 34.0161094665527, 0.593693108910157, -88.519172668457, -1.54495101420595, 218, 30, 'PPL', 'P'),
(58673, 'Bigbee Valley', 33.2480583190918, 0.580288087563243, -88.3497161865234, -1.54199344065736, 218, 30, 'PPL', 'P'),
(108228, 'Bigbend', 38.9636116027832, 0.680043310936832, -81.1619415283203, -1.41654310698031, 218, 58, 'PPL', 'P'),
(85079, 'Bigby (historical)', 35.5755615234375, 0.620910681829794, -87.2161102294922, -1.52220828428695, 218, 50, 'PPL', 'P'),
(191138, 'Bigby Corner', 31.7069396972656, 0.553390493448579, -101.651107788086, -1.77414651920175, 218, 51, 'PPL', 'P'),
(85080, 'Bigbyville', 35.5205612182617, 0.619950745414875, -87.0800018310547, -1.5198327445946, 218, 50, 'PPL', 'P'),
(7481, 'Bigelow', 35.0011100769043, 0.610884612694946, -92.6297225952148, -1.61669364449549, 218, 4, 'PPL', 'P'),
(126880, 'Bigelow', 45.0808296203613, 0.786808906405891, -70.3211135864258, -1.22733496575205, 218, 26, 'PPL', 'P'),
(129823, 'Bigelow', 44.978328704834, 0.78501992794363, -84.2761077880859, -1.47089556166774, 218, 27, 'PPL', 'P'),
(134263, 'Bigelow', 43.5052795410156, 0.75931036999125, -95.6897201538086, -1.67010067699593, 218, 28, 'PPL', 'P'),
(139040, 'Bigelow', 40.1105613708496, 0.700061360744576, -95.289436340332, -1.66311440650833, 218, 29, 'PPL', 'P'),
(147204, 'Bigelow', 44.4216690063477, 0.775304383391884, -75.3663864135742, -1.31539158824719, 218, 40, 'PPL', 'P'),
(177501, 'Bigelow Corners', 41.4719390869141, 0.723821884253181, -73.504997253418, -1.28290421874153, 218, 8, 'PPL', 'P'),
(92646, 'Bigfoot', 29.0466709136963, 0.50696004418727, -98.8663864135742, -1.72554396246586, 218, 51, 'PPL', 'P'),
(134266, 'Bigfork', 47.7444381713867, 0.833297645605559, -93.6538925170898, -1.6345687817321, 218, 28, 'PPL', 'P'),
(196007, 'Bigfork', 48.0633316040039, 0.838863385967716, -114.071670532227, -1.99092623403755, 218, 31, 'PPL', 'P'),
(15231, 'Biggar', 26.5202808380127, 0.462866219176882, -81.89111328125, -1.42926955488147, 218, 12, 'PPL', 'P'),
(7482, 'Biggers', 36.3325004577637, 0.634121758470323, -90.8061065673828, -1.58486554051768, 218, 4, 'PPL', 'P'),
(92647, 'Biggers (historical)', 33.1967010498047, 0.57939173411935, -96.5462493896484, -1.68504993230093, 218, 51, 'PPL', 'P'),
(159220, 'Biggerstown', 41.252498626709, 0.719991925710511, -76.5313873291016, -1.33572469001189, 218, 45, 'PPL', 'P'),
(58674, 'Biggersville', 34.8355598449707, 0.607995216070264, -88.5586090087891, -1.54563930818968, 218, 30, 'PPL', 'P'),
(34819, 'Biggs', 37.4205589294434, 0.653111961255351, -82.2705612182617, -1.43589217072222, 218, 21, 'PPL', 'P'),
(118804, 'Biggs', 40.2413902282715, 0.70234475506321, -89.904167175293, -1.56912372847227, 218, 18, 'PPL', 'P'),
(180094, 'Biggs', 39.4124984741211, 0.687877864810654, -121.711669921875, -2.12426937823727, 218, 6, 'PPL', 'P'),
(53482, 'Biggs (historical)', 36.9124984741211, 0.644244633510796, -92.1913909912109, -1.60904331479007, 218, 29, 'PPL', 'P'),
(188144, 'Biggs (historical)', 36.9055595397949, 0.644123526260225, -106.79167175293, -1.86386628579765, 218, 38, 'PPL', 'P'),
(193200, 'Biggs Junction', 45.6699981689453, 0.797091837427877, -120.831672668457, -2.10891052875662, 218, 43, 'PPL', 'P'),
(129824, 'Biggs Settlement', 44.7102813720703, 0.780341619435715, -84.129997253418, -1.46834545176593, 218, 27, 'PPL', 'P'),
(118805, 'Biggsville', 40.8536109924316, 0.71303002314688, -90.8647232055664, -1.58588859385043, 218, 18, 'PPL', 'P'),
(75127, 'Bigheart', 36.8516693115234, 0.643182964342236, -96.2255630493164, -1.67945289979597, 218, 42, 'PPL', 'P'),
(34820, 'Bighill', 37.5544395446777, 0.655448618795787, -84.2083282470703, -1.46971258551152, 218, 21, 'PPL', 'P'),
(186415, 'Bighorn', 39.6366691589355, 0.691790381347117, -106.296669006348, -1.85522685806338, 218, 7, 'PPL', 'P'),
(196008, 'Bighorn', 46.1616706848145, 0.805673141671358, -107.448059082031, -1.87532240585884, 218, 31, 'PPL', 'P'),
(44833, 'Biglanes Choice', 38.5997200012207, 0.673692204369211, -76.5666732788086, -1.33634054601397, 218, 25, 'PPL', 'P'),
(159222, 'Bigler', 40.9847183227539, 0.715318277734504, -78.3066711425781, -1.36670923771442, 218, 45, 'PPL', 'P'),
(77868, 'Biglerville', 39.9302787780762, 0.696914835916647, -77.2483291625977, -1.34823768555168, 218, 45, 'PPL', 'P'),
(186416, 'Biglow', 39.3436088562012, 0.686675514157511, -106.66667175293, -1.86168462423265, 218, 7, 'PPL', 'P'),
(199181, 'Bignell', 41.0633316040039, 0.716690338328112, -100.610557556152, -1.75598549162212, 218, 35, 'PPL', 'P'),
(177647, 'Bignotti', 34.6772193908691, 0.605231653807089, -111.949440002441, -1.95388632380645, 218, 5, 'PPL', 'P'),
(173180, 'Bigpatch', 42.6666717529297, 0.744673902956284, -90.4761123657227, -1.57910605518622, 218, 57, 'PPL', 'P'),
(85081, 'Bigsby Creek Estates', 35.2277793884277, 0.614840738494258, -84.8958282470703, -1.48171172411898, 218, 50, 'PPL', 'P'),
(108229, 'Bigson', 37.9913902282715, 0.663074846893338, -81.7236099243164, -1.42634606979484, 218, 58, 'PPL', 'P'),
(34821, 'Bigstone', 38.1049995422363, 0.665057703482956, -83.1699981689453, -1.45159030692575, 218, 21, 'PPL', 'P'),
(44834, 'Bigwoods', 39.2855606079102, 0.685662381099817, -76.0427780151367, -1.32719684872729, 218, 25, 'PPL', 'P'),
(180095, 'Bihlman (historical)', 39.2644386291504, 0.685293733025923, -121.660827636719, -2.12338201296205, 218, 6, 'PPL', 'P'),
(39386, 'Bijou', 31.107780456543, 0.54293319195422, -92.2425003051758, -1.60993534059719, 218, 22, 'PPL', 'P'),
(186417, 'Bijou', 39.4225006103516, 0.688052435020109, -104.197776794434, -1.81859427832101, 218, 7, 'PPL', 'P'),
(169840, 'Bijou Hills', 43.5180587768555, 0.759533409732544, -99.1494369506836, -1.73048412628796, 218, 49, 'PPL', 'P'),
(62950, 'Bilboa', 35.9558296203613, 0.627547612161408, -78.8530578613281, -1.37624548494577, 218, 33, 'PPL', 'P'),
(85083, 'Bilbrey', 36.1736106872559, 0.631348608827224, -85.3324966430664, -1.48933302536852, 218, 50, 'PPL', 'P'),
(58675, 'Bilbros Corner', 32.4416694641113, 0.566213946992447, -89.7983322143555, -1.56727655994019, 218, 30, 'PPL', 'P'),
(159223, 'Bilger Rocks', 40.9938888549805, 0.715478333716017, -78.5924987792969, -1.37169787106835, 218, 45, 'PPL', 'P'),
(209309, 'Bill', 43.2319412231445, 0.754539716372537, -105.259719848633, -1.83712868108547, 218, 59, 'PPL', 'P'),
(196009, 'Bill Bracket Place', 46.2638893127441, 0.807457193285602, -110.590560913086, -1.9301694095607, 218, 31, 'PPL', 'P'),
(19286, 'Bill Davis (historical)', 32.9963912963867, 0.575895669398348, -81.8116683959961, -1.42788298005992, 218, 13, 'PPL', 'P'),
(39388, 'Billeaud', 30.1355590820313, 0.525964727910725, -91.945556640625, -1.60475269595784, 218, 22, 'PPL', 'P'),
(124249, 'Billerica', 42.5583305358887, 0.7427829920033, -71.2694396972656, -1.24388637876884, 218, 23, 'PPL', 'P'),
(26525, 'Billett', 38.6644401550293, 0.674821784145568, -87.6522216796875, -1.5298198649985, 218, 18, 'PPL', 'P'),
(108230, 'Billie (historical)', 37.3180618286133, 0.651323049372118, -81.1125030517578, -1.41568024278712, 218, 58, 'PPL', 'P'),
(29215, 'Billie Creek Village', 39.7613906860352, 0.69396718264312, -87.2019424438477, -1.52196100977973, 218, 19, 'PPL', 'P'),
(159224, 'Billing', 41.2825012207031, 0.720515569759848, -79.5113906860352, -1.38773556031087, 218, 45, 'PPL', 'P'),
(53485, 'Billings', 37.0675010681152, 0.646949939125126, -93.5519409179688, -1.63278939064976, 218, 29, 'PPL', 'P'),
(75129, 'Billings', 36.5288887023926, 0.63754937995131, -97.4436111450195, -1.70071184951363, 218, 42, 'PPL', 'P'),
(108231, 'Billings', 38.8572196960449, 0.678186421866774, -81.4038925170898, -1.42076594836279, 218, 58, 'PPL', 'P'),
(129825, 'Billings', 43.8497200012207, 0.765321990098913, -84.3472213745117, -1.47213672789377, 218, 27, 'PPL', 'P'),
(147205, 'Billings', 41.6711082458496, 0.727298041845034, -73.7636108398438, -1.28741787731505, 218, 40, 'PPL', 'P'),
(196010, 'Billings', 45.7833290100098, 0.799069833748506, -108.5, -1.89368223841385, 218, 31, 'PPL', 'P'),
(126881, 'Billings Hill', 44.836109161377, 0.782537728649621, -69.1983337402344, -1.20773876066097, 218, 26, 'PPL', 'P'),
(171746, 'Billings Mobile Manor', 43.5919418334961, 0.760822912332361, -72.9599990844727, -1.2733922062761, 218, 55, 'PPL', 'P'),
(173181, 'Billings Park', 46.7183303833008, 0.815388686223103, -92.1241683959961, -1.60787005917184, 218, 57, 'PPL', 'P'),
(766, 'Billingsley', 32.6594390869141, 0.570014743921181, -86.7177810668945, -1.51351079964091, 218, 2, 'PPL', 'P'),
(44835, 'Billingsley Forest', 38.6049995422363, 0.673784349742928, -77.0297164916992, -1.34442217465793, 218, 25, 'PPL', 'P'),
(44836, 'Billingsley Park', 38.5999984741211, 0.6736970646382, -76.9875030517578, -1.34368541114236, 218, 25, 'PPL', 'P'),
(7484, 'Billingsleys Corner', 33.9080581665039, 0.591807257963245, -94.4069366455078, -1.6477118811858, 218, 4, 'PPL', 'P'),
(70545, 'Billingsport', 39.848331451416, 0.69548458525322, -75.2422180175781, -1.31322444091014, 218, 37, 'PPL', 'P'),
(154327, 'Billingstown', 41.6930618286133, 0.72768120414687, -84.7955627441406, -1.47996176096669, 218, 41, 'PPL', 'P'),
(29216, 'Billingsville', 39.5558280944824, 0.690379438601593, -84.9097213745117, -1.48195420493623, 218, 19, 'PPL', 'P'),
(53483, 'Billingsville', 38.9030609130859, 0.678986502037261, -92.7941665649414, -1.61956373320226, 218, 29, 'PPL', 'P'),
(147206, 'Billington Heights', 42.7841682434082, 0.746724603574672, -78.6266708374023, -1.37229428599448, 218, 40, 'PPL', 'P'),
(19287, 'Billingwood', 32.8958282470703, 0.574140513081932, -83.7300033569336, -1.4613642412844, 218, 13, 'PPL', 'P'),
(39387, 'Billis (historical)', 31.6124992370605, 0.551742196470902, -92.8133316040039, -1.61989822623518, 218, 22, 'PPL', 'P'),
(159225, 'Billmeyer', 40.0722198486328, 0.699392174941666, -76.6513900756836, -1.33781913305118, 218, 45, 'PPL', 'P'),
(53484, 'Billmore', 36.5627784729004, 0.638140868029416, -91.2149963378906, -1.59200201329076, 218, 29, 'PPL', 'P'),
(34822, 'Billows', 37.1708297729492, 0.6487533652363, -84.2966690063477, -1.47125442262462, 218, 21, 'PPL', 'P'),
(194595, 'Bills', 42.5322189331055, 0.74232725856176, -114.28556060791, -1.99465932009556, 218, 17, 'PPL', 'P'),
(75130, 'Bills Corner', 36.2900009155273, 0.633380001527709, -97.0672225952148, -1.69414263005273, 218, 42, 'PPL', 'P'),
(62951, 'Bills Creek', 35.4486083984375, 0.618694931802848, -82.146110534668, -1.43372009653716, 218, 33, 'PPL', 'P'),
(159226, 'Bills Place (historical)', 40.0158309936523, 0.698408003760828, -78.2016677856445, -1.36487658341028, 218, 45, 'PPL', 'P'),
(147207, 'Billsboro', 42.8016700744629, 0.747030068151704, -76.9786071777344, -1.3435301488508, 218, 40, 'PPL', 'P'),
(147208, 'Billsboro Corners', 42.8105583190918, 0.747185197285201, -77.008056640625, -1.34404413894119, 218, 40, 'PPL', 'P'),
(201907, 'Billsburg', 44.4005584716797, 0.774935935055072, -101.679718017578, -1.77464586190614, 218, 49, 'PPL', 'P'),
(301, 'Billstown', 33.9808311462402, 0.593077386066131, -93.5708312988281, -1.63311908999271, 218, 4, 'PPL', 'P'),
(29217, 'Billtown', 39.5099983215332, 0.689579558168188, -87.1861114501953, -1.52168470681664, 218, 19, 'PPL', 'P'),
(58676, 'Billups', 33.4305610656738, 0.583473361385033, -88.5849990844727, -1.54609990190021, 218, 30, 'PPL', 'P'),
(29218, 'Billville', 39.5036087036133, 0.689468038297541, -87.1255569458008, -1.52062783133804, 218, 19, 'PPL', 'P'),
(774, 'Billy Goat Hill', 34.1941719055176, 0.596800884744225, -85.6949996948242, -1.49565989717022, 218, 2, 'PPL', 'P'),
(39389, 'Billy Goat Hill', 31.0886096954346, 0.542598599052765, -93.2705612182617, -1.6278783884416, 218, 22, 'PPL', 'P'),
(19288, 'Billyville', 30.9252796173096, 0.539747951421944, -81.682502746582, -1.42562861419717, 218, 13, 'PPL', 'P'),
(58677, 'Biloxi', 30.3958301544189, 0.530507315071587, -88.8852767944336, -1.55134073660938, 218, 30, 'PPL', 'P'),
(206837, 'Biloxi', 47.5055618286133, 0.82912846691904, -122.472778320313, -2.13755322575458, 218, 56, 'PPL', 'P'),
(15233, 'Biltmore', 30.2875003814697, 0.528616603855685, -81.7355575561523, -1.42655459530819, 218, 12, 'PPL', 'P'),
(39390, 'Biltmore', 30.538890838623, 0.533004195041104, -91.0236129760742, -1.58866174349353, 218, 22, 'PPL', 'P'),
(62953, 'Biltmore', 35.6116714477539, 0.621540918901761, -77.3897171020508, -1.35070537061775, 218, 33, 'PPL', 'P'),
(79800, 'Biltmore', 34.8083305358887, 0.60751997497374, -82.4244384765625, -1.43857783552351, 218, 48, 'PPL', 'P'),
(85087, 'Biltmore', 36.3722190856934, 0.634814979302071, -82.225830078125, -1.43511146504867, 218, 50, 'PPL', 'P'),
(99928, 'Biltmore', 37.6505584716797, 0.657126210545455, -77.4691696166992, -1.35209207859735, 218, 53, 'PPL', 'P'),
(15234, 'Biltmore Beach', 30.1436100006104, 0.526105242947741, -85.758056640625, -1.49676044849069, 218, 12, 'PPL', 'P'),
(62954, 'Biltmore Forest', 35.5336112976074, 0.620178512267104, -82.5286102294922, -1.44039597559971, 218, 33, 'PPL', 'P'),
(154323, 'Biltmore Gardens', 41.6069412231445, 0.726178116027629, -83.466667175293, -1.45676815787514, 218, 41, 'PPL', 'P'),
(177655, 'Biltmore Gates', 33.5224990844727, 0.585077982520833, -112.016670227051, -1.95505971258274, 218, 5, 'PPL', 'P'),
(177656, 'Biltmore Greens III', 33.5286102294922, 0.58518464212249, -112.012496948242, -1.95498687512693, 218, 5, 'PPL', 'P'),
(147209, 'Biltmore Shores', 40.6636085510254, 0.709713854957514, -73.466667175293, -1.2822352326757, 218, 40, 'PPL', 'P'),
(177657, 'Biltmore Villas', 33.5125007629395, 0.584903478890405, -112.02082824707, -1.95513228372245, 218, 5, 'PPL', 'P'),
(108232, 'Bim', 37.9216690063477, 0.661857982012253, -81.6894378662109, -1.42574965486871, 218, 58, 'PPL', 'P'),
(34823, 'Bimble', 36.875, 0.643590161672909, -83.8305587768555, -1.46311926444276, 218, 21, 'PPL', 'P'),
(15235, 'Bimini', 29.4822196960449, 0.514561804492306, -81.355827331543, -1.41992705261942, 218, 12, 'PPL', 'P'),
(62956, 'Bina', 36.4836082458496, 0.636759086897829, -81.4991683959961, -1.42242882614744, 218, 33, 'PPL', 'P'),
(85085, 'Binfield', 35.7050018310547, 0.623169841382508, -84.0744400024414, -1.46737579481303, 218, 50, 'PPL', 'P'),
(58678, 'Binford', 33.753059387207, 0.589102018927942, -88.5808334350586, -1.54602719760245, 218, 30, 'PPL', 'P'),
(139677, 'Binford', 47.561939239502, 0.830112438362797, -98.3447189331055, -1.7164391473311, 218, 34, 'PPL', 'P'),
(209310, 'Binford', 42.3333282470703, 0.738855961238897, -105.342498779297, -1.83857344597684, 218, 59, 'PPL', 'P'),
(196012, 'Bing', 46.4433288574219, 0.810589004148508, -114.08332824707, -1.99112969954483, 218, 31, 'PPL', 'P'),
(108233, 'Bingamon', 39.4638900756836, 0.688774817465793, -80.3394393920898, -1.4021877365984, 218, 58, 'PPL', 'P'),
(7485, 'Bingen', 33.9755592346191, 0.592985373850469, -93.7838897705078, -1.63683766182279, 218, 4, 'PPL', 'P'),
(159230, 'Bingen', 40.5572204589844, 0.707857032466483, -75.3533325195313, -1.31516375481593, 218, 45, 'PPL', 'P'),
(206838, 'Bingen', 45.7150001525879, 0.797877270212369, -121.463333129883, -2.11993508356316, 218, 56, 'PPL', 'P'),
(39391, 'Bingen (historical)', 30.860559463501, 0.538618371645587, -91.4749984741211, -1.5965399066302, 218, 22, 'PPL', 'P'),
(75132, 'Binger', 35.3088912963867, 0.616256408350717, -98.341667175293, -1.71638588410929, 218, 42, 'PPL', 'P'),
(777, 'Bingham', 34.6463890075684, 0.604693562108839, -87.4974975585938, -1.52711941965316, 218, 2, 'PPL', 'P'),
(7486, 'Bingham', 34.5849990844727, 0.603622105823272, -92.2736129760742, -1.61047835914346, 218, 4, 'PPL', 'P'),
(26526, 'Bingham', 39.1141700744629, 0.682671051984413, -89.2133331298828, -1.55706639979499, 218, 18, 'PPL', 'P'),
(71826, 'Bingham', 39.8474998474121, 0.695470071025279, -80.9611129760742, -1.4130379875116, 218, 41, 'PPL', 'P'),
(79801, 'Bingham', 34.435001373291, 0.601004151892697, -79.543327331543, -1.38829295992702, 218, 48, 'PPL', 'P'),
(85086, 'Bingham', 35.9300003051758, 0.627096805567885, -86.9683303833008, -1.51788371015082, 218, 50, 'PPL', 'P'),
(108234, 'Bingham', 38.0336112976074, 0.663811743566962, -80.7938919067383, -1.41011942927298, 218, 58, 'PPL', 'P'),
(114612, 'Bingham', 40.7341690063477, 0.710945367224594, -95.2886123657227, -1.66310002543844, 218, 16, 'PPL', 'P'),
(126882, 'Bingham', 45.0586090087891, 0.786421083572148, -69.8827819824219, -1.21968463604663, 218, 26, 'PPL', 'P'),
(129827, 'Bingham', 44.8758316040039, 0.783231016060396, -85.6741714477539, -1.49529637568142, 218, 27, 'PPL', 'P'),
(159227, 'Bingham', 41.8169403076172, 0.72984329147785, -78.6122207641602, -1.37204208463925, 218, 45, 'PPL', 'P'),
(180098, 'Bingham', 33.8461112976074, 0.5907260811397, -118.058326721191, -2.06050651067999, 218, 6, 'PPL', 'P'),
(188145, 'Bingham', 33.8888893127441, 0.591472698351304, -106.371940612793, -1.85654059542911, 218, 38, 'PPL', 'P'),
(199182, 'Bingham', 42.021110534668, 0.733406734174431, -102.08805847168, -1.7817727472993, 218, 35, 'PPL', 'P'),
(19289, 'Bingham (historical)', 31.8186092376709, 0.55533949460284, -82.7683334350586, -1.44457993483028, 218, 13, 'PPL', 'P'),
(53487, 'Bingham (historical)', 39.4169387817383, 0.687955362798376, -93.6208267211914, -1.63399167472388, 218, 29, 'PPL', 'P'),
(62957, 'Bingham Bridge (historical)', 35.4433288574219, 0.618602786429132, -81.4869384765625, -1.42221537378607, 218, 33, 'PPL', 'P'),
(159228, 'Bingham Center', 41.9538917541504, 0.732233545135224, -77.7766723632813, -1.35745901398414, 218, 45, 'PPL', 'P'),
(129828, 'Bingham Farms', 42.5158309936523, 0.742041235060686, -83.2733306884766, -1.45339379961595, 218, 27, 'PPL', 'P'),
(62958, 'Bingham Heights', 35.6105613708496, 0.621521544404831, -82.5858306884766, -1.44139466100849, 218, 33, 'PPL', 'P'),
(134269, 'Bingham Lake', 43.9066696166992, 0.766315948396758, -95.0461120605469, -1.65886759667604, 218, 28, 'PPL', 'P'),
(147210, 'Bingham Mills', 42.1094398498535, 0.73494837155045, -73.8319396972656, -1.28861044085119, 218, 40, 'PPL', 'P'),
(200413, 'Bingham Springs', 45.7422218322754, 0.798352378150839, -118.230827331543, -2.06351721429233, 218, 43, 'PPL', 'P'),
(85088, 'Binghampton', 35.1500015258789, 0.613483258707618, -89.9694366455078, -1.57026289562855, 218, 50, 'PPL', 'P'),
(118807, 'Binghampton', 41.7166709899902, 0.728093261746532, -89.3038864135742, -1.5586468527439, 218, 18, 'PPL', 'P'),
(147211, 'Binghamton', 42.0986099243164, 0.734759353692082, -75.918327331543, -1.32502477454223, 218, 40, 'PPL', 'P'),
(173182, 'Binghamton', 44.4269409179688, 0.775396395607547, -88.4738922119141, -1.54416072115247, 218, 57, 'PPL', 'P'),
(180099, 'Binghamton', 38.351390838623, 0.669358042853161, -121.821670532227, -2.12618925106711, 218, 6, 'PPL', 'P'),
(781, 'Binghamtown', 33.5800018310547, 0.586081594777629, -86.1869430541992, -1.50424592852463, 218, 2, 'PPL', 'P'),
(34824, 'Binghamtown', 36.6313896179199, 0.63933835841357, -83.7211074829102, -1.46120897899284, 218, 21, 'PPL', 'P'),
(79802, 'Binghamtown (historical)', 34.6883316040039, 0.605425598513474, -81.0202789306641, -1.41407062822428, 218, 48, 'PPL', 'P'),
(171747, 'Binghamville', 44.6749992370605, 0.779725830012661, -72.9238891601563, -1.27276196920413, 218, 55, 'PPL', 'P'),
(147214, 'Bingley', 42.961669921875, 0.749822592291734, -75.8311080932617, -1.32350251166314, 218, 40, 'PPL', 'P'),
(26527, 'Bingman Station', 38.0830612182617, 0.66467480749723, -88.2447204589844, -1.54016091951128, 218, 18, 'PPL', 'P'),
(126884, 'Bingo', 45.3488883972168, 0.791487414650887, -67.6769409179688, -1.18118544669623, 218, 26, 'PPL', 'P'),
(194597, 'Bingo Creek Landing', 46.7572212219238, 0.816067459405937, -115.735832214355, -2.01997133467622, 218, 17, 'PPL', 'P'),
(206839, 'Bingville', 48.3849983215332, 0.844477529282684, -117.628890991211, -2.05301144326613, 218, 56, 'PPL', 'P'),
(53488, 'Binkley', 39.6433296203613, 0.691906628328699, -92.5477828979492, -1.61526352699011, 218, 29, 'PPL', 'P'),
(147215, 'Binnewater', 41.8563919067383, 0.73053185177769, -74.0858306884766, -1.29304167458897, 218, 40, 'PPL', 'P'),
(26528, 'Binney', 38.9900016784668, 0.680503904647361, -89.7272186279297, -1.56603539371416, 218, 18, 'PPL', 'P'),
(180100, 'Binney Junction', 39.1575012207031, 0.683427323154968, -121.589172363281, -2.12213139251415, 218, 6, 'PPL', 'P'),
(118808, 'Binnie Hills', 42.1211090087891, 0.735152036794814, -88.3636093139648, -1.54223592147461, 218, 18, 'PPL', 'P'),
(118809, 'Binnie Lakes', 42.1163902282715, 0.735069678538104, -88.3594436645508, -1.54216321717686, 218, 18, 'PPL', 'P'),
(34825, 'Binns Mill', 36.752498626709, 0.641452109370766, -87.6597213745117, -1.52995075936608, 218, 21, 'PPL', 'P'),
(159231, 'Binnstown', 40.0152816772461, 0.698398416380903, -79.9677810668945, -1.39570107513129, 218, 45, 'PPL', 'P'),
(58680, 'Binnsville', 32.9130592346191, 0.574441250548029, -88.3827819824219, -1.54257054766558, 218, 30, 'PPL', 'P'),
(77870, 'Bino', 39.7536087036133, 0.693831361427526, -77.8097229003906, -1.35803585467625, 218, 45, 'PPL', 'P'),
(154324, 'Binola', 41.3327789306641, 0.721393081339029, -81.8369369506836, -1.42832399953644, 218, 41, 'PPL', 'P'),
(108235, 'Binola (historical)', 39.1749992370605, 0.683732721152973, -81.716667175293, -1.42622489596524, 218, 58, 'PPL', 'P'),
(19290, 'Bio', 34.273609161377, 0.59818732640772, -82.9355621337891, -1.44749862622695, 218, 13, 'PPL', 'P'),
(180101, 'Biola', 36.8022193908691, 0.642319900411969, -120.015281677246, -2.09466181797637, 218, 6, 'PPL', 'P'),
(180102, 'Biola Junction', 36.8008308410645, 0.642295665646049, -119.867782592773, -2.09208747330864, 218, 6, 'PPL', 'P'),
(122229, 'Bippus', 40.9441719055176, 0.714610609253842, -85.623893737793, -1.49441886410224, 218, 19, 'PPL', 'P'),
(92648, 'Birch', 30.3816699981689, 0.530260173722428, -96.6769409179688, -1.68733092977458, 218, 51, 'PPL', 'P'),
(99929, 'Birch', 36.7147216796875, 0.64079277726389, -79.1672210693359, -1.38172866731414, 218, 53, 'PPL', 'P'),
(129832, 'Birch', 46.6986083984375, 0.81504447265221, -87.5780563354492, -1.52852543555067, 218, 27, 'PPL', 'P'),
(134271, 'Birch', 47.0341682434082, 0.820901096784431, -92.5919418334961, -1.61603424580958, 218, 28, 'PPL', 'P'),
(159232, 'Birch', 41.1955604553223, 0.718998167149748, -77.9763870239258, -1.36094469237689, 218, 45, 'PPL', 'P'),
(173183, 'Birch', 46.538330078125, 0.812247088243191, -90.5752792358398, -1.58083684357866, 218, 57, 'PPL', 'P'),
(206840, 'Birch', 47.2247200012207, 0.824226852353722, -121.968063354492, -2.12874428781693, 218, 56, 'PPL', 'P'),
(189938, 'Birch (historical)', 39.9222183227539, 0.696774154432064, -115.872222900391, -2.02235180121659, 218, 39, 'PPL', 'P'),
(206841, 'Birch Bay', 48.9180603027344, 0.853781215971849, -122.74333190918, -2.1422752766834, 218, 56, 'PPL', 'P'),
(206842, 'Birch Bay Circle Grange', 48.9338912963867, 0.854057518934945, -122.746673583984, -2.14233359991128, 218, 56, 'PPL', 'P'),
(129833, 'Birch Beach', 43.2019386291504, 0.7540160723232, -82.5124969482422, -1.4401147457886, 218, 27, 'PPL', 'P'),
(134272, 'Birch Beach', 48.9524993896484, 0.85438229142988, -94.9316711425781, -1.65687022585848, 218, 28, 'PPL', 'P'),
(129834, 'Birch Creek', 45.2027816772461, 0.788937371328109, -87.6111068725586, -1.52910227624278, 218, 27, 'PPL', 'P'),
(196013, 'Birch Creek (historical)', 45.4091682434082, 0.792539496439523, -112.71028137207, -1.96716551079186, 218, 31, 'PPL', 'P'),
(196014, 'Birch Creek Colony', 48.2477798461914, 0.842082615093403, -112.469436645508, -1.96296197732728, 218, 31, 'PPL', 'P'),
(177502, 'Birch Groves', 41.5469398498535, 0.725130894507982, -73.4416732788086, -1.28179900688915, 218, 8, 'PPL', 'P'),
(44837, 'Birch Hanger', 38.4111099243164, 0.670400337524791, -76.7675018310547, -1.33984566548268, 218, 25, 'PPL', 'P'),
(126885, 'Birch Harbor', 44.3886108398438, 0.774727409541719, -68.0377807617188, -1.18748329004205, 218, 26, 'PPL', 'P'),
(169281, 'Birch Hill (historical)', 41.7138900756836, 0.728044725635665, -71.5250015258789, -1.24834677412056, 218, 47, 'PPL', 'P'),
(126886, 'Birch Hill Mobile Home Park', 44.8469390869141, 0.78272674650799, -68.8016662597656, -1.2008156070912, 218, 26, 'PPL', 'P'),
(144842, 'Birch Hills', 40.809440612793, 0.71225910459033, -74.4319381713867, -1.29908238973155, 218, 37, 'PPL', 'P'),
(26529, 'Birch Island', 39.1313896179199, 0.682971589713429, -90.6811065673828, -1.58268387895268, 218, 18, 'PPL', 'P'),
(13383, 'Birch Knoll', 39.8325004577637, 0.695208282290125, -75.5044403076172, -1.31780108324344, 218, 10, 'PPL', 'P'),
(44842, 'Birch Manor', 38.4127807617188, 0.670429499138728, -76.7213897705078, -1.33904085820126, 218, 25, 'PPL', 'P'),
(180103, 'Birch Meadow Acres', 39.1547203063965, 0.683378787044102, -121.024436950684, -2.11227490016172, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(15236, 'Birch Ocean Front', 26.1308307647705, 0.456069033126673, -80.1063919067383, -1.39812029066552, 218, 12, 'PPL', 'P'),
(203047, 'Birch Point Condominium', 40.6549987792969, 0.709563586093006, -111.855560302734, -1.95224781394578, 218, 52, 'PPL', 'P'),
(13384, 'Birch Pointe', 39.7069396972656, 0.693016833608126, -75.6999969482422, -1.32121419049649, 218, 10, 'PPL', 'P'),
(108236, 'Birch River', 38.4986114501953, 0.671927527251897, -80.7552795410156, -1.40944551635914, 218, 58, 'PPL', 'P'),
(129835, 'Birch Run', 43.2508316040039, 0.754869415715488, -83.7941665649414, -1.46248410052277, 218, 27, 'PPL', 'P'),
(99930, 'Birch Town', 37.920280456543, 0.661833747246333, -75.3688888549805, -1.31543526408907, 218, 53, 'PPL', 'P'),
(53489, 'Birch Tree', 36.9911117553711, 0.645616694104405, -91.4925003051758, -1.59684537120723, 218, 29, 'PPL', 'P'),
(159239, 'Birch Valley', 40.1669387817383, 0.701045332188333, -74.8280563354492, -1.30599595592139, 218, 45, 'PPL', 'P'),
(159233, 'Birchardville', 41.8474998474121, 0.730376656065166, -76.0130615234375, -1.326678198105, 218, 45, 'PPL', 'P'),
(99931, 'Birchdale', 38.6388893127441, 0.674375837821034, -77.3108291625977, -1.34932851633418, 218, 53, 'PPL', 'P'),
(134278, 'Birchdale', 48.6269416809082, 0.848700237507114, -94.1016693115234, -1.64238396110899, 218, 28, 'PPL', 'P'),
(211700, 'Birches', 65.1350021362305, 1.13682024557076, -153.556671142578, -2.68006949984015, 218, 1, 'PPL', 'P'),
(99932, 'Birchett Estate', 37.2602806091309, 0.650314576846332, -77.2772216796875, -1.34874195510409, 218, 53, 'PPL', 'P'),
(70546, 'Birchfield', 39.9361114501953, 0.697016635249316, -74.9250030517578, -1.30768799531997, 218, 37, 'PPL', 'P'),
(188146, 'Birchfield', 31.6308307647705, 0.552062141986361, -108.851387023926, -1.89981509893014, 218, 38, 'PPL', 'P'),
(206843, 'Birchfield', 46.577220916748, 0.812925861426025, -120.433326721191, -2.10195808041486, 218, 56, 'PPL', 'P'),
(122230, 'Birchim', 41.7102813720703, 0.727981741875885, -86.602783203125, -1.51150370828537, 218, 19, 'PPL', 'P'),
(99933, 'Birchleaf', 37.1772193908691, 0.648864885106947, -82.272216796875, -1.43592106602005, 218, 53, 'PPL', 'P'),
(134280, 'Birchmont', 47.5463905334473, 0.829841062247718, -94.8602828979492, -1.65562426594248, 218, 28, 'PPL', 'P'),
(203048, 'Birchmont', 40.6158294677734, 0.708879952641183, -111.886108398438, -1.95278097879601, 218, 52, 'PPL', 'P'),
(19291, 'Birchmore', 33.9038887023926, 0.591734487086458, -83.4463882446289, -1.45641422376627, 218, 13, 'PPL', 'P'),
(159234, 'Birchrunville', 40.1294403076172, 0.700390860350446, -75.6380615234375, -1.32013321341002, 218, 45, 'PPL', 'P'),
(152, 'Birchton', 37.9327812194824, 0.662051926718638, -81.5416717529297, -1.42317064966908, 218, 58, 'PPL', 'P'),
(147216, 'Birchton', 43.0008316040039, 0.750506092585503, -73.9686126708984, -1.29099583423957, 218, 40, 'PPL', 'P'),
(159235, 'Birchtown', 41.6525001525879, 0.726973269350099, -75.5183334350586, -1.31804356406069, 218, 45, 'PPL', 'P'),
(180104, 'Birchville', 39.3277816772461, 0.686399277773442, -121.143333435059, -2.1143500352831, 218, 6, 'PPL', 'P'),
(44838, 'Birchwood', 39.0625, 0.681769239060285, -76.5027770996094, -1.3352253473075, 218, 25, 'PPL', 'P'),
(62965, 'Birchwood', 35.603889465332, 0.621405097686167, -77.5947189331055, -1.35428332754227, 218, 33, 'PPL', 'P'),
(85090, 'Birchwood', 35.3624992370605, 0.617192043420689, -84.9922180175781, -1.48339404297959, 218, 50, 'PPL', 'P'),
(129838, 'Birchwood', 45.5386085510254, 0.794798655992237, -84.5374984741211, -1.4754576897731, 218, 27, 'PPL', 'P'),
(134281, 'Birchwood', 45.0611114501953, 0.786464759414025, -92.975830078125, -1.62273435963806, 218, 28, 'PPL', 'P'),
(173186, 'Birchwood', 45.666389465332, 0.797028853668097, -91.5558319091797, -1.59795071621767, 218, 57, 'PPL', 'P'),
(177503, 'Birchwood', 41.8977813720703, 0.731254234223374, -72.7216720581055, -1.2692326149695, 218, 8, 'PPL', 'P'),
(211701, 'Birchwood', 61.4052810668945, 1.07172433272985, -149.468887329102, -2.60872421318526, 218, 1, 'PPL', 'P'),
(129839, 'Birchwood Beach', 44.872501373291, 0.783172892569605, -84.3219375610352, -1.47169544210114, 218, 27, 'PPL', 'P'),
(114614, 'Birchwood Estates', 43.1605606079102, 0.753293889614598, -95.1430587768555, -1.66055963607462, 218, 16, 'PPL', 'P'),
(159236, 'Birchwood Estates', 41.357780456543, 0.721829440283638, -75.57861328125, -1.31909564584933, 218, 45, 'PPL', 'P'),
(203049, 'Birchwood Estates', 40.6455612182617, 0.709398869579585, -111.863609313965, -1.95238829569328, 218, 52, 'PPL', 'P'),
(44839, 'Birchwood Gardens', 39.0508308410645, 0.681565573815921, -76.836669921875, -1.34105287640481, 218, 25, 'PPL', 'P'),
(70547, 'Birchwood Lakes', 39.8661117553711, 0.695794910099242, -74.8127822875977, -1.30572937349627, 218, 37, 'PPL', 'P'),
(159237, 'Birchwood Lakes', 41.2544403076172, 0.720025814435382, -74.9188919067383, -1.30758133571832, 218, 45, 'PPL', 'P'),
(13385, 'Birchwood Park', 39.6763916015625, 0.692483668757892, -75.6902770996094, -1.32104454713505, 218, 10, 'PPL', 'P'),
(62964, 'Birchwood Park', 34.7638893127441, 0.606744329306254, -77.341667175293, -1.34986674119048, 218, 33, 'PPL', 'P'),
(99934, 'Birchwood Park', 37.2463912963867, 0.650072162608107, -76.730827331543, -1.33920557471468, 218, 53, 'PPL', 'P'),
(129840, 'Birchwood Shores', 44.0838890075684, 0.769409010265803, -83.5899963378906, -1.45892065782619, 218, 27, 'PPL', 'P'),
(159238, 'Birchwood Terrace', 40.2783317565918, 0.702989506363118, -75.5983276367188, -1.31943972626217, 218, 45, 'PPL', 'P'),
(134282, 'Birchwood Terrace Mobile Home Park', 45.336109161377, 0.791264374909593, -92.9633331298828, -1.62251624674478, 218, 28, 'PPL', 'P'),
(99935, 'Birchwood-Gardens', 36.8455581665039, 0.643076304740578, -76.1052780151367, -1.32828767950979, 218, 53, 'PPL', 'P'),
(39392, 'Bird', 30.4741706848145, 0.531874615264747, -91.1230621337891, -1.59039745873399, 218, 22, 'PPL', 'P'),
(147217, 'Bird', 42.3661117553711, 0.7394281413991, -78.5447235107422, -1.37086403533105, 218, 40, 'PPL', 'P'),
(786, 'Bird (historical)', 34.0297203063965, 0.593930662879392, -86.3891677856445, -1.50777541591732, 218, 2, 'PPL', 'P'),
(85091, 'Bird (historical)', 35.3388900756836, 0.616779985821027, -87.5805587768555, -1.52856911139255, 218, 50, 'PPL', 'P'),
(62966, 'Bird Cage', 34.3458290100098, 0.599447800551655, -78.8441696166992, -1.37609035581228, 218, 33, 'PPL', 'P'),
(187599, 'Bird City', 39.7508316040039, 0.693782891895687, -101.532501220703, -1.77207644408643, 218, 20, 'PPL', 'P'),
(85092, 'Bird Crossroad', 35.913890838623, 0.6268156423358, -83.3636093139648, -1.4549694588749, 218, 50, 'PPL', 'P'),
(79803, 'Bird Fields', 34.8875007629395, 0.608901756105327, -82.3491668701172, -1.43726409815778, 218, 48, 'PPL', 'P'),
(147219, 'Bird Grove', 40.832218170166, 0.712656647962051, -73.7555618286133, -1.28727739556755, 218, 40, 'PPL', 'P'),
(44840, 'Bird Hill', 39.4883308410645, 0.689201389293396, -76.970832824707, -1.34339446079327, 218, 25, 'PPL', 'P'),
(85093, 'Bird Hill', 36.1247215270996, 0.630495332013962, -83.1155624389648, -1.45064022420687, 218, 50, 'PPL', 'P'),
(44841, 'Bird Hill Estates', 39.4866714477539, 0.689172427416542, -76.959716796875, -1.34320044950785, 218, 25, 'PPL', 'P'),
(159240, 'Bird in Hand', 40.0386085510254, 0.698805547132549, -76.182502746582, -1.32963550533748, 218, 45, 'PPL', 'P'),
(134284, 'Bird Island', 44.7675018310547, 0.781340304844495, -94.8952789306641, -1.65623506193849, 218, 28, 'PPL', 'P'),
(85094, 'Bird Mill', 35.0997200012207, 0.612605680549409, -87.2994384765625, -1.52366263655824, 218, 50, 'PPL', 'P'),
(44843, 'Bird River Beach', 39.375560760498, 0.687233180089773, -76.3874969482422, -1.33321332910395, 218, 25, 'PPL', 'P'),
(53491, 'Bird Springs', 36.7480583190918, 0.641374611383045, -92.2350006103516, -1.60980444622961, 218, 29, 'PPL', 'P'),
(7489, 'Birdell', 36.2444381713867, 0.632584781626211, -91.0780563354492, -1.58961195937047, 218, 4, 'PPL', 'P'),
(159241, 'Birdell', 40.0727806091309, 0.699401962058672, -75.8611068725586, -1.32402608913345, 218, 45, 'PPL', 'P'),
(789, 'Birdeye', 32.6130599975586, 0.569205276107851, -87.8291702270508, -1.53290819975661, 218, 2, 'PPL', 'P'),
(7490, 'Birdeye', 35.3786087036133, 0.617473206652775, -90.6872177124023, -1.58279053855434, 218, 4, 'PPL', 'P'),
(79804, 'Birdfield Estates', 34.8047218322754, 0.607456991213959, -82.3177795410156, -1.43671628592155, 218, 48, 'PPL', 'P'),
(19294, 'Birdford (historical)', 31.9752807617188, 0.558073928541593, -81.894172668457, -1.42932295126133, 218, 13, 'PPL', 'P'),
(791, 'Birdie', 34.1666717529297, 0.596320916536766, -86.5419387817383, -1.5104417728007, 218, 2, 'PPL', 'P'),
(19292, 'Birdie', 33.3197212219238, 0.581538841169199, -84.3444366455078, -1.47208812520387, 218, 13, 'PPL', 'P'),
(34827, 'Birdie', 38.0374984741211, 0.663879587595732, -85.0147171020508, -1.48378672608232, 218, 21, 'PPL', 'P'),
(58681, 'Birdie', 34.3919410705566, 0.600252607833077, -90.3819427490234, -1.57746248531947, 218, 30, 'PPL', 'P'),
(171748, 'Birdport', 43.9850006103516, 0.76768308214235, -73.3130569458008, -1.27955422840632, 218, 55, 'PPL', 'P'),
(19293, 'Birds', 32.3405609130859, 0.564449269875133, -81.2441711425781, -1.41797828449175, 218, 13, 'PPL', 'P'),
(118811, 'Birds', 41.4749984741211, 0.723875280633037, -88.1972198486328, -1.53933187746394, 218, 18, 'PPL', 'P'),
(85095, 'Birds Bower', 35.461669921875, 0.618922898392159, -89.4191665649414, -1.56065887094746, 218, 50, 'PPL', 'P'),
(13386, 'Birds Corner', 39.5633316040039, 0.690510399548198, -75.6405563354492, -1.32017675609385, 218, 10, 'PPL', 'P'),
(53495, 'Birds Corner', 36.889720916748, 0.643847090139074, -89.7636108398438, -1.56667055763415, 218, 29, 'PPL', 'P'),
(108237, 'Birds Creek', 39.4358291625977, 0.688285062141327, -79.807502746582, -1.39290369072227, 218, 58, 'PPL', 'P'),
(124251, 'Birds Hill', 42.2750015258789, 0.737837967912214, -71.2125015258789, -1.24289262020807, 218, 23, 'PPL', 'P'),
(180105, 'Birds Landing', 38.1327781677246, 0.665542531959405, -121.869720458984, -2.12702788049437, 218, 6, 'PPL', 'P'),
(53492, 'Birds Nest', 37.997501373291, 0.663181506494995, -91.3591690063477, -1.59451830104672, 218, 29, 'PPL', 'P'),
(79805, 'Birds Nest', 33.4111099243164, 0.583133874925075, -79.133056640625, -1.38113238554607, 218, 48, 'PPL', 'P'),
(154325, 'Birds Nest', 41.4749984741211, 0.723875280633037, -81.7772216796875, -1.42728177144383, 218, 41, 'PPL', 'P'),
(53493, 'Birds Point', 36.9658317565918, 0.645175474890806, -89.1563873291016, -1.55607250807618, 218, 29, 'PPL', 'P'),
(154326, 'Birds Run', 40.1688919067383, 0.701079420650286, -81.6474990844727, -1.4250176850431, 218, 41, 'PPL', 'P'),
(129841, 'Birdsall', 41.9419403076172, 0.732024953042843, -84.0044403076172, -1.46615406966296, 218, 27, 'PPL', 'P'),
(147218, 'Birdsall', 42.3913917541504, 0.739869360612699, -77.9205627441406, -1.35997037489208, 218, 40, 'PPL', 'P'),
(159242, 'Birdsboro', 40.2644386291504, 0.702747025545866, -75.804443359375, -1.32303712426264, 218, 45, 'PPL', 'P'),
(29219, 'Birdseye', 38.3166694641113, 0.668752040547114, -86.6958312988281, -1.5131277039181, 218, 19, 'PPL', 'P'),
(186418, 'Birdseye', 39.3111114501953, 0.686108327424351, -106.226936340332, -1.85400979344521, 218, 7, 'PPL', 'P'),
(192487, 'Birdseye', 39.9244384765625, 0.696812903425925, -111.548889160156, -1.94689539278694, 218, 52, 'PPL', 'P'),
(196015, 'Birdseye', 46.6655616760254, 0.814467698539126, -112.149436950684, -1.95737692904722, 218, 31, 'PPL', 'P'),
(99936, 'Birdsnest', 37.4388885498047, 0.653431873481297, -75.8813934326172, -1.32438015640037, 218, 53, 'PPL', 'P'),
(795, 'Birdsong', 34.2449989318848, 0.597687983703331, -86.6466674804688, -1.51226963341488, 218, 2, 'PPL', 'P'),
(7491, 'Birdsong', 35.4583282470703, 0.618864575164286, -90.2624969482422, -1.57537776281816, 218, 4, 'PPL', 'P'),
(53494, 'Birdsong', 37.8661117553711, 0.660888325059355, -93.730827331543, -1.63591154755372, 218, 29, 'PPL', 'P'),
(85096, 'Birdsong Creek Subdivision', 35.9874992370605, 0.628100351245654, -88.0444412231445, -1.5366653874225, 218, 50, 'PPL', 'P'),
(19295, 'Birdsong Crossroads', 32.8086090087891, 0.572618250202842, -84.2572174072266, -1.47056586232478, 218, 13, 'PPL', 'P'),
(112556, 'Birdsong Heights', 35.9791717529297, 0.627955009229163, -88.0491714477539, -1.53674794541629, 218, 50, 'PPL', 'P'),
(79806, 'Birdstown Crossroads', 34.4627799987793, 0.601488980369146, -79.9936065673828, -1.39615181514579, 218, 48, 'PPL', 'P'),
(206845, 'Birdsview', 48.5224990844727, 0.846877370319982, -121.874168395996, -2.12710551164015, 218, 56, 'PPL', 'P'),
(19296, 'Birdsville', 32.8713912963867, 0.573714007833355, -82.0780563354492, -1.43253232669098, 218, 13, 'PPL', 'P'),
(34826, 'Birdsville', 37.2211112976074, 0.649630943394509, -88.4480590820313, -1.54370984797992, 218, 21, 'PPL', 'P'),
(44844, 'Birdsville', 38.9000015258789, 0.678933105657405, -76.591667175293, -1.33677677180053, 218, 25, 'PPL', 'P'),
(85099, 'Birdsville (historical)', 35.8683280944824, 0.626020422434302, -83.2724990844727, -1.45337928538801, 218, 50, 'PPL', 'P'),
(7492, 'Birdtown', 35.3061103820801, 0.616207872239851, -92.6074981689453, -1.61630575508272, 218, 4, 'PPL', 'P'),
(62967, 'Birdtown', 35.4686088562012, 0.61904400564273, -83.3522186279297, -1.45477065389952, 218, 33, 'PPL', 'P'),
(79807, 'Birdtown', 34.6300010681152, 0.604407538607764, -80.4336090087891, -1.40383130646514, 218, 48, 'PPL', 'P'),
(159245, 'Birdville', 40.4019393920898, 0.705146866583164, -77.9422225952148, -1.36034841060882, 218, 45, 'PPL', 'P'),
(199183, 'Birdwood', 41.1536102294922, 0.718265997587058, -100.884437561035, -1.7607655994627, 218, 35, 'PPL', 'P'),
(34829, 'Birk City', 37.7852783203125, 0.659477515471886, -87.2844390869141, -1.52340084782308, 218, 21, 'PPL', 'P'),
(118812, 'Birkbeck', 40.1769409179688, 0.701219902397788, -88.8683319091797, -1.55104499257032, 218, 18, 'PPL', 'P'),
(200414, 'Birkenfeld', 45.9908294677734, 0.802691399935878, -123.336387634277, -2.15262605173416, 218, 43, 'PPL', 'P'),
(26532, 'Birkner', 38.5622215270996, 0.673037732531324, -90.029167175293, -1.57130539003727, 218, 18, 'PPL', 'P'),
(209311, 'Birkner Hill', 43.1138916015625, 0.752479361795197, -105.713890075684, -1.84505544691204, 218, 59, 'PPL', 'P'),
(44845, 'Birkwood Estates', 38.4466705322266, 0.671020987216834, -76.9225006103516, -1.34255090451798, 218, 25, 'PPL', 'P'),
(7493, 'Birmac', 34.1713905334473, 0.596403274793476, -91.6194381713867, -1.59906085491807, 218, 4, 'PPL', 'P'),
(799, 'Birmingham', 33.5205612182617, 0.585044160374989, -86.8024978637695, -1.51498938667812, 218, 2, 'PPL', 'P'),
(19297, 'Birmingham', 34.166389465332, 0.596315989688749, -84.3330612182617, -1.47188958654461, 218, 13, 'PPL', 'P'),
(31828, 'Birmingham', 39.4091682434082, 0.687819741319863, -95.6822204589844, -1.66996978262836, 218, 20, 'PPL', 'P'),
(34828, 'Birmingham', 36.9063911437988, 0.644138040488166, -88.2236099243164, -1.53979247117447, 218, 21, 'PPL', 'P'),
(53496, 'Birmingham', 39.165828704834, 0.683572665171459, -94.4511108398438, -1.64848286632138, 218, 29, 'PPL', 'P'),
(58682, 'Birmingham', 34.4083290100098, 0.600538631334151, -88.769172668457, -1.54931433733594, 218, 30, 'PPL', 'P'),
(70548, 'Birmingham', 39.975830078125, 0.697709856081063, -74.710563659668, -1.30394532188203, 218, 37, 'PPL', 'P'),
(99937, 'Birmingham', 37.0724983215332, 0.647037157650826, -81.8138885498047, -1.42792172905378, 218, 53, 'PPL', 'P'),
(114615, 'Birmingham', 40.8788909912109, 0.713471242360479, -91.9469375610352, -1.60477679756571, 218, 16, 'PPL', 'P'),
(118813, 'Birmingham', 40.2641716003418, 0.702742365013959, -90.8208312988281, -1.58512253556287, 218, 18, 'PPL', 'P'),
(122232, 'Birmingham', 40.4686088562012, 0.706310468242447, -86.852783203125, -1.51586703141536, 218, 19, 'PPL', 'P'),
(129842, 'Birmingham', 42.5466690063477, 0.742579459916991, -83.2113876342773, -1.45231268937143, 218, 27, 'PPL', 'P'),
(154329, 'Birmingham', 40.1752815246582, 0.701190940520933, -81.4375, -1.42135250959288, 218, 41, 'PPL', 'P'),
(159246, 'Birmingham', 40.6477813720703, 0.709437618573445, -78.195556640625, -1.36476992380862, 218, 45, 'PPL', 'P'),
(147221, 'Birmingham Corners', 42.8886108398438, 0.748547470761804, -75.1380615234375, -1.31140656715005, 218, 40, 'PPL', 'P'),
(19298, 'Birmingham Road Estates', 34.1622200012207, 0.596243218811963, -84.295280456543, -1.4712301878587, 218, 13, 'PPL', 'P'),
(85097, 'Birnam Wood', 35.1386108398438, 0.613284453732243, -85.3375015258789, -1.48942037705227, 218, 50, 'PPL', 'P'),
(99939, 'Birnam Wood', 36.5919418334961, 0.638649864692758, -79.4780578613281, -1.38715379277074, 218, 53, 'PPL', 'P'),
(173190, 'Birnamwood', 44.9333305358887, 0.784234561738165, -89.2094421386719, -1.5569984891872, 218, 57, 'PPL', 'P'),
(196016, 'Birney', 45.3216705322266, 0.791012373291444, -106.514442443848, -1.85902772157114, 218, 31, 'PPL', 'P'),
(196018, 'Birney Day School', 45.4161109924316, 0.792660670269122, -106.464721679688, -1.85815993052993, 218, 31, 'PPL', 'P'),
(92649, 'Birome', 31.813060760498, 0.555242655407702, -96.9625015258789, -1.69231490259661, 218, 51, 'PPL', 'P'),
(173193, 'Biron', 44.4238891601563, 0.775343132385745, -89.7802810668945, -1.56696150798324, 218, 57, 'PPL', 'P'),
(7494, 'Birta', 35.017219543457, 0.611165775927031, -93.1333312988281, -1.62548327451524, 218, 4, 'PPL', 'P'),
(92650, 'Birthright', 33.2722206115723, 0.580709799121857, -95.5647201538086, -1.66791901543094, 218, 51, 'PPL', 'P'),
(92651, 'Biry', 29.2205600738525, 0.509994982565524, -99.0177764892578, -1.72818621774138, 218, 51, 'PPL', 'P'),
(31829, 'Bisbee', 38.0533294677734, 0.664155890558828, -96.1055603027344, -1.67735845675667, 218, 20, 'PPL', 'P'),
(92652, 'Bisbee', 32.6088905334473, 0.569132505231065, -97.1838912963867, -1.69617888302221, 218, 51, 'PPL', 'P'),
(139682, 'Bisbee', 48.6258316040039, 0.848680863010184, -99.3775024414063, -1.73446462001124, 218, 34, 'PPL', 'P'),
(177662, 'Bisbee', 31.4480590820313, 0.548872174343151, -109.927780151367, -1.91860170304983, 218, 5, 'PPL', 'P'),
(124252, 'Bisbee Corner', 41.790828704834, 0.729387558036311, -70.8691711425781, -1.23690037459734, 218, 23, 'PPL', 'P'),
(177663, 'Bisbee Junction', 31.351390838623, 0.547184995213558, -109.885559082031, -1.9178648063762, 218, 5, 'PPL', 'P'),
(124253, 'Bisbee Mill', 42.374439239502, 0.739573483415591, -72.8194427490234, -1.27093903543797, 218, 23, 'PPL', 'P'),
(134287, 'Biscay', 44.8274993896484, 0.782387459785114, -94.2747192382813, -1.64540425210125, 218, 28, 'PPL', 'P'),
(19299, 'Biscayne Club', 33.6055603027344, 0.586527674260217, -84.4730606079102, -1.47433303684475, 218, 13, 'PPL', 'P'),
(15237, 'Biscayne Gardens', 25.9130592346191, 0.452268202908426, -80.210563659668, -1.39993843074172, 218, 12, 'PPL', 'P'),
(809, 'Biscayne Highlands', 33.5852813720703, 0.586173740151346, -86.6933288574219, -1.51308402807623, 218, 2, 'PPL', 'P'),
(15238, 'Biscayne Park', 25.8822193145752, 0.451729944762607, -80.1808319091797, -1.39941951380332, 218, 12, 'PPL', 'P'),
(15239, 'Biscayne Village', 30.4361095428467, 0.531210323020341, -81.7188873291016, -1.4262636449591, 218, 12, 'PPL', 'P'),
(7495, 'Biscoe', 34.8208312988281, 0.607738154446044, -91.404167175293, -1.59530366725219, 218, 4, 'PPL', 'P'),
(62968, 'Biscoe', 35.3597183227539, 0.617143507309823, -79.7799987792969, -1.39242365593579, 218, 33, 'PPL', 'P'),
(99940, 'Biscoe', 37.8177795410156, 0.660044768784073, -77.0580596923828, -1.34491685683041, 218, 53, 'PPL', 'P'),
(196017, 'Bisel', 45.7058296203613, 0.797717214230855, -111.084167480469, -1.93878446937099, 218, 31, 'PPL', 'P'),
(147222, 'Bishas Mill', 44.0055618286133, 0.768041943099238, -75.2566680908203, -1.31347664226537, 218, 40, 'PPL', 'P'),
(812, 'Bishop', 34.6655616760254, 0.605028188299807, -88.1138916015625, -1.53787752519265, 218, 2, 'PPL', 'P'),
(19300, 'Bishop', 33.8191719055176, 0.590255900049246, -83.4388885498047, -1.45628332939869, 218, 13, 'PPL', 'P'),
(44846, 'Bishop', 38.4275016784668, 0.670686427604893, -75.2213897705078, -1.31286091942134, 218, 25, 'PPL', 'P'),
(62970, 'Bishop', 34.1788902282715, 0.596534169161054, -78.0852813720703, -1.36284525728882, 218, 33, 'PPL', 'P'),
(85098, 'Bishop', 36.0047187805176, 0.628400888974669, -89.3280563354492, -1.55906869746057, 218, 50, 'PPL', 'P'),
(92653, 'Bishop', 27.5858306884766, 0.48146357241161, -97.7988891601563, -1.70691262063772, 218, 51, 'PPL', 'P'),
(99941, 'Bishop', 37.208610534668, 0.649412763922204, -81.5583267211914, -1.42346133370206, 218, 53, 'PPL', 'P'),
(108238, 'Bishop', 37.2083282470703, 0.649407837074187, -81.5602798461914, -1.42349542216401, 218, 58, 'PPL', 'P'),
(118815, 'Bishop', 40.3458290100098, 0.704167555671315, -89.8747177124023, -1.56860973838189, 218, 18, 'PPL', 'P'),
(126887, 'Bishop', 46.8405609130859, 0.817522011414311, -67.9352798461914, -1.18569431157979, 218, 26, 'PPL', 'P'),
(159248, 'Bishop', 40.3205604553223, 0.703726536194798, -80.1872177124023, -1.39953096709494, 218, 45, 'PPL', 'P'),
(177353, 'Bishop', 43.4238891601563, 0.757889839865802, -85.8997192382813, -1.49923292724672, 218, 27, 'PPL', 'P'),
(180106, 'Bishop', 37.3636093139648, 0.652118002957506, -118.394172668457, -2.06636812823926, 218, 6, 'PPL', 'P'),
(209312, 'Bishop', 42.9575004577637, 0.749749821414947, -106.449440002441, -1.85789321494676, 218, 59, 'PPL', 'P'),
(92654, 'Bishop Colonia', 26.1149997711182, 0.455792730163578, -97.7190017700195, -1.70551832264901, 218, 51, 'PPL', 'P'),
(169282, 'Bishop Heights', 41.8263893127441, 0.730008207728354, -71.5580596923828, -1.24892374797072, 218, 47, 'PPL', 'P'),
(118816, 'Bishop Hill', 41.2016716003418, 0.719104826751406, -90.1188888549805, -1.57287132875823, 218, 18, 'PPL', 'P'),
(191139, 'Bishop Hills', 35.2597198486328, 0.615398204689439, -101.949996948242, -1.779363119145, 218, 51, 'PPL', 'P'),
(177666, 'Bishop Place', 35.4602813720703, 0.618898663626239, -112.722221374512, -1.96737390314716, 218, 5, 'PPL', 'P'),
(196020, 'Bishop Place', 45.2249984741211, 0.789325127582825, -112.485832214355, -1.96324813398641, 218, 31, 'PPL', 'P'),
(79810, 'Bishop Town (historical)', 34.6627807617188, 0.60497965218894, -81.7194366455078, -1.42627323233902, 218, 48, 'PPL', 'P'),
(70550, 'Bishop Wood', 39.7541694641113, 0.693841148544532, -75.0144424438477, -1.30924900719292, 218, 37, 'PPL', 'P'),
(70549, 'Bishops', 39.7852783203125, 0.694384100511772, -74.9066696166992, -1.307368016515, 218, 37, 'PPL', 'P'),
(13387, 'Bishops Corner', 39.2236099243164, 0.684581137697245, -75.5761108398438, -1.31905197000745, 218, 10, 'PPL', 'P'),
(99942, 'Bishops Corner', 36.9233283996582, 0.644433651369164, -78.0897216796875, -1.36292275527654, 218, 53, 'PPL', 'P'),
(177504, 'Bishops Corner', 41.5811080932617, 0.725727242855078, -72.8694381713867, -1.27181162016913, 218, 8, 'PPL', 'P'),
(62971, 'Bishops Cross', 35.6108283996582, 0.621526204936739, -76.6780624389648, -1.33828465360973, 218, 33, 'PPL', 'P'),
(44847, 'Bishops Head', 38.2680587768555, 0.667903624002842, -76.0680618286133, -1.32763813451992, 218, 25, 'PPL', 'P'),
(44848, 'Bishopville', 38.4425010681152, 0.670948216340048, -75.1938934326172, -1.31238101779291, 218, 25, 'PPL', 'P'),
(71827, 'Bishopville', 39.5130615234375, 0.689633021127071, -82.0491714477539, -1.43202819029663, 218, 41, 'PPL', 'P'),
(79811, 'Bishopville', 34.2180595397949, 0.597217802612877, -80.2486114501953, -1.40060248995953, 218, 48, 'PPL', 'P'),
(147223, 'Bishopville', 42.3686103820801, 0.73947175066195, -77.7474975585938, -1.35694981758371, 218, 40, 'PPL', 'P'),
(159249, 'Bishtown', 41.0244407653809, 0.716011565145279, -78.3608322143555, -1.36765452674334, 218, 45, 'PPL', 'P'),
(180109, 'Biskra Palms', 33.7900009155273, 0.58974677022785, -116.252220153809, -2.02898400443727, 218, 6, 'PPL', 'P'),
(7498, 'Bismarck', 34.3161087036133, 0.598929083350335, -93.1705627441406, -1.62613308582122, 218, 4, 'PPL', 'P'),
(53497, 'Bismarck', 37.7691688537598, 0.659196352239801, -90.6247177124023, -1.58169970777184, 218, 29, 'PPL', 'P'),
(108243, 'Bismarck', 39.2177810668945, 0.684479404943604, -79.2333297729492, -1.38288248185641, 218, 58, 'PPL', 'P'),
(118818, 'Bismarck', 40.2638893127441, 0.702737438165942, -87.6080627441406, -1.52904914617903, 218, 18, 'PPL', 'P'),
(141301, 'Bismarck', 41.9000015258789, 0.731292983217235, -96.8666687011719, -1.69064230427399, 218, 35, 'PPL', 'P'),
(154330, 'Bismarck', 41.1650009155273, 0.718464802562432, -82.7872161865234, -1.44490950101518, 218, 41, 'PPL', 'P'),
(198009, 'Bismarck', 46.8083305358887, 0.816959485213059, -100.783332824707, -1.75900098892441, 218, 34, 'PPL', 'P'),
(141302, 'Bismarck (historical)', 41.9111099243164, 0.731486861344593, -96.908332824707, -1.69136948040963, 218, 35, 'PPL', 'P'),
(180110, 'Bismarck (historical)', 34.9658317565918, 0.610268889850919, -116.858612060547, -2.0395675397673, 218, 6, 'PPL', 'P'),
(31830, 'Bismark Grove', 38.9847183227539, 0.680411692694617, -95.209716796875, -1.66172303799682, 218, 20, 'PPL', 'P'),
(31831, 'Bison', 38.5227813720703, 0.672349371968566, -99.1969375610352, -1.7313131683353, 218, 20, 'PPL', 'P'),
(75134, 'Bison', 36.1963882446289, 0.631746152198945, -97.8897171020508, -1.70849786727659, 218, 42, 'PPL', 'P'),
(108239, 'Bison', 38.6552810668945, 0.674661927901136, -80.741943359375, -1.40921275607986, 218, 58, 'PPL', 'P'),
(196019, 'Bison', 48.3872184753418, 0.844516278276545, -113.265281677246, -1.97685209346675, 218, 31, 'PPL', 'P'),
(201908, 'Bison', 45.5202789306641, 0.794478743766291, -102.460830688477, -1.78827884984236, 218, 49, 'PPL', 'P'),
(19301, 'Biss', 32.5863914489746, 0.568739822128333, -83.845832824707, -1.46338584686788, 218, 13, 'PPL', 'P'),
(58683, 'Bissaasha (historical)', 32.5222206115723, 0.5676198297319, -89.0388870239258, -1.55402174087876, 218, 30, 'PPL', 'P'),
(206846, 'Bissel', 48.2236099243164, 0.841660770376735, -118.141670227051, -2.06196112926739, 218, 56, 'PPL', 'P'),
(26534, 'Bissell', 39.8461112976074, 0.69544583625936, -89.581672668457, -1.56349513750839, 218, 18, 'PPL', 'P'),
(58684, 'Bissell', 34.2461090087891, 0.597707358200261, -88.7827835083008, -1.54955189130517, 218, 30, 'PPL', 'P'),
(144843, 'Bissell', 40.6666717529297, 0.709767317916397, -74.7922210693359, -1.30537051253939, 218, 37, 'PPL', 'P'),
(159250, 'Bissell', 40.0133285522461, 0.69836432791895, -80.1275024414063, -1.39848873900233, 218, 45, 'PPL', 'P'),
(180113, 'Bissell', 34.9947204589844, 0.610773092824299, -118.001388549805, -2.05951275211923, 218, 6, 'PPL', 'P'),
(200416, 'Bissell', 45.2941703796387, 0.790532405083985, -122.178062438965, -2.13240946326715, 218, 43, 'PPL', 'P'),
(7497, 'Bissell (historical)', 34.2472190856934, 0.597726732697191, -93.9375, -1.63951866609217, 218, 4, 'PPL', 'P'),
(39393, 'Bissonet Plaza', 30.0133304595947, 0.523831436009031, -90.2163925170898, -1.57457308869479, 218, 22, 'PPL', 'P'),
(129845, 'Bitely', 43.746940612793, 0.763528151367663, -85.8616714477539, -1.49856886802891, 218, 27, 'PPL', 'P'),
(15240, 'Bithlo', 28.5544395446777, 0.498368986116297, -81.1066665649414, -1.41557837687543, 218, 12, 'PPL', 'P'),
(77877, 'Bitner', 39.9822196960449, 0.69782137595171, -79.7136077880859, -1.39126491454549, 218, 45, 'PPL', 'P'),
(180112, 'Bitney Corner', 39.2319412231445, 0.684726546292763, -121.107780456543, -2.11372951874912, 218, 6, 'PPL', 'P'),
(209313, 'Bitter Creek', 41.5511093139648, 0.725203665384769, -108.554718017578, -1.89463724798075, 218, 59, 'PPL', 'P'),
(85102, 'Bitter End', 36.211669921875, 0.632012867782117, -82.040283203125, -1.43187306116313, 218, 50, 'PPL', 'P'),
(200415, 'Bitter Lick', 42.7930603027344, 0.746879799287196, -122.637496948242, -2.14042810815132, 218, 43, 'PPL', 'P'),
(196021, 'Bitter Root (historical)', 46.5730590820313, 0.812853223707293, -114.045829772949, -1.99047522770694, 218, 31, 'PPL', 'P'),
(177670, 'Bitter Springs', 36.6286087036133, 0.639289822302704, -111.653610229492, -1.94872312024306, 218, 5, 'PPL', 'P'),
(196022, 'Bitterroot Court', 46.5177803039551, 0.811888427023385, -114.050559997559, -1.99055778570073, 218, 31, 'PPL', 'P'),
(196023, 'Bitterroot Gateway Trailer Court', 46.7555618286133, 0.816038497529082, -114.080558776855, -1.99108136317104, 218, 31, 'PPL', 'P'),
(196024, 'Bitterroot Pines', 46.6416702270508, 0.814050714091447, -114.077781677246, -1.9910328936392, 218, 31, 'PPL', 'P'),
(196025, 'Bitterroot Trailer Court', 48.538890838623, 0.847163460400084, -109.652778625488, -1.91380202097523, 218, 31, 'PPL', 'P'),
(77873, 'Bittersville', 39.9247207641602, 0.696817830273941, -76.5477828979492, -1.33601084667102, 218, 45, 'PPL', 'P'),
(180114, 'Bitterwater', 36.3802795410156, 0.634955660786654, -121.001670837402, -2.11187755652708, 218, 6, 'PPL', 'P'),
(44849, 'Bittinger', 39.6022186279297, 0.691189106152004, -79.2236099243164, -1.38271283849498, 218, 25, 'PPL', 'P'),
(77874, 'Bittinger', 39.8377799987793, 0.695300427663841, -77.0147171020508, -1.34416038592277, 218, 45, 'PPL', 'P'),
(44850, 'Bittle', 39.5105590820313, 0.689589345285194, -77.5416717529297, -1.35335747958931, 218, 25, 'PPL', 'P'),
(159251, 'Bittners Corner', 40.6666717529297, 0.709767317916397, -75.6416702270508, -1.3201961971698, 218, 45, 'PPL', 'P'),
(77875, 'Bittners Mill', 39.8497200012207, 0.69550882001914, -78.8177795410156, -1.37562976210175, 218, 45, 'PPL', 'P'),
(159252, 'Bitumen', 41.2997207641602, 0.720816107488863, -77.8788909912109, -1.35924306559838, 218, 45, 'PPL', 'P'),
(44851, 'Bivalve', 38.3061103820801, 0.66856774979968, -75.8894424438477, -1.32452063814787, 218, 25, 'PPL', 'P'),
(70551, 'Bivalve', 39.2341690063477, 0.684765428444679, -75.0341720581055, -1.30959335392187, 218, 37, 'PPL', 'P'),
(180115, 'Bivalve', 38.0924987792969, 0.664839524010651, -122.826110839844, -2.14372004157477, 218, 6, 'PPL', 'P'),
(39394, 'Bivens', 30.6297206878662, 0.534589474969488, -93.6061096191406, -1.63373481283674, 218, 22, 'PPL', 'P'),
(85101, 'Bivens', 35.3869400024414, 0.617618615248293, -86.9522171020508, -1.51760248033971, 218, 50, 'PPL', 'P'),
(92655, 'Bivins', 33.0194396972656, 0.576297939881005, -94.1988906860352, -1.64408079419753, 218, 51, 'PPL', 'P'),
(134290, 'Biwabik', 47.5330581665039, 0.829608368547472, -92.3399963378906, -1.6116369673757, 218, 28, 'PPL', 'P'),
(732, 'Bixby', 35.939998626709, 0.627271309198312, -80.4552764892578, -1.40420947533993, 218, 33, 'PPL', 'P'),
(26535, 'Bixby', 38.4930610656738, 0.671830654767246, -90.2236099243164, -1.57469905621435, 218, 18, 'PPL', 'P'),
(53498, 'Bixby', 37.6602783203125, 0.657295853906893, -91.1149978637695, -1.59025671067038, 218, 29, 'PPL', 'P'),
(75137, 'Bixby', 35.9419403076172, 0.627305197923184, -95.883056640625, -1.67347503525512, 218, 42, 'PPL', 'P'),
(92656, 'Bixby', 26.1513900756836, 0.456427860794048, -97.8533325195313, -1.70786283651466, 218, 51, 'PPL', 'P'),
(134293, 'Bixby', 43.9444389343262, 0.76697514734558, -93.0969390869141, -1.62484811059525, 218, 28, 'PPL', 'P'),
(141305, 'Bixby', 40.6549987792969, 0.709563586093006, -97.7855606079102, -1.7066799935165, 218, 35, 'PPL', 'P'),
(201911, 'Bixby', 45.1483306884766, 0.787987022293114, -102.561393737793, -1.79003400615878, 218, 49, 'PPL', 'P'),
(159253, 'Bixby Corner', 41.9419403076172, 0.732024953042843, -76.3616714477539, -1.33276258908945, 218, 45, 'PPL', 'P'),
(180116, 'Bixby Knolls', 33.8355598449707, 0.590541923550321, -118.175827026367, -2.06255727787741, 218, 6, 'PPL', 'P'),
(44852, 'Bixler', 39.6311111450195, 0.691693375704411, -76.9775009155273, -1.3435108409329, 218, 25, 'PPL', 'P'),
(159254, 'Bixler', 40.3702812194824, 0.704594327236, -77.4027786254883, -1.35093333720706, 218, 45, 'PPL', 'P'),
(180117, 'Bixler', 37.9402809143066, 0.662182821086216, -121.621109008789, -2.12268879213031, 218, 6, 'PPL', 'P'),
(154331, 'Bixler (historical)', 40.6666717529297, 0.709767317916397, -81.4913864135742, -1.42229300493184, 218, 41, 'PPL', 'P'),
(44853, 'Bixler Valley Estates', 39.6813888549805, 0.692570887283592, -76.9702835083008, -1.34338487341334, 218, 25, 'PPL', 'P'),
(92395, 'BJB Colonia', 26.3780002593994, 0.460382954618438, -98.1449966430664, -1.71295333578029, 218, 51, 'PPL', 'P'),
(211702, 'Bjerrmark', 64.8249969482422, 1.1314096343421, -147.716674804688, -2.57814233543955, 218, 1, 'PPL', 'P'),
(139684, 'Blabon', 47.401668548584, 0.827315187111832, -97.7886123657227, -1.7067332567383, 218, 34, 'PPL', 'P'),
(154332, 'Blachleyville', 40.7644386291504, 0.711473671805838, -82.0822219848633, -1.43260503098874, 218, 41, 'PPL', 'P'),
(200417, 'Blachly', 44.1949996948242, 0.771348257592572, -123.533889770508, -2.1560731142911, 218, 43, 'PPL', 'P'),
(821, 'Black', 31.0091705322266, 0.541212124099756, -85.7444381713867, -1.4965227613634, 218, 2, 'PPL', 'P'),
(26536, 'Black', 38.4677810668945, 0.671389435553647, -88.102783203125, -1.53768364706529, 218, 18, 'PPL', 'P'),
(53499, 'Black', 37.5313911437988, 0.65504634831313, -90.9330596923828, -1.58708129054462, 218, 29, 'PPL', 'P'),
(79812, 'Black', 34.336109161377, 0.599278157190217, -82.2900009155273, -1.4362314574451, 218, 48, 'PPL', 'P'),
(108240, 'Black', 37.4938888549805, 0.654391809896216, -81.2638931274414, -1.41832249806264, 218, 58, 'PPL', 'P'),
(154333, 'Black', 40.0466690063477, 0.698946228617133, -81.5922164916992, -1.42405282178017, 218, 41, 'PPL', 'P'),
(159255, 'Black', 41.8194389343262, 0.7298869007407, -76.4388885498047, -1.33411028175909, 218, 45, 'PPL', 'P'),
(191140, 'Black', 34.6824989318848, 0.605323799180806, -102.60888671875, -1.79086291504807, 218, 51, 'PPL', 'P'),
(211703, 'Black', 62.336109161377, 1.08797034774863, -165.335006713867, -2.88564023596391, 218, 1, 'PPL', 'P'),
(62974, 'Black Ankle', 35.5019416809082, 0.619625773182858, -79.807502746582, -1.39290369072227, 218, 33, 'PPL', 'P'),
(92657, 'Black Ankle', 31.523609161377, 0.550190771977876, -94.0044403076172, -1.64068699486239, 218, 51, 'PPL', 'P'),
(159256, 'Black Ash', 41.5911102294922, 0.725901813064533, -79.9005584716797, -1.39452781951306, 218, 45, 'PPL', 'P'),
(77876, 'Black Baron', 39.735279083252, 0.693511449201581, -76.1919403076172, -1.3298002218509, 218, 45, 'PPL', 'P'),
(92658, 'Black Bass', 26.8775005340576, 0.46910087902584, -99.2547225952148, -1.73232170744011, 218, 51, 'PPL', 'P'),
(58685, 'Black Bayou', 33.8186111450195, 0.59024611293224, -90.2786102294922, -1.57565899262927, 218, 30, 'PPL', 'P'),
(39395, 'Black Bayou (historical)', 32.8411102294922, 0.573185503515029, -93.9272232055664, -1.63933930219276, 218, 22, 'PPL', 'P'),
(58686, 'Black Bayou Junction', 33.7988891601563, 0.589901899361348, -90.269172668457, -1.57549427611585, 218, 30, 'PPL', 'P'),
(75136, 'Black Bear', 36.3405609130859, 0.634262439954907, -97.2194366455078, -1.69679926639814, 218, 42, 'PPL', 'P'),
(194598, 'Black Bear', 47.5161094665527, 0.829312557929392, -115.851387023926, -2.02198814656974, 218, 17, 'PPL', 'P'),
(177672, 'Black Bear Spring', 31.3861103057861, 0.547790964230092, -110.287498474121, -1.92487997216164, 218, 5, 'PPL', 'P'),
(108241, 'Black Betsey', 38.4997215270996, 0.671946901748827, -81.835563659668, -1.42830003108663, 218, 58, 'PPL', 'P'),
(829, 'Black Bottom', 33.9480590820313, 0.592505405643009, -86.8600006103516, -1.51599299893492, 218, 2, 'PPL', 'P'),
(34830, 'Black Bottom', 36.9088897705078, 0.644181649751016, -83.0802764892578, -1.45002436820478, 218, 21, 'PPL', 'P'),
(108242, 'Black Bottom', 37.8461112976074, 0.660539251219473, -82.0038909912109, -1.43123789724315, 218, 58, 'PPL', 'P'),
(99943, 'Black Branch', 36.8252792358398, 0.642722370631707, -78.4972229003906, -1.37003499328371, 218, 53, 'PPL', 'P'),
(147224, 'Black Brook', 44.4583282470703, 0.775944207843776, -73.7427825927734, -1.28705435582626, 218, 40, 'PPL', 'P'),
(193384, 'Black Butte', 41.3916702270508, 0.722420928361745, -122.360000610352, -2.13558488339291, 218, 6, 'PPL', 'P'),
(200418, 'Black Butte', 43.5694389343262, 0.760430162650601, -123.076393127441, -2.14808829155277, 218, 43, 'PPL', 'P'),
(200419, 'Black Butte Ranch', 44.377498626709, 0.774533464835334, -121.652496337891, -2.12323660436654, 218, 43, 'PPL', 'P'),
(194599, 'Black Canyon', 43.9266700744629, 0.76666502223664, -116.441390991211, -2.03228565839869, 218, 17, 'PPL', 'P'),
(177684, 'Black Canyon City', 34.0708312988281, 0.594648185056087, -112.150001525879, -1.95738678274325, 218, 5, 'PPL', 'P'),
(7499, 'Black Cat', 35.4650001525879, 0.61898102188295, -90.0244369506836, -1.57122283204347, 218, 4, 'PPL', 'P'),
(840, 'Black Center', 34.4516716003418, 0.601295102241788, -86.4027786254883, -1.50801296988655, 218, 2, 'PPL', 'P'),
(85103, 'Black Center', 36.0708312988281, 0.629554770095973, -88.0872192382813, -1.5374120046341, 218, 50, 'PPL', 'P'),
(126888, 'Black Corner', 44.3427810668945, 0.773927529108314, -68.6744384765625, -1.19859506337429, 218, 26, 'PPL', 'P'),
(114616, 'Black Corners', 41.6883316040039, 0.727598646153077, -94.023063659668, -1.64101203367344, 218, 16, 'PPL', 'P'),
(147226, 'Black Corners', 42.3941688537598, 0.739917830144538, -79.1983337402344, -1.38227168586041, 218, 40, 'PPL', 'P'),
(849, 'Black Creek', 33.5569381713867, 0.585679057978863, -87.1213912963867, -1.52055512704028, 218, 2, 'PPL', 'P'),
(15241, 'Black Creek', 30.5080604553223, 0.532466103342854, -84.0883331298828, -1.46761827563028, 218, 12, 'PPL', 'P'),
(62975, 'Black Creek', 35.6349983215332, 0.621948049653407, -77.9333267211914, -1.36019314831727, 218, 33, 'PPL', 'P'),
(79813, 'Black Creek', 33.2847213745117, 0.580927978594162, -80.2577819824219, -1.40076254594104, 218, 48, 'PPL', 'P'),
(85104, 'Black Creek', 36.3808288574219, 0.634965248166578, -84.605827331543, -1.47665025330923, 218, 50, 'PPL', 'P'),
(99944, 'Black Creek', 36.7713890075684, 0.641781808713718, -76.9252777099609, -1.34259937404982, 218, 53, 'PPL', 'P'),
(147227, 'Black Creek', 42.2755584716797, 0.737847688450193, -78.2266693115234, -1.36531294235489, 218, 40, 'PPL', 'P'),
(173196, 'Black Creek', 44.4775009155273, 0.776278834034745, -88.4505615234375, -1.5437535238218, 218, 57, 'PPL', 'P'),
(15244, 'Black Creek (historical)', 30.0666694641113, 0.524762377257582, -81.8166732788086, -1.42797033174367, 218, 12, 'PPL', 'P'),
(39396, 'Black Creek (historical)', 31.6897201538086, 0.553089955719564, -92.5694427490234, -1.61564156270685, 218, 22, 'PPL', 'P'),
(853, 'Black Creek Falls (historical)', 34.038330078125, 0.5940809317439, -86.0208282470703, -1.50134667820392, 218, 2, 'PPL', 'P'),
(159257, 'Black Creek Junction', 40.9316711425781, 0.714392429781538, -75.8227767944336, -1.32335710306762, 218, 45, 'PPL', 'P'),
(855, 'Black Diamond', 33.3447189331055, 0.581975133534781, -87.086669921875, -1.51994912473423, 218, 2, 'PPL', 'P'),
(7500, 'Black Diamond', 33.1358299255371, 0.57832933258149, -93.9097213745117, -1.63903383761572, 218, 4, 'PPL', 'P'),
(15242, 'Black Diamond', 28.9122200012207, 0.50461343308226, -82.4861068725586, -1.43965415207807, 218, 12, 'PPL', 'P'),
(159259, 'Black Diamond', 40.1925010681152, 0.701491478249949, -79.9024963378906, -1.3945616416589, 218, 45, 'PPL', 'P'),
(177690, 'Black Diamond', 31.8436107635498, 0.55577585354745, -109.906112670898, -1.91822353417504, 218, 5, 'PPL', 'P'),
(206847, 'Black Diamond', 47.3088912963867, 0.825695918590037, -122.001937866211, -2.12933550957893, 218, 56, 'PPL', 'P'),
(196026, 'Black Eagle', 47.5247192382813, 0.829462826793899, -111.277496337891, -1.94215869447212, 218, 31, 'PPL', 'P'),
(186420, 'Black Eagle Mill', 39.726390838623, 0.693356320068083, -105.546943664551, -1.84214168236338, 218, 7, 'PPL', 'P'),
(173199, 'Black Earth', 43.1372184753418, 0.752886492546843, -89.7466735839844, -1.56637494675315, 218, 57, 'PPL', 'P'),
(201912, 'Black Eyes', 43.2616691589355, 0.755058566731911, -101.696670532227, -1.77494173910325, 218, 49, 'PPL', 'P'),
(177695, 'Black Falls Crossing', 35.5702781677246, 0.62081846987705, -111.275001525879, -1.9421151517883, 218, 5, 'PPL', 'P'),
(92659, 'Black Flat', 33.6966705322266, 0.588117847747104, -98.8394393920898, -1.72507364821735, 218, 51, 'PPL', 'P'),
(19302, 'Black Forest', 33.7938919067383, 0.589814680835647, -84.8052825927734, -1.48013140432813, 218, 13, 'PPL', 'P'),
(186419, 'Black Forest', 39.0130615234375, 0.680906374867099, -104.70027923584, -1.82736460042286, 218, 7, 'PPL', 'P'),
(193385, 'Black Forest', 40.2591705322266, 0.702655079909231, -121.376388549805, -2.11841761437404, 218, 6, 'PPL', 'P'),
(199838, 'Black Forest (historical)', 40.5683288574219, 0.708050910593841, -114.809173583984, -2.00379809053423, 218, 39, 'PPL', 'P'),
(7502, 'Black Fork', 34.7669410705566, 0.606797592528056, -94.4308319091797, -1.64812893221251, 218, 4, 'PPL', 'P'),
(85105, 'Black Fox', 35.1124992370605, 0.612828720290704, -84.9274978637695, -1.48226446320323, 218, 50, 'PPL', 'P'),
(79814, 'Black Gate', 34.250560760498, 0.597785055925064, -81.9861068725586, -1.4309275058181, 218, 48, 'PPL', 'P'),
(34831, 'Black Gnat', 37.3041687011719, 0.651080568554866, -85.436393737793, -1.49114637175475, 218, 21, 'PPL', 'P'),
(34833, 'Black Gold', 37.2594413757324, 0.650299929460336, -86.3300018310547, -1.50674277520464, 218, 21, 'PPL', 'P'),
(177507, 'Black Hall', 41.2986106872559, 0.720796732991933, -72.3188934326172, -1.26220280179807, 218, 8, 'PPL', 'P'),
(134294, 'Black Hammer', 43.6163902282715, 0.761249617318019, -91.6608276367188, -1.59978323736376, 218, 28, 'PPL', 'P'),
(15243, 'Black Hammock', 30.5222206115723, 0.532713244692013, -81.480827331543, -1.42210871418441, 218, 12, 'PPL', 'P'),
(34832, 'Black Hawk', 36.9599990844727, 0.645073675558138, -87.8772201538086, -1.53374682918388, 218, 21, 'PPL', 'P'),
(39397, 'Black Hawk', 31.1555595397949, 0.543767094270551, -91.6358337402344, -1.5993470115772, 218, 22, 'PPL', 'P'),
(58687, 'Black Hawk', 33.3261108398438, 0.581650361039846, -90.0116729736328, -1.57100005861829, 218, 30, 'PPL', 'P'),
(114617, 'Black Hawk', 41.5208282470703, 0.724675161066443, -90.6374969482422, -1.58192274751314, 218, 16, 'PPL', 'P'),
(173202, 'Black Hawk', 43.2691688537598, 0.755189461099489, -89.9272232055664, -1.56952613211298, 218, 57, 'PPL', 'P'),
(186421, 'Black Hawk', 39.7969398498535, 0.694587632598082, -105.49333190918, -1.84120598071438, 218, 7, 'PPL', 'P'),
(188148, 'Black Hawk (historical)', 32.7052803039551, 0.570814824091668, -108.522216796875, -1.89406999466856, 218, 38, 'PPL', 'P'),
(44855, 'Black Hill', 39.1866683959961, 0.683936386397337, -77.2972183227539, -1.34909096236494, 218, 25, 'PPL', 'P'),
(92660, 'Black Hill', 28.9944400787354, 0.506048444146136, -98.3244400024414, -1.71608521322222, 218, 51, 'PPL', 'P'),
(13388, 'Black Hog Landing', 38.7738914489746, 0.676732069595482, -75.1908264160156, -1.312327488255, 218, 10, 'PPL', 'P'),
(194110, 'Black Hollow Junction', 40.5961112976074, 0.708535805649317, -105.02889251709, -1.83309998414645, 218, 7, 'PPL', 'P'),
(144844, 'Black Horse', 40.4180603027344, 0.705428229552331, -74.5025024414063, -1.30031396857765, 218, 37, 'PPL', 'P'),
(154335, 'Black Horse', 41.1588897705078, 0.718358142960775, -81.2733306884766, -1.41848721457607, 218, 41, 'PPL', 'P'),
(159260, 'Black Horse', 40.1080589294434, 0.700017684902699, -75.311393737793, -1.31443178499033, 218, 45, 'PPL', 'P'),
(201913, 'Black Horse', 45.7158317565918, 0.79789178444031, -101.380279541016, -1.76941967458297, 218, 49, 'PPL', 'P'),
(189940, 'Black Horse (historical)', 39.146110534668, 0.683228518179594, -114.281387329102, -1.99458648263975, 218, 39, 'PPL', 'P'),
(79815, 'Black Horse Run', 34.9988899230957, 0.610845863701085, -80.8469390869141, -1.41104527722595, 218, 48, 'PPL', 'P'),
(77879, 'Black Horse Tavern', 39.8188896179199, 0.694970728320889, -77.2836074829102, -1.34885340839571, 218, 45, 'PPL', 'P'),
(7504, 'Black Jack', 36.1786117553711, 0.631435893931951, -90.7008285522461, -1.58302809252358, 218, 4, 'PPL', 'P'),
(31832, 'Black Jack', 38.7677803039551, 0.676625409993824, -95.1155624389648, -1.66007973444618, 218, 20, 'PPL', 'P'),
(34835, 'Black Jack', 36.6336097717285, 0.639377107407431, -86.5638885498047, -1.51082486852351, 218, 21, 'PPL', 'P'),
(53501, 'Black Jack', 38.7933311462402, 0.677071356318358, -90.267219543457, -1.5754601876539, 218, 29, 'PPL', 'P'),
(58688, 'Black Jack', 34.8769416809082, 0.608717465357894, -89.084716796875, -1.55482162131217, 218, 30, 'PPL', 'P'),
(62977, 'Black Jack', 35.5016708374023, 0.619621046071923, -77.2480621337891, -1.34823302501978, 218, 33, 'PPL', 'P'),
(85107, 'Black Jack', 36.6333312988281, 0.639372247138442, -86.5638885498047, -1.51082486852351, 218, 50, 'PPL', 'P'),
(92661, 'Black Jack', 30.8883304595947, 0.539103066963981, -96.5280609130859, -1.68473248349899, 218, 51, 'PPL', 'P'),
(180118, 'Black Jack Bluffs', 37.889720916748, 0.661300382659018, -120.583061218262, -2.10457144039255, 218, 6, 'PPL', 'P'),
(79816, 'Black Jack Valley (historical)', 34.6858291625977, 0.605381922671597, -81.8027801513672, -1.42772785092642, 218, 48, 'PPL', 'P'),
(129846, 'Black Lake', 45.4313888549805, 0.792927319273266, -84.2486114501953, -1.4704156600393, 218, 27, 'PPL', 'P'),
(147229, 'Black Lake', 41.6452789306641, 0.726847235251511, -74.8622207641602, -1.30659223768946, 218, 40, 'PPL', 'P'),
(188149, 'Black Lake', 36.2983283996582, 0.6335253435442, -105.258056640625, -1.83709965262959, 218, 38, 'PPL', 'P'),
(129847, 'Black Lake Bluffs', 45.4722213745117, 0.793639981180971, -84.2369384765625, -1.47021192821591, 218, 27, 'PPL', 'P'),
(188150, 'Black Lake Resorts', 36.2738914489746, 0.633098838295624, -105.243057250977, -1.83683786389443, 218, 38, 'PPL', 'P'),
(159261, 'Black Lick', 40.4791717529297, 0.706494825568908, -79.1999969482422, -1.38230071431629, 218, 45, 'PPL', 'P'),
(108245, 'Black Lick Estates', 38.4705581665039, 0.671437905085486, -81.8883285522461, -1.42922095219158, 218, 58, 'PPL', 'P'),
(180119, 'Black Meadow Landing', 34.3519401550293, 0.599554460153313, -114.196937561035, -1.99311255613445, 218, 6, 'PPL', 'P'),
(34836, 'Black Mountain', 36.8486099243164, 0.64312956796238, -83.1458282470703, -1.45116846220908, 218, 21, 'PPL', 'P'),
(62979, 'Black Mountain', 35.6177787780762, 0.621647511924392, -82.3213882446289, -1.43677926968133, 218, 33, 'PPL', 'P'),
(143525, 'Black Mountain Cabin', 44.1974983215332, 0.771391866855422, -71.1722183227539, -1.24218954568029, 218, 36, 'PPL', 'P'),
(7507, 'Black Oak', 35.9833297729492, 0.628027580368868, -94.0794372558594, -1.64199593853817, 218, 4, 'PPL', 'P'),
(44854, 'Black Oak', 39.4991683959961, 0.689390540309819, -78.9191665649414, -1.37739929948805, 218, 25, 'PPL', 'P'),
(53502, 'Black Oak', 39.5472183227539, 0.690229169737085, -93.8383331298828, -1.63778787769973, 218, 29, 'PPL', 'P'),
(85110, 'Black Oak', 36.0186080932617, 0.628643303212894, -83.9725036621094, -1.4655966700468, 218, 50, 'PPL', 'P'),
(92662, 'Black Oak', 32.9722213745117, 0.57547382468168, -95.4305572509766, -1.66557743104249, 218, 51, 'PPL', 'P'),
(122233, 'Black Oak', 41.5661087036133, 0.725465454119924, -87.3936080932617, -1.52530620642498, 218, 19, 'PPL', 'P'),
(180120, 'Black Oak Estates', 38.0366706848145, 0.663865139946819, -120.226936340332, -2.09835588872442, 218, 6, 'PPL', 'P'),
(180121, 'Black Oaks', 38.8308296203613, 0.677725828156245, -122.831390380859, -2.14381218694849, 218, 6, 'PPL', 'P'),
(194600, 'Black Pine', 42.0724983215332, 0.734303620250542, -112.979438781738, -1.9718631937967, 218, 17, 'PPL', 'P'),
(169283, 'Black Plain', 41.5844383239746, 0.725785366345869, -71.6527786254883, -1.25057690521739, 218, 47, 'PPL', 'P'),
(15245, 'Black Point', 29.4469394683838, 0.513946048358766, -81.3052825927734, -1.41904488050833, 218, 12, 'PPL', 'P'),
(122234, 'Black Point', 41.4049987792969, 0.722653555482963, -85.6836090087891, -1.49546109219484, 218, 19, 'PPL', 'P'),
(177508, 'Black Point', 41.2861099243164, 0.720578553519628, -72.2058334350586, -1.26022953258838, 218, 8, 'PPL', 'P'),
(180122, 'Black Point', 38.110279083252, 0.665149848856673, -122.504440307617, -2.13810583168077, 218, 6, 'PPL', 'P'),
(92663, 'Black Point (historical)', 28.0865497589111, 0.490202768818219, -97.2597503662109, -1.69750287355814, 218, 51, 'PPL', 'P'),
(177505, 'Black Point Beach Club', 41.2966690063477, 0.720762844267062, -72.2044372558594, -1.26020516466441, 218, 8, 'PPL', 'P'),
(99946, 'Black Point Landing', 37.9094390869141, 0.661644529650883, -75.3836135864258, -1.31569225913426, 218, 53, 'PPL', 'P'),
(860, 'Black Pond', 34.0597190856934, 0.594454240349702, -87.3516693115234, -1.52457423659937, 218, 2, 'PPL', 'P'),
(159263, 'Black Ridge', 40.454719543457, 0.706068054004222, -79.852783203125, -1.39369398377576, 218, 45, 'PPL', 'P'),
(129848, 'Black River', 44.8172187805176, 0.78220802930667, -83.3033294677734, -1.45391737708626, 218, 27, 'PPL', 'P'),
(147230, 'Black River', 44.0125007629395, 0.76816305034981, -75.7947235107422, -1.32286748090121, 218, 40, 'PPL', 'P'),
(173203, 'Black River', 46.5622215270996, 0.81266407269087, -92.147216796875, -1.60827232965449, 218, 57, 'PPL', 'P'),
(39398, 'Black River (historical)', 31.6258296966553, 0.551974856881634, -91.8063888549805, -1.60232375988564, 218, 22, 'PPL', 'P'),
(177709, 'Black River Crossing', 33.7127799987793, 0.588399010979189, -110.211112976074, -1.92354679371994, 218, 5, 'PPL', 'P'),
(173204, 'Black River Falls', 44.2947196960449, 0.773088699943966, -90.8513870239258, -1.58565583357116, 218, 57, 'PPL', 'P'),
(188152, 'Black River Village', 32.2016716003418, 0.562025194071916, -104.252502441406, -1.81954942104597, 218, 38, 'PPL', 'P'),
(7513, 'Black Rock', 36.1083297729492, 0.63020924193386, -91.0972213745117, -1.58994645240338, 218, 4, 'PPL', 'P'),
(34838, 'Black Rock', 37.4605598449707, 0.653810108935115, -86.3550033569336, -1.50717913414925, 218, 21, 'PPL', 'P'),
(122235, 'Black Rock', 40.3677787780762, 0.704550651394123, -87.0969390869141, -1.52012835547559, 218, 19, 'PPL', 'P'),
(124254, 'Black Rock', 42.2436103820801, 0.737290089096957, -70.8291702270508, -1.23620222691758, 218, 23, 'PPL', 'P'),
(147231, 'Black Rock', 42.7036094665527, 0.745318587677165, -76.6600036621094, -1.33796946849472, 218, 40, 'PPL', 'P'),
(177509, 'Black Rock', 41.1586112976074, 0.718353282691785, -73.225830078125, -1.27803183236918, 218, 8, 'PPL', 'P'),
(188153, 'Black Rock', 35.0883293151855, 0.612406875574035, -108.790557861328, -1.89875342976158, 218, 38, 'PPL', 'P'),
(200420, 'Black Rock', 44.8711090087891, 0.783148591224658, -123.495002746582, -2.1553944076873, 218, 43, 'PPL', 'P'),
(99947, 'Black Rock Farm', 37.3952789306641, 0.652670742041752, -79.2083282470703, -1.38244612291181, 218, 53, 'PPL', 'P'),
(154336, 'Black Run', 40.1002807617188, 0.699881930266132, -82.1711120605469, -1.43415645548177, 218, 41, 'PPL', 'P'),
(34839, 'Black Snake', 36.7680587768555, 0.641723685222927, -83.5033264160156, -1.45740798232703, 218, 21, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(19303, 'Black Spring', 33.0916709899902, 0.577558613762021, -83.147216796875, -1.451192696975, 218, 13, 'PPL', 'P'),
(7515, 'Black Springs', 34.461109161377, 0.60145981875521, -93.7125015258789, -1.6355917019068, 218, 4, 'PPL', 'P'),
(79817, 'Black Tom (historical)', 33.1333312988281, 0.57828572331864, -80.1486129760742, -1.39885718733915, 218, 48, 'PPL', 'P'),
(53507, 'Black Walnut', 38.8733291625977, 0.678467585098859, -90.3711090087891, -1.57727340088208, 218, 29, 'PPL', 'P'),
(875, 'Black Warrior Town (historical)', 33.811939239502, 0.590129666213577, -87.0522232055664, -1.51934791611815, 218, 2, 'PPL', 'P'),
(62983, 'Black Water', 36.3969383239746, 0.635246411398664, -80.6241683959961, -1.40715719519249, 218, 33, 'PPL', 'P'),
(31834, 'Black Wolf', 38.7583312988281, 0.676460493743321, -98.3616714477539, -1.7167350245282, 218, 20, 'PPL', 'P'),
(108246, 'Black Wolf', 37.336109161377, 0.651638034750047, -81.4863891601563, -1.42220578640614, 218, 58, 'PPL', 'P'),
(173206, 'Black Wolf', 43.9377784729004, 0.766858900363998, -88.5236129760742, -1.54502851219367, 218, 57, 'PPL', 'P'),
(173207, 'Black Wolf Point', 43.9275016784668, 0.766679536464581, -88.4713897705078, -1.54411704531059, 218, 57, 'PPL', 'P'),
(869, 'Blackankle', 34.7449989318848, 0.606414629963302, -86.0213928222656, -1.50135653189995, 218, 2, 'PPL', 'P'),
(154337, 'Blackband', 40.4258308410645, 0.705563851030843, -81.5422210693359, -1.423180237049, 218, 41, 'PPL', 'P'),
(19304, 'Blackbanks', 31.1866703033447, 0.544310079527304, -81.3752822875977, -1.4202666056584, 218, 13, 'PPL', 'P'),
(92664, 'Blackberry', 30.3977794647217, 0.530541336954513, -95.8566665649414, -1.67301444154459, 218, 51, 'PPL', 'P'),
(99949, 'Blackberry', 37.8588905334473, 0.660762290960767, -76.2819366455078, -1.33137095426183, 218, 53, 'PPL', 'P'),
(134297, 'Blackberry', 47.1808280944824, 0.823460794066161, -93.3902816772461, -1.62996790463288, 218, 28, 'PPL', 'P'),
(118819, 'Blackberry Acres', 41.8427810668945, 0.730294297808455, -88.4861068725586, -1.54437390719773, 218, 18, 'PPL', 'P'),
(108250, 'Blackberry City', 37.6113891601563, 0.656442577093631, -82.1666717529297, -1.43407895749404, 218, 58, 'PPL', 'P'),
(154338, 'Blackberry Corner', 41.6036109924316, 0.726119992536838, -83.2808303833008, -1.45352469398353, 218, 41, 'PPL', 'P'),
(44856, 'Blackberry Hills', 39.7036094665527, 0.692958710117335, -77.3600006103516, -1.35018671999546, 218, 25, 'PPL', 'P'),
(62984, 'Blackberry Inn', 35.702220916748, 0.623121305271642, -82.4297180175781, -1.43866998089723, 218, 33, 'PPL', 'P'),
(118820, 'Blackberry Woods', 41.809440612793, 0.729712397110273, -88.4625015258789, -1.54396191617709, 218, 18, 'PPL', 'P'),
(13389, 'Blackbird', 39.3708305358887, 0.687150622095981, -75.6594390869141, -1.32050632227874, 218, 10, 'PPL', 'P'),
(194601, 'Blackbird', 45.1133308410645, 0.787376159718077, -114.218887329102, -1.99349565185725, 218, 17, 'PPL', 'P'),
(139042, 'Blackbird (historical)', 40.5038909912109, 0.7069262576655, -92.9716720581055, -1.62266178849835, 218, 29, 'PPL', 'P'),
(13390, 'Blackbird Landing', 39.3888893127441, 0.687465807210992, -75.6361083984375, -1.32009912494807, 218, 10, 'PPL', 'P'),
(147232, 'Blackbridge', 43.3705596923828, 0.756959065064819, -74.3238906860352, -1.29719660536366, 218, 40, 'PPL', 'P'),
(873, 'Blackburn', 34.7916717529297, 0.60722922436173, -87.054443359375, -1.51938666511201, 218, 2, 'PPL', 'P'),
(7516, 'Blackburn', 35.8163909912109, 0.625113948978266, -94.2194366455078, -1.64443938883831, 218, 4, 'PPL', 'P'),
(34841, 'Blackburn', 37.6955604553223, 0.657911643329946, -88.1202774047852, -1.53798897848426, 218, 21, 'PPL', 'P'),
(39399, 'Blackburn', 32.8466682434082, 0.573282509157735, -93.2044372558594, -1.62672430758321, 218, 22, 'PPL', 'P'),
(53508, 'Blackburn', 39.1063919067383, 0.682535297347846, -93.4833297729492, -1.63159190026561, 218, 29, 'PPL', 'P'),
(62985, 'Blackburn', 35.6158294677734, 0.621613490041466, -81.3311080932617, -1.41949562052282, 218, 33, 'PPL', 'P'),
(75140, 'Blackburn', 36.3730583190918, 0.634829626688066, -96.595832824707, -1.68591532649715, 218, 42, 'PPL', 'P'),
(108247, 'Blackburn', 38.9230613708496, 0.679335575877143, -80.6752777099609, -1.40804922099961, 218, 58, 'PPL', 'P'),
(159264, 'Blackburn', 40.3894386291504, 0.704928687110859, -79.7474975585938, -1.3918564026236, 218, 45, 'PPL', 'P'),
(199840, 'Blackburn', 40.228328704834, 0.702116788473899, -116.166938781738, -2.02749556370402, 218, 39, 'PPL', 'P'),
(203053, 'Blackburn', 40.6647186279297, 0.709733229454444, -111.811111450195, -1.95147203512024, 218, 52, 'PPL', 'P'),
(71832, 'Blackburn (historical)', 39.5424995422363, 0.690146811480374, -82.6383285522461, -1.44231092158153, 218, 41, 'PPL', 'P'),
(159265, 'Blackburn (historical)', 40.2444381713867, 0.702397951705984, -79.7724990844727, -1.39229276156821, 218, 45, 'PPL', 'P'),
(34840, 'Blackburn Bottom', 37.559440612793, 0.655535903900514, -82.4188919067383, -1.43848102961789, 218, 21, 'PPL', 'P'),
(85111, 'Blackburn Hills Estates', 36.2277793884277, 0.632294031014202, -85.5783309936523, -1.49362364420074, 218, 50, 'PPL', 'P'),
(124255, 'Blackburn Village', 42.6269416809082, 0.743980482387454, -71.8811111450195, -1.25456205947258, 218, 23, 'PPL', 'P'),
(19305, 'Blackburns Store (historical)', 31.6191692352295, 0.551858609900052, -84.8644409179688, -1.48116391188275, 218, 13, 'PPL', 'P'),
(194602, 'Blackcloud', 47.5047187805176, 0.829113752954017, -115.903610229492, -2.02289961345282, 218, 17, 'PPL', 'P'),
(188154, 'Blackdom (historical)', 33.1636085510254, 0.578814161057939, -104.508331298828, -1.82401447692959, 218, 38, 'PPL', 'P'),
(134299, 'Blackduck', 47.7330589294434, 0.833099040367266, -94.5483322143555, -1.65017969940992, 218, 28, 'PPL', 'P'),
(108248, 'Blackeagle', 37.5727806091309, 0.655768730758814, -81.3627777099609, -1.42004835960707, 218, 58, 'PPL', 'P'),
(147233, 'Blackesley Corner', 42.2658309936523, 0.7376779119307, -75.6011123657227, -1.31948832895206, 218, 40, 'PPL', 'P'),
(34842, 'Blackey', 37.1399993896484, 0.64821527353805, -82.9791717529297, -1.4482597576665, 218, 21, 'PPL', 'P'),
(99950, 'Blackey', 37.3841705322266, 0.652476863914394, -81.9974975585938, -1.43112631079347, 218, 53, 'PPL', 'P'),
(77882, 'Blackfield', 39.9066696166992, 0.696502778316985, -79.0883331298828, -1.38035181303057, 218, 45, 'PPL', 'P'),
(7517, 'Blackfish', 35.0661087036133, 0.612019052740292, -90.5819396972656, -1.58095309056024, 218, 4, 'PPL', 'P'),
(7518, 'Blackfoot', 34.5805587768555, 0.603544607835551, -90.7944412231445, -1.58466194185234, 218, 4, 'PPL', 'P'),
(92665, 'Blackfoot', 31.9461097717285, 0.557564798720197, -95.8349990844727, -1.6726362726698, 218, 51, 'PPL', 'P'),
(194603, 'Blackfoot', 43.190559387207, 0.753817467084907, -112.344169616699, -1.96077565523038, 218, 17, 'PPL', 'P'),
(196027, 'Blackfoot', 48.5752792358398, 0.84779855774104, -112.875831604004, -1.97005490741654, 218, 31, 'PPL', 'P'),
(196028, 'Blackfoot (historical)', 47.4500007629395, 0.828158743387115, -107.427780151367, -1.87496847174997, 218, 31, 'PPL', 'P'),
(196029, 'Blackfoot City (historical)', 46.6816711425781, 0.814748861771212, -112.542221069336, -1.96423230516725, 218, 31, 'PPL', 'P'),
(34843, 'Blackford', 37.4483299255371, 0.653596656573746, -87.9347229003906, -1.53475044144067, 218, 21, 'PPL', 'P'),
(99952, 'Blackford', 36.9958305358887, 0.645699052361115, -81.9430618286133, -1.43017622807459, 218, 53, 'PPL', 'P'),
(71828, 'Blackfork', 38.8375015258789, 0.677842274874909, -82.5999984741211, -1.44164193551571, 218, 41, 'PPL', 'P'),
(71829, 'Blackfork Junction', 38.860279083252, 0.67823981824663, -82.6005630493164, -1.44165178921174, 218, 41, 'PPL', 'P'),
(75143, 'Blackgum', 35.6097183227539, 0.621506830439808, -94.9894409179688, -1.65787849864718, 218, 42, 'PPL', 'P'),
(29222, 'Blackhawk', 39.3088912963867, 0.68606957843049, -87.3002777099609, -1.52367728394423, 218, 19, 'PPL', 'P'),
(71830, 'Blackhawk', 39.3216705322266, 0.686292618171785, -84.0716705322266, -1.46732745843925, 218, 41, 'PPL', 'P'),
(108249, 'Blackhawk', 38.333610534668, 0.66904771800714, -81.5869369506836, -1.42396067640645, 218, 58, 'PPL', 'P'),
(114623, 'Blackhawk', 40.832218170166, 0.712656647962051, -92.5905609130859, -1.61601014420172, 218, 16, 'PPL', 'P'),
(118825, 'Blackhawk', 42.1875, 0.736310778185108, -90.2238922119141, -1.57470398306237, 218, 18, 'PPL', 'P'),
(159266, 'Blackhawk', 40.7130584716797, 0.710576918887781, -80.4563903808594, -1.40422891641589, 218, 45, 'PPL', 'P'),
(180123, 'Blackhawk', 37.8208312988281, 0.660098032005874, -121.906669616699, -2.12767276495234, 218, 6, 'PPL', 'P'),
(201915, 'Blackhawk', 44.1511116027832, 0.770582265884038, -103.307502746582, -1.80305606494094, 218, 49, 'PPL', 'P'),
(122237, 'Blackhawk Beach', 41.5177803039551, 0.724621964423668, -87.0411071777344, -1.51915390483273, 218, 19, 'PPL', 'P'),
(19306, 'Blackhawk Hills', 33.8044395446777, 0.589998771845999, -84.5352783203125, -1.47541894077923, 218, 13, 'PPL', 'P'),
(173209, 'Blackhawk Island', 42.8983306884766, 0.748717114123242, -88.892219543457, -1.55146191043898, 218, 57, 'PPL', 'P'),
(134301, 'Blackhoof', 46.5327796936035, 0.81215021575854, -92.4619369506836, -1.61376523256083, 218, 28, 'PPL', 'P'),
(44857, 'Blackhorse', 39.6238899230957, 0.691567341605823, -76.5513916015625, -1.3360738304308, 218, 25, 'PPL', 'P'),
(177188, 'Blackhorse (historical)', 40.4844398498535, 0.706586771205543, -80.595832824707, -1.40666264617806, 218, 58, 'PPL', 'P'),
(124256, 'Blackinton', 42.7041702270508, 0.745328374794171, -73.1666717529297, -1.27699932481455, 218, 23, 'PPL', 'P'),
(126889, 'Blackinton Corners', 44.1233291625977, 0.770097370828562, -69.1177825927734, -1.20633287792152, 218, 26, 'PPL', 'P'),
(13391, 'Blackiston', 39.2705612182617, 0.685400592364663, -75.7008285522461, -1.32122870472443, 218, 10, 'PPL', 'P'),
(29223, 'Blackiston Mill', 38.3355598449707, 0.669081739890066, -85.7980575561523, -1.49745859617046, 218, 19, 'PPL', 'P'),
(29224, 'Blackiston Village', 38.3319396972656, 0.669018556393204, -85.7930603027344, -1.49737137764476, 218, 19, 'PPL', 'P'),
(19307, 'Blackjack', 33.2694396972656, 0.580661263010991, -84.6500015258789, -1.47742123844481, 218, 13, 'PPL', 'P'),
(53509, 'Blackjack', 37.8722190856934, 0.660994918081986, -93.7916717529297, -1.63697348303838, 218, 29, 'PPL', 'P'),
(71831, 'Blackjack', 39.4677810668945, 0.68884272807359, -82.491943359375, -1.43975601798977, 218, 41, 'PPL', 'P'),
(75145, 'Blackjack', 35.4305610656738, 0.618379946424919, -94.6374969482422, -1.65173591759291, 218, 42, 'PPL', 'P'),
(92668, 'Blackjack', 32.0508308410645, 0.559392526176318, -95.1041717529297, -1.65988092947081, 218, 51, 'PPL', 'P'),
(7519, 'Blackjack Corner', 36.457218170166, 0.636298493187299, -94.1394424438477, -1.64304322663684, 218, 4, 'PPL', 'P'),
(203056, 'Blackjack Lodge Condominiums', 40.5833282470703, 0.708312699328996, -111.648612976074, -1.94863590171736, 218, 52, 'PPL', 'P'),
(203055, 'Blackjack Village Condominiums', 40.5833282470703, 0.708312699328996, -111.648612976074, -1.94863590171736, 218, 52, 'PPL', 'P'),
(34844, 'Blackjoe', 36.8616714477539, 0.643357534551691, -83.2819366455078, -1.45354400190143, 218, 21, 'PPL', 'P'),
(26537, 'Blackland', 39.7613906860352, 0.69396718264312, -89.103889465332, -1.55515624750313, 218, 18, 'PPL', 'P'),
(58690, 'Blackland', 34.6399993896484, 0.604582042238191, -88.6658325195313, -1.54751071148768, 218, 30, 'PPL', 'P'),
(75146, 'Blackland', 36.8291702270508, 0.642790281239504, -96.491943359375, -1.68410211326897, 218, 42, 'PPL', 'P'),
(92670, 'Blackland', 32.8994407653809, 0.574203563420739, -96.3494415283203, -1.68161498712695, 218, 51, 'PPL', 'P'),
(196030, 'Blackleaf', 48.0125007629395, 0.837976220429583, -112.605278015137, -1.96533285648772, 218, 31, 'PPL', 'P'),
(71833, 'Blacklick', 39.9955596923828, 0.698054202810011, -82.811393737793, -1.4453314788899, 218, 41, 'PPL', 'P'),
(99953, 'Blacklick', 36.9430618286133, 0.644778064677139, -81.2569427490234, -1.41820119107499, 218, 53, 'PPL', 'P'),
(71835, 'Blacklick Estates', 39.9049987792969, 0.696473616703049, -82.8644409179688, -1.44625732684287, 218, 41, 'PPL', 'P'),
(159267, 'Blacklog', 40.4238891601563, 0.705529962305972, -77.6811065673828, -1.35579107619342, 218, 45, 'PPL', 'P'),
(883, 'Blackman', 32.8680610656738, 0.573655884342565, -85.5266723632813, -1.4927220310137, 218, 2, 'PPL', 'P'),
(15248, 'Blackman', 30.9244403839111, 0.539733304035949, -86.6366729736328, -1.51209519636348, 218, 12, 'PPL', 'P'),
(85112, 'Blackman', 35.8752784729004, 0.626141729421955, -86.4983291625977, -1.50968064136116, 218, 50, 'PPL', 'P'),
(147234, 'Blackmans Corners', 43.1588897705078, 0.753264728000661, -75.5477828979492, -1.31855755415108, 218, 40, 'PPL', 'P'),
(62987, 'Blackmans Mills', 35.2477798461914, 0.615189812334141, -78.4080581665039, -1.36847877510072, 218, 33, 'PPL', 'P'),
(139686, 'Blackmer', 45.978889465332, 0.802483007580579, -96.6002807617188, -1.68599295764293, 218, 34, 'PPL', 'P'),
(62988, 'Blackmer (historical)', 35.6763916015625, 0.622670498678119, -80.6341705322266, -1.40733176540194, 218, 33, 'PPL', 'P'),
(62989, 'Blackmon Crossroads', 35.3683280944824, 0.61729377617433, -78.4286117553711, -1.36883750289956, 218, 33, 'PPL', 'P'),
(34845, 'Blackmont', 36.7916717529297, 0.642135809401617, -83.5250015258789, -1.45778628435987, 218, 21, 'PPL', 'P'),
(62990, 'Blacknel', 35.6144409179688, 0.621589255275546, -79.1113891601563, -1.38075421667128, 218, 33, 'PPL', 'P'),
(201916, 'Blackpipe', 43.3438911437988, 0.756493611085301, -101.274169921875, -1.76756771236093, 218, 49, 'PPL', 'P'),
(99954, 'Blackridge', 36.6450004577637, 0.639575912382805, -78.0572204589844, -1.36235550196436, 218, 53, 'PPL', 'P'),
(62991, 'Blackrock', 36.0533294677734, 0.629249305518941, -76.7405624389648, -1.33937548439223, 218, 33, 'PPL', 'P'),
(77883, 'Blackrock', 39.7216682434082, 0.693273895232346, -76.8613891601563, -1.34148430850141, 218, 45, 'PPL', 'P'),
(180124, 'Blackrock', 36.9291687011719, 0.644535583859887, -118.232498168945, -2.06354637590626, 218, 6, 'PPL', 'P'),
(194604, 'Blackrock', 42.7969398498535, 0.746947510157912, -112.326110839844, -1.96046047011537, 218, 17, 'PPL', 'P'),
(206848, 'Blackrock (historical)', 46.5116691589355, 0.811781767421727, -119.996673583984, -2.09433704548143, 218, 56, 'PPL', 'P'),
(44858, 'Blackrock Estates', 39.1408309936523, 0.683136372805877, -77.2980575561523, -1.34910560975094, 218, 25, 'PPL', 'P'),
(44859, 'Blackrock Hills', 39.1452789306641, 0.683214003951653, -77.3036117553711, -1.34920254881462, 218, 25, 'PPL', 'P'),
(44860, 'Blackrock Mill', 39.1266708374023, 0.682889231456718, -77.3144378662109, -1.34939150009396, 218, 25, 'PPL', 'P'),
(79818, 'Blacks', 33.916389465332, 0.591952666558763, -81.6769409179688, -1.42553154197543, 218, 48, 'PPL', 'P'),
(118826, 'Blacks', 40.0702781677246, 0.699358286216795, -90.9980621337891, -1.588215797169, 218, 18, 'PPL', 'P'),
(159269, 'Blacks', 41.2080612182617, 0.719216346622053, -79.758056640625, -1.39204069337103, 218, 45, 'PPL', 'P'),
(194606, 'Blacks (historical)', 43.4638900756836, 0.758587987545566, -116.008331298828, -2.02472734090894, 218, 17, 'PPL', 'P'),
(44862, 'Blacks Corner', 39.7058296203613, 0.692997459111195, -77.102783203125, -1.34569742934591, 218, 25, 'PPL', 'P'),
(159270, 'Blacks Corner', 41.6872215270996, 0.727579271656147, -80.1894378662109, -1.3995697160888, 218, 45, 'PPL', 'P'),
(206849, 'Blacks Corner', 46.2727813720703, 0.807612388998126, -119.925003051758, -2.09308615871742, 218, 56, 'PPL', 'P'),
(194605, 'Blacks Creek', 43.4777793884277, 0.758830401783791, -116.137222290039, -2.02697691308173, 218, 17, 'PPL', 'P'),
(34846, 'Blacks Crossroads', 38.2508316040039, 0.667602953115772, -84.1383285522461, -1.46849086036145, 218, 21, 'PPL', 'P'),
(15246, 'Blacks Ford', 30.0469398498535, 0.524418030528634, -81.5605621337891, -1.42350034901203, 218, 12, 'PPL', 'P'),
(44861, 'Blacks Glen', 39.5180587768555, 0.689720239652771, -77.5947189331055, -1.35428332754227, 218, 25, 'PPL', 'P'),
(15247, 'Blacks Still', 30.4666690826416, 0.531743687607656, -82.8022232055664, -1.44517142290839, 218, 12, 'PPL', 'P'),
(19308, 'Blacksboro (historical)', 32.9341697692871, 0.574809698884841, -84.2616729736328, -1.47064362662861, 218, 13, 'PPL', 'P'),
(79821, 'Blacksburg', 35.1211090087891, 0.612978989155211, -81.51611328125, -1.42272457018649, 218, 48, 'PPL', 'P'),
(99959, 'Blacksburg', 37.2294387817383, 0.649776285411, -80.4141693115234, -1.40349201974227, 218, 53, 'PPL', 'P'),
(19309, 'Blackshear', 31.3058300018311, 0.546389808601574, -82.2422180175781, -1.43539748854974, 218, 13, 'PPL', 'P'),
(19310, 'Blackshear Place', 34.2208290100098, 0.597266138986662, -83.8611068725586, -1.46365242929299, 218, 13, 'PPL', 'P'),
(887, 'Blacksher', 31.2105598449707, 0.54472703068547, -87.7383270263672, -1.53132268680163, 218, 2, 'PPL', 'P'),
(180125, 'Blackslough Landing', 37.9944381713867, 0.663128043536112, -121.417778015137, -2.11913999681972, 218, 6, 'PPL', 'P'),
(99957, 'Blacksmith Corner', 37.2305603027344, 0.649795859645012, -76.5677795410156, -1.33635985393188, 218, 53, 'PPL', 'P'),
(143526, 'Blacksnake Trailer Park', 42.8886108398438, 0.748547470761804, -70.9100036621094, -1.23761303650505, 218, 36, 'PPL', 'P'),
(79819, 'Blackstock', 34.5583305358887, 0.603156651843754, -81.1524963378906, -1.41637825730883, 218, 48, 'PPL', 'P'),
(99958, 'Blackstone', 37.0802803039551, 0.64717297886642, -77.9974975585938, -1.3613131407137, 218, 53, 'PPL', 'P'),
(118830, 'Blackstone', 41.0844383239746, 0.717058720085898, -88.6908264160156, -1.54794693727423, 218, 18, 'PPL', 'P'),
(124257, 'Blackstone', 42.0177803039551, 0.73334861068364, -71.5416717529297, -1.24863772446965, 218, 23, 'PPL', 'P'),
(126890, 'Blackstone', 46.9555587768555, 0.819529102769849, -68.2344436645508, -1.190915705213, 218, 26, 'PPL', 'P'),
(159271, 'Blackstone', 40.6619415283203, 0.709684759922605, -79.6522216796875, -1.39019352483896, 218, 45, 'PPL', 'P'),
(126892, 'Blackstrap', 43.7686080932617, 0.763906320242454, -70.3311080932617, -1.22750940280345, 218, 26, 'PPL', 'P'),
(19311, 'Blacksville', 33.4336090087891, 0.583526558027807, -84.1488876342773, -1.46867515110888, 218, 13, 'PPL', 'P'),
(108251, 'Blacksville', 39.7200012207031, 0.693244800197436, -80.2122192382813, -1.39996732603955, 218, 58, 'PPL', 'P'),
(194607, 'Blacktail', 48.1205596923828, 0.83986220453455, -116.485282897949, -2.03305171668626, 218, 17, 'PPL', 'P'),
(196031, 'Blacktail', 48.2769393920898, 0.842591545177718, -113.447219848633, -1.98002751359251, 218, 31, 'PPL', 'P'),
(201917, 'Blacktail', 44.3699989318848, 0.774402570467756, -103.759719848633, -1.81094874230556, 218, 49, 'PPL', 'P'),
(7521, 'Blackton', 34.6674995422363, 0.605062010445651, -91.1041717529297, -1.59006775939104, 218, 4, 'PPL', 'P'),
(71834, 'Blacktop', 39.976390838623, 0.697719643198069, -81.482780456543, -1.42214280264636, 218, 41, 'PPL', 'P'),
(159272, 'Blacktown', 41.1666717529297, 0.718493964176369, -80.1736068725586, -1.3992934131257, 218, 45, 'PPL', 'P'),
(7522, 'Blackville', 35.4833297729492, 0.619300934108896, -91.1647186279297, -1.59112450171158, 218, 4, 'PPL', 'P'),
(19312, 'Blackville', 32.4819412231445, 0.566916821783146, -82.5983276367188, -1.44161277390177, 218, 13, 'PPL', 'P'),
(79820, 'Blackville', 33.357780456543, 0.582203100124092, -81.2708282470703, -1.41844353873419, 218, 48, 'PPL', 'P'),
(44863, 'Blackwalnut Cove', 38.9375, 0.679587577495292, -76.4805603027344, -1.33483759105279, 218, 25, 'PPL', 'P'),
(13392, 'Blackwater', 38.5458297729492, 0.672751642451222, -75.1624984741211, -1.31183307239863, 218, 10, 'PPL', 'P'),
(34847, 'Blackwater', 37.0530586242676, 0.64669787092795, -83.8949966430664, -1.4642439173711, 218, 21, 'PPL', 'P'),
(44864, 'Blackwater', 38.3852806091309, 0.669949530931268, -76.1425018310547, -1.32893735765772, 218, 25, 'PPL', 'P'),
(53510, 'Blackwater', 38.980281829834, 0.680334261285923, -92.9905624389648, -1.62299148784131, 218, 29, 'PPL', 'P'),
(58692, 'Blackwater', 34.5552787780762, 0.603103388621952, -89.5966720581055, -1.56375692624354, 218, 30, 'PPL', 'P'),
(99962, 'Blackwater', 36.6058311462402, 0.638892278930982, -76.0869369506836, -1.32796756754676, 218, 53, 'PPL', 'P'),
(126891, 'Blackwater', 46.4272193908691, 0.810307840916423, -68.3083267211914, -1.19220520781281, 218, 26, 'PPL', 'P'),
(143527, 'Blackwater', 43.2455596923828, 0.754777403499826, -70.9141693115234, -1.2376857408028, 218, 36, 'PPL', 'P'),
(177726, 'Blackwater', 33.0311088562012, 0.576501605125369, -111.581939697266, -1.94747223347905, 218, 5, 'PPL', 'P'),
(53511, 'Blackwater (historical)', 38.7911109924316, 0.677032607324497, -93.7425003051758, -1.63611527937711, 218, 29, 'PPL', 'P'),
(13393, 'Blackwater Beach', 38.5800018310547, 0.673348057377345, -75.1580581665039, -1.31175557441091, 218, 10, 'PPL', 'P'),
(13394, 'Blackwater Cove', 38.5574989318848, 0.672955307695586, -75.1358337402344, -1.31136768499814, 218, 10, 'PPL', 'P'),
(13398, 'Blackwater Village', 38.5558280944824, 0.67292614608165, -75.1597213745117, -1.31178460286679, 218, 10, 'PPL', 'P'),
(7523, 'Blackwell', 35.2222213745117, 0.614743732851552, -92.8411102294922, -1.62038305471163, 218, 4, 'PPL', 'P'),
(19313, 'Blackwell', 33.3663902282715, 0.5823533689886, -83.6813888549805, -1.4605157581611, 218, 13, 'PPL', 'P'),
(53515, 'Blackwell', 38.0436096191406, 0.66398624719739, -90.623893737793, -1.58168532670196, 218, 29, 'PPL', 'P'),
(62992, 'Blackwell', 36.4425010681152, 0.636041631300161, -79.4638900756836, -1.38690651826352, 218, 33, 'PPL', 'P'),
(75147, 'Blackwell', 36.8044395446777, 0.642358649405829, -97.2825012207031, -1.69789995087667, 218, 42, 'PPL', 'P'),
(99965, 'Blackwell', 36.8286094665527, 0.642780494122498, -81.8566665649414, -1.42866834626538, 218, 53, 'PPL', 'P'),
(159276, 'Blackwell', 41.5563888549805, 0.725295810758486, -77.3794403076172, -1.35052600671833, 218, 45, 'PPL', 'P'),
(173210, 'Blackwell', 45.5141716003418, 0.794372150743661, -88.6125030517578, -1.5465799366867, 218, 57, 'PPL', 'P'),
(191142, 'Blackwell', 32.086669921875, 0.56001803613735, -100.317222595215, -1.75086583074255, 218, 51, 'PPL', 'P'),
(194608, 'Blackwell', 47.6977806091309, 0.83248331752324, -116.806938171387, -2.03866566026414, 218, 17, 'PPL', 'P'),
(19314, 'Blackwell Chase', 34.0430603027344, 0.594163489737692, -84.5180587768555, -1.47511840305022, 218, 13, 'PPL', 'P'),
(126893, 'Blackwell Corner', 44.8352813720703, 0.782523281000708, -69.8166732788086, -1.21853082150435, 218, 26, 'PPL', 'P'),
(92671, 'Blackwell Crossing', 31.8547191619873, 0.555969731674807, -99.195556640625, -1.73128906672743, 218, 51, 'PPL', 'P'),
(177415, 'Blackwell Junction', 45.5316696166992, 0.794677548741666, -88.654167175293, -1.54730711282234, 218, 57, 'PPL', 'P'),
(188155, 'Blackwell Place', 35.0994415283203, 0.61260082028042, -106.142776489258, -1.85254092694598, 218, 38, 'PPL', 'P'),
(99966, 'Blackwell Town', 38.5697212219238, 0.673168626898901, -77.6916732788086, -1.35597550009891, 218, 53, 'PPL', 'P'),
(19315, 'Blackwells', 33.9947204589844, 0.593319800304355, -84.5180587768555, -1.47511840305022, 218, 13, 'PPL', 'P'),
(99967, 'Blackwells', 37.8541717529297, 0.660679932704056, -76.3574981689453, -1.33268975163364, 218, 53, 'PPL', 'P'),
(180126, 'Blackwells Corner', 35.6150016784668, 0.621599042392552, -119.866943359375, -2.09207282592265, 218, 6, 'PPL', 'P'),
(144845, 'Blackwells Mills', 40.4755592346191, 0.7064317752301, -74.5716705322266, -1.30152117949979, 218, 37, 'PPL', 'P'),
(894, 'Blackwood', 31.3872203826904, 0.547810338727023, -85.408332824707, -1.49065661643029, 218, 2, 'PPL', 'P'),
(19316, 'Blackwood', 34.4563903808594, 0.601377460498499, -84.9027786254883, -1.48183303110664, 218, 13, 'PPL', 'P'),
(62993, 'Blackwood', 35.9922218322754, 0.628182776081392, -79.0725021362305, -1.38007551006747, 218, 33, 'PPL', 'P'),
(70552, 'Blackwood', 39.8022193908691, 0.694679777971798, -75.0644378662109, -1.31012159192409, 218, 37, 'PPL', 'P'),
(99968, 'Blackwood', 36.9249992370605, 0.644462812983101, -82.6930618286133, -1.44326619746454, 218, 53, 'PPL', 'P'),
(159273, 'Blackwood', 40.6416702270508, 0.709330958971788, -76.3274993896484, -1.33216617416333, 218, 45, 'PPL', 'P'),
(196032, 'Blackwood', 45.6419410705566, 0.796602148682439, -111.144721984863, -1.93984134484959, 218, 31, 'PPL', 'P'),
(70553, 'Blackwood Terrace', 39.8050003051758, 0.694728314082665, -75.0861129760742, -1.31049989395693, 218, 37, 'PPL', 'P'),
(39400, 'Blade', 31.6541690826416, 0.552469472475089, -92.0527801513672, -1.60662409925584, 218, 22, 'PPL', 'P'),
(19317, 'Bladen', 31.2444400787354, 0.545318352316008, -81.7022171020508, -1.42597269461001, 218, 13, 'PPL', 'P'),
(44865, 'Bladen', 38.9972190856934, 0.680629872166922, -76.6399993896484, -1.33762032807581, 218, 25, 'PPL', 'P'),
(71836, 'Bladen', 38.6599998474121, 0.674744286157847, -82.1869430541992, -1.43443275844486, 218, 41, 'PPL', 'P'),
(79822, 'Bladen', 34.3430595397949, 0.59939946417787, -80.0808334350586, -1.39767421118293, 218, 48, 'PPL', 'P'),
(141307, 'Bladen', 40.3222198486328, 0.703755498071652, -98.5944366455078, -1.72079754361306, 218, 35, 'PPL', 'P'),
(62996, 'Bladen Springs', 34.5372200012207, 0.602788203506941, -78.4752807617188, -1.36965203071896, 218, 33, 'PPL', 'P'),
(62997, 'Bladenboro', 34.5386085510254, 0.602812438272861, -78.7877807617188, -1.37510618463144, 218, 33, 'PPL', 'P'),
(44866, 'Bladensburg', 38.9391708374023, 0.679616739109228, -76.9341735839844, -1.34275463634137, 218, 25, 'PPL', 'P'),
(114624, 'Bladensburg', 41.0461082458496, 0.71638973402007, -92.2369384765625, -1.60983826837546, 218, 16, 'PPL', 'P'),
(154347, 'Bladensburg', 40.2844390869141, 0.703096099385749, -82.2841720581055, -1.43612972469146, 218, 41, 'PPL', 'P'),
(13396, 'Blades', 38.6355590820313, 0.674317714330243, -75.6102828979492, -1.31964838493357, 218, 10, 'PPL', 'P'),
(62999, 'Blades', 34.8858299255371, 0.608872594491391, -76.7724990844727, -1.33993288400838, 218, 33, 'PPL', 'P'),
(99969, 'Blades Corner', 38.1222190856934, 0.665358241211971, -77.6163864135742, -1.35466149641706, 218, 53, 'PPL', 'P'),
(34849, 'Bladeston', 38.7213897705078, 0.675815742443413, -84.0966720581055, -1.46776381738386, 218, 21, 'PPL', 'P'),
(898, 'Bladon Springs', 31.7305603027344, 0.553802750785323, -88.1975021362305, -1.53933680431195, 218, 2, 'PPL', 'P'),
(900, 'Bladon Springs Landing', 31.7627792358398, 0.554365077249494, -88.1569366455078, -1.53862880293616, 218, 2, 'PPL', 'P'),
(159274, 'Blain', 40.3383293151855, 0.704036661303737, -77.5127792358398, -1.3528532100369, 218, 45, 'PPL', 'P'),
(159275, 'Blain City', 40.7563896179199, 0.711333190058336, -78.533332824707, -1.37066523035568, 218, 45, 'PPL', 'P'),
(19326, 'Blain Woods', 33.7177810668945, 0.588486296083916, -84.788330078125, -1.47983552713102, 218, 13, 'PPL', 'P'),
(19318, 'Blaine', 34.5105590820313, 0.602322882685477, -84.5569381713867, -1.47579697649597, 218, 13, 'PPL', 'P'),
(31835, 'Blaine', 39.4966697692871, 0.689346931046969, -96.4027786254883, -1.68254589508598, 218, 20, 'PPL', 'P'),
(34848, 'Blaine', 38.0275001525879, 0.663705083965305, -82.8433303833008, -1.44588887850605, 218, 21, 'PPL', 'P'),
(53516, 'Blaine', 37.9494400024414, 0.662342677330647, -94.3847198486328, -1.64732412493109, 218, 29, 'PPL', 'P'),
(58695, 'Blaine', 33.607780456543, 0.586566423254078, -90.5224990844727, -1.5799156561576, 218, 30, 'PPL', 'P'),
(63000, 'Blaine', 35.4911117553711, 0.61943675532449, -80.059440612793, -1.3973008359981, 218, 33, 'PPL', 'P'),
(85114, 'Blaine', 36.1541709899902, 0.631009322104347, -83.7041702270508, -1.46091336811185, 218, 50, 'PPL', 'P'),
(108252, 'Blaine', 39.3858299255371, 0.687412410831136, -79.1800003051758, -1.38195170705543, 218, 58, 'PPL', 'P'),
(118827, 'Blaine', 42.4469413757324, 0.740838884407542, -88.8030624389648, -1.54990582541404, 218, 18, 'PPL', 'P'),
(122238, 'Blaine', 40.4025001525879, 0.70515665370017, -85.0561065673828, -1.484509108528, 218, 19, 'PPL', 'P'),
(126894, 'Blaine', 46.5047187805176, 0.811660460434074, -67.8691711425781, -1.18454049703751, 218, 26, 'PPL', 'P'),
(129850, 'Blaine', 43.1158294677734, 0.752513183941041, -82.5808334350586, -1.44130744248279, 218, 27, 'PPL', 'P'),
(134303, 'Blaine', 45.160831451416, 0.788205201765419, -93.2347183227539, -1.62725281190154, 218, 28, 'PPL', 'P'),
(141309, 'Blaine', 40.6116714477539, 0.708807381501478, -98.3333282470703, -1.71624034235572, 218, 35, 'PPL', 'P'),
(154340, 'Blaine', 40.0677795410156, 0.699314676953945, -80.817497253418, -1.41053142029362, 218, 41, 'PPL', 'P'),
(173212, 'Blaine', 44.3091697692871, 0.773340901299196, -89.315559387207, -1.55885058456729, 218, 57, 'PPL', 'P'),
(194612, 'Blaine', 43.3424987792969, 0.756469309740354, -114.594718933105, -2.00005515078017, 218, 17, 'PPL', 'P'),
(200421, 'Blaine', 45.2775001525879, 0.790241454734894, -123.703330993652, -2.15903042152358, 218, 43, 'PPL', 'P'),
(206850, 'Blaine', 48.9938888549805, 0.855104673875564, -122.745826721191, -2.14231881936723, 218, 56, 'PPL', 'P'),
(141310, 'Blaine Center (historical)', 41.9333305358887, 0.731874684178336, -99.897216796875, -1.74353534668405, 218, 35, 'PPL', 'P'),
(159282, 'Blaine Hill', 40.273609161377, 0.70290708152738, -79.8752822875977, -1.39408666687849, 218, 45, 'PPL', 'P'),
(154341, 'Blainesville', 40.1216697692871, 0.700255238871934, -80.8883285522461, -1.41176765967163, 218, 41, 'PPL', 'P'),
(99970, 'Blaineville', 38.6069412231445, 0.673818238467799, -78.4508285522461, -1.36922525915427, 218, 53, 'PPL', 'P'),
(159279, 'Blainsburg', 40.0322189331055, 0.698694027261902, -79.8811111450195, -1.39418839963213, 218, 45, 'PPL', 'P'),
(159280, 'Blainsport', 40.2805595397949, 0.703028388515033, -76.1399993896484, -1.32889368181584, 218, 45, 'PPL', 'P'),
(31840, 'Blair', 39.7838897705078, 0.694359865745853, -95.0025024414063, -1.65810646523649, 218, 20, 'PPL', 'P'),
(34850, 'Blair', 36.9902801513672, 0.645602179876464, -82.9530563354492, -1.44780395764593, 218, 21, 'PPL', 'P'),
(58693, 'Blair', 34.4511108398438, 0.601285315124782, -88.7369384765625, -1.54875174455566, 218, 30, 'PPL', 'P'),
(75151, 'Blair', 34.7794418334961, 0.60701577200036, -99.3349990844727, -1.7337227964896, 218, 42, 'PPL', 'P'),
(79823, 'Blair', 34.4213905334473, 0.600766597923462, -81.3963928222656, -1.42063505399521, 218, 48, 'PPL', 'P'),
(85113, 'Blair', 35.9925003051758, 0.628187636350381, -84.4208297729492, -1.47342143680362, 218, 50, 'PPL', 'P'),
(108254, 'Blair', 37.8783302307129, 0.661101577683643, -81.8280563354492, -1.42816900356099, 218, 58, 'PPL', 'P'),
(118828, 'Blair', 41.103328704834, 0.71738841942885, -88.3086090087891, -1.5412759850597, 218, 18, 'PPL', 'P'),
(126896, 'Blair', 45.6330604553223, 0.796447152706996, -70.1758270263672, -1.22479923692013, 218, 26, 'PPL', 'P'),
(141322, 'Blair', 41.5444412231445, 0.725087285245132, -96.1247177124023, -1.67769281663153, 218, 35, 'PPL', 'P'),
(143528, 'Blair', 43.810001373291, 0.764628769267166, -71.6655578613281, -1.25079994495868, 218, 36, 'PPL', 'P'),
(173214, 'Blair', 44.2944412231445, 0.773083839674976, -91.2350006103516, -1.59235115370967, 218, 57, 'PPL', 'P'),
(189944, 'Blair', 37.7930603027344, 0.65961333668748, -117.648330688477, -2.053350729989, 218, 39, 'PPL', 'P'),
(191141, 'Blair', 32.4213905334473, 0.565860012883576, -100.059722900391, -1.74637161324499, 218, 51, 'PPL', 'P'),
(193226, 'Blair', 40.7380599975586, 0.711013277832391, -113.97721862793, -1.98927773732279, 218, 52, 'PPL', 'P'),
(196034, 'Blair', 48.146671295166, 0.84031793797609, -104.625556945801, -1.82606045043705, 218, 31, 'PPL', 'P'),
(196035, 'Blair Crossing', 48.4033317565918, 0.844797508087657, -112.290557861328, -1.95983995358138, 218, 31, 'PPL', 'P'),
(85115, 'Blair Gap', 36.4502792358398, 0.636177385936728, -82.6797180175781, -1.44303330402722, 218, 50, 'PPL', 'P'),
(19319, 'Blair Heights', 33.7286109924316, 0.588675313942284, -84.6847229003906, -1.47802724075086, 218, 13, 'PPL', 'P'),
(189945, 'Blair Junction (historical)', 38.0083312988281, 0.663370524353364, -117.77278137207, -2.05552280417407, 218, 39, 'PPL', 'P'),
(159283, 'Blair Mill Village East', 40.1833305358887, 0.701331422268435, -75.1166687011719, -1.31103319196522, 218, 45, 'PPL', 'P'),
(159284, 'Blair Mill Village West', 40.1800003051758, 0.701273298777644, -75.1216735839844, -1.31112054364898, 218, 45, 'PPL', 'P'),
(44867, 'Blair Portal', 38.9922218322754, 0.680542653641222, -77.0361099243164, -1.3445337611076, 218, 25, 'PPL', 'P'),
(34853, 'Blair Town', 37.5424995422363, 0.655240226440488, -82.5858306884766, -1.44139466100849, 218, 21, 'PPL', 'P'),
(19320, 'Blair Village', 33.6575012207031, 0.58743421429528, -84.3702774047852, -1.47253913153448, 218, 13, 'PPL', 'P'),
(44868, 'Blair Woods', 38.9208297729492, 0.679296627146201, -76.1736068725586, -1.32948024304593, 218, 25, 'PPL', 'P'),
(159286, 'Blairfour', 40.5325012207031, 0.70742560036989, -78.1686096191406, -1.36429960956011, 218, 45, 'PPL', 'P'),
(154342, 'Blairmont', 40.2388916015625, 0.70230114580036, -80.8899993896484, -1.41179682128557, 218, 41, 'PPL', 'P'),
(905, 'Blairs', 31.2638893127441, 0.545657805486452, -86.2233276367188, -1.50488095928656, 218, 2, 'PPL', 'P'),
(99972, 'Blairs', 37.2972183227539, 0.650959261567213, -77.1311111450195, -1.34619184520228, 218, 53, 'PPL', 'P'),
(159287, 'Blairs Corners', 41.1830596923828, 0.718779987677443, -79.5641708374023, -1.38865674773192, 218, 45, 'PPL', 'P'),
(34851, 'Blairs Mills', 38.0827789306641, 0.664669880649213, -83.2919387817383, -1.45371857211089, 218, 21, 'PPL', 'P'),
(159288, 'Blairs Mills', 40.2836112976074, 0.703081651736835, -77.7186126708984, -1.35644568118936, 218, 45, 'PPL', 'P'),
(114627, 'Blairsburg', 42.4799995422363, 0.741415858257708, -93.6427764892578, -1.63437477044669, 218, 16, 'PPL', 'P'),
(180127, 'Blairsden', 39.7811088562012, 0.694311329634986, -120.615562438965, -2.10513869370474, 218, 6, 'PPL', 'P'),
(39401, 'Blairstown', 30.7525005340576, 0.53673238754062, -90.9625015258789, -1.58759514747695, 218, 22, 'PPL', 'P'),
(53518, 'Blairstown', 38.5558280944824, 0.67292614608165, -93.960563659668, -1.63992120289094, 218, 29, 'PPL', 'P'),
(114629, 'Blairstown', 41.9094390869141, 0.731457699730656, -92.0841674804688, -1.60717191149207, 218, 16, 'PPL', 'P'),
(144846, 'Blairstown', 40.982780456543, 0.71528445558866, -74.9608306884766, -1.30831330554392, 218, 37, 'PPL', 'P'),
(19321, 'Blairsville', 34.8761100769043, 0.608702951129953, -83.9583282470703, -1.46534926238154, 218, 13, 'PPL', 'P'),
(26542, 'Blairsville', 37.8111114501953, 0.659928388644436, -89.1236114501953, -1.55550046107403, 218, 18, 'PPL', 'P'),
(29225, 'Blairsville', 38.0788917541504, 0.664602036620443, -87.7619400024414, -1.53173481098032, 218, 19, 'PPL', 'P'),
(71837, 'Blairsville', 38.9933280944824, 0.680561961559125, -84.2936096191406, -1.47120102624477, 218, 41, 'PPL', 'P'),
(79824, 'Blairsville', 34.9152793884277, 0.609386584581776, -81.3505630493164, -1.41983517356181, 218, 48, 'PPL', 'P'),
(159289, 'Blairsville', 40.4311103820801, 0.70565599640456, -79.2611083984375, -1.38336731033286, 218, 45, 'PPL', 'P'),
(108255, 'Blairton', 39.4524993896484, 0.688576012490419, -77.9205627441406, -1.35997037489208, 218, 58, 'PPL', 'P'),
(77884, 'Blairtown', 39.8888893127441, 0.696192453470963, -80.1866683959961, -1.39952137971501, 218, 45, 'PPL', 'P'),
(209314, 'Blairtown', 41.5733299255371, 0.725591488218512, -109.230003356934, -1.90642320054295, 218, 59, 'PPL', 'P'),
(44869, 'Blairtown (historical)', 38.7561111450195, 0.67642174474946, -75.9005584716797, -1.32471464943329, 218, 25, 'PPL', 'P'),
(147235, 'Blairville', 43.2338905334473, 0.754573738255462, -79.017219543457, -1.37911064680454, 218, 40, 'PPL', 'P'),
(177733, 'Blaisdell', 32.7125015258789, 0.570940858190256, -114.425827026367, -1.99710743092762, 218, 5, 'PPL', 'P'),
(198017, 'Blaisdell', 48.336109161377, 0.843624252469423, -102.076393127441, -1.78156914863396, 218, 34, 'PPL', 'P'),
(200422, 'Blaisdell', 42.3783302307129, 0.739641394023388, -120.842781066895, -2.10910440688398, 218, 43, 'PPL', 'P'),
(126897, 'Blaisdell Corners', 43.3477783203125, 0.75656145511407, -70.9280624389648, -1.23792822162006, 218, 26, 'PPL', 'P'),
(907, 'Blake', 33.1138916015625, 0.577946436595764, -85.5008316040039, -1.49227102468309, 218, 2, 'PPL', 'P'),
(15249, 'Blake', 29.170560836792, 0.509122331255332, -81.0388870239258, -1.41439540071921, 218, 12, 'PPL', 'P'),
(31841, 'Blake', 37.1674995422363, 0.648695241745509, -95.7569427490234, -1.67127393261417, 218, 20, 'PPL', 'P'),
(34852, 'Blake', 37.3869400024414, 0.652525200288179, -83.7391662597656, -1.46152416410786, 218, 21, 'PPL', 'P'),
(44870, 'Blake', 39.7155609130859, 0.693167302209715, -75.9169387817383, -1.32500053977631, 218, 25, 'PPL', 'P'),
(53517, 'Blake', 39.9469413757324, 0.697205653107684, -93.8708267211914, -1.63835499785386, 218, 29, 'PPL', 'P'),
(79825, 'Blake', 32.6916694641113, 0.570577270122433, -80.7694396972656, -1.4096926577083, 218, 48, 'PPL', 'P'),
(154343, 'Blake', 41.0469398498535, 0.716404248248011, -81.8152770996094, -1.4279459638197, 218, 41, 'PPL', 'P'),
(194611, 'Blake', 46.473331451416, 0.811112648197845, -116.176666259766, -2.02766534022352, 218, 17, 'PPL', 'P'),
(108256, 'Blake (historical)', 37.3027801513672, 0.651056333788946, -81.0688934326172, -1.41491911134758, 218, 58, 'PPL', 'P'),
(126898, 'Blake Corner', 44.0116691589355, 0.768148536121869, -70.1180572509766, -1.22379096413143, 218, 26, 'PPL', 'P'),
(99974, 'Blake Forest', 37.1436080932617, 0.64827825729783, -80.3330612182617, -1.40207641646483, 218, 53, 'PPL', 'P'),
(203058, 'Blake Heights', 40.6416702270508, 0.709330958971788, -111.946670532227, -1.95383798743267, 218, 52, 'PPL', 'P'),
(203059, 'Blake Holley', 41.3088912963867, 0.720976163470377, -111.849716186523, -1.95214581487603, 218, 52, 'PPL', 'P'),
(177730, 'Blake Place', 32.8074989318848, 0.572598875705912, -110.521667480469, -1.92896699232853, 218, 5, 'PPL', 'P'),
(99975, 'Blake Village', 37.2397193908691, 0.649955715889444, -78.4638900756836, -1.36945322574358, 218, 53, 'PPL', 'P'),
(79826, 'Blakedale', 34.2247200012207, 0.597334049594459, -82.1941680908203, -1.43455885912248, 218, 48, 'PPL', 'P'),
(19322, 'Blakeford', 33.9986114501953, 0.593387710912152, -84.4436111450195, -1.47381904675437, 218, 13, 'PPL', 'P'),
(44871, 'Blakeford', 39.0055618286133, 0.680775480499522, -76.1555633544922, -1.32916532424703, 218, 25, 'PPL', 'P'),
(192921, 'Blakeland', 39.5597190856934, 0.69044734920939, -105.036109924316, -1.83322595166601, 218, 7, 'PPL', 'P'),
(909, 'Blakeley', 30.7419395446777, 0.536548063503673, -87.9241714477539, -1.5345662838513, 218, 2, 'PPL', 'P'),
(108257, 'Blakeley', 38.2961082458496, 0.668393179590226, -81.3038864135742, -1.41902051258435, 218, 58, 'PPL', 'P'),
(134305, 'Blakeley', 44.6108283996582, 0.778605837616228, -93.8530578613281, -1.63804487274492, 218, 28, 'PPL', 'P'),
(147236, 'Blakeley', 42.7355613708496, 0.745876253609427, -78.5955581665039, -1.37175126744821, 218, 40, 'PPL', 'P'),
(7524, 'Blakely', 34.6966705322266, 0.605571140267047, -93.0691680908203, -1.62436341527686, 218, 4, 'PPL', 'P'),
(19323, 'Blakely', 31.3775005340576, 0.547640695365585, -84.9341735839844, -1.48238097650092, 218, 13, 'PPL', 'P'),
(58694, 'Blakely', 32.4436111450195, 0.566247835717318, -90.8222198486328, -1.58514677032879, 218, 30, 'PPL', 'P'),
(79827, 'Blakely', 33.4944381713867, 0.584588227196367, -79.7569427490234, -1.39202125229508, 218, 48, 'PPL', 'P'),
(159291, 'Blakely', 41.4808311462402, 0.723977079965706, -75.5950012207031, -1.3193816693504, 218, 45, 'PPL', 'P'),
(19324, 'Blakely Woods', 33.4638900756836, 0.584055062346133, -84.4397201538086, -1.47375113614657, 218, 13, 'PPL', 'P'),
(187602, 'Blakeman', 39.8222198486328, 0.695028851811681, -101.116668701172, -1.76481879748375, 218, 20, 'PPL', 'P'),
(7525, 'Blakemore', 34.6047210693359, 0.603966319394165, -91.8819427490234, -1.60364242409939, 218, 4, 'PPL', 'P'),
(92672, 'Blakeney', 33.8652801513672, 0.591060640751641, -95.0844421386719, -1.65953658274186, 218, 51, 'PPL', 'P'),
(108258, 'Blaker Mills', 37.7616691589355, 0.659065457872223, -80.6074981689453, -1.4068662448434, 218, 58, 'PPL', 'P'),
(99976, 'Blakes', 37.4991683959961, 0.654483955269933, -76.3677825927734, -1.33286924869111, 218, 53, 'PPL', 'P'),
(118829, 'Blakes', 41.458610534668, 0.723589257131963, -88.7527770996094, -1.54902818067681, 218, 18, 'PPL', 'P'),
(159293, 'Blakes', 41.6911087036133, 0.727647115684916, -77.0266723632813, -1.34436904459418, 218, 45, 'PPL', 'P'),
(180128, 'Blakes Landing', 38.1944389343262, 0.666618715355906, -122.918327331543, -2.14532952297956, 218, 6, 'PPL', 'P'),
(29227, 'Blakesburg', 39.8072204589844, 0.694767063076526, -86.9100036621094, -1.51686571682414, 218, 19, 'PPL', 'P'),
(114630, 'Blakesburg', 40.9622192382813, 0.714925594631772, -92.6338882446289, -1.61676634879324, 218, 16, 'PPL', 'P'),
(147237, 'Blakeslee', 43.0069389343262, 0.750612685608133, -75.8150024414063, -1.32322141501008, 218, 40, 'PPL', 'P'),
(154344, 'Blakeslee', 41.524169921875, 0.724733484294315, -84.7302780151367, -1.4788223274943, 218, 41, 'PPL', 'P'),
(159294, 'Blakeslee', 41.0924987792969, 0.717199401570481, -75.5930633544922, -1.31934784720456, 218, 45, 'PPL', 'P'),
(196036, 'Blakeslee (historical)', 47.1949996948242, 0.823708135152402, -108.672218322754, -1.89668801517817, 218, 31, 'PPL', 'P'),
(159295, 'Blakeslee Estates', 41.1091690063477, 0.717490351919572, -75.5699996948242, -1.31894531040579, 218, 45, 'PPL', 'P'),
(206851, 'Blakeslee Junction', 46.735279083252, 0.815684496841184, -122.97306060791, -2.14628479886257, 218, 56, 'PPL', 'P'),
(85116, 'Blakeville', 35.2594413757324, 0.61539334442045, -86.6752777099609, -1.51276897611927, 218, 50, 'PPL', 'P'),
(44872, 'Blakistone', 38.2838897705078, 0.668179926965938, -76.8024978637695, -1.34045646147869, 218, 25, 'PPL', 'P'),
(58696, 'Blakley Creek', 31.7361106872559, 0.553899623269975, -89.5694427490234, -1.56328168514702, 218, 30, 'PPL', 'P'),
(79828, 'Blakley Crossroads', 34.5838890075684, 0.603602731326342, -80.8469390869141, -1.41104527722595, 218, 48, 'PPL', 'P'),
(913, 'Blalock', 32.3091697692871, 0.563901391059877, -87.3836135864258, -1.52513176937358, 218, 2, 'PPL', 'P'),
(19325, 'Blalock', 34.8930587768555, 0.608998761748033, -83.5136108398438, -1.4575874793845, 218, 13, 'PPL', 'P'),
(186422, 'Blanca', 37.438060760498, 0.653417425832383, -105.515281677246, -1.84158907643719, 218, 7, 'PPL', 'P'),
(63002, 'Blanch', 36.5077781677246, 0.637180931614497, -79.295280456543, -1.38396372525899, 218, 33, 'PPL', 'P'),
(75152, 'Blanch', 35.7830581665039, 0.624532181438138, -94.6658325195313, -1.65223046660734, 218, 42, 'PPL', 'P'),
(13397, 'Blanchard', 38.8205604553223, 0.677546597414883, -75.6524963378906, -1.32038514844914, 218, 10, 'PPL', 'P'),
(39403, 'Blanchard', 32.5808296203613, 0.568642749906599, -93.8925018310547, -1.63873329988671, 218, 22, 'PPL', 'P'),
(75153, 'Blanchard', 35.1377792358398, 0.613269939504302, -97.6577835083008, -1.70444986241967, 218, 42, 'PPL', 'P'),
(92673, 'Blanchard', 30.7366695404053, 0.536456084577524, -95.0552825927734, -1.65902765265755, 218, 51, 'PPL', 'P'),
(114631, 'Blanchard', 40.5791702270508, 0.708240128189291, -95.2213897705078, -1.66192676982021, 218, 16, 'PPL', 'P'),
(126899, 'Blanchard', 45.2675018310547, 0.790066951104466, -69.5841674804688, -1.21447282979335, 218, 26, 'PPL', 'P'),
(129853, 'Blanchard', 43.519718170166, 0.759562371609399, -85.0800018310547, -1.48492615955471, 218, 27, 'PPL', 'P'),
(139687, 'Blanchard', 47.3458290100098, 0.826340603310918, -97.2191696166992, -1.69679460586623, 218, 34, 'PPL', 'P'),
(154345, 'Blanchard', 40.7319412231445, 0.710906485072678, -83.6436080932617, -1.45985635947519, 218, 41, 'PPL', 'P'),
(159297, 'Blanchard', 41.0641708374023, 0.716704985714108, -77.5980606079102, -1.35434165077014, 218, 45, 'PPL', 'P'),
(180129, 'Blanchard', 37.7313919067383, 0.658537020132924, -120.324440002441, -2.10005764866098, 218, 6, 'PPL', 'P'),
(188156, 'Blanchard', 35.3886108398438, 0.617647776862229, -105.356941223145, -1.83882551417401, 218, 38, 'PPL', 'P'),
(194613, 'Blanchard', 48.0169410705566, 0.838053718417304, -116.982780456543, -2.04173468710435, 218, 17, 'PPL', 'P'),
(206852, 'Blanchard', 48.5936088562012, 0.848118469966986, -122.415283203125, -2.13654974665584, 218, 56, 'PPL', 'P'),
(7526, 'Blanchard (historical)', 34.1722183227539, 0.59641772244239, -94.4638900756836, -1.64870590606267, 218, 4, 'PPL', 'P'),
(154346, 'Blanchard (historical)', 40.1074981689453, 0.700007897785693, -82.4858322143555, -1.43964935838811, 218, 41, 'PPL', 'P'),
(126900, 'Blanchard Corner', 45.0055618286133, 0.785495235619182, -67.2752838134766, -1.17417520775881, 218, 26, 'PPL', 'P'),
(19327, 'Blanchard Park', 33.4997215270996, 0.584680439149111, -82.1430587768555, -1.43366683331535, 218, 13, 'PPL', 'P'),
(7527, 'Blanchard Springs', 33.0263900756836, 0.576419246868658, -92.6666717529297, -1.61733852895345, 218, 4, 'PPL', 'P'),
(196037, 'Blanchards Corner', 47.5566711425781, 0.830020492726162, -114.870559692383, -2.00486948024076, 218, 31, 'PPL', 'P'),
(124259, 'Blanchardville', 42.1458282470703, 0.735583468891407, -72.3041687011719, -1.26194580675288, 218, 23, 'PPL', 'P'),
(173217, 'Blanchardville', 42.8102798461914, 0.747180337016212, -89.8619384765625, -1.56838669864059, 218, 57, 'PPL', 'P'),
(916, 'Blanche', 34.3633308410645, 0.599753265128687, -85.6100006103516, -1.49417638328499, 218, 2, 'PPL', 'P'),
(34855, 'Blanche', 36.8180618286133, 0.642596403112146, -83.6552810668945, -1.46006009129858, 218, 21, 'PPL', 'P'),
(39404, 'Blanche', 30.9200000762939, 0.539655806048227, -92.6122207641602, -1.61638817991845, 218, 22, 'PPL', 'P'),
(53519, 'Blanche', 36.8199996948242, 0.64263022525799, -92.3030624389648, -1.61099234923384, 218, 29, 'PPL', 'P'),
(85117, 'Blanche', 35.0430603027344, 0.611616782257636, -86.7544403076172, -1.5141506240928, 218, 50, 'PPL', 'P'),
(71838, 'Blanchester', 39.2930603027344, 0.685793275467395, -83.9888916015625, -1.46588269354788, 218, 41, 'PPL', 'P'),
(34854, 'Blanchet', 38.519718170166, 0.672295909009682, -84.5716705322266, -1.47605410469922, 218, 21, 'PPL', 'P'),
(7528, 'Blanchton', 33.2416687011719, 0.580176567692596, -92.0869369506836, -1.60722024786586, 218, 4, 'PPL', 'P'),
(7529, 'Blanco', 35.9286117553711, 0.627072570801965, -92.8119430541992, -1.61987399146926, 218, 4, 'PPL', 'P'),
(75154, 'Blanco', 34.7511100769043, 0.60652128956496, -95.774169921875, -1.67157460350124, 218, 42, 'PPL', 'P'),
(92674, 'Blanco', 30.0977802276611, 0.525305362514335, -98.4211120605469, -1.71777245893084, 218, 51, 'PPL', 'P'),
(154351, 'Blanco', 41.0855598449707, 0.71707829431991, -80.959716796875, -1.41301361958763, 218, 41, 'PPL', 'P'),
(159301, 'Blanco', 40.776668548584, 0.711687124167208, -79.3544387817383, -1.38499623281361, 218, 45, 'PPL', 'P'),
(188157, 'Blanco', 36.7241706848145, 0.640957693514393, -107.824722290039, -1.8818964190097, 218, 38, 'PPL', 'P'),
(192894, 'Blanco', 36.6786117553711, 0.640162540191923, -121.741668701172, -2.12479295570758, 218, 6, 'PPL', 'P'),
(199841, 'Blanco (historical)', 40.5638885498047, 0.70797341260612, -117.129173278809, -2.04428972385417, 218, 39, 'PPL', 'P'),
(92676, 'Blanconia', 28.3983306884766, 0.495644372584064, -97.4119415283203, -1.70015911042939, 218, 51, 'PPL', 'P'),
(7531, 'Bland', 34.686939239502, 0.605401297168527, -92.6877822875977, -1.61770697729026, 218, 4, 'PPL', 'P'),
(15250, 'Bland', 29.9019393920898, 0.521887295123759, -82.4991683959961, -1.43988211866738, 218, 12, 'PPL', 'P'),
(53520, 'Bland', 38.3016700744629, 0.668490251811959, -91.6327819824219, -1.5992937483554, 218, 29, 'PPL', 'P'),
(92678, 'Bland', 30.0913906097412, 0.525193842643688, -93.7572174072266, -1.63637214126424, 218, 51, 'PPL', 'P'),
(99977, 'Bland', 37.1019401550293, 0.647551014583157, -81.1163864135742, -1.41574802023686, 218, 53, 'PPL', 'P'),
(188158, 'Bland', 35.7574996948242, 0.62408610195555, -106.464721679688, -1.85815993052993, 218, 38, 'PPL', 'P'),
(19328, 'Bland (historical)', 32.5158309936523, 0.567508309861253, -81.8916702270508, -1.42927927541945, 218, 13, 'PPL', 'P'),
(92679, 'Bland Lake', 31.5900001525879, 0.55134951336817, -94.1113891601563, -1.64255360447043, 218, 51, 'PPL', 'P'),
(159298, 'Blandburg', 40.686939239502, 0.710121052288187, -78.4111099243164, -1.36853203832252, 218, 45, 'PPL', 'P'),
(112990, 'Blanden', 42.577220916748, 0.743112691346252, -94.5611114501953, -1.65040273915122, 218, 16, 'PPL', 'P'),
(19329, 'Blandford', 32.2783317565918, 0.563363166203572, -81.2633285522461, -1.41831264436661, 218, 13, 'PPL', 'P'),
(99980, 'Blandford', 37.230281829834, 0.649790999376022, -77.3925018310547, -1.35075397330764, 218, 53, 'PPL', 'P'),
(124260, 'Blandford', 42.1805610656738, 0.736189670934536, -72.9277801513672, -1.27282987981193, 218, 23, 'PPL', 'P'),
(44873, 'Blandford Village', 38.7174987792969, 0.675747831835616, -76.8905563354492, -1.34199337174377, 218, 25, 'PPL', 'P'),
(118844, 'Blanding', 42.2747192382813, 0.737833041064197, -90.3858337402344, -1.57753039592727, 218, 18, 'PPL', 'P'),
(192488, 'Blanding', 37.6241683959961, 0.656665616834926, -109.477500915527, -1.91074284783106, 218, 52, 'PPL', 'P'),
(118831, 'Blandinsville', 40.5561103820801, 0.707837657969553, -90.8658294677734, -1.58590790176833, 218, 18, 'PPL', 'P'),
(159299, 'Blandon', 40.4411087036133, 0.705830500034987, -75.8872222900391, -1.32448188915401, 218, 45, 'PPL', 'P'),
(63003, 'Blands', 35.8877792358398, 0.62635990889426, -78.9574966430664, -1.37806828555388, 218, 33, 'PPL', 'P'),
(63004, 'Blands Crossroads', 35.1811103820801, 0.614026210674858, -77.7094421386719, -1.35628562520785, 218, 33, 'PPL', 'P'),
(917, 'Blands Landing', 32.6813888549805, 0.570397839643989, -85.1391677856445, -1.48595880026739, 218, 2, 'PPL', 'P'),
(99981, 'Blandsford', 38.711669921875, 0.675646099081975, -77.4419403076172, -1.35161683750083, 218, 53, 'PPL', 'P'),
(34856, 'Blandville', 36.9436111450195, 0.644787652057063, -88.9638900756836, -1.55271279720299, 218, 21, 'PPL', 'P'),
(108259, 'Blandville', 39.2566719055176, 0.685158178126438, -80.7108306884766, -1.4086697375336, 218, 58, 'PPL', 'P'),
(19330, 'Blandy', 33.0752792358398, 0.577272523681919, -83.3052825927734, -1.45395146554822, 218, 13, 'PPL', 'P'),
(85119, 'Blaney Forest', 35.0041694641113, 0.610938009074802, -85.2583312988281, -1.48803859592068, 218, 50, 'PPL', 'P'),
(79829, 'Blaney Hills', 34.1694412231445, 0.596369252910551, -80.7708282470703, -1.40971689247422, 218, 48, 'PPL', 'P'),
(129855, 'Blaney Junction', 46.0247192382813, 0.803282888013984, -85.9111099243164, -1.4994317322221, 218, 27, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(129854, 'Blaney Park', 46.1155586242676, 0.804868334389936, -85.9269409179688, -1.49970803518519, 218, 27, 'PPL', 'P'),
(29226, 'Blanford', 39.6650009155273, 0.692284863782517, -87.5205612182617, -1.52752195645193, 218, 19, 'PPL', 'P'),
(44874, 'Blank', 39.5283317565918, 0.689899536973161, -77.5927810668945, -1.35424950539643, 218, 25, 'PPL', 'P'),
(85118, 'Blankenship (historical)', 35.6902809143066, 0.622912912916343, -88.2194366455078, -1.53971963371865, 218, 50, 'PPL', 'P'),
(92680, 'Blanket', 31.8238906860352, 0.55543167326607, -98.7866668701172, -1.72415259395435, 218, 51, 'PPL', 'P'),
(159300, 'Blanket Hill', 40.7649993896484, 0.711483458922844, -79.4225006103516, -1.38618413581784, 218, 45, 'PPL', 'P'),
(92681, 'Blanket Springs', 31.586109161377, 0.551281602760373, -98.779167175293, -1.72402169958677, 218, 51, 'PPL', 'P'),
(44875, 'Blankner Hill', 39.4055595397949, 0.687756757560083, -77.0186080932617, -1.34422829653057, 218, 25, 'PPL', 'P'),
(39405, 'Blanks', 30.5530605316162, 0.533251502837832, -91.6002807617188, -1.59872649504321, 218, 22, 'PPL', 'P'),
(99982, 'Blanks', 36.6058311462402, 0.638892278930982, -78.5425033569336, -1.37082528633719, 218, 53, 'PPL', 'P'),
(99983, 'Blanks Store', 37.3083305358887, 0.651153206273598, -76.9377822875977, -1.34281762010115, 218, 53, 'PPL', 'P'),
(39406, 'Blankston', 32.2419395446777, 0.562728002283588, -92.1322174072266, -1.60801054091934, 218, 22, 'PPL', 'P'),
(7532, 'Blansett', 34.7900009155273, 0.607200062747794, -94.2200012207031, -1.64444924253435, 218, 4, 'PPL', 'P'),
(144848, 'Blansingburg', 40.1366691589355, 0.700517027607089, -74.057502746582, -1.2925472587326, 218, 37, 'PPL', 'P'),
(918, 'Blanton', 32.7344398498535, 0.571323754175982, -85.1338882446289, -1.48586665489367, 218, 2, 'PPL', 'P'),
(7534, 'Blanton', 35.1747207641602, 0.613914690804211, -90.166389465332, -1.57370037080557, 218, 4, 'PPL', 'P'),
(15251, 'Blanton', 28.4113903045654, 0.495872305883861, -82.2466735839844, -1.43547525285357, 218, 12, 'PPL', 'P'),
(58697, 'Blanton', 32.7486114501953, 0.571571095262223, -90.9305572509766, -1.58703761470274, 218, 30, 'PPL', 'P'),
(75155, 'Blanton', 36.4277801513672, 0.635784702833996, -97.9266662597656, -1.70914275173455, 218, 42, 'PPL', 'P'),
(92683, 'Blanton', 31.8213901519775, 0.555388030713707, -99.8705596923828, -1.74307009244162, 218, 51, 'PPL', 'P'),
(112267, 'Blanton', 30.8299999237061, 0.538085007058271, -83.1188888549805, -1.45069828111863, 218, 13, 'PPL', 'P'),
(85120, 'Blanton (historical)', 35.8325004577637, 0.625395112210351, -85.9694366455078, -1.50044972554878, 218, 50, 'PPL', 'P'),
(19337, 'Blanton Acres', 32.8013916015625, 0.572492282683282, -83.8133316040039, -1.46281859355569, 218, 13, 'PPL', 'P'),
(99984, 'Blanton Crossing', 37.7605590820313, 0.659046083375293, -77.3844375610352, -1.35061322524403, 218, 53, 'PPL', 'P'),
(34857, 'Blanton Flats', 37.5699996948242, 0.655720194647947, -84.0038909912109, -1.46614448228303, 218, 21, 'PPL', 'P'),
(99985, 'Blantons', 38.0525016784668, 0.664141442909914, -77.561393737793, -1.3537016931602, 218, 53, 'PPL', 'P'),
(19331, 'Blantons Mill', 33.2205581665039, 0.579808119355784, -84.434440612793, -1.47365899077286, 218, 13, 'PPL', 'P'),
(63005, 'Blantyre', 35.2999992370605, 0.616101212638193, -82.626106262207, -1.44209760237822, 218, 33, 'PPL', 'P'),
(147238, 'Blasdell', 42.7972183227539, 0.746952370426901, -78.8236083984375, -1.37573149485539, 218, 40, 'PPL', 'P'),
(53521, 'Blase', 38.872501373291, 0.678453137449946, -90.4772186279297, -1.57912536310412, 218, 29, 'PPL', 'P'),
(108260, 'Blaser', 39.3866691589355, 0.687427058217131, -79.7177810668945, -1.39133775200131, 218, 58, 'PPL', 'P'),
(71839, 'Blatchford', 39.523609161377, 0.689817112137423, -82.2033309936523, -1.43471878194594, 218, 41, 'PPL', 'P'),
(196039, 'Blatchford', 46.7102813720703, 0.815248204475601, -105.448890686035, -1.8404303350469, 218, 31, 'PPL', 'P'),
(147239, 'Blatchley', 42.0213890075684, 0.73341159444342, -75.7344436645508, -1.32181539911257, 218, 40, 'PPL', 'P'),
(147240, 'Blauvelt', 41.0633316040039, 0.716690338328112, -73.9580612182617, -1.2908116766502, 218, 40, 'PPL', 'P'),
(180131, 'Blavo', 39.5716705322266, 0.69065594130177, -121.732223510742, -2.1246281060361, 218, 6, 'PPL', 'P'),
(144849, 'Blawenburg', 40.4075012207031, 0.705243938804897, -74.7030563354492, -1.3038142943564, 218, 37, 'PPL', 'P'),
(159304, 'Blawnox', 40.4933280944824, 0.70674190033904, -79.8608322143555, -1.39383446552326, 218, 45, 'PPL', 'P'),
(19332, 'Blaylock Mill', 34.6669387817383, 0.605052223328645, -85.3000030517578, -1.48876590521438, 218, 13, 'PPL', 'P'),
(34858, 'Blaze', 38.021671295166, 0.663603351211664, -83.3330612182617, -1.45443629402466, 218, 21, 'PPL', 'P'),
(53522, 'Blazer', 36.1830596923828, 0.631513525077727, -89.7647171020508, -1.56668986555205, 218, 29, 'PPL', 'P'),
(188159, 'Blazers Mill', 33.1563911437988, 0.578688193538378, -105.78694152832, -1.84633043528391, 218, 38, 'PPL', 'P'),
(144850, 'Blaziers Corner', 40.7202796936035, 0.710702952986369, -74.5588912963867, -1.30129813975849, 218, 37, 'PPL', 'P'),
(196038, 'Blazing Place', 46.2249984741211, 0.806778420102768, -111.970558166504, -1.95425490530132, 218, 31, 'PPL', 'P'),
(209315, 'Blazon Junction', 41.685001373291, 0.727540522662286, -110.551940917969, -1.9294953634888, 218, 59, 'PPL', 'P'),
(124262, 'Bleachery', 42.6277809143066, 0.74399512977345, -71.3041687011719, -1.24449251423294, 218, 23, 'PPL', 'P'),
(99986, 'Bleak', 38.5213890075684, 0.672325070623619, -77.6819381713867, -1.35580559042136, 218, 53, 'PPL', 'P'),
(85122, 'Bleak (historical)', 35.0058288574219, 0.610966970951656, -89.795280456543, -1.56722329671839, 218, 50, 'PPL', 'P'),
(7535, 'Bleaker (historical)', 34.0305595397949, 0.593945310265388, -92.4427795410156, -1.61343087268598, 218, 4, 'PPL', 'P'),
(159303, 'Bleakley Hill', 41.4047203063965, 0.722648695213974, -79.8263931274414, -1.39323339006523, 218, 45, 'PPL', 'P'),
(92684, 'Bleakwood', 30.6922206878662, 0.535680305751984, -93.8222198486328, -1.63750664788862, 218, 51, 'PPL', 'P'),
(79832, 'Bleases Crossroads', 34.0586090087891, 0.594434865852772, -81.8130569458008, -1.42790721482584, 218, 48, 'PPL', 'P'),
(53525, 'Bleda', 37.0705604553223, 0.647003335504982, -89.6374969482422, -1.5644694549932, 218, 29, 'PPL', 'P'),
(7536, 'Bledsoe', 34.9052810668945, 0.609212080951349, -90.524169921875, -1.57994481777154, 218, 4, 'PPL', 'P'),
(34859, 'Bledsoe', 36.9236106872559, 0.644438578217181, -83.366943359375, -1.45502764894472, 218, 21, 'PPL', 'P'),
(85124, 'Bledsoe', 36.5155601501465, 0.637316752830091, -86.2655563354492, -1.50561798911824, 218, 50, 'PPL', 'P'),
(177740, 'Bledsoe', 31.4477806091309, 0.548867314074161, -110.306106567383, -1.92520474465657, 218, 5, 'PPL', 'P'),
(191143, 'Bledsoe', 33.6191711425781, 0.586765228229452, -103.02082824707, -1.79805265104296, 218, 51, 'PPL', 'P'),
(99987, 'Bledsoe Corner', 38.3280601501465, 0.668950845522488, -77.9066696166992, -1.35972789407483, 218, 53, 'PPL', 'P'),
(922, 'Bleecker', 32.582218170166, 0.568666984672519, -85.1641693115234, -1.486395159212, 218, 2, 'PPL', 'P'),
(147241, 'Bleecker', 43.1197204589844, 0.752581094548838, -74.3680572509766, -1.29796745734118, 218, 40, 'PPL', 'P'),
(147242, 'Bleecker Center', 43.1505584716797, 0.753119319405143, -74.3947219848633, -1.29843284474168, 218, 40, 'PPL', 'P'),
(92687, 'Bleiblerville', 30.0077800750732, 0.523734563524379, -96.4472198486328, -1.68332154075347, 218, 51, 'PPL', 'P'),
(114632, 'Blencoe', 41.9302787780762, 0.731821420956534, -96.0805587768555, -1.67692209781206, 218, 16, 'PPL', 'P'),
(186423, 'Blende', 38.2458305358887, 0.667515668011045, -104.568061828613, -1.8250569713383, 218, 7, 'PPL', 'P'),
(154354, 'Blendon Corner', 40.0802803039551, 0.69953285642625, -82.9288864135742, -1.44738211292926, 218, 41, 'PPL', 'P'),
(53523, 'Blendville (historical)', 37.0672187805176, 0.646945012277109, -94.5263900756836, -1.64979673684517, 218, 29, 'PPL', 'P'),
(44876, 'Blenheim', 39.4894409179688, 0.689220763790327, -76.54638671875, -1.33598647874705, 218, 25, 'PPL', 'P'),
(70554, 'Blenheim', 39.8091697692871, 0.694801084959451, -75.0777816772461, -1.31035448536142, 218, 37, 'PPL', 'P'),
(79831, 'Blenheim', 34.5105590820313, 0.602322882685477, -79.6530609130859, -1.39020817222495, 218, 48, 'PPL', 'P'),
(99988, 'Blenheim', 37.9033317565918, 0.661537936628253, -78.4886093139648, -1.36988465784017, 218, 53, 'PPL', 'P'),
(44877, 'Blenheim Forest', 39.5044403076172, 0.689482552525482, -76.5524978637695, -1.3360931383487, 218, 25, 'PPL', 'P'),
(44878, 'Blenheim Manor', 39.4916687011719, 0.689259645942242, -76.5555572509766, -1.33614653472856, 218, 25, 'PPL', 'P'),
(173219, 'Blenker', 44.6133308410645, 0.778649513458106, -89.9150009155273, -1.56931281290967, 218, 57, 'PPL', 'P'),
(108263, 'Blennerhassett', 39.2636108398438, 0.685279285377009, -81.6294403076172, -1.42470249992809, 218, 58, 'PPL', 'P'),
(108261, 'Blennerhassett Heights', 39.2627792358398, 0.685264771149068, -81.5944366455078, -1.42409157077403, 218, 58, 'PPL', 'P'),
(108262, 'Blennerhassett Island View Addition', 39.2633285522461, 0.685274358528993, -81.6063919067383, -1.42430022944544, 218, 58, 'PPL', 'P'),
(71840, 'Blennerhassett View', 39.2805595397949, 0.68557509599509, -81.6175003051758, -1.42449410757279, 218, 41, 'PPL', 'P'),
(147245, 'Blennes Corner', 43.3113899230957, 0.755926357773114, -75.6813888549805, -1.32088941800155, 218, 40, 'PPL', 'P'),
(71841, 'Blessing', 39.7024993896484, 0.692939335620404, -83.6036071777344, -1.45915821179543, 218, 41, 'PPL', 'P'),
(92685, 'Blessing', 28.8711109161377, 0.503895944195079, -96.2177810668945, -1.67931707858037, 218, 51, 'PPL', 'P'),
(99989, 'Blessing', 36.9355583190918, 0.644647103730534, -81.2052764892578, -1.41729944472989, 218, 53, 'PPL', 'P'),
(114633, 'Blessing', 42.3116683959961, 0.73847792552216, -92.4558334350586, -1.61365870611723, 218, 16, 'PPL', 'P'),
(7540, 'Blevins', 33.8716697692871, 0.591172160622288, -93.5769424438477, -1.63322574959437, 218, 4, 'PPL', 'P'),
(34860, 'Blevins', 38.0738906860352, 0.664514751515716, -82.9038925170898, -1.44694588714271, 218, 21, 'PPL', 'P'),
(85126, 'Blevins', 36.232780456543, 0.632381316118929, -82.1558303833008, -1.43388973989859, 218, 50, 'PPL', 'P'),
(92686, 'Blevins', 31.2230606079102, 0.544945210157775, -97.2083282470703, -1.69660538827078, 218, 51, 'PPL', 'P'),
(19334, 'Blevins Acre', 34.9530601501465, 0.61004598326768, -85.1872177124023, -1.48679742969465, 218, 13, 'PPL', 'P'),
(99990, 'Blevins Corner', 36.9805603027344, 0.645432536515026, -78.4369430541992, -1.36898291149507, 218, 53, 'PPL', 'P'),
(63006, 'Blevins Crossroads', 36.5422210693359, 0.637782073651555, -81.0141677856445, -1.41396396862262, 218, 33, 'PPL', 'P'),
(99991, 'Blevinstown', 38.8261108398438, 0.677643469899534, -77.3708267211914, -1.3503756712748, 218, 53, 'PPL', 'P'),
(191144, 'Blewett', 29.1847190856934, 0.509369439314978, -100.030281066895, -1.74585775631266, 218, 51, 'PPL', 'P'),
(206853, 'Blewett (historical)', 47.4233283996582, 0.827693222828569, -120.658058166504, -2.10588038406833, 218, 56, 'PPL', 'P'),
(7537, 'Blewford (historical)', 36.1688919067383, 0.631266250570513, -94.3311080932617, -1.64638842328209, 218, 4, 'PPL', 'P'),
(189946, 'Bley (historical)', 37.9888916015625, 0.663031237630487, -118.309997558594, -2.06489899542391, 218, 39, 'PPL', 'P'),
(7538, 'Blick', 35.3836097717285, 0.617560491757502, -92.7058334350586, -1.61802202924722, 218, 4, 'PPL', 'P'),
(114634, 'Bliedorn', 41.9025001525879, 0.731336592480085, -90.6780624389648, -1.58263074888894, 218, 16, 'PPL', 'P'),
(159305, 'Bliem Corners', 41.1391716003418, 0.718013995968909, -75.978889465332, -1.32608178317888, 218, 45, 'PPL', 'P'),
(200423, 'Blind Slough (historical)', 46.2019386291504, 0.80637594988303, -123.561111450195, -2.15654822222957, 218, 43, 'PPL', 'P'),
(180132, 'Blinzing (historical)', 39.7138900756836, 0.693138140595779, -121.412498474121, -2.119047851446, 218, 6, 'PPL', 'P'),
(34861, 'Bliss', 37.0800018310547, 0.647168118597431, -85.371940612793, -1.4900214525103, 218, 21, 'PPL', 'P'),
(53524, 'Bliss', 38.0930595397949, 0.664849311127657, -90.7402801513672, -1.58371665282342, 218, 29, 'PPL', 'P'),
(129860, 'Bliss', 45.6802787780762, 0.797271267906321, -84.8841705322266, -1.4815082586117, 218, 27, 'PPL', 'P'),
(147247, 'Bliss', 42.5769386291504, 0.743107764498235, -78.253059387207, -1.36577353606542, 218, 40, 'PPL', 'P'),
(194614, 'Bliss', 42.9269409179688, 0.749216456827632, -114.948608398438, -2.00623168713834, 218, 17, 'PPL', 'P'),
(199842, 'Bliss', 41.0291709899902, 0.716094123139071, -117.608062744141, -2.05264792177733, 218, 39, 'PPL', 'P'),
(7539, 'Bliss (historical)', 35.413330078125, 0.618079208958822, -91.6202774047852, -1.59907550230407, 218, 4, 'PPL', 'P'),
(85127, 'Bliss (historical)', 35.7911109924316, 0.624672729764667, -88.0955581665039, -1.53755754638767, 218, 50, 'PPL', 'P'),
(180133, 'Bliss (historical)', 39.2722206115723, 0.685429554241517, -121.595283508301, -2.12223805211581, 218, 6, 'PPL', 'P'),
(124263, 'Bliss Corner', 41.6116714477539, 0.726260674021421, -70.9388885498047, -1.2381171728994, 218, 23, 'PPL', 'P'),
(147246, 'Bliss Corner', 43.1575012207031, 0.753240493234742, -74.6686096191406, -1.30321308574031, 218, 40, 'PPL', 'P'),
(169284, 'Bliss Corners', 41.6263885498047, 0.726517535908559, -71.1452789306641, -1.24171936458984, 218, 47, 'PPL', 'P'),
(58698, 'Blissdale', 33.0869407653809, 0.577476055768229, -90.220832824707, -1.57465058668251, 218, 30, 'PPL', 'P'),
(129858, 'Blissfield', 41.8325004577637, 0.730114867330011, -83.8625030517578, -1.46367679721697, 218, 27, 'PPL', 'P'),
(154353, 'Blissfield', 40.3997192382813, 0.705108117589303, -81.9655609130859, -1.43056891117732, 218, 41, 'PPL', 'P'),
(124264, 'Blissville', 42.6725006103516, 0.744775635709925, -72.2750015258789, -1.26143674351051, 218, 23, 'PPL', 'P'),
(171749, 'Blissville', 43.5930595397949, 0.760842419987345, -73.2302780151367, -1.27810946351495, 218, 55, 'PPL', 'P'),
(19335, 'Blitch', 32.5894393920898, 0.568793018771107, -81.7825012207031, -1.42737391681755, 218, 13, 'PPL', 'P'),
(15252, 'Blitchton', 29.2822208404541, 0.511071165962025, -82.3369369506836, -1.43705064579641, 218, 12, 'PPL', 'P'),
(19336, 'Blitchton', 32.1969413757324, 0.561942636078123, -81.4380569458008, -1.42136223013086, 218, 13, 'PPL', 'P'),
(15253, 'Blitchville', 29.6447200775146, 0.517397971184699, -82.8824996948242, -1.44657251195788, 218, 12, 'PPL', 'P'),
(92688, 'Blix', 31.2627792358398, 0.545638430989522, -94.866943359375, -1.65574051292406, 218, 51, 'PPL', 'P'),
(99992, 'Blizzards Corners', 37.1452789306641, 0.648307418911766, -76.7669372558594, -1.33983581178665, 218, 53, 'PPL', 'P'),
(63007, 'Blizzards Crossroads', 35.1363906860352, 0.613245704738383, -77.9019393920898, -1.35964533608104, 218, 33, 'PPL', 'P'),
(7541, 'Blocher', 34.6875, 0.605411084285533, -92.9066696166992, -1.62152728187398, 218, 4, 'PPL', 'P'),
(29228, 'Blocher', 38.7180595397949, 0.675757618952622, -85.6566696166992, -1.49499091110439, 218, 19, 'PPL', 'P'),
(26544, 'Block', 39.9683303833008, 0.697578961713486, -88.085563659668, -1.53738310933627, 218, 18, 'PPL', 'P'),
(31843, 'Block', 38.5050010681152, 0.672039047122544, -94.8077774047852, -1.65470787221139, 218, 20, 'PPL', 'P'),
(85128, 'Block', 36.3419418334961, 0.634286541562772, -84.2547225952148, -1.47052231964096, 218, 50, 'PPL', 'P'),
(85129, 'Block City', 36.5422210693359, 0.637782073651555, -82.6774978637695, -1.44299455503336, 218, 50, 'PPL', 'P'),
(371, 'Blocker', 30.5872192382813, 0.53384768473736, -84.2736129760742, -1.47085201898391, 218, 12, 'PPL', 'P'),
(75156, 'Blocker', 35.0613899230957, 0.611936694483581, -95.5680618286133, -1.66797733865881, 218, 42, 'PPL', 'P'),
(85130, 'Blockhouse', 35.7030601501465, 0.623135952657637, -83.9366683959961, -1.4649712266648, 218, 50, 'PPL', 'P'),
(206854, 'Blockhouse', 45.8397216796875, 0.800054071508372, -120.936393737793, -2.11073825621274, 218, 56, 'PPL', 'P'),
(114635, 'Blockly', 40.6597213745117, 0.709646010928744, -93.7547225952148, -1.63632859858042, 218, 16, 'PPL', 'P'),
(193386, 'Blocksburg', 40.2761116027832, 0.702950757369258, -123.635276794434, -2.15784265167741, 218, 6, 'PPL', 'P'),
(114636, 'Blockton', 40.6155586242676, 0.708875225530248, -94.476936340332, -1.64893360633588, 218, 16, 'PPL', 'P'),
(930, 'Blockton Junc', 33.2088890075684, 0.57960445411142, -87.1433334350586, -1.52093808960503, 218, 2, 'PPL', 'P'),
(44897, 'Blocktown', 39.1949996948242, 0.684081794992855, -77.3266677856445, -1.34960495245533, 218, 25, 'PPL', 'P'),
(154355, 'Blocktown (historical)', 40.746940612793, 0.711168273807833, -83.6908264160156, -1.46068047467452, 218, 41, 'PPL', 'P'),
(147249, 'Blockville', 42.0816688537598, 0.734463676232056, -79.4124984741211, -1.38600956560839, 218, 40, 'PPL', 'P'),
(108264, 'Blocton', 37.7966690063477, 0.65967632044726, -82.3422164916992, -1.43714279117013, 218, 58, 'PPL', 'P'),
(931, 'Blocton (historical)', 33.1130599975586, 0.577931922367823, -87.1041717529297, -1.52025458931126, 218, 2, 'PPL', 'P'),
(31844, 'Blodgett', 37.625560760498, 0.656689918179873, -96.4627838134766, -1.68359318318466, 218, 20, 'PPL', 'P'),
(53528, 'Blodgett', 37.0041694641113, 0.645844594114688, -89.5269393920898, -1.56253986162538, 218, 29, 'PPL', 'P'),
(58699, 'Blodgett', 31.461389541626, 0.549104834753883, -88.9863891601563, -1.55310548030572, 218, 30, 'PPL', 'P'),
(92689, 'Blodgett', 33.0683288574219, 0.577151216694266, -95.1086120605469, -1.65995842745853, 218, 51, 'PPL', 'P'),
(118833, 'Blodgett', 41.377498626709, 0.722173587275504, -88.1900024414063, -1.53920590994438, 218, 18, 'PPL', 'P'),
(200424, 'Blodgett', 44.5972213745117, 0.778368350226021, -123.518333435059, -2.15580160501797, 218, 43, 'PPL', 'P'),
(143530, 'Blodgett Landing', 43.3736114501953, 0.757012328286621, -72.0425033569336, -1.25737888495756, 218, 36, 'PPL', 'P'),
(147248, 'Blodgett Mills', 42.5683288574219, 0.742957495633728, -76.126106262207, -1.32865120099859, 218, 40, 'PPL', 'P'),
(129861, 'Blom', 45.6511116027832, 0.796762204663953, -87.7380599975586, -1.53131802626973, 218, 27, 'PPL', 'P'),
(53526, 'Blomeyer', 37.2238883972168, 0.649679412926348, -89.6597213745117, -1.56485734440597, 218, 29, 'PPL', 'P'),
(134308, 'Blomford', 45.5002784729004, 0.794129669926409, -93.142219543457, -1.62563840364873, 218, 28, 'PPL', 'P'),
(134309, 'Blomkest', 44.9427795410156, 0.784399477988669, -95.023063659668, -1.65846532619338, 218, 28, 'PPL', 'P'),
(39407, 'Blond', 30.5972194671631, 0.534022221657301, -90.1011123657227, -1.57256107049124, 218, 22, 'PPL', 'P'),
(85131, 'Blondy', 35.5602798461914, 0.620643966246623, -87.5327835083008, -1.52773527565524, 218, 50, 'PPL', 'P'),
(143529, 'Blood (historical)', 42.7966690063477, 0.746942783046977, -71.5183334350586, -1.24823039398092, 218, 36, 'PPL', 'P'),
(13039, 'Bloodfield (historical)', 38.9097213745117, 0.679102749018843, -77.0277786254883, -1.34438835251208, 218, 9, 'PPL', 'P'),
(188160, 'Bloodgood Place', 33.0513916015625, 0.576855605813267, -107.969169616699, -1.88441750045563, 218, 38, 'PPL', 'P'),
(53527, 'Bloodland', 37.6872215270996, 0.657766101576374, -92.1519393920898, -1.60835475449023, 218, 29, 'PPL', 'P'),
(29229, 'Bloods Wood Crossing', 38.5386085510254, 0.672625608352634, -87.6302795410156, -1.52943690243375, 218, 19, 'PPL', 'P'),
(19338, 'Bloodtown', 34.6261100769043, 0.604339627999967, -84.6888885498047, -1.47809994504862, 218, 13, 'PPL', 'P'),
(154356, 'Bloody Corners', 41.1175003051758, 0.717635760515091, -81.121940612793, -1.41584495930054, 218, 41, 'PPL', 'P'),
(58700, 'Bloody Springs', 34.5883293151855, 0.603680229314063, -88.1408309936523, -1.5383477062831, 218, 30, 'PPL', 'P'),
(31845, 'Bloom', 37.4863891601563, 0.654260915528639, -99.8958282470703, -1.74351111191813, 218, 20, 'PPL', 'P'),
(44879, 'Bloom', 39.4780616760254, 0.689022158552034, -77.029167175293, -1.344412587278, 218, 25, 'PPL', 'P'),
(139690, 'Bloom', 46.916389465332, 0.818845469318026, -98.6125030517578, -1.72111286188613, 218, 34, 'PPL', 'P'),
(186424, 'Bloom', 37.6875, 0.657770961845363, -103.956108093262, -1.81437636378654, 218, 7, 'PPL', 'P'),
(192489, 'Bloom', 38.9336090087891, 0.679519666887495, -112.808059692383, -1.96887206441838, 218, 52, 'PPL', 'P'),
(99993, 'Bloom (historical)', 39.1469383239746, 0.683242965828508, -78.3736114501953, -1.36787756648464, 218, 53, 'PPL', 'P'),
(154358, 'Bloom Center', 41.2108306884766, 0.719264682995838, -83.5927810668945, -1.45896926051609, 218, 41, 'PPL', 'P'),
(173220, 'Bloom City', 43.4944381713867, 0.7591211523958, -90.4647216796875, -1.57890725021084, 218, 57, 'PPL', 'P'),
(99997, 'Bloom Crossing', 38.7641716003418, 0.676562426234044, -77.4430618286133, -1.35163641173484, 218, 53, 'PPL', 'P'),
(99994, 'Bloom Hill', 38.7200012207031, 0.675791507677493, -77.4824981689453, -1.35232470571857, 218, 53, 'PPL', 'P'),
(71842, 'Bloom Junction', 38.8058280944824, 0.677289469211635, -82.6927795410156, -1.44326127061653, 218, 41, 'PPL', 'P'),
(71843, 'Bloom Rose (historical)', 39.1041717529297, 0.682496548353986, -83.9986114501953, -1.46605233690932, 218, 41, 'PPL', 'P'),
(92692, 'Bloomburg', 33.1377792358398, 0.578363354464416, -94.0572204589844, -1.64160818228345, 218, 51, 'PPL', 'P'),
(159307, 'Bloomburg Village', 40.2999992370605, 0.703367675237909, -76.8150024414063, -1.34067470753002, 218, 45, 'PPL', 'P'),
(92690, 'Bloomdale', 33.2472190856934, 0.580273440177248, -96.6791687011719, -1.6873698119265, 218, 51, 'PPL', 'P'),
(154361, 'Bloomdale', 41.1725006103516, 0.71859569693001, -83.5563888549805, -1.4583340965961, 218, 41, 'PPL', 'P'),
(7542, 'Bloomer', 35.2938919067383, 0.615994619615562, -94.1386108398438, -1.6430287124089, 218, 4, 'PPL', 'P'),
(122242, 'Bloomer', 40.0838890075684, 0.69959584018603, -85.7680587768555, -1.49693501870015, 218, 19, 'PPL', 'P'),
(154362, 'Bloomer', 40.1877784729004, 0.701409053414211, -84.413330078125, -1.47329054243604, 218, 41, 'PPL', 'P'),
(173222, 'Bloomer', 45.1002807617188, 0.787148392865848, -91.4886093139648, -1.59677746059944, 218, 57, 'PPL', 'P'),
(180134, 'Bloomer (historical)', 39.624439239502, 0.691576928985747, -121.490280151367, -2.12040539781167, 218, 6, 'PPL', 'P'),
(99995, 'Bloomer Spring', 38.4144401550293, 0.670458461015582, -78.6975021362305, -1.37353052537249, 218, 53, 'PPL', 'P'),
(147250, 'Bloomerville', 42.4308280944824, 0.74055765459643, -77.4599990844727, -1.35193202261584, 218, 40, 'PPL', 'P'),
(44880, 'Bloomery', 38.7666702270508, 0.676606035496894, -75.7263870239258, -1.32167478420701, 218, 25, 'PPL', 'P'),
(108267, 'Bloomery', 39.3869400024414, 0.687431785328066, -78.3733291625977, -1.36787263963662, 218, 58, 'PPL', 'P'),
(7544, 'Bloomfield', 36.2761116027832, 0.633137587289484, -94.5380630493164, -1.65000046866856, 218, 4, 'PPL', 'P'),
(34865, 'Bloomfield', 37.9102783203125, 0.661659177036879, -85.3166732788086, -1.48905685556348, 218, 21, 'PPL', 'P'),
(44882, 'Bloomfield', 38.7769393920898, 0.676785266238256, -76.1072235107422, -1.32832163481369, 218, 25, 'PPL', 'P'),
(53529, 'Bloomfield', 36.8858299255371, 0.643779179531277, -89.9291687011719, -1.56956008741688, 218, 29, 'PPL', 'P'),
(58703, 'Bloomfield', 32.7947196960449, 0.572375835964618, -88.7386093139648, -1.54878090616959, 218, 30, 'PPL', 'P'),
(63012, 'Bloomfield', 35.7905616760254, 0.624663142384743, -80.9161071777344, -1.41225248814808, 218, 33, 'PPL', 'P'),
(92691, 'Bloomfield', 33.4444389343262, 0.583715575886175, -97.0152816772461, -1.69323609001767, 218, 51, 'PPL', 'P'),
(99996, 'Bloomfield', 39.0533294677734, 0.681609183078771, -77.8208312988281, -1.35822973280361, 218, 53, 'PPL', 'P'),
(114637, 'Bloomfield', 40.7516708374023, 0.711250831801626, -92.4147186279297, -1.61294111736151, 218, 16, 'PPL', 'P'),
(118836, 'Bloomfield', 40.0208282470703, 0.698495222286528, -91.3069381713867, -1.59360670100559, 218, 18, 'PPL', 'P'),
(122239, 'Bloomfield', 40.5116691589355, 0.707062012302067, -84.9738922119141, -1.48307419733267, 218, 19, 'PPL', 'P'),
(129863, 'Bloomfield', 42.5377807617188, 0.742424330783494, -83.2330627441406, -1.45269099140428, 218, 27, 'PPL', 'P'),
(141326, 'Bloomfield', 42.5988883972168, 0.743490860221043, -97.6452789306641, -1.70423161636834, 218, 35, 'PPL', 'P'),
(144851, 'Bloomfield', 40.8066711425781, 0.712210768216545, -74.1858291625977, -1.29478697720936, 218, 37, 'PPL', 'P'),
(147251, 'Bloomfield', 40.6124992370605, 0.708821829150392, -74.1786117553711, -1.2946610096898, 218, 40, 'PPL', 'P'),
(154364, 'Bloomfield', 40.0502815246582, 0.69900927895594, -81.7425003051758, -1.42667576913779, 218, 41, 'PPL', 'P'),
(159308, 'Bloomfield', 40.4608306884766, 0.70617471360588, -79.9511108398438, -1.3954101247822, 218, 45, 'PPL', 'P'),
(169855, 'Bloomfield', 44.6324996948242, 0.778984073070047, -98.0986099243164, -1.71214373480891, 218, 49, 'PPL', 'P'),
(171750, 'Bloomfield', 44.7538909912109, 0.781102750875259, -71.6327819824219, -1.25022789795653, 218, 55, 'PPL', 'P'),
(177511, 'Bloomfield', 41.8263893127441, 0.730008207728354, -72.7305603027344, -1.269387744103, 218, 8, 'PPL', 'P'),
(180136, 'Bloomfield', 38.3138885498047, 0.668703504436247, -122.849998474121, -2.14413695944342, 218, 6, 'PPL', 'P'),
(188161, 'Bloomfield', 36.711109161377, 0.640729726925082, -107.98388671875, -1.88467436234276, 218, 38, 'PPL', 'P'),
(196040, 'Bloomfield', 47.4127807617188, 0.827509131818217, -104.91667175293, -1.83114136232275, 218, 31, 'PPL', 'P'),
(129864, 'Bloomfield Hills', 42.583610534668, 0.743224211216899, -83.2455596923828, -1.45290910429756, 218, 27, 'PPL', 'P'),
(44883, 'Bloomfield Manor', 39.3738899230957, 0.687204018475837, -76.9899978637695, -1.34372895382618, 218, 25, 'PPL', 'P'),
(147252, 'Bloomfield Park', 43.2147216796875, 0.754239178643521, -75.4400024414063, -1.3166764303151, 218, 40, 'PPL', 'P'),
(141327, 'Bloomfield Trailer Court', 42.5988883972168, 0.743490860221043, -97.6452789306641, -1.70423161636834, 218, 35, 'PPL', 'P'),
(200425, 'Blooming', 45.4874992370605, 0.793906630185115, -123.050003051758, -2.14762769784224, 218, 43, 'PPL', 'P'),
(159312, 'Blooming Glen', 40.3694381713867, 0.704579613270977, -75.2486114501953, -1.31333602735981, 218, 45, 'PPL', 'P'),
(933, 'Blooming Grove', 33.7936096191406, 0.589809753987631, -87.9786071777344, -1.53551636657018, 218, 2, 'PPL', 'P'),
(29232, 'Blooming Grove', 39.5022201538086, 0.689443803531621, -85.0647201538086, -1.48465944397154, 218, 19, 'PPL', 'P'),
(85133, 'Blooming Grove', 36.1194381713867, 0.630403120061218, -88.5994415283203, -1.54635197009739, 218, 50, 'PPL', 'P'),
(92693, 'Blooming Grove', 32.0919418334961, 0.560110048353013, -96.7155609130859, -1.68800497584648, 218, 51, 'PPL', 'P'),
(147253, 'Blooming Grove', 41.4091682434082, 0.72272632635975, -74.195556640625, -1.29495675372885, 218, 40, 'PPL', 'P'),
(154367, 'Blooming Grove', 40.7077789306641, 0.710484773514064, -82.716667175293, -1.44367818848518, 218, 41, 'PPL', 'P'),
(159313, 'Blooming Grove', 41.3705596923828, 0.722052480024933, -75.1549987792969, -1.31170217803105, 218, 45, 'PPL', 'P'),
(134315, 'Blooming Prairie', 43.8666687011719, 0.765617800716994, -93.0508270263672, -1.62404330331383, 218, 28, 'PPL', 'P'),
(44884, 'Blooming Rose', 39.6566696166992, 0.692139455186999, -79.4394378662109, -1.38647974669884, 218, 25, 'PPL', 'P'),
(53530, 'Blooming Rose', 37.6127815246582, 0.656466878438578, -91.9725036621094, -1.60522301020635, 218, 29, 'PPL', 'P'),
(159315, 'Blooming Valley', 41.6811103820801, 0.727472612054489, -80.0411071777344, -1.39698085719313, 218, 45, 'PPL', 'P'),
(71849, 'Bloomingburg', 39.6049995422363, 0.691237642262871, -83.3955612182617, -1.45552712480716, 218, 41, 'PPL', 'P'),
(147255, 'Bloomingburg', 41.5541687011719, 0.725257061764625, -74.4400024414063, -1.29922313779516, 218, 40, 'PPL', 'P'),
(13040, 'Bloomingdale', 38.9166717529297, 0.679224056006496, -77.0116729736328, -1.34410725585902, 218, 9, 'PPL', 'P'),
(15254, 'Bloomingdale', 27.8933296203613, 0.486830441219365, -82.2405624389648, -1.43536859325191, 218, 12, 'PPL', 'P'),
(19344, 'Bloomingdale', 32.1322212219238, 0.560813056301766, -81.2991714477539, -1.41893822090667, 218, 13, 'PPL', 'P'),
(29234, 'Bloomingdale', 39.8333282470703, 0.695222729939038, -87.2497177124023, -1.52279484551704, 218, 19, 'PPL', 'P'),
(34862, 'Bloomingdale', 37.8869400024414, 0.661251846548151, -84.1269378662109, -1.46829205538607, 218, 21, 'PPL', 'P'),
(44885, 'Bloomingdale', 38.9724998474121, 0.680198440070329, -76.1236114501953, -1.32860765831476, 218, 25, 'PPL', 'P'),
(63008, 'Bloomingdale', 34.440559387207, 0.601101157535403, -79.0205612182617, -1.37916897003241, 218, 33, 'PPL', 'P'),
(85134, 'Bloomingdale', 36.5844383239746, 0.638518903746153, -82.4894409179688, -1.43971234214789, 218, 50, 'PPL', 'P'),
(118837, 'Bloomingdale', 41.9575004577637, 0.732296528895004, -88.0808334350586, -1.53730055134248, 218, 18, 'PPL', 'P'),
(124265, 'Bloomingdale', 42.2638893127441, 0.737644023205829, -71.7708282470703, -1.25263725979473, 218, 23, 'PPL', 'P'),
(129869, 'Bloomingdale', 42.3827781677246, 0.739719025169164, -85.9569396972656, -1.5002316126555, 218, 27, 'PPL', 'P'),
(144854, 'Bloomingdale', 40.497501373291, 0.706814737794853, -74.6477813720703, -1.30284956425152, 218, 37, 'PPL', 'P'),
(147256, 'Bloomingdale', 44.4077796936035, 0.77506196915366, -74.0875015258789, -1.29307083620291, 218, 40, 'PPL', 'P'),
(154368, 'Bloomingdale', 40.3427810668945, 0.70411435902854, -80.8183288574219, -1.41054593452156, 218, 41, 'PPL', 'P'),
(159319, 'Bloomingdale', 41.2383308410645, 0.719744651203297, -76.1988906860352, -1.32992152883855, 218, 45, 'PPL', 'P'),
(169854, 'Bloomingdale', 42.9244384765625, 0.749172780985754, -96.9563903808594, -1.69220824299496, 218, 49, 'PPL', 'P'),
(173228, 'Bloomingdale', 43.6430587768555, 0.761715071297537, -90.7774963378906, -1.58436619781329, 218, 57, 'PPL', 'P'),
(122241, 'Bloomingport', 40.0269393920898, 0.698601881888185, -84.9947204589844, -1.48343771882146, 218, 19, 'PPL', 'P'),
(108268, 'Bloomingrose', 38.1425018310547, 0.66571224189987, -81.6333312988281, -1.42477041053589, 218, 58, 'PPL', 'P'),
(29235, 'Bloomington', 39.1652793884277, 0.683563077791535, -86.5263900756836, -1.51017039668562, 218, 19, 'PPL', 'P'),
(31851, 'Bloomington', 39.4516716003418, 0.688561564841505, -98.7866668701172, -1.72415259395435, 218, 20, 'PPL', 'P'),
(34863, 'Bloomington', 37.8169403076172, 0.660030121398077, -83.144172668457, -1.45113956691125, 218, 21, 'PPL', 'P'),
(44886, 'Bloomington', 39.4799995422363, 0.689055980697878, -79.0713882446289, -1.38005606899151, 218, 25, 'PPL', 'P'),
(53531, 'Bloomington', 39.7969398498535, 0.694587632598082, -92.5599975585938, -1.61547671303537, 218, 29, 'PPL', 'P'),
(63009, 'Bloomington', 35.3325004577637, 0.61666846595038, -80.3055572509766, -1.40159638167835, 218, 33, 'PPL', 'P'),
(71850, 'Bloomington', 39.5369415283203, 0.690049805837668, -83.7063903808594, -1.46095211710571, 218, 41, 'PPL', 'P'),
(75157, 'Bloomington', 35.0016708374023, 0.610894399811952, -99.6305618286133, -1.73888133952108, 218, 42, 'PPL', 'P'),
(85135, 'Bloomington', 36.5802803039551, 0.638446332606448, -85.1927795410156, -1.48689450191639, 218, 50, 'PPL', 'P'),
(92694, 'Bloomington', 28.6474990844727, 0.499993181486109, -96.892219543457, -1.69108825059852, 218, 51, 'PPL', 'P'),
(114642, 'Bloomington', 42.0561103820801, 0.734017596749468, -93.5872192382813, -1.63340511349379, 218, 16, 'PPL', 'P'),
(118839, 'Bloomington', 40.4841690063477, 0.706582044094608, -88.9936065673828, -1.55323144782528, 218, 18, 'PPL', 'P'),
(134318, 'Bloomington', 44.8408317565918, 0.782620153485359, -93.2980575561523, -1.62835829007003, 218, 28, 'PPL', 'P'),
(141329, 'Bloomington', 40.0941696166992, 0.699775270664474, -99.0366668701172, -1.72851591708433, 218, 35, 'PPL', 'P'),
(147257, 'Bloomington', 41.8788909912109, 0.730924534880423, -74.0444412231445, -1.29231929214329, 218, 40, 'PPL', 'P'),
(159325, 'Bloomington', 40.9388885498047, 0.714518397301098, -78.5175018310547, -1.37038892739258, 218, 45, 'PPL', 'P'),
(173229, 'Bloomington', 42.8852806091309, 0.748489347271013, -90.9233322143555, -1.58691151402513, 218, 57, 'PPL', 'P'),
(180135, 'Bloomington', 34.0702781677246, 0.594638531097135, -117.394996643066, -2.0489292167892, 218, 6, 'PPL', 'P'),
(192490, 'Bloomington', 37.0466690063477, 0.646586351057303, -113.605278015137, -1.98278614900766, 218, 52, 'PPL', 'P'),
(194615, 'Bloomington', 42.1919403076172, 0.736388276172829, -111.40055847168, -1.94430653389127, 218, 17, 'PPL', 'P'),
(7545, 'Bloomington (historical)', 35.5299987792969, 0.620115461928297, -92.3633270263672, -1.61204416470637, 218, 4, 'PPL', 'P'),
(108269, 'Bloomington (historical)', 38.5838890075684, 0.673415901406115, -81.2366714477539, -1.41784739012417, 218, 58, 'PPL', 'P'),
(134319, 'Bloomington Ferry', 44.7997207641602, 0.781902631308665, -93.3841705322266, -1.62986124503122, 218, 28, 'PPL', 'P'),
(85136, 'Bloomington Heights', 36.5622215270996, 0.638131147491437, -82.5427780151367, -1.44064325010693, 218, 50, 'PPL', 'P'),
(118841, 'Bloomington Heights', 40.4805603027344, 0.706519060334827, -89.0336074829102, -1.55392959550504, 218, 18, 'PPL', 'P'),
(192491, 'Bloomington Hills', 37.0602798461914, 0.646823905026538, -113.555282592773, -1.9819135642765, 218, 52, 'PPL', 'P'),
(85137, 'Bloomington Springs', 36.1963882446289, 0.631746152198945, -85.6202774047852, -1.49435574718441, 218, 50, 'PPL', 'P'),
(79833, 'Bloomingvale', 33.5502815246582, 0.585562877576309, -79.6069412231445, -1.38940323178547, 218, 48, 'PPL', 'P'),
(154370, 'Bloomingville', 41.3549995422363, 0.721780904172772, -82.7272186279297, -1.44386234607456, 218, 41, 'PPL', 'P'),
(29237, 'Blooms Eddy (historical)', 38.2861099243164, 0.668218675959798, -85.772216796875, -1.49700758983985, 218, 19, 'PPL', 'P'),
(159322, 'Bloomsburg', 41.0036087036133, 0.715647977077456, -76.4552764892578, -1.33439630526016, 218, 45, 'PPL', 'P'),
(44887, 'Bloomsbury', 39.2638893127441, 0.685284145645999, -76.7300033569336, -1.33919119364479, 218, 25, 'PPL', 'P'),
(144856, 'Bloomsbury', 40.6538887023926, 0.709544211596076, -75.0869369506836, -1.31051427502682, 218, 37, 'PPL', 'P'),
(53533, 'Bloomsdale', 38.0094413757324, 0.663389898850294, -90.2177810668945, -1.57459732346071, 218, 29, 'PPL', 'P'),
(159324, 'Bloomsdorf', 40.7566719055176, 0.711338116906353, -77.8833312988281, -1.3593205635861, 218, 45, 'PPL', 'P'),
(79834, 'Bloomville', 33.6347198486328, 0.587036604344531, -80.1616668701172, -1.3990850207704, 218, 48, 'PPL', 'P'),
(147258, 'Bloomville', 42.3333282470703, 0.738855961238897, -74.8080596923828, -1.30564694866054, 218, 40, 'PPL', 'P'),
(154371, 'Bloomville', 41.0519409179688, 0.716491533352738, -83.0149993896484, -1.44888506789045, 218, 41, 'PPL', 'P'),
(173232, 'Bloomville', 45.2933311462402, 0.790517757697989, -89.5274963378906, -1.56254958216336, 218, 57, 'PPL', 'P'),
(34864, 'Bloss', 37.2163887023926, 0.649548518558771, -84.3600006103516, -1.47235976763506, 218, 21, 'PPL', 'P'),
(936, 'Blossburg', 33.6305618286133, 0.586964033204827, -86.9466705322266, -1.51750567443408, 218, 2, 'PPL', 'P'),
(159327, 'Blossburg', 41.6794395446777, 0.727443450440553, -77.0641708374023, -1.34502351643207, 218, 45, 'PPL', 'P'),
(196041, 'Blossburg', 46.6327781677246, 0.813895518378923, -112.321113586426, -1.96037325158967, 218, 31, 'PPL', 'P'),
(53534, 'Blosser (historical)', 39.1944389343262, 0.684072007875849, -93.2827835083008, -1.62809170764492, 218, 29, 'PPL', 'P'),
(77887, 'Blosser Hill', 39.7458305358887, 0.69369560679096, -79.897216796875, -1.39446949628519, 218, 45, 'PPL', 'P'),
(159329, 'Blosserville', 40.2400016784668, 0.70232052029729, -77.3625030517578, -1.35023039583734, 218, 45, 'PPL', 'P'),
(7546, 'Blossom', 34.9311103820801, 0.609662887544872, -91.0455627441406, -1.58904483921634, 218, 4, 'PPL', 'P'),
(79835, 'Blossom', 33.9463882446289, 0.592476244029073, -79.5727767944336, -1.38880695001741, 218, 48, 'PPL', 'P'),
(85138, 'Blossom', 36.461109161377, 0.636366403795096, -82.751106262207, -1.44427926394321, 218, 50, 'PPL', 'P'),
(92695, 'Blossom', 33.6613883972168, 0.58750205832405, -95.3855590820313, -1.66479206483703, 218, 51, 'PPL', 'P'),
(147259, 'Blossom', 42.8561096191406, 0.747980217449617, -78.6933288574219, -1.37345768791668, 218, 40, 'PPL', 'P'),
(19345, 'Blossom (historical)', 33.5999984741211, 0.586430602038484, -84.0747222900391, -1.46738072166105, 218, 13, 'PPL', 'P'),
(159330, 'Blossom Hill', 40.0900001525879, 0.699702499787688, -76.3208312988281, -1.33204979402369, 218, 45, 'PPL', 'P'),
(44889, 'Blossom Hills', 39.1266708374023, 0.682889231456718, -76.5177764892578, -1.33548713604266, 218, 25, 'PPL', 'P'),
(180137, 'Blossom Valley', 32.8638916015625, 0.573583113465778, -116.859718322754, -2.0395868476852, 218, 6, 'PPL', 'P'),
(63010, 'Blossomtown', 35.1502799987793, 0.613488118976607, -83.3936080932617, -1.45549303634521, 218, 33, 'PPL', 'P'),
(147260, 'Blossvale', 43.2797203063965, 0.755373618688868, -75.6438903808594, -1.32023494616366, 218, 40, 'PPL', 'P'),
(159331, 'Blough', 40.1716690063477, 0.701127890182126, -78.908332824707, -1.37721021505066, 218, 45, 'PPL', 'P'),
(19346, 'Blount', 33.1802787780762, 0.57910511140703, -83.9594421386719, -1.46536870345749, 218, 13, 'PPL', 'P'),
(63011, 'Blount', 35.916389465332, 0.62685925159865, -76.600830078125, -1.33693669462399, 218, 33, 'PPL', 'P'),
(108270, 'Blount', 38.3211097717285, 0.668829538534835, -81.4266662597656, -1.42116342515549, 218, 58, 'PPL', 'P'),
(85139, 'Blount Beach', 35.7833290100098, 0.624536908549073, -83.8958282470703, -1.46425843159904, 218, 50, 'PPL', 'P'),
(942, 'Blount Landing', 31.6361103057861, 0.552154287360078, -88.0872192382813, -1.5374120046341, 218, 2, 'PPL', 'P'),
(943, 'Blount Springs', 33.9311103820801, 0.592209595024929, -86.7941665649414, -1.5148439780826, 218, 2, 'PPL', 'P'),
(63013, 'Blounts Creek', 35.3497200012207, 0.616969003679395, -76.9602813720703, -1.34321030320389, 218, 33, 'PPL', 'P'),
(58702, 'Blounts Store', 32.4072189331055, 0.565612671797334, -89.0444412231445, -1.55411867994244, 218, 30, 'PPL', 'P'),
(15257, 'Blountstown', 30.4433307647705, 0.531336357118929, -85.045280456543, -1.48432015724866, 218, 12, 'PPL', 'P'),
(945, 'Blountsville', 34.0813903808594, 0.59483247580352, -86.5911102294922, -1.51129997646198, 218, 2, 'PPL', 'P'),
(19347, 'Blountsville', 33.1097183227539, 0.57787359913995, -83.4819412231445, -1.45703474030025, 218, 13, 'PPL', 'P'),
(122243, 'Blountsville', 40.060001373291, 0.699178922317378, -85.2402801513672, -1.48772354396373, 218, 19, 'PPL', 'P'),
(79836, 'Blountville', 32.6963882446289, 0.570659628379144, -80.8516693115234, -1.41112783521974, 218, 48, 'PPL', 'P'),
(85141, 'Blountville', 36.5330581665039, 0.637622150828096, -82.3269424438477, -1.43687620874501, 218, 50, 'PPL', 'P'),
(950, 'Blow Gourd', 33.9466705322266, 0.592481170877089, -86.5858306884766, -1.51120783108826, 218, 2, 'PPL', 'P'),
(7547, 'Blowing Cave (historical)', 35.8222198486328, 0.625215681731907, -91.658332824707, -1.59973969467993, 218, 4, 'PPL', 'P'),
(63014, 'Blowing Rock', 36.1349983215332, 0.630674695913379, -81.6777801513672, -1.42554618936143, 218, 33, 'PPL', 'P'),
(99998, 'Blowing Rock', 37.226390838623, 0.649723088768225, -82.4308319091797, -1.43868942197319, 218, 53, 'PPL', 'P'),
(63015, 'Blowing Rock Estates', 36.1127815246582, 0.630286939658663, -81.6597213745117, -1.42523100424642, 218, 33, 'PPL', 'P'),
(15255, 'Blowing Rocks', 26.9766693115234, 0.470831700707796, -80.0819396972656, -1.39769351910084, 218, 12, 'PPL', 'P'),
(19348, 'Blowing Spring', 34.9741706848145, 0.610414431604492, -85.3375015258789, -1.48942037705227, 218, 13, 'PPL', 'P'),
(85142, 'Blowing Springs', 36.1349983215332, 0.630674695913379, -84.1511077880859, -1.46871390010274, 218, 50, 'PPL', 'P'),
(92696, 'Blowout', 30.4469394683838, 0.531399340878709, -98.5772171020508, -1.72049700588405, 218, 51, 'PPL', 'P'),
(159332, 'Blowtown', 41.2958297729492, 0.720748196881066, -78.9349975585938, -1.37767560245115, 218, 45, 'PPL', 'P'),
(805, 'Blowville', 39.0974998474121, 0.682380101635322, -84.0449981689453, -1.4668619378807, 218, 41, 'PPL', 'P'),
(92697, 'Blox', 30.9738903045654, 0.540596367966216, -93.9749984741211, -1.64017313793006, 218, 51, 'PPL', 'P'),
(15256, 'Bloxham', 30.3883304595947, 0.53037642070401, -84.6308288574219, -1.47708661225384, 218, 12, 'PPL', 'P'),
(99999, 'Bloxom', 37.8294410705566, 0.660248300870382, -75.6236114501953, -1.31988101205479, 218, 53, 'PPL', 'P'),
(100000, 'Bloxoms Corner', 37.059440612793, 0.646809257640542, -76.3005599975586, -1.33169599307287, 218, 53, 'PPL', 'P'),
(34866, 'Bloyd', 37.4052810668945, 0.652845312251207, -85.5758285522461, -1.49357996835887, 218, 21, 'PPL', 'P'),
(34867, 'Bloyds Crossing', 37.3605613708496, 0.652064806314732, -85.5727767944336, -1.49352670513707, 218, 21, 'PPL', 'P'),
(29238, 'Blue', 38.9249992370605, 0.679369398022987, -85.0047225952148, -1.48361228903092, 218, 19, 'PPL', 'P'),
(75159, 'Blue', 33.9963912963867, 0.593348961918292, -96.2297210693359, -1.67952547093567, 218, 42, 'PPL', 'P'),
(92698, 'Blue', 30.3916702270508, 0.530434710642369, -97.147216796875, -1.69553879225421, 218, 51, 'PPL', 'P'),
(108271, 'Blue', 39.4474983215332, 0.688488727385691, -80.8255615234375, -1.41067216835723, 218, 58, 'PPL', 'P'),
(177749, 'Blue', 33.6100006103516, 0.586605172247939, -109.106109619141, -1.90426084689586, 218, 5, 'PPL', 'P'),
(70555, 'Blue Anchor', 39.6894416809082, 0.692711435610121, -74.883056640625, -1.30695589233631, 218, 37, 'PPL', 'P'),
(71851, 'Blue Ash', 39.2319412231445, 0.684726546292763, -84.3783264160156, -1.47267961328198, 218, 41, 'PPL', 'P'),
(7548, 'Blue Ball', 34.9622192382813, 0.610205839512112, -93.7083282470703, -1.63551886445098, 218, 4, 'PPL', 'P'),
(13399, 'Blue Ball', 39.7772216796875, 0.694243485606216, -75.5449981689453, -1.31850895146118, 218, 10, 'PPL', 'P'),
(71853, 'Blue Ball', 39.4933280944824, 0.689288607819097, -84.3363876342773, -1.47194764345637, 218, 41, 'PPL', 'P'),
(159334, 'Blue Ball', 40.1186103820801, 0.700201842492078, -76.0475006103516, -1.32727927356303, 218, 45, 'PPL', 'P'),
(44890, 'Blue Ball Village', 39.7000007629395, 0.692895726357554, -75.9372177124023, -1.32535447388518, 218, 25, 'PPL', 'P'),
(85143, 'Blue Bank', 36.3516693115234, 0.634456318082264, -89.4250030517578, -1.56076073685915, 218, 50, 'PPL', 'P'),
(7549, 'Blue Bayou', 33.9694404602051, 0.592878581090756, -93.9555587768555, -1.63983385120718, 218, 4, 'PPL', 'P'),
(70556, 'Blue Bell', 39.5719413757324, 0.690660668412705, -74.9744415283203, -1.30855085951316, 218, 37, 'PPL', 'P'),
(159335, 'Blue Bell', 40.1522216796875, 0.700788470301195, -75.2666702270508, -1.31365121247482, 218, 45, 'PPL', 'P'),
(201919, 'Blue Bell', 43.7166709899902, 0.762999846786419, -103.481941223145, -1.80610059069912, 218, 49, 'PPL', 'P'),
(177750, 'Blue Bell Mobile Home Park', 33.4377784729004, 0.583599328904593, -112.126670837402, -1.95697958541258, 218, 5, 'PPL', 'P'),
(108272, 'Blue Bend', 37.9216690063477, 0.661857982012253, -80.2688903808594, -1.4009564240684, 218, 58, 'PPL', 'P'),
(92699, 'Blue Berry Hill', 28.3886108398438, 0.495474729222626, -97.7819366455078, -1.70661674344061, 218, 51, 'PPL', 'P'),
(92700, 'Blue Berry Hill Colonia', 28.3889999389648, 0.495481520283406, -97.7779998779297, -1.70654803388449, 218, 51, 'PPL', 'P'),
(114645, 'Blue Bird Mobile Park', 41.6161117553711, 0.726338172009143, -93.7111129760742, -1.63556746714088, 218, 16, 'PPL', 'P'),
(53535, 'Blue Branch', 38.2355613708496, 0.667336437269682, -93.3569412231445, -1.62938600393469, 218, 29, 'PPL', 'P'),
(79837, 'Blue Brick', 34.223331451416, 0.597309814828539, -79.5180587768555, -1.3878519404505, 218, 48, 'PPL', 'P'),
(180139, 'Blue Canyon', 39.2572212219238, 0.685167765506362, -120.709999084473, -2.10678692410339, 218, 6, 'PPL', 'P'),
(206855, 'Blue Canyon', 48.6824989318848, 0.849669894460012, -122.276107788086, -2.13412067742558, 218, 56, 'PPL', 'P'),
(196042, 'Blue Cloud (historical)', 46.5916709899902, 0.813178062781256, -112.158332824707, -1.95753219133877, 218, 31, 'PPL', 'P'),
(960, 'Blue Creek', 32.7361106872559, 0.571352915789918, -85.7880630493164, -1.49728415911906, 218, 2, 'PPL', 'P'),
(19349, 'Blue Creek', 33.6652793884277, 0.587569968931847, -84.3002777099609, -1.4713174063844, 218, 13, 'PPL', 'P'),
(71854, 'Blue Creek', 38.7775001525879, 0.676795053355262, -83.3302764892578, -1.45438769133477, 218, 41, 'PPL', 'P'),
(85144, 'Blue Creek', 35.3347206115723, 0.61670721494424, -86.9194412231445, -1.51703043333756, 218, 50, 'PPL', 'P'),
(108273, 'Blue Creek', 38.4505615234375, 0.671088897824631, -81.4574966430664, -1.42170151685374, 218, 58, 'PPL', 'P'),
(203060, 'Blue Creek', 41.8622207641602, 0.730633584531331, -112.456108093262, -1.96272935020606, 218, 52, 'PPL', 'P'),
(19350, 'Blue Creek Forest', 33.6722183227539, 0.587691076182418, -84.3000030517578, -1.47131261269444, 218, 13, 'PPL', 'P'),
(962, 'Blue Creek Junction', 33.4124984741211, 0.583158109690994, -86.9658279418945, -1.51784003430894, 218, 2, 'PPL', 'P'),
(34868, 'Blue Diamond', 37.3077812194824, 0.651143618893674, -83.2158279418945, -1.45239018735916, 218, 21, 'PPL', 'P'),
(189947, 'Blue Diamond', 36.0463905334473, 0.62912819826837, -115.403060913086, -2.01416337981292, 218, 39, 'PPL', 'P'),
(44891, 'Blue Dolphin Estates', 38.4666709899902, 0.671370061056716, -76.5599975585938, -1.33622403271628, 218, 25, 'PPL', 'P'),
(194616, 'Blue Dome', 44.1602783203125, 0.770742255286524, -112.91056060791, -1.97066104288064, 218, 17, 'PPL', 'P'),
(134322, 'Blue Earth', 43.6375007629395, 0.761618065654831, -94.101936340332, -1.6423886216409, 218, 28, 'PPL', 'P'),
(968, 'Blue Eye', 33.601390838623, 0.586454903383431, -86.1344375610352, -1.50332953479354, 218, 2, 'PPL', 'P'),
(7553, 'Blue Eye', 36.4977798461914, 0.63700642798407, -93.3977813720703, -1.63009879900045, 218, 4, 'PPL', 'P'),
(53536, 'Blue Eye', 36.4986114501953, 0.637020942212011, -93.3966674804688, -1.6300793579245, 218, 29, 'PPL', 'P'),
(969, 'Blue Eye (historical)', 33.6472206115723, 0.587254783816836, -86.0208282470703, -1.50134667820392, 218, 2, 'PPL', 'P'),
(974, 'Blue Ford Landing', 31.163610458374, 0.543907609307566, -87.9733276367188, -1.53542422119646, 218, 2, 'PPL', 'P'),
(34870, 'Blue Gap', 37.6877784729004, 0.657775822114352, -85.565559387207, -1.4934007376175, 218, 21, 'PPL', 'P'),
(177753, 'Blue Gap', 36.1708297729492, 0.631300072716357, -109.945831298828, -1.91891675500678, 218, 5, 'PPL', 'P'),
(85145, 'Blue Gem', 35.9963912963867, 0.628255546958178, -84.4527816772461, -1.47397910273588, 218, 50, 'PPL', 'P'),
(85146, 'Blue Goose', 35.7033309936523, 0.623140679768572, -88.5766677856445, -1.54595449330469, 218, 50, 'PPL', 'P'),
(159336, 'Blue Goose', 40.5855598449707, 0.708351648059938, -78.8188934326172, -1.37564920317771, 218, 45, 'PPL', 'P'),
(85147, 'Blue Goose (historical)', 34.9952812194824, 0.610782879941305, -90.2188873291016, -1.57461663137862, 218, 50, 'PPL', 'P'),
(34869, 'Blue Grass', 37.8474998474121, 0.660563485985393, -84.3352813720703, -1.47192833553847, 218, 21, 'PPL', 'P'),
(85148, 'Blue Grass', 35.8647193908691, 0.625957438674522, -84.0597229003906, -1.46711893292589, 218, 50, 'PPL', 'P'),
(100003, 'Blue Grass', 38.5, 0.671951762017817, -79.5500030517578, -1.38840947322471, 218, 53, 'PPL', 'P'),
(114646, 'Blue Grass', 41.5088882446289, 0.724466768711144, -90.7658309936523, -1.58416259914795, 218, 16, 'PPL', 'P'),
(134326, 'Blue Grass', 46.542781829834, 0.812324785967994, -95.0097198486328, -1.65823243275605, 218, 28, 'PPL', 'P'),
(159337, 'Blue Grass', 40.065559387207, 0.699275927960084, -75.0277786254883, -1.3094817674722, 218, 45, 'PPL', 'P'),
(118845, 'Blue Grass (historical)', 40.3574981689453, 0.704371220915679, -87.8258285522461, -1.53284987652874, 218, 18, 'PPL', 'P'),
(203061, 'Blue Grass Acres', 40.6288909912109, 0.709107919230493, -111.85221862793, -1.95218949071791, 218, 52, 'PPL', 'P'),
(44892, 'Blue Grass Manor', 39.5663909912109, 0.690563795928054, -76.8600006103516, -1.34146007373549, 218, 25, 'PPL', 'P'),
(15263, 'Blue Gulf Beach', 30.3411102294922, 0.529552272215171, -86.2058334350586, -1.50457562786759, 218, 12, 'PPL', 'P'),
(79838, 'Blue Heaven', 34.4147186279297, 0.600650151204798, -82.2680587768555, -1.43584849488035, 218, 48, 'PPL', 'P'),
(34871, 'Blue Heron', 36.6713905334473, 0.640036506093335, -84.5455627441406, -1.47559843783671, 218, 21, 'PPL', 'P'),
(79840, 'Blue Heron Bluff', 32.4394416809082, 0.566175064840532, -80.647216796875, -1.40755946567514, 218, 48, 'PPL', 'P'),
(15258, 'Blue Heron Pines', 26.8824996948242, 0.469188130841053, -81.9936065673828, -1.43105840018568, 218, 12, 'PPL', 'P'),
(7554, 'Blue Hill', 34.871940612793, 0.608630180253166, -92.3450012207031, -1.61172431905945, 218, 4, 'PPL', 'P'),
(31853, 'Blue Hill', 39.3069381713867, 0.686035489968537, -98.3633270263672, -1.71676391982603, 218, 20, 'PPL', 'P'),
(44893, 'Blue Hill', 39.6980590820313, 0.692861837632683, -78.1938934326172, -1.36474089535274, 218, 25, 'PPL', 'P'),
(58704, 'Blue Hill', 31.7627792358398, 0.554365077249494, -90.8574981689453, -1.58576249317281, 218, 30, 'PPL', 'P'),
(77886, 'Blue Hill', 39.9508285522461, 0.697273497136454, -75.413330078125, -1.31621090975655, 218, 45, 'PPL', 'P'),
(85149, 'Blue Hill', 35.8102798461914, 0.625007289376609, -85.9130630493164, -1.49946582068405, 218, 50, 'PPL', 'P'),
(126902, 'Blue Hill', 44.413890838623, 0.775168628755318, -68.5872192382813, -1.1970728004952, 218, 26, 'PPL', 'P'),
(141330, 'Blue Hill', 40.3325004577637, 0.703934928550096, -98.4483337402344, -1.71824756686931, 218, 35, 'PPL', 'P'),
(209316, 'Blue Hill (historical)', 43.3041687011719, 0.755800323674526, -106.672218322754, -1.86178143013828, 218, 59, 'PPL', 'P'),
(126903, 'Blue Hill Falls', 44.3808288574219, 0.774591588326125, -68.565559387207, -1.19669476477847, 218, 26, 'PPL', 'P'),
(100002, 'Blue Hills', 37.2986106872559, 0.65098356291216, -79.9236068725586, -1.39493008999572, 218, 53, 'PPL', 'P'),
(124266, 'Blue Hills', 42.2430610656738, 0.737280501717033, -71.0986099243164, -1.24090483677044, 218, 23, 'PPL', 'P'),
(177512, 'Blue Hills', 41.8127784729004, 0.729770653759118, -72.6980590820313, -1.26882049079081, 218, 8, 'PPL', 'P'),
(180140, 'Blue Hills', 37.2880592346191, 0.650799405322781, -122.031112670898, -2.12984470597935, 218, 6, 'PPL', 'P'),
(177754, 'Blue Hills Farms', 34.5208282470703, 0.602502113426839, -112.295829772949, -1.95993196579704, 218, 5, 'PPL', 'P'),
(15259, 'Blue Inlet', 26.378059387207, 0.46038398659336, -80.0738906860352, -1.39755303735333, 218, 12, 'PPL', 'P'),
(118846, 'Blue Island', 41.6572189331055, 0.72705562760681, -87.6800003051758, -1.53030469347495, 218, 18, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(71855, 'Blue Jay', 39.2269401550293, 0.684639261188036, -84.7372207641602, -1.4789435013239, 218, 41, 'PPL', 'P'),
(108274, 'Blue Jay', 37.7369384765625, 0.658633826038549, -81.1380615234375, -1.41612632226971, 218, 58, 'PPL', 'P'),
(159338, 'Blue Jay', 41.5508308410645, 0.725198805115779, -79.1283264160156, -1.38104982755228, 218, 45, 'PPL', 'P'),
(180141, 'Blue Jay', 34.2461090087891, 0.597707358200261, -117.208892822266, -2.04568109236568, 218, 6, 'PPL', 'P'),
(108275, 'Blue Jay 6', 37.6827812194824, 0.657688603588652, -81.1136093139648, -1.41569955070503, 218, 58, 'PPL', 'P'),
(34872, 'Blue John', 36.9297218322754, 0.644545237818839, -84.4830627441406, -1.47450760705421, 218, 21, 'PPL', 'P'),
(159339, 'Blue Knob', 40.3544387817383, 0.704317824535822, -78.5538864135742, -1.37102395815451, 218, 45, 'PPL', 'P'),
(15260, 'Blue Lake', 28.3027801513672, 0.493976701109457, -82.057502746582, -1.43217359889215, 218, 12, 'PPL', 'P'),
(58705, 'Blue Lake', 33.8974990844727, 0.591622967215811, -90.4333267211914, -1.57835930481656, 218, 30, 'PPL', 'P'),
(193387, 'Blue Lake', 40.8830604553223, 0.713544013237266, -123.982780456543, -2.16390773474395, 218, 6, 'PPL', 'P'),
(180142, 'Blue Lake Junction', 38.2586097717285, 0.667738707752339, -120.330558776855, -2.10016444142069, 218, 6, 'PPL', 'P'),
(39408, 'Blue Lake Landing', 30.9811096191406, 0.54072236877529, -92.4427795410156, -1.61343087268598, 218, 22, 'PPL', 'P'),
(180143, 'Blue Lake Springs', 38.2597198486328, 0.667758082249269, -120.323059082031, -2.10003354705311, 218, 6, 'PPL', 'P'),
(15261, 'Blue Lakes Ridge', 28.9850006103516, 0.505883694343201, -81.5311126708984, -1.42298635892165, 218, 12, 'PPL', 'P'),
(34874, 'Blue Level', 36.9775009155273, 0.64537914013517, -86.5411071777344, -1.51042725857276, 218, 21, 'PPL', 'P'),
(29239, 'Blue Lick', 38.5083312988281, 0.672097170613335, -85.8047180175781, -1.49757484315204, 218, 19, 'PPL', 'P'),
(34873, 'Blue Lick', 37.4908294677734, 0.65433841351636, -84.7074966430664, -1.47842471754355, 218, 21, 'PPL', 'P'),
(53537, 'Blue Lick', 39.0133285522461, 0.680911035399007, -93.2099990844727, -1.62682137980495, 218, 29, 'PPL', 'P'),
(982, 'Blue Lock (historical)', 32.288330078125, 0.563537669833999, -87.8897171020508, -1.53396494207716, 218, 2, 'PPL', 'P'),
(159343, 'Blue Marsh (historical)', 40.3672218322754, 0.704540930856144, -76.0366668701172, -1.32709018912564, 218, 45, 'PPL', 'P'),
(85150, 'Blue Mill', 35.8561096191406, 0.625807169810014, -82.9952774047852, -1.44854085431956, 218, 50, 'PPL', 'P'),
(53538, 'Blue Mills', 39.1494407653809, 0.683286641670385, -94.3027801513672, -1.64589400742571, 218, 29, 'PPL', 'P'),
(34875, 'Blue Moon', 37.5074996948242, 0.654629363865451, -82.6977767944336, -1.44334848914223, 218, 21, 'PPL', 'P'),
(26551, 'Blue Mound', 39.7011108398438, 0.692915100854485, -89.1230621337891, -1.5554908736941, 218, 18, 'PPL', 'P'),
(31854, 'Blue Mound', 38.0900001525879, 0.664795914747801, -95.0061111450195, -1.65816944899627, 218, 20, 'PPL', 'P'),
(53539, 'Blue Mound', 39.6277809143066, 0.69163525221362, -93.5577774047852, -1.63289125656146, 218, 29, 'PPL', 'P'),
(92701, 'Blue Mound', 32.8563919067383, 0.573452219098201, -97.3386077880859, -1.69887919520949, 218, 51, 'PPL', 'P'),
(173233, 'Blue Mounds', 43.0175018310547, 0.750797042934594, -89.8322219848633, -1.5678680480183, 218, 57, 'PPL', 'P'),
(44894, 'Blue Mount', 39.6022186279297, 0.691189106152004, -76.621940612793, -1.3373051429608, 218, 25, 'PPL', 'P'),
(984, 'Blue Mountain', 33.684440612793, 0.587904395385734, -85.8427810668945, -1.49823916868596, 218, 2, 'PPL', 'P'),
(7558, 'Blue Mountain', 35.1302795410156, 0.613139045136725, -93.7113876342773, -1.63557226083084, 218, 4, 'PPL', 'P'),
(44896, 'Blue Mountain', 39.7058296203613, 0.692997459111195, -77.5297164916992, -1.3531488209179, 218, 25, 'PPL', 'P'),
(58706, 'Blue Mountain', 34.6708297729492, 0.605120133936442, -89.0263900756836, -1.55380362798548, 218, 30, 'PPL', 'P'),
(100004, 'Blue Mountain', 38.9625015258789, 0.680023936439902, -78.039436340332, -1.36204511053931, 218, 53, 'PPL', 'P'),
(147261, 'Blue Mountain', 42.1083297729492, 0.73492899705352, -74.0202789306641, -1.29189758058468, 218, 40, 'PPL', 'P'),
(194111, 'Blue Mountain', 40.2483291625977, 0.702465862313781, -108.861106872559, -1.89998474229157, 218, 7, 'PPL', 'P'),
(15262, 'Blue Mountain Beach', 30.3372192382813, 0.529484361607374, -86.1972198486328, -1.50442529242405, 218, 12, 'PPL', 'P'),
(147262, 'Blue Mountain Lake', 43.855281829834, 0.765419062320647, -74.4438934326172, -1.29929104840295, 218, 40, 'PPL', 'P'),
(159340, 'Blue Mountain Pines', 40.9022216796875, 0.713878439691152, -75.2427825927734, -1.31323429460617, 218, 45, 'PPL', 'P'),
(196043, 'Blue Mountain Trailer Park', 46.8133316040039, 0.817046770317787, -114.091667175293, -1.9912752412984, 218, 31, 'PPL', 'P'),
(100005, 'Blue Oaks', 38.8199996948242, 0.677536810297877, -77.3083267211914, -1.3492848404923, 218, 53, 'PPL', 'P'),
(177755, 'Blue Palm Mobile Home Park', 33.4508285522461, 0.583827095756822, -112.119720458984, -1.95685827842493, 218, 5, 'PPL', 'P'),
(108276, 'Blue Pennant', 37.9708290100098, 0.662715985936449, -81.5597229003906, -1.42348570162604, 218, 58, 'PPL', 'P'),
(26554, 'Blue Point', 38.5424995422363, 0.672693518960431, -88.4891662597656, -1.54442730357759, 218, 18, 'PPL', 'P'),
(126905, 'Blue Point', 43.5522193908691, 0.760129624921586, -70.3569412231445, -1.227960275976, 218, 26, 'PPL', 'P'),
(147263, 'Blue Point', 40.7438888549805, 0.711115010586032, -73.0350036621094, -1.27470128310992, 218, 40, 'PPL', 'P'),
(988, 'Blue Pond', 34.2369384765625, 0.597547302218747, -85.7202835083008, -1.49610118296284, 218, 2, 'PPL', 'P'),
(31856, 'Blue Rapids', 39.6819381713867, 0.692580474663516, -96.6594390869141, -1.68702546519755, 218, 20, 'PPL', 'P'),
(992, 'Blue Ridge', 32.4925003051758, 0.56710111253058, -86.190559387207, -1.50430904544247, 218, 2, 'PPL', 'P'),
(19351, 'Blue Ridge', 34.8638916015625, 0.608489698505665, -84.3241729736328, -1.47173445741111, 218, 13, 'PPL', 'P'),
(29240, 'Blue Ridge', 39.5191688537598, 0.689739614149701, -85.6355590820313, -1.49462246276758, 218, 19, 'PPL', 'P'),
(58707, 'Blue Ridge', 31.8958301544189, 0.556687253851502, -89.147216796875, -1.55591245209466, 218, 30, 'PPL', 'P'),
(63018, 'Blue Ridge', 35.3502807617188, 0.616978790796401, -82.3630599975586, -1.43750657897503, 218, 33, 'PPL', 'P'),
(79841, 'Blue Ridge', 35.0422210693359, 0.61160213487164, -82.3052825927734, -1.43649817302827, 218, 48, 'PPL', 'P'),
(85151, 'Blue Ridge', 36.5541687011719, 0.637990599164908, -82.2186126708984, -1.43498549752911, 218, 50, 'PPL', 'P'),
(92703, 'Blue Ridge', 31.2761096954346, 0.545871091400254, -96.7411117553711, -1.68845092217102, 218, 51, 'PPL', 'P'),
(100006, 'Blue Ridge', 37.3783302307129, 0.652374931423672, -79.8072204589844, -1.39289876387426, 218, 53, 'PPL', 'P'),
(118848, 'Blue Ridge', 40.2677803039551, 0.702805348773739, -88.4880599975586, -1.54440799565968, 218, 18, 'PPL', 'P'),
(139043, 'Blue Ridge', 40.1922187805176, 0.701486551401932, -93.9352798461914, -1.63947991709831, 218, 29, 'PPL', 'P'),
(147264, 'Blue Ridge', 43.957218170166, 0.767198187086874, -73.7850036621094, -1.28779125249988, 218, 40, 'PPL', 'P'),
(159341, 'Blue Ridge', 40.1311111450195, 0.700420021964382, -74.8666687011719, -1.30666986883524, 218, 45, 'PPL', 'P'),
(84, 'Blue Ridge Acres', 38.0311088562012, 0.663768067725085, -78.8000030517578, -1.37531950383475, 218, 53, 'PPL', 'P'),
(108277, 'Blue Ridge Acres', 39.2861099243164, 0.685671968479742, -77.773063659668, -1.35739603022436, 218, 58, 'PPL', 'P'),
(171752, 'Blue Ridge Acres', 43.6338882446289, 0.761555015316023, -72.9625015258789, -1.27343588211797, 218, 55, 'PPL', 'P'),
(44898, 'Blue Ridge At Crofton Meadows', 39.0094413757324, 0.680843191370237, -76.6655578613281, -1.3380664075584, 218, 25, 'PPL', 'P'),
(100008, 'Blue Ridge Downs', 39.0444412231445, 0.681454053945274, -78.0302810668945, -1.3618853208739, 218, 53, 'PPL', 'P'),
(85152, 'Blue Ridge Estates', 36.4900016784668, 0.636870673347503, -82.5111083984375, -1.44009051102268, 218, 50, 'PPL', 'P'),
(100009, 'Blue Ridge Estates', 39.1380615234375, 0.683088036432092, -77.9208297729492, -1.35997503542399, 218, 53, 'PPL', 'P'),
(100010, 'Blue Ridge Farms', 37.415828704834, 0.653029403261559, -79.2197189331055, -1.38264492788718, 218, 53, 'PPL', 'P'),
(63019, 'Blue Ridge Forest', 35.5411109924316, 0.620309406634682, -82.3861083984375, -1.43790884945769, 218, 33, 'PPL', 'P'),
(100011, 'Blue Ridge Heights', 37.2786102294922, 0.650634489072278, -79.8822174072266, -1.39420770755003, 218, 53, 'PPL', 'P'),
(19352, 'Blue Ridge Manor', 33.8600006103516, 0.590968495377924, -84.6002807617188, -1.47655344740361, 218, 13, 'PPL', 'P'),
(34876, 'Blue Ridge Manor', 38.2430610656738, 0.66746733163726, -85.5630569458008, -1.49335706177563, 218, 21, 'PPL', 'P'),
(159342, 'Blue Ridge Manor', 40.3316688537598, 0.703920414322155, -76.7866668701172, -1.34018015851559, 218, 45, 'PPL', 'P'),
(100017, 'Blue Ridge Mobile Home Park', 39.1833305358887, 0.683878129748491, -78.1005630493164, -1.36311197287199, 218, 53, 'PPL', 'P'),
(100018, 'Blue Ridge Mountains Estates', 38.8522186279297, 0.678099136762047, -78.1508331298828, -1.36398935129312, 218, 53, 'PPL', 'P'),
(100019, 'Blue Ridge Park', 37.2680587768555, 0.650450331482899, -80.0063934326172, -1.39637498804514, 218, 53, 'PPL', 'P'),
(100020, 'Blue Ridge Shores', 38.1049995422363, 0.665057703482956, -78.0250015258789, -1.36179317550019, 218, 53, 'PPL', 'P'),
(77888, 'Blue Ridge Summit', 39.7241706848145, 0.693317571074223, -77.4716720581055, -1.35213575443923, 218, 45, 'PPL', 'P'),
(79842, 'Blue Ridge Terrace', 33.8891716003418, 0.59147762519932, -81.1680603027344, -1.41664989974002, 218, 48, 'PPL', 'P'),
(44899, 'Blue Ridge View', 39.5777816772461, 0.690762600903428, -77.0072174072266, -1.34402949155519, 218, 25, 'PPL', 'P'),
(85153, 'Blue Ridge View', 35.2005615234375, 0.614365697134815, -85.1425018310547, -1.48601699033721, 218, 50, 'PPL', 'P'),
(100021, 'Blue Ridge View', 38.1572189331055, 0.665969103787008, -78.5550003051758, -1.37104339923047, 218, 53, 'PPL', 'P'),
(29245, 'Blue River', 38.5299987792969, 0.672475339488126, -85.9394378662109, -1.49992614807847, 218, 19, 'PPL', 'P'),
(34877, 'Blue River', 37.6191711425781, 0.656578398309225, -82.8438873291016, -1.44589859904403, 218, 21, 'PPL', 'P'),
(173236, 'Blue River', 43.1883316040039, 0.753778584932992, -90.5666732788086, -1.58068664129318, 218, 57, 'PPL', 'P'),
(186425, 'Blue River', 39.4297218322754, 0.688178469118697, -106.043327331543, -1.85080521170552, 218, 7, 'PPL', 'P'),
(200426, 'Blue River', 44.1547203063965, 0.770645249643818, -122.339996337891, -2.135235742974, 218, 43, 'PPL', 'P'),
(63023, 'Blue Rock', 35.8905601501465, 0.626408445005127, -82.1797180175781, -1.43430665776725, 218, 33, 'PPL', 'P'),
(71856, 'Blue Rock', 39.7999992370605, 0.694641028977938, -81.8916702270508, -1.42927927541945, 218, 41, 'PPL', 'P'),
(108278, 'Blue Rock', 38.7247200012207, 0.675873865934204, -80.0911102294922, -1.39785357508235, 218, 58, 'PPL', 'P'),
(92704, 'Blue Rock Colonia', 26.2450008392334, 0.458061676833298, -98.2979965209961, -1.71562368740531, 218, 51, 'PPL', 'P'),
(13400, 'Blue Rock Manor', 39.7958297729492, 0.694568258101151, -75.5430603027344, -1.31847512931534, 218, 10, 'PPL', 'P'),
(154373, 'Blue Row', 40.1925010681152, 0.701491478249949, -81.8619384765625, -1.42876035848105, 218, 41, 'PPL', 'P'),
(134329, 'Blue Skies Mobile Park', 45.5800018310547, 0.795521105016949, -94.1500015258789, -1.64322751738427, 218, 28, 'PPL', 'P'),
(85154, 'Blue Sky', 35.7652816772461, 0.624221923171144, -87.8797225952148, -1.53379050502576, 218, 50, 'PPL', 'P'),
(177756, 'Blue Sky Mobile Estates', 33.5361099243164, 0.585315536490068, -112.161109924316, -1.95758066087061, 218, 5, 'PPL', 'P'),
(19353, 'Blue Spring', 34.8763885498047, 0.608707811398942, -85.2238922119141, -1.48743752046265, 218, 13, 'PPL', 'P'),
(34878, 'Blue Spring', 36.8288917541504, 0.642785420970514, -87.9375, -1.53479891097251, 218, 21, 'PPL', 'P'),
(85155, 'Blue Spring', 36.357780456543, 0.634562977683922, -82.1161117553711, -1.43319651906685, 218, 50, 'PPL', 'P'),
(108279, 'Blue Spring', 38.5366706848145, 0.67259178620679, -80.1125030517578, -1.39822695026718, 218, 58, 'PPL', 'P'),
(19354, 'Blue Spring (historical)', 31.6833305358887, 0.552978435848917, -83.9277801513672, -1.4648160975313, 218, 13, 'PPL', 'P'),
(79843, 'Blue Spring (historical)', 34.422779083252, 0.600790832689382, -80.3300018310547, -1.40202302008498, 218, 48, 'PPL', 'P'),
(34879, 'Blue Spring Estates', 36.8369407653809, 0.642925902718016, -87.9563903808594, -1.53512861031547, 218, 21, 'PPL', 'P'),
(1005, 'Blue Springs', 31.208890914917, 0.544697902361047, -86.3130569458008, -1.50644703116558, 218, 2, 'PPL', 'P'),
(7560, 'Blue Springs', 34.6736106872559, 0.605168670047309, -93.0727767944336, -1.62442639903664, 218, 4, 'PPL', 'P'),
(15264, 'Blue Springs', 30.4863891601563, 0.532087867889035, -83.2200012207031, -1.45246302481497, 218, 12, 'PPL', 'P'),
(19357, 'Blue Springs', 32.6330604553223, 0.569554349947733, -81.4216690063477, -1.42107620662979, 218, 13, 'PPL', 'P'),
(53542, 'Blue Springs', 39.0169410705566, 0.680974085737815, -94.2813873291016, -1.64552063224088, 218, 29, 'PPL', 'P'),
(58708, 'Blue Springs', 34.401668548584, 0.600422384352569, -88.8727798461914, -1.5511226237161, 218, 30, 'PPL', 'P'),
(85159, 'Blue Springs', 35.7419395446777, 0.623814526103389, -84.6672210693359, -1.47772177617383, 218, 50, 'PPL', 'P'),
(92705, 'Blue Springs', 31.2763900756836, 0.545875984958757, -94.0738906860352, -1.64189913263254, 218, 51, 'PPL', 'P'),
(141332, 'Blue Springs', 40.1394386291504, 0.700565363980873, -96.6588897705078, -1.68701587781763, 218, 35, 'PPL', 'P'),
(1006, 'Blue Springs (historical)', 33.7222213745117, 0.588563794071637, -85.8194427490234, -1.49783183819723, 218, 2, 'PPL', 'P'),
(7559, 'Blue Springs (historical)', 33.6336097717285, 0.587017229847601, -92.307502746582, -1.61106984722157, 218, 4, 'PPL', 'P'),
(15265, 'Blue Springs Landing', 28.9430599212646, 0.505151691228079, -81.3399963378906, -1.41965074965632, 218, 12, 'PPL', 'P'),
(1007, 'Blue Springs Park', 34.815559387207, 0.607646142230382, -87.154167175293, -1.52112717404243, 218, 2, 'PPL', 'P'),
(85160, 'Blue Springs Resort', 35.7363891601563, 0.623717653618738, -84.6675033569336, -1.47772670302184, 218, 50, 'PPL', 'P'),
(7561, 'Blue Springs Village', 36.1749992370605, 0.631372843593143, -94.0152816772461, -1.64087621245784, 218, 4, 'PPL', 'P'),
(19358, 'Blue Springs Village Mobile Home Park', 34.0394401550293, 0.59410030624083, -84.6544418334961, -1.47749873643253, 218, 13, 'PPL', 'P'),
(203064, 'Blue Spruce', 40.6563911437988, 0.709587887437953, -111.811668395996, -1.95148175565822, 218, 52, 'PPL', 'P'),
(203065, 'Blue Spruce Heights', 40.6552810668945, 0.709568512941023, -111.810279846191, -1.9514575208923, 218, 52, 'PPL', 'P'),
(92706, 'Blue Star Enterprises Number 2 Colonia', 26.2910003662109, 0.458864520033416, -98.5599975585938, -1.72019646815503, 218, 51, 'PPL', 'P'),
(100022, 'Blue Star Estates', 37.6597213745117, 0.657286133368914, -77.3916702270508, -1.3507394590797, 218, 53, 'PPL', 'P'),
(177757, 'Blue Star Mobile Home Park', 33.4172210693359, 0.583240534526732, -111.594718933105, -1.94769527322034, 218, 5, 'PPL', 'P'),
(147265, 'Blue Store', 42.1088905334473, 0.734938784170526, -73.8180618286133, -1.28836822635005, 218, 40, 'PPL', 'P'),
(108282, 'Blue Sulphur', 38.4152793884277, 0.670473108401578, -82.2483291625977, -1.4355041481514, 218, 58, 'PPL', 'P'),
(108280, 'Blue Sulphur Springs', 37.8250007629395, 0.660170802882661, -80.6363906860352, -1.4073705143958, 218, 58, 'PPL', 'P'),
(180144, 'Blue Tent', 39.3102798461914, 0.68609381319641, -120.972503662109, -2.11136849328471, 218, 6, 'PPL', 'P'),
(206857, 'Blue Town (historical)', 48.6258316040039, 0.848680863010184, -118.120826721191, -2.06159734146249, 218, 56, 'PPL', 'P'),
(186426, 'Blue Valley', 39.6997184753418, 0.692890799509538, -105.488609313965, -1.84112355587864, 218, 7, 'PPL', 'P'),
(71859, 'Blue Valley Acres', 39.639720916748, 0.691843644568918, -82.5583267211914, -1.440914626222, 218, 41, 'PPL', 'P'),
(177758, 'Blue Vista', 33.6191711425781, 0.586765228229452, -109.082496643066, -1.90384872271717, 218, 5, 'PPL', 'P'),
(129873, 'Blue Water Beach', 43.207218170166, 0.754108217696917, -82.5155563354492, -1.44016814216846, 218, 27, 'PPL', 'P'),
(34880, 'Blue Water Estates', 36.8913917541504, 0.643876251753011, -87.9783325195313, -1.53551157288022, 218, 21, 'PPL', 'P'),
(192492, 'Blueacre', 38.485279083252, 0.671694833551651, -113.13111114502, -1.97451037592024, 218, 52, 'PPL', 'P'),
(44900, 'Blueball', 39.7000007629395, 0.692895726357554, -75.9316711425781, -1.32525766797955, 218, 25, 'PPL', 'P'),
(34881, 'Bluebank', 38.3838882446289, 0.669925229586321, -83.6549987792969, -1.46005516445057, 218, 21, 'PPL', 'P'),
(71858, 'Bluebell', 39.898609161377, 0.696362096832401, -81.5897216796875, -1.42400927909635, 218, 41, 'PPL', 'P'),
(203067, 'Bluebell', 40.3594398498535, 0.70440510964055, -110.216667175293, -1.92364373278362, 218, 52, 'PPL', 'P'),
(173238, 'Blueberry', 46.5802803039551, 0.812979257805881, -91.6686096191406, -1.59991905857935, 218, 57, 'PPL', 'P'),
(44901, 'Blueberry Heights', 39.6450004577637, 0.691935789942635, -77.5699996948242, -1.35385189544568, 218, 25, 'PPL', 'P'),
(34882, 'Blueberry Hill', 37.9816703796387, 0.662905203531899, -84.5224990844727, -1.47519590103794, 218, 21, 'PPL', 'P'),
(44902, 'Blueberry Hill', 38.2338905334473, 0.667307275655746, -75.5733337402344, -1.31900350047561, 218, 25, 'PPL', 'P'),
(58710, 'Blueberry Hill', 31.4025001525879, 0.54807702102068, -90.4441680908203, -1.57854852241201, 218, 30, 'PPL', 'P'),
(19359, 'Blueberry Hills', 34.3691711425781, 0.59985519761941, -83.8274993896484, -1.4630658680629, 218, 13, 'PPL', 'P'),
(85161, 'Blueberry Hills', 36.1155586242676, 0.630335409190503, -83.9572219848633, -1.46532995446363, 218, 50, 'PPL', 'P'),
(126906, 'Blueberry Ridge Trailer Park', 43.3522186279297, 0.756638953101792, -70.7094421386719, -1.23411257756825, 218, 26, 'PPL', 'P'),
(154374, 'Bluebird Beach', 41.4186096191406, 0.722891109452198, -82.3788909912109, -1.43778288193813, 218, 41, 'PPL', 'P'),
(39409, 'Bluebonnet Ridge', 30.3672199249268, 0.530007972367197, -91.1002807617188, -1.58999984878324, 218, 22, 'PPL', 'P'),
(122245, 'Bluecast', 41.1541709899902, 0.718275784704064, -84.8694381713867, -1.48125113040845, 218, 19, 'PPL', 'P'),
(193243, 'Bluecreek', 48.3188896179199, 0.843323714740408, -117.819999694824, -2.0563469193734, 218, 56, 'PPL', 'P'),
(15266, 'Bluefield', 27.1997203826904, 0.47472467629976, -80.5875015258789, -1.40651723758254, 218, 12, 'PPL', 'P'),
(63025, 'Bluefield', 34.5247192382813, 0.602570024034637, -78.6022186279297, -1.37186751442979, 218, 33, 'PPL', 'P'),
(85163, 'Bluefield', 35.9383316040039, 0.627242214163403, -86.5555572509766, -1.51067945992799, 218, 50, 'PPL', 'P'),
(100023, 'Bluefield', 37.252498626709, 0.650178755630738, -81.2713928222656, -1.41845339243022, 218, 53, 'PPL', 'P'),
(108281, 'Bluefield', 37.269718170166, 0.650479293359753, -81.2225036621094, -1.41760011561696, 218, 58, 'PPL', 'P'),
(100024, 'Bluefield Heights', 37.2508316040039, 0.650149660595829, -79.9697189331055, -1.39573489727714, 218, 53, 'PPL', 'P'),
(198023, 'Bluegrass', 46.9491691589355, 0.819417582899202, -101.581390380859, -1.77292972089969, 218, 34, 'PPL', 'P'),
(44903, 'Bluegrass Estates', 39.6994400024414, 0.692885939240548, -77.6183319091797, -1.35469545172096, 218, 25, 'PPL', 'P'),
(44904, 'Bluegrass Heights', 39.3238906860352, 0.686331367165645, -76.5252838134766, -1.33561816356829, 218, 25, 'PPL', 'P'),
(92707, 'Bluegrove', 33.6738891601563, 0.587720237796355, -98.2297210693359, -1.71443205597556, 218, 51, 'PPL', 'P'),
(180145, 'Bluegum', 39.583610534668, 0.690864333657069, -122.192222595215, -2.13265660461631, 218, 6, 'PPL', 'P'),
(34883, 'Bluehole', 37.1002807617188, 0.647522052706302, -83.7563934326172, -1.46182483499493, 218, 21, 'PPL', 'P'),
(79844, 'Bluehouse Corners', 32.7700004577637, 0.571944403868025, -80.6994400024414, -1.40847093255822, 218, 48, 'PPL', 'P'),
(75161, 'Bluejacket', 36.7997207641602, 0.642276291149118, -95.0708312988281, -1.65929902877263, 218, 42, 'PPL', 'P'),
(206858, 'Bluelight', 46.041389465332, 0.803573838363076, -120.176109313965, -2.09746878976531, 218, 56, 'PPL', 'P'),
(100025, 'Bluemont', 39.1111106872559, 0.682617655604557, -77.8341674804688, -1.35846249308288, 218, 53, 'PPL', 'P'),
(100026, 'Bluemont Estates', 37.3919410705566, 0.652612485392907, -79.2452774047852, -1.38309100736977, 218, 53, 'PPL', 'P'),
(31861, 'Bluemont Hill', 39.1927795410156, 0.684043045998995, -96.5597229003906, -1.68528508942519, 218, 20, 'PPL', 'P'),
(100027, 'Bluemont Junction', 38.8747215270996, 0.678491886443806, -77.1336135864258, -1.34623552104416, 218, 53, 'PPL', 'P'),
(100028, 'Blueridge Forest', 38.1436080932617, 0.665731549817773, -78.5069427490234, -1.37020463664515, 218, 53, 'PPL', 'P'),
(19360, 'Blueridge Mountain Mobile Home Park', 33.5591697692871, 0.585718006709806, -84.2516708374023, -1.47046905641916, 218, 13, 'PPL', 'P'),
(108283, 'Blues Beach', 39.4258308410645, 0.6881105585109, -78.7155609130859, -1.3738457104875, 218, 58, 'PPL', 'P'),
(1012, 'Blues Old Stand', 31.9847202301025, 0.558238678344528, -85.7169418334961, -1.49604285973497, 218, 2, 'PPL', 'P'),
(206860, 'Blueslide', 48.5563888549805, 0.847468858398089, -117.344718933105, -2.04805170521002, 218, 56, 'PPL', 'P'),
(206859, 'Bluestem', 47.5250015258789, 0.829467753641916, -118.125556945801, -2.06167989945628, 218, 56, 'PPL', 'P'),
(19361, 'Bluestone', 34.1758308410645, 0.596480772781198, -83.2027816772461, -1.45216248708595, 218, 13, 'PPL', 'P'),
(34888, 'Bluestone', 38.1497192382813, 0.665838209419431, -83.5113906860352, -1.45754873039064, 218, 21, 'PPL', 'P'),
(100030, 'Bluestone', 37.3011093139648, 0.65102717217501, -79.9236068725586, -1.39493008999572, 218, 53, 'PPL', 'P'),
(108284, 'Bluestone', 37.311939239502, 0.651216190033378, -81.3180618286133, -1.41926792024962, 218, 58, 'PPL', 'P'),
(154376, 'Bluestone', 41.5333290100098, 0.724893340538747, -81.5466690063477, -1.42325786819478, 218, 41, 'PPL', 'P'),
(159344, 'Bluestone', 41.3805618286133, 0.722227050234387, -77.4402770996094, -1.35158780904495, 218, 45, 'PPL', 'P'),
(44905, 'Bluestone Estates', 38.1661109924316, 0.666124299499533, -76.413330078125, -1.3336642022765, 218, 25, 'PPL', 'P'),
(7562, 'Bluetip (historical)', 35.7541694641113, 0.624027978464759, -91.9169387817383, -1.6042532200954, 218, 4, 'PPL', 'P'),
(92708, 'Bluetown', 26.0738906860352, 0.455075241276397, -97.8227767944336, -1.70732953850637, 218, 51, 'PPL', 'P'),
(92709, 'Bluetown Colonia', 26.0699996948242, 0.4550073306686, -97.822998046875, -1.70733340008995, 218, 51, 'PPL', 'P'),
(92710, 'Bluett', 33.1575012207031, 0.578707568035309, -97.4380569458008, -1.70061491044995, 218, 51, 'PPL', 'P'),
(19362, 'Blueville', 32.4169387817383, 0.565782315158772, -84.4955596923828, -1.47472571994749, 218, 13, 'PPL', 'P'),
(26555, 'Blueville', 39.6622200012207, 0.692236327671651, -89.3919372558594, -1.56018362985093, 218, 18, 'PPL', 'P'),
(108286, 'Blueville', 39.3461112976074, 0.686719189999388, -80.0036087036133, -1.39632638535524, 218, 58, 'PPL', 'P'),
(177759, 'Bluewater', 34.1686096191406, 0.59635473868261, -114.264167785645, -1.99428594491074, 218, 5, 'PPL', 'P'),
(180146, 'Bluewater', 34.1744384765625, 0.596456471436251, -114.270561218262, -1.99439753136041, 218, 6, 'PPL', 'P'),
(188163, 'Bluewater', 33.5577812194824, 0.585693771943886, -105.185562133789, -1.83583438479569, 218, 38, 'PPL', 'P'),
(108289, 'Bluewell', 37.3125, 0.651225977150384, -81.2600021362305, -1.41825458745485, 218, 58, 'PPL', 'P'),
(85166, 'Bluewing', 35.785831451416, 0.624580584390951, -85.9916687011719, -1.50083774811961, 218, 50, 'PPL', 'P'),
(217, 'Bluff', 33.8205604553223, 0.590280134815166, -87.9063873291016, -1.53425589242625, 218, 2, 'PPL', 'P'),
(58711, 'Bluff', 34.6133308410645, 0.604116588258673, -88.9558334350586, -1.55257218229743, 218, 30, 'PPL', 'P'),
(63027, 'Bluff', 35.8377799987793, 0.625487257584068, -82.8580627441406, -1.4461460067093, 218, 33, 'PPL', 'P'),
(75162, 'Bluff', 33.9397201538086, 0.592359863889436, -95.6927795410156, -1.67015407337579, 218, 42, 'PPL', 'P'),
(77891, 'Bluff', 39.8050003051758, 0.694728314082665, -80.307502746582, -1.40163033698225, 218, 45, 'PPL', 'P'),
(192493, 'Bluff', 37.2844390869141, 0.650736221825919, -109.551109313965, -1.91202755674091, 218, 52, 'PPL', 'P'),
(211705, 'Bluff', 64.5727767944336, 1.12700756221826, -163.754165649414, -2.85804935443847, 218, 1, 'PPL', 'P'),
(154375, 'Bluff (historical)', 40.3499984741211, 0.704240326548101, -82.1166687011719, -1.43320623960482, 218, 41, 'PPL', 'P'),
(114648, 'Bluff Acres Mobile Home Park', 41.226390838623, 0.719536258847998, -95.8722229003906, -1.67328595081772, 218, 16, 'PPL', 'P'),
(203069, 'Bluff at Hidden Valley', 40.5341682434082, 0.707454695404799, -111.848327636719, -1.95212158011011, 218, 52, 'PPL', 'P'),
(129874, 'Bluff Beach', 41.814998626709, 0.729809402752979, -85.5372161865234, -1.49290605544502, 218, 27, 'PPL', 'P'),
(34884, 'Bluff Boom', 37.2777786254883, 0.650619974844337, -85.4611129760742, -1.49157780385135, 218, 21, 'PPL', 'P'),
(169856, 'Bluff Center (historical)', 42.9208297729492, 0.749109797225974, -97.0888900756836, -1.69452079892753, 218, 49, 'PPL', 'P'),
(1011, 'Bluff City', 34.5455589294434, 0.602933745260514, -86.7813873291016, -1.51462093834131, 218, 2, 'PPL', 'P'),
(7563, 'Bluff City', 33.7183303833008, 0.58849588346384, -93.1338882446289, -1.62549299505322, 218, 4, 'PPL', 'P'),
(31862, 'Bluff City', 37.0763893127441, 0.647105068258623, -97.8747177124023, -1.70823607854143, 218, 20, 'PPL', 'P'),
(34885, 'Bluff City', 37.8016700744629, 0.659763605551987, -87.3794403076172, -1.52505893191777, 218, 21, 'PPL', 'P'),
(85165, 'Bluff City', 36.4741706848145, 0.636594370384407, -82.2611083984375, -1.43572718789269, 218, 50, 'PPL', 'P'),
(100031, 'Bluff City', 37.3380584716797, 0.651672056632972, -80.7563934326172, -1.4094649574351, 218, 53, 'PPL', 'P'),
(118850, 'Bluff City', 40.1802787780762, 0.701278159046633, -90.2302780151367, -1.57481543635399, 218, 18, 'PPL', 'P'),
(92711, 'Bluff City (historical)', 31.5405597686768, 0.550486615885471, -95.144172668457, -1.66057907715057, 218, 51, 'PPL', 'P'),
(19363, 'Bluff Creek', 34.1216697692871, 0.595535483752274, -84.4550018310547, -1.47401785172974, 218, 13, 'PPL', 'P'),
(29246, 'Bluff Creek', 39.5574989318848, 0.690408600215529, -86.220832824707, -1.50483741660274, 218, 19, 'PPL', 'P'),
(39410, 'Bluff Creek', 30.7463893890381, 0.536625727938962, -90.8572235107422, -1.58575769948285, 218, 22, 'PPL', 'P'),
(85167, 'Bluff Creek', 36.2169418334961, 0.632104879997779, -85.9563903808594, -1.50022202527558, 218, 50, 'PPL', 'P'),
(114649, 'Bluff Creek', 41.1472206115723, 0.718154477716411, -92.8499984741211, -1.62053818384512, 218, 16, 'PPL', 'P'),
(92712, 'Bluff Dale', 32.350830078125, 0.564628500616496, -98.021110534668, -1.71079111529126, 218, 51, 'PPL', 'P'),
(79845, 'Bluff Estates', 33.938060760498, 0.592330902012582, -80.9736099243164, -1.41325610040488, 218, 48, 'PPL', 'P'),
(79846, 'Bluff Farm', 32.4375, 0.566141176115661, -80.6444396972656, -1.4075109961433, 218, 48, 'PPL', 'P'),
(26557, 'Bluff Junction', 38.8183288574219, 0.67750764868394, -89.9824981689453, -1.57049086221786, 218, 18, 'PPL', 'P'),
(1013, 'Bluff Park', 33.4013900756836, 0.582964231563637, -86.8561096191406, -1.51592508832712, 218, 2, 'PPL', 'P'),
(114651, 'Bluff Park', 40.5275001525879, 0.707338315265163, -91.4036102294922, -1.59529394671421, 218, 16, 'PPL', 'P'),
(44906, 'Bluff Point', 39.0755615234375, 0.681997205649596, -76.5758285522461, -1.33650033567938, 218, 25, 'PPL', 'P'),
(122246, 'Bluff Point', 40.3458290100098, 0.704167555671315, -84.9772186279297, -1.48313225424443, 218, 19, 'PPL', 'P'),
(147266, 'Bluff Point', 42.6141700744629, 0.743757575804215, -77.103889465332, -1.34571673726381, 218, 40, 'PPL', 'P'),
(7564, 'Bluff Ridge (historical)', 35.0366706848145, 0.611505262386989, -94.164436340332, -1.64347945242339, 218, 4, 'PPL', 'P'),
(1014, 'Bluff Ridge Subdivision', 33.2802810668945, 0.580850480606441, -86.9916687011719, -1.51829104063955, 218, 2, 'PPL', 'P'),
(173239, 'Bluff Siding', 44.0713882446289, 0.769190830793499, -91.6177825927734, -1.59903195962024, 218, 57, 'PPL', 'P'),
(34886, 'Bluff Spring', 37.0050010681152, 0.645859108342629, -87.3147201538086, -1.52392935214141, 218, 21, 'PPL', 'P'),
(1016, 'Bluff Springs', 31.5708293914795, 0.551014920466715, -86.0672225952148, -1.50215641233336, 218, 2, 'PPL', 'P'),
(15267, 'Bluff Springs', 30.9361095428467, 0.539936969280312, -87.2947235107422, -1.52358034488055, 218, 12, 'PPL', 'P'),
(26558, 'Bluff Springs', 39.9877815246582, 0.697918448173444, -90.345832824707, -1.57683224824751, 218, 18, 'PPL', 'P'),
(58713, 'Bluff Springs', 34.3458290100098, 0.599447800551655, -89.8086090087891, -1.56745592383961, 218, 30, 'PPL', 'P'),
(85168, 'Bluff Springs', 35.8186111450195, 0.625152697972127, -85.7619400024414, -1.49682822594044, 218, 50, 'PPL', 'P'),
(92713, 'Bluff Springs', 30.1574993133545, 0.526347657185965, -97.7686080932617, -1.70638411631939, 218, 51, 'PPL', 'P'),
(7565, 'Bluff Springs (historical)', 34.288890838623, 0.598454041990892, -94.0666732788086, -1.64177316511298, 218, 4, 'PPL', 'P'),
(58714, 'Bluff Springs (historical)', 33.0333290100098, 0.576540354119229, -89.7347183227539, -1.56616628808174, 218, 30, 'PPL', 'P'),
(85169, 'Bluff View', 35.3561096191406, 0.617080523550042, -85.0416717529297, -1.48425717348888, 218, 50, 'PPL', 'P'),
(92714, 'Bluff View', 31.7199993133545, 0.553618426748376, -99.008056640625, -1.72801657437994, 218, 51, 'PPL', 'P'),
(44907, 'Bluff Woods', 38.2583312988281, 0.667733847483349, -76.7238922119141, -1.33908453404314, 218, 25, 'PPL', 'P'),
(203070, 'Bluffdale', 40.4897193908691, 0.706678916579259, -111.938056945801, -1.95368765198913, 218, 52, 'PPL', 'P'),
(85170, 'Bluffpoint (historical)', 35.7561111450195, 0.624061867189631, -87.3238906860352, -1.52408940812292, 218, 50, 'PPL', 'P'),
(1017, 'Bluffport', 32.5938911437988, 0.56887071649591, -88.1155624389648, -1.53790668680658, 218, 2, 'PPL', 'P'),
(196044, 'Bluffport', 46.8144416809082, 0.817066144814717, -105.165557861328, -1.83548524437678, 218, 31, 'PPL', 'P'),
(26560, 'Bluffs', 39.7519416809082, 0.693802266392617, -90.5350036621094, -1.58013390220893, 218, 18, 'PPL', 'P'),
(29247, 'Bluffs', 39.5688896179199, 0.690607405190904, -86.251106262207, -1.50536578776301, 218, 19, 'PPL', 'P'),
(26561, 'Bluffside', 38.4838905334473, 0.671670598785732, -90.1547164916992, -1.57349663898218, 218, 18, 'PPL', 'P'),
(1018, 'Bluffton', 34.0069389343262, 0.593533052928643, -85.4400024414063, -1.49120935551453, 218, 2, 'PPL', 'P'),
(7566, 'Bluffton', 34.9052810668945, 0.609212080951349, -93.6005630493164, -1.63363800693111, 218, 4, 'PPL', 'P'),
(15268, 'Bluffton', 29.1261100769043, 0.508346519140279, -81.5019378662109, -1.42247716252122, 218, 12, 'PPL', 'P'),
(19364, 'Bluffton', 31.5227794647217, 0.550176291039449, -84.8677825927734, -1.48122223511063, 218, 13, 'PPL', 'P'),
(53544, 'Bluffton', 38.7075004577637, 0.675573328205188, -91.6244430541992, -1.59914820660183, 218, 29, 'PPL', 'P'),
(79847, 'Bluffton', 32.2369384765625, 0.562640717178861, -80.8605575561523, -1.41128296435324, 218, 48, 'PPL', 'P'),
(85171, 'Bluffton', 35.8105583190918, 0.625012149645598, -83.1758270263672, -1.45169203967939, 218, 50, 'PPL', 'P'),
(92715, 'Bluffton', 30.8205604553223, 0.537920257255336, -98.4911117553711, -1.71899418408092, 218, 51, 'PPL', 'P'),
(114652, 'Bluffton', 43.4030609130859, 0.757526318377006, -91.9116668701172, -1.60416120787974, 218, 16, 'PPL', 'P'),
(122247, 'Bluffton', 40.7386093139648, 0.711022865212315, -85.1716690063477, -1.48652605357957, 218, 19, 'PPL', 'P'),
(134331, 'Bluffton', 46.4691696166992, 0.811040010479113, -95.232780456543, -1.66212557479558, 218, 28, 'PPL', 'P'),
(154377, 'Bluffton', 40.8952789306641, 0.713757265861554, -83.8888931274414, -1.4641373909275, 218, 41, 'PPL', 'P'),
(19365, 'Blufftown (historical)', 32.1941719055176, 0.561894299704339, -84.9497222900391, -1.482652352616, 218, 13, 'PPL', 'P'),
(173240, 'Bluffview', 43.3711090087891, 0.756968652444743, -89.773063659668, -1.56683554046368, 218, 57, 'PPL', 'P'),
(134334, 'Bluffview Park Mobile Home Park', 43.8069381713867, 0.764575306308282, -91.7622222900391, -1.60155290790811, 218, 28, 'PPL', 'P'),
(26562, 'Bluford', 38.3308296203613, 0.668999181896273, -88.725830078125, -1.5485578664283, 218, 18, 'PPL', 'P'),
(85172, 'Bluhmtown', 35.9038887023926, 0.626641072126345, -85.8797225952148, -1.49888391998587, 218, 50, 'PPL', 'P'),
(188164, 'Bluit', 33.6291694641113, 0.58693973185988, -103.183059692383, -1.80088412391393, 218, 38, 'PPL', 'P'),
(92716, 'Blum', 32.1425018310547, 0.56099248678021, -97.3969421386719, -1.69989732169423, 218, 51, 'PPL', 'P'),
(19372, 'Blume', 33.2599983215332, 0.580496479918542, -82.6580581665039, -1.44265526831048, 218, 13, 'PPL', 'P'),
(39411, 'Blume', 32.2713890075684, 0.563241992373973, -92.9902801513672, -1.62298656099329, 218, 22, 'PPL', 'P'),
(180151, 'Blumenberg (historical)', 38.0486106872559, 0.664073532302117, -121.705558776855, -2.12416271863561, 218, 6, 'PPL', 'P'),
(92717, 'Blumenthal', 30.2216701507568, 0.527467649582398, -98.7413864135742, -1.72336230090087, 218, 51, 'PPL', 'P'),
(129875, 'Blumfield Corners', 43.4241714477539, 0.757894766713819, -83.7183303833008, -1.46116050946101, 218, 27, 'PPL', 'P'),
(19366, 'Blun', 32.7011108398438, 0.570742053214882, -82.2972183227539, -1.43635742496466, 218, 13, 'PPL', 'P'),
(19367, 'Blundale', 32.7480583190918, 0.571561441303272, -82.3913879394531, -1.4380009948314, 218, 13, 'PPL', 'P'),
(108287, 'Blundon', 38.5400009155273, 0.672649909697581, -81.5208282470703, -1.42280686186417, 218, 58, 'PPL', 'P'),
(100032, 'Blundon Corner', 37.892219543457, 0.661343991921868, -76.3636093139648, -1.33279641123529, 218, 53, 'PPL', 'P'),
(169857, 'Blunt', 44.5122184753418, 0.776884769761765, -99.9916687011719, -1.74518384339881, 218, 49, 'PPL', 'P'),
(193388, 'Blunt', 40.2419395446777, 0.702354342443134, -122.290000915527, -2.13436315824283, 218, 6, 'PPL', 'P'),
(19368, 'Blunt (historical)', 31.2808303833008, 0.545953482946479, -81.6647186279297, -1.42531822277212, 218, 13, 'PPL', 'P'),
(92718, 'Bluntzer', 27.8969402313232, 0.486893458268659, -97.7827835083008, -1.70663152398466, 218, 51, 'PPL', 'P'),
(206861, 'Blurock Landing', 45.6669387817383, 0.797038441048021, -122.757499694824, -2.14252255119062, 218, 56, 'PPL', 'P'),
(180147, 'Bly', 33.9925003051758, 0.593281051310495, -117.49388885498, -2.05065521149168, 218, 6, 'PPL', 'P'),
(200427, 'Bly', 42.3977813720703, 0.739980880483346, -121.040557861328, -2.11255626313088, 218, 43, 'PPL', 'P'),
(206862, 'Blyn', 48.0224990844727, 0.83815072406001, -123.004722595215, -2.14683740478876, 218, 56, 'PPL', 'P'),
(19369, 'Blystonel', 31.5380592346191, 0.550442973333107, -82.8516693115234, -1.44603442025963, 218, 13, 'PPL', 'P'),
(19370, 'Blythe', 33.2924995422363, 0.581063733230729, -82.2016677856445, -1.43468975349005, 218, 13, 'PPL', 'P'),
(34887, 'Blythe', 36.6763916015625, 0.640123791198062, -85.5488891601563, -1.49310978726841, 218, 21, 'PPL', 'P'),
(180148, 'Blythe', 33.610279083252, 0.586610032516928, -114.595558166504, -2.00006979816617, 218, 6, 'PPL', 'P'),
(196045, 'Blythe', 47.3013916015625, 0.825565024222459, -110.827781677246, -1.93430969294939, 218, 31, 'PPL', 'P'),
(58715, 'Blythe Crossing', 34.7941703796387, 0.60727283362458, -88.168327331543, -1.53882760791153, 218, 30, 'PPL', 'P'),
(19371, 'Blythe Island', 31.1902809143066, 0.544373096576598, -81.5513916015625, -1.42334029303052, 218, 13, 'PPL', 'P'),
(180149, 'Blythe Marina Mobile Estates', 33.607780456543, 0.586566423254078, -114.533889770508, -1.99899348161161, 218, 6, 'PPL', 'P'),
(159345, 'Blytheburn', 41.125560760498, 0.717776441999674, -75.9538879394531, -1.32564542423427, 218, 45, 'PPL', 'P'),
(44908, 'Blythedale', 39.5880584716797, 0.690941964802845, -76.0638885498047, -1.32756529706411, 218, 25, 'PPL', 'P'),
(139044, 'Blythedale', 40.4752807617188, 0.706426914961111, -93.9266662597656, -1.63932958165478, 218, 29, 'PPL', 'P'),
(159346, 'Blythedale', 40.2491683959961, 0.702480509699777, -79.8011093139648, -1.3927921042726, 218, 45, 'PPL', 'P'),
(58716, 'Blythes Chapel', 34.5902786254883, 0.603714251196989, -88.4638900756836, -1.54398615094301, 218, 30, 'PPL', 'P'),
(7570, 'Blytheville', 35.9272193908691, 0.627048269457018, -89.9188919067383, -1.56938072351747, 218, 4, 'PPL', 'P'),
(79848, 'Blythewood', 34.214168548584, 0.59714989200508, -80.9741668701172, -1.41326582094286, 218, 48, 'PPL', 'P'),
(39412, 'Blythwood', 30.1994400024414, 0.527079660301087, -91.2074966430664, -1.59187111892318, 218, 22, 'PPL', 'P'),
(118852, 'Blyton', 40.5641708374023, 0.707978339454136, -90.2763900756836, -1.57562024363541, 218, 18, 'PPL', 'P'),
(180150, 'Boal', 32.6136093139648, 0.569214863487776, -117.088333129883, -2.04357692878841, 218, 6, 'PPL', 'P'),
(159348, 'Boalsburg', 40.7755584716797, 0.711667749670278, -77.7927780151367, -1.35774011063719, 218, 45, 'PPL', 'P'),
(1019, 'Boar Tush', 34.1911087036133, 0.596747421785342, -87.621940612793, -1.52929136068018, 218, 2, 'PPL', 'P'),
(108288, 'Board', 38.9102783203125, 0.679112469556822, -81.9716720581055, -1.43067557077898, 218, 58, 'PPL', 'P'),
(7571, 'Board Camp', 34.5377807617188, 0.602797990623947, -94.0952835083008, -1.64227250781737, 218, 4, 'PPL', 'P'),
(29248, 'Board Park', 39.5927810668945, 0.691024389638583, -86.6699981689453, -1.51267683074555, 218, 19, 'PPL', 'P'),
(34889, 'Board Tree', 37.5386085510254, 0.655172315832691, -82.1622161865234, -1.43400119319021, 218, 21, 'PPL', 'P'),
(85173, 'Board Valley', 36.0402793884277, 0.629021538666712, -85.3752822875977, -1.49007977573818, 218, 50, 'PPL', 'P'),
(100033, 'Boardley', 37.6177787780762, 0.656554096964278, -76.8388900756836, -1.34109162539867, 218, 53, 'PPL', 'P'),
(15277, 'Boardman', 29.4672203063965, 0.514300015757151, -82.2141723632813, -1.43490799954139, 218, 12, 'PPL', 'P'),
(63030, 'Boardman', 34.4388885498047, 0.601071995921467, -78.9494400024414, -1.37792767064832, 218, 33, 'PPL', 'P'),
(154378, 'Boardman', 41.024169921875, 0.716006838034344, -80.6630630493164, -1.40783603495435, 218, 41, 'PPL', 'P'),
(159349, 'Boardman', 40.8777809143066, 0.713451867863549, -78.4636077880859, -1.36944829889556, 218, 45, 'PPL', 'P'),
(173241, 'Boardman', 45.065559387207, 0.786542390559801, -92.5997161865234, -1.61616993386712, 218, 57, 'PPL', 'P'),
(200429, 'Boardman', 45.8400001525879, 0.800058931777362, -119.699440002441, -2.08914934083601, 218, 43, 'PPL', 'P'),
(200428, 'Boardman (historical)', 45.4027786254883, 0.792427976568876, -120.665283203125, -2.10600648474594, 218, 43, 'PPL', 'P'),
(147267, 'Boardmanville', 42.0905609130859, 0.73461887194458, -78.4266662597656, -1.36880354759566, 218, 40, 'PPL', 'P'),
(180152, 'Boards Crossing', 38.3044395446777, 0.668538588185744, -120.233062744141, -2.09846281464218, 218, 6, 'PPL', 'P'),
(126907, 'Boat Landing Camp', 47.2413902282715, 0.824517802702813, -69.220832824707, -1.2081314437637, 218, 26, 'PPL', 'P'),
(7573, 'Boat Run', 35.4580612182617, 0.618859914632379, -90.5208282470703, -1.57988649454366, 218, 4, 'PPL', 'P'),
(85174, 'Boatland', 36.398609161377, 0.6352755730126, -85.0374984741211, -1.48418433603307, 218, 50, 'PPL', 'P'),
(75164, 'Boatman', 36.2583312988281, 0.632827262443463, -95.1841735839844, -1.66127722483034, 218, 42, 'PPL', 'P'),
(39413, 'Boatner (historical)', 32.1974983215332, 0.561952356616102, -92.5472183227539, -1.61525367329408, 218, 22, 'PPL', 'P'),
(34890, 'Boatwright', 36.6441688537598, 0.639561398154864, -88.1236114501953, -1.53804716855408, 218, 21, 'PPL', 'P'),
(85, 'Boaz', 36.7466697692871, 0.641350376617125, -76.7619400024414, -1.33974859326095, 218, 53, 'PPL', 'P'),
(1020, 'Boaz', 34.2005615234375, 0.596912404614872, -86.166389465332, -1.5038872007258, 218, 2, 'PPL', 'P'),
(26563, 'Boaz', 37.2916717529297, 0.650862455661588, -88.8997192382813, -1.55159280480655, 218, 18, 'PPL', 'P'),
(34891, 'Boaz', 36.8855590820313, 0.643774452420342, -88.6344375610352, -1.5469627660934, 218, 21, 'PPL', 'P'),
(53545, 'Boaz', 37.0186080932617, 0.646096595732837, -93.4002838134766, -1.63014247484233, 218, 29, 'PPL', 'P'),
(108290, 'Boaz', 39.3613891601563, 0.686985839003532, -81.5022201538086, -1.42248208936924, 218, 58, 'PPL', 'P'),
(173243, 'Boaz', 43.3313903808594, 0.756275431612996, -90.5258331298828, -1.57997384622742, 218, 57, 'PPL', 'P'),
(188165, 'Boaz', 33.7366714477539, 0.588815995426868, -103.970832824707, -1.81463335883173, 218, 38, 'PPL', 'P'),
(1021, 'Boaz Corner', 33.2733306884766, 0.580729173618788, -86.3013916015625, -1.50624343250025, 218, 2, 'PPL', 'P'),
(112365, 'Bob', 31.475830078125, 0.549356869661545, -92.2736129760742, -1.61047835914346, 218, 22, 'PPL', 'P'),
(63031, 'Bob (historical)', 35.4111099243164, 0.618040459964961, -82.209716796875, -1.43483023523756, 218, 33, 'PPL', 'P'),
(39414, 'Bob Acres', 29.9483299255371, 0.522696962674171, -91.9652786254883, -1.60509690952874, 218, 22, 'PPL', 'P'),
(193389, 'Bob Hoaglin Place', 40.0944404602051, 0.699779997775409, -123.327499389648, -2.15247092260066, 218, 6, 'PPL', 'P'),
(92719, 'Bob Town', 33.1656608581543, 0.578849980574601, -98.3386764526367, -1.71633368615193, 218, 51, 'PPL', 'P'),
(108291, 'Bob White', 37.9541702270508, 0.66242523532444, -81.7186126708984, -1.42625885126914, 218, 58, 'PPL', 'P'),
(159350, 'Bob White Farms', 40.0733299255371, 0.699411549438597, -75.3733291625977, -1.31551276207679, 218, 45, 'PPL', 'P'),
(63033, 'Bob White Fork', 36.1936111450195, 0.631697682667106, -76.2083282470703, -1.33008624535198, 218, 33, 'PPL', 'P'),
(63032, 'Bobbitt', 36.2208290100098, 0.632172724026549, -78.3969421386719, -1.36828476381531, 218, 33, 'PPL', 'P'),
(92720, 'Bobbittville (historical)', 31.5300006866455, 0.550302325138037, -95.272216796875, -1.66281386877931, 218, 51, 'PPL', 'P'),
(159351, 'Bobbys Corners', 41.2013893127441, 0.719099899903389, -80.4561080932617, -1.40422398956787, 218, 45, 'PPL', 'P'),
(79850, 'Bobcat Landing', 33.3369407653809, 0.581839378898214, -81.0199966430664, -1.41406570137626, 218, 48, 'PPL', 'P'),
(19373, 'Bobilin Estates', 33.6152801513672, 0.586697317621655, -84.2708282470703, -1.47080341629402, 218, 13, 'PPL', 'P'),
(1023, 'Bobo', 33.8772201538086, 0.59126903310694, -87.8225021362305, -1.53279181961698, 218, 2, 'PPL', 'P'),
(19374, 'Bobo', 34.4766693115234, 0.601731394607371, -84.6752777099609, -1.47786239107938, 218, 13, 'PPL', 'P'),
(58718, 'Bobo', 34.2841682434082, 0.598371617155154, -90.1758270263672, -1.573865087319, 218, 30, 'PPL', 'P'),
(71860, 'Bobo', 39.0233306884766, 0.681085605608462, -82.9452819824219, -1.44766826958839, 218, 41, 'PPL', 'P'),
(92721, 'Bobo', 31.9244403839111, 0.557186596555892, -94.3252792358398, -1.64628669052845, 218, 51, 'PPL', 'P'),
(34892, 'Bobs Creek', 36.7905616760254, 0.642116434904686, -83.2477798461914, -1.45294785329142, 218, 21, 'PPL', 'P'),
(85175, 'Bobs Cross Roads (historical)', 35.3916702270508, 0.617701173242085, -86.1255569458008, -1.5031745388181, 218, 50, 'PPL', 'P'),
(44912, 'Bobs Flow', 39.6988906860352, 0.692876351860624, -76.4033279418945, -1.33348963206704, 218, 25, 'PPL', 'P'),
(134335, 'Bobs Trailer Court', 43.9972190856934, 0.767896334766638, -92.4319381713867, -1.61324165509053, 218, 28, 'PPL', 'P'),
(29249, 'Bobtown', 39.0194396972656, 0.681017695000665, -85.9461135864258, -1.50004266137616, 218, 19, 'PPL', 'P'),
(34894, 'Bobtown', 37.2177810668945, 0.649572819903718, -84.5369415283203, -1.47544796923512, 218, 21, 'PPL', 'P'),
(39415, 'Bobtown', 29.4736099243164, 0.514411535627798, -90.7008285522461, -1.58302809252358, 218, 22, 'PPL', 'P'),
(77889, 'Bobtown', 39.7611083984375, 0.693962255795104, -79.9816665649414, -1.39594342279049, 218, 45, 'PPL', 'P'),
(85176, 'Bobtown', 35.185001373291, 0.614094121282655, -85.9158325195313, -1.49951415705784, 218, 50, 'PPL', 'P'),
(100034, 'Bobtown', 37.6508293151855, 0.65713093765639, -75.7936096191406, -1.32284803982525, 218, 53, 'PPL', 'P'),
(118853, 'Bobtown', 40.0761108398438, 0.699460085549463, -89.9880599975586, -1.5705879344396, 218, 18, 'PPL', 'P'),
(92722, 'Bobville', 30.3477802276611, 0.529668685644321, -95.7825012207031, -1.67172001209676, 218, 51, 'PPL', 'P'),
(85177, 'Bobwhite (historical)', 36.5436096191406, 0.637806308417475, -86.7652816772461, -1.51433984168825, 218, 50, 'PPL', 'P'),
(92723, 'Bobwyn', 32.6536102294922, 0.56991301116754, -96.5991668701172, -1.68597351656697, 218, 51, 'PPL', 'P'),
(180153, 'Boca', 39.3861083984375, 0.687417271100125, -120.093063354492, -2.09601936434203, 218, 6, 'PPL', 'P'),
(92724, 'Boca Chica and Medford Colonia', 25.9179992675781, 0.452354422748717, -97.4010009765625, -1.69996816177923, 218, 51, 'PPL', 'P'),
(15269, 'Boca Ciega', 27.7602806091309, 0.484508297906871, -82.7663879394531, -1.44454597952638, 218, 12, 'PPL', 'P'),
(15270, 'Boca Del Mar', 26.3447208404541, 0.459802119184692, -80.1469421386719, -1.39882802572521, 218, 12, 'PPL', 'P'),
(15271, 'Boca Grande', 26.7486095428467, 0.46685130685305, -82.2622222900391, -1.43574662896865, 218, 12, 'PPL', 'P'),
(15272, 'Boca Harbour', 26.4122200012207, 0.460980201782402, -80.0725021362305, -1.39752880258741, 218, 12, 'PPL', 'P'),
(15273, 'Boca Pointe', 26.3327808380127, 0.459593726829393, -80.1597213745117, -1.3990510654665, 218, 12, 'PPL', 'P'),
(15274, 'Boca Raton', 26.3583297729492, 0.460039639864413, -80.0833282470703, -1.39771775386676, 218, 12, 'PPL', 'P'),
(15275, 'Boca West', 26.3802795410156, 0.460422735587221, -80.1600036621094, -1.39905599231452, 218, 12, 'PPL', 'P'),
(134336, 'Bock', 45.7849998474121, 0.799098995362443, -93.5566711425781, -1.63287194864355, 218, 28, 'PPL', 'P'),
(100035, 'Bock (historical)', 37.4544410705566, 0.653703316175403, -76.791389465332, -1.34026258335133, 218, 53, 'PPL', 'P'),
(194112, 'Bockman Lumber Camp', 40.5583305358887, 0.707876406963413, -105.965278625488, -1.84944300480794, 218, 7, 'PPL', 'P'),
(159352, 'Bocktown', 40.5433311462402, 0.707614618228259, -80.3002777099609, -1.40150423630463, 218, 45, 'PPL', 'P'),
(100036, 'Bocock', 37.3597183227539, 0.652050092349709, -79.1122207641602, -1.38076873089922, 218, 53, 'PPL', 'P'),
(39416, 'Bodcau', 32.5341682434082, 0.567828355245253, -93.5955581665039, -1.63355065524736, 218, 22, 'PPL', 'P'),
(39418, 'Bodcau Park', 32.5361099243164, 0.567862243970124, -93.5994415283203, -1.6336184326971, 218, 22, 'PPL', 'P'),
(7576, 'Bodcaw', 33.5583305358887, 0.58570335932381, -93.4069366455078, -1.63025858866586, 218, 4, 'PPL', 'P'),
(206863, 'Boddy', 47.6472206115723, 0.831600879096042, -122.228607177734, -2.13329163537824, 218, 56, 'PPL', 'P'),
(114655, 'Bode', 42.8683280944824, 0.748193470073905, -94.289436340332, -1.64566111398839, 218, 16, 'PPL', 'P'),
(180157, 'Bodega', 38.3452796936035, 0.669251383251504, -122.972778320313, -2.14627987201456, 218, 6, 'PPL', 'P'),
(188166, 'Bodega', 34.5519409179688, 0.603045131973107, -106.675277709961, -1.86183482651814, 218, 38, 'PPL', 'P'),
(180158, 'Bodega Bay', 38.3333282470703, 0.669042791159123, -123.046943664551, -2.14757430146239, 218, 6, 'PPL', 'P'),
(15276, 'Boden', 28.8347206115723, 0.503260813564609, -81.126106262207, -1.4159176635983, 218, 12, 'PPL', 'P'),
(118854, 'Boden', 41.2583312988281, 0.720093725043179, -90.5869369506836, -1.58104030908594, 218, 18, 'PPL', 'P'),
(154380, 'Boden', 40.1150016784668, 0.700138858732297, -81.7024993896484, -1.42597762145802, 218, 41, 'PPL', 'P'),
(191145, 'Boden', 35.399169921875, 0.617832067609663, -102.063331604004, -1.78134118204465, 218, 51, 'PPL', 'P'),
(85178, 'Bodenham', 35.2336082458496, 0.614942471247899, -87.1558303833008, -1.52115620249831, 218, 50, 'PPL', 'P'),
(126908, 'Bodfish', 45.3741683959961, 0.791928633864486, -69.4305572509766, -1.21179182552396, 218, 26, 'PPL', 'P'),
(180159, 'Bodfish', 35.5880584716797, 0.621128794723072, -118.491111755371, -2.06806003447978, 218, 6, 'PPL', 'P'),
(180160, 'Bodie', 38.2122192382813, 0.666929040201927, -119.011108398438, -2.07713568800061, 218, 6, 'PPL', 'P'),
(206864, 'Bodie', 48.8327789306641, 0.852292775238604, -118.895561218262, -2.07511900926515, 218, 56, 'PPL', 'P'),
(177728, 'Bodieville Colonia', 30.9090003967285, 0.539463825423146, -102.870002746582, -1.79542024946347, 218, 51, 'PPL', 'P'),
(39419, 'Bodin', 29.8377799987793, 0.520767502464408, -91.6125030517578, -1.59893981424653, 218, 22, 'PPL', 'P'),
(92725, 'Bodine Colonia', 26.2280006408691, 0.457764967398349, -98.3079986572266, -1.71579825761477, 218, 51, 'PPL', 'P'),
(159353, 'Bodines', 41.4502792358398, 0.723443848536444, -76.9727783203125, -1.34342841609716, 218, 45, 'PPL', 'P'),
(44909, 'Bodkin Manor', 39.1347198486328, 0.683029713204219, -76.4552764892578, -1.33439630526016, 218, 25, 'PPL', 'P'),
(44910, 'Bodkin Plains', 39.1111106872559, 0.682617655604557, -76.4822235107422, -1.33486661950867, 218, 25, 'PPL', 'P'),
(71861, 'Bodman', 39.0444412231445, 0.681454053945274, -83.9661102294922, -1.46548508359713, 218, 41, 'PPL', 'P'),
(26564, 'Bodmann', 39.8827781677246, 0.696085793869306, -88.5791702270508, -1.54599816914657, 218, 18, 'PPL', 'P'),
(39420, 'Bodoc', 30.9188899993896, 0.539636431551297, -91.9905624389648, -1.60553819532136, 218, 22, 'PPL', 'P'),
(44911, 'Bodt Corner', 39.5419387817383, 0.690137024363368, -76.2347183227539, -1.3305468390625, 218, 25, 'PPL', 'P'),
(134338, 'Bodum', 45.521671295166, 0.794503045111238, -93.2041702270508, -1.62671964705131, 218, 28, 'PPL', 'P'),
(129878, 'Bodus', 44.9066696166992, 0.783769240916701, -85.7825012207031, -1.49718708689732, 218, 27, 'PPL', 'P'),
(77890, 'Boeckel Landing', 39.8016700744629, 0.694670190591874, -76.3116683959961, -1.33188987120023, 218, 45, 'PPL', 'P'),
(92726, 'Boedecker Junction', 29.478889465332, 0.514503681001515, -96.3591690063477, -1.68178476364644, 218, 51, 'PPL', 'P'),
(75165, 'Boehler', 34.1708297729492, 0.59639348767647, -95.8833312988281, -1.67347982894508, 218, 42, 'PPL', 'P'),
(194617, 'Boehls', 46.8747215270996, 0.818118226603353, -115.904441833496, -2.02291412768076, 218, 17, 'PPL', 'P'),
(53549, 'Boekerton', 36.4038887023926, 0.635367718386317, -89.7619400024414, -1.56664139602021, 218, 29, 'PPL', 'P'),
(169860, 'Boekhoff Subdivision', 43.5433311462402, 0.759974495788089, -96.8402786254883, -1.69018171056346, 218, 49, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(141335, 'Boelus', 41.0738906860352, 0.716874629075546, -98.7152786254883, -1.72290663403835, 218, 35, 'PPL', 'P'),
(134339, 'Boening Mobile Home Park', 43.9333305358887, 0.766781269218222, -93.9574966430664, -1.63986767335303, 218, 28, 'PPL', 'P'),
(100037, 'Boer', 37.7694396972656, 0.659201079350735, -76.5827789306641, -1.33662164266703, 218, 53, 'PPL', 'P'),
(92727, 'Boerne', 29.7944393157959, 0.520011064846285, -98.7316665649414, -1.72319265753943, 218, 51, 'PPL', 'P'),
(7577, 'Boeuf', 33.1986083984375, 0.579425023632976, -91.3797225952148, -1.59487702884556, 218, 4, 'PPL', 'P'),
(39421, 'Boeuf', 29.6611099243164, 0.517684027975287, -91.0961074829102, -1.58992701132743, 218, 22, 'PPL', 'P'),
(126909, 'Bog Corner', 44.8427810668945, 0.782654175368285, -69.3236083984375, -1.20992521591593, 218, 26, 'PPL', 'P'),
(7578, 'Bog Springs', 34.3294410705566, 0.59916177705058, -94.4288864135742, -1.64809497690861, 218, 4, 'PPL', 'P'),
(39422, 'Bogalusa', 30.7908306121826, 0.537401373606448, -89.8486099243164, -1.56815407151937, 218, 22, 'PPL', 'P'),
(39424, 'Boganvilla', 30.5461101531982, 0.533130195850179, -91.065559387207, -1.58939384647719, 218, 22, 'PPL', 'P'),
(53548, 'Bogard', 39.4575004577637, 0.688663297595146, -93.5233306884766, -1.63229004794537, 218, 29, 'PPL', 'P'),
(19375, 'Bogart', 33.9491691589355, 0.592524780139939, -83.5347213745117, -1.45795592772131, 218, 13, 'PPL', 'P'),
(154381, 'Bogart', 41.3958282470703, 0.72249349950145, -82.6511077880859, -1.44253396132283, 218, 41, 'PPL', 'P'),
(92728, 'Bogata', 33.4705581665039, 0.58417144248577, -95.2136077880859, -1.66179094860462, 218, 51, 'PPL', 'P'),
(63034, 'Boger City', 35.4805603027344, 0.619252597735111, -81.2136077880859, -1.41744485332541, 218, 33, 'PPL', 'P'),
(58719, 'Boggan', 31.7947196960449, 0.554922543444675, -89.8788909912109, -1.5686825758377, 218, 30, 'PPL', 'P'),
(58720, 'Boggan Bend', 34.4513893127441, 0.601290175393772, -88.7538909912109, -1.54904762175276, 218, 30, 'PPL', 'P'),
(85179, 'Boggess Crossroad', 35.6016693115234, 0.621366348692307, -84.67138671875, -1.47779448047159, 218, 50, 'PPL', 'P'),
(203071, 'Boggess Meadow Estates', 40.6172218322754, 0.70890425398613, -111.858329772949, -1.95229615031957, 218, 52, 'PPL', 'P'),
(85180, 'Boggs', 36.2683296203613, 0.63300176607389, -83.3944396972656, -1.45550755057315, 218, 50, 'PPL', 'P'),
(108292, 'Boggs', 38.4686088562012, 0.67140388320256, -80.6252822875977, -1.40717663626844, 218, 58, 'PPL', 'P'),
(71862, 'Boggs (historical)', 38.7458305358887, 0.676242314271016, -82.3680572509766, -1.43759379750073, 218, 41, 'PPL', 'P'),
(29251, 'Boggstown', 39.563060760498, 0.690505672437263, -85.916389465332, -1.49952387759581, 218, 19, 'PPL', 'P'),
(159357, 'Boggstown', 40.0741691589355, 0.699426196824592, -77.813606262207, -1.35810363212599, 218, 45, 'PPL', 'P'),
(159358, 'Boggsville', 40.7588882446289, 0.711376799321186, -79.6711120605469, -1.39052322418191, 218, 45, 'PPL', 'P'),
(186427, 'Boggsville', 38.0416717529297, 0.663952425051546, -103.212219238281, -1.80139305399824, 218, 7, 'PPL', 'P'),
(7579, 'Boggy', 33.2247200012207, 0.579880757074516, -93.8866729736328, -1.63863156713307, 218, 4, 'PPL', 'P'),
(19376, 'Boggy', 30.5219402313232, 0.53270835113351, -82.1516723632813, -1.43381716875889, 218, 13, 'PPL', 'P'),
(7580, 'Boggy (historical)', 33.2294387817383, 0.579963115331226, -93.8869400024414, -1.63863622766498, 218, 4, 'PPL', 'P'),
(147268, 'Boght Corners', 42.7830581665039, 0.746705229077742, -73.7447204589844, -1.2870881779721, 218, 40, 'PPL', 'P'),
(15278, 'Bogia', 30.8422203063965, 0.538298292972073, -87.3244400024414, -1.52409899550285, 218, 12, 'PPL', 'P'),
(194618, 'Bogle', 47.3530616760254, 0.826466837146588, -115.736671447754, -2.01998598206222, 218, 17, 'PPL', 'P'),
(29252, 'Bogle Corner', 39.1775016784668, 0.68377639699485, -87.1847229003906, -1.52166047205072, 218, 19, 'PPL', 'P'),
(910, 'Bogota', 36.163890838623, 0.631178965465785, -89.4383316040039, -1.56099336398037, 218, 50, 'PPL', 'P'),
(112292, 'Bogota', 38.9183311462402, 0.679253017883351, -88.2399978637695, -1.54007849467554, 218, 18, 'PPL', 'P'),
(144858, 'Bogota', 40.8761100769043, 0.713422706249613, -74.0302810668945, -1.29207215079413, 218, 37, 'PPL', 'P'),
(7581, 'Bogota (historical)', 33.6816711425781, 0.587856059011949, -91.3436126708984, -1.59424679177359, 218, 4, 'PPL', 'P'),
(31864, 'Bogue', 39.3624992370605, 0.687005213500463, -99.6869430541992, -1.73986537754387, 218, 20, 'PPL', 'P'),
(63035, 'Bogue', 34.6991691589355, 0.605614749529897, -77.0372161865234, -1.3445530690255, 218, 33, 'PPL', 'P'),
(180162, 'Bogue', 39.0980606079102, 0.682389888752328, -121.623893737793, -2.1227373948202, 218, 6, 'PPL', 'P'),
(1024, 'Bogue Chitto', 32.3655586242676, 0.564885562240716, -87.3036117553711, -1.52373547401405, 218, 2, 'PPL', 'P'),
(58723, 'Bogue Chitto', 32.8305587768555, 0.57300134592565, -88.9319381713867, -1.55215513127072, 218, 30, 'PPL', 'P'),
(58724, 'Bogue Toocolo Chitto (historical)', 32.8166694641113, 0.572758931687426, -88.7027816772461, -1.54815559594564, 218, 30, 'PPL', 'P'),
(1025, 'Bogueloosa', 31.9874992370605, 0.558287181165881, -88.3324966430664, -1.54169290292835, 218, 2, 'PPL', 'P'),
(126910, 'Bogues Corner', 44.167781829834, 0.770873216233129, -69.3788909912109, -1.21089007917886, 218, 26, 'PPL', 'P'),
(159359, 'Bogus Corners', 42.060001373291, 0.734085507357265, -79.9313888549805, -1.39506591121131, 218, 45, 'PPL', 'P'),
(7583, 'Bohannon', 35.8061103820801, 0.624934518499822, -92.7838897705078, -1.61938436930285, 218, 4, 'PPL', 'P'),
(100038, 'Bohannon', 37.396671295166, 0.652695043386699, -76.3602828979492, -1.33273835432353, 218, 53, 'PPL', 'P'),
(85182, 'Bohannon Addition', 35.4316711425781, 0.618399320921849, -84.602783203125, -1.47659712324549, 218, 50, 'PPL', 'P'),
(19377, 'Bohanon Crossroad', 33.2705612182617, 0.580680837245003, -84.8677825927734, -1.48122223511063, 218, 13, 'PPL', 'P'),
(63037, 'Bohaynee', 35.0625, 0.611956068980512, -83.0097198486328, -1.44879292251673, 218, 33, 'PPL', 'P'),
(15279, 'Bohemia', 30.4833297729492, 0.532034471509179, -87.1600036621094, -1.52122903995412, 218, 12, 'PPL', 'P'),
(147269, 'Bohemia', 40.7691688537598, 0.711556229799631, -73.1155624389648, -1.27610729900743, 218, 40, 'PPL', 'P'),
(159360, 'Bohemia', 41.496940612793, 0.724258243197791, -75.0677795410156, -1.31017991515196, 218, 45, 'PPL', 'P'),
(200430, 'Bohemia (historical)', 43.5847206115723, 0.760696878233773, -122.652778625488, -2.1406948237345, 218, 43, 'PPL', 'P'),
(44913, 'Bohemia Acres', 39.461669921875, 0.688736068471932, -75.8891677856445, -1.32451584445791, 218, 25, 'PPL', 'P'),
(44914, 'Bohemia Beach', 39.1888885498047, 0.683975135391198, -76.5722198486328, -1.3364373519196, 218, 25, 'PPL', 'P'),
(39425, 'Bohemian', 29.5436096191406, 0.515633260777872, -89.7555618286133, -1.56653007588664, 218, 22, 'PPL', 'P'),
(44915, 'Bohemias Mills', 39.4661102294922, 0.688813566459654, -75.7786102294922, -1.32258625109009, 218, 25, 'PPL', 'P'),
(26565, 'Bohleysville', 38.4152793884277, 0.670473108401578, -90.1186065673828, -1.57286640191022, 218, 18, 'PPL', 'P'),
(200431, 'Bohna (historical)', 43.7805595397949, 0.764114912334835, -117.824996948242, -2.0564341378991, 218, 43, 'PPL', 'P'),
(173244, 'Bohners Lake', 42.6230583190918, 0.743912704937712, -88.2802810668945, -1.54078156920332, 218, 57, 'PPL', 'P'),
(34895, 'Bohon', 37.8116683959961, 0.659938109182415, -84.9197235107422, -1.48212877514569, 218, 21, 'PPL', 'P'),
(173245, 'Bohri (historical)', 44.1450004577637, 0.77047560628238, -91.6025009155273, -1.59876524403707, 218, 57, 'PPL', 'P'),
(58725, 'Boice', 31.7474994659424, 0.554098394955836, -88.6547164916992, -1.54731670020227, 218, 30, 'PPL', 'P'),
(147270, 'Boiceville', 42.0050010681152, 0.733125570942346, -74.2663879394531, -1.29619299310686, 218, 40, 'PPL', 'P'),
(31865, 'Boicourt', 38.2708282470703, 0.667951960376627, -94.7200012207031, -1.65317588879432, 218, 20, 'PPL', 'P'),
(114656, 'Boies', 42.6144409179688, 0.743762302915149, -92.3769378662109, -1.61228171867561, 218, 16, 'PPL', 'P'),
(85181, 'Boiling (historical)', 36.2902793884277, 0.633384861796698, -84.8411102294922, -1.48075671455208, 218, 50, 'PPL', 'P'),
(180163, 'Boiling Point', 34.5222206115723, 0.602526414771786, -118.261390686035, -2.06405064545867, 218, 6, 'PPL', 'P'),
(1029, 'Boiling Spring', 33.6147193908691, 0.586687530504649, -85.7927780151367, -1.49736645079674, 218, 2, 'PPL', 'P'),
(100043, 'Boiling Spring', 37.7799987792969, 0.659385370098169, -78.5880584716797, -1.37162037308063, 218, 53, 'PPL', 'P'),
(79854, 'Boiling Spring (historical)', 33.5436096191406, 0.585446430857645, -81.1002807617188, -1.41546692358381, 218, 48, 'PPL', 'P'),
(63038, 'Boiling Spring Lakes', 34.0302810668945, 0.593940449996398, -78.067497253418, -1.36253486586377, 218, 33, 'PPL', 'P'),
(1027, 'Boiling Springs', 32.1341705322266, 0.560847078184692, -87.4683303833008, -1.52661035641079, 218, 2, 'PPL', 'P'),
(63040, 'Boiling Springs', 35.2541694641113, 0.615301332204788, -81.6672210693359, -1.425361898614, 218, 33, 'PPL', 'P'),
(79852, 'Boiling Springs', 35.0463905334473, 0.611674905748427, -81.9819412231445, -1.43085480152034, 218, 48, 'PPL', 'P'),
(85183, 'Boiling Springs', 36.0722198486328, 0.629579004861893, -85.591667175293, -1.49385640448002, 218, 50, 'PPL', 'P'),
(159361, 'Boiling Springs', 40.1497192382813, 0.700744794459318, -77.1286087036133, -1.34614816936041, 218, 45, 'PPL', 'P'),
(7584, 'Boiling Springs (historical)', 35.4744415283203, 0.619145804975399, -92.9941711425781, -1.62305447160109, 218, 4, 'PPL', 'P'),
(85184, 'Boiling Springs (historical)', 36.622501373291, 0.639183229280073, -87.5105590820313, -1.52734738624247, 218, 50, 'PPL', 'P'),
(108293, 'Bois', 38.7252807617188, 0.67588365305121, -80.4349975585938, -1.40385554123106, 218, 58, 'PPL', 'P'),
(31866, 'Bois d'' Arc', 37.5963897705078, 0.656180788358477, -96.9250030517578, -1.69166043075873, 218, 20, 'PPL', 'P'),
(53551, 'Bois D''Arc', 37.2563896179199, 0.650246666238535, -93.5074996948242, -1.63201374498228, 218, 29, 'PPL', 'P'),
(92730, 'Bois d''Arc', 31.9582500457764, 0.557776686474426, -95.7527084350586, -1.67120002989392, 218, 51, 'PPL', 'P'),
(134341, 'Boisberg', 45.920280456543, 0.80146008740588, -96.5611114501953, -1.6853093241911, 218, 28, 'PPL', 'P'),
(191146, 'Boise', 35.2144393920898, 0.614607911635958, -102.859169006348, -1.79523116502607, 218, 51, 'PPL', 'P'),
(194619, 'Boise', 43.6136093139648, 0.761201081207152, -116.202499389648, -2.02811621339607, 218, 17, 'PPL', 'P'),
(206865, 'Boise', 47.1805610656738, 0.823456133534253, -122.014442443848, -2.12955375563026, 218, 56, 'PPL', 'P'),
(190958, 'Boise City', 36.7294387817383, 0.641049639151028, -102.51277923584, -1.78918552303548, 218, 42, 'PPL', 'P'),
(134342, 'Boise De Sioux Mobile Estates', 46.2544403076172, 0.807292277035099, -96.5894393920898, -1.68580374004748, 218, 28, 'PPL', 'P'),
(194621, 'Boise Hills Village', 43.6324996948242, 0.761530780550104, -116.188888549805, -2.02787865942683, 218, 17, 'PPL', 'P'),
(194622, 'Boise Junction', 43.6049995422363, 0.761050812342644, -116.255828857422, -2.02904698819705, 218, 17, 'PPL', 'P'),
(100041, 'Boissevain', 37.2816696166992, 0.650687885452134, -81.3805618286133, -1.42035875103212, 218, 53, 'PPL', 'P'),
(206866, 'Boistfort', 46.5352783203125, 0.81219382502139, -123.132499694824, -2.1490675358856, 218, 56, 'PPL', 'P'),
(75166, 'Bokchito', 34.017219543457, 0.593712483407087, -96.1425018310547, -1.67800320805658, 218, 42, 'PPL', 'P'),
(15280, 'Bokeelia', 26.7052803039551, 0.466095068972008, -82.1591720581055, -1.43394806312647, 218, 12, 'PPL', 'P'),
(75170, 'Bokhoma', 33.8227806091309, 0.590318883809027, -94.5827789306641, -1.65078090802601, 218, 42, 'PPL', 'P'),
(75168, 'Bokoshe', 35.1863899230957, 0.614118356048574, -94.7855606079102, -1.65432011595667, 218, 42, 'PPL', 'P'),
(108294, 'Bolair', 38.4375, 0.67086093123532, -80.4441680908203, -1.40401559721258, 218, 58, 'PPL', 'P'),
(193390, 'Bolam', 41.5141716003418, 0.724558980663888, -122.248062133789, -2.13363118841722, 218, 6, 'PPL', 'P'),
(114657, 'Bolan', 43.371940612793, 0.756983166672684, -93.1191711425781, -1.62523613316608, 218, 16, 'PPL', 'P'),
(79853, 'Boland Crossroads (historical)', 34.1563911437988, 0.596141486058322, -81.432502746582, -1.42126529106718, 218, 48, 'PPL', 'P'),
(100042, 'Bolar', 38.2172203063965, 0.667016325306655, -79.6766662597656, -1.39062016324559, 218, 53, 'PPL', 'P'),
(58726, 'Bolatusha', 32.922779083252, 0.574610893909467, -89.7022171020508, -1.56559903476955, 218, 30, 'PPL', 'P'),
(139046, 'Bolckow', 40.1130599975586, 0.700104970007426, -94.8219375610352, -1.65495501356055, 218, 29, 'PPL', 'P'),
(85185, 'Bold Spring', 35.9669418334961, 0.627741556867793, -87.6791687011719, -1.53029017924701, 218, 50, 'PPL', 'P'),
(19378, 'Bold Springs', 33.9008293151855, 0.591681090706602, -83.8016662597656, -1.46261499489035, 218, 13, 'PPL', 'P'),
(92731, 'Bold Springs', 30.8343601226807, 0.53816110688642, -94.9851913452148, -1.65780432961082, 218, 51, 'PPL', 'P'),
(39426, 'Bolden', 30.6786098480225, 0.535442751782749, -91.9308319091797, -1.60449570091265, 218, 22, 'PPL', 'P'),
(7586, 'Bolding', 33.083610534668, 0.577417932277438, -92.2291717529297, -1.60970271347597, 218, 4, 'PPL', 'P'),
(34896, 'Boldman', 37.5286102294922, 0.654997812202263, -82.6222229003906, -1.44202982492848, 218, 21, 'PPL', 'P'),
(1030, 'Boldo', 33.853889465332, 0.590861835776267, -87.1827774047852, -1.52162651674682, 218, 2, 'PPL', 'P'),
(92732, 'Boldtville', 29.3633308410645, 0.512486802528971, -98.3605575561523, -1.71671558345225, 218, 51, 'PPL', 'P'),
(196046, 'Bole', 47.7108306884766, 0.832711084375469, -112.01000213623, -1.9549433324431, 218, 31, 'PPL', 'P'),
(19379, 'Bolen', 31.389720916748, 0.547853981279386, -82.4644393920898, -1.43927598320328, 218, 13, 'PPL', 'P'),
(79855, 'Bolen Town', 33.4749984741211, 0.584248940473491, -81.0175018310547, -1.41402215869244, 218, 48, 'PPL', 'P'),
(7587, 'Boles', 34.7794418334961, 0.60701577200036, -94.0488891601563, -1.64146277368793, 218, 4, 'PPL', 'P'),
(34897, 'Boles', 36.6186103820801, 0.639115318672276, -85.664436340332, -1.49512646600388, 218, 21, 'PPL', 'P'),
(53555, 'Boles', 38.5308303833008, 0.672489853716067, -90.8899993896484, -1.586329746485, 218, 29, 'PPL', 'P'),
(85186, 'Boles', 36.6183280944824, 0.639110391824259, -85.6655578613281, -1.49514604023789, 218, 50, 'PPL', 'P'),
(193391, 'Boles', 41.5391693115234, 0.72499527302947, -121.058059692383, -2.11286172770791, 218, 6, 'PPL', 'P'),
(194623, 'Boles', 45.9105606079102, 0.801290444044442, -116.503059387207, -2.03336197495325, 218, 17, 'PPL', 'P'),
(188167, 'Boles Acres', 32.8069381713867, 0.572589088588906, -105.985557556152, -1.84979693891681, 218, 38, 'PPL', 'P'),
(92733, 'Boles Home', 32.9472198486328, 0.57503746573707, -96.1022186279297, -1.6773001335288, 218, 51, 'PPL', 'P'),
(39427, 'Boley', 31.6855602264404, 0.553017351290346, -92.8986129760742, -1.62138666696842, 218, 22, 'PPL', 'P'),
(75172, 'Boley', 35.4933280944824, 0.619475437739323, -96.4833297729492, -1.68395177782544, 218, 42, 'PPL', 'P'),
(1031, 'Boley Springs', 33.6430587768555, 0.587182146098104, -87.5100021362305, -1.52733766570449, 218, 2, 'PPL', 'P'),
(1032, 'Boligee', 32.7558288574219, 0.571697062781784, -88.0288925170898, -1.53639401130742, 218, 2, 'PPL', 'P'),
(193073, 'Bolin', 36.1394386291504, 0.6307521939011, -102.634719848633, -1.79131378822062, 218, 51, 'PPL', 'P'),
(108295, 'Bolin (historical)', 38.103889465332, 0.665038328986026, -82.1438903808594, -1.4336813475433, 218, 58, 'PPL', 'P'),
(180164, 'Bolinas', 37.9094390869141, 0.661644529650883, -122.685279846191, -2.14126207704668, 218, 6, 'PPL', 'P'),
(154383, 'Bolindale', 41.207218170166, 0.71920163265703, -80.7777786254883, -1.40983819946187, 218, 41, 'PPL', 'P'),
(92734, 'Boling', 29.2641696929932, 0.510756114005069, -95.9436111450195, -1.67453191073372, 218, 51, 'PPL', 'P'),
(19380, 'Bolingbroke', 32.9491691589355, 0.575071487619996, -83.8033294677734, -1.46264402334623, 218, 13, 'PPL', 'P'),
(118856, 'Bolingbrook', 41.6986083984375, 0.727778010052494, -88.0683288574219, -1.53708230529115, 218, 18, 'PPL', 'P'),
(1033, 'Bolinger', 31.7783298492432, 0.554636486654086, -88.3311080932617, -1.54166866816243, 218, 2, 'PPL', 'P'),
(39428, 'Bolinger', 32.9441719055176, 0.574984269094296, -93.6975021362305, -1.63532991317164, 218, 22, 'PPL', 'P'),
(39429, 'Bolinger Hillsppl', 32.5980606079102, 0.568943487372697, -93.8861083984375, -1.63862171343703, 218, 22, 'PPL', 'P'),
(100044, 'Bolington', 39.2516708374023, 0.685070893021711, -77.649169921875, -1.35523367657727, 218, 53, 'PPL', 'P'),
(71863, 'Bolins Mills', 39.2308311462402, 0.684707171795833, -82.2850036621094, -1.4361442389194, 218, 41, 'PPL', 'P'),
(1034, 'Bolivar', 34.913330078125, 0.60935256269885, -85.7750015258789, -1.49705619252975, 218, 2, 'PPL', 'P'),
(19381, 'Bolivar', 34.3697204589844, 0.599864784999334, -84.711669921875, -1.47849755499937, 218, 13, 'PPL', 'P'),
(39430, 'Bolivar', 30.8688907623291, 0.538763780241105, -90.3947219848633, -1.57768552506077, 218, 22, 'PPL', 'P'),
(44916, 'Bolivar', 39.4663887023926, 0.688818426728643, -77.5919418334961, -1.35423485801043, 218, 25, 'PPL', 'P'),
(53554, 'Bolivar', 37.6144409179688, 0.656495840315433, -93.4102783203125, -1.63031691189373, 218, 29, 'PPL', 'P'),
(58730, 'Bolivar', 33.6597213745117, 0.587472963289141, -91.0530624389648, -1.58917573358392, 218, 30, 'PPL', 'P'),
(85187, 'Bolivar', 35.2561111450195, 0.615335220929659, -88.9877777099609, -1.55312971507164, 218, 50, 'PPL', 'P'),
(92735, 'Bolivar', 33.3583297729492, 0.582212687504016, -97.245002746582, -1.69724547903879, 218, 51, 'PPL', 'P'),
(108296, 'Bolivar', 39.3233299255371, 0.686321580048639, -77.753059387207, -1.35704688980545, 218, 58, 'PPL', 'P'),
(122248, 'Bolivar', 40.964168548584, 0.714959616514697, -85.7874984741211, -1.49727430542302, 218, 19, 'PPL', 'P'),
(147272, 'Bolivar', 43.0711097717285, 0.751732678004566, -75.8891677856445, -1.32451584445791, 218, 40, 'PPL', 'P'),
(154384, 'Bolivar', 40.6500015258789, 0.709476367567306, -81.4522171020508, -1.42160937148002, 218, 41, 'PPL', 'P'),
(159362, 'Bolivar', 40.3969383239746, 0.705059581478437, -79.1519393920898, -1.38146195173097, 218, 45, 'PPL', 'P'),
(58727, 'Bolivar (historical)', 33.8972206115723, 0.591618106946822, -88.4433288574219, -1.54362728998613, 218, 30, 'PPL', 'P'),
(92736, 'Bolivar Beach', 29.423059463501, 0.513529263648168, -94.6861114501953, -1.65258440071621, 218, 51, 'PPL', 'P'),
(44934, 'Bolivar Heights', 39.4688911437988, 0.68886210257052, -77.5861129760742, -1.35413312525679, 218, 25, 'PPL', 'P'),
(58729, 'Bolivar Landing', 33.666389465332, 0.587589343428777, -91.054443359375, -1.58919983519178, 218, 30, 'PPL', 'P'),
(92737, 'Bolivar Peninsula', 29.4780597686768, 0.514489200063087, -94.579719543457, -1.65072751164615, 218, 51, 'PPL', 'P'),
(26567, 'Bolivia', 39.7422218322754, 0.693632623031179, -89.3469390869141, -1.55939826364547, 218, 18, 'PPL', 'P'),
(63042, 'Bolivia', 34.0675010681152, 0.594590061565296, -78.1486129760742, -1.36395060229926, 218, 33, 'PPL', 'P'),
(189948, 'Bolivia (historical)', 39.9925003051758, 0.698000806430154, -117.912216186523, -2.05795640077819, 218, 39, 'PPL', 'P'),
(206867, 'Bolles', 46.2783317565918, 0.807709261482778, -118.221389770508, -2.0633524977789, 218, 56, 'PPL', 'P'),
(129881, 'Bolles Harbor', 41.8675003051758, 0.730725729905048, -83.3861083984375, -1.45536214197763, 218, 27, 'PPL', 'P'),
(1035, 'Bolling', 31.7252807617188, 0.553710605411607, -86.7058334350586, -1.51330227412756, 218, 2, 'PPL', 'P'),
(63043, 'Bolling', 36.4650001525879, 0.636434314402893, -77.6944427490234, -1.35602383647269, 218, 33, 'PPL', 'P'),
(44917, 'Bollinger Estates', 39.5263900756836, 0.689865648248289, -76.9413909912109, -1.34288060386093, 218, 25, 'PPL', 'P'),
(100045, 'Bollinger Estates', 37.2477798461914, 0.650096397374027, -77.4361114501953, -1.35151510474719, 218, 53, 'PPL', 'P'),
(44918, 'Bollinger Heights', 39.7050018310547, 0.692983011462282, -77.2527770996094, -1.34831531669746, 218, 25, 'PPL', 'P'),
(53557, 'Bollinger Mill', 37.5447196960449, 0.655278975434349, -89.9508285522461, -1.56993812313362, 218, 29, 'PPL', 'P'),
(192893, 'Bollinger Place', 39.8436088562012, 0.695402160417482, -122.878608703613, -2.14463630214781, 218, 6, 'PPL', 'P'),
(200432, 'Bolly (historical)', 44.1736106872559, 0.77097494898677, -122.891670227051, -2.14486426873712, 218, 43, 'PPL', 'P'),
(19393, 'Bolman Estates', 34.2158317565918, 0.597178920460962, -83.7855606079102, -1.46233389823729, 218, 13, 'PPL', 'P'),
(79856, 'Bolon Hall Landing', 32.4194412231445, 0.56582599100065, -80.8516693115234, -1.41112783521974, 218, 48, 'PPL', 'P'),
(180165, 'Bolsa', 33.7449989318848, 0.588961337443359, -117.954170227051, -2.0586886369199, 218, 6, 'PPL', 'P'),
(180171, 'Bolsa Knolls', 36.7338905334473, 0.641127336875831, -121.636940002441, -2.1229650950934, 218, 6, 'PPL', 'P'),
(126911, 'Bolsters Mills', 44.1155586242676, 0.769961749350049, -70.5977783203125, -1.23216367628253, 218, 26, 'PPL', 'P'),
(108297, 'Bolt', 37.7622184753418, 0.659075045252148, -81.4124984741211, -1.42091615064827, 218, 58, 'PPL', 'P'),
(173246, 'Bolt', 44.3419418334961, 0.773912881722318, -87.7052764892578, -1.53074584610952, 218, 57, 'PPL', 'P'),
(112196, 'Bolte', 34.148609161377, 0.596005664842727, -86.8083267211914, -1.51509111943176, 218, 2, 'PPL', 'P'),
(19382, 'Bolton', 33.8141708374023, 0.590168614944519, -84.4533309936523, -1.47398869011581, 218, 13, 'PPL', 'P'),
(31868, 'Bolton', 37.1566696166992, 0.648506223887141, -95.8052825927734, -1.67211762204751, 218, 20, 'PPL', 'P'),
(44920, 'Bolton', 39.214168548584, 0.684416354604796, -75.7808303833008, -1.32262500008396, 218, 25, 'PPL', 'P'),
(58731, 'Bolton', 32.3491706848145, 0.564599538739641, -90.4599990844727, -1.5788248253751, 218, 30, 'PPL', 'P'),
(63044, 'Bolton', 34.3205604553223, 0.599006781075138, -78.4022216796875, -1.36837690918903, 218, 33, 'PPL', 'P'),
(85188, 'Bolton', 35.3211097717285, 0.616469660975005, -89.7605590820313, -1.56661729441234, 218, 50, 'PPL', 'P'),
(100046, 'Bolton', 36.8047218322754, 0.642363576253846, -82.1977767944336, -1.43462184288226, 218, 53, 'PPL', 'P'),
(114658, 'Bolton', 41.2586097717285, 0.720098585312169, -92.7358322143555, -1.61854560671753, 218, 16, 'PPL', 'P'),
(118857, 'Bolton', 42.2419395446777, 0.737260927483021, -89.7252807617188, -1.56600157156832, 218, 18, 'PPL', 'P'),
(124267, 'Bolton', 42.4333305358887, 0.740601330438307, -71.6083297729492, -1.24980112639185, 218, 23, 'PPL', 'P'),
(129882, 'Bolton', 45.1813888549805, 0.78856399614328, -83.5897216796875, -1.45891586413623, 218, 27, 'PPL', 'P'),
(139047, 'Bolton', 40.2252807617188, 0.702063591831125, -93.8349990844727, -1.63772968762991, 218, 29, 'PPL', 'P'),
(147274, 'Bolton', 43.5363883972168, 0.75985332195849, -73.6680603027344, -1.28575020584045, 218, 40, 'PPL', 'P'),
(154385, 'Bolton', 40.9397201538086, 0.714532911529039, -81.1152801513672, -1.41572871231896, 218, 41, 'PPL', 'P'),
(171756, 'Bolton', 44.3727798461914, 0.774451106578623, -72.8811111450195, -1.27201535199253, 218, 55, 'PPL', 'P'),
(177514, 'Bolton', 41.7688903808594, 0.729004662050584, -72.4338912963867, -1.26420989315361, 218, 8, 'PPL', 'P'),
(200433, 'Bolton', 45.371940612793, 0.791889751712571, -122.623893737793, -2.14019068734014, 218, 43, 'PPL', 'P'),
(85189, 'Bolton Estates', 36.1911087036133, 0.631654006825228, -82.7874984741211, -1.44491442786319, 218, 50, 'PPL', 'P'),
(147278, 'Bolton Landing', 43.5572204589844, 0.760216910026313, -73.6552810668945, -1.28552716609915, 218, 40, 'PPL', 'P'),
(171754, 'Boltonville', 44.1708297729492, 0.770926412875903, -72.1002807617188, -1.25838729090432, 218, 55, 'PPL', 'P'),
(173247, 'Boltonville', 43.5272216796875, 0.759693332556003, -88.1005630493164, -1.53764489807143, 218, 57, 'PPL', 'P'),
(34899, 'Boltsfork', 38.2630615234375, 0.667816405477142, -82.6997222900391, -1.44338244444613, 218, 21, 'PPL', 'P'),
(159363, 'Boltz', 40.4208297729492, 0.705476565926116, -79.003059387207, -1.37886350545538, 218, 45, 'PPL', 'P'),
(39431, 'Bolwood Acres', 30.5955600738525, 0.533993259780446, -91.1322174072266, -1.59055724839939, 218, 22, 'PPL', 'P'),
(34898, 'Bolyn', 37.4436111450195, 0.653514298317035, -82.9061126708984, -1.44698463613657, 218, 21, 'PPL', 'P'),
(85190, 'Boma', 36.1269416809082, 0.630534081007823, -85.682502746582, -1.49544178427694, 218, 50, 'PPL', 'P'),
(1036, 'Bomar', 34.1086082458496, 0.595307517162963, -85.5802764892578, -1.49365759950464, 218, 2, 'PPL', 'P'),
(92738, 'Bomarton', 33.5074996948242, 0.584816193785678, -99.4258270263672, -1.73530804312847, 218, 51, 'PPL', 'P'),
(79857, 'Bombaretta (historical)', 33.1444396972656, 0.578479601445998, -80.0400009155273, -1.39696154927523, 218, 48, 'PPL', 'P'),
(129883, 'Bombay', 43.7416687011719, 0.763436139152001, -84.2663879394531, -1.4707259183063, 218, 27, 'PPL', 'P'),
(134343, 'Bombay', 44.2836112976074, 0.772894821816608, -92.8913879394531, -1.62126056629081, 218, 28, 'PPL', 'P'),
(147276, 'Bombay', 44.9388885498047, 0.784331567380872, -74.5680618286133, -1.30145819574001, 218, 40, 'PPL', 'P'),
(180175, 'Bombay', 38.686939239502, 0.6752144672483, -121.47917175293, -2.12021151968431, 218, 6, 'PPL', 'P'),
(180176, 'Bombay Beach', 33.350830078125, 0.582081793136439, -115.728889465332, -2.01985016084662, 218, 6, 'PPL', 'P'),
(39432, 'Bomer', 32.5988883972168, 0.56895793502161, -91.1830596923828, -1.59144461367461, 218, 22, 'PPL', 'P'),
(58732, 'Bommers', 33.0555610656738, 0.576928376690054, -90.6963882446289, -1.58295059453585, 218, 30, 'PPL', 'P'),
(108298, 'Bomont', 38.4497184753418, 0.671074183859608, -81.2324981689453, -1.41777455266836, 218, 58, 'PPL', 'P'),
(171755, 'Bomoseen', 43.6436080932617, 0.761724658677461, -73.1991729736328, -1.27756657812674, 218, 55, 'PPL', 'P'),
(34908, 'Bon', 36.723331451416, 0.640943046128397, -84.1916732788086, -1.46942190147854, 218, 21, 'PPL', 'P'),
(177760, 'Bon', 32.9713897705078, 0.575459310453739, -111.907783508301, -1.95315928082886, 218, 5, 'PPL', 'P'),
(1037, 'Bon Acre Landing', 32.2863883972168, 0.563503781109128, -84.9247207641602, -1.48221599367139, 218, 2, 'PPL', 'P'),
(1038, 'Bon Air', 33.2636108398438, 0.58055953025735, -86.335563659668, -1.50683984742637, 218, 2, 'PPL', 'P'),
(39433, 'Bon Air', 30.190559387207, 0.526924664325644, -93.0255584716797, -1.62360228383731, 218, 22, 'PPL', 'P'),
(63048, 'Bon Air', 36.1283302307129, 0.630558315773743, -80.2422180175781, -1.40049090350986, 218, 33, 'PPL', 'P'),
(70557, 'Bon Air', 39.9691696166992, 0.697593609099481, -75.0233306884766, -1.30940413632642, 218, 37, 'PPL', 'P'),
(85192, 'Bon Air', 35.9411087036133, 0.627290683695243, -85.3625030517578, -1.48985673599688, 218, 50, 'PPL', 'P'),
(100048, 'Bon Air', 37.5247192382813, 0.654929901594466, -77.5580596923828, -1.35364350309038, 218, 53, 'PPL', 'P'),
(159364, 'Bon Air', 40.3377799987793, 0.704027073923813, -78.8691711425781, -1.37652671475689, 218, 45, 'PPL', 'P'),
(34900, 'Bon Air Estates', 38.2127799987793, 0.666938827318934, -85.6577835083008, -1.49501035218035, 218, 21, 'PPL', 'P'),
(154386, 'Bon Air Estates', 40.6602783203125, 0.709655731466723, -81.1305618286133, -1.41599542790213, 218, 41, 'PPL', 'P'),
(34901, 'Bon Air Hills', 38.1927795410156, 0.666589753479051, -84.8252792358398, -1.48048041158898, 218, 21, 'PPL', 'P'),
(100049, 'Bon Air Manor', 37.5138893127441, 0.654740883736098, -77.541389465332, -1.35335255274129, 218, 53, 'PPL', 'P'),
(71864, 'Bon Air Mobile Home Park', 39.9355583190918, 0.697006981290364, -83.7619400024414, -1.46192164090055, 218, 41, 'PPL', 'P'),
(79858, 'Bon Air Terrace', 33.9413909912109, 0.592389025503373, -80.3794403076172, -1.40288588427816, 218, 48, 'PPL', 'P'),
(79859, 'Bon Aire', 32.3944396972656, 0.56538963205604, -80.7433319091797, -1.40923699084578, 218, 48, 'PPL', 'P'),
(15283, 'Bon Ami', 30.1144409179688, 0.525596146415858, -84.9872207641602, -1.48330682445389, 218, 12, 'PPL', 'P'),
(39434, 'Bon Ami', 30.8075008392334, 0.537692323955539, -93.2949981689453, -1.62830489369018, 218, 22, 'PPL', 'P'),
(92739, 'Bon Ami', 30.7133293151855, 0.536048720799283, -93.8824996948242, -1.63855872967725, 218, 51, 'PPL', 'P'),
(85193, 'Bon Aqua', 35.9533309936523, 0.627504002898558, -87.3269424438477, -1.52414267134473, 218, 50, 'PPL', 'P'),
(85194, 'Bon Aqua Junction', 35.9277801513672, 0.627058056574024, -87.3108291625977, -1.52386144153361, 218, 50, 'PPL', 'P'),
(34902, 'Bon Ayr', 37.0244407653809, 0.646198395065505, -86.0588912963867, -1.50201100373784, 218, 21, 'PPL', 'P'),
(13401, 'Bon Ayre', 39.7802810668945, 0.694296881986072, -75.6711120605469, -1.32071005410213, 218, 10, 'PPL', 'P'),
(39435, 'Bon Dickey', 30.5483303070068, 0.53316894484404, -91.0263900756836, -1.58871021302537, 218, 22, 'PPL', 'P'),
(34903, 'Bon Haven', 38.0047187805176, 0.663307474014556, -84.1958312988281, -1.46949447261824, 218, 21, 'PPL', 'P'),
(44921, 'Bon Haven', 38.9672203063965, 0.680106294696612, -76.5919418334961, -1.33678156549049, 218, 25, 'PPL', 'P'),
(169862, 'Bon Homme Colony', 42.8641700744629, 0.7481208989342, -97.706672668457, -1.70530313923293, 218, 49, 'PPL', 'P'),
(159366, 'Bon Meade', 40.5461082458496, 0.707663087760098, -80.2402801513672, -1.40045708136401, 218, 45, 'PPL', 'P'),
(1039, 'Bon Secour', 30.3152809143066, 0.529101465621648, -87.7294387817383, -1.53116755766814, 218, 2, 'PPL', 'P'),
(39436, 'Bon Secours Plantation', 29.9941692352295, 0.523497009555144, -90.8411102294922, -1.58547646967174, 218, 22, 'PPL', 'P'),
(15281, 'Bon Terra', 29.5813903808594, 0.516292659463775, -81.1883316040039, -1.41700370069084, 218, 12, 'PPL', 'P'),
(92740, 'Bon Wier', 30.7397193908691, 0.536509314509812, -93.6430587768555, -1.6343796972947, 218, 51, 'PPL', 'P'),
(1040, 'Bon-Air', 33.4444389343262, 0.583715575886175, -86.9327774047852, -1.51726319361683, 218, 2, 'PPL', 'P'),
(114659, 'Bon-Aire Mobile Home Lodge', 41.6291694641113, 0.726566072019426, -91.4944381713867, -1.59687919335308, 218, 16, 'PPL', 'P'),
(53558, 'Bona', 37.5447196960449, 0.655278975434349, -93.67138671875, -1.63487411315108, 218, 29, 'PPL', 'P'),
(92741, 'Bona', 33.7113914489746, 0.588374776213269, -96.4747161865234, -1.6838014423819, 218, 51, 'PPL', 'P'),
(19384, 'Bona Bella', 32.0138893127441, 0.55874777487641, -81.0661087036133, -1.41487050865768, 218, 13, 'PPL', 'P'),
(192876, 'Bona Venture Mobile Home Park', 33.648609161377, 0.587279018582756, -112.063056945801, -1.95586931355412, 218, 5, 'PPL', 'P'),
(180177, 'Bonadelle Ranchos Five', 36.9930610656738, 0.645650715987331, -119.981941223145, -2.09407991727818, 218, 6, 'PPL', 'P'),
(180178, 'Bonadelle Ranchos Nine', 36.9599990844727, 0.645073675558138, -119.797218322754, -2.09085589446253, 218, 6, 'PPL', 'P'),
(7589, 'Bonair', 34.9494400024414, 0.609982799770818, -90.7908325195313, -1.58459895809256, 218, 4, 'PPL', 'P'),
(19385, 'Bonair', 33.5222206115723, 0.585073122251843, -82.0483322143555, -1.43201354291063, 218, 13, 'PPL', 'P'),
(114660, 'Bonair', 43.4219398498535, 0.757855817982876, -92.192497253418, -1.60906262270797, 218, 16, 'PPL', 'P'),
(159367, 'Bonair', 40.1863899230957, 0.701384818648291, -75.0980606079102, -1.31070841947029, 218, 45, 'PPL', 'P'),
(19386, 'Bonaire', 32.5436096191406, 0.567993138337702, -83.5961074829102, -1.45902731742785, 218, 13, 'PPL', 'P'),
(79861, 'Bonaire Acres', 34.9241714477539, 0.609541780294301, -82.2399978637695, -1.43535873955588, 218, 48, 'PPL', 'P'),
(39439, 'Bonaire Estates', 30.4630603790283, 0.531680703847876, -90.4972229003906, -1.57947450352303, 218, 22, 'PPL', 'P'),
(19388, 'Bonaire Heights', 32.5422210693359, 0.567968903571782, -83.5994415283203, -1.45908550749767, 218, 13, 'PPL', 'P'),
(92742, 'Bonaldo', 31.5174999237061, 0.550084145665732, -94.8083267211914, -1.65471745959131, 218, 51, 'PPL', 'P'),
(7590, 'Bonanza', 35.2391700744629, 0.615039543469633, -94.4258270263672, -1.64804158052875, 218, 4, 'PPL', 'P'),
(19389, 'Bonanza', 33.4655609130859, 0.58408422396007, -84.336669921875, -1.47195257030439, 218, 13, 'PPL', 'P'),
(34904, 'Bonanza', 37.6919403076172, 0.657848459833084, -82.8638916015625, -1.44624773946294, 218, 21, 'PPL', 'P'),
(53559, 'Bonanza', 39.6441688537598, 0.691921275714694, -93.9725036621094, -1.64012959524624, 218, 29, 'PPL', 'P'),
(92743, 'Bonanza', 32.9808311462402, 0.575624093546188, -95.7202835083008, -1.67063410816228, 218, 51, 'PPL', 'P'),
(186428, 'Bonanza', 38.2947196960449, 0.668368944824306, -106.141670227051, -1.85252161902807, 218, 7, 'PPL', 'P'),
(194624, 'Bonanza', 44.3705596923828, 0.774412357584762, -114.726936340332, -2.00236277986473, 218, 17, 'PPL', 'P'),
(200434, 'Bonanza', 42.1988906860352, 0.736509583160482, -121.404998779297, -2.11891695707843, 218, 43, 'PPL', 'P'),
(203075, 'Bonanza', 40.021110534668, 0.698500149134544, -109.176666259766, -1.90549229258391, 218, 52, 'PPL', 'P'),
(79862, 'Bonanza (historical)', 33.6202812194824, 0.586784602726383, -80.1916732788086, -1.39960873139877, 218, 48, 'PPL', 'P'),
(188168, 'Bonanza City (historical)', 35.538890838623, 0.620270657640821, -106.119438171387, -1.85213359645725, 218, 38, 'PPL', 'P'),
(134344, 'Bonanza Grove', 45.4455604553223, 0.793174660359507, -96.7091674804688, -1.68789338939681, 218, 28, 'PPL', 'P'),
(63047, 'Bonanza Hills', 36.1811103820801, 0.631479503194801, -80.07861328125, -1.39763546218907, 218, 33, 'PPL', 'P'),
(186429, 'Bonanza Mountain Estates', 39.9766693115234, 0.697724503467059, -105.479721069336, -1.84096842674515, 218, 7, 'PPL', 'P'),
(180179, 'Bonanza Springs', 38.8644409179688, 0.678312455965362, -122.685829162598, -2.14127166442661, 218, 6, 'PPL', 'P'),
(7591, 'Bonanza Springs (historical)', 34.5583305358887, 0.603156651843754, -93.084716796875, -1.62463479139194, 218, 4, 'PPL', 'P'),
(114661, 'Bonaparte', 40.6980590820313, 0.710315130152626, -91.8030624389648, -1.60226570297387, 218, 16, 'PPL', 'P'),
(44922, 'Bonaparte Estates', 39.461109161377, 0.688726281354926, -76.4588928222656, -1.33445942217799, 218, 25, 'PPL', 'P'),
(144860, 'Bonaparte Landing', 40.9536094665527, 0.714775325767264, -74.6399993896484, -1.30271374303592, 218, 37, 'PPL', 'P'),
(15282, 'Bonaventure', 28.273609161377, 0.493467571288061, -80.6936111450195, -1.40836919980458, 218, 12, 'PPL', 'P'),
(44923, 'Bonaventure', 39.0852813720703, 0.682166849011034, -76.6944427490234, -1.33857054395275, 218, 25, 'PPL', 'P'),
(19390, 'Bonaventure (historical)', 32.0449981689453, 0.55929072684365, -81.0511093139648, -1.41460871992253, 218, 13, 'PPL', 'P'),
(186430, 'Boncarbo', 37.2166709899902, 0.649553445406787, -104.694442749023, -1.82726273451116, 218, 7, 'PPL', 'P'),
(19391, 'Bond', 34.2297210693359, 0.597421334699186, -83.1875, -1.45189577150278, 218, 13, 'PPL', 'P'),
(34905, 'Bond', 37.3158302307129, 0.651284100641175, -83.9861068725586, -1.46583409085799, 218, 21, 'PPL', 'P'),
(39440, 'Bond', 30.6908302307129, 0.535656037696551, -92.6127777099609, -1.61639790045643, 218, 22, 'PPL', 'P'),
(58734, 'Bond', 30.8941707611084, 0.539204999454704, -89.1686096191406, -1.55628582727949, 218, 30, 'PPL', 'P'),
(75173, 'Bond', 34.8141708374023, 0.607621907464462, -95.654167175293, -1.66948016046195, 218, 42, 'PPL', 'P'),
(85195, 'Bond', 35.7241706848145, 0.62350440099445, -87.4005584716797, -1.52542751341263, 218, 50, 'PPL', 'P'),
(186431, 'Bond', 39.874439239502, 0.695940252115733, -106.686668395996, -1.86203363149351, 218, 7, 'PPL', 'P'),
(196047, 'Bond', 45.3058280944824, 0.790735870591267, -112.66471862793, -1.96637029089036, 218, 31, 'PPL', 'P'),
(71865, 'Bond Hill', 39.1747207641602, 0.683727860883984, -84.4672164916992, -1.47423103777501, 218, 41, 'PPL', 'P'),
(44924, 'Bond Mill Park', 39.1111106872559, 0.682617655604557, -76.8988876342773, -1.34213878033929, 218, 25, 'PPL', 'P'),
(186432, 'Bondad', 37.0458297729492, 0.646571703671307, -107.875556945801, -1.88278365112686, 218, 7, 'PPL', 'P'),
(79864, 'Bondale', 35.0138893127441, 0.61110765243624, -82.0283279418945, -1.43166440249172, 218, 48, 'PPL', 'P'),
(44925, 'Bondbrook', 39.1097183227539, 0.68259335425961, -77.2816696166992, -1.34881958624987, 218, 25, 'PPL', 'P'),
(71866, 'Bondclay', 38.7127799987793, 0.675665473578905, -82.726936340332, -1.44385741922654, 218, 41, 'PPL', 'P'),
(29253, 'Bonds', 38.6811103820801, 0.675112734494659, -86.6294403076172, -1.51196896252781, 218, 19, 'PPL', 'P'),
(143531, 'Bonds Corner', 42.901668548584, 0.748775370772087, -72.0250015258789, -1.25707342038053, 218, 36, 'PPL', 'P'),
(180180, 'Bonds Corner', 32.6936111450195, 0.570611158847304, -115.336387634277, -2.01299971157461, 218, 6, 'PPL', 'P'),
(79863, 'Bonds Crossroads', 34.4441719055176, 0.601164207874211, -81.7727813720703, -1.42720427345611, 218, 48, 'PPL', 'P'),
(177761, 'Bonds Trailer Park', 33.4155616760254, 0.583211572649878, -111.844436645508, -1.95205366950231, 218, 5, 'PPL', 'P'),
(7593, 'Bondsville', 35.6411094665527, 0.622054709255065, -90.2486114501953, -1.57513541515896, 218, 4, 'PPL', 'P'),
(124269, 'Bondsville', 42.2125015258789, 0.736747137129717, -72.345832824707, -1.26267298288853, 218, 23, 'PPL', 'P'),
(159369, 'Bondsville', 40.021671295166, 0.69850993625155, -75.7608337402344, -1.3222759928231, 218, 45, 'PPL', 'P'),
(100050, 'Bondtown', 36.9505615234375, 0.644908959044716, -82.470832824707, -1.43938756965295, 218, 53, 'PPL', 'P'),
(173248, 'Bonduel', 44.7402801513672, 0.780865196906024, -88.4447174072266, -1.54365152475205, 218, 57, 'PPL', 'P'),
(34906, 'Bondurant', 36.5233306884766, 0.637452374308603, -89.3197174072266, -1.558923155707, 218, 21, 'PPL', 'P'),
(114663, 'Bondurant', 41.7005615234375, 0.727812098514447, -93.4619369506836, -1.63121852508078, 218, 16, 'PPL', 'P'),
(209317, 'Bondurant', 43.2030601501465, 0.754035646557212, -110.408058166504, -1.92698413573891, 218, 59, 'PPL', 'P'),
(100051, 'Bondurant (historical)', 36.8191719055176, 0.642615777609076, -83.0449981689453, -1.44940864536076, 218, 53, 'PPL', 'P'),
(34907, 'Bondville', 37.9216690063477, 0.661857982012253, -84.871940612793, -1.48129480625033, 218, 21, 'PPL', 'P'),
(118858, 'Bondville', 40.1133308410645, 0.700109697118361, -88.3694381713867, -1.54233765422826, 218, 18, 'PPL', 'P'),
(171757, 'Bondville', 43.144718170166, 0.75301738691442, -72.876106262207, -1.27192800030877, 218, 55, 'PPL', 'P'),
(19392, 'Bone', 34.2911109924316, 0.598492790984753, -85.3305587768555, -1.48929920322267, 218, 13, 'PPL', 'P'),
(194625, 'Bone', 43.3125, 0.755945732270044, -111.794441223145, -1.95118108477115, 218, 17, 'PPL', 'P'),
(85196, 'Bone Cave', 35.7750015258789, 0.624391566532582, -85.5849990844727, -1.49374002434038, 218, 50, 'PPL', 'P'),
(196048, 'Bone Crossing', 48.521110534668, 0.846853135554062, -107.328887939453, -1.87324247704749, 218, 31, 'PPL', 'P'),
(26571, 'Bone Gap', 38.4474983215332, 0.671035434865748, -87.9958267211914, -1.5358169042992, 218, 18, 'PPL', 'P'),
(7594, 'Bone Town', 36.0447196960449, 0.629099036654434, -91.7763900756836, -1.60180018241533, 218, 4, 'PPL', 'P'),
(192494, 'Bone Valley', 38.125560760498, 0.665416564439844, -112.40193939209, -1.96178392801908, 218, 52, 'PPL', 'P'),
(196049, 'Boneau', 48.2905616760254, 0.842829298884034, -109.860557556152, -1.91742844743159, 218, 31, 'PPL', 'P'),
(201921, 'Boneita Springs', 44.4449996948242, 0.775711580722558, -102.561943054199, -1.79004359353871, 218, 49, 'PPL', 'P'),
(177762, 'Bonelli Landing', 36.0833282470703, 0.629772882989251, -114.481109619141, -1.99807229419056, 218, 5, 'PPL', 'P'),
(79866, 'Boneo', 34.3861083984375, 0.600150808500409, -82.3861083984375, -1.43790884945769, 218, 48, 'PPL', 'P'),
(63049, 'Bones Ford', 35.1188888549805, 0.612940240161351, -79.0802764892578, -1.38021119812501, 218, 33, 'PPL', 'P'),
(169865, 'Bonesteel', 43.0763893127441, 0.751824823378283, -98.9441680908203, -1.72690150883153, 218, 49, 'PPL', 'P'),
(154388, 'Boneta', 41.0994415283203, 0.71732057540008, -81.7752838134766, -1.42724794929799, 218, 41, 'PPL', 'P'),
(203078, 'Boneta', 40.3597183227539, 0.704409969909539, -110.340827941895, -1.92581074696262, 218, 52, 'PPL', 'P'),
(198025, 'Bonetraill', 48.416389465332, 0.845025408097941, -103.83805847168, -1.8123160092092, 218, 34, 'PPL', 'P'),
(180181, 'Bonetti', 38.6747207641602, 0.675001214624012, -120.45361328125, -2.10231214768178, 218, 6, 'PPL', 'P'),
(19394, 'Boneville', 33.4333305358887, 0.583521697758818, -82.4388885498047, -1.43883003687875, 218, 13, 'PPL', 'P'),
(79865, 'Boney', 34.2455596923828, 0.597697770820337, -80.9638900756836, -1.41308645704344, 218, 48, 'PPL', 'P'),
(177763, 'Boneyard', 33.8791694641113, 0.591303054989866, -109.271667480469, -1.9071503766786, 218, 5, 'PPL', 'P'),
(34910, 'Boneyville', 37.5052795410156, 0.65459061487159, -84.6916732788086, -1.47814854773851, 218, 21, 'PPL', 'P'),
(44926, 'Bonfield', 38.6783294677734, 0.675064198383793, -76.164436340332, -1.32932018706441, 218, 25, 'PPL', 'P'),
(118861, 'Bonfield', 41.146671295166, 0.718144890336487, -88.0577774047852, -1.53689814770177, 218, 18, 'PPL', 'P'),
(196050, 'Bonfield', 46.6327781677246, 0.813895518378923, -105.570831298828, -1.84255860023203, 218, 31, 'PPL', 'P'),
(53561, 'Bonfils', 38.7691688537598, 0.676649644759744, -90.4400024414063, -1.57847581811425, 218, 29, 'PPL', 'P'),
(39441, 'Bonfouca', 30.2688903808594, 0.528291798071237, -89.8444366455078, -1.56808123406356, 218, 22, 'PPL', 'P'),
(134346, 'Bonga Landing', 47.3738899230957, 0.826830358635383, -95.4841690063477, -1.66651313269149, 218, 28, 'PPL', 'P'),
(26573, 'Bongard', 39.9241714477539, 0.696808242894017, -88.1236114501953, -1.53804716855408, 218, 18, 'PPL', 'P'),
(134347, 'Bongards', 44.7625007629395, 0.781253019739767, -93.8483276367188, -1.63796231475113, 218, 28, 'PPL', 'P'),
(53560, 'Bonham', 36.9422187805176, 0.644763350712116, -93.6344375610352, -1.63422922869311, 218, 29, 'PPL', 'P'),
(79873, 'Bonham', 34.776668548584, 0.606967369047548, -81.6466674804688, -1.42500317081516, 218, 48, 'PPL', 'P'),
(85197, 'Bonham', 35.7205581665039, 0.623441350655642, -84.8963928222656, -1.48172157781502, 218, 50, 'PPL', 'P'),
(92744, 'Bonham', 33.577220916748, 0.586033058666762, -96.1780624389648, -1.67862385774862, 218, 51, 'PPL', 'P'),
(39444, 'Bonham Landing', 32.7555618286133, 0.571692402249876, -94.0369415283203, -1.64125424817458, 218, 22, 'PPL', 'P'),
(144861, 'Bonhamtown', 40.5233306884766, 0.707265544388377, -74.3580627441406, -1.29779302028978, 218, 37, 'PPL', 'P'),
(58735, 'Bonhomie', 31.288890838623, 0.546094164431062, -89.3097229003906, -1.5587487186556, 218, 30, 'PPL', 'P'),
(211706, 'Bonibrook', 61.1997184753418, 1.06813658868832, -149.774169921875, -2.61405239957818, 218, 1, 'PPL', 'P'),
(85198, 'Bonicord', 35.9544410705566, 0.627523377395488, -89.3216705322266, -1.55895724416895, 218, 50, 'PPL', 'P'),
(15284, 'Bonifay', 30.7916698455811, 0.537416020992443, -85.6797180175781, -1.49539318158705, 218, 12, 'PPL', 'P'),
(147279, 'Bonila', 42.1152801513672, 0.735050304041173, -79.2819366455078, -1.38373083182166, 218, 40, 'PPL', 'P'),
(169868, 'Bonilla', 44.5827789306641, 0.778116282028845, -98.498893737793, -1.71913000529651, 218, 49, 'PPL', 'P'),
(180182, 'Bonilla', 38.2780609130859, 0.668078194212297, -122.436668395996, -2.13692298868262, 218, 6, 'PPL', 'P'),
(1041, 'Bonita', 32.5444412231445, 0.568007652565643, -86.8283309936523, -1.51544025985067, 218, 2, 'PPL', 'P'),
(31869, 'Bonita', 38.8111114501953, 0.677381681164379, -94.8144378662109, -1.65482411919297, 218, 20, 'PPL', 'P'),
(34909, 'Bonita', 38.0858306884766, 0.664723143871015, -84.7080612182617, -1.47843457123959, 218, 21, 'PPL', 'P'),
(39442, 'Bonita', 32.9191703796387, 0.574547910149687, -91.6769409179688, -1.60006446717487, 218, 22, 'PPL', 'P'),
(58736, 'Bonita', 32.3652801513672, 0.564880701971726, -88.6658325195313, -1.54751071148768, 218, 30, 'PPL', 'P'),
(92745, 'Bonita', 33.7588882446289, 0.589203751681583, -97.5941696166992, -1.70333959056121, 218, 51, 'PPL', 'P'),
(173251, 'Bonita', 45.1197204589844, 0.787487679588724, -88.458610534668, -1.5438940055693, 218, 57, 'PPL', 'P'),
(177764, 'Bonita', 32.5897216796875, 0.568797945619124, -109.968612670898, -1.91931436495753, 218, 5, 'PPL', 'P'),
(180184, 'Bonita', 32.6577796936035, 0.569985782044326, -117.029167175293, -2.04254428807573, 218, 6, 'PPL', 'P'),
(186433, 'Bonita', 38.232780456543, 0.667287901158816, -106.21443939209, -1.85379168055193, 218, 7, 'PPL', 'P'),
(200436, 'Bonita', 45.4169387817383, 0.792675117918035, -122.763610839844, -2.14262921079227, 218, 43, 'PPL', 'P'),
(192877, 'Bonita Creek Estates', 34.3786087036133, 0.600019914132831, -111.223609924316, -1.94121819913316, 218, 5, 'PPL', 'P'),
(92746, 'Bonita Junction', 31.6494407653809, 0.55238694777081, -94.663330078125, -1.65218679076546, 218, 51, 'PPL', 'P'),
(15285, 'Bonita Shores', 26.3305606842041, 0.459554977835532, -81.8269424438477, -1.42814956248504, 218, 12, 'PPL', 'P'),
(15286, 'Bonita Springs', 26.3394393920898, 0.459709940521461, -81.7788925170898, -1.42731093305777, 218, 12, 'PPL', 'P'),
(177765, 'Bonita Trading Post', 35.7363891601563, 0.623717653618738, -109.069717407227, -1.90362568297588, 218, 5, 'PPL', 'P'),
(188169, 'Bonito', 33.4505615234375, 0.583822435224915, -105.70832824707, -1.8449583746903, 218, 38, 'PPL', 'P'),
(44927, 'Boniwood', 38.7297210693359, 0.675961151038931, -76.9122161865234, -1.34237140746051, 218, 25, 'PPL', 'P'),
(63051, 'Bonlee', 35.6458282470703, 0.622137067511776, -79.4147186279297, -1.38604831460225, 218, 33, 'PPL', 'P'),
(39443, 'Bonn', 30.6538906097412, 0.535011319686156, -91.2516708374023, -1.59264210405876, 218, 22, 'PPL', 'P'),
(71867, 'Bonn', 39.5313911437988, 0.689952933353017, -81.3855590820313, -1.42044596955782, 218, 41, 'PPL', 'P'),
(39445, 'Bonnabel Place', 29.996940612793, 0.523545379218443, -90.1430587768555, -1.5732931734749, 218, 22, 'PPL', 'P'),
(77896, 'Bonnair', 39.752498626709, 0.693811986930596, -76.7558288574219, -1.33964193365929, 218, 45, 'PPL', 'P'),
(141339, 'Bonnavilla and Eastgate Mobile Home Park', 40.586109161377, 0.708361235439862, -98.3880615234375, -1.71719561823873, 218, 35, 'PPL', 'P'),
(92747, 'Bonnaville Terrace Colonia', 26.2290000915527, 0.457782411103489, -97.7099990844727, -1.70536119614469, 218, 51, 'PPL', 'P'),
(53565, 'Bonne Terre', 37.9230613708496, 0.6618822833572, -90.5552825927734, -1.5804878363178, 218, 29, 'PPL', 'P'),
(79867, 'Bonneau', 33.3052787780762, 0.581286772972023, -79.9580612182617, -1.39553143176986, 218, 48, 'PPL', 'P'),
(79868, 'Bonneau Beach', 33.3197212219238, 0.581538841169199, -80.0005569458008, -1.39627312213344, 218, 48, 'PPL', 'P'),
(77893, 'Bonneauville', 39.811939239502, 0.694849421333236, -77.1374969482422, -1.3463032984939, 218, 45, 'PPL', 'P'),
(180189, 'Bonnefoy', 38.3605613708496, 0.669518098834675, -120.75, -2.10748507178315, 218, 6, 'PPL', 'P'),
(29258, 'Bonnell', 39.1683311462402, 0.683616341013337, -84.9741668701172, -1.48307899102263, 218, 19, 'PPL', 'P'),
(58737, 'Bonner', 31.8136100769043, 0.555252242787626, -89.0488891601563, -1.55419631108821, 218, 30, 'PPL', 'P'),
(196051, 'Bonner', 46.8733291625977, 0.818093925258406, -113.863609313965, -1.98729488073317, 218, 31, 'PPL', 'P'),
(199190, 'Bonner', 41.9397201538086, 0.731986204048983, -103.019996643066, -1.79803813681501, 218, 35, 'PPL', 'P'),
(39446, 'Bonner (historical)', 32.4988899230957, 0.567212632401227, -92.6366729736328, -1.61681495148314, 218, 22, 'PPL', 'P'),
(196052, 'Bonner Junction', 46.8600006103516, 0.817861298137187, -113.880828857422, -1.98759541846218, 218, 31, 'PPL', 'P'),
(129886, 'Bonner Landing', 45.7041702270508, 0.797688252354, -85.5794372558594, -1.49364295211865, 218, 27, 'PPL', 'P'),
(31870, 'Bonner Springs', 39.0597190856934, 0.681720702949418, -94.8833312988281, -1.65602653642514, 218, 20, 'PPL', 'P'),
(7595, 'Bonnerdale', 34.3847198486328, 0.600126573734489, -93.3816680908203, -1.62981756918934, 218, 4, 'PPL', 'P'),
(19395, 'Bonners Camp', 32.4500007629395, 0.566359355587965, -83.7458267211914, -1.46164041108944, 218, 13, 'PPL', 'P'),
(194627, 'Bonners Ferry', 48.6913909912109, 0.849825090172536, -116.315277099609, -2.03008455575774, 218, 17, 'PPL', 'P'),
(63052, 'Bonnerton', 35.3583297729492, 0.617119272543903, -76.8600006103516, -1.34146007373549, 218, 33, 'PPL', 'P'),
(85204, 'Bonnertown', 35.0061111450195, 0.610971897799673, -87.2980575561523, -1.52363853495037, 218, 50, 'PPL', 'P'),
(92748, 'Bonnerville', 31.8405609130859, 0.555722623615162, -96.1691665649414, -1.67846859545707, 218, 51, 'PPL', 'P'),
(169285, 'Bonnet Shores', 41.4824981689453, 0.724006175000615, -71.4219436645508, -1.24654807512032, 218, 47, 'PPL', 'P'),
(63053, 'Bonnetsville', 34.9902801513672, 0.610695594836577, -78.3949966430664, -1.36825080851141, 218, 33, 'PPL', 'P'),
(173252, 'Bonneval', 45.6505584716797, 0.796752550705001, -88.5386123657227, -1.54529030092883, 218, 57, 'PPL', 'P'),
(1044, 'Bonneville', 34.8463897705078, 0.608184233928633, -86.9358291625977, -1.51731645683863, 218, 2, 'PPL', 'P'),
(100052, 'Bonneville', 37.0963897705078, 0.647454142098505, -77.5902786254883, -1.35420582955455, 218, 53, 'PPL', 'P'),
(200437, 'Bonneville', 45.6361083984375, 0.796500349349771, -121.950828552246, -2.1284434837718, 218, 43, 'PPL', 'P'),
(209318, 'Bonneville', 43.2688903808594, 0.755184600830499, -108.072776794434, -1.88622578683579, 218, 59, 'PPL', 'P'),
(85199, 'Bonneville (historical)', 35.6500015258789, 0.622209904967589, -84.9186096191406, -1.48210933406973, 218, 50, 'PPL', 'P'),
(203094, 'Bonneville Acres', 40.6883316040039, 0.710145353633134, -112.076393127441, -1.9561020738334, 218, 52, 'PPL', 'P'),
(85200, 'Bonneville Estates', 35.9955596923828, 0.628241032730237, -84.0844421386719, -1.46755036502249, 218, 50, 'PPL', 'P'),
(203082, 'Bonneville Heights', 41.1644401550293, 0.718455015445426, -111.918060302734, -1.95333864472828, 218, 52, 'PPL', 'P'),
(203085, 'Bonneville Terrace Number One', 41.1605606079102, 0.718387304574711, -111.916107177734, -1.95330455626632, 218, 52, 'PPL', 'P'),
(203086, 'Bonneville Terrace Number Two', 41.1597213745117, 0.718372657188716, -111.916938781738, -1.95331907049426, 218, 52, 'PPL', 'P'),
(203087, 'Bonneville Tower Condominium', 40.7700004577637, 0.711570744027571, -111.867218017578, -1.95245127945306, 218, 52, 'PPL', 'P'),
(92749, 'Bonney', 29.3163890838623, 0.511667514309121, -95.4477767944336, -1.66587796877151, 218, 51, 'PPL', 'P'),
(147280, 'Bonney', 42.7213897705078, 0.745628912523186, -75.67138671875, -1.3207148477921, 218, 40, 'PPL', 'P'),
(206868, 'Bonney Lake', 47.1772193908691, 0.82339781030638, -122.185279846191, -2.13253543078671, 218, 56, 'PPL', 'P'),
(159370, 'Bonneymeade Farm', 40.2641716003418, 0.702742365013959, -76.820556640625, -1.3407716465937, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(122250, 'Bonneyville Mills', 41.7180595397949, 0.728117496512452, -85.7652816772461, -1.49688654916831, 218, 19, 'PPL', 'P'),
(147281, 'Bonni Castle', 43.2380599975586, 0.754646509132249, -76.934440612793, -1.34275929687328, 218, 40, 'PPL', 'P'),
(15287, 'Bonnie', 27.8630599975586, 0.486302136638121, -81.9313888549805, -1.4299724962512, 218, 12, 'PPL', 'P'),
(26574, 'Bonnie', 38.2027816772461, 0.666764323688506, -88.9033279418945, -1.55165578856633, 218, 18, 'PPL', 'P'),
(108300, 'Bonnie', 38.7694396972656, 0.676654371870679, -80.6933288574219, -1.40836427295657, 218, 58, 'PPL', 'P'),
(44929, 'Bonnie Acres', 39.230281829834, 0.684697584415909, -76.7861099243164, -1.34017043797762, 218, 25, 'PPL', 'P'),
(180185, 'Bonnie Bell', 33.9491691589355, 0.592524780139939, -116.642776489258, -2.03580049840538, 218, 6, 'PPL', 'P'),
(177766, 'Bonnie Blink', 31.5466709136963, 0.550593275487128, -110.371673583984, -1.92634910497698, 218, 5, 'PPL', 'P'),
(31872, 'Bonnie Brae', 37.6819381713867, 0.65767388962363, -97.2472229003906, -1.69728422803265, 218, 20, 'PPL', 'P'),
(44931, 'Bonnie Brae', 39.228328704834, 0.684663495953956, -76.7891693115234, -1.34022383435747, 218, 25, 'PPL', 'P'),
(19396, 'Bonnie Brae Subdivision', 32.4836082458496, 0.566945916818055, -83.7925033569336, -1.46245507206689, 218, 13, 'PPL', 'P'),
(199843, 'Bonnie Briar (historical)', 40.6891708374023, 0.710160001019129, -117.863327026367, -2.05710312396492, 218, 39, 'PPL', 'P'),
(44932, 'Bonnie Brook', 38.5555610656738, 0.672921485549742, -76.0213928222656, -1.32682360670052, 218, 25, 'PPL', 'P'),
(159371, 'Bonnie Brook', 40.8663902282715, 0.713253062888174, -79.8294372558594, -1.39328652012897, 218, 45, 'PPL', 'P'),
(189950, 'Bonnie Claire', 37.2266693115234, 0.649727949037215, -117.120002746582, -2.04412966787266, 218, 39, 'PPL', 'P'),
(147282, 'Bonnie Crest', 40.9597206115723, 0.714881985368921, -73.7863922119141, -1.2878154872658, 218, 40, 'PPL', 'P'),
(1042, 'Bonnie Doone', 34.774169921875, 0.606923759784698, -86.9641723632813, -1.51781113901112, 218, 2, 'PPL', 'P'),
(63054, 'Bonnie Doone', 35.0950012207031, 0.612523322292699, -78.9558334350586, -1.378039257098, 218, 33, 'PPL', 'P'),
(79870, 'Bonnie Forest', 34.0794410705566, 0.594798453920594, -81.1363906860352, -1.41609716065577, 218, 48, 'PPL', 'P'),
(79871, 'Bonnie Glen', 33.5458297729492, 0.585485179851506, -81.9377822875977, -1.43008408270087, 218, 48, 'PPL', 'P'),
(134348, 'Bonnie Glen', 45.3588905334473, 0.791661984860342, -92.9036102294922, -1.62147388549412, 218, 28, 'PPL', 'P'),
(203091, 'Bonnie Lane Condominium', 41.1852798461914, 0.718818736671304, -111.961669921875, -1.95409977616782, 218, 52, 'PPL', 'P'),
(15288, 'Bonnie Lock', 26.2791690826416, 0.458658025180394, -80.128059387207, -1.39849845954031, 218, 12, 'PPL', 'P'),
(44933, 'Bonnie Ridge', 39.3777809143066, 0.687271929083634, -76.6624984741211, -1.33801301117854, 218, 25, 'PPL', 'P'),
(189951, 'Bonnie Springs', 36.0591697692871, 0.629351238009664, -115.452499389648, -2.01502624400611, 218, 39, 'PPL', 'P'),
(118859, 'Bonnie Valley', 41.9286117553711, 0.731792325921625, -88.3697204589844, -1.54234258107627, 218, 18, 'PPL', 'P'),
(92750, 'Bonnie View', 28.1674995422363, 0.49161560906602, -97.2997207641602, -1.69820048860569, 218, 51, 'PPL', 'P'),
(180186, 'Bonnie View', 39.3824996948242, 0.687354287340345, -122.683891296387, -2.14123784228076, 218, 6, 'PPL', 'P'),
(203093, 'Bonniebrook Estates', 40.6630592346191, 0.709704267577589, -111.966110229492, -1.95417727415554, 218, 52, 'PPL', 'P'),
(34913, 'Bonnieville', 37.3786087036133, 0.652379791692661, -85.9030609130859, -1.4992912504746, 218, 21, 'PPL', 'P'),
(108299, 'Bonnivale', 39.1741714477539, 0.683718273504059, -81.5055618286133, -1.42254041259711, 218, 58, 'PPL', 'P'),
(79872, 'Bonniview Estates', 33.5149993896484, 0.584947088153255, -81.7127838134766, -1.42615711851549, 218, 48, 'PPL', 'P'),
(53564, 'Bonnots Mill', 38.5780601501465, 0.673314168652474, -91.9655609130859, -1.60510183637675, 218, 29, 'PPL', 'P'),
(34911, 'Bonny', 37.9080581665039, 0.661620428043018, -83.3616714477539, -1.45493563672905, 218, 21, 'PPL', 'P'),
(100053, 'Bonny Blue', 36.8269386291504, 0.642751332508561, -83.0683288574219, -1.44981584269143, 218, 53, 'PPL', 'P'),
(1043, 'Bonny Brook', 33.7816696166992, 0.589601361632332, -85.7613906860352, -1.49681863856051, 218, 2, 'PPL', 'P'),
(159372, 'Bonny Brook', 40.1780586242676, 0.701239410052773, -77.1858291625977, -1.34714685476919, 218, 45, 'PPL', 'P'),
(180187, 'Bonny Doon', 37.0416717529297, 0.646499132531603, -122.149436950684, -2.13190985424665, 218, 6, 'PPL', 'P'),
(177340, 'Bonny Eagle', 43.6897201538086, 0.762529465958883, -70.6149978637695, -1.23246421401154, 218, 26, 'PPL', 'P'),
(147283, 'Bonny Hill', 42.2705612182617, 0.737760469924492, -77.3338928222656, -1.34973105313295, 218, 40, 'PPL', 'P'),
(85201, 'Bonny Kate', 35.8833312988281, 0.626282277748484, -83.8997192382813, -1.46432634220684, 218, 50, 'PPL', 'P'),
(124270, 'Bonny Rigg Corners', 42.2638893127441, 0.737644023205829, -73.0513916015625, -1.274987306611, 218, 23, 'PPL', 'P'),
(200438, 'Bonny Slope', 45.5458297729492, 0.794924690090825, -122.781936645508, -2.14294905643919, 218, 43, 'PPL', 'P'),
(34912, 'Bonnyman', 37.2897186279297, 0.650828367199635, -83.2363891601563, -1.45274904831604, 218, 21, 'PPL', 'P'),
(159373, 'Bonnymeade', 40.3622207641602, 0.704453645751416, -80.3583297729492, -1.40251743594135, 218, 45, 'PPL', 'P'),
(7597, 'Bono', 35.2561111450195, 0.615335220929659, -92.4761123657227, -1.6140126402261, 218, 4, 'PPL', 'P'),
(29255, 'Bono', 39.7602806091309, 0.69394780814619, -87.4938888549805, -1.52705643589338, 218, 19, 'PPL', 'P'),
(92751, 'Bono', 32.3236083984375, 0.564153392678026, -97.5041732788086, -1.70176885815029, 218, 51, 'PPL', 'P'),
(154389, 'Bono', 41.6355590820313, 0.726677591890073, -83.269172668457, -1.45332122847625, 218, 41, 'PPL', 'P'),
(85202, 'Bonsack', 36.2075004577637, 0.63194009690533, -85.1736068725586, -1.48655987572542, 218, 50, 'PPL', 'P'),
(100054, 'Bonsack', 37.3258285522461, 0.651458604271603, -79.8661117553711, -1.39392661089697, 218, 53, 'PPL', 'P'),
(63055, 'Bonsal', 35.6602783203125, 0.622389268867006, -78.9738922119141, -1.37835444221301, 218, 33, 'PPL', 'P'),
(180188, 'Bonsall', 33.288890838623, 0.581000749470948, -117.224716186523, -2.04595726217073, 218, 6, 'PPL', 'P'),
(85203, 'Bonta Vista Estates', 36.0911102294922, 0.629908704204845, -83.9366683959961, -1.4649712266648, 218, 50, 'PPL', 'P'),
(180190, 'Bontes (historical)', 39.7833290100098, 0.694350078628847, -120.621940612793, -2.1052500138383, 218, 6, 'PPL', 'P'),
(58738, 'Bonus', 31.586109161377, 0.551281602760373, -90.8986129760742, -1.58648008192854, 218, 30, 'PPL', 'P'),
(92752, 'Bonus', 29.4513893127441, 0.514023712794055, -96.2805633544922, -1.68041283621089, 218, 51, 'PPL', 'P'),
(159374, 'Bonus', 41.1175003051758, 0.717635760515091, -79.716667175293, -1.39131831092535, 218, 45, 'PPL', 'P'),
(39447, 'Bonvillain', 29.7999992370605, 0.520108103778505, -91.6686096191406, -1.59991905857935, 218, 22, 'PPL', 'P'),
(100055, 'Bonvue Heights', 37.2813911437988, 0.650683025183144, -80.040283203125, -1.39696647612324, 218, 53, 'PPL', 'P'),
(26576, 'Boody', 39.7663917541504, 0.694054467747848, -89.0491714477539, -1.55420123793623, 218, 18, 'PPL', 'P'),
(100056, 'Boody', 36.9058303833008, 0.64412825337116, -82.2972183227539, -1.43635742496466, 218, 53, 'PPL', 'P'),
(63056, 'Booetown', 35.9077796936035, 0.626708982734142, -80.5547180175781, -1.40594505742234, 218, 33, 'PPL', 'P'),
(169870, 'Booge', 43.6458282470703, 0.761763407671322, -96.459716796875, -1.68353965364675, 218, 49, 'PPL', 'P'),
(63057, 'Boogertown', 35.2180595397949, 0.61467109513282, -81.1600036621094, -1.41650928483446, 218, 33, 'PPL', 'P'),
(108301, 'Booher', 39.4438896179199, 0.688425743625911, -80.7713928222656, -1.40972674617025, 218, 58, 'PPL', 'P'),
(159375, 'Booher Corners', 41.3477783203125, 0.721654870074184, -80.0175018310547, -1.3965688661725, 218, 45, 'PPL', 'P'),
(39448, 'Book', 31.3372192382813, 0.546937654127317, -91.8713912963867, -1.60345826651001, 218, 22, 'PPL', 'P'),
(7599, 'Booker', 34.7961082458496, 0.607306655770424, -92.1961135864258, -1.60912573962581, 218, 4, 'PPL', 'P'),
(34914, 'Booker', 37.7819404602051, 0.65941925882304, -85.3000030517578, -1.48876590521438, 218, 21, 'PPL', 'P'),
(100058, 'Booker', 36.6175003051758, 0.639095944175346, -82.083610534668, -1.43262926575466, 218, 53, 'PPL', 'P'),
(159376, 'Booker', 40.8525009155273, 0.71301064864995, -78.4377822875977, -1.36899755888107, 218, 45, 'PPL', 'P'),
(191147, 'Booker', 36.4533309936523, 0.63623064915853, -100.53694152832, -1.75470064955421, 218, 51, 'PPL', 'P'),
(1045, 'Booker Heights', 33.5424995422363, 0.585427056360715, -87.0072174072266, -1.51856241675463, 218, 2, 'PPL', 'P'),
(1046, 'Booker T City', 33.7966690063477, 0.589863150367487, -85.7874984741211, -1.49727430542302, 218, 2, 'PPL', 'P'),
(1047, 'Bookers Mill', 31.5266704559326, 0.550244201647246, -87.0322189331055, -1.51899877569924, 218, 2, 'PPL', 'P'),
(75174, 'Bookertee', 35.3672218322754, 0.617274468256427, -96.0830612182617, -1.67696577365394, 218, 42, 'PPL', 'P'),
(15289, 'Bookertown', 28.8280601501465, 0.503144566583027, -81.3319396972656, -1.41951013475077, 218, 12, 'PPL', 'P'),
(13408, 'Bookhammer Landing', 38.6777801513672, 0.675054611003868, -75.1363906860352, -1.31137740553611, 218, 10, 'PPL', 'P'),
(79875, 'Bookman', 34.1627807617188, 0.596253005928969, -81.1533279418945, -1.41639277153677, 218, 48, 'PPL', 'P'),
(154390, 'Booktown', 41.3888893127441, 0.722372392250878, -83.1080627441406, -1.45050932983929, 218, 41, 'PPL', 'P'),
(71868, 'Bookwalter', 39.7044410705566, 0.692973224345276, -83.5302810668945, -1.45787842973359, 218, 41, 'PPL', 'P'),
(141340, 'Bookwalter', 40.0616683959961, 0.699208017352287, -96.3691711425781, -1.68195933385589, 218, 35, 'PPL', 'P'),
(85205, 'Boom', 36.5158309936523, 0.637321479941026, -85.1697235107422, -1.48649209827568, 218, 50, 'PPL', 'P'),
(100059, 'Boom Furnace', 36.9205589294434, 0.644385314995379, -80.7694396972656, -1.4096926577083, 218, 53, 'PPL', 'P'),
(44935, 'Boomdecker', 39.6955604553223, 0.692818228369833, -75.8755569458008, -1.32427829048868, 218, 25, 'PPL', 'P'),
(63058, 'Boomer', 36.0672187805176, 0.629491719757166, -81.2538909912109, -1.41814792785319, 218, 33, 'PPL', 'P'),
(85206, 'Boomer', 35.8277816772461, 0.625312753953641, -82.9608306884766, -1.44793964570347, 218, 50, 'PPL', 'P'),
(108302, 'Boomer', 38.1505584716797, 0.665852856805426, -81.2874984741211, -1.41873448908328, 218, 58, 'PPL', 'P'),
(147284, 'Boomertown', 42.079719543457, 0.73442965434913, -79.3697204589844, -1.38526294839678, 218, 40, 'PPL', 'P'),
(58739, 'Boon', 33.1005592346191, 0.577713742895518, -88.9563903808594, -1.55258190283541, 218, 30, 'PPL', 'P'),
(77895, 'Boon', 39.9166717529297, 0.69667734852644, -75.2666702270508, -1.31365121247482, 218, 45, 'PPL', 'P'),
(129884, 'Boon', 44.2897186279297, 0.773001414839238, -85.601936340332, -1.49403563522138, 218, 27, 'PPL', 'P'),
(188170, 'Boon Place', 35.2772216796875, 0.615703669266471, -108.392219543457, -1.89180111457787, 218, 38, 'PPL', 'P'),
(159377, 'Boon Terrace', 40.2472190856934, 0.702446487816851, -80.1983337402344, -1.39972497838035, 218, 45, 'PPL', 'P'),
(7601, 'Boone', 36.4736099243164, 0.636584583267401, -93.0208282470703, -1.62351972584352, 218, 4, 'PPL', 'P'),
(34915, 'Boone', 37.5175018310547, 0.654803934074906, -84.3166732788086, -1.47160356304353, 218, 21, 'PPL', 'P'),
(58740, 'Boone', 34.1316719055176, 0.595710053961729, -90.5297164916992, -1.58004162367716, 218, 30, 'PPL', 'P'),
(63062, 'Boone', 36.2166709899902, 0.632100152886844, -81.6747207641602, -1.42549279298157, 218, 33, 'PPL', 'P'),
(75175, 'Boone', 34.898609161377, 0.609095634232685, -98.461669921875, -1.71848032714859, 218, 42, 'PPL', 'P'),
(85207, 'Boone', 36.378059387207, 0.634916911792793, -82.4375, -1.43880580211283, 218, 50, 'PPL', 'P'),
(100060, 'Boone', 36.8422203063965, 0.643018048091733, -76.4338912963867, -1.33402306323339, 218, 53, 'PPL', 'P'),
(114665, 'Boone', 42.0597190856934, 0.734080580509248, -93.879997253418, -1.63851505383538, 218, 16, 'PPL', 'P'),
(141341, 'Boone', 41.6263885498047, 0.726517535908559, -97.9172210693359, -1.70897790206307, 218, 35, 'PPL', 'P'),
(159378, 'Boone', 40.0091705322266, 0.698291756779246, -78.8486099243164, -1.3761678538, 218, 45, 'PPL', 'P'),
(186434, 'Boone', 38.2486114501953, 0.667564204121911, -104.256393432617, -1.81961733165376, 218, 7, 'PPL', 'P'),
(191148, 'Boone', 34.2447204589844, 0.597683123434341, -101.811668395996, -1.77694883045879, 218, 51, 'PPL', 'P'),
(53566, 'Boone (historical)', 38.2591705322266, 0.667748494869345, -91.3230590820313, -1.59388806397476, 218, 29, 'PPL', 'P'),
(108303, 'Boone (historical)', 38.0338897705078, 0.663816603835952, -81.008056640625, -1.41385730902096, 218, 58, 'PPL', 'P'),
(63063, 'Boone Fork', 36.1222190856934, 0.630451656172085, -81.7386093139648, -1.42660785852999, 218, 33, 'PPL', 'P'),
(34916, 'Boone Furnace', 38.4666709899902, 0.671370061056716, -83.1233291625977, -1.45077577910635, 218, 21, 'PPL', 'P'),
(122252, 'Boone Grove', 41.3547210693359, 0.721776043903782, -87.1294403076172, -1.52069560878778, 218, 19, 'PPL', 'P'),
(34917, 'Boone Heights', 36.855281829834, 0.643246014681043, -83.8672180175781, -1.46375908889465, 218, 21, 'PPL', 'P'),
(63064, 'Boone Trail', 35.4172210693359, 0.618147119566619, -78.9613876342773, -1.37813619616168, 218, 33, 'PPL', 'P'),
(79880, 'Boones Creek', 34.9199981689453, 0.609468942838487, -82.9511108398438, -1.44777000234203, 218, 48, 'PPL', 'P'),
(85212, 'Boones Creek', 36.392219543457, 0.635164053141953, -82.4116668701172, -1.43835492894028, 218, 50, 'PPL', 'P'),
(63067, 'Boones Crossroads', 36.3386116027832, 0.634228418071981, -77.4188919067383, -1.35121456701817, 218, 33, 'PPL', 'P'),
(63068, 'Boones Hill', 36.4755592346191, 0.636618605150327, -80.5752792358398, -1.40630391837923, 218, 33, 'PPL', 'P'),
(44936, 'Boones Meadows', 39.6624984741211, 0.69224118794064, -76.8533325195313, -1.34134369359585, 218, 25, 'PPL', 'P'),
(100062, 'Boones Mill', 37.1166687011719, 0.647808076207377, -79.9555587768555, -1.39548775592798, 218, 53, 'PPL', 'P'),
(44937, 'Boones Mobile Estates', 38.8069381713867, 0.677308843708566, -76.6772232055664, -1.33827000622373, 218, 25, 'PPL', 'P'),
(53577, 'Boonesboro', 39.0769386291504, 0.682021240678434, -92.8413925170898, -1.62038798155964, 218, 29, 'PPL', 'P'),
(34918, 'Boonesborough', 37.9083290100098, 0.661625155153953, -84.2719421386719, -1.47082285736998, 218, 21, 'PPL', 'P'),
(108305, 'Boonesborough', 38.1294403076172, 0.665484275310559, -81.2163925170898, -1.4174934560153, 218, 58, 'PPL', 'P'),
(53578, 'Boonesborough (historical)', 38.9769401550293, 0.68027593805805, -92.1497192382813, -1.60831600549637, 218, 29, 'PPL', 'P'),
(100063, 'Boonesville', 38.2361106872559, 0.667346024649607, -78.5980606079102, -1.37179494329009, 218, 53, 'PPL', 'P'),
(1048, 'Booneville', 31.2008304595947, 0.544557220876464, -87.6030578613281, -1.52896179449528, 218, 2, 'PPL', 'P'),
(7605, 'Booneville', 35.1399993896484, 0.613308688498163, -93.92138671875, -1.63923743628106, 218, 4, 'PPL', 'P'),
(34921, 'Booneville', 37.4761085510254, 0.654081485050194, -83.6750030517578, -1.46040430486948, 218, 21, 'PPL', 'P'),
(58741, 'Booneville', 34.6580581665039, 0.604897227353202, -88.5666732788086, -1.54578005625329, 218, 30, 'PPL', 'P'),
(85209, 'Booneville', 35.274169921875, 0.61565040604467, -86.4644393920898, -1.50908915328305, 218, 50, 'PPL', 'P'),
(114670, 'Booneville', 41.524169921875, 0.724733484294315, -93.8836135864258, -1.63857817075321, 218, 16, 'PPL', 'P'),
(159379, 'Booneville', 41.0200004577637, 0.715934067157557, -77.357780456543, -1.3501479710016, 218, 45, 'PPL', 'P'),
(63069, 'Boonford', 35.9302787780762, 0.627101665836874, -82.1691665649414, -1.43412250017787, 218, 33, 'PPL', 'P'),
(100064, 'Boons Path', 36.6791687011719, 0.640172260729901, -83.3522186279297, -1.45477065389952, 218, 53, 'PPL', 'P'),
(44939, 'Boonsboro', 39.5061111450195, 0.689511714139418, -77.6527786254883, -1.35529666033705, 218, 25, 'PPL', 'P'),
(100065, 'Boonsboro', 37.4491691589355, 0.653611303959741, -79.2616729736328, -1.3833771640289, 218, 53, 'PPL', 'P'),
(85210, 'Boonshill', 35.2125015258789, 0.614574089490114, -86.741943359375, -1.51393251119952, 218, 50, 'PPL', 'P'),
(92753, 'Boonsville', 33.0683288574219, 0.577151216694266, -97.8630599975586, -1.70803261303415, 218, 51, 'PPL', 'P'),
(144862, 'Boonton', 40.9025001525879, 0.713883299960142, -74.4075012207031, -1.29865588448297, 218, 37, 'PPL', 'P'),
(29261, 'Boonville', 38.0491714477539, 0.664083319419123, -87.274169921875, -1.52322161708172, 218, 19, 'PPL', 'P'),
(53580, 'Boonville', 38.9736099243164, 0.680217814567259, -92.7430572509766, -1.61867170739514, 218, 29, 'PPL', 'P'),
(63070, 'Boonville', 36.2324981689453, 0.632376389270912, -80.7083282470703, -1.40862606169172, 218, 33, 'PPL', 'P'),
(92754, 'Boonville', 30.670560836792, 0.535302270035247, -96.3244400024414, -1.68117862818234, 218, 51, 'PPL', 'P'),
(147285, 'Boonville', 43.4836082458496, 0.758932134537432, -75.3369369506836, -1.31487759815681, 218, 40, 'PPL', 'P'),
(180191, 'Boonville', 39.0091705322266, 0.680838464259302, -123.36499786377, -2.15312539443855, 218, 6, 'PPL', 'P'),
(85211, 'Boonville (historical)', 35.0547218322754, 0.611820314343945, -84.3730621337891, -1.47258773422437, 218, 50, 'PPL', 'P'),
(44940, 'Boordy Vineyards', 39.475830078125, 0.688983209821092, -76.4866714477539, -1.33494425065444, 218, 25, 'PPL', 'P'),
(26577, 'Boos', 38.9300003051758, 0.679456683127715, -88.1108322143555, -1.53782412881279, 218, 18, 'PPL', 'P'),
(53582, 'Booser (historical)', 36.5911102294922, 0.638635350464817, -90.5025024414063, -1.57956664889675, 218, 29, 'PPL', 'P'),
(7606, 'Booster', 35.749439239502, 0.623945420470967, -92.6600036621094, -1.61722214881381, 218, 4, 'PPL', 'P'),
(1049, 'Boot Hill', 31.8758296966553, 0.55633818001162, -85.6425018310547, -1.49474363659718, 218, 2, 'PPL', 'P'),
(44941, 'Boot Hill', 39.6644401550293, 0.692275076665511, -75.8525009155273, -1.32387588684797, 218, 25, 'PPL', 'P'),
(159380, 'Boot Jack', 41.3813896179199, 0.722241497883301, -78.6866683959961, -1.3733414409351, 218, 45, 'PPL', 'P'),
(1050, 'Booth', 32.5002784729004, 0.567236867167147, -86.5719375610352, -1.51096535027101, 218, 2, 'PPL', 'P'),
(34920, 'Booth', 37.6958312988281, 0.657916370440881, -83.6322174072266, -1.45965755449982, 218, 21, 'PPL', 'P'),
(58742, 'Booth', 32.9605598449707, 0.575270292595371, -90.9316711425781, -1.5870570557787, 218, 30, 'PPL', 'P'),
(79876, 'Booth', 33.9502792358398, 0.59254415463687, -79.0599975585938, -1.37985726401614, 218, 48, 'PPL', 'P'),
(92755, 'Booth', 29.5297203063965, 0.515390846539647, -95.6497192382813, -1.66940252931617, 218, 51, 'PPL', 'P'),
(100066, 'Booth', 37.2163887023926, 0.649548518558771, -76.6147232055664, -1.33717917544124, 218, 53, 'PPL', 'P'),
(108306, 'Booth', 39.5969390869141, 0.691096960778288, -80.0155563354492, -1.3965349108686, 218, 58, 'PPL', 'P'),
(154392, 'Booth', 40.2311096191406, 0.702165324584766, -81.5411071777344, -1.42316079597305, 218, 41, 'PPL', 'P'),
(85213, 'Booth (historical)', 35.0805587768555, 0.612271254095523, -89.8019409179688, -1.56733954369997, 218, 50, 'PPL', 'P'),
(200439, 'Booth (historical)', 42.8027801513672, 0.747049442648634, -123.227783203125, -2.1507305468283, 218, 43, 'PPL', 'P'),
(124271, 'Booth Corner', 41.5875015258789, 0.725838829304753, -71.0888900756836, -1.240735193409, 218, 23, 'PPL', 'P'),
(1052, 'Booth Ford', 33.1852798461914, 0.579192396511757, -87.0019378662109, -1.51847027138091, 218, 2, 'PPL', 'P'),
(112609, 'Booth Fork', 36.9791717529297, 0.645408301749106, -76.9472198486328, -1.34298233661458, 218, 53, 'PPL', 'P'),
(126912, 'Boothbay', 43.8763885498047, 0.765787444078432, -69.6341705322266, -1.21534554768257, 218, 26, 'PPL', 'P'),
(126913, 'Boothbay Harbor', 43.8522186279297, 0.765365599361763, -69.6286087036133, -1.21524847546083, 218, 26, 'PPL', 'P'),
(126915, 'Boothbay Park', 43.5669403076172, 0.760386553387751, -70.4491729736328, -1.2295700236969, 218, 26, 'PPL', 'P'),
(26578, 'Boothby', 38.0022201538086, 0.663263864751706, -88.7786102294922, -1.54947905384936, 218, 18, 'PPL', 'P'),
(7607, 'Boothe', 35.0438919067383, 0.611631296485577, -94.1172180175781, -1.64265533722407, 218, 4, 'PPL', 'P'),
(191149, 'Boothe', 33.9749984741211, 0.592975586733463, -101.201393127441, -1.76629751767901, 218, 51, 'PPL', 'P'),
(1053, 'Boothetown', 30.9511108398438, 0.540198791304981, -88.3394393920898, -1.54181407675795, 218, 2, 'PPL', 'P'),
(77900, 'Booths Corner', 39.839168548584, 0.695324662429761, -75.4944381713867, -1.31762651303399, 218, 45, 'PPL', 'P'),
(85214, 'Boothspoint', 36.1124992370605, 0.630282012810647, -89.602783203125, -1.5638635858452, 218, 50, 'PPL', 'P'),
(108307, 'Boothsville', 39.394718170166, 0.687567539964633, -80.1952819824219, -1.39967171515855, 218, 58, 'PPL', 'P'),
(1054, 'Boothton', 33.1797218322754, 0.579095390869051, -86.9905624389648, -1.51827173272165, 218, 2, 'PPL', 'P'),
(39449, 'Boothville', 29.3433303833008, 0.512137728689088, -89.4197235107422, -1.56066859148543, 218, 22, 'PPL', 'P'),
(77897, 'Boothwyn', 39.8300018310547, 0.695164673027275, -75.4419403076172, -1.31671025246094, 218, 45, 'PPL', 'P'),
(44942, 'Bootjack', 39.2738914489746, 0.685458715855453, -77.1558303833008, -1.34662327729888, 218, 25, 'PPL', 'P'),
(180192, 'Bootjack', 37.4650001525879, 0.653887606922837, -119.885559082031, -2.09239773157564, 218, 6, 'PPL', 'P'),
(44943, 'Bootjack Springs Estates', 39.4652786254883, 0.688799052231713, -77.4658279418945, -1.35203375536948, 218, 25, 'PPL', 'P'),
(191150, 'Bootleg', 34.8288917541504, 0.607878835930628, -102.813606262207, -1.79443594512457, 218, 51, 'PPL', 'P'),
(177767, 'Bootlegger Crossing', 35.2388916015625, 0.615034683200643, -112.113609313965, -1.95675161882327, 218, 5, 'PPL', 'P'),
(108308, 'Booton', 38.2705612182617, 0.667947299844719, -82.3816680908203, -1.43783135146997, 218, 58, 'PPL', 'P'),
(1055, 'Bootsville (historical)', 34.4291687011719, 0.600902352560029, -85.8111114501953, -1.49768642960171, 218, 2, 'PPL', 'P'),
(177768, 'Booze Crossing', 36.8166694641113, 0.642572101767199, -112.600280761719, -1.96524563796202, 218, 5, 'PPL', 'P'),
(1056, 'Boozer (historical)', 33.7019386291504, 0.588209793383738, -86.0458297729492, -1.50178303714853, 218, 2, 'PPL', 'P'),
(19399, 'Boozeville', 34.1713905334473, 0.596403274793476, -85.1752777099609, -1.48658903733935, 218, 13, 'PPL', 'P'),
(147287, 'Boquet', 44.3036117553711, 0.77324389565649, -73.4027786254883, -1.28112016712729, 218, 40, 'PPL', 'P'),
(159381, 'Boquet', 40.3813896179199, 0.704788205363358, -79.6025009155273, -1.38932573379775, 218, 45, 'PPL', 'P'),
(177769, 'Boquillas', 31.7719402313232, 0.554524966783439, -110.227500915527, -1.92383281722102, 218, 5, 'PPL', 'P'),
(191151, 'Boquillas Crossing', 29.1886100769043, 0.509437349922775, -102.944999694824, -1.79672919313924, 218, 51, 'PPL', 'P'),
(92760, 'Bor-ley Heights', 30.163890838623, 0.526459210346126, -94.1875, -1.64388198922216, 218, 51, 'PPL', 'P'),
(191152, 'Boracho', 31.077220916748, 0.542399827366904, -104.388061523438, -1.82191537335839, 218, 51, 'PPL', 'P'),
(189952, 'Borax', 35.7144393920898, 0.62333455789593, -115.339721679688, -2.01305790164443, 218, 39, 'PPL', 'P'),
(196053, 'Borax', 47.4330596923828, 0.827863065927089, -115.668327331543, -2.01879315220997, 218, 31, 'PPL', 'P'),
(79877, 'Borax (historical)', 34.8752784729004, 0.608688436902012, -81.4333267211914, -1.42127967213707, 218, 48, 'PPL', 'P'),
(194629, 'Borax (historical)', 47.434440612793, 0.827887167534954, -115.670829772949, -2.01883682805185, 218, 17, 'PPL', 'P'),
(129887, 'Borculo', 42.8849983215332, 0.748484420422996, -86.021110534668, -1.50135160505194, 218, 27, 'PPL', 'P'),
(75177, 'Bordeaux', 35.1141700744629, 0.61285788190464, -94.8733291625977, -1.65585196621568, 218, 42, 'PPL', 'P'),
(79878, 'Bordeaux', 33.9263916015625, 0.592127236768218, -82.4208297729492, -1.43851485176373, 218, 48, 'PPL', 'P'),
(85215, 'Bordeaux', 36.1938896179199, 0.631702542936095, -86.8313903808594, -1.51549365623053, 218, 50, 'PPL', 'P'),
(199191, 'Bordeaux', 42.7680587768555, 0.746443440342587, -102.813606262207, -1.79443594512457, 218, 35, 'PPL', 'P'),
(206869, 'Bordeaux', 46.8950004577637, 0.818472160712224, -123.078887939453, -2.1481318342366, 218, 56, 'PPL', 'P'),
(209319, 'Bordeaux', 41.9361114501953, 0.731923220289202, -104.844169616699, -1.8298759613308, 218, 59, 'PPL', 'P'),
(85216, 'Bordeaux Hills', 36.1819381713867, 0.631493950843715, -86.841667175293, -1.51567302012995, 218, 50, 'PPL', 'P'),
(159382, 'Bordell', 41.8752784729004, 0.730861484541615, -78.5369415283203, -1.37072821411546, 218, 45, 'PPL', 'P'),
(39450, 'Bordelonville', 31.1052799224854, 0.542889549401856, -91.9072189331055, -1.60408357673396, 218, 22, 'PPL', 'P'),
(29262, 'Borden', 38.4666709899902, 0.671370061056716, -85.9458312988281, -1.50003773452815, 218, 19, 'PPL', 'P'),
(79879, 'Borden', 34.0675010681152, 0.594590061565296, -80.4783325195313, -1.40461187898064, 218, 48, 'PPL', 'P'),
(92756, 'Borden', 29.6911106109619, 0.518207638735111, -96.7016677856445, -1.68776249502923, 218, 51, 'PPL', 'P'),
(147288, 'Borden', 42.0416717529297, 0.733765595131319, -77.3277816772461, -1.34962439353129, 218, 40, 'PPL', 'P'),
(180193, 'Borden', 36.9300003051758, 0.644550098087828, -120.02555847168, -2.09484118187578, 218, 6, 'PPL', 'P'),
(192495, 'Borden', 38.9816703796387, 0.680358496051843, -112.793891906738, -1.96862478991117, 218, 52, 'PPL', 'P'),
(147289, 'Borden Estate', 41.5938911437988, 0.7259503491754, -74.1716690063477, -1.2945398358602, 218, 40, 'PPL', 'P'),
(44950, 'Borden Shaft', 39.6269416809082, 0.691620604827624, -78.9369430541992, -1.37770955775505, 218, 25, 'PPL', 'P'),
(1057, 'Borden Springs', 33.9297218322754, 0.592185360259009, -85.4702835083008, -1.49173785983286, 218, 2, 'PPL', 'P'),
(85217, 'Borden Village', 36.535831451416, 0.637670553780908, -82.541389465332, -1.44061901534101, 218, 50, 'PPL', 'P'),
(1058, 'Borden Wheeler Springs', 33.9136085510254, 0.591904130447896, -85.4658279418945, -1.49166009552903, 218, 2, 'PPL', 'P'),
(39451, 'Bordenax', 32.5816688537598, 0.568657397292595, -91.7636108398438, -1.60157714267403, 218, 22, 'PPL', 'P'),
(144869, 'Bordentown', 40.146110534668, 0.700681810699537, -74.7122192382813, -1.30397421717986, 218, 37, 'PPL', 'P'),
(186435, 'Bordenville', 39.2761116027832, 0.685497464849314, -105.683059692383, -1.84451735521379, 218, 7, 'PPL', 'P'),
(134350, 'Border', 48.6966705322266, 0.849917235546253, -94.2780609130859, -1.64546257532912, 218, 28, 'PPL', 'P'),
(194630, 'Border', 42.1830596923828, 0.736233280197386, -111.046669006348, -1.93812999753311, 218, 17, 'PPL', 'P'),
(147290, 'Border City', 42.8786087036133, 0.748372900552349, -76.9608306884766, -1.34321989058381, 218, 40, 'PPL', 'P'),
(188172, 'Border City (historical)', 31.8263893127441, 0.555475282528921, -107.639442443848, -1.87866267565607, 218, 38, 'PPL', 'P'),
(92757, 'Border Colonia', 26.2259998321533, 0.457730046698556, -98.1809997558594, -1.71358170863949, 218, 51, 'PPL', 'P'),
(191154, 'Border Housing Unit Number 1 Colonia', 28.6310005187988, 0.499705227193244, -100.432998657227, -1.75288650421965, 218, 51, 'PPL', 'P'),
(209320, 'Border Junction', 42.2133293151855, 0.736761584778631, -111.04167175293, -1.93804277900741, 218, 59, 'PPL', 'P'),
(114672, 'Border Plains', 42.3980598449707, 0.739985740752335, -94.0477828979492, -1.64144346577003, 218, 16, 'PPL', 'P'),
(58743, 'Border Springs (historical)', 33.6624984741211, 0.58752143282098, -88.2683334350586, -1.54057304368997, 218, 30, 'PPL', 'P'),
(189953, 'Border Town', 39.6758308410645, 0.692473881640886, -119.990280151367, -2.09422545903176, 218, 39, 'PPL', 'P'),
(108309, 'Borderland', 37.7138900756836, 0.658231555555892, -82.3091735839844, -1.43656608363607, 218, 58, 'PPL', 'P'),
(191155, 'Borderland', 31.8833293914795, 0.556469074379197, -106.595283508301, -1.86043866431666, 218, 51, 'PPL', 'P'),
(92758, 'Borderland Retreat Colonia', 26.2569999694824, 0.458271101163519, -98.197998046875, -1.71387838478493, 218, 51, 'PPL', 'P'),
(92759, 'Bordersville', 30.0011100769043, 0.523618150095229, -95.2936096191406, -1.66318724396414, 218, 51, 'PPL', 'P'),
(34922, 'Bordley', 37.5591697692871, 0.655531176789579, -87.8697204589844, -1.5336159348163, 218, 21, 'PPL', 'P'),
(159383, 'Bordnersville', 40.4441719055176, 0.705883962993871, -76.5308303833008, -1.33571496947391, 218, 45, 'PPL', 'P'),
(171758, 'Bordoville', 44.8433303833008, 0.782663762748209, -72.8191680908203, -1.27093424174801, 218, 55, 'PPL', 'P'),
(139697, 'Bordulac', 47.3877792358398, 0.827072772873608, -98.9636077880859, -1.7272407955544, 218, 34, 'PPL', 'P'),
(173253, 'Borea', 46.5855598449707, 0.813071403179598, -92.1822204589844, -1.60888325880856, 218, 57, 'PPL', 'P'),
(147299, 'Boreas River', 43.9413909912109, 0.766921950702806, -73.9636077880859, -1.29090848255582, 218, 40, 'PPL', 'P'),
(34923, 'Boreing', 37.0380592346191, 0.646436082192795, -84.0147171020508, -1.46633343356238, 218, 21, 'PPL', 'P'),
(108310, 'Boreman', 39.2874984741211, 0.685696203245661, -81.4766693115234, -1.42203614304471, 218, 58, 'PPL', 'P'),
(39452, 'Boretta', 30.7522201538086, 0.536727493982117, -92.1097183227539, -1.6076178578166, 218, 22, 'PPL', 'P'),
(191156, 'Borger', 35.667781829834, 0.622520229813611, -101.396942138672, -1.76971049177401, 218, 51, 'PPL', 'P'),
(108311, 'Borgman', 39.4458312988281, 0.688459632350782, -79.7444381713867, -1.39180300624374, 218, 58, 'PPL', 'P'),
(188171, 'Borica', 34.6752815246582, 0.605197831661245, -104.647216796875, -1.82643848615378, 218, 38, 'PPL', 'P'),
(159384, 'Borie', 41.6858291625977, 0.7275549703112, -77.9524993896484, -1.36052777450824, 218, 45, 'PPL', 'P'),
(44944, 'Boring', 39.5316696166992, 0.689957793622006, -76.8230590820313, -1.34081532243558, 218, 25, 'PPL', 'P'),
(85218, 'Boring', 36.4569396972656, 0.63629363291831, -82.4194412231445, -1.43849061699781, 218, 50, 'PPL', 'P'),
(200440, 'Boring', 45.4300003051758, 0.792903084507346, -122.373611450195, -2.13582243736214, 218, 43, 'PPL', 'P'),
(108312, 'Borland', 39.297779083252, 0.685875633724105, -81.2827835083008, -1.4186521974056, 218, 58, 'PPL', 'P'),
(129888, 'Borland', 43.5369415283203, 0.759862975917442, -85.4391708374023, -1.49119484128659, 218, 27, 'PPL', 'P'),
(159385, 'Borland Manor', 40.2594413757324, 0.702659807020166, -80.1594390869141, -1.39904613861849, 218, 45, 'PPL', 'P'),
(193392, 'Bormister', 41.355281829834, 0.721785831020788, -120.536109924316, -2.10375198572513, 218, 6, 'PPL', 'P'),
(34924, 'Bornes Ford', 36.6624984741211, 0.63988131038081, -86.4122161865234, -1.50817768639997, 218, 21, 'PPL', 'P'),
(211707, 'Bornite', 67.0591735839844, 1.17040337270693, -156.942779541016, -2.73916824022232, 218, 1, 'PPL', 'P'),
(39453, 'Borodino', 31.0658302307129, 0.54220102239153, -91.9508285522461, -1.60484470817351, 218, 22, 'PPL', 'P'),
(147291, 'Borodino', 42.8588905334473, 0.748028753560484, -76.3383331298828, -1.33235525860072, 218, 40, 'PPL', 'P'),
(147292, 'Borodino Landing', 42.8569412231445, 0.747994731677558, -76.3533325195313, -1.33261704733588, 218, 40, 'PPL', 'P'),
(1059, 'Boromville', 32.3063888549805, 0.56385285494901, -85.4416732788086, -1.49123851712847, 218, 2, 'PPL', 'P'),
(180194, 'Boron', 34.999439239502, 0.610855451081009, -117.648887634277, -2.05336045052698, 218, 6, 'PPL', 'P'),
(180195, 'Boronda', 36.6988906860352, 0.640516474300794, -121.673889160156, -2.12360997955136, 218, 6, 'PPL', 'P'),
(180196, 'Borosolvay', 35.7350006103516, 0.623693418852818, -117.400833129883, -2.04903108270089, 218, 6, 'PPL', 'P'),
(147293, 'Borough Park', 40.6338882446289, 0.709195137756193, -73.9972229003906, -1.29149517694396, 218, 40, 'PPL', 'P'),
(191157, 'Borrachio', 29.7311096191406, 0.518905753125361, -104.543327331543, -1.8246252729256, 218, 51, 'PPL', 'P'),
(177770, 'Borree Corner', 32.973331451416, 0.57549319917861, -111.558059692383, -1.94705544876845, 218, 5, 'PPL', 'P'),
(180197, 'Borrego', 33.2211112976074, 0.579817773314735, -116.33332824707, -2.0303996077147, 218, 6, 'PPL', 'P'),
(180198, 'Borrego Springs', 33.2558288574219, 0.580423709041756, -116.374168395996, -2.03111240278046, 218, 6, 'PPL', 'P'),
(173254, 'Borth', 44.0911102294922, 0.769535044364391, -88.8958282470703, -1.55152489419876, 218, 57, 'PPL', 'P'),
(100074, 'Borthwick (historical)', 37.0316696166992, 0.646324562322148, -77.6833267211914, -1.35582982518728, 218, 53, 'PPL', 'P'),
(26579, 'Borton', 39.6558303833008, 0.692124807801004, -87.9338912963867, -1.53473592721273, 218, 18, 'PPL', 'P'),
(144867, 'Borton Landing', 40.0027809143066, 0.698180236908599, -74.8888931274414, -1.30705775824801, 218, 37, 'PPL', 'P'),
(77898, 'Bortondale', 39.901668548584, 0.696415493212257, -75.4063873291016, -1.31608973592696, 218, 45, 'PPL', 'P'),
(134352, 'Borup', 47.1802787780762, 0.823451206686236, -96.5058288574219, -1.68434446092817, 218, 28, 'PPL', 'P'),
(143532, 'Boscawen', 43.314998626709, 0.755989341532894, -71.6213912963867, -1.25002909298116, 218, 36, 'PPL', 'P'),
(53583, 'Boschertown', 38.8333282470703, 0.677769437419095, -90.4700012207031, -1.57899939558456, 218, 29, 'PPL', 'P'),
(34925, 'Bosco', 37.4986114501953, 0.654474234731954, -82.8411102294922, -1.44585012951219, 218, 21, 'PPL', 'P'),
(39454, 'Bosco', 32.2900009155273, 0.563566831447936, -92.0888900756836, -1.60725433632781, 218, 22, 'PPL', 'P'),
(100067, 'Boscobel', 37.5988883972168, 0.656224397621327, -77.7316665649414, -1.35667351462062, 218, 53, 'PPL', 'P'),
(173255, 'Boscobel', 43.1344413757324, 0.752838023015003, -90.7052764892578, -1.58310572366935, 218, 57, 'PPL', 'P'),
(53584, 'Boscobel (historical)', 37.776668548584, 0.659327246607378, -91.5022201538086, -1.59701501456867, 218, 29, 'PPL', 'P'),
(100068, 'Boscobel Country', 37.601390838623, 0.656268073463204, -77.727783203125, -1.35660573717088, 218, 53, 'PPL', 'P'),
(39455, 'Boscoville', 30.5291690826416, 0.532834518390153, -92.0247192382813, -1.60613434393138, 218, 22, 'PPL', 'P'),
(100069, 'Bosher', 37.565559387207, 0.655642696660226, -77.584716796875, -1.35410875733282, 218, 53, 'PPL', 'P'),
(53585, 'Bosky Dell', 36.601390838623, 0.638814780943261, -94.4461135864258, -1.64839564779568, 218, 29, 'PPL', 'P'),
(26580, 'Boskydell', 37.6711082458496, 0.657484871765261, -89.2136077880859, -1.55707119348496, 218, 18, 'PPL', 'P'),
(209321, 'Bosler', 41.5761108398438, 0.725640024329378, -105.694717407227, -1.84472082072107, 218, 59, 'PPL', 'P'),
(209322, 'Bosler Junction', 41.5527801513672, 0.725232826998705, -105.68083190918, -1.84447847306187, 218, 59, 'PPL', 'P'),
(44945, 'Bosley (historical)', 39.4505615234375, 0.688542190344575, -76.5749969482422, -1.33648582145144, 218, 25, 'PPL', 'P'),
(147294, 'Bosley Corner', 42.8213882446289, 0.74737421514357, -77.6105575561523, -1.35455976366342, 218, 40, 'PPL', 'P'),
(92761, 'Bosque', 31.8547191619873, 0.555969731674807, -97.6036071777344, -1.70350430707464, 218, 51, 'PPL', 'P'),
(177771, 'Bosque', 32.9663887023926, 0.575372025349012, -112.597503662109, -1.96519716843018, 218, 5, 'PPL', 'P'),
(188173, 'Bosque', 34.560001373291, 0.60318581345769, -106.788612365723, -1.86381288941779, 218, 38, 'PPL', 'P'),
(191158, 'Bosque Bonito Number 1 Colonia', 31.5620002746582, 0.55086082330814, -106.274002075195, -1.85483124548344, 218, 51, 'PPL', 'P'),
(191159, 'Bosque Bonito Number 2 Colonia', 31.5659999847412, 0.550930631418214, -106.27799987793, -1.854901020304, 218, 51, 'PPL', 'P'),
(188175, 'Bosque Farms', 34.8547210693359, 0.608329642524151, -106.704719543457, -1.86234868345047, 218, 38, 'PPL', 'P'),
(188176, 'Bosquecito', 33.9772186279297, 0.593014335727323, -106.850280761719, -1.86488920597235, 218, 38, 'PPL', 'P'),
(92763, 'Bosqueville', 31.6088905334473, 0.551679212711122, -97.1949996948242, -1.69637276114957, 218, 51, 'PPL', 'P'),
(53586, 'Boss', 37.6430587768555, 0.656995316177877, -91.1891708374023, -1.59155127327627, 218, 29, 'PPL', 'P'),
(92764, 'Boss', 32.5555610656738, 0.568201730430082, -97.5077819824219, -1.70183184191007, 218, 51, 'PPL', 'P'),
(44946, 'Boss Arnold Village', 39.3277816772461, 0.686399277773442, -77.5769424438477, -1.35397306927528, 218, 25, 'PPL', 'P'),
(13402, 'Bossard Property', 38.651668548584, 0.674598877562328, -75.633056640625, -1.32004586172627, 218, 10, 'PPL', 'P'),
(159388, 'Bossards Corner', 40.7744407653809, 0.711648242015293, -75.5294418334961, -1.31823744218805, 218, 45, 'PPL', 'P'),
(159386, 'Bossardsville', 40.9277801513672, 0.714324519173741, -75.2716674804688, -1.31373843100052, 218, 45, 'PPL', 'P'),
(206870, 'Bossburg', 48.752498626709, 0.850891619610086, -118.040832519531, -2.06020117926101, 218, 56, 'PPL', 'P'),
(31874, 'Bosse', 38.0869407653809, 0.664742518367945, -99.8333282470703, -1.74242028113564, 218, 20, 'PPL', 'P'),
(144868, 'Bossert Estates', 40.1472206115723, 0.700701185196468, -74.6916732788086, -1.30361562253908, 218, 37, 'PPL', 'P'),
(100070, 'Bosses', 36.7119407653809, 0.640744241153023, -79.1144409179688, -1.38080747989308, 218, 53, 'PPL', 'P'),
(39456, 'Bossier City', 32.5158309936523, 0.567508309861253, -93.7319412231445, -1.63593098862967, 218, 22, 'PPL', 'P'),
(113372, 'Bosstown', 43.3902816772461, 0.757303278635712, -90.6100006103516, -1.58144284588471, 218, 57, 'PPL', 'P'),
(154393, 'Bostelmans Corners', 41.417781829834, 0.722876661803285, -84.1900024414063, -1.4693927398646, 218, 41, 'PPL', 'P'),
(44947, 'Bostetter', 39.6644401550293, 0.692275076665511, -77.7538909912109, -1.35706140403339, 218, 25, 'PPL', 'P'),
(63082, 'Bostian Heights', 35.7544403076172, 0.624032705575694, -80.929443359375, -1.41248524842735, 218, 33, 'PPL', 'P'),
(1060, 'Bostic', 33.3036117553711, 0.581257677937114, -87.9494400024414, -1.53500730332781, 218, 2, 'PPL', 'P'),
(63076, 'Bostic', 35.3624992370605, 0.617192043420689, -81.8358306884766, -1.42830469161853, 218, 33, 'PPL', 'P'),
(79881, 'Bostick', 33.9319381713867, 0.592224042673842, -79.4875030517578, -1.38731864244221, 218, 48, 'PPL', 'P'),
(92766, 'Bostick', 32.3872184753418, 0.565263597957452, -95.2719421386719, -1.66280907508935, 218, 51, 'PPL', 'P'),
(79882, 'Bostick Landing', 33.9336090087891, 0.592253204287779, -79.4763870239258, -1.3871246311568, 218, 48, 'PPL', 'P'),
(1061, 'Boston', 31.4677791595459, 0.54921635462453, -86.4819412231445, -1.50939461786008, 218, 2, 'PPL', 'P'),
(7608, 'Boston', 35.8405609130859, 0.625535793694935, -93.6011123657227, -1.63364759431104, 218, 4, 'PPL', 'P'),
(19400, 'Boston', 30.7916698455811, 0.537416020992443, -83.7900009155273, -1.46241139622502, 218, 13, 'PPL', 'P'),
(29264, 'Boston', 39.7411117553711, 0.693613248534249, -84.851936340332, -1.48094566583142, 218, 19, 'PPL', 'P'),
(34930, 'Boston', 38.7627792358398, 0.676538124889097, -84.3525009155273, -1.47222887326748, 218, 21, 'PPL', 'P'),
(39458, 'Boston', 29.8830604553223, 0.521557795517889, -92.0555572509766, -1.60667256878768, 218, 22, 'PPL', 'P'),
(53587, 'Boston', 37.4127807617188, 0.652976206618784, -94.2816696166992, -1.6455255590889, 218, 29, 'PPL', 'P'),
(85219, 'Boston', 35.8427810668945, 0.625574542688796, -87.0325012207031, -1.51900370254725, 218, 50, 'PPL', 'P'),
(92765, 'Boston', 33.4413909912109, 0.583662379243401, -94.4194412231445, -1.64793012723713, 218, 51, 'PPL', 'P'),
(100073, 'Boston', 36.735279083252, 0.641151571641751, -76.6011123657227, -1.336941621472, 218, 53, 'PPL', 'P'),
(124272, 'Boston', 42.3583297729492, 0.739292320183506, -71.0602798461914, -1.24023585070461, 218, 23, 'PPLA', 'P'),
(129889, 'Boston', 47.1797218322754, 0.823441486148258, -88.529167175293, -1.54512545125735, 218, 27, 'PPL', 'P'),
(147295, 'Boston', 42.6288909912109, 0.74401450427038, -78.7377777099609, -1.37423346674222, 218, 40, 'PPL', 'P'),
(154395, 'Boston', 41.2633285522461, 0.720180943568879, -81.5597229003906, -1.42348570162604, 218, 41, 'PPL', 'P'),
(159387, 'Boston', 40.311939239502, 0.703576067593208, -79.8233337402344, -1.39317999368537, 218, 45, 'PPL', 'P'),
(177516, 'Boston', 41.2780609130859, 0.720438071772126, -73.4077835083008, -1.28120751881104, 218, 8, 'PPL', 'P'),
(122256, 'Boston Corner', 40.9483299255371, 0.714683180393547, -84.9002838134766, -1.48178948842281, 218, 19, 'PPL', 'P'),
(147296, 'Boston Corner', 42.0527801513672, 0.733959473258677, -73.5216674804688, -1.28319516909062, 218, 40, 'PPL', 'P'),
(206871, 'Boston Harbor', 47.1386108398438, 0.822723963971563, -122.899719238281, -2.14500475048463, 218, 56, 'PPL', 'P'),
(154396, 'Boston Heights', 41.264720916748, 0.720205244913826, -81.5133285522461, -1.4226759674966, 218, 41, 'PPL', 'P'),
(196054, 'Boston Heights (historical)', 47.5055618286133, 0.82912846691904, -111.249443054199, -1.94166907230571, 218, 31, 'PPL', 'P'),
(100075, 'Boston Park', 36.7347183227539, 0.641141784524745, -76.6047210693359, -1.33700460523178, 218, 53, 'PPL', 'P'),
(180200, 'Boston Ravine', 39.2080612182617, 0.684309761582166, -121.06861114502, -2.11304588529729, 218, 6, 'PPL', 'P'),
(159389, 'Boston Run', 40.8030586242676, 0.712147717877737, -76.1894378662109, -1.32975654600902, 218, 45, 'PPL', 'P'),
(180201, 'Bostonia', 32.8074989318848, 0.572598875705912, -116.935562133789, -2.04091057190502, 218, 6, 'PPL', 'P'),
(63077, 'Bosts Mill (historical)', 35.3113899230957, 0.616300017613567, -80.4672164916992, -1.40441786769523, 218, 33, 'PPL', 'P'),
(15290, 'Bostwick', 29.773889541626, 0.519652403626479, -81.6372222900391, -1.42483832114369, 218, 12, 'PPL', 'P'),
(19401, 'Bostwick', 33.7372207641602, 0.588825582806792, -83.5144424438477, -1.45760199361244, 218, 13, 'PPL', 'P'),
(141345, 'Bostwick', 40.0483283996582, 0.698975190493987, -98.1838912963867, -1.71363217554215, 218, 35, 'PPL', 'P'),
(154399, 'Bostwick', 41.6508293151855, 0.726944107736163, -81.0833282470703, -1.4151710463867, 218, 41, 'PPL', 'P'),
(147298, 'Bostwick Corners', 42.4213905334473, 0.740392938083008, -76.6294403076172, -1.33743603732838, 218, 40, 'PPL', 'P'),
(129891, 'Bostwick Lake', 43.0849990844727, 0.75197509224279, -85.4505615234375, -1.49139364626197, 218, 27, 'PPL', 'P'),
(7614, 'Boswell', 36.0402793884277, 0.629021538666712, -92.0555572509766, -1.60667256878768, 218, 4, 'PPL', 'P'),
(63078, 'Boswell', 35.5788917541504, 0.620968805320585, -82.6144409179688, -1.44189400371288, 218, 33, 'PPL', 'P'),
(75179, 'Boswell', 34.0272216796875, 0.593887053616542, -95.8688888549805, -1.67322776074791, 218, 42, 'PPL', 'P'),
(122257, 'Boswell', 40.521110534668, 0.707226795394516, -87.3783264160156, -1.52503949084181, 218, 19, 'PPL', 'P'),
(159390, 'Boswell', 40.1613883972168, 0.700948459703681, -79.029167175293, -1.37931917231789, 218, 45, 'PPL', 'P'),
(100076, 'Boswell (historical)', 37.6963882446289, 0.65792609097886, -78.2294387817383, -1.36536127872867, 218, 53, 'PPL', 'P'),
(154400, 'Boswell (historical)', 40.9505615234375, 0.714722129124489, -80.9550018310547, -1.41293132790994, 218, 41, 'PPL', 'P'),
(211708, 'Boswell Bay', 60.4000015258789, 1.05417889483619, -146.133331298828, -2.55050777807223, 218, 1, 'PPL', 'P'),
(147300, 'Boswell Corners', 42.7186088562012, 0.745580376412319, -77.4247207641602, -1.35131629977181, 218, 40, 'PPL', 'P'),
(63079, 'Boswellville', 35.6744384765625, 0.622636410216166, -77.9727783203125, -1.36088170861711, 218, 33, 'PPL', 'P'),
(1062, 'Bosworth', 33.0227813720703, 0.576356263108878, -85.561393737793, -1.49332803331975, 218, 2, 'PPL', 'P'),
(53588, 'Bosworth', 39.4697189331055, 0.688876550219434, -93.3344421386719, -1.62899332083196, 218, 29, 'PPL', 'P'),
(154401, 'Bosworth (historical)', 41.2805595397949, 0.720481681034977, -81.4836120605469, -1.4221573168743, 218, 41, 'PPL', 'P'),
(79883, 'Botany Acres', 34.1780586242676, 0.596519654933113, -79.8377838134766, -1.3934321950406, 218, 48, 'PPL', 'P'),
(19402, 'Botany Woods', 34.3597183227539, 0.599690214789879, -83.7852783203125, -1.46232897138928, 218, 13, 'PPL', 'P'),
(79885, 'Botany Woods', 34.3652801513672, 0.599787287011613, -80.14111328125, -1.39872629297157, 218, 48, 'PPL', 'P'),
(100077, 'Botetourt (historical)', 37.5038909912109, 0.654566380105671, -79.8027801513672, -1.39282126588654, 218, 53, 'PPL', 'P'),
(100079, 'Botetourt East', 37.3413887023926, 0.651730180123763, -79.8844375610352, -1.39424645654389, 218, 53, 'PPL', 'P'),
(100080, 'Botetourt Springs (historical)', 37.3536109924316, 0.651943499327079, -79.9366683959961, -1.39515805658503, 218, 53, 'PPL', 'P'),
(100081, 'Botha', 38.6066703796387, 0.673813511356864, -77.8380584716797, -1.35853040369068, 218, 53, 'PPL', 'P'),
(206872, 'Bothell', 47.7625007629395, 0.833612897299597, -122.204170227051, -2.13286513012966, 218, 56, 'PPL', 'P'),
(7615, 'Bothersome (historical)', 35.7486114501953, 0.623930972822053, -91.9375, -1.60461208105229, 218, 4, 'PPL', 'P'),
(180203, 'Bothin (historical)', 38.0041694641113, 0.663297886634632, -122.618057250977, -2.14008882142845, 218, 6, 'PPL', 'P'),
(58744, 'Bothwell', 31.3274993896484, 0.546768010765879, -88.7433319091797, -1.54886333100533, 218, 30, 'PPL', 'P'),
(203095, 'Bothwell', 41.7172203063965, 0.728102849126456, -112.258056640625, -1.95927270026919, 218, 52, 'PPL', 'P'),
(92767, 'Botines', 27.7561092376709, 0.48443549374057, -99.4375, -1.73551177495186, 218, 51, 'PPL', 'P'),
(7618, 'Botkinburg', 35.6988906860352, 0.623063181780851, -92.5169372558594, -1.61472516897575, 218, 4, 'PPL', 'P'),
(154402, 'Botkins', 40.4677810668945, 0.706296020593533, -84.1805572509766, -1.46922789019313, 218, 41, 'PPL', 'P'),
(34931, 'Botland', 37.7763900756836, 0.659322386338389, -85.3891677856445, -1.49032212339737, 218, 21, 'PPL', 'P'),
(114673, 'Botna', 41.8558311462402, 0.730522064660684, -95.1311111450195, -1.66035111056126, 218, 16, 'PPL', 'P'),
(177310, 'Botsford', 41.3663902282715, 0.721979709148146, -73.2574996948242, -1.27858457145342, 218, 8, 'PPL', 'P'),
(198028, 'Bottineau', 48.827220916748, 0.852195769595897, -100.445281982422, -1.7531008886874, 218, 34, 'PPL', 'P'),
(85220, 'Bottle Hollow', 35.4069404602051, 0.617967689088175, -86.3622207641602, -1.50730510166881, 218, 50, 'PPL', 'P'),
(34932, 'Botto', 37.0872192382813, 0.647294086116991, -83.6772232055664, -1.46044305386334, 218, 21, 'PPL', 'P'),
(63080, 'Bottom', 36.4747200012207, 0.636603957764331, -80.774169921875, -1.40977521570209, 218, 33, 'PPL', 'P'),
(108314, 'Bottom Creek', 37.4199981689453, 0.653102174138345, -81.4955596923828, -1.42236584238766, 218, 58, 'PPL', 'P'),
(13403, 'Bottom Hills', 38.6172218322754, 0.673997668946243, -75.0713882446289, -1.31024289891174, 218, 10, 'PPL', 'P'),
(19403, 'Bottoms', 33.1055603027344, 0.577801028000246, -84.4130630493164, -1.47328588190414, 218, 13, 'PPL', 'P'),
(77899, 'Botts', 39.9358291625977, 0.697011708401299, -76.8208312988281, -1.34077644028366, 218, 45, 'PPL', 'P'),
(19404, 'Bottsford', 31.9805603027344, 0.558166073915309, -84.4380569458008, -1.47372210769069, 218, 13, 'PPL', 'P'),
(154403, 'Botzum', 41.1619415283203, 0.718411406182576, -81.5752792358398, -1.42375721089917, 218, 41, 'PPL', 'P'),
(92768, 'Bouchard', 32.9069404602051, 0.574334457788317, -96.7591705322266, -1.68876610728603, 218, 51, 'PPL', 'P'),
(147301, 'Bouckville', 42.8891716003418, 0.74855725787881, -75.5516662597656, -1.31862533160082, 218, 40, 'PPL', 'P'),
(100082, 'Boudar', 37.6269416809082, 0.656714019787738, -77.4991683959961, -1.35261565606766, 218, 53, 'PPL', 'P'),
(75180, 'Boudinot', 34.8133316040039, 0.607607260078467, -97.1080627441406, -1.69485542511849, 218, 42, 'PPL', 'P'),
(39460, 'Boudreaux', 29.4147205352783, 0.513383721894596, -90.6999969482422, -1.58301357829564, 218, 22, 'PPL', 'P'),
(92769, 'Bougainvillea Colonia', 26.318000793457, 0.459335766388305, -98.2939987182617, -1.71555391258475, 218, 51, 'PPL', 'P'),
(39461, 'Bougere', 31.2827796936035, 0.545987504829404, -91.6272201538086, -1.59919667613367, 218, 22, 'PPL', 'P'),
(39462, 'Bougere (historical)', 30.0586109161377, 0.524621729062512, -90.6074981689453, -1.58139917004283, 218, 22, 'PPL', 'P'),
(70558, 'Bougher', 39.9933280944824, 0.698015254079068, -74.879997253418, -1.30690249595645, 218, 37, 'PPL', 'P'),
(7616, 'Boughton', 33.8499984741211, 0.59079392516847, -93.3255615234375, -1.62883832485652, 218, 4, 'PPL', 'P'),
(147302, 'Boughton Hill', 42.961109161377, 0.749812805174728, -77.4119415283203, -1.35109326003052, 218, 40, 'PPL', 'P'),
(154404, 'Boughtonville', 41.0525016784668, 0.716501320469744, -82.6113891601563, -1.44184074049108, 218, 41, 'PPL', 'P'),
(79887, 'Bouknight', 33.7880592346191, 0.589712881502979, -81.8369369506836, -1.42832399953644, 218, 48, 'PPL', 'P'),
(75182, 'Boulanger Landing', 36.9700012207031, 0.645248245767592, -96.1999969482422, -1.67900668715532, 218, 42, 'PPL', 'P'),
(75181, 'Boulangerville', 36.9563903808594, 0.645010691798357, -96.2180633544922, -1.67932200542839, 218, 42, 'PPL', 'P'),
(26581, 'Boulder', 38.6966705322266, 0.67538431034682, -89.2255630493164, -1.55727985215636, 218, 18, 'PPL', 'P'),
(100083, 'Boulder', 36.6744384765625, 0.640089702736109, -82.7433319091797, -1.44414357588567, 218, 53, 'PPL', 'P'),
(108313, 'Boulder', 39.0686111450195, 0.681875898661943, -80.1036071777344, -1.39807168797563, 218, 58, 'PPL', 'P'),
(194113, 'Boulder', 40.0149993896484, 0.698393489532887, -105.269996643066, -1.83730804498489, 218, 7, 'PPL', 'P'),
(194631, 'Boulder', 43.8405609130859, 0.765162133854481, -114.505561828613, -1.99849906575524, 218, 17, 'PPL', 'P'),
(196055, 'Boulder', 46.2366714477539, 0.806982151926159, -112.120002746582, -1.95686320527294, 218, 31, 'PPL', 'P'),
(209323, 'Boulder', 42.7483291625977, 0.746099093613639, -109.716941833496, -1.91492188021361, 218, 59, 'PPL', 'P'),
(180204, 'Boulder Bay', 34.2397193908691, 0.597595838329614, -116.945556640625, -2.04108500895643, 218, 6, 'PPL', 'P'),
(13404, 'Boulder Brook', 39.7961082458496, 0.694573118370141, -75.5227813720703, -1.31812119520647, 218, 10, 'PPL', 'P'),
(53589, 'Boulder City', 36.7938919067383, 0.642174558395477, -94.2491683959961, -1.64495830577671, 218, 29, 'PPL', 'P'),
(189954, 'Boulder City', 35.9786109924316, 0.627945222112157, -114.831672668457, -2.00419077363696, 218, 39, 'PPL', 'P'),
(194632, 'Boulder City (historical)', 48.6027793884277, 0.8482785259485, -116.068328857422, -2.02577449584956, 218, 17, 'PPL', 'P'),
(180205, 'Boulder Creek', 37.1261100769043, 0.647972859299825, -122.121109008789, -2.13141543839028, 218, 6, 'PPL', 'P'),
(209324, 'Boulder Flats', 42.9127807617188, 0.748969315478472, -108.798332214355, -1.89888911781912, 218, 59, 'PPL', 'P'),
(118864, 'Boulder Hill', 41.7125015258789, 0.728020490869746, -88.3361129760742, -1.54175601984618, 218, 18, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(173258, 'Boulder Junction', 46.1133308410645, 0.804829452238021, -89.6444396972656, -1.56459062882279, 218, 57, 'PPL', 'P'),
(189955, 'Boulder Junction', 36.0811080932617, 0.62973413399539, -115.197219848633, -2.01057077550241, 218, 39, 'PPL', 'P'),
(194115, 'Boulder Junction', 40.0166702270508, 0.698422651146823, -105.20832824707, -1.83623172843033, 218, 7, 'PPL', 'P'),
(180207, 'Boulder Oaks', 32.957218170166, 0.575211969367498, -116.92472076416, -2.04072135430958, 218, 6, 'PPL', 'P'),
(129892, 'Boulder Park', 45.3138885498047, 0.79087655207585, -85.279167175293, -1.48840225056753, 218, 27, 'PPL', 'P'),
(180208, 'Boulder Park', 32.6588897705078, 0.570005156541257, -116.099998474121, -2.02632723493381, 218, 6, 'PPL', 'P'),
(19407, 'Boulder Park Estates', 33.7897186279297, 0.589741843379834, -84.6791687011719, -1.47793030168718, 218, 13, 'PPL', 'P'),
(192496, 'Boulder Town', 37.9083290100098, 0.661625155153953, -111.422218322754, -1.94468456960801, 218, 52, 'PPL', 'P'),
(19408, 'Boulder Vista', 33.8022193908691, 0.589960022852139, -84.5749969482422, -1.47611216161098, 218, 13, 'PPL', 'P'),
(154405, 'Boulevard', 41.688060760498, 0.727593919042142, -83.5074996948242, -1.45748081978284, 218, 41, 'PPL', 'P'),
(180209, 'Boulevard', 32.6636085510254, 0.570087514797967, -116.27278137207, -2.02934286539416, 218, 6, 'PPL', 'P'),
(100085, 'Boulevard Estates', 37.2797203063965, 0.650653863569208, -80.0177764892578, -1.39657365986246, 218, 53, 'PPL', 'P'),
(180210, 'Boulevard Gardens', 33.7269401550293, 0.588646152328348, -117.989723205566, -2.05930915345389, 218, 6, 'PPL', 'P'),
(86, 'Boulevard Heights', 37.2880592346191, 0.650799405322781, -77.4030609130859, -1.35093826405508, 218, 53, 'PPL', 'P'),
(44948, 'Boulevard Heights', 38.8697204589844, 0.678404601339079, -76.9336090087891, -1.34274478264534, 218, 25, 'PPL', 'P'),
(100086, 'Boulevard Manor', 36.8477783203125, 0.643115053734439, -76.1677780151367, -1.32937851029229, 218, 53, 'PPL', 'P'),
(159392, 'Boulevard Manor', 41.2466697692871, 0.71989019295687, -75.8311080932617, -1.32350251166314, 218, 45, 'PPL', 'P'),
(44949, 'Boulevard Park', 39.101390838623, 0.682448012243119, -76.477783203125, -1.33478912152095, 218, 25, 'PPL', 'P'),
(206873, 'Boulevard Park', 47.4894409179688, 0.828847103949873, -122.313888549805, -2.13478007611148, 218, 56, 'PPL', 'P'),
(15291, 'Boulogne', 30.771390914917, 0.537062086883572, -81.9761123657227, -1.4307530687667, 218, 12, 'PPL', 'P'),
(159393, 'Boulton', 40.774169921875, 0.711643514904358, -75.288330078125, -1.31402924819156, 218, 45, 'PPL', 'P'),
(147303, 'Boultons Beach', 43.9355583190918, 0.766820151370137, -76.1347198486328, -1.32880153644212, 218, 40, 'PPL', 'P'),
(191160, 'Bounce', 31.9524993896484, 0.557676318590844, -102.159172058105, -1.78301391352533, 218, 51, 'PPL', 'P'),
(144872, 'Bound Brook', 40.5683288574219, 0.708050910593841, -74.5388870239258, -1.30094899933958, 218, 37, 'PPL', 'P'),
(144870, 'Bound Brook Junction', 40.5588912963867, 0.70788619408042, -74.5658264160156, -1.30141918043004, 218, 37, 'PPL', 'P'),
(206874, 'Boundary', 48.9986114501953, 0.855187098711302, -121.60417175293, -2.12239318124931, 218, 56, 'PPL', 'P'),
(211709, 'Boundary', 64.0833282470703, 1.11846507354766, -141.016662597656, -2.46120506250304, 218, 1, 'PPL', 'P'),
(122258, 'Boundary City', 40.3444404602051, 0.704143320905395, -84.9219436645508, -1.48216752413955, 218, 19, 'PPL', 'P'),
(34933, 'Boundary Oak', 37.5302810668945, 0.6550269738162, -85.7377777099609, -1.49640651438182, 218, 21, 'PPL', 'P'),
(53591, 'Bounds', 37.2105598449707, 0.649446785805129, -90.4625015258789, -1.57886850121698, 218, 29, 'PPL', 'P'),
(58748, 'Bounds', 33.899169921875, 0.591652128829748, -89.4569396972656, -1.5613181364753, 218, 30, 'PPL', 'P'),
(15292, 'Bounds Crossing', 30.798059463501, 0.53752754086309, -85.9124984741211, -1.49945596698802, 218, 12, 'PPL', 'P'),
(58746, 'Bounds Crossroads', 34.3291702270508, 0.599157049939645, -88.2122192382813, -1.53959366619909, 218, 30, 'PPL', 'P'),
(186436, 'Bountiful', 37.2291717529297, 0.649771624879092, -105.976387023926, -1.8496368829353, 218, 7, 'PPL', 'P'),
(203098, 'Bountiful', 40.8894386291504, 0.713655333370831, -111.879997253418, -1.95267431919436, 218, 52, 'PPL', 'P'),
(203100, 'Bountiful Gardens Apartment Homes', 40.8930587768555, 0.713718516867693, -111.889442443848, -1.95283916886583, 218, 52, 'PPL', 'P'),
(203105, 'Bountiful Peak Summer Home Area', 40.973331451416, 0.715119539338157, -111.807777404785, -1.95141384505042, 218, 52, 'PPL', 'P'),
(198031, 'Bounty', 48.9161109924316, 0.853747194088923, -103.180282592773, -1.80083565438209, 218, 34, 'PPL', 'P'),
(79889, 'Bounty Land', 34.707218170166, 0.605755231277399, -82.9911117553711, -1.4484681500218, 218, 48, 'PPL', 'P'),
(44951, 'Bountys View', 38.797779083252, 0.677148987464134, -76.5950012207031, -1.33683496187035, 218, 25, 'PPL', 'P'),
(171759, 'Bouplon Corner', 42.9947204589844, 0.750399432983845, -73.2669372558594, -1.27874928796685, 218, 55, 'PPL', 'P'),
(180211, 'Bouquet Junction', 34.422779083252, 0.600790832689382, -118.53971862793, -2.06890838444503, 218, 6, 'PPL', 'P'),
(26582, 'Bourbon', 39.7455596923828, 0.693690879680025, -88.3788909912109, -1.54250263705779, 218, 18, 'PPL', 'P'),
(34935, 'Bourbon', 37.0519409179688, 0.646678363272965, -84.6224975585938, -1.47694120365832, 218, 21, 'PPL', 'P'),
(53597, 'Bourbon', 39.2388916015625, 0.684847853280417, -92.3144378662109, -1.61119088789311, 218, 29, 'PPL', 'P'),
(58747, 'Bourbon', 33.3241691589355, 0.581616472314975, -90.7986068725586, -1.5847346461501, 218, 30, 'PPL', 'P'),
(122259, 'Bourbon', 41.2955589294434, 0.720743469770131, -86.1163864135742, -1.50301448283658, 218, 19, 'PPL', 'P'),
(34939, 'Bourbon Springs', 37.8511085510254, 0.660626469745173, -85.4830627441406, -1.49196089957415, 218, 21, 'PPL', 'P'),
(118865, 'Bourbonais (historical)', 41.3436088562012, 0.721582099197397, -89.6352767944336, -1.56443070599933, 218, 18, 'PPL', 'P'),
(118866, 'Bourbonnais', 41.1416702270508, 0.718057605231759, -87.875, -1.53370808019002, 218, 18, 'PPL', 'P'),
(39463, 'Bourg', 29.5533294677734, 0.51580290413931, -90.6022186279297, -1.58130702466911, 218, 22, 'PPL', 'P'),
(39464, 'Bourgeois Landing', 29.9755592346191, 0.523172203770695, -91.6391677856445, -1.59940520164702, 218, 22, 'PPL', 'P'),
(34936, 'Bourne', 37.7097206115723, 0.658158784679106, -84.6130599975586, -1.4767764871449, 218, 21, 'PPL', 'P'),
(124274, 'Bourne', 41.7411117553711, 0.728519833574136, -70.5994415283203, -1.23219270473841, 218, 23, 'PPL', 'P'),
(200441, 'Bourne', 44.8244400024414, 0.782334063405258, -118.196388244629, -2.0629161388343, 218, 43, 'PPL', 'P'),
(124275, 'Bourne Corners', 41.7511100769043, 0.728694337204563, -70.6083297729492, -1.2323478338719, 218, 23, 'PPL', 'P'),
(159394, 'Bourne Mills', 41.8025016784668, 0.729591289859702, -76.6305618286133, -1.33745561156239, 218, 45, 'PPL', 'P'),
(124276, 'Bournedale', 41.7752799987793, 0.729116181921232, -70.5627822875977, -1.23155288028652, 218, 23, 'PPL', 'P'),
(147304, 'Bournes Beach', 42.3597183227539, 0.739316554949426, -79.5511093139648, -1.38842878114261, 218, 40, 'PPL', 'P'),
(71871, 'Bourneville', 39.2819404602051, 0.685599197602955, -83.1566696166992, -1.45135767980453, 218, 41, 'PPL', 'P'),
(177772, 'Bouse', 33.9324989318848, 0.592233829790848, -114.004997253418, -1.98976256579924, 218, 5, 'PPL', 'P'),
(75184, 'Bouse Junction', 36.4216690063477, 0.635678043232338, -98.8886108398438, -1.72593185187863, 218, 42, 'PPL', 'P'),
(63083, 'Boushell (historical)', 35.7916717529297, 0.624682516881673, -78.5861129760742, -1.37158641777674, 218, 33, 'PPL', 'P'),
(143534, 'Boutin Corner', 44.0980606079102, 0.769656351352044, -71.8763885498047, -1.25447963463684, 218, 36, 'PPL', 'P'),
(112991, 'Bouton', 41.851390838623, 0.730444566672963, -94.0088882446289, -1.64076462600817, 218, 16, 'PPL', 'P'),
(147305, 'Boutonville', 41.2569389343262, 0.720069423698232, -73.5650024414063, -1.28395150684021, 218, 40, 'PPL', 'P'),
(39465, 'Boutte', 29.9022197723389, 0.521892188682263, -90.3880615234375, -1.57756927807919, 218, 22, 'PPL', 'P'),
(159396, 'Bovard', 40.3197212219238, 0.703711888808802, -79.5036087036133, -1.38759973909527, 218, 45, 'PPL', 'P'),
(189956, 'Bovard (historical)', 38.790828704834, 0.677027680476481, -118.361671447754, -2.06580087492707, 218, 39, 'PPL', 'P'),
(194634, 'Bovard (historical)', 46.6652793884277, 0.81446277169111, -116.701393127441, -2.03682355173813, 218, 17, 'PPL', 'P'),
(169873, 'Bovee', 43.3233299255371, 0.756134750128412, -98.7686080932617, -1.72383740883934, 218, 49, 'PPL', 'P'),
(191161, 'Bovee Road Colonia', 31.636999130249, 0.552169800273428, -106.285003662109, -1.85502325939804, 218, 51, 'PPL', 'P'),
(134355, 'Bovey', 47.2955589294434, 0.825463224889791, -93.4186096191406, -1.63046232048925, 218, 28, 'PPL', 'P'),
(194635, 'Bovill', 46.8588905334473, 0.817841923640257, -116.392501831055, -2.03143238158543, 218, 17, 'PPL', 'P'),
(58749, 'Bovina', 32.3519401550293, 0.564647875113426, -90.7347183227539, -1.58361958060168, 218, 30, 'PPL', 'P'),
(147306, 'Bovina', 42.2694396972656, 0.73774089569048, -74.7272186279297, -1.30423600591501, 218, 40, 'PPL', 'P'),
(186437, 'Bovina', 39.2802810668945, 0.685570235726101, -103.384719848633, -1.80440375761058, 218, 7, 'PPL', 'P'),
(191162, 'Bovina', 34.5136108398438, 0.602376145907279, -102.882499694824, -1.79563836235674, 218, 51, 'PPL', 'P'),
(147307, 'Bovina Center', 42.2619400024414, 0.737610001322903, -74.7850036621094, -1.30524454501983, 218, 40, 'PPL', 'P'),
(7619, 'Bovine', 33.1783294677734, 0.579071089524104, -91.8816680908203, -1.60363763040943, 218, 4, 'PPL', 'P'),
(34937, 'Bow', 36.7625007629395, 0.641626679580221, -85.3450012207031, -1.48955127141985, 218, 21, 'PPL', 'P'),
(159397, 'Bow', 40.4602813720703, 0.706165126225956, -79.3597183227539, -1.38508837818733, 218, 45, 'PPL', 'P'),
(206875, 'Bow', 48.561939239502, 0.84756573088274, -122.396942138672, -2.13622963469281, 218, 56, 'PPL', 'P'),
(143535, 'Bow Bog', 43.1205596923828, 0.752595741934833, -71.5119400024414, -1.24811880753124, 218, 36, 'PPL', 'P'),
(143540, 'Bow Center', 43.1319389343262, 0.752794347173126, -71.5497207641602, -1.24877820621715, 218, 36, 'PPL', 'P'),
(143536, 'Bow Junction', 43.1763916015625, 0.753570192577693, -71.5263900756836, -1.24837100888647, 218, 36, 'PPL', 'P'),
(143537, 'Bow Lake Village', 43.2413902282715, 0.75470463262304, -71.1511077880859, -1.24182109734348, 218, 36, 'PPL', 'P'),
(186438, 'Bow Mar', 39.6283302307129, 0.691644839593544, -105.049438476563, -1.83345857878723, 218, 7, 'PPL', 'P'),
(143538, 'Bow Mills', 43.1669387817383, 0.753405209748163, -71.5336074829102, -1.24849697640604, 218, 36, 'PPL', 'P'),
(141348, 'Bow Valley', 42.7147216796875, 0.74551253238355, -97.2491683959961, -1.69731818333654, 218, 35, 'PPL', 'P'),
(141346, 'Bow Valley Mills', 42.7616691589355, 0.74633192047194, -97.1666717529297, -1.69587834529319, 218, 35, 'PPL', 'P'),
(198032, 'Bowbells', 48.8030586242676, 0.851774058037283, -102.245559692383, -1.78452166217648, 218, 34, 'PPL', 'P'),
(15293, 'Bowden', 30.2658290863037, 0.528238368401867, -81.6183319091797, -1.42450862180074, 218, 12, 'PPL', 'P'),
(39469, 'Bowden', 30.1627807617188, 0.526439835849195, -90.9933319091797, -1.5881332391752, 218, 22, 'PPL', 'P'),
(75185, 'Bowden', 36.0627784729004, 0.629414221769445, -96.0869369506836, -1.67703341794563, 218, 42, 'PPL', 'P'),
(108316, 'Bowden', 38.9086112976074, 0.679083374521913, -79.7099990844727, -1.39120193078571, 218, 58, 'PPL', 'P'),
(112266, 'Bowden', 33.6444396972656, 0.587206247705969, -84.2163925170898, -1.46985333357513, 218, 13, 'PPL', 'P'),
(126917, 'Bowden (historical)', 45.6749992370605, 0.797179122532605, -68.6716690063477, -1.19854672700051, 218, 26, 'PPL', 'P'),
(1063, 'Bowden Grove', 33.339168548584, 0.58187826105013, -85.8436126708984, -1.4982536829139, 218, 2, 'PPL', 'P'),
(63084, 'Bowdens', 35.0569381713867, 0.611858996758778, -78.1158294677734, -1.36337842213906, 218, 33, 'PPL', 'P'),
(13405, 'Bowdens Garage (historical)', 38.6980590820313, 0.67540854511274, -75.3752822875977, -1.31554685053874, 218, 10, 'PPL', 'P'),
(159402, 'Bowdertown', 40.7608299255371, 0.711410688046058, -78.8480606079102, -1.37615826642007, 218, 45, 'PPL', 'P'),
(63085, 'Bowditch', 35.8838882446289, 0.626291998286463, -82.2163925170898, -1.43494674853525, 218, 33, 'PPL', 'P'),
(169874, 'Bowdle', 45.4530601501465, 0.793305554727084, -99.6536102294922, -1.73928361000374, 218, 49, 'PPL', 'P'),
(196056, 'Bowdoin', 48.3927803039551, 0.844613350498278, -107.605560302734, -1.87807132073602, 218, 31, 'PPL', 'P'),
(126918, 'Bowdoin Center', 44.0366706848145, 0.768584895066478, -69.9733276367188, -1.22126495583748, 218, 26, 'PPL', 'P'),
(126920, 'Bowdoinham', 44.0099983215332, 0.768119374507932, -69.8988876342773, -1.21996573269969, 218, 26, 'PPL', 'P'),
(19409, 'Bowdon', 33.5377807617188, 0.585344698104004, -85.2533264160156, -1.48795124423693, 218, 13, 'PPL', 'P'),
(139699, 'Bowdon', 47.4697189331055, 0.82850289037898, -99.7074966430664, -1.7402241053427, 218, 34, 'PPL', 'P'),
(19410, 'Bowdon Junction', 33.6630592346191, 0.587531219937986, -85.1469421386719, -1.48609448832493, 218, 13, 'PPL', 'P'),
(58750, 'Bowdre', 34.7966690063477, 0.60731644288743, -90.3322219848633, -1.57659469427827, 218, 30, 'PPL', 'P'),
(53598, 'Bowdry', 39.2822189331055, 0.685604057871945, -93.5111083984375, -1.63207672874206, 218, 29, 'PPL', 'P'),
(7620, 'Bowen', 33.9691696166992, 0.592873853979822, -93.4941711425781, -1.63178111786106, 218, 4, 'PPL', 'P'),
(34938, 'Bowen', 37.8411102294922, 0.660451966114746, -83.7719421386719, -1.46209621111, 218, 21, 'PPL', 'P'),
(53599, 'Bowen', 38.5580596923828, 0.672965094812592, -93.5908279418945, -1.63346809725357, 218, 29, 'PPL', 'P'),
(85221, 'Bowen', 36.3072204589844, 0.633680539256724, -83.4286117553711, -1.45610396549927, 218, 50, 'PPL', 'P'),
(108315, 'Bowen', 38.3061103820801, 0.66856774979968, -82.3433303833008, -1.43716223224608, 218, 58, 'PPL', 'P'),
(118868, 'Bowen', 40.2333297729492, 0.702204073578626, -91.0625, -1.58934045009734, 218, 18, 'PPL', 'P'),
(147309, 'Bowen', 42.1294403076172, 0.735297445390333, -79.0155563354492, -1.37908161834865, 218, 40, 'PPL', 'P'),
(1065, 'Bowen (historical)', 34.2191696166992, 0.597237177109807, -86.3758316040039, -1.50754265563804, 218, 2, 'PPL', 'P'),
(154406, 'Bowen (historical)', 41.7158317565918, 0.728078614360537, -83.7972183227539, -1.46253736374458, 218, 41, 'PPL', 'P'),
(147310, 'Bowen Corners', 43.3066711425781, 0.755843999516403, -76.2516708374023, -1.33084271625961, 218, 40, 'PPL', 'P'),
(44952, 'Bowen Country', 38.5852813720703, 0.673440202751062, -76.6177825927734, -1.33723257182109, 218, 25, 'PPL', 'P'),
(44953, 'Bowen Estates', 38.5955581665039, 0.673619566650479, -76.7569427490234, -1.33966137473525, 218, 25, 'PPL', 'P'),
(13406, 'Bowen Landing', 38.920280456543, 0.679287039766277, -75.4094390869141, -1.31614299914876, 218, 10, 'PPL', 'P'),
(19413, 'Bowen Mill', 32.2408294677734, 0.562708627786658, -81.8305587768555, -1.42821267940287, 218, 13, 'PPL', 'P'),
(44954, 'Bowens', 38.4952812194824, 0.671869403761106, -76.6224975585938, -1.33731486349878, 218, 25, 'PPL', 'P'),
(100087, 'Bowens Corner', 36.5669403076172, 0.638213505748148, -77.8213882446289, -1.35823945334158, 218, 53, 'PPL', 'P'),
(124278, 'Bowens Corners', 42.6158294677734, 0.743786537681069, -73.1074981689453, -1.27596655094382, 218, 23, 'PPL', 'P'),
(147311, 'Bowens Corners', 43.2752799987793, 0.755296120701146, -76.4638900756836, -1.33454664070369, 218, 40, 'PPL', 'P'),
(19414, 'Bowens Mill', 31.8425006866455, 0.555756479050519, -83.2094421386719, -1.45227873406754, 218, 13, 'PPL', 'P'),
(129894, 'Bowens Mill', 42.6566696166992, 0.744499332746829, -85.5166702270508, -1.49254746080424, 218, 27, 'PPL', 'P'),
(70559, 'Bowentown', 39.4244384765625, 0.688086257165953, -75.2766723632813, -1.31382578268428, 218, 37, 'PPL', 'P'),
(124279, 'Bowenville', 41.7249984741211, 0.728238603763023, -71.1466674804688, -1.24174359935576, 218, 23, 'PPL', 'P'),
(108317, 'Bower', 38.8583297729492, 0.678205796363704, -80.7200012207031, -1.40882979351511, 218, 58, 'PPL', 'P'),
(159398, 'Bower', 40.894718170166, 0.713747478744548, -78.6755599975586, -1.37314756280774, 218, 45, 'PPL', 'P'),
(141347, 'Bower (historical)', 40.2625007629395, 0.702713203400022, -97.1788864135742, -1.69609153133845, 218, 35, 'PPL', 'P'),
(159400, 'Bower Hill', 40.2602806091309, 0.702674454406162, -80.0680618286133, -1.39745130459969, 218, 45, 'PPL', 'P'),
(126922, 'Bowerbank', 45.2727813720703, 0.790159096478183, -69.2125015258789, -1.20798603516819, 218, 26, 'PPL', 'P'),
(180212, 'Bowerbank', 35.3994407653809, 0.617836794720597, -119.407501220703, -2.08405404788042, 218, 6, 'PPL', 'P'),
(126923, 'Bowerbank (historical)', 45.3963890075684, 0.792316456698229, -68.5997161865234, -1.19729091338848, 218, 26, 'PPL', 'P'),
(44955, 'Bowercrest Park', 39.5130615234375, 0.689633021127071, -77.0730590820313, -1.34517864556556, 218, 25, 'PPL', 'P'),
(75186, 'Bowers', 34.9122200012207, 0.60933318820192, -95.4188919067383, -1.66537383237715, 218, 42, 'PPL', 'P'),
(92770, 'Bowers', 30.9116897583008, 0.539510763637359, -97.1859588623047, -1.69621496885498, 218, 51, 'PPL', 'P'),
(122261, 'Bowers', 40.1569404602051, 0.700870828557906, -86.7247161865234, -1.51363184031245, 218, 19, 'PPL', 'P'),
(159401, 'Bowers', 40.4872207641602, 0.706635307316409, -75.7425003051758, -1.32195601401813, 218, 45, 'PPL', 'P'),
(173262, 'Bowers', 42.6913909912109, 0.745105335052876, -88.4444427490234, -1.54364673106208, 218, 57, 'PPL', 'P'),
(13407, 'Bowers Beach', 39.0597190856934, 0.681720702949418, -75.4016723632813, -1.31600744424927, 218, 10, 'PPL', 'P'),
(191163, 'Bowers City', 35.4188919067383, 0.618176281180555, -100.91667175293, -1.76132819224298, 218, 51, 'PPL', 'P'),
(100088, 'Bowers Corner', 36.6361083984375, 0.639420716670281, -77.9611129760742, -1.36067810995177, 218, 53, 'PPL', 'P'),
(147312, 'Bowers Corner', 42.6508293151855, 0.744397400256106, -76.5961074829102, -1.33685426978825, 218, 40, 'PPL', 'P'),
(100089, 'Bowers Hill', 36.7866706848145, 0.642048524296889, -76.4130630493164, -1.33365954174459, 218, 53, 'PPL', 'P'),
(108318, 'Bowers Hill', 38.792781829834, 0.677061768938434, -81.3080596923828, -1.41909335004017, 218, 58, 'PPL', 'P'),
(177517, 'Bowers Hill', 41.4044418334961, 0.722643834944985, -73.1630630493164, -1.27693634105477, 218, 8, 'PPL', 'P'),
(53602, 'Bowers Mill', 37.1497192382813, 0.648384916899488, -94.0561065673828, -1.64158874120749, 218, 29, 'PPL', 'P'),
(154407, 'Bowerston', 40.4252815246582, 0.705554263650919, -81.1880569458008, -1.41699890700088, 218, 41, 'PPL', 'P'),
(122262, 'Bowerstown', 40.8886108398438, 0.713640885721917, -85.442497253418, -1.49125289819836, 218, 19, 'PPL', 'P'),
(147313, 'Bowerstown', 42.6858291625977, 0.745008262831143, -74.9180603027344, -1.30756682149037, 218, 40, 'PPL', 'P'),
(19415, 'Bowersville', 34.3727798461914, 0.59991818137919, -83.0827789306641, -1.45006804404666, 218, 13, 'PPL', 'P'),
(71872, 'Bowersville', 39.5805587768555, 0.690811070435267, -83.7249984741211, -1.46127688960064, 218, 41, 'PPL', 'P'),
(100090, 'Bowersville', 37.8349990844727, 0.660345306513088, -77.3633270263672, -1.35024477690722, 218, 53, 'PPL', 'P'),
(159403, 'Bowersville', 40.922779083252, 0.714237234069013, -78.8644409179688, -1.37644415676309, 218, 45, 'PPL', 'P'),
(200442, 'Bowersville (historical)', 44.9166717529297, 0.783943811126156, -123.256942749023, -2.15123947691261, 218, 43, 'PPL', 'P'),
(58751, 'Bowerton', 31.7561092376709, 0.554248663820344, -90.5694427490234, -1.58073497766696, 218, 30, 'PPL', 'P'),
(108322, 'Bowes', 37.8411102294922, 0.660451966114746, -80.3744430541992, -1.40279866575246, 218, 58, 'PPL', 'P'),
(118869, 'Bowes', 42.0080604553223, 0.733178967322202, -88.3908309936523, -1.54271102941308, 218, 18, 'PPL', 'P'),
(118870, 'Bowes Bend', 42.0108299255371, 0.733227303695987, -88.4147186279297, -1.54312794728174, 218, 18, 'PPL', 'P'),
(139702, 'Bowesmont', 48.689998626709, 0.849800788827589, -97.1777801513672, -1.69607222342055, 218, 34, 'PPL', 'P'),
(77901, 'Bowest', 39.9874992370605, 0.697913521325427, -79.5908279418945, -1.38912200197436, 218, 45, 'PPL', 'P'),
(39467, 'Bowie', 29.7458305358887, 0.519162681591527, -90.5944366455078, -1.58117120345352, 218, 22, 'PPL', 'P'),
(44956, 'Bowie', 39.0066719055176, 0.680794854996452, -76.7794418334961, -1.34005405783798, 218, 25, 'PPL', 'P'),
(58752, 'Bowie', 31.3927803039551, 0.547907377659242, -89.3716735839844, -1.55982996205817, 218, 30, 'PPL', 'P'),
(92771, 'Bowie', 33.5588912963867, 0.585713146440817, -97.8483276367188, -1.7077754848309, 218, 51, 'PPL', 'P'),
(159404, 'Bowie', 41.2580604553223, 0.720088997932244, -80.1063919067383, -1.39812029066552, 218, 45, 'PPL', 'P'),
(177773, 'Bowie', 32.3263893127441, 0.564201928788892, -109.486389160156, -1.91089797696456, 218, 5, 'PPL', 'P'),
(186439, 'Bowie', 38.9213905334473, 0.679306414263207, -107.539436340332, -1.87691723987764, 218, 7, 'PPL', 'P'),
(53600, 'Bowie Corner', 36.1324996948242, 0.630631086650529, -90.0047225952148, -1.57087875163063, 218, 29, 'PPL', 'P'),
(177774, 'Bowie Junction (historical)', 32.3624992370605, 0.564832165860859, -109.625, -1.91331719249878, 218, 5, 'PPL', 'P'),
(44957, 'Bowie Mill Estates', 39.1419410705566, 0.683155747302807, -77.1152801513672, -1.34591554223919, 218, 25, 'PPL', 'P'),
(44958, 'Bowie Mill Park', 39.1391716003418, 0.683107410929023, -77.1213912963867, -1.34602220184085, 218, 25, 'PPL', 'P'),
(58753, 'Bowies Chapel', 33.1749992370605, 0.579012966033313, -89.3436126708984, -1.5593402067337, 218, 30, 'PPL', 'P'),
(143541, 'Bowkerville', 42.8058280944824, 0.747102639291409, -72.1647186279297, -1.25951194383266, 218, 36, 'PPL', 'P'),
(85222, 'Bowl (historical)', 36.4608306884766, 0.636361543526107, -84.3819427490234, -1.47274273019981, 218, 50, 'PPL', 'P'),
(108319, 'Bowlby', 39.7113914489746, 0.693094531332929, -80.0169372558594, -1.39655901247646, 218, 58, 'PPL', 'P'),
(854, 'Bowlder', 39.9474983215332, 0.697215373645663, -77.0991668701172, -1.34563431242808, 218, 45, 'PPL', 'P'),
(75187, 'Bowlegs', 35.146110534668, 0.613415348099821, -96.6697235107422, -1.68720496225502, 218, 42, 'PPL', 'P'),
(63086, 'Bowlens Creek', 35.8777809143066, 0.626185405263832, -82.2852783203125, -1.43614903260936, 218, 33, 'PPL', 'P'),
(100091, 'Bowler', 37.2769393920898, 0.650605327458341, -78.7050018310547, -1.37366141974007, 218, 53, 'PPL', 'P'),
(147314, 'Bowler', 42.003059387207, 0.733091682217474, -78.2463912963867, -1.36565715592578, 218, 40, 'PPL', 'P'),
(173263, 'Bowler', 44.8630599975586, 0.783008109477157, -88.9819412231445, -1.55302784915994, 218, 57, 'PPL', 'P'),
(196057, 'Bowler', 45.2050018310547, 0.78897612032197, -108.718330383301, -1.89749282245959, 218, 31, 'PPL', 'P'),
(189958, 'Bowlerville (historical)', 36.4488906860352, 0.636153151170808, -116.048889160156, -2.02543520912668, 218, 39, 'PPL', 'P'),
(58754, 'Bowles', 33.3363914489746, 0.58182979151829, -90.5897216796875, -1.58108891177583, 218, 30, 'PPL', 'P'),
(108320, 'Bowles', 38.3236083984375, 0.668873147797685, -82.0569381713867, -1.43216374519611, 218, 58, 'PPL', 'P'),
(112198, 'Bowles', 31.5733299255371, 0.551058563019079, -86.976936340332, -1.5180339124363, 218, 2, 'PPL', 'P'),
(180213, 'Bowles', 36.6041717529297, 0.638863317054127, -119.75, -2.09003177926321, 218, 6, 'PPL', 'P'),
(58755, 'Bowles (historical)', 33.8250007629395, 0.590357632802887, -89.1366729736328, -1.55572842766334, 218, 30, 'PPL', 'P'),
(26585, 'Bowlesville (historical)', 37.6741714477539, 0.657538334724145, -88.2125015258789, -1.53959859304711, 218, 18, 'PPL', 'P'),
(44959, 'Bowleys Quarters', 39.3352813720703, 0.68653017214102, -76.3905563354492, -1.3332667254838, 218, 25, 'PPL', 'P'),
(108321, 'Bowlin', 37.9938888549805, 0.663118456156188, -81.1247177124023, -1.41589342883238, 218, 58, 'PPL', 'P'),
(58756, 'Bowlin (historical)', 33.0847206115723, 0.577437306774368, -89.7763900756836, -1.56689359737544, 218, 30, 'PPL', 'P'),
(75188, 'Bowlin Spring', 36.6188888549805, 0.639120178941265, -95.3775024414063, -1.66465144993147, 218, 42, 'PPL', 'P'),
(85223, 'Bowling', 35.9444389343262, 0.627348807186034, -84.9458312988281, -1.4825844420082, 218, 50, 'PPL', 'P'),
(15294, 'Bowling Green', 27.6380596160889, 0.482375139163231, -81.8241729736328, -1.42810122611125, 218, 12, 'PPL', 'P'),
(29269, 'Bowling Green', 39.3830604553223, 0.687364074457351, -87.0116729736328, -1.51864018105846, 218, 19, 'PPL', 'P'),
(34940, 'Bowling Green', 36.9902801513672, 0.645602179876464, -86.4436111450195, -1.50872563179426, 218, 21, 'PPL', 'P'),
(44960, 'Bowling Green', 39.6236114501953, 0.691562481336833, -78.8047180175781, -1.37540179551244, 218, 25, 'PPL', 'P'),
(53603, 'Bowling Green', 39.3419418334961, 0.686646419122602, -91.1949996948242, -1.59165300602991, 218, 29, 'PPL', 'P'),
(58757, 'Bowling Green', 33.1624984741211, 0.578794786561009, -89.9130630493164, -1.56927899076382, 218, 30, 'PPL', 'P'),
(77902, 'Bowling Green', 39.9191703796387, 0.69672095778929, -75.3808288574219, -1.31564365644437, 218, 45, 'PPL', 'P'),
(79891, 'Bowling Green', 35.1497192382813, 0.613478331859601, -81.2125015258789, -1.41742554540751, 218, 48, 'PPL', 'P'),
(100093, 'Bowling Green', 37.3236083984375, 0.651419855277742, -79.9499969482422, -1.39539068370624, 218, 53, 'PPL', 'P'),
(154408, 'Bowling Green', 41.3747215270996, 0.722125117743665, -83.6513900756836, -1.45999218069079, 218, 41, 'PPL', 'P'),
(203108, 'Bowling Green', 40.6694412231445, 0.709815654290182, -111.943061828613, -1.95377500367289, 218, 52, 'PPL', 'P'),
(19416, 'Bowling Green (historical)', 33.7619400024414, 0.589257014903385, -83.1366729736328, -1.45100867254368, 218, 13, 'PPL', 'P'),
(118871, 'Bowling Green (historical)', 40.6630592346191, 0.709704267577589, -89.1727828979492, -1.5563586647353, 218, 18, 'PPL', 'P'),
(63087, 'Bowling Heights', 35.0627784729004, 0.611960929249501, -77.0297164916992, -1.34442217465793, 218, 33, 'PPL', 'P'),
(44967, 'Bowling Landing', 38.6847190856934, 0.67517571825444, -76.7019424438477, -1.33870143832033, 218, 25, 'PPL', 'P'),
(100095, 'Bowling Springs (historical)', 36.7222213745117, 0.640923671631467, -80.2388916015625, -1.40043284659809, 218, 53, 'PPL', 'P'),
(34941, 'Bowlingtown', 37.309440612793, 0.651172580770528, -83.4527816772461, -1.45652581021594, 218, 21, 'PPL', 'P'),
(19418, 'Bowls (historical)', 34.4091682434082, 0.600553278720147, -84.8008270263672, -1.4800536400243, 218, 13, 'PPL', 'P'),
(171761, 'Bowlsville', 43.4477806091309, 0.758306824313481, -72.8525009155273, -1.27151600928814, 218, 55, 'PPL', 'P'),
(134356, 'Bowlus', 45.8194389343262, 0.799700070820474, -94.4091720581055, -1.64775089649577, 218, 28, 'PPL', 'P'),
(154411, 'Bowlusville', 40.0263900756836, 0.698592294508261, -83.7986068725586, -1.4625615985105, 218, 41, 'PPL', 'P'),
(7626, 'Bowman', 35.8230590820313, 0.625230329117903, -90.4925003051758, -1.57939207868729, 218, 4, 'PPL', 'P'),
(19417, 'Bowman', 34.204719543457, 0.596984975754577, -83.0308303833008, -1.44916137085354, 218, 13, 'PPL', 'P'),
(29266, 'Bowman', 38.4963912963867, 0.671888778258037, -87.3469390869141, -1.52449167860558, 218, 19, 'PPL', 'P'),
(58758, 'Bowman', 34.6994400024414, 0.605619476640832, -89.8455581665039, -1.56810080829757, 218, 30, 'PPL', 'P'),
(79892, 'Bowman', 33.3486099243164, 0.582043044142578, -80.6830596923828, -1.4081850422152, 218, 48, 'PPL', 'P'),
(85224, 'Bowman', 36.0611114501953, 0.629385126734535, -85.0283279418945, -1.48402428005155, 218, 50, 'PPL', 'P'),
(100096, 'Bowman', 37.2811088562012, 0.650678098335128, -79.8916702270508, -1.39437269037956, 218, 53, 'PPL', 'P'),
(143542, 'Bowman', 44.3586082458496, 0.774203765492382, -71.352783203125, -1.24534099735624, 218, 36, 'PPL', 'P'),
(180214, 'Bowman', 38.9419403076172, 0.679665075483013, -121.04638671875, -2.11265799588452, 218, 6, 'PPL', 'P'),
(198034, 'Bowman', 46.1830596923828, 0.80604645027716, -103.394439697266, -1.80457340097201, 218, 34, 'PPL', 'P'),
(26588, 'Bowman (historical)', 39.1375007629395, 0.683078249315086, -90.2444381713867, -1.57506257770315, 218, 18, 'PPL', 'P'),
(177189, 'Bowman (historical)', 40.2472190856934, 0.702446487816851, -80.6447219848633, -1.40751592299132, 218, 58, 'PPL', 'P'),
(29267, 'Bowman Acres', 39.7619400024414, 0.693976770023045, -85.7675018310547, -1.49692529816217, 218, 19, 'PPL', 'P'),
(63088, 'Bowman Bluff', 35.3036117553711, 0.616164262977001, -82.5619430541992, -1.44097774313984, 218, 33, 'PPL', 'P'),
(171762, 'Bowman Corners', 44.5736083984375, 0.777956226047331, -73.057502746582, -1.27509396621266, 218, 55, 'PPL', 'P'),
(159405, 'Bowman Creek', 41.4297218322754, 0.723085054158583, -76.0197219848633, -1.32679444508658, 218, 45, 'PPL', 'P'),
(1066, 'Bowman Crossroads', 34.6022186279297, 0.603922643552288, -85.8563919067383, -1.4984767226552, 218, 2, 'PPL', 'P'),
(100099, 'Bowman Lawn', 37.2963905334473, 0.650944813918299, -79.942497253418, -1.39525978933867, 218, 53, 'PPL', 'P'),
(70560, 'Bowman Manor', 39.0161094665527, 0.680959571509874, -74.934440612793, -1.30785271183339, 218, 37, 'PPL', 'P'),
(180215, 'Bowman Place', 39.7894401550293, 0.694456738230504, -123.561668395996, -2.15655794276755, 218, 6, 'PPL', 'P'),
(196058, 'Bowman Place', 45.1130599975586, 0.787371432607142, -112.048889160156, -1.95562203904691, 218, 31, 'PPL', 'P'),
(159406, 'Bowmans', 40.8238906860352, 0.71251130594556, -76.1397171020508, -1.32888875496782, 218, 45, 'PPL', 'P'),
(44961, 'Bowmans Addition', 39.6916694641113, 0.692750317762036, -78.7486114501953, -1.37442255117961, 218, 25, 'PPL', 'P'),
(154412, 'Bowmans Corners', 40.9880599975586, 0.715376600962376, -80.857780456543, -1.4112344948214, 218, 41, 'PPL', 'P'),
(100097, 'Bowmans Crossing', 38.8074989318848, 0.677318630825572, -78.5922164916992, -1.37169294422034, 218, 53, 'PPL', 'P'),
(44962, 'Bowmans Mill', 39.684440612793, 0.692624150505394, -77.6147232055664, -1.35463246796118, 218, 25, 'PPL', 'P'),
(159407, 'Bowmansdale', 40.1661109924316, 0.701030884539419, -76.9783325195313, -1.34352535516084, 218, 45, 'PPL', 'P'),
(159408, 'Bowmanstown', 40.7997207641602, 0.712089461228892, -75.6622161865234, -1.32055479181058, 218, 45, 'PPL', 'P'),
(53606, 'Bowmansville', 38.709171295166, 0.675602489819125, -93.7336120605469, -1.63596015024361, 218, 29, 'PPL', 'P'),
(147315, 'Bowmansville', 42.9383316040039, 0.749415261803006, -78.6849975585938, -1.37331227932116, 218, 40, 'PPL', 'P'),
(159410, 'Bowmansville', 40.1966705322266, 0.701564249126735, -76.0177764892578, -1.32676048978268, 218, 45, 'PPL', 'P'),
(85225, 'Bowmantown', 36.2980613708496, 0.633520683012292, -82.5758285522461, -1.44122009079904, 218, 50, 'PPL', 'P'),
(100098, 'Bowmantown', 38.9513893127441, 0.679829991733517, -77.6366729736328, -1.35501556368399, 218, 53, 'PPL', 'P'),
(129898, 'Bowmanville', 44.0833282470703, 0.769399223148797, -84.2466735839844, -1.47038183789346, 218, 27, 'PPL', 'P'),
(194636, 'Bowmont', 43.4561080932617, 0.758452166329972, -116.540000915527, -2.03400672625316, 218, 17, 'PPL', 'P'),
(63089, 'Bowmore', 34.9419403076172, 0.60985190540324, -79.3033294677734, -1.38410420700649, 218, 33, 'PPL', 'P'),
(144873, 'Bowne', 40.4197196960449, 0.705457191429186, -74.9130630493164, -1.30747960296467, 218, 37, 'PPL', 'P'),
(129895, 'Bowne Center', 42.8127784729004, 0.747223946279062, -85.3691711425781, -1.48997311613652, 218, 27, 'PPL', 'P'),
(77903, 'Bowood', 39.8161087036133, 0.694922192210023, -79.8497161865234, -1.39364045423784, 218, 45, 'PPL', 'P'),
(75190, 'Bowring', 36.878059387207, 0.643643558052765, -96.1197204589844, -1.67760559810583, 218, 42, 'PPL', 'P'),
(92773, 'Bowser', 31.4055595397949, 0.548130417400536, -98.9619369506836, -1.72721163394047, 218, 51, 'PPL', 'P'),
(7628, 'Bowser (historical)', 33.5844383239746, 0.586159026186323, -91.813606262207, -1.6024497274052, 218, 4, 'PPL', 'P'),
(114675, 'Bowsher', 41.6391716003418, 0.726740642228881, -93.5416717529297, -1.6326101599084, 218, 16, 'PPL', 'P'),
(154413, 'Bowsherville (historical)', 40.7380599975586, 0.711013277832391, -83.2936096191406, -1.45374773372482, 218, 41, 'PPL', 'P'),
(134358, 'Bowstring', 47.5430603027344, 0.829782938756927, -93.79638671875, -1.63705577471607, 218, 28, 'PPL', 'P'),
(203109, 'Bowthorpe', 40.6652793884277, 0.70974301657145, -111.815277099609, -1.951544739418, 218, 52, 'PPL', 'P'),
(79894, 'Bowyer', 33.3061103820801, 0.581301287199964, -80.4205627441406, -1.40360360619194, 218, 48, 'PPL', 'P'),
(75192, 'Box', 35.5811080932617, 0.621007487735419, -94.9761123657227, -1.65764587152596, 218, 42, 'PPL', 'P'),
(19419, 'Box Ankle', 33.1166687011719, 0.577994906127603, -83.9733276367188, -1.46561105111669, 218, 13, 'PPL', 'P'),
(188177, 'Box Bar Place', 34.4241714477539, 0.600815134034329, -107.790557861328, -1.88130013724163, 218, 38, 'PPL', 'P'),
(194637, 'Box Canyon', 44.3788909912109, 0.774557766180281, -111.404716491699, -1.94437910503098, 218, 17, 'PPL', 'P'),
(191164, 'Box Canyon Estates', 29.5283298492432, 0.515366578484214, -101.167503356934, -1.76570602960091, 218, 51, 'PPL', 'P'),
(92774, 'Box Church', 31.4675197601318, 0.549211827250677, -96.4872589111328, -1.68402035422351, 218, 51, 'PPL', 'P'),
(143543, 'Box Corner', 43.2608299255371, 0.755043919345916, -72.0294418334961, -1.25715091836825, 218, 36, 'PPL', 'P'),
(85226, 'Box Elder', 35.2536087036133, 0.615291545087782, -88.309440612793, -1.54129049928764, 218, 50, 'PPL', 'P'),
(100100, 'Box Elder', 36.6575012207031, 0.63979409185511, -76.7263870239258, -1.33912807672696, 218, 53, 'PPL', 'P'),
(196059, 'Box Elder', 48.3172187805176, 0.843294553126471, -110.012496948242, -1.92008029008704, 218, 31, 'PPL', 'P'),
(201924, 'Box Elder', 44.1124992370605, 0.769908352970193, -103.067779541016, -1.79887210571037, 218, 49, 'PPL', 'P'),
(196062, 'Box Elder (historical)', 47.8855590820313, 0.835760670139719, -107.683326721191, -1.87942860078558, 218, 31, 'PPL', 'P'),
(44963, 'Box Hill North', 39.4791717529297, 0.689041533048964, -76.3052825927734, -1.33177841790861, 218, 25, 'PPL', 'P'),
(44964, 'Box Hill South', 39.4680595397949, 0.688847588342579, -76.2972183227539, -1.331637669845, 218, 25, 'PPL', 'P'),
(194116, 'Box Prairie', 40.5813903808594, 0.708278877183152, -105.468330383301, -1.84076962176977, 218, 7, 'PPL', 'P'),
(7630, 'Box Springs', 33.2616691589355, 0.580525641532478, -93.3680572509766, -1.62958001522011, 218, 4, 'PPL', 'P'),
(19420, 'Box Springs', 32.5325012207031, 0.567799260210344, -84.6611099243164, -1.47761511657217, 218, 13, 'PPL', 'P'),
(180216, 'Box Springs', 33.9466705322266, 0.592481170877089, -117.295562744141, -2.04719376786485, 218, 6, 'PPL', 'P'),
(209871, 'Box Springs (historical)', 47.0050010681152, 0.820392033542062, -109.345832824707, -1.90844480612643, 218, 31, 'PPL', 'P'),
(124280, 'Boxboro', 42.4916687011719, 0.741619523502072, -71.5277786254883, -1.24839524365239, 218, 23, 'PPL', 'P'),
(124281, 'Boxboro Station', 42.5041694641113, 0.741837702974376, -71.4933319091797, -1.24779403503631, 218, 23, 'PPL', 'P'),
(92775, 'Boxelder', 33.4797210693359, 0.584331365309229, -94.8816680908203, -1.65599750796926, 218, 51, 'PPL', 'P'),
(209325, 'Boxelder', 42.6144409179688, 0.743762302915149, -105.859443664551, -1.84759583627586, 218, 59, 'PPL', 'P'),
(44965, 'Boxer Hill Park', 39.4569396972656, 0.68865351047814, -76.6833267211914, -1.33837653266734, 218, 25, 'PPL', 'P'),
(124283, 'Boxford', 42.6611099243164, 0.74457683073455, -70.9972229003906, -1.23913529938413, 218, 23, 'PPL', 'P'),
(53608, 'Boxford (historical)', 39.848331451416, 0.69548458525322, -94.5883331298828, -1.65087784708969, 218, 29, 'PPL', 'P'),
(124284, 'Boxford Station', 42.6455612182617, 0.744305454619471, -71.0583267211914, -1.24020176224266, 218, 23, 'PPL', 'P'),
(114676, 'Boxholm', 42.1758308410645, 0.736107112940744, -94.105827331543, -1.64245653224869, 218, 16, 'PPL', 'P'),
(44966, 'Boxiron', 38.1150016784668, 0.665232273692411, -75.3494415283203, -1.31509584420814, 218, 25, 'PPL', 'P'),
(44972, 'Boxiron Landing', 38.098331451416, 0.66494132334332, -75.3380584716797, -1.31489717239082, 218, 25, 'PPL', 'P'),
(7629, 'Boxley', 35.9766693115234, 0.627911333387286, -93.4019393920898, -1.63017137014016, 218, 4, 'PPL', 'P'),
(100101, 'Boxley', 37.2688903808594, 0.65046484571084, -80.9541702270508, -1.412916813682, 218, 53, 'PPL', 'P'),
(122263, 'Boxley', 40.1661109924316, 0.701030884539419, -86.1755599975586, -1.50404725670731, 218, 19, 'PPL', 'P'),
(100102, 'Boxley Hill', 37.3277816772461, 0.651492692733556, -79.9569396972656, -1.39551185753584, 218, 53, 'PPL', 'P'),
(100103, 'Boxley Hills', 37.1016693115234, 0.647546287472222, -76.5250015258789, -1.33561323672027, 218, 53, 'PPL', 'P'),
(1068, 'Boxtel', 34.0186080932617, 0.593736718173007, -86.2680587768555, -1.50566166496012, 218, 2, 'PPL', 'P'),
(34942, 'Boxville', 37.6283302307129, 0.656738254553657, -87.8277816772461, -1.53288396499069, 218, 21, 'PPL', 'P'),
(13416, 'Boxwood', 39.726390838623, 0.693356320068083, -75.5972213745117, -1.31942041834426, 218, 10, 'PPL', 'P'),
(44968, 'Boxwood', 39.422779083252, 0.688057295289098, -76.6555633544922, -1.337891970507, 218, 25, 'PPL', 'P'),
(92776, 'Boxwood', 32.7836112976074, 0.57218195783726, -94.7547225952148, -1.65378189110037, 218, 51, 'PPL', 'P'),
(100104, 'Boxwood', 36.6388893127441, 0.639469252781148, -79.7144393920898, -1.39127942877343, 218, 53, 'PPL', 'P'),
(100105, 'Boxwood Farms', 38.8758316040039, 0.678511260940737, -77.5666732788086, -1.35379383853392, 218, 53, 'PPL', 'P'),
(85229, 'Boxwood Hills', 35.9005584716797, 0.626582948635554, -84.1347198486328, -1.46842787660167, 218, 50, 'PPL', 'P'),
(100106, 'Boxwood Hills', 37.2444381713867, 0.650038074146154, -80.1055603027344, -1.39810577643758, 218, 53, 'PPL', 'P'),
(44969, 'Boxwood Village', 39.0097198486328, 0.680848051639227, -76.8888931274414, -1.34196434328789, 218, 25, 'PPL', 'P'),
(85230, 'Boy (historical)', 36.350830078125, 0.634441670696269, -84.0322189331055, -1.46663889813941, 218, 50, 'PPL', 'P'),
(134363, 'Boy River', 47.1680603027344, 0.823237954061948, -94.121940612793, -1.64273776205981, 218, 28, 'PPL', 'P'),
(134366, 'Boyack Mobile Home Park', 45.749439239502, 0.7984783456704, -94.9388885498047, -1.65699619337804, 218, 28, 'PPL', 'P'),
(34943, 'Boyce', 36.8319396972656, 0.642838617613289, -86.3794403076172, -1.50760563939782, 218, 21, 'PPL', 'P'),
(39468, 'Boyce', 31.3902797698975, 0.547863735106879, -92.6691665649414, -1.61738207163727, 218, 22, 'PPL', 'P'),
(85231, 'Boyce', 35.0769386291504, 0.612208070598661, -85.2572174072266, -1.48801915484473, 218, 50, 'PPL', 'P'),
(92777, 'Boyce', 32.378059387207, 0.56510374171302, -96.7375030517578, -1.68838793841124, 218, 51, 'PPL', 'P'),
(100107, 'Boyce', 39.0930595397949, 0.682302603647601, -78.0597229003906, -1.36239917780623, 218, 53, 'PPL', 'P'),
(143544, 'Boyce', 43.295280456543, 0.755645194541029, -71.5772171020508, -1.24925810784558, 218, 36, 'PPL', 'P'),
(159411, 'Boyce', 40.3177795410156, 0.703678000083931, -80.1102828979492, -1.39818820127332, 218, 45, 'PPL', 'P'),
(173264, 'Boyceville', 45.0436096191406, 0.786159294836993, -92.0408325195313, -1.60641557374249, 218, 57, 'PPL', 'P'),
(1069, 'Boyd', 32.6194381713867, 0.569316596241417, -88.3041687011719, -1.54119848707197, 218, 2, 'PPL', 'P'),
(7631, 'Boyd', 33.3416709899902, 0.581921936892007, -93.9272232055664, -1.63933930219276, 218, 4, 'PPL', 'P'),
(15295, 'Boyd', 30.1888904571533, 0.526895536001222, -83.6066665649414, -1.45921160817529, 218, 12, 'PPL', 'P'),
(26589, 'Boyd', 38.4136085510254, 0.670443946787641, -89.0133285522461, -1.55357566139617, 218, 18, 'PPL', 'P'),
(29268, 'Boyd', 39.7186088562012, 0.693220498852489, -85.5511093139648, -1.49314853626227, 218, 19, 'PPL', 'P'),
(31877, 'Boyd', 38.5186080932617, 0.672276534512752, -98.8480606079102, -1.72522411681894, 218, 20, 'PPL', 'P'),
(34944, 'Boyd', 38.5505599975586, 0.672834200445015, -84.394172668457, -1.47295618256118, 218, 21, 'PPL', 'P'),
(53609, 'Boyd', 37.5169410705566, 0.6547941469579, -93.394172668457, -1.63003581524067, 218, 29, 'PPL', 'P'),
(79897, 'Boyd', 34.2361106872559, 0.597532854569833, -81.5616683959961, -1.42351965692993, 218, 48, 'PPL', 'P'),
(85233, 'Boyd', 35.8458290100098, 0.62562773933157, -84.1769409179688, -1.46916477327529, 218, 50, 'PPL', 'P'),
(92779, 'Boyd', 33.0786094665527, 0.57733064717271, -97.5650024414063, -1.70283052731885, 218, 51, 'PPL', 'P'),
(114677, 'Boyd', 43.0125007629395, 0.750709757829866, -92.2577819824219, -1.61020205618036, 218, 16, 'PPL', 'P'),
(129897, 'Boyd', 42.7269401550293, 0.745725785007838, -86.0897216796875, -1.50254909543609, 218, 27, 'PPL', 'P'),
(134367, 'Boyd', 44.8486099243164, 0.782755908121926, -95.9027786254883, -1.67381924882601, 218, 28, 'PPL', 'P'),
(159412, 'Boyd', 40.9355583190918, 0.714460273810307, -76.5983276367188, -1.33689301878211, 218, 45, 'PPL', 'P'),
(173266, 'Boyd', 44.9519386291504, 0.784559334233101, -91.0347213745117, -1.58885562162089, 218, 57, 'PPL', 'P'),
(188178, 'Boyd', 32.3224983215332, 0.564134018181095, -106.573059082031, -1.86005077490389, 218, 38, 'PPL', 'P'),
(190959, 'Boyd', 36.7033309936523, 0.640593972288515, -100.827781677246, -1.75977676774996, 218, 42, 'PPL', 'P'),
(193065, 'Boyd', 37.4377784729004, 0.653412498984366, -114.566390991211, -1.9995607349238, 218, 39, 'PPL', 'P'),
(193194, 'Boyd', 45.4894409179688, 0.793940518909987, -121.081108093262, -2.11326399819057, 218, 43, 'PPL', 'P'),
(196063, 'Boyd', 45.4577789306641, 0.793387912983795, -109.065826416016, -1.90355777236808, 218, 31, 'PPL', 'P'),
(7632, 'Boyd (historical)', 34.538890838623, 0.602817365120878, -91.9255599975586, -1.60440368869699, 218, 4, 'PPL', 'P'),
(108323, 'Boyd (historical)', 38.836109161377, 0.677817973529962, -80.3927764892578, -1.40311864455744, 218, 58, 'PPL', 'P'),
(196064, 'Boyd (historical)', 48.2083282470703, 0.841394054793563, -104.664436340332, -1.8267390238828, 218, 31, 'PPL', 'P'),
(92780, 'Boyd Colonia Number 1', 26.1539993286133, 0.456473400848688, -97.8850021362305, -1.7084155755989, 218, 51, 'PPL', 'P'),
(126926, 'Boyd Corner', 43.2963905334473, 0.755664569037959, -70.7141723632813, -1.23419513556204, 218, 26, 'PPL', 'P'),
(63090, 'Boyd Crossroads', 35.5305595397949, 0.620125249045303, -77.1888885498047, -1.34720025114904, 218, 33, 'PPL', 'P'),
(19422, 'Boyd Highlands', 34.9811096191406, 0.610535538855064, -85.1813888549805, -1.48669569694101, 218, 13, 'PPL', 'P'),
(7633, 'Boyd Hill', 33.4447212219238, 0.583720502734192, -93.6708297729492, -1.6348643926131, 218, 4, 'PPL', 'P'),
(79898, 'Boyd Hill', 34.9394416809082, 0.60980829614039, -81.0444412231445, -1.41449233978289, 218, 48, 'PPL', 'P'),
(126925, 'Boyd Lake', 45.1872215270996, 0.788665795475948, -68.8919372558594, -1.20239113319209, 218, 26, 'PPL', 'P'),
(92781, 'Boyd Monger Colonia', 26.2719993591309, 0.458532889898674, -98.3560028076172, -1.71663608809371, 218, 51, 'PPL', 'P'),
(7634, 'Boydell', 33.3655586242676, 0.582338854760659, -91.4911117553711, -1.59682113644131, 218, 4, 'PPL', 'P'),
(114678, 'Boyden', 43.1911087036133, 0.753827054464831, -96.0055618286133, -1.67561315413629, 218, 16, 'PPL', 'P'),
(63092, 'Boyden (historical)', 36.2625007629395, 0.632900033320249, -80.4749984741211, -1.40455368891083, 218, 33, 'PPL', 'P'),
(79899, 'Boyden Arbor', 34.0238914489746, 0.593828930125751, -80.9458312988281, -1.41277127192843, 218, 48, 'PPL', 'P'),
(1070, 'Boyds', 32.8172187805176, 0.57276851906735, -85.4047164916992, -1.49059349951245, 218, 2, 'PPL', 'P'),
(44970, 'Boyds', 39.1836090087891, 0.683882990017481, -77.3130569458008, -1.34936739848609, 218, 25, 'PPL', 'P'),
(71874, 'Boyds', 39.4949989318848, 0.689317769433033, -83.3833312988281, -1.45531367244579, 218, 41, 'PPL', 'P'),
(206876, 'Boyds', 48.7138900756836, 0.850217773275268, -118.13166809082, -2.06178655905794, 218, 56, 'PPL', 'P'),
(13409, 'Boyds Corner', 39.5, 0.68940505453776, -75.6494369506836, -1.32033175206929, 218, 10, 'PPL', 'P'),
(85235, 'Boyds Creek', 35.9233283996582, 0.626980358849221, -83.6591720581055, -1.46012800190638, 218, 50, 'PPL', 'P'),
(63095, 'Boyds Fork', 35.5449981689453, 0.620377250663451, -76.845832824707, -1.34121279922827, 218, 33, 'PPL', 'P'),
(100108, 'Boyds Mill', 38.8347206115723, 0.677793738764042, -78.2319412231445, -1.36540495457055, 218, 53, 'PPL', 'P'),
(159413, 'Boyds Mills', 41.6405601501465, 0.726764876994801, -75.1405563354492, -1.31145010983387, 218, 45, 'PPL', 'P'),
(100109, 'Boyds Store', 36.5550003051758, 0.638005113392849, -79.0599975585938, -1.37985726401614, 218, 53, 'PPL', 'P'),
(191165, 'Boydston', 35.1827812194824, 0.614055372288794, -101.008056640625, -1.76292315941983, 218, 51, 'PPL', 'P'),
(159416, 'Boydstown', 40.9377784729004, 0.714499022804168, -79.8463897705078, -1.39358239732608, 218, 45, 'PPL', 'P'),
(7635, 'Boydsville', 36.334171295166, 0.634150920084259, -90.3836135864258, -1.57749164693341, 218, 4, 'PPL', 'P'),
(34948, 'Boydsville', 36.5019416809082, 0.637079065702802, -88.5233306884766, -1.54502358534565, 218, 21, 'PPL', 'P'),
(53610, 'Boydsville', 38.8158302307129, 0.67746403942109, -92.1102828979492, -1.60762771151264, 218, 29, 'PPL', 'P'),
(154414, 'Boydsville', 40.0647201538086, 0.699261280574089, -80.7663879394531, -1.4096393944865, 218, 41, 'PPL', 'P'),
(100110, 'Boydton', 36.6674995422363, 0.639968595485538, -78.3877792358398, -1.36812484099185, 218, 53, 'PPL', 'P'),
(34946, 'Boydtown', 38.2841682434082, 0.668184787234927, -84.5027770996094, -1.47485168746705, 218, 21, 'PPL', 'P'),
(159414, 'Boydtown', 40.7880592346191, 0.711885929142582, -76.5299987792969, -1.33570045524597, 218, 45, 'PPL', 'P'),
(173269, 'Boydtown', 43.1105613708496, 0.752421238304406, -90.8036117553711, -1.58482199783385, 218, 57, 'PPL', 'P'),
(19424, 'Boydville', 34.5400009155273, 0.602836739617808, -83.3663864135742, -1.45501792840674, 218, 13, 'PPL', 'P'),
(53611, 'Boyer', 37.3161087036133, 0.651288960910165, -92.5513916015625, -1.61532651074989, 218, 29, 'PPL', 'P'),
(58759, 'Boyer', 33.5366706848145, 0.585325323607074, -90.6377792358398, -1.58192767436116, 218, 30, 'PPL', 'P'),
(108325, 'Boyer', 38.4888916015625, 0.671757883890459, -79.8008270263672, -1.39278717742458, 218, 58, 'PPL', 'P'),
(114679, 'Boyer', 42.1819381713867, 0.736213705963374, -95.2350006103516, -1.66216432378944, 218, 16, 'PPL', 'P'),
(154415, 'Boyer', 40.9441719055176, 0.714610609253842, -80.7291717529297, -1.40898984949663, 218, 41, 'PPL', 'P'),
(159415, 'Boyer', 40.314998626709, 0.703629463973064, -80.0302810668945, -1.39679190591379, 218, 45, 'PPL', 'P'),
(189959, 'Boyer', 39.9583282470703, 0.697404391504031, -117.866668701172, -2.0571614471928, 218, 39, 'PPL', 'P'),
(194638, 'Boyer', 48.3230590820313, 0.843396485617194, -116.442779541016, -2.03230989316461, 218, 17, 'PPL', 'P'),
(200443, 'Boyer', 45.0702781677246, 0.786624748816512, -123.725563049316, -2.15941844409441, 218, 43, 'PPL', 'P'),
(44971, 'Boyer Mill Heights', 39.3855590820313, 0.687407683720201, -77.2872161865234, -1.34891639215549, 218, 25, 'PPL', 'P'),
(114680, 'Boyer River', 42.1891708374023, 0.736339939799044, -95.2044372558594, -1.6616308926231, 218, 16, 'PPL', 'P'),
(186440, 'Boyero', 38.9427795410156, 0.679679722869009, -103.278610229492, -1.80255179538854, 218, 7, 'PPL', 'P'),
(159417, 'Boyers', 41.1083297729492, 0.717475704533577, -79.899169921875, -1.39450358474714, 218, 45, 'PPL', 'P'),
(159418, 'Boyers Junction', 40.440559387207, 0.705820912655063, -75.7705612182617, -1.32244576934259, 218, 45, 'PPL', 'P'),
(180217, 'Boyers Landing', 38.9516716003418, 0.679834918581533, -121.83805847168, -2.12647527456818, 218, 6, 'PPL', 'P'),
(13410, 'Boyers Village', 38.5436096191406, 0.672712893457362, -75.1549987792969, -1.31170217803105, 218, 10, 'PPL', 'P'),
(159419, 'Boyertown', 40.333610534668, 0.703954303047027, -75.6377792358398, -1.32012828656201, 218, 45, 'PPL', 'P'),
(196065, 'Boyes', 45.2680587768555, 0.790076671642445, -105.030563354492, -1.83312914576039, 218, 31, 'PPL', 'P'),
(203111, 'Boyes Acres', 40.663330078125, 0.709708994688524, -111.823608398438, -1.95169014801352, 218, 52, 'PPL', 'P'),
(180220, 'Boyes Hot Springs', 38.3138885498047, 0.668703504436247, -122.480827331543, -2.13769370750209, 218, 6, 'PPL', 'P'),
(15296, 'Boyette', 27.8172206878662, 0.485502089757147, -82.2227783203125, -1.43505820182687, 218, 12, 'PPL', 'P'),
(58760, 'Boyette', 33.0219383239746, 0.576341549143855, -89.8330612182617, -1.5678826954043, 218, 30, 'PPL', 'P'),
(1073, 'Boykin', 32.0777816772461, 0.559862907003853, -87.2813873291016, -1.52334758460128, 218, 2, 'PPL', 'P'),
(19425, 'Boykin', 31.1044406890869, 0.542874902015861, -84.6866683959961, -1.47806119605476, 218, 13, 'PPL', 'P'),
(79901, 'Boykin', 34.7324981689453, 0.606196450490997, -79.6444396972656, -1.39005770362336, 218, 48, 'PPL', 'P'),
(100111, 'Boykins', 36.5830612182617, 0.638494868717315, -77.2002792358398, -1.34739905612442, 218, 53, 'PPL', 'P'),
(26596, 'Boyle', 39.2833290100098, 0.685623432368875, -90.5772171020508, -1.5808706657245, 218, 18, 'PPL', 'P'),
(31878, 'Boyle', 39.3402786254883, 0.68661739066672, -95.3525009155273, -1.66421509098686, 218, 20, 'PPL', 'P'),
(58761, 'Boyle', 33.7038917541504, 0.588243881845692, -90.7263870239258, -1.58347417200616, 218, 30, 'PPL', 'P'),
(7636, 'Boyle (historical)', 36.0441703796387, 0.629089449274509, -92.2027816772461, -1.60924211976544, 218, 4, 'PPL', 'P'),
(180218, 'Boyle Heights', 34.0338897705078, 0.594003433756179, -118.204437255859, -2.0630566205818, 218, 6, 'PPL', 'P'),
(108326, 'Boylen (historical)', 39.1847190856934, 0.683902364514411, -80.0374984741211, -1.39691787343335, 218, 58, 'PPL', 'P'),
(53612, 'Boylers Mill', 38.3472213745117, 0.669285271976375, -93.070556640625, -1.62438765004278, 218, 29, 'PPL', 'P'),
(1074, 'Boyles Highlands', 33.5675010681152, 0.585863415305324, -86.7744369506836, -1.51449963135366, 218, 2, 'PPL', 'P'),
(26590, 'Boyleston', 38.3613891601563, 0.669532546483589, -88.442497253418, -1.54361277575819, 218, 18, 'PPL', 'P'),
(122264, 'Boyleston', 40.2863883972168, 0.703130121268674, -86.3947219848633, -1.50787235498099, 218, 19, 'PPL', 'P'),
(1075, 'Boylston', 32.4283294677734, 0.565981120134147, -86.2794418334961, -1.50586033677744, 218, 2, 'PPL', 'P'),
(63094, 'Boylston', 35.3499984741211, 0.616973863948385, -82.6236114501953, -1.4420540596944, 218, 33, 'PPL', 'P'),
(124286, 'Boylston', 42.3916702270508, 0.739874220881688, -71.7041702270508, -1.25147385787253, 218, 23, 'PPL', 'P'),
(173272, 'Boylston', 46.5974998474121, 0.813279795534897, -92.1286087036133, -1.60794755715956, 218, 57, 'PPL', 'P'),
(206877, 'Boylston', 46.913890838623, 0.818801860055176, -120.233329772949, -2.09846747517409, 218, 56, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(124287, 'Boylston Center', 42.3527793884277, 0.739195447698854, -71.7355575561523, -1.25202167010876, 218, 23, 'PPL', 'P'),
(147316, 'Boylston Center', 43.6602783203125, 0.762015609026553, -75.9649963378906, -1.32583930236163, 218, 40, 'PPL', 'P'),
(63096, 'Boylston Creek', 35.315559387207, 0.616372788490354, -82.6608276367188, -1.44270360468427, 218, 33, 'PPL', 'P'),
(173270, 'Boylston Junction', 46.6141700744629, 0.813570745883988, -92.1194381713867, -1.60778750117804, 218, 57, 'PPL', 'P'),
(129900, 'Boyne City', 45.2166709899902, 0.789179785566334, -85.0138931274414, -1.48377234501243, 218, 27, 'PPL', 'P'),
(129901, 'Boyne Falls', 45.1680603027344, 0.788331369022062, -84.9161071777344, -1.48206565822785, 218, 27, 'PPL', 'P'),
(7637, 'Boynton', 35.9813919067383, 0.627993758223024, -90.2483291625977, -1.57513048831095, 218, 4, 'PPL', 'P'),
(19426, 'Boynton', 34.9233283996582, 0.609527066329278, -85.1908264160156, -1.48686041345443, 218, 13, 'PPL', 'P'),
(75194, 'Boynton', 35.648609161377, 0.622185603622642, -95.6558303833008, -1.66950918891783, 218, 42, 'PPL', 'P'),
(77904, 'Boynton', 39.7666702270508, 0.694059328016837, -79.0669403076172, -1.37997843784574, 218, 45, 'PPL', 'P'),
(92782, 'Boynton', 31.235559463501, 0.545163356340566, -94.429443359375, -1.64810469744659, 218, 51, 'PPL', 'P'),
(118875, 'Boynton', 40.3522186279297, 0.704279075541962, -89.4352798461914, -1.56094010075857, 218, 18, 'PPL', 'P'),
(139048, 'Boynton', 40.2838897705078, 0.703086512005824, -93.0841674804688, -1.62462520401201, 218, 29, 'PPL', 'P'),
(139703, 'Boynton', 46.1544418334961, 0.805546974414715, -98.5550003051758, -1.72010924962933, 218, 34, 'PPL', 'P'),
(15297, 'Boynton Beach', 26.5249996185303, 0.462948577433593, -80.0666732788086, -1.39742706983377, 218, 12, 'PPL', 'P'),
(144874, 'Boynton Beach', 40.5472183227539, 0.707682462257028, -74.254997253418, -1.29599418813149, 218, 37, 'PPL', 'P'),
(85236, 'Boynton Valley', 35.5574989318848, 0.620595430135756, -86.1444396972656, -1.50350410500299, 218, 50, 'PPL', 'P'),
(147318, 'Boyntonville', 42.8450012207031, 0.747786339322259, -73.4563903808594, -1.28205586877629, 218, 40, 'PPL', 'P'),
(19427, 'Boys Estate', 31.3163890838623, 0.546574099349008, -81.4727783203125, -1.42196823243691, 218, 13, 'PPL', 'P'),
(191166, 'Boys Ranch', 35.5313911437988, 0.620139763273243, -102.253608703613, -1.78466214392398, 218, 51, 'PPL', 'P'),
(180219, 'Boys Republic', 33.996940612793, 0.593358549298216, -117.723609924316, -2.05466460051279, 218, 6, 'PPL', 'P'),
(141350, 'Boys Town', 41.2611083984375, 0.720142194575019, -96.1316680908203, -1.67781412361919, 218, 35, 'PPL', 'P'),
(53613, 'Boys Town of Missouri', 37.9930610656738, 0.663104008507274, -91.5741729736328, -1.5982708281807, 218, 29, 'PPL', 'P'),
(154416, 'Boys Village', 40.832218170166, 0.712656647962051, -81.9019393920898, -1.42945850616081, 218, 41, 'PPL', 'P'),
(209326, 'Boysen', 43.4416694641113, 0.758200164711823, -108.172500610352, -1.88796629576621, 218, 59, 'PPL', 'P'),
(92783, 'Boz', 32.3080596923828, 0.563882016562946, -96.9288864135742, -1.69172820820847, 218, 51, 'PPL', 'P'),
(92784, 'Bozar', 31.5166702270508, 0.550069664727305, -98.5966720581055, -1.72083655892303, 218, 51, 'PPL', 'P'),
(7638, 'Bozarth (historical)', 36.2980613708496, 0.633520683012292, -94.5194396972656, -1.64967542985752, 218, 4, 'PPL', 'P'),
(53614, 'Boze Mill', 36.6630592346191, 0.639891097497816, -91.1938934326172, -1.591633698112, 218, 29, 'PPL', 'P'),
(196066, 'Bozeman', 45.6797218322754, 0.797261547368343, -111.037780761719, -1.93797486839961, 218, 31, 'PPL', 'P'),
(44982, 'Bozman', 38.7700004577637, 0.676664158987685, -76.2713928222656, -1.33118692983051, 218, 25, 'PPL', 'P'),
(108327, 'Bozoo', 37.4627799987793, 0.653848857928976, -80.8225021362305, -1.41061877197737, 218, 58, 'PPL', 'P'),
(70561, 'Bozuretown', 39.8266716003418, 0.695106549536484, -74.6894378662109, -1.30357660722911, 218, 37, 'PPL', 'P'),
(108328, 'Brabant', 38.1152801513672, 0.6652371339614, -82.317497253418, -1.43671135907353, 218, 58, 'PPL', 'P'),
(39470, 'Brabston (historical)', 31.3444404602051, 0.547063688225905, -91.5861129760742, -1.598479220536, 218, 22, 'PPL', 'P'),
(85237, 'Brace', 35.372501373291, 0.617366613630144, -87.3047180175781, -1.52375478193196, 218, 50, 'PPL', 'P'),
(206878, 'Brace', 46.6277809143066, 0.813808299853223, -120.576110839844, -2.1044501334049, 218, 56, 'PPL', 'P'),
(118877, 'Braceville', 41.2269401550293, 0.719545846227923, -88.2647171020508, -1.54050992677213, 218, 18, 'PPL', 'P'),
(154417, 'Braceville', 41.228328704834, 0.719570080993842, -80.954719543457, -1.41292640106193, 218, 41, 'PPL', 'P'),
(154418, 'Braceville Ridge', 41.2361106872559, 0.719705902209436, -80.9755630493164, -1.41329018886683, 218, 41, 'PPL', 'P'),
(194117, 'Bracewell', 40.4594383239746, 0.706150412260933, -104.816673278809, -1.82939605970237, 218, 7, 'PPL', 'P'),
(100113, 'Bracey', 36.5994415283203, 0.638780759060335, -78.1433334350586, -1.36385845692554, 218, 53, 'PPL', 'P'),
(92785, 'Brachfield', 32.0458297729492, 0.559305241071591, -94.6483306884766, -1.65192500203031, 218, 51, 'PPL', 'P'),
(203112, 'Brachipad Summer Home Area', 41.814998626709, 0.729809402752979, -111.616668701172, -1.94807836894315, 218, 52, 'PPL', 'P'),
(34949, 'Bracht', 38.8188896179199, 0.677517435800946, -84.5886077880859, -1.47634971558022, 218, 21, 'PPL', 'P'),
(53615, 'Bracken', 37.3405609130859, 0.65171573247485, -92.7861099243164, -1.61942311829671, 218, 29, 'PPL', 'P'),
(92786, 'Bracken', 29.6097202301025, 0.516787108609662, -98.3208312988281, -1.71602222946244, 218, 51, 'PPL', 'P'),
(122265, 'Bracken', 40.9866714477539, 0.715352366196457, -85.623893737793, -1.49441886410224, 218, 19, 'PPL', 'P'),
(189960, 'Bracken', 36.1074981689453, 0.630194727705919, -115.190277099609, -2.01044960167281, 218, 39, 'PPL', 'P'),
(180222, 'Bracken Brae', 37.1394386291504, 0.648205486421044, -122.142776489258, -2.13179360726507, 218, 6, 'PPL', 'P'),
(159420, 'Brackenridge', 40.6080589294434, 0.70874433116267, -79.7413864135742, -1.39174974302194, 218, 45, 'PPL', 'P'),
(85238, 'Brackentown', 36.5988883972168, 0.638771105101383, -86.3866729736328, -1.50773187323349, 218, 50, 'PPL', 'P'),
(13411, 'Brackenville', 39.7805595397949, 0.694301742255062, -75.6833267211914, -1.32092324014739, 218, 10, 'PPL', 'P'),
(13412, 'Brackenville Woods', 39.7902793884277, 0.6944713856165, -75.6616668701172, -1.32054520443066, 218, 10, 'PPL', 'P'),
(173271, 'Brackett', 44.7013893127441, 0.78018642372319, -91.350830078125, -1.59437275929315, 218, 57, 'PPL', 'P'),
(191167, 'Brackettville', 29.3102798461914, 0.511560887996977, -100.417503356934, -1.75261606021095, 218, 51, 'PPL', 'P'),
(159437, 'Brackney', 41.9897193908691, 0.732858855359174, -75.9272232055664, -1.32518003683378, 218, 45, 'PPL', 'P'),
(180223, 'Brackney', 37.0688896179199, 0.646974173891046, -122.081108093262, -2.13071729071051, 218, 6, 'PPL', 'P'),
(34951, 'Bracktown', 38.0947189331055, 0.664878273004512, -84.5625, -1.47589404871771, 218, 21, 'PPL', 'P'),
(193393, 'Bracut', 40.8274993896484, 0.712574289705341, -124.082221984863, -2.16564331682636, 218, 6, 'PPL', 'P'),
(100114, 'Bracy Station', 36.5997200012207, 0.638785619329324, -78.1430587768555, -1.36385366323558, 218, 53, 'PPL', 'P'),
(92787, 'Brad', 32.7516708374023, 0.571624491642079, -98.5074996948242, -1.71928020758199, 218, 51, 'PPL', 'P'),
(100115, 'Brad Lee', 38.8302803039551, 0.677716240776321, -77.0947189331055, -1.3455566812823, 218, 53, 'PPL', 'P'),
(44973, 'Brad Vern Park', 38.5136108398438, 0.672189315987052, -76.182502746582, -1.32963550533748, 218, 25, 'PPL', 'P'),
(177775, 'Bradberry', 32.4102783203125, 0.565666068177191, -110.311943054199, -1.92530661056827, 218, 5, 'PPL', 'P'),
(85239, 'Bradburn Hill', 36.1916694641113, 0.631663793942234, -82.8069381713867, -1.44525371458607, 218, 50, 'PPL', 'P'),
(26591, 'Bradbury', 39.3241691589355, 0.686336227434635, -88.2427825927734, -1.54012709736544, 218, 18, 'PPL', 'P'),
(71875, 'Bradbury', 39.0094413757324, 0.680843191370237, -82.0669403076172, -1.43233831540557, 218, 41, 'PPL', 'P'),
(85240, 'Bradbury', 35.8702812194824, 0.626054510896255, -84.3899993896484, -1.47288334510537, 218, 50, 'PPL', 'P'),
(126927, 'Bradbury', 47.1944389343262, 0.823698348035396, -68.8444366455078, -1.20156209114475, 218, 26, 'PPL', 'P'),
(180224, 'Bradbury', 34.1469383239746, 0.595976503228791, -117.970001220703, -2.058964939883, 218, 6, 'PPL', 'P'),
(44975, 'Bradbury Heights', 38.8636093139648, 0.678297941737421, -76.9313888549805, -1.34270603365148, 218, 25, 'PPL', 'P'),
(44976, 'Bradbury Park', 38.857780456543, 0.67819620898378, -76.9244384765625, -1.34258472666383, 218, 25, 'PPL', 'P'),
(126928, 'Bradburys', 47.2377815246582, 0.824454818943033, -68.5783309936523, -1.19691767136171, 218, 26, 'PPL', 'P'),
(604, 'Braddock', 39.4208297729492, 0.688023273406173, -77.4772186279297, -1.35223256034486, 218, 25, 'PPL', 'P'),
(70562, 'Braddock', 39.7008285522461, 0.692910174006468, -74.8899993896484, -1.30707706616591, 218, 37, 'PPL', 'P'),
(100116, 'Braddock', 38.8208312988281, 0.677551324525817, -77.0683288574219, -1.34509608757177, 218, 53, 'PPL', 'P'),
(159423, 'Braddock', 40.1452789306641, 0.700667296471596, -80.2300033569336, -1.40027771746459, 218, 45, 'PPL', 'P'),
(198039, 'Braddock', 46.5644416809082, 0.812702821684731, -100.090560913086, -1.74690983810129, 218, 34, 'PPL', 'P'),
(44979, 'Braddock Estates', 39.4144401550293, 0.687911753535525, -77.5069427490234, -1.3527513441252, 218, 25, 'PPL', 'P'),
(44980, 'Braddock Heights', 39.4186096191406, 0.687984524412312, -77.5038909912109, -1.3526980809034, 218, 25, 'PPL', 'P'),
(100117, 'Braddock Heights', 38.8305587768555, 0.67772110104531, -77.0774993896484, -1.34525614355329, 218, 53, 'PPL', 'P'),
(147319, 'Braddock Heights', 43.3069381713867, 0.755848660048311, -77.6997222900391, -1.35611598184641, 218, 40, 'PPL', 'P'),
(159424, 'Braddock Hills', 40.4172210693359, 0.705413582166335, -79.8652801513672, -1.39391209666903, 218, 45, 'PPL', 'P'),
(100118, 'Braddock Hills Estates', 39.2541694641113, 0.685114502284561, -78.2111129760742, -1.36504143308176, 218, 53, 'PPL', 'P'),
(44981, 'Braddock Manor West', 39.4361114501953, 0.688289988989344, -77.0533294677734, -1.34483429883662, 218, 25, 'PPL', 'P'),
(70563, 'Braddocks Mill', 39.8222198486328, 0.695028851811681, -74.8491668701172, -1.3063644042582, 218, 37, 'PPL', 'P'),
(53616, 'Braddy Ford (historical)', 37.5013885498047, 0.654522704263793, -90.4577789306641, -1.57878607638124, 218, 29, 'PPL', 'P'),
(114684, 'Braddyville', 40.5788917541504, 0.708235267920302, -95.0297164916992, -1.65858144001691, 218, 16, 'PPL', 'P'),
(26592, 'Braden', 37.9963912963867, 0.663162131998065, -88.6161117553711, -1.54664292044648, 218, 18, 'PPL', 'P'),
(75195, 'Braden', 35.2841682434082, 0.615824909675097, -94.501106262207, -1.64935545105254, 218, 42, 'PPL', 'P'),
(85242, 'Braden', 36.4174995422363, 0.635605272355552, -83.8755569458008, -1.46390463064822, 218, 50, 'PPL', 'P'),
(108329, 'Braden', 39.4402809143066, 0.68836275986613, -80.7441711425781, -1.40925163823178, 218, 58, 'PPL', 'P'),
(15298, 'Braden Castle', 27.4961109161377, 0.479897666980157, -82.5305633544922, -1.44043006406166, 218, 12, 'PPL', 'P'),
(77905, 'Braden Plan', 39.9694404602051, 0.697598336210416, -80.0469436645508, -1.39708272310483, 218, 45, 'PPL', 'P'),
(44991, 'Bradenbaugh', 39.6497192382813, 0.692018148199346, -76.5233306884766, -1.33558407510634, 218, 25, 'PPL', 'P'),
(44983, 'Bradenbaugh Manor', 39.651668548584, 0.692052170082272, -76.5369415283203, -1.33582162907557, 218, 25, 'PPL', 'P'),
(15299, 'Bradenton', 27.4986095428467, 0.479941276243007, -82.5749969482422, -1.4412055765711, 218, 12, 'PPL', 'P'),
(15300, 'Bradenton Beach', 27.4666690826416, 0.479383810047826, -82.7041702270508, -1.4434600755919, 218, 12, 'PPL', 'P'),
(159427, 'Bradenville', 40.3213882446289, 0.703740983843711, -79.3402786254883, -1.38474909146445, 218, 45, 'PPL', 'P'),
(144875, 'Bradevelt', 40.3344383239746, 0.70396875069594, -74.2397232055664, -1.29572760570637, 218, 37, 'PPL', 'P'),
(53617, 'Bradfield', 36.9661102294922, 0.645180335159795, -93.5744400024414, -1.63318207375249, 218, 29, 'PPL', 'P'),
(100119, 'Bradfield', 39.163890838623, 0.683538843025615, -77.9577789306641, -1.36061991988195, 218, 53, 'PPL', 'P'),
(29270, 'Bradfield Corner', 39.7322196960449, 0.693458052821724, -87.2988891601563, -1.52365304917831, 218, 19, 'PPL', 'P'),
(1077, 'Bradford', 32.9947204589844, 0.575866507784412, -86.0849990844727, -1.50246667060035, 218, 2, 'PPL', 'P'),
(7639, 'Bradford', 35.4230613708496, 0.618249052057342, -91.4558334350586, -1.59620541359729, 218, 4, 'PPL', 'P'),
(15301, 'Bradford', 30.6550006866455, 0.535030694183087, -85.5516662597656, -1.49315825680025, 218, 12, 'PPL', 'P'),
(29271, 'Bradford', 38.3677787780762, 0.669644066354236, -86.0619430541992, -1.50206426695964, 218, 19, 'PPL', 'P'),
(31879, 'Bradford', 38.8216705322266, 0.677565971911813, -96.0388870239258, -1.67619478851836, 218, 20, 'PPL', 'P'),
(34952, 'Bradford', 38.7849998474121, 0.67692594772284, -84.1455612182617, -1.46861709419712, 218, 21, 'PPL', 'P'),
(79902, 'Bradford', 33.964168548584, 0.592786568875094, -80.3811111450195, -1.4029150458921, 218, 48, 'PPL', 'P'),
(85244, 'Bradford', 36.0763893127441, 0.62965177573868, -88.8099975585938, -1.55002686608559, 218, 50, 'PPL', 'P'),
(92788, 'Bradford', 31.9886093139648, 0.558306555662811, -95.7663879394531, -1.67143878228565, 218, 51, 'PPL', 'P'),
(114686, 'Bradford', 42.6330604553223, 0.744087275147166, -93.2447204589844, -1.627427382111, 218, 16, 'PPL', 'P'),
(118879, 'Bradford', 41.1772193908691, 0.71867805518672, -89.6575012207031, -1.5648185954121, 218, 18, 'PPL', 'P'),
(124289, 'Bradford', 42.7694396972656, 0.746467541950452, -71.0763931274414, -1.24051708051572, 218, 23, 'PPL', 'P'),
(126929, 'Bradford', 45.0666694641113, 0.786561765056731, -68.9383316040039, -1.20320086732153, 218, 26, 'PPL', 'P'),
(134370, 'Bradford', 45.5224990844727, 0.794517492760152, -93.3686065673828, -1.62958960260003, 218, 28, 'PPL', 'P'),
(143545, 'Bradford', 43.2700004577637, 0.75520397532743, -71.960563659668, -1.25594876745219, 218, 36, 'PPL', 'P'),
(147320, 'Bradford', 42.3711090087891, 0.7395153599248, -77.1091690063477, -1.34580888263753, 218, 40, 'PPL', 'P'),
(154420, 'Bradford', 40.1322212219238, 0.700439396461313, -84.4308319091797, -1.47359600701308, 218, 41, 'PPL', 'P'),
(159428, 'Bradford', 41.9558296203613, 0.732267367281068, -78.644172668457, -1.37259975057151, 218, 45, 'PPL', 'P'),
(169286, 'Bradford', 41.3988914489746, 0.722546962460333, -71.7375030517578, -1.25205562541265, 218, 47, 'PPL', 'P'),
(171766, 'Bradford', 43.9925003051758, 0.767813976509928, -72.1294403076172, -1.25889622098863, 218, 55, 'PPL', 'P'),
(186441, 'Bradford', 37.8813896179199, 0.661154974063499, -105.332496643066, -1.83839887576738, 218, 7, 'PPL', 'P'),
(203119, 'Bradford', 41.6300010681152, 0.726580586247367, -112.138893127441, -1.95719290461589, 218, 52, 'PPL', 'P'),
(44984, 'Bradford Barrens', 39.4769401550293, 0.689002584318022, -76.2941665649414, -1.3315844066232, 218, 25, 'PPL', 'P'),
(126930, 'Bradford Center', 45.0722198486328, 0.786658637541383, -68.8966674804688, -1.20247369118589, 218, 26, 'PPL', 'P'),
(143546, 'Bradford Center', 43.2372207641602, 0.754631861746253, -71.9719390869141, -1.25614730611145, 218, 36, 'PPL', 'P'),
(171763, 'Bradford Center', 44.0130615234375, 0.768172837466816, -72.1711120605469, -1.25962353028233, 218, 55, 'PPL', 'P'),
(63098, 'Bradford Crossroads', 35.7833290100098, 0.624536908549073, -81.004997253418, -1.41380391264111, 218, 33, 'PPL', 'P'),
(44985, 'Bradford Estates', 39.3647193908691, 0.687043962494323, -77.2294387817383, -1.34790798620873, 218, 25, 'PPL', 'P'),
(159430, 'Bradford Hills', 40.003059387207, 0.698185097177588, -75.6483306884766, -1.32031244415138, 218, 45, 'PPL', 'P'),
(147323, 'Bradford Junction', 42.0969390869141, 0.734730192078146, -78.6263885498047, -1.37228935914646, 218, 40, 'PPL', 'P'),
(203114, 'Bradford Ranchos', 40.624439239502, 0.70903022150569, -111.80583190918, -1.95137988974652, 218, 52, 'PPL', 'P'),
(159431, 'Bradford Woods', 40.6375007629395, 0.709258188095001, -80.0819396972656, -1.39769351910084, 218, 45, 'PPL', 'P'),
(34953, 'Bradfordsville', 37.4941711425781, 0.654396736744233, -85.1488876342773, -1.48612844362882, 218, 21, 'PPL', 'P'),
(26593, 'Bradfordton', 39.8233299255371, 0.695048226308611, -89.7394409179688, -1.56624871291748, 218, 18, 'PPL', 'P'),
(15302, 'Bradfordville', 30.5611095428467, 0.533391984585334, -84.2177810668945, -1.46987756834105, 218, 12, 'PPL', 'P'),
(114688, 'Bradgate', 42.8030586242676, 0.747054302917624, -94.4177780151367, -1.64790109878125, 218, 16, 'PPL', 'P'),
(58762, 'Bradie', 32.2816696166992, 0.563421422852417, -90.253059387207, -1.57521304630474, 218, 30, 'PPL', 'P'),
(1079, 'Bradley', 31.0333309173584, 0.541633802368856, -86.7255630493164, -1.5136466208565, 218, 2, 'PPL', 'P'),
(7640, 'Bradley', 33.0980606079102, 0.577670133632668, -93.6547164916992, -1.63458316280198, 218, 4, 'PPL', 'P'),
(19429, 'Bradley', 33.8772201538086, 0.59126903310694, -83.6355590820313, -1.45971587772769, 218, 13, 'PPL', 'P'),
(34954, 'Bradley', 37.7102813720703, 0.658168571796112, -83.0066680908203, -1.44873965929493, 218, 21, 'PPL', 'P'),
(58763, 'Bradley', 33.374439239502, 0.582493850736101, -88.9800033569336, -1.5529940270141, 218, 30, 'PPL', 'P'),
(75197, 'Bradley', 34.878059387207, 0.608736973012879, -97.7080612182617, -1.70532737399885, 218, 42, 'PPL', 'P'),
(79903, 'Bradley', 34.0491714477539, 0.59427014933935, -82.2447204589844, -1.43544116439162, 218, 48, 'PPL', 'P'),
(108331, 'Bradley', 38.1583290100098, 0.665988478283939, -81.7174987792969, -1.42623941019318, 218, 58, 'PPL', 'P'),
(118881, 'Bradley', 41.1419410705566, 0.718062332342694, -87.8611068725586, -1.53346559937277, 218, 18, 'PPL', 'P'),
(126932, 'Bradley', 44.9208297729492, 0.784016382265861, -68.6286087036133, -1.19779518294089, 218, 26, 'PPL', 'P'),
(129903, 'Bradley', 42.6302795410156, 0.7440387390363, -85.6430587768555, -1.49475335713516, 218, 27, 'PPL', 'P'),
(147322, 'Bradley', 41.8238906860352, 0.729964598465503, -74.6766662597656, -1.30335370064587, 218, 40, 'PPL', 'P'),
(154421, 'Bradley', 40.246940612793, 0.702441627547862, -80.7758331298828, -1.40980424415797, 218, 41, 'PPL', 'P'),
(169878, 'Bradley', 45.0905609130859, 0.78697874950441, -97.6433334350586, -1.70419766106444, 218, 49, 'PPL', 'P'),
(173275, 'Bradley', 44.8011093139648, 0.781926866074585, -90.0147171020508, -1.57105318868203, 218, 57, 'PPL', 'P'),
(180225, 'Bradley', 35.8633308410645, 0.625933203908602, -120.79972076416, -2.10835286282436, 218, 6, 'PPL', 'P'),
(194639, 'Bradley', 47.5463905334473, 0.829841062247718, -116.159721374512, -2.02736959618446, 218, 17, 'PPL', 'P'),
(199199, 'Bradley', 41.7702789306641, 0.729028896816504, -103.38166809082, -1.80435049438877, 218, 35, 'PPL', 'P'),
(26594, 'Bradley (historical)', 37.9411087036133, 0.662197268735129, -89.5669403076172, -1.56323800930514, 218, 18, 'PPL', 'P'),
(196067, 'Bradley (historical)', 46.5702781677246, 0.812804687596426, -112.668891906738, -1.96644312834618, 218, 31, 'PPL', 'P'),
(100120, 'Bradley Acres', 37.5175018310547, 0.654803934074906, -77.2316665649414, -1.34794686836065, 218, 53, 'PPL', 'P'),
(144876, 'Bradley Beach', 40.202220916748, 0.701661121611387, -74.0124969482422, -1.29176175936908, 218, 37, 'PPL', 'P'),
(58764, 'Bradley Chapel', 32.5125007629395, 0.567450186370462, -90.6930618286133, -1.58289253762409, 218, 30, 'PPL', 'P'),
(79904, 'Bradley Corner', 34.0161094665527, 0.593693108910157, -82.3611068725586, -1.43747249051308, 218, 48, 'PPL', 'P'),
(200444, 'Bradley Corner', 45.4533309936523, 0.793310281838019, -122.773063659668, -2.14279419362181, 218, 43, 'PPL', 'P'),
(44987, 'Bradley Farms', 39.0066719055176, 0.680794854996452, -77.1911087036133, -1.3472390001429, 218, 25, 'PPL', 'P'),
(100121, 'Bradley Forest', 38.6991691589355, 0.67542791960967, -77.4747161865234, -1.35218888450298, 218, 53, 'PPL', 'P'),
(144878, 'Bradley Gardens', 40.5627784729004, 0.707954038109189, -74.6549987792969, -1.30297553177108, 218, 37, 'PPL', 'P'),
(44988, 'Bradley Heights', 38.7102813720703, 0.675621864316055, -75.8027801513672, -1.32300809580676, 218, 25, 'PPL', 'P'),
(44989, 'Bradley Hills', 38.9797210693359, 0.680324474168917, -77.1080627441406, -1.34578957471963, 218, 25, 'PPL', 'P'),
(44990, 'Bradley Hills Grove', 39.003059387207, 0.680731804657645, -77.1350021362305, -1.34625975581008, 218, 25, 'PPL', 'P'),
(15304, 'Bradley Junction', 27.7950000762939, 0.485114266923404, -81.9805603027344, -1.43083069991247, 218, 12, 'PPL', 'P'),
(159436, 'Bradley Junction', 40.5516700744629, 0.707760159981832, -78.6672210693359, -1.37300202105417, 218, 45, 'PPL', 'P'),
(1080, 'Bradley Landing', 32.3300018310547, 0.5642649791277, -85.0074996948242, -1.48366075856276, 218, 2, 'PPL', 'P'),
(144879, 'Bradley Park', 40.2050018310547, 0.701709657722253, -74.0247192382813, -1.2919750785724, 218, 37, 'PPL', 'P'),
(118882, 'Bradley Subdivision', 41.3338890075684, 0.721412455835959, -88.4574966430664, -1.54387456449334, 218, 18, 'PPL', 'P'),
(44992, 'Bradley Woods', 38.9922218322754, 0.680542653641222, -77.1211090087891, -1.34601727499283, 218, 25, 'PPL', 'P'),
(19430, 'Bradleys (historical)', 32.024169921875, 0.558927205354854, -82.0130615234375, -1.43139795322466, 218, 13, 'PPL', 'P'),
(126934, 'Bradleys Corner', 43.6591682434082, 0.761996234529622, -70.2975006103516, -1.22692284157336, 218, 26, 'PPL', 'P'),
(45022, 'Bradleysburg (historical)', 38.9666709899902, 0.680096707316688, -75.9305572509766, -1.3252382269036, 218, 25, 'PPL', 'P'),
(1081, 'Bradleyton', 31.9016704559326, 0.556789186342225, -86.2422180175781, -1.50521065862952, 218, 2, 'PPL', 'P'),
(1082, 'Bradleytown', 33.7000007629395, 0.588175971237895, -87.2491683959961, -1.52278525813711, 218, 2, 'PPL', 'P'),
(85246, 'Bradleytown', 36.0019416809082, 0.62835241944283, -89.6488876342773, -1.56466825996857, 218, 50, 'PPL', 'P'),
(159438, 'Bradleytown', 41.5558280944824, 0.72528602364148, -79.8616714477539, -1.39384911290925, 218, 45, 'PPL', 'P'),
(53618, 'Bradleyville', 36.7836112976074, 0.641995127917033, -92.9080581665039, -1.6215515166399, 218, 29, 'PPL', 'P'),
(79905, 'Bradleyville', 33.5122184753418, 0.584898552042389, -81.9391708374023, -1.43010831746679, 218, 48, 'PPL', 'P'),
(129904, 'Bradleyville', 43.5833282470703, 0.760672576888826, -83.6236114501953, -1.45950735221434, 218, 27, 'PPL', 'P'),
(177519, 'Bradleyville', 41.5233306884766, 0.72471883690832, -73.0824966430664, -1.27553019199921, 218, 8, 'PPL', 'P'),
(196068, 'Bradman', 46.6980590820313, 0.815034885272286, -113.223892211914, -1.97612971102107, 218, 31, 'PPL', 'P'),
(44993, 'Bradmoor', 38.9944381713867, 0.680581336056055, -77.1194381713867, -1.34598811337889, 218, 25, 'PPL', 'P'),
(154422, 'Bradner', 41.3241691589355, 0.721242812474521, -83.438606262207, -1.45627840255067, 218, 41, 'PPL', 'P'),
(71876, 'Bradrick', 38.4455604553223, 0.671001612719904, -82.4047164916992, -1.43823362195262, 218, 41, 'PPL', 'P'),
(34956, 'Bradshaw', 36.7799987792969, 0.641932077578226, -87.1502838134766, -1.52105939659269, 218, 21, 'PPL', 'P'),
(44994, 'Bradshaw', 39.4230613708496, 0.688062222137115, -76.3813934326172, -1.33310680266034, 218, 25, 'PPL', 'P'),
(85247, 'Bradshaw', 35.1936111450195, 0.614244390147162, -86.8708267211914, -1.51618195021426, 218, 50, 'PPL', 'P'),
(92789, 'Bradshaw', 32.098331451416, 0.56022156822366, -99.8974990844727, -1.74354027353207, 218, 51, 'PPL', 'P'),
(100122, 'Bradshaw', 37.2997207641602, 0.65100293740909, -80.2244415283203, -1.40018064524286, 218, 53, 'PPL', 'P'),
(108333, 'Bradshaw', 37.3516693115234, 0.651909610602208, -81.7988891601563, -1.42765994031863, 218, 58, 'PPL', 'P'),
(141353, 'Bradshaw', 40.8838882446289, 0.713558460886179, -97.7466735839844, -1.70600128691269, 218, 35, 'PPL', 'P'),
(44995, 'Bradshaw (historical)', 39.327220916748, 0.686389490656436, -79.2761077880859, -1.38362909906802, 218, 25, 'PPL', 'P'),
(177776, 'Bradshaw City', 34.1966705322266, 0.596844494007075, -112.355003356934, -1.96096473966777, 218, 5, 'PPL', 'P'),
(124290, 'Bradstreet', 42.4105606079102, 0.74020392022464, -72.5922164916992, -1.26697318910068, 218, 23, 'PPL', 'P'),
(147324, 'Bradtville', 43.0724983215332, 0.751756912770486, -74.5072174072266, -1.30039626025534, 218, 40, 'PPL', 'P'),
(200445, 'Bradwood', 46.1969413757324, 0.80628873135733, -123.437782287598, -2.15439572227852, 218, 43, 'PPL', 'P'),
(34957, 'Brady', 38.1711082458496, 0.666211518025233, -83.4400024414063, -1.45630277047465, 218, 21, 'PPL', 'P'),
(44996, 'Brady', 39.5922203063965, 0.691014602521577, -78.8219375610352, -1.37570233324145, 218, 25, 'PPL', 'P'),
(75199, 'Brady', 34.6227798461914, 0.604281504509176, -97.2822189331055, -1.69789502402866, 218, 42, 'PPL', 'P'),
(92791, 'Brady', 31.6650009155273, 0.552658523622971, -94.20361328125, -1.64416321903327, 218, 51, 'PPL', 'P'),
(154423, 'Brady', 40.0858306884766, 0.699629728910901, -81.4858322143555, -1.42219606586816, 218, 41, 'PPL', 'P'),
(196069, 'Brady', 48.0355606079102, 0.838378690649321, -111.839172363281, -1.95196179044471, 218, 31, 'PPL', 'P'),
(199196, 'Brady', 41.0222206115723, 0.715972816151418, -100.367218017578, -1.75173841547371, 218, 35, 'PPL', 'P'),
(206879, 'Brady', 46.9961090087891, 0.820236837829538, -123.510559082031, -2.15566591696043, 218, 56, 'PPL', 'P'),
(129905, 'Brady Center', 43.1725006103516, 0.753502281969896, -84.2272186279297, -1.47004228485447, 218, 27, 'PPL', 'P'),
(108334, 'Brady Gate', 38.5475006103516, 0.672780804065159, -80.0774993896484, -1.39761602111311, 218, 58, 'PPL', 'P'),
(79906, 'Brady Heights', 33.8916702270508, 0.59152123446217, -80.3338928222656, -1.40209093069278, 218, 48, 'PPL', 'P'),
(154425, 'Brady Lake', 41.1594390869141, 0.718367730340699, -81.3172225952148, -1.41925327286363, 218, 41, 'PPL', 'P'),
(144880, 'Brady Park', 40.9605598449707, 0.714896632754917, -74.6188888549805, -1.30234529469911, 218, 37, 'PPL', 'P'),
(180226, 'Bradys', 35.702220916748, 0.623121305271642, -117.867782592773, -2.05718088826876, 218, 6, 'PPL', 'P'),
(159444, 'Bradys Bend', 40.9963912963867, 0.715522009557895, -79.6297225952148, -1.38980084173622, 218, 45, 'PPL', 'P'),
(71879, 'Bradysville', 38.6952781677246, 0.675360009001873, -83.6705627441406, -1.46032680688176, 218, 41, 'PPL', 'P'),
(85248, 'Bradyville', 35.7397193908691, 0.623775777109529, -86.1655578613281, -1.50387268649786, 218, 50, 'PPL', 'P'),
(108335, 'Bradyville', 38.1463890075684, 0.66578008592864, -82.1838912963867, -1.43437949522306, 218, 58, 'PPL', 'P'),
(53619, 'Bradyville (historical)', 36.7211112976074, 0.640904297134537, -90.0952835083008, -1.5724593377376, 218, 29, 'PPL', 'P'),
(100123, 'Braebrook Village', 37.2577781677246, 0.650270901004455, -77.4247207641602, -1.35131629977181, 218, 53, 'PPL', 'P'),
(44997, 'Braebrooke', 39.2708282470703, 0.68540525289657, -76.8125, -1.34063103168814, 218, 25, 'PPL', 'P'),
(44998, 'Braeburn', 39.1944389343262, 0.684072007875849, -76.8916702270508, -1.34201281281973, 218, 25, 'PPL', 'P'),
(100124, 'Braeburn', 37.2644386291504, 0.650387147986036, -80.0269393920898, -1.39673358268592, 218, 53, 'PPL', 'P'),
(126935, 'Braeburn', 43.2247200012207, 0.754413682273949, -70.5811080932617, -1.23187272593343, 218, 26, 'PPL', 'P'),
(159447, 'Braeburn', 40.6119384765625, 0.708812042033386, -79.711669921875, -1.39123109239965, 218, 45, 'PPL', 'P'),
(144881, 'Braeburn Heights', 40.2566719055176, 0.702611470646381, -74.7686080932617, -1.3049583883607, 218, 37, 'PPL', 'P'),
(100125, 'Braehead Woods', 38.2802810668945, 0.668116943206157, -77.4800033569336, -1.35228116303475, 218, 53, 'PPL', 'P'),
(108336, 'Braeholm', 37.7750015258789, 0.659298151572469, -81.8216705322266, -1.42805755026937, 218, 58, 'PPL', 'P'),
(19432, 'Braelinn Courts', 33.3833312988281, 0.582649046448626, -84.5641708374023, -1.47592321033164, 218, 13, 'PPL', 'P'),
(19433, 'Braelinn Green', 33.3805618286133, 0.582600710074841, -84.5630569458008, -1.47590376925568, 218, 13, 'PPL', 'P'),
(85249, 'Braemar', 36.2819404602051, 0.633239320043125, -82.1549987792969, -1.43387522567065, 218, 50, 'PPL', 'P'),
(177777, 'Braemar VII', 33.5763893127441, 0.586018544438821, -112.205558776855, -1.95835643969615, 218, 5, 'PPL', 'P'),
(118883, 'Braeside', 42.1525001525879, 0.735699915610071, -87.772216796875, -1.53191417487974, 218, 18, 'PPL', 'P'),
(147325, 'Braeside', 42.5369415283203, 0.742409683397498, -73.6091690063477, -1.28472235881773, 218, 40, 'PPL', 'P'),
(108337, 'Braewick Woods', 39.6627807617188, 0.692246114788657, -79.9563903808594, -1.39550227015592, 218, 58, 'PPL', 'P'),
(45000, 'Brafferton', 38.3333282470703, 0.669042791159123, -75.6180572509766, -1.31978407299111, 218, 25, 'PPL', 'P'),
(71877, 'Braffetsville', 39.9244384765625, 0.696812903425925, -84.7616729736328, -1.47937027288859, 218, 41, 'PPL', 'P'),
(19434, 'Braganza', 31.1180591583252, 0.54311258914315, -82.253059387207, -1.43558670614519, 218, 13, 'PPL', 'P'),
(186442, 'Bragdon', 38.4019393920898, 0.670240281543277, -104.611106872559, -1.82580824908182, 218, 7, 'PPL', 'P'),
(193394, 'Bragdon (historical)', 40.8905601501465, 0.713674907604843, -122.698333740234, -2.14148991047794, 218, 6, 'PPL', 'P'),
(19435, 'Bragg', 33.023609161377, 0.576370710757791, -83.5366668701172, -1.45798988302521, 218, 13, 'PPL', 'P'),
(92792, 'Bragg', 30.4188899993896, 0.530909785291325, -94.5641708374023, -1.65045613553107, 218, 51, 'PPL', 'P'),
(108338, 'Bragg', 37.7822189331055, 0.65942411909203, -80.9905624389648, -1.41355197760199, 218, 58, 'PPL', 'P'),
(171767, 'Bragg', 43.7197189331055, 0.763053043429193, -72.3394393920898, -1.26256139643885, 218, 55, 'PPL', 'P'),
(7646, 'Bragg City', 33.6655616760254, 0.587574895779864, -92.9858322143555, -1.62290892984751, 218, 4, 'PPL', 'P'),
(53620, 'Bragg City', 36.2680587768555, 0.632997038962955, -89.9108276367188, -1.56923997545385, 218, 29, 'PPL', 'P'),
(53621, 'Braggadocio', 36.1752815246582, 0.63137777044116, -89.8294372558594, -1.56781944532841, 218, 29, 'PPL', 'P'),
(214, 'Braggs', 32.0502815246582, 0.559382938796394, -86.7955627441406, -1.51486834600658, 218, 2, 'PPL', 'P'),
(75201, 'Braggs', 35.663330078125, 0.622442532088808, -95.1977767944336, -1.66151464564152, 218, 42, 'PPL', 'P'),
(100126, 'Braggs Corner', 38.4730606079102, 0.671481580927363, -77.9530563354492, -1.36053749504621, 218, 53, 'PPL', 'P'),
(1083, 'Braggsville', 33.5991706848145, 0.58641615438957, -86.5072174072266, -1.50983577049466, 218, 2, 'PPL', 'P'),
(63103, 'Braggtown', 36.0347213745117, 0.628924533024006, -78.892219543457, -1.37692898523954, 218, 33, 'PPL', 'P'),
(1084, 'Braggville', 32.6822204589844, 0.57041235387193, -87.9972229003906, -1.53584127222317, 218, 2, 'PPL', 'P'),
(124291, 'Braggville', 42.1666717529297, 0.735947256696312, -71.4805603027344, -1.24757112845307, 218, 23, 'PPL', 'P'),
(196070, 'Braggville (historical)', 47.3305587768555, 0.826074087464828, -107.183326721191, -1.87070195452561, 218, 31, 'PPL', 'P'),
(124292, 'Braggville Station', 42.1624984741211, 0.735874419240498, -71.4749984741211, -1.24747405623134, 218, 23, 'PPL', 'P'),
(180227, 'Bragur', 34.9352798461914, 0.609735658421658, -120.545562744141, -2.10391696855466, 218, 6, 'PPL', 'P'),
(134373, 'Braham', 45.7227783203125, 0.798013024848936, -93.1705627441406, -1.62613308582122, 218, 28, 'PPL', 'P'),
(134374, 'Braham Mobile Home Park', 45.7297210693359, 0.798134198678534, -93.1805572509766, -1.62630752287262, 218, 28, 'PPL', 'P'),
(203117, 'Brahman Valley Condominium', 40.6527786254883, 0.709524837099145, -111.88500213623, -1.95276167087811, 218, 52, 'PPL', 'P'),
(75202, 'Braidwood', 34.9483299255371, 0.609963425273887, -94.7955627441406, -1.65449468616612, 218, 42, 'PPL', 'P'),
(118884, 'Braidwood', 41.2649993896484, 0.720210105182816, -88.2122192382813, -1.53959366619909, 218, 18, 'PPL', 'P'),
(154427, 'Brailey', 41.5552787780762, 0.725276436261555, -83.9222183227539, -1.46471902530957, 218, 41, 'PPL', 'P'),
(19436, 'Brailsford (historical)', 31.5508308410645, 0.550665879916346, -81.3319396972656, -1.41951013475077, 218, 13, 'PPL', 'P'),
(34958, 'Brainard', 37.663890838623, 0.6573589042457, -82.8963928222656, -1.44681499277513, 218, 21, 'PPL', 'P'),
(114689, 'Brainard', 42.9308280944824, 0.749284300856402, -91.7050018310547, -1.60055422249933, 218, 16, 'PPL', 'P'),
(141356, 'Brainard', 41.1838912963867, 0.718794501905384, -97.0036087036133, -1.69303235819428, 218, 35, 'PPL', 'P'),
(147326, 'Brainard', 42.4958305358887, 0.741692161220804, -73.5124969482422, -1.28303511310911, 218, 40, 'PPL', 'P'),
(193396, 'Brainard', 40.8122215270996, 0.712307640701196, -124.109169006348, -2.16611363107487, 218, 6, 'PPL', 'P'),
(144882, 'Brainards', 40.773609161377, 0.711633727787352, -75.1699981689453, -1.3119639667662, 218, 37, 'PPL', 'P'),
(147327, 'Brainardsville', 44.857780456543, 0.78291596410344, -74.0338897705078, -1.29213513455391, 218, 40, 'PPL', 'P'),
(31880, 'Brainerd', 37.9511108398438, 0.662371838944584, -97.0950012207031, -1.69462745852918, 218, 20, 'PPL', 'P'),
(85250, 'Brainerd', 35.0200004577637, 0.611214312037897, -85.2402801513672, -1.48772354396373, 218, 50, 'PPL', 'P'),
(134376, 'Brainerd', 46.3580589294434, 0.809100763152344, -94.2005615234375, -1.64410995581147, 218, 28, 'PPL', 'P'),
(7647, 'Brainerd (historical)', 35.6811103820801, 0.622752856934829, -90.8633270263672, -1.58586422592646, 218, 4, 'PPL', 'P'),
(159453, 'Brainerd Center', 40.9491691589355, 0.714697827779542, -75.2972183227539, -1.31418437732506, 218, 45, 'PPL', 'P'),
(85251, 'Brainerd Hills', 35.0169410705566, 0.611160915658041, -85.1986083984375, -1.48699623467003, 218, 50, 'PPL', 'P'),
(177520, 'Brainerd Park', 42.0155601501465, 0.733309861689779, -72.57861328125, -1.2667357682895, 218, 8, 'PPL', 'P'),
(124293, 'Braintree', 42.2222213745117, 0.736916780491155, -71, -1.23918376891597, 218, 23, 'PPL', 'P'),
(124294, 'Braintree Highlands', 42.1791687011719, 0.736165369589589, -71.0124969482422, -1.23940188180925, 218, 23, 'PPL', 'P'),
(171768, 'Braintree Hill', 43.9694404602051, 0.767411506290189, -72.6888885498047, -1.2686604348093, 218, 55, 'PPL', 'P'),
(177190, 'Braithewaite (historical)', 40.4222183227539, 0.705500800692036, -80.5997161865234, -1.4067304236278, 218, 58, 'PPL', 'P'),
(39471, 'Braithwaite', 29.8661098480225, 0.521261951610295, -89.9436111450195, -1.56981215561406, 218, 22, 'PPL', 'P'),
(75203, 'Braithwaite', 35.3736114501953, 0.617385988127074, -99.0580596923828, -1.72888929226916, 218, 42, 'PPL', 'P'),
(39472, 'Brake', 30.922779083252, 0.53970430886958, -91.5438919067383, -1.59774232386237, 218, 22, 'PPL', 'P'),
(63104, 'Brake', 35.9230613708496, 0.626975698317313, -77.7380599975586, -1.35678510107029, 218, 33, 'PPL', 'P'),
(108339, 'Brake', 38.8894386291504, 0.678748748330944, -79.0363922119141, -1.3794452729955, 218, 58, 'PPL', 'P'),
(7648, 'Brakebill', 36.4577789306641, 0.636308280304305, -90.9630584716797, -1.58760486801493, 218, 4, 'PPL', 'P'),
(85256, 'Brakebill (historical)', 35.6144409179688, 0.621589255275546, -84.2888870239258, -1.47111860140903, 218, 50, 'PPL', 'P'),
(53623, 'Braley', 39.6808280944824, 0.692561100166586, -94.4263916015625, -1.64805143422479, 218, 29, 'PPL', 'P'),
(124296, 'Braleys', 41.7374992370605, 0.728456783235328, -70.970832824707, -1.23867470567361, 218, 23, 'PPL', 'P'),
(159449, 'Brallier', 40.0691719055176, 0.699338978298892, -78.3322219848633, -1.36715518403895, 218, 45, 'PPL', 'P'),
(79907, 'Bram Landing', 32.1983299255371, 0.561966870844043, -80.7191696166992, -1.40881527928717, 218, 48, 'PPL', 'P'),
(75204, 'Braman', 36.9236106872559, 0.644438578217181, -97.3333282470703, -1.69878704983578, 218, 42, 'PPL', 'P'),
(147328, 'Braman Corners', 42.8086090087891, 0.747151175402275, -74.2191696166992, -1.29536887790754, 218, 40, 'PPL', 'P'),
(124297, 'Bramanville', 42.1805610656738, 0.736189670934536, -71.7708282470703, -1.25263725979473, 218, 23, 'PPL', 'P'),
(147329, 'Bramanville', 42.6861114501953, 0.74501318967916, -74.4016723632813, -1.29855415172933, 218, 40, 'PPL', 'P'),
(29272, 'Bramble', 38.7788887023926, 0.676819288121182, -86.9094390869141, -1.5168558631281, 218, 19, 'PPL', 'P'),
(19437, 'Bramble Oak', 34.079719543457, 0.594803314189584, -84.4233322143555, -1.4734651126455, 218, 13, 'PPL', 'P'),
(100128, 'Brambleton', 36.8480606079102, 0.643119980582456, -76.2713928222656, -1.33118692983051, 218, 53, 'PPL', 'P'),
(100129, 'Brambleton Court', 37.2411117553711, 0.649980017234391, -79.9963912963867, -1.39620041783568, 218, 53, 'PPL', 'P'),
(19438, 'Bramblewood', 33.6755599975586, 0.587749399410291, -84.154167175293, -1.4687672964826, 218, 13, 'PPL', 'P'),
(45002, 'Bramblewood', 38.3880615234375, 0.669998067042135, -75.1805572509766, -1.31214825751364, 218, 25, 'PPL', 'P'),
(159450, 'Bramcote', 40.2433280944824, 0.702378577209054, -75.6922225952148, -1.32107850243895, 218, 45, 'PPL', 'P'),
(169881, 'Bramhall (historical)', 44.5202789306641, 0.777025451246348, -99.3013916015625, -1.73313623525951, 218, 49, 'PPL', 'P'),
(193395, 'Bramlet Place', 40.2608299255371, 0.702684041786086, -123.161392211914, -2.149571805438, 218, 6, 'PPL', 'P'),
(34959, 'Bramlett', 37.1619415283203, 0.648598236102803, -85.4619369506836, -1.49159218492123, 218, 21, 'PPL', 'P'),
(188179, 'Bramlett', 31.3341693878174, 0.546884424195029, -108.843330383301, -1.89967448402458, 218, 38, 'PPL', 'P'),
(129908, 'Brampton', 45.9313888549805, 0.801653965533237, -87.0711135864258, -1.5196776154611, 218, 27, 'PPL', 'P'),
(139704, 'Brampton', 45.9947204589844, 0.802759310543675, -97.7758331298828, -1.70651021699701, 218, 34, 'PPL', 'P'),
(45003, 'Brampton Hills', 39.2416687011719, 0.684896322812256, -76.8111114501953, -1.34060679692222, 218, 25, 'PPL', 'P'),
(108340, 'Bramwell', 37.3250007629395, 0.651444156622689, -81.3119430541992, -1.41916112748991, 218, 58, 'PPL', 'P'),
(194640, 'Bramwell', 43.8383293151855, 0.765123185123539, -116.581939697266, -2.03473869607877, 218, 17, 'PPL', 'P'),
(177778, 'Branaman', 33.0513916015625, 0.576855605813267, -110.911109924316, -1.93576404522068, 218, 5, 'PPL', 'P'),
(159451, 'Branbury Cross', 40.3077812194824, 0.703503496453503, -76.720832824707, -1.33903113766328, 218, 45, 'PPL', 'P'),
(7649, 'Branch', 35.3055610656738, 0.616198284859926, -93.9533309936523, -1.63979496905527, 218, 4, 'PPL', 'P'),
(39473, 'Branch', 30.3486099243164, 0.529683166582748, -92.2675018310547, -1.6103716995418, 218, 22, 'PPL', 'P'),
(53624, 'Branch', 37.910831451416, 0.66166883099583, -93.004997253418, -1.62324342288043, 218, 29, 'PPL', 'P'),
(58765, 'Branch', 32.4302787780762, 0.566015142017073, -89.7113876342773, -1.56575909075107, 218, 30, 'PPL', 'P'),
(92793, 'Branch', 33.1025009155273, 0.577747631620389, -96.5158615112305, -1.68451956376984, 218, 51, 'PPL', 'P'),
(147330, 'Branch', 41.9941711425781, 0.732936553083977, -74.4705581665039, -1.29975643580344, 218, 40, 'PPL', 'P'),
(173277, 'Branch', 44.1458282470703, 0.770490053931294, -87.7611083984375, -1.53172029675238, 218, 57, 'PPL', 'P'),
(159452, 'Branch Dale', 40.6691703796387, 0.709810927179247, -76.3230590820313, -1.33208867617561, 218, 45, 'PPL', 'P'),
(71878, 'Branch Hill', 39.2461090087891, 0.684973820799977, -84.293327331543, -1.47119609939675, 218, 41, 'PPL', 'P'),
(134379, 'Branch Mobile Home Park', 45.5127792358398, 0.794347849398714, -92.9905624389648, -1.62299148784131, 218, 28, 'PPL', 'P'),
(171770, 'Branch School (historical)', 43.9280586242676, 0.76668925700256, -72.8844375610352, -1.27207340890429, 218, 55, 'PPL', 'P'),
(169287, 'Branch Village', 41.9986114501953, 0.733014051071699, -71.5491714477539, -1.24876861883722, 218, 47, 'PPL', 'P'),
(15308, 'Branchborough', 28.2588901519775, 0.493210676111409, -82.0894393920898, -1.4327309985083, 218, 12, 'PPL', 'P'),
(144885, 'Branchburg Park', 40.5722198486328, 0.708118821201638, -74.6852798461914, -1.3035040360894, 218, 37, 'PPL', 'P'),
(100130, 'Branchland', 38.0713882446289, 0.664471075673839, -78.4805603027344, -1.36974417609267, 218, 53, 'PPL', 'P'),
(108341, 'Branchland', 38.2208290100098, 0.667079309066435, -82.2038879394531, -1.43472850248391, 218, 58, 'PPL', 'P'),
(144884, 'Branchport', 40.3088912963867, 0.703522870950434, -73.9983291625977, -1.29151448486187, 218, 37, 'PPL', 'P'),
(147331, 'Branchport', 42.5986099243164, 0.743485999952054, -77.154167175293, -1.346594248843, 218, 40, 'PPL', 'P'),
(15305, 'Branchton', 28.1344394683838, 0.49103860192634, -82.2872161865234, -1.43618285475521, 218, 12, 'PPL', 'P'),
(159454, 'Branchton', 41.0724983215332, 0.716850327730599, -79.9858322143555, -1.39601612708825, 218, 45, 'PPL', 'P'),
(13413, 'Branchview', 38.639720916748, 0.674390352048975, -75.6699981689453, -1.32069061302618, 218, 10, 'PPL', 'P'),
(1085, 'Branchville', 33.6586112976074, 0.587453588792211, -86.432502746582, -1.5085317536669, 218, 2, 'PPL', 'P'),
(7651, 'Branchville', 33.9022216796875, 0.591705392051549, -91.8808288574219, -1.60362298302343, 218, 4, 'PPL', 'P'),
(15306, 'Branchville', 30.6538906097412, 0.535011319686156, -84.482780456543, -1.47450268020619, 218, 12, 'PPL', 'P'),
(19447, 'Branchville', 31.1502799987793, 0.543674948896834, -84.315559387207, -1.47158412196758, 218, 13, 'PPL', 'P'),
(29273, 'Branchville', 38.1636085510254, 0.666080623657655, -86.579719543457, -1.51110117148661, 218, 19, 'PPL', 'P'),
(45004, 'Branchville', 38.9988899230957, 0.680659033780858, -76.9244384765625, -1.34258472666383, 218, 25, 'PPL', 'P'),
(79908, 'Branchville', 33.2511100769043, 0.580341350785045, -80.8158264160156, -1.41050225867968, 218, 48, 'PPL', 'P'),
(85255, 'Branchville', 35.0627784729004, 0.611960929249501, -86.2938919067383, -1.50611253813267, 218, 50, 'PPL', 'P'),
(92796, 'Branchville', 30.8841705322266, 0.539030462534763, -96.7636108398438, -1.68884360527375, 218, 51, 'PPL', 'P'),
(100131, 'Branchville', 36.5702781677246, 0.638271762396994, -77.248893737793, -1.34824753924772, 218, 53, 'PPL', 'P'),
(144886, 'Branchville', 41.1463890075684, 0.71813996348847, -74.7527770996094, -1.3046820853976, 218, 37, 'PPL', 'P'),
(159455, 'Branchville', 41.9599990844727, 0.732340138157854, -80.14111328125, -1.39872629297157, 218, 45, 'PPL', 'P'),
(177521, 'Branchville', 41.2675018310547, 0.720253781024693, -73.4422225952148, -1.28180859426907, 218, 8, 'PPL', 'P'),
(58766, 'Branchville (historical)', 32.9319381713867, 0.574770750153899, -89.8305587768555, -1.56783901956242, 218, 30, 'PPL', 'P'),
(63106, 'Branchwood', 34.7852783203125, 0.607117637912056, -77.413330078125, -1.35111749479644, 218, 33, 'PPL', 'P'),
(100132, 'Brand', 38.1152801513672, 0.6652371339614, -79.0169372558594, -1.37910571995652, 218, 53, 'PPL', 'P'),
(192957, 'Brand', 32.7922210693359, 0.572332226701768, -100.96028137207, -1.76208932368253, 218, 51, 'PPL', 'P'),
(159456, 'Brandamore', 40.0536117553711, 0.699067402446731, -75.8202819824219, -1.3233135603838, 218, 45, 'PPL', 'P'),
(196073, 'Brandenberg', 45.8161087036133, 0.799641947329683, -106.232498168945, -1.85410686566694, 218, 31, 'PPL', 'P'),
(7652, 'Brandenburg', 35.9861106872559, 0.628076116479734, -92.0366668701172, -1.60634286944473, 218, 4, 'PPL', 'P'),
(34960, 'Brandenburg', 37.9988899230957, 0.663205741260915, -86.1694412231445, -1.5039404639476, 218, 21, 'PPL', 'P'),
(45005, 'Brandenburg Estates', 39.4197196960449, 0.688003898909242, -77.5922164916992, -1.35423965170039, 218, 25, 'PPL', 'P'),
(34961, 'Brandenburg Station', 37.9688911437988, 0.662682163790605, -86.1405563354492, -1.50343632755325, 218, 21, 'PPL', 'P'),
(45006, 'Brandermill', 39.1894416809082, 0.683984789350149, -77.2347183227539, -1.34800013158245, 218, 25, 'PPL', 'P'),
(100133, 'Brandermill', 37.4319381713867, 0.653310566493644, -77.6500015258789, -1.35524819080521, 218, 53, 'PPL', 'P'),
(100134, 'Branderwood', 37.2013893127441, 0.649286729823616, -79.9888916015625, -1.39606952346811, 218, 53, 'PPL', 'P'),
(19439, 'Brandington Forest', 33.7838897705078, 0.589640110626193, -84.0441665649414, -1.46684742365276, 218, 13, 'PPL', 'P'),
(7653, 'Brandon', 33.7191696166992, 0.588510530849836, -91.9199981689453, -1.60430661647525, 218, 4, 'PPL', 'P'),
(13414, 'Brandon', 39.8258285522461, 0.695091835571461, -75.5244369506836, -1.3181500905043, 218, 10, 'PPL', 'P'),
(15307, 'Brandon', 27.9375, 0.487601359775916, -82.2861099243164, -1.4361635468373, 218, 12, 'PPL', 'P'),
(39474, 'Brandon', 30.9041690826416, 0.539379503085132, -91.5188903808594, -1.59730596491776, 218, 22, 'PPL', 'P'),
(53629, 'Brandon', 38.5080604553223, 0.6720924435024, -93.4227828979492, -1.63053515794506, 218, 29, 'PPL', 'P'),
(58767, 'Brandon', 32.2730598449707, 0.56327115398791, -89.9858322143555, -1.57054905228768, 218, 30, 'PPL', 'P'),
(63109, 'Brandon', 36.5355606079102, 0.637665826669973, -81.5111083984375, -1.42263721850274, 218, 33, 'PPL', 'P'),
(79909, 'Brandon', 34.8458290100098, 0.608174446811627, -82.4341735839844, -1.43874774520106, 218, 48, 'PPL', 'P'),
(92794, 'Brandon', 32.0455589294434, 0.559300513960656, -96.9602813720703, -1.69227615360275, 218, 51, 'PPL', 'P'),
(100135, 'Brandon', 37.2558288574219, 0.650236879121529, -76.998893737793, -1.34388421611773, 218, 53, 'PPL', 'P'),
(114691, 'Brandon', 42.3144416809082, 0.738526328474972, -92.0019378662109, -1.60573673398063, 218, 16, 'PPL', 'P'),
(134392, 'Brandon', 45.9652786254883, 0.802245453611344, -95.5983276367188, -1.66850557666103, 218, 28, 'PPL', 'P'),
(154428, 'Brandon', 40.3122215270996, 0.703580994441225, -82.5091705322266, -1.44005668887684, 218, 41, 'PPL', 'P'),
(159457, 'Brandon', 41.3161087036133, 0.721102130989938, -79.850830078125, -1.3936598953138, 218, 45, 'PPL', 'P'),
(169883, 'Brandon', 43.5947189331055, 0.7608713818642, -96.5716705322266, -1.68549361493854, 218, 49, 'PPL', 'P'),
(171771, 'Brandon', 43.7980613708496, 0.764420376911867, -73.0880584716797, -1.27562726422095, 218, 55, 'PPL', 'P'),
(173278, 'Brandon', 43.735279083252, 0.763324619281354, -88.7811126708984, -1.54952272969123, 218, 57, 'PPL', 'P'),
(186443, 'Brandon', 38.4463882446289, 0.671016060368818, -102.439170837402, -1.78790081412563, 218, 7, 'PPL', 'P'),
(196072, 'Brandon', 45.4683303833008, 0.793572070573174, -112.138893127441, -1.95719290461589, 218, 31, 'PPL', 'P'),
(199198, 'Brandon', 40.8033294677734, 0.712152444988672, -101.91194152832, -1.77869892676913, 218, 35, 'PPL', 'P'),
(147332, 'Brandon Center', 44.7738914489746, 0.781451824715142, -74.4124984741211, -1.29874310300867, 218, 40, 'PPL', 'P'),
(180228, 'Brandon Corner', 38.5858306884766, 0.673449790130986, -120.933326721191, -2.11068472667483, 218, 6, 'PPL', 'P'),
(129913, 'Brandon Gardens', 42.8255615234375, 0.747447052599383, -83.4436111450195, -1.45636575423443, 218, 27, 'PPL', 'P'),
(92795, 'Brandon Lake Colonia', 26.3088893890381, 0.459176742381714, -98.2505569458008, -1.71479571062241, 218, 51, 'PPL', 'P'),
(45007, 'Brandon Manor', 39.3997192382813, 0.68765482506936, -77.1988906860352, -1.3473748213585, 218, 25, 'PPL', 'P'),
(39476, 'Brandon Place', 30.5227794647217, 0.532722998519506, -91.0250015258789, -1.58868597825945, 218, 22, 'PPL', 'P'),
(45008, 'Brandon Shores', 39.1922187805176, 0.684033258881989, -76.5355606079102, -1.33579752746771, 218, 25, 'PPL', 'P'),
(100137, 'Brandon Village', 38.875560760498, 0.678506533829802, -77.1161117553711, -1.34593005646713, 218, 53, 'PPL', 'P'),
(79912, 'Brandon Woods', 34.1372184753418, 0.595806859867353, -79.728889465332, -1.39153163012867, 218, 48, 'PPL', 'P'),
(1086, 'Brandontown', 34.749439239502, 0.606492127951023, -86.6344375610352, -1.51205618105351, 218, 2, 'PPL', 'P'),
(108342, 'Brandonville', 39.665828704834, 0.692299311431431, -79.6208267211914, -1.38964557944467, 218, 58, 'PPL', 'P'),
(159458, 'Brandonville', 40.8608283996582, 0.713155990666441, -76.166389465332, -1.32935427552637, 218, 45, 'PPL', 'P'),
(147334, 'Brandreth', 43.9375, 0.766854040095009, -74.8530578613281, -1.306432314866, 218, 40, 'PPL', 'P'),
(53625, 'Brandsville', 36.6502799987793, 0.639668057756522, -91.6900024414063, -1.60029243376418, 218, 29, 'PPL', 'P'),
(71880, 'Brandt', 39.9019393920898, 0.696420220323192, -84.0919418334961, -1.46768125939006, 218, 41, 'PPL', 'P'),
(159459, 'Brandt', 41.9594383239746, 0.732330351040848, -75.545280456543, -1.3185138783092, 218, 45, 'PPL', 'P'),
(169886, 'Brandt', 44.6636085510254, 0.779527025037287, -96.623893737793, -1.68640508182162, 218, 49, 'PPL', 'P'),
(206880, 'Brandts Landing', 48.0461082458496, 0.838562781659673, -119.540000915527, -2.08636660381299, 218, 56, 'PPL', 'P'),
(159460, 'Brandtsville', 40.1430587768555, 0.700628547477736, -77.0622177124023, -1.34498942797011, 218, 45, 'PPL', 'P'),
(147335, 'Brandy Brook', 44.246940612793, 0.772254797627635, -74.7761077880859, -1.30508928272827, 218, 40, 'PPL', 'P'),
(159461, 'Brandy Camp', 41.3208312988281, 0.721184555825676, -78.6877822875977, -1.37336088201105, 218, 45, 'PPL', 'P'),
(19441, 'Brandy Chase', 33.6175003051758, 0.586736066615516, -84.4599990844727, -1.47410507025544, 218, 13, 'PPL', 'P'),
(180229, 'Brandy City', 39.5377807617188, 0.690064453223664, -121.024169921875, -2.11227023962981, 218, 6, 'PPL', 'P'),
(100142, 'Brandy Creek Estates', 37.6063919067383, 0.656355358567931, -77.3344421386719, -1.34974064051287, 218, 53, 'PPL', 'P'),
(45009, 'Brandy Farms', 39.0424995422363, 0.681420165220403, -76.6630630493164, -1.33802286487458, 218, 25, 'PPL', 'P'),
(19442, 'Brandy Shoals', 33.5769386291504, 0.586028131818746, -83.9972229003906, -1.4660281021434, 218, 13, 'PPL', 'P'),
(45010, 'Brandy Springs', 39.5944404602051, 0.691053351515437, -76.6861114501953, -1.33842513535723, 218, 25, 'PPL', 'P'),
(100139, 'Brandy Station', 38.5016708374023, 0.671980923631753, -77.8938903808594, -1.35950485433354, 218, 53, 'PPL', 'P'),
(13415, 'Brandywine', 39.8294410705566, 0.695154885910269, -75.5347213745117, -1.31832958756177, 218, 10, 'PPL', 'P'),
(39477, 'Brandywine', 29.7719402313232, 0.519618381743553, -90.779167175293, -1.58439535942722, 218, 22, 'PPL', 'P'),
(45011, 'Brandywine', 38.6966705322266, 0.67538431034682, -76.8480606079102, -1.34125168138019, 218, 25, 'PPL', 'P'),
(100141, 'Brandywine', 38.1150016784668, 0.665232273692411, -77.1808319091797, -1.34705963624349, 218, 53, 'PPL', 'P'),
(108343, 'Brandywine', 38.6247215270996, 0.67412856331382, -79.245002746582, -1.38308621367981, 218, 58, 'PPL', 'P'),
(154430, 'Brandywine', 41.2761116027832, 0.720404049889201, -81.538330078125, -1.42311232644121, 218, 41, 'PPL', 'P'),
(159463, 'Brandywine', 40.0111083984375, 0.69832557892509, -76.7705612182617, -1.33989906186254, 218, 45, 'PPL', 'P'),
(177779, 'Brandywine', 33.6380615234375, 0.587094927572404, -112.140281677246, -1.95721713938181, 218, 5, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(45012, 'Brandywine County', 38.7638893127441, 0.676557499386027, -76.7922210693359, -1.34027709757927, 218, 25, 'PPL', 'P'),
(13417, 'Brandywine Estates', 39.788890838623, 0.69444715085058, -75.4833297729492, -1.31743263490663, 218, 10, 'PPL', 'P'),
(85257, 'Brandywine Estates', 36.2144393920898, 0.632061204155902, -85.5305633544922, -1.49278994162149, 218, 50, 'PPL', 'P'),
(45013, 'Brandywine Farms', 39.523609161377, 0.689817112137423, -76.4388885498047, -1.33411028175909, 218, 25, 'PPL', 'P'),
(45014, 'Brandywine Forest', 38.6988906860352, 0.675423059340681, -76.841667175293, -1.34114009493051, 218, 25, 'PPL', 'P'),
(13418, 'Brandywine Forge', 39.8333282470703, 0.695222729939038, -75.522216796875, -1.31811134151043, 218, 10, 'PPL', 'P'),
(45015, 'Brandywine Heights', 38.6894416809082, 0.675258143090178, -76.8552780151367, -1.34137764889975, 218, 25, 'PPL', 'P'),
(13419, 'Brandywine Hills', 39.7680587768555, 0.694083562782757, -75.5250015258789, -1.31815994420033, 218, 10, 'PPL', 'P'),
(159465, 'Brandywine Manor', 40.3388900756836, 0.704046448420743, -76.8372192382813, -1.34106246378474, 218, 45, 'PPL', 'P'),
(13421, 'Brandywine Springs', 39.7444381713867, 0.693671305446013, -75.6444396972656, -1.32024453354359, 218, 10, 'PPL', 'P'),
(13422, 'Brandywine Springs Manor', 39.7486114501953, 0.693744142901826, -75.6374969482422, -1.32012335971399, 218, 10, 'PPL', 'P'),
(77906, 'Brandywine Summit', 39.8722190856934, 0.695901503121872, -75.5480575561523, -1.31856234784104, 218, 45, 'PPL', 'P'),
(159466, 'Brandywine Village', 40.0972213745117, 0.699828533886276, -75.3724975585938, -1.31549824784885, 218, 45, 'PPL', 'P'),
(13423, 'Brandywood', 39.8208312988281, 0.695004617045761, -75.5083312988281, -1.31786899385124, 218, 10, 'PPL', 'P'),
(15309, 'Branford', 29.958890914917, 0.522881286711118, -82.9283294677734, -1.44737239239128, 218, 12, 'PPL', 'P'),
(177545, 'Branford', 41.2794418334961, 0.720462173379992, -72.815559387207, -1.27087125798823, 218, 8, 'PPL', 'P'),
(177547, 'Branford Hills', 41.2713890075684, 0.720321625053463, -72.8461074829102, -1.27140442283846, 218, 8, 'PPL', 'P'),
(79914, 'Branham Heights', 34.2805595397949, 0.598308633395373, -80.7200012207031, -1.40882979351511, 218, 48, 'PPL', 'P'),
(19443, 'Brannan', 33.5155601501465, 0.584956875270261, -84.1708297729492, -1.46905811367363, 218, 13, 'PPL', 'P'),
(159467, 'Branningville', 41.6205596923828, 0.726415803154918, -75.0883331298828, -1.31053864295079, 218, 45, 'PPL', 'P'),
(45016, 'Brannock Cove', 38.5761108398438, 0.673280146769548, -76.288330078125, -1.3314825407115, 218, 25, 'PPL', 'P'),
(7655, 'Brannon', 35.8177795410156, 0.625138183744186, -93.9461135864258, -1.63966900153571, 218, 4, 'PPL', 'P'),
(34962, 'Brannon', 37.9583282470703, 0.662497806464145, -84.5461120605469, -1.47560802521663, 218, 21, 'PPL', 'P'),
(39478, 'Brannon', 29.985279083252, 0.523341847132134, -91.845832824707, -1.60301218702742, 218, 22, 'PPL', 'P'),
(1089, 'Brannon Springs (historical)', 33.878059387207, 0.591283680492935, -86.022216796875, -1.50137091296984, 218, 2, 'PPL', 'P'),
(1087, 'Brannon Stand', 31.2399997711182, 0.545240854328287, -85.480827331543, -1.49192188426418, 218, 2, 'PPL', 'P'),
(1088, 'Brannon Stand Heights', 31.2416706085205, 0.545270015942223, -85.4833297729492, -1.49196556010606, 218, 2, 'PPL', 'P'),
(19444, 'Brannons Branch', 33.7855606079102, 0.589669272240129, -84.6397171020508, -1.47724174138734, 218, 13, 'PPL', 'P'),
(79915, 'Brannons Store (historical)', 35.0800018310547, 0.612261533557544, -82.0244369506836, -1.43159649188393, 218, 48, 'PPL', 'P'),
(15311, 'Brannonville', 30.2244396209717, 0.527515985956183, -85.5927810668945, -1.49387584555597, 218, 12, 'PPL', 'P'),
(92797, 'Branom', 33.1980590820313, 0.579415436253052, -95.8152770996094, -1.67229205909891, 218, 51, 'PPL', 'P'),
(63113, 'Branon', 36.1205596923828, 0.63042269429523, -80.7397232055664, -1.409174007086, 218, 33, 'PPL', 'P'),
(1096, 'Brans Chapel', 34.0872192382813, 0.594934208557161, -86.0897216796875, -1.50254909543609, 218, 2, 'PPL', 'P'),
(180230, 'Branscomb', 39.6536102294922, 0.692086058807143, -123.624443054199, -2.15765356724001, 218, 6, 'PPL', 'P'),
(85258, 'Bransford', 36.5041694641113, 0.637117947854717, -86.2699966430664, -1.50569548710596, 218, 50, 'PPL', 'P'),
(92798, 'Bransford', 32.8997192382813, 0.574208423689729, -97.1680603027344, -1.69590258005911, 218, 51, 'PPL', 'P'),
(53626, 'Branson', 36.6436080932617, 0.639551611037858, -93.2183303833008, -1.62696678840047, 218, 29, 'PPL', 'P'),
(186444, 'Branson', 37.0175018310547, 0.646077287814934, -103.883888244629, -1.81311588964261, 218, 7, 'PPL', 'P'),
(180231, 'Branson (historical)', 33.0780601501465, 0.577321059792786, -116.616386413574, -2.03533990469485, 218, 6, 'PPL', 'P'),
(53627, 'Branson West', 36.6969413757324, 0.640482452417868, -93.3691711425781, -1.62959945629606, 218, 29, 'PPL', 'P'),
(173280, 'Branstad', 45.7374992370605, 0.798269953315101, -92.6827774047852, -1.61761962560651, 218, 57, 'PPL', 'P'),
(154431, 'Branstetter (historical)', 40.8105583190918, 0.712278612245315, -81.9805603027344, -1.43083069991247, 218, 41, 'PPL', 'P'),
(129914, 'Brant', 43.2591705322266, 0.755014957469061, -84.2297210693359, -1.47008596069635, 218, 27, 'PPL', 'P'),
(147336, 'Brant', 42.5883293151855, 0.74330656947361, -79.0180587768555, -1.37912529419053, 218, 40, 'PPL', 'P'),
(173281, 'Brant', 44.0733299255371, 0.76922471951837, -88.20361328125, -1.53944346391361, 218, 57, 'PPL', 'P'),
(180233, 'Brant', 35.2916717529297, 0.615955870621702, -115.369720458984, -2.01358147911474, 218, 6, 'PPL', 'P'),
(70564, 'Brant Beach', 39.6208305358887, 0.691513945225967, -74.1975021362305, -1.29499070903275, 218, 37, 'PPL', 'P'),
(77907, 'Brant Hill', 39.8116683959961, 0.694844694222302, -80.2069396972656, -1.39987518066583, 218, 45, 'PPL', 'P'),
(147337, 'Brant Lake', 43.6763916015625, 0.762296838837665, -73.75, -1.28718032334582, 218, 40, 'PPL', 'P'),
(124298, 'Brant Rock', 42.086109161377, 0.734541174219777, -70.6416702270508, -1.23292973457009, 218, 23, 'PPL', 'P'),
(31882, 'Brantford', 39.7122192382813, 0.693108978981842, -97.3594436645508, -1.69924284985634, 218, 20, 'PPL', 'P'),
(139707, 'Brantford', 47.5977783203125, 0.830737948323829, -98.9225006103516, -1.72652333995674, 218, 34, 'PPL', 'P'),
(147339, 'Brantingham', 43.6886100769043, 0.762510091461953, -75.2925033569336, -1.31410208564737, 218, 40, 'PPL', 'P'),
(1091, 'Brantley', 32.4288902282715, 0.565990907251153, -86.9466705322266, -1.51750567443408, 218, 2, 'PPL', 'P'),
(19445, 'Brantley', 32.3702812194824, 0.564967987076453, -84.5622177124023, -1.47588912186969, 218, 13, 'PPL', 'P'),
(1092, 'Brantley Crossing', 31.4963893890381, 0.54971569732892, -87.1191711425781, -1.52051637804642, 218, 2, 'PPL', 'P'),
(39479, 'Brantley Landing', 32.9977798461914, 0.575919904164268, -92.0733337402344, -1.60698282705468, 218, 22, 'PPL', 'P'),
(63115, 'Brantleys Grove', 36.3211097717285, 0.633922953494949, -76.9491729736328, -1.34301642507653, 218, 33, 'PPL', 'P'),
(1094, 'Brantleyville', 33.2158317565918, 0.579725627941019, -86.875, -1.51625478767007, 218, 2, 'PPL', 'P'),
(45017, 'Brantly', 39.2794418334961, 0.685555588340105, -77.008056640625, -1.34404413894119, 218, 25, 'PPL', 'P'),
(92799, 'Branton', 32.1683311462402, 0.561443293373734, -98.9633331298828, -1.72723600186444, 218, 51, 'PPL', 'P'),
(45018, 'Branton Manor', 39.396110534668, 0.68759184130958, -76.897216796875, -1.34210961872536, 218, 25, 'PPL', 'P'),
(108344, 'Brantville', 37.9038887023926, 0.661547657166232, -80.434440612793, -1.40384582069308, 218, 58, 'PPL', 'P'),
(45019, 'Brantwood', 39.5586090087891, 0.69042797471246, -75.8041687011719, -1.32303233057268, 218, 25, 'PPL', 'P'),
(144888, 'Brantwood', 40.7291717529297, 0.710858148698894, -74.3402786254883, -1.29748262886474, 218, 37, 'PPL', 'P'),
(173283, 'Brantwood', 45.5627784729004, 0.795220500708906, -90.1149978637695, -1.57280341815043, 218, 57, 'PPL', 'P'),
(45020, 'Brantwood Farms', 39.564998626709, 0.690539494583107, -75.8022232055664, -1.32299837526878, 218, 25, 'PPL', 'P'),
(124299, 'Brantwood Manor', 42.163330078125, 0.735888933468439, -70.8622207641602, -1.23677906760969, 218, 23, 'PPL', 'P'),
(53630, 'Branums Point', 36.0008316040039, 0.6283330449459, -90.1094436645508, -1.57270647908676, 218, 29, 'PPL', 'P'),
(58768, 'Branyan', 34.4513893127441, 0.601290175393772, -88.8011093139648, -1.54987173695209, 218, 30, 'PPL', 'P'),
(19449, 'Braselton', 34.1091690063477, 0.595317304279969, -83.7627792358398, -1.46193628828655, 218, 13, 'PPL', 'P'),
(7656, 'Brasfield', 34.8327789306641, 0.607946679959398, -91.3805618286133, -1.59489167623155, 218, 4, 'PPL', 'P'),
(1095, 'Brasfield Landing', 32.6208305358887, 0.569340897586364, -87.8802795410156, -1.53380022556373, 218, 2, 'PPL', 'P'),
(92800, 'Brashear', 33.1186103820801, 0.578028794852475, -95.7333297729492, -1.67086180843548, 218, 51, 'PPL', 'P'),
(139050, 'Brashear', 40.1488914489746, 0.700730346810404, -92.3788909912109, -1.61231580713756, 218, 29, 'PPL', 'P'),
(7658, 'Brashears', 35.8116683959961, 0.625031524142528, -93.7955627441406, -1.63704139364618, 218, 4, 'PPL', 'P'),
(39480, 'Brashears (historical)', 30.4750003814697, 0.531889096203175, -91.0258331298828, -1.58870049248739, 218, 22, 'PPL', 'P'),
(85259, 'Brashears Subdivision', 35.938060760498, 0.627237487052468, -84.4991683959961, -1.47478870370727, 218, 50, 'PPL', 'P'),
(147340, 'Brasher Center', 44.8672218322754, 0.783080747195889, -74.7841720581055, -1.30523003079188, 218, 40, 'PPL', 'P'),
(147341, 'Brasher Falls', 44.8074989318848, 0.782038385945232, -74.774169921875, -1.30505546058243, 218, 40, 'PPL', 'P'),
(147342, 'Brasher Iron Works', 44.8899993896484, 0.78347829056761, -74.6983337402344, -1.30373186952066, 218, 40, 'PPL', 'P'),
(147344, 'Brasie Corners', 44.4083290100098, 0.775071556533584, -75.5938873291016, -1.31936222827444, 218, 40, 'PPL', 'P'),
(144889, 'Brass Castle', 40.764720916748, 0.711478598653855, -75.0113906860352, -1.30919574397112, 218, 37, 'PPL', 'P'),
(45021, 'Brass Eagle Estates', 39.4061088562012, 0.687766344940007, -76.9997177124023, -1.34389859718762, 218, 25, 'PPL', 'P'),
(129916, 'Brassar', 46.5061111450195, 0.811684761779021, -84.2172164916992, -1.46986771464502, 218, 27, 'PPL', 'P'),
(1097, 'Brassell', 32.3994407653809, 0.565476917160768, -86.040283203125, -1.5016862312429, 218, 2, 'PPL', 'P'),
(1098, 'Brassell Bottom', 32.3988914489746, 0.565467329780843, -86.1847229003906, -1.50420717953077, 218, 2, 'PPL', 'P'),
(34963, 'Brassfield', 37.6741714477539, 0.657538334724145, -84.1463928222656, -1.46863160842506, 218, 21, 'PPL', 'P'),
(63116, 'Brassfield', 35.9311103820801, 0.627116180064815, -78.850830078125, -1.37620660279386, 218, 33, 'PPL', 'P'),
(63118, 'Brasstown', 35.0394401550293, 0.611553598760774, -83.9569396972656, -1.46532502761562, 218, 33, 'PPL', 'P'),
(79917, 'Brasstown', 34.7447204589844, 0.606409769694313, -83.2377777099609, -1.45277328308196, 218, 48, 'PPL', 'P'),
(126936, 'Brassua', 45.6266708374023, 0.796335632836349, -69.9127807617188, -1.22020821351694, 218, 26, 'PPL', 'P'),
(7657, 'Brasswell Spring (historical)', 36.3713912963867, 0.634800531653157, -93.4727783203125, -1.63140774267623, 218, 4, 'PPL', 'P'),
(19451, 'Braswell', 33.9891700744629, 0.593222927819704, -84.9630584716797, -1.48288511289527, 218, 13, 'PPL', 'P'),
(53631, 'Braswell', 36.7138900756836, 0.640778263035949, -91.3108291625977, -1.59367461161339, 218, 29, 'PPL', 'P'),
(63119, 'Braswell', 34.3686103820801, 0.599845410502404, -78.8677825927734, -1.37650247999097, 218, 33, 'PPL', 'P'),
(19452, 'Braswell Corners', 34.0086097717285, 0.59356221454258, -84.8763885498047, -1.48137243739611, 218, 13, 'PPL', 'P'),
(63120, 'Braswells Crossroads', 36.0847206115723, 0.629797184334198, -77.3822174072266, -1.35057447625017, 218, 33, 'PPL', 'P'),
(85260, 'Bratchers Crossroads', 35.7694396972656, 0.624294494310849, -85.9116668701172, -1.49944145276008, 218, 50, 'PPL', 'P'),
(154432, 'Bratenahl', 41.5424995422363, 0.725053396520261, -81.6263885498047, -1.42464923670629, 218, 41, 'PPL', 'P'),
(134386, 'Bratsberg', 43.7350006103516, 0.763319759012364, -91.7702789306641, -1.60169352281367, 218, 28, 'PPL', 'P'),
(15310, 'Bratt', 30.9655609130859, 0.540450992660211, -87.4274978637695, -1.52589769450309, 218, 12, 'PPL', 'P'),
(124300, 'Brattle', 42.4216690063477, 0.740397798351998, -71.168327331543, -1.24212163507249, 218, 23, 'PPL', 'P'),
(171775, 'Brattleboro', 42.850830078125, 0.7478880720759, -72.5583267211914, -1.26638170102257, 218, 55, 'PPL', 'P'),
(34964, 'Bratton', 38.5683288574219, 0.673144325553954, -84.0952835083008, -1.46773958261794, 218, 21, 'PPL', 'P'),
(100143, 'Bratton Lawn', 37.2963905334473, 0.650944813918299, -79.8902816772461, -1.39434845561364, 218, 53, 'PPL', 'P'),
(79918, 'Brattonsville', 34.8636093139648, 0.608484771657648, -81.1752777099609, -1.41677586725958, 218, 48, 'PPL', 'P'),
(85261, 'Brattontown', 36.5330581665039, 0.637622150828096, -86.0569381713867, -1.50197691527589, 218, 50, 'PPL', 'P'),
(108345, 'Braucher', 38.5986099243164, 0.673672829872281, -79.8208312988281, -1.39313631784349, 218, 58, 'PPL', 'P'),
(77908, 'Brave', 39.7247200012207, 0.693327158454147, -80.2602767944336, -1.40080608862487, 218, 45, 'PPL', 'P'),
(129917, 'Bravo', 42.5130615234375, 0.741992898686901, -86.0919418334961, -1.50258784442995, 218, 27, 'PPL', 'P'),
(7659, 'Brawley', 34.8544387817383, 0.608324715676134, -94.3125, -1.64606365078715, 218, 4, 'PPL', 'P'),
(53632, 'Brawley', 36.8738899230957, 0.643570787175979, -91.2838897705078, -1.59320443052293, 218, 29, 'PPL', 'P'),
(180232, 'Brawley', 32.9786109924316, 0.575585344552327, -115.529441833496, -2.01636914298578, 218, 6, 'PPL', 'P'),
(100144, 'Brax-Han Court', 37.3325004577637, 0.651575050990266, -79.9986114501953, -1.39623916682954, 218, 53, 'PPL', 'P'),
(34965, 'Braxton', 37.8413887023926, 0.660456826383735, -84.8055572509766, -1.48013619801809, 218, 21, 'PPL', 'P'),
(58769, 'Braxton', 32.0250015258789, 0.558941719582795, -89.9702835083008, -1.5702776761726, 218, 30, 'PPL', 'P'),
(108347, 'Braxton', 38.7894401550293, 0.677003445710561, -80.7294387817383, -1.40899451002853, 218, 58, 'PPL', 'P'),
(100148, 'Braxton Heights', 37.2972183227539, 0.650959261567213, -80.0494384765625, -1.39712626578865, 218, 53, 'PPL', 'P'),
(29276, 'Braxtons Siding', 38.5591697692871, 0.672984469309522, -86.4880599975586, -1.5095014106198, 218, 19, 'PPL', 'P'),
(75205, 'Bray', 34.6377792358398, 0.604543293244331, -97.8172225952148, -1.70723259944269, 218, 42, 'PPL', 'P'),
(85263, 'Bray', 36.4233283996582, 0.635707005109193, -83.3277816772461, -1.45434414865095, 218, 50, 'PPL', 'P'),
(193397, 'Bray', 41.6441688537598, 0.726827860754581, -121.969718933105, -2.12877318311476, 218, 6, 'PPL', 'P'),
(19453, 'Bray (historical)', 30.8591709136963, 0.538594136879667, -83.2583312988281, -1.4531320108808, 218, 13, 'PPL', 'P'),
(85262, 'Bray (historical)', 35.0463905334473, 0.611674905748427, -89.7052764892578, -1.56565243114941, 218, 50, 'PPL', 'P'),
(71882, 'Brayfield', 38.4102783203125, 0.67038582329685, -82.5358276367188, -1.44052194311927, 218, 41, 'PPL', 'P'),
(53633, 'Braymer', 39.5869407653809, 0.69092245714786, -93.7958297729492, -1.63704605417809, 218, 29, 'PPL', 'P'),
(53634, 'Brays', 38.1202812194824, 0.665324419066127, -92.2444381713867, -1.60996916274304, 218, 29, 'PPL', 'P'),
(100145, 'Brays', 37.8955612182617, 0.66140231514974, -76.8736114501953, -1.34169762770472, 218, 53, 'PPL', 'P'),
(100146, 'Brays Fork', 37.9002799987793, 0.661484673406451, -76.8672180175781, -1.34158604125505, 218, 53, 'PPL', 'P'),
(19454, 'Brays Lakeview', 33.1474990844727, 0.578532997825854, -84.9713897705078, -1.48303052149079, 218, 13, 'PPL', 'P'),
(100147, 'Brays Landing', 37.3180618286133, 0.651323049372118, -76.4730606079102, -1.33470669668521, 218, 53, 'PPL', 'P'),
(29278, 'Braysville', 39.211669921875, 0.684372745341946, -86.7744369506836, -1.51449963135366, 218, 19, 'PPL', 'P'),
(85264, 'Brayton', 35.4822196960449, 0.619281559611966, -85.1833267211914, -1.48672951908686, 218, 50, 'PPL', 'P'),
(114692, 'Brayton', 41.5444412231445, 0.725087285245132, -94.9238891601563, -1.65673440464288, 218, 16, 'PPL', 'P'),
(141361, 'Brayton', 41.4633293151855, 0.723671615388673, -98.4772186279297, -1.71875170326367, 218, 35, 'PPL', 'P'),
(147345, 'Brayton', 43.4511108398438, 0.758364947804272, -73.6258316040039, -1.28501317600877, 218, 40, 'PPL', 'P'),
(124301, 'Brayton Hill', 42.6974983215332, 0.745211928075507, -73.144172668457, -1.27660664171182, 218, 23, 'PPL', 'P'),
(147347, 'Brayton Hollow', 44.9416694641113, 0.784380103491738, -74.1272201538086, -1.29376405703466, 218, 40, 'PPL', 'P'),
(124302, 'Brayton Point', 41.7138900756836, 0.728044725635665, -71.1833267211914, -1.24238342380765, 218, 23, 'PPL', 'P'),
(124303, 'Braytonville', 42.6983299255371, 0.745226442303448, -73.1305618286133, -1.27636908774259, 218, 23, 'PPL', 'P'),
(29279, 'Braytown', 38.7305603027344, 0.675975798424927, -85.1586074829102, -1.48629808699026, 218, 19, 'PPL', 'P'),
(85265, 'Braytown', 36.1580581665039, 0.631077166133117, -84.3733291625977, -1.47259239475628, 218, 50, 'PPL', 'P'),
(129918, 'Braywood', 42.2627792358398, 0.737624648708898, -86.345832824707, -1.50701907816773, 218, 27, 'PPL', 'P'),
(53635, 'Brazeau', 37.6611099243164, 0.657310368134834, -89.6527786254883, -1.56473617057637, 218, 29, 'PPL', 'P'),
(58773, 'Brazelia (historical)', 33.1736106872559, 0.578988731267394, -88.3625030517578, -1.54221661355671, 218, 30, 'PPL', 'P'),
(71884, 'Braziers', 39.061939239502, 0.681759451943279, -84.2247161865234, -1.4699986090126, 218, 41, 'PPL', 'P'),
(29280, 'Brazil', 39.523609161377, 0.689817112137423, -87.125, -1.52061811080006, 218, 19, 'PPL', 'P'),
(34966, 'Brazil', 37.5247192382813, 0.654929901594466, -84.0416717529297, -1.46680388096894, 218, 21, 'PPL', 'P'),
(53636, 'Brazil', 37.8461112976074, 0.660539251219473, -91.0633316040039, -1.58935496432528, 218, 29, 'PPL', 'P'),
(58770, 'Brazil', 34.0263900756836, 0.593872539388601, -90.2805633544922, -1.57569308109123, 218, 30, 'PPL', 'P'),
(85266, 'Brazil', 35.9174995422363, 0.62687862609558, -89.0625, -1.55443386505745, 218, 50, 'PPL', 'P'),
(114693, 'Brazil', 40.7580604553223, 0.711362351672273, -92.9541702270508, -1.62235632392132, 218, 16, 'PPL', 'P'),
(31883, 'Brazilton', 37.5597190856934, 0.655540764169503, -94.9572219848633, -1.65731617218301, 218, 20, 'PPL', 'P'),
(53638, 'Brazito', 38.4455604553223, 0.671001612719904, -92.3024978637695, -1.61098249553781, 218, 29, 'PPL', 'P'),
(159469, 'Braznell', 40.0247192382813, 0.698563132894325, -79.853889465332, -1.39371329169366, 218, 45, 'PPL', 'P'),
(92801, 'Brazoria', 29.0441703796387, 0.506916401634906, -95.5688934326172, -1.66799185288676, 218, 51, 'PPL', 'P'),
(92803, 'Brazos', 32.6613883972168, 0.570048765804107, -98.1216735839844, -1.71254627160767, 218, 51, 'PPL', 'P'),
(177651, 'Brazos', 38.2083282470703, 0.66686112959413, -122.305000305176, -2.13462494697799, 218, 6, 'PPL', 'P'),
(188181, 'Brazos', 36.7513885498047, 0.641432734873836, -106.560829162598, -1.85983732254252, 218, 38, 'PPL', 'P'),
(92804, 'Brazos Country', 29.7536106109619, 0.519298469517607, -96.0502777099609, -1.67639359349374, 218, 51, 'PPL', 'P'),
(92806, 'Brazos Point', 32.186939239502, 0.561768065868669, -97.6188888549805, -1.70377102265781, 218, 51, 'PPL', 'P'),
(92807, 'Brazosport', 28.9468402862549, 0.505217671044086, -95.3141174316406, -1.66354517281465, 218, 51, 'PPL', 'P'),
(180234, 'Brea', 33.9166717529297, 0.59195759340678, -117.899169921875, -2.05772870050498, 218, 6, 'PPL', 'P'),
(180235, 'Brea Chem', 33.9169387817383, 0.591962253938687, -117.86833190918, -2.05719047564868, 218, 6, 'PPL', 'P'),
(171774, 'Bread Loaf', 43.9533309936523, 0.767130343058104, -72.9930572509766, -1.27396918012626, 218, 55, 'PPL', 'P'),
(188182, 'Bread Springs', 35.3983306884766, 0.617817420223667, -108.666389465332, -1.89658628242452, 218, 38, 'PPL', 'P'),
(1100, 'Bread Tray Hill', 32.0638885498047, 0.559620426186602, -85.7705612182617, -1.49697869454203, 218, 2, 'PPL', 'P'),
(159470, 'Breadysville', 40.2183303833008, 0.701942284843472, -75.0583267211914, -1.31001493232243, 218, 45, 'PPL', 'P'),
(147346, 'Breakabeen', 42.524169921875, 0.742186776814259, -74.4100036621094, -1.29869956032485, 218, 40, 'PPL', 'P'),
(206881, 'Breakers', 46.3711090087891, 0.809328530004573, -124.049438476563, -2.16507113666615, 218, 56, 'PPL', 'P'),
(143548, 'Breakfast Hill', 43.0105590820313, 0.750675869104995, -70.8161087036133, -1.23597426032827, 218, 36, 'PPL', 'P'),
(113232, 'Breakman', 41.6583290100098, 0.72707500210374, -81.1130599975586, -1.4156899633251, 218, 41, 'PPL', 'P'),
(159471, 'Breakneck', 40.040828704834, 0.69884429612641, -79.5408325195313, -1.3882494172432, 218, 45, 'PPL', 'P'),
(177523, 'Breakneck', 41.8866691589355, 0.731060289516989, -72.6597213745117, -1.26815137156693, 218, 8, 'PPL', 'P'),
(100149, 'Breaks', 37.2958297729492, 0.650935026801293, -82.2811126708984, -1.4360763283116, 218, 53, 'PPL', 'P'),
(108348, 'Bream', 38.4033317565918, 0.670264582888224, -81.529167175293, -1.42295240361775, 218, 58, 'PPL', 'P'),
(39481, 'Breard', 32.5363883972168, 0.567867104239114, -92.081672668457, -1.60712836880825, 218, 22, 'PPL', 'P'),
(45023, 'Breathedsville', 39.5436096191406, 0.690166185977305, -77.7183303833008, -1.35644075434135, 218, 25, 'PPL', 'P'),
(39482, 'Breaux Bridge', 30.2733306884766, 0.528369296058958, -91.899169921875, -1.60394309498646, 218, 22, 'PPL', 'P'),
(34968, 'Breck', 38.4958305358887, 0.67187899114103, -84.7355575561523, -1.47891447286802, 218, 21, 'PPL', 'P'),
(29282, 'Breckenridge', 38.2177810668945, 0.667026112423661, -86.0330581665039, -1.50156013056529, 218, 19, 'PPL', 'P'),
(53641, 'Breckenridge', 39.7622184753418, 0.693981630292034, -93.8041687011719, -1.63719159593166, 218, 29, 'PPL', 'P'),
(92808, 'Breckenridge', 32.7555618286133, 0.571692402249876, -98.9019393920898, -1.72616447899985, 218, 51, 'PPL', 'P'),
(118886, 'Breckenridge', 40.2436103820801, 0.702383504057071, -91.2863922119141, -1.59324810636481, 218, 18, 'PPL', 'P'),
(129919, 'Breckenridge', 43.4080581665039, 0.757613536902706, -84.4749984741211, -1.4743668589906, 218, 27, 'PPL', 'P'),
(134388, 'Breckenridge', 46.2636108398438, 0.807452333016612, -96.5877838134766, -1.68577484474965, 218, 28, 'PPL', 'P'),
(186445, 'Breckenridge', 39.4816703796387, 0.689085142311814, -106.037780761719, -1.85070840579989, 218, 7, 'PPL', 'P'),
(114694, 'Breckenridge Estates', 41.6061096191406, 0.726163601799688, -91.4611129760742, -1.596297558971, 218, 16, 'PPL', 'P'),
(53639, 'Breckenridge Hills', 38.7144393920898, 0.67569443545576, -90.3672180175781, -1.57720549027428, 218, 29, 'PPL', 'P'),
(177784, 'Breckenridge Manor', 33.3627815246582, 0.582290385228819, -111.795829772949, -1.95120531953707, 218, 5, 'PPL', 'P'),
(34969, 'Breckinridge', 38.4413909912109, 0.670928841843117, -84.3786087036133, -1.47268454013, 218, 21, 'PPL', 'P'),
(75206, 'Breckinridge', 36.436939239502, 0.635944559078428, -97.7313919067383, -1.70573457132952, 218, 42, 'PPL', 'P'),
(34970, 'Breckinridge Center', 37.6827812194824, 0.657688603588652, -87.8630599975586, -1.53349968783472, 218, 21, 'PPL', 'P'),
(79925, 'Breckridge', 34.1883316040039, 0.596698952253502, -82.1983337402344, -1.43463156342024, 218, 48, 'PPL', 'P'),
(154434, 'Brecksville', 41.3197212219238, 0.721165181328745, -81.6269378662109, -1.42465882408622, 218, 41, 'PPL', 'P'),
(71883, 'Brecon', 39.2805595397949, 0.68557509599509, -84.3566665649414, -1.47230157756524, 218, 41, 'PPL', 'P'),
(114695, 'Breda', 42.1816711425781, 0.736209045431467, -94.9766693115234, -1.65765559206394, 218, 16, 'PPL', 'P'),
(134391, 'Breda', 47.311939239502, 0.825749115232811, -91.8855590820313, -1.60370554101722, 218, 28, 'PPL', 'P'),
(180236, 'Bredehoft Place', 39.7827796936035, 0.694340491248922, -122.938331604004, -2.14567866339847, 218, 6, 'PPL', 'P'),
(196074, 'Bredette', 48.5055618286133, 0.846581759438983, -105.299171447754, -1.83781724138531, 218, 31, 'PPL', 'P'),
(159474, 'Bredinsburg', 41.394718170166, 0.722474125004519, -79.7727813720703, -1.39229768841623, 218, 45, 'PPL', 'P'),
(159475, 'Bredinville', 40.8466682434082, 0.712908849317282, -79.9108276367188, -1.39470705025442, 218, 45, 'PPL', 'P'),
(7664, 'Bredlow Corner', 34.5341682434082, 0.60273494028514, -92.1011123657227, -1.60746765553112, 218, 4, 'PPL', 'P'),
(108350, 'Breece', 38.1369400024414, 0.665615169678137, -81.8963928222656, -1.42936170025519, 218, 58, 'PPL', 'P'),
(173284, 'Breed', 45.0730590820313, 0.786673284927378, -88.4241714477539, -1.54329293011127, 218, 57, 'PPL', 'P'),
(79919, 'Breeden', 34.6530609130859, 0.604810008827502, -79.6594390869141, -1.39031949235852, 218, 48, 'PPL', 'P'),
(108349, 'Breeden', 37.9252815246582, 0.661921032351061, -82.26611328125, -1.43581453957645, 218, 58, 'PPL', 'P'),
(100150, 'Breeden Forest', 38.792781829834, 0.677061768938434, -77.4563903808594, -1.35186903885606, 218, 53, 'PPL', 'P'),
(85268, 'Breedenton', 35.5438919067383, 0.620357942745548, -84.8008270263672, -1.4800536400243, 218, 50, 'PPL', 'P'),
(34972, 'Breeding', 36.959171295166, 0.645059227909224, -85.434440612793, -1.4911122832928, 218, 21, 'PPL', 'P'),
(108351, 'Breedlove (historical)', 39.2522201538086, 0.685080480401635, -79.5019378662109, -1.38757057748134, 218, 58, 'PPL', 'P'),
(39483, 'Breedlove Hills', 31.7388896942139, 0.553948126091328, -93.1658325195313, -1.62605052782742, 218, 22, 'PPL', 'P'),
(118887, 'Breeds', 40.5552787780762, 0.707823143741612, -89.920280456543, -1.56940495828338, 218, 18, 'PPL', 'P'),
(129920, 'Breedsville', 42.3463897705078, 0.739083927828207, -86.0730590820313, -1.50225827824505, 218, 27, 'PPL', 'P'),
(159476, 'Breedtown', 41.5999984741211, 0.72605694219803, -79.7080612182617, -1.39116810863987, 218, 45, 'PPL', 'P'),
(186446, 'Breen', 37.1925010681152, 0.649131600690119, -108.077217102051, -1.88630328482351, 218, 7, 'PPL', 'P'),
(53642, 'Breen Acres', 39.1913909912109, 0.684018811233075, -94.6066665649414, -1.65119782589466, 218, 29, 'PPL', 'P'),
(26598, 'Breese', 38.6105613708496, 0.673881421964661, -89.5269393920898, -1.56253986162538, 218, 18, 'PPL', 'P'),
(147348, 'Breesport', 42.1733283996582, 0.736063437098867, -76.7341690063477, -1.33926389794255, 218, 40, 'PPL', 'P'),
(203121, 'Breeze Estates', 40.707218170166, 0.710474986397058, -112.08805847168, -1.95630567249873, 218, 52, 'PPL', 'P'),
(15312, 'Breezeswept Park Estates', 26.1288890838623, 0.456035144401802, -80.2127838134766, -1.39997717973558, 218, 12, 'PPL', 'P'),
(1104, 'Breezeway Bay', 34.5050010681152, 0.602225877042771, -86.1888885498047, -1.50427988382853, 218, 2, 'PPL', 'P'),
(13425, 'Breezewood', 38.7202796936035, 0.675796367946483, -75.1305618286133, -1.31127567278247, 218, 10, 'PPL', 'P'),
(77911, 'Breezewood', 39.9991683959961, 0.698117186569791, -78.2388916015625, -1.36552626155821, 218, 45, 'PPL', 'P'),
(79920, 'Breezewood', 34.0713882446289, 0.594657905594066, -82.1466674804688, -1.43372981707513, 218, 48, 'PPL', 'P'),
(154436, 'Breezewood', 40.5083312988281, 0.707003755653222, -84.4508285522461, -1.47394501427393, 218, 41, 'PPL', 'P'),
(45024, 'Breezewood Estates', 39.6347198486328, 0.691756359464191, -77.0122222900391, -1.34411684323895, 218, 25, 'PPL', 'P'),
(45025, 'Breezewood Farms', 39.3244400024414, 0.68634095454557, -76.8811111450195, -1.3418285220723, 218, 25, 'PPL', 'P'),
(13426, 'Breezewood II', 39.6599998474121, 0.69219757867779, -75.7055587768555, -1.32131126271822, 218, 10, 'PPL', 'P'),
(159477, 'Breezy Acres', 40.9797210693359, 0.715231059208804, -76.4283294677734, -1.33392599101165, 218, 45, 'PPL', 'P'),
(129921, 'Breezy Beach', 41.8025016784668, 0.729591289859702, -85.559440612793, -1.49329394485779, 218, 27, 'PPL', 'P'),
(159478, 'Breezy Corner', 40.4111099243164, 0.705306922564678, -75.8466720581055, -1.32377415409432, 218, 45, 'PPL', 'P'),
(39484, 'Breezy Hill', 31.6602802276611, 0.552576132076747, -92.4366683959961, -1.61332421308432, 218, 22, 'PPL', 'P'),
(124304, 'Breezy Hill', 42.0319404602051, 0.733595752032799, -70.8444366455078, -1.23646867618464, 218, 23, 'PPL', 'P'),
(45026, 'Breezy Hill Estates', 39.6730613708496, 0.692425545267101, -76.8019409179688, -1.34044674094071, 218, 25, 'PPL', 'P'),
(45027, 'Breezy Knoll Estates', 38.6605606079102, 0.674754073274853, -76.6352767944336, -1.33753790324007, 218, 25, 'PPL', 'P'),
(45028, 'Breezy Knolls', 38.5038909912109, 0.672019672625614, -76.7641677856445, -1.33978747541286, 218, 25, 'PPL', 'P'),
(100151, 'Breezy Knolls Estates', 38.8613891601563, 0.678259192743561, -77.5747222900391, -1.35393432028142, 218, 53, 'PPL', 'P'),
(177780, 'Breezy Pines', 34.4388885498047, 0.601071995921467, -112.353889465332, -1.96094529859182, 218, 5, 'PPL', 'P'),
(45029, 'Breezy Point', 38.621940612793, 0.674080027202954, -76.51611328125, -1.33545810758677, 218, 25, 'PPL', 'P'),
(77909, 'Breezy Point', 39.9847183227539, 0.69786498521456, -78.04638671875, -1.36216641752696, 218, 45, 'PPL', 'P'),
(122266, 'Breezy Point', 40.6919403076172, 0.710208337392914, -86.753059387207, -1.51412652248494, 218, 19, 'PPL', 'P'),
(134393, 'Breezy Point', 46.6166687011719, 0.813614355146838, -94.216667175293, -1.64439105246453, 218, 28, 'PPL', 'P'),
(143549, 'Breezy Point', 43.9661102294922, 0.767353382799398, -71.8352813720703, -1.25376217903918, 218, 36, 'PPL', 'P'),
(147349, 'Breezy Point', 40.5563888549805, 0.707842518238542, -73.9266662597656, -1.29026373125591, 218, 40, 'PPL', 'P'),
(45030, 'Breezy Point Beach', 39.2775001525879, 0.685521699615234, -76.3847198486328, -1.33316485957211, 218, 25, 'PPL', 'P'),
(154437, 'Brehm (historical)', 40.6222190856934, 0.70899147251183, -84.7466735839844, -1.47910848415343, 218, 41, 'PPL', 'P'),
(206882, 'Breidablick', 47.8022193908691, 0.834306118131345, -122.648063659668, -2.14061253205681, 218, 56, 'PPL', 'P'),
(198043, 'Breien', 46.3800010681152, 0.809483725717098, -100.941940307617, -1.7617692117195, 218, 34, 'PPL', 'P'),
(159487, 'Breinigsville', 40.5366706848145, 0.707498371246677, -75.6316680908203, -1.32002162696035, 218, 45, 'PPL', 'P'),
(200446, 'Breitenbush', 44.7819404602051, 0.781592306462643, -121.970832824707, -2.12879262419071, 218, 43, 'PPL', 'P'),
(200447, 'Breitenbush Hot Springs', 44.7830581665039, 0.781611814117628, -121.977783203125, -2.12891393117837, 218, 43, 'PPL', 'P'),
(203122, 'Breithing Park', 40.6886100769043, 0.710150213902123, -111.906669616699, -1.9531398397529, 218, 52, 'PPL', 'P'),
(180237, 'Brela', 38.5752792358398, 0.673265632541607, -120.964721679688, -2.11123267206911, 218, 6, 'PPL', 'P'),
(58772, 'Breland', 31.3255596160889, 0.546734155330522, -89.3986129760742, -1.56030014314862, 218, 30, 'PPL', 'P'),
(45031, 'Brelsmir Haven', 38.6152801513672, 0.673963780221372, -76.1694412231445, -1.32940753874817, 218, 25, 'PPL', 'P'),
(1103, 'Bremen', 33.9944381713867, 0.593314873456339, -86.9700012207031, -1.51791287176476, 218, 2, 'PPL', 'P'),
(19456, 'Bremen', 33.7211112976074, 0.588544419574707, -85.1455612182617, -1.48607038671706, 218, 13, 'PPL', 'P'),
(31884, 'Bremen', 39.9013900756836, 0.696410632943268, -96.7888870239258, -1.68928475790832, 218, 20, 'PPL', 'P'),
(34973, 'Bremen', 37.3613891601563, 0.652079253963646, -87.2186126708984, -1.52225196012882, 218, 21, 'PPL', 'P'),
(112478, 'Bremen', 39.7016716003418, 0.692924887971491, -82.4269409179688, -1.43862151136539, 218, 41, 'PPL', 'P'),
(118888, 'Bremen', 42.4005584716797, 0.740029350015185, -90.4136123657227, -1.57801522440372, 218, 18, 'PPL', 'P'),
(122267, 'Bremen', 41.4463882446289, 0.723375937928647, -86.148063659668, -1.50356735507888, 218, 19, 'PPL', 'P'),
(126937, 'Bremen', 44.0013885498047, 0.767969105643425, -69.4291687011719, -1.21176759075804, 218, 26, 'PPL', 'P'),
(134396, 'Bremen', 44.208610534668, 0.771585811561807, -92.3105621337891, -1.61112324360142, 218, 28, 'PPL', 'P'),
(139708, 'Bremen', 47.7466697692871, 0.833336594336501, -99.3863906860352, -1.73461974914474, 218, 34, 'PPL', 'P'),
(114697, 'Bremer', 42.7733306884766, 0.746535452558249, -92.3947219848633, -1.61259211010065, 218, 16, 'PPL', 'P'),
(206883, 'Bremer', 46.5786094665527, 0.812950096191945, -122.413887023926, -2.13652537873187, 218, 56, 'PPL', 'P'),
(45032, 'Bremerton', 38.3972206115723, 0.670157923286567, -75.5111083984375, -1.31791746338308, 218, 25, 'PPL', 'P'),
(206884, 'Bremerton', 47.5675010681152, 0.83020951058453, -122.631393432617, -2.14032158170772, 218, 56, 'PPL', 'P'),
(206885, 'Bremerton Junction', 47.5313911437988, 0.829579273512563, -122.732780456543, -2.14209111909402, 218, 56, 'PPL', 'P'),
(100152, 'Bremo Bluff', 37.7122192382813, 0.658202393941956, -78.2977828979492, -1.36655410858092, 218, 53, 'PPL', 'P'),
(39485, 'Bremond', 29.4563903808594, 0.514110997898783, -89.6630630493164, -1.56491566763384, 218, 22, 'PPL', 'P'),
(92809, 'Bremond', 31.1650009155273, 0.543931877362999, -96.6766662597656, -1.68732613608462, 218, 51, 'PPL', 'P'),
(122268, 'Brems', 41.339168548584, 0.721504601209676, -86.6975021362305, -1.51315686553204, 218, 19, 'PPL', 'P'),
(100153, 'Bren Mar Park', 38.7986106872559, 0.677163501692075, -77.1555633544922, -1.34661861676697, 218, 53, 'PPL', 'P'),
(196076, 'Brenchley Mobile Home Park', 48.4411087036133, 0.845456840194534, -114.349166870117, -1.99576945879596, 218, 31, 'PPL', 'P'),
(177781, 'Brenda', 33.6797218322754, 0.587822037129023, -113.943893432617, -1.98869610294071, 218, 5, 'PPL', 'P'),
(92810, 'Brenda Gay Colonia', 26.3090000152588, 0.459178673173504, -98.0220031738281, -1.71080669478363, 218, 51, 'PPL', 'P'),
(19457, 'Brenda View', 33.8108291625977, 0.590110291716646, -84.6111068725586, -1.47674239868295, 218, 13, 'PPL', 'P'),
(122269, 'Brendan Wood', 40.0672187805176, 0.699304889836939, -86.4688873291016, -1.50916678442883, 218, 19, 'PPL', 'P'),
(192497, 'Brendel', 38.9469413757324, 0.679752360587741, -109.814170837402, -1.91661884646021, 218, 52, 'PPL', 'P'),
(63124, 'Brendletown', 35.2402801513672, 0.615058917966563, -83.3405609130859, -1.45456718839224, 218, 33, 'PPL', 'P'),
(29283, 'Brendonwood', 39.857780456543, 0.695649501503724, -86.0638885498047, -1.50209822226354, 218, 19, 'PPL', 'P'),
(361, 'Brenford', 39.2563896179199, 0.685153251278421, -75.6111068725586, -1.31966276600346, 218, 10, 'PPL', 'P'),
(31885, 'Brenham', 37.6097183227539, 0.656413415479695, -99.2077789306641, -1.73150238593075, 218, 20, 'PPL', 'P'),
(92811, 'Brenham', 30.1666698455811, 0.526507713167479, -96.3974990844727, -1.68245374971227, 218, 51, 'PPL', 'P'),
(159479, 'Brenizer', 40.4002799987793, 0.705117904706309, -79.2683334350586, -1.38349341101048, 218, 45, 'PPL', 'P'),
(196075, 'Brenna Trailer Court', 48.7894401550293, 0.851536370909994, -105.415000915527, -1.83983884696879, 218, 31, 'PPL', 'P'),
(209932, 'Brennan', 48.8224983215332, 0.85211334476016, -122.561111450195, -2.13909492970963, 218, 56, 'PPL', 'P'),
(199846, 'Brennen Ranch', 40.6680603027344, 0.709791552682317, -115.547218322754, -2.01667940125278, 218, 39, 'PPL', 'P'),
(31886, 'Brenner', 39.7252807617188, 0.693336945571153, -95.1149978637695, -1.66006988075015, 218, 20, 'PPL', 'P'),
(71888, 'Brennersville', 39.8019409179688, 0.694674917702809, -84.5774993896484, -1.47615583745286, 218, 41, 'PPL', 'P'),
(134398, 'Brennyville', 45.8086090087891, 0.799511052962105, -93.9055633544922, -1.63896126647602, 218, 28, 'PPL', 'P'),
(649, 'Brent', 36.3641700744629, 0.634674497554569, -89.7355575561523, -1.56618093546773, 218, 29, 'PPL', 'P'),
(1112, 'Brent', 32.9372215270996, 0.574862962106643, -87.1647186279297, -1.52131133163181, 218, 2, 'PPL', 'P'),
(15313, 'Brent', 30.4686107635498, 0.531777576332528, -87.2361068725586, -1.5225572915478, 218, 12, 'PPL', 'P'),
(19458, 'Brent', 32.9816703796387, 0.575638740932183, -84.0102767944336, -1.46625593557465, 218, 13, 'PPL', 'P'),
(34974, 'Brent', 39.0547218322754, 0.681633484423718, -84.4336090087891, -1.47364447654492, 218, 21, 'PPL', 'P'),
(39488, 'Brent', 32.8580589294434, 0.57348131413311, -93.9819412231445, -1.64029431175966, 218, 22, 'PPL', 'P'),
(75207, 'Brent', 35.3677787780762, 0.617284188794406, -94.793327331543, -1.65445567085616, 218, 42, 'PPL', 'P'),
(79921, 'Brent', 34.0194396972656, 0.593751232400948, -80.3702774047852, -1.4027259614547, 218, 48, 'PPL', 'P'),
(159480, 'Brent', 41.1136093139648, 0.717567849907294, -80.1672210693359, -1.39918195983408, 218, 45, 'PPL', 'P'),
(129924, 'Brent Creek', 43.1177787780762, 0.752547205823967, -83.8866729736328, -1.46409864193364, 218, 27, 'PPL', 'P'),
(100154, 'Brent Town', 38.5933303833008, 0.673580684498564, -77.601936340332, -1.35440929506183, 218, 53, 'PPL', 'P'),
(100155, 'Brent Turf Acres', 38.6958312988281, 0.675369662960825, -77.5152816772461, -1.35289688587878, 218, 53, 'PPL', 'P'),
(29284, 'Brent Woods', 39.538330078125, 0.690074040603588, -85.7569427490234, -1.49674100741474, 218, 19, 'PPL', 'P'),
(169892, 'Brentford', 45.1602783203125, 0.788195547806468, -98.3225021362305, -1.71605139107638, 218, 49, 'PPL', 'P'),
(45033, 'Brentland', 38.4652786254883, 0.671345759711769, -77.0411071777344, -1.3446209796333, 218, 25, 'PPL', 'P'),
(108352, 'Brenton', 37.5958290100098, 0.656171001241471, -81.6361083984375, -1.42481888006773, 218, 58, 'PPL', 'P'),
(169288, 'Brenton Village', 41.4744415283203, 0.723865560095059, -71.3391723632813, -1.245103443387, 218, 47, 'PPL', 'P'),
(1105, 'Brents Cross Roads', 33.711109161377, 0.588369849365252, -86.9930572509766, -1.51831527540547, 218, 2, 'PPL', 'P'),
(180238, 'Brents Junction', 34.1483306884766, 0.596000804573738, -118.696937561035, -2.07165237247419, 218, 6, 'PPL', 'P'),
(34975, 'Brentsville', 38.2377815246582, 0.667375186263543, -84.2897186279297, -1.47113311563697, 218, 21, 'PPL', 'P'),
(100156, 'Brentsville', 38.688060760498, 0.675234041482312, -77.4963912963867, -1.35256718653583, 218, 53, 'PPL', 'P'),
(1107, 'Brentwood', 31.250280380249, 0.545420284806731, -85.4486083984375, -1.49135955780001, 218, 2, 'PPL', 'P'),
(7665, 'Brentwood', 35.8600006103516, 0.625875080417811, -94.1069412231445, -1.64247597332465, 218, 4, 'PPL', 'P'),
(15314, 'Brentwood', 30.3588905334473, 0.529862597061192, -81.6588897705078, -1.42521649001848, 218, 12, 'PPL', 'P'),
(19461, 'Brentwood', 31.6944408416748, 0.553172347265788, -82.1136093139648, -1.43315284322497, 218, 13, 'PPL', 'P'),
(34976, 'Brentwood', 37.2966690063477, 0.650949674187288, -87.5133285522461, -1.52739572261626, 218, 21, 'PPL', 'P'),
(45035, 'Brentwood', 38.9430618286133, 0.679684649717025, -76.9569396972656, -1.34315197997601, 218, 25, 'PPL', 'P'),
(53643, 'Brentwood', 38.6175003051758, 0.674002529215232, -90.3491668701172, -1.57689043831733, 218, 29, 'PPL', 'P'),
(63125, 'Brentwood', 35.586669921875, 0.621104559957152, -77.3777770996094, -1.35049697826245, 218, 33, 'PPL', 'P'),
(79922, 'Brentwood', 32.8563919067383, 0.573452219098201, -80.0113906860352, -1.39646220657084, 218, 48, 'PPL', 'P'),
(85274, 'Brentwood', 36.0330581665039, 0.628895504568124, -86.7827835083008, -1.51464530626528, 218, 50, 'PPL', 'P'),
(100160, 'Brentwood', 37.3166694641113, 0.651298748027171, -79.9391708374023, -1.3952017324269, 218, 53, 'PPL', 'P'),
(118891, 'Brentwood', 42.1527786254883, 0.73570477587906, -88.0480575561523, -1.53672850434033, 218, 18, 'PPL', 'P'),
(122270, 'Brentwood', 40.0974998474121, 0.699833394155265, -85.7152786254883, -1.49601383127909, 218, 19, 'PPL', 'P'),
(143550, 'Brentwood', 42.9786109924316, 0.75011826975176, -71.0733337402344, -1.24046368413587, 218, 36, 'PPL', 'P'),
(147350, 'Brentwood', 40.7811088562012, 0.711764622154929, -73.2466735839844, -1.27839562017408, 218, 40, 'PPL', 'P'),
(154438, 'Brentwood', 41.6477813720703, 0.726890911093389, -81.375, -1.42026167881039, 218, 41, 'PPL', 'P'),
(159481, 'Brentwood', 40.3705596923828, 0.704599187504989, -79.9749984741211, -1.39582704265085, 218, 45, 'PPL', 'P'),
(180240, 'Brentwood', 34.0519409179688, 0.594318485713135, -118.47306060791, -2.06774498252283, 218, 6, 'PPL', 'P'),
(45036, 'Brentwood Acres', 39.5572204589844, 0.69040373994654, -76.9038925170898, -1.34222613202305, 218, 25, 'PPL', 'P'),
(143551, 'Brentwood Corners', 43.0083312988281, 0.75063698695308, -71.0766677856445, -1.24052187420568, 218, 36, 'PPL', 'P'),
(15315, 'Brentwood Estates', 26.1891708374023, 0.457087259479951, -80.147216796875, -1.39883281941517, 218, 12, 'PPL', 'P'),
(85279, 'Brentwood Estates', 35.148609161377, 0.613458957362671, -84.9124984741211, -1.48200267446807, 218, 50, 'PPL', 'P'),
(180241, 'Brentwood Heights', 34.0636100769043, 0.594522150957499, -118.473892211914, -2.06775949675077, 218, 6, 'PPL', 'P'),
(154440, 'Brentwood Lake', 41.3161087036133, 0.721102130989938, -82.0777816772461, -1.43252753300102, 218, 41, 'PPL', 'P'),
(177782, 'Brentwood Mobile Manor', 33.4191703796387, 0.583274556409658, -111.751106262207, -1.95042474702157, 218, 5, 'PPL', 'P'),
(45037, 'Brentwood Park', 39.5397186279297, 0.690098275369508, -76.3747177124023, -1.33299028936265, 218, 25, 'PPL', 'P'),
(180242, 'Brentwood Park', 38.0449981689453, 0.66401048196331, -120.245826721191, -2.09868558806737, 218, 6, 'PPL', 'P'),
(203128, 'Brentwood Park', 40.6336097717285, 0.709190277487204, -111.856109619141, -1.9522574013257, 218, 52, 'PPL', 'P'),
(39486, 'Brentwood Place', 30.5647201538086, 0.533455001634628, -91.1258316040039, -1.59044579510777, 218, 22, 'PPL', 'P'),
(85285, 'Brentwood Station', 36.021671295166, 0.628696766171777, -86.7925033569336, -1.51481494962672, 218, 50, 'PPL', 'P'),
(100162, 'Brentwood Terrace', 39.1797218322754, 0.683815145988711, -78.1222229003906, -1.36349000858873, 218, 53, 'PPL', 'P'),
(13041, 'Brentwood Village', 38.9208297729492, 0.679296627146201, -76.9847183227539, -1.34363680845246, 218, 9, 'PPL', 'P'),
(177783, 'Brentwood West', 33.4099998474121, 0.583114500428144, -111.759719848633, -1.9505750824651, 218, 5, 'PPL', 'P'),
(118892, 'Brereton', 40.6108283996582, 0.708792667536455, -90.0258331298828, -1.57124719996745, 218, 18, 'PPL', 'P'),
(92812, 'Breslau', 29.5227794647217, 0.515269705999562, -96.9963912963867, -1.69290639067472, 218, 51, 'PPL', 'P'),
(141360, 'Breslau', 42.3502807617188, 0.739151838436004, -97.6986083984375, -1.70516239116932, 218, 35, 'PPL', 'P'),
(159483, 'Breslau', 41.2333297729492, 0.71965736609857, -75.9349975585938, -1.32531572489132, 218, 45, 'PPL', 'P'),
(159484, 'Bressler', 40.2294387817383, 0.702136162970829, -76.8202819824219, -1.34076685290374, 218, 45, 'PPL', 'P'),
(129926, 'Brethren', 44.3044395446777, 0.773258343305404, -86.0188903808594, -1.50131285605808, 218, 27, 'PPL', 'P'),
(206886, 'Bretland', 48.1222190856934, 0.839891166411404, -122.42472076416, -2.13671446316926, 218, 56, 'PPL', 'P'),
(34977, 'Breton', 37.5505599975586, 0.655380907925071, -87.5236129760742, -1.52757521967373, 218, 21, 'PPL', 'P'),
(39487, 'Breton', 29.4938907623291, 0.514765503026183, -89.1738891601563, -1.55637797265321, 218, 22, 'PPL', 'P'),
(187605, 'Breton', 39.4524993896484, 0.688576012490419, -100.813606262207, -1.75952936008469, 218, 20, 'PPL', 'P'),
(45038, 'Breton Beach', 38.2372207641602, 0.667365399146537, -76.6872177124023, -1.33844444327513, 218, 25, 'PPL', 'P'),
(45039, 'Breton Woods', 38.2833290100098, 0.668170139848932, -76.664436340332, -1.33804683332439, 218, 25, 'PPL', 'P'),
(144890, 'Breton Woods', 40.0455589294434, 0.698926854120202, -74.1091690063477, -1.2934490050777, 218, 37, 'PPL', 'P'),
(159485, 'Bretonville', 40.8519401550293, 0.713000861532944, -78.5661087036133, -1.37123727735783, 218, 45, 'PPL', 'P'),
(177524, 'Bretton Heights', 41.5436096191406, 0.725072771017191, -72.6600036621094, -1.26815629841495, 218, 8, 'PPL', 'P'),
(19464, 'Bretton Woods', 34.1788902282715, 0.596534169161054, -83.8186111450195, -1.46291073892941, 218, 13, 'PPL', 'P'),
(45040, 'Bretton Woods', 39.0800018310547, 0.682074703637317, -76.6555633544922, -1.337891970507, 218, 25, 'PPL', 'P'),
(100163, 'Bretton Woods', 37.6588897705078, 0.657271619140973, -77.5152816772461, -1.35289688587878, 218, 53, 'PPL', 'P'),
(143553, 'Bretton Woods', 44.2580604553223, 0.772448875492074, -71.4416732788086, -1.24689242184926, 218, 36, 'PPL', 'P'),
(108354, 'Bretz', 39.0952796936035, 0.682341352641461, -79.6641693115234, -1.39040205035231, 218, 58, 'PPL', 'P'),
(180244, 'Bretz Mill', 37.0374984741211, 0.646426295075789, -119.238891601563, -2.08111125487588, 218, 6, 'PPL', 'P'),
(29285, 'Bretzville', 38.2994384765625, 0.668451303081017, -86.8730621337891, -1.51622096552423, 218, 19, 'PPL', 'P'),
(63134, 'Brevard', 35.2333297729492, 0.61493761097891, -82.7344436645508, -1.44398844675217, 218, 33, 'PPL', 'P'),
(159486, 'Brevard', 40.2616691589355, 0.702698689172081, -80.2680587768555, -1.40094190984046, 218, 45, 'PPL', 'P'),
(63135, 'Brevard (historical)', 35.8472213745117, 0.625652040676517, -81.0616683959961, -1.41479301066996, 218, 33, 'PPL', 'P'),
(53645, 'Brevator', 38.9580612182617, 0.67994643845218, -90.7430572509766, -1.58376512235526, 218, 29, 'PPL', 'P'),
(58775, 'Brevet (historical)', 31.9286098480225, 0.557259367432678, -89.0186080932617, -1.55366780676989, 218, 30, 'PPL', 'P'),
(211710, 'Brevig Mission', 65.334716796875, 1.14030592396351, -166.489166259766, -2.90578412013316, 218, 1, 'PPL', 'P'),
(134400, 'Brevik', 47.0830612182617, 0.82175444017672, -94.288330078125, -1.64564180607048, 218, 28, 'PPL', 'P'),
(129928, 'Brevort', 46.0188903808594, 0.803181155260343, -85.0416717529297, -1.48425717348888, 218, 27, 'PPL', 'P'),
(7666, 'Brewer', 35.6699981689453, 0.622558912228444, -92.179443359375, -1.60883478927672, 218, 4, 'PPL', 'P'),
(31887, 'Brewer', 39.124439239502, 0.682850282725775, -97.7874984741211, -1.70671381566234, 218, 20, 'PPL', 'P'),
(53646, 'Brewer', 37.7808303833008, 0.65939988432611, -89.9252777099609, -1.56949217680908, 218, 29, 'PPL', 'P'),
(58778, 'Brewer', 31.3724994659424, 0.547553410260857, -88.8663864135742, -1.55101103726643, 218, 30, 'PPL', 'P'),
(75209, 'Brewer', 34.813060760498, 0.607602532967532, -95.8605575561523, -1.67308235215239, 218, 42, 'PPL', 'P'),
(126939, 'Brewer', 44.7966690063477, 0.781849368086863, -68.7619400024414, -1.2001222531014, 218, 26, 'PPL', 'P'),
(196077, 'Brewer', 46.1380615234375, 0.805261084071695, -111.400001525879, -1.94429681335329, 218, 31, 'PPL', 'P'),
(19465, 'Brewer (historical)', 31.6783294677734, 0.552891150744189, -81.6827774047852, -1.42563340788713, 218, 13, 'PPL', 'P'),
(85286, 'Brewer Addition', 35.4352798461914, 0.61846230468163, -84.5983276367188, -1.47651935894166, 218, 50, 'PPL', 'P'),
(71887, 'Brewer Heights', 39.3424987792969, 0.68665613966058, -83.0202789306641, -1.44897721326417, 218, 41, 'PPL', 'P'),
(108355, 'Brewer Hill', 39.6536102294922, 0.692086058807143, -79.9897232055664, -1.39608403769605, 218, 58, 'PPL', 'P'),
(34978, 'Brewers', 36.7713890075684, 0.641781808713718, -88.4388885498047, -1.5435497919984, 218, 21, 'PPL', 'P'),
(19466, 'Brewers (historical)', 34.0083312988281, 0.59355735427359, -85.1097183227539, -1.485444810177, 218, 13, 'PPL', 'P'),
(63137, 'Brewers (historical)', 36.351390838623, 0.634451457813275, -81.0905609130859, -1.41529728022237, 218, 33, 'PPL', 'P'),
(147351, 'Brewers Corner', 43.1113891601563, 0.75243568595332, -75.5344390869141, -1.31832466071375, 218, 40, 'PPL', 'P'),
(171776, 'Brewers Corner', 43.6191711425781, 0.761298153428885, -72.8772201538086, -1.27194744138473, 218, 55, 'PPL', 'P'),
(63138, 'Brewers Crossroads', 36.5088882446289, 0.637200306111427, -77.6033325195313, -1.35443366298581, 218, 33, 'PPL', 'P'),
(15317, 'Brewers Landing', 29.8730602264404, 0.521383258597948, -81.6208267211914, -1.42455216448456, 218, 12, 'PPL', 'P'),
(1114, 'Brewersville', 32.5163917541504, 0.567518096978259, -88.0919418334961, -1.53749442946984, 218, 2, 'PPL', 'P'),
(29286, 'Brewersville', 39.0844383239746, 0.682152135046011, -85.6116714477539, -1.49420554489893, 218, 19, 'PPL', 'P'),
(79926, 'Brewerton', 34.4305610656738, 0.600926653904976, -82.2402801513672, -1.4353636664039, 218, 48, 'PPL', 'P'),
(147352, 'Brewerton', 43.2380599975586, 0.754646509132249, -76.14111328125, -1.3289131228918, 218, 40, 'PPL', 'P'),
(79927, 'Brewington (historical)', 33.7005615234375, 0.588185758354901, -80.0536117553711, -1.39719910324446, 218, 48, 'PPL', 'P'),
(15318, 'Brewster', 27.7525005340576, 0.48437250998079, -81.9797210693359, -1.43081605252648, 218, 12, 'PPL', 'P'),
(124305, 'Brewster', 41.7599983215332, 0.72884946633806, -70.0833282470703, -1.22318482866732, 218, 23, 'PPL', 'P'),
(134401, 'Brewster', 43.6986083984375, 0.762684595092381, -95.4683303833008, -1.66623669657034, 218, 28, 'PPL', 'P'),
(141362, 'Brewster', 41.9388885498047, 0.731971689821042, -99.8644409179688, -1.7429632996819, 218, 35, 'PPL', 'P'),
(147353, 'Brewster', 41.3972206115723, 0.722517800846397, -73.6175003051758, -1.28486776741325, 218, 40, 'PPL', 'P'),
(154441, 'Brewster', 40.7069396972656, 0.710470126128069, -81.5983276367188, -1.42415948138183, 218, 41, 'PPL', 'P'),
(187606, 'Brewster', 39.3666687011719, 0.687077984377249, -101.376388549805, -1.76935176397517, 218, 20, 'PPL', 'P'),
(206887, 'Brewster', 48.0961112976074, 0.839435499548892, -119.779441833496, -2.09054563619554, 218, 56, 'PPL', 'P'),
(126941, 'Brewster Corner', 44.7949981689453, 0.781820206472927, -67.811393737793, -1.18353209109075, 218, 26, 'PPL', 'P'),
(45056, 'Brewster Heights', 39.6705589294434, 0.692381869425224, -75.8341674804688, -1.32355590804299, 218, 25, 'PPL', 'P'),
(147354, 'Brewster Heights', 41.4061088562012, 0.722672929979894, -73.633056640625, -1.28513927668638, 218, 40, 'PPL', 'P'),
(147355, 'Brewster Hill', 41.4238891601563, 0.722983254825915, -73.6047210693359, -1.28464472767195, 218, 40, 'PPL', 'P'),
(108356, 'Brewsterdale', 37.2491683959961, 0.650120632139947, -81.5516662597656, -1.42334508672048, 218, 58, 'PPL', 'P'),
(85287, 'Brewstertown', 36.3447189331055, 0.634335011094611, -84.7249984741211, -1.47873018212058, 218, 50, 'PPL', 'P'),
(177525, 'Brewsterville (historical)', 41.3025016784668, 0.72086464359973, -72.915283203125, -1.27261176691865, 218, 8, 'PPL', 'P'),
(1115, 'Brewton', 31.1049995422363, 0.542884655843353, -87.0722198486328, -1.519696923379, 218, 2, 'PPL', 'P'),
(19467, 'Brewton', 32.5936088562012, 0.568865789647893, -82.7980575561523, -1.44509871861063, 218, 13, 'PPL', 'P'),
(79928, 'Brewton', 32.6508293151855, 0.569864475056673, -80.8061065673828, -1.41033261531824, 218, 48, 'PPL', 'P'),
(39489, 'Brewtons Mill', 32.1211090087891, 0.560619111595381, -92.8427810668945, -1.62041221632556, 218, 22, 'PPL', 'P'),
(92814, 'Breyfogle Park Colonia Number 1', 26.2320003509521, 0.457834775508423, -98.3570022583008, -1.71665353179885, 218, 51, 'PPL', 'P'),
(39490, 'Brian', 32.6383285522461, 0.569646295584368, -93.9305572509766, -1.63939749226257, 218, 22, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(53647, 'Brian', 36.6066703796387, 0.638906926316977, -90.0930633544922, -1.57242058874374, 218, 29, 'PPL', 'P'),
(39491, 'Brian Estates', 30.5025005340576, 0.532369064410634, -91.0838928222656, -1.58971382528217, 218, 22, 'PPL', 'P'),
(192498, 'Brian Head', 37.6927795410156, 0.65786310721908, -112.849998474121, -1.96960403424399, 218, 52, 'PPL', 'P'),
(85288, 'Brian Manor', 35.9099998474121, 0.626747731728003, -86.3227767944336, -1.50661667452702, 218, 50, 'PPL', 'P'),
(19468, 'Brians Chase', 32.4533309936523, 0.566417479078756, -81.7486114501953, -1.42678242873944, 218, 13, 'PPL', 'P'),
(45041, 'Brianwood', 38.375560760498, 0.66977988756983, -76.4069366455078, -1.33355261582682, 218, 25, 'PPL', 'P'),
(7670, 'Briar', 34.0877799987793, 0.594943995674167, -93.8736114501953, -1.63840360054376, 218, 4, 'PPL', 'P'),
(53648, 'Briar', 36.6483306884766, 0.639634035873596, -90.9716720581055, -1.58775520345847, 218, 29, 'PPL', 'P'),
(92813, 'Briar', 32.9949989318848, 0.575871368053401, -97.5425033569336, -1.70243784421611, 218, 51, 'PPL', 'P'),
(118894, 'Briar Bluff', 41.4597206115723, 0.723608631628893, -90.3633270263672, -1.57713757966648, 218, 18, 'PPL', 'P'),
(45042, 'Briar Cliff on the Severn', 39.0258293151855, 0.681129214871312, -76.5158309936523, -1.33545318073876, 218, 25, 'PPL', 'P'),
(79929, 'Briar Creek', 35.0444412231445, 0.611640883865501, -81.6055603027344, -1.4242857152175, 218, 48, 'PPL', 'P'),
(159488, 'Briar Creek', 41.0458297729492, 0.71638487375108, -76.2825012207031, -1.33138080795786, 218, 45, 'PPL', 'P'),
(159490, 'Briar Crest Woods', 41.0480613708496, 0.716423822482023, -75.5430603027344, -1.31847512931534, 218, 45, 'PPL', 'P'),
(118895, 'Briar Gate', 41.9663887023926, 0.732451658028501, -88.4219436645508, -1.54325404795935, 218, 18, 'PPL', 'P'),
(19485, 'Briar Glen', 33.6847190856934, 0.587909255654723, -84.2527770996094, -1.47048836433706, 218, 13, 'PPL', 'P'),
(1116, 'Briar Hill', 31.958890914917, 0.557787871751005, -86.129997253418, -1.50325203680582, 218, 2, 'PPL', 'P'),
(26603, 'Briar Hill', 38.5730590820313, 0.673226883547747, -90.0630569458008, -1.57189687811537, 218, 18, 'PPL', 'P'),
(45043, 'Briar Hill', 39.2733306884766, 0.685448928738447, -76.9416732788086, -1.34288553070895, 218, 25, 'PPL', 'P'),
(154442, 'Briar Hill Corners', 41.4905586242676, 0.724146856485198, -81.3399963378906, -1.41965074965632, 218, 41, 'PPL', 'P'),
(13427, 'Briar Hook', 38.6824989318848, 0.675136969260579, -75.6602783203125, -1.32052096966474, 218, 10, 'PPL', 'P'),
(1117, 'Briar Lake Estates', 31, 0.541052068118242, -87.4805603027344, -1.52682380877216, 218, 2, 'PPL', 'P'),
(19469, 'Briar Lakes', 33.9075012207031, 0.591797537425266, -83.4880599975586, -1.45714153305997, 218, 13, 'PPL', 'P'),
(45044, 'Briar Lea', 39.0374984741211, 0.681332880115676, -76.4947204589844, -1.33508473240195, 218, 25, 'PPL', 'P'),
(144891, 'Briar Manor', 40.211669921875, 0.70182603786189, -74.6588897705078, -1.30304344237888, 218, 37, 'PPL', 'P'),
(13428, 'Briar Park', 39.1061096191406, 0.68253037049983, -75.5444412231445, -1.3184992309232, 218, 10, 'PPL', 'P'),
(45045, 'Briar Patch', 38.3186111450195, 0.668785929271985, -75.8877792358398, -1.32449160969199, 218, 25, 'PPL', 'P'),
(39492, 'Briar Place', 30.3819408416748, 0.530264900833363, -91.0297164916992, -1.58876826993713, 218, 22, 'PPL', 'P'),
(45047, 'Briar Ridge', 39.5625, 0.690495885320257, -76.4377822875977, -1.33409097384118, 218, 25, 'PPL', 'P'),
(100170, 'Briar Ridge', 37.1986083984375, 0.649238193712749, -80.0280609130859, -1.39675315691993, 218, 53, 'PPL', 'P'),
(85289, 'Briar Thicket', 36.1097183227539, 0.63023347669978, -83.1286087036133, -1.45086792448007, 218, 50, 'PPL', 'P'),
(7671, 'Briarcliff', 36.2750015258789, 0.633118212792554, -92.2861099243164, -1.61069647203674, 218, 4, 'PPL', 'P'),
(39493, 'Briarcliff', 30.3583297729492, 0.529852809944186, -91.0966720581055, -1.58993686502346, 218, 22, 'PPL', 'P'),
(63140, 'Briarcliff', 35.6944389343262, 0.622985484056048, -79.7752838134766, -1.3923413642581, 218, 33, 'PPL', 'P'),
(79933, 'Briarcliff', 34.1786117553711, 0.596529308892064, -82.1869430541992, -1.43443275844486, 218, 48, 'PPL', 'P'),
(92815, 'Briarcliff', 30.4072208404541, 0.530706120046961, -98.0441665649414, -1.71119351893197, 218, 51, 'PPL', 'P'),
(100164, 'Briarcliff', 37.2680587768555, 0.650450331482899, -79.8863906860352, -1.39428054500585, 218, 53, 'PPL', 'P'),
(1120, 'Briarcliff Estates', 33.7236099243164, 0.588588028837557, -87.0002822875977, -1.51844137608308, 218, 2, 'PPL', 'P'),
(79934, 'Briarcliff Estates', 33.8636093139648, 0.591031479137705, -80.4097213745117, -1.40341438859649, 218, 48, 'PPL', 'P'),
(147356, 'Briarcliff Manor', 41.1455612182617, 0.718125515839556, -73.8241729736328, -1.28847488595171, 218, 40, 'PPL', 'P'),
(85291, 'Briarcliff View', 36.1627807617188, 0.631159590968855, -83.4222183227539, -1.4559923790496, 218, 50, 'PPL', 'P'),
(79935, 'Briarcliffe Acres', 33.7847213745117, 0.589654624854134, -78.7427825927734, -1.37432081842597, 218, 48, 'PPL', 'P'),
(19470, 'Briarcreek Estates', 33.0475006103516, 0.57678769520547, -85.1638870239258, -1.48639023236398, 218, 13, 'PPL', 'P'),
(206888, 'Briarcrest', 47.7438888549805, 0.833288058225635, -122.296112060547, -2.13446981784449, 218, 56, 'PPL', 'P'),
(1121, 'Briarfield', 33.422779083252, 0.583337540169439, -86.2769393920898, -1.50581666093556, 218, 2, 'PPL', 'P'),
(100165, 'Briarfield (historical)', 36.5499992370605, 0.637917828288122, -79.5627822875977, -1.38863251296601, 218, 53, 'PPL', 'P'),
(19471, 'Briargate', 33.5430603027344, 0.585436843477721, -84.3855590820313, -1.47280584711765, 218, 13, 'PPL', 'P'),
(79936, 'Briargate', 34.8502807617188, 0.60825214453643, -82.5522232055664, -1.4408080997784, 218, 48, 'PPL', 'P'),
(92816, 'Briargrove', 29.7458305358887, 0.519162681591527, -95.4894409179688, -1.66660514490715, 218, 51, 'PPL', 'P'),
(19472, 'Briarhill', 33.4769401550293, 0.584282829198362, -84.5716705322266, -1.47605410469922, 218, 13, 'PPL', 'P'),
(45048, 'Briaridge', 39.170280456543, 0.683650362896262, -76.9674987792969, -1.34333627072345, 218, 25, 'PPL', 'P'),
(7672, 'Briark', 35.146671295166, 0.613425135216827, -90.1258316040039, -1.57299250258783, 218, 4, 'PPL', 'P'),
(159491, 'Briarly', 40.850830078125, 0.712981487036014, -77.8966674804688, -1.35955332386538, 218, 45, 'PPL', 'P'),
(92817, 'Briaroaks', 32.5033302307129, 0.567290130388948, -97.3047180175781, -1.69828770713139, 218, 51, 'PPL', 'P'),
(19473, 'Briarpatch', 33.6319389343262, 0.586988068233665, -83.8194427490234, -1.46292525315735, 218, 13, 'PPL', 'P'),
(79937, 'Briars', 32.5811080932617, 0.568647610175589, -80.6994400024414, -1.40847093255822, 218, 48, 'PPL', 'P'),
(45049, 'Briars Acres', 39.1605606079102, 0.683480719534824, -77.0858306884766, -1.3454015521488, 218, 25, 'PPL', 'P'),
(173286, 'Briarton', 44.603328704834, 0.778474943248651, -88.4263916015625, -1.54333167910513, 218, 57, 'PPL', 'P'),
(34979, 'Briartown', 37.6938896179199, 0.65788248171601, -85.2425003051758, -1.48776229295759, 218, 21, 'PPL', 'P'),
(75212, 'Briartown', 35.2972183227539, 0.616052676527326, -95.2394409179688, -1.66224182177717, 218, 42, 'PPL', 'P'),
(19477, 'Briarwood', 34.223331451416, 0.597309814828539, -83.871940612793, -1.46384151373039, 218, 13, 'PPL', 'P'),
(29287, 'Briarwood', 39.5508308410645, 0.690292220075893, -86.5066680908203, -1.50982618311473, 218, 19, 'PPL', 'P'),
(34980, 'Briarwood', 38.2780609130859, 0.668078194212297, -85.5930633544922, -1.49388077240399, 218, 21, 'PPL', 'P'),
(45053, 'Briarwood', 39.0811080932617, 0.68209401155522, -76.8513870239258, -1.34130973829195, 218, 25, 'PPL', 'P'),
(79940, 'Briarwood', 34.0916709899902, 0.595011906281964, -80.920280456543, -1.4123253256039, 218, 48, 'PPL', 'P'),
(85297, 'Briarwood', 35.9083290100098, 0.626718570114066, -86.3083267211914, -1.50636447317179, 218, 50, 'PPL', 'P'),
(100168, 'Briarwood', 36.8658294677734, 0.643430105691395, -76.379997253418, -1.33308243473637, 218, 53, 'PPL', 'P'),
(118896, 'Briarwood', 41.9427795410156, 0.732039600428839, -89.1144409179688, -1.55534040509251, 218, 18, 'PPL', 'P'),
(139711, 'Briarwood', 46.7861099243164, 0.816571662379316, -96.7966690063477, -1.68942057912391, 218, 34, 'PPL', 'P'),
(200448, 'Briarwood', 45.4302787780762, 0.792907944776336, -122.659439086914, -2.14081107071608, 218, 43, 'PPL', 'P'),
(63144, 'Briarwood Acres', 35.0158309936523, 0.611141541161111, -80.5819396972656, -1.40642016536081, 218, 33, 'PPL', 'P'),
(124307, 'Briarwood Beach', 41.7374992370605, 0.728456783235328, -70.7416687011719, -1.23467503719047, 218, 23, 'PPL', 'P'),
(154443, 'Briarwood Beach (historical)', 41.0766716003418, 0.716923165186413, -81.8963928222656, -1.42936170025519, 218, 41, 'PPL', 'P'),
(180245, 'Briarwood Canyon', 38.6749992370605, 0.675006074893001, -121.013893127441, -2.11209087573039, 218, 6, 'PPL', 'P'),
(203133, 'Briarwood Condominium', 41.2408294677734, 0.719788260466147, -111.943893432617, -1.95378951790083, 218, 52, 'PPL', 'P'),
(39495, 'Briarwood Estates', 30.3697204589844, 0.530051614919561, -91.0361099243164, -1.58887985638681, 218, 22, 'PPL', 'P'),
(85299, 'Briarwood Estates', 36.0227813720703, 0.628716140668708, -83.9925003051758, -1.46594567730766, 218, 50, 'PPL', 'P'),
(45054, 'Briarwood Farms', 39.4816703796387, 0.689085142311814, -76.7225036621094, -1.33906029927722, 218, 25, 'PPL', 'P'),
(13429, 'Briarwood Manor', 38.7205581665039, 0.675801228215472, -75.3008270263672, -1.31424736108484, 218, 10, 'PPL', 'P'),
(34981, 'Briarwood Manor', 36.9861106872559, 0.645529408999677, -86.4113922119141, -1.50816330533009, 218, 21, 'PPL', 'P'),
(19482, 'Briarwood Park', 33.438060760498, 0.58360425575261, -84.4197235107422, -1.47340212888572, 218, 13, 'PPL', 'P'),
(203136, 'Briarwood Springs Condo', 40.6111106872559, 0.708797594384472, -111.873611450195, -1.95256286590274, 218, 52, 'PPL', 'P'),
(203137, 'Briarwood Springs Townhomes', 40.6124992370605, 0.708821829150392, -111.873611450195, -1.95256286590274, 218, 52, 'PPL', 'P'),
(63146, 'Briarwood Townhouses', 35.2949981689453, 0.616013927533466, -81.5238876342773, -1.42286025824403, 218, 33, 'PPL', 'P'),
(92818, 'Briary', 31.0444393157959, 0.541827680496214, -96.8916702270508, -1.6910786632186, 218, 51, 'PPL', 'P'),
(1124, 'Brice', 34.0944404602051, 0.595060242655749, -85.9719390869141, -1.50049340139066, 218, 2, 'PPL', 'P'),
(7673, 'Brice', 35.084171295166, 0.61233430443433, -90.2830581665039, -1.57573662377505, 218, 4, 'PPL', 'P'),
(19483, 'Brice', 34.1094398498535, 0.595322031390904, -85.1533279418945, -1.48620594161655, 218, 13, 'PPL', 'P'),
(45055, 'Brice', 38.5586090087891, 0.672974682192516, -76.9433288574219, -1.34291442600678, 218, 25, 'PPL', 'P'),
(63147, 'Brice', 35.1913909912109, 0.614205641153302, -81.8497161865234, -1.42854703927773, 218, 33, 'PPL', 'P'),
(71890, 'Brice', 39.9180603027344, 0.696701583292359, -82.8322219848633, -1.4456950003787, 218, 41, 'PPL', 'P'),
(122271, 'Brice', 40.4180603027344, 0.705428229552331, -84.8963928222656, -1.48172157781502, 218, 19, 'PPL', 'P'),
(129929, 'Brice', 43.1616706848145, 0.753313264111528, -84.7583312988281, -1.47931194966071, 218, 27, 'PPL', 'P'),
(191169, 'Brice', 34.7055587768555, 0.605726269400544, -100.89582824707, -1.76096440443808, 218, 51, 'PPL', 'P'),
(92819, 'Brice Lane Colonia', 29.2019996643066, 0.50967104230843, -99.7809982299805, -1.74150695003979, 218, 51, 'PPL', 'P'),
(45057, 'Brice Manor', 39.0072212219238, 0.680804442376377, -76.4805603027344, -1.33483759105279, 218, 25, 'PPL', 'P'),
(173287, 'Brice Prairie', 43.9386100769043, 0.766873414591939, -91.2997207641602, -1.59348073348603, 218, 57, 'PPL', 'P'),
(180246, 'Briceburg', 37.6049995422363, 0.656331057222984, -119.965827941895, -2.09379868746707, 218, 6, 'PPL', 'P'),
(193398, 'Briceland', 40.1080589294434, 0.700017684902699, -123.898887634277, -2.16244352877663, 218, 6, 'PPL', 'P'),
(134403, 'Bricelyn', 43.5622215270996, 0.76030419513104, -93.8116683959961, -1.63732249029924, 218, 28, 'PPL', 'P'),
(63148, 'Brices Creek', 35.0558280944824, 0.611839622261848, -77.0880584716797, -1.34544043430072, 218, 33, 'PPL', 'P'),
(63149, 'Brices Crossroads', 34.8186111450195, 0.607699405452184, -78.1016693115234, -1.3631312807899, 218, 33, 'PPL', 'P'),
(154444, 'Briceton', 41.0844383239746, 0.717058720085898, -84.6311111450195, -1.47709153910186, 218, 41, 'PPL', 'P'),
(85300, 'Briceville', 36.1783294677734, 0.631430967083934, -84.1852798461914, -1.46931031502887, 218, 50, 'PPL', 'P'),
(29288, 'Brick Chapel', 39.711669921875, 0.693099391601918, -86.8691711425781, -1.51615305491643, 218, 19, 'PPL', 'P'),
(85301, 'Brick Church', 35.2838897705078, 0.615820049406108, -86.9044418334961, -1.5167686446024, 218, 50, 'PPL', 'P'),
(159492, 'Brick Church', 40.6861114501953, 0.710106604639273, -79.4555587768555, -1.38676110966801, 218, 45, 'PPL', 'P'),
(79942, 'Brick House', 34.2777786254883, 0.598260097284507, -82.3261108398438, -1.43686169451707, 218, 48, 'PPL', 'P'),
(147357, 'Brick House Corners', 42.9930610656738, 0.75037047110699, -78.4061126708984, -1.36844481979682, 218, 40, 'PPL', 'P'),
(45061, 'Brick House Landing', 38.4283294677734, 0.670700875253807, -75.9583282470703, -1.32572292222199, 218, 25, 'PPL', 'P'),
(63154, 'Brick Landing', 33.9047203063965, 0.591749001314399, -78.392219543457, -1.36820233897957, 218, 33, 'PPL', 'P'),
(63150, 'Brick Landing Plantation', 33.9047203063965, 0.591749001314399, -78.392219543457, -1.36820233897957, 218, 33, 'PPL', 'P'),
(85302, 'Brick Mill', 35.6569404602051, 0.622331012218161, -84.1033325195313, -1.46788006436544, 218, 50, 'PPL', 'P'),
(143554, 'Brick School Corner', 42.9391708374023, 0.749429909189002, -70.9502792358398, -1.23831597787477, 218, 36, 'PPL', 'P'),
(13430, 'Brick Store', 39.3219413757324, 0.686297345282719, -75.5730590820313, -1.31899870678565, 218, 10, 'PPL', 'P'),
(147358, 'Brick Tavern', 42.2724990844727, 0.737794292070336, -73.7238922119141, -1.28672465648331, 218, 40, 'PPL', 'P'),
(159493, 'Brick Tavern', 40.4563903808594, 0.706097215618159, -75.3850021362305, -1.31571649390018, 218, 45, 'PPL', 'P'),
(45058, 'Brick Wall Landing', 38.9294395446777, 0.679446896010709, -75.8341674804688, -1.32355590804299, 218, 25, 'PPL', 'P'),
(191170, 'Brickel', 36.2874984741211, 0.633336325685831, -102.148063659668, -1.78282003539797, 218, 51, 'PPL', 'P'),
(15319, 'Brickell Hammock', 25.749719619751, 0.449417388830037, -80.204719543457, -1.39983643167197, 218, 12, 'PPL', 'P'),
(114699, 'Bricker', 40.5755615234375, 0.708177144429511, -91.4555587768555, -1.59620061990733, 218, 16, 'PPL', 'P'),
(159494, 'Bricker Crossroads', 40.7408294677734, 0.711061614206176, -79.7247161865234, -1.39145879267285, 218, 45, 'PPL', 'P'),
(159495, 'Brickerville', 40.225830078125, 0.702073179211049, -76.3027801513672, -1.33173474206673, 218, 45, 'PPL', 'P'),
(200449, 'Brickerville', 44.0658302307129, 0.769093825150792, -123.879722595215, -2.16210903574371, 218, 43, 'PPL', 'P'),
(126942, 'Brickett Place', 44.2675018310547, 0.772613658584523, -71.0047225952148, -1.23926619375171, 218, 26, 'PPL', 'P'),
(7674, 'Brickeys', 34.8605613708496, 0.608431575014874, -90.5922164916992, -1.58113245445966, 218, 4, 'PPL', 'P'),
(53649, 'Brickeys', 38.0844383239746, 0.664698842526068, -90.210563659668, -1.57447135594115, 218, 29, 'PPL', 'P'),
(63151, 'Brickhaven', 35.5747184753418, 0.620895967864772, -79.029167175293, -1.37931917231789, 218, 33, 'PPL', 'P'),
(19484, 'Brickhouse', 33.7750015258789, 0.589484981492696, -82.8108291625977, -1.44532162519387, 218, 13, 'PPL', 'P'),
(79944, 'Brickhouse Crossroads', 34.4536094665527, 0.601328924387632, -81.7038879394531, -1.42600185622394, 218, 48, 'PPL', 'P'),
(70565, 'Bricksboro', 39.3019409179688, 0.685948271442837, -74.978889465332, -1.30862849065893, 218, 37, 'PPL', 'P'),
(19486, 'Brickston', 31.6122207641602, 0.551737336201913, -81.4902801513672, -1.42227369701394, 218, 13, 'PPL', 'P'),
(15320, 'Brickton', 30.7336101531982, 0.536402688197668, -87.3213882446289, -1.52404573228105, 218, 12, 'PPL', 'P'),
(63152, 'Brickton', 35.4088897705078, 0.618001710971101, -82.5136108398438, -1.44013418686456, 218, 33, 'PPL', 'P'),
(134405, 'Brickton', 45.6072196960449, 0.795996146376391, -93.605827331543, -1.63372988598872, 218, 28, 'PPL', 'P'),
(141364, 'Brickton (historical)', 40.4833297729492, 0.706567396708612, -98.4208297729492, -1.71776753208283, 218, 35, 'PPL', 'P'),
(144893, 'Bricktown', 40.0591697692871, 0.699164408089437, -74.1374969482422, -1.29394342093407, 218, 37, 'PPL', 'P'),
(1126, 'Brickyard', 32.3983306884766, 0.565457542663837, -85.0100021362305, -1.48370443440463, 218, 2, 'PPL', 'P'),
(15321, 'Brickyard', 29.9624996185303, 0.522944270470898, -85.0219421386719, -1.48391282675993, 218, 12, 'PPL', 'P'),
(1128, 'Brickyard Junction', 33.4097213745117, 0.583109640159155, -86.9422225952148, -1.51742804328831, 218, 2, 'PPL', 'P'),
(100171, 'Brickyard Landing', 37.3705596923828, 0.652239309945159, -76.8794403076172, -1.34179936045836, 218, 53, 'PPL', 'P'),
(126943, 'Brickyard Landing (historical)', 43.1438903808594, 0.753002939265506, -70.6769409179688, -1.23354532425606, 218, 26, 'PPL', 'P'),
(200450, 'Bridal Veil', 45.5591697692871, 0.795157516949125, -122.174171447754, -2.13234155265935, 218, 43, 'PPL', 'P'),
(45059, 'Briddletown', 38.3347206115723, 0.66906709250407, -75.1952819824219, -1.31240525255883, 218, 25, 'PPL', 'P'),
(85303, 'Bride', 35.6002807617188, 0.621342113926387, -89.7227783203125, -1.56595789572644, 218, 50, 'PPL', 'P'),
(1127, 'Brides Hill', 34.670280456543, 0.605110546556518, -87.2441711425781, -1.52269803961141, 218, 2, 'PPL', 'P'),
(159496, 'Bridesburg', 40.0002784729004, 0.698136561066721, -75.0699996948242, -1.31021866414582, 218, 45, 'PPL', 'P'),
(45060, 'Bridewell (historical)', 39.1455612182617, 0.68321893079967, -76.7816696166992, -1.34009293998989, 218, 25, 'PPL', 'P'),
(194641, 'Bridge', 42.1294403076172, 0.735297445390333, -113.341667175293, -1.97818527190844, 218, 17, 'PPL', 'P'),
(200451, 'Bridge', 43.024169921875, 0.75091342307423, -124.005828857422, -2.16431000522661, 218, 43, 'PPL', 'P'),
(39496, 'Bridge City', 29.9330596923828, 0.522430446828081, -90.1699981689453, -1.57376335456535, 218, 22, 'PPL', 'P'),
(92820, 'Bridge City', 30.0205593109131, 0.523957603265673, -93.8455581665039, -1.63791397837735, 218, 51, 'PPL', 'P'),
(53650, 'Bridge Creek', 39.5722198486328, 0.690665528681695, -93.3844375610352, -1.62986590556313, 218, 29, 'PPL', 'P'),
(75213, 'Bridge Creek', 35.2350006103516, 0.614966772592846, -97.7363891601563, -1.70582178985522, 218, 42, 'PPL', 'P'),
(177724, 'Bridge House', 39.0433311462402, 0.681434679448344, -119.780281066895, -2.09056028358154, 218, 39, 'PPL', 'P'),
(39497, 'Bridge Junction', 30.2636108398438, 0.52819965269752, -93.1969375610352, -1.62659341321564, 218, 22, 'PPL', 'P'),
(45062, 'Bridge Point', 38.9722213745117, 0.68019357980134, -76.289436340332, -1.33150184862941, 218, 25, 'PPL', 'P'),
(159516, 'Bridge Point', 40.2830581665039, 0.703071997777883, -75.1305618286133, -1.31127567278247, 218, 45, 'PPL', 'P'),
(100172, 'Bridge Point Farms', 36.8480606079102, 0.643119980582456, -76.5491714477539, -1.33603508143694, 218, 53, 'PPL', 'P'),
(159497, 'Bridge Valley', 40.2794418334961, 0.703008880860048, -75.084716796875, -1.31047552603296, 218, 45, 'PPL', 'P'),
(45063, 'Bridge View', 39.0061111450195, 0.680785067879446, -76.3166732788086, -1.33197722288399, 218, 25, 'PPL', 'P'),
(19487, 'Bridgeboro', 31.4013900756836, 0.54805764652375, -83.9749984741211, -1.46564021273063, 218, 13, 'PPL', 'P'),
(144894, 'Bridgeboro', 40.0219383239746, 0.698514596783458, -74.9327774047852, -1.30782368337751, 218, 37, 'PPL', 'P'),
(159498, 'Bridgeburg', 40.8691711425781, 0.713301598999041, -79.4841690063477, -1.3872604523724, 218, 45, 'PPL', 'P'),
(147359, 'Bridgehampton', 40.9377784729004, 0.714499022804168, -72.3013916015625, -1.26189733722104, 218, 40, 'PPL', 'P'),
(180248, 'Bridgehaven', 38.4336090087891, 0.670793020627523, -123.099716186523, -2.14849535572539, 218, 6, 'PPL', 'P'),
(206889, 'Bridgehaven', 47.8344383239746, 0.834868444595515, -122.689437866211, -2.14133464818639, 218, 56, 'PPL', 'P'),
(1129, 'Bridgehead', 30.6677799224854, 0.535253733924381, -87.9111099243164, -1.53433831726198, 218, 2, 'PPL', 'P'),
(180249, 'Bridgehead', 38.0050010681152, 0.663312400862573, -121.754440307617, -2.12501586229082, 218, 6, 'PPL', 'P'),
(203139, 'Bridgeland', 40.1630592346191, 0.700977621317618, -110.233612060547, -1.92393947682267, 218, 52, 'PPL', 'P'),
(19488, 'Bridgeman', 32.8313903808594, 0.573015860153591, -83.5658264160156, -1.45849881310953, 218, 13, 'PPL', 'P'),
(134406, 'Bridgeman', 46.3838882446289, 0.809551569745867, -94.5802764892578, -1.65073723218413, 218, 28, 'PPL', 'P'),
(144895, 'Bridgepoint', 40.4324989318848, 0.70568023117048, -74.6488876342773, -1.30286887216942, 218, 37, 'PPL', 'P'),
(1130, 'Bridgeport', 34.9474983215332, 0.609948911045946, -85.7144393920898, -1.49599918389309, 218, 2, 'PPL', 'P'),
(15323, 'Bridgeport', 29.753059387207, 0.519288848848169, -81.5702819824219, -1.42366999237347, 218, 12, 'PPL', 'P'),
(19489, 'Bridgeport', 33.4613914489746, 0.584011453083283, -82.1044387817383, -1.43299278724345, 218, 13, 'PPL', 'P'),
(26604, 'Bridgeport', 38.7058296203613, 0.675544166591252, -87.7600021362305, -1.53170098883448, 218, 18, 'PPL', 'P'),
(29291, 'Bridgeport', 39.7322196960449, 0.693458052821724, -86.3172225952148, -1.50651973546334, 218, 19, 'PPL', 'P'),
(31888, 'Bridgeport', 38.6277809143066, 0.674181959693676, -97.6127777099609, -1.70366436305615, 218, 20, 'PPL', 'P'),
(34982, 'Bridgeport', 38.1599998474121, 0.666017639897875, -84.9511108398438, -1.48267658738192, 218, 21, 'PPL', 'P'),
(45065, 'Bridgeport', 39.642219543457, 0.691887253831769, -77.6783294677734, -1.35574260666158, 218, 25, 'PPL', 'P'),
(58783, 'Bridgeport', 31.8236103057861, 0.555426779707567, -90.0908279418945, -1.57238157343377, 218, 30, 'PPL', 'P'),
(70566, 'Bridgeport', 39.8008308410645, 0.694655543205879, -75.3477783203125, -1.31506681575226, 218, 37, 'PPL', 'P'),
(75214, 'Bridgeport', 35.5463905334473, 0.620401552008398, -98.3841705322266, -1.71712770763094, 218, 42, 'PPL', 'P'),
(85304, 'Bridgeport', 35.9530601501465, 0.627499275787623, -83.1172180175781, -1.45066911950469, 218, 50, 'PPL', 'P'),
(92821, 'Bridgeport', 33.2099990844727, 0.57962382860835, -97.7544403076172, -1.70613684181218, 218, 51, 'PPL', 'P'),
(100173, 'Bridgeport', 37.7097206115723, 0.658158784679106, -78.3341674804688, -1.36718913934285, 218, 53, 'PPL', 'P'),
(108357, 'Bridgeport', 39.2863883972168, 0.685676828748731, -80.2563934326172, -1.40073831117512, 218, 58, 'PPL', 'P'),
(113146, 'Bridgeport', 40.1561088562012, 0.700856314329965, -94.0650024414063, -1.64174400349904, 218, 29, 'PPL', 'P'),
(114702, 'Bridgeport', 40.7533302307129, 0.71127979367848, -93.2313919067383, -1.62719475498978, 218, 16, 'PPL', 'P'),
(129931, 'Bridgeport', 43.3594398498535, 0.75676498720038, -83.8816680908203, -1.46401129024988, 218, 27, 'PPL', 'P'),
(147361, 'Bridgeport', 42.915828704834, 0.749022512121247, -76.7527770996094, -1.33958867043749, 218, 40, 'PPL', 'P'),
(154447, 'Bridgeport', 40.1605606079102, 0.700934012054768, -83.3947219848633, -1.45551247742117, 218, 41, 'PPL', 'P'),
(159504, 'Bridgeport', 40.1291694641113, 0.700386133239511, -79.5327835083008, -1.3881089354957, 218, 45, 'PPL', 'P'),
(173288, 'Bridgeport', 43.0091705322266, 0.750651634339075, -91.0577774047852, -1.5892580252616, 218, 57, 'PPL', 'P'),
(177526, 'Bridgeport', 41.1669387817383, 0.718498624708276, -73.2052764892578, -1.27767310457034, 218, 8, 'PPL', 'P'),
(177786, 'Bridgeport', 34.7213897705078, 0.60600257236364, -111.995826721191, -1.95469592477784, 218, 5, 'PPL', 'P'),
(180252, 'Bridgeport', 39.2916717529297, 0.685769040701475, -121.19361114502, -2.11522754686229, 218, 6, 'PPL', 'P'),
(186447, 'Bridgeport', 38.836669921875, 0.677827760646968, -108.379997253418, -1.89158779537455, 218, 7, 'PPL', 'P'),
(199200, 'Bridgeport', 41.6652793884277, 0.727196309091393, -103.098609924316, -1.79941019740862, 218, 35, 'PPL', 'P'),
(200452, 'Bridgeport', 44.8486099243164, 0.782755908121926, -123.385276794434, -2.15347932854742, 218, 43, 'PPL', 'P'),
(206890, 'Bridgeport', 48.0083312988281, 0.837903449552797, -119.669998168945, -2.08863548390368, 218, 56, 'PPL', 'P'),
(7676, 'Bridgeport (historical)', 36.1111106872559, 0.630257778044727, -91.4491729736328, -1.59608916661571, 218, 4, 'PPL', 'P'),
(118898, 'Bridgeport (historical)', 40.7433280944824, 0.711105223469026, -90.2369384765625, -1.57493168333557, 218, 18, 'PPL', 'P'),
(169289, 'Bridgeport (historical)', 41.6166687011719, 0.726347892547121, -71.210563659668, -1.24285879806223, 218, 47, 'PPL', 'P'),
(1131, 'Bridgeport Landing', 32.0405616760254, 0.559213295434956, -87.2744369506836, -1.52322627761363, 218, 2, 'PPL', 'P'),
(193221, 'Bridger', 44.5458297729492, 0.777471397570882, -101.910827636719, -1.77867948569317, 218, 49, 'PPL', 'P'),
(196078, 'Bridger', 45.2958297729492, 0.790561366960839, -108.913063049316, -1.90089154864275, 218, 31, 'PPL', 'P'),
(209327, 'Bridger', 41.3813896179199, 0.722241497883301, -110.593887329102, -1.93022746647246, 218, 59, 'PPL', 'P'),
(19490, 'Bridger Point', 33.4127807617188, 0.583163036539011, -84.5127792358398, -1.4750262576765, 218, 13, 'PPL', 'P'),
(196079, 'Bridger View Trailer Court', 45.7027816772461, 0.797664017588081, -111.02082824707, -1.9376789912025, 218, 31, 'PPL', 'P'),
(63155, 'Bridgersville', 35.7561111450195, 0.624061867189631, -77.7516708374023, -1.35702265503953, 218, 33, 'PPL', 'P'),
(15324, 'Bridges', 27.4083309173584, 0.478365616984062, -81.9069366455078, -1.42954572468651, 218, 12, 'PPL', 'P'),
(19491, 'Bridges', 31.8527793884277, 0.55593587623945, -83.8652801513672, -1.46372526674881, 218, 13, 'PPL', 'P'),
(58782, 'Bridges', 31.2027797698975, 0.544591242759389, -90.2502822875977, -1.5751645767729, 218, 30, 'PPL', 'P'),
(71892, 'Bridges', 39.3047218322754, 0.685996807553704, -83.5227813720703, -1.45774753536601, 218, 41, 'PPL', 'P'),
(92822, 'Bridges Chapel', 33.2608604431152, 0.580511526778701, -95.0466918945313, -1.65887771668818, 218, 51, 'PPL', 'P'),
(19492, 'Bridges Crossroad', 31.7658290863037, 0.554418307181782, -84.353889465332, -1.4722531080334, 218, 13, 'PPL', 'P'),
(39499, 'Bridges Mill', 32.5944404602051, 0.568880303875834, -92.982780456543, -1.62285566662571, 218, 22, 'PPL', 'P'),
(186448, 'Bridges Switch', 39.0986099243164, 0.682399476132252, -108.403327941895, -1.89199499270523, 218, 7, 'PPL', 'P'),
(1132, 'Bridgeton', 33.4438896179199, 0.583705988506251, -86.6575012207031, -1.51245871785227, 218, 2, 'PPL', 'P'),
(29290, 'Bridgeton', 39.6450004577637, 0.691935789942635, -87.1774978637695, -1.5215343713731, 218, 19, 'PPL', 'P'),
(53654, 'Bridgeton', 38.7669410705566, 0.676610762607829, -90.4113922119141, -1.57797647540986, 218, 29, 'PPL', 'P'),
(63156, 'Bridgeton', 35.1213912963867, 0.612983916003228, -77.021110534668, -1.34427197237245, 218, 33, 'PPL', 'P'),
(70574, 'Bridgeton', 39.4272193908691, 0.68813479327682, -75.2344436645508, -1.3130887528526, 218, 37, 'PPL', 'P'),
(77913, 'Bridgeton', 39.790828704834, 0.694480972996424, -76.4208297729492, -1.33379509664407, 218, 45, 'PPL', 'P'),
(129933, 'Bridgeton', 43.3466682434082, 0.75654208061714, -85.9372177124023, -1.49988739908461, 218, 27, 'PPL', 'P'),
(169290, 'Bridgeton', 41.9655609130859, 0.732437210379588, -71.7055587768555, -1.25149809263845, 218, 47, 'PPL', 'P'),
(70567, 'Bridgeton Junction', 39.4527816772461, 0.688580939338435, -75.2130584716797, -1.31271551082582, 218, 37, 'PPL', 'P'),
(53655, 'Bridgeton Terrace', 38.7463912963867, 0.676252101388022, -90.3863906860352, -1.57754011646525, 218, 29, 'PPL', 'P'),
(19493, 'Bridgetown', 31.4363899230957, 0.548668509098787, -83.0566711425781, -1.44961237718415, 218, 13, 'PPL', 'P'),
(45066, 'Bridgetown', 39.0344390869141, 0.681279483735819, -75.8744430541992, -1.32425884941272, 218, 25, 'PPL', 'P'),
(71893, 'Bridgetown', 39.1530609130859, 0.683349825167247, -84.6372222900391, -1.47719819870352, 218, 41, 'PPL', 'P'),
(100174, 'Bridgetown', 37.4455604553223, 0.653548320199961, -75.9266662597656, -1.3251703162958, 218, 53, 'PPL', 'P'),
(159509, 'Bridgetown', 40.184440612793, 0.701350796765365, -74.9550018310547, -1.30821157279028, 218, 45, 'PPL', 'P'),
(169291, 'Bridgetown', 41.4872207641602, 0.724088599836353, -71.445556640625, -1.24696019929901, 218, 47, 'PPL', 'P'),
(100175, 'Bridgetown (historical)', 37.8102798461914, 0.659913874416495, -76.5427780151367, -1.33592349498727, 218, 53, 'PPL', 'P'),
(118900, 'Bridgeview', 41.75, 0.728674962707633, -87.8041687011719, -1.532471840812, 218, 18, 'PPL', 'P'),
(200453, 'Bridgeview', 42.1261100769043, 0.735239321899542, -123.604721069336, -2.15730935366912, 218, 43, 'PPL', 'P'),
(1134, 'Bridgeville', 33.1047210693359, 0.57778638061425, -88.1419372558594, -1.538367014201, 218, 2, 'PPL', 'P'),
(13431, 'Bridgeville', 38.7425003051758, 0.676184190780225, -75.6047210693359, -1.31955131271184, 218, 10, 'PPL', 'P'),
(34983, 'Bridgeville', 38.5950012207031, 0.6736098461125, -84.0199966430664, -1.46642557893609, 218, 21, 'PPL', 'P'),
(71894, 'Bridgeville', 39.9694404602051, 0.697598336210416, -81.8677825927734, -1.4288623575508, 218, 41, 'PPL', 'P'),
(129935, 'Bridgeville', 43.1358299255371, 0.752862257780923, -84.5927810668945, -1.47642255303603, 218, 27, 'PPL', 'P'),
(144896, 'Bridgeville', 40.836669921875, 0.712734345686854, -75.0263900756836, -1.30945753270628, 218, 37, 'PPL', 'P'),
(147362, 'Bridgeville', 41.6341705322266, 0.726653357124153, -74.6194381713867, -1.30235488207903, 218, 40, 'PPL', 'P'),
(159510, 'Bridgeville', 40.3561096191406, 0.704346986149759, -80.1102828979492, -1.39818820127332, 218, 45, 'PPL', 'P'),
(193399, 'Bridgeville', 40.4694404602051, 0.706324982470388, -123.798606872559, -2.16069329930823, 218, 6, 'PPL', 'P'),
(13432, 'Bridgeville Manor', 38.7333297729492, 0.676024134798712, -75.595832824707, -1.31939618357834, 218, 10, 'PPL', 'P'),
(13433, 'Bridgeville North', 38.7541694641113, 0.676387856024589, -75.5963897705078, -1.31940590411632, 218, 10, 'PPL', 'P'),
(19494, 'Bridgewater', 33.8883285522461, 0.591462911234298, -84.0266723632813, -1.46654209223378, 218, 13, 'PPL', 'P'),
(63157, 'Bridgewater', 35.7113914489746, 0.623281361253155, -81.8627777099609, -1.42877500586704, 218, 33, 'PPL', 'P'),
(79946, 'Bridgewater', 34.5180587768555, 0.602453777053055, -82.7816696166992, -1.44481269510955, 218, 48, 'PPL', 'P'),
(100176, 'Bridgewater', 38.3819389343262, 0.669891207703395, -78.976936340332, -1.37840757227675, 218, 53, 'PPL', 'P'),
(114703, 'Bridgewater', 41.2449989318848, 0.719861031342934, -94.6686096191406, -1.65227893613918, 218, 16, 'PPL', 'P'),
(124308, 'Bridgewater', 41.9902801513672, 0.73286864247618, -70.9755630493164, -1.2387572636674, 218, 23, 'PPL', 'P'),
(126944, 'Bridgewater', 46.4277801513672, 0.810317628033429, -67.8438873291016, -1.18409921124488, 218, 26, 'PPL', 'P'),
(129936, 'Bridgewater', 42.160831451416, 0.735845324205589, -83.9022216796875, -1.46437001804871, 218, 27, 'PPL', 'P'),
(143555, 'Bridgewater', 43.6383285522461, 0.761632513303745, -71.7369384765625, -1.25204577171662, 218, 36, 'PPL', 'P'),
(147363, 'Bridgewater', 42.8791694641113, 0.748382687669355, -75.2513885498047, -1.31338449689165, 218, 40, 'PPL', 'P'),
(154448, 'Bridgewater', 40.8286094665527, 0.712593664202271, -80.9894409179688, -1.41353240336797, 218, 41, 'PPL', 'P'),
(159513, 'Bridgewater', 40.0977783203125, 0.699838254424255, -74.9197235107422, -1.30759584994626, 218, 45, 'PPL', 'P'),
(169895, 'Bridgewater', 43.5516700744629, 0.760120037541661, -97.5072174072266, -1.70182198821403, 218, 49, 'PPL', 'P'),
(171777, 'Bridgewater', 43.5880584716797, 0.760755134882618, -72.6255569458008, -1.26755508979886, 218, 55, 'PPL', 'P'),
(177529, 'Bridgewater', 41.5349998474121, 0.724922502152684, -73.3666687011719, -1.28048993005532, 218, 8, 'PPL', 'P'),
(154449, 'Bridgewater Center', 41.6580581665039, 0.727070274992805, -84.6308288574219, -1.47708661225384, 218, 41, 'PPL', 'P'),
(171778, 'Bridgewater Center', 43.6163902282715, 0.761249617318019, -72.6597213745117, -1.26815137156693, 218, 55, 'PPL', 'P'),
(126945, 'Bridgewater Corner', 46.4511108398438, 0.810724825364102, -67.8522186279297, -1.1842446198404, 218, 26, 'PPL', 'P'),
(171779, 'Bridgewater Corners', 43.5883293151855, 0.760759861993553, -72.6563873291016, -1.26809318149711, 218, 55, 'PPL', 'P'),
(108358, 'Bridgeway', 39.4866714477539, 0.689172427416542, -80.9072189331055, -1.41209735901458, 218, 58, 'PPL', 'P'),
(118901, 'Bridgeway Addition', 41.473331451416, 0.723846185598128, -90.5041732788086, -1.57959581051068, 218, 18, 'PPL', 'P'),
(19495, 'Bridgewood', 33.5602798461914, 0.585737381206736, -84.2172164916992, -1.46986771464502, 218, 13, 'PPL', 'P'),
(203140, 'Bridgewood Manor Condominium', 41.1147193908691, 0.717587224404224, -112.024169921875, -1.95519060695032, 218, 52, 'PPL', 'P'),
(129938, 'Bridgman', 41.9430618286133, 0.732044527276855, -86.5569381713867, -1.51070356153586, 218, 27, 'PPL', 'P'),
(126947, 'Bridgton', 44.0547218322754, 0.768899947023435, -70.7133331298828, -1.23418048817604, 218, 26, 'PPL', 'P'),
(100179, 'Bridle Creek', 36.6188888549805, 0.639120178941265, -81.2436065673828, -1.41796843079572, 218, 53, 'PPL', 'P'),
(15325, 'Bridle Path Acres', 30.5088901519775, 0.532480584281281, -84.2624969482422, -1.4706580076985, 218, 12, 'PPL', 'P'),
(200454, 'Bridlemile', 45.4933280944824, 0.794008362938756, -122.709167480469, -2.14167899491533, 218, 43, 'PPL', 'P'),
(45068, 'Bridleshire', 39.4022216796875, 0.687698500911237, -76.6597213745117, -1.3379645416467, 218, 25, 'PPL', 'P'),
(13434, 'Bridleshire Farms', 39.7638893127441, 0.69401079190597, -75.7305603027344, -1.32174762166283, 218, 10, 'PPL', 'P'),
(39498, 'Bridlewood', 30.5716705322266, 0.533576308622281, -91.0116729736328, -1.58845335113823, 218, 22, 'PPL', 'P'),
(45069, 'Bridlewood', 39.4236106872559, 0.688071809517039, -76.6127777099609, -1.33714522013734, 218, 25, 'PPL', 'P'),
(79947, 'Bridlewood', 34.5805587768555, 0.603544607835551, -82.7019424438477, -1.44342119343999, 218, 48, 'PPL', 'P'),
(100178, 'Bridlewood', 37.2088890075684, 0.649417624191193, -80.0316696166992, -1.39681614067971, 218, 53, 'PPL', 'P'),
(1136, 'Bridlewood Forest Estates', 33.6300010681152, 0.586954246087821, -86.6952819824219, -1.51311811653818, 218, 2, 'PPL', 'P'),
(85305, 'Bridwell Heights', 36.5483283996582, 0.637888666674186, -82.4558334350586, -1.4391257809178, 218, 50, 'PPL', 'P'),
(63158, 'Brief', 35.189998626709, 0.614181339808355, -80.5336074829102, -1.40557660908553, 218, 33, 'PPL', 'P'),
(144898, 'Brielle', 40.107780456543, 0.700012824633709, -74.0569381713867, -1.29253740503657, 218, 37, 'PPL', 'P'),
(34984, 'Brien', 36.9047203063965, 0.644108878874229, -88.2302780151367, -1.5399088513141, 218, 21, 'PPL', 'P'),
(34985, 'Briensburg', 36.9036102294922, 0.644089504377299, -88.3236083984375, -1.54153777379485, 218, 21, 'PPL', 'P'),
(124310, 'Brier', 42.5894393920898, 0.74332594397054, -72.9944381713867, -1.27399328173413, 218, 23, 'PPL', 'P'),
(206891, 'Brier', 47.7847213745117, 0.83400072013334, -122.273063659668, -2.13406754736183, 218, 56, 'PPL', 'P'),
(63160, 'Brier Creek (historical)', 36.1936111450195, 0.631697682667106, -80.9980621337891, -1.41368287196956, 218, 33, 'PPL', 'P'),
(19496, 'Brier Creek Landing', 32.7819404602051, 0.572152796223324, -81.4316711425781, -1.42125077683924, 218, 13, 'PPL', 'P'),
(77916, 'Brier Hill', 39.980281829834, 0.697787553805866, -79.8283309936523, -1.39326721221107, 218, 45, 'PPL', 'P'),
(85306, 'Brier Hill', 35.3636093139648, 0.61721141791762, -87.3663864135742, -1.52483109848651, 218, 50, 'PPL', 'P'),
(147367, 'Brier Hill', 44.5313911437988, 0.777219395952733, -75.6630630493164, -1.32056957235463, 218, 40, 'PPL', 'P'),
(154451, 'Brier Hill', 41.1216697692871, 0.717708531391877, -80.6691665649414, -1.40794256139795, 218, 41, 'PPL', 'P'),
(206892, 'Briercrest', 47.7338905334473, 0.833113554595207, -122.286666870117, -2.13430496817301, 218, 56, 'PPL', 'P'),
(45071, 'Briercrest Heights', 39.3680610656738, 0.687102285722196, -77.5352783203125, -1.35324589313963, 218, 25, 'PPL', 'P'),
(1137, 'Brierfield', 33.038890838623, 0.576637426340963, -86.9088897705078, -1.51684627574818, 218, 2, 'PPL', 'P'),
(118903, 'Briergate', 42.1761093139648, 0.736111973209733, -87.8147201538086, -1.53265599840138, 218, 18, 'PPL', 'P'),
(45072, 'Brierleigh', 39.4361114501953, 0.688289988989344, -76.6636123657227, -1.3380324522545, 218, 25, 'PPL', 'P'),
(63161, 'Briertown', 35.2622184753418, 0.615441813952289, -83.6125030517578, -1.45931347408698, 218, 33, 'PPL', 'P'),
(45074, 'Brierwood', 39.478889465332, 0.689036606200948, -76.3547210693359, -1.3326412821018, 218, 25, 'PPL', 'P'),
(108359, 'Brierwood', 39.336669921875, 0.686554406906939, -81.4369430541992, -1.4213427890549, 218, 58, 'PPL', 'P'),
(122278, 'Brierwood Hills', 41.0552787780762, 0.716549790001584, -85.2341690063477, -1.48761688436207, 218, 19, 'PPL', 'P'),
(100180, 'Briery', 37.0913887023926, 0.647366856993778, -78.4580612182617, -1.36935149298994, 218, 53, 'PPL', 'P'),
(100181, 'Briery Branch', 38.435001373291, 0.67081732197247, -79.079719543457, -1.38020147758703, 218, 53, 'PPL', 'P'),
(34986, 'Brigadoon', 37.9866714477539, 0.662992488636627, -84.5180587768555, -1.47511840305022, 218, 21, 'PPL', 'P'),
(45075, 'Brigadoon', 39.2980613708496, 0.685880560572122, -76.73388671875, -1.33925897109454, 218, 25, 'PPL', 'P'),
(124311, 'Brigadoon Village', 42.5847206115723, 0.743243585713829, -71.0152816772461, -1.23945048449915, 218, 23, 'PPL', 'P'),
(70569, 'Brigantine', 39.4099998474121, 0.687834255547804, -74.3649978637695, -1.29791406096133, 218, 37, 'PPL', 'P'),
(71895, 'Brigglesville', 39.7566719055176, 0.69388482438641, -82.0880584716797, -1.43270689690044, 218, 41, 'PPL', 'P'),
(71896, 'Briggs', 39.3255615234375, 0.686360528779582, -81.0608291625977, -1.41477836328397, 218, 41, 'PPL', 'P'),
(75216, 'Briggs', 35.9269409179688, 0.627043409188029, -94.8744430541992, -1.65587140729164, 218, 42, 'PPL', 'P'),
(92823, 'Briggs', 30.889440536499, 0.539122441460912, -97.9247207641602, -1.70910879643065, 218, 51, 'PPL', 'P'),
(100182, 'Briggs', 39.107780456543, 0.682559532113766, -78.0141677856445, -1.36160409106279, 218, 53, 'PPL', 'P'),
(122272, 'Briggs', 41.0855598449707, 0.71707829431991, -85.4702835083008, -1.49173785983286, 218, 19, 'PPL', 'P'),
(141365, 'Briggs', 41.3502807617188, 0.721698545916061, -96.0074996948242, -1.67564697628213, 218, 35, 'PPL', 'P'),
(147365, 'Briggs', 44.1650009155273, 0.770824680122262, -75.1374969482422, -1.31139671345402, 218, 40, 'PPL', 'P'),
(177788, 'Briggs', 34.0608291625977, 0.594473614846632, -112.474998474121, -1.96305904954901, 218, 5, 'PPL', 'P'),
(85307, 'Briggs (historical)', 36.0155601501465, 0.628590106570119, -82.5902786254883, -1.44147229215427, 218, 50, 'PPL', 'P'),
(124312, 'Briggs Corner', 41.9124984741211, 0.731511096110512, -71.2597198486328, -1.2437167354074, 218, 23, 'PPL', 'P'),
(126949, 'Briggs Corner', 43.1005592346191, 0.752246668094951, -70.7125015258789, -1.2341659739481, 218, 26, 'PPL', 'P'),
(147366, 'Briggs Corner', 43.874439239502, 0.765753422195506, -75.5361099243164, -1.31835382232769, 218, 40, 'PPL', 'P'),
(147368, 'Briggs Hollow', 42.0175018310547, 0.733343750414651, -76.3063888549805, -1.33179772582652, 218, 40, 'PPL', 'P'),
(134408, 'Briggs Lake', 45.5086097717285, 0.794275078521928, -93.9358291625977, -1.63948950447824, 218, 28, 'PPL', 'P'),
(26610, 'Briggs Landing', 39.9902801513672, 0.697962057436294, -90.5177764892578, -1.57983323132186, 218, 18, 'PPL', 'P'),
(188183, 'Briggs Place', 35.1133308410645, 0.612843234518644, -106.173889160156, -1.85308394549224, 218, 38, 'PPL', 'P'),
(177652, 'Briggs Terrace', 34.2408294677734, 0.597615212826544, -118.225830078125, -2.06342999576663, 218, 6, 'PPL', 'P'),
(71897, 'Briggsdale', 39.9258308410645, 0.696837204770872, -83.0583267211914, -1.44964127248198, 218, 41, 'PPL', 'P'),
(194118, 'Briggsdale', 40.6347198486328, 0.709209651984134, -104.326393127441, -1.82083905680384, 218, 7, 'PPL', 'P'),
(19498, 'Briggston', 30.7213897705078, 0.536189402283866, -83.3058319091797, -1.45396105292814, 218, 13, 'PPL', 'P'),
(180253, 'Briggston (historical)', 38.5313911437988, 0.672499640833073, -121.747779846191, -2.12489961530924, 218, 6, 'PPL', 'P'),
(7677, 'Briggsville', 34.9338912963867, 0.609711423655738, -93.4941711425781, -1.63178111786106, 218, 4, 'PPL', 'P'),
(124313, 'Briggsville', 42.7163887023926, 0.745541627418459, -73.0808334350586, -1.27550116354333, 218, 23, 'PPL', 'P'),
(159517, 'Briggsville', 41.040828704834, 0.716297588646353, -76.1377792358398, -1.32885493282198, 218, 45, 'PPL', 'P'),
(173290, 'Briggsville', 43.6549987792969, 0.761923463652836, -89.5852813720703, -1.56355812126817, 218, 57, 'PPL', 'P'),
(203145, 'Brigham City', 41.5102806091309, 0.724491070056091, -112.014717102051, -1.95502562412079, 218, 52, 'PPL', 'P'),
(177789, 'Brigham City (historical)', 35.0416717529297, 0.611592547491716, -110.650001525879, -1.93120684396334, 218, 5, 'PPL', 'P'),
(126950, 'Brighams Cove', 43.8394393920898, 0.765142559620469, -69.8483276367188, -1.21908329427249, 218, 26, 'PPL', 'P'),
(7679, 'Bright', 33.4194412231445, 0.583279283520593, -93.3188934326172, -1.62872194471688, 218, 4, 'PPL', 'P'),
(29292, 'Bright', 39.2183303833008, 0.684488992323528, -84.8561096191406, -1.48101850328724, 218, 19, 'PPL', 'P'),
(58785, 'Bright', 34.8469390869141, 0.608193821308557, -89.920280456543, -1.56940495828338, 218, 30, 'PPL', 'P'),
(108360, 'Bright', 38.6258316040039, 0.674147937810751, -81.2347183227539, -1.41781330166222, 218, 58, 'PPL', 'P'),
(173292, 'Bright', 44.8861083984375, 0.783410379959813, -90.5319366455078, -1.58008037267102, 218, 57, 'PPL', 'P'),
(71898, 'Bright (historical)', 39.8652801513672, 0.695780395871301, -82.9222183227539, -1.44726573278963, 218, 41, 'PPL', 'P'),
(85308, 'Bright (historical)', 36.2811088562012, 0.633224805815184, -83.2383270263672, -1.45278287046189, 218, 50, 'PPL', 'P'),
(45077, 'Bright Acres Mobile Home Park', 38.6897201538086, 0.675263003359167, -76.6397171020508, -1.33761540122779, 218, 25, 'PPL', 'P'),
(58786, 'Bright Corner', 33.5547218322754, 0.58564037556403, -90.1172180175781, -1.5728421671443, 218, 30, 'PPL', 'P'),
(85311, 'Bright Hope', 36.0952796936035, 0.629981475081631, -82.9713897705078, -1.4481239364509, 218, 50, 'PPL', 'P'),
(45078, 'Bright Oaks', 39.5027809143066, 0.689453590648627, -76.3191680908203, -1.33202076556781, 218, 25, 'PPL', 'P'),
(1138, 'Bright Star', 34.1602783203125, 0.596209330087091, -86.4302825927734, -1.50849300467304, 218, 2, 'PPL', 'P'),
(19499, 'Bright Star', 33.7033309936523, 0.588234094728685, -84.7919387817383, -1.4798985108908, 218, 13, 'PPL', 'P'),
(92824, 'Bright Star', 32.8327789306641, 0.573040094919511, -95.6741714477539, -1.66982930088086, 218, 51, 'PPL', 'P'),
(45079, 'Brightfield', 39.2130584716797, 0.684396980107866, -76.7855606079102, -1.34016085059769, 218, 25, 'PPL', 'P'),
(212, 'Brighton', 33.4341697692871, 0.583536345144813, -86.9472198486328, -1.51751526181401, 218, 2, 'PPL', 'P'),
(412, 'Brighton', 31.5025005340576, 0.549822356930577, -83.4561080932617, -1.4565838671277, 218, 13, 'PPL', 'P'),
(7680, 'Brighton', 36.0675010681152, 0.629496646605182, -90.3561096191406, -1.57701161214692, 218, 4, 'PPL', 'P'),
(15327, 'Brighton', 27.2255592346191, 0.475175649340851, -81.0952835083008, -1.41537970505811, 218, 12, 'PPL', 'P'),
(26607, 'Brighton', 39.0397186279297, 0.681371629109536, -90.1405563354492, -1.57324949763302, 218, 18, 'PPL', 'P'),
(34987, 'Brighton', 38.0138893127441, 0.66346752999607, -84.4197235107422, -1.47340212888572, 218, 21, 'PPL', 'P'),
(45081, 'Brighton', 39.1927795410156, 0.684043045998995, -77.0266723632813, -1.34436904459418, 218, 25, 'PPL', 'P'),
(53656, 'Brighton', 37.4577789306641, 0.653761572824249, -93.3477783203125, -1.62922608111124, 218, 29, 'PPL', 'P'),
(58787, 'Brighton', 33.4786109924316, 0.584311990812299, -91.0044403076172, -1.58832711730256, 218, 30, 'PPL', 'P'),
(79950, 'Brighton', 32.6124992370605, 0.569195488990845, -81.2738876342773, -1.41849693511404, 218, 48, 'PPL', 'P'),
(85310, 'Brighton', 35.4838905334473, 0.619310721225902, -89.7249984741211, -1.5659966447203, 218, 50, 'PPL', 'P'),
(108361, 'Brighton', 38.7997207641602, 0.677182876189005, -82.0405578613281, -1.43187785485309, 218, 58, 'PPL', 'P'),
(114704, 'Brighton', 41.1747207641602, 0.71863444592387, -91.8194427490234, -1.60255159331689, 218, 16, 'PPL', 'P'),
(122273, 'Brighton', 41.7222213745117, 0.728190134231184, -85.3111114501953, -1.48895978334174, 218, 19, 'PPL', 'P'),
(124314, 'Brighton', 42.3499984741211, 0.739146911587988, -71.1569366455078, -1.24192283009712, 218, 23, 'PPL', 'P'),
(126951, 'Brighton', 45.045280456543, 0.786188456450929, -69.6952819824219, -1.21641214369914, 218, 26, 'PPL', 'P'),
(129940, 'Brighton', 42.5294418334961, 0.742278789029921, -83.7802810668945, -1.46224175286358, 218, 27, 'PPL', 'P'),
(144900, 'Brighton', 40.9850006103516, 0.71532320458252, -74.7638931274414, -1.30487609668301, 218, 37, 'PPL', 'P'),
(147371, 'Brighton', 42.8677787780762, 0.748183882693981, -75.029167175293, -1.30950600223812, 218, 40, 'PPL', 'P'),
(154452, 'Brighton', 41.1708297729492, 0.718566535316073, -82.3097229003906, -1.43657567101599, 218, 41, 'PPL', 'P'),
(173293, 'Brighton', 42.6291694641113, 0.744019364539369, -88.0997161865234, -1.53763011752738, 218, 57, 'PPL', 'P'),
(180254, 'Brighton', 38.5494384765625, 0.672814626211003, -121.416107177734, -2.11911083520579, 218, 6, 'PPL', 'P'),
(186450, 'Brighton', 39.985279083252, 0.697874772331566, -104.819999694824, -1.82945411661413, 218, 7, 'PPL', 'P'),
(200456, 'Brighton', 45.6725006103516, 0.797135513269755, -123.921669006348, -2.16284113872738, 218, 43, 'PPL', 'P'),
(203146, 'Brighton', 40.603889465332, 0.708671560285884, -111.581390380859, -1.94746264609913, 218, 52, 'PPL', 'P'),
(206893, 'Brighton', 47.5463905334473, 0.829841062247718, -122.274436950684, -2.13409151581164, 218, 56, 'PPL', 'P'),
(70571, 'Brighton At Barnegat Mobile Home Park', 39.7605590820313, 0.693952668415179, -74.3222198486328, -1.29716744374972, 218, 37, 'PPL', 'P'),
(70572, 'Brighton Beach', 39.6063919067383, 0.691261943607818, -74.2083282470703, -1.29517966031209, 218, 37, 'PPL', 'P'),
(79951, 'Brighton Beach', 32.2152786254883, 0.562262681462124, -80.8486099243164, -1.41107443883988, 218, 48, 'PPL', 'P'),
(147372, 'Brighton Beach', 40.5777816772461, 0.708215893423371, -73.9599990844727, -1.29084549879604, 218, 40, 'PPL', 'P'),
(173294, 'Brighton Beach', 44.2033309936523, 0.77149366618809, -88.4205627441406, -1.54322994635149, 218, 57, 'PPL', 'P'),
(71901, 'Brighton Corner', 39.1222190856934, 0.682811533731915, -84.5336074829102, -1.4753897791653, 218, 41, 'PPL', 'P'),
(126952, 'Brighton Corner', 43.666389465332, 0.76212226862821, -70.29638671875, -1.2269034004974, 218, 26, 'PPL', 'P'),
(45082, 'Brighton Estates', 39.1847190856934, 0.683902364514411, -77.0152816772461, -1.34417023961881, 218, 25, 'PPL', 'P'),
(45083, 'Brighton Farm Estates', 39.202220916748, 0.684207829091443, -76.9861068725586, -1.34366104321838, 218, 25, 'PPL', 'P'),
(100183, 'Brighton Green', 37.5041694641113, 0.65457124037466, -77.5641708374023, -1.35375016269204, 218, 53, 'PPL', 'P'),
(19500, 'Brighton Heights', 33.0525016784668, 0.576874980310198, -83.9527816772461, -1.46525245647591, 218, 13, 'PPL', 'P'),
(203148, 'Brighton Hills', 40.6133308410645, 0.708836343378333, -111.806938171387, -1.95139919766443, 218, 52, 'PPL', 'P'),
(45084, 'Brighton Knolls', 39.1861114501953, 0.683926665859358, -77.0208282470703, -1.34426704552443, 218, 25, 'PPL', 'P'),
(19501, 'Brighton Mills', 33.0513916015625, 0.576855605813267, -83.95361328125, -1.46526697070385, 218, 13, 'PPL', 'P'),
(45085, 'Brighton Pines', 39.2083282470703, 0.684314422114074, -76.9908294677734, -1.34374346805412, 218, 25, 'PPL', 'P'),
(177790, 'Brighton Place', 33.3380584716797, 0.581858886553199, -111.863059997559, -1.95237870831336, 218, 5, 'PPL', 'P'),
(203149, 'Brighton Place Condo', 40.6141700744629, 0.708850990764328, -111.82861328125, -1.95177749969727, 218, 52, 'PPL', 'P'),
(203150, 'Brighton Point', 40.6144409179688, 0.708855717875263, -111.792503356934, -1.9511472626253, 218, 52, 'PPL', 'P'),
(203151, 'Brighton Ridge', 40.6175003051758, 0.708909114255119, -111.837501525879, -1.95193262883077, 218, 52, 'PPL', 'P'),
(203152, 'Brighton View', 40.6122207641602, 0.708816968881402, -111.820556640625, -1.95163688479172, 218, 52, 'PPL', 'P'),
(45086, 'Brighton Woods', 38.6505584716797, 0.674579503065398, -76.6036071777344, -1.33698516415583, 218, 25, 'PPL', 'P'),
(100184, 'Brights', 37.0286102294922, 0.646271165942292, -79.432502746582, -1.3863587060273, 218, 53, 'PPL', 'P'),
(45112, 'Brightseat', 38.9136085510254, 0.679170593047613, -76.8611068725586, -1.34147938165339, 218, 25, 'PPL', 'P'),
(34988, 'Brightshade', 37.0222206115723, 0.646159646071645, -83.6600036621094, -1.46014251613432, 218, 21, 'PPL', 'P'),
(124315, 'Brightside', 42.1624984741211, 0.735874419240498, -72.6333312988281, -1.2676907778564, 218, 23, 'PPL', 'P'),
(180255, 'Brightside', 37.5991706848145, 0.656229324469343, -121.923332214355, -2.12796358214337, 218, 6, 'PPL', 'P'),
(45087, 'Brightside (historical)', 39.3852806091309, 0.687402823451211, -76.6430587768555, -1.33767372445567, 218, 25, 'PPL', 'P'),
(7681, 'Brightstar', 33.1152801513672, 0.577970671361684, -93.9894409179688, -1.64042520612724, 218, 4, 'PPL', 'P'),
(15328, 'Brightsville', 30.3213901519775, 0.529208091933792, -81.8525009155273, -1.42859564196763, 218, 12, 'PPL', 'P'),
(177531, 'Brightview', 41.271671295166, 0.720326551901479, -72.897216796875, -1.27229644864558, 218, 8, 'PPL', 'P'),
(45088, 'Brightview Woods', 39.1144409179688, 0.682675779095348, -76.6172180175781, -1.33722271812506, 218, 25, 'PPL', 'P'),
(1140, 'Brightwater', 31.9799995422363, 0.558156286798303, -88.3541717529297, -1.54207120496119, 218, 2, 'PPL', 'P'),
(7682, 'Brightwater', 36.417781829834, 0.635610199203568, -94.0566711425781, -1.64159859490353, 218, 4, 'PPL', 'P'),
(63164, 'Brightwater', 35.3308296203613, 0.616639304336443, -82.5197219848633, -1.44024084646621, 218, 33, 'PPL', 'P'),
(126954, 'Brightwater', 43.8050003051758, 0.764541484162438, -69.8608322143555, -1.21930154032382, 218, 26, 'PPL', 'P'),
(45089, 'Brightwater Beach', 39.1611099243164, 0.683490306914749, -76.5500030517578, -1.33604959566488, 218, 25, 'PPL', 'P'),
(147375, 'Brightwaters', 40.7208290100098, 0.710712540366293, -73.2677764892578, -1.27876393535284, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(100185, 'Brightwell Mill', 37.4583282470703, 0.653771160204173, -79.0475006103516, -1.37963915112286, 218, 53, 'PPL', 'P'),
(13042, 'Brightwood', 38.961109161377, 0.679999635094955, -77.0277786254883, -1.34438835251208, 218, 9, 'PPL', 'P'),
(45092, 'Brightwood', 38.8644409179688, 0.678312455965362, -76.3488922119141, -1.33253954934816, 218, 25, 'PPL', 'P'),
(63165, 'Brightwood', 36.1327781677246, 0.630635946919518, -79.7597198486328, -1.39206972182692, 218, 33, 'PPL', 'P'),
(100186, 'Brightwood', 38.4213905334473, 0.670579768003235, -78.1938934326172, -1.36474089535274, 218, 53, 'PPL', 'P'),
(124316, 'Brightwood', 42.1186103820801, 0.735108427531964, -72.6166687011719, -1.26739996066536, 218, 23, 'PPL', 'P'),
(154455, 'Brightwood', 40.4486083984375, 0.705961394402565, -81.3933334350586, -1.42058165761536, 218, 41, 'PPL', 'P'),
(159520, 'Brightwood', 40.3405609130859, 0.70407561003468, -80.0327835083008, -1.39683558175567, 218, 45, 'PPL', 'P'),
(200455, 'Brightwood', 45.3763885498047, 0.791967382858347, -122.015556335449, -2.12957319670622, 218, 43, 'PPL', 'P'),
(29293, 'Brightwood (historical)', 39.8036117553711, 0.694704079316745, -86.1097183227539, -1.50289810269694, 218, 19, 'PPL', 'P'),
(45093, 'Brightwood Acres', 39.6161117553711, 0.691431586969256, -77.6827774047852, -1.35582023780736, 218, 25, 'PPL', 'P'),
(100187, 'Brightwood Manor', 37.2241706848145, 0.649684339774365, -80.4458312988281, -1.40404462566846, 218, 53, 'PPL', 'P'),
(13043, 'Brightwood Park', 38.9569396972656, 0.679926864218168, -77.0252838134766, -1.34434480982826, 218, 9, 'PPL', 'P'),
(45094, 'Brightwood Terrace', 39.110279083252, 0.682603141376616, -76.6083297729492, -1.33706758899156, 218, 25, 'PPL', 'P'),
(39501, 'Brignac', 30.2697200775146, 0.528306279009664, -90.870002746582, -1.58598073922415, 218, 22, 'PPL', 'P'),
(45095, 'Brilhart Terrace', 39.6100006103516, 0.691324927367598, -76.8730621337891, -1.3416880403248, 218, 25, 'PPL', 'P'),
(173298, 'Brill', 45.6027793884277, 0.79591864838867, -91.6719436645508, -1.59997724864917, 218, 57, 'PPL', 'P'),
(71902, 'Brill (historical)', 39.7322196960449, 0.693458052821724, -81.7083282470703, -1.42607935421166, 218, 41, 'PPL', 'P'),
(77918, 'Brillhart', 39.9091682434082, 0.696546387579835, -76.754997253418, -1.33962741943135, 218, 45, 'PPL', 'P'),
(1141, 'Brilliant', 34.0252799987793, 0.593853164891671, -87.7583312988281, -1.53167182722054, 218, 2, 'PPL', 'P'),
(154456, 'Brilliant', 40.264720916748, 0.702751952393883, -80.6263885498047, -1.40719594418635, 218, 41, 'PPL', 'P'),
(188184, 'Brilliant', 36.9561080932617, 0.645005764950341, -104.533889770508, -1.82446055641218, 218, 38, 'PPL', 'P'),
(173299, 'Brillion', 44.1772193908691, 0.77103793274655, -88.0641708374023, -1.53700973415144, 218, 57, 'PPL', 'P'),
(100188, 'Brilyn Park', 38.898609161377, 0.678908804312458, -77.1747207641602, -1.34695297664183, 218, 53, 'PPL', 'P'),
(63168, 'Brim (historical)', 36.5386085510254, 0.637719023312748, -80.466667175293, -1.40440828031531, 218, 33, 'PPL', 'P'),
(154457, 'Brimestone Corners (historical)', 40.8772201538086, 0.713442080746543, -81.6055603027344, -1.4242857152175, 218, 41, 'PPL', 'P'),
(45096, 'Brimfield', 39.3883285522461, 0.687456020093986, -76.9383316040039, -1.34282720748108, 218, 25, 'PPL', 'P'),
(118907, 'Brimfield', 40.8388900756836, 0.712773094680715, -89.8863906860352, -1.56881347020528, 218, 18, 'PPL', 'P'),
(122274, 'Brimfield', 41.4541702270508, 0.723511759144241, -85.398063659668, -1.49047738568892, 218, 19, 'PPL', 'P'),
(124317, 'Brimfield', 42.1227798461914, 0.735181198408751, -72.2013931274414, -1.26015203460066, 218, 23, 'PPL', 'P'),
(154458, 'Brimfield', 41.0999984741211, 0.717330295938059, -81.3466720581055, -1.41976726295401, 218, 41, 'PPL', 'P'),
(70573, 'Brimfield Crossing', 39.5708312988281, 0.690641293915775, -74.9080581665039, -1.30739225128092, 218, 37, 'PPL', 'P'),
(154459, 'Brimfield Station', 41.0997200012207, 0.717325435669069, -81.3705596923828, -1.42018418082266, 218, 41, 'PPL', 'P'),
(188185, 'Brimhall Nizhoni', 35.7675018310547, 0.624260672165005, -108.642776489258, -1.89617415824583, 218, 38, 'PPL', 'P'),
(129944, 'Brimley', 46.4052810668945, 0.809924944930697, -84.5722198486328, -1.47606369207914, 218, 27, 'PPL', 'P'),
(85312, 'Brims Corner', 35.8005599975586, 0.624837646015171, -89.1722183227539, -1.55634881103927, 218, 50, 'PPL', 'P'),
(63167, 'Brims Grove', 36.4122200012207, 0.635513126981835, -80.4158325195313, -1.40352104819815, 218, 33, 'PPL', 'P'),
(134410, 'Brimson', 47.276668548584, 0.825133525546839, -91.866943359375, -1.60338063536423, 218, 28, 'PPL', 'P'),
(139051, 'Brimson', 40.1436080932617, 0.70063813485766, -93.7386093139648, -1.63604736876931, 218, 29, 'PPL', 'P'),
(39502, 'Brimstone', 30.249439239502, 0.527952311611279, -93.4019393920898, -1.63017137014016, 218, 22, 'PPL', 'P'),
(124319, 'Brimstone Corner', 42.0588912963867, 0.734066132860335, -70.7838897705078, -1.23541193386409, 218, 23, 'PPL', 'P'),
(126955, 'Brimstone Corner', 44.2075004577637, 0.771566437064876, -70.4972229003906, -1.23040865312416, 218, 26, 'PPL', 'P'),
(171785, 'Brimstone Corner', 43.9377784729004, 0.766858900363998, -72.26611328125, -1.26128161437702, 218, 55, 'PPL', 'P'),
(186449, 'Brimstone Corner', 38.938060760498, 0.679597364612298, -107.974716186523, -1.88451430636125, 218, 7, 'PPL', 'P'),
(29294, 'Brimstone Corners', 38.7372207641602, 0.676092045406509, -86.2644424438477, -1.50559854804229, 218, 19, 'PPL', 'P'),
(147376, 'Brinckerhoff', 41.5438919067383, 0.725077697865208, -73.8686065673828, -1.28925039846114, 218, 40, 'PPL', 'P'),
(154461, 'Brindle Corner', 40.2963905334473, 0.703304691478129, -83.2013931274414, -1.45213825232003, 218, 41, 'PPL', 'P'),
(63169, 'Brindletown', 35.625, 0.62177354602298, -81.8008270263672, -1.42769376246447, 218, 33, 'PPL', 'P'),
(144901, 'Brindletown', 40.0472183227539, 0.698955815997057, -74.5055618286133, -1.30036736495751, 218, 37, 'PPL', 'P'),
(34989, 'Brinegar', 38.2211112976074, 0.667084235914452, -83.2900009155273, -1.45368474996504, 218, 21, 'PPL', 'P'),
(13044, 'Brinetown (historical)', 38.9147186279297, 0.679189967544543, -77.0680618286133, -1.34509142703986, 218, 9, 'PPL', 'P'),
(112366, 'Bringhurst', 31.0747203826904, 0.54235618481454, -92.5202789306641, -1.61478349220363, 218, 22, 'PPL', 'P'),
(122275, 'Bringhurst', 40.5252799987793, 0.707299566271302, -86.5250015258789, -1.5101461619197, 218, 19, 'PPL', 'P'),
(45097, 'Brink', 39.2099990844727, 0.68434358372801, -77.2399978637695, -1.34809227695617, 218, 25, 'PPL', 'P'),
(75217, 'Brink', 36.8411102294922, 0.642998673594802, -98.6119384765625, -1.7211030081901, 218, 42, 'PPL', 'P'),
(100192, 'Brink', 36.6177787780762, 0.639100804444335, -77.6347198486328, -1.35498147522204, 218, 53, 'PPL', 'P'),
(108363, 'Brink', 39.5480613708496, 0.690243883702108, -80.4930572509766, -1.40486887402584, 218, 58, 'PPL', 'P'),
(108364, 'Brink (historical)', 37.8450012207031, 0.660519876722543, -80.3463897705078, -1.40230904358605, 218, 58, 'PPL', 'P'),
(45098, 'Brink Meadow', 39.2130584716797, 0.684396980107866, -77.2438888549805, -1.34816018756396, 218, 25, 'PPL', 'P'),
(92825, 'Brinker', 33.1272201538086, 0.578179063716982, -95.4922180175781, -1.66665361443899, 218, 51, 'PPL', 'P'),
(159521, 'Brinker', 40.8294410705566, 0.712608178430212, -79.8300018310547, -1.39329637382501, 218, 45, 'PPL', 'P'),
(53657, 'Brinkerhoff (historical)', 36.3494415283203, 0.634417435930349, -89.7391662597656, -1.56624391922752, 218, 29, 'PPL', 'P'),
(159523, 'Brinkerton', 40.2227783203125, 0.702019915989248, -79.5263900756836, -1.38799734904602, 218, 45, 'PPL', 'P'),
(154462, 'Brinkhaven', 40.4694404602051, 0.706324982470388, -82.1941680908203, -1.43455885912248, 218, 41, 'PPL', 'P'),
(45099, 'Brinkleigh', 39.2838897705078, 0.685633219485881, -76.8402786254883, -1.34111586016459, 218, 25, 'PPL', 'P'),
(45100, 'Brinkleigh Manor', 39.288330078125, 0.685710717473602, -76.829719543457, -1.34093156941716, 218, 25, 'PPL', 'P'),
(7684, 'Brinkley', 34.8877792358398, 0.608906616374317, -91.1944427490234, -1.59164328549193, 218, 4, 'PPL', 'P'),
(34990, 'Brinkley', 37.3088912963867, 0.651162993390604, -82.9488906860352, -1.44773125334817, 218, 21, 'PPL', 'P'),
(63170, 'Brinkley Estates', 36.2216682434082, 0.632187371412544, -80.1191711425781, -1.39834333040682, 218, 33, 'PPL', 'P'),
(63172, 'Brinkleyville', 36.3227806091309, 0.633952115108885, -76.9688873291016, -1.34336050548937, 218, 33, 'PPL', 'P'),
(45102, 'Brinklow', 39.165828704834, 0.683572665171459, -77.0158309936523, -1.34417982699873, 218, 25, 'PPL', 'P'),
(75218, 'Brinkman', 35.0099983215332, 0.611039741828443, -99.5163879394531, -1.73688862923543, 218, 42, 'PPL', 'P'),
(196081, 'Brinkman (historical)', 48.2916717529297, 0.842848673380965, -110.626388549805, -1.93079471978465, 218, 31, 'PPL', 'P'),
(191171, 'Brinkman Addition Colonia', 31.6009998321533, 0.551541493993251, -106.266998291016, -1.85470900638941, 218, 51, 'PPL', 'P'),
(118909, 'Brinksburg (historical)', 42.1949996948242, 0.736441672552685, -90.311393737793, -1.57623117278948, 218, 18, 'PPL', 'P'),
(53658, 'Brinktown', 38.1266708374023, 0.665435938936775, -92.0844421386719, -1.60717670518203, 218, 29, 'PPL', 'P'),
(45103, 'Brinkwood Estates', 39.2083282470703, 0.684314422114074, -77.227783203125, -1.3478790909109, 218, 25, 'PPL', 'P'),
(71903, 'Brinley', 39.8944396972656, 0.696289325955615, -84.7397232055664, -1.47898717716578, 218, 41, 'PPL', 'P'),
(1142, 'Brinn', 34.1686096191406, 0.59635473868261, -87.8008270263672, -1.53241351758413, 218, 2, 'PPL', 'P'),
(100189, 'Brinnington', 38.1347198486328, 0.665576420684276, -78.5591735839844, -1.37111623668628, 218, 53, 'PPL', 'P'),
(206894, 'Brinnon', 47.6794395446777, 0.832163205560213, -122.896942138672, -2.14495628095279, 218, 56, 'PPL', 'P'),
(139716, 'Brinsmade', 48.1824989318848, 0.84094324820004, -99.3236083984375, -1.73352399151423, 218, 34, 'PPL', 'P'),
(19502, 'Brinson', 30.9766693115234, 0.540644870787569, -84.7377777099609, -1.47895322186188, 218, 13, 'PPL', 'P'),
(19503, 'Brinson Crossing', 33.2102813720703, 0.579628755456367, -82.3600006103516, -1.43745318259517, 218, 13, 'PPL', 'P'),
(129957, 'Brinton', 43.7702789306641, 0.763935481856391, -85.0102767944336, -1.4837092280946, 218, 27, 'PPL', 'P'),
(209328, 'Brinton', 41.7183303833008, 0.728122223623387, -104.899719238281, -1.83084548512565, 218, 59, 'PPL', 'P'),
(159524, 'Brintons Corners', 40.8527793884277, 0.713015508918939, -80.1822204589844, -1.39944374856924, 218, 45, 'PPL', 'P'),
(15329, 'Briny Breezes', 26.5080604553223, 0.462652933263081, -80.0511093139648, -1.39715542740259, 218, 12, 'PPL', 'P'),
(118910, 'Brisbane', 41.4925003051758, 0.724180745210069, -87.9577789306641, -1.53515284508139, 218, 18, 'PPL', 'P'),
(180256, 'Brisbane', 37.6808280944824, 0.657654515126699, -122.398887634277, -2.13626358999671, 218, 6, 'PPL', 'P'),
(198046, 'Brisbane', 46.3424987792969, 0.808829187300183, -101.490562438965, -1.77134447426082, 218, 34, 'PPL', 'P'),
(7686, 'Brisbane (historical)', 33.5833282470703, 0.586139651689393, -93.3488922119141, -1.62924552218719, 218, 4, 'PPL', 'P'),
(147377, 'Brisben', 42.3650016784668, 0.73940876690217, -75.6819381713867, -1.32089900538147, 218, 40, 'PPL', 'P'),
(159525, 'Brisbin', 40.8380584716797, 0.712758580452774, -78.3547210693359, -1.36754786714168, 218, 45, 'PPL', 'P'),
(196080, 'Brisbin', 45.5230598449707, 0.794527279877158, -110.607780456543, -1.93046994728971, 218, 31, 'PPL', 'P'),
(19504, 'Brisbon', 31.9169406890869, 0.557055702188314, -81.3063888549805, -1.41906418842623, 218, 13, 'PPL', 'P'),
(122276, 'Brisco', 40.4111099243164, 0.705306922564678, -87.3583297729492, -1.52469048358095, 218, 19, 'PPL', 'P'),
(1143, 'Briscoe', 34.4577789306641, 0.601401695264419, -86.5886077880859, -1.5112563006201, 218, 2, 'PPL', 'P'),
(45104, 'Briscoe', 38.4236106872559, 0.670618516997096, -76.5644378662109, -1.336301530704, 218, 25, 'PPL', 'P'),
(53659, 'Briscoe', 39.0819396972656, 0.682108525783161, -91.0119400024414, -1.58845801167014, 218, 29, 'PPL', 'P'),
(112631, 'Briscoe', 39.3494415283203, 0.686777313490179, -81.5330581665039, -1.42302031422554, 218, 58, 'PPL', 'P'),
(147378, 'Briscoe', 41.7641716003418, 0.728922303793874, -74.8788909912109, -1.30688318803855, 218, 40, 'PPL', 'P'),
(191172, 'Briscoe', 35.583610534668, 0.621051163577296, -100.289436340332, -1.75038086910805, 218, 51, 'PPL', 'P'),
(19505, 'Briscoe (historical)', 34.089168548584, 0.594968230440087, -85.2397232055664, -1.48771382342575, 218, 13, 'PPL', 'P'),
(129945, 'Brissette Beach', 43.709171295166, 0.762868952418841, -83.9361114501953, -1.46496150612682, 218, 27, 'PPL', 'P'),
(7694, 'Brister', 33.1405601501465, 0.578411890575283, -93.1919403076172, -1.62650619468994, 218, 4, 'PPL', 'P'),
(71904, 'Brister', 39.7975006103516, 0.694597419715088, -81.2763900756836, -1.41854061095592, 218, 41, 'PPL', 'P'),
(58788, 'Bristers Store', 31.3863906860352, 0.547795857788595, -90.2324981689453, -1.57485418534785, 218, 30, 'PPL', 'P'),
(100190, 'Bristersburg', 38.5833282470703, 0.673406114289109, -77.6141662597656, -1.3546227474232, 218, 53, 'PPL', 'P'),
(58789, 'Bristerville', 31.3799991607666, 0.547684304628435, -90.2761077880859, -1.5756153167874, 218, 30, 'PPL', 'P'),
(13435, 'Bristle Knoll', 39.7166709899902, 0.693186676706645, -75.7819366455078, -1.32264430800186, 218, 10, 'PPL', 'P'),
(53660, 'Bristle Ridge', 38.7138900756836, 0.675684848075835, -93.6577835083008, -1.63463669233989, 218, 29, 'PPL', 'P'),
(34991, 'Bristletown', 36.9341697692871, 0.644622868964615, -85.9194412231445, -1.49957714081762, 218, 21, 'PPL', 'P'),
(58790, 'Bristo (historical)', 33.9872207641602, 0.593188905936778, -88.5519409179688, -1.54552292805004, 218, 30, 'PPL', 'P'),
(15330, 'Bristol', 30.4319400787354, 0.531137552143554, -84.975830078125, -1.48310801947851, 218, 12, 'PPL', 'P'),
(19506, 'Bristol', 31.4483299255371, 0.548876901454086, -82.2147216796875, -1.43491758692131, 218, 13, 'PPL', 'P'),
(39503, 'Bristol', 30.3708305358887, 0.530070989416491, -92.1383285522461, -1.60811720052099, 218, 22, 'PPL', 'P'),
(45105, 'Bristol', 38.7922210693359, 0.677051981821428, -76.668327331543, -1.33811474393218, 218, 25, 'PPL', 'P'),
(53661, 'Bristol', 39.0916709899902, 0.682278368881681, -94.4527816772461, -1.64851202793532, 218, 29, 'PPL', 'P'),
(71906, 'Bristol', 39.6688919067383, 0.692352774390314, -82.227783203125, -1.43514555351062, 218, 41, 'PPL', 'P'),
(85313, 'Bristol', 36.5950012207031, 0.638703261072614, -82.1888885498047, -1.43446671374876, 218, 50, 'PPL', 'P'),
(92826, 'Bristol', 32.4613914489746, 0.56655816056334, -96.5697174072266, -1.68545952647659, 218, 51, 'PPL', 'P'),
(100191, 'Bristol', 36.5963897705078, 0.638727495838533, -82.188606262207, -1.43446178690074, 218, 53, 'PPL', 'P'),
(108365, 'Bristol', 39.2877807617188, 0.685701130093678, -80.524169921875, -1.4054118925721, 218, 58, 'PPL', 'P'),
(114706, 'Bristol', 43.4119415283203, 0.757681314352449, -93.4677810668945, -1.63132052415053, 218, 16, 'PPL', 'P'),
(118911, 'Bristol', 41.6855583190918, 0.727550243200265, -88.4280624389648, -1.54336084071906, 218, 18, 'PPL', 'P'),
(122277, 'Bristol', 41.7213897705078, 0.728175620003243, -85.817497253418, -1.49779788289333, 218, 19, 'PPL', 'P'),
(126956, 'Bristol', 43.9575004577637, 0.767203113934891, -69.5097198486328, -1.2131734734975, 218, 26, 'PPL', 'P'),
(129946, 'Bristol', 44.103889465332, 0.769758084105685, -85.583610534668, -1.49371578957446, 218, 27, 'PPL', 'P'),
(134412, 'Bristol', 43.5444412231445, 0.759993870285019, -92.1691665649414, -1.6086554253773, 218, 28, 'PPL', 'P'),
(143557, 'Bristol', 43.5911102294922, 0.76080839810442, -71.7372207641602, -1.25205069856464, 218, 36, 'PPL', 'P'),
(147381, 'Bristol', 42.8452796936035, 0.747791199591249, -77.4244384765625, -1.3513113729238, 218, 40, 'PPL', 'P'),
(159527, 'Bristol', 40.1005592346191, 0.699886790535121, -74.8522186279297, -1.30641766748001, 218, 45, 'PPL', 'P'),
(169292, 'Bristol', 41.6769409179688, 0.727399841177703, -71.2666702270508, -1.24383804239505, 218, 47, 'PPL', 'P'),
(169898, 'Bristol', 45.3447189331055, 0.791414643774101, -97.7480621337891, -1.70602552167861, 218, 49, 'PPL', 'P'),
(171783, 'Bristol', 44.1333312988281, 0.770271941038016, -73.0794372558594, -1.27547679561936, 218, 55, 'PPL', 'P'),
(173302, 'Bristol', 42.5588912963867, 0.742792779120306, -88.0491714477539, -1.53674794541629, 218, 57, 'PPL', 'P'),
(177532, 'Bristol', 41.6716690063477, 0.72730782896204, -72.9497222900391, -1.27321284237668, 218, 8, 'PPL', 'P'),
(186451, 'Bristol', 38.1222190856934, 0.665358241211971, -102.311111450195, -1.78566575618078, 218, 7, 'PPL', 'P'),
(189961, 'Bristol', 38.0800018310547, 0.664621411117374, -114.618606567383, -2.00047206864883, 218, 39, 'PPL', 'P'),
(206895, 'Bristol', 47.144718170166, 0.822830556994193, -120.796669006348, -2.10829959960255, 218, 56, 'PPL', 'P'),
(7688, 'Bristol (historical)', 35.1661109924316, 0.613764421939703, -92.1319427490234, -1.60800574722937, 218, 4, 'PPL', 'P'),
(26609, 'Bristol (historical)', 38.9383316040039, 0.679602091723233, -88.6355590820313, -1.54698234032741, 218, 18, 'PPL', 'P'),
(45106, 'Bristol (historical)', 38.4700012207031, 0.671428184547507, -77.0263900756836, -1.34436411774616, 218, 25, 'PPL', 'P'),
(147379, 'Bristol Center', 42.8088912963867, 0.747156102250292, -77.3908309936523, -1.35072481169371, 218, 40, 'PPL', 'P'),
(19507, 'Bristol Downs', 33.913890838623, 0.591909057295913, -84.0197219848633, -1.46642078524613, 218, 13, 'PPL', 'P'),
(169294, 'Bristol Ferry', 41.6324996948242, 0.726624195510217, -71.2541732788086, -1.24361992950177, 218, 47, 'PPL', 'P'),
(19509, 'Bristol Hammock', 30.8222198486328, 0.537949219132191, -81.6347198486328, -1.42479464530181, 218, 13, 'PPL', 'P'),
(169295, 'Bristol Highlands', 41.6961097717285, 0.727734400789644, -71.2877807617188, -1.24420649073186, 218, 47, 'PPL', 'P'),
(45107, 'Bristol Landing', 38.7922210693359, 0.677051981821428, -76.704719543457, -1.33874990785217, 218, 25, 'PPL', 'P'),
(203157, 'Bristol Mansion Condominium', 41.2205581665039, 0.71943445951533, -111.949996948242, -1.95389604434443, 218, 52, 'PPL', 'P'),
(147380, 'Bristol Springs', 42.7061080932617, 0.745362196940015, -77.3802795410156, -1.35054065410433, 218, 40, 'PPL', 'P'),
(177791, 'Bristol Square', 33.5900001525879, 0.586256098408056, -112.189720153809, -1.958080003575, 218, 5, 'PPL', 'P'),
(63174, 'Bristol Terrace', 35.7833290100098, 0.624536908549073, -80.9400024414063, -1.41266953917479, 218, 33, 'PPL', 'P'),
(159528, 'Bristol Terrace Number One', 40.1144409179688, 0.700129071615291, -74.8530578613281, -1.306432314866, 218, 45, 'PPL', 'P'),
(159529, 'Bristol Terrace Number Two', 40.1194381713867, 0.700216290140991, -74.8555603027344, -1.30647599070788, 218, 45, 'PPL', 'P'),
(169296, 'Bristol Township', 41.6838912963867, 0.727521148165356, -71.2644424438477, -1.24379916024314, 218, 47, 'PPL', 'P'),
(71907, 'Bristol Village', 39.1313896179199, 0.682971589713429, -82.9674987792969, -1.44805602584311, 218, 41, 'PPL', 'P'),
(189963, 'Bristol Well (historical)', 38.1049995422363, 0.665057703482956, -114.688056945801, -2.00168420641898, 218, 39, 'PPL', 'P'),
(19510, 'Bristol Wood', 33.5108299255371, 0.584874317276469, -82.0541687011719, -1.43211540882233, 218, 13, 'PPL', 'P'),
(154464, 'Bristolville', 41.3875007629395, 0.722348157484959, -80.8694381713867, -1.41143796032868, 218, 41, 'PPL', 'P'),
(45108, 'Bristolwood', 38.6319389343262, 0.674254530833381, -76.0074996948242, -1.32658112588327, 218, 25, 'PPL', 'P'),
(77919, 'Bristoria', 39.8736114501953, 0.695925804466819, -80.4088897705078, -1.40339987436855, 218, 45, 'PPL', 'P'),
(1144, 'Bristow', 34.1958312988281, 0.59682984662108, -85.7777786254883, -1.49710466206159, 218, 2, 'PPL', 'P'),
(29295, 'Bristow', 38.1399993896484, 0.665668566057993, -86.7216720581055, -1.51357871024871, 218, 19, 'PPL', 'P'),
(34992, 'Bristow', 37.0186080932617, 0.646096595732837, -86.3600006103516, -1.50726635267495, 218, 21, 'PPL', 'P'),
(53662, 'Bristow', 37.8050003051758, 0.659821729042778, -94.2641677856445, -1.64522009451187, 218, 29, 'PPL', 'P'),
(58791, 'Bristow', 34.0052795410156, 0.593504091051789, -88.3638916015625, -1.54224084832263, 218, 30, 'PPL', 'P'),
(75220, 'Bristow', 35.8305587768555, 0.62536122348548, -96.3908309936523, -1.68233736957263, 218, 42, 'PPL', 'P'),
(79952, 'Bristow', 34.4191703796387, 0.600727848929602, -79.6186065673828, -1.38960683045081, 218, 48, 'PPL', 'P'),
(100195, 'Bristow', 38.7227783203125, 0.675839977209333, -77.5363922119141, -1.35326533421559, 218, 53, 'PPL', 'P'),
(114709, 'Bristow', 42.7738914489746, 0.746545239675255, -92.9072189331055, -1.6215368692539, 218, 16, 'PPL', 'P'),
(141369, 'Bristow', 42.8419418334961, 0.747732942942403, -98.5844421386719, -1.72062310656166, 218, 35, 'PPL', 'P'),
(75221, 'Bristow Point', 35.1216697692871, 0.612988776272217, -95.6122207641602, -1.66874805747828, 218, 42, 'PPL', 'P'),
(100196, 'Britain', 39.2527809143066, 0.685090267518641, -77.6972198486328, -1.35607230600453, 218, 53, 'PPL', 'P'),
(19511, 'Britain Estates', 33.8861083984375, 0.591424162240437, -83.3769378662109, -1.45520208599612, 218, 13, 'PPL', 'P'),
(124321, 'Britanniaville', 41.9186096191406, 0.73161775571217, -71.1061096191406, -1.24103573113802, 218, 23, 'PPL', 'P'),
(45109, 'Britinay Hills', 39.3997192382813, 0.68765482506936, -76.5102767944336, -1.33535624167508, 218, 25, 'PPL', 'P'),
(173305, 'British Hollow', 42.7058296203613, 0.745357336671025, -90.6866683959961, -1.58278095117442, 218, 57, 'PPL', 'P'),
(129947, 'British Landing', 45.877498626709, 0.800713403615249, -84.6449966430664, -1.47733388676106, 218, 27, 'PPL', 'P'),
(63177, 'British Woods', 35.8980598449707, 0.626539339372704, -81.5377807617188, -1.42310273906128, 218, 33, 'PPL', 'P'),
(100197, 'British Woods', 37.3583297729492, 0.65202585758379, -79.8819427490234, -1.39420291386007, 218, 53, 'PPL', 'P'),
(34993, 'Britmart', 36.8830604553223, 0.643730843157492, -87.2811126708984, -1.52334279091132, 218, 21, 'PPL', 'P'),
(71909, 'Britney Acres', 39.0611114501953, 0.681745004294365, -84.334716796875, -1.47191848184243, 218, 41, 'PPL', 'P'),
(180258, 'Brito', 36.9925003051758, 0.645640928870325, -120.707778930664, -2.10674817510953, 218, 6, 'PPL', 'P'),
(180257, 'Britona (historical)', 38.8244400024414, 0.677614308285598, -121.907783508301, -2.12769220602829, 218, 6, 'PPL', 'P'),
(19512, 'Britt', 33.7266693115234, 0.588641425217413, -84.6686096191406, -1.47774601093975, 218, 13, 'PPL', 'P'),
(114710, 'Britt', 43.0977783203125, 0.752198131984084, -93.8016662597656, -1.63714792008978, 218, 16, 'PPL', 'P'),
(134414, 'Britt', 47.6402816772461, 0.831479771845471, -92.5252838134766, -1.61487084388738, 218, 28, 'PPL', 'P'),
(7691, 'Britt (historical)', 33.8741683959961, 0.591215769885138, -93.2519378662109, -1.62755334963056, 218, 4, 'PPL', 'P'),
(7692, 'Brittain', 34.6569404602051, 0.604877719698217, -92.3225021362305, -1.61133163595672, 218, 4, 'PPL', 'P'),
(53663, 'Brittain', 37.5497207641602, 0.655366260539076, -92.8636093139648, -1.62077573781436, 218, 29, 'PPL', 'P'),
(154465, 'Brittain', 41.0644416809082, 0.716709712825043, -81.4633331298828, -1.42180338276543, 218, 41, 'PPL', 'P'),
(108366, 'Brittain (historical)', 39.3791694641113, 0.687296163849554, -80.0519409179688, -1.39716994163053, 218, 58, 'PPL', 'P'),
(159532, 'Brittains Corner', 40.0999984741211, 0.699877003418115, -75.4786071777344, -1.31735021007089, 218, 45, 'PPL', 'P'),
(124322, 'Brittan Square', 42.2861099243164, 0.738031846039572, -71.7874984741211, -1.25292821014382, 218, 23, 'PPL', 'P'),
(39505, 'Brittany', 30.2119407653809, 0.527297839773392, -90.8813934326172, -1.58617954419952, 218, 22, 'PPL', 'P'),
(45110, 'Brittany', 39.250560760498, 0.68505151852478, -76.8069381713867, -1.34053395946641, 218, 25, 'PPL', 'P'),
(100198, 'Brittany Farms', 36.8375015258789, 0.642935689835022, -76.5025024414063, -1.33522055361754, 218, 53, 'PPL', 'P'),
(19513, 'Brittany Forest', 33.610279083252, 0.586610032516928, -84.460563659668, -1.47411492395148, 218, 13, 'PPL', 'P'),
(63182, 'Brittany Ridge', 35.5730590820313, 0.620867005987917, -77.3261108398438, -1.34959523191735, 218, 33, 'PPL', 'P'),
(198049, 'Brittin', 46.7152786254883, 0.815335423001302, -100.405281066895, -1.75240274100763, 218, 34, 'PPL', 'P'),
(100199, 'Brittland', 37.7055587768555, 0.658086146960374, -77.7255630493164, -1.35656698817702, 218, 53, 'PPL', 'P'),
(134416, 'Brittmount', 47.5966682434082, 0.830718573826899, -92.5819396972656, -1.61585967560013, 218, 28, 'PPL', 'P'),
(45111, 'Britton', 38.2599983215332, 0.667762942518259, -76.6452789306641, -1.33771247344953, 218, 25, 'PPL', 'P'),
(75223, 'Britton', 35.565559387207, 0.620736111620339, -97.5308303833008, -1.70223411239272, 218, 42, 'PPL', 'P'),
(79954, 'Britton', 33.8502807617188, 0.590798852016486, -80.290283203125, -1.40132979925323, 218, 48, 'PPL', 'P'),
(92827, 'Britton', 32.5483283996582, 0.568075496594412, -97.067497253418, -1.6941474237427, 218, 51, 'PPL', 'P'),
(129948, 'Britton', 41.9866714477539, 0.7328056587164, -83.8311080932617, -1.46312885182268, 218, 27, 'PPL', 'P'),
(169903, 'Britton', 45.7916717529297, 0.799215442081106, -97.7505569458008, -1.70606906436244, 218, 49, 'PPL', 'P'),
(85314, 'Britton Acres', 36.1616706848145, 0.631140216471925, -83.4130630493164, -1.45583258938419, 218, 50, 'PPL', 'P'),
(191176, 'Britton Davis', 31.860279083252, 0.556066770607027, -106.421943664551, -1.85741331331833, 218, 51, 'PPL', 'P'),
(159533, 'Britton Run', 41.7947196960449, 0.729455468644108, -79.7425003051758, -1.3917691840979, 218, 45, 'PPL', 'P'),
(79955, 'Brittons Neck', 33.9124984741211, 0.591884755950966, -79.341667175293, -1.38477332623037, 218, 48, 'PPL', 'P'),
(85315, 'Brittontown', 36.2727813720703, 0.633079463798693, -82.7866668701172, -1.44489991363525, 218, 50, 'PPL', 'P'),
(100200, 'Brittonwood', 37.3841705322266, 0.652476863914394, -77.4627838134766, -1.35198062530574, 218, 53, 'PPL', 'P'),
(85317, 'Brittsville', 35.353328704834, 0.617031987439176, -84.9077835083008, -1.48192038279039, 218, 50, 'PPL', 'P'),
(53664, 'Brixey', 36.750560760498, 0.641418287224922, -92.4047164916992, -1.61276654715205, 218, 29, 'PPL', 'P'),
(126958, 'Brixham', 43.1858291625977, 0.753734909091115, -70.7447204589844, -1.23472830041227, 218, 26, 'PPL', 'P'),
(126959, 'Brixham Lower Corners', 43.1805610656738, 0.75364296345448, -70.7366714477539, -1.23458781866477, 218, 26, 'PPL', 'P'),
(188186, 'Brizendine Place', 34.6697196960449, 0.605100759439512, -106.289436340332, -1.85510062422771, 218, 38, 'PPL', 'P'),
(1145, 'Broach Mill', 32.5486106872559, 0.568080423442429, -85.7566680908203, -1.49673621372477, 218, 2, 'PPL', 'P'),
(7693, 'Broad', 33.292781829834, 0.581068660078746, -92.0741729736328, -1.60699747444067, 218, 4, 'PPL', 'P'),
(19514, 'Broad', 33.9469413757324, 0.592485897988024, -82.706672668457, -1.44350375143378, 218, 13, 'PPL', 'P'),
(13436, 'Broad Acres', 38.639720916748, 0.674390352048975, -75.5761108398438, -1.31905197000745, 218, 10, 'PPL', 'P'),
(85316, 'Broad Acres', 36.0316696166992, 0.628871269802205, -84.0477828979492, -1.4669105405706, 218, 50, 'PPL', 'P'),
(129949, 'Broad Acres', 42.5491714477539, 0.742623135758868, -82.9022216796875, -1.44691672552877, 218, 27, 'PPL', 'P'),
(143559, 'Broad Acres', 42.7688903808594, 0.746457954570528, -71.5072174072266, -1.24803638269551, 218, 36, 'PPL', 'P'),
(159534, 'Broad Acres', 41.1769409179688, 0.718673194917731, -80.0838928222656, -1.39772760756279, 218, 45, 'PPL', 'P'),
(159536, 'Broad Axe', 40.1388893127441, 0.700555776600949, -75.2444381713867, -1.313263189904, 218, 45, 'PPL', 'P'),
(100201, 'Broad Axe (historical)', 38.035831451416, 0.663850492560823, -78.6597213745117, -1.37287112668659, 218, 53, 'PPL', 'P'),
(100202, 'Broad Bay Colony', 36.9047203063965, 0.644108878874229, -76.0577774047852, -1.32745863746245, 218, 53, 'PPL', 'P'),
(34994, 'Broad Bottom', 37.5341682434082, 0.65509481784497, -82.5930633544922, -1.44152089484416, 218, 21, 'PPL', 'P'),
(15331, 'Broad Branch', 30.3113899230957, 0.529033555013851, -85.2955627441406, -1.48868840722666, 218, 12, 'PPL', 'P'),
(177533, 'Broad Brook', 41.9122200012207, 0.731506235841523, -72.5455627441406, -1.26615892759739, 218, 8, 'PPL', 'P'),
(147383, 'Broad Channel', 40.6030616760254, 0.70865711263697, -73.8208312988281, -1.28841656272383, 218, 40, 'PPL', 'P'),
(126960, 'Broad Cove', 44.0377807617188, 0.768604269563409, -69.415283203125, -1.21152524309885, 218, 26, 'PPL', 'P'),
(13441, 'Broad Creek', 38.5855598449707, 0.673445063020052, -75.5841674804688, -1.31919258491301, 218, 10, 'PPL', 'P'),
(45113, 'Broad Creek', 38.7577781677246, 0.676450839784369, -76.9972229003906, -1.34385505450379, 218, 25, 'PPL', 'P'),
(63186, 'Broad Creek', 34.7205581665039, 0.605988058135699, -76.9366683959961, -1.3427981790252, 218, 33, 'PPL', 'P'),
(100203, 'Broad Creek', 36.8566703796387, 0.643270249446963, -76.220832824707, -1.33030449140331, 218, 53, 'PPL', 'P'),
(13437, 'Broad Creek Estates', 38.561939239502, 0.673032805683307, -75.6175003051758, -1.31977435245313, 218, 10, 'PPL', 'P'),
(45114, 'Broad Creek Farms', 38.7630615234375, 0.676543051737113, -76.2566680908203, -1.33092993478531, 218, 25, 'PPL', 'P'),
(45115, 'Broad Creek Park', 39.6963882446289, 0.692832676018747, -76.2386093139648, -1.3306147496703, 218, 25, 'PPL', 'P'),
(34995, 'Broad Fields', 38.2413902282715, 0.667438170023323, -85.6522216796875, -1.49491327995861, 218, 21, 'PPL', 'P'),
(34996, 'Broad Ford', 37.3813896179199, 0.652428327803528, -86.0794372558594, -1.50236959837862, 218, 21, 'PPL', 'P'),
(159535, 'Broad Ford', 40.0472183227539, 0.698955815997057, -79.6086120605469, -1.38943239339941, 218, 45, 'PPL', 'P'),
(70575, 'Broad Lane', 39.670280456543, 0.692377009156234, -74.9266662597656, -1.30771702377586, 218, 37, 'PPL', 'P'),
(100204, 'Broad Marsh', 37.2936096191406, 0.650896277807432, -76.4649963378906, -1.3345659486216, 218, 53, 'PPL', 'P'),
(100205, 'Broad Meadows', 37.6541709899902, 0.657189260884262, -77.5541687011719, -1.35357559248258, 218, 53, 'PPL', 'P'),
(108367, 'Broad Oaks', 39.273609161377, 0.685453789007437, -80.32861328125, -1.40199878531906, 218, 58, 'PPL', 'P'),
(29296, 'Broad Park', 39.5858306884766, 0.69090308265093, -86.6694412231445, -1.51266711020757, 218, 19, 'PPL', 'P'),
(211712, 'Broad Pass (historical)', 63.2333297729492, 1.10362980153732, -149.266662597656, -2.60519472579257, 218, 1, 'PPL', 'P'),
(29298, 'Broad Ripple', 39.8666687011719, 0.695804630637221, -86.1305618286133, -1.50326189050185, 218, 19, 'PPL', 'P'),
(79956, 'Broad River Bluff', 32.4147186279297, 0.565743566164912, -80.7694396972656, -1.4096926577083, 218, 48, 'PPL', 'P'),
(79957, 'Broad River Estates', 34.0499992370605, 0.594284596988264, -81.0886077880859, -1.41526319176042, 218, 48, 'PPL', 'P'),
(45116, 'Broad Run', 39.3936080932617, 0.687548165467702, -77.5977783203125, -1.35433672392213, 218, 25, 'PPL', 'P'),
(100209, 'Broad Run', 37.6444396972656, 0.657019417785743, -77.708610534668, -1.35627111097991, 218, 53, 'PPL', 'P'),
(45117, 'Broad Run Acres', 39.3891716003418, 0.687470734059008, -77.5872192382813, -1.35415243317469, 218, 25, 'PPL', 'P'),
(100210, 'Broad Run Farms', 39.0586090087891, 0.681701328452488, -77.4330596923828, -1.35146184152539, 218, 53, 'PPL', 'P'),
(100212, 'Broad Run Village', 38.7622184753418, 0.676528337772091, -77.5886077880859, -1.35417666794061, 218, 53, 'PPL', 'P'),
(159537, 'Broad Top City', 40.202220916748, 0.701661121611387, -78.14111328125, -1.36381970793168, 218, 45, 'PPL', 'P'),
(154466, 'Broadacre', 40.3661117553711, 0.704521556359213, -80.783332824707, -1.40993513852555, 218, 41, 'PPL', 'P'),
(147384, 'Broadalbin', 43.0586090087891, 0.751514498532261, -74.1969375610352, -1.29498085533671, 218, 40, 'PPL', 'P'),
(147385, 'Broadalbin Junction', 43.0849990844727, 0.75197509224279, -74.2944412231445, -1.29668261527328, 218, 40, 'PPL', 'P'),
(200457, 'Broadbent', 43.0091705322266, 0.750651634339075, -124.145278930664, -2.16674386814683, 218, 43, 'PPL', 'P'),
(129950, 'Broadbridge Station', 42.6786117553711, 0.744882295311582, -82.5119400024414, -1.44010502525062, 218, 27, 'PPL', 'P'),
(92828, 'Broaddus', 31.3066692352295, 0.54640445598757, -94.2688903808594, -1.64530251934761, 218, 51, 'PPL', 'P'),
(100213, 'Broaddus', 38.0672187805176, 0.664398304797052, -77.2955627441406, -1.34906206706712, 218, 53, 'PPL', 'P'),
(19517, 'Broadfield', 31.3069400787354, 0.546409183098505, -81.4619369506836, -1.42177901484146, 218, 13, 'PPL', 'P'),
(100214, 'Broadford', 36.9272193908691, 0.644501561976961, -81.6727828979492, -1.42545897083573, 218, 53, 'PPL', 'P'),
(194642, 'Broadford', 43.4697189331055, 0.758689720299207, -114.279441833496, -1.99455252733585, 218, 17, 'PPL', 'P'),
(45118, 'Broadfording', 39.6858291625977, 0.692648385271313, -77.8030624389648, -1.35791960769467, 218, 25, 'PPL', 'P'),
(196082, 'Broadhead (historical)', 48.2402801513672, 0.841951720725826, -112.387496948242, -1.96153185982191, 218, 31, 'PPL', 'P'),
(19518, 'Broadhurst', 31.4738903045654, 0.549323014226188, -81.9175033569336, -1.429730148592, 218, 13, 'PPL', 'P'),
(13439, 'Broadkill Beach', 38.8280601501465, 0.67767749178246, -75.2122192382813, -1.31270086343983, 218, 10, 'PPL', 'P'),
(169905, 'Broadland', 44.4925003051758, 0.776540622769899, -98.3488922119141, -1.71651198478691, 218, 49, 'PPL', 'P'),
(26611, 'Broadlands', 39.9086112976074, 0.696536667041856, -87.9941711425781, -1.53578800900137, 218, 18, 'PPL', 'P'),
(100215, 'Broadlands', 39.0180587768555, 0.680993593392799, -77.5205612182617, -1.35298903125249, 218, 53, 'PPL', 'P'),
(159542, 'Broadlawn Highlands', 40.3261108398438, 0.703823408679449, -80.0725021362305, -1.39752880258741, 218, 45, 'PPL', 'P'),
(79961, 'Broadleaf Acres', 34.9011116027832, 0.609139310074562, -82.3216705322266, -1.43678419652935, 218, 48, 'PPL', 'P'),
(200458, 'Broadmead', 45.0730590820313, 0.786673284927378, -123.268333435059, -2.15143828188798, 218, 43, 'PPL', 'P'),
(45119, 'Broadmeade', 39.4708290100098, 0.688895924716364, -76.6966705322266, -1.33860942610467, 218, 25, 'PPL', 'P'),
(29299, 'Broadmoor', 39.8488883972168, 0.695494305791199, -86.2141723632813, -1.50472116962116, 218, 19, 'PPL', 'P'),
(39516, 'Broadmoor', 30.4469394683838, 0.531399340878709, -91.0849990844727, -1.58973313320007, 218, 22, 'PPL', 'P'),
(45120, 'Broadmoor', 39.4822196960449, 0.689094729691739, -76.6675033569336, -1.3381003628623, 218, 25, 'PPL', 'P'),
(79958, 'Broadmoor', 34.8911094665527, 0.608964739865108, -82.3249969482422, -1.43684225344111, 218, 48, 'PPL', 'P'),
(85318, 'Broadmoor', 36.2055587768555, 0.631906208180459, -89.4611129760742, -1.56139097393112, 218, 50, 'PPL', 'P'),
(100216, 'Broadmoor', 36.7744407653809, 0.64183507193552, -76.3211135864258, -1.33205472087171, 218, 53, 'PPL', 'P'),
(118913, 'Broadmoor', 41.1455612182617, 0.718125515839556, -89.6286087036133, -1.5643143258597, 218, 18, 'PPL', 'P'),
(180259, 'Broadmoor', 37.6866683959961, 0.657756447617422, -122.481666564941, -2.13770835488808, 218, 6, 'PPL', 'P'),
(186452, 'Broadmoor', 38.7955589294434, 0.677110238470273, -104.840827941895, -1.82981763810293, 218, 7, 'PPL', 'P'),
(206896, 'Broadmoor', 47.6336097717285, 0.831363325126807, -122.288330078125, -2.1343339966289, 218, 56, 'PPL', 'P'),
(211713, 'Broadmoor', 64.8238906860352, 1.1313903264242, -147.875823974609, -2.5809200124565, 218, 1, 'PPL', 'P'),
(153, 'Broadmoor Addition', 39.2574996948242, 0.685172625775352, -81.6211090087891, -1.42455709133257, 218, 58, 'PPL', 'P'),
(201928, 'Broadmoor Subdivision', 44.0394401550293, 0.768633231440263, -103.272499084473, -1.80244513578688, 218, 49, 'PPL', 'P'),
(180260, 'Broadmoor Village', 37.689998626709, 0.657814571108213, -122.480003356934, -2.1376793264322, 218, 6, 'PPL', 'P'),
(79959, 'Broadmouth', 34.4524993896484, 0.601309549890702, -82.3522186279297, -1.43731736137958, 218, 48, 'PPL', 'P'),
(19520, 'Broadnax', 34.4097213745117, 0.600562932679098, -83.9630584716797, -1.46543182037533, 218, 13, 'PPL', 'P'),
(196083, 'Broadus', 45.4438896179199, 0.793145498745571, -105.406936645508, -1.83969809890518, 218, 31, 'PPL', 'P'),
(100217, 'Broadus Corner', 37.9791717529297, 0.662861594269049, -77.1811065673828, -1.34706442993345, 218, 53, 'PPL', 'P'),
(29300, 'Broadview', 39.139720916748, 0.683116998308947, -86.538330078125, -1.51037878904092, 218, 19, 'PPL', 'P'),
(45122, 'Broadview', 38.8125, 0.677405915930299, -76.9269409179688, -1.3426284025057, 218, 25, 'PPL', 'P'),
(63192, 'Broadview', 35.7947196960449, 0.624735713524448, -80.8266677856445, -1.41069147627513, 218, 33, 'PPL', 'P'),
(85321, 'Broadview', 35.4930610656738, 0.619470777207416, -87.0980606079102, -1.52014792970961, 218, 50, 'PPL', 'P'),
(118914, 'Broadview', 41.8638916015625, 0.730662746145268, -87.8533325195313, -1.53332991131523, 218, 18, 'PPL', 'P'),
(154467, 'Broadview', 41.2177810668945, 0.719385989983491, -81.6386108398438, -1.42486255590961, 218, 41, 'PPL', 'P'),
(159540, 'Broadview', 40.6116714477539, 0.708807381501478, -79.7744369506836, -1.39232658371405, 218, 45, 'PPL', 'P'),
(188187, 'Broadview', 34.8194389343262, 0.607713853101097, -103.21305847168, -1.80140770138424, 218, 38, 'PPL', 'P'),
(191174, 'Broadview', 33.6366691589355, 0.587070626227457, -101.92749786377, -1.77897043604226, 218, 51, 'PPL', 'P'),
(196086, 'Broadview', 46.0977783203125, 0.804558009543914, -108.876388549805, -1.90025145787475, 218, 31, 'PPL', 'P'),
(45123, 'Broadview Acres', 39.4519386291504, 0.688566225373413, -77.3838882446289, -1.35060363786411, 218, 25, 'PPL', 'P'),
(63193, 'Broadview Acres', 35.0177803039551, 0.611175563044037, -80.5408325195313, -1.40570270976314, 218, 33, 'PPL', 'P'),
(45124, 'Broadview Estates', 38.9633293151855, 0.680038384088815, -76.5733337402344, -1.33645679299555, 218, 25, 'PPL', 'P'),
(63194, 'Broadview Estates', 35.2416687011719, 0.615083152732483, -82.7216720581055, -1.44376554016893, 218, 33, 'PPL', 'P'),
(79960, 'Broadview Estates', 34.464168548584, 0.601513215135066, -82.6086120605469, -1.44179227095924, 218, 48, 'PPL', 'P'),
(180261, 'Broadview Farms', 36.8219413757324, 0.642664113982861, -120.505828857422, -2.10322348140681, 218, 6, 'PPL', 'P'),
(154469, 'Broadview Heights', 41.3138885498047, 0.721063381996077, -81.6852798461914, -1.42567708372901, 218, 41, 'PPL', 'P'),
(15332, 'Broadview Park', 26.0991706848145, 0.455516460489995, -80.2088928222656, -1.39990926912778, 218, 12, 'PPL', 'P'),
(126961, 'Broadview Park', 43.6180610656738, 0.761278778931955, -70.2766723632813, -1.22655932008456, 218, 26, 'PPL', 'P'),
(34997, 'Broadville Manor', 38.1686096191406, 0.666167908762383, -84.9313888549805, -1.48233237381103, 218, 21, 'PPL', 'P'),
(15333, 'Broadwater', 27.726390838623, 0.483916809828764, -82.6875, -1.44316912524281, 218, 12, 'PPL', 'P'),
(45125, 'Broadwater', 38.792781829834, 0.677061768938434, -76.5347213745117, -1.33578288008171, 218, 25, 'PPL', 'P'),
(53665, 'Broadwater', 36.5819396972656, 0.638475294483303, -89.9211120605469, -1.56941947251133, 218, 29, 'PPL', 'P'),
(100218, 'Broadwater', 37.3927803039551, 0.652627132778902, -75.7088928222656, -1.32136945278804, 218, 53, 'PPL', 'P'),
(196084, 'Broadwater', 46.6036109924316, 0.813386455136554, -112.085830688477, -1.95626679034682, 218, 31, 'PPL', 'P'),
(199201, 'Broadwater', 41.5961112976074, 0.72598909816926, -102.85221862793, -1.79510985803842, 218, 35, 'PPL', 'P'),
(45126, 'Broadwater Beach', 39.0652809143066, 0.681817775171152, -76.4933319091797, -1.33506049763603, 218, 25, 'PPL', 'P'),
(45128, 'Broadwater Estates', 38.7413902282715, 0.676164816283295, -77.0130615234375, -1.34413149062494, 218, 25, 'PPL', 'P'),
(45129, 'Broadwater Point', 38.7880592346191, 0.676979344102696, -76.5286102294922, -1.33567622048005, 218, 25, 'PPL', 'P'),
(34998, 'Broadway', 37.3144416809082, 0.651259865875255, -86.2736129760742, -1.5057586040238, 218, 21, 'PPL', 'P'),
(53666, 'Broadway', 38.5430603027344, 0.672703306077437, -90.2624969482422, -1.57537776281816, 218, 29, 'PPL', 'P'),
(63196, 'Broadway', 35.4577789306641, 0.618854987784362, -79.0533294677734, -1.3797408838765, 218, 33, 'PPL', 'P'),
(85322, 'Broadway', 35.6749992370605, 0.622646197333172, -88.466667175293, -1.54403462047485, 218, 50, 'PPL', 'P'),
(100219, 'Broadway', 38.6130599975586, 0.673925031227511, -78.7991714477539, -1.37530498960681, 218, 53, 'PPL', 'P'),
(144902, 'Broadway', 40.7319412231445, 0.710906485072678, -75.0519409179688, -1.30990347903081, 218, 37, 'PPL', 'P'),
(154471, 'Broadway', 40.3411102294922, 0.704085197414604, -83.4122161865234, -1.45581780884014, 218, 41, 'PPL', 'P'),
(159541, 'Broadway', 41.2472190856934, 0.719899780336794, -76.2149963378906, -1.33020262549161, 218, 45, 'PPL', 'P'),
(191175, 'Broadway', 33.7036094665527, 0.588238954997675, -101.072219848633, -1.76404301865821, 218, 51, 'PPL', 'P'),
(206898, 'Broadway', 47.6341705322266, 0.831373112243813, -122.324172973633, -2.13495957316896, 218, 56, 'PPL', 'P'),
(53667, 'Broadway (historical)', 38.1016693115234, 0.664999579992165, -91.7074966430664, -1.60059776518316, 218, 29, 'PPL', 'P'),
(199847, 'Broadway (historical)', 40.0008316040039, 0.698146215025673, -114.048057556152, -1.99051410985886, 218, 39, 'PPL', 'P'),
(92830, 'Broadway Junction', 33.5224990844727, 0.585077982520833, -95.5894393920898, -1.66835044752753, 218, 51, 'PPL', 'P'),
(147387, 'Broadway Junction', 40.6766700744629, 0.709941821546825, -73.9005584716797, -1.2898080643934, 218, 40, 'PPL', 'P'),
(177792, 'Broadway Trailer Court', 33.4075012207031, 0.583070891165294, -112.103889465332, -1.95658197546183, 218, 5, 'PPL', 'P'),
(45130, 'Broadway-Orleans Homes', 39.2944412231445, 0.68581737707526, -76.5913925170898, -1.33677197811057, 218, 25, 'PPL', 'P'),
(34999, 'Broadwell', 38.3286094665527, 0.668960432902413, -84.3591690063477, -1.47234525340712, 218, 21, 'PPL', 'P'),
(71911, 'Broadwell', 39.3647193908691, 0.687043962494323, -81.8797225952148, -1.4290707499061, 218, 41, 'PPL', 'P'),
(118915, 'Broadwell', 40.0680618286133, 0.699319603801962, -89.4430618286133, -1.56107592197416, 218, 18, 'PPL', 'P'),
(180262, 'Broadwell', 34.8738899230957, 0.608664202136092, -116.192497253418, -2.02794164318661, 218, 6, 'PPL', 'P'),
(45131, 'Broadwood Manor', 39.0786094665527, 0.68205040229237, -77.1191711425781, -1.34598345284699, 218, 25, 'PPL', 'P'),
(19521, 'Brobston', 31.2600002288818, 0.545589928168169, -81.5580596923828, -1.42345667317015, 218, 13, 'PPL', 'P'),
(19522, 'Brock', 33.9188919067383, 0.59199634240064, -84.7877807617188, -1.4798259397511, 218, 13, 'PPL', 'P'),
(35000, 'Brock', 37.1097183227539, 0.647686769219723, -84, -1.46607657167524, 218, 21, 'PPL', 'P'),
(75224, 'Brock', 34.1158294677734, 0.595433551261551, -97.2391662597656, -1.69714361312709, 218, 42, 'PPL', 'P'),
(77923, 'Brock', 39.7425003051758, 0.693637483300169, -80.1730575561523, -1.39928382574578, 218, 45, 'PPL', 'P'),
(79962, 'Brock', 34.6505584716797, 0.604766332985625, -83.0819396972656, -1.45005339666067, 218, 48, 'PPL', 'P'),
(92831, 'Brock', 32.6761093139648, 0.570305694270272, -97.940559387207, -1.7093852325518, 218, 51, 'PPL', 'P'),
(139052, 'Brock', 40.5511093139648, 0.707750372864826, -92.1516723632813, -1.60835009395832, 218, 29, 'PPL', 'P'),
(141371, 'Brock', 40.4799995422363, 0.706509273217821, -95.9591674804688, -1.67480342000685, 218, 35, 'PPL', 'P'),
(154472, 'Brock', 40.2663917541504, 0.702781114007819, -84.5586090087891, -1.47582613810991, 218, 41, 'PPL', 'P'),
(196087, 'Brock Creek', 46.6036109924316, 0.813386455136554, -112.854721069336, -1.96968645907973, 218, 31, 'PPL', 'P'),
(193400, 'Brock Creek (historical)', 40.2480583190918, 0.702461135202846, -123.714996337891, -2.15923402018892, 218, 6, 'PPL', 'P'),
(15334, 'Brock Crossroad', 30.6902809143066, 0.535646450316627, -85.6294403076172, -1.49451567000787, 218, 12, 'PPL', 'P'),
(92832, 'Brock Junction', 32.7027816772461, 0.570771214828818, -97.9563903808594, -1.7096615355149, 218, 51, 'PPL', 'P'),
(206901, 'Brockdale', 47.2825012207031, 0.825235324879508, -123.157783508301, -2.14950882167822, 218, 56, 'PPL', 'P'),
(85323, 'Brockdell', 35.5280609130859, 0.620081639782453, -85.3238906860352, -1.48918282308304, 218, 50, 'PPL', 'P'),
(139720, 'Brocket', 48.2130584716797, 0.841476612787356, -98.3566665649414, -1.71664767284445, 218, 34, 'PPL', 'P'),
(7695, 'Brockett', 36.3386116027832, 0.634228418071981, -90.9427795410156, -1.58725093390606, 218, 4, 'PPL', 'P'),
(79965, 'Brockington', 33.7311096191406, 0.588718923205134, -79.8036117553711, -1.39283578011448, 218, 48, 'PPL', 'P'),
(7696, 'Brockington Corner', 34.9705581665039, 0.610351381265685, -92.2949981689453, -1.61085160117023, 218, 4, 'PPL', 'P'),
(79963, 'Brockington Heights', 34.0977783203125, 0.595118499304595, -81.0588912963867, -1.41474454113812, 218, 48, 'PPL', 'P'),
(85324, 'Brockland Acres', 36.2305603027344, 0.632342567125068, -83.2202835083008, -1.45246795166299, 218, 50, 'PPL', 'P'),
(188188, 'Brockman', 32.1230583190918, 0.560653133478307, -108.484169006348, -1.89340593545075, 218, 38, 'PPL', 'P'),
(193401, 'Brockman', 40.9638900756836, 0.714954756245708, -120.498062133789, -2.10308792650732, 218, 6, 'PPL', 'P'),
(180263, 'Brockmans Corner', 37.3761100769043, 0.652336182429811, -118.43138885498, -2.06701767322913, 218, 6, 'PPL', 'P'),
(100220, 'Brockmont', 38.8763885498047, 0.678520981478715, -77.182502746582, -1.34708879785742, 218, 53, 'PPL', 'P'),
(147388, 'Brockport', 43.2136116027832, 0.754219804146591, -77.9394378662109, -1.36029980791892, 218, 40, 'PPL', 'P'),
(159543, 'Brockport', 41.2597198486328, 0.720117959809099, -78.726936340332, -1.37404424914677, 218, 45, 'PPL', 'P'),
(100221, 'Brockroad', 38.2744407653809, 0.668015010715434, -77.679443359375, -1.35576204773754, 218, 53, 'PPL', 'P'),
(63197, 'Brocks', 34.9166717529297, 0.609410885926723, -77.5255584716797, -1.35307624977819, 218, 33, 'PPL', 'P'),
(71912, 'Brocks Corner', 39.190559387207, 0.684004297005134, -82.7605590820313, -1.44444424677274, 218, 41, 'PPL', 'P'),
(79969, 'Brocks Mill', 34.7572212219238, 0.606627949166618, -79.9952774047852, -1.39618097675973, 218, 48, 'PPL', 'P'),
(141372, 'Brocksburg', 42.9302787780762, 0.749274713476477, -99.3319396972656, -1.73366940010974, 218, 35, 'PPL', 'P'),
(19523, 'Brockton', 34.1199989318848, 0.595506322138338, -83.4947204589844, -1.45725778004155, 218, 13, 'PPL', 'P'),
(79966, 'Brockton', 34.1847190856934, 0.596635901914695, -79.8808288574219, -1.39418347278411, 218, 48, 'PPL', 'P'),
(124323, 'Brockton', 42.0833282470703, 0.734492638108911, -71.0188903808594, -1.23951346825893, 218, 23, 'PPL', 'P'),
(159544, 'Brockton', 40.7483291625977, 0.711192508573753, -76.0688934326172, -1.32765264874786, 218, 45, 'PPL', 'P'),
(196088, 'Brockton', 48.1513900756836, 0.8404002962328, -104.916389465332, -1.83113643547474, 218, 31, 'PPL', 'P'),
(124324, 'Brockton Heights', 42.0888900756836, 0.734589710330644, -71.0652770996094, -1.24032306923031, 218, 23, 'PPL', 'P'),
(7697, 'Brocktown (historical)', 34.0713882446289, 0.594657905594066, -93.6083297729492, -1.6337735618306, 218, 4, 'PPL', 'P'),
(147389, 'Brockville', 43.2611083984375, 0.755048779614905, -78.0908279418945, -1.36294206319445, 218, 40, 'PPL', 'P'),
(129951, 'Brockway', 43.0744400024414, 0.751790801495357, -82.7655563354492, -1.44453146529844, 218, 27, 'PPL', 'P'),
(147390, 'Brockway', 41.5305595397949, 0.724845004164962, -73.9780578613281, -1.29116068391105, 218, 40, 'PPL', 'P'),
(159545, 'Brockway', 41.2491683959961, 0.71993380221972, -78.7997207641602, -1.37531457698674, 218, 45, 'PPL', 'P'),
(173306, 'Brockway', 44.2847213745117, 0.772914196313538, -90.8394393920898, -1.5854473080578, 218, 57, 'PPL', 'P'),
(177534, 'Brockway', 41.3944396972656, 0.72246926473553, -72.3805618286133, -1.26327911835263, 218, 8, 'PPL', 'P'),
(180264, 'Brockway', 39.2266693115234, 0.684634534077101, -120.011108398438, -2.09458898052055, 218, 6, 'PPL', 'P'),
(196089, 'Brockway', 47.297779083252, 0.825501973883652, -105.761940002441, -1.8458940763393, 218, 31, 'PPL', 'P'),
(200459, 'Brockway', 43.1091690063477, 0.752396936959459, -123.454170227051, -2.15468174577959, 218, 43, 'PPL', 'P'),
(139722, 'Brockway (historical)', 46.288890838623, 0.807893552230211, -97.8144378662109, -1.7071839967528, 218, 34, 'PPL', 'P'),
(154474, 'Brockway (historical)', 41.2772216796875, 0.720423424386131, -80.5686111450195, -1.40618753823959, 218, 41, 'PPL', 'P'),
(124326, 'Brockway Corner', 42.4427795410156, 0.74076624668881, -71.5611114501953, -1.24897701119252, 218, 23, 'PPL', 'P'),
(177536, 'Brockway Landing', 41.3886108398438, 0.722367531981889, -72.3888931274414, -1.26342452694815, 218, 8, 'PPL', 'P'),
(180265, 'Brockway Vista', 39.2380599975586, 0.684833339052476, -120.014167785645, -2.09464237690041, 218, 6, 'PPL', 'P'),
(171786, 'Brockways Mills', 43.2069396972656, 0.754103357427927, -72.5166702270508, -1.26565465804498, 218, 55, 'PPL', 'P'),
(7698, 'Brockwell', 36.1427803039551, 0.630810517128973, -91.9263916015625, -1.60441820292493, 218, 4, 'PPL', 'P'),
(100222, 'Brockwood', 38.877498626709, 0.678540355975646, -77.1291732788086, -1.34615802305644, 218, 53, 'PPL', 'P'),
(203160, 'Brockwood', 40.6647186279297, 0.709733229454444, -111.852783203125, -1.95219934441394, 218, 52, 'PPL', 'P'),
(26612, 'Brocton', 39.7155609130859, 0.693167302209715, -87.932502746582, -1.53471169244681, 218, 18, 'PPL', 'P'),
(147391, 'Brocton', 42.3886108398438, 0.739820824501832, -79.4413909912109, -1.38651383516079, 218, 40, 'PPL', 'P'),
(77920, 'Brodbecks', 39.7705612182617, 0.694127238624634, -76.8280563354492, -1.34090254096128, 218, 45, 'PPL', 'P'),
(180266, 'Broderick', 38.5911102294922, 0.673541935504703, -121.51611328125, -2.12085627098422, 218, 6, 'PPL', 'P'),
(35001, 'Brodhead', 37.4041709899902, 0.652825937754277, -84.4138870239258, -1.47330026297402, 218, 21, 'PPL', 'P'),
(147392, 'Brodhead', 41.9436111450195, 0.73205411465678, -74.2577819824219, -1.29604279082138, 218, 40, 'PPL', 'P'),
(159547, 'Brodhead', 40.6805610656738, 0.710009732154621, -75.3413925170898, -1.31495536246064, 218, 45, 'PPL', 'P'),
(173312, 'Brodhead', 42.6183280944824, 0.743830146943919, -89.376106262207, -1.55990732688784, 218, 57, 'PPL', 'P'),
(159548, 'Brodheadsville', 40.9244384765625, 0.714266195945868, -75.394172668457, -1.31587654988169, 218, 45, 'PPL', 'P'),
(100223, 'Brodnax', 36.7063903808594, 0.640647368668371, -78.0316696166992, -1.36190955563982, 218, 53, 'PPL', 'P'),
(39517, 'Brodnax (historical)', 32.8838882446289, 0.573932120726633, -91.79638671875, -1.60214918967618, 218, 22, 'PPL', 'P'),
(173309, 'Brodtville', 42.9524993896484, 0.74966253631022, -91.04638671875, -1.58905922028622, 218, 57, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(58794, 'Brody', 34.9319381713867, 0.609677335193786, -89.0699996948242, -1.55456475942503, 218, 30, 'PPL', 'P'),
(519, 'Broeck Pointe', 38.2955589294434, 0.668383592210301, -85.5861129760742, -1.49375946541634, 218, 21, 'PPL', 'P'),
(200460, 'Brogan', 44.2463912963867, 0.77224521024771, -117.51611328125, -2.05104310090445, 218, 43, 'PPL', 'P'),
(114712, 'Brogan (historical)', 42.2152786254883, 0.736795606661557, -95.1916732788086, -1.66140811919792, 218, 16, 'PPL', 'P'),
(199203, 'Broganville', 41.207218170166, 0.71920163265703, -101.51611328125, -1.77179042058536, 218, 35, 'PPL', 'P'),
(63199, 'Brogden', 35.2924995422363, 0.615970318270615, -78.0347213745117, -1.36196281886162, 218, 33, 'PPL', 'P'),
(79967, 'Brogden', 33.5361099243164, 0.585315536490068, -81.9644393920898, -1.43054933694331, 218, 48, 'PPL', 'P'),
(19524, 'Brogdon', 33.5308303833008, 0.585223391116351, -84.5130615234375, -1.47503118452452, 218, 13, 'PPL', 'P'),
(79968, 'Brogdon', 33.811939239502, 0.590129666213577, -80.2624969482422, -1.40084483761873, 218, 48, 'PPL', 'P'),
(77921, 'Brogue', 39.8716697692871, 0.695891915741948, -76.4833297729492, -1.33488592742657, 218, 45, 'PPL', 'P'),
(77922, 'Brogueville', 39.8430595397949, 0.695392573037558, -76.5319366455078, -1.33573427739182, 218, 45, 'PPL', 'P'),
(108368, 'Brohard', 39.0363883972168, 0.681313505618745, -81.1763916015625, -1.41679530833554, 218, 58, 'PPL', 'P'),
(129953, 'Brohman', 43.6852798461914, 0.762451967971162, -85.8158264160156, -1.4977687212794, 218, 27, 'PPL', 'P'),
(71913, 'Brokaw', 39.5280609130859, 0.689894809862226, -81.7272186279297, -1.42640905355462, 218, 41, 'PPL', 'P'),
(118917, 'Brokaw', 40.4511108398438, 0.706005070244442, -88.9024963378906, -1.55164127433839, 218, 18, 'PPL', 'P'),
(173310, 'Brokaw', 45.0272216796875, 0.785873271335918, -89.6530609130859, -1.56474109742438, 218, 57, 'PPL', 'P'),
(75226, 'Broken Arrow', 36.0525016784668, 0.629234857870028, -95.7905578613281, -1.67186062700231, 218, 42, 'PPL', 'P'),
(186453, 'Broken Arrow Acres', 39.5027809143066, 0.689453590648627, -105.326110839844, -1.83828742247576, 218, 7, 'PPL', 'P'),
(31889, 'Broken Arrow Park', 38.9308280944824, 0.679471130776628, -95.2388916015625, -1.66223223439724, 218, 20, 'PPL', 'P'),
(75227, 'Broken Bow', 34.0291709899902, 0.593921075499468, -94.7388916015625, -1.65350558813727, 218, 42, 'PPL', 'P'),
(141373, 'Broken Bow', 41.4019393920898, 0.722600159103107, -99.6388931274414, -1.7390267481166, 218, 35, 'PPL', 'P'),
(100224, 'Broken Hill', 38.7511100769043, 0.676334459644733, -77.7083282470703, -1.35626618413189, 218, 53, 'PPL', 'P'),
(189964, 'Broken Hills (historical)', 39.0497207641602, 0.681546199318991, -118.009437561035, -2.05965323386673, 218, 39, 'PPL', 'P'),
(203161, 'Broken Ridge at Highpoint', 40.6061096191406, 0.708710309279745, -111.860557556152, -1.95233503247148, 218, 52, 'PPL', 'P'),
(154473, 'Broken Sword', 40.9066696166992, 0.713956070836928, -83.0169372558594, -1.44891889003629, 218, 41, 'PPL', 'P'),
(100225, 'Brokenburg', 38.1455612182617, 0.665765638279726, -77.7191696166992, -1.35645540172734, 218, 53, 'PPL', 'P'),
(206902, 'Bromart', 47.8997192382813, 0.836007811488878, -122.097778320313, -2.1310082410596, 218, 56, 'PPL', 'P'),
(192895, 'Bromela', 35.0177803039551, 0.611175563044037, -120.582778930664, -2.10456651354454, 218, 6, 'PPL', 'P'),
(29301, 'Bromer', 38.5936088562012, 0.673585544767553, -86.3358306884766, -1.50684450795828, 218, 19, 'PPL', 'P'),
(75230, 'Bromide', 34.4183311462402, 0.600713201543606, -96.4966735839844, -1.68418467126276, 218, 42, 'PPL', 'P'),
(75229, 'Bromide Junction', 34.4041709899902, 0.600466060194447, -96.432502746582, -1.68306467886633, 218, 42, 'PPL', 'P'),
(1151, 'Bromley', 30.7386093139648, 0.536489940012882, -87.8675003051758, -1.53357718582244, 218, 2, 'PPL', 'P'),
(35007, 'Bromley', 39.0819396972656, 0.682108525783161, -84.5602798461914, -1.47585529972384, 218, 21, 'PPL', 'P'),
(114713, 'Bromley', 42.1188888549805, 0.735113287800954, -93.1294403076172, -1.62541536390744, 218, 16, 'PPL', 'P'),
(147393, 'Bromley', 42.7825012207031, 0.746695508539763, -76.1833267211914, -1.32964988640737, 218, 40, 'PPL', 'P'),
(19525, 'Bromley Estates', 33.8111114501953, 0.590115218564663, -84.790283203125, -1.47986961559298, 218, 13, 'PPL', 'P'),
(171787, 'Bromley Village', 43.2119407653809, 0.754190642532655, -72.9436111450195, -1.27310618277502, 218, 55, 'PPL', 'P'),
(159550, 'Brommerstown', 40.5974998474121, 0.708560040415237, -76.1558303833008, -1.32916998477893, 218, 45, 'PPL', 'P'),
(1150, 'Brompton', 33.5819396972656, 0.586115416923473, -86.4694366455078, -1.50917637180875, 218, 2, 'PPL', 'P'),
(114714, 'Brompton', 40.9313888549805, 0.714387502933521, -92.7344436645508, -1.61852137195161, 218, 16, 'PPL', 'P'),
(203182, 'Bron Breck', 40.6655616760254, 0.709747943419467, -111.807502746582, -1.95140905136046, 218, 52, 'PPL', 'P'),
(53668, 'Bronaugh', 37.6941719055176, 0.657887408564027, -94.4686126708984, -1.64878833089841, 218, 29, 'PPL', 'P'),
(188189, 'Broncho', 34.5588912963867, 0.60316643896076, -106.135833740234, -1.85241975311638, 218, 38, 'PPL', 'P'),
(147394, 'Bronck House', 42.3452796936035, 0.739064553331277, -73.8469390869141, -1.28887222958635, 218, 40, 'PPL', 'P'),
(19547, 'Bronco', 34.6599998474121, 0.604931116078073, -85.3427810668945, -1.48951252242599, 218, 13, 'PPL', 'P'),
(180267, 'Bronco', 39.3863906860352, 0.687422197948142, -120.021667480469, -2.09477327126799, 218, 6, 'PPL', 'P'),
(191177, 'Bronco', 33.2569389343262, 0.580443083538686, -103.058609008789, -1.79871204972886, 218, 51, 'PPL', 'P'),
(189966, 'Bronco (historical)', 39.3980598449707, 0.687625863192506, -119.97721862793, -2.09399749244245, 218, 39, 'PPL', 'P'),
(180274, 'Bronge (historical)', 36.764720916748, 0.641665428574081, -119.681671142578, -2.08883921572707, 218, 6, 'PPL', 'P'),
(186454, 'Bronquist', 38.2019386291504, 0.666749609723483, -104.89111328125, -1.83069528284017, 218, 7, 'PPL', 'P'),
(15335, 'Bronson', 29.4475002288818, 0.513955835475772, -82.6425018310547, -1.44238375903735, 218, 12, 'PPL', 'P'),
(31890, 'Bronson', 37.8958282470703, 0.661406975681648, -95.0730590820313, -1.65933791092454, 218, 20, 'PPL', 'P'),
(39522, 'Bronson', 30.0694408416748, 0.52481074692088, -91.7358322143555, -1.60109231419758, 218, 22, 'PPL', 'P'),
(92833, 'Bronson', 31.3438892364502, 0.547054067556467, -94.0133285522461, -1.64084212399589, 218, 51, 'PPL', 'P'),
(114715, 'Bronson', 42.410831451416, 0.740208647335575, -96.2136077880859, -1.67924424112456, 218, 16, 'PPL', 'P'),
(118918, 'Bronson', 40.1150016784668, 0.700138858732297, -87.8052825927734, -1.53249128188796, 218, 18, 'PPL', 'P'),
(129954, 'Bronson', 41.8722190856934, 0.730808088161759, -85.1947174072266, -1.48692832406223, 218, 27, 'PPL', 'P'),
(79970, 'Bronson Crossroads', 34.4497184753418, 0.601261013779835, -79.3236083984375, -1.38445814111536, 218, 48, 'PPL', 'P'),
(35003, 'Bronston', 36.9855613708496, 0.645519821619753, -84.6230621337891, -1.47695105735436, 218, 21, 'PPL', 'P'),
(191179, 'Bronte', 31.8872203826904, 0.556536984986994, -100.291389465332, -1.75041495757, 218, 51, 'PPL', 'P'),
(19526, 'Bronwood', 31.8308296203613, 0.555552780516642, -84.3644409179688, -1.47243726562278, 218, 13, 'PPL', 'P'),
(147395, 'Bronx', 40.8499984741211, 0.712966972808073, -73.8666687011719, -1.28921657631529, 218, 40, 'PPL', 'P'),
(194643, 'Bronx', 48.3519401550293, 0.843900555432519, -116.54638671875, -2.03411817954478, 218, 17, 'PPL', 'P'),
(209329, 'Bronx', 42.9927787780762, 0.750365544258974, -110.11499786377, -1.9218692685493, 218, 59, 'PPL', 'P'),
(147398, 'Bronxdale', 40.8505592346191, 0.712976759925079, -73.866943359375, -1.28922137000525, 218, 40, 'PPL', 'P'),
(147399, 'Bronxville', 40.938060760498, 0.714503949652185, -73.8324966430664, -1.28862016138917, 218, 40, 'PPL', 'P'),
(147400, 'Bronxville Heights', 40.9661102294922, 0.714993505239569, -73.8433303833008, -1.28880924582657, 218, 40, 'PPL', 'P'),
(177793, 'Bronze Boot', 33.4858283996582, 0.584437958331859, -112.044166564941, -1.95553961421117, 218, 5, 'PPL', 'P'),
(85325, 'Broodwood', 35.8672218322754, 0.626001114516399, -86.4625015258789, -1.50905533113721, 218, 50, 'PPL', 'P'),
(122279, 'Brook', 40.8663902282715, 0.713253062888174, -87.3636093139648, -1.52478262895467, 218, 19, 'PPL', 'P'),
(63220, 'Brook Cove', 36.2863883972168, 0.633316951188901, -80.1897201538086, -1.39957464293681, 218, 33, 'PPL', 'P'),
(186455, 'Brook Forest', 39.5794410705566, 0.690791562780283, -105.381393432617, -1.8392522857387, 218, 7, 'PPL', 'P'),
(19527, 'Brook Forest Mobile Home Park', 33.8038902282715, 0.589989184466075, -84.629997253418, -1.4770720980259, 218, 13, 'PPL', 'P'),
(19528, 'Brook Glen', 33.672779083252, 0.587700863299424, -84.2352828979492, -1.47018303291808, 218, 13, 'PPL', 'P'),
(63201, 'Brook Green', 35.5986099243164, 0.621312952312451, -77.3566665649414, -1.35012852992564, 218, 33, 'PPL', 'P'),
(79972, 'Brook Green Park', 34.2319412231445, 0.597460083693047, -79.7858276367188, -1.39252538868943, 218, 48, 'PPL', 'P'),
(1152, 'Brook Highland', 33.4355583190918, 0.583560579910733, -86.6738891601563, -1.51274474135335, 218, 2, 'PPL', 'P'),
(100227, 'Brook Hill', 37.6055603027344, 0.65634084433999, -77.4444427490234, -1.35166051334271, 218, 53, 'PPL', 'P'),
(112508, 'Brook Hill', 39.9333305358887, 0.696968099138449, -76.7050018310547, -1.33875483470018, 218, 45, 'PPL', 'P'),
(45132, 'Brook Hill Acres', 39.7122192382813, 0.693108978981842, -76.8847198486328, -1.34189150583208, 218, 25, 'PPL', 'P'),
(45133, 'Brook Hill Farms', 39.524169921875, 0.689826899254429, -76.4077835083008, -1.33356739637087, 218, 25, 'PPL', 'P'),
(77924, 'Brook Hill South', 39.9300003051758, 0.696909975647658, -76.7022171020508, -1.33870623201029, 218, 45, 'PPL', 'P'),
(19529, 'Brook Hollow', 33.8222198486328, 0.590309096692021, -84.1930618286133, -1.46944613624446, 218, 13, 'PPL', 'P'),
(45134, 'Brook Hollow', 39.2236099243164, 0.684581137697245, -77.1333312988281, -1.34623059419615, 218, 25, 'PPL', 'P'),
(79973, 'Brook Hollow', 34.5625, 0.60322942272054, -82.6572189331055, -1.44264062092449, 218, 48, 'PPL', 'P'),
(114716, 'Brook Mount', 42.3855590820313, 0.739767561280031, -95.2641677856445, -1.66267338703181, 218, 16, 'PPL', 'P'),
(134418, 'Brook Park', 45.9494400024414, 0.801969017490194, -93.0752792358398, -1.62447007487852, 218, 28, 'PPL', 'P'),
(154476, 'Brook Park', 41.3983306884766, 0.722537175343327, -81.8047180175781, -1.42776167307227, 218, 41, 'PPL', 'P'),
(79974, 'Brook Pines', 34.0583305358887, 0.594430005583782, -81.1083297729492, -1.41560740533131, 218, 48, 'PPL', 'P'),
(19530, 'Brook Springs', 32.9705581665039, 0.575444796225798, -82.9461135864258, -1.44768278381633, 218, 13, 'PPL', 'P'),
(100242, 'Brook Vale', 37.7591705322266, 0.659021848609373, -76.4211120605469, -1.33380002349209, 218, 53, 'PPL', 'P'),
(63204, 'Brook Valley', 35.5875015258789, 0.621119074185093, -77.3258285522461, -1.34959030506933, 218, 33, 'PPL', 'P'),
(144903, 'Brook Valley', 40.9644393920898, 0.714964343625632, -74.3683319091797, -1.29797225103115, 218, 37, 'PPL', 'P'),
(45135, 'Brook Valley Farms', 39.702220916748, 0.692934475351415, -76.716667175293, -1.33895843336552, 218, 25, 'PPL', 'P'),
(19531, 'Brookcliff', 33.4430618286133, 0.583691540857337, -84.4880599975586, -1.47459482557991, 218, 13, 'PPL', 'P'),
(45136, 'Brookdale', 38.959171295166, 0.679965812949111, -77.0919418334961, -1.34550821175046, 218, 25, 'PPL', 'P'),
(63206, 'Brookdale', 35.3013916015625, 0.61612551398314, -82.4541702270508, -1.43909675246192, 218, 33, 'PPL', 'P'),
(71914, 'Brookdale', 38.4061088562012, 0.670313052420064, -82.5391693115234, -1.44058026634715, 218, 41, 'PPL', 'P'),
(79976, 'Brookdale', 34.9577789306641, 0.61012834152439, -82.1849975585938, -1.43439880314096, 218, 48, 'PPL', 'P'),
(114717, 'Brookdale', 42.5686111450195, 0.742962422481744, -96.4486083984375, -1.68334577551939, 218, 16, 'PPL', 'P'),
(144912, 'Brookdale', 40.833610534668, 0.712680949306998, -74.1833267211914, -1.29474330136748, 218, 37, 'PPL', 'P'),
(147402, 'Brookdale', 44.8083305358887, 0.782052900173173, -74.8919372558594, -1.30711088831175, 218, 40, 'PPL', 'P'),
(159551, 'Brookdale', 41.9772186279297, 0.73264067588687, -75.8116683959961, -1.32316322494026, 218, 45, 'PPL', 'P'),
(180268, 'Brookdale', 37.1063919067383, 0.64762871230796, -122.105003356934, -2.13113434173722, 218, 6, 'PPL', 'P'),
(206903, 'Brookdale', 47.1419410705566, 0.822782087462354, -122.381942749023, -2.13596784595766, 218, 56, 'PPL', 'P'),
(13443, 'Brookdale Heights', 39.0838890075684, 0.682142547666087, -75.4927825927734, -1.31759761773616, 218, 10, 'PPL', 'P'),
(45137, 'Brookdale Heights', 38.3788909912109, 0.669838011060621, -75.5697174072266, -1.31894038355778, 218, 25, 'PPL', 'P'),
(45138, 'Brooke Grove', 39.1994400024414, 0.684159292980577, -77.14111328125, -1.34636641541174, 218, 25, 'PPL', 'P'),
(45139, 'Brooke Jane Manor', 38.7347183227539, 0.676048369564631, -76.9000015258789, -1.34215822141525, 218, 25, 'PPL', 'P'),
(45140, 'Brooke Manor', 38.7769393920898, 0.676785266238256, -77.0033264160156, -1.3439615809474, 218, 25, 'PPL', 'P'),
(92837, 'Brookeland', 31.1525001525879, 0.543713697890695, -93.9933319091797, -1.64049311673503, 218, 51, 'PPL', 'P'),
(45141, 'Brookemanor Estates', 39.1338882446289, 0.683015198976279, -77.0913925170898, -1.34549862437054, 218, 25, 'PPL', 'P'),
(15336, 'Brooker', 29.8886108398438, 0.521654668002541, -82.3327789306641, -1.4369780746567, 218, 12, 'PPL', 'P'),
(19532, 'Brooker', 31.7472190856934, 0.554093501397333, -82.6855621337891, -1.44313530309697, 218, 13, 'PPL', 'P'),
(100229, 'Brookes Corner', 38.8666687011719, 0.678351338117277, -77.8191680908203, -1.35820070434772, 218, 53, 'PPL', 'P'),
(100230, 'Brookeshire', 37.5272216796875, 0.654973577436344, -76.7794418334961, -1.34005405783798, 218, 53, 'PPL', 'P'),
(92834, 'Brookesmith', 31.5502796173096, 0.550656259246909, -99.1183319091797, -1.72994124089974, 218, 51, 'PPL', 'P'),
(45142, 'Brookeville', 39.1805610656738, 0.683829793374707, -77.059440612793, -1.34494095843827, 218, 25, 'PPL', 'P'),
(45143, 'Brookeville Heights', 39.2019386291504, 0.684202902243427, -77.0708312988281, -1.34513976341365, 218, 25, 'PPL', 'P'),
(45144, 'Brookeville Knolls', 39.1627807617188, 0.683519468528685, -77.0691680908203, -1.34511073495777, 218, 25, 'PPL', 'P'),
(45145, 'Brookewood Cove', 39.3588905334473, 0.686942229740682, -75.9611129760742, -1.32577152491188, 218, 25, 'PPL', 'P'),
(13444, 'Brookfield', 39.0961112976074, 0.682355866869402, -75.5388870239258, -1.31840229185953, 218, 10, 'PPL', 'P'),
(19533, 'Brookfield', 31.4183292388916, 0.548353290694263, -83.39111328125, -1.45544949366138, 218, 13, 'PPL', 'P'),
(29302, 'Brookfield', 39.6377792358398, 0.691809755844047, -85.9427795410156, -1.49998447130634, 218, 19, 'PPL', 'P'),
(45148, 'Brookfield', 39.5288887023926, 0.689909257511139, -76.5733337402344, -1.33645679299555, 218, 25, 'PPL', 'P'),
(53669, 'Brookfield', 39.7844390869141, 0.694369453125777, -93.0733337402344, -1.62443611957462, 218, 29, 'PPL', 'P'),
(70581, 'Brookfield', 39.8824996948242, 0.696080933600316, -75.01611328125, -1.30927816880686, 218, 37, 'PPL', 'P'),
(85326, 'Brookfield', 35.1041717529297, 0.612683378274212, -89.8797225952148, -1.56869709006564, 218, 50, 'PPL', 'P'),
(100232, 'Brookfield', 38.3111114501953, 0.668655034904408, -77.4330596923828, -1.35146184152539, 218, 53, 'PPL', 'P'),
(118922, 'Brookfield', 41.8238906860352, 0.729964598465503, -87.8516693115234, -1.53330088285934, 218, 18, 'PPL', 'P'),
(124327, 'Brookfield', 42.2138900756836, 0.736771371895637, -72.102783203125, -1.25843096674619, 218, 23, 'PPL', 'P'),
(129961, 'Brookfield', 42.4511108398438, 0.740911655284329, -84.7966690063477, -1.4799810688846, 218, 27, 'PPL', 'P'),
(143560, 'Brookfield', 43.5588912963867, 0.760246071640249, -71.0658264160156, -1.24033265661023, 218, 36, 'PPL', 'P'),
(147407, 'Brookfield', 43.2999992370605, 0.755727552797739, -75.5697174072266, -1.31894038355778, 218, 40, 'PPL', 'P'),
(154478, 'Brookfield', 41.2338905334473, 0.719667153215576, -80.5697174072266, -1.40620684615749, 218, 41, 'PPL', 'P'),
(159552, 'Brookfield', 41.9944381713867, 0.732941213615885, -77.5936126708984, -1.35426401962437, 218, 45, 'PPL', 'P'),
(171788, 'Brookfield', 44.0422210693359, 0.76868176755113, -72.603889465332, -1.26717692092407, 218, 55, 'PPL', 'P'),
(173313, 'Brookfield', 43.0605583190918, 0.751548520415187, -88.1063919067383, -1.53774663082507, 218, 57, 'PPL', 'P'),
(177537, 'Brookfield', 41.4824981689453, 0.724006175000615, -73.4100036621094, -1.2812462678049, 218, 8, 'PPL', 'P'),
(206904, 'Brookfield', 46.2649993896484, 0.807476567782532, -123.559440612793, -2.15651906061564, 218, 56, 'PPL', 'P'),
(186456, 'Brookfield (historical)', 37.5938911437988, 0.656137179095627, -102.841667175293, -1.79492570044904, 218, 7, 'PPL', 'P'),
(85328, 'Brookfield Acres', 36.0886116027832, 0.629865094941995, -83.8616714477539, -1.46366228298903, 218, 50, 'PPL', 'P'),
(154479, 'Brookfield Center', 41.2405586242676, 0.719783533355212, -80.5580596923828, -1.40600338065021, 218, 41, 'PPL', 'P'),
(171789, 'Brookfield Center', 44.0202789306641, 0.768298804986376, -72.6050033569336, -1.26719636200003, 218, 55, 'PPL', 'P'),
(177535, 'Brookfield Center', 41.4661102294922, 0.72372015149954, -73.3880615234375, -1.28086330524015, 218, 8, 'PPL', 'P'),
(79977, 'Brookfield East', 34.853328704834, 0.608305341179204, -82.2905578613281, -1.43624117798308, 218, 48, 'PPL', 'P'),
(124328, 'Brookfield Mobile Home Park', 42.1708297729492, 0.736019827836017, -72.1305618286133, -1.25891579522264, 218, 23, 'PPL', 'P'),
(45149, 'Brookfield on the Magothy', 39.1138916015625, 0.682666191715424, -76.5416717529297, -1.33590418706936, 218, 25, 'PPL', 'P'),
(100233, 'Brookfield Park', 36.9313888549805, 0.644574332853748, -76.2330627441406, -1.33051794376468, 218, 53, 'PPL', 'P'),
(19535, 'Brookfield West', 33.5205612182617, 0.585044160374989, -82.0599975585938, -1.43221714157597, 218, 13, 'PPL', 'P'),
(79978, 'Brookfield West', 34.8566703796387, 0.608363664407077, -82.2986068725586, -1.43638165973058, 218, 48, 'PPL', 'P'),
(19536, 'Brookfield Woods', 33.6411094665527, 0.587148124215178, -84.1958312988281, -1.46949447261824, 218, 13, 'PPL', 'P'),
(63209, 'Brookford', 35.7030601501465, 0.623135952657637, -81.3480606079102, -1.41979149771993, 218, 33, 'PPL', 'P'),
(79979, 'Brookforest Estates', 34.7833290100098, 0.60708361602913, -82.3827819824219, -1.43785079254592, 218, 48, 'PPL', 'P'),
(79980, 'Brookgate', 33.7158317565918, 0.58845227420099, -78.9625015258789, -1.37815563723763, 218, 48, 'PPL', 'P'),
(63210, 'Brookgreen', 35.8005599975586, 0.624837646015171, -80.8691711425781, -1.41143329979677, 218, 33, 'PPL', 'P'),
(79982, 'Brookgreen', 34.9822196960449, 0.610554913351994, -82.4002838134766, -1.43815625712296, 218, 48, 'PPL', 'P'),
(13445, 'Brookhaven', 39.6966705322266, 0.692837602866763, -75.6913909912109, -1.32106398821101, 218, 10, 'PPL', 'P'),
(19538, 'Brookhaven', 32.4505615234375, 0.566369142704971, -84.9444427490234, -1.48256020724228, 218, 13, 'PPL', 'P'),
(31891, 'Brookhaven', 37.6958312988281, 0.657916370440881, -97.1544418334961, -1.69566489293182, 218, 20, 'PPL', 'P'),
(35004, 'Brookhaven', 38.0016708374023, 0.663254277371782, -84.5138931274414, -1.47504569875246, 218, 21, 'PPL', 'P'),
(58795, 'Brookhaven', 31.5788898468018, 0.551155601951298, -90.440559387207, -1.57848553865223, 218, 30, 'PPL', 'P'),
(77926, 'Brookhaven', 39.8691711425781, 0.695848306479098, -75.3827819824219, -1.31567774490632, 218, 45, 'PPL', 'P'),
(79984, 'Brookhaven', 34.8941688537598, 0.609018136244964, -82.0475006103516, -1.43199902868269, 218, 48, 'PPL', 'P'),
(85329, 'Brookhaven', 35.9319381713867, 0.627130627713729, -85.0069427490234, -1.48365103802478, 218, 50, 'PPL', 'P'),
(92836, 'Brookhaven', 29.6747207641602, 0.517921581944522, -95.3627777099609, -1.66439445488628, 218, 51, 'PPL', 'P'),
(100234, 'Brookhaven', 38.9302787780762, 0.679461543396704, -77.1636123657227, -1.34675909851447, 218, 53, 'PPL', 'P'),
(108370, 'Brookhaven', 39.6116714477539, 0.691354088981535, -79.9047164916992, -1.39460039065276, 218, 58, 'PPL', 'P'),
(122280, 'Brookhaven', 40.519718170166, 0.707202494049569, -85.6158294677734, -1.49427811603863, 218, 19, 'PPL', 'P'),
(147405, 'Brookhaven', 40.7791709899902, 0.711730800009085, -72.9158325195313, -1.27262135429857, 218, 40, 'PPL', 'P'),
(13446, 'Brookhaven Estates', 39.0569381713867, 0.681672166838552, -75.5002822875977, -1.31772851210374, 218, 10, 'PPL', 'P'),
(39518, 'Brookhaven Estates', 32.5733299255371, 0.568511855539022, -93.6374969482422, -1.63428262507297, 218, 22, 'PPL', 'P'),
(79985, 'Brookhaven Estates', 33.4986114501953, 0.584661064652181, -81.7133331298828, -1.42616670589542, 218, 48, 'PPL', 'P'),
(71916, 'Brookhill', 39.2113914489746, 0.684367885072957, -84.4972229003906, -1.47475474840337, 218, 41, 'PPL', 'P'),
(85330, 'Brookhill', 35.8283309936523, 0.625322341333565, -86.4422225952148, -1.50870139702834, 218, 50, 'PPL', 'P'),
(13447, 'Brookhill Farms', 39.7758293151855, 0.694219184261269, -75.6861114501953, -1.32097184283729, 218, 10, 'PPL', 'P'),
(19541, 'Brookhollow', 31.565559387207, 0.550922941540566, -84.2536087036133, -1.470502878565, 218, 13, 'PPL', 'P'),
(39519, 'Brookhollow Glen', 30.3597202301025, 0.52987707799962, -91.0625, -1.58934045009734, 218, 22, 'PPL', 'P'),
(1155, 'Brookhurst', 34.7830581665039, 0.607078888918195, -86.6050033569336, -1.51154245727923, 218, 2, 'PPL', 'P'),
(45150, 'Brookhurst', 39.3963890075684, 0.687596701578569, -76.4680633544922, -1.33461947815951, 218, 25, 'PPL', 'P'),
(143562, 'Brookhurst', 43.5080604553223, 0.759358906102117, -71.2644424438477, -1.24379916024314, 218, 36, 'PPL', 'P'),
(180271, 'Brookhurst', 33.8444404602051, 0.590696919525764, -117.957778930664, -2.05875162067968, 218, 6, 'PPL', 'P'),
(209330, 'Brookhurst', 42.8574981689453, 0.748004452215537, -106.235832214355, -1.85416505573676, 218, 59, 'PPL', 'P'),
(159554, 'Brookhurst Estates', 41.357780456543, 0.721829440283638, -75.5611114501953, -1.3187901812723, 218, 45, 'PPL', 'P'),
(7700, 'Brookings', 36.2849998474121, 0.633292716422981, -90.7205581665039, -1.58337243925252, 218, 4, 'PPL', 'P'),
(169908, 'Brookings', 44.3113899230957, 0.773379650293057, -96.7980575561523, -1.68944481388983, 218, 49, 'PPL', 'P'),
(200461, 'Brookings', 42.0527801513672, 0.733959473258677, -124.282783508301, -2.16914377576316, 218, 43, 'PPL', 'P'),
(7701, 'Brookland', 35.9000015258789, 0.626573228097575, -90.5819396972656, -1.58095309056024, 218, 4, 'PPL', 'P'),
(13045, 'Brookland', 38.9327812194824, 0.679505219238581, -76.9844436645508, -1.3436320147625, 218, 9, 'PPL', 'P'),
(45151, 'Brookland', 38.9911117553711, 0.680523279144291, -76.8202819824219, -1.34076685290374, 218, 25, 'PPL', 'P'),
(159555, 'Brookland', 41.8288917541504, 0.730051883570231, -77.7977828979492, -1.35782746232095, 218, 45, 'PPL', 'P'),
(100235, 'Brookland Estates', 38.7880592346191, 0.676979344102696, -77.1313934326172, -1.3461967720503, 218, 53, 'PPL', 'P'),
(63214, 'Brookland Manor', 35.2997207641602, 0.616096352369203, -82.4477767944336, -1.43898516601224, 218, 33, 'PPL', 'P'),
(13448, 'Brookland Terrace', 39.7433280944824, 0.693651930949082, -75.623893737793, -1.31988593890281, 218, 10, 'PPL', 'P'),
(45152, 'Brooklandville', 39.420280456543, 0.688013686026248, -76.670280456543, -1.33814883239414, 218, 25, 'PPL', 'P'),
(45153, 'Brooklandwood Estates', 39.4230613708496, 0.688062222137115, -76.6736068725586, -1.3382068893059, 218, 25, 'PPL', 'P'),
(1156, 'Brooklane Place', 33.4372215270996, 0.583589608366615, -86.9819412231445, -1.51812126412006, 218, 2, 'PPL', 'P'),
(70577, 'Brooklawn', 39.8741683959961, 0.695935525004798, -75.120002746582, -1.31109138203504, 218, 37, 'PPL', 'P'),
(100237, 'Brooklawn', 37.336669921875, 0.651647821867053, -79.9716720581055, -1.39576898573909, 218, 53, 'PPL', 'P'),
(159556, 'Brooklawn', 40.0900001525879, 0.699702499787688, -76.3008270263672, -1.33170065360478, 218, 45, 'PPL', 'P'),
(63215, 'Brooklawn Park', 35.5252799987793, 0.620033103671586, -82.5411071777344, -1.44061408849299, 218, 33, 'PPL', 'P'),
(693, 'Brookleigh', 32.2063903808594, 0.562107552328627, -90.2522201538086, -1.57519839891874, 218, 30, 'PPL', 'P'),
(19542, 'Brooklet', 32.3794403076172, 0.565127843320886, -81.663330078125, -1.4252939880062, 218, 13, 'PPL', 'P'),
(85331, 'Brooklin', 36.0502815246582, 0.629196108876167, -86.6147232055664, -1.51171210064067, 218, 50, 'PPL', 'P'),
(108371, 'Brooklin', 37.6730613708496, 0.657518960227214, -80.8974990844727, -1.41192771565315, 218, 58, 'PPL', 'P'),
(126962, 'Brooklin', 44.2661094665527, 0.772589357239576, -68.5697174072266, -1.19676733591817, 218, 26, 'PPL', 'P'),
(53672, 'Brookline', 37.163330078125, 0.648622470868723, -93.4199981689453, -1.63048655525517, 218, 29, 'PPL', 'P'),
(124330, 'Brookline', 42.3316688537598, 0.738826999362042, -71.1216735839844, -1.2413073735692, 218, 23, 'PPL', 'P'),
(143563, 'Brookline', 42.7347183227539, 0.745861539644404, -71.6586074829102, -1.25067863797103, 218, 36, 'PPL', 'P'),
(159557, 'Brookline', 40.3919410705566, 0.704972362952737, -80.0180587768555, -1.39657858671047, 218, 45, 'PPL', 'P'),
(171791, 'Brookline', 43.0316696166992, 0.751044317441808, -72.601936340332, -1.26714283246212, 218, 55, 'PPL', 'P'),
(124331, 'Brookline Village', 42.3327789306641, 0.738846373858972, -71.1166687011719, -1.24122002188545, 218, 23, 'PPL', 'P'),
(1159, 'Brooklyn', 34.225830078125, 0.597353424091389, -86.6152801513672, -1.51172182117865, 218, 2, 'PPL', 'P'),
(15337, 'Brooklyn', 30.3233299255371, 0.52924194736915, -81.6747207641602, -1.42549279298157, 218, 12, 'PPL', 'P'),
(29303, 'Brooklyn', 39.5391693115234, 0.690088687989584, -86.3691711425781, -1.50742640865646, 218, 19, 'PPL', 'P'),
(35005, 'Brooklyn', 37.2897186279297, 0.650828367199635, -86.5763931274414, -1.51104311457484, 218, 21, 'PPL', 'P'),
(45154, 'Brooklyn', 39.230281829834, 0.684697584415909, -76.6025009155273, -1.33696585623792, 218, 25, 'PPL', 'P'),
(58798, 'Brooklyn', 33.1725006103516, 0.578969356770463, -90.4863891601563, -1.57928541908563, 218, 30, 'PPL', 'P'),
(79986, 'Brooklyn', 35.1805610656738, 0.614016623294933, -81.9258270263672, -1.42987542402946, 218, 48, 'PPL', 'P'),
(100239, 'Brooklyn', 37.1511116027832, 0.648409218244435, -80.5605621337891, -1.40604705649209, 218, 53, 'PPL', 'P'),
(108373, 'Brooklyn', 39.6352806091309, 0.691766146581197, -80.8636093139648, -1.41133622757504, 218, 58, 'PPL', 'P'),
(112268, 'Brooklyn', 32.1736106872559, 0.56153543874745, -84.708610534668, -1.47844415861951, 218, 13, 'PPL', 'P'),
(114721, 'Brooklyn', 41.7336082458496, 0.728388872627531, -92.4452819824219, -1.61347454852785, 218, 16, 'PPL', 'P'),
(118925, 'Brooklyn', 40.225830078125, 0.702073179211049, -90.7630615234375, -1.58411426277416, 218, 18, 'PPL', 'P'),
(129960, 'Brooklyn', 42.1058311462402, 0.73488538779067, -84.2483291625977, -1.47041073319129, 218, 27, 'PPL', 'P'),
(134422, 'Brooklyn', 47.4397201538086, 0.827979312908671, -92.9208297729492, -1.62177442322314, 218, 28, 'PPL', 'P'),
(139053, 'Brooklyn', 40.3983306884766, 0.705083882823384, -94.0405578613281, -1.64131736509241, 218, 29, 'PPL', 'P'),
(147409, 'Brooklyn', 42.3441696166992, 0.739045178834347, -75.1708297729492, -1.31197848099415, 218, 40, 'PPL', 'P'),
(154481, 'Brooklyn', 41.4397201538086, 0.723259557789011, -81.7355575561523, -1.42655459530819, 218, 41, 'PPL', 'P'),
(159559, 'Brooklyn', 41.9091682434082, 0.731452972619722, -77.1416702270508, -1.34637613594972, 218, 45, 'PPL', 'P'),
(173316, 'Brooklyn', 42.8536109924316, 0.747936608186767, -89.3702774047852, -1.55980559413419, 218, 57, 'PPL', 'P'),
(177538, 'Brooklyn', 41.7880592346191, 0.729339221662526, -71.9502792358398, -1.25576927039472, 218, 8, 'PPL', 'P'),
(200463, 'Brooklyn', 45.4905586242676, 0.793960026564971, -122.636108398438, -2.1404038733854, 218, 43, 'PPL', 'P'),
(206905, 'Brooklyn', 46.7763900756836, 0.816402019017878, -123.508613586426, -2.15563196165653, 218, 56, 'PPL', 'P'),
(39520, 'Brooklyn (historical)', 32.2652816772461, 0.563135399351343, -92.3805618286133, -1.6123449687515, 218, 22, 'PPL', 'P'),
(58799, 'Brooklyn (historical)', 32.9533309936523, 0.575144125338728, -88.4583282470703, -1.54388907872128, 218, 30, 'PPL', 'P'),
(63216, 'Brooklyn (historical)', 35.9661102294922, 0.627727042639852, -77.9691696166992, -1.36081872485733, 218, 33, 'PPL', 'P'),
(134423, 'Brooklyn Center', 45.0761108398438, 0.78672654814918, -93.3324966430664, -1.62895936552806, 218, 28, 'PPL', 'P'),
(29304, 'Brooklyn Heights', 39.8202781677246, 0.694994963086809, -86.2091674804688, -1.5046338179374, 218, 19, 'PPL', 'P'),
(53674, 'Brooklyn Heights', 37.1733283996582, 0.64879697449915, -94.383056640625, -1.6472950964752, 218, 29, 'PPL', 'P'),
(85332, 'Brooklyn Heights', 36.2041702270508, 0.631881973414539, -86.7866668701172, -1.51471308371503, 218, 50, 'PPL', 'P'),
(154483, 'Brooklyn Heights', 41.4252815246582, 0.723007556170862, -81.6883316040039, -1.42573034695081, 218, 41, 'PPL', 'P'),
(180272, 'Brooklyn Heights', 34.0486106872559, 0.594260362222344, -118.211112976074, -2.06317313387949, 218, 6, 'PPL', 'P'),
(45155, 'Brooklyn Homes', 39.2291717529297, 0.684678209918979, -76.6005630493164, -1.33693203409208, 218, 25, 'PPL', 'P'),
(45156, 'Brooklyn Manor', 39.2241706848145, 0.684590924814251, -76.5899963378906, -1.33674761018659, 218, 25, 'PPL', 'P'),
(147412, 'Brooklyn Manor', 40.6947212219238, 0.710256873503781, -73.8480606079102, -1.28889180382036, 218, 40, 'PPL', 'P'),
(45157, 'Brooklyn Park', 39.228328704834, 0.684663495953956, -76.6166687011719, -1.33721313074514, 218, 25, 'PPL', 'P'),
(134425, 'Brooklyn Park', 45.0941696166992, 0.787041733264191, -93.3561096191406, -1.62937148970675, 218, 28, 'PPL', 'P'),
(45158, 'Brooklyn Terrace', 39.2027816772461, 0.684217616208449, -76.6100006103516, -1.3370967506055, 218, 25, 'PPL', 'P'),
(19544, 'Brookman', 31.1908302307129, 0.544382683956523, -81.6591720581055, -1.42522141686649, 218, 13, 'PPL', 'P'),
(147414, 'Brookman Corners', 42.9172210693359, 0.749046813466194, -74.7266693115234, -1.30422641853509, 218, 40, 'PPL', 'P'),
(45159, 'Brookmead', 39.1172218322754, 0.682724315206215, -77.3019409179688, -1.34917338720068, 218, 25, 'PPL', 'P'),
(85333, 'Brookmead', 36.5177803039551, 0.637355501823952, -82.2050018310547, -1.43474794355987, 218, 50, 'PPL', 'P'),
(45160, 'Brookmead North', 39.1197204589844, 0.682767924469065, -77.3005599975586, -1.34914928559282, 218, 25, 'PPL', 'P'),
(13449, 'Brookmeade', 39.7541694641113, 0.693841148544532, -75.6291732788086, -1.31997808427653, 218, 10, 'PPL', 'P'),
(63217, 'Brookmeade', 35.8025016784668, 0.624871534740042, -80.8127822875977, -1.41044912861593, 218, 33, 'PPL', 'P'),
(45161, 'Brookmere Farms', 39.4644393920898, 0.688784404845717, -77.4622192382813, -1.3519707716097, 218, 25, 'PPL', 'P'),
(45162, 'Brookmont', 38.9419403076172, 0.679665075483013, -77.1205596923828, -1.34600768761291, 218, 25, 'PPL', 'P'),
(13450, 'Brookmont Farms', 39.6277809143066, 0.69163525221362, -75.692497253418, -1.32108329612891, 218, 10, 'PPL', 'P'),
(29305, 'Brookmoor', 39.5675010681152, 0.690583170424984, -86.3747177124023, -1.50752321456209, 218, 19, 'PPL', 'P'),
(100240, 'Brookneal', 37.0499992370605, 0.646644474548094, -78.9444427490234, -1.37784045212262, 218, 53, 'PPL', 'P'),
(100241, 'Brookneil', 39.1355590820313, 0.683044360590215, -78.2411117553711, -1.36556501055207, 218, 53, 'PPL', 'P'),
(71917, 'Brookover (historical)', 39.9238891601563, 0.696803316046, -81.9341735839844, -1.43002109894109, 218, 41, 'PPL', 'P'),
(71918, 'Brookover Estates', 38.4541702270508, 0.671151881584412, -82.3388900756836, -1.43708473425836, 218, 41, 'PPL', 'P'),
(26614, 'Brookport', 37.1236114501953, 0.647929250036975, -88.6302795410156, -1.54689019495369, 218, 18, 'PPL', 'P'),
(15338, 'Brookridge', 28.5508308410645, 0.498306002356517, -82.4922180175781, -1.43976081167973, 218, 12, 'PPL', 'P'),
(45163, 'Brookridge Manor', 38.7680587768555, 0.676630270262814, -76.7527770996094, -1.33958867043749, 218, 25, 'PPL', 'P'),
(45164, 'Brookridge North', 39.4500007629395, 0.688532403227568, -77.5580596923828, -1.35364350309038, 218, 25, 'PPL', 'P'),
(1162, 'Brooks', 31.4816703796387, 0.549458802152268, -86.6849975585938, -1.51293861948071, 218, 2, 'PPL', 'P'),
(7703, 'Brooks', 34.5661087036133, 0.603292406480321, -92.4475021362305, -1.61351329752171, 218, 4, 'PPL', 'P'),
(19546, 'Brooks', 32.9097213745117, 0.574382993899183, -83.3816680908203, -1.45528464398991, 218, 13, 'PPL', 'P'),
(26615, 'Brooks', 38.774169921875, 0.676736929864471, -90.0899963378906, -1.57236705920583, 218, 18, 'PPL', 'P'),
(29306, 'Brooks', 39.9383316040039, 0.697055384243176, -85.9191665649414, -1.49957234712765, 218, 19, 'PPL', 'P'),
(31892, 'Brooks', 37.3847198486328, 0.652486451294319, -95.6025009155273, -1.66857841411685, 218, 20, 'PPL', 'P'),
(35006, 'Brooks', 38.0611114501953, 0.664291711774422, -85.709716796875, -1.49591675905736, 218, 21, 'PPL', 'P'),
(39521, 'Brooks', 30.7280597686768, 0.536305815713017, -91.4852828979492, -1.59671940368767, 218, 22, 'PPL', 'P'),
(58800, 'Brooks', 33.7961082458496, 0.589853363250481, -90.460563659668, -1.57883467907114, 218, 30, 'PPL', 'P'),
(108374, 'Brooks', 37.7241706848145, 0.658410986034336, -80.8866729736328, -1.41173876437381, 218, 58, 'PPL', 'P'),
(114722, 'Brooks', 40.9652786254883, 0.714978991011628, -94.8047180175781, -1.65465447583153, 218, 16, 'PPL', 'P'),
(124333, 'Brooks', 42.413890838623, 0.740262043715431, -71.8986129760742, -1.25486752404961, 218, 23, 'PPL', 'P'),
(126964, 'Brooks', 44.5502815246582, 0.777549095295685, -69.1213912963867, -1.2063958616813, 218, 26, 'PPL', 'P'),
(134427, 'Brooks', 47.8144416809082, 0.83451943733466, -96.0019378662109, -1.6755499040604, 218, 28, 'PPL', 'P'),
(173321, 'Brooks', 43.8252792358398, 0.76489541827131, -89.6444396972656, -1.56459062882279, 218, 57, 'PPL', 'P'),
(177653, 'Brooks', 38.7416687011719, 0.676169676552284, -122.146942138672, -2.13186631156283, 218, 6, 'PPL', 'P'),
(196090, 'Brooks', 47.2041702270508, 0.823868191133915, -109.420562744141, -1.9097490892703, 218, 31, 'PPL', 'P'),
(200462, 'Brooks', 45.0483283996582, 0.786241653093704, -122.957221984863, -2.14600836274142, 218, 43, 'PPL', 'P'),
(7704, 'Brooks (historical)', 34.5666694641113, 0.603302193597327, -92.4472198486328, -1.6135083706737, 218, 4, 'PPL', 'P'),
(1163, 'Brooks Acres', 34.8347206115723, 0.607980568684269, -87.5052795410156, -1.52725524086876, 218, 2, 'PPL', 'P'),
(147415, 'Brooks Corner', 42.7661094665527, 0.746409418459661, -75.4972229003906, -1.31767511572388, 218, 40, 'PPL', 'P'),
(92839, 'Brooks Crossing', 31.1161098480225, 0.543078567260224, -98.0550003051758, -1.71138260336936, 218, 51, 'PPL', 'P'),
(1164, 'Brooks Crossroads', 34.5963897705078, 0.603820910798647, -85.7844390869141, -1.49722090904317, 218, 2, 'PPL', 'P'),
(63221, 'Brooks Crossroads', 36.1199989318848, 0.630412907178224, -80.7733306884766, -1.40976056831609, 218, 33, 'PPL', 'P'),
(19551, 'Brooks Estates', 33.9327812194824, 0.592238756638865, -84.7555618286133, -1.47926361328693, 218, 13, 'PPL', 'P'),
(19549, 'Brooks Farm', 33.9444389343262, 0.592442222146147, -84.7375030517578, -1.47894842817192, 218, 13, 'PPL', 'P'),
(147416, 'Brooks Grove', 42.6305618286133, 0.744043665884316, -77.9283294677734, -1.36010592979157, 218, 40, 'PPL', 'P'),
(45165, 'Brooks Hill', 39.2724990844727, 0.685434414510507, -76.5316696166992, -1.33572961685991, 218, 25, 'PPL', 'P'),
(53675, 'Brooks Junction', 37.024169921875, 0.64619366795457, -89.6425018310547, -1.56455680667695, 218, 29, 'PPL', 'P'),
(19550, 'Brooks Manor', 33.5800018310547, 0.586081594777629, -84.4263916015625, -1.47351850902535, 218, 13, 'PPL', 'P'),
(159561, 'Brooks Mill', 40.3736114501953, 0.704652450726791, -78.4230575561523, -1.36874056383588, 218, 45, 'PPL', 'P'),
(193402, 'Brooks Mill', 41.2794418334961, 0.720462173379992, -120.309722900391, -2.09980078677384, 218, 6, 'PPL', 'P'),
(124334, 'Brooks Place', 42.0374984741211, 0.733692757675505, -71.0208282470703, -1.23954729040477, 218, 23, 'PPL', 'P'),
(45176, 'Brooks View', 38.6800003051758, 0.675093359997729, -76.7074966430664, -1.33879837738401, 218, 25, 'PPL', 'P'),
(124335, 'Brooks Village', 42.5625, 0.742855762880086, -72.107780456543, -1.25851818527189, 218, 23, 'PPL', 'P'),
(29307, 'Brooksburg', 38.7363891601563, 0.676077531178568, -85.2436065673828, -1.48778160087549, 218, 19, 'PPL', 'P'),
(147417, 'Brooksburg', 42.3027801513672, 0.738322796388663, -74.2072219848633, -1.29516035239419, 218, 40, 'PPL', 'P'),
(63222, 'Brooksdale', 36.3741683959961, 0.634849001184996, -78.980827331543, -1.37847548288455, 218, 33, 'PPL', 'P'),
(92840, 'Brookshire', 29.7858295440674, 0.519860795981777, -95.9508285522461, -1.67465787825328, 218, 51, 'PPL', 'P'),
(180275, 'Brookshire', 37.7591705322266, 0.659021848609373, -122.027221679688, -2.12977679537155, 218, 6, 'PPL', 'P'),
(203171, 'Brookshire Estates', 40.6333312988281, 0.709185417218215, -111.934722900391, -1.95362946191931, 218, 52, 'PPL', 'P'),
(85335, 'Brookshire Hills', 36.5819396972656, 0.638475294483303, -82.6419372558594, -1.44237390534131, 218, 50, 'PPL', 'P'),
(1168, 'Brookside', 34.0008316040039, 0.593426459906013, -87.7452774047852, -1.53144399378929, 218, 2, 'PPL', 'P'),
(13451, 'Brookside', 39.6669387817383, 0.692318685928361, -75.7272186279297, -1.32168929843496, 218, 10, 'PPL', 'P'),
(15339, 'Brookside', 27.767219543457, 0.484629405157442, -80.5516662597656, -1.40589179420054, 218, 12, 'PPL', 'P'),
(35008, 'Brookside', 36.8591690063477, 0.643313858709813, -83.2494430541992, -1.4529768817473, 218, 21, 'PPL', 'P'),
(45167, 'Brookside', 38.6647186279297, 0.674826644414557, -76.5427780151367, -1.33592349498727, 218, 25, 'PPL', 'P'),
(53676, 'Brookside', 37.459171295166, 0.653785874169196, -89.6961135864258, -1.56549250832595, 218, 29, 'PPL', 'P'),
(58801, 'Brookside', 31.2997207641602, 0.54628318228943, -90.7525024414063, -1.58392997202673, 218, 30, 'PPL', 'P'),
(79988, 'Brookside', 34.1725006103516, 0.596422649290407, -82.2002792358398, -1.43466551872413, 218, 48, 'PPL', 'P'),
(85336, 'Brookside', 36.2527809143066, 0.632730389958811, -84.3483276367188, -1.47215603581167, 218, 50, 'PPL', 'P'),
(100243, 'Brookside', 37.3269386291504, 0.651477978768533, -79.9458312988281, -1.39531797940849, 218, 53, 'PPL', 'P'),
(108375, 'Brookside', 39.3258285522461, 0.686365189311489, -79.5266723632813, -1.38800227589404, 218, 58, 'PPL', 'P'),
(118928, 'Brookside', 41.9358291625977, 0.731918293441186, -88.432502746582, -1.54343833870679, 218, 18, 'PPL', 'P'),
(124336, 'Brookside', 42.1688919067383, 0.735986005690173, -73.357780456543, -1.28033480092182, 218, 23, 'PPL', 'P'),
(129963, 'Brookside', 44.7422218322754, 0.780899085630896, -85.6466674804688, -1.49481634089494, 218, 27, 'PPL', 'P'),
(144904, 'Brookside', 40.7941703796387, 0.71199258874424, -74.5683288574219, -1.30146285627191, 218, 37, 'PPL', 'P'),
(154490, 'Brookside', 40.0705604553223, 0.699363213064812, -80.7611083984375, -1.40954724911278, 218, 41, 'PPL', 'P'),
(159567, 'Brookside', 41.5750007629395, 0.725620649832448, -75.9358291625977, -1.32533023911926, 218, 45, 'PPL', 'P'),
(171794, 'Brookside', 42.9449996948242, 0.749531641942643, -72.7536087036133, -1.26979001458566, 218, 55, 'PPL', 'P'),
(173323, 'Brookside', 44.8047218322754, 0.781989916413392, -87.9977798461914, -1.53585099276115, 218, 57, 'PPL', 'P'),
(186457, 'Brookside', 38.4152793884277, 0.670473108401578, -105.191390991211, -1.83593611754933, 218, 7, 'PPL', 'P'),
(63223, 'Brookside (historical)', 36.2874984741211, 0.633336325685831, -81.6125030517578, -1.42440688904709, 218, 33, 'PPL', 'P'),
(196091, 'Brookside (historical)', 48.0883293151855, 0.839299678333298, -108.323890686035, -1.89060855104173, 218, 31, 'PPL', 'P'),
(122281, 'Brookside Estates', 41.146671295166, 0.718144890336487, -85.0791702270508, -1.48491164532677, 218, 19, 'PPL', 'P'),
(45168, 'Brookside Forest', 39.0072212219238, 0.680804442376377, -77.004997253418, -1.34399074256133, 218, 25, 'PPL', 'P'),
(70579, 'Brookside Heights', 39.961669921875, 0.697462714731904, -74.1602783203125, -1.29434103088482, 218, 37, 'PPL', 'P'),
(45169, 'Brookside Manor', 38.9647216796875, 0.680062685433762, -76.9766693115234, -1.34349632670496, 218, 25, 'PPL', 'P'),
(85337, 'Brookside Mill', 36.0155601501465, 0.628590106570119, -83.0975036621094, -1.45032503909185, 218, 50, 'PPL', 'P'),
(154486, 'Brookside Park', 41.2658309936523, 0.720224619410757, -80.8369369506836, -1.41087070701649, 218, 41, 'PPL', 'P'),
(203172, 'Brookside Park', 40.646671295166, 0.709418244076515, -111.836387634277, -1.95191318775481, 218, 52, 'PPL', 'P'),
(71920, 'Brookside Park Mobile Home Park', 39.9497184753418, 0.697254122639523, -83.679443359375, -1.4604818028572, 218, 41, 'PPL', 'P'),
(124337, 'Brookside Station', 42.6083297729492, 0.743655643313492, -71.4116668701172, -1.2463687112209, 218, 23, 'PPL', 'P'),
(171795, 'Brookside Trailer Park', 43.5936088562012, 0.76085200736727, -72.9647216796875, -1.27347463111183, 218, 55, 'PPL', 'P'),
(19552, 'Brookside Village', 33.8041687011719, 0.589994044735064, -84.517219543457, -1.47510375566422, 218, 13, 'PPL', 'P'),
(79990, 'Brookside Village', 34.9191703796387, 0.609454495189573, -82.0833282470703, -1.43262433890664, 218, 48, 'PPL', 'P'),
(92841, 'Brookside Village', 29.586669921875, 0.516384804837492, -95.3249969482422, -1.66373505620037, 218, 51, 'PPL', 'P'),
(63225, 'Brookston', 36.3663902282715, 0.63471324654843, -78.3408279418945, -1.36730538632443, 218, 33, 'PPL', 'P'),
(92842, 'Brookston', 33.6230583190918, 0.586833072258222, -95.6991729736328, -1.67026565982547, 218, 51, 'PPL', 'P'),
(122282, 'Brookston', 40.6027793884277, 0.708652185788954, -86.8672180175781, -1.51611896645448, 218, 19, 'PPL', 'P'),
(134429, 'Brookston', 46.8677787780762, 0.817997052773754, -92.6036071777344, -1.61623784447492, 218, 28, 'PPL', 'P'),
(159568, 'Brookston', 41.6175003051758, 0.726362406775062, -78.9786071777344, -1.37843673389069, 218, 45, 'PPL', 'P'),
(19554, 'Brookstone', 33.7597198486328, 0.589218265909524, -84.648063659668, -1.47738741629897, 218, 13, 'PPL', 'P'),
(203173, 'Brookstone Condo', 40.6333312988281, 0.709185417218215, -111.845558166504, -1.95207324373633, 218, 52, 'PPL', 'P'),
(39523, 'Brookstown', 30.4933300018311, 0.53220900842912, -91.1283264160156, -1.5904893377916, 218, 22, 'PPL', 'P'),
(177540, 'Brooksvale', 41.4691696166992, 0.723773547879396, -72.916389465332, -1.27263107483655, 218, 8, 'PPL', 'P'),
(1171, 'Brooksville', 34.5008316040039, 0.602153106165985, -86.8550033569336, -1.51590578040922, 218, 2, 'PPL', 'P'),
(15340, 'Brooksville', 28.5550003051758, 0.498378773233303, -82.3880615234375, -1.43794293791964, 218, 12, 'PPL', 'P'),
(19557, 'Brooksville', 31.8733291625977, 0.556294537459256, -84.6566696166992, -1.47753761858445, 218, 13, 'PPL', 'P'),
(35009, 'Brooksville', 38.6824989318848, 0.675136969260579, -84.0658264160156, -1.4672254593695, 218, 21, 'PPL', 'P'),
(58802, 'Brooksville', 33.2344398498535, 0.580050400435954, -88.5822219848633, -1.54605143236837, 218, 30, 'PPL', 'P'),
(75232, 'Brooksville', 35.1980590820313, 0.614322021292938, -96.9680633544922, -1.69241197481835, 218, 42, 'PPL', 'P'),
(79991, 'Brooksville', 33.9061088562012, 0.591773236080319, -78.6588897705078, -1.37285661245865, 218, 48, 'PPL', 'P'),
(126966, 'Brooksville', 44.3466682434082, 0.773995373137083, -68.6841735839844, -1.19876497305184, 218, 26, 'PPL', 'P'),
(171796, 'Brooksville', 44.065559387207, 0.769089098039858, -73.1733322143555, -1.27711557179614, 218, 55, 'PPL', 'P'),
(85338, 'Brooksville (historical)', 35.5050010681152, 0.619679169562714, -86.0097198486328, -1.50115280007656, 218, 50, 'PPL', 'P'),
(77929, 'Brookthorpe Hills', 39.9833297729492, 0.697840750448641, -75.3463897705078, -1.31504258098634, 218, 45, 'PPL', 'P'),
(19558, 'Brookton', 34.4449996948242, 0.601178655523125, -83.7794418334961, -1.46222710547758, 218, 13, 'PPL', 'P'),
(126968, 'Brookton', 45.5297203063965, 0.79464352685874, -67.76611328125, -1.18274179803727, 218, 26, 'PPL', 'P'),
(129964, 'Brookton Corners', 46.5494384765625, 0.812440966370549, -87.4558334350586, -1.52639224351752, 218, 27, 'PPL', 'P'),
(147418, 'Brooktondale', 42.3805618286133, 0.739680342754331, -76.3949966430664, -1.33334422347152, 218, 40, 'PPL', 'P'),
(180276, 'Brooktrails', 39.4438896179199, 0.688425743625911, -123.384170532227, -2.15346002062952, 218, 6, 'PPL', 'P'),
(139724, 'Brooktree Park', 47.003059387207, 0.820358144817191, -96.8955612182617, -1.69114657382639, 218, 34, 'PPL', 'P'),
(147419, 'Brookvale', 42.125560760498, 0.735229734519617, -75.7866668701172, -1.32272686599565, 218, 40, 'PPL', 'P'),
(186458, 'Brookvale', 39.6297187805176, 0.691669074359464, -105.418609619141, -1.83990183072857, 218, 7, 'PPL', 'P'),
(19559, 'Brookvale Estates', 34.9713897705078, 0.610365895493626, -85.2347183227539, -1.48762647174199, 218, 13, 'PPL', 'P'),
(45170, 'Brookview', 38.5752792358398, 0.673265632541607, -75.79638671875, -1.32289650935709, 218, 25, 'PPL', 'P'),
(144905, 'Brookview', 40.4205589294434, 0.705471838815181, -74.4744415283203, -1.29982421325319, 218, 37, 'PPL', 'P'),
(147420, 'Brookview', 42.5411109924316, 0.742482454274285, -73.7202835083008, -1.28666167272353, 218, 40, 'PPL', 'P'),
(45171, 'Brookview Farms', 39.4091682434082, 0.687819741319863, -76.5663909912109, -1.33633561916596, 218, 25, 'PPL', 'P'),
(29308, 'Brookville', 39.4230613708496, 0.688062222137115, -85.0127792358398, -1.48375290393647, 218, 19, 'PPL', 'P'),
(31893, 'Brookville', 38.7750015258789, 0.676751444092412, -97.8680572509766, -1.70811983155985, 218, 20, 'PPL', 'P'),
(71922, 'Brookville', 39.836669921875, 0.695281053166911, -84.4113922119141, -1.4732567202902, 218, 41, 'PPL', 'P'),
(100246, 'Brookville', 37.3600006103516, 0.652055019197726, -79.208610534668, -1.38245104975982, 218, 53, 'PPL', 'P'),
(114723, 'Brookville', 41.0555610656738, 0.7165547168496, -92.0888900756836, -1.60725433632781, 218, 16, 'PPL', 'P'),
(118930, 'Brookville', 40.0647201538086, 0.699261280574089, -87.6063919067383, -1.5290199845651, 218, 18, 'PPL', 'P'),
(124338, 'Brookville', 42.125, 0.735219947402611, -71.0097198486328, -1.23935341227741, 218, 23, 'PPL', 'P'),
(129965, 'Brookville', 42.3772201538086, 0.739622019526458, -83.57861328125, -1.45872198600887, 218, 27, 'PPL', 'P'),
(144906, 'Brookville', 40.4005584716797, 0.705122764975299, -74.9663925170898, -1.30841037776566, 218, 37, 'PPL', 'P'),
(147422, 'Brookville', 40.813060760498, 0.712322288087192, -73.5677795410156, -1.28399997637205, 218, 40, 'PPL', 'P'),
(159569, 'Brookville', 41.1611099243164, 0.718396891954635, -79.0833282470703, -1.38026446134681, 218, 45, 'PPL', 'P'),
(29309, 'Brookville Heights', 39.7244415283203, 0.693322298185158, -85.9066696166992, -1.49935423423438, 218, 19, 'PPL', 'P'),
(100247, 'Brookville Manor', 38.0349998474121, 0.663835978332882, -78.8097229003906, -1.37548914719619, 218, 53, 'PPL', 'P'),
(1175, 'Brookwood', 33.2555618286133, 0.580419048509848, -87.3208312988281, -1.52403601174307, 218, 2, 'PPL', 'P'),
(19566, 'Brookwood', 33.0483283996582, 0.576802142854384, -85.0972213745117, -1.48522669728372, 218, 13, 'PPL', 'P'),
(45173, 'Brookwood', 38.7625007629395, 0.676533264620107, -76.8255615234375, -1.34085899827746, 218, 25, 'PPL', 'P'),
(63228, 'Brookwood', 36.1263885498047, 0.630524427048871, -80.2297210693359, -1.40027279061658, 218, 33, 'PPL', 'P'),
(71923, 'Brookwood', 39.2013893127441, 0.684193314863502, -84.4411087036133, -1.47377537091249, 218, 41, 'PPL', 'P'),
(79993, 'Brookwood', 34.9930610656738, 0.610744130947444, -81.0180587768555, -1.41403187923042, 218, 48, 'PPL', 'P'),
(100250, 'Brookwood', 37.2055587768555, 0.649359500700402, -80.0377807617188, -1.39692280028137, 218, 53, 'PPL', 'P'),
(159571, 'Brookwood', 40.0955581665039, 0.699799505430394, -74.9361114501953, -1.30788187344733, 218, 45, 'PPL', 'P'),
(19572, 'Brookwood Acres', 33.7811088562012, 0.589591574515326, -84.6624984741211, -1.47763935133809, 218, 13, 'PPL', 'P'),
(45174, 'Brookwood Acres', 38.6124992370605, 0.673915244110505, -76.9897232055664, -1.34372416013622, 218, 25, 'PPL', 'P'),
(154487, 'Brookwood Beach', 41.6316719055176, 0.726609747861303, -81.4841690063477, -1.42216703741228, 218, 41, 'PPL', 'P'),
(203177, 'Brookwood Condominiums', 40.6652793884277, 0.70974301657145, -111.855560302734, -1.95224781394578, 218, 52, 'PPL', 'P'),
(19573, 'Brookwood East', 33.5527801513672, 0.585606486839159, -83.7811126708984, -1.46225626709152, 218, 13, 'PPL', 'P'),
(19575, 'Brookwood Estates', 33.8958282470703, 0.591593805601875, -83.4663925170898, -1.45676336418518, 218, 13, 'PPL', 'P'),
(100251, 'Brookwood Estates', 37.5294418334961, 0.655012326430204, -77.5688934326172, -1.35383258752778, 218, 53, 'PPL', 'P'),
(171797, 'Brookwood Estates', 43.6133308410645, 0.761196220938162, -72.932502746582, -1.27291230464766, 218, 55, 'PPL', 'P'),
(1179, 'Brookwood Forest', 34.7955589294434, 0.6072970683905, -86.9305572509766, -1.51722444462297, 218, 2, 'PPL', 'P'),
(79998, 'Brookwood Forest', 34.9166717529297, 0.609410885926723, -82.3341674804688, -1.43700230942262, 218, 48, 'PPL', 'P'),
(19576, 'Brookwood Hills', 33.8077812194824, 0.590057095073872, -84.3902816772461, -1.47288827195339, 218, 13, 'PPL', 'P'),
(19578, 'Brookwood Manor', 33.8805618286133, 0.591327356334812, -84.0355606079102, -1.46669722136728, 218, 13, 'PPL', 'P'),
(71924, 'Brookwood Mobile Home Park', 39.9813919067383, 0.697806928302797, -84.001106262207, -1.46609587959314, 218, 41, 'PPL', 'P'),
(63232, 'Brookwood Subdivision', 36.1002807617188, 0.630068760186359, -79.4563903808594, -1.38677562389595, 218, 33, 'PPL', 'P'),
(80000, 'Brookwood Trailer Park', 35.1722183227539, 0.613871014962333, -82.1741714477539, -1.43420985186162, 218, 48, 'PPL', 'P'),
(7705, 'Broom (historical)', 35.9199981689453, 0.62692223535843, -91.1213912963867, -1.59036829712005, 218, 4, 'PPL', 'P'),
(19579, 'Broom Hall', 33.348331451416, 0.582038183873589, -84.4541702270508, -1.4740033375018, 218, 13, 'PPL', 'P'),
(29311, 'Broom Hill', 38.4488906860352, 0.671059736210695, -85.8775024414063, -1.49884517099201, 218, 19, 'PPL', 'P'),
(77930, 'Broomall', 39.9813919067383, 0.697806928302797, -75.3569412231445, -1.31522673857572, 218, 45, 'PPL', 'P'),
(191178, 'Broome', 31.7594394683838, 0.554306787311135, -100.836936950684, -1.75993655741536, 218, 51, 'PPL', 'P'),
(147423, 'Broome Center', 42.4630584716797, 0.741120180797682, -74.3516693115234, -1.29768143384011, 218, 40, 'PPL', 'P'),
(45177, 'Broomes Island', 38.4180603027344, 0.670521644512444, -76.5444412231445, -1.33595252344315, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(7706, 'Broomfield', 35.476390838623, 0.619179826858325, -93.0783309936523, -1.62452333810032, 218, 4, 'PPL', 'P'),
(186459, 'Broomfield', 39.9205589294434, 0.696745192555209, -105.086112976074, -1.83409866955523, 218, 7, 'PPL', 'P'),
(129966, 'Broomfield Center', 43.5958290100098, 0.76089075636113, -85.0266723632813, -1.48399538475373, 218, 27, 'PPL', 'P'),
(1180, 'Broomtown', 34.3605613708496, 0.599704928754902, -85.5216674804688, -1.49263467932994, 218, 2, 'PPL', 'P'),
(19580, 'Broomtown (historical)', 34.5338897705078, 0.60273008001615, -85.4141693115234, -1.49075848234198, 218, 13, 'PPL', 'P'),
(134432, 'Brooten', 45.5011100769043, 0.79414418415435, -95.1241683959961, -1.66022993673167, 218, 28, 'PPL', 'P'),
(196092, 'Brorson (historical)', 47.7758293151855, 0.833845524420816, -104.294441223145, -1.82028139087157, 218, 31, 'PPL', 'P'),
(15341, 'Broscan', 29.6816692352295, 0.518042855642662, -83.3436126708984, -1.45462045161404, 218, 12, 'PPL', 'P'),
(53677, 'Broseley', 36.6749992370605, 0.640099489853115, -90.2416687011719, -1.57501424132936, 218, 29, 'PPL', 'P'),
(45178, 'Brosenne', 39.3002815246582, 0.685919309565983, -76.9244384765625, -1.34258472666383, 218, 25, 'PPL', 'P'),
(100252, 'Brosville', 36.6194381713867, 0.63912976632119, -79.6022186279297, -1.38932080694974, 218, 53, 'PPL', 'P'),
(194644, 'Broten', 48.2211112976074, 0.841617161113885, -116.416389465332, -2.03184929945408, 218, 17, 'PPL', 'P'),
(194645, 'Broten Post Office (historical)', 48.2211112976074, 0.841617161113885, -116.416389465332, -2.03184929945408, 218, 17, 'PPL', 'P'),
(118932, 'Brothers', 40.1444396972656, 0.700652649085601, -87.8086090087891, -1.53254933879972, 218, 18, 'PPL', 'P'),
(200464, 'Brothers', 43.8138885498047, 0.764696613295935, -120.60221862793, -2.10490580026741, 218, 43, 'PPL', 'P'),
(45179, 'Brothers Delight', 39.685001373291, 0.692633937622399, -76.8616714477539, -1.34148923534942, 218, 25, 'PPL', 'P'),
(77932, 'Brotherton', 39.9713897705078, 0.697632358093342, -78.9580612182617, -1.37807813924991, 218, 45, 'PPL', 'P'),
(85341, 'Brotherton', 36.1888885498047, 0.631615257831368, -85.3791732788086, -1.49014768634597, 218, 50, 'PPL', 'P'),
(92843, 'Brotherton', 33.5761108398438, 0.586013684169832, -96.1091690063477, -1.67742144051645, 218, 51, 'PPL', 'P'),
(147426, 'Brothertown', 42.9486083984375, 0.749594625702423, -75.4216690063477, -1.31635645151013, 218, 40, 'PPL', 'P'),
(173324, 'Brothertown', 43.9680595397949, 0.767387404682324, -88.3088912963867, -1.54128091190771, 218, 57, 'PPL', 'P'),
(70584, 'Brotmanville', 39.5205612182617, 0.689763915494648, -75.0827789306641, -1.31044170388712, 218, 37, 'PPL', 'P'),
(203179, 'Brough Estates', 40.5533294677734, 0.707789121858686, -111.853057861328, -1.9522041381039, 218, 52, 'PPL', 'P'),
(35010, 'Broughtentown', 37.3838882446289, 0.652471937066378, -84.543327331543, -1.47555942252674, 218, 21, 'PPL', 'P'),
(1181, 'Broughton', 33.1824989318848, 0.579143860400891, -85.4416732788086, -1.49123851712847, 218, 2, 'PPL', 'P'),
(19581, 'Broughton', 33.5052795410156, 0.584777444791817, -83.6533279418945, -1.46002600283663, 218, 13, 'PPL', 'P'),
(26618, 'Broughton', 37.9347190856934, 0.662085748864482, -88.4619369506836, -1.54395206248106, 218, 18, 'PPL', 'P'),
(154488, 'Broughton', 41.0897216796875, 0.717150932038642, -84.5352783203125, -1.47541894077923, 218, 41, 'PPL', 'P'),
(159572, 'Broughton', 40.3258285522461, 0.703818481831432, -79.9866714477539, -1.39603077447425, 218, 45, 'PPL', 'P'),
(186461, 'Broughton', 38.8133316040039, 0.67742043015824, -108.326393127441, -1.89065222688361, 218, 7, 'PPL', 'P'),
(31894, 'Broughton (historical)', 39.3213882446289, 0.686287691323768, -97.0530624389648, -1.69389548870357, 218, 20, 'PPL', 'P'),
(159573, 'Broughton Hollow', 41.6688919067383, 0.727259359430201, -77.3119430541992, -1.34934795741014, 218, 45, 'PPL', 'P'),
(39528, 'Brouillette', 31.2122192382813, 0.544755992562324, -92.0213928222656, -1.60607628701961, 218, 22, 'PPL', 'P'),
(108376, 'Brounland', 38.2419395446777, 0.667447757403248, -81.7680587768555, -1.42712184862038, 218, 58, 'PPL', 'P'),
(39525, 'Brousard Plaza', 30.3544406890869, 0.529784932625903, -91.1236114501953, -1.59040704611391, 218, 22, 'PPL', 'P'),
(39527, 'Broussard', 30.1469402313232, 0.526163366438532, -91.9611129760742, -1.60502420523098, 218, 22, 'PPL', 'P'),
(39529, 'Broussard Landing', 30.3219394683838, 0.529217679313716, -91.1986083984375, -1.59171598978969, 218, 22, 'PPL', 'P'),
(39530, 'Brousville', 29.9627799987793, 0.522949164029401, -91.9380569458008, -1.60462180159027, 218, 22, 'PPL', 'P'),
(15343, 'Broward Estates', 26.125280380249, 0.455972160642022, -80.1936111450195, -1.39964255354461, 218, 12, 'PPL', 'P'),
(15344, 'Broward Gardens', 26.0569400787354, 0.454779397368802, -80.2077789306641, -1.39988982805182, 218, 12, 'PPL', 'P'),
(15345, 'Broward Highlands', 26.298059463501, 0.458987724523346, -80.1111068725586, -1.3982025823432, 218, 12, 'PPL', 'P'),
(15346, 'Browardale', 26.1283302307129, 0.45602539057431, -80.1927795410156, -1.39962803931667, 218, 12, 'PPL', 'P'),
(35011, 'Browder', 37.1972198486328, 0.649213958946829, -87.0363922119141, -1.51907161315505, 218, 21, 'PPL', 'P'),
(134434, 'Browerville', 46.0858306884766, 0.804349484030561, -94.8655624389648, -1.6557164113162, 218, 28, 'PPL', 'P'),
(211714, 'Browerville', 71.2980575561523, 1.24438585463128, -156.770004272461, -2.73615274292002, 218, 1, 'PPL', 'P'),
(15347, 'Brown', 29.9947204589844, 0.523506630224582, -82.4266662597656, -1.43861671767543, 218, 12, 'PPL', 'P'),
(39531, 'Brown', 32.1775016784668, 0.561603349355247, -93.0508270263672, -1.62404330331383, 218, 22, 'PPL', 'P'),
(45181, 'Brown', 38.8527793884277, 0.678108923879053, -76.8024978637695, -1.34045646147869, 218, 25, 'PPL', 'P'),
(71925, 'Brown', 39.9416694641113, 0.697113640892022, -84.067497253418, -1.46725462098343, 218, 41, 'PPL', 'P'),
(75233, 'Brown', 34.0888900756836, 0.594963370171098, -96.4800033569336, -1.68389372091367, 218, 42, 'PPL', 'P'),
(108377, 'Brown', 39.3875007629395, 0.687441572445072, -80.4611129760742, -1.40431134125163, 218, 58, 'PPL', 'P'),
(180278, 'Brown', 35.773609161377, 0.624367265187635, -117.849166870117, -2.05685598261577, 218, 6, 'PPL', 'P'),
(189967, 'Brown', 37.6072196960449, 0.656369806216845, -114.131942749023, -1.99197818266813, 218, 39, 'PPL', 'P'),
(191180, 'Brown', 32.4258308410645, 0.565937510871297, -101.736671447754, -1.77563988678301, 218, 51, 'PPL', 'P'),
(7709, 'Brown (historical)', 35.9091682434082, 0.626733217500062, -90.211669921875, -1.57449066385905, 218, 4, 'PPL', 'P'),
(39532, 'Brown (historical)', 30.3041706085205, 0.528907554204776, -91.1208267211914, -1.59035844342402, 218, 22, 'PPL', 'P'),
(63234, 'Brown (historical)', 36.1380615234375, 0.630728158872262, -81.2063903808594, -1.41731888580585, 218, 33, 'PPL', 'P'),
(139054, 'Brown (historical)', 40.3469390869141, 0.704186930168245, -92.9741668701172, -1.62270533118218, 218, 29, 'PPL', 'P'),
(92844, 'Brown Acres Colonia', 26.1919994354248, 0.457136627828659, -98.0660018920898, -1.71157461728396, 218, 51, 'PPL', 'P'),
(80001, 'Brown Arrow', 35.1138916015625, 0.61285302163565, -82.022216796875, -1.43155774289007, 218, 48, 'PPL', 'P'),
(80002, 'Brown Bay', 33.9069404602051, 0.59178775030826, -79.0894393920898, -1.38037112094847, 218, 48, 'PPL', 'P'),
(19582, 'Brown Bridge Square', 33.5805587768555, 0.586091315315608, -83.9319381713867, -1.46488866867101, 218, 13, 'PPL', 'P'),
(147427, 'Brown Center', 43.1694412231445, 0.75344888559004, -76.0388870239258, -1.3271289381195, 218, 40, 'PPL', 'P'),
(129968, 'Brown City', 43.2122192382813, 0.754195502801644, -82.9897232055664, -1.44844391525588, 218, 27, 'PPL', 'P'),
(200465, 'Brown City (historical)', 42.0138893127441, 0.733280700075843, -123.626388549805, -2.15768752254391, 218, 43, 'PPL', 'P'),
(92845, 'Brown College', 30.2289505004883, 0.527594715655908, -96.1352462768555, -1.67787657474675, 218, 51, 'PPL', 'P'),
(126971, 'Brown Corner', 44.5405616760254, 0.777379451934247, -68.9155578613281, -1.20280339052884, 218, 26, 'PPL', 'P'),
(154489, 'Brown Corner', 41.2655601501465, 0.720219892299822, -80.8016662597656, -1.41025511733052, 218, 41, 'PPL', 'P'),
(85342, 'Brown Crossroads', 35.0641708374023, 0.611985230594448, -87.3913879394531, -1.52526745743112, 218, 50, 'PPL', 'P'),
(173328, 'Brown Deer', 43.163330078125, 0.753342225988383, -87.9644393920898, -1.53526909206297, 218, 57, 'PPL', 'P'),
(85343, 'Brown Ellis', 35.8716697692871, 0.626078745662175, -84.5466690063477, -1.47561774575461, 218, 50, 'PPL', 'P'),
(1182, 'Brown Estates', 31.2102794647217, 0.544722137126967, -85.3797225952148, -1.4901572737259, 218, 2, 'PPL', 'P'),
(100253, 'Brown Grove', 37.7161102294922, 0.658270304549753, -77.4255599975586, -1.35133094715781, 218, 53, 'PPL', 'P'),
(39534, 'Brown Heights', 30.5900001525879, 0.533896220848227, -91.1166687011719, -1.59028587228431, 218, 22, 'PPL', 'P'),
(45182, 'Brown Heights', 39.6366691589355, 0.691790381347117, -77.147216796875, -1.34647294185534, 218, 25, 'PPL', 'P'),
(19583, 'Brown Hill', 32.5522193908691, 0.568143407202209, -83.2605590820313, -1.45317089303271, 218, 13, 'PPL', 'P'),
(92847, 'Brown Hill', 29.7688903808594, 0.519565151811265, -97.3147201538086, -1.69846227734084, 218, 51, 'PPL', 'P'),
(159574, 'Brown Hill', 41.790828704834, 0.729387558036311, -79.932502746582, -1.39508535228727, 218, 45, 'PPL', 'P'),
(29313, 'Brown Jug Corner', 39.2880592346191, 0.685705990362667, -87.2588882446289, -1.52295490149855, 218, 19, 'PPL', 'P'),
(206906, 'Brown Lake', 48.4661102294922, 0.845893199139143, -119.654998779297, -2.08837369516853, 218, 56, 'PPL', 'P'),
(19584, 'Brown Mill', 34.9238891601563, 0.609536853446284, -84.2463912963867, -1.47037691104544, 218, 13, 'PPL', 'P'),
(85344, 'Brown Mill', 35.0894393920898, 0.612426250070965, -86.2699966430664, -1.50569548710596, 218, 50, 'PPL', 'P'),
(77933, 'Brown Mills', 39.829719543457, 0.695159746179258, -77.7019424438477, -1.35615473084027, 218, 45, 'PPL', 'P'),
(63236, 'Brown Mountain Beach', 35.9077796936035, 0.626708982734142, -81.7266693115234, -1.42639946617469, 218, 33, 'PPL', 'P'),
(39533, 'Brown Park Estates', 32.389720916748, 0.56530727379933, -93.7572174072266, -1.63637214126424, 218, 22, 'PPL', 'P'),
(188191, 'Brown Place', 34.7391700744629, 0.606312897209661, -106.328330993652, -1.85577946398957, 218, 38, 'PPL', 'P'),
(193403, 'Brown Place', 40.0252799987793, 0.698572920011331, -122.588607788086, -2.13957483133806, 218, 6, 'PPL', 'P'),
(77934, 'Brown Row', 39.9697189331055, 0.697603196479406, -79.6105575561523, -1.38946634870331, 218, 45, 'PPL', 'P'),
(53678, 'Brown Shanty', 38.5511093139648, 0.672843787824939, -91.5744400024414, -1.59827548871261, 218, 29, 'PPL', 'P'),
(7710, 'Brown Springs', 34.1569404602051, 0.596151073438246, -92.9205627441406, -1.62176976269123, 218, 4, 'PPL', 'P'),
(203184, 'Brown Stone Condominium', 40.7738914489746, 0.711638654635368, -111.89582824707, -1.95295062215745, 218, 52, 'PPL', 'P'),
(13453, 'Brown Street', 38.9141693115234, 0.679180380164619, -75.4069366455078, -1.31609932330688, 218, 10, 'PPL', 'P'),
(19585, 'Brown Subdivision', 33.7486114501953, 0.589024387782166, -84.6944427490234, -1.4781968841123, 218, 13, 'PPL', 'P'),
(58806, 'Brown Town', 31.0711097717285, 0.542293167765246, -88.4366683959961, -1.54351104300454, 218, 30, 'PPL', 'P'),
(63238, 'Brown Town', 34.3463897705078, 0.599457587668661, -77.7350006103516, -1.35673170469044, 218, 33, 'PPL', 'P'),
(203185, 'Brown-Tye Meadows', 40.6630592346191, 0.709704267577589, -111.920562744141, -1.95338232057015, 218, 52, 'PPL', 'P'),
(159575, 'Brownbacks', 40.1747207641602, 0.701181153403927, -75.6186065673828, -1.31979366037104, 218, 45, 'PPL', 'P'),
(53680, 'Brownbranch', 36.7944412231445, 0.642184145775402, -92.8305587768555, -1.62019889712225, 218, 29, 'PPL', 'P'),
(19586, 'Browndale', 32.3050003051758, 0.56382862018309, -83.5875015258789, -1.45887711514237, 218, 13, 'PPL', 'P'),
(31896, 'Browndale', 39.3597183227539, 0.686956677389596, -97.3505630493164, -1.6990878538809, 218, 20, 'PPL', 'P'),
(92848, 'Browndell', 31.1088905334473, 0.54295256645115, -93.9627838134766, -1.6399599518848, 218, 51, 'PPL', 'P'),
(31897, 'Brownell', 38.6402816772461, 0.674400139165981, -99.7458267211914, -1.74089309140853, 218, 20, 'PPL', 'P'),
(39535, 'Brownell', 32.1163902282715, 0.560536753338671, -91.741943359375, -1.60119897379924, 218, 22, 'PPL', 'P'),
(134437, 'Brownell', 46.6772193908691, 0.814671164046408, -92.3380584716797, -1.61160314522985, 218, 28, 'PPL', 'P'),
(124339, 'Brownell Corner', 41.6266708374023, 0.726522462756576, -71.1025009155273, -1.24097274737823, 218, 23, 'PPL', 'P'),
(191181, 'Brownfeld Corner', 31.9836101531982, 0.558219303847597, -105.128608703613, -1.83484035991882, 218, 51, 'PPL', 'P'),
(26621, 'Brownfield', 37.3455581665039, 0.65180295100055, -88.6069412231445, -1.54648286446496, 218, 18, 'PPL', 'P'),
(53681, 'Brownfield', 37.6669387817383, 0.657412100888475, -92.3447189331055, -1.61171939221144, 218, 29, 'PPL', 'P'),
(58807, 'Brownfield', 34.9900016784668, 0.610690734567588, -88.8925018310547, -1.55146683728699, 218, 30, 'PPL', 'P'),
(77935, 'Brownfield', 39.8569412231445, 0.695634854117728, -79.7122192382813, -1.39124067977957, 218, 45, 'PPL', 'P'),
(126972, 'Brownfield', 43.938060760498, 0.766863827212015, -70.9091720581055, -1.2375985222771, 218, 26, 'PPL', 'P'),
(191182, 'Brownfield', 33.1811103820801, 0.579119625634971, -102.273887634277, -1.78501607803285, 218, 51, 'PPL', 'P'),
(39536, 'Brownfields', 30.5463905334473, 0.533135089408682, -91.1205596923828, -1.59035378289211, 218, 22, 'PPL', 'P'),
(154498, 'Brownhelm', 41.3888893127441, 0.722372392250878, -82.2827835083008, -1.43610548992554, 218, 41, 'PPL', 'P'),
(154499, 'Brownhelm Station', 41.4094390869141, 0.722731053470685, -82.2941665649414, -1.43630416174286, 218, 41, 'PPL', 'P'),
(19587, 'Browning', 31.9172191619873, 0.557060562457304, -83.2724990844727, -1.45337928538801, 218, 13, 'PPL', 'P'),
(35012, 'Browning', 36.9469413757324, 0.644845775547854, -86.6097183227539, -1.51162474895692, 218, 21, 'PPL', 'P'),
(58808, 'Browning', 33.5180587768555, 0.585000484533111, -90.1197204589844, -1.57288584298617, 218, 30, 'PPL', 'P'),
(92849, 'Browning', 32.3836097717285, 0.565200614197672, -95.0838928222656, -1.65952699536194, 218, 51, 'PPL', 'P'),
(108379, 'Browning', 37.6522216796875, 0.657155239001337, -80.8583297729492, -1.41124408220132, 218, 58, 'PPL', 'P'),
(118935, 'Browning', 40.1288909912109, 0.700381272970522, -90.371940612793, -1.57728791511002, 218, 18, 'PPL', 'P'),
(139055, 'Browning', 40.0352783203125, 0.698747423641758, -93.1622161865234, -1.62598741090959, 218, 29, 'PPL', 'P'),
(180280, 'Browning', 33.7333297729492, 0.588757672198995, -117.801391601563, -2.05602214687846, 218, 6, 'PPL', 'P'),
(196093, 'Browning', 48.5569381713867, 0.847478445778013, -113.012496948242, -1.97244016764687, 218, 31, 'PPL', 'P'),
(108378, 'Browning (historical)', 39.0244407653809, 0.681104980105392, -81.6611099243164, -1.42525523901234, 218, 58, 'PPL', 'P'),
(35013, 'Browning Corner', 38.6197204589844, 0.674041278209093, -84.220832824707, -1.46993083156285, 218, 21, 'PPL', 'P'),
(92850, 'Browning-Ken Number 3 Colonia', 26.193000793457, 0.457154104823312, -98.1159973144531, -1.71244720201512, 218, 51, 'PPL', 'P'),
(144907, 'Brownings', 40.9524993896484, 0.714755951270333, -75.1136093139648, -1.31097979558537, 218, 37, 'PPL', 'P'),
(45183, 'Browningsville', 39.3072204589844, 0.686040416816554, -77.2433319091797, -1.34815046702598, 218, 25, 'PPL', 'P'),
(35014, 'Brownington', 37.9483299255371, 0.662323302833717, -85.5852813720703, -1.4937449511884, 218, 21, 'PPL', 'P'),
(53682, 'Brownington', 38.2458305358887, 0.667515668011045, -93.7227783203125, -1.63577106580621, 218, 29, 'PPL', 'P'),
(85346, 'Brownington', 35.2447204589844, 0.615136415954284, -86.2666702270508, -1.5056374301942, 218, 50, 'PPL', 'P'),
(171800, 'Brownington Center', 44.8227806091309, 0.782305101528403, -72.1486129760742, -1.2592308471796, 218, 55, 'PPL', 'P'),
(171798, 'Brownington Village', 44.8308296203613, 0.782445583275905, -72.1722183227539, -1.25964283820024, 218, 55, 'PPL', 'P'),
(19588, 'Brownlee', 30.8705596923828, 0.538792908565528, -84.1727828979492, -1.46909220213559, 218, 13, 'PPL', 'P'),
(39537, 'Brownlee', 32.5755615234375, 0.568550804269964, -93.7263870239258, -1.63583404956599, 218, 22, 'PPL', 'P'),
(159577, 'Brownlee', 41.667781829834, 0.727239984933271, -77.2572174072266, -1.34839281468518, 218, 45, 'PPL', 'P'),
(191183, 'Brownlee', 32.415828704834, 0.565762940661842, -100.634719848633, -1.75640720318073, 218, 51, 'PPL', 'P'),
(194119, 'Brownlee', 40.7847213745117, 0.711827672493737, -106.286109924316, -1.85504256731594, 218, 7, 'PPL', 'P'),
(194646, 'Brownlee', 44.0088882446289, 0.768100000011002, -116.244438171387, -2.02884818322167, 218, 17, 'PPL', 'P'),
(199204, 'Brownlee', 42.2880592346191, 0.738065867922497, -100.625282287598, -1.75624248666731, 218, 35, 'PPL', 'P'),
(200466, 'Brownlee', 44.8116683959961, 0.782111156822018, -116.933326721191, -2.04087155659506, 218, 43, 'PPL', 'P'),
(80003, 'Brownlee Crossroads', 34.2455596923828, 0.597697770820337, -82.5266723632813, -1.44036215345387, 218, 48, 'PPL', 'P'),
(39538, 'Brownlee Estates', 32.5769386291504, 0.568574839298802, -93.7177810668945, -1.63568384728051, 218, 22, 'PPL', 'P'),
(129971, 'Brownlee Park', 42.3188896179199, 0.738603959620748, -85.1425018310547, -1.48601699033721, 218, 27, 'PPL', 'P'),
(108380, 'Brownlow', 39.351390838623, 0.686811335373105, -79.996940612793, -1.39621000521561, 218, 58, 'PPL', 'P'),
(85345, 'Brownlow (historical)', 36.0361099243164, 0.628948767789926, -82.4613876342773, -1.43922271998148, 218, 50, 'PPL', 'P'),
(1184, 'Browns', 32.4366683959961, 0.56612666188772, -87.3661117553711, -1.52482630479655, 218, 2, 'PPL', 'P'),
(7714, 'Browns', 35.0930595397949, 0.612489433567827, -90.3869400024414, -1.57754970384517, 218, 4, 'PPL', 'P'),
(26623, 'Browns', 38.3769416809082, 0.669803989177695, -87.9830627441406, -1.53559413087401, 218, 18, 'PPL', 'P'),
(39539, 'Browns', 30.8047199249268, 0.537643787844672, -91.1125030517578, -1.59021316798656, 218, 22, 'PPL', 'P'),
(53684, 'Browns', 36.8624992370605, 0.643371982200604, -89.6327819824219, -1.56438716331551, 218, 29, 'PPL', 'P'),
(71928, 'Browns', 39.9025001525879, 0.696430007440198, -84.5997161865234, -1.47654359370758, 218, 41, 'PPL', 'P'),
(85348, 'Browns', 36.4894409179688, 0.636860886230497, -85.9716720581055, -1.50048874085875, 218, 50, 'PPL', 'P'),
(114725, 'Browns', 42.0305595397949, 0.733571650424934, -90.4991683959961, -1.57950845882693, 218, 16, 'PPL', 'P'),
(144908, 'Browns', 41.1566696166992, 0.718319393966914, -74.3486099243164, -1.29762803746025, 218, 37, 'PPL', 'P'),
(159578, 'Browns', 41.3447189331055, 0.721601473694328, -75.7286071777344, -1.32171353320088, 218, 45, 'PPL', 'P'),
(19589, 'Browns (historical)', 34.1311111450195, 0.595700266844723, -84.8705596923828, -1.48127070464247, 218, 13, 'PPL', 'P'),
(180279, 'Browns (historical)', 34.0936088562012, 0.595045728427808, -117.139442443848, -2.04446895459553, 218, 6, 'PPL', 'P'),
(186462, 'Browns Canon', 38.6119384765625, 0.673905456993499, -106.059440612793, -1.85108644151663, 218, 7, 'PPL', 'P'),
(71929, 'Browns Chapel', 39.6055603027344, 0.691247429379877, -84.4544372558594, -1.47400799803371, 218, 41, 'PPL', 'P'),
(108382, 'Browns Chapel', 39.4977798461914, 0.6893663055439, -79.9155578613281, -1.39478960824821, 218, 58, 'PPL', 'P'),
(1185, 'Browns Corner', 34.9327812194824, 0.609692049158808, -86.7136077880859, -1.5134379621851, 218, 2, 'PPL', 'P'),
(13459, 'Browns Corner', 39.0911102294922, 0.682268581764675, -75.519172668457, -1.31805821144669, 218, 10, 'PPL', 'P'),
(45187, 'Browns Corner', 39.100830078125, 0.682438225126113, -76.0347213745117, -1.32705623382174, 218, 25, 'PPL', 'P'),
(100256, 'Browns Corner', 37.8230590820313, 0.660136914157789, -76.4188919067383, -1.33376127449823, 218, 53, 'PPL', 'P'),
(108381, 'Browns Corner', 39.327220916748, 0.686389490656436, -77.8966674804688, -1.35955332386538, 218, 58, 'PPL', 'P'),
(122283, 'Browns Corner', 40.814998626709, 0.712356110233036, -85.4116668701172, -1.4907148065001, 218, 19, 'PPL', 'P'),
(124340, 'Browns Corner', 42.4000015258789, 0.740019629477207, -71.5944366455078, -1.2495586455746, 218, 23, 'PPL', 'P'),
(126975, 'Browns Corner', 44.8191719055176, 0.782242117768623, -69.5633316040039, -1.2141091751465, 218, 26, 'PPL', 'P'),
(143565, 'Browns Corner', 42.978889465332, 0.750123130020749, -71.6113891601563, -1.2498545227717, 218, 36, 'PPL', 'P'),
(177542, 'Browns Corner', 41.8280601501465, 0.73003736934229, -72.976936340332, -1.2736878171571, 218, 8, 'PPL', 'P'),
(180281, 'Browns Corner', 38.6777801513672, 0.675054611003868, -121.801391601563, -2.12583531695824, 218, 6, 'PPL', 'P'),
(194120, 'Browns Corner', 40.4075012207031, 0.705243938804897, -105.058326721191, -1.83361370792073, 218, 7, 'PPL', 'P'),
(147428, 'Browns Corners', 44.2991714477539, 0.773166397668769, -75.857780456543, -1.32396803222168, 218, 40, 'PPL', 'P'),
(171802, 'Browns Corners', 44.9683303833008, 0.784845424313202, -72.9691696166992, -1.27355226225761, 218, 55, 'PPL', 'P'),
(19600, 'Browns Crossing', 33.0472183227539, 0.576782768357454, -83.3574981689453, -1.45486279927324, 218, 13, 'PPL', 'P'),
(26624, 'Browns Crossing', 39.7238883972168, 0.693312644226206, -89.98388671875, -1.57051509698378, 218, 18, 'PPL', 'P'),
(29319, 'Browns Crossing', 39.4063911437988, 0.687771271788024, -86.5055618286133, -1.50980687519683, 218, 19, 'PPL', 'P'),
(53685, 'Browns Crossing', 36.9719390869141, 0.645282067913436, -90.5947189331055, -1.58117613030154, 218, 29, 'PPL', 'P'),
(147429, 'Browns Crossing', 42.2491683959961, 0.737387094739663, -77.4511108398438, -1.35177689348234, 218, 40, 'PPL', 'P'),
(1188, 'Browns Crossroad', 31.416109085083, 0.548314541700402, -85.5274963378906, -1.49273641208358, 218, 2, 'PPL', 'P'),
(35015, 'Browns Crossroads', 36.7158317565918, 0.64081215176082, -85.1908264160156, -1.48686041345443, 218, 21, 'PPL', 'P'),
(63239, 'Browns Crossroads', 35.7438888549805, 0.623848547986315, -79.5788879394531, -1.38891360961906, 218, 33, 'PPL', 'P'),
(80004, 'Browns Crossroads', 34.3683280944824, 0.599840483654387, -81.5286102294922, -1.42294268307977, 218, 48, 'PPL', 'P'),
(154501, 'Browns Crossroads', 40.6025009155273, 0.708647325519964, -83.5238876342773, -1.45776684328392, 218, 41, 'PPL', 'P'),
(159579, 'Browns Crossroads', 40.9272193908691, 0.714314732056735, -79.6275024414063, -1.38976209274236, 218, 45, 'PPL', 'P'),
(15348, 'Browns Farm', 26.5611095428467, 0.46357881450556, -80.5163879394531, -1.40527607135651, 218, 12, 'PPL', 'P'),
(180282, 'Browns Flat', 38.0038909912109, 0.663293026365642, -120.384170532227, -2.10110014306969, 218, 6, 'PPL', 'P'),
(53687, 'Browns Ford', 38.1377792358398, 0.665629817064132, -93.6166687011719, -1.63391910358417, 218, 29, 'PPL', 'P'),
(35016, 'Browns Fork', 37.2361106872559, 0.649892732129663, -83.2324981689453, -1.45268113770825, 218, 21, 'PPL', 'P'),
(35017, 'Browns Grove', 36.6238899230957, 0.639207464045993, -88.4872207641602, -1.54439334827369, 218, 21, 'PPL', 'P'),
(154502, 'Browns Heights', 40.0302810668945, 0.698660205116058, -81.6108322143555, -1.42437772743316, 218, 41, 'PPL', 'P'),
(80005, 'Browns Hill', 33.3574981689453, 0.582198173276075, -81.8569412231445, -1.42867313995535, 218, 48, 'PPL', 'P'),
(147430, 'Browns Hollow', 42.8074989318848, 0.747131800905345, -74.5072174072266, -1.30039626025534, 218, 40, 'PPL', 'P'),
(173330, 'Browns Lake', 42.6925010681152, 0.745124709549807, -88.2311096191406, -1.53992336554204, 218, 57, 'PPL', 'P'),
(1187, 'Browns Landing', 30.5111103057861, 0.532519333275142, -87.4488906860352, -1.52627106968792, 218, 2, 'PPL', 'P'),
(45188, 'Browns Landing', 38.646671295166, 0.674511659036628, -75.8144378662109, -1.32321156131405, 218, 25, 'PPL', 'P'),
(80006, 'Browns Landing', 33.0491714477539, 0.576816856819407, -81.5449981689453, -1.42322870658084, 218, 48, 'PPL', 'P'),
(85349, 'Browns Mill', 35.9022216796875, 0.626611977091436, -86.2808303833008, -1.50588457154336, 218, 50, 'PPL', 'P'),
(100257, 'Browns Mill', 38.9508285522461, 0.67982020461651, -77.2844390869141, -1.34886792262365, 218, 53, 'PPL', 'P'),
(108384, 'Browns Mill', 39.4794387817383, 0.689046193580872, -79.8283309936523, -1.39326721221107, 218, 58, 'PPL', 'P'),
(118937, 'Browns Mill', 42.2822189331055, 0.737963935431775, -89.5208282470703, -1.56243320202372, 218, 18, 'PPL', 'P'),
(159580, 'Browns Mill', 40.3025016784668, 0.703411351079787, -75.7819366455078, -1.32264430800186, 218, 45, 'PPL', 'P'),
(171801, 'Browns Mill', 44.6855583190918, 0.779910120760095, -71.6350021362305, -1.25026664695039, 218, 55, 'PPL', 'P'),
(19591, 'Browns Mill Lake', 33.6394386291504, 0.587118962601242, -84.1136093139648, -1.46805942826486, 218, 13, 'PPL', 'P'),
(70582, 'Browns Mills', 39.9724998474121, 0.697651732590272, -74.5833282470703, -1.30172464500707, 218, 37, 'PPL', 'P'),
(70583, 'Browns Mills Junction', 39.9483299255371, 0.697229887873604, -74.5902786254883, -1.30184595199472, 218, 37, 'PPL', 'P'),
(124341, 'Browns Point', 42.8388900756836, 0.747679679720602, -70.8305587768555, -1.2362264616835, 218, 23, 'PPL', 'P'),
(206907, 'Browns Point', 47.3005599975586, 0.825550509994519, -122.440002441406, -2.13698117875243, 218, 56, 'PPL', 'P'),
(85350, 'Browns Shop', 35.3211097717285, 0.616469660975005, -86.7030563354492, -1.51325380459572, 218, 50, 'PPL', 'P'),
(53688, 'Browns Spring', 36.9738883972168, 0.645316089796362, -93.5105590820313, -1.63206714136213, 218, 29, 'PPL', 'P'),
(199848, 'Browns Station (historical)', 40.017219543457, 0.698432238526747, -118.67749786377, -2.07131308575132, 218, 39, 'PPL', 'P'),
(15349, 'Browns Still', 29.9841709136963, 0.523322505924717, -82.4908294677734, -1.43973657691381, 218, 12, 'PPL', 'P'),
(100259, 'Browns Store', 37.8288917541504, 0.660238713490458, -76.4291687011719, -1.33394063839765, 218, 53, 'PPL', 'P'),
(45189, 'Browns Store (historical)', 39.6719398498535, 0.692405971033089, -77.4991683959961, -1.35261565606766, 218, 25, 'PPL', 'P'),
(63240, 'Browns Summit', 36.2125015258789, 0.632027382010057, -79.7138900756836, -1.39126984139351, 218, 33, 'PPL', 'P'),
(203188, 'Browns Townsite', 40.7083282470703, 0.710494360893989, -112.101112365723, -1.95653350592999, 218, 52, 'PPL', 'P'),
(29320, 'Browns Valley', 39.9030609130859, 0.696439794557205, -86.991943359375, -1.51829583432951, 218, 19, 'PPL', 'P'),
(35018, 'Browns Valley', 37.6402816772461, 0.656946846646038, -87.1188888549805, -1.5205114511984, 218, 21, 'PPL', 'P'),
(134438, 'Browns Valley', 45.5952796936035, 0.795787754021093, -96.8330612182617, -1.6900557430439, 218, 28, 'PPL', 'P'),
(180283, 'Browns Valley', 39.2422218322754, 0.684905976771208, -121.408058166504, -2.11897035345828, 218, 6, 'PPL', 'P'),
(1198, 'Browns Valley (historical)', 34.9075012207031, 0.609250829945209, -85.7708282470703, -1.49698335507393, 218, 2, 'PPL', 'P'),
(58809, 'Browns Wells', 31.7749996185303, 0.554578363163295, -90.5013885498047, -1.57954720782079, 218, 30, 'PPL', 'P'),
(45190, 'Browns Woods', 39.0058288574219, 0.68078014103143, -76.4683303833008, -1.33462413869142, 218, 25, 'PPL', 'P'),
(45191, 'Browns Woods Villa', 39.0094413757324, 0.680843191370237, -76.470832824707, -1.33466781453329, 218, 25, 'PPL', 'P'),
(19592, 'Brownsand', 32.5730590820313, 0.568507128428087, -84.4422225952148, -1.47379481198845, 218, 13, 'PPL', 'P'),
(1189, 'Brownsboro', 34.7491683959961, 0.606487400840089, -86.4430618286133, -1.50871604441433, 218, 2, 'PPL', 'P'),
(35019, 'Brownsboro', 38.3561096191406, 0.669440401109872, -85.4983291625977, -1.49222734884122, 218, 21, 'PPL', 'P'),
(92852, 'Brownsboro', 32.3022193908691, 0.563780084072224, -95.6133270263672, -1.66876736539619, 218, 51, 'PPL', 'P'),
(200467, 'Brownsboro', 42.4683303833008, 0.741212193013344, -122.708892822266, -2.14167420122537, 218, 43, 'PPL', 'P'),
(85351, 'Brownsboro (historical)', 36.1847190856934, 0.631542486954581, -82.605827331543, -1.44174366826935, 218, 50, 'PPL', 'P'),
(35020, 'Brownsboro Farm', 38.3027801513672, 0.668509626308889, -85.5961074829102, -1.49393390246774, 218, 21, 'PPL', 'P'),
(35021, 'Brownsboro Village', 38.2630615234375, 0.667816405477142, -85.6658325195313, -1.49515083392785, 218, 21, 'PPL', 'P'),
(29321, 'Brownsburg', 39.8433303833008, 0.695397300148493, -86.3977813720703, -1.50792575136085, 218, 19, 'PPL', 'P'),
(100261, 'Brownsburg', 37.9283294677734, 0.661974228993835, -79.3194427490234, -1.3843854368176, 218, 53, 'PPL', 'P'),
(108385, 'Brownsburg', 38.2677803039551, 0.667898763733852, -80.0755615234375, -1.39758219896727, 218, 58, 'PPL', 'P'),
(159581, 'Brownsburg', 40.3180618286133, 0.703682926931947, -74.9205627441406, -1.30761049733225, 218, 45, 'PPL', 'P'),
(15350, 'Brownsdale', 30.8822193145752, 0.538996407362324, -87.2255630493164, -1.52237326711648, 218, 12, 'PPL', 'P'),
(134441, 'Brownsdale', 43.7402801513672, 0.763411904386081, -92.8691711425781, -1.62087281003609, 218, 28, 'PPL', 'P'),
(159582, 'Brownsdale', 40.7738914489746, 0.711638654635368, -79.966667175293, -1.39568163405534, 218, 45, 'PPL', 'P'),
(177192, 'Brownsdale Mobile Home Park', 40.5644416809082, 0.707983066565071, -80.6408309936523, -1.40744801238352, 218, 58, 'PPL', 'P'),
(147431, 'Brownsell Corner', 41.1636085510254, 0.718440501217485, -73.9886093139648, -1.29134484150043, 218, 40, 'PPL', 'P'),
(39541, 'Brownsfield', 30.5522193908691, 0.533236822162323, -91.1288909912109, -1.59049919148763, 218, 22, 'PPL', 'P'),
(200468, 'Brownsmead', 46.2177810668945, 0.806652452583207, -123.539436340332, -2.15616992019673, 218, 43, 'PPL', 'P'),
(199205, 'Brownson', 41.1875, 0.718857485665165, -103.112503051758, -1.79965267822587, 218, 35, 'PPL', 'P'),
(26626, 'Brownsport (historical)', 38.0561103820801, 0.664204426669695, -88.0425033569336, -1.53663156527665, 218, 18, 'PPL', 'P'),
(85352, 'Brownsport (historical)', 35.5486106872559, 0.620440301002259, -87.998893737793, -1.53587043383711, 218, 50, 'PPL', 'P'),
(31899, 'Brownstone', 37.3327789306641, 0.651579911259256, -95.1938934326172, -1.66144686819178, 218, 20, 'PPL', 'P'),
(180285, 'Brownstone (historical)', 34.4094390869141, 0.600558005831082, -118.933891296387, -2.07578799533098, 218, 6, 'PPL', 'P'),
(1190, 'Brownstown', 32.6019401550293, 0.569011198243412, -87.9311065673828, -1.53468732452284, 218, 2, 'PPL', 'P'),
(7715, 'Brownstown', 33.8177795410156, 0.590231598704299, -94.0669403076172, -1.64177782564489, 218, 4, 'PPL', 'P'),
(26627, 'Brownstown', 38.9958305358887, 0.680605637401002, -88.9527816772461, -1.55251891907563, 218, 18, 'PPL', 'P'),
(29323, 'Brownstown', 38.8788909912109, 0.678564657320593, -86.0419387817383, -1.50171512654073, 218, 19, 'PPL', 'P'),
(45192, 'Brownstown', 39.1411094665527, 0.683141233074867, -77.2947235107422, -1.34904741968112, 218, 25, 'PPL', 'P'),
(154503, 'Brownstown', 40.7377815246582, 0.711008417563401, -83.370002746582, -1.45508104532457, 218, 41, 'PPL', 'P'),
(159586, 'Brownstown', 40.1236114501953, 0.700289127596805, -76.2141723632813, -1.33018824442173, 218, 45, 'PPL', 'P'),
(206908, 'Brownstown', 46.4044418334961, 0.809910297544701, -120.605827331543, -2.10496878402719, 218, 56, 'PPL', 'P'),
(71931, 'Brownstown (historical)', 39.4936103820801, 0.689293534667113, -83.1033325195313, -1.4504267718455, 218, 41, 'PPL', 'P'),
(108386, 'Brownstown (historical)', 38.4188919067383, 0.670536158740385, -82.4544372558594, -1.43910141299382, 218, 58, 'PPL', 'P'),
(45193, 'Brownstown Estates', 39.1405601501465, 0.683131645694942, -77.2858276367188, -1.34889215738957, 218, 25, 'PPL', 'P'),
(1191, 'Brownsville', 33.1258316040039, 0.578154828951063, -86.0472183227539, -1.50180727191445, 218, 2, 'PPL', 'P'),
(7718, 'Brownsville', 34.8194389343262, 0.607713853101097, -91.8791732788086, -1.6035940877256, 218, 4, 'PPL', 'P'),
(13454, 'Brownsville', 38.9136085510254, 0.679170593047613, -75.6800003051758, -1.32086518323563, 218, 10, 'PPL', 'P'),
(15352, 'Brownsville', 25.8213901519775, 0.450668275594047, -80.2413864135742, -1.40047638928191, 218, 12, 'PPL', 'P'),
(19593, 'Brownsville', 33.7994384765625, 0.589911486741272, -84.7574996948242, -1.47929743543277, 218, 13, 'PPL', 'P'),
(26628, 'Brownsville', 38.041389465332, 0.663947498203529, -88.2447204589844, -1.54016091951128, 218, 18, 'PPL', 'P'),
(29325, 'Brownsville', 39.6644401550293, 0.692275076665511, -85.0047225952148, -1.48361228903092, 218, 19, 'PPL', 'P'),
(35023, 'Brownsville', 36.5347213745117, 0.637651179283978, -89.2169418334961, -1.55712938355477, 218, 21, 'PPL', 'P'),
(39542, 'Brownsville', 32.4869384765625, 0.567004040308846, -92.154167175293, -1.60839363664214, 218, 22, 'PPL', 'P'),
(45196, 'Brownsville', 39.3819389343262, 0.687344500223339, -77.6605606079102, -1.35543248155264, 218, 25, 'PPL', 'P'),
(58810, 'Brownsville', 32.4486083984375, 0.566335054243018, -90.4369430541992, -1.57842242173439, 218, 30, 'PPL', 'P'),
(70585, 'Brownsville', 39.811939239502, 0.694849421333236, -75.0188903808594, -1.3093266383387, 218, 37, 'PPL', 'P'),
(71934, 'Brownsville', 39.2605590820313, 0.685226022155208, -83.0505599975586, -1.44950571758249, 218, 41, 'PPL', 'P'),
(80008, 'Brownsville', 34.392219543457, 0.600257468102066, -79.5924987792969, -1.3891511635883, 218, 48, 'PPL', 'P'),
(85354, 'Brownsville', 36.3600006103516, 0.634601726677783, -87.7225036621094, -1.53104651699659, 218, 50, 'PPL', 'P'),
(92853, 'Brownsville', 25.9013900756836, 0.452064537664062, -97.4972229003906, -1.70164755116263, 218, 51, 'PPL', 'P'),
(100263, 'Brownsville', 39.1355590820313, 0.683044360590215, -77.6427764892578, -1.35512209012759, 218, 53, 'PPL', 'P'),
(108388, 'Brownsville', 39.0022201538086, 0.680717157271649, -80.4761123657227, -1.40457312998678, 218, 58, 'PPL', 'P'),
(114726, 'Brownsville', 41.5125007629395, 0.724529819049952, -92.5561065673828, -1.61540880242758, 218, 16, 'PPL', 'P'),
(129972, 'Brownsville', 41.878059387207, 0.730910020652482, -85.9541702270508, -1.50018327628172, 218, 27, 'PPL', 'P'),
(134443, 'Brownsville', 43.6941719055176, 0.762607163683686, -91.2797164916992, -1.59313159306712, 218, 28, 'PPL', 'P'),
(147433, 'Brownsville', 43.0116691589355, 0.750695243601926, -77.3666687011719, -1.35030310013509, 218, 40, 'PPL', 'P'),
(159589, 'Brownsville', 40.023609161377, 0.698543758397394, -79.8841705322266, -1.39424179601198, 218, 45, 'PPL', 'P'),
(171803, 'Brownsville', 43.4686088562012, 0.758670345802277, -72.4713897705078, -1.2648643649915, 218, 55, 'PPL', 'P'),
(173331, 'Brownsville', 43.6163902282715, 0.761249617318019, -88.4905624389648, -1.54445167150156, 218, 57, 'PPL', 'P'),
(180284, 'Brownsville', 39.473331451416, 0.688939600558242, -121.268058776855, -2.11652690315814, 218, 6, 'PPL', 'P'),
(200469, 'Brownsville', 44.3936080932617, 0.774814628067419, -122.983612060547, -2.14646895645195, 218, 43, 'PPL', 'P'),
(206909, 'Brownsville', 47.6558303833008, 0.83175114796055, -122.615280151367, -2.14004035189661, 218, 56, 'PPL', 'P'),
(100264, 'Brownsville (historical)', 37.4669418334961, 0.653921495647708, -75.8233337402344, -1.3233668236056, 218, 53, 'PPL', 'P'),
(201932, 'Brownsville (historical)', 44.2752799987793, 0.77274941322109, -103.693893432617, -1.80979985461129, 218, 49, 'PPL', 'P'),
(77937, 'Brownton', 39.8697204589844, 0.695857893859022, -76.5622177124023, -1.33626278171014, 218, 45, 'PPL', 'P'),
(108389, 'Brownton', 39.2200012207031, 0.684518153937465, -80.1502838134766, -1.39888634895308, 218, 58, 'PPL', 'P'),
(134447, 'Brownton', 44.7319412231445, 0.780719655152452, -94.3499984741211, -1.64671812262504, 218, 28, 'PPL', 'P'),
(26629, 'Brownton (historical)', 39.7636108398438, 0.694005931636981, -90.1911087036133, -1.57413180290217, 218, 18, 'PPL', 'P'),
(100265, 'Brownton (historical)', 37.8499984741211, 0.660607095248243, -78.5719375610352, -1.37133901011147, 218, 53, 'PPL', 'P'),
(1194, 'Browntown', 33.5911102294922, 0.586275472904987, -87.3405609130859, -1.52438035847201, 218, 2, 'PPL', 'P'),
(15353, 'Browntown', 30.9822196960449, 0.540741743272221, -85.4672164916992, -1.49168433029495, 218, 12, 'PPL', 'P'),
(19594, 'Browntown', 31.3372192382813, 0.546937654127317, -81.7819366455078, -1.42736406312152, 218, 13, 'PPL', 'P'),
(71935, 'Browntown', 39.0436096191406, 0.681439539717333, -82.0097198486328, -1.43133962999679, 218, 41, 'PPL', 'P'),
(85355, 'Browntown', 35.959171295166, 0.627605935389281, -85.2050018310547, -1.4871078211197, 218, 50, 'PPL', 'P'),
(100269, 'Browntown', 38.8108291625977, 0.677376754316363, -78.23388671875, -1.36543890987445, 218, 53, 'PPL', 'P'),
(144909, 'Browntown', 40.401668548584, 0.705142139472229, -74.3069381713867, -1.29690072816655, 218, 37, 'PPL', 'P'),
(147434, 'Browntown', 42.0269393920898, 0.733508466928072, -77.0527801513672, -1.34482471145669, 218, 40, 'PPL', 'P'),
(159596, 'Browntown', 40.3338890075684, 0.703959163316016, -79.7330627441406, -1.39160446758448, 218, 45, 'PPL', 'P'),
(173333, 'Browntown', 42.5777816772461, 0.743122478463258, -89.7941665649414, -1.56720385564243, 218, 57, 'PPL', 'P'),
(200471, 'Browntown', 42.084171295166, 0.734507352073933, -123.51611328125, -2.15576285602411, 218, 43, 'PPL', 'P'),
(85356, 'Browntown (historical)', 35.1933288574219, 0.614239463299146, -87.915283203125, -1.5344111547178, 218, 50, 'PPL', 'P'),
(200470, 'Browntown (historical)', 42.0530586242676, 0.733964333527666, -123.26277923584, -2.15134134282431, 218, 43, 'PPL', 'P'),
(63245, 'Browntown Crossroads', 35.3769416809082, 0.617444111617865, -77.6677780151367, -1.3555584490722, 218, 33, 'PPL', 'P'),
(39544, 'Brownview', 30.7266693115234, 0.536281547657583, -91.5858306884766, -1.59847429368798, 218, 22, 'PPL', 'P'),
(85357, 'Brownview Acres', 35.8416709899902, 0.625555168191865, -86.4783325195313, -1.5093316341003, 218, 50, 'PPL', 'P'),
(1196, 'Brownville', 33.3925018310547, 0.58280910243014, -87.7533264160156, -1.53158447553679, 218, 2, 'PPL', 'P'),
(15354, 'Brownville', 27.297779083252, 0.476436123484786, -81.8241729736328, -1.42810122611125, 218, 12, 'PPL', 'P'),
(114727, 'Brownville', 43.3422203063965, 0.756464449471364, -92.6758270263672, -1.61749831861885, 218, 16, 'PPL', 'P'),
(126976, 'Brownville', 45.3069381713867, 0.790755245088197, -69.0338897705078, -1.20486867195419, 218, 26, 'PPL', 'P'),
(141378, 'Brownville', 40.3977813720703, 0.705074295443459, -95.6577835083008, -1.66954327737978, 218, 35, 'PPL', 'P'),
(144910, 'Brownville', 40.4005584716797, 0.705122764975299, -74.2955627441406, -1.29670218950729, 218, 37, 'PPL', 'P'),
(147436, 'Brownville', 41.7997207641602, 0.729542753748835, -74.3811111450195, -1.29819529077244, 218, 40, 'PPL', 'P'),
(173335, 'Brownville', 45.0313911437988, 0.785946042212705, -90.9336090087891, -1.58709087792455, 218, 57, 'PPL', 'P'),
(187607, 'Brownville', 39.1861114501953, 0.683926665859358, -101.353057861328, -1.7689445666445, 218, 20, 'PPL', 'P'),
(39543, 'Brownville (historical)', 30.7833309173584, 0.537270479238871, -91.5897216796875, -1.59854220429578, 218, 22, 'PPL', 'P'),
(126977, 'Brownville Junction', 45.3499984741211, 0.791506789147818, -69.0527801513672, -1.20519837129715, 218, 26, 'PPL', 'P'),
(80009, 'Brownway', 33.7975006103516, 0.589877664595428, -79.166389465332, -1.3817141530862, 218, 48, 'PPL', 'P'),
(19596, 'Brownwood', 33.5613899230957, 0.585756755703666, -83.5558319091797, -1.45832437605813, 218, 13, 'PPL', 'P'),
(53689, 'Brownwood', 37.0808296203613, 0.647182566246344, -89.9544372558594, -1.5700011068934, 218, 29, 'PPL', 'P'),
(63241, 'Brownwood', 36.276668548584, 0.633147307827463, -81.5547180175781, -1.42339834994228, 218, 33, 'PPL', 'P'),
(92859, 'Brownwood', 31.7091693878174, 0.553429408890008, -98.9908294677734, -1.72771590349287, 218, 51, 'PPL', 'P'),
(118938, 'Brownwood', 40.396110534668, 0.705045133829523, -89.4747161865234, -1.5616283947423, 218, 18, 'PPL', 'P'),
(19598, 'Brownwood Acres', 33.5433311462402, 0.585441570588656, -84.1986083984375, -1.46954294215008, 218, 13, 'PPL', 'P'),
(15355, 'Broxson', 30.5674991607666, 0.533503504455981, -86.9219436645508, -1.51707410917944, 218, 12, 'PPL', 'P'),
(19599, 'Broxton', 31.625, 0.551960375943207, -82.8869400024414, -1.4466500099456, 218, 13, 'PPL', 'P'),
(75241, 'Broxton', 34.9858283996582, 0.610617897111774, -98.4088897705078, -1.71755913972753, 218, 42, 'PPL', 'P'),
(100270, 'Broyhill Crest', 38.8463897705078, 0.677997404008406, -77.1944427490234, -1.34729719021272, 218, 53, 'PPL', 'P'),
(100271, 'Broyhill Forest', 38.9152793884277, 0.679199754661549, -77.1227798461914, -1.34604643660677, 218, 53, 'PPL', 'P'),
(100272, 'Broyhill Park', 38.8600006103516, 0.678234957977641, -77.1966705322266, -1.34733607236464, 218, 53, 'PPL', 'P'),
(100273, 'Broyhill-Glen Gary Park', 38.9216690063477, 0.679311274532196, -77.1675033569336, -1.34682700912227, 218, 53, 'PPL', 'P'),
(100274, 'Broyhill-Langley Estates', 38.9491691589355, 0.679791242739656, -77.1855621337891, -1.34714219423728, 218, 53, 'PPL', 'P'),
(100275, 'Broyhill-McLean Estates', 38.9352798461914, 0.679548828501431, -77.1875, -1.34717601638312, 218, 53, 'PPL', 'P'),
(85358, 'Broyles', 36.4752807617188, 0.636613744881337, -84.1991729736328, -1.46955279584612, 218, 50, 'PPL', 'P'),
(85359, 'Broylesville', 36.2138900756836, 0.632051616775977, -82.602783203125, -1.4416905382056, 218, 50, 'PPL', 'P'),
(58815, 'Brozville', 33.0330581665039, 0.576535627008294, -90.1122207641602, -1.5727549486186, 218, 30, 'PPL', 'P'),
(26630, 'Brubaker', 38.6930618286133, 0.67532132658704, -88.8763885498047, -1.55118560747588, 218, 18, 'PPL', 'P'),
(15356, 'Bruce', 30.4722194671631, 0.531840560092308, -85.9652786254883, -1.50037715440908, 218, 12, 'PPL', 'P'),
(26631, 'Bruce', 39.5188903808594, 0.689734753880712, -88.5944366455078, -1.54626461841363, 218, 18, 'PPL', 'P'),
(58811, 'Bruce', 33.9919395446777, 0.593271264193489, -89.3488922119141, -1.55943235210742, 218, 30, 'PPL', 'P'),
(63242, 'Bruce', 35.6730613708496, 0.622612375187328, -77.4841690063477, -1.35235386733251, 218, 33, 'PPL', 'P'),
(77939, 'Bruce', 39.7949981689453, 0.69455374387321, -76.4452819824219, -1.33422186820876, 218, 45, 'PPL', 'P'),
(100276, 'Bruce', 36.8344383239746, 0.642882226876139, -76.3994369506836, -1.33342172145925, 218, 53, 'PPL', 'P'),
(108390, 'Bruce', 38.1630592346191, 0.666071036277731, -80.7769393920898, -1.40982355207587, 218, 58, 'PPL', 'P'),
(134449, 'Bruce', 43.5222206115723, 0.759606047451276, -96.398063659668, -1.6824636034083, 218, 28, 'PPL', 'P'),
(169915, 'Bruce', 44.438060760498, 0.775590473471986, -96.8897171020508, -1.69104457475664, 218, 49, 'PPL', 'P'),
(173336, 'Bruce', 45.4569396972656, 0.7933732655978, -91.273063659668, -1.59301547924359, 218, 57, 'PPL', 'P'),
(194121, 'Bruce', 40.4958305358887, 0.706785576180917, -104.863891601563, -1.8302201749017, 218, 7, 'PPL', 'P'),
(206910, 'Bruce', 46.8397216796875, 0.817507364028316, -119.051109313965, -2.07783383568037, 218, 56, 'PPL', 'P'),
(7720, 'Bruce (historical)', 34.2677803039551, 0.598085593654079, -92.1813888549805, -1.60886874458061, 218, 4, 'PPL', 'P'),
(196094, 'Bruce (historical)', 47.249439239502, 0.824658284450315, -107.415283203125, -1.87475035885669, 218, 31, 'PPL', 'P'),
(129976, 'Bruce Crossing', 46.5349998474121, 0.8121889647524, -89.1786117553711, -1.55646039748895, 218, 27, 'PPL', 'P'),
(194647, 'Bruce Eddy', 46.5136108398438, 0.811815656146598, -116.28971862793, -2.02963847627516, 218, 17, 'PPL', 'P'),
(58812, 'Bruce Junction', 33.9644393920898, 0.592791295986029, -89.6847229003906, -1.56529370335057, 218, 30, 'PPL', 'P'),
(122284, 'Bruce Lake Station', 41.0694389343262, 0.716796931350743, -86.4147186279297, -1.50822136224185, 218, 19, 'PPL', 'P'),
(196095, 'Bruce Place', 46.288330078125, 0.807883765113205, -110.858329772949, -1.93484285779962, 218, 31, 'PPL', 'P'),
(206911, 'Bruceport', 46.6794395446777, 0.814709913040269, -123.898887634277, -2.16244352877663, 218, 56, 'PPL', 'P'),
(85360, 'Bruceton', 36.0380592346191, 0.628982789672852, -88.2444381713867, -1.54015599266326, 218, 50, 'PPL', 'P'),
(159597, 'Bruceton', 40.3180618286133, 0.703682926931947, -79.9800033569336, -1.39591439433461, 218, 45, 'PPL', 'P'),
(108391, 'Bruceton Mills', 39.6586112976074, 0.69217334391187, -79.6413879394531, -1.39000444040156, 218, 58, 'PPL', 'P'),
(100280, 'Brucetown', 39.2544403076172, 0.685119229395496, -78.0669403076172, -1.36252514532579, 218, 53, 'PPL', 'P'),
(1199, 'Bruceville', 32.0977783203125, 0.560211914264708, -85.8483276367188, -1.49833597459158, 218, 2, 'PPL', 'P'),
(15357, 'Bruceville', 29.2336101531982, 0.510222749417753, -81.9472198486328, -1.43024879921429, 218, 12, 'PPL', 'P'),
(29327, 'Bruceville', 38.7594413757324, 0.676479868240251, -87.4155578613281, -1.52568930214779, 218, 19, 'PPL', 'P'),
(45198, 'Bruceville', 38.6711082458496, 0.674938164285204, -75.9841690063477, -1.32617392855259, 218, 25, 'PPL', 'P'),
(85361, 'Bruceville', 35.9194412231445, 0.626912514820451, -89.3494415283203, -1.55944193948734, 218, 50, 'PPL', 'P'),
(92856, 'Bruceville', 31.3191699981689, 0.546622635459875, -97.2363891601563, -1.69709514359525, 218, 51, 'PPL', 'P'),
(100277, 'Bruceville', 37.0916709899902, 0.647371783841794, -78.3791732788086, -1.36797463870637, 218, 53, 'PPL', 'P'),
(147438, 'Bruceville', 41.8313903808594, 0.730095492833081, -74.121940612793, -1.29367191166094, 218, 40, 'PPL', 'P'),
(180286, 'Bruceville', 38.3358306884766, 0.669086467001001, -121.416107177734, -2.11911083520579, 218, 6, 'PPL', 'P'),
(92858, 'Bruceville-Eddy', 31.3050003051758, 0.546375327663147, -97.2513885498047, -1.69735693233041, 218, 51, 'PPL', 'P'),
(114729, 'Brucewell', 40.6458282470703, 0.709403530111492, -93.6374969482422, -1.63428262507297, 218, 16, 'PPL', 'P'),
(189968, 'Brucite', 38.8627815246582, 0.678283494088508, -117.901107788086, -2.05776252265083, 218, 39, 'PPL', 'P'),
(169298, 'Brudickville', 41.417781829834, 0.722876661803285, -71.7302780151367, -1.25192952473504, 218, 47, 'PPL', 'P'),
(173339, 'Bruemmerville', 44.6066703796387, 0.778533266476524, -87.4700012207031, -1.52663951802473, 218, 57, 'PPL', 'P'),
(35024, 'Bruin', 38.1877784729004, 0.666502468374324, -83.0188903808594, -1.44895297849825, 218, 21, 'PPL', 'P'),
(159598, 'Bruin', 41.0547218322754, 0.716540069463605, -79.726936340332, -1.39149754166671, 218, 45, 'PPL', 'P'),
(192499, 'Bruin Point', 39.6416702270508, 0.691877666451844, -110.345001220703, -1.92588358441843, 218, 52, 'PPL', 'P'),
(15358, 'Bruing', 28.1355590820313, 0.491058142870839, -82.4638900756836, -1.43926639582335, 218, 12, 'PPL', 'P'),
(100278, 'Bruington', 37.7752799987793, 0.659303011841458, -76.9916687011719, -1.34375811544012, 218, 53, 'PPL', 'P'),
(7721, 'Bruins', 34.8883285522461, 0.608916203754241, -90.3511123657227, -1.57692439362122, 218, 4, 'PPL', 'P'),
(58813, 'Bruinsburg', 31.9422206878662, 0.557496921401913, -91.1572189331055, -1.590993607344, 218, 30, 'PPL', 'P'),
(39546, 'Brule', 29.8038902282715, 0.520176014386302, -90.8752822875977, -1.58607288459786, 218, 22, 'PPL', 'P'),
(173338, 'Brule', 46.5530586242676, 0.812504149867411, -91.5763931274414, -1.59830957717456, 218, 57, 'PPL', 'P'),
(199207, 'Brule', 41.0941696166992, 0.717228563184418, -101.887496948242, -1.7782722883625, 218, 35, 'PPL', 'P'),
(39547, 'Brulie Maurin', 30.045560836792, 0.524393962210283, -90.9883270263672, -1.58804588749145, 218, 22, 'PPL', 'P'),
(39548, 'Bruly La Croix', 30.1505603790283, 0.526226549935394, -91.1941680908203, -1.59163849180197, 218, 22, 'PPL', 'P'),
(39549, 'Bruly McCall', 30.107780456543, 0.525479899434276, -91.0897216796875, -1.58981555803581, 218, 22, 'PPL', 'P'),
(39550, 'Bruly Saint Martin', 30.0458297729492, 0.524398656031704, -91.0972213745117, -1.58994645240338, 218, 22, 'PPL', 'P'),
(159600, 'Brumbaugh', 40.1794395446777, 0.701263511660638, -78.470832824707, -1.36957439957318, 218, 45, 'PPL', 'P'),
(159601, 'Brumbaugh Crossing', 40.3913917541504, 0.704962775572812, -78.1352767944336, -1.36371784201999, 218, 45, 'PPL', 'P'),
(35025, 'Brumfield', 37.6041717529297, 0.656316609574071, -84.9822235107422, -1.48321960592819, 218, 21, 'PPL', 'P'),
(299, 'Brumley', 35.0625, 0.611956068980512, -92.4258270263672, -1.61313499548887, 218, 4, 'PPL', 'P'),
(53690, 'Brumley', 38.0863914489746, 0.664732930988021, -92.4866714477539, -1.61419693097354, 218, 29, 'PPL', 'P'),
(92860, 'Brumley', 32.8794403076172, 0.573854489580857, -95.0147171020508, -1.65831965128175, 218, 51, 'PPL', 'P'),
(186463, 'Brumley', 39.0894393920898, 0.682239420150738, -106.542221069336, -1.85951255004759, 218, 7, 'PPL', 'P'),
(100281, 'Brumley Gap', 36.8019409179688, 0.642315040142979, -82.0269393920898, -1.4316401677258, 218, 53, 'PPL', 'P'),
(85362, 'Brumley Heights', 36.1025009155273, 0.630107509180219, -82.8708267211914, -1.44636878013449, 218, 50, 'PPL', 'P'),
(45199, 'Brummel', 39.6027793884277, 0.69119889326901, -76.92138671875, -1.34253146344202, 218, 25, 'PPL', 'P'),
(63244, 'Brummels (historical)', 35.9122200012207, 0.626786480721863, -80.0736083984375, -1.39754811050532, 218, 33, 'PPL', 'P'),
(7722, 'Brummitt', 34.538890838623, 0.602817365120878, -91.6616668701172, -1.59979788474975, 218, 4, 'PPL', 'P'),
(122285, 'Brummitt Acres', 41.6188888549805, 0.726386641540982, -87.0169372558594, -1.51873206011607, 218, 19, 'PPL', 'P'),
(92861, 'Brundage', 28.5738906860352, 0.498708472576255, -99.668327331543, -1.73954047189088, 218, 51, 'PPL', 'P'),
(1201, 'Brundidge', 31.7199993133545, 0.553618426748376, -85.8161087036133, -1.49777364812741, 218, 2, 'PPL', 'P'),
(75239, 'Brundidge', 35.5916709899902, 0.621191845061879, -95.9622192382813, -1.67485668322865, 218, 42, 'PPL', 'P'),
(85363, 'Brundige', 36.4294395446777, 0.63581366471085, -88.6566696166992, -1.54735078866422, 218, 50, 'PPL', 'P'),
(7723, 'Brundige (historical)', 35.1902809143066, 0.614186266656371, -91.9016723632813, -1.60398677082834, 218, 4, 'PPL', 'P'),
(194648, 'Bruneau', 42.8805618286133, 0.748406989014302, -115.79638671875, -2.02102821015482, 218, 17, 'PPL', 'P'),
(196096, 'Brunelda (historical)', 46.9022216796875, 0.818598194810812, -107.269439697266, -1.87220490948679, 218, 31, 'PPL', 'P'),
(53691, 'Bruner', 37.014720916748, 0.646028751704067, -92.9858322143555, -1.62290892984751, 218, 29, 'PPL', 'P'),
(80010, 'Bruner', 33.9208297729492, 0.592030164546484, -80.841667175293, -1.41095326501029, 218, 48, 'PPL', 'P'),
(92864, 'Bruner', 30.0886096954346, 0.525145306532822, -93.7538909912109, -1.63631408435248, 218, 51, 'PPL', 'P'),
(1200, 'Bruner (historical)', 33.6847190856934, 0.587909255654723, -86.0769424438477, -1.5023260556948, 218, 2, 'PPL', 'P'),
(85364, 'Bruner Crossing', 35.2480583190918, 0.61519467260313, -86.116943359375, -1.50302420337456, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(85365, 'Bruner Grove', 36.0750007629395, 0.62962754097276, -83.1161117553711, -1.45064981158679, 218, 50, 'PPL', 'P'),
(154504, 'Brunersburg', 41.3066711425781, 0.720937414476516, -84.3869400024414, -1.47282994872551, 218, 41, 'PPL', 'P'),
(29330, 'Brunerstown', 39.6525001525879, 0.692066684310213, -86.9983291625977, -1.51840728762113, 218, 19, 'PPL', 'P'),
(39551, 'Brunett (historical)', 32.8969383239746, 0.574159887578862, -91.1688919067383, -1.59119733916739, 218, 22, 'PPL', 'P'),
(45200, 'Brunetto Acres', 39.5961112976074, 0.691082513129374, -76.9702835083008, -1.34338487341334, 218, 25, 'PPL', 'P'),
(92862, 'Bruni', 27.4258308410645, 0.47867104827158, -98.8405609130859, -1.72509322245136, 218, 51, 'PPL', 'P'),
(141382, 'Bruning', 40.336109161377, 0.703997912309877, -97.565559387207, -1.70284024785682, 218, 35, 'PPL', 'P'),
(129977, 'Bruningville', 45.3852806091309, 0.792122578570871, -83.8244400024414, -1.46301247168305, 218, 27, 'PPL', 'P'),
(159602, 'Brunnerville', 40.1847190856934, 0.701355657034355, -76.2850036621094, -1.33142448379974, 218, 45, 'PPL', 'P'),
(194649, 'Brunning', 46.4841690063477, 0.811301799214267, -116.142776489258, -2.02707385214541, 218, 17, 'PPL', 'P'),
(7724, 'Bruno', 36.1441688537598, 0.630834751894893, -92.7780609130859, -1.61928263654921, 218, 4, 'PPL', 'P'),
(71936, 'Bruno', 39.848331451416, 0.69548458525322, -82.4138870239258, -1.43839367793414, 218, 41, 'PPL', 'P'),
(75240, 'Bruno', 34.3441696166992, 0.5994188386748, -96.0749969482422, -1.67682502559033, 218, 42, 'PPL', 'P'),
(100282, 'Bruno', 36.6375007629395, 0.639445018015228, -82.4222183227539, -1.43853908652965, 218, 53, 'PPL', 'P'),
(112614, 'Bruno', 37.690559387207, 0.657824358225219, -81.8691711425781, -1.42888659231672, 218, 58, 'PPL', 'P'),
(134451, 'Bruno', 46.2791709899902, 0.807723908868773, -92.6641693115234, -1.61729485311157, 218, 28, 'PPL', 'P'),
(141385, 'Bruno', 41.2838897705078, 0.720539804525767, -96.9583282470703, -1.6922420651408, 218, 35, 'PPL', 'P'),
(196097, 'Bruno', 46.3722190856934, 0.809347904501504, -110.627220153809, -1.93080923401259, 218, 31, 'PPL', 'P'),
(199849, 'Bruno City (historical)', 41.7702789306641, 0.729028896816504, -115.566673278809, -2.01701895429176, 218, 39, 'PPL', 'P'),
(53693, 'Brunot', 37.3102798461914, 0.651187228156524, -90.54638671875, -1.58033257402625, 218, 29, 'PPL', 'P'),
(39552, 'Bruns', 30.2280597686768, 0.527579169453045, -91.0663909912109, -1.58940836070513, 218, 22, 'PPL', 'P'),
(80011, 'Brunson', 32.9252815246582, 0.574654569751344, -81.1875, -1.4169891864629, 218, 48, 'PPL', 'P'),
(80013, 'Brunson Crossroads', 33.7433280944824, 0.588932175829422, -79.4747161865234, -1.38709546954287, 218, 48, 'PPL', 'P'),
(80014, 'Brunsons Store', 33.8772201538086, 0.59126903310694, -80.232780456543, -1.40032618699643, 218, 48, 'PPL', 'P'),
(114730, 'Brunsville', 42.8097190856934, 0.747170549899206, -96.2688903808594, -1.68020910438749, 218, 16, 'PPL', 'P'),
(19602, 'Brunswick', 31.1497192382813, 0.543665161779828, -81.4916687011719, -1.42229793177986, 218, 13, 'PPL', 'P'),
(45201, 'Brunswick', 39.3141708374023, 0.686161723804207, -77.628059387207, -1.35486522824045, 218, 25, 'PPL', 'P'),
(58814, 'Brunswick', 32.5544395446777, 0.56818215619607, -91.0616683959961, -1.5893259358694, 218, 30, 'PPL', 'P'),
(63246, 'Brunswick', 34.2866706848145, 0.598415292997031, -78.7013931274414, -1.37359843598029, 218, 33, 'PPL', 'P'),
(85366, 'Brunswick', 35.267219543457, 0.615529099057017, -89.7686080932617, -1.56675777615985, 218, 50, 'PPL', 'P'),
(92863, 'Brunswick', 31.5816707611084, 0.551204138062165, -95.0616683959961, -1.65913910594917, 218, 51, 'PPL', 'P'),
(100283, 'Brunswick', 36.6474990844727, 0.639619521645655, -77.8708267211914, -1.35910231753477, 218, 53, 'PPL', 'P'),
(112897, 'Brunswick', 39.4233283996582, 0.688066882669023, -93.1302795410156, -1.62543001129344, 218, 29, 'PPL', 'P'),
(122286, 'Brunswick', 41.3777809143066, 0.722178514123521, -87.508056640625, -1.52730371040059, 218, 19, 'PPL', 'P'),
(126979, 'Brunswick', 43.9144401550293, 0.76645156987527, -69.9658279418945, -1.22113406146991, 218, 26, 'PPL', 'P'),
(129978, 'Brunswick', 43.4330596923828, 0.758049895847316, -86.040283203125, -1.5016862312429, 218, 27, 'PPL', 'P'),
(134454, 'Brunswick', 45.788890838623, 0.79916690597024, -93.2755584716797, -1.6279656069673, 218, 28, 'PPL', 'P'),
(141386, 'Brunswick', 42.3377799987793, 0.7389336589637, -97.9702835083008, -1.70990401633215, 218, 35, 'PPL', 'P'),
(147439, 'Brunswick', 42.7358283996582, 0.745880914141335, -73.5619430541992, -1.28389811046035, 218, 40, 'PPL', 'P'),
(154505, 'Brunswick', 41.2380599975586, 0.719739924092362, -81.8419418334961, -1.42841135122019, 218, 41, 'PPL', 'P'),
(189970, 'Brunswick (historical)', 39.1763916015625, 0.68375702249792, -119.6875, -2.08894094848071, 218, 39, 'PPL', 'P'),
(147440, 'Brunswick Center', 42.7569389343262, 0.746249362478147, -73.6166687011719, -1.28485325318531, 218, 40, 'PPL', 'P'),
(100285, 'Brunswick Estates', 36.5525016784668, 0.637961504129999, -77.8655624389648, -1.35901043847716, 218, 53, 'PPL', 'P'),
(144911, 'Brunswick Gardens', 40.3905601501465, 0.704948261344871, -74.336669921875, -1.29741964510495, 218, 37, 'PPL', 'P'),
(39553, 'Brunswick Plantation', 30.7219390869141, 0.536198989663791, -91.519172668457, -1.59731089176578, 218, 22, 'PPL', 'P'),
(171804, 'Brunswick Springs', 44.7363891601563, 0.780797286298227, -71.6327819824219, -1.25022789795653, 218, 55, 'PPL', 'P'),
(196098, 'Brusett', 47.4252815246582, 0.827727311290522, -107.26611328125, -1.87214685257503, 218, 31, 'PPL', 'P'),
(194122, 'Brush', 40.2588882446289, 0.702650153061215, -103.623329162598, -1.80856827576519, 218, 7, 'PPL', 'P'),
(180287, 'Brush (historical)', 39.6963882446289, 0.692832676018747, -121.404716491699, -2.11891203023041, 218, 6, 'PPL', 'P'),
(53695, 'Brush Arbor', 36.9075012207031, 0.644157414985096, -90.648063659668, -1.58210717141863, 218, 29, 'PPL', 'P'),
(108392, 'Brush Camp Low Place', 38.4497184753418, 0.671074183859608, -80.1661071777344, -1.39916251875812, 218, 58, 'PPL', 'P'),
(200472, 'Brush College', 44.9722213745117, 0.784913334920999, -123.076393127441, -2.14808829155277, 218, 43, 'PPL', 'P'),
(1202, 'Brush Creek', 32.7911109924316, 0.572312852204838, -87.4636077880859, -1.52652793157505, 218, 2, 'PPL', 'P'),
(53696, 'Brush Creek', 37.6161117553711, 0.656525001929369, -92.7133331298828, -1.61815292361479, 218, 29, 'PPL', 'P'),
(71937, 'Brush Creek', 39.8702812194824, 0.695867680976028, -81.9861068725586, -1.4309275058181, 218, 41, 'PPL', 'P'),
(75242, 'Brush Creek', 36.4166717529297, 0.635590824706638, -94.7858276367188, -1.65432477648858, 218, 42, 'PPL', 'P'),
(85369, 'Brush Creek', 36.0072212219238, 0.628444564816547, -87.0813903808594, -1.51985697936052, 218, 50, 'PPL', 'P'),
(108393, 'Brush Creek', 38.1436080932617, 0.665731549817773, -81.7555618286133, -1.4269037357271, 218, 58, 'PPL', 'P'),
(112224, 'Brush Creek', 34.2177810668945, 0.597212942343888, -92.6533279418945, -1.61710563551612, 218, 4, 'PPL', 'P'),
(134456, 'Brush Creek', 43.644718170166, 0.761744033174392, -93.8480606079102, -1.63795765421922, 218, 28, 'PPL', 'P'),
(180288, 'Brush Creek', 39.690559387207, 0.692730943265106, -121.33805847168, -2.11774862830821, 218, 6, 'PPL', 'P'),
(108394, 'Brush Fork', 37.2808303833008, 0.650673238066138, -81.2561111450195, -1.41818667684705, 218, 58, 'PPL', 'P'),
(35026, 'Brush Grove', 37.8430595397949, 0.660485987997671, -85.1802825927734, -1.48667638902311, 218, 21, 'PPL', 'P'),
(100286, 'Brush Harbor', 37.1841697692871, 0.6489861920946, -80.2911071777344, -1.40134418032312, 218, 53, 'PPL', 'P'),
(846, 'Brush Hill', 35.4199981689453, 0.618195589098458, -95.628059387207, -1.66902449359943, 218, 42, 'PPL', 'P'),
(124342, 'Brush Hill Mobile Home Park', 42.144718170166, 0.735564094394477, -72.6347198486328, -1.26771501262232, 218, 23, 'PPL', 'P'),
(124343, 'Brush Hollow', 42.3416709899902, 0.739001569571497, -73.033332824707, -1.27467212149599, 218, 23, 'PPL', 'P'),
(154508, 'Brush Lake (historical)', 40.1680603027344, 0.701064906422345, -83.5774993896484, -1.45870254493292, 218, 41, 'PPL', 'P'),
(206912, 'Brush Prairie', 45.7330589294434, 0.79819245532738, -122.545280456543, -2.13881862674653, 218, 56, 'PPL', 'P'),
(154509, 'Brush Ridge', 40.6875, 0.710130839405193, -83.1536102294922, -1.45130428342468, 218, 41, 'PPL', 'P'),
(77946, 'Brush Run', 39.8619384765625, 0.695722072643428, -77.0980606079102, -1.34561500451017, 218, 45, 'PPL', 'P'),
(100287, 'Brush Tavern', 37.3288917541504, 0.651512067230486, -79.2463912963867, -1.38311044844573, 218, 53, 'PPL', 'P'),
(159603, 'Brush Valley', 40.5361099243164, 0.707488584129671, -79.0666732788086, -1.37997377731383, 218, 45, 'PPL', 'P'),
(35027, 'Brushart', 38.5188903808594, 0.672281461360769, -83.0827789306641, -1.45006804404666, 218, 21, 'PPL', 'P'),
(7725, 'Brushey Lake', 35.4858283996582, 0.619344543371746, -90.913330078125, -1.58673694381567, 218, 4, 'PPL', 'P'),
(92866, 'Brushie Prairie', 31.9941692352295, 0.558403594595031, -96.754997253418, -1.68869326983021, 218, 51, 'PPL', 'P'),
(108395, 'Brushton', 38.1661109924316, 0.666124299499533, -81.7091674804688, -1.42609400159766, 218, 58, 'PPL', 'P'),
(147442, 'Brushton', 44.8302803039551, 0.78243599589598, -74.5138931274414, -1.30051277355303, 218, 40, 'PPL', 'P'),
(159605, 'Brushton', 40.4566688537598, 0.706102075887148, -79.894172668457, -1.39441636622144, 218, 45, 'PPL', 'P'),
(159606, 'Brushtown', 40.0905609130859, 0.699712286904694, -77.3172225952148, -1.34944010278385, 218, 45, 'PPL', 'P'),
(134458, 'Brushvale', 46.3694381713867, 0.809299368390637, -96.6430587768555, -1.68673957485453, 218, 28, 'PPL', 'P'),
(159608, 'Brushville', 41.915828704834, 0.731569219601304, -75.6283264160156, -1.31996330373248, 218, 45, 'PPL', 'P'),
(173342, 'Brushville', 44.1699981689453, 0.770911898647962, -88.9958267211914, -1.55327019681914, 218, 57, 'PPL', 'P'),
(124344, 'Brushwood', 42.1027793884277, 0.734832124568868, -71.4297180175781, -1.24668376317786, 218, 23, 'PPL', 'P'),
(75243, 'Brushy', 35.5569381713867, 0.62058564301875, -94.7252807617188, -1.65326803416803, 218, 42, 'PPL', 'P'),
(92865, 'Brushy', 32.0927810668945, 0.560124695739008, -95.1463928222656, -1.66061782614444, 218, 51, 'PPL', 'P'),
(114731, 'Brushy', 42.4308280944824, 0.74055765459643, -94.0100021362305, -1.64078406708412, 218, 16, 'PPL', 'P'),
(7727, 'Brushy (historical)', 34.2541694641113, 0.597848039684844, -93.9852828979492, -1.64035263498753, 218, 4, 'PPL', 'P'),
(1203, 'Brushy Creek', 31.6683292388916, 0.552716613824248, -86.6705627441406, -1.51268668444159, 218, 2, 'PPL', 'P'),
(92868, 'Brushy Creek', 30.5133304595947, 0.532558082269003, -97.7394409179688, -1.70587505307702, 218, 51, 'PPL', 'P'),
(19604, 'Brushy Creek (historical)', 33.1966705322266, 0.579391201487132, -82.2202835083008, -1.43501465914304, 218, 13, 'PPL', 'P'),
(53700, 'Brushy Mill (historical)', 37.2811088562012, 0.650678098335128, -91.2938919067383, -1.59337900073239, 218, 29, 'PPL', 'P'),
(1204, 'Brushy Pond', 34.0286102294922, 0.593911288382462, -87.0074996948242, -1.51856734360264, 218, 2, 'PPL', 'P'),
(122287, 'Brushy Prairie', 41.6416702270508, 0.726784251491731, -85.2474975585938, -1.48784951148329, 218, 19, 'PPL', 'P'),
(108396, 'Brushy Run', 38.8375015258789, 0.677842274874909, -79.2477798461914, -1.38313468321165, 218, 58, 'PPL', 'P'),
(53701, 'Brushyknob', 36.9647216796875, 0.645156100393876, -92.4858322143555, -1.61418228358754, 218, 29, 'PPL', 'P'),
(39555, 'Brusle Saint Vincent', 29.9597206115723, 0.522895767649545, -91.0702819824219, -1.58947627131293, 218, 22, 'PPL', 'P'),
(39556, 'Brusly', 30.3941707611084, 0.530478353194732, -91.2536087036133, -1.59267592620461, 218, 22, 'PPL', 'P'),
(39557, 'Brusly Landing', 30.3875007629395, 0.530361939765582, -91.2372207641602, -1.59238990270353, 218, 22, 'PPL', 'P'),
(53705, 'Brussells', 39.0508308410645, 0.681565573815921, -90.8788909912109, -1.58613586835764, 218, 29, 'PPL', 'P'),
(26633, 'Brussels', 38.9494400024414, 0.679795969850591, -90.5886077880859, -1.58106947069988, 218, 18, 'PPL', 'P'),
(113373, 'Brussels', 44.7361106872559, 0.780792426029238, -87.6208267211914, -1.52927191960422, 218, 57, 'PPL', 'P'),
(85370, 'Bruton Branch', 35.0758285522461, 0.61218869610173, -88.1813888549805, -1.53905557450084, 218, 50, 'PPL', 'P'),
(80015, 'Brutons Fork', 34.6991691589355, 0.605614749529897, -79.666389465332, -1.39044079934617, 218, 48, 'PPL', 'P'),
(1205, 'Brutonville', 33.7897186279297, 0.589741843379834, -85.8647232055664, -1.49862213125071, 218, 2, 'PPL', 'P'),
(35028, 'Brutus', 37.2472190856934, 0.650086610257021, -83.5769424438477, -1.45869282439494, 218, 21, 'PPL', 'P'),
(100288, 'Brutus', 37.0108299255371, 0.64596084109627, -79.2694396972656, -1.38351271892838, 218, 53, 'PPL', 'P'),
(129979, 'Brutus', 45.4930610656738, 0.794003702406849, -84.7816696166992, -1.47971928014944, 218, 27, 'PPL', 'P'),
(108397, 'Bruxton', 38.9249992370605, 0.679369398022987, -79.8850021362305, -1.39425631023993, 218, 58, 'PPL', 'P'),
(147444, 'Bruynswick', 41.6575012207031, 0.727060554454827, -74.2266693115234, -1.29549977227512, 218, 40, 'PPL', 'P'),
(1206, 'Bryan', 33.6994400024414, 0.588166184120889, -87.0477828979492, -1.51927041813043, 218, 2, 'PPL', 'P'),
(7730, 'Bryan', 34.9352798461914, 0.609735658421658, -94.2249984741211, -1.64453646106005, 218, 4, 'PPL', 'P'),
(35029, 'Bryan', 36.9294395446777, 0.644540310970822, -85.2038879394531, -1.48708838004374, 218, 21, 'PPL', 'P'),
(92874, 'Bryan', 30.6741695404053, 0.535365253795028, -96.3697204589844, -1.68196892123582, 218, 51, 'PPL', 'P'),
(154511, 'Bryan', 41.4747200012207, 0.723870420364048, -84.5524978637695, -1.47571947850825, 218, 41, 'PPL', 'P'),
(159609, 'Bryan', 40.8327789306641, 0.712666435079057, -79.2905578613281, -1.38388130042325, 218, 45, 'PPL', 'P'),
(209331, 'Bryan', 41.5705604553223, 0.725543151844727, -109.68138885498, -1.91430136367962, 218, 59, 'PPL', 'P'),
(39558, 'Bryan (historical)', 32.2799987792969, 0.563392261238481, -93.0619430541992, -1.62423731459924, 218, 22, 'PPL', 'P'),
(63251, 'Bryan (historical)', 36.1972198486328, 0.631760666426886, -81.0458297729492, -1.41451657454881, 218, 33, 'PPL', 'P'),
(92870, 'Bryan Acres Colonia', 26.2950000762939, 0.45893432814349, -98.2979965209961, -1.71562368740531, 218, 51, 'PPL', 'P'),
(92871, 'Bryan Beach', 28.8830394744873, 0.504104136813296, -95.3783569335938, -1.66466636363357, 218, 51, 'PPL', 'P'),
(85371, 'Bryan Hill', 35.4972190856934, 0.61954334834712, -85.0025024414063, -1.48357354003706, 218, 50, 'PPL', 'P'),
(159610, 'Bryan Hill Manor', 40.6427803039551, 0.709350333468718, -79.1308288574219, -1.38109350339415, 218, 45, 'PPL', 'P'),
(80016, 'Bryan Landing', 32.1761093139648, 0.5615790480103, -80.8249969482422, -1.4106623146612, 218, 48, 'PPL', 'P'),
(19606, 'Bryan Mill', 34.8977813720703, 0.609081186583771, -84.1725006103516, -1.46908727528757, 218, 13, 'PPL', 'P'),
(85372, 'Bryan Mill', 35.5663909912109, 0.62075062584828, -85.9377822875977, -1.49989725278064, 218, 50, 'PPL', 'P'),
(159611, 'Bryan Mill', 41.2625007629395, 0.720166495919966, -76.7144393920898, -1.33891955121361, 218, 45, 'PPL', 'P'),
(19607, 'Bryan Neck (historical)', 31.9249992370605, 0.557196350383384, -81.3055572509766, -1.41904967419829, 218, 13, 'PPL', 'P'),
(13455, 'Bryan Park', 38.6897201538086, 0.675263003359167, -75.5875015258789, -1.31925077498282, 218, 10, 'PPL', 'P'),
(45202, 'Bryan Point', 38.6838912963867, 0.675161270605526, -77.054443359375, -1.34485373991257, 218, 25, 'PPL', 'P'),
(100289, 'Bryan Ridge', 37.3413887023926, 0.651730180123763, -77.416389465332, -1.3511708911763, 218, 53, 'PPL', 'P'),
(19608, 'Bryan Village', 31.8916702270508, 0.556614649422284, -81.5930633544922, -1.42406760232422, 218, 13, 'PPL', 'P'),
(92872, 'Bryan''s Addition Colonia', 26.2049999237061, 0.457363529153534, -98.2229995727539, -1.71431474372954, 218, 51, 'PPL', 'P'),
(53703, 'Bryans (historical)', 39.0555610656738, 0.681648131809714, -91.8916702270508, -1.60381220061888, 218, 29, 'PPL', 'P'),
(190960, 'Bryans Corner', 36.6163902282715, 0.639076569678416, -100.828056335449, -1.75978156143992, 218, 42, 'PPL', 'P'),
(80019, 'Bryans Crossroads', 33.5811080932617, 0.586100902695532, -79.8216705322266, -1.39315096522949, 218, 48, 'PPL', 'P'),
(92873, 'Bryans Mill', 33.2350006103516, 0.58006018755296, -94.4977798461914, -1.64929739414078, 218, 51, 'PPL', 'P'),
(45203, 'Bryans Road', 38.6269416809082, 0.674167312307681, -77.0733337402344, -1.34518343925553, 218, 25, 'PPL', 'P'),
(13456, 'Bryans Store', 38.5924987792969, 0.673566170270623, -75.4097213745117, -1.31614792599677, 218, 10, 'PPL', 'P'),
(63253, 'Bryans Woods', 35.8655586242676, 0.625972086060517, -80.2222213745117, -1.400141896249, 218, 33, 'PPL', 'P'),
(77943, 'Bryansville', 39.7480583190918, 0.693734488942875, -76.3533325195313, -1.33261704733588, 218, 45, 'PPL', 'P'),
(1208, 'Bryant', 34.9436111450195, 0.609881067017177, -85.6322174072266, -1.49456413953971, 218, 2, 'PPL', 'P'),
(7737, 'Bryant', 34.5958290100098, 0.603811123681641, -92.4888916015625, -1.6142356799674, 218, 4, 'PPL', 'P'),
(15359, 'Bryant', 26.8494396209717, 0.468611123701374, -80.6166687011719, -1.40702630082491, 218, 12, 'PPL', 'P'),
(19609, 'Bryant', 32.3536109924316, 0.564677036727362, -83.1347198486328, -1.45097458408172, 218, 13, 'PPL', 'P'),
(35031, 'Bryant', 38.2391700744629, 0.667399421029463, -84.9511108398438, -1.48267658738192, 218, 21, 'PPL', 'P'),
(53704, 'Bryant', 38.9597206115723, 0.679975400329035, -94.5116729736328, -1.64953987495803, 218, 29, 'PPL', 'P'),
(58816, 'Bryant', 33.9255599975586, 0.592112722540277, -89.7033309936523, -1.56561847584551, 218, 30, 'PPL', 'P'),
(75251, 'Bryant', 35.3905601501465, 0.617681798745155, -96.0644378662109, -1.6766407348429, 218, 42, 'PPL', 'P'),
(85373, 'Bryant', 35.2994384765625, 0.616091425521187, -85.4441680908203, -1.49128205981229, 218, 50, 'PPL', 'P'),
(100290, 'Bryant', 37.8008308410645, 0.659748958165992, -78.956672668457, -1.37805390448399, 218, 53, 'PPL', 'P'),
(114732, 'Bryant', 41.9633293151855, 0.732398261648645, -90.3300018310547, -1.57655594528441, 218, 16, 'PPL', 'P'),
(118940, 'Bryant', 40.4661102294922, 0.706266858979597, -90.091667175293, -1.57239622081976, 218, 18, 'PPL', 'P'),
(122288, 'Bryant', 40.5333290100098, 0.707440048018804, -84.9638900756836, -1.48289962712321, 218, 19, 'PPL', 'P'),
(129980, 'Bryant', 44.5250015258789, 0.777107876082086, -83.6658325195313, -1.46024424888796, 218, 27, 'PPL', 'P'),
(159612, 'Bryant', 40.5669403076172, 0.708026675827921, -79.9422225952148, -1.39525499564871, 218, 45, 'PPL', 'P'),
(169924, 'Bryant', 44.5905609130859, 0.778252103244439, -97.4669418334961, -1.70111904684431, 218, 49, 'PPL', 'P'),
(173344, 'Bryant', 45.2080612182617, 0.789029516701826, -89.0238876342773, -1.55375995214361, 218, 57, 'PPL', 'P'),
(200474, 'Bryant', 45.4041709899902, 0.792452277913823, -122.721389770508, -2.14189231411865, 218, 43, 'PPL', 'P'),
(206913, 'Bryant', 48.2391700744629, 0.841932346228896, -122.156669616699, -2.13203608808232, 218, 56, 'PPL', 'P'),
(108398, 'Bryant (historical)', 38.024169921875, 0.663646960474514, -80.7441711425781, -1.40925163823178, 218, 58, 'PPL', 'P'),
(200473, 'Bryant City (historical)', 44.6027793884277, 0.778465355868727, -122.33332824707, -2.13511936283436, 218, 43, 'PPL', 'P'),
(100291, 'Bryant Corner', 37.8830604553223, 0.661184135677436, -76.4591674804688, -1.33446421586796, 218, 53, 'PPL', 'P'),
(124345, 'Bryant Four Corners', 42.4686088562012, 0.741217053282334, -72.932502746582, -1.27291230464766, 218, 23, 'PPL', 'P'),
(100292, 'Bryant Heights', 37.3463897705078, 0.651817465228491, -79.9266662597656, -1.39498348637557, 218, 53, 'PPL', 'P'),
(1210, 'Bryant Landing', 30.4211101531982, 0.530948534285186, -87.9102783203125, -1.53432380303404, 218, 2, 'PPL', 'P'),
(126981, 'Bryant Pond', 44.3783302307129, 0.774547979063275, -70.6463928222656, -1.23301215940582, 218, 26, 'PPL', 'P'),
(85374, 'Bryant Station', 35.5116691589355, 0.619795549702351, -86.8894424438477, -1.51650685586725, 218, 50, 'PPL', 'P'),
(100295, 'Bryant Town', 38.1541709899902, 0.665915907144234, -76.8150024414063, -1.34067470753002, 218, 53, 'PPL', 'P'),
(45204, 'Bryant Woods', 39.2219390869141, 0.684551976083309, -76.8680572509766, -1.34160068864104, 218, 25, 'PPL', 'P'),
(45206, 'Bryantown', 38.9416694641113, 0.679660348372078, -76.170280456543, -1.32942218613416, 218, 25, 'PPL', 'P'),
(63254, 'Bryantown', 36.2805595397949, 0.63321521843526, -77.3591690063477, -1.35017220576752, 218, 33, 'PPL', 'P'),
(45207, 'Bryantown Estates', 38.5449981689453, 0.672737128223281, -76.8050003051758, -1.34050013732057, 218, 25, 'PPL', 'P'),
(45208, 'Bryantown Hills', 38.5405616760254, 0.672659696814587, -76.857780456543, -1.34142132474163, 218, 25, 'PPL', 'P'),
(180289, 'Bryants', 38.7188911437988, 0.675772133180563, -120.475563049316, -2.10269524340459, 218, 6, 'PPL', 'P'),
(100293, 'Bryants Corner', 36.5883293151855, 0.63858681435395, -77.4158325195313, -1.35116117063832, 218, 53, 'PPL', 'P'),
(126982, 'Bryants Corner', 44.4377784729004, 0.77558554662397, -69.0283279418945, -1.20477159973246, 218, 26, 'PPL', 'P'),
(203192, 'Bryants Fork Summer Home Area', 40.1749992370605, 0.701186013672916, -111.183326721191, -1.94051512460538, 218, 52, 'PPL', 'P'),
(147445, 'Bryants Mill', 44.6863899230957, 0.779924634988036, -74.1177825927734, -1.29359934052124, 218, 40, 'PPL', 'P'),
(19610, 'Bryants Mill (historical)', 34.1980590820313, 0.596868728772995, -85.083610534668, -1.48498914331449, 218, 13, 'PPL', 'P'),
(80017, 'Bryants Store (historical)', 35.149169921875, 0.613468744479677, -82.0369415283203, -1.43181473793526, 218, 48, 'PPL', 'P'),
(29331, 'Bryantsburg', 38.8858299255371, 0.678685764571164, -85.3744430541992, -1.49006512835218, 218, 19, 'PPL', 'P'),
(114733, 'Bryantsburg', 42.5747184753418, 0.743069015504375, -91.9052810668945, -1.60404975458812, 218, 16, 'PPL', 'P'),
(29332, 'Bryantsville', 38.7686080932617, 0.676639857642738, -86.5730590820313, -1.51098492450503, 218, 19, 'PPL', 'P'),
(35032, 'Bryantsville', 37.7144393920898, 0.658241142935816, -84.649169921875, -1.47740672421687, 218, 21, 'PPL', 'P'),
(124346, 'Bryantville', 42.0438919067383, 0.73380434412518, -70.8430633544922, -1.23644470773483, 218, 23, 'PPL', 'P'),
(7741, 'Bryanville', 34.9199981689453, 0.609468942838487, -90.8625030517578, -1.58584984485657, 218, 4, 'PPL', 'P'),
(154513, 'Bryar', 40.0233306884766, 0.698538898128405, -83.8838882446289, -1.46405003924374, 218, 41, 'PPL', 'P'),
(92875, 'Bryarly', 33.7463912963867, 0.588985638788306, -94.8905563354492, -1.65615263710275, 218, 51, 'PPL', 'P'),
(92876, 'Bryce', 31.9680500030518, 0.557947727995436, -94.5401992797852, -1.65003775292382, 218, 51, 'PPL', 'P'),
(108399, 'Bryce', 38.2230606079102, 0.667118257797378, -81.1519393920898, -1.41636853677085, 218, 58, 'PPL', 'P'),
(118941, 'Bryce', 40.6344413757324, 0.709204791715145, -87.7566680908203, -1.53164279876466, 218, 18, 'PPL', 'P'),
(177794, 'Bryce', 32.9288902282715, 0.574717553511125, -109.827217102051, -1.91684654673341, 218, 5, 'PPL', 'P'),
(192500, 'Bryce Canyon', 37.6283302307129, 0.656738254553657, -112.166938781738, -1.95768239362425, 218, 52, 'PPL', 'P'),
(39559, 'Bryceland', 32.4508285522461, 0.566373803236879, -92.9791717529297, -1.62279268286593, 218, 22, 'PPL', 'P'),
(15360, 'Bryceville', 30.3844394683838, 0.530308510096213, -81.9388885498047, -1.43010339061877, 218, 12, 'PPL', 'P'),
(191184, 'Bryden', 36.0233306884766, 0.628725728048632, -101.954719543457, -1.77944554398074, 218, 51, 'PPL', 'P'),
(108400, 'Brydon', 39.2799987792969, 0.685565308878084, -80.0650024414063, -1.39739790821984, 218, 58, 'PPL', 'P'),
(180290, 'Bryman', 34.6747207641602, 0.605188044544239, -117.344718933105, -2.04805170521002, 218, 6, 'PPL', 'P'),
(159613, 'Bryn Athyn', 40.1313896179199, 0.700424882233372, -75.0677795410156, -1.31017991515196, 218, 45, 'PPL', 'P'),
(19614, 'Bryn Mawr', 32.5677795410156, 0.56841498305437, -83.8127822875977, -1.46280900617576, 218, 13, 'PPL', 'P'),
(100294, 'Bryn Mawr', 38.9308280944824, 0.679471130776628, -77.1777801513672, -1.34700637302169, 218, 53, 'PPL', 'P'),
(159616, 'Bryn Mawr', 40.019718170166, 0.698475847789597, -75.3050003051758, -1.31432019854065, 218, 45, 'PPL', 'P'),
(180291, 'Bryn Mawr', 34.0483283996582, 0.594255435374327, -117.230003356934, -2.0460495407025, 218, 6, 'PPL', 'P'),
(206914, 'Bryn Mawr', 47.5036087036133, 0.829094378457087, -122.231666564941, -2.13334503175809, 218, 56, 'PPL', 'P'),
(147446, 'Bryn Mawr Park', 40.9461097717285, 0.714644431399686, -73.8649978637695, -1.28918741470136, 218, 40, 'PPL', 'P'),
(19611, 'Brynwood', 33.4963912963867, 0.58462231565832, -82.0508270263672, -1.43205708559446, 218, 13, 'PPL', 'P'),
(45209, 'Brynwood Farm Estates', 38.5363883972168, 0.672586859358773, -76.9055633544922, -1.34225529363698, 218, 25, 'PPL', 'P'),
(53706, 'Bryson', 38.5802803039551, 0.673352917646335, -93.4786071777344, -1.63150947542987, 218, 29, 'PPL', 'P'),
(85376, 'Bryson', 35.0986099243164, 0.612586306052479, -86.8616714477539, -1.51602216054886, 218, 50, 'PPL', 'P'),
(92877, 'Bryson', 33.1611099243164, 0.578770551795089, -98.3852767944336, -1.71714701554884, 218, 51, 'PPL', 'P'),
(180292, 'Bryson', 35.8066711425781, 0.624944305616828, -121.08943939209, -2.11340940678609, 218, 6, 'PPL', 'P'),
(196099, 'Bryson', 47.4152793884277, 0.827552741081067, -115.575828552246, -2.01717874395717, 218, 31, 'PPL', 'P'),
(71942, 'Bryson (historical)', 39.7166709899902, 0.693186676706645, -83.9366683959961, -1.4649712266648, 218, 41, 'PPL', 'P'),
(80018, 'Bryson (historical)', 34.5602798461914, 0.603190673726679, -82.0083312988281, -1.43131539523087, 218, 48, 'PPL', 'P'),
(63256, 'Bryson City', 35.4308280944824, 0.618384606956827, -83.4475021362305, -1.45643366484222, 218, 33, 'PPL', 'P'),
(85380, 'Bryson Mountain', 36.5658302307129, 0.638194131251218, -83.8125, -1.46280407932775, 218, 50, 'PPL', 'P'),
(63257, 'Bryson Place', 35.5208282470703, 0.619955405946783, -83.4191665649414, -1.4559391158278, 218, 33, 'PPL', 'P'),
(77944, 'Brysonia', 39.9513893127441, 0.69728328425346, -77.3080596923828, -1.34928017996039, 218, 45, 'PPL', 'P'),
(85378, 'Brysonville', 35.8833312988281, 0.626282277748484, -86.103889465332, -1.5027963699433, 218, 50, 'PPL', 'P'),
(180293, 'Bryte', 38.5947189331055, 0.673604919264484, -121.540557861328, -2.12128290939085, 218, 6, 'PPL', 'P'),
(108401, 'Bubbling Spring', 39.2541694641113, 0.685114502284561, -78.4583282470703, -1.36935615352185, 218, 58, 'PPL', 'P'),
(39560, 'Bubenzer', 30.9666690826416, 0.540470333867628, -92.2158279418945, -1.60946982003865, 218, 22, 'PPL', 'P'),
(114734, 'Bubona (historical)', 43.327220916748, 0.756202660736209, -94.6594390869141, -1.65211888015767, 218, 16, 'PPL', 'P'),
(15361, 'Bucell Junction', 30.0694408416748, 0.52481074692088, -83.5558319091797, -1.45832437605813, 218, 12, 'PPL', 'P'),
(15362, 'Buchanan', 27.4116706848145, 0.478423906922421, -81.7927780151367, -1.42755328071697, 218, 12, 'PPL', 'P'),
(19612, 'Buchanan', 33.8025016784668, 0.589964949700155, -85.188606262207, -1.48682166446057, 218, 13, 'PPL', 'P'),
(29333, 'Buchanan', 38.2161102294922, 0.666996950809724, -85.8994369506836, -1.49922800039871, 218, 19, 'PPL', 'P'),
(35033, 'Buchanan', 38.2438888549805, 0.667481779286173, -82.6108322143555, -1.4418310199531, 218, 21, 'PPL', 'P'),
(53707, 'Buchanan', 37.211109161377, 0.649456373185054, -90.1922225952148, -1.57415124397812, 218, 29, 'PPL', 'P'),
(71944, 'Buchanan', 39.1497192382813, 0.683291501939374, -83.1236114501953, -1.45078070595437, 218, 41, 'PPL', 'P'),
(85379, 'Buchanan', 36.436939239502, 0.635944559078428, -88.2083282470703, -1.5395257555913, 218, 50, 'PPL', 'P'),
(100296, 'Buchanan', 37.5272216796875, 0.654973577436344, -79.6800003051758, -1.3906783533154, 218, 53, 'PPL', 'P'),
(114735, 'Buchanan', 41.7649993896484, 0.728936751442787, -91.2466735839844, -1.59255488553306, 218, 16, 'PPL', 'P'),
(129981, 'Buchanan', 41.827220916748, 0.730022721956294, -86.3611068725586, -1.50728566059285, 218, 27, 'PPL', 'P'),
(139729, 'Buchanan', 47.0625, 0.821395579219831, -98.82861328125, -1.72488469693801, 218, 34, 'PPL', 'P'),
(147447, 'Buchanan', 41.2619400024414, 0.72015670880296, -73.938606262207, -1.29047212361121, 218, 40, 'PPL', 'P'),
(180294, 'Buchanan', 37.9147186279297, 0.6617366750246, -120.1875, -2.09766759474068, 218, 6, 'PPL', 'P'),
(194123, 'Buchanan', 40.8319396972656, 0.712651787693062, -103.168060302734, -1.80062233517877, 218, 7, 'PPL', 'P'),
(200475, 'Buchanan', 43.6425018310547, 0.761705350759558, -118.627502441406, -2.07044050102015, 218, 43, 'PPL', 'P'),
(19613, 'Buchanan (historical)', 33.9152793884277, 0.591933292061833, -84.2636108398438, -1.47067744877446, 218, 13, 'PPL', 'P'),
(92878, 'Buchanan (historical)', 32.4069595336914, 0.565608144423481, -97.4537124633789, -1.7008881507778, 218, 51, 'PPL', 'P'),
(188192, 'Buchanan (historical)', 34.4319381713867, 0.600950688933814, -104.791938781738, -1.82896436128967, 218, 38, 'PPL', 'P'),
(29334, 'Buchanan Corner', 39.1925010681152, 0.684038185730005, -87.2033309936523, -1.52198524454565, 218, 19, 'PPL', 'P'),
(92879, 'Buchanan Dam', 30.7397193908691, 0.536509314509812, -98.4308319091797, -1.71794210229228, 218, 51, 'PPL', 'P'),
(92880, 'Buchanan Lake Village', 30.8504390716553, 0.538441737486287, -98.4491424560547, -1.71826168162309, 218, 51, 'PPL', 'P'),
(85381, 'Buchanan Subdivision', 36.4111099243164, 0.635493752484905, -88.107780456543, -1.53777086559099, 218, 50, 'PPL', 'P'),
(77945, 'Buchanan Summit', 39.9188919067383, 0.6967160975203, -77.9452819824219, -1.36040180698867, 218, 45, 'PPL', 'P'),
(58817, 'Buchannan', 34.3388900756836, 0.599326693301084, -89.0994415283203, -1.55507861635736, 218, 30, 'PPL', 'P'),
(92881, 'Buchel', 29.158519744873, 0.508912174555812, -97.2910919189453, -1.69804988684604, 218, 51, 'PPL', 'P'),
(75252, 'Bucher', 35.9141693115234, 0.626820502604789, -98.3572235107422, -1.71665739338243, 218, 42, 'PPL', 'P'),
(159617, 'Buchers Mills', 41.7611083984375, 0.72886884083499, -79.1699981689453, -1.38177713684598, 218, 45, 'PPL', 'P'),
(180295, 'Buchli', 38.2150001525879, 0.666977576312794, -122.331672668457, -2.13509046753653, 218, 6, 'PPL', 'P'),
(71943, 'Buchtel', 39.4619407653809, 0.688740795582867, -82.1819381713867, -1.43434540676111, 218, 41, 'PPL', 'P'),
(63258, 'Buck', 36.1563911437988, 0.631048071098208, -81.2266693115234, -1.41767281991472, 218, 33, 'PPL', 'P'),
(77947, 'Buck', 39.872501373291, 0.695906429969889, -76.2291717529297, -1.33045003315688, 218, 45, 'PPL', 'P'),
(100299, 'Buck', 36.8044395446777, 0.642358649405829, -80.9305572509766, -1.41250468950331, 218, 53, 'PPL', 'P'),
(108402, 'Buck', 37.6016693115234, 0.656272933732193, -80.8241729736328, -1.41064793359131, 218, 58, 'PPL', 'P'),
(19615, 'Buck Creek', 33.5730590820313, 0.58596042094803, -83.958610534668, -1.46535418922955, 218, 13, 'PPL', 'P'),
(31902, 'Buck Creek', 39.0499992370605, 0.68155105958798, -95.2819366455078, -1.66298351214075, 218, 20, 'PPL', 'P'),
(53710, 'Buck Creek', 38.2313919067383, 0.667263666392896, -92.7683334350586, -1.61911286002971, 218, 29, 'PPL', 'P'),
(114740, 'Buck Creek', 42.3372192382813, 0.738923871846694, -91.3419418334961, -1.59421763015965, 218, 16, 'PPL', 'P'),
(122289, 'Buck Creek', 40.4877815246582, 0.706645094433415, -86.7613906860352, -1.51427193108046, 218, 19, 'PPL', 'P'),
(173346, 'Buck Creek', 43.4205589294434, 0.757831716375011, -90.3613891601563, -1.57710375752064, 218, 57, 'PPL', 'P'),
(19616, 'Buck Creek (historical)', 33.6124992370605, 0.586648781510789, -85.1122207641602, -1.48548848601888, 218, 13, 'PPL', 'P'),
(75253, 'Buck Creek Landing', 34.0263900756836, 0.593872539388601, -94.5113906860352, -1.64953494811002, 218, 42, 'PPL', 'P'),
(653, 'Buck Donic', 36.0397186279297, 0.629011751549706, -90.3258285522461, -1.5764831078286, 218, 29, 'PPL', 'P'),
(200476, 'Buck Fork (historical)', 43.1124992370605, 0.75245506045025, -123.14582824707, -2.14930016300681, 218, 43, 'PPL', 'P'),
(35034, 'Buck Grove', 37.9188919067383, 0.661809512480414, -86.1277770996094, -1.50321328781196, 218, 21, 'PPL', 'P'),
(114742, 'Buck Grove', 42.5141716003418, 0.742012273183831, -92.8494415283203, -1.62052846330715, 218, 16, 'PPL', 'P'),
(80020, 'Buck Hall', 33.0530586242676, 0.576884700848177, -79.5599975585938, -1.38858391027611, 218, 48, 'PPL', 'P'),
(80021, 'Buck Hall (historical)', 33.189998626709, 0.579274754768468, -79.9527816772461, -1.39543928639614, 218, 48, 'PPL', 'P'),
(159618, 'Buck Hill Falls', 41.1877784729004, 0.718862345934154, -75.26611328125, -1.31364149193685, 218, 45, 'PPL', 'P'),
(13457, 'Buck Hill Landing', 38.5597190856934, 0.672994056689447, -75.2222213745117, -1.31287543364928, 218, 10, 'PPL', 'P'),
(191185, 'Buck Hollow', 30.4899997711182, 0.532150884938329, -100.020278930664, -1.7456831861032, 218, 51, 'PPL', 'P'),
(1211, 'Buck Island Shores', 34.3919410705566, 0.600252607833077, -86.2724990844727, -1.50573916294784, 218, 2, 'PPL', 'P'),
(7742, 'Buck Knob', 34.7102813720703, 0.605808694236282, -93.9388885498047, -1.63954290085809, 218, 4, 'PPL', 'P'),
(85382, 'Buck Lake Estates', 36.163890838623, 0.631178965465785, -85.4416732788086, -1.49123851712847, 218, 50, 'PPL', 'P'),
(70586, 'Buck Landing', 38.9491691589355, 0.679791242739656, -74.9124984741211, -1.30746974926864, 218, 37, 'PPL', 'P'),
(45210, 'Buck Lodge', 39.0083312988281, 0.680823816873307, -76.9630584716797, -1.34325877273573, 218, 25, 'PPL', 'P'),
(180296, 'Buck Meadows', 37.8127784729004, 0.659957483679345, -120.063331604004, -2.09550044740363, 218, 6, 'PPL', 'P'),
(63259, 'Buck Mobil Home Park', 35.6308288574219, 0.621875278776621, -77.351936340332, -1.35004597193185, 218, 33, 'PPL', 'P'),
(85383, 'Buck Mountain', 36.1816711425781, 0.631489290311807, -81.9972229003906, -1.43112151710351, 218, 50, 'PPL', 'P'),
(159620, 'Buck Mountain', 40.8211097717285, 0.712462769834693, -76.0991668701172, -1.32818101990813, 218, 45, 'PPL', 'P'),
(85384, 'Buck Mountain Estates', 36.1500015258789, 0.630936551227561, -85.4358291625977, -1.49113651805872, 218, 50, 'PPL', 'P'),
(45211, 'Buck Neck', 39.2700004577637, 0.685390805247657, -76.1591720581055, -1.32922830800681, 218, 25, 'PPL', 'P'),
(45212, 'Buck Neck Landing', 39.2744407653809, 0.685468303235378, -76.168327331543, -1.32938809767221, 218, 25, 'PPL', 'P'),
(209332, 'Buck Place', 42.5750007629395, 0.743073942352391, -105.920280456543, -1.84865763860248, 218, 59, 'PPL', 'P'),
(7745, 'Buck Range', 33.8566703796387, 0.590910371887133, -93.8488922119141, -1.63797216844716, 218, 4, 'PPL', 'P'),
(159622, 'Buck Run', 40.7075004577637, 0.710479913245075, -76.3272171020508, -1.33216124731531, 218, 45, 'PPL', 'P'),
(71945, 'Buck Run (historical)', 38.9855613708496, 0.68042640665964, -83.579719543457, -1.45874129392678, 218, 41, 'PPL', 'P'),
(147448, 'Buck Settlement', 42.2911109924316, 0.738119131144299, -77.4002838134766, -1.35088979452324, 218, 40, 'PPL', 'P'),
(7744, 'Buck Snort', 35.8930587768555, 0.626452054267977, -90.649169921875, -1.58212647933653, 218, 4, 'PPL', 'P'),
(80022, 'Buck Stand', 34.2738914489746, 0.598192253255737, -82.3766708374023, -1.43774413294427, 218, 48, 'PPL', 'P'),
(129984, 'Buck Trails', 44.101390838623, 0.769714474842835, -84.857780456543, -1.48104766490117, 218, 27, 'PPL', 'P'),
(77949, 'Buck Valley', 39.7663917541504, 0.694054467747848, -78.283332824707, -1.36630190722569, 218, 45, 'PPL', 'P'),
(58818, 'Buckatunna', 31.538890838623, 0.550457487561048, -88.5288925170898, -1.54512065756739, 218, 30, 'PPL', 'P'),
(173347, 'Buckbee', 44.6488914489746, 0.779270163150149, -88.8349990844727, -1.5504632250302, 218, 57, 'PPL', 'P'),
(45213, 'Buckels Corner', 38.9897193908691, 0.680498977799344, -75.8969421386719, -1.32465153251545, 218, 25, 'PPL', 'P'),
(15363, 'Bucker Womans Town (historical)', 28.5666694641113, 0.498582438477667, -82.1333312988281, -1.43349705679586, 218, 12, 'PPL', 'P'),
(7747, 'Buckeye', 35.9599990844727, 0.627620383038194, -90.1588897705078, -1.573569476438, 218, 4, 'PPL', 'P'),
(31903, 'Buckeye', 39.0466690063477, 0.681492936097189, -97.1666717529297, -1.69587834529319, 218, 20, 'PPL', 'P'),
(35035, 'Buckeye', 37.7155609130859, 0.658260717169828, -84.5055618286133, -1.47490029015694, 218, 21, 'PPL', 'P'),
(39561, 'Buckeye', 31.3661098480225, 0.54744189039021, -92.1888885498047, -1.60899963894819, 218, 22, 'PPL', 'P'),
(53712, 'Buckeye', 36.9044418334961, 0.64410401860524, -89.4925003051758, -1.56193878616735, 218, 29, 'PPL', 'P'),
(71947, 'Buckeye', 39.8883285522461, 0.696182666353957, -81.9933319091797, -1.43105360649571, 218, 41, 'PPL', 'P'),
(85385, 'Buckeye', 36.4072189331055, 0.635425841877108, -84.2936096191406, -1.47120102624477, 218, 50, 'PPL', 'P'),
(92882, 'Buckeye', 28.8952808380127, 0.504317788911748, -96.0477828979492, -1.67635005080991, 218, 51, 'PPL', 'P'),
(100300, 'Buckeye', 37.6872215270996, 0.657766101576374, -77.3166732788086, -1.34943051540393, 218, 53, 'PPL', 'P'),
(108404, 'Buckeye', 38.1858291625977, 0.666468446491398, -80.1347198486328, -1.39861470652189, 218, 58, 'PPL', 'P'),
(114743, 'Buckeye', 42.4172210693359, 0.740320167206222, -93.3747177124023, -1.62969626220169, 218, 16, 'PPL', 'P'),
(118942, 'Buckeye', 40.5319404602051, 0.707415813252884, -90.2908325195313, -1.57587231183259, 218, 18, 'PPL', 'P'),
(122290, 'Buckeye', 40.6911087036133, 0.710193823164973, -85.353889465332, -1.48970640055335, 218, 19, 'PPL', 'P'),
(141393, 'Buckeye', 41.190559387207, 0.718910882045021, -99.5680618286133, -1.73779050873859, 218, 35, 'PPL', 'P'),
(159624, 'Buckeye', 40.121940612793, 0.700259965982869, -79.5505599975586, -1.38841919376269, 218, 45, 'PPL', 'P'),
(177795, 'Buckeye', 33.3702812194824, 0.582421279596397, -112.583061218262, -1.96494510023301, 218, 5, 'PPL', 'P'),
(188193, 'Buckeye', 32.8019409179688, 0.572501870063206, -103.505279541016, -1.80650792118785, 218, 38, 'PPL', 'P'),
(189971, 'Buckeye', 38.9605598449707, 0.67999004771503, -119.723327636719, -2.08956625870466, 218, 39, 'PPL', 'P'),
(193404, 'Buckeye', 40.6436080932617, 0.709364781117632, -122.396392822266, -2.13622004731289, 218, 6, 'PPL', 'P'),
(194124, 'Buckeye', 40.827220916748, 0.712569429436351, -105.094436645508, -1.8342439449927, 218, 7, 'PPL', 'P'),
(206915, 'Buckeye', 47.8424987792969, 0.835009126080098, -117.373329162598, -2.04855104791441, 218, 56, 'PPL', 'P'),
(100301, 'Buckeye (historical)', 38.2847213745117, 0.668194441193879, -79.7480621337891, -1.39186625631963, 218, 53, 'PPL', 'P'),
(154516, 'Buckeye City', 40.4438896179199, 0.705879036145854, -82.2586135864258, -1.43568364520887, 218, 41, 'PPL', 'P'),
(186464, 'Buckeye Crossroads', 37.5574989318848, 0.655502015175643, -102.128326416016, -1.78247555551097, 218, 7, 'PPL', 'P'),
(180299, 'Buckeye Flat (historical)', 38.6694412231445, 0.674909069250295, -120.91194152832, -2.11031148464805, 218, 6, 'PPL', 'P'),
(63262, 'Buckeye Ford', 35.2563896179199, 0.615340081198648, -82.3902816772461, -1.4379816869135, 218, 33, 'PPL', 'P'),
(71948, 'Buckeye Lake', 39.9336090087891, 0.696972959407438, -82.4725036621094, -1.43941673126689, 218, 41, 'PPL', 'P'),
(177796, 'Buckeye Mill', 32.2561111450195, 0.562975343369829, -109.581672668457, -1.91256098790726, 218, 5, 'PPL', 'P'),
(71950, 'Buckeyeville', 39.9513893127441, 0.69728328425346, -81.6133270263672, -1.42442127011698, 218, 41, 'PPL', 'P'),
(45214, 'Buckeystown', 39.3347206115723, 0.686520385024014, -77.4319381713867, -1.35144226729138, 218, 25, 'PPL', 'P'),
(45215, 'Buckeystown Station', 39.3316688537598, 0.686467121802212, -77.4486083984375, -1.35173321764047, 218, 25, 'PPL', 'P'),
(126983, 'Buckfield', 44.2894401550293, 0.772996554570249, -70.3658294677734, -1.2281154051095, 218, 26, 'PPL', 'P'),
(100302, 'Buckhall', 38.7316703796387, 0.675995172921857, -77.4313888549805, -1.35143267991145, 218, 53, 'PPL', 'P'),
(108405, 'Buckhannon', 38.9938888549805, 0.680571748676131, -80.2322235107422, -1.40031646645846, 218, 58, 'PPL', 'P'),
(26636, 'Buckhart', 39.7497215270996, 0.693763517398757, -89.4447174072266, -1.56110481727199, 218, 18, 'PPL', 'P'),
(53714, 'Buckhart', 36.8938903808594, 0.643919861015861, -92.3188934326172, -1.61126865219694, 218, 29, 'PPL', 'P'),
(53715, 'Buckhart Springs (historical)', 37.0558280944824, 0.646746207301735, -91.3847198486328, -1.59496424737126, 218, 29, 'PPL', 'P'),
(19619, 'Buckhead', 33.5683288574219, 0.585877862954238, -83.3625030517578, -1.45495015095699, 218, 13, 'PPL', 'P'),
(63263, 'Buckhead', 34.374439239502, 0.599947143256045, -78.418327331543, -1.36865800584208, 218, 33, 'PPL', 'P'),
(19620, 'Buckhead (historical)', 33.2077789306641, 0.57958507961449, -83.1930618286133, -1.45199284372452, 218, 13, 'PPL', 'P'),
(15364, 'Buckhead Ridge', 27.1299991607666, 0.473507811418676, -80.8938903808594, -1.41186473189337, 218, 12, 'PPL', 'P'),
(200477, 'Buckheaven', 45.3766708374023, 0.791972309706363, -122.998329162598, -2.14672581833909, 218, 43, 'PPL', 'P'),
(92883, 'Buckholts', 30.8727798461914, 0.538831657559389, -97.1247177124023, -1.69514610915148, 218, 51, 'PPL', 'P'),
(1214, 'Buckhorn', 31.8033294677734, 0.555072812309182, -85.7605590820313, -1.49680412433257, 218, 2, 'PPL', 'P'),
(7748, 'Buckhorn', 34.7341690063477, 0.606225612104934, -91.0497207641602, -1.58911741035604, 218, 4, 'PPL', 'P'),
(15366, 'Buckhorn', 30.0669403076172, 0.524767104368517, -84.4519424438477, -1.47396445534989, 218, 12, 'PPL', 'P'),
(26638, 'Buckhorn', 39.9366683959961, 0.697026355787294, -90.8358306884766, -1.58538432429802, 218, 18, 'PPL', 'P'),
(35036, 'Buckhorn', 37.3486099243164, 0.651856214222352, -83.4763870239258, -1.45693780123658, 218, 21, 'PPL', 'P'),
(53717, 'Buckhorn', 37.3380584716797, 0.651672056632972, -90.289436340332, -1.57584794390861, 218, 29, 'PPL', 'P'),
(58819, 'Buckhorn', 34.0924987792969, 0.595026353930878, -89.1575012207031, -1.55609194915213, 218, 30, 'PPL', 'P'),
(71951, 'Buckhorn', 38.7463912963867, 0.676252101388022, -82.6352767944336, -1.44225765835973, 218, 41, 'PPL', 'P'),
(92885, 'Buckhorn', 30.038330078125, 0.524267761664127, -96.1997222900391, -1.67900189346536, 218, 51, 'PPL', 'P'),
(114744, 'Buckhorn', 42.060001373291, 0.734085507357265, -90.753059387207, -1.58393969256471, 218, 16, 'PPL', 'P'),
(129986, 'Buckhorn', 42.0019416809082, 0.73307217456249, -86.4036102294922, -1.50802748411449, 218, 27, 'PPL', 'P'),
(159626, 'Buckhorn', 41.0191688537598, 0.715919552929616, -76.5008316040039, -1.3351913920036, 218, 45, 'PPL', 'P'),
(177797, 'Buckhorn', 33.4155616760254, 0.583211572649878, -111.701110839844, -1.9495521622904, 218, 5, 'PPL', 'P'),
(180300, 'Buckhorn', 34.4008293151855, 0.600407736966574, -118.814720153809, -2.07370806651962, 218, 6, 'PPL', 'P'),
(188194, 'Buckhorn', 33.0369415283203, 0.576603404458037, -108.707778930664, -1.89730866487021, 218, 38, 'PPL', 'P'),
(199851, 'Buckhorn', 40.1761093139648, 0.701205388169847, -116.479721069336, -2.03295464446452, 218, 39, 'PPL', 'P'),
(206916, 'Buckhorn', 48.7066688537598, 0.85009173917668, -122.868057250977, -2.14445214455843, 218, 56, 'PPL', 'P'),
(209333, 'Buckhorn', 44.1494407653809, 0.770553104270101, -104.095283508301, -1.8168054330168, 218, 59, 'PPL', 'P'),
(39562, 'Buckhorn (historical)', 32.4536094665527, 0.566422339347746, -93.3052825927734, -1.62848439074765, 218, 22, 'PPL', 'P'),
(71952, 'Buckhorn (historical)', 39.0727806091309, 0.681948669538729, -82.2022171020508, -1.43469934086998, 218, 41, 'PPL', 'P'),
(108407, 'Buckhorn (historical)', 39.3697204589844, 0.687131247599051, -79.7013931274414, -1.39105172850023, 218, 58, 'PPL', 'P'),
(154518, 'Buckhorn Corner', 40.2230606079102, 0.702024842837264, -84.7752838134766, -1.47960782685782, 218, 41, 'PPL', 'P'),
(173348, 'Buckhorn Corner', 43.5083312988281, 0.759363633213052, -88.8058319091797, -1.54995416178783, 218, 57, 'PPL', 'P'),
(118945, 'Buckhorn Corners', 42.4247207641602, 0.740451061573799, -89.6383285522461, -1.56448396922114, 218, 18, 'PPL', 'P'),
(63264, 'Buckhorn Crossroads', 35.6780586242676, 0.622699593713028, -78.107780456543, -1.36323794039155, 218, 33, 'PPL', 'P'),
(180301, 'Buckhorn Estates', 37.9533309936523, 0.662410587938445, -120.271667480469, -2.09913659439797, 218, 6, 'PPL', 'P'),
(71953, 'Buckhorn Furnace', 38.7363891601563, 0.676077531178568, -82.6522216796875, -1.44255340239878, 218, 41, 'PPL', 'P'),
(45217, 'Buckhorn Run', 39.4180603027344, 0.687974937032388, -77.0147171020508, -1.34416038592277, 218, 25, 'PPL', 'P'),
(200478, 'Buckhorn Springs', 42.1055603027344, 0.734880660679735, -122.530563354492, -2.1385617648594, 218, 43, 'PPL', 'P'),
(19621, 'Buckhorn Tavern', 34.5230598449707, 0.602541062157782, -84.0374984741211, -1.46673104351312, 218, 13, 'PPL', 'P'),
(147449, 'Buckhout Corners', 41.1330604553223, 0.717907336367251, -73.8191680908203, -1.28838753426795, 218, 40, 'PPL', 'P'),
(793, 'Buckingham', 39.9311103820801, 0.696929350144588, -74.4477767944336, -1.2993588258527, 218, 37, 'PPL', 'P'),
(15367, 'Buckingham', 26.6747207641602, 0.465561704384693, -81.7322235107422, -1.42649640523837, 218, 12, 'PPL', 'P'),
(19622, 'Buckingham', 33.538890838623, 0.585364072600934, -84.0269393920898, -1.46654675276569, 218, 13, 'PPL', 'P'),
(35037, 'Buckingham', 37.3691711425781, 0.65221507517924, -82.7394409179688, -1.44407566527787, 218, 21, 'PPL', 'P'),
(71954, 'Buckingham', 39.5916709899902, 0.691005015141653, -82.1377792358398, -1.43357468794164, 218, 41, 'PPL', 'P'),
(100309, 'Buckingham', 38.8733291625977, 0.678467585098859, -77.1069412231445, -1.34577000048562, 218, 53, 'PPL', 'P'),
(114745, 'Buckingham', 42.2625007629395, 0.737619788439909, -92.4475021362305, -1.61351329752171, 218, 16, 'PPL', 'P'),
(118946, 'Buckingham', 41.0469398498535, 0.716404248248011, -88.1752777099609, -1.53894891489918, 218, 18, 'PPL', 'P'),
(159627, 'Buckingham', 40.3236083984375, 0.703779732837572, -75.0602798461914, -1.31004902078438, 218, 45, 'PPL', 'P'),
(177543, 'Buckingham', 41.7122192382813, 0.728015564021729, -72.5227813720703, -1.26576131764664, 218, 8, 'PPL', 'P'),
(194126, 'Buckingham', 40.6213912963867, 0.708977024862916, -103.97721862793, -1.81474481212335, 218, 7, 'PPL', 'P'),
(194650, 'Buckingham', 43.9891700744629, 0.767755853019137, -116.892501831055, -2.0401590278454, 218, 17, 'PPL', 'P'),
(196100, 'Buckingham', 46.5169410705566, 0.811873779637389, -111.165832519531, -1.9402097931864, 218, 31, 'PPL', 'P'),
(114746, 'Buckingham (historical)', 42.2105598449707, 0.736713248404846, -92.4791717529297, -1.61406603660596, 218, 16, 'PPL', 'P'),
(199853, 'Buckingham Camp', 40.6130599975586, 0.708831616267398, -117.071670532227, -2.04328611159738, 218, 39, 'PPL', 'P'),
(100305, 'Buckingham Circle', 38.0294418334961, 0.663738972690176, -78.5308303833008, -1.3706215545138, 218, 53, 'PPL', 'P'),
(100307, 'Buckingham Estates', 37.3116683959961, 0.651211462922443, -80.0652770996094, -1.3974027019098, 218, 53, 'PPL', 'P'),
(13458, 'Buckingham Heights', 39.8063888549805, 0.694752548848585, -75.4972229003906, -1.31767511572388, 218, 10, 'PPL', 'P'),
(85386, 'Buckingham Heights', 36.1552810668945, 0.631028696601278, -82.8000030517578, -1.44513267391453, 218, 50, 'PPL', 'P'),
(45218, 'Buckingham Hills', 39.3250007629395, 0.686350741662576, -77.4191665649414, -1.35121936070814, 218, 25, 'PPL', 'P'),
(80023, 'Buckingham Landing', 32.2299995422363, 0.562519609928289, -80.7994384765625, -1.41021623517861, 218, 48, 'PPL', 'P'),
(45219, 'Buckingham Manor', 39.4388885498047, 0.688338458521183, -76.9569396972656, -1.34315197997601, 218, 25, 'PPL', 'P'),
(144913, 'Buckingham Park', 40.0436096191406, 0.698892832237277, -74.8861083984375, -1.30700915555811, 218, 37, 'PPL', 'P'),
(180302, 'Buckingham Park', 39.0155601501465, 0.680949984129949, -122.756942749023, -2.14251283065264, 218, 6, 'PPL', 'P'),
(159628, 'Buckingham Valley', 40.3097190856934, 0.703537318599347, -75.0500030517578, -1.30986965688497, 218, 45, 'PPL', 'P'),
(45220, 'Buckingham View', 39.5583305358887, 0.69042311444347, -76.9763870239258, -1.34349139985694, 218, 25, 'PPL', 'P'),
(70587, 'Buckingham Village', 39.7602806091309, 0.69394780814619, -75.1374969482422, -1.31139671345402, 218, 37, 'PPL', 'P'),
(15368, 'Buckingham West', 29.6583309173584, 0.517635525153934, -82.4352798461914, -1.43876705311896, 218, 12, 'PPL', 'P'),
(63266, 'Buckland', 36.4741706848145, 0.636594370384407, -76.7616729736328, -1.33974393272904, 218, 33, 'PPL', 'P'),
(100308, 'Buckland', 38.7802810668945, 0.676843589466129, -77.6741714477539, -1.35567003552188, 218, 53, 'PPL', 'P'),
(124347, 'Buckland', 42.5922203063965, 0.743374480081407, -72.7922210693359, -1.2704639274995, 218, 23, 'PPL', 'P'),
(154520, 'Buckland', 40.6227798461914, 0.709001259628836, -84.2600021362305, -1.47061446501468, 218, 41, 'PPL', 'P'),
(177544, 'Buckland', 41.7961082458496, 0.729479703410027, -72.5511093139648, -1.26625573350301, 218, 8, 'PPL', 'P'),
(211715, 'Buckland', 65.9797210693359, 1.15156337220739, -161.123062133789, -2.81212793513002, 218, 1, 'PPL', 'P'),
(100310, 'Buckland Forest', 37.3558311462402, 0.651982248320939, -79.9749984741211, -1.39582704265085, 218, 53, 'PPL', 'P'),
(124348, 'Buckland Four Corners', 42.5647201538086, 0.742894511873947, -72.8041687011719, -1.27067245301285, 218, 23, 'PPL', 'P'),
(189972, 'Bucklands Station (historical)', 39.2947196960449, 0.685822237344249, -119.250556945801, -2.08131485354122, 218, 39, 'PPL', 'P'),
(45221, 'Buckler Trailer Park', 38.563060760498, 0.673052379917319, -76.6066665649414, -1.33703856053568, 218, 25, 'PPL', 'P'),
(100311, 'Buckles (historical)', 36.8158302307129, 0.642557454381204, -82.9574966430664, -1.44788145563365, 218, 53, 'PPL', 'P'),
(63268, 'Bucklesberry', 35.2299995422363, 0.614879487488119, -77.720832824707, -1.35648443018322, 218, 33, 'PPL', 'P'),
(118947, 'Buckley', 40.5969390869141, 0.708550253298231, -88.0380630493164, -1.53655406728893, 218, 18, 'PPL', 'P'),
(129987, 'Buckley', 44.5044403076172, 0.776749015125198, -85.6769409179688, -1.49534471205521, 218, 27, 'PPL', 'P'),
(206917, 'Buckley', 47.163330078125, 0.823155396068156, -122.02555847168, -2.12974776691567, 218, 56, 'PPL', 'P'),
(53718, 'Buckley (historical)', 37.4233283996582, 0.653160297629136, -93.5316696166992, -1.63243558969894, 218, 29, 'PPL', 'P'),
(189973, 'Buckley Camp (historical)', 38.7341690063477, 0.676038782184707, -118.533889770508, -2.06880665169139, 218, 39, 'PPL', 'P'),
(147450, 'Buckley Hollow', 42.4008293151855, 0.74003407712612, -75.6605606079102, -1.32052589651275, 218, 40, 'PPL', 'P'),
(58820, 'Buckleytown', 32.3036117553711, 0.563804385417171, -89.3608322143555, -1.55964074446272, 218, 30, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(147451, 'Buckleyville', 42.3458290100098, 0.739074140711201, -73.6052780151367, -1.28465444820993, 218, 40, 'PPL', 'P'),
(80030, 'Bucklick', 34.4511108398438, 0.601285315124782, -80.9036102294922, -1.4120343752548, 218, 48, 'PPL', 'P'),
(85388, 'Bucklick', 36.1672210693359, 0.631237088956576, -84.85888671875, -1.48106697281907, 218, 50, 'PPL', 'P'),
(31908, 'Bucklin', 37.5472183227539, 0.655322584697199, -99.6338882446289, -1.73893939643285, 218, 20, 'PPL', 'P'),
(53719, 'Bucklin', 39.7816696166992, 0.694321116751992, -92.8899993896484, -1.62123633152489, 218, 29, 'PPL', 'P'),
(45222, 'Bucklodge', 39.1925010681152, 0.684038185730005, -77.335563659668, -1.34976021474688, 218, 25, 'PPL', 'P'),
(134459, 'Buckman', 45.8974990844727, 0.801062477455131, -94.0933303833008, -1.64223841935542, 218, 28, 'PPL', 'P'),
(173349, 'Buckman', 44.4144401550293, 0.775178216135242, -87.7852783203125, -1.53214214146905, 218, 57, 'PPL', 'P'),
(188195, 'Buckman', 35.8319396972656, 0.625385325093345, -106.156112670898, -1.85277368722525, 218, 38, 'PPL', 'P'),
(159631, 'Buckmanville', 40.314998626709, 0.703629463973064, -74.9747161865234, -1.30855565320312, 218, 45, 'PPL', 'P'),
(114749, 'Bucknell', 41.0661087036133, 0.716738807859952, -93.0441665649414, -1.62392705633225, 218, 16, 'PPL', 'P'),
(159632, 'Bucknell', 40.9575004577637, 0.714843236375061, -76.9086074829102, -1.34230842370073, 218, 45, 'PPL', 'P'),
(100312, 'Bucknell Heights', 38.764720916748, 0.676572013613968, -77.0777816772461, -1.3452610704013, 218, 53, 'PPL', 'P'),
(100313, 'Bucknell Manor', 38.7680587768555, 0.676630270262814, -77.0694427490234, -1.34511552864773, 218, 53, 'PPL', 'P'),
(7751, 'Buckner', 33.3583297729492, 0.582212687504016, -93.4358291625977, -1.63076285821827, 218, 4, 'PPL', 'P'),
(26640, 'Buckner', 37.9830589294434, 0.662929438297819, -89.01611328125, -1.55362426408607, 218, 18, 'PPL', 'P'),
(35038, 'Buckner', 38.3836097717285, 0.669920369317332, -85.4400024414063, -1.49120935551453, 218, 21, 'PPL', 'P'),
(39563, 'Buckner', 32.3008308410645, 0.563755849306304, -91.938606262207, -1.60463138897019, 218, 22, 'PPL', 'P'),
(53721, 'Buckner', 39.1324996948242, 0.682990964210359, -94.1983337402344, -1.64407107365955, 218, 29, 'PPL', 'P'),
(63269, 'Buckner', 35.8638916015625, 0.625942991025608, -82.4841690063477, -1.43962032993223, 218, 33, 'PPL', 'P'),
(85389, 'Buckner', 36.0047187805176, 0.628400888974669, -85.7513885498047, -1.49664406835106, 218, 50, 'PPL', 'P'),
(92888, 'Buckner', 32.5897216796875, 0.568797945619124, -97.9022216796875, -1.70871611332792, 218, 51, 'PPL', 'P'),
(100314, 'Buckner', 37.9619407653809, 0.662560856802952, -77.773063659668, -1.35739603022436, 218, 53, 'PPL', 'P'),
(100317, 'Buckners Corner', 38.6216697692871, 0.674075300092019, -78.2355575561523, -1.36546807148839, 218, 53, 'PPL', 'P'),
(209334, 'Bucknum', 43.0208282470703, 0.750855099846358, -106.625556945801, -1.86096703547693, 218, 59, 'PPL', 'P'),
(129988, 'Buckroe', 46.6722183227539, 0.814583878941681, -87.524169921875, -1.52758494021171, 218, 27, 'PPL', 'P'),
(100315, 'Buckroe Beach', 37.042781829834, 0.646518507028533, -76.2936096191406, -1.33157468608522, 218, 53, 'PPL', 'P'),
(100316, 'Buckroe Gardens', 37.0499992370605, 0.646644474548094, -76.2925033569336, -1.33155537816732, 218, 53, 'PPL', 'P'),
(1217, 'Bucks', 31.0102806091309, 0.541231498596686, -88.024169921875, -1.53631158647168, 218, 2, 'PPL', 'P'),
(118948, 'Bucks', 40.2649993896484, 0.702756812662872, -88.9700012207031, -1.55281945680464, 218, 18, 'PPL', 'P'),
(129989, 'Bucks', 44.7480583190918, 0.781000951542591, -84.5699996948242, -1.47602494308528, 218, 27, 'PPL', 'P'),
(147452, 'Bucks Bridge', 44.7050018310547, 0.780249474061998, -75.1594390869141, -1.31177967601877, 218, 40, 'PPL', 'P'),
(63270, 'Bucks Corner', 34.7222213745117, 0.606017086591581, -77.0686111450195, -1.34510101441979, 218, 33, 'PPL', 'P'),
(143566, 'Bucks Corner', 43.7377815246582, 0.763368295123231, -71.9486083984375, -1.25574010878078, 218, 36, 'PPL', 'P'),
(147454, 'Bucks Corner', 42.6883316040039, 0.74505193867302, -73.4372177124023, -1.28172124258532, 218, 40, 'PPL', 'P'),
(154521, 'Bucks Corner', 40.3091697692871, 0.703527731219423, -84.7752838134766, -1.47960782685782, 218, 41, 'PPL', 'P'),
(200479, 'Bucks Corners', 45.7855606079102, 0.799108782479449, -119.326667785645, -2.08264323829295, 218, 43, 'PPL', 'P'),
(126985, 'Bucks Harbor', 44.6419410705566, 0.779148856162496, -67.3888931274414, -1.17615806434843, 218, 26, 'PPL', 'P'),
(180303, 'Bucks Lake', 39.8708305358887, 0.695877268355953, -121.183326721191, -2.11504804980481, 218, 6, 'PPL', 'P'),
(7752, 'Bucks Landing', 34.8705596923828, 0.608606078645301, -91.4661102294922, -1.59638477749671, 218, 4, 'PPL', 'P'),
(180304, 'Bucks Lodge', 39.875560760498, 0.695959826349745, -121.173606872559, -2.11487840644338, 218, 6, 'PPL', 'P'),
(71955, 'Bucks Mill', 39.1416702270508, 0.683151020191873, -81.9466705322266, -1.43023921183437, 218, 41, 'PPL', 'P'),
(85391, 'Bucks Mill', 34.9911117553711, 0.610710109064518, -86.5224990844727, -1.51010248607783, 218, 50, 'PPL', 'P'),
(134462, 'Bucks Mill', 46.7230606079102, 0.815471244216896, -95.9147186279297, -1.67402764118131, 218, 28, 'PPL', 'P'),
(144914, 'Bucks Mill', 40.2844390869141, 0.703096099385749, -74.1980590820313, -1.29500042957073, 218, 37, 'PPL', 'P'),
(126986, 'Bucks Mills', 44.6266708374023, 0.778882340316406, -68.7300033569336, -1.19956485348525, 218, 26, 'PPL', 'P'),
(129990, 'Buckshot Landing', 46.8163909912109, 0.817100166697643, -89.7949981689453, -1.56721836987038, 218, 27, 'PPL', 'P'),
(70588, 'Buckshutem', 39.3188896179199, 0.686244082060918, -75.0130615234375, -1.30922490558506, 218, 37, 'PPL', 'P'),
(29336, 'Buckskin', 38.228328704834, 0.667210203434012, -87.4119415283203, -1.52562618522995, 218, 19, 'PPL', 'P'),
(189975, 'Buckskin (historical)', 38.9922218322754, 0.680542653641222, -119.351387023926, -2.08307467038954, 218, 39, 'PPL', 'P'),
(186465, 'Buckskin Joe', 38.476390838623, 0.671539704418154, -105.326393127441, -1.83829234932378, 218, 7, 'PPL', 'P'),
(45223, 'Buckskin Woods', 39.2541694641113, 0.685114502284561, -76.970832824707, -1.34339446079327, 218, 25, 'PPL', 'P'),
(1222, 'Bucksnort', 34.503059387207, 0.6021919883179, -86.3038864135742, -1.50628697518407, 218, 2, 'PPL', 'P'),
(7753, 'Bucksnort', 33.8455581665039, 0.590716427180748, -92.4741668701172, -1.6139786849222, 218, 4, 'PPL', 'P'),
(85396, 'Bucksnort', 35.8855590820313, 0.626321159900399, -87.684440612793, -1.53038219146267, 218, 50, 'PPL', 'P'),
(134463, 'Bucksnort', 43.8177795410156, 0.764764523903732, -92.0508270263672, -1.60659001079389, 218, 28, 'PPL', 'P'),
(80024, 'Bucksport', 33.6647186279297, 0.587560181814841, -79.102783203125, -1.3806040143858, 218, 48, 'PPL', 'P'),
(126987, 'Bucksport', 44.5736083984375, 0.777956226047331, -68.7961120605469, -1.20071866802752, 218, 26, 'PPL', 'P'),
(193405, 'Bucksport', 40.7752799987793, 0.711662889401288, -124.191108703613, -2.16754374858024, 218, 6, 'PPL', 'P'),
(126988, 'Bucksport Center', 44.6311111450195, 0.778959838304127, -68.8344421386719, -1.20138765409335, 218, 26, 'PPL', 'P'),
(159638, 'Buckstown', 40.0711097717285, 0.699372800444736, -78.8619384765625, -1.37640048092122, 218, 45, 'PPL', 'P'),
(1219, 'Bucksville', 33.2783317565918, 0.580816458723515, -87.085563659668, -1.51992981681633, 218, 2, 'PPL', 'P'),
(80025, 'Bucksville', 33.7186088562012, 0.58850074373283, -79.0630569458008, -1.379910660396, 218, 48, 'PPL', 'P'),
(159634, 'Bucksville', 40.5063896179199, 0.706969866928351, -75.1880569458008, -1.31227915188122, 218, 45, 'PPL', 'P'),
(7754, 'Bucksville (historical)', 34.6122207641602, 0.604097213761743, -93.3402786254883, -1.62909518674366, 218, 4, 'PPL', 'P'),
(159635, 'Bucksville Manor', 40.5119400024414, 0.707066739413002, -75.1894378662109, -1.31230325348908, 218, 45, 'PPL', 'P'),
(193406, 'Bucktail', 40.7041702270508, 0.710421789754284, -122.848892211914, -2.14411765152552, 218, 6, 'PPL', 'P'),
(199209, 'Bucktail', 41.564998626709, 0.725446079622993, -101.430000305176, -1.77028746562417, 218, 35, 'PPL', 'P'),
(159636, 'Bucktoe', 40.1938896179199, 0.701515713015868, -74.9063873291016, -1.30736308966698, 218, 45, 'PPL', 'P'),
(100318, 'Buckton', 38.9552803039551, 0.679897902341314, -78.2541732788086, -1.36579297714138, 218, 53, 'PPL', 'P'),
(147453, 'Buckton', 44.7383308410645, 0.780831175023099, -74.7874984741211, -1.30528808770365, 218, 40, 'PPL', 'P'),
(19623, 'Bucktown', 33.4747200012207, 0.584244080204501, -85.2905578613281, -1.48860105554291, 218, 13, 'PPL', 'P'),
(29337, 'Bucktown', 38.9947204589844, 0.680586262904072, -87.2600021362305, -1.52297434257451, 218, 19, 'PPL', 'P'),
(39564, 'Bucktown', 30.014720916748, 0.523855704064464, -90.14111328125, -1.573259218171, 218, 22, 'PPL', 'P'),
(45224, 'Bucktown', 38.459171295166, 0.671239166689139, -76.0311126708984, -1.32699325006196, 218, 25, 'PPL', 'P'),
(85394, 'Bucktown', 35.7811088562012, 0.624498159555213, -84.2813873291016, -1.47098770704145, 218, 50, 'PPL', 'P'),
(118949, 'Bucktown', 40.1133308410645, 0.700109697118361, -87.7447204589844, -1.53143427325131, 218, 18, 'PPL', 'P'),
(159637, 'Bucktown', 40.1747207641602, 0.701181153403927, -75.6624984741211, -1.3205597186586, 218, 45, 'PPL', 'P'),
(180305, 'Bucktown', 38.3908309936523, 0.67004640341592, -122.023063659668, -2.12970422423185, 218, 6, 'PPL', 'P'),
(1220, 'Bucktown (historical)', 33.1105613708496, 0.577888313104973, -87.1111068725586, -1.52037562998281, 218, 2, 'PPL', 'P'),
(71957, 'Bucktown (historical)', 39.1049995422363, 0.682510996002899, -84.504997253418, -1.47489043646091, 218, 41, 'PPL', 'P'),
(1221, 'Buckville', 32.5208282470703, 0.567595528386953, -85.8636093139648, -1.49860269017476, 218, 2, 'PPL', 'P'),
(15369, 'Buckville', 30.1288890838623, 0.525848314481575, -83.2925033569336, -1.45372842580692, 218, 12, 'PPL', 'P'),
(53724, 'Bucoda', 36.0900001525879, 0.629889329707915, -90.2141723632813, -1.57453433970093, 218, 29, 'PPL', 'P'),
(206918, 'Bucoda', 46.7991714477539, 0.816799628968627, -122.868606567383, -2.14446173193836, 218, 56, 'PPL', 'P'),
(100319, 'Bucu', 37.0686111450195, 0.646969313622056, -82.2136077880859, -1.43489814584535, 218, 53, 'PPL', 'P'),
(31910, 'Bucyrus', 38.726390838623, 0.67590302754814, -94.7180633544922, -1.65314206664847, 218, 20, 'PPL', 'P'),
(53722, 'Bucyrus', 37.3441696166992, 0.65177871623463, -92.0166702270508, -1.60599386218387, 218, 29, 'PPL', 'P'),
(154523, 'Bucyrus', 40.8083305358887, 0.712239730093399, -82.9755630493164, -1.44819677390672, 218, 41, 'PPL', 'P'),
(198056, 'Bucyrus', 46.0638885498047, 0.803966521465808, -102.787780761719, -1.79398520511008, 218, 34, 'PPL', 'P'),
(147455, 'Bucyrus Heights', 43.0299987792969, 0.751015155827871, -78.7991714477539, -1.37530498960681, 218, 40, 'PPL', 'P'),
(19624, 'Bud', 33.8600006103516, 0.590968495377924, -84.9199981689453, -1.48213356883565, 218, 13, 'PPL', 'P'),
(29338, 'Bud', 39.4469413757324, 0.688479006847712, -86.1758270263672, -1.50405191723922, 218, 19, 'PPL', 'P'),
(108409, 'Bud', 37.5374984741211, 0.655152941335761, -81.3794403076172, -1.42033917679811, 218, 58, 'PPL', 'P'),
(173351, 'Bud', 43.5583305358887, 0.760236284523243, -90.9877777099609, -1.58803630011152, 218, 57, 'PPL', 'P'),
(85395, 'Bud (historical)', 36.0325012207031, 0.628885784030146, -84.1352767944336, -1.46843759713965, 218, 50, 'PPL', 'P'),
(993, 'Buda', 30.0849990844727, 0.525082289483528, -97.8399963378906, -1.70763007623539, 218, 51, 'PPL', 'P'),
(15371, 'Buda', 29.7588901519775, 0.519390614891324, -82.626106262207, -1.44209760237822, 218, 12, 'PPL', 'P'),
(118950, 'Buda', 41.3261108398438, 0.721276701199392, -89.6788864135742, -1.56519183743888, 218, 18, 'PPL', 'P'),
(141396, 'Buda', 40.714168548584, 0.710596293384711, -98.9936065673828, -1.72776437302471, 218, 35, 'PPL', 'P'),
(194127, 'Buda', 40.3286094665527, 0.703867017942299, -104.97721862793, -1.8321981046433, 218, 7, 'PPL', 'P'),
(19625, 'Budapest', 33.7150001525879, 0.588437759973049, -85.2180633544922, -1.48733578770901, 218, 13, 'PPL', 'P'),
(53723, 'Budapest', 36.7688903808594, 0.641738199450868, -90.7108306884766, -1.58320266273303, 218, 29, 'PPL', 'P'),
(159639, 'Budaville', 40.1619415283203, 0.700958113662633, -80.4663925170898, -1.40440348662535, 218, 45, 'PPL', 'P'),
(114750, 'Budd', 42.5330581665039, 0.742341905947756, -90.815559387207, -1.58503052334721, 218, 16, 'PPL', 'P'),
(118951, 'Budd', 41.0988883972168, 0.717310921441128, -88.6230621337891, -1.54676422743413, 218, 18, 'PPL', 'P'),
(7756, 'Budd Creek', 35.5552787780762, 0.620556681141895, -92.1186065673828, -1.6077729869501, 218, 4, 'PPL', 'P'),
(144915, 'Budd Lake', 40.8711090087891, 0.713335421144885, -74.7344436645508, -1.30436210659263, 218, 37, 'PPL', 'P'),
(29339, 'Buddha', 38.7919387817383, 0.677047054973411, -86.4066696166992, -1.50808088049435, 218, 19, 'PPL', 'P'),
(87, 'Buddle', 36.9180603027344, 0.644341705732529, -80.8483276367188, -1.41106951199187, 218, 53, 'PPL', 'P'),
(45230, 'Budds Creek', 38.4022216796875, 0.670245208391294, -76.8319396972656, -1.34097031841102, 218, 25, 'PPL', 'P'),
(159645, 'Budds Place', 40.017219543457, 0.698432238526747, -78.1508331298828, -1.36398935129312, 218, 45, 'PPL', 'P'),
(70592, 'Buddtown', 39.9391708374023, 0.697070031629172, -74.7033309936523, -1.30381908804636, 218, 37, 'PPL', 'P'),
(7757, 'Buddys Landing', 34.6241683959961, 0.604305739275096, -93.5430603027344, -1.63263439467432, 218, 4, 'PPL', 'P'),
(58821, 'Bude', 31.4627799987793, 0.549129102809316, -90.8499984741211, -1.58563159880524, 218, 30, 'PPL', 'P'),
(194651, 'Budge', 42.6088905334473, 0.743665430430498, -113.823608398438, -1.9865967330534, 218, 17, 'PPL', 'P'),
(173350, 'Budsin', 43.9194412231445, 0.766538854979998, -89.3119430541992, -1.55878746764946, 218, 57, 'PPL', 'P'),
(7758, 'Budsmith (historical)', 35.2402801513672, 0.615058917966563, -90.7233276367188, -1.58342077562631, 218, 4, 'PPL', 'P'),
(188196, 'Budville', 35.0699996948242, 0.612086963348089, -107.525283813477, -1.87667023168653, 218, 38, 'PPL', 'P'),
(199854, 'Bueasta (historical)', 41.9311103820801, 0.731835935184475, -115.675003051758, -2.01890966550766, 218, 39, 'PPL', 'P'),
(39565, 'Bueche', 30.5708293914795, 0.533561627946772, -91.3483276367188, -1.59432908345127, 218, 22, 'PPL', 'P'),
(35039, 'Buechel', 38.1949996948242, 0.666628502472912, -85.6519393920898, -1.4949083531106, 218, 21, 'PPL', 'P'),
(35040, 'Buel', 37.5483283996582, 0.655341959194129, -87.1741714477539, -1.52147631446134, 218, 21, 'PPL', 'P'),
(147456, 'Buel', 42.8491706848145, 0.747859110199046, -74.6594390869141, -1.3030530297588, 218, 40, 'PPL', 'P'),
(7759, 'Buell', 35.3030586242676, 0.616154609018049, -94.3816680908203, -1.64727086170929, 218, 4, 'PPL', 'P'),
(53725, 'Buell', 39.0341682434082, 0.681274756624885, -91.4388885498047, -1.59590966955823, 218, 29, 'PPL', 'P'),
(100320, 'Buell', 36.7863883972168, 0.642043597448873, -76.2911071777344, -1.33153101024334, 218, 53, 'PPL', 'P'),
(196101, 'Buell', 45.7877807617188, 0.799147531473309, -111.320831298828, -1.94291503222171, 218, 31, 'PPL', 'P'),
(200481, 'Buell', 45.0163917541504, 0.78568425347755, -123.417221069336, -2.15403686132163, 218, 43, 'PPL', 'P'),
(199855, 'Buell (historical)', 41.2555618286133, 0.720045388669394, -114.045562744141, -1.99047056717503, 218, 39, 'PPL', 'P'),
(85397, 'Buell Acres', 36.1619415283203, 0.63114494358286, -83.3916702270508, -1.45545921419936, 218, 50, 'PPL', 'P'),
(71958, 'Buells (historical)', 39.5222206115723, 0.689792877371503, -81.4841690063477, -1.42216703741228, 218, 41, 'PPL', 'P'),
(180306, 'Buellton', 34.6136093139648, 0.604121448527662, -120.191673278809, -2.0977404321965, 218, 6, 'PPL', 'P'),
(147457, 'Buellville', 42.9866714477539, 0.750258951236343, -75.9499969482422, -1.32557751362647, 218, 40, 'PPL', 'P'),
(196102, 'Buelow', 48.5597190856934, 0.84752698188888, -110.836387634277, -1.93445989523487, 218, 31, 'PPL', 'P'),
(70589, 'Buena', 39.5136108398438, 0.689642608506995, -74.9250030517578, -1.30768799531997, 218, 37, 'PPL', 'P'),
(112601, 'Buena', 38.3413887023926, 0.669183472643707, -78.0483322143555, -1.36220037283086, 218, 53, 'PPL', 'P'),
(180307, 'Buena', 33.1733283996582, 0.578983804419377, -117.207778930664, -2.04566165128973, 218, 6, 'PPL', 'P'),
(206919, 'Buena', 46.4288902282715, 0.810337002530359, -120.312217712402, -2.09984432945766, 218, 56, 'PPL', 'P'),
(108410, 'Buena (historical)', 39.0130615234375, 0.680906374867099, -79.4458312988281, -1.38659133314851, 218, 58, 'PPL', 'P'),
(173352, 'Buena Park', 42.792781829834, 0.746874939018207, -88.220832824707, -1.53974400164263, 218, 57, 'PPL', 'P'),
(180308, 'Buena Park', 33.8675003051758, 0.591099389745502, -117.997222900391, -2.05944004782147, 218, 6, 'PPL', 'P'),
(188197, 'Buena Ventura', 35.0763893127441, 0.612198483218736, -106.537216186523, -1.85942519836383, 218, 38, 'PPL', 'P'),
(1223, 'Buena Vista', 31.7930603027344, 0.55489358156782, -87.2486114501953, -1.52277553759913, 218, 2, 'PPL', 'P'),
(7760, 'Buena Vista', 33.4872207641602, 0.584462259676806, -92.9550018310547, -1.62237083814926, 218, 4, 'PPL', 'P'),
(13046, 'Buena Vista', 38.8569412231445, 0.678181561597785, -76.9797210693359, -1.34354958992676, 218, 9, 'PPL', 'P'),
(15374, 'Buena Vista', 28.3713893890381, 0.495174158204097, -81.524169921875, -1.42286518509205, 218, 12, 'PPL', 'P'),
(19627, 'Buena Vista', 33.1416702270508, 0.578431265072213, -85.0919418334961, -1.48513455191001, 218, 13, 'PPL', 'P'),
(35044, 'Buena Vista', 36.9363899230957, 0.644661617958475, -88.2249984741211, -1.53981670594039, 218, 21, 'PPL', 'P'),
(45226, 'Buena Vista', 38.9566688537598, 0.679922137107233, -76.8249969482422, -1.34084914458142, 218, 25, 'PPL', 'P'),
(58823, 'Buena Vista', 34.6666717529297, 0.605047562796737, -88.9150009155273, -1.55185952038972, 218, 30, 'PPL', 'P'),
(63274, 'Buena Vista', 36.4416694641113, 0.63602711707222, -77.1197204589844, -1.34599304022691, 218, 33, 'PPL', 'P'),
(71961, 'Buena Vista', 38.6300010681152, 0.674220708687537, -83.2613906860352, -1.45318540726065, 218, 41, 'PPL', 'P'),
(85398, 'Buena Vista', 35.976390838623, 0.627906473118296, -88.289436340332, -1.54094135886873, 218, 50, 'PPL', 'P'),
(100322, 'Buena Vista', 37.2675018310547, 0.65044061094492, -79.9252777099609, -1.39495925160965, 218, 53, 'PPL', 'P'),
(114751, 'Buena Vista', 41.7419395446777, 0.728534281223049, -90.7402801513672, -1.58371665282342, 218, 16, 'PPL', 'P'),
(118953, 'Buena Vista', 42.4255599975586, 0.740465708959795, -89.6777801513672, -1.56517252952098, 218, 18, 'PPL', 'P'),
(122291, 'Buena Vista', 40.1205596923828, 0.700235864375003, -85.0730590820313, -1.48480498572511, 218, 19, 'PPL', 'P'),
(129992, 'Buena Vista', 43.420280456543, 0.757826856106021, -83.8986129760742, -1.46430703428893, 218, 27, 'PPL', 'P'),
(147458, 'Buena Vista', 42.3005599975586, 0.738284047394802, -77.5091705322266, -1.35279022627712, 218, 40, 'PPL', 'P'),
(159643, 'Buena Vista', 40.0208282470703, 0.698495222286528, -75.9797210693359, -1.32609629740682, 218, 45, 'PPL', 'P'),
(173354, 'Buena Vista', 43.065559387207, 0.751635805519914, -88.3516693115234, -1.54202752911932, 218, 57, 'PPL', 'P'),
(177798, 'Buena Vista', 32.8436088562012, 0.573229112777879, -109.561393737793, -1.91220705379838, 218, 5, 'PPL', 'P'),
(186466, 'Buena Vista', 38.8422203063965, 0.677924633131619, -106.130561828613, -1.85232774090072, 218, 7, 'PPL', 'P'),
(188200, 'Buena Vista', 35.9136085510254, 0.626810715487783, -105.248611450195, -1.83693480295811, 218, 38, 'PPL', 'P'),
(191187, 'Buena Vista', 31.211109161377, 0.544736618065394, -102.640281677246, -1.79141086044235, 218, 51, 'PPL', 'P'),
(193407, 'Buena Vista', 40.0555610656738, 0.699101424329657, -121.866386413574, -2.12696969042455, 218, 6, 'PPL', 'P'),
(200480, 'Buena Vista', 44.769718170166, 0.781378987259328, -123.149436950684, -2.14936314676659, 218, 43, 'PPL', 'P'),
(203193, 'Buena Vista', 40.7583312988281, 0.711367078783208, -111.97110748291, -1.95426449268124, 218, 52, 'PPL', 'P'),
(58824, 'Buena Vista (historical)', 31.8166694641113, 0.555305639167483, -91.3305587768555, -1.59401895834233, 218, 30, 'PPL', 'P'),
(114752, 'Buena Vista (historical)', 40.3866691589355, 0.704880350737074, -91.4336090087891, -1.59581752418452, 218, 16, 'PPL', 'P'),
(154525, 'Buena Vista (historical)', 40.7786102294922, 0.711721012892079, -84.5519409179688, -1.47570975797027, 218, 41, 'PPL', 'P'),
(180315, 'Buena Vista (historical)', 39.1891708374023, 0.683980062239214, -120.972221374512, -2.11136356643669, 218, 6, 'PPL', 'P'),
(154526, 'Buena Vista Beach', 41.8097190856934, 0.729717257379262, -81.128059387207, -1.41595175206026, 218, 41, 'PPL', 'P'),
(92894, 'Buena Vista Colonia', 26.8920001983643, 0.469353945908425, -99.265998840332, -1.73251851504467, 218, 51, 'PPL', 'P'),
(35045, 'Buena Vista Estates', 37.0250015258789, 0.646208182182511, -88.0477828979492, -1.53672371065037, 218, 21, 'PPL', 'P'),
(45227, 'Buena Vista Estates', 39.6130599975586, 0.691378323747454, -76.8216705322266, -1.34079108766966, 218, 25, 'PPL', 'P'),
(85400, 'Buena Vista Estates', 36.2272186279297, 0.632284243897196, -86.82861328125, -1.51544518669869, 218, 50, 'PPL', 'P'),
(1225, 'Buena Vista Highlands', 33.4625015258789, 0.584030827580213, -86.8086090087891, -1.51509604627978, 218, 2, 'PPL', 'P'),
(45228, 'Buena Vista Hills', 38.5286102294922, 0.672451104722207, -76.6213912963867, -1.33729555558087, 218, 25, 'PPL', 'P'),
(58825, 'Buena Vista Lakes', 34.7347183227539, 0.606235199484858, -90.0069427490234, -1.5709175006245, 218, 30, 'PPL', 'P'),
(45229, 'Buena Vista on the Patuxent', 38.5269393920898, 0.67242194310827, -76.6500015258789, -1.33779489828526, 218, 25, 'PPL', 'P'),
(92895, 'Buena Vista Plaza Colonia', 26.4080009460449, 0.460906565378261, -98.9800033569336, -1.72752695221353, 218, 51, 'PPL', 'P'),
(124350, 'Buena Vista Shores', 41.8097190856934, 0.729717257379262, -70.9555587768555, -1.23840812324849, 218, 23, 'PPL', 'P'),
(77950, 'Buena Vista Springs', 39.7319412231445, 0.693453192552735, -77.5033264160156, -1.35268822720737, 218, 45, 'PPL', 'P'),
(177799, 'Buenavante', 33.5988883972168, 0.586411227541554, -111.92138671875, -1.95339670164004, 218, 5, 'PPL', 'P'),
(15375, 'Buenaventura Lakes', 28.3355598449707, 0.494548814690633, -81.3533325195313, -1.41988350993559, 218, 12, 'PPL', 'P'),
(29342, 'Buenavista', 39.0330581665039, 0.681255382127954, -86.6555633544922, -1.51242489570643, 218, 19, 'PPL', 'P'),
(206920, 'Buenna', 47.3313903808594, 0.826088601692769, -122.343330383301, -2.13529393304382, 218, 56, 'PPL', 'P'),
(196103, 'Bueno Vista Acres Trailer Court', 45.8499984741211, 0.800233435407789, -111.04167175293, -1.93804277900741, 218, 31, 'PPL', 'P'),
(191188, 'Buenos', 33.2991714477539, 0.581180179949393, -101.48722076416, -1.77128615103295, 218, 51, 'PPL', 'P'),
(177800, 'Buenos Aires', 31.521110534668, 0.550147162715026, -111.656669616699, -1.94877651662292, 218, 5, 'PPL', 'P'),
(191189, 'Buenos Aires', 29.0849990844727, 0.507628996963584, -103.468612670898, -1.8058679635779, 218, 51, 'PPL', 'P'),
(188201, 'Bueyeros', 35.9794387817383, 0.62795966976107, -103.686668395996, -1.80967375393368, 218, 38, 'PPL', 'P'),
(19630, 'Buff (historical)', 34.586669921875, 0.603651267437209, -84.7880630493164, -1.47983086659911, 218, 13, 'PPL', 'P'),
(26642, 'Buffalo', 39.8525009155273, 0.695557356130007, -89.4086074829102, -1.56047458020002, 218, 18, 'PPL', 'P'),
(31909, 'Buffalo', 37.7097206115723, 0.658158784679106, -95.6972198486328, -1.67023157136351, 218, 20, 'PPL', 'P'),
(35047, 'Buffalo', 36.9194412231445, 0.644365807340395, -87.6861114501953, -1.53041135307661, 218, 21, 'PPL', 'P'),
(53726, 'Buffalo', 37.6438903808594, 0.657009830405818, -93.0922164916992, -1.62476568575952, 218, 29, 'PPL', 'P'),
(63279, 'Buffalo', 36.4949989318848, 0.636957891873203, -80.0530624389648, -1.39718951586454, 218, 33, 'PPL', 'P'),
(75255, 'Buffalo', 36.8355598449707, 0.642901801110151, -99.629997253418, -1.73887148582505, 218, 42, 'PPL', 'P'),
(80029, 'Buffalo', 34.7255592346191, 0.606075343240426, -81.6836090087891, -1.42564792211507, 218, 48, 'PPL', 'P'),
(85404, 'Buffalo', 36.4922218322754, 0.636909422341364, -82.3058319091797, -1.4365077604082, 218, 50, 'PPL', 'P'),
(92899, 'Buffalo', 31.4813899993896, 0.549453908593765, -98.8974990844727, -1.72608698101213, 218, 51, 'PPL', 'P'),
(108411, 'Buffalo', 38.6175003051758, 0.674002529215232, -81.9819412231445, -1.43085480152034, 218, 58, 'PPL', 'P'),
(112197, 'Buffalo', 32.9461097717285, 0.57501809124014, -85.4019393920898, -1.49054502998061, 218, 2, 'PPL', 'P'),
(112468, 'Buffalo', 39.0963897705078, 0.682360727138392, -82.6483306884766, -1.44248549179099, 218, 41, 'PPL', 'P'),
(114757, 'Buffalo', 41.4563903808594, 0.723550508138102, -90.7233276367188, -1.58342077562631, 218, 16, 'PPL', 'P'),
(122292, 'Buffalo', 40.8824996948242, 0.71353422612026, -86.7452774047852, -1.51399070126934, 218, 19, 'PPL', 'P'),
(126990, 'Buffalo', 46.8269386291504, 0.817284257707994, -68.4863891601563, -1.19531298364688, 218, 26, 'PPL', 'P'),
(134464, 'Buffalo', 45.1719398498535, 0.788399079892777, -93.8744430541992, -1.6384181147717, 218, 28, 'PPL', 'P'),
(139735, 'Buffalo', 46.9197196960449, 0.818903592808817, -97.5491714477539, -1.70255422435575, 218, 34, 'PPL', 'P'),
(141399, 'Buffalo', 40.9891700744629, 0.715395975459307, -99.8349990844727, -1.74244944274957, 218, 35, 'PPL', 'P'),
(159644, 'Buffalo', 40.226390838623, 0.702082966328055, -80.3605575561523, -1.40255631809327, 218, 45, 'PPL', 'P'),
(196104, 'Buffalo', 46.8211097717285, 0.817182524954353, -109.827781677246, -1.91685640042944, 218, 31, 'PPL', 'P'),
(201936, 'Buffalo', 45.584171295166, 0.795593875893735, -103.545562744141, -1.80721099571563, 218, 49, 'PPL', 'P'),
(209335, 'Buffalo', 44.348331451416, 0.774024401592965, -106.698333740234, -1.86223723015885, 218, 59, 'PPL', 'P'),
(7763, 'Buffalo (historical)', 34.7983283996582, 0.607345404764285, -94.0436096191406, -1.64137062831421, 218, 4, 'PPL', 'P'),
(108412, 'Buffalo (historical)', 38.827220916748, 0.677662844396465, -81.5341720581055, -1.4230397553015, 218, 58, 'PPL', 'P'),
(100325, 'Buffalo Bend', 37.7163887023926, 0.658275164818742, -79.4727783203125, -1.38706164739702, 218, 53, 'PPL', 'P'),
(15376, 'Buffalo Bluff', 29.579439163208, 0.516258604291336, -81.6738891601563, -1.42547827875363, 218, 12, 'PPL', 'P'),
(114758, 'Buffalo Center', 43.3858299255371, 0.757225580910909, -93.9463882446289, -1.63967379522567, 218, 16, 'PPL', 'P'),
(7764, 'Buffalo City', 36.167781829834, 0.631246876073583, -92.4419403076172, -1.61341622529998, 218, 4, 'PPL', 'P'),
(63280, 'Buffalo City', 35.8422203063965, 0.625564755571789, -75.9175033569336, -1.32501039347234, 218, 33, 'PPL', 'P'),
(173357, 'Buffalo City', 44.2305603027344, 0.771968907284615, -91.8641662597656, -1.60333216583239, 218, 57, 'PPL', 'P'),
(147459, 'Buffalo Corners', 42.7780609130859, 0.746618010552041, -78.008056640625, -1.36149743146113, 218, 40, 'PPL', 'P'),
(63281, 'Buffalo Cove', 36.0911102294922, 0.629908704204845, -81.5269393920898, -1.42291352146583, 218, 33, 'PPL', 'P'),
(108413, 'Buffalo Creek', 38.3555603027344, 0.669430813729948, -82.5094375610352, -1.44006134940874, 218, 58, 'PPL', 'P'),
(186467, 'Buffalo Creek', 39.3866691589355, 0.687427058217131, -105.269721984863, -1.83730325129492, 218, 7, 'PPL', 'P'),
(159646, 'Buffalo Crossroads', 40.9633293151855, 0.714944969128702, -76.9691696166992, -1.34336543233738, 218, 45, 'PPL', 'P'),
(45233, 'Buffalo Estates', 39.4708290100098, 0.688895924716364, -77.1208267211914, -1.34601234814481, 218, 25, 'PPL', 'P'),
(209336, 'Buffalo Ford', 44.9249992370605, 0.784089153142647, -110.377220153809, -1.9264459108826, 218, 59, 'PPL', 'P'),
(100326, 'Buffalo Forge', 37.6866683959961, 0.657756447617422, -79.4333267211914, -1.38637308709718, 218, 53, 'PPL', 'P'),
(35048, 'Buffalo Fork', 36.999439239502, 0.645762036120896, -86.6733322143555, -1.51273502081537, 218, 21, 'PPL', 'P'),
(92901, 'Buffalo Gap', 32.2791709899902, 0.563377813589567, -99.829719543457, -1.74235729737586, 218, 51, 'PPL', 'P'),
(100329, 'Buffalo Gap', 38.186939239502, 0.666487820988329, -79.2397232055664, -1.38299406830609, 218, 53, 'PPL', 'P'),
(201939, 'Buffalo Gap', 43.4916687011719, 0.759072816022015, -103.3125, -1.80314328346664, 218, 49, 'PPL', 'P'),
(118959, 'Buffalo Grove', 42.1513900756836, 0.735680541113141, -87.959716796875, -1.53518666722723, 218, 18, 'PPL', 'P'),
(26643, 'Buffalo Hart', 39.913890838623, 0.696628812415573, -89.4475021362305, -1.56115341996188, 218, 18, 'PPL', 'P'),
(114759, 'Buffalo Heights', 41.4724998474121, 0.723831671370187, -90.7144393920898, -1.58326564649281, 218, 16, 'PPL', 'P'),
(100327, 'Buffalo Hill', 37.6127815246582, 0.656466878438578, -79.0169372558594, -1.37910571995652, 218, 53, 'PPL', 'P'),
(180317, 'Buffalo Hill', 38.9086112976074, 0.679083374521913, -120.846389770508, -2.10916739064376, 218, 6, 'PPL', 'P'),
(45231, 'Buffalo Hills', 39.4636116027832, 0.688769957196804, -77.1224975585938, -1.34604150975875, 218, 25, 'PPL', 'P'),
(100328, 'Buffalo Hills', 38.8694381713867, 0.678399674491062, -77.1558303833008, -1.34662327729888, 218, 53, 'PPL', 'P'),
(100330, 'Buffalo Junction', 36.6041717529297, 0.638863317054127, -78.6319427490234, -1.37238629821014, 218, 53, 'PPL', 'P'),
(134465, 'Buffalo Lake', 44.7372207641602, 0.780811800526168, -94.6166687011719, -1.65137239610412, 218, 28, 'PPL', 'P'),
(134467, 'Buffalo Manor East', 45.1749992370605, 0.788452476272633, -93.8574981689453, -1.63812237073264, 218, 28, 'PPL', 'P'),
(199856, 'Buffalo Meadows (historical)', 40.607780456543, 0.708739470893681, -119.73999786377, -2.08985720905376, 218, 39, 'PPL', 'P'),
(159647, 'Buffalo Mills', 40.8400001525879, 0.712792469177645, -79.6436080932617, -1.39004318939542, 218, 45, 'PPL', 'P'),
(92902, 'Buffalo Mop', 31.4188709259033, 0.548362744916132, -96.6945037841797, -1.68763745961605, 218, 51, 'PPL', 'P'),
(118956, 'Buffalo Prairie', 41.3383293151855, 0.721489953823681, -90.8547210693359, -1.58571402364098, 218, 18, 'PPL', 'P'),
(19631, 'Buffalo Ranch', 33.4722213745117, 0.584200470941652, -82.1419372558594, -1.43364725908134, 218, 13, 'PPL', 'P'),
(100332, 'Buffalo Ridge', 36.7369384765625, 0.641180533518605, -80.248893737793, -1.40060741680755, 218, 53, 'PPL', 'P'),
(85405, 'Buffalo Ridge (historical)', 36.3838882446289, 0.635018644546435, -82.4652786254883, -1.43929063058927, 218, 50, 'PPL', 'P'),
(159648, 'Buffalo Run', 40.8283309936523, 0.712588803933282, -77.9625015258789, -1.36070234471769, 218, 45, 'PPL', 'P'),
(173359, 'Buffalo Shore Estates', 43.7408294677734, 0.763421491766005, -89.470832824707, -1.56156061729256, 218, 57, 'PPL', 'P'),
(85406, 'Buffalo Springs', 36.2177810668945, 0.632119527383774, -83.5630569458008, -1.45845047673574, 218, 50, 'PPL', 'P'),
(100334, 'Buffalo Springs', 37.6094398498535, 0.656408555210706, -78.8622207641602, -1.37640540776923, 218, 53, 'PPL', 'P'),
(159649, 'Buffalo Springs', 40.2919387817383, 0.703226993753326, -76.3349990844727, -1.33229706853091, 218, 45, 'PPL', 'P'),
(188202, 'Buffalo Springs', 35.9347190856934, 0.627179163824595, -108.653327941895, -1.89635831583521, 218, 38, 'PPL', 'P'),
(191191, 'Buffalo Springs', 33.5319404602051, 0.585242765613281, -101.707778930664, -1.77513561723061, 218, 51, 'PPL', 'P'),
(198064, 'Buffalo Springs', 46.1749992370605, 0.805905768792576, -103.234443664551, -1.80178094341101, 218, 34, 'PPL', 'P'),
(92904, 'Buffalo Springs (historical)', 29.8046798706055, 0.520189796244943, -98.1739883422852, -1.71345933638741, 218, 51, 'PPL', 'P'),
(108414, 'Buffalo Station (historical)', 39.4958305358887, 0.689332283660974, -80.1266708374023, -1.39847422477439, 218, 58, 'PPL', 'P'),
(85409, 'Buffalo Valley', 35.4536094665527, 0.618782216907576, -87.6133270263672, -1.52914102523664, 218, 50, 'PPL', 'P'),
(85408, 'Buffalo View', 36.2861099243164, 0.633312090919912, -82.3172225952148, -1.43670656538357, 218, 50, 'PPL', 'P'),
(7767, 'Buffalolick (historical)', 35.663890838623, 0.622452319205814, -90.6841735839844, -1.58273740849059, 218, 4, 'PPL', 'P'),
(108416, 'Buffalolick (historical)', 38.7041702270508, 0.675515204714397, -81.3475036621094, -1.41978177718195, 218, 58, 'PPL', 'P'),
(29345, 'Buffaloville', 38.0974998474121, 0.664926809115379, -86.9652786254883, -1.51783044692902, 218, 19, 'PPL', 'P'),
(85410, 'Buffat Heights', 36.0144386291504, 0.628570532336107, -83.8791732788086, -1.46396774756606, 218, 50, 'PPL', 'P'),
(19632, 'Buffington', 34.2413902282715, 0.59762499994355, -84.4208297729492, -1.47342143680362, 218, 13, 'PPL', 'P'),
(53733, 'Buffington', 36.8305587768555, 0.642814516005424, -89.7430572509766, -1.56631182983531, 218, 29, 'PPL', 'P'),
(77952, 'Buffington', 39.9288902282715, 0.696890601150728, -79.8413925170898, -1.39349517880038, 218, 45, 'PPL', 'P'),
(122293, 'Buffington', 41.6372184753418, 0.726706553766928, -87.4258270263672, -1.52586853288915, 218, 19, 'PPL', 'P'),
(124353, 'Buffington Corner', 41.7847213745117, 0.72928096501368, -71.0319366455078, -1.23974116853213, 218, 23, 'PPL', 'P'),
(134470, 'Bufflao Manor', 45.1749992370605, 0.788452476272633, -93.8591690063477, -1.63815153234658, 218, 28, 'PPL', 'P'),
(100335, 'Bufflick Heights', 39.1380615234375, 0.683088036432092, -78.1572189331055, -1.36410080458474, 218, 53, 'PPL', 'P'),
(7768, 'Buffo (historical)', 34.1555595397949, 0.596126971830381, -91.3677825927734, -1.59466863649026, 218, 4, 'PPL', 'P'),
(100336, 'Bufford Crossroads', 36.7377815246582, 0.641195247483628, -77.6197204589844, -1.35471968648688, 218, 53, 'PPL', 'P'),
(126992, 'Buffum Hill', 43.2963905334473, 0.755664569037959, -70.5880584716797, -1.23199403292109, 218, 26, 'PPL', 'P'),
(124351, 'Buffumville', 42.1188888549805, 0.735113287800954, -71.9000015258789, -1.25489175881553, 218, 23, 'PPL', 'P'),
(31914, 'Buffville', 37.4824981689453, 0.654193004920842, -95.6600036621094, -1.66958202637364, 218, 20, 'PPL', 'P'),
(29346, 'Bufkin', 37.9877815246582, 0.663011863133557, -87.845832824707, -1.53319901694765, 218, 19, 'PPL', 'P'),
(7769, 'Buford', 36.2455596923828, 0.632604355860223, -92.4283294677734, -1.61317867133074, 218, 4, 'PPL', 'P'),
(19633, 'Buford', 34.1205596923828, 0.595516109255344, -84.0044403076172, -1.46615406966296, 218, 13, 'PPL', 'P'),
(35049, 'Buford', 37.5641708374023, 0.655618461894306, -86.98388671875, -1.51815521942395, 218, 21, 'PPL', 'P'),
(71964, 'Buford', 39.0766716003418, 0.682016580146526, -83.8441696166992, -1.46335681841199, 218, 41, 'PPL', 'P'),
(80031, 'Buford', 34.7444381713867, 0.606404842846296, -80.616943359375, -1.40703109451487, 218, 48, 'PPL', 'P'),
(100337, 'Buford', 36.5666694641113, 0.638208778637213, -79.54638671875, -1.38834635630688, 218, 53, 'PPL', 'P'),
(186468, 'Buford', 39.9872207641602, 0.697908661056438, -107.616111755371, -1.8782554783254, 218, 7, 'PPL', 'P'),
(191193, 'Buford', 32.4613914489746, 0.56655816056334, -100.856391906738, -1.76027611045434, 218, 51, 'PPL', 'P'),
(198060, 'Buford', 47.9986114501953, 0.837733806191359, -103.990829467773, -1.81498236609259, 218, 34, 'PPL', 'P'),
(209337, 'Buford', 41.121940612793, 0.717713258502812, -105.304168701172, -1.83790445991101, 218, 59, 'PPL', 'P'),
(196105, 'Buford (historical)', 47.2944412231445, 0.825443717234806, -115.144439697266, -2.00964958808135, 218, 31, 'PPL', 'P'),
(100339, 'Buford Estates', 37.5119400024414, 0.654706861853172, -77.5513916015625, -1.35352712295074, 218, 53, 'PPL', 'P'),
(19634, 'Buford Horizons Mobile Home Park', 34.0761108398438, 0.594740330429804, -84.0036087036133, -1.46613955543502, 218, 13, 'PPL', 'P'),
(191194, 'Buford View Estates Colonia', 31.6520004272461, 0.552431622298096, -106.292999267578, -1.85516280903916, 218, 51, 'PPL', 'P'),
(85411, 'Bufords', 35.3319396972656, 0.616658678833374, -87.0255584716797, -1.51888252871766, 218, 50, 'PPL', 'P'),
(80033, 'Bufords Bridge', 33.1144409179688, 0.577956023975688, -81.1838912963867, -1.41692620270312, 218, 48, 'PPL', 'P'),
(35050, 'Bug', 36.6547203063965, 0.639745555744243, -85.1091690063477, -1.48543522279708, 218, 21, 'PPL', 'P'),
(63282, 'Bug Hill', 34.0786094665527, 0.594783939692654, -78.644172668457, -1.37259975057151, 218, 33, 'PPL', 'P'),
(75261, 'Bug Tussle', 35.0308303833008, 0.611403329896266, -95.6897201538086, -1.67010067699593, 218, 42, 'PPL', 'P'),
(92905, 'Bug Tussle', 33.4836082458496, 0.584399209337999, -95.9433288574219, -1.6745269838857, 218, 51, 'PPL', 'P'),
(126991, 'Bugbee', 46.7788887023926, 0.816445628280728, -68.1555633544922, -1.18953898408748, 218, 26, 'PPL', 'P'),
(35051, 'Buggytown', 37.6355590820313, 0.6568644218103, -84.3691711425781, -1.47251982361657, 218, 21, 'PPL', 'P'),
(58826, 'Bugh', 33.3661117553711, 0.58234850871961, -89.0016708374023, -1.55337219588889, 218, 30, 'PPL', 'P'),
(85412, 'Bugscuffle', 35.499439239502, 0.619582097340981, -86.3152770996094, -1.50648578015945, 218, 50, 'PPL', 'P'),
(194652, 'Bugtown (historical)', 43.6594390869141, 0.762000961640557, -116.673889160156, -2.03634351695165, 218, 17, 'PPL', 'P'),
(35053, 'Bugtussle', 36.6258316040039, 0.639241352770864, -85.8758316040039, -1.49881600937807, 218, 21, 'PPL', 'P'),
(180318, 'Buhach', 37.3363914489746, 0.651642961598063, -120.580833435059, -2.10453255824064, 218, 6, 'PPL', 'P'),
(1226, 'Buhl', 33.2569389343262, 0.580443083538686, -87.7527770996094, -1.53157488815686, 218, 2, 'PPL', 'P'),
(134472, 'Buhl', 47.4936103820801, 0.82891987482666, -92.7777786254883, -1.61927770970119, 218, 28, 'PPL', 'P'),
(194653, 'Buhl', 42.5991706848145, 0.74349578706906, -114.758613586426, -2.00291565210703, 218, 17, 'PPL', 'P'),
(31915, 'Buhler', 38.1344413757324, 0.665571560415287, -97.7697219848633, -1.70640355739535, 218, 20, 'PPL', 'P'),
(39568, 'Buhler', 30.3327808380127, 0.529406896909166, -93.3619384765625, -1.62947322246039, 218, 22, 'PPL', 'P'),
(159654, 'Buhls Station', 40.7986106872559, 0.712070086731961, -80.0258331298828, -1.39671427476801, 218, 45, 'PPL', 'P'),
(45232, 'Buhrman', 39.5638885498047, 0.690520120086176, -77.5711135864258, -1.35387133652164, 218, 25, 'PPL', 'P'),
(53734, 'Buick', 37.6069412231445, 0.656364945947856, -91.1266708374023, -1.59046044249377, 218, 29, 'PPL', 'P'),
(7771, 'Buie', 34.3519401550293, 0.599554460153313, -92.5638885498047, -1.61554462364317, 218, 4, 'PPL', 'P'),
(39567, 'Buie', 32.0499992370605, 0.559378011948377, -91.8583297729492, -1.6032302999207, 218, 22, 'PPL', 'P'),
(63284, 'Buie', 34.7363891601563, 0.606264361098794, -79.1449966430664, -1.38134077790137, 218, 33, 'PPL', 'P'),
(63287, 'Buies Creek', 35.4130592346191, 0.618074481847887, -78.7358322143555, -1.37419951143832, 218, 33, 'PPL', 'P'),
(63285, 'Buies Neck', 34.7975006103516, 0.607330957115371, -78.8949966430664, -1.37697745477138, 218, 33, 'PPL', 'P'),
(194654, 'Buist', 42.327220916748, 0.738749368216266, -112.604721069336, -1.96532313594974, 218, 17, 'PPL', 'P'),
(154, 'Bula', 39.7030601501465, 0.69294912273741, -80.2574996948242, -1.40075761909303, 218, 58, 'PPL', 'P'),
(100338, 'Bula', 37.773609161377, 0.659273850227522, -78.04638671875, -1.36216641752696, 218, 53, 'PPL', 'P'),
(191195, 'Bula', 33.9113883972168, 0.591865381454036, -102.637496948242, -1.79136225775246, 218, 51, 'PPL', 'P'),
(63286, 'Buladean', 36.1083297729492, 0.63020924193386, -82.1949996948242, -1.43457337335042, 218, 33, 'PPL', 'P'),
(85413, 'Buladeen', 36.4597206115723, 0.636342169029177, -82.0186080932617, -1.43149475913029, 218, 50, 'PPL', 'P'),
(58827, 'Bulah', 30.4936103820801, 0.532213901987623, -89.0716705322266, -1.55459392103896, 218, 30, 'PPL', 'P'),
(92906, 'Bulah', 31.6852798461914, 0.553012457731842, -95.216667175293, -1.66184434498447, 218, 51, 'PPL', 'P'),
(154528, 'Bulah', 41.7819404602051, 0.729232428902813, -80.6686096191406, -1.40793284085997, 218, 41, 'PPL', 'P'),
(35052, 'Bulan', 37.3013916015625, 0.651032099023026, -83.1650009155273, -1.45150308840005, 218, 21, 'PPL', 'P'),
(71965, 'Bulaville', 38.9000015258789, 0.678933105657405, -82.1830596923828, -1.43436498099512, 218, 41, 'PPL', 'P'),
(92907, 'Bulcher', 33.8002815246582, 0.589926200706295, -97.429443359375, -1.70046457500642, 218, 51, 'PPL', 'P'),
(108417, 'Bulger', 38.1333312988281, 0.665552185918357, -81.9813919067383, -1.43084521414042, 218, 58, 'PPL', 'P'),
(159655, 'Bulger', 40.3783302307129, 0.704734808983501, -80.3280563354492, -1.40198906478108, 218, 45, 'PPL', 'P'),
(194128, 'Bulger', 40.7936096191406, 0.711982801627234, -104.981941223145, -1.83228052947904, 218, 7, 'PPL', 'P'),
(1227, 'Bulgers', 32.8186111450195, 0.572792820412297, -85.9680633544922, -1.50042575709897, 218, 2, 'PPL', 'P'),
(114765, 'Bulgers Hollow', 41.9352798461914, 0.731908706061261, -90.1838912963867, -1.57400583538261, 218, 16, 'PPL', 'P'),
(154529, 'Bulkhead', 40.5205612182617, 0.707217208014592, -84.42138671875, -1.4734311573416, 218, 41, 'PPL', 'P'),
(1228, 'Bull City', 33.416389465332, 0.583226020298791, -87.2583312988281, -1.52294518096057, 218, 2, 'PPL', 'P'),
(35054, 'Bull Creek', 37.6666717529297, 0.657407440356567, -82.727783203125, -1.44387219977059, 218, 21, 'PPL', 'P'),
(53735, 'Bull Creek', 36.7150001525879, 0.640797637532879, -93.2033309936523, -1.62670499966531, 218, 29, 'PPL', 'P'),
(193408, 'Bull Creek', 40.3358306884766, 0.703993052040887, -124.025283813477, -2.16464955826559, 218, 6, 'PPL', 'P'),
(189978, 'Bull Fork', 39.0736083984375, 0.681963117187643, -115.766387939453, -2.02050463268451, 218, 39, 'PPL', 'P'),
(147461, 'Bull Hill', 43.2638893127441, 0.755097315725772, -74.9102783203125, -1.30743100027478, 218, 40, 'PPL', 'P'),
(75262, 'Bull Hollow', 36.3136100769043, 0.633792059127371, -94.9069366455078, -1.65643852744577, 218, 42, 'PPL', 'P'),
(147462, 'Bull Mine', 41.3661117553711, 0.721974848879157, -74.1961135864258, -1.29496647426683, 218, 40, 'PPL', 'P'),
(196106, 'Bull Mountain', 46.0224990844727, 0.803244139020124, -107.856941223145, -1.88245874547387, 218, 31, 'PPL', 'P'),
(100340, 'Bull Neck', 38.0361099243164, 0.663855352829812, -76.6444396972656, -1.33769782606353, 218, 53, 'PPL', 'P'),
(39569, 'Bull Run', 29.6533298492432, 0.517548240049207, -90.8736114501953, -1.58604372298393, 218, 22, 'PPL', 'P'),
(45234, 'Bull Run', 38.3377799987793, 0.669120488883926, -76.7916717529297, -1.34026751019935, 218, 25, 'PPL', 'P'),
(85414, 'Bull Run', 36.0308303833008, 0.628856622416209, -84.0936126708984, -1.467710421004, 218, 50, 'PPL', 'P'),
(100341, 'Bull Run', 38.7836112976074, 0.67690171295692, -77.5208282470703, -1.3529936917844, 218, 53, 'PPL', 'P'),
(108418, 'Bull Run', 39.5838890075684, 0.690869193926059, -79.7702789306641, -1.39225401257435, 218, 58, 'PPL', 'P'),
(147463, 'Bull Run', 41.913890838623, 0.731535397455459, -74.4458312988281, -1.2993248705488, 218, 40, 'PPL', 'P'),
(200482, 'Bull Run', 45.4305610656738, 0.792912871624352, -122.230560302734, -2.13332572384019, 218, 43, 'PPL', 'P'),
(53736, 'Bull Run Camp', 36.9658317565918, 0.645175474890806, -90.5933303833008, -1.58115189553562, 218, 29, 'PPL', 'P'),
(177546, 'Bull Run Corner', 41.9297218322754, 0.731811700418555, -72.670280456543, -1.26833566231436, 218, 8, 'PPL', 'P'),
(100344, 'Bull Run East', 38.7891693115234, 0.676998718599626, -77.5013885498047, -1.35265440506153, 218, 53, 'PPL', 'P'),
(100342, 'Bull Run Mobile Home Park', 38.7938919067383, 0.677081143435364, -77.4608306884766, -1.35194653684378, 218, 53, 'PPL', 'P'),
(100343, 'Bull Run Mountain Estates', 38.9036102294922, 0.678996089417185, -77.6619415283203, -1.35545658316051, 218, 53, 'PPL', 'P'),
(7772, 'Bull Shoals', 36.3838882446289, 0.635018644546435, -92.5813903808594, -1.6158500882202, 218, 4, 'PPL', 'P'),
(80034, 'Bull Station', 33.4236106872559, 0.583352054397379, -80.4052810668945, -1.40333689060877, 218, 48, 'PPL', 'P'),
(159657, 'Bull Tavern', 40.1172218322754, 0.700177607726158, -75.4875030517578, -1.31750547236244, 218, 45, 'PPL', 'P'),
(118960, 'Bull Valley', 42.3205604553223, 0.738633121234684, -88.3550033569336, -1.54208571918913, 218, 18, 'PPL', 'P'),
(19635, 'Bullard', 32.6302795410156, 0.569505813836867, -83.4972229003906, -1.45730145588343, 218, 13, 'PPL', 'P'),
(92908, 'Bullard', 32.139720916748, 0.560943950669344, -95.3199996948242, -1.66364783767467, 218, 51, 'PPL', 'P'),
(114766, 'Bullard', 40.6166687011719, 0.708894600027178, -91.4069366455078, -1.59535200362597, 218, 16, 'PPL', 'P'),
(180319, 'Bullard', 38.6091690063477, 0.673857120619714, -120.96028137207, -2.11115517408139, 218, 6, 'PPL', 'P'),
(1229, 'Bullard Shoals (historical)', 33.3919410705566, 0.582799315313134, -87.0236129760742, -1.51884857341376, 218, 2, 'PPL', 'P'),
(200483, 'Bullards', 43.1500015258789, 0.753109598867164, -124.394439697266, -2.17109254389082, 218, 43, 'PPL', 'P'),
(180320, 'Bullards Bar (historical)', 39.422779083252, 0.688057295289098, -121.13777923584, -2.11425309621943, 218, 6, 'PPL', 'P'),
(124352, 'Bullardville', 42.6980590820313, 0.745221715192513, -72.0852813720703, -1.25812550216916, 218, 23, 'PPL', 'P'),
(100345, 'Bullbegger', 37.9577789306641, 0.66248821908422, -75.6147232055664, -1.31972588292129, 218, 53, 'PPL', 'P'),
(26645, 'Bulldog Crossing', 39.7955589294434, 0.694563530990216, -89.0124969482422, -1.55356114716823, 218, 18, 'PPL', 'P'),
(45235, 'Bulle Rock', 39.0569381713867, 0.681672166838552, -76.1469421386719, -1.32901485564544, 218, 25, 'PPL', 'P'),
(126993, 'Bullen Mills', 44.6958312988281, 0.780089418080484, -70.0691680908203, -1.22293768731816, 218, 26, 'PPL', 'P'),
(39570, 'Buller', 30.3797206878662, 0.530226151839502, -93.0183334350586, -1.6234761831597, 218, 22, 'PPL', 'P'),
(85415, 'Bullet Creek', 35.2788887023926, 0.61573276430138, -84.4261093139648, -1.47351358217734, 218, 50, 'PPL', 'P'),
(147464, 'Bullet Hole', 41.3902816772461, 0.722396693595825, -73.7897186279297, -1.28787354417757, 218, 40, 'PPL', 'P'),
(189979, 'Bullfrog (historical)', 36.8902816772461, 0.64385687725608, -116.832778930664, -2.03911666659475, 218, 39, 'PPL', 'P'),
(7774, 'Bullfrog Valley', 35.5188903808594, 0.619921583800939, -93.2125015258789, -1.62686505564683, 218, 4, 'PPL', 'P'),
(201947, 'Bullhead', 45.7655601501465, 0.798759708639567, -101.080276489258, -1.76418363356376, 218, 49, 'PPL', 'P'),
(19636, 'Bullhead Bluff', 30.8852806091309, 0.539049837031693, -81.845832824707, -1.42847926182799, 218, 13, 'PPL', 'P'),
(177801, 'Bullhead City', 35.1477813720703, 0.613444509713757, -114.567497253418, -1.9995800428417, 218, 5, 'PPL', 'P'),
(39571, 'Bullion', 30.3277797698975, 0.529319611804439, -90.9972229003906, -1.588201149783, 218, 22, 'PPL', 'P'),
(139058, 'Bullion', 40.1713905334473, 0.701123029913136, -92.4880599975586, -1.61422116573946, 218, 29, 'PPL', 'P'),
(159658, 'Bullion', 41.2463912963867, 0.719885332687881, -79.8977813720703, -1.39447934998122, 218, 45, 'PPL', 'P'),
(194655, 'Bullion', 43.4727783203125, 0.758743116679063, -114.375831604004, -1.99623484619646, 218, 17, 'PPL', 'P'),
(199859, 'Bullion', 40.5238914489746, 0.707275331505383, -115.995559692383, -2.0245044343257, 218, 39, 'PPL', 'P'),
(194656, 'Bullion (historical)', 47.4322204589844, 0.827848418541093, -115.669998168945, -2.01882231382391, 218, 17, 'PPL', 'P'),
(199860, 'Bullion (historical)', 40.3375015258789, 0.704022213654824, -116.691940307617, -2.0366585689086, 218, 39, 'PPL', 'P'),
(192501, 'Bullion Falls', 38.4097213745117, 0.670376102758871, -112.337783813477, -1.96066420193876, 218, 52, 'PPL', 'P'),
(203199, 'Bullionville', 40.7008285522461, 0.710363466526411, -109.57250213623, -1.91240093192574, 218, 52, 'PPL', 'P'),
(189981, 'Bullionville (historical)', 37.8033294677734, 0.659792567428842, -114.406112670898, -1.99676335051478, 218, 39, 'PPL', 'P'),
(92909, 'Bullis Addition Colonia', 26.2210006713867, 0.457642794883342, -97.5820007324219, -1.70312720346428, 218, 51, 'PPL', 'P'),
(129994, 'Bullis Crossing', 42.4677810668945, 0.74120260563342, -84.0330581665039, -1.4666535455254, 218, 27, 'PPL', 'P'),
(159659, 'Bullis Mills', 41.9847183227539, 0.732771570254447, -78.3511123657227, -1.3674848833819, 218, 45, 'PPL', 'P'),
(39572, 'Bullitt Bayou', 31.6333293914795, 0.552105751249211, -91.4333267211914, -1.5958125973365, 218, 22, 'PPL', 'P'),
(35056, 'Bullittsville', 39.0752792358398, 0.681992278801579, -84.7386093139648, -1.47896773608982, 218, 21, 'PPL', 'P'),
(19638, 'Bulloch Crossroads', 32.8730583190918, 0.573743102868265, -84.6324996948242, -1.47711577386778, 218, 13, 'PPL', 'P'),
(19639, 'Bullochville (historical)', 32.8933296203613, 0.574096903819082, -84.6533279418945, -1.47747929535657, 218, 13, 'PPL', 'P'),
(1230, 'Bullock', 31.5405597686768, 0.550486615885471, -86.1786117553711, -1.50410051992912, 218, 2, 'PPL', 'P'),
(45236, 'Bullock', 39.6674995422363, 0.692328473045367, -77.2594375610352, -1.34843156367904, 218, 25, 'PPL', 'P'),
(63289, 'Bullock', 36.4911117553711, 0.636890047844433, -78.545280456543, -1.37087375586903, 218, 33, 'PPL', 'P'),
(70593, 'Bullock', 39.8816719055176, 0.696066485951403, -74.4499969482422, -1.29939757484656, 218, 37, 'PPL', 'P'),
(92910, 'Bullock', 32.5155601501465, 0.567503582750318, -98.686393737793, -1.722402497644, 218, 51, 'PPL', 'P'),
(80035, 'Bullock (historical)', 34.1599998474121, 0.596204469818102, -82.2061080932617, -1.43476725147777, 218, 48, 'PPL', 'P'),
(80036, 'Bullock Creek', 34.8541717529297, 0.608320055144227, -81.4119415283203, -1.42090643011029, 218, 48, 'PPL', 'P'),
(129995, 'Bullock Creek', 43.5833282470703, 0.760672576888826, -84.2477798461914, -1.47040114581136, 218, 27, 'PPL', 'P'),
(100346, 'Bullocks Corner', 38.1558303833008, 0.665944869021089, -77.334716796875, -1.34974543420283, 218, 53, 'PPL', 'P'),
(100347, 'Bullocks Trailer Park', 36.8402786254883, 0.642984159366861, -76.4602813720703, -1.33448365694391, 218, 53, 'PPL', 'P'),
(63290, 'Bullocksville', 36.4530601501465, 0.636225922047595, -78.3466720581055, -1.36740738539418, 218, 33, 'PPL', 'P'),
(29347, 'Bullocktown', 37.9747200012207, 0.662783896544246, -87.2227783203125, -1.52232466442658, 218, 19, 'PPL', 'P'),
(177548, 'Bulls Bridge', 41.6755599975586, 0.727375739569837, -73.5077819824219, -1.28295282143143, 218, 8, 'PPL', 'P'),
(85416, 'Bulls Gap', 36.2569389343262, 0.632802961098516, -83.0861129760742, -1.45012623411648, 218, 50, 'PPL', 'P'),
(147466, 'Bulls Head', 40.6069412231445, 0.708724823507686, -74.1624984741211, -1.29437977987868, 218, 40, 'PPL', 'P'),
(100348, 'Bulls Landing', 37.1775016784668, 0.648869811954964, -75.940559387207, -1.32541279711305, 218, 53, 'PPL', 'P'),
(13460, 'Bullseye', 38.5916709899902, 0.673551722621709, -75.2236099243164, -1.3128996684152, 218, 10, 'PPL', 'P'),
(171807, 'Bullthroat', 44.663890838623, 0.779531951885304, -71.6488876342773, -1.25050899460959, 218, 55, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(307, 'Bulltown', 35.1341705322266, 0.613206955744522, -91.1763916015625, -1.59132823353497, 218, 4, 'PPL', 'P'),
(70596, 'Bulltown', 39.6380615234375, 0.691814682692064, -74.5944366455078, -1.30191852313443, 218, 37, 'PPL', 'P'),
(108419, 'Bulltown', 38.7886085510254, 0.67698893148262, -80.5666732788086, -1.40615371609375, 218, 58, 'PPL', 'P'),
(63291, 'Bullucks Crossroads', 35.8794403076172, 0.626214367140687, -77.7408294677734, -1.35683343744408, 218, 33, 'PPL', 'P'),
(147467, 'Bullville', 41.5441703796387, 0.725082558134197, -74.3619384765625, -1.29786066458147, 218, 40, 'PPL', 'P'),
(159661, 'Bully Hill', 41.3688888549805, 0.722023318410996, -79.8263931274414, -1.39323339006523, 218, 45, 'PPL', 'P'),
(193409, 'Bully Hill', 40.797779083252, 0.71205557250402, -122.191940307617, -2.13265167776829, 218, 6, 'PPL', 'P'),
(26646, 'Bulpitt', 39.5916709899902, 0.691005015141653, -89.4238891601563, -1.56074129578319, 218, 18, 'PPL', 'P'),
(147468, 'Bulsontown', 41.2602806091309, 0.720127746926105, -74.0169372558594, -1.2918392573568, 218, 40, 'PPL', 'P'),
(92911, 'Bulverde', 29.7436103820801, 0.519123932597666, -98.4527816772461, -1.71832519801509, 218, 51, 'PPL', 'P'),
(92912, 'Bulverde East (historical)', 29.7533302307129, 0.519293575959104, -98.3905563354492, -1.71723916092256, 218, 51, 'PPL', 'P'),
(92913, 'Bulverde South (historical)', 29.7641696929932, 0.51948276026504, -98.4461135864258, -1.71820881787545, 218, 51, 'PPL', 'P'),
(92914, 'Bulverde West (historical)', 29.7722206115723, 0.519623275302056, -98.5250015258789, -1.71958567215902, 218, 51, 'PPL', 'P'),
(177802, 'Bumble Bee', 34.2008285522461, 0.59691706514678, -112.152221679688, -1.95742553173711, 218, 5, 'PPL', 'P'),
(180321, 'Bumblebee', 38.226390838623, 0.667176381288169, -119.996109008789, -2.0943271917854, 218, 6, 'PPL', 'P'),
(129996, 'Bumbletown', 47.288890838623, 0.825346844750155, -88.4194412231445, -1.54321037211747, 218, 27, 'PPL', 'P'),
(53737, 'Bumgarden Ford', 37.2683296203613, 0.650455058593834, -92.9786071777344, -1.6227828291699, 218, 29, 'PPL', 'P'),
(180322, 'Bummerville', 38.4013900756836, 0.670230694163353, -120.504722595215, -2.1032041734889, 218, 6, 'PPL', 'P'),
(100349, 'Bumpass', 37.9633293151855, 0.662585091568872, -77.7375030517578, -1.35677538053231, 218, 53, 'PPL', 'P'),
(416, 'Bumphead', 32.1891708374023, 0.561807014599611, -84.20361328125, -1.46963029383384, 218, 13, 'PPL', 'P'),
(85417, 'Bumpus Cove', 36.1541709899902, 0.631009322104347, -82.4875030517578, -1.43967852000204, 218, 50, 'PPL', 'P'),
(85418, 'Bumpus Mills', 36.6047210693359, 0.638872904434052, -87.8375015258789, -1.53305360835213, 218, 50, 'PPL', 'P'),
(159662, 'Bumpville', 41.9041709899902, 0.731365754094021, -76.3861083984375, -1.33318909433803, 218, 45, 'PPL', 'P'),
(177803, 'Bumstead', 33.5733299255371, 0.585965148058965, -112.356109619141, -1.96098404758568, 218, 5, 'PPL', 'P'),
(92915, 'Buna', 30.4327793121338, 0.53115219952955, -93.9622192382813, -1.63995009818877, 218, 51, 'PPL', 'P'),
(191196, 'Bunavista', 35.6536102294922, 0.62227288872737, -101.446937561035, -1.77058307650517, 218, 51, 'PPL', 'P'),
(194657, 'Buncel Place', 42.5502815246582, 0.742642510255798, -116.023612976074, -2.02499405649211, 218, 17, 'PPL', 'P'),
(53738, 'Bunceton', 38.7880592346191, 0.676979344102696, -92.7991714477539, -1.61965108488602, 218, 29, 'PPL', 'P'),
(75263, 'Bunch', 35.6824989318848, 0.622777091700749, -94.7608337402344, -1.65388855070202, 218, 42, 'PPL', 'P'),
(15377, 'Bunche Park', 25.920280456543, 0.452394237007014, -80.2372207641602, -1.40040368498416, 218, 12, 'PPL', 'P'),
(159663, 'Bunches', 40.1813888549805, 0.701297533543564, -76.8788909912109, -1.34178977307844, 218, 45, 'PPL', 'P'),
(200484, 'Buncom', 42.1741714477539, 0.736078151063889, -122.996940612793, -2.14670158357317, 218, 43, 'PPL', 'P'),
(26647, 'Buncombe', 37.4713897705078, 0.653999126793484, -88.976936340332, -1.55294049747619, 218, 18, 'PPL', 'P'),
(85419, 'Buncombe', 36.5116691589355, 0.637248842222294, -82.3172225952148, -1.43670656538357, 218, 50, 'PPL', 'P'),
(39573, 'Buncombe (historical)', 32.4580612182617, 0.566500037072549, -93.8455581665039, -1.63791397837735, 218, 22, 'PPL', 'P'),
(85420, 'Buncombe (historical)', 35.3250007629395, 0.616537571582802, -86.0833282470703, -1.50243750898642, 218, 50, 'PPL', 'P'),
(92916, 'Buncome', 32.0488891601563, 0.559358637451447, -94.4236068725586, -1.64800283153489, 218, 51, 'PPL', 'P'),
(134476, 'Bunde', 44.9347190856934, 0.784258796504085, -95.3099975585938, -1.66347326746522, 218, 28, 'PPL', 'P'),
(100350, 'Bundick', 37.9605598449707, 0.662536755195087, -76.4875030517578, -1.33495876488238, 218, 53, 'PPL', 'P'),
(39574, 'Bundick (historical)', 30.7122192382813, 0.536029346302353, -93.0444412231445, -1.62393185002221, 218, 22, 'PPL', 'P'),
(100351, 'Bundy', 36.829719543457, 0.642799868619428, -82.9311065673828, -1.44742086192312, 218, 53, 'PPL', 'P'),
(173363, 'Bundy', 45.4997215270996, 0.794119949388431, -89.4336090087891, -1.56091093914463, 218, 57, 'PPL', 'P'),
(194658, 'Bundy', 46.3613891601563, 0.809158886643135, -116.756393432617, -2.03778348815305, 218, 17, 'PPL', 'P'),
(196107, 'Bundy', 46.292781829834, 0.807961462838008, -108.778060913086, -1.8985353168683, 218, 31, 'PPL', 'P'),
(92918, 'Bundy Crossing', 30.9241695404053, 0.539728576925014, -96.2041702270508, -1.67907952461114, 218, 51, 'PPL', 'P'),
(147469, 'Bundy Crossing', 43.3830604553223, 0.757177244537124, -76.445556640625, -1.33422666189872, 218, 40, 'PPL', 'P'),
(154530, 'Bundysburg', 41.4199981689453, 0.722915344218118, -81.0083312988281, -1.41386210271093, 218, 41, 'PPL', 'P'),
(39575, 'Bungalo (historical)', 32.3691711425781, 0.564948612579523, -93.8147201538086, -1.63737575352104, 218, 22, 'PPL', 'P'),
(85421, 'Bungalow', 35.7611083984375, 0.624149085715331, -83.9925003051758, -1.46594567730766, 218, 50, 'PPL', 'P'),
(159664, 'Bungalow Park', 40.5819396972656, 0.708288464563076, -75.5263900756836, -1.31818417896625, 218, 45, 'PPL', 'P'),
(126994, 'Bunganuc Landing', 43.8638916015625, 0.765569331185154, -70.0224990844727, -1.22212315949876, 218, 26, 'PPL', 'P'),
(26648, 'Bungay', 38.1791687011719, 0.666352199509816, -88.4086074829102, -1.54302128768008, 218, 18, 'PPL', 'P'),
(92917, 'Bunger', 33.0136108398438, 0.576196207127364, -98.5936126708984, -1.72078316254318, 218, 51, 'PPL', 'P'),
(100352, 'Bungletown', 37.8711090087891, 0.660975543585055, -78.6438903808594, -1.37259482372349, 218, 53, 'PPL', 'P'),
(143567, 'Bungy', 44.8438911437988, 0.782673549865216, -71.3933334350586, -1.24604873241593, 218, 36, 'PPL', 'P'),
(26649, 'Bunje', 38.9925003051758, 0.680547513910211, -89.5911102294922, -1.56365985402181, 218, 18, 'PPL', 'P'),
(188203, 'Bunk Clay Place', 35.413330078125, 0.618079208958822, -103.331390380859, -1.80347298280959, 218, 38, 'PPL', 'P'),
(15378, 'Bunker', 30.3872203826904, 0.530357046207079, -86.0827789306641, -1.50242792160649, 218, 12, 'PPL', 'P'),
(53739, 'Bunker', 37.4555587768555, 0.653722823830388, -91.2094421386719, -1.59190507422708, 218, 29, 'PPL', 'P'),
(112364, 'Bunker', 32.9447212219238, 0.57499385647422, -93.4499969482422, -1.63101013272548, 218, 22, 'PPL', 'P'),
(147470, 'Bunker', 42.8061103820801, 0.747107566139425, -76.6469421386719, -1.33774150190541, 218, 40, 'PPL', 'P'),
(180323, 'Bunker', 38.350830078125, 0.669348255736155, -121.757217407227, -2.12506433182266, 218, 6, 'PPL', 'P'),
(203201, 'Bunker', 40.3083305358887, 0.703513083833428, -111.732780456543, -1.95010490137465, 218, 52, 'PPL', 'P'),
(206921, 'Bunker', 46.6444396972656, 0.814099050465232, -123.115280151367, -2.14876699815658, 218, 56, 'PPL', 'P'),
(201943, 'Bunker (historical)', 44.2386093139648, 0.772109389032116, -101.101387023926, -1.76455208190058, 218, 49, 'PPL', 'P'),
(53742, 'Bunker Camp (historical)', 37.5063896179199, 0.654609989368521, -91.2533264160156, -1.59267099935659, 218, 29, 'PPL', 'P'),
(15379, 'Bunker Donation', 30.5311107635498, 0.532868407115024, -85.8694381713867, -1.4987044229284, 218, 12, 'PPL', 'P'),
(7775, 'Bunker Hill', 35.0697212219238, 0.6120821030791, -92.6686096191406, -1.61737235109929, 218, 4, 'PPL', 'P'),
(15380, 'Bunker Hill', 27.5933303833008, 0.481594466779188, -82.1869430541992, -1.43443275844486, 218, 12, 'PPL', 'P'),
(19640, 'Bunker Hill', 34.8394393920898, 0.608062926940979, -84.0511093139648, -1.46696859748236, 218, 13, 'PPL', 'P'),
(26650, 'Bunker Hill', 39.042781829834, 0.68142509206842, -89.9516677856445, -1.56995277051961, 218, 18, 'PPL', 'P'),
(31916, 'Bunker Hill', 38.8758316040039, 0.678511260940737, -98.70361328125, -1.72270303537302, 218, 20, 'PPL', 'P'),
(35057, 'Bunker Hill', 38.163890838623, 0.666085550505672, -84.0130615234375, -1.46630453826455, 218, 21, 'PPL', 'P'),
(58829, 'Bunker Hill', 31.8063907623291, 0.555126241978552, -89.5138931274414, -1.56231216135218, 218, 30, 'PPL', 'P'),
(63292, 'Bunker Hill', 34.954719543457, 0.610074945144534, -79.7713928222656, -1.39227345365031, 218, 33, 'PPL', 'P'),
(80038, 'Bunker Hill', 33.833610534668, 0.590507901667395, -79.2194366455078, -1.38264000103916, 218, 48, 'PPL', 'P'),
(85425, 'Bunker Hill', 36.4197196960449, 0.635644021349412, -82.2491683959961, -1.4355187955374, 218, 50, 'PPL', 'P'),
(100355, 'Bunker Hill', 39.0133285522461, 0.680911035399007, -78.2058334350586, -1.36494928770804, 218, 53, 'PPL', 'P'),
(108420, 'Bunker Hill', 39.3333282470703, 0.686496083679067, -78.0547180175781, -1.36231182612248, 218, 58, 'PPL', 'P'),
(122294, 'Bunker Hill', 40.6602783203125, 0.709655731466723, -86.102783203125, -1.5027770620254, 218, 19, 'PPL', 'P'),
(129997, 'Bunker Hill', 42.4755592346191, 0.741338360269987, -84.317497253418, -1.47161794411342, 218, 27, 'PPL', 'P'),
(139059, 'Bunker Hill', 40.5766716003418, 0.708196518926441, -92.3850021362305, -1.61242246673922, 218, 29, 'PPL', 'P'),
(154532, 'Bunker Hill', 40.959171295166, 0.714872397988997, -80.9358291625977, -1.41259670171897, 218, 41, 'PPL', 'P'),
(159666, 'Bunker Hill', 40.3938903808594, 0.705006384835662, -76.4847183227539, -1.33491016219249, 218, 45, 'PPL', 'P'),
(173364, 'Bunker Hill', 43.4958305358887, 0.759145453740747, -90.2569427490234, -1.57528082375448, 218, 57, 'PPL', 'P'),
(177549, 'Bunker Hill', 41.5711097717285, 0.725552739224651, -73.0638885498047, -1.27520541950428, 218, 8, 'PPL', 'P'),
(180325, 'Bunker Hill', 38.4266700744629, 0.670671913376952, -120.827217102051, -2.10883276445279, 218, 6, 'PPL', 'P'),
(191197, 'Bunker Hill', 36.1263885498047, 0.630524427048871, -102.873893737793, -1.79548816007126, 218, 51, 'PPL', 'P'),
(200485, 'Bunker Hill', 43.3561096191406, 0.756706863709589, -124.20361328125, -2.16776199463157, 218, 43, 'PPL', 'P'),
(206922, 'Bunker Hill', 46.2024993896484, 0.806385737000036, -123.137496948242, -2.1491547544113, 218, 56, 'PPL', 'P'),
(71967, 'Bunker Hill (historical)', 39.1058311462402, 0.68252551023084, -82.063606262207, -1.43228012533575, 218, 41, 'PPL', 'P'),
(139060, 'Bunker Hill (historical)', 40.1800003051758, 0.701273298777644, -91.7386093139648, -1.60114078372942, 218, 29, 'PPL', 'P'),
(45238, 'Bunker Hill Estates', 39.5555610656738, 0.690374778069685, -77.2194366455078, -1.34773341599928, 218, 25, 'PPL', 'P'),
(92921, 'Bunker Hill Village', 29.767219543457, 0.519535990197328, -95.5297164916992, -1.66730808627688, 218, 51, 'PPL', 'P'),
(154533, 'Bunkers Corners', 41.0827789306641, 0.717029758209043, -81.3472213745117, -1.41977685033394, 218, 41, 'PPL', 'P'),
(159667, 'Bunkertown', 40.6508293151855, 0.70949081521622, -77.2416687011719, -1.3481214385701, 218, 45, 'PPL', 'P'),
(189982, 'Bunkerville', 36.7730598449707, 0.641810970327654, -114.127220153809, -1.99189575783239, 218, 39, 'PPL', 'P'),
(39576, 'Bunkie', 30.9530601501465, 0.540232813187907, -92.182502746582, -1.60888818565657, 218, 22, 'PPL', 'P'),
(58831, 'Bunkley', 31.3622207641602, 0.547374013071927, -90.9908294677734, -1.58808956333333, 218, 30, 'PPL', 'P'),
(26652, 'Bunkum', 38.6208305358887, 0.674060652706023, -90.0447235107422, -1.5715768993104, 218, 18, 'PPL', 'P'),
(7778, 'Bunn', 34.0013885498047, 0.593436180443992, -92.4952774047852, -1.61434713325902, 218, 4, 'PPL', 'P'),
(63293, 'Bunn', 35.9608306884766, 0.627634897266135, -78.2538909912109, -1.36578805029336, 218, 33, 'PPL', 'P'),
(194659, 'Bunn', 47.5111083984375, 0.829225272824664, -115.898063659668, -2.02280280754719, 218, 17, 'PPL', 'P'),
(15381, 'Bunnell', 29.4658298492432, 0.514275747701718, -81.258056640625, -1.41822063215095, 218, 12, 'PPL', 'P'),
(35058, 'Bunnell Crossing', 37.2316703796387, 0.649815234141942, -85.8047180175781, -1.49757484315204, 218, 21, 'PPL', 'P'),
(7777, 'Bunney', 35.7224998474121, 0.623475239380513, -90.3844375610352, -1.5775060280033, 218, 4, 'PPL', 'P'),
(63294, 'Bunnlevel', 35.309440612793, 0.616265995730642, -78.7805633544922, -1.37498021711188, 218, 33, 'PPL', 'P'),
(144916, 'Bunnvale', 40.7016716003418, 0.710378180491434, -74.8836135864258, -1.30696561287429, 218, 37, 'PPL', 'P'),
(53743, 'Bunnville (historical)', 37.8433303833008, 0.660490715108606, -94.5830612182617, -1.65078583487403, 218, 29, 'PPL', 'P'),
(159668, 'Bunola', 40.2372207641602, 0.702271984186424, -79.9508285522461, -1.39540519793419, 218, 45, 'PPL', 'P'),
(13461, 'Bunting', 38.4633293151855, 0.671311737828844, -75.1544418334961, -1.31169245749307, 218, 10, 'PPL', 'P'),
(193410, 'Buntingville', 40.285831451416, 0.703120400730695, -120.48388671875, -2.10284051884205, 218, 6, 'PPL', 'P'),
(85427, 'Buntontown', 36.2916717529297, 0.633409163141645, -81.9733276367188, -1.4307044660768, 218, 50, 'PPL', 'P'),
(85428, 'Buntyn', 35.1158294677734, 0.612886843781494, -89.9716720581055, -1.57030191093852, 218, 50, 'PPL', 'P'),
(63296, 'Bunyan', 35.5377807617188, 0.620251283143891, -76.9755630493164, -1.34347701878706, 218, 33, 'PPL', 'P'),
(92922, 'Bunyan', 32.1688919067383, 0.56145308049074, -98.3647232055664, -1.71678828775, 218, 51, 'PPL', 'P'),
(177417, 'Bunyan', 45.4761085510254, 0.793707825209741, -92.366943359375, -1.61210728162421, 218, 57, 'PPL', 'P'),
(194129, 'Bunyan', 40.2902793884277, 0.703198031876471, -104.91471862793, -1.8311072738608, 218, 7, 'PPL', 'P'),
(80039, 'Bur Clare', 32.7083282470703, 0.570868020734442, -79.960563659668, -1.39557510761173, 218, 48, 'PPL', 'P'),
(35059, 'Buras', 37.7016716003418, 0.658018302931604, -86.3161087036133, -1.50650029438739, 218, 21, 'PPL', 'P'),
(39577, 'Buras', 29.3516693115234, 0.512283270442661, -89.524169921875, -1.56249152525159, 218, 22, 'PPL', 'P'),
(63297, 'Burbage Crossroads', 35.4502792358398, 0.618724093416785, -76.7033309936523, -1.33872567308625, 218, 33, 'PPL', 'P'),
(1232, 'Burbank', 31.2177791595459, 0.544853031494544, -88.3905563354492, -1.54270623572312, 218, 2, 'PPL', 'P'),
(15382, 'Burbank', 29.2905597686768, 0.511216707715598, -82.001106262207, -1.43118929455325, 218, 12, 'PPL', 'P'),
(53744, 'Burbank', 37.1469383239746, 0.648336380788621, -90.3702774047852, -1.57725888665414, 218, 29, 'PPL', 'P'),
(75266, 'Burbank', 36.6949996948242, 0.640448563692997, -96.7316665649414, -1.68828607249954, 218, 42, 'PPL', 'P'),
(85429, 'Burbank', 36.148609161377, 0.630912249882614, -82.101936340332, -1.43294911140158, 218, 50, 'PPL', 'P'),
(118961, 'Burbank', 41.7338905334473, 0.728393799475548, -87.7794418334961, -1.53204027555736, 218, 18, 'PPL', 'P'),
(154534, 'Burbank', 40.9886093139648, 0.715386188342301, -81.995002746582, -1.43108276810965, 218, 41, 'PPL', 'P'),
(169935, 'Burbank', 42.7452812194824, 0.746045896970865, -96.8288879394531, -1.68998290558808, 218, 49, 'PPL', 'P'),
(180327, 'Burbank', 37.3233299255371, 0.651414995008753, -121.930557250977, -2.12808968282099, 218, 6, 'PPL', 'P'),
(206923, 'Burbank', 46.2000007629395, 0.806342127737186, -119.011940002441, -2.07715020222855, 218, 56, 'PPL', 'P'),
(39578, 'Burbank (historical)', 30.0597190856934, 0.524641070269929, -91.0472183227539, -1.58907373451417, 218, 22, 'PPL', 'P'),
(206924, 'Burbank Heights', 46.2108306884766, 0.806531145595554, -119.00666809082, -2.07705819001289, 218, 56, 'PPL', 'P'),
(180328, 'Burbank Junction', 34.1852798461914, 0.596645689031701, -118.317222595215, -2.06502509610153, 218, 6, 'PPL', 'P'),
(180329, 'Burbeck', 39.4300003051758, 0.688183329387686, -123.442497253418, -2.1544780139562, 218, 6, 'PPL', 'P'),
(39579, 'Burbridge', 29.6741695404053, 0.517911961275085, -89.9561080932617, -1.57003026850734, 218, 22, 'PPL', 'P'),
(191198, 'Burbridge Acres Colonia', 31.6030006408691, 0.551576414693045, -106.241996765137, -1.8542726474448, 218, 51, 'PPL', 'P'),
(45237, 'Burch', 38.5091705322266, 0.672111817999331, -76.6624984741211, -1.33801301117854, 218, 25, 'PPL', 'P'),
(53745, 'Burch', 37.2683296203613, 0.650455058593834, -90.3544387817383, -1.57698245053299, 218, 29, 'PPL', 'P'),
(63298, 'Burch', 36.2758293151855, 0.633132660441468, -80.7666702270508, -1.40964432133451, 218, 33, 'PPL', 'P'),
(108421, 'Burch', 37.7200012207031, 0.65833821515755, -82.1916732788086, -1.43451531643865, 218, 58, 'PPL', 'P'),
(177804, 'Burch', 33.4438896179199, 0.583705988506251, -110.831390380859, -1.93437267670917, 218, 5, 'PPL', 'P'),
(80040, 'Burch Crossroads', 34.1452789306641, 0.595947541351937, -79.7286071777344, -1.39152670328065, 218, 48, 'PPL', 'P'),
(19641, 'Burch Grant', 33.3997192382813, 0.5829350699497, -82.0441665649414, -1.43194083861287, 218, 13, 'PPL', 'P'),
(134479, 'Burchard', 44.2561111450195, 0.772414853609149, -95.9899978637695, -1.6753415117051, 218, 28, 'PPL', 'P'),
(141403, 'Burchard', 40.1474990844727, 0.700706045465457, -96.3499984741211, -1.68162470766493, 218, 35, 'PPL', 'P'),
(191199, 'Burchard Place', 31.5041694641113, 0.549851485255, -103.856109619141, -1.81263106116616, 218, 51, 'PPL', 'P'),
(180330, 'Burchell (historical)', 37.2622184753418, 0.650348398992176, -120.286109924316, -2.09938866259515, 218, 6, 'PPL', 'P'),
(1233, 'Burchfield', 33.3447189331055, 0.581975133534781, -87.2986068725586, -1.5236481223303, 218, 2, 'PPL', 'P'),
(108422, 'Burchfield', 39.586669921875, 0.690917730036925, -80.5411071777344, -1.4057075034531, 218, 58, 'PPL', 'P'),
(85430, 'Burchfield Heights', 35.9883308410645, 0.628114865473595, -84.182502746582, -1.46926184549703, 218, 50, 'PPL', 'P'),
(114768, 'Burchinal', 43.0652809143066, 0.751630945250925, -93.2780609130859, -1.62800928280918, 218, 16, 'PPL', 'P'),
(159669, 'Burd Coleman Village', 40.2666702270508, 0.702785974276809, -76.418327331543, -1.3337514208022, 218, 45, 'PPL', 'P'),
(180331, 'Burdell', 38.1580581665039, 0.665983751173004, -122.564170837402, -2.13914832608949, 218, 6, 'PPL', 'P'),
(31917, 'Burden', 37.3127784729004, 0.651230837419374, -96.7538909912109, -1.68867396191231, 218, 20, 'PPL', 'P'),
(63299, 'Burden', 36.1588897705078, 0.631091680361058, -77.0650024414063, -1.34503803066001, 218, 33, 'PPL', 'P'),
(147473, 'Burden', 42.1588897705078, 0.735811435480718, -73.8277816772461, -1.28853786971149, 218, 40, 'PPL', 'P'),
(31918, 'Burdett', 38.1919403076172, 0.666575106093056, -99.5263900756836, -1.73706319944489, 218, 20, 'PPL', 'P'),
(53746, 'Burdett', 38.4336090087891, 0.670793020627523, -94.4824981689453, -1.64903067855761, 218, 29, 'PPL', 'P'),
(147471, 'Burdett', 42.4199981689453, 0.740368636738062, -76.8491668701172, -1.34127098929809, 218, 40, 'PPL', 'P'),
(194130, 'Burdett', 40.3655586242676, 0.704511902400262, -102.950561523438, -1.79682626536097, 218, 7, 'PPL', 'P'),
(19642, 'Burdett (historical)', 33.3180618286133, 0.581509879292344, -84.3513870239258, -1.47220943219153, 218, 13, 'PPL', 'P'),
(63300, 'Burdett (historical)', 35.2011108398438, 0.61437528451474, -80.6405563354492, -1.40744321869356, 218, 33, 'PPL', 'P'),
(7782, 'Burdette', 35.8172187805176, 0.62512839662718, -89.9391708374023, -1.56973465762634, 218, 4, 'PPL', 'P'),
(45241, 'Burdette', 39.1994400024414, 0.684159292980577, -77.3052825927734, -1.34923171042856, 218, 25, 'PPL', 'P'),
(58832, 'Burdette', 33.348331451416, 0.582038183873589, -90.9147186279297, -1.58676117858159, 218, 30, 'PPL', 'P'),
(77953, 'Burdette', 39.9680595397949, 0.697574234602551, -80.4466705322266, -1.40405927305445, 218, 45, 'PPL', 'P'),
(100356, 'Burdette', 36.7683296203613, 0.641728412333862, -76.8986129760742, -1.34213398664933, 218, 53, 'PPL', 'P'),
(108423, 'Burdette', 38.063060760498, 0.664325733657348, -80.7997207641602, -1.41022116202662, 218, 58, 'PPL', 'P'),
(114769, 'Burdette', 42.5719413757324, 0.743020545972535, -93.3600006103516, -1.62943940031455, 218, 16, 'PPL', 'P'),
(169936, 'Burdette', 44.7050018310547, 0.780249474061998, -98.8000030517578, -1.72438535423362, 218, 49, 'PPL', 'P'),
(31919, 'Burdick', 38.5636100769043, 0.673061967297244, -96.8452835083008, -1.69026906224721, 218, 20, 'PPL', 'P'),
(35060, 'Burdick', 37.273609161377, 0.65054720396755, -85.376106262207, -1.49009415680806, 218, 21, 'PPL', 'P'),
(122295, 'Burdick', 41.6011085510254, 0.726076316694961, -86.9727783203125, -1.5179613412966, 218, 19, 'PPL', 'P'),
(147472, 'Burdick Crossing', 43.9855613708496, 0.767692869259356, -73.4255599975586, -1.28151777707804, 218, 40, 'PPL', 'P'),
(196108, 'Burdick Place', 45.1749992370605, 0.788452476272633, -112.212501525879, -1.95847761352575, 218, 31, 'PPL', 'P'),
(130000, 'Burdickville', 44.8488883972168, 0.782760768390916, -85.9480590820313, -1.50007661668006, 218, 27, 'PPL', 'P'),
(169299, 'Burdickville', 41.4180603027344, 0.722881522072274, -71.7333297729492, -1.25198278795684, 218, 47, 'PPL', 'P'),
(126995, 'Burdin Corner', 45.0936088562012, 0.787031946147185, -69.5313873291016, -1.21355164237229, 218, 26, 'PPL', 'P'),
(35061, 'Burdine', 37.1891708374023, 0.649073477199328, -82.5991668701172, -1.44162742128776, 218, 21, 'PPL', 'P'),
(201946, 'Burdock', 43.4530601501465, 0.758398969687198, -103.992782592773, -1.81501645455454, 218, 49, 'PPL', 'P'),
(159670, 'Burds Crossing', 40.3286094665527, 0.703867017942299, -79.3116683959961, -1.38424974876006, 218, 45, 'PPL', 'P'),
(45239, 'Bureau', 38.8158302307129, 0.67746403942109, -75.8555603027344, -1.32392928322782, 218, 25, 'PPL', 'P'),
(118962, 'Bureau', 41.2891693115234, 0.720631949899484, -89.3663864135742, -1.5597376835264, 218, 18, 'PPL', 'P'),
(85431, 'Burem', 36.4150009155273, 0.635561663092702, -82.920280456543, -1.44723191064378, 218, 50, 'PPL', 'P'),
(35062, 'Burfield', 36.726390838623, 0.640996442508254, -84.7900009155273, -1.47986468874496, 218, 21, 'PPL', 'P'),
(92923, 'Burford', 32.785831451416, 0.572220706831121, -94.383056640625, -1.6472950964752, 218, 51, 'PPL', 'P'),
(53748, 'Burfordville', 37.3675003051758, 0.652185913565303, -89.8069381713867, -1.56742676222567, 218, 29, 'PPL', 'P'),
(7780, 'Burg', 34.2369384765625, 0.597547302218747, -94.0699996948242, -1.64183122202474, 218, 4, 'PPL', 'P'),
(75267, 'Burg', 34.5805587768555, 0.603544607835551, -95.9958267211914, -1.67544324445874, 218, 42, 'PPL', 'P'),
(80041, 'Burgan', 33.8499984741211, 0.59079392516847, -79.1947174072266, -1.38220856894257, 218, 48, 'PPL', 'P'),
(80042, 'Burgan (historical)', 33.8375015258789, 0.590575812275192, -79.216667175293, -1.38259166466538, 218, 48, 'PPL', 'P'),
(63301, 'Burgaw', 34.5519409179688, 0.603045131973107, -77.9263916015625, -1.36007210764572, 218, 33, 'PPL', 'P'),
(194660, 'Burgdorf', 45.2772216796875, 0.790236594465904, -115.91194152832, -2.02304502204834, 218, 17, 'PPL', 'P'),
(29351, 'Burge Terrace', 39.7433280944824, 0.693651930949082, -85.9963912963867, -1.50092017295534, 218, 19, 'PPL', 'P'),
(45240, 'Burgee', 39.3561096191406, 0.686893693629815, -77.5569381713867, -1.35362392885637, 218, 25, 'PPL', 'P'),
(85432, 'Burgen', 35.7286109924316, 0.623581898982171, -86.1224975585938, -1.50312114243824, 218, 50, 'PPL', 'P'),
(85433, 'Burger', 35.3988914489746, 0.617827207340673, -84.4441680908203, -1.47382876729235, 218, 50, 'PPL', 'P'),
(63303, 'Burger Town', 35.0491714477539, 0.611723441859293, -84.304443359375, -1.47139011068216, 218, 33, 'PPL', 'P'),
(1234, 'Burgess', 34.4300003051758, 0.60091686678797, -85.5513916015625, -1.49315346311029, 218, 2, 'PPL', 'P'),
(19643, 'Burgess', 33.3894386291504, 0.582755639471256, -85.2861099243164, -1.48852342439713, 218, 13, 'PPL', 'P'),
(53749, 'Burgess', 37.5561103820801, 0.655477780409723, -94.6147232055664, -1.65133844080022, 218, 29, 'PPL', 'P'),
(58833, 'Burgess', 34.3413887023926, 0.599370302563934, -89.6680603027344, -1.56500288615954, 218, 30, 'PPL', 'P'),
(63304, 'Burgess', 36.1347198486328, 0.63066983564439, -76.4075012207031, -1.33356246952286, 218, 33, 'PPL', 'P'),
(80043, 'Burgess', 33.6063919067383, 0.586542188488158, -79.0558319091797, -1.37978455971838, 218, 48, 'PPL', 'P'),
(85434, 'Burgess', 36.0972213745117, 0.630015363806503, -85.5486068725586, -1.4931048604204, 218, 50, 'PPL', 'P'),
(100358, 'Burgess', 37.1425018310547, 0.648258949379927, -77.5119400024414, -1.3528385626509, 218, 53, 'PPL', 'P'),
(118965, 'Burgess', 41.1272201538086, 0.717805403876529, -90.6413879394531, -1.58199065812094, 218, 18, 'PPL', 'P'),
(130001, 'Burgess', 45.3525009155273, 0.791550464989695, -85.1613922119141, -1.48634668968016, 218, 27, 'PPL', 'P'),
(173365, 'Burgess Corners', 43.1808280944824, 0.753647623986387, -89.1869430541992, -1.55660580608446, 218, 57, 'PPL', 'P'),
(209338, 'Burgess Junction', 44.7700004577637, 0.781383914107345, -107.519172668457, -1.87656357208487, 218, 59, 'PPL', 'P'),
(85435, 'Burgesstown (historical)', 35.8263893127441, 0.625288452608694, -85.1611099243164, -1.48634176283214, 218, 50, 'PPL', 'P'),
(39582, 'Burgessville (historical)', 32.561939239502, 0.568313050563648, -92.5699996948242, -1.61565128324483, 218, 22, 'PPL', 'P'),
(159672, 'Burgettstown', 40.3819389343262, 0.704797792743282, -80.3930587768555, -1.40312357140545, 218, 45, 'PPL', 'P'),
(154535, 'Burghill', 41.3594398498535, 0.721858402160493, -80.5686111450195, -1.40618753823959, 218, 41, 'PPL', 'P'),
(35063, 'Burgin', 37.7533302307129, 0.65891991611865, -84.7666702270508, -1.47945749141429, 218, 21, 'PPL', 'P'),
(80045, 'Burgiss Hills', 34.9474983215332, 0.609948911045946, -82.2577819824219, -1.43566913098093, 218, 48, 'PPL', 'P'),
(154536, 'Burgoon', 41.2675018310547, 0.720253781024693, -83.2516708374023, -1.45301576389922, 218, 41, 'PPL', 'P'),
(147474, 'Burgoyne', 43.0897216796875, 0.752057517078528, -73.6630630493164, -1.28566298731475, 218, 40, 'PPL', 'P'),
(1235, 'Burgreen Gin', 34.728889465332, 0.606133466731217, -86.79638671875, -1.51488272707646, 218, 2, 'PPL', 'P'),
(177805, 'Burgundy Hill', 33.3633308410645, 0.582299972608744, -111.976387023926, -1.95435663805496, 218, 5, 'PPL', 'P'),
(100359, 'Burgundy Village', 38.7986106872559, 0.677163501692075, -77.0877838134766, -1.34543564061076, 218, 53, 'PPL', 'P'),
(159673, 'Burholme', 40.0611114501953, 0.699198296814309, -75.083610534668, -1.31045621811506, 218, 45, 'PPL', 'P'),
(206925, 'Burien', 47.4705581665039, 0.828517537764976, -122.345558166504, -2.13533281519573, 218, 56, 'PPL', 'P'),
(108424, 'Burk', 39.5263900756836, 0.689865648248289, -79.8147201538086, -1.39302965824183, 218, 58, 'PPL', 'P'),
(147475, 'Burk Hill', 42.7780609130859, 0.746618010552041, -78.0263900756836, -1.36181741026611, 218, 40, 'PPL', 'P'),
(92925, 'Burkburnett', 34.0977783203125, 0.595118499304595, -98.5702819824219, -1.72037596521251, 218, 51, 'PPL', 'P'),
(100360, 'Burkdale', 37.1022186279297, 0.647555874852146, -76.538330078125, -1.33584586384149, 218, 53, 'PPL', 'P'),
(35064, 'Burke', 38.1072196960449, 0.665096452476817, -83.0400009155273, -1.44932142683506, 218, 21, 'PPL', 'P'),
(39581, 'Burke', 30.0608291625977, 0.524660444766859, -91.8819427490234, -1.60364242409939, 218, 22, 'PPL', 'P'),
(85436, 'Burke', 35.7744407653809, 0.624381779415576, -85.0169372558594, -1.48382547507618, 218, 50, 'PPL', 'P'),
(92924, 'Burke', 31.2316703796387, 0.545095479022282, -94.7683334350586, -1.6540194450696, 218, 51, 'PPL', 'P'),
(100361, 'Burke', 38.7933311462402, 0.677071356318358, -77.2719421386719, -1.34864980973037, 218, 53, 'PPL', 'P'),
(118966, 'Burke', 42.0511093139648, 0.73393031164474, -90.0366668701172, -1.57143628440484, 218, 18, 'PPL', 'P'),
(147478, 'Burke', 44.9047203063965, 0.783735219033776, -74.1697235107422, -1.2945058805563, 218, 40, 'PPL', 'P'),
(169939, 'Burke', 43.1824989318848, 0.753676785600324, -99.2916717529297, -1.73296659189807, 218, 49, 'PPL', 'P'),
(173369, 'Burke', 43.1358299255371, 0.752862257780923, -89.2761077880859, -1.55816202426745, 218, 57, 'PPL', 'P'),
(193144, 'Burke', 47.5202789306641, 0.829385328806178, -115.81916809082, -2.02142582010557, 218, 17, 'PPL', 'P'),
(147476, 'Burke Center', 44.9188919067383, 0.783982560120017, -74.1800003051758, -1.29468524445572, 218, 40, 'PPL', 'P'),
(171808, 'Burke Hollow', 44.622501373291, 0.77880956943962, -71.9499969482422, -1.2557643435467, 218, 55, 'PPL', 'P'),
(58834, 'Burke Landing', 34.2702789306641, 0.598129202916929, -90.788330078125, -1.58455528225068, 218, 30, 'PPL', 'P'),
(100362, 'Burke Meadows', 38.8608283996582, 0.678249405626554, -77.6819381713867, -1.35580559042136, 218, 53, 'PPL', 'P'),
(63306, 'Burke Park', 36.0791702270508, 0.629700311849546, -80.3069381713867, -1.40162048328621, 218, 33, 'PPL', 'P'),
(143568, 'Burkehaven', 43.375560760498, 0.757046350169546, -72.0713882446289, -1.25788302135191, 218, 36, 'PPL', 'P'),
(63307, 'Burkemont', 35.6816711425781, 0.622762644051835, -81.6997222900391, -1.42592915192618, 218, 33, 'PPL', 'P'),
(203206, 'Burkes Addition', 40.704719543457, 0.710431377134208, -112.102783203125, -1.95656266754393, 218, 52, 'PPL', 'P'),
(100363, 'Burkes Corner', 37.3525009155273, 0.651924124830149, -76.7322235107422, -1.33922994263865, 218, 53, 'PPL', 'P'),
(100364, 'Burkes Garden', 37.0980606079102, 0.647483303712441, -81.3411102294922, -1.41967019073228, 218, 53, 'PPL', 'P'),
(35065, 'Burkes Spring', 37.6474990844727, 0.657072814165599, -85.3483276367188, -1.48960932833161, 218, 21, 'PPL', 'P'),
(100365, 'Burkes Tavern', 37.1947212219238, 0.649170349683979, -78.2386093139648, -1.36552133471019, 218, 53, 'PPL', 'P'),
(100366, 'Burkeston (historical)', 37.6016693115234, 0.656272933732193, -79.7638931274414, -1.39214255928273, 218, 53, 'PPL', 'P'),
(35067, 'Burkesville', 36.7902793884277, 0.64211150805667, -85.3705596923828, -1.48999735090244, 218, 21, 'PPL', 'P'),
(144921, 'Burkesville', 40.1605606079102, 0.700934012054768, -74.42138671875, -1.29889823214217, 218, 37, 'PPL', 'P'),
(122296, 'Burket', 41.1552810668945, 0.718295159200994, -85.9686126708984, -1.50043534447889, 218, 19, 'PPL', 'P'),
(100367, 'Burketown', 38.3027801513672, 0.668509626308889, -78.9347229003906, -1.37767080876118, 218, 53, 'PPL', 'P'),
(31920, 'Burkett', 38.0416717529297, 0.663952425051546, -96.2649993896484, -1.6801411937797, 218, 20, 'PPL', 'P'),
(92926, 'Burkett', 31.9958305358887, 0.558432589761399, -99.2252807617188, -1.73180785050778, 218, 51, 'PPL', 'P'),
(80046, 'Burkett Landing', 33.9066696166992, 0.591783023197325, -79.6436080932617, -1.39004318939542, 218, 48, 'PPL', 'P'),
(154537, 'Burkettsville', 40.3519401550293, 0.704274215272972, -84.642219543457, -1.47728541722922, 218, 41, 'PPL', 'P'),
(58835, 'Burkettsville (historical)', 33.1555595397949, 0.578673679310437, -89.6194381713867, -1.56415426987818, 218, 30, 'PPL', 'P'),
(126996, 'Burkettville', 44.2980613708496, 0.773147023171839, -69.3183288574219, -1.20983307054221, 218, 26, 'PPL', 'P'),
(92927, 'Burkeville', 30.999719619751, 0.541047174559739, -93.6677780151367, -1.63481112939129, 218, 51, 'PPL', 'P'),
(100368, 'Burkeville', 37.1875, 0.649044315585391, -78.2016677856445, -1.36487658341028, 218, 53, 'PPL', 'P'),
(1236, 'Burkhalter Subdivision', 34.1819381713867, 0.596587365803828, -85.7180633544922, -1.49606243396898, 218, 2, 'PPL', 'P'),
(173367, 'Burkhardt', 45.021671295166, 0.785776398851267, -92.6669387817383, -1.61734318948536, 218, 57, 'PPL', 'P'),
(173368, 'Burkhardt Station', 45.0144386291504, 0.785650165015597, -92.665283203125, -1.61731429418753, 218, 57, 'PPL', 'P'),
(35066, 'Burkhart', 37.7066688537598, 0.658105521457304, -83.2752838134766, -1.45342788807791, 218, 21, 'PPL', 'P'),
(71968, 'Burkhart', 39.7891693115234, 0.694452011119569, -81.2630615234375, -1.4183079838347, 218, 41, 'PPL', 'P'),
(77954, 'Burkhelder', 39.8808288574219, 0.69605177198638, -79.033332824707, -1.37939187661565, 218, 45, 'PPL', 'P'),
(124354, 'Burkinshaws Factory', 42.6680603027344, 0.744698137722203, -71.6125030517578, -1.24987396384766, 218, 23, 'PPL', 'P'),
(45242, 'Burkittsville', 39.3936080932617, 0.687548165467702, -77.6291732788086, -1.35488466931641, 218, 25, 'PPL', 'P'),
(169942, 'Burkmere', 45.0486106872559, 0.78624657994172, -99.311393737793, -1.73331080546897, 218, 49, 'PPL', 'P'),
(39585, 'Burkplace', 32.2183303833008, 0.562315944683925, -93.0138931274414, -1.62339868517198, 218, 22, 'PPL', 'P'),
(7784, 'Burks', 34.3016700744629, 0.598677081732186, -91.4022216796875, -1.59526971194829, 218, 4, 'PPL', 'P'),
(19645, 'Burkshire', 33.6166687011719, 0.586721552387575, -84.3055572509766, -1.47140955175812, 218, 13, 'PPL', 'P'),
(26654, 'Burksville', 38.267219543457, 0.667888976616847, -90.1524963378906, -1.57345788998832, 218, 18, 'PPL', 'P'),
(53750, 'Burksville', 39.8619384765625, 0.695722072643428, -91.9172210693359, -1.60425814694342, 218, 29, 'PPL', 'P'),
(26655, 'Burksville Station', 38.2680587768555, 0.667903624002842, -90.1183319091797, -1.57286160822025, 218, 18, 'PPL', 'P'),
(1238, 'Burkville', 32.3280601501465, 0.564231090402829, -86.5369415283203, -1.510354554275, 218, 2, 'PPL', 'P'),
(124355, 'Burkville', 42.5063896179199, 0.741876451968237, -72.7125015258789, -1.26907255898799, 218, 23, 'PPL', 'P'),
(108425, 'Burl', 38.2752799987793, 0.66802965810143, -80.9263916015625, -1.41243198520555, 218, 58, 'PPL', 'P'),
(70594, 'Burleigh', 39.0455589294434, 0.681473561600259, -74.851936340332, -1.30641274063199, 218, 37, 'PPL', 'P'),
(92928, 'Burleigh', 29.9194393157959, 0.522192726411278, -96.1500015258789, -1.67813410242416, 218, 51, 'PPL', 'P'),
(45244, 'Burleigh Manor', 39.2638893127441, 0.685284145645999, -76.8658294677734, -1.34156180648913, 218, 25, 'PPL', 'P'),
(13047, 'Burleith', 38.9152793884277, 0.679199754661549, -77.0727767944336, -1.34517371871755, 218, 9, 'PPL', 'P'),
(92929, 'Burleson', 32.5419387817383, 0.567963976723765, -97.320556640625, -1.69856414325254, 218, 51, 'PPL', 'P'),
(194662, 'Burley', 42.535831451416, 0.742390308900568, -113.791938781738, -1.98604399396916, 218, 17, 'PPL', 'P'),
(206926, 'Burley', 47.4180603027344, 0.827601277191934, -122.629722595215, -2.14029242009378, 218, 56, 'PPL', 'P'),
(124356, 'Burleys Corner', 42.577220916748, 0.743112691346252, -70.9902801513672, -1.23901412555454, 218, 23, 'PPL', 'P'),
(45253, 'Burleytown', 39.151668548584, 0.6833255238223, -76.6694412231445, -1.33813418500814, 218, 25, 'PPL', 'P'),
(180333, 'Burling (historical)', 36.1838912963867, 0.631528039305668, -119.342216491699, -2.08291461440803, 218, 6, 'PPL', 'P'),
(26656, 'Burlingame', 39.9236106872559, 0.696798455777011, -90.163330078125, -1.57364697442572, 218, 18, 'PPL', 'P'),
(31921, 'Burlingame', 38.7538909912109, 0.6763829957556, -95.834716796875, -1.67263134582178, 218, 20, 'PPL', 'P'),
(180334, 'Burlingame', 37.584171295166, 0.655967535734189, -122.36499786377, -2.13567210191861, 218, 6, 'PPL', 'P'),
(200486, 'Burlingame', 45.4686088562012, 0.793576930842163, -122.683891296387, -2.14123784228076, 218, 43, 'PPL', 'P'),
(71970, 'Burlingham', 39.1666717529297, 0.683587379136482, -82.0213928222656, -1.43154336182018, 218, 41, 'PPL', 'P'),
(147479, 'Burlingham', 41.5900001525879, 0.725882438567603, -74.3824996948242, -1.29821952553836, 218, 40, 'PPL', 'P'),
(1239, 'Burlington', 32.5802803039551, 0.568633162526675, -85.9388885498047, -1.49991656069855, 218, 2, 'PPL', 'P'),
(7785, 'Burlington', 36.3794403076172, 0.634941013400659, -93.2280578613281, -1.62713656491996, 218, 4, 'PPL', 'P'),
(19646, 'Burlington', 33.6733283996582, 0.587710450679349, -84.1883316040039, -1.46936357825067, 218, 13, 'PPL', 'P'),
(31923, 'Burlington', 38.1944389343262, 0.666618715355906, -95.7425003051758, -1.67102186441699, 218, 20, 'PPL', 'P'),
(35068, 'Burlington', 39.0275001525879, 0.681158376485248, -84.7241668701172, -1.47871566789264, 218, 21, 'PPL', 'P'),
(63308, 'Burlington', 36.0955581665039, 0.629986335350621, -79.4380569458008, -1.38645564509097, 218, 33, 'PPL', 'P'),
(75268, 'Burlington', 36.9000015258789, 0.644026520617519, -98.4225006103516, -1.71779669369676, 218, 42, 'PPL', 'P'),
(85437, 'Burlington', 35.9905586242676, 0.62815374762551, -83.8791732788086, -1.46396774756606, 218, 50, 'PPL', 'P'),
(92931, 'Burlington', 31.0149993896484, 0.541313856853397, -96.9963912963867, -1.69290639067472, 218, 51, 'PPL', 'P'),
(108426, 'Burlington', 39.3375015258789, 0.68656892113488, -78.918327331543, -1.37738465210206, 218, 58, 'PPL', 'P'),
(114770, 'Burlington', 40.8074989318848, 0.712225215865458, -91.1127777099609, -1.59021796167652, 218, 16, 'PPL', 'P'),
(118967, 'Burlington', 42.0527801513672, 0.733959473258677, -88.5480575561523, -1.5454551506003, 218, 18, 'PPL', 'P'),
(122297, 'Burlington', 40.480281829834, 0.706514200065838, -86.3947219848633, -1.50787235498099, 218, 19, 'PPL', 'P'),
(124357, 'Burlington', 42.5047187805176, 0.741847290354301, -71.1961135864258, -1.242606596707, 218, 23, 'PPL', 'P'),
(126997, 'Burlington', 45.209171295166, 0.789048891198756, -68.4272232055664, -1.1942803429342, 218, 26, 'PPL', 'P'),
(130003, 'Burlington', 42.1066703796387, 0.734900035176666, -85.079719543457, -1.48492123270669, 218, 27, 'PPL', 'P'),
(144917, 'Burlington', 40.0711097717285, 0.699372800444736, -74.8652801513672, -1.30664563406932, 218, 37, 'PPL', 'P'),
(147480, 'Burlington', 42.7227783203125, 0.745653147289106, -75.1258316040039, -1.31119311478868, 218, 40, 'PPL', 'P'),
(154538, 'Burlington', 41.5722198486328, 0.725572113721581, -84.3080596923828, -1.4714532276, 218, 41, 'PPL', 'P'),
(159674, 'Burlington', 41.7797203063965, 0.729193679908953, -76.607780456543, -1.33705800161164, 218, 45, 'PPL', 'P'),
(171810, 'Burlington', 44.475830078125, 0.776249672420808, -73.2125015258789, -1.27779920524796, 218, 55, 'PPL', 'P'),
(173370, 'Burlington', 42.6780586242676, 0.744872641352631, -88.2761077880859, -1.54070873174751, 218, 57, 'PPL', 'P'),
(177550, 'Burlington', 41.7691688537598, 0.729009522319574, -72.9649963378906, -1.2734794248018, 218, 8, 'PPL', 'P'),
(186469, 'Burlington', 39.3061103820801, 0.686021042319624, -102.268890380859, -1.78492885950715, 218, 7, 'PPL', 'P'),
(193411, 'Burlington', 40.3086090087891, 0.703517944102417, -123.908058166504, -2.16260358475814, 218, 6, 'PPL', 'P'),
(198070, 'Burlington', 48.2752799987793, 0.842562583300863, -101.428329467773, -1.77025830401023, 218, 34, 'PPL', 'P'),
(200487, 'Burlington', 45.6463890075684, 0.796679779828215, -122.84139251709, -2.14398675715794, 218, 43, 'PPL', 'P'),
(206927, 'Burlington', 48.475830078125, 0.846062842500581, -122.324172973633, -2.13495957316896, 218, 56, 'PPL', 'P'),
(209339, 'Burlington', 44.4472198486328, 0.775750329716418, -108.431671142578, -1.89248967487771, 218, 59, 'PPL', 'P'),
(39583, 'Burlington (historical)', 30.5713901519775, 0.533571415063778, -90.9888916015625, -1.58805574118748, 218, 22, 'PPL', 'P'),
(53751, 'Burlington (historical)', 38.7058296203613, 0.675544166591252, -92.3513870239258, -1.61183577235107, 218, 29, 'PPL', 'P'),
(196109, 'Burlington (historical)', 46.0125007629395, 0.803069635389696, -112.591667175293, -1.96509530251849, 218, 31, 'PPL', 'P'),
(200488, 'Burlington (historical)', 44.4472198486328, 0.775750329716418, -123.204170227051, -2.15031842264961, 218, 43, 'PPL', 'P'),
(122298, 'Burlington Beach', 41.5058288574219, 0.724413372331288, -87.045280456543, -1.51922674228855, 218, 19, 'PPL', 'P'),
(100370, 'Burlington Estates', 37.3491706848145, 0.651866001339357, -79.9736099243164, -1.39580280788493, 218, 53, 'PPL', 'P'),
(147481, 'Burlington Flats', 42.7452812194824, 0.746045896970865, -75.1833267211914, -1.31219659388742, 218, 40, 'PPL', 'P'),
(85438, 'Burlington Heights', 35.2041702270508, 0.614428680894596, -84.8611068725586, -1.48110572181294, 218, 50, 'PPL', 'P'),
(100371, 'Burlington Heights', 37.3400001525879, 0.651705945357844, -79.9680633544922, -1.39570600197931, 218, 53, 'PPL', 'P'),
(144918, 'Burlington Heights', 40.271671295166, 0.702873259381536, -74.2361068725586, -1.29566448878854, 218, 37, 'PPL', 'P'),
(139061, 'Burlington Junction', 40.4455604553223, 0.70590819775979, -95.0658264160156, -1.65921167708887, 218, 29, 'PPL', 'P'),
(100372, 'Burlington Mills', 37.0897216796875, 0.647337761958869, -80.6849975585938, -1.40821886436105, 218, 53, 'PPL', 'P'),
(85439, 'Burlison', 35.5569381713867, 0.62058564301875, -89.7788925170898, -1.56693727321732, 218, 50, 'PPL', 'P'),
(159677, 'Burly', 40.8977813720703, 0.713800941703431, -78.3463897705078, -1.36740245854617, 218, 45, 'PPL', 'P'),
(7787, 'Burma (historical)', 34.6527786254883, 0.604805081979486, -91.3652801513672, -1.59462496064838, 218, 4, 'PPL', 'P'),
(147483, 'Burma Woods', 43.1819381713867, 0.753666998483318, -78.2544403076172, -1.36579763767328, 218, 40, 'PPL', 'P'),
(75269, 'Burmah', 35.8269386291504, 0.625298039988618, -99.0744400024414, -1.72917518261218, 218, 42, 'PPL', 'P'),
(194661, 'Burmah', 43.1294403076172, 0.752750737910276, -114.259437561035, -1.99420338691694, 218, 17, 'PPL', 'P'),
(1240, 'Burmah (historical)', 33.1316719055176, 0.578256761441785, -87.129997253418, -1.52070532932576, 218, 2, 'PPL', 'P'),
(203210, 'Burmester', 40.6911087036133, 0.710193823164973, -112.451393127441, -1.96264705852838, 218, 52, 'PPL', 'P'),
(77955, 'Burmont', 39.935001373291, 0.696997260752385, -75.2802810668945, -1.31388876644406, 218, 45, 'PPL', 'P'),
(7786, 'Burna', 35.0999984741211, 0.612610540818399, -94.3494415283203, -1.64670840208706, 218, 4, 'PPL', 'P'),
(35069, 'Burna', 37.2455596923828, 0.650057648380166, -88.3605575561523, -1.54218265825281, 218, 21, 'PPL', 'P'),
(35070, 'Burnaugh', 38.2602806091309, 0.667767869366275, -82.581672668457, -1.44132208986879, 218, 21, 'PPL', 'P'),
(45245, 'Burnbrae', 39.3988914489746, 0.687640377420446, -76.6197204589844, -1.33726639396694, 218, 25, 'PPL', 'P'),
(39584, 'Burnbridge', 29.6749992370605, 0.517926442213512, -89.9538879394531, -1.56999151951347, 218, 22, 'PPL', 'P'),
(124359, 'Burncoat', 42.3097190856934, 0.738443903639234, -71.7861099243164, -1.2529039753779, 218, 23, 'PPL', 'P'),
(58836, 'Burnell', 31.8088893890381, 0.555169851241402, -90.7474975585938, -1.58384262034298, 218, 30, 'PPL', 'P'),
(92933, 'Burnell', 28.6805591583252, 0.500570188625788, -97.8324966430664, -1.70749918186781, 218, 51, 'PPL', 'P'),
(108427, 'Burner', 38.6169395446777, 0.673992742098226, -79.8072204589844, -1.39289876387426, 218, 58, 'PPL', 'P'),
(180335, 'Burness', 36.7649993896484, 0.641670288843071, -119.657501220703, -2.0884173710104, 218, 6, 'PPL', 'P'),
(92932, 'Burnet', 30.7580604553223, 0.53682942647284, -98.2280578613281, -1.71440302751968, 218, 51, 'PPL', 'P'),
(19648, 'Burnett', 31.6533298492432, 0.552454825089094, -81.995002746582, -1.43108276810965, 218, 13, 'PPL', 'P'),
(29352, 'Burnett', 39.542781829834, 0.690151738328391, -87.2955627441406, -1.52359499226655, 218, 19, 'PPL', 'P'),
(75270, 'Burnett', 35.1558303833008, 0.613584991461259, -97.0805587768555, -1.69437539033201, 218, 42, 'PPL', 'P'),
(85440, 'Burnett', 36.0727806091309, 0.629588791978899, -85.4038925170898, -1.49057911844257, 218, 50, 'PPL', 'P'),
(92934, 'Burnett', 33.5555610656738, 0.585655022950025, -96.0288925170898, -1.67602035146696, 218, 51, 'PPL', 'P'),
(118987, 'Burnett', 41.2772216796875, 0.720423424386131, -89.6636123657227, -1.56492525501376, 218, 18, 'PPL', 'P'),
(134483, 'Burnett', 46.9008293151855, 0.818573893465865, -92.524169921875, -1.61485140281142, 218, 28, 'PPL', 'P'),
(173373, 'Burnett', 43.5047187805176, 0.759300582874244, -88.7069396972656, -1.54822816708535, 218, 57, 'PPL', 'P'),
(206928, 'Burnett', 47.1294403076172, 0.822563907990049, -122.047782897949, -2.13013565632844, 218, 56, 'PPL', 'P'),
(63309, 'Burnett Fields', 35.2611083984375, 0.615422439455359, -83.541389465332, -1.45807230786095, 218, 33, 'PPL', 'P'),
(63310, 'Burnett Siding', 35.3958282470703, 0.61777374438179, -82.938606262207, -1.4475517562907, 218, 33, 'PPL', 'P'),
(35071, 'Burnetta', 37.0708312988281, 0.647008062615917, -84.8027801513672, -1.48008772848625, 218, 21, 'PPL', 'P'),
(100373, 'Burnette Heights', 37.336669921875, 0.651647821867053, -79.9236068725586, -1.39493008999572, 218, 53, 'PPL', 'P'),
(80051, 'Burnettown', 33.5152816772461, 0.584952015001272, -81.8491668701172, -1.42853745189781, 218, 48, 'PPL', 'P'),
(177551, 'Burnetts Corner', 41.3891716003418, 0.722377319098895, -71.9802780151367, -1.25629284786502, 218, 8, 'PPL', 'P'),
(154540, 'Burnetts Corners', 40.771110534668, 0.711590118524502, -81.9733276367188, -1.4307044660768, 218, 41, 'PPL', 'P'),
(15383, 'Burnetts Lake', 29.7872200012207, 0.519885064037211, -82.477783203125, -1.43950887664061, 218, 12, 'PPL', 'P'),
(122300, 'Burnettsville', 40.7611083984375, 0.711415548315047, -86.5936126708984, -1.51134365230386, 218, 19, 'PPL', 'P'),
(29355, 'Burney', 39.3172187805176, 0.686214920446982, -85.6402816772461, -1.49470488760332, 218, 19, 'PPL', 'P'),
(63311, 'Burney', 34.7316703796387, 0.606182002842084, -78.7177810668945, -1.37388445948136, 218, 33, 'PPL', 'P'),
(193412, 'Burney', 40.8824996948242, 0.71353422612026, -121.659721374512, -2.12336270504415, 218, 6, 'PPL', 'P'),
(53754, 'Burney Ford', 37.4275016784668, 0.65323313508495, -92.3988876342773, -1.61266481439841, 218, 29, 'PPL', 'P'),
(19649, 'Burney Hill', 31.166109085083, 0.543951218570416, -83.5286102294922, -1.45784926811966, 218, 13, 'PPL', 'P'),
(75273, 'Burneyville', 33.9077796936035, 0.591802397694255, -97.2886123657227, -1.69800661047833, 218, 42, 'PPL', 'P'),
(53752, 'Burnham', 36.9266700744629, 0.644491974597037, -91.9574966430664, -1.60496108831314, 218, 29, 'PPL', 'P'),
(118969, 'Burnham', 41.6388893127441, 0.726735715380864, -87.5566711425781, -1.52815219352389, 218, 18, 'PPL', 'P'),
(126999, 'Burnham', 44.6927795410156, 0.780036154858683, -69.4280624389648, -1.21174828284014, 218, 26, 'PPL', 'P'),
(159678, 'Burnham', 40.6386108398438, 0.709277562591931, -77.5688934326172, -1.35383258752778, 218, 45, 'PPL', 'P'),
(177553, 'Burnham', 41.7991714477539, 0.729533166368911, -72.6186065673828, -1.26743378281121, 218, 8, 'PPL', 'P'),
(180336, 'Burnham', 37.8919410705566, 0.661339131652878, -121.14778137207, -2.11442766642888, 218, 6, 'PPL', 'P'),
(196110, 'Burnham', 48.5608291625977, 0.84754635638581, -109.885833740234, -1.91786960006617, 218, 31, 'PPL', 'P'),
(58837, 'Burnham (historical)', 32.1369400024414, 0.560895414558477, -89.8633270263672, -1.56841093340651, 218, 30, 'PPL', 'P'),
(45246, 'Burnham Hills', 39.1983299255371, 0.684139918483646, -77.148063659668, -1.34648772239939, 218, 25, 'PPL', 'P'),
(171812, 'Burnham Hollow', 43.4841690063477, 0.758941921654438, -73.1477813720703, -1.2766696254716, 218, 55, 'PPL', 'P'),
(19650, 'Burnham Woods', 33.3875007629395, 0.582721817325412, -84.5502777099609, -1.47568072951439, 218, 13, 'PPL', 'P'),
(45247, 'Burnham Woods', 39.2083282470703, 0.684314422114074, -77.1622161865234, -1.3467347305905, 218, 25, 'PPL', 'P'),
(147484, 'Burnhams', 42.3355598449707, 0.738894909969839, -79.3233337402344, -1.3844533474254, 218, 40, 'PPL', 'P'),
(19651, 'Burning Bush', 34.898609161377, 0.609095634232685, -85.2147216796875, -1.48727746448114, 218, 13, 'PPL', 'P'),
(77956, 'Burning Bush', 39.938060760498, 0.697050657132241, -78.5805587768555, -1.37148947871306, 218, 45, 'PPL', 'P'),
(35072, 'Burning Fork', 37.7333297729492, 0.658570842278768, -83.0233306884766, -1.44903047648597, 218, 21, 'PPL', 'P'),
(100374, 'Burning Knolls', 39.160831451416, 0.683485446645759, -78.1041717529297, -1.36317495663177, 218, 53, 'PPL', 'P'),
(45248, 'Burning Oaks', 38.4152793884277, 0.670473108401578, -76.7330627441406, -1.33924459002465, 218, 25, 'PPL', 'P'),
(80047, 'Burning Ridge', 33.7763900756836, 0.589509216258615, -79.0166702270508, -1.37910105942461, 218, 48, 'PPL', 'P'),
(35073, 'Burning Springs', 37.2491683959961, 0.650120632139947, -83.8213882446289, -1.46295920846124, 218, 21, 'PPL', 'P'),
(108428, 'Burning Springs', 38.9811096191406, 0.680348708934837, -81.3141708374023, -1.41920000964183, 218, 58, 'PPL', 'P'),
(118971, 'Burning Tree', 41.9458312988281, 0.73209286365064, -88.4066696166992, -1.54298746553423, 218, 18, 'PPL', 'P'),
(45249, 'Burning Tree Estates', 39.0077781677246, 0.680814162914355, -77.1561126708984, -1.34662820414689, 218, 25, 'PPL', 'P'),
(203213, 'Burningham Industrial', 40.5230598449707, 0.707260817277442, -111.888328552246, -1.95281972778987, 218, 52, 'PPL', 'P'),
(63312, 'Burningtown', 35.2311096191406, 0.614898861985049, -83.4711074829102, -1.45684565586286, 218, 33, 'PPL', 'P'),
(1242, 'Burningtree Estates', 34.5186080932617, 0.602463364432979, -86.938606262207, -1.51736492637047, 218, 2, 'PPL', 'P'),
(1243, 'Burningtree Mountain', 34.5180587768555, 0.602453777053055, -86.92138671875, -1.51706438864146, 218, 2, 'PPL', 'P'),
(130006, 'Burnips', 42.7319412231445, 0.745813070112565, -85.8394393920898, -1.49818084545809, 218, 27, 'PPL', 'P'),
(100375, 'Burnley', 38.167781829834, 0.666153461113469, -78.3402786254883, -1.36729579894451, 218, 53, 'PPL', 'P'),
(1244, 'Burns', 33.8383293151855, 0.590590259924106, -85.6066665649414, -1.49411819321517, 218, 2, 'PPL', 'P'),
(31926, 'Burns', 38.0902786254883, 0.664800775016791, -96.8861083984375, -1.69098159099686, 218, 20, 'PPL', 'P'),
(39586, 'Burns', 29.5733299255371, 0.516151977979192, -91.5327835083008, -1.59754844573502, 218, 22, 'PPL', 'P'),
(53753, 'Burns', 37.6047210693359, 0.656326196953995, -93.3088912963867, -1.62854737450743, 218, 29, 'PPL', 'P'),
(58838, 'Burns', 32.1352806091309, 0.560866452681623, -89.5477828979492, -1.56290364943028, 218, 30, 'PPL', 'P'),
(85441, 'Burns', 36.0533294677734, 0.629249305518941, -87.3125, -1.52389060314755, 218, 50, 'PPL', 'P'),
(92936, 'Burns', 33.5180587768555, 0.585000484533111, -94.2888870239258, -1.64565152660846, 218, 51, 'PPL', 'P'),
(118972, 'Burns', 40.4002799987793, 0.705117904706309, -88.9783325195313, -1.55296486540016, 218, 18, 'PPL', 'P'),
(147487, 'Burns', 42.4297218322754, 0.740538346678527, -77.7252807617188, -1.356562061329, 218, 40, 'PPL', 'P'),
(173376, 'Burns', 43.9449996948242, 0.766984934462586, -90.975830078125, -1.58782777459817, 218, 57, 'PPL', 'P'),
(177806, 'Burns', 33.0127792358398, 0.576181692899423, -111.833610534668, -1.95186471822297, 218, 5, 'PPL', 'P'),
(186470, 'Burns', 39.8738899230957, 0.695930664735809, -106.88500213623, -1.86549520827839, 218, 7, 'PPL', 'P'),
(194663, 'Burns', 48.6261100769043, 0.848685723279173, -116.393890380859, -2.03145661635135, 218, 17, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(196111, 'Burns', 47.378059387207, 0.82690312951217, -104.404716491699, -1.82220605739137, 218, 31, 'PPL', 'P'),
(200489, 'Burns', 43.5863914489746, 0.760726039847709, -119.053062438965, -2.07786792414233, 218, 43, 'PPL', 'P'),
(209340, 'Burns', 41.1927795410156, 0.718949631038881, -104.358612060547, -1.82140138326801, 218, 59, 'PPL', 'P'),
(58839, 'Burns (historical)', 32.1055603027344, 0.560347735480302, -89.2513885498047, -1.55773059217086, 218, 30, 'PPL', 'P'),
(29353, 'Burns City', 38.8224983215332, 0.677580419560727, -86.8869400024414, -1.51646318002537, 218, 19, 'PPL', 'P'),
(92937, 'Burns City', 33.5125007629395, 0.584903478890405, -97.0372161865234, -1.69361891942437, 218, 51, 'PPL', 'P'),
(45250, 'Burns Corner', 39.5275001525879, 0.68988502274522, -76.1711120605469, -1.32943670036211, 218, 25, 'PPL', 'P'),
(1246, 'Burns Crossroad', 33.6199989318848, 0.586779675878366, -85.9416732788086, -1.49996516338844, 218, 2, 'PPL', 'P'),
(100376, 'Burns Crossroads', 38.9094390869141, 0.679097822170826, -77.5447235107422, -1.35341074281111, 218, 53, 'PPL', 'P'),
(80048, 'Burns Down', 33.9258308410645, 0.592117449651212, -80.3713912963867, -1.40274540253066, 218, 48, 'PPL', 'P'),
(75275, 'Burns Flat', 35.3488883972168, 0.616954489451454, -99.1699981689453, -1.73084298724484, 218, 42, 'PPL', 'P'),
(122301, 'Burns Harbor', 41.6258316040039, 0.726507815370581, -87.1333312988281, -1.52076351939558, 218, 19, 'PPL', 'P'),
(130007, 'Burns Landing', 46.8274993896484, 0.817294044825, -87.728889465332, -1.53115797028821, 218, 27, 'PPL', 'P'),
(80049, 'Burns Mill', 34.7658309936523, 0.606778218031125, -83.0280609130859, -1.44911303447976, 218, 48, 'PPL', 'P'),
(1245, 'Burns Park', 33.9794387817383, 0.593053084721184, -85.9516677856445, -1.50013960043984, 218, 2, 'PPL', 'P'),
(85442, 'Burns Place', 35.7652816772461, 0.624221923171144, -86.3430633544922, -1.50697074179395, 218, 50, 'PPL', 'P'),
(196112, 'Burns Trailer Court', 48.5900001525879, 0.848055486207206, -109.230560302734, -1.90643292108093, 218, 31, 'PPL', 'P'),
(19652, 'Burnside', 31.9438896179199, 0.557526049726336, -81.1108322143555, -1.41565108117319, 218, 13, 'PPL', 'P'),
(35074, 'Burnside', 36.9888916015625, 0.645577945110544, -84.5999984741211, -1.47654852055559, 218, 21, 'PPL', 'P'),
(39587, 'Burnside', 30.1386108398438, 0.526017991132527, -90.9238891601563, -1.58692123456311, 218, 22, 'PPL', 'P'),
(58841, 'Burnside', 32.853328704834, 0.573398756139317, -89.1033325195313, -1.55514652696516, 218, 30, 'PPL', 'P'),
(100377, 'Burnside', 37.2130584716797, 0.64949039506798, -77.4333267211914, -1.3514665020573, 218, 53, 'PPL', 'P'),
(112989, 'Burnside', 42.3458290100098, 0.739074140711201, -94.1066665649414, -1.64247117963469, 218, 16, 'PPL', 'P'),
(118974, 'Burnside', 41.7202796936035, 0.728156245506312, -87.5980606079102, -1.52887457596958, 218, 18, 'PPL', 'P'),
(130009, 'Burnside', 43.2105598449707, 0.754166540924789, -83.0772171020508, -1.44997097182493, 218, 27, 'PPL', 'P'),
(147486, 'Burnside', 41.4566688537598, 0.723555368407092, -74.2091674804688, -1.29519430769808, 218, 40, 'PPL', 'P'),
(159680, 'Burnside', 40.8127784729004, 0.712317361239175, -78.7858276367188, -1.37507209616949, 218, 45, 'PPL', 'P'),
(177554, 'Burnside', 41.7797203063965, 0.729193679908953, -72.6074981689453, -1.26723990468385, 218, 8, 'PPL', 'P'),
(177807, 'Burnside', 35.7511100769043, 0.623974582084903, -109.623893737793, -1.91329788458088, 218, 5, 'PPL', 'P'),
(118975, 'Burnside (historical)', 40.7694396972656, 0.711560956910565, -90.2733306884766, -1.57556684725556, 218, 18, 'PPL', 'P'),
(200490, 'Burnside (historical)', 46.1752815246582, 0.805910695640593, -123.676940917969, -2.15856982781305, 218, 43, 'PPL', 'P'),
(45251, 'Burnside Acres', 39.4358291625977, 0.688285062141327, -77.720832824707, -1.35648443018322, 218, 25, 'PPL', 'P'),
(80050, 'Burnside East', 33.9625015258789, 0.592757473840185, -80.9499969482422, -1.41284397622619, 218, 48, 'PPL', 'P'),
(100378, 'Burnside Farms', 37.6261100769043, 0.656699505559797, -77.394172668457, -1.35078313492158, 218, 53, 'PPL', 'P'),
(19653, 'Burnside View', 31.9269409179688, 0.557230239108256, -81.0819396972656, -1.41514681162078, 218, 13, 'PPL', 'P'),
(108429, 'Burnsides', 38.1083297729492, 0.665115826973747, -80.208610534668, -1.39990434227977, 218, 58, 'PPL', 'P'),
(139739, 'Burnstad', 46.3855590820313, 0.809580731359804, -99.6322174072266, -1.73891023481891, 218, 34, 'PPL', 'P'),
(1247, 'Burnstown', 34.6430587768555, 0.604635438618047, -88.1188888549805, -1.53796474371835, 218, 2, 'PPL', 'P'),
(39588, 'Burnstown', 31.2822208404541, 0.545977751001912, -92.9347229003906, -1.62201690404039, 218, 22, 'PPL', 'P'),
(1248, 'Burnsville', 32.4744415283203, 0.566785927415569, -86.8916702270508, -1.51654573801916, 218, 2, 'PPL', 'P'),
(29354, 'Burnsville', 39.172779083252, 0.683693972159113, -85.7402801513672, -1.4964501902237, 218, 19, 'PPL', 'P'),
(58840, 'Burnsville', 34.8405609130859, 0.608082501174992, -88.3147201538086, -1.54138264466135, 218, 30, 'PPL', 'P'),
(63315, 'Burnsville', 35.9172210693359, 0.626873765826591, -82.3011093139648, -1.43642533557246, 218, 33, 'PPL', 'P'),
(100379, 'Burnsville', 38.1777801513672, 0.666327964743897, -79.6477813720703, -1.39011602685123, 218, 53, 'PPL', 'P'),
(108430, 'Burnsville', 38.8561096191406, 0.678167047369844, -80.6549987792969, -1.40769528689074, 218, 58, 'PPL', 'P'),
(134486, 'Burnsville', 44.7677803039551, 0.781345165113484, -93.2774963378906, -1.62799942911314, 218, 28, 'PPL', 'P'),
(130011, 'Burnt', 43.2366714477539, 0.754622274366329, -83.9033279418945, -1.46438932596662, 218, 27, 'PPL', 'P'),
(189984, 'Burnt Cabin (historical)', 39.0966682434082, 0.682365587407381, -117.764717102051, -2.05538205611046, 218, 39, 'PPL', 'P'),
(159683, 'Burnt Cabins', 40.0780601501465, 0.699494107432389, -77.8958282470703, -1.35953867647938, 218, 45, 'PPL', 'P'),
(7789, 'Burnt Cane', 35.014720916748, 0.611122166664181, -90.6377792358398, -1.58192767436116, 218, 4, 'PPL', 'P'),
(7790, 'Burnt Cane Crossing', 34.9900016784668, 0.610690734567588, -90.6141662597656, -1.58151555018247, 218, 4, 'PPL', 'P'),
(100380, 'Burnt Chimney', 37.1049995422363, 0.647604410963013, -79.8158264160156, -1.39304896615974, 218, 53, 'PPL', 'P'),
(63318, 'Burnt Chimney Corner', 35.2069396972656, 0.614477017268381, -82.2041702270508, -1.43473342933193, 218, 33, 'PPL', 'P'),
(80053, 'Burnt Church Crossroads', 32.8080596923828, 0.572608662822918, -80.4916687011719, -1.40484463925992, 218, 48, 'PPL', 'P'),
(1249, 'Burnt Corn', 31.5533294677734, 0.550709489179196, -87.1602783203125, -1.52123383364409, 218, 2, 'PPL', 'P'),
(19654, 'Burnt Creek', 33.9127807617188, 0.591889682798983, -84.1175003051758, -1.46812733887265, 218, 13, 'PPL', 'P'),
(196113, 'Burnt Creek (historical)', 46.021110534668, 0.803219904254204, -107.227783203125, -1.8714778665092, 218, 31, 'PPL', 'P'),
(100381, 'Burnt Factory', 39.1944389343262, 0.684072007875849, -78.0763931274414, -1.36269012815533, 218, 53, 'PPL', 'P'),
(108431, 'Burnt Factory', 39.6558303833008, 0.692124807801004, -78.2088928222656, -1.3650026840879, 218, 58, 'PPL', 'P'),
(80052, 'Burnt Factory (historical)', 34.6713905334473, 0.605129921053448, -79.6624984741211, -1.39037288873837, 218, 48, 'PPL', 'P'),
(203215, 'Burnt Flat', 40.6347198486328, 0.709209651984134, -111.61499786377, -1.94804920732922, 218, 52, 'PPL', 'P'),
(196114, 'Burnt Fork (historical)', 46.4605598449707, 0.810889741614605, -113.941673278809, -1.98865735394685, 218, 31, 'PPL', 'P'),
(19661, 'Burnt Fort', 30.9452800750732, 0.540097025261826, -81.8983306884766, -1.42939552240103, 218, 13, 'PPL', 'P'),
(45252, 'Burnt Hickory', 39.3033294677734, 0.685972506208757, -77.3661117553711, -1.35029337959712, 218, 25, 'PPL', 'P'),
(19655, 'Burnt Hickory Acres', 33.9672203063965, 0.592839832096896, -84.8572235107422, -1.48103794436319, 218, 13, 'PPL', 'P'),
(19656, 'Burnt Hickory Estates', 33.7961082458496, 0.589853363250481, -84.716667175293, -1.47858477352507, 218, 13, 'PPL', 'P'),
(19658, 'Burnt Hickory Farms', 34.0527801513672, 0.594333133099131, -84.8222198486328, -1.48042701520913, 218, 13, 'PPL', 'P'),
(19660, 'Burnt Hickory Ridge Estates', 34.0386085510254, 0.594085792012889, -84.8330612182617, -1.48061623280458, 218, 13, 'PPL', 'P'),
(7791, 'Burnt Hill', 35.878059387207, 0.626190265532822, -90.5152816772461, -1.57978968863804, 218, 4, 'PPL', 'P'),
(177555, 'Burnt Hill', 41.5741691589355, 0.725606135604507, -73.0344390869141, -1.27469142941389, 218, 8, 'PPL', 'P'),
(147488, 'Burnt Hills', 42.9097213745117, 0.748915919098616, -73.8955612182617, -1.2897208458677, 218, 40, 'PPL', 'P'),
(108432, 'Burnt House', 39.0463905334473, 0.6814880758282, -80.9875030517578, -1.41349858122213, 218, 58, 'PPL', 'P'),
(127001, 'Burnt Landing', 47.0863914489746, 0.821812563667511, -68.3680572509766, -1.19324770222152, 218, 26, 'PPL', 'P'),
(45254, 'Burnt Mill', 38.3305587768555, 0.668994454785338, -76.6388931274414, -1.33760102015791, 218, 25, 'PPL', 'P'),
(127002, 'Burnt Mill', 47.1413917541504, 0.82277250008243, -68.7041702270508, -1.1991139803127, 218, 26, 'PPL', 'P'),
(186471, 'Burnt Mill', 38.0516700744629, 0.664126928681973, -104.795829772949, -1.82903227189747, 218, 7, 'PPL', 'P'),
(45255, 'Burnt Mills', 39.0336112976074, 0.681265036086906, -77.0047225952148, -1.34398594887137, 218, 25, 'PPL', 'P'),
(63319, 'Burnt Mills', 36.3941688537598, 0.635198075024879, -76.2652816772461, -1.33108027022885, 218, 33, 'PPL', 'P'),
(77958, 'Burnt Mills', 39.8349990844727, 0.695251891552975, -75.6502838134766, -1.32034653261334, 218, 45, 'PPL', 'P'),
(144922, 'Burnt Mills', 40.6358299255371, 0.709229026481065, -74.6872177124023, -1.30353785823525, 218, 37, 'PPL', 'P'),
(45256, 'Burnt Mills Hills', 39.0327796936035, 0.681250521858965, -76.9944381713867, -1.3438064518139, 218, 25, 'PPL', 'P'),
(45257, 'Burnt Mills Knolls', 39.0313911437988, 0.681226287093045, -76.9880599975586, -1.34369513168033, 218, 25, 'PPL', 'P'),
(45258, 'Burnt Mills Manor', 39.0355606079102, 0.681299057969831, -77.0047225952148, -1.34398594887137, 218, 25, 'PPL', 'P'),
(45259, 'Burnt Mills Village', 39.0377807617188, 0.681337806963692, -77.0052795410156, -1.34399566940935, 218, 25, 'PPL', 'P'),
(19662, 'Burnt Mountain Estates', 34.5461082458496, 0.602943332640438, -84.3722229003906, -1.47257308683838, 218, 13, 'PPL', 'P'),
(26659, 'Burnt Prairie', 38.2516708374023, 0.667617600501767, -88.2613906860352, -1.54045186986037, 218, 18, 'PPL', 'P'),
(193413, 'Burnt Ranch', 40.8091697692871, 0.712254377479395, -123.47306060791, -2.15501144512254, 218, 6, 'PPL', 'P'),
(15384, 'Burnt Store Lakes', 26.8924999237061, 0.469362667760995, -82.0263900756836, -1.43163058034588, 218, 12, 'PPL', 'P'),
(15385, 'Burnt Store Marina', 26.764720916748, 0.467132503374649, -82.0511093139648, -1.43206201244247, 218, 12, 'PPL', 'P'),
(100382, 'Burnt Tree', 38.2983283996582, 0.668431928584086, -78.1791687011719, -1.36448390030755, 218, 53, 'PPL', 'P'),
(45261, 'Burnt Woods', 39.2777786254883, 0.685526559884223, -76.9974975585938, -1.34385984819376, 218, 25, 'PPL', 'P'),
(200491, 'Burnt Woods', 44.603889465332, 0.778484730365657, -123.621673583984, -2.15760523086623, 218, 43, 'PPL', 'P'),
(209341, 'Burntfork', 41.0291709899902, 0.716094123139071, -110.003608703613, -1.91992516095354, 218, 59, 'PPL', 'P'),
(1251, 'Burntout', 34.4508285522461, 0.601280388276766, -88.0227813720703, -1.53628735170576, 218, 2, 'PPL', 'P'),
(134489, 'Burntside', 47.8944396972656, 0.835915666115161, -91.9286117553711, -1.60445695191879, 218, 28, 'PPL', 'P'),
(134490, 'Burntside Lake', 47.8927803039551, 0.835886704238307, -92.0344390869141, -1.60630398729281, 218, 28, 'PPL', 'P'),
(203216, 'Burnugh Downs', 40.6477813720703, 0.709437618573445, -111.967781066895, -1.95420643576948, 218, 52, 'PPL', 'P'),
(7792, 'Burnville', 35.1886100769043, 0.614157105042435, -94.1888885498047, -1.64390622398808, 218, 4, 'PPL', 'P'),
(1252, 'Burnwell', 33.7077789306641, 0.588311725874461, -87.0875015258789, -1.51996363896217, 218, 2, 'PPL', 'P'),
(35076, 'Burnwell', 37.6288909912109, 0.656748041670663, -82.2233276367188, -1.43506778920679, 218, 21, 'PPL', 'P'),
(108434, 'Burnwell', 38.0525016784668, 0.664141442909914, -81.3755569458008, -1.42027139934836, 218, 58, 'PPL', 'P'),
(147489, 'Burnwood', 41.9466705322266, 0.732107511036636, -75.0608291625977, -1.31005860816431, 218, 40, 'PPL', 'P'),
(159689, 'Burnwood', 41.7861099243164, 0.7293051997796, -75.5072174072266, -1.31784955277528, 218, 45, 'PPL', 'P'),
(7793, 'Buroak', 35.934440612793, 0.627174303555606, -92.7663879394531, -1.61907890472582, 218, 4, 'PPL', 'P'),
(206929, 'Buroker', 46.1172218322754, 0.804897362845818, -118.217216491699, -2.06327966032309, 218, 56, 'PPL', 'P'),
(35075, 'Burr', 37.3419418334961, 0.651739834082715, -84.3050003051758, -1.47139983122014, 218, 21, 'PPL', 'P'),
(53756, 'Burr', 36.5019416809082, 0.637079065702802, -90.9861068725586, -1.58800713849759, 218, 29, 'PPL', 'P'),
(92938, 'Burr', 29.3077793121338, 0.511517245444614, -96.0072174072266, -1.67564204943412, 218, 51, 'PPL', 'P'),
(108433, 'Burr', 38.065559387207, 0.664369342920198, -80.1052780151367, -1.39810084958956, 218, 58, 'PPL', 'P'),
(134491, 'Burr', 44.7483291625977, 0.781005678653526, -96.35888671875, -1.68177983679842, 218, 28, 'PPL', 'P'),
(141405, 'Burr', 40.5355606079102, 0.707478996749746, -96.2997207641602, -1.68074719608574, 218, 35, 'PPL', 'P'),
(180337, 'Burr', 36.2452812194824, 0.632599495591234, -119.114166259766, -2.07893438700085, 218, 6, 'PPL', 'P'),
(206930, 'Burr', 46.4622192382813, 0.81091870349146, -118.629173278809, -2.07046966263409, 218, 56, 'PPL', 'P'),
(39589, 'Burr Ferry', 31.0661106109619, 0.542205915950033, -93.4958267211914, -1.63181001315888, 218, 22, 'PPL', 'P'),
(80054, 'Burr Hill', 32.9313888549805, 0.574761162773975, -80.5133285522461, -1.40522267497665, 218, 48, 'PPL', 'P'),
(100383, 'Burr Hill', 38.3438911437988, 0.669227148485584, -77.8600006103516, -1.35891336625543, 218, 53, 'PPL', 'P'),
(31927, 'Burr Oak', 39.8661117553711, 0.695794910099242, -98.3047180175781, -1.71574099965133, 218, 20, 'PPL', 'P'),
(71971, 'Burr Oak', 39.5508308410645, 0.690292220075893, -82.0638885498047, -1.43228505218377, 218, 41, 'PPL', 'P'),
(114774, 'Burr Oak', 43.4588890075684, 0.758500702440839, -91.8652801513672, -1.60335160690835, 218, 16, 'PPL', 'P'),
(122311, 'Burr Oak', 41.2563896179199, 0.720059836318308, -86.415283203125, -1.50823121593788, 218, 19, 'PPL', 'P'),
(130013, 'Burr Oak', 41.8472213745117, 0.730371795796177, -85.3186111450195, -1.48909067770932, 218, 27, 'PPL', 'P'),
(141406, 'Burr Oak', 41.125560760498, 0.717776441999674, -99.5591735839844, -1.73763537960509, 218, 35, 'PPL', 'P'),
(173379, 'Burr Oak', 44.0572204589844, 0.768943556286285, -91.054443359375, -1.58919983519178, 218, 57, 'PPL', 'P'),
(53755, 'Burr Oak (historical)', 39.0591697692871, 0.681711115569494, -90.7638931274414, -1.58412877700211, 218, 29, 'PPL', 'P'),
(71972, 'Burr Oaks Heights', 39.7113914489746, 0.693094531332929, -83.2744369506836, -1.45341310753386, 218, 41, 'PPL', 'P'),
(118978, 'Burr Ridge', 41.7488899230957, 0.728655588210702, -87.918327331543, -1.53446428478155, 218, 18, 'PPL', 'P'),
(124360, 'Burrage', 42.0291709899902, 0.733547415659014, -70.8561096191406, -1.23667240800803, 218, 23, 'PPL', 'P'),
(124361, 'Burrage Corner', 42.5208282470703, 0.742128453586386, -72.2249984741211, -1.26056402562129, 218, 23, 'PPL', 'P'),
(92939, 'Burrantown', 31.4925003051758, 0.549647820010636, -95.204719543457, -1.66163581947112, 218, 51, 'PPL', 'P'),
(180338, 'Burrel', 36.4883308410645, 0.636841511733567, -119.984169006348, -2.0941187994301, 218, 6, 'PPL', 'P'),
(159684, 'Burrell', 40.4169387817383, 0.705408655318319, -79.2663879394531, -1.38345945570658, 218, 45, 'PPL', 'P'),
(141407, 'Burress', 40.5813903808594, 0.708278877183152, -97.5013885498047, -1.70172025546039, 218, 35, 'PPL', 'P'),
(45263, 'Burrier Knob', 39.4466705322266, 0.688474279736777, -77.2055587768555, -1.34749120149813, 218, 25, 'PPL', 'P'),
(80055, 'Burris', 34.473331451416, 0.601673137958525, -82.4347229003906, -1.43875733258099, 218, 48, 'PPL', 'P'),
(191200, 'Burris', 33.5247192382813, 0.585116731514693, -101.779167175293, -1.7763815771466, 218, 51, 'PPL', 'P'),
(209342, 'Burris', 43.3641700744629, 0.756847545194172, -109.274169921875, -1.90719405252047, 218, 59, 'PPL', 'P'),
(19663, 'Burris Crossroads', 34.3300018310547, 0.599171564167586, -84.4875030517578, -1.47458510504193, 218, 13, 'PPL', 'P'),
(85443, 'Burristown', 36.3866691589355, 0.635067180657301, -85.5419387817383, -1.49298848028076, 218, 50, 'PPL', 'P'),
(45262, 'Burrisville', 39.0969390869141, 0.682370314518316, -76.0694427490234, -1.32766223612779, 218, 25, 'PPL', 'P'),
(177808, 'Burro John', 34.1302795410156, 0.595685752616782, -112.360282897949, -1.96105688504149, 218, 5, 'PPL', 'P'),
(19664, 'Burroughs', 31.9747200012207, 0.558064141424587, -81.2477798461914, -1.41804126825153, 218, 13, 'PPL', 'P'),
(92940, 'Burrow', 33.0073204040527, 0.576086418311425, -96.2931213378906, -1.6806320143686, 218, 51, 'PPL', 'P'),
(1253, 'Burrows', 34.5677795410156, 0.603321568094257, -86.5408325195313, -1.5104224648828, 218, 2, 'PPL', 'P'),
(122303, 'Burrows', 40.6766700744629, 0.709941821546825, -86.5074996948242, -1.50984069734267, 218, 19, 'PPL', 'P'),
(139062, 'Burrows', 40.5161094665527, 0.707139510289789, -93.7555618286133, -1.63634324596642, 218, 29, 'PPL', 'P'),
(159687, 'Burrows', 41.6936111450195, 0.727690791526794, -77.75, -1.35699349342559, 218, 45, 'PPL', 'P'),
(206931, 'Burrows', 47.0566711425781, 0.82129384646619, -124.035827636719, -2.16483358269692, 218, 56, 'PPL', 'P'),
(1254, 'Burrows Crossroads', 33.9127807617188, 0.591889682798983, -87.1600036621094, -1.52122903995412, 218, 2, 'PPL', 'P'),
(80056, 'Burrows Crossroads', 34.0852813720703, 0.594900386411317, -80.3919372558594, -1.40310399717144, 218, 48, 'PPL', 'P'),
(26661, 'Burrowsville', 39.7994384765625, 0.694631241860932, -88.633056640625, -1.54693866448553, 218, 18, 'PPL', 'P'),
(100384, 'Burrowsville', 37.2144393920898, 0.649514496675845, -77.0761108398438, -1.34523190878737, 218, 53, 'PPL', 'P'),
(70597, 'Burrs Mill', 39.8883285522461, 0.696182666353957, -74.6502838134766, -1.30289324009339, 218, 37, 'PPL', 'P'),
(147490, 'Burrs Mills', 43.9327812194824, 0.766771681838298, -75.8591690063477, -1.3239922669876, 218, 40, 'PPL', 'P'),
(45264, 'Burrsville', 38.8938903808594, 0.678826446055747, -75.7291717529297, -1.32172338689691, 218, 25, 'PPL', 'P'),
(31931, 'Burrton', 38.0238914489746, 0.663642100205524, -97.6694412231445, -1.70465332792695, 218, 20, 'PPL', 'P'),
(85444, 'Burrus Landing', 36.3666687011719, 0.634718106817419, -89.5047225952148, -1.56215210537066, 218, 50, 'PPL', 'P'),
(100387, 'Burruss Corner', 37.8930587768555, 0.661358639307863, -77.416389465332, -1.3511708911763, 218, 53, 'PPL', 'P'),
(85445, 'Burrville', 36.2938919067383, 0.633447912135506, -84.7516708374023, -1.47919570267913, 218, 50, 'PPL', 'P'),
(177557, 'Burrville', 41.8683280944824, 0.730740177553962, -73.0852813720703, -1.27557879468911, 218, 8, 'PPL', 'P'),
(192502, 'Burrville', 38.5708312988281, 0.673188001395832, -111.862777709961, -1.95237378146534, 218, 52, 'PPL', 'P'),
(39590, 'Burrwood (historical)', 28.9680595397949, 0.505588016883175, -89.3775024414063, -1.55993169481181, 218, 22, 'PPL', 'P'),
(134492, 'Burschville', 45.125, 0.787579824962441, -93.6361083984375, -1.63425839030705, 218, 28, 'PPL', 'P'),
(180339, 'Burson', 38.1838912963867, 0.666434624345554, -120.889442443848, -2.10991880154532, 218, 6, 'PPL', 'P'),
(100385, 'Burson Place', 36.665828704834, 0.639939433871601, -82.1777801513672, -1.4342728356214, 218, 53, 'PPL', 'P'),
(852, 'Burson Plan', 39.9674987792969, 0.697564447485545, -80.0500030517578, -1.39713611948468, 218, 45, 'PPL', 'P'),
(159688, 'Bursonville', 40.5377807617188, 0.707517745743607, -75.2405624389648, -1.31319554561231, 218, 45, 'PPL', 'P'),
(154541, 'Bursville', 40.6258316040039, 0.709054522850637, -84.7275009155273, -1.47877385796246, 218, 41, 'PPL', 'P'),
(58842, 'Burt', 34.4955596923828, 0.602061093950322, -89.3333282470703, -1.55916070967623, 218, 30, 'PPL', 'P'),
(75276, 'Burt', 34.4502792358398, 0.601270800896841, -99.0805587768555, -1.72928197537189, 218, 42, 'PPL', 'P'),
(85447, 'Burt', 35.7691688537598, 0.624289767199914, -86.1294403076172, -1.50324231626784, 218, 50, 'PPL', 'P'),
(114778, 'Burt', 43.1974983215332, 0.753938574335479, -94.2194366455078, -1.64443938883831, 218, 16, 'PPL', 'P'),
(118980, 'Burt', 40.3380584716797, 0.704031934192802, -89.3683319091797, -1.5597716388303, 218, 18, 'PPL', 'P'),
(130014, 'Burt', 43.2366714477539, 0.754622274366329, -83.9063873291016, -1.46444272234647, 218, 27, 'PPL', 'P'),
(147491, 'Burt', 43.3163909912109, 0.756013642877841, -78.7141723632813, -1.37382147572158, 218, 40, 'PPL', 'P'),
(198076, 'Burt', 46.3652801513672, 0.809226797250932, -102.154716491699, -1.7829361492215, 218, 34, 'PPL', 'P'),
(206932, 'Burt', 46.666389465332, 0.81448214618804, -123.459167480469, -2.15476896430529, 218, 56, 'PPL', 'P'),
(100386, 'Burt (historical)', 36.9099998474121, 0.644201024247946, -77.182502746582, -1.34708879785742, 218, 53, 'PPL', 'P'),
(130017, 'Burt Lake', 45.4408302307129, 0.793092102365714, -84.7111129760742, -1.47848783446139, 218, 27, 'PPL', 'P'),
(45267, 'Burtner', 39.5238914489746, 0.689822038985439, -77.7202835083008, -1.3564748428033, 218, 25, 'PPL', 'P'),
(7796, 'Burton', 35.9208297729492, 0.626936749586371, -89.8555603027344, -1.56827537850703, 218, 4, 'PPL', 'P'),
(26662, 'Burton', 39.9047203063965, 0.696468756434059, -91.248893737793, -1.59259363452692, 218, 18, 'PPL', 'P'),
(35077, 'Burton', 37.3594398498535, 0.65204523208072, -82.7238922119141, -1.4438042891628, 218, 21, 'PPL', 'P'),
(53759, 'Burton', 39.2147216796875, 0.684426008563748, -92.6119384765625, -1.61638325307044, 218, 29, 'PPL', 'P'),
(58843, 'Burton', 34.6380615234375, 0.604548220092347, -88.3394393920898, -1.54181407675795, 218, 30, 'PPL', 'P'),
(63321, 'Burton', 36.0402793884277, 0.629021538666712, -78.8191680908203, -1.37565399686767, 218, 33, 'PPL', 'P'),
(80057, 'Burton', 32.4355583190918, 0.566107287390789, -80.7241668701172, -1.40890249781287, 218, 48, 'PPL', 'P'),
(85446, 'Burton', 36.0625, 0.629409361500455, -85.6516723632813, -1.49490369257869, 218, 50, 'PPL', 'P'),
(92942, 'Burton', 32.2933311462402, 0.563624954938727, -97.4441680908203, -1.70072157005161, 218, 51, 'PPL', 'P'),
(108435, 'Burton', 39.663890838623, 0.692265489285587, -80.4308319091797, -1.4037828369333, 218, 58, 'PPL', 'P'),
(130020, 'Burton', 43.0077781677246, 0.750627332994129, -84.2847213745117, -1.47104589711127, 218, 27, 'PPL', 'P'),
(141410, 'Burton', 42.9116706848145, 0.748949940981542, -99.5913925170898, -1.73819770606926, 218, 35, 'PPL', 'P'),
(154542, 'Burton', 41.4705581665039, 0.723797782645316, -81.1452789306641, -1.41625228978927, 218, 41, 'PPL', 'P'),
(173380, 'Burton', 42.7177810668945, 0.745565928763406, -90.8172225952148, -1.58505955180309, 218, 57, 'PPL', 'P'),
(177809, 'Burton', 34.332218170166, 0.59921024658242, -110.147216796875, -1.92243159501347, 218, 5, 'PPL', 'P'),
(190962, 'Burton', 36.7983283996582, 0.642251989804171, -102.160827636719, -1.78304280882316, 218, 42, 'PPL', 'P'),
(194664, 'Burton', 43.7975006103516, 0.764410589794861, -111.857223510742, -1.95227684240166, 218, 17, 'PPL', 'P'),
(206934, 'Burton', 47.3891716003418, 0.827097074218555, -122.459442138672, -2.13732046547531, 218, 56, 'PPL', 'P'),
(39591, 'Burton (historical)', 30.0116691589355, 0.523802440842663, -90.8716735839844, -1.58600990083808, 218, 22, 'PPL', 'P'),
(196115, 'Burton (historical)', 47.8855590820313, 0.835760670139719, -112.111106872559, -1.95670794298139, 218, 31, 'PPL', 'P'),
(13462, 'Burton Acres', 38.5763893127441, 0.673285007038538, -75.2627792358398, -1.31358330186703, 218, 10, 'PPL', 'P'),
(203219, 'Burton Addition', 40.6988906860352, 0.710329644380567, -111.891387939453, -1.95287312416973, 218, 52, 'PPL', 'P'),
(154543, 'Burton City', 40.8447189331055, 0.712874827434356, -81.7041702270508, -1.42600678307196, 218, 41, 'PPL', 'P'),
(127003, 'Burton Corner', 44.8333282470703, 0.782489192538755, -69.4763870239258, -1.21259170595737, 218, 26, 'PPL', 'P'),
(85448, 'Burton Estates', 36.1527786254883, 0.6309850207594, -85.4622192382813, -1.49159711176925, 218, 50, 'PPL', 'P'),
(63322, 'Burton Hills', 35.2825012207031, 0.615795814640188, -81.1402816772461, -1.41616507126357, 218, 33, 'PPL', 'P'),
(206935, 'Burton Homes', 45.6433296203613, 0.796626383448359, -122.594436645508, -2.1396765640917, 218, 56, 'PPL', 'P'),
(19665, 'Burton Junction (historical)', 34.8033294677734, 0.607432689869012, -83.4280624389648, -1.45609437811935, 218, 13, 'PPL', 'P'),
(154544, 'Burton Lake', 41.4286117553711, 0.723065679661653, -81.1869430541992, -1.41697946592492, 218, 41, 'PPL', 'P'),
(39592, 'Burton Landing', 30.1019401550293, 0.525377966943554, -93.3291702270508, -1.6289013086163, 218, 22, 'PPL', 'P'),
(39593, 'Burton Lane', 30.0244407653809, 0.524025347425902, -90.8405609130859, -1.58546688229182, 218, 22, 'PPL', 'P'),
(7794, 'Burton Mill', 33.1738891601563, 0.578993591536383, -93.6350021362305, -1.63423908238915, 218, 4, 'PPL', 'P'),
(85449, 'Burton Mill', 35.6708297729492, 0.622573426456385, -84.2694396972656, -1.4707791815281, 218, 50, 'PPL', 'P'),
(180340, 'Burton Mill', 35.500560760498, 0.619601671574993, -118.406112670898, -2.06657652059455, 218, 6, 'PPL', 'P'),
(154545, 'Burton Station', 41.4891700744629, 0.724122621719278, -81.1005630493164, -1.41547185043182, 218, 41, 'PPL', 'P'),
(118981, 'Burton View', 40.1708297729492, 0.70111324279613, -89.4847183227539, -1.56180296495175, 218, 18, 'PPL', 'P'),
(100388, 'Burtons', 36.8852806091309, 0.643769592151353, -76.1961135864258, -1.32987305930671, 218, 53, 'PPL', 'P'),
(80058, 'Burtons (historical)', 33.1575012207031, 0.578707568035309, -79.8375015258789, -1.39342726819258, 218, 48, 'PPL', 'P'),
(118983, 'Burtons Bridge', 42.2797203063965, 0.737920326168924, -88.228889465332, -1.53988461654818, 218, 18, 'PPL', 'P'),
(100395, 'Burtons Corner', 37.9288902282715, 0.661984016110841, -76.5541687011719, -1.33612229996264, 218, 53, 'PPL', 'P'),
(19667, 'Burtons Ferry Landing', 32.9366683959961, 0.574853308147691, -81.5041732788086, -1.42251617783119, 218, 13, 'PPL', 'P'),
(100389, 'Burtons Ford', 36.8913917541504, 0.643876251753011, -82.3397216796875, -1.4370992484863, 218, 53, 'PPL', 'P'),
(100390, 'Burtons Shop', 37.1300010681152, 0.648040769907622, -81.4416732788086, -1.4214253470487, 218, 53, 'PPL', 'P'),
(45265, 'Burtonsville', 39.1111106872559, 0.682617655604557, -76.9327774047852, -1.3427302684174, 218, 25, 'PPL', 'P'),
(147492, 'Burtonsville', 42.8050003051758, 0.747088191642495, -74.2597198486328, -1.29607661296723, 218, 40, 'PPL', 'P'),
(58844, 'Burtonton (historical)', 31.9930591583252, 0.558384220098101, -90.6958312988281, -1.58294087399788, 218, 30, 'PPL', 'P'),
(35078, 'Burtonville', 38.4958305358887, 0.67187899114103, -83.5733337402344, -1.45862984063516, 218, 21, 'PPL', 'P'),
(53761, 'Burtonville', 36.7516708374023, 0.641437661721852, -93.9702835083008, -1.64009084625238, 218, 29, 'PPL', 'P'),
(71973, 'Burtonville', 39.4049987792969, 0.687746970443077, -83.8144378662109, -1.46283790147359, 218, 41, 'PPL', 'P'),
(100391, 'Burtonville', 38.2730598449707, 0.667990909107569, -78.3491668701172, -1.36745092807801, 218, 53, 'PPL', 'P'),
(134494, 'Burtrum', 45.8675003051758, 0.800538899984821, -94.6847229003906, -1.65256016595029, 218, 28, 'PPL', 'P'),
(100392, 'Burts', 37.1477813720703, 0.648351094753644, -76.4627838134766, -1.33452733278579, 218, 53, 'PPL', 'P'),
(19668, 'Burtsboro', 34.478328704834, 0.601760356484225, -84.0897216796875, -1.4676425103962, 218, 13, 'PPL', 'P'),
(7795, 'Burtsell', 33.9550018310547, 0.592626579472608, -93.2897186279297, -1.62821274831646, 218, 4, 'PPL', 'P'),
(124362, 'Burtts Crossing', 42.6030616760254, 0.743563697676857, -71.1916732788086, -1.24252909871928, 218, 23, 'PPL', 'P'),
(39594, 'Burtville', 30.3322200775146, 0.52939710979216, -91.1344375610352, -1.59059599739325, 218, 22, 'PPL', 'P'),
(53762, 'Burtville', 38.6763916015625, 0.675030376237948, -93.6183319091797, -1.63394813204005, 218, 29, 'PPL', 'P'),
(159690, 'Burtville', 41.788890838623, 0.729353735890466, -78.2052764892578, -1.36493956717006, 218, 45, 'PPL', 'P'),
(19669, 'Burwell', 33.5791702270508, 0.586067080549688, -85.2063903808594, -1.48713205588562, 218, 13, 'PPL', 'P'),
(75277, 'Burwell', 34.1858291625977, 0.596655276411625, -95.1511077880859, -1.66070011782212, 218, 42, 'PPL', 'P'),
(100393, 'Burwell', 37.2911109924316, 0.650852668544582, -80.0586090087891, -1.39728632177016, 218, 53, 'PPL', 'P'),
(134496, 'Burwell', 47.7452812194824, 0.833312359570582, -96.5027770996094, -1.68429119770637, 218, 28, 'PPL', 'P'),
(141411, 'Burwell', 41.7816696166992, 0.729227701791879, -99.1327819824219, -1.73019344225497, 218, 35, 'PPL', 'P'),
(100394, 'Burwell Bay', 37.0552787780762, 0.64673661992181, -76.6686096191406, -1.3381196707802, 218, 53, 'PPL', 'P'),
(13463, 'Burwood', 39.0927810668945, 0.682297743378611, -75.5622177124023, -1.3188094891902, 218, 10, 'PPL', 'P'),
(85450, 'Burwood', 35.8125, 0.625046038370469, -86.9833297729492, -1.51814549888598, 218, 50, 'PPL', 'P'),
(13464, 'Burwood Farms', 39.0927810668945, 0.682297743378611, -75.5622177124023, -1.3188094891902, 218, 10, 'PPL', 'P'),
(63324, 'Busbee', 35.4983291625977, 0.619562722844051, -82.5180587768555, -1.44021181801033, 218, 33, 'PPL', 'P'),
(31938, 'Busby', 37.4694404602051, 0.653965104910558, -96.0441665649414, -1.67628693389208, 218, 20, 'PPL', 'P'),
(85451, 'Busby', 35.1066703796387, 0.612726987537062, -87.4097213745117, -1.52558743623609, 218, 50, 'PPL', 'P'),
(191201, 'Busby', 32.6227798461914, 0.569374919469289, -100.420562744141, -1.75266945659081, 218, 51, 'PPL', 'P'),
(196116, 'Busby', 45.5372200012207, 0.794774421226317, -106.955001831055, -1.86671693342847, 218, 31, 'PPL', 'P'),
(206936, 'Busby', 46.6925010681152, 0.81493787962958, -117.149436950684, -2.04464339164693, 218, 56, 'PPL', 'P'),
(7797, 'Busch', 36.464168548584, 0.636419800174952, -93.8305587768555, -1.63765218964219, 218, 4, 'PPL', 'P'),
(53763, 'Busch', 39.579719543457, 0.690796423049272, -91.192497253418, -1.59160933018803, 218, 29, 'PPL', 'P'),
(196117, 'Busch', 45.8036117553711, 0.799423834436405, -111.082221984863, -1.9387505140671, 218, 31, 'PPL', 'P'),
(71974, 'Busenbark', 39.4655609130859, 0.688803979079729, -84.4855575561523, -1.47455114973803, 218, 41, 'PPL', 'P'),
(26664, 'Busenville', 39.9872207641602, 0.697908661056438, -87.6755599975586, -1.53022719548723, 218, 18, 'PPL', 'P'),
(58845, 'Busey', 33.5586090087891, 0.5857082195928, -90.8633270263672, -1.58586422592646, 218, 30, 'PPL', 'P'),
(1256, 'Bush', 33.4483299255371, 0.583783486493972, -86.9830627441406, -1.51814083835407, 218, 2, 'PPL', 'P'),
(26665, 'Bush', 37.8433303833008, 0.660490715108606, -89.1311111450195, -1.5556313554416, 218, 18, 'PPL', 'P'),
(35079, 'Bush', 37.0924987792969, 0.647386231490708, -83.8702774047852, -1.46381248527451, 218, 21, 'PPL', 'P'),
(39595, 'Bush', 30.6086101531982, 0.534221026632675, -89.9000015258789, -1.56905102417451, 218, 22, 'PPL', 'P'),
(45266, 'Bush', 39.4736099243164, 0.688944460827231, -76.2644424438477, -1.33106562284285, 218, 25, 'PPL', 'P'),
(58846, 'Bush', 31.8619403839111, 0.556095765773395, -89.9866714477539, -1.57056369967368, 218, 30, 'PPL', 'P'),
(180341, 'Bush', 34.1500015258789, 0.596029966187674, -115.702217102051, -2.01938464028808, 218, 6, 'PPL', 'P'),
(206937, 'Bush', 46.9791717529297, 0.819941226948539, -122.877777099609, -2.14462178791987, 218, 56, 'PPL', 'P'),
(80059, 'Bush (historical)', 33.264720916748, 0.58057890475428, -81.7750015258789, -1.42724302244997, 218, 48, 'PPL', 'P'),
(159691, 'Bush Addition', 40.9047203063965, 0.713922048954002, -77.7891693115234, -1.35767712687741, 218, 45, 'PPL', 'P'),
(31932, 'Bush City', 38.211109161377, 0.666909665704997, -95.1444396972656, -1.66058373768248, 218, 20, 'PPL', 'P'),
(147493, 'Bush Corner', 42.9044418334961, 0.7488237737249, -77.5205612182617, -1.35298903125249, 218, 40, 'PPL', 'P'),
(606, 'Bush Creek Estates', 39.3652801513672, 0.687053749611329, -77.2763900756836, -1.34872744087615, 218, 25, 'PPL', 'P'),
(85452, 'Bush Grove', 35.2513885498047, 0.615252796093921, -89.774169921875, -1.56685484838158, 218, 50, 'PPL', 'P'),
(100396, 'Bush Hill Woods', 38.788890838623, 0.676993858330637, -77.1230621337891, -1.34605136345478, 218, 53, 'PPL', 'P'),
(134498, 'Bush Landing', 47.3316688537598, 0.826093461961758, -95.4730606079102, -1.66631925456413, 218, 28, 'PPL', 'P'),
(13465, 'Bush Manor', 39.2077789306641, 0.684304834734149, -75.563606262207, -1.31883372395612, 218, 10, 'PPL', 'P'),
(100397, 'Bush Mill', 36.7555618286133, 0.641505572329649, -82.4355621337891, -1.43877197996698, 218, 53, 'PPL', 'P'),
(100398, 'Bush Park (historical)', 37.6358299255371, 0.656869148921235, -78.1397171020508, -1.36379534000771, 218, 53, 'PPL', 'P'),
(159692, 'Bush Patch', 41.3736114501953, 0.722105743246734, -75.746940612793, -1.32203351200585, 218, 45, 'PPL', 'P'),
(177810, 'Bush Pit', 33.7513885498047, 0.589072857314006, -113.768608093262, -1.98563679663848, 218, 5, 'PPL', 'P'),
(45275, 'Bush River', 39.4411087036133, 0.688377207515044, -76.2377777099609, -1.33060023544236, 218, 25, 'PPL', 'P'),
(80060, 'Bush River', 34.3216705322266, 0.599026155572068, -81.7608337402344, -1.42699574794276, 218, 48, 'PPL', 'P'),
(45268, 'Bush River Mobile Home Park', 39.4486083984375, 0.688508101882621, -76.2324981689453, -1.33050809006864, 218, 25, 'PPL', 'P'),
(53764, 'Bushburg', 38.3052787780762, 0.66855323557174, -90.3763885498047, -1.57736554625579, 218, 29, 'PPL', 'P'),
(39596, 'Bushes', 32.2172203063965, 0.562296570186995, -91.6161117553711, -1.59900279800631, 218, 22, 'PPL', 'P'),
(147494, 'Bushes Landing', 43.7775001525879, 0.764061515954979, -75.4094390869141, -1.31614299914876, 218, 40, 'PPL', 'P'),
(45269, 'Bushey Heights', 39.4333305358887, 0.688241452878477, -77.0197219848633, -1.34424773760653, 218, 25, 'PPL', 'P'),
(85453, 'Bushing (historical)', 36.2480583190918, 0.632647965123073, -85.2505569458008, -1.48790290786314, 218, 50, 'PPL', 'P'),
(159693, 'Bushkill', 41.0933303833008, 0.717213915798422, -75.0022201538086, -1.30903568798961, 218, 45, 'PPL', 'P'),
(159694, 'Bushkill Center', 40.7936096191406, 0.711982801627234, -75.3249969482422, -1.31466920580151, 218, 45, 'PPL', 'P'),
(191202, 'Bushland', 35.1919403076172, 0.614215228533226, -102.064170837402, -1.78135582943065, 218, 51, 'PPL', 'P'),
(177811, 'Bushman Acres', 35.024169921875, 0.611287082914684, -110.679443359375, -1.93172070089567, 218, 5, 'PPL', 'P'),
(15386, 'Bushnell', 28.6647205352783, 0.500293752504638, -82.1130599975586, -1.43314325584504, 218, 12, 'PPL', 'P'),
(19670, 'Bushnell', 31.5599994659424, 0.550825902608347, -82.9599990844727, -1.44792513147553, 218, 13, 'PPL', 'P'),
(31933, 'Bushnell', 37.3616714477539, 0.652084180811662, -97.1597213745117, -1.69575703830554, 218, 20, 'PPL', 'P'),
(53765, 'Bushnell', 37.496940612793, 0.654445073118017, -94.1508331298828, -1.64324203161221, 218, 29, 'PPL', 'P'),
(118984, 'Bushnell', 40.5527801513672, 0.707779534478762, -90.5061111450195, -1.57962963265653, 218, 18, 'PPL', 'P'),
(154547, 'Bushnell', 41.8627815246582, 0.730643371648337, -80.5716705322266, -1.40624093461945, 218, 41, 'PPL', 'P'),
(169944, 'Bushnell', 44.3286094665527, 0.773680188022072, -96.642219543457, -1.68672492746854, 218, 49, 'PPL', 'P'),
(199211, 'Bushnell', 41.2322196960449, 0.719637991601639, -103.891387939453, -1.81324678401018, 218, 35, 'PPL', 'P'),
(147495, 'Bushnell Basin', 43.059440612793, 0.751529012760202, -77.4744415283203, -1.35218409081302, 218, 40, 'PPL', 'P'),
(147496, 'Bushnellsville', 42.1533317565918, 0.735714429838012, -74.415283203125, -1.29879170569856, 218, 40, 'PPL', 'P'),
(31934, 'Bushong', 38.6430587768555, 0.674448608697821, -96.2569427490234, -1.68000057887414, 218, 20, 'PPL', 'P'),
(29356, 'Bushrod', 38.9688911437988, 0.680135456310549, -87.10888671875, -1.52033688098895, 218, 19, 'PPL', 'P'),
(45270, 'Bushs Corner', 39.6719398498535, 0.692405971033089, -76.4094390869141, -1.3335962916687, 218, 25, 'PPL', 'P'),
(118986, 'Bushs Corners', 42.2949981689453, 0.738186975173069, -87.9833297729492, -1.53559879140592, 218, 18, 'PPL', 'P'),
(26666, 'Bushton', 39.5922203063965, 0.691014602521577, -88.1386108398438, -1.53830895728924, 218, 18, 'PPL', 'P'),
(31935, 'Bushton', 38.5125007629395, 0.672169941490122, -98.3949966430664, -1.71731665891028, 218, 20, 'PPL', 'P'),
(915, 'Bushtown', 35.0494384765625, 0.611728102391201, -85.2675018310547, -1.4881986519022, 218, 50, 'PPL', 'P'),
(35084, 'Bushtown', 37.7305603027344, 0.658522505904983, -84.7291717529297, -1.4788030195764, 218, 21, 'PPL', 'P'),
(7798, 'Bushtown (historical)', 35.4736099243164, 0.619131290747458, -93.5361099243164, -1.63251308768667, 218, 4, 'PPL', 'P'),
(39597, 'Bushville', 30.3711109161377, 0.530075882974994, -91.8969421386719, -1.60390421283454, 218, 22, 'PPL', 'P'),
(114780, 'Bushville', 40.8566703796387, 0.713083419526736, -94.7380599975586, -1.65349107390933, 218, 16, 'PPL', 'P'),
(147499, 'Bushville', 41.7150001525879, 0.728064100132596, -74.7463912963867, -1.30457063210598, 218, 40, 'PPL', 'P'),
(147500, 'Bushwick', 40.6941719055176, 0.710247286123857, -73.9191665649414, -1.29013283688833, 218, 40, 'PPL', 'P'),
(147501, 'Bushwick Junction', 40.7152786254883, 0.710615667881642, -73.9086074829102, -1.2899485461409, 218, 40, 'PPL', 'P'),
(45271, 'Bushwood', 38.2963905334473, 0.668398106438242, -76.7794418334961, -1.34005405783798, 218, 25, 'PPL', 'P'),
(100399, 'Bushwood (historical)', 37.9249992370605, 0.661916105503044, -76.7977828979492, -1.34037416980101, 218, 53, 'PPL', 'P'),
(45272, 'Bushwood Wharf', 38.2838897705078, 0.668179926965938, -76.8022232055664, -1.34045166778873, 218, 25, 'PPL', 'P'),
(100404, 'Bushy', 37.5763893127441, 0.655831714518594, -76.4100036621094, -1.33360614536473, 218, 53, 'PPL', 'P'),
(100400, 'Bushy Acres', 38.8377799987793, 0.677847135143898, -77.5947189331055, -1.35428332754227, 218, 53, 'PPL', 'P'),
(92943, 'Bushy Creek Colonia', 28.6989994049072, 0.500892031643524, -99.8310012817383, -1.74237966792901, 218, 51, 'PPL', 'P'),
(63325, 'Bushy Fork', 36.3077812194824, 0.63369032637373, -79.086669921875, -1.38032278457469, 218, 33, 'PPL', 'P'),
(45273, 'Bushy Park Estates', 39.3138885498047, 0.68615679695619, -77.0555572509766, -1.34487318098853, 218, 25, 'PPL', 'P'),
(75278, 'Bushyhead', 36.4613914489746, 0.636371330643113, -95.4938888549805, -1.66668277605293, 218, 42, 'PPL', 'P'),
(45274, 'Busic', 39.1388893127441, 0.683102484081006, -75.8244400024414, -1.3233861315235, 218, 25, 'PPL', 'P'),
(63327, 'Busick', 35.769718170166, 0.624299354579838, -82.1830596923828, -1.43436498099512, 218, 33, 'PPL', 'P'),
(154548, 'Business Corner', 41.5736083984375, 0.725596348487501, -83.7377777099609, -1.46149992934194, 218, 41, 'PPL', 'P'),
(114781, 'Business Corners (historical)', 40.8544387817383, 0.713044470795794, -92.2436065673828, -1.60995464851509, 218, 16, 'PPL', 'P'),
(71975, 'Businessburg', 39.9313888549805, 0.696934210413578, -80.8505630493164, -1.41110852730184, 218, 41, 'PPL', 'P'),
(35081, 'Buskirk', 37.6194381713867, 0.656583058841133, -82.1688919067383, -1.4341177064879, 218, 21, 'PPL', 'P'),
(147502, 'Buskirk', 42.9536094665527, 0.74968191080715, -73.4347229003906, -1.2816776999015, 218, 40, 'PPL', 'P'),
(173381, 'Buss''s Corners', 43.1661109924316, 0.753390762099249, -89.2072219848633, -1.55695974019334, 218, 57, 'PPL', 'P'),
(85454, 'Bussell', 36.1069412231445, 0.630185007167941, -85.5944366455078, -1.4939047408538, 218, 50, 'PPL', 'P'),
(85455, 'Busselltown', 35.7752799987793, 0.624396426801572, -84.2344436645508, -1.47016838553209, 218, 50, 'PPL', 'P'),
(85456, 'Busseltown', 35.6725006103516, 0.622602588070322, -88.0355606079102, -1.53651039144705, 218, 50, 'PPL', 'P'),
(29357, 'Busseron', 38.8355598449707, 0.677808386150037, -87.4491729736328, -1.52627599653593, 218, 19, 'PPL', 'P'),
(7799, 'Bussey', 33.1555595397949, 0.578673679310437, -93.4561080932617, -1.63111679232714, 218, 4, 'PPL', 'P'),
(19671, 'Bussey', 33.7369384765625, 0.588820655958775, -82.3108291625977, -1.4365949789339, 218, 13, 'PPL', 'P'),
(114782, 'Bussey', 41.2044410705566, 0.719153163125191, -92.8824996948242, -1.62110543715731, 218, 16, 'PPL', 'P'),
(19672, 'Bussey Crossroads', 32.8769416809082, 0.573810880318007, -84.644172668457, -1.47731950569117, 218, 13, 'PPL', 'P'),
(35082, 'Busseyville', 38.0708312988281, 0.66446135513586, -82.6705627441406, -1.44287351436181, 218, 21, 'PPL', 'P'),
(173382, 'Busseyville', 42.898609161377, 0.748721974392231, -88.9877777099609, -1.55312971507164, 218, 57, 'PPL', 'P'),
(134499, 'Bussler Trailer Court', 44.5499992370605, 0.777544168447668, -94.3625030517578, -1.64693636867637, 218, 28, 'PPL', 'P'),
(92944, 'Bustamante', 27.000560760498, 0.471248685155475, -99.1116714477539, -1.72982499391816, 218, 51, 'PPL', 'P'),
(92945, 'Bustamante Colonia', 26.1040000915527, 0.455600749538496, -97.8789978027344, -1.70831078021001, 218, 51, 'PPL', 'P'),
(196118, 'Busteed', 45.9416694641113, 0.801833396011682, -109.348327636719, -1.90848834881025, 218, 31, 'PPL', 'P'),
(100401, 'Busthead', 37.1072196960449, 0.647643159956873, -81.6983337402344, -1.42590491716026, 218, 53, 'PPL', 'P'),
(147503, 'Busti', 42.0380592346191, 0.733702544792511, -79.2836074829102, -1.3837599934356, 218, 40, 'PPL', 'P'),
(127004, 'Bustins Island', 43.7988891601563, 0.764434824560781, -70.0702819824219, -1.22295712839412, 218, 26, 'PPL', 'P'),
(100402, 'Bustleburg', 37.8919410705566, 0.661339131652878, -79.3647232055664, -1.38517572987108, 218, 53, 'PPL', 'P'),
(144923, 'Bustleton', 40.0880584716797, 0.699668611062817, -74.7830581665039, -1.30521058971593, 218, 37, 'PPL', 'P'),
(159696, 'Bustleton', 40.0825004577637, 0.69957160542011, -75.0319366455078, -1.3095543386119, 218, 45, 'PPL', 'P'),
(194665, 'Buswell (historical)', 46.8330612182617, 0.817391117046734, -117.027221679688, -2.04251033277184, 218, 17, 'PPL', 'P'),
(35083, 'Busy', 37.2783317565918, 0.650629628803288, -83.2905578613281, -1.45369447050302, 218, 21, 'PPL', 'P'),
(100403, 'Busy Bee Corner', 36.6944389343262, 0.640438776575991, -78.2430572509766, -1.36559896585596, 218, 53, 'PPL', 'P'),
(58847, 'Busy Corner', 31.2786102294922, 0.545914733952618, -90.8633270263672, -1.58586422592646, 218, 30, 'PPL', 'P'),
(85457, 'Busy Corner', 35.5283317565918, 0.620086366893387, -86.158332824707, -1.50374658582024, 218, 50, 'PPL', 'P'),
(154549, 'Busy Corners', 41.4247207641602, 0.722997769053856, -83.3000030517578, -1.4538593201745, 218, 41, 'PPL', 'P'),
(180343, 'Butano Park', 37.2333297729492, 0.649844196018797, -122.326110839844, -2.1349933953148, 218, 6, 'PPL', 'P'),
(53766, 'Butcher', 37.9599990844727, 0.662526968078081, -93.4902801513672, -1.63171320725326, 218, 29, 'PPL', 'P'),
(85458, 'Butcher (historical)', 36.3397216796875, 0.634247792568911, -82.9263916015625, -1.44733857024544, 218, 50, 'PPL', 'P'),
(147505, 'Butcher Corner', 42.3502807617188, 0.739151838436004, -77.5774993896484, -1.35398278981326, 218, 40, 'PPL', 'P'),
(45278, 'Butchers Hill', 39.2894401550293, 0.685730091970533, -76.5886077880859, -1.33672337542067, 218, 25, 'PPL', 'P'),
(108437, 'Butchersville', 39.086109161377, 0.682181296659948, -80.477783203125, -1.40460229160072, 218, 58, 'PPL', 'P'),
(35086, 'Butchertown', 37.5113906860352, 0.654697274473248, -84.8905563354492, -1.48161971190332, 218, 21, 'PPL', 'P'),
(80061, 'Butchertown (historical)', 34.0200004577637, 0.593761019517954, -81.0422210693359, -1.41445359078903, 218, 48, 'PPL', 'P'),
(196119, 'Butchertown (historical)', 46.0361099243164, 0.803481692989359, -112.534721374512, -1.96410141079967, 218, 31, 'PPL', 'P'),
(77959, 'Bute', 39.9544410705566, 0.697336547475261, -79.7002792358398, -1.39103228742428, 218, 45, 'PPL', 'P'),
(139063, 'Bute', 40.0944404602051, 0.699779997775409, -92.9494400024414, -1.62227376592753, 218, 29, 'PPL', 'P'),
(45276, 'Buteaux Crossing', 38.5913887023926, 0.673546795773693, -77.1113891601563, -1.34584763163139, 218, 25, 'PPL', 'P'),
(1257, 'Butler', 32.0894393920898, 0.560066372511135, -88.2219390869141, -1.53976330956053, 218, 2, 'PPL', 'P'),
(7800, 'Butler', 35.6116714477539, 0.621540918901761, -89.938606262207, -1.5697248039303, 218, 4, 'PPL', 'P'),
(19673, 'Butler', 32.5569381713867, 0.56822576545892, -84.2383270263672, -1.47023616298183, 218, 13, 'PPL', 'P'),
(26667, 'Butler', 39.1994400024414, 0.684159292980577, -89.5338897705078, -1.56266116861303, 218, 18, 'PPL', 'P'),
(35085, 'Butler', 38.7863883972168, 0.676950182488759, -84.3697204589844, -1.4725294109965, 218, 21, 'PPL', 'P'),
(45277, 'Butler', 39.5352783203125, 0.690020777381786, -76.7283325195313, -1.33916203203086, 218, 25, 'PPL', 'P'),
(53767, 'Butler', 38.2586097717285, 0.667738707752339, -94.3302764892578, -1.64637390905415, 218, 29, 'PPL', 'P'),
(75279, 'Butler', 35.6366691589355, 0.621977211267344, -99.1855621337891, -1.73111462967603, 218, 42, 'PPL', 'P'),
(85459, 'Butler', 36.353328704834, 0.634485279959119, -82.0325012207031, -1.43173723994754, 218, 50, 'PPL', 'P'),
(92947, 'Butler', 31.663610458374, 0.552634255567538, -95.9233322143555, -1.67417797662485, 218, 51, 'PPL', 'P'),
(100405, 'Butler', 38.9919395446777, 0.680537726793205, -77.5641708374023, -1.35375016269204, 218, 53, 'PPL', 'P'),
(112431, 'Butler', 33.2275009155273, 0.579929293185382, -90.2988891601563, -1.57601292673814, 218, 30, 'PPL', 'P'),
(122304, 'Butler', 41.4297218322754, 0.723085054158583, -84.8713912963867, -1.48128521887041, 218, 19, 'PPL', 'P'),
(130023, 'Butler', 42.0577812194824, 0.734046758363404, -84.8652801513672, -1.48117855926875, 218, 27, 'PPL', 'P'),
(134501, 'Butler', 46.688060760498, 0.814860381641859, -95.352783203125, -1.66422001783488, 218, 28, 'PPL', 'P'),
(144924, 'Butler', 41.0036087036133, 0.715647977077456, -74.3419418334961, -1.29751165732062, 218, 37, 'PPL', 'P'),
(154550, 'Butler', 40.5883293151855, 0.708399984433723, -82.4250030517578, -1.43858768921955, 218, 41, 'PPL', 'P'),
(159697, 'Butler', 40.8611106872559, 0.713160917514458, -79.8955612182617, -1.39444060098736, 218, 45, 'PPL', 'P'),
(169946, 'Butler', 45.2588882446289, 0.789916615660931, -97.7119369506836, -1.70539501829054, 218, 49, 'PPL', 'P'),
(173383, 'Butler', 43.1058311462402, 0.752338680310613, -88.0694427490234, -1.53710174636711, 218, 57, 'PPL', 'P'),
(180344, 'Butler', 34.1324996948242, 0.595724501610642, -117.96443939209, -2.05886786766127, 218, 6, 'PPL', 'P'),
(15387, 'Butler (historical)', 30.797779083252, 0.537522647304587, -84.9436111450195, -1.48254569301434, 218, 12, 'PPL', 'P'),
(39598, 'Butler (historical)', 31.896390914917, 0.556697040968508, -93.466667175293, -1.63130108307457, 218, 22, 'PPL', 'P'),
(180345, 'Butler (historical)', 36.7222213745117, 0.640923671631467, -119.681106567383, -2.08882936203104, 218, 6, 'PPL', 'P'),
(15388, 'Butler Beach', 29.798059463501, 0.520074248343147, -81.267219543457, -1.41838055497441, 218, 12, 'PPL', 'P'),
(114783, 'Butler Center', 42.6974983215332, 0.745211928075507, -92.783332824707, -1.61937464876487, 218, 16, 'PPL', 'P'),
(122305, 'Butler Center', 41.3083305358887, 0.720966376353371, -85.1366729736328, -1.48591525758356, 218, 19, 'PPL', 'P'),
(147506, 'Butler Center', 43.1686096191406, 0.753434371362099, -76.7716674804688, -1.33991836978044, 218, 40, 'PPL', 'P'),
(63332, 'Butler Crossroads', 34.0858306884766, 0.594909973791242, -78.644172668457, -1.37259975057151, 218, 33, 'PPL', 'P'),
(80063, 'Butler Crossroads', 33.9436111450195, 0.592427774497233, -79.563606262207, -1.38864689403589, 218, 48, 'PPL', 'P'),
(85460, 'Butler Estates', 35.8722190856934, 0.626088333042099, -86.4824981689453, -1.50940433839806, 218, 50, 'PPL', 'P'),
(203222, 'Butler Hills', 40.6150016784668, 0.708865504992269, -111.827781677246, -1.95176298546933, 218, 52, 'PPL', 'P'),
(159699, 'Butler Junction', 40.6733283996582, 0.709883498318952, -79.6938934326172, -1.39092083413266, 218, 45, 'PPL', 'P'),
(19675, 'Butler Manor', 33.4069404602051, 0.583061104048288, -82.0919418334961, -1.43277467435018, 218, 13, 'PPL', 'P'),
(1261, 'Butler Mill', 34.579719543457, 0.603529960449556, -86.3019409179688, -1.50625301988017, 218, 2, 'PPL', 'P'),
(144925, 'Butler Park', 40.7516708374023, 0.711250831801626, -74.9313888549805, -1.30779944861159, 218, 37, 'PPL', 'P'),
(1259, 'Butler Springs', 31.8019409179688, 0.555048577543263, -86.8661117553711, -1.51609965853658, 218, 2, 'PPL', 'P'),
(19676, 'Butler Subdivision', 31.5638904571533, 0.550893813216144, -84.0780563354492, -1.46743891173087, 218, 13, 'PPL', 'P'),
(180346, 'Butlers (historical)', 33.0022201538086, 0.575997402151989, -115.408332824707, -2.01425539202859, 218, 6, 'PPL', 'P'),
(45279, 'Butlers Beach', 38.4569396972656, 0.671200217958197, -75.8363876342773, -1.32359465703685, 218, 25, 'PPL', 'P'),
(127005, 'Butlers Corner', 44.4075012207031, 0.775057108884671, -69.1016693115234, -1.20605164811041, 218, 26, 'PPL', 'P'),
(171813, 'Butlers Corners', 44.5102806091309, 0.776850947615921, -73.0844421386719, -1.27556414730311, 218, 55, 'PPL', 'P'),
(63329, 'Butlers Crossroads', 34.9230613708496, 0.60952240579737, -78.3311080932617, -1.36713574296299, 218, 33, 'PPL', 'P'),
(100406, 'Butlers Fork', 37.9541702270508, 0.66242523532444, -77.2344436645508, -1.34799533789249, 218, 53, 'PPL', 'P'),
(85461, 'Butlers Landing', 36.4897193908691, 0.636865746499486, -85.5616683959961, -1.49333282700971, 218, 50, 'PPL', 'P'),
(1260, 'Butlers Mill', 33.4577789306641, 0.583948402744475, -85.3819427490234, -1.49019602271976, 218, 2, 'PPL', 'P'),
(154555, 'Butlers Mill', 41.1630592346191, 0.718430913837561, -83.8613891601563, -1.46365735614101, 218, 41, 'PPL', 'P'),
(70598, 'Butlers Place', 39.8541717529297, 0.695586517743943, -74.5083312988281, -1.30041570133129, 218, 37, 'PPL', 'P'),
(35088, 'Butlersville', 36.7836112976074, 0.641995127917033, -86.3130569458008, -1.50644703116558, 218, 21, 'PPL', 'P'),
(45280, 'Butlertown', 39.2825012207031, 0.685608984719961, -76.1047210693359, -1.32827795897181, 218, 25, 'PPL', 'P'),
(7803, 'Butlerville', 34.975830078125, 0.610443393481347, -91.8333282470703, -1.60279394097609, 218, 4, 'PPL', 'P'),
(29360, 'Butlerville', 39.0344390869141, 0.681279483735819, -85.5127792358398, -1.49247955019645, 218, 19, 'PPL', 'P'),
(71979, 'Butlerville', 39.3025016784668, 0.685958058559843, -84.0899963378906, -1.46764730408617, 218, 41, 'PPL', 'P'),
(124363, 'Butlerville', 42.1527786254883, 0.73570477587906, -72.404167175293, -1.26369110937326, 218, 23, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(147508, 'Butlerville', 41.3491706848145, 0.721679171419131, -73.6727828979492, -1.28583263067618, 218, 40, 'PPL', 'P'),
(130025, 'Butman', 44.1391716003418, 0.770373873528739, -84.4674987792969, -1.47423596462302, 218, 27, 'PPL', 'P'),
(173386, 'Butman Corners', 44.0780601501465, 0.769307277512162, -91.2916717529297, -1.59334025173853, 218, 57, 'PPL', 'P'),
(63330, 'Butner', 36.1319389343262, 0.630621299533523, -78.7569427490234, -1.37456795977513, 218, 33, 'PPL', 'P'),
(75280, 'Butner', 35.2608299255371, 0.61541757918637, -96.458610534668, -1.68352034572884, 218, 42, 'PPL', 'P'),
(58848, 'Buttahatchie (historical)', 33.8055610656738, 0.590018346080011, -88.2786102294922, -1.54075240758939, 218, 30, 'PPL', 'P'),
(141415, 'Butte', 42.9113883972168, 0.748945014133525, -98.8488922119141, -1.72523863104688, 218, 35, 'PPL', 'P'),
(196120, 'Butte', 46.0038909912109, 0.802919366525189, -112.533889770508, -1.96408689657173, 218, 31, 'PPL', 'P'),
(198075, 'Butte', 47.8380584716797, 0.834931628092377, -100.665000915527, -1.75693570749906, 218, 34, 'PPL', 'P'),
(211716, 'Butte', 61.5422210693359, 1.07411438665014, -149.033325195313, -2.60112221985362, 218, 1, 'PPL', 'P'),
(180348, 'Butte City', 39.4647216796875, 0.688789331693734, -121.988891601563, -2.12910780930572, 218, 6, 'PPL', 'P'),
(194666, 'Butte City', 43.6100006103516, 0.761138097447371, -113.24333190918, -1.97646899774394, 218, 17, 'PPL', 'P'),
(196121, 'Butte Creek', 48.8819389343262, 0.8531507791628, -105.847778320313, -1.84739223761053, 218, 31, 'PPL', 'P'),
(196122, 'Butte Creek (historical)', 47.4777793884277, 0.828643571863564, -107.253608703613, -1.8719286065237, 218, 31, 'PPL', 'P'),
(200492, 'Butte Creek (historical)', 45.0652809143066, 0.786537530290811, -122.695831298828, -2.14144623463606, 218, 43, 'PPL', 'P'),
(173387, 'Butte des Morts', 44.0994415283203, 0.76968045295991, -88.6538925170898, -1.54730231913238, 218, 57, 'PPL', 'P'),
(200493, 'Butte Falls', 42.5433311462402, 0.742521203268145, -122.564437866211, -2.13915298662139, 218, 43, 'PPL', 'P'),
(180349, 'Butte House (historical)', 39.167781829834, 0.683606753633412, -121.73388671875, -2.12465713449198, 218, 6, 'PPL', 'P'),
(39599, 'Butte La Rose', 30.2775001525879, 0.528442066935744, -91.6866683959961, -1.60023424369436, 218, 22, 'PPL', 'P'),
(193414, 'Butte Meadows', 40.0813903808594, 0.69955223092318, -121.550003051758, -2.12144775906233, 218, 6, 'PPL', 'P'),
(180350, 'Butte Street Junction', 34.0180587768555, 0.593727130793083, -118.230827331543, -2.06351721429233, 218, 6, 'PPL', 'P'),
(7804, 'Butter Creek (historical)', 35.5419387817383, 0.620323854283595, -92.5569381713867, -1.61542331665552, 218, 4, 'PPL', 'P'),
(45281, 'Buttercup Estates', 39.3047218322754, 0.685996807553704, -76.958610534668, -1.34318114158995, 218, 25, 'PPL', 'P'),
(7808, 'Butterfield', 34.4272193908691, 0.600868330677103, -92.813606262207, -1.61990301992514, 218, 4, 'PPL', 'P'),
(45282, 'Butterfield', 39.3633308410645, 0.687019727728403, -77.2708282470703, -1.34863036865442, 218, 25, 'PPL', 'P'),
(53771, 'Butterfield', 36.75, 0.641408500107916, -93.9075012207031, -1.63899508862186, 218, 29, 'PPL', 'P'),
(130027, 'Butterfield', 44.2777786254883, 0.77279302248394, -84.9533309936523, -1.48271533637578, 218, 27, 'PPL', 'P'),
(134502, 'Butterfield', 43.9583282470703, 0.767217561583804, -94.7944412231445, -1.65447511193211, 218, 28, 'PPL', 'P'),
(191203, 'Butterfield', 31.8347206115723, 0.555620691124439, -106.095283508301, -1.85171201805669, 218, 51, 'PPL', 'P'),
(127006, 'Butterfield (historical)', 44.8316688537598, 0.7824602306619, -70.3913879394531, -1.22856148459208, 218, 26, 'PPL', 'P'),
(191207, 'Butterfield City Number 1 Colonia', 31.8320007324219, 0.555573220278008, -106.095001220703, -1.85170709120867, 218, 51, 'PPL', 'P'),
(191204, 'Butterfield City Number 2 Colonia', 31.8379993438721, 0.555677915798362, -106.09700012207, -1.85174197861895, 218, 51, 'PPL', 'P'),
(191205, 'Butterfield City Number 3 Colonia', 31.8339996337891, 0.555608107688288, -106.092002868652, -1.85165476009325, 218, 51, 'PPL', 'P'),
(191206, 'Butterfield City Number 4 Colonia', 31.8540000915527, 0.55595718152817, -106.069000244141, -1.85125328855892, 218, 51, 'PPL', 'P'),
(180351, 'Butterfield Lake Estates', 33.4799995422363, 0.584336225578218, -116.962501525879, -2.04138075299548, 218, 6, 'PPL', 'P'),
(127007, 'Butterfield Landing', 45.7105598449707, 0.797799772224647, -67.8600006103516, -1.184380441056, 218, 26, 'PPL', 'P'),
(35089, 'Butterfly', 37.288330078125, 0.650804132433716, -83.2724990844727, -1.45337928538801, 218, 21, 'PPL', 'P'),
(85462, 'Butterfly (historical)', 36.4894409179688, 0.636860886230497, -82.6083297729492, -1.44178734411122, 218, 50, 'PPL', 'P'),
(7806, 'Buttermilk', 35.3872184753418, 0.617623475517282, -92.8969421386719, -1.62135750535449, 218, 4, 'PPL', 'P'),
(31937, 'Buttermilk', 37.1027793884277, 0.647565661969152, -99.3249969482422, -1.73354822628015, 218, 20, 'PPL', 'P'),
(159704, 'Buttermilk Falls', 40.2636108398438, 0.702732577896953, -79.2911071777344, -1.38389088780317, 218, 45, 'PPL', 'P'),
(122308, 'Buttermilk Point', 41.3772201538086, 0.722168727006514, -85.6741714477539, -1.49529637568142, 218, 19, 'PPL', 'P'),
(85463, 'Buttermilk Shores', 35.8813896179199, 0.626248389023613, -84.3625030517578, -1.47240344347694, 218, 50, 'PPL', 'P'),
(130029, 'Butternut', 43.1833305358887, 0.753691299828265, -84.9155578613281, -1.48205607084793, 218, 27, 'PPL', 'P'),
(134505, 'Butternut', 44.1377792358398, 0.770349572183792, -94.3288879394531, -1.64634967428823, 218, 28, 'PPL', 'P'),
(171814, 'Butternut', 43.3752784729004, 0.75704142332153, -73.2027816772461, -1.27762956188652, 218, 55, 'PPL', 'P'),
(173388, 'Butternut', 46.0130615234375, 0.803079422506702, -90.4902801513672, -1.57935332969343, 218, 57, 'PPL', 'P'),
(147509, 'Butternut Grove', 41.957218170166, 0.732291602046987, -74.9908294677734, -1.30883688301423, 218, 40, 'PPL', 'P'),
(159705, 'Butternut Grove', 41.353889465332, 0.721761529675841, -76.8977813720703, -1.34211947242139, 218, 45, 'PPL', 'P'),
(63333, 'Butters', 34.5602798461914, 0.603190673726679, -78.8486099243164, -1.3761678538, 218, 33, 'PPL', 'P'),
(130030, 'Buttersville', 43.9449996948242, 0.766984934462586, -86.4555587768555, -1.50893415730761, 218, 27, 'PPL', 'P'),
(147512, 'Butterville', 41.7611083984375, 0.72886884083499, -74.1191711425781, -1.29362357528716, 218, 40, 'PPL', 'P'),
(100407, 'Butterworth', 37.0511093139648, 0.646663849045024, -77.6272201538086, -1.35485058085446, 218, 53, 'PPL', 'P'),
(71980, 'Butterworth (historical)', 39.3027801513672, 0.685962918828833, -84.2558288574219, -1.47054162755886, 218, 41, 'PPL', 'P'),
(144927, 'Butterworth Farms', 40.8213882446289, 0.712467630103683, -74.5236129760742, -1.30068241691447, 218, 37, 'PPL', 'P'),
(186472, 'Buttes', 38.5872192382813, 0.673474024896906, -104.66667175293, -1.82677803919277, 218, 7, 'PPL', 'P'),
(200494, 'Butteville', 45.2625007629395, 0.789979665999739, -122.839172363281, -2.14394800816408, 218, 43, 'PPL', 'P'),
(147513, 'Button City', 42.7216682434082, 0.745633772792175, -75.3252792358398, -1.31467413264952, 218, 40, 'PPL', 'P'),
(35090, 'Buttonsberry', 37.4466705322266, 0.653567694696891, -87.1686096191406, -1.5213792422396, 218, 21, 'PPL', 'P'),
(180352, 'Buttonwillow', 35.4005584716797, 0.617856302375582, -119.468612670898, -2.08512064389699, 218, 6, 'PPL', 'P'),
(13468, 'Buttonwood', 39.6833305358887, 0.692604776008463, -75.5569381713867, -1.31871734381648, 218, 10, 'PPL', 'P'),
(159707, 'Buttonwood', 41.4997215270996, 0.724306779308657, -77.1350021362305, -1.34625975581008, 218, 45, 'PPL', 'P'),
(169301, 'Buttonwoods', 41.6852798461914, 0.727545382931275, -71.4191665649414, -1.24649960558848, 218, 47, 'PPL', 'P'),
(7807, 'Buttry (historical)', 36.4599990844727, 0.636347029298166, -94.0597229003906, -1.64165185812533, 218, 4, 'PPL', 'P'),
(19677, 'Butts', 32.725830078125, 0.571173485311474, -82.0263900756836, -1.43163058034588, 218, 13, 'PPL', 'P'),
(53773, 'Butts', 37.9958305358887, 0.663152344881059, -91.1561126708984, -1.5909742994261, 218, 29, 'PPL', 'P'),
(100409, 'Butts', 36.7322196960449, 0.641098175261895, -82.0366668701172, -1.4318099442453, 218, 53, 'PPL', 'P'),
(159708, 'Butts', 41.0272216796875, 0.716060101256145, -77.9113922119141, -1.35981031891057, 218, 45, 'PPL', 'P'),
(100410, 'Butts Corner', 38.7811088562012, 0.676858037115043, -77.3277816772461, -1.34962439353129, 218, 53, 'PPL', 'P'),
(147514, 'Butts Corner', 42.4755592346191, 0.741338360269987, -74.8216705322266, -1.30588450262977, 218, 40, 'PPL', 'P'),
(1262, 'Butts Mill', 32.5611114501953, 0.568298602914734, -85.9627838134766, -1.50033361172525, 218, 2, 'PPL', 'P'),
(1263, 'Buttston', 32.9463882446289, 0.575022951509129, -85.6383285522461, -1.49467079914136, 218, 2, 'PPL', 'P'),
(139065, 'Buttsville', 40.2127799987793, 0.70184541235882, -93.6711120605469, -1.63486931946111, 218, 29, 'PPL', 'P'),
(139742, 'Buttzville', 46.5080604553223, 0.811718783661947, -97.6294403076172, -1.70395518024719, 218, 34, 'PPL', 'P'),
(144928, 'Buttzville', 40.832218170166, 0.712656647962051, -75.0066680908203, -1.30911331913538, 218, 37, 'PPL', 'P'),
(100411, 'Butylo', 37.7708282470703, 0.659225314116655, -76.6883316040039, -1.33846388435109, 218, 53, 'PPL', 'P'),
(100412, 'Butzner Corner', 38.2555618286133, 0.667685511109564, -77.357780456543, -1.3501479710016, 218, 53, 'PPL', 'P'),
(159713, 'Butztown', 40.6530609130859, 0.709529763947162, -75.3283309936523, -1.31472739587133, 218, 45, 'PPL', 'P'),
(31939, 'Buxton', 37.4483299255371, 0.653596656573746, -95.920280456543, -1.67412471340304, 218, 20, 'PPL', 'P'),
(53774, 'Buxton', 39.3188896179199, 0.686244082060918, -94.8730621337891, -1.65584730568378, 218, 29, 'PPL', 'P'),
(58849, 'Buxton', 34.547779083252, 0.602972494254375, -90.1977767944336, -1.5742481830418, 218, 30, 'PPL', 'P'),
(63335, 'Buxton', 35.2675018310547, 0.615534025905033, -75.5427780151367, -1.31847020246732, 218, 33, 'PPL', 'P'),
(114789, 'Buxton', 41.1583290100098, 0.718348355843769, -92.8211135864258, -1.62003404745077, 218, 16, 'PPL', 'P'),
(127008, 'Buxton', 43.6377792358398, 0.76162292592382, -70.5194396972656, -1.23079640937888, 218, 26, 'PPL', 'P'),
(139743, 'Buxton', 47.6019401550293, 0.830810586042561, -97.0969390869141, -1.69466128067503, 218, 34, 'PPL', 'P'),
(196123, 'Buxton', 45.9433288574219, 0.801862357888536, -112.711669921875, -1.96718974555778, 218, 31, 'PPL', 'P'),
(200495, 'Buxton', 45.6888885498047, 0.797421536770829, -123.189720153809, -2.15006622129438, 218, 43, 'PPL', 'P'),
(127009, 'Buxton Center', 43.648609161377, 0.761811943782189, -70.5416717529297, -1.2311844319497, 218, 26, 'PPL', 'P'),
(63336, 'Buxton Landing', 35.271671295166, 0.61560679678182, -75.540283203125, -1.3184266597835, 218, 33, 'PPL', 'P'),
(1264, 'Buyck', 32.7044410705566, 0.570800176705673, -86.2569427490234, -1.50546765367471, 218, 2, 'PPL', 'P'),
(134507, 'Buyck', 48.121940612793, 0.839886306142415, -92.5233306884766, -1.61483675542543, 218, 28, 'PPL', 'P'),
(159709, 'Buyerstown', 40.0113906860352, 0.698330505773106, -76.0461120605469, -1.32725503879711, 218, 45, 'PPL', 'P'),
(1265, 'Buzbee Landing', 30.702220916748, 0.535854842671925, -87.8977813720703, -1.53410569014077, 218, 2, 'PPL', 'P'),
(77960, 'Buzz', 39.7872200012207, 0.694417989236644, -80.3225021362305, -1.4018921257174, 218, 45, 'PPL', 'P'),
(177812, 'Buzzard Gulch Trailer Park', 34.9191703796387, 0.609454495189573, -110.151107788086, -1.92249950562127, 218, 5, 'PPL', 'P'),
(13048, 'Buzzard Point', 38.8722190856934, 0.678448210601929, -77.0111083984375, -1.34409740216299, 218, 9, 'PPL', 'P'),
(45283, 'Buzzard Point', 38.2780609130859, 0.668078194212297, -76.6380615234375, -1.33758650592997, 218, 25, 'PPL', 'P'),
(1266, 'Buzzard Roost', 34.7611083984375, 0.606695793195387, -88.0238876342773, -1.53630665962366, 218, 2, 'PPL', 'P'),
(154556, 'Buzzard Roost', 41.2155609130859, 0.71934724098963, -81.7091674804688, -1.42609400159766, 218, 41, 'PPL', 'P'),
(7809, 'Buzzard Roost (historical)', 35.5761108398438, 0.620920269209719, -92.5113906860352, -1.61462836307013, 218, 4, 'PPL', 'P'),
(124364, 'Buzzards Bay', 41.7452812194824, 0.728592604450922, -70.6186065673828, -1.23252719777132, 218, 23, 'PPL', 'P'),
(63337, 'Buzzards Crossroads', 36.1594390869141, 0.631101267740982, -76.8952789306641, -1.34207579657951, 218, 33, 'PPL', 'P'),
(53775, 'Buzzards Roost', 39.4711112976074, 0.688900851564381, -91.7941665649414, -1.60211044068232, 218, 29, 'PPL', 'P'),
(118990, 'Buzzville', 40.3661117553711, 0.704521556359213, -89.9902801513672, -1.57062668343346, 218, 18, 'PPL', 'P'),
(75281, 'Byars', 34.8741683959961, 0.608669062405081, -97.0497207641602, -1.6938371654757, 218, 42, 'PPL', 'P'),
(35091, 'Bybee', 37.7330589294434, 0.658566115167833, -84.1247177124023, -1.46825330639221, 218, 21, 'PPL', 'P'),
(85464, 'Bybee', 36.0480613708496, 0.629157359882306, -83.179443359375, -1.45175515659723, 218, 50, 'PPL', 'P'),
(100413, 'Bybee', 37.9255599975586, 0.66192589262005, -78.2058334350586, -1.36494928770804, 218, 53, 'PPL', 'P'),
(118991, 'Bybee', 40.5977783203125, 0.708564900684226, -90.1847229003906, -1.57402034961055, 218, 18, 'PPL', 'P'),
(200496, 'Bybee Corner', 42.3172187805176, 0.738574798006811, -122.950828552246, -2.14589677629175, 218, 43, 'PPL', 'P'),
(159711, 'Byberry', 40.0999984741211, 0.699877003418115, -74.9683303833008, -1.3084441999115, 218, 45, 'PPL', 'P'),
(53776, 'Byberry (historical)', 38.6916694641113, 0.675297025242093, -92.9274978637695, -1.62189080336278, 218, 29, 'PPL', 'P'),
(45284, 'Byeforde', 39.0113906860352, 0.680877213253163, -77.0844421386719, -1.34537731738288, 218, 25, 'PPL', 'P'),
(71981, 'Byer', 39.1813888549805, 0.68384424102362, -82.6313934326172, -1.44218988090999, 218, 41, 'PPL', 'P'),
(159714, 'Byerly', 40.3455581665039, 0.70416282856038, -79.7638931274414, -1.39214255928273, 218, 45, 'PPL', 'P'),
(19679, 'Byers', 34.235279083252, 0.597518340341892, -83.9194412231445, -1.46467055577773, 218, 13, 'PPL', 'P'),
(31941, 'Byers', 37.7874984741211, 0.659516264465746, -98.8666687011719, -1.72554888931388, 218, 20, 'PPL', 'P'),
(53777, 'Byers', 38.3955612182617, 0.670128961409712, -90.3741683959961, -1.57732679726193, 218, 29, 'PPL', 'P'),
(92948, 'Byers', 34.0680618286133, 0.594599848682302, -98.1902770996094, -1.71374362883377, 218, 51, 'PPL', 'P'),
(159715, 'Byers', 40.0780601501465, 0.699494107432389, -75.6811065673828, -1.32088449115353, 218, 45, 'PPL', 'P'),
(186473, 'Byers', 39.7113914489746, 0.693094531332929, -104.22721862793, -1.81910813525334, 218, 7, 'PPL', 'P'),
(159716, 'Byers Corner', 40.976390838623, 0.715172935718013, -79.7977828979492, -1.39273404736084, 218, 45, 'PPL', 'P'),
(19681, 'Byers Crossroads', 33.5275001525879, 0.58516526762556, -84.8622207641602, -1.48112516288889, 218, 13, 'PPL', 'P'),
(159717, 'Byersdale', 40.6236114501953, 0.709015773856777, -80.2247161865234, -1.40018543893282, 218, 45, 'PPL', 'P'),
(147515, 'Byersville', 42.5833282470703, 0.743219284368882, -77.7911071777344, -1.35771094902326, 218, 40, 'PPL', 'P'),
(63339, 'Byersville (historical)', 35.2208290100098, 0.614719431506605, -81.7477798461914, -1.4267679145115, 218, 33, 'PPL', 'P'),
(71982, 'Byesville', 39.9697189331055, 0.697603196479406, -81.5366668701172, -1.42308329798532, 218, 41, 'PPL', 'P'),
(13466, 'Byewood Manor', 38.5602798461914, 0.673003843806453, -75.120002746582, -1.31109138203504, 218, 10, 'PPL', 'P'),
(124365, 'Byfield', 42.7597198486328, 0.746297898589014, -70.9486083984375, -1.23828681626084, 218, 23, 'PPL', 'P'),
(134509, 'Bygland', 47.8116683959961, 0.834471034381848, -96.9319381713867, -1.69178147143027, 218, 28, 'PPL', 'P'),
(58850, 'Byhalia', 34.8722190856934, 0.608635040522156, -89.690559387207, -1.56539556926227, 218, 30, 'PPL', 'P'),
(154557, 'Byhalia', 40.4536094665527, 0.706048679507292, -83.4555587768555, -1.45657427974778, 218, 41, 'PPL', 'P'),
(71983, 'Byington', 39.0875015258789, 0.682205598004894, -83.2994384765625, -1.45384946647846, 218, 41, 'PPL', 'P'),
(85465, 'Byington', 35.9680595397949, 0.627761064522778, -84.1183319091797, -1.46814185310059, 218, 50, 'PPL', 'P'),
(177813, 'Bylas', 33.1386108398438, 0.578377868692357, -110.124443054199, -1.92203411822078, 218, 5, 'PPL', 'P'),
(100414, 'Byllesby', 36.7844390869141, 0.642009575565947, -80.9352798461914, -1.41258711433905, 218, 53, 'PPL', 'P'),
(19680, 'Byne Crossroads', 31.6975002288818, 0.553225743645644, -84.2194366455078, -1.46990646363888, 218, 13, 'PPL', 'P'),
(75283, 'Byng', 34.8611106872559, 0.608441162394798, -96.665283203125, -1.6871274642673, 218, 42, 'PPL', 'P'),
(1267, 'Bynum', 33.6130599975586, 0.586658568627795, -85.9611129760742, -1.50030445011132, 218, 2, 'PPL', 'P'),
(45285, 'Bynum', 39.565559387207, 0.690549281700113, -76.3649978637695, -1.33282064600121, 218, 25, 'PPL', 'P'),
(58852, 'Bynum', 34.7125015258789, 0.605847443230143, -88.5513916015625, -1.54551334067012, 218, 30, 'PPL', 'P'),
(63338, 'Bynum', 35.7738914489746, 0.624372192035652, -79.1425018310547, -1.38129723521755, 218, 33, 'PPL', 'P'),
(92949, 'Bynum', 31.9716701507568, 0.558010911492299, -97.0027770996094, -1.69301784396634, 218, 51, 'PPL', 'P'),
(196124, 'Bynum', 47.9791717529297, 0.837394519468482, -112.310829162598, -1.9601937545322, 218, 31, 'PPL', 'P'),
(45286, 'Bynum Hills', 39.4847183227539, 0.689138338954589, -76.279167175293, -1.33132261788804, 218, 25, 'PPL', 'P'),
(45287, 'Bynum Overlook', 39.4791717529297, 0.689041533048964, -76.2777786254883, -1.33129838312213, 218, 25, 'PPL', 'P'),
(53778, 'Bynumville', 39.6166687011719, 0.691441307507235, -92.7758331298828, -1.61924375439729, 218, 29, 'PPL', 'P'),
(58853, 'Byram', 32.1791687011719, 0.561632444390156, -90.2452774047852, -1.57507722508914, 218, 30, 'PPL', 'P'),
(144929, 'Byram', 40.4236106872559, 0.705525102036983, -75.0599975585938, -1.31004409393637, 218, 37, 'PPL', 'P'),
(177556, 'Byram', 41.0041694641113, 0.715657764194461, -73.654167175293, -1.28550772502319, 218, 8, 'PPL', 'P'),
(144930, 'Byram Cove', 40.9555587768555, 0.71480934765019, -74.6602783203125, -1.30306767714479, 218, 37, 'PPL', 'P'),
(1268, 'Byrd', 34.079719543457, 0.594803314189584, -88.1322174072266, -1.53819737083956, 218, 2, 'PPL', 'P'),
(15389, 'Byrd', 29.6774997711182, 0.517970084765875, -81.4611129760742, -1.42176463377157, 218, 12, 'PPL', 'P'),
(58854, 'Byrd', 31.2199993133545, 0.544891780488405, -88.7397232055664, -1.54880034724555, 218, 30, 'PPL', 'P'),
(80064, 'Byrd', 33.1688919067383, 0.578906373010683, -80.517219543457, -1.40529058558445, 218, 48, 'PPL', 'P'),
(92950, 'Byrd', 32.2105598449707, 0.562180323205413, -96.6661071777344, -1.68714184533719, 218, 51, 'PPL', 'P'),
(85466, 'Byrd Chapel', 35.9249992370605, 0.627009520463157, -84.1691665649414, -1.46902908521775, 218, 50, 'PPL', 'P'),
(100415, 'Byrd Mill', 37.9883308410645, 0.663021450513481, -78.0811080932617, -1.36277241983301, 218, 53, 'PPL', 'P'),
(147516, 'Byrdcliffe', 42.0525016784668, 0.733954612989687, -74.1469421386719, -1.29410827060555, 218, 40, 'PPL', 'P'),
(92954, 'Byrds', 31.913330078125, 0.55699268513902, -99.0416717529297, -1.72860326876809, 218, 51, 'PPL', 'P'),
(173390, 'Byrds Creek', 43.2200012207031, 0.754331324017238, -90.5483322143555, -1.58036652933015, 218, 57, 'PPL', 'P'),
(80065, 'Byrds Crossroads', 33.9558296203613, 0.592641027121521, -79.8683319091797, -1.39396535989083, 218, 48, 'PPL', 'P'),
(177814, 'Byrds Mobile Park', 33.4269409179688, 0.583410177888171, -112.351387023926, -1.96090162274994, 218, 5, 'PPL', 'P'),
(85467, 'Byrdstown', 36.5744400024414, 0.638344400115725, -85.1288909912109, -1.48577943636797, 218, 50, 'PPL', 'P'),
(100416, 'Byrdton', 37.7011108398438, 0.658008515814598, -76.3369369506836, -1.33233089067675, 218, 53, 'PPL', 'P'),
(45288, 'Byrdtown', 37.9594383239746, 0.662517180961075, -75.8402786254883, -1.32366256764465, 218, 25, 'PPL', 'P'),
(92951, 'Byrdtown', 33.6122207641602, 0.586643921241799, -95.3647232055664, -1.66442841019018, 218, 51, 'PPL', 'P'),
(63343, 'Byrdville', 34.3177795410156, 0.598958244964271, -78.311393737793, -1.36679166255016, 218, 33, 'PPL', 'P'),
(191208, 'Byrne', 31.3180599212646, 0.546603260962944, -100.476669311523, -1.75364870092363, 218, 51, 'PPL', 'P'),
(194668, 'Byrne', 43.6919403076172, 0.762568214952744, -111.745826721191, -1.95033260164785, 218, 17, 'PPL', 'P'),
(196125, 'Byrne', 46.7038917541504, 0.815136684604954, -113.452499389648, -1.98011965896622, 218, 31, 'PPL', 'P'),
(58857, 'Byrne City', 33.0927810668945, 0.577577988258951, -91.0980606079102, -1.58996109978938, 218, 30, 'PPL', 'P'),
(159718, 'Byrnedale', 41.2919387817383, 0.720680286273269, -78.5044403076172, -1.37016096080327, 218, 45, 'PPL', 'P'),
(209343, 'Byrnes Crossing', 41.2819404602051, 0.720505782642842, -110.63777923584, -1.93099352476002, 218, 59, 'PPL', 'P'),
(53780, 'Byrnes Mill', 38.4377784729004, 0.67086579150431, -90.581672668457, -1.58094843002833, 218, 29, 'PPL', 'P'),
(53781, 'Byrnesville', 38.3927803039551, 0.670080425298845, -90.6397171020508, -1.581961496507, 218, 29, 'PPL', 'P'),
(80067, 'Byrneswood', 34.0466690063477, 0.594226473497473, -81.0569381713867, -1.41471045267617, 218, 48, 'PPL', 'P'),
(15390, 'Byrneville', 30.9661102294922, 0.540460580040136, -87.3269424438477, -1.52414267134473, 218, 12, 'PPL', 'P'),
(29361, 'Byrneville', 38.3274993896484, 0.668941058405482, -86.0436096191406, -1.50174428815467, 218, 19, 'PPL', 'P'),
(159719, 'Byrnsville', 40.7963905334473, 0.712031337738101, -76.3394393920898, -1.33237456651863, 218, 45, 'PPL', 'P'),
(159720, 'Byromtown', 41.524169921875, 0.724733484294315, -79.0505599975586, -1.37969254750272, 218, 45, 'PPL', 'P'),
(19682, 'Byromville', 32.2019386291504, 0.562029854603824, -83.9086074829102, -1.46448147134033, 218, 13, 'PPL', 'P'),
(7810, 'Byron', 36.3224983215332, 0.633947188260868, -91.9574966430664, -1.60496108831314, 218, 4, 'PPL', 'P'),
(19683, 'Byron', 32.6536102294922, 0.56991301116754, -83.7597198486328, -1.46188289190669, 218, 13, 'PPL', 'P'),
(53782, 'Byron', 38.3352813720703, 0.669076879621076, -91.710563659668, -1.60065129472107, 218, 29, 'PPL', 'P'),
(71985, 'Byron', 39.7861099243164, 0.694398614739713, -83.980827331543, -1.46574194548427, 218, 41, 'PPL', 'P'),
(75284, 'Byron', 36.9019393920898, 0.644060342763363, -98.2936096191406, -1.71554712152397, 218, 42, 'PPL', 'P'),
(100417, 'Byron', 37.2336082458496, 0.649849056287786, -81.1366729736328, -1.41610208750379, 218, 53, 'PPL', 'P'),
(118992, 'Byron', 42.1269416809082, 0.735253836127483, -89.2555618286133, -1.55780342962667, 218, 18, 'PPL', 'P'),
(122309, 'Byron', 41.6561088562012, 0.72703625310988, -86.6247177124023, -1.51188653769207, 218, 19, 'PPL', 'P'),
(127011, 'Byron', 44.7219390869141, 0.780545084942997, -70.6311111450195, -1.23274544382265, 218, 26, 'PPL', 'P'),
(130031, 'Byron', 42.8227806091309, 0.747398516488516, -83.9444427490234, -1.46510691472234, 218, 27, 'PPL', 'P'),
(134511, 'Byron', 44.0327796936035, 0.768516984458681, -92.6452789306641, -1.61696515376862, 218, 28, 'PPL', 'P'),
(141423, 'Byron', 40.0038909912109, 0.698199611405529, -97.7686080932617, -1.70638411631939, 218, 35, 'PPL', 'P'),
(147517, 'Byron', 43.079719543457, 0.751882946869074, -78.0641708374023, -1.36247680895201, 218, 40, 'PPL', 'P'),
(173391, 'Byron', 43.6522216796875, 0.761874994120996, -88.4508285522461, -1.5437581843537, 218, 57, 'PPL', 'P'),
(180353, 'Byron', 37.8672218322754, 0.660907699556285, -121.636940002441, -2.1229650950934, 218, 6, 'PPL', 'P'),
(206938, 'Byron', 46.188060760498, 0.806133735381887, -119.873329162598, -2.09218427921427, 218, 56, 'PPL', 'P'),
(209344, 'Byron', 44.7963905334473, 0.781844507817874, -108.505828857422, -1.89378397116749, 218, 59, 'PPL', 'P'),
(130032, 'Byron Center', 42.8122215270996, 0.747214225741083, -85.7227783203125, -1.49614472564667, 218, 27, 'PPL', 'P'),
(118993, 'Byron Hills Estates', 42.1413917541504, 0.735506037482713, -89.2697219848633, -1.55805057097583, 218, 18, 'PPL', 'P'),
(80068, 'Byron Terrace', 34.913890838623, 0.609362349815856, -81.976936340332, -1.43076744983658, 218, 48, 'PPL', 'P'),
(45289, 'Byrons Manor', 39.4633293151855, 0.688765030348787, -77.2119369506836, -1.3476025216317, 218, 25, 'PPL', 'P'),
(180354, 'Bystrom', 37.6208305358887, 0.65660736018608, -120.984718322754, -2.11158167932997, 218, 6, 'PPL', 'P'),
(45290, 'Bywater Estates', 38.9588890075684, 0.679960886101094, -76.5352783203125, -1.33579260061969, 218, 25, 'PPL', 'P'),
(203225, 'Bywater Park Estates', 40.6172218322754, 0.70890425398613, -111.80638885498, -1.9513896102845, 218, 52, 'PPL', 'P'),
(77961, 'Bywood', 39.9580612182617, 0.697399730972123, -75.267219543457, -1.31366079985475, 218, 45, 'PPL', 'P'),
(58856, 'Bywy', 33.4372215270996, 0.583589608366615, -89.2411117553711, -1.55755122827144, 218, 30, 'PPL', 'P'),
(92952, 'C A Conner Colonia', 26.1420001983643, 0.456263976518467, -97.8860015869141, -1.70843301930404, 218, 51, 'PPL', 'P'),
(122310, 'C and C Beach', 40.7033309936523, 0.710407142368289, -86.7563934326172, -1.51418471255476, 218, 19, 'PPL', 'P'),
(141421, 'C and K Mobile Home Park', 41.3058280944824, 0.720922700511494, -96.3499984741211, -1.68162470766493, 218, 35, 'PPL', 'P'),
(159722, 'C and M Junction', 41.0838890075684, 0.717049132705973, -78.758056640625, -1.37458740085109, 218, 45, 'PPL', 'P'),
(188204, 'C Davis Place', 34.9619407653809, 0.610200979243122, -106.110000610352, -1.85196887994383, 218, 38, 'PPL', 'P'),
(159721, 'C V Junction', 41.9822196960449, 0.732727960991597, -77.1236114501953, -1.34606095083471, 218, 45, 'PPL', 'P'),
(80069, 'Cabal', 34.8063888549805, 0.607486086248868, -81.4527816772461, -1.42161922517605, 218, 48, 'PPL', 'P'),
(203229, 'Caballero Ranches', 40.6094398498535, 0.708768432770536, -111.839996337891, -1.95197617151459, 218, 52, 'PPL', 'P'),
(80070, 'Caballin Springs', 34.6083297729492, 0.604029303153945, -82.9180603027344, -1.44719316164992, 218, 48, 'PPL', 'P'),
(188205, 'Caballo', 32.9755592346191, 0.575532081330525, -107.307220458984, -1.8728643081727, 218, 38, 'PPL', 'P'),
(85468, 'Cabana Estates', 36.4777793884277, 0.636657354144187, -88.0783309936523, -1.5372568755006, 218, 50, 'PPL', 'P'),
(7811, 'Cabanal', 36.2783317565918, 0.633176336283345, -93.5319366455078, -1.63244025023085, 218, 4, 'PPL', 'P'),
(19684, 'Cabaniss', 33.1533317565918, 0.578634797158522, -83.8794403076172, -1.46397240809797, 218, 13, 'PPL', 'P'),
(75286, 'Cabaniss', 34.9416694641113, 0.609847178292305, -96.0244369506836, -1.67594258716313, 218, 42, 'PPL', 'P'),
(100418, 'Cabaniss', 39.1777801513672, 0.68378125726384, -78.2827835083008, -1.36629231984577, 218, 53, 'PPL', 'P'),
(63341, 'Cabarrus', 35.2369384765625, 0.61500059473869, -80.5419387817383, -1.40572201768104, 218, 33, 'PPL', 'P'),
(194669, 'Cabarton', 44.4355583190918, 0.775546797630109, -116.039169311523, -2.02526556576525, 218, 17, 'PPL', 'P'),
(180356, 'Cabazon', 33.9174995422363, 0.591972041055693, -116.786392211914, -2.03830706562336, 218, 6, 'PPL', 'P'),
(15394, 'Cabbage Grove', 30.2094402313232, 0.527254197221028, -83.873893737793, -1.46387560219234, 218, 12, 'PPL', 'P'),
(19685, 'Cabbage Town', 33.7480583190918, 0.589014733823215, -84.3666687011719, -1.4724761477747, 218, 13, 'PPL', 'P'),
(159723, 'Cabel', 40.8147201538086, 0.712351249964046, -76.5861129760742, -1.33667983273685, 218, 45, 'PPL', 'P'),
(35092, 'Cabell', 36.8311080932617, 0.642824103385348, -85.0069427490234, -1.48365103802478, 218, 21, 'PPL', 'P'),
(108440, 'Cabell', 37.7886085510254, 0.659535638962677, -81.2316665649414, -1.41776003844042, 218, 58, 'PPL', 'P'),
(200497, 'Cabell City', 44.8952789306641, 0.783570435941327, -118.367218017578, -2.06589768083269, 218, 43, 'PPL', 'P'),
(118995, 'Cabery', 40.9958305358887, 0.715512222440889, -88.2052764892578, -1.53947249236949, 218, 18, 'PPL', 'P'),
(63344, 'Cabes Ford', 36.0794410705566, 0.629705038960481, -79.0074996948242, -1.3789410034431, 218, 33, 'PPL', 'P'),
(188206, 'Cabezon', 35.6263885498047, 0.6217977807889, -107.097221374512, -1.86919913272248, 218, 38, 'PPL', 'P'),
(63345, 'Cabin', 34.964168548584, 0.610239861395038, -77.8027801513672, -1.35791468084665, 218, 33, 'PPL', 'P'),
(19686, 'Cabin Bluff', 30.8891696929932, 0.539117714349977, -81.5166702270508, -1.42273429072447, 218, 13, 'PPL', 'P'),
(196126, 'Cabin City', 47.3663902282715, 0.826699464267806, -115.263328552246, -2.01172459004468, 218, 31, 'PPL', 'P'),
(180358, 'Cabin Cove', 36.4655609130859, 0.636444101519899, -118.653060913086, -2.07088658050274, 218, 6, 'PPL', 'P'),
(108441, 'Cabin Creek', 38.1958312988281, 0.666643016700853, -81.477783203125, -1.42205558412066, 218, 58, 'PPL', 'P'),
(186474, 'Cabin Creek', 39.7405586242676, 0.693603594575297, -104.029998779297, -1.81566599954441, 218, 7, 'PPL', 'P'),
(206939, 'Cabin Creek', 47.2416687011719, 0.824522662971802, -121.230003356934, -2.11586271078227, 218, 56, 'PPL', 'P'),
(209872, 'Cabin Creek', 46.6133308410645, 0.813556098497992, -104.421112060547, -1.8224922140505, 218, 31, 'PPL', 'P'),
(200498, 'Cabin Creek (historical)', 45.6861114501953, 0.79737306723899, -117.870826721191, -2.0572340183325, 218, 43, 'PPL', 'P'),
(45291, 'Cabin Creek Estates', 38.6202812194824, 0.674051065326099, -75.9158325195313, -1.3249812318584, 218, 25, 'PPL', 'P'),
(45292, 'Cabin Hill', 39.2097206115723, 0.684338723459021, -76.9619369506836, -1.34323919850171, 218, 25, 'PPL', 'P'),
(45293, 'Cabin John', 38.9752807617188, 0.680246976181196, -77.158332824707, -1.34666695314075, 218, 25, 'PPL', 'P'),
(45294, 'Cabin John Park', 38.976390838623, 0.680266350678126, -77.165283203125, -1.34678826012841, 218, 25, 'PPL', 'P'),
(45295, 'Cabin River Farms', 39.2786102294922, 0.685541074112164, -77.0952835083008, -1.34556653497833, 218, 25, 'PPL', 'P'),
(154562, 'Cabinet', 40.1180610656738, 0.700192255112153, -81.2172164916992, -1.41750783708519, 218, 41, 'PPL', 'P'),
(194670, 'Cabinet', 48.0844383239746, 0.839231767725501, -116.07250213623, -2.02584733330537, 218, 17, 'PPL', 'P'),
(108442, 'Cabins', 38.9988899230957, 0.680659033780858, -79.2055587768555, -1.38239778653802, 218, 58, 'PPL', 'P'),
(71986, 'Cabinville (historical)', 39.7041702270508, 0.692968497234341, -81.7255630493164, -1.42638015825679, 218, 41, 'PPL', 'P'),
(118998, 'Cable', 41.2838897705078, 0.720539804525767, -90.5072174072266, -1.57964894057443, 218, 18, 'PPL', 'P'),
(134515, 'Cable', 45.5116691589355, 0.794328474901784, -94.0738906860352, -1.64189913263254, 218, 28, 'PPL', 'P'),
(154558, 'Cable', 40.170280456543, 0.701103655416206, -83.6283264160156, -1.45958964389202, 218, 41, 'PPL', 'P'),
(173394, 'Cable', 46.2080612182617, 0.806482809221769, -91.2919387817383, -1.59334491227043, 218, 57, 'PPL', 'P'),
(180359, 'Cable', 35.1691703796387, 0.613817818319559, -118.475280761719, -2.06778373151669, 218, 6, 'PPL', 'P'),
(194671, 'Cable Car Crossing', 45.4538917541504, 0.793320068955025, -115.941940307617, -2.02356859951865, 218, 17, 'PPL', 'P'),
(196127, 'Cable City (historical)', 46.1952781677246, 0.806259702901448, -113.20832824707, -1.97585806858988, 218, 31, 'PPL', 'P'),
(159724, 'Cable Hollow', 41.9636116027832, 0.732403188496662, -79.0827789306641, -1.38025487396689, 218, 45, 'PPL', 'P'),
(143569, 'Cable Road', 42.9913902282715, 0.750341309493054, -70.7649993896484, -1.23508223452114, 218, 36, 'PPL', 'P'),
(200499, 'Cableville (historical)', 44.8569412231445, 0.782901316717445, -118.268058776855, -2.06416702559831, 218, 43, 'PPL', 'P'),
(85469, 'Cabo', 35.4305610656738, 0.618379946424919, -88.4741668701172, -1.54416551484243, 218, 50, 'PPL', 'P'),
(53784, 'Cabool', 37.1238899230957, 0.647934110305964, -92.1011123657227, -1.60746765553112, 218, 29, 'PPL', 'P'),
(7813, 'Cabool (historical)', 34.0333290100098, 0.593993646639173, -92.1500015258789, -1.60832093234439, 218, 4, 'PPL', 'P'),
(29363, 'Caborn', 37.9705581665039, 0.662711258825514, -87.7919387817383, -1.53225838845063, 218, 19, 'PPL', 'P'),
(7814, 'Cabot', 34.9744415283203, 0.610419158715427, -92.0163879394531, -1.60598893533586, 218, 4, 'PPL', 'P'),
(35093, 'Cabot', 37.6886100769043, 0.657790336342293, -86.6533279418945, -1.51238588039646, 218, 21, 'PPL', 'P'),
(39600, 'Cabot', 29.6888904571533, 0.51816888974125, -91.4638900756836, -1.59634602850284, 218, 22, 'PPL', 'P'),
(108443, 'Cabot', 38.0363883972168, 0.663860213098802, -81.6152801513672, -1.42445535857893, 218, 58, 'PPL', 'P'),
(159726, 'Cabot', 40.764720916748, 0.711478598653855, -79.7666702270508, -1.39219102881457, 218, 45, 'PPL', 'P'),
(171815, 'Cabot', 44.4013900756836, 0.774950449283013, -72.3127822875977, -1.26209614219642, 218, 55, 'PPL', 'P'),
(108444, 'Cabot Station', 38.9294395446777, 0.679446896010709, -81.1113891601563, -1.41566080171116, 218, 58, 'PPL', 'P'),
(188207, 'Cabra Springs (historical)', 35.314998626709, 0.616363001373348, -104.659172058105, -1.82664714482519, 218, 38, 'PPL', 'P'),
(180361, 'Cabrillo Village', 34.274169921875, 0.598197113524726, -119.154716491699, -2.07964212206054, 218, 6, 'PPL', 'P'),
(108445, 'Cacapehon', 39.4983291625977, 0.689375892923824, -78.4955596923828, -1.37000596482783, 218, 58, 'PPL', 'P'),
(15395, 'Cacema Town (historical)', 27.7666702270508, 0.484619817777518, -81.1999969482422, -1.41720729935617, 218, 12, 'PPL', 'P'),
(26669, 'Cache', 37.0999984741211, 0.647517125858285, -89.2613906860352, -1.55790516238031, 218, 18, 'PPL', 'P'),
(75287, 'Cache', 34.6294403076172, 0.604397751490758, -98.6283264160156, -1.72138903169117, 218, 42, 'PPL', 'P'),
(209858, 'Cache', 43.7880592346191, 0.764245806702412, -111.162216186523, -1.94014667626857, 218, 17, 'PPL', 'P'),
(203230, 'Cache Junction', 41.8355598449707, 0.730168263709867, -112.001937866211, -1.95480258437949, 218, 52, 'PPL', 'P'),
(7816, 'Cache Lake', 36.2955589294434, 0.633477007170415, -90.5330581665039, -1.58009994690503, 218, 4, 'PPL', 'P'),
(118997, 'Cache Lake', 41.6444396972656, 0.726832587865516, -88.0111083984375, -1.53608361988237, 218, 18, 'PPL', 'P'),
(75288, 'Cache Wye', 34.7094383239746, 0.605793980271259, -98.628059387207, -1.72138437115926, 218, 42, 'PPL', 'P'),
(180362, 'Cachuma Village', 34.586109161377, 0.603641480320203, -119.98999786377, -2.09422053218374, 218, 6, 'PPL', 'P'),
(19687, 'Cackle Corner', 33.5858306884766, 0.58618332753127, -84.7102813720703, -1.47847332023345, 218, 13, 'PPL', 'P'),
(159725, 'Cacoosing', 40.3497200012207, 0.704235466279112, -76.0083312988281, -1.32659564011121, 218, 45, 'PPL', 'P'),
(177815, 'Cactus', 33.5986099243164, 0.586406367272564, -112.029716491699, -1.95528741285594, 218, 5, 'PPL', 'P'),
(180363, 'Cactus', 32.8622207641602, 0.573553951851842, -114.896110534668, -2.0053154265653, 218, 6, 'PPL', 'P'),
(191209, 'Cactus', 36.0522193908691, 0.629229931022011, -102.001937866211, -1.78026965918006, 218, 51, 'PPL', 'P'),
(206940, 'Cactus', 46.6100006103516, 0.813497975007201, -118.931671142578, -2.07574924633711, 218, 56, 'PPL', 'P'),
(180364, 'Cactus City', 33.6783294677734, 0.587797735784076, -115.96305847168, -2.02393718101351, 218, 6, 'PPL', 'P'),
(85470, 'Cactus Cove', 35.8424987792969, 0.625569615840779, -84.0972213745117, -1.46777340476378, 218, 50, 'PPL', 'P'),
(177822, 'Cactus Cove Trailer Park', 33.452220916748, 0.583851397101769, -112.11499786377, -1.95677585358919, 218, 5, 'PPL', 'P'),
(177816, 'Cactus Flat', 32.7583312988281, 0.571740738623661, -109.715560913086, -1.91489777860575, 218, 5, 'PPL', 'P'),
(201952, 'Cactus Flat', 43.8355598449707, 0.765074848749754, -101.893890380859, -1.77838387481218, 218, 49, 'PPL', 'P'),
(196128, 'Cactus Flat (historical)', 48.0263900756836, 0.838218634667807, -106.417778015137, -1.85734060902057, 218, 31, 'PPL', 'P'),
(177817, 'Cactus Forest', 32.9599990844727, 0.575260505478364, -111.31916809082, -1.94288600376582, 218, 5, 'PPL', 'P'),
(177818, 'Cactus Gale V', 33.5999984741211, 0.586430602038484, -112.164169311523, -1.95763405725047, 218, 5, 'PPL', 'P'),
(177819, 'Cactus Gardens Mobile Home Park', 33.6108283996582, 0.586619619896852, -112.03694152832, -1.95541351353356, 218, 5, 'PPL', 'P'),
(169952, 'Cactus Heights', 43.5602798461914, 0.760270306406169, -96.6669387817383, -1.68715635956513, 218, 49, 'PPL', 'P'),
(45296, 'Cactus Hill', 38.6858291625977, 0.67519509275137, -77.0652770996094, -1.34504282434997, 218, 25, 'PPL', 'P'),
(189986, 'Cactus Springs', 36.5777816772461, 0.638402723343598, -115.726669311523, -2.01981141185276, 218, 39, 'PPL', 'P'),
(177820, 'Cactus Villa', 33.5883293151855, 0.58622693679412, -111.854438781738, -1.95222823971177, 218, 5, 'PPL', 'P'),
(177821, 'Cactus Wren Mobile Park', 33.4199981689453, 0.583289004058572, -111.63111114502, -1.94833043714033, 218, 5, 'PPL', 'P'),
(141422, 'Cadams', 40.103889465332, 0.699944914025912, -98.0097198486328, -1.71059231031588, 218, 35, 'PPL', 'P'),
(58858, 'Cadamy', 34.1813888549805, 0.596577778423904, -88.2591705322266, -1.54041312086651, 218, 30, 'PPL', 'P'),
(58859, 'Cadaretta', 33.7061080932617, 0.588282564260525, -89.4511108398438, -1.56121640372166, 218, 30, 'PPL', 'P'),
(108446, 'Caddell', 39.4630584716797, 0.688760303237852, -79.6505584716797, -1.39016449638307, 218, 58, 'PPL', 'P'),
(1272, 'Caddo', 34.5691719055176, 0.603345869439204, -87.1399993896484, -1.52087989953521, 218, 2, 'PPL', 'P'),
(35094, 'Caddo', 38.747501373291, 0.676271475884953, -84.245002746582, -1.47035267627952, 218, 21, 'PPL', 'P'),
(39601, 'Caddo', 32.7563896179199, 0.57170684989879, -93.9736099243164, -1.64014890316414, 218, 22, 'PPL', 'P'),
(53785, 'Caddo', 37.3419418334961, 0.651739834082715, -93.0469436645508, -1.62397552586409, 218, 29, 'PPL', 'P'),
(75291, 'Caddo', 34.1266708374023, 0.595622768857001, -96.2630615234375, -1.68010737163385, 218, 42, 'PPL', 'P'),
(92957, 'Caddo', 32.7180595397949, 0.571037863832962, -98.6680603027344, -1.72208251883903, 218, 51, 'PPL', 'P'),
(7823, 'Caddo Gap', 34.4000015258789, 0.60039328931766, -93.6191711425781, -1.63396277942605, 218, 4, 'PPL', 'P'),
(92958, 'Caddo Mills', 33.065559387207, 0.577102880320481, -96.2275009155273, -1.67948672194181, 218, 51, 'PPL', 'P'),
(7828, 'Caddo Valley', 34.1819381713867, 0.596587365803828, -93.0708312988281, -1.62439244373274, 218, 4, 'PPL', 'P'),
(186475, 'Caddoa', 38.047779083252, 0.664059018074176, -102.965560913086, -1.79708805409613, 218, 7, 'PPL', 'P'),
(39603, 'Cade', 30.0872192382813, 0.525121038477388, -91.9052810668945, -1.60404975458812, 218, 22, 'PPL', 'P'),
(75296, 'Cade', 34.0986099243164, 0.595133013532536, -95.9897232055664, -1.67533671801514, 218, 42, 'PPL', 'P'),
(191210, 'Cadelaria', 30.1383304595947, 0.526013097574024, -104.682502746582, -1.82705434215586, 218, 51, 'PPL', 'P'),
(92959, 'Cadena Colonia', 27.7649993896484, 0.484590656163581, -98.2539978027344, -1.71485576490499, 218, 51, 'PPL', 'P'),
(180365, 'Cadenasso', 38.7144393920898, 0.67569443545576, -122.128059387207, -2.13153674537793, 218, 6, 'PPL', 'P'),
(35096, 'Cadentown', 38.0122184753418, 0.663438368382133, -84.4266662597656, -1.47352330271532, 218, 21, 'PPL', 'P'),
(7826, 'Cades', 34.0152816772461, 0.593678661261243, -91.5863876342773, -1.59848401422596, 218, 4, 'PPL', 'P'),
(80073, 'Cades', 33.7863883972168, 0.589683719889043, -79.7827835083008, -1.39247225862568, 218, 48, 'PPL', 'P'),
(85471, 'Cades', 35.975830078125, 0.62789668600129, -88.783332824707, -1.5495614786851, 218, 50, 'PPL', 'P'),
(53786, 'Cadet', 37.9874992370605, 0.663006936285541, -90.6883316040039, -1.5828099796303, 218, 29, 'PPL', 'P'),
(100419, 'Cadet', 36.860279083252, 0.643333233206744, -82.7947235107422, -1.44504052854081, 218, 53, 'PPL', 'P'),
(39604, 'Cadeville', 32.4288902282715, 0.565990907251153, -92.3388900756836, -1.61161765945779, 218, 22, 'PPL', 'P'),
(15396, 'Cadillac', 29.7413902282715, 0.519085183603805, -82.5388870239258, -1.44057533949913, 218, 12, 'PPL', 'P'),
(58860, 'Cadillac', 31.6513900756836, 0.552420969653736, -91.1102828979492, -1.59017441899269, 218, 30, 'PPL', 'P'),
(130034, 'Cadillac', 44.2519416809082, 0.772342082732362, -85.4011077880859, -1.49053051575267, 218, 27, 'PPL', 'P'),
(45297, 'Cadillac Homes', 39.1761093139648, 0.683752095649903, -76.6097183227539, -1.33709182375748, 218, 25, 'PPL', 'P'),
(159729, 'Cadis', 41.978889465332, 0.732669837500806, -76.2427825927734, -1.33068758712612, 218, 45, 'PPL', 'P'),
(26672, 'Cadiz', 37.5791702270508, 0.655880250629461, -88.2263870239258, -1.53984094070631, 218, 18, 'PPL', 'P'),
(29364, 'Cadiz', 39.9513893127441, 0.69728328425346, -85.4866714477539, -1.49202388333393, 218, 19, 'PPL', 'P'),
(35095, 'Cadiz', 36.8650016784668, 0.643415658042482, -87.8352813720703, -1.53301485935827, 218, 21, 'PPL', 'P'),
(92960, 'Cadiz', 28.4269409179688, 0.496143715288454, -97.9391708374023, -1.70936099778588, 218, 51, 'PPL', 'P'),
(147519, 'Cadiz', 42.3205604553223, 0.738633121234684, -78.4674987792969, -1.36951620950336, 218, 40, 'PPL', 'P'),
(154559, 'Cadiz', 40.2727813720703, 0.702892633878466, -80.996940612793, -1.41366329773555, 218, 41, 'PPL', 'P'),
(180366, 'Cadiz', 34.5200004577637, 0.602487665777926, -115.511940002441, -2.01606367840875, 218, 6, 'PPL', 'P'),
(154560, 'Cadiz Junction', 40.3591690063477, 0.704400382529615, -80.9319381713867, -1.41252879111118, 218, 41, 'PPL', 'P'),
(19688, 'Cadley', 33.5336112976074, 0.585271927227218, -82.6597213745117, -1.44268429676636, 218, 13, 'PPL', 'P'),
(31942, 'Cadmus', 38.3455581665039, 0.669256243520493, -94.899169921875, -1.65630297254629, 218, 20, 'PPL', 'P'),
(71987, 'Cadmus', 38.7669410705566, 0.676610762607829, -82.4369430541992, -1.43879608157485, 218, 41, 'PPL', 'P'),
(130036, 'Cadmus', 41.8738899230957, 0.730837249775695, -84.1605606079102, -1.46887888293227, 218, 27, 'PPL', 'P'),
(159727, 'Cadogan', 40.7538909912109, 0.711289580795486, -79.5813903808594, -1.38895728546094, 218, 45, 'PPL', 'P'),
(147520, 'Cadosia', 41.975830078125, 0.73261644112095, -75.267219543457, -1.31366079985475, 218, 40, 'PPL', 'P'),
(173397, 'Cadott', 44.9480590820313, 0.784491623362385, -91.1505584716797, -1.59087736036242, 218, 57, 'PPL', 'P'),
(7827, 'Cadron (historical)', 35.1152801513672, 0.61287725640157, -92.5500030517578, -1.61530227598397, 218, 4, 'PPL', 'P'),
(19689, 'Cadwell', 32.3394393920898, 0.564429695641121, -83.0422210693359, -1.44936017582892, 218, 13, 'PPL', 'P'),
(26673, 'Cadwell', 39.6811103820801, 0.692566027014602, -88.5216674804688, -1.54499455688977, 218, 18, 'PPL', 'P'),
(180367, 'Cadwell', 38.3583297729492, 0.669479150103733, -122.776672363281, -2.14285717738159, 218, 6, 'PPL', 'P'),
(100420, 'Cady', 37.7425003051758, 0.658730898260282, -77.3622207641602, -1.35022546898932, 218, 53, 'PPL', 'P'),
(130037, 'Cady', 42.5602798461914, 0.742817013886226, -82.9644393920898, -1.44800262946325, 218, 27, 'PPL', 'P'),
(124367, 'Cadys Corners', 42.1680603027344, 0.735971491462232, -72.5055618286133, -1.26546077991762, 218, 23, 'PPL', 'P'),
(171817, 'Cadys Falls', 44.5780601501465, 0.778033923772134, -72.6122207641602, -1.26732232951959, 218, 55, 'PPL', 'P'),
(147521, 'Cadyville', 44.6980590820313, 0.7801283002324, -73.6319427490234, -1.28511983561042, 218, 40, 'PPL', 'P'),
(39606, 'Caernarvon', 29.8636093139648, 0.521218309057932, -89.9063873291016, -1.56916247746613, 218, 22, 'PPL', 'P'),
(45298, 'Caernarvon Woods', 38.5455589294434, 0.672746915340287, -77.0299987792969, -1.34442710150594, 218, 25, 'PPL', 'P'),
(58861, 'Caesar', 30.5841693878174, 0.533794454805072, -89.5466690063477, -1.56288420835433, 218, 30, 'PPL', 'P'),
(92961, 'Caesar', 28.6552791595459, 0.500128969412189, -97.898063659668, -1.70864354218822, 218, 51, 'PPL', 'P'),
(80072, 'Caesars Head', 35.1055603027344, 0.612707613040132, -82.6236114501953, -1.4420540596944, 218, 48, 'PPL', 'P'),
(1274, 'Caffee Junction', 33.2452812194824, 0.580239618031404, -87.1377792358398, -1.52084115054135, 218, 2, 'PPL', 'P'),
(39607, 'Caffery', 29.8055591583252, 0.520205142710724, -91.4794387817383, -1.59661740461792, 218, 22, 'PPL', 'P'),
(85473, 'Caffey', 35.0580596923828, 0.611878570992791, -88.4947204589844, -1.54452424264126, 218, 50, 'PPL', 'P'),
(130038, 'Caffey', 46.1688919067383, 0.805799175769946, -85.1852798461914, -1.48676360754881, 218, 27, 'PPL', 'P'),
(130039, 'Caffey Corner', 46.1619415283203, 0.805677868782293, -85.1852798461914, -1.48676360754881, 218, 27, 'PPL', 'P'),
(53787, 'Caffeyville', 37.6019401550293, 0.656277660843128, -92.7122192382813, -1.61813348253884, 218, 29, 'PPL', 'P'),
(63347, 'Caffys Inlet Hamlet', 36.2008285522461, 0.631823650186666, -75.7652816772461, -1.32235362396888, 218, 33, 'PPL', 'P'),
(19690, 'Cagle', 34.396671295166, 0.600335165826869, -84.4330596923828, -1.47363488916499, 218, 13, 'PPL', 'P'),
(85474, 'Cagle', 35.4749984741211, 0.619155525513377, -85.4611129760742, -1.49157780385135, 218, 50, 'PPL', 'P'),
(29366, 'Cagle Mill', 39.4872207641602, 0.689182014796466, -86.9397201538086, -1.51738436744643, 218, 19, 'PPL', 'P'),
(7833, 'Caglesville', 35.3952789306641, 0.617764157001866, -92.9644393920898, -1.62253555466268, 218, 4, 'PPL', 'P'),
(147522, 'Cagwin Corners', 43.1497192382813, 0.753104672019147, -75.5758285522461, -1.31904704315943, 218, 40, 'PPL', 'P'),
(1275, 'Cahaba', 32.3166694641113, 0.564032285427454, -87.1013870239258, -1.52020598662137, 218, 2, 'PPL', 'P'),
(63348, 'Cahaba', 36.0402793884277, 0.629021538666712, -77.1566696166992, -1.34663792468487, 218, 33, 'PPL', 'P'),
(1276, 'Cahaba Cliffs', 33.4286117553711, 0.583439339502107, -86.7194366455078, -1.51353969493874, 218, 2, 'PPL', 'P'),
(1277, 'Cahaba Commons', 33.4277801513672, 0.583424825274166, -86.7141723632813, -1.51344781588113, 218, 2, 'PPL', 'P'),
(1279, 'Cahaba Crest', 33.6300010681152, 0.586954246087821, -86.5988922119141, -1.51143579767758, 218, 2, 'PPL', 'P'),
(1280, 'Cahaba Heights', 33.4638900756836, 0.584055062346133, -86.7319412231445, -1.51375794099007, 218, 2, 'PPL', 'P'),
(1281, 'Cahaba Hills', 33.538890838623, 0.585364072600934, -86.5741729736328, -1.51100436558098, 218, 2, 'PPL', 'P'),
(1283, 'Cahaba Oaks', 33.4619407653809, 0.584021040463207, -86.7211074829102, -1.51356885655267, 218, 2, 'PPL', 'P'),
(1284, 'Cahaba River Estates', 33.3547210693359, 0.582149703744236, -86.8261108398438, -1.51540151085681, 218, 2, 'PPL', 'P'),
(1286, 'Cahaba Valley Estates', 33.3086090087891, 0.581344896462814, -86.8144378662109, -1.51519777903342, 218, 2, 'PPL', 'P'),
(26675, 'Cahokia', 38.5708312988281, 0.673188001395832, -90.1900024414063, -1.57411249498426, 218, 18, 'PPL', 'P'),
(186476, 'Cahone', 37.6588897705078, 0.657271619140973, -108.807220458984, -1.89904424695261, 218, 7, 'PPL', 'P'),
(203233, 'Cahoon Haynes Addition', 40.6647186279297, 0.709733229454444, -111.888610839844, -1.95282465463789, 218, 52, 'PPL', 'P'),
(124366, 'Cahoon Hollow', 41.9444389343262, 0.732068562305693, -69.9861068725586, -1.22148799557878, 218, 23, 'PPL', 'P'),
(147523, 'Cahoonzie', 41.4500007629395, 0.723438988267455, -74.7125015258789, -1.30397914402787, 218, 40, 'PPL', 'P'),
(180368, 'Cahuilla', 33.540828704834, 0.585397894746778, -116.743057250977, -2.03755072787378, 218, 6, 'PPL', 'P'),
(180369, 'Cahuilla Hills', 33.6886100769043, 0.58797716626252, -116.415557861328, -2.03183478522614, 218, 6, 'PPL', 'P'),
(85475, 'Caigletown', 35.9058303833008, 0.626674960851216, -87.8502807617188, -1.53327664809342, 218, 50, 'PPL', 'P'),
(58866, 'Caile', 33.2999992370605, 0.581194627598306, -90.5899963378906, -1.5810937054658, 218, 30, 'PPL', 'P'),
(7834, 'Cain', 35.5997200012207, 0.621332326809381, -94.1774978637695, -1.6437074190127, 218, 4, 'PPL', 'P'),
(92962, 'Cain City', 30.1969394683838, 0.527036017748723, -98.8125, -1.7246034671269, 218, 51, 'PPL', 'P'),
(127013, 'Cain Crest Trailer Park', 43.1327781677246, 0.752808994559121, -70.6980590820313, -1.23391390575093, 218, 26, 'PPL', 'P'),
(1287, 'Cain Landing', 34.5499992370605, 0.603011243248235, -86.8013916015625, -1.51497007876022, 218, 2, 'PPL', 'P'),
(19691, 'Cain Manor', 34.0561103820801, 0.594391256589921, -83.9291687011719, -1.46484033229722, 218, 13, 'PPL', 'P'),
(85480, 'Cain Mill', 36.2652816772461, 0.632948569431116, -83.1986083984375, -1.45208964963014, 218, 50, 'PPL', 'P'),
(193415, 'Cain Rock', 40.1369400024414, 0.700521754718023, -123.591667175293, -2.15708152023786, 218, 6, 'PPL', 'P'),
(80074, 'Caines', 33.3050003051758, 0.581281912703034, -79.2133331298828, -1.38253347459556, 218, 48, 'PPL', 'P'),
(192503, 'Caineville', 38.3330612182617, 0.669038130627216, -111.018058776855, -1.93763065482872, 218, 52, 'PPL', 'P'),
(80075, 'Cainhoy', 32.9291687011719, 0.574722413780114, -79.8313903808594, -1.39332060859093, 218, 48, 'PPL', 'P'),
(159732, 'Cains', 40.0269393920898, 0.698601881888185, -75.9544372558594, -1.32565501161419, 218, 45, 'PPL', 'P'),
(147527, 'Cains Corners', 43.3052787780762, 0.755819698171456, -76.5972213745117, -1.33687371086421, 218, 40, 'PPL', 'P'),
(19692, 'Cains Courthouse (historical)', 34.0738906860352, 0.594701581435943, -83.8330612182617, -1.46316294028464, 218, 13, 'PPL', 'P'),
(85476, 'Cainsville', 35.985279083252, 0.628061602251793, -86.248893737793, -1.50532717192721, 218, 50, 'PPL', 'P'),
(139066, 'Cainsville', 40.4375, 0.705767516275207, -93.7750015258789, -1.63668253268929, 218, 29, 'PPL', 'P'),
(173400, 'Cainville', 42.7097206115723, 0.745425247278822, -89.2519378662109, -1.55774017955078, 218, 57, 'PPL', 'P'),
(39608, 'Caire', 29.9977798461914, 0.523560026604438, -90.8533325195313, -1.58568978887506, 218, 22, 'PPL', 'P'),
(159733, 'Cairnbrook', 40.1188888549805, 0.700206702761067, -78.8183288574219, -1.37563934948167, 218, 45, 'PPL', 'P'),
(180370, 'Cairns Corner', 36.2125015258789, 0.632027382010057, -119.134719848633, -2.07929311479968, 218, 6, 'PPL', 'P'),
(1288, 'Cairo', 34.8705596923828, 0.608606078645301, -87.1444396972656, -1.52095739752294, 218, 2, 'PPL', 'P'),
(7835, 'Cairo', 33.2200012207031, 0.579798398817805, -92.8697204589844, -1.62088239741602, 218, 4, 'PPL', 'P'),
(15397, 'Cairo', 30.3047199249268, 0.528917141584701, -85.4772186279297, -1.4918589005044, 218, 12, 'PPL', 'P'),
(19693, 'Cairo', 30.8772201538086, 0.53890915554711, -84.2013931274414, -1.46959154483998, 218, 13, 'PPL', 'P'),
(26677, 'Cairo', 37.0052795410156, 0.645863968611619, -89.1763916015625, -1.55642164849508, 218, 18, 'PPL', 'P'),
(31943, 'Cairo', 37.6500015258789, 0.657116490007476, -98.5541687011719, -1.72009473540139, 218, 20, 'PPL', 'P'),
(35097, 'Cairo', 37.7080612182617, 0.658129822802251, -87.6458282470703, -1.52970827854883, 218, 21, 'PPL', 'P'),
(53788, 'Cairo', 39.5119400024414, 0.689613446893059, -92.4402770996094, -1.6133871968441, 218, 29, 'PPL', 'P'),
(58865, 'Cairo', 34.7266693115234, 0.606094717737356, -88.3480606079102, -1.54196454535954, 218, 30, 'PPL', 'P'),
(63349, 'Cairo', 34.8844413757324, 0.608848359725471, -79.9330596923828, -1.39509507282525, 218, 33, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(75300, 'Cairo', 34.5905609130859, 0.603719178045006, -96.1316680908203, -1.67781412361919, 218, 42, 'PPL', 'P'),
(85478, 'Cairo', 36.3608283996582, 0.634616174326696, -86.3636093139648, -1.50732933643473, 218, 50, 'PPL', 'P'),
(108447, 'Cairo', 39.208610534668, 0.68431934896209, -81.1575012207031, -1.41646560899259, 218, 58, 'PPL', 'P'),
(114791, 'Cairo', 41.1836090087891, 0.718789575057368, -91.3272171020508, -1.59396063511446, 218, 16, 'PPL', 'P'),
(122313, 'Cairo', 40.540828704834, 0.707570942386381, -86.9247207641602, -1.51712257871128, 218, 19, 'PPL', 'P'),
(141424, 'Cairo', 41.0011100769043, 0.715604367814605, -98.6072235107422, -1.72102071651241, 218, 35, 'PPL', 'P'),
(147524, 'Cairo', 42.2988891601563, 0.738254885780866, -73.998893737793, -1.2915243385579, 218, 40, 'PPL', 'P'),
(154564, 'Cairo', 40.9044418334961, 0.713917188685013, -81.3605575561523, -1.42000961061321, 218, 41, 'PPL', 'P'),
(200500, 'Cairo', 43.9961090087891, 0.767876960269708, -117.008056640625, -2.04217583973892, 218, 43, 'PPL', 'P'),
(85479, 'Cairo Bend', 36.2388916015625, 0.632487975720587, -86.4002838134766, -1.50796942720273, 218, 50, 'PPL', 'P'),
(26679, 'Cairo Junction', 37.040828704834, 0.64648441856658, -89.1916732788086, -1.55668836407826, 218, 18, 'PPL', 'P'),
(147525, 'Cairo Junction', 42.253059387207, 0.73745500534746, -73.9669418334961, -1.29096667262564, 218, 40, 'PPL', 'P'),
(63350, 'Cajahs Mountain', 35.8347206115723, 0.625433861204212, -81.5416717529297, -1.42317064966908, 218, 33, 'PPL', 'P'),
(180371, 'Cajon', 34.2988891601563, 0.598628545621319, -117.455558776855, -2.04998622542585, 218, 6, 'PPL', 'P'),
(180372, 'Cajon Junction', 34.3116683959961, 0.598851585362613, -117.473892211914, -2.05030620423082, 218, 6, 'PPL', 'P'),
(200501, 'Cake (historical)', 44.4208297729492, 0.775289736005889, -117.572219848633, -2.05202234523727, 218, 43, 'PPL', 'P'),
(45301, 'Cal Acres', 38.3072204589844, 0.668587124296611, -76.5086135864258, -1.3353272132192, 218, 25, 'PPL', 'P'),
(180373, 'Cal-Ida', 39.5261116027832, 0.6898607879793, -121.014717102051, -2.11210525680028, 218, 6, 'PPL', 'P'),
(189987, 'Cal-Nev-Ari', 35.3055610656738, 0.616198284859926, -114.882781982422, -2.00508279944408, 218, 39, 'PPL', 'P'),
(63352, 'Cal-Vel', 36.4291687011719, 0.635808937599916, -78.9694366455078, -1.37827667790918, 218, 33, 'PPL', 'P'),
(177823, 'Calabasas', 31.4672203063965, 0.549206600797038, -110.974716186523, -1.93687418392108, 218, 5, 'PPL', 'P'),
(180374, 'Calabasas', 34.1577796936035, 0.596165720824241, -118.637496948242, -2.07061493807155, 218, 6, 'PPL', 'P'),
(180375, 'Calabasas Highlands', 34.1308288574219, 0.595695339996706, -118.644439697266, -2.07073611190115, 218, 6, 'PPL', 'P'),
(63351, 'Calabash', 33.8905601501465, 0.59150185996524, -78.5686111450195, -1.3712809531997, 218, 33, 'PPL', 'P'),
(180376, 'Calada', 35.579719543457, 0.620983252969499, -115.370559692383, -2.01359612650074, 218, 6, 'PPL', 'P'),
(63357, 'Calahaln', 35.9194412231445, 0.626912514820451, -80.6630630493164, -1.40783603495435, 218, 33, 'PPL', 'P'),
(71989, 'Calais', 39.8569412231445, 0.695634854117728, -81.2763900756836, -1.41854061095592, 218, 41, 'PPL', 'P'),
(127014, 'Calais', 45.1888885498047, 0.788694890510857, -67.279167175293, -1.17424298520856, 218, 26, 'PPL', 'P'),
(196129, 'Calais', 48.1477813720703, 0.84033731247302, -104.815277099609, -1.8293716917784, 218, 31, 'PPL', 'P'),
(144932, 'Calais Crossroads', 40.8274993896484, 0.712574289705341, -74.5947189331055, -1.30192344998244, 218, 37, 'PPL', 'P'),
(92963, 'Calallen', 27.8672199249268, 0.486374741067339, -97.6227798461914, -1.7038389332656, 218, 51, 'PPL', 'P'),
(7836, 'Calamine', 36.0113906860352, 0.628517335693333, -91.3988876342773, -1.59521152187847, 218, 4, 'PPL', 'P'),
(173401, 'Calamine', 42.7425003051758, 0.745997360859998, -90.1619415283203, -1.5736227396598, 218, 57, 'PPL', 'P'),
(196130, 'Calamity Janes Trailer Court', 45.0319404602051, 0.785955629592629, -110.705001831055, -1.93216678037826, 218, 31, 'PPL', 'P'),
(154565, 'Calamoutier', 40.6652793884277, 0.70974301657145, -81.7844390869141, -1.4274077389634, 218, 41, 'PPL', 'P'),
(114792, 'Calamus', 41.8258285522461, 0.729998420611347, -90.758056640625, -1.58402691109041, 218, 16, 'PPL', 'P'),
(203234, 'Calann', 40.648609161377, 0.709452066222359, -111.842498779297, -1.95201984735647, 218, 52, 'PPL', 'P'),
(200502, 'Calapooia', 44.3274993896484, 0.773660813525142, -122.739440917969, -2.14220736607561, 218, 43, 'PPL', 'P'),
(92964, 'Calaveras', 29.2219390869141, 0.510019050883876, -98.2597198486328, -1.71495563344587, 218, 51, 'PPL', 'P'),
(180378, 'Calaveritas', 38.1580581665039, 0.665983751173004, -120.60888671875, -2.10502218040705, 218, 6, 'PPL', 'P'),
(180379, 'Calavo Gardens', 32.7627792358398, 0.571818369769437, -116.96028137207, -2.04134200400162, 218, 6, 'PPL', 'P'),
(39609, 'Calcasieu', 31.0894393920898, 0.542613079991192, -92.7113876342773, -1.6181189683109, 218, 22, 'PPL', 'P'),
(1289, 'Calcis', 33.4263916015625, 0.583400590508246, -86.4316711425781, -1.50851723943896, 218, 2, 'PPL', 'P'),
(130040, 'Calcite', 45.4088897705078, 0.792534636170534, -83.7866668701172, -1.4623532061552, 218, 27, 'PPL', 'P'),
(147528, 'Calcium', 44.021671295166, 0.768323106331324, -75.8463897705078, -1.32376922724631, 218, 40, 'PPL', 'P'),
(29367, 'Calcutta', 39.6041717529297, 0.691223194613957, -87.0694427490234, -1.51964845384716, 218, 19, 'PPL', 'P'),
(108448, 'Calcutta', 39.3505592346191, 0.686796821145164, -81.1947174072266, -1.41711515398246, 218, 58, 'PPL', 'P'),
(147529, 'Calcutta', 42.6327781677246, 0.74408234829915, -74.6766662597656, -1.30335370064587, 218, 40, 'PPL', 'P'),
(154566, 'Calcutta', 40.6733283996582, 0.709883498318952, -80.5766677856445, -1.40632815314515, 218, 41, 'PPL', 'P'),
(191211, 'Calcutta Colonia', 31.6709995269775, 0.552763219143325, -106.276000976563, -1.85486613289372, 218, 51, 'PPL', 'P'),
(194672, 'Calder', 47.2777786254883, 0.82515290004377, -116.190277099609, -2.02790289419275, 218, 17, 'PPL', 'P'),
(92965, 'Calder Highlands', 30.0966701507568, 0.525285988017405, -94.144172668457, -1.64312578463063, 218, 51, 'PPL', 'P'),
(92966, 'Calder Terrace', 30.0888900756836, 0.525150200091325, -94.1575012207031, -1.64335841175185, 218, 51, 'PPL', 'P'),
(31944, 'Calderhead', 39.6830596923828, 0.692600048897528, -97.3308334350586, -1.69874350715196, 218, 20, 'PPL', 'P'),
(180380, 'Calders Corner', 35.3836097717285, 0.617560491757502, -119.250282287598, -2.08131005985125, 218, 6, 'PPL', 'P'),
(85481, 'Calderwood', 35.5091705322266, 0.619751940439501, -83.9941711425781, -1.4659748389216, 218, 50, 'PPL', 'P'),
(130041, 'Calderwood', 46.4097213745117, 0.810002442918418, -89.0852813720703, -1.5548314750082, 218, 27, 'PPL', 'P'),
(180381, 'Caldor', 38.6061096191406, 0.673803724239858, -120.431671142578, -2.10192918511703, 218, 6, 'PPL', 'P'),
(1290, 'Caldwell', 33.8122215270996, 0.590134593061593, -86.3644409179688, -1.50734385066267, 218, 2, 'PPL', 'P'),
(7837, 'Caldwell', 35.0744400024414, 0.61216446133581, -90.8166732788086, -1.58504996442316, 218, 4, 'PPL', 'P'),
(31945, 'Caldwell', 37.0322189331055, 0.646334149702072, -97.6066665649414, -1.70355770345449, 218, 20, 'PPL', 'P'),
(35099, 'Caldwell', 38.8066711425781, 0.677304183176658, -84.3913879394531, -1.47290757987129, 218, 21, 'PPL', 'P'),
(63355, 'Caldwell', 36.1897201538086, 0.631629772059309, -79.0175018310547, -1.37911557365255, 218, 33, 'PPL', 'P'),
(71990, 'Caldwell', 39.7477798461914, 0.693729628673885, -81.5166702270508, -1.42273429072447, 218, 41, 'PPL', 'P'),
(80076, 'Caldwell', 33.0416717529297, 0.576685962451829, -80.9038925170898, -1.41203930210282, 218, 48, 'PPL', 'P'),
(85482, 'Caldwell', 35.5036087036133, 0.619654868217767, -86.3822174072266, -1.50765410892966, 218, 50, 'PPL', 'P'),
(108449, 'Caldwell', 37.7805595397949, 0.659395157215175, -80.394172668457, -1.40314301248141, 218, 58, 'PPL', 'P'),
(118999, 'Caldwell', 40.642219543457, 0.709340546351712, -89.5155563354492, -1.56234118980806, 218, 18, 'PPL', 'P'),
(144933, 'Caldwell', 40.8397216796875, 0.712787608908656, -74.2769393920898, -1.29637715069624, 218, 37, 'PPL', 'P'),
(159735, 'Caldwell', 41.4000015258789, 0.722566336957263, -77.0449981689453, -1.3446888902411, 218, 45, 'PPL', 'P'),
(173402, 'Caldwell', 42.8352813720703, 0.747616695960821, -88.2763900756836, -1.54071365859553, 218, 57, 'PPL', 'P'),
(191212, 'Caldwell', 33.7658309936523, 0.589324925511182, -101.957221984863, -1.77948921982261, 218, 51, 'PPL', 'P'),
(194673, 'Caldwell', 43.6630592346191, 0.762064145137419, -116.686393737793, -2.03656176300298, 218, 17, 'PPL', 'P'),
(196131, 'Caldwell', 48.9716682434082, 0.854716851041821, -108.171943664551, -1.88795657522823, 218, 31, 'PPL', 'P'),
(19695, 'Caldwell (historical)', 34.8730583190918, 0.608649687908151, -83.8797225952148, -1.46397733494598, 218, 13, 'PPL', 'P'),
(63356, 'Caldwell (historical)', 35.2863883972168, 0.615863658668958, -81.1011123657227, -1.41548143781175, 218, 33, 'PPL', 'P'),
(180382, 'Caldwell (historical)', 36.5786094665527, 0.638417170992512, -120.146667480469, -2.09695493283298, 218, 6, 'PPL', 'P'),
(199213, 'Caldwell (historical)', 41.9000015258789, 0.731292983217235, -103.966667175293, -1.81456065453398, 218, 35, 'PPL', 'P'),
(127016, 'Caldwell Corner', 44.1719398498535, 0.770945787372834, -70.4588928222656, -1.22973966705833, 218, 26, 'PPL', 'P'),
(92969, 'Caldwell Crossing', 31.6238899230957, 0.551941001446276, -97.3344421386719, -1.69880649091174, 218, 51, 'PPL', 'P'),
(80077, 'Caldwell Crossroad', 34.5736083984375, 0.603423300847898, -80.9722213745117, -1.41323186563896, 218, 48, 'PPL', 'P'),
(75297, 'Caldwell Hill', 34.1872215270996, 0.596679577756572, -97.01611328125, -1.69325060424561, 218, 42, 'PPL', 'P'),
(35100, 'Caldwell Manor', 37.6580581665039, 0.657257104913032, -84.7819366455078, -1.47972394068135, 218, 21, 'PPL', 'P'),
(180383, 'Caldwell Pines', 38.8455581665039, 0.677982889780465, -122.806938171387, -2.1433854153838, 218, 6, 'PPL', 'P'),
(114793, 'Caldwell Siding', 41.452220916748, 0.723477737261316, -94.2369384765625, -1.64474485341534, 218, 16, 'PPL', 'P'),
(80078, 'Caldwell Village', 34.4983291625977, 0.602109430324107, -82.6533279418945, -1.44257271031669, 218, 48, 'PPL', 'P'),
(154567, 'Caldwells Addition', 41.186939239502, 0.718847698548158, -83.4244384765625, -1.45603112804346, 218, 41, 'PPL', 'P'),
(92970, 'Caldwood', 30.076940536499, 0.524941641288458, -94.1572189331055, -1.64335348490383, 218, 51, 'PPL', 'P'),
(92971, 'Caldwood Acres', 30.0613899230957, 0.524670231883865, -94.1536102294922, -1.64329050114405, 218, 51, 'PPL', 'P'),
(7838, 'Cale', 33.6261100769043, 0.586886335480024, -93.2402801513672, -1.62734988412327, 218, 4, 'PPL', 'P'),
(29369, 'Cale', 38.7958297729492, 0.677114965581208, -86.7513885498047, -1.514097360871, 218, 19, 'PPL', 'P'),
(35101, 'Caleast', 37.6902809143066, 0.65781949795623, -84.3319396972656, -1.4718700123106, 218, 21, 'PPL', 'P'),
(15398, 'Caleb', 30.2766704559326, 0.528427585997317, -81.8319396972656, -1.42823678101074, 218, 12, 'PPL', 'P'),
(19696, 'Caleb', 33.7825012207031, 0.589615875860273, -84.0122222900391, -1.46628989087855, 218, 13, 'PPL', 'P'),
(180384, 'Caleb (historical)', 33.5366706848145, 0.585325323607074, -116.014167785645, -2.02482920682064, 218, 6, 'PPL', 'P'),
(200503, 'Caleb (historical)', 44.523609161377, 0.777083574737139, -119.911109924316, -2.09284367790017, 218, 43, 'PPL', 'P'),
(1292, 'Calebee', 32.3852806091309, 0.565229775811608, -85.8844375610352, -1.49896621166355, 218, 2, 'PPL', 'P'),
(45303, 'Calebs Delight', 39.4355583190918, 0.688280335030392, -77.1324996948242, -1.3462160799682, 218, 25, 'PPL', 'P'),
(19697, 'Calebs Meadows', 33.3852806091309, 0.582683068331552, -84.4250030517578, -1.47349427425943, 218, 13, 'PPL', 'P'),
(1296, 'Caledonia', 31.8902797698975, 0.55659038136685, -87.0875015258789, -1.51996363896217, 218, 2, 'PPL', 'P'),
(7839, 'Caledonia', 33.0555610656738, 0.576928376690054, -92.6536102294922, -1.61711056236414, 218, 4, 'PPL', 'P'),
(35102, 'Caledonia', 36.8202781677246, 0.642635085526979, -87.6949996948242, -1.53056648221011, 218, 21, 'PPL', 'P'),
(53792, 'Caledonia', 37.7633285522461, 0.659094419749078, -90.7727813720703, -1.5842839061356, 218, 29, 'PPL', 'P'),
(58867, 'Caledonia', 33.6827812194824, 0.587875433508879, -88.3244400024414, -1.54155228802279, 218, 30, 'PPL', 'P'),
(92972, 'Caledonia', 31.9238891601563, 0.557176975886454, -94.5266723632813, -1.64980166369319, 218, 51, 'PPL', 'P'),
(100421, 'Caledonia', 37.8211097717285, 0.660102892274864, -78.1066665649414, -1.3632184993156, 218, 53, 'PPL', 'P'),
(113274, 'Caledonia', 41.2872200012207, 0.720597928016559, -78.4602813720703, -1.3693902419838, 218, 45, 'PPL', 'P'),
(119000, 'Caledonia', 42.3694381713867, 0.739486198310864, -88.8925018310547, -1.55146683728699, 218, 18, 'PPL', 'P'),
(130043, 'Caledonia', 42.7891693115234, 0.746811888679399, -85.5166702270508, -1.49254746080424, 218, 27, 'PPL', 'P'),
(134517, 'Caledonia', 43.6347198486328, 0.761569529543964, -91.4966735839844, -1.59691820866305, 218, 28, 'PPL', 'P'),
(139748, 'Caledonia', 47.4575004577637, 0.828289637754692, -96.8852767944336, -1.69096707676892, 218, 34, 'PPL', 'P'),
(147531, 'Caledonia', 42.9730606079102, 0.750021397267108, -77.8530578613281, -1.35879219242583, 218, 40, 'PPL', 'P'),
(154568, 'Caledonia', 40.6363906860352, 0.709238813598071, -82.9691696166992, -1.44808518745704, 218, 41, 'PPL', 'P'),
(173403, 'Caledonia', 42.8077812194824, 0.747136727753362, -87.9241714477539, -1.5345662838513, 218, 57, 'PPL', 'P'),
(206941, 'Caledonia', 47.309440612793, 0.825705505969961, -122.430000305176, -2.13680660854298, 218, 56, 'PPL', 'P'),
(29368, 'Caledonia (historical)', 39.0988883972168, 0.682404336401242, -87.3349990844727, -1.52428328625028, 218, 19, 'PPL', 'P'),
(114798, 'Caledonia (historical)', 40.624439239502, 0.70903022150569, -94.1616668701172, -1.64343111604961, 218, 16, 'PPL', 'P'),
(119001, 'Caledonia (historical)', 41.1183280944824, 0.717650208164004, -89.2502822875977, -1.55771128425296, 218, 18, 'PPL', 'P'),
(196132, 'Caledonia (historical)', 45.163890838623, 0.788258598145275, -109.212501525879, -1.90611773596592, 218, 31, 'PPL', 'P'),
(134518, 'Caledonia Mobile Home Park', 43.6347198486328, 0.761569529543964, -91.4966735839844, -1.59691820866305, 218, 28, 'PPL', 'P'),
(77962, 'Caledonia Park', 39.9041709899902, 0.696459169054135, -77.478889465332, -1.35226172195879, 218, 45, 'PPL', 'P'),
(194674, 'Calendar', 45.6241683959961, 0.796291956994472, -115.668891906738, -2.018803005906, 218, 17, 'PPL', 'P'),
(1293, 'Calera', 33.1027793884277, 0.577752491889379, -86.7536087036133, -1.51413610986486, 218, 2, 'PPL', 'P'),
(75298, 'Calera', 33.934440612793, 0.592267718515719, -96.4283294677734, -1.68299184141052, 218, 42, 'PPL', 'P'),
(80079, 'Calestown', 33.2902793884277, 0.581024984236868, -79.7869415283203, -1.39254482976539, 218, 48, 'PPL', 'P'),
(180386, 'Calexico', 32.6788902282715, 0.570354230381139, -115.498062133789, -2.01582146390761, 218, 6, 'PPL', 'P'),
(180385, 'Calexico Lodge', 32.6661109924316, 0.570131190639845, -116.279998779297, -2.02946883291372, 218, 6, 'PPL', 'P'),
(92973, 'Calf Creek', 30.978609085083, 0.540678726222927, -99.4686126708984, -1.73605479349813, 218, 51, 'PPL', 'P'),
(180387, 'Calflax', 36.3424987792969, 0.634296262100751, -120.101936340332, -2.09617422715942, 218, 6, 'PPL', 'P'),
(26688, 'Calftown (historical)', 39.9263916015625, 0.696846991887878, -91.4033279418945, -1.59528901986619, 218, 18, 'PPL', 'P'),
(92974, 'Calgary', 31.6172199249268, 0.551824588017126, -94.1191711425781, -1.64268942568602, 218, 51, 'PPL', 'P'),
(19700, 'Calgary Place', 33.3611106872559, 0.582261223614883, -84.5486068725586, -1.47565156790045, 218, 13, 'PPL', 'P'),
(92975, 'Calgary Woods', 29.8633308410645, 0.521213448788942, -95.3144378662109, -1.66355076545294, 218, 51, 'PPL', 'P'),
(180391, 'Calgro', 36.4897193908691, 0.636865746499486, -119.284721374512, -2.08191113530929, 218, 6, 'PPL', 'P'),
(186477, 'Calhan', 39.0355606079102, 0.681299057969831, -104.296669006348, -1.82032027302349, 218, 7, 'PPL', 'P'),
(1294, 'Calhoun', 32.0499992370605, 0.559378011948377, -86.5449981689453, -1.51049516918056, 218, 2, 'PPL', 'P'),
(7841, 'Calhoun', 33.8927803039551, 0.591540608959101, -91.7886123657227, -1.60201350161864, 218, 4, 'PPL', 'P'),
(19698, 'Calhoun', 34.502498626709, 0.602182201200894, -84.9511108398438, -1.48267658738192, 218, 13, 'PPL', 'P'),
(26680, 'Calhoun', 38.6502799987793, 0.674574642796409, -88.0436096191406, -1.53665087319455, 218, 18, 'PPL', 'P'),
(35103, 'Calhoun', 37.538890838623, 0.655177242680708, -87.2583312988281, -1.52294518096057, 218, 21, 'PPL', 'P'),
(39612, 'Calhoun', 32.5125007629395, 0.567450186370462, -92.3583297729492, -1.61195694618067, 218, 22, 'PPL', 'P'),
(53793, 'Calhoun', 38.4672203063965, 0.671379648436641, -93.626106262207, -1.63408382009759, 218, 29, 'PPL', 'P'),
(58871, 'Calhoun', 31.6958293914795, 0.553196582031708, -89.2052764892578, -1.55692578488944, 218, 30, 'PPL', 'P'),
(75301, 'Calhoun', 35.1036109924316, 0.612673591157206, -94.7458267211914, -1.65362662880881, 218, 42, 'PPL', 'P'),
(80080, 'Calhoun', 34.6925010681152, 0.60549836939026, -82.831672668457, -1.44568541299877, 218, 48, 'PPL', 'P'),
(85483, 'Calhoun', 35.2963905334473, 0.616038228878413, -84.7480621337891, -1.47913271891935, 218, 50, 'PPL', 'P'),
(108450, 'Calhoun', 39.0911102294922, 0.682268581764675, -79.9858322143555, -1.39601612708825, 218, 58, 'PPL', 'P'),
(114796, 'Calhoun', 41.6316719055176, 0.726609747861303, -95.8949966430664, -1.67368342761042, 218, 16, 'PPL', 'P'),
(173408, 'Calhoun', 43.0133285522461, 0.75072420547878, -88.1269378662109, -1.53810522546585, 218, 57, 'PPL', 'P'),
(194131, 'Calhoun', 40.1425018310547, 0.700618826939757, -102.889999389648, -1.79576925672432, 218, 7, 'PPL', 'P'),
(134521, 'Calhoun Beach', 44.9497184753418, 0.78452058523924, -93.3152770996094, -1.62865882779905, 218, 28, 'PPL', 'P'),
(58869, 'Calhoun City', 33.855281829834, 0.590886137121214, -89.311393737793, -1.55877788026953, 218, 30, 'PPL', 'P'),
(177558, 'Calhoun Corners', 41.8036117553711, 0.729610664356632, -73.3822174072266, -1.2807613061704, 218, 8, 'PPL', 'P'),
(80083, 'Calhoun Falls', 34.0922203063965, 0.595021493661889, -82.595832824707, -1.44156923121795, 218, 48, 'PPL', 'P'),
(80084, 'Calhoun Hills', 34.4588890075684, 0.601421069761349, -82.6466674804688, -1.44245646333511, 218, 48, 'PPL', 'P'),
(7844, 'Calhoun Junction', 33.2511100769043, 0.580341350785045, -93.148063659668, -1.62574040271849, 218, 4, 'PPL', 'P'),
(80085, 'Calhoun Lake', 34.9322204589844, 0.609682262041802, -81.845832824707, -1.42847926182799, 218, 48, 'PPL', 'P'),
(13469, 'Calhoun Landing', 38.5924987792969, 0.673566170270623, -75.1208267211914, -1.31110576310493, 218, 10, 'PPL', 'P'),
(80086, 'Calhoun Mill', 34.0327796936035, 0.593984059259248, -82.4711074829102, -1.43939236334292, 218, 48, 'PPL', 'P'),
(206942, 'Calhounville', 46.0011100769043, 0.802870830414322, -118.434173583984, -2.06706627591902, 218, 56, 'PPL', 'P'),
(80087, 'Calibogue Cay', 32.1483306884766, 0.561094219533852, -80.7988891601563, -1.41020664779868, 218, 48, 'PPL', 'P'),
(63360, 'Calico', 35.4183311462402, 0.618166494063549, -77.254997253418, -1.34835406569132, 218, 33, 'PPL', 'P'),
(85484, 'Calico', 35.5252799987793, 0.620033103671586, -84.8344421386719, -1.48064033441244, 218, 50, 'PPL', 'P'),
(108452, 'Calico', 37.6402816772461, 0.656946846646038, -82.0038909912109, -1.43123789724315, 218, 58, 'PPL', 'P'),
(112538, 'Calico', 34.9075012207031, 0.609250829945209, -81.7947235107422, -1.42758723602087, 218, 48, 'PPL', 'P'),
(180389, 'Calico', 34.9488906860352, 0.609973212390893, -116.864166259766, -2.03966447883098, 218, 6, 'PPL', 'P'),
(159736, 'Calico Corner', 40.1286087036133, 0.700376346122505, -74.9691696166992, -1.3084588472975, 218, 45, 'PPL', 'P'),
(7848, 'Calico Neck (historical)', 33.059440612793, 0.576996087560769, -93.0052795410156, -1.62324834972844, 218, 4, 'PPL', 'P'),
(63361, 'Calico Place', 35.8436088562012, 0.625588990337709, -81.6094436645508, -1.42435349266724, 218, 33, 'PPL', 'P'),
(7847, 'Calico Rock', 36.1194381713867, 0.630403120061218, -92.1358337402344, -1.60807365783717, 218, 4, 'PPL', 'P'),
(75302, 'Calida', 36.1930618286133, 0.631688095287181, -96.2977828979492, -1.6807133739399, 218, 42, 'PPL', 'P'),
(180390, 'Caliente', 35.2911109924316, 0.615946083504696, -118.626937866211, -2.07043064732412, 218, 6, 'PPL', 'P'),
(189989, 'Caliente', 37.6150016784668, 0.656505627432439, -114.511108398438, -1.99859587166087, 218, 39, 'PPL', 'P'),
(180393, 'Califa (historical)', 37.0847206115723, 0.647250476854141, -120.206939697266, -2.09800688146356, 218, 6, 'PPL', 'P'),
(144934, 'Califon', 40.7194404602051, 0.710688305600374, -74.8361129760742, -1.30613657082695, 218, 37, 'PPL', 'P'),
(19701, 'California', 33.9188919067383, 0.59199634240064, -84.7458267211914, -1.47909370360938, 218, 13, 'PPL', 'P'),
(35104, 'California', 38.9186096191406, 0.67925787815234, -84.2636108398438, -1.47067744877446, 218, 21, 'PPL', 'P'),
(45305, 'California', 38.3652801513672, 0.669600457091386, -75.6111068725586, -1.31966276600346, 218, 25, 'PPL', 'P'),
(53794, 'California', 38.627498626709, 0.67417703284566, -92.5663909912109, -1.61558829948505, 218, 29, 'PPL', 'P'),
(63365, 'California', 35.6330604553223, 0.621914227507563, -77.5569381713867, -1.35362392885637, 218, 33, 'PPL', 'P'),
(71991, 'California', 39.0652809143066, 0.681817775171152, -84.4233322143555, -1.4734651126455, 218, 41, 'PPL', 'P'),
(100422, 'California', 37.9088897705078, 0.661634942270959, -79.5872192382813, -1.38905901821458, 218, 53, 'PPL', 'P'),
(127017, 'California', 47.0691719055176, 0.821512025938495, -68.1063919067383, -1.1886807804262, 218, 26, 'PPL', 'P'),
(130048, 'California', 41.7963905334473, 0.729484630258044, -84.8833312988281, -1.48149361122571, 218, 27, 'PPL', 'P'),
(159739, 'California', 40.4755592346191, 0.7064317752301, -75.3475036621094, -1.31506202206229, 218, 45, 'PPL', 'P'),
(180399, 'California', 37.2502784729004, 0.650140006636877, -119.750282287598, -2.09003670611123, 218, 6, 'ADM1', 'A'),
(200504, 'California Bar', 42.1197204589844, 0.735127802028895, -123.473609924316, -2.15502103250247, 218, 43, 'PPL', 'P'),
(180394, 'California City', 35.1258316040039, 0.613061413990949, -117.985000610352, -2.05922672861815, 218, 6, 'PPL', 'P'),
(100423, 'California Crossroads', 37.1086082458496, 0.647667394722793, -76.7744369506836, -1.33996670615422, 218, 53, 'PPL', 'P'),
(159740, 'California Furnace', 40.1916694641113, 0.701476964022008, -79.2083282470703, -1.38244612291181, 218, 45, 'PPL', 'P'),
(180395, 'California Heights', 33.8266716003418, 0.590386794416824, -118.175827026367, -2.06255727787741, 218, 6, 'PPL', 'P'),
(180396, 'California Hot Springs', 35.8802795410156, 0.626229014526682, -118.672782897949, -2.07123079407363, 218, 6, 'PPL', 'P'),
(114801, 'California Junction', 41.5586090087891, 0.725334559752346, -95.9944381713867, -1.67541900969282, 218, 16, 'PPL', 'P'),
(193416, 'California Pines', 41.4099998474121, 0.722740840587691, -120.678062438965, -2.10622952448723, 218, 6, 'PPL', 'P'),
(180398, 'California Valley', 35.3199996948242, 0.616450286478075, -120.005828857422, -2.09449683514684, 218, 6, 'PPL', 'P'),
(53796, 'Caligoa', 36.601390838623, 0.638814780943261, -90.1502838134766, -1.57341927415252, 218, 29, 'PPL', 'P'),
(180404, 'Calimesa', 34.0038909912109, 0.593479856285869, -117.061111450195, -2.04310182084994, 218, 6, 'PPL', 'P'),
(180400, 'Calimesa Mobile Home Ranch', 33.9736099243164, 0.592951351967543, -117.036109924316, -2.04266546190533, 218, 6, 'PPL', 'P'),
(92977, 'Calina', 31.7563896179199, 0.554253557378847, -96.6997222900391, -1.68772853972533, 218, 51, 'PPL', 'P'),
(80088, 'Calina Heights', 34.9433288574219, 0.60987614016916, -82.1858291625977, -1.4344133173689, 218, 48, 'PPL', 'P'),
(139751, 'Calio', 48.6311111450195, 0.8487730083839, -98.932502746582, -1.72669791016619, 218, 34, 'PPL', 'P'),
(7852, 'Calion', 33.3288917541504, 0.581698897150713, -92.538330078125, -1.61509854416058, 218, 4, 'PPL', 'P'),
(180401, 'Calipatria', 33.125560760498, 0.578150101840128, -115.513328552246, -2.01608791317467, 218, 6, 'PPL', 'P'),
(108453, 'Calis', 39.9391708374023, 0.697070031629172, -80.5511093139648, -1.40588207366256, 218, 58, 'PPL', 'P'),
(7853, 'Calis (historical)', 36.3772201538086, 0.634902264406798, -94.3247222900391, -1.64627696999047, 218, 4, 'PPL', 'P'),
(206943, 'Calispell', 48.3438911437988, 0.843760073685017, -117.299438476563, -2.04726141215654, 218, 56, 'PPL', 'P'),
(31948, 'Calista', 37.639720916748, 0.656937059529032, -98.2822189331055, -1.7153483165486, 218, 20, 'PPL', 'P'),
(85485, 'Calistia', 36.5127792358398, 0.637268216719224, -86.6658325195313, -1.51260412644779, 218, 50, 'PPL', 'P'),
(180402, 'Calistoga', 38.5788917541504, 0.673328682880415, -122.57861328125, -2.13940039428666, 218, 6, 'PPL', 'P'),
(159743, 'Calkins', 41.6552810668945, 0.727021805460966, -75.1558303833008, -1.31171669225899, 218, 45, 'PPL', 'P'),
(200505, 'Calkins', 43.2216682434082, 0.754360419052147, -123.407501220703, -2.15386721796019, 218, 43, 'PPL', 'P'),
(193417, 'Calkins (historical)', 40.6650009155273, 0.709738156302461, -122.184440612793, -2.13252078340072, 218, 6, 'PPL', 'P'),
(196133, 'Calkins (historical)', 46.4416694641113, 0.810560042271653, -110.920280456543, -1.93592410120219, 218, 31, 'PPL', 'P'),
(53795, 'Call', 37.2011108398438, 0.649281869554626, -93.7769393920898, -1.63671635483514, 218, 29, 'PPL', 'P'),
(63366, 'Call', 36.1458282470703, 0.630863713771747, -81.0777816772461, -1.41507424048107, 218, 33, 'PPL', 'P'),
(92979, 'Call', 30.6129093170166, 0.534296061196388, -93.8740005493164, -1.63841039160454, 218, 51, 'PPL', 'P'),
(92980, 'Call Junction', 30.5922203063965, 0.533934969842087, -93.9155578613281, -1.63913570352742, 218, 51, 'PPL', 'P'),
(154574, 'Calla', 40.9724998474121, 0.715105025110216, -80.7708282470703, -1.40971689247422, 218, 41, 'PPL', 'P'),
(180403, 'Calla', 37.7758293151855, 0.659312599221383, -121.181938171387, -2.11502381503889, 218, 6, 'PPL', 'P'),
(80089, 'Calla (historical)', 34.1269416809082, 0.595627495967936, -81.1766662597656, -1.4168001020255, 218, 48, 'PPL', 'P'),
(92981, 'Callaghan', 27.8763904571533, 0.486534797048853, -99.4002838134766, -1.73486222996199, 218, 51, 'PPL', 'P'),
(100424, 'Callaghan', 37.811939239502, 0.65994283629335, -80.0744400024414, -1.39756262473326, 218, 53, 'PPL', 'P'),
(15400, 'Callahan', 30.561939239502, 0.533406465523761, -81.8308334350586, -1.42821747309283, 218, 12, 'PPL', 'P'),
(75305, 'Callahan', 36.2958297729492, 0.63348173428135, -97.5686111450195, -1.70289351107863, 218, 42, 'PPL', 'P'),
(193418, 'Callahan', 41.3097190856934, 0.720990611119291, -122.800277709961, -2.14326916840222, 218, 6, 'PPL', 'P'),
(200506, 'Callahan', 43.2661094665527, 0.755136064719633, -123.608612060547, -2.15737726427692, 218, 43, 'PPL', 'P'),
(100425, 'Callahans Corner', 36.7113914489746, 0.640734653773099, -78.2841720581055, -1.36631655461169, 218, 53, 'PPL', 'P'),
(100434, 'Callahans Hills', 36.6041717529297, 0.638863317054127, -79.5188903808594, -1.38786645467844, 218, 53, 'PPL', 'P'),
(92983, 'Callan', 31.0583305358887, 0.542070128023952, -99.6913909912109, -1.73994300868964, 218, 51, 'PPL', 'P'),
(100426, 'Callands', 36.8199996948242, 0.64263022525799, -79.5869369506836, -1.38905409136656, 218, 53, 'PPL', 'P'),
(53800, 'Callao', 39.7608299255371, 0.693957395526114, -92.6230621337891, -1.6165773975139, 218, 29, 'PPL', 'P'),
(100427, 'Callao', 37.9691696166992, 0.662687024059595, -76.5599975585938, -1.33622403271628, 218, 53, 'PPL', 'P'),
(192504, 'Callao', 39.8977813720703, 0.696347649183488, -113.707778930664, -1.98457512746993, 218, 52, 'PPL', 'P'),
(159744, 'Callapoose', 41.3713912963867, 0.722066994252873, -75.4055633544922, -1.31607535485707, 218, 45, 'PPL', 'P'),
(100428, 'Callaville', 36.8283309936523, 0.642775633853508, -77.6677780151367, -1.3555584490722, 218, 53, 'PPL', 'P'),
(15401, 'Callaway', 30.1527805328369, 0.526265298929254, -85.5699996948242, -1.49347823560523, 218, 12, 'PPL', 'P'),
(19702, 'Callaway', 33.809440612793, 0.590086056950727, -82.876106262207, -1.4464609255082, 218, 13, 'PPL', 'P'),
(35105, 'Callaway', 36.7833290100098, 0.641990201069017, -83.5633316040039, -1.4584552704257, 218, 21, 'PPL', 'P'),
(45306, 'Callaway', 38.2383308410645, 0.667384773643467, -76.5194396972656, -1.33551616449854, 218, 25, 'PPL', 'P'),
(53798, 'Callaway', 38.9161109924316, 0.67921426888949, -91.9499969482422, -1.60483019394556, 218, 29, 'PPL', 'P'),
(100429, 'Callaway', 37.0113906860352, 0.645970628213276, -80.0497207641602, -1.39713119263667, 218, 53, 'PPL', 'P'),
(113123, 'Callaway', 46.9824981689453, 0.819999283860303, -95.9094390869141, -1.67393549580759, 218, 28, 'PPL', 'P'),
(141425, 'Callaway', 41.2919387817383, 0.720680286273269, -99.9222183227539, -1.74397170562866, 218, 35, 'PPL', 'P'),
(19703, 'Callaway Mill', 34.8330612182617, 0.607951606807414, -85.0602798461914, -1.48458194598382, 218, 13, 'PPL', 'P'),
(53802, 'Calleaway', 38.9152793884277, 0.679199754661549, -91.9505615234375, -1.6048400476416, 218, 29, 'PPL', 'P'),
(114802, 'Callender', 42.3619384765625, 0.739355303943286, -94.2955627441406, -1.64576803990615, 218, 16, 'PPL', 'P'),
(180406, 'Callender', 35.0530586242676, 0.611791285888063, -120.595283508301, -2.10478475959587, 218, 6, 'PPL', 'P'),
(85486, 'Callender (historical)', 35.9930610656738, 0.628197423467387, -86.8022232055664, -1.51498459298816, 218, 50, 'PPL', 'P'),
(159748, 'Callensburg', 41.1258316040039, 0.717781169110609, -79.5586090087891, -1.38855967551019, 218, 45, 'PPL', 'P'),
(159746, 'Callery', 40.7405586242676, 0.711056887095241, -80.0366668701172, -1.39690335920541, 218, 45, 'PPL', 'P'),
(147532, 'Callicoon', 41.767219543457, 0.728975500436648, -75.0566711425781, -1.3099860370246, 218, 40, 'PPL', 'P'),
(147533, 'Callicoon Center', 41.836669921875, 0.730187638206798, -74.9469375610352, -1.30807082472667, 218, 40, 'PPL', 'P'),
(85487, 'Callie', 35.832218170166, 0.625390185362335, -86.8502807617188, -1.51582335557348, 218, 50, 'PPL', 'P'),
(19704, 'Callier Springs Heights', 34.226390838623, 0.597363211208395, -85.14111328125, -1.48599275557129, 218, 13, 'PPL', 'P'),
(92984, 'Calliham', 28.4802799224854, 0.497074656537005, -98.3499984741211, -1.71653129270481, 218, 51, 'PPL', 'P'),
(77963, 'Callimont', 39.7980613708496, 0.694607206832094, -78.9166717529297, -1.37735575680423, 218, 45, 'PPL', 'P'),
(92985, 'Callisburg', 33.6977806091309, 0.588137222244034, -97.0086135864258, -1.69311970987803, 218, 51, 'PPL', 'P'),
(80090, 'Callison', 34.0144386291504, 0.593663947296221, -82.1258316040039, -1.43336616242828, 218, 48, 'PPL', 'P'),
(100430, 'Callison', 37.9786109924316, 0.662851807152043, -79.9116668701172, -1.39472169764042, 218, 53, 'PPL', 'P'),
(63367, 'Callisons', 35.084171295166, 0.61233430443433, -76.7255630493164, -1.33911369565707, 218, 33, 'PPL', 'P'),
(1297, 'Calliston', 33.2794418334961, 0.580835833220445, -86.8430633544922, -1.51569738805392, 218, 2, 'PPL', 'P'),
(173409, 'Callon', 44.8977813720703, 0.783614111783204, -89.5047225952148, -1.56215210537066, 218, 57, 'PPL', 'P'),
(200507, 'Calloway (historical)', 44.6611099243164, 0.779483415774437, -123.211112976074, -2.1504395964792, 218, 43, 'PPL', 'P'),
(35110, 'Calloway Crossing', 37.7241706848145, 0.658410986034336, -84.0055618286133, -1.46617364389697, 218, 21, 'PPL', 'P'),
(45307, 'Calloway Landing', 38.1686096191406, 0.666167908762383, -76.4611129760742, -1.33449817117186, 218, 25, 'PPL', 'P'),
(19705, 'Calloway Woods', 33.5149993896484, 0.584947088153255, -82.1527786254883, -1.43383647667679, 218, 13, 'PPL', 'P'),
(85488, 'Calls', 35.3461112976074, 0.616906019919615, -86.0052795410156, -1.50107530208884, 218, 50, 'PPL', 'P'),
(53803, 'Calm', 36.5516700744629, 0.637946989902058, -91.1616668701172, -1.59107123848978, 218, 29, 'PPL', 'P'),
(154569, 'Calm (historical)', 41.6902809143066, 0.727632668036003, -81.0027770996094, -1.41376516364725, 218, 41, 'PPL', 'P'),
(92988, 'Calma Estates Colonia', 26.3309993743896, 0.459562634423666, -98.2480010986328, -1.71475110267415, 218, 51, 'PPL', 'P'),
(92986, 'Calma Estates Colonia Number 2', 26.3311100006104, 0.459564565215457, -98.2505569458008, -1.71479571062241, 218, 51, 'PPL', 'P'),
(92987, 'Calma Estates Colonia Number 3', 26.3311100006104, 0.459564565215457, -98.2505569458008, -1.71479571062241, 218, 51, 'PPL', 'P'),
(114803, 'Calmar', 43.1836090087891, 0.753696160097254, -91.8638916015625, -1.60332737214243, 218, 16, 'PPL', 'P'),
(7854, 'Calmer', 33.9375, 0.592321114895576, -92.0305633544922, -1.60623634300113, 218, 4, 'PPL', 'P'),
(100431, 'Calmes Neck Estates', 39.0761108398438, 0.68200679302952, -77.9863891601563, -1.36111926258634, 218, 53, 'PPL', 'P'),
(189993, 'Calmville (historical)', 38.0097198486328, 0.663394759119283, -117.996940612793, -2.05943512097345, 218, 39, 'PPL', 'P'),
(77964, 'Caln', 39.9908294677734, 0.697971644816218, -75.7805633544922, -1.32262033955205, 218, 45, 'PPL', 'P'),
(159749, 'Caln Meeting House', 40.0072212219238, 0.69825773489632, -75.7647171020508, -1.32234377027284, 218, 45, 'PPL', 'P'),
(193419, 'Calneva', 40.1527786254883, 0.700798190839174, -120.007781982422, -2.09453092360879, 218, 6, 'PPL', 'P'),
(100432, 'Calno', 37.813060760498, 0.659962410527362, -77.3016662597656, -1.34916859351072, 218, 53, 'PPL', 'P'),
(144936, 'Calno', 41.0561103820801, 0.716564304229525, -75.0055618286133, -1.30909401121748, 218, 37, 'PPL', 'P'),
(114813, 'Caloma', 41.2772216796875, 0.720423424386131, -93.3091735839844, -1.62855230135545, 218, 16, 'PPL', 'P'),
(80091, 'Calomet Valley', 32.9644393920898, 0.575338003466086, -80.186393737793, -1.39951658602505, 218, 48, 'PPL', 'P'),
(15402, 'Caloosahatchee (historical)', 26.5833301544189, 0.463966637339303, -81.9833297729492, -1.43087903628626, 218, 12, 'PPL', 'P'),
(199214, 'Calora', 41.6402816772461, 0.726760016725811, -101.447219848633, -1.77058800335319, 218, 35, 'PPL', 'P'),
(180407, 'Calpack', 37.2969398498535, 0.650954401298223, -120.351112365723, -2.10052316921952, 218, 6, 'PPL', 'P'),
(180408, 'Calpella', 39.2336082458496, 0.684755641327673, -123.202781677246, -2.15029418788369, 218, 6, 'PPL', 'P'),
(209345, 'Calpet', 42.2838897705078, 0.737993097045711, -110.258331298828, -1.92437090891927, 218, 59, 'PPL', 'P'),
(15403, 'Calphos', 28.9119396209717, 0.504608539523757, -82.3844375610352, -1.43787968784375, 218, 12, 'PPL', 'P'),
(180409, 'Calpine', 39.666389465332, 0.692309098548437, -120.438606262207, -2.10205022578857, 218, 6, 'PPL', 'P'),
(139753, 'Calspur', 47.9333305358887, 0.836594439297995, -97.0877838134766, -1.69450149100962, 218, 34, 'PPL', 'P'),
(1298, 'Calumet', 33.7947196960449, 0.589829128484561, -87.2869415283203, -1.52344452366496, 218, 2, 'PPL', 'P'),
(7857, 'Calumet', 35.9816703796387, 0.627998618492013, -89.9861068725586, -1.57055384597764, 218, 4, 'PPL', 'P'),
(39613, 'Calumet', 29.6994400024414, 0.518353014041115, -91.3633270263672, -1.59459087218643, 218, 22, 'PPL', 'P'),
(53804, 'Calumet', 39.3269386291504, 0.68638456380842, -91.0119400024414, -1.58845801167014, 218, 29, 'PPL', 'P'),
(75303, 'Calumet', 35.6011085510254, 0.621356561575301, -98.1183319091797, -1.7124879483798, 218, 42, 'PPL', 'P'),
(114805, 'Calumet', 42.9463882446289, 0.749555876708562, -95.5497207641602, -1.66765722669579, 218, 16, 'PPL', 'P'),
(119004, 'Calumet', 41.7316703796387, 0.728355050481687, -87.5513916015625, -1.52806004815018, 218, 18, 'PPL', 'P'),
(130050, 'Calumet', 47.2466697692871, 0.82460994807653, -88.4538879394531, -1.54381158073356, 218, 27, 'PPL', 'P'),
(134524, 'Calumet', 47.3219413757324, 0.825923685442266, -93.2766723632813, -1.62798504804326, 218, 28, 'PPL', 'P'),
(154570, 'Calumet', 40.4819412231445, 0.706543161942693, -80.6069412231445, -1.40685652430542, 218, 41, 'PPL', 'P'),
(159750, 'Calumet', 40.2108306884766, 0.701811390475894, -79.4855575561523, -1.38728468713832, 218, 45, 'PPL', 'P'),
(177825, 'Calumet', 31.3541698455811, 0.547233498034912, -109.606941223145, -1.91300200738377, 218, 5, 'PPL', 'P'),
(189990, 'Calumet', 39.2630615234375, 0.685269697997085, -114.875831604004, -2.00496149245643, 218, 39, 'PPL', 'P'),
(119005, 'Calumet City', 41.6155586242676, 0.726328518050191, -87.5294418334961, -1.52767695242737, 218, 18, 'PPL', 'P'),
(173411, 'Calumet Harbor', 43.9130592346191, 0.766427468267405, -88.3322219848633, -1.54168810923839, 218, 57, 'PPL', 'P'),
(119007, 'Calumet Park', 41.6627807617188, 0.727152699828543, -87.6605606079102, -1.52996540675207, 218, 18, 'PPL', 'P'),
(19706, 'Calumet West', 33.9805603027344, 0.593072658955196, -84.6772232055664, -1.47789634638328, 218, 13, 'PPL', 'P'),
(19707, 'Calumet Woods', 34.0299987792969, 0.593935523148382, -84.6738891601563, -1.47783815631346, 218, 13, 'PPL', 'P'),
(173413, 'Calumetville', 43.9361114501953, 0.766829805329089, -88.3033294677734, -1.54118383968598, 218, 57, 'PPL', 'P'),
(177826, 'Calva', 33.1805610656738, 0.579110038255047, -110.185829162598, -1.92310550792732, 218, 5, 'PPL', 'P'),
(180410, 'Calvada (historical)', 39.4625015258789, 0.688750582699873, -120.004997253418, -2.0944823209189, 218, 6, 'PPL', 'P'),
(180411, 'Calvada Springs', 35.9683303833008, 0.627765791633713, -115.894172668457, -2.0227348969394, 218, 6, 'PPL', 'P'),
(63368, 'Calvander', 35.9427795410156, 0.627319845309179, -79.1100006103516, -1.38072998190536, 218, 33, 'PPL', 'P'),
(1299, 'Calvary', 32.2252807617188, 0.562437251671578, -87.7930603027344, -1.53227796268464, 218, 2, 'PPL', 'P'),
(19708, 'Calvary', 30.7266693115234, 0.536281547657583, -84.3497161865234, -1.47218027057759, 218, 13, 'PPL', 'P'),
(35107, 'Calvary', 37.5155601501465, 0.654770045350034, -85.2624969482422, -1.48811130021844, 218, 21, 'PPL', 'P'),
(45308, 'Calvary', 39.5349998474121, 0.690015917112797, -76.2608337402344, -1.33100263908307, 218, 25, 'PPL', 'P'),
(58872, 'Calvary', 33.0888900756836, 0.577510077651154, -89.1263885498047, -1.55554893060587, 218, 30, 'PPL', 'P'),
(85489, 'Calvary', 36.1922187805176, 0.631673381322159, -89.4491729736328, -1.56118258157582, 218, 50, 'PPL', 'P'),
(92989, 'Calvary', 32.7577781677246, 0.57173108466471, -95.5269393920898, -1.66725961674504, 218, 51, 'PPL', 'P'),
(100433, 'Calvary', 38.8733291625977, 0.678467585098859, -78.5519409179688, -1.37099000285061, 218, 53, 'PPL', 'P'),
(173414, 'Calvary', 43.8466682434082, 0.765268726877112, -88.2438888549805, -1.54014640528334, 218, 57, 'PPL', 'P'),
(53806, 'Calvary Church', 37.6694412231445, 0.657455776730352, -89.772216796875, -1.56682075991963, 218, 29, 'PPL', 'P'),
(1300, 'Calvert', 31.1550006866455, 0.543757340443058, -88.0100021362305, -1.53606431196446, 218, 2, 'PPL', 'P'),
(31949, 'Calvert', 39.8497200012207, 0.69550882001914, -99.7574996948242, -1.74109682323192, 218, 20, 'PPL', 'P'),
(45309, 'Calvert', 39.7002792358398, 0.692900586626544, -75.982780456543, -1.32614969378668, 218, 25, 'PPL', 'P'),
(63369, 'Calvert', 35.1569404602051, 0.613604365958189, -82.8108291625977, -1.44532162519387, 218, 33, 'PPL', 'P'),
(80092, 'Calvert', 34.9441719055176, 0.609890854134183, -82.0061111450195, -1.43127664623701, 218, 48, 'PPL', 'P'),
(92990, 'Calvert', 30.9777793884277, 0.540664245284499, -96.6736068725586, -1.68727273970477, 218, 51, 'PPL', 'P'),
(159751, 'Calvert', 41.4002799987793, 0.722571197226253, -76.966667175293, -1.34332175649551, 218, 45, 'PPL', 'P'),
(173415, 'Calvert', 43.7541694641113, 0.763654318624306, -91.2050018310547, -1.59182757623936, 218, 57, 'PPL', 'P'),
(196134, 'Calvert', 47.1652793884277, 0.823189417951081, -111.133613586426, -1.93964746672223, 218, 31, 'PPL', 'P'),
(200508, 'Calvert (historical)', 43.6138916015625, 0.761206008055168, -123.216667175293, -2.15053653554288, 218, 43, 'PPL', 'P'),
(39617, 'Calvert Acres', 31.7788906097412, 0.554646273771093, -93.1458282470703, -1.62570138740852, 218, 22, 'PPL', 'P'),
(45311, 'Calvert Acres', 39.6944389343262, 0.692798654135821, -75.9430618286133, -1.32545647295493, 218, 25, 'PPL', 'P'),
(45312, 'Calvert Beach', 38.4658317565918, 0.671355413670721, -76.4775009155273, -1.33478419467293, 218, 25, 'PPL', 'P'),
(45313, 'Calvert Beach Estates', 38.4619407653809, 0.671287503062924, -76.4836120605469, -1.33489085427459, 218, 25, 'PPL', 'P'),
(45314, 'Calvert Beach Park', 38.4719390869141, 0.671462006693351, -76.4944381713867, -1.33507980555393, 218, 25, 'PPL', 'P'),
(45315, 'Calvert Chase', 38.7449989318848, 0.676227800043075, -76.670280456543, -1.33814883239414, 218, 25, 'PPL', 'P'),
(35108, 'Calvert City', 37.0333290100098, 0.646353524199002, -88.3499984741211, -1.54199836750538, 218, 21, 'PPL', 'P'),
(45317, 'Calvert Estates', 38.7533302307129, 0.676373208638594, -76.6613922119141, -1.33799370326064, 218, 25, 'PPL', 'P'),
(45318, 'Calvert Heights', 39.2186088562012, 0.684493852592518, -76.0791702270508, -1.32783201264728, 218, 25, 'PPL', 'P'),
(45319, 'Calvert Hills', 38.9747200012207, 0.68023718906419, -76.9358291625977, -1.3427835316392, 218, 25, 'PPL', 'P'),
(159752, 'Calvert Hills', 40.5186080932617, 0.707183119552639, -78.4113922119141, -1.36853696517054, 218, 45, 'PPL', 'P'),
(92991, 'Calvert Junction', 30.9419403076172, 0.540038735323467, -96.7372207641602, -1.68838301156322, 218, 51, 'PPL', 'P'),
(45321, 'Calvert Manor', 38.689998626709, 0.675267863628156, -77.0091705322266, -1.34406358001715, 218, 25, 'PPL', 'P'),
(45322, 'Calvert Mobile Home Park', 38.5063896179199, 0.672063281888464, -76.6449966430664, -1.33770754660151, 218, 25, 'PPL', 'P'),
(45324, 'Calvert Towne', 38.5305595397949, 0.672485126605132, -76.5763931274414, -1.33651018937541, 218, 25, 'PPL', 'P'),
(45325, 'Calvert Woods', 38.6852798461914, 0.675185505371446, -76.6080627441406, -1.33706292845966, 218, 25, 'PPL', 'P'),
(45328, 'Calverton', 38.939998626709, 0.679631186758142, -76.2988891601563, -1.33166683145894, 218, 25, 'PPL', 'P'),
(100435, 'Calverton', 38.6319389343262, 0.674254530833381, -77.6708297729492, -1.355611712294, 218, 53, 'PPL', 'P'),
(147534, 'Calverton', 40.9063911437988, 0.713951210567939, -72.7438888549805, -1.26962037122422, 218, 40, 'PPL', 'P'),
(45329, 'Calverton Heights', 39.2941703796387, 0.685812649964325, -76.6638870239258, -1.33803724594446, 218, 25, 'PPL', 'P'),
(53807, 'Calverton Park', 38.764720916748, 0.676572013613968, -90.313606262207, -1.57626978862528, 218, 29, 'PPL', 'P'),
(29370, 'Calvertville', 39.1163902282715, 0.682709800978274, -86.9038925170898, -1.51675905722248, 218, 19, 'PPL', 'P'),
(53808, 'Calvey (historical)', 38.3474998474121, 0.669290132245364, -90.7961120605469, -1.58469110346628, 218, 29, 'PPL', 'P'),
(193420, 'Calville', 40.9363899230957, 0.714474788038248, -124.099166870117, -2.16593906086541, 218, 6, 'PPL', 'P'),
(7856, 'Calvin', 35.9300003051758, 0.627096805567885, -91.0586090087891, -1.58927253948954, 218, 4, 'PPL', 'P'),
(19710, 'Calvin', 33.3797187805176, 0.582585996109818, -83.7041702270508, -1.46091336811185, 218, 13, 'PPL', 'P'),
(26682, 'Calvin', 38.2080612182617, 0.666856469062223, -88.0186080932617, -1.53621451424995, 218, 18, 'PPL', 'P'),
(35109, 'Calvin', 36.7222213745117, 0.640923671631467, -83.6222229003906, -1.45948311744842, 218, 21, 'PPL', 'P'),
(39614, 'Calvin', 31.9655609130859, 0.557904285180155, -92.7755584716797, -1.61923896070733, 218, 22, 'PPL', 'P'),
(63370, 'Calvin', 35.7333297729492, 0.623664257238882, -81.7305603027344, -1.42646737678249, 218, 33, 'PPL', 'P'),
(75309, 'Calvin', 34.9677810668945, 0.610302911733845, -96.2483291625977, -1.67985024343061, 218, 42, 'PPL', 'P'),
(100436, 'Calvin', 36.8519401550293, 0.643187691453171, -82.9416732788086, -1.44760528582861, 218, 53, 'PPL', 'P'),
(108454, 'Calvin', 38.336669921875, 0.669101114386996, -80.7147216796875, -1.40873764814139, 218, 58, 'PPL', 'P'),
(139754, 'Calvin', 48.8525009155273, 0.852636988809496, -98.9349975585938, -1.72674145285001, 218, 34, 'PPL', 'P'),
(159753, 'Calvin', 40.336669921875, 0.704007699426883, -78.0274963378906, -1.36183671818401, 218, 45, 'PPL', 'P'),
(80093, 'Calvin (historical)', 34.8022193908691, 0.607413315372082, -81.3649978637695, -1.42008710860093, 218, 48, 'PPL', 'P'),
(130052, 'Calvin Center', 41.8458290100098, 0.73034749445123, -85.9349975585938, -1.49984865009075, 218, 27, 'PPL', 'P'),
(180414, 'Calwa', 36.7105598449707, 0.640720139545158, -119.757499694824, -2.09016267363079, 218, 6, 'PPL', 'P'),
(53810, 'Calwood', 38.920280456543, 0.679287039766277, -91.8525009155273, -1.60312856716706, 218, 29, 'PPL', 'P'),
(63371, 'Calypso', 35.1536102294922, 0.613546242467398, -78.1055603027344, -1.36319919139769, 218, 33, 'PPL', 'P'),
(196135, 'Calypso', 46.7730598449707, 0.816343895527087, -105.422218322754, -1.83996481448835, 218, 31, 'PPL', 'P'),
(58873, 'Calyx', 32.9502792358398, 0.575090862116926, -88.495002746582, -1.54452916948928, 218, 30, 'PPL', 'P'),
(180412, 'Calzona', 34.1288909912109, 0.595661517850862, -114.410278320313, -1.99683605481254, 218, 6, 'PPL', 'P'),
(58874, 'Cam', 31.5577793121338, 0.550787153614486, -90.3874969482422, -1.57755942438315, 218, 30, 'PPL', 'P'),
(19711, 'Camak', 33.4533309936523, 0.5838707715987, -82.646110534668, -1.44244674279713, 218, 13, 'PPL', 'P'),
(1301, 'Camak Mills (historical)', 33.9075012207031, 0.591797537425266, -87.288330078125, -1.52346875843088, 218, 2, 'PPL', 'P'),
(114806, 'Camanche', 41.7880592346191, 0.729339221662526, -90.2561111450195, -1.57526630952654, 218, 16, 'PPL', 'P'),
(180413, 'Camanche (historical)', 38.2133293151855, 0.666948414698858, -120.934173583984, -2.11069950721888, 218, 6, 'PPL', 'P'),
(180415, 'Camanche Village', 38.2700004577637, 0.667937512727713, -120.972221374512, -2.11136356643669, 218, 6, 'PPL', 'P'),
(206944, 'Camano', 48.1741714477539, 0.840797906183549, -122.52693939209, -2.13849851478351, 218, 56, 'PPL', 'P'),
(39615, 'Camardelle', 29.7255592346191, 0.51880888064071, -90.3580627441406, -1.57704570060888, 218, 22, 'PPL', 'P'),
(92992, 'Camargito Colonia', 26.3460006713867, 0.459824456448335, -98.7409973144531, -1.72335550984009, 218, 51, 'PPL', 'P'),
(26683, 'Camargo', 39.8002815246582, 0.694645955825954, -88.1638870239258, -1.53875010992381, 218, 18, 'PPL', 'P'),
(35111, 'Camargo', 37.9941711425781, 0.663123383004204, -83.8877792358398, -1.46411794985154, 218, 21, 'PPL', 'P'),
(75307, 'Camargo', 36.017219543457, 0.628619068446974, -99.2888870239258, -1.73291798920818, 218, 42, 'PPL', 'P'),
(77966, 'Camargo', 39.9161109924316, 0.696667561409434, -76.1752777099609, -1.32950940465986, 218, 45, 'PPL', 'P'),
(85491, 'Camargo', 35.082218170166, 0.612300215972377, -86.6358337402344, -1.51208054897748, 218, 50, 'PPL', 'P'),
(58875, 'Camargo (historical)', 34.0708312988281, 0.594648185056087, -88.6486129760742, -1.54721017375866, 218, 30, 'PPL', 'P'),
(180416, 'Camarillo', 34.2163887023926, 0.597188640998941, -119.036666870117, -2.0775817674832, 218, 6, 'PPL', 'P'),
(7858, 'Camark', 33.6322212219238, 0.586992995081681, -92.7666702270508, -1.61908383157383, 218, 4, 'PPL', 'P'),
(194675, 'Camas', 44.0074996948242, 0.768075765245082, -112.220283508301, -1.95861343474134, 218, 17, 'PPL', 'P'),
(196136, 'Camas', 47.6180610656738, 0.831091949011728, -114.656936645508, -2.00114105471465, 218, 31, 'PPL', 'P'),
(206946, 'Camas', 48.0394401550293, 0.838446401520036, -117.858329772949, -2.05701590543922, 218, 56, 'PPL', 'P'),
(196137, 'Camas Prairie', 47.4627799987793, 0.828381783128409, -114.606109619141, -2.00025395575555, 218, 31, 'PPL', 'P'),
(200509, 'Camas Valley', 43.0344390869141, 0.751092653815593, -123.672782897949, -2.15849725667335, 218, 43, 'PPL', 'P'),
(71992, 'Camba', 38.9647216796875, 0.680062685433762, -82.6052780151367, -1.44173408088942, 218, 41, 'PPL', 'P'),
(180418, 'Cambio (historical)', 35.0944404602051, 0.612513535175693, -118.132217407227, -2.06179614643786, 218, 6, 'PPL', 'P'),
(15404, 'Cambon', 30.3458309173584, 0.529634663761395, -81.8063888549805, -1.4277908346862, 218, 12, 'PPL', 'P'),
(26685, 'Cambon', 37.8994407653809, 0.661470026020456, -88.9980621337891, -1.55330921212911, 218, 18, 'PPL', 'P'),
(159754, 'Cambra', 41.1980590820313, 0.719041776412598, -76.3061065673828, -1.3317927989785, 218, 45, 'PPL', 'P'),
(192938, 'Cambray', 32.2252807617188, 0.562437251671578, -107.316940307617, -1.87303395153414, 218, 38, 'PPL', 'P'),
(26686, 'Cambria', 37.7813911437988, 0.659409671443116, -89.1191711425781, -1.55542296308631, 218, 18, 'PPL', 'P'),
(45331, 'Cambria', 39.711109161377, 0.693089604484912, -76.3488922119141, -1.33253954934816, 218, 25, 'PPL', 'P'),
(85490, 'Cambria', 35.2816696166992, 0.615781300412247, -84.5363922119141, -1.47543838185519, 218, 50, 'PPL', 'P'),
(100437, 'Cambria', 37.1430587768555, 0.648268669917906, -80.396110534668, -1.40317683462725, 218, 53, 'PPL', 'P'),
(108456, 'Cambria', 38.2652816772461, 0.667855154471003, -81.1997222900391, -1.41720250566621, 218, 58, 'PPL', 'P'),
(114808, 'Cambria', 40.8377799987793, 0.712753720183785, -93.4022216796875, -1.63017629698818, 218, 16, 'PPL', 'P'),
(122316, 'Cambria', 40.3658294677734, 0.704516629511197, -86.5591735839844, -1.51074257684583, 218, 19, 'PPL', 'P'),
(130054, 'Cambria', 41.8219413757324, 0.729930576582578, -84.6650009155273, -1.47768302717997, 218, 27, 'PPL', 'P'),
(134525, 'Cambria', 44.2386093139648, 0.772109389032116, -94.3141708374023, -1.64609281240109, 218, 28, 'PPL', 'P'),
(173417, 'Cambria', 43.5422210693359, 0.759955121291158, -89.1072235107422, -1.55521443757295, 218, 57, 'PPL', 'P'),
(180419, 'Cambria', 35.5641708374023, 0.62071187685442, -121.079719543457, -2.11323976342465, 218, 6, 'PPL', 'P'),
(209346, 'Cambria (historical)', 43.9391708374023, 0.766883201708945, -104.206939697266, -1.81875420114447, 218, 59, 'PPL', 'P'),
(147535, 'Cambria Center', 43.1777801513672, 0.753594427343613, -78.8197174072266, -1.37566358424759, 218, 40, 'PPL', 'P'),
(159755, 'Cambria City', 40.3400001525879, 0.704065822917674, -78.9305572509766, -1.37759810446343, 218, 45, 'PPL', 'P'),
(147536, 'Cambria Heights', 40.6944389343262, 0.710251946655764, -73.7388916015625, -1.28698644521846, 218, 40, 'PPL', 'P'),
(19712, 'Cambria Hills', 34.0722198486328, 0.594672419822007, -84.584716796875, -1.47628180497242, 218, 13, 'PPL', 'P'),
(180420, 'Cambria Pines', 35.5675010681152, 0.620770000345211, -121.093063354492, -2.11347265686198, 218, 6, 'PPL', 'P'),
(203239, 'Cambria Pines', 40.6555595397949, 0.709573373210012, -111.808326721191, -1.95142343243035, 218, 52, 'PPL', 'P'),
(180421, 'Cambrian Park', 37.2569389343262, 0.650256253618459, -121.929718017578, -2.12807503543499, 218, 6, 'PPL', 'P'),
(1302, 'Cambridge', 33.3861083984375, 0.582697515980465, -85.4588928222656, -1.49153905485748, 218, 2, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(19713, 'Cambridge', 33.5361099243164, 0.585315536490068, -82.0555572509766, -1.43213964358825, 218, 13, 'PPL', 'P'),
(31952, 'Cambridge', 37.3161087036133, 0.651288960910165, -96.6641693115234, -1.68710802319134, 218, 20, 'PPL', 'P'),
(35113, 'Cambridge', 38.2216682434082, 0.667093956452431, -85.6166687011719, -1.49429276342463, 218, 21, 'PPL', 'P'),
(45332, 'Cambridge', 38.563060760498, 0.673052379917319, -76.0791702270508, -1.32783201264728, 218, 25, 'PPL', 'P'),
(53815, 'Cambridge', 39.2577781677246, 0.685177486044341, -92.9486083984375, -1.62225925169959, 218, 29, 'PPL', 'P'),
(63379, 'Cambridge', 35.5811080932617, 0.621007487735419, -77.3877792358398, -1.35067154847191, 218, 33, 'PPL', 'P'),
(75308, 'Cambridge', 35.0727806091309, 0.612135499458956, -99.2050018310547, -1.73145391639891, 218, 42, 'PPL', 'P'),
(80095, 'Cambridge', 34.9152793884277, 0.609386584581776, -82.0541687011719, -1.43211540882233, 218, 48, 'PPL', 'P'),
(85492, 'Cambridge', 35.7930603027344, 0.624706751647593, -85.6958312988281, -1.49567441139816, 218, 50, 'PPL', 'P'),
(92996, 'Cambridge', 33.8111114501953, 0.590115218564663, -96.727783203125, -1.6882182950498, 218, 51, 'PPL', 'P'),
(100438, 'Cambridge', 37.5302810668945, 0.6550269738162, -77.5800018310547, -1.35402646565513, 218, 53, 'PPL', 'P'),
(114809, 'Cambridge', 41.8983306884766, 0.731263821603299, -93.5288925170898, -1.6323871201671, 218, 16, 'PPL', 'P'),
(119009, 'Cambridge', 41.3036117553711, 0.72088401809666, -90.1927795410156, -1.5741609645161, 218, 18, 'PPL', 'P'),
(124369, 'Cambridge', 42.2444381713867, 0.737304536745871, -71.8125, -1.25336456908843, 218, 23, 'PPL', 'P'),
(127018, 'Cambridge', 45.024169921875, 0.785820008114117, -69.4744415283203, -1.21255775065347, 218, 26, 'PPL', 'P'),
(134527, 'Cambridge', 45.5727806091309, 0.79539507091836, -93.2241668701172, -1.62706865431216, 218, 28, 'PPL', 'P'),
(144937, 'Cambridge', 40.0288887023926, 0.698635903771111, -74.9730606079102, -1.30852675790529, 218, 37, 'PPL', 'P'),
(147538, 'Cambridge', 43.0280609130859, 0.750981333682027, -73.3816680908203, -1.28075171879048, 218, 40, 'PPL', 'P'),
(154571, 'Cambridge', 40.0311088562012, 0.698674652764972, -81.5886077880859, -1.42398983802039, 218, 41, 'PPL', 'P'),
(159758, 'Cambridge', 40.0813903808594, 0.69955223092318, -75.9377822875977, -1.32536432758121, 218, 45, 'PPL', 'P'),
(171820, 'Cambridge', 44.644718170166, 0.779197325694335, -72.8766708374023, -1.2719378540048, 218, 55, 'PPL', 'P'),
(173419, 'Cambridge', 43.0036087036133, 0.750554562117342, -89.0163879394531, -1.55362905777603, 218, 57, 'PPL', 'P'),
(194678, 'Cambridge', 44.5727806091309, 0.777941778398417, -116.675003051758, -2.03636295802761, 218, 17, 'PPL', 'P'),
(199215, 'Cambridge', 40.2819404602051, 0.703052490122899, -100.165283203125, -1.7482139880871, 218, 35, 'PPL', 'P'),
(80096, 'Cambridge (historical)', 34.1452789306641, 0.595947541351937, -82.0247192382813, -1.43160141873194, 218, 48, 'PPL', 'P'),
(189991, 'Cambridge (historical)', 38.6883316040039, 0.675238768593247, -119.013061523438, -2.07716977646256, 218, 39, 'PPL', 'P'),
(29371, 'Cambridge City', 39.8125, 0.694859208450242, -85.1716690063477, -1.48652605357957, 218, 19, 'PPL', 'P'),
(203240, 'Cambridge Condominium', 40.7675018310547, 0.711527134764721, -111.86499786377, -1.9524125304592, 218, 52, 'PPL', 'P'),
(19715, 'Cambridge Estates', 33.3080596923828, 0.58133530908289, -84.4097213745117, -1.47322755867626, 218, 13, 'PPL', 'P'),
(45333, 'Cambridge Estates', 39.6494407653809, 0.692013287930357, -77.0194396972656, -1.34424281075851, 218, 25, 'PPL', 'P'),
(203241, 'Cambridge Estates', 40.6547203063965, 0.709558725824017, -111.83943939209, -1.95196645097661, 218, 52, 'PPL', 'P'),
(19716, 'Cambridge Forest', 33.6269416809082, 0.586900849707965, -83.8775024414063, -1.46393858595212, 218, 13, 'PPL', 'P'),
(177827, 'Cambridge Heights', 33.3541717529297, 0.582140116364312, -111.979721069336, -1.95441482812478, 218, 5, 'PPL', 'P'),
(130056, 'Cambridge Junction', 42.0588912963867, 0.734066132860335, -84.2211074829102, -1.46993562525282, 218, 27, 'PPL', 'P'),
(171821, 'Cambridge Junction', 44.649169921875, 0.779275023419138, -72.8138885498047, -1.27084209637429, 218, 55, 'PPL', 'P'),
(180422, 'Cambridge Oaks', 38.6669387817383, 0.674865393408418, -121.002502441406, -2.11189207075502, 218, 6, 'PPL', 'P'),
(35112, 'Cambridge Shores', 36.939998626709, 0.644724601718256, -88.2283325195313, -1.5398748960102, 218, 21, 'PPL', 'P'),
(159759, 'Cambridge Springs', 41.8036117553711, 0.729610664356632, -80.0566711425781, -1.39725249962432, 218, 45, 'PPL', 'P'),
(19717, 'Cambridge Square', 33.9091682434082, 0.591826632460175, -84.2624969482422, -1.4706580076985, 218, 13, 'PPL', 'P'),
(124371, 'Cambridgeport', 42.3583297729492, 0.739292320183506, -71.1041717529297, -1.24100190899217, 218, 23, 'PPL', 'P'),
(171823, 'Cambridgeport', 43.1513900756836, 0.753133833633084, -72.5608291625977, -1.26642537686445, 218, 55, 'PPL', 'P'),
(29372, 'Camby', 39.6624984741211, 0.69224118794064, -86.3166732788086, -1.50651014808342, 218, 19, 'PPL', 'P'),
(147540, 'Camby', 41.725830078125, 0.728253117990964, -73.664436340332, -1.28568695576456, 218, 40, 'PPL', 'P'),
(1304, 'Camden', 31.9908294677734, 0.558345304656672, -87.2905578613281, -1.5235076405828, 218, 2, 'PPL', 'P'),
(7859, 'Camden', 33.5844383239746, 0.586159026186323, -92.8341674804688, -1.62026188088203, 218, 4, 'PPL', 'P'),
(13470, 'Camden', 39.1133308410645, 0.682656404598418, -75.5422210693359, -1.31846048192934, 218, 10, 'PPL', 'P'),
(45340, 'Camden', 38.3583297729492, 0.669479150103733, -75.6097183227539, -1.31963853123754, 218, 25, 'PPL', 'P'),
(53813, 'Camden', 39.1972198486328, 0.684120543986716, -94.0227813720703, -1.64100710682542, 218, 29, 'PPL', 'P'),
(58876, 'Camden', 32.7822189331055, 0.572157656492313, -89.8386077880859, -1.56797950130992, 218, 30, 'PPL', 'P'),
(63376, 'Camden', 36.3283309936523, 0.634048987593537, -76.1722183227539, -1.32945600828001, 218, 33, 'PPL', 'P'),
(70600, 'Camden', 39.9258308410645, 0.696837204770872, -75.120002746582, -1.31109138203504, 218, 37, 'PPL', 'P'),
(80099, 'Camden', 34.2463912963867, 0.597712285048277, -80.6072235107422, -1.40686145115343, 218, 48, 'PPL', 'P'),
(85495, 'Camden', 36.0588912963867, 0.629346377740675, -88.0977783203125, -1.53759629538153, 218, 50, 'PPL', 'P'),
(92993, 'Camden', 30.9169406890869, 0.539602409668371, -94.7341690063477, -1.65342316330153, 218, 51, 'PPL', 'P'),
(100439, 'Camden', 38.1627807617188, 0.666066176008742, -77.1586074829102, -1.34667174683072, 218, 53, 'PPL', 'P'),
(108457, 'Camden', 39.0544395446777, 0.681628557575702, -80.5666732788086, -1.40615371609375, 218, 58, 'PPL', 'P'),
(113234, 'Camden', 41.2377815246582, 0.719735063823373, -82.3058319091797, -1.4365077604082, 218, 41, 'PPL', 'P'),
(119011, 'Camden', 40.1536102294922, 0.700812705067115, -90.7705612182617, -1.58424515714174, 218, 18, 'PPL', 'P'),
(122317, 'Camden', 40.6086082458496, 0.708753918542595, -86.5400009155273, -1.51040795065486, 218, 19, 'PPL', 'P'),
(127020, 'Camden', 44.2097206115723, 0.771605186058737, -69.0652770996094, -1.20541648419042, 218, 26, 'PPL', 'P'),
(130058, 'Camden', 41.7522201538086, 0.728713711701493, -84.7577819824219, -1.47930236228079, 218, 27, 'PPL', 'P'),
(147541, 'Camden', 43.3344383239746, 0.75632862825577, -75.7483291625977, -1.32205774677177, 218, 40, 'PPL', 'P'),
(159762, 'Camden', 40.3397216796875, 0.704060962648684, -79.897216796875, -1.39446949628519, 218, 45, 'PPL', 'P'),
(180424, 'Camden', 38.4275016784668, 0.670686427604893, -121.378326416016, -2.11845143651988, 218, 6, 'PPL', 'P'),
(194132, 'Camden', 40.3041687011719, 0.703440446114696, -103.548606872559, -1.80726412577938, 218, 7, 'PPL', 'P'),
(209911, 'Camden', 48.0475006103516, 0.83858708300462, -117.238891601563, -2.04620466983599, 218, 56, 'PPL', 'P'),
(141426, 'Camden (historical)', 40.7083282470703, 0.710494360893989, -96.9944381713867, -1.69287230221277, 218, 35, 'PPL', 'P'),
(63377, 'Camden Acres', 35.2597198486328, 0.615398204689439, -81.5741729736328, -1.42373790298127, 218, 33, 'PPL', 'P'),
(85496, 'Camden Bay Subdivision', 35.9813919067383, 0.627993758223024, -88.0436096191406, -1.53665087319455, 218, 50, 'PPL', 'P'),
(100440, 'Camden Heights', 36.8824996948242, 0.643721056040486, -76.2033309936523, -1.32999902682628, 218, 53, 'PPL', 'P'),
(53816, 'Camden Junction', 39.1916694641113, 0.684023671502064, -94.0386123657227, -1.64128340978851, 218, 29, 'PPL', 'P'),
(108458, 'Camden on Gauley', 38.3666687011719, 0.669624691857306, -80.595832824707, -1.40666264617806, 218, 58, 'PPL', 'P'),
(53820, 'Camden Point', 39.4527816772461, 0.688580939338435, -94.7413864135742, -1.65354913082109, 218, 29, 'PPL', 'P'),
(53819, 'Camdenton', 38.0080604553223, 0.663365797242429, -92.7444381713867, -1.61869580900301, 218, 29, 'PPL', 'P'),
(177828, 'Camel', 33.0499992370605, 0.57683130446832, -113.276390075684, -1.97704597159411, 218, 5, 'PPL', 'P'),
(209347, 'Camel Hump', 43.3058280944824, 0.75582928555138, -106.568328857422, -1.8599682169101, 218, 59, 'PPL', 'P'),
(45334, 'Camelback', 38.665828704834, 0.674846018911488, -76.6166687011719, -1.33721313074514, 218, 25, 'PPL', 'P'),
(177829, 'Camelback Estates IV', 33.5641708374023, 0.585805291814533, -111.973609924316, -1.95430816852312, 218, 5, 'PPL', 'P'),
(177830, 'Camelback Trailer Ranch', 33.4700012207031, 0.584161721947791, -112.037216186523, -1.95541830722352, 218, 5, 'PPL', 'P'),
(45335, 'Camelback Village', 39.1502799987793, 0.68330128905638, -77.0652770996094, -1.34504282434997, 218, 25, 'PPL', 'P'),
(35114, 'Camelia', 37.023609161377, 0.646183880837564, -88.7744369506836, -1.54940621639354, 218, 21, 'PPL', 'P'),
(100441, 'Camellia Garden', 38.0750007629395, 0.664534126012646, -78.4944381713867, -1.36998639059382, 218, 53, 'PPL', 'P'),
(19719, 'Camellia Heights', 34.2863883972168, 0.598410366149015, -83.7922210693359, -1.46245014521888, 218, 13, 'PPL', 'P'),
(100442, 'Camellia Shores', 36.9136085510254, 0.644264008007726, -76.204719543457, -1.3300232615922, 218, 53, 'PPL', 'P'),
(1307, 'Camelot', 34.6269416809082, 0.604354142227908, -86.5313873291016, -1.51025761521132, 218, 2, 'PPL', 'P'),
(19723, 'Camelot', 33.5591697692871, 0.585718006709806, -84.3788909912109, -1.47268946697801, 218, 13, 'PPL', 'P'),
(45337, 'Camelot', 39.5061111450195, 0.689511714139418, -76.345832824707, -1.3324861529683, 218, 25, 'PPL', 'P'),
(63383, 'Camelot', 35.0166702270508, 0.611156188547107, -80.5677795410156, -1.40617302401165, 218, 33, 'PPL', 'P'),
(70603, 'Camelot', 39.9605598449707, 0.697443340234974, -74.2152786254883, -1.29530096729974, 218, 37, 'PPL', 'P'),
(80100, 'Camelot', 34.7811088562012, 0.607044867035269, -82.267219543457, -1.43583384749435, 218, 48, 'PPL', 'P'),
(85502, 'Camelot', 35.2533302307129, 0.615286684818792, -84.9013900756836, -1.48180879634072, 218, 50, 'PPL', 'P'),
(100446, 'Camelot', 38.6972198486328, 0.675393897726744, -77.4444427490234, -1.35166051334271, 218, 53, 'PPL', 'P'),
(7860, 'Camelot Acres', 35.038330078125, 0.611534224263843, -92.095832824707, -1.60737551015741, 218, 4, 'PPL', 'P'),
(112905, 'Camelot Acres', 35.8066711425781, 0.624944305616828, -80.8194427490234, -1.41056537559752, 218, 33, 'PPL', 'P'),
(19725, 'Camelot Club', 33.6027793884277, 0.58647913814935, -84.4747161865234, -1.47436193214258, 218, 13, 'PPL', 'P'),
(159763, 'Camelot Forest', 41.0999984741211, 0.717330295938059, -75.5736083984375, -1.31900829416557, 218, 45, 'PPL', 'P'),
(180425, 'Camelot Hills', 33.7683296203613, 0.589368534774032, -117.33528137207, -2.0478869886966, 218, 6, 'PPL', 'P'),
(177831, 'Camelot Luxury Homes', 33.360279083252, 0.582246709386942, -111.923057556152, -1.95342586325398, 218, 5, 'PPL', 'P'),
(13471, 'Camelot Mobile Home Park', 38.7200012207031, 0.675791507677493, -75.1197204589844, -1.31108645518702, 218, 10, 'PPL', 'P'),
(134531, 'Camelot Park', 44.1763916015625, 0.771023485097637, -94.029167175293, -1.64111856011704, 218, 28, 'PPL', 'P'),
(1308, 'Camelot Plateau', 33.5144386291504, 0.584937301036249, -86.2408294677734, -1.5051864238636, 218, 2, 'PPL', 'P'),
(85501, 'Camelot Two', 36.334171295166, 0.634150920084259, -82.3933334350586, -1.4380349501353, 218, 50, 'PPL', 'P'),
(108461, 'Camelot Village Mobile Home Park', 38.5502815246582, 0.672829340176025, -81.9524993896484, -1.43034094458801, 218, 58, 'PPL', 'P'),
(80104, 'Camelot Woods', 34.9811096191406, 0.610535538855064, -81.021110534668, -1.41408514245222, 218, 48, 'PPL', 'P'),
(108459, 'Cameo', 38.1113891601563, 0.665169223353603, -81.9313888549805, -1.4299724962512, 218, 58, 'PPL', 'P'),
(180426, 'Cameo', 36.764720916748, 0.641665428574081, -119.702217102051, -2.08919781036785, 218, 6, 'PPL', 'P'),
(186478, 'Cameo', 39.148609161377, 0.683272127442444, -108.320281982422, -1.89054556728195, 218, 7, 'PPL', 'P'),
(188209, 'Cameo', 34.2874984741211, 0.598429740645945, -103.222778320313, -1.80157734474568, 218, 38, 'PPL', 'P'),
(19726, 'Cameo (historical)', 32.8841705322266, 0.57393704757465, -84.8191680908203, -1.48037375198733, 218, 13, 'PPL', 'P'),
(806, 'Cameron', 39.7669410705566, 0.694064055127772, -80.9449996948242, -1.41275675770049, 218, 41, 'PPL', 'P'),
(19727, 'Cameron', 32.5577812194824, 0.568240479423943, -81.6738891601563, -1.42547827875363, 218, 13, 'PPL', 'P'),
(31953, 'Cameron', 37.0769386291504, 0.647114655638547, -96.8536071777344, -1.69041433768468, 218, 20, 'PPL', 'P'),
(39619, 'Cameron', 29.7975006103516, 0.520064494515655, -93.3249969482422, -1.62882847116049, 218, 22, 'PPL', 'P'),
(53821, 'Cameron', 39.7402801513672, 0.693598734306308, -94.2408294677734, -1.64481276402314, 218, 29, 'PPL', 'P'),
(58877, 'Cameron', 32.8355598449707, 0.573088631030378, -89.8838882446289, -1.5687697943634, 218, 30, 'PPL', 'P'),
(63385, 'Cameron', 35.3266716003418, 0.616566733196739, -79.2555618286133, -1.38327050442724, 218, 33, 'PPL', 'P'),
(75310, 'Cameron', 35.1338882446289, 0.613202028896505, -94.5344390869141, -1.64993721859267, 218, 42, 'PPL', 'P'),
(80105, 'Cameron', 33.5574989318848, 0.585688845095869, -80.7147216796875, -1.40873764814139, 218, 48, 'PPL', 'P'),
(92994, 'Cameron', 30.8530597686768, 0.53848747727801, -96.9766693115234, -1.69256217710383, 218, 51, 'PPL', 'P'),
(100447, 'Cameron', 38.8013916015625, 0.677212037802941, -77.1341705322266, -1.34624524158214, 218, 53, 'PPL', 'P'),
(108460, 'Cameron', 39.8269386291504, 0.695111210068391, -80.5666732788086, -1.40615371609375, 218, 58, 'PPL', 'P'),
(112190, 'Cameron', 33.7958297729492, 0.589848502981492, -87.2716674804688, -1.52317794123984, 218, 2, 'PPL', 'P'),
(114811, 'Cameron', 42.6661109924316, 0.744664115839278, -90.8658294677734, -1.58590790176833, 218, 16, 'PPL', 'P'),
(119013, 'Cameron', 40.8888893127441, 0.713645745990907, -90.517219543457, -1.57982351078388, 218, 18, 'PPL', 'P'),
(141427, 'Cameron', 40.9172210693359, 0.714140228426307, -98.6350021362305, -1.72150554498886, 218, 35, 'PPL', 'P'),
(147543, 'Cameron', 42.1991691589355, 0.736514443429472, -77.4066696166992, -1.35100124781486, 218, 40, 'PPL', 'P'),
(159766, 'Cameron', 40.9741706848145, 0.715134186724152, -76.976936340332, -1.34350098723687, 218, 45, 'PPL', 'P'),
(173422, 'Cameron', 45.4086112976074, 0.792529775901544, -91.7438888549805, -1.60123292910314, 218, 57, 'PPL', 'P'),
(177832, 'Cameron', 35.8758316040039, 0.626151383380907, -111.412216186523, -1.94450999939855, 218, 5, 'PPL', 'P'),
(180428, 'Cameron', 39.2724990844727, 0.685434414510507, -123.553329467773, -2.15641240101398, 218, 6, 'PPL', 'P'),
(194679, 'Cameron', 46.6058311462402, 0.813425204130415, -116.571113586426, -2.03454974479943, 218, 17, 'PPL', 'P'),
(196138, 'Cameron', 45.2033309936523, 0.788946958708033, -111.677780151367, -1.94914496495973, 218, 31, 'PPL', 'P'),
(196139, 'Cameron (historical)', 46.9083290100098, 0.818704787833443, -110.391670227051, -1.92669811223783, 218, 31, 'PPL', 'P'),
(200510, 'Cameron (historical)', 42.2000007629395, 0.736528957657413, -123.043060302734, -2.14750652401265, 218, 43, 'PPL', 'P'),
(180429, 'Cameron Airpark Estates', 38.6811103820801, 0.675112734494659, -120.987503051758, -2.11163028201986, 218, 6, 'PPL', 'P'),
(15405, 'Cameron City', 28.7566699981689, 0.50189857337752, -81.2188873291016, -1.41753699869913, 218, 12, 'PPL', 'P'),
(180430, 'Cameron Corners', 32.6288909912109, 0.569481579070947, -116.470283508301, -2.0327899279511, 218, 6, 'PPL', 'P'),
(100448, 'Cameron Court', 37.2961082458496, 0.650939887070283, -80.0719375610352, -1.39751894889138, 218, 53, 'PPL', 'P'),
(19728, 'Cameron Cove', 33.0972213745117, 0.577655486246673, -85.0702819824219, -1.48475651619327, 218, 13, 'PPL', 'P'),
(180431, 'Cameron Creek Colony', 36.3172187805176, 0.633855042887152, -119.203887939453, -2.08050032572182, 218, 6, 'PPL', 'P'),
(196140, 'Cameron Crossing', 45.7616691589355, 0.79869179803177, -105.824722290039, -1.84698983396982, 218, 31, 'PPL', 'P'),
(19732, 'Cameron Glen', 33.9150009155273, 0.591928431792843, -84.4300003051758, -1.47358149278513, 218, 13, 'PPL', 'P'),
(13472, 'Cameron Hills', 39.7930603027344, 0.694519921727366, -75.6944427490234, -1.32111725143281, 218, 10, 'PPL', 'P'),
(100449, 'Cameron Hills', 37.3424987792969, 0.651749554620694, -77.3433303833008, -1.34989576964637, 218, 53, 'PPL', 'P'),
(147544, 'Cameron Mills', 42.1802787780762, 0.73618474408652, -77.3638916015625, -1.35025463060325, 218, 40, 'PPL', 'P'),
(92997, 'Cameron Park', 25.9641704559326, 0.453160262005061, -97.4763870239258, -1.70128389651578, 218, 51, 'PPL', 'P'),
(180432, 'Cameron Park', 38.6688919067383, 0.674899481870371, -120.986106872559, -2.11160591409589, 218, 6, 'PPL', 'P'),
(196141, 'Cameron Park', 45.7997207641602, 0.799355923828608, -108.581108093262, -1.89509784169128, 218, 31, 'PPL', 'P'),
(92998, 'Cameron Park Colonia', 25.9710006713867, 0.453279471753356, -97.4779968261719, -1.70131199286528, 218, 51, 'PPL', 'P'),
(19729, 'Cameron Point', 34.3033294677734, 0.598706043609041, -83.9027786254883, -1.46437973858669, 218, 13, 'PPL', 'P'),
(45338, 'Cameron Ridge', 38.5050010681152, 0.672039047122544, -76.8244400024414, -1.34083942404344, 218, 25, 'PPL', 'P'),
(45339, 'Cameron Tract', 39.269718170166, 0.68538587839964, -76.9094390869141, -1.34232293792867, 218, 25, 'PPL', 'P'),
(100452, 'Cameron Valley', 38.8080596923828, 0.677328417942578, -77.0863876342773, -1.34541127268678, 218, 53, 'PPL', 'P'),
(100450, 'Cameron Villa Farms', 38.7802810668945, 0.676843589466129, -77.1377792358398, -1.34630822534192, 218, 53, 'PPL', 'P'),
(19730, 'Camerons Crossing', 33.7866706848145, 0.58968864673706, -84.5999984741211, -1.47654852055559, 218, 13, 'PPL', 'P'),
(1310, 'Cameronsville', 34.8705596923828, 0.608606078645301, -85.7455596923828, -1.49654233559742, 218, 2, 'PPL', 'P'),
(58878, 'Cameta', 33.0077781677246, 0.576094407794696, -90.8411102294922, -1.58547646967174, 218, 30, 'PPL', 'P'),
(92999, 'Camey', 33.0833282470703, 0.577413005429421, -96.855827331543, -1.69045308667854, 218, 51, 'PPL', 'P'),
(706, 'Camilla', 30.5994396209717, 0.534060970651162, -95.0577774047852, -1.65907119534137, 218, 51, 'PPL', 'P'),
(19731, 'Camilla', 31.2311096191406, 0.545085691905276, -84.210563659668, -1.46975160082149, 218, 13, 'PPL', 'P'),
(7863, 'Camilla (historical)', 34.898609161377, 0.609095634232685, -92.0722198486328, -1.60696338597872, 218, 4, 'PPL', 'P'),
(39620, 'Camille', 29.954439163208, 0.522803588986315, -92.0058288574219, -1.60580464458842, 218, 22, 'PPL', 'P'),
(113180, 'Camillus', 43.0391693115234, 0.751175211809385, -76.304443359375, -1.33176377052262, 218, 40, 'PPL', 'P'),
(180434, 'Camino', 38.7383308410645, 0.676111419903439, -120.673889160156, -2.10615668703142, 218, 6, 'PPL', 'P'),
(191213, 'Camino Barrial Colonia', 31.5820007324219, 0.551209897148022, -106.261001586914, -1.85460434415857, 218, 51, 'PPL', 'P'),
(180435, 'Camino Heights', 38.732780456543, 0.676014547418787, -120.711112976074, -2.10680636517935, 218, 6, 'PPL', 'P'),
(100451, 'Camm', 37.6458282470703, 0.657043652551662, -78.5933303833008, -1.3717123852963, 218, 53, 'PPL', 'P'),
(122318, 'Cammack', 40.2097206115723, 0.701792015978964, -85.4925003051758, -1.49212561608757, 218, 19, 'PPL', 'P'),
(7861, 'Cammack Village', 34.7780609130859, 0.606991670392495, -92.3488922119141, -1.61179222966725, 218, 4, 'PPL', 'P'),
(159768, 'Cammal', 41.4033317565918, 0.722624460448054, -77.4633331298828, -1.35199021268566, 218, 45, 'PPL', 'P'),
(196142, 'Camona', 45.7658309936523, 0.798764435750501, -111.080558776855, -1.93872148561121, 218, 31, 'PPL', 'P'),
(7862, 'Camp', 36.4141693115234, 0.635547148864761, -91.7347183227539, -1.60107287312163, 218, 4, 'PPL', 'P'),
(71994, 'Camp', 38.9736099243164, 0.680217814567259, -83.1152801513672, -1.45063529735885, 218, 41, 'PPL', 'P'),
(93000, 'Camp Air', 30.9016494750977, 0.539335527637632, -99.283561706543, -1.73282504488614, 218, 51, 'PPL', 'P'),
(119014, 'Camp Algonquin', 42.1830596923828, 0.736233280197386, -88.2677764892578, -1.54056332315199, 218, 18, 'PPL', 'P'),
(124372, 'Camp Ashmere', 42.4441719055176, 0.740790548033757, -73.0791702270508, -1.27547213508745, 218, 23, 'PPL', 'P'),
(124373, 'Camp Avoda', 41.8661117553711, 0.730701495139128, -70.8641662597656, -1.23681302291359, 218, 23, 'PPL', 'P'),
(180436, 'Camp Bartlett', 34.4280586242676, 0.600882978063099, -119.107223510742, -2.07881321317125, 218, 6, 'PPL', 'P'),
(124374, 'Camp Barton', 42.1541709899902, 0.735729077224007, -71.8958282470703, -1.25481892135972, 218, 23, 'PPL', 'P'),
(124375, 'Camp Becket', 42.2916717529297, 0.738128918261305, -73.0791702270508, -1.27547213508745, 218, 23, 'PPL', 'P'),
(124376, 'Camp Bement', 42.1805610656738, 0.736189670934536, -71.9649963378906, -1.25602613228185, 218, 23, 'PPL', 'P'),
(71995, 'Camp Bennett', 38.7730598449707, 0.676717555367541, -82.8605575561523, -1.44618954939312, 218, 41, 'PPL', 'P'),
(124377, 'Camp Berkshire', 42.0313911437988, 0.733586164652875, -72.7611083984375, -1.26992090895323, 218, 23, 'PPL', 'P'),
(186479, 'Camp Bird', 37.9727783203125, 0.662750007819375, -107.725830078125, -1.88017042430722, 218, 7, 'PPL', 'P'),
(124378, 'Camp Bob White', 42.226390838623, 0.736989551367942, -71.4688873291016, -1.24736739662968, 218, 23, 'PPL', 'P'),
(189992, 'Camp Booth (historical)', 35.6563911437988, 0.622321424838236, -114.815826416016, -2.00391420435775, 218, 39, 'PPL', 'P'),
(1312, 'Camp Branch', 33.207218170166, 0.579575292497484, -86.7600021362305, -1.51424769631454, 218, 2, 'PPL', 'P'),
(80108, 'Camp Branch', 32.8102798461914, 0.572647411816779, -81.0233306884766, -1.41412389144608, 218, 48, 'PPL', 'P'),
(124379, 'Camp Breezy Meadow', 42.1738891601563, 0.736073224215873, -71.4436111450195, -1.24692624399511, 218, 23, 'PPL', 'P'),
(171824, 'Camp Brook', 43.8502807617188, 0.765331777215919, -72.6936111450195, -1.26874285964504, 218, 55, 'PPL', 'P'),
(29373, 'Camp Brosend', 37.9644393920898, 0.662604466065802, -87.3958282470703, -1.52534495541884, 218, 19, 'PPL', 'P'),
(63387, 'Camp Bryan', 34.8450012207031, 0.608159999162713, -76.9844436645508, -1.3436320147625, 218, 33, 'PPL', 'P'),
(124380, 'Camp Burgess', 41.6977806091309, 0.72776356240358, -70.4555587768555, -1.22968147698852, 218, 23, 'PPL', 'P'),
(124381, 'Camp Cabot', 42.4000015258789, 0.740019629477207, -71.2324981689453, -1.24324162746893, 218, 23, 'PPL', 'P'),
(154575, 'Camp Calvary', 41.9441719055176, 0.732063901773786, -80.6252822875977, -1.40717663626844, 218, 41, 'PPL', 'P'),
(124382, 'Camp Caravan', 42.6427803039551, 0.744256918508604, -72.1547164916992, -1.2593373736232, 218, 23, 'PPL', 'P'),
(200511, 'Camp Carson (historical)', 45.0361099243164, 0.786028400469416, -118.294441223145, -2.06462748615078, 218, 43, 'PPL', 'P'),
(124383, 'Camp Chappa Challa', 42.0499992370605, 0.73391093714781, -70.6666717529297, -1.2333660935147, 218, 23, 'PPL', 'P'),
(124384, 'Camp Chimney Corners', 42.2811088562012, 0.737944560934844, -73.0722198486328, -1.2753508280998, 218, 23, 'PPL', 'P'),
(124385, 'Camp Cielo Celeste', 42.6019401550293, 0.743544123442845, -71.4458312988281, -1.24696499298897, 218, 23, 'PPL', 'P'),
(124386, 'Camp Collier', 42.6188888549805, 0.743839934060925, -71.9644393920898, -1.25601641174387, 218, 23, 'PPL', 'P'),
(70604, 'Camp Columbus', 39.8958282470703, 0.696313560721535, -74.3216705322266, -1.2971578563698, 218, 37, 'PPL', 'P'),
(180437, 'Camp Connell', 38.309440612793, 0.668625873290471, -120.277221679688, -2.09923353346165, 218, 6, 'PPL', 'P'),
(100453, 'Camp Corner', 36.9002799987793, 0.644031380886508, -76.9308319091797, -1.3426963131135, 218, 53, 'PPL', 'P'),
(80109, 'Camp Cox', 35.0336112976074, 0.611451866007133, -80.8899993896484, -1.41179682128557, 218, 48, 'PPL', 'P'),
(63388, 'Camp Creek', 35.5744400024414, 0.620891107595782, -81.5536117553711, -1.42337904202438, 218, 33, 'PPL', 'P'),
(80110, 'Camp Creek', 34.7608299255371, 0.606690932926398, -80.6958312988281, -1.40840794879844, 218, 48, 'PPL', 'P'),
(85503, 'Camp Creek', 36.0872192382813, 0.629840793597048, -82.7638931274414, -1.44450243684256, 218, 50, 'PPL', 'P'),
(154576, 'Camp Creek', 40.7344398498535, 0.710950094335528, -81.5736083984375, -1.42372804928523, 218, 41, 'PPL', 'P'),
(177833, 'Camp Creek', 33.9116706848145, 0.591870308302052, -111.816108703613, -1.95155925364594, 218, 5, 'PPL', 'P'),
(19735, 'Camp Creek Estates', 33.8558311462402, 0.590895724501138, -84.1194381713867, -1.4681611610185, 218, 13, 'PPL', 'P'),
(194680, 'Camp Creek Summer Home Area', 44.1738891601563, 0.770979809255759, -115.221389770508, -2.01099262021908, 218, 17, 'PPL', 'P'),
(80111, 'Camp Croft', 34.9105606079102, 0.609304226325065, -81.8530578613281, -1.4286053625056, 218, 48, 'PPL', 'P'),
(201959, 'Camp Crook', 45.5502815246582, 0.795002387815628, -103.974166870117, -1.81469154890155, 218, 49, 'PPL', 'P'),
(93002, 'Camp Dallas', 33.139720916748, 0.578397243189287, -96.9886093139648, -1.69277056945913, 218, 51, 'PPL', 'P'),
(124387, 'Camp Danbee', 42.4427795410156, 0.74076624668881, -73.0758285522461, -1.27541381185958, 218, 23, 'PPL', 'P'),
(71997, 'Camp Dennison', 39.1980590820313, 0.684135191372711, -84.2888870239258, -1.47111860140903, 218, 41, 'PPL', 'P'),
(189994, 'Camp Desert Rock', 36.6272201538086, 0.639265587536784, -116.019172668457, -2.02491655850439, 218, 39, 'PPL', 'P'),
(206949, 'Camp Diana', 48.1061096191406, 0.839610003179319, -122.429718017578, -2.13680168169496, 218, 56, 'PPL', 'P'),
(206947, 'Camp Discovery', 47.8113899230957, 0.834466174112859, -122.792503356934, -2.14313348034468, 218, 56, 'PPL', 'P'),
(114814, 'Camp Dodge', 41.6997184753418, 0.727797384549424, -93.7072219848633, -1.63549955653308, 218, 16, 'PPL', 'P'),
(63390, 'Camp Don-Lee', 34.9741706848145, 0.610414431604492, -76.7880630493164, -1.34020452643957, 218, 33, 'PPL', 'P'),
(173425, 'Camp Douglas', 43.9225006103516, 0.766592251359854, -90.2713928222656, -1.57553302510971, 218, 57, 'PPL', 'P'),
(189999, 'Camp Douglas', 38.3386116027832, 0.669135003111867, -118.198890686035, -2.06295981467617, 218, 39, 'PPL', 'P'),
(189995, 'Camp Duncan (historical)', 35.7041702270508, 0.623155327154568, -114.804168701172, -2.00371073885047, 218, 39, 'PPL', 'P'),
(189996, 'Camp Dupont (historical)', 35.5652809143066, 0.62073125135135, -114.762496948242, -2.00298342955677, 218, 39, 'PPL', 'P'),
(180438, 'Camp Earnest', 38.0130615234375, 0.663453082347156, -120.224998474121, -2.09832206657857, 218, 6, 'PPL', 'P'),
(15406, 'Camp Echockotee', 30.1522197723389, 0.526255511812248, -81.7272186279297, -1.42640905355462, 218, 12, 'PPL', 'P'),
(124388, 'Camp Edwards', 41.6569404602051, 0.72705076733782, -70.5444412231445, -1.23123276832349, 218, 23, 'PPL', 'P'),
(180440, 'Camp Eighteen', 39.6269416809082, 0.691620604827624, -121.169166564941, -2.11480090845565, 218, 6, 'PPL', 'P'),
(200512, 'Camp Elkanah', 45.2350006103516, 0.789499697792279, -118.448890686035, -2.06732313780616, 218, 43, 'PPL', 'P'),
(127022, 'Camp Ellis', 43.4636116027832, 0.758583127276577, -70.3808288574219, -1.22837719384465, 218, 26, 'PPL', 'P'),
(124389, 'Camp Emerson', 42.4324989318848, 0.740586816210366, -73.1333312988281, -1.27641742411637, 218, 23, 'PPL', 'P'),
(180439, 'Camp Evers', 37.042781829834, 0.646518507028533, -122.023887634277, -2.12971860530173, 218, 6, 'PPL', 'P'),
(39621, 'Camp Five (historical)', 30.860559463501, 0.538618371645587, -89.9705581665039, -1.57028246986257, 218, 22, 'PPL', 'P'),
(29374, 'Camp Flat Rock', 39.3969383239746, 0.687606288958493, -85.7472229003906, -1.4965713640533, 218, 19, 'PPL', 'P'),
(143571, 'Camp Forest Lake', 42.7886085510254, 0.746802101562393, -72.3600006103516, -1.26292025739574, 218, 36, 'PPL', 'P'),
(139756, 'Camp Grafton', 48.0569381713867, 0.838751799518041, -98.9205627441406, -1.72648951781089, 218, 34, 'PPL', 'P'),
(80112, 'Camp Gravatt', 33.7380599975586, 0.588840230192788, -81.5852813720703, -1.42393178110862, 218, 48, 'PPL', 'P'),
(124390, 'Camp Green Eyrie', 42.4972190856934, 0.741716395986723, -71.5972213745117, -1.24960724826449, 218, 23, 'PPL', 'P'),
(124391, 'Camp Greylock', 42.2999992370605, 0.738274260277796, -73.0680618286133, -1.27527825696009, 218, 23, 'PPL', 'P'),
(1313, 'Camp Ground', 34.3566703796387, 0.599637018147105, -87.0536117553711, -1.51937215088407, 218, 2, 'PPL', 'P'),
(7864, 'Camp Ground', 36.121940612793, 0.630446795903095, -90.5466690063477, -1.58033750087427, 218, 4, 'PPL', 'P'),
(26689, 'Camp Ground', 38.3388900756836, 0.669139863380857, -88.8349990844727, -1.5504632250302, 218, 18, 'PPL', 'P'),
(58879, 'Camp Ground', 34.1888885498047, 0.596708672791481, -89.6444396972656, -1.56459062882279, 218, 30, 'PPL', 'P'),
(85506, 'Camp Ground', 36.3952789306641, 0.635217449521809, -88.7888870239258, -1.54965841774877, 218, 50, 'PPL', 'P'),
(108462, 'Camp Ground', 39.413890838623, 0.687902166155601, -79.7333297729492, -1.39160912811639, 218, 58, 'PPL', 'P'),
(35115, 'Camp Grounds', 36.9719390869141, 0.645282067913436, -84.0722198486328, -1.46733704581917, 218, 21, 'PPL', 'P'),
(171825, 'Camp Grounds', 44.9088897705078, 0.783807989910562, -72.8838882446289, -1.27206382152436, 218, 55, 'PPL', 'P'),
(119015, 'Camp Grove', 41.0788917541504, 0.716961914180273, -89.633056640625, -1.56439195700547, 218, 18, 'PPL', 'P'),
(143572, 'Camp Gundalow', 43.0299987792969, 0.751015155827871, -70.8477783203125, -1.23652699941251, 218, 36, 'PPL', 'P'),
(63391, 'Camp Hardee', 35.4738883972168, 0.619136151016447, -76.995002746582, -1.34381630550993, 218, 33, 'PPL', 'P'),
(189997, 'Camp Harding (historical)', 37.9530601501465, 0.66240586082751, -117.486106872559, -2.05051939027609, 218, 39, 'PPL', 'P'),
(39622, 'Camp Hardtner', 31.6311092376709, 0.552067002255351, -92.399169921875, -1.61266974124643, 218, 22, 'PPL', 'P'),
(143573, 'Camp Hedding', 43.042781829834, 0.751238262148193, -71.0322189331055, -1.23974609538014, 218, 36, 'PPL', 'P'),
(124392, 'Camp Herbron', 41.9097213745117, 0.731462626578673, -71.3013916015625, -1.2444440447011, 218, 23, 'PPL', 'P'),
(1314, 'Camp Hill', 32.8002815246582, 0.572472908186351, -85.6536102294922, -1.49493751472453, 218, 2, 'PPL', 'P'),
(147548, 'Camp Hill', 41.1863899230957, 0.718838111168234, -74.0541687011719, -1.29248906866278, 218, 40, 'PPL', 'P'),
(159769, 'Camp Hill', 40.2397193908691, 0.702315593449274, -76.920280456543, -1.34251215552412, 218, 45, 'PPL', 'P'),
(159771, 'Camp Hironimus', 40.8477783203125, 0.712928223814212, -77.3333282470703, -1.34972119943691, 218, 45, 'PPL', 'P'),
(1315, 'Camp Horne', 33.4169387817383, 0.583235607678716, -86.7355575561523, -1.5138210579079, 218, 2, 'PPL', 'P'),
(124393, 'Camp Howe', 42.4519386291504, 0.740926102933242, -72.7930603027344, -1.2704785748855, 218, 23, 'PPL', 'P'),
(93003, 'Camp Hulen', 28.7063903808594, 0.501021028508825, -96.2430572509766, -1.67975823121494, 218, 51, 'PPL', 'P'),
(124394, 'Camp Immaculate Heart', 42.6458282470703, 0.744310115151379, -71.495002746582, -1.24782319665025, 218, 23, 'PPL', 'P'),
(124395, 'Camp Jayson', 42.1875, 0.736310778185108, -73.1980590820313, -1.27754713705078, 218, 23, 'PPL', 'P'),
(159772, 'Camp Jo-Ann', 40.5080604553223, 0.706999028542287, -79.6808319091797, -1.39069286754335, 218, 45, 'PPL', 'P'),
(85507, 'Camp Jordan', 35.0041694641113, 0.610938009074802, -85.1877822875977, -1.48680728339069, 218, 50, 'PPL', 'P'),
(124396, 'Camp Kingsmont', 42.3013916015625, 0.738298561622743, -73.414436340332, -1.28132363263457, 218, 23, 'PPL', 'P'),
(124397, 'Camp Kinneywood', 42.2972183227539, 0.738225724166929, -71.8625030517578, -1.25423728697765, 218, 23, 'PPL', 'P'),
(124399, 'Camp Kiwanis', 42.0583305358887, 0.734056345743328, -70.8499984741211, -1.23656574840637, 218, 23, 'PPL', 'P'),
(193421, 'Camp Klamath', 41.5405616760254, 0.725019574374417, -124.048606872559, -2.16505662243821, 218, 6, 'PPL', 'P'),
(173427, 'Camp Lake', 42.5347213745117, 0.742370934403638, -88.1436080932617, -1.53839617581494, 218, 57, 'PPL', 'P'),
(147549, 'Camp Lakeland', 42.667781829834, 0.744693277453214, -79.0602798461914, -1.37986219086416, 218, 40, 'PPL', 'P'),
(53824, 'Camp Lakewood', 37.9483299255371, 0.662323302833717, -90.9302825927734, -1.58703282101278, 218, 29, 'PPL', 'P'),
(63392, 'Camp Leach', 35.4602813720703, 0.618898663626239, -76.8872222900391, -1.34193518167396, 218, 33, 'PPL', 'P'),
(124400, 'Camp Lenore', 42.4397201538086, 0.740712850308954, -73.0930633544922, -1.2757146159047, 218, 23, 'PPL', 'P'),
(39623, 'Camp Leroy Johnson', 30.0300006866455, 0.524122386358122, -90.0455627441406, -1.57159154669639, 218, 22, 'PPL', 'P'),
(124401, 'Camp Lincoln Hill', 42.0708312988281, 0.734274525215633, -71.2152786254883, -1.24294108973991, 218, 23, 'PPL', 'P'),
(119016, 'Camp Logan', 42.464168548584, 0.741139555294612, -87.8169403076172, -1.53269474739524, 218, 18, 'PPL', 'P'),
(80113, 'Camp Long', 33.6780586242676, 0.587793008673141, -81.6197204589844, -1.42453285656665, 218, 48, 'PPL', 'P'),
(130060, 'Camp Lu Lay Lea', 44.3369407653809, 0.773825596617591, -84.008056640625, -1.46621718658079, 218, 27, 'PPL', 'P'),
(154577, 'Camp Luther', 41.9411087036133, 0.732010438814902, -80.6466674804688, -1.40754987829522, 218, 41, 'PPL', 'P'),
(124402, 'Camp Mah-Kee-Nac', 42.3402786254883, 0.73897726822655, -73.3097229003906, -1.2794960383365, 218, 23, 'PPL', 'P'),
(211579, 'Camp Maluhia', 20.9566707611084, 0.365762905037768, -156.537780761719, -2.73209967805703, 218, 15, 'PPL', 'P'),
(171826, 'Camp Maquam', 44.9027786254883, 0.783701330308904, -73.1661071777344, -1.27698947111852, 218, 55, 'PPL', 'P'),
(124403, 'Camp Mar Vel (historical)', 41.9319381713867, 0.731850382833389, -70.0227813720703, -1.22212808634678, 218, 23, 'PPL', 'P'),
(124404, 'Camp Marion White', 42.4152793884277, 0.740286278481351, -73.3166732788086, -1.27961734532416, 218, 23, 'PPL', 'P'),
(124405, 'Camp Mary Day', 42.327220916748, 0.738749368216266, -71.3263931274414, -1.24488040364571, 218, 23, 'PPL', 'P'),
(124406, 'Camp Massapoag', 42.6500015258789, 0.744382952607192, -71.4983291625977, -1.24788125356201, 218, 23, 'PPL', 'P'),
(180441, 'Camp Meeker', 38.4252815246582, 0.670647678611032, -122.95832824707, -2.14602767065932, 218, 6, 'PPL', 'P'),
(124407, 'Camp Merrill', 42.4888916015625, 0.741571053970232, -73.2452774047852, -1.27837125225011, 218, 23, 'PPL', 'P'),
(124408, 'Camp Merriwood', 41.7930603027344, 0.729426506767253, -71.1041717529297, -1.24100190899217, 218, 23, 'PPL', 'P'),
(124409, 'Camp Mishannock', 41.9555587768555, 0.732262640170133, -70.7388916015625, -1.23462656765863, 218, 23, 'PPL', 'P'),
(124410, 'Camp Mohawk', 42.5336112976074, 0.742351559906707, -73.2008285522461, -1.27759547342457, 218, 23, 'PPL', 'P'),
(124411, 'Camp Nashoba', 42.6027793884277, 0.74355877082884, -71.4480590820313, -1.24700387514088, 218, 23, 'PPL', 'P'),
(180442, 'Camp Nelson', 36.1427803039551, 0.630810517128973, -118.608329772949, -2.07010587482918, 218, 6, 'PPL', 'P'),
(124412, 'Camp Neyati', 42.1972198486328, 0.736480421546546, -71.9430618286133, -1.25564330287515, 218, 23, 'PPL', 'P'),
(124413, 'Camp Noquochoke', 41.5958290100098, 0.725984171321244, -71.0633316040039, -1.24028911392641, 218, 23, 'PPL', 'P'),
(124414, 'Camp Norse', 41.9366683959961, 0.731932940827181, -70.7458267211914, -1.23474760833017, 218, 23, 'PPL', 'P'),
(143574, 'Camp Notre Dame', 42.9199981689453, 0.749095282998033, -72.4377822875977, -1.26427780376141, 218, 36, 'PPL', 'P'),
(80114, 'Camp Oak', 34.8580589294434, 0.608387899172996, -83.0341720581055, -1.44921969408142, 218, 48, 'PPL', 'P'),
(15407, 'Camp Ocala', 29.1075000762939, 0.50802171335583, -81.6311111450195, -1.42473166154203, 218, 12, 'PPL', 'P'),
(63393, 'Camp Occoneechee', 35.4086112976074, 0.617996850702111, -82.208610534668, -1.43481092731965, 218, 33, 'PPL', 'P'),
(85508, 'Camp Ocoee', 35.0791702270508, 0.612247019329603, -84.6477813720703, -1.47738248945095, 218, 50, 'PPL', 'P'),
(206948, 'Camp Orkila', 48.7013893127441, 0.849999593802964, -122.940559387207, -2.14571754555039, 218, 56, 'PPL', 'P'),
(144938, 'Camp Osborne', 40.0083312988281, 0.69827710939325, -74.0591735839844, -1.29257642034654, 218, 37, 'PPL', 'P'),
(124415, 'Camp Ousamequin', 42.0069389343262, 0.73315939308819, -70.8505630493164, -1.2365756021024, 218, 23, 'PPL', 'P'),
(180443, 'Camp Owens', 35.7686080932617, 0.624279980082908, -118.430000305176, -2.06699343846321, 218, 6, 'PPL', 'P'),
(71998, 'Camp Oyo', 38.725830078125, 0.675893240431134, -83.1524963378906, -1.45128484234872, 218, 41, 'PPL', 'P'),
(180444, 'Camp Pardee', 38.2480583190918, 0.66755455016296, -120.843330383301, -2.1091139942639, 218, 6, 'PPL', 'P'),
(154578, 'Camp Park', 41.0691719055176, 0.716792270818835, -80.7922210693359, -1.41009026765905, 218, 41, 'PPL', 'P'),
(180445, 'Camp Pendola', 38.2147216796875, 0.666972716043805, -120.148063659668, -2.09697930075695, 218, 6, 'PPL', 'P'),
(7865, 'Camp Pershing (historical)', 34.8791694641113, 0.608756347509809, -92.811393737793, -1.61986440408933, 218, 4, 'PPL', 'P'),
(19736, 'Camp Pinkney (historical)', 30.8372192382813, 0.538211007867346, -81.9761123657227, -1.4307530687667, 218, 13, 'PPL', 'P'),
(147550, 'Camp Pioneer', 42.6330604553223, 0.744087275147166, -79.0811080932617, -1.38022571235295, 218, 40, 'PPL', 'P'),
(85509, 'Camp Placid', 36.5208282470703, 0.637408698466726, -82.3402786254883, -1.43710896902428, 218, 50, 'PPL', 'P'),
(119017, 'Camp Point', 40.0391693115234, 0.698815334249555, -91.0691680908203, -1.58945683023697, 218, 18, 'PPL', 'P'),
(80115, 'Camp Rawls', 33.6547203063965, 0.587385678184413, -81.4811096191406, -1.42211364103243, 218, 48, 'PPL', 'P'),
(124416, 'Camp Resolute', 42.4222183227539, 0.740407385731922, -71.5875015258789, -1.24943760490305, 218, 23, 'PPL', 'P'),
(180446, 'Camp Richardson', 38.934440612793, 0.679534181115436, -120.039169311523, -2.09507873584502, 218, 6, 'PPL', 'P'),
(134535, 'Camp Ripley Junction', 46.0702781677246, 0.804078041336455, -94.3280563354492, -1.64633516006029, 218, 28, 'PPL', 'P'),
(80116, 'Camp Road Estates', 32.7363891601563, 0.571357776058908, -79.9747161865234, -1.39582211580284, 218, 48, 'PPL', 'P'),
(29375, 'Camp Roberts', 39.1783294677734, 0.683790844643764, -86.1936111450195, -1.50436230866427, 218, 19, 'PPL', 'P'),
(124417, 'Camp Romaca', 42.4269409179688, 0.74048981056766, -73.133056640625, -1.27641263042641, 218, 23, 'PPL', 'P'),
(15408, 'Camp Roosevelt', 29.1458301544189, 0.508690699421658, -82.1155624389648, -1.43318693168692, 218, 12, 'PPL', 'P'),
(154579, 'Camp Roosevelt', 41.791389465332, 0.729397345153317, -81.1675033569336, -1.41664017920204, 218, 41, 'PPL', 'P'),
(180447, 'Camp Rose', 38.6152801513672, 0.673963780221372, -122.830001831055, -2.14378795218257, 218, 6, 'PPL', 'P'),
(124418, 'Camp Rowe', 42.6894416809082, 0.745071313169951, -72.898063659668, -1.27231122918963, 218, 23, 'PPL', 'P'),
(93004, 'Camp Ruby', 30.6965599060059, 0.535756039395483, -94.7292175292969, -1.65333674372416, 218, 51, 'PPL', 'P'),
(124419, 'Camp Russell', 42.4116706848145, 0.74022329472157, -73.3236083984375, -1.2797383859957, 218, 23, 'PPL', 'P'),
(80117, 'Camp Saint Christopher', 32.565559387207, 0.56837623406051, -80.1819381713867, -1.39943882172122, 218, 48, 'PPL', 'P'),
(93005, 'Camp San Saba', 30.9952793121338, 0.540969676572018, -99.2547225952148, -1.73232170744011, 218, 51, 'PPL', 'P'),
(124420, 'Camp Sayre', 42.2333297729492, 0.737110658618513, -71.0944366455078, -1.24083199931462, 218, 23, 'PPL', 'P'),
(124421, 'Camp Sea Haven', 42.7374992370605, 0.745910075755271, -70.7888870239258, -1.23549915238979, 218, 23, 'PPL', 'P'),
(63394, 'Camp Seagull', 34.9705581665039, 0.610351381265685, -76.7994384765625, -1.34040306509883, 218, 33, 'PPL', 'P'),
(93006, 'Camp Seale', 30.5752601623535, 0.533638959486925, -94.6075286865234, -1.65121287275482, 218, 51, 'PPL', 'P'),
(39624, 'Camp Seven (historical)', 30.9549999237061, 0.540266668623264, -90.0277786254883, -1.57128115527135, 218, 22, 'PPL', 'P'),
(200513, 'Camp Sherman', 44.4605598449707, 0.775983156574718, -121.639999389648, -2.12301849147326, 218, 43, 'PPL', 'P'),
(19737, 'Camp Sherwood', 31.5977802276611, 0.55148530129425, -83.8666687011719, -1.46374950151473, 218, 13, 'PPL', 'P'),
(29376, 'Camp Shor', 38.9980583190918, 0.680644519552917, -84.8491668701172, -1.48089732945764, 218, 19, 'PPL', 'P'),
(180448, 'Camp Sierra', 37.190559387207, 0.649097711965247, -119.258888244629, -2.08146026213674, 218, 6, 'PPL', 'P'),
(39625, 'Camp Six (historical)', 30.9022197723389, 0.539345481202206, -89.9361114501953, -1.56968126124648, 218, 22, 'PPL', 'P'),
(124422, 'Camp Snipatuit', 41.7649993896484, 0.728936751442787, -70.8722229003906, -1.23695363781914, 218, 23, 'PPL', 'P'),
(180449, 'Camp Spaulding', 39.3191719055176, 0.686249008908934, -120.636940002441, -2.10551180257346, 218, 6, 'PPL', 'P'),
(1316, 'Camp Spring (historical)', 34.4263916015625, 0.600853883028189, -87.4583282470703, -1.52643578620134, 218, 2, 'PPL', 'P'),
(35117, 'Camp Springs', 39.0019416809082, 0.68071229700266, -84.3647232055664, -1.4724421924708, 218, 21, 'PPL', 'P'),
(45345, 'Camp Springs', 38.8038902282715, 0.677255647065791, -76.9069366455078, -1.34227926208679, 218, 25, 'PPL', 'P'),
(63395, 'Camp Springs', 36.2961082458496, 0.633486594550339, -79.491943359375, -1.38739614042994, 218, 33, 'PPL', 'P'),
(191215, 'Camp Springs', 32.7597694396973, 0.571765838916935, -100.691688537598, -1.75740149437371, 218, 51, 'PPL', 'P'),
(124423, 'Camp Spruce Hill', 42.0436096191406, 0.733799417277163, -73.0250015258789, -1.27452671290047, 218, 23, 'PPL', 'P'),
(124424, 'Camp Stevenson', 42.475830078125, 0.741343087380921, -73.2827835083008, -1.27902585724605, 218, 23, 'PPL', 'P'),
(124425, 'Camp Sumner', 42.4874992370605, 0.741546752625285, -73.2416687011719, -1.27830826849033, 218, 23, 'PPL', 'P'),
(189998, 'Camp Sunrise (historical)', 35.4666709899902, 0.619010183496886, -114.866668701172, -2.00480156963297, 218, 39, 'PPL', 'P'),
(93007, 'Camp Swift', 30.190559387207, 0.526924664325644, -97.2919387817383, -1.69806466739009, 218, 51, 'PPL', 'P'),
(124426, 'Camp Taconic', 42.4527816772461, 0.740940816898265, -73.091667175293, -1.27569024798073, 218, 23, 'PPL', 'P'),
(35116, 'Camp Taylor', 38.1955604553223, 0.666638289589918, -85.7155609130859, -1.49601875812711, 218, 21, 'PPL', 'P'),
(100454, 'Camp Tazewell', 37.1480598449707, 0.648355955022633, -81.6483306884766, -1.42503219927104, 218, 53, 'PPL', 'P'),
(124427, 'Camp Ted', 42.3972206115723, 0.73997109336634, -71.2286071777344, -1.24317371686113, 218, 23, 'PPL', 'P'),
(180450, 'Camp Thayer', 38.4911117553711, 0.67179663288432, -123.0625, -2.14784581073552, 218, 6, 'PPL', 'P'),
(196143, 'Camp Three', 46.4408302307129, 0.810545394885658, -108.564170837402, -1.89480223081028, 218, 31, 'PPL', 'P'),
(124428, 'Camp Titicut', 41.9333305358887, 0.731874684178336, -70.9994430541992, -1.239174048378, 218, 23, 'PPL', 'P'),
(85510, 'Camp Tom Howard', 36.538890838623, 0.637723950160764, -81.9933319091797, -1.43105360649571, 218, 50, 'PPL', 'P'),
(26690, 'Camp Travis', 38.6599998474121, 0.674744286157847, -88.3313903808594, -1.54167359501044, 218, 18, 'PPL', 'P'),
(19738, 'Camp Valley Estates', 33.5763893127441, 0.586018544438821, -84.4563903808594, -1.47404208649566, 218, 13, 'PPL', 'P'),
(93008, 'Camp Verde', 29.8936100006104, 0.521741919817755, -99.1044387817383, -1.72969876008249, 218, 51, 'PPL', 'P'),
(177834, 'Camp Verde', 34.5636100769043, 0.60324879721747, -111.853607177734, -1.95221372548383, 218, 5, 'PPL', 'P'),
(124429, 'Camp Virginia', 42.4249992370605, 0.740455921842789, -71.5805587768555, -1.24931643107345, 218, 23, 'PPL', 'P'),
(124430, 'Camp Wakitatina', 42.6002807617188, 0.74351516156599, -71.4508285522461, -1.24705221151467, 218, 23, 'PPL', 'P'),
(124431, 'Camp Wampatuck', 42.0638885498047, 0.734153351386035, -70.8630599975586, -1.23679371499568, 218, 23, 'PPL', 'P'),
(124432, 'Camp Warwick', 42.6986083984375, 0.745231302572437, -72.3180618286133, -1.26218828757013, 218, 23, 'PPL', 'P'),
(71999, 'Camp Washington', 39.1361083984375, 0.683053947970139, -84.5369415283203, -1.47544796923512, 218, 41, 'PPL', 'P'),
(127023, 'Camp Wavus', 44.1858291625977, 0.771188201611058, -69.4913864135742, -1.21285349469252, 218, 26, 'PPL', 'P'),
(124433, 'Camp Welch', 41.8166694641113, 0.729838564366915, -71.0875015258789, -1.24071095864308, 218, 23, 'PPL', 'P'),
(173428, 'Camp Whitcomb', 43.1713905334473, 0.753482907472966, -88.3269424438477, -1.54159596386467, 218, 57, 'PPL', 'P'),
(85511, 'Camp Wildwood', 36.3380584716797, 0.634218764113029, -82.3541717529297, -1.43735144984153, 218, 50, 'PPL', 'P'),
(93009, 'Camp Willow', 29.6655597686768, 0.517761692410577, -98.0683288574219, -1.71161523049058, 218, 51, 'PPL', 'P'),
(124434, 'Camp Witawentin', 42.4749984741211, 0.741328573152981, -73.2863922119141, -1.27908884100583, 218, 23, 'PPL', 'P'),
(191214, 'Camp Wood', 29.6691703796387, 0.517824709459871, -100.011940002441, -1.74553764434963, 218, 51, 'PPL', 'P'),
(124435, 'Camp Woronoak', 42.1533317565918, 0.735714429838012, -72.8708267211914, -1.27183585493505, 218, 23, 'PPL', 'P'),
(93010, 'Camp Worth (historical)', 31.6119194030762, 0.55173207645876, -94.2921371459961, -1.64570825193968, 218, 51, 'PPL', 'P'),
(53825, 'Camp Wyman', 38.5238914489746, 0.672368746465496, -90.6680603027344, -1.58245617867948, 218, 29, 'PPL', 'P'),
(124436, 'Camp Wyoma', 42.4283294677734, 0.74051404533358, -73.1258316040039, -1.27628652974879, 218, 23, 'PPL', 'P'),
(124437, 'Camp Yomechas', 41.8597183227539, 0.730589908689454, -70.8597183227539, -1.23673539176781, 218, 23, 'PPL', 'P'),
(124438, 'Camp, Cedar Hill', 42.3899993896484, 0.739845059267752, -71.2186126708984, -1.24299927980973, 218, 23, 'PPL', 'P'),
(19739, 'Campagne (historical)', 34.9777793884277, 0.610477415364273, -83.817497253418, -1.46289129785345, 218, 13, 'PPL', 'P'),
(85512, 'Campaign', 35.7708282470703, 0.624318729076769, -85.6286087036133, -1.49450115577993, 218, 50, 'PPL', 'P'),
(180451, 'Campana', 38.8841705322266, 0.678656802694309, -120.519439697266, -2.10346103537604, 218, 6, 'PPL', 'P'),
(188210, 'Campana', 35.5752792358398, 0.620905754981778, -103.893333435059, -1.81328073931408, 218, 38, 'PPL', 'P'),
(19740, 'Campania', 33.4105606079102, 0.58312428754515, -82.290283203125, -1.43623638429312, 218, 13, 'PPL', 'P'),
(1318, 'Campbell', 31.9233303070068, 0.557167222058962, -87.9811096191406, -1.53556004241206, 218, 2, 'PPL', 'P'),
(7866, 'Campbell', 35.8708305358887, 0.626064098276179, -92.4749984741211, -1.61399319915015, 218, 4, 'PPL', 'P'),
(15409, 'Campbell', 28.2586097717285, 0.493205782552906, -81.456672668457, -1.42168713578385, 218, 12, 'PPL', 'P'),
(39628, 'Campbell', 30.4572200775146, 0.531578771357153, -90.4438934326172, -1.57854372872205, 218, 22, 'PPL', 'P'),
(45342, 'Campbell', 38.4116706848145, 0.670410124641797, -75.2380599975586, -1.31315186977043, 218, 25, 'PPL', 'P'),
(53826, 'Campbell', 36.4933280944824, 0.636928730259267, -90.0749969482422, -1.57210527047067, 218, 29, 'PPL', 'P'),
(63396, 'Campbell', 36.5277786254883, 0.637530005454379, -80.2375030517578, -1.40040861183217, 218, 33, 'PPL', 'P'),
(80118, 'Campbell', 34.5108299255371, 0.602327609796412, -82.5580596923828, -1.4409099656901, 218, 48, 'PPL', 'P'),
(85513, 'Campbell', 36.0819396972656, 0.629748648223331, -85.5361099243164, -1.49288674752712, 218, 50, 'PPL', 'P'),
(93011, 'Campbell', 33.1480598449707, 0.57854278494286, -95.9511108398438, -1.6746628051013, 218, 51, 'PPL', 'P'),
(100455, 'Campbell', 38.0316696166992, 0.663777854842091, -78.3024978637695, -1.3666364002586, 218, 53, 'PPL', 'P'),
(114816, 'Campbell', 41.6105613708496, 0.726241299524491, -93.7944412231445, -1.63702181941217, 218, 16, 'PPL', 'P'),
(119019, 'Campbell', 40.1911087036133, 0.701467176905002, -87.5794372558594, -1.52854953715853, 218, 18, 'PPL', 'P'),
(127024, 'Campbell', 46.7730598449707, 0.816343895527087, -67.9619369506836, -1.18615956582222, 218, 26, 'PPL', 'P'),
(130061, 'Campbell', 46.017219543457, 0.803151993646407, -87.1311111450195, -1.52072477040172, 218, 27, 'PPL', 'P'),
(134537, 'Campbell', 46.0977783203125, 0.804558009543914, -96.4044418334961, -1.68257492354187, 218, 28, 'PPL', 'P'),
(141429, 'Campbell', 40.2983283996582, 0.703338513623973, -98.7316665649414, -1.72319265753943, 218, 35, 'PPL', 'P'),
(147552, 'Campbell', 42.2330589294434, 0.737105931507578, -77.1977767944336, -1.34735538028254, 218, 40, 'PPL', 'P'),
(154580, 'Campbell', 41.0783309936523, 0.716952127063267, -80.5994415283203, -1.40672562993784, 218, 41, 'PPL', 'P'),
(188211, 'Campbell', 33.6080589294434, 0.586571283523067, -104.196388244629, -1.81857004355509, 218, 38, 'PPL', 'P'),
(193422, 'Campbell', 41.2400016784668, 0.719773812817234, -120.279441833496, -2.09927228245551, 218, 6, 'PPL', 'P'),
(211717, 'Campbell', 61.1719398498535, 1.06765176021187, -149.894165039063, -2.61614670945942, 218, 1, 'PPL', 'P'),
(19741, 'Campbell (historical)', 33.0819396972656, 0.577388770663501, -83.6083297729492, -1.45924063663117, 218, 13, 'PPL', 'P'),
(29377, 'Campbell Corner', 39.1427803039551, 0.683170394688803, -87.4088897705078, -1.52557292200815, 218, 19, 'PPL', 'P'),
(45343, 'Campbell Corner', 39.0019416809082, 0.68071229700266, -77.1808319091797, -1.34705963624349, 218, 25, 'PPL', 'P'),
(100457, 'Campbell Corner', 37.8591690063477, 0.660767151229757, -77.404167175293, -1.35095757197298, 218, 53, 'PPL', 'P'),
(139067, 'Campbell Corner', 40.1300010681152, 0.700400647467452, -95.0891723632813, -1.65961914073566, 218, 29, 'PPL', 'P'),
(171827, 'Campbell Corner', 43.833610534668, 0.765040826866828, -72.311393737793, -1.2620719074305, 218, 55, 'PPL', 'P'),
(130062, 'Campbell Corners', 42.8058280944824, 0.747102639291409, -85.2322235107422, -1.48758292905817, 218, 27, 'PPL', 'P'),
(63397, 'Campbell Creek', 35.2936096191406, 0.615989692767546, -76.6911087036133, -1.33851235388293, 218, 33, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(80119, 'Campbell Crossroads', 34.6419410705566, 0.604615930963063, -80.1711120605469, -1.39924987044188, 218, 48, 'PPL', 'P'),
(77967, 'Campbell Estates', 39.9286117553711, 0.696885740881738, -76.7736129760742, -1.33995232508434, 218, 45, 'PPL', 'P'),
(147554, 'Campbell Hall', 41.4552803039551, 0.723531133641172, -74.2630615234375, -1.2961349361951, 218, 40, 'PPL', 'P'),
(147553, 'Campbell Hall Junction', 41.4602813720703, 0.723618418745899, -74.2613906860352, -1.29610577458116, 218, 40, 'PPL', 'P'),
(26693, 'Campbell Hill', 37.9300003051758, 0.662003390607771, -89.5488891601563, -1.56292295734819, 218, 18, 'PPL', 'P'),
(180453, 'Campbell Hot Springs', 39.5750007629395, 0.690714064792561, -120.346939086914, -2.10045033176371, 218, 6, 'PPL', 'P'),
(85515, 'Campbell Junction', 36.0436096191406, 0.629079662157503, -85.1691665649414, -1.4864823777377, 218, 50, 'PPL', 'P'),
(1320, 'Campbell Mill', 34.4930610656738, 0.602017484687472, -86.2441711425781, -1.50524474709147, 218, 2, 'PPL', 'P'),
(108464, 'Campbell Park', 38.4066696166992, 0.67032283953707, -82.3691711425781, -1.43761323857669, 218, 58, 'PPL', 'P'),
(196144, 'Campbell Place', 45.1502799987793, 0.78802104417604, -112.195831298828, -1.95818666317666, 218, 31, 'PPL', 'P'),
(1321, 'Campbell Settlement (historical)', 34.6472206115723, 0.604708076336779, -87.54638671875, -1.52797269646642, 218, 2, 'PPL', 'P'),
(1322, 'Campbell Springs', 33.3699989318848, 0.58241635274838, -85.8677825927734, -1.49867552763057, 218, 2, 'PPL', 'P'),
(7868, 'Campbell Station', 35.6683311462402, 0.622529817193535, -91.2447204589844, -1.59252079707111, 218, 4, 'PPL', 'P'),
(108465, 'Campbells', 39.6180610656738, 0.691465608852182, -78.4119415283203, -1.36854655255046, 218, 58, 'PPL', 'P'),
(70605, 'Campbells Corner', 39.4858283996582, 0.689157713451519, -75.3191680908203, -1.31456747304787, 218, 37, 'PPL', 'P'),
(100459, 'Campbells Corner', 37.9258308410645, 0.661930619730985, -77.3441696166992, -1.34991041703236, 218, 53, 'PPL', 'P'),
(130064, 'Campbells Corner', 42.7997207641602, 0.746996046268778, -83.1336135864258, -1.45095527616382, 218, 27, 'PPL', 'P'),
(171828, 'Campbells Corner', 44.5916709899902, 0.778271477741369, -72.3319396972656, -1.26243050207128, 218, 55, 'PPL', 'P'),
(130065, 'Campbells Corners', 44.313060760498, 0.773408811906993, -84.1455612182617, -1.46861709419712, 218, 27, 'PPL', 'P'),
(63398, 'Campbells Crossroad', 35.0869407653809, 0.612382640808115, -79.2313919067383, -1.38284865971057, 218, 33, 'PPL', 'P'),
(1323, 'Campbells Crossroads', 33.3699989318848, 0.58241635274838, -85.8766708374023, -1.49883065676407, 218, 2, 'PPL', 'P'),
(1324, 'Campbells Landing', 31.9608306884766, 0.557821727186362, -88.0688934326172, -1.53709215898718, 218, 2, 'PPL', 'P'),
(100460, 'Campbells Landing', 36.6066703796387, 0.638906926316977, -75.9913864135742, -1.32629989607216, 218, 53, 'PPL', 'P'),
(159773, 'Campbells Mill', 40.4688911437988, 0.706315395090464, -79.2294387817383, -1.38281457124862, 218, 45, 'PPL', 'P'),
(85516, 'Campbells Station', 35.4466705322266, 0.618661109657004, -86.9888916015625, -1.51824257110771, 218, 50, 'PPL', 'P'),
(124439, 'Campbells Station', 42.1305618286133, 0.735317019624345, -71.2986068725586, -1.2443954420112, 218, 23, 'PPL', 'P'),
(29380, 'Campbellsburg', 38.6513900756836, 0.674594017293339, -86.2611083984375, -1.50554035797247, 218, 19, 'PPL', 'P'),
(35119, 'Campbellsburg', 38.523609161377, 0.672363819617479, -85.2027816772461, -1.48706907212584, 218, 21, 'PPL', 'P'),
(26694, 'Campbellsburg (historical)', 39.6836090087891, 0.692609636277453, -89.420280456543, -1.56067831202341, 218, 18, 'PPL', 'P'),
(154582, 'Campbellsport', 41.1358299255371, 0.717955672741036, -81.1975021362305, -1.41716375667235, 218, 41, 'PPL', 'P'),
(173430, 'Campbellsport', 43.5977783203125, 0.760924778244056, -88.2788925170898, -1.5407573344374, 218, 57, 'PPL', 'P'),
(72000, 'Campbellstown', 39.7877807617188, 0.69442777635365, -84.7602767944336, -1.47934590496461, 218, 41, 'PPL', 'P'),
(35120, 'Campbellsville', 37.3433303833008, 0.651764068848635, -85.3419418334961, -1.48949787503999, 218, 21, 'PPL', 'P'),
(85517, 'Campbellsville', 35.3372192382813, 0.61675082420709, -87.1305618286133, -1.52071518302179, 218, 50, 'PPL', 'P'),
(15420, 'Campbellton', 30.9491691589355, 0.54016490258011, -85.4022216796875, -1.49054995682863, 218, 12, 'PPL', 'P'),
(19742, 'Campbellton', 33.6502799987793, 0.587308180196692, -84.6694412231445, -1.47776052516769, 218, 13, 'PPL', 'P'),
(53834, 'Campbellton', 38.5400009155273, 0.672649909697581, -91.1605606079102, -1.59105193057188, 218, 29, 'PPL', 'P'),
(93012, 'Campbellton', 28.7472190856934, 0.501733623837503, -98.3022232055664, -1.71569745696751, 218, 51, 'PPL', 'P'),
(58880, 'Campbellton (historical)', 34.461109161377, 0.60145981875521, -88.6836090087891, -1.54782096975467, 218, 30, 'PPL', 'P'),
(29381, 'Campbelltown', 38.4213905334473, 0.670579768003235, -87.2399978637695, -1.5226252021556, 218, 19, 'PPL', 'P'),
(108466, 'Campbelltown', 38.2416687011719, 0.667443030292313, -80.0908279418945, -1.39784864823433, 218, 58, 'PPL', 'P'),
(159776, 'Campbelltown', 41.7119407653809, 0.72801070375274, -78.6530609130859, -1.37275487970501, 218, 45, 'PPL', 'P'),
(186480, 'Campbelltown', 38.6122207641602, 0.673910383841516, -106.564720153809, -1.85990523315032, 218, 7, 'PPL', 'P'),
(1325, 'Campbellville', 33.8363914489746, 0.590556437778262, -87.0552825927734, -1.519401312498, 218, 2, 'PPL', 'P'),
(58882, 'Campbellville', 32.8122215270996, 0.57268130054165, -90.6952819824219, -1.58293128661795, 218, 30, 'PPL', 'P'),
(159775, 'Campbellville', 41.5480613708496, 0.725150468741995, -76.5541687011719, -1.33612229996264, 218, 45, 'PPL', 'P'),
(193423, 'Campbellville', 40.0258293151855, 0.698582507391255, -121.721939086914, -2.12444860897863, 218, 6, 'PPL', 'P'),
(63399, 'Campcall', 35.3822212219238, 0.617536256991582, -81.6186065673828, -1.4245134154907, 218, 33, 'PPL', 'P'),
(124440, 'Campello', 42.0541687011719, 0.733983708024597, -71.0208282470703, -1.23954729040477, 218, 23, 'PPL', 'P'),
(39629, 'Camperdown', 29.8455600738525, 0.520903290390489, -91.48388671875, -1.5966950357637, 218, 22, 'PPL', 'P'),
(45344, 'Campers Hill', 39.475830078125, 0.688983209821092, -77.3069381713867, -1.34926060572638, 218, 25, 'PPL', 'P'),
(80120, 'Campfield', 33.4824981689453, 0.584379834841068, -79.2694396972656, -1.38351271892838, 218, 48, 'PPL', 'P'),
(144939, 'Campgaw', 41.0238914489746, 0.716001977765354, -74.2013931274414, -1.29505861964054, 218, 37, 'PPL', 'P'),
(1326, 'Campground', 32.1913909912109, 0.561845763593472, -87.9561080932617, -1.53512368346745, 218, 2, 'PPL', 'P'),
(124441, 'Campground Landing', 41.8527793884277, 0.730468801438883, -70.0069427490234, -1.22185165022563, 218, 23, 'PPL', 'P'),
(19743, 'Campground School Estates', 33.8563919067383, 0.590905511618144, -84.834716796875, -1.48064512810241, 218, 13, 'PPL', 'P'),
(180455, 'Camphora', 36.4530601501465, 0.636225922047595, -121.370002746582, -2.11830616108242, 218, 6, 'PPL', 'P'),
(173432, 'Campia', 45.5374984741211, 0.794779281495307, -91.6655578613281, -1.59986579535755, 218, 57, 'PPL', 'P'),
(194133, 'Campion', 40.3494415283203, 0.704230606010122, -105.077217102051, -1.83394340726368, 218, 7, 'PPL', 'P'),
(180456, 'Campland on the Bay Trailer Park', 32.7958297729492, 0.572395210461548, -117.223327636719, -2.04593302740481, 218, 6, 'PPL', 'P'),
(180457, 'Campo', 32.6063919067383, 0.569088895968215, -116.468063354492, -2.03275117895724, 218, 6, 'PPL', 'P'),
(186481, 'Campo', 37.1049995422363, 0.647604410963013, -102.579170227051, -1.79034426442578, 218, 7, 'PPL', 'P'),
(93018, 'Campo Alto', 26.204719543457, 0.45735863559503, -98.126106262207, -1.71262363643734, 218, 51, 'PPL', 'P'),
(191216, 'Campo Bello Estates Colonia', 31.5909996032715, 0.55136695707331, -106.251998901367, -1.85444721765426, 218, 51, 'PPL', 'P'),
(177836, 'Campo Bonito', 32.5636100769043, 0.568342212177584, -110.737777709961, -1.9327388273804, 218, 5, 'PPL', 'P'),
(180459, 'Campo Seco', 37.9388885498047, 0.662158519741268, -120.415000915527, -2.10163823476794, 218, 6, 'PPL', 'P'),
(93013, 'Campo Verde Colonia', 26.3920001983643, 0.460627299648453, -98.9140014648438, -1.72637500188402, 218, 51, 'PPL', 'P'),
(80121, 'Campobello', 35.1155586242676, 0.61288211667056, -82.1502838134766, -1.43379293399297, 218, 48, 'PPL', 'P'),
(93014, 'Campobello Colonia', 26.4120006561279, 0.460976373488335, -99.0230026245117, -1.72827743100872, 218, 51, 'PPL', 'P'),
(93015, 'Campobello Number 2 Colonia', 26.4139995574951, 0.461011260898615, -99.0230026245117, -1.72827743100872, 218, 51, 'PPL', 'P'),
(93016, 'Camposanto-Elcometa Colonia', 28.6979999542236, 0.500874587938384, -99.8359985351563, -1.74246688645471, 218, 51, 'PPL', 'P'),
(100461, 'Campostella', 36.8291702270508, 0.642790281239504, -76.258056640625, -1.33095416955123, 218, 53, 'PPL', 'P'),
(100462, 'Campostella Heights', 36.833610534668, 0.642867779227225, -76.2605590820313, -1.33099784539311, 218, 53, 'PPL', 'P'),
(15410, 'Camps', 28.5911102294922, 0.49900901030527, -82.4308319091797, -1.43868942197319, 218, 12, 'PPL', 'P'),
(147556, 'Camps Mills', 43.9366683959961, 0.766839525867068, -76.0716705322266, -1.3277011182797, 218, 40, 'PPL', 'P'),
(15411, 'Camps Still', 30.4322204589844, 0.531142445702057, -82.8672180175781, -1.44630579637471, 218, 12, 'PPL', 'P'),
(177837, 'Campstone', 31.6433296203613, 0.552280288169153, -110.345832824707, -1.92589809864637, 218, 5, 'PPL', 'P'),
(39630, 'Campti', 31.8933296203613, 0.556643611299138, -93.1180572509766, -1.62521669209012, 218, 22, 'PPL', 'P'),
(93017, 'Campti', 31.8261108398438, 0.555470422259931, -94.0400009155273, -1.64130764455443, 218, 51, 'PPL', 'P'),
(15412, 'Campton', 30.8733291625977, 0.538841244939313, -86.5183334350586, -1.51002978178007, 218, 12, 'PPL', 'P'),
(19744, 'Campton', 33.8716697692871, 0.591172160622288, -83.7202835083008, -1.46119459792296, 218, 13, 'PPL', 'P'),
(26695, 'Campton', 37.9283294677734, 0.661974228993835, -89.8019409179688, -1.56733954369997, 218, 18, 'PPL', 'P'),
(35121, 'Campton', 37.7341690063477, 0.658585489664764, -83.5475006103516, -1.45817896746261, 218, 21, 'PPL', 'P'),
(80122, 'Campton', 35.0286102294922, 0.611364580902405, -82.0641708374023, -1.43228997903178, 218, 48, 'PPL', 'P'),
(206951, 'Campton', 47.6624984741211, 0.831867528100186, -122.098892211914, -2.13102768213556, 218, 56, 'PPL', 'P'),
(143575, 'Campton Hollow', 43.8233299255371, 0.764861396388384, -71.6413879394531, -1.25037810024201, 218, 36, 'PPL', 'P'),
(143576, 'Campton Lower Village', 43.8588905334473, 0.765482046080427, -71.6333312988281, -1.25023748533646, 218, 36, 'PPL', 'P'),
(119020, 'Campton Pines', 41.9174995422363, 0.73159838121524, -88.3886108398438, -1.54267228041922, 218, 18, 'PPL', 'P'),
(143577, 'Campton Station', 43.8536109924316, 0.76538990070671, -71.6513900756836, -1.25055267045147, 218, 36, 'PPL', 'P'),
(143578, 'Campton Upper Village', 43.8658294677734, 0.765603153330998, -71.6386108398438, -1.25032963071017, 218, 36, 'PPL', 'P'),
(180461, 'Camptonville', 39.4519386291504, 0.688566225373413, -121.047500610352, -2.11267743696048, 218, 6, 'PPL', 'P'),
(159778, 'Camptown', 41.7311096191406, 0.728345263364681, -76.2350006103516, -1.33055176591052, 218, 45, 'PPL', 'P'),
(119022, 'Campus', 41.0233306884766, 0.715992190648348, -88.3061065673828, -1.54123230921782, 218, 18, 'PPL', 'P'),
(154583, 'Campus', 40.702220916748, 0.710387767871358, -80.6666717529297, -1.40789901871413, 218, 41, 'PPL', 'P'),
(45346, 'Campus Green', 39.0558280944824, 0.681652792341621, -76.5124969482422, -1.33539499066894, 218, 25, 'PPL', 'P'),
(45347, 'Campus Heights', 39.5402793884277, 0.690108062486514, -76.9872207641602, -1.34368048429434, 218, 25, 'PPL', 'P'),
(45348, 'Campus Hill Farms', 39.5680618286133, 0.69059295754199, -76.2658309936523, -1.33108985760877, 218, 25, 'PPL', 'P'),
(45349, 'Campus Hills', 39.4063911437988, 0.687771271788024, -76.5830612182617, -1.33662656951505, 218, 25, 'PPL', 'P'),
(45350, 'Campus Hills Estates', 39.5675010681152, 0.690583170424984, -76.2769393920898, -1.33128373573613, 218, 25, 'PPL', 'P'),
(45351, 'Campus Valley Estates', 39.5625, 0.690495885320257, -76.2713928222656, -1.33118692983051, 218, 25, 'PPL', 'P'),
(15413, 'Campville', 29.666109085083, 0.517771279790501, -82.1186065673828, -1.43324006175067, 218, 12, 'PPL', 'P'),
(147557, 'Campville', 42.0875015258789, 0.734565475564724, -76.149169921875, -1.32905373779735, 218, 40, 'PPL', 'P'),
(177560, 'Campville', 41.7372207641602, 0.728451922966338, -73.1061096191406, -1.2759423161779, 218, 8, 'PPL', 'P'),
(147558, 'Camroden', 43.2527809143066, 0.754903437598414, -75.3555603027344, -1.31520263696785, 218, 40, 'PPL', 'P'),
(180468, 'Camulos', 34.4066696166992, 0.600509669457297, -118.755828857422, -2.07268021949691, 218, 6, 'PPL', 'P'),
(15414, 'Cana', 27.2833309173584, 0.476183955419069, -80.4933319091797, -1.4048736677158, 218, 12, 'PPL', 'P'),
(63400, 'Cana', 35.9741706848145, 0.627867724124435, -80.5774993896484, -1.40634266737309, 218, 33, 'PPL', 'P'),
(93023, 'Cana', 32.5744400024414, 0.568531230035952, -96.0144424438477, -1.67576815011173, 218, 51, 'PPL', 'P'),
(100463, 'Cana', 36.5894393920898, 0.63860618885088, -80.6719436645508, -1.40799103092979, 218, 53, 'PPL', 'P'),
(180462, 'Cana', 39.8402786254883, 0.695344036926691, -121.993057250977, -2.12918051360348, 218, 6, 'PPL', 'P'),
(80123, 'Cana (historical)', 34.1402816772461, 0.595860322826236, -82.2752838134766, -1.43597459555796, 218, 48, 'PPL', 'P'),
(93019, 'Cana de Azucar Colonia', 26.2880001068115, 0.458812155628482, -97.9940032958984, -1.7103180047236, 218, 51, 'PPL', 'P'),
(1328, 'Canaan', 32.204719543457, 0.56207839071469, -86.3036117553711, -1.50628218149411, 218, 2, 'PPL', 'P'),
(7871, 'Canaan', 35.8669395446777, 0.625996187668382, -92.7033309936523, -1.61797835340534, 218, 4, 'PPL', 'P'),
(15415, 'Canaan', 28.7900009155273, 0.502480307628134, -81.2227783203125, -1.41760490930692, 218, 12, 'PPL', 'P'),
(19745, 'Canaan', 33.603889465332, 0.586498512646281, -83.4669418334961, -1.4567729515651, 218, 13, 'PPL', 'P'),
(29382, 'Canaan', 38.8666687011719, 0.678351338117277, -85.2958297729492, -1.48869306775857, 218, 19, 'PPL', 'P'),
(53835, 'Canaan', 38.3122215270996, 0.668674409401338, -91.5588912963867, -1.59800411259753, 218, 29, 'PPL', 'P'),
(58881, 'Canaan', 34.9302787780762, 0.609648373316931, -89.1266708374023, -1.55555385745388, 218, 30, 'PPL', 'P'),
(63401, 'Canaan', 35.1630592346191, 0.613711158717901, -82.9963912963867, -1.44856029539551, 218, 33, 'PPL', 'P'),
(80126, 'Canaan', 34.8930587768555, 0.608998761748033, -81.9322204589844, -1.42998701047914, 218, 48, 'PPL', 'P'),
(85519, 'Canaan', 36.4041709899902, 0.635372645234333, -87.4911117553711, -1.52700796636154, 218, 50, 'PPL', 'P'),
(93020, 'Canaan', 33.5544395446777, 0.585635448716013, -96.4013900756836, -1.68252166032006, 218, 51, 'PPL', 'P'),
(108467, 'Canaan', 38.7444381713867, 0.676218012926069, -80.2958297729492, -1.40142660515885, 218, 58, 'PPL', 'P'),
(127025, 'Canaan', 44.7616691589355, 0.781238505511826, -69.5619430541992, -1.21408494038058, 218, 26, 'PPL', 'P'),
(143580, 'Canaan', 43.6474990844727, 0.761792569285258, -72.0122222900391, -1.25685038063923, 218, 36, 'PPL', 'P'),
(147559, 'Canaan', 42.4119415283203, 0.740228021832505, -73.4475021362305, -1.28190073964279, 218, 40, 'PPL', 'P'),
(154584, 'Canaan', 40.9447212219238, 0.714620196633767, -81.9366683959961, -1.43006464162491, 218, 41, 'PPL', 'P'),
(171829, 'Canaan', 44.9961090087891, 0.785330252789651, -71.5388870239258, -1.24858912177975, 218, 55, 'PPL', 'P'),
(177559, 'Canaan', 42.0272216796875, 0.733513393776089, -73.329719543457, -1.27984504559736, 218, 8, 'PPL', 'P'),
(200514, 'Canaan', 45.9322204589844, 0.801668479761178, -122.91667175293, -2.14530062768173, 218, 43, 'PPL', 'P'),
(1329, 'Canaan (historical)', 34.7936096191406, 0.607263046507574, -87.6888885498047, -1.53045982260845, 218, 2, 'PPL', 'P'),
(143581, 'Canaan Center', 43.6802787780762, 0.762364682866435, -72.0530624389648, -1.25756317570499, 218, 36, 'PPL', 'P'),
(147560, 'Canaan Center', 42.3863906860352, 0.739782075507972, -73.4555587768555, -1.28204135454835, 218, 40, 'PPL', 'P'),
(108468, 'Canaan Crossing', 38.9747200012207, 0.68023718906419, -79.4638900756836, -1.38690651826352, 218, 58, 'PPL', 'P'),
(85520, 'Canaan Grove', 35.4436111450195, 0.618607713277148, -89.5897216796875, -1.56363561925589, 218, 50, 'PPL', 'P'),
(159777, 'Canaan Grove', 40.2897186279297, 0.703188244759465, -76.2605590820313, -1.33099784539311, 218, 45, 'PPL', 'P'),
(19746, 'Canaan Heights', 33.9083290100098, 0.59181198507418, -84.8005599975586, -1.48004897949239, 218, 13, 'PPL', 'P'),
(108469, 'Canaan Heights', 39.0980606079102, 0.682389888752328, -79.4308319091797, -1.38632954441336, 218, 58, 'PPL', 'P'),
(63402, 'Canaan Park', 36.2761116027832, 0.633137587289484, -79.7852783203125, -1.3925158013095, 218, 33, 'PPL', 'P'),
(143582, 'Canaan Street', 43.6652793884277, 0.76210289413128, -72.0427780151367, -1.25738367864752, 218, 36, 'PPL', 'P'),
(177561, 'Canaan Valley', 42.0405616760254, 0.733746220634389, -73.2572174072266, -1.27857964460541, 218, 8, 'PPL', 'P'),
(19747, 'Canaan Woods', 33.6972198486328, 0.588127435127028, -84.5827789306641, -1.47624798282658, 218, 13, 'PPL', 'P'),
(72002, 'Canaanville', 39.3211097717285, 0.686282831054779, -81.9916687011719, -1.43102457803983, 218, 41, 'PPL', 'P'),
(31955, 'Canada', 38.3541717529297, 0.669406578964028, -97.1125030517578, -1.69493292310622, 218, 20, 'PPL', 'P'),
(35122, 'Canada', 37.6055603027344, 0.65634084433999, -82.3244400024414, -1.43683253290313, 218, 21, 'PPL', 'P'),
(72003, 'Canada (historical)', 39.2386093139648, 0.6848429264324, -82.8438873291016, -1.44589859904403, 218, 41, 'PPL', 'P'),
(130066, 'Canada Corners', 43.235279083252, 0.754597973021382, -85.8491668701172, -1.49835062197758, 218, 27, 'PPL', 'P'),
(130069, 'Canada Creek Ranch', 45.1719398498535, 0.788399079892777, -84.2080612182617, -1.46970792497961, 218, 27, 'PPL', 'P'),
(188216, 'Canada de los Alamos', 35.5930595397949, 0.621216079827799, -105.860557556152, -1.84761527735182, 218, 38, 'PPL', 'P'),
(180487, 'Canada Home Mobile Home Park', 37.4319381713867, 0.653310566493644, -122.426391601563, -2.1367436247832, 218, 6, 'PPL', 'P'),
(147562, 'Canada Lake', 43.1741714477539, 0.753531443583833, -74.5119400024414, -1.30047868509107, 218, 40, 'PPL', 'P'),
(124442, 'Canada Mills', 42.3730583190918, 0.739549381807726, -71.8277816772461, -1.2536312846716, 218, 23, 'PPL', 'P'),
(130067, 'Canada Shores', 41.8077812194824, 0.729683435233418, -84.9625015258789, -1.48287539235729, 218, 27, 'PPL', 'P'),
(93021, 'Canada Verde', 29.1918201446533, 0.509493376174208, -98.275749206543, -1.71523539851838, 218, 51, 'PPL', 'P'),
(188214, 'Canada Village', 35.0663909912109, 0.612023979588309, -106.502777099609, -1.8588241229058, 218, 38, 'PPL', 'P'),
(85521, 'Canadaville', 35.1522216796875, 0.613522007701478, -89.5936126708984, -1.56370352986369, 218, 50, 'PPL', 'P'),
(159780, 'Canadensis', 41.1919403076172, 0.718934983652886, -75.2516708374023, -1.31338942373967, 218, 45, 'PPL', 'P'),
(75313, 'Canadian', 35.1772193908691, 0.613958300067061, -95.6549987792969, -1.66949467468989, 218, 42, 'PPL', 'P'),
(191217, 'Canadian', 35.9127807617188, 0.626796267838869, -100.38166809082, -1.75199061682894, 218, 51, 'PPL', 'P'),
(75315, 'Canadian Fork', 35.2430610656738, 0.61510745407743, -95.5274963378906, -1.66726933728302, 218, 42, 'PPL', 'P'),
(130068, 'Canadian Lakes', 43.5791702270508, 0.760600005749121, -85.3016662597656, -1.48879493367027, 218, 27, 'PPL', 'P'),
(75316, 'Canadian Shores', 35.1747207641602, 0.613914690804211, -95.7399978637695, -1.67097818857512, 218, 42, 'PPL', 'P'),
(93022, 'Canadiana Estates Colonia', 26.2110004425049, 0.457468257963401, -98.3769989013672, -1.7170025390597, 218, 51, 'PPL', 'P'),
(147563, 'Canadice', 42.7369384765625, 0.745900288638265, -77.5419387817383, -1.35336214012121, 218, 40, 'PPL', 'P'),
(159781, 'Canadohta Lake', 41.8136100769043, 0.729785167987059, -79.8349990844727, -1.39338359235071, 218, 45, 'PPL', 'P'),
(80129, 'Canady Landing', 32.8152809143066, 0.572734696921506, -80.4049987792969, -1.40333196376075, 218, 48, 'PPL', 'P'),
(80128, 'Canadys', 33.0555610656738, 0.576928376690054, -80.6205596923828, -1.40709421143271, 218, 48, 'PPL', 'P'),
(147564, 'Canajoharie', 42.9055595397949, 0.748843281379884, -74.5722198486328, -1.30153076687971, 218, 40, 'PPL', 'P'),
(159782, 'Canal Center', 41.4719390869141, 0.723821884253181, -79.9341735839844, -1.3951145139012, 218, 45, 'PPL', 'P'),
(154588, 'Canal Fulton', 40.889720916748, 0.713660260218848, -81.5977783203125, -1.4241498940019, 218, 41, 'PPL', 'P'),
(19748, 'Canal Lake', 34.8952789306641, 0.609037510741894, -83.9980621337891, -1.46604274952939, 218, 13, 'PPL', 'P'),
(154589, 'Canal Lewisville', 40.2991714477539, 0.703353227588996, -81.8363876342773, -1.42831441215651, 218, 41, 'PPL', 'P'),
(15416, 'Canal Point', 26.8588905334473, 0.468776073241391, -80.6338882446289, -1.40732683855393, 218, 12, 'PPL', 'P'),
(45352, 'Canal View Estates', 39.5361099243164, 0.690035291609727, -75.7975006103516, -1.32291595043305, 218, 25, 'PPL', 'P'),
(72004, 'Canal Winchester', 39.8427810668945, 0.695387712768569, -82.8047180175781, -1.44521496559221, 218, 41, 'PPL', 'P'),
(7873, 'Canale', 33.0666694641113, 0.577122254817412, -93.8138885498047, -1.6373612392931, 218, 4, 'PPL', 'P'),
(93024, 'Canales Colonia', 26.3819999694824, 0.460452762728512, -98.8349990844727, -1.72499615022963, 218, 51, 'PPL', 'P'),
(53837, 'Canalou', 36.7550010681152, 0.641495785212644, -89.6869430541992, -1.56533245234444, 218, 29, 'PPL', 'P'),
(154590, 'Canalport', 41.1172218322754, 0.717630900246101, -84.4277801513672, -1.47354274379127, 218, 41, 'PPL', 'P'),
(159784, 'Canan', 40.4619407653809, 0.70619408810281, -78.4300003051758, -1.36886173766547, 218, 45, 'PPL', 'P'),
(130071, 'Canandaigua', 41.7986106872559, 0.729523379251905, -84.2344436645508, -1.47016838553209, 218, 27, 'PPL', 'P'),
(147567, 'Canandaigua', 42.8741683959961, 0.748295402564628, -77.288330078125, -1.34893583323145, 218, 40, 'PPL', 'P'),
(147570, 'Canarsie', 40.6436080932617, 0.709364781117632, -73.9011077880859, -1.28981765177332, 218, 40, 'PPL', 'P'),
(93025, 'Canary', 30.9933300018311, 0.540935654689092, -96.1780624389648, -1.67862385774862, 218, 51, 'PPL', 'P'),
(200516, 'Canary', 43.9280586242676, 0.76668925700256, -124.034172058105, -2.16480468739909, 218, 43, 'PPL', 'P'),
(147571, 'Canaseraga', 42.4613914489746, 0.741091085762773, -77.7772216796875, -1.35746860136406, 218, 40, 'PPL', 'P'),
(147572, 'Canastota', 43.0794410705566, 0.751878086600084, -75.751106262207, -1.32210621630361, 218, 40, 'PPL', 'P'),
(15417, 'Canaveral (historical)', 28.4708309173584, 0.496909740286502, -80.5374984741211, -1.40564451969332, 218, 12, 'PPL', 'P'),
(15418, 'Canaveral Acres', 28.4166698455811, 0.495964451257578, -80.834716796875, -1.41083195802263, 218, 12, 'PPL', 'P'),
(45359, 'Canavest (historical)', 39.2727813720703, 0.685439341358523, -77.5397186279297, -1.35332339112735, 218, 25, 'PPL', 'P'),
(147573, 'Canawaugus', 42.9269409179688, 0.749216456827632, -77.7797164916992, -1.35751214404788, 218, 40, 'PPL', 'P'),
(39631, 'Canbeal', 32.8194389343262, 0.572807268061211, -92.3530578613281, -1.61186493396501, 218, 22, 'PPL', 'P'),
(45353, 'Canbury Woods', 39.2038917541504, 0.68423699070538, -76.7172164916992, -1.33896802074544, 218, 25, 'PPL', 'P'),
(35123, 'Canby', 38.517219543457, 0.672252299746832, -84.6611099243164, -1.47761511657217, 218, 21, 'PPL', 'P'),
(114818, 'Canby', 41.4172210693359, 0.722866874686279, -94.5663909912109, -1.65049488452494, 218, 16, 'PPL', 'P'),
(134539, 'Canby', 44.7088890075684, 0.780317318090768, -96.2761077880859, -1.68033507190705, 218, 28, 'PPL', 'P'),
(193425, 'Canby', 41.4438896179199, 0.723332328665797, -120.869171142578, -2.1095650005945, 218, 6, 'PPL', 'P'),
(200515, 'Canby', 45.2630615234375, 0.789989453116745, -122.691390991211, -2.14136873664834, 218, 43, 'PPL', 'P'),
(206950, 'Canby', 47.4988899230957, 0.829012020200376, -118.023063659668, -2.05989105415207, 218, 56, 'PPL', 'P'),
(130070, 'Canby Corners', 45.6361083984375, 0.796500349349771, -84.915283203125, -1.48205127715797, 218, 27, 'PPL', 'P'),
(193424, 'Canby Cross', 41.8188896179199, 0.729877313360776, -121.542503356934, -2.12131686469475, 218, 6, 'PPL', 'P'),
(85522, 'Canby Hills', 35.9500007629395, 0.627445879407767, -84.0611114501953, -1.46714316769181, 218, 50, 'PPL', 'P'),
(13473, 'Canby Park Estates', 39.7388916015625, 0.693574499540388, -75.5819396972656, -1.31915370276109, 218, 10, 'PPL', 'P'),
(39632, 'Cancienne', 29.8999996185303, 0.521853439688402, -91.0255584716797, -1.58869569879743, 218, 22, 'PPL', 'P'),
(191218, 'Candelaria', 30.1383304595947, 0.526013097574024, -104.684997558594, -1.82709788483969, 218, 51, 'PPL', 'P'),
(190001, 'Candelaria (historical)', 38.1588897705078, 0.665998265400945, -118.088333129883, -2.06103022130836, 218, 39, 'PPL', 'P'),
(190002, 'Candelaria Junction', 38.1758308410645, 0.666293942860971, -118.181671142578, -2.06265927694716, 218, 39, 'PPL', 'P'),
(188217, 'Candelaria Place', 34.6722183227539, 0.605144368702362, -106.351936340332, -1.8561914550102, 218, 38, 'PPL', 'P'),
(143584, 'Candia', 43.0777816772461, 0.75184912472323, -71.2772216796875, -1.24402219998443, 218, 36, 'PPL', 'P'),
(143585, 'Candia Four Corners', 43.0613899230957, 0.751563034643128, -71.2888870239258, -1.24422579864977, 218, 36, 'PPL', 'P'),
(45354, 'Candice Estates', 39.3933296203613, 0.687543305198713, -77.1455612182617, -1.34644404655751, 218, 25, 'PPL', 'P'),
(211718, 'Candle', 65.913330078125, 1.15040463081709, -161.924438476563, -2.82611459085901, 218, 1, 'PPL', 'P'),
(29383, 'Candleglo Village', 39.5574989318848, 0.690408600215529, -85.7919387817383, -1.49735180341075, 218, 19, 'PPL', 'P'),
(114819, 'Candlelight Trailer Court', 42.9944381713867, 0.750394506135828, -96.0555572509766, -1.67648573886745, 218, 16, 'PPL', 'P'),
(203247, 'Candlelite Corner', 40.6100006103516, 0.708778219887542, -111.872222900391, -1.95253863113682, 218, 52, 'PPL', 'P'),
(15419, 'Candler', 29.0711097717285, 0.50738658272536, -81.9683303833008, -1.4306172475511, 218, 12, 'PPL', 'P'),
(19749, 'Candler', 34.2102813720703, 0.59708204797631, -83.7813873291016, -1.46226106078148, 218, 13, 'PPL', 'P'),
(63404, 'Candler', 35.5363883972168, 0.620226981798944, -82.6930618286133, -1.44326619746454, 218, 33, 'PPL', 'P'),
(100464, 'Candler', 36.8994407653809, 0.644016733500512, -82.2050018310547, -1.43474794355987, 218, 53, 'PPL', 'P'),
(63408, 'Candler Heights', 35.5400009155273, 0.620290032137751, -82.7063903808594, -1.44349882458576, 218, 33, 'PPL', 'P'),
(45355, 'Candlewick', 39.3977813720703, 0.687621002923516, -76.9958267211914, -1.34383068657982, 218, 25, 'PPL', 'P'),
(63405, 'Candlewick Estates', 35.601390838623, 0.621361488423317, -77.4655609130859, -1.35202909483757, 218, 33, 'PPL', 'P'),
(112252, 'Candlewicke', 39.1208305358887, 0.682787298965995, -75.5202789306641, -1.31807751936459, 218, 10, 'PPL', 'P'),
(45356, 'Candlewood', 39.089168548584, 0.682234693039804, -76.5858306884766, -1.33667490588883, 218, 25, 'PPL', 'P'),
(144940, 'Candlewood', 40.1500015258789, 0.700749721307334, -74.2138900756836, -1.29527673253382, 218, 37, 'PPL', 'P'),
(19752, 'Candlewood Crossing', 33.5252799987793, 0.585126518631699, -82.0999984741211, -1.43291528925573, 218, 13, 'PPL', 'P'),
(7875, 'Candlewood Estates', 34.9327812194824, 0.609692049158808, -92.0180587768555, -1.60601809694979, 218, 4, 'PPL', 'P'),
(177563, 'Candlewood Knolls', 41.4794387817383, 0.723952778620759, -73.4638900756836, -1.28218676314387, 218, 8, 'PPL', 'P'),
(177564, 'Candlewood Lake Club', 41.4944381713867, 0.724214567355913, -73.4408264160156, -1.2817842263451, 218, 8, 'PPL', 'P'),
(1332, 'Candlewood Lakes', 33.6841697692871, 0.587899668274799, -86.5888900756836, -1.51126122746812, 218, 2, 'PPL', 'P'),
(177566, 'Candlewood Orchards', 41.4686088562012, 0.72376376076239, -73.4366683959961, -1.28171165520539, 218, 8, 'PPL', 'P'),
(177567, 'Candlewood Pines', 41.4566688537598, 0.723555368407092, -73.4533309936523, -1.28200247239643, 218, 8, 'PPL', 'P'),
(177569, 'Candlewood Point', 41.5363883972168, 0.724946736918603, -73.4411087036133, -1.28178915319312, 218, 8, 'PPL', 'P'),
(177568, 'Candlewood Shores', 41.4819412231445, 0.723996454462636, -73.442497253418, -1.28181338795904, 218, 8, 'PPL', 'P'),
(177565, 'Candlewood Springs', 41.5597190856934, 0.725353934249277, -73.4400024414063, -1.28176984527521, 218, 8, 'PPL', 'P'),
(70606, 'Candlewyck', 39.8919410705566, 0.696245716692765, -74.9458312988281, -1.30805151680877, 218, 37, 'PPL', 'P'),
(100465, 'Candlewyck', 38.0744400024414, 0.66452433889564, -78.5722198486328, -1.37134393695948, 218, 53, 'PPL', 'P'),
(108470, 'Candlewyck Place', 38.4550018310547, 0.671166395812352, -81.9499969482422, -1.43029726874613, 218, 58, 'PPL', 'P'),
(139758, 'Cando', 48.4866714477539, 0.846252060096031, -99.2094421386719, -1.73153141438663, 218, 34, 'PPL', 'P'),
(63407, 'Candor', 35.2949981689453, 0.616013927533466, -79.7455596923828, -1.39182258047776, 218, 33, 'PPL', 'P'),
(147574, 'Candor', 42.232780456543, 0.737101071238589, -76.3427810668945, -1.3324328897465, 218, 40, 'PPL', 'P'),
(159785, 'Candor', 40.3919410705566, 0.704972362952737, -80.3091735839844, -1.40165949859618, 218, 45, 'PPL', 'P'),
(72005, 'Candy Town', 39.4791717529297, 0.689041533048964, -82.2305603027344, -1.43519402304246, 218, 41, 'PPL', 'P'),
(85524, 'Candyland Estates', 36.1952781677246, 0.631726777702015, -85.4694366455078, -1.49172307928881, 218, 50, 'PPL', 'P'),
(39633, 'Cane', 31.6438903808594, 0.552290075286158, -92.0194396972656, -1.60604219855766, 218, 22, 'PPL', 'P'),
(63410, 'Cane', 35.9049987792969, 0.626660446623275, -82.3863906860352, -1.4379137763057, 218, 33, 'PPL', 'P'),
(177839, 'Cane', 36.5677795410156, 0.638228153134143, -112.003059387207, -1.95482215861351, 218, 5, 'PPL', 'P'),
(177838, 'Cane Beds', 36.9463882446289, 0.644836121588903, -112.893608093262, -1.97036516568353, 218, 5, 'PPL', 'P'),
(63409, 'Cane Brake', 35.0658302307129, 0.612014192471303, -82.8902816772461, -1.44670833317347, 218, 33, 'PPL', 'P'),
(80130, 'Cane Brake', 34.8877792358398, 0.608906616374317, -82.2605590820313, -1.43571760051277, 218, 48, 'PPL', 'P'),
(1334, 'Cane Creek', 33.8138885498047, 0.590163688096502, -86.8499984741211, -1.51581842872546, 218, 2, 'PPL', 'P'),
(7876, 'Cane Creek', 34.4430618286133, 0.601144833377281, -92.3536071777344, -1.61187452134493, 218, 4, 'PPL', 'P'),
(19753, 'Cane Creek', 34.5719413757324, 0.603394205812989, -84.0119400024414, -1.46628496403054, 218, 13, 'PPL', 'P'),
(35124, 'Cane Creek', 37.0558280944824, 0.646746207301735, -83.9227828979492, -1.4647288790056, 218, 21, 'PPL', 'P'),
(85525, 'Cane Creek', 35.7658309936523, 0.624231510551069, -85.3969421386719, -1.49045781145491, 218, 50, 'PPL', 'P'),
(1336, 'Cane Creek (historical)', 33.7166709899902, 0.588466921586986, -86.0063934326172, -1.5010947431648, 218, 2, 'PPL', 'P'),
(85526, 'Cane Creek (historical)', 36.1683311462402, 0.631256463453507, -84.1319427490234, -1.46837940706983, 218, 50, 'PPL', 'P'),
(53839, 'Cane Hill', 37.5788917541504, 0.655875390360472, -93.7313919067383, -1.63592140124975, 218, 29, 'PPL', 'P'),
(7880, 'Cane Island (historical)', 35.8458290100098, 0.62562773933157, -90.4283294677734, -1.57827208629086, 218, 4, 'PPL', 'P'),
(93026, 'Cane Junction', 29.1744403839111, 0.509190042126048, -95.9986114501953, -1.67549184714864, 218, 51, 'PPL', 'P'),
(39634, 'Cane Ridge (historical)', 32.8133316040039, 0.57270067503858, -92.6952819824219, -1.61783787165784, 218, 22, 'PPL', 'P'),
(63412, 'Cane River', 35.9144401550293, 0.626825229715724, -82.3913879394531, -1.4380009948314, 218, 33, 'PPL', 'P'),
(80132, 'Cane Savannah', 33.901668548584, 0.591695738092598, -80.4505615234375, -1.40412718366225, 218, 48, 'PPL', 'P'),
(35125, 'Cane Valley', 37.1802787780762, 0.648918281486803, -85.3197174072266, -1.48910998562722, 218, 21, 'PPL', 'P'),
(147576, 'Caneadea', 42.3863906860352, 0.739782075507972, -78.1538925170898, -1.36404274767298, 218, 40, 'PPL', 'P'),
(39637, 'Canebrake', 31.7013893127441, 0.553293620963928, -91.4116668701172, -1.59543456161976, 218, 22, 'PPL', 'P'),
(85527, 'Canebrake', 35.9347190856934, 0.627179163824595, -86.2988891601563, -1.50619975665837, 218, 50, 'PPL', 'P'),
(108471, 'Canebrake', 37.247501373291, 0.650091537105038, -81.64111328125, -1.42490623175148, 218, 58, 'PPL', 'P'),
(180494, 'Canebrake', 35.728328704834, 0.623576972134154, -118.137496948242, -2.06188829181158, 218, 6, 'PPL', 'P'),
(180495, 'Canebrake (historical)', 35.7316703796387, 0.623635295362027, -118.077781677246, -2.06084606371898, 218, 6, 'PPL', 'P'),
(124443, 'Canedys Corner', 41.8013916015625, 0.729571915362771, -70.9763870239258, -1.23877164473728, 218, 23, 'PPL', 'P'),
(53840, 'Caneer', 36.0061111450195, 0.628425190319616, -90.1772232055664, -1.57388945524297, 218, 29, 'PPL', 'P'),
(7882, 'Canehill', 35.9086112976074, 0.626723496962083, -94.3963928222656, -1.64752785675448, 218, 4, 'PPL', 'P'),
(53841, 'Canehill (historical)', 37.5838890075684, 0.655962608886172, -93.6730575561523, -1.63490327476501, 218, 29, 'PPL', 'P'),
(39635, 'Caneland', 29.829719543457, 0.520626820979825, -91.6163864135742, -1.59900759169627, 218, 22, 'PPL', 'P'),
(177840, 'Canelo', 31.5427799224854, 0.550525364879331, -110.513893127441, -1.92883130427099, 218, 5, 'PPL', 'P'),
(200517, 'Canemah', 45.3458290100098, 0.791434018271031, -122.620002746582, -2.14012277673235, 218, 43, 'PPL', 'P'),
(100466, 'Canepatch (historical)', 36.9444389343262, 0.644802099705977, -82.7186126708984, -1.44371214378908, 218, 53, 'PPL', 'P'),
(85528, 'Caneridge (historical)', 35.7488899230957, 0.623935833091043, -85.5605621337891, -1.4933135190918, 218, 50, 'PPL', 'P'),
(7886, 'Caney', 35.0611114501953, 0.611931834214592, -92.3844375610352, -1.61241261304318, 218, 4, 'PPL', 'P'),
(31957, 'Caney', 37.0113906860352, 0.645970628213276, -95.9349975585938, -1.67438157529018, 218, 20, 'PPL', 'P'),
(35126, 'Caney', 37.8013916015625, 0.659758745282998, -83.2591705322266, -1.45314665826679, 218, 21, 'PPL', 'P'),
(39636, 'Caney', 31.1200008392334, 0.543146477868021, -93.3874969482422, -1.62991930194298, 218, 22, 'PPL', 'P'),
(75320, 'Caney', 34.2322196960449, 0.597464943962036, -96.2138900756836, -1.67924916797258, 218, 42, 'PPL', 'P'),
(93028, 'Caney', 33.6708297729492, 0.587666841416499, -94.8816680908203, -1.65599750796926, 218, 51, 'PPL', 'P'),
(7885, 'Caney (historical)', 33.5897216796875, 0.586251238139067, -93.1444396972656, -1.6256771526426, 218, 4, 'PPL', 'P'),
(85529, 'Caney Branch', 36.0466690063477, 0.629133058537359, -82.9833297729492, -1.4483323288062, 218, 50, 'PPL', 'P'),
(93029, 'Caney City', 32.2252807617188, 0.562437251671578, -96.0327835083008, -1.67608826207476, 218, 51, 'PPL', 'P'),
(15421, 'Caney Creek', 30.8997192382813, 0.539301838649842, -86.208610534668, -1.50462409739943, 218, 12, 'PPL', 'P'),
(53842, 'Caney Creek', 37.1294403076172, 0.648030982790616, -89.6875, -1.56534217288241, 218, 29, 'PPL', 'P'),
(85530, 'Caney Creek', 35.0950012207031, 0.612523322292699, -84.5480575561523, -1.47564198052053, 218, 50, 'PPL', 'P'),
(85531, 'Caney Fork', 36.1375007629395, 0.630718371755256, -85.8013916015625, -1.49751678624028, 218, 50, 'PPL', 'P'),
(85532, 'Caney Forks', 35.9819412231445, 0.628003345602948, -85.1730575561523, -1.48655028834549, 218, 50, 'PPL', 'P'),
(85533, 'Caney Hollow', 35.0044403076172, 0.610942736185737, -88.2172164916992, -1.53968088472479, 218, 50, 'PPL', 'P'),
(75321, 'Caney Ridge', 35.7641716003418, 0.624202548674214, -94.8805618286133, -1.65597820005135, 218, 42, 'PPL', 'P'),
(85534, 'Caney Spring', 35.6072196960449, 0.621463221176958, -86.7630615234375, -1.51430109269439, 218, 50, 'PPL', 'P'),
(7888, 'Caney Valley', 34.2622184753418, 0.597988521432346, -93.5397186279297, -1.63257607144645, 218, 4, 'PPL', 'P'),
(85535, 'Caney Valley', 36.420280456543, 0.635653808466418, -83.4494400024414, -1.45646748698807, 218, 50, 'PPL', 'P'),
(35127, 'Caneyville', 37.4241714477539, 0.653175011594159, -86.4883270263672, -1.5095060711517, 218, 21, 'PPL', 'P'),
(7893, 'Canfield', 33.1827812194824, 0.579148787248907, -93.6324996948242, -1.63419540654727, 218, 4, 'PPL', 'P'),
(108473, 'Canfield', 38.5941696166992, 0.673595331884559, -80.7541732788086, -1.40942620844123, 218, 58, 'PPL', 'P'),
(114821, 'Canfield', 42.5119400024414, 0.741973324452889, -92.14111328125, -1.60816580321089, 218, 16, 'PPL', 'P'),
(154593, 'Canfield', 41.0250015258789, 0.716021352262285, -80.7611083984375, -1.40954724911278, 218, 41, 'PPL', 'P'),
(194134, 'Canfield', 40.0536117553711, 0.699067402446731, -105.074172973633, -1.83389027719993, 218, 7, 'PPL', 'P'),
(194681, 'Canfield', 45.8377799987793, 0.800020182783501, -116.370826721191, -2.03105407955259, 218, 17, 'PPL', 'P'),
(130072, 'Canfield Beach', 45.4605598449707, 0.793436449094662, -84.2216720581055, -1.46994547894885, 218, 27, 'PPL', 'P'),
(134543, 'Canisteo', 47.2877807617188, 0.825327470253224, -93.4538879394531, -1.63107804333328, 218, 28, 'PPL', 'P'),
(147578, 'Canisteo', 42.2702789306641, 0.737755543076476, -77.6061096191406, -1.35448213251765, 218, 40, 'PPL', 'P'),
(147579, 'Canisteo Center', 42.2655601501465, 0.737673184819765, -77.5791702270508, -1.35401195142719, 218, 40, 'PPL', 'P'),
(169955, 'Canistota', 43.5977783203125, 0.760924778244056, -97.290283203125, -1.69803577209227, 218, 49, 'PPL', 'P'),
(188218, 'Canjilon', 36.4794387817383, 0.636686316021042, -106.437217712402, -1.85767989574345, 218, 38, 'PPL', 'P'),
(39638, 'Cankton', 30.3458309173584, 0.529634663761395, -92.1094436645508, -1.60761306412664, 218, 22, 'PPL', 'P'),
(35128, 'Canmer', 37.2902793884277, 0.650838154316641, -85.767219543457, -1.49692037131415, 218, 21, 'PPL', 'P'),
(100467, 'Cannady', 37.1650009155273, 0.648651632482659, -82.2041702270508, -1.43473342933193, 218, 53, 'PPL', 'P'),
(35129, 'Cannel City', 37.7900009155273, 0.659559940307624, -83.274169921875, -1.45340844700195, 218, 21, 'PPL', 'P'),
(29384, 'Cannelburg', 38.6697196960449, 0.674913929519285, -86.9983291625977, -1.51840728762113, 218, 19, 'PPL', 'P'),
(29390, 'Cannelton', 37.9113883972168, 0.661678551533809, -86.7444381713867, -1.51397605388335, 218, 19, 'PPL', 'P'),
(108474, 'Cannelton', 38.1941719055176, 0.666614054823998, -81.2961120605469, -1.41888482452681, 218, 58, 'PPL', 'P'),
(159786, 'Cannelton', 40.7988891601563, 0.712074947000951, -80.475830078125, -1.40456820313877, 218, 45, 'PPL', 'P'),
(72006, 'Cannelville', 39.8138885498047, 0.694883443216162, -81.9972229003906, -1.43112151710351, 218, 41, 'PPL', 'P'),
(209940, 'Cannery', 57.7852783203125, 1.00854336587075, -135.096389770508, -2.35787680905295, 218, 1, 'PPL', 'P'),
(180496, 'Cannery Row', 36.6133308410645, 0.639023173298559, -121.896667480469, -2.12749819474288, 218, 6, 'PPL', 'P'),
(201966, 'Canning', 44.3963890075684, 0.774863164178286, -100.031669616699, -1.74588199107858, 218, 49, 'PPL', 'P'),
(13474, 'Cannon', 38.6994400024414, 0.675432646720605, -75.6152801513672, -1.31973560345927, 218, 10, 'PPL', 'P'),
(35130, 'Cannon', 36.9144401550293, 0.644278522235667, -83.8583297729492, -1.46360395976115, 218, 21, 'PPL', 'P'),
(39639, 'Cannon', 32.4566688537598, 0.566475735727602, -93.8563919067383, -1.63810306281474, 218, 22, 'PPL', 'P'),
(72007, 'Cannon', 39.827220916748, 0.695116136916408, -82.1383285522461, -1.43358427532156, 218, 41, 'PPL', 'P'),
(93030, 'Cannon', 33.4386100769043, 0.583613843132534, -96.4836120605469, -1.68395670467345, 218, 51, 'PPL', 'P'),
(100468, 'Cannon', 38.7941703796387, 0.677086003704353, -77.0977783203125, -1.34561007766216, 218, 53, 'PPL', 'P'),
(180498, 'Cannon', 38.3044395446777, 0.668538588185744, -121.946113586426, -2.12836119209412, 218, 6, 'PPL', 'P'),
(7894, 'Cannon (historical)', 36.2599983215332, 0.632856357478372, -94.2466735839844, -1.64491476309289, 218, 4, 'PPL', 'P'),
(45357, 'Cannon Acres', 38.5563888549805, 0.672935933198656, -76.0124969482422, -1.32666834440897, 218, 25, 'PPL', 'P'),
(198083, 'Cannon Ball', 46.3894386291504, 0.809648442230519, -100.593612670898, -1.75568974758306, 218, 34, 'PPL', 'P'),
(200518, 'Cannon Beach', 45.8919410705566, 0.800965471812425, -123.96028137207, -2.16351505164122, 218, 43, 'PPL', 'P'),
(134545, 'Cannon City', 44.3291702270508, 0.773689975139078, -93.2111129760742, -1.62684082088091, 218, 28, 'PPL', 'P'),
(7895, 'Cannon Creek', 35.9047203063965, 0.626655586354286, -93.9400024414063, -1.63956234193405, 218, 4, 'PPL', 'P'),
(19757, 'Cannon Crossing', 34.9536094665527, 0.610055570647604, -85.2783279418945, -1.48838760318154, 218, 13, 'PPL', 'P'),
(63419, 'Cannon Crossroads', 35.5516700744629, 0.620493697382115, -77.3838882446289, -1.35060363786411, 218, 33, 'PPL', 'P'),
(134547, 'Cannon Falls', 44.5069389343262, 0.776792624388048, -92.9052810668945, -1.62150304710806, 218, 28, 'PPL', 'P'),
(45358, 'Cannon Farm', 38.3980598449707, 0.670172570672562, -75.5555572509766, -1.31869324220862, 218, 25, 'PPL', 'P'),
(63417, 'Cannon Ferry', 36.2702789306641, 0.633035787956816, -76.6725006103516, -1.338187581388, 218, 33, 'PPL', 'P'),
(80133, 'Cannon Hills', 34.9869384765625, 0.610637271608705, -82.2533264160156, -1.4355913666771, 218, 48, 'PPL', 'P'),
(53843, 'Cannon Mines', 38.0533294677734, 0.664155890558828, -90.6980590820313, -1.58297975614979, 218, 29, 'PPL', 'P'),
(159788, 'Cannon Run', 40.0933303833008, 0.699760623278479, -75.3833312988281, -1.31568733228624, 218, 45, 'PPL', 'P'),
(159787, 'Cannon Run West', 40.1083297729492, 0.700022412013634, -75.3966674804688, -1.31592009256552, 218, 45, 'PPL', 'P'),
(85537, 'Cannon Subdivision', 35.773609161377, 0.624367265187635, -84.6361083984375, -1.47717875762756, 218, 50, 'PPL', 'P'),
(15422, 'Cannon Town', 30.8547191619873, 0.538516439154864, -86.6741714477539, -1.51274966820137, 218, 12, 'PPL', 'P'),
(39640, 'Cannonburg', 30.1963901519775, 0.527026430368799, -91.1033325195313, -1.59005311200504, 218, 22, 'PPL', 'P'),
(177570, 'Cannondale', 41.2163887023926, 0.719361688638544, -73.4258270263672, -1.28152243760994, 218, 8, 'PPL', 'P'),
(19756, 'Cannongate Acres', 33.4486083984375, 0.583788346762962, -84.6500015258789, -1.47742123844481, 218, 13, 'PPL', 'P'),
(7896, 'Cannongate Addition', 34.9719390869141, 0.61037548287355, -92.1125030517578, -1.6076664605065, 218, 4, 'PPL', 'P'),
(80134, 'Cannons Camp Ground', 35.0094413757324, 0.611030021290464, -81.8611068725586, -1.42874584425311, 218, 48, 'PPL', 'P'),
(72010, 'Cannons Creek', 38.6488914489746, 0.674550408030489, -82.6255569458008, -1.44208801499829, 218, 41, 'PPL', 'P'),
(35131, 'Cannons Mill', 36.6888885498047, 0.640341904091339, -85.0899963378906, -1.48510059660611, 218, 21, 'PPL', 'P'),
(154595, 'Cannons Mill', 40.6822204589844, 0.710038694031476, -80.6111068725586, -1.40692922860318, 218, 41, 'PPL', 'P'),
(35132, 'Cannons Point', 37.5838890075684, 0.655962608886172, -86.4613876342773, -1.50903589006125, 218, 21, 'PPL', 'P'),
(35133, 'Cannonsburg', 38.3886108398438, 0.670007654422059, -82.7027816772461, -1.44343584082598, 218, 21, 'PPL', 'P'),
(58883, 'Cannonsburg', 31.6336097717285, 0.552110644807714, -91.2111129760742, -1.59193423584102, 218, 30, 'PPL', 'P'),
(130073, 'Cannonsburg', 43.0538902282715, 0.75143214027555, -85.4697189331055, -1.49172800613683, 218, 27, 'PPL', 'P'),
(154596, 'Cannonsburg', 40.9147186279297, 0.71409655258443, -83.7850036621094, -1.46232417769932, 218, 41, 'PPL', 'P'),
(19758, 'Cannonville', 32.9663887023926, 0.575372025349012, -85.1052780151367, -1.48536731218928, 218, 13, 'PPL', 'P'),
(124444, 'Cannonville', 41.6597213745117, 0.727099303448687, -70.7986068725586, -1.23566879575123, 218, 23, 'PPL', 'P'),
(192505, 'Cannonville', 37.5669403076172, 0.655666798268091, -112.053062438965, -1.95569487650272, 218, 52, 'PPL', 'P'),
(143587, 'Canobie Lake', 42.8055610656738, 0.747097978759501, -71.2455596923828, -1.24346959405824, 218, 36, 'PPL', 'P'),
(1338, 'Canoe', 31.0261096954346, 0.541507768270268, -87.4119415283203, -1.52562618522995, 218, 2, 'PPL', 'P'),
(19759, 'Canoe', 32.4194412231445, 0.56582599100065, -82.1413879394531, -1.43363767170142, 218, 13, 'PPL', 'P'),
(35134, 'Canoe', 37.4488906860352, 0.653606443690751, -83.4486083984375, -1.45645297276013, 218, 21, 'PPL', 'P'),
(114820, 'Canoe', 43.350830078125, 0.756614718335872, -91.6538925170898, -1.59966219669221, 218, 16, 'PPL', 'P'),
(159789, 'Canoe Creek', 40.478328704834, 0.706480111603885, -78.2716674804688, -1.36609830856035, 218, 45, 'PPL', 'P'),
(159790, 'Canoe Furnace', 41.1888885498047, 0.718881720431084, -79.5180587768555, -1.3878519404505, 218, 45, 'PPL', 'P'),
(147581, 'Canoe Hill', 42.0930595397949, 0.734662481207431, -73.9402770996094, -1.29050128522515, 218, 40, 'PPL', 'P'),
(7897, 'Canoe Landing', 33.9438896179199, 0.592432634766223, -92.2649993896484, -1.61032802369992, 218, 4, 'PPL', 'P'),
(147582, 'Canoe Place', 40.8888893127441, 0.713645745990907, -72.5044403076172, -1.26544120568361, 218, 40, 'PPL', 'P'),
(159791, 'Canoe Ridge', 40.8636093139648, 0.713204526777308, -78.9361114501953, -1.3776950435271, 218, 45, 'PPL', 'P'),
(147583, 'Canoga', 42.853328704834, 0.74793168133875, -76.748893737793, -1.33952089298774, 218, 40, 'PPL', 'P'),
(180499, 'Canoga Park', 34.2011108398438, 0.596921991994796, -118.597221374512, -2.06991199670182, 218, 6, 'PPL', 'P'),
(147584, 'Canoga Springs', 42.8511085510254, 0.74789293234489, -76.7669372558594, -1.33983581178665, 218, 40, 'PPL', 'P'),
(19760, 'Canon', 34.3461112976074, 0.599452727399671, -83.1100006103516, -1.45054315198513, 218, 13, 'PPL', 'P'),
(186483, 'Canon', 37.0433311462402, 0.646528094408457, -106.145278930664, -1.85258460278785, 218, 7, 'PPL', 'P'),
(188221, 'Canon', 36.3908309936523, 0.635139818376033, -105.562782287598, -1.84241811848453, 218, 38, 'PPL', 'P'),
(186482, 'Canon City', 38.4000015258789, 0.670206459397433, -105.216667175293, -1.8363772701839, 218, 7, 'PPL', 'P'),
(190004, 'Canon City', 39.4566688537598, 0.688648783367205, -117.128326416016, -2.04427494331012, 218, 39, 'PPL', 'P'),
(199863, 'Canon Creek Station (historical)', 41.788890838623, 0.729353735890466, -117.663612365723, -2.05361744557217, 218, 39, 'PPL', 'P'),
(80135, 'Canon Hill', 33.7861099243164, 0.589678859620054, -79.1930618286133, -1.38217967364474, 218, 48, 'PPL', 'P'),
(169302, 'Canonchet', 41.4900016784668, 0.724137135947219, -71.7333297729492, -1.25198278795684, 218, 47, 'PPL', 'P'),
(188229, 'Canoncito', 36.5444412231445, 0.637820822645416, -105.633331298828, -1.84364943101453, 218, 38, 'PPL', 'P'),
(188230, 'Canones', 36.188060760498, 0.631600810182454, -106.438888549805, -1.85770905735738, 218, 38, 'PPL', 'P'),
(159793, 'Canonsburg', 40.2625007629395, 0.702713203400022, -80.1875, -1.39953589394295, 218, 45, 'PPL', 'P'),
(19761, 'Canoochee', 32.6719398498535, 0.570232923393486, -82.1791687011719, -1.43429707038732, 218, 13, 'PPL', 'P'),
(100469, 'Canova', 38.6769409179688, 0.675039963617873, -77.4422225952148, -1.35162176434885, 218, 53, 'PPL', 'P'),
(169958, 'Canova', 43.8811111450195, 0.76586986891417, -97.5041732788086, -1.70176885815029, 218, 49, 'PPL', 'P'),
(188231, 'Canova', 36.1591682434082, 0.631096540630048, -105.984443664551, -1.84977749784086, 218, 38, 'PPL', 'P'),
(15423, 'Canova Beach', 28.1388893127441, 0.49111626636163, -80.5805587768555, -1.40639606375294, 218, 12, 'PPL', 'P'),
(63420, 'Cansellers', 35.4697189331055, 0.619063380139661, -81.1180572509766, -1.4157771818508, 218, 33, 'PPL', 'P'),
(100470, 'Cant (historical)', 37.5291709899902, 0.655007599319269, -77.1691665649414, -1.34685603757815, 218, 53, 'PPL', 'P'),
(476, 'Cantaloupe', 38.5313911437988, 0.672499640833073, -87.5194396972656, -1.52750238221791, 218, 19, 'PPL', 'P'),
(188232, 'Cantara', 34.4244384765625, 0.600819794566236, -103.742500305176, -1.81064820457654, 218, 38, 'PPL', 'P'),
(193426, 'Cantara (historical)', 41.2652816772461, 0.720215032030832, -122.290283203125, -2.13436808509085, 218, 6, 'PPL', 'P'),
(13475, 'Cantebury Apartments', 38.7427787780762, 0.676189051049215, -75.5927810668945, -1.31934292035654, 218, 10, 'PPL', 'P'),
(13476, 'Cantebury, Village of', 39.6452789306641, 0.691940650211625, -75.6297225952148, -1.31998767165645, 218, 10, 'PPL', 'P'),
(1339, 'Cantelous', 32.3233299255371, 0.564148532409036, -86.4558334350586, -1.50893895099757, 218, 2, 'PPL', 'P'),
(203252, 'Canterbay Estates', 40.6541709899902, 0.709549138444092, -111.836936950684, -1.95192277513474, 218, 52, 'PPL', 'P'),
(100471, 'Canterburg', 39.0466690063477, 0.681492936097189, -78.184440612793, -1.36457591252321, 218, 53, 'PPL', 'P'),
(13477, 'Canterbury', 39.0424995422363, 0.681420165220403, -75.5558319091797, -1.31869803589858, 218, 10, 'PPL', 'P'),
(45401, 'Canterbury', 39.3522186279297, 0.686825783022018, -76.4730606079102, -1.33470669668521, 218, 25, 'PPL', 'P'),
(63421, 'Canterbury', 35.5466690063477, 0.620406412277388, -77.3833312988281, -1.35059391732613, 218, 33, 'PPL', 'P'),
(77968, 'Canterbury', 39.9838905334473, 0.697850537565647, -76.7099990844727, -1.33884205322588, 218, 45, 'PPL', 'P'),
(80137, 'Canterbury', 34.2230606079102, 0.597305087717604, -82.1761093139648, -1.43424367400747, 218, 48, 'PPL', 'P'),
(100473, 'Canterbury', 37.6016693115234, 0.656272933732193, -77.602783203125, -1.35442407560588, 218, 53, 'PPL', 'P'),
(108475, 'Canterbury', 37.8213882446289, 0.660107752543853, -82.2569427490234, -1.43565448359493, 218, 58, 'PPL', 'P'),
(143588, 'Canterbury', 43.3369407653809, 0.756372304097647, -71.5658264160156, -1.24905930287021, 218, 36, 'PPL', 'P'),
(177571, 'Canterbury', 41.6983299255371, 0.727773149783504, -71.9713897705078, -1.25613771873153, 218, 8, 'PPL', 'P'),
(45363, 'Canterbury Estates', 39.3952789306641, 0.687577327081639, -76.7158279418945, -1.33894378597952, 218, 25, 'PPL', 'P'),
(80139, 'Canterbury Heights', 35.0144386291504, 0.611117239816164, -81.9611129760742, -1.43049128003154, 218, 48, 'PPL', 'P'),
(147585, 'Canterbury Hill', 43.2566719055176, 0.754971348206211, -75.4158325195313, -1.31625458559843, 218, 40, 'PPL', 'P'),
(13478, 'Canterbury Hills', 39.7625007629395, 0.693986557140051, -75.654167175293, -1.32041431006308, 218, 10, 'PPL', 'P'),
(100477, 'Canterbury Hills', 37.2619400024414, 0.650343538723187, -76.7433319091797, -1.33942382076601, 218, 53, 'PPL', 'P'),
(100478, 'Canterbury Park', 37.2194404602051, 0.649601781780572, -80.0238876342773, -1.39668031946412, 218, 53, 'PPL', 'P'),
(45364, 'Canterbury Riding', 39.1236114501953, 0.682835835076862, -76.845832824707, -1.34121279922827, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(143589, 'Canterbury Station', 43.3286094665527, 0.756226895502129, -71.6091690063477, -1.24981577377784, 218, 36, 'PPL', 'P'),
(19762, 'Canterbury Woods', 33.5722198486328, 0.585945773562035, -84.2874984741211, -1.47109436664311, 218, 13, 'PPL', 'P'),
(100479, 'Canterbury Woods', 38.8166694641113, 0.677478686807086, -77.2386093139648, -1.34806804219025, 218, 53, 'PPL', 'P'),
(206952, 'Canterwood', 47.3752784729004, 0.826854593401303, -122.58805847168, -2.13956524395814, 218, 56, 'PPL', 'P'),
(80140, 'Cantey', 34.3444404602051, 0.599423565785735, -80.6786117553711, -1.40810741106943, 218, 48, 'PPL', 'P'),
(180501, 'Cantil', 35.3088912963867, 0.616256408350717, -117.967498779297, -2.05892126404112, 218, 6, 'PPL', 'P'),
(63422, 'Canto', 35.7013893127441, 0.623106791043701, -82.7591705322266, -1.44442001200682, 218, 33, 'PPL', 'P'),
(19763, 'Canton', 34.2366714477539, 0.597542641686839, -84.4908294677734, -1.47464316195369, 218, 13, 'PPL', 'P'),
(29385, 'Canton', 38.6238899230957, 0.674114049085879, -86.0347213745117, -1.50158915902117, 218, 19, 'PPL', 'P'),
(31961, 'Canton', 38.3861083984375, 0.669963978580182, -97.4277801513672, -1.70043554655054, 218, 20, 'PPL', 'P'),
(35135, 'Canton', 36.7988891601563, 0.642261776921177, -87.9608306884766, -1.53520610830319, 218, 21, 'PPL', 'P'),
(39641, 'Canton', 30.6761093139648, 0.535399109230385, -92.7347183227539, -1.61852616564157, 218, 22, 'PPL', 'P'),
(45366, 'Canton', 38.3711090087891, 0.669702189845027, -75.5880584716797, -1.3192604955208, 218, 25, 'PPL', 'P'),
(58884, 'Canton', 32.6124992370605, 0.569195488990845, -90.0366668701172, -1.57143628440484, 218, 30, 'PPL', 'P'),
(63423, 'Canton', 35.5327796936035, 0.620163998039163, -82.8375015258789, -1.44578714575241, 218, 33, 'PPL', 'P'),
(70607, 'Canton', 39.4708290100098, 0.688895924716364, -75.415283203125, -1.31624499821851, 218, 37, 'PPL', 'P'),
(75324, 'Canton', 36.0536117553711, 0.629254232366958, -98.5880584716797, -1.7206862234795, 218, 42, 'PPL', 'P'),
(93031, 'Canton', 32.5563888549805, 0.568216178078996, -95.8630599975586, -1.67312602799426, 218, 51, 'PPL', 'P'),
(100480, 'Canton', 36.6575012207031, 0.63979409185511, -82.9208297729492, -1.44724149802371, 218, 53, 'PPL', 'P'),
(108477, 'Canton', 39.4761085510254, 0.688988070090081, -80.0819396972656, -1.39769351910084, 218, 58, 'PPL', 'P'),
(113026, 'Canton', 40.5580596923828, 0.707871679852479, -90.0350036621094, -1.57140725594896, 218, 18, 'PPL', 'P'),
(114823, 'Canton', 42.163330078125, 0.735888933468439, -90.8955612182617, -1.58642681870674, 218, 16, 'PPL', 'P'),
(124445, 'Canton', 42.1583290100098, 0.735801648363712, -71.1452789306641, -1.24171936458984, 218, 23, 'PPL', 'P'),
(127027, 'Canton', 44.440559387207, 0.775634082734836, -70.3158264160156, -1.22724268722028, 218, 26, 'PPL', 'P'),
(130074, 'Canton', 42.3086090087891, 0.738424529142304, -83.4822235107422, -1.45703966714827, 218, 27, 'PPL', 'P'),
(134552, 'Canton', 43.5297203063965, 0.759736941818854, -91.9297180175781, -1.60447625983669, 218, 28, 'PPL', 'P'),
(139071, 'Canton', 40.125, 0.700313362362725, -91.625, -1.5991579271398, 218, 29, 'PPL', 'P'),
(147586, 'Canton', 44.5955581665039, 0.778339321770139, -75.1694412231445, -1.31195424622823, 218, 40, 'PPL', 'P'),
(154597, 'Canton', 40.7988891601563, 0.712074947000951, -81.3786087036133, -1.42032466257017, 218, 41, 'PPL', 'P'),
(159795, 'Canton', 41.6563911437988, 0.727041179957896, -76.8536071777344, -1.34134848728581, 218, 45, 'PPL', 'P'),
(169961, 'Canton', 43.3008308410645, 0.75574206702568, -96.5924987792969, -1.68585713642733, 218, 49, 'PPL', 'P'),
(173433, 'Canton', 45.4280586242676, 0.792869195782475, -91.6597213745117, -1.59976392944585, 218, 57, 'PPL', 'P'),
(177573, 'Canton', 41.8244400024414, 0.729974185845428, -72.894172668457, -1.27224331858184, 218, 8, 'PPL', 'P'),
(194135, 'Canton', 40.3158302307129, 0.703643978201005, -104.345558166504, -1.82117354983675, 218, 7, 'PPL', 'P'),
(196145, 'Canton', 46.413890838623, 0.810075213795204, -111.502502441406, -1.94608579181555, 218, 31, 'PPL', 'P'),
(7898, 'Canton (historical)', 36.2825012207031, 0.633249107160131, -91.4544372558594, -1.59618104567331, 218, 4, 'PPL', 'P'),
(188233, 'Canton (historical)', 34.2166709899902, 0.597193567846957, -104.031669616699, -1.81569516115835, 218, 38, 'PPL', 'P'),
(177574, 'Canton Center', 41.8563919067383, 0.73053185177769, -72.9155578613281, -1.27261656060861, 218, 8, 'PPL', 'P'),
(124446, 'Canton Junction', 42.1624984741211, 0.735874419240498, -71.1624984741211, -1.24201990231885, 218, 23, 'PPL', 'P'),
(127028, 'Canton Point', 44.4691696166992, 0.776133425439226, -70.2983322143555, -1.2269373558013, 218, 26, 'PPL', 'P'),
(154599, 'Canton Road', 40.7472190856934, 0.711173134076823, -81.517219543457, -1.42274387810439, 218, 41, 'PPL', 'P'),
(177575, 'Canton Valley', 41.834171295166, 0.730144028943948, -72.892219543457, -1.27220923011988, 218, 8, 'PPL', 'P'),
(15424, 'Cantonment', 30.6083297729492, 0.534216133074172, -87.3399963378906, -1.52437050477598, 218, 12, 'PPL', 'P'),
(35136, 'Cantown', 37.2613906860352, 0.650333951343262, -84.9122161865234, -1.48199774762006, 218, 21, 'PPL', 'P'),
(26697, 'Cantrall', 39.9377784729004, 0.697045730284225, -89.6758270263672, -1.56513844105902, 218, 18, 'PPL', 'P'),
(193427, 'Cantrall Mill', 41.3191719055176, 0.721155593948821, -120.326393127441, -2.10009173712293, 218, 6, 'PPL', 'P'),
(85538, 'Cantrell (historical)', 36.5205612182617, 0.637404037934818, -82.3513870239258, -1.43730284715164, 218, 50, 'PPL', 'P'),
(85539, 'Cantrell Subdivision', 35.3008308410645, 0.616115726866134, -87.7611083984375, -1.53172029675238, 218, 50, 'PPL', 'P'),
(114825, 'Cantril', 40.6441688537598, 0.709374568234638, -92.0697174072266, -1.60691971013684, 218, 16, 'PPL', 'P'),
(93037, 'Cantu', 26.315559387207, 0.459293155810864, -98.3083267211914, -1.71580398341111, 218, 51, 'PPL', 'P'),
(93032, 'Cantu Addition', 27.202220916748, 0.474768318852124, -98.1549987792969, -1.71312790598975, 218, 51, 'PPL', 'P'),
(93033, 'Cantu Addition Number 1 Colonia', 27.2019996643066, 0.474764457268543, -98.1529998779297, -1.71309301857947, 218, 51, 'PPL', 'P'),
(93034, 'Cantu Addition Number 2 Colonia', 27.2019996643066, 0.474764457268543, -98.1549987792969, -1.71312790598975, 218, 51, 'PPL', 'P'),
(93035, 'Cantu Colonia', 26.4050006866455, 0.460854200973328, -98.9919967651367, -1.72773627667521, 218, 51, 'PPL', 'P'),
(180502, 'Cantua Creek', 36.5013885498047, 0.63706941174385, -120.315277099609, -2.09989772583752, 218, 6, 'PPL', 'P'),
(53844, 'Cantwell', 37.872501373291, 0.660999844930002, -90.5116729736328, -1.57972670487826, 218, 29, 'PPL', 'P'),
(108478, 'Cantwell', 39.1324996948242, 0.682990964210359, -81.1313934326172, -1.41600994213007, 218, 58, 'PPL', 'P'),
(211719, 'Cantwell', 63.3916702270508, 1.1063933638005, -148.950836181641, -2.59968251496833, 218, 1, 'PPL', 'P'),
(58885, 'Cantwell Mill', 31.5088901519775, 0.549933876801225, -89.6900024414063, -1.56538584872429, 218, 30, 'PPL', 'P'),
(1344, 'Canty', 32.163330078125, 0.561356008269006, -86.0830612182617, -1.50243284845451, 218, 2, 'PPL', 'P'),
(80142, 'Cantys Lane', 34.1650009155273, 0.596291754922829, -80.5688934326172, -1.40619246508761, 218, 48, 'PPL', 'P'),
(75327, 'Canute', 35.4219398498535, 0.61822947782333, -99.279167175293, -1.73274834584674, 218, 42, 'PPL', 'P'),
(191219, 'Canutillo', 31.9113903045654, 0.556958829703663, -106.599716186523, -1.86051602914633, 218, 51, 'PPL', 'P'),
(108479, 'Canvas', 38.2683296203613, 0.667908351113777, -80.7744369506836, -1.409779876234, 218, 58, 'PPL', 'P'),
(108480, 'Canyon', 39.6763916015625, 0.692483668757892, -79.8916702270508, -1.39437269037956, 218, 58, 'PPL', 'P'),
(134555, 'Canyon', 47.0400009155273, 0.821002896117099, -92.4705581665039, -1.61391570116242, 218, 28, 'PPL', 'P'),
(180503, 'Canyon', 37.8316688537598, 0.660287183022297, -122.186668395996, -2.13255966555263, 218, 6, 'PPL', 'P'),
(191221, 'Canyon', 34.980281829834, 0.61052109120615, -101.918327331543, -1.77881038006075, 218, 51, 'PPL', 'P'),
(194682, 'Canyon', 47.5752792358398, 0.830345265221097, -116.411666870117, -2.03176687461835, 218, 17, 'PPL', 'P'),
(196146, 'Canyon (historical)', 47.1772193908691, 0.82339781030638, -109.209716796875, -1.90606913327602, 218, 31, 'PPL', 'P'),
(180504, 'Canyon Acres', 33.5530586242676, 0.585611347108148, -117.771667480469, -2.05550336309811, 218, 6, 'PPL', 'P'),
(93036, 'Canyon City', 29.8736095428467, 0.521392845977873, -98.1875, -1.71369515930193, 218, 51, 'PPL', 'P'),
(180505, 'Canyon City', 32.5950012207031, 0.56889009099284, -116.52693939209, -2.03377875966385, 218, 6, 'PPL', 'P'),
(200519, 'Canyon City', 44.389720916748, 0.774746784038649, -118.949172973633, -2.07605471091415, 218, 43, 'PPL', 'P'),
(190005, 'Canyon City (historical)', 39.3463897705078, 0.686724050268377, -117.136108398438, -2.04441076452572, 218, 39, 'PPL', 'P'),
(201961, 'Canyon City (historical)', 44.0849990844727, 0.769428384762734, -103.605278015137, -1.80825322380823, 218, 49, 'PPL', 'P'),
(180506, 'Canyon Country', 34.4233283996582, 0.600800420069306, -118.47110748291, -2.06771089406087, 218, 6, 'PPL', 'P'),
(203254, 'Canyon Cove', 40.6333312988281, 0.709185417218215, -111.795562744141, -1.95120065900516, 218, 52, 'PPL', 'P'),
(203255, 'Canyon Cove Condominium Phase One', 41.2324981689453, 0.719642851870629, -111.942497253418, -1.95376514997685, 218, 52, 'PPL', 'P'),
(19765, 'Canyon Creek', 33.9083290100098, 0.59181198507418, -83.482780456543, -1.45704938768625, 218, 13, 'PPL', 'P'),
(196147, 'Canyon Creek', 46.8055610656738, 0.816911148839274, -112.263610839844, -1.95936963933287, 218, 31, 'PPL', 'P'),
(196148, 'Canyon Creek Boat Landing', 48.2138900756836, 0.841491127015297, -113.767219543457, -1.98561256187257, 218, 31, 'PPL', 'P'),
(180507, 'Canyon Crest Heights', 33.9805603027344, 0.593072658955196, -117.328056335449, -2.04776088801898, 218, 6, 'PPL', 'P'),
(177841, 'Canyon Day', 33.7847213745117, 0.589654624854134, -110.025833129883, -1.92031305036631, 218, 5, 'PPL', 'P'),
(177842, 'Canyon Diablo', 35.1627807617188, 0.613706298448912, -111.116943359375, -1.93935651637314, 218, 5, 'PPL', 'P'),
(203259, 'Canyon Enterprises', 40.627498626709, 0.709083617885546, -111.73999786377, -1.95023086889421, 218, 52, 'PPL', 'P'),
(188234, 'Canyon Estates', 35.082218170166, 0.612300215972377, -106.380561828613, -1.8566910640307, 218, 38, 'PPL', 'P'),
(524, 'Canyon Falls', 37.5763893127441, 0.655831714518594, -83.5774993896484, -1.45870254493292, 218, 21, 'PPL', 'P'),
(196149, 'Canyon Ferry', 46.6555595397949, 0.814293128329672, -111.717498779297, -1.94983818579148, 218, 31, 'PPL', 'P'),
(203260, 'Canyon Glen', 40.3302803039551, 0.703896179556236, -111.618057250977, -1.94810260370907, 218, 52, 'PPL', 'P'),
(209349, 'Canyon Junction', 44.7361106872559, 0.780792426029238, -110.492500305176, -1.92845792908616, 218, 59, 'PPL', 'P'),
(93038, 'Canyon Lake', 29.875, 0.521417114033306, -98.2622222900391, -1.71499930928774, 218, 51, 'PPL', 'P'),
(180509, 'Canyon Lake', 33.685001373291, 0.58791418250274, -117.272216796875, -2.04678630421807, 218, 6, 'PPL', 'P'),
(93039, 'Canyon Lake Forest', 29.8616695404053, 0.521184453622574, -98.2627792358398, -1.71500902982572, 218, 51, 'PPL', 'P'),
(188235, 'Canyon Mill', 34.3144416809082, 0.598899988315426, -106.714721679688, -1.86252325365992, 218, 38, 'PPL', 'P'),
(154602, 'Canyon Park', 41.0786094665527, 0.716956987332257, -80.9955596923828, -1.41363919612769, 218, 41, 'PPL', 'P'),
(206953, 'Canyon Park', 47.7911109924316, 0.834112240003987, -122.191390991211, -2.13264209038837, 218, 56, 'PPL', 'P'),
(203263, 'Canyon Place', 40.5863914489746, 0.708366162287879, -111.792503356934, -1.9511472626253, 218, 52, 'PPL', 'P'),
(203264, 'Canyon Racquet Club Condo', 40.6158294677734, 0.708879952641183, -111.788887023926, -1.95108414570747, 218, 52, 'PPL', 'P'),
(203265, 'Canyon Rim', 40.7066688537598, 0.710465399017134, -111.821113586426, -1.95164660532969, 218, 52, 'PPL', 'P'),
(203267, 'Canyon Road Towers Condominium', 40.7722206115723, 0.711609493021432, -111.885833740234, -1.95277618510605, 218, 52, 'PPL', 'P'),
(177843, 'Canyon Run', 33.3327789306641, 0.581766741179483, -111.88166809082, -1.95270348080829, 218, 5, 'PPL', 'P'),
(93040, 'Canyon Springs', 29.8724994659424, 0.521373471480942, -98.2872161865234, -1.7154355350743, 218, 51, 'PPL', 'P'),
(203268, 'Canyon Terrace Condominium', 41.2416687011719, 0.719802907852143, -111.947776794434, -1.95385729535057, 218, 52, 'PPL', 'P'),
(177844, 'Canyon Trails Mobile Home Park', 33.6913909912109, 0.588025702373387, -112.110000610352, -1.95668863506349, 218, 5, 'PPL', 'P'),
(191222, 'Canyon Valley', 33.4011116027832, 0.582959371294647, -101.334716796875, -1.76862445468147, 218, 51, 'PPL', 'P'),
(177845, 'Canyon View', 33.6558303833008, 0.587405052681344, -112.153060913086, -1.95744017912311, 218, 5, 'PPL', 'P'),
(180510, 'Canyon View', 38.1925010681152, 0.666584893210062, -120.355560302734, -2.1006008003653, 218, 6, 'PPL', 'P'),
(203270, 'Canyon View Condo', 40.6111106872559, 0.708797594384472, -111.79167175293, -1.95113274839736, 218, 52, 'PPL', 'P'),
(196150, 'Canyon View Trailer Court', 45.6583290100098, 0.796888172183513, -110.949996948242, -1.93644275182449, 218, 31, 'PPL', 'P'),
(203272, 'Canyon View Village', 40.6211090087891, 0.708972098014899, -111.842498779297, -1.95201984735647, 218, 52, 'PPL', 'P'),
(72008, 'Canyon Villa Estates', 39.9769401550293, 0.697729230577994, -82.5138931274414, -1.44013911371257, 218, 41, 'PPL', 'P'),
(177846, 'Canyon Village', 33.5936088562012, 0.586319082167837, -112.11499786377, -1.95677585358919, 218, 5, 'PPL', 'P'),
(209350, 'Canyon Village', 44.7338905334473, 0.780753677035377, -110.489166259766, -1.92839973901634, 218, 59, 'PPL', 'P'),
(159799, 'Canyon Vista', 41.4661102294922, 0.72372015149954, -76.5650024414063, -1.33631138440004, 218, 45, 'PPL', 'P'),
(203274, 'Canyon West', 40.686939239502, 0.710121052288187, -112.065002441406, -1.95590326885802, 218, 52, 'PPL', 'P'),
(193428, 'Canyondam', 40.1719398498535, 0.70113261729306, -121.071670532227, -2.11309928167715, 218, 6, 'PPL', 'P'),
(200520, 'Canyonville', 42.9275016784668, 0.749226243944638, -123.279998779297, -2.15164188055332, 218, 43, 'PPL', 'P'),
(53845, 'Cap au Gris', 38.9988899230957, 0.680659033780858, -90.6916732788086, -1.58286830285817, 218, 29, 'PPL', 'P'),
(191223, 'Cap Rock', 33.4913902282715, 0.584535030553593, -101.398063659668, -1.76973006600802, 218, 51, 'PPL', 'P'),
(206954, 'Cap Sante', 48.5183296203613, 0.846804599443196, -122.599166870117, -2.1397591220855, 218, 56, 'PPL', 'P'),
(201962, 'Capa', 44.1088905334473, 0.769845369210413, -100.977783203125, -1.76239478825956, 218, 49, 'PPL', 'P'),
(130077, 'Capac', 43.0125007629395, 0.750709757829866, -82.9280624389648, -1.44736773185938, 218, 27, 'PPL', 'P'),
(100481, 'Capahosic', 37.3808288574219, 0.652418540686522, -76.6333312988281, -1.33750394793617, 218, 53, 'PPL', 'P'),
(31964, 'Capaldo', 37.4677810668945, 0.653936143033703, -94.7263870239258, -1.65328734208594, 218, 20, 'PPL', 'P'),
(180512, 'Capay', 38.7077789306641, 0.675578188474178, -122.046943664551, -2.13012100894244, 218, 6, 'PPL', 'P'),
(45367, 'Cape Anne', 38.795280456543, 0.677105378201284, -76.5261077880859, -1.33563254463817, 218, 25, 'PPL', 'P'),
(45368, 'Cape Arthur', 39.0788917541504, 0.682055329140387, -76.5250015258789, -1.33561323672027, 218, 25, 'PPL', 'P'),
(15425, 'Cape Canaveral', 28.4055595397949, 0.495770539840707, -80.6050033569336, -1.40682270215957, 218, 12, 'PPL', 'P'),
(100482, 'Cape Carlyn', 37.1500015258789, 0.648389843747504, -79.7147216796875, -1.39128435562145, 218, 53, 'PPL', 'P'),
(63424, 'Cape Carteret', 34.6913909912109, 0.60547899489333, -77.0633316040039, -1.34500886904607, 218, 33, 'PPL', 'P'),
(100483, 'Cape Charles', 37.2677803039551, 0.650445471213909, -76.0177764892578, -1.32676048978268, 218, 53, 'PPL', 'P'),
(100484, 'Cape Charlie', 37.7844390869141, 0.65946286808589, -77.0961074829102, -1.34558091604822, 218, 53, 'PPL', 'P'),
(1343, 'Cape Choccolocco', 33.5683288574219, 0.585877862954238, -86.1750030517578, -1.50403753616934, 218, 2, 'PPL', 'P'),
(63425, 'Cape Colony', 36.0194396972656, 0.628657817440835, -76.5819396972656, -1.33660699528103, 218, 33, 'PPL', 'P'),
(15426, 'Cape Coral', 26.5625, 0.463603082560994, -81.9497222900391, -1.43029247505617, 218, 12, 'PPL', 'P'),
(127030, 'Cape Cottage', 43.6269416809082, 0.761433774907398, -70.216667175293, -1.22551203198589, 218, 26, 'PPL', 'P'),
(127031, 'Cape Elizabeth', 43.5636100769043, 0.76032842989696, -70.2005615234375, -1.22523093533283, 218, 26, 'PPL', 'P'),
(53846, 'Cape Fair', 36.7299995422363, 0.641059426268034, -93.5100021362305, -1.63205742082415, 218, 29, 'PPL', 'P'),
(63426, 'Cape Fear', 35.4249992370605, 0.618282874203186, -78.8150024414063, -1.37558129256991, 218, 33, 'PPL', 'P'),
(53847, 'Cape Galena (historical)', 38.2058296203613, 0.66681752033128, -92.767219543457, -1.61909341895376, 218, 29, 'PPL', 'P'),
(53848, 'Cape Girardeau', 37.3058280944824, 0.65110953043172, -89.5180587768555, -1.56238486564994, 218, 29, 'PPL', 'P'),
(15427, 'Cape Haze', 26.8500003814697, 0.46862091081838, -82.2944412231445, -1.43630895543282, 218, 12, 'PPL', 'P'),
(45369, 'Cape Hill Farms', 39.6363906860352, 0.691785521078128, -76.8838882446289, -1.34187699160414, 218, 25, 'PPL', 'P'),
(180517, 'Cape Horn', 39.1291694641113, 0.682932840719568, -120.923606872559, -2.11051508331339, 218, 6, 'PPL', 'P'),
(194684, 'Cape Horn (historical)', 44.4049987792969, 0.775013433042793, -115.167221069336, -2.0100471980321, 218, 17, 'PPL', 'P'),
(45370, 'Cape Horn South', 39.6172218322754, 0.691450961466186, -76.8997192382813, -1.34215329456723, 218, 25, 'PPL', 'P'),
(45371, 'Cape Isle Of Wight', 38.3527793884277, 0.669382277619081, -75.1183319091797, -1.3110622204211, 218, 25, 'PPL', 'P'),
(100485, 'Cape Junction', 37.2700004577637, 0.65048422020777, -75.9844436645508, -1.32617872224256, 218, 53, 'PPL', 'P'),
(45372, 'Cape Leonard', 38.4019393920898, 0.670240281543277, -76.4922180175781, -1.33504105656007, 218, 25, 'PPL', 'P'),
(45373, 'Cape Loch Haven', 38.9236106872559, 0.679345163257068, -76.5238876342773, -1.33559379564431, 218, 25, 'PPL', 'P'),
(63429, 'Cape Lookout', 34.605281829834, 0.603976106511171, -76.5366668701172, -1.33581683538561, 218, 33, 'PPL', 'P'),
(70614, 'Cape May', 38.935001373291, 0.679543968232442, -74.9063873291016, -1.30736308966698, 218, 37, 'PPL', 'P'),
(45374, 'Cape May Beach', 39.3025016784668, 0.685958058559843, -76.4180603027344, -1.33374676027029, 218, 25, 'PPL', 'P'),
(70609, 'Cape May Court House', 39.0825004577637, 0.682118312900167, -74.8241729736328, -1.30592817847165, 218, 37, 'PPL', 'P'),
(45375, 'Cape May Landing', 39.2986106872559, 0.685890147952046, -76.4261093139648, -1.33388724201779, 218, 25, 'PPL', 'P'),
(70610, 'Cape May Point', 38.9372215270996, 0.679582717226303, -74.9697189331055, -1.30846843467742, 218, 37, 'PPL', 'P'),
(45376, 'Cape McKinsey', 39.0758285522461, 0.682001866181503, -76.5227813720703, -1.33557448772641, 218, 25, 'PPL', 'P'),
(200521, 'Cape Meares', 45.4900016784668, 0.793950306026992, -123.957496643066, -2.16346644895133, 218, 43, 'PPL', 'P'),
(127033, 'Cape Neddick', 43.1936111450195, 0.753870730306709, -70.6213912963867, -1.23257580046121, 218, 26, 'PPL', 'P'),
(211720, 'Cape Nome', 64.4638900756836, 1.12510713046438, -164.959442138672, -2.8790853975729, 218, 1, 'PPL', 'P'),
(45377, 'Cape Pleasant', 38.4411087036133, 0.670923914995101, -75.1258316040039, -1.31119311478868, 218, 25, 'PPL', 'P'),
(209941, 'Cape Pole', 55.9650001525879, 0.976773518541788, -133.793334960938, -2.335134212292, 218, 1, 'PPL', 'P'),
(127037, 'Cape Porpoise', 43.372501373291, 0.75699295378969, -70.438606262207, -1.22938559979141, 218, 26, 'PPL', 'P'),
(127034, 'Cape Rosier', 44.3313903808594, 0.773728724132939, -68.7994384765625, -1.20077672493929, 218, 26, 'PPL', 'P'),
(45378, 'Cape Sable', 39.079719543457, 0.6820697767893, -76.5036087036133, -1.33523986153544, 218, 25, 'PPL', 'P'),
(45379, 'Cape Saint Claire', 39.0430603027344, 0.681429952337409, -76.4452819824219, -1.33422186820876, 218, 25, 'PPL', 'P'),
(45380, 'Cape Saint John', 38.961109161377, 0.679999635094955, -76.5702819824219, -1.33640352977375, 218, 25, 'PPL', 'P'),
(29386, 'Cape Sandy', 38.1508293151855, 0.665857583916361, -86.3708267211914, -1.50745530395429, 218, 19, 'PPL', 'P'),
(100486, 'Cape Story by the Sea', 36.9099998474121, 0.644201024247946, -76.0577774047852, -1.32745863746245, 218, 53, 'PPL', 'P'),
(147588, 'Cape Vincent', 44.1277809143066, 0.770175068553365, -76.3333282470703, -1.33226790691697, 218, 40, 'PPL', 'P'),
(13479, 'Cape Windsor Mobile Home Park', 38.4536094665527, 0.671142094467406, -75.0736083984375, -1.3102816479056, 218, 10, 'PPL', 'P'),
(29387, 'Capehart', 38.7455596923828, 0.676237587160081, -87.1941680908203, -1.52182532172219, 218, 19, 'PPL', 'P'),
(108481, 'Capehart', 38.7130584716797, 0.675670333847895, -81.8811111450195, -1.42909498467201, 218, 58, 'PPL', 'P'),
(141430, 'Capehart', 41.1258316040039, 0.717781169110609, -95.956672668457, -1.67475987732303, 218, 35, 'PPL', 'P'),
(80141, 'Capehart Housing Project', 32.461109161377, 0.566553233715323, -80.7983322143555, -1.4101969272607, 218, 48, 'PPL', 'P'),
(19764, 'Capel', 30.9730606079102, 0.540581887027789, -84.1986083984375, -1.46954294215008, 218, 13, 'PPL', 'P'),
(58886, 'Capell', 31.0247192382813, 0.541483500214835, -90.9877777099609, -1.58803630011152, 218, 30, 'PPL', 'P'),
(739, 'Capella', 36.3616714477539, 0.634630888291719, -80.3166732788086, -1.40179039296376, 218, 33, 'PPL', 'P'),
(108482, 'Capels', 37.4544410705566, 0.653703316175403, -81.6016693115234, -1.4242178046097, 218, 58, 'PPL', 'P'),
(63430, 'Capels Mill', 35.1558303833008, 0.613584991461259, -79.79638671875, -1.39270967943686, 218, 33, 'PPL', 'P'),
(63431, 'Capelsie', 35.3191719055176, 0.616435838829161, -79.8711090087891, -1.39401382942267, 218, 33, 'PPL', 'P'),
(63432, 'Capernium', 36.0541687011719, 0.629263952904937, -80.4169387817383, -1.40354035611605, 218, 33, 'PPL', 'P'),
(85540, 'Capers (historical)', 35.6947212219238, 0.622990410904064, -87.204719543457, -1.52200947931157, 218, 50, 'PPL', 'P'),
(108483, 'Caperton', 38.021110534668, 0.663593564094658, -81.0266723632813, -1.41418221467395, 218, 58, 'PPL', 'P'),
(13480, 'Capes Cove Mobile Home Park', 38.7641716003418, 0.676562426234044, -75.1694412231445, -1.31195424622823, 218, 10, 'PPL', 'P'),
(93041, 'Capetillo Colonia', 26.1030006408691, 0.455583305833356, -97.9440002441406, -1.70944528683438, 218, 51, 'PPL', 'P'),
(193429, 'Capetown', 40.4663887023926, 0.706271719248586, -124.366111755371, -2.17059812803445, 218, 6, 'PPL', 'P'),
(45381, 'Capetowne', 39.0325012207031, 0.681245661589975, -76.4802780151367, -1.33483266420477, 218, 25, 'PPL', 'P'),
(88, 'Capeville', 37.2027816772461, 0.649311031168563, -75.9574966430664, -1.32570840799405, 218, 53, 'PPL', 'P'),
(31965, 'Capioma', 39.776668548584, 0.694233831647265, -95.8199996948242, -1.67237448393464, 218, 20, 'PPL', 'P'),
(93042, 'Capisallo Heights Colonia', 26.2140007019043, 0.457520622368335, -97.9179992675781, -1.70899148418463, 218, 51, 'PPL', 'P'),
(93043, 'Capisallo Park Colonia', 26.1840000152588, 0.456997011608511, -97.8960037231445, -1.7086075895135, 218, 51, 'PPL', 'P'),
(180518, 'Capistrano Beach', 33.4625015258789, 0.584030827580213, -117.670829772949, -2.05374341309174, 218, 6, 'PPL', 'P'),
(180521, 'Capital Hill', 35.6277809143066, 0.621822082133847, -120.679718017578, -2.10625841978506, 218, 6, 'PPL', 'P'),
(13481, 'Capital Trail Farms', 39.7291717529297, 0.69340485617895, -75.6458282470703, -1.32026876830951, 218, 10, 'PPL', 'P'),
(39643, 'Capitan', 30.0652809143066, 0.524738142491662, -91.9824981689453, -1.60539744725775, 218, 22, 'PPL', 'P'),
(180522, 'Capitan', 34.4633293151855, 0.60149856774907, -120.042221069336, -2.09513199906682, 218, 6, 'PPL', 'P'),
(188236, 'Capitan', 33.545280456543, 0.585475592471581, -105.571670532227, -1.84257324761803, 218, 38, 'PPL', 'P'),
(188237, 'Capitan Hill', 36.670280456543, 0.640017131596404, -104.773887634277, -1.82864930933271, 218, 38, 'PPL', 'P'),
(35137, 'Capito', 36.6141700744629, 0.639037820684555, -83.8305587768555, -1.46311926444276, 218, 21, 'PPL', 'P'),
(196151, 'Capitol', 45.4361114501953, 0.793009744109004, -104.065002441406, -1.81627692869848, 218, 31, 'PPL', 'P'),
(186484, 'Capitol City (historical)', 38.0072212219238, 0.663351149856433, -107.466110229492, -1.8756374578158, 218, 7, 'PPL', 'P'),
(45382, 'Capitol Estates', 38.586109161377, 0.673454650399976, -76.9555587768555, -1.34312787836815, 218, 25, 'PPL', 'P'),
(203279, 'Capitol Gardens Condominium', 40.7794418334961, 0.71173552712002, -111.893608093262, -1.95291187316359, 218, 52, 'PPL', 'P'),
(13482, 'Capitol Green', 39.1549987792969, 0.683383647313091, -75.517219543457, -1.31802412298473, 218, 10, 'PPL', 'P'),
(45383, 'Capitol Heights', 38.8849983215332, 0.678671250343223, -76.9161071777344, -1.34243931806831, 218, 25, 'PPL', 'P'),
(114827, 'Capitol Heights', 41.6333312988281, 0.726638709738158, -93.5199966430664, -1.63223185787555, 218, 16, 'PPL', 'P'),
(203281, 'Capitol Heights Condominium', 40.7799987792969, 0.711745247657999, -111.891670227051, -1.95287805101775, 218, 52, 'PPL', 'P'),
(13050, 'Capitol Hill', 38.8888893127441, 0.67873916095102, -77.0005569458008, -1.34391324457361, 218, 9, 'PPL', 'P'),
(85542, 'Capitol Hill', 35.2911109924316, 0.615946083504696, -86.0652770996094, -1.50212245702946, 218, 50, 'PPL', 'P'),
(144941, 'Capitol Hill', 40.0552787780762, 0.69909649748164, -74.9038925170898, -1.30731954698316, 218, 37, 'PPL', 'P'),
(200522, 'Capitol Hill', 45.4655609130859, 0.793523734199389, -122.696388244629, -2.14145595517404, 218, 43, 'PPL', 'P'),
(206955, 'Capitol Hill', 47.6236114501953, 0.83118882149638, -122.318328857422, -2.13485757409921, 218, 56, 'PPL', 'P'),
(45384, 'Capitol Hills', 39.1986083984375, 0.684144778752636, -76.6172180175781, -1.33722271812506, 218, 25, 'PPL', 'P'),
(26699, 'Capitol Oaks', 38.5900001525879, 0.673522561007773, -89.9683303833008, -1.57024358771065, 218, 18, 'PPL', 'P'),
(13483, 'Capitol Park', 39.1413917541504, 0.683146159922883, -75.5044403076172, -1.31780108324344, 218, 10, 'PPL', 'P'),
(13051, 'Capitol View', 38.8894386291504, 0.678748748330944, -76.9316711425781, -1.3427109604995, 218, 9, 'PPL', 'P'),
(100487, 'Capitol View', 37.475830078125, 0.654076624781205, -77.3908309936523, -1.35072481169371, 218, 53, 'PPL', 'P'),
(45385, 'Capitol View Park', 39.0222206115723, 0.681066231111531, -77.0608291625977, -1.34496519320419, 218, 25, 'PPL', 'P'),
(15428, 'Capitola', 30.4508304595947, 0.531467251486506, -84.0880584716797, -1.46761348194032, 218, 12, 'PPL', 'P'),
(45386, 'Capitola', 38.2886085510254, 0.668262285222648, -75.8066711425781, -1.32307600641456, 218, 25, 'PPL', 'P'),
(180523, 'Capitola', 36.9752807617188, 0.645340391141309, -121.952217102051, -2.12846771853772, 218, 6, 'PPL', 'P'),
(191224, 'Capitola', 32.6222190856934, 0.569365132352283, -100.492218017578, -1.75392007703871, 218, 51, 'PPL', 'P'),
(93044, 'Caplen', 29.499439239502, 0.514862342221321, -94.523063659668, -1.64973867993341, 218, 51, 'PPL', 'P'),
(206956, 'Caples', 45.9058303833008, 0.801207886050649, -122.79972076416, -2.14325944786424, 218, 56, 'PPL', 'P'),
(206957, 'Caples Landing', 45.9052810668945, 0.801198298670725, -122.801666259766, -2.14329340316814, 218, 56, 'PPL', 'P'),
(85543, 'Capleville', 35.0205612182617, 0.611224099154904, -89.8977813720703, -1.56901227518065, 218, 50, 'PPL', 'P'),
(53851, 'Caplinger Mills', 37.7941703796387, 0.65963271118441, -93.8041687011719, -1.63719159593166, 218, 29, 'PPL', 'P'),
(39645, 'Caplis', 32.3969383239746, 0.56543324131889, -93.6094436645508, -1.63379300290656, 218, 22, 'PPL', 'P'),
(108484, 'Capon Bridge', 39.2980613708496, 0.685880560572122, -78.436393737793, -1.36897332411515, 218, 58, 'PPL', 'P'),
(108485, 'Capon Lake', 39.1558303833008, 0.683398161541032, -78.5380630493164, -1.37074778834947, 218, 58, 'PPL', 'P'),
(108488, 'Capon Springs', 39.1361083984375, 0.683053947970139, -78.4847183227539, -1.36981674723238, 218, 58, 'PPL', 'P'),
(108489, 'Capon Springs Station (historical)', 39.1511116027832, 0.683315803284321, -78.5194396972656, -1.37042274953842, 218, 58, 'PPL', 'P'),
(53852, 'Cappeln', 38.6841697692871, 0.675166130874515, -90.9388885498047, -1.58718302329826, 218, 29, 'PPL', 'P'),
(29388, 'Capperas Banks (historical)', 38.3125, 0.668679269670328, -85.7944412231445, -1.49739547925262, 218, 19, 'PPL', 'P'),
(1346, 'Capps', 31.496940612793, 0.549725317998358, -85.3119430541992, -1.48897429756968, 218, 2, 'PPL', 'P'),
(7899, 'Capps', 36.2355613708496, 0.632429852229796, -93.1891708374023, -1.62645785831615, 218, 4, 'PPL', 'P'),
(15429, 'Capps', 30.4102802276611, 0.530759516426818, -83.9111099243164, -1.46452514718221, 218, 12, 'PPL', 'P'),
(53853, 'Capps', 38.2422218322754, 0.667452684251264, -92.3208312988281, -1.61130247434278, 218, 29, 'PPL', 'P'),
(7900, 'Capps City', 33.0200004577637, 0.576307726998011, -93.9763870239258, -1.64019737269598, 218, 4, 'PPL', 'P'),
(93045, 'Capps Corner', 33.8022193908691, 0.589960022852139, -97.5074996948242, -1.70182691506205, 218, 51, 'PPL', 'P'),
(191225, 'Capps Switch', 36.0377807617188, 0.628977929403862, -101.642219543457, -1.77399139006825, 218, 51, 'PPL', 'P'),
(45387, 'Capri Estates', 39.0694389343262, 0.681890346310856, -76.5097198486328, -1.3353465211371, 218, 25, 'PPL', 'P'),
(1347, 'Capri Islands', 33.5550003051758, 0.585645235833019, -86.1772232055664, -1.5040762851632, 218, 2, 'PPL', 'P'),
(80144, 'Capri Isles', 32.7769393920898, 0.572065511118596, -80.023063659668, -1.39666593839423, 218, 48, 'PPL', 'P'),
(119028, 'Capri Village', 42.1416702270508, 0.735510897751703, -88.0297164916992, -1.5364083923773, 218, 18, 'PPL', 'P'),
(177847, 'Capri Village', 33.4552803039551, 0.583904793481625, -112.148612976074, -1.95736254797733, 218, 5, 'PPL', 'P'),
(159800, 'Caprivi', 40.2438888549805, 0.70238836432606, -77.2319412231445, -1.34795166205061, 218, 45, 'PPL', 'P'),
(188238, 'Caprock', 33.3919410705566, 0.582799315313134, -103.711936950684, -1.8101147734102, 218, 38, 'PPL', 'P'),
(75328, 'Capron', 36.896671295166, 0.643968397126727, -98.5772171020508, -1.72049700588405, 218, 42, 'PPL', 'P'),
(100488, 'Capron', 36.7108306884766, 0.640724866656093, -77.2002792358398, -1.34739905612442, 218, 53, 'PPL', 'P'),
(119029, 'Capron', 42.3997192382813, 0.74001470262919, -88.7402801513672, -1.54881006778353, 218, 18, 'PPL', 'P'),
(93046, 'Caps', 32.3730583190918, 0.565016456608293, -99.8466720581055, -1.74265317457296, 218, 51, 'PPL', 'P'),
(1348, 'Capshaw', 34.7730598449707, 0.606904385287768, -86.7927780151367, -1.51481974331668, 218, 2, 'PPL', 'P'),
(19768, 'Capstan (historical)', 33.2169418334961, 0.579745002437949, -85.0652770996094, -1.48466916450952, 218, 13, 'PPL', 'P'),
(100490, 'Captain', 37.392219543457, 0.652617345661896, -80.4550018310547, -1.40420468164997, 218, 53, 'PPL', 'P'),
(211677, 'Captain Cook', 19.496940612793, 0.340285807759038, -155.921676635742, -2.72134663252362, 218, 15, 'PPL', 'P'),
(45388, 'Captains Choice', 39.0138893127441, 0.680920822516013, -76.4875030517578, -1.33495876488238, 218, 25, 'PPL', 'P'),
(206958, 'Captains Choice', 48.223331451416, 0.841655910107745, -122.67138671875, -2.14101959622943, 218, 56, 'PPL', 'P'),
(45389, 'Captains Cove', 39.0805587768555, 0.682084424175296, -76.5677795410156, -1.33635985393188, 218, 25, 'PPL', 'P'),
(80145, 'Captains Cove', 33.5397186279297, 0.585378520249848, -79.0597229003906, -1.37985247032618, 218, 48, 'PPL', 'P'),
(13484, 'Captains Grant Mobile Home Park', 38.6027793884277, 0.673745600749067, -75.1847229003906, -1.3122209618114, 218, 10, 'PPL', 'P'),
(100491, 'Captains Grove', 37.3313903808594, 0.651555676493336, -79.9580612182617, -1.39553143176986, 218, 53, 'PPL', 'P'),
(45390, 'Captains Hill', 38.350830078125, 0.669348255736155, -75.0999984741211, -1.31074224161613, 218, 25, 'PPL', 'P'),
(45391, 'Captains Knoll', 38.3525009155273, 0.669377417350092, -75.1158294677734, -1.31101854457923, 218, 25, 'PPL', 'P'),
(19769, 'Captains Quarters', 33.7305603027344, 0.58870933582521, -84.7330627441406, -1.4788709301842, 218, 13, 'PPL', 'P'),
(72009, 'Captina', 39.8875007629395, 0.696168218705044, -80.8711090087891, -1.41146712194262, 218, 41, 'PPL', 'P'),
(108490, 'Captina', 39.8188896179199, 0.694970728320889, -80.8133316040039, -1.41045871599586, 218, 58, 'PPL', 'P'),
(15430, 'Captiva', 26.5216693878174, 0.462890453942802, -82.1894378662109, -1.43447630112868, 218, 12, 'PPL', 'P'),
(19770, 'Captolo', 32.6252784729004, 0.569418528732139, -81.5972213745117, -1.42414017346392, 218, 13, 'PPL', 'P'),
(186485, 'Capulin', 37.2838897705078, 0.650726634445994, -106.110832214355, -1.85198339417177, 218, 7, 'PPL', 'P'),
(188240, 'Capulin', 36.7411117553711, 0.641253370974419, -103.993057250977, -1.8150212482445, 218, 38, 'PPL', 'P'),
(201964, 'Caputa', 43.9938888549805, 0.767838211275847, -102.981666564941, -1.79736915074919, 218, 49, 'PPL', 'P'),
(80146, 'Capwells Crossroads', 32.7791709899902, 0.572104459849539, -80.2686080932617, -1.40095149722038, 218, 48, 'PPL', 'P'),
(15431, 'Cara', 29.3444404602051, 0.512157103186019, -82.2630615234375, -1.43576127635465, 218, 12, 'PPL', 'P'),
(93048, 'Caradan', 31.5536098480225, 0.5507143827377, -98.476936340332, -1.71874677641565, 218, 51, 'PPL', 'P'),
(141431, 'Caradon Mobile Home Park', 41.2347183227539, 0.71968160086449, -96.0194396972656, -1.67585536863743, 218, 35, 'PPL', 'P'),
(63433, 'Caraleigh', 35.7605590820313, 0.624139498335406, -78.6494369506836, -1.37269162962912, 218, 33, 'PPL', 'P'),
(85545, 'Caramel Village', 35.1958312988281, 0.614283139141023, -85.1750030517578, -1.48658424364939, 218, 50, 'PPL', 'P'),
(93047, 'Carancahua', 28.6963901519775, 0.500846491588884, -96.3894424438477, -1.68231313480671, 218, 51, 'PPL', 'P'),
(1350, 'Carara', 33.3997192382813, 0.5829350699497, -86.0358276367188, -1.50160846693907, 218, 2, 'PPL', 'P'),
(127035, 'Caratunk', 45.2338905334473, 0.789480323295349, -69.9905624389648, -1.22156575988261, 218, 26, 'PPL', 'P'),
(180524, 'Caravan Mobile Home Park', 39.1269416809082, 0.682893958567653, -123.15860748291, -2.14952320274811, 218, 6, 'PPL', 'P'),
(13485, 'Caravel Farms', 39.5958290100098, 0.691077586281357, -75.720832824707, -1.32157784514334, 218, 10, 'PPL', 'P'),
(85546, 'Caravelle', 36.2038917541504, 0.63187711314555, -86.5411071777344, -1.51042725857276, 218, 50, 'PPL', 'P'),
(80147, 'Caravelle Heights', 34.5230598449707, 0.602541062157782, -82.7750015258789, -1.44469631496992, 218, 48, 'PPL', 'P'),
(7901, 'Caraway', 35.7580604553223, 0.624095889072556, -90.3222198486328, -1.57642012406882, 218, 4, 'PPL', 'P'),
(196152, 'Carbella', 45.2077789306641, 0.789024589853809, -110.90389251709, -1.93563807770112, 218, 31, 'PPL', 'P'),
(196153, 'Carbert', 48.975830078125, 0.854789488760553, -105.809997558594, -1.84673283892462, 218, 31, 'PPL', 'P'),
(108491, 'Carbide', 39.5394401550293, 0.690093415100518, -80.6669387817383, -1.40790367924604, 218, 58, 'PPL', 'P'),
(100497, 'Carbo', 36.9283294677734, 0.644520936473892, -82.1944427490234, -1.43456365281244, 218, 53, 'PPL', 'P'),
(39646, 'Carboco', 30.9219398498535, 0.539689661483585, -92.2311096191406, -1.60973653562182, 218, 22, 'PPL', 'P'),
(26706, 'Carbon', 38.5938911437988, 0.67359047161557, -89.9391708374023, -1.56973465762634, 218, 18, 'PPL', 'P'),
(29389, 'Carbon', 39.5977783203125, 0.691111608164283, -87.1186065673828, -1.52050652435039, 218, 19, 'PPL', 'P'),
(75329, 'Carbon', 34.9261093139648, 0.609575602440144, -95.6388931274414, -1.66921357803683, 218, 42, 'PPL', 'P'),
(93049, 'Carbon', 32.2705612182617, 0.563227544725059, -98.8283309936523, -1.72487977008999, 218, 51, 'PPL', 'P'),
(108493, 'Carbon', 38.0194396972656, 0.663564402480721, -81.4063873291016, -1.42080949104661, 218, 58, 'PPL', 'P'),
(114829, 'Carbon', 40.8963890075684, 0.713776640358484, -92.4216690063477, -1.61306242434916, 218, 16, 'PPL', 'P'),
(159803, 'Carbon', 40.2902793884277, 0.703198031876471, -79.5605621337891, -1.38859376397214, 218, 45, 'PPL', 'P'),
(209351, 'Carbon', 41.8486099243164, 0.730396030562096, -106.376388549805, -1.85661822657489, 218, 59, 'PPL', 'P'),
(31968, 'Carbon (historical)', 39.4769401550293, 0.689002584318022, -95.5980606079102, -1.66850091612912, 218, 20, 'PPL', 'P'),
(53855, 'Carbon Center', 38.0461082458496, 0.66402985646024, -94.3216705322266, -1.64622370676867, 218, 29, 'PPL', 'P'),
(159804, 'Carbon Center', 40.8730583190918, 0.713369443027811, -79.7936096191406, -1.39266120990502, 218, 45, 'PPL', 'P'),
(194685, 'Carbon Center', 47.5583305358887, 0.830049454603017, -115.900001525879, -2.02283662969304, 218, 17, 'PPL', 'P'),
(7902, 'Carbon City', 35.2975006103516, 0.616057603375343, -93.7916717529297, -1.63697348303838, 218, 4, 'PPL', 'P'),
(119030, 'Carbon Cliff', 41.4947204589844, 0.72421949420393, -90.3905563354492, -1.57761282076301, 218, 18, 'PPL', 'P'),
(35138, 'Carbon Glow', 37.1797218322754, 0.648908560948825, -82.9533309936523, -1.44780875133589, 218, 21, 'PPL', 'P'),
(1351, 'Carbon Hill', 33.8916702270508, 0.59152123446217, -87.5261077880859, -1.52761876235755, 218, 2, 'PPL', 'P'),
(53856, 'Carbon Hill', 38.7791709899902, 0.676824214969199, -93.6074981689453, -1.63375904760266, 218, 29, 'PPL', 'P'),
(72011, 'Carbon Hill', 39.5016708374023, 0.689434216151697, -82.2447204589844, -1.43544116439162, 218, 41, 'PPL', 'P'),
(119031, 'Carbon Hill', 41.2969398498535, 0.720767571377997, -88.3000030517578, -1.54112578277421, 218, 18, 'PPL', 'P'),
(196155, 'Carbon Hill Trailer Court', 46.399169921875, 0.809818285329039, -105.819442749023, -1.8468976885961, 218, 31, 'PPL', 'P'),
(186486, 'Carbon Junction', 37.2374992370605, 0.649916966895583, -107.866111755371, -1.88261880145539, 218, 7, 'PPL', 'P'),
(180526, 'Carbona', 37.6961097717285, 0.657921230709871, -121.411109924316, -2.11902361668008, 218, 6, 'PPL', 'P'),
(206959, 'Carbonado', 47.0800018310547, 0.821701043796863, -122.050277709961, -2.13017919901226, 218, 56, 'PPL', 'P'),
(186487, 'Carbonate', 39.7430610656738, 0.693647270417175, -107.34610748291, -1.8735430147765, 218, 7, 'PPL', 'P'),
(194686, 'Carbonate (historical)', 47.4552803039551, 0.828250888760832, -115.763893127441, -2.02046109000069, 218, 17, 'PPL', 'P'),
(201965, 'Carbonate (historical)', 44.4000015258789, 0.774926214517093, -103.868057250977, -1.81283958667951, 218, 49, 'PPL', 'P'),
(19772, 'Carbondale', 34.6444396972656, 0.604659540225913, -84.9938888549805, -1.48342320459352, 218, 13, 'PPL', 'P'),
(26700, 'Carbondale', 37.7272186279297, 0.658464182677111, -89.216667175293, -1.55712458986481, 218, 18, 'PPL', 'P'),
(31969, 'Carbondale', 38.8186111450195, 0.677512575531957, -95.6888885498047, -1.67008616276799, 218, 20, 'PPL', 'P'),
(72012, 'Carbondale', 39.3777809143066, 0.687271929083634, -82.271110534668, -1.43590175810215, 218, 41, 'PPL', 'P'),
(75330, 'Carbondale', 36.0952796936035, 0.629981475081631, -96.0199966430664, -1.67586508917541, 218, 42, 'PPL', 'P'),
(93050, 'Carbondale', 33.314998626709, 0.581456416333461, -94.4411087036133, -1.64830829611193, 218, 51, 'PPL', 'P'),
(108492, 'Carbondale', 38.1861114501953, 0.666473373339415, -81.2994384765625, -1.41894288143858, 218, 58, 'PPL', 'P'),
(114830, 'Carbondale', 41.582218170166, 0.725746617352009, -93.503059387207, -1.63193624699455, 218, 16, 'PPL', 'P'),
(122319, 'Carbondale', 40.3600006103516, 0.704414896757556, -87.3477783203125, -1.52450632599158, 218, 19, 'PPL', 'P'),
(130078, 'Carbondale', 45.2783317565918, 0.790255968962835, -87.6158294677734, -1.52918470107852, 218, 27, 'PPL', 'P'),
(159807, 'Carbondale', 41.5736083984375, 0.725596348487501, -75.5022201538086, -1.31776233424958, 218, 45, 'PPL', 'P'),
(180527, 'Carbondale', 38.4088897705078, 0.670361588530931, -121.005828857422, -2.11195012766678, 218, 6, 'PPL', 'P'),
(186488, 'Carbondale', 39.4022216796875, 0.687698500911237, -107.210563659668, -1.87117732878019, 218, 7, 'PPL', 'P'),
(180528, 'Carbondale (historical)', 33.7533302307129, 0.589106746038877, -117.676391601563, -2.05384048531347, 218, 6, 'PPL', 'P'),
(186489, 'Carbonera', 39.4588890075684, 0.688687532361066, -108.95832824707, -1.90168157538012, 218, 7, 'PPL', 'P'),
(63434, 'Carbonton', 35.5202789306641, 0.619945818566858, -79.3491668701172, -1.38490422059795, 218, 33, 'PPL', 'P'),
(192507, 'Carbonville', 39.6199989318848, 0.691499430998026, -110.833610534668, -1.93441142570303, 218, 52, 'PPL', 'P'),
(15432, 'Carbur', 29.9180603027344, 0.522168658092926, -83.4280624389648, -1.45609437811935, 218, 12, 'PPL', 'P'),
(198086, 'Carbury', 48.8908309936523, 0.853305974875324, -100.544166564941, -1.75482675023182, 218, 34, 'PPL', 'P'),
(173435, 'Carcajou', 42.889720916748, 0.748566845258734, -88.9619369506836, -1.55267870874103, 218, 57, 'PPL', 'P'),
(35144, 'Carcassonne', 37.1749992370605, 0.648826136113087, -82.9916687011719, -1.44847787055978, 218, 21, 'PPL', 'P'),
(180529, 'Card Place', 39.8080596923828, 0.694781710462521, -123.403610229492, -2.15379930735239, 218, 6, 'PPL', 'P'),
(1352, 'Card Switch', 34.8727798461914, 0.608644827639162, -85.8555603027344, -1.49846220842725, 218, 2, 'PPL', 'P'),
(77969, 'Cardale', 39.9566688537598, 0.697375429627177, -79.8663864135742, -1.39393140458694, 218, 45, 'PPL', 'P'),
(19773, 'Cardell', 33.7863883972168, 0.589683719889043, -84.5388870239258, -1.47548192453902, 218, 13, 'PPL', 'P'),
(31970, 'Carden', 39.8277816772461, 0.695125924033414, -96.5805587768555, -1.68564874407204, 218, 20, 'PPL', 'P'),
(35139, 'Carden', 37.0424995422363, 0.646513580180516, -85.9986114501953, -1.5009589219492, 218, 21, 'PPL', 'P'),
(7903, 'Carden Bottoms', 35.1483306884766, 0.613454097093681, -93.0136108398438, -1.62339375832396, 218, 4, 'PPL', 'P'),
(63436, 'Cardenas (historical)', 35.5936088562012, 0.621225667207723, -78.7744369506836, -1.37487329119411, 218, 33, 'PPL', 'P'),
(85547, 'Cardens Bluff (historical)', 36.3152809143066, 0.633821220741308, -82.1152801513672, -1.43318200483891, 218, 50, 'PPL', 'P'),
(45393, 'Carderock', 38.9775009155273, 0.680285725175056, -77.1947174072266, -1.34730198390268, 218, 25, 'PPL', 'P'),
(45394, 'Carderock Springs', 38.9888916015625, 0.680484530150431, -77.1677780151367, -1.34683180281223, 218, 25, 'PPL', 'P'),
(1353, 'Cardiff', 33.6455612182617, 0.587225821939982, -86.9336090087891, -1.51727770784477, 218, 2, 'PPL', 'P'),
(7904, 'Cardiff', 34.9272193908691, 0.609594976937075, -93.9250030517578, -1.6393005531989, 218, 4, 'PPL', 'P'),
(13486, 'Cardiff', 39.8133316040039, 0.694873722678183, -75.538330078125, -1.31839257132155, 218, 10, 'PPL', 'P'),
(45396, 'Cardiff', 39.7172203063965, 0.69319626408657, -76.3380584716797, -1.33235046491076, 218, 25, 'PPL', 'P'),
(70613, 'Cardiff', 39.4099998474121, 0.687834255547804, -74.5875015258789, -1.30179748246288, 218, 37, 'PPL', 'P'),
(85548, 'Cardiff', 35.8905601501465, 0.626408445005127, -84.6311111450195, -1.47709153910186, 218, 50, 'PPL', 'P'),
(93051, 'Cardiff', 29.7858295440674, 0.519860795981777, -95.9058303833008, -1.67387251204781, 218, 51, 'PPL', 'P'),
(119032, 'Cardiff', 41.0516700744629, 0.716486806241803, -88.2872161865234, -1.54090260987487, 218, 18, 'PPL', 'P'),
(147590, 'Cardiff', 42.889720916748, 0.748566845258734, -76.1436080932617, -1.32895666557562, 218, 40, 'PPL', 'P'),
(159810, 'Cardiff', 40.4949989318848, 0.706771061952976, -78.8341674804688, -1.37591578560282, 218, 45, 'PPL', 'P'),
(186491, 'Cardiff', 39.5061111450195, 0.689511714139418, -107.310279846191, -1.87291770455255, 218, 7, 'PPL', 'P'),
(194687, 'Cardiff', 46.5744400024414, 0.812877325315158, -115.811393737793, -2.02129013204803, 218, 17, 'PPL', 'P'),
(194688, 'Cardiff Mill', 46.4708290100098, 0.811068972355967, -115.793609619141, -2.02097974062298, 218, 17, 'PPL', 'P'),
(180530, 'Cardiff-by-the-Sea', 33.021671295166, 0.576336888611947, -117.280281066895, -2.04692705228168, 218, 6, 'PPL', 'P'),
(134556, 'Cardigan Junction', 45.0527801513672, 0.786319350818507, -93.1091690063477, -1.62506156295662, 218, 28, 'PPL', 'P'),
(75331, 'Cardin', 36.9724998474121, 0.645291855030442, -94.8486099243164, -1.65542053411909, 218, 42, 'PPL', 'P'),
(35140, 'Cardinal', 36.8016700744629, 0.642310313032044, -83.5124969482422, -1.45756803830854, 218, 21, 'PPL', 'P'),
(100492, 'Cardinal', 37.420280456543, 0.653107100986362, -76.3819427490234, -1.33311639004027, 218, 53, 'PPL', 'P'),
(186490, 'Cardinal (historical)', 39.9697189331055, 0.697603196479406, -105.547218322754, -1.84214647605334, 218, 7, 'PPL', 'P'),
(53857, 'Cardinal Acres', 37.0552787780762, 0.64673661992181, -91.668327331543, -1.59991413173133, 218, 29, 'PPL', 'P'),
(119033, 'Cardinal Court', 40.517219543457, 0.707158884786719, -88.9991683959961, -1.55332852004701, 218, 18, 'PPL', 'P'),
(100494, 'Cardinal Estates', 36.7972183227539, 0.642232615307241, -76.0749969482422, -1.32775917519146, 218, 53, 'PPL', 'P'),
(45397, 'Cardinal Forest', 39.1283302307129, 0.682918193333572, -76.8691711425781, -1.341620129717, 218, 25, 'PPL', 'P'),
(100495, 'Cardinal Forest', 38.7830581665039, 0.676892058997968, -77.2361068725586, -1.34802436634837, 218, 53, 'PPL', 'P'),
(100496, 'Cardinal Heights', 38.5347213745117, 0.672557764323864, -77.3099975585938, -1.34931400210624, 218, 53, 'PPL', 'P'),
(124448, 'Cardinal Heights', 42.0611114501953, 0.734104881854195, -71.9319381713867, -1.25544915843169, 218, 23, 'PPL', 'P'),
(35141, 'Cardinal Hill', 38.042781829834, 0.663971799548476, -84.5388870239258, -1.47548192453902, 218, 21, 'PPL', 'P'),
(85550, 'Cardinal Hills', 36.2583312988281, 0.632827262443463, -83.2213897705078, -1.45248725958089, 218, 50, 'PPL', 'P'),
(19774, 'Cardinal Lake Estates', 33.9805603027344, 0.593072658955196, -84.1358337402344, -1.46844731767763, 218, 13, 'PPL', 'P'),
(80148, 'Cardinal Park', 34.5449981689453, 0.602923958143508, -82.6383285522461, -1.44231092158153, 218, 48, 'PPL', 'P'),
(19775, 'Cardinal Ridge', 32.5291709899902, 0.567741136719553, -83.7041702270508, -1.46091336811185, 218, 13, 'PPL', 'P'),
(35142, 'Cardinal Valley', 38.0530586242676, 0.664151163447893, -84.5441665649414, -1.47557406991273, 218, 21, 'PPL', 'P'),
(77970, 'Cardington', 39.940559387207, 0.697094266395091, -75.2466735839844, -1.31330220521397, 218, 45, 'PPL', 'P'),
(154603, 'Cardington', 40.500560760498, 0.70686813417471, -82.8936080932617, -1.44676639008524, 218, 41, 'PPL', 'P'),
(203284, 'Cardon', 41.8247184753418, 0.729979046114417, -111.843612670898, -1.95203928843243, 218, 52, 'PPL', 'P'),
(29391, 'Cardonia', 39.5616683959961, 0.690481371092316, -87.1188888549805, -1.5205114511984, 218, 19, 'PPL', 'P'),
(100502, 'Cardova', 38.5322189331055, 0.672514088481987, -78.038330078125, -1.3620258026214, 218, 53, 'PPL', 'P'),
(147591, 'Cards Corners', 42.9891700744629, 0.750302560499193, -76.2508316040039, -1.33082806887362, 218, 40, 'PPL', 'P'),
(58887, 'Cardsville', 34.1555595397949, 0.596126971830381, -88.4024963378906, -1.54291462807842, 218, 30, 'PPL', 'P'),
(45398, 'Cardtown', 38.5372200012207, 0.672601373586714, -76.0233306884766, -1.32685742884636, 218, 25, 'PPL', 'P'),
(147592, 'Cardtown', 42.6441688537598, 0.744281153274524, -75.2461090087891, -1.31329235151794, 218, 40, 'PPL', 'P'),
(127038, 'Cardville', 45.0558280944824, 0.786372547461281, -68.5994415283203, -1.19728611969852, 218, 26, 'PPL', 'P'),
(15433, 'Cardwell', 26.7655601501465, 0.467147150760644, -80.6600036621094, -1.40778263857449, 218, 12, 'PPL', 'P'),
(35143, 'Cardwell', 37.8241691589355, 0.66015628865472, -85.0341720581055, -1.4841262791213, 218, 21, 'PPL', 'P'),
(53858, 'Cardwell', 36.0469398498535, 0.629137785648294, -90.2927780151367, -1.57590626713649, 218, 29, 'PPL', 'P'),
(100498, 'Cardwell', 37.6725006103516, 0.657509173110208, -77.7944412231445, -1.35776913909308, 218, 53, 'PPL', 'P'),
(194689, 'Cardwell', 47.209171295166, 0.823955476238643, -116.5625, -2.03439940935589, 218, 17, 'PPL', 'P'),
(196156, 'Cardwell', 45.8600006103516, 0.800408005617244, -111.951667785645, -1.95392520595837, 218, 31, 'PPL', 'P'),
(100499, 'Cardwell Town', 36.9019393920898, 0.644060342763363, -81.779167175293, -1.42731572674773, 218, 53, 'PPL', 'P'),
(139069, 'Cardy', 40.0016708374023, 0.698160862411668, -92.5952835083008, -1.61609256903745, 218, 29, 'PPL', 'P'),
(100500, 'Care Free Acres', 39.0208282470703, 0.681041929766584, -77.9972229003906, -1.36130834702374, 218, 53, 'PPL', 'P'),
(45399, 'Carea', 39.7013893127441, 0.692919961123474, -76.5063934326172, -1.33528846422534, 218, 25, 'PPL', 'P'),
(29393, 'Carefree', 38.2516708374023, 0.667617600501767, -86.3513870239258, -1.50711601723141, 218, 19, 'PPL', 'P'),
(177849, 'Carefree', 33.8222198486328, 0.590309096692021, -111.917503356934, -1.9533289241903, 218, 5, 'PPL', 'P'),
(177848, 'Carefree Foothills', 33.7980613708496, 0.589887451712434, -111.948608398438, -1.95387180957851, 218, 5, 'PPL', 'P'),
(180532, 'Carefree Mobile Village', 33.9238891601563, 0.592083560926341, -116.561943054199, -2.03438968881791, 218, 6, 'PPL', 'P'),
(80150, 'Carem', 34.6983299255371, 0.605600102143901, -81.5680618286133, -1.42363124337961, 218, 48, 'PPL', 'P'),
(39647, 'Carencro', 30.3169403076172, 0.529130427498502, -92.0488891601563, -1.60655618864804, 218, 22, 'PPL', 'P'),
(108494, 'Caress', 38.7044410705566, 0.675519931825332, -80.5494384765625, -1.40585291204862, 218, 58, 'PPL', 'P'),
(100501, 'Caret', 37.9824981689453, 0.662919651180813, -76.961669921875, -1.34323453796981, 218, 53, 'PPL', 'P'),
(108495, 'Caretta', 37.3355598449707, 0.651628447370122, -81.6730575561523, -1.42546376452569, 218, 58, 'PPL', 'P'),
(108496, 'Carew', 37.514720916748, 0.654755397964039, -80.8874969482422, -1.41175314544369, 218, 58, 'PPL', 'P'),
(1354, 'Carey', 34.8763885498047, 0.608707811398942, -86.9341735839844, -1.51728756154081, 218, 2, 'PPL', 'P'),
(19777, 'Carey', 33.5475006103516, 0.585514341465442, -83.269172668457, -1.45332122847625, 218, 13, 'PPL', 'P'),
(39650, 'Carey', 30.5025005340576, 0.532369064410634, -91.3158264160156, -1.59376183013909, 218, 22, 'PPL', 'P'),
(144942, 'Carey', 40.8555603027344, 0.713064045029806, -74.6788864135742, -1.30339244963973, 218, 37, 'PPL', 'P'),
(154605, 'Carey', 40.9524993896484, 0.714755951270333, -83.3824996948242, -1.45529915821785, 218, 41, 'PPL', 'P'),
(191226, 'Carey', 34.4711112976074, 0.601634388964664, -100.32527923584, -1.75100644564811, 218, 51, 'PPL', 'P'),
(194690, 'Carey', 43.3077812194824, 0.755863374013333, -113.943893432617, -1.98869610294071, 218, 17, 'PPL', 'P'),
(200523, 'Carey (historical)', 44.8611106872559, 0.782974087594231, -123.409721374512, -2.15390596695405, 218, 43, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(45400, 'Carey Acres', 38.454719543457, 0.671161468964336, -75.5369415283203, -1.31836833655563, 218, 25, 'PPL', 'P'),
(124449, 'Carey Corner', 42.3733291625977, 0.739554108918661, -73.3463897705078, -1.28013599594645, 218, 23, 'PPL', 'P'),
(45402, 'Carey Heights', 38.3624992370605, 0.669551920980519, -75.5666732788086, -1.31888725349403, 218, 25, 'PPL', 'P'),
(19778, 'Carey Park', 33.7836112976074, 0.589635250357203, -84.4719390869141, -1.47431346261074, 218, 13, 'PPL', 'P'),
(147593, 'Careys Corners', 43.1472206115723, 0.753061062756297, -75.2958297729492, -1.31416014255914, 218, 40, 'PPL', 'P'),
(13487, 'Careys Estate Mobile Home Park', 38.5533294677734, 0.6728825368188, -75.3683319091797, -1.31542554355109, 218, 10, 'PPL', 'P'),
(45403, 'Careytown', 38.4338912963867, 0.67079794747554, -75.3258285522461, -1.31468372002945, 218, 25, 'PPL', 'P'),
(72014, 'Careytown', 39.310001373291, 0.686088952927421, -83.6291732788086, -1.45960442443607, 218, 41, 'PPL', 'P'),
(7905, 'Careyville Landing', 33.2633285522461, 0.580554603409333, -92.3088912963867, -1.61109408198749, 218, 4, 'PPL', 'P'),
(194691, 'Careywood', 48.0347213745117, 0.838364043263326, -116.642219543457, -2.0357907778674, 218, 17, 'PPL', 'P'),
(100503, 'Carfax', 36.8905601501465, 0.64386173752507, -82.3777770996094, -1.43776344086217, 218, 53, 'PPL', 'P'),
(39648, 'Cargas', 32.6938896179199, 0.570616019116294, -92.0144424438477, -1.60595498003196, 218, 22, 'PPL', 'P'),
(7907, 'Cargile', 33.1572189331055, 0.578702641187292, -92.6516723632813, -1.61707674021829, 218, 4, 'PPL', 'P'),
(191227, 'Cargray', 35.5166702270508, 0.619882834807078, -101.175003051758, -1.76583692396848, 218, 51, 'PPL', 'P'),
(15434, 'Caribbean Key', 26.3997192382813, 0.460762022310097, -80.0725021362305, -1.39752880258741, 218, 12, 'PPL', 'P'),
(194694, 'Caribel', 46.2580604553223, 0.807355460531961, -115.94361114502, -2.02359776113258, 218, 17, 'PPL', 'P'),
(127039, 'Caribou', 46.8605613708496, 0.817871085254193, -68.0124969482422, -1.18704200424942, 218, 26, 'PPL', 'P'),
(134557, 'Caribou', 48.9824981689453, 0.854905868900189, -96.4491729736328, -1.68335562921542, 218, 28, 'PPL', 'P'),
(193430, 'Caribou', 40.0805587768555, 0.699537716695239, -121.156669616699, -2.11458279556238, 218, 6, 'PPL', 'P'),
(186492, 'Caribou (historical)', 39.9808311462402, 0.697797141185791, -105.578056335449, -1.84268470090965, 218, 7, 'PPL', 'P'),
(186493, 'Caribou City', 39.9900016784668, 0.697957197167304, -105.512222290039, -1.84153568005733, 218, 7, 'PPL', 'P'),
(194692, 'Caribou City', 43.1030616760254, 0.752290343936828, -111.263893127441, -1.94192127366094, 218, 17, 'PPL', 'P'),
(53859, 'Carico', 36.7944412231445, 0.642184145775402, -93.4111099243164, -1.63033142612167, 218, 29, 'PPL', 'P'),
(53863, 'Carie', 36.6377792358398, 0.639449878284217, -90.9388885498047, -1.58718302329826, 218, 29, 'PPL', 'P'),
(134558, 'Carimona', 43.6602783203125, 0.762015609026553, -92.1575012207031, -1.60845182671196, 218, 28, 'PPL', 'P'),
(85551, 'Caringer (historical)', 35.5077781677246, 0.619727639094554, -84.033332824707, -1.46665833921536, 218, 50, 'PPL', 'P'),
(188241, 'Carisbrook', 36.9169387817383, 0.644322131498517, -104.370826721191, -1.82161456931327, 218, 38, 'PPL', 'P'),
(19779, 'Carl', 34.0055618286133, 0.593509017899805, -83.811393737793, -1.46278477140984, 218, 13, 'PPL', 'P'),
(35145, 'Carl', 36.9736099243164, 0.645311229527373, -87.336669921875, -1.52431244786422, 218, 21, 'PPL', 'P'),
(75332, 'Carl', 34.9580612182617, 0.610133268372407, -99.9400024414063, -1.74428209705371, 218, 42, 'PPL', 'P'),
(93052, 'Carl', 30.113920211792, 0.525587058378638, -97.7494201660156, -1.70604922381231, 218, 51, 'PPL', 'P'),
(108497, 'Carl', 38.1105613708496, 0.665154775704689, -80.6847229003906, -1.40821407067109, 218, 58, 'PPL', 'P'),
(114831, 'Carl', 41.1199989318848, 0.717679369777941, -94.6627807617188, -1.65217720338554, 218, 16, 'PPL', 'P'),
(53860, 'Carl Junction', 37.1766700744629, 0.648855297727023, -94.5652770996094, -1.65047544344898, 218, 29, 'PPL', 'P'),
(1355, 'Carl Smith Subdivision', 33.5230598449707, 0.585087769637839, -86.2611083984375, -1.50554035797247, 218, 2, 'PPL', 'P'),
(39649, 'Carla', 31.9400005340576, 0.557458172408053, -92.6847229003906, -1.6176535809104, 218, 22, 'PPL', 'P'),
(19780, 'Carlan', 34.334171295166, 0.599244335044373, -83.4005584716797, -1.45561434333286, 218, 13, 'PPL', 'P'),
(130079, 'Carland', 43.0580596923828, 0.751504911152337, -84.3047180175781, -1.47139490437213, 218, 27, 'PPL', 'P'),
(147594, 'Carle Place', 40.752498626709, 0.711265279450539, -73.6108322143555, -1.28475138727361, 218, 40, 'PPL', 'P'),
(119035, 'Carle Springs', 40.2536087036133, 0.702558007687498, -88.9669418334961, -1.55276606042479, 218, 18, 'PPL', 'P'),
(75333, 'Carleton', 36.0149993896484, 0.628580319453113, -98.5199966430664, -1.71949832047527, 218, 42, 'PPL', 'P'),
(130080, 'Carleton', 42.0591697692871, 0.734070993129324, -83.3908309936523, -1.45544456681337, 218, 27, 'PPL', 'P'),
(141433, 'Carleton', 40.3005599975586, 0.703377462354915, -97.6783294677734, -1.70480845706045, 218, 35, 'PPL', 'P'),
(1356, 'Carleton Point', 33.2061080932617, 0.579555918000553, -86.477783203125, -1.50932204672038, 218, 2, 'PPL', 'P'),
(72020, 'Carletonville', 39.0105590820313, 0.680862699025222, -81.9850006103516, -1.4309081979002, 218, 41, 'PPL', 'P'),
(159811, 'Carley Brook', 41.6277809143066, 0.726541837253506, -75.2355575561523, -1.31310819392856, 218, 45, 'PPL', 'P'),
(147595, 'Carley Mills', 43.3786087036133, 0.757099546812321, -76.1216735839844, -1.32857383616892, 218, 40, 'PPL', 'P'),
(1357, 'Carleys', 32.2669410705566, 0.563164361228197, -87.4913864135742, -1.5270127600515, 218, 2, 'PPL', 'P'),
(19781, 'Carlier Springs (historical)', 34.2013893127441, 0.596926852263786, -85.1141662597656, -1.48552244132278, 218, 13, 'PPL', 'P'),
(209355, 'Carlile', 44.4869384765625, 0.776443550548166, -104.800827026367, -1.82911949042317, 218, 59, 'PPL', 'P'),
(209353, 'Carlile Junction', 44.5022201538086, 0.776710266131337, -104.687782287598, -1.82714648752958, 218, 59, 'PPL', 'P'),
(159814, 'Carlim', 40.4869384765625, 0.706630380468393, -78.1699981689453, -1.36432384432603, 218, 45, 'PPL', 'P'),
(199864, 'Carlin', 40.7138900756836, 0.710591433115722, -116.103057861328, -2.02638063131366, 218, 39, 'PPL', 'P'),
(35146, 'Carlinburg', 37.8833312988281, 0.661188862788371, -87.3233337402344, -1.52407968758494, 218, 21, 'PPL', 'P'),
(19782, 'Carling (historical)', 33.0555610656738, 0.576928376690054, -83.2386093139648, -1.45278779730991, 218, 13, 'PPL', 'P'),
(26703, 'Carlinville', 39.2797203063965, 0.685560448609094, -89.8816680908203, -1.56873104536954, 218, 18, 'PPL', 'P'),
(1358, 'Carlisle', 34.1288909912109, 0.595661517850862, -86.1202774047852, -1.50308239344438, 218, 2, 'PPL', 'P'),
(7909, 'Carlisle', 34.7830581665039, 0.607078888918195, -91.7463912963867, -1.60127660494502, 218, 4, 'PPL', 'P'),
(29392, 'Carlisle', 38.9683303833008, 0.680125669193543, -87.4055633544922, -1.52551486509639, 218, 19, 'PPL', 'P'),
(35147, 'Carlisle', 38.311939239502, 0.668669482553321, -84.0274963378906, -1.46655647330367, 218, 21, 'PPL', 'P'),
(39657, 'Carlisle', 29.6866703033447, 0.518130140747389, -89.9622192382813, -1.57013692810899, 218, 22, 'PPL', 'P'),
(58888, 'Carlisle', 32.002498626709, 0.558548969901036, -90.7844390869141, -1.58448737164288, 218, 30, 'PPL', 'P'),
(72016, 'Carlisle', 39.5819396972656, 0.690835172043133, -84.3202819824219, -1.47166654680331, 218, 41, 'PPL', 'P'),
(75334, 'Carlisle', 35.500560760498, 0.619601671574993, -95.0261077880859, -1.65851845625713, 218, 42, 'PPL', 'P'),
(80152, 'Carlisle', 34.5927810668945, 0.603757927038866, -81.4627838134766, -1.42179379538551, 218, 48, 'PPL', 'P'),
(85552, 'Carlisle', 36.4247207641602, 0.63573130645414, -87.7569427490234, -1.53164759245462, 218, 50, 'PPL', 'P'),
(100504, 'Carlisle', 36.6616706848145, 0.639866862731897, -79.7869415283203, -1.39254482976539, 218, 53, 'PPL', 'P'),
(108498, 'Carlisle', 37.961109161377, 0.662546342575011, -81.1805572509766, -1.4168680126333, 218, 58, 'PPL', 'P'),
(114833, 'Carlisle', 41.5008316040039, 0.724326153805588, -93.4908294677734, -1.63172279463318, 218, 16, 'PPL', 'P'),
(124452, 'Carlisle', 42.5291709899902, 0.742274061918986, -71.3499984741211, -1.24529239466634, 218, 23, 'PPL', 'P'),
(130082, 'Carlisle', 42.8263893127441, 0.747461500248297, -85.6833267211914, -1.49545616534683, 218, 27, 'PPL', 'P'),
(134560, 'Carlisle', 46.3683280944824, 0.809279993893707, -96.1894378662109, -1.67882239640789, 218, 28, 'PPL', 'P'),
(141436, 'Carlisle', 40.3505592346191, 0.704250113665107, -97.7647171020508, -1.7063162057116, 218, 35, 'PPL', 'P'),
(147599, 'Carlisle', 42.7569389343262, 0.746249362478147, -74.4461135864258, -1.29932979739681, 218, 40, 'PPL', 'P'),
(159812, 'Carlisle', 40.2013893127441, 0.701646607383446, -77.1891708374023, -1.34720517799706, 218, 45, 'PPL', 'P'),
(191228, 'Carlisle', 33.5777816772461, 0.586042845783768, -101.976669311523, -1.77982863970354, 218, 51, 'PPL', 'P'),
(206960, 'Carlisle', 47.1549987792969, 0.823009987472637, -124.097221374512, -2.16590510556151, 218, 56, 'PPL', 'P'),
(19783, 'Carlisle (historical)', 34.5499992370605, 0.603011243248235, -84.5969390869141, -1.47649512417574, 218, 13, 'PPL', 'P'),
(19784, 'Carlisle Acres', 34.0438919067383, 0.594178003965633, -84.4780578613281, -1.47442025537046, 218, 13, 'PPL', 'P'),
(147596, 'Carlisle Center', 42.7247200012207, 0.745687036013977, -74.4283294677734, -1.29901940597177, 218, 40, 'PPL', 'P'),
(206961, 'Carlisle East', 47.142219543457, 0.822786947731343, -124.099166870117, -2.16593906086541, 218, 56, 'PPL', 'P'),
(147597, 'Carlisle Gardens', 43.1791687011719, 0.753618662109533, -78.6561126708984, -1.37280814292681, 218, 40, 'PPL', 'P'),
(159813, 'Carlisle Junction', 40.1241683959961, 0.700298848134784, -77.1769409179688, -1.34699172563569, 218, 45, 'PPL', 'P'),
(159817, 'Carlisle Springs', 40.2708282470703, 0.702858545416513, -77.1647186279297, -1.34677840643237, 218, 45, 'PPL', 'P'),
(124450, 'Carlisle Station', 42.5361099243164, 0.742395169169557, -71.3974990844727, -1.24612143671368, 218, 23, 'PPL', 'P'),
(13488, 'Carlisle Village', 39.1875, 0.683950900625278, -75.5791702270508, -1.31910536638731, 218, 10, 'PPL', 'P'),
(206962, 'Carlisle West', 47.1525001525879, 0.822966378209787, -124.106666564941, -2.16606995523299, 218, 56, 'PPL', 'P'),
(70615, 'Carlls Corner', 39.4627799987793, 0.688755442968863, -75.2055587768555, -1.31258461645825, 218, 37, 'PPL', 'P'),
(206963, 'Carlmar', 47.0525016784668, 0.821221075589404, -118.129173278809, -2.06174301637412, 218, 56, 'PPL', 'P'),
(85554, 'Carlock', 35.291389465332, 0.615950943773685, -84.5524978637695, -1.47571947850825, 218, 50, 'PPL', 'P'),
(119036, 'Carlock', 40.582218170166, 0.708293324832065, -89.1319427490234, -1.55564586966954, 218, 18, 'PPL', 'P'),
(169970, 'Carlock', 43.0819396972656, 0.751921695862934, -99.434440612793, -1.73545837857201, 218, 49, 'PPL', 'P'),
(100506, 'Carloover', 37.9241714477539, 0.66190165785413, -79.8888931274414, -1.39432422084772, 218, 53, 'PPL', 'P'),
(58889, 'Carlos', 31.6180591583252, 0.551839235403122, -90.3791732788086, -1.57741414894569, 218, 30, 'PPL', 'P'),
(63438, 'Carlos', 35.2094383239746, 0.614520626531231, -78.7719421386719, -1.37482974851029, 218, 33, 'PPL', 'P'),
(93054, 'Carlos', 30.5944404602051, 0.533973718835948, -96.0777816772461, -1.67687362828022, 218, 51, 'PPL', 'P'),
(108501, 'Carlos', 37.3958282470703, 0.652680329421677, -81.8016662597656, -1.42770840985047, 218, 58, 'PPL', 'P'),
(112386, 'Carlos', 39.6230583190918, 0.691552827377882, -78.9572219848633, -1.37806349186392, 218, 25, 'PPL', 'P'),
(122320, 'Carlos', 40.0263900756836, 0.698592294508261, -85.0344390869141, -1.48413093965321, 218, 19, 'PPL', 'P'),
(134562, 'Carlos', 45.9724998474121, 0.802371487709932, -95.2919387817383, -1.66315808235021, 218, 28, 'PPL', 'P'),
(93055, 'Carlos Acres Colonia', 26.2269992828369, 0.457747490403696, -98.4140014648438, -1.71764835562405, 218, 51, 'PPL', 'P'),
(93056, 'Carlos G Leal, Junior Colonia', 26.2269992828369, 0.457747490403696, -98.3339996337891, -1.71625206026452, 218, 51, 'PPL', 'P'),
(93057, 'Carlos G Leal, Junior Colonia Number 2', 26.2670001983643, 0.45844563808346, -98.3460006713867, -1.71646151788425, 218, 51, 'PPL', 'P'),
(45404, 'Carlos Junction', 39.6055603027344, 0.691247429379877, -78.9433288574219, -1.37782101104666, 218, 25, 'PPL', 'P'),
(1359, 'Carloss', 33.2944412231445, 0.5810976219556, -88.0755615234375, -1.53720853912682, 218, 2, 'PPL', 'P'),
(193431, 'Carlotta', 40.5374984741211, 0.70751281889559, -124.059440612793, -2.16524570687561, 218, 6, 'PPL', 'P'),
(53861, 'Carlow', 39.8808288574219, 0.69605177198638, -93.8322219848633, -1.63768121809807, 218, 29, 'PPL', 'P'),
(1360, 'Carlowville', 32.0869407653809, 0.560022763248285, -87.0341720581055, -1.51903286416119, 218, 2, 'PPL', 'P'),
(93058, 'Carls Corner', 32.0708312988281, 0.5597416000162, -97.0719375610352, -1.69422492173042, 218, 51, 'PPL', 'P'),
(180533, 'Carlsbad', 33.1580581665039, 0.578717288573287, -117.349716186523, -2.04813892373572, 218, 6, 'PPL', 'P'),
(188242, 'Carlsbad', 32.4205589294434, 0.565845498655635, -104.228332519531, -1.8191275763293, 218, 38, 'PPL', 'P'),
(191229, 'Carlsbad', 31.6052799224854, 0.551616195661828, -100.643058776855, -1.75655274493431, 218, 51, 'PPL', 'P'),
(206964, 'Carlsborg', 48.0908317565918, 0.839343354175175, -123.170829772949, -2.14973652195142, 218, 56, 'PPL', 'P'),
(26705, 'Carlsburg', 39.0833282470703, 0.682132760549081, -89.7222213745117, -1.56594817518846, 218, 18, 'PPL', 'P'),
(130083, 'Carlshend', 46.3108291625977, 0.808276448215937, -87.220832824707, -1.52229070912268, 218, 27, 'PPL', 'P'),
(15435, 'Carlson', 28.8241691589355, 0.50307665597523, -82.1819381713867, -1.43434540676111, 218, 12, 'PPL', 'P'),
(93059, 'Carlson', 30.4274997711182, 0.531060054155833, -97.4516677856445, -1.70085246441919, 218, 51, 'PPL', 'P'),
(159816, 'Carlson', 41.5838890075684, 0.725775778965945, -78.8394393920898, -1.37600779781848, 218, 45, 'PPL', 'P'),
(199218, 'Carlson', 41.8730583190918, 0.730822735547754, -103.514442443848, -1.80666784401131, 218, 35, 'PPL', 'P'),
(206965, 'Carlson', 46.7002792358398, 0.815073634266147, -122.198333740234, -2.13276326421797, 218, 56, 'PPL', 'P'),
(209354, 'Carlson', 41.8549995422363, 0.730507550432743, -110.971389770508, -1.93681612700932, 218, 59, 'PPL', 'P'),
(206966, 'Carlson Landing', 46.2649993896484, 0.807476567782532, -123.632499694824, -2.15779418214557, 218, 56, 'PPL', 'P'),
(144943, 'Carlstadt', 40.8402786254883, 0.712797329446635, -74.0911102294922, -1.29313381996269, 218, 37, 'PPL', 'P'),
(53862, 'Carlston', 36.2216682434082, 0.632187371412544, -89.7372207641602, -1.56620996392362, 218, 29, 'PPL', 'P'),
(177416, 'Carlsville', 44.9516716003418, 0.784554673701193, -87.336669921875, -1.52431244786422, 218, 57, 'PPL', 'P'),
(1361, 'Carlton', 31.3430595397949, 0.54703958661804, -87.8455581665039, -1.53319422325769, 218, 2, 'PPL', 'P'),
(15436, 'Carlton', 27.3430595397949, 0.477226416538267, -80.4227828979492, -1.4036423551858, 218, 12, 'PPL', 'P'),
(19785, 'Carlton', 34.0430603027344, 0.594163489737692, -83.0338897705078, -1.4492147672334, 218, 13, 'PPL', 'P'),
(31971, 'Carlton', 38.6872215270996, 0.675219394096317, -97.2930603027344, -1.69808424162411, 218, 20, 'PPL', 'P'),
(39651, 'Carlton', 32.5372200012207, 0.567881618467055, -92.3594436645508, -1.61197638725663, 218, 22, 'PPL', 'P'),
(72017, 'Carlton', 38.9636116027832, 0.680043310936832, -82.0986099243164, -1.43289105448981, 218, 41, 'PPL', 'P'),
(75336, 'Carlton', 36.0144386291504, 0.628570532336107, -98.5149993896484, -1.71941110194957, 218, 42, 'PPL', 'P'),
(85555, 'Carlton', 35.8244400024414, 0.625254430725768, -84.0261077880859, -1.46653223853775, 218, 50, 'PPL', 'P'),
(93060, 'Carlton', 31.9180603027344, 0.557075243132813, -98.1716690063477, -1.71341885633884, 218, 51, 'PPL', 'P'),
(130084, 'Carlton', 42.7266693115234, 0.745721057896903, -85.2513885498047, -1.48791742209109, 218, 27, 'PPL', 'P'),
(134567, 'Carlton', 46.663890838623, 0.81443853692519, -92.4247207641602, -1.61311568757096, 218, 28, 'PPL', 'P'),
(147600, 'Carlton', 43.3277816772461, 0.756212447853215, -78.1911087036133, -1.36469229266285, 218, 40, 'PPL', 'P'),
(159820, 'Carlton', 41.4761085510254, 0.723894655129968, -80.0199966430664, -1.39661240885632, 218, 45, 'PPL', 'P'),
(180535, 'Carlton', 33.9019393920898, 0.591700465203533, -117.836387634277, -2.05663294287447, 218, 6, 'PPL', 'P'),
(186494, 'Carlton', 38.0847206115723, 0.664703769374084, -102.419166564941, -1.78755167370672, 218, 7, 'PPL', 'P'),
(196157, 'Carlton', 46.6758308410645, 0.814646929280489, -114.077781677246, -1.9910328936392, 218, 31, 'PPL', 'P'),
(200524, 'Carlton', 45.2944412231445, 0.79053713219492, -123.175277709961, -2.1498141530972, 218, 43, 'PPL', 'P'),
(206967, 'Carlton', 48.2483291625977, 0.842092202473328, -120.11499786377, -2.09640219374873, 218, 56, 'PPL', 'P'),
(169972, 'Carlton (historical)', 44.7222213745117, 0.780550011791014, -97.8249969482422, -1.70736828750023, 218, 49, 'PPL', 'P'),
(100505, 'Carlton Corner', 37.7299995422363, 0.658512718787977, -76.8330612182617, -1.34098989264503, 218, 53, 'PPL', 'P'),
(77971, 'Carlton Heights', 39.9249992370605, 0.696822690542931, -77.7555618286133, -1.35709056564732, 218, 45, 'PPL', 'P'),
(144945, 'Carlton Hill', 40.8463897705078, 0.712903989048292, -74.1111068725586, -1.29348282722355, 218, 37, 'PPL', 'P'),
(180536, 'Carlton Hills', 32.8527793884277, 0.573389168759393, -116.99388885498, -2.04192856523171, 218, 6, 'PPL', 'P'),
(114834, 'Carlton Mobile Home Court', 42.0499992370605, 0.73391093714781, -91.4680633544922, -1.59641886595866, 218, 16, 'PPL', 'P'),
(100518, 'Carlton Park', 37.3063888549805, 0.651119317548727, -80.0341720581055, -1.39685981652159, 218, 53, 'PPL', 'P'),
(203286, 'Carlton Towers Condominium', 40.773609161377, 0.711633727787352, -111.880561828613, -1.95268417289039, 218, 52, 'PPL', 'P'),
(15437, 'Carlton Village', 28.9322204589844, 0.504962506922142, -81.8855590820313, -1.42917261581779, 218, 12, 'PPL', 'P'),
(177850, 'Carlton Vista', 33.7033309936523, 0.588234094728685, -109.152496337891, -1.90507044786724, 218, 5, 'PPL', 'P'),
(72018, 'Carlwick (historical)', 39.9166717529297, 0.69667734852644, -81.9013900756836, -1.42944891878089, 218, 41, 'PPL', 'P'),
(26707, 'Carlyle', 38.610279083252, 0.673876495116644, -89.3724975585938, -1.55984434312805, 218, 18, 'PPL', 'P'),
(31972, 'Carlyle', 37.9936103820801, 0.663113595887198, -95.3905563354492, -1.66487928336273, 218, 20, 'PPL', 'P'),
(196158, 'Carlyle', 46.6549987792969, 0.814283341212666, -104.075561523438, -1.81646121944591, 218, 31, 'PPL', 'P'),
(100507, 'Carlyle Station', 38.7991714477539, 0.677173288809081, -77.5144424438477, -1.35288223849278, 218, 53, 'PPL', 'P'),
(206969, 'Carlyon Beach', 47.1797218322754, 0.823441486148258, -122.938606262207, -2.14568345708843, 218, 56, 'PPL', 'P'),
(39652, 'Carlyss', 30.1686096191406, 0.526541568602836, -93.3758316040039, -1.62971570327765, 218, 22, 'PPL', 'P'),
(100508, 'Carma Heights', 37.1652793884277, 0.648656492751648, -80.4372177124023, -1.40389429022492, 218, 53, 'PPL', 'P'),
(35148, 'Carmack', 37.0180587768555, 0.646087008352913, -88.1158294677734, -1.53791134733849, 218, 21, 'PPL', 'P'),
(58890, 'Carmack', 33.2402801513672, 0.580152332926677, -89.6624984741211, -1.5649058139378, 218, 30, 'PPL', 'P'),
(139070, 'Carmack', 40.2408294677734, 0.702334967946204, -94.4258270263672, -1.64804158052875, 218, 29, 'PPL', 'P'),
(45405, 'Carmae Acres', 39.3794403076172, 0.687300890960489, -76.9958267211914, -1.34383068657982, 218, 25, 'PPL', 'P'),
(119037, 'Carman', 40.7405586242676, 0.711056887095241, -91.059440612793, -1.58928705371748, 218, 18, 'PPL', 'P'),
(147602, 'Carman', 42.7705612182617, 0.746487116184464, -73.9338912963867, -1.29038983193353, 218, 40, 'PPL', 'P'),
(154607, 'Carman', 40.357780456543, 0.704376147763695, -80.8811111450195, -1.41164169215207, 218, 41, 'PPL', 'P'),
(159818, 'Carman', 41.3658294677734, 0.72196992203114, -78.8247222900391, -1.37575093593135, 218, 45, 'PPL', 'P'),
(85556, 'Carman (historical)', 35.6711082458496, 0.622578286725375, -86.0091705322266, -1.50114321269664, 218, 50, 'PPL', 'P'),
(190006, 'Carman Heights', 38.8375015258789, 0.677842274874909, -119.508056640625, -2.08580907103878, 218, 39, 'PPL', 'P'),
(199219, 'Carmans Mobile Park', 40.5125007629395, 0.707076526530008, -101.640556335449, -1.77396236161237, 218, 35, 'PPL', 'P'),
(70616, 'Carmantown', 39.5091705322266, 0.689565110519274, -74.6944427490234, -1.30366395891286, 218, 37, 'PPL', 'P'),
(7911, 'Carmel', 33.5447196960449, 0.585465805354575, -92.0713882446289, -1.60694887175078, 218, 4, 'PPL', 'P'),
(19787, 'Carmel', 33.1722183227539, 0.578964429922447, -84.5374984741211, -1.4754576897731, 218, 13, 'PPL', 'P'),
(29394, 'Carmel', 39.978328704834, 0.697753465343913, -86.1180572509766, -1.50304364445052, 218, 19, 'PPL', 'P'),
(39653, 'Carmel', 32.0872192382813, 0.560027623517275, -93.6205596923828, -1.63398701419197, 218, 22, 'PPL', 'P'),
(70617, 'Carmel', 39.4341697692871, 0.688256100264473, -75.1216735839844, -1.31112054364898, 218, 37, 'PPL', 'P'),
(72019, 'Carmel', 39.1669387817383, 0.68359203966839, -83.408332824707, -1.4557500313904, 218, 41, 'PPL', 'P'),
(100509, 'Carmel', 38.8269386291504, 0.677657917548448, -78.432502746582, -1.36890541350735, 218, 53, 'PPL', 'P'),
(108499, 'Carmel', 39.3305587768555, 0.686447747305282, -79.5547180175781, -1.38849176490239, 218, 58, 'PPL', 'P'),
(114836, 'Carmel', 43.1277809143066, 0.752721776033421, -96.2350006103516, -1.67961761630939, 218, 16, 'PPL', 'P'),
(134570, 'Carmel', 48.2816696166992, 0.84267410317151, -95.4441680908203, -1.66581498501172, 218, 28, 'PPL', 'P'),
(147608, 'Carmel', 41.4300003051758, 0.723089914427573, -73.6805572509766, -1.28596831873372, 218, 40, 'PPL', 'P'),
(173437, 'Carmel', 44.4458312988281, 0.775726094950498, -88.7980575561523, -1.54981847373029, 218, 57, 'PPL', 'P'),
(177341, 'Carmel', 44.7975006103516, 0.781863882314804, -69.0516662597656, -1.20517893022119, 218, 26, 'PPL', 'P'),
(122321, 'Carmel (historical)', 41.4805603027344, 0.723972352854771, -86.404167175293, -1.50803720465247, 218, 19, 'PPL', 'P'),
(39654, 'Carmel Acres', 30.5450000762939, 0.533110821353249, -91.0808334350586, -1.58966042890231, 218, 22, 'PPL', 'P'),
(19788, 'Carmel Chase', 33.7155609130859, 0.588447547090055, -84.7022171020508, -1.47833257216984, 218, 13, 'PPL', 'P'),
(203287, 'Carmel Cove', 40.6158294677734, 0.708879952641183, -111.875556945801, -1.95259682120663, 218, 52, 'PPL', 'P'),
(19789, 'Carmel East', 33.9222183227539, 0.592054399312404, -83.975830078125, -1.46565472695857, 218, 13, 'PPL', 'P'),
(19790, 'Carmel Farms', 33.7138900756836, 0.588418385476119, -84.6977767944336, -1.47825507418211, 218, 13, 'PPL', 'P'),
(180537, 'Carmel Highlands', 36.5041694641113, 0.637117947854717, -121.930557250977, -2.12808968282099, 218, 6, 'PPL', 'P'),
(147603, 'Carmel Hills', 41.4044418334961, 0.722643834944985, -73.6711120605469, -1.28580346906225, 218, 40, 'PPL', 'P'),
(147604, 'Carmel Park Estates', 41.4919395446777, 0.724170958093063, -73.7352828979492, -1.28692346145868, 218, 40, 'PPL', 'P'),
(180538, 'Carmel Valley', 36.4797210693359, 0.636691242869059, -121.731391906738, -2.12461359180816, 218, 6, 'PPL', 'P'),
(180539, 'Carmel Valley Manor', 36.5316696166992, 0.637597916062176, -121.824996948242, -2.12624730797887, 218, 6, 'PPL', 'P'),
(180540, 'Carmel Valley Village', 36.4861106872559, 0.636802762739706, -121.722778320313, -2.12446325636463, 218, 6, 'PPL', 'P'),
(180541, 'Carmel-by-the-Sea', 36.5552787780762, 0.638009973661839, -121.922218322754, -2.12794414106741, 218, 6, 'PPL', 'P'),
(19791, 'Carmell Mobile Home Park', 33.4480590820313, 0.583778759383037, -82.0608291625977, -1.43223165580391, 218, 13, 'PPL', 'P'),
(1362, 'Carmen', 31.6322193145752, 0.552086376752281, -86.1891708374023, -1.50428481067655, 218, 2, 'PPL', 'P'),
(63446, 'Carmen', 36.0047187805176, 0.628400888974669, -82.64111328125, -1.44235952427143, 218, 33, 'PPL', 'P'),
(75339, 'Carmen', 36.5788917541504, 0.638422097840529, -98.4619369506836, -1.71848498768049, 218, 42, 'PPL', 'P'),
(177851, 'Carmen', 31.5872192382813, 0.551300977257303, -111.052223205566, -1.93822693659679, 218, 5, 'PPL', 'P'),
(194695, 'Carmen', 45.2425003051758, 0.789630592159857, -113.892501831055, -1.98779915028558, 218, 17, 'PPL', 'P'),
(180542, 'Carmen City', 38.0475006103516, 0.664054157805187, -120.689720153809, -2.10643298999452, 218, 6, 'PPL', 'P'),
(39656, 'Carmenia (historical)', 31.2544403076172, 0.545492889235949, -93.5577774047852, -1.63289125656146, 218, 22, 'PPL', 'P'),
(180543, 'Carmenita', 33.8913917541504, 0.591516374193181, -118.045280456543, -2.06027881040679, 218, 6, 'PPL', 'P'),
(144946, 'Carmerville', 40.1769409179688, 0.701219902397788, -74.1294403076172, -1.29380280602852, 218, 37, 'PPL', 'P'),
(180544, 'Carmet', 38.374439239502, 0.669760313335818, -123.07527923584, -2.14806885047682, 218, 6, 'PPL', 'P'),
(7912, 'Carmi', 35.8886108398438, 0.626374423122201, -90.273063659668, -1.57556218672365, 218, 4, 'PPL', 'P'),
(26709, 'Carmi', 38.0908317565918, 0.664810428975742, -88.1586074829102, -1.53865796455009, 218, 18, 'PPL', 'P'),
(58891, 'Carmich', 31.3838901519775, 0.547752215236232, -89.9850006103516, -1.57053453805974, 218, 30, 'PPL', 'P'),
(45406, 'Carmichael', 38.9422187805176, 0.679669935752003, -76.1338882446289, -1.32878702221418, 218, 25, 'PPL', 'P'),
(58893, 'Carmichael', 32.0697212219238, 0.55972222551927, -90.5313873291016, -1.5800707852911, 218, 30, 'PPL', 'P'),
(180545, 'Carmichael', 38.6172218322754, 0.673997668946243, -121.327217102051, -2.11755941071276, 218, 6, 'PPL', 'P'),
(19792, 'Carmichael Crossroads', 34.2122192382813, 0.597115870122154, -84.3966674804688, -1.47299972524501, 218, 13, 'PPL', 'P'),
(80155, 'Carmichael Crossroads', 34.4636116027832, 0.601503494597087, -79.2877807617188, -1.38383283089141, 218, 48, 'PPL', 'P'),
(147606, 'Carmichael Hill', 43.339168548584, 0.756411186249563, -75.3383331298828, -1.31490196608078, 218, 40, 'PPL', 'P'),
(77972, 'Carmichaels', 39.896671295166, 0.696328274686557, -79.9747161865234, -1.39582211580284, 218, 45, 'PPL', 'P'),
(206970, 'Carmill Station', 47.202220916748, 0.82383416925099, -123.088890075684, -2.14830640444605, 218, 56, 'PPL', 'P'),
(93061, 'Carmine', 30.149169921875, 0.52620228187996, -96.6858291625977, -1.68748605890808, 218, 51, 'PPL', 'P'),
(134571, 'Carmody', 45.651668548584, 0.796771925201931, -93.4711074829102, -1.63137858106229, 218, 28, 'PPL', 'P'),
(45407, 'Carmody Hills', 38.8963890075684, 0.678870055318597, -76.8952789306641, -1.34207579657951, 218, 25, 'PPL', 'P'),
(93062, 'Carmona', 30.9899997711182, 0.540877531198301, -94.9563903808594, -1.65730165795507, 218, 51, 'PPL', 'P'),
(159819, 'Carmona', 41.1222190856934, 0.717718118771801, -80.1030578613281, -1.3980621005957, 218, 45, 'PPL', 'P'),
(72021, 'Carmonte', 39.7236099243164, 0.693307783957217, -84.1966705322266, -1.46950912000424, 218, 41, 'PPL', 'P'),
(63447, 'Carmur', 35.5522193908691, 0.620503284762039, -76.1902770996094, -1.32977119339502, 218, 33, 'PPL', 'P'),
(180546, 'Carnadero', 36.976390838623, 0.645359765638239, -121.542221069336, -2.12131193784674, 218, 6, 'PPL', 'P'),
(200525, 'Carnahan', 46.1005592346191, 0.804606545654781, -123.915832519531, -2.16273927281568, 218, 43, 'PPL', 'P'),
(114837, 'Carnarvon', 42.2536087036133, 0.737464592727385, -95.0213928222656, -1.65843616457944, 218, 16, 'PPL', 'P'),
(200526, 'Carnation', 45.5077781677246, 0.794260564293987, -123.101387023926, -2.14852451733933, 218, 43, 'PPL', 'P'),
(206971, 'Carnation', 47.6480598449707, 0.831615526482038, -121.912780761719, -2.12777942455399, 218, 56, 'PPL', 'P'),
(188243, 'Carne', 32.2880592346191, 0.563532942723064, -107.570831298828, -1.87746518527192, 218, 38, 'PPL', 'P'),
(19793, 'Carne (historical)', 32.3213882446289, 0.564114643684165, -83.2766723632813, -1.45345212284383, 218, 13, 'PPL', 'P'),
(19794, 'Carnegie', 31.6427803039551, 0.552270700789228, -84.779167175293, -1.47967560430756, 218, 13, 'PPL', 'P'),
(75340, 'Carnegie', 35.1036109924316, 0.612673591157206, -98.6033325195313, -1.72095280590462, 218, 42, 'PPL', 'P'),
(85558, 'Carnegie', 36.3280601501465, 0.634044260482602, -82.3413925170898, -1.43712841010024, 218, 50, 'PPL', 'P'),
(113282, 'Carnegie', 40.4086112976074, 0.705263313301828, -80.083610534668, -1.39772268071477, 218, 45, 'PPL', 'P'),
(147607, 'Carnegie', 42.7472190856934, 0.746079719116709, -78.8455581665039, -1.3761145905782, 218, 40, 'PPL', 'P'),
(173438, 'Carnegie', 46.6333312988281, 0.813905172337875, -92.192497253418, -1.60906262270797, 218, 57, 'PPL', 'P'),
(19795, 'Carnegie Place', 33.5083312988281, 0.584830708013619, -84.4274978637695, -1.47353781694326, 218, 13, 'PPL', 'P'),
(31974, 'Carneiro', 38.7388916015625, 0.676121207020445, -98.0305633544922, -1.71095609812079, 218, 20, 'PPL', 'P'),
(180548, 'Carnelian Bay', 39.2269401550293, 0.684639261188036, -120.080833435059, -2.09580591198067, 218, 6, 'PPL', 'P'),
(180549, 'Carnelian Heights', 39.2097206115723, 0.684338723459021, -120.100563049316, -2.09615025870961, 218, 6, 'PPL', 'P'),
(134572, 'Carnelian Junction', 45.1247215270996, 0.787574964693452, -92.8300018310547, -1.62018917658427, 218, 28, 'PPL', 'P'),
(188244, 'Carnero', 34.6241683959961, 0.604305739275096, -105.386390686035, -1.8393395042644, 218, 38, 'PPL', 'P'),
(180550, 'Carneros (historical)', 38.2286109924316, 0.667215130282029, -122.308326721191, -2.13468300388975, 218, 6, 'PPL', 'P'),
(690, 'Carnes', 30.9933300018311, 0.540935654689092, -89.2597198486328, -1.55787600076638, 218, 30, 'PPL', 'P'),
(93063, 'Carnes', 34.3994407653809, 0.600383502200654, -99.7377777099609, -1.74075260966103, 218, 51, 'PPL', 'P'),
(114838, 'Carnes', 42.9272193908691, 0.749221317096621, -96.0566711425781, -1.67650517994341, 218, 16, 'PPL', 'P'),
(19799, 'Carnes Creek', 34.5372200012207, 0.602788203506941, -83.32861328125, -1.45435866287889, 218, 13, 'PPL', 'P'),
(80156, 'Carnes Crossroad', 33.0633316040039, 0.577063998168566, -80.0933303833008, -1.39789232407621, 218, 48, 'PPL', 'P'),
(15438, 'Carnestown', 25.9105606079102, 0.452224593645576, -81.3644409179688, -1.42007738806295, 218, 12, 'PPL', 'P'),
(19796, 'Carnesville', 34.3697204589844, 0.599864784999334, -83.2352828979492, -1.45272974039814, 218, 13, 'PPL', 'P'),
(1363, 'Carney', 30.9272193908691, 0.539781806857302, -87.7191696166992, -1.53098832692677, 218, 2, 'PPL', 'P'),
(39658, 'Carney', 30.8458309173584, 0.538361310021367, -91.3019409179688, -1.59351948247989, 218, 22, 'PPL', 'P'),
(45408, 'Carney', 39.3941688537598, 0.687557952584708, -76.5238876342773, -1.33559379564431, 218, 25, 'PPL', 'P'),
(75341, 'Carney', 35.8083305358887, 0.624973267493683, -97.0124969482422, -1.69318748732778, 218, 42, 'PPL', 'P'),
(114840, 'Carney', 41.6883316040039, 0.727598646153077, -93.6002807617188, -1.6336330800831, 218, 16, 'PPL', 'P'),
(130087, 'Carney', 45.586669921875, 0.795637485156585, -87.5572204589844, -1.52816178090382, 218, 27, 'PPL', 'P'),
(159822, 'Carney', 40.3063888549805, 0.703479195108556, -79.4472198486328, -1.38661556791443, 218, 45, 'PPL', 'P'),
(196159, 'Carney', 45.7652816772461, 0.798754848370577, -110.123062133789, -1.92201001661291, 218, 31, 'PPL', 'P'),
(108500, 'Carney (historical)', 38.5508308410645, 0.67283892755595, -81.5861129760742, -1.42394629533656, 218, 58, 'PPL', 'P'),
(45409, 'Carney Grove', 39.394718170166, 0.687567539964633, -76.5102767944336, -1.33535624167508, 218, 25, 'PPL', 'P'),
(70618, 'Carneys Point', 39.711109161377, 0.693089604484912, -75.4705581665039, -1.31720972832339, 218, 37, 'PPL', 'P'),
(114841, 'Carnforth', 41.7222213745117, 0.728190134231184, -92.3494415283203, -1.61180181704717, 218, 16, 'PPL', 'P'),
(7916, 'Carnie (historical)', 33.1191711425781, 0.578038581969481, -92.9427795410156, -1.62215751894595, 218, 4, 'PPL', 'P'),
(19797, 'Carnigan', 31.4341697692871, 0.548629760104926, -81.394172668457, -1.42059630500135, 218, 13, 'PPL', 'P'),
(7914, 'Carnis', 35.2480583190918, 0.61519467260313, -94.2027816772461, -1.64414870480533, 218, 4, 'PPL', 'P'),
(100510, 'Carnot', 37.0416717529297, 0.646499132531603, -81.0963897705078, -1.41539901297601, 218, 53, 'PPL', 'P'),
(159824, 'Carnot', 40.5169410705566, 0.707154024517729, -80.2216720581055, -1.40013230886908, 218, 45, 'PPL', 'P'),
(173439, 'Carnot', 44.7050018310547, 0.780249474061998, -87.4186096191406, -1.52574256536959, 218, 57, 'PPL', 'P'),
(1364, 'Carns', 34.8091697692871, 0.607534622359735, -85.9741668701172, -1.50053228354257, 218, 2, 'PPL', 'P'),
(141437, 'Carns (historical)', 42.7347183227539, 0.745861539644404, -99.4819412231445, -1.73628742061935, 218, 35, 'PPL', 'P'),
(53864, 'Carns Ford', 37.5636100769043, 0.6556086747773, -93.6983337402344, -1.63534442739958, 218, 29, 'PPL', 'P'),
(19798, 'Carns Mill', 34.5258293151855, 0.602589398531567, -84.5086135864258, -1.47495355337874, 218, 13, 'PPL', 'P'),
(85559, 'Carnsville (historical)', 36.1147193908691, 0.630320761804507, -88.336669921875, -1.54176574038416, 218, 50, 'PPL', 'P'),
(85560, 'Carnton Plantation', 35.9030609130859, 0.626626624477431, -86.8583297729492, -1.51596383732098, 218, 50, 'PPL', 'P'),
(35150, 'Carntown', 38.8380584716797, 0.677851995412887, -84.2411117553711, -1.47028476567173, 218, 21, 'PPL', 'P'),
(188245, 'Carnuel', 35.0638885498047, 0.611980303746432, -106.456672668457, -1.85801944878243, 218, 38, 'PPL', 'P'),
(159823, 'Carnwath', 40.8633308410645, 0.713199666508318, -78.5124969482422, -1.37030157570883, 218, 45, 'PPL', 'P'),
(93064, 'Caro', 31.7549991607666, 0.554229289323413, -94.7055587768555, -1.65292382059714, 218, 51, 'PPL', 'P'),
(130088, 'Caro', 43.4911117553711, 0.759063095484036, -83.3969421386719, -1.45555122641503, 218, 27, 'PPL', 'P'),
(211721, 'Caro', 67.1675033569336, 1.17229408392284, -148.019714355469, -2.58343137336445, 218, 1, 'PPL', 'P'),
(1371, 'Caro (historical)', 34.9394416809082, 0.60980829614039, -86.8116683959961, -1.51514944265964, 218, 2, 'PPL', 'P'),
(177370, 'Caroga Lake', 43.1377792358398, 0.752896279663849, -74.4816665649414, -1.2999503139308, 218, 40, 'PPL', 'P'),
(173440, 'Carol Beach', 42.5122184753418, 0.741978184721878, -87.8091735839844, -1.53255919249576, 218, 57, 'PPL', 'P'),
(15439, 'Carol City', 25.9402809143066, 0.452743310846896, -80.2458267211914, -1.40055388726964, 218, 12, 'PPL', 'P'),
(93065, 'Carol Colonia', 26.318000793457, 0.459335766388305, -98.3580017089844, -1.71667097550399, 218, 51, 'PPL', 'P'),
(45410, 'Carol Court', 38.3672218322754, 0.669634345816257, -76.4388885498047, -1.33411028175909, 218, 25, 'PPL', 'P'),
(77974, 'Carol Heights', 39.9358291625977, 0.697011708401299, -76.6416702270508, -1.33764948968975, 218, 45, 'PPL', 'P'),
(100511, 'Carol Heights', 37.3005599975586, 0.651017584795086, -79.9816665649414, -1.39594342279049, 218, 53, 'PPL', 'P'),
(119039, 'Carol Stream', 41.9124984741211, 0.731511096110512, -88.1347198486328, -1.53824104668144, 218, 18, 'PPL', 'P'),
(19812, 'Carol Woods', 33.5916709899902, 0.586285260021993, -84.3230590820313, -1.47171501633515, 218, 13, 'PPL', 'P'),
(53865, 'Carola', 36.5516700744629, 0.637946989902058, -90.3358306884766, -1.57665767803805, 218, 29, 'PPL', 'P'),
(7915, 'Carolan', 35.0936088562012, 0.612499020947752, -93.9791717529297, -1.64024597538587, 218, 4, 'PPL', 'P'),
(100512, 'Carolandville', 38.5094413757324, 0.672116545110266, -77.7980575561523, -1.35783225601091, 218, 53, 'PPL', 'P'),
(100513, 'Carolanne Farms', 36.8286094665527, 0.642780494122498, -76.1763916015625, -1.32952884573582, 218, 53, 'PPL', 'P'),
(45411, 'Carole Acres', 39.0697212219238, 0.681895273158873, -76.9958267211914, -1.34383068657982, 218, 25, 'PPL', 'P'),
(45412, 'Carole Highlands', 38.9813919067383, 0.680353635782853, -76.9836120605469, -1.34361750053456, 218, 25, 'PPL', 'P'),
(63448, 'Caroleen', 35.2808303833008, 0.615766653026252, -81.79638671875, -1.42761626447675, 218, 33, 'PPL', 'P'),
(1366, 'Carolina', 31.2405605316162, 0.545250641445293, -86.5277786254883, -1.51019463145154, 218, 2, 'PPL', 'P'),
(39659, 'Carolina', 32.1958312988281, 0.561923261581193, -92.9375, -1.62206537357223, 218, 22, 'PPL', 'P'),
(58894, 'Carolina', 34.1183280944824, 0.595477160524401, -88.4819412231445, -1.54430120289997, 218, 30, 'PPL', 'P'),
(63449, 'Carolina', 36.1316719055176, 0.630616639001615, -79.4127807617188, -1.3860144924564, 218, 33, 'PPL', 'P'),
(80158, 'Carolina', 34.5744400024414, 0.603437815075839, -79.4383316040039, -1.38646043878094, 218, 48, 'PPL', 'P'),
(93066, 'Carolina', 30.7936096191406, 0.537449876427801, -95.3966674804688, -1.66498594296438, 218, 51, 'PPL', 'P'),
(108502, 'Carolina', 39.480281829834, 0.689060907545895, -80.2736129760742, -1.40103884890414, 218, 58, 'PPL', 'P'),
(169303, 'Carolina', 41.4569396972656, 0.723560095518026, -71.6638870239258, -1.25077078334475, 218, 47, 'PPL', 'P'),
(19800, 'Carolina (historical)', 33.9916687011719, 0.593266537082554, -84.1530609130859, -1.4687479885647, 218, 13, 'PPL', 'P'),
(80157, 'Carolina Acres', 34.2216682434082, 0.597280786372657, -79.7477798461914, -1.39186132947162, 218, 48, 'PPL', 'P'),
(63451, 'Carolina Beach', 34.0349998474121, 0.594022808253109, -77.8938903808594, -1.35950485433354, 218, 33, 'PPL', 'P'),
(63452, 'Carolina City', 34.7247200012207, 0.606060695854431, -76.7399978637695, -1.33936563069619, 218, 33, 'PPL', 'P'),
(63453, 'Carolina Country', 34.7666702270508, 0.606792865417121, -77.3300018310547, -1.34966314252515, 218, 33, 'PPL', 'P'),
(63470, 'Carolina Dunes', 36.1908302307129, 0.631649146556239, -75.7608337402344, -1.3222759928231, 218, 33, 'PPL', 'P'),
(63454, 'Carolina Forest', 35.3616714477539, 0.617177595771776, -80.0519409179688, -1.39716994163053, 218, 33, 'PPL', 'P'),
(63455, 'Carolina Heights', 35.5936088562012, 0.621225667207723, -77.3916702270508, -1.3507394590797, 218, 33, 'PPL', 'P'),
(80160, 'Carolina Heights', 34.8111114501953, 0.607568511084606, -82.45361328125, -1.43908703192394, 218, 48, 'PPL', 'P'),
(45413, 'Carolina Hills', 39.2833290100098, 0.685623432368875, -77.3597183227539, -1.35018179314744, 218, 25, 'PPL', 'P'),
(100514, 'Carolina Junction', 36.815559387207, 0.642552727270269, -76.2602767944336, -1.33099291854509, 218, 53, 'PPL', 'P'),
(80163, 'Carolina Mobile Home Park', 33.9652786254883, 0.592805943372025, -80.4944381713867, -1.4048929756337, 218, 48, 'PPL', 'P'),
(63456, 'Carolina Mountains', 35.4494400024414, 0.618709446030789, -82.1722183227539, -1.43417576339967, 218, 33, 'PPL', 'P'),
(63460, 'Carolina Pines', 35.7483291625977, 0.623926045974036, -78.658332824707, -1.37284689192067, 218, 33, 'PPL', 'P'),
(63462, 'Carolina Shores', 36.1041717529297, 0.630136670794156, -76.2430572509766, -1.33069238081608, 218, 33, 'PPL', 'P'),
(63463, 'Carolina Trace', 35.4130592346191, 0.618074481847887, -79.1116714477539, -1.38075914351929, 218, 33, 'PPL', 'P'),
(39660, 'Caroline', 30.0725002288818, 0.524864143300736, -91.6666717529297, -1.59988523643351, 218, 22, 'PPL', 'P'),
(113233, 'Caroline', 41.0522193908691, 0.716496393621727, -82.8936080932617, -1.44676639008524, 218, 41, 'PPL', 'P'),
(147610, 'Caroline', 42.3783302307129, 0.739641394023388, -76.2958297729492, -1.33161343507908, 218, 40, 'PPL', 'P'),
(173441, 'Caroline', 44.7208290100098, 0.780525710446067, -88.8913879394531, -1.55144739621103, 218, 57, 'PPL', 'P'),
(45414, 'Caroline Acres Mobile Home Park', 39.0686111450195, 0.681875898661943, -75.772216796875, -1.32247466464042, 218, 25, 'PPL', 'P'),
(147611, 'Caroline Center', 42.3519401550293, 0.739180800312859, -76.3188934326172, -1.33201597187785, 218, 40, 'PPL', 'P'),
(147614, 'Caroline Depot', 42.3699989318848, 0.73949598542787, -76.4038925170898, -1.33349948576308, 218, 40, 'PPL', 'P'),
(19801, 'Caroline Park', 32.5144386291504, 0.567484008516306, -84.976936340332, -1.48312732739641, 218, 13, 'PPL', 'P'),
(100516, 'Caroline Pines', 37.896110534668, 0.661411902529665, -77.4361114501953, -1.35151510474719, 218, 53, 'PPL', 'P'),
(196160, 'Carols Court', 46.8819389343262, 0.818244194122913, -113.893058776855, -1.98780887082355, 218, 31, 'PPL', 'P'),
(100517, 'Carolyn Heights', 37.207218170166, 0.649388462577257, -80.0111083984375, -1.39645727972282, 218, 53, 'PPL', 'P'),
(80166, 'Caromi Village', 33.0016708374023, 0.575987814772065, -80.084716796875, -1.39774198863268, 218, 48, 'PPL', 'P'),
(31976, 'Carona', 37.2802810668945, 0.650663650686214, -94.8683319091797, -1.65576474768998, 218, 20, 'PPL', 'P'),
(53866, 'Carondelet', 38.5561103820801, 0.672931072929666, -90.2658309936523, -1.57543595288798, 218, 29, 'PPL', 'P'),
(80167, 'Caropine', 33.6111106872559, 0.586624546744869, -78.9897232055664, -1.3786307451761, 218, 48, 'PPL', 'P'),
(63467, 'Carosel Apartments', 35.2924995422363, 0.615970318270615, -81.5550003051758, -1.4234032767903, 218, 33, 'PPL', 'P'),
(194696, 'Carothers Place (historical)', 42.8836097717285, 0.748460185657077, -116.431938171387, -2.03212067556916, 218, 17, 'PPL', 'P'),
(13489, 'Carousel Knoll', 39.7291717529297, 0.69340485617895, -75.6750030517578, -1.32077796470993, 218, 10, 'PPL', 'P'),
(80168, 'Carowood', 35.0591697692871, 0.611897945489721, -80.9761123657227, -1.41329977624676, 218, 48, 'PPL', 'P'),
(29395, 'Carp', 39.3849983215332, 0.687397896603195, -86.7608337402344, -1.51426221054248, 218, 19, 'PPL', 'P'),
(134573, 'Carp', 48.5052795410156, 0.846576832590967, -94.6469421386719, -1.65190076726439, 218, 28, 'PPL', 'P'),
(190007, 'Carp', 37.1119384765625, 0.647725518213584, -114.491943359375, -1.99826137862795, 218, 39, 'PPL', 'P'),
(130089, 'Carp Lake', 45.6972198486328, 0.797566945366347, -84.75, -1.47916654106519, 218, 27, 'PPL', 'P'),
(130090, 'Carp Lake Landing', 46.8302803039551, 0.817342580935867, -89.7163925170898, -1.56584644243482, 218, 27, 'PPL', 'P'),
(1370, 'Carpenter', 31.541389465332, 0.550501096823898, -88.2363891601563, -1.54001551091576, 218, 2, 'PPL', 'P'),
(7918, 'Carpenter', 33.4105606079102, 0.58312428754515, -91.8499984741211, -1.60308489132518, 218, 4, 'PPL', 'P'),
(13490, 'Carpenter', 39.8183288574219, 0.694960941203884, -75.4647216796875, -1.31710786241169, 218, 10, 'PPL', 'P'),
(26711, 'Carpenter', 38.8919410705566, 0.678792424172822, -89.894172668457, -1.56894929142087, 218, 18, 'PPL', 'P'),
(35151, 'Carpenter', 36.7158317565918, 0.64081215176082, -83.9713897705078, -1.46557722897085, 218, 21, 'PPL', 'P'),
(58895, 'Carpenter', 32.0338897705078, 0.559096848716292, -90.6802825927734, -1.5826694978828, 218, 30, 'PPL', 'P'),
(63468, 'Carpenter', 35.8205604553223, 0.625186719855053, -78.871940612793, -1.37657505113067, 218, 33, 'PPL', 'P'),
(72022, 'Carpenter', 39.1627807617188, 0.683519468528685, -82.2194366455078, -1.43499987859899, 218, 41, 'PPL', 'P'),
(75342, 'Carpenter', 35.5302810668945, 0.620120388776313, -99.3713912963867, -1.73435796040958, 218, 42, 'PPL', 'P'),
(93067, 'Carpenter', 29.378059387207, 0.51274386415319, -98.184440612793, -1.71364176292208, 218, 51, 'PPL', 'P'),
(114842, 'Carpenter', 43.4150009155273, 0.757734710732305, -93.0147171020508, -1.62341306624186, 218, 16, 'PPL', 'P'),
(159825, 'Carpenter', 40.0522193908691, 0.699043101101784, -75.2005615234375, -1.31249739793255, 218, 45, 'PPL', 'P'),
(169975, 'Carpenter', 44.6375007629395, 0.779071358174774, -97.916389465332, -1.70896338783513, 218, 49, 'PPL', 'P'),
(180551, 'Carpenter', 37.6133308410645, 0.656476465818503, -122.043327331543, -2.13005789202461, 218, 6, 'PPL', 'P'),
(196161, 'Carpenter', 45.8913917541504, 0.8009558844325, -111.463607788086, -1.94540695205369, 218, 31, 'PPL', 'P'),
(209356, 'Carpenter', 41.0455589294434, 0.716380146640145, -104.366111755371, -1.82153227763558, 218, 59, 'PPL', 'P'),
(85562, 'Carpenter Addition', 36.045280456543, 0.62910882377144, -83.8102798461914, -1.46276533033389, 218, 50, 'PPL', 'P'),
(45416, 'Carpenter Beach', 38.6049995422363, 0.673784349742928, -76.5147171020508, -1.3354337396628, 218, 25, 'PPL', 'P'),
(63469, 'Carpenter Bottom', 36.0825004577637, 0.629758435340337, -81.9963912963867, -1.43110700287557, 218, 33, 'PPL', 'P'),
(159826, 'Carpenter Hollow', 41.5480613708496, 0.725150468741995, -75.8169403076172, -1.32325523715592, 218, 45, 'PPL', 'P'),
(130093, 'Carpenter Landing', 46.2897186279297, 0.807907999879125, -85.7577819824219, -1.49675565480073, 218, 27, 'PPL', 'P'),
(180552, 'Carpenter Place', 39.7347183227539, 0.693501662084575, -122.928611755371, -2.14550902003703, 218, 6, 'PPL', 'P'),
(45417, 'Carpenter Point', 39.5441703796387, 0.690175973094311, -76.0069427490234, -1.32657140534529, 218, 25, 'PPL', 'P'),
(159827, 'Carpenter Town', 41.561939239502, 0.725392683243137, -75.7091674804688, -1.321374246478, 218, 45, 'PPL', 'P'),
(85564, 'Carpenters (historical)', 35.9769401550293, 0.62791606049822, -86.7766723632813, -1.51453864666363, 218, 50, 'PPL', 'P'),
(93068, 'Carpenters Bluff', 33.7544403076172, 0.589126120535807, -96.4127807617188, -1.68272046529544, 218, 51, 'PPL', 'P'),
(13491, 'Carpenters Corner', 38.7425003051758, 0.676184190780225, -75.1505584716797, -1.31162468004333, 218, 10, 'PPL', 'P'),
(134575, 'Carpenters Corner', 48.1580581665039, 0.840516676372437, -96.4372177124023, -1.68314697054402, 218, 28, 'PPL', 'P'),
(169304, 'Carpenters Corner', 41.8216705322266, 0.729925849471643, -71.3566665649414, -1.24540877480598, 218, 47, 'PPL', 'P'),
(147615, 'Carpenters Corners', 43.2186088562012, 0.754307022672291, -74.1544418334961, -1.29423916497313, 218, 40, 'PPL', 'P'),
(154611, 'Carpenters Corners', 40.6730613708496, 0.709878837787044, -83.2319412231445, -1.45267141717027, 218, 41, 'PPL', 'P'),
(29396, 'Carpentersville', 39.8055610656738, 0.694738101199671, -86.8055572509766, -1.51504278305798, 218, 19, 'PPL', 'P'),
(119041, 'Carpentersville', 42.1211090087891, 0.735152036794814, -88.2577819824219, -1.54038888610059, 218, 18, 'PPL', 'P'),
(144947, 'Carpentersville', 40.6358299255371, 0.709229026481065, -75.1888885498047, -1.31229366610916, 218, 37, 'PPL', 'P'),
(159828, 'Carpentertown', 40.1852798461914, 0.70136544415136, -79.5166702270508, -1.38782770568458, 218, 45, 'PPL', 'P'),
(200527, 'Carpenterville', 42.2202796936035, 0.736882891766284, -124.338333129883, -2.170113299558, 218, 43, 'PPL', 'P'),
(196162, 'Carperville (historical)', 45.8547210693359, 0.800315860243527, -107.611106872559, -1.87816812664165, 218, 31, 'PPL', 'P'),
(180553, 'Carpinteria', 34.3988914489746, 0.60037391482073, -119.517501831055, -2.08597392071026, 218, 6, 'PPL', 'P'),
(198088, 'Carpio', 48.4425010681152, 0.845481141539481, -101.714172363281, -1.77524720368028, 218, 34, 'PPL', 'P'),
(100519, 'Carps Corner', 37.523609161377, 0.654910527097536, -77.0091705322266, -1.34406358001715, 218, 53, 'PPL', 'P'),
(180554, 'Carquinez Heights', 38.0763893127441, 0.664558360778566, -122.238891601563, -2.13347113243571, 218, 6, 'PPL', 'P'),
(63471, 'Carr', 36.2113914489746, 0.632008007513127, -79.2202835083008, -1.38265478158321, 218, 33, 'PPL', 'P'),
(93069, 'Carr', 28.735559463501, 0.501530125040707, -96.7547225952148, -1.68868847614025, 218, 51, 'PPL', 'P'),
(130094, 'Carr', 43.8736114501953, 0.765738974546592, -86.038330078125, -1.50165214278095, 218, 27, 'PPL', 'P'),
(180555, 'Carr', 34.9311103820801, 0.609662887544872, -120.510833740234, -2.10331083309056, 218, 6, 'PPL', 'P'),
(194136, 'Carr', 40.896110534668, 0.713771780089495, -104.874443054199, -1.83040433249107, 218, 7, 'PPL', 'P'),
(7920, 'Carr (historical)', 35.6902809143066, 0.622912912916343, -90.5177764892578, -1.57983323132186, 218, 4, 'PPL', 'P'),
(85565, 'Carr Branch', 36.389720916748, 0.635120443879103, -83.7077789306641, -1.46097635187163, 218, 50, 'PPL', 'P'),
(127042, 'Carr Corner', 45.0283317565918, 0.785892645832849, -69.2375030517578, -1.2084223941128, 218, 26, 'PPL', 'P'),
(19802, 'Carr Corners (historical)', 32.9186096191406, 0.57453812303268, -83.2236099243164, -1.45252600857475, 218, 13, 'PPL', 'P'),
(35152, 'Carr Creek', 37.2311096191406, 0.649805447024936, -82.9680633544922, -1.44806587953914, 218, 21, 'PPL', 'P'),
(53868, 'Carr Lane', 36.5077781677246, 0.637180931614497, -93.565559387207, -1.63302707777705, 218, 29, 'PPL', 'P'),
(1372, 'Carr Mill', 33.2052803039551, 0.57954147035164, -85.9438934326172, -1.5000039123823, 218, 2, 'PPL', 'P'),
(196163, 'Carr Trailer Court', 45.6361083984375, 0.796500349349771, -109.244720458984, -1.90668006243009, 218, 31, 'PPL', 'P'),
(127043, 'Carrabassett', 45.0777816772461, 0.786755709763116, -70.2125015258789, -1.22543932768813, 218, 26, 'PPL', 'P'),
(15442, 'Carrabelle', 29.8530597686768, 0.521034184758066, -84.664436340332, -1.47767317348393, 218, 12, 'PPL', 'P'),
(15440, 'Carrabelle Beach', 29.8319396972656, 0.520665569973686, -84.6841735839844, -1.47801765337093, 218, 12, 'PPL', 'P'),
(15441, 'Carrabelle Lighthouse', 29.827220916748, 0.520583211716975, -84.7011108398438, -1.47831326425193, 218, 12, 'PPL', 'P'),
(186495, 'Carracas', 37.0050010681152, 0.645859108342629, -107.258056640625, -1.87200623766947, 218, 7, 'PPL', 'P'),
(188246, 'Carracas', 36.9986114501953, 0.645747588471982, -107.244438171387, -1.87176855054219, 218, 38, 'PPL', 'P'),
(190008, 'Carrara (historical)', 36.8008308410645, 0.642295665646049, -116.711387634277, -2.03699798878954, 218, 39, 'PPL', 'P'),
(15443, 'Carraway', 29.708890914917, 0.518517963581132, -81.7866668701172, -1.42744662111531, 218, 12, 'PPL', 'P'),
(63474, 'Carrboro', 35.9099998474121, 0.626747731728003, -79.0755615234375, -1.38012890644733, 218, 33, 'PPL', 'P'),
(13492, 'Carrcroft', 39.7874984741211, 0.694422849505633, -75.5063934326172, -1.31783517170539, 218, 10, 'PPL', 'P'),
(13493, 'Carrcroft Crest', 39.7916717529297, 0.694495686961447, -75.5041732788086, -1.31779642271153, 218, 10, 'PPL', 'P'),
(19803, 'Carrefour Place', 33.8694381713867, 0.591133211891346, -84.1516723632813, -1.46872375379878, 218, 13, 'PPL', 'P'),
(93070, 'Carretas Crossing', 26.0194396972656, 0.454124892241402, -97.2916717529297, -1.69806000685819, 218, 51, 'PPL', 'P'),
(186496, 'Carriage Club', 39.5325012207031, 0.689972307849947, -104.90055847168, -1.83086013251164, 218, 7, 'PPL', 'P'),
(203294, 'Carriage Crossing Condominium', 40.8822212219238, 0.71352936585127, -111.881393432617, -1.95269868711833, 218, 52, 'PPL', 'P'),
(29398, 'Carriage Estates', 39.7374992370605, 0.693550198195441, -85.8938903808594, -1.49913119449308, 218, 19, 'PPL', 'P'),
(45418, 'Carriage Hill', 39.1041717529297, 0.682496548353986, -76.883056640625, -1.3418624773762, 218, 25, 'PPL', 'P'),
(85568, 'Carriage Hill', 35.1116714477539, 0.61281427264179, -85.3480606079102, -1.48960466779971, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(100520, 'Carriage Hill', 37.1191711425781, 0.647851752049254, -76.5369415283203, -1.33582162907557, 218, 53, 'PPL', 'P'),
(100522, 'Carriage Hill Estates', 38.6572189331055, 0.67469575004698, -77.3997192382813, -1.35087994082721, 218, 53, 'PPL', 'P'),
(45419, 'Carriage Hill Village', 39.353328704834, 0.686845157518949, -76.8127822875977, -1.34063595853616, 218, 25, 'PPL', 'P'),
(1374, 'Carriage Hills', 33.7202796936035, 0.588529905346766, -86.6527786254883, -1.51237629301654, 218, 2, 'PPL', 'P'),
(19807, 'Carriage Hills', 33.9352798461914, 0.592282365901715, -83.352783203125, -1.45478050759556, 218, 13, 'PPL', 'P'),
(45423, 'Carriage Hills', 39.1713905334473, 0.683669737393193, -76.8613891601563, -1.34148430850141, 218, 25, 'PPL', 'P'),
(85566, 'Carriage Hills', 35.2508316040039, 0.615243075555942, -84.7908325195313, -1.4798792029729, 218, 50, 'PPL', 'P'),
(141438, 'Carriage House Estates', 41.4416694641113, 0.723293579671937, -97.3324966430664, -1.69877253560784, 218, 35, 'PPL', 'P'),
(19808, 'Carriage Lakes', 34.0305595397949, 0.593945310265388, -84.4069366455078, -1.47317895598637, 218, 13, 'PPL', 'P'),
(13494, 'Carriage Lane', 39.1094398498535, 0.682588493990621, -75.523063659668, -1.31812612205448, 218, 10, 'PPL', 'P'),
(119042, 'Carriage Lane Estates', 41.0955581665039, 0.717252797950337, -88.8238906860352, -1.55026934690284, 218, 18, 'PPL', 'P'),
(39662, 'Carriage Oaks', 32.5677795410156, 0.56841498305437, -93.6505584716797, -1.63451059166228, 218, 22, 'PPL', 'P'),
(114843, 'Carriage Place', 41.5905609130859, 0.725892225684609, -90.4266662597656, -1.57824305783498, 218, 16, 'PPL', 'P'),
(80169, 'Carriage Run', 33.5577812194824, 0.585693771943886, -79.070556640625, -1.38004155476357, 218, 48, 'PPL', 'P'),
(203299, 'Carriage Square', 40.6811103820801, 0.710019319534546, -111.940002441406, -1.95372160729303, 218, 52, 'PPL', 'P'),
(159829, 'Carriage Stop', 40.0991706848145, 0.699862555769202, -74.932502746582, -1.30781888968755, 218, 45, 'PPL', 'P'),
(19809, 'Carriage Trace', 33.5794410705566, 0.586071807660623, -84.2302780151367, -1.47009568123433, 218, 13, 'PPL', 'P'),
(93071, 'Carricitos', 26.0450000762939, 0.454571005013504, -97.7094421386719, -1.70535147560671, 218, 51, 'PPL', 'P'),
(93072, 'Carricitos-Landrum Colonia', 26.0440006256104, 0.454553561308364, -97.7030029296875, -1.70523909020871, 218, 51, 'PPL', 'P'),
(159830, 'Carrick', 40.3963890075684, 0.705049994098512, -79.9905624389648, -1.39609868508204, 218, 45, 'PPL', 'P'),
(193432, 'Carrick', 41.4474983215332, 0.723395312425578, -122.362777709961, -2.13563335292475, 218, 6, 'PPL', 'P'),
(159831, 'Carrick Valley', 40.0597190856934, 0.699173995469362, -77.8655624389648, -1.35901043847716, 218, 45, 'PPL', 'P'),
(100523, 'Carrico', 38.4672203063965, 0.671379648436641, -77.8597183227539, -1.35890843940741, 218, 53, 'PPL', 'P'),
(100524, 'Carrico Mill', 36.7211112976074, 0.640904297134537, -82.5358276367188, -1.44052194311927, 218, 53, 'PPL', 'P'),
(45424, 'Carrico Mill Estates', 38.5002784729004, 0.671956622286806, -76.8050003051758, -1.34050013732057, 218, 25, 'PPL', 'P'),
(35153, 'Carrie', 37.3316688537598, 0.651560536762325, -83.0327835083008, -1.4491954593155, 218, 21, 'PPL', 'P'),
(100525, 'Carrie', 37.0322189331055, 0.646334149702072, -82.206672668457, -1.43477710517381, 218, 53, 'PPL', 'P'),
(75343, 'Carrier', 36.4769401550293, 0.636642706758192, -98.0219421386719, -1.7108056295192, 218, 42, 'PPL', 'P'),
(26712, 'Carrier Mills', 37.6841697692871, 0.657712838354572, -88.6327819824219, -1.54693387079557, 218, 18, 'PPL', 'P'),
(58897, 'Carriere', 30.6166706085205, 0.534361708117259, -89.6524963378906, -1.56473124372835, 218, 30, 'PPL', 'P'),
(194697, 'Carrietown', 43.6049995422363, 0.761050812342644, -114.699440002441, -2.0018828782363, 218, 17, 'PPL', 'P'),
(45425, 'Carrington', 38.6027793884277, 0.673745600749067, -76.9191665649414, -1.34249271444816, 218, 25, 'PPL', 'P'),
(53867, 'Carrington', 38.8080596923828, 0.677328417942578, -92.059440612793, -1.60674034623742, 218, 29, 'PPL', 'P'),
(72024, 'Carrington', 39.5961112976074, 0.691082513129374, -82.1650009155273, -1.43404979588011, 218, 41, 'PPL', 'P'),
(100526, 'Carrington', 36.8811111450195, 0.643696821274567, -78.8361129760742, -1.37594974090672, 218, 53, 'PPL', 'P'),
(139764, 'Carrington', 47.4497184753418, 0.828153816539098, -99.1258316040039, -1.73007213526732, 218, 34, 'PPL', 'P'),
(19810, 'Carrington Chase', 33.8977813720703, 0.591627894063828, -84.7594375610352, -1.47933125757862, 218, 13, 'PPL', 'P'),
(80170, 'Carris', 33.5122184753418, 0.584898552042389, -79.8294372558594, -1.39328652012897, 218, 48, 'PPL', 'P'),
(127045, 'Carriveau Mill', 47.2161102294922, 0.824076583489214, -68.3686065673828, -1.19325728960145, 218, 26, 'PPL', 'P'),
(177852, 'Carrizo', 33.9938888549805, 0.593305286076414, -110.288063049316, -1.92488982585767, 218, 5, 'PPL', 'P'),
(188247, 'Carrizo', 33.2836112976074, 0.580908604097232, -105.706390380859, -1.84492455254446, 218, 38, 'PPL', 'P'),
(93073, 'Carrizo Hill', 28.5033302307129, 0.497476960309175, -99.8291702270508, -1.74234770999593, 218, 51, 'PPL', 'P'),
(93075, 'Carrizo Hills Colonia', 28.5009994506836, 0.497436280523524, -99.8300018310547, -1.74236222422387, 218, 51, 'PPL', 'P'),
(93074, 'Carrizo Springs', 28.5216693878174, 0.497797038982689, -99.8602828979492, -1.7428907285422, 218, 51, 'PPL', 'P'),
(186497, 'Carrizo Springs', 37.1636085510254, 0.648627331137712, -103.034439086914, -1.79829020501219, 218, 7, 'PPL', 'P'),
(188248, 'Carrizozo', 33.6416702270508, 0.587157911332184, -105.876670837402, -1.84789650716293, 218, 38, 'PPL', 'P'),
(7921, 'Carrol Corner', 35.7286109924316, 0.623581898982171, -90.1786117553711, -1.57391369000889, 218, 4, 'PPL', 'P'),
(53870, 'Carrol Junction', 37.7386093139648, 0.658662987652485, -92.6016693115234, -1.61620402232907, 218, 29, 'PPL', 'P'),
(100527, 'Carrol Mill', 36.6758308410645, 0.640114004081056, -83.2622222900391, -1.45319992148859, 218, 53, 'PPL', 'P'),
(39663, 'Carroll', 32.0786094665527, 0.559877354652767, -93.3913879394531, -1.62998721255078, 218, 22, 'PPL', 'P'),
(45426, 'Carroll', 39.2808303833008, 0.685579823106025, -76.6722183227539, -1.33818265453998, 218, 25, 'PPL', 'P'),
(63476, 'Carroll', 34.9519386291504, 0.610026409033668, -78.0763931274414, -1.36269012815533, 218, 33, 'PPL', 'P'),
(72025, 'Carroll', 39.7988891601563, 0.694621654481007, -82.7011108398438, -1.44340667921205, 218, 41, 'PPL', 'P'),
(85569, 'Carroll', 35.7183303833008, 0.623402468503727, -88.8199996948242, -1.55020143629504, 218, 50, 'PPL', 'P'),
(93076, 'Carroll', 32.4772186279297, 0.566834396947408, -95.5199966430664, -1.66713844291544, 218, 51, 'PPL', 'P'),
(114844, 'Carroll', 42.0658302307129, 0.734187240110906, -94.8666687011719, -1.6557357192341, 218, 16, 'PPL', 'P'),
(127046, 'Carroll', 45.4144401550293, 0.792631508655185, -68.0386123657227, -1.18749780426999, 218, 26, 'PPL', 'P'),
(141439, 'Carroll', 42.2761116027832, 0.737857342409144, -97.1888885498047, -1.69626610154791, 218, 35, 'PPL', 'P'),
(143591, 'Carroll', 44.2983283996582, 0.773151683703746, -71.5411071777344, -1.24862787077361, 218, 36, 'PPL', 'P'),
(147616, 'Carroll', 42.0063896179199, 0.733149805708265, -78.3280563354492, -1.36708247974119, 218, 40, 'PPL', 'P'),
(177405, 'Carroll', 41.0486106872559, 0.716433409861947, -77.2099990844727, -1.34756869948586, 218, 45, 'PPL', 'P'),
(39664, 'Carroll (historical)', 32.8875007629395, 0.573995171065441, -92.504997253418, -1.61451677662045, 218, 22, 'PPL', 'P'),
(190009, 'Carroll (historical)', 39.2622184753418, 0.685254984032062, -117.717781066895, -2.05456286775915, 218, 39, 'PPL', 'P'),
(196164, 'Carroll (historical)', 47.5736083984375, 0.830316103607161, -108.372779846191, -1.89146182785499, 218, 31, 'PPL', 'P'),
(200528, 'Carroll (historical)', 44.6536102294922, 0.779352521406859, -118.349998474121, -2.06559714310368, 218, 43, 'PPL', 'P'),
(114845, 'Carroll Community Estates', 42.0625, 0.734129116620115, -94.8522186279297, -1.65548351787887, 218, 16, 'PPL', 'P'),
(177579, 'Carroll Corners', 41.9263916015625, 0.731753576927764, -72.7655563354492, -1.26999854009901, 218, 8, 'PPL', 'P'),
(45428, 'Carroll County Trails', 39.5224990844727, 0.689797737640492, -76.9086074829102, -1.34230842370073, 218, 25, 'PPL', 'P'),
(1379, 'Carroll Crossroads', 34.3666687011719, 0.599811521777533, -87.583610534668, -1.52862237461435, 218, 2, 'PPL', 'P'),
(45447, 'Carroll Dale', 39.4169387817383, 0.687955362798376, -76.9186096191406, -1.34248299391019, 218, 25, 'PPL', 'P'),
(45430, 'Carroll Heights', 39.3930587768555, 0.687538578087778, -77.1536102294922, -1.34658452830502, 218, 25, 'PPL', 'P'),
(45432, 'Carroll Highlands', 39.3872184753418, 0.687436645597055, -76.9175033569336, -1.34246368599228, 218, 25, 'PPL', 'P'),
(45433, 'Carroll Island', 39.3344383239746, 0.686515458175997, -76.3944396972656, -1.33333450293355, 218, 25, 'PPL', 'P'),
(45434, 'Carroll Knolls', 39.023609161377, 0.681090465877451, -77.0500030517578, -1.34477624192485, 218, 25, 'PPL', 'P'),
(45437, 'Carroll Manor', 38.980281829834, 0.680334261285923, -77.0047225952148, -1.34398594887137, 218, 25, 'PPL', 'P'),
(159832, 'Carroll Manor', 40.1341705322266, 0.700473418344238, -77.0124969482422, -1.34412163692891, 218, 45, 'PPL', 'P'),
(45438, 'Carroll Manor Ridge', 39.5097198486328, 0.689574697899198, -76.503059387207, -1.33523027415552, 218, 25, 'PPL', 'P'),
(45439, 'Carroll Meadows', 39.5069389343262, 0.689526161788331, -76.498893737793, -1.33515756985776, 218, 25, 'PPL', 'P'),
(45441, 'Carroll Park', 39.4536094665527, 0.688595386987349, -76.9974975585938, -1.34385984819376, 218, 25, 'PPL', 'P'),
(77975, 'Carroll Park', 39.9708290100098, 0.697622570976336, -75.2369384765625, -1.31313229553642, 218, 45, 'PPL', 'P'),
(45442, 'Carroll Square', 39.4119415283203, 0.687868144272675, -76.9622192382813, -1.34324412534973, 218, 25, 'PPL', 'P'),
(77978, 'Carroll Valley', 39.7491683959961, 0.693753863439805, -77.3833312988281, -1.35059391732613, 218, 45, 'PPL', 'P'),
(45443, 'Carroll View', 39.6263885498047, 0.691610950868673, -77.2586135864258, -1.34841718260915, 218, 25, 'PPL', 'P'),
(45444, 'Carroll Winde', 39.4638900756836, 0.688774817465793, -76.9530563354492, -1.34308420252627, 218, 25, 'PPL', 'P'),
(45445, 'Carroll Woods Estates', 39.4272193908691, 0.68813479327682, -77.1097183227539, -1.34581847001746, 218, 25, 'PPL', 'P'),
(19815, 'Carrolls', 33.0122184753418, 0.576171905782417, -84.5661087036133, -1.47595703247749, 218, 13, 'PPL', 'P'),
(206972, 'Carrolls', 46.0716705322266, 0.804102342681402, -122.861106872559, -2.14433083757078, 218, 56, 'PPL', 'P'),
(13052, 'Carrollsburg (historical)', 38.875560760498, 0.678506533829802, -77.0069427490234, -1.34402469786523, 218, 9, 'PPL', 'P'),
(1380, 'Carrollton', 33.2616691589355, 0.580525641532478, -88.0950012207031, -1.53754782584969, 218, 2, 'PPL', 'P'),
(19816, 'Carrollton', 33.5800018310547, 0.586081594777629, -85.0766677856445, -1.48486796948489, 218, 13, 'PPL', 'P'),
(26716, 'Carrollton', 39.3022193908691, 0.685953131711827, -90.4069366455078, -1.57789871110603, 218, 18, 'PPL', 'P'),
(35155, 'Carrollton', 38.6808280944824, 0.675107807646643, -85.179443359375, -1.48666174163711, 218, 21, 'PPL', 'P'),
(39665, 'Carrollton', 29.9472198486328, 0.52267758817724, -90.129997253418, -1.57306520688559, 218, 22, 'PPL', 'P'),
(45461, 'Carrollton', 39.5569381713867, 0.690398813098523, -76.9172210693359, -1.34245875914427, 218, 25, 'PPL', 'P'),
(53873, 'Carrollton', 39.3583297729492, 0.686932442623676, -93.4955596923828, -1.63180535262698, 218, 29, 'PPL', 'P'),
(58899, 'Carrollton', 33.5080604553223, 0.584825980902684, -89.920280456543, -1.56940495828338, 218, 30, 'PPL', 'P'),
(93077, 'Carrollton', 32.9536094665527, 0.575148985607717, -96.8899993896484, -1.69104950160466, 218, 51, 'PPL', 'P'),
(100529, 'Carrollton', 36.9466705322266, 0.644841048436919, -76.5608291625977, -1.33623854694422, 218, 53, 'PPL', 'P'),
(108504, 'Carrollton', 39.0902786254883, 0.682254067536734, -80.0872192382813, -1.39778566447455, 218, 58, 'PPL', 'P'),
(112223, 'Carrollton', 36.2625007629395, 0.632900033320249, -93.3216705322266, -1.62877041424872, 218, 4, 'PPL', 'P'),
(114850, 'Carrollton', 41.9497184753418, 0.73216070767941, -94.7477798461914, -1.65366071727077, 218, 16, 'PPL', 'P'),
(122323, 'Carrollton', 40.5177803039551, 0.707168671903725, -86.3919372558594, -1.5078237522911, 218, 19, 'PPL', 'P'),
(130095, 'Carrollton', 43.458610534668, 0.758495842171849, -83.9302825927734, -1.46485977337318, 218, 27, 'PPL', 'P'),
(147618, 'Carrollton', 42.1083297729492, 0.73492899705352, -78.6519393920898, -1.372735305471, 218, 40, 'PPL', 'P'),
(154614, 'Carrollton', 40.5727806091309, 0.708128608318644, -81.0858306884766, -1.41521472222858, 218, 41, 'PPL', 'P'),
(45449, 'Carrollton Manor', 39.0763893127441, 0.682011653298509, -76.5838928222656, -1.33664108374299, 218, 25, 'PPL', 'P'),
(159836, 'Carrolltown', 40.6027793884277, 0.708652185788954, -78.7088928222656, -1.37372933034787, 218, 45, 'PPL', 'P'),
(159837, 'Carrolltown Road', 40.5974998474121, 0.708560040415237, -78.7280578613281, -1.37406382338078, 218, 45, 'PPL', 'P'),
(45450, 'Carrolltowne', 39.3908309936523, 0.687499695935863, -76.9305572509766, -1.34269151942354, 218, 25, 'PPL', 'P'),
(173442, 'Carrollville', 42.8800010681152, 0.748397201897296, -87.8547210693359, -1.53335414608115, 218, 57, 'PPL', 'P'),
(85571, 'Carrollville (historical)', 35.3911094665527, 0.617691386125079, -87.977783203125, -1.53550198550029, 218, 50, 'PPL', 'P'),
(15444, 'Carrollwood', 28.0497207641602, 0.489559981599615, -82.4930572509766, -1.43977545906572, 218, 12, 'PPL', 'P'),
(39666, 'Carrollwood', 30.0755596160889, 0.524917539680593, -90.4955596923828, -1.57944547506715, 218, 22, 'PPL', 'P'),
(45451, 'Carrollwood', 39.3319396972656, 0.686471848913147, -76.3902816772461, -1.33326193179384, 218, 25, 'PPL', 'P'),
(45452, 'Carrollwood Manor', 39.329719543457, 0.686433099919286, -76.3841705322266, -1.33315527219218, 218, 25, 'PPL', 'P'),
(15445, 'Carrollwood Village', 28.0672206878662, 0.489865412887133, -82.521110534668, -1.44026508123213, 218, 12, 'PPL', 'P'),
(45453, 'Carrollyn Manor', 39.5986099243164, 0.691126122392224, -77.0388870239258, -1.34458223063944, 218, 25, 'PPL', 'P'),
(19817, 'Carrols Crossing', 34.0825004577637, 0.594851850300451, -84.0466690063477, -1.46689109949464, 218, 13, 'PPL', 'P'),
(180557, 'Carrolton', 37.7986106872559, 0.659710209172131, -121.06916809082, -2.11305560583527, 218, 6, 'PPL', 'P'),
(154615, 'Carrothers', 40.9980583190918, 0.715551104592804, -82.9222183227539, -1.44726573278963, 218, 41, 'PPL', 'P'),
(35156, 'Carrs', 38.6575012207031, 0.674700676894997, -83.4194412231445, -1.45594390951776, 218, 21, 'PPL', 'P'),
(190010, 'Carrs Camp (historical)', 37.2630615234375, 0.650363112957199, -116.925277709961, -2.04073107484755, 218, 39, 'PPL', 'P'),
(127048, 'Carrs Corner', 44.439998626709, 0.77562429561783, -69.4094390869141, -1.2114232440291, 218, 26, 'PPL', 'P'),
(144948, 'Carrs Corner', 40.2330589294434, 0.702199346467692, -74.3708267211914, -1.29801579371497, 218, 37, 'PPL', 'P'),
(206973, 'Carrs Corner', 48.1888885498047, 0.841054768070687, -117.879173278809, -2.05737969324413, 218, 56, 'PPL', 'P'),
(45454, 'Carrs Mill', 39.3147201538086, 0.686171311184131, -77.0527801513672, -1.34482471145669, 218, 25, 'PPL', 'P'),
(45455, 'Carrs Ridge', 38.8902816772461, 0.678763462295967, -76.5175018310547, -1.33548234235269, 218, 25, 'PPL', 'P'),
(45456, 'Carrs Store (historical)', 39.5672187805176, 0.690578243576967, -76.7777786254883, -1.3400250293821, 218, 25, 'PPL', 'P'),
(144949, 'Carrs Tavern', 40.1713905334473, 0.701123029913136, -74.4219436645508, -1.29890795268015, 218, 37, 'PPL', 'P'),
(100530, 'Carrsbrook', 38.0930595397949, 0.664849311127657, -78.4580612182617, -1.36935149298994, 218, 53, 'PPL', 'P'),
(35158, 'Carrsville', 37.3974990844727, 0.652709491035613, -88.3747177124023, -1.54242979960197, 218, 21, 'PPL', 'P'),
(100531, 'Carrsville', 36.711669921875, 0.640739514042088, -76.8263931274414, -1.3408735125054, 218, 53, 'PPL', 'P'),
(100532, 'Carruthers Corner', 38.2686080932617, 0.667913211382766, -77.0988922119141, -1.34562951873811, 218, 53, 'PPL', 'P'),
(1381, 'Carrville', 32.5497207641602, 0.568099797939359, -85.870002746582, -1.49871427662443, 218, 2, 'PPL', 'P'),
(114853, 'Carrville', 43.0088882446289, 0.750646707491059, -92.5747222900391, -1.61573370808057, 218, 16, 'PPL', 'P'),
(193433, 'Carrville', 41.064998626709, 0.716719433363022, -122.703056335449, -2.14157233531368, 218, 6, 'PPL', 'P'),
(7926, 'Carryville', 36.3422203063965, 0.634291401831761, -90.103889465332, -1.57260954002308, 218, 4, 'PPL', 'P'),
(72026, 'Cars Run (historical)', 39.0958290100098, 0.682350940021386, -82.8666687011719, -1.44629620899478, 218, 41, 'PPL', 'P'),
(45457, 'Carsan Knolls', 39.4213905334473, 0.688033060523179, -77.2058334350586, -1.3474959951881, 218, 25, 'PPL', 'P'),
(72027, 'Carsey Town', 39.2502784729004, 0.685046591676764, -82.0083312988281, -1.43131539523087, 218, 41, 'PPL', 'P'),
(45458, 'Carsin Vale', 39.5183296203613, 0.689724966763706, -76.2263870239258, -1.33040143046699, 218, 25, 'PPL', 'P'),
(45459, 'Carsins', 39.5372200012207, 0.690054666106658, -76.2127838134766, -1.33016400965581, 218, 25, 'PPL', 'P'),
(45460, 'Carsins Run', 39.545280456543, 0.690195347591241, -76.211669921875, -1.33014456857985, 218, 25, 'PPL', 'P'),
(45462, 'Carsins Run Estates', 39.538890838623, 0.690083827720594, -76.2077789306641, -1.33007665797205, 218, 25, 'PPL', 'P'),
(45463, 'Carsinwood', 39.5299987792969, 0.68992863200807, -76.2155609130859, -1.33021247918765, 218, 25, 'PPL', 'P'),
(100533, 'Carsley', 37.0955581665039, 0.647439627870564, -77.0061111450195, -1.34401018363729, 218, 53, 'PPL', 'P'),
(572, 'Carson', 30.7544403076172, 0.536766242975978, -93.3130569458008, -1.62862007880519, 218, 22, 'PPL', 'P'),
(1382, 'Carson', 31.4722194671631, 0.549293852612251, -87.9413909912109, -1.53486682158031, 218, 2, 'PPL', 'P'),
(35157, 'Carson', 38.6800003051758, 0.675093359997729, -84.9627838134766, -1.48288031920531, 218, 21, 'PPL', 'P'),
(58903, 'Carson', 31.5377807617188, 0.550438113064117, -89.7949981689453, -1.56721836987038, 218, 30, 'PPL', 'P'),
(75344, 'Carson', 35.165828704834, 0.613759495091686, -96.0883331298828, -1.6770577858696, 218, 42, 'PPL', 'P'),
(93078, 'Carson', 33.7019386291504, 0.588209793383738, -96.0055618286133, -1.67561315413629, 218, 51, 'PPL', 'P'),
(100534, 'Carson', 37.0352783203125, 0.646387546081928, -77.3955612182617, -1.3508073696875, 218, 53, 'PPL', 'P'),
(114851, 'Carson', 41.2366714477539, 0.719715689326442, -95.4177780151367, -1.6653543913012, 218, 16, 'PPL', 'P'),
(127049, 'Carson', 46.8436088562012, 0.817575208057085, -68.1347198486328, -1.18917519628258, 218, 26, 'PPL', 'P'),
(180558, 'Carson', 33.8313903808594, 0.590469152673535, -118.281112670898, -2.06439485902956, 218, 6, 'PPL', 'P'),
(188249, 'Carson', 36.3644409179688, 0.634679224665504, -105.764717102051, -1.84594254587114, 218, 38, 'PPL', 'P'),
(198092, 'Carson', 46.417781829834, 0.810143124403001, -101.564437866211, -1.77263384370259, 218, 34, 'PPL', 'P'),
(200529, 'Carson', 44.9358291625977, 0.784278171001015, -117.174438476563, -2.04507975059154, 218, 43, 'PPL', 'P'),
(206974, 'Carson', 45.7255592346191, 0.798061560959802, -121.818061828613, -2.12612626730733, 218, 56, 'PPL', 'P'),
(53875, 'Carson (historical)', 36.7097206115723, 0.640705492159162, -91.8030624389648, -1.60226570297387, 218, 29, 'PPL', 'P'),
(58901, 'Carson City', 31.3672199249268, 0.547461264887141, -88.6638870239258, -1.54747675618378, 218, 30, 'PPL', 'P'),
(130097, 'Carson City', 43.1769409179688, 0.753579779957618, -84.8463897705078, -1.4808488599258, 218, 27, 'PPL', 'P'),
(190011, 'Carson City', 39.163890838623, 0.683538843025615, -119.766387939453, -2.09031780276428, 218, 39, 'PPL', 'P'),
(200530, 'Carson Heights', 45.4580612182617, 0.793392839831812, -122.680000305176, -2.14116993167297, 218, 43, 'PPL', 'P'),
(180559, 'Carson Hill', 38.0283317565918, 0.663719598193246, -120.505561828613, -2.1032188208749, 218, 6, 'PPL', 'P'),
(190013, 'Carson Hot Springs', 39.1938896179199, 0.684062420495925, -119.751670837402, -2.09006094087715, 218, 39, 'PPL', 'P'),
(7927, 'Carson Lake', 35.6333312988281, 0.621918954618498, -90.0422210693359, -1.57153322346852, 218, 4, 'PPL', 'P'),
(63478, 'Carson Mill', 35.4022216796875, 0.617885330831464, -83.5311126708984, -1.45789294396153, 218, 33, 'PPL', 'P'),
(190015, 'Carson Rapids City', 39.3044395446777, 0.685991880705687, -119.555282592773, -2.08663331939616, 218, 39, 'PPL', 'P'),
(58902, 'Carson Ridge (historical)', 33.1041717529297, 0.577776793234326, -89.4319381713867, -1.5608817775307, 218, 30, 'PPL', 'P'),
(85572, 'Carson Springs', 35.9272193908691, 0.627048269457018, -83.2641677856445, -1.45323387679249, 218, 50, 'PPL', 'P'),
(45464, 'Carsondale', 38.9416694641113, 0.679660348372078, -76.853889465332, -1.34135341413383, 218, 25, 'PPL', 'P'),
(53877, 'Carsons Corner', 37.9083290100098, 0.661625155153953, -93.3008270263672, -1.62840662644382, 218, 29, 'PPL', 'P'),
(144950, 'Carsons Mills', 40.2169418334961, 0.701918050077552, -74.5602798461914, -1.30132237452441, 218, 37, 'PPL', 'P'),
(159841, 'Carsontown', 41.4077796936035, 0.72270209159383, -77.3330612182617, -1.349716538905, 218, 45, 'PPL', 'P'),
(19818, 'Carsonville', 32.7130584716797, 0.570950578728235, -84.2897186279297, -1.47113311563697, 218, 13, 'PPL', 'P'),
(100535, 'Carsonville', 36.6772193908691, 0.640138238846976, -81.0697174072266, -1.41493349241746, 218, 53, 'PPL', 'P'),
(130099, 'Carsonville', 43.4269409179688, 0.757943103087603, -82.67138671875, -1.4428878954317, 218, 27, 'PPL', 'P'),
(159839, 'Carsonville', 40.4841690063477, 0.706582044094608, -76.767219543457, -1.33984073863466, 218, 45, 'PPL', 'P'),
(108506, 'Carswell', 37.4394416809082, 0.653441527440248, -81.5088882446289, -1.42259846950888, 218, 58, 'PPL', 'P'),
(13496, 'Carsylian Acres', 38.7513885498047, 0.676339319913722, -75.2305603027344, -1.31302097540286, 218, 10, 'PPL', 'P'),
(191231, 'Carta Valley', 29.7933292388916, 0.519991690349355, -100.674438476563, -1.75710042401248, 218, 51, 'PPL', 'P'),
(180560, 'Cartago', 36.3208312988281, 0.633918093225959, -118.02555847168, -2.0599345968359, 218, 6, 'PPL', 'P'),
(39667, 'Carte Rouge', 29.7016696929932, 0.518391929482544, -90.9225006103516, -1.58689699979719, 218, 22, 'PPL', 'P'),
(19819, 'Cartecay', 34.6263885498047, 0.604344488268956, -84.3836135864258, -1.47277189181375, 218, 13, 'PPL', 'P'),
(35159, 'Carter', 38.4288902282715, 0.670710662370813, -83.1208267211914, -1.45073210326447, 218, 21, 'PPL', 'P'),
(58905, 'Carter', 32.9888916015625, 0.575764775030771, -90.4491729736328, -1.57863587409576, 218, 30, 'PPL', 'P'),
(63479, 'Carter', 36.3572196960449, 0.634553190566916, -76.6847229003906, -1.33840090059131, 218, 33, 'PPL', 'P'),
(75347, 'Carter', 35.2188911437988, 0.614685609360761, -99.5052795410156, -1.73669475110807, 218, 42, 'PPL', 'P'),
(85574, 'Carter', 36.0208282470703, 0.628682052206754, -83.7141723632813, -1.4610879383213, 218, 50, 'PPL', 'P'),
(93080, 'Carter', 32.9066696166992, 0.574329730677382, -97.7411117553711, -1.70590421469096, 218, 51, 'PPL', 'P'),
(108505, 'Carter', 38.8444404602051, 0.67796338212548, -80.2825012207031, -1.40119397803764, 218, 58, 'PPL', 'P'),
(159840, 'Carter', 41.1197204589844, 0.717674509508951, -80.0319366455078, -1.39682080121162, 218, 45, 'PPL', 'P'),
(173445, 'Carter', 46.228889465332, 0.806846330710565, -90.1302795410156, -1.57307013373361, 218, 57, 'PPL', 'P'),
(196165, 'Carter', 47.7811088562012, 0.833937669794532, -110.955558776855, -1.93653982404622, 218, 31, 'PPL', 'P'),
(201967, 'Carter', 43.3872184753418, 0.757249815676829, -100.202217102051, -1.74885860622896, 218, 49, 'PPL', 'P'),
(209357, 'Carter', 41.4377784729004, 0.72322566906414, -110.427780151367, -1.9273283493098, 218, 59, 'PPL', 'P'),
(7929, 'Carter (historical)', 35.9269409179688, 0.627043409188029, -94.0519409179688, -1.64151603690973, 218, 4, 'PPL', 'P'),
(72028, 'Carter (historical)', 39.5611114501953, 0.690471650554337, -81.2422180175781, -1.4179441960298, 218, 41, 'PPL', 'P'),
(19820, 'Carter Acres', 32.4080581665039, 0.56562731918333, -84.9663925170898, -1.48294330296509, 218, 13, 'PPL', 'P'),
(58906, 'Carter Branch', 34.6627807617188, 0.60497965218894, -88.164436340332, -1.53875969730373, 218, 30, 'PPL', 'P'),
(209358, 'Carter Cedars', 41.5180587768555, 0.724626824692658, -110.513061523438, -1.92881679004304, 218, 59, 'PPL', 'P'),
(85577, 'Carter Crossing', 36.2841682434082, 0.633278202195041, -82.4111099243164, -1.4383452084023, 218, 50, 'PPL', 'P'),
(85578, 'Carter Crossroads', 35.6691703796387, 0.622544464579531, -86.5252838134766, -1.51015108876772, 218, 50, 'PPL', 'P'),
(13501, 'Carter Development', 39.1197204589844, 0.682767924469065, -75.5302810668945, -1.31825208957405, 218, 10, 'PPL', 'P'),
(1383, 'Carter Grove', 34.9477806091309, 0.609953837893963, -86.6958312988281, -1.5131277039181, 218, 2, 'PPL', 'P'),
(100536, 'Carter Heights', 37.3019409179688, 0.651041686402951, -79.9341735839844, -1.3951145139012, 218, 53, 'PPL', 'P'),
(114854, 'Carter Lake', 41.2905616760254, 0.720656251244431, -95.9177780151367, -1.67408103756117, 218, 16, 'PPL', 'P'),
(80173, 'Carter Landing', 34.1458282470703, 0.595957128731861, -79.5438919067383, -1.38830281362305, 218, 48, 'PPL', 'P'),
(75349, 'Carter Nine', 36.7447204589844, 0.641316354734199, -96.6611099243164, -1.68705462681149, 218, 42, 'PPL', 'P'),
(93081, 'Carter Settlement', 30.2374992370605, 0.52774391925598, -94.9722213745117, -1.65757796091816, 218, 51, 'PPL', 'P'),
(1384, 'Carter Subdivision', 33.2158317565918, 0.579725627941019, -87.6013870239258, -1.52893263288134, 218, 2, 'PPL', 'P'),
(144951, 'Carteret', 40.577220916748, 0.708206106306365, -74.2286071777344, -1.29553359442096, 218, 37, 'PPL', 'P'),
(19821, 'Carters', 34.6088905334473, 0.604039090270951, -84.6930618286133, -1.47817278250443, 218, 13, 'PPL', 'P'),
(58907, 'Carters', 32.7608299255371, 0.571784347886511, -88.5619430541992, -1.5456974982595, 218, 30, 'PPL', 'P'),
(100537, 'Carters', 38.9655609130859, 0.680077332819758, -77.4944381713867, -1.35253309807387, 218, 53, 'PPL', 'P'),
(72029, 'Carters (historical)', 39.9394416809082, 0.697074758740107, -83.3630599975586, -1.45495987149497, 218, 41, 'PPL', 'P'),
(85580, 'Carters Chapel', 35.9244384765625, 0.626999733346151, -88.5749969482422, -1.54592533169076, 218, 50, 'PPL', 'P'),
(15446, 'Carters Corner', 28.0438899993896, 0.48945821555646, -81.8586120605469, -1.42870230156928, 218, 12, 'PPL', 'P'),
(75350, 'Carters Corner', 35.2894401550293, 0.615916921890759, -95.6627807617188, -1.66963049590548, 218, 42, 'PPL', 'P'),
(100538, 'Carters Corner', 38.0497207641602, 0.664092906799048, -77.2880630493164, -1.34893117269954, 218, 53, 'PPL', 'P'),
(85581, 'Carters Creek', 35.7172203063965, 0.623383094006797, -86.9947204589844, -1.51834430386135, 218, 50, 'PPL', 'P'),
(80175, 'Carters Crossroads', 33.6552810668945, 0.58739546530142, -79.3169403076172, -1.38434176097572, 218, 48, 'PPL', 'P'),
(19822, 'Carters Grove', 33.6933288574219, 0.588059524519231, -82.9433288574219, -1.44763418112644, 218, 13, 'PPL', 'P'),
(1386, 'Carters Hill', 32.1927795410156, 0.561869998359392, -86.1172180175781, -1.50302899706452, 218, 2, 'PPL', 'P'),
(75351, 'Carters Landing', 35.7972183227539, 0.624779322787298, -94.9036102294922, -1.65638047053401, 218, 42, 'PPL', 'P'),
(100539, 'Carters Mill', 36.6044387817383, 0.638867977586035, -80.4766693115234, -1.40458285052476, 218, 53, 'PPL', 'P'),
(45465, 'Carters Plains', 38.8125, 0.677405915930299, -76.0611114501953, -1.32751682753227, 218, 25, 'PPL', 'P'),
(100540, 'Carters Point', 36.6588897705078, 0.63981832662103, -78.6336135864258, -1.37241545982408, 218, 53, 'PPL', 'P'),
(100541, 'Carters Store', 38.1930618286133, 0.666594680327068, -77.470832824707, -1.35212110705324, 218, 53, 'PPL', 'P'),
(29412, 'Cartersburg', 39.6986083984375, 0.692871425012607, -86.4636077880859, -1.50907463905511, 218, 19, 'PPL', 'P'),
(1385, 'Cartersville', 34.7583312988281, 0.606647323663548, -85.6041717529297, -1.49407465053135, 218, 2, 'PPL', 'P'),
(19823, 'Cartersville', 34.1650009155273, 0.596291754922829, -84.8000030517578, -1.48003925895441, 218, 13, 'PPL', 'P'),
(35161, 'Cartersville', 37.5380592346191, 0.655162728452767, -84.4080581665039, -1.47319853022038, 218, 21, 'PPL', 'P'),
(63481, 'Cartersville', 34.7730598449707, 0.606904385287768, -77.9197235107422, -1.35995572750609, 218, 33, 'PPL', 'P'),
(75352, 'Cartersville', 35.2313919067383, 0.614903788833066, -94.8447189331055, -1.65535262351129, 218, 42, 'PPL', 'P'),
(80176, 'Cartersville', 34.086109161377, 0.594914834060231, -80.0288925170898, -1.39676767114787, 218, 48, 'PPL', 'P'),
(85583, 'Cartersville', 35.7211112976074, 0.623451004614594, -87.2455596923828, -1.52272227437733, 218, 50, 'PPL', 'P'),
(100543, 'Cartersville', 36.7275009155273, 0.641015817005184, -79.3841705322266, -1.38551514975201, 218, 53, 'PPL', 'P'),
(114855, 'Cartersville', 42.9944381713867, 0.750394506135828, -93.0827789306641, -1.62460096924609, 218, 16, 'PPL', 'P'),
(196167, 'Cartersville', 46.2994384765625, 0.808077643240563, -106.466941833496, -1.8581986795238, 218, 31, 'PPL', 'P'),
(100544, 'Carterton', 36.913330078125, 0.644259147738737, -82.2211074829102, -1.43502904021293, 218, 53, 'PPL', 'P'),
(85584, 'Cartertown', 35.7372207641602, 0.623732167846679, -83.4850006103516, -1.45708813668011, 218, 50, 'PPL', 'P'),
(26719, 'Carterville', 37.7599983215332, 0.659036296258287, -89.0772171020508, -1.55469072694459, 218, 18, 'PPL', 'P'),
(39668, 'Carterville', 32.9697189331055, 0.575430148839802, -93.5880584716797, -1.63341976087978, 218, 22, 'PPL', 'P'),
(53880, 'Carterville', 37.149169921875, 0.648375329519563, -94.4427795410156, -1.64833745772586, 218, 29, 'PPL', 'P'),
(58908, 'Carterville', 31.3197193145752, 0.546632222839799, -89.2461090087891, -1.55763844679714, 218, 30, 'PPL', 'P'),
(93083, 'Carterville', 32.6011085510254, 0.568996684015471, -94.5858306884766, -1.65083417124781, 218, 51, 'PPL', 'P'),
(124453, 'Carterville', 42.3883285522461, 0.739815897653816, -71.6458282470703, -1.25045559822973, 218, 23, 'PPL', 'P'),
(147620, 'Carterville', 43.3394393920898, 0.756415913360498, -75.8930587768555, -1.32458375506571, 218, 40, 'PPL', 'P'),
(186498, 'Carterville', 39.6308288574219, 0.691688448856394, -106.645561218262, -1.86131617589584, 218, 7, 'PPL', 'P'),
(201969, 'Carterville (historical)', 44.3375015258789, 0.773835383734597, -103.745826721191, -1.8107062614883, 218, 49, 'PPL', 'P'),
(201970, 'Cartesville (historical)', 44.3394393920898, 0.773869205880441, -103.756942749023, -1.81090027277372, 218, 49, 'PPL', 'P'),
(7932, 'Carthage', 34.0750007629395, 0.594720955932873, -92.5552825927734, -1.61539442135769, 218, 4, 'PPL', 'P'),
(29402, 'Carthage', 39.7383308410645, 0.693564712423382, -85.5719375610352, -1.49351205775107, 218, 19, 'PPL', 'P'),
(35162, 'Carthage', 38.9355583190918, 0.679553688770421, -84.3072204589844, -1.471438580214, 218, 21, 'PPL', 'P'),
(53881, 'Carthage', 37.1763916015625, 0.648850437458034, -94.3099975585938, -1.64601997494527, 218, 29, 'PPL', 'P'),
(58910, 'Carthage', 32.7324981689453, 0.571289865451111, -89.5361099243164, -1.56269991760689, 218, 30, 'PPL', 'P'),
(63482, 'Carthage', 35.3458290100098, 0.616901093071598, -79.4172210693359, -1.38609199044412, 218, 33, 'PPL', 'P'),
(72030, 'Carthage', 39.1969413757324, 0.684115683717727, -84.4791717529297, -1.47443969644641, 218, 41, 'PPL', 'P'),
(85585, 'Carthage', 36.2522201538086, 0.632720602841805, -85.9516677856445, -1.50013960043984, 218, 50, 'PPL', 'P'),
(93084, 'Carthage', 32.1572189331055, 0.561249348667349, -94.3372192382813, -1.64649508288374, 218, 51, 'PPL', 'P'),
(100545, 'Carthage', 36.9674987792969, 0.645204569925715, -80.4961090087891, -1.40492213724764, 218, 53, 'PPL', 'P'),
(119046, 'Carthage', 41.9188919067383, 0.731622682560187, -89.313606262207, -1.55881649610534, 218, 18, 'PPL', 'P'),
(127050, 'Carthage', 44.6241683959961, 0.778838664474529, -70.4736099243164, -1.22999652894547, 218, 26, 'PPL', 'P'),
(147621, 'Carthage', 43.9780616760254, 0.767561974891779, -75.6097183227539, -1.31963853123754, 218, 40, 'PPL', 'P'),
(169978, 'Carthage', 44.1711082458496, 0.770931273144893, -97.7161102294922, -1.70546785574635, 218, 49, 'PPL', 'P'),
(188250, 'Carthage', 33.8833312988281, 0.591375692708597, -106.658889770508, -1.86154880301706, 218, 38, 'PPL', 'P'),
(201971, 'Carthage (historical)', 44.3305587768555, 0.773714209904998, -103.808326721191, -1.8117970922708, 218, 49, 'PPL', 'P'),
(39669, 'Carthage Bluff Landing', 30.3077793121338, 0.528970537964557, -90.5877838134766, -1.58105508962999, 218, 22, 'PPL', 'P'),
(85586, 'Carthage Junction', 36.167781829834, 0.631246876073583, -85.913330078125, -1.49947048121596, 218, 50, 'PPL', 'P'),
(119047, 'Carthage Lake', 40.7905616760254, 0.71192960498446, -91.0752792358398, -1.58956348983863, 218, 18, 'PPL', 'P'),
(154617, 'Carthagena', 40.4366683959961, 0.705753002047266, -84.5599975585938, -1.47585037287583, 218, 41, 'PPL', 'P'),
(45466, 'Carthagena Creek', 38.1744384765625, 0.666269641516024, -76.4694366455078, -1.33464344660932, 218, 25, 'PPL', 'P'),
(72032, 'Carthon', 39.7488899230957, 0.693749003170816, -82.3319396972656, -1.43696342727071, 218, 41, 'PPL', 'P'),
(159842, 'Cartin', 40.5849990844727, 0.708341860942932, -76.8494415283203, -1.34127578298805, 218, 45, 'PPL', 'P'),
(80177, 'Cartley Subdivision', 33.9005584716797, 0.591676363595667, -80.4013900756836, -1.40326898000097, 218, 48, 'PPL', 'P'),
(53882, 'Cartmell (historical)', 36.8102798461914, 0.642460581896552, -94.2241668701172, -1.64452194683211, 218, 29, 'PPL', 'P'),
(7931, 'Cartney', 36.1944389343262, 0.631712130316019, -92.3822174072266, -1.61237386404932, 218, 4, 'PPL', 'P'),
(58911, 'Carto', 31.1211109161377, 0.543165852364952, -90.0780563354492, -1.57215866685053, 218, 30, 'PPL', 'P'),
(75353, 'Cartoco', 36.0872192382813, 0.629840793597048, -96.7138900756836, -1.68797581423255, 218, 42, 'PPL', 'P'),
(26720, 'Cartter', 38.5411109924316, 0.672669284194511, -88.9122161865234, -1.55181091769983, 218, 18, 'PPL', 'P'),
(39670, 'Cartville (historical)', 30.3341693878174, 0.529431131675086, -92.517219543457, -1.61473009582377, 218, 22, 'PPL', 'P'),
(80180, 'Cartwheel Landing', 34.0999984741211, 0.595157248298456, -79.2405624389648, -1.38300871569208, 218, 48, 'PPL', 'P'),
(1387, 'Cartwright', 34.8722190856934, 0.608635040522156, -87.0647201538086, -1.51956602901142, 218, 2, 'PPL', 'P'),
(35163, 'Cartwright', 36.7527809143066, 0.641457036218783, -85.0761108398438, -1.48485824894691, 218, 21, 'PPL', 'P'),
(39671, 'Cartwright', 32.4677810668945, 0.566669680433987, -92.4697189331055, -1.61390105377643, 218, 22, 'PPL', 'P'),
(75354, 'Cartwright', 33.8527793884277, 0.590842461279336, -96.5616683959961, -1.68531904472908, 218, 42, 'PPL', 'P'),
(85588, 'Cartwright', 36.3925018310547, 0.635168979989969, -85.870002746582, -1.49871427662443, 218, 50, 'PPL', 'P'),
(93086, 'Cartwright', 32.871940612793, 0.57372359521328, -95.3711090087891, -1.66453986348179, 218, 51, 'PPL', 'P'),
(159843, 'Cartwright', 41.2744407653809, 0.720374888275264, -78.7311096191406, -1.37411708660258, 218, 45, 'PPL', 'P'),
(177853, 'Cartwright', 33.4805603027344, 0.584346012695224, -112.186393737793, -1.95802194666324, 218, 5, 'PPL', 'P'),
(198095, 'Cartwright', 47.8597183227539, 0.835309663809114, -103.925827026367, -1.81384785946822, 218, 34, 'PPL', 'P'),
(159844, 'Cartwrights Crossing', 41.6683311462402, 0.727249572313195, -78.7494430541992, -1.37443706540756, 218, 45, 'PPL', 'P'),
(200531, 'Carus', 45.2713890075684, 0.790134795133236, -122.569442749023, -2.13924033830515, 218, 43, 'PPL', 'P'),
(19824, 'Caruso', 33.329719543457, 0.581713344799626, -84.2872161865234, -1.47108943979509, 218, 13, 'PPL', 'P'),
(187610, 'Caruso', 39.3386116027832, 0.686588295631811, -101.815002441406, -1.7770070205286, 218, 20, 'PPL', 'P'),
(53883, 'Caruth', 36.1341705322266, 0.630660248264465, -90.086669921875, -1.57230900229406, 218, 29, 'PPL', 'P'),
(180562, 'Caruthers', 36.542781829834, 0.637791860768561, -119.832221984863, -2.0914668236166, 218, 6, 'PPL', 'P'),
(93087, 'Caruthers Cove Colonia', 27.8439998626709, 0.485969474528456, -97.2220001220703, -1.69684400750446, 218, 51, 'PPL', 'P'),
(19825, 'Caruthers Mill', 33.8800010681152, 0.591317569217806, -83.5930633544922, -1.4589741873641, 218, 13, 'PPL', 'P'),
(53884, 'Caruthersville', 36.1930618286133, 0.631688095287181, -89.6555633544922, -1.56478477326626, 218, 29, 'PPL', 'P'),
(45467, 'Carvel Beach', 39.1650009155273, 0.683558217522546, -76.5352783203125, -1.33579260061969, 218, 25, 'PPL', 'P'),
(7934, 'Carver', 35.9861106872559, 0.628076116479734, -93.0416717529297, -1.62388351364843, 218, 4, 'PPL', 'P'),
(15447, 'Carver', 28.6569404602051, 0.500157964578558, -82.1025009155273, -1.43295896509761, 218, 12, 'PPL', 'P'),
(35164, 'Carver', 37.6411094665527, 0.656961294294952, -83.0502777099609, -1.44950079073447, 218, 21, 'PPL', 'P'),
(75355, 'Carver', 34.5233306884766, 0.602545789268717, -97.4841690063477, -1.70141971773138, 218, 42, 'PPL', 'P'),
(124455, 'Carver', 41.8833312988281, 0.731002032868144, -70.7630615234375, -1.2350484123753, 218, 23, 'PPL', 'P'),
(134579, 'Carver', 44.7636108398438, 0.781272394236698, -93.6255569458008, -1.63407423271767, 218, 28, 'PPL', 'P'),
(200532, 'Carver', 45.394718170166, 0.792287295084293, -122.496109008789, -2.13796042308526, 218, 43, 'PPL', 'P'),
(108507, 'Carver (historical)', 38.0758285522461, 0.66454857366156, -81.0841674804688, -1.41518569377269, 218, 58, 'PPL', 'P'),
(134580, 'Carver Beach', 44.878059387207, 0.783269898212312, -93.5374984741211, -1.63253732245259, 218, 28, 'PPL', 'P'),
(100546, 'Carver Court', 37.0405616760254, 0.646479758034672, -76.351936340332, -1.3325926794119, 218, 53, 'PPL', 'P'),
(100547, 'Carver Gardens', 37.2508316040039, 0.650149660595829, -76.6588897705078, -1.33795002741876, 218, 53, 'PPL', 'P'),
(15448, 'Carver Heights', 26.3147201538086, 0.459278508424869, -80.103889465332, -1.39807661482364, 218, 12, 'PPL', 'P'),
(100548, 'Carver Homes', 37.3488883972168, 0.651861074491341, -77.476936340332, -1.35222763349684, 218, 53, 'PPL', 'P'),
(15449, 'Carver Manor', 30.3777809143066, 0.530192296404144, -81.7283325195313, -1.42642849463057, 218, 12, 'PPL', 'P'),
(190016, 'Carver Park', 36.0463905334473, 0.62912819826837, -114.976669311523, -2.00672144246281, 218, 39, 'PPL', 'P'),
(15450, 'Carver Ranches', 25.9880599975586, 0.453577213163227, -80.192497253418, -1.39962311246865, 218, 12, 'PPL', 'P'),
(100549, 'Carver Terrace', 36.6611099243164, 0.63985707561489, -76.5972213745117, -1.33687371086421, 218, 53, 'PPL', 'P'),
(15451, 'Carver Village', 26.2519397735596, 0.458182784083869, -80.1436080932617, -1.39876983565539, 218, 12, 'PPL', 'P'),
(19827, 'Carver Village', 32.0705604553223, 0.559736872905265, -81.1205596923828, -1.41582085769268, 218, 13, 'PPL', 'P'),
(63485, 'Carvers', 34.4608306884766, 0.60145495848622, -78.4138870239258, -1.36858050785436, 218, 33, 'PPL', 'P'),
(190017, 'Carvers', 38.7866706848145, 0.676955109336776, -117.178329467773, -2.04514766119934, 218, 39, 'PPL', 'P'),
(127052, 'Carvers Corner', 44.288330078125, 0.772977180073319, -69.0305633544922, -1.20481061504243, 218, 26, 'PPL', 'P'),
(159845, 'Carversville', 40.3863906860352, 0.704875490468085, -75.0630569458008, -1.31009749031622, 218, 45, 'PPL', 'P'),
(159846, 'Carverton', 41.3372192382813, 0.72147057932675, -75.8652801513672, -1.32409892658926, 218, 45, 'PPL', 'P'),
(39672, 'Carville', 30.2172203063965, 0.527389985147108, -91.0961074829102, -1.58992701132743, 218, 22, 'PPL', 'P'),
(45468, 'Carville', 39.0491714477539, 0.681536611939067, -76.0041732788086, -1.3265230689715, 218, 25, 'PPL', 'P'),
(180563, 'Carvin Creek Homesites', 39.6286087036133, 0.691649699862533, -120.576942443848, -2.10446464763284, 218, 6, 'PPL', 'P'),
(75356, 'Carwile', 36.4633293151855, 0.636405152788957, -98.3008270263672, -1.71567308904353, 218, 42, 'PPL', 'P'),
(29403, 'Carwood', 38.4483299255371, 0.671049949093689, -85.8638916015625, -1.49860761702277, 218, 19, 'PPL', 'P'),
(201972, 'Carwye (historical)', 44.2222213745117, 0.771823365531042, -103.420829772949, -1.80503399468254, 218, 49, 'PPL', 'P'),
(7935, 'Cary', 35.7200012207031, 0.623431630117663, -90.6880569458008, -1.58280518594034, 218, 4, 'PPL', 'P'),
(15452, 'Cary', 30.4624996185303, 0.53167091673087, -81.7844390869141, -1.4274077389634, 218, 12, 'PPL', 'P'),
(19828, 'Cary', 32.514720916748, 0.567488935364323, -83.3050003051758, -1.4539465387002, 218, 13, 'PPL', 'P'),
(29404, 'Cary', 39.7069396972656, 0.693016833608126, -86.8230590820313, -1.51534824763501, 218, 19, 'PPL', 'P'),
(35165, 'Cary', 36.7936096191406, 0.642169631547461, -83.664436340332, -1.46021988096399, 218, 21, 'PPL', 'P'),
(58912, 'Cary', 32.8058280944824, 0.572569714091976, -90.9266662597656, -1.58696970409495, 218, 30, 'PPL', 'P'),
(63488, 'Cary', 35.791389465332, 0.624677590033657, -78.7813873291016, -1.37499459818176, 218, 33, 'PPL', 'P'),
(119050, 'Cary', 42.2119407653809, 0.736737350012711, -88.2380599975586, -1.5400446725297, 218, 18, 'PPL', 'P'),
(127053, 'Cary', 45.9952812194824, 0.802769097660681, -67.8625030517578, -1.18442411689787, 218, 26, 'PPL', 'P'),
(203303, 'Caryhurst', 40.3077812194824, 0.703503496453503, -111.65389251709, -1.94872804709108, 218, 52, 'PPL', 'P'),
(100550, 'Carys Corner', 38.061939239502, 0.664306159423336, -76.6241683959961, -1.33734402511271, 218, 53, 'PPL', 'P'),
(127055, 'Carys Mills', 46.1019401550293, 0.804630647262646, -67.8727798461914, -1.18460348079729, 218, 26, 'PPL', 'P'),
(100551, 'Carysbrook', 37.8122215270996, 0.659947763141366, -78.2427825927734, -1.365594172166, 218, 53, 'PPL', 'P'),
(15453, 'Carysfort Yacht Harbor', 25.2527809143066, 0.440744172239435, -80.3105621337891, -1.4016837333621, 218, 12, 'PPL', 'P'),
(154618, 'Carysville', 40.2119407653809, 0.701830764972825, -83.980827331543, -1.46574194548427, 218, 41, 'PPL', 'P'),
(1391, 'Caryton (historical)', 34.8222198486328, 0.607762389211964, -88.0777816772461, -1.53724728812068, 218, 2, 'PPL', 'P'),
(53885, 'Carytown', 37.2661094665527, 0.650416309599973, -94.3091735839844, -1.64600559387539, 218, 29, 'PPL', 'P'),
(15454, 'Caryville', 30.7730598449707, 0.537091215207995, -85.8141708374023, -1.49773982598157, 218, 12, 'PPL', 'P'),
(85589, 'Caryville', 36.2988891601563, 0.633535130661206, -84.2233276367188, -1.46997437424668, 218, 50, 'PPL', 'P'),
(124456, 'Caryville', 42.1333312988281, 0.73536535599813, -71.4483337402344, -1.24700866883084, 218, 23, 'PPL', 'P'),
(173447, 'Caryville', 44.7513885498047, 0.781059075033382, -91.6744384765625, -1.60002079133299, 218, 57, 'PPL', 'P'),
(7936, 'Casa', 35.0227813720703, 0.611262848148764, -93.0475006103516, -1.62398524640207, 218, 4, 'PPL', 'P'),
(186499, 'Casa', 38.0091705322266, 0.663385171739359, -103.471672058105, -1.80592135995776, 218, 7, 'PPL', 'P'),
(19829, 'Casa Bella', 33.5188903808594, 0.585014998761052, -82.1025009155273, -1.43295896509761, 218, 13, 'PPL', 'P'),
(93088, 'Casa Blanca', 28.000560760498, 0.488701977675418, -97.9036102294922, -1.70874034809384, 218, 51, 'PPL', 'P'),
(177854, 'Casa Blanca', 33.1202812194824, 0.578057956466411, -111.887496948242, -1.95280521356193, 218, 5, 'PPL', 'P'),
(180565, 'Casa Blanca', 33.9330596923828, 0.592243616907854, -117.401672363281, -2.04904573008689, 218, 6, 'PPL', 'P'),
(188251, 'Casa Blanca', 35.0455589294434, 0.611660391520486, -107.470832824707, -1.87571988265154, 218, 38, 'PPL', 'P'),
(15455, 'Casa Blanco', 30.5161094665527, 0.532606585090356, -83.8877792358398, -1.46411794985154, 218, 12, 'PPL', 'P'),
(93089, 'Casa Bonita Colonia', 26.2110004425049, 0.457468257963401, -98.2470016479492, -1.71473365896901, 218, 51, 'PPL', 'P'),
(15456, 'Casa Cola', 29.9719390869141, 0.523109020273833, -81.3463897705078, -1.419762336106, 218, 12, 'PPL', 'P'),
(188252, 'Casa Colorada', 34.5738906860352, 0.603428227695915, -106.748611450195, -1.86311474173803, 218, 38, 'PPL', 'P'),
(180566, 'Casa Conejo', 34.1836090087891, 0.596616527417764, -118.942497253418, -2.07593819761646, 218, 6, 'PPL', 'P'),
(177861, 'Casa de Francisco Mobile Home Park', 33.3722190856934, 0.582455101742241, -112.069442749023, -1.95598076684574, 218, 5, 'PPL', 'P'),
(93091, 'Casa de los Vecinos Colonia', 26.3059997558594, 0.459126308768571, -98.3359985351563, -1.7162869476748, 218, 51, 'PPL', 'P'),
(180574, 'Casa de Oro', 32.7488899230957, 0.571575955531213, -116.980003356934, -2.04168621757251, 218, 6, 'PPL', 'P'),
(191233, 'Casa de Peidras', 29.8533306121826, 0.521038911869001, -101.916107177734, -1.77877163106689, 218, 51, 'PPL', 'P'),
(191234, 'Casa de Piedra', 29.101390838623, 0.507915087043686, -103.054168701172, -1.79863455174114, 218, 51, 'PPL', 'P'),
(180575, 'Casa del Norte Mobile Home Community', 34.2230606079102, 0.597305087717604, -119.103332519531, -2.07874530256345, 218, 6, 'PPL', 'P'),
(177862, 'Casa del Oro', 32.5774993896484, 0.568584626415808, -110.843887329102, -1.93459078960245, 218, 5, 'PPL', 'P'),
(93092, 'Casa del Rey Colonia', 26.1079998016357, 0.45567055764857, -97.5039978027344, -1.70176579551503, 218, 51, 'PPL', 'P'),
(177863, 'Casa del Sol Resorts', 33.5847206115723, 0.58616395303434, -112.204170227051, -1.95833220493023, 218, 5, 'PPL', 'P'),
(177864, 'Casa del Sol Resorts Number One', 33.5875015258789, 0.586212489145206, -112.252777099609, -1.95918055489547, 218, 5, 'PPL', 'P'),
(188257, 'Casa Fria', 35.2636108398438, 0.615466115297236, -107.46639251709, -1.87564238466381, 218, 38, 'PPL', 'P'),
(177855, 'Casa Grande', 32.8794403076172, 0.573854489580857, -111.75666809082, -1.9505218192433, 218, 5, 'PPL', 'P'),
(188254, 'Casa Grande', 36.8883285522461, 0.643822788794127, -104.978332519531, -1.83221754571925, 218, 38, 'PPL', 'P'),
(19830, 'Casa Linda', 33.5077781677246, 0.584821054054667, -82.0977783203125, -1.43287654026187, 218, 13, 'PPL', 'P'),
(39673, 'Casa Linda', 32.5102806091309, 0.567411437376601, -92.2133331298828, -1.60942627735482, 218, 22, 'PPL', 'P'),
(177856, 'Casa Linda', 33.3402786254883, 0.58189763554706, -111.854438781738, -1.95222823971177, 218, 5, 'PPL', 'P'),
(93090, 'Casa Linda Colonia', 27.9869995117188, 0.488465289233538, -97.9680023193359, -1.70986420207385, 218, 51, 'PPL', 'P'),
(180571, 'Casa Loma', 33.8269386291504, 0.590391454948731, -117.031112670898, -2.04257824337963, 218, 6, 'PPL', 'P'),
(188255, 'Casa Loma', 35.1108283996582, 0.612799558676767, -106.385276794434, -1.85677335570839, 218, 38, 'PPL', 'P'),
(177857, 'Casa Piedra', 31.3891696929932, 0.547844360609948, -111.25, -1.94167879284369, 218, 5, 'PPL', 'P'),
(191232, 'Casa Piedra', 29.7383308410645, 0.519031787223949, -104.053611755371, -1.8160781237231, 218, 51, 'PPL', 'P'),
(177858, 'Casa Rica', 33.5888900756836, 0.586236723911126, -111.858329772949, -1.95229615031957, 218, 5, 'PPL', 'P'),
(177859, 'Casa Rosa', 33.9474983215332, 0.592495618526003, -112.334999084473, -1.96061559924886, 218, 5, 'PPL', 'P'),
(188256, 'Casa Salazar', 35.4833297729492, 0.619300934108896, -107.115562438965, -1.8695192446855, 218, 38, 'PPL', 'P'),
(177860, 'Casa Serena Mobile Home Park', 33.4041709899902, 0.583012767674503, -111.644996643066, -1.94857278479953, 218, 5, 'PPL', 'P'),
(63491, 'Casablanca', 35.1372184753418, 0.613260152387296, -78.970832824707, -1.37830104583315, 218, 33, 'PPL', 'P'),
(177580, 'Casagmo', 41.288330078125, 0.720617302513489, -73.4972229003906, -1.28276853068399, 218, 8, 'PPL', 'P'),
(112610, 'Casanova', 38.6575012207031, 0.674700676894997, -77.7172164916992, -1.35642131326539, 218, 53, 'PPL', 'P'),
(159847, 'Casanova', 40.954719543457, 0.714794700264194, -78.1677780151367, -1.36428509533217, 218, 45, 'PPL', 'P'),
(63492, 'Casar', 35.5122184753418, 0.619805137082275, -81.6175003051758, -1.42449410757279, 218, 33, 'PPL', 'P'),
(177865, 'Casas Adobes', 32.3233299255371, 0.564148532409036, -110.994438171387, -1.93721839749197, 218, 5, 'PPL', 'P'),
(93093, 'Casas Colonia', 26.4759998321533, 0.462093369828541, -98.9329986572266, -1.72670656543973, 218, 51, 'PPL', 'P'),
(177866, 'Casas del Campo Mobile Home Park', 33.3288917541504, 0.581698897150713, -111.837501525879, -1.95193262883077, 218, 5, 'PPL', 'P'),
(177867, 'Cascabel', 32.291389465332, 0.563591066213855, -110.378890991211, -1.92647507249654, 218, 5, 'PPL', 'P'),
(26723, 'Cascade', 39.670280456543, 0.692377009156234, -89.491943359375, -1.56192906562937, 218, 18, 'PPL', 'P'),
(29405, 'Cascade', 39.190559387207, 0.684004297005134, -86.5388870239258, -1.5103885095789, 218, 19, 'PPL', 'P'),
(45469, 'Cascade', 39.7108306884766, 0.693084744215923, -77.4897232055664, -1.35245080639619, 218, 25, 'PPL', 'P'),
(53886, 'Cascade', 37.2994384765625, 0.650998010561073, -90.269172668457, -1.57549427611585, 218, 29, 'PPL', 'P'),
(100552, 'Cascade', 36.5644416809082, 0.638169896485298, -79.6699981689453, -1.39050378310595, 218, 53, 'PPL', 'P'),
(108508, 'Cascade', 39.5633316040039, 0.690510399548198, -79.8147201538086, -1.39302965824183, 218, 58, 'PPL', 'P'),
(114856, 'Cascade', 42.2986106872559, 0.738250025511876, -91.0147171020508, -1.58850648120198, 218, 16, 'PPL', 'P'),
(130101, 'Cascade', 46.4469413757324, 0.810652054487315, -87.4852828979492, -1.5269062336079, 218, 27, 'PPL', 'P'),
(143594, 'Cascade', 44.4494400024414, 0.775789078710279, -71.1930618286133, -1.2425533334852, 218, 36, 'PPL', 'P'),
(147622, 'Cascade', 42.7552795410156, 0.746220400601293, -76.4736099243164, -1.33471628406513, 218, 40, 'PPL', 'P'),
(154619, 'Cascade', 41.0208282470703, 0.715948514806471, -84.2888870239258, -1.47111860140903, 218, 41, 'PPL', 'P'),
(159848, 'Cascade', 41.7363891601563, 0.728437408738397, -75.3777770996094, -1.31559039322257, 218, 45, 'PPL', 'P'),
(173448, 'Cascade', 43.6583290100098, 0.761981587143627, -88.0069427490234, -1.53601091558461, 218, 57, 'PPL', 'P'),
(180576, 'Cascade', 39.7000007629395, 0.692895726357554, -121.177223205566, -2.11494152336121, 218, 6, 'PPL', 'P'),
(186501, 'Cascade', 38.896671295166, 0.678874982166614, -104.971672058105, -1.83210129873767, 218, 7, 'PPL', 'P'),
(194698, 'Cascade', 44.5163917541504, 0.776957607217578, -116.040832519531, -2.02529459422113, 218, 17, 'PPL', 'P'),
(196168, 'Cascade', 47.271110534668, 0.825036519904133, -111.699722290039, -1.94952792752448, 218, 31, 'PPL', 'P'),
(199220, 'Cascade', 42.1813888549805, 0.73620411858345, -100.385276794434, -1.75205360058873, 218, 35, 'PPL', 'P'),
(154620, 'Cascade (historical)', 41.0852813720703, 0.71707343405092, -81.517219543457, -1.42274387810439, 218, 41, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(196169, 'Cascade Colony', 47.439998626709, 0.82798417317766, -111.81916809082, -1.9516126500258, 218, 31, 'PPL', 'P'),
(45470, 'Cascade Estates', 39.6227798461914, 0.691547967108892, -76.9091720581055, -1.34231827739676, 218, 25, 'PPL', 'P'),
(200533, 'Cascade Gorge', 42.7158317565918, 0.74553190688048, -122.567497253418, -2.13920638300125, 218, 43, 'PPL', 'P'),
(19831, 'Cascade Heights', 33.7222213745117, 0.588563794071637, -84.4633331298828, -1.47416326032526, 218, 13, 'PPL', 'P'),
(19832, 'Cascade Hills', 32.5091705322266, 0.567392062879671, -84.9841690063477, -1.48325356123208, 218, 13, 'PPL', 'P'),
(206975, 'Cascade Junction', 47.1372184753418, 0.822699662626616, -122.076667785645, -2.13063979272279, 218, 56, 'PPL', 'P'),
(200534, 'Cascade Locks', 45.6699981689453, 0.797091837427877, -121.889442443848, -2.12737209406527, 218, 43, 'PPL', 'P'),
(180577, 'Cascade Shores', 39.2649993896484, 0.685303520142929, -120.910003662109, -2.11027766250221, 218, 6, 'PPL', 'P'),
(201973, 'Cascade Springs', 43.3333282470703, 0.75630925375884, -103.550003051758, -1.80728849370335, 218, 49, 'PPL', 'P'),
(147623, 'Cascade Valley', 42.0022201538086, 0.733077034831479, -75.5794372558594, -1.31911002691921, 218, 40, 'PPL', 'P'),
(206976, 'Cascade Valley', 47.1347198486328, 0.822656053363766, -119.326942443848, -2.08264803198291, 218, 56, 'PPL', 'P'),
(19833, 'Cascade Woods', 34.2619400024414, 0.597983661163357, -83.873893737793, -1.46387560219234, 218, 13, 'PPL', 'P'),
(180578, 'Cascadel Woods', 37.2305603027344, 0.649795859645012, -119.454170227051, -2.08486857569982, 218, 6, 'PPL', 'P'),
(200535, 'Cascadia', 44.3974990844727, 0.774882538675216, -122.480560302734, -2.13768904697018, 218, 43, 'PPL', 'P'),
(58913, 'Cascilla', 33.8566703796387, 0.590910371887133, -90.0041732788086, -1.57086916425071, 218, 30, 'PPL', 'P'),
(100553, 'Casco', 37.7488899230957, 0.658842418130929, -77.6544418334961, -1.35532568879293, 218, 53, 'PPL', 'P'),
(127056, 'Casco', 44.0066719055176, 0.768061317596169, -70.5233306884766, -1.23086431998668, 218, 26, 'PPL', 'P'),
(130103, 'Casco', 42.752498626709, 0.746171864490426, -82.6716690063477, -1.44289282227972, 218, 27, 'PPL', 'P'),
(134584, 'Casco', 47.2580604553223, 0.824808753051904, -92.7016677856445, -1.61794932494946, 218, 28, 'PPL', 'P'),
(173449, 'Casco', 44.5577812194824, 0.777679989663262, -87.6180572509766, -1.52922358323043, 218, 57, 'PPL', 'P'),
(173453, 'Casco Junction', 44.5305595397949, 0.777204881724792, -87.6505584716797, -1.52979083654262, 218, 57, 'PPL', 'P'),
(7938, 'Case', 36.2080612182617, 0.631949884022336, -90.7624969482422, -1.58410440907813, 218, 4, 'PPL', 'P'),
(53888, 'Case', 38.7350006103516, 0.676053296412648, -91.373893737793, -1.59477529609192, 218, 29, 'PPL', 'P'),
(7939, 'Case (historical)', 36.2216682434082, 0.632187371412544, -90.7427825927734, -1.58376032866529, 218, 4, 'PPL', 'P'),
(177578, 'Case Corner', 41.8358306884766, 0.730172990820802, -72.7708282470703, -1.27009055231467, 218, 8, 'PPL', 'P'),
(190018, 'Caselton', 37.9191703796387, 0.661814372749403, -114.484443664551, -1.99813048426037, 218, 39, 'PPL', 'P'),
(190019, 'Caselton Heights', 37.913890838623, 0.661722227375686, -114.478332519531, -1.99802382465872, 218, 39, 'PPL', 'P'),
(1392, 'Casemore', 32.5802803039551, 0.568633162526675, -87.6838912963867, -1.53037260408275, 218, 2, 'PPL', 'P'),
(130107, 'Caseville', 43.9411087036133, 0.766917023854789, -83.2713928222656, -1.45335997747011, 218, 27, 'PPL', 'P'),
(1393, 'Casey', 32.3291702270508, 0.564250464899759, -86.9433288574219, -1.51744735120621, 218, 2, 'PPL', 'P'),
(7941, 'Casey', 35.0461082458496, 0.61166997890041, -91.1972198486328, -1.59169175502377, 218, 4, 'PPL', 'P'),
(26722, 'Casey', 39.2991714477539, 0.685899935069052, -87.9925003051758, -1.53575884738743, 218, 18, 'PPL', 'P'),
(35166, 'Casey', 37.3344383239746, 0.65160887313611, -86.6074981689453, -1.51158599996306, 218, 21, 'PPL', 'P'),
(75358, 'Casey', 36.2825012207031, 0.633249107160131, -96.6738891601563, -1.68727766655278, 218, 42, 'PPL', 'P'),
(114858, 'Casey', 41.5050010681152, 0.724398924682374, -94.519172668457, -1.64967076932561, 218, 16, 'PPL', 'P'),
(134585, 'Casey', 45.0661087036133, 0.786551977939725, -94.4411087036133, -1.64830829611193, 218, 28, 'PPL', 'P'),
(203307, 'Casey Acres', 41.276668548584, 0.72041377042718, -111.774169921875, -1.95082728382033, 218, 52, 'PPL', 'P'),
(180579, 'Casey Corner', 39.1972198486328, 0.684120543986716, -121.176940917969, -2.11493659651319, 218, 6, 'PPL', 'P'),
(35167, 'Casey Creek', 37.2722206115723, 0.650522969201631, -85.1575012207031, -1.48627877907236, 218, 21, 'PPL', 'P'),
(53889, 'Casey Ford', 37.5941696166992, 0.656142039364616, -92.3597183227539, -1.61198118094659, 218, 29, 'PPL', 'P'),
(159850, 'Casey Highlands', 40.1794395446777, 0.701263511660638, -75.0650024414063, -1.31013144562012, 218, 45, 'PPL', 'P'),
(80181, 'Casey Hill (historical)', 33.0349998474121, 0.576569515733166, -80.0625, -1.39735423237796, 218, 48, 'PPL', 'P'),
(159851, 'Casey Village', 40.1949996948242, 0.701535087512799, -75.0475006103516, -1.30982598104309, 218, 45, 'PPL', 'P'),
(19834, 'Caseyville', 33.9130592346191, 0.591894543067972, -85.2980575561523, -1.48873194991049, 218, 13, 'PPL', 'P'),
(26725, 'Caseyville', 38.6366691589355, 0.674337088827174, -90.0255584716797, -1.57124240627748, 218, 18, 'PPL', 'P'),
(35169, 'Caseyville', 37.5377807617188, 0.655157868183777, -88.0641708374023, -1.53700973415144, 218, 21, 'PPL', 'P'),
(53890, 'Caseyville', 38.2052803039551, 0.666807932951356, -91.079719543457, -1.58964098782635, 218, 29, 'PPL', 'P'),
(58914, 'Caseyville', 31.672779083252, 0.552794278259538, -90.6555633544922, -1.5822380657862, 218, 30, 'PPL', 'P'),
(696, 'Cash', 32.5672187805176, 0.568405195937364, -89.5719375610352, -1.56332522783084, 218, 30, 'PPL', 'P'),
(7940, 'Cash', 35.7941703796387, 0.624726126144524, -90.936393737793, -1.58713948061444, 218, 4, 'PPL', 'P'),
(19835, 'Cash', 34.4897193908691, 0.6019591614596, -84.8186111450195, -1.48036403144935, 218, 13, 'PPL', 'P'),
(53891, 'Cash', 39.8505592346191, 0.695523467405135, -92.6338882446289, -1.61676634879324, 218, 29, 'PPL', 'P'),
(80182, 'Cash', 34.6183280944824, 0.604203806784373, -79.8775024414063, -1.39412541587235, 218, 48, 'PPL', 'P'),
(93094, 'Cash', 32.9944381713867, 0.575861580936395, -96.107780456543, -1.67739720575053, 218, 51, 'PPL', 'P'),
(130109, 'Cash', 43.348331451416, 0.756571109073022, -82.7863922119141, -1.44489511994529, 218, 27, 'PPL', 'P'),
(45471, 'Cash Corner', 37.9908294677734, 0.663065059776331, -75.8099975585938, -1.32313406332632, 218, 25, 'PPL', 'P'),
(100555, 'Cash Corner', 38.1258316040039, 0.665421291550779, -77.2422180175781, -1.34813102595003, 218, 53, 'PPL', 'P'),
(127058, 'Cash Corner', 43.6300010681152, 0.761487171287254, -70.2927780151367, -1.22684041673762, 218, 26, 'PPL', 'P'),
(45472, 'Cash Corner (historical)', 39.4011116027832, 0.687679126414307, -75.8447189331055, -1.32374006563237, 218, 25, 'PPL', 'P'),
(63494, 'Cash Corner Number 2', 35.0013885498047, 0.610889472963935, -76.7919387817383, -1.34027217073126, 218, 33, 'PPL', 'P'),
(39674, 'Cash Point', 32.6177787780762, 0.569287634364562, -93.771110534668, -1.6366146220815, 218, 22, 'PPL', 'P'),
(85591, 'Cash Point', 35.0180587768555, 0.611180423313026, -86.8052825927734, -1.51503798936802, 218, 50, 'PPL', 'P'),
(139766, 'Cashel', 48.4847183227539, 0.846217971634078, -97.2983322143555, -1.69817625383977, 218, 34, 'PPL', 'P'),
(45473, 'Cashell Manor', 39.1430587768555, 0.683175254957792, -77.0877838134766, -1.34543564061076, 218, 25, 'PPL', 'P'),
(45474, 'Cashell Woods', 39.1294403076172, 0.682937567830503, -77.0783309936523, -1.34527065778123, 218, 25, 'PPL', 'P'),
(108511, 'Cashers Hill', 37.4477806091309, 0.653587069193821, -80.8888931274414, -1.41177751336767, 218, 58, 'PPL', 'P'),
(63495, 'Cashiers', 35.1055603027344, 0.612707613040132, -83.0966720581055, -1.45031052486391, 218, 33, 'PPL', 'P'),
(75359, 'Cashion', 35.7980613708496, 0.62479403675232, -97.6783294677734, -1.70480845706045, 218, 42, 'PPL', 'P'),
(177868, 'Cashion', 33.4352798461914, 0.583555719641743, -112.297218322754, -1.95995620056296, 218, 5, 'PPL', 'P'),
(93095, 'Cashion Community', 34.0355606079102, 0.594032595370115, -98.4997177124023, -1.7191443863664, 218, 51, 'PPL', 'P'),
(80183, 'Cashion Crossroads', 35.0897216796875, 0.612431176918982, -81.508056640625, -1.42258395528093, 218, 48, 'PPL', 'P'),
(108509, 'Cashmere', 37.4497184753418, 0.653620891339665, -80.7799987792969, -1.40987694845573, 218, 58, 'PPL', 'P'),
(206977, 'Cashmere', 47.5224990844727, 0.829424077800039, -120.468612670898, -2.10257393641694, 218, 56, 'PPL', 'P'),
(100558, 'Cashs Corner', 36.9152793884277, 0.644293169621663, -77.1116714477539, -1.34585255847941, 218, 53, 'PPL', 'P'),
(173455, 'Cashton', 43.7419395446777, 0.763440866262936, -90.779167175293, -1.58439535942722, 218, 57, 'PPL', 'P'),
(77981, 'Cashtown', 39.8677787780762, 0.695824005134151, -77.7366714477539, -1.35676086630437, 218, 45, 'PPL', 'P'),
(134587, 'Cashtown', 45.2986106872559, 0.790609903071706, -96.4388885498047, -1.68317613215795, 218, 28, 'PPL', 'P'),
(206978, 'Cashup', 47.0605583190918, 0.82136169049496, -117.378608703613, -2.04864319328812, 218, 56, 'PPL', 'P'),
(80184, 'Cashville', 34.8072204589844, 0.607500600476809, -82.129997253418, -1.43343886672604, 218, 48, 'PPL', 'P'),
(100556, 'Cashville', 37.7019386291504, 0.658022963463512, -75.8086090087891, -1.3231098285604, 218, 53, 'PPL', 'P'),
(177418, 'Casimir', 44.5699996948242, 0.777893242287551, -89.6074981689453, -1.56394587752289, 218, 57, 'PPL', 'P'),
(134588, 'Casino', 46.4269409179688, 0.810302980647433, -94.5400009155273, -1.65003429081441, 218, 28, 'PPL', 'P'),
(114859, 'Casino Beach', 42.6241683959961, 0.743932079434642, -95.2283325195313, -1.66204794364981, 218, 16, 'PPL', 'P'),
(206979, 'Casino Corner', 47.920280456543, 0.836366672445766, -122.231391906738, -2.13334023806813, 218, 56, 'PPL', 'P'),
(196171, 'Casitas Del Rio East Mobile Home Park', 47.1049995422363, 0.822137336162446, -104.726387023926, -1.82782026728537, 218, 31, 'PPL', 'P'),
(180580, 'Casitas Mobile Home Park', 34.3711090087891, 0.599889019765254, -119.305000305176, -2.08226506941816, 218, 6, 'PPL', 'P'),
(180581, 'Casitas Springs', 34.3713912963867, 0.59989394661327, -119.305557250977, -2.08227478995614, 218, 6, 'PPL', 'P'),
(80185, 'Caskey', 34.7447204589844, 0.606409769694313, -80.8372192382813, -1.41087563386451, 218, 48, 'PPL', 'P'),
(100557, 'Caskie', 37.5394401550293, 0.655186830060632, -78.8302764892578, -1.37584787499503, 218, 53, 'PPL', 'P'),
(35170, 'Casky', 36.8169403076172, 0.642576828878134, -87.4322204589844, -1.52598011933883, 218, 21, 'PPL', 'P'),
(180584, 'Casmalia', 34.8380584716797, 0.608038825333114, -120.530281066895, -2.10365025297149, 218, 6, 'PPL', 'P'),
(26727, 'Casner', 39.8002815246582, 0.694645955825954, -88.7911071777344, -1.54969716674263, 218, 18, 'PPL', 'P'),
(130110, 'Casnovia', 43.2347183227539, 0.754588185904376, -85.7905578613281, -1.49732770180288, 218, 27, 'PPL', 'P'),
(39675, 'Cason', 30.8833293914795, 0.539015781859254, -91.8111114501953, -1.60240618472137, 218, 22, 'PPL', 'P'),
(93096, 'Cason', 33.0386085510254, 0.576632499492946, -94.8147201538086, -1.65482904604098, 218, 51, 'PPL', 'P'),
(63497, 'Cason Old Field', 34.8383293151855, 0.608043552444049, -80.0941696166992, -1.39790697146221, 218, 33, 'PPL', 'P'),
(147624, 'Casowasco', 42.7833290100098, 0.746709956188676, -76.4941711425781, -1.33507514502202, 218, 40, 'PPL', 'P'),
(180586, 'Caspar', 39.3636093139648, 0.687024587997393, -123.814720153809, -2.16097452911934, 218, 6, 'PPL', 'P'),
(39676, 'Caspari (historical)', 31.8797206878662, 0.556406090619417, -93.0511093139648, -1.62404823016185, 218, 22, 'PPL', 'P'),
(26729, 'Caspars', 38.2999992370605, 0.668461090198023, -89.6616668701172, -1.56489129970986, 218, 18, 'PPL', 'P'),
(209359, 'Casper', 42.8666687011719, 0.74816450819705, -106.3125, -1.85550316102647, 218, 59, 'PPL', 'P'),
(85592, 'Casper (historical)', 36.3277816772461, 0.634039400213612, -81.9319381713867, -1.42998208363112, 218, 50, 'PPL', 'P'),
(209360, 'Casper Mountain', 42.7330589294434, 0.74583257776755, -106.326110839844, -1.85574071499571, 218, 59, 'PPL', 'P'),
(134589, 'Casperson', 48.5761108398438, 0.847813071968981, -95.6869430541992, -1.6700522074641, 218, 28, 'PPL', 'P'),
(130112, 'Caspian', 46.0641708374023, 0.803971448313824, -88.6313934326172, -1.54690963602965, 218, 27, 'PPL', 'P'),
(39677, 'Caspiana', 32.288890838623, 0.563547456951005, -93.5561065673828, -1.63286209494752, 218, 22, 'PPL', 'P'),
(7947, 'Cass', 35.6875, 0.622864376805476, -93.8191680908203, -1.63745338466682, 218, 4, 'PPL', 'P'),
(29406, 'Cass', 39.0869407653809, 0.682195810887888, -87.2786102294922, -1.52329911506944, 218, 19, 'PPL', 'P'),
(93097, 'Cass', 33.1949996948242, 0.579362039873196, -94.0630569458008, -1.64171004819515, 218, 51, 'PPL', 'P'),
(108510, 'Cass', 38.396671295166, 0.670148335906642, -79.9150009155273, -1.39477988771024, 218, 58, 'PPL', 'P'),
(114860, 'Cass', 42.1947212219238, 0.736436812283696, -91.3455581665039, -1.59428074707749, 218, 16, 'PPL', 'P'),
(26730, 'Cass (historical)', 39.9680595397949, 0.697574234602551, -90.269172668457, -1.57549427611585, 218, 18, 'PPL', 'P'),
(130114, 'Cass City', 43.600830078125, 0.760978041465858, -83.1747207641602, -1.45167273176149, 218, 27, 'PPL', 'P'),
(127059, 'Cass Corner', 44.9036102294922, 0.783715844536845, -69.6994400024414, -1.21648471483885, 218, 26, 'PPL', 'P'),
(134591, 'Cass Lake', 47.3794403076172, 0.826927231120035, -94.603889465332, -1.65114935636282, 218, 28, 'PPL', 'P'),
(209361, 'Cassa', 42.4161109924316, 0.740300792709292, -104.949440002441, -1.83171327616685, 218, 59, 'PPL', 'P'),
(15457, 'Cassadaga', 28.9661102294922, 0.505553995000249, -81.2361068725586, -1.41783753642814, 218, 12, 'PPL', 'P'),
(147625, 'Cassadaga', 42.3441696166992, 0.739045178834347, -79.3097229003906, -1.38421579345616, 218, 40, 'PPL', 'P'),
(19836, 'Cassandra', 34.7841682434082, 0.607098263415126, -85.398063659668, -1.49047738568892, 218, 13, 'PPL', 'P'),
(39678, 'Cassandra', 31.1888904571533, 0.544348828521165, -92.1688919067383, -1.60865063168734, 218, 22, 'PPL', 'P'),
(159854, 'Cassandra', 40.4086112976074, 0.705263313301828, -78.6408309936523, -1.37254142734364, 218, 45, 'PPL', 'P'),
(45475, 'Cassatt', 38.0777816772461, 0.664582662123513, -75.579719543457, -1.31911495376723, 218, 25, 'PPL', 'P'),
(80186, 'Cassatt', 34.3644409179688, 0.599772639625617, -80.4361114501953, -1.40387498230702, 218, 48, 'PPL', 'P'),
(7942, 'Casscoe', 34.5255584716797, 0.602584671420632, -91.3258285522461, -1.59393640034854, 218, 4, 'PPL', 'P'),
(193434, 'Cassel', 40.9191703796387, 0.714174250309233, -121.546669006348, -2.12138956899251, 218, 6, 'PPL', 'P'),
(15458, 'Casselberry', 28.6774997711182, 0.500516792245932, -81.3280563354492, -1.41944235730102, 218, 12, 'PPL', 'P'),
(154624, 'Cassell', 40.0102806091309, 0.698311131276176, -81.6569366455078, -1.42518240155653, 218, 41, 'PPL', 'P'),
(173458, 'Cassell', 43.2066688537598, 0.754098630316992, -89.875, -1.5686146652299, 218, 57, 'PPL', 'P'),
(154625, 'Cassella', 40.4072189331055, 0.705239011956881, -84.5511093139648, -1.47569524374233, 218, 41, 'PPL', 'P'),
(154626, 'Cassellview', 40.000560760498, 0.698141487914738, -81.6686096191406, -1.42538613337992, 218, 41, 'PPL', 'P'),
(45476, 'Casselman', 39.6752815246582, 0.692464294260961, -79.1719436645508, -1.38181109214988, 218, 25, 'PPL', 'P'),
(77982, 'Casselman', 39.8855590820313, 0.696134329980172, -79.211669921875, -1.38250444613968, 218, 45, 'PPL', 'P'),
(139768, 'Casselton', 46.9005584716797, 0.81856916635493, -97.2108306884766, -1.69664906411266, 218, 34, 'PPL', 'P'),
(15459, 'Cassia', 28.8891696929932, 0.50421112931009, -81.4655609130859, -1.42184226491735, 218, 12, 'PPL', 'P'),
(7943, 'Cassidy', 35.5833282470703, 0.621046236729279, -90.4836120605469, -1.57923694955379, 218, 4, 'PPL', 'P'),
(53897, 'Cassidy', 37.0675010681152, 0.646949939125126, -93.2461090087891, -1.62745161687692, 218, 29, 'PPL', 'P'),
(196172, 'Cassidy Curve', 48.8274993896484, 0.852200629864887, -113.54972076416, -1.98181649205477, 218, 31, 'PPL', 'P'),
(45477, 'Cassidy Wharf', 39.3841705322266, 0.687383448954281, -75.9608306884766, -1.32576659806387, 218, 25, 'PPL', 'P'),
(93098, 'Cassin', 29.2583293914795, 0.510654181514346, -98.4916687011719, -1.7190039046189, 218, 51, 'PPL', 'P'),
(80187, 'Cassina Heights', 32.8058280944824, 0.572569714091976, -79.8341674804688, -1.39336907812277, 218, 48, 'PPL', 'P'),
(108512, 'Cassity', 38.8261108398438, 0.677643469899534, -80.0350036621094, -1.39687433074953, 218, 58, 'PPL', 'P'),
(31981, 'Cassoday', 38.038890838623, 0.663903888940679, -96.6388931274414, -1.68666687055677, 218, 20, 'PPL', 'P'),
(13497, 'Casson Corner', 39.1605606079102, 0.683480719534824, -75.6086120605469, -1.31961922331964, 218, 10, 'PPL', 'P'),
(130116, 'Cassopolis', 41.9116706848145, 0.731496648461599, -86.0100021362305, -1.50115772692458, 218, 27, 'PPL', 'P'),
(154627, 'Casstown', 40.0519409179688, 0.699038240832795, -84.1297225952148, -1.46834065807597, 218, 41, 'PPL', 'P'),
(19837, 'Cassville', 34.2447204589844, 0.597683123434341, -84.8522186279297, -1.48095059267944, 218, 13, 'PPL', 'P'),
(53898, 'Cassville', 36.6769409179688, 0.640133378577986, -93.8686065673828, -1.63831624886, 218, 29, 'PPL', 'P'),
(85593, 'Cassville', 35.9552803039551, 0.627538024781484, -85.6016693115234, -1.49403097468947, 218, 50, 'PPL', 'P'),
(108513, 'Cassville', 39.6655616760254, 0.692294650899523, -80.0638885498047, -1.39737846714388, 218, 58, 'PPL', 'P'),
(122330, 'Cassville', 40.560001373291, 0.70790556857735, -86.1227798461914, -1.50312606928626, 218, 19, 'PPL', 'P'),
(144953, 'Cassville', 40.1044387817383, 0.699954501405837, -74.3869400024414, -1.29829702352608, 218, 37, 'PPL', 'P'),
(147626, 'Cassville', 42.9458312988281, 0.749546156170584, -75.2547225952148, -1.31344268696147, 218, 40, 'PPL', 'P'),
(154628, 'Cassville', 40.228328704834, 0.702116788473899, -81.1005630493164, -1.41547185043182, 218, 41, 'PPL', 'P'),
(159861, 'Cassville', 40.2930603027344, 0.703246567987338, -78.0272216796875, -1.36183192449405, 218, 45, 'PPL', 'P'),
(173460, 'Cassville', 42.7144393920898, 0.745507605535533, -90.9905624389648, -1.58808490280142, 218, 57, 'PPL', 'P'),
(180588, 'Castaic', 34.4888916015625, 0.601944713810686, -118.621940612793, -2.07034342879842, 218, 6, 'PPL', 'P'),
(180589, 'Castaic Junction', 34.4408302307129, 0.601105884646338, -118.605560302734, -2.0700575384554, 218, 6, 'PPL', 'P'),
(63498, 'Castalia', 36.0816688537598, 0.629743921112396, -78.0577774047852, -1.36236522250234, 218, 33, 'PPL', 'P'),
(114872, 'Castalia', 43.1119384765625, 0.752445273333244, -91.6761093139648, -1.60004995294693, 218, 16, 'PPL', 'P'),
(154629, 'Castalia', 41.4000015258789, 0.722566336957263, -82.8086090087891, -1.44528287620001, 218, 41, 'PPL', 'P'),
(58915, 'Castalian Springs', 33.0727806091309, 0.577228914419069, -89.904167175293, -1.56912372847227, 218, 30, 'PPL', 'P'),
(85594, 'Castalian Springs', 36.3936080932617, 0.635188287907873, -86.3080596923828, -1.50635981263988, 218, 50, 'PPL', 'P'),
(114873, 'Castana', 42.0744400024414, 0.734337508975414, -95.908332824707, -1.67391618788969, 218, 16, 'PPL', 'P'),
(159857, 'Castanea', 41.1247215270996, 0.717761794613679, -77.4300003051758, -1.35140844514553, 218, 45, 'PPL', 'P'),
(190963, 'Castaneda', 36.8811111450195, 0.643696821274567, -102.52082824707, -1.78932600478298, 218, 42, 'PPL', 'P'),
(93099, 'Castaneda Colonia', 26.2679996490479, 0.4584630817886, -98.322998046875, -1.71606004634992, 218, 51, 'PPL', 'P'),
(85595, 'Castaway Cove', 35.7944412231445, 0.624730853255458, -84.1125030517578, -1.46804012034695, 218, 50, 'PPL', 'P'),
(7944, 'Casteel (historical)', 36.0702781677246, 0.629545116137022, -92.2363891601563, -1.60982868099553, 218, 4, 'PPL', 'P'),
(93100, 'Castell', 30.7008304595947, 0.535830574616492, -98.9561080932617, -1.72710990118682, 218, 51, 'PPL', 'P'),
(85600, 'Castell Springs', 36.2597198486328, 0.632851497209383, -82.8238906860352, -1.44554959178318, 218, 50, 'PPL', 'P'),
(193435, 'Castella', 41.1386108398438, 0.718004208851903, -122.316673278809, -2.13482867880138, 218, 6, 'PPL', 'P'),
(180590, 'Castellammare', 34.0424995422363, 0.594153702620686, -118.560279846191, -2.06926724540192, 218, 6, 'PPL', 'P'),
(154630, 'Caster Subdivision', 41.5269393920898, 0.7247818206681, -84.5169372558594, -1.47509882881621, 218, 41, 'PPL', 'P'),
(186502, 'Castiel', 38.1072196960449, 0.665096452476817, -103.462501525879, -1.80576130397624, 218, 7, 'PPL', 'P'),
(77984, 'Castile', 39.9886093139648, 0.697932895822357, -80.1263885498047, -1.39846929792638, 218, 45, 'PPL', 'P'),
(147627, 'Castile', 42.6288909912109, 0.74401450427038, -78.0547180175781, -1.36231182612248, 218, 40, 'PPL', 'P'),
(19838, 'Castile Cove', 33.5958290100098, 0.586357831161697, -84.4552764892578, -1.47402264541971, 218, 13, 'PPL', 'P'),
(203308, 'Castilla', 40.0355606079102, 0.698752350489775, -111.525283813477, -1.9464834017663, 218, 52, 'PPL', 'P'),
(39680, 'Castille', 30.3680591583252, 0.530022619753193, -91.0313873291016, -1.58879743155107, 218, 22, 'PPL', 'P'),
(177869, 'Castillo Nuevo Mobile Home Park', 33.4099998474121, 0.583114500428144, -111.759719848633, -1.9505750824651, 218, 5, 'PPL', 'P'),
(72033, 'Castine', 39.9316711425781, 0.696939137261594, -84.6244430541992, -1.47697515896222, 218, 41, 'PPL', 'P'),
(127060, 'Castine', 44.3877792358398, 0.774712895313778, -68.8002777099609, -1.20079137232528, 218, 26, 'PPL', 'P'),
(75361, 'Castle', 35.4744415283203, 0.619145804975399, -96.3819427490234, -1.68218224043913, 218, 42, 'PPL', 'P'),
(45478, 'Castle Acres', 38.8605613708496, 0.678244745094647, -76.6125030517578, -1.33714042644738, 218, 25, 'PPL', 'P'),
(13498, 'Castle Apartments', 39.6722183227539, 0.692410831302078, -75.5877838134766, -1.31925570183084, 218, 10, 'PPL', 'P'),
(177870, 'Castle Butte', 35.3047218322754, 0.616183637473931, -110.34806060791, -1.92593698079829, 218, 5, 'PPL', 'P'),
(177871, 'Castle Canyon Mesa', 34.5908317565918, 0.603723905155941, -112.355003356934, -1.96096473966777, 218, 5, 'PPL', 'P'),
(19840, 'Castle Courts', 33.9294395446777, 0.592180433410992, -84.0536117553711, -1.46701227332424, 218, 13, 'PPL', 'P'),
(19841, 'Castle Cove', 34.2466697692871, 0.597717145317267, -85.2336120605469, -1.48760716382409, 218, 13, 'PPL', 'P'),
(193436, 'Castle Crag', 41.1627807617188, 0.718426053568572, -122.290832519531, -2.13437767247077, 218, 6, 'PPL', 'P'),
(147629, 'Castle Creek', 42.2275009155273, 0.737008925864872, -75.9186096191406, -1.32502970139024, 218, 40, 'PPL', 'P'),
(192508, 'Castle Dale', 39.2122192382813, 0.684382332721871, -111.018890380859, -1.93764516905666, 218, 52, 'PPL', 'P'),
(134595, 'Castle Danger', 47.1208305358887, 0.822413639125541, -91.503059387207, -1.59702966195467, 218, 28, 'PPL', 'P'),
(177872, 'Castle Dome Landing', 32.9650001525879, 0.575347790583092, -114.462783813477, -1.99775244854364, 218, 5, 'PPL', 'P'),
(26732, 'Castle Fin', 39.4700012207031, 0.688881477067451, -87.7333297729492, -1.53123546827593, 218, 18, 'PPL', 'P'),
(77986, 'Castle Fin', 39.7683296203613, 0.694088289893692, -76.32861328125, -1.33218561523929, 218, 45, 'PPL', 'P'),
(29413, 'Castle Garden', 38.0275001525879, 0.663705083965305, -87.399169921875, -1.52540327864671, 218, 19, 'PPL', 'P'),
(159860, 'Castle Garden', 40.8647193908691, 0.713223901274238, -75.4108276367188, -1.31616723391468, 218, 45, 'PPL', 'P'),
(180591, 'Castle Gardens', 37.3566703796387, 0.651996895706935, -120.579719543457, -2.10451311716468, 218, 6, 'PPL', 'P'),
(114874, 'Castle Grove', 42.2605590820313, 0.737585899715038, -91.3166732788086, -1.59377661068314, 218, 16, 'PPL', 'P'),
(127062, 'Castle Harmony', 44.9411087036133, 0.784370316374732, -69.5088882446289, -1.21315895926956, 218, 26, 'PPL', 'P'),
(45479, 'Castle Haven', 38.6263885498047, 0.67415765834873, -76.1730575561523, -1.329470655666, 218, 25, 'PPL', 'P'),
(45480, 'Castle Haven Estates', 38.1533317565918, 0.665901259758239, -75.4094390869141, -1.31614299914876, 218, 25, 'PPL', 'P'),
(63500, 'Castle Hayne', 34.3555603027344, 0.599617643650175, -77.9002838134766, -1.35961644078321, 218, 33, 'PPL', 'P'),
(85596, 'Castle Heights', 35.9536094665527, 0.627508863167547, -83.1591720581055, -1.45140135564641, 218, 50, 'PPL', 'P'),
(100559, 'Castle Heights', 36.6158294677734, 0.639066782561409, -78.3088912963867, -1.36674798670828, 218, 53, 'PPL', 'P'),
(15460, 'Castle Hill', 28.545560836792, 0.498214023430368, -81.684440612793, -1.42566243634301, 218, 12, 'PPL', 'P'),
(100560, 'Castle Hill', 37.2305603027344, 0.649795859645012, -79.9986114501953, -1.39623916682954, 218, 53, 'PPL', 'P'),
(93102, 'Castle Hill Estate', 32.8672218322754, 0.573641236956569, -97.5155563354492, -1.7019675299676, 218, 51, 'PPL', 'P'),
(13499, 'Castle Hills', 39.6863899230957, 0.692658172388319, -75.5650024414063, -1.31885809188009, 218, 10, 'PPL', 'P'),
(93103, 'Castle Hills', 29.5230598449707, 0.515274599558065, -98.51611328125, -1.71943054302553, 218, 51, 'PPL', 'P'),
(177873, 'Castle Hot Springs', 33.9833297729492, 0.593120995328981, -112.359718322754, -1.96104703134546, 218, 5, 'PPL', 'P'),
(119052, 'Castle Junction', 41.3925018310547, 0.722435442589686, -90.5777816772461, -1.58088051942054, 218, 18, 'PPL', 'P'),
(45481, 'Castle Manor', 38.9544410705566, 0.679883254955318, -76.9561080932617, -1.34313746574807, 218, 25, 'PPL', 'P'),
(45482, 'Castle Marina', 38.9833297729492, 0.680387457928697, -76.2852783203125, -1.3314292774897, 218, 25, 'PPL', 'P'),
(45483, 'Castle Oaks', 39.5894393920898, 0.69096606641071, -76.8647232055664, -1.34154249857122, 218, 25, 'PPL', 'P'),
(130117, 'Castle Park', 42.7480583190918, 0.746094366502705, -86.2069396972656, -1.50459493578549, 218, 27, 'PPL', 'P'),
(180593, 'Castle Park', 32.610279083252, 0.569156739996985, -117.066673278809, -2.04319889307168, 218, 6, 'PPL', 'P'),
(186503, 'Castle Pines', 39.4580612182617, 0.688673084712152, -104.895561218262, -1.83077291398594, 218, 7, 'PPL', 'P'),
(53899, 'Castle Point', 38.7580604553223, 0.676455766632386, -90.2480621337891, -1.57512582777904, 218, 29, 'PPL', 'P'),
(147634, 'Castle Point', 41.5461082458496, 0.725116380280041, -73.9599990844727, -1.29084549879604, 218, 40, 'PPL', 'P'),
(39683, 'Castle Ridge Estates', 30.3638896942139, 0.529949848876406, -91.0086135864258, -1.58839995475837, 218, 22, 'PPL', 'P'),
(77985, 'Castle Rock', 39.9741706848145, 0.697680894204209, -75.440559387207, -1.31668615085308, 218, 45, 'PPL', 'P'),
(100561, 'Castle Rock', 37.2355613708496, 0.649883144749739, -80.0336074829102, -1.39684996282555, 218, 53, 'PPL', 'P'),
(134593, 'Castle Rock', 44.5438919067383, 0.777437575425038, -93.1522216796875, -1.62581297385819, 218, 28, 'PPL', 'P'),
(186504, 'Castle Rock', 39.3722190856934, 0.687174856861901, -104.855560302734, -1.83007476630618, 218, 7, 'PPL', 'P'),
(201977, 'Castle Rock', 44.9644393920898, 0.784777513705405, -103.423889160156, -1.8050873910624, 218, 49, 'PPL', 'P'),
(203311, 'Castle Rock', 41.1116714477539, 0.71753402776145, -111.202499389648, -1.94084975079635, 218, 52, 'PPL', 'P'),
(206980, 'Castle Rock', 46.2752799987793, 0.807655998260976, -122.906387329102, -2.14512113062426, 218, 56, 'PPL', 'P'),
(53900, 'Castle Rock (historical)', 38.4708290100098, 0.671442632196421, -92.1547164916992, -1.60840322402207, 218, 29, 'PPL', 'P'),
(196173, 'Castle Rock (historical)', 45.875560760498, 0.800679581469405, -106.802780151367, -1.86406016392501, 218, 31, 'PPL', 'P'),
(159862, 'Castle Rock Acres', 41.0927810668945, 0.717204328418498, -75.1094436645508, -1.31090709128761, 218, 45, 'PPL', 'P'),
(100562, 'Castle Rock Farms', 37.2305603027344, 0.649795859645012, -80.0302810668945, -1.39679190591379, 218, 53, 'PPL', 'P'),
(180594, 'Castle Rock Springs', 38.7702789306641, 0.676669019256674, -122.715560913086, -2.14179058136501, 218, 6, 'PPL', 'P'),
(100563, 'Castle Rock West', 37.232780456543, 0.649834608638872, -80.0347213745117, -1.39686940390151, 218, 53, 'PPL', 'P'),
(159863, 'Castle Rocks', 41.0977783203125, 0.717291546944198, -77.241943359375, -1.34812623226006, 218, 45, 'PPL', 'P'),
(194700, 'Castle Rocks', 43.3283309936523, 0.75622203523314, -115.313606262207, -2.01260210162386, 218, 17, 'PPL', 'P'),
(159864, 'Castle Shannon', 40.3647193908691, 0.704497255014267, -80.0224990844727, -1.3966560846982, 218, 45, 'PPL', 'P'),
(196174, 'Castle Town', 46.4413909912109, 0.810555182002664, -110.671112060547, -1.93157529230015, 218, 31, 'PPL', 'P'),
(159866, 'Castle Valley', 40.2872200012207, 0.703144635496615, -75.1594390869141, -1.31177967601877, 218, 45, 'PPL', 'P'),
(192509, 'Castle Valley', 38.6394386291504, 0.674385425200959, -109.408332824707, -1.90953563690893, 218, 52, 'PPL', 'P'),
(1394, 'Castleberry', 31.2988891601563, 0.546268668061489, -87.0224990844727, -1.5188291323378, 218, 2, 'PPL', 'P'),
(7946, 'Castleberry (historical)', 33.4983291625977, 0.584656137804164, -92.2111129760742, -1.60938752836096, 218, 4, 'PPL', 'P'),
(194701, 'Castleford', 42.5208282470703, 0.742128453586386, -114.867500305176, -2.00481608386091, 218, 17, 'PPL', 'P'),
(203313, 'Castleford Estates', 40.6355590820313, 0.70922429937013, -111.990562438965, -1.95460404572023, 218, 52, 'PPL', 'P'),
(19843, 'Castlegate', 33.589168548584, 0.586241584180115, -84.456672668457, -1.47404701334368, 218, 13, 'PPL', 'P'),
(19844, 'Castlegate East', 33.6097183227539, 0.586600245399922, -85.0341720581055, -1.4841262791213, 218, 13, 'PPL', 'P'),
(63502, 'Castlehaven', 35.5263900756836, 0.620052478168516, -78.3525009155273, -1.36750911814782, 218, 33, 'PPL', 'P'),
(58917, 'Castleman', 33.2036094665527, 0.579512308737703, -90.5186080932617, -1.5798477455498, 218, 30, 'PPL', 'P'),
(100564, 'Castlemans Ferry', 39.1202812194824, 0.682777711586071, -77.8908309936523, -1.35945145795368, 218, 53, 'PPL', 'P'),
(45484, 'Castlemore', 38.6566696166992, 0.674686162667056, -76.6666717529297, -1.33808584863436, 218, 25, 'PPL', 'P'),
(206981, 'Castlenook (historical)', 47.2658309936523, 0.824944374530416, -122.634437561035, -2.14037471177147, 218, 56, 'PPL', 'P'),
(45485, 'Castles Rising', 39.5230598449707, 0.689807524757498, -76.8955612182617, -1.34208072342753, 218, 25, 'PPL', 'P'),
(29414, 'Castleton', 39.9069404602051, 0.69650750542792, -86.0522232055664, -1.5018946235982, 218, 19, 'PPL', 'P'),
(31979, 'Castleton', 37.8677787780762, 0.660917420094264, -97.9688873291016, -1.70987964840818, 218, 20, 'PPL', 'P'),
(45486, 'Castleton', 39.6747207641602, 0.692454507143955, -76.2149963378906, -1.33020262549161, 218, 25, 'PPL', 'P'),
(100565, 'Castleton', 38.6058311462402, 0.673798863970869, -78.1069412231445, -1.36322329300556, 218, 53, 'PPL', 'P'),
(119053, 'Castleton', 41.1177787780762, 0.71764062078408, -89.7061080932617, -1.56566694537735, 218, 18, 'PPL', 'P'),
(177366, 'Castleton', 43.6105613708496, 0.761147884564378, -73.1802825927734, -1.27723687878379, 218, 55, 'PPL', 'P'),
(201978, 'Castleton (historical)', 44.0652809143066, 0.769084237770868, -103.655563354492, -1.80913086854547, 218, 49, 'PPL', 'P'),
(147630, 'Castleton Corners', 40.6130599975586, 0.708831616267398, -74.1227798461914, -1.29368655904694, 218, 40, 'PPL', 'P'),
(171831, 'Castleton Corners', 43.6083297729492, 0.761108935833435, -73.2083282470703, -1.27772636779215, 218, 55, 'PPL', 'P'),
(147631, 'Castleton-on-Hudson', 42.5183296203613, 0.742084844323536, -73.7516708374023, -1.28720948495975, 218, 40, 'PPL', 'P'),
(7948, 'Castleville (historical)', 36.2574996948242, 0.632812748215522, -94.3052825927734, -1.64593768326759, 218, 4, 'PPL', 'P'),
(39682, 'Castlewood', 30.454719543457, 0.531535128804789, -91.086669921875, -1.589762294814, 218, 22, 'PPL', 'P'),
(53901, 'Castlewood', 38.5499992370605, 0.672824413328009, -90.5536117553711, -1.58045867470387, 218, 29, 'PPL', 'P'),
(100566, 'Castlewood', 36.8899993896484, 0.643851950408064, -82.2797164916992, -1.43605196038763, 218, 53, 'PPL', 'P'),
(159869, 'Castlewood', 40.9249992370605, 0.714275983062874, -80.2744369506836, -1.40105322997403, 218, 45, 'PPL', 'P'),
(169983, 'Castlewood', 44.7227783203125, 0.780559732328992, -97.0297164916992, -1.69348802505679, 218, 49, 'PPL', 'P'),
(186505, 'Castlewood', 39.5847206115723, 0.690883708153999, -104.90055847168, -1.83086013251164, 218, 7, 'PPL', 'P'),
(19846, 'Castlewood Estates', 33.788890838623, 0.58972739573092, -84.5316696166992, -1.47535595701945, 218, 13, 'PPL', 'P'),
(19847, 'Castlewood Mobile Home Park', 33.8036117553711, 0.589984324197086, -84.0911102294922, -1.46766674516212, 218, 13, 'PPL', 'P'),
(196175, 'Castner Falls', 47.3066711425781, 0.825657169596176, -111.494720458984, -1.94594997059996, 218, 31, 'PPL', 'P'),
(194702, 'Casto', 44.5680618286133, 0.777859420141707, -114.847778320313, -2.00447187029002, 218, 17, 'PPL', 'P'),
(203315, 'Casto Gardens', 40.6616706848145, 0.70968003281167, -111.812782287598, -1.95150119673418, 218, 52, 'PPL', 'P'),
(203314, 'Casto Pines Condominium', 40.6597213745117, 0.709646010928744, -111.818061828613, -1.95159334210789, 218, 52, 'PPL', 'P'),
(191235, 'Castolon', 29.1330604553223, 0.508467826127932, -103.513893127441, -1.80665825663138, 218, 51, 'PPL', 'P'),
(75363, 'Caston', 34.957218170166, 0.610118554407384, -94.8327789306641, -1.655144231156, 218, 42, 'PPL', 'P'),
(39684, 'Castor', 32.253059387207, 0.562922080148027, -93.1655578613281, -1.62604573413746, 218, 22, 'PPL', 'P'),
(53902, 'Castor', 37.0675010681152, 0.646949939125126, -89.9786071777344, -1.57042295161007, 218, 29, 'PPL', 'P'),
(93105, 'Castor', 31.3688907623291, 0.547490426501077, -98.5100021362305, -1.71932388342387, 218, 51, 'PPL', 'P'),
(39685, 'Castor Plunge', 31.2083301544189, 0.544688115244041, -92.5938873291016, -1.61606820111348, 218, 22, 'PPL', 'P'),
(53903, 'Castor Station', 37.5277786254883, 0.654983297974323, -90.1694412231445, -1.57375363402738, 218, 29, 'PPL', 'P'),
(63504, 'Castoria', 35.5363883972168, 0.620226981798944, -77.6747207641602, -1.3556796229018, 218, 33, 'PPL', 'P'),
(147632, 'Castorland', 43.8883285522461, 0.76599583643373, -75.5116729736328, -1.31792731707911, 218, 40, 'PPL', 'P'),
(180595, 'Castro City', 37.4025001525879, 0.65279677614034, -122.102500915527, -2.13109066589534, 218, 6, 'PPL', 'P'),
(180596, 'Castro Valley', 37.6941719055176, 0.657887408564027, -122.08528137207, -2.13079012816633, 218, 6, 'PPL', 'P'),
(93104, 'Castroville', 29.3555603027344, 0.512351181050458, -98.8783264160156, -1.72575235482116, 218, 51, 'PPL', 'P'),
(180597, 'Castroville', 36.7658309936523, 0.641684803071012, -121.756942749023, -2.12505953813269, 218, 6, 'PPL', 'P'),
(63505, 'Casville', 36.3899993896484, 0.635125304148092, -79.5044403076172, -1.38761425332321, 218, 33, 'PPL', 'P'),
(1395, 'Caswell', 30.2936096191406, 0.528723230167829, -87.539436340332, -1.52785138947877, 218, 2, 'PPL', 'P'),
(85599, 'Caswell', 36.0263900756836, 0.628779124428488, -83.8430633544922, -1.46333751049409, 218, 50, 'PPL', 'P'),
(180598, 'Caswell', 34.7222213745117, 0.606017086591581, -118.797500610352, -2.07340752879061, 218, 6, 'PPL', 'P'),
(63506, 'Caswell Beach', 33.8958282470703, 0.591593805601875, -78.0513916015625, -1.36225376921072, 218, 33, 'PPL', 'P'),
(85601, 'Cat Corner', 36.2136116027832, 0.632046756506988, -89.4141693115234, -1.56057165242176, 218, 50, 'PPL', 'P'),
(196176, 'Cat Creek', 47.0652809143066, 0.821444115330698, -108.005561828613, -1.88505266437561, 218, 31, 'PPL', 'P'),
(147633, 'Cat Elbow Corner', 42.5441703796387, 0.742535850654141, -76.8488922119141, -1.34126619560813, 218, 40, 'PPL', 'P'),
(80189, 'Cat Hole', 33.1444396972656, 0.578479601445998, -80.6941680908203, -1.40837892034256, 218, 48, 'PPL', 'P'),
(93106, 'Cat Spring', 29.8452796936035, 0.520898396831986, -96.3255615234375, -1.68119820241635, 218, 51, 'PPL', 'P'),
(63510, 'Cat Square', 35.5400009155273, 0.620290032137751, -81.4108276367188, -1.42088698903434, 218, 33, 'PPL', 'P'),
(39686, 'Catahoula', 30.2144393920898, 0.527341449036242, -91.7088928222656, -1.60062213310713, 218, 22, 'PPL', 'P'),
(58918, 'Catahoula', 30.4930591583252, 0.532204281318186, -89.4955596923828, -1.5619921825472, 218, 30, 'PPL', 'P'),
(39689, 'Catahoula Cove', 30.1933307647705, 0.526973033988943, -91.7461090087891, -1.601271678097, 218, 22, 'PPL', 'P'),
(194703, 'Cataldo', 47.5488891601563, 0.829884671510568, -116.32861328125, -2.03031731603702, 218, 17, 'PPL', 'P'),
(75364, 'Catale', 36.5608291625977, 0.63810684614649, -95.3716735839844, -1.66454971717783, 218, 42, 'PPL', 'P'),
(159867, 'Catalina', 40.2891693115234, 0.703178657379541, -76.8199996948242, -1.34076192605572, 218, 45, 'PPL', 'P'),
(177874, 'Catalina', 32.5, 0.567232006898157, -110.920562744141, -1.93592902805021, 218, 5, 'PPL', 'P'),
(19848, 'Catalina Beach Estates', 31.6063899993896, 0.551635570158758, -84.1208267211914, -1.46818539578442, 218, 13, 'PPL', 'P'),
(203316, 'Catalina Estates', 40.7000007629395, 0.710349018877498, -112.083061218262, -1.95621845397303, 218, 52, 'PPL', 'P'),
(177875, 'Catalina Foothills', 32.297779083252, 0.563702586084502, -110.918060302734, -1.93588535220833, 218, 5, 'PPL', 'P'),
(13500, 'Catalina Gardens', 39.6513900756836, 0.692047309813282, -75.7458267211914, -1.32201407092989, 218, 10, 'PPL', 'P'),
(177876, 'Catalina Village', 33.4597206115723, 0.583982291469347, -112.146110534668, -1.95731887213545, 218, 5, 'PPL', 'P'),
(63511, 'Cataloochee', 35.6399993896484, 0.622035334758135, -83.0802764892578, -1.45002436820478, 218, 33, 'PPL', 'P'),
(1396, 'Catalpa', 31.8794403076172, 0.556401197060914, -85.8330612182617, -1.49806952532452, 218, 2, 'PPL', 'P'),
(7950, 'Catalpa', 35.6913909912109, 0.622932287413273, -93.5263900756836, -1.63234344432523, 218, 4, 'PPL', 'P'),
(53906, 'Catalpa', 36.8827781677246, 0.643725916309476, -89.2944412231445, -1.55848200307242, 218, 29, 'PPL', 'P'),
(85602, 'Catalpa', 35.3194389343262, 0.616440499361069, -86.7119369506836, -1.51340880057116, 218, 50, 'PPL', 'P'),
(100568, 'Catalpa', 38.5105590820313, 0.67213605276525, -77.9880599975586, -1.36114842420028, 218, 53, 'PPL', 'P'),
(141441, 'Catalpa', 42.7761116027832, 0.746583988669116, -98.8683319091797, -1.72557791776976, 218, 35, 'PPL', 'P'),
(39688, 'Catalpa (historical)', 30.8533306121826, 0.538492204388944, -91.3766708374023, -1.59482376562375, 218, 22, 'PPL', 'P'),
(29416, 'Cataract', 39.4275016784668, 0.688139720124836, -86.8163909912109, -1.51523186749537, 218, 19, 'PPL', 'P'),
(173465, 'Cataract', 44.0877799987793, 0.7694769208736, -90.8422164916992, -1.58549577758964, 218, 57, 'PPL', 'P'),
(93107, 'Catarina', 28.3452796936035, 0.494718458052071, -99.6130599975586, -1.73857587494405, 218, 51, 'PPL', 'P'),
(80190, 'Catarrh', 34.565559387207, 0.603282819100396, -80.3675003051758, -1.40267749192287, 218, 48, 'PPL', 'P'),
(159868, 'Catasauqua', 40.6547203063965, 0.709558725824017, -75.4749984741211, -1.31728722631111, 218, 45, 'PPL', 'P'),
(85603, 'Cataska', 35.232780456543, 0.614928023598986, -84.3266677856445, -1.47177800009493, 218, 50, 'PPL', 'P'),
(147635, 'Catatonk', 42.1569404602051, 0.735777413597792, -76.3077774047852, -1.33182196059243, 218, 40, 'PPL', 'P'),
(19849, 'Cataula', 32.6552810668945, 0.569942172781476, -84.8686065673828, -1.48123661618051, 218, 13, 'PPL', 'P'),
(124457, 'Cataumet', 41.6661109924316, 0.727210823319334, -70.6202774047852, -1.23255635938526, 218, 23, 'PPL', 'P'),
(124458, 'Cataumet Station', 41.6655616760254, 0.72720123593941, -70.6138916015625, -1.23244490609364, 218, 23, 'PPL', 'P'),
(15461, 'Catawba', 28.6883296966553, 0.500705810104301, -82.3766708374023, -1.43774413294427, 218, 12, 'PPL', 'P'),
(35171, 'Catawba', 38.7202796936035, 0.675796367946483, -84.3244400024414, -1.47173911794302, 218, 21, 'PPL', 'P'),
(53907, 'Catawba', 39.6408309936523, 0.691863019065849, -93.8333282470703, -1.63770052601598, 218, 29, 'PPL', 'P'),
(63513, 'Catawba', 35.707218170166, 0.623208523797342, -81.0758285522461, -1.41504015201912, 218, 33, 'PPL', 'P'),
(70620, 'Catawba', 39.4069404602051, 0.687780859167948, -74.7144393920898, -1.30401296617372, 218, 37, 'PPL', 'P'),
(72035, 'Catawba', 39.9991683959961, 0.698117186569791, -83.6216735839844, -1.45947353006849, 218, 41, 'PPL', 'P'),
(80191, 'Catawba', 34.8527793884277, 0.60829575379928, -80.9113922119141, -1.4121701964704, 218, 48, 'PPL', 'P'),
(100572, 'Catawba', 36.9222183227539, 0.644414276872234, -78.9505615234375, -1.37794724488233, 218, 53, 'PPL', 'P'),
(108514, 'Catawba', 39.5269393920898, 0.689875235628214, -80.0780563354492, -1.39762574165109, 218, 58, 'PPL', 'P'),
(147637, 'Catawba', 42.4955596923828, 0.741687434109869, -77.1602783203125, -1.34670090844465, 218, 40, 'PPL', 'P'),
(173466, 'Catawba', 45.5363883972168, 0.794759906998377, -90.5297164916992, -1.58004162367716, 218, 57, 'PPL', 'P'),
(63514, 'Catawba (historical)', 35.2155609130859, 0.61462748586997, -81.0652770996094, -1.41485599442974, 218, 33, 'PPL', 'P'),
(63518, 'Catawba Heights', 35.7000007629395, 0.623082556277781, -80.4841690063477, -1.40471374489234, 218, 33, 'PPL', 'P'),
(113231, 'Catawba Island', 41.5852813720703, 0.725800080310892, -82.8369369506836, -1.44577729205638, 218, 41, 'PPL', 'P'),
(80192, 'Catawba Ridge', 35.101390838623, 0.612634842163346, -81.0666732788086, -1.41488036235372, 218, 48, 'PPL', 'P'),
(154632, 'Catawba Station', 40.0294418334961, 0.698645557730063, -83.6516723632813, -1.4599971075388, 218, 41, 'PPL', 'P'),
(53908, 'Catawissa', 38.4247207641602, 0.670637891494026, -90.7825012207031, -1.58445354949704, 218, 29, 'PPL', 'P'),
(159871, 'Catawissa', 40.9519386291504, 0.714746164153327, -76.4599990844727, -1.3344787300959, 218, 45, 'PPL', 'P'),
(72034, 'Catbird', 38.7372207641602, 0.676092045406509, -83.5547180175781, -1.45830493498217, 218, 41, 'PPL', 'P'),
(80193, 'Catchall', 34.0094413757324, 0.593576728770521, -80.4905624389648, -1.40482533134201, 218, 48, 'PPL', 'P'),
(7951, 'Catcher', 35.4075012207031, 0.617977476205181, -94.2763900756836, -1.64543341371518, 218, 4, 'PPL', 'P'),
(45487, 'Catchpenny', 38.3547210693359, 0.669416166343952, -75.7241668701172, -1.32163603521315, 218, 25, 'PPL', 'P'),
(85604, 'Cate crossroad', 35.9908294677734, 0.628158474736445, -83.5861129760742, -1.45885288037645, 218, 50, 'PPL', 'P'),
(80194, 'Cateechee', 34.7705612182617, 0.606860776024918, -82.7738876342773, -1.44467687389396, 218, 48, 'PPL', 'P'),
(29415, 'Cates', 39.9966697692871, 0.698073577306941, -87.3377838134766, -1.52433188894018, 218, 19, 'PPL', 'P'),
(63521, 'Cates', 36.2949981689453, 0.633467220053409, -78.9872207641602, -1.37858706933423, 218, 33, 'PPL', 'P'),
(85605, 'Cates', 36.4436111450195, 0.636061005797091, -89.4775009155273, -1.56167699743219, 218, 50, 'PPL', 'P'),
(75365, 'Catesby', 36.4930610656738, 0.636924069727359, -99.9625015258789, -1.74467478015644, 218, 42, 'PPL', 'P'),
(85606, 'Cateston', 35.7947196960449, 0.624735713524448, -86.1505584716797, -1.5036108977627, 218, 50, 'PPL', 'P'),
(7955, 'Catesville', 33.1044387817383, 0.577781453766233, -92.663330078125, -1.61728020572558, 218, 4, 'PPL', 'P'),
(63522, 'Catfish', 35.7550010681152, 0.6240424926927, -81.1180572509766, -1.4157771818508, 218, 33, 'PPL', 'P'),
(159874, 'Catfish', 41.0063896179199, 0.715696513188322, -79.5869369506836, -1.38905409136656, 218, 45, 'PPL', 'P'),
(26733, 'Catfish (historical)', 39.6716690063477, 0.692401243922154, -87.9277801513672, -1.53462926761108, 218, 18, 'PPL', 'P'),
(173469, 'Catfish (historical)', 43.1513900756836, 0.753133833633084, -89.4030609130859, -1.5603777742944, 218, 57, 'PPL', 'P'),
(19850, 'Catfish Acres', 30.7686100006104, 0.537013550772705, -81.6902770996094, -1.42576430225471, 218, 13, 'PPL', 'P'),
(147636, 'Catfish Corners', 43.3699989318848, 0.756949277947813, -76.2072219848633, -1.33006693743407, 218, 40, 'PPL', 'P'),
(39690, 'Catfish Landing', 30.2999992370605, 0.528834750038476, -90.6483306884766, -1.58211183195053, 218, 22, 'PPL', 'P'),
(80195, 'Catfish Landing', 33.9669418334961, 0.592834971827906, -79.4819412231445, -1.38722157022048, 218, 48, 'PPL', 'P'),
(177877, 'Catfish Paradise', 34.7449989318848, 0.606414629963302, -114.486671447754, -1.99816936641229, 218, 5, 'PPL', 'P'),
(58919, 'Catfish Point Landing', 33.702220916748, 0.588214720231755, -91.163330078125, -1.59110026694566, 218, 30, 'PPL', 'P'),
(206982, 'Cathan', 48.1144409179688, 0.839755411774838, -122.276107788086, -2.13412067742558, 218, 56, 'PPL', 'P'),
(127065, 'Cathance', 43.958610534668, 0.767222488431821, -69.9302825927734, -1.22051367809397, 218, 26, 'PPL', 'P'),
(31982, 'Catharine', 38.9272193908691, 0.679408147016848, -99.2163925170898, -1.73165272137428, 218, 20, 'PPL', 'P'),
(119054, 'Catharine', 41.5230598449707, 0.724714109797385, -88.7191696166992, -1.54844161944672, 218, 18, 'PPL', 'P'),
(147638, 'Catharine', 42.3127784729004, 0.73849730001909, -76.7850036621094, -1.34015113005971, 218, 40, 'PPL', 'P'),
(100574, 'Catharpin', 38.8541717529297, 0.678133225224, -77.5722198486328, -1.35389064443954, 218, 53, 'PPL', 'P'),
(100576, 'Catharpin Farms', 38.851390838623, 0.678084689113133, -77.5772171020508, -1.35397786296524, 218, 53, 'PPL', 'P'),
(100575, 'Catharpin Farms Estates', 38.8327789306641, 0.677759850039171, -77.5877838134766, -1.35416228687073, 218, 53, 'PPL', 'P'),
(139771, 'Cathay', 47.5533294677734, 0.829962169498289, -99.4086074829102, -1.73500750539945, 218, 34, 'PPL', 'P'),
(206983, 'Cathcart', 47.8480606079102, 0.835106198301832, -122.09806060791, -2.13101316790762, 218, 56, 'PPL', 'P'),
(186506, 'Cathedral', 38.0958290100098, 0.664897647501442, -107.033332824707, -1.86808406717406, 218, 7, 'PPL', 'P'),
(180600, 'Cathedral City', 33.7797203063965, 0.589567339749406, -116.46443939209, -2.03268792888135, 218, 6, 'PPL', 'P'),
(13053, 'Cathedral Heights', 38.9255599975586, 0.679379185139993, -77.0777816772461, -1.3452610704013, 218, 9, 'PPL', 'P'),
(194704, 'Cathedral Pines', 43.7775001525879, 0.764061515954979, -114.525833129883, -1.99885286670606, 218, 17, 'PPL', 'P'),
(114876, 'Cathedral Square', 42.4947204589844, 0.741672786723873, -90.6761093139648, -1.58259666042698, 218, 16, 'PPL', 'P'),
(100577, 'Cather Estates', 39.1994400024414, 0.684159292980577, -78.0063934326172, -1.36146840300525, 218, 53, 'PPL', 'P'),
(1398, 'Catherine', 32.184440612793, 0.561724456605819, -87.4694366455078, -1.5266296643287, 218, 2, 'PPL', 'P'),
(39693, 'Catherine', 30.461669921875, 0.531656435792443, -91.2611083984375, -1.59280682057218, 218, 22, 'PPL', 'P'),
(186507, 'Catherine', 39.4072189331055, 0.687785719436937, -107.152221679688, -1.8701590691374, 218, 7, 'PPL', 'P'),
(93108, 'Catherine Colonia', 26.2700004577637, 0.458498002488394, -97.9739990234375, -1.70996886430469, 218, 51, 'PPL', 'P'),
(100578, 'Catherine Furnace', 38.5574989318848, 0.672955307695586, -78.6358337402344, -1.37245420881794, 218, 53, 'PPL', 'P'),
(63525, 'Catherine Lake', 34.8175010681152, 0.607680030955253, -77.5641708374023, -1.35375016269204, 218, 33, 'PPL', 'P'),
(53909, 'Catherine Place', 37.5750007629395, 0.655807479752675, -90.3241729736328, -1.57645421253077, 218, 29, 'PPL', 'P'),
(63523, 'Catherine Square', 34.875560760498, 0.608693363750028, -77.7908325195313, -1.3577061553333, 218, 33, 'PPL', 'P'),
(147640, 'Catherineville', 44.6294403076172, 0.778930676690191, -74.7675018310547, -1.30493908044279, 218, 40, 'PPL', 'P'),
(45488, 'Cathers Corner', 39.6525001525879, 0.692066684310213, -76.0505599975586, -1.32733266994289, 218, 25, 'PPL', 'P'),
(63524, 'Cathey (historical)', 35.3116683959961, 0.616304877882557, -81.1102828979492, -1.41564149379326, 218, 33, 'PPL', 'P'),
(180601, 'Catheys Valley', 37.4324989318848, 0.65332035361065, -120.096939086914, -2.09608700863372, 218, 6, 'PPL', 'P'),
(206985, 'Cathlamet', 46.2033309936523, 0.806400251227977, -123.381942749023, -2.1534211384776, 218, 56, 'PPL', 'P'),
(206984, 'Cathlapotle (historical)', 45.8486099243164, 0.80020920064187, -122.773612976074, -2.14280378100173, 218, 56, 'PPL', 'P'),
(80198, 'Catholic Hill', 32.7763900756836, 0.572055923738672, -80.6611099243164, -1.4078019464924, 218, 48, 'PPL', 'P'),
(7952, 'Catholic Point', 35.3441696166992, 0.616872131194744, -92.5527801513672, -1.61535074551581, 218, 4, 'PPL', 'P'),
(113108, 'Cathro', 45.1588897705078, 0.788171313040548, -83.554443359375, -1.45830014129221, 218, 27, 'PPL', 'P'),
(63528, 'Catilina', 36.3758316040039, 0.634878029640878, -78.8127822875977, -1.37554254357605, 218, 33, 'PPL', 'P'),
(85607, 'Catlen', 35.8833312988281, 0.626282277748484, -85.720832824707, -1.49611077034277, 218, 50, 'PPL', 'P'),
(19851, 'Catlett', 34.749439239502, 0.606492127951023, -85.192497253418, -1.48688957506837, 218, 13, 'PPL', 'P'),
(100579, 'Catlett', 38.6536102294922, 0.6746327662872, -77.6408309936523, -1.35508813482369, 218, 53, 'PPL', 'P'),
(180602, 'Catlett', 38.8452796936035, 0.677978029511475, -121.537498474121, -2.121229513011, 218, 6, 'PPL', 'P'),
(35172, 'Catlettsburg', 38.4047203063965, 0.670288817654144, -82.6005630493164, -1.44165178921174, 218, 21, 'PPL', 'P'),
(85608, 'Catlettsburg', 35.9044418334961, 0.626650726085296, -83.5811080932617, -1.4587655286927, 218, 50, 'PPL', 'P'),
(19852, 'Catlin', 32.5111083984375, 0.567425885025515, -82.8219375610352, -1.44551550332123, 218, 13, 'PPL', 'P'),
(29418, 'Catlin', 39.6936111450195, 0.692784206486907, -87.2352828979492, -1.52254291047791, 218, 19, 'PPL', 'P'),
(119055, 'Catlin', 40.064998626709, 0.699266140843078, -87.7019424438477, -1.5306876560397, 218, 18, 'PPL', 'P'),
(45489, 'Catlin (historical)', 39.2050018310547, 0.68425636520231, -76.0041732788086, -1.3265230689715, 218, 25, 'PPL', 'P'),
(147641, 'Catlin Hill', 42.1047210693359, 0.73486601329374, -76.3380584716797, -1.33235046491076, 218, 40, 'PPL', 'P'),
(171833, 'Catlinsburg (historical)', 44.4808311462402, 0.776336957525535, -73.1900024414063, -1.27740652214523, 218, 55, 'PPL', 'P'),
(35173, 'Catnip', 37.9322204589844, 0.662042139601632, -84.5561065673828, -1.47578246226803, 218, 21, 'PPL', 'P'),
(7954, 'Cato', 34.9283294677734, 0.609614351434005, -92.2611083984375, -1.61026011309213, 218, 4, 'PPL', 'P'),
(29417, 'Cato', 38.4366683959961, 0.670846417007379, -87.1855621337891, -1.52167511943671, 218, 19, 'PPL', 'P'),
(31984, 'Cato', 37.667781829834, 0.657426814853497, -94.7397232055664, -1.65352010236521, 218, 20, 'PPL', 'P'),
(53910, 'Cato', 36.7208290100098, 0.64089937028652, -93.6800003051758, -1.63502444859461, 218, 29, 'PPL', 'P'),
(58920, 'Cato', 32.0900001525879, 0.560076159628141, -89.878059387207, -1.56866806160976, 218, 30, 'PPL', 'P'),
(85609, 'Cato', 36.3972206115723, 0.63525133824668, -86.0341720581055, -1.50157957164125, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(112500, 'Cato', 36.1458282470703, 0.630863713771747, -98.0322189331055, -1.71098499341861, 218, 42, 'PPL', 'P'),
(147643, 'Cato', 43.1680603027344, 0.753424783982175, -76.5733337402344, -1.33645679299555, 218, 40, 'PPL', 'P'),
(173470, 'Cato', 44.1427803039551, 0.770436857288519, -87.8611068725586, -1.53346559937277, 218, 57, 'PPL', 'P'),
(80196, 'Cato Estates', 34.9719390869141, 0.61037548287355, -81.0438919067383, -1.41448275240297, 218, 48, 'PPL', 'P'),
(45490, 'Catoctin Acres', 39.452220916748, 0.688571152221429, -77.5022201538086, -1.35266891928947, 218, 25, 'PPL', 'P'),
(45491, 'Catoctin Furnace', 39.5791702270508, 0.690786835669348, -77.4327774047852, -1.35145691467737, 218, 25, 'PPL', 'P'),
(45494, 'Catoctin Hills', 39.4563903808594, 0.688643923098216, -77.5419387817383, -1.35336214012121, 218, 25, 'PPL', 'P'),
(45495, 'Catoctin Manor Estates', 39.4913902282715, 0.689254785673252, -77.4186096191406, -1.35120964017016, 218, 25, 'PPL', 'P'),
(45497, 'Catoctin Point', 39.3555603027344, 0.686884106249891, -77.5238876342773, -1.35304708816426, 218, 25, 'PPL', 'P'),
(45499, 'Catoctin View', 39.3902816772461, 0.687490108555939, -77.2350006103516, -1.34800505843046, 218, 25, 'PPL', 'P'),
(80197, 'Catoe (historical)', 34.7394409179688, 0.606317624320596, -80.1205596923828, -1.39836756517274, 218, 48, 'PPL', 'P'),
(1399, 'Catoma', 32.3133316040039, 0.563974028778609, -86.4336090087891, -1.5085510615848, 218, 2, 'PPL', 'P'),
(85610, 'Caton', 35.8002815246582, 0.624832785746181, -83.4508285522461, -1.45649172175399, 218, 50, 'PPL', 'P'),
(177377, 'Caton', 42.0561103820801, 0.734017596749468, -77.0280609130859, -1.3443932793601, 218, 40, 'PPL', 'P'),
(119057, 'Caton Farm', 41.5652809143066, 0.72545100647101, -88.2391662597656, -1.5400639804476, 218, 18, 'PPL', 'P'),
(85611, 'Catons Grove', 35.7922210693359, 0.624692104261598, -83.2072219848633, -1.45223998507368, 218, 50, 'PPL', 'P'),
(45500, 'Catonsville', 39.2719383239746, 0.685424627393501, -76.7322235107422, -1.33922994263865, 218, 25, 'PPL', 'P'),
(45501, 'Catonsville Gateway', 39.2900009155273, 0.685739879087539, -76.7658309936523, -1.33981650386874, 218, 25, 'PPL', 'P'),
(45502, 'Catonsville Heights', 39.2786102294922, 0.685541074112164, -76.746940612793, -1.33948680452579, 218, 25, 'PPL', 'P'),
(45503, 'Catonsville Manor', 39.2963905334473, 0.685851398958186, -76.73388671875, -1.33925897109454, 218, 25, 'PPL', 'P'),
(75366, 'Catoosa', 36.1888885498047, 0.631615257831368, -95.7455596923828, -1.67107526079685, 218, 42, 'PPL', 'P'),
(85612, 'Catoosa', 36.0541687011719, 0.629263952904937, -84.6725006103516, -1.47781392154754, 218, 50, 'PPL', 'P'),
(85613, 'Catoosa Canyon', 36.0486106872559, 0.629166947262231, -84.966667175293, -1.48294809665505, 218, 50, 'PPL', 'P'),
(85614, 'Catoosa Country', 36.0708312988281, 0.629554770095973, -84.9694366455078, -1.48299643302884, 218, 50, 'PPL', 'P'),
(19854, 'Catoosa Springs', 34.913890838623, 0.609362349815856, -85.0555572509766, -1.48449952114808, 218, 13, 'PPL', 'P'),
(147646, 'Cator Corners', 43.0938911437988, 0.752130287955315, -77.3022232055664, -1.3491783140487, 218, 40, 'PPL', 'P'),
(7957, 'Catorce (historical)', 34.8822212219238, 0.60880961073161, -92.4336090087891, -1.61327081670446, 218, 4, 'PPL', 'P'),
(7956, 'Catron', 34.2372207641602, 0.597552229066764, -90.9516677856445, -1.58740606303956, 218, 4, 'PPL', 'P'),
(53911, 'Catron', 36.6113891601563, 0.638989284573688, -89.7030563354492, -1.56561368215555, 218, 29, 'PPL', 'P'),
(196177, 'Catron', 45.7008285522461, 0.797629929126128, -111.061111450195, -1.93838206573028, 218, 31, 'PPL', 'P'),
(100581, 'Catron (historical)', 36.8452796936035, 0.643071444471589, -81.0330581665039, -1.41429366796557, 218, 53, 'PPL', 'P'),
(100582, 'Cats Bridge', 37.5516700744629, 0.655400282422002, -75.7822189331055, -1.32264923484987, 218, 53, 'PPL', 'P'),
(77987, 'Cats Run Junction', 39.8349990844727, 0.695251891552975, -79.920280456543, -1.39487203308395, 218, 45, 'PPL', 'P'),
(147647, 'Catskill', 42.2172203063965, 0.736829495386428, -73.8649978637695, -1.28918741470136, 218, 40, 'PPL', 'P'),
(63529, 'Cattail Creek Community', 35.8458290100098, 0.62562773933157, -82.2527770996094, -1.43558177929718, 218, 33, 'PPL', 'P'),
(147650, 'Cattaraugus', 42.3291702270508, 0.738783390099192, -78.8683319091797, -1.37651206737089, 218, 40, 'PPL', 'P'),
(45504, 'Cattertons Reach', 38.7083282470703, 0.675587775854102, -76.6247177124023, -1.33735361249264, 218, 25, 'PPL', 'P'),
(114877, 'Cattese', 42.461109161377, 0.741086158914756, -90.6311111450195, -1.58181129422152, 218, 16, 'PPL', 'P'),
(186508, 'Cattle Creek', 39.4583282470703, 0.68867774524406, -107.261940002441, -1.87207401511922, 218, 7, 'PPL', 'P'),
(80199, 'Cattle Creek (historical)', 33.2055587768555, 0.579546330620629, -80.7222213745117, -1.40886854250897, 218, 48, 'PPL', 'P'),
(191237, 'Cattleman''s North Ranchos Colonia', 31.617000579834, 0.551820759723059, -106.056999206543, -1.85104383093919, 218, 51, 'PPL', 'P'),
(191238, 'Cattleman''s North Ranchos Number 2 Colonia', 31.617000579834, 0.551820759723059, -106.051002502441, -1.85093916870835, 218, 51, 'PPL', 'P'),
(191239, 'Cattleman''s North Ranchos Number 3 Colonia', 31.6420001983643, 0.552257085378155, -106.061996459961, -1.85113104946489, 218, 51, 'PPL', 'P'),
(147652, 'Cattown', 42.730281829834, 0.74578410823571, -75.0033264160156, -1.30905499590751, 218, 40, 'PPL', 'P'),
(45505, 'Catts Corner', 39.2847213745117, 0.685647733713822, -76.095832824707, -1.32812282983831, 218, 25, 'PPL', 'P'),
(39694, 'Catuna', 31.9036102294922, 0.556823041777582, -93.710563659668, -1.63555787976095, 218, 22, 'PPL', 'P'),
(147653, 'Caughdenoy', 43.2724990844727, 0.75524758459028, -76.2074966430664, -1.33007173112403, 218, 40, 'PPL', 'P'),
(58921, 'Cauhorn (historical)', 33.8852806091309, 0.591409714591523, -88.273063659668, -1.54065560168376, 218, 30, 'PPL', 'P'),
(53912, 'Caulfield', 36.6144409179688, 0.63904254779549, -92.1047210693359, -1.6075306392909, 218, 29, 'PPL', 'P'),
(7958, 'Caulksville', 35.3019409179688, 0.616135101363064, -93.8638916015625, -1.63823395718232, 218, 4, 'PPL', 'P'),
(53914, 'Cause Prairie (historical)', 38.7472190856934, 0.676266549036936, -94.165283203125, -1.64349423296744, 218, 29, 'PPL', 'P'),
(80204, 'Causeway Branch', 33.9180603027344, 0.5919818281727, -80.3891677856445, -1.40305566079766, 218, 48, 'PPL', 'P'),
(35174, 'Causey', 37.0572204589844, 0.646770508646682, -83.2808303833008, -1.45352469398353, 218, 21, 'PPL', 'P'),
(80200, 'Causey', 34.2633285522461, 0.598007895929276, -79.0983276367188, -1.38052625008197, 218, 48, 'PPL', 'P'),
(192939, 'Causey', 33.8791694641113, 0.591303054989866, -103.126106262207, -1.79989009903706, 218, 38, 'PPL', 'P'),
(39695, 'Causey (historical)', 32.9516716003418, 0.575115163461873, -91.8541717529297, -1.60315772878099, 218, 22, 'PPL', 'P'),
(203319, 'Causey Estates', 41.2694396972656, 0.720287603170537, -111.574440002441, -1.94734133911147, 218, 52, 'PPL', 'P'),
(191240, 'Causey Place', 30.2222194671631, 0.527477236962322, -103.106391906738, -1.79954601862422, 218, 51, 'PPL', 'P'),
(147654, 'Cauterskill', 42.2200012207031, 0.736878031497295, -73.8916702270508, -1.2896529352599, 218, 40, 'PPL', 'P'),
(19855, 'Cauthen', 34.0538902282715, 0.594352507596061, -82.8227767944336, -1.44553015070722, 218, 13, 'PPL', 'P'),
(80201, 'Cauthens Crossroads', 34.6199989318848, 0.604232968398309, -80.7697219848633, -1.40969758455631, 218, 48, 'PPL', 'P'),
(100586, 'Cauthornville', 37.8811111450195, 0.66115011379451, -77.065559387207, -1.34504775119799, 218, 53, 'PPL', 'P'),
(7960, 'Cauthron', 34.9208297729492, 0.609483457066428, -94.2972183227539, -1.64579693520398, 218, 4, 'PPL', 'P'),
(177878, 'Cavalay Park', 31.5522193908691, 0.550690114682266, -110.362503051758, -1.92618904899546, 218, 5, 'PPL', 'P'),
(206986, 'Cavalero Corner', 47.978328704834, 0.83737980550346, -122.133613586426, -2.13163368444161, 218, 56, 'PPL', 'P'),
(139774, 'Cavalier', 48.7938919067383, 0.851614068634797, -97.621940612793, -1.70382428587961, 218, 34, 'PPL', 'P'),
(45506, 'Cavalier Country', 38.7483291625977, 0.676285923533866, -76.6305618286133, -1.33745561156239, 218, 25, 'PPL', 'P'),
(100583, 'Cavalier Manor', 36.7997207641602, 0.642276291149118, -76.3636093139648, -1.33279641123529, 218, 53, 'PPL', 'P'),
(100584, 'Cavalier Park', 36.8736114501953, 0.643565926906989, -75.9886093139648, -1.32625142654032, 218, 53, 'PPL', 'P'),
(13502, 'Cavaliers Country Club Apartments', 39.684440612793, 0.692624150505394, -75.6466674804688, -1.3202834156955, 218, 10, 'PPL', 'P'),
(154636, 'Cavallo', 40.4127807617188, 0.705336084178614, -82.1777801513672, -1.4342728356214, 218, 41, 'PPL', 'P'),
(1400, 'Cavalry Hill', 34.7405586242676, 0.606337131975581, -86.6111068725586, -1.51164898372284, 218, 2, 'PPL', 'P'),
(841, 'Cavanal', 34.980281829834, 0.61052109120615, -94.6980590820313, -1.65279292622956, 218, 42, 'PPL', 'P'),
(7963, 'Cavanaugh', 35.3122215270996, 0.616314531841508, -94.4255599975586, -1.64803691999685, 218, 4, 'PPL', 'P'),
(188259, 'Cavasos Place', 35.0847206115723, 0.612343891814255, -106.026107788086, -1.8505046739765, 218, 38, 'PPL', 'P'),
(93109, 'Cavazos', 26.0182495117188, 0.454104119584899, -97.6075820922852, -1.70357368242103, 218, 51, 'PPL', 'P'),
(53913, 'Cave', 39.019718170166, 0.681022555269654, -91.043327331543, -1.58900582390637, 218, 29, 'PPL', 'P'),
(187611, 'Cave', 37.3586082458496, 0.652030717852779, -101.140830993652, -1.76524050904236, 218, 20, 'PPL', 'P'),
(7964, 'Cave (historical)', 36.4105606079102, 0.63548416510498, -94.5861129760742, -1.65083909809583, 218, 4, 'PPL', 'P'),
(100585, 'Cave Alum Springs (historical)', 37.3980598449707, 0.652719278152619, -79.9933319091797, -1.39614702145583, 218, 53, 'PPL', 'P'),
(7965, 'Cave City', 35.9416694641113, 0.627300470812249, -91.5483322143555, -1.59781982185009, 218, 4, 'PPL', 'P'),
(35175, 'Cave City', 37.1366691589355, 0.648157150047259, -85.9569396972656, -1.5002316126555, 218, 21, 'PPL', 'P'),
(53915, 'Cave City', 39.6894416809082, 0.692711435610121, -91.331672668457, -1.59403839941829, 218, 29, 'PPL', 'P'),
(180603, 'Cave City', 38.2024993896484, 0.666759396840489, -120.507499694824, -2.10325264302074, 218, 6, 'PPL', 'P'),
(13503, 'Cave Colony', 38.7638893127441, 0.676557499386027, -75.290283203125, -1.31406333665351, 218, 10, 'PPL', 'P'),
(7966, 'Cave Creek', 35.9291687011719, 0.627082291339944, -92.9791717529297, -1.62279268286593, 218, 4, 'PPL', 'P'),
(85615, 'Cave Creek', 35.8138885498047, 0.625070273136389, -84.3874969482422, -1.47283966926349, 218, 50, 'PPL', 'P'),
(177880, 'Cave Creek', 33.6166687011719, 0.586721552387575, -112.034721374512, -1.9553747645397, 218, 5, 'PPL', 'P'),
(53916, 'Cave Hill', 38.4847183227539, 0.671685046434645, -91.5516662597656, -1.59787801191991, 218, 29, 'PPL', 'P'),
(200537, 'Cave Junction', 42.1630592346191, 0.735884206357504, -123.646942138672, -2.15804625034274, 218, 43, 'PPL', 'P'),
(85616, 'Cave Mill', 35.7991714477539, 0.624813411249251, -83.8880615234375, -1.46412287669955, 218, 50, 'PPL', 'P'),
(1403, 'Cave Spring', 34.788330078125, 0.607170901133857, -87.1355590820313, -1.52080240154749, 218, 2, 'PPL', 'P'),
(19856, 'Cave Spring', 34.1074981689453, 0.595288142666033, -85.3363876342773, -1.48940093597631, 218, 13, 'PPL', 'P'),
(35176, 'Cave Spring', 37.6494407653809, 0.65710670289047, -86.4241714477539, -1.50838634507138, 218, 21, 'PPL', 'P'),
(53917, 'Cave Spring', 37.351390838623, 0.651904750333218, -93.4633331298828, -1.63124289300475, 218, 29, 'PPL', 'P'),
(85618, 'Cave Spring', 36.4861106872559, 0.636802762739706, -87.5994415283203, -1.52889867757744, 218, 50, 'PPL', 'P'),
(100587, 'Cave Spring', 37.2275009155273, 0.649742463265156, -80.0130615234375, -1.39649136818477, 218, 53, 'PPL', 'P'),
(7967, 'Cave Spring (historical)', 36.204719543457, 0.631891560794463, -93.5727767944336, -1.63315304529661, 218, 4, 'PPL', 'P'),
(1405, 'Cave Springs', 34.5458297729492, 0.602938472371449, -86.8513870239258, -1.51584266349138, 218, 2, 'PPL', 'P'),
(7971, 'Cave Springs', 36.2633285522461, 0.632914480969163, -94.2316665649414, -1.64465284119968, 218, 4, 'PPL', 'P'),
(31986, 'Cave Springs', 37.5333290100098, 0.655080170458974, -96.1222229003906, -1.67764927394771, 218, 20, 'PPL', 'P'),
(35177, 'Cave Springs', 36.7991714477539, 0.642266703769194, -86.9533309936523, -1.51762192141567, 218, 21, 'PPL', 'P'),
(85619, 'Cave Springs', 36.5513916015625, 0.637942129633069, -85.4725036621094, -1.49177660882672, 218, 50, 'PPL', 'P'),
(45508, 'Cave Valley', 39.4524993896484, 0.688576012490419, -76.7513885498047, -1.33956443567157, 218, 25, 'PPL', 'P'),
(190021, 'Cave Valley (historical)', 38.6433296203613, 0.674453335808756, -114.803329467773, -2.00369609146448, 218, 39, 'PPL', 'P'),
(26736, 'Cave-in-Rock', 37.4691696166992, 0.653960377799623, -88.165283203125, -1.53877447784778, 218, 18, 'PPL', 'P'),
(199868, 'Cavecreek (historical)', 40.2000007629395, 0.701622372617526, -115.491668701172, -2.01570987745793, 218, 39, 'PPL', 'P'),
(7969, 'Cavell', 35.2599983215332, 0.615403064958429, -91.2608337402344, -1.59280202688222, 218, 4, 'PPL', 'P'),
(134596, 'Caven Mobile Home Park', 43.6519393920898, 0.76187006727298, -94.7249984741211, -1.65326310732002, 218, 28, 'PPL', 'P'),
(53919, 'Cavendish', 39.6894416809082, 0.692711435610121, -93.4899978637695, -1.63170828040524, 218, 29, 'PPL', 'P'),
(171834, 'Cavendish', 43.3819389343262, 0.757157670303112, -72.6086120605469, -1.26725934575981, 218, 55, 'PPL', 'P'),
(194705, 'Cavendish', 46.5602798461914, 0.812630183965999, -116.433059692383, -2.03214024980318, 218, 17, 'PPL', 'P'),
(171835, 'Cavendish Center', 43.4099998474121, 0.757647425627577, -72.6061096191406, -1.26721566991793, 218, 55, 'PPL', 'P'),
(200536, 'Caverhill (historical)', 44.8180618286133, 0.782222743271692, -119.097221374512, -2.0786386429618, 218, 43, 'PPL', 'P'),
(7970, 'Caverna', 36.4991683959961, 0.637030662749989, -94.269172668457, -1.64530744619562, 218, 4, 'PPL', 'P'),
(53920, 'Caverna', 36.4991683959961, 0.637030662749989, -94.26611328125, -1.64525404981577, 218, 29, 'PPL', 'P'),
(1406, 'Cavers Grove', 33.3919410705566, 0.582799315313134, -85.4897232055664, -1.49207714655574, 218, 2, 'PPL', 'P'),
(45509, 'Caves Park', 39.439998626709, 0.688357833018114, -76.725830078125, -1.33911835618898, 218, 25, 'PPL', 'P'),
(93110, 'Caves Spring', 32.9666709899902, 0.575376952197028, -94.399169921875, -1.64757632628632, 218, 51, 'PPL', 'P'),
(45510, 'Caveswood', 39.4263916015625, 0.688120345627906, -76.7491683959961, -1.33952568667771, 218, 25, 'PPL', 'P'),
(45511, 'Cavetown', 39.6441688537598, 0.691921275714694, -77.5861129760742, -1.35413312525679, 218, 25, 'PPL', 'P'),
(100589, 'Cavetown', 38.6152801513672, 0.673963780221372, -78.4491729736328, -1.36919636385644, 218, 53, 'PPL', 'P'),
(196178, 'Cavetown', 46.6541709899902, 0.814268893563752, -111.699996948242, -1.94953272121444, 218, 31, 'PPL', 'P'),
(39699, 'Cavett', 32.7924995422363, 0.572337086970757, -93.8377838134766, -1.63777829031981, 218, 22, 'PPL', 'P'),
(154633, 'Cavett', 40.9463882446289, 0.714649291668676, -84.5813903808594, -1.47622374806066, 218, 41, 'PPL', 'P'),
(159876, 'Cavettsville', 40.375560760498, 0.704686472609717, -79.7613906860352, -1.39209888344085, 218, 45, 'PPL', 'P'),
(180604, 'Cavin', 34.3952789306641, 0.600310864481922, -118.848609924316, -2.07429955459773, 218, 6, 'PPL', 'P'),
(93112, 'Caviness', 33.7577781677246, 0.589184377184653, -95.6130599975586, -1.66876270486428, 218, 51, 'PPL', 'P'),
(200538, 'Caviness (historical)', 44.2333297729492, 0.7720172436584, -117.816673278809, -2.05628886246163, 218, 43, 'PPL', 'P'),
(93111, 'Cavitt', 31.375560760498, 0.547606839930227, -97.5183334350586, -1.70201599949944, 218, 51, 'PPL', 'P'),
(169987, 'Cavour', 44.3699989318848, 0.774402570467756, -98.0374984741211, -1.71107713879233, 218, 49, 'PPL', 'P'),
(173472, 'Cavour', 45.6522216796875, 0.796781579160883, -88.6294403076172, -1.5468755475677, 218, 57, 'PPL', 'P'),
(180605, 'Cawelo', 35.499439239502, 0.619582097340981, -119.16471862793, -2.07981669226999, 218, 6, 'PPL', 'P'),
(31990, 'Cawker City', 39.5125007629395, 0.689623234010065, -98.4333267211914, -1.7179856449761, 218, 20, 'PPL', 'P'),
(35178, 'Cawood', 36.7838897705078, 0.641999988186023, -83.2283325195313, -1.45260843341049, 218, 21, 'PPL', 'P'),
(139072, 'Cawood', 40.1127815246582, 0.700100109738437, -94.7494430541992, -1.65368974572665, 218, 29, 'PPL', 'P'),
(93113, 'Cawthon', 30.4183292388916, 0.530899998174319, -96.2427825927734, -1.67975343752498, 218, 51, 'PPL', 'P'),
(72036, 'Cawthorn', 39.4769401550293, 0.689002584318022, -82.2019424438477, -1.43469454718002, 218, 41, 'PPL', 'P'),
(15464, 'Caxambas', 25.9105606079102, 0.452224593645576, -81.6980590820313, -1.4259001234703, 218, 12, 'PPL', 'P'),
(35179, 'Cayce', 36.5552787780762, 0.638009973661839, -89.0358276367188, -1.5539683444989, 218, 21, 'PPL', 'P'),
(58922, 'Cayce', 34.9552803039551, 0.61008473226154, -89.6180572509766, -1.56413016827032, 218, 30, 'PPL', 'P'),
(80205, 'Cayce', 33.9655609130859, 0.592810870220041, -81.0741729736328, -1.41501125672129, 218, 48, 'PPL', 'P'),
(124459, 'Cayenne', 42.1305618286133, 0.735317019624345, -72.6374969482422, -1.26776348215416, 218, 23, 'PPL', 'P'),
(100590, 'Caylor', 36.6305618286133, 0.639323910764657, -83.4944381713867, -1.45725285319353, 218, 53, 'PPL', 'P'),
(180607, 'Caymus (historical)', 38.4055595397949, 0.67030346504014, -122.362503051758, -2.13562855923478, 218, 6, 'PPL', 'P'),
(15462, 'Cayo Costa', 26.6186103820801, 0.464582393472843, -82.225830078125, -1.43511146504867, 218, 12, 'PPL', 'P'),
(15463, 'Cayo Pelau', 26.7755603790283, 0.467321687680585, -82.220832824707, -1.43502424652297, 218, 12, 'PPL', 'P'),
(93114, 'Cayote', 31.7686100006104, 0.554466843292648, -97.4572219848633, -1.70094940348287, 218, 51, 'PPL', 'P'),
(45512, 'Cayots', 39.4858283996582, 0.689157713451519, -75.8480606079102, -1.32379838886024, 218, 25, 'PPL', 'P'),
(63536, 'Cayton', 35.2636108398438, 0.615466115297236, -76.9899978637695, -1.34372895382618, 218, 33, 'PPL', 'P'),
(193437, 'Cayton', 41.061939239502, 0.716666036983166, -121.632781982422, -2.1228925239537, 218, 6, 'PPL', 'P'),
(180608, 'Cayucos', 35.4427795410156, 0.618593199049207, -120.89111328125, -2.10994796315926, 218, 6, 'PPL', 'P'),
(29419, 'Cayuga', 39.9486083984375, 0.697234748142593, -87.459716796875, -1.52646002096726, 218, 19, 'PPL', 'P'),
(58923, 'Cayuga', 32.1591682434082, 0.561283370550274, -90.6938934326172, -1.58290705185203, 218, 30, 'PPL', 'P'),
(75369, 'Cayuga', 36.6341705322266, 0.639386894524437, -94.6797180175781, -1.65247281426654, 218, 42, 'PPL', 'P'),
(93115, 'Cayuga', 31.9569396972656, 0.557753816578565, -95.9744415283203, -1.67507000243197, 218, 51, 'PPL', 'P'),
(119058, 'Cayuga', 40.9411087036133, 0.714557146294959, -88.583610534668, -1.54607566713429, 218, 18, 'PPL', 'P'),
(139778, 'Cayuga', 46.0741691589355, 0.804145951944252, -97.3838882446289, -1.69966948826298, 218, 34, 'PPL', 'P'),
(147656, 'Cayuga', 42.9188919067383, 0.74907597508013, -76.7266693115234, -1.33913300357497, 218, 40, 'PPL', 'P'),
(173474, 'Cayuga', 46.2444381713867, 0.807117706825644, -90.6822204589844, -1.58270332002864, 218, 57, 'PPL', 'P'),
(147657, 'Cayuga Heights', 42.4594383239746, 0.74105699730082, -76.4869384765625, -1.33494891118635, 218, 40, 'PPL', 'P'),
(147658, 'Cayuga Junction', 42.8697204589844, 0.748217771418852, -76.7052764892578, -1.33875962839015, 218, 40, 'PPL', 'P'),
(85620, 'Cayuga Town (historical)', 35.4097213745117, 0.618016225199042, -84.977783203125, -1.48314210794046, 218, 50, 'PPL', 'P'),
(194706, 'Cayuse Junction', 46.5991706848145, 0.813308957148833, -114.853057861328, -2.00456401566373, 218, 17, 'PPL', 'P'),
(147659, 'Cayuta', 42.2816696166992, 0.73795434805185, -76.6972198486328, -1.33861901348459, 218, 40, 'PPL', 'P'),
(147661, 'Cayutaville', 42.389720916748, 0.739840198998763, -76.6975021362305, -1.33862394033261, 218, 40, 'PPL', 'P'),
(72037, 'Caywood', 39.4566688537598, 0.688648783367205, -81.3858337402344, -1.42045076324778, 218, 41, 'PPL', 'P'),
(147662, 'Caywood', 42.5652809143066, 0.742904298990953, -76.8641662597656, -1.34153277803325, 218, 40, 'PPL', 'P'),
(180609, 'Cazadero', 38.5333290100098, 0.672533462978917, -123.084167480469, -2.14822397961031, 218, 6, 'PPL', 'P'),
(177881, 'Cazador', 31.4913902282715, 0.549628445513706, -109.421669006348, -1.9097683971882, 218, 5, 'PPL', 'P'),
(119059, 'Cazenovia', 40.8502807617188, 0.712971899656089, -89.3319396972656, -1.55913647491031, 218, 18, 'PPL', 'P'),
(134597, 'Cazenovia', 44.0669403076172, 0.769113199647723, -96.3675003051758, -1.68193017224196, 218, 28, 'PPL', 'P'),
(147663, 'Cazenovia', 42.9300003051758, 0.749269853207488, -75.8530578613281, -1.32388560738594, 218, 40, 'PPL', 'P'),
(173473, 'Cazenovia', 43.5230598449707, 0.759620694837272, -90.1961135864258, -1.57421915458592, 218, 57, 'PPL', 'P'),
(112640, 'Cazy', 37.9422187805176, 0.662216643232059, -81.7099990844727, -1.4261085158256, 218, 58, 'PPL', 'P'),
(53921, 'Cazzell', 39.3069381713867, 0.686035489968537, -92.9419403076172, -1.62214287155995, 218, 29, 'PPL', 'P'),
(45513, 'Cearfoss', 39.7008285522461, 0.692910174006468, -77.7758331298828, -1.35744436659814, 218, 25, 'PPL', 'P'),
(159877, 'Cease Mills', 41.252498626709, 0.719991925710511, -76.0274963378906, -1.32693013314412, 218, 45, 'PPL', 'P'),
(159878, 'Ceasetown', 41.2577781677246, 0.720084071084228, -76.0133285522461, -1.32668285863691, 218, 45, 'PPL', 'P'),
(206987, 'Cebalop (historical)', 47.2755584716797, 0.825114151049909, -122.473609924316, -2.13756773998252, 218, 56, 'PPL', 'P'),
(72038, 'Cebee', 38.5175018310547, 0.672257226594849, -82.3883285522461, -1.43794759845155, 218, 41, 'PPL', 'P'),
(188260, 'Cebolla', 36.538330078125, 0.637714163043758, -106.485832214355, -1.85852837886675, 218, 38, 'PPL', 'P'),
(188262, 'Cebolletita', 35.1744384765625, 0.613909763956194, -107.395561218262, -1.8744061452858, 218, 38, 'PPL', 'P'),
(80206, 'Cebu (historical)', 33.9288902282715, 0.592170846031068, -79.029167175293, -1.37931917231789, 218, 48, 'PPL', 'P'),
(7972, 'Cecil', 35.4386100769043, 0.618520428172421, -93.9444427490234, -1.63963983992177, 218, 4, 'PPL', 'P'),
(19859, 'Cecil', 31.045280456543, 0.541842361171723, -83.392219543457, -1.45546880157929, 218, 13, 'PPL', 'P'),
(35180, 'Cecil', 37.1025009155273, 0.647560801700163, -88.6669387817383, -1.54753001940558, 218, 21, 'PPL', 'P'),
(39696, 'Cecil', 32.9608306884766, 0.575275019706305, -92.2358322143555, -1.60981896045756, 218, 22, 'PPL', 'P'),
(70622, 'Cecil', 39.6483306884766, 0.691993913433426, -74.9475021362305, -1.30808067842271, 218, 37, 'PPL', 'P'),
(108517, 'Cecil', 39.2713890075684, 0.685415040013576, -79.9875030517578, -1.39604528870219, 218, 58, 'PPL', 'P'),
(112200, 'Cecil', 32.3025016784668, 0.56378501092024, -86.0086135864258, -1.50113349215866, 218, 2, 'PPL', 'P'),
(130120, 'Cecil', 45.7461090087891, 0.798420222179609, -84.8288879394531, -1.48054339534877, 218, 27, 'PPL', 'P'),
(154634, 'Cecil', 41.2186088562012, 0.719400437632404, -84.6022186279297, -1.47658726954945, 218, 41, 'PPL', 'P'),
(159879, 'Cecil', 40.3294410705566, 0.70388153217024, -80.1711120605469, -1.39924987044188, 218, 45, 'PPL', 'P'),
(173476, 'Cecil', 44.810001373291, 0.782082061787109, -88.4522171020508, -1.54378241911962, 218, 57, 'PPL', 'P'),
(200539, 'Cecil', 45.6180610656738, 0.796185363971841, -119.957778930664, -2.09365820571957, 218, 43, 'PPL', 'P'),
(63533, 'Cecil (historical)', 35.4052810668945, 0.61793872721132, -82.9016723632813, -1.44690713814885, 218, 33, 'PPL', 'P'),
(45515, 'Cecil Manor', 39.6569404602051, 0.692144182297934, -75.817497253418, -1.3232649576939, 218, 25, 'PPL', 'P'),
(147665, 'Cecil Park', 40.9749984741211, 0.715148634373066, -73.8188934326172, -1.28838274057799, 218, 40, 'PPL', 'P'),
(39697, 'Cecile', 32.3194389343262, 0.564080621801239, -93.5919418334961, -1.63348753832953, 218, 22, 'PPL', 'P'),
(180610, 'Cecile', 36.7008285522461, 0.640550296446638, -119.716667175293, -2.08945001172308, 218, 6, 'PPL', 'P'),
(35181, 'Cecilia', 37.665828704834, 0.657392726391544, -85.956672668457, -1.5002269521236, 218, 21, 'PPL', 'P'),
(39698, 'Cecilia', 30.3369407653809, 0.529479501338385, -91.8530578613281, -1.60313828770504, 218, 22, 'PPL', 'P'),
(45516, 'Cecilton', 39.4038887023926, 0.687727595946147, -75.8677825927734, -1.32414260243114, 218, 25, 'PPL', 'P'),
(193438, 'Cecilville', 41.1411094665527, 0.718047818114753, -123.138893127441, -2.14917912233527, 218, 6, 'PPL', 'P'),
(1407, 'Cedahoma (historical)', 32.3088912963867, 0.563896530790887, -87.976936340332, -1.53548720495624, 218, 2, 'PPL', 'P'),
(31989, 'Cedar', 39.6572189331055, 0.692149042566923, -98.9400024414063, -1.72682880453377, 218, 20, 'PPL', 'P'),
(75368, 'Cedar', 35.0183296203613, 0.611185150423961, -94.9891662597656, -1.65787370495722, 218, 42, 'PPL', 'P'),
(108516, 'Cedar', 37.7369384765625, 0.658633826038549, -81.2125015258789, -1.41742554540751, 218, 58, 'PPL', 'P'),
(114878, 'Cedar', 41.2122192382813, 0.719288917761757, -92.5255584716797, -1.61487563757734, 218, 16, 'PPL', 'P'),
(122331, 'Cedar', 41.3127784729004, 0.721044007499147, -85.1561126708984, -1.48625454430644, 218, 19, 'PPL', 'P'),
(124460, 'Cedar', 42.1230583190918, 0.73518605867774, -71.2638931274414, -1.24378957286321, 218, 23, 'PPL', 'P'),
(127066, 'Cedar', 45.0580596923828, 0.786411496192223, -67.4644393920898, -1.17747659540413, 218, 26, 'PPL', 'P'),
(130121, 'Cedar', 44.8477783203125, 0.782741393893985, -85.7955627441406, -1.49741505348664, 218, 27, 'PPL', 'P'),
(134598, 'Cedar', 45.3197212219238, 0.790978351408519, -93.2858276367188, -1.62814483770866, 218, 28, 'PPL', 'P'),
(173478, 'Cedar', 46.5072212219238, 0.811704136275951, -90.4980621337891, -1.57948915090902, 218, 57, 'PPL', 'P'),
(177882, 'Cedar', 34.7786102294922, 0.607001257772419, -113.793609619141, -1.98607315558309, 218, 5, 'PPL', 'P'),
(192510, 'Cedar', 39.3938903808594, 0.687553092315719, -110.454170227051, -1.92778894302033, 218, 52, 'PPL', 'P'),
(194707, 'Cedar', 42.5938911437988, 0.743403641695343, -114.704719543457, -2.00197502361001, 218, 17, 'PPL', 'P'),
(196179, 'Cedar (historical)', 48.086109161377, 0.839260929339437, -116.005561828613, -2.02467900453516, 218, 31, 'PPL', 'P'),
(45517, 'Cedar Acres', 39.2027816772461, 0.684217616208449, -76.8883285522461, -1.34195448959186, 218, 25, 'PPL', 'P'),
(80207, 'Cedar Acres', 34.5369415283203, 0.602783343237952, -82.6216735839844, -1.44202023754855, 218, 48, 'PPL', 'P'),
(130122, 'Cedar Bank', 46.2969398498535, 0.808034033977713, -87.2666702270508, -1.52309072271414, 218, 27, 'PPL', 'P'),
(63535, 'Cedar Bay', 33.9455604553223, 0.592461796380159, -78.5486068725586, -1.37093181278079, 218, 33, 'PPL', 'P'),
(93116, 'Cedar Bayou', 29.7751903533936, 0.519675107074771, -94.9418334960938, -1.65704759238707, 218, 51, 'PPL', 'P'),
(45520, 'Cedar Beach', 38.5119400024414, 0.672160154373116, -76.6511077880859, -1.33781420620317, 218, 25, 'PPL', 'P'),
(70621, 'Cedar Beach', 39.8733291625977, 0.695920877618803, -74.1497192382813, -1.29415674013739, 218, 37, 'PPL', 'P'),
(134599, 'Cedar Beach', 44.1616706848145, 0.770766556631471, -92.4647216796875, -1.61381383525073, 218, 28, 'PPL', 'P'),
(171837, 'Cedar Beach', 44.2916717529297, 0.773035503301191, -73.3033294677734, -1.27938445188683, 218, 55, 'PPL', 'P'),
(177581, 'Cedar Beach', 41.1783294677734, 0.718697429683651, -73.0983276367188, -1.27580649496231, 218, 8, 'PPL', 'P'),
(1408, 'Cedar Bluff', 34.2200012207031, 0.597251691337748, -85.607780456543, -1.49413763429113, 218, 2, 'PPL', 'P'),
(19857, 'Cedar Bluff', 33.9194412231445, 0.592005929780565, -83.3261108398438, -1.45431498703701, 218, 13, 'PPL', 'P'),
(35182, 'Cedar Bluff', 37.0883293151855, 0.647313460613922, -87.8447189331055, -1.53317957587169, 218, 21, 'PPL', 'P'),
(53923, 'Cedar Bluff', 37.1194381713867, 0.647856412581161, -92.0922164916992, -1.60731239323957, 218, 29, 'PPL', 'P'),
(58925, 'Cedar Bluff', 33.586669921875, 0.586197974917265, -88.8322219848633, -1.55041475549836, 218, 30, 'PPL', 'P'),
(85623, 'Cedar Bluff', 35.8544387817383, 0.625778008196078, -83.4349975585938, -1.45621541879089, 218, 50, 'PPL', 'P'),
(100593, 'Cedar Bluff', 36.6355590820313, 0.639411129290357, -81.8600006103516, -1.4287265363352, 218, 53, 'PPL', 'P'),
(114879, 'Cedar Bluff', 41.785831451416, 0.72930033951061, -91.3080596923828, -1.5936262752396, 218, 16, 'PPL', 'P'),
(130123, 'Cedar Bluff', 42.4855613708496, 0.741512930479441, -86.2461090087891, -1.50527856923731, 218, 27, 'PPL', 'P'),
(119061, 'Cedar Bluff Estates', 40.836109161377, 0.712724558569848, -89.6138916015625, -1.56405746397256, 218, 18, 'PPL', 'P'),
(141443, 'Cedar Bluffs', 41.3969383239746, 0.72251287399838, -96.6111068725586, -1.68618190892227, 218, 35, 'PPL', 'P'),
(147666, 'Cedar Bluffs', 43.0391693115234, 0.751175211809385, -73.7136077880859, -1.28654515942583, 218, 40, 'PPL', 'P'),
(192930, 'Cedar Bluffs', 39.978889465332, 0.697763252460919, -100.561393737793, -1.75512742111889, 218, 20, 'PPL', 'P'),
(13504, 'Cedar Brae Farm', 39.3647193908691, 0.687043962494323, -75.682502746582, -1.32090885907751, 218, 10, 'PPL', 'P'),
(100594, 'Cedar Branch', 36.8899993896484, 0.643851950408064, -81.7463912963867, -1.42674367974558, 218, 53, 'PPL', 'P'),
(144954, 'Cedar Bridge', 40.0558280944824, 0.699106084861565, -74.1286087036133, -1.29378829180058, 218, 37, 'PPL', 'P'),
(144955, 'Cedar Bridge Manor', 40.0561103820801, 0.699111011709581, -74.129997253418, -1.2938125265665, 218, 37, 'PPL', 'P'),
(70623, 'Cedar Brook', 39.7152786254883, 0.693162375361698, -74.9011077880859, -1.30727094429327, 218, 37, 'PPL', 'P'),
(119062, 'Cedar Brook', 41.5574989318848, 0.725315185255416, -90.373893737793, -1.57732200357197, 218, 18, 'PPL', 'P'),
(124461, 'Cedar Bushes', 41.8972206115723, 0.731244447106368, -70.5500030517578, -1.23132984054522, 218, 23, 'PPL', 'P'),
(201983, 'Cedar Butte', 43.5769386291504, 0.760561057018179, -101.018058776855, -1.76309772962928, 218, 49, 'PPL', 'P'),
(201986, 'Cedar Canyon', 45.023609161377, 0.785810220997111, -102.690002441406, -1.79227865148355, 218, 49, 'PPL', 'P'),
(122332, 'Cedar Canyons', 41.232780456543, 0.719647778718645, -85.0891723632813, -1.48508621553622, 218, 19, 'PPL', 'P'),
(85624, 'Cedar Chapel', 35.4022216796875, 0.617885330831464, -89.1672210693359, -1.55626159251357, 218, 50, 'PPL', 'P'),
(53925, 'Cedar City', 38.5972213745117, 0.673648595106361, -92.179443359375, -1.60883478927672, 218, 29, 'PPL', 'P'),
(114880, 'Cedar City', 42.5405616760254, 0.74247286689436, -92.4408264160156, -1.61339678422402, 218, 16, 'PPL', 'P'),
(192511, 'Cedar City', 37.6775016784668, 0.657596458214936, -113.061111450195, -1.97328865077017, 218, 52, 'PPL', 'P'),
(19858, 'Cedar Cliff', 34.9805603027344, 0.610525951475139, -83.793327331543, -1.46246945313678, 218, 13, 'PPL', 'P'),
(45521, 'Cedar Cliff', 39.6083297729492, 0.691295765753662, -78.807502746582, -1.37545039820233, 218, 25, 'PPL', 'P'),
(108518, 'Cedar Cliff', 39.5972213745117, 0.691101887626304, -78.8097229003906, -1.37548914719619, 218, 58, 'PPL', 'P'),
(147671, 'Cedar Cliff', 41.5863914489746, 0.725819454807822, -73.9599990844727, -1.29084549879604, 218, 40, 'PPL', 'P'),
(159881, 'Cedar Cliff', 40.228328704834, 0.702116788473899, -76.9030609130859, -1.34221161779511, 218, 45, 'PPL', 'P'),
(53926, 'Cedar Cliffs', 37.2433280944824, 0.650018699649224, -89.6605606079102, -1.56487199179196, 218, 29, 'PPL', 'P'),
(154635, 'Cedar Corners', 41.1624984741211, 0.718421126720555, -80.6341705322266, -1.40733176540194, 218, 41, 'PPL', 'P'),
(1410, 'Cedar Cove', 33.1747207641602, 0.579008105764324, -87.3219375610352, -1.52405531966097, 218, 2, 'PPL', 'P'),
(45522, 'Cedar Cove', 38.2611083984375, 0.667782317015189, -76.4166717529297, -1.33372252550437, 218, 25, 'PPL', 'P'),
(58924, 'Cedar Cove', 34.1888885498047, 0.596708672791481, -88.7652816772461, -1.54924642672814, 218, 30, 'PPL', 'P'),
(194137, 'Cedar Cove', 40.415828704834, 0.705389280821389, -105.264999389648, -1.83722082645919, 218, 7, 'PPL', 'P'),
(1411, 'Cedar Cove Estates', 33.4408302307129, 0.583652592126395, -86.311393737793, -1.5064180027097, 218, 2, 'PPL', 'P'),
(15465, 'Cedar Creek', 29.273609161377, 0.510920863808004, -81.9019393920898, -1.42945850616081, 218, 12, 'PPL', 'P'),
(19862, 'Cedar Creek', 33.5577812194824, 0.585693771943886, -83.8472213745117, -1.46341008163379, 218, 13, 'PPL', 'P'),
(63539, 'Cedar Creek', 35.7213897705078, 0.623455864883583, -79.8444366455078, -1.39354830886413, 218, 33, 'PPL', 'P'),
(80210, 'Cedar Creek', 33.3586082458496, 0.582217547773006, -79.6558303833008, -1.39025650859874, 218, 48, 'PPL', 'P'),
(85625, 'Cedar Creek', 36.0238914489746, 0.628735515165638, -82.9024963378906, -1.44692151921873, 218, 50, 'PPL', 'P'),
(93118, 'Cedar Creek', 30.1944408416748, 0.526992408485873, -96.0599975585938, -1.67656323685518, 218, 51, 'PPL', 'P'),
(112221, 'Cedar Creek', 34.7852783203125, 0.607117637912056, -93.8663864135742, -1.63827749986614, 218, 4, 'PPL', 'P'),
(130124, 'Cedar Creek', 42.5202789306641, 0.742118866206462, -85.3274993896484, -1.48924580684282, 218, 27, 'PPL', 'P'),
(141445, 'Cedar Creek', 41.0366706848145, 0.716225017506648, -96.0991668701172, -1.677246870307, 218, 35, 'PPL', 'P'),
(154637, 'Cedar Creek', 41.5994415283203, 0.726047221660051, -83.4313888549805, -1.45615243503111, 218, 41, 'PPL', 'P'),
(173479, 'Cedar Creek', 43.3397216796875, 0.756420840208514, -88.2227783203125, -1.53977795694653, 218, 57, 'PPL', 'P'),
(177883, 'Cedar Creek', 33.8955612182617, 0.591589145069967, -110.173057556152, -1.92288260134408, 218, 5, 'PPL', 'P'),
(186509, 'Cedar Creek', 38.478889465332, 0.671583313681004, -107.713890075684, -1.87996203195192, 218, 7, 'PPL', 'P'),
(194708, 'Cedar Creek', 48.0183296203613, 0.838077953183224, -116.445281982422, -2.03235356900649, 218, 17, 'PPL', 'P'),
(203322, 'Cedar Creek', 41.9644393920898, 0.732417636145575, -113.155563354492, -1.97493714748493, 218, 52, 'PPL', 'P'),
(58927, 'Cedar Creek (historical)', 33.3208312988281, 0.581558215666129, -88.4402770996094, -1.54357402676432, 218, 30, 'PPL', 'P'),
(100599, 'Cedar Creek Battlefield', 39.017219543457, 0.680978946006804, -78.2930603027344, -1.36647168374518, 218, 53, 'PPL', 'P'),
(177628, 'Cedar Creek Crossing', 33.8652801513672, 0.591060640751641, -110.200561523438, -1.92336263613056, 218, 5, 'PPL', 'P'),
(45523, 'Cedar Creek Estates', 39.1483306884766, 0.683267267173455, -77.2880630493164, -1.34893117269954, 218, 25, 'PPL', 'P'),
(80211, 'Cedar Creek Landing', 33.0527801513672, 0.576879840579187, -79.8819427490234, -1.39420291386007, 218, 48, 'PPL', 'P'),
(80212, 'Cedar Creek Village', 33.8611106872559, 0.590987869874855, -78.6425018310547, -1.37257058895757, 218, 48, 'PPL', 'P'),
(70629, 'Cedar Crest', 39.9025001525879, 0.696430007440198, -74.3225021362305, -1.29717237059774, 218, 37, 'PPL', 'P'),
(75370, 'Cedar Crest', 36.1133308410645, 0.630296527038588, -95.228889465332, -1.66205766418779, 218, 42, 'PPL', 'P'),
(100596, 'Cedar Crest', 38.8186111450195, 0.677512575531957, -77.2052764892578, -1.34748627465012, 218, 53, 'PPL', 'P'),
(180612, 'Cedar Crest', 39.1977806091309, 0.684130331103722, -121.005828857422, -2.11195012766678, 218, 6, 'PPL', 'P'),
(186510, 'Cedar Crest', 37.8069381713867, 0.659855551188622, -104.298057556152, -1.82034450778941, 218, 7, 'PPL', 'P'),
(188264, 'Cedar Crest', 35.1074981689453, 0.612741435185976, -106.372222900391, -1.85654552227713, 218, 38, 'PPL', 'P'),
(100597, 'Cedar Crest Hall', 36.8958282470703, 0.643953683161705, -76.5055618286133, -1.3352739499974, 218, 53, 'PPL', 'P'),
(70624, 'Cedar Crest Manor', 39.6772193908691, 0.692498116406805, -75.4761123657227, -1.31730666738707, 218, 37, 'PPL', 'P'),
(85626, 'Cedar Crest North', 36.0677795410156, 0.629501506874172, -83.9833297729492, -1.46578562132615, 218, 50, 'PPL', 'P'),
(19863, 'Cedar Crest Plantation', 34.0541687011719, 0.59435736786505, -84.745002746582, -1.47907932253949, 218, 13, 'PPL', 'P'),
(19864, 'Cedar Crossing', 32.0255584716797, 0.558951440120774, -82.4080581665039, -1.43829194518049, 218, 13, 'PPL', 'P'),
(206988, 'Cedar Crossing', 48.746940612793, 0.85079461396738, -120.816940307617, -2.10865340055337, 218, 56, 'PPL', 'P'),
(80213, 'Cedar Estates', 33.9363899230957, 0.592301740398645, -81.1694412231445, -1.41667400134789, 218, 48, 'PPL', 'P'),
(63543, 'Cedar Falls', 35.7519416809082, 0.623989096312844, -79.7316665649414, -1.3915800996605, 218, 33, 'PPL', 'P'),
(114882, 'Cedar Falls', 42.5277786254883, 0.742249760574039, -92.4452819824219, -1.61347454852785, 218, 16, 'PPL', 'P'),
(173480, 'Cedar Falls', 44.9358291625977, 0.784278171001015, -91.8838882446289, -1.60367637940329, 218, 57, 'PPL', 'P'),
(206989, 'Cedar Falls', 47.4255599975586, 0.827732171559511, -121.77555847168, -2.12538444378568, 218, 56, 'PPL', 'P'),
(72039, 'Cedar Falls (historical)', 39.4197196960449, 0.688003898909242, -82.5233306884766, -1.440303830226, 218, 41, 'PPL', 'P'),
(114883, 'Cedar Falls Junction', 42.4452781677246, 0.74080985595166, -92.4186096191406, -1.61300902796931, 218, 16, 'PPL', 'P'),
(114884, 'Cedar Falls Mobile Home Park', 42.5013885498047, 0.74178916686351, -92.4791717529297, -1.61406603660596, 218, 16, 'PPL', 'P'),
(114885, 'Cedar Falls Mobile Home Village', 42.5155601501465, 0.742036507949751, -92.4927825927734, -1.61430359057519, 218, 16, 'PPL', 'P'),
(29420, 'Cedar Farm Landing', 37.9730606079102, 0.662754934667392, -86.0622177124023, -1.5020690606496, 218, 19, 'PPL', 'P'),
(13506, 'Cedar Farms', 39.6327781677246, 0.69172247073932, -75.7083282470703, -1.321359599092, 218, 10, 'PPL', 'P'),
(35183, 'Cedar Flat', 38.1180610656738, 0.665285670072267, -86.3216705322266, -1.50659736660912, 218, 21, 'PPL', 'P'),
(200540, 'Cedar Flat', 44.0527801513672, 0.768866058298563, -122.840278625488, -2.14396731608199, 218, 43, 'PPL', 'P'),
(35184, 'Cedar Flats', 36.9463882446289, 0.644836121588903, -85.6141662597656, -1.49424908758275, 218, 21, 'PPL', 'P'),
(85627, 'Cedar Flats', 36.0475006103516, 0.6291475727653, -83.975830078125, -1.46565472695857, 218, 50, 'PPL', 'P'),
(147667, 'Cedar Flats', 41.2408294677734, 0.719788260466147, -74.0244369506836, -1.29197015172438, 218, 40, 'PPL', 'P'),
(53930, 'Cedar Ford', 37.894718170166, 0.661387601184718, -91.4797210693359, -1.59662233146594, 218, 29, 'PPL', 'P'),
(100609, 'Cedar Forest', 37.0463905334473, 0.646581490788313, -79.1108322143555, -1.3807444961333, 218, 53, 'PPL', 'P'),
(80214, 'Cedar Forest Acres', 34.9977798461914, 0.610826489204155, -81.0605621337891, -1.41477370275206, 218, 48, 'PPL', 'P'),
(63544, 'Cedar Forest Estates', 36.0113906860352, 0.628517335693333, -80.5272216796875, -1.40546515579391, 218, 33, 'PPL', 'P'),
(63545, 'Cedar Fork', 34.8766708374023, 0.608712738246959, -77.7080612182617, -1.35626152359998, 218, 33, 'PPL', 'P'),
(72044, 'Cedar Fork', 39.086109161377, 0.682181296659948, -83.3183288574219, -1.45417916582142, 218, 41, 'PPL', 'P'),
(85628, 'Cedar Fork', 35.6841697692871, 0.622806253314685, -84.5325012207031, -1.4753704712474, 218, 50, 'PPL', 'P'),
(100600, 'Cedar Fork', 37.961669921875, 0.662556129692017, -77.5483322143555, -1.35347372657089, 218, 53, 'PPL', 'P'),
(203324, 'Cedar Fort', 40.327220916748, 0.703842783176379, -112.103607177734, -1.95657704861381, 218, 52, 'PPL', 'P'),
(53931, 'Cedar Gap', 37.1055603027344, 0.647614198080019, -92.6694412231445, -1.61738686532723, 218, 29, 'PPL', 'P'),
(7984, 'Cedar Glade (historical)', 34.2138900756836, 0.597145031736091, -94.1566696166992, -1.64334389752391, 218, 4, 'PPL', 'P'),
(7977, 'Cedar Glades (historical)', 34.6124992370605, 0.604102074030732, -93.2972183227539, -1.62834364268404, 218, 4, 'PPL', 'P'),
(180613, 'Cedar Glen', 34.2538909912109, 0.597843179415855, -117.163887023926, -2.04489559300217, 218, 6, 'PPL', 'P'),
(70625, 'Cedar Glen Lakes', 39.952220916748, 0.697297798481401, -74.4002838134766, -1.29852991696341, 218, 37, 'PPL', 'P'),
(144956, 'Cedar Glen West', 40.0419387817383, 0.69886367062334, -74.2930603027344, -1.29665851366541, 218, 37, 'PPL', 'P'),
(100601, 'Cedar Green', 38.1508293151855, 0.665857583916361, -79.1288909912109, -1.38105968124831, 218, 53, 'PPL', 'P'),
(1417, 'Cedar Grove', 34.8566703796387, 0.608363664407077, -87.2147216796875, -1.52218404952103, 218, 2, 'PPL', 'P'),
(7981, 'Cedar Grove', 36.3333282470703, 0.634136206119237, -90.9508285522461, -1.58739141565356, 218, 4, 'PPL', 'P'),
(15467, 'Cedar Grove', 30.1708297729492, 0.526580317596697, -85.6252822875977, -1.49444309886816, 218, 12, 'PPL', 'P'),
(19870, 'Cedar Grove', 34.7166709899902, 0.605920214106929, -85.4261093139648, -1.49096687469728, 218, 13, 'PPL', 'P'),
(29421, 'Cedar Grove', 39.3569412231445, 0.686908207857756, -84.9377822875977, -1.4824439602607, 218, 19, 'PPL', 'P'),
(35187, 'Cedar Grove', 36.9341697692871, 0.644622868964615, -87.1561126708984, -1.52116112934633, 218, 21, 'PPL', 'P'),
(39703, 'Cedar Grove', 31.2491703033447, 0.545400910309801, -92.279167175293, -1.61057529820714, 218, 22, 'PPL', 'P'),
(45527, 'Cedar Grove', 39.5316696166992, 0.689957793622006, -77.8225021362305, -1.35825889441754, 218, 25, 'PPL', 'P'),
(58926, 'Cedar Grove', 32.3488883972168, 0.564594611891624, -89.1858291625977, -1.55658636500851, 218, 30, 'PPL', 'P'),
(63550, 'Cedar Grove', 35.6755599975586, 0.622655984450178, -79.8888931274414, -1.39432422084772, 218, 33, 'PPL', 'P'),
(72040, 'Cedar Grove', 39.4377784729004, 0.688319084024253, -82.5397186279297, -1.44058985372707, 218, 41, 'PPL', 'P'),
(80216, 'Cedar Grove', 34.7222213745117, 0.606017086591581, -81.232780456543, -1.41777947951638, 218, 48, 'PPL', 'P'),
(85642, 'Cedar Grove', 36.2516708374023, 0.632711015461881, -86.5277786254883, -1.51019463145154, 218, 50, 'PPL', 'P'),
(93120, 'Cedar Grove', 32.7577590942383, 0.571730751769573, -96.0862731933594, -1.67702183319489, 218, 51, 'PPL', 'P'),
(100607, 'Cedar Grove', 37.8824996948242, 0.66117434856043, -79.3838882446289, -1.385510222904, 218, 53, 'PPL', 'P'),
(108520, 'Cedar Grove', 39.2277793884277, 0.684653908574032, -81.5066680908203, -1.42255972051502, 218, 58, 'PPL', 'P'),
(124462, 'Cedar Grove', 42.2805595397949, 0.73793497355492, -71.0583267211914, -1.24020176224266, 218, 23, 'PPL', 'P'),
(127068, 'Cedar Grove', 44.1161117553711, 0.769971403309001, -69.7636108398438, -1.21760470723528, 218, 26, 'PPL', 'P'),
(134600, 'Cedar Grove', 44.8047218322754, 0.781989916413392, -93.2099990844727, -1.62682137980495, 218, 28, 'PPL', 'P'),
(144958, 'Cedar Grove', 40.3680610656738, 0.704555578242139, -74.6952819824219, -1.30367860629886, 218, 37, 'PPL', 'P'),
(159884, 'Cedar Grove', 40.0299987792969, 0.698655278268041, -75.105827331543, -1.31084397436977, 218, 45, 'PPL', 'P'),
(173481, 'Cedar Grove', 43.5697212219238, 0.760435089498618, -87.8233337402344, -1.53280633384492, 218, 57, 'PPL', 'P'),
(180616, 'Cedar Grove', 36.790828704834, 0.642121095436594, -118.669441223145, -2.07117247084576, 218, 6, 'PPL', 'P'),
(186511, 'Cedar Grove', 38.0750007629395, 0.664534126012646, -104.938331604004, -1.83151939803949, 218, 7, 'PPL', 'P'),
(188265, 'Cedar Grove', 35.1708297729492, 0.613846780196414, -106.189437866211, -1.85335532160732, 218, 38, 'PPL', 'P'),
(206990, 'Cedar Grove', 47.4358291625977, 0.827911402300874, -122.060829162598, -2.13036335660164, 218, 56, 'PPL', 'P'),
(1418, 'Cedar Grove (historical)', 33.523609161377, 0.585097357017763, -86.5788879394531, -1.51108665725867, 218, 2, 'PPL', 'P'),
(39704, 'Cedar Grove (historical)', 30.1755599975586, 0.52666287559049, -91.1630630493164, -1.59109560641375, 218, 22, 'PPL', 'P'),
(85643, 'Cedar Grove (historical)', 35.1902809143066, 0.614186266656371, -89.8905563354492, -1.56888617450304, 218, 50, 'PPL', 'P'),
(188266, 'Cedar Grove (historical)', 32.0072212219238, 0.558631394736773, -108.163330078125, -1.8878062397847, 218, 38, 'PPL', 'P'),
(19871, 'Cedar Grove Acres', 33.6569404602051, 0.587424427178274, -84.3166732788086, -1.47160356304353, 218, 13, 'PPL', 'P'),
(100608, 'Cedar Grove Acres', 36.792781829834, 0.642155183898547, -76.404167175293, -1.33350427945304, 218, 53, 'PPL', 'P'),
(169990, 'Cedar Grove Colony', 43.5302810668945, 0.75974672893586, -98.807502746582, -1.7245162486012, 218, 49, 'PPL', 'P'),
(45528, 'Cedar Grove Knolls', 39.2508316040039, 0.685056245635715, -77.2305603027344, -1.34792756044274, 218, 25, 'PPL', 'P'),
(39705, 'Cedar Grove Plantation', 29.8583297729492, 0.521126163684215, -90.9638900756836, -1.58761938224287, 218, 22, 'PPL', 'P'),
(15466, 'Cedar Hammock', 27.4666690826416, 0.479383810047826, -82.5833282470703, -1.44135098516661, 218, 12, 'PPL', 'P'),
(19872, 'Cedar Hammock', 31.9747200012207, 0.558064141424587, -81.083610534668, -1.41517597323472, 218, 13, 'PPL', 'P'),
(130127, 'Cedar Haven', 44.1761093139648, 0.77101855824962, -83.5625, -1.45844075619776, 218, 27, 'PPL', 'P'),
(13507, 'Cedar Heights', 39.7208290100098, 0.69325924784635, -75.6166687011719, -1.31975983822519, 218, 10, 'PPL', 'P'),
(45530, 'Cedar Heights', 38.9025001525879, 0.678976714920255, -76.908332824707, -1.34230363001077, 218, 25, 'PPL', 'P'),
(144960, 'Cedar Heights', 40.6605606079102, 0.709660658314739, -74.8772201538086, -1.30685402642461, 218, 37, 'PPL', 'P'),
(159885, 'Cedar Heights', 40.084171295166, 0.699600767034047, -75.2897186279297, -1.31405348295748, 218, 45, 'PPL', 'P'),
(177582, 'Cedar Heights', 41.4480590820313, 0.723405099542584, -73.4361114501953, -1.28170193466742, 218, 8, 'PPL', 'P'),
(45531, 'Cedar Heights Estates', 39.2563896179199, 0.685153251278421, -77.2219390869141, -1.34777709184115, 218, 25, 'PPL', 'P'),
(1420, 'Cedar Hill', 34.9769401550293, 0.610462767978277, -86.8199996948242, -1.51529485125515, 218, 2, 'PPL', 'P'),
(19875, 'Cedar Hill', 34.8125, 0.607592745850526, -85.5408325195313, -1.49296917236286, 218, 13, 'PPL', 'P'),
(45533, 'Cedar Hill', 39.6749992370605, 0.692459367412945, -75.892219543457, -1.32456910767971, 218, 25, 'PPL', 'P'),
(53932, 'Cedar Hill', 38.353328704834, 0.669391864999005, -90.64111328125, -1.58198586443097, 218, 29, 'PPL', 'P'),
(58929, 'Cedar Hill', 33.564998626709, 0.585819739463447, -89.586669921875, -1.56358235603409, 218, 30, 'PPL', 'P'),
(63556, 'Cedar Hill', 36.3666687011719, 0.634718106817419, -80.5313873291016, -1.40553786009166, 218, 33, 'PPL', 'P'),
(72041, 'Cedar Hill', 39.689998626709, 0.6927211561481, -82.8052825927734, -1.44522481928824, 218, 41, 'PPL', 'P'),
(80218, 'Cedar Hill', 33.9088897705078, 0.591821772191186, -82.3333282470703, -1.43698766203663, 218, 48, 'PPL', 'P'),
(85647, 'Cedar Hill', 36.5513916015625, 0.637942129633069, -86.9991683959961, -1.51842193500713, 218, 50, 'PPL', 'P'),
(100612, 'Cedar Hill', 36.8499984741211, 0.6431538027283, -79.3133316040039, -1.38427877721594, 218, 53, 'PPL', 'P'),
(124463, 'Cedar Hill', 42.1333312988281, 0.73536535599813, -71.283332824707, -1.24412885958609, 218, 23, 'PPL', 'P'),
(147668, 'Cedar Hill', 42.5444412231445, 0.742540577765076, -73.7738876342773, -1.28759724121447, 218, 40, 'PPL', 'P'),
(159886, 'Cedar Hill', 40.6538887023926, 0.709544211596076, -77.6302795410156, -1.35490397723432, 218, 45, 'PPL', 'P'),
(188269, 'Cedar Hill', 35.2436103820801, 0.615117041457354, -105.266670227051, -1.83724998807312, 218, 38, 'PPL', 'P'),
(191241, 'Cedar Hill', 34.1433296203613, 0.595913519469011, -101.203887939453, -1.76634106036284, 218, 51, 'PPL', 'P'),
(1421, 'Cedar Hill (historical)', 34.8883285522461, 0.608916203754241, -87.3013916015625, -1.52369672502019, 218, 2, 'PPL', 'P'),
(7982, 'Cedar Hill (historical)', 34.2630615234375, 0.598003235397369, -94.0666732788086, -1.64177316511298, 218, 4, 'PPL', 'P'),
(58930, 'Cedar Hill (historical)', 32.8722190856934, 0.573728455482269, -90.2916717529297, -1.57588695921858, 218, 30, 'PPL', 'P'),
(53933, 'Cedar Hill Lakes', 38.329719543457, 0.668979807399343, -90.6575012207031, -1.58227188793205, 218, 29, 'PPL', 'P'),
(100613, 'Cedar Hill Mobile Home Park', 38.1452789306641, 0.66576071143171, -78.4305572509766, -1.36887145820345, 218, 53, 'PPL', 'P'),
(85649, 'Cedar Hill Park', 36.1908302307129, 0.631649146556239, -83.4216690063477, -1.45598279166967, 218, 50, 'PPL', 'P'),
(15468, 'Cedar Hills', 30.2627792358398, 0.528185138469579, -81.7474975585938, -1.42676298766349, 218, 12, 'PPL', 'P'),
(26737, 'Cedar Hills', 37.6044387817383, 0.656321270105978, -88.9430618286133, -1.55234927571419, 218, 18, 'PPL', 'P'),
(45534, 'Cedar Hills', 39.6650009155273, 0.692284863782517, -77.6624984741211, -1.35546630369849, 218, 25, 'PPL', 'P'),
(63559, 'Cedar Hills', 35.8055610656738, 0.624924931119898, -80.8038864135742, -1.41029386632438, 218, 33, 'PPL', 'P'),
(85652, 'Cedar Hills', 35.8194389343262, 0.625167145621041, -84.226936340332, -1.47003735800646, 218, 50, 'PPL', 'P'),
(100614, 'Cedar Hills', 37.6977806091309, 0.657950392323807, -77.883056640625, -1.35931576989614, 218, 53, 'PPL', 'P'),
(114887, 'Cedar Hills', 41.9727783203125, 0.732563177899148, -91.7402801513672, -1.60116994534336, 218, 16, 'PPL', 'P'),
(200541, 'Cedar Hills', 45.5050010681152, 0.794212094762147, -122.797218322754, -2.14321577202236, 218, 43, 'PPL', 'P'),
(203323, 'Cedar Hills', 40.4141693115234, 0.705360318944534, -111.757781982422, -1.95054126031926, 218, 52, 'PPL', 'P'),
(1422, 'Cedar Hills Estates', 34.7055587768555, 0.605726269400544, -87.753059387207, -1.53157981500488, 218, 2, 'PPL', 'P'),
(7983, 'Cedar Hills Estates', 34.9333305358887, 0.609701636538732, -91.9638900756836, -1.60507267476282, 218, 4, 'PPL', 'P'),
(15469, 'Cedar Hills Estates', 30.2772197723389, 0.528437173377241, -81.7455596923828, -1.42672916551764, 218, 12, 'PPL', 'P'),
(159891, 'Cedar Hollow', 40.0724983215332, 0.699397035210656, -75.523063659668, -1.31812612205448, 218, 45, 'PPL', 'P'),
(63561, 'Cedar Island', 35.0080604553223, 0.611005919682599, -76.3163909912109, -1.33197229603597, 218, 33, 'PPL', 'P'),
(196180, 'Cedar Junction (historical)', 47.1277809143066, 0.822534946113194, -115.011108398438, -2.00732251792084, 218, 31, 'PPL', 'P'),
(15470, 'Cedar Key', 29.1383304595947, 0.50855980505408, -83.0352783203125, -1.44923900199932, 218, 12, 'PPL', 'P'),
(35188, 'Cedar Knob', 36.6283302307129, 0.639284962033714, -85.084716796875, -1.48500845123239, 218, 21, 'PPL', 'P'),
(75372, 'Cedar Knobb', 35.246940612793, 0.615175164948145, -94.4475021362305, -1.6484198825616, 218, 42, 'PPL', 'P'),
(159887, 'Cedar Knoll', 40.0316696166992, 0.698684439881978, -75.8274993896484, -1.32343952790336, 218, 45, 'PPL', 'P'),
(45535, 'Cedar Knoll Farms', 39.1433296203613, 0.683179982068727, -76.9822235107422, -1.34359326576864, 218, 25, 'PPL', 'P'),
(114888, 'Cedar Knoll Park', 42.4347190856934, 0.740625565204227, -92.2958297729492, -1.61086611539817, 218, 16, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(108521, 'Cedar Knoll Trailer Park', 37.7722206115723, 0.659249615461602, -80.459716796875, -1.40428697332765, 218, 58, 'PPL', 'P'),
(63563, 'Cedar Knolls', 35.3994407653809, 0.617836794720597, -80.1852798461914, -1.39949714494909, 218, 33, 'PPL', 'P'),
(100615, 'Cedar Knolls', 38.7763900756836, 0.676775678858332, -77.5538864135742, -1.35357066563457, 218, 53, 'PPL', 'P'),
(144961, 'Cedar Knolls', 40.8219413757324, 0.712477284062634, -74.4491729736328, -1.29938319377667, 218, 37, 'PPL', 'P'),
(147669, 'Cedar Knolls', 40.9480590820313, 0.714678453282612, -73.8408279418945, -1.28876556998469, 218, 40, 'PPL', 'P'),
(1425, 'Cedar Lake', 33.6375007629395, 0.587085140455398, -87.2819366455078, -1.52335717198121, 218, 2, 'PPL', 'P'),
(19879, 'Cedar Lake', 31.5677795410156, 0.550961690534427, -84.2533264160156, -1.47049795171699, 218, 13, 'PPL', 'P'),
(58932, 'Cedar Lake', 30.4680595397949, 0.53176795566309, -88.9380569458008, -1.55226192403044, 218, 30, 'PPL', 'P'),
(70630, 'Cedar Lake', 39.583610534668, 0.690864333657069, -74.9005584716797, -1.30726135691334, 218, 37, 'PPL', 'P'),
(80219, 'Cedar Lake', 34.2041702270508, 0.596975388374653, -82.1830596923828, -1.43436498099512, 218, 48, 'PPL', 'P'),
(93122, 'Cedar Lake', 28.9008293151855, 0.504414628106886, -95.6366729736328, -1.66917482904297, 218, 51, 'PPL', 'P'),
(122335, 'Cedar Lake', 41.3647193908691, 0.72195054753421, -87.4411087036133, -1.52613524847232, 218, 19, 'PPL', 'P'),
(130128, 'Cedar Lake', 43.4061088562012, 0.75757951501978, -84.9749984741211, -1.48309350525057, 218, 27, 'PPL', 'P'),
(134601, 'Cedar Lake', 44.5872192382813, 0.778193780016566, -93.4400024414063, -1.63083569567408, 218, 28, 'PPL', 'P'),
(147670, 'Cedar Lake', 42.9580612182617, 0.749759608531953, -75.1797180175781, -1.31213361012764, 218, 40, 'PPL', 'P'),
(173483, 'Cedar Lake', 43.353889465332, 0.756668114715728, -88.2925033569336, -1.54099488840664, 218, 57, 'PPL', 'P'),
(177584, 'Cedar Lake', 41.4013900756836, 0.722590571723183, -72.504997253418, -1.26545092622159, 218, 8, 'PPL', 'P'),
(100616, 'Cedar Lake Shores', 36.7758293151855, 0.641859306701439, -76.5358276367188, -1.33580218799961, 218, 53, 'PPL', 'P'),
(177583, 'Cedar Land', 41.4738883972168, 0.723855906136107, -73.2263870239258, -1.27804155290716, 218, 8, 'PPL', 'P'),
(15471, 'Cedar Landing', 29.7238903045654, 0.518779752316287, -81.2538909912109, -1.41814792785319, 218, 12, 'PPL', 'P'),
(45537, 'Cedar Landing', 38.1463890075684, 0.66578008592864, -76.4677810668945, -1.33461455131149, 218, 25, 'PPL', 'P'),
(100617, 'Cedar Landing Estates', 37.1180610656738, 0.647832377552323, -76.3680572509766, -1.33287404238107, 218, 53, 'PPL', 'P'),
(85653, 'Cedar Lane', 36.3569412231445, 0.634548330297926, -82.6622161865234, -1.44272783945019, 218, 50, 'PPL', 'P'),
(93124, 'Cedar Lane', 28.9387798309326, 0.505076989559502, -95.7370529174805, -1.67092678956608, 218, 51, 'PPL', 'P'),
(100618, 'Cedar Lane', 37.7041702270508, 0.658061912194454, -77.4833297729492, -1.35233921994651, 218, 53, 'PPL', 'P'),
(134603, 'Cedar Lane Trailer Park', 44.2291717529297, 0.771944672518695, -95.6244430541992, -1.6689613766816, 218, 28, 'PPL', 'P'),
(45539, 'Cedar Lawn', 39.6494407653809, 0.692013287930357, -77.7644424438477, -1.35724556162277, 218, 25, 'PPL', 'P'),
(159888, 'Cedar Ledge', 41.6394386291504, 0.726745302760788, -76.8708267211914, -1.34164902501483, 218, 45, 'PPL', 'P'),
(100619, 'Cedar Level', 37.2733306884766, 0.650542343698561, -77.3183288574219, -1.34945941070176, 218, 53, 'PPL', 'P'),
(147672, 'Cedar Manor', 40.690559387207, 0.710184235785049, -73.7908325195313, -1.28789298525352, 218, 40, 'PPL', 'P'),
(177884, 'Cedar Mill', 34.4719390869141, 0.601648836613578, -111.995826721191, -1.95469592477784, 218, 5, 'PPL', 'P'),
(180617, 'Cedar Mill', 39.9441719055176, 0.697157316733899, -120.922218322754, -2.11049084854747, 218, 6, 'PPL', 'P'),
(200542, 'Cedar Mill', 45.5250015258789, 0.794561168602029, -122.809722900391, -2.1434340180737, 218, 43, 'PPL', 'P'),
(19880, 'Cedar Mill Crossing', 34.1166687011719, 0.595448198647547, -84.6361083984375, -1.47717875762756, 218, 13, 'PPL', 'P'),
(39706, 'Cedar Mill Run', 30.5513896942139, 0.533222341223896, -91.0013885498047, -1.58827385408076, 218, 22, 'PPL', 'P'),
(72043, 'Cedar Mills', 38.8230590820313, 0.677590206677733, -83.3927764892578, -1.45547852211727, 218, 41, 'PPL', 'P'),
(93125, 'Cedar Mills', 33.8286094665527, 0.590420616562668, -96.8194427490234, -1.68981805591661, 218, 51, 'PPL', 'P'),
(134604, 'Cedar Mills', 44.9430618286133, 0.784404404836685, -94.522216796875, -1.64972389938936, 218, 28, 'PPL', 'P'),
(63564, 'Cedar Mountain', 35.1433296203613, 0.613366811988954, -82.6430587768555, -1.44239347957533, 218, 33, 'PPL', 'P'),
(206991, 'Cedar Mountain', 47.4483299255371, 0.828129581773178, -122.071937561035, -2.130557234729, 218, 56, 'PPL', 'P'),
(196181, 'Cedar Mouth (historical)', 47.1791687011719, 0.823431832189306, -114.861106872559, -2.00470449741123, 218, 31, 'PPL', 'P'),
(100621, 'Cedar Orchard', 37.2347183227539, 0.649868430784716, -80.3969421386719, -1.4031913488552, 218, 53, 'PPL', 'P'),
(26738, 'Cedar Park', 38.7555618286133, 0.676412157369536, -90.103889465332, -1.57260954002308, 218, 18, 'PPL', 'P'),
(93126, 'Cedar Park', 30.5049991607666, 0.532412673673484, -97.8199996948242, -1.70728106897453, 218, 51, 'PPL', 'P'),
(100623, 'Cedar Park', 38.7933311462402, 0.677071356318358, -77.4794387817383, -1.35227130933872, 218, 53, 'PPL', 'P'),
(154640, 'Cedar Park', 41.1627807617188, 0.718426053568572, -80.6433334350586, -1.4074916882254, 218, 41, 'PPL', 'P'),
(173485, 'Cedar Park', 42.6888885498047, 0.745061659210999, -88.2305603027344, -1.53991377816212, 218, 57, 'PPL', 'P'),
(159889, 'Cedar Pines', 41.5094413757324, 0.724476422670095, -77.4563903808594, -1.35186903885606, 218, 45, 'PPL', 'P'),
(180618, 'Cedar Pines Vista', 38.0338897705078, 0.663816603835952, -120.225563049316, -2.0983319202746, 218, 6, 'PPL', 'P'),
(1426, 'Cedar Plains', 34.3650016784668, 0.599782426742623, -86.9963912963867, -1.51837346547529, 218, 2, 'PPL', 'P'),
(1428, 'Cedar Point', 32.3666687011719, 0.564904936737646, -86.4400024414063, -1.50866264803448, 218, 2, 'PPL', 'P'),
(15472, 'Cedar Point', 30.4436092376709, 0.531341217387918, -81.4638900756836, -1.42181310330341, 218, 12, 'PPL', 'P'),
(19881, 'Cedar Point', 31.4972190856934, 0.549730178267347, -81.3494415283203, -1.4198155993278, 218, 13, 'PPL', 'P'),
(31991, 'Cedar Point', 38.2599983215332, 0.667762942518259, -96.8194427490234, -1.68981805591661, 218, 20, 'PPL', 'P'),
(35190, 'Cedar Point', 36.8647193908691, 0.643410731194465, -87.8919372558594, -1.53400369107102, 218, 21, 'PPL', 'P'),
(45541, 'Cedar Point', 38.7438888549805, 0.676208425546145, -76.1041717529297, -1.32826837159189, 218, 25, 'PPL', 'P'),
(63565, 'Cedar Point', 34.6875, 0.605411084285533, -77.0727767944336, -1.34517371871755, 218, 33, 'PPL', 'P'),
(93127, 'Cedar Point', 31.704719543457, 0.553351744454719, -94.4863891601563, -1.64909858916541, 218, 51, 'PPL', 'P'),
(100627, 'Cedar Point', 36.8988914489746, 0.644007146120588, -76.4922180175781, -1.33504105656007, 218, 53, 'PPL', 'P'),
(119065, 'Cedar Point', 41.2630615234375, 0.720176283036972, -89.1255569458008, -1.55553441637793, 218, 18, 'PPL', 'P'),
(122337, 'Cedar Point', 40.7088890075684, 0.710504148010995, -86.7602767944336, -1.5142524900045, 218, 19, 'PPL', 'P'),
(154641, 'Cedar Point', 41.4799995422363, 0.723962565737765, -82.682502746582, -1.44308190671711, 218, 41, 'PPL', 'P'),
(159890, 'Cedar Point', 40.1699981689453, 0.701098728568189, -76.8866729736328, -1.34192559429403, 218, 45, 'PPL', 'P'),
(186512, 'Cedar Point', 39.3452796936035, 0.686704675771447, -103.870002746582, -1.81287354198341, 218, 7, 'PPL', 'P'),
(200543, 'Cedar Point', 43.1797218322754, 0.753628316068484, -124.212219238281, -2.16791219691705, 218, 43, 'PPL', 'P'),
(114889, 'Cedar Rapids', 42.0083312988281, 0.733183694433137, -91.6438903808594, -1.59948762648276, 218, 16, 'PPL', 'P'),
(141447, 'Cedar Rapids', 41.560001373291, 0.725358861097293, -98.144172668457, -1.7129389547104, 218, 35, 'PPL', 'P'),
(80222, 'Cedar Reef Villas', 32.4049987792969, 0.565573922803474, -80.4327774047852, -1.4038167922372, 218, 48, 'PPL', 'P'),
(19883, 'Cedar Ridge', 34.7811088562012, 0.607044867035269, -84.8888931274414, -1.48159068344744, 218, 13, 'PPL', 'P'),
(53934, 'Cedar Ridge', 37.651668548584, 0.657145585042385, -92.9127807617188, -1.62163394147564, 218, 29, 'PPL', 'P'),
(63566, 'Cedar Ridge', 36.4199981689453, 0.635648881618402, -79.6572189331055, -1.39028074336466, 218, 33, 'PPL', 'P'),
(75373, 'Cedar Ridge', 36.2077789306641, 0.63194495717432, -96.2697219848633, -1.68022361861543, 218, 42, 'PPL', 'P'),
(77989, 'Cedar Ridge', 39.8461112976074, 0.69544583625936, -77.1113891601563, -1.34584763163139, 218, 45, 'PPL', 'P'),
(177885, 'Cedar Ridge', 33.3333282470703, 0.581776328559407, -111.845001220703, -1.95206352319835, 218, 5, 'PPL', 'P'),
(180622, 'Cedar Ridge', 39.1988906860352, 0.684149705600652, -121.019996643066, -2.11219740217399, 218, 6, 'PPL', 'P'),
(191242, 'Cedar Ridge Number 1 Colonia', 28.6860008239746, 0.500665163608163, -100.471000671387, -1.75354976448913, 218, 51, 'PPL', 'P'),
(191243, 'Cedar Ridge Number 2 Colonia', 28.6889991760254, 0.500717494723583, -100.47200012207, -1.75356720819427, 218, 51, 'PPL', 'P'),
(191244, 'Cedar Ridge Number 3 Colonia', 28.6860008239746, 0.500665163608163, -100.472999572754, -1.75358465189941, 218, 51, 'PPL', 'P'),
(191245, 'Cedar Ridge Number 4 Colonia', 28.6860008239746, 0.500665163608163, -100.472999572754, -1.75358465189941, 218, 51, 'PPL', 'P'),
(130129, 'Cedar River', 45.4111099243164, 0.792573385164394, -87.3544387817383, -1.52462257297316, 218, 27, 'PPL', 'P'),
(19885, 'Cedar Rock', 33.502498626709, 0.58472890868095, -82.6155624389648, -1.44191357794689, 218, 13, 'PPL', 'P'),
(80221, 'Cedar Rock', 34.8738899230957, 0.608664202136092, -82.6402816772461, -1.44234501004349, 218, 48, 'PPL', 'P'),
(112451, 'Cedar Rock', 35.9441719055176, 0.627344146654126, -81.4583282470703, -1.42171603108168, 218, 33, 'PPL', 'P'),
(63567, 'Cedar Rock Estates', 35.9625015258789, 0.627664058880072, -81.4377822875977, -1.4213574364409, 218, 33, 'PPL', 'P'),
(180620, 'Cedar Rock Lodge', 38.021671295166, 0.663603351211664, -120.245826721191, -2.09868558806737, 218, 6, 'PPL', 'P'),
(177428, 'Cedar Rocks', 40.0288887023926, 0.698635903771111, -80.6469421386719, -1.40755467198518, 218, 58, 'PPL', 'P'),
(45542, 'Cedar Run', 38.7416687011719, 0.676169676552284, -76.6333312988281, -1.33750394793617, 218, 25, 'PPL', 'P'),
(70631, 'Cedar Run', 39.6847190856934, 0.692629010774383, -74.2675018310547, -1.29621243418282, 218, 37, 'PPL', 'P'),
(72045, 'Cedar Run', 39.7730598449707, 0.694170847887484, -81.9024963378906, -1.42946822669879, 218, 41, 'PPL', 'P'),
(130130, 'Cedar Run', 44.7627792358398, 0.781257880008757, -85.813606262207, -1.49772997228554, 218, 27, 'PPL', 'P'),
(159892, 'Cedar Run', 41.5224990844727, 0.724704322680379, -77.4461135864258, -1.35168967495664, 218, 45, 'PPL', 'P'),
(19886, 'Cedar Shoals Estates', 33.9150009155273, 0.591928431792843, -83.320556640625, -1.45421804797333, 218, 13, 'PPL', 'P'),
(13508, 'Cedar Shores', 38.5747184753418, 0.673255845424601, -75.0938873291016, -1.31063558201447, 218, 10, 'PPL', 'P'),
(93128, 'Cedar Shores', 31.9348106384277, 0.557367591641476, -97.4414978027344, -1.70067496473254, 218, 51, 'PPL', 'P'),
(122338, 'Cedar Shores', 41.2275009155273, 0.719555633344929, -85.0722198486328, -1.48479033833911, 218, 19, 'PPL', 'P'),
(180621, 'Cedar Slope', 36.1452789306641, 0.630854126391823, -118.577499389648, -2.06956778313093, 218, 6, 'PPL', 'P'),
(35191, 'Cedar Spring', 37.1222190856934, 0.647904948692028, -86.1530609130859, -1.50365457360458, 218, 21, 'PPL', 'P'),
(45543, 'Cedar Spring', 39.5011100769043, 0.68942442903469, -76.3394393920898, -1.33237456651863, 218, 25, 'PPL', 'P'),
(85655, 'Cedar Spring', 36.1841697692871, 0.631532899574657, -85.293327331543, -1.48864939191669, 218, 50, 'PPL', 'P'),
(1430, 'Cedar Springs', 33.8199996948242, 0.59027034769816, -85.8349990844727, -1.49810334747037, 218, 2, 'PPL', 'P'),
(19887, 'Cedar Springs', 31.1833305358887, 0.544251789588945, -85.0380630493164, -1.4841941897291, 218, 13, 'PPL', 'P'),
(35192, 'Cedar Springs', 36.8308296203613, 0.642819243116358, -86.1066665649414, -1.50284483947514, 218, 21, 'PPL', 'P'),
(53951, 'Cedar Springs', 37.8736114501953, 0.661019219426933, -93.8933334350586, -1.63874781411465, 218, 29, 'PPL', 'P'),
(70632, 'Cedar Springs', 39.2452812194824, 0.684959373151064, -74.7072219848633, -1.30388699865416, 218, 37, 'PPL', 'P'),
(72050, 'Cedar Springs', 39.8380584716797, 0.695305287932831, -84.7941665649414, -1.47993739304272, 218, 41, 'PPL', 'P'),
(75374, 'Cedar Springs', 36.2174987792969, 0.632114600535758, -98.5830612182617, -1.7205990049538, 218, 42, 'PPL', 'P'),
(80225, 'Cedar Springs', 34.2416687011719, 0.59762986021254, -80.8188934326172, -1.41055578821759, 218, 48, 'PPL', 'P'),
(85658, 'Cedar Springs', 35.4191703796387, 0.618181141449545, -84.616943359375, -1.47684426459465, 218, 50, 'PPL', 'P'),
(93130, 'Cedar Springs', 32.8688888549805, 0.573670331991478, -94.7344436645508, -1.65342795699149, 218, 51, 'PPL', 'P'),
(100633, 'Cedar Springs', 36.8280601501465, 0.642770906742573, -81.2905578613281, -1.41878788546314, 218, 53, 'PPL', 'P'),
(130131, 'Cedar Springs', 43.223331451416, 0.754389447508029, -85.5513916015625, -1.49315346311029, 218, 27, 'PPL', 'P'),
(159893, 'Cedar Springs', 41.0813903808594, 0.717005523443123, -77.4800033569336, -1.35228116303475, 218, 45, 'PPL', 'P'),
(177886, 'Cedar Springs', 35.4516716003418, 0.618748394761732, -110.363609313965, -1.92620835691337, 218, 5, 'PPL', 'P'),
(180625, 'Cedar Springs', 34.3505592346191, 0.599530358545447, -117.884170532227, -2.05746691176983, 218, 6, 'PPL', 'P'),
(203327, 'Cedar Springs', 41.6369400024414, 0.726701693497938, -112.627777099609, -1.96572553959045, 218, 52, 'PPL', 'P'),
(1431, 'Cedar Springs (historical)', 34.3050003051758, 0.598735205222977, -85.4933319091797, -1.49214013031552, 218, 2, 'PPL', 'P'),
(180623, 'Cedar Springs (historical)', 34.2833290100098, 0.598356969769158, -117.33332824707, -2.04785290023464, 218, 6, 'PPL', 'P'),
(203328, 'Cedar Springs Condominium', 40.9174995422363, 0.714145088695296, -111.879997253418, -1.95267431919436, 218, 52, 'PPL', 'P'),
(193439, 'Cedar Stock', 40.8463897705078, 0.712903989048292, -122.82861328125, -2.14376371741665, 218, 6, 'PPL', 'P'),
(80226, 'Cedar Swamp', 33.6566696166992, 0.587419700067339, -79.6675033569336, -1.39046024042213, 218, 48, 'PPL', 'P'),
(147673, 'Cedar Swamp', 43.0258293151855, 0.750942384951085, -77.6305618286133, -1.35490890408233, 218, 40, 'PPL', 'P'),
(80227, 'Cedar Terrace', 34.7455596923828, 0.606424417080308, -80.813606262207, -1.41046350968582, 218, 48, 'PPL', 'P'),
(19888, 'Cedar Trace', 33.3372192382813, 0.581844239167204, -84.8597183227539, -1.48108148704702, 218, 13, 'PPL', 'P'),
(31992, 'Cedar Vale', 37.1041717529297, 0.647589963314099, -96.4997177124023, -1.68423780132651, 218, 20, 'PPL', 'P'),
(19895, 'Cedar Valley', 33.6558303833008, 0.587405052681344, -84.3005599975586, -1.47132233323242, 218, 13, 'PPL', 'P'),
(53935, 'Cedar Valley', 36.7669410705566, 0.641704177567942, -90.4530563354492, -1.57870365154551, 218, 29, 'PPL', 'P'),
(63568, 'Cedar Valley', 35.9027786254883, 0.626621697629415, -81.4347229003906, -1.42130404006104, 218, 33, 'PPL', 'P'),
(75375, 'Cedar Valley', 35.8641700744629, 0.625947851294597, -97.5616683959961, -1.70277233724903, 218, 42, 'PPL', 'P'),
(93132, 'Cedar Valley', 30.2222194671631, 0.527477236962322, -97.9555587768555, -1.70964702128696, 218, 51, 'PPL', 'P'),
(114891, 'Cedar Valley', 41.726390838623, 0.72826290510797, -91.2463912963867, -1.59254995868505, 218, 16, 'PPL', 'P'),
(154647, 'Cedar Valley', 40.8722190856934, 0.713354795641815, -82.0247192382813, -1.43160141873194, 218, 41, 'PPL', 'P'),
(206993, 'Cedar Valley', 47.8138885498047, 0.834509783375709, -122.302223205566, -2.13457647744615, 218, 56, 'PPL', 'P'),
(53936, 'Cedar Valley (historical)', 36.5400009155273, 0.637743324657695, -93.2919387817383, -1.62825149731032, 218, 29, 'PPL', 'P'),
(100631, 'Cedar View', 37.6136093139648, 0.656481326087492, -75.876106262207, -1.3242878778686, 218, 53, 'PPL', 'P'),
(63569, 'Cedar Village', 35.3269386291504, 0.616571393728646, -80.228889465332, -1.40025827638864, 218, 33, 'PPL', 'P'),
(75377, 'Cedar Village', 34.4422187805176, 0.601130119412258, -97.1338882446289, -1.69530616513299, 218, 42, 'PPL', 'P'),
(53937, 'Cedar Vista', 37.5258293151855, 0.654949276091397, -93.370002746582, -1.62961397052401, 218, 29, 'PPL', 'P'),
(180624, 'Cedar Vista', 38.1694412231445, 0.666182422990324, -120.406936645508, -2.10149748670433, 218, 6, 'PPL', 'P'),
(143595, 'Cedar Waters', 43.1263885498047, 0.752697474688474, -71.0708312988281, -1.24042000829399, 218, 36, 'PPL', 'P'),
(45545, 'Cedar Woods', 39.208610534668, 0.68431934896209, -76.8874969482422, -1.34193997536392, 218, 25, 'PPL', 'P'),
(45546, 'Cedarbrook', 39.605281829834, 0.691242569110888, -76.8322219848633, -1.34097524525904, 218, 25, 'PPL', 'P'),
(100632, 'Cedarbrook', 38.4388885498047, 0.67088516600124, -78.0313873291016, -1.36190462879181, 218, 53, 'PPL', 'P'),
(159894, 'Cedarbrook', 40.0830612182617, 0.699581392537116, -75.1602783203125, -1.31179432340477, 218, 45, 'PPL', 'P'),
(180627, 'Cedarbrook', 36.7069396972656, 0.640656956048296, -119.007217407227, -2.07706777739281, 218, 6, 'PPL', 'P'),
(13509, 'Cedarbrook Acres', 39.2791709899902, 0.68555086122917, -75.6097183227539, -1.31963853123754, 218, 10, 'PPL', 'P'),
(159895, 'Cedarbrook County Home', 40.5766716003418, 0.708196518926441, -75.5449981689453, -1.31850895146118, 218, 45, 'PPL', 'P'),
(173490, 'Cedarburg', 43.2966690063477, 0.755669429306948, -87.9875030517578, -1.53567162886173, 218, 57, 'PPL', 'P'),
(85661, 'Cedarchase', 36.0744400024414, 0.629617753855754, -83.8986129760742, -1.46430703428893, 218, 50, 'PPL', 'P'),
(53943, 'Cedarcreek', 36.5788917541504, 0.638422097840529, -92.9974975585938, -1.62311252851285, 218, 29, 'PPL', 'P'),
(45547, 'Cedarcrest', 38.3450012207031, 0.669246522982514, -75.6947174072266, -1.32112204512277, 218, 25, 'PPL', 'P'),
(147680, 'Cedarcrest', 42.8055610656738, 0.747097978759501, -77.7008285522461, -1.35613528976431, 218, 40, 'PPL', 'P'),
(45549, 'Cedarcroft', 39.3669395446777, 0.687082711488184, -76.6100006103516, -1.3370967506055, 218, 25, 'PPL', 'P'),
(75404, 'Cedardale', 36.3188896179199, 0.633884204501088, -98.9961090087891, -1.72780804886659, 218, 42, 'PPL', 'P'),
(200546, 'Cedardale', 45.1591682434082, 0.788176173309537, -122.493606567383, -2.13791674724338, 218, 43, 'PPL', 'P'),
(206995, 'Cedardale', 48.3594398498535, 0.844031449800096, -122.32250213623, -2.13493041155502, 218, 56, 'PPL', 'P'),
(186513, 'Cedaredge', 38.901668548584, 0.678962200692314, -107.925827026367, -1.88366102954799, 218, 7, 'PPL', 'P'),
(53944, 'Cedargrove', 37.4186096191406, 0.653077939372425, -91.6069412231445, -1.59884274202479, 218, 29, 'PPL', 'P'),
(45550, 'Cedarhaven', 38.5727806091309, 0.673222023278757, -76.686393737793, -1.33843006220525, 218, 25, 'PPL', 'P'),
(194709, 'Cedarhill', 42.2669410705566, 0.73769728642763, -112.730560302734, -1.96751944490073, 218, 17, 'PPL', 'P'),
(45553, 'Cedarhurst', 39.500560760498, 0.689414841654766, -76.894172668457, -1.34205648866161, 218, 25, 'PPL', 'P'),
(147674, 'Cedarhurst', 40.6227798461914, 0.709001259628836, -73.7247161865234, -1.28673903755319, 218, 40, 'PPL', 'P'),
(177585, 'Cedarhurst', 41.4266700744629, 0.723031790936782, -73.2216720581055, -1.27795926122947, 218, 8, 'PPL', 'P'),
(206996, 'Cedarhurst', 47.4822196960449, 0.828721069851285, -122.478057861328, -2.1376453711283, 218, 56, 'PPL', 'P'),
(190026, 'Cedarhurst (historical)', 38.2666702270508, 0.667879389236922, -114.269996643066, -1.99438767766438, 218, 39, 'PPL', 'P'),
(45554, 'Cedarhurst Acres', 38.4008293151855, 0.670220907046347, -75.6391677856445, -1.32015252132793, 218, 25, 'PPL', 'P'),
(200544, 'Cedarhurst Park', 45.3311080932617, 0.791177089804866, -122.425003051758, -2.13671939001728, 218, 43, 'PPL', 'P'),
(45555, 'Cedarhurst Village Trailer Park', 38.398609161377, 0.670182158052486, -75.6347198486328, -1.32007489018215, 218, 25, 'PPL', 'P'),
(45556, 'Cedarlea', 38.8216705322266, 0.677565971911813, -76.5361099243164, -1.33580711484763, 218, 25, 'PPL', 'P'),
(45557, 'Cedarmere', 39.4352798461914, 0.688275474761403, -76.8061065673828, -1.34051944523847, 218, 25, 'PPL', 'P'),
(100637, 'Cedarmere', 38.2491683959961, 0.66757392465989, -78.5833282470703, -1.37153781508684, 218, 53, 'PPL', 'P'),
(100634, 'Cedarmere (historical)', 38.2522201538086, 0.667627187881692, -78.5833282470703, -1.37153781508684, 218, 53, 'PPL', 'P'),
(19891, 'Cedarpark', 31.9752807617188, 0.558073928541593, -82.8375015258789, -1.44578714575241, 218, 13, 'PPL', 'P'),
(180626, 'Cedarpines Park', 34.25, 0.597775268808058, -117.324996948242, -2.04770749163913, 218, 6, 'PPL', 'P'),
(13510, 'Cedars', 39.7416687011719, 0.693622969072228, -75.6374969482422, -1.32012335971399, 218, 10, 'PPL', 'P'),
(45558, 'Cedars', 39.1694412231445, 0.683635715510267, -76.7911071777344, -1.34025765650332, 218, 25, 'PPL', 'P'),
(58936, 'Cedars', 32.250560760498, 0.562878470885177, -90.9252777099609, -1.58694546932903, 218, 30, 'PPL', 'P'),
(75383, 'Cedars', 35.274169921875, 0.61565040604467, -94.442497253418, -1.64833253087785, 218, 42, 'PPL', 'P'),
(147675, 'Cedars', 44.4911117553711, 0.776516388003979, -75.6369400024414, -1.32011363917601, 218, 40, 'PPL', 'P'),
(159896, 'Cedars', 40.2125015258789, 0.701840552089831, -75.3688888549805, -1.31543526408907, 218, 45, 'PPL', 'P'),
(13511, 'Cedars Knoll', 39.7444381713867, 0.693671305446013, -75.6355590820313, -1.32008953756815, 218, 10, 'PPL', 'P'),
(147676, 'Cedars Nursing Home', 44.6652793884277, 0.779556186651223, -75.5391693115234, -1.31840721870754, 218, 40, 'PPL', 'P'),
(45559, 'Cedarside Farm', 39.4041709899902, 0.687732522794163, -76.476936340332, -1.3347743409769, 218, 25, 'PPL', 'P'),
(39708, 'Cedarton', 32.6300010681152, 0.569500953567877, -92.5274963378906, -1.61490945972319, 218, 22, 'PPL', 'P'),
(19892, 'Cedartown', 34.0536117553711, 0.594347647327071, -85.254997253418, -1.48798040585087, 218, 13, 'PPL', 'P'),
(45560, 'Cedartown', 38.1958312988281, 0.666643016700853, -75.3038864135742, -1.31430075746469, 218, 25, 'PPL', 'P'),
(93133, 'Cedarvale', 32.5697212219238, 0.568448871779242, -96.0913925170898, -1.67711118224946, 218, 51, 'PPL', 'P'),
(147677, 'Cedarvale', 42.9658317565918, 0.749895230010466, -76.2497177124023, -1.33080862779766, 218, 40, 'PPL', 'P'),
(188270, 'Cedarvale', 34.3705596923828, 0.599879432385329, -105.701393127441, -1.84483733401876, 218, 38, 'PPL', 'P'),
(58937, 'Cedarview', 34.9136085510254, 0.60935742296784, -89.8319396972656, -1.56786312117028, 218, 30, 'PPL', 'P'),
(93134, 'Cedarview', 32.579719543457, 0.568623375409669, -96.9663925170898, -1.69238281320441, 218, 51, 'PPL', 'P'),
(203330, 'Cedarview', 40.360279083252, 0.704419757026545, -110.042221069336, -1.92059907386739, 218, 52, 'PPL', 'P'),
(1435, 'Cedarville', 32.6124992370605, 0.569195488990845, -87.6694412231445, -1.53012040272752, 218, 2, 'PPL', 'P'),
(7988, 'Cedarville', 35.5697212219238, 0.620808749339071, -94.3666687011719, -1.64700907297413, 218, 4, 'PPL', 'P'),
(35193, 'Cedarville', 37.3252792358398, 0.651449016891678, -82.3274993896484, -1.43688592928299, 218, 21, 'PPL', 'P'),
(45561, 'Cedarville', 38.6627807617188, 0.674792822268713, -76.8024978637695, -1.34045646147869, 218, 25, 'PPL', 'P'),
(53945, 'Cedarville', 37.5744400024414, 0.655797692635669, -93.9841690063477, -1.64033319391157, 218, 29, 'PPL', 'P'),
(70642, 'Cedarville', 39.3325004577637, 0.686481636030153, -75.1999969482422, -1.31248754423651, 218, 37, 'PPL', 'P'),
(72046, 'Cedarville', 39.7441711425781, 0.693666644914105, -83.8086090087891, -1.46273616871995, 218, 41, 'PPL', 'P'),
(100635, 'Cedarville', 38.9769401550293, 0.68027593805805, -78.184440612793, -1.36457591252321, 218, 53, 'PPL', 'P'),
(108522, 'Cedarville', 38.8422203063965, 0.677924633131619, -80.8194427490234, -1.41056537559752, 218, 58, 'PPL', 'P'),
(119067, 'Cedarville', 42.3758316040039, 0.739597784760538, -89.633056640625, -1.56439195700547, 218, 18, 'PPL', 'P'),
(124464, 'Cedarville', 41.8102798461914, 0.729727044496268, -70.5558319091797, -1.23143157329886, 218, 23, 'PPL', 'P'),
(130134, 'Cedarville', 45.9980583190918, 0.80281756719252, -84.3630599975586, -1.47241316401492, 218, 27, 'PPL', 'P'),
(147678, 'Cedarville', 42.9305610656738, 0.749279640324494, -75.1130599975586, -1.31097020820544, 218, 40, 'PPL', 'P'),
(159897, 'Cedarville', 40.2269401550293, 0.702092553707979, -75.6719436645508, -1.32072456833007, 218, 45, 'PPL', 'P'),
(173489, 'Cedarville', 45.4536094665527, 0.793315142107009, -87.982780456543, -1.53558920402599, 218, 57, 'PPL', 'P'),
(193440, 'Cedarville', 41.5291709899902, 0.724820769399043, -120.172218322754, -2.09740087915751, 218, 6, 'PPL', 'P'),
(206999, 'Cedarville', 48.8402786254883, 0.852423669606181, -122.294441223145, -2.13444065623055, 218, 56, 'PPL', 'P'),
(122339, 'Cedarville (historical)', 41.2036094665527, 0.71913864889725, -85.0219421386719, -1.48391282675993, 218, 19, 'PPL', 'P'),
(124465, 'Cedarville Landing', 41.8138885498047, 0.729790028256049, -70.5416717529297, -1.2311844319497, 218, 23, 'PPL', 'P'),
(13512, 'Cedarville Mobile Home Park', 38.5813903808594, 0.673372292143265, -75.0863876342773, -1.3105046876469, 218, 10, 'PPL', 'P'),
(147679, 'Cedarville Station', 42.9027786254883, 0.748794745269018, -75.1211090087891, -1.31111068995294, 218, 40, 'PPL', 'P'),
(45562, 'Cedarville Trailer Park', 38.6569404602051, 0.674690889777991, -76.8249969482422, -1.34084914458142, 218, 25, 'PPL', 'P'),
(19893, 'Cedarwood', 33.5527801513672, 0.585606486839159, -85.0924987792969, -1.48514427244799, 218, 13, 'PPL', 'P'),
(45564, 'Cedarwood', 39.5480613708496, 0.690243883702108, -76.383056640625, -1.33313583111623, 218, 25, 'PPL', 'P'),
(80229, 'Cedarwood', 35.1049995422363, 0.612697825923126, -81.0577774047852, -1.41472510006217, 218, 48, 'PPL', 'P'),
(124466, 'Cedarwood', 42.3708305358887, 0.739510499655811, -71.2630615234375, -1.24377505863527, 218, 23, 'PPL', 'P'),
(186514, 'Cedarwood', 37.9416694641113, 0.662207055852135, -104.616943359375, -1.82591011499351, 218, 7, 'PPL', 'P'),
(45565, 'Cedarwood Cove', 39.0002784729004, 0.680683268546778, -76.4627838134766, -1.33452733278579, 218, 25, 'PPL', 'P'),
(45566, 'Cedarwood Estates', 39.3791694641113, 0.687296163849554, -76.7347183227539, -1.33927348532248, 218, 25, 'PPL', 'P'),
(144962, 'Cedarwood Park', 40.0497207641602, 0.698999491838934, -74.1305618286133, -1.29382238026253, 218, 37, 'PPL', 'P'),
(100636, 'Cedon', 38.0611114501953, 0.664291711774422, -77.5188903808594, -1.35295986963856, 218, 53, 'PPL', 'P'),
(45567, 'Cedonia', 39.3338890075684, 0.686505870796073, -76.5430603027344, -1.33592842183528, 218, 25, 'PPL', 'P'),
(207000, 'Cedonia', 48.1538887023926, 0.84044390549565, -118.168060302734, -2.06242172297792, 218, 56, 'PPL', 'P'),
(193164, 'Cedric', 45.8250007629395, 0.799797143042207, -112.265556335449, -1.95940359463677, 218, 31, 'PPL', 'P'),
(188271, 'Cedro', 35.0222206115723, 0.611253061031758, -106.353057861328, -1.85621102924421, 218, 38, 'PPL', 'P'),
(1436, 'Cedron', 33.4658317565918, 0.584088951071004, -85.5177764892578, -1.49256676872215, 218, 2, 'PPL', 'P'),
(53946, 'Cedron', 38.773609161377, 0.676727142747465, -92.567497253418, -1.61560760740295, 218, 29, 'PPL', 'P'),
(72048, 'Cedron', 38.8061103820801, 0.677294396059652, -84.0550003051758, -1.46703650809016, 218, 41, 'PPL', 'P'),
(194710, 'Cedron', 43.6222190856934, 0.76135135007166, -111.190277099609, -1.94063643159303, 218, 17, 'PPL', 'P'),
(1437, 'Cedrum', 33.851390838623, 0.590818226513417, -87.4466705322266, -1.52623232069406, 218, 2, 'PPL', 'P'),
(134611, 'Cee Jefferson', 43.5141716003418, 0.759465565703774, -91.2802810668945, -1.59314144676315, 218, 28, 'PPL', 'P'),
(191246, 'Cee Vee', 34.2230606079102, 0.597305087717604, -100.445281982422, -1.7531008886874, 218, 51, 'PPL', 'P'),
(63572, 'Ceffo', 36.4569396972656, 0.63629363291831, -79.0466690063477, -1.37962463689492, 218, 33, 'PPL', 'P'),
(93135, 'Cego', 31.2450008392334, 0.545328139433014, -97.1622161865234, -1.69580058098936, 218, 51, 'PPL', 'P'),
(196182, 'Celander Trailer Court', 45.7019386291504, 0.797649303623058, -111.033332824707, -1.93789723725383, 218, 31, 'PPL', 'P'),
(93136, 'Cele', 30.4411106109619, 0.531297608125068, -97.522216796875, -1.70208377694919, 218, 51, 'PPL', 'P'),
(15473, 'Celebration', 28.3250007629395, 0.494364523943199, -81.533332824707, -1.42302510791551, 218, 12, 'PPL', 'P'),
(154642, 'Celeryville', 41.0297203063965, 0.716103710518995, -82.7319412231445, -1.4439447709103, 218, 41, 'PPL', 'P'),
(203333, 'Celesta Vu Condominium', 40.7744407653809, 0.711648242015293, -111.881393432617, -1.95269868711833, 218, 52, 'PPL', 'P'),
(1438, 'Celeste', 30.8944396972656, 0.539209693276125, -88.1233291625977, -1.53804224170607, 218, 2, 'PPL', 'P'),
(19894, 'Celeste', 33.7827796936035, 0.589620736129262, -82.8450012207031, -1.44591804011999, 218, 13, 'PPL', 'P'),
(93137, 'Celeste', 33.2941703796387, 0.581092894844665, -96.1944427490234, -1.67890974809164, 218, 51, 'PPL', 'P'),
(203331, 'Celeste', 40.610279083252, 0.708783080156531, -111.887496948242, -1.95280521356193, 218, 52, 'PPL', 'P'),
(63573, 'Celeste Hinkel', 35.7569389343262, 0.624076314838544, -80.9755630493164, -1.41329018886683, 218, 33, 'PPL', 'P'),
(203332, 'Celeste Place Townhouses', 41.1513900756836, 0.718227248593197, -112.035003662109, -1.95537969138771, 218, 52, 'PPL', 'P'),
(80232, 'Celestia (historical)', 34.0058288574219, 0.593513678431713, -81.9569396972656, -1.43041844257573, 218, 48, 'PPL', 'P'),
(29422, 'Celestine', 38.3847198486328, 0.669939743814262, -86.779167175293, -1.51458218934745, 218, 19, 'PPL', 'P'),
(159898, 'Celia', 40.814998626709, 0.712356110233036, -80.228889465332, -1.40025827638864, 218, 45, 'PPL', 'P'),
(200545, 'Celilo Village', 45.6458282470703, 0.796669992711209, -120.964721679688, -2.11123267206911, 218, 43, 'PPL', 'P'),
(29423, 'Celina', 38.188060760498, 0.666507395222341, -86.6127777099609, -1.51167814533677, 218, 19, 'PPL', 'P'),
(85665, 'Celina', 36.5499992370605, 0.637917828288122, -85.5052795410156, -1.49234865582887, 218, 50, 'PPL', 'P'),
(93138, 'Celina', 33.3244400024414, 0.58162119942591, -96.7841720581055, -1.68920246623064, 218, 51, 'PPL', 'P'),
(134612, 'Celina', 47.8658294677734, 0.835416323410772, -93.0616683959961, -1.62423252090928, 218, 28, 'PPL', 'P'),
(154643, 'Celina', 40.5488891601563, 0.707711623870965, -84.5702819824219, -1.4760298699333, 218, 41, 'PPL', 'P'),
(180628, 'Cella', 36.6916694641113, 0.640390440202206, -119.453887939453, -2.0848636488518, 218, 6, 'PPL', 'P'),
(45568, 'Cellar Hill', 38.4561080932617, 0.671185703730256, -76.6747207641602, -1.33822633038186, 218, 25, 'PPL', 'P'),
(63574, 'Celo', 35.8549995422363, 0.625787795313084, -82.1980590820313, -1.43462676973027, 218, 33, 'PPL', 'P'),
(147681, 'Celoron', 42.1094398498535, 0.73494837155045, -79.283332824707, -1.38375519974563, 218, 40, 'PPL', 'P'),
(93139, 'Celso Colonia', 26.2749996185303, 0.458585254303607, -98.3809967041016, -1.71707231388026, 218, 51, 'PPL', 'P'),
(53947, 'Celt', 37.8758316040039, 0.661057968420793, -92.9013900756836, -1.62143513650026, 218, 29, 'PPL', 'P'),
(75384, 'Cement', 34.9319381713867, 0.609677335193786, -98.1399993896484, -1.71286611725459, 218, 42, 'PPL', 'P'),
(53948, 'Cement City', 39.144718170166, 0.683204216834647, -94.4166717529297, -1.64788179086335, 218, 29, 'PPL', 'P'),
(130136, 'Cement City', 42.0699996948242, 0.734260010987692, -84.3305587768555, -1.47184591070273, 218, 27, 'PPL', 'P'),
(147682, 'Cementon', 42.1349983215332, 0.735394451033039, -73.9250030517578, -1.29023470280003, 218, 40, 'PPL', 'P'),
(159899, 'Cementon', 40.6891708374023, 0.710160001019129, -75.508056640625, -1.31786420016128, 218, 45, 'PPL', 'P'),
(29424, 'Cementville', 38.3497200012207, 0.669328881239225, -85.7461090087891, -1.49655192297734, 218, 19, 'PPL', 'P'),
(143596, 'Cemetery Corners', 42.9630584716797, 0.749846827057653, -70.8408279418945, -1.23640569242486, 218, 36, 'PPL', 'P'),
(19915, 'Cenchat', 34.9127807617188, 0.609342975318926, -85.345832824707, -1.48956578564779, 218, 13, 'PPL', 'P'),
(180629, 'Ceneda', 35.3544387817383, 0.617051361936106, -117.896392822266, -2.05768023097315, 218, 6, 'PPL', 'P'),
(53949, 'Centaur', 38.6444396972656, 0.674472710305686, -90.6988906860352, -1.58299427037773, 218, 29, 'PPL', 'P'),
(1439, 'Centenary', 31.7786102294922, 0.554641380212589, -86.3675003051758, -1.50739724704252, 218, 2, 'PPL', 'P'),
(29425, 'Centenary', 39.6583290100098, 0.692168417063854, -87.4733276367188, -1.52669757493649, 218, 19, 'PPL', 'P'),
(72049, 'Centenary', 38.7991714477539, 0.677173288809081, -82.2677764892578, -1.43584356803233, 218, 41, 'PPL', 'P'),
(80233, 'Centenary', 34.0308303833008, 0.593950037376323, -79.355827331543, -1.38502046757953, 218, 48, 'PPL', 'P'),
(100650, 'Centenary', 37.709171295166, 0.658149197299181, -78.5116729736328, -1.37028719463894, 218, 53, 'PPL', 'P'),
(147683, 'Centenary', 41.1777801513672, 0.718687842303726, -73.9661102294922, -1.2909521583977, 218, 40, 'PPL', 'P'),
(19896, 'Centennial', 33.5858306884766, 0.58618332753127, -83.6125030517578, -1.45931347408698, 218, 13, 'PPL', 'P'),
(93140, 'Centennial', 32.2255592346191, 0.562442111940568, -94.0650024414063, -1.64174400349904, 218, 51, 'PPL', 'P'),
(108523, 'Centennial', 37.5825004577637, 0.655938374120252, -80.3294372558594, -1.40201316638894, 218, 58, 'PPL', 'P'),
(122340, 'Centennial', 40.0113906860352, 0.698330505773106, -87.2433319091797, -1.52268339222542, 218, 19, 'PPL', 'P'),
(130137, 'Centennial', 47.2583312988281, 0.824813480162839, -88.4286117553711, -1.54337042809899, 218, 27, 'PPL', 'P'),
(154644, 'Centennial', 41.7169418334961, 0.728097988857467, -83.7438888549805, -1.46160658894359, 218, 41, 'PPL', 'P'),
(159902, 'Centennial', 40.7775001525879, 0.711701638395149, -78.0430603027344, -1.3621083606152, 218, 45, 'PPL', 'P'),
(177887, 'Centennial', 33.5694389343262, 0.585897237451168, -113.351387023926, -1.97835491526988, 218, 5, 'PPL', 'P'),
(186515, 'Centennial', 39.5791702270508, 0.690786835669348, -104.876388549805, -1.83043828779497, 218, 7, 'PPL', 'P'),
(209362, 'Centennial', 41.2983283996582, 0.720791806143916, -106.14111328125, -1.85251189849009, 218, 59, 'PPL', 'P'),
(159900, 'Centennial Acres', 40.348331451416, 0.704211231513192, -76.8249969482422, -1.34084914458142, 218, 45, 'PPL', 'P'),
(201989, 'Centennial City (historical)', 44.4347190856934, 0.775532150244113, -103.634719848633, -1.80876708074056, 218, 49, 'PPL', 'P'),
(203334, 'Centennial Condominium', 41.2561111450195, 0.720054976049319, -111.955558776855, -1.95399311656616, 218, 52, 'PPL', 'P'),
(130138, 'Centennial Heights', 47.2605590820313, 0.824852362314754, -88.4444427490234, -1.54364673106208, 218, 27, 'PPL', 'P'),
(45569, 'Centennial Homestead', 39.4944381713867, 0.689307982316027, -76.9052810668945, -1.34225036678897, 218, 25, 'PPL', 'P'),
(45570, 'Centennial Lake', 39.2491683959961, 0.685027217179833, -76.8630599975586, -1.34151347011534, 218, 25, 'PPL', 'P'),
(45571, 'Centennial Manor', 39.271671295166, 0.685419966861593, -76.8675003051758, -1.34159096810306, 218, 25, 'PPL', 'P'),
(13513, 'Centennial Village', 39.639720916748, 0.691843644568918, -75.6597213745117, -1.32051124912676, 218, 10, 'PPL', 'P'),
(45572, 'Centennial Village', 38.3708305358887, 0.669697329576038, -75.6727828979492, -1.32073921571607, 218, 25, 'PPL', 'P'),
(203336, 'Centennial Village', 40.6994400024414, 0.710339231760492, -112.064720153809, -1.95589834201001, 218, 52, 'PPL', 'P'),
(203337, 'Centennial Village Two', 40.6908302307129, 0.710188962895984, -112.067222595215, -1.95594201785188, 218, 52, 'PPL', 'P'),
(1440, 'Center', 34.2644386291504, 0.598027270426207, -87.5877838134766, -1.52869521207016, 218, 2, 'PPL', 'P'),
(7990, 'Center', 36.1497192382813, 0.630931624379544, -91.5108337402344, -1.59716535001221, 218, 4, 'PPL', 'P'),
(19899, 'Center', 32.1277809143066, 0.560735558314045, -82.3969421386719, -1.43809793389508, 218, 13, 'PPL', 'P'),
(35194, 'Center', 37.142219543457, 0.64825402253191, -85.6930618286133, -1.49562607502437, 218, 21, 'PPL', 'P'),
(53950, 'Center', 39.5080604553223, 0.689545736022344, -91.5286102294922, -1.5974756082792, 218, 29, 'PPL', 'P'),
(58940, 'Center', 33.5805587768555, 0.586091315315608, -89.3597183227539, -1.55962130338676, 218, 30, 'PPL', 'P'),
(63577, 'Center', 36.1474990844727, 0.630892875385684, -80.7144393920898, -1.40873272129338, 218, 33, 'PPL', 'P'),
(75386, 'Center', 34.7991714477539, 0.607360118729308, -96.8152770996094, -1.68974535161885, 218, 42, 'PPL', 'P'),
(85666, 'Center', 35.353889465332, 0.617041774556182, -87.4516677856445, -1.52631953921976, 218, 50, 'PPL', 'P'),
(122342, 'Center', 40.4449996948242, 0.705898410642784, -85.0769424438477, -1.48487276317485, 218, 19, 'PPL', 'P'),
(141452, 'Center', 42.6094398498535, 0.743675017810422, -97.8763885498047, -1.70826524015537, 218, 35, 'PPL', 'P'),
(154646, 'Center', 41.142219543457, 0.718067192611684, -83.1577835083008, -1.45137712088049, 218, 41, 'PPL', 'P'),
(159901, 'Center', 40.4775009155273, 0.706465663954971, -79.7591705322266, -1.39206013444699, 218, 45, 'PPL', 'P'),
(186516, 'Center', 37.753059387207, 0.658915189007716, -106.108062744141, -1.85193505779798, 218, 7, 'PPL', 'P'),
(191247, 'Center', 32.7280616760254, 0.571212434042417, -100.452499389648, -1.75322685620696, 218, 51, 'PPL', 'P'),
(198100, 'Center', 47.1163902282715, 0.82233614113782, -101.299171447754, -1.76800407130554, 218, 34, 'PPL', 'P'),
(203338, 'Center', 40.2502784729004, 0.702499884196707, -112.400001525879, -1.96175010587324, 218, 52, 'PPL', 'P'),
(58941, 'Center (historical)', 30.5874996185303, 0.533852578295863, -89.5347213745117, -1.56267568284097, 218, 30, 'PPL', 'P'),
(72051, 'Center (historical)', 39.7852783203125, 0.694384100511772, -81.4588928222656, -1.42172588477771, 218, 41, 'PPL', 'P'),
(143597, 'Center Barnstead', 43.339168548584, 0.756411186249563, -71.2600021362305, -1.24372166225541, 218, 36, 'PPL', 'P'),
(127067, 'Center Belmont', 44.3758316040039, 0.774504369800425, -69.1230621337891, -1.20642502329524, 218, 26, 'PPL', 'P'),
(72052, 'Center Bend', 39.5938911437988, 0.691043764135513, -81.6813888549805, -1.42560917312121, 218, 41, 'PPL', 'P'),
(147684, 'Center Berlin', 42.660831451416, 0.744571970465561, -73.3691711425781, -1.2805336058972, 218, 40, 'PPL', 'P'),
(108524, 'Center Branch', 39.2472190856934, 0.684993195296908, -80.3152770996094, -1.40176602503979, 218, 58, 'PPL', 'P'),
(159904, 'Center Bridge', 40.4002799987793, 0.705117904706309, -74.9800033569336, -1.30864793173489, 218, 45, 'PPL', 'P'),
(147685, 'Center Cambridge', 42.9947204589844, 0.750399432983845, -73.4563903808594, -1.28205586877629, 218, 40, 'PPL', 'P'),
(1441, 'Center Chapel', 33.1769409179688, 0.579046854758185, -85.3322219848633, -1.48932823167856, 218, 2, 'PPL', 'P'),
(93143, 'Center City', 31.4702796936035, 0.549259997176894, -98.4086074829102, -1.71755421287951, 218, 51, 'PPL', 'P'),
(134614, 'Center City', 45.3938903808594, 0.792272847435379, -92.8163909912109, -1.61995162261503, 218, 28, 'PPL', 'P'),
(1442, 'Center Community', 34.0380592346191, 0.594076204632965, -86.8108291625977, -1.51513479527364, 218, 2, 'PPL', 'P'),
(143598, 'Center Conway', 43.9947204589844, 0.767852725503788, -71.061393737793, -1.24025529178057, 218, 36, 'PPL', 'P'),
(159903, 'Center Corner', 41.9561080932617, 0.732272227550057, -80.4475021362305, -1.40407378728239, 218, 45, 'PPL', 'P'),
(141453, 'Center Court Mobile Home Park', 40.8458290100098, 0.712894201931286, -96.6666717529297, -1.68715169903322, 218, 35, 'PPL', 'P'),
(203339, 'Center Creek', 40.4780616760254, 0.706475451071977, -111.356391906738, -1.94353568191375, 218, 52, 'PPL', 'P'),
(100638, 'Center Cross', 37.8044395446777, 0.659811941925772, -76.779167175293, -1.34004926414802, 218, 53, 'PPL', 'P'),
(80234, 'Center Crossroads', 33.6933288574219, 0.588059524519231, -79.3172225952148, -1.38434668782374, 218, 48, 'PPL', 'P'),
(1443, 'Center Dale', 34.3211097717285, 0.599016368455062, -86.7230606079102, -1.51360294501463, 218, 2, 'PPL', 'P'),
(143599, 'Center Effingham', 43.7394409179688, 0.763397257000086, -71.0094375610352, -1.2393484854294, 218, 36, 'PPL', 'P'),
(147686, 'Center Falls', 43.0991706848145, 0.752222433329031, -73.4588928222656, -1.28209954461816, 218, 40, 'PPL', 'P'),
(19900, 'Center Green', 33.3855590820313, 0.582687928600541, -84.5652770996094, -1.47594251824954, 218, 13, 'PPL', 'P'),
(177586, 'Center Groton', 41.3836097717285, 0.722280246877162, -72.0283279418945, -1.25713147729229, 218, 8, 'PPL', 'P'),
(1444, 'Center Grove', 34.3838882446289, 0.600112059506548, -86.6386108398438, -1.51212901850932, 218, 2, 'PPL', 'P'),
(7991, 'Center Grove', 34.3180618286133, 0.598963171812288, -92.2922210693359, -1.61080313163839, 218, 4, 'PPL', 'P'),
(19901, 'Center Grove', 34.788890838623, 0.607180688250863, -85.2194366455078, -1.48735975615882, 218, 13, 'PPL', 'P'),
(58942, 'Center Grove', 33.5088882446289, 0.584840428551598, -89.0250015258789, -1.55377939321956, 218, 30, 'PPL', 'P'),
(85668, 'Center Grove', 36.2638893127441, 0.632924268086169, -85.6086120605469, -1.49415214851907, 218, 50, 'PPL', 'P'),
(93145, 'Center Grove', 33.1286087036133, 0.578203298482902, -94.8380584716797, -1.65523637652971, 218, 51, 'PPL', 'P'),
(114911, 'Center Grove', 42.4911117553711, 0.741609802964093, -90.7152786254883, -1.58328029387881, 218, 16, 'PPL', 'P'),
(143600, 'Center Harbor', 43.7097206115723, 0.762878539798766, -71.4608306884766, -1.24722678172412, 218, 36, 'PPL', 'P'),
(143602, 'Center Haverhill', 44.0769386291504, 0.76928770327815, -71.9861068725586, -1.25639458061867, 218, 36, 'PPL', 'P'),
(1449, 'Center Hill', 33.2355613708496, 0.580069974669966, -86.3194427490234, -1.5065584844572, 218, 2, 'PPL', 'P'),
(7993, 'Center Hill', 35.2625007629395, 0.615446740800306, -91.8838882446289, -1.60367637940329, 218, 4, 'PPL', 'P'),
(15475, 'Center Hill', 28.6497192382813, 0.50003193047997, -81.9927825927734, -1.43104401911579, 218, 12, 'PPL', 'P'),
(19903, 'Center Hill', 33.7747192382813, 0.589480054644679, -84.4719390869141, -1.47431346261074, 218, 13, 'PPL', 'P'),
(58943, 'Center Hill', 32.5222206115723, 0.5676198297319, -88.7644424438477, -1.54923177934214, 218, 30, 'PPL', 'P'),
(63579, 'Center Hill', 36.2150001525879, 0.632070991272908, -76.6111068725586, -1.3371160585234, 218, 33, 'PPL', 'P'),
(85670, 'Center Hill', 35.5438919067383, 0.620357942745548, -88.394172668457, -1.54276935264096, 218, 50, 'PPL', 'P'),
(93146, 'Center Hill', 31.3799991607666, 0.547684304628435, -95.246940612793, -1.66237271614474, 218, 51, 'PPL', 'P'),
(100639, 'Center Hill', 37.2552795410156, 0.650227291741605, -79.9780578613281, -1.39588043903071, 218, 53, 'PPL', 'P'),
(119068, 'Center Hill', 42.0808296203613, 0.734449028846061, -90.0461120605469, -1.57160113407632, 218, 18, 'PPL', 'P'),
(159905, 'Center Hill', 40.7975006103516, 0.712050712235031, -79.5788879394531, -1.38891360961906, 218, 45, 'PPL', 'P'),
(85671, 'Center Hill (historical)', 36.1083297729492, 0.63020924193386, -86.2324981689453, -1.50504101526808, 218, 50, 'PPL', 'P'),
(114913, 'Center Junction', 42.1161117553711, 0.735064818269114, -91.0869369506836, -1.58976695534591, 218, 16, 'PPL', 'P'),
(127069, 'Center Lebanon', 43.4147186279297, 0.757729783884288, -70.9177780151367, -1.23774872456258, 218, 26, 'PPL', 'P'),
(93147, 'Center Line', 30.424560546875, 0.531008755015335, -96.5375671386719, -1.68489839843491, 218, 51, 'PPL', 'P'),
(130139, 'Center Line', 42.4850006103516, 0.741503143362435, -83.0277786254883, -1.44910810763174, 218, 27, 'PPL', 'P'),
(147687, 'Center Lisle', 42.3583297729492, 0.739292320183506, -76.0619430541992, -1.32753134176021, 218, 40, 'PPL', 'P'),
(127080, 'Center Lovell', 44.1794395446777, 0.771076681740411, -70.8925018310547, -1.23730757192801, 218, 26, 'PPL', 'P'),
(93148, 'Center Mill', 32.5538902282715, 0.568172568816146, -97.7641677856445, -1.70630661833167, 218, 51, 'PPL', 'P'),
(188272, 'Center Mill', 33.2750015258789, 0.580758335232724, -104.774169921875, -1.82865423618073, 218, 38, 'PPL', 'P'),
(77991, 'Center Mills', 39.9555587768555, 0.697356055130246, -77.2113876342773, -1.34759293425178, 218, 45, 'PPL', 'P'),
(127070, 'Center Minot', 44.1336097717285, 0.770276801307006, -70.3163909912109, -1.22725254091631, 218, 26, 'PPL', 'P'),
(127071, 'Center Montville', 44.4466705322266, 0.775740742336494, -69.2466735839844, -1.20858245009431, 218, 26, 'PPL', 'P'),
(159906, 'Center Moreland', 41.4199981689453, 0.722915344218118, -75.9305572509766, -1.3252382269036, 218, 45, 'PPL', 'P'),
(147688, 'Center Moriches', 40.8002815246582, 0.712099248345898, -72.790283203125, -1.27043010535366, 218, 40, 'PPL', 'P'),
(143603, 'Center Ossipee', 43.7550010681152, 0.763668832852247, -71.1524963378906, -1.2418453321094, 218, 36, 'PPL', 'P'),
(15476, 'Center Park', 30.2900009155273, 0.528660246408049, -81.5013885498047, -1.4224675751413, 218, 12, 'PPL', 'P'),
(63580, 'Center Pigeon', 35.5061111450195, 0.619698544059645, -82.852783203125, -1.44605386133559, 218, 33, 'PPL', 'P'),
(191248, 'Center Plains', 34.3727798461914, 0.59991818137919, -101.885276794434, -1.77823353936864, 218, 51, 'PPL', 'P'),
(655, 'Center Point', 36.917781829834, 0.64433684546354, -94.081672668457, -1.64203495384813, 218, 29, 'PPL', 'P'),
(1452, 'Center Point', 31.9897193908691, 0.558325930159741, -86.0872192382813, -1.50250541959421, 218, 2, 'PPL', 'P'),
(7996, 'Center Point', 34.6272201538086, 0.604359002496897, -94.3688888549805, -1.64704782196799, 218, 4, 'PPL', 'P'),
(29427, 'Center Point', 39.4169387817383, 0.687955362798376, -87.0772171020508, -1.5197841419047, 218, 19, 'PPL', 'P'),
(39709, 'Center Point', 31.2480602264404, 0.54538153581287, -92.209716796875, -1.60936316043699, 218, 22, 'PPL', 'P'),
(58944, 'Center Point', 31.3994407653809, 0.548023624640824, -90.6158294677734, -1.58154457863835, 218, 30, 'PPL', 'P'),
(75387, 'Center Point', 34.9463882446289, 0.609929536549016, -95.3133316040039, -1.66353145753504, 218, 42, 'PPL', 'P'),
(85675, 'Center Point', 35.8861083984375, 0.626330747280323, -85.6152801513672, -1.49426852865871, 218, 50, 'PPL', 'P'),
(93156, 'Center Point', 32.6112518310547, 0.569173717648934, -95.0190505981445, -1.65839528505671, 218, 51, 'PPL', 'P'),
(108526, 'Center Point', 39.3916702270508, 0.687514343321858, -80.6355590820313, -1.40735600016786, 218, 58, 'PPL', 'P'),
(114914, 'Center Point', 42.1908302307129, 0.736368901675899, -91.7850036621094, -1.60195051785886, 218, 16, 'PPL', 'P'),
(58947, 'Center Point (historical)', 34.0113906860352, 0.593610750653446, -89.9736099243164, -1.57033573308437, 218, 30, 'PPL', 'P'),
(85676, 'Center Point (historical)', 35.1111106872559, 0.612804485524784, -89.6575012207031, -1.5648185954121, 218, 50, 'PPL', 'P'),
(1453, 'Center Point Gardens', 33.6380615234375, 0.587094927572404, -86.6827774047852, -1.51289987048685, 218, 2, 'PPL', 'P'),
(85677, 'Center Point Lula', 35.4661102294922, 0.61900039637988, -88.3727798461914, -1.54239597745613, 218, 50, 'PPL', 'P'),
(19904, 'Center Post', 34.6080589294434, 0.604024576043011, -85.3530578613281, -1.48969188632541, 218, 13, 'PPL', 'P'),
(53955, 'Center Post', 37.8438911437988, 0.660500502225612, -91.1263885498047, -1.59045551564575, 218, 29, 'PPL', 'P'),
(1455, 'Center Ridge', 31.1958293914795, 0.544469935771736, -85.9250030517578, -1.49967421303935, 218, 2, 'PPL', 'P'),
(7999, 'Center Ridge', 35.3738899230957, 0.617390848396064, -92.5627822875977, -1.61552531572527, 218, 4, 'PPL', 'P'),
(15477, 'Center Ridge', 30.8024997711182, 0.537605038850812, -86.0947189331055, -1.50263631396179, 218, 12, 'PPL', 'P'),
(58950, 'Center Ridge', 33.0722198486328, 0.577219127302063, -89.0650024414063, -1.55447754089933, 218, 30, 'PPL', 'P'),
(58951, 'Center Ridge (historical)', 32.6699981689453, 0.570199034668614, -88.5924987792969, -1.54623079626779, 218, 30, 'PPL', 'P'),
(63581, 'Center Road', 34.6297187805176, 0.604402611759747, -78.7544403076172, -1.37452428393326, 218, 33, 'PPL', 'P'),
(159907, 'Center Road', 41.7119407653809, 0.72801070375274, -80.4172210693359, -1.40354528296407, 218, 45, 'PPL', 'P'),
(154648, 'Center Road (historical)', 41.5577812194824, 0.725320112103433, -81.1286087036133, -1.41596133944018, 218, 41, 'PPL', 'P'),
(171838, 'Center Rutland', 43.6044387817383, 0.761041025225638, -73.0119400024414, -1.27429874631116, 218, 55, 'PPL', 'P'),
(143604, 'Center Sandwich', 43.8074989318848, 0.764585093425288, -71.4397201538086, -1.24685833338731, 218, 36, 'PPL', 'P'),
(29428, 'Center Square', 38.8363914489746, 0.677822900377978, -85.0313873291016, -1.48407767643141, 218, 19, 'PPL', 'P'),
(159910, 'Center Square', 40.2958297729492, 0.703294904361123, -77.5502777099609, -1.35350768187479, 218, 45, 'PPL', 'P'),
(1456, 'Center Star', 34.8613891601563, 0.608446022663787, -87.4555587768555, -1.52638744982755, 218, 2, 'PPL', 'P'),
(85679, 'Center Star', 35.6983299255371, 0.623053394663845, -87.32861328125, -1.52417183295866, 218, 50, 'PPL', 'P'),
(72053, 'Center Station', 38.6783294677734, 0.675064198383793, -82.6627807617188, -1.44273769314622, 218, 41, 'PPL', 'P'),
(143605, 'Center Strafford', 43.2700004577637, 0.75520397532743, -71.1258316040039, -1.24137994470891, 218, 36, 'PPL', 'P'),
(143606, 'Center Tuftonboro', 43.6541709899902, 0.761909016003922, -71.2477798461914, -1.2435083430521, 218, 36, 'PPL', 'P'),
(159911, 'Center Union', 40.538330078125, 0.707527333123531, -77.9611129760742, -1.36067810995177, 218, 45, 'PPL', 'P'),
(8000, 'Center Valley', 35.3300018310547, 0.61662485668753, -93.0844421386719, -1.62462999770198, 218, 4, 'PPL', 'P'),
(29430, 'Center Valley', 39.5136108398438, 0.689642608506995, -86.4088897705078, -1.50811962948821, 218, 19, 'PPL', 'P'),
(147689, 'Center Valley', 42.7577781677246, 0.746264009864143, -74.6861114501953, -1.30351855031735, 218, 40, 'PPL', 'P'),
(159913, 'Center Valley', 40.5291709899902, 0.707367476879099, -75.3936080932617, -1.31586669618566, 218, 45, 'PPL', 'P'),
(173491, 'Center Valley', 44.4022216796875, 0.774964963510954, -88.459716796875, -1.5439133134872, 218, 57, 'PPL', 'P'),
(127072, 'Center Vassalboro', 44.4099998474121, 0.775100718147521, -69.6305618286133, -1.21528256392279, 218, 26, 'PPL', 'P'),
(85680, 'Center View', 36.3716697692871, 0.634805391922146, -81.7561111450195, -1.42691332310702, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(147690, 'Center Village', 42.1674995422363, 0.735961704345226, -75.6136093139648, -1.31970644184534, 218, 40, 'PPL', 'P'),
(154649, 'Center Village', 40.1652793884277, 0.701016370311478, -82.8077774047852, -1.44526836197207, 218, 41, 'PPL', 'P'),
(1457, 'Center West', 33.4411087036133, 0.583657452395384, -85.6333312988281, -1.49458358061566, 218, 2, 'PPL', 'P'),
(147703, 'Center White Creek', 42.9702796936035, 0.749972861156242, -73.378059387207, -1.2806887350307, 218, 40, 'PPL', 'P'),
(154650, 'Center World', 41.228328704834, 0.719570080993842, -80.9100036621094, -1.41214596170448, 218, 41, 'PPL', 'P'),
(177588, 'Centerbrook', 41.351390838623, 0.721717920412991, -72.416389465332, -1.26390442857658, 218, 8, 'PPL', 'P'),
(154657, 'Centerburg', 40.3044395446777, 0.703445173225631, -82.6963882446289, -1.44332425437631, 218, 41, 'PPL', 'P'),
(1458, 'Centercrest', 33.6572189331055, 0.587429287447264, -86.6730575561523, -1.51273022712541, 218, 2, 'PPL', 'P'),
(114933, 'Centerdale', 41.6419410705566, 0.726788978602666, -91.3069381713867, -1.59360670100559, 218, 16, 'PPL', 'P'),
(169305, 'Centerdale', 41.8563919067383, 0.73053185177769, -71.4791717529297, -1.24754689368715, 218, 47, 'PPL', 'P'),
(147691, 'Centereach', 40.8583297729492, 0.713112381403591, -73.0999984741211, -1.27583565657624, 218, 40, 'PPL', 'P'),
(35195, 'Centerfield', 38.3499984741211, 0.669333741508214, -85.4075012207031, -1.49064210220235, 218, 21, 'PPL', 'P'),
(177378, 'Centerfield', 42.8813896179199, 0.748421436663216, -77.3591690063477, -1.35017220576752, 218, 40, 'PPL', 'P'),
(203341, 'Centerfield', 40.6913909912109, 0.71019875001299, -111.897216796875, -1.95297485692337, 218, 52, 'PPL', 'P'),
(19905, 'Centerpoint', 31.9850006103516, 0.558243571903031, -84.5302810668945, -1.47533172225353, 218, 13, 'PPL', 'P'),
(72058, 'Centerpoint', 38.851390838623, 0.678084689113133, -82.4499969482422, -1.4390239150061, 218, 41, 'PPL', 'P'),
(147693, 'Centerport', 40.8852806091309, 0.713582762231126, -73.3766708374023, -1.28066450026478, 218, 40, 'PPL', 'P'),
(159918, 'Centerport', 40.4861106872559, 0.706615932819479, -76.0077819824219, -1.32658605273128, 218, 45, 'PPL', 'P'),
(39710, 'Centerra', 30.5638904571533, 0.5334405206962, -91.0602798461914, -1.58930170110348, 218, 22, 'PPL', 'P'),
(19906, 'Centerside', 34.5180587768555, 0.602453777053055, -83.7352828979492, -1.46145638665811, 218, 13, 'PPL', 'P'),
(85682, 'Centersville', 35.7144393920898, 0.62333455789593, -84.2074966430664, -1.46969807128358, 218, 50, 'PPL', 'P'),
(8007, 'Centerton', 36.3597183227539, 0.634596799829766, -94.2850036621094, -1.64558374915872, 218, 4, 'PPL', 'P'),
(29450, 'Centerton', 39.5149993896484, 0.689666843272915, -86.3949966430664, -1.50787714867096, 218, 19, 'PPL', 'P'),
(70635, 'Centerton', 39.5252799987793, 0.689846273751359, -75.1680603027344, -1.31193014462036, 218, 37, 'PPL', 'P'),
(154658, 'Centerton', 41.0833282470703, 0.717039345588967, -82.7533264160156, -1.44431801293707, 218, 41, 'PPL', 'P'),
(35196, 'Centertown', 37.4172210693359, 0.653053704606506, -86.9961090087891, -1.51836853862727, 218, 21, 'PPL', 'P'),
(53963, 'Centertown', 38.6186103820801, 0.674021903712163, -92.4122161865234, -1.61289744151963, 218, 29, 'PPL', 'P'),
(85683, 'Centertown', 35.7249984741211, 0.623518848643363, -85.9205627441406, -1.49959671505163, 218, 50, 'PPL', 'P'),
(159920, 'Centertown', 41.2286109924316, 0.719575007841859, -80.0447235107422, -1.39704397411097, 218, 45, 'PPL', 'P'),
(171839, 'Centertown', 43.660831451416, 0.762025262985504, -72.3816680908203, -1.26329842627053, 218, 55, 'PPL', 'P'),
(32024, 'Centerview', 37.8152809143066, 0.660001159521223, -99.2680587768555, -1.73255446771938, 218, 20, 'PPL', 'P'),
(35197, 'Centerview', 37.6308288574219, 0.656781863816507, -86.3086090087891, -1.50636940001981, 218, 21, 'PPL', 'P'),
(53964, 'Centerview', 38.7441711425781, 0.676213352394162, -93.8450012207031, -1.63790425783937, 218, 29, 'PPL', 'P'),
(63584, 'Centerview', 35.4905586242676, 0.619427101365538, -80.6186065673828, -1.40706012297075, 218, 33, 'PPL', 'P'),
(75392, 'Centerview', 35.4336090087891, 0.618433143067693, -96.6650009155273, -1.68712253741929, 218, 42, 'PPL', 'P'),
(85684, 'Centerview', 35.2852783203125, 0.615844284172028, -88.1736068725586, -1.53891975328525, 218, 50, 'PPL', 'P'),
(93157, 'Centerview', 31.2524394989014, 0.545457968536156, -95.8075637817383, -1.6721574363058, 218, 51, 'PPL', 'P'),
(72059, 'Centerview (historical)', 39.5444412231445, 0.690180700205246, -81.0347213745117, -1.41432269642145, 218, 41, 'PPL', 'P'),
(1460, 'Centerville', 34.2761116027832, 0.598231002249598, -86.929443359375, -1.51720500354701, 218, 2, 'PPL', 'P'),
(8011, 'Centerville', 35.1127815246582, 0.61283364713872, -93.1686096191406, -1.62609899735926, 218, 4, 'PPL', 'P'),
(13514, 'Centerville', 39.8213882446289, 0.69501433758374, -75.616943359375, -1.31976463191516, 218, 10, 'PPL', 'P'),
(15478, 'Centerville', 30.5569400787354, 0.533319213708547, -84.1763916015625, -1.46915518589537, 218, 12, 'PPL', 'P'),
(19912, 'Centerville', 33.8011093139648, 0.589940648355208, -82.9227828979492, -1.44727558648566, 218, 13, 'PPL', 'P'),
(29446, 'Centerville', 39.8177795410156, 0.694951353823959, -84.9963912963867, -1.4834668804354, 218, 19, 'PPL', 'P'),
(32025, 'Centerville', 38.2208290100098, 0.667079309066435, -95.0138931274414, -1.65830527021186, 218, 20, 'PPL', 'P'),
(35199, 'Centerville', 37.978889465332, 0.662856667421033, -84.3630599975586, -1.47241316401492, 218, 21, 'PPL', 'P'),
(39712, 'Centerville', 29.7594394683838, 0.519400202271248, -91.4283294677734, -1.5957253788108, 218, 22, 'PPL', 'P'),
(45574, 'Centerville', 39.5244407653809, 0.689831626365364, -77.2719421386719, -1.34864980973037, 218, 25, 'PPL', 'P'),
(53966, 'Centerville', 37.435001373291, 0.653364029452527, -90.9583282470703, -1.58752231002114, 218, 29, 'PPL', 'P'),
(58953, 'Centerville', 34.3641700744629, 0.599767912514682, -88.5091705322266, -1.5447764439965, 218, 30, 'PPL', 'P'),
(63585, 'Centerville', 36.1861114501953, 0.631566788299528, -78.105827331543, -1.3632038519296, 218, 33, 'PPL', 'P'),
(75394, 'Centerville', 34.8666687011719, 0.608538168037504, -95.5175018310547, -1.66709490023162, 218, 42, 'PPL', 'P'),
(80238, 'Centerville', 32.9955596923828, 0.575881155170408, -80.1705627441406, -1.39924028306195, 218, 48, 'PPL', 'P'),
(85686, 'Centerville', 36.2894401550293, 0.633370214410703, -86.206672668457, -1.50459027525358, 218, 50, 'PPL', 'P'),
(93160, 'Centerville', 31.1802806854248, 0.544198559656657, -95.0427780151367, -1.65880940660622, 218, 51, 'PPL', 'P'),
(100649, 'Centerville', 37.1697196960449, 0.64873399073937, -80.5386123657227, -1.40566396076928, 218, 53, 'PPL', 'P'),
(108528, 'Centerville', 38.2613906860352, 0.667787243863205, -82.5297164916992, -1.44041528351761, 218, 58, 'PPL', 'P'),
(114935, 'Centerville', 42.0927810668945, 0.734657620938441, -93.9352798461914, -1.63947991709831, 218, 16, 'PPL', 'P'),
(119070, 'Centerville', 40.1233291625977, 0.700284200748788, -88.4961090087891, -1.54454847740718, 218, 18, 'PPL', 'P'),
(124469, 'Centerville', 42.0730590820313, 0.734313407367548, -71.6130599975586, -1.24988368438564, 218, 23, 'PPL', 'P'),
(127073, 'Centerville', 44.7055587768555, 0.780259194599977, -67.679443359375, -1.18122912253811, 218, 26, 'PPL', 'P'),
(134618, 'Centerville', 43.9430618286133, 0.766951112316742, -91.6355590820313, -1.59934221788724, 218, 28, 'PPL', 'P'),
(141463, 'Centerville', 40.6538887023926, 0.709544211596076, -96.7427825927734, -1.68848008378495, 218, 35, 'PPL', 'P'),
(144965, 'Centerville', 40.4147186279297, 0.705369906324458, -74.1580581665039, -1.29430228189096, 218, 37, 'PPL', 'P'),
(147698, 'Centerville', 42.084171295166, 0.734507352073933, -74.0136108398438, -1.29178120044504, 218, 40, 'PPL', 'P'),
(154660, 'Centerville', 40.6683311462402, 0.709796279793252, -82.0411071777344, -1.43188744223302, 218, 41, 'PPL', 'P'),
(159927, 'Centerville', 40.2458305358887, 0.702422253050931, -79.6352767944336, -1.3898977807999, 218, 45, 'PPL', 'P'),
(169307, 'Centerville', 41.5222206115723, 0.72469946241139, -71.746940612793, -1.25222034192608, 218, 47, 'PPL', 'P'),
(169993, 'Centerville', 43.1194381713867, 0.752576167700821, -96.9611129760742, -1.69229066783069, 218, 49, 'PPL', 'P'),
(171841, 'Centerville', 43.6763916015625, 0.762296838837665, -72.3869400024414, -1.26339043848619, 218, 55, 'PPL', 'P'),
(173496, 'Centerville', 44.0699996948242, 0.769166596027579, -91.4511108398438, -1.59612298876155, 218, 57, 'PPL', 'P'),
(177587, 'Centerville', 41.3838882446289, 0.722285107146151, -72.9075012207031, -1.27247594570305, 218, 8, 'PPL', 'P'),
(177888, 'Centerville', 34.7597198486328, 0.606671558429468, -112.05583190918, -1.95574321287651, 218, 5, 'PPL', 'P'),
(186517, 'Centerville', 38.7088890075684, 0.675597562971108, -106.091110229492, -1.85163918060088, 218, 7, 'PPL', 'P'),
(188273, 'Centerville', 35.7975006103516, 0.624784249635314, -103.08943939209, -1.79925014142711, 218, 38, 'PPL', 'P'),
(190022, 'Centerville', 38.9105606079102, 0.679117396404839, -119.778327941895, -2.09052619511958, 218, 39, 'PPL', 'P'),
(193441, 'Centerville', 40.5183296203613, 0.707178259283649, -122.484169006348, -2.13775203072996, 218, 6, 'PPL', 'P'),
(194711, 'Centerville', 43.9127807617188, 0.766422607998416, -115.891387939453, -2.0226862942495, 218, 17, 'PPL', 'P'),
(196184, 'Centerville', 46.0227813720703, 0.80324906586814, -112.548606872559, -1.96434375845887, 218, 31, 'PPL', 'P'),
(203342, 'Centerville', 40.9180603027344, 0.714154875812303, -111.871391296387, -1.95252411690888, 218, 52, 'PPL', 'P'),
(207001, 'Centerville', 45.7533302307129, 0.798546256278197, -120.903610229492, -2.11016607605254, 218, 56, 'PPL', 'P'),
(19914, 'Centerville (historical)', 34.3477783203125, 0.599481822434581, -84.3105621337891, -1.47149690344188, 218, 13, 'PPL', 'P'),
(119071, 'Centerville (historical)', 41.2563896179199, 0.720059836318308, -88.2938919067383, -1.54101912317256, 218, 18, 'PPL', 'P'),
(154661, 'Centerville (historical)', 41.0999984741211, 0.717330295938059, -82.1425018310547, -1.43365711277738, 218, 41, 'PPL', 'P'),
(159928, 'Centerville (historical)', 40.3894386291504, 0.704928687110859, -79.0736083984375, -1.38009481798537, 218, 45, 'PPL', 'P'),
(190023, 'Centerville (historical)', 39.7433280944824, 0.693651930949082, -114.608062744141, -2.0002880442175, 218, 39, 'PPL', 'P'),
(193442, 'Centerville (historical)', 40.5750007629395, 0.708167357312505, -124.346939086914, -2.17026350184348, 218, 6, 'PPL', 'P'),
(196187, 'Centerville (historical)', 45.4458312988281, 0.793179387470442, -112.420829772949, -1.96211362736203, 218, 31, 'PPL', 'P'),
(200547, 'Centerville (historical)', 45.5513916015625, 0.795021762312559, -123.063056945801, -2.1478555312735, 218, 43, 'PPL', 'P'),
(188274, 'Centerville Corner', 35.7966690063477, 0.624769735407374, -103.126388549805, -1.79989502588507, 218, 38, 'PPL', 'P'),
(180634, 'Centerville District', 37.5541687011719, 0.655443891684852, -121.998062133789, -2.12926786528724, 218, 6, 'PPL', 'P'),
(26742, 'Centerville Station', 38.5572204589844, 0.672950447426597, -90.1091690063477, -1.57270168539679, 218, 18, 'PPL', 'P'),
(80239, 'Centerville Terrace Estates', 34.5250015258789, 0.602574950882653, -82.7249984741211, -1.4438235970807, 218, 48, 'PPL', 'P'),
(1461, 'Centerwood Estates', 33.644718170166, 0.587211107974959, -86.6691665649414, -1.51266231651761, 218, 2, 'PPL', 'P'),
(93161, 'Centex', 29.9019393920898, 0.521887295123759, -97.914436340332, -1.70892929937318, 218, 51, 'PPL', 'P'),
(75395, 'Centrahoma', 34.6097183227539, 0.604053537919865, -96.3452835083008, -1.68154241598724, 218, 42, 'PPL', 'P'),
(1464, 'Central', 34.6661109924316, 0.605037775679731, -85.7905578613281, -1.49732770180288, 218, 2, 'PPL', 'P'),
(8015, 'Central', 34.2961082458496, 0.598580009510453, -92.852783203125, -1.62058678653502, 218, 4, 'PPL', 'P'),
(29448, 'Central', 38.773609161377, 0.676727142747465, -85.3333282470703, -1.48934753959646, 218, 19, 'PPL', 'P'),
(32028, 'Central', 38.2722206115723, 0.667976261721574, -95.3833312988281, -1.66475318268511, 218, 20, 'PPL', 'P'),
(39715, 'Central', 29.6413898468018, 0.517339847693908, -90.813606262207, -1.58499643488525, 218, 22, 'PPL', 'P'),
(53967, 'Central', 37.4650001525879, 0.653887606922837, -90.3466720581055, -1.5768468956335, 218, 29, 'PPL', 'P'),
(58954, 'Central', 30.8811092376709, 0.538977032865393, -88.654167175293, -1.54730711282234, 218, 30, 'PPL', 'P'),
(63586, 'Central', 35.936939239502, 0.627217912818456, -80.966667175293, -1.41313492657528, 218, 33, 'PPL', 'P'),
(80240, 'Central', 34.7241706848145, 0.606051108474506, -82.7813873291016, -1.44480776826154, 218, 48, 'PPL', 'P'),
(85688, 'Central', 35.8036117553711, 0.624890909236972, -89.5372161865234, -1.5627192255248, 218, 50, 'PPL', 'P'),
(93167, 'Central', 31.4272193908691, 0.548508453117273, -94.8083267211914, -1.65471745959131, 218, 51, 'PPL', 'P'),
(108529, 'Central', 39.3455581665039, 0.686709536040437, -81.523063659668, -1.42284587717414, 218, 58, 'PPL', 'P'),
(119072, 'Central', 41.4738883972168, 0.723855906136107, -88.4338912963867, -1.5434625734727, 218, 18, 'PPL', 'P'),
(130143, 'Central', 47.4072189331055, 0.827412059596484, -88.2005615234375, -1.53939020069181, 218, 27, 'PPL', 'P'),
(134620, 'Central', 48.6994400024414, 0.849965571920038, -94.3427810668945, -1.64659215510548, 218, 28, 'PPL', 'P'),
(159932, 'Central', 40.1775016784668, 0.701229689514794, -79.5852813720703, -1.38902519606874, 218, 45, 'PPL', 'P'),
(177889, 'Central', 32.8675003051758, 0.573646097225558, -109.792221069336, -1.9162357507374, 218, 5, 'PPL', 'P'),
(180635, 'Central', 38.3927803039551, 0.670080425298845, -121.571937561035, -2.12183058846903, 218, 6, 'PPL', 'P'),
(188275, 'Central', 32.7763900756836, 0.572055923738672, -108.15389251709, -1.88764152327128, 218, 38, 'PPL', 'P'),
(192512, 'Central', 37.4166717529297, 0.653044117226581, -113.623611450195, -1.98310612781264, 218, 52, 'PPL', 'P'),
(194712, 'Central', 42.6349983215332, 0.74412109729301, -111.810829162598, -1.95146710827222, 218, 17, 'PPL', 'P'),
(211722, 'Central', 65.5725021362305, 1.14445606104824, -144.80305480957, -2.52729007337281, 218, 1, 'PPL', 'P'),
(199869, 'Central (historical)', 40.7822189331055, 0.71178399665186, -118.132499694824, -2.06180107328588, 218, 39, 'PPL', 'P'),
(200548, 'Central (historical)', 44.6305618286133, 0.778950250924203, -122.973609924316, -2.1462943862425, 218, 43, 'PPL', 'P'),
(58955, 'Central Academy', 34.3047218322754, 0.598730344953988, -89.8169403076172, -1.56760133243513, 218, 30, 'PPL', 'P'),
(63587, 'Central Area', 36.5069389343262, 0.637166284228502, -79.745002746582, -1.39181285993978, 218, 33, 'PPL', 'P'),
(154662, 'Central Avenue Park', 41.6788902282715, 0.727433863060628, -83.6822204589844, -1.46053027238904, 218, 41, 'PPL', 'P'),
(196188, 'Central Avenue Trailer Court', 47.6083297729492, 0.830922105913208, -114.676391601563, -2.00148060775364, 218, 31, 'PPL', 'P'),
(29449, 'Central Barren', 38.3641700744629, 0.669581082594456, -86.0963897705078, -1.50266547557573, 218, 19, 'PPL', 'P'),
(147700, 'Central Bridge', 42.711109161377, 0.745449482044742, -74.3391723632813, -1.29746332094683, 218, 40, 'PPL', 'P'),
(180636, 'Central Camp', 37.3494415283203, 0.651870728450292, -119.482780456543, -2.08536791840421, 218, 6, 'PPL', 'P'),
(1465, 'Central City', 31.2430591583252, 0.545294250708143, -85.8850021362305, -1.49897606535959, 218, 2, 'PPL', 'P'),
(8016, 'Central City', 35.3191719055176, 0.616435838829161, -94.2519378662109, -1.6450066421505, 218, 4, 'PPL', 'P'),
(15479, 'Central City', 30.188060760498, 0.526881055062794, -84.9258270263672, -1.48223530158929, 218, 12, 'PPL', 'P'),
(35200, 'Central City', 37.2938919067383, 0.650901204655449, -87.1233291625977, -1.52058894918612, 218, 21, 'PPL', 'P'),
(53968, 'Central City', 37.0855598449707, 0.647265124240137, -94.5833282470703, -1.65079049540593, 218, 29, 'PPL', 'P'),
(114937, 'Central City', 42.2038917541504, 0.73659686826521, -91.5238876342773, -1.59739318344346, 218, 16, 'PPL', 'P'),
(119073, 'Central City', 41.2377815246582, 0.719735063823373, -88.2816696166992, -1.54080580396924, 218, 18, 'PPL', 'P'),
(141467, 'Central City', 41.1158294677734, 0.717606598901154, -98.0013885498047, -1.71044690172036, 218, 35, 'PPL', 'P'),
(159934, 'Central City', 40.1105613708496, 0.700061360744576, -78.8022232055664, -1.37535825282861, 218, 45, 'PPL', 'P'),
(186519, 'Central City', 39.8019409179688, 0.694674917702809, -105.513610839844, -1.84155991482325, 218, 7, 'PPL', 'P'),
(201992, 'Central City', 44.3658294677734, 0.77432979959097, -103.771942138672, -1.81116206150887, 218, 49, 'PPL', 'P'),
(154663, 'Central City (historical)', 40.0341682434082, 0.698728049144828, -82.4702835083008, -1.43937798227303, 218, 41, 'PPL', 'P'),
(196189, 'Central City (historical)', 45.3013916015625, 0.790658439182573, -111.955558776855, -1.95399311656616, 218, 31, 'PPL', 'P'),
(154664, 'Central College', 40.1019401550293, 0.699910892142987, -82.8883285522461, -1.44667424471152, 218, 41, 'PPL', 'P'),
(194713, 'Central Cove', 43.6072196960449, 0.761089561336505, -116.861671447754, -2.03962093614715, 218, 17, 'PPL', 'P'),
(80241, 'Central Crossroads', 33.8877792358398, 0.591453323854373, -79.9130630493164, -1.39474606556439, 218, 48, 'PPL', 'P'),
(39716, 'Central Estates', 30.562780380249, 0.53342114619927, -91.0261077880859, -1.58870528617735, 218, 22, 'PPL', 'P'),
(93162, 'Central Estates Colonia', 25.9559993743896, 0.453017649728688, -97.443000793457, -1.70070119686927, 218, 51, 'PPL', 'P'),
(63588, 'Central Falls', 35.7619400024414, 0.624163599943272, -79.7763900756836, -1.39236067217601, 218, 33, 'PPL', 'P'),
(169308, 'Central Falls', 41.8905601501465, 0.731128200124786, -71.3927764892578, -1.24603901187795, 218, 47, 'PPL', 'P'),
(207002, 'Central Ferry', 46.6266708374023, 0.813788925356293, -117.817497253418, -2.05630324353152, 218, 56, 'PPL', 'P'),
(93163, 'Central Gardens', 29.9952793121338, 0.523516384052075, -94.0138931274414, -1.64085197769192, 218, 51, 'PPL', 'P'),
(100651, 'Central Gardens', 37.5569381713867, 0.655492228058637, -77.4049987792969, -1.35097208620092, 218, 53, 'PPL', 'P'),
(58956, 'Central Grove', 34.0088882446289, 0.593567074811569, -88.6055603027344, -1.5464587628571, 218, 30, 'PPL', 'P'),
(19916, 'Central Grove (historical)', 34.3358306884766, 0.599273296921227, -85.2069396972656, -1.48714164326555, 218, 13, 'PPL', 'P'),
(1466, 'Central Heights', 34.8944396972656, 0.609022863355899, -87.7908325195313, -1.53223908053273, 218, 2, 'PPL', 'P'),
(63589, 'Central Heights', 35.3875007629395, 0.617628402365299, -77.9019393920898, -1.35964533608104, 218, 33, 'PPL', 'P'),
(93164, 'Central Heights', 31.7049999237061, 0.553356638013222, -94.6766662597656, -1.65241955104474, 218, 51, 'PPL', 'P'),
(114938, 'Central Heights', 43.1349983215332, 0.752847743552982, -93.2416687011719, -1.62737411888919, 218, 16, 'PPL', 'P'),
(177890, 'Central Heights', 33.4124984741211, 0.583158109690994, -110.814170837402, -1.93407213898015, 218, 5, 'PPL', 'P'),
(75396, 'Central High', 34.6230583190918, 0.604286364778165, -98.0894393920898, -1.71198367882739, 218, 42, 'PPL', 'P'),
(93165, 'Central High', 31.706470489502, 0.553382304228227, -95.0535278320313, -1.65899702630501, 218, 51, 'PPL', 'P'),
(1467, 'Central Highlands', 33.5541687011719, 0.585630721605079, -86.7161102294922, -1.51348163802697, 218, 2, 'PPL', 'P'),
(159936, 'Central Highlands', 40.2738914489746, 0.702912008375397, -79.8308334350586, -1.39331088805295, 218, 45, 'PPL', 'P'),
(100652, 'Central Hill', 36.9105606079102, 0.644210811364952, -76.7408294677734, -1.33938014492413, 218, 53, 'PPL', 'P'),
(147701, 'Central Islip', 40.7905616760254, 0.71192960498446, -73.2022171020508, -1.27761970819049, 218, 40, 'PPL', 'P'),
(19917, 'Central Junction', 32.0900001525879, 0.560076159628141, -81.164436340332, -1.41658664966413, 218, 13, 'PPL', 'P'),
(130144, 'Central Lake', 45.0699996948242, 0.786619888547522, -85.2644424438477, -1.48814525552234, 218, 27, 'PPL', 'P'),
(134621, 'Central Lakes', 47.225830078125, 0.824246226850652, -92.4763870239258, -1.61401743391607, 218, 28, 'PPL', 'P'),
(127077, 'Central Landing', 43.7361106872559, 0.763339133509295, -70.1080627441406, -1.22361652708002, 218, 26, 'PPL', 'P'),
(77995, 'Central Manor', 39.9991683959961, 0.698117186569791, -76.4263916015625, -1.33389216886581, 218, 45, 'PPL', 'P'),
(1468, 'Central Mills', 32.2861099243164, 0.563498920840139, -87.4408264160156, -1.52613032162431, 218, 2, 'PPL', 'P'),
(13054, 'Central Northeast', 38.8958282470703, 0.678860268201591, -76.9416732788086, -1.34288553070895, 218, 9, 'PPL', 'P'),
(147702, 'Central Nyack', 41.0938911437988, 0.717223702915428, -73.9505615234375, -1.29068078228262, 218, 40, 'PPL', 'P'),
(159937, 'Central Oak Heights', 41.0113906860352, 0.71578379829305, -76.8705596923828, -1.34164436448292, 218, 45, 'PPL', 'P'),
(80242, 'Central Pacolet', 34.913330078125, 0.60935256269885, -81.7486114501953, -1.42678242873944, 218, 48, 'PPL', 'P'),
(19918, 'Central Park', 31.1677799224854, 0.543980380184352, -81.3872222900391, -1.4204749980137, 218, 13, 'PPL', 'P'),
(70636, 'Central Park', 39.6597213745117, 0.692192718408801, -75.5149993896484, -1.31798537399087, 218, 37, 'PPL', 'P'),
(100657, 'Central Park', 37.3863906860352, 0.652515612908255, -77.4311065673828, -1.35142775306343, 218, 53, 'PPL', 'P'),
(143607, 'Central Park', 43.2333297729492, 0.754563951138456, -70.8824996948242, -1.23713300171856, 218, 36, 'PPL', 'P'),
(207003, 'Central Park', 46.9736099243164, 0.819844154726806, -123.691108703613, -2.15881710232027, 218, 56, 'PPL', 'P'),
(1469, 'Central Park Highlands', 33.4900016784668, 0.584510795787673, -86.8819427490234, -1.51637596149967, 218, 2, 'PPL', 'P'),
(177891, 'Central Park Village', 33.6386108398438, 0.587104514952328, -112.075561523438, -1.95608755960546, 218, 5, 'PPL', 'P'),
(39718, 'Central Place', 30.5358295440674, 0.532950765371735, -91.0236129760742, -1.58866174349353, 218, 22, 'PPL', 'P'),
(100658, 'Central Point', 37.9888916015625, 0.663031237630487, -77.1324996948242, -1.3462160799682, 218, 53, 'PPL', 'P'),
(200550, 'Central Point', 42.3761100769043, 0.739602645029527, -122.915283203125, -2.14527639291581, 218, 43, 'PPL', 'P'),
(177892, 'Central Ridge', 33.3194389343262, 0.581533914321182, -111.885833740234, -1.95277618510605, 218, 5, 'PPL', 'P'),
(199870, 'Central Rochester (historical)', 40.2897186279297, 0.703188244759465, -118.177223205566, -2.06258164580138, 218, 39, 'PPL', 'P'),
(19919, 'Central Springs', 32.3619384765625, 0.564822378743853, -84.8194427490234, -1.48037854567729, 218, 13, 'PPL', 'P'),
(77996, 'Central Square', 39.9966697692871, 0.698073577306941, -75.4066696166992, -1.31609466277497, 218, 45, 'PPL', 'P'),
(124470, 'Central Square', 42.4911117553711, 0.741609802964093, -71.1511077880859, -1.24182109734348, 218, 23, 'PPL', 'P'),
(147704, 'Central Square', 43.2866706848145, 0.755494925676521, -76.1463928222656, -1.32900526826551, 218, 40, 'PPL', 'P'),
(108533, 'Central Station', 39.2938919067383, 0.685807789695336, -80.8258285522461, -1.41067682888914, 218, 58, 'PPL', 'P'),
(147705, 'Central Valley', 41.3316688537598, 0.721373706842099, -74.1213912963867, -1.29366232428102, 218, 40, 'PPL', 'P'),
(192513, 'Central Valley', 38.7038917541504, 0.675510344445408, -112.09806060791, -1.95648024270819, 218, 52, 'PPL', 'P'),
(207004, 'Central Valley', 47.663330078125, 0.831882042328127, -122.648612976074, -2.14062211943674, 218, 56, 'PPL', 'P'),
(193443, 'Central Valley (historical)', 40.6805610656738, 0.710009732154621, -122.370002746582, -2.13575945360236, 218, 6, 'PPL', 'P'),
(45575, 'Central Village', 38.5541687011719, 0.672897184204795, -76.5769424438477, -1.33651977675533, 218, 25, 'PPL', 'P'),
(124471, 'Central Village', 41.5736083984375, 0.725596348487501, -71.091667175293, -1.24078366294084, 218, 23, 'PPL', 'P'),
(177589, 'Central Village', 41.7227783203125, 0.728199854769162, -71.9072189331055, -1.25501772633509, 218, 8, 'PPL', 'P'),
(80243, 'Central-Shiloh', 34.2599983215332, 0.597949772438485, -82.3438873291016, -1.43717195278406, 218, 48, 'PPL', 'P'),
(19920, 'Centralhatchee', 33.3688888549805, 0.58239697825145, -85.1036071777344, -1.48533815057534, 218, 13, 'PPL', 'P'),
(26746, 'Centralia', 38.5250015258789, 0.672388120962426, -89.1333312988281, -1.55567010443546, 218, 18, 'PPL', 'P'),
(32029, 'Centralia', 39.725830078125, 0.693346532951077, -96.1269378662109, -1.67773156562539, 218, 20, 'PPL', 'P'),
(53974, 'Centralia', 39.2102813720703, 0.684348510576027, -92.1377792358398, -1.60810761314107, 218, 29, 'PPL', 'P'),
(75397, 'Centralia', 36.7966690063477, 0.642223027927317, -95.3530578613281, -1.66422481152484, 218, 42, 'PPL', 'P'),
(93166, 'Centralia', 31.2577800750732, 0.545551179174308, -95.0397186279297, -1.65875601022636, 218, 51, 'PPL', 'P'),
(100659, 'Centralia', 37.3808288574219, 0.652418540686522, -77.4602813720703, -1.35193694946386, 218, 53, 'PPL', 'P'),
(108534, 'Centralia', 38.6230583190918, 0.674099534857939, -80.5680618286133, -1.40617795085967, 218, 58, 'PPL', 'P'),
(114939, 'Centralia', 42.4722213745117, 0.741280103621141, -90.8369369506836, -1.58540363221593, 218, 16, 'PPL', 'P'),
(147706, 'Centralia', 42.2586097717285, 0.737551877832112, -79.3480606079102, -1.38488491268005, 218, 40, 'PPL', 'P'),
(159952, 'Centralia', 40.8041687011719, 0.712167092374667, -76.3408279418945, -1.33239880128455, 218, 45, 'PPL', 'P'),
(180637, 'Centralia', 38.3202781677246, 0.668815024306894, -121.243606567383, -2.11610013159345, 218, 6, 'PPL', 'P'),
(207005, 'Centralia', 46.7163887023926, 0.815354797498232, -122.953056335449, -2.14593565844366, 218, 56, 'PPL', 'P'),
(100660, 'Centralia Gardens', 37.3824996948242, 0.652447702300458, -77.4722213745117, -1.35214534181916, 218, 53, 'PPL', 'P'),
(124472, 'Centralville', 42.6555595397949, 0.744479958249899, -71.3055572509766, -1.24451674899886, 218, 23, 'PPL', 'P'),
(85689, 'Centralville (historical)', 36.1686096191406, 0.631261323722496, -86.5455627441406, -1.51050502287659, 218, 50, 'PPL', 'P'),
(1470, 'Centre', 34.1519393920898, 0.596063788333518, -85.6788864135742, -1.49537866735911, 218, 2, 'PPL', 'P'),
(159940, 'Centre', 40.3561096191406, 0.704346986149759, -77.4075012207031, -1.3510157620428, 218, 45, 'PPL', 'P'),
(58958, 'Centre (historical)', 30.7177791595459, 0.536126385234572, -89.5550003051758, -1.56302961694984, 218, 30, 'PPL', 'P'),
(70637, 'Centre City', 39.7758293151855, 0.694219184261269, -75.1811065673828, -1.31215784489356, 218, 37, 'PPL', 'P'),
(70638, 'Centre Grove', 39.3563919067383, 0.686898620477832, -75.1222229003906, -1.3111301310289, 218, 37, 'PPL', 'P'),
(159942, 'Centre Hall', 40.8474998474121, 0.712923363545223, -77.686393737793, -1.35588335472519, 218, 45, 'PPL', 'P'),
(100661, 'Centre Heights', 38.8408317565918, 0.6779003983657, -77.4552764892578, -1.3518495977801, 218, 53, 'PPL', 'P'),
(159944, 'Centre Hill', 40.8186111450195, 0.712419160571843, -77.6469421386719, -1.35519479442535, 218, 45, 'PPL', 'P'),
(147707, 'Centre Island', 40.901668548584, 0.713868785732201, -73.5202789306641, -1.2831709343247, 218, 40, 'PPL', 'P'),
(124473, 'Centre Mills', 41.9749984741211, 0.732601926893009, -71.1852798461914, -1.2424175122696, 218, 23, 'PPL', 'P'),
(1471, 'Centre Ridge (historical)', 31.6361103057861, 0.552154287360078, -85.9722213745117, -1.50049832823867, 218, 2, 'PPL', 'P'),
(124474, 'Centre Village (historical)', 42.5394401550293, 0.742453292660348, -71.4833297729492, -1.24761946482685, 218, 23, 'PPL', 'P'),
(1472, 'Centreville', 32.9444389343262, 0.574988929626204, -87.1386108398438, -1.52085566476929, 218, 2, 'PPL', 'P'),
(26748, 'Centreville', 38.5833282470703, 0.673406114289109, -90.125, -1.57297798835989, 218, 18, 'PPL', 'P'),
(45576, 'Centreville', 39.0416717529297, 0.681405717571489, -76.0666732788086, -1.327613899754, 218, 25, 'PPL', 'P'),
(58959, 'Centreville', 31.0894393920898, 0.542613079991192, -91.0683288574219, -1.58944218285098, 218, 30, 'PPL', 'P'),
(100663, 'Centreville', 38.0475006103516, 0.664054157805187, -77.8172225952148, -1.35816674904383, 218, 53, 'PPL', 'P'),
(130146, 'Centreville', 41.9233283996582, 0.731700113968881, -85.5283279418945, -1.49275092631153, 218, 27, 'PPL', 'P'),
(159947, 'Centreville', 40.5191688537598, 0.707192906669645, -75.5458297729492, -1.31852346568912, 218, 45, 'PPL', 'P'),
(100665, 'Centreville Farms', 38.8436088562012, 0.677948867897539, -77.415283203125, -1.35115158325839, 218, 53, 'PPL', 'P'),
(45577, 'Centreville Landing', 39.0547218322754, 0.681633484423718, -76.0738906860352, -1.32773986727356, 218, 25, 'PPL', 'P'),
(186518, 'Centro', 37.2838897705078, 0.650726634445994, -106.146942138672, -1.85261363124374, 218, 7, 'PPL', 'P'),
(32030, 'Centropolis', 38.7161102294922, 0.675723597069696, -95.3499984741211, -1.66417141514498, 218, 20, 'PPL', 'P'),
(53976, 'Centropolis', 39.0897216796875, 0.682244346998755, -94.4941711425781, -1.649234410381, 218, 29, 'PPL', 'P'),
(177893, 'Centura West', 33.4605598449707, 0.583996938855342, -112.1875, -1.95804125458114, 218, 5, 'PPL', 'P'),
(173498, 'Centuria', 45.4513893127441, 0.793276393113148, -92.5538864135742, -1.61537005343372, 218, 57, 'PPL', 'P'),
(63592, 'Centurion Park', 35.3836097717285, 0.617560491757502, -80.1861114501953, -1.39951165917703, 218, 33, 'PPL', 'P'),
(15480, 'Century', 30.9730606079102, 0.540581887027789, -87.2638931274414, -1.5230422531823, 218, 12, 'PPL', 'P'),
(19922, 'Century', 31.6772193908691, 0.552871776247259, -84.1627807617188, -1.46891763192613, 218, 13, 'PPL', 'P'),
(108535, 'Century', 39.0997200012207, 0.682418850629183, -80.1888885498047, -1.39956012870887, 218, 58, 'PPL', 'P'),
(159948, 'Century', 40.0102806091309, 0.698311131276176, -79.8861083984375, -1.39427561815783, 218, 45, 'PPL', 'P'),
(85690, 'Century Acres', 35.9047203063965, 0.626655586354286, -84.4291687011719, -1.47356697855719, 218, 50, 'PPL', 'P'),
(180639, 'Century City', 34.0555610656738, 0.594381669209997, -118.416938781738, -2.0667654718739, 218, 6, 'PPL', 'P'),
(203349, 'Century Condominium', 40.6958312988281, 0.710276248000711, -112.047782897949, -1.95560273112901, 218, 52, 'PPL', 'P'),
(45578, 'Century Estates', 38.7044410705566, 0.675519931825332, -76.6494369506836, -1.33778504458923, 218, 25, 'PPL', 'P'),
(108536, 'Century Junction', 39.0741691589355, 0.681972904304649, -80.1172180175781, -1.39830924194486, 218, 58, 'PPL', 'P'),
(45579, 'Century Manor', 38.7544403076172, 0.676392583135524, -76.6344375610352, -1.33752325585408, 218, 25, 'PPL', 'P'),
(15481, 'Century Village', 26.7136096954346, 0.466240444278013, -80.1291732788086, -1.39851790061627, 218, 12, 'PPL', 'P'),
(35201, 'Ceralvo', 37.3650016784668, 0.652142304302453, -87.0313873291016, -1.5189842614713, 218, 21, 'PPL', 'P'),
(63593, 'Ceramic', 36.3066711425781, 0.6336709518768, -80.0858306884766, -1.39776142970863, 218, 33, 'PPL', 'P'),
(177894, 'Cerbat', 35.3030586242676, 0.616154609018049, -114.138893127441, -1.99209948965578, 218, 5, 'PPL', 'P'),
(119076, 'Cereal', 40.7083282470703, 0.710494360893989, -88.3511123657227, -1.54201780858134, 218, 18, 'PPL', 'P'),
(159949, 'Cereal', 40.3144416809082, 0.703619743435085, -79.7238922119141, -1.39144441160297, 218, 45, 'PPL', 'P'),
(191249, 'Cereal', 34.2024993896484, 0.596946226760716, -101.521392822266, -1.77188256595907, 218, 51, 'PPL', 'P'),
(35202, 'Ceredo', 37.0411109924316, 0.646489345414597, -88.866943359375, -1.5510207578044, 218, 21, 'PPL', 'P'),
(108537, 'Ceredo', 38.3963890075684, 0.670143409058626, -82.5588912963867, -1.44092447991804, 218, 58, 'PPL', 'P'),
(19923, 'Ceres', 32.8077812194824, 0.572603802553929, -83.9966735839844, -1.46601851476347, 218, 13, 'PPL', 'P'),
(75398, 'Ceres', 36.4772186279297, 0.636647567027182, -97.2822189331055, -1.69789502402866, 218, 42, 'PPL', 'P'),
(100666, 'Ceres', 37.0177803039551, 0.646082148083923, -81.3430633544922, -1.41970427919423, 218, 53, 'PPL', 'P'),
(108539, 'Ceres', 37.3077812194824, 0.651143618893674, -81.148063659668, -1.41630089247917, 218, 58, 'PPL', 'P'),
(114940, 'Ceres', 42.8205604553223, 0.747359767494656, -91.1861114501953, -1.59149787689641, 218, 16, 'PPL', 'P'),
(147708, 'Ceres', 41.999439239502, 0.733028498720612, -78.269172668457, -1.36605476587653, 218, 40, 'PPL', 'P'),
(180638, 'Ceres', 37.5950012207031, 0.656156553592557, -120.956672668457, -2.11109219032161, 218, 6, 'PPL', 'P'),
(207006, 'Ceres', 46.6080589294434, 0.81346408628233, -123.152221679688, -2.14941174945649, 218, 56, 'PPL', 'P'),
(130147, 'Ceresco', 42.2719383239746, 0.73778450495333, -85.061393737793, -1.48460138705977, 218, 27, 'PPL', 'P'),
(141471, 'Ceresco', 41.0572204589844, 0.716583678726455, -96.6444396972656, -1.6867636764624, 218, 35, 'PPL', 'P'),
(45580, 'Ceresville', 39.4536094665527, 0.688595386987349, -77.366943359375, -1.35030789382506, 218, 25, 'PPL', 'P'),
(15482, 'Cerny Heights', 30.4438896179199, 0.531346110946421, -87.3166732788086, -1.52396344060336, 218, 12, 'PPL', 'P'),
(188276, 'Cerrillos', 35.4377784729004, 0.61850591394448, -106.121940612793, -1.85217727229913, 218, 38, 'PPL', 'P'),
(93168, 'Cerrito Colonia', 26.2169990539551, 0.457572953483755, -97.9089965820313, -1.70883435768032, 218, 51, 'PPL', 'P'),
(180640, 'Cerritos', 33.8583297729492, 0.590939333763988, -118.063888549805, -2.06060358290173, 218, 6, 'PPL', 'P'),
(180641, 'Cerro', 37.9916687011719, 0.663079707162327, -122.530281066895, -2.13855683801138, 218, 6, 'PPL', 'P'),
(188277, 'Cerro', 36.7538909912109, 0.641476410715713, -105.61222076416, -1.84328098267772, 218, 38, 'PPL', 'P'),
(26750, 'Cerro Gordo', 39.8905601501465, 0.6962216150849, -88.7280578613281, -1.54859674858021, 218, 18, 'PPL', 'P'),
(63597, 'Cerro Gordo', 34.3219413757324, 0.599030882683003, -78.9266662597656, -1.37753019385563, 218, 33, 'PPL', 'P'),
(85691, 'Cerro Gordo', 35.3036117553711, 0.616164262977001, -88.1805572509766, -1.5390410602729, 218, 50, 'PPL', 'P'),
(134623, 'Cerro Gordo', 45.0525016784668, 0.786314490549517, -96.0316696166992, -1.6760688209988, 218, 28, 'PPL', 'P'),
(194714, 'Cerro Grande', 43.4411087036133, 0.758190377594817, -112.932502746582, -1.9710440054454, 218, 17, 'PPL', 'P'),
(180642, 'Cerro Villa Heights', 33.8266716003418, 0.590386794416824, -117.803329467773, -2.05605596902431, 218, 6, 'PPL', 'P'),
(8017, 'Cerrogordo', 33.9197196960449, 0.592010790049554, -94.475830078125, -1.64891429841797, 218, 4, 'PPL', 'P'),
(15483, 'Cerrogordo', 30.8316707611084, 0.538114168672208, -85.8874969482422, -1.49901960804341, 218, 12, 'PPL', 'P'),
(35203, 'Cerulean', 36.9594383239746, 0.645063888441132, -87.7099990844727, -1.53082827094526, 218, 21, 'PPL', 'P'),
(93169, 'Cesar Chavez', 26.3030605316162, 0.459075009628073, -98.1149978637695, -1.71242975830998, 218, 51, 'PPL', 'P'),
(154665, 'Cesarea', 40.7108306884766, 0.710538036735866, -82.4819412231445, -1.43958144778031, 218, 41, 'PPL', 'P'),
(58960, 'Cessions Landing', 34.0969390869141, 0.595103851918599, -90.8802795410156, -1.58616010312356, 218, 30, 'PPL', 'P'),
(32032, 'Cessna', 37.6386108398438, 0.656917685032102, -97.4127807617188, -1.70017375781538, 218, 20, 'PPL', 'P'),
(159951, 'Cessna', 40.0944404602051, 0.699779997775409, -78.5258331298828, -1.3705343359881, 218, 45, 'PPL', 'P'),
(93170, 'Cestohowa', 29.0097198486328, 0.506315126439794, -97.934440612793, -1.70927843979209, 218, 51, 'PPL', 'P'),
(75399, 'Cestos', 36.1441688537598, 0.630834751894893, -99.0933303833008, -1.72950488195513, 218, 42, 'PPL', 'P'),
(159953, 'Cetronia', 40.586669921875, 0.708371022556868, -75.5299987792969, -1.31824716272603, 218, 45, 'PPL', 'P'),
(19924, 'Ceylon', 30.961389541626, 0.540378188493911, -81.6508331298828, -1.42507587511292, 218, 13, 'PPL', 'P'),
(112515, 'Ceylon', 39.8619384765625, 0.695722072643428, -79.980827331543, -1.3959287754045, 218, 45, 'PPL', 'P'),
(122355, 'Ceylon', 40.6066703796387, 0.708720096396751, -84.9533309936523, -1.48271533637578, 218, 19, 'PPL', 'P'),
(134625, 'Ceylon', 43.5336112976074, 0.759804852426651, -94.6313934326172, -1.65162939114931, 218, 28, 'PPL', 'P'),
(154667, 'Ceylon', 41.3716697692871, 0.722071854521863, -82.4938888549805, -1.43978997329366, 218, 41, 'PPL', 'P'),
(85692, 'Chable (historical)', 35.0430603027344, 0.611616782257636, -84.5930633544922, -1.47642747988405, 218, 50, 'PPL', 'P'),
(180643, 'Chabot Terrace', 38.1472206115723, 0.665794600156581, -122.245002746582, -2.13357779203737, 218, 6, 'PPL', 'P'),
(39721, 'Chacahoula', 29.7058296203613, 0.518464533911762, -90.9111099243164, -1.58669819482181, 218, 22, 'PPL', 'P'),
(147709, 'Chace', 42.6652793884277, 0.744649601611337, -78.0661087036133, -1.36251063109785, 218, 40, 'PPL', 'P'),
(39722, 'Chackbay', 29.8833293914795, 0.521562489339311, -90.7972183227539, -1.58471041138418, 218, 22, 'PPL', 'P'),
(188278, 'Chacon', 36.1441688537598, 0.630834751894893, -105.367218017578, -1.83900487807343, 218, 38, 'PPL', 'P'),
(93171, 'Chacon Estates Number 1 Colonia', 26.2740001678467, 0.458567810598467, -98.3649978637695, -1.71679308143997, 218, 51, 'PPL', 'P'),
(186520, 'Chacra', 39.5752792358398, 0.690718925061551, -107.446113586426, -1.87528845055494, 218, 7, 'PPL', 'P'),
(35204, 'Chad', 36.9697189331055, 0.645243318919576, -83.0227813720703, -1.44902088910604, 218, 21, 'PPL', 'P'),
(196190, 'Chadborn', 45.8116683959961, 0.799564449341961, -110.537780761719, -1.92924822213964, 218, 31, 'PPL', 'P'),
(63595, 'Chadbourn', 34.3219413757324, 0.599030882683003, -78.8272171020508, -1.37579447861517, 218, 33, 'PPL', 'P'),
(180644, 'Chadbourne', 38.2438888549805, 0.667481779286173, -122.082778930664, -2.13074645232445, 218, 6, 'PPL', 'P'),
(127079, 'Chadbournes Mills', 43.6263885498047, 0.761424120948446, -70.7222213745117, -1.23433561730954, 218, 26, 'PPL', 'P'),
(77997, 'Chadds Ford', 39.8716697692871, 0.695891915741948, -75.591667175293, -1.31932347928058, 218, 45, 'PPL', 'P'),
(77998, 'Chadds Ford Junction', 39.8688888549805, 0.695843379631081, -75.5963897705078, -1.31940590411632, 218, 45, 'PPL', 'P'),
(77999, 'Chadds Ford Knoll', 39.8675003051758, 0.695819144865162, -75.6074981689453, -1.31959978224368, 218, 45, 'PPL', 'P'),
(19925, 'Chadds Walk', 33.9719390869141, 0.592922190353606, -83.440559387207, -1.45631249101262, 218, 13, 'PPL', 'P'),
(177895, 'Chador Mobile Home Park', 33.579719543457, 0.586076667929612, -112.251388549805, -1.95915632012955, 218, 5, 'PPL', 'P'),
(199222, 'Chadron', 42.8294410705566, 0.747514763470098, -102.999443054199, -1.79767940901618, 218, 35, 'PPL', 'P'),
(45581, 'Chadswood', 39.1938896179199, 0.684062420495925, -77.2358322143555, -1.34801957265841, 218, 25, 'PPL', 'P'),
(100667, 'Chadswyck', 36.8177795410156, 0.642591476264129, -76.4097213745117, -1.33360121851672, 218, 53, 'PPL', 'P'),
(78001, 'Chadville', 39.8663902282715, 0.695799770368231, -79.7519378662109, -1.39193390061132, 218, 45, 'PPL', 'P'),
(200551, 'Chadwell (historical)', 46.1027793884277, 0.804645294648642, -123.849998474121, -2.16159025196337, 218, 43, 'PPL', 'P'),
(45583, 'Chadwick', 39.6011085510254, 0.691169731655074, -76.4372177124023, -1.33408112014515, 218, 25, 'PPL', 'P'),
(63599, 'Chadwick', 34.9552803039551, 0.61008473226154, -77.2422180175781, -1.34813102595003, 218, 33, 'PPL', 'P'),
(70639, 'Chadwick', 39.9930610656738, 0.69801059354716, -74.0641708374023, -1.29266363887224, 218, 37, 'PPL', 'P'),
(112405, 'Chadwick', 36.9300003051758, 0.644550098087828, -93.0566711425781, -1.62414530238358, 218, 29, 'PPL', 'P'),
(119077, 'Chadwick', 42.0133285522461, 0.733270912958837, -89.8905563354492, -1.56888617450304, 218, 18, 'PPL', 'P'),
(198107, 'Chadwick', 46.1597213745117, 0.805639119788432, -101.033889770508, -1.76337403259238, 218, 34, 'PPL', 'P'),
(8018, 'Chadwick (historical)', 34.9808311462402, 0.610530678586074, -92.3513870239258, -1.61183577235107, 218, 4, 'PPL', 'P'),
(72065, 'Chadwick (historical)', 39.5122184753418, 0.689618307162048, -81.7505569458008, -1.42681638404334, 218, 41, 'PPL', 'P'),
(63598, 'Chadwick Acres', 34.5186080932617, 0.602463364432979, -77.3727798461914, -1.35040975973675, 218, 33, 'PPL', 'P'),
(70640, 'Chadwick Beach', 39.982780456543, 0.697831163068716, -74.0638885498047, -1.29265871202422, 218, 37, 'PPL', 'P'),
(45584, 'Chadwick Court', 39.5730590820313, 0.69068017606769, -77.040283203125, -1.34460659856341, 218, 25, 'PPL', 'P'),
(45585, 'Chadwick Manor', 39.3097190856934, 0.686084026079404, -76.7666702270508, -1.33983115125474, 218, 25, 'PPL', 'P'),
(124475, 'Chadwick Square', 42.2902793884277, 0.738104616916358, -71.8097229003906, -1.25331609955659, 218, 23, 'PPL', 'P'),
(147710, 'Chadwicks', 43.0277786254883, 0.750976406834011, -75.2719421386719, -1.31374322469049, 218, 40, 'PPL', 'P'),
(124476, 'Chadwicks Folly', 41.3197212219238, 0.721165181328745, -69.9902801513672, -1.22156083303459, 218, 23, 'PPL', 'P'),
(53978, 'Chaffee', 37.1800003051758, 0.648913421217814, -89.6549987792969, -1.56477491957023, 218, 29, 'PPL', 'P'),
(108540, 'Chaffee', 39.4063911437988, 0.687771271788024, -79.1624984741211, -1.3816462424784, 218, 58, 'PPL', 'P'),
(139782, 'Chaffee', 46.7744407653809, 0.816367997134952, -97.3522186279297, -1.69911674917873, 218, 34, 'PPL', 'P'),
(147711, 'Chaffee', 42.5680618286133, 0.74295283510182, -78.4791717529297, -1.36971994132675, 218, 40, 'PPL', 'P'),
(159954, 'Chaffee', 41.5802803039551, 0.725712795206165, -78.9341735839844, -1.37766122138126, 218, 45, 'PPL', 'P'),
(180645, 'Chaffee', 35.0666694641113, 0.612028839857298, -118.170280456543, -2.06246047197178, 218, 6, 'PPL', 'P'),
(207007, 'Chaffee', 46.2602806091309, 0.807394209525822, -119.605560302734, -2.08751083097534, 218, 56, 'PPL', 'P'),
(80246, 'Chaffee (historical)', 33.6972198486328, 0.588127435127028, -81.4002838134766, -1.42070296460301, 218, 48, 'PPL', 'P'),
(154668, 'Chaffee (historical)', 41.3208312988281, 0.721184555825676, -81.5844421386719, -1.42391713372263, 218, 41, 'PPL', 'P'),
(93172, 'Chaffee Village', 31.1294403076172, 0.543311227670956, -97.7613906860352, -1.70625814879983, 218, 51, 'PPL', 'P'),
(177590, 'Chaffeeville', 41.7947196960449, 0.729455468644108, -72.2088928222656, -1.26028292896824, 218, 8, 'PPL', 'P'),
(173500, 'Chaffey', 46.3983306884766, 0.809803637943043, -92.163330078125, -1.6085535594656, 218, 57, 'PPL', 'P'),
(93173, 'Chaffin Crossing', 31.4558296203613, 0.549007795821663, -99.3986129760742, -1.73483306834805, 218, 51, 'PPL', 'P'),
(191250, 'Chaffin Place', 29.9808292388916, 0.523264182696844, -104.457221984863, -1.82312245112247, 218, 51, 'PPL', 'P'),
(124477, 'Chaffinville', 42.336109161377, 0.738904497349763, -71.8333282470703, -1.25372809057722, 218, 23, 'PPL', 'P'),
(154669, 'Chagrin Falls', 41.4361114501953, 0.723196574029231, -81.3866729736328, -1.42046541063378, 218, 41, 'PPL', 'P'),
(154670, 'Chagrin Falls Park', 41.413890838623, 0.722808751195488, -81.3866729736328, -1.42046541063378, 218, 41, 'PPL', 'P'),
(113237, 'Chagrin Harbor', 41.6786117553711, 0.727429002791639, -81.4305572509766, -1.42123133576328, 218, 41, 'PPL', 'P'),
(159955, 'Chain', 40.7374992370605, 0.711003490715385, -75.945556640625, -1.32550001563875, 218, 45, 'PPL', 'P'),
(207009, 'Chain Hill', 46.8805618286133, 0.818220159094075, -122.844436645508, -2.14403988722169, 218, 56, 'PPL', 'P'),
(15484, 'Chain O''Lakes', 28.9836101531982, 0.505859426287767, -81.5119400024414, -1.42265173273068, 218, 12, 'PPL', 'P'),
(53979, 'Chain of Rocks', 38.9150009155273, 0.67919489439256, -90.8013916015625, -1.58478324883999, 218, 29, 'PPL', 'P'),
(53980, 'Chain-O-Lakes', 36.5344390869141, 0.637646252435961, -93.7247161865234, -1.63580488795206, 218, 29, 'PPL', 'P'),
(122356, 'Chain-O-Lakes', 41.7083282470703, 0.727947653413932, -86.379997253418, -1.5076153599358, 218, 19, 'PPL', 'P'),
(159956, 'Chaintown', 40.0969390869141, 0.699823607038259, -79.6555633544922, -1.39025184806683, 218, 45, 'PPL', 'P'),
(177896, 'Chair Crossing', 36.8727798461914, 0.643551412679048, -111.594436645508, -1.94769034637233, 218, 5, 'PPL', 'P'),
(15485, 'Chaires', 30.4361095428467, 0.531210323020341, -84.1175003051758, -1.46812733887265, 218, 12, 'PPL', 'P'),
(70641, 'Chairville', 39.8983306884766, 0.696357236563412, -74.789436340332, -1.30532190984949, 218, 37, 'PPL', 'P'),
(130148, 'Chaison', 45.8769416809082, 0.80070368307727, -87.0647201538086, -1.51956602901142, 218, 27, 'PPL', 'P'),
(211723, 'Chakaktolik', 61.7683296203613, 1.07806072533244, -163.622222900391, -2.85574651904388, 218, 1, 'PPL', 'P'),
(177897, 'Chakpahu', 35.7619400024414, 0.624163599943272, -110.172218322754, -1.92286795395808, 218, 5, 'PPL', 'P'),
(211724, 'Chakwaktolik', 61.2291717529297, 1.06865064535773, -163.754165649414, -2.85804935443847, 218, 1, 'PPL', 'P'),
(141472, 'Chalco', 41.1838912963867, 0.718794501905384, -96.1500015258789, -1.67813410242416, 218, 35, 'PPL', 'P'),
(177898, 'Chalender', 35.2344398498535, 0.61495698547584, -112.024436950684, -1.95519526748223, 218, 5, 'PPL', 'P'),
(45586, 'Chalet De La Rance', 39.690559387207, 0.692730943265106, -76.6483306884766, -1.33776573667133, 218, 25, 'PPL', 'P'),
(85693, 'Chalet Village', 35.7075004577637, 0.623213450645358, -83.5449981689453, -1.45813529162073, 218, 50, 'PPL', 'P'),
(159957, 'Chalfant', 40.4086112976074, 0.705263313301828, -79.8391723632813, -1.39345642980652, 218, 45, 'PPL', 'P'),
(180646, 'Chalfant Valley', 37.5294418334961, 0.655012326430204, -118.362503051758, -2.06581538915501, 218, 6, 'PPL', 'P'),
(72066, 'Chalfants', 39.8691711425781, 0.695848306479098, -82.2852783203125, -1.43614903260936, 218, 41, 'PPL', 'P'),
(26752, 'Chalfin Bridge', 38.2119407653809, 0.666924179932938, -90.2686080932617, -1.57548442241982, 218, 18, 'PPL', 'P'),
(45587, 'Chalfone Manor', 39.2772216796875, 0.685516839346245, -76.7819366455078, -1.3400976005218, 218, 25, 'PPL', 'P'),
(159958, 'Chalfont', 40.288330078125, 0.703164009993546, -75.2094421386719, -1.31265239390799, 218, 45, 'PPL', 'P'),
(13515, 'Chalfonte', 39.8188896179199, 0.694970728320889, -75.5330581665039, -1.31830055910588, 218, 10, 'PPL', 'P'),
(191251, 'Chalk', 33.8783302307129, 0.59128840760387, -100.22306060791, -1.74922239403386, 218, 51, 'PPL', 'P'),
(8021, 'Chalk (historical)', 35.5416717529297, 0.620319193751688, -92.246940612793, -1.61001283858491, 218, 4, 'PPL', 'P'),
(193444, 'Chalk Bank Landing', 41.9122200012207, 0.731506235841523, -121.641670227051, -2.12304765308719, 218, 6, 'PPL', 'P'),
(58961, 'Chalk Bluff (historical)', 33.9283294677734, 0.592161058914062, -88.7733306884766, -1.54938690847564, 218, 30, 'PPL', 'P'),
(196191, 'Chalk Buttes (historical)', 45.6602783203125, 0.796922194066439, -104.741668701172, -1.82808698286854, 218, 31, 'PPL', 'P'),
(194715, 'Chalk Cut', 42.9811096191406, 0.75016187901461, -115.532218933105, -2.01641761251762, 218, 17, 'PPL', 'P'),
(93174, 'Chalk Hill', 32.3527793884277, 0.564662522499421, -94.6508331298828, -1.65196867787218, 218, 51, 'PPL', 'P'),
(53981, 'Chalk Level', 38.0933303833008, 0.664854038238592, -93.809440612793, -1.63728360814732, 218, 29, 'PPL', 'P'),
(85694, 'Chalk Level', 36.357780456543, 0.634562977683922, -82.995002746582, -1.44853606062959, 218, 50, 'PPL', 'P'),
(100668, 'Chalk Level', 36.9183311462402, 0.644346432843464, -79.2780609130859, -1.38366318752997, 218, 53, 'PPL', 'P'),
(63602, 'Chalk Level (historical)', 36.1566696166992, 0.631052931367198, -80.2055587768555, -1.39985107905796, 218, 33, 'PPL', 'P'),
(93175, 'Chalk Mountain', 32.1541709899902, 0.561196152024574, -97.9105606079102, -1.70886165508149, 218, 51, 'PPL', 'P'),
(45588, 'Chalk Point', 38.836109161377, 0.677817973529962, -76.5388870239258, -1.33585558437947, 218, 25, 'PPL', 'P'),
(19926, 'Chalker (historical)', 33.1613883972168, 0.578775412064078, -82.7350006103516, -1.44399816729015, 218, 13, 'PPL', 'P'),
(130149, 'Chalkerville', 42.4322204589844, 0.740581955941377, -84.0186080932617, -1.46640134417017, 218, 27, 'PPL', 'P'),
(78002, 'Chalkhill', 39.8441696166992, 0.695411947534488, -79.616943359375, -1.38957780199493, 218, 45, 'PPL', 'P'),
(85695, 'Chalklevel', 35.9866714477539, 0.62808590359674, -88.0650024414063, -1.53702424837938, 218, 50, 'PPL', 'P'),
(39723, 'Chalkley', 30.1519393920898, 0.526250618253745, -93.0972213745117, -1.62485303744327, 218, 22, 'PPL', 'P'),
(1473, 'Chalkville', 33.6530609130859, 0.587356716307559, -86.6477813720703, -1.51228907449084, 218, 2, 'PPL', 'P'),
(211725, 'Chalkyitsik', 66.6544418334961, 1.16333947107355, -143.722213745117, -2.50842583810735, 218, 1, 'PPL', 'P'),
(26753, 'Challacombe', 39.2183303833008, 0.684488992323528, -90.1211090087891, -1.57291007775209, 218, 18, 'PPL', 'P'),
(80247, 'Challedon', 34.0647201538086, 0.594541525454429, -81.1577835083008, -1.4164705358406, 218, 48, 'PPL', 'P'),
(80248, 'Challedon West', 34.0644416809082, 0.59453666518544, -81.1763916015625, -1.41679530833554, 218, 48, 'PPL', 'P'),
(159960, 'Challenge', 41.2886085510254, 0.720622162782478, -78.6891708374023, -1.37338511677697, 218, 45, 'PPL', 'P'),
(180647, 'Challenge', 39.4874992370605, 0.689186875065455, -121.222503662109, -2.11573181641469, 218, 6, 'PPL', 'P'),
(194716, 'Challis', 44.5047187805176, 0.776753875394187, -114.230827331543, -1.99370404421255, 218, 17, 'PPL', 'P'),
(93176, 'Chalmers', 29.0708293914795, 0.507381689166857, -95.9613876342773, -1.67484216900071, 218, 51, 'PPL', 'P'),
(122357, 'Chalmers', 40.6630592346191, 0.709704267577589, -86.8694381713867, -1.51615771544834, 218, 19, 'PPL', 'P'),
(39724, 'Chalmette', 29.9424991607666, 0.522595196631016, -89.9633331298828, -1.57015636918495, 218, 22, 'PPL', 'P'),
(39725, 'Chalmette Vista', 29.9463901519775, 0.522663107238813, -89.9791717529297, -1.5704328053061, 218, 22, 'PPL', 'P'),
(35205, 'Chalybeate', 37.1269416809082, 0.647987373527766, -86.2361068725586, -1.50510399902786, 218, 21, 'PPL', 'P'),
(58962, 'Chalybeate', 34.9302787780762, 0.609648373316931, -88.8680572509766, -1.55104019888036, 218, 30, 'PPL', 'P'),
(85696, 'Chalybeate', 35.5586090087891, 0.620614804632686, -85.5111083984375, -1.49245038858251, 218, 50, 'PPL', 'P'),
(159961, 'Chalybeate', 40.0280609130859, 0.698621456122197, -78.4850006103516, -1.36982167408039, 218, 45, 'PPL', 'P'),
(1474, 'Chalybeate Springs', 34.564998626709, 0.60327303198339, -87.2266693115234, -1.52239257503438, 218, 2, 'PPL', 'P'),
(8023, 'Chalybeate Springs', 34.9866714477539, 0.610632611076797, -93.5722198486328, -1.63314332475863, 218, 4, 'PPL', 'P'),
(19927, 'Chalybeate Springs', 32.8566703796387, 0.57345707936719, -84.5802764892578, -1.4762043069847, 218, 13, 'PPL', 'P'),
(63600, 'Chalybeate Springs', 35.5083312988281, 0.619737293053505, -78.8141708374023, -1.37556677834197, 218, 33, 'PPL', 'P'),
(186523, 'Chama', 37.7188911437988, 0.65831884066062, -105.298332214355, -1.83780259399931, 218, 7, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(188279, 'Chama', 36.9030609130859, 0.644079916997375, -106.578887939453, -1.86015250765753, 218, 38, 'PPL', 'P'),
(198109, 'Chama', 46.9077796936035, 0.818695200453518, -103.909721374512, -1.81356676281516, 218, 34, 'PPL', 'P'),
(188281, 'Chamberino', 32.0497207641602, 0.559373151679388, -106.67472076416, -1.86182510598016, 218, 38, 'PPL', 'P'),
(127081, 'Chamberlain', 43.8919410705566, 0.766058886772538, -69.477783203125, -1.21261607388134, 218, 26, 'PPL', 'P'),
(130150, 'Chamberlain', 42.0658302307129, 0.734187240110906, -85.7427825927734, -1.49649386606558, 218, 27, 'PPL', 'P'),
(134627, 'Chamberlain', 46.9052810668945, 0.818651591190668, -94.7213897705078, -1.65320012356024, 218, 28, 'PPL', 'P'),
(170002, 'Chamberlain', 43.8108291625977, 0.764643216916079, -99.3302764892578, -1.73364037165386, 218, 49, 'PPL', 'P'),
(154673, 'Chamberlain (historical)', 41.1291694641113, 0.717839425759454, -81.8786087036133, -1.42905130883014, 218, 41, 'PPL', 'P'),
(100669, 'Chamberlain Village', 38.5288887023926, 0.672455964991196, -77.2949981689453, -1.34905221337108, 218, 53, 'PPL', 'P'),
(180648, 'Chamberlands Estates', 39.0694389343262, 0.681890346310856, -120.151390075684, -2.09703735766872, 218, 6, 'PPL', 'P'),
(100672, 'Chamberlayne', 37.6263885498047, 0.656704365828786, -77.4288864135742, -1.35138900406957, 218, 53, 'PPL', 'P'),
(100670, 'Chamberlayne Farms', 37.6330604553223, 0.65682081254745, -77.4377822875977, -1.35154426636113, 218, 53, 'PPL', 'P'),
(100671, 'Chamberlayne Heights', 37.6272201538086, 0.656718880056727, -77.432502746582, -1.35145212098741, 218, 53, 'PPL', 'P'),
(45589, 'Chamberlea', 39.2988891601563, 0.685895008221036, -76.852783203125, -1.34133410621593, 218, 25, 'PPL', 'P'),
(19928, 'Chamberlin', 33.898609161377, 0.591642341712742, -83.3402786254883, -1.45456226154422, 218, 13, 'PPL', 'P'),
(39726, 'Chamberlin', 30.5349998474121, 0.532936284433307, -91.3033294677734, -1.59354371724581, 218, 22, 'PPL', 'P'),
(191252, 'Chamberlin', 36.148609161377, 0.630912249882614, -102.383888244629, -1.78693595086269, 218, 51, 'PPL', 'P'),
(1475, 'Chambers', 33.2416687011719, 0.580176567692596, -87.1580581665039, -1.52119508465023, 218, 2, 'PPL', 'P'),
(35206, 'Chambers', 37.8372192382813, 0.660384055506949, -86.7852783203125, -1.51468884894911, 218, 21, 'PPL', 'P'),
(39727, 'Chambers', 31.1783294677734, 0.544164504484218, -92.4136123657227, -1.61292180944361, 218, 22, 'PPL', 'P'),
(75400, 'Chambers', 34.8697204589844, 0.608591431259306, -95.8244400024414, -1.67245198192237, 218, 42, 'PPL', 'P'),
(85698, 'Chambers', 36.4533309936523, 0.63623064915853, -88.9847183227539, -1.55307631869178, 218, 50, 'PPL', 'P'),
(108541, 'Chambers', 37.8211097717285, 0.660102892274864, -81.8802795410156, -1.42908047044407, 218, 58, 'PPL', 'P'),
(141473, 'Chambers', 42.2050018310547, 0.73661624276214, -98.7486114501953, -1.72348840157848, 218, 35, 'PPL', 'P'),
(147712, 'Chambers', 42.2622184753418, 0.737614861591892, -76.9569396972656, -1.34315197997601, 218, 40, 'PPL', 'P'),
(177899, 'Chambers', 35.1886100769043, 0.614157105042435, -109.432502746582, -1.90995748162559, 218, 5, 'PPL', 'P'),
(207008, 'Chambers', 46.6430587768555, 0.814074948857367, -117.183609008789, -2.04523980657306, 218, 56, 'PPL', 'P'),
(63601, 'Chambers (historical)', 35.6749992370605, 0.622646197333172, -81.7152786254883, -1.42620066119932, 218, 33, 'PPL', 'P'),
(194717, 'Chambers (historical)', 46.9249992370605, 0.818995738182534, -116.782783508301, -2.03824408186358, 218, 17, 'PPL', 'P'),
(127082, 'Chambers Corner', 44.0774993896484, 0.769297490395156, -70.5505599975586, -1.2313395610832, 218, 26, 'PPL', 'P'),
(144966, 'Chambers Corners', 40.0177803039551, 0.698442025643753, -74.7330627441406, -1.30433800498476, 218, 37, 'PPL', 'P'),
(180650, 'Chambers Lodge', 39.0733299255371, 0.681958256918653, -120.140281677246, -2.09684347954136, 218, 6, 'PPL', 'P'),
(159963, 'Chambers Mill', 40.0994415283203, 0.699867282880136, -80.2436065673828, -1.40051513827578, 218, 45, 'PPL', 'P'),
(203352, 'Chambers Park', 40.7077789306641, 0.710484773514064, -112.106941223145, -1.95663523868363, 218, 52, 'PPL', 'P'),
(8025, 'Chambers Spring (historical)', 36.1180610656738, 0.63037908503238, -94.4305572509766, -1.64812413852255, 218, 4, 'PPL', 'P'),
(1477, 'Chambers Springs', 33.2919387817383, 0.581053946113723, -86.0405578613281, -1.50169102493287, 218, 2, 'PPL', 'P'),
(203353, 'Chambers Townsite', 40.709171295166, 0.710509074859011, -112.108612060547, -1.95666440029757, 218, 52, 'PPL', 'P'),
(26754, 'Chambersburg', 39.8172187805176, 0.694941566706953, -90.6572189331055, -1.58226696108403, 218, 18, 'PPL', 'P'),
(29451, 'Chambersburg', 38.5180587768555, 0.672266947132828, -86.392219543457, -1.50782867913912, 218, 19, 'PPL', 'P'),
(78005, 'Chambersburg', 39.9375, 0.697040870015235, -77.6613922119141, -1.35544699578058, 218, 45, 'PPL', 'P'),
(139074, 'Chambersburg', 40.5238914489746, 0.707275331505383, -91.7991714477539, -1.60219779236608, 218, 29, 'PPL', 'P'),
(154680, 'Chambersburg', 40.7874984741211, 0.711876142025576, -81.0319366455078, -1.41427409373156, 218, 41, 'PPL', 'P'),
(8027, 'Chambersville', 33.7477798461914, 0.589009873554226, -92.4311065673828, -1.61322714086258, 218, 4, 'PPL', 'P'),
(13516, 'Chambersville', 39.3636093139648, 0.687024587997393, -75.5791702270508, -1.31910536638731, 218, 10, 'PPL', 'P'),
(93178, 'Chambersville', 33.3061103820801, 0.581301287199964, -96.6355590820313, -1.68660868048695, 218, 51, 'PPL', 'P'),
(100673, 'Chambersville', 39.1936111450195, 0.684057560226936, -78.2425003051758, -1.36558924531799, 218, 53, 'PPL', 'P'),
(159964, 'Chambersville', 40.7052803039551, 0.710441164251214, -79.1580581665039, -1.38156874449068, 218, 45, 'PPL', 'P'),
(80250, 'Chambert Forest', 34.439998626709, 0.601091370418397, -82.7205581665039, -1.44374609909298, 218, 48, 'PPL', 'P'),
(1478, 'Chamblee', 33.2416687011719, 0.580176567692596, -87.1488876342773, -1.52103502866871, 218, 2, 'PPL', 'P'),
(19929, 'Chamblee', 33.8919410705566, 0.591525961573105, -84.2988891601563, -1.47129317161848, 218, 13, 'PPL', 'P'),
(39728, 'Chamblee', 31.8613891601563, 0.556086145103957, -91.357780456543, -1.5944940662808, 218, 22, 'PPL', 'P'),
(1479, 'Chamblees Mill', 34.0616683959961, 0.594488262232628, -86.6694412231445, -1.51266711020757, 218, 2, 'PPL', 'P'),
(180649, 'Chambless', 34.5613899230957, 0.60321004822361, -115.543891906738, -2.01662134434101, 218, 6, 'PPL', 'P'),
(19930, 'Chambliss', 31.9194393157959, 0.557099311451165, -84.5441665649414, -1.47557406991273, 218, 13, 'PPL', 'P'),
(93179, 'Chambliss', 33.2947196960449, 0.58110248222459, -96.495002746582, -1.68415550964883, 218, 51, 'PPL', 'P'),
(100674, 'Chamblissburg', 37.2541694641113, 0.650207917244674, -79.7072219848633, -1.39115346125387, 218, 53, 'PPL', 'P'),
(188282, 'Chamisal', 36.165828704834, 0.631212787611629, -105.73722076416, -1.84546264424271, 218, 38, 'PPL', 'P'),
(177900, 'Chamiso', 31.9927806854248, 0.558379359829111, -110.353889465332, -1.92603871355193, 218, 5, 'PPL', 'P'),
(188283, 'Chamita', 36.0702781677246, 0.629545116137022, -106.096389770508, -1.85173132597459, 218, 38, 'PPL', 'P'),
(188284, 'Chamizal', 34.2174987792969, 0.597208015495871, -106.913063049316, -1.86598496360286, 218, 38, 'PPL', 'P'),
(26756, 'Chamness (historical)', 37.6769409179688, 0.657586671097929, -88.9886093139648, -1.55314422929958, 218, 18, 'PPL', 'P'),
(53983, 'Chamois', 38.6752815246582, 0.675011001741018, -91.7694396972656, -1.60167887542767, 218, 29, 'PPL', 'P'),
(159965, 'Chamouni', 40.0586090087891, 0.699154620972431, -79.8733291625977, -1.39405257841653, 218, 45, 'PPL', 'P'),
(45590, 'Champ', 38.1602783203125, 0.666022500166864, -75.8080596923828, -1.32310024118048, 218, 25, 'PPL', 'P'),
(53985, 'Champ', 38.7413902282715, 0.676164816283295, -90.4449996948242, -1.57856303663995, 218, 29, 'PPL', 'P'),
(85699, 'Champ', 35.1552810668945, 0.613575404081334, -86.3852767944336, -1.50770750530952, 218, 50, 'PPL', 'P'),
(100675, 'Champ', 36.976390838623, 0.645359765638239, -77.7708282470703, -1.35735701491439, 218, 53, 'PPL', 'P'),
(93180, 'Champ d''Asile (historical)', 30.0750007629395, 0.5249077858531, -94.8166732788086, -1.65486313450294, 218, 51, 'PPL', 'P'),
(100676, 'Champ Mills Estates', 38.6966705322266, 0.67538431034682, -77.4100036621094, -1.35105943788468, 218, 53, 'PPL', 'P'),
(39729, 'Champagne', 30.3019409179688, 0.528868638763348, -91.8483276367188, -1.60305572971124, 218, 22, 'PPL', 'P'),
(180651, 'Champagne', 34.0344390869141, 0.594013021136103, -117.5625, -2.05185270187583, 218, 6, 'PPL', 'P'),
(180652, 'Champagne Fountain', 37.2758293151855, 0.650585952961411, -122.007499694824, -2.12943258180066, 218, 6, 'PPL', 'P'),
(8026, 'Champagnolle', 33.3108291625977, 0.581383645456675, -92.5216674804688, -1.61480772696955, 218, 4, 'PPL', 'P'),
(119079, 'Champaign', 40.1163902282715, 0.700163093498217, -88.2433319091797, -1.54013668474536, 218, 18, 'PPL', 'P'),
(203354, 'Champignon', 40.6597213745117, 0.709646010928744, -111.969436645508, -1.95423533106731, 218, 52, 'PPL', 'P'),
(1480, 'Champion', 33.9355583190918, 0.592287226170704, -86.445556640625, -1.50875958709815, 218, 2, 'PPL', 'P'),
(53987, 'Champion', 36.7880592346191, 0.642072759062809, -89.5877838134766, -1.56360179711005, 218, 29, 'PPL', 'P'),
(113106, 'Champion', 46.5138893127441, 0.811820516415588, -87.9633331298828, -1.53524978414506, 218, 27, 'PPL', 'P'),
(147713, 'Champion', 43.9622192382813, 0.767285472191601, -75.690559387207, -1.32104947398306, 218, 40, 'PPL', 'P'),
(154676, 'Champion', 41.2999992370605, 0.720820967757853, -80.8499984741211, -1.4110986736058, 218, 41, 'PPL', 'P'),
(159967, 'Champion', 40.0750007629395, 0.699440711052533, -79.3583297729492, -1.38506414342141, 218, 45, 'PPL', 'P'),
(173501, 'Champion', 44.589168548584, 0.778227801899492, -87.7941665649414, -1.53229727060255, 218, 57, 'PPL', 'P'),
(191253, 'Champion', 32.3586082458496, 0.564764255253062, -100.620002746582, -1.75615034129359, 218, 51, 'PPL', 'P'),
(199223, 'Champion', 40.4691696166992, 0.706320255359453, -101.748062133789, -1.77583869175839, 218, 35, 'PPL', 'P'),
(8029, 'Champion (historical)', 33.9477806091309, 0.59250054537402, -91.6500015258789, -1.59959428608441, 218, 4, 'PPL', 'P'),
(180653, 'Champion (historical)', 39.2597198486328, 0.685211374769212, -121.036666870117, -2.11248835252308, 218, 6, 'PPL', 'P'),
(196192, 'Champion (historical)', 46.2338905334473, 0.806933615815292, -112.612503051758, -1.96545895716534, 218, 31, 'PPL', 'P'),
(53988, 'Champion City', 38.3194389343262, 0.668800376920899, -91.2702789306641, -1.5929668765537, 218, 29, 'PPL', 'P'),
(19931, 'Champion Crossroad', 32.8511085510254, 0.573360007145457, -84.8702774047852, -1.48126577779445, 218, 13, 'PPL', 'P'),
(45591, 'Champion Forest', 39.1472206115723, 0.683247892676524, -76.7613906860352, -1.33973900588102, 218, 25, 'PPL', 'P'),
(58965, 'Champion Hill', 32.3499984741211, 0.564613986388555, -90.5372161865234, -1.58017251804474, 218, 30, 'PPL', 'P'),
(186524, 'Champion Mill', 39.1375007629395, 0.683078249315086, -106.503890991211, -1.85884356398176, 218, 7, 'PPL', 'P'),
(130151, 'Champion Mine', 47.0347213745117, 0.820910750743382, -88.6708297729492, -1.54759793001338, 218, 27, 'PPL', 'P'),
(15486, 'ChampionsGate', 28.2613906860352, 0.493254318663773, -81.6186065673828, -1.4245134154907, 218, 12, 'PPL', 'P'),
(100677, 'Champlain', 38.0133285522461, 0.663457742879064, -76.9930572509766, -1.34378235020604, 218, 53, 'PPL', 'P'),
(147715, 'Champlain', 44.9863891601563, 0.785160609428213, -73.4469375610352, -1.28189088594676, 218, 40, 'PPL', 'P'),
(119083, 'Champlin', 40.7830581665039, 0.711798644037855, -88.5458297729492, -1.54541626844839, 218, 18, 'PPL', 'P'),
(134629, 'Champlin', 45.1888885498047, 0.788694890510857, -93.397216796875, -1.63008894530442, 218, 28, 'PPL', 'P'),
(192514, 'Champlin', 39.6511116027832, 0.692042449544293, -112.303062438965, -1.96005819963271, 218, 52, 'PPL', 'P'),
(29452, 'Champlin Meadows', 39.4075012207031, 0.687790646284954, -86.4366683959961, -1.50860445796466, 218, 19, 'PPL', 'P'),
(13517, 'Champlin Village', 39.7286109924316, 0.693395069061944, -75.5936126708984, -1.31935743458448, 218, 10, 'PPL', 'P'),
(200552, 'Champoeg', 45.2488899230957, 0.789742112030504, -122.896942138672, -2.14495628095279, 218, 43, 'PPL', 'P'),
(108542, 'Champwood', 39.4433288574219, 0.688415956508905, -78.8194427490234, -1.37565879055763, 218, 58, 'PPL', 'P'),
(119084, 'Chana', 41.9805603027344, 0.732698999114742, -89.2197189331055, -1.55717785308661, 218, 18, 'PPL', 'P'),
(1481, 'Chana Creek', 32.6208305358887, 0.569340897586364, -85.9883270263672, -1.50077942489173, 218, 2, 'PPL', 'P'),
(1482, 'Chance', 31.7486095428467, 0.554117769452766, -87.5319366455078, -1.52772049511119, 218, 2, 'PPL', 'P'),
(35207, 'Chance', 36.9752807617188, 0.645340391141309, -85.3247222900391, -1.48919733731098, 218, 21, 'PPL', 'P'),
(45592, 'Chance', 38.1719398498535, 0.666226032253174, -75.9413909912109, -1.32542731134099, 218, 25, 'PPL', 'P'),
(75401, 'Chance', 36.0602798461914, 0.629370612506594, -94.6549987792969, -1.65204138216994, 218, 42, 'PPL', 'P'),
(100678, 'Chance', 38.0569381713867, 0.664218874318608, -77.0086135864258, -1.34405385947917, 218, 53, 'PPL', 'P'),
(193055, 'Chance', 38.4372215270996, 0.670856070966331, -106.849166870117, -1.86486976489639, 218, 7, 'PPL', 'P'),
(196193, 'Chance', 45.0119400024414, 0.785606555752747, -109.0625, -1.90349971545632, 218, 31, 'PPL', 'P'),
(201997, 'Chance', 45.4099998474121, 0.792554010667464, -102.280830383301, -1.78513725186245, 218, 49, 'PPL', 'P'),
(8030, 'Chancel', 35.752498626709, 0.623998816850823, -93.1449966430664, -1.62568687318057, 218, 4, 'PPL', 'P'),
(1483, 'Chancellor', 31.1813907623291, 0.544217934153587, -85.8772201538086, -1.49884024414399, 218, 2, 'PPL', 'P'),
(58963, 'Chancellor', 32.0102806091309, 0.55868479111663, -88.6297225952148, -1.54688047441571, 218, 30, 'PPL', 'P'),
(100679, 'Chancellor', 38.2838897705078, 0.668179926965938, -77.6013870239258, -1.35439970768191, 218, 53, 'PPL', 'P'),
(170005, 'Chancellor', 43.3722190856934, 0.756988026941674, -96.9866714477539, -1.69273674731328, 218, 49, 'PPL', 'P'),
(191254, 'Chancellor', 30.6924991607666, 0.535685166020974, -103.173606872559, -1.8007191410844, 218, 51, 'PPL', 'P'),
(1484, 'Chancellor Crossroads', 33.2963905334473, 0.581131643838526, -86.3997192382813, -1.5079595735067, 218, 2, 'PPL', 'P'),
(100681, 'Chancellorsville', 38.3083305358887, 0.668606498793541, -77.6347198486328, -1.35498147522204, 218, 53, 'PPL', 'P'),
(1485, 'Chances Crossroad', 34.1741714477539, 0.596451810904343, -87.0586090087891, -1.51945936940977, 218, 2, 'PPL', 'P'),
(93181, 'Chances Store', 30.5209999084473, 0.532691939403293, -96.3906402587891, -1.68233404062127, 218, 51, 'PPL', 'P'),
(100682, 'Chancetown', 37.6322212219238, 0.656806165161455, -75.7008285522461, -1.32122870472443, 218, 53, 'PPL', 'P'),
(15487, 'Chancey', 30.2402801513672, 0.527792455366847, -83.2605590820313, -1.45317089303271, 218, 12, 'PPL', 'P'),
(85700, 'Chanceytown', 35.0530586242676, 0.611791285888063, -84.3838882446289, -1.47277668550371, 218, 50, 'PPL', 'P'),
(58964, 'Chancy', 34.1208305358887, 0.595520836366279, -90.2811126708984, -1.57570266847115, 218, 30, 'PPL', 'P'),
(211726, 'Chandalar', 67.5052795410156, 1.17818939046989, -148.493606567383, -2.59170235276191, 218, 1, 'PPL', 'P'),
(656, 'Chandler', 39.3002815246582, 0.685919309565983, -94.3824996948242, -1.64728537593723, 218, 29, 'PPL', 'P'),
(8031, 'Chandler', 34.4636116027832, 0.601503494597087, -93.2636108398438, -1.62775708145395, 218, 4, 'PPL', 'P'),
(29454, 'Chandler', 38.4213905334473, 0.670579768003235, -87.3522186279297, -1.5245838239793, 218, 19, 'PPL', 'P'),
(75403, 'Chandler', 35.7016716003418, 0.623111717891717, -96.8805618286133, -1.69088478509124, 218, 42, 'PPL', 'P'),
(80251, 'Chandler', 32.9044418334961, 0.574290848525467, -79.7358322143555, -1.39165280395826, 218, 48, 'PPL', 'P'),
(85701, 'Chandler', 35.8380584716797, 0.625492117853058, -83.9841690063477, -1.46580026871214, 218, 50, 'PPL', 'P'),
(93182, 'Chandler', 32.3077812194824, 0.563877156293957, -95.4797210693359, -1.66643550154571, 218, 51, 'PPL', 'P'),
(130153, 'Chandler', 45.8699989318848, 0.800582509247671, -87.1558303833008, -1.52115620249831, 218, 27, 'PPL', 'P'),
(134631, 'Chandler', 43.9291687011719, 0.76670863149949, -95.9469375610352, -1.67458996764548, 218, 28, 'PPL', 'P'),
(154678, 'Chandler', 40.3077812194824, 0.703503496453503, -80.804443359375, -1.41030358686236, 218, 41, 'PPL', 'P'),
(177901, 'Chandler', 33.3061103820801, 0.581301287199964, -111.840560913086, -1.95198602521063, 218, 5, 'PPL', 'P'),
(180655, 'Chandler (historical)', 38.9147186279297, 0.679189967544543, -121.621391296387, -2.12269371897832, 218, 6, 'PPL', 'P'),
(186525, 'Chandler (historical)', 38.3730583190918, 0.669736211727953, -105.199996948242, -1.83608631983481, 218, 7, 'PPL', 'P'),
(19932, 'Chandler Acres', 33.3972206115723, 0.58289146068685, -84.4533309936523, -1.47398869011581, 218, 13, 'PPL', 'P'),
(127083, 'Chandler Cove Landing', 43.7158317565918, 0.762985199400423, -70.1266708374023, -1.22394129957496, 218, 26, 'PPL', 'P'),
(100683, 'Chandler Crossing', 37.8958282470703, 0.661406975681648, -77.4644393920898, -1.35200952060356, 218, 53, 'PPL', 'P'),
(177902, 'Chandler Gardens Mobile Home Park', 33.310001373291, 0.581369197807761, -111.832778930664, -1.95185020399503, 218, 5, 'PPL', 'P'),
(177903, 'Chandler Heights', 33.2119407653809, 0.579657717333222, -111.685562133789, -1.94928078617532, 218, 5, 'PPL', 'P'),
(124478, 'Chandler Hill', 42.273609161377, 0.737813666567267, -71.7916717529297, -1.25300104759963, 218, 23, 'PPL', 'P'),
(80252, 'Chandler Lakes', 32.9941711425781, 0.575856920404488, -80.148063659668, -1.39884759995922, 218, 48, 'PPL', 'P'),
(177904, 'Chandler Meadows Mobile Home Park', 33.3177795410156, 0.581504952444328, -111.833892822266, -1.95186964507099, 218, 5, 'PPL', 'P'),
(1487, 'Chandler Mountain', 33.9416694641113, 0.592393885772362, -86.254997253418, -1.50543369837081, 218, 2, 'PPL', 'P'),
(1488, 'Chandler Springs', 33.3305587768555, 0.581727992185622, -85.9983291625977, -1.50095399510119, 218, 2, 'PPL', 'P'),
(80253, 'Chandler Village', 32.978328704834, 0.57558041770431, -80.147216796875, -1.39883281941517, 218, 48, 'PPL', 'P'),
(80254, 'Chandlers', 33.6800003051758, 0.587826897398012, -79.4888916015625, -1.38734287720813, 218, 48, 'PPL', 'P'),
(35208, 'Chandlers Chapel', 36.9491691589355, 0.644884657699769, -86.7930603027344, -1.5148246701647, 218, 21, 'PPL', 'P'),
(100684, 'Chandlers Forks', 37.019718170166, 0.646115970229767, -78.7002792358398, -1.37357899490433, 218, 53, 'PPL', 'P'),
(143608, 'Chandlers Mills', 43.3580589294434, 0.756740885592514, -72.2483291625977, -1.26097122295197, 218, 36, 'PPL', 'P'),
(159969, 'Chandlers Valley', 41.9341697692871, 0.731889331564331, -79.3038864135742, -1.38411392754447, 218, 45, 'PPL', 'P'),
(72068, 'Chandlersville', 39.8983306884766, 0.696357236563412, -81.8274993896484, -1.42815928302302, 218, 41, 'PPL', 'P'),
(35209, 'Chandlerville', 37.9347190856934, 0.662085748864482, -82.813606262207, -1.44537009472571, 218, 21, 'PPL', 'P'),
(119085, 'Chandlerville', 40.0480613708496, 0.69897052996208, -90.1549987792969, -1.5735015658302, 218, 18, 'PPL', 'P'),
(180656, 'Chandon (historical)', 39.3144416809082, 0.686166450915142, -121.661109924316, -2.12338693981007, 218, 6, 'PPL', 'P'),
(45593, 'Chaney', 38.7513885498047, 0.676339319913722, -76.6350021362305, -1.33753310955011, 218, 25, 'PPL', 'P'),
(75408, 'Chaney', 36.4791717529297, 0.636681655489134, -99.8483276367188, -1.74268206987079, 218, 42, 'PPL', 'P'),
(93183, 'Chaney', 32.3650016784668, 0.564875841702737, -98.6202774047852, -1.72124854994367, 218, 51, 'PPL', 'P'),
(114942, 'Chaney', 41.7947196960449, 0.729455468644108, -90.2844390869141, -1.57576072538291, 218, 16, 'PPL', 'P'),
(177905, 'Chaney Place', 32.4833297729492, 0.566941056549066, -109.346672058105, -1.90845945351242, 218, 5, 'PPL', 'P'),
(180657, 'Chaney Ranch', 36.6558303833008, 0.639764930241174, -120.578056335449, -2.1044840887088, 218, 6, 'PPL', 'P'),
(45594, 'Chaney Station', 38.7541694641113, 0.676387856024589, -76.6399993896484, -1.33762032807581, 218, 25, 'PPL', 'P'),
(100685, 'Chaneys Store', 36.8422203063965, 0.643018048091733, -79.1183319091797, -1.38087539050088, 218, 53, 'PPL', 'P'),
(78006, 'Chaneysville', 39.8236083984375, 0.6950530865776, -78.4894409179688, -1.36989917206812, 218, 45, 'PPL', 'P'),
(45595, 'Chaneyville', 38.6916694641113, 0.675297025242093, -76.6402816772461, -1.33762525492383, 218, 25, 'PPL', 'P'),
(72067, 'Chaneyville (historical)', 39.624439239502, 0.691576928985747, -81.9127807617188, -1.42964772375626, 218, 41, 'PPL', 'P'),
(45596, 'Chaneyville Farm Estates', 38.6902809143066, 0.675272790476173, -76.6666717529297, -1.33808584863436, 218, 25, 'PPL', 'P'),
(144967, 'Changewater', 40.7380599975586, 0.711013277832391, -74.9444427490234, -1.30802728204285, 218, 37, 'PPL', 'P'),
(134633, 'Chanhassen', 44.8622207641602, 0.782993462091161, -93.5305633544922, -1.63241628178104, 218, 28, 'PPL', 'P'),
(211727, 'Chaniliut', 63.0411109924316, 1.10027495093312, -163.393325805664, -2.85175151109265, 218, 1, 'PPL', 'P'),
(119087, 'Channahon', 41.4294395446777, 0.723080127310567, -88.2286071777344, -1.53987968970017, 218, 18, 'PPL', 'P'),
(53990, 'Channel', 36.0597190856934, 0.629360825389588, -89.9408264160156, -1.56976355292416, 218, 29, 'PPL', 'P'),
(180658, 'Channel Islands Beach', 34.1580581665039, 0.596170581093231, -119.222221374512, -2.08082030452679, 218, 6, 'PPL', 'P'),
(119089, 'Channel Lake', 42.4786109924316, 0.741391623491788, -88.1374969482422, -1.53828951621328, 218, 18, 'PPL', 'P'),
(93184, 'Channel Lots Colonia', 26.3439998626709, 0.459789535748541, -97.4229965209961, -1.70035205645036, 218, 51, 'PPL', 'P'),
(93185, 'Channelview', 29.7758293151855, 0.519686259061836, -95.1144409179688, -1.66006016021217, 218, 51, 'PPL', 'P'),
(93186, 'Channey Crossing', 30.7202796936035, 0.536170027786936, -96.1675033569336, -1.67843956700119, 218, 51, 'PPL', 'P'),
(13518, 'Channin', 39.8311080932617, 0.695183980945178, -75.5097198486328, -1.31789322861716, 218, 10, 'PPL', 'P'),
(130156, 'Channing', 46.1416702270508, 0.805324067831476, -88.0938873291016, -1.53752838477374, 218, 27, 'PPL', 'P'),
(186526, 'Channing', 38.1436080932617, 0.665731549817773, -102.548889160156, -1.78981576010745, 218, 7, 'PPL', 'P'),
(191255, 'Channing', 35.6836090087891, 0.622796466197679, -102.329719543457, -1.78599052867571, 218, 51, 'PPL', 'P'),
(201999, 'Channing (historical)', 44.2416687011719, 0.772162785411972, -103.516670227051, -1.80670672616322, 218, 49, 'PPL', 'P'),
(8032, 'Chant (historical)', 34.7472190856934, 0.606453378957163, -94.0755615234375, -1.64192829424648, 218, 4, 'PPL', 'P'),
(85703, 'Chantay Acres', 35.6405601501465, 0.622045121875141, -87.0219421386719, -1.51881941179982, 218, 50, 'PPL', 'P'),
(63605, 'Chanteloupe Country Estates', 35.2919387817383, 0.615960531153609, -82.4588928222656, -1.43917917729765, 218, 33, 'PPL', 'P'),
(8033, 'Chanticleer', 33.3008308410645, 0.581209141826247, -91.279167175293, -1.59312200568719, 218, 4, 'PPL', 'P'),
(15488, 'Chanticleer', 30.3208293914795, 0.529198304816786, -87.3952789306641, -1.52533536803892, 218, 12, 'PPL', 'P'),
(19933, 'Chanticleer', 33.4230613708496, 0.583342467017455, -84.4361114501953, -1.47368815238679, 218, 13, 'PPL', 'P'),
(63606, 'Chantilly', 36.3016700744629, 0.633583666772073, -76.1711120605469, -1.32943670036211, 218, 33, 'PPL', 'P'),
(100686, 'Chantilly', 38.8941688537598, 0.678831306324737, -77.4313888549805, -1.35143267991145, 218, 53, 'PPL', 'P'),
(53991, 'Chantilly (historical)', 38.9980583190918, 0.680644519552917, -90.8430633544922, -1.58551055813369, 218, 29, 'PPL', 'P'),
(15489, 'Chantilly Acres', 29.7138900756836, 0.518605215396346, -82.4180603027344, -1.43846651538995, 218, 12, 'PPL', 'P'),
(45597, 'Chantilly Manor', 39.6591682434082, 0.692183064449849, -75.9913864135742, -1.32629989607216, 218, 25, 'PPL', 'P'),
(32033, 'Chanute', 37.6791687011719, 0.657625553249845, -95.4569396972656, -1.66603789159496, 218, 20, 'PPL', 'P'),
(85702, 'Chanute', 36.6058311462402, 0.638892278930982, -85.0597229003906, -1.48457222544584, 218, 50, 'PPL', 'P'),
(53992, 'Chaonia (historical)', 36.9819412231445, 0.645456638122891, -90.3511123657227, -1.57692439362122, 218, 29, 'PPL', 'P'),
(100687, 'Chap', 37.2544403076172, 0.650212644355609, -78.831672668457, -1.375872242919, 218, 53, 'PPL', 'P'),
(93187, 'Chapa Colonia Number 3', 26.2329998016357, 0.457852219213563, -98.0029983520508, -1.71047499806986, 218, 51, 'PPL', 'P'),
(93188, 'Chapa North Colonia', 26.238000869751, 0.45793950431829, -97.9629974365234, -1.7097768503901, 218, 51, 'PPL', 'P'),
(93189, 'Chapa Number 1 Colonia', 26.181999206543, 0.456962090908718, -98.0199966430664, -1.7107716742153, 218, 51, 'PPL', 'P'),
(93190, 'Chapa South Colonia', 26.2339992523193, 0.457869662918703, -97.9629974365234, -1.7097768503901, 218, 51, 'PPL', 'P'),
(63608, 'Chapanoke', 36.2538909912109, 0.632749764455741, -76.3777770996094, -1.33304368574251, 218, 33, 'PPL', 'P'),
(177906, 'Chaparral', 33.6433296203613, 0.587186873209039, -112.178886413574, -1.9578909191376, 218, 5, 'PPL', 'P'),
(180659, 'Chaparral Heights', 38.002498626709, 0.663268725020695, -120.250831604004, -2.09877293975112, 218, 6, 'PPL', 'P'),
(80256, 'Chaparral Ranches', 33.0811080932617, 0.57737425643556, -80.0961074829102, -1.39794079360805, 218, 48, 'PPL', 'P'),
(203360, 'Chaparral West', 40.6944389343262, 0.710251946655764, -112.087219238281, -1.95629102511274, 218, 52, 'PPL', 'P'),
(93191, 'Chaparrito Colonia', 26.3409996032715, 0.459737171343608, -98.7360000610352, -1.72326829131439, 218, 51, 'PPL', 'P'),
(188286, 'Chapatalito (historical)', 35.3463897705078, 0.616910880188604, -105.980560302734, -1.84970972039111, 218, 38, 'PPL', 'P'),
(108546, 'Chapel', 38.747501373291, 0.676271475884953, -80.8050003051758, -1.41031330740034, 218, 58, 'PPL', 'P'),
(139075, 'Chapel', 40.5405616760254, 0.707566281854474, -92.7294387817383, -1.61843402026785, 218, 29, 'PPL', 'P'),
(154679, 'Chapel', 41.7816696166992, 0.729227701791879, -80.8097229003906, -1.41039573223608, 218, 41, 'PPL', 'P'),
(159968, 'Chapel', 40.4361114501953, 0.705743281509287, -75.5458297729492, -1.31852346568912, 218, 45, 'PPL', 'P'),
(100688, 'Chapel Acres', 38.7413902282715, 0.676164816283295, -77.2455596923828, -1.3481893491779, 218, 53, 'PPL', 'P'),
(80257, 'Chapel Creek', 33.4749984741211, 0.584248940473491, -79.1388931274414, -1.38123425145776, 218, 48, 'PPL', 'P'),
(80261, 'Chapel Creek Villas', 33.4655609130859, 0.58408422396007, -79.1447219848633, -1.38133598421141, 218, 48, 'PPL', 'P'),
(80258, 'Chapel Estates', 34.9213905334473, 0.609493244183434, -82.1811065673828, -1.43433089253317, 218, 48, 'PPL', 'P'),
(100689, 'Chapel Estates', 39.0969390869141, 0.682370314518316, -78.0149993896484, -1.36161860529073, 218, 53, 'PPL', 'P'),
(100692, 'Chapel Forest', 37.235279083252, 0.649878217901722, -79.9533309936523, -1.39544887377606, 218, 53, 'PPL', 'P'),
(45598, 'Chapel Heights', 39.5466690063477, 0.690219582357161, -77.0238876342773, -1.34432044190429, 218, 25, 'PPL', 'P'),
(19934, 'Chapel Heights Estates', 33.5436096191406, 0.585446430857645, -85.0708312988281, -1.48476610357319, 218, 13, 'PPL', 'P'),
(1494, 'Chapel Hill', 31.6933307647705, 0.553152972768858, -88.4402770996094, -1.54357402676432, 218, 2, 'PPL', 'P'),
(13519, 'Chapel Hill', 39.7013893127441, 0.692919961123474, -75.7313919067383, -1.32176213589077, 218, 10, 'PPL', 'P'),
(15500, 'Chapel Hill', 26.4977798461914, 0.462473502784637, -80.0744400024414, -1.39756262473326, 218, 12, 'PPL', 'P'),
(19936, 'Chapel Hill', 33.6861114501953, 0.58793355699967, -84.7158279418945, -1.47857012613907, 218, 13, 'PPL', 'P'),
(29456, 'Chapel Hill', 38.9983291625977, 0.680649246663852, -86.4491729736328, -1.50882270401599, 218, 19, 'PPL', 'P'),
(35210, 'Chapel Hill', 36.7197189331055, 0.64087999578959, -86.2927780151367, -1.50609309705671, 218, 21, 'PPL', 'P'),
(45601, 'Chapel Hill', 38.723331451416, 0.675849631168284, -76.982780456543, -1.34360298630662, 218, 25, 'PPL', 'P'),
(53994, 'Chapel Hill', 38.9174995422363, 0.67923850365541, -94.0580596923828, -1.64162282966944, 218, 29, 'PPL', 'P'),
(58966, 'Chapel Hill', 32.1141700744629, 0.56049800434481, -90.5136108398438, -1.5797605270241, 218, 30, 'PPL', 'P'),
(63610, 'Chapel Hill', 35.9130592346191, 0.626801128107859, -79.0561065673828, -1.37978935340834, 218, 33, 'PPL', 'P'),
(72070, 'Chapel Hill', 39.6236114501953, 0.691562481336833, -82.0536117553711, -1.43210568828435, 218, 41, 'PPL', 'P'),
(85706, 'Chapel Hill', 35.6336097717285, 0.621923814887488, -87.2516708374023, -1.52282893397899, 218, 50, 'PPL', 'P'),
(93192, 'Chapel Hill', 32.3111114501953, 0.563935279784748, -95.1916732788086, -1.66140811919792, 218, 51, 'PPL', 'P'),
(100690, 'Chapel Hill', 38.8191719055176, 0.677522362648963, -77.0880584716797, -1.34544043430072, 218, 53, 'PPL', 'P'),
(112225, 'Chapel Hill', 33.9952812194824, 0.593329587421361, -93.8652801513672, -1.63825819194824, 218, 4, 'PPL', 'P'),
(144968, 'Chapel Hill', 40.3972206115723, 0.705064508326453, -74.0708312988281, -1.29277988585382, 218, 37, 'PPL', 'P'),
(58967, 'Chapel Hill (historical)', 33.2622184753418, 0.580535228912403, -89.4680633544922, -1.56151228091877, 218, 30, 'PPL', 'P'),
(80259, 'Chapel Hill (historical)', 33.3463897705078, 0.582004295148718, -80.1097183227539, -1.39817834757729, 218, 48, 'PPL', 'P'),
(114943, 'Chapel Hill (historical)', 41.4922218322754, 0.72417588494108, -90.647216796875, -1.58209239087458, 218, 16, 'PPL', 'P'),
(45602, 'Chapel Hills', 39.5588912963867, 0.690432901560476, -76.1705627441406, -1.32942711298218, 218, 25, 'PPL', 'P'),
(100691, 'Chapel Hills', 38.0680618286133, 0.664413018762075, -78.4766693115234, -1.36967626548488, 218, 53, 'PPL', 'P'),
(45603, 'Chapel Knoll', 38.8569412231445, 0.678181561597785, -76.5749969482422, -1.33648582145144, 218, 25, 'PPL', 'P'),
(58968, 'Chapel Landing', 32.9388885498047, 0.574892057141552, -90.7869415283203, -1.58453104748476, 218, 30, 'PPL', 'P'),
(45604, 'Chapel Manor', 39.4069404602051, 0.687780859167948, -76.4638900756836, -1.33454664070369, 218, 25, 'PPL', 'P'),
(122358, 'Chapel Manor', 41.4761085510254, 0.723894655129968, -87.331672668457, -1.52422522933852, 218, 19, 'PPL', 'P'),
(19938, 'Chapel Mill', 33.6805610656738, 0.587836684515018, -84.2202835083008, -1.46992124418293, 218, 13, 'PPL', 'P'),
(45605, 'Chapel Oaks', 38.9080581665039, 0.679073720562961, -76.9180603027344, -1.34247340653026, 218, 25, 'PPL', 'P'),
(45606, 'Chapel Point', 38.4636116027832, 0.67131666467686, -77.029167175293, -1.344412587278, 218, 25, 'PPL', 'P'),
(45607, 'Chapel Point Woods', 38.4680595397949, 0.671394295822636, -76.9947204589844, -1.34381137866192, 218, 25, 'PPL', 'P'),
(45608, 'Chapel Ridge', 39.4463882446289, 0.688469352888761, -76.6686096191406, -1.3381196707802, 218, 25, 'PPL', 'P'),
(173502, 'Chapel Ridge', 44.5316696166992, 0.777224256221723, -87.9044418334961, -1.53422193712235, 218, 57, 'PPL', 'P'),
(45609, 'Chapel Station', 38.8661117553711, 0.678341617579298, -76.0124969482422, -1.32666834440897, 218, 25, 'PPL', 'P'),
(45610, 'Chapel Valley', 39.4105606079102, 0.68784404266481, -76.4638900756836, -1.33454664070369, 218, 25, 'PPL', 'P'),
(78007, 'Chapel View', 39.9230613708496, 0.696788868397087, -76.6324996948242, -1.33748943370823, 218, 45, 'PPL', 'P'),
(100693, 'Chapel Village', 37.0372200012207, 0.646421434806799, -76.3813934326172, -1.33310680266034, 218, 53, 'PPL', 'P'),
(45612, 'Chapel Woods', 38.8630599975586, 0.678288354357497, -75.9749984741211, -1.32601387257108, 218, 25, 'PPL', 'P'),
(45614, 'Chapelgate', 39.4524993896484, 0.688576012490419, -76.6627807617188, -1.33801793802656, 218, 25, 'PPL', 'P'),
(188287, 'Chapelle', 35.3891716003418, 0.617657563979235, -105.293060302734, -1.83771058178365, 218, 38, 'PPL', 'P'),
(13528, 'Chapeltown', 39.0997200012207, 0.682418850629183, -75.6972198486328, -1.32116572096465, 218, 10, 'PPL', 'P'),
(58969, 'Chapeltown', 34.2616691589355, 0.597978934052422, -90.0283279418945, -1.57129074265127, 218, 30, 'PPL', 'P'),
(45615, 'Chapelview', 39.2727813720703, 0.685439341358523, -76.8083267211914, -1.34055819423233, 218, 25, 'PPL', 'P'),
(58970, 'Chapelville', 34.439998626709, 0.601091370418397, -88.5908279418945, -1.54620163465385, 218, 30, 'PPL', 'P'),
(188288, 'Chaperito', 35.3658294677734, 0.61725016691148, -104.944717407227, -1.83163085133111, 218, 38, 'PPL', 'P'),
(26758, 'Chapin', 39.7658309936523, 0.694044680630842, -90.3988876342773, -1.57775822935853, 218, 18, 'PPL', 'P'),
(53996, 'Chapin', 36.690559387207, 0.640371065705276, -91.7713928222656, -1.60171296388963, 218, 29, 'PPL', 'P'),
(80260, 'Chapin', 34.165828704834, 0.596306202571743, -81.3499984741211, -1.41982531986578, 218, 48, 'PPL', 'P'),
(93193, 'Chapin', 32.5377807617188, 0.567891405584061, -97.6752777099609, -1.70475519383865, 218, 51, 'PPL', 'P'),
(100694, 'Chapin', 38.148609161377, 0.665818834922501, -79.2774963378906, -1.38365333383394, 218, 53, 'PPL', 'P'),
(114944, 'Chapin', 42.833610534668, 0.747587534346885, -93.2219390869141, -1.62702977216025, 218, 16, 'PPL', 'P'),
(130157, 'Chapin', 43.1322212219238, 0.752799274021143, -84.3047180175781, -1.47139490437213, 218, 27, 'PPL', 'P'),
(147717, 'Chapin', 42.9186096191406, 0.749071048232113, -77.2350006103516, -1.34800505843046, 218, 40, 'PPL', 'P'),
(194718, 'Chapin', 43.6433296203613, 0.761719798408472, -111.110000610352, -1.93923534254354, 218, 17, 'PPL', 'P'),
(124479, 'Chapinville', 42.3369407653809, 0.738919011577704, -71.625, -1.25009207674094, 218, 23, 'PPL', 'P'),
(147718, 'Chapinville', 42.7350006103516, 0.745866466492421, -75.1827774047852, -1.3121870065075, 218, 40, 'PPL', 'P'),
(45616, 'Chaple', 38.8447189331055, 0.677968242394469, -76.0205612182617, -1.32680909247258, 218, 25, 'PPL', 'P'),
(13520, 'Chaplecroft', 39.1208305358887, 0.682787298965995, -75.5388870239258, -1.31840229185953, 218, 10, 'PPL', 'P'),
(518, 'Chaplin', 37.8977813720703, 0.661441064143601, -85.2213897705078, -1.48739384462078, 218, 21, 'PPL', 'P'),
(177591, 'Chaplin', 41.7947196960449, 0.729455468644108, -72.1277770996094, -1.25886719253275, 218, 8, 'PPL', 'P'),
(8036, 'Chaplin (historical)', 36.2452812194824, 0.632599495591234, -93.6344375610352, -1.63422922869311, 218, 4, 'PPL', 'P'),
(1496, 'Chapman', 31.6711101531982, 0.552765149935115, -86.7122192382813, -1.51341372741918, 218, 2, 'PPL', 'P'),
(8035, 'Chapman', 36.2188911437988, 0.632138901880705, -93.0805587768555, -1.62456222025223, 218, 4, 'PPL', 'P'),
(15490, 'Chapman', 28.1091709136963, 0.490597582449823, -82.4602813720703, -1.43920341206357, 218, 12, 'PPL', 'P'),
(19939, 'Chapman', 34.3694381713867, 0.599859858151317, -83.8455581665039, -1.46338105317791, 218, 13, 'PPL', 'P'),
(26760, 'Chapman', 39.1055603027344, 0.682520783119905, -89.3169403076172, -1.55887468617516, 218, 18, 'PPL', 'P'),
(32035, 'Chapman', 38.9722213745117, 0.68019357980134, -97.022216796875, -1.69335713068922, 218, 20, 'PPL', 'P'),
(35212, 'Chapman', 38.023609161377, 0.663637173357508, -82.623893737793, -1.44205898654241, 218, 21, 'PPL', 'P'),
(72069, 'Chapman', 39.089168548584, 0.682234693039804, -82.6183319091797, -1.44196191432068, 218, 41, 'PPL', 'P'),
(93194, 'Chapman', 32.1497192382813, 0.561118454299771, -94.633056640625, -1.65165841960519, 218, 51, 'PPL', 'P'),
(108545, 'Chapman', 38.5449981689453, 0.672737128223281, -80.4608306884766, -1.40430641440361, 218, 58, 'PPL', 'P'),
(127084, 'Chapman', 46.6480598449707, 0.814162233962094, -68.1613922119141, -1.18964071684112, 218, 26, 'PPL', 'P'),
(141477, 'Chapman', 41.024169921875, 0.716006838034344, -98.1588897705078, -1.71319581659754, 218, 35, 'PPL', 'P'),
(159972, 'Chapman', 40.6872215270996, 0.710125979136203, -76.8869400024414, -1.34193025482594, 218, 45, 'PPL', 'P'),
(180661, 'Chapman', 37.9188919067383, 0.661809512480414, -122.515830993652, -2.13830463665615, 218, 6, 'PPL', 'P'),
(196194, 'Chapman', 48.8686103820801, 0.852918152041582, -108.132499694824, -1.88726814808645, 218, 31, 'PPL', 'P'),
(200553, 'Chapman', 45.8252792358398, 0.799802003311196, -122.984169006348, -2.14647867698993, 218, 43, 'PPL', 'P'),
(19940, 'Chapman (historical)', 30.8888893127441, 0.539112820791474, -83.2477798461914, -1.45294785329142, 218, 13, 'PPL', 'P'),
(177592, 'Chapman (historical)', 41.2738914489746, 0.72036530089534, -72.4261093139648, -1.26407407193802, 218, 8, 'PPL', 'P'),
(177195, 'Chapman Addition', 40.2786102294922, 0.702994366632107, -80.561393737793, -1.40606157072003, 218, 58, 'PPL', 'P'),
(200554, 'Chapman Corner', 44.9605598449707, 0.78470980283469, -123.077781677246, -2.14811252631869, 218, 43, 'PPL', 'P'),
(919, 'Chapman Grove', 35.8216705322266, 0.625206094351983, -84.5805587768555, -1.47620923383272, 218, 50, 'PPL', 'P'),
(1498, 'Chapman Heights', 34.7536087036133, 0.60656489882781, -86.5688934326172, -1.51091222020727, 218, 2, 'PPL', 'P'),
(45617, 'Chapman Landing', 38.6213912963867, 0.674070439823029, -77.1194381713867, -1.34598811337889, 218, 25, 'PPL', 'P'),
(200555, 'Chapman Landing', 45.7461090087891, 0.798420222179609, -122.83943939209, -2.14395266869599, 218, 43, 'PPL', 'P'),
(188291, 'Chapman Place', 32.8908309936523, 0.574053294556232, -108.992218017578, -1.90227306345823, 218, 38, 'PPL', 'P'),
(93195, 'Chapman Ranch', 27.586109161377, 0.4814684326806, -97.4530563354492, -1.70087669918511, 218, 51, 'PPL', 'P'),
(85707, 'Chapmans', 35.1763916015625, 0.613943852418147, -87.0194396972656, -1.51877573595794, 218, 50, 'PPL', 'P'),
(80262, 'Chapmans Crossroads', 34.1194381713867, 0.595496535021332, -81.7988891601563, -1.42765994031863, 218, 48, 'PPL', 'P'),
(85708, 'Chapmansboro', 36.3122215270996, 0.633767824361452, -87.1413879394531, -1.52090413430113, 218, 50, 'PPL', 'P'),
(180662, 'Chapmantown', 39.7205581665039, 0.693254520735415, -121.815559387207, -2.12608259146545, 218, 6, 'PPL', 'P'),
(108547, 'Chapmanville', 37.9736099243164, 0.662764522047316, -82.0175018310547, -1.43147545121238, 218, 58, 'PPL', 'P'),
(159977, 'Chapmanville', 41.5930595397949, 0.725935834947459, -79.8383331298828, -1.39344178242052, 218, 45, 'PPL', 'P'),
(147719, 'Chappaqua', 41.1594390869141, 0.718367730340699, -73.7652816772461, -1.28744703892899, 218, 40, 'PPL', 'P'),
(124480, 'Chappaquiddick', 41.3872184753418, 0.722343230636942, -70.504997253418, -1.2305443411817, 218, 23, 'PPL', 'P'),
(124481, 'Chappaquoit', 41.6041717529297, 0.726129779653844, -70.6500015258789, -1.2330751431656, 218, 23, 'PPL', 'P'),
(188289, 'Chapparal', 32.0349998474121, 0.559116223213222, -106.417778015137, -1.85734060902057, 218, 38, 'PPL', 'P'),
(177907, 'Chapparal Mobile Village', 33.3783302307129, 0.582561761343898, -112.079437255859, -1.95615520389714, 218, 5, 'PPL', 'P'),
(19941, 'Chappel', 33.1777801513672, 0.57906150214418, -84.0975036621094, -1.4677783316118, 218, 13, 'PPL', 'P'),
(93196, 'Chappel', 31.0555591583252, 0.542021758360654, -98.570556640625, -1.72038075890247, 218, 51, 'PPL', 'P'),
(188290, 'Chappel', 32.1916694641113, 0.561850623862461, -107.184173583984, -1.87071673506966, 218, 38, 'PPL', 'P'),
(39731, 'Chappel (historical)', 30.7972202301025, 0.537512893477095, -92.1602783203125, -1.6085002962438, 218, 22, 'PPL', 'P'),
(35213, 'Chappell', 37.0108299255371, 0.64596084109627, -83.3499984741211, -1.45473190490566, 218, 21, 'PPL', 'P'),
(199225, 'Chappell', 41.0927810668945, 0.717204328418498, -102.470283508301, -1.78844383267189, 218, 35, 'PPL', 'P'),
(1497, 'Chappell Hill', 31.8916702270508, 0.556614649422284, -88.2555618286133, -1.54035013710673, 218, 2, 'PPL', 'P'),
(93197, 'Chappell Hill', 30.1424999237061, 0.52608586845081, -96.2566680908203, -1.67999578518418, 218, 51, 'PPL', 'P'),
(8038, 'Chappelle (historical)', 34.6994400024414, 0.605619476640832, -90.8744430541992, -1.58605823721187, 218, 4, 'PPL', 'P'),
(80263, 'Chappells', 34.1797218322754, 0.596548683388995, -81.866943359375, -1.4288477101648, 218, 48, 'PPL', 'P'),
(19942, 'Chappells Mill', 32.6613883972168, 0.570048765804107, -83.0527801513672, -1.44954446657635, 218, 13, 'PPL', 'P'),
(180663, 'Chappo', 33.2930603027344, 0.581073520347735, -117.361106872559, -2.04833772871109, 218, 6, 'PPL', 'P'),
(45618, 'Chaptico', 38.3675003051758, 0.669639206085247, -76.783332824707, -1.34012196844578, 218, 25, 'PPL', 'P'),
(173503, 'Chapultepee', 44.2230606079102, 0.771838012917037, -91.2811126708984, -1.59315596099109, 218, 57, 'PPL', 'P'),
(45619, 'Char-Nor Manor', 39.2386093139648, 0.6848429264324, -75.9855575561523, -1.32619816331851, 218, 25, 'PPL', 'P'),
(198114, 'Charbonneau', 47.853328704834, 0.835198143938467, -103.76277923584, -1.81100213868541, 218, 34, 'PPL', 'P'),
(200556, 'Charbonneau', 45.2874984741211, 0.790415958365321, -122.756942749023, -2.14251283065264, 218, 43, 'PPL', 'P'),
(45620, 'Charbonnet', 39.6177787780762, 0.691460682004165, -76.5175018310547, -1.33548234235269, 218, 25, 'PPL', 'P'),
(112570, 'Charco', 28.7402801513672, 0.501612516586932, -97.6152801513672, -1.70370803889803, 218, 51, 'PPL', 'P'),
(177908, 'Charco', 32.250560760498, 0.562878470885177, -112.605278015137, -1.96533285648772, 218, 5, 'PPL', 'P'),
(70643, 'Charcoal Landing', 39.6416702270508, 0.691877666451844, -74.5122222900391, -1.30048361193909, 218, 37, 'PPL', 'P'),
(207010, 'Chard', 46.5380592346191, 0.812242361132256, -117.855827331543, -2.05697222959735, 218, 56, 'PPL', 'P'),
(154681, 'Chardon', 41.6141700744629, 0.726304283284271, -81.149169921875, -1.41632020039707, 218, 41, 'PPL', 'P'),
(187615, 'Chardon', 39.6547203063965, 0.692105433304073, -101.056671142578, -1.76377164254313, 218, 20, 'PPL', 'P'),
(154682, 'Chardon Centre (historical)', 41.6041717529297, 0.726129779653844, -81.2427825927734, -1.41795404972583, 218, 41, 'PPL', 'P'),
(39732, 'Charenton', 29.8813896179199, 0.521528633903953, -91.5250015258789, -1.59741262451942, 218, 22, 'PPL', 'P'),
(154684, 'Chargin Harbor Beach', 41.6772193908691, 0.727404701446692, -81.4327774047852, -1.42127008475714, 218, 41, 'PPL', 'P'),
(19943, 'Charing', 32.4613914489746, 0.56655816056334, -84.3616714477539, -1.472388929249, 218, 13, 'PPL', 'P'),
(45621, 'Charing Cross', 39.0141716003418, 0.68092574936403, -76.682502746582, -1.33836215159745, 218, 25, 'PPL', 'P'),
(130159, 'Charing Cross', 42.5716705322266, 0.7430158188616, -83.2213897705078, -1.45248725958089, 218, 27, 'PPL', 'P'),
(211728, 'Chariot', 68.105827331543, 1.18867092673017, -165.742782592773, -2.89275726766104, 218, 1, 'PPL', 'P'),
(114945, 'Chariton', 41.0138893127441, 0.7158274075559, -93.3063888549805, -1.62850369866555, 218, 16, 'PPL', 'P'),
(139076, 'Chariton', 40.5702781677246, 0.708084932476767, -92.7811126708984, -1.61933589977101, 218, 29, 'PPL', 'P'),
(54003, 'Charity', 37.5152816772461, 0.654765185081045, -93.01611328125, -1.62343743416584, 218, 29, 'PPL', 'P'),
(63613, 'Charity', 34.8227806091309, 0.60777217632897, -77.9461135864258, -1.36041632121662, 218, 33, 'PPL', 'P'),
(80264, 'Charity', 33.0058288574219, 0.57606038591177, -79.8499984741211, -1.39364538108586, 218, 48, 'PPL', 'P'),
(100695, 'Charity', 36.8197212219238, 0.642625364989001, -80.2186126708984, -1.40007891248922, 218, 53, 'PPL', 'P'),
(8037, 'Charity (historical)', 34.7347183227539, 0.606235199484858, -92.1677780151367, -1.60863119061138, 218, 4, 'PPL', 'P'),
(85710, 'Charity Hill', 36.3291702270508, 0.634063634979532, -82.179443359375, -1.43430186407728, 218, 50, 'PPL', 'P'),
(54004, 'Charlack', 38.7024993896484, 0.675486043100461, -90.3433303833008, -1.57678857240563, 218, 29, 'PPL', 'P'),
(29457, 'Charle Sumac Estates', 39.6786117553711, 0.692522417751752, -85.9744415283203, -1.50053707723254, 218, 19, 'PPL', 'P'),
(100696, 'Charlemont', 37.4669418334961, 0.653921495647708, -79.4052810668945, -1.38588359808883, 218, 53, 'PPL', 'P'),
(124482, 'Charlemont', 42.6277809143066, 0.74399512977345, -72.8702774047852, -1.27182626755513, 218, 23, 'PPL', 'P'),
(45622, 'Charlene', 39.1763916015625, 0.68375702249792, -77.1877822875977, -1.34718094323114, 218, 25, 'PPL', 'P'),
(159981, 'Charleroi', 40.1377792358398, 0.700536402104019, -79.8983306884766, -1.39448893736114, 218, 45, 'PPL', 'P'),
(1499, 'Charles', 32.3216705322266, 0.564119570532182, -88.2858276367188, -1.54087837510895, 218, 2, 'PPL', 'P'),
(19945, 'Charles', 32.2216682434082, 0.562374201332771, -82.4288864135742, -1.43865546666929, 218, 13, 'PPL', 'P'),
(63614, 'Charles', 35.913890838623, 0.6268156423358, -80.8722229003906, -1.41148656301857, 218, 33, 'PPL', 'P'),
(130160, 'Charles', 46.0144386291504, 0.80310345753554, -84.692497253418, -1.4781629288084, 218, 27, 'PPL', 'P'),
(127086, 'Charles Chase Corner', 43.2941703796387, 0.755625820044098, -70.5894393920898, -1.23201813452895, 218, 26, 'PPL', 'P'),
(100697, 'Charles City', 37.3433303833008, 0.651764068848635, -77.0733337402344, -1.34518343925553, 218, 53, 'PPL', 'P'),
(114949, 'Charles City', 43.0663909912109, 0.751650319747855, -92.6722183227539, -1.61743533485907, 218, 16, 'PPL', 'P'),
(100699, 'Charles Corner', 37.25, 0.650135146367888, -76.6194381713867, -1.33726146711892, 218, 53, 'PPL', 'P'),
(45623, 'Charles County Gardens', 38.5869407653809, 0.673469164627917, -76.866943359375, -1.34158124756508, 218, 25, 'PPL', 'P'),
(45625, 'Charles Manor', 39.5283317565918, 0.689899536973161, -76.4530563354492, -1.3343575562663, 218, 25, 'PPL', 'P'),
(154686, 'Charles Mill', 40.7341690063477, 0.710945367224594, -82.3633270263672, -1.43751123950694, 218, 41, 'PPL', 'P'),
(124484, 'Charles River Grove', 42.0916709899902, 0.734638246441511, -71.4736099243164, -1.24744982146542, 218, 23, 'PPL', 'P'),
(124485, 'Charles River Station', 42.2622184753418, 0.737614861591892, -71.2630615234375, -1.24377505863527, 218, 23, 'PPL', 'P'),
(124486, 'Charles River Village', 42.2605590820313, 0.737585899715038, -71.2616729736328, -1.24375082386935, 218, 23, 'PPL', 'P'),
(108548, 'Charles Town', 39.288890838623, 0.685720504590608, -77.8600006103516, -1.35891336625543, 218, 58, 'PPL', 'P'),
(80265, 'Charles Towne Village', 32.7880592346191, 0.572259588983036, -79.9897232055664, -1.39608403769605, 218, 48, 'PPL', 'P'),
(45643, 'Charles Village', 39.3230590820313, 0.686316852937704, -76.6136093139648, -1.33715973436528, 218, 25, 'PPL', 'P'),
(173504, 'Charlesburg', 43.9697189331055, 0.767416366559179, -88.1699981689453, -1.53885676952547, 218, 57, 'PPL', 'P'),
(29460, 'Charlesmac Village', 39.6841697692871, 0.692619423394459, -85.9791717529297, -1.50061963522633, 218, 19, 'PPL', 'P'),
(45626, 'Charlesmont', 39.2755584716797, 0.685487810890363, -76.4816665649414, -1.33485689897069, 218, 25, 'PPL', 'P'),
(63615, 'Charlesmont', 35.9341697692871, 0.627169576444671, -81.5127792358398, -1.42266638011667, 218, 33, 'PPL', 'P'),
(8039, 'Charleston', 35.2969398498535, 0.616047816258337, -94.0361099243164, -1.64123973394664, 218, 4, 'PPL', 'P'),
(26761, 'Charleston', 39.4961090087891, 0.689337143929963, -88.1761093139648, -1.53896342912713, 218, 18, 'PPL', 'P'),
(35214, 'Charleston', 37.2247200012207, 0.649693927154289, -87.6719436645508, -1.53016407856939, 218, 21, 'PPL', 'P'),
(54005, 'Charleston', 36.9208297729492, 0.644390042106314, -89.3505630493164, -1.55946151372136, 218, 29, 'PPL', 'P'),
(58972, 'Charleston', 34.0066719055176, 0.593528392396736, -90.0566711425781, -1.57178542482375, 218, 30, 'PPL', 'P'),
(63616, 'Charleston', 36.1199989318848, 0.630412907178224, -77.3758316040039, -1.35046302295855, 218, 33, 'PPL', 'P'),
(80266, 'Charleston', 32.7763900756836, 0.572055923738672, -79.9311065673828, -1.39506098436329, 218, 48, 'PPL', 'P'),
(85712, 'Charleston', 35.4958305358887, 0.619519113581201, -89.5088882446289, -1.56222480966842, 218, 50, 'PPL', 'P'),
(93198, 'Charleston', 33.3863906860352, 0.582702442828482, -95.5336074829102, -1.66737599688467, 218, 51, 'PPL', 'P'),
(108550, 'Charleston', 38.3497200012207, 0.669328881239225, -81.6327819824219, -1.42476082315597, 218, 58, 'PPL', 'P'),
(114950, 'Charleston', 40.5908317565918, 0.7084436602756, -91.5311126708984, -1.59751928412108, 218, 16, 'PPL', 'P'),
(127087, 'Charleston', 45.0849990844727, 0.786881677282677, -69.0411071777344, -1.20499463947375, 218, 26, 'PPL', 'P'),
(130161, 'Charleston', 43.6591682434082, 0.761996234529622, -82.6861114501953, -1.44314489047689, 218, 27, 'PPL', 'P'),
(144969, 'Charleston', 40.038890838623, 0.698810473980566, -74.8916702270508, -1.30710622777985, 218, 37, 'PPL', 'P'),
(147721, 'Charleston', 40.5366706848145, 0.707498371246677, -74.2377777099609, -1.29569365040247, 218, 40, 'PPL', 'P'),
(159980, 'Charleston', 41.7683296203613, 0.728994874933578, -77.2447204589844, -1.3481747017919, 218, 45, 'PPL', 'P'),
(177909, 'Charleston', 31.6319408416748, 0.552081516483292, -110.173606872559, -1.922892188724, 218, 5, 'PPL', 'P'),
(187616, 'Charleston', 37.8652801513672, 0.660873810831414, -100.564437866211, -1.75518055118264, 218, 20, 'PPL', 'P'),
(199871, 'Charleston', 41.6708297729492, 0.727293181576045, -115.509719848633, -2.01602492941489, 218, 39, 'PPL', 'P'),
(200557, 'Charleston', 43.3402786254883, 0.756430560746493, -124.328887939453, -2.16994844988653, 218, 43, 'PPL', 'P'),
(203364, 'Charleston', 40.4663887023926, 0.706271719248586, -111.469169616699, -1.94550402427543, 218, 52, 'PPL', 'P'),
(207011, 'Charleston', 47.5613899230957, 0.830102850982873, -122.658332824707, -2.14079176279817, 218, 56, 'PPL', 'P'),
(72071, 'Charleston (historical)', 39.3694381713867, 0.687126320751034, -82.8194427490234, -1.4454719606374, 218, 41, 'PPL', 'P'),
(180664, 'Charleston (historical)', 37.9777793884277, 0.662837292924102, -121.175827026367, -2.11491715543724, 218, 6, 'PPL', 'P'),
(45627, 'Charleston Creek', 38.2852783203125, 0.668204161731857, -76.8513870239258, -1.34130973829195, 218, 25, 'PPL', 'P'),
(80268, 'Charleston Crossroads', 34.0811080932617, 0.594827548955504, -82.48388671875, -1.43961540308421, 218, 48, 'PPL', 'P'),
(70644, 'Charleston East', 39.8894386291504, 0.696202040850888, -74.978889465332, -1.30862849065893, 218, 37, 'PPL', 'P'),
(147722, 'Charleston Four Corners', 42.8027801513672, 0.747049442648634, -74.3994369506836, -1.29851513641936, 218, 40, 'PPL', 'P'),
(45628, 'Charleston Gardens', 38.5525016784668, 0.672868089169886, -77.1569366455078, -1.34664258521678, 218, 25, 'PPL', 'P'),
(80270, 'Charleston Heights', 32.8569412231445, 0.573461806478125, -79.970832824707, -1.3957543383531, 218, 48, 'PPL', 'P'),
(100700, 'Charleston Heights', 37.271110534668, 0.6505035947047, -76.6711120605469, -1.33816334662208, 218, 53, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(15499, 'Charleston Park', 26.7052803039551, 0.466095068972008, -81.5805587768555, -1.42384935627289, 218, 12, 'PPL', 'P'),
(203381, 'Charleston Place', 40.6452789306641, 0.709393942731568, -111.838607788086, -1.95195193674867, 218, 52, 'PPL', 'P'),
(144970, 'Charleston Springs', 40.2005615234375, 0.701632159734532, -74.3736114501953, -1.29806439640486, 218, 37, 'PPL', 'P'),
(29458, 'Charlestown', 38.4530601501465, 0.671132507087481, -85.670280456543, -1.49522846507363, 218, 19, 'PPL', 'P'),
(45631, 'Charlestown', 39.5736083984375, 0.690689763447614, -75.9752807617188, -1.3260187994191, 218, 25, 'PPL', 'P'),
(124487, 'Charlestown', 42.3777809143066, 0.739631806643464, -71.0625, -1.24027459969847, 218, 23, 'PPL', 'P'),
(143610, 'Charlestown', 43.2386093139648, 0.754656096512173, -72.4250030517578, -1.26405476402012, 218, 36, 'PPL', 'P'),
(144971, 'Charlestown', 40.6891708374023, 0.710160001019129, -74.9727783203125, -1.30852183105728, 218, 37, 'PPL', 'P'),
(154687, 'Charlestown', 41.1630592346191, 0.718430913837561, -81.148063659668, -1.41630089247917, 218, 41, 'PPL', 'P'),
(159983, 'Charlestown', 40.0986099243164, 0.699852768652195, -75.5533294677734, -1.3186543600567, 218, 45, 'PPL', 'P'),
(169310, 'Charlestown', 41.3830604553223, 0.722270659497237, -71.642219543457, -1.25039261446995, 218, 47, 'PPL', 'P'),
(200558, 'Charlestown', 45.8888893127441, 0.800912208590623, -119.29638671875, -2.08211473397462, 218, 43, 'PPL', 'P'),
(141480, 'Charlestown (historical)', 40.8166694641113, 0.712385271846972, -97.692497253418, -1.70505573156766, 218, 35, 'PPL', 'P'),
(169311, 'Charlestown Beach', 41.3680610656738, 0.722008870762083, -71.6283264160156, -1.2501501336527, 218, 47, 'PPL', 'P'),
(45632, 'Charlestown Manor Beach', 39.5755615234375, 0.690723851909567, -75.9672164916992, -1.32587805135549, 218, 25, 'PPL', 'P'),
(45633, 'Charlesville', 39.4880599975586, 0.689196662182461, -77.4297180175781, -1.35140351829751, 218, 25, 'PPL', 'P'),
(78009, 'Charlesville', 39.9486083984375, 0.697234748142593, -78.5044403076172, -1.37016096080327, 218, 45, 'PPL', 'P'),
(134636, 'Charlesville', 45.9491691589355, 0.801964290379259, -96.2683334350586, -1.68019938384952, 218, 28, 'PPL', 'P'),
(80273, 'Charleswood', 34.1124992370605, 0.59537542777076, -80.9338912963867, -1.41256287957313, 218, 48, 'PPL', 'P'),
(130163, 'Charlesworth', 42.4505615234375, 0.740902067904404, -84.6894378662109, -1.47810953242854, 218, 27, 'PPL', 'P'),
(147724, 'Charlesworth Corners', 42.9663887023926, 0.749904950548445, -74.686393737793, -1.30352347716536, 218, 40, 'PPL', 'P'),
(130164, 'Charlevoix', 45.3180618286133, 0.790949389531664, -85.2583312988281, -1.48803859592068, 218, 27, 'PPL', 'P'),
(35215, 'Charley', 37.9747200012207, 0.662783896544246, -82.7077789306641, -1.44352305935168, 218, 21, 'PPL', 'P'),
(85715, 'Charleys Branch', 36.1930618286133, 0.631688095287181, -84.3333282470703, -1.47189424707651, 218, 50, 'PPL', 'P'),
(93200, 'Charlie', 34.0961112976074, 0.595089404269686, -98.3152770996094, -1.71592529039876, 218, 51, 'PPL', 'P'),
(173506, 'Charlie Bluff', 42.8402786254883, 0.747703914486521, -88.9780578613281, -1.5529600717102, 218, 57, 'PPL', 'P'),
(177910, 'Charlie Moore Place', 33.389720916748, 0.582760566319273, -109.04638671875, -1.9032184856452, 218, 5, 'PPL', 'P'),
(159992, 'Charlies Grove', 40.5311088562012, 0.707401299024943, -78.8936080932617, -1.37695322000546, 218, 45, 'PPL', 'P'),
(211729, 'Charlieskin Village', 62.9705581665039, 1.0990435718241, -141.820007324219, -2.47522607301009, 218, 1, 'PPL', 'P'),
(39734, 'Charlieville', 32.3066711425781, 0.563857781797027, -91.9191665649414, -1.60429210224731, 218, 22, 'PPL', 'P'),
(196195, 'Charlo', 47.4386100769043, 0.82795993841174, -114.17138671875, -1.99266660980991, 218, 31, 'PPL', 'P'),
(154689, 'Charloe', 41.1313896179199, 0.717878174753315, -84.4338912963867, -1.47364940339293, 218, 41, 'PPL', 'P'),
(196196, 'Charlos Heights', 46.1263885498047, 0.805057352248304, -114.176940917969, -1.99276354887359, 218, 31, 'PPL', 'P'),
(8042, 'Charlotte', 35.8183288574219, 0.62514777112411, -91.438606262207, -1.59590474271022, 218, 4, 'PPL', 'P'),
(39735, 'Charlotte', 29.9955596923828, 0.523521277610578, -91.9127807617188, -1.60418064895569, 218, 22, 'PPL', 'P'),
(63618, 'Charlotte', 35.2269401550293, 0.614826091108263, -80.8433303833008, -1.41098229346617, 218, 33, 'PPL', 'P'),
(85716, 'Charlotte', 36.1772193908691, 0.631411592587004, -87.3397216796875, -1.52436571108602, 218, 50, 'PPL', 'P'),
(93199, 'Charlotte', 28.8616695404053, 0.503731161102631, -98.7061080932617, -1.72274657805684, 218, 51, 'PPL', 'P'),
(114952, 'Charlotte', 41.9602813720703, 0.732345065005871, -90.4649963378906, -1.5789120439008, 218, 16, 'PPL', 'P'),
(119091, 'Charlotte', 40.8197212219238, 0.712438535068774, -88.2888870239258, -1.5409317714888, 218, 18, 'PPL', 'P'),
(127089, 'Charlotte', 45.021110534668, 0.785766611734261, -67.2458267211914, -1.17366108451037, 218, 26, 'PPL', 'P'),
(130168, 'Charlotte', 42.5636100769043, 0.742875137377017, -84.8358306884766, -1.48066456917836, 218, 27, 'PPL', 'P'),
(147725, 'Charlotte', 43.2550010681152, 0.754942186592275, -77.6172180175781, -1.354676010645, 218, 40, 'PPL', 'P'),
(171843, 'Charlotte', 44.3097190856934, 0.773350488679121, -73.2613906860352, -1.27865248206122, 218, 55, 'PPL', 'P'),
(147726, 'Charlotte Center', 42.3044395446777, 0.738351758265517, -79.2380599975586, -1.38296503985021, 218, 40, 'PPL', 'P'),
(100702, 'Charlotte Court House', 37.0563888549805, 0.646755994418741, -78.6386108398438, -1.37250267834978, 218, 53, 'PPL', 'P'),
(35216, 'Charlotte Furnace', 38.4116706848145, 0.670410124641797, -83.033332824707, -1.44920504669542, 218, 21, 'PPL', 'P'),
(45634, 'Charlotte Hall', 38.4808311462402, 0.671617202405876, -76.7783279418945, -1.34003461676202, 218, 25, 'PPL', 'P'),
(15502, 'Charlotte Harbor', 26.9580593109131, 0.470506894923347, -82.0672225952148, -1.43234324225358, 218, 12, 'PPL', 'P'),
(130169, 'Charlotte Landing', 42.392219543457, 0.739883808261613, -84.7758331298828, -1.47961741423774, 218, 27, 'PPL', 'P'),
(15503, 'Charlotte Park', 26.9097194671631, 0.46966320549001, -82.0541687011719, -1.43211540882233, 218, 12, 'PPL', 'P'),
(85717, 'Charlotte Park', 36.1497192382813, 0.630931624379544, -86.8850021362305, -1.51642935787953, 218, 50, 'PPL', 'P'),
(144972, 'Charlotteburg', 41.0302810668945, 0.716113497636001, -74.4241714477539, -1.29894683483206, 218, 37, 'PPL', 'P'),
(29462, 'Charlottesville', 39.7902793884277, 0.6944713856165, -85.6127777099609, -1.49422485281683, 218, 19, 'PPL', 'P'),
(100703, 'Charlottesville', 38.0291709899902, 0.663734245579241, -78.476936340332, -1.36968092601678, 218, 53, 'PPL', 'P'),
(19947, 'Charlotteville', 32.0111083984375, 0.558699238765543, -82.5224990844727, -1.44028931599805, 218, 13, 'PPL', 'P'),
(147729, 'Charlotteville', 42.545280456543, 0.742555225151071, -74.6650009155273, -1.30315010198053, 218, 40, 'PPL', 'P'),
(159986, 'Charlottsville', 40.644718170166, 0.709384155614562, -78.2772216796875, -1.36619524762403, 218, 45, 'PPL', 'P'),
(26763, 'Charlottsville (historical)', 38.8347206115723, 0.677793738764042, -87.754997253418, -1.53161363715072, 218, 18, 'PPL', 'P'),
(45635, 'Charloumyr', 39.5541687011719, 0.690350476724738, -77.0722198486328, -1.34516399817957, 218, 25, 'PPL', 'P'),
(198115, 'Charlson', 48.0602798461914, 0.838810122745914, -102.870826721191, -1.79543463053335, 218, 34, 'PPL', 'P'),
(45636, 'Charlton', 39.6300010681152, 0.69167400120748, -77.8944396972656, -1.35951444171346, 218, 25, 'PPL', 'P'),
(58973, 'Charlton', 32.5816688537598, 0.568657397292595, -90.1283264160156, -1.57303604527165, 218, 30, 'PPL', 'P'),
(100705, 'Charlton', 37.5827789306641, 0.655943234389242, -80.0113906860352, -1.39646220657084, 218, 53, 'PPL', 'P'),
(124488, 'Charlton', 42.1355590820313, 0.735404238150045, -71.9705581665039, -1.25612320450359, 218, 23, 'PPL', 'P'),
(147730, 'Charlton', 42.9333305358887, 0.749327976698279, -73.9694366455078, -1.29101021530946, 218, 40, 'PPL', 'P'),
(159987, 'Charlton', 41.1783294677734, 0.718697429683651, -77.350830078125, -1.35002666401394, 218, 45, 'PPL', 'P'),
(124489, 'Charlton City', 42.1458282470703, 0.735583468891407, -71.9888916015625, -1.25644318330856, 218, 23, 'PPL', 'P'),
(124490, 'Charlton Depot', 42.1730613708496, 0.736058776566959, -71.9791717529297, -1.25627353994712, 218, 23, 'PPL', 'P'),
(108560, 'Charlton Heights', 38.1236114501953, 0.665382542556918, -81.2341690063477, -1.4178037142823, 218, 58, 'PPL', 'P'),
(100706, 'Charlton Village', 36.7988891601563, 0.642261776921177, -76.4355621337891, -1.33405222484732, 218, 53, 'PPL', 'P'),
(154690, 'Charm', 40.5066719055176, 0.706974793776367, -81.7850036621094, -1.42741759265943, 218, 41, 'PPL', 'P'),
(203366, 'Charmar', 40.5905609130859, 0.708438933164665, -111.777778625488, -1.95089026758011, 218, 52, 'PPL', 'P'),
(108551, 'Charmco', 38.0022201538086, 0.663263864751706, -80.7372207641602, -1.40913033124413, 218, 58, 'PPL', 'P'),
(173507, 'Charme', 43.167781829834, 0.753419923713186, -91.1377792358398, -1.59065432062113, 218, 57, 'PPL', 'P'),
(78010, 'Charmian', 39.7427787780762, 0.693642343569158, -77.4649963378906, -1.35201924114154, 218, 45, 'PPL', 'P'),
(159988, 'Charming Forge', 40.3894386291504, 0.704928687110859, -76.1725006103516, -1.32946093512803, 218, 45, 'PPL', 'P'),
(39736, 'Charmingdale', 32.4063911437988, 0.565598224148421, -92.0999984741211, -1.60744821445517, 218, 22, 'PPL', 'P'),
(45637, 'Charolais Acres', 39.4900016784668, 0.689230550907333, -76.9244384765625, -1.34258472666383, 218, 25, 'PPL', 'P'),
(39737, 'Charon', 30.021390914917, 0.523972117493614, -92.023063659668, -1.60610544863355, 218, 22, 'PPL', 'P'),
(45639, 'Charred Oak Estates', 39.0027809143066, 0.680726944388655, -77.1622161865234, -1.3467347305905, 218, 25, 'PPL', 'P'),
(54007, 'Charrette (historical)', 38.6519393920898, 0.674603604673263, -91.0972213745117, -1.58994645240338, 218, 29, 'PPL', 'P'),
(119093, 'Charter Grove', 42.0663909912109, 0.734197027227912, -88.6313934326172, -1.54690963602965, 218, 18, 'PPL', 'P'),
(54008, 'Charter Oak', 36.7152786254883, 0.640802497801869, -89.7197189331055, -1.56590449934658, 218, 29, 'PPL', 'P'),
(114953, 'Charter Oak', 42.0683288574219, 0.734230849373756, -95.5913925170898, -1.66838453598949, 218, 16, 'PPL', 'P'),
(180665, 'Charter Oak', 34.1030616760254, 0.595210711257339, -117.845001220703, -2.05678327831801, 218, 6, 'PPL', 'P'),
(207012, 'Charter Oak', 45.8244400024414, 0.799787355925201, -122.556938171387, -2.13902209225382, 218, 56, 'PPL', 'P'),
(173508, 'Charter Oak Mills (historical)', 44.2686080932617, 0.772632966502426, -90.8747177124023, -1.58606303090183, 218, 57, 'PPL', 'P'),
(13521, 'Charter Oaks', 39.7833290100098, 0.694350078628847, -75.6875, -1.32099607760321, 218, 10, 'PPL', 'P'),
(159989, 'Charter Oaks', 42.0883293151855, 0.734579923213638, -80.1377792358398, -1.39866810290175, 218, 45, 'PPL', 'P'),
(159990, 'Charteroak', 40.6777801513672, 0.709961196043755, -77.9097213745117, -1.35978115729663, 218, 45, 'PPL', 'P'),
(35218, 'Charters', 38.5736083984375, 0.673236470927671, -83.4333267211914, -1.45618625717696, 218, 21, 'PPL', 'P'),
(32039, 'Charters Corner', 38.0574989318848, 0.664228661435614, -98.1788864135742, -1.7135448238584, 218, 20, 'PPL', 'P'),
(85718, 'Chartersville', 35.7200012207031, 0.623431630117663, -87.2447204589844, -1.52270762699134, 218, 50, 'PPL', 'P'),
(78011, 'Chartiers', 39.9580612182617, 0.697399730972123, -80.0511093139648, -1.39715542740259, 218, 45, 'PPL', 'P'),
(45640, 'Chartley', 39.4594383239746, 0.68869711974099, -76.8127822875977, -1.34063595853616, 218, 25, 'PPL', 'P'),
(124492, 'Chartley', 41.9486083984375, 0.73214133318248, -71.2263870239258, -1.24313496786727, 218, 23, 'PPL', 'P'),
(45641, 'Chartridge', 39.0888900756836, 0.682229832770814, -76.5777816772461, -1.33653442414133, 218, 25, 'PPL', 'P'),
(45642, 'Chartwell', 39.0916709899902, 0.682278368881681, -76.5913925170898, -1.33677197811057, 218, 25, 'PPL', 'P'),
(80274, 'Chartwell', 34.045280456543, 0.594202238731553, -81.1136093139648, -1.41569955070503, 218, 48, 'PPL', 'P'),
(45644, 'Chartwood', 39.0930595397949, 0.682302603647601, -76.6083297729492, -1.33706758899156, 218, 25, 'PPL', 'P'),
(159993, 'Chartwood', 40.2649993896484, 0.702756812662872, -76.788330078125, -1.34020918697148, 218, 45, 'PPL', 'P'),
(80275, 'Charwood', 33.8930587768555, 0.59154546922809, -81.0791702270508, -1.41509847524699, 218, 48, 'PPL', 'P'),
(171845, 'Chasanna Acres', 43.6430587768555, 0.761715071297537, -72.9602813720703, -1.27339713312411, 218, 55, 'PPL', 'P'),
(1501, 'Chase', 34.7833290100098, 0.60708361602913, -86.5466690063477, -1.5105243307945, 218, 2, 'PPL', 'P'),
(32040, 'Chase', 38.3549995422363, 0.669421026612942, -98.3491668701172, -1.71651677847687, 218, 20, 'PPL', 'P'),
(39738, 'Chase', 32.0969390869141, 0.560197266878713, -91.6988906860352, -1.60044756289768, 218, 22, 'PPL', 'P'),
(45645, 'Chase', 39.3633308410645, 0.687019727728403, -76.3713912963867, -1.33293223245089, 218, 25, 'PPL', 'P'),
(113109, 'Chase', 43.8891716003418, 0.766010550398753, -85.6355590820313, -1.49462246276758, 218, 27, 'PPL', 'P'),
(113280, 'Chase', 41.2847213745117, 0.720554318753708, -75.9633331298828, -1.32581027390574, 218, 45, 'PPL', 'P'),
(122359, 'Chase', 40.5194396972656, 0.70719763378058, -87.3419418334961, -1.52440446007988, 218, 19, 'PPL', 'P'),
(147732, 'Chase', 42.6686096191406, 0.744707725102128, -74.9908294677734, -1.30883688301423, 218, 40, 'PPL', 'P'),
(154691, 'Chase', 41.0730590820313, 0.716860114847605, -83.7088928222656, -1.46099579294758, 218, 41, 'PPL', 'P'),
(173509, 'Chase', 44.7180595397949, 0.780477374072282, -88.1566696166992, -1.53862414240425, 218, 57, 'PPL', 'P'),
(180667, 'Chase', 35.1838912963867, 0.614074746785724, -115.502502441406, -2.01589896189533, 218, 6, 'PPL', 'P'),
(199227, 'Chase', 40.564998626709, 0.70799278710305, -101.819999694824, -1.7770942390543, 218, 35, 'PPL', 'P'),
(202000, 'Chase', 44.9411087036133, 0.784370316374732, -101.628059387207, -1.77374424871909, 218, 49, 'PPL', 'P'),
(211730, 'Chase', 62.4491691589355, 1.08994361695832, -150.101669311523, -2.61976834222581, 218, 1, 'PPL', 'P'),
(200559, 'Chase (historical)', 42.1405601501465, 0.735491523254772, -122.004173278809, -2.1293745248889, 218, 43, 'PPL', 'P'),
(100707, 'Chase City', 36.7991714477539, 0.642266703769194, -78.458610534668, -1.36936108036986, 218, 53, 'PPL', 'P'),
(127091, 'Chase Corner', 44.747501373291, 0.780991231004612, -70.438606262207, -1.22938559979141, 218, 26, 'PPL', 'P'),
(100708, 'Chase Crossing', 37.7625007629395, 0.659079972100164, -75.6677780151367, -1.32065186403232, 218, 53, 'PPL', 'P'),
(45646, 'Chase Eden', 39.1680603027344, 0.683611613902402, -76.8697204589844, -1.34162971709692, 218, 25, 'PPL', 'P'),
(45647, 'Chase Hill', 39.0930595397949, 0.682302603647601, -76.6819381713867, -1.33835229790142, 218, 25, 'PPL', 'P'),
(127093, 'Chase Mills', 44.7561111450195, 0.78114149986912, -67.3605575561523, -1.175663515334, 218, 26, 'PPL', 'P'),
(147733, 'Chase Mills', 44.8488883972168, 0.782760768390916, -75.0811080932617, -1.31041254227318, 218, 40, 'PPL', 'P'),
(143612, 'Chase Village', 43.1105613708496, 0.752421238304406, -71.7513885498047, -1.25229797307185, 218, 36, 'PPL', 'P'),
(45648, 'Chase Wood Run', 39.148609161377, 0.683272127442444, -76.4755630493164, -1.33475037252709, 218, 25, 'PPL', 'P'),
(19951, 'Chase Woods', 33.5449981689453, 0.585470665623565, -84.3819427490234, -1.47274273019981, 218, 13, 'PPL', 'P'),
(173511, 'Chaseburg', 43.6577796936035, 0.761971999763703, -91.0963897705078, -1.58993193817544, 218, 57, 'PPL', 'P'),
(139787, 'Chaseley', 47.4502792358398, 0.828163603656104, -99.8197174072266, -1.7421827271664, 218, 34, 'PPL', 'P'),
(19952, 'Chaserville', 31.2169399261475, 0.544838384108549, -83.3574981689453, -1.45486279927324, 218, 13, 'PPL', 'P'),
(180668, 'Chases (historical)', 39.9672203063965, 0.697559587216556, -120.520561218262, -2.10348060961006, 218, 6, 'PPL', 'P'),
(45649, 'Chases Forest', 39.3894386291504, 0.687475394590916, -77.1236114501953, -1.34606095083471, 218, 25, 'PPL', 'P'),
(143613, 'Chases Grove', 42.8616714477539, 0.74807728967135, -71.2172164916992, -1.24297491188576, 218, 36, 'PPL', 'P'),
(143614, 'Chases Mill', 43.7211112976074, 0.76307734477414, -71.003059387207, -1.23923716529583, 218, 36, 'PPL', 'P'),
(127094, 'Chases Pond', 43.188060760498, 0.753773857822057, -70.6524963378906, -1.23311868584943, 218, 26, 'PPL', 'P'),
(72073, 'Chasetown', 39.1605606079102, 0.683480719534824, -83.9319381713867, -1.46488866867101, 218, 41, 'PPL', 'P'),
(15504, 'Chaseville', 30.3861103057861, 0.530337671710149, -81.6152801513672, -1.42445535857893, 218, 12, 'PPL', 'P'),
(72074, 'Chaseville', 39.8861083984375, 0.696143917360097, -81.4641723632813, -1.42181803015143, 218, 41, 'PPL', 'P'),
(85720, 'Chaseville', 35.8772201538086, 0.626175618146826, -88.1130599975586, -1.5378630109647, 218, 50, 'PPL', 'P'),
(124493, 'Chaseville', 42.0416717529297, 0.733765595131319, -71.897216796875, -1.25484315612564, 218, 23, 'PPL', 'P'),
(147737, 'Chaseville', 42.5405616760254, 0.74247286689436, -74.8566665649414, -1.30649529862578, 218, 40, 'PPL', 'P'),
(8040, 'Chasewood Landing', 34.6333312988281, 0.604465662098555, -93.6736068725586, -1.63491286214494, 218, 4, 'PPL', 'P'),
(85719, 'Chaska', 36.5288887023926, 0.63754937995131, -84.0774993896484, -1.46742919119289, 218, 50, 'PPL', 'P'),
(134638, 'Chaska', 44.7894401550293, 0.781723200830221, -93.601936340332, -1.63366197538093, 218, 28, 'PPL', 'P'),
(154692, 'Chaska Beach', 41.3925018310547, 0.722435442589686, -82.5391693115234, -1.44058026634715, 218, 41, 'PPL', 'P'),
(147734, 'Chasm Falls', 44.7572212219238, 0.78116087436605, -74.2191696166992, -1.29536887790754, 218, 40, 'PPL', 'P'),
(39740, 'Chasmore (historical)', 30.8980598449707, 0.539272876772988, -93.1727828979492, -1.62617183481508, 218, 22, 'PPL', 'P'),
(15505, 'Chason', 30.5349998474121, 0.532936284433307, -85.1919403076172, -1.48687985453039, 218, 12, 'PPL', 'P'),
(15506, 'Chassahowitzka', 28.7127799987793, 0.501132548379472, -82.5744400024414, -1.44119585603312, 218, 12, 'PPL', 'P'),
(130172, 'Chassell', 47.0283317565918, 0.820799230872735, -88.5250015258789, -1.54505274695959, 218, 27, 'PPL', 'P'),
(19953, 'Chastain', 31.0324993133545, 0.541619288140915, -83.9305572509766, -1.46486456706314, 218, 13, 'PPL', 'P'),
(8041, 'Chastain (historical)', 36.1749992370605, 0.631372843593143, -92.2811126708984, -1.61060925351104, 218, 4, 'PPL', 'P'),
(1502, 'Chastang', 31.0375003814697, 0.541706573245643, -88.0233306884766, -1.53629693908568, 218, 2, 'PPL', 'P'),
(39741, 'Chataignier', 30.5683307647705, 0.533518018683922, -92.3219375610352, -1.61132178226069, 218, 22, 'PPL', 'P'),
(211731, 'Chatanika', 65.1122207641602, 1.13642263562001, -147.47721862793, -2.57396303674089, 218, 1, 'PPL', 'P'),
(58974, 'Chatawa', 31.0602798461914, 0.542104149906878, -90.4722213745117, -1.57903814457842, 218, 30, 'PPL', 'P'),
(194719, 'Chatcolet', 47.3722190856934, 0.826801197021447, -116.762496948242, -2.03789001459666, 218, 17, 'PPL', 'P'),
(1504, 'Chateau Estates', 31.2477798461914, 0.545376642254367, -85.4355621337891, -1.49113185752681, 218, 2, 'PPL', 'P'),
(72075, 'Chateau Estates Mobile Home Park', 39.9811096191406, 0.69780200145478, -83.9208297729492, -1.46469479054365, 218, 41, 'PPL', 'P'),
(45650, 'Chateau Ridge', 39.2688903808594, 0.685371430750726, -76.8736114501953, -1.34169762770472, 218, 25, 'PPL', 'P'),
(45651, 'Chateau Valley', 39.2541694641113, 0.685114502284561, -76.8569412231445, -1.34140667735563, 218, 25, 'PPL', 'P'),
(39743, 'Chateau Village', 32.436939239502, 0.566131388998655, -93.8000030517578, -1.6371188916339, 218, 22, 'PPL', 'P'),
(203373, 'Chateau Village', 40.6505584716797, 0.709486088105285, -112.027221679688, -1.95524387017212, 218, 52, 'PPL', 'P'),
(80276, 'Chateau Woods', 34.5591697692871, 0.603171299229749, -82.7263870239258, -1.44384783184662, 218, 48, 'PPL', 'P'),
(93201, 'Chateau Woods', 30.1683292388916, 0.526536675044333, -95.4227828979492, -1.66544174298495, 218, 51, 'PPL', 'P'),
(203374, 'Chateau-Park Condominium', 41.1613883972168, 0.718401752223625, -112.036109924316, -1.95539899930562, 218, 52, 'PPL', 'P'),
(147736, 'Chateaugay', 43.5738906860352, 0.760507860375404, -75.9625015258789, -1.3257957596778, 218, 40, 'PPL', 'P'),
(171846, 'Chateauguay', 43.6602783203125, 0.762015609026553, -72.6952819824219, -1.26877202125897, 218, 55, 'PPL', 'P'),
(8043, 'Chatfield', 35.0058288574219, 0.610966970951656, -90.397216796875, -1.57772906774459, 218, 4, 'PPL', 'P'),
(93202, 'Chatfield', 32.2413902282715, 0.562718414903664, -96.4072189331055, -1.68262339307371, 218, 51, 'PPL', 'P'),
(134641, 'Chatfield', 43.8455581665039, 0.765249352380181, -92.1888885498047, -1.60899963894819, 218, 28, 'PPL', 'P'),
(154693, 'Chatfield', 40.9502792358398, 0.714717202276473, -82.9449996948242, -1.44766334274037, 218, 41, 'PPL', 'P'),
(19956, 'Chatfield (historical)', 33.9005584716797, 0.591676363595667, -82.8616714477539, -1.44620899046908, 218, 13, 'PPL', 'P'),
(147738, 'Chatfield Corner', 43.1080589294434, 0.752377562462529, -73.9430618286133, -1.29054988791504, 218, 40, 'PPL', 'P'),
(13522, 'Chatham', 39.8041687011719, 0.694713799854724, -75.5166702270508, -1.31801453560481, 218, 10, 'PPL', 'P'),
(15507, 'Chatham', 25.7138900756836, 0.448792045316573, -81.2441711425781, -1.41797828449175, 218, 12, 'PPL', 'P'),
(26764, 'Chatham', 39.6761093139648, 0.692478741909875, -89.7044372558594, -1.56563778376341, 218, 18, 'PPL', 'P'),
(35217, 'Chatham', 38.7152786254883, 0.675709082841755, -84.0188903808594, -1.46640627101819, 218, 21, 'PPL', 'P'),
(39744, 'Chatham', 32.3061103820801, 0.563847994680021, -92.4502792358398, -1.61356176705355, 218, 22, 'PPL', 'P'),
(45654, 'Chatham', 38.9869384765625, 0.680450441688478, -76.9591674804688, -1.34319086212793, 218, 25, 'PPL', 'P'),
(58976, 'Chatham', 33.1005592346191, 0.577713742895518, -91.0977783203125, -1.58995617294136, 218, 30, 'PPL', 'P'),
(78012, 'Chatham', 39.853328704834, 0.69557180377892, -75.8219375610352, -1.32334245568162, 218, 45, 'PPL', 'P'),
(100709, 'Chatham', 36.8255615234375, 0.642727297479723, -79.3983306884766, -1.38576229110117, 218, 53, 'PPL', 'P'),
(124494, 'Chatham', 41.6819381713867, 0.727487059703403, -69.9602813720703, -1.22103725556428, 218, 23, 'PPL', 'P'),
(130174, 'Chatham', 46.3477783203125, 0.8089213326739, -86.9288864135742, -1.51719528300904, 218, 27, 'PPL', 'P'),
(143615, 'Chatham', 44.1644401550293, 0.770814893005256, -71.0116729736328, -1.23938750073937, 218, 36, 'PPL', 'P'),
(144973, 'Chatham', 40.7408294677734, 0.711061614206176, -74.3841705322266, -1.2982486871523, 218, 37, 'PPL', 'P'),
(147739, 'Chatham', 42.3641700744629, 0.739394252674229, -73.5952835083008, -1.28448001115853, 218, 40, 'PPL', 'P'),
(154696, 'Chatham', 41.0994415283203, 0.71732057540008, -82.0244369506836, -1.43159649188393, 218, 41, 'PPL', 'P'),
(209942, 'Chatham', 57.5152816772461, 1.00383103547991, -134.943603515625, -2.35521018585345, 218, 1, 'PPL', 'P'),
(147740, 'Chatham Center', 42.4180603027344, 0.740334814592218, -73.6144409179688, -1.28481437103339, 218, 40, 'PPL', 'P'),
(63621, 'Chatham Circle', 35.610279083252, 0.621516617556815, -77.3619384765625, -1.3502205421413, 218, 33, 'PPL', 'P'),
(19954, 'Chatham City', 32.1002807617188, 0.560255590106586, -81.1544418334961, -1.41641221261273, 218, 13, 'PPL', 'P'),
(45655, 'Chatham Gardens', 39.2799987792969, 0.685565308878084, -76.836669921875, -1.34105287640481, 218, 25, 'PPL', 'P'),
(100710, 'Chatham Heights', 38.3083305358887, 0.668606498793541, -77.4505615234375, -1.35176730610242, 218, 53, 'PPL', 'P'),
(100712, 'Chatham Hill', 36.9555587768555, 0.644996177570416, -81.5233306884766, -1.42285053770605, 218, 53, 'PPL', 'P'),
(108552, 'Chatham Hill', 39.5122184753418, 0.689618307162048, -80.2369384765625, -1.40039875813614, 218, 58, 'PPL', 'P'),
(45656, 'Chatham Hills', 39.0855598449707, 0.682171709280023, -76.5969390869141, -1.33686878401619, 218, 25, 'PPL', 'P'),
(124495, 'Chatham Port', 41.7027816772461, 0.727850847508308, -69.9700012207031, -1.22120689892572, 218, 23, 'PPL', 'P'),
(159995, 'Chatham Run', 41.1713905334473, 0.718576322433079, -77.3655624389648, -1.35028379221719, 218, 45, 'PPL', 'P'),
(39747, 'Chatman Town', 30.0352802276611, 0.524214531731839, -90.8436126708984, -1.58552014551362, 218, 22, 'PPL', 'P'),
(15509, 'Chatmire', 29.0669403076172, 0.507313811848573, -82.4530563354492, -1.43907731138596, 218, 12, 'PPL', 'P'),
(100714, 'Chatmoss', 36.6566696166992, 0.639779577627169, -79.8125, -1.39299090924797, 218, 53, 'PPL', 'P'),
(188292, 'Chato', 34.6308288574219, 0.604421986256678, -106.348327636719, -1.85612847125042, 218, 38, 'PPL', 'P'),
(1505, 'Chatom', 31.4650001525879, 0.549167851803177, -88.2544403076172, -1.54033056287272, 218, 2, 'PPL', 'P'),
(180669, 'Chats (historical)', 39.774169921875, 0.694190222384415, -120.072219848633, -2.09565557653713, 218, 6, 'PPL', 'P'),
(19964, 'Chatsworth', 34.7658309936523, 0.606778218031125, -84.7699966430664, -1.47951554832605, 218, 13, 'PPL', 'P'),
(70645, 'Chatsworth', 39.8175010681152, 0.69494649355497, -74.5352783203125, -1.3008860155798, 218, 37, 'PPL', 'P'),
(114955, 'Chatsworth', 42.9161109924316, 0.749027438969263, -96.51611328125, -1.68452395798564, 218, 16, 'PPL', 'P'),
(119096, 'Chatsworth', 40.7536087036133, 0.71128465394747, -88.2919387817383, -1.5409850347106, 218, 18, 'PPL', 'P'),
(180670, 'Chatsworth', 34.2572212219238, 0.597901302906646, -118.600280761719, -2.06996539308168, 218, 6, 'PPL', 'P'),
(180671, 'Chatsworth Lake Manor', 34.2408294677734, 0.597615212826544, -118.636108398438, -2.07059070330563, 218, 6, 'PPL', 'P'),
(177594, 'Chatsworth Village', 41.9383316040039, 0.731961969283063, -72.7944412231445, -1.27050267649336, 218, 8, 'PPL', 'P'),
(93203, 'Chatt', 31.9436092376709, 0.557521156167833, -97.0894393920898, -1.69453038630745, 218, 51, 'PPL', 'P'),
(15508, 'Chattahoochee', 30.7049999237061, 0.535903345493278, -84.8430633544922, -1.48079080301403, 218, 12, 'PPL', 'P'),
(19957, 'Chattahoochee', 33.8083305358887, 0.590066682453796, -84.4819412231445, -1.4744880328202, 218, 13, 'PPL', 'P'),
(19959, 'Chattahoochee Heights', 33.9683303833008, 0.592859206593826, -84.3974990844727, -1.47301423947295, 218, 13, 'PPL', 'P'),
(19960, 'Chattahoochee Landing', 34.3472213745117, 0.599472101896602, -83.8305587768555, -1.46311926444276, 218, 13, 'PPL', 'P'),
(19961, 'Chattahoochee Mobile Home Park', 34.019718170166, 0.593756092669938, -84.1127777099609, -1.46804491403691, 218, 13, 'PPL', 'P'),
(19962, 'Chattahoochee Place', 34.3619384765625, 0.59972896378374, -83.8652801513672, -1.46372526674881, 218, 13, 'PPL', 'P'),
(19963, 'Chattahoochee Plantation', 33.9416694641113, 0.592393885772362, -84.413330078125, -1.47329054243604, 218, 13, 'PPL', 'P'),
(19965, 'Chattahoochee Station', 33.9724998474121, 0.592931977470613, -84.2586135864258, -1.47059023024876, 218, 13, 'PPL', 'P'),
(75409, 'Chattanooga', 34.422779083252, 0.600790832689382, -98.6561126708984, -1.72187399332567, 218, 42, 'PPL', 'P'),
(85721, 'Chattanooga', 35.0455589294434, 0.611660391520486, -85.3097229003906, -1.48893554857582, 218, 50, 'PPL', 'P'),
(154698, 'Chattanooga', 40.6369400024414, 0.709248400977995, -84.7850036621094, -1.47977747021926, 218, 41, 'PPL', 'P'),
(186527, 'Chattanooga', 37.8736114501953, 0.661019219426933, -107.724716186523, -1.88015098323126, 218, 7, 'PPL', 'P'),
(19966, 'Chattanooga Valley', 34.9327812194824, 0.609692049158808, -85.3555603027344, -1.48973556216728, 218, 13, 'PPL', 'P'),
(108553, 'Chattaroy', 37.7033309936523, 0.658047264808459, -82.2811126708984, -1.4360763283116, 218, 58, 'PPL', 'P'),
(207013, 'Chattaroy', 47.889720916748, 0.835833307858451, -117.356666564941, -2.04826023072337, 218, 56, 'PPL', 'P'),
(203375, 'Chattel Estates', 40.5694389343262, 0.708070285090771, -111.970832824707, -1.95425969899128, 218, 52, 'PPL', 'P'),
(19968, 'Chatterton', 31.5113906860352, 0.549977519353588, -82.7363891601563, -1.44402240205607, 218, 13, 'PPL', 'P'),
(122360, 'Chatterton', 40.4036102294922, 0.7051760281971, -87.2397232055664, -1.52262040846564, 218, 19, 'PPL', 'P'),
(75410, 'Chatto Crossing', 34.6855583190918, 0.605377195560662, -98.3872222900391, -1.71718097085274, 218, 42, 'PPL', 'P'),
(45657, 'Chattolanee', 39.4083290100098, 0.687805093933868, -76.7430572509766, -1.33941902707605, 218, 25, 'PPL', 'P'),
(119098, 'Chatton', 40.1508293151855, 0.700764168956248, -91.0327835083008, -1.58882179947504, 218, 18, 'PPL', 'P'),
(19970, 'Chattoogaville', 34.3450012207031, 0.599433352902741, -85.4469375610352, -1.49133039618608, 218, 13, 'PPL', 'P'),
(78013, 'Chatwood', 39.9663887023926, 0.697545072988615, -75.5897216796875, -1.31928952397669, 218, 45, 'PPL', 'P'),
(39746, 'Chaudiere Casse', 29.7299995422363, 0.518886378628431, -90.3324966430664, -1.57659948796823, 218, 22, 'PPL', 'P'),
(80278, 'Chauga Heights', 34.6749992370605, 0.605192904813228, -83.1419372558594, -1.45110055160129, 218, 48, 'PPL', 'P'),
(35219, 'Chaumont', 37.1286087036133, 0.648016468562675, -86.0666732788086, -1.50214682495343, 218, 21, 'PPL', 'P'),
(147743, 'Chaumont', 44.0669403076172, 0.769113199647723, -76.1305618286133, -1.32872896530242, 218, 40, 'PPL', 'P'),
(19972, 'Chauncey', 32.1044387817383, 0.56032816124629, -83.0647201538086, -1.44975285893165, 218, 13, 'PPL', 'P'),
(26766, 'Chauncey', 38.8352813720703, 0.677803525881048, -87.8708267211914, -1.5336352427342, 218, 18, 'PPL', 'P'),
(72076, 'Chauncey', 39.3977813720703, 0.687621002923516, -82.1294403076172, -1.43342914618806, 218, 41, 'PPL', 'P'),
(108554, 'Chauncey', 37.7661094665527, 0.659142955859945, -81.9877777099609, -1.43095666743203, 218, 58, 'PPL', 'P'),
(130176, 'Chauncey', 43.0502815246582, 0.75136915651577, -85.5502777099609, -1.49313402203433, 218, 27, 'PPL', 'P'),
(147744, 'Chauncey', 41.002498626709, 0.715628602580525, -73.8569412231445, -1.2890467997958, 218, 40, 'PPL', 'P'),
(80279, 'Chaunessy', 34.833610534668, 0.607961194187338, -82.258056640625, -1.43567392467089, 218, 48, 'PPL', 'P'),
(194720, 'Chausse', 42.1808280944824, 0.736194331466444, -111.083061218262, -1.93876516145309, 218, 17, 'PPL', 'P'),
(196199, 'Chausse (historical)', 46.0616683959961, 0.803927772471947, -104.748611450195, -1.82820815669814, 218, 31, 'PPL', 'P'),
(26767, 'Chautauqua', 38.9644393920898, 0.680057758585746, -90.3855590820313, -1.57752560223731, 218, 18, 'PPL', 'P'),
(32042, 'Chautauqua', 37.0202789306641, 0.646125757346773, -96.1763916015625, -1.67859469613469, 218, 20, 'PPL', 'P'),
(72077, 'Chautauqua', 39.5897216796875, 0.690970993258727, -84.29638671875, -1.47124949577661, 218, 41, 'PPL', 'P'),
(114956, 'Chautauqua', 41.290828704834, 0.720660911776339, -95.793327331543, -1.6719089633761, 218, 16, 'PPL', 'P'),
(147746, 'Chautauqua', 42.2097206115723, 0.736698601018851, -79.4669418334961, -1.38695978148533, 218, 40, 'PPL', 'P'),
(170009, 'Chautauqua', 43.980281829834, 0.767600723885639, -97.0597229003906, -1.69401173568516, 218, 49, 'PPL', 'P'),
(207014, 'Chautauqua', 47.4233283996582, 0.827693222828569, -122.431671142578, -2.13683577015692, 218, 56, 'PPL', 'P'),
(119099, 'Chautauqua Park', 40.3227806091309, 0.703765285188658, -90.0519409179688, -1.57170286682996, 218, 18, 'PPL', 'P'),
(39748, 'Chauvin', 29.4383296966553, 0.513795779494258, -90.5952835083008, -1.58118598399757, 218, 22, 'PPL', 'P'),
(39749, 'Chauvin Estates', 32.5588912963867, 0.568259853920873, -92.0936126708984, -1.60733676116355, 218, 22, 'PPL', 'P'),
(188295, 'Chaves Place', 34.7416687011719, 0.606356506472511, -106.374168395996, -1.85657947758103, 218, 38, 'PPL', 'P'),
(1506, 'Chavies', 34.4727783203125, 0.601663483999574, -85.813606262207, -1.49772997228554, 218, 2, 'PPL', 'P'),
(35220, 'Chavies', 37.3477783203125, 0.651841699994411, -83.3563919067383, -1.45484349135534, 218, 21, 'PPL', 'P'),
(80280, 'Chavistown', 34.6947212219238, 0.605537118384121, -79.7680587768555, -1.39221526358049, 218, 48, 'PPL', 'P'),
(45658, 'Chazdale North', 39.5880584716797, 0.690941964802845, -76.9461135864258, -1.34296302869667, 218, 25, 'PPL', 'P'),
(147748, 'Chazy', 44.889720916748, 0.783473430298621, -73.436393737793, -1.28170686151543, 218, 40, 'PPL', 'P'),
(147749, 'Chazy Landing', 44.8872184753418, 0.783429754456743, -73.3786087036133, -1.28069832241062, 218, 40, 'PPL', 'P'),
(100715, 'Cheaden (historical)', 37.5611114501953, 0.65556506551445, -76.4899978637695, -1.33500230756621, 218, 53, 'PPL', 'P'),
(196197, 'Cheadle (historical)', 47.0611114501953, 0.821371344453912, -109.151672363281, -1.90505606679736, 218, 31, 'PPL', 'P'),
(85722, 'Cheap Hill', 36.3325004577637, 0.634121758470323, -87.1561126708984, -1.52116112934633, 218, 50, 'PPL', 'P'),
(93204, 'Cheapside', 29.2780609130859, 0.510998561532807, -97.4027786254883, -1.69999918760593, 218, 51, 'PPL', 'P'),
(100716, 'Cheapside', 37.2011108398438, 0.649281869554626, -75.9844436645508, -1.32617872224256, 218, 53, 'PPL', 'P'),
(124497, 'Cheapside', 42.5722198486328, 0.743025406241525, -72.5861129760742, -1.26686666265708, 218, 23, 'PPL', 'P'),
(108555, 'Cheat Junction', 38.7947196960449, 0.677095591084278, -79.7547225952148, -1.39198250330122, 218, 58, 'PPL', 'P'),
(108556, 'Cheat Lake', 39.6719398498535, 0.692405971033089, -79.8536071777344, -1.39370836484564, 218, 58, 'PPL', 'P'),
(108557, 'Cheat Neck', 39.685001373291, 0.692633937622399, -79.8341674804688, -1.39336907812277, 218, 58, 'PPL', 'P'),
(8044, 'Cheatham', 34.1044387817383, 0.595234746286177, -94.4680633544922, -1.64877874351849, 218, 4, 'PPL', 'P'),
(85723, 'Cheatham (historical)', 35.815559387207, 0.625099434750325, -86.8994369506836, -1.51668129291865, 218, 50, 'PPL', 'P'),
(100717, 'Cheatham Annex', 37.2838897705078, 0.650726634445994, -76.5908279418945, -1.33676212441453, 218, 53, 'PPL', 'P'),
(119100, 'Chebanse', 41.003059387207, 0.715638389697531, -87.9080581665039, -1.53428505404018, 218, 18, 'PPL', 'P'),
(127095, 'Chebeague Island', 43.7408294677734, 0.763421491766005, -70.1086120605469, -1.22362611445995, 218, 26, 'PPL', 'P'),
(130177, 'Cheboygan', 45.6469383239746, 0.796689367208139, -84.4744415283203, -1.47435713845262, 218, 27, 'PPL', 'P'),
(171847, 'Checkerberry Village', 44.6291694641113, 0.778925949579256, -73.1444396972656, -1.27661130224373, 218, 55, 'PPL', 'P'),
(196198, 'Checkerboard', 46.5724983215332, 0.812843436590287, -110.546112060547, -1.92939363073516, 218, 31, 'PPL', 'P'),
(159996, 'Checkerville', 41.9099998474121, 0.731467486847662, -76.7605590820313, -1.33972449165308, 218, 45, 'PPL', 'P'),
(119102, 'Checkrow', 40.5541687011719, 0.707803769244682, -90.378059387207, -1.57739470786973, 218, 18, 'PPL', 'P'),
(8045, 'Checks Corner (historical)', 36.4891700744629, 0.636856159119562, -94.5238876342773, -1.64975306100329, 218, 4, 'PPL', 'P'),
(75413, 'Checotah', 35.4700012207031, 0.619068306987677, -95.5227813720703, -1.66718704560533, 218, 42, 'PPL', 'P'),
(80281, 'Cheddar', 34.5780601501465, 0.603500998572701, -82.4963912963867, -1.43983364913554, 218, 48, 'PPL', 'P'),
(147751, 'Chedwel', 42.2163887023926, 0.736814981158487, -79.4355621337891, -1.38641210240715, 218, 40, 'PPL', 'P'),
(75412, 'Cheek', 34.0783309936523, 0.594779079423664, -97.2822189331055, -1.69789502402866, 218, 42, 'PPL', 'P'),
(93205, 'Cheek', 29.9833297729492, 0.523307825249208, -94.2024993896484, -1.64414377795731, 218, 51, 'PPL', 'P'),
(19973, 'Cheeko Manor', 33.5947189331055, 0.586338456664767, -84.4444427490234, -1.47383356098231, 218, 13, 'PPL', 'P'),
(63623, 'Cheeks', 35.5991706848145, 0.621322739429457, -79.5819396972656, -1.38896687284086, 218, 33, 'PPL', 'P'),
(63624, 'Cheeks Crossroads', 36.0702781677246, 0.629545116137022, -79.2255630493164, -1.38274692695693, 218, 33, 'PPL', 'P'),
(85725, 'Cheeks Crossroads', 36.2502784729004, 0.632686714116934, -83.2125015258789, -1.45233213044739, 218, 50, 'PPL', 'P'),
(147752, 'Cheektowaga', 42.9033317565918, 0.748804399227969, -78.754997253418, -1.37453400447123, 218, 40, 'PPL', 'P'),
(144976, 'Cheesequake', 40.4247207641602, 0.705544476533913, -74.2880630493164, -1.29657129513971, 218, 37, 'PPL', 'P'),
(78014, 'Cheesetown', 39.9663887023926, 0.697545072988615, -77.6941680908203, -1.35601904278273, 218, 45, 'PPL', 'P'),
(173513, 'Cheeseville', 43.4688911437988, 0.758675272650293, -88.0805587768555, -1.53729575765252, 218, 57, 'PPL', 'P'),
(193446, 'Cheeseville', 41.521110534668, 0.724680087914459, -122.898612976074, -2.14498544256672, 218, 6, 'PPL', 'P'),
(143617, 'Cheever', 43.7988891601563, 0.764434824560781, -71.9108276367188, -1.25508071009487, 218, 36, 'PPL', 'P'),
(39752, 'Chef Menteur', 30.0694408416748, 0.52481074692088, -89.8019409179688, -1.56733954369997, 218, 22, 'PPL', 'P'),
(211732, 'Chefornak', 60.1599998474121, 1.04999007533663, -164.265823364258, -2.86697946620573, 218, 1, 'PPL', 'P'),
(39750, 'Chegby', 29.8783302307129, 0.521475237524097, -90.8072204589844, -1.58488498159363, 218, 22, 'PPL', 'P'),
(200560, 'Chehalem', 45.3280601501465, 0.791123893162091, -122.887496948242, -2.14479143128131, 218, 43, 'PPL', 'P'),
(207015, 'Chehalis', 46.6622200012207, 0.814409375311254, -122.962783813477, -2.14610543496316, 218, 56, 'PPL', 'P'),
(207016, 'Chehalis Village', 46.8036117553711, 0.816877126956348, -123.167778015137, -2.14968325872962, 218, 56, 'PPL', 'P'),
(1508, 'Chehaw', 32.4799995422363, 0.566882933058275, -85.7188873291016, -1.49607681503887, 218, 2, 'PPL', 'P'),
(19974, 'Chehaw', 31.7083301544189, 0.553414761504013, -84.0505599975586, -1.46695901010243, 218, 13, 'PPL', 'P'),
(207017, 'Chelan', 47.8411102294922, 0.834984891314179, -120.015281677246, -2.09466181797637, 218, 56, 'PPL', 'P'),
(207019, 'Chelan Falls', 47.8016700744629, 0.83429653075142, -119.984718322754, -2.09412838681002, 218, 56, 'PPL', 'P'),
(207020, 'Chelatchie', 45.9280586242676, 0.801595842042446, -122.378326416016, -2.13590472903982, 218, 56, 'PPL', 'P'),
(211733, 'Chelatna Lodge', 62.434440612793, 1.0896865553341, -151.404434204102, -2.64250587898069, 218, 1, 'PPL', 'P'),
(8046, 'Chelford', 35.5166702270508, 0.619882834807078, -90.2366714477539, -1.57492702280366, 218, 4, 'PPL', 'P'),
(39751, 'Chelly Landing', 32.1641693115234, 0.561370655655002, -91.5677795410156, -1.59815924173102, 218, 22, 'PPL', 'P'),
(124498, 'Chelmsford', 42.5997200012207, 0.743505374448984, -71.3677825927734, -1.24560278609139, 218, 23, 'PPL', 'P'),
(124502, 'Chelmsford Center', 42.5958290100098, 0.743437463841187, -71.2027816772461, -1.24272297684663, 218, 23, 'PPL', 'P'),
(1510, 'Chelsea', 33.3400001525879, 0.581892775278071, -86.6302795410156, -1.5119836099138, 218, 2, 'PPL', 'P'),
(19975, 'Chelsea', 34.5233306884766, 0.602545789268717, -85.4402770996094, -1.49121414920449, 218, 13, 'PPL', 'P'),
(29465, 'Chelsea', 38.6505584716797, 0.674579503065398, -85.5250015258789, -1.49269286939976, 218, 19, 'PPL', 'P'),
(32045, 'Chelsea', 37.9038887023926, 0.661547657166232, -96.7744369506836, -1.68903255655309, 218, 20, 'PPL', 'P'),
(45659, 'Chelsea', 39.4194412231445, 0.687999038640253, -76.2230606079102, -1.33034337355522, 218, 25, 'PPL', 'P'),
(75414, 'Chelsea', 36.5355606079102, 0.637665826669973, -95.4322204589844, -1.66560645949837, 218, 42, 'PPL', 'P'),
(78015, 'Chelsea', 39.8669395446777, 0.695809357748155, -75.4683303833008, -1.31717084617147, 218, 45, 'PPL', 'P'),
(80283, 'Chelsea', 32.3541717529297, 0.564686823844368, -80.8883285522461, -1.41176765967163, 218, 48, 'PPL', 'P'),
(100719, 'Chelsea', 37.1994400024414, 0.64925270794069, -76.5749969482422, -1.33648582145144, 218, 53, 'PPL', 'P'),
(114957, 'Chelsea', 41.9191703796387, 0.731627542829176, -92.3944396972656, -1.61258718325264, 218, 16, 'PPL', 'P'),
(124500, 'Chelsea', 42.3916702270508, 0.739874220881688, -71.033332824707, -1.2397655364561, 218, 23, 'PPL', 'P'),
(127097, 'Chelsea', 44.2502784729004, 0.77231305427648, -69.7177810668945, -1.21680482680187, 218, 26, 'PPL', 'P'),
(130180, 'Chelsea', 42.3180618286133, 0.738589511971834, -84.0205612182617, -1.46643543263212, 218, 27, 'PPL', 'P'),
(147756, 'Chelsea', 40.6005592346191, 0.708613436795093, -74.1952819824219, -1.29495196003889, 218, 40, 'PPL', 'P'),
(170016, 'Chelsea', 45.1686096191406, 0.788340956401986, -98.7391662597656, -1.723323551907, 218, 49, 'PPL', 'P'),
(171848, 'Chelsea', 43.9897193908691, 0.767765440399061, -72.4480590820313, -1.26445716766083, 218, 55, 'PPL', 'P'),
(173514, 'Chelsea', 45.2902793884277, 0.790464494476188, -90.3072204589844, -1.57615833533366, 218, 57, 'PPL', 'P'),
(177196, 'Chelsea', 40.4900016784668, 0.706683843427276, -80.5991668701172, -1.40672083624788, 218, 58, 'PPL', 'P'),
(196200, 'Chelsea', 48.1330604553223, 0.840080384006855, -105.337783813477, -1.83849115429915, 218, 31, 'PPL', 'P'),
(45660, 'Chelsea Beach', 39.1019401550293, 0.682457599623043, -76.5202789306641, -1.33553081188453, 218, 25, 'PPL', 'P'),
(45661, 'Chelsea Court', 38.3588905334473, 0.669488937220739, -75.5677795410156, -1.31890656141193, 218, 25, 'PPL', 'P'),
(13524, 'Chelsea Estates', 39.6916694641113, 0.692750317762036, -75.595832824707, -1.31939618357834, 218, 10, 'PPL', 'P'),
(45662, 'Chelsea Estates', 39.1338882446289, 0.683015198976279, -76.8816680908203, -1.34183824261028, 218, 25, 'PPL', 'P'),
(19976, 'Chelsea Heights', 33.7833290100098, 0.589630323509187, -84.3172225952148, -1.47161315042346, 218, 13, 'PPL', 'P'),
(70646, 'Chelsea Heights', 39.3555603027344, 0.686884106249891, -74.4630584716797, -1.29962554143587, 218, 37, 'PPL', 'P'),
(45664, 'Chelsea of Nottingham', 39.663890838623, 0.692265489285587, -76.0861129760742, -1.32795318647688, 218, 25, 'PPL', 'P'),
(19981, 'Chelsea Park', 33.9452781677246, 0.592456869532142, -84.2552795410156, -1.47053204017894, 218, 13, 'PPL', 'P'),
(45663, 'Chelsea Pines', 39.1066703796387, 0.682540157616836, -76.5255584716797, -1.33562295725825, 218, 25, 'PPL', 'P'),
(85726, 'Chelsey Village', 35.7244415283203, 0.623509128105385, -83.9402770996094, -1.46503421042458, 218, 50, 'PPL', 'P'),
(159998, 'Chelten Hills', 40.0786094665527, 0.699503694812313, -75.147216796875, -1.31156635681546, 218, 45, 'PPL', 'P'),
(45665, 'Cheltenham', 38.7355613708496, 0.676063083529654, -76.8266677856445, -1.34087830619536, 218, 25, 'PPL', 'P'),
(159999, 'Cheltenham', 40.0608291625977, 0.699193369966292, -75.0944366455078, -1.3106451693944, 218, 45, 'PPL', 'P'),
(45666, 'Cheltenham Acres', 38.7144393920898, 0.67569443545576, -76.8450012207031, -1.34119828500033, 218, 25, 'PPL', 'P'),
(160000, 'Cheltenham Village', 40.0666694641113, 0.699295302457015, -75.0999984741211, -1.31074224161613, 218, 45, 'PPL', 'P'),
(188296, 'Chelwood Park', 35.0961112976074, 0.612542696789629, -106.506393432617, -1.85888723982364, 218, 38, 'PPL', 'P'),
(108558, 'Chelyan', 38.1952781677246, 0.666633362741901, -81.4911117553711, -1.42228821124188, 218, 58, 'PPL', 'P'),
(200561, 'Chemawa', 45.0016708374023, 0.785427325011385, -122.991386413574, -2.14660464450949, 218, 43, 'PPL', 'P'),
(180673, 'Chemeketa Park', 37.1624984741211, 0.648607956640782, -121.979721069336, -2.12894775332421, 218, 6, 'PPL', 'P'),
(108559, 'Chemical (historical)', 38.7597198486328, 0.676484728509241, -80.2352828979492, -1.40036986283831, 218, 58, 'PPL', 'P'),
(200562, 'Chemult', 43.2166709899902, 0.754273200526447, -121.781669616699, -2.12549110338734, 218, 43, 'PPL', 'P'),
(119104, 'Chemung', 42.4152793884277, 0.740286278481351, -88.6666717529297, -1.54752535887368, 218, 18, 'PPL', 'P'),
(147758, 'Chemung', 42.0083312988281, 0.733183694433137, -76.6241683959961, -1.33734402511271, 218, 40, 'PPL', 'P'),
(160002, 'Chemung', 41.5905609130859, 0.725892225684609, -76.8391723632813, -1.34109655224669, 218, 45, 'PPL', 'P'),
(180672, 'Chemurgic', 37.464168548584, 0.653873092694896, -120.917778015137, -2.11041335055975, 218, 6, 'PPL', 'P'),
(63628, 'Chemway', 35.2719383239746, 0.615611457313727, -80.897216796875, -1.41192278880513, 218, 33, 'PPL', 'P'),
(211734, 'Chena Hot Springs', 65.0530624389648, 1.13539012806539, -146.055557250977, -2.54915036486462, 218, 1, 'PPL', 'P'),
(39753, 'Chenal', 30.6122207641602, 0.534284043681969, -91.3797225952148, -1.59487702884556, 218, 22, 'PPL', 'P'),
(39754, 'Chenal Crossing', 30.6344394683838, 0.534671833226198, -91.3616714477539, -1.5945619768886, 218, 22, 'PPL', 'P'),
(39755, 'Chenango', 30.3322200775146, 0.52939710979216, -91.2561111450195, -1.59271960204648, 218, 22, 'PPL', 'P'),
(93206, 'Chenango', 29.2538890838623, 0.510576683526625, -95.458610534668, -1.6660670532089, 218, 51, 'PPL', 'P'),
(147761, 'Chenango Bridge', 42.1666717529297, 0.735947256696312, -75.8627777099609, -1.32405525074738, 218, 40, 'PPL', 'P'),
(147763, 'Chenango Forks', 42.2355613708496, 0.737149607349455, -75.8486099243164, -1.32380797624017, 218, 40, 'PPL', 'P'),
(147764, 'Chenango Lake', 42.5849990844727, 0.743248445982819, -75.4355621337891, -1.31659893232738, 218, 40, 'PPL', 'P'),
(100720, 'Chenaults Shop', 37.985279083252, 0.66296818729168, -77.2850036621094, -1.34887777631968, 218, 53, 'PPL', 'P'),
(35221, 'Chenaultt', 38.0149993896484, 0.663486904493, -86.5180587768555, -1.51002498809011, 218, 21, 'PPL', 'P'),
(211735, 'Chenega (historical)', 60.2813911437988, 1.05210875314184, -148.076110839844, -2.58441567770334, 218, 1, 'PPL', 'P'),
(211736, 'Chenega Bay', 60.0633316040039, 1.04830289620704, -148.011383056641, -2.58328596476893, 218, 1, 'PPL', 'P'),
(173519, 'Chenequa', 43.1116714477539, 0.752440612801336, -88.392219543457, -1.542735264179, 218, 57, 'PPL', 'P'),
(32046, 'Cheney', 37.6300010681152, 0.656767416167594, -97.7822189331055, -1.70662167028863, 218, 20, 'PPL', 'P'),
(54010, 'Cheney', 36.9069404602051, 0.64414762786809, -92.4413909912109, -1.61340663792006, 218, 29, 'PPL', 'P'),
(114958, 'Cheney', 42.2541694641113, 0.737474379844391, -91.9272232055664, -1.60443271715287, 218, 16, 'PPL', 'P'),
(141483, 'Cheney', 40.7255592346191, 0.710795098360086, -96.595832824707, -1.68591532649715, 218, 35, 'PPL', 'P'),
(207022, 'Cheney', 47.4874992370605, 0.828813215225002, -117.574722290039, -2.05206602107915, 218, 56, 'PPL', 'P'),
(19978, 'Cheney (historical)', 33.6894416809082, 0.587991680490461, -84.4369430541992, -1.47370266661473, 218, 13, 'PPL', 'P'),
(100721, 'Cheney Creek', 37.7355613708496, 0.658609791009711, -77.8955612182617, -1.35953401594747, 218, 53, 'PPL', 'P'),
(93207, 'Cheneyboro', 31.9575004577637, 0.557763603695571, -96.3483276367188, -1.68159554605099, 218, 51, 'PPL', 'P'),
(39756, 'Cheneyville', 31.014720916748, 0.541308996584408, -92.2872161865234, -1.61071577995464, 218, 22, 'PPL', 'P'),
(119107, 'Cheneyville', 40.4691696166992, 0.706320255359453, -87.584716796875, -1.52864168253225, 218, 18, 'PPL', 'P'),
(39757, 'Cheniere', 32.5086097717285, 0.567382275762665, -92.2472229003906, -1.61001776543293, 218, 22, 'PPL', 'P'),
(39759, 'Cheniere au Tigre', 29.5680599212646, 0.516059999053043, -92.2030563354492, -1.60924691345541, 218, 22, 'PPL', 'P'),
(39758, 'Cheniere Caminada', 29.2105598449707, 0.509820445645583, -90.0502777099609, -1.57167383837408, 218, 22, 'PPL', 'P'),
(211737, 'Chenik', 59.2138900756836, 1.03347734473467, -154.138885498047, -2.69023105729546, 218, 1, 'PPL', 'P'),
(147766, 'Cheningo', 42.6597213745117, 0.744552595968631, -75.998893737793, -1.32643092359779, 218, 40, 'PPL', 'P'),
(19979, 'Chennault', 33.9075012207031, 0.591797537425266, -82.6022186279297, -1.44168068450957, 218, 13, 'PPL', 'P'),
(526, 'Chenoa', 36.6691703796387, 0.639997757099474, -83.8616714477539, -1.46366228298903, 218, 21, 'PPL', 'P'),
(119108, 'Chenoa', 40.7416687011719, 0.711076261592171, -88.7197189331055, -1.54845120682664, 218, 18, 'PPL', 'P'),
(35222, 'Chenowee', 37.5433311462402, 0.655254740668429, -83.4805603027344, -1.45701063869239, 218, 21, 'PPL', 'P'),
(72078, 'Chenoweth', 39.7311096191406, 0.693438678324794, -83.3574981689453, -1.45486279927324, 218, 41, 'PPL', 'P'),
(200563, 'Chenoweth', 45.6277809143066, 0.79635500733328, -121.242218017578, -2.11607589682753, 218, 43, 'PPL', 'P'),
(19980, 'Chenube (historical)', 31.874439239502, 0.556313911956187, -84.4958267211914, -1.47473038047939, 218, 13, 'PPL', 'P'),
(203379, 'Cheny Ridge Estates', 40.6074981689453, 0.708734544045664, -111.877777099609, -1.9526355702005, 218, 52, 'PPL', 'P'),
(63627, 'Cheoah', 35.3400001525879, 0.616799360317957, -83.7472229003906, -1.46166477901341, 218, 33, 'PPL', 'P'),
(80282, 'Cheohee', 34.9022216796875, 0.609158684571493, -83.0477828979492, -1.44945724805065, 218, 48, 'PPL', 'P'),
(147767, 'Chepachet', 42.910831451416, 0.748935293595547, -75.1213912963867, -1.31111561680096, 218, 40, 'PPL', 'P'),
(169313, 'Chepachet', 41.9150009155273, 0.73155477195239, -71.6719436645508, -1.2509113982503, 218, 47, 'PPL', 'P'),
(63630, 'Chepanuu (historical)', 36.1083297729492, 0.63020924193386, -76.2083282470703, -1.33008624535198, 218, 33, 'PPL', 'P'),
(169314, 'Chepiwanoxet', 41.672779083252, 0.727327203458971, -71.4486083984375, -1.24701346252081, 218, 47, 'PPL', 'P'),
(32047, 'Chepstow', 39.6236114501953, 0.691562481336833, -96.9005584716797, -1.6912337923521, 218, 20, 'PPL', 'P'),
(1511, 'Chepultepec', 33.9038887023926, 0.591734487086458, -86.4947204589844, -1.50961765760138, 218, 2, 'PPL', 'P'),
(114959, 'Chequest', 40.8283309936523, 0.712588803933282, -92.2455596923828, -1.60998873697705, 218, 16, 'PPL', 'P'),
(58977, 'Cheraw', 31.1555595397949, 0.543767094270551, -89.8433303833008, -1.56806192614566, 218, 30, 'PPL', 'P'),
(80285, 'Cheraw', 34.6974983215332, 0.605585587915961, -79.8836135864258, -1.39423207547401, 218, 48, 'PPL', 'P'),
(186528, 'Cheraw', 38.1069412231445, 0.665091592207827, -103.509719848633, -1.80658541917557, 218, 7, 'PPL', 'P'),
(45667, 'Cherby-Maurlyn Estates', 39.7150001525879, 0.693157515092709, -76.3608322143555, -1.33274794170346, 218, 25, 'PPL', 'P'),
(19982, 'Cherecobb Estates', 34.0750007629395, 0.594720955932873, -84.4438934326172, -1.47382397360239, 218, 13, 'PPL', 'P'),
(100727, 'Chericoke', 37.6347198486328, 0.656849774424305, -77.1127777099609, -1.34587186639731, 218, 53, 'PPL', 'P'),
(100722, 'Cheriton', 37.2894401550293, 0.650823506930646, -75.9716720581055, -1.32595581565932, 218, 53, 'PPL', 'P'),
(173517, 'Cherneyville', 44.4288902282715, 0.775430417490472, -87.7347183227539, -1.53125970304185, 218, 57, 'PPL', 'P'),
(211738, 'Chernofski', 53.4083290100098, 0.932151189213074, -167.550003051758, -2.92429921497972, 218, 1, 'PPL', 'P'),
(5, 'Cherokee', 30.9822196960449, 0.540741743272221, -98.7072219848633, -1.7227660191328, 218, 51, 'PPL', 'P'),
(1512, 'Cherokee', 34.7569389343262, 0.606623022318601, -87.9727783203125, -1.53541463381654, 218, 2, 'PPL', 'P'),
(19984, 'Cherokee', 34.1680603027344, 0.596345151302685, -84.5708312988281, -1.47603945731322, 218, 13, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(32048, 'Cherokee', 37.3458290100098, 0.651807678111485, -94.8086090087891, -1.65472238643933, 218, 20, 'PPL', 'P'),
(35223, 'Cherokee', 38.0774993896484, 0.664577735275496, -82.8377838134766, -1.44579207260043, 218, 21, 'PPL', 'P'),
(63632, 'Cherokee', 35.4741706848145, 0.619141077864464, -83.3150024414063, -1.45412110890965, 218, 33, 'PPL', 'P'),
(75416, 'Cherokee', 36.7544403076172, 0.641485998095637, -98.3563919067383, -1.71664287915449, 218, 42, 'PPL', 'P'),
(85728, 'Cherokee', 36.274169921875, 0.633103698564613, -82.3844375610352, -1.43787968784375, 218, 50, 'PPL', 'P'),
(108561, 'Cherokee', 37.4069404602051, 0.652874274128062, -81.3369369506836, -1.41959735327647, 218, 58, 'PPL', 'P'),
(114961, 'Cherokee', 42.749439239502, 0.74611846811057, -95.5513916015625, -1.66768638830972, 218, 16, 'PPL', 'P'),
(154699, 'Cherokee', 40.4377784729004, 0.705772376544196, -83.7925033569336, -1.46245507206689, 218, 41, 'PPL', 'P'),
(173518, 'Cherokee', 44.9022216796875, 0.783691609770926, -90.2177810668945, -1.57459732346071, 218, 57, 'PPL', 'P'),
(180677, 'Cherokee', 37.9816703796387, 0.662905203531899, -120.246673583984, -2.09870036861142, 218, 6, 'PPL', 'P'),
(207023, 'Cherokee', 48.4508285522461, 0.845626483555972, -119.465278625488, -2.08506245382718, 218, 56, 'PPL', 'P'),
(1513, 'Cherokee Acres', 31.2430591583252, 0.545294250708143, -85.414436340332, -1.49076314287389, 218, 2, 'PPL', 'P'),
(207024, 'Cherokee Bay Park', 47.3605613708496, 0.826597731514165, -122.049171447754, -2.13015989109436, 218, 56, 'PPL', 'P'),
(1514, 'Cherokee Beach', 33.292781829834, 0.581068660078746, -86.9077835083008, -1.51682696783028, 218, 2, 'PPL', 'P'),
(1516, 'Cherokee Bluffs', 32.6819381713867, 0.570407427023913, -85.9063873291016, -1.49934930738636, 218, 2, 'PPL', 'P'),
(1526, 'Cherokee Brook Estates', 33.526668548584, 0.585150753397619, -86.6877822875977, -1.5129872221706, 218, 2, 'PPL', 'P'),
(8047, 'Cherokee City', 36.2983283996582, 0.6335253435442, -94.5774993896484, -1.65068876265229, 218, 4, 'PPL', 'P'),
(20002, 'Cherokee Estates', 34.0930595397949, 0.595036141047884, -84.5952835083008, -1.47646622887791, 218, 13, 'PPL', 'P'),
(85729, 'Cherokee Estates', 36.1805610656738, 0.631469915814877, -82.896110534668, -1.44681006592711, 218, 50, 'PPL', 'P'),
(80295, 'Cherokee Falls', 35.0647201538086, 0.611994817974373, -81.5425033569336, -1.42318516389702, 218, 48, 'PPL', 'P'),
(1520, 'Cherokee Forest', 33.4686088562012, 0.584137420602844, -86.76611328125, -1.51435435591619, 218, 2, 'PPL', 'P'),
(19989, 'Cherokee Forest', 33.6605606079102, 0.587487610675136, -84.3194427490234, -1.47165189941732, 218, 13, 'PPL', 'P'),
(80287, 'Cherokee Forest', 34.8972206115723, 0.609071399466765, -82.3302764892578, -1.43693439881483, 218, 48, 'PPL', 'P'),
(35224, 'Cherokee Garden', 38.2455596923828, 0.66751094090011, -85.6774978637695, -1.49535443259319, 218, 21, 'PPL', 'P'),
(80289, 'Cherokee Gardens', 34.7075004577637, 0.605760158125415, -82.8958282470703, -1.4468051390791, 218, 48, 'PPL', 'P'),
(85730, 'Cherokee Grdens', 36.2750015258789, 0.633118212792554, -82.3891677856445, -1.43796224583754, 218, 50, 'PPL', 'P'),
(85732, 'Cherokee Heights', 35.7374992370605, 0.623737028115668, -88.0277786254883, -1.53637457023146, 218, 50, 'PPL', 'P'),
(19993, 'Cherokee Hills', 34.3133316040039, 0.598880613818495, -83.9300003051758, -1.46485484652516, 218, 13, 'PPL', 'P'),
(80292, 'Cherokee Hills', 34.2347183227539, 0.597508553224886, -82.1741714477539, -1.43420985186162, 218, 48, 'PPL', 'P'),
(85734, 'Cherokee Hills', 35.8624992370605, 0.625918689680661, -83.5138931274414, -1.45759240623252, 218, 50, 'PPL', 'P'),
(100723, 'Cherokee Hills', 37.2750015258789, 0.650571505312497, -80.1502838134766, -1.39888634895308, 218, 53, 'PPL', 'P'),
(93209, 'Cherokee Landing', 32.0622215270996, 0.559591331151692, -95.4280624389648, -1.66553388835867, 218, 51, 'PPL', 'P'),
(19994, 'Cherokee Meadows', 34.371940612793, 0.599903533993195, -83.8236083984375, -1.46299795745511, 218, 13, 'PPL', 'P'),
(19995, 'Cherokee Mobile Home Park', 34.0805587768555, 0.594817961575579, -84.5911102294922, -1.47639339142209, 218, 13, 'PPL', 'P'),
(177911, 'Cherokee Mobile Village', 33.4172210693359, 0.583240534526732, -111.609443664551, -1.94795226826554, 218, 5, 'PPL', 'P'),
(19996, 'Cherokee Park', 32.4055595397949, 0.56558370992048, -84.9611129760742, -1.48285115759137, 218, 13, 'PPL', 'P'),
(85736, 'Cherokee Park', 36.2730598449707, 0.633084324067683, -83.2547225952148, -1.45306902712102, 218, 50, 'PPL', 'P'),
(54013, 'Cherokee Pass', 37.4894409179688, 0.65431417875044, -90.3050003051758, -1.5761195863398, 218, 29, 'PPL', 'P'),
(19997, 'Cherokee Plantation', 30.8902797698975, 0.539137088846907, -83.3119430541992, -1.4540677125298, 218, 13, 'PPL', 'P'),
(85739, 'Cherokee Ridge', 36.0044403076172, 0.62839602870568, -84.0169372558594, -1.46637218255624, 218, 50, 'PPL', 'P'),
(19998, 'Cherokee South', 34.0786094665527, 0.594783939692654, -84.5986099243164, -1.47652428578967, 218, 13, 'PPL', 'P'),
(80294, 'Cherokee Springs', 35.0497207641602, 0.611733029239218, -81.89111328125, -1.42926955488147, 218, 48, 'PPL', 'P'),
(180679, 'Cherokee Strip', 35.4672203063965, 0.619019770876811, -119.259719848633, -2.08147477636468, 218, 6, 'PPL', 'P'),
(20000, 'Cherokee Trail', 34.2833290100098, 0.598356969769158, -83.9161071777344, -1.46461236570791, 218, 13, 'PPL', 'P'),
(1524, 'Cherokee Village', 31.7294406890869, 0.553783209840825, -86.3369369506836, -1.50686381587618, 218, 2, 'PPL', 'P'),
(8048, 'Cherokee Village', 36.297779083252, 0.633515756164275, -91.5158309936523, -1.59725256853791, 218, 4, 'PPL', 'P'),
(20001, 'Cherokee Village', 31.8174991607666, 0.55532012010591, -81.601936340332, -1.42422246514161, 218, 13, 'PPL', 'P'),
(13525, 'Cherokee Woods', 39.6749992370605, 0.692459367412945, -75.709716796875, -1.32138383385792, 218, 10, 'PPL', 'P'),
(63637, 'Cherokee Woods', 36.1074981689453, 0.630194727705919, -81.7622222900391, -1.42701998270868, 218, 33, 'PPL', 'P'),
(85741, 'Cherokee Woods', 35.0730590820313, 0.612140359727945, -85.2094421386719, -1.48718531910742, 218, 50, 'PPL', 'P'),
(63638, 'Cherry', 35.8486099243164, 0.625676275442437, -76.4216690063477, -1.33380974403007, 218, 33, 'PPL', 'P'),
(85743, 'Cherry', 35.6766700744629, 0.622675358947108, -89.7083282470703, -1.56570569437121, 218, 50, 'PPL', 'P'),
(112639, 'Cherry', 39.0058288574219, 0.68078014103143, -81.3408279418945, -1.41966526388426, 218, 58, 'PPL', 'P'),
(119110, 'Cherry', 41.4269409179688, 0.723036518047717, -89.2133331298828, -1.55706639979499, 218, 18, 'PPL', 'P'),
(134646, 'Cherry', 47.4008293151855, 0.827300539725837, -92.7069396972656, -1.61804133716512, 218, 28, 'PPL', 'P'),
(177912, 'Cherry', 34.5880584716797, 0.603675502203128, -112.041107177734, -1.95548621783132, 218, 5, 'PPL', 'P'),
(180680, 'Cherry (historical)', 38.2852783203125, 0.668204161731857, -122.746391296387, -2.14232867306326, 218, 6, 'PPL', 'P'),
(100726, 'Cherry Acres', 37.040828704834, 0.64648441856658, -76.3436126708984, -1.33244740397444, 218, 53, 'PPL', 'P'),
(130181, 'Cherry Beach', 42.6847190856934, 0.744988888334213, -82.5097198486328, -1.44006627625676, 218, 27, 'PPL', 'P'),
(130182, 'Cherry Bend', 44.7936096191406, 0.781795971707007, -85.6474990844727, -1.49483085512288, 218, 27, 'PPL', 'P'),
(54012, 'Cherry Box', 39.9247207641602, 0.696817830273941, -92.2350006103516, -1.60980444622961, 218, 29, 'PPL', 'P'),
(85744, 'Cherry Branch', 35.9883308410645, 0.628114865473595, -84.9499969482422, -1.48265714630596, 218, 50, 'PPL', 'P'),
(160003, 'Cherry City', 40.4947204589844, 0.706766201683987, -79.9630584716797, -1.39561865029556, 218, 45, 'PPL', 'P'),
(45668, 'Cherry Corner', 39.4272193908691, 0.68813479327682, -76.9599990844727, -1.34320537635587, 218, 25, 'PPL', 'P'),
(160004, 'Cherry Corner', 40.8858299255371, 0.713592349611051, -78.6413879394531, -1.37255114788162, 218, 45, 'PPL', 'P'),
(58979, 'Cherry Creek', 34.3505592346191, 0.599530358545447, -88.9875030517578, -1.55312492138168, 218, 30, 'PPL', 'P'),
(85745, 'Cherry Creek', 36.0208282470703, 0.628682052206754, -85.4458312988281, -1.49131108826817, 218, 50, 'PPL', 'P'),
(108562, 'Cherry Creek', 37.6763916015625, 0.657577083718005, -81.1033325195313, -1.41552018680561, 218, 58, 'PPL', 'P'),
(147768, 'Cherry Creek', 42.2944412231445, 0.73817725463509, -79.0999984741211, -1.3805554116959, 218, 40, 'PPL', 'P'),
(190030, 'Cherry Creek', 39.9005584716797, 0.696396118715327, -114.88500213623, -2.00512154843794, 218, 39, 'PPL', 'P'),
(194721, 'Cherry Creek', 42.098331451416, 0.734754493423093, -112.228057861328, -1.95874912279888, 218, 17, 'PPL', 'P'),
(202003, 'Cherry Creek', 44.6055603027344, 0.778513891979593, -101.499443054199, -1.77149947023627, 218, 49, 'PPL', 'P'),
(199874, 'Cherry Creek (historical)', 40.5722198486328, 0.708118821201638, -117.887496948242, -2.05752496868159, 218, 39, 'PPL', 'P'),
(180681, 'Cherry Creek Acres', 39.1041717529297, 0.682496548353986, -121.081672668457, -2.1132738518866, 218, 6, 'PPL', 'P'),
(20003, 'Cherry Creek Hills', 30.9083309173584, 0.539452140803863, -83.2986068725586, -1.45383495225052, 218, 13, 'PPL', 'P'),
(63640, 'Cherry Crossroads', 36.0483283996582, 0.629162020414214, -77.7024993896484, -1.35616445137825, 218, 33, 'PPL', 'P'),
(85746, 'Cherry Crossroads', 36.5930595397949, 0.638669372347742, -85.7324981689453, -1.49631436900811, 218, 50, 'PPL', 'P'),
(160012, 'Cherry Dale', 40.0800018310547, 0.69952799615726, -75.2616729736328, -1.31356399394912, 218, 45, 'PPL', 'P'),
(54015, 'Cherry Dell (historical)', 39.8899993896484, 0.696211827967894, -91.8358306884766, -1.60283761681797, 218, 29, 'PPL', 'P'),
(70647, 'Cherry Downs', 39.8891716003418, 0.69619738031898, -74.9561080932617, -1.30823088070819, 218, 37, 'PPL', 'P'),
(108563, 'Cherry Falls', 38.4655609130859, 0.671350686559786, -80.394172668457, -1.40314301248141, 218, 58, 'PPL', 'P'),
(160005, 'Cherry Flats', 41.7316703796387, 0.728355050481687, -77.1750030517578, -1.34695790348985, 218, 45, 'PPL', 'P'),
(72079, 'Cherry Fork', 38.8875007629395, 0.6787149261851, -83.6144409179688, -1.45934729623282, 218, 41, 'PPL', 'P'),
(1528, 'Cherry Grove', 34.913890838623, 0.609362349815856, -87.2027816772461, -1.52197565716573, 218, 2, 'PPL', 'P'),
(35225, 'Cherry Grove', 38.6016693115234, 0.673726226252137, -84.570556640625, -1.47603466362326, 218, 21, 'PPL', 'P'),
(39760, 'Cherry Grove', 30.7194404602051, 0.536155380400941, -92.9258270263672, -1.62186164174884, 218, 22, 'PPL', 'P'),
(45676, 'Cherry Grove', 38.9480590820313, 0.679771868242726, -76.8494415283203, -1.34127578298805, 218, 25, 'PPL', 'P'),
(63646, 'Cherry Grove', 36.3069381713867, 0.633675612408708, -79.459716796875, -1.38683368080771, 218, 33, 'PPL', 'P'),
(72080, 'Cherry Grove', 39.0724983215332, 0.681943742690712, -84.3219375610352, -1.47169544210114, 218, 41, 'PPL', 'P'),
(85747, 'Cherry Grove', 36.1150016784668, 0.630325688652524, -87.9886093139648, -1.53569093677964, 218, 50, 'PPL', 'P'),
(100730, 'Cherry Grove', 38.586669921875, 0.673464437516982, -78.8716735839844, -1.37657039059876, 218, 53, 'PPL', 'P'),
(108565, 'Cherry Grove', 38.4394416809082, 0.670894819960192, -81.9222183227539, -1.42981244026968, 218, 58, 'PPL', 'P'),
(122361, 'Cherry Grove', 40.1355590820313, 0.700497653110158, -86.9044418334961, -1.5167686446024, 218, 19, 'PPL', 'P'),
(134650, 'Cherry Grove', 43.5875015258789, 0.760745414344639, -92.2886123657227, -1.61074014787861, 218, 28, 'PPL', 'P'),
(147771, 'Cherry Grove', 40.6588897705078, 0.709631496700803, -73.0894393920898, -1.27565136582881, 218, 40, 'PPL', 'P'),
(160007, 'Cherry Grove', 41.6961097717285, 0.727734400789644, -79.1447219848633, -1.38133598421141, 218, 45, 'PPL', 'P'),
(200564, 'Cherry Grove', 45.4477806091309, 0.793213409353368, -123.242218017578, -2.15098248186742, 218, 43, 'PPL', 'P'),
(207025, 'Cherry Grove', 45.795280456543, 0.799278425840887, -122.577781677246, -2.13938588005872, 218, 56, 'PPL', 'P'),
(8051, 'Cherry Grove (historical)', 34.2519416809082, 0.597809157532929, -92.4124984741211, -1.61290236836765, 218, 4, 'PPL', 'P'),
(80296, 'Cherry Grove Beach', 33.827220916748, 0.590396381796748, -78.6430587768555, -1.37258030949555, 218, 48, 'PPL', 'P'),
(100734, 'Cherry Grove Estates', 36.8977813720703, 0.643987771623658, -76.5405578613281, -1.33588474599341, 218, 53, 'PPL', 'P'),
(200565, 'Cherry Heights', 45.6030616760254, 0.795923575236687, -121.239723205566, -2.11603235414371, 218, 43, 'PPL', 'P'),
(8053, 'Cherry Hill', 34.5858306884766, 0.603636620051213, -93.9980621337891, -1.64057567472883, 218, 4, 'PPL', 'P'),
(13527, 'Cherry Hill', 39.6819381713867, 0.692580474663516, -75.773063659668, -1.32248944518447, 218, 10, 'PPL', 'P'),
(45674, 'Cherry Hill', 39.0163917541504, 0.68096449835789, -76.932502746582, -1.34272547472744, 218, 25, 'PPL', 'P'),
(80300, 'Cherry Hill', 33.4180603027344, 0.583255181912728, -79.6022186279297, -1.38932080694974, 218, 48, 'PPL', 'P'),
(85748, 'Cherry Hill', 36.0741691589355, 0.629613026744819, -85.727783203125, -1.49623207733042, 218, 50, 'PPL', 'P'),
(100732, 'Cherry Hill', 37.2758293151855, 0.650585952961411, -80.0069427490234, -1.39638457542506, 218, 53, 'PPL', 'P'),
(119112, 'Cherry Hill', 41.5233306884766, 0.72471883690832, -88.0144424438477, -1.53614180995219, 218, 18, 'PPL', 'P'),
(130184, 'Cherry Hill', 42.3061103820801, 0.738380919879454, -83.5361099243164, -1.45798016248723, 218, 27, 'PPL', 'P'),
(144978, 'Cherry Hill', 40.9208297729492, 0.714203212186088, -74.0388870239258, -1.29222235307961, 218, 37, 'PPL', 'P'),
(147770, 'Cherry Hill', 42.0108299255371, 0.733227303695987, -79.4116668701172, -1.38599505138045, 218, 40, 'PPL', 'P'),
(160011, 'Cherry Hill', 40.2066688537598, 0.701738752757162, -76.8630599975586, -1.34151347011534, 218, 45, 'PPL', 'P'),
(26768, 'Cherry Hill Estates', 38.4288902282715, 0.670710662370813, -87.7627792358398, -1.53174945836632, 218, 18, 'PPL', 'P'),
(70649, 'Cherry Hill Estates', 39.9333305358887, 0.696968099138449, -75.0194396972656, -1.30933622571862, 218, 37, 'PPL', 'P'),
(80301, 'Cherry Hill Estates', 32.4049987792969, 0.565573922803474, -80.7336120605469, -1.40906734748435, 218, 48, 'PPL', 'P'),
(85749, 'Cherry Hill Estates', 35.9319381713867, 0.627130627713729, -86.4688873291016, -1.50916678442883, 218, 50, 'PPL', 'P'),
(70650, 'Cherry Hill Mall', 39.9358291625977, 0.697011708401299, -75.0094375610352, -1.30916165550917, 218, 37, 'PPL', 'P'),
(100733, 'Cherry Hill Park', 37.2724990844727, 0.65052782947062, -80.0036087036133, -1.39632638535524, 218, 53, 'PPL', 'P'),
(203387, 'Cherry Hills', 40.6152801513672, 0.708870365261258, -111.811393737793, -1.95147696196826, 218, 52, 'PPL', 'P'),
(186529, 'Cherry Hills Village', 39.6416702270508, 0.691877666451844, -104.958892822266, -1.83187825899638, 218, 7, 'PPL', 'P'),
(130185, 'Cherry Island', 42.0805587768555, 0.734444301735126, -83.1947174072266, -1.45202173902234, 218, 27, 'PPL', 'P'),
(15511, 'Cherry Lake', 28.9105606079102, 0.504584471205406, -81.9538879394531, -1.43036517935393, 218, 12, 'PPL', 'P'),
(63643, 'Cherry Lane', 36.4419403076172, 0.636031844183155, -81.0183334350586, -1.41403667292038, 218, 33, 'PPL', 'P'),
(160013, 'Cherry Lane', 40.5691719055176, 0.708065624558864, -79.5599975585938, -1.38858391027611, 218, 45, 'PPL', 'P'),
(85751, 'Cherry Lane Acres', 35.9297218322754, 0.627091945298895, -86.3986129760742, -1.50794026558879, 218, 50, 'PPL', 'P'),
(20004, 'Cherry Log', 34.7802810668945, 0.607030419386356, -84.3908309936523, -1.47289785933331, 218, 13, 'PPL', 'P'),
(160014, 'Cherry Mills', 41.5036087036133, 0.724374623337427, -76.4591674804688, -1.33446421586796, 218, 45, 'PPL', 'P'),
(85752, 'Cherry Mount (historical)', 36.5269393920898, 0.637515358068384, -86.6374969482422, -1.51210957743337, 218, 50, 'PPL', 'P'),
(93210, 'Cherry Mountain', 30.3824996948242, 0.530274654660855, -98.9230575561523, -1.72653306049471, 218, 51, 'PPL', 'P'),
(63645, 'Cherry Oaks', 35.5669403076172, 0.620760213228205, -77.3313903808594, -1.34968737729107, 218, 33, 'PPL', 'P'),
(177596, 'Cherry Park', 41.8113899230957, 0.729746418993199, -72.8874969482422, -1.27212680528415, 218, 8, 'PPL', 'P'),
(26770, 'Cherry Point', 39.7991714477539, 0.694626581329024, -87.7211074829102, -1.53102214907262, 218, 18, 'PPL', 'P'),
(45675, 'Cherry Point', 38.8300018310547, 0.677711380507331, -76.5327835083008, -1.33574905793587, 218, 25, 'PPL', 'P'),
(80302, 'Cherry Point Landing', 32.3261108398438, 0.564197068519903, -80.9172210693359, -1.41227192922404, 218, 48, 'PPL', 'P'),
(742, 'Cherry Point Landing (historical)', 34.9416694641113, 0.609847178292305, -76.8691711425781, -1.341620129717, 218, 33, 'PPL', 'P'),
(72081, 'Cherry Point Mobile Home Park', 39.9105606079102, 0.696570688924782, -83.7416687011719, -1.46156783994973, 218, 41, 'PPL', 'P'),
(144977, 'Cherry Quay', 40.0263900756836, 0.698592294508261, -74.1233291625977, -1.29369614642686, 218, 37, 'PPL', 'P'),
(20005, 'Cherry Ridge', 33.6813888549805, 0.587851132163932, -84.2425003051758, -1.47030900043765, 218, 13, 'PPL', 'P'),
(160015, 'Cherry Ridge', 41.5316696166992, 0.724864378661893, -75.2788925170898, -1.31386453167814, 218, 45, 'PPL', 'P'),
(39761, 'Cherry Ridge (historical)', 32.9186096191406, 0.57453812303268, -92.475830078125, -1.61400771337809, 218, 22, 'PPL', 'P'),
(196201, 'Cherry Ridge (historical)', 48.9147186279297, 0.853722892743976, -109.005828857422, -1.90251061742746, 218, 31, 'PPL', 'P'),
(196202, 'Cherry Ridge Ranch', 48.9144401550293, 0.853718032474987, -108.998329162598, -1.90237972305988, 218, 31, 'PPL', 'P'),
(108566, 'Cherry Run', 39.627498626709, 0.691630325365603, -78.0341720581055, -1.3619532314817, 218, 58, 'PPL', 'P'),
(160019, 'Cherry Run', 41.6341705322266, 0.726653357124153, -78.9966735839844, -1.37875205216376, 218, 45, 'PPL', 'P'),
(93211, 'Cherry Spring', 30.483060836792, 0.532029777687758, -99.0088882446289, -1.72803108860788, 218, 51, 'PPL', 'P'),
(196203, 'Cherry Springs (historical)', 45.3052787780762, 0.790726283211343, -108.989166259766, -1.90221980023642, 218, 31, 'PPL', 'P'),
(75420, 'Cherry Tree', 35.7413902282715, 0.623804938723465, -94.6430587768555, -1.65183298981465, 218, 42, 'PPL', 'P'),
(160020, 'Cherry Tree', 40.726390838623, 0.710809612588027, -78.8069381713867, -1.3754405445063, 218, 45, 'PPL', 'P'),
(45677, 'Cherry Tree Hills', 39.439998626709, 0.688357833018114, -76.9355621337891, -1.34277887110729, 218, 25, 'PPL', 'P'),
(203390, 'Cherry Tree Lane', 40.6233291625977, 0.70901084700876, -111.840278625488, -1.95198109836261, 218, 52, 'PPL', 'P'),
(8055, 'Cherry Valley', 35.4019393920898, 0.617880403983448, -90.753059387207, -1.58393969256471, 218, 4, 'PPL', 'P'),
(45679, 'Cherry Valley', 39.1388893127441, 0.683102484081006, -77.0736083984375, -1.34518823294549, 218, 25, 'PPL', 'P'),
(54014, 'Cherry Valley', 37.954719543457, 0.662434822704364, -91.2663879394531, -1.5928989659459, 218, 29, 'PPL', 'P'),
(70655, 'Cherry Valley', 39.936939239502, 0.697031082898229, -74.9911117553711, -1.30884180986225, 218, 37, 'PPL', 'P'),
(85760, 'Cherry Valley', 36.098331451416, 0.630034738303433, -86.1638870239258, -1.50384352488392, 218, 50, 'PPL', 'P'),
(119113, 'Cherry Valley', 42.2347183227539, 0.737134893384433, -88.9488906860352, -1.55245100846783, 218, 18, 'PPL', 'P'),
(124503, 'Cherry Valley', 42.2430610656738, 0.737280501717033, -71.8736114501953, -1.254431165105, 218, 23, 'PPL', 'P'),
(147772, 'Cherry Valley', 42.7955589294434, 0.746923408550046, -74.7536087036133, -1.30469659962554, 218, 40, 'PPL', 'P'),
(154702, 'Cherry Valley', 40.3019409179688, 0.703401563962781, -80.879997253418, -1.41162225107611, 218, 41, 'PPL', 'P'),
(160023, 'Cherry Valley', 40.3505592346191, 0.704250113665107, -80.3486099243164, -1.40234779257991, 218, 45, 'PPL', 'P'),
(169315, 'Cherry Valley', 41.8708305358887, 0.730783853395839, -71.6750030517578, -1.25096479463016, 218, 47, 'PPL', 'P'),
(180682, 'Cherry Valley', 33.9724998474121, 0.592931977470613, -116.976387023926, -2.04162310065468, 218, 6, 'PPL', 'P'),
(188297, 'Cherry Valley (historical)', 35.7924995422363, 0.624696964530587, -104.842781066895, -1.82985172656488, 218, 38, 'PPL', 'P'),
(45680, 'Cherry Walk Estates', 38.399169921875, 0.670191945169493, -75.7861099243164, -1.32271714545767, 218, 25, 'PPL', 'P'),
(45681, 'Cherry Wood', 39.6616706848145, 0.692226740291726, -75.8566665649414, -1.32394859114572, 218, 25, 'PPL', 'P'),
(203392, 'Cherry Wood Estates', 40.5911102294922, 0.70844852054459, -111.872222900391, -1.95253863113682, 218, 52, 'PPL', 'P'),
(85753, 'Cherrybrook', 36.0127792358398, 0.628541570459253, -84.0116729736328, -1.46628030349863, 218, 50, 'PPL', 'P'),
(100738, 'Cherrydale', 38.8969383239746, 0.678879642698522, -77.1086120605469, -1.34579916209955, 218, 53, 'PPL', 'P'),
(100736, 'Cherrydale West', 37.627498626709, 0.656723740325717, -77.3272171020508, -1.34961453983525, 218, 53, 'PPL', 'P'),
(63647, 'Cherryfield', 35.1736106872559, 0.61389531630728, -82.8047180175781, -1.44521496559221, 218, 33, 'PPL', 'P'),
(127098, 'Cherryfield', 44.6072196960449, 0.778542853856448, -67.9263916015625, -1.18553918244629, 218, 26, 'PPL', 'P'),
(45706, 'Cherryfield (historical)', 38.3683280944824, 0.66965365373416, -77.2222213745117, -1.34778201868917, 218, 25, 'PPL', 'P'),
(180683, 'Cherryland', 37.6794395446777, 0.65763028036078, -122.10221862793, -2.13108573904733, 218, 6, 'PPL', 'P'),
(194722, 'Cherrylane', 46.5161094665527, 0.811859265409448, -116.680557250977, -2.03645989709128, 218, 17, 'PPL', 'P'),
(147773, 'Cherryplain', 42.6291694641113, 0.744019364539369, -73.3586120605469, -1.28034931514976, 218, 40, 'PPL', 'P'),
(80303, 'Cherrys Crossing', 34.6549987792969, 0.604843830973346, -82.8352813720703, -1.44574839675855, 218, 48, 'PPL', 'P'),
(100737, 'Cherrystone', 37.3061103820801, 0.651114457279737, -76.0019378662109, -1.32648405366153, 218, 53, 'PPL', 'P'),
(45682, 'Cherrytown', 39.6875, 0.69267754688525, -77.0250015258789, -1.34433988298024, 218, 25, 'PPL', 'P'),
(147774, 'Cherrytown', 41.8250007629395, 0.729983972962434, -74.329719543457, -1.2972983381173, 218, 40, 'PPL', 'P'),
(160029, 'Cherrytown', 40.2938919067383, 0.703261082215279, -78.241943359375, -1.36557952478001, 218, 45, 'PPL', 'P'),
(1530, 'Cherrytree', 34.6455612182617, 0.604679114459925, -86.4444427490234, -1.5087401460222, 218, 2, 'PPL', 'P'),
(160030, 'Cherrytree', 41.5327796936035, 0.724883753158823, -79.7186126708984, -1.39135226622925, 218, 45, 'PPL', 'P'),
(13529, 'Cherrytree Landing', 38.6430587768555, 0.674448608697821, -75.5913925170898, -1.31931868559062, 218, 10, 'PPL', 'P'),
(29463, 'Cherryvale', 39.4633293151855, 0.688765030348787, -87.2394409179688, -1.52261548161762, 218, 19, 'PPL', 'P'),
(32054, 'Cherryvale', 37.2702789306641, 0.650489080476759, -95.5522232055664, -1.66770090253766, 218, 20, 'PPL', 'P'),
(80304, 'Cherryvale', 33.9555587768555, 0.592636300010586, -80.4583282470703, -1.40426273856173, 218, 48, 'PPL', 'P'),
(54017, 'Cherryville', 37.8519401550293, 0.660640983973114, -91.2766723632813, -1.59307846300337, 218, 29, 'PPL', 'P'),
(63649, 'Cherryville', 35.3786087036133, 0.617473206652775, -81.3791732788086, -1.4203345162662, 218, 33, 'PPL', 'P'),
(144979, 'Cherryville', 40.5611114501953, 0.70792494307428, -74.9036102294922, -1.30731462013514, 218, 37, 'PPL', 'P'),
(160032, 'Cherryville', 40.7538909912109, 0.711289580795486, -75.5388870239258, -1.31840229185953, 218, 45, 'PPL', 'P'),
(194723, 'Cherryville', 42.0405616760254, 0.733746220634389, -111.748611450195, -1.95038120433774, 218, 17, 'PPL', 'P'),
(200566, 'Cherryville', 45.3672218322754, 0.79180739345586, -122.15389251709, -2.13198761855048, 218, 43, 'PPL', 'P'),
(72082, 'Cherryville (historical)', 38.6111106872559, 0.673891009344585, -82.5308303833008, -1.44043472459357, 218, 41, 'PPL', 'P'),
(188298, 'Cherryville (historical)', 33.5694389343262, 0.585897237451168, -107.604438781738, -1.87805174650201, 218, 38, 'PPL', 'P'),
(20007, 'Cherrywood', 34.2750015258789, 0.598211627752667, -83.8697204589844, -1.46380276473653, 218, 13, 'PPL', 'P'),
(45685, 'Cherrywood', 39.0966682434082, 0.682365587407381, -76.8838882446289, -1.34187699160414, 218, 25, 'PPL', 'P'),
(70652, 'Cherrywood', 39.7983283996582, 0.694611867364001, -75.0255584716797, -1.30944301847834, 218, 37, 'PPL', 'P'),
(85755, 'Cherrywood', 36.0927810668945, 0.629937865818781, -88.5144424438477, -1.54486845621216, 218, 50, 'PPL', 'P'),
(203395, 'Cherrywood Condo', 40.5902786254883, 0.708434006316649, -111.871391296387, -1.95252411690888, 218, 52, 'PPL', 'P'),
(203396, 'Cherrywood Condominium', 41.2425003051758, 0.719817422080084, -111.948608398438, -1.95387180957851, 218, 52, 'PPL', 'P'),
(45686, 'Cherrywood Estates', 39.6313896179199, 0.6916982359734, -76.3905563354492, -1.3332667254838, 218, 25, 'PPL', 'P'),
(35226, 'Cherrywood Village', 38.2602806091309, 0.667767869366275, -85.6544418334961, -1.49495202895248, 218, 21, 'PPL', 'P'),
(80305, 'Cheryl Fields', 34.9463882446289, 0.609929536549016, -82.1538925170898, -1.43385591775275, 218, 48, 'PPL', 'P'),
(45687, 'Chesaco Park', 39.3133316040039, 0.686147076418212, -76.4961090087891, -1.33510896716787, 218, 25, 'PPL', 'P'),
(130187, 'Chesaning', 43.1847190856934, 0.753715534594184, -84.1149978637695, -1.46808366303078, 218, 27, 'PPL', 'P'),
(54018, 'Chesapeake', 37.1169395446777, 0.647812803318311, -93.6813888549805, -1.63504868336053, 218, 29, 'PPL', 'P'),
(72083, 'Chesapeake', 38.4277801513672, 0.670691287873882, -82.4572219848633, -1.43915001568372, 218, 41, 'PPL', 'P'),
(100740, 'Chesapeake', 37.3077812194824, 0.651143618893674, -75.9522171020508, -1.32561626262033, 218, 53, 'PPL', 'P'),
(108568, 'Chesapeake', 39.5069389343262, 0.689526161788331, -80.1522216796875, -1.39892017109893, 218, 58, 'PPL', 'P'),
(45689, 'Chesapeake Beach', 38.6861114501953, 0.675200019599386, -76.5350036621094, -1.33578780692973, 218, 25, 'PPL', 'P'),
(100742, 'Chesapeake Beach', 36.9152793884277, 0.644293169621663, -76.1205596923828, -1.32855439509296, 218, 53, 'PPL', 'P'),
(45690, 'Chesapeake City', 39.5308303833008, 0.689943146236011, -75.8077774047852, -1.32309531433246, 218, 25, 'PPL', 'P'),
(45691, 'Chesapeake Cove', 39.5763893127441, 0.690738299558481, -75.8591690063477, -1.3239922669876, 218, 25, 'PPL', 'P'),
(45692, 'Chesapeake Cove Estates', 38.3766708374023, 0.66979926206676, -76.4158325195313, -1.33370787811837, 218, 25, 'PPL', 'P'),
(45693, 'Chesapeake Estates', 38.9313888549805, 0.679480917893634, -76.3591690063477, -1.33271891324757, 218, 25, 'PPL', 'P'),
(45694, 'Chesapeake Haven', 39.398609161377, 0.68763545057243, -76.0347213745117, -1.32705623382174, 218, 25, 'PPL', 'P'),
(45695, 'Chesapeake Heights', 38.3766708374023, 0.66979926206676, -75.5447235107422, -1.31850415777122, 218, 25, 'PPL', 'P'),
(100743, 'Chesapeake Heights', 37.0352783203125, 0.646387546081928, -76.3038864135742, -1.33175404998464, 218, 53, 'PPL', 'P'),
(45696, 'Chesapeake Heights on the Bay', 38.5666694641113, 0.6731153636771, -76.5269393920898, -1.33564705886612, 218, 25, 'PPL', 'P'),
(45698, 'Chesapeake Landing', 39.2655601501465, 0.685313307259935, -76.1522216796875, -1.32910700101915, 218, 25, 'PPL', 'P'),
(45699, 'Chesapeake Mobile Court', 39.148609161377, 0.683272127442444, -76.7186126708984, -1.33899238866942, 218, 25, 'PPL', 'P'),
(45700, 'Chesapeake Oaks', 39.0361099243164, 0.681308645349756, -76.4111099243164, -1.33362545328264, 218, 25, 'PPL', 'P'),
(45701, 'Chesapeake Overlook', 38.7249984741211, 0.675878726203193, -76.5486068725586, -1.33602522774091, 218, 25, 'PPL', 'P'),
(45702, 'Chesapeake Ranch Estates', 38.3461112976074, 0.669265897479445, -76.4180603027344, -1.33374676027029, 218, 25, 'PPL', 'P'),
(45704, 'Chesapeake Terrace', 39.2205581665039, 0.684527874475444, -76.4541702270508, -1.33437699734226, 218, 25, 'PPL', 'P'),
(45705, 'Chesapeake Woods', 38.3591690063477, 0.669493797489728, -76.4361114501953, -1.33406181222725, 218, 25, 'PPL', 'P'),
(207026, 'Chesaw', 48.9461097717285, 0.854270771559233, -119.050277709961, -2.07781932145243, 218, 56, 'PPL', 'P'),
(39765, 'Chesbrough', 30.8486099243164, 0.53840981284272, -90.4561080932617, -1.57875691476731, 218, 22, 'PPL', 'P'),
(100745, 'Chesconessex', 37.7519416809082, 0.658895681352731, -75.7666702270508, -1.3223778587348, 218, 53, 'PPL', 'P'),
(100746, 'Chesdin Manor', 37.2230606079102, 0.649664965277434, -77.5430603027344, -1.35338171435523, 218, 53, 'PPL', 'P'),
(143618, 'Chesham', 42.9305610656738, 0.749279640324494, -72.149169921875, -1.25924056771758, 218, 36, 'PPL', 'P'),
(45714, 'Cheshaven', 39.3861083984375, 0.687417271100125, -76.0305633544922, -1.32698366268203, 218, 25, 'PPL', 'P'),
(124504, 'Cheshire', 42.561939239502, 0.74284597576308, -73.163330078125, -1.27694100158668, 218, 23, 'PPL', 'P'),
(147775, 'Cheshire', 42.8213882446289, 0.74737421514357, -77.3277816772461, -1.34962439353129, 218, 40, 'PPL', 'P'),
(154704, 'Cheshire', 40.2386093139648, 0.702296218952343, -82.9633331298828, -1.44798332154535, 218, 41, 'PPL', 'P'),
(177595, 'Cheshire', 41.4988899230957, 0.724292265080716, -72.9011077880859, -1.27236435925338, 218, 8, 'PPL', 'P'),
(200567, 'Cheshire', 44.1897201538086, 0.771256112218855, -123.284439086914, -2.15171937854104, 218, 43, 'PPL', 'P'),
(130189, 'Cheshire Center', 42.4516716003418, 0.740921442401335, -85.934440612793, -1.49983892955277, 218, 27, 'PPL', 'P'),
(124505, 'Cheshire Harbor', 42.5938911437988, 0.743403641695343, -73.1419372558594, -1.27656762640185, 218, 23, 'PPL', 'P'),
(26771, 'Cheshire Hills', 39.939998626709, 0.697084479278085, -91.3477783203125, -1.59431949607135, 218, 18, 'PPL', 'P'),
(177597, 'Cheshire Street (historical)', 41.5397186279297, 0.725004860409394, -72.8680572509766, -1.27178751856127, 218, 8, 'PPL', 'P'),
(70653, 'Chesilhurst', 39.7322196960449, 0.693458052821724, -74.8813934326172, -1.30692686388043, 218, 37, 'PPL', 'P'),
(194724, 'Chesley', 46.3491706848145, 0.808945634018847, -116.551940917969, -2.03421511860846, 218, 17, 'PPL', 'P'),
(45707, 'Cheslou Village', 38.9719390869141, 0.680188652953323, -76.2666702270508, -1.33110450499477, 218, 25, 'PPL', 'P'),
(45709, 'Chesmar', 39.226390838623, 0.684629673808112, -76.0372161865234, -1.32709977650556, 218, 25, 'PPL', 'P'),
(80306, 'Chesnee', 35.1483306884766, 0.613454097093681, -81.8611068725586, -1.42874584425311, 218, 48, 'PPL', 'P'),
(45710, 'Chesney', 39.2680587768555, 0.685356916522785, -77.2194366455078, -1.34773341599928, 218, 25, 'PPL', 'P'),
(85757, 'Chesney', 36.2299995422363, 0.632332780008062, -83.7125015258789, -1.46105877670736, 218, 50, 'PPL', 'P'),
(80307, 'Chesnut Hill (historical)', 34.1152801513672, 0.595423963881627, -82.5041732788086, -1.43996947035114, 218, 48, 'PPL', 'P'),
(100747, 'Chesopeian Colony', 36.8458290100098, 0.643081031851513, -76.0625, -1.32754106229819, 218, 53, 'PPL', 'P'),
(1532, 'Chesson', 32.2936096191406, 0.563629815207716, -85.9244384765625, -1.49966435934332, 218, 2, 'PPL', 'P'),
(100748, 'Chesswood', 37.3883285522461, 0.652549435054099, -77.4719390869141, -1.35214041497114, 218, 53, 'PPL', 'P'),
(72086, 'Chesswood Acres', 39.2236099243164, 0.684581137697245, -84.5938873291016, -1.47644186095393, 218, 41, 'PPL', 'P'),
(160033, 'Chest Springs', 40.5800018310547, 0.708254642417232, -78.6072235107422, -1.37195486611355, 218, 45, 'PPL', 'P'),
(1533, 'Chestang', 31.1616706848145, 0.543873753872208, -88.1144409179688, -1.53788711257257, 218, 2, 'PPL', 'P'),
(20009, 'Chestatee', 34.2941703796387, 0.598546187364609, -83.9997177124023, -1.46607164482722, 218, 13, 'PPL', 'P'),
(20010, 'Chestatee North', 34.3458290100098, 0.599447800551655, -83.9194412231445, -1.46467055577773, 218, 13, 'PPL', 'P'),
(8056, 'Chester', 35.6808280944824, 0.622747930086813, -94.1750030517578, -1.64366387632888, 218, 4, 'PPL', 'P'),
(15512, 'Chester', 30.6827793121338, 0.535515522659536, -81.540283203125, -1.42314641490316, 218, 12, 'PPL', 'P'),
(20011, 'Chester', 32.3936080932617, 0.565375117828099, -83.1530609130859, -1.45129469604475, 218, 13, 'PPL', 'P'),
(26772, 'Chester', 37.9136085510254, 0.66171730052767, -89.8219375610352, -1.56768855096083, 218, 18, 'PPL', 'P'),
(29464, 'Chester', 39.8880615234375, 0.69617800582205, -84.8877792358398, -1.48157124237148, 218, 19, 'PPL', 'P'),
(39762, 'Chester', 32.1113891601563, 0.560449468233943, -92.3130569458008, -1.61116678628524, 218, 22, 'PPL', 'P'),
(45711, 'Chester', 38.9752807617188, 0.680246976181196, -76.2897186279297, -1.33150677547742, 218, 25, 'PPL', 'P'),
(58981, 'Chester', 33.3586082458496, 0.582217547773006, -89.2383270263672, -1.55750262558155, 218, 30, 'PPL', 'P'),
(72087, 'Chester', 39.0875015258789, 0.682205598004894, -81.9227828979492, -1.42982229396572, 218, 41, 'PPL', 'P'),
(75421, 'Chester', 36.2163887023926, 0.632095226038827, -98.9205627441406, -1.72648951781089, 218, 42, 'PPL', 'P'),
(78016, 'Chester', 39.8494415283203, 0.695503959750151, -75.3561096191406, -1.31521222434777, 218, 45, 'PPL', 'P'),
(80314, 'Chester', 34.704719543457, 0.605711622014549, -81.2144393920898, -1.41745936755335, 218, 48, 'PPL', 'P'),
(93212, 'Chester', 30.9261093139648, 0.539762432360371, -94.5963897705078, -1.65101846199524, 218, 51, 'PPL', 'P'),
(100749, 'Chester', 37.3566703796387, 0.651996895706935, -77.4419403076172, -1.35161683750083, 218, 53, 'PPL', 'P'),
(114969, 'Chester', 43.4911117553711, 0.759063095484036, -92.3602828979492, -1.61199103464262, 218, 16, 'PPL', 'P'),
(124507, 'Chester', 42.2791709899902, 0.737910738789, -72.9791717529297, -1.27372683246706, 218, 23, 'PPL', 'P'),
(127104, 'Chester', 45.4086112976074, 0.792529775901544, -68.5002822875977, -1.19555546446413, 218, 26, 'PPL', 'P'),
(130191, 'Chester', 42.6058311462402, 0.743612034050642, -84.9147186279297, -1.48204142346193, 218, 27, 'PPL', 'P'),
(134649, 'Chester', 44.0069389343262, 0.768065978128076, -92.3450012207031, -1.61172431905945, 218, 28, 'PPL', 'P'),
(141489, 'Chester', 40.0102806091309, 0.698311131276176, -97.6180572509766, -1.70375650842987, 218, 35, 'PPL', 'P'),
(143620, 'Chester', 42.9566688537598, 0.749735307187006, -71.2577819824219, -1.24368291326155, 218, 36, 'PPL', 'P'),
(144980, 'Chester', 40.7841682434082, 0.711818018534785, -74.6972198486328, -1.3037124284447, 218, 37, 'PPL', 'P'),
(147777, 'Chester', 41.3624992370605, 0.721911798540349, -74.2716674804688, -1.29628513848058, 218, 40, 'PPL', 'P'),
(170012, 'Chester', 43.8950004577637, 0.766112283152394, -96.9261093139648, -1.69167973867663, 218, 49, 'PPL', 'P'),
(171850, 'Chester', 43.2627792358398, 0.755077941228842, -72.5955581665039, -1.26703151232855, 218, 55, 'PPL', 'P'),
(177197, 'Chester', 40.6130599975586, 0.708831616267398, -80.5630569458008, -1.40609059917591, 218, 58, 'PPL', 'P'),
(177598, 'Chester', 41.4030609130859, 0.722619733337119, -72.4513931274414, -1.26451535773064, 218, 8, 'PPL', 'P'),
(186531, 'Chester', 38.3736114501953, 0.669745865686904, -106.301109313965, -1.8553043560511, 218, 7, 'PPL', 'P'),
(192515, 'Chester', 39.4761085510254, 0.688988070090081, -111.562217712402, -1.94712801990816, 218, 52, 'PPL', 'P'),
(193447, 'Chester', 40.3063888549805, 0.703479195108556, -121.230827331543, -2.11587709185216, 218, 6, 'PPL', 'P'),
(194725, 'Chester', 43.999439239502, 0.767935083760499, -111.56916809082, -1.94724932689581, 218, 17, 'PPL', 'P'),
(196204, 'Chester', 48.5105590820313, 0.846668977964683, -110.966667175293, -1.93673370217358, 218, 31, 'PPL', 'P'),
(207027, 'Chester', 47.6180610656738, 0.831091949011728, -117.249443054199, -2.04638882742537, 218, 56, 'PPL', 'P'),
(54019, 'Chester (historical)', 36.8561096191406, 0.643260462329957, -94.146110534668, -1.64315960677648, 218, 29, 'PPL', 'P'),
(124508, 'Chester Center', 42.2902793884277, 0.738104616916358, -72.9250030517578, -1.27278141028009, 218, 23, 'PPL', 'P'),
(154705, 'Chester Center', 41.5341682434082, 0.724907987924743, -81.3380584716797, -1.41961692751048, 218, 41, 'PPL', 'P'),
(100750, 'Chester Gap', 38.853328704834, 0.678118511258977, -78.1352767944336, -1.36371784201999, 218, 53, 'PPL', 'P'),
(45712, 'Chester Grove', 38.8444404602051, 0.67796338212548, -76.855827331543, -1.34138723627967, 218, 25, 'PPL', 'P'),
(45713, 'Chester Harbor', 39.211669921875, 0.684372745341946, -76.0299987792969, -1.326973808986, 218, 25, 'PPL', 'P'),
(78022, 'Chester Heights', 39.8899993896484, 0.696211827967894, -75.475830078125, -1.31730174053905, 218, 45, 'PPL', 'P'),
(147783, 'Chester Heights', 40.9255599975586, 0.71428577017988, -73.8019409179688, -1.28808686338088, 218, 40, 'PPL', 'P'),
(160038, 'Chester Hill', 40.889720916748, 0.713660260218848, -78.2286071777344, -1.36534676450073, 218, 45, 'PPL', 'P'),
(147778, 'Chester Hill Park', 40.9233283996582, 0.714246821448938, -73.8227767944336, -1.28845051802773, 218, 40, 'PPL', 'P'),
(78018, 'Chester Plaza', 39.8622207641602, 0.695726999491445, -75.4116668701172, -1.31618188130067, 218, 45, 'PPL', 'P'),
(45723, 'Chester River Beach', 38.9708290100098, 0.680169278456393, -76.2119369506836, -1.33014922911176, 218, 25, 'PPL', 'P'),
(160040, 'Chester Springs', 40.0950012207031, 0.699789784892415, -75.6172180175781, -1.31976942560512, 218, 45, 'PPL', 'P'),
(100751, 'Chesterbrook', 38.9213905334473, 0.679306414263207, -77.1536102294922, -1.34658452830502, 218, 53, 'PPL', 'P'),
(160041, 'Chesterbrook', 40.0755615234375, 0.699450498169539, -75.4594421386719, -1.31701571703798, 218, 45, 'PPL', 'P'),
(100752, 'Chesterbrook Estates', 38.9280586242676, 0.679422794402843, -77.133056640625, -1.34622580050618, 218, 53, 'PPL', 'P'),
(100753, 'Chesterbrook Farms', 37.3619384765625, 0.65208884134357, -77.456672668457, -1.35187396570408, 218, 53, 'PPL', 'P'),
(100754, 'Chesterbrook Gardens', 38.9161109924316, 0.67921426888949, -77.1711120605469, -1.34688999288205, 218, 53, 'PPL', 'P'),
(100755, 'Chesterbrook Woods', 38.9258308410645, 0.679383912250928, -77.1394424438477, -1.3463372537978, 218, 53, 'PPL', 'P'),
(1534, 'Chesterfield', 34.4466705322266, 0.601207817137061, -85.5238876342773, -1.4926734283238, 218, 2, 'PPL', 'P'),
(26774, 'Chesterfield', 39.2550010681152, 0.685129016512502, -90.0630569458008, -1.57189687811537, 218, 18, 'PPL', 'P'),
(45717, 'Chesterfield', 39.5680618286133, 0.69059295754199, -76.6505584716797, -1.33780461882324, 218, 25, 'PPL', 'P'),
(54020, 'Chesterfield', 38.6630592346191, 0.674797682537703, -90.5769424438477, -1.58086587203454, 218, 29, 'PPL', 'P'),
(63652, 'Chesterfield', 35.810001373291, 0.625002429107619, -81.6611099243164, -1.42525523901234, 218, 33, 'PPL', 'P'),
(80310, 'Chesterfield', 34.7358283996582, 0.606254573981788, -80.0883331298828, -1.39780510555051, 218, 48, 'PPL', 'P'),
(85761, 'Chesterfield', 35.6344413757324, 0.621938329115429, -88.2669372558594, -1.54054867576599, 218, 50, 'PPL', 'P'),
(100758, 'Chesterfield', 37.2147216796875, 0.649519423523861, -79.9841690063477, -1.39598709863237, 218, 53, 'PPL', 'P'),
(122364, 'Chesterfield', 40.1124992370605, 0.70009518289042, -85.5969390869141, -1.49394841669568, 218, 19, 'PPL', 'P'),
(124510, 'Chesterfield', 42.3916702270508, 0.739874220881688, -72.8402786254883, -1.27130269008482, 218, 23, 'PPL', 'P'),
(130195, 'Chesterfield', 42.6627807617188, 0.744605992348487, -82.8424987792969, -1.44587436427811, 218, 27, 'PPL', 'P'),
(143622, 'Chesterfield', 42.8872184753418, 0.748523169416857, -72.470832824707, -1.26485464445352, 218, 36, 'PPL', 'P'),
(144983, 'Chesterfield', 40.1150016784668, 0.700138858732297, -74.6397171020508, -1.30270881618791, 218, 37, 'PPL', 'P'),
(160042, 'Chesterfield', 40.7938919067383, 0.711987728475251, -78.4700012207031, -1.36955988534524, 218, 45, 'PPL', 'P'),
(177601, 'Chesterfield', 41.4272193908691, 0.723041378316706, -72.2149963378906, -1.26038945541184, 218, 8, 'PPL', 'P'),
(194726, 'Chesterfield', 42.8669395446777, 0.748169235307985, -111.901107788086, -1.95304276753117, 218, 17, 'PPL', 'P'),
(100761, 'Chesterfield Court House', 37.3769416809082, 0.652350696657752, -77.5052795410156, -1.35272231566932, 218, 53, 'PPL', 'P'),
(80313, 'Chesterfield Estates', 34.7222213745117, 0.606017086591581, -82.434440612793, -1.43875240573297, 218, 48, 'PPL', 'P'),
(100762, 'Chesterfield Estates', 38.5136108398438, 0.672189315987052, -78.0116729736328, -1.36156054837897, 218, 53, 'PPL', 'P'),
(45718, 'Chesterfield Gardens', 39.1297187805176, 0.682942428099492, -76.522216796875, -1.33556463403038, 218, 25, 'PPL', 'P'),
(45719, 'Chesterfield Plaza', 39.1286087036133, 0.682923053602562, -76.5277786254883, -1.33566170625211, 218, 25, 'PPL', 'P'),
(130196, 'Chesterfield Shores', 42.6699981689453, 0.744731959868047, -82.7613906860352, -1.44445876100068, 218, 27, 'PPL', 'P'),
(100763, 'Chesterfield Village', 37.5069389343262, 0.654619576748445, -77.5361099243164, -1.35326040736757, 218, 53, 'PPL', 'P'),
(45720, 'Chesterhaven Beach', 38.9786109924316, 0.680305099671987, -76.2752838134766, -1.3312548404383, 218, 25, 'PPL', 'P'),
(72090, 'Chesterhill', 39.4883308410645, 0.689201389293396, -81.8661117553711, -1.42883319593686, 218, 41, 'PPL', 'P'),
(154710, 'Chesterland', 41.5222206115723, 0.72469946241139, -81.3380584716797, -1.41961692751048, 218, 41, 'PPL', 'P'),
(122365, 'Chesterton', 41.6105613708496, 0.726241299524491, -87.0641708374023, -1.5195564416315, 218, 19, 'PPL', 'P'),
(45721, 'Chestertown', 39.2088890075684, 0.68432420923108, -76.0669403076172, -1.32761856028591, 218, 25, 'PPL', 'P'),
(147782, 'Chestertown', 43.6525001525879, 0.761879854389986, -73.8013916015625, -1.28807727600096, 218, 40, 'PPL', 'P'),
(119117, 'Chestervale', 40.0922203063965, 0.699741248781548, -89.3216705322266, -1.55895724416895, 218, 18, 'PPL', 'P'),
(26776, 'Chesterville', 39.7033309936523, 0.692953849848345, -88.39111328125, -1.5427159562611, 218, 18, 'PPL', 'P'),
(29466, 'Chesterville', 39.0677795410156, 0.681861384434002, -85.0522232055664, -1.48444133107826, 218, 19, 'PPL', 'P'),
(45722, 'Chesterville', 39.2758293151855, 0.685492538001298, -75.9155578613281, -1.32497643816844, 218, 25, 'PPL', 'P'),
(58982, 'Chesterville', 34.2863883972168, 0.598410366149015, -88.8255615234375, -1.55029850851677, 218, 30, 'PPL', 'P'),
(78021, 'Chesterville', 39.7777786254883, 0.694253206144195, -75.8111114501953, -1.32315350440228, 218, 45, 'PPL', 'P'),
(93213, 'Chesterville', 29.6097202301025, 0.516787108609662, -96.2072219848633, -1.67913278783294, 218, 51, 'PPL', 'P'),
(108569, 'Chesterville', 39.1555595397949, 0.683393434430097, -81.4983291625977, -1.42241417876144, 218, 58, 'PPL', 'P'),
(127101, 'Chesterville', 44.5511093139648, 0.777563542944599, -70.086669921875, -1.2232431518952, 218, 26, 'PPL', 'P'),
(154711, 'Chesterville', 40.4799995422363, 0.706509273217821, -82.6836090087891, -1.44310121463501, 218, 41, 'PPL', 'P'),
(45732, 'Chesterville Forest', 39.2683296203613, 0.68536164363372, -75.8936080932617, -1.32459334244563, 218, 25, 'PPL', 'P'),
(45724, 'Chesterwood', 39.2577781677246, 0.685177486044341, -76.4972229003906, -1.33512840824382, 218, 25, 'PPL', 'P'),
(26777, 'Chestline', 39.8447189331055, 0.695421534914413, -90.959716796875, -1.58754654478706, 218, 18, 'PPL', 'P'),
(1536, 'Chestnut', 31.8075008392334, 0.555145616475482, -87.2322235107422, -1.52248951409806, 218, 2, 'PPL', 'P'),
(35227, 'Chestnut', 37.8899993896484, 0.661305242928007, -82.6802825927734, -1.44304315772325, 218, 21, 'PPL', 'P'),
(39763, 'Chestnut', 32.0566711425781, 0.559494458667041, -93.01611328125, -1.62343743416584, 218, 22, 'PPL', 'P'),
(108570, 'Chestnut', 38.8388900756836, 0.677866509640828, -81.9222183227539, -1.42981244026968, 218, 58, 'PPL', 'P'),
(119118, 'Chestnut', 40.0536117553711, 0.699067402446731, -89.1852798461914, -1.55657677762858, 218, 18, 'PPL', 'P'),
(196205, 'Chestnut', 45.6477813720703, 0.796704081173162, -110.888061523438, -1.93536177473802, 218, 31, 'PPL', 'P'),
(63651, 'Chestnut Apartments', 35.2891693115234, 0.615912194779825, -81.5274963378906, -1.42292324200381, 218, 33, 'PPL', 'P'),
(85762, 'Chestnut Bluff', 35.8624992370605, 0.625918689680661, -89.3330612182617, -1.55915604914432, 218, 50, 'PPL', 'P'),
(80318, 'Chestnut Crossroads', 33.9238891601563, 0.592083560926341, -78.7630615234375, -1.37467475253485, 218, 48, 'PPL', 'P'),
(160043, 'Chestnut Crossroads', 40.0502815246582, 0.69900927895594, -77.4530563354492, -1.35181084878624, 218, 45, 'PPL', 'P'),
(63653, 'Chestnut Dale', 36.0663909912109, 0.629477272108252, -81.9800033569336, -1.4308209793745, 218, 33, 'PPL', 'P'),
(144985, 'Chestnut Estates', 40.0538902282715, 0.699072262715721, -74.2147216796875, -1.29529124676176, 218, 37, 'PPL', 'P'),
(45725, 'Chestnut Farms', 39.2972183227539, 0.685865846607099, -76.8027801513672, -1.34046138832671, 218, 25, 'PPL', 'P'),
(20012, 'Chestnut Forest', 33.9458312988281, 0.592466523491094, -84.2841720581055, -1.47103630973135, 218, 13, 'PPL', 'P'),
(100764, 'Chestnut Fork', 37.2041702270508, 0.649335265934482, -79.4963912963867, -1.38747377157571, 218, 53, 'PPL', 'P'),
(20013, 'Chestnut Gap', 34.8955612182617, 0.609042437589911, -84.413330078125, -1.47329054243604, 218, 13, 'PPL', 'P'),
(35228, 'Chestnut Gap', 37.458610534668, 0.65377608705219, -83.6588897705078, -1.46012307505836, 218, 21, 'PPL', 'P'),
(100765, 'Chestnut Gardens', 37.2144393920898, 0.649514496675845, -77.5041732788086, -1.35270300775142, 218, 53, 'PPL', 'P'),
(85776, 'Chestnut Glade', 36.4480590820313, 0.636138636942867, -88.7750015258789, -1.54941607008958, 218, 50, 'PPL', 'P'),
(1537, 'Chestnut Glen', 33.2847213745117, 0.580927978594162, -86.9197235107422, -1.51703536018558, 218, 2, 'PPL', 'P'),
(1538, 'Chestnut Grove', 31.5969390869141, 0.551470620618741, -85.9136123657227, -1.49947540806397, 218, 2, 'PPL', 'P'),
(13530, 'Chestnut Grove', 39.1694412231445, 0.683635715510267, -75.5719375610352, -1.31897913255164, 218, 10, 'PPL', 'P'),
(35229, 'Chestnut Grove', 38.2999992370605, 0.668461090198023, -85.2638931274414, -1.48813566814242, 218, 21, 'PPL', 'P'),
(45727, 'Chestnut Grove', 39.4094390869141, 0.687824468430798, -77.6958312988281, -1.35604807123861, 218, 25, 'PPL', 'P'),
(63655, 'Chestnut Grove', 36.3224983215332, 0.633947188260868, -80.3850021362305, -1.4029829564999, 218, 33, 'PPL', 'P'),
(85769, 'Chestnut Grove', 36.288330078125, 0.633350839913772, -83.7516708374023, -1.46174241015919, 218, 50, 'PPL', 'P'),
(100768, 'Chestnut Grove', 37.8222198486328, 0.660122266771794, -76.4397201538086, -1.33412479598703, 218, 53, 'PPL', 'P'),
(160046, 'Chestnut Grove', 41.1852798461914, 0.718818736671304, -76.5844421386719, -1.33665067112291, 218, 45, 'PPL', 'P'),
(72091, 'Chestnut Grove Cottage Area', 39.935001373291, 0.696997260752385, -81.420280456543, -1.42105197186387, 218, 41, 'PPL', 'P'),
(100769, 'Chestnut Grove Estates', 39.3213882446289, 0.686287691323768, -78.2286071777344, -1.36534676450073, 218, 53, 'PPL', 'P'),
(20015, 'Chestnut Hill', 34.1986083984375, 0.596878316152919, -83.8611068725586, -1.46365242929299, 218, 13, 'PPL', 'P'),
(29468, 'Chestnut Hill', 38.475830078125, 0.671529917301148, -85.9327774047852, -1.49980990109689, 218, 19, 'PPL', 'P'),
(45731, 'Chestnut Hill', 38.4249992370605, 0.670642751763016, -75.5622177124023, -1.3188094891902, 218, 25, 'PPL', 'P'),
(63657, 'Chestnut Hill', 35.4747200012207, 0.619150665244388, -82.3427810668945, -1.43715264486616, 218, 33, 'PPL', 'P'),
(85773, 'Chestnut Hill', 36.5541687011719, 0.637990599164908, -86.4000015258789, -1.50796450035471, 218, 50, 'PPL', 'P'),
(100773, 'Chestnut Hill', 37.5625, 0.65558930028037, -77.4222183227539, -1.35127262392994, 218, 53, 'PPL', 'P'),
(124512, 'Chestnut Hill', 42.3305587768555, 0.738807624865112, -71.1666717529297, -1.24209273977467, 218, 23, 'PPL', 'P'),
(160053, 'Chestnut Hill', 40.0636100769043, 0.699241906077159, -77.0858306884766, -1.3454015521488, 218, 45, 'PPL', 'P'),
(177198, 'Chestnut Hill', 40.4144401550293, 0.705365046055469, -80.5505599975586, -1.40587248628263, 218, 58, 'PPL', 'P'),
(20016, 'Chestnut Hill (historical)', 33.7066688537598, 0.588292351377531, -84.9636077880859, -1.4828947002752, 218, 13, 'PPL', 'P'),
(45733, 'Chestnut Hill Cove', 39.1699981689453, 0.683645436048246, -76.5416717529297, -1.33590418706936, 218, 25, 'PPL', 'P'),
(13531, 'Chestnut Hill Estates', 39.6791687011719, 0.692532138289731, -75.7069396972656, -1.32133536432608, 218, 10, 'PPL', 'P'),
(45734, 'Chestnut Hill Estates', 39.2924995422363, 0.685783488350389, -76.7986068725586, -1.34038855087089, 218, 25, 'PPL', 'P'),
(124513, 'Chestnut Hill Meeting House', 42.0449981689453, 0.733823652043083, -71.57861328125, -1.24928247576955, 218, 23, 'PPL', 'P'),
(45737, 'Chestnut Hills', 39.0311088562012, 0.681221360245028, -76.9199981689453, -1.34250722867611, 218, 25, 'PPL', 'P'),
(80315, 'Chestnut Hills', 34.8141708374023, 0.607621907464462, -82.4258270263672, -1.43860207028943, 218, 48, 'PPL', 'P'),
(85775, 'Chestnut Hills', 35.9011116027832, 0.626592602594506, -84.4000015258789, -1.47305791531483, 218, 50, 'PPL', 'P'),
(100774, 'Chestnut Hills', 37.2361106872559, 0.649892732129663, -79.9569396972656, -1.39551185753584, 218, 53, 'PPL', 'P'),
(100775, 'Chestnut Knob', 36.6238899230957, 0.639207464045993, -79.9108276367188, -1.39470705025442, 218, 53, 'PPL', 'P'),
(108573, 'Chestnut Knob', 37.4058303833008, 0.652854899631131, -80.9063873291016, -1.41208284478664, 218, 58, 'PPL', 'P'),
(359, 'Chestnut Knoll', 38.9575004577637, 0.679936651335174, -75.4527816772461, -1.31689947005639, 218, 10, 'PPL', 'P'),
(80316, 'Chestnut Lake', 35.0063896179199, 0.610976758068662, -82.0527801513672, -1.43209117405641, 218, 48, 'PPL', 'P'),
(20017, 'Chestnut Lake Estates', 33.5044403076172, 0.584762797405822, -84.271110534668, -1.47080834314204, 218, 13, 'PPL', 'P'),
(78024, 'Chestnut Level', 39.8227806091309, 0.695038638928687, -76.2161102294922, -1.33022206656757, 218, 45, 'PPL', 'P'),
(20018, 'Chestnut Log', 33.7483291625977, 0.58901946093415, -84.6458282470703, -1.477348400989, 218, 13, 'PPL', 'P'),
(85777, 'Chestnut Mound', 36.2027816772461, 0.631857738648619, -85.8263931274414, -1.49795314518489, 218, 50, 'PPL', 'P'),
(20019, 'Chestnut Mountain', 34.1725006103516, 0.596422649290407, -83.8380584716797, -1.46325015881034, 218, 13, 'PPL', 'P'),
(20020, 'Chestnut Oak Hills', 34.2797203063965, 0.598293986009378, -83.7688903808594, -1.4620429478882, 218, 13, 'PPL', 'P'),
(45738, 'Chestnut Oaks', 39.4194412231445, 0.687999038640253, -77.0283279418945, -1.34439793989201, 218, 25, 'PPL', 'P'),
(100776, 'Chestnut Oaks', 37.540828704834, 0.655211064826552, -77.7925033569336, -1.35773531694723, 218, 53, 'PPL', 'P'),
(85778, 'Chestnut Orchard', 36.4524993896484, 0.636216134930589, -86.8913879394531, -1.51654081117115, 218, 50, 'PPL', 'P'),
(203400, 'Chestnut Place Condo', 40.6541709899902, 0.709549138444092, -111.916107177734, -1.95330455626632, 218, 52, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(45739, 'Chestnut Point', 39.5541687011719, 0.690350476724738, -76.0083312988281, -1.32659564011121, 218, 25, 'PPL', 'P'),
(1540, 'Chestnut Ridge', 33.3958282470703, 0.582867159341903, -86.772216796875, -1.5144608823598, 218, 2, 'PPL', 'P'),
(29469, 'Chestnut Ridge', 38.8886108398438, 0.678734300682031, -85.8602828979492, -1.49854463326299, 218, 19, 'PPL', 'P'),
(45742, 'Chestnut Ridge', 39.0347213745117, 0.681284410583836, -77.0366668701172, -1.34454348164558, 218, 25, 'PPL', 'P'),
(54021, 'Chestnut Ridge', 37.7980613708496, 0.659700621792207, -90.3363876342773, -1.57666739857603, 218, 29, 'PPL', 'P'),
(85782, 'Chestnut Ridge', 35.8016700744629, 0.624857020512101, -84.3055572509766, -1.47140955175812, 218, 50, 'PPL', 'P'),
(108575, 'Chestnut Ridge', 39.3838882446289, 0.687378522106264, -79.813606262207, -1.39301021716588, 218, 58, 'PPL', 'P'),
(144986, 'Chestnut Ridge', 41.0569381713867, 0.716578751878438, -74.0680618286133, -1.29273154948003, 218, 37, 'PPL', 'P'),
(147785, 'Chestnut Ridge', 41.084171295166, 0.71705405955399, -74.0561065673828, -1.29252289080863, 218, 40, 'PPL', 'P'),
(160054, 'Chestnut Ridge', 40.0555610656738, 0.699101424329657, -76.3730621337891, -1.33296139406483, 218, 45, 'PPL', 'P'),
(160055, 'Chestnut Ridge Acres', 40.5469398498535, 0.707677601988039, -75.1033325195313, -1.31080043168595, 218, 45, 'PPL', 'P'),
(80317, 'Chestnut Springs', 35.1741714477539, 0.613905103424286, -82.4033279418945, -1.4382093871867, 218, 48, 'PPL', 'P'),
(63661, 'Chestnut Trails', 36.2419395446777, 0.632541172363361, -80.2486114501953, -1.40060248995953, 218, 33, 'PPL', 'P'),
(124514, 'Chestnut Tree Corner', 41.8283309936523, 0.730042096453225, -71.1444396972656, -1.24170471720384, 218, 23, 'PPL', 'P'),
(85787, 'Chestnut Valley', 35.4308280944824, 0.618384606956827, -84.1738891601563, -1.46911151005349, 218, 50, 'PPL', 'P'),
(160056, 'Chestnut View', 40.0411109924316, 0.698849222974426, -76.3702774047852, -1.33291279137493, 218, 45, 'PPL', 'P'),
(160057, 'Chestnut Wood Village', 40.060001373291, 0.699178922317378, -74.9833297729492, -1.30870598864666, 218, 45, 'PPL', 'P'),
(35230, 'Chestnutburg', 37.288890838623, 0.650813919550722, -83.7966690063477, -1.46252777636465, 218, 21, 'PPL', 'P'),
(20021, 'Chestnutfield', 33.3830604553223, 0.582644319337691, -84.5480575561523, -1.47564198052053, 218, 13, 'PPL', 'P'),
(20022, 'Chestnutflat (historical)', 34.7458305358887, 0.606429144191243, -85.1655578613281, -1.48641939397792, 218, 13, 'PPL', 'P'),
(54022, 'Chestnutridge', 36.836669921875, 0.642921175607081, -93.2516708374023, -1.62754868909865, 218, 29, 'PPL', 'P'),
(85783, 'Chestoa', 36.1055603027344, 0.630160905560075, -82.4452819824219, -1.43894162332842, 218, 50, 'PPL', 'P'),
(45743, 'Cheston', 38.8811111450195, 0.678603406314453, -76.6374969482422, -1.33757665223393, 218, 25, 'PPL', 'P'),
(45744, 'Cheston on the Wye', 38.9174995422363, 0.67923850365541, -76.1536102294922, -1.32913123578507, 218, 25, 'PPL', 'P'),
(130198, 'Chestonia', 45.0602798461914, 0.786450245186084, -85.0774993896484, -1.48488248371283, 218, 27, 'PPL', 'P'),
(85786, 'Chestuee', 35.4663887023926, 0.61900525664887, -84.4172210693359, -1.47335845304384, 218, 50, 'PPL', 'P'),
(127103, 'Chesuncook', 46.0602798461914, 0.803903537706027, -69.4100036621094, -1.21143309772513, 218, 26, 'PPL', 'P'),
(160059, 'Cheswick', 40.5416717529297, 0.707585656351404, -79.7994384765625, -1.39276294265866, 218, 45, 'PPL', 'P'),
(13532, 'Cheswold', 39.2191696166992, 0.684503639709524, -75.5861129760742, -1.31922654021691, 218, 10, 'PPL', 'P'),
(45745, 'Cheswolde', 39.3638916015625, 0.68702951484541, -76.6894378662109, -1.338483192269, 218, 25, 'PPL', 'P'),
(177913, 'Chetco', 35.2163887023926, 0.614641933518884, -109.333610534668, -1.90823148692311, 218, 5, 'PPL', 'P'),
(173521, 'Chetek', 45.3141708374023, 0.790881478923867, -91.6508331298828, -1.59960880031236, 218, 57, 'PPL', 'P'),
(58984, 'Chethams (historical)', 32.663890838623, 0.570092441645984, -90.4444427490234, -1.57855331610197, 218, 30, 'PPL', 'P'),
(1541, 'Chetopa', 33.6788902282715, 0.587807522901082, -86.9680633544922, -1.51787904961891, 218, 2, 'PPL', 'P'),
(32056, 'Chetopa', 37.0372200012207, 0.646421434806799, -95.0897216796875, -1.65962872811558, 218, 20, 'PPL', 'P'),
(29470, 'Chetwynd', 39.4430618286133, 0.688411295976997, -86.2694396972656, -1.50568576656799, 218, 19, 'PPL', 'P'),
(211739, 'Chevak', 61.5277786254883, 1.07386231845296, -165.586395263672, -2.89002779385982, 218, 1, 'PPL', 'P'),
(15513, 'Cheval', 28.1483306884766, 0.491281049454078, -82.5147171020508, -1.44015349478246, 218, 12, 'PPL', 'P'),
(45746, 'Cheval Trails', 38.9797210693359, 0.680324474168917, -76.6322174072266, -1.33748450686022, 218, 25, 'PPL', 'P'),
(100782, 'Chevalle', 38.7155609130859, 0.675714009689772, -77.4927825927734, -1.35250420277604, 218, 53, 'PPL', 'P'),
(108576, 'Chevaux De Frise', 39.1561088562012, 0.683403021810021, -81.0188903808594, -1.41404639345836, 218, 58, 'PPL', 'P'),
(45747, 'Cheverly', 38.9280586242676, 0.679422794402843, -76.9161071777344, -1.34243931806831, 218, 25, 'PPL', 'P'),
(39764, 'Chevey Chase', 31.6294403076172, 0.552037873930928, -91.7655563354492, -1.60161109797793, 218, 22, 'PPL', 'P'),
(130200, 'Cheviers', 44.5680618286133, 0.777859420141707, -83.7369384765625, -1.46148528195594, 218, 27, 'PPL', 'P'),
(72092, 'Chevington Woods North', 39.9338912963867, 0.696977886255455, -82.7480621337891, -1.44422613387946, 218, 41, 'PPL', 'P'),
(72093, 'Cheviot', 39.1569404602051, 0.683417536037962, -84.6133270263672, -1.47678114767681, 218, 41, 'PPL', 'P'),
(147786, 'Cheviot', 42.125, 0.735219947402611, -73.904167175293, -1.28987104815318, 218, 40, 'PPL', 'P'),
(207028, 'Cheviot', 46.8980598449707, 0.81852555709208, -120.169998168945, -2.09736213016365, 218, 56, 'PPL', 'P'),
(20023, 'Cheviot Hills', 33.5972213745117, 0.586382132506644, -84.8658294677734, -1.48118814664867, 218, 13, 'PPL', 'P'),
(35231, 'Chevrolet', 36.8172187805176, 0.642581689147123, -83.2747192382813, -1.45341803438187, 218, 21, 'PPL', 'P'),
(187617, 'Chevron', 38.3125, 0.668679269670328, -100.909721374512, -1.76120688525533, 218, 20, 'PPL', 'P'),
(13056, 'Chevy Chase', 38.9638900756836, 0.680048171205821, -77.0680618286133, -1.34509142703986, 218, 9, 'PPL', 'P'),
(35232, 'Chevy Chase', 38.0202789306641, 0.663579049866717, -84.4875030517578, -1.47458510504193, 218, 21, 'PPL', 'P'),
(45748, 'Chevy Chase', 38.9711112976074, 0.680174205304409, -77.0766677856445, -1.34524162932534, 218, 25, 'PPL', 'P'),
(203401, 'Chevy Chase', 40.6513900756836, 0.709500602333226, -111.857223510742, -1.95227684240166, 218, 52, 'PPL', 'P'),
(13057, 'Chevy Chase Heights', 38.9594383239746, 0.679970473481018, -77.0777816772461, -1.3452610704013, 218, 9, 'PPL', 'P'),
(160061, 'Chevy Chase Heights', 40.6366691589355, 0.70924367386706, -79.1444396972656, -1.38133105736339, 218, 45, 'PPL', 'P'),
(45749, 'Chevy Chase Lake', 38.9919395446777, 0.680537726793205, -77.0708312988281, -1.34513976341365, 218, 25, 'PPL', 'P'),
(45750, 'Chevy Chase Manor', 38.9786109924316, 0.680305099671987, -77.0669403076172, -1.34507185280585, 218, 25, 'PPL', 'P'),
(45751, 'Chevy Chase Section 4 (historical)', 38.980281829834, 0.680334261285923, -77.0819396972656, -1.34533364154101, 218, 25, 'PPL', 'P'),
(45752, 'Chevy Chase Section Five', 38.9836082458496, 0.680392318197687, -77.0744400024414, -1.34520274717343, 218, 25, 'PPL', 'P'),
(45753, 'Chevy Chase Section Three', 38.978889465332, 0.680309959940976, -77.0741729736328, -1.34519808664152, 218, 25, 'PPL', 'P'),
(45754, 'Chevy Chase Terrace', 38.9722213745117, 0.68019357980134, -77.0941696166992, -1.34554709390238, 218, 25, 'PPL', 'P'),
(45755, 'Chevy Chase View', 39.019718170166, 0.681022555269654, -77.0827789306641, -1.345348288927, 218, 25, 'PPL', 'P'),
(45756, 'Chevy Chase Village', 38.9691696166992, 0.680140316579538, -77.0791702270508, -1.34528530516722, 218, 25, 'PPL', 'P'),
(207029, 'Chew', 46.6019401550293, 0.813357293522618, -118.316673278809, -2.0650155087216, 218, 56, 'PPL', 'P'),
(1542, 'Chewacla', 32.6199989318848, 0.569326383358423, -85.3372192382813, -1.48941545020426, 218, 2, 'PPL', 'P'),
(920, 'Chewalla', 35.0133285522461, 0.611097865319234, -88.6463928222656, -1.5471714247648, 218, 50, 'PPL', 'P'),
(144987, 'Chewalla Park', 40.2313919067383, 0.702170251432782, -74.7127838134766, -1.30398407087589, 218, 37, 'PPL', 'P'),
(200568, 'Chewaucan (historical)', 42.6597213745117, 0.744552595968631, -120.52278137207, -2.10351935860392, 218, 43, 'PPL', 'P'),
(207030, 'Chewelah', 48.2763900756836, 0.842581957797793, -117.71443939209, -2.05450454453128, 218, 56, 'PPL', 'P'),
(75423, 'Chewey', 36.1036109924316, 0.63012688367715, -94.767219543457, -1.65400000399364, 218, 42, 'PPL', 'P'),
(100777, 'Chewnings Corner', 38.0505599975586, 0.664107554185043, -77.6622161865234, -1.35546137685047, 218, 53, 'PPL', 'P'),
(70656, 'Chews', 39.8333282470703, 0.695222729939038, -75.0633316040039, -1.31010228400618, 218, 37, 'PPL', 'P'),
(45757, 'Chews Manor', 38.8583297729492, 0.678205796363704, -76.3552780151367, -1.33265100263978, 218, 25, 'PPL', 'P'),
(45758, 'Chewsville', 39.6427803039551, 0.691897040948775, -77.6352767944336, -1.35499119576002, 218, 25, 'PPL', 'P'),
(160062, 'Chewton', 40.8888893127441, 0.713645745990907, -80.3261108398438, -1.40195510947718, 218, 45, 'PPL', 'P'),
(93214, 'Cheyene Colonia', 27.9850006103516, 0.488430401823257, -97.6029968261719, -1.70349365443027, 218, 51, 'PPL', 'P'),
(32059, 'Cheyenne', 39.1766700744629, 0.68376188276691, -98.6386108398438, -1.72156852874864, 218, 20, 'PPL', 'P'),
(75422, 'Cheyenne', 35.6138916015625, 0.621579667895622, -99.6711120605469, -1.73958907458077, 218, 42, 'PPL', 'P'),
(191256, 'Cheyenne', 31.9850006103516, 0.558243571903031, -103.125282287598, -1.79987571796717, 218, 51, 'PPL', 'P'),
(209363, 'Cheyenne', 41.1399993896484, 0.718028443617823, -104.819717407227, -1.82944918976612, 218, 59, 'PPL', 'P'),
(202005, 'Cheyenne Crossing', 44.2961082458496, 0.773112934709886, -103.86888885498, -1.81285410090745, 218, 49, 'PPL', 'P'),
(32061, 'Cheyenne Gap', 39.2200012207031, 0.684518153937465, -98.6477813720703, -1.72172858473016, 218, 20, 'PPL', 'P'),
(75425, 'Cheyenne Valley', 36.3691711425781, 0.634761782659296, -98.6575012207031, -1.72189822809159, 218, 42, 'PPL', 'P'),
(108577, 'Cheyenne Valley', 38.4513893127441, 0.671103345473545, -81.959716796875, -1.43046691210757, 218, 58, 'PPL', 'P'),
(177914, 'Cheyenne Village', 33.5999984741211, 0.586430602038484, -112.137496948242, -1.95716853669192, 218, 5, 'PPL', 'P'),
(186533, 'Cheyenne Wells', 38.8213882446289, 0.677561045063796, -102.352783203125, -1.78639306547448, 218, 7, 'PPL', 'P'),
(78026, 'Cheyney', 39.9283294677734, 0.696880814033722, -75.523063659668, -1.31812612205448, 218, 45, 'PPL', 'P'),
(188299, 'Chi Chil Tah', 35.249439239502, 0.615218774210995, -108.907218933105, -1.900789549573, 218, 38, 'PPL', 'P'),
(20025, 'Chiaha (historical)', 34.2555618286133, 0.597872341029791, -85.1755599975586, -1.48659396418737, 218, 13, 'PPL', 'P'),
(180684, 'Chianti', 38.7372207641602, 0.676092045406509, -122.941108703613, -2.14572713293031, 218, 6, 'PPL', 'P'),
(177917, 'Chiapuk', 32.535831451416, 0.567857383701135, -112.134437561035, -1.95711514031206, 218, 5, 'PPL', 'P'),
(39766, 'Chiasson', 30.5324993133545, 0.532892641880944, -91.9527816772461, -1.60487879663546, 218, 22, 'PPL', 'P'),
(177915, 'Chiawuli Tak', 31.9355602264404, 0.557380674420331, -111.780281066895, -1.95093394342199, 218, 5, 'PPL', 'P'),
(85788, 'Chic', 35.9463882446289, 0.627382829068959, -89.6466674804688, -1.56462951097471, 218, 50, 'PPL', 'P'),
(119121, 'Chicago', 41.8499984741211, 0.730420265328016, -87.6500015258789, -1.52978111600464, 218, 18, 'PPL', 'P'),
(173524, 'Chicago', 42.586109161377, 0.743267820479749, -87.8247222900391, -1.53283056861084, 218, 57, 'PPL', 'P'),
(173525, 'Chicago Corners', 44.4588890075684, 0.775953994960782, -88.2508316040039, -1.54026757911294, 218, 57, 'PPL', 'P'),
(212246, 'Chicago Creek', 65.8944396972656, 1.15007493147414, -162.449172973633, -2.83527293553168, 218, 1, 'PPL', 'P'),
(119122, 'Chicago Heights', 41.5061111450195, 0.724418299179304, -87.6355590820313, -1.52952904780746, 218, 18, 'PPL', 'P'),
(173526, 'Chicago Junction', 45.8033294677734, 0.799418907588389, -91.8863906860352, -1.60372005524516, 218, 57, 'PPL', 'P'),
(119124, 'Chicago Ridge', 41.7013893127441, 0.727826546163361, -87.779167175293, -1.53203548186739, 218, 18, 'PPL', 'P'),
(130201, 'Chicagon', 46.0952796936035, 0.804514400281064, -88.5072174072266, -1.54474235553454, 218, 27, 'PPL', 'P'),
(188301, 'Chical', 34.8683280944824, 0.608567129914359, -106.667778015137, -1.86170393215056, 218, 38, 'PPL', 'P'),
(45759, 'Chicamuxen', 38.5372200012207, 0.672601373586714, -77.2125015258789, -1.34761237532773, 218, 25, 'PPL', 'P'),
(143624, 'Chichester', 43.2491683959961, 0.754840387259607, -71.4002838134766, -1.24617003940358, 218, 36, 'PPL', 'P'),
(147787, 'Chichester', 42.1016693115234, 0.734812750071938, -74.3097229003906, -1.29694933085645, 218, 40, 'PPL', 'P'),
(54023, 'Chick (historical)', 39.315559387207, 0.686185958570127, -94.2350006103516, -1.6447110312695, 218, 29, 'PPL', 'P'),
(80319, 'Chick Springs', 34.9269409179688, 0.609590116668085, -82.2808303833008, -1.43607140146359, 218, 48, 'PPL', 'P'),
(100778, 'Chickahominy', 37.6080589294434, 0.65638445360284, -77.413330078125, -1.35111749479644, 218, 53, 'PPL', 'P'),
(100779, 'Chickahominy Haven', 37.3708305358887, 0.652244037056094, -76.8955612182617, -1.34208072342753, 218, 53, 'PPL', 'P'),
(100783, 'Chickahominy Shores', 37.3936080932617, 0.652641580427816, -76.9413909912109, -1.34288060386093, 218, 53, 'PPL', 'P'),
(8060, 'Chickalah', 35.1641693115234, 0.613730533214832, -93.2783279418945, -1.62801394334109, 218, 4, 'PPL', 'P'),
(211741, 'Chickaloon', 64.7958297729492, 1.13090057109973, -148.466674804688, -2.59123230482951, 218, 1, 'PPL', 'P'),
(20026, 'Chickamauga', 34.8711090087891, 0.608615666025225, -85.2908325195313, -1.48860584923287, 218, 13, 'PPL', 'P'),
(134653, 'Chickamaw Beach', 46.7436103820801, 0.815829905436702, -94.3850021362305, -1.6473290517791, 218, 28, 'PPL', 'P'),
(160063, 'Chickaree', 40.4458312988281, 0.705912924870725, -78.8819427490234, -1.37674962134013, 218, 45, 'PPL', 'P'),
(1544, 'Chickasaw', 30.7636108398438, 0.536926298957491, -88.0747222900391, -1.53719389174082, 218, 2, 'PPL', 'P'),
(39768, 'Chickasaw', 32.9625015258789, 0.575304181320242, -91.3308334350586, -1.5940237520323, 218, 22, 'PPL', 'P'),
(114966, 'Chickasaw', 43.0338897705078, 0.751083066435668, -92.495002746582, -1.61434233956905, 218, 16, 'PPL', 'P'),
(154712, 'Chickasaw', 40.436939239502, 0.705757729158201, -84.4933319091797, -1.47468683779557, 218, 41, 'PPL', 'P'),
(1545, 'Chickasaw (historical)', 34.8863906860352, 0.608882381608397, -88.0769424438477, -1.53723264073468, 218, 2, 'PPL', 'P'),
(1547, 'Chickasaw Heights', 31.2008304595947, 0.544557220876464, -85.4322204589844, -1.49107353429894, 218, 2, 'PPL', 'P'),
(85790, 'Chickasaw Heights', 36.3105583190918, 0.63373879590557, -88.3055572509766, -1.54122272183789, 218, 50, 'PPL', 'P'),
(45760, 'Chickasaw Run', 38.4894409179688, 0.671767471270383, -76.7616729736328, -1.33974393272904, 218, 25, 'PPL', 'P'),
(8062, 'Chickasawba', 35.9272193908691, 0.627048269457018, -89.9233322143555, -1.56945822150519, 218, 4, 'PPL', 'P'),
(20027, 'Chickasawhatchee', 31.7011108398438, 0.553288760694938, -84.3747177124023, -1.4726166295222, 218, 13, 'PPL', 'P'),
(75427, 'Chickasha', 35.0525016784668, 0.611781565350084, -97.9361114501953, -1.70930760140603, 218, 42, 'PPL', 'P'),
(211742, 'Chicken', 64.0733337402344, 1.11829063649626, -141.936111450195, -2.47725247228353, 218, 1, 'PPL', 'P'),
(26778, 'Chicken Bristle', 39.836109161377, 0.695271266049905, -88.3666687011719, -1.54228931785447, 218, 18, 'PPL', 'P'),
(35233, 'Chicken Bristle', 37.4858283996582, 0.654251128411632, -84.7699966430664, -1.47951554832605, 218, 21, 'PPL', 'P'),
(160064, 'Chickentown', 40.6811103820801, 0.710019319534546, -75.3891677856445, -1.31578919819794, 218, 45, 'PPL', 'P'),
(160065, 'Chickies', 40.0569381713867, 0.699125459358495, -76.5250015258789, -1.33561323672027, 218, 45, 'PPL', 'P'),
(143626, 'Chicks Corner', 43.8027801513672, 0.764502735168578, -71.4733276367188, -1.2474448946174, 218, 36, 'PPL', 'P'),
(143627, 'Chickville', 43.7299995422363, 0.763232473907637, -71.1566696166992, -1.24191816956521, 218, 36, 'PPL', 'P'),
(154713, 'Chickwan', 40.2324981689453, 0.702189559350686, -80.8827819824219, -1.41167085376601, 218, 41, 'PPL', 'P'),
(1548, 'Chico', 33.2183303833008, 0.579769237203869, -86.1958312988281, -1.50440105765813, 218, 2, 'PPL', 'P'),
(93215, 'Chico', 33.2958297729492, 0.58112185672152, -97.7986068725586, -1.7069076937897, 218, 51, 'PPL', 'P'),
(180685, 'Chico', 39.7286109924316, 0.693395069061944, -121.836387634277, -2.12644611295424, 218, 6, 'PPL', 'P'),
(188302, 'Chico', 36.4866714477539, 0.636812549856712, -104.192222595215, -1.81849733925733, 218, 38, 'PPL', 'P'),
(196206, 'Chico', 45.3211097717285, 0.791002586174438, -110.704437255859, -1.93215692668222, 218, 31, 'PPL', 'P'),
(207031, 'Chico', 47.6116714477539, 0.830980429141081, -122.709167480469, -2.14167899491533, 218, 56, 'PPL', 'P'),
(200569, 'Chico (historical)', 45.7319412231445, 0.798172947672395, -117.154167175293, -2.04472594964073, 218, 43, 'PPL', 'P'),
(196208, 'Chico Hot Springs', 45.3377799987793, 0.791293536523529, -110.691390991211, -1.93192922640902, 218, 31, 'PPL', 'P'),
(177916, 'Chico Shunie', 32.3277816772461, 0.564226230133839, -112.946113586426, -1.97128155941463, 218, 5, 'PPL', 'P'),
(63662, 'Chicod', 35.4638900756836, 0.61896164738602, -77.2752838134766, -1.34870813295825, 218, 33, 'PPL', 'P'),
(20028, 'Chicopee', 34.2533302307129, 0.597833392298849, -83.8436126708984, -1.46334709787401, 218, 13, 'PPL', 'P'),
(32063, 'Chicopee', 37.3819389343262, 0.652437915183452, -94.7416687011719, -1.65355405766911, 218, 20, 'PPL', 'P'),
(54024, 'Chicopee', 36.9850006103516, 0.645510034502747, -91.0055618286133, -1.58834669153657, 218, 29, 'PPL', 'P'),
(124515, 'Chicopee', 42.148609161377, 0.735632005002274, -72.6083297729492, -1.26725441891179, 218, 23, 'PPL', 'P'),
(127105, 'Chicopee', 43.7005615234375, 0.762718683554333, -70.5538864135742, -1.23139761799496, 218, 26, 'PPL', 'P'),
(124516, 'Chicopee Falls', 42.1519393920898, 0.735690128493065, -72.5763931274414, -1.26669701929564, 218, 23, 'PPL', 'P'),
(58986, 'Chicora', 31.5636100769043, 0.550888919657641, -88.5752792358398, -1.54593025853877, 218, 30, 'PPL', 'P'),
(80320, 'Chicora', 33.2669410705566, 0.580617653748141, -80.1097183227539, -1.39817834757729, 218, 48, 'PPL', 'P'),
(130202, 'Chicora', 42.4766693115234, 0.741357734766917, -85.9736099243164, -1.50052256300459, 218, 27, 'PPL', 'P'),
(160066, 'Chicora', 40.9480590820313, 0.714678453282612, -79.7430572509766, -1.39177890463588, 218, 45, 'PPL', 'P'),
(196207, 'Chicory', 45.4055595397949, 0.792476512679743, -110.700828552246, -1.93209394292244, 218, 31, 'PPL', 'P'),
(8064, 'Chicot', 33.2055587768555, 0.579546330620629, -91.2863922119141, -1.59324810636481, 218, 4, 'PPL', 'P'),
(8066, 'Chicot Junction', 33.2027816772461, 0.57949786108879, -91.2597198486328, -1.59278258580626, 218, 4, 'PPL', 'P'),
(93216, 'Chicota', 33.8688888549805, 0.591123624511421, -95.5708312988281, -1.6680256750326, 218, 51, 'PPL', 'P'),
(8067, 'Chidester', 33.702220916748, 0.588214720231755, -93.0202789306641, -1.6235101384636, 218, 4, 'PPL', 'P'),
(130203, 'Chief Lake', 44.3486099243164, 0.774029261861955, -86.1022186279297, -1.50276720832937, 218, 27, 'PPL', 'P'),
(173528, 'Chief Lake', 45.9266700744629, 0.801571607276527, -91.3327789306641, -1.59405770733619, 218, 57, 'PPL', 'P'),
(15514, 'Chiefland', 29.4747200012207, 0.514430910124728, -82.8600006103516, -1.44617982885515, 218, 12, 'PPL', 'P'),
(108579, 'Chiefton', 39.4436111450195, 0.688420883356921, -80.258056640625, -1.40076733963101, 218, 58, 'PPL', 'P'),
(1549, 'Chigger Hill', 34.3974990844727, 0.600349613475783, -86.0163879394531, -1.5012691802162, 218, 2, 'PPL', 'P'),
(1550, 'Chigger Ridge (historical)', 33.7841682434082, 0.589644970895182, -85.9519424438477, -1.5001443941298, 218, 2, 'PPL', 'P'),
(75429, 'Chigley', 34.5933303833008, 0.603767514418791, -97.0780563354492, -1.69433171449013, 218, 42, 'PPL', 'P'),
(211743, 'Chignik', 56.295280456543, 0.982537997300291, -158.402221679688, -2.76464031078449, 218, 1, 'PPL', 'P'),
(211744, 'Chignik Lake', 56.2555618286133, 0.981844776468544, -158.762496948242, -2.77092830043428, 218, 1, 'PPL', 'P'),
(93219, 'Chihuahua', 26.2247200012207, 0.457707709434913, -98.413330078125, -1.71763663771525, 218, 51, 'PPL', 'P'),
(93217, 'Chihuahua Colonia', 26.2240009307861, 0.457695159288276, -98.4069976806641, -1.71752611653001, 218, 51, 'PPL', 'P'),
(177918, 'Chilchinbito', 36.5272216796875, 0.6375202849164, -110.081672668457, -1.92128763416723, 218, 5, 'PPL', 'P'),
(194727, 'Chilco', 47.8638916015625, 0.835382501264928, -116.745559692383, -2.03759440371566, 218, 17, 'PPL', 'P'),
(180686, 'Chilcoot', 39.797779083252, 0.694602279984077, -120.138610839844, -2.09681431792742, 218, 6, 'PPL', 'P'),
(45761, 'Chilcutt', 38.7713890075684, 0.676688393753605, -76.0444412231445, -1.32722587718318, 218, 25, 'PPL', 'P'),
(8068, 'Childers', 34.9205589294434, 0.609478729955493, -91.5641708374023, -1.59809625797124, 218, 4, 'PPL', 'P'),
(75430, 'Childers', 36.771671295166, 0.641786735561735, -95.539436340332, -1.66747772963832, 218, 42, 'PPL', 'P'),
(119127, 'Childers Acres', 41.9174995422363, 0.73159838121524, -89.1283264160156, -1.55558275275171, 218, 18, 'PPL', 'P'),
(85791, 'Childers Hill', 35.0783309936523, 0.612232371943607, -88.3249969482422, -1.54156200856077, 218, 50, 'PPL', 'P'),
(93218, 'Childers Mill (historical)', 30.9976997375488, 0.541011920964809, -97.4418334960938, -1.70068082368693, 218, 51, 'PPL', 'P'),
(1551, 'Childersburg', 33.2780609130859, 0.58081173161258, -86.3550033569336, -1.50717913414925, 218, 2, 'PPL', 'P'),
(177603, 'Childrens Village of the Hartford Orphan Asylum', 41.7866706848145, 0.729314986896606, -72.7119369506836, -1.26906270529195, 218, 8, 'PPL', 'P'),
(188303, 'Childres Place', 35.3277816772461, 0.616586107693669, -105.719718933105, -1.84515717966568, 218, 38, 'PPL', 'P'),
(8069, 'Childress', 35.961669921875, 0.627649544652131, -90.3422164916992, -1.57676913132967, 218, 4, 'PPL', 'P'),
(85792, 'Childress', 36.4277801513672, 0.635784702833996, -82.2636108398438, -1.43577086373457, 218, 50, 'PPL', 'P'),
(100785, 'Childress', 37.0561103820801, 0.646751134149751, -80.5047225952148, -1.40507247269117, 218, 53, 'PPL', 'P'),
(191257, 'Childress', 34.4263916015625, 0.600853883028189, -100.20361328125, -1.74888297415293, 218, 51, 'PPL', 'P'),
(15515, 'Childs', 27.2094402313232, 0.474894319661198, -81.3450012207031, -1.41973810134008, 218, 12, 'PPL', 'P'),
(45762, 'Childs', 39.646110534668, 0.691955164439566, -75.871940612793, -1.32421517357084, 218, 25, 'PPL', 'P'),
(80323, 'Childs', 33.9511108398438, 0.592558668864811, -80.9611129760742, -1.4130379875116, 218, 48, 'PPL', 'P'),
(108580, 'Childs', 39.6025009155273, 0.691194033000021, -80.7786102294922, -1.40985271368981, 218, 58, 'PPL', 'P'),
(134656, 'Childs', 46.065559387207, 0.803995683079744, -96.5341720581055, -1.68483914310065, 218, 28, 'PPL', 'P'),
(160068, 'Childs', 41.5558280944824, 0.72528602364148, -75.5205612182617, -1.31808244621261, 218, 45, 'PPL', 'P'),
(177376, 'Childs', 43.2866706848145, 0.755494925676521, -78.1919403076172, -1.36470680689079, 218, 40, 'PPL', 'P'),
(192878, 'Childs', 32.4527816772461, 0.566407891698832, -112.842781066895, -1.96947806672443, 218, 5, 'PPL', 'P'),
(196209, 'Childs', 47.7786102294922, 0.833894060531682, -115.485832214355, -2.01560801154624, 218, 31, 'PPL', 'P'),
(32066, 'Childs Acres', 37.7722206115723, 0.659249615461602, -97.42138671875, -1.70032396010086, 218, 20, 'PPL', 'P'),
(193448, 'Childs Meadows', 40.360279083252, 0.704419757026545, -121.490829467773, -2.1204149851916, 218, 6, 'PPL', 'P'),
(20029, 'Childs Place', 32.128059387207, 0.560740418583034, -84.982780456543, -1.48322932646616, 218, 13, 'PPL', 'P'),
(80324, 'Childsbury', 33.0969390869141, 0.577650559398656, -79.9341735839844, -1.3951145139012, 218, 48, 'PPL', 'P'),
(130205, 'Childsdale', 43.1047210693359, 0.752319305813683, -85.5802764892578, -1.49365759950464, 218, 27, 'PPL', 'P'),
(147788, 'Childwold', 44.2863883972168, 0.772943291348448, -74.6636123657227, -1.30312586721461, 218, 40, 'PPL', 'P'),
(177919, 'Chilean Mill', 34.1511116027832, 0.596049340684605, -112.392501831055, -1.96161921150566, 218, 5, 'PPL', 'P'),
(32067, 'Chiles', 38.6797218322754, 0.675088499728739, -94.7613906860352, -1.65389827124, 218, 20, 'PPL', 'P'),
(35236, 'Chiles', 37.1136093139648, 0.64775467982752, -88.7491683959961, -1.54896519691703, 218, 21, 'PPL', 'P'),
(35234, 'Chilesburg', 38.0069389343262, 0.663346223008417, -84.3597183227539, -1.47235484078704, 218, 21, 'PPL', 'P'),
(100786, 'Chilesburg', 37.999439239502, 0.663215328640839, -77.5927810668945, -1.35424950539643, 218, 53, 'PPL', 'P'),
(75431, 'Chilesville', 35.5519409179688, 0.62049842449305, -96.4763870239258, -1.68383060399584, 218, 42, 'PPL', 'P'),
(54025, 'Chilhowee', 38.5888900756836, 0.673503186510843, -93.8541717529297, -1.63806431382088, 218, 29, 'PPL', 'P'),
(85793, 'Chilhowee', 35.5572204589844, 0.620590569866767, -84.0105590820313, -1.46626086242267, 218, 50, 'PPL', 'P'),
(85794, 'Chilhowee Hills', 36.0074996948242, 0.628449425085536, -83.8502807617188, -1.46346347801365, 218, 50, 'PPL', 'P'),
(85795, 'Chilhowee View', 35.7144393920898, 0.62333455789593, -83.9216690063477, -1.46470943792964, 218, 50, 'PPL', 'P'),
(85796, 'Chilhowey (historical)', 35.5513916015625, 0.620488837113126, -84.0069427490234, -1.46619774550484, 218, 50, 'PPL', 'P'),
(100787, 'Chilhowie', 36.7983283996582, 0.642251989804171, -81.682502746582, -1.42562861419717, 218, 53, 'PPL', 'P'),
(119128, 'Chili', 40.2177810668945, 0.701932697463547, -91.1413879394531, -1.59071730438091, 218, 18, 'PPL', 'P'),
(122366, 'Chili', 40.8600006103516, 0.713141543017527, -86.0263900756836, -1.50144375042565, 218, 19, 'PPL', 'P'),
(154714, 'Chili', 40.3738899230957, 0.70465731099578, -81.7541732788086, -1.42687950096118, 218, 41, 'PPL', 'P'),
(173532, 'Chili', 44.6269416809082, 0.778887067427341, -90.3563919067383, -1.57701653899494, 218, 57, 'PPL', 'P'),
(188304, 'Chili', 36.1049995422363, 0.630151118443069, -106.149169921875, -1.85265251339565, 218, 38, 'PPL', 'P'),
(147789, 'Chili Center', 43.1072196960449, 0.752362915076533, -77.7458267211914, -1.35692065596978, 218, 40, 'PPL', 'P'),
(188305, 'Chilili', 34.8894386291504, 0.608935578251171, -106.232223510742, -1.85410207197698, 218, 38, 'PPL', 'P'),
(75432, 'Chilli', 34.9419403076172, 0.60985190540324, -95.436393737793, -1.66567929695419, 218, 42, 'PPL', 'P'),
(54027, 'Chillicothe', 39.795280456543, 0.694558670721227, -93.5522232055664, -1.63279431749778, 218, 29, 'PPL', 'P'),
(93220, 'Chillicothe', 34.2563896179199, 0.597886788678705, -99.5163879394531, -1.73688862923543, 218, 51, 'PPL', 'P'),
(112481, 'Chillicothe', 39.3330612182617, 0.686491423147159, -82.9824981689453, -1.44831781457826, 218, 41, 'PPL', 'P'),
(114970, 'Chillicothe', 41.0855598449707, 0.71707829431991, -92.529167175293, -1.61493862133712, 218, 16, 'PPL', 'P'),
(119130, 'Chillicothe', 40.9222183227539, 0.714227446952007, -89.4861068725586, -1.56182719971767, 218, 18, 'PPL', 'P'),
(160069, 'Chillisquaque', 40.9425010681152, 0.714581447639906, -76.8552780151367, -1.34137764889975, 218, 45, 'PPL', 'P'),
(207032, 'Chillowist', 48.3041687011719, 0.843066786274242, -119.635833740234, -2.08803920213561, 218, 56, 'PPL', 'P'),
(45763, 'Chillum', 38.9636116027832, 0.680043310936832, -76.9911117553711, -1.34374839490214, 218, 25, 'PPL', 'P'),
(45764, 'Chillum Gardens', 38.959171295166, 0.679965812949111, -76.9894409179688, -1.3437192332882, 218, 25, 'PPL', 'P'),
(45765, 'Chillum Heights', 38.9597206115723, 0.679975400329035, -76.9816665649414, -1.34358354523066, 218, 25, 'PPL', 'P'),
(45766, 'Chillum Manor', 38.9705581665039, 0.680164551345458, -76.9883270263672, -1.34369979221224, 218, 25, 'PPL', 'P'),
(13058, 'Chillum Station', 38.9555587768555, 0.679902762610303, -77.0044403076172, -1.34398102202336, 218, 9, 'PPL', 'P'),
(194728, 'Chilly', 44.0777816772461, 0.769302417243173, -113.878059387207, -1.9875470820884, 218, 17, 'PPL', 'P'),
(100789, 'Chilly Hollow Estates', 39.1083297729492, 0.68256911949369, -77.9255599975586, -1.36005759341778, 218, 53, 'PPL', 'P'),
(124520, 'Chilmark', 41.3430595397949, 0.721572511817473, -70.7452774047852, -1.23473802095025, 218, 23, 'PPL', 'P'),
(72096, 'Chilo', 38.7930603027344, 0.677066629207423, -84.1408309936523, -1.46853453620333, 218, 41, 'PPL', 'P'),
(75433, 'Chilocco', 36.9888916015625, 0.645577945110544, -97.0694427490234, -1.69418137904659, 218, 42, 'PPL', 'P'),
(200570, 'Chiloquin', 42.5777816772461, 0.743122478463258, -121.86499786377, -2.12694545565863, 218, 43, 'PPL', 'P'),
(147791, 'Chiloway', 41.9672203063965, 0.732466172256442, -75.0438919067383, -1.30976299728331, 218, 40, 'PPL', 'P'),
(8070, 'Chilson', 35.7125015258789, 0.623300735750086, -91.0013885498047, -1.58827385408076, 218, 4, 'PPL', 'P'),
(130206, 'Chilson', 42.5269393920898, 0.742235113188044, -83.8616714477539, -1.46366228298903, 218, 27, 'PPL', 'P'),
(147792, 'Chilson', 43.8772201538086, 0.765801958306373, -73.529167175293, -1.2833260634582, 218, 40, 'PPL', 'P'),
(1552, 'Chilton', 31.7819404602051, 0.554699503703381, -87.8441696166992, -1.53316998849177, 218, 2, 'PPL', 'P'),
(35235, 'Chilton', 37.4550018310547, 0.653713103292409, -84.9875030517578, -1.4833117513019, 218, 21, 'PPL', 'P'),
(54029, 'Chilton', 36.9330596923828, 0.644603494467684, -90.92138671875, -1.58687755872123, 218, 29, 'PPL', 'P'),
(93221, 'Chilton', 31.2800006866455, 0.545939002008051, -97.0638885498047, -1.69408443998292, 218, 51, 'PPL', 'P'),
(173529, 'Chilton', 44.0288887023926, 0.768449073850884, -88.1627807617188, -1.53873080200591, 218, 57, 'PPL', 'P'),
(54030, 'Chilton (historical)', 37.0680618286133, 0.646959726242132, -90.7516708374023, -1.58391545779879, 218, 29, 'PPL', 'P'),
(100790, 'Chiltons', 38.1288909912109, 0.665474687930635, -76.8066711425781, -1.3405292989345, 218, 53, 'PPL', 'P'),
(124519, 'Chiltonville', 41.9375, 0.731947455055122, -70.6291732788086, -1.23271162167681, 218, 23, 'PPL', 'P'),
(207033, 'Chimacum', 48.0111083984375, 0.837951919084636, -122.767501831055, -2.14269712140007, 218, 56, 'PPL', 'P'),
(188307, 'Chimayo', 36.0038909912109, 0.628386441325756, -105.946388244629, -1.84911330546499, 218, 38, 'PPL', 'P'),
(8071, 'Chimes', 35.6980590820313, 0.62304866755291, -92.7383270263672, -1.61858914940135, 218, 4, 'PPL', 'P'),
(100791, 'Chimney Corner', 37.4083290100098, 0.652898508893981, -77.434440612793, -1.35148594313325, 218, 53, 'PPL', 'P'),
(108581, 'Chimney Corner', 38.1388893127441, 0.665649191561063, -81.147216796875, -1.41628611193512, 218, 58, 'PPL', 'P'),
(171852, 'Chimney Corner', 44.5880584716797, 0.778208427402561, -73.1666717529297, -1.27699932481455, 218, 55, 'PPL', 'P'),
(147793, 'Chimney Corners', 41.2297210693359, 0.719594382338789, -73.9086074829102, -1.2899485461409, 218, 40, 'PPL', 'P'),
(130207, 'Chimney Corners Resort', 44.6897201538086, 0.779982758478827, -86.2077789306641, -1.50460958317148, 218, 27, 'PPL', 'P'),
(196210, 'Chimney Crossing', 47.0155601501465, 0.820576324289496, -107.61833190918, -1.87829422731926, 218, 31, 'PPL', 'P'),
(20036, 'Chimney Hill', 33.5458297729492, 0.585485179851506, -82.1425018310547, -1.43365711277738, 218, 13, 'PPL', 'P'),
(177920, 'Chimney Hill', 33.5847206115723, 0.58616395303434, -111.855560302734, -1.95224781394578, 218, 5, 'PPL', 'P'),
(100792, 'Chimney Hill Estates', 37.2533302307129, 0.650193269858679, -80.1458282470703, -1.39880858464925, 218, 53, 'PPL', 'P'),
(20030, 'Chimney Lakes', 34.0313911437988, 0.593959824493329, -84.4244384765625, -1.4734844205634, 218, 13, 'PPL', 'P'),
(171853, 'Chimney Point', 44.0361099243164, 0.768575107949472, -73.4186096191406, -1.28139647009038, 218, 55, 'PPL', 'P'),
(177577, 'Chimney Point', 41.5016708374023, 0.724340801191583, -73.4416732788086, -1.28179900688915, 218, 8, 'PPL', 'P'),
(20032, 'Chimney Ridge', 33.5727806091309, 0.585955560679041, -84.2069396972656, -1.4696883507456, 218, 13, 'PPL', 'P'),
(80325, 'Chimney Ridge', 34.0991706848145, 0.595142800649542, -80.851936340332, -1.41113249575165, 218, 48, 'PPL', 'P'),
(63665, 'Chimney Rock', 35.4391708374023, 0.618530215289427, -82.2466735839844, -1.43547525285357, 218, 33, 'PPL', 'P'),
(144988, 'Chimney Rock', 40.579719543457, 0.708249715569215, -74.5572204589844, -1.30126897814456, 218, 37, 'PPL', 'P'),
(186534, 'Chimney Rock', 37.1944389343262, 0.649165422835963, -107.300559997559, -1.87274806119112, 218, 7, 'PPL', 'P'),
(196211, 'Chimney Rock', 45.5499992370605, 0.794997460967612, -110.738059997559, -1.93274375422842, 218, 31, 'PPL', 'P'),
(100793, 'Chimney Run', 38.0791702270508, 0.664606896889433, -79.7836074829102, -1.39248663969557, 218, 53, 'PPL', 'P'),
(100794, 'Chimney Springs', 37.7644386291504, 0.659113794246008, -78.0538864135742, -1.36229731189454, 218, 53, 'PPL', 'P'),
(203404, 'Chimney Street Condominium', 40.7016716003418, 0.710378180491434, -111.97444152832, -1.95432268275106, 218, 52, 'PPL', 'P'),
(20033, 'Chimney Trace', 33.9183311462402, 0.591986555283634, -84.4644393920898, -1.47418256824317, 218, 13, 'PPL', 'P'),
(20034, 'Chimney Villa', 31.6144409179688, 0.551776085195773, -81.4024963378906, -1.42074158043882, 218, 13, 'PPL', 'P'),
(85797, 'Chimneytop (historical)', 36.4124984741211, 0.635517987250824, -82.7594375610352, -1.44442467253873, 218, 50, 'PPL', 'P'),
(1555, 'China', 31.5233306884766, 0.550185911708887, -87.0177764892578, -1.51874670750206, 218, 2, 'PPL', 'P'),
(29471, 'China', 38.8258285522461, 0.677638543051518, -85.3383331298828, -1.48943489128021, 218, 19, 'PPL', 'P'),
(39770, 'China', 30.4016704559326, 0.53060924756231, -92.7055587768555, -1.61801723555726, 218, 22, 'PPL', 'P'),
(54031, 'China', 36.6119384765625, 0.638998871953612, -91.8994369506836, -1.60394775551837, 218, 29, 'PPL', 'P'),
(93222, 'China', 30.047779083252, 0.52443267791463, -94.335563659668, -1.64646618758592, 218, 51, 'PPL', 'P'),
(127106, 'China', 44.4786109924316, 0.776298208531675, -69.5177764892578, -1.21331408840305, 218, 26, 'PPL', 'P'),
(147794, 'China', 42.144718170166, 0.735564094394477, -75.4005584716797, -1.31598800317331, 218, 40, 'PPL', 'P'),
(93223, 'China Creek', 31.2588901519775, 0.545570553671239, -98.789436340332, -1.72420093032813, 218, 51, 'PPL', 'P'),
(1556, 'China Grove', 32.0294418334961, 0.559019217570516, -85.9447174072266, -1.50001829345219, 218, 2, 'PPL', 'P'),
(58987, 'China Grove', 31.2124996185303, 0.544760886120827, -90.0533294677734, -1.57172710159588, 218, 30, 'PPL', 'P'),
(63668, 'China Grove', 35.5691719055176, 0.620799161959147, -80.5819396972656, -1.40642016536081, 218, 33, 'PPL', 'P'),
(85798, 'China Grove', 36.1388893127441, 0.630742606521176, -88.9138870239258, -1.55184007931377, 218, 50, 'PPL', 'P'),
(191259, 'China Grove', 32.5299987792969, 0.567755584368467, -100.816940307617, -1.7595875501545, 218, 51, 'PPL', 'P'),
(180688, 'China Gulch (historical)', 39.8166694641113, 0.694931979327029, -121.175277709961, -2.11490756805731, 218, 6, 'PPL', 'P'),
(194730, 'China Hat', 42.1016693115234, 0.734812750071938, -115.939170837402, -2.02352026314486, 218, 17, 'PPL', 'P'),
(20035, 'China Hill', 31.8527793884277, 0.55593587623945, -83.0844421386719, -1.45009707250254, 218, 13, 'PPL', 'P'),
(100795, 'China Hill', 38.0927810668945, 0.664844450858668, -76.8819427490234, -1.34184303630024, 218, 53, 'PPL', 'P'),
(194729, 'China Hill', 42.5527801513672, 0.742686119518648, -111.826667785645, -1.95174354439337, 218, 17, 'PPL', 'P'),
(180689, 'China Lake', 35.6508293151855, 0.622224352616503, -117.660827636719, -2.05356884288228, 218, 6, 'PPL', 'P'),
(180690, 'China Lake Acres', 35.6405601501465, 0.622045121875141, -117.763061523438, -2.05535316081263, 218, 6, 'PPL', 'P'),
(93226, 'China Springs', 31.6522197723389, 0.552435450592163, -97.307502746582, -1.69833630982128, 218, 51, 'PPL', 'P'),
(200571, 'China Town', 44.4930610656738, 0.776550409886905, -117.698333740234, -2.05422344787822, 218, 43, 'PPL', 'P'),
(45767, 'Chinaberry Manor', 38.3380584716797, 0.669125349152916, -75.648063659668, -1.32030778361948, 218, 25, 'PPL', 'P'),
(191260, 'Chinati', 29.824010848999, 0.520527185465542, -104.605331420898, -1.82570744843456, 218, 51, 'PPL', 'P'),
(13059, 'Chinatown', 38.9008293151855, 0.678947553306319, -77.023063659668, -1.3443060608344, 218, 9, 'PPL', 'P'),
(119133, 'Chinatown', 41.8516693115234, 0.730449426941952, -87.6291732788086, -1.52941759451585, 218, 18, 'PPL', 'P'),
(180692, 'Chinatown', 38.2138900756836, 0.666958201815864, -119.013061523438, -2.07716977646256, 218, 6, 'PPL', 'P'),
(196212, 'Chinatown', 44.8827781677246, 0.783352256469022, -113.194717407227, -1.97562051462064, 218, 31, 'PPL', 'P'),
(199875, 'Chinatown', 41.5316696166992, 0.724864378661893, -119.205001831055, -2.08051976679777, 218, 39, 'PPL', 'P'),
(211678, 'Chinatown', 21.3150005340576, 0.372016939383655, -157.866394042969, -2.75528835430057, 218, 15, 'PPL', 'P'),
(180695, 'Chinatown (historical)', 37.3338890075684, 0.651599285756186, -121.889167785645, -2.1273673003753, 218, 6, 'PPL', 'P'),
(160070, 'Chinchilla', 41.4749984741211, 0.723875280633037, -75.6774978637695, -1.32082150739375, 218, 45, 'PPL', 'P'),
(39769, 'Chinchuba', 30.3869400024414, 0.530352152648576, -90.079719543457, -1.57218769530641, 218, 22, 'PPL', 'P'),
(100796, 'Chincoteague', 37.9330596923828, 0.662056786987627, -75.3791732788086, -1.31561476114654, 218, 53, 'PPL', 'P'),
(180696, 'Chinese Camp', 37.8711090087891, 0.660975543585055, -120.432220458984, -2.10193877249695, 218, 6, 'PPL', 'P'),
(100797, 'Chinese Corner', 36.8455581665039, 0.643076304740578, -76.1561126708984, -1.32917491162695, 218, 53, 'PPL', 'P'),
(45768, 'Chingville', 38.2408294677734, 0.667428382906317, -76.5588912963867, -1.33620472479838, 218, 25, 'PPL', 'P'),
(211745, 'Chiniak', 57.6319389343262, 1.0058670887123, -152.182495117188, -2.65608560369512, 218, 1, 'PPL', 'P'),
(177921, 'Chinle', 36.1544418334961, 0.631014049215282, -109.551940917969, -1.91204207096885, 218, 5, 'PPL', 'P'),
(1558, 'Chinn', 33.371940612793, 0.582450241473251, -87.0480575561523, -1.51927521182039, 218, 2, 'PPL', 'P'),
(1560, 'Chinnabee', 33.4627799987793, 0.584035687849203, -85.9669418334961, -1.50040618286496, 218, 2, 'PPL', 'P'),
(1559, 'Chinnabee (historical)', 33.5974998474121, 0.586386992775634, -85.8180618286133, -1.49780773658937, 218, 2, 'PPL', 'P'),
(80326, 'Chinners', 33.9805603027344, 0.593072658955196, -79.1455612182617, -1.3813506315974, 218, 48, 'PPL', 'P'),
(180697, 'Chino', 34.0122184753418, 0.59362519830236, -117.688056945801, -2.05404408397881, 218, 6, 'PPL', 'P'),
(180698, 'Chino Hills', 33.8936080932617, 0.591555056608014, -117.726387023926, -2.05471307004463, 218, 6, 'PPL', 'P'),
(177922, 'Chino Valley', 34.7574996948242, 0.606632809435607, -112.453056335449, -1.96267608698426, 218, 5, 'PPL', 'P'),
(196213, 'Chinook', 48.5900001525879, 0.848055486207206, -109.230560302734, -1.90643292108093, 218, 31, 'PPL', 'P'),
(207034, 'Chinook', 46.2730598449707, 0.807617249267116, -123.94416809082, -2.16323382183011, 218, 56, 'PPL', 'P'),
(58988, 'Chinquapin', 30.7347202301025, 0.536422062694599, -89.7738876342773, -1.56684992153356, 218, 30, 'PPL', 'P'),
(63669, 'Chinquapin', 34.8308296203613, 0.607912658076472, -77.8166732788086, -1.3581571616639, 218, 33, 'PPL', 'P'),
(80327, 'Chinquapin', 34.1761093139648, 0.596485633050187, -82.2141723632813, -1.43490799954139, 218, 48, 'PPL', 'P'),
(93228, 'Chinquapin', 31.4027805328369, 0.548081914579183, -94.0991668701172, -1.64234028526711, 218, 51, 'PPL', 'P'),
(100798, 'Chinquapin', 38.0436096191406, 0.66398624719739, -78.9063873291016, -1.37717625974676, 218, 53, 'PPL', 'P'),
(45769, 'Chinquapin Crest', 38.8752784729004, 0.678501606981785, -76.6666717529297, -1.33808584863436, 218, 25, 'PPL', 'P'),
(80328, 'Chinquapin Falls', 33.8252792358398, 0.590362493071877, -81.5224990844727, -1.42283602347811, 218, 48, 'PPL', 'P'),
(85799, 'Chinquapin Grove', 36.4430618286133, 0.636051418417167, -82.2133331298828, -1.43489335215539, 218, 50, 'PPL', 'P'),
(93234, 'Chinquapin Landing', 28.7491703033447, 0.501767679009942, -95.76611328125, -1.67143398859568, 218, 51, 'PPL', 'P'),
(39771, 'Chinquapin Park', 31.7591705322266, 0.554302093489713, -93.061393737793, -1.62422772721932, 218, 22, 'PPL', 'P'),
(100801, 'Chinquapin Village', 38.8202781677246, 0.677541670566866, -77.0824966430664, -1.34534336207899, 218, 53, 'PPL', 'P'),
(58989, 'Chins Springs (historical)', 33.6769409179688, 0.587773501018156, -88.3963928222656, -1.54280810163482, 218, 30, 'PPL', 'P'),
(85800, 'Chinubee', 35.1230583190918, 0.613013011038137, -87.5186080932617, -1.52748786798997, 218, 50, 'PPL', 'P'),
(63671, 'Chip', 35.2597198486328, 0.615398204689439, -79.8936080932617, -1.39440651252541, 218, 33, 'PPL', 'P'),
(186536, 'Chipeta', 38.6811103820801, 0.675112734494659, -108.008331298828, -1.88510100074939, 218, 7, 'PPL', 'P'),
(186535, 'Chipita Park', 38.9244384765625, 0.679359610905981, -105.00611114502, -1.8327023741957, 218, 7, 'PPL', 'P'),
(15516, 'Chipley', 30.7816696166992, 0.537241484072502, -85.5386123657227, -1.492930423369, 218, 12, 'PPL', 'P'),
(93229, 'Chipley', 28.7863903045654, 0.50241729057884, -97.0355606079102, -1.69359002412654, 218, 51, 'PPL', 'P'),
(63672, 'Chipley Park', 35.8436088562012, 0.625588990337709, -80.904167175293, -1.41204409579278, 218, 33, 'PPL', 'P'),
(85801, 'Chipman', 36.4486083984375, 0.636148224322792, -86.279167175293, -1.50585554308748, 218, 50, 'PPL', 'P'),
(147796, 'Chipman', 44.7811088562012, 0.781577792234702, -75.1963882446289, -1.31242456047673, 218, 40, 'PPL', 'P'),
(147797, 'Chipman Corners', 42.6327781677246, 0.74408234829915, -76.3755569458008, -1.33300493674865, 218, 40, 'PPL', 'P'),
(147798, 'Chipmunk', 42.0569381713867, 0.734032044398381, -78.5755615234375, -1.37140226018736, 218, 40, 'PPL', 'P'),
(15517, 'Chipola', 30.5049991607666, 0.532412673673484, -85.1183319091797, -1.48559514562054, 218, 12, 'PPL', 'P'),
(39776, 'Chipola', 30.9219398498535, 0.539689661483585, -90.8030624389648, -1.58481241045393, 218, 22, 'PPL', 'P'),
(15518, 'Chipola Terrace', 30.827220916748, 0.538036504236918, -85.1658325195313, -1.48642418766788, 218, 12, 'PPL', 'P'),
(45770, 'Chippendale', 39.6602783203125, 0.692202438946779, -75.8680572509766, -1.3241473961211, 218, 25, 'PPL', 'P'),
(171854, 'Chippenhook', 43.5183296203613, 0.759538136843479, -73.0144424438477, -1.27434242215304, 218, 55, 'PPL', 'P'),
(119134, 'Chippewa', 42.0213890075684, 0.73341159444342, -88.4150009155273, -1.54313287412975, 218, 18, 'PPL', 'P'),
(160071, 'Chippewa', 41.2377815246582, 0.719735063823373, -76.7772216796875, -1.34001530884412, 218, 45, 'PPL', 'P'),
(196214, 'Chippewa (historical)', 47.0916709899902, 0.821904709041227, -108.935829162598, -1.90128889227739, 218, 31, 'PPL', 'P'),
(147799, 'Chippewa Bay', 44.4419403076172, 0.775658184342702, -75.7572174072266, -1.32221287590527, 218, 40, 'PPL', 'P'),
(130209, 'Chippewa Beach', 45.4402809143066, 0.79308251498579, -84.6391677856445, -1.47723215400742, 218, 27, 'PPL', 'P'),
(134657, 'Chippewa City', 47.7597198486328, 0.83356436118873, -90.3019409179688, -1.57606618995995, 218, 28, 'PPL', 'P'),
(173535, 'Chippewa Falls', 44.936939239502, 0.784297545497946, -91.3927764892578, -1.59510486227681, 218, 57, 'PPL', 'P'),
(20037, 'Chippewa Forest', 33.5661087036133, 0.585839113960377, -84.4630584716797, -1.4741584666353, 218, 13, 'PPL', 'P'),
(130211, 'Chippewa Lake', 43.7438888549805, 0.763474888145862, -85.2972183227539, -1.48871730252449, 218, 27, 'PPL', 'P'),
(154715, 'Chippewa Lake', 41.0697212219238, 0.71680185819876, -81.9011077880859, -1.42944399193287, 218, 41, 'PPL', 'P'),
(154716, 'Chippewa Lake Park', 41.0633316040039, 0.716690338328112, -81.8958282470703, -1.42935184655915, 218, 41, 'PPL', 'P'),
(20038, 'Chippewa Terrace', 31.9986095428467, 0.558481092582752, -81.1163864135742, -1.41574802023686, 218, 13, 'PPL', 'P'),
(130212, 'Chippewa Vista', 43.7383308410645, 0.763377882503155, -85.0994415283203, -1.48526544627758, 218, 27, 'PPL', 'P'),
(154718, 'Chippewa-on-the-Lake (historical)', 41.0697212219238, 0.71680185819876, -81.9011077880859, -1.42944399193287, 218, 41, 'PPL', 'P'),
(188308, 'Chippeway Park', 32.9094390869141, 0.574378067051167, -105.704719543457, -1.84489539093052, 218, 38, 'PPL', 'P'),
(45771, 'Chippingwood', 38.4866714477539, 0.671719134896598, -76.5280609130859, -1.33566663310013, 218, 25, 'PPL', 'P'),
(100800, 'Chippokes', 37.1411094665527, 0.64823464803498, -76.7255630493164, -1.33911369565707, 218, 53, 'PPL', 'P'),
(26780, 'Chipps', 39.6330604553223, 0.691727397587336, -88.5811080932617, -1.54603199129241, 218, 18, 'PPL', 'P'),
(180699, 'Chipps', 38.0513916015625, 0.664122068412984, -121.913887023926, -2.1277987324719, 218, 6, 'PPL', 'P'),
(180700, 'Chiquita', 38.6349983215332, 0.674307927213237, -122.873329162598, -2.1445441567741, 218, 6, 'PPL', 'P'),
(93230, 'Chireno', 31.4991703033447, 0.549764233439787, -94.3516693115234, -1.64674728423898, 218, 51, 'PPL', 'P'),
(180701, 'Chiriaco Summit', 33.660831451416, 0.587492337786071, -115.720558166504, -2.01970475225111, 218, 6, 'PPL', 'P'),
(177923, 'Chiricahua', 31.5922203063965, 0.55138826236203, -109.23999786377, -1.90659763759435, 218, 5, 'PPL', 'P'),
(134660, 'Chisago City', 45.3736114501953, 0.791918913326507, -92.8897171020508, -1.62123140467687, 218, 28, 'PPL', 'P'),
(211746, 'Chisana', 62.0661087036133, 1.08325795077876, -142.040832519531, -2.47908019973965, 218, 1, 'PPL', 'P'),
(211747, 'Chisana (historical)', 62.1530609130859, 1.08477555312594, -142.156936645508, -2.48110659901309, 218, 1, 'PPL', 'P'),
(1561, 'Chisca', 34.7625007629395, 0.606720094540334, -88.0055618286133, -1.53598681397674, 218, 2, 'PPL', 'P'),
(188309, 'Chise', 33.2722206115723, 0.580709799121857, -107.596939086914, -1.87792085213443, 218, 38, 'PPL', 'P'),
(171855, 'Chiselville', 43.0711097717285, 0.751732678004566, -73.1350021362305, -1.27644658573031, 218, 55, 'PPL', 'P'),
(100802, 'Chisford', 38.1427803039551, 0.66571710216886, -76.8002777099609, -1.34041771248483, 218, 53, 'PPL', 'P'),
(1563, 'Chisholm', 32.4172210693359, 0.565787242006789, -86.2855606079102, -1.50596712953715, 218, 2, 'PPL', 'P'),
(93231, 'Chisholm', 32.8380584716797, 0.573132240293228, -96.3713912963867, -1.68199808284975, 218, 51, 'PPL', 'P'),
(127108, 'Chisholm', 44.4813919067383, 0.776346744642542, -70.1999969482422, -1.2252210816368, 218, 26, 'PPL', 'P'),
(134664, 'Chisholm', 47.4891700744629, 0.828842376838938, -92.8836135864258, -1.62112487823327, 218, 28, 'PPL', 'P'),
(75434, 'Chism', 34.9127807617188, 0.609342975318926, -96.9366683959961, -1.69186402942406, 218, 42, 'PPL', 'P'),
(63674, 'Chisman (historical)', 36.3147201538086, 0.633811433624302, -80.0638885498047, -1.39737846714388, 218, 33, 'PPL', 'P'),
(8072, 'Chismville', 35.2172203063965, 0.614656447746825, -93.9402770996094, -1.63956713562401, 218, 4, 'PPL', 'P'),
(75439, 'Chisney', 35.1463890075684, 0.61342020836881, -96.9261093139648, -1.69167973867663, 218, 42, 'PPL', 'P'),
(80329, 'Chisolm', 32.5374984741211, 0.567886478736044, -80.602783203125, -1.40678395316571, 218, 48, 'PPL', 'P'),
(112539, 'Chisolms', 32.5755615234375, 0.568550804269964, -80.6733322143555, -1.40801526569571, 218, 48, 'PPL', 'P'),
(191261, 'Chispa', 30.7444400787354, 0.536591706056037, -104.696937561035, -1.82730627719499, 218, 51, 'PPL', 'P'),
(211748, 'Chistochina', 62.564998626709, 1.0919652225418, -144.66471862793, -2.52487565152855, 218, 1, 'PPL', 'P'),
(188310, 'Chisum', 33.2619400024414, 0.580530368643413, -104.418327331543, -1.82244361136061, 218, 38, 'PPL', 'P'),
(93232, 'Chita', 30.9363899230957, 0.539941862838815, -95.2080612182617, -1.66169414269899, 218, 51, 'PPL', 'P'),
(58991, 'Chita (historical)', 33.2255592346191, 0.579895404460511, -89.6022186279297, -1.56385373214917, 218, 30, 'PPL', 'P'),
(211749, 'Chitina', 61.5158309936523, 1.07365379293961, -144.436935424805, -2.52090008465328, 218, 1, 'PPL', 'P'),
(173538, 'Chittamo', 46.128059387207, 0.805086513862241, -91.7163925170898, -1.60075302747471, 218, 57, 'PPL', 'P'),
(147800, 'Chittenango', 43.0449981689453, 0.751276944563026, -75.866943359375, -1.32412795504514, 218, 40, 'PPL', 'P'),
(147801, 'Chittenango Falls', 42.978328704834, 0.750113342903743, -75.8372192382813, -1.32360917126479, 218, 40, 'PPL', 'P'),
(171856, 'Chittenden', 43.7077789306641, 0.762844651073894, -72.9486083984375, -1.27319340130072, 218, 55, 'PPL', 'P'),
(180703, 'Chittenden', 36.9013900756836, 0.644050755383438, -121.60417175293, -2.12239318124931, 218, 6, 'PPL', 'P'),
(154719, 'Chittendens Corners', 41.2319412231445, 0.71963313133265, -81.4941711425781, -1.42234160762174, 218, 41, 'PPL', 'P'),
(85802, 'Chittum', 36.4241714477539, 0.635721719074215, -83.5680618286133, -1.4585378284195, 218, 50, 'PPL', 'P'),
(26781, 'Chittyville', 37.8294410705566, 0.660248300870382, -89.0277786254883, -1.5538278627514, 218, 18, 'PPL', 'P'),
(54033, 'Chitwood', 37.1949996948242, 0.649175209952969, -90.9725036621094, -1.58776971768641, 218, 29, 'PPL', 'P'),
(200572, 'Chitwood', 44.6549987792969, 0.779376756172779, -123.821388244629, -2.16109090925898, 218, 43, 'PPL', 'P'),
(177924, 'Chiuli Shaik', 31.8286094665527, 0.555514031522781, -111.646110534668, -1.94859222587548, 218, 5, 'PPL', 'P'),
(177925, 'Chiulikam', 32.5744400024414, 0.568531230035952, -112.525283813477, -1.96393669428625, 218, 5, 'PPL', 'P'),
(186537, 'Chivington', 38.4363899230957, 0.67084155673839, -102.543060302734, -1.78971402735381, 218, 7, 'PPL', 'P'),
(58992, 'Chiwapa', 34.1813888549805, 0.596577778423904, -88.9308319091797, -1.55213582335282, 218, 30, 'PPL', 'P'),
(207035, 'Chiwaukum', 47.690559387207, 0.832357283424652, -120.734718322754, -2.10721835619998, 218, 56, 'PPL', 'P'),
(39772, 'Chloe', 30.2397193908691, 0.527782668249841, -93.1141662597656, -1.62514878148232, 218, 22, 'PPL', 'P'),
(54035, 'Chloe', 38.1841697692871, 0.666439484614544, -93.7330627441406, -1.63595056286369, 218, 29, 'PPL', 'P'),
(108582, 'Chloe', 38.6925010681152, 0.675311539470034, -81.086669921875, -1.41522936961457, 218, 58, 'PPL', 'P'),
(75435, 'Chloeta', 36.4230613708496, 0.635702344577285, -94.9705581665039, -1.65754893246228, 218, 42, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(54034, 'Chloride', 37.4605598449707, 0.653810108935115, -90.6869430541992, -1.58278574486438, 218, 29, 'PPL', 'P'),
(177926, 'Chloride', 35.4144401550293, 0.618098583455752, -114.198608398438, -1.99314171774838, 218, 5, 'PPL', 'P'),
(188311, 'Chloride', 33.3386116027832, 0.581868540512151, -107.677223205566, -1.87932207434198, 218, 38, 'PPL', 'P'),
(180704, 'Chloride City', 36.7066688537598, 0.640652228937361, -116.881393432617, -2.03996514971805, 218, 6, 'PPL', 'P'),
(26788, 'Choat', 37.2133293151855, 0.649495122178914, -88.7986068725586, -1.54982806111021, 218, 18, 'PPL', 'P'),
(13533, 'Choate', 39.702220916748, 0.692934475351415, -75.6958312988281, -1.32114148619873, 218, 10, 'PPL', 'P'),
(93233, 'Choate', 28.764440536499, 0.502034194856032, -97.7427825927734, -1.7059333763049, 218, 51, 'PPL', 'P'),
(173539, 'Choate', 45.378059387207, 0.791996544472283, -88.8222198486328, -1.5502401852889, 218, 57, 'PPL', 'P'),
(35237, 'Choateville', 38.2000007629395, 0.666715787577639, -84.9077835083008, -1.48192038279039, 218, 21, 'PPL', 'P'),
(1565, 'Choccolocco', 33.6591682434082, 0.587463309330189, -85.70361328125, -1.49581023261375, 218, 2, 'PPL', 'P'),
(75436, 'Chockie', 34.5819396972656, 0.603568709443416, -95.9980621337891, -1.67548225976871, 218, 42, 'PPL', 'P'),
(93235, 'Chocolate Bayou', 29.3190135955811, 0.511713320679871, -95.2554092407227, -1.66252052158524, 218, 51, 'PPL', 'P'),
(93236, 'Chocolate Springs', 29.3044395446777, 0.511458955506254, -95.2619400024414, -1.6626345048799, 218, 51, 'PPL', 'P'),
(15519, 'Choconickla (historical)', 30.4666690826416, 0.531743687607656, -85.0055618286133, -1.48362693641691, 218, 12, 'PPL', 'P'),
(160073, 'Choconut', 41.9786109924316, 0.732664977231817, -76, -1.32645023151569, 218, 45, 'PPL', 'P'),
(147802, 'Choconut Center', 42.1427803039551, 0.735530272248633, -75.9438934326172, -1.32547098718287, 218, 40, 'PPL', 'P'),
(143628, 'Chocorua', 43.8788909912109, 0.765831119920309, -71.2202835083008, -1.24302844142367, 218, 36, 'PPL', 'P'),
(63675, 'Chocowinity', 35.5125007629395, 0.619810063930292, -77.100830078125, -1.34566334088396, 218, 33, 'PPL', 'P'),
(8073, 'Choctaw', 35.5275001525879, 0.620071852665447, -92.4397201538086, -1.61337747630612, 218, 4, 'PPL', 'P'),
(15520, 'Choctaw', 30.3672199249268, 0.530007972367197, -86.1061096191406, -1.50283511893716, 218, 12, 'PPL', 'P'),
(26782, 'Choctaw', 39.2822189331055, 0.685604057871945, -87.7213897705078, -1.53102707592063, 218, 18, 'PPL', 'P'),
(39775, 'Choctaw', 30.3880596160889, 0.530371693593075, -91.2986068725586, -1.59346129241007, 218, 22, 'PPL', 'P'),
(58995, 'Choctaw', 33.172779083252, 0.578974217039453, -90.304443359375, -1.57610986580182, 218, 30, 'PPL', 'P'),
(75437, 'Choctaw', 35.497501373291, 0.619548275195137, -97.2686080932617, -1.69765747005942, 218, 42, 'PPL', 'P'),
(58996, 'Choctaw (historical)', 32.1041717529297, 0.560323500714383, -88.8069381713867, -1.54997346970573, 218, 30, 'PPL', 'P'),
(15521, 'Choctaw Bay Estates', 30.3769397735596, 0.530177615728635, -86.1366729736328, -1.50336855010351, 218, 12, 'PPL', 'P'),
(15522, 'Choctaw Beach', 30.4711093902588, 0.531821185595378, -86.3433303833008, -1.50697540232586, 218, 12, 'PPL', 'P'),
(1567, 'Choctaw Bluff', 31.3886108398438, 0.547834606782456, -87.7888870239258, -1.53220512522883, 218, 2, 'PPL', 'P'),
(1570, 'Choctaw City', 32.2088890075684, 0.562151161591477, -88.0941696166992, -1.53753331162175, 218, 2, 'PPL', 'P'),
(1568, 'Choctaw Corner', 31.9347190856934, 0.557365993744822, -87.7547225952148, -1.53160884346076, 218, 2, 'PPL', 'P'),
(1571, 'Choctaw Hills', 32.9688911437988, 0.575415701190889, -87.1858291625977, -1.52167977996862, 218, 2, 'PPL', 'P'),
(72097, 'Choctaw Lake', 39.9599990844727, 0.697433553117968, -83.4850006103516, -1.45708813668011, 218, 41, 'PPL', 'P'),
(72098, 'Choctaw Lake Subdivision', 39.964168548584, 0.697506323994754, -83.491943359375, -1.45720931050971, 218, 41, 'PPL', 'P'),
(58998, 'Choctaw Landing', 32.8697204589844, 0.573684846219419, -90.8088912963867, -1.58491414320757, 218, 30, 'PPL', 'P'),
(8074, 'Choctaw Pines', 35.5200004577637, 0.619940958297869, -92.3444366455078, -1.61171446536342, 218, 4, 'PPL', 'P'),
(20045, 'Choestoe', 34.795280456543, 0.607292208121511, -83.8872222900391, -1.46410822931356, 218, 13, 'PPL', 'P'),
(93237, 'Choice', 31.6994400024414, 0.553259599081002, -94.1452789306641, -1.64314509254853, 218, 51, 'PPL', 'P'),
(134665, 'Choice', 43.6597213745117, 0.762005888488574, -91.7905578613281, -1.60204745692254, 218, 28, 'PPL', 'P'),
(20039, 'Choice (historical)', 33.8813896179199, 0.591341803983726, -84.1638870239258, -1.46893693984404, 218, 13, 'PPL', 'P'),
(203405, 'Chokecherry Summer Home Area', 41.7713890075684, 0.729048271313434, -111.654998779297, -1.94874735500898, 218, 52, 'PPL', 'P'),
(20040, 'Chokee', 31.8936100006104, 0.556648504857641, -84.0497207641602, -1.46694436271644, 218, 13, 'PPL', 'P'),
(134666, 'Chokio', 45.5716705322266, 0.79537569642143, -96.1730575561523, -1.67853650606487, 218, 28, 'PPL', 'P'),
(15523, 'Chokoloskee', 25.8125, 0.450513113171036, -81.3622207641602, -1.42003863906909, 218, 12, 'PPL', 'P'),
(198119, 'Chola', 48.6222190856934, 0.848617812671376, -101.490280151367, -1.77133954741281, 218, 34, 'PPL', 'P'),
(180705, 'Cholame', 35.7238883972168, 0.623499474146433, -120.295562744141, -2.09955364542468, 218, 6, 'PPL', 'P'),
(59000, 'Chomontakali (historical)', 32.6236114501953, 0.56938943369723, -88.7249984741211, -1.54854335220036, 218, 30, 'PPL', 'P'),
(207036, 'Chopaka', 48.999439239502, 0.855201546360215, -119.723609924316, -2.08957118555268, 218, 56, 'PPL', 'P'),
(100803, 'Chopawamsic (historical)', 38.5305595397949, 0.672485126605132, -77.4236068725586, -1.35129685869586, 218, 53, 'PPL', 'P'),
(113284, 'Chopersville', 40.0033302307129, 0.698189824288523, -75.1316680908203, -1.31129498070038, 218, 45, 'PPL', 'P'),
(39777, 'Chopin', 31.4966697692871, 0.549720590887423, -92.8591690063477, -1.62069823982664, 218, 22, 'PPL', 'P'),
(39778, 'Chopin (historical)', 29.9838905334473, 0.523317612366214, -90.8047180175781, -1.58484130575176, 218, 22, 'PPL', 'P'),
(169316, 'Chopmist', 41.8252792358398, 0.729988833231423, -71.6708297729492, -1.25089195717434, 218, 47, 'PPL', 'P'),
(20041, 'Chopped Oak', 34.7841682434082, 0.607098263415126, -84.4613876342773, -1.47412930502136, 218, 13, 'PPL', 'P'),
(80330, 'Choppee', 33.5711097717285, 0.585926399065105, -79.383056640625, -1.38549570867606, 218, 48, 'PPL', 'P'),
(85803, 'Choptack', 36.4041709899902, 0.635372645234333, -83.0975036621094, -1.45032503909185, 218, 50, 'PPL', 'P'),
(45772, 'Choptank', 38.6808280944824, 0.675107807646643, -75.9486083984375, -1.32555327886055, 218, 25, 'PPL', 'P'),
(13534, 'Choptank Mills', 39.0669403076172, 0.681846737048006, -75.7355575561523, -1.32183484018853, 218, 10, 'PPL', 'P'),
(45774, 'Choptank Overlook', 38.9397201538086, 0.679626326489153, -75.8249969482422, -1.32339585206148, 218, 25, 'PPL', 'P'),
(45775, 'Choptank Pines', 39.0055618286133, 0.680775480499522, -75.772216796875, -1.32247466464042, 218, 25, 'PPL', 'P'),
(45776, 'Choptank Ponds', 38.982780456543, 0.680377870548773, -75.7874984741211, -1.32274138022359, 218, 25, 'PPL', 'P'),
(180709, 'Chorro', 35.3266716003418, 0.616566733196739, -120.676666259766, -2.10620515656326, 218, 6, 'PPL', 'P'),
(85804, 'Chota', 35.6169395446777, 0.621632864538397, -84.0369415283203, -1.46672132297515, 218, 50, 'PPL', 'P'),
(85805, 'Chota (historical)', 35.5550003051758, 0.620551820872906, -84.129997253418, -1.46834545176593, 218, 50, 'PPL', 'P'),
(59001, 'Chotard', 32.5905609130859, 0.568812593005119, -91.022216796875, -1.58863737556956, 218, 30, 'PPL', 'P'),
(196215, 'Choteau', 47.8125, 0.834485548609789, -112.182777404785, -1.9579588297454, 218, 31, 'PPL', 'P'),
(196216, 'Choteau Junction', 47.8050003051758, 0.834354654242211, -112.176109313965, -1.95784244960576, 218, 31, 'PPL', 'P'),
(85806, 'Choto Estates', 35.8216705322266, 0.625206094351983, -84.147216796875, -1.46864598949495, 218, 50, 'PPL', 'P'),
(85807, 'Choto Hills', 35.8147201538086, 0.62508478736433, -84.1355590820313, -1.46844252398766, 218, 50, 'PPL', 'P'),
(39779, 'Choudrant', 32.5299987792969, 0.567755584368467, -92.5141677856445, -1.61467683260197, 218, 22, 'PPL', 'P'),
(177928, 'Choulic', 31.6672191619873, 0.552697239327318, -111.776107788086, -1.95086110596618, 218, 5, 'PPL', 'P'),
(39782, 'Choupique', 30.1683292388916, 0.526536675044333, -93.4347229003906, -1.63074355030036, 218, 22, 'PPL', 'P'),
(32071, 'Chouteau', 39.0472183227539, 0.681502523477114, -94.8300018310547, -1.65509576162416, 218, 20, 'PPL', 'P'),
(75441, 'Chouteau', 36.1858291625977, 0.631561861451512, -95.3427810668945, -1.66404544762542, 218, 42, 'PPL', 'P'),
(54036, 'Chouteau Springs', 38.9249992370605, 0.679369398022987, -92.8947219848633, -1.62131875636063, 218, 29, 'PPL', 'P'),
(63677, 'Chowan', 36.2663917541504, 0.632967943928046, -76.6680603027344, -1.33811008340028, 218, 33, 'PPL', 'P'),
(63679, 'Chowan Beach', 36.4174995422363, 0.635605272355552, -76.9499969482422, -1.34303080614641, 218, 33, 'PPL', 'P'),
(63682, 'Chowansville (historical)', 35.7347183227539, 0.623688492004801, -80.7188873291016, -1.40881035243915, 218, 33, 'PPL', 'P'),
(180710, 'Chowchilla', 37.1230583190918, 0.647919596078024, -120.259170532227, -2.0989184815047, 218, 6, 'PPL', 'P'),
(100804, 'Chowning Place', 37.2166709899902, 0.649553445406787, -80.4458312988281, -1.40404462566846, 218, 53, 'PPL', 'P'),
(63681, 'Choyce Acres', 35.8491706848145, 0.625686062559443, -80.2613906860352, -1.40082552970082, 218, 33, 'PPL', 'P'),
(54038, 'Chraneville (historical)', 39.5224990844727, 0.689797737640492, -92.9286117553711, -1.62191024443873, 218, 29, 'PPL', 'P'),
(93238, 'Chriesman', 30.5991706848145, 0.53405627682974, -96.7705612182617, -1.6889649122614, 218, 51, 'PPL', 'P'),
(45777, 'Chris Mar Estates', 39.1991691589355, 0.684154565869642, -76.977783203125, -1.34351576778092, 218, 25, 'PPL', 'P'),
(177927, 'Chris-Town Travel Trailer and Mobile Home Park', 33.5127792358398, 0.584908339159395, -112.099998474121, -1.95651406485403, 218, 5, 'PPL', 'P'),
(45778, 'Chrisland At Annapolis Cove', 38.9377784729004, 0.679592437764281, -76.4727783203125, -1.33470176983719, 218, 25, 'PPL', 'P'),
(26784, 'Chrisman', 39.8036117553711, 0.694704079316745, -87.6736068725586, -1.53019310702528, 218, 18, 'PPL', 'P'),
(72099, 'Chrisman', 39.8330612182617, 0.695218069407131, -83.3727798461914, -1.45512951485641, 218, 41, 'PPL', 'P'),
(180711, 'Chrisman', 34.297779083252, 0.598609171124389, -119.301109313965, -2.08219715881036, 218, 6, 'PPL', 'P'),
(29473, 'Chrisney', 38.014720916748, 0.663482044224011, -87.0363922119141, -1.51907161315505, 218, 19, 'PPL', 'P'),
(100805, 'Christ Church', 37.6816711425781, 0.657669229091722, -76.4233322143555, -1.33383877248595, 218, 53, 'PPL', 'P'),
(20042, 'Christa', 33.4213905334473, 0.583313305403519, -82.091667175293, -1.43276988066022, 218, 13, 'PPL', 'P'),
(100806, 'Christchurch', 37.6047210693359, 0.656326196953995, -76.5347213745117, -1.33578288008171, 218, 53, 'PPL', 'P'),
(193449, 'Christensen', 41.2808303833008, 0.720486408145911, -120.567497253418, -2.10429979796136, 218, 6, 'PPL', 'P'),
(100807, 'Christensons Corner', 37.3877792358398, 0.652539847674175, -76.7088928222656, -1.33882274530798, 218, 53, 'PPL', 'P'),
(100808, 'Christian', 38.1822204589844, 0.666405462731618, -79.227783203125, -1.38278567595079, 218, 53, 'PPL', 'P'),
(108583, 'Christian', 37.6919403076172, 0.657848459833084, -81.8561096191406, -1.42865862572741, 218, 58, 'PPL', 'P'),
(211750, 'Christian', 67.3600006103516, 1.17565379479602, -145.196105957031, -2.53415011002475, 218, 1, 'PPL', 'P'),
(85808, 'Christian Bend', 36.4749984741211, 0.636608818033321, -82.7947235107422, -1.44504052854081, 218, 50, 'PPL', 'P'),
(54039, 'Christian Center', 36.9408302307129, 0.644739115946196, -93.1666717529297, -1.62606517521342, 218, 29, 'PPL', 'P'),
(85811, 'Christian Chapel', 36.2227783203125, 0.632206745909474, -89.0441665649414, -1.55411388625248, 218, 50, 'PPL', 'P'),
(160075, 'Christian Corner', 40.8308296203613, 0.712632413196131, -75.5497207641602, -1.31859137629692, 218, 45, 'PPL', 'P'),
(20043, 'Christian Corners', 33.5544395446777, 0.585635448716013, -84.5216674804688, -1.47518138681, 218, 13, 'PPL', 'P'),
(147804, 'Christian Hill', 43.7372207641602, 0.763358508006225, -74.0791702270508, -1.29292542760739, 218, 40, 'PPL', 'P'),
(160076, 'Christian Hill', 41.8502807617188, 0.730425192176033, -77.351936340332, -1.35004597193185, 218, 45, 'PPL', 'P'),
(169317, 'Christian Hill', 41.8144416809082, 0.729799682215, -71.420280456543, -1.24651904666443, 218, 47, 'PPL', 'P'),
(143629, 'Christian Hollow', 43.0366706848145, 0.751131602546535, -72.3899993896484, -1.26344383486605, 218, 36, 'PPL', 'P'),
(143630, 'Christian Shore', 43.0863914489746, 0.751999393587737, -70.7705612182617, -1.23517930674288, 218, 36, 'PPL', 'P'),
(160077, 'Christian Springs', 40.7341690063477, 0.710945367224594, -75.3411102294922, -1.31495043561262, 218, 45, 'PPL', 'P'),
(124521, 'Christian Town', 41.4252815246582, 0.723007556170862, -70.6875, -1.23372961500349, 218, 23, 'PPL', 'P'),
(1572, 'Christiana', 33.3772201538086, 0.582542386846968, -85.6402816772461, -1.49470488760332, 218, 2, 'PPL', 'P'),
(13535, 'Christiana', 39.6650009155273, 0.692284863782517, -75.6602783203125, -1.32052096966474, 218, 10, 'PPL', 'P'),
(45779, 'Christiana', 38.639720916748, 0.674390352048975, -76.5397186279297, -1.33587009860741, 218, 25, 'PPL', 'P'),
(78028, 'Christiana', 39.954719543457, 0.697341407744251, -75.9972229003906, -1.32640176198385, 218, 45, 'PPL', 'P'),
(85812, 'Christiana', 35.7099990844727, 0.623257059908209, -86.3994369506836, -1.50795464665868, 218, 50, 'PPL', 'P'),
(13536, 'Christiana Acres', 39.6888885498047, 0.692701781651169, -75.6194381713867, -1.31980817459898, 218, 10, 'PPL', 'P'),
(45780, 'Christiana Estates', 39.4686088562012, 0.688857175722504, -76.9313888549805, -1.34270603365148, 218, 25, 'PPL', 'P'),
(13537, 'Christiana Green', 39.6541709899902, 0.692095845924149, -75.6797180175781, -1.32086025638761, 218, 10, 'PPL', 'P'),
(13539, 'Christiana Landing', 39.6500015258789, 0.692023075047363, -75.6580581665039, -1.32048222067088, 218, 10, 'PPL', 'P'),
(13540, 'Christiana Village', 39.6652793884277, 0.692289724051507, -75.6647186279297, -1.32059846765246, 218, 10, 'PPL', 'P'),
(35239, 'Christianburg', 38.2780609130859, 0.668078194212297, -85.0994415283203, -1.48526544627758, 218, 21, 'PPL', 'P'),
(85813, 'Christianburg', 35.5369415283203, 0.620236635757895, -84.4430618286133, -1.47380945937445, 218, 50, 'PPL', 'P'),
(192516, 'Christianburg', 39.1594390869141, 0.683461145300812, -111.752220153809, -1.95044418809752, 218, 52, 'PPL', 'P'),
(29472, 'Christiansburg', 39.0886116027832, 0.682224972501825, -86.1561126708984, -1.50370783682638, 218, 19, 'PPL', 'P'),
(100810, 'Christiansburg', 37.1297187805176, 0.648035843059606, -80.4091720581055, -1.40340480121657, 218, 53, 'PPL', 'P'),
(154720, 'Christiansburg', 40.0552787780762, 0.69909649748164, -84.0261077880859, -1.46653223853775, 218, 41, 'PPL', 'P'),
(850, 'Christie', 35.9580612182617, 0.62758656089235, -94.6900024414063, -1.65265231132401, 218, 42, 'PPL', 'P'),
(100809, 'Christie', 36.5488891601563, 0.637898453791192, -78.8436126708984, -1.3760806352743, 218, 53, 'PPL', 'P'),
(173542, 'Christie', 44.6472206115723, 0.779241001536212, -90.5963897705078, -1.58120529191547, 218, 57, 'PPL', 'P'),
(180712, 'Christie', 38.003059387207, 0.663278512137701, -122.205558776855, -2.13288936489558, 218, 6, 'PPL', 'P'),
(85814, 'Christie (historical)', 36.3349990844727, 0.634165367733173, -82.6125030517578, -1.44186018156704, 218, 50, 'PPL', 'P'),
(200573, 'Christie (historical)', 45.4041709899902, 0.792452277913823, -122.647216796875, -2.14059775151276, 218, 43, 'PPL', 'P'),
(173543, 'Christilla Heights', 42.5288887023926, 0.742269135070969, -89.0727767944336, -1.55461322895687, 218, 57, 'PPL', 'P'),
(196218, 'Christina', 47.3819389343262, 0.826970840382885, -109.323333740234, -1.9080521230237, 218, 31, 'PPL', 'P'),
(13541, 'Christina Manor', 39.6791687011719, 0.692532138289731, -75.7874984741211, -1.32274138022359, 218, 10, 'PPL', 'P'),
(35243, 'Christine', 37.142219543457, 0.64825402253191, -85.2069396972656, -1.48714164326555, 218, 21, 'PPL', 'P'),
(93239, 'Christine', 28.788890838623, 0.502460933131204, -98.496940612793, -1.71909591683456, 218, 51, 'PPL', 'P'),
(139793, 'Christine', 46.5736083984375, 0.812862811087217, -96.8013916015625, -1.68950300395965, 218, 34, 'PPL', 'P'),
(160081, 'Christleys Mills', 41.0794410705566, 0.716971501560198, -80.0738906860352, -1.39755303735333, 218, 45, 'PPL', 'P'),
(160078, 'Christmans', 40.9680595397949, 0.715027527122494, -75.6444396972656, -1.32024453354359, 218, 45, 'PPL', 'P'),
(160079, 'Christmansville', 40.976390838623, 0.715172935718013, -75.6752777099609, -1.32078275839989, 218, 45, 'PPL', 'P'),
(15524, 'Christmas', 28.5361099243164, 0.498049073890351, -81.0177764892578, -1.4140269523824, 218, 12, 'PPL', 'P'),
(59002, 'Christmas', 33.7763900756836, 0.589509216258615, -90.9783325195313, -1.58787145044005, 218, 30, 'PPL', 'P'),
(130217, 'Christmas', 46.436939239502, 0.810477484277861, -86.7013931274414, -1.51322477613984, 218, 27, 'PPL', 'P'),
(177929, 'Christmas', 33.0622215270996, 0.577044623671636, -110.741943359375, -1.93281153167816, 218, 5, 'PPL', 'P'),
(203409, 'Christmas City', 40.3216705322266, 0.703745910691728, -111.64582824707, -1.94858729902747, 218, 52, 'PPL', 'P'),
(127109, 'Christmas Cove', 43.8469390869141, 0.765273453988046, -69.5541687011719, -1.21394925232304, 218, 26, 'PPL', 'P'),
(1573, 'Christmas Landing', 31.711389541626, 0.553468157883869, -88.0905609130859, -1.53747032786197, 218, 2, 'PPL', 'P'),
(203408, 'Christmas Meadow Summer Home Area', 40.8269386291504, 0.712564502588334, -110.806938171387, -1.93394590514448, 218, 52, 'PPL', 'P'),
(200574, 'Christmas Valley', 43.2363891601563, 0.754617347518312, -120.635833740234, -2.10549249465556, 218, 43, 'PPL', 'P'),
(85817, 'Christmasville', 36.0933303833008, 0.629947453198706, -88.6474990844727, -1.54719073268271, 218, 50, 'PPL', 'P'),
(20046, 'Christopher', 32.3269386291504, 0.564211516168816, -84.7305603027344, -1.47882725434232, 218, 13, 'PPL', 'P'),
(26786, 'Christopher', 37.9724998474121, 0.662745147550386, -89.0533294677734, -1.55427380907594, 218, 18, 'PPL', 'P'),
(35240, 'Christopher', 37.2336082458496, 0.649849056287786, -83.17138671875, -1.45161454169167, 218, 21, 'PPL', 'P'),
(54041, 'Christopher', 36.7986106872559, 0.642256916652188, -94.289436340332, -1.64566111398839, 218, 29, 'PPL', 'P'),
(207037, 'Christopher', 47.334171295166, 0.826137137803636, -122.230827331543, -2.1333303843721, 218, 56, 'PPL', 'P'),
(177932, 'Christopher Creek', 34.3211097717285, 0.599016368455062, -111.011108398438, -1.93750934784106, 218, 5, 'PPL', 'P'),
(100814, 'Christopher Fork', 38.0405616760254, 0.663933050554615, -77.2230606079102, -1.34779666607517, 218, 53, 'PPL', 'P'),
(80331, 'Christopher Heights', 34.4588890075684, 0.601421069761349, -82.6397171020508, -1.44233515634745, 218, 48, 'PPL', 'P'),
(70657, 'Christopher Mills', 39.878059387207, 0.696003435612595, -74.8591690063477, -1.30653897446766, 218, 37, 'PPL', 'P'),
(188312, 'Christopher Place', 36.9208297729492, 0.644390042106314, -107.513610839844, -1.87646649986314, 218, 38, 'PPL', 'P'),
(20047, 'Christophers Cove', 32.834171295166, 0.573064396264458, -83.7813873291016, -1.46226106078148, 218, 13, 'PPL', 'P'),
(45781, 'Christophers Crossing', 39.4583282470703, 0.68867774524406, -77.4402770996094, -1.35158780904495, 218, 25, 'PPL', 'P'),
(20048, 'Christophers Run', 34.1369400024414, 0.595801999598364, -84.3077774047852, -1.47144830075198, 218, 13, 'PPL', 'P'),
(191262, 'Christoval', 31.1933307647705, 0.544426326508886, -100.498329162598, -1.75402673664036, 218, 51, 'PPL', 'P'),
(45782, 'Christs Rock', 38.5444412231445, 0.672727407685302, -76.1033325195313, -1.32825372420589, 218, 25, 'PPL', 'P'),
(35242, 'Christy', 38.1947212219238, 0.666623642203923, -83.414436340332, -1.455856557834, 218, 21, 'PPL', 'P'),
(154721, 'Christy', 41.3427810668945, 0.721567651548484, -83.6655578613281, -1.460239455198, 218, 41, 'PPL', 'P'),
(45783, 'Christy Acres', 39.3955612182617, 0.687582253929655, -77.1430587768555, -1.34640037071564, 218, 25, 'PPL', 'P'),
(85816, 'Christy Hill', 35.6380615234375, 0.622001512612291, -84.0002822875977, -1.46608149852325, 218, 50, 'PPL', 'P'),
(160080, 'Christy Manor', 40.7383308410645, 0.711018004943325, -79.5288925170898, -1.3880410248879, 218, 45, 'PPL', 'P'),
(154722, 'Christytown', 40.9997215270996, 0.715580133048686, -80.9861068725586, -1.41347421329816, 218, 41, 'PPL', 'P'),
(45784, 'Chriswood Manor', 39.2208290100098, 0.684532601586378, -76.9247207641602, -1.34258965351184, 218, 25, 'PPL', 'P'),
(78030, 'Chrome', 39.7333297729492, 0.693477427318655, -75.982780456543, -1.32614969378668, 218, 45, 'PPL', 'P'),
(144990, 'Chrome', 40.5763893127441, 0.708191592078424, -74.216667175293, -1.29532520206566, 218, 37, 'PPL', 'P'),
(180713, 'Chrome', 39.7291717529297, 0.69340485617895, -122.548332214355, -2.13887188996834, 218, 6, 'PPL', 'P'),
(45785, 'Chrome Hill', 39.622501373291, 0.691543106839903, -76.4208297729492, -1.33379509664407, 218, 25, 'PPL', 'P'),
(45786, 'Chrome Hill Estates', 39.625560760498, 0.691596503219759, -76.4138870239258, -1.33367392281448, 218, 25, 'PPL', 'P'),
(186538, 'Chromo', 37.0363883972168, 0.646406920578859, -106.842781066895, -1.86475831160477, 218, 7, 'PPL', 'P'),
(1574, 'Chrysler', 31.3050003051758, 0.546375327663147, -87.7011108398438, -1.53067314181176, 218, 2, 'PPL', 'P'),
(180714, 'Chrysopolis (historical)', 36.9605598449707, 0.645083462675144, -118.195831298828, -2.06290641829632, 218, 6, 'PPL', 'P'),
(177931, 'Chrysotile', 33.7402801513672, 0.588878979186648, -110.566108703613, -1.92974263799601, 218, 5, 'PPL', 'P'),
(160082, 'Chrystal', 41.9597206115723, 0.732335277888865, -78.0302810668945, -1.3618853208739, 218, 45, 'PPL', 'P'),
(180715, 'Chualar', 36.5705604553223, 0.63827668924501, -121.517501831055, -2.12088050575014, 218, 6, 'PPL', 'P'),
(211751, 'Chuathbaluk', 61.5719413757324, 1.07463310385146, -159.244995117188, -2.77934948211722, 218, 1, 'PPL', 'P'),
(191263, 'Chub', 32.0238914489746, 0.558922345085865, -102.018890380859, -1.78056553637717, 218, 51, 'PPL', 'P'),
(100811, 'Chub (historical)', 36.8638916015625, 0.643396283545551, -77.1758270263672, -1.34697228455973, 218, 53, 'PPL', 'P'),
(63684, 'Chub Lake', 36.4508285522461, 0.636186973316652, -79.0027770996094, -1.37885857860736, 218, 33, 'PPL', 'P'),
(147806, 'Chubbs Dock', 43.6369400024414, 0.761608278537825, -73.434440612793, -1.28167277305348, 218, 40, 'PPL', 'P'),
(20049, 'Chubbtown', 34.0902786254883, 0.594987604937017, -85.2825012207031, -1.48846044063735, 218, 13, 'PPL', 'P'),
(180717, 'Chubbuck', 34.3650016784668, 0.599782426742623, -115.285278320313, -2.01210768576749, 218, 6, 'PPL', 'P'),
(194731, 'Chubbuck', 42.9208297729492, 0.749109797225974, -112.465278625488, -1.96288940618757, 218, 17, 'PPL', 'P'),
(207038, 'Chuckanut', 48.665828704834, 0.849378944110921, -122.482498168945, -2.13772286911602, 218, 56, 'PPL', 'P'),
(207039, 'Chuckanut Junction', 48.4861106872559, 0.846242272979025, -122.334442138672, -2.13513880391032, 218, 56, 'PPL', 'P'),
(207040, 'Chuckanut Village', 48.7011108398438, 0.849994733533974, -122.492500305176, -2.13789743932548, 218, 56, 'PPL', 'P'),
(100812, 'Chuckatuck', 36.8616714477539, 0.643357534551691, -76.5805587768555, -1.33658289367317, 218, 53, 'PPL', 'P'),
(154723, 'Chuckery', 40.1116714477539, 0.700080735241506, -83.3905563354492, -1.45543977312341, 218, 41, 'PPL', 'P'),
(147805, 'Chuckery Corners', 43.0322189331055, 0.751053904821732, -75.3294372558594, -1.31474670378923, 218, 40, 'PPL', 'P'),
(85818, 'Chuckey', 36.2158317565918, 0.632085505500849, -82.6883316040039, -1.44318363947075, 218, 50, 'PPL', 'P'),
(85819, 'Chuckey Bend (historical)', 36.1958312988281, 0.631736431660966, -83.1597213745117, -1.45141094302633, 218, 50, 'PPL', 'P'),
(63685, 'Chuckle (historical)', 36.3013916015625, 0.633578806503083, -81.0405578613281, -1.41442456233315, 218, 33, 'PPL', 'P'),
(93240, 'Chuckville', 32.0991706848145, 0.560236215609655, -98.8997192382813, -1.72612573000599, 218, 51, 'PPL', 'P'),
(209364, 'Chugcreek', 42.0480613708496, 0.733877115001966, -104.917778015137, -1.83116067024066, 218, 59, 'PPL', 'P'),
(211752, 'Chugiak', 61.3888893127441, 1.07143824264974, -149.48193359375, -2.60895191345846, 218, 1, 'PPL', 'P'),
(209365, 'Chugwater', 41.7566719055176, 0.728791409426296, -104.821113586426, -1.82947355769009, 218, 59, 'PPL', 'P'),
(177933, 'Chuichu', 32.7519416809082, 0.571629218753014, -111.782501220703, -1.95097269241585, 218, 5, 'PPL', 'P'),
(80332, 'Chukker Creek', 33.4833297729492, 0.584394349069009, -81.7069396972656, -1.42605511944574, 218, 48, 'PPL', 'P'),
(177935, 'Chukson', 31.9130592346191, 0.556987958028086, -111.796112060547, -1.95121024638509, 218, 5, 'PPL', 'P'),
(15526, 'Chukuchatta (historical)', 28.3999996185303, 0.495673500908487, -82.3000030517578, -1.43640602765455, 218, 12, 'PPL', 'P'),
(177934, 'Chukut Kuk', 31.7655601501465, 0.55441361336036, -112.104438781738, -1.95659156284175, 218, 5, 'PPL', 'P'),
(8079, 'Chula', 34.7866706848145, 0.607141939257003, -93.5711135864258, -1.63312401684073, 218, 4, 'PPL', 'P'),
(20050, 'Chula', 31.5494403839111, 0.550641611860913, -83.5475006103516, -1.45817896746261, 218, 13, 'PPL', 'P'),
(39784, 'Chula', 29.8425006866455, 0.520849894010633, -90.9552764892578, -1.58746904679934, 218, 22, 'PPL', 'P'),
(54042, 'Chula', 39.9216690063477, 0.69676456705214, -93.4741668701172, -1.63143197744215, 218, 29, 'PPL', 'P'),
(100815, 'Chula', 37.3883285522461, 0.652549435054099, -77.9033279418945, -1.35966957084696, 218, 53, 'PPL', 'P'),
(180718, 'Chula Vista', 32.6399993896484, 0.569675457198305, -117.08332824707, -2.04348957710466, 218, 6, 'PPL', 'P'),
(191264, 'Chula Vista 1-5 Colonia', 28.6560001373291, 0.50014155284834, -100.416999816895, -1.75260727177935, 218, 51, 'PPL', 'P'),
(93241, 'Chula Vista Acres Colonia', 26.2810001373291, 0.458689983113475, -98.3649978637695, -1.71679308143997, 218, 51, 'PPL', 'P'),
(93243, 'Chula Vista Colonia', 28.6599998474121, 0.500211360958414, -99.8089981079102, -1.74199564009982, 218, 51, 'PPL', 'P'),
(191265, 'Chula Vista School Block Colonia', 28.6560001373291, 0.50014155284834, -100.421997070313, -1.75269449030505, 218, 51, 'PPL', 'P'),
(1575, 'Chulafinnee', 33.545280456543, 0.585475592471581, -85.6488876342773, -1.4948550898888, 218, 2, 'PPL', 'P'),
(59006, 'Chulahoma', 34.6536102294922, 0.604819596207426, -89.6302795410156, -1.56434348747363, 218, 30, 'PPL', 'P'),
(160083, 'Chulasky', 40.9538917541504, 0.71478025261528, -76.6650009155273, -1.33805668702042, 218, 45, 'PPL', 'P'),
(1576, 'Chulavista', 33.5955581665039, 0.586353104050763, -86.3666687011719, -1.50738273281458, 218, 2, 'PPL', 'P'),
(20051, 'Chulio', 34.163890838623, 0.596272380425899, -85.0983276367188, -1.48524600520163, 218, 13, 'PPL', 'P'),
(20052, 'Chulio Hills', 34.2125015258789, 0.597120796970171, -85.1316680908203, -1.48582790589981, 218, 13, 'PPL', 'P'),
(211753, 'Chulitna', 62.8869400024414, 1.09758415954673, -149.583053588867, -2.61071679031285, 218, 1, 'PPL', 'P'),
(211754, 'Chuloonawick', 62.9461097717285, 1.09861686683844, -164.172225952148, -2.86534588319307, 218, 1, 'PPL', 'P'),
(15529, 'Chuluota', 28.6416702270508, 0.499891448732468, -81.1236114501953, -1.41587412091448, 218, 12, 'PPL', 'P'),
(93244, 'Chumley', 31.5102806091309, 0.549958144856658, -94.0005569458008, -1.64061921741265, 218, 51, 'PPL', 'P'),
(1577, 'Chumley (historical)', 34.2144393920898, 0.597154619116015, -85.9483337402344, -1.50008141037002, 218, 2, 'PPL', 'P'),
(130218, 'Chums Corner', 44.6719398498535, 0.779672433632805, -85.6563873291016, -1.49498598425637, 218, 27, 'PPL', 'P'),
(207041, 'Chumstick', 47.6883316040039, 0.832318401272737, -120.638061523438, -2.10553137680747, 218, 56, 'PPL', 'P'),
(15527, 'Chumuckla', 30.7763900756836, 0.537149338698786, -87.2372207641602, -1.52257673262376, 218, 12, 'PPL', 'P'),
(15528, 'Chumuckla Springs', 30.833610534668, 0.538148024107565, -87.2961120605469, -1.52360457964647, 218, 12, 'PPL', 'P'),
(1578, 'Chunchula', 30.9216709136963, 0.539684967662164, -88.2005615234375, -1.53939020069181, 218, 2, 'PPL', 'P'),
(59004, 'Chunky', 32.3255615234375, 0.564187481139979, -88.9280624389648, -1.55208748697904, 218, 30, 'PPL', 'P'),
(191266, 'Chunky', 35.3994407653809, 0.617836794720597, -101.840278625488, -1.77744817316318, 218, 51, 'PPL', 'P'),
(59005, 'Chunky (historical)', 32.3708305358887, 0.564977574456378, -89.0986099243164, -1.55506410212942, 218, 30, 'PPL', 'P'),
(20053, 'Chunn Estates', 34.2533302307129, 0.597833392298849, -84.8605575561523, -1.48109613443301, 218, 13, 'PPL', 'P'),
(1579, 'Chunnenuggee', 32.1563911437988, 0.561234901018435, -85.6436080932617, -1.49476294451508, 218, 2, 'PPL', 'P'),
(188313, 'Chupadera', 34.2705612182617, 0.598134129764946, -106.360000610352, -1.85633220307381, 218, 38, 'PPL', 'P'),
(188314, 'Chupadero', 35.8224983215332, 0.625220542000897, -105.916107177734, -1.84858480114666, 218, 38, 'PPL', 'P'),
(114971, 'Church', 43.3522186279297, 0.756638953101792, -91.3388900756836, -1.59416436693785, 218, 16, 'PPL', 'P'),
(100816, 'Church (historical)', 36.8888893127441, 0.643832575911134, -77.2027816772461, -1.34744273196629, 218, 53, 'PPL', 'P'),
(147807, 'Church Corners', 42.978889465332, 0.750123130020749, -74.2816696166992, -1.29645970869004, 218, 40, 'PPL', 'P'),
(45787, 'Church Creek', 38.5019416809082, 0.671985650742688, -76.1524963378906, -1.32911179470912, 218, 25, 'PPL', 'P'),
(80333, 'Church Creek', 32.8236083984375, 0.572880038937997, -80.0527801513672, -1.39718458901652, 218, 48, 'PPL', 'P'),
(100820, 'Church Creek Point', 37.4680595397949, 0.653941003302693, -75.9313888549805, -1.32525274113154, 218, 53, 'PPL', 'P'),
(63686, 'Church Crossroads', 35.7911109924316, 0.624672729764667, -77.1833267211914, -1.34710317892731, 218, 33, 'PPL', 'P'),
(13548, 'Church Hill', 39.7722206115723, 0.694156200501489, -75.6736068725586, -1.32075359678596, 218, 10, 'PPL', 'P'),
(20054, 'Church Hill', 32.1630592346191, 0.561351281158071, -84.5455627441406, -1.47559843783671, 218, 13, 'PPL', 'P'),
(35244, 'Church Hill', 36.8022193908691, 0.642319900411969, -87.5722198486328, -1.52842356963897, 218, 21, 'PPL', 'P'),
(45789, 'Church Hill', 39.1411094665527, 0.683141233074867, -75.9858322143555, -1.32620295700848, 218, 25, 'PPL', 'P'),
(63689, 'Church Hill', 36.4791717529297, 0.636681655489134, -78.0449981689453, -1.36214218276104, 218, 33, 'PPL', 'P'),
(85820, 'Church Hill', 36.5222206115723, 0.637432999811673, -82.7136077880859, -1.44362479210532, 218, 50, 'PPL', 'P'),
(93245, 'Church Hill', 32.1908111572266, 0.56183564358133, -94.6651077270508, -1.65221781659216, 218, 51, 'PPL', 'P'),
(100818, 'Church Hill', 36.8183288574219, 0.642601063644054, -82.1538925170898, -1.43385591775275, 218, 53, 'PPL', 'P'),
(160086, 'Church Hill', 40.6819381713867, 0.710033767183459, -77.5988922119141, -1.35435616499809, 218, 45, 'PPL', 'P'),
(196219, 'Church Hill', 45.7508316040039, 0.798502647015347, -111.303611755371, -1.94261449449269, 218, 31, 'PPL', 'P'),
(80334, 'Church Hill (historical)', 33.1111106872559, 0.577897900484897, -80.0188903808594, -1.39659310093842, 218, 48, 'PPL', 'P'),
(45790, 'Church Hill Estates', 39.5175018310547, 0.689710519114792, -77.5666732788086, -1.35379383853392, 218, 25, 'PPL', 'P'),
(80335, 'Church Hill Heights', 34.9836082458496, 0.610579148117914, -81.0694427490234, -1.4149286987275, 218, 48, 'PPL', 'P'),
(13543, 'Church Hill Village', 38.934440612793, 0.679534181115436, -75.4761123657227, -1.31730666738707, 218, 10, 'PPL', 'P'),
(70658, 'Church Landing', 39.6758308410645, 0.692473881640886, -75.5111083984375, -1.31791746338308, 218, 37, 'PPL', 'P'),
(39785, 'Church Point', 30.4027805328369, 0.53062862205924, -92.2149963378906, -1.6094553058107, 218, 22, 'PPL', 'P'),
(188315, 'Church Rock', 35.5338897705078, 0.620183372536094, -108.599166870117, -1.89541302680629, 218, 38, 'PPL', 'P'),
(39786, 'Church Spur', 29.9811096191406, 0.523269076255347, -91.017219543457, -1.58855015704386, 218, 22, 'PPL', 'P'),
(100821, 'Church View', 37.6775016784668, 0.657596458214936, -76.6786117553711, -1.33829424098965, 218, 53, 'PPL', 'P'),
(93246, 'Churchill', 28.9344005584717, 0.505000556836217, -95.556999206543, -1.66778425947978, 218, 51, 'PPL', 'P'),
(100828, 'Churchill', 38.5113906860352, 0.672150566993191, -77.966667175293, -1.36077504901545, 218, 53, 'PPL', 'P'),
(119136, 'Churchill', 41.3875007629395, 0.722348157484959, -89.1722183227539, -1.55634881103927, 218, 18, 'PPL', 'P'),
(134671, 'Churchill', 44.8183288574219, 0.7822274038036, -94.6705627441406, -1.65231302460113, 218, 28, 'PPL', 'P'),
(154724, 'Churchill', 41.1619415283203, 0.718411406182576, -80.6650009155273, -1.40786985710019, 218, 41, 'PPL', 'P'),
(160087, 'Churchill', 40.4383316040039, 0.705782030503148, -79.8433303833008, -1.39352900094622, 218, 45, 'PPL', 'P'),
(190033, 'Churchill', 39.271671295166, 0.685419966861593, -119.279998779297, -2.08182871047355, 218, 39, 'PPL', 'P'),
(124522, 'Churchill Landing', 41.9013900756836, 0.731317217983155, -70.5444412231445, -1.23123276832349, 218, 23, 'PPL', 'P'),
(124523, 'Churchill Shores', 41.8055610656738, 0.729644686239558, -70.9583282470703, -1.23845645962227, 218, 23, 'PPL', 'P'),
(160088, 'Churchill Valley', 40.4588890075684, 0.706140824881009, -79.8338928222656, -1.3933642844328, 218, 45, 'PPL', 'P'),
(63688, 'Churchland', 35.7861099243164, 0.62458544465994, -80.4177780151367, -1.40355500350205, 218, 33, 'PPL', 'P'),
(100823, 'Churchland', 36.8644409179688, 0.643405870925476, -76.3969421386719, -1.33337817877542, 218, 53, 'PPL', 'P'),
(139795, 'Churchs Ferry', 48.2691688537598, 0.842455923699205, -99.1897201538086, -1.73118720081574, 218, 34, 'PPL', 'P'),
(45791, 'Churchton', 38.8025016784668, 0.677231412299872, -76.5372161865234, -1.33582642276553, 218, 25, 'PPL', 'P'),
(85821, 'Churchton', 36.1191711425781, 0.630398459529311, -89.1774978637695, -1.55644095641299, 218, 50, 'PPL', 'P'),
(70659, 'Churchtown', 39.6719398498535, 0.692405971033089, -75.5102767944336, -1.31790294915514, 218, 37, 'PPL', 'P'),
(72100, 'Churchtown', 39.4672203063965, 0.688832940956584, -81.5480575561523, -1.4232821029607, 218, 41, 'PPL', 'P'),
(147808, 'Churchtown', 42.1761093139648, 0.736111973209733, -73.7191696166992, -1.28664223164757, 218, 40, 'PPL', 'P'),
(160091, 'Churchtown', 40.1330604553223, 0.700454043847308, -75.9649963378906, -1.32583930236163, 218, 45, 'PPL', 'P'),
(45792, 'Churchville', 39.5611114501953, 0.690471650554337, -76.2458267211914, -1.33074071718986, 218, 25, 'PPL', 'P'),
(100825, 'Churchville', 38.2261085510254, 0.667171454440152, -79.1624984741211, -1.3816462424784, 218, 53, 'PPL', 'P'),
(108584, 'Churchville', 39.0972213745117, 0.682375241366333, -80.591667175293, -1.4065899418803, 218, 58, 'PPL', 'P'),
(114972, 'Churchville', 41.396671295166, 0.722508213466472, -93.7508316040039, -1.63626068797262, 218, 16, 'PPL', 'P'),
(119137, 'Churchville', 41.935001373291, 0.731903845792272, -87.9538879394531, -1.53508493447359, 218, 18, 'PPL', 'P'),
(130220, 'Churchville', 46.5183296203613, 0.811898014403309, -84.1230621337891, -1.46822441109439, 218, 27, 'PPL', 'P'),
(147810, 'Churchville', 43.1897201538086, 0.753802819698912, -75.5766677856445, -1.31906169054543, 218, 40, 'PPL', 'P'),
(160096, 'Churchville', 40.7519416809082, 0.711255558912561, -75.2505569458008, -1.31336998266371, 218, 45, 'PPL', 'P'),
(100826, 'Churchwood (historical)', 37.2005615234375, 0.649272282174702, -80.6097183227539, -1.40690499383726, 218, 53, 'PPL', 'P'),
(114973, 'Churdan', 42.1519393920898, 0.735690128493065, -94.4741668701172, -1.64888526996209, 218, 16, 'PPL', 'P'),
(223, 'Churntown', 34.4027786254883, 0.6004417588495, -87.665283203125, -1.53004783158781, 218, 2, 'PPL', 'P'),
(193450, 'Churntown (historical)', 40.6780586242676, 0.709966056312744, -122.407218933105, -2.13640899859223, 218, 6, 'PPL', 'P'),
(122367, 'Churubusco', 41.2305603027344, 0.719609029724785, -85.3194427490234, -1.48910519193726, 218, 19, 'PPL', 'P'),
(147811, 'Churubusco', 44.9538917541504, 0.784593422695054, -73.9319381713867, -1.29035574347157, 218, 40, 'PPL', 'P'),
(177936, 'Chutum Vaya', 31.7163906097412, 0.553555442988596, -111.646110534668, -1.94859222587548, 218, 5, 'PPL', 'P'),
(177938, 'Chuwut Murk', 31.8872203826904, 0.556536984986994, -112.144996643066, -1.9572994310595, 218, 5, 'PPL', 'P'),
(177937, 'Cibecue', 34.0447196960449, 0.594192451614547, -110.484718322754, -1.92832210787056, 218, 5, 'PPL', 'P'),
(177940, 'Cibecue Creek', 34.0963897705078, 0.595094264538675, -110.502502441406, -1.92863249929561, 218, 5, 'PPL', 'P'),
(177939, 'Cibola', 33.3163909912109, 0.581480717678408, -114.664169311523, -2.00126728855032, 218, 5, 'PPL', 'P'),
(93247, 'Cibolo', 29.5613899230957, 0.515943585623893, -98.2266693115234, -1.71437879275376, 218, 51, 'PPL', 'P'),
(8081, 'Cicalla', 35.0741691589355, 0.612159734224876, -90.5286102294922, -1.58002231575926, 218, 4, 'PPL', 'P'),
(32068, 'Cicero', 37.3338890075684, 0.651599285756186, -97.3402786254883, -1.69890835682343, 218, 20, 'PPL', 'P'),
(119138, 'Cicero', 41.8455581665039, 0.730342767340295, -87.7538909912109, -1.53159432923282, 218, 18, 'PPL', 'P'),
(122368, 'Cicero', 40.1238899230957, 0.700293987865794, -86.0133285522461, -1.50121578383634, 218, 19, 'PPL', 'P'),
(147812, 'Cicero', 43.1755599975586, 0.753555678349752, -76.1197204589844, -1.32853974770697, 218, 40, 'PPL', 'P'),
(173544, 'Cicero', 44.5736083984375, 0.777956226047331, -88.3872222900391, -1.5426480456533, 218, 57, 'PPL', 'P'),
(207042, 'Cicero', 48.2688903808594, 0.842451063430216, -122.009170532227, -2.1294617434146, 218, 56, 'PPL', 'P'),
(154725, 'Cicero (historical)', 41.3394393920898, 0.721509328320611, -84.7094421386719, -1.47845867284745, 218, 41, 'PPL', 'P'),
(180719, 'Cicero (historical)', 38.3291702270508, 0.668970220019419, -121.183326721191, -2.11504804980481, 218, 6, 'PPL', 'P'),
(147813, 'Cicero Center', 43.1788902282715, 0.753613801840543, -76.0411071777344, -1.32716768711336, 218, 40, 'PPL', 'P'),
(108585, 'Cicerone', 38.6197204589844, 0.674041278209093, -81.5088882446289, -1.42259846950888, 218, 58, 'PPL', 'P'),
(63691, 'Cid', 35.711669921875, 0.623286221522145, -80.1063919067383, -1.39812029066552, 218, 33, 'PPL', 'P'),
(127110, 'Cider Hill', 43.1555595397949, 0.75320660450987, -70.6891708374023, -1.23375877661743, 218, 26, 'PPL', 'P'),
(177941, 'Ciela Grande Mobile Home Park', 33.4066696166992, 0.583056376937353, -111.625831604004, -1.94823829176661, 218, 5, 'PPL', 'P'),
(93248, 'Cielito Lindo Colonia', 25.8899993896484, 0.451865732688688, -97.4059982299805, -1.70005538030493, 218, 51, 'PPL', 'P'),
(191267, 'Cielo Vista', 31.7877807617188, 0.554801436194103, -106.379997253418, -1.85668121033467, 218, 51, 'PPL', 'P'),
(180720, 'Cienega', 34.021110534668, 0.593780394014884, -118.327499389648, -2.06520446000095, 218, 6, 'PPL', 'P'),
(188317, 'Cienega (historical)', 32.0513916015625, 0.559402313293324, -105.099716186523, -1.83433609036641, 218, 38, 'PPL', 'P'),
(180724, 'Cienega Seabreeze Mobile Home Park', 35.0969390869141, 0.612557144438543, -120.603607177734, -2.10493003503333, 218, 6, 'PPL', 'P'),
(177942, 'Cienega Springs', 34.1886100769043, 0.596703812522492, -114.223892211914, -1.99358300354101, 218, 5, 'PPL', 'P'),
(191268, 'Cienegas Terrace', 29.3672199249268, 0.512554679847254, -100.943328857422, -1.76179344648542, 218, 51, 'PPL', 'P'),
(191269, 'Cienegas Terrace Colonia', 29.3680000305176, 0.512568295258327, -100.949996948242, -1.76190982662505, 218, 51, 'PPL', 'P'),
(188318, 'Cieneguilla', 35.5955581665039, 0.621259689090649, -106.123062133789, -1.85219684653314, 218, 38, 'PPL', 'P'),
(100827, 'Cifax', 37.410831451416, 0.652942184735859, -79.4077835083008, -1.3859272739307, 218, 53, 'PPL', 'P'),
(63690, 'Cilley (historical)', 36.0424995422363, 0.629060287660573, -81.4702835083008, -1.42192468975309, 218, 33, 'PPL', 'P'),
(72101, 'Cilley (historical)', 39.1833305358887, 0.683878129748491, -84.7777786254883, -1.47965136954164, 218, 41, 'PPL', 'P'),
(143631, 'Cilleyville', 43.4305610656738, 0.758006286584466, -71.8666687011719, -1.25430999127541, 218, 36, 'PPL', 'P'),
(93249, 'Cima', 30.9400005340576, 0.540004879888109, -94.4016723632813, -1.64762000212819, 218, 51, 'PPL', 'P'),
(180725, 'Cima', 35.2377815246582, 0.615015308703713, -115.498329162598, -2.01582612443951, 218, 6, 'PPL', 'P'),
(177943, 'Cimarron', 33.3875007629395, 0.582721817325412, -111.991386413574, -1.95461842679011, 218, 5, 'PPL', 'P'),
(180726, 'Cimarron', 36.2986106872559, 0.633530270392216, -119.812782287598, -2.09112753689372, 218, 6, 'PPL', 'P'),
(186539, 'Cimarron', 38.4425010681152, 0.670948216340048, -107.556106567383, -1.87720819022673, 218, 7, 'PPL', 'P'),
(188320, 'Cimarron', 36.5108299255371, 0.637234194836299, -104.915283203125, -1.83111712755683, 218, 38, 'PPL', 'P'),
(192932, 'Cimarron', 37.8066711425781, 0.659850890656715, -100.347778320313, -1.75139912875084, 218, 20, 'PPL', 'P'),
(75444, 'Cimarron City', 35.8894386291504, 0.626388870771114, -97.6013870239258, -1.70346555808077, 218, 42, 'PPL', 'P'),
(180727, 'Cimarron Estates Mobile Home Park', 34.8644409179688, 0.608499285885589, -120.401107788086, -2.10139575395069, 218, 6, 'PPL', 'P'),
(186540, 'Cimarron Hills', 38.8586082458496, 0.678210656632694, -104.698333740234, -1.82733064511896, 218, 7, 'PPL', 'P'),
(80336, 'Cimerron Plantation South', 33.6805610656738, 0.587836684515018, -78.9922180175781, -1.37867428785993, 218, 48, 'PPL', 'P'),
(26789, 'Cimic', 39.5900001525879, 0.690975853527716, -89.6558303833008, -1.56478943379817, 218, 18, 'PPL', 'P'),
(39787, 'Cimmaron', 30.5563907623291, 0.533309626328623, -91.0250015258789, -1.58868597825945, 218, 22, 'PPL', 'P'),
(35245, 'Cimota City', 37.0922203063965, 0.647381371221719, -88.8561096191406, -1.55083167336701, 218, 21, 'PPL', 'P'),
(8080, 'Cincinnati', 36.0372200012207, 0.628968142286856, -94.5108337402344, -1.64952522757204, 218, 4, 'PPL', 'P'),
(26790, 'Cincinnati', 38.4008293151855, 0.670220907046347, -88.5119400024414, -1.54482478037028, 218, 18, 'PPL', 'P'),
(29476, 'Cincinnati', 39.8569412231445, 0.695634854117728, -87.2261123657227, -1.5223828544964, 218, 19, 'PPL', 'P'),
(54043, 'Cincinnati', 39.5633316040039, 0.690510399548198, -91.5941696166992, -1.59861983544155, 218, 29, 'PPL', 'P'),
(72102, 'Cincinnati', 39.1619415283203, 0.68350482114269, -84.4569396972656, -1.47405167387559, 218, 41, 'PPL', 'P'),
(114974, 'Cincinnati', 40.6308288574219, 0.709141741376337, -92.9244384765625, -1.62183740698292, 218, 16, 'PPL', 'P'),
(147817, 'Cincinnatus', 42.5422210693359, 0.742501828771215, -75.896110534668, -1.32463701828751, 218, 40, 'PPL', 'P'),
(39788, 'Cinclare', 30.396110534668, 0.53051220863009, -91.2300033569336, -1.59226393518397, 218, 22, 'PPL', 'P'),
(39789, 'Cinclare Landing (historical)', 30.391939163208, 0.53043940446379, -91.2244415283203, -1.59216686296224, 218, 22, 'PPL', 'P'),
(108587, 'Cinco', 38.3369407653809, 0.669105841497931, -81.4663925170898, -1.42185677914529, 218, 58, 'PPL', 'P'),
(180728, 'Cinco', 35.2633285522461, 0.61546118844922, -118.035278320313, -2.06010424019734, 218, 6, 'PPL', 'P'),
(39790, 'Cinco (historical)', 30.0972194671631, 0.525295575397329, -91.8422164916992, -1.60294907010959, 218, 22, 'PPL', 'P'),
(15530, 'Cinco Bayou', 30.4219398498535, 0.530963015223613, -86.6094436645508, -1.51161995526695, 218, 12, 'PPL', 'P'),
(93250, 'Cinco Ranch', 29.7386093139648, 0.519036647492939, -95.7577819824219, -1.67128858000016, 218, 51, 'PPL', 'P'),
(177944, 'Cinco Soles', 33.5250015258789, 0.58512165836271, -111.952781677246, -1.95394464703432, 218, 5, 'PPL', 'P'),
(180729, 'Cincotta', 36.7613906860352, 0.641607305083291, -119.753608703613, -2.09009476302299, 218, 6, 'PPL', 'P'),
(35246, 'Cinda', 37.1072196960449, 0.647643159956873, -83.2947235107422, -1.45376717480078, 218, 21, 'PPL', 'P'),
(80337, 'Cinder Creek', 34.9688911437988, 0.610322286230775, -81.845832824707, -1.42847926182799, 218, 48, 'PPL', 'P'),
(108586, 'Cinderella', 37.6841697692871, 0.657712838354572, -82.2366714477539, -1.43530068264412, 218, 58, 'PPL', 'P'),
(20055, 'Cinderella Hills', 34.9544410705566, 0.610070084875545, -85.1983337402344, -1.48699144098007, 218, 13, 'PPL', 'P'),
(207043, 'Cinebar', 46.6044387817383, 0.813400902785468, -122.530563354492, -2.1385617648594, 218, 56, 'PPL', 'P'),
(188321, 'Ciniza', 35.4908294677734, 0.619431828476473, -108.420829772949, -1.89230045728226, 218, 38, 'PPL', 'P'),
(196220, 'Cinnabar Court', 46.4822196960449, 0.811267777331342, -114.087219238281, -1.99119761015263, 218, 31, 'PPL', 'P'),
(193451, 'Cinnabar Springs (historical)', 41.9650001525879, 0.732427423262581, -122.873329162598, -2.1445441567741, 218, 6, 'PPL', 'P'),
(70660, 'Cinnaminson', 39.9966697692871, 0.698073577306941, -74.9930572509766, -1.30887576516615, 218, 37, 'PPL', 'P'),
(8082, 'Cinnamon Acres', 34.922779083252, 0.609517478949353, -91.9527816772461, -1.60487879663546, 218, 4, 'PPL', 'P'),
(100839, 'Cinnamon Creek', 38.9438896179199, 0.679699097365939, -77.279167175293, -1.34877591040799, 218, 53, 'PPL', 'P'),
(63692, 'Cinnamon Ridge', 36.1124992370605, 0.630282012810647, -80.4319381713867, -1.40380214485121, 218, 33, 'PPL', 'P'),
(100829, 'Cinquoteck (historical)', 37.5333290100098, 0.655080170458974, -76.7986068725586, -1.34038855087089, 218, 53, 'PPL', 'P'),
(141490, 'Cio (historical)', 40.5955581665039, 0.708526151690366, -96.024169921875, -1.67593792663122, 218, 35, 'PPL', 'P'),
(93251, 'Cipres', 26.6886100769043, 0.465804118622917, -98.3197174072266, -1.71600278838649, 218, 51, 'PPL', 'P'),
(191270, 'Circle', 34.188060760498, 0.596694225142567, -102.235832214355, -1.78435188565699, 218, 51, 'PPL', 'P'),
(196221, 'Circle', 47.4166717529297, 0.827577042426014, -105.591667175293, -1.84292225487888, 218, 31, 'PPL', 'P'),
(211755, 'Circle', 65.8255615234375, 1.14887278055808, -144.060562133789, -2.51433113150849, 218, 1, 'PPL', 'P'),
(196222, 'Circle ''J'' Mobile Park', 46.8822212219238, 0.81824912097093, -113.898063659668, -1.98789622250731, 218, 31, 'PPL', 'P'),
(8083, 'Circle B Addition', 34.9944381713867, 0.610768165976282, -91.9569396972656, -1.60495136777516, 218, 4, 'PPL', 'P'),
(54045, 'Circle City', 36.8566703796387, 0.643270249446963, -89.8022232055664, -1.56734447054799, 218, 29, 'PPL', 'P'),
(177945, 'Circle City', 33.8158302307129, 0.590197576821374, -112.579437255859, -1.96488185015712, 218, 5, 'PPL', 'P'),
(20056, 'Circle Creek', 33.5663909912109, 0.585844040808394, -84.1938934326172, -1.4694606504724, 218, 13, 'PPL', 'P'),
(154726, 'Circle Green', 40.4844398498535, 0.706586771205543, -80.8758316040039, -1.41154954677836, 218, 41, 'PPL', 'P'),
(20057, 'Circle H Estates', 33.3583297729492, 0.582212687504016, -84.6216735839844, -1.47692682258844, 218, 13, 'PPL', 'P'),
(13544, 'Circle Haven Mobile Home Park', 38.9361114501953, 0.679563342729372, -75.5611114501953, -1.3187901812723, 218, 10, 'PPL', 'P'),
(108588, 'Circle Heights', 39.0338897705078, 0.681269896355895, -80.4400024414063, -1.40394289291482, 218, 58, 'PPL', 'P'),
(154727, 'Circle Hill', 40.0727806091309, 0.699401962058672, -84.414436340332, -1.47330985035395, 218, 41, 'PPL', 'P'),
(72104, 'Circle Hills', 39.5641708374023, 0.690525046934193, -82.9088897705078, -1.44703310566841, 218, 41, 'PPL', 'P'),
(211757, 'Circle Hot Springs', 65.4833297729492, 1.14289970970719, -144.634170532227, -2.52434248667831, 218, 1, 'PPL', 'P'),
(211756, 'Circle Hot Springs Station', 65.4702835083008, 1.14267200943399, -144.689163208008, -2.52530228993518, 218, 1, 'PPL', 'P'),
(85822, 'Circle M', 35.8472213745117, 0.625652040676517, -84.5611114501953, -1.47586981395179, 218, 50, 'PPL', 'P'),
(122369, 'Circle Park', 41.5497207641602, 0.725179430618849, -84.9100036621094, -1.48195913178425, 218, 19, 'PPL', 'P'),
(130221, 'Circle Pine Center', 42.5738906860352, 0.743054567855461, -85.460563659668, -1.49156821647142, 218, 27, 'PPL', 'P'),
(134672, 'Circle Pines', 45.148609161377, 0.787991882562104, -93.1513900756836, -1.62579845963025, 218, 28, 'PPL', 'P'),
(100830, 'Circle Terrace', 37.2719383239746, 0.650518042353614, -80.0619430541992, -1.39734451183998, 218, 53, 'PPL', 'P'),
(196223, 'Circle Trailer Court', 47.4222183227539, 0.827673848331639, -105.578887939453, -1.84269921513759, 218, 31, 'PPL', 'P'),
(108589, 'Circle View', 37.7966690063477, 0.65967632044726, -81.2508316040039, -1.41809453147333, 218, 58, 'PPL', 'P'),
(160097, 'Circle Ville', 40.7891693115234, 0.711905303639513, -77.9063873291016, -1.35972296722681, 218, 45, 'PPL', 'P'),
(191271, 'Circleback', 34.0321884155273, 0.593973739510024, -102.663841247559, -1.79182205251466, 218, 51, 'PPL', 'P'),
(45793, 'Circles Trailer Park', 38.702220916748, 0.675481182831472, -76.648063659668, -1.33776107613942, 218, 25, 'PPL', 'P'),
(29475, 'Circleville', 39.6002807617188, 0.69115528400616, -85.4391708374023, -1.49119484128659, 218, 19, 'PPL', 'P'),
(32069, 'Circleville', 39.5083312988281, 0.689550463133279, -95.8583297729492, -1.67304347000047, 218, 20, 'PPL', 'P'),
(72105, 'Circleville', 39.6005592346191, 0.69116014427515, -82.9461135864258, -1.44768278381633, 218, 41, 'PPL', 'P'),
(93253, 'Circleville', 30.6372203826904, 0.534720369337065, -97.4352798461914, -1.70056644091811, 218, 51, 'PPL', 'P'),
(100831, 'Circleville', 39.0791702270508, 0.682060189409376, -77.6949996948242, -1.35603355701067, 218, 53, 'PPL', 'P'),
(108590, 'Circleville', 38.6708297729492, 0.674933304016215, -79.4913864135742, -1.38738641989196, 218, 58, 'PPL', 'P'),
(147816, 'Circleville', 41.5141716003418, 0.724558980663888, -74.3838882446289, -1.29824376030428, 218, 40, 'PPL', 'P'),
(160098, 'Circleville', 40.3280601501465, 0.703857430562375, -79.7375030517578, -1.3916819655722, 218, 45, 'PPL', 'P'),
(192517, 'Circleville', 38.1716690063477, 0.666221305142239, -112.269721984863, -1.95947629893453, 218, 52, 'PPL', 'P'),
(108591, 'Cirtsville', 37.8813896179199, 0.661154974063499, -81.26611328125, -1.41836124705651, 218, 58, 'PPL', 'P'),
(188322, 'Ciruela', 35.9544410705566, 0.627523377395488, -104.818061828613, -1.82942029446829, 218, 38, 'PPL', 'P'),
(8084, 'Cisco', 36.3758316040039, 0.634878029640878, -93.4938888549805, -1.63177619101304, 218, 4, 'PPL', 'P'),
(20058, 'Cisco', 34.9511108398438, 0.610011961384754, -84.7363891601563, -1.47892898709596, 218, 13, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(35247, 'Cisco', 37.8525009155273, 0.66065077109012, -83.1352767944336, -1.4509843046197, 218, 21, 'PPL', 'P'),
(63693, 'Cisco', 36.1897201538086, 0.631629772059309, -76.6341705322266, -1.33751859532217, 218, 33, 'PPL', 'P'),
(93254, 'Cisco', 32.3880615234375, 0.565278311922475, -98.978889465332, -1.72750751113757, 218, 51, 'PPL', 'P'),
(108592, 'Cisco', 39.1286087036133, 0.682923053602562, -81.2847213745117, -1.41868601955144, 218, 58, 'PPL', 'P'),
(119141, 'Cisco', 40.0113906860352, 0.698330505773106, -88.7261123657227, -1.54856279327632, 218, 18, 'PPL', 'P'),
(124524, 'Cisco', 41.2541694641113, 0.720021087324447, -70.154167175293, -1.22442120120339, 218, 23, 'PPL', 'P'),
(180730, 'Cisco', 39.3016700744629, 0.685943544331902, -120.545829772949, -2.10392162908657, 218, 6, 'PPL', 'P'),
(192518, 'Cisco', 38.9700012207031, 0.680154830807479, -109.319999694824, -1.90799393295388, 218, 52, 'PPL', 'P'),
(180731, 'Cisco Grove', 39.310001373291, 0.686088952927421, -120.538887023926, -2.10380045525697, 218, 6, 'PPL', 'P'),
(85823, 'Cisco Indian Village (historical)', 35.4958305358887, 0.619519113581201, -88.6819381713867, -1.54779180814074, 218, 50, 'PPL', 'P'),
(15531, 'Cisky Park', 28.7944393157959, 0.502557772326342, -81.8494415283203, -1.42854224558777, 218, 12, 'PPL', 'P'),
(100832, 'Cismont', 38.0574989318848, 0.664228661435614, -78.3138885498047, -1.36683520523398, 218, 53, 'PPL', 'P'),
(160103, 'Cisna Run', 40.3525009155273, 0.704284002389978, -77.4313888549805, -1.35143267991145, 218, 45, 'PPL', 'P'),
(26792, 'Cisne', 38.5158309936523, 0.672228064980913, -88.4375, -1.54352555723249, 218, 18, 'PPL', 'P'),
(93255, 'Cisneros Estates Colonia', 25.8600006103516, 0.451342155218378, -97.4330596923828, -1.70052769192425, 218, 51, 'PPL', 'P'),
(207044, 'Cispus', 46.4925003051758, 0.811447207809786, -122.121109008789, -2.13141543839028, 218, 56, 'PPL', 'P'),
(35249, 'Cisselville', 37.6933288574219, 0.657872694599004, -85.2769393920898, -1.48836336841562, 218, 21, 'PPL', 'P'),
(119142, 'Cissna Park', 40.5647201538086, 0.707987926834061, -87.8930587768555, -1.53402326530503, 218, 18, 'PPL', 'P'),
(93256, 'Cistern', 29.815559387207, 0.520379679630666, -97.2183303833008, -1.69677995848024, 218, 51, 'PPL', 'P'),
(1583, 'Citico', 34.0825004577637, 0.594851850300451, -85.9313888549805, -1.49978566633097, 218, 2, 'PPL', 'P'),
(85824, 'Citico', 35.4000015258789, 0.617846581837604, -84.1166687011719, -1.46811282464471, 218, 50, 'PPL', 'P'),
(85826, 'Citico (historical)', 35.5499992370605, 0.620464535768179, -84.0999984741211, -1.46782187429562, 218, 50, 'PPL', 'P'),
(85827, 'Citico Beach', 35.5366706848145, 0.62023190864696, -84.1074981689453, -1.4679527686632, 218, 50, 'PPL', 'P'),
(78032, 'Cito', 39.8758316040039, 0.69596455346068, -77.9933319091797, -1.36124043641594, 218, 45, 'PPL', 'P'),
(15532, 'Citra', 29.4116706848145, 0.513330491962308, -82.1100006103516, -1.43308985946519, 218, 12, 'PPL', 'P'),
(75451, 'Citra', 34.7963905334473, 0.607311582618441, -96.376106262207, -1.68208037452744, 218, 42, 'PPL', 'P'),
(93257, 'Citralinda Colonia', 26.2999992370605, 0.459021579958703, -98.3570022583008, -1.71665353179885, 218, 51, 'PPL', 'P'),
(93258, 'Citriana Village Colonia', 26.2080001831055, 0.457415893558467, -98.1380004882813, -1.71283122984431, 218, 51, 'PPL', 'P'),
(180732, 'Citro', 36.3927803039551, 0.635173840258959, -119.023612976074, -2.07735393405194, 218, 6, 'PPL', 'P'),
(192899, 'Citrona', 38.6336097717285, 0.674283692447318, -121.970283508301, -2.12878303681079, 218, 6, 'PPL', 'P'),
(1584, 'Citronelle', 31.0905609130859, 0.542632654225204, -88.2280578613281, -1.53987010232024, 218, 2, 'PPL', 'P'),
(15533, 'Citronelle', 28.9783306121826, 0.505767280914051, -82.5688934326172, -1.44109905012749, 218, 12, 'PPL', 'P'),
(180734, 'Citrus', 38.6066703796387, 0.673813511356864, -121.265556335449, -2.11648322731626, 218, 6, 'PPL', 'P'),
(93259, 'Citrus City', 26.3261108398438, 0.459477313400243, -98.3850021362305, -1.71714222185888, 218, 51, 'PPL', 'P'),
(93260, 'Citrus City Lake Number 1 Colonia', 26.2959995269775, 0.45895177184863, -98.2480010986328, -1.71475110267415, 218, 51, 'PPL', 'P'),
(177946, 'Citrus Gardens', 33.4213905334473, 0.583313305403519, -111.742500305176, -1.95027454473609, 218, 5, 'PPL', 'P'),
(180735, 'Citrus Gardens Mobile Home Park', 33.1519393920898, 0.578610495813575, -117.118057250977, -2.04409571256876, 218, 6, 'PPL', 'P'),
(93261, 'Citrus Grove', 28.7472305297852, 0.501733823574585, -96.1054611206055, -1.67735672570196, 218, 51, 'PPL', 'P'),
(177947, 'Citrus Grove Trailer Court', 33.4144401550293, 0.583191998415866, -111.851936340332, -1.95218456386989, 218, 5, 'PPL', 'P'),
(177948, 'Citrus Grove Trailer Park', 33.5555610656738, 0.585655022950025, -112.073608398438, -1.9560534711435, 218, 5, 'PPL', 'P'),
(180736, 'Citrus Heights', 38.707218170166, 0.675568401357172, -121.279998779297, -2.11673529551343, 218, 6, 'PPL', 'P'),
(15535, 'Citrus Hills', 28.8880596160889, 0.50419175481316, -82.4327774047852, -1.43872337727709, 218, 12, 'PPL', 'P'),
(177949, 'Citrus Hills', 33.3791694641113, 0.582576408729894, -112.04167175293, -1.95549607152735, 218, 5, 'PPL', 'P'),
(93262, 'Citrus Hills Colonia', 26.2439994812012, 0.458044199838644, -98.2779998779297, -1.71527468014446, 218, 51, 'PPL', 'P'),
(93263, 'Citrus Lake Estates Colonia', 26.3110008239746, 0.459213593873298, -98.370002746582, -1.71688043312372, 218, 51, 'PPL', 'P'),
(15536, 'Citrus Park', 28.0780601501465, 0.49005459719307, -82.5699996948242, -1.4411183580454, 218, 12, 'PPL', 'P'),
(177950, 'Citrus Park', 33.5486106872559, 0.585533715962372, -112.44361114502, -1.96251123731278, 218, 5, 'PPL', 'P'),
(93264, 'Citrus Ranchitos Colonia', 26.2450008392334, 0.458061676833298, -98.1549987792969, -1.71312790598975, 218, 51, 'PPL', 'P'),
(93265, 'Citrus Retreat Colonia', 26.1380004882813, 0.456194168408393, -98.0080032348633, -1.71056234975362, 218, 51, 'PPL', 'P'),
(15537, 'Citrus Ridge', 28.3458309173584, 0.494728078721509, -81.6736068725586, -1.42547335190562, 218, 12, 'PPL', 'P'),
(15538, 'Citrus Springs', 28.9972190856934, 0.506096946967489, -82.470832824707, -1.43938756965295, 218, 12, 'PPL', 'P'),
(180737, 'Citrus View', 32.9647216796875, 0.575342930314102, -115.565002441406, -2.01698979267782, 218, 6, 'PPL', 'P'),
(127111, 'City Camp Landing', 45.9002799987793, 0.801111013565998, -68.0827789306641, -1.18826865624751, 218, 26, 'PPL', 'P'),
(203428, 'City Crest Condominium', 40.7708282470703, 0.711585191676485, -111.885833740234, -1.95277618510605, 218, 52, 'PPL', 'P'),
(100833, 'City Farm', 37.3255615234375, 0.651453943739695, -79.1897201538086, -1.38212135041687, 218, 53, 'PPL', 'P'),
(100834, 'City Gomingo', 37.4300003051758, 0.6532767443478, -79.0908279418945, -1.38039535571439, 218, 53, 'PPL', 'P'),
(147818, 'City Island', 40.8472213745117, 0.712918503276233, -73.7869415283203, -1.28782507464573, 218, 40, 'PPL', 'P'),
(147819, 'City Line', 40.6761093139648, 0.709932034429818, -73.8874969482422, -1.28958009780409, 218, 40, 'PPL', 'P'),
(124525, 'City Mills', 42.1083297729492, 0.73492899705352, -71.3550033569336, -1.2453797463501, 218, 23, 'PPL', 'P'),
(15539, 'City Point', 28.4058303833008, 0.495775266951642, -80.7555618286133, -1.40945044320715, 218, 12, 'PPL', 'P'),
(124526, 'City Point', 42.336109161377, 0.738904497349763, -71.029167175293, -1.23969283215834, 218, 23, 'PPL', 'P'),
(127112, 'City Point', 44.4511108398438, 0.775818240324215, -69.0355606079102, -1.20489783356813, 218, 26, 'PPL', 'P'),
(173546, 'City Point', 44.3522186279297, 0.774092245621735, -90.3213882446289, -1.57640560984088, 218, 57, 'PPL', 'P'),
(177604, 'City Point', 41.2830581665039, 0.720525290297827, -72.9288864135742, -1.27284918772983, 218, 8, 'PPL', 'P'),
(100835, 'City Point (historical)', 37.3166694641113, 0.651298748027171, -77.2777786254883, -1.34875167564207, 218, 53, 'PPL', 'P'),
(180741, 'City Terrace', 34.0499992370605, 0.594284596988264, -118.181938171387, -2.06266393747906, 218, 6, 'PPL', 'P'),
(75452, 'City View', 34.8413887023926, 0.608096948823905, -99.3516693115234, -1.73401374683869, 218, 42, 'PPL', 'P'),
(80338, 'City View', 34.8613891601563, 0.608446022663787, -82.4316711425781, -1.43870406935918, 218, 48, 'PPL', 'P'),
(108594, 'City View Addition', 37.8494415283203, 0.660597374710264, -82.0022201538086, -1.43120873562921, 218, 58, 'PPL', 'P'),
(72107, 'City View Heights', 39.422779083252, 0.688057295289098, -84.5513916015625, -1.47570017059035, 218, 41, 'PPL', 'P'),
(100836, 'City View Heights', 37.2408294677734, 0.649975090386374, -80.0250015258789, -1.39669976054007, 218, 53, 'PPL', 'P'),
(173548, 'City View Heights', 43.1802787780762, 0.753638036606463, -89.1797180175781, -1.55647970540685, 218, 57, 'PPL', 'P'),
(20060, 'City Village', 32.4886093139648, 0.567033201922783, -84.9880599975586, -1.48332147183988, 218, 13, 'PPL', 'P'),
(93266, 'City, Arroyo', 26.3327808380127, 0.459593726829393, -97.4391708374023, -1.70063435152591, 218, 51, 'PPL', 'P'),
(93267, 'City-by-the Sea', 27.9513893127441, 0.48784377401414, -97.1047210693359, -1.69479710189062, 218, 51, 'PPL', 'P'),
(63695, 'Cityview', 36.1016693115234, 0.630092994952278, -80.2050018310547, -1.39984135851999, 218, 33, 'PPL', 'P'),
(119145, 'Civer (historical)', 40.524169921875, 0.707280191774372, -90.1074981689453, -1.57267252378286, 218, 18, 'PPL', 'P'),
(54047, 'Civil Bend', 39.9972190856934, 0.698083164686865, -94.0999984741211, -1.64235479949505, 218, 29, 'PPL', 'P'),
(200575, 'Civil Bend (historical)', 43.1069412231445, 0.752358054807544, -123.423606872559, -2.15414831461325, 218, 43, 'PPL', 'P'),
(75453, 'Civit', 34.7891693115234, 0.607185548519853, -97.1252822875977, -1.69515596284751, 218, 42, 'PPL', 'P'),
(92953, 'CJRS Colonia', 26.3439998626709, 0.459789535748541, -98.3359985351563, -1.7162869476748, 218, 51, 'PPL', 'P'),
(35248, 'Clabber Bottom', 38.1936111450195, 0.666604267706992, -84.5244369506836, -1.47522972318378, 218, 21, 'PPL', 'P'),
(59012, 'Clack', 34.8458290100098, 0.608174446811627, -90.2930603027344, -1.5759111939845, 218, 30, 'PPL', 'P'),
(85828, 'Clack Branch', 35.0952796936035, 0.612528182561688, -87.4741668701172, -1.52671222232249, 218, 50, 'PPL', 'P'),
(200578, 'Clackamas', 45.4077796936035, 0.792515261673603, -122.56916809082, -2.13923554461519, 218, 43, 'PPL', 'P'),
(200577, 'Clackamas Heights', 45.3713912963867, 0.791880164332647, -122.578056335449, -2.13939067374868, 218, 43, 'PPL', 'P'),
(1585, 'Clackville', 33.0888900756836, 0.577510077651154, -85.4508285522461, -1.49139830679387, 218, 2, 'PPL', 'P'),
(32070, 'Claflin', 38.5250015258789, 0.672388120962426, -98.533332824707, -1.71973108075454, 218, 20, 'PPL', 'P'),
(45794, 'Claggerts Forest', 39.4738883972168, 0.68894932109622, -76.355827331543, -1.3326605900197, 218, 25, 'PPL', 'P'),
(45795, 'Claggettsville', 39.3172187805176, 0.686214920446982, -77.1980590820313, -1.34736030713056, 218, 25, 'PPL', 'P'),
(160100, 'Claghorn', 40.4877815246582, 0.706645094433415, -79.0752792358398, -1.38012397959931, 218, 45, 'PPL', 'P'),
(194732, 'Clagstone', 48.019718170166, 0.838102187949144, -116.805557250977, -2.03864155865628, 218, 17, 'PPL', 'P'),
(45796, 'Clahamman Hills', 38.5597190856934, 0.672994056689447, -76.5663909912109, -1.33633561916596, 218, 25, 'PPL', 'P'),
(100837, 'Claiborn (historical)', 37.002498626709, 0.645815432500752, -79.9433288574219, -1.39527430356661, 218, 53, 'PPL', 'P'),
(1586, 'Claiborne', 31.5400009155273, 0.550476862057978, -87.5155563354492, -1.52743460476817, 218, 2, 'PPL', 'P'),
(39791, 'Claiborne', 32.5158309936523, 0.567508309861253, -92.1916732788086, -1.60904824163809, 218, 22, 'PPL', 'P'),
(45797, 'Claiborne', 38.8375015258789, 0.677842274874909, -76.2780609130859, -1.33130330997014, 218, 25, 'PPL', 'P'),
(100838, 'Claiborne', 38.1597213745117, 0.666012779628886, -77.4558334350586, -1.35185931831808, 218, 53, 'PPL', 'P'),
(154728, 'Claiborne', 40.3880615234375, 0.704904652082021, -83.3491668701172, -1.45471739067772, 218, 41, 'PPL', 'P'),
(59007, 'Claiborne (historical)', 31.8888893127441, 0.556566113311417, -89.0319366455078, -1.55390043389111, 218, 30, 'PPL', 'P'),
(39792, 'Claiborne Hill', 30.4769401550293, 0.531922951638532, -90.0861129760742, -1.57229928175608, 218, 22, 'PPL', 'P'),
(1587, 'Claiborne Landing', 31.5499992370605, 0.550651365688406, -87.5138931274414, -1.52740557631229, 218, 2, 'PPL', 'P'),
(45798, 'Claibornes Landing', 38.9152793884277, 0.679199754661549, -76.3483276367188, -1.33252969565212, 218, 25, 'PPL', 'P'),
(59009, 'Claibornesville (historical)', 32.601390838623, 0.569001610863488, -90.5361099243164, -1.58015321012684, 218, 30, 'PPL', 'P'),
(112406, 'Clair', 39.7849998474121, 0.694379240242783, -94.7441711425781, -1.65359773351099, 218, 29, 'PPL', 'P'),
(180743, 'Clair', 33.8066711425781, 0.590037720576942, -117.983612060547, -2.05920249385223, 218, 6, 'PPL', 'P'),
(15540, 'Clair-Mel City', 27.9308300018311, 0.487484946346766, -82.3688888549805, -1.43760831172867, 218, 12, 'PPL', 'P'),
(170018, 'Claire City', 45.8572196960449, 0.800359469506377, -97.1033325195313, -1.6947728671247, 218, 49, 'PPL', 'P'),
(180742, 'Clairemont', 32.7972183227539, 0.572419445227468, -117.191673278809, -2.04538055463667, 218, 6, 'PPL', 'P'),
(191272, 'Clairemont', 33.166389465332, 0.578862697168806, -100.752220153809, -1.75845797037815, 218, 51, 'PPL', 'P'),
(93268, 'Clairette', 32.0391693115234, 0.559188994090009, -98.1186065673828, -1.71249274206976, 218, 51, 'PPL', 'P'),
(85830, 'Clairfield', 36.5499992370605, 0.637917828288122, -83.9502792358398, -1.46520878063403, 218, 50, 'PPL', 'P'),
(63703, 'Clairmont', 34.2324981689453, 0.597469804231026, -77.9886093139648, -1.3611580115802, 218, 33, 'PPL', 'P'),
(100840, 'Clairmont Manor', 38.440559387207, 0.670914327615177, -78.0416717529297, -1.36208412584928, 218, 53, 'PPL', 'P'),
(1588, 'Clairmont Springs', 33.3502807617188, 0.582072205756515, -85.9302825927734, -1.49976635841307, 218, 2, 'PPL', 'P'),
(160101, 'Clairton', 40.2922210693359, 0.703231920601343, -79.8819427490234, -1.39420291386007, 218, 45, 'PPL', 'P'),
(207045, 'Clallam Bay', 48.2547187805176, 0.842203722343975, -124.258331298828, -2.16871700419847, 218, 56, 'PPL', 'P'),
(100841, 'Clam', 37.8136100769043, 0.659971997907286, -75.6705627441406, -1.32070046672221, 218, 53, 'PPL', 'P'),
(193452, 'Clam Beach', 40.9947204589844, 0.715492847943958, -124.110832214355, -2.16614265953075, 218, 6, 'PPL', 'P'),
(173549, 'Clam Falls', 45.6886100769043, 0.79741667650184, -92.293327331543, -1.6108224395563, 218, 57, 'PPL', 'P'),
(211758, 'Clam Gulch', 60.2311096191406, 1.05123117498363, -151.393615722656, -2.64231706085941, 218, 1, 'PPL', 'P'),
(173551, 'Clam Lake', 46.163890838623, 0.805711890665218, -90.9022216796875, -1.58654306568832, 218, 57, 'PPL', 'P'),
(130223, 'Clam River', 44.9452781677246, 0.784443087251519, -85.2802810668945, -1.48842169164349, 218, 27, 'PPL', 'P'),
(80339, 'Clambank', 33.3349990844727, 0.581805490173343, -79.1947174072266, -1.38220856894257, 218, 48, 'PPL', 'P'),
(190036, 'Clan Alpine (historical)', 39.5369415283203, 0.690049805837668, -117.834442138672, -2.05659898757057, 218, 39, 'PPL', 'P'),
(100842, 'Clancie', 37.5802803039551, 0.655899625126392, -76.6933288574219, -1.33855110287679, 218, 53, 'PPL', 'P'),
(196224, 'Clancy', 46.4652786254883, 0.810972099871316, -111.985557556152, -1.95451669403647, 218, 31, 'PPL', 'P'),
(26793, 'Clank', 37.1883316040039, 0.649058829813332, -89.3249969482422, -1.55901530108071, 218, 18, 'PPL', 'P'),
(122371, 'Clanricarde', 41.288330078125, 0.720617302513489, -86.9494400024414, -1.51755401080787, 218, 19, 'PPL', 'P'),
(1589, 'Clanton', 32.8386116027832, 0.573141894252179, -86.6294403076172, -1.51196896252781, 218, 2, 'PPL', 'P'),
(8086, 'Clantonville', 36.4813919067383, 0.636720404482995, -93.9088897705078, -1.63901932338778, 218, 4, 'PPL', 'P'),
(160107, 'Clapp Lease', 41.399169921875, 0.722551822729322, -79.529167175293, -1.38804581857786, 218, 45, 'PPL', 'P'),
(54048, 'Clapper', 39.5900001525879, 0.690975853527716, -91.8450012207031, -1.60299767279948, 218, 29, 'PPL', 'P'),
(134674, 'Clappers', 47.4355583190918, 0.827906675189939, -91.9647216796875, -1.60508718899076, 218, 28, 'PPL', 'P'),
(160104, 'Clappertown', 40.4030609130859, 0.705166440817176, -78.2755584716797, -1.36616621916815, 218, 45, 'PPL', 'P'),
(124527, 'Clapps Corner', 42.2000007629395, 0.736528957657413, -70.8130569458008, -1.23592099710646, 218, 23, 'PPL', 'P'),
(160105, 'Clappville', 41.6963882446289, 0.727739261058633, -79.7947235107422, -1.39268065098098, 218, 45, 'PPL', 'P'),
(207047, 'Claquato', 46.6436080932617, 0.814084536237291, -123.01611328125, -2.14703620976414, 218, 56, 'PPL', 'P'),
(15541, 'Clara', 29.7969398498535, 0.520054707398649, -83.3202819824219, -1.45421325428337, 218, 12, 'PPL', 'P'),
(45799, 'Clara', 38.2758293151855, 0.668039245481354, -75.8202819824219, -1.3233135603838, 218, 25, 'PPL', 'P'),
(54049, 'Clara', 37.2997207641602, 0.65100293740909, -92.021110534668, -1.6060713601716, 218, 29, 'PPL', 'P'),
(59010, 'Clara', 31.5802803039551, 0.551179870006732, -88.6963882446289, -1.54804400949597, 218, 30, 'PPL', 'P'),
(93270, 'Clara', 34.0909881591797, 0.594999988636086, -98.6968383789063, -1.72258479102062, 218, 51, 'PPL', 'P'),
(114976, 'Clara', 41.3536109924316, 0.721756669406852, -95.8966674804688, -1.67371258922435, 218, 16, 'PPL', 'P'),
(160106, 'Clara', 41.8927803039551, 0.731166949118647, -78.102783203125, -1.36315072186585, 218, 45, 'PPL', 'P'),
(144993, 'Clara Barton', 40.5341682434082, 0.707454695404799, -74.3397216796875, -1.29747290832676, 218, 37, 'PPL', 'P'),
(202008, 'Clara Belle Camp (historical)', 43.8638916015625, 0.765569331185154, -103.595832824707, -1.80808837413676, 218, 49, 'PPL', 'P'),
(134675, 'Clara City', 44.9550018310547, 0.784612797191984, -95.3661117553711, -1.66445264495609, 218, 28, 'PPL', 'P'),
(188323, 'Clara Peak', 36.0355606079102, 0.628939180410002, -106.239723205566, -1.85423296634456, 218, 38, 'PPL', 'P'),
(100843, 'Claraville', 37.9172210693359, 0.661780350866477, -76.4458312988281, -1.33423145558868, 218, 53, 'PPL', 'P'),
(180744, 'Claraville', 35.4422187805176, 0.618583411932201, -118.32861328125, -2.0652239010769, 218, 6, 'PPL', 'P'),
(15542, 'Clarcona', 28.6124992370605, 0.499382318911072, -81.498893737793, -1.42242403245748, 218, 12, 'PPL', 'P'),
(93269, 'Clardy', 33.5258293151855, 0.585136106011624, -95.4319381713867, -1.66560153265035, 218, 51, 'PPL', 'P'),
(32072, 'Clare', 38.8269386291504, 0.677657917548448, -94.8711090087891, -1.65581321722182, 218, 20, 'PPL', 'P'),
(35251, 'Clare', 36.7150001525879, 0.640797637532879, -86.3947219848633, -1.50787235498099, 218, 21, 'PPL', 'P'),
(39794, 'Clare', 31.3252792358398, 0.546729261772019, -93.6044387817383, -1.6337056512228, 218, 22, 'PPL', 'P'),
(72108, 'Clare', 39.1394386291504, 0.68311207146093, -84.3769378662109, -1.47265537851606, 218, 41, 'PPL', 'P'),
(114977, 'Clare', 42.5872192382813, 0.743287194976679, -94.3452835083008, -1.64663583094736, 218, 16, 'PPL', 'P'),
(119146, 'Clare', 42.0161094665527, 0.733319449069703, -88.8291702270508, -1.55036149227656, 218, 18, 'PPL', 'P'),
(122372, 'Clare', 40.1152801513672, 0.700143719001287, -85.9611129760742, -1.50030445011132, 218, 19, 'PPL', 'P'),
(130225, 'Clare', 43.8194389343262, 0.764793485780587, -84.7686080932617, -1.47949131356013, 218, 27, 'PPL', 'P'),
(147820, 'Clare', 44.4013900756836, 0.774950449283013, -75.0627822875977, -1.31009269662626, 218, 40, 'PPL', 'P'),
(180745, 'Clare Mill', 39.416389465332, 0.687945775418451, -123.426940917969, -2.15420650468307, 218, 6, 'PPL', 'P'),
(26794, 'Claremont', 38.7194404602051, 0.675781720560487, -87.9713897705078, -1.53539039905062, 218, 18, 'PPL', 'P'),
(59011, 'Claremont', 34.1205596923828, 0.595516109255344, -90.5238876342773, -1.57993989092352, 218, 30, 'PPL', 'P'),
(63698, 'Claremont', 35.7144393920898, 0.62333455789593, -81.1463928222656, -1.41627173086523, 218, 33, 'PPL', 'P'),
(80342, 'Claremont', 33.9736099243164, 0.592951351967543, -80.5597229003906, -1.40603240910609, 218, 48, 'PPL', 'P'),
(100849, 'Claremont', 38.8430595397949, 0.677939280517615, -77.1050033569336, -1.34573617833977, 218, 53, 'PPL', 'P'),
(108595, 'Claremont', 37.9180603027344, 0.661794998252473, -81.0511093139648, -1.41460871992253, 218, 58, 'PPL', 'P'),
(134677, 'Claremont', 44.0444412231445, 0.768720516544991, -92.9974975585938, -1.62311252851285, 218, 28, 'PPL', 'P'),
(143632, 'Claremont', 43.3766708374023, 0.757065724666477, -72.3472213745117, -1.26269721765445, 218, 36, 'PPL', 'P'),
(154730, 'Claremont', 40.0472183227539, 0.698955815997057, -80.857780456543, -1.4112344948214, 218, 41, 'PPL', 'P'),
(170021, 'Claremont', 45.6719398498535, 0.797125726152748, -98.0152816772461, -1.71068938253761, 218, 49, 'PPL', 'P'),
(180746, 'Claremont', 34.0966682434082, 0.595099124807664, -117.718887329102, -2.05458217567706, 218, 6, 'PPL', 'P'),
(188324, 'Claremont', 33.4111099243164, 0.583133874925075, -108.779167175293, -1.8985546247862, 218, 38, 'PPL', 'P'),
(45800, 'Claremont (historical)', 39.274169921875, 0.685463576124443, -76.6558303833008, -1.33789663103891, 218, 25, 'PPL', 'P'),
(143633, 'Claremont Junction', 43.3683280944824, 0.756920116333877, -72.3783264160156, -1.26324010304266, 218, 36, 'PPL', 'P'),
(100845, 'Claremont Manor', 37.2363891601563, 0.649897592398653, -76.977783203125, -1.34351576778092, 218, 53, 'PPL', 'P'),
(134678, 'Claremont Mobile Homes', 44.0466690063477, 0.768759398696906, -92.9952774047852, -1.62307377951899, 218, 28, 'PPL', 'P'),
(177951, 'Claremont Place', 33.5283317565918, 0.585179781853501, -112.04167175293, -1.95549607152735, 218, 5, 'PPL', 'P'),
(75454, 'Claremore', 36.3125, 0.633772684630441, -95.6158294677734, -1.66881104123806, 218, 42, 'PPL', 'P'),
(1592, 'Clarence', 34.083610534668, 0.594871224797381, -86.4283294677734, -1.50845891621108, 218, 2, 'PPL', 'P'),
(35250, 'Clarence', 37.2919387817383, 0.650867116193496, -84.557502746582, -1.475806830192, 218, 21, 'PPL', 'P'),
(39795, 'Clarence', 31.8213901519775, 0.555388030713707, -93.0294418334961, -1.62367006128706, 218, 22, 'PPL', 'P'),
(54050, 'Clarence', 39.7419395446777, 0.693627696183163, -92.2583312988281, -1.61021164356029, 218, 29, 'PPL', 'P'),
(108596, 'Clarence', 38.7755584716797, 0.676761164630391, -81.4813919067383, -1.42211856788044, 218, 58, 'PPL', 'P'),
(114978, 'Clarence', 41.8888893127441, 0.73109903851085, -91.0563888549805, -1.58923379049568, 218, 16, 'PPL', 'P'),
(119148, 'Clarence', 40.4638900756836, 0.706228109985736, -87.970832824707, -1.53538067851264, 218, 18, 'PPL', 'P'),
(147822, 'Clarence', 42.9766693115234, 0.750084381026889, -78.5922164916992, -1.37169294422034, 218, 40, 'PPL', 'P'),
(160109, 'Clarence', 41.0480613708496, 0.716423822482023, -77.940559387207, -1.36031938215294, 218, 45, 'PPL', 'P'),
(130228, 'Clarence Center', 42.3811111450195, 0.739689930134255, -84.7680587768555, -1.47948172618021, 218, 27, 'PPL', 'P'),
(147823, 'Clarence Center', 43.0105590820313, 0.750675869104995, -78.6377792358398, -1.37248816412184, 218, 40, 'PPL', 'P'),
(45801, 'Clarence Perkins Homes', 39.2874984741211, 0.685696203245661, -76.5972213745117, -1.33687371086421, 218, 25, 'PPL', 'P'),
(130230, 'Clarenceville', 42.4483299255371, 0.740863119173462, -83.3372192382813, -1.45450886516437, 218, 27, 'PPL', 'P'),
(8087, 'Clarendon', 34.6930618286133, 0.605508156507266, -91.313606262207, -1.59372308114523, 218, 4, 'PPL', 'P'),
(63700, 'Clarendon', 34.2099990844727, 0.597077121128294, -78.8455581665039, -1.3761145905782, 218, 33, 'PPL', 'P'),
(80340, 'Clarendon', 34.5497207641602, 0.603006382979246, -82.628059387207, -1.44213169084017, 218, 48, 'PPL', 'P'),
(100846, 'Clarendon', 38.8858299255371, 0.678685764571164, -77.0972213745117, -1.34560035712418, 218, 53, 'PPL', 'P'),
(130231, 'Clarendon', 42.1302795410156, 0.735312092776328, -84.8658294677734, -1.48118814664867, 218, 27, 'PPL', 'P'),
(147825, 'Clarendon', 43.1933288574219, 0.753865803458692, -78.0650024414063, -1.36249132317995, 218, 40, 'PPL', 'P'),
(160110, 'Clarendon', 41.7799987792969, 0.729198540177942, -79.0933303833008, -1.38043903155627, 218, 45, 'PPL', 'P'),
(171859, 'Clarendon', 43.5161094665527, 0.759499387849618, -72.9702835083008, -1.27357170333357, 218, 55, 'PPL', 'P'),
(191273, 'Clarendon', 34.9377784729004, 0.609779267684508, -100.88777923584, -1.76082392269057, 218, 51, 'PPL', 'P'),
(160111, 'Clarendon Heights', 41.791389465332, 0.729397345153317, -79.1055603027344, -1.38065248391764, 218, 45, 'PPL', 'P'),
(119149, 'Clarendon Hills', 41.7975006103516, 0.729504004754974, -87.954719543457, -1.53509944870153, 218, 18, 'PPL', 'P'),
(124529, 'Clarendon Hills', 42.2750015258789, 0.737837967912214, -71.1236114501953, -1.24134119571505, 218, 23, 'PPL', 'P'),
(194733, 'Clarendon Hot Springs', 43.559440612793, 0.760255659020174, -114.414169311523, -1.99690396542034, 218, 17, 'PPL', 'P'),
(171860, 'Clarendon Springs', 43.547779083252, 0.760052126933864, -73.0227813720703, -1.27448796390661, 218, 55, 'PPL', 'P'),
(89, 'Claresville', 36.622501373291, 0.639183229280073, -77.4511108398438, -1.35177689348234, 218, 53, 'PPL', 'P'),
(209366, 'Clareton (historical)', 43.7005615234375, 0.762718683554333, -104.691940307617, -1.82721905866929, 218, 59, 'PPL', 'P'),
(93273, 'Clareville', 28.3222198486328, 0.494315987832333, -97.8708267211914, -1.70816816793364, 218, 51, 'PPL', 'P'),
(180747, 'Claribel', 37.7144393920898, 0.658241142935816, -120.824440002441, -2.10878429492095, 218, 6, 'PPL', 'P'),
(85832, 'Claridge', 35.1527786254883, 0.613531728239457, -85.3147201538086, -1.48902276710152, 218, 50, 'PPL', 'P'),
(160113, 'Claridge', 40.3655586242676, 0.704511902400262, -79.6224975585938, -1.38967474105861, 218, 45, 'PPL', 'P'),
(13545, 'Claridge Court', 39.6483306884766, 0.691993913433426, -75.6213912963867, -1.31984226306093, 218, 10, 'PPL', 'P'),
(154732, 'Claridon', 40.5830612182617, 0.708308038797088, -82.996940612793, -1.44856988277544, 218, 41, 'PPL', 'P'),
(114979, 'Clarinda', 40.7419395446777, 0.711080988703106, -95.0380630493164, -1.65872711492853, 218, 16, 'PPL', 'P'),
(114980, 'Clarinda Junction (historical)', 40.9322204589844, 0.714402017161462, -95.0008316040039, -1.65807730362255, 218, 16, 'PPL', 'P'),
(72109, 'Clarington', 39.7655601501465, 0.694039953519907, -80.8713912963867, -1.41147204879063, 218, 41, 'PPL', 'P'),
(160114, 'Clarington', 41.3325004577637, 0.72138822107004, -79.1233291625977, -1.38096260902658, 218, 45, 'PPL', 'P'),
(72110, 'Clarion', 39.0908317565918, 0.682263721495685, -82.3833312988281, -1.43786037992585, 218, 41, 'PPL', 'P'),
(114981, 'Clarion', 42.7316703796387, 0.74580834300163, -93.732780456543, -1.63594563601567, 218, 16, 'PPL', 'P'),
(119150, 'Clarion', 41.5050010681152, 0.724398924682374, -89.1919403076172, -1.55669302461016, 218, 18, 'PPL', 'P'),
(130233, 'Clarion', 45.2783317565918, 0.790255968962835, -84.9233322143555, -1.48219175890547, 218, 27, 'PPL', 'P'),
(160115, 'Clarion', 41.2147216796875, 0.719332593603635, -79.3855590820313, -1.38553938451793, 218, 45, 'PPL', 'P'),
(160117, 'Clarion Junction', 41.2369384765625, 0.71972034985835, -79.4172210693359, -1.38609199044412, 218, 45, 'PPL', 'P'),
(134681, 'Clarissa', 46.1302795410156, 0.805125262856101, -94.9483337402344, -1.65716104304951, 218, 28, 'PPL', 'P'),
(75458, 'Clarita', 34.482780456543, 0.601838054209028, -96.4330596923828, -1.68307439940431, 218, 42, 'PPL', 'P'),
(1590, 'Clark', 33.0125007629395, 0.576176832630434, -88.2852783203125, -1.54086878772902, 218, 2, 'PPL', 'P'),
(15543, 'Clark', 29.7730598449707, 0.519637922688051, -82.626106262207, -1.44209760237822, 218, 12, 'PPL', 'P'),
(26796, 'Clark', 39.2597198486328, 0.685211374769212, -90.5777816772461, -1.58088051942054, 218, 18, 'PPL', 'P'),
(54051, 'Clark', 39.2811088562012, 0.685584683375014, -92.3424987792969, -1.61168064321758, 218, 29, 'PPL', 'P'),
(59013, 'Clark', 31.2880592346191, 0.546079650203121, -88.5738906860352, -1.54590602377285, 218, 30, 'PPL', 'P'),
(63702, 'Clark', 35.4402809143066, 0.618549589786357, -83.0738906860352, -1.44991291491316, 218, 33, 'PPL', 'P'),
(93272, 'Clark', 30.391939163208, 0.53043940446379, -94.76611328125, -1.65398069607574, 218, 51, 'PPL', 'P'),
(114982, 'Clark', 40.9505615234375, 0.714722129124489, -95.5400009155273, -1.66748758333435, 218, 16, 'PPL', 'P'),
(144994, 'Clark', 40.6408309936523, 0.709316311585792, -74.3111114501953, -1.29697356562237, 218, 37, 'PPL', 'P'),
(147827, 'Clark', 42.124439239502, 0.735210160285605, -79.0986099243164, -1.38053117692998, 218, 40, 'PPL', 'P'),
(154736, 'Clark', 40.0130615234375, 0.698359667387043, -84.7241668701172, -1.47871566789264, 218, 41, 'PPL', 'P'),
(160120, 'Clark', 41.2861099243164, 0.720578553519628, -80.4277801513672, -1.4037295737115, 218, 45, 'PPL', 'P'),
(170024, 'Clark', 44.8777809143066, 0.783265037943322, -97.732780456543, -1.70575880609544, 218, 49, 'PPL', 'P'),
(173552, 'Clark', 45.0291709899902, 0.785907293218844, -90.6588897705078, -1.58229612269797, 218, 57, 'PPL', 'P'),
(190037, 'Clark', 39.5641708374023, 0.690525046934193, -119.480560302734, -2.08532916941035, 218, 39, 'PPL', 'P'),
(194139, 'Clark', 40.3277816772461, 0.703852570293386, -104.925003051758, -1.83128677091827, 218, 7, 'PPL', 'P'),
(209367, 'Clark', 44.8994407653809, 0.783643073660059, -109.150283813477, -1.90503183203144, 218, 59, 'PPL', 'P'),
(1591, 'Clark (historical)', 33.7763900756836, 0.589509216258615, -85.9319381713867, -1.49979525371089, 218, 2, 'PPL', 'P'),
(100848, 'Clark (historical)', 36.9977798461914, 0.645733074244041, -82.7513885498047, -1.44428419079123, 218, 53, 'PPL', 'P'),
(108597, 'Clark (historical)', 37.4144401550293, 0.653005168495639, -81.432502746582, -1.42126529106718, 218, 58, 'PPL', 'P'),
(196225, 'Clark (historical)', 46.3186111450195, 0.808412269431532, -113.286666870117, -1.97722533549352, 218, 31, 'PPL', 'P'),
(130234, 'Clark Bayshore', 44.2461090087891, 0.772240283399694, -83.5400009155273, -1.45804807309503, 218, 27, 'PPL', 'P'),
(26797, 'Clark Center', 39.3624992370605, 0.687005213500463, -87.7819366455078, -1.53208381824118, 218, 18, 'PPL', 'P'),
(139078, 'Clark City', 40.4208297729492, 0.705476565926116, -91.6813888549805, -1.60014209832064, 218, 29, 'PPL', 'P'),
(93274, 'Clark Colonia', 26.1749992370605, 0.45683991839371, -98.0830001831055, -1.71187129342939, 218, 51, 'PPL', 'P'),
(170025, 'Clark Colony', 44.7894401550293, 0.781723200830221, -97.9800033569336, -1.71007365969359, 218, 49, 'PPL', 'P'),
(130235, 'Clark Corners', 43.0227813720703, 0.750889188308311, -86.1449966430664, -1.50351382554097, 218, 27, 'PPL', 'P'),
(147830, 'Clark Corners', 43.4375, 0.758127393835037, -76.4263916015625, -1.33389216886581, 218, 40, 'PPL', 'P'),
(154737, 'Clark Corners', 41.0552787780762, 0.716549790001584, -81.7324981689453, -1.42650119892833, 218, 41, 'PPL', 'P'),
(1593, 'Clark Crossroads', 31.1952800750732, 0.544460348391812, -85.475830078125, -1.49183466573848, 218, 2, 'PPL', 'P'),
(80343, 'Clark Estates', 35.1094398498535, 0.612775323910847, -82.0369415283203, -1.43181473793526, 218, 48, 'PPL', 'P'),
(54052, 'Clark Ford', 37.5213890075684, 0.654871778103675, -92.39111328125, -1.61252912634087, 218, 29, 'PPL', 'P'),
(194735, 'Clark Fork', 48.1452789306641, 0.840293636631143, -116.17472076416, -2.02763138491962, 218, 17, 'PPL', 'P'),
(147831, 'Clark Heights', 41.7316703796387, 0.728355050481687, -73.8436126708984, -1.28881417267458, 218, 40, 'PPL', 'P'),
(35253, 'Clark Hill', 38.2949981689453, 0.668373805093295, -83.1908264160156, -1.45195382841455, 218, 21, 'PPL', 'P'),
(143635, 'Clark Hill', 43.0463905334473, 0.751301245907973, -70.9552764892578, -1.23840319640047, 218, 36, 'PPL', 'P'),
(127113, 'Clark Island', 43.9922218322754, 0.767809116240938, -69.1827774047852, -1.20746725138784, 218, 26, 'PPL', 'P'),
(35254, 'Clark Landing', 37.1352806091309, 0.648132915281339, -86.6022186279297, -1.51149385458934, 218, 21, 'PPL', 'P'),
(143636, 'Clark Landing', 43.7080612182617, 0.762849577921911, -71.3491668701172, -1.2452778804384, 218, 36, 'PPL', 'P'),
(147832, 'Clark Mills', 43.0922203063965, 0.752101126341378, -75.379997253418, -1.31562914221643, 218, 40, 'PPL', 'P'),
(13060, 'Clark Mills Estate Subdivision (historical)', 38.9283294677734, 0.679427521513778, -76.9694366455078, -1.34337009286929, 218, 9, 'PPL', 'P'),
(147833, 'Clark Point', 43.8252792358398, 0.76489541827131, -76.2694396972656, -1.33115284136855, 218, 40, 'PPL', 'P'),
(29478, 'Clark Siding', 38.4727783203125, 0.671476654079347, -85.6636123657227, -1.49511208493399, 218, 19, 'PPL', 'P'),
(93275, 'Clark Station', 28.6158294677734, 0.499440442401863, -96.7102813720703, -1.68791283047277, 218, 51, 'PPL', 'P'),
(199231, 'Clark Trailer Court', 42.8047218322754, 0.747083331373506, -102.202781677246, -1.78377504496488, 218, 35, 'PPL', 'P'),
(194736, 'Clark Tree', 46.2969398498535, 0.808034033977713, -115.710563659668, -2.01953031519971, 218, 17, 'PPL', 'P'),
(59015, 'Clarkburg', 32.3300018310547, 0.5642649791277, -89.7294387817383, -1.56607414270802, 218, 30, 'PPL', 'P'),
(1594, 'Clarkdale', 34.8072204589844, 0.607500600476809, -86.7727813720703, -1.51447073605583, 218, 2, 'PPL', 'P'),
(20063, 'Clarkdale', 33.8308296203613, 0.590459365556528, -84.6497192382813, -1.47741631159679, 218, 13, 'PPL', 'P'),
(114984, 'Clarkdale', 40.7852783203125, 0.711837393031716, -92.9047164916992, -1.62149319341203, 218, 16, 'PPL', 'P'),
(177952, 'Clarkdale', 34.771110534668, 0.606870363404842, -112.057220458984, -1.95576744764243, 218, 5, 'PPL', 'P'),
(190039, 'Clarkdale (historical)', 37.2694396972656, 0.650474433090764, -116.914436340332, -2.0405418572521, 218, 39, 'PPL', 'P'),
(1595, 'Clarke', 33.9144401550293, 0.591918644675837, -87.5766677856445, -1.52850120078475, 218, 2, 'PPL', 'P'),
(200579, 'Clarke', 45.8380584716797, 0.80002504305249, -119.599716186523, -2.08740883190559, 218, 43, 'PPL', 'P'),
(119153, 'Clarke City', 41.1580581665039, 0.718343628732834, -88.2427825927734, -1.54012709736544, 218, 18, 'PPL', 'P'),
(122373, 'Clarke Junction', 41.6300010681152, 0.726580586247367, -87.416389465332, -1.52570381637573, 218, 19, 'PPL', 'P'),
(8095, 'Clarkedale', 35.3091697692871, 0.616261268619707, -90.2361068725586, -1.57491716910763, 218, 4, 'PPL', 'P'),
(20065, 'Clarkedale', 33.915828704834, 0.591942879441757, -83.3419418334961, -1.45459129000011, 218, 13, 'PPL', 'P'),
(200580, 'Clarkes', 45.2155609130859, 0.789160411069403, -122.470001220703, -2.13750475622274, 218, 43, 'PPL', 'P'),
(100850, 'Clarkes Summit', 36.9958305358887, 0.645699052361115, -80.8891677856445, -1.41178230705763, 218, 53, 'PPL', 'P'),
(20066, 'Clarkesville', 34.6124992370605, 0.604102074030732, -83.5250015258789, -1.45778628435987, 218, 13, 'PPL', 'P'),
(85834, 'Clarketown', 36.1719398498535, 0.631319447213287, -82.2122192382813, -1.43487391107943, 218, 50, 'PPL', 'P'),
(134684, 'Clarkfield', 44.7905616760254, 0.781742775064233, -95.8083267211914, -1.67217075211125, 218, 28, 'PPL', 'P'),
(194737, 'Clarkia', 47.0108299255371, 0.820493766295703, -116.251937866211, -2.02897907758925, 218, 17, 'PPL', 'P'),
(20067, 'Clarking', 30.5161094665527, 0.532606585090356, -82.1183319091797, -1.43323526806071, 218, 13, 'PPL', 'P'),
(130237, 'Clarklake', 42.1213912963867, 0.735156963642831, -84.3450012207031, -1.47209797889991, 218, 27, 'PPL', 'P'),
(85835, 'Clarkrange', 36.1833305358887, 0.631518252188662, -85.0175018310547, -1.48383532877221, 218, 50, 'PPL', 'P'),
(8096, 'Clarkridge', 36.4777793884277, 0.636657354144187, -92.3511123657227, -1.61183097866111, 218, 4, 'PPL', 'P'),
(39796, 'Clarks', 32.0263900756836, 0.558965954348715, -92.1388931274414, -1.60812705421703, 218, 22, 'PPL', 'P'),
(122374, 'Clarks', 41.1333312988281, 0.717912063478186, -86.8902816772461, -1.51652150325325, 218, 19, 'PPL', 'P'),
(141492, 'Clarks', 41.2152786254883, 0.719342314141613, -97.835563659668, -1.70755271140572, 218, 35, 'PPL', 'P'),
(154740, 'Clarks', 41.5875015258789, 0.725838829304753, -81.211669921875, -1.41741103117956, 218, 41, 'PPL', 'P'),
(154741, 'Clarks (historical)', 41.6500015258789, 0.726929660087249, -81.2416687011719, -1.41793460864987, 218, 41, 'PPL', 'P'),
(190041, 'Clarks (historical)', 39.5849990844727, 0.690888568422989, -119.465278625488, -2.08506245382718, 218, 39, 'PPL', 'P'),
(20069, 'Clarks Bluff', 30.7777805328369, 0.537173606754219, -81.7658309936523, -1.42708296646846, 218, 13, 'PPL', 'P'),
(20070, 'Clarks Bridge', 34.3638916015625, 0.599763052245693, -83.7850036621094, -1.46232417769932, 218, 13, 'PPL', 'P'),
(20071, 'Clarks Bridge Place', 34.3802795410156, 0.600049075746767, -83.7827835083008, -1.46228542870545, 218, 13, 'PPL', 'P'),
(8097, 'Clarks Corner', 35.1233291625977, 0.613017738149072, -90.6119384765625, -1.58147666803055, 218, 4, 'PPL', 'P'),
(35255, 'Clarks Corner', 37.0419387817383, 0.64650379306351, -85.6611099243164, -1.49506840909211, 218, 21, 'PPL', 'P'),
(100851, 'Clarks Corner', 38.7705612182617, 0.676673946104691, -77.9497222900391, -1.3604793049764, 218, 53, 'PPL', 'P'),
(127116, 'Clarks Corner', 44.3191719055176, 0.773515471508651, -69.0788879394531, -1.20565403815966, 218, 26, 'PPL', 'P'),
(147834, 'Clarks Corner', 43.2213897705078, 0.754355558783158, -73.6419372558594, -1.28529427266182, 218, 40, 'PPL', 'P'),
(177606, 'Clarks Corner', 41.7680587768555, 0.728990147822643, -72.0930633544922, -1.25826132338476, 218, 8, 'PPL', 'P'),
(100853, 'Clarks Crossing', 38.9211082458496, 0.67930148741519, -77.2858276367188, -1.34889215738957, 218, 53, 'PPL', 'P'),
(63709, 'Clarks Crossroads', 34.5208282470703, 0.602502113426839, -78.5569381713867, -1.37107722137631, 218, 33, 'PPL', 'P'),
(80345, 'Clarks Crossroads', 33.7958297729492, 0.589848502981492, -79.8177795410156, -1.39308305462169, 218, 48, 'PPL', 'P'),
(112980, 'Clarks Falls', 41.4561080932617, 0.723545581290086, -71.8147201538086, -1.25340331808229, 218, 8, 'PPL', 'P'),
(54058, 'Clarks Fork', 38.8869400024414, 0.678705139068094, -92.6524963378906, -1.61709112128818, 218, 29, 'PPL', 'P'),
(100854, 'Clarks Gap', 39.1394386291504, 0.68311207146093, -77.6100006103516, -1.35455004312544, 218, 53, 'PPL', 'P'),
(160122, 'Clarks Green', 41.4927787780762, 0.724185605479059, -75.6999969482422, -1.32121419049649, 218, 45, 'PPL', 'P'),
(134686, 'Clarks Grove', 43.7638893127441, 0.763823961985744, -93.3288879394531, -1.62889638176828, 218, 28, 'PPL', 'P'),
(75456, 'Clarks Heights', 35.3763885498047, 0.617434457658914, -97.0005569458008, -1.69297909497248, 218, 42, 'PPL', 'P'),
(80344, 'Clarks Hill', 33.6708297729492, 0.587666841416499, -82.1730575561523, -1.43419041078566, 218, 48, 'PPL', 'P'),
(122375, 'Clarks Hill', 40.246940612793, 0.702441627547862, -86.7249984741211, -1.51363676716047, 218, 19, 'PPL', 'P'),
(20072, 'Clarks Junction', 34.1547203063965, 0.596112324444385, -82.8633270263672, -1.44623788576691, 218, 13, 'PPL', 'P'),
(39797, 'Clarks Landing', 30.9591693878174, 0.540339439500051, -92.4519424438477, -1.61359079550943, 218, 22, 'PPL', 'P'),
(45834, 'Clarks Landing', 38.3422203063965, 0.669197986871648, -76.5044403076172, -1.33525437576338, 218, 25, 'PPL', 'P'),
(63705, 'Clarks Landing', 34.3933296203613, 0.600276842598997, -77.9824981689453, -1.36105135197855, 218, 33, 'PPL', 'P'),
(122376, 'Clarks Landing', 41.5597190856934, 0.725353934249277, -84.9116668701172, -1.48198816024013, 218, 19, 'PPL', 'P'),
(144996, 'Clarks Landing', 40.0905609130859, 0.699712286904694, -74.0611114501953, -1.29261024249238, 218, 37, 'PPL', 'P'),
(20073, 'Clarks Mill', 31.6441707611084, 0.552294968844662, -84.4663925170898, -1.47421665670512, 218, 13, 'PPL', 'P'),
(70662, 'Clarks Mill', 39.3597183227539, 0.686956677389596, -75.0175018310547, -1.30930240357278, 218, 37, 'PPL', 'P'),
(113374, 'Clarks Mills', 44.0900001525879, 0.769515669867461, -87.8641662597656, -1.53351899575262, 218, 57, 'PPL', 'P'),
(127115, 'Clarks Mills', 43.5788917541504, 0.760595145480132, -70.6036071777344, -1.23226540903617, 218, 26, 'PPL', 'P'),
(144997, 'Clarks Mills', 40.3169403076172, 0.703663352697935, -74.3505630493164, -1.29766212592221, 218, 37, 'PPL', 'P'),
(147835, 'Clarks Mills', 43.1180610656738, 0.752552132671983, -73.5691680908203, -1.28402421113797, 218, 40, 'PPL', 'P'),
(160124, 'Clarks Mills', 41.3930587768555, 0.722445163127665, -80.1838912963867, -1.39947291018317, 218, 45, 'PPL', 'P'),
(80346, 'Clarks Point', 32.7388916015625, 0.571401451900785, -79.9524993896484, -1.39543435954812, 218, 48, 'PPL', 'P'),
(173554, 'Clarks Point', 44.1508293151855, 0.770577339036021, -88.7102813720703, -1.54828649031322, 218, 57, 'PPL', 'P'),
(211759, 'Clarks Point', 58.8441696166992, 1.02702450541341, -158.550827026367, -2.76723396337012, 218, 1, 'PPL', 'P'),
(80347, 'Clarks Sound', 32.7180595397949, 0.571037863832962, -79.9402770996094, -1.39522104034481, 218, 48, 'PPL', 'P'),
(160130, 'Clarks Summit', 41.4886093139648, 0.724112834602272, -75.7088928222656, -1.32136945278804, 218, 45, 'PPL', 'P'),
(160126, 'Clarks View', 41.2208290100098, 0.719439186626265, -76.2866668701172, -1.33145351225562, 218, 45, 'PPL', 'P'),
(169318, 'Clarks Village', 41.4625015258789, 0.72365716773976, -71.39111328125, -1.24600998342207, 218, 47, 'PPL', 'P'),
(177607, 'Clarks Village', 41.360279083252, 0.721873049546488, -71.8450012207031, -1.25393182240061, 218, 8, 'PPL', 'P'),
(20074, 'Clarksboro', 34.0411109924316, 0.594129467854767, -83.4983291625977, -1.45732076380133, 218, 13, 'PPL', 'P'),
(70664, 'Clarksboro', 39.7997207641602, 0.694636168708948, -75.2241668701172, -1.31290938895318, 218, 37, 'PPL', 'P'),
(45803, 'Clarksbrook Estates', 39.2336082458496, 0.684755641327673, -77.267219543457, -1.34856738489464, 218, 25, 'PPL', 'P'),
(26799, 'Clarksburg', 39.3300018310547, 0.686438026767303, -88.7416687011719, -1.54883430254945, 218, 18, 'PPL', 'P'),
(29482, 'Clarksburg', 39.4333305358887, 0.688241452878477, -85.3477783203125, -1.48959974095169, 218, 19, 'PPL', 'P'),
(35256, 'Clarksburg', 38.5849990844727, 0.673435275903046, -83.3661117553711, -1.45501313471678, 218, 21, 'PPL', 'P'),
(45804, 'Clarksburg', 39.2386093139648, 0.6848429264324, -77.2797164916992, -1.34878549778791, 218, 25, 'PPL', 'P'),
(54059, 'Clarksburg', 38.6591682434082, 0.674729771929906, -92.663330078125, -1.61728020572558, 218, 29, 'PPL', 'P'),
(72114, 'Clarksburg', 39.5052795410156, 0.689497199911477, -83.1533279418945, -1.45129935657666, 218, 41, 'PPL', 'P'),
(85836, 'Clarksburg', 35.8716697692871, 0.626078745662175, -88.3930587768555, -1.542749911565, 218, 50, 'PPL', 'P'),
(108598, 'Clarksburg', 39.2805595397949, 0.68557509599509, -80.3447189331055, -1.40227988197212, 218, 58, 'PPL', 'P'),
(130238, 'Clarksburg', 46.4919395446777, 0.81143742069278, -87.851936340332, -1.53330554339125, 218, 27, 'PPL', 'P'),
(144998, 'Clarksburg', 40.1886100769043, 0.701423567642152, -74.4411087036133, -1.29924244571306, 218, 37, 'PPL', 'P'),
(147836, 'Clarksburg', 42.6197204589844, 0.743854448288866, -78.831672668457, -1.375872242919, 218, 40, 'PPL', 'P'),
(160127, 'Clarksburg', 40.5336112976074, 0.707444974866821, -79.3822174072266, -1.38548106129006, 218, 45, 'PPL', 'P'),
(177654, 'Clarksburg', 38.4205589294434, 0.670565253775294, -121.526107788086, -2.12103070803562, 218, 6, 'PPL', 'P'),
(45805, 'Clarksburg Heights', 39.2236099243164, 0.684581137697245, -77.2641677856445, -1.34851412167283, 218, 25, 'PPL', 'P'),
(26800, 'Clarksburg IL', 39.3180618286133, 0.686229634412004, -88.7644424438477, -1.54923177934214, 218, 18, 'PPL', 'P'),
(26802, 'Clarksdale', 39.4897193908691, 0.689225624059316, -89.3677825927734, -1.55976205145037, 218, 18, 'PPL', 'P'),
(29483, 'Clarksdale', 39.2000007629395, 0.684169080097583, -86.126106262207, -1.50318412619802, 218, 19, 'PPL', 'P'),
(54060, 'Clarksdale', 39.8136100769043, 0.694878582947173, -94.5502777099609, -1.65021365471382, 218, 29, 'PPL', 'P'),
(59017, 'Clarksdale', 34.2000007629395, 0.596902617497866, -90.5708312988281, -1.58075921243288, 218, 30, 'PPL', 'P'),
(154742, 'Clarksfield', 41.1949996948242, 0.718988380032742, -82.4116668701172, -1.43835492894028, 218, 41, 'PPL', 'P'),
(35257, 'Clarkson', 37.4952812194824, 0.654416111241163, -86.2213897705078, -1.50484713714072, 218, 21, 'PPL', 'P'),
(45806, 'Clarkson', 39.2980613708496, 0.685880560572122, -76.9358291625977, -1.3427835316392, 218, 25, 'PPL', 'P'),
(54061, 'Clarkson', 37.0488891601563, 0.646625100051163, -94.0047225952148, -1.64069192171041, 218, 29, 'PPL', 'P'),
(59018, 'Clarkson', 33.6352806091309, 0.587046391461537, -89.1494369506836, -1.55595120108852, 218, 30, 'PPL', 'P'),
(93276, 'Clarkson', 30.9950008392334, 0.540964816303028, -96.9247207641602, -1.69165550391071, 218, 51, 'PPL', 'P'),
(100855, 'Clarkson', 38.4497184753418, 0.671074183859608, -78.0902786254883, -1.36293247581452, 218, 53, 'PPL', 'P'),
(141493, 'Clarkson', 41.7266693115234, 0.728267765376959, -97.121940612793, -1.69509763961964, 218, 35, 'PPL', 'P'),
(147837, 'Clarkson', 43.2330589294434, 0.754559224027522, -77.9277801513672, -1.36009634241164, 218, 40, 'PPL', 'P'),
(154744, 'Clarkson', 40.746940612793, 0.711168273807833, -80.6136093139648, -1.40697290444505, 218, 41, 'PPL', 'P'),
(194738, 'Clarkson', 43.211669921875, 0.75418591542172, -112.417778015137, -1.96206036414023, 218, 17, 'PPL', 'P'),
(80348, 'Clarkson (historical)', 34.7916717529297, 0.60722922436173, -81.3277816772461, -1.41943756361106, 218, 48, 'PPL', 'P'),
(85837, 'Clarkson (historical)', 36.1680603027344, 0.631251736342572, -82.540283203125, -1.4405997074231, 218, 50, 'PPL', 'P'),
(114986, 'Clarkson (historical)', 41.3344383239746, 0.721422043215884, -93.4522171020508, -1.63104888171934, 218, 16, 'PPL', 'P'),
(202010, 'Clarkson Addition', 44.0086097717285, 0.768095139742013, -103.326393127441, -1.80338576428389, 218, 49, 'PPL', 'P'),
(54062, 'Clarkson Valley', 38.6183280944824, 0.674016976864146, -90.5891723632813, -1.58107932439591, 218, 29, 'PPL', 'P'),
(13546, 'Clarksons Crossroads', 38.7144393920898, 0.67569443545576, -75.6527786254883, -1.32039007529716, 218, 10, 'PPL', 'P'),
(20075, 'Clarkston', 33.809440612793, 0.590086056950727, -84.2397232055664, -1.47026053090581, 218, 13, 'PPL', 'P'),
(130240, 'Clarkston', 42.708610534668, 0.745405872781892, -83.4397201538086, -1.45629784362663, 218, 27, 'PPL', 'P'),
(196226, 'Clarkston', 46.0299987792969, 0.803375033387701, -111.412780761719, -1.94451985309459, 218, 31, 'PPL', 'P'),
(203432, 'Clarkston', 41.920280456543, 0.731646917326107, -112.049171447754, -1.95562696589493, 218, 52, 'PPL', 'P'),
(207051, 'Clarkston', 46.416389465332, 0.810118823058054, -117.044166564941, -2.04280607681089, 218, 56, 'PPL', 'P'),
(207049, 'Clarkston Heights', 46.3963890075684, 0.809769749218172, -117.081390380859, -2.04345575495881, 218, 56, 'PPL', 'P'),
(70665, 'Clarkstown', 39.435001373291, 0.688270614492414, -74.7155609130859, -1.30403254040773, 218, 37, 'PPL', 'P'),
(160128, 'Clarkstown', 41.1986083984375, 0.719051363792522, -76.725830078125, -1.33911835618898, 218, 45, 'PPL', 'P'),
(848, 'Clarksville', 35.8255615234375, 0.62527400495978, -95.5138931274414, -1.66703191647184, 218, 42, 'PPL', 'P'),
(1598, 'Clarksville', 31.728889465332, 0.553773589171387, -87.8930587768555, -1.53402326530503, 218, 2, 'PPL', 'P'),
(8098, 'Clarksville', 35.4713897705078, 0.619092541753597, -93.4663925170898, -1.63129628938461, 218, 4, 'PPL', 'P'),
(13547, 'Clarksville', 38.5488891601563, 0.672805038831078, -75.148063659668, -1.31158113735951, 218, 10, 'PPL', 'P'),
(15546, 'Clarksville', 30.1208305358887, 0.525707666286505, -81.4844436645508, -1.42217183110225, 218, 12, 'PPL', 'P'),
(45807, 'Clarksville', 39.2063903808594, 0.68428059996823, -76.9433288574219, -1.34291442600678, 218, 25, 'PPL', 'P'),
(54063, 'Clarksville', 39.3705596923828, 0.687145894985046, -90.9049987792969, -1.58659153522016, 218, 29, 'PPL', 'P'),
(72124, 'Clarksville', 39.4013900756836, 0.687683986683296, -83.9813919067383, -1.4657517991803, 218, 41, 'PPL', 'P'),
(78033, 'Clarksville', 39.9727783203125, 0.697656592859262, -80.0441665649414, -1.39703425357299, 218, 45, 'PPL', 'P'),
(85838, 'Clarksville', 36.5297203063965, 0.637563894179251, -87.3594436645508, -1.52470992465691, 218, 50, 'PPL', 'P'),
(93277, 'Clarksville', 33.6105613708496, 0.586614959364945, -95.0524978637695, -1.65897904996765, 218, 51, 'PPL', 'P'),
(100857, 'Clarksville', 36.7986106872559, 0.642256916652188, -81.7652816772461, -1.42707337908854, 218, 53, 'PPL', 'P'),
(114987, 'Clarksville', 42.7847213745117, 0.746734257533623, -92.6675033569336, -1.61735304318139, 218, 16, 'PPL', 'P'),
(119154, 'Clarksville', 40.6505584716797, 0.709486088105285, -88.8483276367188, -1.55069585215141, 218, 18, 'PPL', 'P'),
(122377, 'Clarksville', 40.0322189331055, 0.698694027261902, -85.9124984741211, -1.49945596698802, 218, 19, 'PPL', 'P'),
(130241, 'Clarksville', 42.8422203063965, 0.747737803211392, -85.2425003051758, -1.48776229295759, 218, 27, 'PPL', 'P'),
(145000, 'Clarksville', 40.2963905334473, 0.703304691478129, -74.6805572509766, -1.30342161125367, 218, 37, 'PPL', 'P'),
(147840, 'Clarksville', 42.5758285522461, 0.743088390001305, -73.9644393920898, -1.29092299678376, 218, 40, 'PPL', 'P'),
(180748, 'Clarksville', 38.6549987792969, 0.674657001053119, -121.051391601563, -2.11274534756828, 218, 6, 'PPL', 'P'),
(194739, 'Clarksville', 47.7538909912109, 0.833462628435089, -116.731941223145, -2.03735671658837, 218, 17, 'PPL', 'P'),
(200581, 'Clarksville', 44.4913902282715, 0.776521248272969, -117.678886413574, -2.05388402799729, 218, 43, 'PPL', 'P'),
(93278, 'Clarksville (historical)', 25.9572792053223, 0.453039986992331, -97.152587890625, -1.69563253552458, 218, 51, 'PPL', 'P'),
(154745, 'Clarksville (historical)', 41.4222183227539, 0.722954093211979, -84.7680587768555, -1.47948172618021, 218, 41, 'PPL', 'P'),
(199876, 'Clarksville (historical)', 40.3127784729004, 0.703590714979203, -118.492782592773, -2.06808919609372, 218, 39, 'PPL', 'P'),
(93279, 'Clarksville City', 32.5294418334961, 0.567745863830488, -94.9027786254883, -1.65636595630607, 218, 51, 'PPL', 'P'),
(78034, 'Clarksville Hill', 39.9822196960449, 0.69782137595171, -80.0391693115234, -1.39694703504729, 218, 45, 'PPL', 'P'),
(1599, 'Clarksville Landing', 34.4874992370605, 0.601920412465739, -86.504997253418, -1.5097970215008, 218, 2, 'PPL', 'P'),
(45808, 'Clarksville Meadows', 39.1888885498047, 0.683975135391198, -76.9102783203125, -1.34233758531467, 218, 25, 'PPL', 'P'),
(45809, 'Clarksville Ridge', 39.184440612793, 0.683897504245422, -76.9124984741211, -1.34237633430853, 218, 25, 'PPL', 'P'),
(54064, 'Clarkton', 36.4516716003418, 0.636201687281675, -89.9669418334961, -1.57021935294473, 218, 29, 'PPL', 'P'),
(63707, 'Clarkton', 34.4872207641602, 0.60191555219675, -78.6563873291016, -1.37281293661677, 218, 33, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(100858, 'Clarkton', 36.9830589294434, 0.645476145777876, -78.9061126708984, -1.37717146605679, 218, 53, 'PPL', 'P'),
(72116, 'Clarktown', 38.8505592346191, 0.678070174885192, -82.9113922119141, -1.44707678151028, 218, 41, 'PPL', 'P'),
(85839, 'Clarktown', 35.9330596923828, 0.627150201947741, -85.3099975585938, -1.48894034226579, 218, 50, 'PPL', 'P'),
(93280, 'Clarktown', 31.1719398498535, 0.544052984613571, -93.7636108398438, -1.63648372771392, 218, 51, 'PPL', 'P'),
(147842, 'Clarkville', 43.2433280944824, 0.754738454768884, -74.1233291625977, -1.29369614642686, 218, 40, 'PPL', 'P'),
(169319, 'Clarkville', 41.9222183227539, 0.731680739471951, -71.7916717529297, -1.25300104759963, 218, 47, 'PPL', 'P'),
(194140, 'Clarkville', 40.3950004577637, 0.705025759332593, -102.625556945801, -1.79115386539716, 218, 7, 'PPL', 'P'),
(15547, 'Clarkwild', 28.0508308410645, 0.489579356096545, -82.3197174072266, -1.43675010806739, 218, 12, 'PPL', 'P'),
(93281, 'Clarkwood', 27.7841701507568, 0.484925249065036, -97.539436340332, -1.7023843146782, 218, 51, 'PPL', 'P'),
(26804, 'Clarmin', 38.2211112976074, 0.667084235914452, -89.6994400024414, -1.56555056523771, 218, 18, 'PPL', 'P'),
(173555, 'Clarno', 42.5186080932617, 0.742089704592525, -89.6477813720703, -1.56464895205067, 218, 57, 'PPL', 'P'),
(200582, 'Clarno', 44.9136085510254, 0.783890348167273, -120.472221374512, -2.10263692017672, 218, 43, 'PPL', 'P'),
(63708, 'Clarrissa', 36.0130615234375, 0.628546497307269, -82.1172180175781, -1.43321582698475, 218, 33, 'PPL', 'P'),
(180749, 'Clarsona', 38.3738899230957, 0.669750725955894, -120.982498168945, -2.11154293033611, 218, 6, 'PPL', 'P'),
(100859, 'Clary', 39.0252799987793, 0.681119627491387, -78.3649978637695, -1.3677272310411, 218, 53, 'PPL', 'P'),
(45810, 'Clarys Forest', 39.211669921875, 0.684372745341946, -76.8916702270508, -1.34201281281973, 218, 25, 'PPL', 'P'),
(45811, 'Clarysville', 39.6425018310547, 0.691892180679785, -78.8886108398438, -1.37686600147976, 218, 25, 'PPL', 'P'),
(59019, 'Clarysville', 34.6438903808594, 0.604649952845988, -88.9116668701172, -1.55180133031991, 218, 30, 'PPL', 'P'),
(35258, 'Claryville', 38.9191703796387, 0.679267665269346, -84.3955612182617, -1.4729804173271, 218, 21, 'PPL', 'P'),
(54065, 'Claryville', 37.892219543457, 0.661343991921868, -89.8288879394531, -1.56780985794848, 218, 29, 'PPL', 'P'),
(147843, 'Claryville', 41.9183311462402, 0.731612895443181, -74.5727767944336, -1.30154048741769, 218, 40, 'PPL', 'P'),
(196227, 'Clasoil', 46.563060760498, 0.812678720076866, -111.792778015137, -1.95115205631527, 218, 31, 'PPL', 'P'),
(147844, 'Clason Point', 40.8055610656738, 0.712191393719614, -73.9499969482422, -1.29067092858658, 218, 40, 'PPL', 'P'),
(207050, 'Classet', 48.3866691589355, 0.844506690896621, -124.675559997559, -2.17599901872513, 218, 56, 'PPL', 'P'),
(100860, 'Classic Shore', 38.2616691589355, 0.667792104132195, -76.9744415283203, -1.34345744455305, 218, 53, 'PPL', 'P'),
(141495, 'Clatonia', 40.4652786254883, 0.706252344751656, -96.8494415283203, -1.69034163338692, 218, 35, 'PPL', 'P'),
(200583, 'Clatskanie', 46.101390838623, 0.804621059882722, -123.205558776855, -2.15034265741553, 218, 43, 'PPL', 'P'),
(200584, 'Clatskanie Heights', 46.0561103820801, 0.803830766829241, -123.215827941895, -2.15052188815689, 218, 43, 'PPL', 'P'),
(80349, 'Clatworthy Crossroads', 34.0588912963867, 0.594439792700788, -82.3741683959961, -1.43770045710239, 218, 48, 'PPL', 'P'),
(1600, 'Claud', 32.5788917541504, 0.568608927760755, -86.070556640625, -1.50221460240318, 218, 2, 'PPL', 'P'),
(54067, 'Claud', 37.8133316040039, 0.659967137638297, -93.711669921875, -1.63557718767886, 218, 29, 'PPL', 'P'),
(188325, 'Claud', 34.5941696166992, 0.603782161804786, -103.178611755371, -1.80080649276815, 218, 38, 'PPL', 'P'),
(54066, 'Claud (historical)', 36.7016716003418, 0.640565010411661, -89.7366714477539, -1.56620037654369, 218, 29, 'PPL', 'P'),
(85840, 'Claud (historical)', 36.1797218322754, 0.631455268428881, -87.9483337402344, -1.53498799540991, 218, 50, 'PPL', 'P'),
(8099, 'Claude', 35.4727783203125, 0.619116776519517, -92.6022186279297, -1.616213609709, 218, 4, 'PPL', 'P'),
(108599, 'Claude', 39.2897186279297, 0.685734952239522, -79.9097213745117, -1.39468774233652, 218, 58, 'PPL', 'P'),
(191274, 'Claude', 35.1116714477539, 0.61281427264179, -101.362777709961, -1.76911421000594, 218, 51, 'PPL', 'P'),
(32076, 'Claudell', 39.6624984741211, 0.69224118794064, -99.0288925170898, -1.72838022902679, 218, 20, 'PPL', 'P'),
(100861, 'Claudville', 36.5894393920898, 0.63860618885088, -80.4186096191406, -1.40356951772999, 218, 53, 'PPL', 'P'),
(191275, 'Clauene', 33.461669921875, 0.584016313352272, -102.375556945801, -1.78679054226717, 218, 51, 'PPL', 'P'),
(8100, 'Claunch', 35.8708305358887, 0.626064098276179, -90.4622192382813, -1.57886357436896, 218, 4, 'PPL', 'P'),
(188326, 'Claunch', 34.1419410705566, 0.595889284703091, -105.99388885498, -1.84994234751233, 218, 38, 'PPL', 'P'),
(119155, 'Claus', 41.3697204589844, 0.722037832638937, -87.6100006103516, -1.52908296832488, 218, 18, 'PPL', 'P'),
(180750, 'Claus', 37.6866683959961, 0.657756447617422, -120.918891906738, -2.11043279163571, 218, 6, 'PPL', 'P'),
(130242, 'Clausedale', 43.2924995422363, 0.755596658430162, -84.059440612793, -1.46711400607788, 218, 27, 'PPL', 'P'),
(39798, 'Clausen', 29.7158298492432, 0.518639070831703, -91.4538879394531, -1.59617145829339, 218, 22, 'PPL', 'P'),
(80350, 'Claussen', 34.1308288574219, 0.595695339996706, -79.6311111450195, -1.38982507650214, 218, 48, 'PPL', 'P'),
(180751, 'Claussenius', 38.8466682434082, 0.678002264277395, -120.612777709961, -2.10509009101484, 218, 6, 'PPL', 'P'),
(160129, 'Claussville', 40.6141700744629, 0.708850990764328, -75.654167175293, -1.32041431006308, 218, 45, 'PPL', 'P'),
(147845, 'Claverack', 42.2249984741211, 0.736965250022995, -73.7350006103516, -1.28691853461066, 218, 40, 'PPL', 'P'),
(207052, 'Clavton', 47.996940612793, 0.837704644577422, -117.557220458984, -2.05176055650212, 218, 56, 'PPL', 'P'),
(93282, 'Clawson', 31.4005603790283, 0.548043165585323, -94.7925033569336, -1.65444128978627, 218, 51, 'PPL', 'P'),
(108600, 'Clawson', 38.2683296203613, 0.667908351113777, -80.0302810668945, -1.39679190591379, 218, 58, 'PPL', 'P'),
(130243, 'Clawson', 42.5333290100098, 0.742346633058691, -83.1463928222656, -1.45117831590512, 218, 27, 'PPL', 'P'),
(192519, 'Clawson', 39.1330604553223, 0.683000751327365, -111.096389770508, -1.93899778857431, 218, 52, 'PPL', 'P'),
(194740, 'Clawson', 43.7980613708496, 0.764420376911867, -111.110000610352, -1.93923534254354, 218, 17, 'PPL', 'P'),
(20077, 'Claxton', 32.1613883972168, 0.561322119544135, -81.904167175293, -1.42949738831273, 218, 13, 'PPL', 'P'),
(35259, 'Claxton', 37.1041717529297, 0.647589963314099, -87.76611328125, -1.53180764843614, 218, 21, 'PPL', 'P'),
(85842, 'Claxton', 35.3038902282715, 0.61616912324599, -84.6444396972656, -1.47732416622308, 218, 50, 'PPL', 'P'),
(1601, 'Clay', 33.7024993896484, 0.588219580500745, -86.5997161865234, -1.51145017874746, 218, 2, 'PPL', 'P'),
(8101, 'Clay', 35.396671295166, 0.617788458346813, -91.7861099243164, -1.60196982577676, 218, 4, 'PPL', 'P'),
(35260, 'Clay', 37.4766693115234, 0.6540912721672, -87.8199996948242, -1.5327481437751, 218, 21, 'PPL', 'P'),
(39799, 'Clay', 32.4327812194824, 0.56605881785895, -92.6769409179688, -1.61751775969481, 218, 22, 'PPL', 'P'),
(59021, 'Clay', 34.2700004577637, 0.59812434264794, -88.3372192382813, -1.54177532776409, 218, 30, 'PPL', 'P'),
(63710, 'Clay', 36.2425003051758, 0.632550959480367, -78.5880584716797, -1.37162037308063, 218, 33, 'PPL', 'P'),
(72117, 'Clay', 38.9352798461914, 0.679548828501431, -82.5669403076172, -1.44106496166554, 218, 41, 'PPL', 'P'),
(93283, 'Clay', 30.3891696929932, 0.530391068090005, -96.3433303833008, -1.68150832752529, 218, 51, 'PPL', 'P'),
(100862, 'Clay', 37.3833312988281, 0.652462216528399, -79.2461090087891, -1.38310552159771, 218, 53, 'PPL', 'P'),
(108601, 'Clay', 38.4602813720703, 0.671258541186069, -81.0852813720703, -1.41520513484865, 218, 58, 'PPL', 'P'),
(139081, 'Clay', 40.2275009155273, 0.702102340824985, -92.4522171020508, -1.6135955891994, 218, 29, 'PPL', 'P'),
(147846, 'Clay', 43.1858291625977, 0.753734909091115, -76.1727828979492, -1.32946586197604, 218, 40, 'PPL', 'P'),
(160131, 'Clay', 40.2183303833008, 0.701942284843472, -76.2558288574219, -1.33091528739932, 218, 45, 'PPL', 'P'),
(180752, 'Clay', 38.336109161377, 0.66909132726999, -121.158332824707, -2.11461182401826, 218, 6, 'PPL', 'P'),
(85843, 'Clay (historical)', 35.1474990844727, 0.61343958286574, -89.8177795410156, -1.56761597982112, 218, 50, 'PPL', 'P'),
(13556, 'Clay Acres', 39.5930595397949, 0.691029249907572, -75.7125015258789, -1.32143243654782, 218, 10, 'PPL', 'P'),
(100863, 'Clay Bank', 37.3474998474121, 0.651836839725421, -76.607780456543, -1.33705800161164, 218, 53, 'PPL', 'P'),
(32078, 'Clay Center', 39.3769416809082, 0.687257281697639, -97.1244430541992, -1.69514131546151, 218, 20, 'PPL', 'P'),
(141497, 'Clay Center', 40.521671295166, 0.707236582511522, -98.0550003051758, -1.71138260336936, 218, 35, 'PPL', 'P'),
(154746, 'Clay Center', 41.5633316040039, 0.725416984588084, -83.3619384765625, -1.45494029726096, 218, 41, 'PPL', 'P'),
(1602, 'Clay City', 30.485559463501, 0.532073386950608, -87.8066711425781, -1.53251551665388, 218, 2, 'PPL', 'P'),
(26805, 'Clay City', 38.6886100769043, 0.675243628862237, -88.3541717529297, -1.54207120496119, 218, 18, 'PPL', 'P'),
(29486, 'Clay City', 38.0825004577637, 0.664665020380224, -86.9516677856445, -1.51759289295978, 218, 19, 'PPL', 'P'),
(35261, 'Clay City', 37.8591690063477, 0.660767151229757, -83.9186096191406, -1.46465604154979, 218, 21, 'PPL', 'P'),
(207053, 'Clay City', 46.9258308410645, 0.819010252410475, -122.254722595215, -2.13374743539881, 218, 56, 'PPL', 'P'),
(100864, 'Clay Estates', 37.2077789306641, 0.649398249694263, -77.5569381713867, -1.35362392885637, 218, 53, 'PPL', 'P'),
(20079, 'Clay Hill', 33.6644401550293, 0.587555321545852, -82.4444427490234, -1.43892697594242, 218, 13, 'PPL', 'P'),
(78039, 'Clay Hill', 39.8197212219238, 0.69498524254883, -77.6750030517578, -1.35568454974982, 218, 45, 'PPL', 'P'),
(85846, 'Clay Hill', 36.5597190856934, 0.63808747164956, -84.4313888549805, -1.47360572755105, 218, 50, 'PPL', 'P'),
(127117, 'Clay Hill', 43.2194404602051, 0.754321536900232, -70.6430587768555, -1.23295396933601, 218, 26, 'PPL', 'P'),
(192520, 'Clay Hills Crossing', 37.2944412231445, 0.650910792035373, -110.404167175293, -1.92691622513111, 218, 52, 'PPL', 'P'),
(15549, 'Clay Island', 28.663610458374, 0.500274378007708, -81.6961135864258, -1.4258661681664, 218, 12, 'PPL', 'P'),
(108603, 'Clay Junction', 38.4747200012207, 0.671510542804218, -81.0777816772461, -1.41507424048107, 218, 58, 'PPL', 'P'),
(15550, 'Clay Landing', 29.7744407653809, 0.519662024295916, -81.5619430541992, -1.4235244506199, 218, 12, 'PPL', 'P'),
(114989, 'Clay Mills', 42.1841697692871, 0.736252654694317, -90.9430618286133, -1.58725586075408, 218, 16, 'PPL', 'P'),
(170032, 'Clay Point', 42.9097213745117, 0.748915919098616, -96.9027786254883, -1.69127254134596, 218, 49, 'PPL', 'P'),
(160132, 'Clay Ridge', 40.502498626709, 0.706901956320554, -75.1158294677734, -1.31101854457923, 218, 45, 'PPL', 'P'),
(15551, 'Clay Sink', 28.4722194671631, 0.496933975052421, -82.0669403076172, -1.43233831540557, 218, 12, 'PPL', 'P'),
(177953, 'Clay Springs', 34.3616714477539, 0.599724303251832, -110.294723510742, -1.92500607283925, 218, 5, 'PPL', 'P'),
(209368, 'Clay Spur', 44.0224990844727, 0.768337553980237, -104.475830078125, -1.82344722361741, 218, 59, 'PPL', 'P'),
(35263, 'Clay Village', 38.1925010681152, 0.666584893210062, -85.1072235107422, -1.48540126749318, 218, 21, 'PPL', 'P'),
(39800, 'Claybank', 30.3386096954346, 0.529508629662807, -90.8630599975586, -1.58585956539455, 218, 22, 'PPL', 'P'),
(134691, 'Claybank', 44.4416694641113, 0.775653457231767, -92.6316680908203, -1.61672759979938, 218, 28, 'PPL', 'P'),
(72123, 'Claybank (historical)', 39.6755599975586, 0.692469154529951, -82.1841735839844, -1.43438442207108, 218, 41, 'PPL', 'P'),
(100865, 'Claybank Landing', 37.2649993896484, 0.650396935103043, -76.8600006103516, -1.34146007373549, 218, 53, 'PPL', 'P'),
(20082, 'Claybed', 32.5169410705566, 0.567527684358183, -83.5980606079102, -1.4590614058898, 218, 13, 'PPL', 'P'),
(1609, 'Clayborn', 34.1055603027344, 0.595254320520189, -86.2583312988281, -1.50549188844063, 218, 2, 'PPL', 'P'),
(85848, 'Claybrook', 35.7083282470703, 0.623227898294272, -88.6341705322266, -1.54695810556149, 218, 50, 'PPL', 'P'),
(147848, 'Clayburg', 44.5963897705078, 0.77835383599808, -73.8386077880859, -1.28872682099083, 218, 40, 'PPL', 'P'),
(54080, 'Claycomo', 39.2024993896484, 0.684212689360433, -94.4922180175781, -1.64920032191905, 218, 29, 'PPL', 'P'),
(20083, 'Clayfields', 32.8536109924316, 0.573403682987334, -83.2513885498047, -1.4530108370512, 218, 13, 'PPL', 'P'),
(78037, 'Clayford', 39.894718170166, 0.696294186224604, -79.7752838134766, -1.3923413642581, 218, 45, 'PPL', 'P'),
(1604, 'Clayhatchee', 31.235559463501, 0.545163356340566, -85.7227783203125, -1.49614472564667, 218, 2, 'PPL', 'P'),
(1605, 'Clayhill', 32.0163917541504, 0.558791450718287, -87.7505569458008, -1.531536139163, 218, 2, 'PPL', 'P'),
(35264, 'Clayhole', 37.4672203063965, 0.653926355916697, -83.2975006103516, -1.45381564433262, 218, 21, 'PPL', 'P'),
(78038, 'Claylick', 39.7666702270508, 0.694059328016837, -77.8938903808594, -1.35950485433354, 218, 45, 'PPL', 'P'),
(85847, 'Claylick', 36.1586112976074, 0.631086820092069, -87.2169418334961, -1.52222279851489, 218, 50, 'PPL', 'P'),
(154751, 'Claylick', 40.0583305358887, 0.699149760703442, -82.2872161865234, -1.43618285475521, 218, 41, 'PPL', 'P'),
(13549, 'Claymont', 39.8005599975586, 0.694650816094944, -75.4599990844727, -1.31702543757595, 218, 10, 'PPL', 'P'),
(13550, 'Claymont Addition', 39.7986106872559, 0.694616794212018, -75.470832824707, -1.31721452201335, 218, 10, 'PPL', 'P'),
(13551, 'Claymont Heights', 39.7958297729492, 0.694568258101151, -75.470832824707, -1.31721452201335, 218, 10, 'PPL', 'P'),
(100866, 'Claymont Manor', 38.0783309936523, 0.664592249503437, -78.9555587768555, -1.37803446340803, 218, 53, 'PPL', 'P'),
(35266, 'Claymour', 36.8866691589355, 0.643793826917273, -87.1113891601563, -1.52038055683082, 218, 21, 'PPL', 'P'),
(15552, 'Clayno', 29.9061107635498, 0.521960099290059, -82.2502822875977, -1.43553823661335, 218, 12, 'PPL', 'P'),
(35265, 'Claypool', 36.9058303833008, 0.64412825337116, -86.2408294677734, -1.5051864238636, 218, 21, 'PPL', 'P'),
(108607, 'Claypool', 37.8327789306641, 0.660306557519227, -80.8708267211914, -1.4114621950946, 218, 58, 'PPL', 'P'),
(119156, 'Claypool', 41.3458290100098, 0.721620848191258, -88.3872222900391, -1.5426480456533, 218, 18, 'PPL', 'P'),
(122385, 'Claypool', 41.1291694641113, 0.717839425759454, -85.8805618286133, -1.49889856737186, 218, 19, 'PPL', 'P'),
(177954, 'Claypool', 33.4111099243164, 0.583133874925075, -110.841941833496, -1.93455683429855, 218, 5, 'PPL', 'P'),
(100867, 'Claypool Hill', 37.0625, 0.646862654020398, -81.7519378662109, -1.42684048565121, 218, 53, 'PPL', 'P'),
(119157, 'Claypool Woods', 41.3441696166992, 0.721591886314403, -88.4000015258789, -1.5428710853946, 218, 18, 'PPL', 'P'),
(160136, 'Claypoole Heights', 40.6213912963867, 0.708977024862916, -79.1930618286133, -1.38217967364474, 218, 45, 'PPL', 'P'),
(154752, 'Claypools (historical)', 40.0400009155273, 0.698829848477496, -82.1699981689453, -1.43413701440581, 218, 41, 'PPL', 'P'),
(63714, 'Clayroot', 35.3713912963867, 0.617347239133214, -77.2483291625977, -1.34823768555168, 218, 33, 'PPL', 'P'),
(100868, 'Clays Corner', 37.1961097717285, 0.649194584449899, -77.9630584716797, -1.36071206525567, 218, 53, 'PPL', 'P'),
(191276, 'Clays Corner', 34.3858299255371, 0.600145948231419, -102.716110229492, -1.79273431834607, 218, 51, 'PPL', 'P'),
(130247, 'Clays Landing', 42.5516700744629, 0.742666745021718, -82.6044387817383, -1.44171943350343, 218, 27, 'PPL', 'P'),
(100869, 'Clays Mill', 36.8263893127441, 0.642741745128637, -78.8683319091797, -1.37651206737089, 218, 53, 'PPL', 'P'),
(112297, 'Clays Prairie', 39.686939239502, 0.692667759768243, -87.5633316040039, -1.52826844050548, 218, 18, 'PPL', 'P'),
(203435, 'Clays Ranchettes', 41.1958312988281, 0.719002894260683, -112.047500610352, -1.95559780428099, 218, 52, 'PPL', 'P'),
(160137, 'Claysburg', 40.2966690063477, 0.703309551747118, -78.4499969482422, -1.36921074492633, 218, 45, 'PPL', 'P'),
(72129, 'Claysburg (historical)', 39.6263885498047, 0.691610950868673, -84.7597198486328, -1.47933618442663, 218, 41, 'PPL', 'P'),
(1607, 'Claysville', 34.4077796936035, 0.600529043954227, -86.2719421386719, -1.50572944240986, 218, 2, 'PPL', 'P'),
(26808, 'Claysville', 39.8672218322754, 0.695814284596172, -89.9002838134766, -1.56905595102253, 218, 18, 'PPL', 'P'),
(29497, 'Claysville', 38.622501373291, 0.67408981431996, -86.289436340332, -1.50603477382884, 218, 19, 'PPL', 'P'),
(35267, 'Claysville', 38.5191688537598, 0.672286321629758, -84.1852798461914, -1.46931031502887, 218, 21, 'PPL', 'P'),
(45812, 'Claysville', 39.1938896179199, 0.684062420495925, -77.1247177124023, -1.34608025875261, 218, 25, 'PPL', 'P'),
(54083, 'Claysville', 38.6613883972168, 0.674768520923766, -92.2591705322266, -1.61022629094628, 218, 29, 'PPL', 'P'),
(72125, 'Claysville', 39.9361114501953, 0.697016635249316, -81.6705627441406, -1.42542022184187, 218, 41, 'PPL', 'P'),
(85850, 'Claysville', 35.9691696166992, 0.627780439019708, -85.1494369506836, -1.48613803100875, 218, 50, 'PPL', 'P'),
(108609, 'Claysville', 39.3488883972168, 0.686767659531227, -79.0566711425781, -1.37979920710438, 218, 58, 'PPL', 'P'),
(160138, 'Claysville', 40.1177787780762, 0.700187328264137, -80.4105606079102, -1.40342903598249, 218, 45, 'PPL', 'P'),
(608, 'Clayton', 39.4502792358398, 0.688537263496558, -76.3550033569336, -1.33264620894981, 218, 25, 'PPL', 'P'),
(1608, 'Clayton', 31.878059387207, 0.556377095453049, -85.4497222900391, -1.49137899887597, 218, 2, 'PPL', 'P'),
(13555, 'Clayton', 39.2905616760254, 0.685749666204545, -75.6347198486328, -1.32007489018215, 218, 10, 'PPL', 'P'),
(20084, 'Clayton', 34.878059387207, 0.608736973012879, -83.4011077880859, -1.45562393071278, 218, 13, 'PPL', 'P'),
(29498, 'Clayton', 39.6891708374023, 0.692706708499186, -86.5224990844727, -1.51010248607783, 218, 19, 'PPL', 'P'),
(39801, 'Clayton', 31.7224998474121, 0.55366206930074, -91.5430603027344, -1.59772780963443, 218, 22, 'PPL', 'P'),
(54082, 'Clayton', 38.6425018310547, 0.674438888159842, -90.3236083984375, -1.57644435883474, 218, 29, 'PPL', 'P'),
(59023, 'Clayton', 34.5999984741211, 0.603883894558427, -90.416389465332, -1.57806369393556, 218, 30, 'PPL', 'P'),
(63715, 'Clayton', 35.6505584716797, 0.622219625505568, -78.456672668457, -1.36932725822402, 218, 33, 'PPL', 'P'),
(70668, 'Clayton', 39.6599998474121, 0.69219757867779, -75.0924987792969, -1.31061134724855, 218, 37, 'PPL', 'P'),
(75460, 'Clayton', 34.5894393920898, 0.603699603810994, -95.3525009155273, -1.66421509098686, 218, 42, 'PPL', 'P'),
(80351, 'Clayton', 34.4877815246582, 0.601925339313756, -81.4191665649414, -1.42103253078791, 218, 48, 'PPL', 'P'),
(85849, 'Clayton', 36.459171295166, 0.636332581649252, -89.2386093139648, -1.55750755242956, 218, 50, 'PPL', 'P'),
(93285, 'Clayton', 32.0980606079102, 0.560216841112725, -94.4747161865234, -1.64889485734202, 218, 51, 'PPL', 'P'),
(108608, 'Clayton', 37.723331451416, 0.658396338648341, -80.7291717529297, -1.40898984949663, 218, 58, 'PPL', 'P'),
(115001, 'Clayton', 42.9038887023926, 0.748814119765948, -91.147216796875, -1.59081903713455, 218, 16, 'PPL', 'P'),
(119158, 'Clayton', 40.0313911437988, 0.698679579612988, -90.960563659668, -1.58756132533111, 218, 18, 'PPL', 'P'),
(124531, 'Clayton', 42.0430603027344, 0.733789829897239, -73.2874984741211, -1.27910814892373, 218, 23, 'PPL', 'P'),
(130248, 'Clayton', 41.8633308410645, 0.730652959028262, -84.2363891601563, -1.47020234083599, 218, 27, 'PPL', 'P'),
(147849, 'Clayton', 44.2394409179688, 0.772123903260057, -76.0861129760742, -1.32795318647688, 218, 40, 'PPL', 'P'),
(154753, 'Clayton', 40.1508293151855, 0.700764168956248, -84.3755569458008, -1.47263127690819, 218, 41, 'PPL', 'P'),
(160140, 'Clayton', 40.4180603027344, 0.705428229552331, -75.5738906860352, -1.31901322101359, 218, 45, 'PPL', 'P'),
(170033, 'Clayton', 43.4436111450195, 0.758234053436695, -97.6575012207031, -1.70444493557165, 218, 49, 'PPL', 'P'),
(173558, 'Clayton', 45.3313903808594, 0.791182016652882, -92.1711120605469, -1.6086893806812, 218, 57, 'PPL', 'P'),
(180754, 'Clayton', 38.9080581665039, 0.679073720562961, -121.311111450195, -2.1172783140597, 218, 6, 'PPL', 'P'),
(187624, 'Clayton', 39.7374992370605, 0.693550198195441, -100.177223205566, -1.7484223804424, 218, 20, 'PPL', 'P'),
(188327, 'Clayton', 36.4516716003418, 0.636201687281675, -103.183609008789, -1.80089371129385, 218, 38, 'PPL', 'P'),
(194741, 'Clayton', 44.2594413757324, 0.772472977099939, -114.400833129883, -1.99667120514106, 218, 17, 'PPL', 'P'),
(207054, 'Clayton', 47.9958305358887, 0.837685270080492, -117.558326721191, -2.05177986442002, 218, 56, 'PPL', 'P'),
(209369, 'Clayton', 42.853889465332, 0.747941468455756, -105.751106262207, -1.84570499190191, 218, 59, 'PPL', 'P'),
(8107, 'Clayton (historical)', 33.6261100769043, 0.586886335480024, -93.4397201538086, -1.63083076882606, 218, 4, 'PPL', 'P'),
(39802, 'Clayton (historical)', 32.8633308410645, 0.573573326348772, -92.5447235107422, -1.61521013061026, 218, 22, 'PPL', 'P'),
(180755, 'Clayton (historical)', 34.0299987792969, 0.593935523148382, -118.025001525879, -2.05992487629792, 218, 6, 'PPL', 'P'),
(115002, 'Clayton Center', 42.8833312988281, 0.748455325388087, -91.3266677856445, -1.59395104773454, 218, 16, 'PPL', 'P'),
(147850, 'Clayton Center', 44.1916694641113, 0.771290134101781, -76.0425033569336, -1.32719205503733, 218, 40, 'PPL', 'P'),
(127118, 'Clayton Lake', 46.6108283996582, 0.813512422656115, -69.5227813720703, -1.21340144008681, 218, 26, 'PPL', 'P'),
(20086, 'Clayton Manor', 33.5963897705078, 0.586367618278703, -84.371940612793, -1.47256815999036, 218, 13, 'PPL', 'P'),
(45813, 'Clayton Manor', 39.4472198486328, 0.688483867116702, -76.3380584716797, -1.33235046491076, 218, 25, 'PPL', 'P'),
(20087, 'Clayton Ridge', 33.5133285522461, 0.584917926539319, -84.4191665649414, -1.47339240834774, 218, 13, 'PPL', 'P'),
(20088, 'Clayton Ridge North', 33.521671295166, 0.585063534871919, -84.4102783203125, -1.47323727921424, 218, 13, 'PPL', 'P'),
(45814, 'Clayton Run Estates', 38.5897216796875, 0.673517700738783, -76.7986068725586, -1.34038855087089, 218, 25, 'PPL', 'P'),
(8110, 'Clayton Spur (historical)', 34.4736099243164, 0.601677998227514, -94.3772201538086, -1.64719323056351, 218, 4, 'PPL', 'P'),
(59024, 'Clayton Village', 33.4738883972168, 0.584229565976561, -88.7558288574219, -1.54908144389861, 218, 30, 'PPL', 'P'),
(160141, 'Claytonia', 41.0097198486328, 0.715754636679113, -79.9672164916992, -1.39569122143526, 218, 45, 'PPL', 'P'),
(194742, 'Claytonia', 43.5675010681152, 0.760396340504757, -116.831939697266, -2.03910201920875, 218, 17, 'PPL', 'P'),
(145013, 'Claytons Corner', 40.3286094665527, 0.703867017942299, -74.2869415283203, -1.2965517209057, 218, 37, 'PPL', 'P'),
(100870, 'Claytonville', 39.0913887023926, 0.682273442033664, -78.0219421386719, -1.36173977912033, 218, 53, 'PPL', 'P'),
(119161, 'Claytonville', 40.5669403076172, 0.708026675827921, -87.8230590820313, -1.53280154015495, 218, 18, 'PPL', 'P'),
(191278, 'Claytonville', 34.3752784729004, 0.59996179064204, -101.574440002441, -1.77280841391204, 218, 51, 'PPL', 'P'),
(59025, 'Claytown', 32.976390838623, 0.575546595558466, -88.9663925170898, -1.55275647304486, 218, 30, 'PPL', 'P'),
(70667, 'Clayville', 39.4333305358887, 0.688241452878477, -75.0311126708984, -1.30953995754201, 218, 37, 'PPL', 'P'),
(100871, 'Clayville', 37.4597206115723, 0.65379546154912, -77.8172225952148, -1.35816674904383, 218, 53, 'PPL', 'P'),
(147852, 'Clayville', 42.9799995422363, 0.75014250451768, -75.2513885498047, -1.31338449689165, 218, 40, 'PPL', 'P'),
(169320, 'Clayville', 41.7777786254883, 0.729159791184081, -71.6761093139648, -1.25098410254806, 218, 47, 'PPL', 'P'),
(177605, 'Clayville', 41.6172218322754, 0.726357546506073, -71.9780578613281, -1.25625409887116, 218, 8, 'PPL', 'P'),
(35268, 'Claywell', 36.8186111450195, 0.64260599049207, -85.2900009155273, -1.48859133500493, 218, 21, 'PPL', 'P'),
(207055, 'Cle Elum', 47.1955604553223, 0.823717922269408, -120.938056945801, -2.11076728466862, 218, 56, 'PPL', 'P'),
(45815, 'Clear Acres', 39.4455604553223, 0.688454905239847, -76.3755569458008, -1.33300493674865, 218, 25, 'PPL', 'P'),
(59026, 'Clear Branch', 32.0750007629395, 0.559814370892987, -90.1930618286133, -1.57416589136412, 218, 30, 'PPL', 'P'),
(100872, 'Clear Brook', 39.2563896179199, 0.685153251278421, -78.0963897705078, -1.36303913541618, 218, 53, 'PPL', 'P'),
(29500, 'Clear Creek', 39.1091690063477, 0.682583766879686, -86.5400009155273, -1.51040795065486, 218, 19, 'PPL', 'P'),
(63718, 'Clear Creek', 35.2019386291504, 0.614389732163653, -80.6002807617188, -1.40674027732384, 218, 33, 'PPL', 'P'),
(108610, 'Clear Creek', 37.9161109924316, 0.661760976369547, -81.3444366455078, -1.41972824764404, 218, 58, 'PPL', 'P'),
(147854, 'Clear Creek', 42.2208290100098, 0.736892479146208, -79.0605621337891, -1.37986711771217, 218, 40, 'PPL', 'P'),
(177955, 'Clear Creek', 34.5219383239746, 0.60252148792377, -111.817779541016, -1.95158841525988, 218, 5, 'PPL', 'P'),
(192521, 'Clear Creek', 39.6458282470703, 0.691950237591549, -111.151672363281, -1.93996265183724, 218, 52, 'PPL', 'P'),
(192961, 'Clear Creek', 35.9394416809082, 0.627261588660333, -100.325561523438, -1.75101137249612, 218, 51, 'PPL', 'P'),
(193454, 'Clear Creek', 41.7094383239746, 0.727967027910862, -123.449172973633, -2.15459452725389, 218, 6, 'PPL', 'P'),
(200586, 'Clear Creek', 45.8061103820801, 0.799467443699255, -123.278327941895, -2.15161271893938, 218, 43, 'PPL', 'P'),
(63720, 'Clear Creek (historical)', 35.2019386291504, 0.614389732163653, -80.5991668701172, -1.40672083624788, 218, 33, 'PPL', 'P'),
(100874, 'Clear Creek (historical)', 36.9366683959961, 0.644666478227465, -82.5905609130859, -1.44147721900228, 218, 53, 'PPL', 'P'),
(1610, 'Clear Creek Estates', 33.4477806091309, 0.583773899114048, -86.283332824707, -1.50592824738524, 218, 2, 'PPL', 'P'),
(35269, 'Clear Creek Furnace', 38.0499992370605, 0.664097767068037, -83.5891723632813, -1.45890627675631, 218, 21, 'PPL', 'P'),
(115006, 'Clear Creek Mobile Home Park', 41.7027816772461, 0.727850847508308, -91.6638870239258, -1.59983663374361, 218, 16, 'PPL', 'P'),
(211760, 'Clear Creek Park', 64.8186111450195, 1.13129818105048, -147.565826416016, -2.5755095343859, 218, 1, 'PPL', 'P'),
(35270, 'Clear Creek Springs', 36.7269401550293, 0.641006029888178, -83.726936340332, -1.46131071174649, 218, 21, 'PPL', 'P'),
(196228, 'Clear Creek Terrace Trailer Court', 48.5463905334473, 0.847294354767661, -109.662216186523, -1.91396673748865, 218, 31, 'PPL', 'P'),
(100873, 'Clear Fork', 37.2119407653809, 0.649470887412995, -81.1875, -1.4169891864629, 218, 53, 'PPL', 'P'),
(108611, 'Clear Fork', 37.6308288574219, 0.656781863816507, -81.6830596923828, -1.42563833473515, 218, 58, 'PPL', 'P'),
(108618, 'Clear Fork Junction', 37.4488906860352, 0.653606443690751, -81.7399978637695, -1.42663209329591, 218, 58, 'PPL', 'P'),
(8115, 'Clear Lake', 35.8633308410645, 0.625933203908602, -89.8733291625977, -1.56858550361597, 218, 4, 'PPL', 'P'),
(93286, 'Clear Lake', 33.0780601501465, 0.577321059792786, -96.495002746582, -1.68415550964883, 218, 51, 'PPL', 'P'),
(115010, 'Clear Lake', 43.1380615234375, 0.752901206511865, -93.3791732788086, -1.62977402650552, 218, 16, 'PPL', 'P'),
(119162, 'Clear Lake', 40.0505599975586, 0.69901413922493, -90.3088912963867, -1.5761874969476, 218, 18, 'PPL', 'P'),
(122386, 'Clear Lake', 41.7374992370605, 0.728456783235328, -84.8333282470703, -1.48062089333649, 218, 19, 'PPL', 'P'),
(134694, 'Clear Lake', 45.4449996948242, 0.793164873242501, -93.9986114501953, -1.64058526210875, 218, 28, 'PPL', 'P'),
(170035, 'Clear Lake', 44.7458305358887, 0.780962069390676, -96.6822204589844, -1.6874230751483, 218, 49, 'PPL', 'P'),
(173564, 'Clear Lake', 45.2519416809082, 0.789795375252305, -92.271110534668, -1.61043468330158, 218, 57, 'PPL', 'P'),
(190967, 'Clear Lake', 36.6888885498047, 0.640341904091339, -100.271667480469, -1.75007074399911, 218, 42, 'PPL', 'P'),
(192522, 'Clear Lake', 39.1183280944824, 0.682743623124118, -112.736671447754, -1.96762610450239, 218, 52, 'PPL', 'P'),
(200587, 'Clear Lake', 45.0355606079102, 0.786018813089491, -123.019721984863, -2.14709919352392, 218, 43, 'PPL', 'P'),
(207056, 'Clear Lake', 48.4644393920898, 0.845864037525207, -122.232780456543, -2.13336447283405, 218, 56, 'PPL', 'P'),
(39803, 'Clear Lake (historical)', 31.8816699981689, 0.556440112502343, -92.9613876342773, -1.62248229144088, 218, 22, 'PPL', 'P'),
(93287, 'Clear Lake City', 29.5550003051758, 0.515832065753246, -95.1149978637695, -1.66006988075015, 218, 51, 'PPL', 'P'),
(8116, 'Clear Lake Junction', 33.5208282470703, 0.585048820906896, -93.9236068725586, -1.63927618527492, 218, 4, 'PPL', 'P'),
(180756, 'Clear Lake Keys', 39.0208282470703, 0.681041929766584, -122.661392211914, -2.14084515917803, 218, 6, 'PPL', 'P'),
(180757, 'Clear Lake Riviera', 38.9541702270508, 0.679878527844383, -122.719718933105, -2.14186315250471, 218, 6, 'PPL', 'P'),
(93288, 'Clear Lake Shores', 29.5472202301025, 0.515696277827166, -95.0319366455078, -1.65862018901077, 218, 51, 'PPL', 'P'),
(8118, 'Clear Point', 36.2955589294434, 0.633477007170415, -94.0102767944336, -1.64078886077409, 218, 4, 'PPL', 'P'),
(80353, 'Clear Pond', 33.188060760498, 0.579240932622624, -81.029167175293, -1.41422575735778, 218, 48, 'PPL', 'P'),
(45816, 'Clear Ridge', 39.5827789306641, 0.690849819429128, -77.1247177124023, -1.34608025875261, 218, 25, 'PPL', 'P'),
(160142, 'Clear Ridge', 40.089168548584, 0.699687985559747, -77.9952774047852, -1.36127439171984, 218, 45, 'PPL', 'P'),
(63721, 'Clear Run', 34.7558288574219, 0.606603647821671, -78.2874984741211, -1.36637461152345, 218, 33, 'PPL', 'P'),
(160143, 'Clear Run', 41.1375007629395, 0.717984834354973, -78.754997253418, -1.37453400447123, 218, 45, 'PPL', 'P'),
(8119, 'Clear Spring', 34.0708312988281, 0.594648185056087, -93.3819427490234, -1.6298223628793, 218, 4, 'PPL', 'P'),
(29502, 'Clear Spring', 38.9249992370605, 0.679369398022987, -86.2099990844727, -1.50464833216535, 218, 19, 'PPL', 'P'),
(45817, 'Clear Spring', 39.6561088562012, 0.692129668069993, -77.9319381713867, -1.36016891355135, 218, 25, 'PPL', 'P'),
(160150, 'Clear Spring', 40.3330612182617, 0.703944715667102, -76.5483322143555, -1.33602043405094, 218, 45, 'PPL', 'P'),
(45818, 'Clear Spring Estates', 39.5733299255371, 0.690684903178625, -76.4658279418945, -1.33458046284954, 218, 25, 'PPL', 'P'),
(1616, 'Clear Springs', 33.8633308410645, 0.591026618868715, -86.5641708374023, -1.51082979537153, 218, 2, 'PPL', 'P'),
(15554, 'Clear Springs', 30.9797191619873, 0.540698100719857, -86.3452835083008, -1.50700949078781, 218, 12, 'PPL', 'P'),
(35271, 'Clear Springs', 36.8277816772461, 0.642766046473584, -88.5386123657227, -1.54529030092883, 218, 21, 'PPL', 'P'),
(54087, 'Clear Springs', 37.1083297729492, 0.647662534453804, -91.8502807617188, -1.6030898181732, 218, 29, 'PPL', 'P'),
(59027, 'Clear Springs', 32.1438903808594, 0.56101672154613, -89.3438873291016, -1.55934500042366, 218, 30, 'PPL', 'P'),
(80352, 'Clear Springs', 34.121940612793, 0.595540210863209, -80.9266662597656, -1.41243677889551, 218, 48, 'PPL', 'P'),
(85852, 'Clear Springs', 35.4622192382813, 0.618932485772083, -84.7649993896484, -1.47942832980035, 218, 50, 'PPL', 'P'),
(93290, 'Clear Springs', 31.4672203063965, 0.549206600797038, -94.3869400024414, -1.64736287392495, 218, 51, 'PPL', 'P'),
(160145, 'Clear Springs', 40.0041694641113, 0.698204471674518, -76.7361068725586, -1.3392977200884, 218, 45, 'PPL', 'P'),
(1612, 'Clear Springs (historical)', 33.9813919067383, 0.593087173183137, -86.2680587768555, -1.50566166496012, 218, 2, 'PPL', 'P'),
(85853, 'Clear Springs (historical)', 36.291389465332, 0.633404236293628, -83.5927810668945, -1.45896926051609, 218, 50, 'PPL', 'P'),
(45819, 'Clear View', 39.4000015258789, 0.687659751917377, -77.3775024414063, -1.35049218457249, 218, 25, 'PPL', 'P'),
(160146, 'Clear View', 40.0063896179199, 0.698243220668379, -76.6936111450195, -1.33855602972481, 218, 45, 'PPL', 'P'),
(8120, 'Clear Water (historical)', 35.3413887023926, 0.616823595083877, -91.6425018310547, -1.59946339171684, 218, 4, 'PPL', 'P'),
(45821, 'Clear Water Beach', 39.166389465332, 0.683582452288465, -76.5274963378906, -1.33565677940409, 218, 25, 'PPL', 'P'),
(85854, 'Clearbranch', 36.0541687011719, 0.629263952904937, -82.5163879394531, -1.4401826563964, 218, 50, 'PPL', 'P'),
(100875, 'Clearbrook', 37.1991691589355, 0.649247980829755, -79.9438934326172, -1.39528415726264, 218, 53, 'PPL', 'P'),
(134697, 'Clearbrook', 47.6919403076172, 0.832381385032517, -95.4308319091797, -1.66558222473245, 218, 28, 'PPL', 'P'),
(145001, 'Clearbrook', 40.3138885498047, 0.703610089476134, -74.4680633544922, -1.29971289311962, 218, 37, 'PPL', 'P'),
(207057, 'Clearbrook', 48.978889465332, 0.854842885140409, -122.321113586426, -2.1349061767891, 218, 56, 'PPL', 'P'),
(145002, 'Clearbrook Park', 40.3097190856934, 0.703537318599347, -74.4649963378906, -1.29965936358171, 218, 37, 'PPL', 'P'),
(108612, 'Clearco', 38.0933303833008, 0.664854038238592, -80.5694427490234, -1.40620205246753, 218, 58, 'PPL', 'P'),
(13564, 'Clearfield', 39.7319412231445, 0.693453192552735, -75.5944366455078, -1.31937181565437, 218, 10, 'PPL', 'P'),
(32089, 'Clearfield', 38.8261108398438, 0.677643469899534, -95.0933303833008, -1.65969171187536, 218, 20, 'PPL', 'P'),
(35272, 'Clearfield', 38.1619415283203, 0.666051528622746, -83.4288864135742, -1.45610875918923, 218, 21, 'PPL', 'P'),
(45822, 'Clearfield', 39.5494384765625, 0.690267918730946, -76.9533309936523, -1.34308899621623, 218, 25, 'PPL', 'P'),
(115014, 'Clearfield', 40.8008308410645, 0.712108835725822, -94.4755630493164, -1.64890963788607, 218, 16, 'PPL', 'P'),
(160148, 'Clearfield', 40.8008308410645, 0.712108835725822, -75.3472213745117, -1.31505709521428, 218, 45, 'PPL', 'P'),
(202012, 'Clearfield', 43.1683311462402, 0.75342951109311, -100.027778625488, -1.74581408047078, 218, 49, 'PPL', 'P'),
(203436, 'Clearfield', 41.1108283996582, 0.717519313796427, -112.025283813477, -1.95521004802628, 218, 52, 'PPL', 'P'),
(160151, 'Clearfield Junction', 41.0011100769043, 0.715604367814605, -78.3974990844727, -1.36829448435329, 218, 45, 'PPL', 'P'),
(119163, 'Clearing', 41.7780609130859, 0.729164718032098, -87.7616729736328, -1.53173015044842, 218, 18, 'PPL', 'P'),
(180758, 'Clearing House', 37.6650009155273, 0.657378278742631, -119.866386413574, -2.09206310538467, 218, 6, 'PPL', 'P'),
(180759, 'Clearlake', 38.9583282470703, 0.679951098984088, -122.625282287598, -2.14021492210606, 218, 6, 'PPL', 'P'),
(180760, 'Clearlake Highlands', 38.9555587768555, 0.679902762610303, -122.641670227051, -2.14050094560714, 218, 6, 'PPL', 'P'),
(180761, 'Clearlake Oaks', 39.0263900756836, 0.681139001988318, -122.670829772949, -2.14100987569145, 218, 6, 'PPL', 'P'),
(180762, 'Clearlake Park', 38.9666709899902, 0.680096707316688, -122.650001525879, -2.14064635420266, 218, 6, 'PPL', 'P'),
(59028, 'Clearman', 32.9647216796875, 0.575342930314102, -88.6569366455078, -1.54735544919613, 218, 30, 'PPL', 'P'),
(80354, 'Clearmont', 34.6691703796387, 0.605091172059587, -83.0605621337891, -1.44968028779195, 218, 48, 'PPL', 'P'),
(85855, 'Clearmont', 35.7252807617188, 0.62352377549138, -85.982780456543, -1.50068261898611, 218, 50, 'PPL', 'P'),
(139089, 'Clearmont', 40.5097198486328, 0.707027990419142, -95.0319366455078, -1.65862018901077, 218, 29, 'PPL', 'P'),
(209370, 'Clearmont', 44.6402816772461, 0.779119894285641, -106.380279541016, -1.85668613718268, 218, 59, 'PPL', 'P'),
(72132, 'Clearport', 39.622501373291, 0.691543106839903, -82.6802825927734, -1.44304315772325, 218, 41, 'PPL', 'P'),
(45823, 'Clearspring Manor', 39.2724990844727, 0.685434414510507, -77.2063903808594, -1.34750571572608, 218, 25, 'PPL', 'P'),
(1614, 'Clearview', 32.0430603027344, 0.559256904697806, -86.3880615234375, -1.50775610799941, 218, 2, 'PPL', 'P'),
(20091, 'Clearview', 32.247501373291, 0.562825074505321, -84.0744400024414, -1.46737579481303, 218, 13, 'PPL', 'P'),
(45827, 'Clearview', 39.7169418334961, 0.69319140381758, -77.7405624389648, -1.35682877691217, 218, 25, 'PPL', 'P'),
(75463, 'Clearview', 35.3969383239746, 0.61779311887872, -96.1861114501953, -1.67876433949613, 218, 42, 'PPL', 'P'),
(80355, 'Clearview', 34.5327796936035, 0.60271070551922, -82.7255630493164, -1.44383345077673, 218, 48, 'PPL', 'P'),
(93291, 'Clearview', 30.0424995422363, 0.524340532540913, -97.3352813720703, -1.69882113829773, 218, 51, 'PPL', 'P'),
(100876, 'Clearview', 37.5483283996582, 0.655341959194129, -75.9047164916992, -1.32478722057299, 218, 53, 'PPL', 'P'),
(154756, 'Clearview', 40.8236083984375, 0.712506379097544, -81.5169372558594, -1.42273895125638, 218, 41, 'PPL', 'P'),
(160154, 'Clearview', 40.0625, 0.699222531580228, -76.3016662597656, -1.33171530099078, 218, 45, 'PPL', 'P'),
(177200, 'Clearview', 40.1411094665527, 0.70059452559481, -80.6883316040039, -1.40827705443087, 218, 58, 'PPL', 'P'),
(207058, 'Clearview', 47.8338890075684, 0.834858857215591, -122.124717712402, -2.13147842215006, 218, 56, 'PPL', 'P'),
(209371, 'Clearview Acres', 41.5805587768555, 0.725717655475154, -109.276107788086, -1.90722787466632, 218, 59, 'PPL', 'P'),
(32090, 'Clearview City', 38.9458312988281, 0.67973298609081, -95.0027770996094, -1.65811125892645, 218, 20, 'PPL', 'P'),
(8121, 'Clearview Estates', 35.7372207641602, 0.623732167846679, -91.6500015258789, -1.59959428608441, 218, 4, 'PPL', 'P'),
(78041, 'Clearview Heights', 39.9052810668945, 0.696478543551065, -76.6716690063477, -1.33817306716006, 218, 45, 'PPL', 'P'),
(80357, 'Clearview Heights', 35.038330078125, 0.611534224263843, -81.9941711425781, -1.43106825388171, 218, 48, 'PPL', 'P'),
(100877, 'Clearview Heights', 37.2463912963867, 0.650072162608107, -80.001106262207, -1.39628270951337, 218, 53, 'PPL', 'P'),
(177956, 'Clearview Heights', 34.9083290100098, 0.609265277594123, -110.145561218262, -1.92240269971564, 218, 5, 'PPL', 'P'),
(177957, 'Clearview Hills', 33.5341682434082, 0.585281647765196, -111.984718322754, -1.95450204665048, 218, 5, 'PPL', 'P'),
(100878, 'Clearview Knolls', 38.1138916015625, 0.66521289919548, -78.5155563354492, -1.37035497208868, 218, 53, 'PPL', 'P'),
(13557, 'Clearview Manor', 39.7055587768555, 0.69299273200026, -75.5680618286133, -1.31891148825995, 218, 10, 'PPL', 'P'),
(100879, 'Clearview Manor', 38.9411087036133, 0.679650561255072, -77.1500015258789, -1.34652154454524, 218, 53, 'PPL', 'P'),
(160155, 'Clearview Manor', 40.2750015258789, 0.702931382872327, -76.788330078125, -1.34020918697148, 218, 45, 'PPL', 'P'),
(100880, 'Clearview Meadows', 38.1111106872559, 0.665164363084614, -78.5199966430664, -1.3704324700764, 218, 53, 'PPL', 'P'),
(72135, 'Clearview Mobile Home Park', 39.913330078125, 0.696619025298567, -83.8605575561523, -1.46364284191307, 218, 41, 'PPL', 'P'),
(45828, 'Clearview North', 38.7133293151855, 0.675675060958829, -76.565559387207, -1.33632110493801, 218, 25, 'PPL', 'P'),
(45829, 'Clearview Village', 39.1230583190918, 0.68282618111791, -76.5361099243164, -1.33580711484763, 218, 25, 'PPL', 'P'),
(78042, 'Clearville', 39.9166717529297, 0.69667734852644, -78.3841705322266, -1.36806185723207, 218, 45, 'PPL', 'P'),
(8122, 'Clearwater', 35.9233283996582, 0.626980358849221, -90.2569427490234, -1.57528082375448, 218, 4, 'PPL', 'P'),
(15555, 'Clearwater', 27.9655609130859, 0.488091115100381, -82.8002777099609, -1.44513746760449, 218, 12, 'PPL', 'P'),
(32091, 'Clearwater', 37.5027809143066, 0.65454700560874, -97.5041732788086, -1.70176885815029, 218, 20, 'PPL', 'P'),
(39804, 'Clearwater', 30.9902801513672, 0.540882424756804, -92.3938903808594, -1.61257759587271, 218, 22, 'PPL', 'P'),
(54088, 'Clearwater', 37.7655601501465, 0.65913336848002, -90.1383285522461, -1.57321061548111, 218, 29, 'PPL', 'P'),
(80358, 'Clearwater', 33.4966697692871, 0.584627175927309, -81.892219543457, -1.42928886279937, 218, 48, 'PPL', 'P'),
(85858, 'Clearwater', 35.5052795410156, 0.619684029831704, -84.6508331298828, -1.47743575267275, 218, 50, 'PPL', 'P'),
(93292, 'Clearwater', 32.9997215270996, 0.575953792889139, -95.2011108398438, -1.66157283571134, 218, 51, 'PPL', 'P'),
(134699, 'Clearwater', 45.4194412231445, 0.792718793759913, -94.0486068725586, -1.64145784683991, 218, 28, 'PPL', 'P'),
(141506, 'Clearwater', 42.1699981689453, 0.736005313608076, -98.1880569458008, -1.71370487983991, 218, 35, 'PPL', 'P'),
(145003, 'Clearwater', 41.0277786254883, 0.716069821794124, -74.7125015258789, -1.30397914402787, 218, 37, 'PPL', 'P'),
(180763, 'Clearwater', 33.8963890075684, 0.591603592718881, -118.159172058105, -2.06226659384442, 218, 6, 'PPL', 'P'),
(194743, 'Clearwater', 46.0224990844727, 0.803244139020124, -115.889999389648, -2.02266205948358, 218, 17, 'PPL', 'P'),
(196229, 'Clearwater', 47.0002784729004, 0.820309608706324, -113.376937866211, -1.97880086159442, 218, 31, 'PPL', 'P'),
(200588, 'Clearwater', 43.2630615234375, 0.755082868076858, -122.420829772949, -2.13664655256147, 218, 43, 'PPL', 'P'),
(207059, 'Clearwater', 47.5777816772461, 0.830388941062974, -124.293327331543, -2.16932780019448, 218, 56, 'PPL', 'P'),
(85859, 'Clearwater Acres', 35.1794395446777, 0.613997049060921, -85.1869430541992, -1.48679263600469, 218, 50, 'PPL', 'P'),
(15556, 'Clearwater Beach', 27.9769401550293, 0.488289720338674, -82.8280563354492, -1.44562229608094, 218, 12, 'PPL', 'P'),
(93293, 'Clearwater Cove', 28.0900001525879, 0.490262989548368, -97.8675003051758, -1.70811011102187, 218, 51, 'PPL', 'P'),
(134701, 'Clearwater Estates', 45.4124984741211, 0.792597619930314, -94.040283203125, -1.64131257140245, 218, 28, 'PPL', 'P'),
(173568, 'Clearwater Lake', 45.8536109924316, 0.800296485746597, -89.1880569458008, -1.55662524716042, 218, 57, 'PPL', 'P'),
(100881, 'Clearwater Park', 37.8369407653809, 0.660379195237959, -79.9861068725586, -1.39602092077821, 218, 53, 'PPL', 'P'),
(20093, 'Clearwater Springs', 33.0152816772461, 0.5762253687413, -84.3247222900391, -1.47174404479103, 218, 13, 'PPL', 'P'),
(54089, 'Cleary', 39.7433280944824, 0.693651930949082, -93.5313873291016, -1.63243066285093, 218, 29, 'PPL', 'P'),
(59029, 'Cleary', 32.1652793884277, 0.561390030151932, -90.1805572509766, -1.57394764531279, 218, 30, 'PPL', 'P'),
(59030, 'Cleary (historical)', 34.3555603027344, 0.599617643650175, -90.4319381713867, -1.57833507005064, 218, 30, 'PPL', 'P'),
(35273, 'Cleaton', 37.2544403076172, 0.650212644355609, -87.0888900756836, -1.51998787372809, 218, 21, 'PPL', 'P'),
(20094, 'Cleaton (historical)', 33.7705612182617, 0.589407483504974, -83.7013931274414, -1.46086489858001, 218, 13, 'PPL', 'P'),
(177958, 'Cleator', 34.2786102294922, 0.598274611512448, -112.232223510742, -1.95882182709664, 218, 5, 'PPL', 'P'),
(177959, 'Cleaveland', 33.7216682434082, 0.588554140112686, -109.280563354492, -1.90730563897015, 218, 5, 'PPL', 'P'),
(147855, 'Cleaver', 42.1805610656738, 0.736189670934536, -75.2358322143555, -1.31311298761852, 218, 40, 'PPL', 'P'),
(45830, 'Cleavers Corner', 39.271110534668, 0.685410179744587, -75.9772186279297, -1.32605262156494, 218, 25, 'PPL', 'P'),
(45831, 'Cleaves Fork', 39.1327781677246, 0.682995824479348, -75.7874984741211, -1.32274138022359, 218, 25, 'PPL', 'P'),
(127119, 'Cleaves Landing', 43.7061080932617, 0.762815489459958, -70.1425018310547, -1.22421760253806, 218, 26, 'PPL', 'P'),
(54090, 'Cleavesville', 38.2727813720703, 0.66798604883858, -91.6016693115234, -1.59875072980913, 218, 29, 'PPL', 'P'),
(85860, 'Cleavet Springs (historical)', 36.4255599975586, 0.635745953840135, -82.2194366455078, -1.43499987859899, 218, 50, 'PPL', 'P'),
(8123, 'Clebb (historical)', 35.148609161377, 0.613458957362671, -92.5941696166992, -1.6160731279615, 218, 4, 'PPL', 'P'),
(75472, 'Clebit', 34.3902816772461, 0.600223645956222, -95.0199966430664, -1.65841179665547, 218, 42, 'PPL', 'P'),
(1617, 'Cleburne', 33.6480598449707, 0.587269431202831, -85.6297225952148, -1.49452059685588, 218, 2, 'PPL', 'P'),
(26811, 'Cleburne', 37.9358291625977, 0.662105123361412, -89.0536117553711, -1.55427873592395, 218, 18, 'PPL', 'P'),
(93294, 'Cleburne', 32.3474998474121, 0.564570377125705, -97.3863906860352, -1.69971316410485, 218, 51, 'PPL', 'P'),
(194747, 'Cleft', 43.2394409179688, 0.754670610740114, -115.849716186523, -2.0219589849558, 218, 17, 'PPL', 'P'),
(93295, 'Clegg', 28.1224994659424, 0.490830209571042, -98.2649993896484, -1.71504777881958, 218, 51, 'PPL', 'P'),
(112452, 'Clegg', 35.8655586242676, 0.625972086060517, -78.8497161865234, -1.3761871617179, 218, 33, 'PPL', 'P'),
(115015, 'Cleghorn', 42.8122215270996, 0.747214225741083, -95.7125015258789, -1.67049828694668, 218, 16, 'PPL', 'P'),
(173569, 'Cleghorn', 44.6836090087891, 0.779876098877169, -91.4266662597656, -1.59569635035492, 218, 57, 'PPL', 'P'),
(196230, 'Cleiv', 47.6941719055176, 0.83242033376346, -111.896110534668, -1.95295554900547, 218, 31, 'PPL', 'P'),
(80359, 'Cleland Crossroads', 32.9388885498047, 0.574892057141552, -81.1180572509766, -1.4157771818508, 218, 48, 'PPL', 'P'),
(13558, 'Cleland Heights', 39.7347183227539, 0.693501662084575, -75.5749969482422, -1.31903252893149, 218, 10, 'PPL', 'P'),
(100882, 'Clell', 37.1377792358398, 0.648176524544189, -81.9677810668945, -1.43060766017118, 218, 53, 'PPL', 'P'),
(20095, 'Clem', 33.5280609130859, 0.585175054742566, -85.0133285522461, -1.4837624913164, 218, 13, 'PPL', 'P'),
(59032, 'Clem', 31.7108306884766, 0.553458404056376, -89.7877807617188, -1.56709240235081, 218, 30, 'PPL', 'P'),
(108613, 'Clem', 38.6341705322266, 0.674293479564324, -80.914436340332, -1.41222332653415, 218, 58, 'PPL', 'P'),
(200590, 'Clem', 45.4213905334473, 0.792752815642838, -120.202217102051, -2.09792445662782, 218, 43, 'PPL', 'P'),
(124532, 'Clematis Brook Station', 42.3816719055176, 0.739699717251261, -71.2111129760742, -1.24286838544215, 218, 23, 'PPL', 'P'),
(177960, 'Clemenceau', 34.7319412231445, 0.606186729953019, -112.025833129883, -1.9552196354062, 218, 5, 'PPL', 'P'),
(190043, 'Clemens (historical)', 39.9719390869141, 0.697641945473266, -118.216667175293, -2.06327007294317, 218, 39, 'PPL', 'P'),
(45832, 'Clemens Crossing', 39.1972198486328, 0.684120543986716, -76.8763885498047, -1.34174609723656, 218, 25, 'PPL', 'P'),
(54092, 'Clement', 38.0569381713867, 0.664218874318608, -90.165283203125, -1.57368106288767, 218, 29, 'PPL', 'P'),
(63727, 'Clement', 35.0955581665039, 0.612533042830677, -78.6288909912109, -1.37233303498834, 218, 33, 'PPL', 'P'),
(72136, 'Clement', 39.7402801513672, 0.693598734306308, -84.1055603027344, -1.46791894651735, 218, 41, 'PPL', 'P'),
(139800, 'Clement', 46.1544418334961, 0.805546974414715, -98.2438888549805, -1.71467933048277, 218, 34, 'PPL', 'P'),
(180764, 'Clement Junction', 34.0141716003418, 0.593659286764313, -118.237777709961, -2.06363852127998, 218, 6, 'PPL', 'P'),
(80360, 'Clementia (historical)', 32.7249984741211, 0.571158971083533, -80.1855621337891, -1.39950207179711, 218, 48, 'PPL', 'P'),
(54091, 'Clementine', 37.8763885498047, 0.661067688958772, -92.017219543457, -1.6060034495638, 218, 29, 'PPL', 'P'),
(8127, 'Clementine (historical)', 36.3730583190918, 0.634829626688066, -94.4513931274414, -1.6484877931694, 218, 4, 'PPL', 'P'),
(70669, 'Clementon', 39.8113899230957, 0.694839833953312, -74.9833297729492, -1.30870598864666, 218, 37, 'PPL', 'P'),
(100883, 'Clementown Mills', 37.4408302307129, 0.653465762206168, -78.0905609130859, -1.36293740266254, 218, 53, 'PPL', 'P'),
(461, 'Clements', 39.6188888549805, 0.691480056501095, -90.1508331298828, -1.57342886153244, 218, 18, 'PPL', 'P'),
(32093, 'Clements', 38.2999992370605, 0.668461090198023, -96.7405624389648, -1.68844133479109, 218, 20, 'PPL', 'P'),
(45833, 'Clements', 38.3261108398438, 0.668916823639563, -76.7275009155273, -1.33914751780292, 218, 25, 'PPL', 'P'),
(134704, 'Clements', 44.3816719055176, 0.774606302291147, -95.0522232055664, -1.65897425627769, 218, 28, 'PPL', 'P'),
(180765, 'Clements', 38.1908302307129, 0.666555731596126, -121.087219238281, -2.11337065779223, 218, 6, 'PPL', 'P'),
(8128, 'Clements (historical)', 34.1766700744629, 0.596495420167193, -91.670280456543, -1.59994822019329, 218, 4, 'PPL', 'P'),
(108614, 'Clements (historical)', 39.0533294677734, 0.681609183078771, -80.0147171020508, -1.3965202634826, 218, 58, 'PPL', 'P'),
(70671, 'Clements Bridge', 39.8408317565918, 0.695353690885643, -75.083610534668, -1.31045621811506, 218, 37, 'PPL', 'P'),
(134706, 'Clementson', 48.6908302307129, 0.84981530305553, -94.4361114501953, -1.64822107758623, 218, 28, 'PPL', 'P'),
(35274, 'Clementsville', 37.2900009155273, 0.650833294047652, -85.0930633544922, -1.48515412614402, 218, 21, 'PPL', 'P'),
(85863, 'Clementsville', 36.6116714477539, 0.638994211421705, -85.725830078125, -1.49619798886847, 218, 50, 'PPL', 'P'),
(139802, 'Clementsville', 47.0377807617188, 0.820964147123239, -98.4927825927734, -1.71902334569485, 218, 34, 'PPL', 'P'),
(194745, 'Clementsville', 43.8766708374023, 0.765792370926448, -111.369171142578, -1.94375872165504, 218, 17, 'PPL', 'P'),
(72137, 'Clemma (historical)', 38.6302795410156, 0.674225568956527, -82.1997222900391, -1.43465579818616, 218, 41, 'PPL', 'P'),
(63723, 'Clemmons', 36.0213890075684, 0.62869183932376, -80.3822174072266, -1.40293435381, 218, 33, 'PPL', 'P'),
(63724, 'Clemmons Station', 35.999439239502, 0.628308743600953, -80.3802795410156, -1.40290053166416, 218, 33, 'PPL', 'P'),
(63725, 'Clemmons West', 36.0086097717285, 0.628468799582466, -80.3855590820313, -1.40299267703788, 218, 33, 'PPL', 'P'),
(160157, 'Clemo', 41.5038909912109, 0.724379550185444, -75.3244400024414, -1.31465948526353, 218, 45, 'PPL', 'P'),
(35275, 'Clemons', 37.2958297729492, 0.650935026801293, -83.2324981689453, -1.45268113770825, 218, 21, 'PPL', 'P'),
(93296, 'Clemons', 29.8425006866455, 0.520849894010633, -96.0408325195313, -1.67622874382226, 218, 51, 'PPL', 'P'),
(115016, 'Clemons', 42.1138916015625, 0.735026069275254, -93.1558303833008, -1.62587595761797, 218, 16, 'PPL', 'P'),
(147856, 'Clemons', 43.6363906860352, 0.761598691157901, -73.4458312988281, -1.28187157802885, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(196231, 'Clemons (historical)', 47.3069381713867, 0.825661830128084, -112.409721374512, -1.96191974923468, 218, 31, 'PPL', 'P'),
(1622, 'Clemons Crossroad', 34.4749984741211, 0.601702232993434, -86.896110534668, -1.51662323600689, 218, 2, 'PPL', 'P'),
(180766, 'Clems (historical)', 37.0980606079102, 0.647483303712441, -121.996391296387, -2.1292387036733, 218, 6, 'PPL', 'P'),
(75464, 'Clemscott', 34.3472213745117, 0.599472101896602, -97.4563903808594, -1.70093488925493, 218, 42, 'PPL', 'P'),
(80368, 'Clemson', 34.6833305358887, 0.605338313408747, -82.8375015258789, -1.44578714575241, 218, 48, 'PPL', 'P'),
(80361, 'Clemson Forest', 34.6694412231445, 0.605095899170522, -82.879997253418, -1.446528836116, 218, 48, 'PPL', 'P'),
(45835, 'Clemsonville', 39.521671295166, 0.689783289991579, -77.179443359375, -1.34703540147757, 218, 25, 'PPL', 'P'),
(108615, 'Clemtown', 39.2324981689453, 0.684736266830742, -79.9775009155273, -1.39587071849273, 218, 58, 'PPL', 'P'),
(93297, 'Clemville', 28.9958305358887, 0.506072712201569, -96.1408309936523, -1.67797404644264, 218, 51, 'PPL', 'P'),
(108616, 'Clendenenville', 37.8788909912109, 0.661111364800649, -80.4122161865234, -1.40345793128031, 218, 58, 'PPL', 'P'),
(108617, 'Clendenin', 38.4886093139648, 0.671752957042442, -81.3483276367188, -1.41979615825184, 218, 58, 'PPL', 'P'),
(154757, 'Clendening (historical)', 40.252498626709, 0.702538633190568, -81.2141723632813, -1.41745470702144, 218, 41, 'PPL', 'P'),
(59033, 'Cleo', 31.7002792358398, 0.553274246466997, -89.0366668701172, -1.5539829918849, 218, 30, 'PPL', 'P'),
(93298, 'Cleo', 30.603609085083, 0.534133741527948, -99.8747177124023, -1.74314266358132, 218, 51, 'PPL', 'P'),
(75465, 'Cleo Springs', 36.4052810668945, 0.635392019731264, -98.4402770996094, -1.71810695196376, 218, 42, 'PPL', 'P'),
(160158, 'Cleona', 40.3372192382813, 0.704017286806807, -76.475830078125, -1.33475503305899, 218, 45, 'PPL', 'P'),
(26813, 'Cleone', 39.4230613708496, 0.688062222137115, -87.9075012207031, -1.5342753335022, 218, 18, 'PPL', 'P'),
(180767, 'Cleone', 39.4900016784668, 0.689230550907333, -123.784439086914, -2.16044602480101, 218, 6, 'PPL', 'P'),
(35276, 'Cleopatra', 37.6222190856934, 0.656631594952, -87.2927780151367, -1.52354638957666, 218, 21, 'PPL', 'P'),
(139090, 'Cleopatra', 40.5486106872559, 0.707706763601975, -93.404167175293, -1.63021025229207, 218, 29, 'PPL', 'P'),
(100889, 'Cleopus', 36.5927810668945, 0.638664512078753, -76.8302764892578, -1.34094128995514, 218, 53, 'PPL', 'P'),
(75467, 'Cleora', 36.5788917541504, 0.638422097840529, -94.970832824707, -1.65755372615224, 218, 42, 'PPL', 'P'),
(80365, 'Cleora', 33.8413887023926, 0.590643656303962, -82.0500030517578, -1.43204270452457, 218, 48, 'PPL', 'P'),
(186542, 'Cleora', 38.5133285522461, 0.672184389139035, -105.969436645508, -1.84951557594765, 218, 7, 'PPL', 'P'),
(39806, 'Cleora (historical)', 32.7333297729492, 0.571304379679052, -91.8333282470703, -1.60279394097609, 218, 22, 'PPL', 'P'),
(13559, 'Clermont', 39.788890838623, 0.69444715085058, -75.5274963378906, -1.31820348688415, 218, 10, 'PPL', 'P'),
(15557, 'Clermont', 28.5491695404053, 0.498277007190148, -81.773063659668, -1.42720920030413, 218, 12, 'PPL', 'P'),
(20096, 'Clermont', 34.4777793884277, 0.601750769104301, -83.7736129760742, -1.46212537272394, 218, 13, 'PPL', 'P'),
(29503, 'Clermont', 39.8097190856934, 0.694810672339376, -86.3225021362305, -1.50661188083706, 218, 19, 'PPL', 'P'),
(35277, 'Clermont', 37.9297218322754, 0.661998530338782, -85.6527786254883, -1.49492300049659, 218, 21, 'PPL', 'P'),
(70673, 'Clermont', 39.9905586242676, 0.697966917705283, -74.8000030517578, -1.30550633375498, 218, 37, 'PPL', 'P'),
(115018, 'Clermont', 43.0036087036133, 0.750554562117342, -91.6522216796875, -1.59963303507827, 218, 16, 'PPL', 'P'),
(147862, 'Clermont', 42.0849990844727, 0.734521799722847, -73.8274993896484, -1.28853294286347, 218, 40, 'PPL', 'P'),
(160160, 'Clermont', 41.6894416809082, 0.727618020650007, -78.4886093139648, -1.36988465784017, 218, 45, 'PPL', 'P'),
(59034, 'Clermont Harbor', 30.2613906860352, 0.528160903703659, -89.4161071777344, -1.5606054745676, 218, 30, 'PPL', 'P'),
(29506, 'Clermont Heights', 39.8266716003418, 0.695106549536484, -86.3441696166992, -1.50699004971185, 218, 19, 'PPL', 'P'),
(100884, 'Clermont Heights', 37.2408294677734, 0.649975090386374, -79.9472198486328, -1.39534221417441, 218, 53, 'PPL', 'P'),
(100885, 'Clermont Woods', 38.7972183227539, 0.677139200347128, -77.1108322143555, -1.34583791109341, 218, 53, 'PPL', 'P'),
(72139, 'Clermontville', 38.9222183227539, 0.679320861912121, -84.2538909912109, -1.47050780541302, 218, 41, 'PPL', 'P'),
(72140, 'Clertoma', 39.1716690063477, 0.683674597662182, -84.2827835083008, -1.47101207496543, 218, 41, 'PPL', 'P'),
(191279, 'Cleta', 34.9252815246582, 0.609561154791231, -101.926109313965, -1.77894620127635, 218, 51, 'PPL', 'P'),
(59035, 'Cletonia', 33.1505584716797, 0.57858639420571, -90.8472213745117, -1.5855831292734, 218, 30, 'PPL', 'P'),
(80366, 'Clevedale', 34.9300003051758, 0.609643513047942, -82.0405578613281, -1.43187785485309, 218, 48, 'PPL', 'P'),
(1621, 'Cleveland', 33.6894416809082, 0.587991680490461, -87.6497192382813, -1.52977618915662, 218, 2, 'PPL', 'P'),
(8129, 'Cleveland', 35.4213905334473, 0.618219890443405, -92.7094421386719, -1.618085013007, 218, 4, 'PPL', 'P'),
(15567, 'Cleveland', 26.961389541626, 0.470565018414138, -81.9841690063477, -1.43089368367225, 218, 12, 'PPL', 'P'),
(20097, 'Cleveland', 34.5969390869141, 0.603830498178571, -83.7633285522461, -1.46194587566647, 218, 13, 'PPL', 'P'),
(29504, 'Cleveland', 39.7902793884277, 0.6944713856165, -85.6447219848633, -1.49478238559104, 218, 19, 'PPL', 'P'),
(32094, 'Cleveland', 37.5516700744629, 0.655400282422002, -98.1333312988281, -1.71274973711495, 218, 20, 'PPL', 'P'),
(54093, 'Cleveland', 38.6791687011719, 0.675078845769788, -94.5933303833008, -1.65096506561539, 218, 29, 'PPL', 'P'),
(59037, 'Cleveland', 32.7511100769043, 0.571614704525073, -88.8300018310547, -1.5503760065045, 218, 30, 'PPL', 'P'),
(63728, 'Cleveland', 35.7330589294434, 0.623659530127947, -80.6772232055664, -1.40808317630351, 218, 33, 'PPL', 'P'),
(75468, 'Cleveland', 36.310001373291, 0.633729075367591, -96.4638900756836, -1.68361249110256, 218, 42, 'PPL', 'P'),
(80367, 'Cleveland', 35.0722198486328, 0.61212571234195, -82.5274963378906, -1.44037653452375, 218, 48, 'PPL', 'P'),
(85864, 'Cleveland', 35.1594390869141, 0.613647975221039, -84.8766708374023, -1.48137736424412, 218, 50, 'PPL', 'P'),
(93300, 'Cleveland', 30.3411102294922, 0.529552272215171, -95.0852813720703, -1.65955123012786, 218, 51, 'PPL', 'P'),
(100886, 'Cleveland', 36.9436111450195, 0.644787652057063, -82.1519393920898, -1.4338218292908, 218, 53, 'PPL', 'P'),
(108620, 'Cleveland', 38.7269401550293, 0.675912614928064, -80.3925018310547, -1.40311385086747, 218, 58, 'PPL', 'P'),
(119166, 'Cleveland', 41.5061111450195, 0.724418299179304, -90.3147201538086, -1.57628922970124, 218, 18, 'PPL', 'P'),
(127120, 'Cleveland', 47.2599983215332, 0.824842575197748, -68.2594375610352, -1.19135193099955, 218, 26, 'PPL', 'P'),
(134707, 'Cleveland', 44.3255615234375, 0.773626991379298, -93.8375015258789, -1.63777336347179, 218, 28, 'PPL', 'P'),
(139803, 'Cleveland', 46.8916702270508, 0.818414037221433, -99.1175003051758, -1.7299267266718, 218, 34, 'PPL', 'P'),
(147858, 'Cleveland', 43.2402801513672, 0.75468525812611, -75.8841705322266, -1.32442862593221, 218, 40, 'PPL', 'P'),
(154758, 'Cleveland', 41.499439239502, 0.724301852460641, -81.695556640625, -1.42585644762842, 218, 41, 'PPL', 'P'),
(173570, 'Cleveland', 43.9150009155273, 0.766461356992276, -87.7472229003906, -1.53147794909318, 218, 57, 'PPL', 'P'),
(188328, 'Cleveland', 35.9933280944824, 0.628202083999295, -105.370002746582, -1.83905348076332, 218, 38, 'PPL', 'P'),
(192523, 'Cleveland', 39.3488883972168, 0.686767659531227, -110.850830078125, -1.93471196343204, 218, 52, 'PPL', 'P'),
(194746, 'Cleveland', 42.3400001525879, 0.73897240795756, -111.712501525879, -1.94975096726578, 218, 17, 'PPL', 'P'),
(196232, 'Cleveland', 48.2694396972656, 0.84246065081014, -109.15193939209, -1.90506072732927, 218, 31, 'PPL', 'P'),
(200589, 'Cleveland', 43.2963905334473, 0.755664569037959, -123.475280761719, -2.1550501941164, 218, 43, 'PPL', 'P'),
(207060, 'Cleveland', 45.9708290100098, 0.802342326095996, -120.351936340332, -2.10053755028941, 218, 56, 'PPL', 'P'),
(141508, 'Cleveland (historical)', 42.7750015258789, 0.746564614172185, -99.1138916015625, -1.72986374291202, 218, 35, 'PPL', 'P'),
(190045, 'Cleveland (historical)', 39.2555618286133, 0.685138803629508, -114.486106872559, -1.99815951271626, 218, 39, 'PPL', 'P'),
(171862, 'Cleveland Corners', 44.5936088562012, 0.778305299887213, -72.5630569458008, -1.26646425901636, 218, 55, 'PPL', 'P'),
(59038, 'Cleveland Crossing', 33.7472190856934, 0.58900008643722, -90.7975006103516, -1.5847153382322, 218, 30, 'PPL', 'P'),
(1625, 'Cleveland Crossroads', 33.1130599975586, 0.577931922367823, -85.9875030517578, -1.50076504382185, 218, 2, 'PPL', 'P'),
(80369, 'Cleveland Forest', 34.8402786254883, 0.608077574326975, -82.3886108398438, -1.43795252529956, 218, 48, 'PPL', 'P'),
(113238, 'Cleveland Heights', 41.5200004577637, 0.724660713417529, -81.5563888549805, -1.42342751155622, 218, 41, 'PPL', 'P'),
(147859, 'Cleveland Hill', 42.9447212219238, 0.749526781673653, -78.7844390869141, -1.37504786140357, 218, 40, 'PPL', 'P'),
(1624, 'Cleveland Mills', 32.7041702270508, 0.570795449594738, -87.1988906860352, -1.52190774655793, 218, 2, 'PPL', 'P'),
(63730, 'Cleveland Mills (historical)', 35.4991683959961, 0.619577370230046, -81.6452789306641, -1.42497893604924, 218, 33, 'PPL', 'P'),
(13061, 'Cleveland Park', 38.9361114501953, 0.679563342729372, -77.0658264160156, -1.34505241172989, 218, 9, 'PPL', 'P'),
(45838, 'Cleveland Park Estates', 38.583610534668, 0.673411041137126, -76.9305572509766, -1.34269151942354, 218, 25, 'PPL', 'P'),
(63731, 'Cleveland Spring (historical)', 35.2769393920898, 0.615698742418455, -81.4963912963867, -1.4223803566156, 218, 33, 'PPL', 'P'),
(20099, 'Cleveland Station', 33.9491691589355, 0.592524780139939, -83.5086135864258, -1.4575002608588, 218, 13, 'PPL', 'P'),
(80370, 'Cleveland-A-Farm', 34.6355590820313, 0.60450454425047, -82.9527816772461, -1.44779916395597, 218, 48, 'PPL', 'P'),
(124533, 'Clevelandtown', 41.3833312988281, 0.722275386608172, -70.5194396972656, -1.23079640937888, 218, 23, 'PPL', 'P'),
(45836, 'Clevelandville', 39.4786109924316, 0.689031745931958, -77.6394424438477, -1.35506390005777, 218, 25, 'PPL', 'P'),
(54095, 'Clevenger', 39.2366714477539, 0.684809104286556, -94.2213897705078, -1.64447347730027, 218, 29, 'PPL', 'P'),
(85865, 'Clevenger', 35.9688911437988, 0.627775578750719, -83.2638931274414, -1.45322908310253, 218, 50, 'PPL', 'P'),
(154761, 'Clevengers (historical)', 40.9583282470703, 0.714857684023974, -84.1780624389648, -1.4691843475093, 218, 41, 'PPL', 'P'),
(54096, 'Clever', 37.0302810668945, 0.646300327556228, -93.4727783203125, -1.63140774267623, 218, 29, 'PPL', 'P'),
(147860, 'Cleverdale', 43.4772186279297, 0.758820614666785, -73.6430587768555, -1.28531384689584, 218, 40, 'PPL', 'P'),
(160162, 'Cleversburg', 40.0374984741211, 0.698786172635619, -77.4663925170898, -1.35204360906552, 218, 45, 'PPL', 'P'),
(160163, 'Cleversburg Junction', 40.0502815246582, 0.69900927895594, -77.4649963378906, -1.35201924114154, 218, 45, 'PPL', 'P'),
(72141, 'Cleves', 39.1616706848145, 0.683500094031755, -84.7491683959961, -1.47915202683725, 218, 41, 'PPL', 'P'),
(115022, 'Cleves', 42.4727783203125, 0.74128982415912, -93.0449981689453, -1.62394157056019, 218, 16, 'PPL', 'P'),
(63734, 'Clevewood', 35.538330078125, 0.620260870523815, -77.383056640625, -1.35058912363617, 218, 33, 'PPL', 'P'),
(100887, 'Clevilas (historical)', 37.2088890075684, 0.649417624191193, -79.6833267211914, -1.39073641022717, 218, 53, 'PPL', 'P'),
(63735, 'Clewis Corner', 34.1863899230957, 0.596665063528631, -78.4024963378906, -1.36838170287899, 218, 33, 'PPL', 'P'),
(15558, 'Clewiston', 26.7538890838623, 0.466943452226767, -80.9338912963867, -1.41256287957313, 218, 12, 'PPL', 'P'),
(93301, 'Click', 30.563060760498, 0.533426039757773, -98.5736083984375, -1.72043402212427, 218, 51, 'PPL', 'P'),
(85866, 'Click Mill', 35.8969383239746, 0.626519765138692, -83.084716796875, -1.45010186619251, 218, 50, 'PPL', 'P'),
(194748, 'Clicks', 46.2802810668945, 0.807743283365704, -116.533889770508, -2.0339000666515, 218, 17, 'PPL', 'P'),
(108621, 'Clickton (historical)', 38.6944389343262, 0.675345361615878, -80.8194427490234, -1.41056537559752, 218, 58, 'PPL', 'P'),
(113069, 'Clicquot', 42.1713905334473, 0.736029614953023, -71.352783203125, -1.24534099735624, 218, 23, 'PPL', 'P'),
(63736, 'Clifdale', 35.0613899230957, 0.611936694483581, -79.0155563354492, -1.37908161834865, 218, 33, 'PPL', 'P'),
(100888, 'Clifdale', 37.6805610656738, 0.657649854594792, -80.0149993896484, -1.39652519033062, 218, 53, 'PPL', 'P'),
(35278, 'Cliff', 37.6813888549805, 0.657664302243705, -82.7805633544922, -1.44479338719165, 218, 21, 'PPL', 'P'),
(54099, 'Cliff', 37.1686096191406, 0.64871461624244, -89.788330078125, -1.56710198973074, 218, 29, 'PPL', 'P'),
(188329, 'Cliff', 32.9622192382813, 0.575299254472225, -108.610557556152, -1.89561183178166, 218, 38, 'PPL', 'P'),
(194749, 'Cliff (historical)', 43.8758316040039, 0.765777723540453, -113.677223205566, -1.98404182946164, 218, 17, 'PPL', 'P'),
(54097, 'Cliff Cave', 38.461669921875, 0.671282775951989, -90.2874984741211, -1.57581412176277, 218, 29, 'PPL', 'P'),
(1628, 'Cliff Haven', 34.7772216796875, 0.6069770230065, -87.6730575561523, -1.53018351964535, 218, 2, 'PPL', 'P'),
(147861, 'Cliff Haven', 44.6586112976074, 0.779439806511587, -73.4413909912109, -1.28179408004113, 218, 40, 'PPL', 'P'),
(180769, 'Cliff Haven', 33.6324996948242, 0.586997855350671, -117.91471862793, -2.05800007662006, 218, 6, 'PPL', 'P'),
(127121, 'Cliff Island', 43.6961097717285, 0.76264098582953, -70.1083297729492, -1.22362118761193, 218, 26, 'PPL', 'P'),
(127122, 'Cliff Island Landing', 43.6949996948242, 0.7626216113326, -70.1105575561523, -1.22366006976385, 218, 26, 'PPL', 'P'),
(196233, 'Cliff Lake', 44.829719543457, 0.782426208778974, -111.518890380859, -1.94637181531663, 218, 31, 'PPL', 'P'),
(100890, 'Cliff Mills', 38.7208290100098, 0.675805955326407, -77.9086074829102, -1.35976171622067, 218, 53, 'PPL', 'P'),
(85867, 'Cliff Springs', 36.1805610656738, 0.631469915814877, -85.1508331298828, -1.48616239893272, 218, 50, 'PPL', 'P'),
(54098, 'Cliff Village', 37.0233306884766, 0.646179020568575, -94.5149993896484, -1.6495979318698, 218, 29, 'PPL', 'P'),
(59039, 'Cliff Williams', 32.2958297729492, 0.563668564201577, -88.602783203125, -1.54641029332526, 218, 30, 'PPL', 'P'),
(26814, 'Cliffdale', 39.3605613708496, 0.686971391354618, -90.6263885498047, -1.58172886938578, 218, 18, 'PPL', 'P'),
(186543, 'Cliffdale', 39.4086112976074, 0.687810020781884, -105.375831604004, -1.83915521351697, 218, 7, 'PPL', 'P'),
(207061, 'Cliffdell', 46.9463882446289, 0.819369046788336, -121.067779541016, -2.11303137106935, 218, 56, 'PPL', 'P'),
(100891, 'Cliffield', 37.0977783203125, 0.647478376864425, -81.6569366455078, -1.42518240155653, 218, 53, 'PPL', 'P'),
(115023, 'Cliffland', 40.9658317565918, 0.714988644970579, -92.3261108398438, -1.6113946197165, 218, 16, 'PPL', 'P'),
(695, 'Clifford', 33.8236083984375, 0.59033333145794, -90.8850021362305, -1.5862425279593, 218, 30, 'PPL', 'P'),
(26815, 'Clifford', 37.8236083984375, 0.660146501537714, -89.0772171020508, -1.55469072694459, 218, 18, 'PPL', 'P'),
(29505, 'Clifford', 39.2822189331055, 0.685604057871945, -85.8691711425781, -1.49869976239649, 218, 19, 'PPL', 'P'),
(35279, 'Clifford', 38.0011100769043, 0.663244490254776, -82.5272216796875, -1.44037174083379, 218, 21, 'PPL', 'P'),
(39807, 'Clifford', 32.9638900756836, 0.575328416086161, -93.4541702270508, -1.63108297018129, 218, 22, 'PPL', 'P'),
(45837, 'Clifford', 39.246940612793, 0.684988335027918, -76.6333312988281, -1.33750394793617, 218, 25, 'PPL', 'P'),
(72142, 'Clifford', 38.9266700744629, 0.679398559636924, -83.0197219848633, -1.44896749272619, 218, 41, 'PPL', 'P'),
(100892, 'Clifford', 37.6433296203613, 0.657000043288812, -79.0224990844727, -1.37920279217825, 218, 53, 'PPL', 'P'),
(124534, 'Clifford', 41.726390838623, 0.72826290510797, -70.9416732788086, -1.23816577558929, 218, 23, 'PPL', 'P'),
(130255, 'Clifford', 43.3147201538086, 0.755984481263905, -83.1791687011719, -1.45175036290726, 218, 27, 'PPL', 'P'),
(139806, 'Clifford', 47.3480606079102, 0.82637955204186, -97.4102783203125, -1.7001300819735, 218, 34, 'PPL', 'P'),
(147863, 'Clifford', 43.3816719055176, 0.757153009771204, -76.2855606079102, -1.33143420433772, 218, 40, 'PPL', 'P'),
(160164, 'Clifford', 41.6488914489746, 0.726910285590319, -75.5991668701172, -1.31945437364816, 218, 45, 'PPL', 'P'),
(173576, 'Clifford', 45.5552787780762, 0.795089606341328, -90.0430603027344, -1.57154787085452, 218, 57, 'PPL', 'P'),
(186544, 'Clifford', 39.0438919067383, 0.68144446656535, -103.350830078125, -1.80381226953247, 218, 7, 'PPL', 'P'),
(54100, 'Clifford (historical)', 37.732780456543, 0.658561254898844, -93.2094421386719, -1.62681165926697, 218, 29, 'PPL', 'P'),
(29509, 'Clifford Park (historical)', 39.788890838623, 0.69444715085058, -86.0880584716797, -1.50252006698021, 218, 19, 'PPL', 'P'),
(194750, 'Cliffs', 42.6391716003418, 0.744193934748824, -116.979438781738, -2.04167636387648, 218, 17, 'PPL', 'P'),
(160166, 'Cliffs (historical)', 40.0191688537598, 0.698466260409673, -78.4786071777344, -1.36971008763072, 218, 45, 'PPL', 'P'),
(45839, 'Cliffs City', 39.1183280944824, 0.682743623124118, -76.1500015258789, -1.32906825202529, 218, 25, 'PPL', 'P'),
(45840, 'Cliffs of Calvert', 38.339168548584, 0.669144723649846, -76.4075012207031, -1.33356246952286, 218, 25, 'PPL', 'P'),
(63737, 'Cliffside', 35.2380599975586, 0.615020168972703, -81.7699966430664, -1.42715567076622, 218, 33, 'PPL', 'P'),
(85868, 'Cliffside', 36.5149993896484, 0.637306965713085, -82.521110534668, -1.44026508123213, 218, 50, 'PPL', 'P'),
(147864, 'Cliffside', 42.5138893127441, 0.742007346335815, -74.982780456543, -1.30869640126673, 218, 40, 'PPL', 'P'),
(191280, 'Cliffside', 35.2649993896484, 0.615490350063156, -101.932220458984, -1.779052860878, 218, 51, 'PPL', 'P'),
(145004, 'Cliffside Park', 40.8213882446289, 0.712467630103683, -73.9880599975586, -1.29133525412051, 218, 37, 'PPL', 'P'),
(45841, 'Cliffton Estates', 39.5583305358887, 0.69042311444347, -77.4997177124023, -1.35262524344759, 218, 25, 'PPL', 'P'),
(108623, 'Clifftop', 37.7713890075684, 0.659235101233661, -81.121940612793, -1.41584495930054, 218, 58, 'PPL', 'P'),
(85869, 'Clifftops', 35.2236099243164, 0.614767967617472, -85.8561096191406, -1.49847179580718, 218, 50, 'PPL', 'P'),
(100894, 'Cliffview', 37.2705612182617, 0.650494007324776, -80.0352783203125, -1.39687912443949, 218, 53, 'PPL', 'P'),
(145006, 'Cliffwood', 40.4366683959961, 0.705753002047266, -74.2399978637695, -1.29573239939634, 218, 37, 'PPL', 'P'),
(145007, 'Cliffwood Beach', 40.4419403076172, 0.705845014262928, -74.2172164916992, -1.29533478944559, 218, 37, 'PPL', 'P'),
(203445, 'Cliffwood Park', 40.6652793884277, 0.70974301657145, -111.813888549805, -1.95152050465208, 218, 52, 'PPL', 'P'),
(72143, 'Cliffyville (historical)', 39.7061080932617, 0.693002319380185, -81.3324966430664, -1.41951985528874, 218, 41, 'PPL', 'P'),
(199877, 'Clifside', 40.9161109924316, 0.714120853929377, -114.276390075684, -1.99449926411405, 218, 39, 'PPL', 'P'),
(1626, 'Clift Acres', 34.7030601501465, 0.605682660137694, -86.7377777099609, -1.51385980690177, 218, 2, 'PPL', 'P'),
(15559, 'Clifton', 28.708890914917, 0.501064671061189, -81.2694396972656, -1.41841930396827, 218, 12, 'PPL', 'P'),
(20100, 'Clifton', 33.7619400024414, 0.589257014903385, -84.3330612182617, -1.47188958654461, 218, 13, 'PPL', 'P'),
(29508, 'Clifton', 39.6902809143066, 0.692726082996116, -84.9558334350586, -1.48275901221766, 218, 19, 'PPL', 'P'),
(32099, 'Clifton', 39.5672187805176, 0.690578243576967, -97.2783279418945, -1.69782711342086, 218, 20, 'PPL', 'P'),
(35282, 'Clifton', 38.086109161377, 0.664728004140004, -84.8261108398438, -1.48049492581693, 218, 21, 'PPL', 'P'),
(39809, 'Clifton', 30.9252796173096, 0.539747951421944, -90.1797180175781, -1.57393299792679, 218, 22, 'PPL', 'P'),
(45842, 'Clifton', 39.4205589294434, 0.688018546295238, -77.4861068725586, -1.35238768947835, 218, 25, 'PPL', 'P'),
(59041, 'Clifton', 32.4661102294922, 0.566640518820051, -89.5663909912109, -1.56322842192522, 218, 30, 'PPL', 'P'),
(63739, 'Clifton', 36.4466705322266, 0.636114402176948, -81.5711135864258, -1.42368450660141, 218, 33, 'PPL', 'P'),
(72146, 'Clifton', 39.5394401550293, 0.690093415100518, -81.5519409179688, -1.42334988041044, 218, 41, 'PPL', 'P'),
(75471, 'Clifton', 35.5158309936523, 0.619868187421083, -96.9116668701172, -1.69142767047945, 218, 42, 'PPL', 'P'),
(80371, 'Clifton', 34.9794387817383, 0.610506377241127, -81.8180618286133, -1.42799456650959, 218, 48, 'PPL', 'P'),
(85870, 'Clifton', 35.3869400024414, 0.617618615248293, -87.9952774047852, -1.53580731691927, 218, 50, 'PPL', 'P'),
(93303, 'Clifton', 32.7828407287598, 0.572168508873755, -95.9824981689453, -1.67521061733752, 218, 51, 'PPL', 'P'),
(100897, 'Clifton', 38.7799987792969, 0.676838662618112, -77.3869400024414, -1.35065690108591, 218, 53, 'PPL', 'P'),
(108624, 'Clifton', 39.0022201538086, 0.680717157271649, -82.0416717529297, -1.43189729592905, 218, 58, 'PPL', 'P'),
(119167, 'Clifton', 40.9352798461914, 0.714455413541318, -87.934440612793, -1.53474551459266, 218, 18, 'PPL', 'P'),
(124535, 'Clifton', 42.4833297729492, 0.741473981748499, -70.8805618286133, -1.23709917957271, 218, 23, 'PPL', 'P'),
(127123, 'Clifton', 44.8166694641113, 0.782198441926745, -68.5116729736328, -1.19575426943951, 218, 26, 'PPL', 'P'),
(134710, 'Clifton', 46.8813896179199, 0.818234606742989, -91.920280456543, -1.60431154332327, 218, 28, 'PPL', 'P'),
(139091, 'Clifton', 40.4272193908691, 0.705588085796763, -92.4841690063477, -1.61415325513166, 218, 29, 'PPL', 'P'),
(145008, 'Clifton', 40.8583297729492, 0.713112381403591, -74.1641693115234, -1.29440894149262, 218, 37, 'PPL', 'P'),
(147866, 'Clifton', 40.6199989318848, 0.708952723517969, -74.0774993896484, -1.29289626599346, 218, 40, 'PPL', 'P'),
(160169, 'Clifton', 41.2227783203125, 0.719473208509191, -75.5480575561523, -1.31856234784104, 218, 45, 'PPL', 'P'),
(173577, 'Clifton', 43.8791694641113, 0.765835980189299, -90.3566665649414, -1.5770213326849, 218, 57, 'PPL', 'P'),
(177961, 'Clifton', 33.0508308410645, 0.576845818696261, -109.295562744141, -1.9075674277053, 218, 5, 'PPL', 'P'),
(180768, 'Clifton', 33.8274993896484, 0.590401242065738, -118.378890991211, -2.06610141265608, 218, 6, 'PPL', 'P'),
(186545, 'Clifton', 39.0919418334961, 0.682283095992616, -108.448333740234, -1.89278049206875, 218, 7, 'PPL', 'P'),
(194751, 'Clifton', 42.189998626709, 0.736354387447958, -112.007217407227, -1.95489472975321, 218, 17, 'PPL', 'P'),
(198128, 'Clifton', 47.8911094665527, 0.83585754262437, -100.033889770508, -1.74592074007244, 218, 34, 'PPL', 'P'),
(200592, 'Clifton', 46.211109161377, 0.806536005864543, -123.461112976074, -2.15480291960919, 218, 43, 'PPL', 'P'),
(203446, 'Clifton', 40.1044387817383, 0.699954501405837, -113.816390991211, -1.98647076553384, 218, 52, 'PPL', 'P'),
(209372, 'Clifton', 43.6408309936523, 0.761676189145622, -104.093887329102, -1.81678106509283, 218, 59, 'PPL', 'P'),
(1627, 'Clifton (historical)', 34.9902801513672, 0.610695594836577, -87.102783203125, -1.52023035454534, 218, 2, 'PPL', 'P'),
(190047, 'Clifton (historical)', 39.4983291625977, 0.689375892923824, -117.07861328125, -2.04340728542697, 218, 39, 'PPL', 'P'),
(93304, 'Clifton Beach', 29.5111103057861, 0.515066040755199, -94.976936340332, -1.65766025259585, 218, 51, 'PPL', 'P'),
(54102, 'Clifton City', 38.764720916748, 0.676572013613968, -93.0411071777344, -1.62387365995239, 218, 29, 'PPL', 'P'),
(39810, 'Clifton Crossing', 31.2341709136963, 0.545139121574646, -92.8219375610352, -1.62004842852066, 218, 22, 'PPL', 'P'),
(100898, 'Clifton Forge', 37.8161087036133, 0.660015607170136, -79.8247222900391, -1.39320422845129, 218, 53, 'PPL', 'P'),
(54104, 'Clifton Heights', 38.6091690063477, 0.673857120619714, -90.2861099243164, -1.57578988699685, 218, 29, 'PPL', 'P'),
(72147, 'Clifton Heights', 39.1355590820313, 0.683044360590215, -84.5250015258789, -1.47523957687982, 218, 41, 'PPL', 'P'),
(78043, 'Clifton Heights', 39.9291687011719, 0.696895461419717, -75.2966690063477, -1.31417478994513, 218, 45, 'PPL', 'P'),
(100912, 'Clifton Heights', 37.295280456543, 0.650925439421369, -79.9119415283203, -1.39472649133038, 218, 53, 'PPL', 'P'),
(124536, 'Clifton Heights', 42.0569381713867, 0.734032044398381, -71.0305633544922, -1.23971720008232, 218, 23, 'PPL', 'P'),
(147867, 'Clifton Heights', 42.7358283996582, 0.745880914141335, -78.9169387817383, -1.37736041733614, 218, 40, 'PPL', 'P'),
(54103, 'Clifton Hill', 39.438060760498, 0.68832401087227, -92.6661071777344, -1.61732867525742, 218, 29, 'PPL', 'P'),
(85871, 'Clifton Hills', 35.0091705322266, 0.611025294179529, -85.29638671875, -1.48870278829655, 218, 50, 'PPL', 'P'),
(85872, 'Clifton Junction', 35.3086090087891, 0.616251481502701, -87.9488906860352, -1.53499771594789, 218, 50, 'PPL', 'P'),
(45844, 'Clifton Knoll', 39.422779083252, 0.688057295289098, -77.4813919067383, -1.35230539780067, 218, 25, 'PPL', 'P'),
(130256, 'Clifton Mill', 42.7849998474121, 0.746739117802613, -83.0861129760742, -1.45012623411648, 218, 27, 'PPL', 'P'),
(35283, 'Clifton Mills', 37.8672218322754, 0.660907699556285, -86.3880615234375, -1.50775610799941, 218, 21, 'PPL', 'P'),
(108625, 'Clifton Mills', 39.6969413757324, 0.692842329977698, -79.6180572509766, -1.38959724307089, 218, 58, 'PPL', 'P'),
(45846, 'Clifton on the Potomac', 38.3699989318848, 0.669682815348097, -76.9733276367188, -1.34343800347709, 218, 25, 'PPL', 'P'),
(147868, 'Clifton Park', 42.8655586242676, 0.74814513370012, -73.7713928222656, -1.28755369853065, 218, 40, 'PPL', 'P'),
(154762, 'Clifton Park', 41.4872207641602, 0.724088599836353, -81.8024978637695, -1.42772292407841, 218, 41, 'PPL', 'P'),
(147869, 'Clifton Park Center', 42.8583297729492, 0.748018966443478, -73.8208312988281, -1.28841656272383, 218, 40, 'PPL', 'P'),
(13560, 'Clifton Park Manor', 39.7583312988281, 0.693913786263264, -75.5124969482422, -1.317941698149, 218, 10, 'PPL', 'P'),
(45845, 'Clifton Park Village', 39.0011100769043, 0.680697782774719, -76.9922180175781, -1.34376770282004, 218, 25, 'PPL', 'P'),
(147871, 'Clifton Springs', 42.961669921875, 0.749822592291734, -77.1402816772461, -1.3463519011838, 218, 40, 'PPL', 'P'),
(80372, 'Clifton Station', 34.996940612793, 0.610811841818159, -81.8194427490234, -1.42801866811746, 218, 48, 'PPL', 'P'),
(26816, 'Clifton Terrace', 38.9294395446777, 0.679446896010709, -90.2555618286133, -1.57525672214662, 218, 18, 'PPL', 'P'),
(45847, 'Cliftonbrook', 39.1416702270508, 0.683151020191873, -76.9888916015625, -1.34370964590828, 218, 25, 'PPL', 'P'),
(20101, 'Cliftondale', 33.644718170166, 0.587211107974959, -84.5947189331055, -1.47645637518188, 218, 13, 'PPL', 'P'),
(124537, 'Cliftondale', 42.4486083984375, 0.740867979442451, -71.0111083984375, -1.23937764704333, 218, 23, 'PPL', 'P'),
(100903, 'Cliftondale Park', 37.8233299255371, 0.660141641268724, -79.7988891601563, -1.39275335527874, 218, 53, 'PPL', 'P'),
(35284, 'Cliftons', 38.2552795410156, 0.667680584261548, -85.7158279418945, -1.49602341865901, 218, 21, 'PPL', 'P'),
(15560, 'Cliftonville', 30.0444393157959, 0.524374387976271, -82.392219543457, -1.43801550905934, 218, 12, 'PPL', 'P'),
(59042, 'Cliftonville', 33.2355613708496, 0.580069974669966, -88.4250030517578, -1.54330744433921, 218, 30, 'PPL', 'P'),
(63742, 'Cliftonville', 35.8227806091309, 0.625225468848913, -77.9488906860352, -1.36046479074846, 218, 33, 'PPL', 'P'),
(180770, 'Cliftwood Mobile Home Park', 36.9900016784668, 0.645597319607474, -121.938606262207, -2.12823016456849, 218, 6, 'PPL', 'P'),
(1629, 'Clifty', 34.2991714477539, 0.598633472469336, -87.0738906860352, -1.51972608499294, 218, 2, 'PPL', 'P'),
(8142, 'Clifty', 36.2372207641602, 0.63245881410665, -93.7961120605469, -1.63705098102611, 218, 4, 'PPL', 'P'),
(35285, 'Clifty', 36.9952812194824, 0.645689464981191, -87.1477813720703, -1.52101572075081, 218, 21, 'PPL', 'P'),
(85873, 'Clifty', 35.9002799987793, 0.626578088366565, -85.2200012207031, -1.48736960985486, 218, 50, 'PPL', 'P'),
(108626, 'Clifty', 38.1455612182617, 0.665765638279726, -80.9622192382813, -1.4130572954295, 218, 58, 'PPL', 'P'),
(26817, 'Clifty Heights', 37.6005592346191, 0.656253559235263, -88.9436111450195, -1.55235886309411, 218, 18, 'PPL', 'P'),
(180771, 'Clima', 38.249439239502, 0.667578651770825, -122.070556640625, -2.13053313312113, 218, 6, 'PPL', 'P'),
(20102, 'Climax', 30.8758296966553, 0.538884887491677, -84.4313888549805, -1.47360572755105, 218, 13, 'PPL', 'P'),
(32102, 'Climax', 37.7197189331055, 0.658333288309533, -96.2230606079102, -1.67940922395409, 218, 20, 'PPL', 'P'),
(35286, 'Climax', 37.4697189331055, 0.653969965179547, -84.2249984741211, -1.47000353586061, 218, 21, 'PPL', 'P'),
(63743, 'Climax', 35.9127807617188, 0.626796267838869, -79.7177810668945, -1.39133775200131, 218, 33, 'PPL', 'P'),
(80373, 'Climax', 34.0661087036133, 0.594565760220349, -81.458610534668, -1.42172095792969, 218, 48, 'PPL', 'P'),
(93306, 'Climax', 31.4886093139648, 0.549579909402839, -94.6930618286133, -1.65270570770386, 218, 51, 'PPL', 'P'),
(100904, 'Climax', 36.8869400024414, 0.643798554028208, -79.4894409179688, -1.38735246458806, 218, 53, 'PPL', 'P'),
(115024, 'Climax', 40.9305610656738, 0.714373055284607, -95.3655624389648, -1.66444305757617, 218, 16, 'PPL', 'P'),
(130257, 'Climax', 42.2383308410645, 0.73719794372324, -85.3349990844727, -1.48937670121039, 218, 27, 'PPL', 'P'),
(134713, 'Climax', 47.607780456543, 0.830912518533284, -96.8166732788086, -1.68976971954282, 218, 28, 'PPL', 'P'),
(147873, 'Climax', 42.3658294677734, 0.739423214551083, -73.8513870239258, -1.28894986073212, 218, 40, 'PPL', 'P'),
(154763, 'Climax', 40.6305618286133, 0.70913708084443, -82.8880615234375, -1.44666958417961, 218, 41, 'PPL', 'P'),
(160172, 'Climax', 40.3852806091309, 0.704856115971155, -79.1244430541992, -1.38098205010253, 218, 45, 'PPL', 'P'),
(186546, 'Climax', 39.3688888549805, 0.68711673337111, -106.183059692383, -1.85324400147376, 218, 7, 'PPL', 'P'),
(200591, 'Climax', 42.295280456543, 0.738191902021085, -122.618606567383, -2.14009840880837, 218, 43, 'PPL', 'P'),
(207062, 'Climax', 46.246940612793, 0.807161382667521, -118.466110229492, -2.06762367553517, 218, 56, 'PPL', 'P'),
(54106, 'Climax Springs', 38.1041717529297, 0.665043255834042, -93.0500030517578, -1.62402892224395, 218, 29, 'PPL', 'P'),
(115025, 'Climbing Hill', 42.3416709899902, 0.739001569571497, -96.0774993896484, -1.67686870143221, 218, 16, 'PPL', 'P'),
(85874, 'Climer', 35.1758308410645, 0.613934065301141, -84.758056640625, -1.47930715597075, 218, 50, 'PPL', 'P'),
(15561, 'Clinch', 29.5741691589355, 0.516166625365188, -82.392219543457, -1.43801550905934, 218, 12, 'PPL', 'P'),
(100905, 'Clinch', 36.8163909912109, 0.64256724149821, -82.4977798461914, -1.43985788390146, 218, 53, 'PPL', 'P'),
(85879, 'Clinch River (historical)', 36.0322189331055, 0.628880857182129, -84.1677780151367, -1.46900485045183, 218, 50, 'PPL', 'P'),
(85876, 'Clinch View', 36.086109161377, 0.629821419100118, -84.1383285522461, -1.46849086036145, 218, 50, 'PPL', 'P'),
(100906, 'Clinchburg', 36.8319396972656, 0.642838617613289, -81.8147201538086, -1.42793624328172, 218, 53, 'PPL', 'P'),
(100907, 'Clinchco', 37.1611099243164, 0.648583721874862, -82.3600006103516, -1.43745318259517, 218, 53, 'PPL', 'P'),
(20104, 'Clinchfield', 32.413330078125, 0.565719331398992, -83.6383285522461, -1.45976421410148, 218, 13, 'PPL', 'P'),
(63745, 'Clinchfield', 35.6988906860352, 0.623063181780851, -81.9916687011719, -1.43102457803983, 218, 33, 'PPL', 'P'),
(100908, 'Clinchfield', 36.9555587768555, 0.644996177570416, -82.1838912963867, -1.43437949522306, 218, 53, 'PPL', 'P'),
(85877, 'Clinchmore', 36.2194404602051, 0.632148489260629, -84.2822189331055, -1.47100222126939, 218, 50, 'PPL', 'P'),
(100909, 'Clinchport', 36.6769409179688, 0.640133378577986, -82.7422180175781, -1.44412413480971, 218, 53, 'PPL', 'P'),
(85878, 'Clinchview Heights', 36.2547187805176, 0.632764212104655, -83.2388916015625, -1.45279272415792, 218, 50, 'PPL', 'P'),
(72148, 'Cline', 39.6074981689453, 0.691281251525721, -81.1594390869141, -1.41649943113843, 218, 41, 'PPL', 'P'),
(100910, 'Cline', 36.9330596923828, 0.644603494467684, -81.168327331543, -1.41665456027193, 218, 53, 'PPL', 'P'),
(191281, 'Cline', 29.2430591583252, 0.510387665668256, -100.082496643066, -1.74676909003768, 218, 51, 'PPL', 'P'),
(196234, 'Cline', 45.8822212219238, 0.800795828450987, -108.408332824707, -1.89208234438898, 218, 31, 'PPL', 'P'),
(207063, 'Cline', 48.0622215270996, 0.838844011470785, -117.750556945801, -2.0551349147613, 218, 56, 'PPL', 'P'),
(200593, 'Cline Falls (historical)', 44.2744407653809, 0.772734765835094, -121.258331298828, -2.11635712663864, 218, 43, 'PPL', 'P'),
(63747, 'Cline Street Apartments', 35.2938919067383, 0.615994619615562, -81.5316696166992, -1.42299607945962, 218, 33, 'PPL', 'P'),
(188330, 'Clines Corners', 35.0094413757324, 0.611030021290464, -105.668609619141, -1.84426515385856, 218, 38, 'PPL', 'P'),
(20105, 'Clines Crossroads', 32.7472190856934, 0.571546793917276, -85.021110534668, -1.48389831253199, 218, 13, 'PPL', 'P'),
(100911, 'Clines Hacking', 38.5644416809082, 0.673076481525185, -79.0261077880859, -1.37926577593803, 218, 53, 'PPL', 'P'),
(54107, 'Clines Island', 36.9038887023926, 0.644094364646288, -89.7936096191406, -1.56719413510446, 218, 29, 'PPL', 'P'),
(63748, 'Clingman', 36.1783294677734, 0.631430967083934, -80.9280624389648, -1.41246114681949, 218, 33, 'PPL', 'P'),
(180772, 'Clint', 36.4313888549805, 0.635847686593776, -119.772499084473, -2.09042446236594, 218, 6, 'PPL', 'P'),
(191282, 'Clint', 31.5922203063965, 0.55138826236203, -106.223609924316, -1.85395173653345, 218, 51, 'PPL', 'P'),
(1630, 'Clinton', 32.9136085510254, 0.574450837927953, -87.9925003051758, -1.53575884738743, 218, 2, 'PPL', 'P'),
(8145, 'Clinton', 35.5913887023926, 0.621186918213863, -92.4602813720703, -1.61373633726301, 218, 4, 'PPL', 'P'),
(20106, 'Clinton', 32.9986114501953, 0.575934418392209, -83.5555572509766, -1.45831958236816, 218, 13, 'PPL', 'P'),
(29516, 'Clinton', 39.6569404602051, 0.692144182297934, -87.398063659668, -1.52538397072881, 218, 19, 'PPL', 'P'),
(32103, 'Clinton', 38.9116706848145, 0.679136770901769, -95.3902816772461, -1.66487448967276, 218, 20, 'PPL', 'P'),
(35287, 'Clinton', 36.6672210693359, 0.639963735216548, -88.9933319091797, -1.55322665413532, 218, 21, 'PPL', 'P'),
(39811, 'Clinton', 30.8655605316162, 0.538705656750314, -91.0155563354492, -1.58852112858797, 218, 22, 'PPL', 'P'),
(45873, 'Clinton', 38.7649993896484, 0.676576873882958, -76.8986129760742, -1.34213398664933, 218, 25, 'PPL', 'P'),
(54109, 'Clinton', 37.8136100769043, 0.659971997907286, -91.559440612793, -1.59801369997745, 218, 29, 'PPL', 'P'),
(59043, 'Clinton', 32.3413887023926, 0.564463717524047, -90.3216705322266, -1.57641053668889, 218, 30, 'PPL', 'P'),
(63750, 'Clinton', 34.9977798461914, 0.610826489204155, -78.3236083984375, -1.36700484859542, 218, 33, 'PPL', 'P'),
(75477, 'Clinton', 35.5155601501465, 0.619863460310148, -98.9669418334961, -1.72729898562422, 218, 42, 'PPL', 'P'),
(80374, 'Clinton', 34.4724998474121, 0.601658623730584, -81.8808288574219, -1.429090057824, 218, 48, 'PPL', 'P'),
(85880, 'Clinton', 36.103328704834, 0.630121956829133, -84.1319427490234, -1.46837940706983, 218, 50, 'PPL', 'P'),
(93307, 'Clinton', 33.103328704834, 0.577762079269303, -96.2355575561523, -1.67962733684737, 218, 51, 'PPL', 'P'),
(100919, 'Clinton', 37.5424995422363, 0.655240226440488, -78.1258316040039, -1.36355299234851, 218, 53, 'PPL', 'P'),
(115026, 'Clinton', 41.8444404602051, 0.73032325968531, -90.188606262207, -1.57408812706029, 218, 16, 'PPL', 'P'),
(119168, 'Clinton', 40.1536102294922, 0.700812705067115, -88.9644393920898, -1.55272238458291, 218, 18, 'PPL', 'P'),
(124538, 'Clinton', 42.4166717529297, 0.740310579826298, -71.6833267211914, -1.25111007006762, 218, 23, 'PPL', 'P'),
(127125, 'Clinton', 44.6377792358398, 0.779076218443764, -69.5036087036133, -1.21306681389584, 218, 26, 'PPL', 'P'),
(130260, 'Clinton', 42.5869407653809, 0.74328233470769, -82.9199981689453, -1.44722698379577, 218, 27, 'PPL', 'P'),
(134715, 'Clinton', 45.4602813720703, 0.793431588825672, -96.4333267211914, -1.68307905993622, 218, 28, 'PPL', 'P'),
(145012, 'Clinton', 41.0713882446289, 0.716830953233669, -74.4508285522461, -1.2994120890745, 218, 37, 'PPL', 'P'),
(147874, 'Clinton', 43.0483283996582, 0.751335068053817, -75.3788909912109, -1.31560983429852, 218, 40, 'PPL', 'P'),
(154765, 'Clinton', 40.9266700744629, 0.71430514467681, -81.6305618286133, -1.4247220741621, 218, 41, 'PPL', 'P'),
(160176, 'Clinton', 40.0491714477539, 0.69898990445901, -79.4633331298828, -1.38689679772555, 218, 45, 'PPL', 'P'),
(173581, 'Clinton', 42.5577812194824, 0.742773404623376, -88.8649978637695, -1.55098680250051, 218, 57, 'PPL', 'P'),
(177201, 'Clinton', 40.1238899230957, 0.700293987865794, -80.6263885498047, -1.40719594418635, 218, 58, 'PPL', 'P'),
(177608, 'Clinton', 41.2786102294922, 0.720447659152051, -72.5280609130859, -1.26585346302035, 218, 8, 'PPL', 'P'),
(180773, 'Clinton', 38.3761100769043, 0.669789474949754, -120.667221069336, -2.10604030689179, 218, 6, 'PPL', 'P'),
(196235, 'Clinton', 46.7691688537598, 0.81627598491929, -113.711669921875, -1.98464303807772, 218, 31, 'PPL', 'P'),
(199235, 'Clinton', 42.7599983215332, 0.746302758858003, -102.348892211914, -1.78632515486668, 218, 35, 'PPL', 'P'),
(203449, 'Clinton', 40.3869400024414, 0.704885077848009, -111.934997558594, -1.95363425560928, 218, 52, 'PPL', 'P'),
(207064, 'Clinton', 47.9786109924316, 0.837384732351476, -122.354438781738, -2.13548781117117, 218, 56, 'PPL', 'P'),
(154766, 'Clinton (historical)', 40.4124984741211, 0.705331157330597, -82.4997177124023, -1.43989170604731, 218, 41, 'PPL', 'P'),
(180774, 'Clinton (historical)', 37.7963905334473, 0.659671460178271, -122.250282287598, -2.13366993741108, 218, 6, 'PPL', 'P'),
(190048, 'Clinton (historical)', 39.3972206115723, 0.68761121580651, -117.050827026367, -2.04292232379247, 218, 39, 'PPL', 'P'),
(45848, 'Clinton Acres', 38.7297210693359, 0.675961151038931, -76.8777770996094, -1.34177033200248, 218, 25, 'PPL', 'P'),
(177609, 'Clinton Beach', 41.2663917541504, 0.720234406527763, -72.5008316040039, -1.26537822192383, 218, 8, 'PPL', 'P'),
(115027, 'Clinton Center', 40.6091690063477, 0.708763705659601, -93.3844375610352, -1.62986590556313, 218, 16, 'PPL', 'P'),
(147875, 'Clinton Corners', 41.8300018310547, 0.730071258067161, -73.7627792358398, -1.28740336308711, 218, 40, 'PPL', 'P'),
(29512, 'Clinton Falls', 39.7191696166992, 0.693230285969495, -86.9638900756836, -1.5178062121631, 218, 19, 'PPL', 'P'),
(134716, 'Clinton Falls', 44.1388893127441, 0.770368946680722, -93.2466735839844, -1.62746147057295, 218, 28, 'PPL', 'P'),
(108628, 'Clinton Furnace', 39.5158309936523, 0.689681357500856, -79.966667175293, -1.39568163405534, 218, 58, 'PPL', 'P'),
(143638, 'Clinton Grove', 43.0780601501465, 0.751853984992219, -71.7588882446289, -1.25242886743943, 218, 36, 'PPL', 'P'),
(15562, 'Clinton Heights', 28.329439163208, 0.494441988641407, -82.1897201538086, -1.4344812279767, 218, 12, 'PPL', 'P'),
(45849, 'Clinton Heights', 38.7608299255371, 0.676504103006171, -76.8638916015625, -1.34152798434328, 218, 25, 'PPL', 'P'),
(147877, 'Clinton Heights', 42.6188888549805, 0.743839934060925, -73.7344436645508, -1.28690881407268, 218, 40, 'PPL', 'P'),
(45850, 'Clinton Hills', 38.7144393920898, 0.67569443545576, -76.9638900756836, -1.34327328696367, 218, 25, 'PPL', 'P'),
(147878, 'Clinton Hollow', 41.8450012207031, 0.730333046802316, -73.8163909912109, -1.28833906473611, 218, 40, 'PPL', 'P'),
(147879, 'Clinton Mills', 44.9605598449707, 0.78470980283469, -73.8805618286133, -1.28945905713254, 218, 40, 'PPL', 'P'),
(93308, 'Clinton Park', 29.7402801513672, 0.519065809106875, -95.2572174072266, -1.66255208004416, 218, 51, 'PPL', 'P'),
(147880, 'Clinton Park', 42.6241683959961, 0.743932079434642, -73.728889465332, -1.28681187500901, 218, 40, 'PPL', 'P'),
(207065, 'Clinton Park', 47.1680603027344, 0.823237954061948, -122.527221679688, -2.13850344163152, 218, 56, 'PPL', 'P'),
(115029, 'Clinton Stock Yards', 41.8166694641113, 0.729838564366915, -90.2225036621094, -1.57467974829645, 218, 16, 'PPL', 'P'),
(130262, 'Clinton Village', 42.7958297729492, 0.746928135660981, -84.5313873291016, -1.47535103017144, 218, 27, 'PPL', 'P'),
(143639, 'Clinton Village', 43.040828704834, 0.75120417368624, -71.9647216796875, -1.25602133859189, 218, 36, 'PPL', 'P'),
(45851, 'Clinton Woods', 38.7388916015625, 0.676121207020445, -76.9000015258789, -1.34215822141525, 218, 25, 'PPL', 'P'),
(147883, 'Clintondale', 41.6947212219238, 0.727710166023724, -74.0516662597656, -1.2924453928209, 218, 40, 'PPL', 'P'),
(160183, 'Clintondale', 41.017219543457, 0.715885531046691, -77.521110534668, -1.35299861863242, 218, 45, 'PPL', 'P'),
(147884, 'Clintondale Station', 41.7163887023926, 0.728088334898515, -74.0597229003906, -1.29258600772646, 218, 40, 'PPL', 'P'),
(1631, 'Clintonville', 31.4069404602051, 0.548154519008402, -85.894172668457, -1.4991361213411, 218, 2, 'PPL', 'P'),
(35289, 'Clintonville', 38.0849990844727, 0.664708629643074, -84.2683334350586, -1.4707598736102, 218, 21, 'PPL', 'P'),
(108629, 'Clintonville', 37.8938903808594, 0.661373153535804, -80.5991668701172, -1.40672083624788, 218, 58, 'PPL', 'P'),
(119171, 'Clintonville', 42.000560760498, 0.733048072954624, -88.2733306884766, -1.54066026221567, 218, 18, 'PPL', 'P'),
(130266, 'Clintonville', 42.6902809143066, 0.745085960555946, -83.3561096191406, -1.45483856450732, 218, 27, 'PPL', 'P'),
(147887, 'Clintonville', 42.6141700744629, 0.743757575804215, -74.958610534668, -1.30827455655006, 218, 40, 'PPL', 'P'),
(160184, 'Clintonville', 41.1991691589355, 0.719061150909528, -79.8730621337891, -1.39404791788463, 218, 45, 'PPL', 'P'),
(173586, 'Clintonville', 44.6205596923828, 0.778775680714748, -88.7622222900391, -1.54919303034828, 218, 57, 'PPL', 'P'),
(177611, 'Clintonville', 41.3941688537598, 0.722464537624595, -72.817497253418, -1.27090508013407, 218, 8, 'PPL', 'P'),
(177962, 'Clints Well', 34.5544395446777, 0.603088741235957, -111.312217712402, -1.94276469677817, 218, 5, 'PPL', 'P'),
(100913, 'Clintwood', 37.1500015258789, 0.648389843747504, -82.4561080932617, -1.43913057460776, 218, 53, 'PPL', 'P'),
(1632, 'Clio', 31.708610534668, 0.553419655062516, -85.6105575561523, -1.49418610382297, 218, 2, 'PPL', 'P'),
(15563, 'Clio', 30.3191699981689, 0.529169342939931, -84.8261108398438, -1.48049492581693, 218, 12, 'PPL', 'P'),
(35290, 'Clio', 36.8177795410156, 0.642591476264129, -84.1994400024414, -1.46955745637802, 218, 21, 'PPL', 'P'),
(39812, 'Clio', 30.309440612793, 0.528999533130925, -90.6097183227539, -1.58143791903669, 218, 22, 'PPL', 'P'),
(80376, 'Clio', 34.5794410705566, 0.603525100180566, -79.5466690063477, -1.38835128315489, 218, 48, 'PPL', 'P'),
(108631, 'Clio', 38.5811080932617, 0.673367365295249, -81.3013916015625, -1.41897696990053, 218, 58, 'PPL', 'P'),
(115035, 'Clio', 40.6349983215332, 0.709214512253124, -93.4511108398438, -1.63102957380144, 218, 16, 'PPL', 'P'),
(130267, 'Clio', 43.1775016784668, 0.753589567074624, -83.7341690063477, -1.46143694558216, 218, 27, 'PPL', 'P'),
(180775, 'Clio', 39.7433280944824, 0.693651930949082, -120.579170227051, -2.10450352978475, 218, 6, 'PPL', 'P'),
(154774, 'Clio (historical)', 40.0811080932617, 0.699547304075163, -81.5047225952148, -1.42252576521112, 218, 41, 'PPL', 'P'),
(54115, 'Clippard', 37.2694396972656, 0.650474433090764, -89.8713912963867, -1.56855168147012, 218, 29, 'PPL', 'P'),
(8146, 'Clipper', 33.5719413757324, 0.585940913293046, -93.8530578613281, -1.63804487274492, 218, 4, 'PPL', 'P'),
(20107, 'Clipper', 34.5424995422363, 0.602880348880658, -84.5830612182617, -1.47625290967459, 218, 13, 'PPL', 'P'),
(207066, 'Clipper', 48.7602806091309, 0.85102744082568, -122.200828552246, -2.13280680690179, 218, 56, 'PPL', 'P'),
(180776, 'Clipper Gap', 38.9694404602051, 0.680145043690473, -121.016387939453, -2.11213441841421, 218, 6, 'PPL', 'P'),
(45852, 'Clipper Hill Estates', 39.3769416809082, 0.687257281697639, -76.9336090087891, -1.34274478264534, 218, 25, 'PPL', 'P'),
(72152, 'Clipper Mills', 38.7636108398438, 0.676552639117038, -82.2094421386719, -1.43482544154759, 218, 41, 'PPL', 'P'),
(180777, 'Clipper Mills', 39.5327796936035, 0.689977168118936, -121.156387329102, -2.11457786871436, 218, 6, 'PPL', 'P'),
(108630, 'Clips Mill', 39.2513885498047, 0.685065966173694, -77.8399963378906, -1.35856422583652, 218, 58, 'PPL', 'P'),
(54116, 'Cliquot', 37.6938896179199, 0.65788248171601, -93.4775009155273, -1.63149016751197, 218, 29, 'PPL', 'P'),
(134721, 'Clitherall', 46.2750015258789, 0.807651137991987, -95.6308288574219, -1.66907282997322, 218, 28, 'PPL', 'P'),
(20108, 'Clito', 32.5122184753418, 0.567445259522445, -81.7538909912109, -1.42687457411316, 218, 13, 'PPL', 'P'),
(100915, 'Clito Mill', 36.6933288574219, 0.640419402079061, -81.0741729736328, -1.41501125672129, 218, 53, 'PPL', 'P'),
(115036, 'Clive', 41.6030616760254, 0.726110405156914, -93.7238922119141, -1.63579050688217, 218, 16, 'PPL', 'P'),
(203451, 'Clive', 40.708610534668, 0.710499287742005, -113.116668701172, -1.97425830772307, 218, 52, 'PPL', 'P'),
(100916, 'Cliveden', 37.1555595397949, 0.648486849390211, -76.5258331298828, -1.33562775094821, 218, 53, 'PPL', 'P'),
(63752, 'Cloaninger', 35.7755584716797, 0.624401287070561, -80.8513870239258, -1.41112290837172, 218, 33, 'PPL', 'P'),
(8147, 'Cloar', 35.3097190856934, 0.616270855999631, -90.4577789306641, -1.57878607638124, 218, 4, 'PPL', 'P'),
(127127, 'Clock Farm Corner', 43.4049987792969, 0.75756014052285, -70.4274978637695, -1.22919172166405, 218, 26, 'PPL', 'P'),
(113178, 'Clockville', 43.0416717529297, 0.751218887651262, -75.745002746582, -1.32199968986, 218, 40, 'PPL', 'P'),
(93309, 'Clodine', 29.7072200775146, 0.518488801967196, -95.6877822875977, -1.67006685485009, 218, 51, 'PPL', 'P'),
(160186, 'Cloe', 40.936939239502, 0.714484375418173, -78.9327774047852, -1.37763685345729, 218, 45, 'PPL', 'P'),
(1634, 'Cloester Valley', 33.2861099243164, 0.580952213360082, -87.1188888549805, -1.5205114511984, 218, 2, 'PPL', 'P'),
(611, 'Cloisters', 39.3869400024414, 0.687431785328066, -76.6266708374023, -1.33738770095459, 218, 25, 'PPL', 'P'),
(757, 'Cloisters', 34.1527786254883, 0.596078435719514, -79.7802810668945, -1.3924285827838, 218, 48, 'PPL', 'P'),
(13062, 'Cloisters', 38.9111099243164, 0.679126983784763, -77.0666732788086, -1.34506719227394, 218, 9, 'PPL', 'P'),
(160187, 'Clokeyville (historical)', 40.1811103820801, 0.701292673274574, -80.1377792358398, -1.39866810290175, 218, 45, 'PPL', 'P'),
(32105, 'Clonmel', 37.5627784729004, 0.655594160549359, -97.5536117553711, -1.70263172234347, 218, 20, 'PPL', 'P'),
(78045, 'Clonmell', 39.8822212219238, 0.696076073331327, -75.8263931274414, -1.32342021998545, 218, 45, 'PPL', 'P'),
(134724, 'Clontarf', 45.3763885498047, 0.791967382858347, -95.6783294677734, -1.66990187202056, 218, 28, 'PPL', 'P'),
(20109, 'Clopine', 32.4838905334473, 0.566950843666072, -83.8019409179688, -1.46261978858031, 218, 13, 'PPL', 'P'),
(45853, 'Clopper', 39.1497192382813, 0.683291501939374, -77.2433319091797, -1.34815046702598, 218, 25, 'PPL', 'P'),
(93310, 'Cloptins Crossing', 29.9802799224854, 0.52325459531692, -98.1152801513672, -1.712434685158, 218, 51, 'PPL', 'P'),
(1635, 'Clopton', 31.6083297729492, 0.551669425594116, -85.4300003051758, -1.49103478530508, 218, 2, 'PPL', 'P'),
(85881, 'Clopton', 35.4605598449707, 0.618903523895229, -89.67138671875, -1.5650609430713, 218, 50, 'PPL', 'P'),
(100918, 'Clopton', 37.4749984741211, 0.654062110553264, -77.4458312988281, -1.35168474810863, 218, 53, 'PPL', 'P'),
(20110, 'Clopton (historical)', 33.2236099243164, 0.579861382577585, -83.4305572509766, -1.45613792080317, 218, 13, 'PPL', 'P'),
(134727, 'Cloquet', 46.7216682434082, 0.815446942871949, -92.4591674804688, -1.61371689618705, 218, 28, 'PPL', 'P'),
(8148, 'Cloquet (historical)', 33.6172218322754, 0.586731206346527, -92.0972213745117, -1.60739974492333, 218, 4, 'PPL', 'P'),
(191283, 'Close City', 33.2108306884766, 0.579638342836291, -101.486671447754, -1.77127656365303, 218, 51, 'PPL', 'P'),
(100922, 'Closeburn Manor', 37.3091697692871, 0.651167853659593, -79.2627792358398, -1.3833964719468, 218, 53, 'PPL', 'P'),
(93311, 'Closner Colonia', 26.253999710083, 0.458218736758585, -98.1549987792969, -1.71312790598975, 218, 51, 'PPL', 'P'),
(35291, 'Closplint', 36.9038887023926, 0.644094364646288, -83.0688934326172, -1.44982569638746, 218, 21, 'PPL', 'P'),
(63753, 'Closs', 35.313060760498, 0.616329179227504, -77.4627838134766, -1.35198062530574, 218, 33, 'PPL', 'P'),
(141517, 'Closter', 41.8869400024414, 0.731065016627924, -97.8888931274414, -1.7084834862067, 218, 35, 'PPL', 'P'),
(145017, 'Closter', 40.9730606079102, 0.715114812227222, -73.9619369506836, -1.29087932094188, 218, 37, 'PPL', 'P'),
(75474, 'Clothier', 35.3197212219238, 0.616445426209086, -97.414436340332, -1.70020265311321, 218, 42, 'PPL', 'P'),
(108632, 'Clothier', 37.9466705322266, 0.662294340956863, -81.8105621337891, -1.42786367214202, 218, 58, 'PPL', 'P'),
(134729, 'Clotho', 46.019718170166, 0.803195602909257, -95.0425033569336, -1.65880461291625, 218, 28, 'PPL', 'P'),
(180778, 'Clotho', 36.7213897705078, 0.640909157403526, -119.60888671875, -2.0875688878871, 218, 6, 'PPL', 'P'),
(39813, 'Clotilda', 29.6719398498535, 0.517873045833656, -90.5347213745117, -1.58012897536092, 218, 22, 'PPL', 'P'),
(115037, 'Cloud', 41.1749992370605, 0.71863930619286, -93.2350006103516, -1.62725773874956, 218, 16, 'PPL', 'P'),
(72153, 'Cloud (historical)', 39.728328704834, 0.693390142213927, -81.7508316040039, -1.42682117773331, 218, 41, 'PPL', 'P'),
(75475, 'Cloud Chief', 35.252498626709, 0.615272170590851, -98.8427810668945, -1.72513197144522, 218, 42, 'PPL', 'P'),
(75476, 'Cloud Creek', 36.2666702270508, 0.632972804197036, -94.7694396972656, -1.6540387529875, 218, 42, 'PPL', 'P'),
(85884, 'Cloud Creek', 36.4036102294922, 0.635362858117327, -83.1377792358398, -1.45102798046158, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(35292, 'Cloud Crossing', 37.0327796936035, 0.646343936819078, -88.3883285522461, -1.54266735357121, 218, 21, 'PPL', 'P'),
(85882, 'Cloud Ford', 36.5894393920898, 0.63860618885088, -82.6055603027344, -1.44173900773744, 218, 50, 'PPL', 'P'),
(15564, 'Cloud Lake', 26.6758308410645, 0.465581078881623, -80.0741729736328, -1.39755796420135, 218, 12, 'PPL', 'P'),
(20111, 'Cloud Springs', 34.9633293151855, 0.610225214009042, -85.2561111450195, -1.48799984692682, 218, 13, 'PPL', 'P'),
(188331, 'Cloudcroft', 32.957218170166, 0.575211969367498, -105.741943359375, -1.84554506907845, 218, 38, 'PPL', 'P'),
(20112, 'Cloudland', 34.5158309936523, 0.602414894901139, -85.4944381713867, -1.49215943823342, 218, 13, 'PPL', 'P'),
(63754, 'Cloudland (historical)', 36.1041717529297, 0.630136670794156, -82.1327819824219, -1.43348746941594, 218, 33, 'PPL', 'P'),
(85883, 'Clouds', 36.459171295166, 0.636332581649252, -83.649169921875, -1.45995343169693, 218, 50, 'PPL', 'P'),
(75479, 'Cloudy', 34.3019409179688, 0.598681808843121, -95.2808303833008, -1.66296420422285, 218, 42, 'PPL', 'P'),
(1636, 'Clough', 32.4816703796387, 0.566912094672211, -85.7638931274414, -1.49686231440239, 218, 2, 'PPL', 'P'),
(202015, 'Clough', 44.5791702270508, 0.778053298269064, -102.804168701172, -1.79427122861115, 218, 49, 'PPL', 'P'),
(72154, 'Clough Heights', 39.086109161377, 0.682181296659948, -84.3002777099609, -1.4713174063844, 218, 41, 'PPL', 'P'),
(85885, 'Clouse Hill', 35.2916717529297, 0.615955870621702, -85.8013916015625, -1.49751678624028, 218, 50, 'PPL', 'P'),
(108633, 'Clouston', 39.8477783203125, 0.695474931294269, -80.5555572509766, -1.40595970480833, 218, 58, 'PPL', 'P'),
(39814, 'Cloutierville', 31.5430603027344, 0.550530258437834, -92.9180603027344, -1.62172608684935, 218, 22, 'PPL', 'P'),
(147889, 'Clove', 41.6708297729492, 0.727293181576045, -73.6752777099609, -1.28587617336001, 218, 40, 'PPL', 'P'),
(147890, 'Clove Valley', 41.6352806091309, 0.726672731621084, -73.6888885498047, -1.28611372732924, 218, 40, 'PPL', 'P'),
(39815, 'Clovelly Farms', 29.5402793884277, 0.515575137287081, -90.2930603027344, -1.5759111939845, 218, 22, 'PPL', 'P'),
(20113, 'Clover', 33.3738899230957, 0.582484263356177, -84.5766677856445, -1.47614132322492, 218, 13, 'PPL', 'P'),
(35293, 'Clover', 36.9280586242676, 0.644516209362957, -82.9655609130859, -1.44802220369726, 218, 21, 'PPL', 'P'),
(72155, 'Clover', 38.9986114501953, 0.680654173511869, -84.0430603027344, -1.46682811573486, 218, 41, 'PPL', 'P'),
(80378, 'Clover', 35.1111106872559, 0.612804485524784, -81.2266693115234, -1.41767281991472, 218, 48, 'PPL', 'P'),
(100921, 'Clover', 36.8325004577637, 0.642848404730295, -78.7336120605469, -1.37416076244446, 218, 53, 'PPL', 'P'),
(108635, 'Clover', 38.7230606079102, 0.675844904057349, -81.2897186279297, -1.41877323807714, 218, 58, 'PPL', 'P'),
(160189, 'Clover', 41.0588912963867, 0.716612840340391, -80.35888671875, -1.40252715647933, 218, 45, 'PPL', 'P'),
(173588, 'Clover', 44.0380592346191, 0.768609129832398, -87.7016677856445, -1.53068286234974, 218, 57, 'PPL', 'P'),
(194752, 'Clover', 42.5141716003418, 0.742012273183831, -114.686668395996, -2.00165997165306, 218, 17, 'PPL', 'P'),
(203453, 'Clover', 40.3369407653809, 0.704012426537818, -112.460563659668, -1.96280711450989, 218, 52, 'PPL', 'P'),
(194753, 'Clover (historical)', 45.1338882446289, 0.787734954095938, -114.994720458984, -2.00703649441976, 218, 17, 'PPL', 'P'),
(199878, 'Clover (historical)', 40.7550010681152, 0.711308955292417, -115.038330078125, -2.00779762585931, 218, 39, 'PPL', 'P'),
(200594, 'Clover (historical)', 44.1361083984375, 0.770320410569856, -117.877777099609, -2.05735532532016, 218, 43, 'PPL', 'P'),
(147891, 'Clover Bank', 42.7472190856934, 0.746079719116709, -78.8899993896484, -1.37689023624568, 218, 40, 'PPL', 'P'),
(8149, 'Clover Bend', 35.9808311462402, 0.627983971106017, -91.0930633544922, -1.58987388126368, 218, 4, 'PPL', 'P'),
(35294, 'Clover Bottom', 37.4988899230957, 0.654479095000943, -84.1513900756836, -1.46871882695076, 218, 21, 'PPL', 'P'),
(54119, 'Clover Bottom', 38.5036087036133, 0.672014745777597, -91.1194381713867, -1.5903342086581, 218, 29, 'PPL', 'P'),
(100923, 'Clover Creek', 38.2700004577637, 0.667937512727713, -79.5491714477539, -1.38839495899677, 218, 53, 'PPL', 'P'),
(160188, 'Clover Creek', 40.3063888549805, 0.703479195108556, -78.2794418334961, -1.36623399661789, 218, 45, 'PPL', 'P'),
(45854, 'Clover Dale Acres', 38.3463897705078, 0.669270757748434, -76.7588882446289, -1.33969533003915, 218, 25, 'PPL', 'P'),
(45855, 'Clover Field', 39.6133308410645, 0.691383050858389, -76.4749984741211, -1.33474051883105, 218, 25, 'PPL', 'P'),
(180779, 'Clover Flat', 32.6619415283203, 0.570058419763058, -116.413612365723, -2.03180082992225, 218, 6, 'PPL', 'P'),
(63756, 'Clover Fork Acres', 35.4072189331055, 0.617972549357164, -80.1958312988281, -1.39968130253847, 218, 33, 'PPL', 'P'),
(63755, 'Clover Garden', 36.1883316040039, 0.631605537293389, -79.4630584716797, -1.38689200403558, 218, 33, 'PPL', 'P'),
(20114, 'Clover Heights', 31.2252807617188, 0.544983959151635, -81.5325012207031, -1.42301059368757, 218, 13, 'PPL', 'P'),
(1637, 'Clover Hill', 31.9977798461914, 0.558466611644325, -86.7016677856445, -1.5132295698298, 218, 2, 'PPL', 'P'),
(45856, 'Clover Hill', 39.4561080932617, 0.688638996250199, -77.4291687011719, -1.35139393091759, 218, 25, 'PPL', 'P'),
(59044, 'Clover Hill', 34.2750015258789, 0.598211627752667, -90.5441665649414, -1.58029382503239, 218, 30, 'PPL', 'P'),
(80379, 'Clover Hill', 34.4472198486328, 0.601217404516985, -82.6341705322266, -1.44223835044183, 218, 48, 'PPL', 'P'),
(85886, 'Clover Hill', 35.7044410705566, 0.623160054265502, -84.0497207641602, -1.46694436271644, 218, 50, 'PPL', 'P'),
(100926, 'Clover Hill', 38.4519386291504, 0.671112932853469, -79.0302810668945, -1.37933861339385, 218, 53, 'PPL', 'P'),
(154775, 'Clover Hill', 41.4888916015625, 0.724117761450289, -80.8777770996094, -1.41158350208225, 218, 41, 'PPL', 'P'),
(160190, 'Clover Hill', 40.0858306884766, 0.699629728910901, -79.9791717529297, -1.39589988010667, 218, 45, 'PPL', 'P'),
(85887, 'Clover Hill Estates', 35.7013893127441, 0.623106791043701, -84.0438919067383, -1.4668426299628, 218, 50, 'PPL', 'P'),
(203457, 'Clover Hollow', 40.6577796936035, 0.709612122203873, -111.907783508301, -1.95315928082886, 218, 52, 'PPL', 'P'),
(203458, 'Clover Hollow Condo', 40.6588897705078, 0.709631496700803, -111.907501220703, -1.95315435398084, 218, 52, 'PPL', 'P'),
(70674, 'Clover Leaf Lakes', 39.4702796936035, 0.68888633733644, -74.7108306884766, -1.30394998241394, 218, 37, 'PPL', 'P'),
(108637, 'Clover Lick', 38.3308296203613, 0.668999181896273, -79.9711074829102, -1.39575913204306, 218, 58, 'PPL', 'P'),
(207067, 'Clover Park', 47.1605606079102, 0.823107059694371, -122.519439697266, -2.13836762041593, 218, 56, 'PPL', 'P'),
(209943, 'Clover Pass', 55.4722213745117, 0.968172906380404, -131.79167175293, -2.30019859879623, 218, 1, 'PPL', 'P'),
(20116, 'Clover Reach', 33.3808288574219, 0.582605370606749, -84.5744400024414, -1.476102441073, 218, 13, 'PPL', 'P'),
(160191, 'Clover Run', 40.9338912963867, 0.714431178775398, -78.7802810668945, -1.37497529026386, 218, 45, 'PPL', 'P'),
(108638, 'Clover Run (historical)', 39.0869407653809, 0.682195810887888, -79.6922225952148, -1.39089167251872, 218, 58, 'PPL', 'P'),
(200595, 'Clover Station (historical)', 42.2222213745117, 0.736916780491155, -122.070831298828, -2.1305379268111, 218, 43, 'PPL', 'P'),
(29517, 'Clover Village', 39.6074981689453, 0.691281251525721, -85.8591690063477, -1.49852519218703, 218, 19, 'PPL', 'P'),
(35295, 'Clover-Darby', 36.8936080932617, 0.643914934167844, -83.0630569458008, -1.44972383047577, 218, 21, 'PPL', 'P'),
(85888, 'Cloverbottom (historical)', 36.4708290100098, 0.636536047156534, -82.5986099243164, -1.44161770074979, 218, 50, 'PPL', 'P'),
(85889, 'Clovercroft', 35.9236106872559, 0.626985285697238, -86.7666702270508, -1.51436407645417, 218, 50, 'PPL', 'P'),
(1642, 'Cloverdale', 33.2338905334473, 0.58004081305603, -87.6350021362305, -1.52951932726949, 218, 2, 'PPL', 'P'),
(8150, 'Cloverdale', 34.6730613708496, 0.605159082667384, -92.3505630493164, -1.61182139128119, 218, 4, 'PPL', 'P'),
(20117, 'Cloverdale', 34.7211112976074, 0.60599771209465, -85.5280609130859, -1.49274626577962, 218, 13, 'PPL', 'P'),
(29521, 'Cloverdale', 39.514720916748, 0.689661983003926, -86.7938919067383, -1.51483918439264, 218, 19, 'PPL', 'P'),
(32107, 'Cloverdale', 37.2269401550293, 0.64973267614815, -96.4888916015625, -1.68404885004717, 218, 20, 'PPL', 'P'),
(39816, 'Cloverdale', 31.1986103057861, 0.544518471882603, -92.4763870239258, -1.61401743391607, 218, 22, 'PPL', 'P'),
(45859, 'Cloverdale', 39.5283317565918, 0.689899536973161, -76.4305572509766, -1.33396487316357, 218, 25, 'PPL', 'P'),
(54118, 'Cloverdale', 37.6347198486328, 0.656849774424305, -93.0263900756836, -1.62361679806526, 218, 29, 'PPL', 'P'),
(59045, 'Cloverdale', 31.4977798461914, 0.549739965384353, -91.4205627441406, -1.59558982391132, 218, 30, 'PPL', 'P'),
(63763, 'Cloverdale', 35.8663902282715, 0.625986600288458, -81.5802764892578, -1.42384442942487, 218, 33, 'PPL', 'P'),
(80380, 'Cloverdale', 34.4816703796387, 0.601818679712098, -82.6975021362305, -1.44334369545227, 218, 48, 'PPL', 'P'),
(85890, 'Cloverdale', 36.2338905334473, 0.632400690615859, -89.3302764892578, -1.55910744645443, 218, 50, 'PPL', 'P'),
(100933, 'Cloverdale', 38.6238899230957, 0.674114049085879, -77.3244400024414, -1.34956607030341, 218, 53, 'PPL', 'P'),
(108640, 'Cloverdale', 37.4500007629395, 0.653625818187682, -80.815559387207, -1.41049759814777, 218, 58, 'PPL', 'P'),
(115038, 'Cloverdale', 43.3469390869141, 0.756546807728075, -95.6855621337891, -1.67002810585623, 218, 16, 'PPL', 'P'),
(119174, 'Cloverdale', 40.6402816772461, 0.709306724205868, -89.51611328125, -1.56235091034604, 218, 18, 'PPL', 'P'),
(134735, 'Cloverdale', 46.0122184753418, 0.80306470854168, -92.7397232055664, -1.61861351732532, 218, 28, 'PPL', 'P'),
(154777, 'Cloverdale', 41.3413887023926, 0.721543350203537, -83.5738906860352, -1.45863956117314, 218, 41, 'PPL', 'P'),
(171863, 'Cloverdale', 44.6063919067383, 0.778528406207534, -72.9316711425781, -1.27289779041972, 218, 55, 'PPL', 'P'),
(173590, 'Cloverdale', 44.0250015258789, 0.768381229822114, -90.1788864135742, -1.57391848369885, 218, 57, 'PPL', 'P'),
(188332, 'Cloverdale', 31.4169406890869, 0.548329055928343, -108.929168701172, -1.9011726452958, 218, 38, 'PPL', 'P'),
(193455, 'Cloverdale', 40.4736099243164, 0.706397753347174, -122.474716186523, -2.13758704790043, 218, 6, 'PPL', 'P'),
(194754, 'Cloverdale', 43.6197204589844, 0.761307740808809, -116.333061218262, -2.03039494718279, 218, 17, 'PPL', 'P'),
(200598, 'Cloverdale', 44.291389465332, 0.773030576453175, -121.451667785645, -2.11973148489783, 218, 43, 'PPL', 'P'),
(190049, 'Cloverdale (historical)', 38.565559387207, 0.673095989180169, -117.548332214355, -2.05160542736862, 218, 39, 'PPL', 'P'),
(45860, 'Cloverdale Farm', 38.375560760498, 0.66977988756983, -75.5622177124023, -1.3188094891902, 218, 25, 'PPL', 'P'),
(1647, 'Cloverdale Heights', 34.8697204589844, 0.608591431259306, -87.6919403076172, -1.53051308583025, 218, 2, 'PPL', 'P'),
(45861, 'Cloverfield', 39.5694389343262, 0.690616992570828, -76.6286087036133, -1.33742152310044, 218, 25, 'PPL', 'P'),
(45862, 'Cloverfield Manor', 39.398609161377, 0.68763545057243, -76.5027770996094, -1.3352253473075, 218, 25, 'PPL', 'P'),
(45864, 'Cloverfields', 38.9972190856934, 0.680629872166922, -76.3041687011719, -1.33175897683265, 218, 25, 'PPL', 'P'),
(85892, 'Cloverhill', 36.1563911437988, 0.631048071098208, -86.658332824707, -1.51247323208022, 218, 50, 'PPL', 'P'),
(145018, 'Cloverhill', 40.4880599975586, 0.706649954702405, -74.7825012207031, -1.30520086917795, 218, 37, 'PPL', 'P'),
(63759, 'Cloverhill Plantation', 36.0130615234375, 0.628546497307269, -81.5066680908203, -1.42255972051502, 218, 33, 'PPL', 'P'),
(29519, 'Cloverland', 39.5013885498047, 0.68942928930368, -87.2313919067383, -1.52247499987012, 218, 19, 'PPL', 'P'),
(100934, 'Cloverland', 37.5924987792969, 0.65611287775068, -77.4300003051758, -1.35140844514553, 218, 53, 'PPL', 'P'),
(173593, 'Cloverland', 46.6769409179688, 0.814666303777419, -91.6788864135742, -1.60009842247877, 218, 57, 'PPL', 'P'),
(207068, 'Cloverland', 46.250560760498, 0.807224566164383, -117.249443054199, -2.04638882742537, 218, 56, 'PPL', 'P'),
(85894, 'Cloverland Acres', 36.0294418334961, 0.628832387650289, -86.7641677856445, -1.51432040061229, 218, 50, 'PPL', 'P'),
(45865, 'Cloverlea', 38.877498626709, 0.678540355975646, -76.5138931274414, -1.33541935859291, 218, 25, 'PPL', 'P'),
(93312, 'Cloverleaf', 29.7780609130859, 0.519725207792779, -95.1716690063477, -1.66105897877901, 218, 51, 'PPL', 'P'),
(177963, 'Cloverleaf', 33.3444404602051, 0.581970273265792, -111.862503051758, -1.95236898777538, 218, 5, 'PPL', 'P'),
(154778, 'Cloverleaf (historical)', 41.4716682434082, 0.723817157142246, -84.0766677856445, -1.46741467696495, 218, 41, 'PPL', 'P'),
(170050, 'Cloverleaf Colony', 44.1824989318848, 0.771130078120267, -97.5366668701172, -1.70233597830442, 218, 49, 'PPL', 'P'),
(100935, 'Cloverleaf Farm Estates', 38.8069381713867, 0.677308843708566, -77.398063659668, -1.35085104552938, 218, 53, 'PPL', 'P'),
(134736, 'Cloverleaf Mobile Home Community', 45.5722198486328, 0.795385283801354, -94.1388931274414, -1.64303363925691, 218, 28, 'PPL', 'P'),
(80381, 'Cloverleaf Mobile Home Park', 33.0372200012207, 0.576608264727026, -80.1555633544922, -1.3989784943268, 218, 48, 'PPL', 'P'),
(45866, 'Cloverly', 39.1080589294434, 0.682564392382755, -76.9980621337891, -1.34386970188979, 218, 25, 'PPL', 'P'),
(194141, 'Cloverly', 40.4566688537598, 0.706102075887148, -104.625831604004, -1.82606524412701, 218, 7, 'PPL', 'P'),
(160194, 'Cloverly Acres', 40.5527801513672, 0.707779534478762, -76.9358291625977, -1.3427835316392, 218, 45, 'PPL', 'P'),
(35297, 'Cloverport', 37.8333282470703, 0.660316144899152, -86.6327819824219, -1.51202728575568, 218, 21, 'PPL', 'P'),
(85893, 'Cloverport', 35.3974990844727, 0.617802905995726, -89.0175018310547, -1.55364849885199, 218, 50, 'PPL', 'P'),
(45867, 'Cloverton', 39.6066703796387, 0.691266803876807, -77.8091735839844, -1.35802626729632, 218, 25, 'PPL', 'P'),
(134737, 'Cloverton', 46.1680603027344, 0.805784661542005, -92.3194427490234, -1.61127823957686, 218, 28, 'PPL', 'P'),
(35296, 'Clovertown', 36.8511085510254, 0.64317317722523, -83.3086090087891, -1.45400952245998, 218, 21, 'PPL', 'P'),
(45868, 'Cloverview', 39.4622192382813, 0.688745655851857, -77.4225006103516, -1.35127755077795, 218, 25, 'PPL', 'P'),
(130269, 'Cloverville', 43.190559387207, 0.753817467084907, -86.165283203125, -1.5038678928079, 218, 27, 'PPL', 'P'),
(180781, 'Clovis', 36.8252792358398, 0.642722370631707, -119.701942443848, -2.08919301667789, 218, 6, 'PPL', 'P'),
(188333, 'Clovis', 34.4047203063965, 0.600475647574371, -103.204719543457, -1.80126215963066, 218, 38, 'PPL', 'P'),
(80382, 'Clovis Point', 34.7324981689453, 0.606196450490997, -82.95361328125, -1.44781367818391, 218, 48, 'PPL', 'P'),
(112226, 'Clow', 33.889720916748, 0.591487212579245, -93.7724990844727, -1.63663885684742, 218, 4, 'PPL', 'P'),
(93313, 'Clower', 32.542781829834, 0.567978690688788, -95.6944427490234, -1.67018310183167, 218, 51, 'PPL', 'P'),
(1651, 'Clowers Crossroads', 31.5913906097412, 0.551373781423603, -85.8933334350586, -1.4991214739551, 218, 2, 'PPL', 'P'),
(130270, 'Clowry', 46.5233306884766, 0.811985299508036, -87.898063659668, -1.53411061698878, 218, 27, 'PPL', 'P'),
(154779, 'Clowville (historical)', 40.2416687011719, 0.702349615332199, -81.8644409179688, -1.42880403432292, 218, 41, 'PPL', 'P'),
(85896, 'Cloyd Creek (historical)', 35.6986083984375, 0.623058254932834, -84.1388931274414, -1.46850071405748, 218, 50, 'PPL', 'P'),
(35298, 'Cloyds Landing', 36.7541694641113, 0.641481270984703, -85.4911117553711, -1.49210138132165, 218, 21, 'PPL', 'P'),
(160193, 'Club Estates', 40.3300018310547, 0.703891319287246, -76.845832824707, -1.34121279922827, 218, 45, 'PPL', 'P'),
(80384, 'Club Forest', 33.8969383239746, 0.591613180098805, -80.3705596923828, -1.40273088830272, 218, 48, 'PPL', 'P'),
(13561, 'Club House Landing', 38.5625, 0.673042592800313, -75.0911102294922, -1.31058711248263, 218, 10, 'PPL', 'P'),
(154780, 'Club Island', 40.5080604553223, 0.706999028542287, -84.4847183227539, -1.47453650235204, 218, 41, 'PPL', 'P'),
(63760, 'Club Pines', 35.5661087036133, 0.620745699000264, -77.3986129760742, -1.3508606329093, 218, 33, 'PPL', 'P'),
(85895, 'Club Springs', 36.1577796936035, 0.631072305864128, -85.8583297729492, -1.49851054480104, 218, 50, 'PPL', 'P'),
(54120, 'Clubb', 37.2144393920898, 0.649514496675845, -90.3455581665039, -1.57682745455754, 218, 29, 'PPL', 'P'),
(80388, 'Clubhouse Crossroads', 33.9599990844727, 0.592713797998308, -81.4022216796875, -1.42073678674886, 218, 48, 'PPL', 'P'),
(45869, 'Clubhouse Estates', 38.9041709899902, 0.679005876534192, -76.5727767944336, -1.33644707245758, 218, 25, 'PPL', 'P'),
(39819, 'Clubhouse Landing', 30.9669399261475, 0.540475060978563, -92.4752807617188, -1.61399812599816, 218, 22, 'PPL', 'P'),
(80389, 'Clubside Estates', 34.8763885498047, 0.608707811398942, -81.0444412231445, -1.41449233978289, 218, 48, 'PPL', 'P'),
(63764, 'Clubview Acres', 35.0227813720703, 0.611262848148764, -80.5880584716797, -1.40652695812052, 218, 33, 'PPL', 'P'),
(1654, 'Clubview Heights', 33.9780616760254, 0.593029049692346, -86.0158309936523, -1.50125945967822, 218, 2, 'PPL', 'P'),
(20120, 'Clubview Heights', 32.4952812194824, 0.567149648641446, -84.9533309936523, -1.48271533637578, 218, 13, 'PPL', 'P'),
(115039, 'Clucas', 41.4966697692871, 0.724253516086856, -94.0516662597656, -1.64151124321977, 218, 16, 'PPL', 'P'),
(20121, 'Cluese (historical)', 33.6119384765625, 0.586638994393783, -82.3566665649414, -1.43739499252536, 218, 13, 'PPL', 'P'),
(143640, 'Cluffs Crossing', 42.7652816772461, 0.746394970810747, -71.2180633544922, -1.24298969242981, 218, 36, 'PPL', 'P'),
(203462, 'Cluistos', 40.6388893127441, 0.709282422860921, -111.930282592773, -1.95355196393159, 218, 52, 'PPL', 'P'),
(45870, 'Clumber', 39.0247192382813, 0.681109840374381, -76.5461120605469, -1.33598168505708, 218, 25, 'PPL', 'P'),
(147892, 'Clums Corner', 42.750560760498, 0.746138042344582, -73.5725021362305, -1.28408240120778, 218, 40, 'PPL', 'P'),
(122399, 'Clunette', 41.3197212219238, 0.721165181328745, -85.9227828979492, -1.49963546404549, 218, 19, 'PPL', 'P'),
(147893, 'Cluny Point', 42.8250007629395, 0.747437265482377, -77.709716796875, -1.35629041889781, 218, 40, 'PPL', 'P'),
(199879, 'Cluro', 40.5808296203613, 0.708269090066146, -116.32250213623, -2.03021065643536, 218, 39, 'PPL', 'P'),
(108641, 'Cluster', 39.3233299255371, 0.686321580048639, -81.3258285522461, -1.41940347514911, 218, 58, 'PPL', 'P'),
(15565, 'Cluster Springs', 30.8383293151855, 0.538230382364276, -86.2052764892578, -1.50456590732961, 218, 12, 'PPL', 'P'),
(100937, 'Cluster Springs', 36.6208305358887, 0.639154067666137, -78.9219436645508, -1.37744776901989, 218, 53, 'PPL', 'P'),
(93314, 'Clute', 29.0244407653809, 0.506572054905959, -95.3986129760742, -1.66501989826828, 218, 51, 'PPL', 'P'),
(8152, 'Clutes (historical)', 36.0430603027344, 0.629070074777579, -92.8833312988281, -1.62111995138525, 218, 4, 'PPL', 'P'),
(115040, 'Clutier', 42.0794410705566, 0.734424794080141, -92.4019393920898, -1.61271807762022, 218, 16, 'PPL', 'P'),
(93315, 'Clutter Point', 33.5080604553223, 0.584825980902684, -96.0933303833008, -1.6771450043953, 218, 51, 'PPL', 'P'),
(35299, 'Clutts', 36.9719390869141, 0.645282067913436, -82.9705581665039, -1.44810942222296, 218, 21, 'PPL', 'P'),
(1655, 'Cluttsville', 34.8305587768555, 0.607907930965537, -86.7491683959961, -1.51405861187714, 218, 2, 'PPL', 'P'),
(113283, 'Cly', 40.1238899230957, 0.700293987865794, -76.7366714477539, -1.33930757378443, 218, 45, 'PPL', 'P'),
(20122, 'Clyattville', 30.6913890838623, 0.535665791524043, -83.3152770996094, -1.45412590259962, 218, 13, 'PPL', 'P'),
(80390, 'Clyburn', 34.4186096191406, 0.600718061812595, -80.5994415283203, -1.40672562993784, 218, 48, 'PPL', 'P'),
(8151, 'Clyde', 35.8913917541504, 0.626422959233067, -94.4063873291016, -1.64770229380588, 218, 4, 'PPL', 'P'),
(32108, 'Clyde', 39.5911102294922, 0.690995228024647, -97.3986129760742, -1.69992648330817, 218, 20, 'PPL', 'P'),
(39820, 'Clyde', 31.6416702270508, 0.552251326292298, -93.6750030517578, -1.63493723006891, 218, 22, 'PPL', 'P'),
(59046, 'Clyde', 31.3500003814697, 0.547160727158125, -89.4677810668945, -1.56150735407075, 218, 30, 'PPL', 'P'),
(63765, 'Clyde', 35.5333290100098, 0.620173585419088, -82.9108276367188, -1.44706692781425, 218, 33, 'PPL', 'P'),
(75480, 'Clyde', 36.8463897705078, 0.643090818968519, -97.8208312988281, -1.70729558320247, 218, 42, 'PPL', 'P'),
(80391, 'Clyde', 34.3852806091309, 0.600136360851495, -80.1847229003906, -1.39948742441111, 218, 48, 'PPL', 'P'),
(93316, 'Clyde', 32.4058303833008, 0.565588437031415, -99.4933319091797, -1.73648622559472, 218, 51, 'PPL', 'P'),
(113182, 'Clyde', 43.084171295166, 0.751960644593877, -76.8697204589844, -1.34162971709692, 218, 40, 'PPL', 'P'),
(115041, 'Clyde', 41.8419418334961, 0.73027965042246, -93.2649993896484, -1.62778131621987, 218, 16, 'PPL', 'P'),
(130273, 'Clyde', 42.6808280944824, 0.744920977726416, -83.6180572509766, -1.45941041315066, 218, 27, 'PPL', 'P'),
(134739, 'Clyde', 43.894718170166, 0.766107356304378, -91.9791717529297, -1.60533939034599, 218, 28, 'PPL', 'P'),
(139092, 'Clyde', 40.2691688537598, 0.702829583539659, -94.668327331543, -1.65227400929116, 218, 29, 'PPL', 'P'),
(139810, 'Clyde', 48.7700004577637, 0.851197084187118, -98.8986129760742, -1.72610642208808, 218, 34, 'PPL', 'P'),
(141520, 'Clyde', 40.413330078125, 0.705345671558538, -99.4177780151367, -1.73516756138097, 218, 35, 'PPL', 'P'),
(145019, 'Clyde', 40.4863891601563, 0.706620793088468, -74.5108337402344, -1.30045937717317, 218, 37, 'PPL', 'P'),
(154781, 'Clyde', 41.3041687011719, 0.720893738634639, -82.9752807617188, -1.4481918470587, 218, 41, 'PPL', 'P'),
(160200, 'Clyde', 40.4497184753418, 0.705980768899495, -79.0702819824219, -1.38003676107361, 218, 45, 'PPL', 'P'),
(169321, 'Clyde', 41.7191696166992, 0.728136871009382, -71.5233306884766, -1.24831761250662, 218, 47, 'PPL', 'P'),
(173595, 'Clyde', 44.5161094665527, 0.776952680369562, -87.5827789306641, -1.52860786038641, 218, 57, 'PPL', 'P'),
(180783, 'Clyde', 32.9166717529297, 0.574504300886836, -114.965278625488, -2.00652263748743, 218, 6, 'PPL', 'P'),
(194755, 'Clyde', 44.1358299255371, 0.770315550300866, -113.246109008789, -1.97651746727578, 218, 17, 'PPL', 'P'),
(207071, 'Clyde', 47.6152801513672, 0.831043412900861, -122.213890075684, -2.1330347734911, 218, 56, 'PPL', 'P'),
(1656, 'Clyde (historical)', 34.3666687011719, 0.599811521777533, -85.8716735839844, -1.49874343823837, 218, 2, 'PPL', 'P'),
(207070, 'Clyde Hill', 47.6319389343262, 0.831334163512871, -122.216667175293, -2.13308324302294, 218, 56, 'PPL', 'P'),
(1657, 'Clyde Jones Subdivision', 33.2088890075684, 0.57960445411142, -87.4822235107422, -1.52685283722804, 218, 2, 'PPL', 'P'),
(196236, 'Clyde Park', 45.8869400024414, 0.800878186707697, -110.603057861328, -1.93038752245397, 218, 31, 'PPL', 'P'),
(45871, 'Clydesdale Acres', 39.5224990844727, 0.689797737640492, -76.8649978637695, -1.34154729226119, 218, 25, 'PPL', 'P'),
(85897, 'Clydeton (historical)', 36.1711082458496, 0.631304932985346, -87.9127807617188, -1.53436747887592, 218, 50, 'PPL', 'P'),
(173597, 'Clyman', 43.3113899230957, 0.755926357773114, -88.7200012207031, -1.54845613367466, 218, 57, 'PPL', 'P'),
(173604, 'Clyman Junction', 43.3252792358398, 0.756168772011338, -88.7177810668945, -1.5484173846808, 218, 57, 'PPL', 'P'),
(147897, 'Clymer', 42.0208282470703, 0.733401807326414, -79.6302795410156, -1.3898105622742, 218, 40, 'PPL', 'P'),
(160197, 'Clymer', 41.8566703796387, 0.73053671204668, -77.5986099243164, -1.35435123815007, 218, 45, 'PPL', 'P'),
(200599, 'Clymer (historical)', 44.9013900756836, 0.783677095542985, -122.801391601563, -2.14328860947818, 218, 43, 'PPL', 'P'),
(147894, 'Clymer Center', 42.0533294677734, 0.733969060638601, -79.5780563354492, -1.38889909539112, 218, 40, 'PPL', 'P'),
(147895, 'Clymer Hill', 42.0608291625977, 0.734099955006179, -79.6152801513672, -1.38954877353905, 218, 40, 'PPL', 'P'),
(122396, 'Clymers', 40.7075004577637, 0.710479913245075, -86.4488906860352, -1.50881777716797, 218, 19, 'PPL', 'P'),
(20123, 'Clyo', 32.4838905334473, 0.566950843666072, -81.267219543457, -1.41838055497441, 218, 13, 'PPL', 'P'),
(203464, 'Co Rae', 40.853328704834, 0.713025096298864, -111.879997253418, -1.95267431919436, 218, 52, 'PPL', 'P'),
(177964, 'Co-op Village', 33.3363914489746, 0.58182979151829, -112.207221984863, -1.95838546815203, 218, 5, 'PPL', 'P'),
(35300, 'Co-Operative', 36.6927795410156, 0.640409814699136, -84.607780456543, -1.47668434177119, 218, 21, 'PPL', 'P'),
(13562, 'Coach Hill', 39.711669921875, 0.693099391601918, -75.7055587768555, -1.32131126271822, 218, 10, 'PPL', 'P'),
(180785, 'Coachella', 33.6802787780762, 0.587831757667002, -116.173057556152, -2.02760235646374, 218, 6, 'PPL', 'P'),
(177614, 'Coachlight Village', 41.7772216796875, 0.729150070646103, -72.6136093139648, -1.26734656428551, 218, 8, 'PPL', 'P'),
(15566, 'Coachman', 27.9775009155273, 0.48829950745568, -82.7380599975586, -1.44405156367001, 218, 12, 'PPL', 'P'),
(80397, 'Coachmans Corners', 32.9677810668945, 0.575396326693959, -80.3019409179688, -1.40153326476051, 218, 48, 'PPL', 'P'),
(45872, 'Coachmans Field', 39.6291694641113, 0.69165948697954, -76.6577835083008, -1.33793071950086, 218, 25, 'PPL', 'P'),
(93317, 'Coady', 29.7841701507568, 0.519831834104923, -95.01611328125, -1.65834401920573, 218, 51, 'PPL', 'P'),
(59048, 'Coahoma', 34.3666687011719, 0.599811521777533, -90.523063659668, -1.57992550985363, 218, 30, 'PPL', 'P'),
(191284, 'Coahoma', 32.2963905334473, 0.563678351318583, -101.30583190918, -1.76812031828712, 218, 51, 'PPL', 'P'),
(85898, 'Coahulla Ranch', 35.0402793884277, 0.611568246146769, -84.8499984741211, -1.48091184368558, 218, 50, 'PPL', 'P'),
(35301, 'Coakley', 37.3761100769043, 0.652336182429811, -85.5355606079102, -1.49287716014719, 218, 21, 'PPL', 'P'),
(63767, 'Coakley', 35.9225006103516, 0.626965911200307, -77.4188919067383, -1.35121456701817, 218, 33, 'PPL', 'P'),
(100938, 'Coakley Town', 38.4533309936523, 0.671137234198416, -78.9686126708984, -1.37826229683929, 218, 53, 'PPL', 'P'),
(54121, 'Coal', 38.3258285522461, 0.668911896791546, -93.6149978637695, -1.63388994197024, 218, 29, 'PPL', 'P'),
(196237, 'Coal Banks Landing', 48.0338897705078, 0.838349529035385, -110.22721862793, -1.923827890373, 218, 31, 'PPL', 'P'),
(1658, 'Coal Bluff', 31.9449996948242, 0.557545424223266, -87.4383316040039, -1.52608677894048, 218, 2, 'PPL', 'P'),
(29520, 'Coal Bluff', 39.5827789306641, 0.690849819429128, -87.2200012207031, -1.52227619489474, 218, 19, 'PPL', 'P'),
(160201, 'Coal Castle', 40.7227783203125, 0.710746562249219, -76.2455596923828, -1.33073605665795, 218, 45, 'PPL', 'P'),
(160202, 'Coal Center', 40.0683288574219, 0.699324264333869, -79.9019393920898, -1.39455192112092, 218, 45, 'PPL', 'P'),
(1659, 'Coal City', 33.6605606079102, 0.587487610675136, -86.2633285522461, -1.50557910696633, 218, 2, 'PPL', 'P'),
(29522, 'Coal City', 39.230281829834, 0.684697584415909, -87.0458297729492, -1.51923632966847, 218, 19, 'PPL', 'P'),
(108642, 'Coal City', 37.6788902282715, 0.657620692980855, -81.210563659668, -1.41739172326166, 218, 58, 'PPL', 'P'),
(115042, 'Coal City', 40.5972213745117, 0.708555180146247, -92.7186126708984, -1.61824506898851, 218, 16, 'PPL', 'P'),
(119177, 'Coal City', 41.2877807617188, 0.720607715133565, -88.2855606079102, -1.54087371457704, 218, 18, 'PPL', 'P'),
(160204, 'Coal City', 41.3108291625977, 0.721009985616221, -79.8133316040039, -1.39300542347592, 218, 45, 'PPL', 'P'),
(192524, 'Coal City', 39.6666717529297, 0.692314025396454, -111.015556335449, -1.93758697898684, 218, 52, 'PPL', 'P'),
(75482, 'Coal Creek', 35.1888885498047, 0.614161965311424, -94.6605606079102, -1.65213845439168, 218, 42, 'PPL', 'P'),
(115043, 'Coal Creek', 41.4377784729004, 0.72322566906414, -92.3933334350586, -1.61256787533474, 218, 16, 'PPL', 'P'),
(122397, 'Coal Creek', 40.0363883972168, 0.698766798138688, -87.3805618286133, -1.52507850615178, 218, 19, 'PPL', 'P'),
(186548, 'Coal Creek', 38.3611106872559, 0.669527686214599, -105.14778137207, -1.83517498610979, 218, 7, 'PPL', 'P'),
(207072, 'Coal Creek', 46.2002792358398, 0.806346988006175, -123.015556335449, -2.14702648922616, 218, 56, 'PPL', 'P'),
(211761, 'Coal Creek', 65.3052825927734, 1.13979220018924, -143.153610229492, -2.49850183462127, 218, 1, 'PPL', 'P'),
(196238, 'Coal Creek (historical)', 47.5250015258789, 0.829467753641916, -106.04167175293, -1.85077631640769, 218, 31, 'PPL', 'P'),
(1660, 'Coal Fire', 33.4038887023926, 0.583007840826487, -88.084716796875, -1.53736832879222, 218, 2, 'PPL', 'P'),
(108643, 'Coal Fork', 38.3175010681152, 0.668766554775055, -81.521110534668, -1.42281178871219, 218, 58, 'PPL', 'P'),
(160208, 'Coal Glen', 41.211669921875, 0.719279330381833, -78.8550033569336, -1.37627944024967, 218, 45, 'PPL', 'P'),
(72158, 'Coal Grove', 38.5033302307129, 0.672009885508608, -82.647216796875, -1.44246605071503, 218, 41, 'PPL', 'P'),
(8153, 'Coal Hill', 35.4372215270996, 0.618496193406501, -93.6727828979492, -1.63489848107505, 218, 4, 'PPL', 'P'),
(54122, 'Coal Hill', 37.8783302307129, 0.661101577683643, -93.9333267211914, -1.63944582863636, 218, 29, 'PPL', 'P'),
(72159, 'Coal Hill', 39.7916717529297, 0.694495686961447, -81.7188873291016, -1.4262636449591, 218, 41, 'PPL', 'P'),
(85900, 'Coal Hill', 36.3077812194824, 0.63369032637373, -84.6130599975586, -1.4767764871449, 218, 50, 'PPL', 'P'),
(160205, 'Coal Hill', 41.3908309936523, 0.72240628097575, -79.5838928222656, -1.38900096130282, 218, 45, 'PPL', 'P'),
(119179, 'Coal Hollow', 41.3655586242676, 0.721965194920205, -89.3633270263672, -1.55968428714654, 218, 18, 'PPL', 'P'),
(160207, 'Coal Hollow', 41.3450012207031, 0.721606400542344, -78.6105575561523, -1.37201305618337, 218, 45, 'PPL', 'P'),
(160209, 'Coal Junction', 40.1361083984375, 0.700507240490083, -79.0622177124023, -1.37989601301, 218, 45, 'PPL', 'P'),
(100939, 'Coal Kiln Crossing', 37.5708312988281, 0.655734708875888, -75.7947235107422, -1.32286748090121, 218, 53, 'PPL', 'P'),
(100940, 'Coal Landing', 38.4458312988281, 0.671006339830839, -77.3866729736328, -1.350652240554, 218, 53, 'PPL', 'P'),
(85901, 'Coal Mine (historical)', 36.5608291625977, 0.63810684614649, -84.1875, -1.46934906402273, 218, 50, 'PPL', 'P'),
(177965, 'Coal Mine Mesa', 35.9597206115723, 0.627615522769205, -110.938888549805, -1.93624887369713, 218, 5, 'PPL', 'P'),
(20126, 'Coal Mountain', 34.2713890075684, 0.59814857741386, -84.100830078125, -1.46783638852356, 218, 13, 'PPL', 'P'),
(108644, 'Coal Mountain', 37.6694412231445, 0.657455776730352, -81.7286071777344, -1.42643328832054, 218, 58, 'PPL', 'P'),
(20125, 'Coal Neck Settlement (historical)', 32.7630615234375, 0.571823296617454, -83.7441711425781, -1.46161151579161, 218, 13, 'PPL', 'P'),
(59049, 'Coal Oil Corner', 34.8683280944824, 0.608567129914359, -89.6705627441406, -1.56504656200142, 218, 30, 'PPL', 'P'),
(72160, 'Coal Ridge', 39.8077812194824, 0.694776850193532, -81.5736083984375, -1.42372804928523, 218, 41, 'PPL', 'P'),
(72161, 'Coal Run', 39.5675010681152, 0.690583170424984, -81.5813903808594, -1.42386387050083, 218, 41, 'PPL', 'P'),
(160210, 'Coal Run', 40.7938919067383, 0.711987728475251, -76.5227813720703, -1.33557448772641, 218, 45, 'PPL', 'P'),
(35302, 'Coal Run Village', 37.5130615234375, 0.654726436087184, -82.5586090087891, -1.44091955307002, 218, 21, 'PPL', 'P'),
(115044, 'Coal Siding (historical)', 41.6708297729492, 0.727293181576045, -93.0558319091797, -1.62413065499759, 218, 16, 'PPL', 'P'),
(202017, 'Coal Springs', 45.4416694641113, 0.79310674975171, -102.107223510742, -1.78210724033221, 218, 49, 'PPL', 'P'),
(1661, 'Coal Valley', 33.7400016784668, 0.588874118917659, -87.4180603027344, -1.52573297798967, 218, 2, 'PPL', 'P'),
(108645, 'Coal Valley', 37.9413909912109, 0.662202195583146, -81.8163909912109, -1.42796540489566, 218, 58, 'PPL', 'P'),
(115045, 'Coal Valley', 42.0316696166992, 0.733591024921864, -93.9505615234375, -1.63974663268148, 218, 16, 'PPL', 'P'),
(119180, 'Coal Valley', 41.4286117553711, 0.723065679661653, -90.4608306884766, -1.57883933960304, 218, 18, 'PPL', 'P'),
(160212, 'Coal Valley', 40.3180618286133, 0.703682926931947, -79.9027786254883, -1.39456656850692, 218, 45, 'PPL', 'P'),
(32109, 'Coal Valley (historical)', 37.3244400024414, 0.651434369505683, -94.779167175293, -1.654208529507, 218, 20, 'PPL', 'P'),
(100941, 'Coalboro (historical)', 37.3708305358887, 0.652244037056094, -77.7013931274414, -1.35614514346035, 218, 53, 'PPL', 'P'),
(1662, 'Coalburg', 33.5936088562012, 0.586319082167837, -86.8572235107422, -1.51594452940308, 218, 2, 'PPL', 'P'),
(108646, 'Coalburg', 38.2075004577637, 0.666846681945217, -81.4594421386719, -1.42173547215764, 218, 58, 'PPL', 'P'),
(154782, 'Coalburg', 41.1930618286133, 0.718954557886898, -80.5883331298828, -1.40653175181048, 218, 41, 'PPL', 'P'),
(1663, 'Coaldale', 33.8266716003418, 0.590386794416824, -86.7908325195313, -1.51478578801279, 218, 2, 'PPL', 'P'),
(8155, 'Coaldale', 34.8941688537598, 0.609018136244964, -94.4486083984375, -1.6484391904795, 218, 4, 'PPL', 'P'),
(108648, 'Coaldale', 37.3630599975586, 0.652108415577582, -81.3344421386719, -1.41955381059264, 218, 58, 'PPL', 'P'),
(160219, 'Coaldale', 40.1672210693359, 0.70105025903635, -78.2155609130859, -1.36511906422753, 218, 45, 'PPL', 'P'),
(186549, 'Coaldale', 38.3655586242676, 0.669605317360375, -105.757217407227, -1.84581165150356, 218, 7, 'PPL', 'P'),
(190051, 'Coaldale', 38.0275001525879, 0.663705083965305, -117.882217407227, -2.05743282330788, 218, 39, 'PPL', 'P'),
(190052, 'Coaldale (historical)', 38.0424995422363, 0.66396687270046, -117.892501831055, -2.05761232036535, 218, 39, 'PPL', 'P'),
(190053, 'Coaldale Junction', 38.0316696166992, 0.663777854842091, -117.886108398438, -2.05750073391567, 218, 39, 'PPL', 'P'),
(100942, 'Coaldan', 37.1613883972168, 0.648588582143852, -81.7900009155273, -1.42750481118513, 218, 53, 'PPL', 'P'),
(200600, 'Coaledo', 43.2324981689453, 0.754549436910515, -124.231941223145, -2.16825641048794, 218, 43, 'PPL', 'P'),
(119182, 'Coaler', 40.7472190856934, 0.711173134076823, -87.7330627441406, -1.53123080774403, 218, 18, 'PPL', 'P'),
(59050, 'Coaler (historical)', 31.8516693115234, 0.555916501742519, -90.1619415283203, -1.5736227396598, 218, 30, 'PPL', 'P'),
(85903, 'Coalfield', 36.0288887023926, 0.628822733691338, -84.4208297729492, -1.47342143680362, 218, 50, 'PPL', 'P'),
(108647, 'Coalfield', 38.0044403076172, 0.663302613745567, -81.3505630493164, -1.41983517356181, 218, 58, 'PPL', 'P'),
(207073, 'Coalfield', 47.5027809143066, 0.829079930808173, -122.120559692383, -2.13140585101035, 218, 56, 'PPL', 'P'),
(807, 'Coalgate', 39.5369415283203, 0.690049805837668, -82.1849975585938, -1.43439880314096, 218, 41, 'PPL', 'P'),
(112492, 'Coalgate', 34.5380592346191, 0.602802850892937, -96.2183303833008, -1.6793266659603, 218, 42, 'PPL', 'P'),
(1668, 'Coaling', 33.1588897705078, 0.578731802801228, -87.3408279418945, -1.52438501900392, 218, 2, 'PPL', 'P'),
(85902, 'Coaling', 36.3005599975586, 0.633564292275142, -87.2633285522461, -1.52303239948627, 218, 50, 'PPL', 'P'),
(180786, 'Coalinga', 36.139720916748, 0.630757120749117, -120.359169006348, -2.10066378412508, 218, 6, 'PPL', 'P'),
(80392, 'Coalla (historical)', 32.9819412231445, 0.575643468043118, -81.2699966430664, -1.41842902450625, 218, 48, 'PPL', 'P'),
(1664, 'Coalmont', 33.2547187805176, 0.580404334544825, -86.883056640625, -1.51639540257563, 218, 2, 'PPL', 'P'),
(29523, 'Coalmont', 39.1933288574219, 0.684052633378919, -87.2311096191406, -1.5224700730221, 218, 19, 'PPL', 'P'),
(85904, 'Coalmont', 35.3375015258789, 0.616755751055107, -85.7041702270508, -1.49581995315173, 218, 50, 'PPL', 'P'),
(160217, 'Coalmont', 40.211109161377, 0.701816250744884, -78.2002792358398, -1.36485234864436, 218, 45, 'PPL', 'P'),
(194142, 'Coalmont', 40.5625, 0.7079491778402, -106.443893432617, -1.85779640904114, 218, 7, 'PPL', 'P'),
(188334, 'Coalora', 33.5677795410156, 0.585868275574314, -105.596672058105, -1.84300960656264, 218, 38, 'PPL', 'P'),
(154783, 'Coalport', 40.2827796936035, 0.703067137508894, -81.6125030517578, -1.42440688904709, 218, 41, 'PPL', 'P'),
(160220, 'Coalport', 40.7477798461914, 0.711182921193829, -78.5347213745117, -1.3706894651216, 218, 45, 'PPL', 'P'),
(108649, 'Coalridge', 38.372501373291, 0.669726491189974, -81.3933334350586, -1.42058165761536, 218, 58, 'PPL', 'P'),
(196239, 'Coalridge', 48.6983299255371, 0.849946197423108, -104.188606262207, -1.8184342223395, 218, 31, 'PPL', 'P'),
(35303, 'Coalton', 38.3699989318848, 0.669682815348097, -82.769172668457, -1.44459458221628, 218, 21, 'PPL', 'P'),
(72164, 'Coalton', 39.1136093139648, 0.682661264867407, -82.6113891601563, -1.44184074049108, 218, 41, 'PPL', 'P'),
(75485, 'Coalton', 35.497501373291, 0.619548275195137, -95.9388885498047, -1.67444948589798, 218, 42, 'PPL', 'P'),
(108651, 'Coalton', 38.8963890075684, 0.678870055318597, -79.9680633544922, -1.39570600197931, 218, 58, 'PPL', 'P'),
(119183, 'Coalton', 40.4324989318848, 0.70568023117048, -87.5899963378906, -1.52873382790597, 218, 18, 'PPL', 'P'),
(160222, 'Coaltown', 41.0391693115234, 0.716268626769498, -80.3472213745117, -1.40232355781399, 218, 45, 'PPL', 'P'),
(32110, 'Coalvale', 37.6155586242676, 0.656515347970418, -94.6486129760742, -1.65192992887832, 218, 20, 'PPL', 'P'),
(59051, 'Coalville', 30.4624996185303, 0.53167091673087, -89.0013885498047, -1.55336726904087, 218, 30, 'PPL', 'P'),
(63772, 'Coalville', 35.1883316040039, 0.614152244773446, -83.89111328125, -1.46417613992136, 218, 33, 'PPL', 'P'),
(93320, 'Coalville', 32.5755615234375, 0.568550804269964, -98.3319396972656, -1.7162161075898, 218, 51, 'PPL', 'P'),
(115046, 'Coalville', 42.4452781677246, 0.74080985595166, -94.1255569458008, -1.64280087897764, 218, 16, 'PPL', 'P'),
(119184, 'Coalville', 41.0902786254883, 0.717160652576621, -88.8513870239258, -1.55074924853127, 218, 18, 'PPL', 'P'),
(203470, 'Coalville', 40.917781829834, 0.714150015543313, -111.398612976074, -1.94427257858737, 218, 52, 'PPL', 'P'),
(196240, 'Coalville (historical)', 45.4000015258789, 0.792379507037037, -108.922218322754, -1.90105133830815, 218, 31, 'PPL', 'P'),
(108650, 'Coalwood', 37.3872184753418, 0.652530060557169, -81.6527786254883, -1.42510983041682, 218, 58, 'PPL', 'P'),
(130274, 'Coalwood', 46.3405609130859, 0.808795365154339, -86.7316665649414, -1.51375314730011, 218, 27, 'PPL', 'P'),
(196241, 'Coalwood', 45.7280616760254, 0.79810523680168, -105.589996337891, -1.84289309326495, 218, 31, 'PPL', 'P'),
(100943, 'Coan', 37.9583282470703, 0.662497806464145, -76.4805603027344, -1.33483759105279, 218, 53, 'PPL', 'P'),
(188335, 'Coane', 33.8008308410645, 0.589935788086219, -106.326667785645, -1.85575043553369, 218, 38, 'PPL', 'P'),
(59052, 'Coars Springs (historical)', 31.8972206115723, 0.556711521906935, -90.2819366455078, -1.57571704954104, 218, 30, 'PPL', 'P'),
(180787, 'Coarsegold', 37.2622184753418, 0.650348398992176, -119.699996948242, -2.08915906137399, 218, 6, 'PPL', 'P'),
(80393, 'Coastal Heights', 33.7880592346191, 0.589712881502979, -79.0116729736328, -1.37901384089891, 218, 48, 'PPL', 'P'),
(1665, 'Coates', 31.726390838623, 0.553729979908537, -85.1500015258789, -1.48614788470478, 218, 2, 'PPL', 'P'),
(134741, 'Coates', 44.7172203063965, 0.780462726686286, -93.0344390869141, -1.62375727981276, 218, 28, 'PPL', 'P'),
(203465, 'Coates Estates', 40.665828704834, 0.709752603951374, -111.95832824707, -1.95404145293995, 218, 52, 'PPL', 'P'),
(29524, 'Coatesville', 39.6877784729004, 0.692682407154239, -86.670280456543, -1.51268175759357, 218, 19, 'PPL', 'P'),
(78046, 'Coatesville', 39.9830589294434, 0.697836023337706, -75.8241729736328, -1.32338147099159, 218, 45, 'PPL', 'P'),
(100944, 'Coatesville', 37.8786087036133, 0.661106437952633, -77.6086120605469, -1.35452580835952, 218, 53, 'PPL', 'P'),
(80394, 'Coatesworth', 34.0777816772461, 0.59476949204374, -81.1875, -1.4169891864629, 218, 48, 'PPL', 'P'),
(1666, 'Coato Bend (historical)', 34.0527801513672, 0.594333133099131, -85.845832824707, -1.49829243190776, 218, 2, 'PPL', 'P'),
(1667, 'Coatopa', 32.4850006103516, 0.566970218163002, -88.0694427490234, -1.53710174636711, 218, 2, 'PPL', 'P'),
(59053, 'Coatraw (historical)', 32.2744407653809, 0.563295255595775, -89.1944427490234, -1.55673670045204, 218, 30, 'PPL', 'P'),
(697, 'Coats', 31.8458309173584, 0.55581460254131, -89.704719543457, -1.56564271061143, 218, 30, 'PPL', 'P'),
(32111, 'Coats', 37.5119400024414, 0.654706861853172, -98.8238906860352, -1.72480227210227, 218, 20, 'PPL', 'P'),
(63770, 'Coats', 35.4077796936035, 0.61798233647417, -78.6722183227539, -1.37308923957987, 218, 33, 'PPL', 'P'),
(72165, 'Coats', 39.7808303833008, 0.694306469365996, -81.059440612793, -1.41475412851805, 218, 41, 'PPL', 'P'),
(80395, 'Coats Crossroad', 34.5083312988281, 0.602284000533562, -80.6366729736328, -1.40737544124382, 218, 48, 'PPL', 'P'),
(63771, 'Coats Crossroads', 35.5141716003418, 0.619839225544228, -78.5438919067383, -1.37084952110311, 218, 33, 'PPL', 'P'),
(203469, 'Coats Estates Number 7', 40.6611099243164, 0.709670245694664, -111.949440002441, -1.95388632380645, 218, 52, 'PPL', 'P'),
(130278, 'Coats Grove', 42.6830596923828, 0.744959926457358, -85.1922225952148, -1.48688478137841, 218, 27, 'PPL', 'P'),
(29525, 'Coats Spring', 38.4375, 0.67086093123532, -87.3905563354492, -1.52525294320318, 218, 19, 'PPL', 'P'),
(119185, 'Coatsburg', 40.0327796936035, 0.698703814378908, -91.1575012207031, -1.59099853419202, 218, 18, 'PPL', 'P'),
(139093, 'Coatsville', 40.589168548584, 0.708414631819719, -92.6333312988281, -1.61675662825527, 218, 29, 'PPL', 'P'),
(177613, 'Cobalt', 41.5622215270996, 0.725397610091154, -72.5558319091797, -1.26633815833875, 218, 8, 'PPL', 'P'),
(194756, 'Cobalt', 45.0930595397949, 0.78702235876726, -114.230827331543, -1.99370404421255, 218, 17, 'PPL', 'P'),
(75486, 'Cobalt Junction', 34.1624984741211, 0.596248079080952, -97.5116729736328, -1.70189975251786, 218, 42, 'PPL', 'P'),
(177612, 'Cobalt Landing', 41.5561103820801, 0.725290950489496, -72.5616683959961, -1.26644002425044, 218, 8, 'PPL', 'P'),
(160223, 'Cobalt Ridge', 40.1563911437988, 0.700861241177981, -74.8694381713867, -1.30671820520902, 218, 45, 'PPL', 'P'),
(54124, 'Cobalt Village', 37.5449981689453, 0.655283835703338, -90.2874984741211, -1.57581412176277, 218, 29, 'PPL', 'P'),
(20127, 'Cobb', 31.958610534668, 0.557782978192501, -83.9886093139648, -1.46587776669986, 218, 13, 'PPL', 'P'),
(29526, 'Cobb', 39.5811080932617, 0.690820657815192, -87.2233276367188, -1.52233425180651, 218, 19, 'PPL', 'P'),
(35304, 'Cobb', 36.9902801513672, 0.645602179876464, -87.7788925170898, -1.53203068817743, 218, 21, 'PPL', 'P'),
(39821, 'Cobb', 32.4008293151855, 0.565501151926687, -92.1186065673828, -1.6077729869501, 218, 22, 'PPL', 'P'),
(54127, 'Cobb', 37.8944396972656, 0.661382740915728, -93.7544403076172, -1.63632367173241, 218, 29, 'PPL', 'P'),
(75487, 'Cobb', 34.0847206115723, 0.594890599294311, -96.4075012207031, -1.68262831992172, 218, 42, 'PPL', 'P'),
(93319, 'Cobb', 32.714168548584, 0.570969953225165, -96.0999984741211, -1.67726138453494, 218, 51, 'PPL', 'P'),
(108652, 'Cobb', 38.0855598449707, 0.66471841676008, -80.5883331298828, -1.40653175181048, 218, 58, 'PPL', 'P'),
(147898, 'Cobb', 40.9011116027832, 0.713859065194222, -72.3555603027344, -1.26284275940802, 218, 40, 'PPL', 'P'),
(173600, 'Cobb', 42.9674987792969, 0.749924325045375, -90.3294372558594, -1.57654609158838, 218, 57, 'PPL', 'P'),
(180788, 'Cobb', 38.8222198486328, 0.677575559291737, -122.721939086914, -2.14190190149857, 218, 6, 'PPL', 'P'),
(196242, 'Cobb', 46.3452796936035, 0.80887772341105, -114.101669311523, -1.99144981150786, 218, 31, 'PPL', 'P'),
(200601, 'Cobb', 45.9552803039551, 0.802070949980917, -118.396392822266, -2.06640687723312, 218, 43, 'PPL', 'P'),
(1669, 'Cobb City', 33.9166717529297, 0.59195759340678, -85.9124984741211, -1.49945596698802, 218, 2, 'PPL', 'P'),
(127128, 'Cobb Cove', 44.0711097717285, 0.769185970524509, -70.5033264160156, -1.23051517956777, 218, 26, 'PPL', 'P'),
(15568, 'Cobb Cross Roads', 30.9805603027344, 0.540712781395366, -85.5475006103516, -1.49308555250249, 218, 12, 'PPL', 'P'),
(20129, 'Cobb Crossing', 33.9411087036133, 0.592384098655356, -84.7241668701172, -1.47871566789264, 218, 13, 'PPL', 'P'),
(20130, 'Cobb Estates', 33.936939239502, 0.59231132777857, -84.8405609130859, -1.48074712717216, 218, 13, 'PPL', 'P'),
(20131, 'Cobb Place Manor', 34.0180587768555, 0.593727130793083, -84.5369415283203, -1.47544796923512, 218, 13, 'PPL', 'P'),
(85905, 'Cobb Subdivision', 35.163890838623, 0.613725672945842, -87.0777816772461, -1.51979399560073, 218, 50, 'PPL', 'P'),
(63773, 'Cobb Town', 35.7200012207031, 0.623431630117663, -77.6013870239258, -1.35439970768191, 218, 33, 'PPL', 'P'),
(173601, 'Cobb Town', 44.375560760498, 0.77449964268949, -89.2152786254883, -1.55710035509889, 218, 57, 'PPL', 'P'),
(173603, 'Cobban', 45.1030616760254, 0.787196928976715, -91.2061080932617, -1.59184688415726, 218, 57, 'PPL', 'P'),
(100945, 'Cobbdale', 38.8650016784668, 0.678322243082368, -77.3150024414063, -1.34940135378999, 218, 53, 'PPL', 'P'),
(20132, 'Cobbham', 33.5686111450195, 0.585882789802255, -82.4327774047852, -1.43872337727709, 218, 13, 'PPL', 'P'),
(20133, 'Cobbham (historical)', 33.9597206115723, 0.592708937729318, -83.3944396972656, -1.45550755057315, 218, 13, 'PPL', 'P'),
(20134, 'Cobbham Crossroads', 33.5527801513672, 0.585606486839159, -82.4372177124023, -1.43880087526481, 218, 13, 'PPL', 'P'),
(203472, 'Cobble Creek Park', 41.3680610656738, 0.722008870762083, -111.895561218262, -1.95294596162554, 218, 52, 'PPL', 'P'),
(203477, 'Cobble Knoll Condominium', 40.7666702270508, 0.71151262053678, -111.866668701172, -1.95244169207314, 218, 52, 'PPL', 'P'),
(54126, 'Cobbler', 39.1636085510254, 0.683533916177599, -94.3280563354492, -1.64633516006029, 218, 29, 'PPL', 'P'),
(203473, 'Cobblerock Lane', 40.624439239502, 0.70903022150569, -111.818061828613, -1.95159334210789, 218, 52, 'PPL', 'P'),
(35307, 'Cobblers Knob', 37.5680618286133, 0.655686372502103, -86.3855590820313, -1.50771243215754, 218, 21, 'PPL', 'P'),
(203474, 'Cobblestone', 40.6644401550293, 0.709728369185455, -111.97917175293, -1.95440524074485, 218, 52, 'PPL', 'P'),
(20135, 'Cobblestone Creek', 33.4094390869141, 0.583104713311138, -84.5902786254883, -1.47637887719415, 218, 13, 'PPL', 'P'),
(177966, 'Cobblestone Square', 33.601390838623, 0.586454903383431, -111.971939086914, -1.95427900690918, 218, 5, 'PPL', 'P'),
(160225, 'Cobblesville', 40.0852813720703, 0.699620141530977, -77.3324966430664, -1.34970668520897, 218, 45, 'PPL', 'P'),
(8157, 'Cobbs', 34.6283302307129, 0.604378376993828, -92.0088882446289, -1.60585804096828, 218, 4, 'PPL', 'P'),
(59054, 'Cobbs', 31.5597190856934, 0.550821009049844, -90.5744400024414, -1.58082219619266, 218, 30, 'PPL', 'P'),
(39822, 'Cobbs Addition', 31.5777797698975, 0.551136227454368, -93.470832824707, -1.63137378737233, 218, 22, 'PPL', 'P'),
(100946, 'Cobbs Corner', 38.8269386291504, 0.677657917548448, -77.3847198486328, -1.35061815209205, 218, 53, 'PPL', 'P'),
(122400, 'Cobbs Corner', 41.4347190856934, 0.723172272684284, -87.1100006103516, -1.5203563220649, 218, 19, 'PPL', 'P'),
(145020, 'Cobbs Corner', 40.8705596923828, 0.713325833764961, -74.4191665649414, -1.29885948314831, 218, 37, 'PPL', 'P'),
(100947, 'Cobbs Creek', 37.5055618286133, 0.654595541719607, -76.397216796875, -1.33338297246538, 218, 53, 'PPL', 'P'),
(63777, 'Cobbs Crossroad', 35.8241691589355, 0.625249703614833, -77.8572235107422, -1.35886489672359, 218, 33, 'PPL', 'P'),
(63775, 'Cobbs Crossroads', 35.7811088562012, 0.624498159555213, -77.6050033569336, -1.35446282459974, 218, 33, 'PPL', 'P'),
(1670, 'Cobbs Ford', 32.4541702270508, 0.566432126464752, -86.3772201538086, -1.50756689040396, 218, 2, 'PPL', 'P'),
(80396, 'Cobbs Glen', 34.5430603027344, 0.602890135997664, -82.5955581665039, -1.44156443752798, 218, 48, 'PPL', 'P'),
(70675, 'Cobbs Mill', 39.5291709899902, 0.689914184359156, -75.3213882446289, -1.31460622204173, 218, 37, 'PPL', 'P'),
(1671, 'Cobbs Quarters', 32.2138900756836, 0.562238446696204, -87.3530578613281, -1.52459847136529, 218, 2, 'PPL', 'P'),
(124540, 'Cobbs Village', 41.7083282470703, 0.727947653413932, -70.2916717529297, -1.22682110881972, 218, 23, 'PPL', 'P'),
(15569, 'Cobbtown', 30.8827800750732, 0.53900619447933, -87.1197204589844, -1.52052596542634, 218, 12, 'PPL', 'P'),
(20136, 'Cobbtown', 32.2802810668945, 0.563397188086498, -82.1388931274414, -1.43359412901759, 218, 13, 'PPL', 'P'),
(147900, 'Cobbtown', 43.7255592346191, 0.763154975919916, -76.0441665649414, -1.32722108349321, 218, 40, 'PPL', 'P'),
(20137, 'Cobbville', 31.9177799224854, 0.55707034957431, -82.9824981689453, -1.44831781457826, 218, 13, 'PPL', 'P'),
(59055, 'Cobbville', 32.6719398498535, 0.570232923393486, -90.0066680908203, -1.57091270693453, 218, 30, 'PPL', 'P'),
(26819, 'Cobden', 37.5313911437988, 0.65504634831313, -89.2533264160156, -1.5577644143167, 218, 18, 'PPL', 'P'),
(134742, 'Cobden', 44.2863883972168, 0.772943291348448, -94.8486099243164, -1.65542053411909, 218, 28, 'PPL', 'P'),
(100948, 'Cobham', 38.0627784729004, 0.664320806809331, -78.2683334350586, -1.36604011849054, 218, 53, 'PPL', 'P'),
(160226, 'Cobham', 41.7238883972168, 0.728219229266093, -79.3341674804688, -1.38464243186279, 218, 45, 'PPL', 'P'),
(100950, 'Cobham Park', 37.940559387207, 0.662187681355205, -76.7466735839844, -1.33948214399388, 218, 53, 'PPL', 'P'),
(35305, 'Cobhill', 37.7150001525879, 0.658250930052822, -83.82861328125, -1.46308530913886, 218, 21, 'PPL', 'P'),
(85906, 'Coble', 35.7830581665039, 0.624532181438138, -87.6324996948242, -1.52947565142761, 218, 50, 'PPL', 'P'),
(177735, 'Coble', 33.5950012207031, 0.586343383512784, -102.502502441406, -1.78900615913607, 218, 51, 'PPL', 'P'),
(45874, 'Coblentz Heights', 39.4049987792969, 0.687746970443077, -77.5086135864258, -1.35278050573914, 218, 25, 'PPL', 'P'),
(100951, 'Cobleshaw', 37.2427787780762, 0.6500091122693, -79.9899978637695, -1.39608883138601, 218, 53, 'PPL', 'P'),
(147901, 'Cobleskill', 42.6777801513672, 0.744867781083641, -74.4858322143555, -1.30002301822856, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(188336, 'Cobre', 32.7805595397949, 0.572128694615459, -108.111389160156, -1.88689969974963, 218, 38, 'PPL', 'P'),
(199880, 'Cobre', 41.1119384765625, 0.717538688293357, -114.400001525879, -1.99665669091312, 218, 39, 'PPL', 'P'),
(35306, 'Coburg', 37.2013893127441, 0.649286729823616, -85.3358306884766, -1.48939121543834, 218, 21, 'PPL', 'P'),
(115047, 'Coburg', 40.9174995422363, 0.714145088695296, -95.2641677856445, -1.66267338703181, 218, 16, 'PPL', 'P'),
(122401, 'Coburg', 41.5188903808594, 0.724641338920599, -86.9494400024414, -1.51755401080787, 218, 19, 'PPL', 'P'),
(196243, 'Coburg', 48.4513893127441, 0.845636270672978, -108.438606262207, -1.89261071554925, 218, 31, 'PPL', 'P'),
(200602, 'Coburg', 44.1372184753418, 0.770339785066786, -123.065277099609, -2.14789428026736, 218, 43, 'PPL', 'P'),
(39824, 'Coburn', 30.5122203826904, 0.532538707772072, -90.3983306884766, -1.57774850882055, 218, 22, 'PPL', 'P'),
(63776, 'Coburn', 35.5349998474121, 0.620202747033024, -82.7552795410156, -1.44435210139902, 218, 33, 'PPL', 'P'),
(108653, 'Coburn', 39.5927810668945, 0.691024389638583, -80.5036087036133, -1.40505303161522, 218, 58, 'PPL', 'P'),
(127129, 'Coburn', 44.8880615234375, 0.783444468421766, -69.225830078125, -1.2082186622894, 218, 26, 'PPL', 'P'),
(139811, 'Coburn', 46.6177787780762, 0.813633729643768, -97.3708267211914, -1.69944152167366, 218, 34, 'PPL', 'P'),
(143641, 'Coburn', 43.4588890075684, 0.758500702440839, -71.1324996948242, -1.24149632484854, 218, 36, 'PPL', 'P'),
(160228, 'Coburn', 40.8630599975586, 0.713194939397384, -77.4647216796875, -1.35201444745158, 218, 45, 'PPL', 'P'),
(180789, 'Coburn', 36.2886085510254, 0.633355700182762, -121.151672363281, -2.11449557703668, 218, 6, 'PPL', 'P'),
(186550, 'Coburn', 38.8466682434082, 0.678002264277395, -107.635276794434, -1.87858997135831, 218, 7, 'PPL', 'P'),
(191285, 'Coburn', 36.0663909912109, 0.629477272108252, -100.153060913086, -1.74800066888379, 218, 51, 'PPL', 'P'),
(127132, 'Coburn Gore', 45.3791694641113, 0.792015918969213, -70.8038864135742, -1.23576094112495, 218, 26, 'PPL', 'P'),
(124541, 'Coburnville', 42.2727813720703, 0.737799218918353, -71.4361114501953, -1.24679534962753, 218, 23, 'PPL', 'P'),
(160229, 'Cocalico', 40.2886085510254, 0.703168870262535, -76.20361328125, -1.33000395367429, 218, 45, 'PPL', 'P'),
(160230, 'Cocalico House', 40.2816696166992, 0.703047763011964, -76.2038879394531, -1.33000874736425, 218, 45, 'PPL', 'P'),
(143642, 'Cocheco', 43.2297210693359, 0.754500967378676, -70.9391708374023, -1.23812209974741, 218, 36, 'PPL', 'P'),
(147903, 'Cochecton', 41.7058296203613, 0.727904044151082, -75.0608291625977, -1.31005860816431, 218, 40, 'PPL', 'P'),
(147904, 'Cochecton Center', 41.6547203063965, 0.72701201834396, -74.9830627441406, -1.30870132811475, 218, 40, 'PPL', 'P'),
(124542, 'Cochesett', 42.0166702270508, 0.73332923618671, -71.0388870239258, -1.23986247551978, 218, 23, 'PPL', 'P'),
(177967, 'Cochise', 32.1136093139648, 0.560488217227804, -109.921112060547, -1.91848532291019, 218, 5, 'PPL', 'P'),
(188337, 'Cochiti', 35.6088905334473, 0.621492382790895, -106.349716186523, -1.85615270601634, 218, 38, 'PPL', 'P'),
(188338, 'Cochiti Lake', 35.6480598449707, 0.622176016242718, -106.336936950684, -1.85592966627505, 218, 38, 'PPL', 'P'),
(188339, 'Cochiti Pueblo', 35.6074981689453, 0.621468081445948, -106.346672058105, -1.85609957595259, 218, 38, 'PPL', 'P'),
(124543, 'Cochituate', 42.3208312988281, 0.738637848345619, -71.3647232055664, -1.24554938971154, 218, 23, 'PPL', 'P'),
(20138, 'Cochran', 32.3866691589355, 0.565254010577528, -83.3547210693359, -1.4548143297414, 218, 13, 'PPL', 'P'),
(29527, 'Cochran', 39.0522193908691, 0.681589808581841, -84.9205627441406, -1.48214342253169, 218, 19, 'PPL', 'P'),
(85907, 'Cochran', 35.4230613708496, 0.618249052057342, -86.8016662597656, -1.51497487245018, 218, 50, 'PPL', 'P'),
(93321, 'Cochran', 30.0286102294922, 0.524098118302689, -96.1291732788086, -1.67777058093536, 218, 51, 'PPL', 'P'),
(100952, 'Cochran', 36.8430595397949, 0.643032695477728, -77.9052810668945, -1.35970365930891, 218, 53, 'PPL', 'P'),
(177969, 'Cochran', 33.1094398498535, 0.577868738870961, -111.149169921875, -1.93991897599537, 218, 5, 'PPL', 'P'),
(45875, 'Cochran Hills', 39.4597206115723, 0.688702046589006, -76.3399963378906, -1.3323842870566, 218, 25, 'PPL', 'P'),
(1672, 'Cochran Landing', 32.0472183227539, 0.55932947583751, -87.2613906860352, -1.52299857734043, 218, 2, 'PPL', 'P'),
(191286, 'Cochran Mobile Park Colonia', 31.6669998168945, 0.552693411033251, -106.13200378418, -1.85235290777302, 218, 51, 'PPL', 'P'),
(1673, 'Cochran Springs (historical)', 33.8416709899902, 0.590648583151979, -86.0186080932617, -1.50130792921006, 218, 2, 'PPL', 'P'),
(80398, 'Cochran Town', 33.8730583190918, 0.591196395388208, -79.0708312988281, -1.38004634845354, 218, 48, 'PPL', 'P'),
(1674, 'Cochrane', 33.0652809143066, 0.577098020051492, -88.251106262207, -1.5402723728029, 218, 2, 'PPL', 'P'),
(32112, 'Cochrane', 39.2666702270508, 0.685332681756865, -94.8786087036133, -1.6559441115894, 218, 20, 'PPL', 'P'),
(173605, 'Cochrane', 44.2275009155273, 0.771915510904759, -91.8349990844727, -1.60282310259003, 218, 57, 'PPL', 'P'),
(180790, 'Cochrane', 37.7311096191406, 0.658532093284908, -121.358612060547, -2.11810735610704, 218, 6, 'PPL', 'P'),
(200603, 'Cochrane (historical)', 44.8847198486328, 0.783386145193893, -123.236106872559, -2.15087582226576, 218, 43, 'PPL', 'P'),
(160235, 'Cochrans Mill', 40.2916717529297, 0.703222333221418, -79.9613876342773, -1.39558948868162, 218, 45, 'PPL', 'P'),
(160231, 'Cochrans Mills', 40.6699981689453, 0.709825374828161, -79.4583282470703, -1.38680944604179, 218, 45, 'PPL', 'P'),
(160232, 'Cochranton', 41.5200004577637, 0.724660713417529, -80.0486068725586, -1.39711175156071, 218, 45, 'PPL', 'P'),
(78049, 'Cochranville', 39.8916702270508, 0.69624098958183, -75.9219436645508, -1.32508789146006, 218, 45, 'PPL', 'P'),
(180791, 'Cockatoo Grove', 32.6430587768555, 0.569728853578161, -116.983062744141, -2.04173961395237, 218, 6, 'PPL', 'P'),
(13563, 'Cocked Hat', 38.7666702270508, 0.676606035496894, -75.6111068725586, -1.31966276600346, 218, 10, 'PPL', 'P'),
(203476, 'Cockerills Addition', 40.7125015258789, 0.710567198349802, -112.089721679688, -1.95633470095462, 218, 52, 'PPL', 'P'),
(45876, 'Cockeysville', 39.4811096191406, 0.689075355194808, -76.644172668457, -1.33769316553162, 218, 25, 'PPL', 'P'),
(39825, 'Cockfield (historical)', 31.6324996948242, 0.552091270310784, -92.9124984741211, -1.62162901462762, 218, 22, 'PPL', 'P'),
(75489, 'Cocklebur Flat', 36.8300018310547, 0.642804795467445, -95.1975021362305, -1.66150985195156, 218, 42, 'PPL', 'P'),
(93324, 'Cockrans', 30.4013900756836, 0.530604354003807, -94.9994430541992, -1.65805306885663, 218, 51, 'PPL', 'P'),
(54128, 'Cockrell', 38.8855590820313, 0.678681037460229, -94.2375030517578, -1.64475470711138, 218, 29, 'PPL', 'P'),
(63778, 'Cockrell Beach', 35.399169921875, 0.617832067609663, -76.6272201538086, -1.33739728833452, 218, 33, 'PPL', 'P'),
(93322, 'Cockrell Hill', 32.7361106872559, 0.571352915789918, -96.8866729736328, -1.6909914446929, 218, 51, 'PPL', 'P'),
(72166, 'Cockrell Run', 38.9533309936523, 0.679863880458388, -82.9791717529297, -1.4482597576665, 218, 41, 'PPL', 'P'),
(54130, 'Cockrum', 36.0111083984375, 0.628512408845316, -90.3380584716797, -1.57669656018997, 218, 29, 'PPL', 'P'),
(59056, 'Cockrum', 34.8027801513672, 0.607423102489088, -89.8119430541992, -1.56751411390943, 218, 30, 'PPL', 'P'),
(108654, 'Coco', 38.4030609130859, 0.67025985577729, -81.4194412231445, -1.42103732447787, 218, 58, 'PPL', 'P'),
(15570, 'Cocoa', 28.3858299255371, 0.495426193111759, -80.7422180175781, -1.40921754976983, 218, 12, 'PPL', 'P'),
(15571, 'Cocoa Beach', 28.3197193145752, 0.494272345279969, -80.607780456543, -1.40687117169141, 218, 12, 'PPL', 'P'),
(39826, 'Cocodrie', 29.2466697692871, 0.51045068271755, -90.6613922119141, -1.58233979853985, 218, 22, 'PPL', 'P'),
(194757, 'Cocolalla', 48.1080589294434, 0.839644025062245, -116.616386413574, -2.03533990469485, 218, 17, 'PPL', 'P'),
(160234, 'Cocolamus', 40.6477813720703, 0.709437618573445, -77.2127838134766, -1.34761730217575, 218, 45, 'PPL', 'P'),
(177971, 'Coconino', 35.9944381713867, 0.628221458496225, -112.19750213623, -1.95821582479059, 218, 5, 'PPL', 'P'),
(15579, 'Coconut', 26.399169921875, 0.460752434930173, -81.8397216796875, -1.42837260222633, 218, 12, 'PPL', 'P'),
(15572, 'Coconut Creek', 26.2513904571533, 0.458173196703945, -80.1791687011719, -1.39939048534743, 218, 12, 'PPL', 'P'),
(15573, 'Coconut Creek Park', 26.2416706085205, 0.458003553342507, -80.182502746582, -1.39944867541725, 218, 12, 'PPL', 'P'),
(15574, 'Coconut Grove', 25.7122192382813, 0.448762883702636, -80.2572174072266, -1.40075269224501, 218, 12, 'PPL', 'P'),
(39827, 'Cocoville', 31.1027793884277, 0.542845906849492, -92.0638885498047, -1.6068179773832, 218, 22, 'PPL', 'P'),
(211679, 'Cod Fish Village', 20.896390914917, 0.364710823249132, -156.421112060547, -2.73006342508755, 218, 15, 'PPL', 'P'),
(130275, 'Coddes Beach', 45.4427795410156, 0.79312612424864, -84.2191696166992, -1.46990180310697, 218, 27, 'PPL', 'P'),
(160237, 'Codding', 41.8202781677246, 0.729901548126696, -76.6086120605469, -1.33707251583958, 218, 45, 'PPL', 'P'),
(173607, 'Coddington', 44.3702812194824, 0.774407497315773, -89.5480575561523, -1.56290844312025, 218, 57, 'PPL', 'P'),
(154784, 'Coddingville', 41.1366691589355, 0.717970320127032, -81.7052764892578, -1.42602609098986, 218, 41, 'PPL', 'P'),
(63780, 'Coddle Creek (historical)', 35.4977798461914, 0.619553135464126, -80.7394409179688, -1.40916908023799, 218, 33, 'PPL', 'P'),
(100953, 'Coddyshore (historical)', 37.0297203063965, 0.646290540439222, -77.2983322143555, -1.3491104034409, 218, 53, 'PPL', 'P'),
(32113, 'Codell', 39.1933288574219, 0.684052633378919, -99.1769409179688, -1.73096416107444, 218, 20, 'PPL', 'P'),
(1675, 'Coden', 30.3827800750732, 0.530279548219358, -88.2383270263672, -1.5400493330616, 218, 2, 'PPL', 'P'),
(160236, 'Coder', 41.144718170166, 0.718110801874533, -79.1136093139648, -1.38079296566514, 218, 45, 'PPL', 'P'),
(124544, 'Codfish Park', 41.2797203063965, 0.720467033648981, -69.9625015258789, -1.22107600455814, 218, 23, 'PPL', 'P'),
(191288, 'Codman', 35.6399993896484, 0.622035334758135, -100.753059387207, -1.75847261776414, 218, 51, 'PPL', 'P'),
(186551, 'Codo', 37.5022201538086, 0.654537218491734, -105.146667480469, -1.83515554503383, 218, 7, 'PPL', 'P'),
(180792, 'Codora', 39.4588890075684, 0.688687532361066, -122.021110534668, -2.12967013576989, 218, 6, 'PPL', 'P'),
(160238, 'Codorus Furnace', 40.0508308410645, 0.699018866335865, -76.6580581665039, -1.33793551319082, 218, 45, 'PPL', 'P'),
(8158, 'Cody', 34.8438911437988, 0.608140624665783, -90.6397171020508, -1.581961496507, 218, 4, 'PPL', 'P'),
(15575, 'Cody', 30.360559463501, 0.529891725385615, -84.0511093139648, -1.46696859748236, 218, 12, 'PPL', 'P'),
(26822, 'Cody', 39.7708282470703, 0.694131899156542, -89.7238922119141, -1.5659773368024, 218, 18, 'PPL', 'P'),
(54131, 'Cody', 37.1186103820801, 0.647841964932248, -93.1191711425781, -1.62523613316608, 218, 29, 'PPL', 'P'),
(75491, 'Cody', 36.3188896179199, 0.633884204501088, -96.7099990844727, -1.68790790362475, 218, 42, 'PPL', 'P'),
(100954, 'Cody', 36.9775009155273, 0.64537914013517, -79.0986099243164, -1.38053117692998, 218, 53, 'PPL', 'P'),
(199236, 'Cody', 42.9358291625977, 0.749371585961129, -101.244171142578, -1.76704413489062, 218, 35, 'PPL', 'P'),
(209373, 'Cody', 44.5263900756836, 0.777132110848006, -109.05583190918, -1.90338333531668, 218, 59, 'PPL', 'P'),
(54132, 'Cody (historical)', 36.6105613708496, 0.638974836924774, -89.6094436645508, -1.56397983282678, 218, 29, 'PPL', 'P'),
(186552, 'Cody Park', 39.7158317565918, 0.69317202932065, -105.269721984863, -1.83730325129492, 218, 7, 'PPL', 'P'),
(15576, 'Codys Corner', 29.3430595397949, 0.512133001578153, -81.3111114501953, -1.41914661326197, 218, 12, 'PPL', 'P'),
(35308, 'Codyville', 37.7777786254883, 0.659346621104308, -86.4475021362305, -1.50879354240205, 218, 21, 'PPL', 'P'),
(127130, 'Codyville', 45.4397201538086, 0.793072727868784, -67.6947174072266, -1.18149570496322, 218, 26, 'PPL', 'P'),
(29528, 'Coe', 38.3063888549805, 0.66857261006867, -87.258056640625, -1.52294038727061, 218, 19, 'PPL', 'P'),
(35309, 'Coe', 36.6833305358887, 0.640244898448633, -85.5502777099609, -1.49313402203433, 218, 21, 'PPL', 'P'),
(108655, 'Coe', 38.3258285522461, 0.668911896791546, -80.5547180175781, -1.40594505742234, 218, 58, 'PPL', 'P'),
(130276, 'Coe', 43.4805603027344, 0.758878937894657, -84.642219543457, -1.47728541722922, 218, 27, 'PPL', 'P'),
(39828, 'Coe (historical)', 30.4286098480225, 0.531079428652763, -92.3388900756836, -1.61161765945779, 218, 22, 'PPL', 'P'),
(100955, 'Coeburn', 36.9438896179199, 0.644792512326053, -82.4641723632813, -1.43927132267137, 218, 53, 'PPL', 'P'),
(26823, 'Coello', 37.9941711425781, 0.663123383004204, -89.0672225952148, -1.55451628989319, 218, 18, 'PPL', 'P'),
(93323, 'Coesfield', 33.8183288574219, 0.590241186084224, -97.0316696166992, -1.69352211351875, 218, 51, 'PPL', 'P'),
(122402, 'Coesse', 41.1277809143066, 0.717815190993535, -85.3952789306641, -1.49042878299903, 218, 19, 'PPL', 'P'),
(122403, 'Coesse Corners', 41.1399993896484, 0.718028443617823, -85.3958282470703, -1.49043837037895, 218, 19, 'PPL', 'P'),
(194758, 'Coeur d''Alene', 47.6777801513672, 0.832134243683358, -116.779441833496, -2.03818575863571, 218, 17, 'PPL', 'P'),
(194759, 'Coeur d''Alene Junction', 47.7566719055176, 0.833511164545956, -116.911392211914, -2.04048872718836, 218, 17, 'PPL', 'P'),
(203478, 'Coeur Dalane Estates', 40.6122207641602, 0.708816968881402, -111.796669006348, -1.95121996692306, 218, 52, 'PPL', 'P'),
(207074, 'Coey', 47.4980583190918, 0.828997505972435, -117.111106872559, -2.04397440558111, 218, 56, 'PPL', 'P'),
(147906, 'Coeymans', 42.4738883972168, 0.74130919865605, -73.7927780151367, -1.28792694055742, 218, 40, 'PPL', 'P'),
(147910, 'Coeymans Hollow', 42.4716682434082, 0.74127044966219, -73.8949966430664, -1.28971099217167, 218, 40, 'PPL', 'P'),
(35310, 'Cofer', 36.9597206115723, 0.645068815289148, -85.4902801513672, -1.49208686709371, 218, 21, 'PPL', 'P'),
(20139, 'Coffee', 31.5074996948242, 0.549909608745791, -82.3116683959961, -1.43660962631989, 218, 13, 'PPL', 'P'),
(100956, 'Coffee', 37.4308280944824, 0.653291191996713, -79.3088912963867, -1.38420127922822, 218, 53, 'PPL', 'P'),
(193456, 'Coffee', 41.1030616760254, 0.717383758896942, -122.77693939209, -2.14286183791349, 218, 6, 'PPL', 'P'),
(20140, 'Coffee Bluff', 31.9366703033447, 0.557400048917262, -81.1533279418945, -1.41639277153677, 218, 13, 'PPL', 'P'),
(20141, 'Coffee Bluff Plantation', 31.9436092376709, 0.557521156167833, -81.1519393920898, -1.41636853677085, 218, 13, 'PPL', 'P'),
(93325, 'Coffee City', 32.1158294677734, 0.560526966221665, -95.4991683959961, -1.66677492142664, 218, 51, 'PPL', 'P'),
(193457, 'Coffee Creek', 41.089168548584, 0.71714127807969, -122.707778930664, -2.14165476014941, 218, 6, 'PPL', 'P'),
(196244, 'Coffee Creek', 47.3477783203125, 0.826374625193844, -110.080833435059, -1.92127298678123, 218, 31, 'PPL', 'P'),
(45877, 'Coffee Hill', 38.3919410705566, 0.67006577791285, -76.8258285522461, -1.34086365880936, 218, 25, 'PPL', 'P'),
(194760, 'Coffee Point', 43.1563911437988, 0.753221118737811, -112.967216491699, -1.97164987459339, 218, 17, 'PPL', 'P'),
(134744, 'Coffee Pot Landing', 47.3494415283203, 0.826403653649725, -95.1827774047852, -1.66125285690636, 218, 28, 'PPL', 'P'),
(85910, 'Coffee Ridge', 36.0238914489746, 0.628735515165638, -82.5088882446289, -1.44005176202882, 218, 50, 'PPL', 'P'),
(13565, 'Coffee Run', 39.7513885498047, 0.693792612433666, -75.658332824707, -1.32048701436084, 218, 10, 'PPL', 'P'),
(1677, 'Coffee Springs', 31.1644401550293, 0.543922090245993, -85.9094390869141, -1.49940257060816, 218, 2, 'PPL', 'P'),
(26824, 'Coffeen', 39.089168548584, 0.682234693039804, -89.3905563354492, -1.56015952824307, 218, 18, 'PPL', 'P'),
(177972, 'Coffeepot', 34.0394401550293, 0.59410030624083, -111.186111450195, -1.94056372729528, 218, 5, 'PPL', 'P'),
(160241, 'Coffeetown', 40.6188888549805, 0.708933349021039, -75.2080612182617, -1.31262829230012, 218, 45, 'PPL', 'P'),
(1678, 'Coffeeville', 31.7577800750732, 0.55427782543428, -88.0897216796875, -1.53745568047598, 218, 2, 'PPL', 'P'),
(8159, 'Coffeeville', 35.4911117553711, 0.61943675532449, -91.4002838134766, -1.59523588980244, 218, 4, 'PPL', 'P'),
(59057, 'Coffeeville', 33.9766693115234, 0.593004748347399, -89.6755599975586, -1.56513378052712, 218, 30, 'PPL', 'P'),
(93326, 'Coffeeville', 32.8291702270508, 0.57297711115973, -94.7574996948242, -1.6538303606322, 218, 51, 'PPL', 'P'),
(1679, 'Coffeeville Landing', 31.7563896179199, 0.554253557378847, -88.1016693115234, -1.53766420598933, 218, 2, 'PPL', 'P'),
(191289, 'Cofferville', 34.0108299255371, 0.59360096353644, -102.32527923584, -1.78591303068799, 218, 51, 'PPL', 'P'),
(139094, 'Coffey', 40.1066703796387, 0.699993450136779, -94.004997253418, -1.64069671540037, 218, 29, 'PPL', 'P'),
(100960, 'Coffey Corner', 37.9505615234375, 0.66236225156466, -77.543327331543, -1.35338637488713, 218, 53, 'PPL', 'P'),
(113272, 'Coffeys Crossing', 40.1586112976074, 0.700899990171842, -80.3349990844727, -1.40211023861068, 218, 45, 'PPL', 'P'),
(54133, 'Coffeyton', 38.1166687011719, 0.66526136872732, -91.2727813720703, -1.59301055239557, 218, 29, 'PPL', 'P'),
(32115, 'Coffeyville', 37.0372200012207, 0.646421434806799, -95.6161117553711, -1.66881596808608, 218, 20, 'PPL', 'P'),
(180793, 'Coffing', 38.4563903808594, 0.671190630578272, -121.318061828613, -2.11739962104735, 218, 6, 'PPL', 'P'),
(70676, 'Coffins Corner', 39.8600006103516, 0.695688250497584, -74.9891662597656, -1.30880785455835, 218, 37, 'PPL', 'P'),
(143643, 'Coffins Mill', 42.9430618286133, 0.749497819796799, -70.8758316040039, -1.23701662157892, 218, 36, 'PPL', 'P'),
(147908, 'Coffins Mills', 44.1722183227539, 0.770950647641823, -75.085563659668, -1.31049030657701, 218, 40, 'PPL', 'P'),
(20142, 'Coffinton', 32.0097198486328, 0.558675003999624, -85.0224990844727, -1.48392254729791, 218, 13, 'PPL', 'P'),
(8162, 'Coffman', 36.0636100769043, 0.629428735997385, -91.0783309936523, -1.58961675306043, 218, 4, 'PPL', 'P'),
(35311, 'Coffman', 37.4630584716797, 0.653853718197965, -87.101936340332, -1.52021557400129, 218, 21, 'PPL', 'P'),
(45878, 'Coffman', 39.5994415283203, 0.691140636620165, -76.3219375610352, -1.33206910194159, 218, 25, 'PPL', 'P'),
(54134, 'Coffman', 37.7844390869141, 0.65946286808589, -90.1941680908203, -1.57418519928202, 218, 29, 'PPL', 'P'),
(160242, 'Coffman', 40.0516700744629, 0.69903351372186, -79.3822174072266, -1.38548106129006, 218, 45, 'PPL', 'P'),
(209944, 'Coffman Cove', 56.0138893127441, 0.977626795355049, -132.827774047852, -2.31828199523009, 218, 1, 'PPL', 'P'),
(100957, 'Coffmantown', 38.8916702270508, 0.678787697061887, -78.5877838134766, -1.37161557939067, 218, 53, 'PPL', 'P'),
(39831, 'Cofield', 30.1297206878662, 0.525862828709516, -90.9336090087891, -1.58709087792455, 218, 22, 'PPL', 'P'),
(63781, 'Cofield', 36.3563919067383, 0.634538742918002, -76.9102783203125, -1.34233758531467, 218, 33, 'PPL', 'P'),
(475, 'Cofield Corner', 38.9527816772461, 0.679854293078463, -84.958610534668, -1.4828074817495, 218, 19, 'PPL', 'P'),
(75492, 'Cogar', 35.3338890075684, 0.616692700716299, -98.1302795410156, -1.71269647389315, 218, 42, 'PPL', 'P'),
(20144, 'Cogdell', 31.1647205352783, 0.543926983804496, -82.7180633544922, -1.44370255640915, 218, 13, 'PPL', 'P'),
(177973, 'Cogdill Center', 35.1858291625977, 0.614108568931568, -111.643333435059, -1.94854375634364, 218, 5, 'PPL', 'P'),
(169322, 'Coggeshall', 41.6997184753418, 0.727797384549424, -71.2394409179688, -1.24336280129853, 218, 47, 'PPL', 'P'),
(160244, 'Coggins Corner', 41.6169395446777, 0.726352619658056, -75.3727798461914, -1.31550317469687, 218, 45, 'PPL', 'P'),
(63785, 'Coggins Mine', 35.4866714477539, 0.619359257336769, -80.0205612182617, -1.39662226255235, 218, 33, 'PPL', 'P'),
(115049, 'Coggon', 42.2808303833008, 0.737939700665855, -91.5302810668945, -1.59750476989314, 218, 16, 'PPL', 'P'),
(63782, 'Coghill', 35.5947189331055, 0.621245041704654, -77.3505630493164, -1.35002200348204, 218, 33, 'PPL', 'P'),
(63783, 'Cognac', 34.9561080932617, 0.610099179910454, -79.6100006103516, -1.38945662816533, 218, 33, 'PPL', 'P'),
(39829, 'Cognac (historical)', 31.6455593109131, 0.552319203610581, -92.9550018310547, -1.62237083814926, 218, 22, 'PPL', 'P'),
(35312, 'Cogswell', 38.0988883972168, 0.664951043881298, -83.4886093139648, -1.45715112043989, 218, 21, 'PPL', 'P'),
(139813, 'Cogswell', 46.1069412231445, 0.804717932367374, -97.7816696166992, -1.7066120829087, 218, 34, 'PPL', 'P'),
(196245, 'Cohagen', 47.0544395446777, 0.821254897735248, -106.616943359375, -1.8608167000334, 218, 31, 'PPL', 'P'),
(70677, 'Cohansey', 39.5113906860352, 0.689603859513135, -75.295280456543, -1.31415055517921, 218, 37, 'PPL', 'P'),
(45879, 'Cohansey Village', 39.1500015258789, 0.683296428787391, -76.6402816772461, -1.33762525492383, 218, 25, 'PPL', 'P'),
(45880, 'Cohasset', 38.9855613708496, 0.68042640665964, -77.1377792358398, -1.34630822534192, 218, 25, 'PPL', 'P'),
(100958, 'Cohasset', 37.7694396972656, 0.659201079350735, -78.3033294677734, -1.36665091448655, 218, 53, 'PPL', 'P'),
(124545, 'Cohasset', 42.2416687011719, 0.737256200372086, -70.8041687011719, -1.23576586797297, 218, 23, 'PPL', 'P'),
(134745, 'Cohasset', 47.2636108398438, 0.824905625536556, -93.620002746582, -1.63397729365399, 218, 28, 'PPL', 'P'),
(180794, 'Cohasset', 39.9255599975586, 0.696832477659937, -121.730003356934, -2.12458935704224, 218, 6, 'PPL', 'P'),
(1680, 'Cohassett', 31.3947200775146, 0.5479412330946, -86.6933288574219, -1.51308402807623, 218, 2, 'PPL', 'P'),
(207075, 'Cohassett', 46.8727798461914, 0.818084337878481, -124.105278015137, -2.16604572046707, 218, 56, 'PPL', 'P'),
(207076, 'Cohassett Beach', 46.8686103820801, 0.818011567001695, -124.110557556152, -2.16613786584079, 218, 56, 'PPL', 'P'),
(59059, 'Cohay', 31.9280605316162, 0.557249780052754, -89.5969390869141, -1.56376158677545, 218, 30, 'PPL', 'P'),
(80399, 'Cohen Hill', 32.8563919067383, 0.573452219098201, -80.0430603027344, -1.39701494565508, 218, 48, 'PPL', 'P'),
(80400, 'Cohens Bluff Landing', 32.8413887023926, 0.573190363784019, -81.4266662597656, -1.42116342515549, 218, 48, 'PPL', 'P'),
(20145, 'Cohentown', 33.7938919067383, 0.589814680835647, -82.7186126708984, -1.44371214378908, 218, 13, 'PPL', 'P'),
(160245, 'Coheva', 40.3458290100098, 0.704167555671315, -76.4502792358398, -1.33430908673446, 218, 45, 'PPL', 'P'),
(45881, 'Cohill', 39.6463890075684, 0.691960024708555, -78.2541732788086, -1.36579297714138, 218, 25, 'PPL', 'P'),
(612, 'Cohill Estates', 39.7000007629395, 0.692895726357554, -78.2083282470703, -1.36499283039186, 218, 25, 'PPL', 'P'),
(130279, 'Cohoctah', 42.7597198486328, 0.746297898589014, -83.9486083984375, -1.4651796190201, 218, 27, 'PPL', 'P'),
(130280, 'Cohoctah Center', 42.7550010681152, 0.746215540332303, -83.9869384765625, -1.46584860508593, 218, 27, 'PPL', 'P'),
(147909, 'Cohocton', 42.5022201538086, 0.741803681091451, -77.5074996948242, -1.35276106466318, 218, 40, 'PPL', 'P'),
(211762, 'Cohoe', 60.3686103820801, 1.05363101602093, -151.306396484375, -2.64079479798032, 218, 1, 'PPL', 'P'),
(147913, 'Cohoes', 42.774169921875, 0.746550099944244, -73.7005615234375, -1.28631745915263, 218, 40, 'PPL', 'P'),
(100959, 'Cohoke', 37.5791702270508, 0.655880250629461, -76.9463882446289, -1.34296782238663, 218, 53, 'PPL', 'P'),
(15577, 'Cohowfoochee (historical)', 30.3333301544189, 0.529416484289091, -84.5083312988281, -1.47494862653073, 218, 12, 'PPL', 'P'),
(20147, 'Cohutta', 34.9594383239746, 0.610157303401245, -84.9527816772461, -1.48270574899586, 218, 13, 'PPL', 'P'),
(20146, 'Cohutta Springs', 34.8877792358398, 0.608906616374317, -84.7272186279297, -1.47876893111445, 218, 13, 'PPL', 'P'),
(75493, 'Coil', 34.6580581665039, 0.604897227353202, -96.5294418334961, -1.68475658510686, 218, 42, 'PPL', 'P'),
(59060, 'Coila', 33.3952789306641, 0.582857571961979, -89.9711074829102, -1.57029205724249, 218, 30, 'PPL', 'P'),
(147912, 'Coila', 43.035831451416, 0.75111695516054, -73.4013900756836, -1.28109593236137, 218, 40, 'PPL', 'P'),
(85911, 'Coile', 35.4280586242676, 0.618336270583042, -84.6516723632813, -1.47745040005875, 218, 50, 'PPL', 'P'),
(160246, 'Coilton', 40.7094383239746, 0.710513735390919, -75.245002746582, -1.31327304360003, 218, 45, 'PPL', 'P'),
(35313, 'Coiltown', 37.3511085510254, 0.651899823485201, -87.6449966430664, -1.52969376432089, 218, 21, 'PPL', 'P'),
(8163, 'Coin', 36.3302803039551, 0.634083009476462, -93.3477783203125, -1.62922608111124, 218, 4, 'PPL', 'P'),
(35314, 'Coin', 37.1749992370605, 0.648826136113087, -84.5102767944336, -1.47498258183463, 218, 21, 'PPL', 'P'),
(115050, 'Coin', 40.6544418334961, 0.709553865555027, -95.2300033569336, -1.66207710526374, 218, 16, 'PPL', 'P'),
(134746, 'Coin', 45.7350006103516, 0.798226344052251, -93.3063888549805, -1.62850369866555, 218, 28, 'PPL', 'P'),
(199881, 'Coin', 40.8830604553223, 0.713544013237266, -115.714721679688, -2.01960288633941, 218, 39, 'PPL', 'P'),
(63784, 'Coinjock', 36.3427810668945, 0.634301188948767, -75.9527816772461, -1.32562611631637, 218, 33, 'PPL', 'P'),
(93327, 'Coit', 31.3830604553223, 0.547737734297804, -96.6711120605469, -1.68722919702094, 218, 51, 'PPL', 'P'),
(154785, 'Coits', 41.5499992370605, 0.725184290887838, -81.6022186279297, -1.42422739198962, 218, 41, 'PPL', 'P'),
(154786, 'Coitsville Center', 41.0905609130859, 0.717165579424637, -80.5691680908203, -1.40619725877757, 218, 41, 'PPL', 'P'),
(134747, 'Cokato', 45.0758285522461, 0.786721621301163, -94.1897201538086, -1.64392073821602, 218, 28, 'PPL', 'P'),
(93328, 'Coke', 32.9249992370605, 0.574649642903328, -95.4349975585938, -1.66565492903021, 218, 51, 'PPL', 'P'),
(29529, 'Coke Oven Hollow', 39.8530616760254, 0.695567143247013, -87.2919387817383, -1.52353174219066, 218, 19, 'PPL', 'P'),
(160247, 'Cokeburg', 40.1011085510254, 0.699896377915046, -80.067497253418, -1.39744145090366, 218, 45, 'PPL', 'P'),
(160248, 'Cokeburg Junction', 40.1086082458496, 0.700027272282623, -80.0316696166992, -1.39681614067971, 218, 45, 'PPL', 'P'),
(32117, 'Cokedale', 37.2466697692871, 0.650077022877097, -94.8925018310547, -1.65618659240665, 218, 20, 'PPL', 'P'),
(186553, 'Cokedale', 37.1452789306641, 0.648307418911766, -104.620559692383, -1.82597323191135, 218, 7, 'PPL', 'P'),
(207079, 'Cokedale', 48.5222206115723, 0.846872510050993, -122.170829772949, -2.13228322943148, 218, 56, 'PPL', 'P'),
(45882, 'Cokeland', 38.4049987792969, 0.670293677923134, -75.8777770996094, -1.32431703948254, 218, 25, 'PPL', 'P'),
(108656, 'Cokeleys', 39.1602783203125, 0.683475792686808, -81.1097183227539, -1.41563164009723, 218, 58, 'PPL', 'P'),
(1682, 'Coker', 33.2458305358887, 0.580249205411328, -87.6877822875977, -1.53044051469054, 218, 2, 'PPL', 'P'),
(15578, 'Coker', 27.5650005340576, 0.481100017633301, -81.8150024414063, -1.42794117012974, 218, 12, 'PPL', 'P'),
(39835, 'Coker', 31.9833297729492, 0.558214410289094, -93.7136077880859, -1.6356110098247, 218, 22, 'PPL', 'P'),
(199238, 'Coker', 41.1838912963867, 0.718794501905384, -101.116668701172, -1.76481879748375, 218, 35, 'PPL', 'P'),
(85912, 'Coker Creek', 35.2655601501465, 0.615500137180162, -84.2858276367188, -1.47106520502917, 218, 50, 'PPL', 'P'),
(1681, 'Coker Heights', 33.249439239502, 0.580312189171108, -87.6944427490234, -1.53055676167213, 218, 2, 'PPL', 'P'),
(63787, 'Cokers Crossroads', 35.4061088562012, 0.617953174860234, -77.8424987792969, -1.3586079016784, 218, 33, 'PPL', 'P'),
(147914, 'Cokertown', 42.0191688537598, 0.73337284544956, -73.8216705322266, -1.28843121010983, 218, 40, 'PPL', 'P'),
(45883, 'Cokesbury', 38.1269416809082, 0.665440666047709, -75.5794372558594, -1.31911002691921, 218, 25, 'PPL', 'P'),
(63789, 'Cokesbury', 36.3486099243164, 0.634402921702408, -78.304443359375, -1.3666703555625, 218, 33, 'PPL', 'P'),
(80401, 'Cokesbury', 34.2891693115234, 0.598458902259881, -82.2080612182617, -1.43480133993973, 218, 48, 'PPL', 'P'),
(145021, 'Cokesbury', 40.6833305358887, 0.710058068528406, -74.836669921875, -1.30614629136493, 218, 37, 'PPL', 'P'),
(154788, 'Cokesbury Corners', 40.1769409179688, 0.701219902397788, -82.5530624389648, -1.4408227471644, 218, 41, 'PPL', 'P'),
(13566, 'Cokesbury Village', 39.7750015258789, 0.694204736612355, -75.658332824707, -1.32048701436084, 218, 10, 'PPL', 'P'),
(108657, 'Coketon', 39.1399993896484, 0.683121858577936, -79.5122222900391, -1.38775007453881, 218, 58, 'PPL', 'P'),
(177202, 'Coketown', 40.3455581665039, 0.70416282856038, -80.605827331543, -1.40683708322946, 218, 58, 'PPL', 'P'),
(209374, 'Cokeville', 42.0825004577637, 0.734478190459997, -110.954437255859, -1.93652024981221, 218, 59, 'PPL', 'P'),
(160250, 'Cokeville (historical)', 40.4183311462402, 0.705432956663266, -79.2558288574219, -1.38327516495915, 218, 45, 'PPL', 'P'),
(199882, 'Colado', 40.2455596923828, 0.702417525939996, -118.391937255859, -2.06632911292929, 218, 39, 'PPL', 'P'),
(1683, 'Colbert', 32.2825012207031, 0.563435937080358, -85.2366714477539, -1.48766056020395, 218, 2, 'PPL', 'P'),
(20148, 'Colbert', 34.0377807617188, 0.594071344363976, -83.2127838134766, -1.45233705729541, 218, 13, 'PPL', 'P'),
(75494, 'Colbert', 33.8530616760254, 0.590847388127353, -96.5022201538086, -1.68428147716839, 218, 42, 'PPL', 'P'),
(207077, 'Colbert', 47.8266716003418, 0.83473288969603, -117.340827941895, -2.04798379460222, 218, 56, 'PPL', 'P'),
(59061, 'Colbert (historical)', 34.8213882446289, 0.607747874984023, -89.3186111450195, -1.55890384778909, 218, 30, 'PPL', 'P'),
(1685, 'Colbert Heights', 34.660831451416, 0.604945630306014, -87.6944427490234, -1.53055676167213, 218, 2, 'PPL', 'P'),
(45885, 'Colbourn Manor', 38.3333282470703, 0.669042791159123, -75.5977783203125, -1.31943013888224, 218, 25, 'PPL', 'P'),
(45884, 'Colbourne', 38.2613906860352, 0.667787243863205, -75.4544372558594, -1.31692836535422, 218, 25, 'PPL', 'P'),
(113375, 'Colburn', 45.0402793884277, 0.786101171346202, -91.0447235107422, -1.58903019183034, 218, 57, 'PPL', 'P'),
(122405, 'Colburn', 40.5186080932617, 0.707183119552639, -86.7130584716797, -1.51342837480517, 218, 19, 'PPL', 'P'),
(194761, 'Colburn', 48.3972206115723, 0.844690848486, -116.534172058105, -2.03390499349952, 218, 17, 'PPL', 'P'),
(8165, 'Colburn Spring (historical)', 34.9902801513672, 0.610695594836577, -94.0144424438477, -1.64086156507185, 218, 4, 'PPL', 'P'),
(147915, 'Colburns', 42.1388893127441, 0.735462361640836, -79.3600006103516, -1.38509330503534, 218, 40, 'PPL', 'P'),
(35315, 'Colby', 37.9958305358887, 0.663152344881059, -84.2636108398438, -1.47067744877446, 218, 21, 'PPL', 'P'),
(59062, 'Colby', 32.8783302307129, 0.573835115083927, -90.6858291625977, -1.58276630378842, 218, 30, 'PPL', 'P'),
(127133, 'Colby', 46.9002799987793, 0.818564306085941, -68.1363906860352, -1.18920435789651, 218, 26, 'PPL', 'P'),
(134750, 'Colby', 47.5419387817383, 0.829763364522915, -92.1697235107422, -1.60866514591528, 218, 28, 'PPL', 'P'),
(143644, 'Colby', 43.1494407653809, 0.753099811750158, -71.769172668457, -1.2526083644969, 218, 36, 'PPL', 'P'),
(154789, 'Colby', 41.2633285522461, 0.720180943568879, -82.9463882446289, -1.44768757750629, 218, 41, 'PPL', 'P'),
(173610, 'Colby', 44.9099998474121, 0.783827364407492, -90.315559387207, -1.57630387708723, 218, 57, 'PPL', 'P'),
(186554, 'Colby', 38.9316711425781, 0.679485844741651, -107.974716186523, -1.88451430636125, 218, 7, 'PPL', 'P'),
(187627, 'Colby', 39.3958282470703, 0.687586914461563, -101.051940917969, -1.76368908454934, 218, 20, 'PPL', 'P'),
(207078, 'Colby', 47.5327796936035, 0.829603508278483, -122.544441223145, -2.13880397936054, 218, 56, 'PPL', 'P'),
(85913, 'Colby (historical)', 36.4716682434082, 0.63655069454253, -82.4166717529297, -1.43844228062403, 218, 50, 'PPL', 'P'),
(35316, 'Colby Hills', 37.9888916015625, 0.663031237630487, -84.1977767944336, -1.46952842792214, 218, 21, 'PPL', 'P'),
(119187, 'Colby Point', 42.2963905334473, 0.738211276518016, -88.2399978637695, -1.54007849467554, 218, 18, 'PPL', 'P'),
(171864, 'Colbyville', 44.3502807617188, 0.774058423475891, -72.7427825927734, -1.26960106330631, 218, 55, 'PPL', 'P'),
(100962, 'Colchester', 38.6686096191406, 0.674894555022354, -77.2344436645508, -1.34799533789249, 218, 53, 'PPL', 'P'),
(119188, 'Colchester', 40.4263916015625, 0.705573638147849, -90.7925033569336, -1.5846281197065, 218, 18, 'PPL', 'P'),
(147916, 'Colchester', 42.1602783203125, 0.735835670246638, -75.0777816772461, -1.31035448536142, 218, 40, 'PPL', 'P'),
(171865, 'Colchester', 44.5438919067383, 0.777437575425038, -73.1483306884766, -1.27667921285153, 218, 55, 'PPL', 'P'),
(177615, 'Colchester', 41.5755615234375, 0.725630436949454, -72.3324966430664, -1.26244022260925, 218, 8, 'PPL', 'P'),
(207080, 'Colchester', 47.545280456543, 0.829821687750788, -122.540283203125, -2.13873140822083, 218, 56, 'PPL', 'P'),
(100961, 'Colchester Acres', 38.8133316040039, 0.67742043015824, -77.3730621337891, -1.35041468658477, 218, 53, 'PPL', 'P'),
(45888, 'Colchester on the Severn', 39.0727806091309, 0.681948669538729, -76.5722198486328, -1.3364373519196, 218, 25, 'PPL', 'P'),
(75498, 'Colcord', 36.2641716003418, 0.632929194934186, -94.6927795410156, -1.65270078085585, 218, 42, 'PPL', 'P'),
(108658, 'Colcord', 37.9441719055176, 0.662250731694013, -81.4372177124023, -1.42134758274487, 218, 58, 'PPL', 'P'),
(177974, 'Colcord Mountain Estates', 34.2638893127441, 0.598017683046282, -110.900283813477, -1.93557509394134, 218, 5, 'PPL', 'P'),
(211763, 'Cold Bay', 55.1858291625977, 0.963174419330434, -162.721115112305, -2.84001922122642, 218, 1, 'PPL', 'P'),
(127134, 'Cold Brook', 44.7799987792969, 0.781558417737772, -68.8691711425781, -1.20199378955745, 218, 26, 'PPL', 'P'),
(147919, 'Cold Brook', 42.0130615234375, 0.733266252426929, -74.2702789306641, -1.29626090371466, 218, 40, 'PPL', 'P'),
(193458, 'Cold Fork', 40.1719398498535, 0.70113261729306, -122.672218322754, -2.14103411045737, 218, 6, 'PPL', 'P'),
(100963, 'Cold Harbor Farms', 37.5913887023926, 0.656093503253749, -77.3147201538086, -1.34939642694198, 218, 53, 'PPL', 'P'),
(145033, 'Cold Indian Springs', 40.2422218322754, 0.702359269291151, -74.0666732788086, -1.29270731471411, 218, 37, 'PPL', 'P'),
(80404, 'Cold Point', 34.4216690063477, 0.600771458192451, -82.0461120605469, -1.43197479391677, 218, 48, 'PPL', 'P'),
(160252, 'Cold Point', 40.1113891601563, 0.70007580839349, -75.2719421386719, -1.31374322469049, 218, 45, 'PPL', 'P'),
(143645, 'Cold River', 43.1222190856934, 0.752624703811688, -72.4277801513672, -1.26410323355195, 218, 36, 'PPL', 'P'),
(171867, 'Cold River', 43.5394401550293, 0.759906585180292, -72.8755569458008, -1.27191841292885, 218, 55, 'PPL', 'P'),
(160251, 'Cold Run', 40.1966705322266, 0.701564249126735, -75.8330612182617, -1.32353660012509, 218, 45, 'PPL', 'P'),
(45886, 'Cold Saturday', 39.4858283996582, 0.689157713451519, -76.896110534668, -1.34209031080745, 218, 25, 'PPL', 'P'),
(1686, 'Cold Spring', 32.6088905334473, 0.569132505231065, -86.3680572509766, -1.5074069675805, 218, 2, 'PPL', 'P'),
(35317, 'Cold Spring', 39.021671295166, 0.681056643731607, -84.4400024414063, -1.47375606299459, 218, 21, 'PPL', 'P'),
(45887, 'Cold Spring', 39.348331451416, 0.686757938993249, -76.6580581665039, -1.33793551319082, 218, 25, 'PPL', 'P'),
(70678, 'Cold Spring', 38.9666709899902, 0.680096707316688, -74.9166717529297, -1.30754258672445, 218, 37, 'PPL', 'P'),
(80403, 'Cold Spring', 34.9144401550293, 0.609371937195781, -82.0069427490234, -1.43129116046495, 218, 48, 'PPL', 'P'),
(85916, 'Cold Spring', 36.5741691589355, 0.638339673004791, -82.0677795410156, -1.43235296279156, 218, 50, 'PPL', 'P'),
(100965, 'Cold Spring', 37.9944381713867, 0.663128043536112, -79.1347198486328, -1.38116141400195, 218, 53, 'PPL', 'P'),
(124549, 'Cold Spring', 42.1541709899902, 0.735729077224007, -73.0749969482422, -1.27539929763163, 218, 23, 'PPL', 'P'),
(134758, 'Cold Spring', 45.4558296203613, 0.793353891100869, -94.4286117553711, -1.64809018321865, 218, 28, 'PPL', 'P'),
(147922, 'Cold Spring', 41.4199981689453, 0.722915344218118, -73.9550018310547, -1.29075828027034, 218, 40, 'PPL', 'P'),
(160255, 'Cold Spring', 41.728889465332, 0.72830651437082, -75.2980575561523, -1.31419902471105, 218, 45, 'PPL', 'P'),
(171868, 'Cold Spring', 43.6713905334473, 0.762209553732938, -73.4072189331055, -1.28119766511501, 218, 55, 'PPL', 'P'),
(173613, 'Cold Spring', 42.8908309936523, 0.748586219755665, -88.774169921875, -1.54940155586164, 218, 57, 'PPL', 'P'),
(186555, 'Cold Spring', 38.1494407653809, 0.665833349150442, -105.241943359375, -1.83681842281848, 218, 7, 'PPL', 'P'),
(190055, 'Cold Spring', 37.7513885498047, 0.658886027393779, -114.423889160156, -1.99707360878178, 218, 39, 'PPL', 'P'),
(196246, 'Cold Spring', 46.2827796936035, 0.807786892628554, -106.757499694824, -1.86326987087152, 218, 31, 'PPL', 'P'),
(180796, 'Cold Spring (historical)', 39.4608306884766, 0.688721421085937, -120.911109924316, -2.11029697042011, 218, 6, 'PPL', 'P'),
(169323, 'Cold Spring Beach', 41.5666694641113, 0.72547524123693, -71.4438934326172, -1.24693117084312, 218, 47, 'PPL', 'P'),
(147923, 'Cold Spring Harbor', 40.8713912963867, 0.713340347992902, -73.4572219848633, -1.28207038300423, 218, 40, 'PPL', 'P'),
(202018, 'Cold Spring II (historical)', 43.6222190856934, 0.76135135007166, -103.504722595215, -1.80649820064987, 218, 49, 'PPL', 'P'),
(147924, 'Cold Spring Park', 43.9983291625977, 0.767915709263569, -73.4752807617188, -1.28238556811924, 218, 40, 'PPL', 'P'),
(1690, 'Cold Springs', 33.9816703796387, 0.593092033452126, -87.033332824707, -1.51901821677519, 218, 2, 'PPL', 'P'),
(35318, 'Cold Springs', 38.0538902282715, 0.664165677675834, -86.289436340332, -1.50603477382884, 218, 21, 'PPL', 'P'),
(54136, 'Cold Springs', 38.2313919067383, 0.667263666392896, -93.383056640625, -1.62984180395526, 218, 29, 'PPL', 'P'),
(59064, 'Cold Springs', 31.6186103820801, 0.55184885607256, -89.5444412231445, -1.56284532620241, 218, 30, 'PPL', 'P'),
(63791, 'Cold Springs', 35.4150009155273, 0.618108370572758, -80.5133285522461, -1.40522267497665, 218, 33, 'PPL', 'P'),
(75497, 'Cold Springs', 34.7958297729492, 0.607301795501435, -99.0047225952148, -1.72795838431012, 218, 42, 'PPL', 'P'),
(85918, 'Cold Springs', 36.5194396972656, 0.637384463700806, -82.8488922119141, -1.44598595072779, 218, 50, 'PPL', 'P'),
(93329, 'Cold Springs', 31.2416706085205, 0.545270015942223, -97.6163864135742, -1.70372734681593, 218, 51, 'PPL', 'P'),
(122406, 'Cold Springs', 41.5558280944824, 0.72528602364148, -84.9088897705078, -1.48193969070829, 218, 19, 'PPL', 'P'),
(130284, 'Cold Springs', 45.4602813720703, 0.793431588825672, -84.5899963378906, -1.47637395034614, 218, 27, 'PPL', 'P'),
(147927, 'Cold Springs', 42.374439239502, 0.739573483415591, -77.2827835083008, -1.34883902732582, 218, 40, 'PPL', 'P'),
(154790, 'Cold Springs', 41.7319412231445, 0.728359777592622, -80.8663864135742, -1.41138469710688, 218, 41, 'PPL', 'P'),
(173614, 'Cold Springs', 43.8477783203125, 0.765288101374042, -91.2125015258789, -1.59195847060694, 218, 57, 'PPL', 'P'),
(180798, 'Cold Springs', 38.1624984741211, 0.666061249160725, -120.052223205566, -2.09530656927627, 218, 6, 'PPL', 'P'),
(190057, 'Cold Springs', 39.4122200012207, 0.687873004541665, -117.838333129883, -2.05666689817837, 218, 39, 'PPL', 'P'),
(200604, 'Cold Springs', 45.8786087036133, 0.800732778112179, -119.164436340332, -2.07981176542198, 218, 43, 'PPL', 'P'),
(8166, 'Cold Springs (historical)', 34.7938919067383, 0.607267973355591, -92.6999969482422, -1.61792016333552, 218, 4, 'PPL', 'P'),
(20149, 'Cold Springs (historical)', 31.7622203826904, 0.554355323422001, -83.4563903808594, -1.45658879397572, 218, 13, 'PPL', 'P'),
(59063, 'Cold Springs (historical)', 33.4683303833008, 0.584132560333854, -90.9855575561523, -1.58799755111766, 218, 30, 'PPL', 'P'),
(85919, 'Cold Springs (historical)', 36.1388893127441, 0.630742606521176, -84.9966735839844, -1.48347180728342, 218, 50, 'PPL', 'P'),
(200605, 'Cold Springs Junction', 45.913890838623, 0.801348567535233, -119.136940002441, -2.07933186379354, 218, 43, 'PPL', 'P'),
(108660, 'Cold Stream', 39.3394393920898, 0.686602743280724, -78.4422225952148, -1.36907505686879, 218, 58, 'PPL', 'P'),
(63792, 'Cold Water', 35.4161109924316, 0.618127745069689, -80.5500030517578, -1.40586276574465, 218, 33, 'PPL', 'P'),
(20150, 'Coldbrook', 32.2374992370605, 0.562650504295866, -81.241943359375, -1.41793940233984, 218, 13, 'PPL', 'P'),
(119190, 'Coldbrook', 40.9474983215332, 0.714668666165606, -90.517219543457, -1.57982351078388, 218, 18, 'PPL', 'P'),
(147928, 'Coldbrook', 42.7786102294922, 0.746627597931966, -73.9441680908203, -1.29056919583294, 218, 40, 'PPL', 'P'),
(160257, 'Coldbrook', 40.040828704834, 0.69884429612641, -79.5763931274414, -1.38887006693524, 218, 45, 'PPL', 'P'),
(124550, 'Coldbrook Springs', 42.3944396972656, 0.739922557255473, -72.0472183227539, -1.25746117663524, 218, 23, 'PPL', 'P'),
(147929, 'Colden', 42.6441688537598, 0.744281153274524, -78.6849975585938, -1.37331227932116, 218, 40, 'PPL', 'P'),
(147931, 'Coldenham', 41.5255584716797, 0.724757719060235, -74.1533279418945, -1.29421972389717, 218, 40, 'PPL', 'P'),
(211764, 'Coldfoot', 67.2563934326172, 1.17384550841586, -150.184173583984, -2.62120831342722, 218, 1, 'PPL', 'P'),
(35319, 'Coldiron', 36.8266716003418, 0.642746671976654, -83.45361328125, -1.45654032444388, 218, 21, 'PPL', 'P'),
(160258, 'Coldsborough Manor', 40.1338882446289, 0.700468491496222, -76.748893737793, -1.33952089298774, 218, 45, 'PPL', 'P'),
(54138, 'Coldspring', 36.9716682434082, 0.645277340802501, -92.4302825927734, -1.6132127597927, 218, 29, 'PPL', 'P'),
(93330, 'Coldspring', 30.5922203063965, 0.533934969842087, -95.1291732788086, -1.66031728841542, 218, 51, 'PPL', 'P'),
(160259, 'Coldspring Crossing', 40.1555595397949, 0.70084672695004, -75.4555587768555, -1.31694793958823, 218, 45, 'PPL', 'P'),
(32119, 'Coldspur', 39.0044403076172, 0.68075590626551, -94.9244384765625, -1.65674399202281, 218, 20, 'PPL', 'P'),
(20151, 'Coldstream', 33.9172210693359, 0.591967180786704, -84.4038925170898, -1.47312582592262, 218, 13, 'PPL', 'P'),
(35321, 'Coldstream', 38.3147201538086, 0.668718018664188, -85.5238876342773, -1.4926734283238, 218, 21, 'PPL', 'P'),
(45890, 'Coldstream', 39.7019386291504, 0.692929548503398, -76.4899978637695, -1.33500230756621, 218, 25, 'PPL', 'P'),
(80405, 'Coldstream', 34.0666694641113, 0.594575547337355, -81.2077789306641, -1.41734312057177, 218, 48, 'PPL', 'P'),
(1689, 'Coldwater', 31.4347190856934, 0.548639347484851, -86.4233322143555, -1.50837169768538, 218, 2, 'PPL', 'P'),
(8167, 'Coldwater', 35.3644409179688, 0.617225932145561, -90.5788879394531, -1.58089982733844, 218, 4, 'PPL', 'P'),
(20152, 'Coldwater', 34.2230606079102, 0.597305087717604, -82.7975006103516, -1.44508899807265, 218, 13, 'PPL', 'P'),
(32118, 'Coldwater', 37.2688903808594, 0.65046484571084, -99.3263931274414, -1.73357259420412, 218, 20, 'PPL', 'P'),
(35320, 'Coldwater', 36.6508293151855, 0.639677645136446, -88.4552764892578, -1.54383581549948, 218, 21, 'PPL', 'P'),
(39832, 'Coldwater', 31.9819393157959, 0.558190142233661, -92.8638916015625, -1.62078066466238, 218, 22, 'PPL', 'P'),
(54137, 'Coldwater', 37.3033294677734, 0.65106592116887, -90.4097213745117, -1.57794731379592, 218, 29, 'PPL', 'P'),
(59066, 'Coldwater', 34.6916694641113, 0.60548385516232, -89.9772186279297, -1.57039871684415, 218, 30, 'PPL', 'P'),
(85920, 'Coldwater', 35.0844383239746, 0.612338964966238, -86.7336120605469, -1.51378710260401, 218, 50, 'PPL', 'P'),
(100966, 'Coldwater', 37.6541709899902, 0.657189260884262, -76.7347183227539, -1.33927348532248, 218, 53, 'PPL', 'P'),
(108659, 'Coldwater', 39.1683311462402, 0.683616341013337, -80.6336135864258, -1.40732204486396, 218, 58, 'PPL', 'P'),
(130283, 'Coldwater', 41.9402809143066, 0.731995991165989, -85.0005569458008, -1.48353958473316, 218, 27, 'PPL', 'P'),
(147933, 'Coldwater', 43.1358299255371, 0.752862257780923, -77.7355575561523, -1.35674142522842, 218, 40, 'PPL', 'P'),
(154791, 'Coldwater', 40.4797210693359, 0.706504412948832, -84.6283264160156, -1.47704293641197, 218, 41, 'PPL', 'P'),
(191291, 'Coldwater', 36.4552803039551, 0.636264671041455, -102.629173278809, -1.79121698231499, 218, 51, 'PPL', 'P'),
(85921, 'Coldwater (historical)', 35.7319412231445, 0.623640022472962, -86.0305633544922, -1.50151658788147, 218, 50, 'PPL', 'P'),
(154792, 'Coldwater Beach', 40.5019416809082, 0.706892235782575, -84.5458297729492, -1.47560309836861, 218, 41, 'PPL', 'P'),
(199239, 'Coldwater Trailer Court', 41.4972190856934, 0.72426310346678, -102.619720458984, -1.79105199948546, 218, 35, 'PPL', 'P'),
(851, 'Cole', 35.1022186279297, 0.612649289812259, -97.5725021362305, -1.70296142168642, 218, 42, 'PPL', 'P'),
(8170, 'Cole', 33.6508293151855, 0.587317767576616, -93.9863891601563, -1.64037194290543, 218, 4, 'PPL', 'P'),
(39833, 'Cole', 30.771110534668, 0.537057193325069, -91.2361068725586, -1.59237046162757, 218, 22, 'PPL', 'P'),
(72173, 'Cole', 39.2988891601563, 0.685895008221036, -81.9063873291016, -1.42953613730659, 218, 41, 'PPL', 'P'),
(93331, 'Cole', 32.7005615234375, 0.570732465834957, -96.9205627441406, -1.691582932771, 218, 51, 'PPL', 'P'),
(113057, 'Cole', 40.4797210693359, 0.706504412948832, -85.7872161865234, -1.49726937857501, 218, 19, 'PPL', 'P'),
(193459, 'Cole', 42.0022201538086, 0.733077034831479, -122.639167785645, -2.14045726976526, 218, 6, 'PPL', 'P'),
(196247, 'Cole', 48.5411109924316, 0.847202209393944, -107.468063354492, -1.87567154627775, 218, 31, 'PPL', 'P'),
(45891, 'Cole (historical)', 39.4583282470703, 0.68867774524406, -76.1294403076172, -1.3287093910684, 218, 25, 'PPL', 'P'),
(85922, 'Cole (historical)', 35.2013893127441, 0.614380144783729, -87.095832824707, -1.52010904755769, 218, 50, 'PPL', 'P'),
(54140, 'Cole Camp', 38.4599990844727, 0.671253614338053, -93.2024993896484, -1.62669048543737, 218, 29, 'PPL', 'P'),
(54141, 'Cole Camp Junction', 38.4627799987793, 0.671302150448919, -93.2752838134766, -1.62796081327734, 218, 29, 'PPL', 'P'),
(39834, 'Cole Central', 30.8819408416748, 0.538991547093334, -93.0861129760742, -1.62465915931591, 218, 22, 'PPL', 'P'),
(20153, 'Cole City', 34.9519386291504, 0.610026409033668, -85.5680618286133, -1.49344441345938, 218, 13, 'PPL', 'P'),
(93332, 'Cole Colonia', 26.2399997711182, 0.45797439172857, -98.1240005493164, -1.7125868848143, 218, 51, 'PPL', 'P'),
(124551, 'Cole Corner', 42.2236099243164, 0.736941015257075, -70.8861083984375, -1.23719598547834, 218, 23, 'PPL', 'P'),
(127135, 'Cole Corner', 45.1725006103516, 0.788408867009783, -69.51611328125, -1.21328505994717, 218, 26, 'PPL', 'P'),
(198135, 'Cole Ford', 48.5291709899902, 0.846993817038646, -100.462783813477, -1.75340635326443, 218, 34, 'PPL', 'P'),
(160260, 'Cole Hill', 40.0130615234375, 0.698359667387043, -75.9680633544922, -1.32589283189954, 218, 45, 'PPL', 'P'),
(54143, 'Cole Junction', 38.6141700744629, 0.673944405724441, -92.2241668701172, -1.60961536179222, 218, 29, 'PPL', 'P'),
(124552, 'Cole Mill', 41.9263916015625, 0.731753576927764, -70.7991714477539, -1.23567864944727, 218, 23, 'PPL', 'P'),
(188340, 'Cole Place', 32.8202781677246, 0.572821915447206, -104.743057250977, -1.82811121763446, 218, 38, 'PPL', 'P'),
(8171, 'Cole Ridge', 35.8427810668945, 0.625574542688796, -89.9991683959961, -1.57078181256696, 218, 4, 'PPL', 'P'),
(1691, 'Cole Spring', 34.353889465332, 0.599588482036238, -86.8327789306641, -1.51551789099645, 218, 2, 'PPL', 'P'),
(1692, 'Coleanor', 33.0955581665039, 0.577626457790791, -87.0358276367188, -1.51906175945902, 218, 2, 'PPL', 'P'),
(108661, 'Colebank', 39.2438888549805, 0.684935071806117, -79.8424987792969, -1.39351448671828, 218, 58, 'PPL', 'P'),
(45895, 'Colebrook', 39.4124984741211, 0.687877864810654, -77.5458297729492, -1.35343005072901, 218, 25, 'PPL', 'P'),
(143646, 'Colebrook', 44.8944396972656, 0.783555788555331, -71.4963912963867, -1.24784743141617, 218, 36, 'PPL', 'P'),
(154793, 'Colebrook', 41.5355606079102, 0.72493228926969, -80.7627792358398, -1.40957641072672, 218, 41, 'PPL', 'P'),
(160261, 'Colebrook', 40.2380599975586, 0.702286631572419, -76.5113906860352, -1.33537568275104, 218, 45, 'PPL', 'P'),
(177617, 'Colebrook', 41.9894409179688, 0.732853995090185, -73.0961074829102, -1.27576774596845, 218, 8, 'PPL', 'P'),
(160263, 'Colebrookdale', 40.3074989318848, 0.703498569605487, -75.6524963378906, -1.32038514844914, 218, 45, 'PPL', 'P'),
(45892, 'Colebrooke', 38.8411102294922, 0.677905258634689, -76.9516677856445, -1.34305996776035, 218, 25, 'PPL', 'P'),
(147934, 'Colegrave', 42.7361106872559, 0.745885840989351, -78.5550003051758, -1.37104339923047, 218, 40, 'PPL', 'P'),
(160265, 'Colegrove', 41.7286109924316, 0.728301654101831, -78.3861083984375, -1.36809567937791, 218, 45, 'PPL', 'P'),
(198132, 'Coleharbor', 47.5441703796387, 0.829802313253857, -101.223327636719, -1.76668034708571, 218, 34, 'PPL', 'P'),
(1693, 'Coleman', 32.6005592346191, 0.568987096635547, -87.4780578613281, -1.52678013293029, 218, 2, 'PPL', 'P'),
(8173, 'Coleman', 33.7744407653809, 0.58947519437569, -91.748893737793, -1.60132028078689, 218, 4, 'PPL', 'P'),
(15580, 'Coleman', 28.7994403839111, 0.502645057431069, -82.0702819824219, -1.43239663863344, 218, 12, 'PPL', 'P'),
(20154, 'Coleman', 31.672779083252, 0.552794278259538, -84.8891677856445, -1.4815954771374, 218, 13, 'PPL', 'P'),
(32121, 'Coleman', 37.8641700744629, 0.660854436334484, -97.4636077880859, -1.70106085677449, 218, 20, 'PPL', 'P'),
(35322, 'Coleman', 37.4813919067383, 0.654173697002938, -82.1833267211914, -1.43436964152703, 218, 21, 'PPL', 'P'),
(39836, 'Coleman', 32.3255615234375, 0.564187481139979, -91.0844421386719, -1.58972341266209, 218, 22, 'PPL', 'P'),
(45893, 'Coleman', 39.3413887023926, 0.68663676516365, -76.0783309936523, -1.32781736526128, 218, 25, 'PPL', 'P'),
(54144, 'Coleman', 38.7513885498047, 0.676339319913722, -94.3944396972656, -1.64749376829252, 218, 29, 'PPL', 'P'),
(63793, 'Coleman', 35.6533317565918, 0.62226802845838, -82.254997253418, -1.43562052829104, 218, 33, 'PPL', 'P'),
(75500, 'Coleman', 34.2713890075684, 0.59814857741386, -96.4188919067383, -1.6828271248971, 218, 42, 'PPL', 'P'),
(93333, 'Coleman', 31.827220916748, 0.555489796756862, -99.4261093139648, -1.73531296997649, 218, 51, 'PPL', 'P'),
(108662, 'Coleman', 38.1622200012207, 0.666056388891736, -82.4749984741211, -1.43946027395071, 218, 58, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(119192, 'Coleman', 41.9786109924316, 0.732664977231817, -88.2972183227539, -1.54107718008432, 218, 18, 'PPL', 'P'),
(130288, 'Coleman', 43.7566719055176, 0.763697994466183, -84.5858306884766, -1.47630124604838, 218, 27, 'PPL', 'P'),
(154795, 'Coleman', 40.7961082458496, 0.712026410890084, -80.8133316040039, -1.41045871599586, 218, 41, 'PPL', 'P'),
(160266, 'Coleman', 40.0527801513672, 0.69905288821879, -78.9636077880859, -1.37817494515554, 218, 45, 'PPL', 'P'),
(173616, 'Coleman', 45.064998626709, 0.786532603442795, -88.0341720581055, -1.53648615668113, 218, 57, 'PPL', 'P'),
(180799, 'Coleman', 39.1775016784668, 0.68377639699485, -120.974716186523, -2.11140710912051, 218, 6, 'PPL', 'P'),
(194762, 'Coleman', 48.0041694641113, 0.837830811834065, -116.905830383301, -2.04039165496662, 218, 17, 'PPL', 'P'),
(171869, 'Coleman Corner', 44.2586097717285, 0.772458462871999, -73.2222213745117, -1.2779688486094, 218, 55, 'PPL', 'P'),
(100969, 'Coleman Falls', 37.5013885498047, 0.654522704263793, -79.3038864135742, -1.38411392754447, 218, 53, 'PPL', 'P'),
(85923, 'Coleman Heights', 35.4438896179199, 0.618612573546138, -86.7830581665039, -1.51465009995525, 218, 50, 'PPL', 'P'),
(145022, 'Coleman Hollow', 40.8122215270996, 0.712307640701196, -74.607780456543, -1.30215141657175, 218, 37, 'PPL', 'P'),
(100967, 'Coleman Place', 36.8705596923828, 0.643512663685188, -76.2447204589844, -1.33072140927196, 218, 53, 'PPL', 'P'),
(147935, 'Coleman Station', 41.901668548584, 0.731322078252144, -73.5188903808594, -1.28314669955878, 218, 40, 'PPL', 'P'),
(100968, 'Coleman Store', 36.8861083984375, 0.643784039800267, -80.9916687011719, -1.41357128551989, 218, 53, 'PPL', 'P'),
(85924, 'Coleman Subdivision', 35.4847183227539, 0.619325168874816, -84.8708267211914, -1.48127536517437, 218, 50, 'PPL', 'P'),
(39838, 'Coleman Town', 30.8891696929932, 0.539117714349977, -90.8199996948242, -1.58510802133493, 218, 22, 'PPL', 'P'),
(63794, 'Colemans (historical)', 35.4997215270996, 0.619587024188998, -80.6180572509766, -1.40705053559083, 218, 33, 'PPL', 'P'),
(20155, 'Colemans Bluff', 34.0930595397949, 0.595036141047884, -84.4469375610352, -1.47387710366613, 218, 13, 'PPL', 'P'),
(80407, 'Colemans Crossroads', 34.105281829834, 0.5952494602512, -81.7744369506836, -1.42723316875394, 218, 48, 'PPL', 'P'),
(20156, 'Colemans Lake', 32.8208312988281, 0.572831569406158, -82.2752838134766, -1.43597459555796, 218, 13, 'PPL', 'P'),
(20157, 'Colemans Landing', 34.1027793884277, 0.595205784409322, -84.4433288574219, -1.47381411990635, 218, 13, 'PPL', 'P'),
(100970, 'Colemans Mill', 38.1161117553711, 0.665251648189341, -77.5244369506836, -1.35305667554418, 218, 53, 'PPL', 'P'),
(100971, 'Colemans Mill Crossing', 37.9588890075684, 0.662507593581151, -77.4297180175781, -1.35140351829751, 218, 53, 'PPL', 'P'),
(147936, 'Colemans Mills', 43.1294403076172, 0.752750737910276, -75.3463897705078, -1.31504258098634, 218, 40, 'PPL', 'P'),
(112332, 'Colemansville', 38.5277786254883, 0.672436590494266, -84.4069366455078, -1.47317895598637, 218, 21, 'PPL', 'P'),
(70689, 'Colemantown', 39.9297218322754, 0.696905115378669, -74.8874969482422, -1.30703339032403, 218, 37, 'PPL', 'P'),
(78053, 'Colemanville', 39.9005584716797, 0.696396118715327, -76.3430633544922, -1.33243781659452, 218, 45, 'PPL', 'P'),
(8174, 'Coler', 33.5747184753418, 0.585989382824885, -93.5891723632813, -1.63343920195574, 218, 4, 'PPL', 'P'),
(20163, 'Colerain', 30.8327808380127, 0.538133543169138, -81.9008331298828, -1.42943919824291, 218, 13, 'PPL', 'P'),
(63795, 'Colerain', 36.2011108398438, 0.631828577034683, -76.7688903808594, -1.3398699002486, 218, 33, 'PPL', 'P'),
(80406, 'Colerain', 34.7236099243164, 0.6060413213575, -81.7980575561523, -1.42764542609068, 218, 48, 'PPL', 'P'),
(154802, 'Colerain', 40.1258316040039, 0.700327876590666, -80.8088912963867, -1.41038121800814, 218, 41, 'PPL', 'P'),
(160267, 'Colerain', 40.6261100769043, 0.709059383119627, -78.1149978637695, -1.36336390791112, 218, 45, 'PPL', 'P'),
(63796, 'Colerain Beach', 36.1963882446289, 0.631746152198945, -76.7541732788086, -1.33961303836146, 218, 33, 'PPL', 'P'),
(72167, 'Colerain Heights', 39.2405586242676, 0.684876948315326, -84.5980606079102, -1.47651469840975, 218, 41, 'PPL', 'P'),
(134752, 'Coleraine', 47.288890838623, 0.825346844750155, -93.4274978637695, -1.63061744962275, 218, 28, 'PPL', 'P'),
(134753, 'Coleraine Junction', 46.9672203063965, 0.819732634856159, -92.5722198486328, -1.61569003223869, 218, 28, 'PPL', 'P'),
(63798, 'Coleridge', 35.6399993896484, 0.622035334758135, -79.6155624389648, -1.38955370038706, 218, 33, 'PPL', 'P'),
(141523, 'Coleridge', 42.5061111450195, 0.741871591699248, -97.2033309936523, -1.69651816974508, 218, 35, 'PPL', 'P'),
(20158, 'Coleridge (historical)', 31.2419395446777, 0.545274709763645, -81.758056640625, -1.42694727841092, 218, 13, 'PPL', 'P'),
(20159, 'Coles', 31.7533302307129, 0.554200160998991, -84.8341674804688, -1.48063554072248, 218, 13, 'PPL', 'P'),
(26828, 'Coles', 39.5202789306641, 0.689758988646632, -88.4711074829102, -1.54411211846258, 218, 18, 'PPL', 'P'),
(59067, 'Coles', 31.2772197723389, 0.545890465897184, -91.0316696166992, -1.58880235839909, 218, 30, 'PPL', 'P'),
(127136, 'Coles', 44.4536094665527, 0.775861849587065, -69.496940612793, -1.2129504337562, 218, 26, 'PPL', 'P'),
(169325, 'Coles', 41.7291717529297, 0.728311441218837, -71.3938903808594, -1.2460584529539, 218, 47, 'PPL', 'P'),
(45894, 'Coles Corner', 38.7758293151855, 0.676765891741326, -76.8675003051758, -1.34159096810306, 218, 25, 'PPL', 'P'),
(171870, 'Coles Corner', 44.4936103820801, 0.77655999726683, -72.0580596923828, -1.25765039423069, 218, 55, 'PPL', 'P'),
(207081, 'Coles Corner', 47.7563896179199, 0.833506237697939, -120.738059997559, -2.10727667942785, 218, 56, 'PPL', 'P'),
(160269, 'Coles Creek', 41.2413902282715, 0.719798047583153, -76.3649978637695, -1.33282064600121, 218, 45, 'PPL', 'P'),
(20160, 'Coles Crossing', 34.9458312988281, 0.609919816011037, -84.2502822875977, -1.47044482165324, 218, 13, 'PPL', 'P'),
(80419, 'Coles Crossing', 34.166389465332, 0.596315989688749, -79.7638931274414, -1.39214255928273, 218, 48, 'PPL', 'P'),
(100972, 'Coles Hill', 36.875560760498, 0.643599948789915, -79.3008270263672, -1.38406053116461, 218, 53, 'PPL', 'P'),
(160268, 'Coles Mill', 41.1891708374023, 0.718886647279101, -76.4800033569336, -1.33482787051481, 218, 45, 'PPL', 'P'),
(72170, 'Coles Park', 38.7869415283203, 0.676959836447711, -83.01611328125, -1.44890450896641, 218, 41, 'PPL', 'P'),
(100974, 'Coles Point', 38.1436080932617, 0.665731549817773, -76.6358337402344, -1.33754762377805, 218, 53, 'PPL', 'P'),
(200606, 'Coles Valley', 43.3652801513672, 0.756866919691102, -123.501388549805, -2.15550586097892, 218, 43, 'PPL', 'P'),
(20161, 'Colesburg', 30.9233303070068, 0.539713929539018, -81.7163925170898, -1.42622010227527, 218, 13, 'PPL', 'P'),
(35323, 'Colesburg', 37.7847213745117, 0.659467794933907, -85.7738876342773, -1.49703675145379, 218, 21, 'PPL', 'P'),
(85925, 'Colesburg', 36.0625, 0.629409361500455, -87.3455581665039, -1.52446757699771, 218, 50, 'PPL', 'P'),
(115052, 'Colesburg', 42.6394386291504, 0.744198595280732, -91.2019424438477, -1.59177417985951, 218, 16, 'PPL', 'P'),
(160270, 'Colesburg', 41.8358306884766, 0.730172990820802, -77.9400024414063, -1.36030966161496, 218, 45, 'PPL', 'P'),
(200607, 'Colestin', 42.0533294677734, 0.733969060638601, -122.650001525879, -2.14064635420266, 218, 43, 'PPL', 'P'),
(70679, 'Colestown', 39.9333305358887, 0.696968099138449, -74.9891662597656, -1.30880785455835, 218, 37, 'PPL', 'P'),
(45896, 'Colesville', 39.0755615234375, 0.681997205649596, -77.0022201538086, -1.34394227302949, 218, 25, 'PPL', 'P'),
(145023, 'Colesville', 41.2750015258789, 0.72038467539227, -74.6502838134766, -1.30289324009339, 218, 37, 'PPL', 'P'),
(160271, 'Colesville', 40.5719413757324, 0.708113960932649, -75.3927764892578, -1.31585218195772, 218, 45, 'PPL', 'P'),
(45897, 'Colesville Manor', 39.0858306884766, 0.682176436390958, -77.0038909912109, -1.34397143464343, 218, 25, 'PPL', 'P'),
(45898, 'Colesville Park', 39.0986099243164, 0.682399476132252, -77.0038909912109, -1.34397143464343, 218, 25, 'PPL', 'P'),
(1694, 'Coleta', 33.2611083984375, 0.580515854415472, -86.033332824707, -1.50156492425525, 218, 2, 'PPL', 'P'),
(119193, 'Coleta', 41.9022216796875, 0.731331732211096, -89.8022232055664, -1.56734447054799, 218, 18, 'PPL', 'P'),
(93335, 'Coletoville', 28.7591705322266, 0.501942215929884, -97.1458282470703, -1.69551455748829, 218, 51, 'PPL', 'P'),
(35324, 'Coletown', 37.9288902282715, 0.661984016110841, -84.4422225952148, -1.47379481198845, 218, 21, 'PPL', 'P'),
(85926, 'Coletown', 35.0038909912109, 0.610933148805812, -84.370002746582, -1.47253433784452, 218, 50, 'PPL', 'P'),
(154797, 'Coletown', 40.1344413757324, 0.700478145455173, -84.7027816772461, -1.47834242586587, 218, 41, 'PPL', 'P'),
(54146, 'Coleville', 38.4155616760254, 0.670478035249594, -94.3019409179688, -1.64587936003972, 218, 29, 'PPL', 'P'),
(63800, 'Coleville', 36.5397186279297, 0.637738397809678, -80.2241668701172, -1.4001758515529, 218, 33, 'PPL', 'P'),
(160273, 'Coleville', 41.8950004577637, 0.731205698112508, -78.51611328125, -1.37036469262666, 218, 45, 'PPL', 'P'),
(180800, 'Coleville', 38.5663909912109, 0.67311050340811, -119.50611114502, -2.08577511573488, 218, 6, 'PPL', 'P'),
(59069, 'Coleville (historical)', 34.0374984741211, 0.594066417515959, -88.8861083984375, -1.55135525083732, 218, 30, 'PPL', 'P'),
(20162, 'Coley', 32.4280586242676, 0.565976393023212, -83.3888931274414, -1.45541074466752, 218, 13, 'PPL', 'P'),
(63802, 'Coley Acres', 35.4947204589844, 0.61949973908427, -77.9527816772461, -1.36053270135625, 218, 33, 'PPL', 'P'),
(177618, 'Coley Town', 41.1855583190918, 0.718823596940293, -73.3419418334961, -1.28005836480067, 218, 8, 'PPL', 'P'),
(191292, 'Coleyville', 34.2338905334473, 0.597494105575973, -100.378890991211, -1.75194214729711, 218, 51, 'PPL', 'P'),
(8175, 'Colfax', 36.3108291625977, 0.633743523016505, -92.4227828979492, -1.61308186542512, 218, 4, 'PPL', 'P'),
(35327, 'Colfax', 38.2125015258789, 0.666933967049944, -83.6341705322266, -1.45969164296177, 218, 21, 'PPL', 'P'),
(39839, 'Colfax', 31.5188903808594, 0.550108413721166, -92.706672668457, -1.61803667663321, 218, 22, 'PPL', 'P'),
(63805, 'Colfax', 36.1124992370605, 0.630282012810647, -80.0147171020508, -1.3965202634826, 218, 33, 'PPL', 'P'),
(72171, 'Colfax', 39.7402801513672, 0.693598734306308, -82.5022201538086, -1.43993538188918, 218, 41, 'PPL', 'P'),
(93336, 'Colfax', 32.5102806091309, 0.567411437376601, -95.7324981689453, -1.67084729420754, 218, 51, 'PPL', 'P'),
(108663, 'Colfax', 39.4347190856934, 0.688265687644397, -80.1319427490234, -1.39856623699006, 218, 58, 'PPL', 'P'),
(115053, 'Colfax', 41.6777801513672, 0.727414488563698, -93.245002746582, -1.62743230895901, 218, 16, 'PPL', 'P'),
(119194, 'Colfax', 40.5669403076172, 0.708026675827921, -88.6163864135742, -1.54664771413644, 218, 18, 'PPL', 'P'),
(122407, 'Colfax', 40.1949996948242, 0.701535087512799, -86.6672210693359, -1.51262836121371, 218, 19, 'PPL', 'P'),
(130290, 'Colfax', 43.7433280944824, 0.763465101028855, -86.0791702270508, -1.50236493784671, 218, 27, 'PPL', 'P'),
(139836, 'Colfax', 46.4694404602051, 0.811044737590048, -96.8741683959961, -1.69077319864157, 218, 34, 'PPL', 'P'),
(160274, 'Colfax', 40.3650016784668, 0.704502181862283, -78.0111083984375, -1.36155069468293, 218, 45, 'PPL', 'P'),
(173618, 'Colfax', 44.997501373291, 0.785354554134598, -91.726936340332, -1.60093705190603, 218, 57, 'PPL', 'P'),
(180801, 'Colfax', 39.100830078125, 0.682438225126113, -120.952217102051, -2.11101442601778, 218, 6, 'PPL', 'P'),
(188341, 'Colfax', 36.5966682434082, 0.638732356107523, -104.737777709961, -1.82801907226074, 218, 38, 'PPL', 'P'),
(207082, 'Colfax', 46.8802795410156, 0.818215232246059, -117.363327026367, -2.04837647770495, 218, 56, 'PPL', 'P'),
(20165, 'Colfax (historical)', 32.499439239502, 0.567222219781151, -81.8397216796875, -1.42837260222633, 218, 13, 'PPL', 'P'),
(170055, 'Colfax Corner', 43.0111083984375, 0.750685456484919, -97.0219421386719, -1.69335233699925, 218, 49, 'PPL', 'P'),
(180802, 'Colfax Spring', 37.8208312988281, 0.660098032005874, -120.026672363281, -2.09486062295174, 218, 6, 'PPL', 'P'),
(177976, 'Colfred', 32.7044410705566, 0.570800176705673, -113.900833129883, -1.98794455888109, 218, 5, 'PPL', 'P'),
(198134, 'Colgan', 48.9483299255371, 0.854309520553093, -103.627777099609, -1.80864590691096, 218, 34, 'PPL', 'P'),
(45900, 'Colgate', 39.2713890075684, 0.685415040013576, -76.5558319091797, -1.33615132841852, 218, 25, 'PPL', 'P'),
(139818, 'Colgate', 47.2447204589844, 0.824575926193604, -97.6561126708984, -1.70442070080573, 218, 34, 'PPL', 'P'),
(173621, 'Colgate', 43.1930618286133, 0.753861142926784, -88.206672668457, -1.53949686029347, 218, 57, 'PPL', 'P'),
(196248, 'Colgate', 47.0105590820313, 0.820489039184768, -104.754997253418, -1.82831960998976, 218, 31, 'PPL', 'P'),
(45901, 'Colgate Creek', 39.2661094665527, 0.68532289463986, -76.543327331543, -1.33593308236719, 218, 25, 'PPL', 'P'),
(39840, 'Colgrade', 31.9108295440674, 0.556949042586657, -92.5344390869141, -1.61503063355279, 218, 22, 'PPL', 'P'),
(20164, 'Colima', 34.5430603027344, 0.602890135997664, -84.7072219848633, -1.47841992385359, 218, 13, 'PPL', 'P'),
(180803, 'Colima', 33.9447212219238, 0.592447148994164, -118.01277923584, -2.0597115570946, 218, 6, 'PPL', 'P'),
(1695, 'Colina', 31.9527797698975, 0.557681212149347, -85.8361129760742, -1.49812278854632, 218, 2, 'PPL', 'P'),
(100975, 'Colina (historical)', 37.0711097717285, 0.647012922884906, -77.5027770996094, -1.35267863982744, 218, 53, 'PPL', 'P'),
(180804, 'Colina Vista', 33.4625015258789, 0.584030827580213, -117.115280151367, -2.04404724303692, 218, 6, 'PPL', 'P'),
(63807, 'Colington', 36.0077781677246, 0.628454285354525, -75.7019424438477, -1.32124814580038, 218, 33, 'PPL', 'P'),
(93338, 'Colita', 30.8835105895996, 0.539018944363048, -95.009651184082, -1.65823123433356, 218, 51, 'PPL', 'P'),
(35325, 'Colitown Junction', 37.3358306884766, 0.651633174481057, -87.6327819824219, -1.52948057827563, 218, 21, 'PPL', 'P'),
(59070, 'Coll Town', 30.5119400024414, 0.532533814213569, -88.5505599975586, -1.54549882644218, 218, 30, 'PPL', 'P'),
(147938, 'Collabar', 41.5341682434082, 0.724907987924743, -74.3172225952148, -1.29708022522402, 218, 40, 'PPL', 'P'),
(122409, 'Collamer', 41.0758285522461, 0.71690845122139, -85.6647186279297, -1.49513139285189, 218, 19, 'PPL', 'P'),
(147940, 'Collamer', 43.1047210693359, 0.752319305813683, -76.0605621337891, -1.32750724015234, 218, 40, 'PPL', 'P'),
(154798, 'Collamer', 41.5397186279297, 0.725004860409394, -81.5725021362305, -1.42370874136733, 218, 41, 'PPL', 'P'),
(100976, 'Collander-Bishop Meadows', 36.7194404602051, 0.6408751355206, -76.600830078125, -1.33693669462399, 218, 53, 'PPL', 'P'),
(187629, 'Collano', 37.2988891601563, 0.650988423181149, -100.506942749023, -1.7541770720839, 218, 20, 'PPL', 'P'),
(1696, 'Collbran', 34.3758316040039, 0.599971444600992, -85.7786102294922, -1.49711917628953, 218, 2, 'PPL', 'P'),
(186556, 'Collbran', 39.2405586242676, 0.684876948315326, -107.960563659668, -1.88426729817014, 218, 7, 'PPL', 'P'),
(100977, 'Colleen', 37.709171295166, 0.658149197299181, -78.9313888549805, -1.37761261869137, 218, 53, 'PPL', 'P'),
(211765, 'College', 64.8569412231445, 1.13196716711631, -147.802780151367, -2.57964515724268, 218, 1, 'PPL', 'P'),
(80408, 'College Acres', 33.4958305358887, 0.584612528541314, -81.6952819824219, -1.42585165393846, 218, 48, 'PPL', 'P'),
(8176, 'College City', 36.1252784729004, 0.630505052551941, -90.9391708374023, -1.58718795014628, 218, 4, 'PPL', 'P'),
(180806, 'College City', 39.0058288574219, 0.68078014103143, -122.008331298828, -2.1294470960286, 218, 6, 'PPL', 'P'),
(72172, 'College Corner', 39.5675010681152, 0.690583170424984, -84.8144378662109, -1.48029119399353, 218, 41, 'PPL', 'P'),
(122412, 'College Corner', 40.6986083984375, 0.710324717532551, -85.8855590820313, -1.49898578589756, 218, 19, 'PPL', 'P'),
(63817, 'College Court', 35.5974998474121, 0.62129357781552, -77.3494415283203, -1.35000242924802, 218, 33, 'PPL', 'P'),
(29532, 'College Crest', 39.9249992370605, 0.696822690542931, -86.1505584716797, -1.5036108977627, 218, 19, 'PPL', 'P'),
(20171, 'College Estates', 32.8013916015625, 0.572492282683282, -83.7336120605469, -1.46142722504418, 218, 13, 'PPL', 'P'),
(63810, 'College Estates', 36.3905601501465, 0.635135091265098, -79.6938934326172, -1.39092083413266, 218, 33, 'PPL', 'P'),
(85929, 'College Grove', 35.8911094665527, 0.626418032385051, -84.6208267211914, -1.47691204204439, 218, 50, 'PPL', 'P'),
(8177, 'College Heights', 33.5902786254883, 0.586260958677046, -91.8005599975586, -1.602222027132, 218, 4, 'PPL', 'P'),
(45903, 'College Heights', 38.975830078125, 0.68025656356112, -76.9408264160156, -1.3428707501649, 218, 25, 'PPL', 'P'),
(160276, 'College Heights', 40.3741683959961, 0.70466217126477, -75.8983306884766, -1.32467576728137, 218, 45, 'PPL', 'P'),
(180807, 'College Heights', 34.1066703796387, 0.595273695017119, -117.688331604004, -2.05404887766877, 218, 6, 'PPL', 'P'),
(45904, 'College Heights Estates', 38.978328704834, 0.68030017282397, -76.9513931274414, -1.34305517407039, 218, 25, 'PPL', 'P'),
(7, 'College Hill', 33.4155616760254, 0.583211572649878, -94.6127777099609, -1.65130448549632, 218, 51, 'PPL', 'P'),
(8179, 'College Hill', 33.4058303833008, 0.583041729551358, -93.2008285522461, -1.62666132382343, 218, 4, 'PPL', 'P'),
(35326, 'College Hill', 37.7866706848145, 0.659501816816833, -84.1233291625977, -1.46822907162629, 218, 21, 'PPL', 'P'),
(59071, 'College Hill', 34.4216690063477, 0.600771458192451, -89.570556640625, -1.56330112622298, 218, 30, 'PPL', 'P'),
(85930, 'College Hill', 35.4863891601563, 0.619354330488752, -85.0219421386719, -1.48391282675993, 218, 50, 'PPL', 'P'),
(100985, 'College Hill', 37.4091682434082, 0.652913156279977, -79.1527786254883, -1.38147659911696, 218, 53, 'PPL', 'P'),
(124553, 'College Hill', 42.2333297729492, 0.737110658618513, -71.8111114501953, -1.25334033432251, 218, 23, 'PPL', 'P'),
(154800, 'College Hill', 40.5433311462402, 0.707614618228259, -82.3349990844727, -1.43701682365056, 218, 41, 'PPL', 'P'),
(160277, 'College Hill', 40.7777786254883, 0.711706498664138, -80.3241729736328, -1.40192128733134, 218, 45, 'PPL', 'P'),
(200608, 'College Hill', 44.0311088562012, 0.768487822844745, -123.096939086914, -2.14844688619355, 218, 43, 'PPL', 'P'),
(39842, 'College Hills', 30.392219543457, 0.530444298022293, -91.1500015258789, -1.59086763982444, 218, 22, 'PPL', 'P'),
(45906, 'College Hills', 39.2547187805176, 0.685124089664485, -76.7305603027344, -1.33920091418277, 218, 25, 'PPL', 'P'),
(45907, 'College Manor', 39.0475006103516, 0.68150745032513, -76.5041732788086, -1.33524971523148, 218, 25, 'PPL', 'P'),
(29533, 'College Meadows', 39.9352798461914, 0.697002121021375, -86.1402816772461, -1.50343153386329, 218, 19, 'PPL', 'P'),
(54149, 'College Mound', 39.6230583190918, 0.691552827377882, -92.5725021362305, -1.61569495908671, 218, 29, 'PPL', 'P'),
(93339, 'College Mound', 32.6728210449219, 0.570248303148781, -96.1866683959961, -1.6787740600341, 218, 51, 'PPL', 'P'),
(13567, 'College Park', 39.6736106872559, 0.692435132647025, -75.7694396972656, -1.32242619510858, 218, 10, 'PPL', 'P'),
(15583, 'College Park', 29.8830604553223, 0.521557795517889, -81.3530578613281, -1.41987871624563, 218, 12, 'PPL', 'P'),
(20167, 'College Park', 34.6413917541504, 0.604606343583138, -83.5305633544922, -1.45788335658161, 218, 13, 'PPL', 'P'),
(45908, 'College Park', 38.9805603027344, 0.680339121554912, -76.9372177124023, -1.34280776640512, 218, 25, 'PPL', 'P'),
(80413, 'College Park', 33.7997207641602, 0.589916413589289, -79.0088882446289, -1.37896523820902, 218, 48, 'PPL', 'P'),
(85932, 'College Park', 36.2972183227539, 0.63350596904727, -82.3099975585938, -1.43658046470596, 218, 50, 'PPL', 'P'),
(100983, 'College Park', 38.1716690063477, 0.666221305142239, -79.0552825927734, -1.37977497233846, 218, 53, 'PPL', 'P'),
(147941, 'College Park', 42.0191688537598, 0.73337284544956, -73.8819427490234, -1.28948315874041, 218, 40, 'PPL', 'P'),
(160278, 'College Park', 40.9483299255371, 0.714683180393547, -76.8850021362305, -1.3418964326801, 218, 45, 'PPL', 'P'),
(177975, 'College Park', 33.627498626709, 0.586910570245943, -112.177780151367, -1.9578716112197, 218, 5, 'PPL', 'P'),
(180809, 'College Park', 37.3422203063965, 0.651744694351704, -121.898612976074, -2.12753215004678, 218, 6, 'PPL', 'P'),
(8180, 'College Park (historical)', 34.2638893127441, 0.598017683046282, -92.059440612793, -1.60674034623742, 218, 4, 'PPL', 'P'),
(191293, 'College Park Addition Colonia', 31.6429996490479, 0.552274529083295, -106.125999450684, -1.85224811238412, 218, 51, 'PPL', 'P'),
(85933, 'College Park Estates', 35.7191696166992, 0.623417115889722, -83.9427795410156, -1.46507788626646, 218, 50, 'PPL', 'P'),
(610, 'College Park Woods', 39.0086097717285, 0.680828677142296, -76.9513931274414, -1.34305517407039, 218, 25, 'PPL', 'P'),
(207083, 'College Place', 46.0494384765625, 0.803714320110577, -118.387222290039, -2.0662468212516, 218, 56, 'PPL', 'P'),
(147942, 'College Point', 40.7874984741211, 0.711876142025576, -73.8463897705078, -1.28886264220642, 218, 40, 'PPL', 'P'),
(115060, 'College Springs', 40.6191711425781, 0.708938275869055, -95.1205596923828, -1.66016695297188, 218, 16, 'PPL', 'P'),
(8181, 'College Station', 34.7080612182617, 0.605769945242421, -92.2211074829102, -1.60956196541236, 218, 4, 'PPL', 'P'),
(45910, 'College Station', 39.0547218322754, 0.681633484423718, -76.522216796875, -1.33556463403038, 218, 25, 'PPL', 'P'),
(93340, 'College Station', 30.6277809143066, 0.53455561953413, -96.3341674804688, -1.68134840470183, 218, 51, 'PPL', 'P'),
(45909, 'College View', 39.0430603027344, 0.681429952337409, -77.065559387207, -1.34504775119799, 218, 25, 'PPL', 'P'),
(63815, 'College View', 35.6086082458496, 0.621487455942878, -77.3647232055664, -1.3502691448312, 218, 33, 'PPL', 'P'),
(85934, 'College View', 36.1786117553711, 0.631435893931951, -82.7708282470703, -1.4446234775141, 218, 50, 'PPL', 'P'),
(141527, 'College View', 40.7722206115723, 0.711609493021432, -96.6519393920898, -1.68689457082997, 218, 35, 'PPL', 'P'),
(186557, 'College View', 39.6630592346191, 0.692250975057646, -105.021110534668, -1.83296416293086, 218, 7, 'PPL', 'P'),
(141528, 'College View Park', 41.4458312988281, 0.723366217390669, -97.3916702270508, -1.69980530947857, 218, 35, 'PPL', 'P'),
(203481, 'College Ward', 41.6769409179688, 0.727399841177703, -111.879173278809, -1.95265993812447, 218, 52, 'PPL', 'P'),
(85935, 'Collegedale', 35.0530586242676, 0.611791285888063, -85.0502777099609, -1.48440737577436, 218, 50, 'PPL', 'P'),
(93341, 'Collegeport', 28.7250003814697, 0.501345834293274, -96.1747207641602, -1.67856553452075, 218, 51, 'PPL', 'P'),
(39844, 'Collegetown', 30.4033298492432, 0.530638209439164, -91.165283203125, -1.59113435540761, 218, 22, 'PPL', 'P'),
(8182, 'Collegeville', 34.6366691589355, 0.6045239187474, -92.4752807617188, -1.61399812599816, 218, 4, 'PPL', 'P'),
(122413, 'Collegeville', 40.9116706848145, 0.714043355941655, -87.1552810668945, -1.52114661511839, 218, 19, 'PPL', 'P'),
(134756, 'Collegeville', 45.5944404602051, 0.795773106635097, -94.3627777099609, -1.64694116236633, 218, 28, 'PPL', 'P'),
(160280, 'Collegeville', 40.1855583190918, 0.70137030442035, -75.4519424438477, -1.3168848226704, 218, 45, 'PPL', 'P'),
(180811, 'Collegeville', 37.9049987792969, 0.661567031663162, -121.146392822266, -2.11440343166296, 218, 6, 'PPL', 'P'),
(113110, 'Collens Landing', 44.6450004577637, 0.779202252542352, -84.7713928222656, -1.47953991625002, 218, 27, 'PPL', 'P'),
(80417, 'Colleton', 33.0397186279297, 0.576651873989876, -80.8824996948242, -1.41166592691799, 218, 48, 'PPL', 'P'),
(115062, 'Collett', 40.9061088562012, 0.713946283719922, -91.9775009155273, -1.60531022873205, 218, 16, 'PPL', 'P'),
(122414, 'Collett', 40.3752784729004, 0.7046815457617, -85.0008316040039, -1.48354437842312, 218, 19, 'PPL', 'P'),
(143648, 'Collettes Grove', 42.8769416809082, 0.74834380551744, -71.2147216796875, -1.24293136920193, 218, 36, 'PPL', 'P'),
(63818, 'Collettsville', 35.9255599975586, 0.627019307580163, -81.6747207641602, -1.42549279298157, 218, 33, 'PPL', 'P'),
(100986, 'Colley', 37.1538887023926, 0.648457687776274, -82.2455596923828, -1.43545581177761, 218, 53, 'PPL', 'P'),
(160282, 'Colley', 41.5344390869141, 0.724912715035678, -76.2866668701172, -1.33145351225562, 218, 45, 'PPL', 'P'),
(93342, 'Colleyville', 32.8808288574219, 0.573878724346777, -97.1547164916992, -1.69566968662179, 218, 51, 'PPL', 'P'),
(20169, 'Collier', 33.0469398498535, 0.576777908088464, -84.0169372558594, -1.46637218255624, 218, 13, 'PPL', 'P'),
(78066, 'Collier', 39.8502807617188, 0.695518607136146, -79.7788925170898, -1.39240434801788, 218, 45, 'PPL', 'P'),
(100987, 'Collier', 36.8177795410156, 0.642591476264129, -81.2094421386719, -1.41737214902765, 218, 53, 'PPL', 'P'),
(191294, 'Collier', 31.1674995422363, 0.543975486625849, -103.583061218262, -1.80786546755352, 218, 51, 'PPL', 'P'),
(15585, 'Collier Estates', 26.1994400024414, 0.457266490221314, -80.1408309936523, -1.39872136612355, 218, 12, 'PPL', 'P'),
(15586, 'Collier Manor', 26.2625007629395, 0.458367108120816, -80.1091690063477, -1.39816876019736, 218, 12, 'PPL', 'P'),
(100988, 'Collier Mill', 36.7147216796875, 0.64079277726389, -83.0302810668945, -1.44915178347362, 218, 53, 'PPL', 'P'),
(15587, 'Collier Park', 26.2338905334473, 0.457867765416426, -80.1594390869141, -1.39904613861849, 218, 12, 'PPL', 'P'),
(194763, 'Collier Place', 42.5791702270508, 0.743146713229178, -116.239440917969, -2.02876096469597, 218, 17, 'PPL', 'P'),
(80420, 'Colliers', 33.708610534668, 0.588326240102402, -82.0777816772461, -1.43252753300102, 218, 48, 'PPL', 'P'),
(177203, 'Colliers', 40.3669395446777, 0.704536004008127, -80.541389465332, -1.40571243030112, 218, 58, 'PPL', 'P'),
(85937, 'Colliers Corner', 36.1055603027344, 0.630160905560075, -83.4000015258789, -1.45560462279488, 218, 50, 'PPL', 'P'),
(145024, 'Colliers Mills', 40.0675010681152, 0.699309816684956, -74.4497222900391, -1.29939278115659, 218, 37, 'PPL', 'P'),
(100989, 'Collierstown', 37.7855606079102, 0.659482442319902, -79.5894393920898, -1.38909776720844, 218, 53, 'PPL', 'P'),
(147943, 'Colliersville', 42.4908294677734, 0.741604876116076, -74.9824981689453, -1.30869147441872, 218, 40, 'PPL', 'P'),
(85938, 'Collierville', 35.0419387817383, 0.611597208023624, -89.664436340332, -1.56493963608365, 218, 50, 'PPL', 'P'),
(180812, 'Collierville', 38.2147216796875, 0.666972716043805, -121.267776489258, -2.11652197631012, 218, 6, 'PPL', 'P'),
(8184, 'Collietown', 35.8697204589844, 0.626044723779249, -91.8308334350586, -1.60275039829227, 218, 4, 'PPL', 'P'),
(93343, 'Collin', 33.1986083984375, 0.579425023632976, -96.8161087036133, -1.68975986584679, 218, 51, 'PPL', 'P'),
(93344, 'Collin Colonia', 26.326000213623, 0.459475382608453, -98.036003112793, -1.71105103981365, 218, 51, 'PPL', 'P'),
(130296, 'Colling', 43.6111106872559, 0.761157471944302, -83.4091720581055, -1.4557646787764, 218, 27, 'PPL', 'P'),
(78056, 'Collingdale', 39.9116706848145, 0.696590063421712, -75.2774963378906, -1.31384016375417, 218, 45, 'PPL', 'P'),
(70680, 'Collings Lakes', 39.5955581665039, 0.691072859170422, -74.8819427490234, -1.30693645126035, 218, 37, 'PPL', 'P'),
(70681, 'Collingswood', 39.9180603027344, 0.696701583292359, -75.0716705322266, -1.31024782575976, 218, 37, 'PPL', 'P'),
(45911, 'Collington', 38.9683303833008, 0.680125669193543, -76.7600021362305, -1.3397147711151, 218, 25, 'PPL', 'P'),
(45912, 'Collingwood', 38.2588882446289, 0.667743568021328, -76.7477798461914, -1.33950145191179, 218, 25, 'PPL', 'P'),
(100990, 'Collingwood', 38.7316703796387, 0.675995172921857, -77.045280456543, -1.34469381708911, 218, 53, 'PPL', 'P'),
(147944, 'Collingwood', 42.8675003051758, 0.748179022424991, -76.0833282470703, -1.32790458378698, 218, 40, 'PPL', 'P'),
(147945, 'Collingwood Estates', 43.228889465332, 0.754486453150735, -79.0483322143555, -1.3796536653508, 218, 40, 'PPL', 'P'),
(145025, 'Collingwood Park', 40.2222213745117, 0.702010195451269, -74.1341705322266, -1.29388536402231, 218, 37, 'PPL', 'P'),
(308, 'Collins', 33.5313911437988, 0.585233178233357, -91.5652770996094, -1.59811556588915, 218, 4, 'PPL', 'P'),
(923, 'Collins', 35.3805618286133, 0.617507295114727, -85.5744400024414, -1.49355573359295, 218, 50, 'PPL', 'P'),
(1703, 'Collins', 33.4463882446289, 0.583749597769101, -86.9644393920898, -1.51781579954302, 218, 2, 'PPL', 'P'),
(20170, 'Collins', 32.1811103820801, 0.561666333115028, -82.1091690063477, -1.43307534523725, 218, 13, 'PPL', 'P'),
(26830, 'Collins', 38.0208282470703, 0.663588637246641, -89.9477767944336, -1.56988485991182, 218, 18, 'PPL', 'P'),
(35328, 'Collins', 37.4013900756836, 0.65277740164341, -82.5180587768555, -1.44021181801033, 218, 21, 'PPL', 'P'),
(54150, 'Collins', 37.8911094665527, 0.661324617424937, -93.6227798461914, -1.63402576318583, 218, 29, 'PPL', 'P'),
(59075, 'Collins', 31.6452808380127, 0.552314343341592, -89.5552825927734, -1.56303454379786, 218, 30, 'PPL', 'P'),
(78058, 'Collins', 39.8800010681152, 0.696037324337466, -76.133056640625, -1.32877250798624, 218, 45, 'PPL', 'P'),
(93346, 'Collins', 31.0011100769043, 0.541071442615172, -93.9744415283203, -1.64016341739208, 218, 51, 'PPL', 'P'),
(115063, 'Collins', 41.9027786254883, 0.731341452749074, -93.3061065673828, -1.62849877181753, 218, 16, 'PPL', 'P'),
(122415, 'Collins', 41.1974983215332, 0.719031989295592, -85.3866729736328, -1.49027858071355, 218, 19, 'PPL', 'P'),
(130297, 'Collins', 42.9291687011719, 0.749255338979547, -84.9438934326172, -1.48255061986236, 218, 27, 'PPL', 'P'),
(147946, 'Collins', 42.4963912963867, 0.74170194833781, -78.9208297729492, -1.37742832794393, 218, 40, 'PPL', 'P'),
(154803, 'Collins', 41.2586097717285, 0.720098585312169, -82.4913864135742, -1.43974629745179, 218, 41, 'PPL', 'P'),
(173623, 'Collins', 44.0855598449707, 0.76943817187974, -87.982780456543, -1.53558920402599, 218, 57, 'PPL', 'P'),
(180813, 'Collins', 38.165828704834, 0.666119372651516, -122.251388549805, -2.13368924532899, 218, 6, 'PPL', 'P'),
(194764, 'Collins', 43.202220916748, 0.754020999171216, -112.375, -1.96131374692863, 218, 17, 'PPL', 'P'),
(196249, 'Collins', 47.9283294677734, 0.836507154193268, -111.809440612793, -1.9514428735063, 218, 31, 'PPL', 'P'),
(1704, 'Collins (historical)', 33.9563903808594, 0.592650814238527, -85.7069396972656, -1.49586828952552, 218, 2, 'PPL', 'P'),
(63820, 'Collins (historical)', 35.8563919067383, 0.625812096658031, -81.7330627441406, -1.42651105262437, 218, 33, 'PPL', 'P'),
(119196, 'Collins (historical)', 41.064998626709, 0.716719433363022, -87.6972198486328, -1.53060523120397, 218, 18, 'PPL', 'P'),
(180815, 'Collins (historical)', 34.0416717529297, 0.594139254971773, -117.583892822266, -2.05222607706066, 218, 6, 'PPL', 'P'),
(209375, 'Collins (historical)', 41.1100006103516, 0.717504866147513, -106.162498474121, -1.85288514051687, 218, 59, 'PPL', 'P'),
(13573, 'Collins and Russell Development', 38.7874984741211, 0.67696955698569, -75.3233337402344, -1.31464017734563, 218, 10, 'PPL', 'P'),
(13568, 'Collins Beach', 39.3852806091309, 0.687402823451211, -75.522216796875, -1.31811134151043, 218, 10, 'PPL', 'P'),
(147947, 'Collins Center', 42.4936103820801, 0.741653412226943, -78.8516693115234, -1.37622125017985, 218, 40, 'PPL', 'P'),
(1705, 'Collins Chapel', 32.9425010681152, 0.57495510748036, -86.6805572509766, -1.51286112149299, 218, 2, 'PPL', 'P'),
(124554, 'Collins Corner', 41.711109161377, 0.727996189524799, -71.1069412231445, -1.24105024536596, 218, 23, 'PPL', 'P'),
(130298, 'Collins Corner', 42.2083282470703, 0.736674299673904, -85.4822235107422, -1.49194625218816, 218, 27, 'PPL', 'P'),
(80421, 'Collins Creek', 33.1572189331055, 0.578702641187292, -79.4108276367188, -1.38598040399445, 218, 48, 'PPL', 'P'),
(13589, 'Collins Creek Estates', 38.5611114501953, 0.673018358034394, -75.1213912963867, -1.31111561680096, 218, 10, 'PPL', 'P'),
(59076, 'Collins Crossing', 34.8074989318848, 0.607505460745799, -88.7241668701172, -1.54852883797242, 218, 30, 'PPL', 'P'),
(100992, 'Collins Crossing', 38.100830078125, 0.66498493260617, -77.399169921875, -1.35087035344728, 218, 53, 'PPL', 'P'),
(45913, 'Collins Estates', 39.4197196960449, 0.688003898909242, -76.9611129760742, -1.34322481743183, 218, 25, 'PPL', 'P'),
(100991, 'Collins Estates', 37.4688911437988, 0.653955517530634, -75.8680572509766, -1.3241473961211, 218, 53, 'PPL', 'P'),
(80423, 'Collins Lakeside Village', 34.3138885498047, 0.598890334356474, -82.1155624389648, -1.43318693168692, 218, 48, 'PPL', 'P'),
(147948, 'Collins Landing', 44.3002815246582, 0.773185772165699, -75.980827331543, -1.32611560532472, 218, 40, 'PPL', 'P'),
(15588, 'Collins Mill', 30.9658298492432, 0.540455686481633, -85.5311126708984, -1.49279952900142, 218, 12, 'PPL', 'P'),
(85941, 'Collins Mill', 35.5813903808594, 0.621012414583435, -84.6725006103516, -1.47781392154754, 218, 50, 'PPL', 'P'),
(13569, 'Collins Mill Park', 38.709171295166, 0.675602489819125, -75.524169921875, -1.31814542997239, 218, 10, 'PPL', 'P'),
(13570, 'Collins Park', 39.6861114501953, 0.69265331211933, -75.5566711425781, -1.31871268328457, 218, 10, 'PPL', 'P'),
(15589, 'Collins Park Estates', 27.3716697692871, 0.477725759242657, -80.3191680908203, -1.40183393564758, 218, 12, 'PPL', 'P'),
(13571, 'Collins Park Mobile Home Park', 38.5550003051758, 0.672911698432736, -75.086669921875, -1.31050961449491, 218, 10, 'PPL', 'P'),
(209376, 'Collins Place', 43.5288887023926, 0.759722427590913, -109.090827941895, -1.90399413131269, 218, 59, 'PPL', 'P'),
(13572, 'Collins Pond Acres', 38.7105598449707, 0.675626724585044, -75.5138931274414, -1.31796606607297, 218, 10, 'PPL', 'P'),
(39845, 'Collinsburg', 32.8627815246582, 0.573563738968848, -93.7375030517578, -1.63602806085141, 218, 22, 'PPL', 'P'),
(160285, 'Collinsburg', 40.2241706848145, 0.702044217334195, -79.7686080932617, -1.39222485096041, 218, 45, 'PPL', 'P'),
(108664, 'Collinsdale', 38.035831451416, 0.663850492560823, -81.3636093139648, -1.42006287383501, 218, 58, 'PPL', 'P'),
(39850, 'Collinston', 32.6908302307129, 0.570562622736437, -91.8716735839844, -1.60346319335803, 218, 22, 'PPL', 'P'),
(203482, 'Collinston', 41.7747192382813, 0.729106394804225, -112.094169616699, -1.95641233210039, 218, 52, 'PPL', 'P'),
(59077, 'Collinstown', 34.8074989318848, 0.607505460745799, -88.732780456543, -1.54867917341595, 218, 30, 'PPL', 'P'),
(63821, 'Collinstown', 36.545280456543, 0.637835470031411, -80.3372192382813, -1.40214898760454, 218, 33, 'PPL', 'P'),
(1706, 'Collinsville', 34.2638893127441, 0.598017683046282, -85.8605575561523, -1.49854942695295, 218, 2, 'PPL', 'P'),
(20172, 'Collinsville', 33.702220916748, 0.588214720231755, -84.0886077880859, -1.46762306932025, 218, 13, 'PPL', 'P'),
(26831, 'Collinsville', 38.670280456543, 0.674923716636291, -89.9844436645508, -1.57052481752176, 218, 18, 'PPL', 'P'),
(59078, 'Collinsville', 32.4977798461914, 0.567193257904296, -88.845832824707, -1.55065230946759, 218, 30, 'PPL', 'P'),
(63822, 'Collinsville', 35.2113914489746, 0.614554714993184, -82.0875015258789, -1.43269717636246, 218, 33, 'PPL', 'P'),
(72186, 'Collinsville', 39.5152816772461, 0.689671770120932, -84.6094436645508, -1.47671337022707, 218, 41, 'PPL', 'P'),
(75501, 'Collinsville', 36.3644409179688, 0.634679224665504, -95.8386077880859, -1.67269925642958, 218, 42, 'PPL', 'P'),
(78059, 'Collinsville', 39.8566703796387, 0.695630127006793, -76.4511108398438, -1.3343236009624, 218, 45, 'PPL', 'P'),
(93347, 'Collinsville', 33.5613899230957, 0.585756755703666, -96.9108276367188, -1.69141302309346, 218, 51, 'PPL', 'P'),
(100997, 'Collinsville', 39.3569412231445, 0.686908207857756, -78.2874984741211, -1.36637461152345, 218, 53, 'PPL', 'P'),
(124555, 'Collinsville', 42.6833305358887, 0.744964653568293, -71.352783203125, -1.24534099735624, 218, 23, 'PPL', 'P'),
(147950, 'Collinsville', 43.610279083252, 0.761142957716361, -75.3844375610352, -1.31570664020415, 218, 40, 'PPL', 'P'),
(177620, 'Collinsville', 41.8127784729004, 0.729770653759118, -72.9205627441406, -1.27270391229237, 218, 8, 'PPL', 'P'),
(180816, 'Collinsville', 38.0769386291504, 0.66456794815849, -121.848892211914, -2.12666435900558, 218, 6, 'PPL', 'P'),
(85942, 'Collinwood', 35.1741714477539, 0.613905103424286, -87.7377777099609, -1.53131309942171, 218, 50, 'PPL', 'P'),
(100994, 'Collinwood', 36.7388916015625, 0.641214621980558, -82.3247222900391, -1.43683745975115, 218, 53, 'PPL', 'P'),
(154804, 'Collinwood', 41.5583305358887, 0.725329699483357, -81.5694427490234, -1.42365534498747, 218, 41, 'PPL', 'P'),
(1707, 'Collirene', 32.1758308410645, 0.561574187741311, -86.8236083984375, -1.51535783501494, 218, 2, 'PPL', 'P'),
(134761, 'Collis', 45.646671295166, 0.796684706676231, -96.4252777099609, -1.68293857818872, 218, 28, 'PPL', 'P'),
(119197, 'Collison', 40.2249984741211, 0.702058664983108, -87.8038864135742, -1.53246691396399, 218, 18, 'PPL', 'P'),
(45914, 'Collison Corner', 38.9150009155273, 0.67919489439256, -76.5522232055664, -1.33608834465874, 218, 25, 'PPL', 'P'),
(35331, 'Collista', 37.7825012207031, 0.659429045940046, -82.8244400024414, -1.4455591791631, 218, 21, 'PPL', 'P'),
(35329, 'Colliver', 37.5961112976074, 0.656175928089487, -82.7366714477539, -1.44402732890409, 218, 21, 'PPL', 'P'),
(45915, 'Collmus', 39.4055595397949, 0.687756757560083, -77.2597198486328, -1.34843649052706, 218, 25, 'PPL', 'P'),
(209377, 'Colloid', 44.110279083252, 0.769869603976333, -104.656387329102, -1.8265985421353, 218, 59, 'PPL', 'P'),
(160286, 'Collomsville', 41.1474990844727, 0.7181593379854, -77.1433334350586, -1.3464051644056, 218, 45, 'PPL', 'P'),
(100995, 'Collosse', 36.7611083984375, 0.641602378235274, -76.8219375610352, -1.34079574820157, 218, 53, 'PPL', 'P'),
(63823, 'Colly', 34.4599990844727, 0.601440444258279, -78.2547225952148, -1.3658025645213, 218, 33, 'PPL', 'P'),
(187630, 'Collyer', 39.0355606079102, 0.681299057969831, -100.117500305176, -1.74738001919175, 218, 20, 'PPL', 'P'),
(180817, 'Colma', 37.6769409179688, 0.657586671097929, -122.458610534668, -2.13730595124737, 218, 6, 'PPL', 'P'),
(170057, 'Colman', 43.9824981689453, 0.767639406300473, -96.8141708374023, -1.68972604370095, 218, 49, 'PPL', 'P'),
(35330, 'Colmar', 36.665828704834, 0.639939433871601, -83.6519393920898, -1.46000176807071, 218, 21, 'PPL', 'P'),
(119198, 'Colmar', 40.3452796936035, 0.70415796829139, -90.89111328125, -1.58634918756096, 218, 18, 'PPL', 'P'),
(160287, 'Colmar', 40.267219543457, 0.702795561656733, -75.2538909912109, -1.31342817273353, 218, 45, 'PPL', 'P'),
(13574, 'Colmar Manor', 39.2833290100098, 0.685623432368875, -75.6097183227539, -1.31963853123754, 218, 10, 'PPL', 'P'),
(45916, 'Colmar Manor', 38.9330596923828, 0.679510079507571, -76.9461135864258, -1.34296302869667, 218, 25, 'PPL', 'P'),
(93348, 'Colmesneil', 30.9077796936035, 0.539442520134426, -94.4219436645508, -1.64797380307901, 218, 51, 'PPL', 'P'),
(188343, 'Colmor', 36.2205581665039, 0.632167996915614, -104.648887634277, -1.82646764776772, 218, 38, 'PPL', 'P'),
(527, 'Colo', 37.0455589294434, 0.646566976560372, -84.48388671875, -1.4745219881241, 218, 21, 'PPL', 'P'),
(115065, 'Colo', 42.0177803039551, 0.73334861068364, -93.3150024414063, -1.62865403410909, 218, 16, 'PPL', 'P'),
(70683, 'Cologne', 39.5047187805176, 0.689487412794471, -74.6136093139648, -1.30225314932539, 218, 37, 'PPL', 'P'),
(93349, 'Cologne', 28.7052803039551, 0.501001654011895, -97.1813888549805, -1.69613520718033, 218, 51, 'PPL', 'P'),
(100996, 'Cologne', 37.5305595397949, 0.655031834085189, -76.6913909912109, -1.33851728073095, 218, 53, 'PPL', 'P'),
(134762, 'Cologne', 44.771671295166, 0.781413075721281, -93.7811126708984, -1.63678919229095, 218, 28, 'PPL', 'P'),
(29534, 'Coloma', 39.788330078125, 0.694437363733574, -87.2919387817383, -1.52353174219066, 218, 19, 'PPL', 'P'),
(54152, 'Coloma', 39.5313911437988, 0.689952933353017, -93.523063659668, -1.63228538741346, 218, 29, 'PPL', 'P'),
(130299, 'Coloma', 42.1861114501953, 0.736286543419188, -86.3083267211914, -1.50636447317179, 218, 27, 'PPL', 'P'),
(173624, 'Coloma', 44.0355606079102, 0.768565520569548, -89.5213928222656, -1.56244305571975, 218, 57, 'PPL', 'P'),
(180818, 'Coloma', 38.7999992370605, 0.677187736457994, -120.889167785645, -2.10991400785536, 218, 6, 'PPL', 'P'),
(196250, 'Coloma', 46.8430595397949, 0.817565620677161, -113.379722595215, -1.97884946428431, 218, 31, 'PPL', 'P'),
(1708, 'Coloma (historical)', 34.077220916748, 0.594759704926734, -85.6188888549805, -1.49433151241849, 218, 2, 'PPL', 'P'),
(39846, 'Colomb Park (historical)', 30.0702800750732, 0.524825394306876, -90.8502807617188, -1.58563652565325, 218, 22, 'PPL', 'P'),
(170060, 'Colome', 43.2605590820313, 0.755039192234981, -99.7147216796875, -1.74035020602032, 218, 49, 'PPL', 'P'),
(20193, 'Colomokee', 31.4602794647217, 0.549085460256953, -84.8794403076172, -1.48142570061791, 218, 13, 'PPL', 'P'),
(20173, 'Colon', 30.7558307647705, 0.536790511031411, -82.6222229003906, -1.44202982492848, 218, 13, 'PPL', 'P'),
(63825, 'Colon', 35.526668548584, 0.620057338437506, -79.1524963378906, -1.38147167226895, 218, 33, 'PPL', 'P'),
(130302, 'Colon', 41.9583282470703, 0.732310976543918, -85.3249969482422, -1.48920213100094, 218, 27, 'PPL', 'P'),
(141530, 'Colon', 41.2975006103516, 0.720777358495003, -96.6055603027344, -1.68608510301664, 218, 35, 'PPL', 'P'),
(160288, 'Colon', 41.0958290100098, 0.717257525061272, -79.0766677856445, -1.38014821436523, 218, 45, 'PPL', 'P'),
(8186, 'Colona', 35.1916694641113, 0.614210501422291, -91.2355575561523, -1.59236087424765, 218, 4, 'PPL', 'P'),
(119200, 'Colona', 41.4838905334473, 0.724030476345562, -90.3530578613281, -1.57695834892512, 218, 18, 'PPL', 'P'),
(186558, 'Colona', 38.3250007629395, 0.668897449142632, -107.779167175293, -1.88110133226626, 218, 7, 'PPL', 'P'),
(80424, 'Colonel Creek Landing', 34.3688888549805, 0.599850270771393, -80.7972183227539, -1.41017748618475, 218, 48, 'PPL', 'P'),
(145026, 'Colonia', 40.5744400024414, 0.708157570195499, -74.3024978637695, -1.29682323017883, 218, 37, 'PPL', 'P'),
(93350, 'Colonia Allende', 26.2740001678467, 0.458567810598467, -98.3209991455078, -1.71602515893964, 218, 51, 'PPL', 'P'),
(93351, 'Colonia Big 5', 26.4050006866455, 0.460854200973328, -98.1849975585938, -1.71365148346005, 218, 51, 'PPL', 'P'),
(93352, 'Colonia Boyce', 26.1979999542236, 0.457241356638526, -98.0490036010742, -1.71127794113852, 218, 51, 'PPL', 'P'),
(93353, 'Colonia Camargo', 26.242000579834, 0.458009312428364, -98.4509963989258, -1.71829403903034, 218, 51, 'PPL', 'P'),
(93354, 'Colonia Claude Lookingbill', 26.3199996948242, 0.459370653798585, -98.004997253418, -1.71050988548014, 218, 51, 'PPL', 'P'),
(191296, 'Colonia de las Azaleas', 31.5779991149902, 0.551140055748435, -106.28099822998, -1.85495335141942, 218, 51, 'PPL', 'P'),
(191297, 'Colonia de las Azaleas Number 2', 31.5849990844727, 0.551262228263442, -106.282997131348, -1.8549882388297, 218, 51, 'PPL', 'P'),
(191298, 'Colonia de las Azaleas Number 3', 31.5879993438721, 0.551314592668376, -106.279998779297, -1.85493590771428, 218, 51, 'PPL', 'P'),
(191299, 'Colonia de las Dalias', 31.5779991149902, 0.551140055748435, -106.277000427246, -1.85488357659886, 218, 51, 'PPL', 'P'),
(191300, 'Colonia de las Dalias Number 2', 31.5699996948242, 0.551000439528288, -106.274002075195, -1.85483124548344, 218, 51, 'PPL', 'P'),
(93371, 'Colonia del Noreste', 26.1879997253418, 0.457066819718585, -98.0179977416992, -1.71073678680502, 218, 51, 'PPL', 'P'),
(191301, 'Colonia del Rio Number 1', 31.5739994049072, 0.551070247638361, -106.253997802734, -1.85448210506454, 218, 51, 'PPL', 'P'),
(191302, 'Colonia del Rio Number 2', 31.5729999542236, 0.551052803933221, -106.250999450684, -1.85442977394912, 218, 51, 'PPL', 'P'),
(191303, 'Colonia del Rio Number 3', 31.57200050354, 0.551035360228081, -106.247001647949, -1.85435999912856, 218, 51, 'PPL', 'P'),
(93355, 'Colonia Evans', 26.1280002593994, 0.456019631488452, -98.1969985961914, -1.71386094107979, 218, 51, 'PPL', 'P'),
(93356, 'Colonia Evans Number 2', 26.128999710083, 0.456037075193592, -98.1969985961914, -1.71386094107979, 218, 51, 'PPL', 'P'),
(93357, 'Colonia Garza', 26.1569995880127, 0.456525765253622, -97.9160003662109, -1.70895659677435, 218, 51, 'PPL', 'P'),
(93358, 'Colonia George', 26.1529998779297, 0.456455957143548, -97.8919982910156, -1.70853768153488, 218, 51, 'PPL', 'P'),
(93359, 'Colonia Guadalupe', 26.1909999847412, 0.457119184123519, -98.0950012207031, -1.71208075104913, 218, 51, 'PPL', 'P'),
(93360, 'Colonia Guadalupe Number 2', 26.1909999847412, 0.457119184123519, -98.0940017700195, -1.71206330734399, 218, 51, 'PPL', 'P'),
(93361, 'Colonia Guadalupe Number 3', 26.1900005340576, 0.457101740418379, -98.0960006713867, -1.71209819475427, 218, 51, 'PPL', 'P'),
(93362, 'Colonia Iglesia Antigua', 26.0769996643066, 0.455129503183607, -97.8379974365234, -1.70759518882511, 218, 51, 'PPL', 'P'),
(180819, 'Colonia Juarez', 33.7125015258789, 0.588394150710199, -117.946670532227, -2.05855774255233, 218, 6, 'PPL', 'P'),
(93372, 'Colonia las Palmas', 26.1030006408691, 0.455583305833356, -97.9489974975586, -1.70953250536008, 218, 51, 'PPL', 'P'),
(93373, 'Colonia los Angeles', 26.4950008392334, 0.462424999963284, -97.7839965820313, -1.70665269611533, 218, 51, 'PPL', 'P'),
(93363, 'Colonia Lucero del Norte', 26.2159996032715, 0.457555509778615, -97.9449996948242, -1.70946273053952, 218, 51, 'PPL', 'P'),
(180820, 'Colonia Manzanilla', 33.7605590820313, 0.58923291329552, -117.933326721191, -2.058324849115, 218, 6, 'PPL', 'P'),
(93364, 'Colonia Martinez', 26.242000579834, 0.458009312428364, -98.4489974975586, -1.71825915162006, 218, 51, 'PPL', 'P'),
(93365, 'Colonia Rafael', 26.2810001373291, 0.458689983113475, -98.5670013427734, -1.72031870724907, 218, 51, 'PPL', 'P'),
(93366, 'Colonia Saenz', 26.1539993286133, 0.456473400848688, -97.8639984130859, -1.70804899147486, 218, 51, 'PPL', 'P'),
(93367, 'Colonia San Miguel', 26.2749996185303, 0.458585254303607, -98.5609970092773, -1.72021391186017, 218, 51, 'PPL', 'P'),
(93368, 'Colonia Tejana', 26.2929992675781, 0.458899407443696, -98.0709991455078, -1.71166183580966, 218, 51, 'PPL', 'P'),
(93369, 'Colonia Victoriana', 26.1350002288818, 0.45614180400346, -97.9260025024414, -1.70913116698381, 218, 51, 'PPL', 'P'),
(93370, 'Colonia Whalen Road', 26.181999206543, 0.456962090908718, -98.088996887207, -1.71197595566023, 218, 51, 'PPL', 'P'),
(13575, 'Colonial Acres', 38.6066703796387, 0.673813511356864, -75.5619430541992, -1.31880469550024, 218, 10, 'PPL', 'P'),
(45919, 'Colonial Acres', 38.3791694641113, 0.66984287132961, -75.5213928222656, -1.31809696044055, 218, 25, 'PPL', 'P'),
(85957, 'Colonial Acres', 36.478328704834, 0.636666941524112, -82.522216796875, -1.44028438915004, 218, 50, 'PPL', 'P'),
(100998, 'Colonial Acres', 38.7011108398438, 0.675461808334541, -77.5561065673828, -1.35360941462843, 218, 53, 'PPL', 'P'),
(124556, 'Colonial Acres', 41.6477813720703, 0.726890911093389, -70.2561111450195, -1.22620045912767, 218, 23, 'PPL', 'P'),
(147951, 'Colonial Acres', 40.9752807617188, 0.715153561221082, -73.7602767944336, -1.28735968724523, 218, 40, 'PPL', 'P'),
(100999, 'Colonial Beach', 38.2544403076172, 0.667665936875552, -76.9638900756836, -1.34327328696367, 218, 53, 'PPL', 'P'),
(20174, 'Colonial Coach Estates', 33.601390838623, 0.586454903383431, -84.2241668701172, -1.46998902163267, 218, 13, 'PPL', 'P'),
(177977, 'Colonial Coronita', 33.3044395446777, 0.581272125586028, -111.795829772949, -1.95120531953707, 218, 5, 'PPL', 'P'),
(160289, 'Colonial Crest', 40.3266716003418, 0.703833195796455, -76.8283309936523, -1.34090733465124, 218, 45, 'PPL', 'P'),
(13576, 'Colonial East Mobile Home Park', 38.735279083252, 0.676058156681637, -75.1369400024414, -1.31138699291604, 218, 10, 'PPL', 'P'),
(20176, 'Colonial Estates', 33.752498626709, 0.589092231810936, -84.6972198486328, -1.47824535364414, 218, 13, 'PPL', 'P'),
(80442, 'Colonial Estates', 33.4049987792969, 0.583027215323417, -79.2758331298828, -1.38362430537806, 218, 48, 'PPL', 'P'),
(85948, 'Colonial Estates', 35.7366714477539, 0.623722580466754, -86.4027786254883, -1.50801296988655, 218, 50, 'PPL', 'P'),
(160290, 'Colonial Estates', 40.3041687011719, 0.703440446114696, -76.8000030517578, -1.34041291879487, 218, 45, 'PPL', 'P'),
(171871, 'Colonial Estates', 43.6544418334961, 0.761913743114857, -72.9674987792969, -1.27352310064367, 218, 55, 'PPL', 'P'),
(115066, 'Colonial Estates Mobile Home Park', 41.9333305358887, 0.731874684178336, -91.408332824707, -1.59537637154995, 218, 16, 'PPL', 'P'),
(101000, 'Colonial Estates Trailer Park', 37.6872215270996, 0.657766101576374, -77.4655609130859, -1.35202909483757, 218, 53, 'PPL', 'P'),
(80425, 'Colonial Forest', 34.1425018310547, 0.595899071820097, -79.8411102294922, -1.39349025195236, 218, 48, 'PPL', 'P'),
(85949, 'Colonial Forest', 36.1097183227539, 0.63023347669978, -85.5458297729492, -1.49305639088856, 218, 50, 'PPL', 'P'),
(101001, 'Colonial Forest', 37.6827812194824, 0.657688603588652, -77.3550033569336, -1.35009950146976, 218, 53, 'PPL', 'P'),
(45920, 'Colonial Gardens', 39.2763900756836, 0.685502325118304, -76.7588882446289, -1.33969533003915, 218, 25, 'PPL', 'P'),
(70684, 'Colonial Gardens', 39.9777793884277, 0.697743877963989, -74.2102813720703, -1.29521374877404, 218, 37, 'PPL', 'P'),
(108666, 'Colonial Gardens', 38.4452781677246, 0.670996685871887, -81.9766693115234, -1.43076278930468, 218, 58, 'PPL', 'P'),
(203485, 'Colonial Gardens Condominium', 41.1833305358887, 0.718784714788378, -112.008331298828, -1.95491417082917, 218, 52, 'PPL', 'P'),
(1711, 'Colonial Heights', 34.7144393920898, 0.605881265375987, -87.6838912963867, -1.53037260408275, 218, 2, 'PPL', 'P'),
(13577, 'Colonial Heights', 39.7472190856934, 0.693719841556879, -75.584716796875, -1.31920217229293, 218, 10, 'PPL', 'P'),
(20178, 'Colonial Heights', 32.8805618286133, 0.573874063814869, -85.0308303833008, -1.48406795589343, 218, 13, 'PPL', 'P'),
(63831, 'Colonial Heights', 35.6972198486328, 0.623034020166914, -78.670280456543, -1.37305541743402, 218, 33, 'PPL', 'P'),
(72175, 'Colonial Heights', 39.9949989318848, 0.698044415693004, -81.7016677856445, -1.42596310723008, 218, 41, 'PPL', 'P'),
(80428, 'Colonial Heights', 34.7688903808594, 0.606831614410981, -83.0311126708984, -1.44916629770156, 218, 48, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(85950, 'Colonial Heights', 36.4850006103516, 0.636783388242775, -82.5033264160156, -1.43995468980709, 218, 50, 'PPL', 'P'),
(101005, 'Colonial Heights', 37.2533302307129, 0.650193269858679, -79.9602813720703, -1.39557018076372, 218, 53, 'PPL', 'P'),
(147953, 'Colonial Heights', 40.9597206115723, 0.714881985368921, -73.841667175293, -1.28878021737068, 218, 40, 'PPL', 'P'),
(20179, 'Colonial Hills', 33.8458290100098, 0.590721154291683, -84.753059387207, -1.47921993744505, 218, 13, 'PPL', 'P'),
(45923, 'Colonial Hills', 39.6791687011719, 0.692532138289731, -77.1105575561523, -1.34583311740345, 218, 25, 'PPL', 'P'),
(63836, 'Colonial Hills', 34.7574996948242, 0.606632809435607, -77.3397216796875, -1.34983278588659, 218, 33, 'PPL', 'P'),
(80434, 'Colonial Hills', 34.9058303833008, 0.609221668331273, -82.2972183227539, -1.43635742496466, 218, 48, 'PPL', 'P'),
(160293, 'Colonial Hills', 40.565559387207, 0.708002574220056, -77.6122207641602, -1.3545887921193, 218, 45, 'PPL', 'P'),
(145027, 'Colonial Lake Lands', 40.253059387207, 0.702548420307574, -74.7291717529297, -1.30427009437697, 218, 37, 'PPL', 'P'),
(45924, 'Colonial Manor', 39.1313896179199, 0.682971589713429, -76.6736068725586, -1.3382068893059, 218, 25, 'PPL', 'P'),
(70685, 'Colonial Manor', 39.8549995422363, 0.695600965392857, -75.1516723632813, -1.31164412111929, 218, 37, 'PPL', 'P'),
(160294, 'Colonial Manor', 40.0205612182617, 0.69849056175462, -76.3486099243164, -1.33253462250014, 218, 45, 'PPL', 'P'),
(134764, 'Colonial Manor Mobile Home Park', 44.0999984741211, 0.769690173497888, -93.2577819824219, -1.62765534870031, 218, 28, 'PPL', 'P'),
(45925, 'Colonial Manor Trailer Park', 39.0327796936035, 0.681250521858965, -76.4655609130859, -1.33457580231763, 218, 25, 'PPL', 'P'),
(119204, 'Colonial Meadows', 40.4761085510254, 0.706441362610024, -88.9252777099609, -1.55203888428914, 218, 18, 'PPL', 'P'),
(177622, 'Colonial Mobile Home Park', 41.7372207641602, 0.728451922966338, -72.6369400024414, -1.26775376161618, 218, 8, 'PPL', 'P'),
(80435, 'Colonial Oaks Mobile Manor', 34.9625015258789, 0.610210766360128, -82.45361328125, -1.43908703192394, 218, 48, 'PPL', 'P'),
(45927, 'Colonial Park', 39.6294403076172, 0.691664214090474, -77.6975021362305, -1.35607723285255, 218, 25, 'PPL', 'P'),
(101007, 'Colonial Park', 37.2566719055176, 0.650251593086551, -76.6661071777344, -1.33807599493832, 218, 53, 'PPL', 'P'),
(124557, 'Colonial Park', 42.0272216796875, 0.733513393776089, -71.8319396972656, -1.2537038558113, 218, 23, 'PPL', 'P'),
(147954, 'Colonial Park', 43.2208290100098, 0.754345771666152, -75.4361114501953, -1.3166085197073, 218, 40, 'PPL', 'P'),
(160296, 'Colonial Park', 41.0041694641113, 0.715657764194461, -76.8394393920898, -1.3411012127786, 218, 45, 'PPL', 'P'),
(160297, 'Colonial Park Farms', 40.2900009155273, 0.703193171607482, -76.8133316040039, -1.34064554591609, 218, 45, 'PPL', 'P'),
(202019, 'Colonial Pine Hills', 44.0077781677246, 0.768080625514072, -103.315002441406, -1.80318695930852, 218, 49, 'PPL', 'P'),
(143649, 'Colonial Pines', 43.0263900756836, 0.750952172068091, -70.7872161865234, -1.23546999077586, 218, 36, 'PPL', 'P'),
(80436, 'Colonial Place', 34.6811103820801, 0.605299564414886, -82.896110534668, -1.44681006592711, 218, 48, 'PPL', 'P'),
(101009, 'Colonial Place', 36.8847198486328, 0.643759805034347, -76.291389465332, -1.33153593709136, 218, 53, 'PPL', 'P'),
(203489, 'Colonial Plaza Condominium', 41.166389465332, 0.718489037328352, -112.026390075684, -1.95522935594418, 218, 52, 'PPL', 'P'),
(101010, 'Colonial Point', 36.7886085510254, 0.642082346442733, -76.4119415283203, -1.33363996751058, 218, 53, 'PPL', 'P'),
(160298, 'Colonial Terrace', 40.3416709899902, 0.70409498453161, -76.8066711425781, -1.3405292989345, 218, 45, 'PPL', 'P'),
(115067, 'Colonial Terrace Mobile Home Park', 41.3177795410156, 0.721131292603874, -93.0838928222656, -1.62462041032205, 218, 16, 'PPL', 'P'),
(101011, 'Colonial Trail', 37.313060760498, 0.65123576426739, -79.8877792358398, -1.39430477977176, 218, 53, 'PPL', 'P'),
(13063, 'Colonial Village', 38.9925003051758, 0.680547513910211, -77.040283203125, -1.34460659856341, 218, 9, 'PPL', 'P'),
(29535, 'Colonial Village', 39.9375, 0.697040870015235, -85.8349990844727, -1.49810334747037, 218, 19, 'PPL', 'P'),
(45928, 'Colonial Village', 39.3597183227539, 0.686956677389596, -76.710563659668, -1.33885190692192, 218, 25, 'PPL', 'P'),
(80437, 'Colonial Village', 35.0125007629395, 0.61108341767032, -80.855827331543, -1.41120040635945, 218, 48, 'PPL', 'P'),
(85953, 'Colonial Village', 35.9388885498047, 0.627251934701382, -86.4611129760742, -1.50903109637129, 218, 50, 'PPL', 'P'),
(101012, 'Colonial Village', 38.8930587768555, 0.678811931827807, -77.0863876342773, -1.34541127268678, 218, 53, 'PPL', 'P'),
(147955, 'Colonial Village', 43.1349983215332, 0.752847743552982, -78.9661102294922, -1.37821862099741, 218, 40, 'PPL', 'P'),
(160300, 'Colonial Village', 41.4438896179199, 0.723332328665797, -79.6849975585938, -1.3907655718411, 218, 45, 'PPL', 'P'),
(13578, 'Colonial Village Apartments', 39.6847190856934, 0.692629010774383, -75.5688934326172, -1.31892600248789, 218, 10, 'PPL', 'P'),
(160301, 'Colonial Wood', 40.2991714477539, 0.703353227588996, -76.8300018310547, -1.34093649626518, 218, 45, 'PPL', 'P'),
(160302, 'Colonial Woods', 40.184440612793, 0.701350796765365, -76.8283309936523, -1.34090733465124, 218, 45, 'PPL', 'P'),
(160303, 'Colonial Woods South', 40.1816711425781, 0.70130246039158, -76.8291702270508, -1.34092198203724, 218, 45, 'PPL', 'P'),
(188344, 'Colonias', 35.1097183227539, 0.612780184179837, -104.846672058105, -1.82991963717268, 218, 38, 'PPL', 'P'),
(147956, 'Colonie', 42.7177810668945, 0.745565928763406, -73.8338928222656, -1.28864452931314, 218, 40, 'PPL', 'P'),
(130304, 'Colonville', 43.8441696166992, 0.765225117614262, -84.7058334350586, -1.47839568908767, 218, 27, 'PPL', 'P'),
(1714, 'Colony', 33.564998626709, 0.585819739463447, -86.1991729736328, -1.504459380886, 218, 2, 'PPL', 'P'),
(32126, 'Colony', 38.0708312988281, 0.66446135513586, -95.3652801513672, -1.66443813072815, 218, 20, 'PPL', 'P'),
(35332, 'Colony', 38.0433311462402, 0.6639813869284, -84.5619430541992, -1.47588432817973, 218, 21, 'PPL', 'P'),
(75503, 'Colony', 35.3486099243164, 0.616949629182465, -98.6763916015625, -1.72222792743455, 218, 42, 'PPL', 'P'),
(93375, 'Colony', 32.781551361084, 0.572146005162544, -95.6877365112305, -1.67006605590176, 218, 51, 'PPL', 'P'),
(101013, 'Colony', 37.4141693115234, 0.653000441384704, -79.1180572509766, -1.38087059681091, 218, 53, 'PPL', 'P'),
(139097, 'Colony', 40.2538909912109, 0.702562934535515, -91.9905624389648, -1.60553819532136, 218, 29, 'PPL', 'P'),
(209378, 'Colony', 44.8699989318848, 0.783129216727728, -104.154716491699, -1.81784273426139, 218, 59, 'PPL', 'P'),
(45929, 'Colony Acres', 39.6463890075684, 0.691960024708555, -76.0755615234375, -1.3277690288875, 218, 25, 'PPL', 'P'),
(101014, 'Colony Acres', 36.7794418334961, 0.641922357040247, -76.0486068725586, -1.32729858148094, 218, 53, 'PPL', 'P'),
(160304, 'Colony Arms', 40.1266708374023, 0.700342523976661, -75.4383316040039, -1.31664726870116, 218, 45, 'PPL', 'P'),
(196251, 'Colony Bay (historical)', 48.0305595397949, 0.838291405544594, -110.611671447754, -1.93053785789751, 218, 31, 'PPL', 'P'),
(177978, 'Colony Biltmore IV', 33.5152816772461, 0.584952015001272, -112.023887634277, -1.9551856801023, 218, 5, 'PPL', 'P'),
(20184, 'Colony Center', 34.0786094665527, 0.594783939692654, -84.4333267211914, -1.4736395496969, 218, 13, 'PPL', 'P'),
(101015, 'Colony Club', 36.563060760498, 0.638145794877433, -77.852783203125, -1.35878739873587, 218, 53, 'PPL', 'P'),
(134765, 'Colony Court', 44.0980606079102, 0.769656351352044, -93.5061111450195, -1.63198951021636, 218, 28, 'PPL', 'P'),
(203493, 'Colony East Estates', 40.5999984741211, 0.708603649678087, -111.883331298828, -1.95273250926417, 218, 52, 'PPL', 'P'),
(63841, 'Colony Estates', 35.1216697692871, 0.612988776272217, -77.095832824707, -1.34557612235826, 218, 33, 'PPL', 'P'),
(203494, 'Colony Estates', 40.6650009155273, 0.709738156302461, -111.978057861328, -1.9543857996689, 218, 52, 'PPL', 'P'),
(93376, 'Colony Estates Colonia', 27.9629993438721, 0.488046407283582, -97.9879989624023, -1.71021320933471, 218, 51, 'PPL', 'P'),
(93377, 'Colony Estates of Sinton Colonia', 28.007999420166, 0.48883180677856, -97.5630035400391, -1.70279563990857, 218, 51, 'PPL', 'P'),
(45930, 'Colony Fairfield', 39.1208305358887, 0.682787298965995, -76.7624969482422, -1.33975831379893, 218, 25, 'PPL', 'P'),
(80438, 'Colony Gardens Estates', 32.4444389343262, 0.566262283366232, -80.6555633544922, -1.40770514058677, 218, 48, 'PPL', 'P'),
(20185, 'Colony Heights', 33.0041694641113, 0.576031424034915, -85.1336135864258, -1.48586186120371, 218, 13, 'PPL', 'P'),
(112251, 'Colony Hill', 38.9130592346191, 0.679161005667689, -77.0875015258789, -1.34543071376274, 218, 9, 'PPL', 'P'),
(13580, 'Colony Hills', 39.711109161377, 0.693089604484912, -75.6097183227539, -1.31963853123754, 218, 10, 'PPL', 'P'),
(101016, 'Colony Manor', 36.7702789306641, 0.641762434216788, -76.3858337402344, -1.33318430064806, 218, 53, 'PPL', 'P'),
(80440, 'Colony North', 32.9480590820313, 0.575052113123066, -80.0638885498047, -1.39737846714388, 218, 48, 'PPL', 'P'),
(20186, 'Colony Park', 33.4536094665527, 0.583875631867689, -82.0555572509766, -1.43213964358825, 218, 13, 'PPL', 'P'),
(45932, 'Colony Ridge', 39.0741691589355, 0.681972904304649, -76.6849975585938, -1.33840569428127, 218, 25, 'PPL', 'P'),
(20187, 'Colony South', 34.2200012207031, 0.597251691337748, -83.8288879394531, -1.46309010282882, 218, 13, 'PPL', 'P'),
(177979, 'Colony South', 33.6213912963867, 0.586803977223313, -112.110282897949, -1.9566935619115, 218, 5, 'PPL', 'P'),
(203496, 'Colony South', 40.666389465332, 0.70976239106838, -111.966941833496, -1.95419178838348, 218, 52, 'PPL', 'P'),
(20188, 'Colony Springs', 34.086109161377, 0.594914834060231, -84.4433288574219, -1.47381411990635, 218, 13, 'PPL', 'P'),
(45933, 'Colony Square', 38.2574996948242, 0.667719333255408, -76.4499969482422, -1.33430415988644, 218, 25, 'PPL', 'P'),
(80441, 'Colony Subdivision', 34.9630584716797, 0.610220486898107, -82.3083267211914, -1.43655130309202, 218, 48, 'PPL', 'P'),
(203499, 'Colony West Subdivision - Numbers 13, 14 and 15', 40.6697196960449, 0.709820514559171, -112.016670227051, -1.95505971258274, 218, 52, 'PPL', 'P'),
(20189, 'Colony Woods', 34.0988883972168, 0.595137873801525, -84.5019378662109, -1.47483704008105, 218, 13, 'PPL', 'P'),
(101017, 'Colony Woods', 38.639720916748, 0.674390352048975, -77.3555603027344, -1.35010922200774, 218, 53, 'PPL', 'P'),
(45935, 'Colora', 39.6719398498535, 0.692405971033089, -76.0988922119141, -1.32817622621817, 218, 25, 'PPL', 'P'),
(93378, 'Colorado', 29.985559463501, 0.523346740690636, -97.1338882446289, -1.69530616513299, 218, 51, 'PPL', 'P'),
(186561, 'Colorado', 39.0002784729004, 0.680683268546778, -105.500282287598, -1.84132728770203, 218, 7, 'ADM1', 'A'),
(211766, 'Colorado', 63.1627807617188, 1.10239848900732, -149.435836791992, -2.60814737249314, 218, 1, 'PPL', 'P'),
(93379, 'Colorado Acres Colonia', 27.6450004577637, 0.482496279703316, -99.213996887207, -1.73161090974517, 218, 51, 'PPL', 'P'),
(177980, 'Colorado City', 36.9902801513672, 0.645602179876464, -112.974998474121, -1.97178569580898, 218, 5, 'PPL', 'P'),
(186559, 'Colorado City', 37.9452781677246, 0.662270039611916, -104.834716796875, -1.82971097850127, 218, 7, 'PPL', 'P'),
(191304, 'Colorado City', 32.3880615234375, 0.565278311922475, -100.864166259766, -1.76041179851188, 218, 51, 'PPL', 'P'),
(186560, 'Colorado Springs', 38.8338890075684, 0.677779224536101, -104.820831298828, -1.82946863084207, 218, 7, 'PPL', 'P'),
(147958, 'Colosse', 43.420280456543, 0.757826856106021, -76.1591720581055, -1.32922830800681, 218, 40, 'PPL', 'P'),
(26833, 'Colp', 37.8052787780762, 0.659826589311768, -89.0800018310547, -1.55473932963448, 218, 18, 'PPL', 'P'),
(20190, 'Colquitt', 31.1711101531982, 0.544038503675143, -84.7333297729492, -1.4788755907161, 218, 13, 'PPL', 'P'),
(39847, 'Colquitt', 32.9497184753418, 0.57508107499992, -92.9736099243164, -1.6226956106442, 218, 22, 'PPL', 'P'),
(93385, 'Colquitt', 32.795280456543, 0.572385623081624, -96.3572235107422, -1.68175080834254, 218, 51, 'PPL', 'P'),
(124558, 'Colrain', 42.6730613708496, 0.744785422826931, -72.6972198486328, -1.26880584340482, 218, 23, 'PPL', 'P'),
(35333, 'Colson', 37.2238883972168, 0.649679412926348, -82.8563919067383, -1.44611684509537, 218, 21, 'PPL', 'P'),
(39849, 'Colsons (historical)', 32.7272186279297, 0.571197720077394, -92.2422180175781, -1.60993041374918, 218, 22, 'PPL', 'P'),
(196252, 'Colstrip', 45.8841705322266, 0.800829850333912, -106.623062133789, -1.86092349279311, 218, 31, 'PPL', 'P'),
(571, 'Colt', 30.3016700744629, 0.528863911652413, -89.8333282470703, -1.5678873559362, 218, 22, 'PPL', 'P'),
(8188, 'Colt', 35.1313896179199, 0.613158419633655, -90.8111114501953, -1.58495289220143, 218, 4, 'PPL', 'P'),
(209379, 'Colter', 43.9563903808594, 0.76718373943796, -108.013328552246, -1.88518821927509, 218, 59, 'PPL', 'P'),
(209380, 'Colter Bay Village', 43.9047203063965, 0.766281926513832, -110.639999389648, -1.93103227375388, 218, 59, 'PPL', 'P'),
(93381, 'Colthorp', 31.3672199249268, 0.547461264887141, -95.1469421386719, -1.66062741352436, 218, 51, 'PPL', 'P'),
(101018, 'Colthurst', 38.0663909912109, 0.664383857148139, -78.5250015258789, -1.37051982176016, 218, 53, 'PPL', 'P'),
(194766, 'Coltman', 43.6177787780762, 0.761273852083938, -112.011390686035, -1.95496756720902, 218, 17, 'PPL', 'P'),
(93382, 'Colton', 30.1494407653809, 0.526207008990895, -97.6969375610352, -1.70513322955538, 218, 51, 'PPL', 'P'),
(147959, 'Colton', 44.5530586242676, 0.777597564827524, -74.9400024414063, -1.30794978405513, 218, 40, 'PPL', 'P'),
(154806, 'Colton', 41.4647216796875, 0.72369591673362, -83.9524993896484, -1.4652475296279, 218, 41, 'PPL', 'P'),
(170063, 'Colton', 43.7861099243164, 0.764211784819486, -96.9272232055664, -1.69169917975259, 218, 49, 'PPL', 'P'),
(180821, 'Colton', 34.0738906860352, 0.594701581435943, -117.312782287598, -2.04749430559386, 218, 6, 'PPL', 'P'),
(192525, 'Colton', 39.8525009155273, 0.695557356130007, -111.012222290039, -1.93752878891702, 218, 52, 'PPL', 'P'),
(199241, 'Colton', 41.1533317565918, 0.718261137318069, -102.856666564941, -1.79518748918419, 218, 35, 'PPL', 'P'),
(200609, 'Colton', 45.1722183227539, 0.788403940161766, -122.436668395996, -2.13692298868262, 218, 43, 'PPL', 'P'),
(207084, 'Colton', 46.5680618286133, 0.812766005181593, -117.127502441406, -2.04426056224024, 218, 56, 'PPL', 'P'),
(8189, 'Colton Crossing', 35.3652801513672, 0.617240579531556, -90.6122207641602, -1.58148159487857, 218, 4, 'PPL', 'P'),
(124560, 'Colton Hollow', 42.1097183227539, 0.73495323181944, -72.3541717529297, -1.2628185246421, 218, 23, 'PPL', 'P'),
(101019, 'Coltons Mill', 37.4619407653809, 0.653834210542981, -79.4633331298828, -1.38689679772555, 218, 53, 'PPL', 'P'),
(45936, 'Coltons Point', 38.2244415283203, 0.667142359405243, -76.7536087036133, -1.33960318466543, 218, 25, 'PPL', 'P'),
(63845, 'Coltranes Mill', 35.9058303833008, 0.626674960851216, -79.8566665649414, -1.3937617612255, 218, 33, 'PPL', 'P'),
(35334, 'Colts', 36.8802795410156, 0.643682307046626, -83.1466674804688, -1.45118310959508, 218, 21, 'PPL', 'P'),
(145028, 'Colts Neck', 40.2874984741211, 0.703149495765605, -74.1727828979492, -1.29455927693616, 218, 37, 'PPL', 'P'),
(124561, 'Coltsville', 42.4674987792969, 0.741197678785403, -73.2041702270508, -1.27765379665244, 218, 23, 'PPL', 'P'),
(1716, 'Columbia', 31.2924995422363, 0.546157148190842, -85.1116714477539, -1.48547889863895, 218, 2, 'PPL', 'P'),
(13581, 'Columbia', 38.4977798461914, 0.671913013023956, -75.6780624389648, -1.32083136108979, 218, 10, 'PPL', 'P'),
(15590, 'Columbia', 30.0736103057861, 0.524883517797667, -82.6958312988281, -1.44331453383833, 218, 12, 'PPL', 'P'),
(26834, 'Columbia', 38.4436111450195, 0.670967590836978, -90.2011108398438, -1.57430637311162, 218, 18, 'PPL', 'P'),
(29536, 'Columbia', 39.5763893127441, 0.690738299558481, -85.2072219848633, -1.48714657011356, 218, 19, 'PPL', 'P'),
(35338, 'Columbia', 37.1027793884277, 0.647565661969152, -85.3063888549805, -1.488877358506, 218, 21, 'PPL', 'P'),
(39852, 'Columbia', 30.0233306884766, 0.524005972928972, -90.5711135864258, -1.5807641392809, 218, 22, 'PPL', 'P'),
(45937, 'Columbia', 39.2402801513672, 0.684872088046336, -76.8397216796875, -1.34110613962661, 218, 25, 'PPL', 'P'),
(54153, 'Columbia', 38.9516716003418, 0.679834918581533, -92.3338928222656, -1.61153044093209, 218, 29, 'PPL', 'P'),
(59083, 'Columbia', 31.2516708374023, 0.545444552862164, -89.8375015258789, -1.56796019339202, 218, 30, 'PPL', 'P'),
(63846, 'Columbia', 35.9174995422363, 0.62687862609558, -76.2525024414063, -1.33085723048755, 218, 33, 'PPL', 'P'),
(80443, 'Columbia', 34.000560760498, 0.593421732795078, -81.0350036621094, -1.41432762326947, 218, 48, 'PPL', 'P'),
(85958, 'Columbia', 35.6150016784668, 0.621599042392552, -87.0352783203125, -1.51905217207909, 218, 50, 'PPL', 'P'),
(101020, 'Columbia', 37.7527809143066, 0.658910328738726, -78.1627807617188, -1.36419787680647, 218, 53, 'PPL', 'P'),
(108667, 'Columbia', 38.1227798461914, 0.665368028328977, -81.3111114501953, -1.41914661326197, 218, 58, 'PPL', 'P'),
(115070, 'Columbia', 41.1752815246582, 0.718644233040876, -93.1497192382813, -1.62576929801631, 218, 16, 'PPL', 'P'),
(127137, 'Columbia', 44.6580581665039, 0.779430152552635, -67.7750015258789, -1.18289692717077, 218, 26, 'PPL', 'P'),
(143651, 'Columbia', 44.8777809143066, 0.783265037943322, -71.5147171020508, -1.24816727706308, 218, 36, 'PPL', 'P'),
(145030, 'Columbia', 40.9261093139648, 0.714295357559804, -75.0930633544922, -1.31062120094459, 218, 37, 'PPL', 'P'),
(154809, 'Columbia', 41.6330604553223, 0.726633982627223, -84.7886123657227, -1.47984045397904, 218, 41, 'PPL', 'P'),
(160305, 'Columbia', 40.0336112976074, 0.698718328606849, -76.5047225952148, -1.3352593026114, 218, 45, 'PPL', 'P'),
(170064, 'Columbia', 45.6130599975586, 0.796098078867114, -98.3122177124023, -1.71587189401891, 218, 49, 'PPL', 'P'),
(173627, 'Columbia', 44.5163917541504, 0.776957607217578, -90.7197189331055, -1.58335779186653, 218, 57, 'PPL', 'P'),
(177621, 'Columbia', 41.7019386291504, 0.727836133543285, -72.3016662597656, -1.261902130911, 218, 8, 'PPL', 'P'),
(177981, 'Columbia', 34.0336112976074, 0.593998573487189, -112.309722900391, -1.96017444661429, 218, 5, 'PPL', 'P'),
(180822, 'Columbia', 38.0363883972168, 0.663860213098802, -120.400283813477, -2.1013813728808, 218, 6, 'PPL', 'P'),
(192526, 'Columbia', 39.5169410705566, 0.689700731997786, -110.381942749023, -1.92652833571834, 218, 52, 'PPL', 'P'),
(207086, 'Columbia', 48.9672203063965, 0.854639219896045, -122.161666870117, -2.13212330660802, 218, 56, 'PPL', 'P'),
(199883, 'Columbia (historical)', 41.6783294677734, 0.727424075943622, -116.077217102051, -2.02592962498306, 218, 39, 'PPL', 'P'),
(45938, 'Columbia Beach', 38.8177795410156, 0.677498061304016, -76.5008316040039, -1.3351913920036, 218, 25, 'PPL', 'P'),
(207087, 'Columbia Beach', 47.9705581665039, 0.837244184024947, -122.349998474121, -2.13541031318345, 218, 56, 'PPL', 'P'),
(147961, 'Columbia Center', 42.9324989318848, 0.749313462470338, -75.0374984741211, -1.30965141083363, 218, 40, 'PPL', 'P'),
(154810, 'Columbia Center', 41.3125, 0.721039147230157, -81.9258270263672, -1.42987542402946, 218, 41, 'PPL', 'P'),
(122416, 'Columbia City', 41.1572189331055, 0.718328981346838, -85.4883270263672, -1.49205277863176, 218, 19, 'PPL', 'P'),
(200610, 'Columbia City', 45.8902816772461, 0.80093650993557, -122.80583190918, -2.1433661074659, 218, 43, 'PPL', 'P'),
(160307, 'Columbia Cross Roads', 41.8358306884766, 0.730172990820802, -76.8022232055664, -1.34045166778873, 218, 45, 'PPL', 'P'),
(127138, 'Columbia Falls', 44.6536102294922, 0.779352521406859, -67.7280578613281, -1.1820776056614, 218, 26, 'PPL', 'P'),
(196253, 'Columbia Falls', 48.372501373291, 0.844259416389407, -114.180557250977, -1.99282666579143, 218, 31, 'PPL', 'P'),
(45939, 'Columbia Forest', 38.9900016784668, 0.680503904647361, -77.0861129760742, -1.34540647899682, 218, 25, 'PPL', 'P'),
(101021, 'Columbia Forest', 38.853889465332, 0.678128298375983, -77.1105575561523, -1.34583311740345, 218, 53, 'PPL', 'P'),
(101022, 'Columbia Furnace', 38.8761100769043, 0.678516121209726, -78.6258316040039, -1.37227963860848, 218, 53, 'PPL', 'P'),
(85959, 'Columbia Gardens', 35.6161117553711, 0.621618416889483, -87.0769424438477, -1.51977934821474, 218, 50, 'PPL', 'P'),
(196254, 'Columbia Gardens', 46.0066719055176, 0.802967902636055, -112.463333129883, -1.96285545088367, 218, 31, 'PPL', 'P'),
(13064, 'Columbia Heights', 38.9255599975586, 0.679379185139993, -77.0297164916992, -1.34442217465793, 218, 9, 'PPL', 'P'),
(20194, 'Columbia Heights', 33.5161094665527, 0.584966462650185, -82.0977783203125, -1.43287654026187, 218, 13, 'PPL', 'P'),
(39853, 'Columbia Heights', 32.0911102294922, 0.560095534125072, -92.0891723632813, -1.60725926317583, 218, 22, 'PPL', 'P'),
(63847, 'Columbia Heights', 36.0902786254883, 0.629894189976904, -80.227783203125, -1.40023896847073, 218, 33, 'PPL', 'P'),
(93383, 'Columbia Heights', 29.3697204589844, 0.512598322399618, -98.5263900756836, -1.71960990692494, 218, 51, 'PPL', 'P'),
(101023, 'Columbia Heights', 38.8574981689453, 0.678191282135764, -77.1213912963867, -1.34602220184085, 218, 53, 'PPL', 'P'),
(134769, 'Columbia Heights', 45.040828704834, 0.786110758726126, -93.2627792358398, -1.62774256722601, 218, 28, 'PPL', 'P'),
(169324, 'Columbia Heights', 41.4422187805176, 0.723303167051861, -71.6386108398438, -1.25032963071017, 218, 47, 'PPL', 'P'),
(200612, 'Columbia Heights', 45.8638916015625, 0.800475916225041, -122.837501525879, -2.14391884655015, 218, 43, 'PPL', 'P'),
(207089, 'Columbia Heights', 46.1644401550293, 0.805721478045143, -122.940277099609, -2.14571261870237, 218, 56, 'PPL', 'P'),
(85960, 'Columbia Hill', 36.1986083984375, 0.631784901192806, -85.208610534668, -1.48717080487948, 218, 50, 'PPL', 'P'),
(160308, 'Columbia Hill', 41.041389465332, 0.716307375763359, -76.565559387207, -1.33632110493801, 218, 45, 'PPL', 'P'),
(45940, 'Columbia Hills', 39.2419395446777, 0.684901049923191, -76.8291702270508, -1.34092198203724, 218, 25, 'PPL', 'P'),
(154811, 'Columbia Hills Corners', 41.3127784729004, 0.721044007499147, -81.9158325195313, -1.42970098697806, 218, 41, 'PPL', 'P'),
(192527, 'Columbia Junction', 39.5316696166992, 0.689957793622006, -110.443061828613, -1.92759506489297, 218, 52, 'PPL', 'P'),
(70686, 'Columbia Lakes', 39.9347190856934, 0.696992333904369, -75.0052795410156, -1.30908908436946, 218, 37, 'PPL', 'P'),
(20196, 'Columbia Mine (historical)', 33.6166687011719, 0.586721552387575, -82.5666732788086, -1.44106030113363, 218, 13, 'PPL', 'P'),
(45942, 'Columbia Park', 38.9174995422363, 0.67923850365541, -76.8886108398438, -1.34195941643988, 218, 25, 'PPL', 'P'),
(101025, 'Columbia Park', 37.3300018310547, 0.651531441727416, -77.4375, -1.35153933951311, 218, 53, 'PPL', 'P'),
(101026, 'Columbia Pines', 38.8405609130859, 0.677895671254765, -77.1875, -1.34717601638312, 218, 53, 'PPL', 'P'),
(59081, 'Columbia Springs (historical)', 31.288890838623, 0.546094164431062, -89.850830078125, -1.56819282051324, 218, 30, 'PPL', 'P'),
(154812, 'Columbia Station', 41.313060760498, 0.721048934347163, -81.9469375610352, -1.43024387236628, 218, 41, 'PPL', 'P'),
(207090, 'Columbia Valley Gardens', 46.1577796936035, 0.805605231063561, -122.973609924316, -2.1462943862425, 218, 56, 'PPL', 'P'),
(180823, 'Columbia Village', 38.0238914489746, 0.663642100205524, -120.40055847168, -2.10138616657076, 218, 6, 'PPL', 'P'),
(1717, 'Columbiana', 33.1780586242676, 0.579066362413169, -86.6072235107422, -1.51158120627309, 218, 2, 'PPL', 'P'),
(154814, 'Columbiana', 40.8883285522461, 0.713635958873901, -80.6941680908203, -1.40837892034256, 218, 41, 'PPL', 'P'),
(26835, 'Columbiana (historical)', 39.2972183227539, 0.685865846607099, -90.6002807617188, -1.58127320252327, 218, 18, 'PPL', 'P'),
(130308, 'Columbiaville', 43.1566696166992, 0.753225979006801, -83.4105606079102, -1.45578891354232, 218, 27, 'PPL', 'P'),
(147964, 'Columbiaville', 42.3183288574219, 0.738594172503742, -73.7536087036133, -1.2872433071056, 218, 40, 'PPL', 'P'),
(194143, 'Columbine', 40.8541717529297, 0.713039810263886, -106.965278625488, -1.86689629732789, 218, 7, 'PPL', 'P'),
(186563, 'Columbine Valley', 39.6011085510254, 0.691169731655074, -105.031669616699, -1.83314845367829, 218, 7, 'PPL', 'P'),
(1718, 'Columbus', 33.7580604553223, 0.58918930403267, -86.7533264160156, -1.51413118301684, 218, 2, 'PPL', 'P'),
(8192, 'Columbus', 33.7758293151855, 0.589499429141609, -93.8169403076172, -1.6374145025149, 218, 4, 'PPL', 'P'),
(20197, 'Columbus', 32.4608306884766, 0.566548373446334, -84.9877777099609, -1.48331654499186, 218, 13, 'PPL', 'P'),
(26836, 'Columbus', 39.9880599975586, 0.697923308442433, -91.1466674804688, -1.59080944975462, 218, 18, 'PPL', 'P'),
(29541, 'Columbus', 39.2013893127441, 0.684193314863502, -85.92138671875, -1.49961109612151, 218, 19, 'PPL', 'P'),
(32129, 'Columbus', 37.1691703796387, 0.648724403359445, -94.8438873291016, -1.65533810928335, 218, 20, 'PPL', 'P'),
(35336, 'Columbus', 36.7597198486328, 0.641578143469354, -89.1033325195313, -1.55514652696516, 218, 21, 'PPL', 'P'),
(54155, 'Columbus', 38.8586082458496, 0.678210656632694, -93.8905563354492, -1.63869934458281, 218, 29, 'PPL', 'P'),
(59082, 'Columbus', 33.4955596923828, 0.584607801430379, -88.4272232055664, -1.54334619333307, 218, 30, 'PPL', 'P'),
(63851, 'Columbus', 35.253059387207, 0.615281957707857, -82.1972198486328, -1.43461212234428, 218, 33, 'PPL', 'P'),
(72181, 'Columbus', 39.961109161377, 0.697452927614898, -82.998893737793, -1.44860397123739, 218, 41, 'PPL', 'P'),
(93384, 'Columbus', 29.7063903808594, 0.518474321028768, -96.539436340332, -1.68493102215826, 218, 51, 'PPL', 'P'),
(130309, 'Columbus', 42.8822212219238, 0.748435950891157, -82.6624984741211, -1.4427327662982, 218, 27, 'PPL', 'P'),
(141532, 'Columbus', 41.4297218322754, 0.723085054158583, -97.3680572509766, -1.69939318529988, 218, 35, 'PPL', 'P'),
(145031, 'Columbus', 40.0724983215332, 0.699397035210656, -74.7211074829102, -1.30412934631335, 218, 37, 'PPL', 'P'),
(147965, 'Columbus', 42.6838912963867, 0.744974440685299, -75.3730621337891, -1.31550810154488, 218, 40, 'PPL', 'P'),
(160311, 'Columbus', 41.9408302307129, 0.732005578545913, -79.5819396972656, -1.38896687284086, 218, 45, 'PPL', 'P'),
(173629, 'Columbus', 43.3380584716797, 0.756391811752632, -89.0152816772461, -1.55360974985812, 218, 57, 'PPL', 'P'),
(186564, 'Columbus', 37.3277816772461, 0.651492692733556, -107.629440307617, -1.87848810544662, 218, 7, 'PPL', 'P'),
(188345, 'Columbus', 31.8274993896484, 0.555494657025851, -107.639442443848, -1.87866267565607, 218, 38, 'PPL', 'P'),
(190059, 'Columbus', 38.110279083252, 0.665149848856673, -118.018333435059, -2.05980849615828, 218, 39, 'PPL', 'P'),
(196255, 'Columbus', 45.6366691589355, 0.796510136466777, -109.251388549805, -1.90679644256972, 218, 31, 'PPL', 'P'),
(198136, 'Columbus', 48.9041709899902, 0.853538801733625, -102.779998779297, -1.79384938389448, 218, 34, 'PPL', 'P'),
(26837, 'Columbus (historical)', 39.7638893127441, 0.69401079190597, -90.6041717529297, -1.58134111313107, 218, 18, 'PPL', 'P'),
(39854, 'Columbus (historical)', 31.3544406890869, 0.547238225145846, -93.6530609130859, -1.63455426750416, 218, 22, 'PPL', 'P'),
(85961, 'Columbus (historical)', 35.2261085510254, 0.614811576880322, -84.6222229003906, -1.47693640996836, 218, 50, 'PPL', 'P'),
(1719, 'Columbus City', 34.4605598449707, 0.601450231375285, -86.2333297729492, -1.50505552949602, 218, 2, 'PPL', 'P'),
(115073, 'Columbus City', 41.2586097717285, 0.720098585312169, -91.3741683959961, -1.59478008978188, 218, 16, 'PPL', 'P'),
(154816, 'Columbus Grove', 40.9194412231445, 0.714178977420168, -84.0569381713867, -1.467070330236, 218, 41, 'PPL', 'P'),
(85962, 'Columbus Hill', 36.3863906860352, 0.635062320388312, -85.6222229003906, -1.49438970248831, 218, 50, 'PPL', 'P'),
(115075, 'Columbus Junction', 41.2799987792969, 0.720471893917971, -91.3605575561523, -1.59454253581264, 218, 16, 'PPL', 'P'),
(124562, 'Columbus Park', 42.2555618286133, 0.737498681189338, -71.834716796875, -1.25375232534314, 218, 23, 'PPL', 'P'),
(147966, 'Columbus Quarter', 42.7102813720703, 0.745435034395828, -75.3177795410156, -1.31454323828195, 218, 40, 'PPL', 'P'),
(119205, 'Colusa', 40.5708312988281, 0.708094586435718, -91.1677780151367, -1.59117789809144, 218, 18, 'PPL', 'P'),
(180825, 'Colusa', 39.2144393920898, 0.684421081715731, -122.008331298828, -2.1294470960286, 218, 6, 'PPL', 'P'),
(180827, 'Colusa Junction', 39.1477813720703, 0.68325767979353, -121.659172058105, -2.12335311766423, 218, 6, 'PPL', 'P'),
(180828, 'Colusa Rancheria', 39.2502784729004, 0.685046591676764, -122.024719238281, -2.12973311952967, 218, 6, 'PPL', 'P'),
(160313, 'Colver', 40.5433311462402, 0.707614618228259, -78.7880630493164, -1.37511111147945, 218, 45, 'PPL', 'P'),
(35337, 'Colville', 38.3652801513672, 0.669600457091386, -84.2102813720703, -1.46974667397348, 218, 21, 'PPL', 'P'),
(207091, 'Colville', 48.5466690063477, 0.847299215036651, -117.904441833496, -2.05782071272065, 218, 56, 'PPL', 'P'),
(8193, 'Colville (historical)', 36.2586097717285, 0.632832122712452, -94.1944427490234, -1.64400316305176, 218, 4, 'PPL', 'P'),
(1720, 'Colvin', 33.9208297729492, 0.592030164546484, -85.9136123657227, -1.49947540806397, 218, 2, 'PPL', 'P'),
(101028, 'Colvin Farms', 38.6949996948242, 0.675355148732884, -77.540283203125, -1.35333324482339, 218, 53, 'PPL', 'P'),
(119206, 'Colvin Park', 42.1380615234375, 0.735447913991922, -88.783332824707, -1.5495614786851, 218, 18, 'PPL', 'P'),
(1721, 'Colvins Gap', 33.9361114501953, 0.592296880129656, -85.8133316040039, -1.49772517859558, 218, 2, 'PPL', 'P'),
(169326, 'Colvintown', 41.7180595397949, 0.728117496512452, -71.5722198486328, -1.24917088931988, 218, 47, 'PPL', 'P'),
(207092, 'Colvos', 47.476390838623, 0.828619337097644, -122.489440917969, -2.13784404294562, 218, 56, 'PPL', 'P'),
(1722, 'Colwell', 33.8791694641113, 0.591303054989866, -85.9191665649414, -1.49957234712765, 218, 2, 'PPL', 'P'),
(20198, 'Colwell', 34.8969383239746, 0.609066472618749, -84.4725036621094, -1.47432331630678, 218, 13, 'PPL', 'P'),
(115076, 'Colwell', 43.1558303833008, 0.753211331620805, -92.5938873291016, -1.61606820111348, 218, 16, 'PPL', 'P'),
(32131, 'Colwich', 37.7791709899902, 0.659370922449255, -97.5361099243164, -1.70232625776644, 218, 20, 'PPL', 'P'),
(70687, 'Colwick', 39.9519386291504, 0.697292871633384, -75.0233306884766, -1.30940413632642, 218, 37, 'PPL', 'P'),
(85963, 'Colwick (historical)', 35.7822189331055, 0.624517534052143, -88.1780624389648, -1.53899751758908, 218, 50, 'PPL', 'P'),
(130312, 'Colwood', 43.6116714477539, 0.761167259061308, -83.3522186279297, -1.45477065389952, 218, 27, 'PPL', 'P'),
(78060, 'Colwyn', 39.9122200012207, 0.696599650801636, -75.2541732788086, -1.31343309958155, 218, 45, 'PPL', 'P'),
(39855, 'Colyell', 30.3902797698975, 0.530410442586935, -90.7699966430664, -1.58423530344571, 218, 22, 'PPL', 'P'),
(160314, 'Colyer', 40.7841682434082, 0.711818018534785, -77.6761093139648, -1.35570385766772, 218, 45, 'PPL', 'P'),
(160315, 'Colza', 41.9152793884277, 0.731559632221379, -79.6055603027344, -1.38937913017761, 218, 45, 'PPL', 'P'),
(8195, 'Comal', 36.2372207641602, 0.63245881410665, -92.772216796875, -1.61918063747946, 218, 4, 'PPL', 'P'),
(93386, 'Comal', 29.6452808380127, 0.517407758301705, -98.2233276367188, -1.71432046952588, 218, 51, 'PPL', 'P'),
(75505, 'Comanche', 34.3688888549805, 0.599850270771393, -97.9636077880859, -1.70978750303446, 218, 42, 'PPL', 'P'),
(93388, 'Comanche', 31.8972206115723, 0.556711521906935, -98.6033325195313, -1.72095280590462, 218, 51, 'PPL', 'P'),
(186565, 'Comanche', 39.9855613708496, 0.697879699179583, -104.300003051758, -1.82037846309331, 218, 7, 'PPL', 'P'),
(196256, 'Comanche', 45.9977798461914, 0.802812706923531, -108.77278137207, -1.89844317149458, 218, 31, 'PPL', 'P'),
(93390, 'Comanche Crossing', 29.5733299255371, 0.516151977979192, -97.2708282470703, -1.69769621905328, 218, 51, 'PPL', 'P'),
(85964, 'Comanche Subdivision', 35.8925018310547, 0.626442333729998, -85.0583267211914, -1.48454785752186, 218, 50, 'PPL', 'P'),
(93391, 'Comanche Village I', 31.1413898468018, 0.543519786473823, -97.807502746582, -1.70706295608125, 218, 51, 'PPL', 'P'),
(93392, 'Comanche Village II', 31.1366691589355, 0.543437394927599, -97.8097229003906, -1.70710170507511, 218, 51, 'PPL', 'P'),
(93393, 'Comanche Village III', 31.1408290863037, 0.543509999356817, -97.8238906860352, -1.70734897958233, 218, 51, 'PPL', 'P'),
(207093, 'Comar', 48.7319412231445, 0.850532825232225, -122.202217102051, -2.13283104166771, 218, 56, 'PPL', 'P'),
(35339, 'Comargo', 36.6775016784668, 0.640143165694992, -84.541389465332, -1.47552560038089, 218, 21, 'PPL', 'P'),
(72183, 'Comargo', 39.2902793884277, 0.685744739356528, -84.1638870239258, -1.46893693984404, 218, 41, 'PPL', 'P'),
(101027, 'Combat Village', 38.5994415283203, 0.673687344100221, -77.45361328125, -1.35182056932422, 218, 53, 'PPL', 'P'),
(15592, 'Combee Settlement', 28.0580596923828, 0.489705523353187, -81.9055633544922, -1.4295217562367, 218, 12, 'PPL', 'P'),
(93394, 'Combes', 26.2483291625977, 0.458119767034575, -97.7336120605469, -1.70577332032338, 218, 51, 'PPL', 'P'),
(93395, 'Combes Colonia', 26.2430000305176, 0.458026756133504, -97.7249984741211, -1.70562298487985, 218, 51, 'PPL', 'P'),
(93396, 'Combine', 32.5883293151855, 0.568773644274177, -96.5083312988281, -1.68438813677005, 218, 51, 'PPL', 'P'),
(173632, 'Combined Locks', 44.2658309936523, 0.772584496970587, -88.3141708374023, -1.54137305728143, 218, 57, 'PPL', 'P'),
(8196, 'Combs', 35.8255615234375, 0.62527400495978, -93.8363876342773, -1.63775392239583, 218, 4, 'PPL', 'P'),
(35340, 'Combs', 37.2669410705566, 0.650430823827914, -83.2127838134766, -1.45233705729541, 218, 21, 'PPL', 'P'),
(85965, 'Combs', 36.5011100769043, 0.637064551474861, -83.6894378662109, -1.4606562399086, 218, 50, 'PPL', 'P'),
(119207, 'Combs', 40.1194381713867, 0.700216290140991, -88.6102828979492, -1.54654118769284, 218, 18, 'PPL', 'P'),
(108668, 'Combs Addition', 37.7305603027344, 0.658522505904983, -81.8002777099609, -1.42768417508455, 218, 58, 'PPL', 'P'),
(35341, 'Combs Ford', 37.5152816772461, 0.654765185081045, -86.8683319091797, -1.51613840753044, 218, 21, 'PPL', 'P'),
(63854, 'Combs Fork', 35.0625, 0.611956068980512, -77.5199966430664, -1.35297917755646, 218, 33, 'PPL', 'P'),
(63855, 'Combstown', 36.500560760498, 0.637054964094936, -80.5791702270508, -1.40637182898702, 218, 33, 'PPL', 'P'),
(59086, 'Comeby (historical)', 32.0694389343262, 0.559717298671253, -90.0097198486328, -1.57096597015633, 218, 30, 'PPL', 'P'),
(1724, 'Comer', 34.9291687011719, 0.609628998820001, -87.4047164916992, -1.52550008455234, 218, 2, 'PPL', 'P'),
(20199, 'Comer', 34.0636100769043, 0.594522150957499, -83.1255569458008, -1.45081466125827, 218, 13, 'PPL', 'P'),
(26839, 'Comer', 39.2930603027344, 0.685793275467395, -89.9705581665039, -1.57028246986257, 218, 18, 'PPL', 'P'),
(35342, 'Comer', 37.6377792358398, 0.656903170804161, -87.4438934326172, -1.52618385116222, 218, 21, 'PPL', 'P'),
(194144, 'Comer', 40.4677810668945, 0.706296020593533, -104.853889465332, -1.83004560469224, 218, 7, 'PPL', 'P'),
(1725, 'Comerdale', 33.2130584716797, 0.579677224988206, -86.2958297729492, -1.50614636027851, 218, 2, 'PPL', 'P'),
(101029, 'Comers Rock', 36.7441711425781, 0.641306767354275, -81.2363891601563, -1.41784246327616, 218, 53, 'PPL', 'P'),
(101030, 'Comertown', 38.4983291625977, 0.671922600403881, -78.5877838134766, -1.37161557939067, 218, 53, 'PPL', 'P'),
(196257, 'Comertown', 48.8969383239746, 0.853412567897955, -104.248329162598, -1.81947658359015, 218, 31, 'PPL', 'P'),
(8203, 'Comet', 33.6838912963867, 0.587894808005809, -94.2433319091797, -1.64485643986502, 218, 4, 'PPL', 'P'),
(54158, 'Comet', 37.3972206115723, 0.652704630766623, -93.6322174072266, -1.63419047969925, 218, 29, 'PPL', 'P'),
(63856, 'Comet', 36.4819412231445, 0.636729991862919, -81.5547180175781, -1.42339834994228, 218, 33, 'PPL', 'P'),
(101031, 'Comet', 36.9847183227539, 0.64550510765473, -76.7441711425781, -1.33943846815201, 218, 53, 'PPL', 'P'),
(154818, 'Comet', 40.9225006103516, 0.714232373800024, -81.5258331298828, -1.42289421354793, 218, 41, 'PPL', 'P'),
(196258, 'Comet', 46.3108291625977, 0.808276448215937, -112.169166564941, -1.95772127577617, 218, 31, 'PPL', 'P'),
(180829, 'Cometa', 37.8566703796387, 0.660723541966907, -120.944999694824, -2.11088845849822, 218, 6, 'PPL', 'P'),
(191305, 'Cometa', 28.6644401550293, 0.500288858946135, -100.018890380859, -1.74565895133728, 218, 51, 'PPL', 'P'),
(160316, 'Comettsburg', 40.4805603027344, 0.706519060334827, -80.4980621337891, -1.40495622570959, 218, 45, 'PPL', 'P'),
(63857, 'Comfort', 35.0055618286133, 0.610962310419749, -77.5091705322266, -1.35279022627712, 218, 33, 'PPL', 'P'),
(85966, 'Comfort', 35.127498626709, 0.613090509025858, -85.7422180175781, -1.49648401236954, 218, 50, 'PPL', 'P'),
(93397, 'Comfort', 29.9675006866455, 0.523031555575626, -98.9047164916992, -1.72621294853169, 218, 51, 'PPL', 'P'),
(108669, 'Comfort', 38.1302795410156, 0.665498922696555, -81.6158294677734, -1.42446494595886, 218, 58, 'PPL', 'P'),
(177420, 'Comfort', 44.7750015258789, 0.781471199212072, -92.0352783203125, -1.60631863467881, 218, 57, 'PPL', 'P'),
(20200, 'Comfort (historical)', 33.3863906860352, 0.582702442828482, -83.1413879394531, -1.45109096422136, 218, 13, 'PPL', 'P'),
(134772, 'Comfrey', 44.110279083252, 0.769869603976333, -94.9044418334961, -1.65639498476195, 218, 28, 'PPL', 'P'),
(70688, 'Comical Corners', 39.9833297729492, 0.697840750448641, -74.6836090087891, -1.30347487447547, 218, 37, 'PPL', 'P'),
(194767, 'Comical Turn', 42.5613899230957, 0.742836388383156, -116.143608093262, -2.02708836637335, 218, 17, 'PPL', 'P'),
(80444, 'Comingtee', 33.0794410705566, 0.577345161400651, -79.9172210693359, -1.3948186367041, 218, 48, 'PPL', 'P'),
(124563, 'Cominsville', 42.186939239502, 0.736300991068102, -71.8958282470703, -1.25481892135972, 218, 23, 'PPL', 'P'),
(8197, 'Cominto', 33.5455589294434, 0.585480452740571, -91.6266708374023, -1.59918708875374, 218, 4, 'PPL', 'P'),
(39856, 'Comite', 30.5111103057861, 0.532519333275142, -91.0297164916992, -1.58876826993713, 218, 22, 'PPL', 'P'),
(39857, 'Comite Estates', 30.5261096954346, 0.532781122010297, -91.0994415283203, -1.58998520139724, 218, 22, 'PPL', 'P'),
(39858, 'Comite Hills', 30.5174999237061, 0.532630853145789, -91.0500030517578, -1.58912233720406, 218, 22, 'PPL', 'P'),
(39859, 'Comite Hills West', 30.5138893127441, 0.532567836096495, -91.0622177124023, -1.58933552324932, 218, 22, 'PPL', 'P'),
(160317, 'Comly', 41.1194381713867, 0.717669582660935, -76.7291717529297, -1.33917667941685, 218, 45, 'PPL', 'P'),
(147968, 'Commack', 40.8427810668945, 0.712841005288512, -73.293327331543, -1.27920988167737, 218, 40, 'PPL', 'P'),
(26840, 'Commanche Village', 39.5922203063965, 0.691014602521577, -89.621940612793, -1.56419794572006, 218, 18, 'PPL', 'P'),
(1726, 'Commerce', 31.6816692352295, 0.552949440682548, -86.9672164916992, -1.51786426907486, 218, 2, 'PPL', 'P'),
(20202, 'Commerce', 34.2038917541504, 0.596970528105663, -83.4572219848633, -1.45660330820366, 218, 13, 'PPL', 'P'),
(54159, 'Commerce', 37.1588897705078, 0.648544972881001, -89.4427795410156, -1.56107099512615, 218, 29, 'PPL', 'P'),
(59084, 'Commerce', 34.8177795410156, 0.607684891224243, -90.3708267211914, -1.57726847403406, 218, 30, 'PPL', 'P'),
(75507, 'Commerce', 36.9333305358887, 0.644608221578619, -94.8727798461914, -1.65584237883576, 218, 42, 'PPL', 'P'),
(85967, 'Commerce', 36.1399993896484, 0.630761981018106, -86.1033325195313, -1.50278664940533, 218, 50, 'PPL', 'P'),
(93398, 'Commerce', 33.246940612793, 0.580268579908259, -95.8997192382813, -1.67376585244616, 218, 51, 'PPL', 'P'),
(130315, 'Commerce', 42.5911102294922, 0.743355105584476, -83.4908294677734, -1.45718986943375, 218, 27, 'PPL', 'P'),
(177317, 'Commerce', 41.538890838623, 0.724990412760481, -93.7644424438477, -1.63649824194186, 218, 16, 'PPL', 'P'),
(180830, 'Commerce', 34.000560760498, 0.593421732795078, -118.158889770508, -2.06226166699641, 218, 6, 'PPL', 'P'),
(186566, 'Commerce City', 39.8083305358887, 0.694786437573456, -104.933326721191, -1.83143204635574, 218, 7, 'PPL', 'P'),
(35343, 'Commerce Landing', 36.9738883972168, 0.645316089796362, -88.0280609130859, -1.53637949707948, 218, 21, 'PPL', 'P'),
(59085, 'Commerce Landing', 34.8319396972656, 0.607932032573402, -90.3847198486328, -1.57751095485131, 218, 30, 'PPL', 'P'),
(72185, 'Commercial Point', 39.7683296203613, 0.694088289893692, -83.0572204589844, -1.44962196456407, 218, 41, 'PPL', 'P'),
(29543, 'Commiskey', 38.8594398498535, 0.678225170860635, -85.6455612182617, -1.49479703297703, 218, 19, 'PPL', 'P'),
(8199, 'Commissary (historical)', 36.1083297729492, 0.63020924193386, -90.6427764892578, -1.58201489288686, 218, 4, 'PPL', 'P'),
(35344, 'Commissary Corner', 39.0086097717285, 0.680828677142296, -84.7838897705078, -1.4797580291433, 218, 21, 'PPL', 'P'),
(20203, 'Commissary Hill', 31.4497203826904, 0.548901169509519, -84.6661071777344, -1.47770233509787, 218, 13, 'PPL', 'P'),
(160318, 'Commodore', 40.7130584716797, 0.710576918887781, -78.9436111450195, -1.37782593789468, 218, 45, 'PPL', 'P'),
(101032, 'Commodore Park', 36.9366683959961, 0.644666478227465, -76.2677764892578, -1.33112381291267, 218, 53, 'PPL', 'P'),
(169327, 'Common Fence Point', 41.6438903808594, 0.726823000485591, -71.2238922119141, -1.24309142518345, 218, 47, 'PPL', 'P'),
(32134, 'Commonwealth', 37.0011100769043, 0.645791197734832, -94.7402801513672, -1.65352982290319, 218, 20, 'PPL', 'P'),
(101033, 'Commonwealth', 38.0747184753418, 0.66452919916463, -78.4875030517578, -1.36986534992227, 218, 53, 'PPL', 'P'),
(173634, 'Commonwealth', 45.9136085510254, 0.801343640687216, -88.2399978637695, -1.54007849467554, 218, 57, 'PPL', 'P'),
(20204, 'Commonwealth (historical)', 32.5397186279297, 0.567925227729905, -84.8119430541992, -1.48024765130971, 218, 13, 'PPL', 'P'),
(101034, 'Commonwealth Park', 38.4013900756836, 0.670230694163353, -78.0069427490234, -1.36147799038518, 218, 53, 'PPL', 'P'),
(203504, 'Commonwealth Square Condominium', 41.1513900756836, 0.718227248593197, -112.026390075684, -1.95522935594418, 218, 52, 'PPL', 'P'),
(115077, 'Communia', 42.7900009155273, 0.74682640290734, -91.3627777099609, -1.5945812848065, 218, 16, 'PPL', 'P'),
(108671, 'Community Acres', 39.204719543457, 0.684251438354293, -81.4938888549805, -1.42233668077372, 218, 58, 'PPL', 'P'),
(180831, 'Community Center', 34.2691688537598, 0.598109828419999, -118.736671447754, -2.07234585962205, 218, 6, 'PPL', 'P'),
(124564, 'Community Park', 42.1152801513672, 0.735050304041173, -71.908332824707, -1.25503716741105, 218, 23, 'PPL', 'P'),
(39860, 'Como', 32.0986099243164, 0.560226428492649, -91.6025009155273, -1.59876524403707, 218, 22, 'PPL', 'P'),
(54161, 'Como', 36.6199989318848, 0.639139553438196, -89.7552795410156, -1.56652514903863, 218, 29, 'PPL', 'P'),
(59087, 'Como', 34.5105590820313, 0.602322882685477, -89.9397201538086, -1.56974424500626, 218, 30, 'PPL', 'P'),
(63858, 'Como', 36.5013885498047, 0.63706941174385, -77.0097198486328, -1.34407316739707, 218, 33, 'PPL', 'P'),
(85968, 'Como', 36.2930603027344, 0.633433397907565, -88.5122222900391, -1.5448297072183, 218, 50, 'PPL', 'P'),
(93399, 'Como', 33.0605583190918, 0.577015595215754, -95.4719390869141, -1.66629968033012, 218, 51, 'PPL', 'P'),
(119208, 'Como', 41.7663917541504, 0.728961052787734, -89.7669372558594, -1.56672861454591, 218, 18, 'PPL', 'P'),
(122418, 'Como', 40.3852806091309, 0.704856115971155, -85.0869369506836, -1.48504720022625, 218, 19, 'PPL', 'P'),
(147969, 'Como', 42.6733283996582, 0.744790083358838, -76.2772216796875, -1.33128866258415, 218, 40, 'PPL', 'P'),
(173636, 'Como', 42.6122207641602, 0.743723553921289, -88.4822235107422, -1.54430612974799, 218, 57, 'PPL', 'P'),
(180832, 'Como', 33.6988906860352, 0.588156596740964, -117.792778015137, -2.05587181143493, 218, 6, 'PPL', 'P'),
(186567, 'Como', 39.3161087036133, 0.686195545950051, -105.892219543457, -1.84816788327801, 218, 7, 'PPL', 'P'),
(190062, 'Como', 39.1725006103516, 0.683689111890123, -119.475563049316, -2.08524195088465, 218, 39, 'PPL', 'P'),
(196259, 'Como', 46.0897216796875, 0.804417394638358, -114.174438476563, -1.99271987303171, 218, 31, 'PPL', 'P'),
(8200, 'Como (historical)', 33.8925018310547, 0.591535748690111, -92.3888931274414, -1.61249037734701, 218, 4, 'PPL', 'P'),
(39861, 'Como Landing', 30.9061107635498, 0.539413391810003, -91.5280609130859, -1.59746602089928, 218, 22, 'PPL', 'P'),
(203505, 'Como Springs', 41.0374984741211, 0.716239465155562, -111.654716491699, -1.94874242816096, 218, 52, 'PPL', 'P'),
(177982, 'Comobabi', 32.0580596923828, 0.559518693432961, -111.799438476563, -1.95126830329685, 218, 5, 'PPL', 'P'),
(101035, 'Comorn', 38.2802810668945, 0.668116943206157, -77.2213897705078, -1.34776750446123, 218, 53, 'PPL', 'P'),
(160319, 'Compass', 40.0224990844727, 0.698524383900464, -75.9427795410156, -1.32545154610691, 218, 45, 'PPL', 'P'),
(15593, 'Compass Lake', 30.5925006866455, 0.53393986340059, -85.3927764892578, -1.49038510715715, 218, 12, 'PPL', 'P'),
(115078, 'Competine', 41.1205596923828, 0.717689156894947, -92.2272186279297, -1.60966862501402, 218, 16, 'PPL', 'P'),
(54164, 'Competition', 37.4836082458496, 0.654212379417772, -92.4288864135742, -1.61318839186872, 218, 29, 'PPL', 'P'),
(101036, 'Compher', 39.0736083984375, 0.681963117187643, -77.5286102294922, -1.353129513, 218, 53, 'PPL', 'P'),
(59088, 'Complete', 32.3786087036133, 0.565113329092945, -88.7291717529297, -1.54861618965617, 218, 30, 'PPL', 'P'),
(63859, 'Complex', 35.5780601501465, 0.620954291092644, -80.0666732788086, -1.39742706983377, 218, 33, 'PPL', 'P'),
(177624, 'Compo', 41.1113891601563, 0.717529100913433, -73.3555603027344, -1.28029605192796, 218, 8, 'PPL', 'P'),
(26841, 'Compro', 39.5897216796875, 0.690970993258727, -89.7825012207031, -1.5670002569771, 218, 18, 'PPL', 'P'),
(59089, 'Compromise', 31.2005596160889, 0.544552493765529, -90.8863906860352, -1.58626676272522, 218, 30, 'PPL', 'P'),
(78062, 'Comps Crossroads', 39.7999992370605, 0.694641028977938, -78.7925033569336, -1.37518860946718, 218, 45, 'PPL', 'P'),
(180833, 'Comptche', 39.2649993896484, 0.685303520142929, -123.589996337891, -2.15705235862393, 218, 6, 'PPL', 'P'),
(1738, 'Compton', 33.8172187805176, 0.590221811587293, -86.6277770996094, -1.51193993407193, 218, 2, 'PPL', 'P'),
(8201, 'Compton', 36.0966682434082, 0.630005709847551, -93.3024978637695, -1.62843578805775, 218, 4, 'PPL', 'P'),
(45951, 'Compton', 38.4511108398438, 0.671098485204556, -77.1147232055664, -1.34590582170121, 218, 25, 'PPL', 'P'),
(75508, 'Compton', 34.8044395446777, 0.607452064365943, -95.021110534668, -1.65843123773143, 218, 42, 'PPL', 'P'),
(85969, 'Compton', 35.9047203063965, 0.626655586354286, -86.3288879394531, -1.50672333412868, 218, 50, 'PPL', 'P'),
(101037, 'Compton', 38.7825012207031, 0.67688233845999, -78.3691711425781, -1.36780006849691, 218, 53, 'PPL', 'P'),
(119210, 'Compton', 41.6944389343262, 0.727705239175708, -89.0811080932617, -1.55475863755239, 218, 18, 'PPL', 'P'),
(160321, 'Compton', 40.6247215270996, 0.709035148353707, -79.7405624389648, -1.39173536195206, 218, 45, 'PPL', 'P'),
(180834, 'Compton', 33.8958282470703, 0.591593805601875, -118.219169616699, -2.06331374878504, 218, 6, 'PPL', 'P'),
(8202, 'Compton (historical)', 33.9263916015625, 0.592127236768218, -93.8016662597656, -1.63714792008978, 218, 4, 'PPL', 'P'),
(54163, 'Compton (historical)', 37.2336082458496, 0.649849056287786, -93.0366668701172, -1.62379616196467, 218, 29, 'PPL', 'P'),
(1727, 'Compton Landing', 32.1288909912109, 0.560754932810975, -88.040283203125, -1.53659281628279, 218, 2, 'PPL', 'P'),
(85970, 'Compton Meadows', 35.9075012207031, 0.626704122465153, -86.3477783203125, -1.50705303347163, 218, 50, 'PPL', 'P'),
(72195, 'Compton Park', 39.2311096191406, 0.684712032064823, -84.5072174072266, -1.47492918545477, 218, 41, 'PPL', 'P'),
(20205, 'Compton Woods', 33.8388900756836, 0.590600047041112, -83.9524993896484, -1.4652475296279, 218, 13, 'PPL', 'P'),
(72187, 'Compton Woods', 39.2322196960449, 0.684731406561753, -84.4983291625977, -1.47477405632127, 218, 41, 'PPL', 'P'),
(191308, 'Comptons', 29.0886096954346, 0.507692014012878, -103.081108093262, -1.79910473283159, 218, 51, 'PPL', 'P'),
(101038, 'Comptons Bridge (historical)', 37.5966682434082, 0.656185648627466, -79.7761077880859, -1.39235574532799, 218, 53, 'PPL', 'P'),
(101039, 'Comptons Corner', 38.8097190856934, 0.677357379819432, -77.4491729736328, -1.3517430713365, 218, 53, 'PPL', 'P'),
(574, 'Comrade', 31.3216705322266, 0.546666278012238, -92.9641723632813, -1.62253089413078, 218, 22, 'PPL', 'P'),
(130316, 'Comstock', 42.2866706848145, 0.738041633156578, -85.5133285522461, -1.49248913757637, 218, 27, 'PPL', 'P'),
(134776, 'Comstock', 46.6594390869141, 0.814360839200387, -96.7480621337891, -1.68857222915867, 218, 28, 'PPL', 'P'),
(139822, 'Comstock', 48.1508293151855, 0.840390509115794, -99.3938903808594, -1.73475064351232, 218, 34, 'PPL', 'P'),
(147971, 'Comstock', 43.457218170166, 0.758471540826902, -73.4419403076172, -1.28180366742106, 218, 40, 'PPL', 'P'),
(173639, 'Comstock', 45.4777793884277, 0.793736986823677, -92.0749969482422, -1.60701185551056, 218, 57, 'PPL', 'P'),
(177363, 'Comstock', 41.5605583190918, 0.725368581635272, -99.25, -1.73223928260437, 218, 35, 'PPL', 'P'),
(191306, 'Comstock', 29.6841697692871, 0.518086498195026, -101.173057556152, -1.76580296866459, 218, 51, 'PPL', 'P'),
(200613, 'Comstock', 43.7394409179688, 0.763397257000086, -123.185279846191, -2.14998872330665, 218, 43, 'PPL', 'P'),
(190064, 'Comstock (historical)', 39.2702789306641, 0.685395665516646, -119.66056060791, -2.08847076739026, 218, 39, 'PPL', 'P'),
(180835, 'Comstock Acres', 39.1591682434082, 0.683456418189877, -120.148612976074, -2.09698888813688, 218, 6, 'PPL', 'P'),
(147970, 'Comstock Corners', 43.144718170166, 0.75301738691442, -78.7825012207031, -1.37501403925772, 218, 40, 'PPL', 'P'),
(169328, 'Comstock Gardens', 41.7775001525879, 0.729154930915092, -71.5233306884766, -1.24831761250662, 218, 47, 'PPL', 'P'),
(130317, 'Comstock Park', 43.0386085510254, 0.751165424692379, -85.6699981689453, -1.49522353822561, 218, 27, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(180836, 'Comstock Ranch', 38.0499992370605, 0.664097767068037, -120.261672973633, -2.09896215734657, 218, 6, 'PPL', 'P'),
(45944, 'Comus', 39.246940612793, 0.684988335027918, -77.3502807617188, -1.35001707663402, 218, 25, 'PPL', 'P'),
(134779, 'Comus', 44.3849983215332, 0.774664359202911, -93.2572174072266, -1.62764549500427, 218, 28, 'PPL', 'P'),
(199884, 'Comus', 41.000560760498, 0.715594780434681, -117.326110839844, -2.04772693271508, 218, 39, 'PPL', 'P'),
(45945, 'Comus Sugarloaf', 39.2555618286133, 0.685138803629508, -77.3708267211914, -1.3503756712748, 218, 25, 'PPL', 'P'),
(93400, 'Comyn', 32.0727806091309, 0.559775621899126, -98.4700012207031, -1.71862573574411, 218, 51, 'PPL', 'P'),
(169329, 'Conanicut Park', 41.5616683959961, 0.725387956132202, -71.3647232055664, -1.24554938971154, 218, 47, 'PPL', 'P'),
(375, 'Conant', 28.9375, 0.505054652295859, -81.9280624389648, -1.42991443933943, 218, 12, 'PPL', 'P'),
(8204, 'Conant', 35.1547203063965, 0.613565616964328, -91.6730575561523, -1.59999668972513, 218, 4, 'PPL', 'P'),
(26843, 'Conant', 38.0558280944824, 0.664199499821678, -89.4822235107422, -1.56175942226793, 218, 18, 'PPL', 'P'),
(154819, 'Conant', 40.7188911437988, 0.710678718220449, -84.2805633544922, -1.47097332597157, 218, 41, 'PPL', 'P'),
(193460, 'Conant', 41.1127815246582, 0.71755340225838, -122.324440002441, -2.13496423370086, 218, 6, 'PPL', 'P'),
(194768, 'Conant', 42.2761116027832, 0.737857342409144, -113.448890686035, -1.98005667520644, 218, 17, 'PPL', 'P'),
(177625, 'Conantville', 41.7386093139648, 0.728476157732258, -72.2024993896484, -1.26017134251856, 218, 8, 'PPL', 'P'),
(85972, 'Conasauga', 35.329719543457, 0.616619929839513, -84.4766693115234, -1.47439602060454, 218, 50, 'PPL', 'P'),
(20206, 'Conasauga (historical)', 34.7822189331055, 0.6070642415322, -84.5913925170898, -1.47639831827011, 218, 13, 'PPL', 'P'),
(85973, 'Conasauga Heights', 36.0316696166992, 0.628871269802205, -84.1991729736328, -1.46955279584612, 218, 50, 'PPL', 'P'),
(85974, 'Conasauga Mill', 35.3102798461914, 0.616280643116637, -84.3569412231445, -1.4723063712552, 218, 50, 'PPL', 'P'),
(160320, 'Conashaugh', 41.271110534668, 0.720316764784473, -74.8494415283203, -1.30636919794817, 218, 45, 'PPL', 'P'),
(202020, 'Conata', 43.7286109924316, 0.763208239141717, -102.188331604004, -1.78352284360965, 218, 49, 'PPL', 'P'),
(101040, 'Conaway', 37.3522186279297, 0.651919197982132, -82.2119369506836, -1.43486898423142, 218, 53, 'PPL', 'P'),
(108670, 'Conaway', 39.5074996948242, 0.689535948905338, -80.7699966430664, -1.40970237824628, 218, 58, 'PPL', 'P'),
(180837, 'Conaway', 38.6772193908691, 0.675044823886862, -121.671943664551, -2.12357602424747, 218, 6, 'PPL', 'P'),
(45946, 'Conaways', 39.0230598449707, 0.681080878497527, -76.6930618286133, -1.33854644234489, 218, 25, 'PPL', 'P'),
(93401, 'Concan', 29.4950008392334, 0.514784877523114, -99.7122192382813, -1.74030653017844, 218, 51, 'PPL', 'P'),
(93402, 'Concepcion', 27.3933296203613, 0.478103794959393, -98.3550033569336, -1.71661864438857, 218, 51, 'PPL', 'P'),
(180838, 'Concepcion', 34.4536094665527, 0.601328924387632, -120.453887939453, -2.10231694137175, 218, 6, 'PPL', 'P'),
(93403, 'Conception', 27.396110534668, 0.47815233107026, -98.3574981689453, -1.71666218707239, 218, 51, 'PPL', 'P'),
(134780, 'Conception', 44.2655601501465, 0.772579769859652, -92.1097183227539, -1.6076178578166, 218, 28, 'PPL', 'P'),
(139099, 'Conception', 40.2427787780762, 0.70236898982913, -94.6866683959961, -1.65259412125419, 218, 29, 'PPL', 'P'),
(139100, 'Conception Junction', 40.269718170166, 0.702839170919583, -94.6916732788086, -1.65268147293794, 218, 29, 'PPL', 'P'),
(39862, 'Concession', 29.8308296203613, 0.520646195476755, -90.0038909912109, -1.57086423740269, 218, 22, 'PPL', 'P'),
(80445, 'Conch Creek', 33.6655616760254, 0.587574895779864, -79.2019424438477, -1.38233466962019, 218, 48, 'PPL', 'P'),
(15594, 'Conch Key', 24.7900009155273, 0.432667137548361, -80.8897171020508, -1.41179189443755, 218, 12, 'PPL', 'P'),
(188346, 'Conchas', 35.4027786254883, 0.617895051369443, -104.189437866211, -1.81844873656744, 218, 38, 'PPL', 'P'),
(75509, 'Concho', 35.6155586242676, 0.621608762930531, -97.9941711425781, -1.7103209342008, 218, 42, 'PPL', 'P'),
(93404, 'Concho', 31.5366706848145, 0.550418738567187, -99.8111114501953, -1.74203252488092, 218, 51, 'PPL', 'P'),
(108672, 'Concho', 37.9669418334961, 0.66264814190768, -81.0880584716797, -1.41525360438049, 218, 58, 'PPL', 'P'),
(177983, 'Concho', 34.4752807617188, 0.601707159841451, -109.605278015137, -1.91297297892789, 218, 5, 'PPL', 'P'),
(207094, 'Conconully', 48.5574989318848, 0.847488232895019, -119.748611450195, -2.09000754449729, 218, 56, 'PPL', 'P'),
(698, 'Concord', 34.5536117553711, 0.603074293587043, -88.9824981689453, -1.55303756969792, 218, 30, 'PPL', 'P'),
(1732, 'Concord', 33.1349983215332, 0.578314818353549, -85.5027770996094, -1.49230497998699, 218, 2, 'PPL', 'P'),
(8206, 'Concord', 35.4705581665039, 0.619078027525656, -94.2574996948242, -1.64510371437223, 218, 4, 'PPL', 'P'),
(13583, 'Concord', 38.6419410705566, 0.674429101042836, -75.5555572509766, -1.31869324220862, 218, 10, 'PPL', 'P'),
(15596, 'Concord', 30.5636100769043, 0.533435627137697, -84.0455627441406, -1.46687179157673, 218, 12, 'PPL', 'P'),
(20209, 'Concord', 32.1399993896484, 0.560948810938333, -84.3813934326172, -1.47273314281989, 218, 13, 'PPL', 'P'),
(26844, 'Concord', 39.8166694641113, 0.694931979327029, -90.3727798461914, -1.57730256249601, 218, 18, 'PPL', 'P'),
(35351, 'Concord', 38.3144416809082, 0.668713158395199, -83.7811126708984, -1.46225626709152, 218, 21, 'PPL', 'P'),
(39867, 'Concord', 32.3133316040039, 0.563974028778609, -92.4944381713867, -1.61433248587302, 218, 22, 'PPL', 'P'),
(45948, 'Concord', 39.3691711425781, 0.687121660219126, -77.5013885498047, -1.35265440506153, 218, 25, 'PPL', 'P'),
(54167, 'Concord', 38.5244407653809, 0.67237833384542, -90.3572235107422, -1.57703105322288, 218, 29, 'PPL', 'P'),
(63865, 'Concord', 35.8797187805176, 0.626219227409676, -82.3227767944336, -1.43680350444725, 218, 33, 'PPL', 'P'),
(80447, 'Concord', 35.0499992370605, 0.611737889508207, -81.0647201538086, -1.41484627389176, 218, 48, 'PPL', 'P'),
(85979, 'Concord', 35.7413902282715, 0.623804938723465, -86.5550003051758, -1.51066973939001, 218, 50, 'PPL', 'P'),
(93412, 'Concord', 32.8252792358398, 0.572909200551934, -94.9105606079102, -1.65650177752166, 218, 51, 'PPL', 'P'),
(101044, 'Concord', 38.4730606079102, 0.671481580927363, -77.5447235107422, -1.35341074281111, 218, 53, 'PPL', 'P'),
(108673, 'Concord', 39.4147186279297, 0.687916613804515, -79.8180618286133, -1.39308798146971, 218, 58, 'PPL', 'P'),
(122420, 'Concord', 40.2933311462402, 0.703251295098273, -86.8375015258789, -1.51560031583219, 218, 19, 'PPL', 'P'),
(124565, 'Concord', 42.4602813720703, 0.741071711265842, -71.3494415283203, -1.24528267412836, 218, 23, 'PPL', 'P'),
(130319, 'Concord', 42.1777801513672, 0.73614113482367, -84.6430587768555, -1.47730006461521, 218, 27, 'PPL', 'P'),
(134781, 'Concord', 44.1474990844727, 0.77051921554523, -92.8361129760742, -1.62029583618593, 218, 28, 'PPL', 'P'),
(141536, 'Concord', 42.3836097717285, 0.739733539397105, -96.9880599975586, -1.6927609820792, 218, 35, 'PPL', 'P'),
(143653, 'Concord', 43.2080612182617, 0.754122931661939, -71.5380630493164, -1.24857474070987, 218, 36, 'PPL', 'P'),
(147974, 'Concord', 42.5352783203125, 0.742380654941616, -78.7311096191406, -1.37411708660258, 218, 40, 'PPL', 'P'),
(154822, 'Concord', 40.1430587768555, 0.700628547477736, -82.6380615234375, -1.44230626104963, 218, 41, 'PPL', 'P'),
(171872, 'Concord', 44.4288902282715, 0.775430417490472, -71.8905563354492, -1.25472690914406, 218, 55, 'PPL', 'P'),
(173637, 'Concord', 43.0694389343262, 0.751703516390629, -88.5986099243164, -1.54633745586945, 218, 57, 'PPL', 'P'),
(177403, 'Concord', 41.8925018310547, 0.731162088849658, -79.7350006103516, -1.39163828973032, 218, 45, 'PPL', 'P'),
(180840, 'Concord', 37.9780616760254, 0.662842219772119, -122.029998779297, -2.12982526490339, 218, 6, 'PPL', 'P'),
(194771, 'Concord', 45.5847206115723, 0.795603463273659, -115.682777404785, -2.0190453535652, 218, 17, 'PPL', 'P'),
(200614, 'Concord', 45.4044418334961, 0.792457005024758, -122.636390686035, -2.14040880023342, 218, 43, 'PPL', 'P'),
(45949, 'Concord (historical)', 39.4888916015625, 0.689211176410402, -75.8383331298828, -1.32362861234075, 218, 25, 'PPL', 'P'),
(54168, 'Concord (historical)', 37.5077781677246, 0.65463422413444, -89.6930618286133, -1.56543924510415, 218, 29, 'PPL', 'P'),
(63866, 'Concord (historical)', 35.7916717529297, 0.624682516881673, -81.3736114501953, -1.42023744404447, 218, 33, 'PPL', 'P'),
(85980, 'Concord (historical)', 35.6572189331055, 0.62233587248715, -87.121940612793, -1.5205647144202, 218, 50, 'PPL', 'P'),
(101045, 'Concord (historical)', 37.3622207641602, 0.652093768191586, -76.6119384765625, -1.33713057275134, 218, 53, 'PPL', 'P'),
(171873, 'Concord Corner', 44.4013900756836, 0.774950449283013, -71.8619384765625, -1.25422743328161, 218, 55, 'PPL', 'P'),
(80448, 'Concord Crossroads', 32.9919395446777, 0.575817971673545, -81.4222183227539, -1.42108579400971, 218, 48, 'PPL', 'P'),
(80449, 'Concord Estates', 33.8822212219238, 0.591356318211667, -80.3194427490234, -1.40183872933754, 218, 48, 'PPL', 'P'),
(85982, 'Concord Forest', 35.9905586242676, 0.62815374762551, -86.6902770996094, -1.51303076485442, 218, 50, 'PPL', 'P'),
(13584, 'Concord Heights', 38.6530609130859, 0.674623178907275, -75.541389465332, -1.3184459677014, 218, 10, 'PPL', 'P'),
(101046, 'Concord Heights', 38.2700004577637, 0.667937512727713, -77.4888916015625, -1.35243629216825, 218, 53, 'PPL', 'P'),
(143654, 'Concord Heights', 43.2125015258789, 0.754200429649661, -71.5102767944336, -1.24808977907536, 218, 36, 'PPL', 'P'),
(54169, 'Concord Hill', 38.6502799987793, 0.674574642796409, -91.1361083984375, -1.59062515900719, 218, 29, 'PPL', 'P'),
(13585, 'Concord Hills', 39.8338890075684, 0.695232517056044, -75.5458297729492, -1.31852346568912, 218, 10, 'PPL', 'P'),
(13586, 'Concord Manor', 39.8055610656738, 0.694738101199671, -75.5416717529297, -1.31845089454942, 218, 10, 'PPL', 'P'),
(143655, 'Concord Manor', 43.2666702270508, 0.755145851836639, -71.5833282470703, -1.24936476744724, 218, 36, 'PPL', 'P'),
(13587, 'Concord Towers', 39.6741714477539, 0.692444919764031, -75.6800003051758, -1.32086518323563, 218, 10, 'PPL', 'P'),
(32136, 'Concordia', 39.5708312988281, 0.690641293915775, -97.6622161865234, -1.70452722724933, 218, 20, 'PPL', 'P'),
(35349, 'Concordia', 38.0588912963867, 0.664252962780561, -86.4280624389648, -1.50845425567918, 218, 21, 'PPL', 'P'),
(54174, 'Concordia', 38.9833297729492, 0.680387457928697, -93.5683288574219, -1.63307541415084, 218, 29, 'PPL', 'P'),
(59090, 'Concordia', 33.9775009155273, 0.59301926257534, -90.9505615234375, -1.58738675512165, 218, 30, 'PPL', 'P'),
(93413, 'Concordia', 27.6022205352783, 0.481749629202198, -97.706672668457, -1.70530313923293, 218, 51, 'PPL', 'P'),
(145034, 'Concordia', 40.3108291625977, 0.703556693096278, -74.4486083984375, -1.29937334008064, 218, 37, 'PPL', 'P'),
(20210, 'Concordia (historical)', 34.2333297729492, 0.597484318458967, -82.7541732788086, -1.44433279348112, 218, 13, 'PPL', 'P'),
(122423, 'Concordia Gardens', 41.1455612182617, 0.718125515839556, -85.1066665649414, -1.4853915469552, 218, 19, 'PPL', 'P'),
(85984, 'Concords Woods', 35.8727798461914, 0.626098120159105, -84.1374969482422, -1.46847634613351, 218, 50, 'PPL', 'P'),
(78065, 'Concordville', 39.8849983215332, 0.696124542863166, -75.5205612182617, -1.31808244621261, 218, 45, 'PPL', 'P'),
(127141, 'Concordville', 43.170280456543, 0.753463532976036, -70.5966720581055, -1.23214436836462, 218, 26, 'PPL', 'P'),
(180839, 'Concow', 39.7458305358887, 0.69369560679096, -121.493606567383, -2.12046345472344, 218, 6, 'PPL', 'P'),
(8, 'Concrete', 29.2380599975586, 0.510300413853043, -97.2927780151367, -1.69807931477609, 218, 51, 'PPL', 'P'),
(139824, 'Concrete', 48.7455596923828, 0.850770512359514, -97.9341735839844, -1.70927377926018, 218, 34, 'PPL', 'P'),
(186568, 'Concrete', 38.3833312988281, 0.669915509048342, -104.997222900391, -1.83254724506221, 218, 7, 'PPL', 'P'),
(194769, 'Concrete', 44.355281829834, 0.774145708580618, -116.794441223145, -2.03844754737087, 218, 17, 'PPL', 'P'),
(207095, 'Concrete', 48.5394401550293, 0.847173047780008, -121.745002746582, -2.1248511457774, 218, 56, 'PPL', 'P'),
(160326, 'Concrete Bridge Crossing', 40.5372200012207, 0.707507958626601, -78.8675003051758, -1.37649755314295, 218, 45, 'PPL', 'P'),
(194770, 'Conda', 42.728328704834, 0.745750019773757, -111.531669616699, -1.94659485505792, 218, 17, 'PPL', 'P'),
(101047, 'Conde', 38.7591705322266, 0.676475141129317, -77.9241714477539, -1.36003335865186, 218, 53, 'PPL', 'P'),
(170069, 'Conde', 45.1572189331055, 0.788142151426611, -98.0972213745117, -1.71211950004299, 218, 49, 'PPL', 'P'),
(108674, 'Condee (historical)', 38.7125015258789, 0.675660613309916, -82.022216796875, -1.43155774289007, 218, 58, 'PPL', 'P'),
(180841, 'Condemned Bar (historical)', 39.3294410705566, 0.686428239650297, -121.195556640625, -2.11526150216618, 218, 6, 'PPL', 'P'),
(72192, 'Condeville', 38.9519386291504, 0.679839579113441, -81.9086074829102, -1.42957488630045, 218, 41, 'PPL', 'P'),
(108675, 'Condit', 39.5758285522461, 0.690728512441475, -80.3436126708984, -1.40226057405421, 218, 58, 'PPL', 'P'),
(130321, 'Condit', 42.1883316040039, 0.736325292413049, -84.7866668701172, -1.47980649867514, 218, 27, 'PPL', 'P'),
(154828, 'Condit', 40.2599983215332, 0.702669527558145, -82.7880630493164, -1.44492428155923, 218, 41, 'PPL', 'P'),
(160327, 'Condit Crossing', 40.065559387207, 0.699275927960084, -80.2302780151367, -1.40028251115456, 218, 45, 'PPL', 'P'),
(203509, 'Condo Shops Condominium', 40.7177810668945, 0.710659343723519, -111.952217102051, -1.95393479333829, 218, 52, 'PPL', 'P'),
(85989, 'Condon', 36.1811103820801, 0.631479503194801, -83.7938919067383, -1.46247930683281, 218, 50, 'PPL', 'P'),
(196260, 'Condon', 47.5277786254883, 0.829516223173756, -113.709716796875, -1.98460894961577, 218, 31, 'PPL', 'P'),
(200615, 'Condon', 45.2344398498535, 0.789489910675273, -120.183891296387, -2.0976046109809, 218, 43, 'PPL', 'P'),
(20211, 'Condor', 32.5424995422363, 0.567973763840771, -82.836669921875, -1.44577263152447, 218, 13, 'PPL', 'P'),
(85985, 'Condra', 35.2644386291504, 0.61548056294615, -85.466667175293, -1.49167474291502, 218, 50, 'PPL', 'P'),
(54175, 'Condray', 37.7666702270508, 0.659152742976951, -91.5547180175781, -1.59793127514171, 218, 29, 'PPL', 'P'),
(160328, 'Condron', 40.6069412231445, 0.708724823507686, -78.5086135864258, -1.37023379825908, 218, 45, 'PPL', 'P'),
(130322, 'Cone', 42.0319404602051, 0.733595752032799, -83.753059387207, -1.46176664492511, 218, 27, 'PPL', 'P'),
(191307, 'Cone', 33.7972183227539, 0.589872737747411, -101.387222290039, -1.76954084841257, 218, 51, 'PPL', 'P'),
(196261, 'Cone Butte (historical)', 47.4533309936523, 0.828216866877906, -109.408332824707, -1.90953563690893, 218, 31, 'PPL', 'P'),
(59091, 'Conehatta', 32.4511108398438, 0.566378730084896, -89.2852783203125, -1.55832208024897, 218, 30, 'PPL', 'P'),
(101050, 'Conehurst', 37.2955589294434, 0.650930299690358, -80.0227813720703, -1.39666101154621, 218, 53, 'PPL', 'P'),
(180842, 'Conejo', 36.5183296203613, 0.637365089203876, -119.718063354492, -2.08947437964706, 218, 6, 'PPL', 'P'),
(180843, 'Conejo Valley Trailer Park', 34.1830596923828, 0.59660694003784, -118.906112670898, -2.07530316685453, 218, 6, 'PPL', 'P'),
(186570, 'Conejos', 37.0883293151855, 0.647313460613922, -106.019172668457, -1.85038363330496, 218, 7, 'PPL', 'P'),
(160329, 'Conemaugh', 40.3266716003418, 0.703833195796455, -78.908332824707, -1.37721021505066, 218, 45, 'PPL', 'P'),
(59092, 'Conerby (historical)', 31.1130599975586, 0.543025337327936, -90.1263885498047, -1.57300222312581, 218, 30, 'PPL', 'P'),
(59093, 'Conerly', 31.1747207641602, 0.544101520724437, -90.289436340332, -1.57584794390861, 218, 30, 'PPL', 'P'),
(143657, 'Cones', 44.8197212219238, 0.782251705148547, -71.5663909912109, -1.24906915656624, 218, 36, 'PPL', 'P'),
(80450, 'Conestee', 34.7680587768555, 0.60681710018304, -82.3499984741211, -1.43727861238572, 218, 48, 'PPL', 'P'),
(160332, 'Conestoga', 40.142219543457, 0.70061390009174, -75.8352813720703, -1.32357534911895, 218, 45, 'PPL', 'P'),
(160333, 'Conestoga Gardens', 40.0322189331055, 0.698694027261902, -76.2774963378906, -1.33129345627411, 218, 45, 'PPL', 'P'),
(199244, 'Conestoga Mobile Home Park', 41.1444396972656, 0.718105941605544, -102.972221374512, -1.79720430107771, 218, 35, 'PPL', 'P'),
(160334, 'Conestoga Woods', 40.0377807617188, 0.698791099483635, -76.2752838134766, -1.3312548404383, 218, 45, 'PPL', 'P'),
(147975, 'Conesus', 42.7188911437988, 0.745585303260336, -77.6766662597656, -1.3557135782057, 218, 40, 'PPL', 'P'),
(147984, 'Conesus Lake Junction', 42.8555603027344, 0.747970630069693, -77.7058334350586, -1.35622264144807, 218, 40, 'PPL', 'P'),
(115086, 'Conesville', 41.3819389343262, 0.722251085263225, -91.3497161865234, -1.59435331821719, 218, 16, 'PPL', 'P'),
(147977, 'Conesville', 42.3872184753418, 0.739796523156885, -74.3766708374023, -1.29811779278472, 218, 40, 'PPL', 'P'),
(154829, 'Conesville', 40.1838912963867, 0.701341209385441, -81.89111328125, -1.42926955488147, 218, 41, 'PPL', 'P'),
(63869, 'Conetoe', 35.815559387207, 0.625099434750325, -77.4561080932617, -1.35186411200804, 218, 33, 'PPL', 'P'),
(160336, 'Coneville', 41.9038887023926, 0.731360827246005, -78.0650024414063, -1.36249132317995, 218, 45, 'PPL', 'P'),
(160335, 'Conewago', 40.1580581665039, 0.70089033621289, -76.6605606079102, -1.3379791890327, 218, 45, 'PPL', 'P'),
(160337, 'Conewago Heights', 40.0855598449707, 0.699625001799966, -76.7169418334961, -1.33896322705548, 218, 45, 'PPL', 'P'),
(147979, 'Conewango', 42.2386093139648, 0.73720280399223, -79.0313873291016, -1.37935792131175, 218, 40, 'PPL', 'P'),
(147980, 'Conewango Valley', 42.2408294677734, 0.737241552986091, -79.0611114501953, -1.3798767050921, 218, 40, 'PPL', 'P'),
(20212, 'Coney', 31.9558296203613, 0.557734442081635, -83.8838882446289, -1.46405003924374, 218, 13, 'PPL', 'P'),
(54176, 'Coney Island', 36.5930595397949, 0.638669372347742, -93.3969421386719, -1.63008415161446, 218, 29, 'PPL', 'P'),
(134783, 'Coney Island', 44.8549995422363, 0.782867427992573, -93.7611083984375, -1.63644005187204, 218, 28, 'PPL', 'P'),
(147983, 'Coney Island', 44.6061096191406, 0.778523479359518, -74.9719390869141, -1.30850718367128, 218, 40, 'PPL', 'P'),
(35350, 'Confederate', 36.9919395446777, 0.645631141753318, -87.9974975585938, -1.53584606591313, 218, 21, 'PPL', 'P'),
(180844, 'Confederate Corners', 36.644718170166, 0.639570985534789, -121.663330078125, -2.12342568880393, 218, 6, 'PPL', 'P'),
(72193, 'Confederate Crossroads (historical)', 39.836669921875, 0.695281053166911, -81.8580627441406, -1.42869271418936, 218, 41, 'PPL', 'P'),
(1734, 'Confederate Estates', 33.711109161377, 0.588369849365252, -86.5897216796875, -1.51127574169606, 218, 2, 'PPL', 'P'),
(85986, 'Confederate Glen Estates', 35.8811111450195, 0.626243528754623, -86.4630584716797, -1.50906505167519, 218, 50, 'PPL', 'P'),
(1735, 'Confederate Hill Estates', 33.2550010681152, 0.580409261392842, -87.0794372558594, -1.51982289089856, 218, 2, 'PPL', 'P'),
(45952, 'Confederate Hills', 39.4533309936523, 0.688590526718359, -77.7622222900391, -1.35720681262891, 218, 25, 'PPL', 'P'),
(8208, 'Confederate Place', 34.9555587768555, 0.61008959253053, -91.9797210693359, -1.60534897772591, 218, 4, 'PPL', 'P'),
(101048, 'Confederate Ridge', 38.2791709899902, 0.668097568709227, -77.4869384765625, -1.35240220370629, 218, 53, 'PPL', 'P'),
(101049, 'Confederate Woods', 37.0936088562012, 0.647405605987638, -77.5844421386719, -1.35410396364286, 218, 53, 'PPL', 'P'),
(15604, 'Confer', 28.9549999237061, 0.505360083583378, -81.6438903808594, -1.42495470128332, 218, 12, 'PPL', 'P'),
(26847, 'Confidence', 38.922779083252, 0.679330649029127, -88.9263916015625, -1.5520583253651, 218, 18, 'PPL', 'P'),
(108676, 'Confidence', 38.5724983215332, 0.673217096430741, -81.8288879394531, -1.42818351778894, 218, 58, 'PPL', 'P'),
(115087, 'Confidence', 40.8627815246582, 0.713190079128394, -93.1252822875977, -1.62534279276774, 218, 16, 'PPL', 'P'),
(180845, 'Confidence', 38.0475006103516, 0.664054157805187, -120.20027923584, -2.09789063448198, 218, 6, 'PPL', 'P'),
(1736, 'Confluence', 34.851390838623, 0.60827151903336, -87.2352828979492, -1.52254291047791, 218, 2, 'PPL', 'P'),
(35352, 'Confluence', 37.269718170166, 0.650479293359753, -83.3841705322266, -1.45532831983179, 218, 21, 'PPL', 'P'),
(78069, 'Confluence', 39.8127784729004, 0.694864068719232, -79.3569412231445, -1.38503990865549, 218, 45, 'PPL', 'P'),
(124567, 'Congamond', 42.0194396972656, 0.733377572560495, -72.7699966430664, -1.27007603808673, 218, 23, 'PPL', 'P'),
(80451, 'Congaree', 33.9044418334961, 0.59174414104541, -80.795280456543, -1.4101436640389, 218, 48, 'PPL', 'P'),
(80452, 'Congaree (historical)', 33.8813896179199, 0.591341803983726, -81.2355575561523, -1.41782794904822, 218, 48, 'PPL', 'P'),
(169330, 'Congdon Hill (historical)', 41.519718170166, 0.724655786569512, -71.4797210693359, -1.24755648106707, 218, 47, 'PPL', 'P'),
(115088, 'Conger', 41.3519401550293, 0.721727507792916, -93.758056640625, -1.63638678865024, 218, 16, 'PPL', 'P'),
(134784, 'Conger', 43.6150016784668, 0.761225382552099, -93.5280609130859, -1.63237260593916, 218, 28, 'PPL', 'P'),
(160340, 'Conger', 40.0272216796875, 0.698606808736202, -80.2483291625977, -1.40059756311151, 218, 45, 'PPL', 'P'),
(177984, 'Conger', 33.3730583190918, 0.582469749128236, -112.657501220703, -1.9662443233708, 218, 5, 'PPL', 'P'),
(147987, 'Conger Corners', 42.9194412231445, 0.749085562460054, -75.4113922119141, -1.31617708761071, 218, 40, 'PPL', 'P'),
(147985, 'Congers', 41.1505584716797, 0.718212734365256, -73.9458312988281, -1.29059822428883, 218, 40, 'PPL', 'P'),
(115089, 'Congers Mobile Home Park', 40.8083305358887, 0.712239730093399, -91.1305618286133, -1.59052835310157, 218, 16, 'PPL', 'P'),
(119214, 'Congerville', 40.6169395446777, 0.708899327138113, -89.2041702270508, -1.55690647697153, 218, 18, 'PPL', 'P'),
(35354, 'Congleton', 37.6091690063477, 0.656403828099771, -87.4494400024414, -1.52628065706784, 218, 21, 'PPL', 'P'),
(63870, 'Congleton', 35.7522201538086, 0.623993956581833, -77.2313919067383, -1.34794207467068, 218, 33, 'PPL', 'P'),
(1737, 'Congo', 34.3108291625977, 0.598836937976618, -85.6508331298828, -1.4948890451927, 218, 2, 'PPL', 'P'),
(8209, 'Congo', 34.6588897705078, 0.604911741581143, -92.5872192382813, -1.61595182097384, 218, 4, 'PPL', 'P'),
(72194, 'Congo', 39.6152801513672, 0.691417072741315, -82.1216735839844, -1.43329359128858, 218, 41, 'PPL', 'P'),
(160341, 'Congo', 40.350830078125, 0.704254840776042, -75.5841674804688, -1.31919258491301, 218, 45, 'PPL', 'P'),
(177204, 'Congo', 40.6083297729492, 0.708749058273605, -80.6361083984375, -1.40736558754779, 218, 58, 'PPL', 'P'),
(54177, 'Congo (historical)', 36.9391708374023, 0.644710154069342, -91.601936340332, -1.59875539034104, 218, 29, 'PPL', 'P'),
(154830, 'Congress', 40.9258308410645, 0.714290497290815, -82.0530624389648, -1.43209610090443, 218, 41, 'PPL', 'P'),
(177985, 'Congress', 34.1624984741211, 0.596248079080952, -112.849998474121, -1.96960403424399, 218, 5, 'PPL', 'P'),
(59095, 'Congress (historical)', 33.7608299255371, 0.589237640406455, -89.0819396972656, -1.55477315178033, 218, 30, 'PPL', 'P'),
(13066, 'Congress Heights', 38.8427810668945, 0.677934420248625, -77.0005569458008, -1.34391324457361, 218, 9, 'PPL', 'P'),
(160342, 'Congress Hill', 41.0991706848145, 0.717315848289145, -78.2805633544922, -1.36625357085191, 218, 45, 'PPL', 'P'),
(177986, 'Congress Junction', 34.1627807617188, 0.596253005928969, -112.844169616699, -1.96950230149035, 218, 5, 'PPL', 'P'),
(154831, 'Congress Lake (historical)', 40.9777793884277, 0.715197170483932, -81.3300018310547, -1.41947631260492, 218, 41, 'PPL', 'P'),
(13067, 'Congress Park', 38.8411102294922, 0.677905258634689, -76.9911117553711, -1.34374839490214, 218, 9, 'PPL', 'P'),
(45953, 'Congressional Manor', 38.9972190856934, 0.680629872166922, -77.1730575561523, -1.34692394818595, 218, 25, 'PPL', 'P'),
(160343, 'Congruity', 40.3983306884766, 0.705083882823384, -79.5038909912109, -1.38760466594329, 218, 45, 'PPL', 'P'),
(101051, 'Conicville', 38.8294410705566, 0.677701593390325, -78.6902770996094, -1.37340442469488, 218, 53, 'PPL', 'P'),
(147986, 'Conifer', 44.2166709899902, 0.77172649304639, -74.6133270263672, -1.30224822247738, 218, 40, 'PPL', 'P'),
(160344, 'Conifer', 41.0830612182617, 0.71703468505706, -79.1388931274414, -1.38123425145776, 218, 45, 'PPL', 'P'),
(186571, 'Conifer', 39.521110534668, 0.689773502874573, -105.304718017578, -1.83791404729093, 218, 7, 'PPL', 'P'),
(80455, 'Conifer (historical)', 33.1522216796875, 0.578615422661592, -79.7788925170898, -1.39240434801788, 218, 48, 'PPL', 'P'),
(20213, 'Conifer Place', 33.4916687011719, 0.584539890822582, -82.0747222900391, -1.43247413662116, 218, 13, 'PPL', 'P'),
(141538, 'Coniglias Mobile Home Park', 41.2261085510254, 0.719531331999982, -96.0102767944336, -1.67569544581397, 218, 35, 'PPL', 'P'),
(169331, 'Conimicut', 41.7241706848145, 0.728224156114109, -71.3833312988281, -1.24587416220647, 218, 47, 'PPL', 'P'),
(108677, 'Conings', 39.079719543457, 0.6820697767893, -80.7669372558594, -1.40964898186642, 218, 58, 'PPL', 'P'),
(20214, 'Coniston', 34.6377792358398, 0.604543293244331, -84.7091674804688, -1.47845387915749, 218, 13, 'PPL', 'P'),
(192898, 'Coniston', 38.4150009155273, 0.670468248132588, -121.559173583984, -2.12160781504384, 218, 6, 'PPL', 'P'),
(196262, 'Conkelley', 48.3894386291504, 0.844555027270406, -114.131942749023, -1.99197818266813, 218, 31, 'PPL', 'P'),
(85987, 'Conkintown', 36.4661102294922, 0.636453688899824, -82.6636123657227, -1.44275220737416, 218, 50, 'PPL', 'P'),
(54178, 'Conklin', 37.3852806091309, 0.652496238411325, -93.0188903808594, -1.62348590369768, 218, 29, 'PPL', 'P'),
(85988, 'Conklin', 36.189998626709, 0.631634632328298, -82.5405578613281, -1.44060450111307, 218, 50, 'PPL', 'P'),
(101052, 'Conklin', 38.8963890075684, 0.678870055318597, -77.5169372558594, -1.3529257811766, 218, 53, 'PPL', 'P'),
(130323, 'Conklin', 43.1288909912109, 0.752741150530352, -85.8813934326172, -1.4989130815998, 218, 27, 'PPL', 'P'),
(147988, 'Conklin', 42.0341682434082, 0.733634634184714, -75.8041687011719, -1.32303233057268, 218, 40, 'PPL', 'P'),
(147989, 'Conklin Center', 42.0561103820801, 0.734017596749468, -75.8072204589844, -1.32308559379448, 218, 40, 'PPL', 'P'),
(147990, 'Conklin Cove', 42.8422203063965, 0.747737803211392, -76.5052795410156, -1.33526902314938, 218, 40, 'PPL', 'P'),
(147991, 'Conklin Forks', 42.023609161377, 0.733450343437281, -75.8569412231445, -1.32395338483569, 218, 40, 'PPL', 'P'),
(160345, 'Conklin Hill', 41.7372207641602, 0.728451922966338, -75.0833282470703, -1.31045129126704, 218, 45, 'PPL', 'P'),
(147992, 'Conklin Station', 42.0224990844727, 0.733430968940351, -75.7975006103516, -1.32291595043305, 218, 40, 'PPL', 'P'),
(35355, 'Conkling', 37.3813896179199, 0.652428327803528, -83.6900024414063, -1.46066609360463, 218, 21, 'PPL', 'P'),
(194772, 'Conkling Park', 47.4044418334961, 0.827363590064644, -116.757217407227, -2.03779786922294, 218, 17, 'PPL', 'P'),
(147994, 'Conklingville', 43.315559387207, 0.7559991286499, -73.9352798461914, -1.29041406669945, 218, 40, 'PPL', 'P'),
(191309, 'Conlen', 36.235279083252, 0.632424925381779, -102.236938476563, -1.78437119357489, 218, 51, 'PPL', 'P'),
(20215, 'Conley', 33.644718170166, 0.587211107974959, -84.3258285522461, -1.47176335270894, 218, 13, 'PPL', 'P'),
(35356, 'Conley', 37.7516708374023, 0.658890954241796, -82.9783325195313, -1.4482451102805, 218, 21, 'PPL', 'P'),
(180846, 'Conley (historical)', 38.3030586242676, 0.668514486577879, -121.230560302734, -2.11587243132025, 218, 6, 'PPL', 'P'),
(13588, 'Conley Chapel Village Mobile Home Park', 38.6913909912109, 0.675292164973103, -75.1986083984375, -1.31246330947059, 218, 10, 'PPL', 'P'),
(85990, 'Conley Crossroads (historical)', 36.5941696166992, 0.638688746844673, -85.0541687011719, -1.48447528638216, 218, 50, 'PPL', 'P'),
(20216, 'Conley Downs', 33.6725006103516, 0.587696003030435, -84.2633285522461, -1.47067252192644, 218, 13, 'PPL', 'P'),
(143658, 'Conleys Grove', 42.8574981689453, 0.748004452215537, -71.208610534668, -1.24282470960028, 218, 36, 'PPL', 'P'),
(26848, 'Conlogue', 39.5900001525879, 0.690975853527716, -87.7930603027344, -1.53227796268464, 218, 18, 'PPL', 'P'),
(39868, 'Conn', 32.5902786254883, 0.568807666157102, -93.7716674804688, -1.63662434261948, 218, 22, 'PPL', 'P'),
(59096, 'Conn', 31.8977794647217, 0.556721275734428, -90.7099990844727, -1.58318814850509, 218, 30, 'PPL', 'P'),
(63871, 'Connaritsa', 36.1891708374023, 0.631620184679384, -77.0749969482422, -1.34521246771141, 218, 33, 'PPL', 'P'),
(160347, 'Connaughtown', 40.079719543457, 0.699523069309244, -75.3141708374023, -1.31448025452217, 218, 45, 'PPL', 'P'),
(154833, 'Conneaut', 41.9474983215332, 0.732121958685549, -80.554443359375, -1.40594026373238, 218, 41, 'PPL', 'P'),
(160348, 'Conneaut Center', 41.7122192382813, 0.728015564021729, -80.4502792358398, -1.40412225681423, 218, 45, 'PPL', 'P'),
(160349, 'Conneaut Lake', 41.603328704834, 0.726115065688821, -80.3055572509766, -1.40159638167835, 218, 45, 'PPL', 'P'),
(160350, 'Conneaut Lake Park', 41.6355590820313, 0.726677591890073, -80.3150024414063, -1.40176123134982, 218, 45, 'PPL', 'P'),
(160356, 'Conneautville', 41.7577781677246, 0.728810717344199, -80.3680572509766, -1.40268721246084, 218, 45, 'PPL', 'P'),
(160354, 'Conneautville Station', 41.7605590820313, 0.728859253455066, -80.4024963378906, -1.40328828791887, 218, 45, 'PPL', 'P'),
(112983, 'Connecticut', 41.6669387817383, 0.727225270968248, -72.6669387817383, -1.26827733908649, 218, 8, 'ADM1', 'A'),
(45954, 'Connecticut Avenue Estates', 39.0538902282715, 0.681618970195777, -77.0688934326172, -1.3451059412678, 218, 25, 'PPL', 'P'),
(45955, 'Connecticut Avenue Hills', 39.0466690063477, 0.681492936097189, -77.0800018310547, -1.34529981939516, 218, 25, 'PPL', 'P'),
(45956, 'Connecticut Avenue Park', 39.0625, 0.681769239060285, -77.0780563354492, -1.34526586409126, 218, 25, 'PPL', 'P'),
(45957, 'Connecticut Gardens', 39.047779083252, 0.68151231059412, -77.0730590820313, -1.34517864556556, 218, 25, 'PPL', 'P'),
(32139, 'Connell', 37.6194381713867, 0.656583058841133, -97.2947235107422, -1.69811327007999, 218, 20, 'PPL', 'P'),
(93414, 'Connell', 30.101390838623, 0.525368379563629, -93.9944381713867, -1.64051242465294, 218, 51, 'PPL', 'P'),
(207097, 'Connell', 46.6636085510254, 0.814433610077173, -118.860000610352, -2.0744983595731, 218, 56, 'PPL', 'P'),
(39869, 'Connells (historical)', 32.7619400024414, 0.571803722383442, -93.399169921875, -1.63012303376637, 218, 22, 'PPL', 'P'),
(8210, 'Connells Point', 34.4097213745117, 0.600562932679098, -91.0013885498047, -1.58827385408076, 218, 4, 'PPL', 'P'),
(160359, 'Connellsville', 40.0177803039551, 0.698442025643753, -79.5897216796875, -1.38910269405646, 218, 45, 'PPL', 'P'),
(147995, 'Connelly', 41.9099998474121, 0.731467486847662, -73.9916687011719, -1.29139823788029, 218, 40, 'PPL', 'P'),
(147996, 'Connelly Park', 42.1430587768555, 0.735535132517622, -79.3988876342773, -1.38577201163915, 218, 40, 'PPL', 'P'),
(63872, 'Connelly Springs', 35.7427787780762, 0.623829173489385, -81.5136108398438, -1.42268089434461, 218, 33, 'PPL', 'P'),
(139101, 'Connelsville', 40.2775001525879, 0.702974992135177, -92.6999969482422, -1.61792016333552, 218, 29, 'PPL', 'P'),
(8211, 'Conner', 36.2411117553711, 0.632526724714447, -93.4447174072266, -1.63091798735176, 218, 4, 'PPL', 'P'),
(15597, 'Conner', 29.2399997711182, 0.5103342692884, -81.9613876342773, -1.43049607372151, 218, 12, 'PPL', 'P'),
(35357, 'Conner', 38.2236099243164, 0.667127845177302, -85.3902816772461, -1.49034156447333, 218, 21, 'PPL', 'P'),
(180847, 'Conner', 35.1800003051758, 0.614006836177927, -119.11499786377, -2.07894890122879, 218, 6, 'PPL', 'P'),
(196263, 'Conner', 45.9308280944824, 0.801644178416231, -114.123611450195, -1.99183277407261, 218, 31, 'PPL', 'P'),
(200616, 'Conner Creek (historical)', 44.5722198486328, 0.777931991281411, -117.193061828613, -2.04540478940259, 218, 43, 'PPL', 'P'),
(85991, 'Conner Heights', 35.771110534668, 0.624323655924785, -83.5427780151367, -1.45809654262687, 218, 50, 'PPL', 'P'),
(80457, 'Conneross (historical)', 34.7119407653809, 0.605837656113137, -83.0702819824219, -1.44984993115338, 218, 48, 'PPL', 'P'),
(101053, 'Conners', 36.973331451416, 0.645306369258383, -80.9044418334961, -1.41204888948274, 218, 53, 'PPL', 'P'),
(45959, 'Conners Corner', 38.0094413757324, 0.663389898850294, -75.7369384765625, -1.32185894179639, 218, 25, 'PPL', 'P'),
(130324, 'Conners Creek', 42.4333305358887, 0.740601330438307, -82.9833297729492, -1.4483323288062, 218, 27, 'PPL', 'P'),
(15598, 'Conners Ford', 30.3261108398438, 0.529290483480016, -84.8638916015625, -1.48115432450283, 218, 12, 'PPL', 'P'),
(101054, 'Conners Grove', 36.7963905334473, 0.642218167658327, -80.418327331543, -1.40356459088197, 218, 53, 'PPL', 'P'),
(78071, 'Conners Mill', 39.8944396972656, 0.696289325955615, -76.1147232055664, -1.32845252918127, 218, 45, 'PPL', 'P'),
(15600, 'Connersville', 29.2752799987793, 0.51095002542194, -81.4761123657227, -1.42202642250673, 218, 12, 'PPL', 'P'),
(29544, 'Connersville', 39.6411094665527, 0.691867879334838, -85.14111328125, -1.48599275557129, 218, 19, 'PPL', 'P'),
(35358, 'Connersville', 38.3800010681152, 0.669857385557551, -84.4127807617188, -1.47328095505612, 218, 21, 'PPL', 'P'),
(160360, 'Connersville', 40.7922210693359, 0.711958566861314, -76.4255599975586, -1.33387765463787, 218, 45, 'PPL', 'P'),
(160361, 'Connerton', 40.7994384765625, 0.712084534380875, -76.2738876342773, -1.33123047251433, 218, 45, 'PPL', 'P'),
(75510, 'Connerville', 34.4474983215332, 0.601222264785975, -96.6358337402344, -1.68661347417692, 218, 42, 'PPL', 'P'),
(72196, 'Connett', 39.4113883972168, 0.687858490313724, -82.2547225952148, -1.43561573460107, 218, 41, 'PPL', 'P'),
(191310, 'Connington Colonia', 31.57200050354, 0.551035360228081, -106.217002868652, -1.85383642165825, 218, 51, 'PPL', 'P'),
(101055, 'Connistone', 37.3013916015625, 0.651032099023026, -79.9449996948242, -1.39530346518054, 218, 53, 'PPL', 'P'),
(160362, 'Connoquenessing', 40.8177795410156, 0.712404646343902, -80.0144424438477, -1.39651546979264, 218, 45, 'PPL', 'P'),
(63874, 'Connor', 35.7419395446777, 0.623814526103389, -78.1486129760742, -1.36395060229926, 218, 33, 'PPL', 'P'),
(93415, 'Connor', 30.9647197723389, 0.540436311984702, -95.8125, -1.67224358956707, 218, 51, 'PPL', 'P'),
(154836, 'Connor', 40.1888885498047, 0.701428427911141, -80.7133331298828, -1.40871341337548, 218, 41, 'PPL', 'P'),
(194773, 'Connor', 42.2811088562012, 0.737944560934844, -113.500556945801, -1.98095842155154, 218, 17, 'PPL', 'P'),
(80458, 'Connors (historical)', 33.3522186279297, 0.582106027902359, -80.3838882446289, -1.40296351542394, 218, 48, 'PPL', 'P'),
(127143, 'Connors Corner', 44.3741683959961, 0.774475341344543, -69.2819366455078, -1.20919790662223, 218, 26, 'PPL', 'P'),
(173640, 'Connorsville', 45.1361083984375, 0.787773703089799, -92.0947189331055, -1.60735606908145, 218, 57, 'PPL', 'P'),
(130325, 'Connorville', 46.5519409179688, 0.812484642212426, -89.9308319091797, -1.56958911587276, 218, 27, 'PPL', 'P'),
(154837, 'Connorville', 40.1927795410156, 0.701496338518938, -80.7133331298828, -1.40871341337548, 218, 41, 'PPL', 'P'),
(45960, 'Conococheague', 39.6572189331055, 0.692149042566923, -77.8450012207031, -1.35865157752027, 218, 25, 'PPL', 'P'),
(45961, 'Conococheaque', 39.5761108398438, 0.690733439289492, -77.7816696166992, -1.35754623250984, 218, 25, 'PPL', 'P'),
(63876, 'Conoho', 35.9833297729492, 0.628027580368868, -77.3116683959961, -1.34934316372018, 218, 33, 'PPL', 'P'),
(93416, 'Conoley', 30.5580596923828, 0.533338754653046, -97.1705627441406, -1.69594625590099, 218, 51, 'PPL', 'P'),
(29546, 'Conologue', 38.9755592346191, 0.680251836450185, -85.7991714477539, -1.49747803724642, 218, 19, 'PPL', 'P'),
(35359, 'Conoloway', 37.3680610656738, 0.652195700682309, -86.2155609130859, -1.50474540438708, 218, 21, 'PPL', 'P'),
(154838, 'Conotton', 40.4172210693359, 0.705413582166335, -81.1466674804688, -1.41627652455519, 218, 41, 'PPL', 'P'),
(63880, 'Conover', 35.7063903808594, 0.623194076148428, -81.2188873291016, -1.41753699869913, 218, 33, 'PPL', 'P'),
(115091, 'Conover', 43.2163887023926, 0.75426827367843, -91.897216796875, -1.60390900652451, 218, 16, 'PPL', 'P'),
(119216, 'Conover', 40.1772193908691, 0.701224762666777, -90.0238876342773, -1.57121324466355, 218, 18, 'PPL', 'P'),
(154839, 'Conover', 40.1352806091309, 0.700492792841169, -84.04638671875, -1.46688617264662, 218, 41, 'PPL', 'P'),
(173641, 'Conover', 46.0547218322754, 0.803806532063321, -89.2577819824219, -1.55784217862053, 218, 57, 'PPL', 'P'),
(70691, 'Conovertown', 39.4397201538086, 0.688352972749124, -74.478889465332, -1.29990184439896, 218, 37, 'PPL', 'P'),
(45962, 'Conowingo', 39.6777801513672, 0.692507903523812, -76.1594390869141, -1.32923296853871, 218, 25, 'PPL', 'P'),
(45963, 'Conowingo (historical)', 39.6833305358887, 0.692604776008463, -76.1936111450195, -1.32982938346484, 218, 25, 'PPL', 'P'),
(45964, 'Conowingo Manor', 39.6711082458496, 0.692391456805148, -76.1575012207031, -1.32919914639287, 218, 25, 'PPL', 'P'),
(45965, 'Conowingo Mobile Home Park', 39.6800003051758, 0.692546652517672, -76.1877822875977, -1.3297276507112, 218, 25, 'PPL', 'P'),
(45966, 'Conowingo Village', 39.6522216796875, 0.692061824041223, -76.1802825927734, -1.32959675634362, 218, 25, 'PPL', 'P'),
(160366, 'Conpitt Junction', 40.3758316040039, 0.704691199720652, -79.102783203125, -1.3806040143858, 218, 45, 'PPL', 'P'),
(147997, 'Conquest', 43.1211090087891, 0.752605329314758, -76.6483306884766, -1.33776573667133, 218, 40, 'PPL', 'P'),
(45967, 'Conquest Beach', 39.0938911437988, 0.682317117875542, -76.1241683959961, -1.32861737885274, 218, 25, 'PPL', 'P'),
(93418, 'Conquista Crossing', 28.9424991607666, 0.505141904111073, -98.0569381713867, -1.71141642551521, 218, 51, 'PPL', 'P'),
(15601, 'Conrad', 29.1588897705078, 0.508918632721455, -81.383056640625, -1.42040229371594, 218, 12, 'PPL', 'P'),
(26849, 'Conrad', 38.9252815246582, 0.679374324871004, -90.616943359375, -1.58156401971431, 218, 18, 'PPL', 'P'),
(115092, 'Conrad', 42.2247200012207, 0.736960389754005, -92.8744430541992, -1.62096482225175, 218, 16, 'PPL', 'P'),
(122424, 'Conrad', 41.1049995422363, 0.717417581042786, -87.4433288574219, -1.52617399746618, 218, 19, 'PPL', 'P'),
(160367, 'Conrad', 41.6100006103516, 0.726231512407485, -77.8908309936523, -1.35945145795368, 218, 45, 'PPL', 'P'),
(190968, 'Conrad', 36.6152801513672, 0.639057195181485, -102.373062133789, -1.78674699958335, 218, 42, 'PPL', 'P'),
(196264, 'Conrad', 48.170280456543, 0.840729995575752, -111.945281982422, -1.95381375266675, 218, 31, 'PPL', 'P'),
(54180, 'Conrads Mill', 37.5063896179199, 0.654609989368521, -89.8605575561523, -1.56836259703273, 218, 29, 'PPL', 'P'),
(54179, 'Conran', 36.4833297729492, 0.636754226628839, -89.6466674804688, -1.56462951097471, 218, 29, 'PPL', 'P'),
(35360, 'Conrard', 37.1808280944824, 0.648927868866728, -84.3574981689453, -1.47231609179318, 218, 21, 'PPL', 'P'),
(173643, 'Conrath', 45.3861083984375, 0.792137026219785, -91.0380630493164, -1.58891394484876, 218, 57, 'PPL', 'P'),
(15602, 'Conrock', 28.5541706085205, 0.498364292294876, -82.341667175293, -1.4371332037902, 218, 12, 'PPL', 'P'),
(93417, 'Conroe', 30.3116703033447, 0.529038448572354, -95.4558334350586, -1.66601858367706, 218, 51, 'PPL', 'P'),
(115093, 'Conroy', 41.7291717529297, 0.728311441218837, -91.9974975585938, -1.60565923599291, 218, 16, 'PPL', 'P'),
(75512, 'Conser', 34.8402786254883, 0.608077574326975, -94.6847229003906, -1.65256016595029, 218, 42, 'PPL', 'P'),
(160368, 'Conshohocken', 40.0791702270508, 0.699513481929319, -75.3019409179688, -1.3142668021608, 218, 45, 'PPL', 'P'),
(160369, 'Conshohocken Station', 40.0602798461914, 0.699183782586368, -75.3394393920898, -1.31492127399868, 218, 45, 'PPL', 'P'),
(139826, 'Considine', 48.561939239502, 0.84756573088274, -99.2827835083008, -1.73281146276458, 218, 34, 'PPL', 'P'),
(115094, 'Consol', 41.0713882446289, 0.716830953233669, -93.0016708374023, -1.62318536596866, 218, 16, 'PPL', 'P'),
(72197, 'Consol (historical)', 39.5072212219238, 0.689531088636348, -82.1894378662109, -1.43447630112868, 218, 41, 'PPL', 'P'),
(108678, 'Consol Number 9', 39.5397186279297, 0.690098275369508, -80.2552795410156, -1.40071887009917, 218, 58, 'PPL', 'P'),
(35361, 'Consolation', 38.2566719055176, 0.667704885606495, -85.0427780151367, -1.48427648140678, 218, 21, 'PPL', 'P'),
(147999, 'Constable', 44.9291687011719, 0.784161924019434, -74.2975006103516, -1.29673601165313, 218, 40, 'PPL', 'P'),
(148001, 'Constableville', 43.5666694641113, 0.760381826276816, -75.4288864135742, -1.31648241902969, 218, 40, 'PPL', 'P'),
(35362, 'Constance', 39.0738906860352, 0.681968044035659, -84.6374969482422, -1.47720299239348, 218, 21, 'PPL', 'P'),
(134787, 'Constance', 45.2552795410156, 0.789853631901151, -93.2852783203125, -1.62813525032874, 218, 28, 'PPL', 'P'),
(141540, 'Constance', 42.7069396972656, 0.745376711167956, -97.4355621337891, -1.70057136776613, 218, 35, 'PPL', 'P'),
(8212, 'Constance (historical)', 33.5297203063965, 0.585204016619421, -91.4102783203125, -1.59541032685384, 218, 4, 'PPL', 'P'),
(45968, 'Constance Acres', 39.5327796936035, 0.689977168118936, -76.9322204589844, -1.34272054787942, 218, 25, 'PPL', 'P'),
(39870, 'Constance Beach', 29.7591705322266, 0.519395508449827, -93.5794372558594, -1.63326929227819, 218, 22, 'PPL', 'P'),
(101056, 'Constances Warehouse (historical)', 36.8397216796875, 0.642974438828883, -76.5319366455078, -1.33573427739182, 218, 53, 'PPL', 'P'),
(45969, 'Constant Branch', 39.4736099243164, 0.688944460827231, -76.3222198486328, -1.33207402878961, 218, 25, 'PPL', 'P'),
(45970, 'Constant Friendship', 39.4702796936035, 0.68888633733644, -76.3111114501953, -1.33188015066225, 218, 25, 'PPL', 'P'),
(148002, 'Constantia', 43.2477798461914, 0.754816152493687, -76.0005569458008, -1.32645995205367, 218, 40, 'PPL', 'P'),
(148003, 'Constantia Center', 43.2805595397949, 0.755388266074863, -75.9222183227539, -1.32509268515002, 218, 40, 'PPL', 'P'),
(20218, 'Constantine', 34.2486114501953, 0.597751034042138, -83.6519393920898, -1.46000176807071, 218, 13, 'PPL', 'P'),
(35363, 'Constantine', 37.6752815246582, 0.657557709221075, -86.2363891601563, -1.50510892587587, 218, 21, 'PPL', 'P'),
(130326, 'Constantine', 41.8411102294922, 0.730265136194519, -85.6686096191406, -1.49519930345969, 218, 27, 'PPL', 'P'),
(177987, 'Constellation', 34.0633316040039, 0.594517290688509, -112.581672668457, -1.96492086546709, 218, 5, 'PPL', 'P'),
(20219, 'Constitution', 33.6888885498047, 0.587982026531509, -84.3424987792969, -1.47205430305803, 218, 13, 'PPL', 'P'),
(72198, 'Constitution', 39.3480606079102, 0.686753211882314, -81.5547180175781, -1.42339834994228, 218, 41, 'PPL', 'P'),
(45971, 'Constitution Hills', 38.6313896179199, 0.674244943453457, -76.9349975585938, -1.34276901741126, 218, 25, 'PPL', 'P'),
(39871, 'Consuella (historical)', 31.764440536499, 0.554394072415862, -91.4349975585938, -1.59584175895044, 218, 22, 'PPL', 'P'),
(1740, 'Consul', 32.2641716003418, 0.563116024854412, -87.5400009155273, -1.5278612431748, 218, 2, 'PPL', 'P'),
(192528, 'Consumers', 39.7005615234375, 0.69290551347456, -111.061943054199, -1.93839657995822, 218, 52, 'PPL', 'P'),
(196265, 'Contact', 45.5083312988281, 0.794270218252938, -110.225280761719, -1.92379406822716, 218, 31, 'PPL', 'P'),
(199886, 'Contact', 41.7694396972656, 0.729014249430509, -114.751670837402, -2.00279447827743, 218, 39, 'PPL', 'P'),
(45972, 'Conte Manor', 38.7966690063477, 0.677129612967203, -76.6374969482422, -1.33757665223393, 218, 25, 'PPL', 'P'),
(45973, 'Contee', 39.0788917541504, 0.682055329140387, -76.8658294677734, -1.34156180648913, 218, 25, 'PPL', 'P'),
(177988, 'Contempo Tempe', 33.3902816772461, 0.582770353436279, -111.972221374512, -1.9542839337572, 218, 5, 'PPL', 'P'),
(141541, 'Contempo-Lincoln Mobile Home Park', 40.848331451416, 0.712937877773164, -96.7236099243164, -1.68814545759398, 218, 35, 'PPL', 'P'),
(160371, 'Content', 41.1100006103516, 0.717504866147513, -79.1447219848633, -1.38133598421141, 218, 45, 'PPL', 'P'),
(196266, 'Content', 48.0205612182617, 0.838116901914166, -107.559722900391, -1.87727130714456, 218, 31, 'PPL', 'P'),
(177989, 'Contention', 31.7688903808594, 0.554471736851151, -110.201393127441, -1.9233771503585, 218, 5, 'PPL', 'P'),
(63879, 'Contentnea', 35.5016708374023, 0.619621046071923, -77.7311096191406, -1.35666379408264, 218, 33, 'PPL', 'P'),
(63881, 'Contentnea Junction', 35.6780586242676, 0.622699593713028, -77.9327774047852, -1.36018356093734, 218, 33, 'PPL', 'P'),
(199246, 'Conterra', 42.4474983215332, 0.740848604945521, -100.629173278809, -1.75631039727511, 218, 35, 'PPL', 'P'),
(154840, 'Continental', 41.1002807617188, 0.717335222786075, -84.2663879394531, -1.4707259183063, 218, 41, 'PPL', 'P'),
(177990, 'Continental', 31.8522205352783, 0.555926122411957, -110.974166870117, -1.93686459654116, 218, 5, 'PPL', 'P'),
(188347, 'Continental Divide', 35.4249992370605, 0.618282874203186, -108.314720153809, -1.89044849506022, 218, 38, 'PPL', 'P'),
(203513, 'Continental Estates', 40.6555595397949, 0.709573373210012, -111.964721679688, -1.95415303938962, 218, 52, 'PPL', 'P'),
(78073, 'Continental Number 2', 39.8786087036133, 0.696013022992519, -79.76611328125, -1.39218130827659, 218, 45, 'PPL', 'P'),
(177991, 'Continental Tempe', 33.351390838623, 0.582091580253445, -111.912780761719, -1.95324649935456, 218, 5, 'PPL', 'P'),
(203515, 'Continental Townhouse Condominium', 40.8763885498047, 0.713427566518602, -111.886390686035, -1.95278590564403, 218, 52, 'PPL', 'P'),
(148005, 'Continental Village', 41.3400001525879, 0.721519115437617, -73.904167175293, -1.28987104815318, 218, 40, 'PPL', 'P'),
(177992, 'Continental Village', 33.5694389343262, 0.585897237451168, -111.858062744141, -1.95229148978766, 218, 5, 'PPL', 'P'),
(143659, 'Contoocook', 43.2219390869141, 0.754365146163082, -71.7144393920898, -1.25165308861389, 218, 36, 'PPL', 'P'),
(203516, 'Contoy Estates', 40.6358299255371, 0.709229026481065, -111.932777404785, -1.95359550661541, 218, 52, 'PPL', 'P'),
(101057, 'Contra', 37.7605590820313, 0.659046083375293, -76.8438873291016, -1.34117884392437, 218, 53, 'PPL', 'P'),
(59098, 'Contrell', 32.5466690063477, 0.568046534717558, -89.6177825927734, -1.56412537458036, 218, 30, 'PPL', 'P'),
(39872, 'Contreras', 29.8652801513672, 0.521247470671868, -89.7866668701172, -1.56707296127486, 218, 22, 'PPL', 'P'),
(72199, 'Contreras', 39.523609161377, 0.689817112137423, -84.8116683959961, -1.48024285761975, 218, 41, 'PPL', 'P'),
(188348, 'Contreras', 34.3827781677246, 0.600092685009618, -106.813056945801, -1.86423952782442, 218, 38, 'PPL', 'P'),
(1741, 'Contwell', 31.7080593109131, 0.553410034393078, -88.4286117553711, -1.54337042809899, 218, 2, 'PPL', 'P'),
(127144, 'Convene', 43.8877792358398, 0.765986249053806, -70.728889465332, -1.23445199744918, 218, 26, 'PPL', 'P'),
(39873, 'Convent', 30.0205593109131, 0.523957603265673, -90.829719543457, -1.58527766469637, 218, 22, 'PPL', 'P'),
(39874, 'Converse', 31.7813892364502, 0.554689883033943, -93.6936111450195, -1.63526200256385, 218, 22, 'PPL', 'P'),
(54182, 'Converse', 39.4988899230957, 0.68938568004083, -94.2761077880859, -1.64542848686717, 218, 29, 'PPL', 'P'),
(80460, 'Converse', 34.9919395446777, 0.610724556713432, -81.8349990844727, -1.42829017739059, 218, 48, 'PPL', 'P'),
(93419, 'Converse', 29.5177803039551, 0.515182454184349, -98.3158264160156, -1.71593487777869, 218, 51, 'PPL', 'P'),
(122426, 'Converse', 40.5774993896484, 0.708210966575355, -85.8733291625977, -1.49877233353619, 218, 19, 'PPL', 'P'),
(148006, 'Converse', 44.6802787780762, 0.779817975386378, -74.8249969482422, -1.30594255954154, 218, 40, 'PPL', 'P'),
(154841, 'Converse', 40.7430610656738, 0.711100562937118, -84.416389465332, -1.4733439388159, 218, 41, 'PPL', 'P'),
(39875, 'Converse (historical)', 30.8813896179199, 0.538981926423896, -91.3586120605469, -1.59450858050874, 218, 22, 'PPL', 'P'),
(80461, 'Converse Heights', 34.9500007629395, 0.609992586887824, -81.9127807617188, -1.42964772375626, 218, 48, 'PPL', 'P'),
(154842, 'Converse Station', 40.7277793884277, 0.710833847353947, -84.4161071777344, -1.47333901196788, 218, 41, 'PPL', 'P'),
(143660, 'Converseville', 42.7391700744629, 0.745939237369208, -71.980827331543, -1.25630243524495, 218, 36, 'PPL', 'P'),
(93420, 'Conville', 31.4361095428467, 0.548663615540284, -94.0627822875977, -1.64170525450518, 218, 51, 'PPL', 'P'),
(8214, 'Conville (historical)', 36.2644386291504, 0.632933855466093, -92.4527816772461, -1.61360544289543, 218, 4, 'PPL', 'P'),
(154843, 'Convoy', 40.9166717529297, 0.714130641046383, -84.7027816772461, -1.47834242586587, 218, 41, 'PPL', 'P'),
(8215, 'Conway', 35.0886116027832, 0.612411802422052, -92.4419403076172, -1.61341622529998, 218, 4, 'PPL', 'P'),
(15603, 'Conway', 28.5025005340576, 0.497462479370748, -81.3308334350586, -1.41949082683286, 218, 12, 'PPL', 'P'),
(32144, 'Conway', 38.3694381713867, 0.669673028231091, -97.7861099243164, -1.70668958089642, 218, 20, 'PPL', 'P'),
(35364, 'Conway', 37.4777793884277, 0.654110646664131, -84.3344421386719, -1.47191368815247, 218, 21, 'PPL', 'P'),
(39876, 'Conway', 32.8883285522461, 0.574009618714354, -92.3969421386719, -1.61263085909452, 218, 22, 'PPL', 'P'),
(54181, 'Conway', 37.5019416809082, 0.654532358222745, -92.8208312988281, -1.62002912060276, 218, 29, 'PPL', 'P'),
(59099, 'Conway', 32.8561096191406, 0.573447292250184, -89.5899963378906, -1.56364041294585, 218, 30, 'PPL', 'P'),
(63883, 'Conway', 36.436939239502, 0.635944559078428, -77.2291717529297, -1.34790332567682, 218, 33, 'PPL', 'P'),
(80462, 'Conway', 33.8358306884766, 0.590546650661256, -79.0480575561523, -1.37964887166084, 218, 48, 'PPL', 'P'),
(85992, 'Conway', 35.0911102294922, 0.612455411684902, -86.95361328125, -1.51762684826368, 218, 50, 'PPL', 'P'),
(115095, 'Conway', 40.7486114501953, 0.71119743542177, -94.6186065673828, -1.65140621824996, 218, 16, 'PPL', 'P'),
(124568, 'Conway', 42.5097198486328, 0.741934575459028, -72.6999969482422, -1.26885431293666, 218, 23, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(130329, 'Conway', 45.4166717529297, 0.792670457386128, -84.866943359375, -1.48120758772463, 218, 27, 'PPL', 'P'),
(139827, 'Conway', 48.2383308410645, 0.8419176988429, -97.6747207641602, -1.70474547330067, 218, 34, 'PPL', 'P'),
(143661, 'Conway', 43.9791717529297, 0.767581349388709, -71.1208267211914, -1.24129259302515, 218, 36, 'PPL', 'P'),
(160372, 'Conway', 40.6597213745117, 0.709646010928744, -80.2394409179688, -1.40044243397802, 218, 45, 'PPL', 'P'),
(191311, 'Conway', 35.2077789306641, 0.614491664654376, -101.380828857422, -1.76942926196289, 218, 51, 'PPL', 'P'),
(207098, 'Conway', 48.3405609130859, 0.843701950194226, -122.341667175293, -2.13526490458793, 218, 56, 'PPL', 'P'),
(72200, 'Conway Addition', 39.7513885498047, 0.693792612433666, -82.0883331298828, -1.4327116905904, 218, 41, 'PPL', 'P'),
(93421, 'Conway Plaza Colonia', 26.2259998321533, 0.457730046698556, -98.322998046875, -1.71606004634992, 218, 51, 'PPL', 'P'),
(32140, 'Conway Springs', 37.3902816772461, 0.652583523516052, -97.6419372558594, -1.70417329314046, 218, 20, 'PPL', 'P'),
(26850, 'Conwayville (historical)', 39.2361106872559, 0.68479931716955, -90.399169921875, -1.57776315620654, 218, 18, 'PPL', 'P'),
(20220, 'Conyers', 33.6674995422363, 0.587608717925708, -84.0177764892578, -1.46638682994223, 218, 13, 'PPL', 'P'),
(85993, 'Conyersville', 36.4497184753418, 0.636167598819722, -88.2941665649414, -1.54102391686252, 218, 50, 'PPL', 'P'),
(160374, 'Conyngham', 40.9919395446777, 0.715444311833092, -76.0569381713867, -1.32744399007645, 218, 45, 'PPL', 'P'),
(101058, 'Coocheyville', 37.6474990844727, 0.657072814165599, -75.8525009155273, -1.32387588684797, 218, 53, 'PPL', 'P'),
(39878, 'Coochie (historical)', 31.0952796936035, 0.542715012481915, -91.6222229003906, -1.59910945760797, 218, 22, 'PPL', 'P'),
(93422, 'Coody Crossing', 33.1005592346191, 0.577713742895518, -99.4711074829102, -1.73609833618195, 218, 51, 'PPL', 'P'),
(75513, 'Coodys Bluff', 36.6983299255371, 0.640506687183788, -95.5638885498047, -1.667904501203, 218, 42, 'PPL', 'P'),
(15605, 'Cooglers Beach', 28.5530605316162, 0.498344917797945, -82.6502838134766, -1.44251958025294, 218, 12, 'PPL', 'P'),
(15606, 'Cook', 30.1238899230957, 0.525761062666361, -85.5177764892578, -1.49256676872215, 218, 12, 'PPL', 'P'),
(32142, 'Cook', 39.5472183227539, 0.690229169737085, -97.6116714477539, -1.70364505513825, 218, 20, 'PPL', 'P'),
(72201, 'Cook', 39.6830596923828, 0.692600048897528, -83.3072204589844, -1.45398528769406, 218, 41, 'PPL', 'P'),
(75514, 'Cook', 34.271110534668, 0.59814371714487, -96.1969375610352, -1.67895329077547, 218, 42, 'PPL', 'P'),
(80463, 'Cook', 33.642219543457, 0.587167498712109, -79.4844436645508, -1.38726524606236, 218, 48, 'PPL', 'P'),
(93423, 'Cook', 33.6119384765625, 0.586638994393783, -97.1275024414063, -1.69519471184137, 218, 51, 'PPL', 'P'),
(122427, 'Cook', 41.3772201538086, 0.722168727006514, -87.4697189331055, -1.52663459117671, 218, 19, 'PPL', 'P'),
(134788, 'Cook', 47.8525009155273, 0.835183696289553, -92.6894378662109, -1.61773587258809, 218, 28, 'PPL', 'P'),
(141542, 'Cook', 40.5097198486328, 0.707027990419142, -96.163330078125, -1.67836672954538, 218, 35, 'PPL', 'P'),
(200617, 'Cook', 45.4022216796875, 0.792418256030897, -122.731941223145, -2.14207647170803, 218, 43, 'PPL', 'P'),
(207099, 'Cook', 45.7105598449707, 0.797799772224647, -121.658889770508, -2.12334819081621, 218, 56, 'PPL', 'P'),
(39877, 'Cook (historical)', 31.9750003814697, 0.55806903498309, -93.8375015258789, -1.63777336347179, 218, 22, 'PPL', 'P'),
(80464, 'Cook Corner', 33.4197196960449, 0.583284143789582, -79.6272201538086, -1.38975716589435, 218, 48, 'PPL', 'P'),
(192529, 'Cook Corner', 38.2949981689453, 0.668373805093295, -113.046669006348, -1.97303658257299, 218, 52, 'PPL', 'P'),
(148009, 'Cook Corners', 44.2419395446777, 0.772167512522907, -74.8852767944336, -1.30699464133017, 218, 40, 'PPL', 'P'),
(20223, 'Cook Heights', 31.7975006103516, 0.554971079555541, -82.353889465332, -1.43734652299352, 218, 13, 'PPL', 'P'),
(80465, 'Cook Landing', 32.1949996948242, 0.561908747353252, -81.0005569458008, -1.41372641465339, 218, 48, 'PPL', 'P'),
(85995, 'Cook Mill', 35.6936111450195, 0.622971036407134, -84.5352783203125, -1.47541894077923, 218, 50, 'PPL', 'P'),
(127145, 'Cook Mills', 43.9855613708496, 0.767692869259356, -70.5569381713867, -1.23145088121677, 218, 26, 'PPL', 'P'),
(108679, 'Cook Mine', 39.3455581665039, 0.686709536040437, -80.3011093139648, -1.40151875053257, 218, 58, 'PPL', 'P'),
(54183, 'Cook Station', 37.8127784729004, 0.659957483679345, -91.4377822875977, -1.59589036164033, 218, 29, 'PPL', 'P'),
(72202, 'Cook Subdivision', 38.7930603027344, 0.677066629207423, -82.2350006103516, -1.43527152103018, 218, 41, 'PPL', 'P'),
(160382, 'Cook Tomb', 41.3286094665527, 0.721320310462243, -79.1966705322266, -1.38224265740452, 218, 45, 'PPL', 'P'),
(196267, 'Cooke City', 45.0166702270508, 0.785689113746539, -109.933326721191, -1.91869850895545, 218, 31, 'PPL', 'P'),
(80466, 'Cooke Crossroads', 32.9480590820313, 0.575052113123066, -80.2058334350586, -1.39985587274793, 218, 48, 'PPL', 'P'),
(13068, 'Cookes Park', 38.9113883972168, 0.679131844053752, -77.0605621337891, -1.34496053267229, 218, 9, 'PPL', 'P'),
(119218, 'Cookes Subdivision', 41.6674995422363, 0.727235058085254, -87.6252822875977, -1.52934968390805, 218, 18, 'PPL', 'P'),
(85996, 'Cookeville', 36.1627807617188, 0.631159590968855, -85.5016708374023, -1.49228567206909, 218, 50, 'PPL', 'P'),
(75515, 'Cookietown', 34.2750015258789, 0.598211627752667, -98.4530563354492, -1.71832999170505, 218, 42, 'PPL', 'P'),
(139102, 'Cookman', 40.2386093139648, 0.702296218952343, -93.2736129760742, -1.6279316516634, 218, 29, 'PPL', 'P'),
(160380, 'Cookport', 40.6994400024414, 0.710339231760492, -78.9122161865234, -1.3772779925004, 218, 45, 'PPL', 'P'),
(1742, 'Cooks', 32.4113883972168, 0.565685442674121, -86.1466674804688, -1.50354298715491, 218, 2, 'PPL', 'P'),
(130331, 'Cooks', 45.917781829834, 0.80141647814303, -86.4761123657227, -1.50929288510644, 218, 27, 'PPL', 'P'),
(160381, 'Cooks', 40.2113914489746, 0.7018211775929, -78.0875015258789, -1.36288400628268, 218, 45, 'PPL', 'P'),
(124570, 'Cooks Brook Beach', 41.8644409179688, 0.730672333525192, -70.0083312988281, -1.22187588499155, 218, 23, 'PPL', 'P'),
(85997, 'Cooks Corner', 35.9397201538086, 0.627266448929323, -86.4847183227539, -1.50944308739192, 218, 50, 'PPL', 'P'),
(101059, 'Cooks Corner', 37.601390838623, 0.656268073463204, -76.5663909912109, -1.33633561916596, 218, 53, 'PPL', 'P'),
(124571, 'Cooks Corner', 42.2777786254883, 0.737886437444053, -72.470832824707, -1.26485464445352, 218, 23, 'PPL', 'P'),
(127147, 'Cooks Corner', 44.6788902282715, 0.779793740620458, -69.2802810668945, -1.2091690113244, 218, 26, 'PPL', 'P'),
(169332, 'Cooks Corner', 41.6044387817383, 0.726134440185751, -71.5219421386719, -1.2482933777407, 218, 47, 'PPL', 'P'),
(130332, 'Cooks Corners', 43.0883293151855, 0.752033215733581, -85.2624969482422, -1.48811130021844, 218, 27, 'PPL', 'P'),
(20224, 'Cooks Crossing', 33.6266708374023, 0.58689612259703, -84.4744415283203, -1.47435713845262, 218, 13, 'PPL', 'P'),
(63884, 'Cooks Crossing', 35.4483299255371, 0.618690071533859, -80.6149978637695, -1.40699713921097, 218, 33, 'PPL', 'P'),
(143663, 'Cooks Crossing', 44.0897216796875, 0.769510809598472, -71.2061080932617, -1.2427810337584, 218, 36, 'PPL', 'P'),
(1743, 'Cooks Crossroads', 31.5680599212646, 0.55096658409293, -86.9763870239258, -1.51802432505638, 218, 2, 'PPL', 'P'),
(80467, 'Cooks Crossroads', 34.7241706848145, 0.606051108474506, -82.1655578613281, -1.43405951641809, 218, 48, 'PPL', 'P'),
(148010, 'Cooks Falls', 41.9477806091309, 0.732126885533566, -74.980827331543, -1.30866231280478, 218, 40, 'PPL', 'P'),
(15607, 'Cooks Hammock', 29.9294395446777, 0.522367263331219, -83.2766723632813, -1.45345212284383, 218, 12, 'PPL', 'P'),
(45974, 'Cooks Hope', 38.7422218322754, 0.676179330511236, -76.0888900756836, -1.32800165600872, 218, 25, 'PPL', 'P'),
(59100, 'Cooks Landing', 34.9311103820801, 0.609662887544872, -88.1666717529297, -1.5387987126137, 218, 30, 'PPL', 'P'),
(130333, 'Cooks Mill', 42.2200012207031, 0.736878031497295, -85.4238891601563, -1.49092812570342, 218, 27, 'PPL', 'P'),
(148011, 'Cooks Mill', 44.9627799987793, 0.784748551828551, -74.1311111450195, -1.29383196764245, 218, 40, 'PPL', 'P'),
(881, 'Cooks Mills', 39.7486114501953, 0.693744142901826, -78.7425003051758, -1.37431589157796, 218, 45, 'PPL', 'P'),
(26851, 'Cooks Mills', 39.5825004577637, 0.690844959160139, -88.4061126708984, -1.54297774499626, 218, 18, 'PPL', 'P'),
(145035, 'Cooks Mills', 40.2891693115234, 0.703178657379541, -74.1138916015625, -1.29353142991344, 218, 37, 'PPL', 'P'),
(93425, 'Cooks Point', 30.5956993103027, 0.533995689914941, -96.6093902587891, -1.68615194836001, 218, 51, 'PPL', 'P'),
(160383, 'Cooks Run', 41.2808303833008, 0.720486408145911, -77.876106262207, -1.35919446290849, 218, 45, 'PPL', 'P'),
(1744, 'Cooks Springs', 33.5900001525879, 0.586256098408056, -86.3944396972656, -1.50786742813298, 218, 2, 'PPL', 'P'),
(160384, 'Cooks Summit', 40.7066688537598, 0.710465399017134, -79.5397186279297, -1.38822997616724, 218, 45, 'PPL', 'P'),
(193461, 'Cooks Valley', 40.0013885498047, 0.698155935563652, -123.785003662109, -2.16045587849705, 218, 6, 'PPL', 'P'),
(35365, 'Cooksburg', 37.3888893127441, 0.652559222171105, -84.1852798461914, -1.46931031502887, 218, 21, 'PPL', 'P'),
(148012, 'Cooksburg', 42.4205589294434, 0.740378423855068, -74.2055587768555, -1.2951313239383, 218, 40, 'PPL', 'P'),
(160385, 'Cooksburg', 41.3333282470703, 0.721402668718953, -79.209716796875, -1.38247035767773, 218, 45, 'PPL', 'P'),
(54184, 'Cooksey', 37.7519416809082, 0.658895681352731, -91.4577789306641, -1.59623936890119, 218, 29, 'PPL', 'P'),
(45975, 'Cooksey Knolls', 38.4677810668945, 0.671389435553647, -76.9044418334961, -1.34223571940297, 218, 25, 'PPL', 'P'),
(75516, 'Cookson', 35.7108306884766, 0.623271574136149, -94.9197235107422, -1.65666170034512, 218, 42, 'PPL', 'P'),
(101060, 'Cookstown', 38.2949981689453, 0.668373805093295, -77.7019424438477, -1.35615473084027, 218, 53, 'PPL', 'P'),
(145036, 'Cookstown', 40.0488891601563, 0.698984977610993, -74.5627822875977, -1.30136605036629, 218, 37, 'PPL', 'P'),
(20225, 'Cooksville', 33.2391700744629, 0.580132958429746, -84.9977798461914, -1.48349111520132, 218, 13, 'PPL', 'P'),
(35367, 'Cooksville', 36.6122207641602, 0.639003798801629, -88.5233306884766, -1.54502358534565, 218, 21, 'PPL', 'P'),
(59101, 'Cooksville', 32.9836082458496, 0.575672563078027, -88.35888671875, -1.54215349663888, 218, 30, 'PPL', 'P'),
(63885, 'Cooksville', 35.5930595397949, 0.621216079827799, -81.4761123657227, -1.42202642250673, 218, 33, 'PPL', 'P'),
(119219, 'Cooksville', 40.5430603027344, 0.707609891117324, -88.7163925170898, -1.54839314991488, 218, 18, 'PPL', 'P'),
(173646, 'Cooksville', 42.8352813720703, 0.747616695960821, -89.2405624389648, -1.55754164089152, 218, 57, 'PPL', 'P'),
(20227, 'Cooktown', 32.6363906860352, 0.569612473438524, -83.1333312988281, -1.4509503493158, 218, 13, 'PPL', 'P'),
(35366, 'Cooktown', 36.8347206115723, 0.642887153724155, -85.9408264160156, -1.49995038284439, 218, 21, 'PPL', 'P'),
(39879, 'Cooktown', 32.5508308410645, 0.56811917243629, -92.6569366455078, -1.6171686192759, 218, 22, 'PPL', 'P'),
(63886, 'Cooktown', 36.0636100769043, 0.629428735997385, -82.1572189331055, -1.43391397466451, 218, 33, 'PPL', 'P'),
(85998, 'Cooktown', 36.3397216796875, 0.634247792568911, -85.1241683959961, -1.48569701153223, 218, 50, 'PPL', 'P'),
(101061, 'Cooktown', 38.9866714477539, 0.68044578115657, -77.3836135864258, -1.35059884417415, 218, 53, 'PPL', 'P'),
(32143, 'Cookville', 37.8202781677246, 0.660088378046923, -95.5919418334961, -1.66839412336941, 218, 20, 'PPL', 'P'),
(54185, 'Cookville', 37.6488914489746, 0.657097115510546, -92.209716796875, -1.60936316043699, 218, 29, 'PPL', 'P'),
(93426, 'Cookville', 33.1855583190918, 0.579197256780747, -94.8541717529297, -1.65551760634082, 218, 51, 'PPL', 'P'),
(148013, 'Cookville', 43.0097198486328, 0.750661221719, -78.3269424438477, -1.36706303866524, 218, 40, 'PPL', 'P'),
(171875, 'Cookville', 44.023609161377, 0.768356928477168, -72.290283203125, -1.26170345909368, 218, 55, 'PPL', 'P'),
(93427, 'Cool', 32.7999992370605, 0.572467981338335, -98.0008316040039, -1.71043718118238, 218, 51, 'PPL', 'P'),
(115097, 'Cool', 41.223331451416, 0.719482862468142, -93.5772171020508, -1.63323054328433, 218, 16, 'PPL', 'P'),
(80468, 'Cool Branch', 34.5491714477539, 0.602996795599322, -81.3797225952148, -1.42034410364612, 218, 48, 'PPL', 'P'),
(39880, 'Cool Coosa', 31.7105598449707, 0.553453676945441, -91.4625015258789, -1.59632179373692, 218, 22, 'PPL', 'P'),
(45976, 'Cool Hollow Estates', 39.5652809143066, 0.690544421431123, -77.6861114501953, -1.35587842787717, 218, 25, 'PPL', 'P'),
(45977, 'Cool Meadows Farms', 39.6055603027344, 0.691247429379877, -76.5119400024414, -1.33538527013096, 218, 25, 'PPL', 'P'),
(45978, 'Cool Pond', 39.0805587768555, 0.682084424175296, -76.5569381713867, -1.33617063633643, 218, 25, 'PPL', 'P'),
(108680, 'Cool Ridge', 37.6580581665039, 0.657257104913032, -81.095832824707, -1.41538929243803, 218, 58, 'PPL', 'P'),
(63887, 'Cool Run', 33.9513893127441, 0.5925635291338, -78.4702835083008, -1.36956481219326, 218, 33, 'PPL', 'P'),
(13593, 'Cool Spring', 38.7319412231445, 0.675999900032792, -75.2486114501953, -1.31333602735981, 218, 10, 'PPL', 'P'),
(45979, 'Cool Spring', 39.5883293151855, 0.69094669191378, -76.2794418334961, -1.33132741157801, 218, 25, 'PPL', 'P'),
(80469, 'Cool Spring', 33.9749984741211, 0.592975586733463, -79.1372222900391, -1.38120508984383, 218, 48, 'PPL', 'P'),
(101062, 'Cool Spring', 36.8338890075684, 0.642872639496214, -77.8261108398438, -1.35832187817732, 218, 53, 'PPL', 'P'),
(160386, 'Cool Spring', 41.2930603027344, 0.720699860507281, -80.2405624389648, -1.40046200821203, 218, 45, 'PPL', 'P'),
(13590, 'Cool Spring Farms', 38.725830078125, 0.675893240431134, -75.2527770996094, -1.31340873165757, 218, 10, 'PPL', 'P'),
(13591, 'Cool Spring Farms Mobile Home Park', 38.7249984741211, 0.675878726203193, -75.2477798461914, -1.31332151313187, 218, 10, 'PPL', 'P'),
(13592, 'Cool Spring Manor', 38.7197189331055, 0.675786580829477, -75.2563934326172, -1.31347184857541, 218, 10, 'PPL', 'P'),
(155, 'Cool Springs', 39.1624984741211, 0.683514541680668, -81.4752807617188, -1.42201190827879, 218, 58, 'PPL', 'P'),
(1745, 'Cool Springs', 33.7966690063477, 0.589863150367487, -86.3291702270508, -1.5067282609767, 218, 2, 'PPL', 'P'),
(20228, 'Cool Springs', 31.228889465332, 0.545046942911416, -83.6016693115234, -1.45912438964958, 218, 13, 'PPL', 'P'),
(35368, 'Cool Springs', 37.2933311462402, 0.650891417538443, -86.8819427490234, -1.51637596149967, 218, 21, 'PPL', 'P'),
(63891, 'Cool Springs', 35.4691696166992, 0.619053792759736, -79.2122192382813, -1.3825140335196, 218, 33, 'PPL', 'P'),
(85999, 'Cool Springs', 36.1627807617188, 0.631159590968855, -89.1386108398438, -1.55576224980918, 218, 50, 'PPL', 'P'),
(20229, 'Cool Springs Forest', 34.3883285522461, 0.600189557494269, -83.9316711425781, -1.4648840081391, 218, 13, 'PPL', 'P'),
(45980, 'Cool Springs Park', 39.6027793884277, 0.69119889326901, -75.9263916015625, -1.32516552260584, 218, 25, 'PPL', 'P'),
(54186, 'Cool Valley', 38.7277793884277, 0.67592726231406, -90.3099975585938, -1.5762068048655, 218, 29, 'PPL', 'P'),
(160389, 'Cool Valley', 40.2897186279297, 0.703188244759465, -80.1566696166992, -1.3989978022447, 218, 45, 'PPL', 'P'),
(160387, 'Coolbaugh', 41.0625, 0.716675824100172, -75.0691680908203, -1.31020414991788, 218, 45, 'PPL', 'P'),
(63895, 'Cooleemee', 35.8102798461914, 0.625007289376609, -80.5561065673828, -1.40596929218826, 218, 33, 'PPL', 'P'),
(63893, 'Cooleemee Junction', 35.8252792358398, 0.625269078111763, -80.5838928222656, -1.40645425382276, 218, 33, 'PPL', 'P'),
(39881, 'Cooley', 31.1766700744629, 0.544135542607363, -92.4841690063477, -1.61415325513166, 218, 22, 'PPL', 'P'),
(134791, 'Cooley', 47.3583297729492, 0.826558782783222, -93.1919403076172, -1.62650619468994, 218, 28, 'PPL', 'P'),
(148014, 'Cooley', 41.8716697692871, 0.730798500781835, -74.7094421386719, -1.30392574764802, 218, 40, 'PPL', 'P'),
(1746, 'Cooley Crossroads', 33.1683311462402, 0.578896585893677, -85.7058334350586, -1.49584898160761, 218, 2, 'PPL', 'P'),
(180849, 'Cooley Landing', 37.4766693115234, 0.6540912721672, -122.120559692383, -2.13140585101035, 218, 6, 'PPL', 'P'),
(59102, 'Cooley Springs', 31.708890914917, 0.553424548621019, -89.6686096191406, -1.56501247353946, 218, 30, 'PPL', 'P'),
(80471, 'Cooley Springs', 35.1411094665527, 0.613328062995093, -81.9486083984375, -1.43027303398021, 218, 48, 'PPL', 'P'),
(54187, 'Cooleys (historical)', 39.2455596923828, 0.684964233420053, -94.2286071777344, -1.64459944481983, 218, 29, 'PPL', 'P'),
(145042, 'Cooleys Corner', 40.2147216796875, 0.701879301083691, -74.5166702270508, -1.30056124308487, 218, 37, 'PPL', 'P'),
(63894, 'Cooleys Crossroads', 36.4824981689453, 0.636739712400898, -77.8813934326172, -1.35928674144026, 218, 33, 'PPL', 'P'),
(8217, 'Cooleyville', 34.021671295166, 0.593790181131891, -93.7666702270508, -1.63653712409378, 218, 4, 'PPL', 'P'),
(124572, 'Cooleyville', 42.4630584716797, 0.741120180797682, -72.3730621337891, -1.26314822398505, 218, 23, 'PPL', 'P'),
(20230, 'Coolidge', 31.0111103057861, 0.541245979535114, -83.8663864135742, -1.46374457466671, 218, 13, 'PPL', 'P'),
(93428, 'Coolidge', 31.7538890838623, 0.554209914826483, -96.6497192382813, -1.68685582183611, 218, 51, 'PPL', 'P'),
(177993, 'Coolidge', 32.9777793884277, 0.575570830324386, -111.516937255859, -1.94633772685468, 218, 5, 'PPL', 'P'),
(187635, 'Coolidge', 38.0416717529297, 0.663952425051546, -102.008331298828, -1.78038124562973, 218, 20, 'PPL', 'P'),
(188349, 'Coolidge', 35.4469413757324, 0.618665836767939, -108.362777709961, -1.89128725764554, 218, 38, 'PPL', 'P'),
(173647, 'Coolidge (historical)', 45.8116683959961, 0.799564449341961, -90.4077835083008, -1.57791349165008, 218, 57, 'PPL', 'P'),
(196268, 'Coolidge (historical)', 45.4894409179688, 0.793940518909987, -113.03556060791, -1.97284270444564, 218, 31, 'PPL', 'P'),
(148015, 'Coolidge Beach', 43.3058280944824, 0.75582928555138, -78.8675003051758, -1.37649755314295, 218, 40, 'PPL', 'P'),
(124573, 'Coolidge Corner', 42.3458290100098, 0.739074140711201, -71.125, -1.24136543048097, 218, 23, 'PPL', 'P'),
(127148, 'Coolidge Corner', 45.0400009155273, 0.786096311077213, -69.2486114501953, -1.20861627224015, 218, 26, 'PPL', 'P'),
(177994, 'Coolidge Dam', 33.1819381713867, 0.579134073283885, -110.525833129883, -1.92903969662628, 218, 5, 'PPL', 'P'),
(124574, 'Coolidge Hill', 42.3736114501953, 0.739559035766677, -71.1394424438477, -1.24161749867814, 218, 23, 'PPL', 'P'),
(160390, 'Coolidge Hollow', 41.689998626709, 0.727627741187986, -77.2927780151367, -1.34901346437722, 218, 45, 'PPL', 'P'),
(180850, 'Coolidge Springs', 33.3941688537598, 0.582838197465049, -116.049438476563, -2.02544479650661, 218, 6, 'PPL', 'P'),
(194774, 'Coolin', 48.4797210693359, 0.846130753108378, -116.848327636719, -2.03938804270983, 218, 17, 'PPL', 'P'),
(160391, 'Coolspring', 41.0430603027344, 0.716336537377296, -79.0838928222656, -1.38027431504285, 218, 45, 'PPL', 'P'),
(63896, 'Coolvale', 33.9661102294922, 0.592820457599965, -78.0355606079102, -1.36197746624762, 218, 33, 'PPL', 'P'),
(72203, 'Coolville', 39.2216682434082, 0.684547248972374, -81.7975006103516, -1.42763570555271, 218, 41, 'PPL', 'P'),
(101063, 'Coolwell', 37.5275001525879, 0.654978437705333, -79.0908279418945, -1.38039535571439, 218, 53, 'PPL', 'P'),
(122429, 'Coolwood Acres', 41.459171295166, 0.723599044248969, -87.0872192382813, -1.51995871211416, 218, 19, 'PPL', 'P'),
(180851, 'Coombs (historical)', 39.2963905334473, 0.685851398958186, -121.531387329102, -2.12112285340934, 218, 6, 'PPL', 'P'),
(173648, 'Coomer', 45.747501373291, 0.798444523524556, -92.2569427490234, -1.61018740879437, 218, 57, 'PPL', 'P'),
(39882, 'Coon', 30.7752799987793, 0.537129964201855, -91.7577819824219, -1.60147540992039, 218, 22, 'PPL', 'P'),
(1747, 'Coon Creek', 33.8311080932617, 0.590464225825518, -87.0283279418945, -1.51893086509144, 218, 2, 'PPL', 'P'),
(134792, 'Coon Creek', 45.151668548584, 0.78804527894196, -93.3008270263672, -1.62840662644382, 218, 28, 'PPL', 'P'),
(72204, 'Coon Crossing', 39.1558303833008, 0.683398161541032, -83.3919372558594, -1.45546387473127, 218, 41, 'PPL', 'P'),
(160393, 'Coon Hunter', 40.7758293151855, 0.711672476781212, -77.0552825927734, -1.34486838729857, 218, 45, 'PPL', 'P'),
(160394, 'Coon Island', 40.1116714477539, 0.700080735241506, -80.461669921875, -1.40432106178961, 218, 45, 'PPL', 'P'),
(134793, 'Coon Lake Beach', 45.3080596923828, 0.790774819322209, -93.1558303833008, -1.62587595761797, 218, 28, 'PPL', 'P'),
(45981, 'Coon Manor', 39.1338882446289, 0.683015198976279, -76.8938903808594, -1.34205156181359, 218, 25, 'PPL', 'P'),
(115098, 'Coon Rapids', 41.8708305358887, 0.730783853395839, -94.6772232055664, -1.65242927158271, 218, 16, 'PPL', 'P'),
(134794, 'Coon Rapids', 45.1199989318848, 0.787492539857714, -93.2874984741211, -1.6281739993226, 218, 28, 'PPL', 'P'),
(173649, 'Coon Rock', 43.1508293151855, 0.753124046516078, -89.9894409179688, -1.57061203604746, 218, 57, 'PPL', 'P'),
(59103, 'Coon Tail (historical)', 33.9194412231445, 0.592005929780565, -88.5597229003906, -1.54565874926564, 218, 30, 'PPL', 'P'),
(173655, 'Coon Valley', 43.702220916748, 0.762747645431188, -91.0130615234375, -1.58847758590415, 218, 57, 'PPL', 'P'),
(8218, 'Cooney', 34.1322212219238, 0.595719641341653, -92.5316696166992, -1.614982297179, 218, 4, 'PPL', 'P'),
(177393, 'Cooney', 41.6572189331055, 0.72705562760681, -84.7474975585938, -1.47912286522332, 218, 41, 'PPL', 'P'),
(188350, 'Cooney', 33.422779083252, 0.583337540169439, -108.807220458984, -1.89904424695261, 218, 38, 'PPL', 'P'),
(148016, 'Cooney Crossing', 43.0858306884766, 0.751989606470731, -77.2391662597656, -1.34807776272822, 218, 40, 'PPL', 'P'),
(45982, 'Cooney Neck Estate', 38.4722213745117, 0.671466933541368, -76.7216720581055, -1.33904578504927, 218, 25, 'PPL', 'P'),
(148017, 'Coonrod', 43.2483291625977, 0.754825739873611, -75.5236129760742, -1.31813570943441, 218, 40, 'PPL', 'P'),
(148018, 'Coons', 42.9186096191406, 0.749071048232113, -73.7463912963867, -1.28711733958604, 218, 40, 'PPL', 'P'),
(160395, 'Coons Corners', 41.7161102294922, 0.728083474629526, -80.209716796875, -1.39992365019767, 218, 45, 'PPL', 'P'),
(101064, 'Coonsville (historical)', 37.3069381713867, 0.651128904928651, -79.6883316040039, -1.39082376191092, 218, 53, 'PPL', 'P'),
(145037, 'Coontown', 40.6186103820801, 0.708928488752049, -74.5186080932617, -1.30059506523071, 218, 37, 'PPL', 'P'),
(160396, 'Coontown', 41.6688919067383, 0.727259359430201, -78.7219390869141, -1.37395703062107, 218, 45, 'PPL', 'P'),
(154853, 'Coonville', 41.3463897705078, 0.721630635308264, -82.0972213745117, -1.43286681972389, 218, 41, 'PPL', 'P'),
(59104, 'Coonwood (historical)', 32.9777793884277, 0.575570830324386, -88.9833297729492, -1.55305208392586, 218, 30, 'PPL', 'P'),
(1748, 'Cooper', 32.7750015258789, 0.572031688972752, -86.5455627441406, -1.51050502287659, 218, 2, 'PPL', 'P'),
(35369, 'Cooper', 36.771110534668, 0.641776948444729, -84.8613891601563, -1.48111064866095, 218, 21, 'PPL', 'P'),
(45983, 'Cooper', 39.6991691589355, 0.692881212129613, -76.2836074829102, -1.33140011587577, 218, 25, 'PPL', 'P'),
(63897, 'Cooper', 35.1549987792969, 0.613570477233318, -78.6294403076172, -1.37234262236826, 218, 33, 'PPL', 'P'),
(75518, 'Cooper', 36.8111114501953, 0.642475096124493, -96.7516708374023, -1.68863521291845, 218, 42, 'PPL', 'P'),
(80472, 'Cooper', 33.5661087036133, 0.585839113960377, -79.6102828979492, -1.38946155501335, 218, 48, 'PPL', 'P'),
(86000, 'Cooper', 36.4194412231445, 0.635639161080423, -85.0875015258789, -1.48505705392229, 218, 50, 'PPL', 'P'),
(93430, 'Cooper', 31.243049621582, 0.545294084260575, -95.581916809082, -1.66821915368579, 218, 51, 'PPL', 'P'),
(101065, 'Cooper', 37.6105613708496, 0.656428129444718, -76.5188903808594, -1.33550657711861, 218, 53, 'PPL', 'P'),
(115101, 'Cooper', 41.920280456543, 0.731646917326107, -94.3444366455078, -1.64662105040331, 218, 16, 'PPL', 'P'),
(119220, 'Cooper', 40.6602783203125, 0.709655731466723, -89.404167175293, -1.5603970822123, 218, 18, 'PPL', 'P'),
(127149, 'Cooper', 44.9594383239746, 0.784690228600678, -67.4402770996094, -1.17705488384552, 218, 26, 'PPL', 'P'),
(130334, 'Cooper', 42.3763885498047, 0.739607505298517, -85.6102828979492, -1.49418131013301, 218, 27, 'PPL', 'P'),
(145038, 'Cooper', 41.1627807617188, 0.718426053568572, -74.3324966430664, -1.29734680764914, 218, 37, 'PPL', 'P'),
(154844, 'Cooper', 41.1688919067383, 0.718532713170229, -82.976936340332, -1.44822074235653, 218, 41, 'PPL', 'P'),
(180853, 'Cooper', 36.7144393920898, 0.640787850415873, -121.716110229492, -2.12434687622499, 218, 6, 'PPL', 'P'),
(188351, 'Cooper', 33.9300003051758, 0.592190220527998, -105.785278320313, -1.84630140682803, 218, 38, 'PPL', 'P'),
(194145, 'Cooper', 40.3605613708496, 0.704424683874562, -103.528610229492, -1.80691511851852, 218, 7, 'PPL', 'P'),
(194775, 'Cooper', 46.4466705322266, 0.810647327376381, -116.053886413574, -2.02552242765238, 218, 17, 'PPL', 'P'),
(196269, 'Cooper', 47.5222206115723, 0.829419217531049, -111.136108398438, -1.93969100940606, 218, 31, 'PPL', 'P'),
(8219, 'Cooper (historical)', 34.2666702270508, 0.598066219157149, -93.725830078125, -1.63582432902802, 218, 4, 'PPL', 'P'),
(39883, 'Cooper (historical)', 32.0647201538086, 0.559634940414543, -92.2163925170898, -1.60947967373468, 218, 22, 'PPL', 'P'),
(190066, 'Cooper (historical)', 39.0986099243164, 0.682399476132252, -114.58332824707, -1.9998563458048, 218, 39, 'PPL', 'P'),
(8220, 'Cooper Addition', 34.9688911437988, 0.610322286230775, -91.9688873291016, -1.60515989328852, 218, 4, 'PPL', 'P'),
(15608, 'Cooper City', 26.0569400787354, 0.454779397368802, -80.2719421386719, -1.4010096872902, 218, 12, 'PPL', 'P'),
(29547, 'Cooper Corner', 39.8716697692871, 0.695891915741948, -85.7699966430664, -1.49696884084599, 218, 19, 'PPL', 'P'),
(160397, 'Cooper Corners', 41.5877799987793, 0.725843689573742, -75.9236068725586, -1.32511691991594, 218, 45, 'PPL', 'P'),
(20231, 'Cooper Creek', 34.7433280944824, 0.606385468349366, -84.1394424438477, -1.46851030143741, 218, 13, 'PPL', 'P'),
(93431, 'Cooper Creek', 33.2402801513672, 0.580152332926677, -97.0811080932617, -1.69438497771193, 218, 51, 'PPL', 'P'),
(13595, 'Cooper Farm', 39.7402801513672, 0.693598734306308, -75.6416702270508, -1.3201961971698, 218, 10, 'PPL', 'P'),
(20232, 'Cooper Heights', 34.8072204589844, 0.607500600476809, -85.3891677856445, -1.49032212339737, 218, 13, 'PPL', 'P'),
(54190, 'Cooper Hill', 38.4272193908691, 0.670681500756876, -91.6613922119141, -1.59979309105979, 218, 29, 'PPL', 'P'),
(15609, 'Cooper L Hills Estates', 29.6511096954346, 0.517509491055346, -81.9141693115234, -1.42967195852218, 218, 12, 'PPL', 'P'),
(209382, 'Cooper Lake', 41.6327781677246, 0.726629055779206, -105.768890380859, -1.84601538332696, 218, 59, 'PPL', 'P'),
(35370, 'Cooper Landing', 37.061939239502, 0.646852866903392, -88.333610534668, -1.5417123440043, 218, 21, 'PPL', 'P'),
(211767, 'Cooper Landing', 60.4900016784668, 1.05574969382614, -149.834167480469, -2.6150995545188, 218, 1, 'PPL', 'P'),
(45986, 'Cooper Mill', 38.5036087036133, 0.672014745777597, -75.7286071777344, -1.32171353320088, 218, 25, 'PPL', 'P'),
(86001, 'Cooper Mill', 35.6308288574219, 0.621875278776621, -85.1527786254883, -1.48619635423662, 218, 50, 'PPL', 'P'),
(80474, 'Cooper River Landing', 32.1336097717285, 0.560837291067686, -80.8691711425781, -1.41143329979677, 218, 48, 'PPL', 'P'),
(39884, 'Cooper Road', 32.5436096191406, 0.567993138337702, -93.8147201538086, -1.63737575352104, 218, 22, 'PPL', 'P'),
(160398, 'Cooper Settlement', 41.0313911437988, 0.716132872132932, -78.1080627441406, -1.36324286723957, 218, 45, 'PPL', 'P'),
(70693, 'Cooper Village', 39.8199996948242, 0.69499010281782, -75.1177825927734, -1.31105263304118, 218, 37, 'PPL', 'P'),
(154845, 'Cooperdale', 40.2197189331055, 0.701966519609391, -82.0652770996094, -1.43230928694969, 218, 41, 'PPL', 'P'),
(45985, 'Cooperfield', 39.4311103820801, 0.688202703884617, -76.6569366455078, -1.33791593895681, 218, 25, 'PPL', 'P'),
(20233, 'Coopers', 32.978328704834, 0.57558041770431, -83.2852783203125, -1.45360232512931, 218, 13, 'PPL', 'P'),
(39885, 'Coopers', 31.0486106872559, 0.541900484662514, -93.2752838134766, -1.62796081327734, 218, 22, 'PPL', 'P'),
(54191, 'Coopers', 39.3005599975586, 0.685924169834972, -94.2302780151367, -1.64462860643376, 218, 29, 'PPL', 'P'),
(80475, 'Coopers', 33.6888885498047, 0.587982026531509, -79.0063934326172, -1.37892169552519, 218, 48, 'PPL', 'P'),
(108681, 'Coopers', 37.3222198486328, 0.651395620511822, -81.3266677856445, -1.4194181225351, 218, 58, 'PPL', 'P'),
(13594, 'Coopers Corner', 39.1388893127441, 0.683102484081006, -75.522216796875, -1.31811134151043, 218, 10, 'PPL', 'P'),
(127151, 'Coopers Corner', 43.3597183227539, 0.756769847469369, -70.4819412231445, -1.23014193754099, 218, 26, 'PPL', 'P'),
(134797, 'Coopers Corner', 45.399169921875, 0.792364992809096, -93.2344436645508, -1.62724801821158, 218, 28, 'PPL', 'P'),
(145039, 'Coopers Corner', 40.371940612793, 0.704623289112854, -74.8483276367188, -1.30634975687221, 218, 37, 'PPL', 'P'),
(148019, 'Coopers Corners', 41.6713905334473, 0.727302968693051, -74.7513885498047, -1.30465785063168, 218, 40, 'PPL', 'P'),
(101066, 'Coopers Cove', 37.2108306884766, 0.649451512916064, -79.8583297729492, -1.39379078968138, 218, 53, 'PPL', 'P'),
(148020, 'Coopers Falls', 44.5177803039551, 0.776981841983498, -75.3386077880859, -1.31490675977074, 218, 40, 'PPL', 'P'),
(1749, 'Coopers Mill', 34.9480590820313, 0.609958698162952, -85.7994384765625, -1.49748269777832, 218, 2, 'PPL', 'P'),
(127152, 'Coopers Mills', 44.2588882446289, 0.772463323140988, -69.5524978637695, -1.2139200907091, 218, 26, 'PPL', 'P'),
(148021, 'Coopers Plains', 42.1822204589844, 0.736218632811391, -77.1419372558594, -1.34638079648163, 218, 40, 'PPL', 'P'),
(20234, 'Coopers Pond', 33.9066696166992, 0.591783023197325, -84.0555572509766, -1.46704622862813, 218, 13, 'PPL', 'P'),
(173652, 'Coopers Shores', 42.8325004577637, 0.747568159849955, -89.0113906860352, -1.55354183925033, 218, 57, 'PPL', 'P'),
(160401, 'Coopersburg', 40.5113906860352, 0.707057152033078, -75.3908309936523, -1.31581822665382, 218, 45, 'PPL', 'P'),
(160403, 'Coopersdale', 40.3555603027344, 0.704337398769834, -78.9375, -1.37771927829302, 218, 45, 'PPL', 'P'),
(26853, 'Cooperstown', 39.9638900756836, 0.697501463725765, -90.6063919067383, -1.58137986212493, 218, 18, 'PPL', 'P'),
(35371, 'Cooperstown', 36.9302787780762, 0.644554958356818, -86.8874969482422, -1.51647290056335, 218, 21, 'PPL', 'P'),
(139830, 'Cooperstown', 47.4444389343262, 0.828061671165381, -98.1236114501953, -1.71258009375352, 218, 34, 'PPL', 'P'),
(145040, 'Cooperstown', 40.0466690063477, 0.698946228617133, -74.9036102294922, -1.30731462013514, 218, 37, 'PPL', 'P'),
(148022, 'Cooperstown', 42.7005615234375, 0.74526539103439, -74.9247207641602, -1.30768306847196, 218, 40, 'PPL', 'P'),
(160406, 'Cooperstown', 40.3058280944824, 0.70346940799155, -79.3655624389648, -1.38519037725708, 218, 45, 'PPL', 'P'),
(173653, 'Cooperstown', 44.3127784729004, 0.773403885058977, -87.7744369506836, -1.5319529238736, 218, 57, 'PPL', 'P'),
(180855, 'Cooperstown', 37.7433280944824, 0.658745345909196, -120.543609619141, -2.10388288009271, 218, 6, 'PPL', 'P'),
(148023, 'Cooperstown Junction', 42.4916687011719, 0.741619523502072, -74.9574966430664, -1.30825511547411, 218, 40, 'PPL', 'P'),
(35372, 'Coopersville', 36.7602806091309, 0.64158793058636, -84.7377777099609, -1.47895322186188, 218, 21, 'PPL', 'P'),
(39886, 'Coopersville', 30.0091705322266, 0.523758831579813, -91.8088912963867, -1.60236743572751, 218, 22, 'PPL', 'P'),
(45987, 'Coopersville', 39.5475006103516, 0.690234096585102, -76.7422180175781, -1.33940437969005, 218, 25, 'PPL', 'P'),
(72206, 'Coopersville', 38.961109161377, 0.679999635094955, -83.0427780151367, -1.4493698963669, 218, 41, 'PPL', 'P'),
(78077, 'Coopersville', 39.9375, 0.697040870015235, -76.0355606079102, -1.32707088120773, 218, 45, 'PPL', 'P'),
(130336, 'Coopersville', 43.0638885498047, 0.751606643905978, -85.9347229003906, -1.49984385640079, 218, 27, 'PPL', 'P'),
(145041, 'Coopersville', 40.7069396972656, 0.710470126128069, -75.1094436645508, -1.31090709128761, 218, 37, 'PPL', 'P'),
(148025, 'Coopersville', 42.6036109924316, 0.743573285056781, -77.9116668701172, -1.35981511260053, 218, 40, 'PPL', 'P'),
(75521, 'Cooperton', 34.8675003051758, 0.608552682265445, -98.8663864135742, -1.72554396246586, 218, 42, 'PPL', 'P'),
(130338, 'Cooperton', 44.1575012207031, 0.770693785754685, -84.7858276367188, -1.47979185128914, 218, 27, 'PPL', 'P'),
(15610, 'Coopertown', 25.7602806091309, 0.449601712866984, -80.5611114501953, -1.40605664387201, 218, 12, 'PPL', 'P'),
(86002, 'Coopertown', 36.4375, 0.635954346195434, -86.9672164916992, -1.51786426907486, 218, 50, 'PPL', 'P'),
(108682, 'Coopertown', 38.0780601501465, 0.664587522392503, -81.5899963378906, -1.42401407278631, 218, 58, 'PPL', 'P'),
(78075, 'Coopertown (historical)', 39.9966697692871, 0.698073577306941, -75.3244400024414, -1.31465948526353, 218, 45, 'PPL', 'P'),
(20236, 'Cooperville', 32.5905609130859, 0.568812593005119, -81.7041702270508, -1.42600678307196, 218, 13, 'PPL', 'P'),
(59105, 'Cooperville', 32.2405586242676, 0.562703900675723, -89.7130584716797, -1.565788252365, 218, 30, 'PPL', 'P'),
(45988, 'Coopstown', 39.5897216796875, 0.690970993258727, -76.4319381713867, -1.33398897477143, 218, 25, 'PPL', 'P'),
(200618, 'Coos Bay', 43.3666687011719, 0.756891154457022, -124.216667175293, -2.16798982806283, 218, 43, 'PPL', 'P'),
(127153, 'Coos Canyon', 44.7202796936035, 0.780516123066142, -70.6324996948242, -1.23276967858857, 218, 26, 'PPL', 'P'),
(200619, 'Coos City (historical)', 43.3013916015625, 0.755751854142686, -124.211112976074, -2.16789288899915, 218, 43, 'PPL', 'P'),
(143665, 'Coos Junction', 44.5061111450195, 0.776778176739134, -71.5683288574219, -1.24910297871208, 218, 36, 'PPL', 'P'),
(193202, 'Coos River', 43.3777809143066, 0.757085099163407, -124.099998474121, -2.16595357509335, 218, 43, 'PPL', 'P'),
(20235, 'Coosa', 34.2544403076172, 0.597852766795779, -85.3544387817383, -1.48971598793327, 218, 13, 'PPL', 'P'),
(59106, 'Coosa', 32.8422203063965, 0.57320487801196, -89.4222183227539, -1.56071213416926, 218, 30, 'PPL', 'P'),
(1751, 'Coosa Court', 33.2791709899902, 0.580831106109511, -86.3455581665039, -1.50701428447777, 218, 2, 'PPL', 'P'),
(1752, 'Coosa Pines', 33.3274993896484, 0.581674595805766, -86.3591690063477, -1.50725183844701, 218, 2, 'PPL', 'P'),
(1753, 'Coosa River', 32.6477813720703, 0.569811278413899, -86.3697204589844, -1.50743599603639, 218, 2, 'PPL', 'P'),
(1755, 'Coosada', 32.4977798461914, 0.567193257904296, -86.3313903808594, -1.50676700997056, 218, 2, 'PPL', 'P'),
(15611, 'Coosada Old Town (historical)', 30.6333293914795, 0.534652458729268, -85.9000015258789, -1.49923785409474, 218, 12, 'PPL', 'P'),
(80476, 'Coosaw', 32.5449981689453, 0.568017373103621, -80.7736129760742, -1.40976549516411, 218, 48, 'PPL', 'P'),
(20237, 'Coosawattee (historical)', 34.600830078125, 0.603898408786368, -84.7813873291016, -1.47971435330142, 218, 13, 'PPL', 'P'),
(80477, 'Coosawhatchie', 32.5886116027832, 0.568778571122193, -80.9274978637695, -1.41245129312346, 218, 48, 'PPL', 'P'),
(200621, 'Cooston', 43.3950004577637, 0.757385636892423, -124.184173583984, -2.16742270790869, 218, 43, 'PPL', 'P'),
(54192, 'Cooter', 36.0466690063477, 0.629133058537359, -89.8099975585938, -1.56748015860553, 218, 29, 'PPL', 'P'),
(39887, 'Cooter Point', 31.9300003051758, 0.557283635488112, -91.4905624389648, -1.59681154906139, 218, 22, 'PPL', 'P'),
(39888, 'Cooters Landing', 31.9280605316162, 0.557249780052754, -91.5116729736328, -1.5971799973982, 218, 22, 'PPL', 'P'),
(39889, 'Cooterville', 32.274169921875, 0.56329052848484, -93.4863891601563, -1.63164529664546, 218, 22, 'PPL', 'P'),
(148032, 'Copake', 42.103328704834, 0.734841711948793, -73.5505599975586, -1.28369943864303, 218, 40, 'PPL', 'P'),
(148026, 'Copake Falls', 42.1194381713867, 0.735122875180878, -73.5255584716797, -1.28326307969842, 218, 40, 'PPL', 'P'),
(148027, 'Copake Lake', 42.1391716003418, 0.735467288488852, -73.5827789306641, -1.2842617651072, 218, 40, 'PPL', 'P'),
(207100, 'Copalis Beach', 47.1127815246582, 0.82227315737804, -124.172500610352, -2.1672189760853, 218, 56, 'PPL', 'P'),
(207101, 'Copalis Crossing', 47.1080589294434, 0.822190732542302, -124.068061828613, -2.1653961754772, 218, 56, 'PPL', 'P'),
(75523, 'Copan', 36.8974990844727, 0.643982844775641, -95.9258270263672, -1.67422151930867, 218, 42, 'PPL', 'P'),
(93432, 'Copano Village', 28.0877799987793, 0.490224240554508, -97.0580596923828, -1.69398270722927, 218, 51, 'PPL', 'P'),
(134798, 'Copas', 45.2347183227539, 0.789494770944263, -92.7644424438477, -1.61904494942192, 218, 28, 'PPL', 'P'),
(193462, 'Copco', 41.9833297729492, 0.732747335488527, -122.360282897949, -2.13558981024092, 218, 6, 'PPL', 'P'),
(29548, 'Cope', 39.4502792358398, 0.688537263496558, -86.3188934326172, -1.50654889707728, 218, 19, 'PPL', 'P'),
(80480, 'Cope', 33.3777809143066, 0.582552173963974, -81.0072174072266, -1.41384266163497, 218, 48, 'PPL', 'P'),
(186572, 'Cope', 39.663890838623, 0.692265489285587, -102.850563049316, -1.79508096274059, 218, 7, 'PPL', 'P'),
(196270, 'Cope Trailer Park', 46.4000015258789, 0.80983279955698, -105.827781677246, -1.84704323034967, 218, 31, 'PPL', 'P'),
(35373, 'Copebranch', 37.5175018310547, 0.654803934074906, -83.5261077880859, -1.45780559227778, 218, 21, 'PPL', 'P'),
(1757, 'Copeland', 34.8347206115723, 0.607980568684269, -86.8319396972656, -1.51550324361045, 218, 2, 'PPL', 'P'),
(8221, 'Copeland', 35.6713905334473, 0.622583213573391, -92.6363906860352, -1.61681002463512, 218, 4, 'PPL', 'P'),
(15612, 'Copeland', 25.9533290863037, 0.452971044409611, -81.3561096191406, -1.41993197946743, 218, 12, 'PPL', 'P'),
(20238, 'Copeland', 31.9880599975586, 0.558296968282887, -83.2394409179688, -1.45280231153785, 218, 13, 'PPL', 'P'),
(45989, 'Copeland', 39.3013916015625, 0.685938684062913, -76.1733322143555, -1.32947544935597, 218, 25, 'PPL', 'P'),
(54194, 'Copeland', 38.1922187805176, 0.666579966362045, -93.9033279418945, -1.63892225116605, 218, 29, 'PPL', 'P'),
(63901, 'Copeland', 36.3383293151855, 0.634223491223964, -80.6502838134766, -1.40761299521305, 218, 33, 'PPL', 'P'),
(75522, 'Copeland', 36.6558303833008, 0.639764930241174, -94.8280563354492, -1.65506180632026, 218, 42, 'PPL', 'P'),
(93433, 'Copeland', 32.2397193908691, 0.562689253289727, -95.2716674804688, -1.66280428139939, 218, 51, 'PPL', 'P'),
(101067, 'Copeland', 37.8880615234375, 0.661271420782163, -79.6997222900391, -1.3910225668863, 218, 53, 'PPL', 'P'),
(180854, 'Copeland', 39.9555587768555, 0.697356055130246, -122.0625, -2.13039251821558, 218, 6, 'PPL', 'P'),
(187639, 'Copeland', 37.5419387817383, 0.655230439323482, -100.629173278809, -1.75631039727511, 218, 20, 'PPL', 'P'),
(194776, 'Copeland', 48.9022216796875, 0.853504779850699, -116.38777923584, -2.0313499567497, 218, 17, 'PPL', 'P'),
(20239, 'Copeland (historical)', 32.7944412231445, 0.572370975695629, -84.9636077880859, -1.4828947002752, 218, 13, 'PPL', 'P'),
(86003, 'Copeland (historical)', 35.2763900756836, 0.61568915503853, -88.4000015258789, -1.5428710853946, 218, 50, 'PPL', 'P'),
(1758, 'Copeland Bridge', 34.2966690063477, 0.598589796627459, -85.8852767944336, -1.49898085904955, 218, 2, 'PPL', 'P'),
(130339, 'Copeland Corner', 42.6725006103516, 0.744775635709925, -82.6224975585938, -1.44203461861844, 218, 27, 'PPL', 'P'),
(20240, 'Copeland Crossing', 34.8669395446777, 0.608542895148439, -85.0813903808594, -1.48495039432063, 218, 13, 'PPL', 'P'),
(1759, 'Copeland Gap', 34.1041717529297, 0.595230085754269, -86.0999984741211, -1.50272845933551, 218, 2, 'PPL', 'P'),
(39890, 'Copeland Landing', 31.8349990844727, 0.555625551393428, -91.5708312988281, -1.59821250495283, 218, 22, 'PPL', 'P'),
(15613, 'Copeland Settlement', 29.6758308410645, 0.517940956441453, -82.2444381713867, -1.4354362375436, 218, 12, 'PPL', 'P'),
(160408, 'Copella', 40.7999992370605, 0.712094321497881, -75.3688888549805, -1.31543526408907, 218, 45, 'PPL', 'P'),
(130340, 'Copemish', 44.4816703796387, 0.776351604911531, -85.9225006103516, -1.49963053719747, 218, 27, 'PPL', 'P'),
(156, 'Copen', 38.8375015258789, 0.677842274874909, -80.7297210693359, -1.40899943687655, 218, 58, 'PPL', 'P'),
(39891, 'Copenhagen', 32.023609161377, 0.558917418237848, -92.0388870239258, -1.60638161843859, 218, 22, 'PPL', 'P'),
(148029, 'Copenhagen', 43.8933296203613, 0.766083121538458, -75.6738891601563, -1.32075852363397, 218, 40, 'PPL', 'P'),
(1760, 'Copenhagen (historical)', 34.9841690063477, 0.61058893523492, -85.7249984741211, -1.49618347464053, 218, 2, 'PPL', 'P'),
(63902, 'Copenhagen (historical)', 35.8655586242676, 0.625972086060517, -81.5994415283203, -1.42417892245778, 218, 33, 'PPL', 'P'),
(130341, 'Copenhagen Beach', 45.9836082458496, 0.80256536583729, -86.2941665649414, -1.50611733182263, 218, 27, 'PPL', 'P'),
(108684, 'Copenhaver (historical)', 38.4311103820801, 0.670749411364673, -81.522216796875, -1.42283109663009, 218, 58, 'PPL', 'P'),
(101068, 'Copenhavers', 36.8925018310547, 0.643895626249941, -81.1980590820313, -1.41717347721033, 218, 53, 'PPL', 'P'),
(148030, 'Copes Corner', 42.4391708374023, 0.74070326292903, -75.3480606079102, -1.31507174260027, 218, 40, 'PPL', 'P'),
(78076, 'Copesville', 39.9588890075684, 0.697414178621037, -75.6563873291016, -1.32045305905694, 218, 45, 'PPL', 'P'),
(93434, 'Copeville', 33.0794410705566, 0.577345161400651, -96.415283203125, -1.68276414113732, 218, 51, 'PPL', 'P'),
(148031, 'Copiague', 40.6813888549805, 0.710024179803535, -73.4002838134766, -1.28107662444347, 218, 40, 'PPL', 'P'),
(193463, 'Copic', 41.8652801513672, 0.730686980911187, -121.340827941895, -2.11779696468199, 218, 6, 'PPL', 'P'),
(75524, 'Copic Slab', 35.6097183227539, 0.621506830439808, -94.5588912963867, -1.65036399015736, 218, 42, 'PPL', 'P'),
(35374, 'Copland', 37.454719543457, 0.653708176444393, -83.3691711425781, -1.45506653109663, 218, 21, 'PPL', 'P'),
(160409, 'Coplay', 40.6699981689453, 0.709825374828161, -75.4958267211914, -1.31765074779991, 218, 45, 'PPL', 'P'),
(39892, 'Copley', 32.8777809143066, 0.573825527704003, -92.6352767944336, -1.61679058355916, 218, 22, 'PPL', 'P'),
(108683, 'Copley', 38.9694404602051, 0.680145043690473, -80.6477813720703, -1.40756931937118, 218, 58, 'PPL', 'P'),
(154846, 'Copley', 41.0988883972168, 0.717310921441128, -81.6447219848633, -1.42496921551126, 218, 41, 'PPL', 'P'),
(154847, 'Copley Junction', 41.1047210693359, 0.717412720773796, -81.5991668701172, -1.42417412876782, 218, 41, 'PPL', 'P'),
(80479, 'Copp Landing', 32.3061103820801, 0.563847994680021, -80.8444366455078, -1.41100160138407, 218, 48, 'PPL', 'P'),
(207102, 'Coppei', 46.2219390869141, 0.806725023722912, -118.123893737793, -2.0616508710004, 218, 56, 'PPL', 'P'),
(93435, 'Coppell', 32.9544410705566, 0.575163499835658, -97.0147171020508, -1.69322623632164, 218, 51, 'PPL', 'P'),
(173656, 'Coppens Corner', 44.4583282470703, 0.775944207843776, -87.7855606079102, -1.53214706831707, 218, 57, 'PPL', 'P'),
(200622, 'Copper', 42.026668548584, 0.733503739817137, -123.145561218262, -2.14929550247491, 218, 43, 'PPL', 'P'),
(200623, 'Copper (historical)', 45.7513885498047, 0.798512367553325, -116.547218322754, -2.03413269377272, 218, 43, 'PPL', 'P'),
(199887, 'Copper Basin', 40.6030616760254, 0.70865711263697, -117.045562744141, -2.04283044473486, 218, 39, 'PPL', 'P'),
(190069, 'Copper Camp (historical)', 35.5430603027344, 0.620343428517607, -114.761108398438, -2.00295919479085, 218, 39, 'PPL', 'P'),
(196271, 'Copper Camp (historical)', 47.0702781677246, 0.821531333856398, -112.792221069336, -1.96859562829723, 218, 31, 'PPL', 'P'),
(202023, 'Copper Camp (historical)', 44.0916709899902, 0.769544831481397, -103.798606872559, -1.81162744890936, 218, 49, 'PPL', 'P'),
(93436, 'Copper Canyon', 33.0958290100098, 0.577631184901726, -97.0963897705078, -1.6946516932951, 218, 51, 'PPL', 'P'),
(211768, 'Copper Center', 61.9550018310547, 1.08131877003102, -145.305282592773, -2.5360556017847, 218, 1, 'PPL', 'P'),
(130342, 'Copper City', 47.2836112976074, 0.825254699376438, -88.3869400024414, -1.54264311880529, 218, 27, 'PPL', 'P'),
(180859, 'Copper City', 35.350830078125, 0.616988378176326, -117.184722900391, -2.04525924764902, 218, 6, 'PPL', 'P'),
(196272, 'Copper City', 45.9811096191406, 0.80252175657444, -111.548606872559, -1.94689046593892, 218, 31, 'PPL', 'P'),
(203520, 'Copper City', 40.6469383239746, 0.709422904608423, -112.032218933105, -1.95533108869782, 218, 52, 'PPL', 'P'),
(188352, 'Copper City (historical)', 36.0019416809082, 0.62835241944283, -106.911666870117, -1.86596059567889, 218, 38, 'PPL', 'P'),
(190070, 'Copper City (historical)', 36.3166694641113, 0.633845455507227, -114.211112976074, -1.99335996379971, 218, 39, 'PPL', 'P'),
(196273, 'Copper Cliff', 46.8088912963867, 0.816969272330065, -113.453887939453, -1.98014389373214, 218, 31, 'PPL', 'P'),
(203521, 'Copper Cove', 40.7044410705566, 0.710426516865219, -112.108612060547, -1.95666440029757, 218, 52, 'PPL', 'P'),
(203522, 'Copper Cove Condominium', 40.7030601501465, 0.710402415257354, -112.108612060547, -1.95666440029757, 218, 52, 'PPL', 'P'),
(180857, 'Copper Cove Subdivision', 37.9269409179688, 0.661949994227915, -120.630279541016, -2.10539555559188, 218, 6, 'PPL', 'P'),
(180858, 'Copper Cove Village', 37.9597206115723, 0.662522107809092, -120.634437561035, -2.10546812673158, 218, 6, 'PPL', 'P'),
(177995, 'Copper Creek', 32.7508316040039, 0.571609844256084, -110.475830078125, -1.92816697873707, 218, 5, 'PPL', 'P'),
(130343, 'Copper Falls', 47.4300003051758, 0.827809669547233, -88.1986083984375, -1.53935611222986, 218, 27, 'PPL', 'P'),
(171876, 'Copper Flat', 43.8349990844727, 0.765065061632748, -72.3344421386719, -1.26247417791315, 218, 55, 'PPL', 'P'),
(190072, 'Copper Flat', 39.2611083984375, 0.685235609535132, -114.98722076416, -2.00690560005219, 218, 39, 'PPL', 'P'),
(63903, 'Copper Ford', 35.3611106872559, 0.61716780865477, -82.3188934326172, -1.43673572699751, 218, 33, 'PPL', 'P'),
(130344, 'Copper Harbor', 47.4688911437988, 0.828488442730067, -87.8883285522461, -1.53394070731124, 218, 27, 'PPL', 'P'),
(101070, 'Copper Hill', 37.0816688537598, 0.64719721363234, -80.1344375610352, -1.39860977967388, 218, 53, 'PPL', 'P'),
(145044, 'Copper Hill', 40.4749984741211, 0.706421988113094, -74.8638916015625, -1.3066213993034, 218, 37, 'PPL', 'P'),
(177996, 'Copper Hill', 33.4302787780762, 0.583468434537016, -110.763893127441, -1.93319462740097, 218, 5, 'PPL', 'P'),
(190071, 'Copper Hill (historical)', 38.8333282470703, 0.677769437419095, -118.711112976074, -2.07189978013946, 218, 39, 'PPL', 'P'),
(203525, 'Copper Hills Heights', 40.688060760498, 0.710140626522199, -112.046943664551, -1.95558808374301, 218, 52, 'PPL', 'P'),
(177997, 'Copper Kettle Trailer Villa', 33.6319389343262, 0.586988068233665, -112.010559082031, -1.95495305298108, 218, 5, 'PPL', 'P'),
(54195, 'Copper Mine', 37.9036102294922, 0.661542796897242, -90.1463928222656, -1.57335136354472, 218, 29, 'PPL', 'P'),
(186573, 'Copper Mountain', 39.5066719055176, 0.689521501256424, -106.141670227051, -1.85252161902807, 218, 7, 'PPL', 'P'),
(86004, 'Copper Ridge', 36.1322212219238, 0.63062622638154, -83.9136123657227, -1.46456882302409, 218, 50, 'PPL', 'P'),
(190074, 'Copper Run', 38.8208312988281, 0.677551324525817, -118.888328552246, -2.07499277542948, 218, 39, 'PPL', 'P'),
(1761, 'Copper Springs', 33.6736106872559, 0.587715377527365, -86.4408264160156, -1.50867702910436, 218, 2, 'PPL', 'P'),
(186574, 'Copper Spur', 39.9105606079102, 0.696570688924782, -106.687782287598, -1.86205307256947, 218, 7, 'PPL', 'P'),
(203526, 'Copper View Estates', 40.6941719055176, 0.710247286123857, -112.077217102051, -1.95611645490328, 218, 52, 'PPL', 'P'),
(124575, 'Copper Works', 41.9483299255371, 0.73213647291349, -71.1791687011719, -1.24231085266794, 218, 23, 'PPL', 'P'),
(93437, 'Copperas Cove', 31.1238899230957, 0.543214355186305, -97.9027786254883, -1.7087258338659, 218, 51, 'PPL', 'P'),
(8222, 'Copperas Gap (historical)', 35.0591697692871, 0.611897945489721, -92.7222213745117, -1.61830805274829, 218, 4, 'PPL', 'P'),
(186575, 'Copperdale', 39.9141693115234, 0.696633672684562, -105.348892211914, -1.83868503242651, 218, 7, 'PPL', 'P'),
(190075, 'Coppereid (historical)', 39.8488883972168, 0.695494305791199, -118.218063354492, -2.06329444086714, 218, 39, 'PPL', 'P'),
(45991, 'Copperfield', 39.3597183227539, 0.686956677389596, -77.5547180175781, -1.35358517986251, 218, 25, 'PPL', 'P'),
(190076, 'Copperfield', 39.6316719055176, 0.691703162821417, -119.943893432617, -2.09341585806037, 218, 39, 'PPL', 'P'),
(171877, 'Copperfield (historical)', 43.9097213745117, 0.76636921161856, -72.2877807617188, -1.26165978325181, 218, 55, 'PPL', 'P'),
(190077, 'Copperfield (historical)', 38.5916709899902, 0.673551722621709, -118.368057250977, -2.06591232821869, 218, 39, 'PPL', 'P'),
(86005, 'Copperhill', 34.9888916015625, 0.610671360070658, -84.3708267211914, -1.4725487189144, 218, 50, 'PPL', 'P'),
(20243, 'Coppermine Estates', 33.8916702270508, 0.59152123446217, -84.7919387817383, -1.4798985108908, 218, 13, 'PPL', 'P'),
(45993, 'Coppermine Estates', 39.5166702270508, 0.689696004886851, -77.2369384765625, -1.34803888057631, 218, 25, 'PPL', 'P'),
(177998, 'Copperopolis', 34.0802803039551, 0.59481310130659, -112.469436645508, -1.96296197732728, 218, 5, 'PPL', 'P'),
(180860, 'Copperopolis', 37.9811096191406, 0.662895416414893, -120.640830993652, -2.10557971318126, 218, 6, 'PPL', 'P'),
(188353, 'Copperton', 35.146110534668, 0.613415348099821, -108.149436950684, -1.88756375896745, 218, 38, 'PPL', 'P'),
(203527, 'Copperton', 40.5647201538086, 0.707987926834061, -112.096672058105, -1.95645600794227, 218, 52, 'PPL', 'P'),
(209383, 'Copperton (historical)', 41.1430587768555, 0.718081839997679, -107.121391296387, -1.86962097743915, 218, 59, 'PPL', 'P'),
(193464, 'Coppervale', 40.3466682434082, 0.70418220305731, -120.90389251709, -2.11017100290055, 218, 6, 'PPL', 'P'),
(203528, 'Copperview', 40.711669921875, 0.710552684121861, -112.066673278809, -1.95593243047196, 218, 52, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(203529, 'Copperview Village Condominium', 40.711109161377, 0.710542897004855, -112.068061828613, -1.95595666523788, 218, 52, 'PPL', 'P'),
(45995, 'Copperville', 38.8247184753418, 0.677619168554587, -76.1711120605469, -1.32943670036211, 218, 25, 'PPL', 'P'),
(143666, 'Copperville', 44.5344390869141, 0.777272592595508, -71.2397232055664, -1.24336772814654, 218, 36, 'PPL', 'P'),
(194777, 'Copperville', 45.753059387207, 0.798541529167262, -116.323333740234, -2.0302251706633, 218, 17, 'PPL', 'P'),
(211769, 'Copperville', 62.0438919067383, 1.08287019452405, -145.420562744141, -2.53806761998825, 218, 1, 'PPL', 'P'),
(122430, 'Coppess Corner', 40.7449989318848, 0.711134385082962, -84.9569396972656, -1.48277832013556, 218, 19, 'PPL', 'P'),
(1762, 'Coppinville', 31.3091697692871, 0.546448098539933, -85.8144378662109, -1.49774448651348, 218, 2, 'PPL', 'P'),
(193465, 'Copple Place', 40.0086097717285, 0.69828196966224, -122.628608703613, -2.14027297901783, 218, 6, 'PPL', 'P'),
(115104, 'Coppock', 41.1622200012207, 0.718416266451566, -91.7111129760742, -1.60066088210099, 218, 16, 'PPL', 'P'),
(86006, 'Coptown', 35.0008316040039, 0.610879752425956, -86.1736068725586, -1.50401316824536, 218, 50, 'PPL', 'P'),
(200624, 'Coquille', 43.1772193908691, 0.753584640226607, -124.186393737793, -2.16746145690255, 218, 43, 'PPL', 'P'),
(15614, 'Coquina Gables', 29.8427791595459, 0.520854754279622, -81.2655563354492, -1.41835152651853, 218, 12, 'PPL', 'P'),
(80481, 'Coquina Harbor', 33.8636093139648, 0.591031479137705, -78.6361083984375, -1.3724590025079, 218, 48, 'PPL', 'P'),
(498, 'Cora', 39.8927803039551, 0.69626036407876, -98.663330078125, -1.72199996084524, 218, 20, 'PPL', 'P'),
(26855, 'Cora', 37.8238906860352, 0.66015142838573, -89.670280456543, -1.5650416351534, 218, 18, 'PPL', 'P'),
(39894, 'Cora', 31.1088905334473, 0.54295256645115, -92.8683319091797, -1.6208581626501, 218, 22, 'PPL', 'P'),
(72207, 'Cora', 38.8244400024414, 0.677614308285598, -82.3697204589844, -1.43762282595661, 218, 41, 'PPL', 'P'),
(75525, 'Cora', 36.797779083252, 0.642242402424247, -98.9166717529297, -1.72642160720309, 218, 42, 'PPL', 'P'),
(108686, 'Cora', 37.834171295166, 0.660330858864174, -82.0266723632813, -1.4316355071939, 218, 58, 'PPL', 'P'),
(139104, 'Cora', 40.1097183227539, 0.700046646779553, -93.1302795410156, -1.62543001129344, 218, 29, 'PPL', 'P'),
(194778, 'Cora', 47.0038909912109, 0.820372659045132, -116.963890075684, -2.0414049877614, 218, 17, 'PPL', 'P'),
(207103, 'Cora', 46.5361099243164, 0.81220833924933, -121.788887023926, -2.1256170709069, 218, 56, 'PPL', 'P'),
(209384, 'Cora', 42.9397201538086, 0.749439496568926, -109.978889465332, -1.91949372885695, 218, 59, 'PPL', 'P'),
(188354, 'Cora Crew', 33.4824981689453, 0.584379834841068, -106.024436950684, -1.85047551236257, 218, 38, 'PPL', 'P'),
(59108, 'Coral', 31.3861103057861, 0.547790964230092, -89.5297164916992, -1.56258833115722, 218, 30, 'PPL', 'P'),
(119223, 'Coral', 42.2172203063965, 0.736829495386428, -88.5644378662109, -1.54574104094332, 218, 18, 'PPL', 'P'),
(130345, 'Coral', 43.3627815246582, 0.756823310428252, -85.4027786254883, -1.49055967736661, 218, 27, 'PPL', 'P'),
(160411, 'Coral', 40.4991683959961, 0.706843832829762, -79.1741714477539, -1.38184997430179, 218, 45, 'PPL', 'P'),
(173657, 'Coral City', 44.3794403076172, 0.774567353560205, -91.2772216796875, -1.5930880503833, 218, 57, 'PPL', 'P'),
(15616, 'Coral Estates', 26.1602802276611, 0.456583023217059, -80.1277770996094, -1.3984935326923, 218, 12, 'PPL', 'P'),
(15617, 'Coral Gables', 25.7211093902588, 0.448918046125647, -80.2686080932617, -1.40095149722038, 218, 12, 'PPL', 'P'),
(15618, 'Coral Gardens', 27.139440536499, 0.473672594511124, -80.2113876342773, -1.3999528118116, 218, 12, 'PPL', 'P'),
(15619, 'Coral Heights', 26.1794395446777, 0.456917416381432, -80.1291732788086, -1.39851790061627, 218, 12, 'PPL', 'P'),
(203530, 'Coral Heights', 40.6366691589355, 0.70924367386706, -111.93083190918, -1.95356155131152, 218, 52, 'PPL', 'P'),
(35375, 'Coral Hill', 37.0513916015625, 0.646668775893041, -85.8563919067383, -1.4984767226552, 218, 21, 'PPL', 'P'),
(199888, 'Coral Hill (historical)', 40.6402816772461, 0.709306724205868, -115.724998474121, -2.01978225023883, 218, 39, 'PPL', 'P'),
(15620, 'Coral Hills', 26.188060760498, 0.457067884983021, -80.121940612793, -1.3983916667806, 218, 12, 'PPL', 'P'),
(45999, 'Coral Hills', 38.8702812194824, 0.678414388456085, -76.92138671875, -1.34253146344202, 218, 25, 'PPL', 'P'),
(15621, 'Coral Manor', 26.2999992370605, 0.459021579958703, -80.103889465332, -1.39807661482364, 218, 12, 'PPL', 'P'),
(15622, 'Coral Ridge', 26.1599998474121, 0.456578129658556, -80.1100006103516, -1.3981832744253, 218, 12, 'PPL', 'P'),
(15623, 'Coral Ridge Isles', 26.1924991607666, 0.457145349681229, -80.1180572509766, -1.39832388933086, 218, 12, 'PPL', 'P'),
(178002, 'Coral Sands Mobile Estates', 33.4208297729492, 0.583303518286513, -111.582778930664, -1.94748688086505, 218, 5, 'PPL', 'P'),
(15624, 'Coral Springs', 26.2708301544189, 0.458512483426821, -80.2708282470703, -1.40099024621425, 218, 12, 'PPL', 'P'),
(15625, 'Coral Terrace', 25.7455596923828, 0.449344784400819, -80.3047180175781, -1.40158173429235, 218, 12, 'PPL', 'P'),
(115105, 'Coral Trailer Park', 41.6741714477539, 0.727351504803918, -91.5749969482422, -1.59828520925059, 218, 16, 'PPL', 'P'),
(15626, 'Coral Villas', 26.2922191619873, 0.458885792032623, -80.0833282470703, -1.39771775386676, 218, 12, 'PPL', 'P'),
(15627, 'Coral Way Village', 25.7430591583252, 0.449301141848455, -80.3274993896484, -1.4019793442431, 218, 12, 'PPL', 'P'),
(15628, 'Coral Woods', 26.1669406890869, 0.45669927019864, -80.1275024414063, -1.39848873900233, 218, 12, 'PPL', 'P'),
(115106, 'Coralville', 41.6763916015625, 0.727390253797778, -91.5802764892578, -1.5983773546243, 218, 16, 'PPL', 'P'),
(148033, 'Coram', 40.8686103820801, 0.713291811882035, -73.0019378662109, -1.2741241761017, 218, 40, 'PPL', 'P'),
(193466, 'Coram', 40.7102813720703, 0.710528449355942, -122.440277099609, -2.1369859724424, 218, 6, 'PPL', 'P'),
(196274, 'Coram', 48.4180603027344, 0.845054569711877, -114.045280456543, -1.99046564032702, 218, 31, 'PPL', 'P'),
(86007, 'Coran', 36.3594398498535, 0.634591939560777, -83.0116729736328, -1.44882701097868, 218, 50, 'PPL', 'P'),
(160412, 'Coraopolis', 40.5183296203613, 0.707178259283649, -80.1669387817383, -1.39917703298606, 218, 45, 'PPL', 'P'),
(160413, 'Coraopolis Heights', 40.4655609130859, 0.706257271599673, -80.2061080932617, -1.39986066643789, 218, 45, 'PPL', 'P'),
(63904, 'Corapeake', 36.5341682434082, 0.637641525325026, -76.5766677856445, -1.33651498306537, 218, 33, 'PPL', 'P'),
(35376, 'Coraville', 37.7305603027344, 0.658522505904983, -87.4713897705078, -1.52666375279065, 218, 21, 'PPL', 'P'),
(188355, 'Corazon (historical)', 35.4466705322266, 0.618661109657004, -104.603332519531, -1.82567256102428, 218, 38, 'PPL', 'P'),
(86008, 'Corbandale', 36.4486083984375, 0.636148224322792, -87.5130615234375, -1.52739106208435, 218, 50, 'PPL', 'P'),
(93438, 'Corbet', 32.0063896179199, 0.558616880508833, -96.5366668701172, -1.68488268578447, 218, 51, 'PPL', 'P'),
(45996, 'Corbett', 39.5699996948242, 0.690626779687834, -76.6183319091797, -1.33724215920102, 218, 25, 'PPL', 'P'),
(63905, 'Corbett', 36.2497215270996, 0.632676993578955, -79.2391662597656, -1.38298434776811, 218, 33, 'PPL', 'P'),
(75527, 'Corbett', 34.973331451416, 0.610399784218497, -97.2291717529297, -1.69696917607569, 218, 42, 'PPL', 'P'),
(148036, 'Corbett', 42.0433311462402, 0.733794557008174, -75.022216796875, -1.30938469525046, 218, 40, 'PPL', 'P'),
(160415, 'Corbett', 41.6827812194824, 0.727501773668425, -77.7761077880859, -1.3574491602881, 218, 45, 'PPL', 'P'),
(200625, 'Corbett', 45.5319404602051, 0.794682275852601, -122.290000915527, -2.13436315824283, 218, 43, 'PPL', 'P'),
(45997, 'Corbett Hill Farms', 39.5558280944824, 0.690379438601593, -76.5997161865234, -1.33691725354803, 218, 25, 'PPL', 'P'),
(160416, 'Corbettown', 40.9669418334961, 0.715008019467509, -79.1822204589844, -1.38199045604929, 218, 45, 'PPL', 'P'),
(148034, 'Corbettsville', 42.0155601501465, 0.733309861689779, -75.7908325195313, -1.32279957029341, 218, 40, 'PPL', 'P'),
(1763, 'Corbin', 33.3013916015625, 0.581218928943253, -85.4255599975586, -1.49095728731736, 218, 2, 'PPL', 'P'),
(20242, 'Corbin', 34.2200012207031, 0.597251691337748, -84.695556640625, -1.47821632518825, 218, 13, 'PPL', 'P'),
(32146, 'Corbin', 37.1263885498047, 0.647977719568815, -97.5436096191406, -1.70245715213402, 218, 20, 'PPL', 'P'),
(35377, 'Corbin', 36.9486083984375, 0.644874870582763, -84.0969390869141, -1.46776847791576, 218, 21, 'PPL', 'P'),
(39895, 'Corbin', 30.4955596923828, 0.532247923870549, -90.8494415283203, -1.58562187826726, 218, 22, 'PPL', 'P'),
(45998, 'Corbin', 38.1552810668945, 0.665935281641164, -75.4911117553711, -1.31756845612222, 218, 25, 'PPL', 'P'),
(101071, 'Corbin', 38.1994400024414, 0.666706000460633, -77.3891677856445, -1.35069578323783, 218, 53, 'PPL', 'P'),
(196275, 'Corbin', 46.3805618286133, 0.809493512834104, -112.061111450195, -1.95583535825023, 218, 31, 'PPL', 'P'),
(32147, 'Corbin (historical)', 37.2519416809082, 0.650169035092759, -95.5541687011719, -1.66773485784156, 218, 20, 'PPL', 'P'),
(54196, 'Corbin (historical)', 38.0658302307129, 0.664374070031133, -93.5963897705078, -1.6335651694753, 218, 29, 'PPL', 'P'),
(108687, 'Corbin (historical)', 39.3091697692871, 0.68607443869948, -81.3475036621094, -1.41978177718195, 218, 58, 'PPL', 'P'),
(70694, 'Corbin City', 39.3033294677734, 0.685972506208757, -74.7561111450195, -1.30474027546742, 218, 37, 'PPL', 'P'),
(148035, 'Corbin Corner', 42.4469413757324, 0.740838884407542, -75.7255630493164, -1.32166040313713, 218, 40, 'PPL', 'P'),
(86009, 'Corbin Estates', 36.2541694641113, 0.632754624724731, -83.2658309936523, -1.45326290524838, 218, 50, 'PPL', 'P'),
(194779, 'Corbin Junction', 47.8911094665527, 0.83585754262437, -116.719718933105, -2.03714339738505, 218, 17, 'PPL', 'P'),
(1764, 'Corbinville', 34.2830581665039, 0.598352242658224, -86.1875, -1.50425564906261, 218, 2, 'PPL', 'P'),
(13596, 'Corbit', 39.5880584716797, 0.690941964802845, -75.6597213745117, -1.32051124912676, 218, 10, 'PPL', 'P'),
(196276, 'Corbly (historical)', 47.0788917541504, 0.821681669299933, -109.355560302734, -1.90861458264592, 218, 31, 'PPL', 'P'),
(93439, 'Corbyn', 29.648609161377, 0.517465848502983, -98.2347183227539, -1.71451927450126, 218, 51, 'PPL', 'P'),
(1765, 'Corcoran', 31.8313903808594, 0.555562567633648, -85.9497222900391, -1.50010564513594, 218, 2, 'PPL', 'P'),
(134800, 'Corcoran', 45.0952796936035, 0.787061107761121, -93.5472183227539, -1.63270696581402, 218, 28, 'PPL', 'P'),
(180863, 'Corcoran', 36.0980606079102, 0.630030011192498, -119.559440612793, -2.08670589053586, 218, 6, 'PPL', 'P'),
(8223, 'Cord', 35.811939239502, 0.625036251253463, -91.3433303833008, -1.59424186492557, 218, 4, 'PPL', 'P'),
(200626, 'Cord (historical)', 43.1258316040039, 0.752687754150496, -118.122497558594, -2.06162650307642, 218, 43, 'PPL', 'P'),
(124576, 'Cordage', 41.9791717529297, 0.732674764348823, -70.6916732788086, -1.23380245245931, 218, 23, 'PPL', 'P'),
(124577, 'Cordaville', 42.2688903808594, 0.737731308310556, -71.5244369506836, -1.24833692042452, 218, 23, 'PPL', 'P'),
(20244, 'Cordele', 31.9633293151855, 0.557865336449212, -83.7825012207031, -1.46228050185744, 218, 13, 'PPL', 'P'),
(93440, 'Cordele', 29.1347198486328, 0.508496788004786, -96.6297225952148, -1.68650681457526, 218, 51, 'PPL', 'P'),
(154849, 'Cordelia', 40.8994407653809, 0.713829903580286, -83.7858276367188, -1.4623385587692, 218, 41, 'PPL', 'P'),
(160417, 'Cordelia', 40.0513916015625, 0.69902865345287, -76.4747161865234, -1.33473559198304, 218, 45, 'PPL', 'P'),
(180861, 'Cordelia', 38.2105598449707, 0.666900078325073, -122.134719848633, -2.13165299235951, 218, 6, 'PPL', 'P'),
(180862, 'Cordelia Junction', 38.2169418334961, 0.667011465037665, -122.138610839844, -2.13172090296731, 218, 6, 'PPL', 'P'),
(35378, 'Cordell', 38.0055618286133, 0.663322187979579, -82.7930603027344, -1.44501150008493, 218, 21, 'PPL', 'P'),
(75529, 'Cordell', 35.2905616760254, 0.615936496124772, -98.9880599975586, -1.72766756711909, 218, 42, 'PPL', 'P'),
(86010, 'Cordell', 36.3369407653809, 0.634199256458044, -84.4494400024414, -1.47392077950801, 218, 50, 'PPL', 'P'),
(130346, 'Cordell', 46.1897201538086, 0.806162697258742, -84.8477783203125, -1.48087309469172, 218, 27, 'PPL', 'P'),
(207104, 'Cordell', 48.8666687011719, 0.85288426331671, -119.410827636719, -2.08411210479218, 218, 56, 'PPL', 'P'),
(1766, 'Cordell (historical)', 34.5255584716797, 0.602584671420632, -85.6286087036133, -1.49450115577993, 218, 2, 'PPL', 'P'),
(54197, 'Corder', 39.098331451416, 0.682394615863263, -93.6405563354492, -1.63433602145282, 218, 29, 'PPL', 'P'),
(108688, 'Corder Crossing', 39.1936111450195, 0.684057560226936, -80.0536117553711, -1.39719910324446, 218, 58, 'PPL', 'P'),
(86011, 'Corder Crossroads', 35.0855598449707, 0.61235853920025, -86.4733276367188, -1.50924428241655, 218, 50, 'PPL', 'P'),
(199889, 'Cordero', 41.9144401550293, 0.731544984835384, -117.813888549805, -2.05624025977174, 218, 39, 'PPL', 'P'),
(180864, 'Cordero Junction', 38.2877807617188, 0.668247837573735, -121.953330993652, -2.12848715961368, 218, 6, 'PPL', 'P'),
(26856, 'Cordes', 38.2961082458496, 0.668393179590226, -89.4572219848633, -1.56132306332332, 218, 18, 'PPL', 'P'),
(177999, 'Cordes', 34.3033294677734, 0.598706043609041, -112.166107177734, -1.95766787939631, 218, 5, 'PPL', 'P'),
(178000, 'Cordes Junction', 34.332218170166, 0.59921024658242, -112.119720458984, -1.95685827842493, 218, 5, 'PPL', 'P'),
(178001, 'Cordes Lakes', 34.3077812194824, 0.598783741333844, -112.102783203125, -1.95656266754393, 218, 5, 'PPL', 'P'),
(80482, 'Cordesville', 33.1319389343262, 0.578261421973693, -79.8836135864258, -1.39423207547401, 218, 48, 'PPL', 'P'),
(35379, 'Cordia', 37.2788887023926, 0.650639349341267, -83.1108322143555, -1.45055766621307, 218, 21, 'PPL', 'P'),
(192941, 'Cordillera', 35.9822196960449, 0.628008205871937, -105.35888671875, -1.83885946947791, 218, 38, 'PPL', 'P'),
(924, 'Cordova', 35.1555595397949, 0.613580264350324, -89.7761077880859, -1.56688867052742, 218, 50, 'PPL', 'P'),
(1767, 'Cordova', 33.7597198486328, 0.589218265909524, -87.1833267211914, -1.52163610412674, 218, 2, 'PPL', 'P'),
(20245, 'Cordova', 33.5569381713867, 0.585679057978863, -84.3755569458008, -1.47263127690819, 218, 13, 'PPL', 'P'),
(35380, 'Cordova', 38.540828704834, 0.672664357346495, -84.5152816772461, -1.47506993351838, 218, 21, 'PPL', 'P'),
(46000, 'Cordova', 38.875560760498, 0.678506533829802, -75.9963912963867, -1.32638724775591, 218, 25, 'PPL', 'P'),
(63907, 'Cordova', 34.9127807617188, 0.609342975318926, -79.8222198486328, -1.39316055260941, 218, 33, 'PPL', 'P'),
(80483, 'Cordova', 33.4352798461914, 0.583555719641743, -80.9211120605469, -1.41233983983184, 218, 48, 'PPL', 'P'),
(108689, 'Cordova', 38.0636100769043, 0.664335321037272, -80.4222183227539, -1.40363250148977, 218, 58, 'PPL', 'P'),
(115107, 'Cordova', 41.4244384765625, 0.722992842205839, -93.095832824707, -1.62482880267735, 218, 16, 'PPL', 'P'),
(119225, 'Cordova', 41.6802787780762, 0.727458097826548, -90.3188934326172, -1.57636206715705, 218, 18, 'PPL', 'P'),
(134802, 'Cordova', 44.3363914489746, 0.773816009237666, -93.67138671875, -1.63487411315108, 218, 28, 'PPL', 'P'),
(141543, 'Cordova', 40.7172203063965, 0.710649556606513, -97.352783203125, -1.69912660287476, 218, 35, 'PPL', 'P'),
(148037, 'Cordova', 42.4491691589355, 0.740877766559457, -79.3544387817383, -1.38499623281361, 218, 40, 'PPL', 'P'),
(180865, 'Cordova', 38.5102806091309, 0.672131192496261, -121.474166870117, -2.12012416800056, 218, 6, 'PPL', 'P'),
(188356, 'Cordova', 36.0072212219238, 0.628444564816547, -105.860000610352, -1.84760555681384, 218, 38, 'PPL', 'P'),
(196277, 'Cordova', 47.7216682434082, 0.832900235391892, -111.782783508301, -1.95097761926387, 218, 31, 'PPL', 'P'),
(211770, 'Cordova', 60.542781829834, 1.0566708812472, -145.757507324219, -2.54394841230737, 218, 1, 'PPL', 'P'),
(186576, 'Cordova Plaza', 37.1333312988281, 0.648098893398413, -104.829170227051, -1.82961417259565, 218, 7, 'PPL', 'P'),
(20246, 'Cordrays Mill', 31.5888900756836, 0.551330138871239, -84.5633316040039, -1.47590856294565, 218, 13, 'PPL', 'P'),
(160418, 'Corduroy', 41.5097198486328, 0.724481282939085, -78.9347229003906, -1.37767080876118, 218, 45, 'PPL', 'P'),
(108690, 'Core', 39.6800003051758, 0.692546652517672, -80.1074981689453, -1.39813959858342, 218, 58, 'PPL', 'P'),
(63908, 'Core Creek', 34.8283309936523, 0.607869048813622, -76.6933288574219, -1.33855110287679, 218, 33, 'PPL', 'P'),
(63909, 'Core Point', 35.4241714477539, 0.618268426554272, -76.8505630493164, -1.34129535722206, 218, 33, 'PPL', 'P'),
(20247, 'Corea', 31.2341709136963, 0.545139121574646, -84.7272186279297, -1.47876893111445, 218, 13, 'PPL', 'P'),
(127155, 'Corea', 44.4008293151855, 0.774940662166007, -67.9755630493164, -1.18639738610757, 218, 26, 'PPL', 'P'),
(196278, 'Corette', 44.6474990844727, 0.779245861805202, -111.148063659668, -1.93989966807746, 218, 31, 'PPL', 'P'),
(15629, 'Corey', 30.3630599975586, 0.529935367937979, -84.1819381713867, -1.46925199180099, 218, 12, 'PPL', 'P'),
(39896, 'Corey', 32.2224998474121, 0.562388715560712, -92.1100006103516, -1.60762278466462, 218, 22, 'PPL', 'P'),
(130347, 'Corey', 41.9027786254883, 0.731341452749074, -85.7608337402344, -1.49680891802253, 218, 27, 'PPL', 'P'),
(200627, 'Corey Hill', 45.8619384765625, 0.800441827763088, -123.204719543457, -2.15032801002953, 218, 43, 'PPL', 'P'),
(148038, 'Coreys', 44.4144401550293, 0.775178216135242, -74.3166732788086, -1.2970706378441, 218, 40, 'PPL', 'P'),
(63910, 'Coreys Crossroads', 35.7405586242676, 0.623790424495524, -77.0766677856445, -1.34524162932534, 218, 33, 'PPL', 'P'),
(143667, 'Coreys Mobile Park', 44.3066711425781, 0.773297292036346, -71.7533264160156, -1.2523317952177, 218, 36, 'PPL', 'P'),
(78078, 'Coreze', 39.9925003051758, 0.698000806430154, -75.3038864135742, -1.31430075746469, 218, 45, 'PPL', 'P'),
(148039, 'Corfu', 42.9599990844727, 0.749793430677797, -78.4058303833008, -1.36843989294881, 218, 40, 'PPL', 'P'),
(207106, 'Corfu', 46.8152809143066, 0.817080792200712, -119.454170227051, -2.08486857569982, 218, 56, 'PPL', 'P'),
(93441, 'Corina''s Corner Colonia', 26.3010005950928, 0.459039056953357, -98.3199996948242, -1.7160077152345, 218, 51, 'PPL', 'P'),
(127156, 'Corinna', 44.9211082458496, 0.78402124253485, -69.2622222900391, -1.20885382620939, 218, 26, 'PPL', 'P'),
(127157, 'Corinna Center', 44.9513893127441, 0.784549746853176, -69.2472229003906, -1.20859203747423, 218, 26, 'PPL', 'P'),
(75531, 'Corinne', 34.1858291625977, 0.596655276411625, -95.2911071777344, -1.66314356812227, 218, 42, 'PPL', 'P'),
(78079, 'Corinne', 39.9052810668945, 0.696478543551065, -75.6722183227539, -1.32072936202004, 218, 45, 'PPL', 'P'),
(108705, 'Corinne', 37.5727806091309, 0.655768730758814, -81.3566665649414, -1.41994170000541, 218, 58, 'PPL', 'P'),
(130348, 'Corinne', 46.086669921875, 0.804364131416557, -85.7219390869141, -1.49613007826067, 218, 27, 'PPL', 'P'),
(203533, 'Corinne', 41.5511093139648, 0.725203665384769, -112.109443664551, -1.95667891452551, 218, 52, 'PPL', 'P'),
(1768, 'Corinne (historical)', 33.1130599975586, 0.577931922367823, -87.1074981689453, -1.52031264622303, 218, 2, 'PPL', 'P'),
(1774, 'Corinth', 33.7849998474121, 0.589659485123123, -87.2033309936523, -1.52198524454565, 218, 2, 'PPL', 'P'),
(8227, 'Corinth', 35.0733299255371, 0.61214508683888, -93.4291687011719, -1.63064661123668, 218, 4, 'PPL', 'P'),
(20249, 'Corinth', 34.6674995422363, 0.605062010445651, -85.2477798461914, -1.48785443833131, 218, 13, 'PPL', 'P'),
(26857, 'Corinth', 37.8188896179199, 0.660064143281003, -88.7763900756836, -1.5494403048555, 218, 18, 'PPL', 'P'),
(32148, 'Corinth', 39.4161109924316, 0.687940915149462, -98.5449981689453, -1.71993467941988, 218, 20, 'PPL', 'P'),
(35382, 'Corinth', 36.788890838623, 0.64208727329075, -86.8038864135742, -1.51501362144404, 218, 21, 'PPL', 'P'),
(39897, 'Corinth', 32.7294387817383, 0.571236469071255, -92.7874984741211, -1.61944735306263, 218, 22, 'PPL', 'P'),
(59110, 'Corinth', 31.3436107635498, 0.547049207287478, -89.1397171020508, -1.55578155772708, 218, 30, 'PPL', 'P'),
(63912, 'Corinth', 35.3613891601563, 0.617172668923759, -81.7969436645508, -1.42762598501473, 218, 33, 'PPL', 'P'),
(86013, 'Corinth', 36.064998626709, 0.629452970763305, -83.8847198486328, -1.46406455347168, 218, 50, 'PPL', 'P'),
(93445, 'Corinth', 33.8447189331055, 0.590701779794753, -97.5216674804688, -1.70207418956926, 218, 51, 'PPL', 'P'),
(101074, 'Corinth', 36.7886085510254, 0.642082346442733, -80.8797225952148, -1.41161745738615, 218, 53, 'PPL', 'P'),
(108691, 'Corinth', 39.4216690063477, 0.688037920792168, -79.491943359375, -1.38739614042994, 218, 58, 'PPL', 'P'),
(112541, 'Corinth', 34.7122192382813, 0.605842516382126, -82.896110534668, -1.44681006592711, 218, 48, 'PPL', 'P'),
(130349, 'Corinth', 42.7827796936035, 0.746700368808752, -85.6636123657227, -1.49511208493399, 218, 27, 'PPL', 'P'),
(148040, 'Corinth', 43.2444381713867, 0.754757829265814, -73.8327789306641, -1.28862508823719, 218, 40, 'PPL', 'P'),
(154850, 'Corinth', 41.398609161377, 0.722542035612316, -80.6230621337891, -1.40713788727458, 218, 41, 'PPL', 'P'),
(173658, 'Corinth', 45.0027809143066, 0.785446699508315, -90.1391677856445, -1.5732252628671, 218, 57, 'PPL', 'P'),
(196279, 'Corinth', 45.8558311462402, 0.800335234740457, -107.964172363281, -1.88433028192993, 218, 31, 'PPL', 'P'),
(198142, 'Corinth', 48.6124992370605, 0.848448169309938, -103.327217102051, -1.80340014535378, 218, 34, 'PPL', 'P'),
(20250, 'Corinth (historical)', 32.0505599975586, 0.559387799065383, -84.0219421386719, -1.46645953423999, 218, 13, 'PPL', 'P'),
(80486, 'Corinth (historical)', 34.0977783203125, 0.595118499304595, -81.6227798461914, -1.42458625294651, 218, 48, 'PPL', 'P'),
(171878, 'Corinth Corner', 44.0222206115723, 0.768332693711248, -72.273063659668, -1.26140292136467, 218, 55, 'PPL', 'P'),
(171879, 'Corinth Corners', 44.0099983215332, 0.768119374507932, -72.3494415283203, -1.26273596664831, 218, 55, 'PPL', 'P'),
(101073, 'Corinth Fork', 37.7661094665527, 0.659142955859945, -77.2455596923828, -1.3481893491779, 218, 53, 'PPL', 'P'),
(20251, 'Corinth Hills', 33.8327789306641, 0.590493387439454, -84.116943359375, -1.46811761833467, 218, 13, 'PPL', 'P'),
(54198, 'Corioli (historical)', 38.9041709899902, 0.679005876534192, -92.9888916015625, -1.62296232622737, 218, 29, 'PPL', 'P'),
(20252, 'Cork', 33.2166709899902, 0.579740275327014, -83.8633270263672, -1.46369117828685, 218, 13, 'PPL', 'P'),
(35383, 'Cork', 37.0374984741211, 0.646426295075789, -85.5833282470703, -1.49371086272644, 218, 21, 'PPL', 'P'),
(148042, 'Cork', 43.0447196960449, 0.751272084294037, -74.4611129760742, -1.29959158613197, 218, 40, 'PPL', 'P'),
(154851, 'Cork', 41.7305603027344, 0.728335675984756, -80.9516677856445, -1.41287313784012, 218, 41, 'PPL', 'P'),
(160419, 'Cork', 40.4911117553711, 0.706703217924206, -80.3291702270508, -1.40200850585704, 218, 45, 'PPL', 'P'),
(178003, 'Cork', 32.9569396972656, 0.575207109098508, -109.918060302734, -1.91843205968839, 218, 5, 'PPL', 'P'),
(169336, 'Cork Hill (historical)', 41.8191719055176, 0.729882240208793, -71.4013900756836, -1.24618934732148, 218, 47, 'PPL', 'P'),
(160420, 'Cork Lane', 41.3125, 0.721039147230157, -75.7861099243164, -1.32271714545767, 218, 45, 'PPL', 'P'),
(54199, 'Corkery', 37.795280456543, 0.65965208568134, -92.8611068725586, -1.62073206197248, 218, 29, 'PPL', 'P'),
(207105, 'Corkindale', 48.5088882446289, 0.846639816350747, -121.472503662109, -2.12009513954468, 218, 56, 'PPL', 'P'),
(15636, 'Corkscrew', 26.4716701507568, 0.462017802632611, -81.559440612793, -1.42348077477802, 218, 12, 'PPL', 'P'),
(122431, 'Corkwell', 40.4672203063965, 0.706286233476527, -85.0586090087891, -1.48455278436988, 218, 19, 'PPL', 'P'),
(191320, 'Corlena', 36.3202781677246, 0.633908439267008, -102.938888549805, -1.79662253353758, 218, 51, 'PPL', 'P'),
(8228, 'Corley', 35.2133293151855, 0.614588537139028, -93.6344375610352, -1.63422922869311, 218, 4, 'PPL', 'P'),
(93446, 'Corley', 33.3261108398438, 0.581650361039846, -94.394172668457, -1.64748910776062, 218, 51, 'PPL', 'P'),
(108693, 'Corley', 38.7366714477539, 0.676082458026584, -80.5997161865234, -1.4067304236278, 218, 58, 'PPL', 'P'),
(115109, 'Corley', 41.5786094665527, 0.725683633592228, -95.3300018310547, -1.66382240788413, 218, 16, 'PPL', 'P'),
(39898, 'Corleyville', 31.4988899230957, 0.549759339881283, -93.3616714477539, -1.62946856192849, 218, 22, 'PPL', 'P'),
(108694, 'Corliss', 38.0341682434082, 0.663821464104941, -80.8702774047852, -1.41145260771468, 218, 58, 'PPL', 'P'),
(160421, 'Corliss', 40.4538917541504, 0.706053606355309, -80.0652770996094, -1.3974027019098, 218, 45, 'PPL', 'P'),
(173659, 'Cormier', 44.5627784729004, 0.777767208188963, -88.0780563354492, -1.53725208181064, 218, 57, 'PPL', 'P'),
(134807, 'Cormorant', 46.7305603027344, 0.815602138584473, -96.0652770996094, -1.67665538222889, 218, 28, 'PPL', 'P'),
(203534, 'Cormorant', 40.6191711425781, 0.708938275869055, -111.845558166504, -1.95207324373633, 218, 52, 'PPL', 'P'),
(75530, 'Corn', 35.378059387207, 0.61746361927285, -98.7816696166992, -1.72406537542865, 218, 42, 'PPL', 'P'),
(29549, 'Corn Brook', 39.2444381713867, 0.684944659186041, -85.9391708374023, -1.49992148754656, 218, 19, 'PPL', 'P'),
(202025, 'Corn Creek', 43.564998626709, 0.76035266466288, -101.200561523438, -1.76628300345107, 218, 49, 'PPL', 'P'),
(190078, 'Corn Creek (historical)', 36.4208297729492, 0.635663395846343, -115.380828857422, -2.0137753572421, 218, 39, 'PPL', 'P'),
(20253, 'Corn Creek Cove', 33.6311111450195, 0.586973620584751, -84.6347198486328, -1.47715452286164, 218, 13, 'PPL', 'P'),
(20255, 'Corn Crib Mobile Home Park', 33.7519416809082, 0.589082511272958, -84.8211135864258, -1.48040770729123, 218, 13, 'PPL', 'P'),
(93447, 'Corn Hill', 30.8066692352295, 0.537677809727598, -97.6147232055664, -1.70369831836005, 218, 51, 'PPL', 'P'),
(101075, 'Corn Valley', 36.8997192382813, 0.644021593769502, -81.9349975585938, -1.43003548001098, 218, 53, 'PPL', 'P'),
(75532, 'Cornatzar', 36.6388893127441, 0.639469252781148, -95.1074981689453, -1.65993898638257, 218, 42, 'PPL', 'P'),
(63913, 'Cornatzer', 35.9236106872559, 0.626985285697238, -80.4800033569336, -1.40464104059458, 218, 33, 'PPL', 'P'),
(20254, 'Cornelia', 34.5113906860352, 0.602337396913418, -83.5272216796875, -1.45782503335374, 218, 13, 'PPL', 'P'),
(54203, 'Cornelia', 38.6436080932617, 0.674458196077745, -93.7391662597656, -1.63605708930729, 218, 29, 'PPL', 'P'),
(108695, 'Cornelia', 38.2825012207031, 0.668155692200018, -80.9102783203125, -1.41215075539444, 218, 58, 'PPL', 'P'),
(115110, 'Cornelia', 42.7900009155273, 0.74682640290734, -93.6830596923828, -1.63507784497447, 218, 16, 'PPL', 'P'),
(173660, 'Cornelia', 42.6894416809082, 0.745071313169951, -90.5774993896484, -1.58087559257252, 218, 57, 'PPL', 'P'),
(186577, 'Cornelia', 38.0927810668945, 0.664844450858668, -103.287780761719, -1.80271185137005, 218, 7, 'PPL', 'P'),
(154852, 'Cornelion', 41.4930610656738, 0.724190532327075, -80.5311126708984, -1.4055330664017, 218, 41, 'PPL', 'P'),
(29550, 'Cornelius', 39.2997207641602, 0.685909522448977, -86.2980575561523, -1.50618524243043, 218, 19, 'PPL', 'P'),
(35384, 'Cornelius', 37.3138885498047, 0.651250211916304, -84.0088882446289, -1.46623170080873, 218, 21, 'PPL', 'P'),
(63914, 'Cornelius', 35.4866714477539, 0.619359257336769, -80.8602828979492, -1.41127817066328, 218, 33, 'PPL', 'P'),
(200628, 'Cornelius', 45.5200004577637, 0.794473883497302, -123.058609008789, -2.14777790012772, 218, 43, 'PPL', 'P'),
(180866, 'Cornelius (historical)', 38.9394416809082, 0.679621466220163, -121.542221069336, -2.12131193784674, 218, 6, 'PPL', 'P'),
(20256, 'Cornell', 33.6883316040039, 0.587972305993531, -84.3641662597656, -1.47243247193282, 218, 13, 'PPL', 'P'),
(32151, 'Cornell', 37.4633293151855, 0.6538584453089, -94.6305618286133, -1.65161487692137, 218, 20, 'PPL', 'P'),
(115111, 'Cornell', 42.9444389343262, 0.749521854825637, -95.1397171020508, -1.66050131284674, 218, 16, 'PPL', 'P'),
(119228, 'Cornell', 40.9900016784668, 0.715410489687248, -88.7291717529297, -1.54861618965617, 218, 18, 'PPL', 'P'),
(130350, 'Cornell', 45.9013900756836, 0.801130388062928, -87.2222213745117, -1.5223149438886, 218, 27, 'PPL', 'P'),
(160422, 'Cornell', 40.1911087036133, 0.701467176905002, -75.0325012207031, -1.30956419230793, 218, 45, 'PPL', 'P'),
(173661, 'Cornell', 45.1672210693359, 0.788316721636066, -91.149169921875, -1.5908531255965, 218, 57, 'PPL', 'P'),
(193467, 'Cornell', 41.7994384765625, 0.729537826900818, -121.318328857422, -2.11740428157926, 218, 6, 'PPL', 'P'),
(199247, 'Cornell (historical)', 40.0238914489746, 0.698548685245411, -100.937217712402, -1.76168678688376, 218, 35, 'PPL', 'P'),
(72219, 'Cornell Heights', 39.7763900756836, 0.694228971378275, -84.2402801513672, -1.47027025144378, 218, 41, 'PPL', 'P'),
(1775, 'Corner', 33.8002815246582, 0.589926200706295, -86.9422225952148, -1.51742804328831, 218, 2, 'PPL', 'P'),
(72208, 'Corner', 39.3088912963867, 0.68606957843049, -81.6619415283203, -1.42526975324028, 218, 41, 'PPL', 'P'),
(101076, 'Corner', 36.9530601501465, 0.644952568307566, -82.0372161865234, -1.43181953162522, 218, 53, 'PPL', 'P'),
(54200, 'Corner Campbell School', 39.7058296203613, 0.692997459111195, -93.4824981689453, -1.63157738603767, 218, 29, 'PPL', 'P'),
(607, 'Corner House', 39.3950004577637, 0.687572466812649, -77.5911102294922, -1.35422034378249, 218, 25, 'PPL', 'P'),
(13608, 'Corner Ketch', 39.7491683959961, 0.693753863439805, -75.7413864135742, -1.32193657294217, 218, 10, 'PPL', 'P'),
(160423, 'Corner Ketch', 40.0369415283203, 0.69877645209764, -75.75, -1.3220869083857, 218, 45, 'PPL', 'P'),
(113002, 'Corner of the Pines', 41.8386116027832, 0.730221526931669, -73.3288879394531, -1.27983053136942, 218, 8, 'PPL', 'P'),
(188357, 'Corner Ranch', 31.3561096191406, 0.547267353470269, -108.210563659668, -1.88863062130013, 218, 38, 'PPL', 'P'),
(160424, 'Corner Store', 40.1175003051758, 0.700182467995147, -75.5052795410156, -1.31781573062944, 218, 45, 'PPL', 'P'),
(188359, 'Corner Well', 32.4980583190918, 0.567198118173286, -105.071388244629, -1.83384167451004, 218, 38, 'PPL', 'P'),
(178004, 'Corner Windmill', 32.1188888549805, 0.560580362601521, -111.321113586426, -1.94291995906972, 218, 5, 'PPL', 'P'),
(191318, 'Corner Windmill', 30.1597194671631, 0.526386406179826, -100.919166564941, -1.7613717349268, 218, 51, 'PPL', 'P'),
(35385, 'Corners', 37.7947196960449, 0.659642298564334, -86.2302780151367, -1.50500226627422, 218, 21, 'PPL', 'P'),
(54201, 'Corners', 37.6563911437988, 0.657228009878123, -90.1108322143555, -1.57273071385268, 218, 29, 'PPL', 'P'),
(154854, 'Cornersburg', 41.0627784729004, 0.716680684369161, -80.7113876342773, -1.40867945807158, 218, 41, 'PPL', 'P'),
(1776, 'Cornerstone', 32.1558303833008, 0.561225113901429, -85.8422164916992, -1.49822931498993, 218, 2, 'PPL', 'P'),
(8229, 'Cornerstone', 34.230281829834, 0.597431121816192, -91.745002746582, -1.6012523701791, 218, 4, 'PPL', 'P'),
(46001, 'Cornersville', 38.5963897705078, 0.67363408087842, -76.2094421386719, -1.33010568642793, 218, 25, 'PPL', 'P'),
(59111, 'Cornersville', 34.538890838623, 0.602817365120878, -89.2555618286133, -1.55780342962667, 218, 30, 'PPL', 'P'),
(86014, 'Cornersville', 35.3613891601563, 0.617172668923759, -86.8397216796875, -1.51563906482605, 218, 50, 'PPL', 'P'),
(8230, 'Cornertown', 36.4980583190918, 0.637011288253059, -91.7583312988281, -1.60148499730032, 218, 4, 'PPL', 'P'),
(54202, 'Cornertown', 36.4991683959961, 0.637030662749989, -91.7583312988281, -1.60148499730032, 218, 29, 'PPL', 'P'),
(39899, 'Cornerview', 30.2408294677734, 0.527802042746771, -90.966667175293, -1.58766785177471, 218, 22, 'PPL', 'P'),
(8231, 'Cornerville', 33.8441696166992, 0.590692192414829, -91.9402770996094, -1.60466055058413, 218, 4, 'PPL', 'P'),
(26858, 'Cornerville', 37.9069404602051, 0.661600920388033, -88.6233291625977, -1.54676888796604, 218, 18, 'PPL', 'P'),
(72209, 'Cornerville', 39.396671295166, 0.687601628426586, -81.375, -1.42026167881039, 218, 41, 'PPL', 'P'),
(207107, 'Cornet', 48.396110534668, 0.844671473989069, -122.628326416016, -2.14026805216981, 218, 56, 'PPL', 'P'),
(93448, 'Cornett', 33.1294403076172, 0.578217812710843, -94.5744400024414, -1.65063536627244, 218, 51, 'PPL', 'P'),
(35386, 'Cornette', 37.2930603027344, 0.650886690427508, -84.0927810668945, -1.46769590677606, 218, 21, 'PPL', 'P'),
(29552, 'Cornettsville', 38.7566719055176, 0.676431531866466, -87.1100006103516, -1.5203563220649, 218, 19, 'PPL', 'P'),
(35388, 'Cornettsville', 37.1338882446289, 0.648108613936392, -83.0769424438477, -1.44996617813497, 218, 21, 'PPL', 'P'),
(113004, 'Cornfield Park', 41.2619400024414, 0.72015670880296, -72.3874969482422, -1.26340015902417, 218, 8, 'PPL', 'P'),
(178006, 'Cornfields', 35.6522216796875, 0.62224865396145, -109.678611755371, -1.91425289414778, 218, 5, 'PPL', 'P'),
(8234, 'Cornhill (historical)', 33.8541717529297, 0.590866762624283, -94.0338897705078, -1.64120098495278, 218, 4, 'PPL', 'P'),
(1777, 'Cornhouse', 33.2224998474121, 0.579842008080655, -85.4558334350586, -1.49148565847763, 218, 2, 'PPL', 'P'),
(141545, 'Cornhusker Trailer Court', 40.6994400024414, 0.710339231760492, -99.0811080932617, -1.72929156275182, 218, 35, 'PPL', 'P'),
(8232, 'Cornie', 33.0677795410156, 0.577141629314342, -92.725830078125, -1.61837103650807, 218, 4, 'PPL', 'P'),
(8235, 'Corning', 36.4077796936035, 0.635435628994114, -90.579719543457, -1.58091434156638, 218, 4, 'PPL', 'P'),
(29551, 'Corning', 38.5827789306641, 0.673396526909185, -87.0175018310547, -1.5187419138121, 218, 19, 'PPL', 'P'),
(32150, 'Corning', 39.6572189331055, 0.692149042566923, -96.029167175293, -1.67602514515693, 218, 20, 'PPL', 'P'),
(72210, 'Corning', 39.6025009155273, 0.691194033000021, -82.0883331298828, -1.4327116905904, 218, 41, 'PPL', 'P'),
(115112, 'Corning', 40.9900016784668, 0.715410489687248, -94.7405624389648, -1.65353474975121, 218, 16, 'PPL', 'P'),
(130352, 'Corning', 42.7247200012207, 0.745687036013977, -85.600830078125, -1.49401632730348, 218, 27, 'PPL', 'P'),
(134809, 'Corning', 43.7611083984375, 0.763775425874877, -93.0491714477539, -1.624014408016, 218, 28, 'PPL', 'P'),
(139105, 'Corning', 40.2483291625977, 0.702465862313781, -95.4538879394531, -1.66598462837316, 218, 29, 'PPL', 'P'),
(148043, 'Corning', 42.1427803039551, 0.735530272248633, -77.0550003051758, -1.34486346045055, 218, 40, 'PPL', 'P'),
(160425, 'Corning', 40.4513893127441, 0.706009930513432, -75.5308303833008, -1.31826167695397, 218, 45, 'PPL', 'P'),
(180868, 'Corning', 39.9277801513672, 0.696871226653797, -122.178062438965, -2.13240946326715, 218, 6, 'PPL', 'P'),
(86015, 'Corning (historical)', 35.0938911437988, 0.612503947795768, -87.6050033569336, -1.52899574979918, 218, 50, 'PPL', 'P'),
(148044, 'Corning Manor', 42.1208305358887, 0.735147176525825, -77.0055618286133, -1.34400059625737, 218, 40, 'PPL', 'P'),
(59112, 'Cornish', 34.2680587768555, 0.598090453923069, -89.3583297729492, -1.55959706862084, 218, 30, 'PPL', 'P'),
(75533, 'Cornish', 34.1588897705078, 0.596185095321172, -97.5966720581055, -1.70338326640309, 218, 42, 'PPL', 'P'),
(78082, 'Cornish', 39.7574996948242, 0.693899272035323, -79.8258285522461, -1.39322353636919, 218, 45, 'PPL', 'P'),
(127160, 'Cornish', 43.8047218322754, 0.764536623893449, -70.8016662597656, -1.23572219213109, 218, 26, 'PPL', 'P'),
(145043, 'Cornish', 40.7975006103516, 0.712050712235031, -75.0350036621094, -1.30960786814981, 218, 37, 'PPL', 'P'),
(194146, 'Cornish', 40.5230598449707, 0.707260817277442, -104.412780761719, -1.82234680545499, 218, 7, 'PPL', 'P'),
(203535, 'Cornish', 41.9755592346191, 0.732611714010015, -111.952499389648, -1.95393972018631, 218, 52, 'PPL', 'P'),
(199890, 'Cornish Camp (historical)', 40.0277786254883, 0.698616529274181, -118.025001525879, -2.05992487629792, 218, 39, 'PPL', 'P'),
(143668, 'Cornish Center', 43.482780456543, 0.758917686888518, -72.3199996948242, -1.26222210971598, 218, 36, 'PPL', 'P'),
(143669, 'Cornish City', 43.4666709899902, 0.758636523656433, -72.3505630493164, -1.26275554088232, 218, 36, 'PPL', 'P'),
(143670, 'Cornish Flat', 43.4972190856934, 0.759169688506667, -72.2799987792969, -1.26152396203621, 218, 36, 'PPL', 'P'),
(13597, 'Cornish Hills', 39.7708282470703, 0.694131899156542, -75.7083282470703, -1.321359599092, 218, 10, 'PPL', 'P'),
(143671, 'Cornish Mills', 43.4644393920898, 0.75859757492549, -72.3694381713867, -1.26308497390916, 218, 36, 'PPL', 'P'),
(35387, 'Cornishville', 37.8002815246582, 0.659739370786068, -84.9936065673828, -1.48341827774551, 218, 21, 'PPL', 'P'),
(26859, 'Cornland', 39.9372215270996, 0.697036009746246, -89.4022216796875, -1.5603631269084, 218, 18, 'PPL', 'P'),
(39900, 'Cornland', 30.0611095428467, 0.524665338325362, -90.5444412231445, -1.58029861872235, 218, 22, 'PPL', 'P'),
(54204, 'Cornland', 38.1777801513672, 0.666327964743897, -94.3836135864258, -1.64730481701318, 218, 29, 'PPL', 'P'),
(101080, 'Cornland', 36.6266708374023, 0.63925600015686, -76.3216705322266, -1.33206444140969, 218, 53, 'PPL', 'P'),
(141546, 'Cornlea', 41.6800003051758, 0.727453237557559, -97.5661087036133, -1.70284983523675, 218, 35, 'PPL', 'P'),
(160426, 'Cornog', 40.0766716003418, 0.699469872666469, -75.754997253418, -1.3221741269114, 218, 45, 'PPL', 'P'),
(160427, 'Cornplanter (historical)', 41.9416694641113, 0.732020225931908, -78.9333267211914, -1.37764644083721, 218, 45, 'PPL', 'P'),
(46002, 'Corns Manor', 39.5544395446777, 0.690355203835673, -76.2727813720703, -1.33121116459643, 218, 25, 'PPL', 'P'),
(72211, 'Cornstalk', 39.5702781677246, 0.690631639956823, -83.9858322143555, -1.46582929716802, 218, 41, 'PPL', 'P'),
(108696, 'Cornstalk', 37.9461097717285, 0.662284553839857, -80.5297164916992, -1.40550869847773, 218, 58, 'PPL', 'P'),
(173664, 'Cornucopia', 46.853889465332, 0.81775463853553, -91.1016693115234, -1.59002408354916, 218, 57, 'PPL', 'P'),
(200629, 'Cornucopia', 45.0083312988281, 0.785543571992967, -117.191673278809, -2.04538055463667, 218, 43, 'PPL', 'P'),
(199891, 'Cornucopia (historical)', 41.5349998474121, 0.724922502152684, -116.291389465332, -2.02966763788909, 218, 39, 'PPL', 'P'),
(191319, 'Cornudas', 31.7797203063965, 0.55466075470952, -105.470558166504, -1.84080850392169, 218, 51, 'PPL', 'P'),
(127162, 'Cornville', 44.836669921875, 0.782547515766628, -69.6736068725586, -1.2160338416663, 218, 26, 'PPL', 'P'),
(178005, 'Cornville', 34.7177810668945, 0.605939588603859, -111.920829772949, -1.95338698110206, 218, 5, 'PPL', 'P'),
(54205, 'Cornwall', 37.5122184753418, 0.654711722122162, -90.2027816772461, -1.57433553472556, 218, 29, 'PPL', 'P'),
(63916, 'Cornwall', 36.4794387817383, 0.636686316021042, -78.6655578613281, -1.37297299259828, 218, 33, 'PPL', 'P'),
(101077, 'Cornwall', 37.8044395446777, 0.659811941925772, -79.3188934326172, -1.38437584943768, 218, 53, 'PPL', 'P'),
(113005, 'Cornwall', 41.8436088562012, 0.730308745457369, -73.329719543457, -1.27984504559736, 218, 8, 'PPL', 'P'),
(160429, 'Cornwall', 40.273609161377, 0.70290708152738, -76.4063873291016, -1.3335430284469, 218, 45, 'PPL', 'P'),
(171881, 'Cornwall', 43.9608306884766, 0.767261237425682, -73.2108306884766, -1.27777004363402, 218, 55, 'PPL', 'P'),
(180869, 'Cornwall', 38.0205612182617, 0.663583976714733, -121.877777099609, -2.12716849539993, 218, 6, 'PPL', 'P'),
(194781, 'Cornwall', 46.7088890075684, 0.815223903130655, -116.864723205566, -2.03967419936896, 218, 17, 'PPL', 'P'),
(113006, 'Cornwall Bridge', 41.8186111450195, 0.729872453091787, -73.3713912963867, -1.28057235489106, 218, 8, 'PPL', 'P'),
(160430, 'Cornwall Center', 40.2772216796875, 0.702970131866188, -76.413330078125, -1.3336642022765, 218, 45, 'PPL', 'P'),
(1778, 'Cornwall Furnace', 34.2405586242676, 0.597610485715609, -85.5872192382813, -1.49377877333424, 218, 2, 'PPL', 'P'),
(160431, 'Cornwall Furnace', 40.2705612182617, 0.702853884884606, -76.4061126708984, -1.33353823475694, 218, 45, 'PPL', 'P'),
(160432, 'Cornwall Junction', 40.3424987792969, 0.704109432180524, -76.4402770996094, -1.33413451652501, 218, 45, 'PPL', 'P'),
(148047, 'Cornwall Landing', 41.4433288574219, 0.723322541548791, -74.0008316040039, -1.29155816070374, 218, 40, 'PPL', 'P'),
(148049, 'Cornwall-on-Hudson', 41.4447212219238, 0.723346842893738, -74.01611328125, -1.29182487628692, 218, 40, 'PPL', 'P'),
(108697, 'Cornwallis', 39.2272186279297, 0.684644121457025, -81.1186065673828, -1.41578676923073, 218, 58, 'PPL', 'P'),
(148050, 'Cornwallville', 42.3680610656738, 0.739462163282026, -74.1586074829102, -1.29431186927089, 218, 40, 'PPL', 'P'),
(15630, 'Cornwell', 27.3783302307129, 0.477842006224239, -81.0969390869141, -1.41540860035593, 218, 12, 'PPL', 'P'),
(35389, 'Cornwell', 37.9566688537598, 0.66246884458729, -83.7111129760742, -1.46103454194144, 218, 21, 'PPL', 'P'),
(80487, 'Cornwell', 34.6072196960449, 0.604009928657015, -81.179443359375, -1.41684857155734, 218, 48, 'PPL', 'P'),
(101078, 'Cornwell', 38.6888885498047, 0.675248489131226, -77.4416732788086, -1.35161217696892, 218, 53, 'PPL', 'P'),
(160434, 'Cornwell', 40.0694389343262, 0.6993436388308, -74.9683303833008, -1.3084441999115, 218, 45, 'PPL', 'P'),
(180870, 'Cornwell (historical)', 36.399169921875, 0.635285360129606, -119.779441833496, -2.09054563619554, 218, 6, 'PPL', 'P'),
(160435, 'Cornwells Heights', 40.0766716003418, 0.699469872666469, -74.9491729736328, -1.30810984003664, 218, 45, 'PPL', 'P'),
(160436, 'Cornwells Manor', 40.0716705322266, 0.699382587561742, -74.9483337402344, -1.30809519265065, 218, 45, 'PPL', 'P'),
(63918, 'Corola Hills', 35.8849983215332, 0.626311372783393, -81.6163864135742, -1.42447466649684, 218, 33, 'PPL', 'P'),
(63917, 'Corolla', 36.3811111450195, 0.634970175014595, -75.8333282470703, -1.323541260657, 218, 33, 'PPL', 'P'),
(180871, 'Coromar', 34.4341697692871, 0.600989637664756, -119.866668701172, -2.09206803223268, 218, 6, 'PPL', 'P'),
(1779, 'Corona', 33.7083282470703, 0.588321313254386, -87.4694366455078, -1.5266296643287, 218, 2, 'PPL', 'P'),
(54206, 'Corona', 36.5511093139648, 0.637937202785052, -91.4116668701172, -1.59543456161976, 218, 29, 'PPL', 'P'),
(86016, 'Corona', 35.4452781677246, 0.618636808312057, -90.0824966430664, -1.57223616483825, 218, 50, 'PPL', 'P'),
(134812, 'Corona', 46.6705589294434, 0.814554917064827, -92.76611328125, -1.61907411103585, 218, 28, 'PPL', 'P'),
(148051, 'Corona', 40.746940612793, 0.711168273807833, -73.8605575561523, -1.28910991671364, 218, 40, 'PPL', 'P'),
(170078, 'Corona', 45.3338890075684, 0.791225625915732, -96.7627792358398, -1.68882909104581, 218, 49, 'PPL', 'P'),
(180872, 'Corona', 33.8752784729004, 0.591235144382068, -117.565559387207, -2.05190609825569, 218, 6, 'PPL', 'P'),
(188360, 'Corona', 34.2508316040039, 0.597789783035999, -105.59610748291, -1.8429997528666, 218, 38, 'PPL', 'P'),
(180873, 'Corona (historical)', 38.2636108398438, 0.667825992857066, -122.658332824707, -2.14079176279817, 218, 6, 'PPL', 'P'),
(186578, 'Corona (historical)', 39.934440612793, 0.696987473635379, -105.684722900391, -1.84454638366967, 218, 7, 'PPL', 'P'),
(178008, 'Corona de Tucson', 31.9652805328369, 0.557899391621652, -110.775001525879, -1.93338850552833, 218, 5, 'PPL', 'P'),
(180874, 'Corona del Mar', 33.5980606079102, 0.58639677989264, -117.872222900391, -2.05725838625648, 218, 6, 'PPL', 'P'),
(178007, 'Corona Village', 33.3180618286133, 0.581509879292344, -111.924438476563, -1.95344996486184, 218, 5, 'PPL', 'P'),
(80489, 'Coronaca', 34.2597198486328, 0.597944912169496, -82.0944366455078, -1.432818217034, 218, 48, 'PPL', 'P'),
(101079, 'Coronado', 36.9013900756836, 0.644050755383438, -76.2466735839844, -1.33075549773391, 218, 53, 'PPL', 'P'),
(180875, 'Coronado', 32.6858291625977, 0.57047533763171, -117.182220458984, -2.04521557180714, 218, 6, 'PPL', 'P'),
(187638, 'Coronado', 38.4858283996582, 0.671704420931576, -101.304168701172, -1.76809128983124, 218, 20, 'PPL', 'P'),
(93450, 'Coronado Colonia', 26.238000869751, 0.45793950431829, -98.2890014648438, -1.71546669405905, 218, 51, 'PPL', 'P'),
(20257, 'Coronado Forest', 33.725830078125, 0.588626777831418, -84.7788925170898, -1.4796708106176, 218, 13, 'PPL', 'P'),
(180876, 'Coronado Gardens Mobile Home Park', 33.7013893127441, 0.588200206003814, -116.238891601563, -2.02875137731605, 218, 6, 'PPL', 'P'),
(180877, 'Coronado Heights (historical)', 32.600830078125, 0.568991823746482, -117.126937866211, -2.0442507085442, 218, 6, 'PPL', 'P'),
(191321, 'Coronado Hills', 31.8280601501465, 0.555504444142857, -106.52693939209, -1.85924583446441, 218, 51, 'PPL', 'P'),
(178009, 'Coronado Mobile Home Park', 33.413330078125, 0.583172623918935, -111.771942138672, -1.95078840166842, 218, 5, 'PPL', 'P'),
(93451, 'Coronado Perez Addition Colonia', 27.878999710083, 0.486580337103493, -98.6029968261719, -1.72094694695022, 218, 51, 'PPL', 'P'),
(200630, 'Coronado Shores', 44.8652801513672, 0.783046858471017, -124.038330078125, -2.1648772585388, 218, 43, 'PPL', 'P'),
(178010, 'Coronado Village', 31.5486106872559, 0.550627130922486, -110.347221374512, -1.92592233341229, 218, 5, 'PPL', 'P'),
(93452, 'Coronados Camp', 32.8486099243164, 0.573316397882607, -98.2091674804688, -1.71407332817672, 218, 51, 'PPL', 'P'),
(15631, 'Coronet', 27.9872207641602, 0.488469150817118, -82.0808334350586, -1.43258079622282, 218, 12, 'PPL', 'P'),
(180878, 'Corporal', 36.9297218322754, 0.644545237818839, -121.546943664551, -2.12139436268247, 218, 6, 'PPL', 'P'),
(93453, 'Corpus Christi', 27.8002796173096, 0.485206412297121, -97.396110534668, -1.69988280746629, 218, 51, 'PPL', 'P'),
(191322, 'Corpus Christi de la Isleta (historical)', 31.6983299255371, 0.553240224584072, -106.324440002441, -1.85571155338177, 218, 51, 'PPL', 'P'),
(148052, 'Corrado Corners', 43.0311088562012, 0.751034530324802, -75.0772171020508, -1.31034463166538, 218, 40, 'PPL', 'P'),
(196280, 'Corral', 46.2744407653809, 0.807641350874981, -113.431938171387, -1.97976079800933, 218, 31, 'PPL', 'P'),
(93454, 'Corral City', 33.0999984741211, 0.577703955778512, -97.225830078125, -1.69691085284782, 218, 51, 'PPL', 'P'),
(196281, 'Corral Creek (historical)', 47.4488906860352, 0.828139368890184, -105.309173583984, -1.83799181159476, 218, 31, 'PPL', 'P'),
(75535, 'Corral Crossing', 34.6655616760254, 0.605028188299807, -98.3791732788086, -1.71704048910524, 218, 42, 'PPL', 'P'),
(180883, 'Corral de Tierra', 36.5699996948242, 0.638266902128004, -121.731391906738, -2.12461359180816, 218, 6, 'PPL', 'P'),
(188361, 'Corrales', 35.2377815246582, 0.615015308703713, -106.606109619141, -1.860627615596, 218, 38, 'PPL', 'P'),
(180884, 'Corralitos', 36.9886093139648, 0.645573018262528, -121.805282592773, -2.12590322756603, 218, 6, 'PPL', 'P'),
(29553, 'Correct', 39.0086097717285, 0.680828677142296, -85.2863922119141, -1.48852835124515, 218, 19, 'PPL', 'P'),
(115113, 'Correctionville', 42.4749984741211, 0.741328573152981, -95.7852783203125, -1.6717684816286, 218, 16, 'PPL', 'P'),
(178011, 'Correjo Crossing', 34.0916709899902, 0.595011906281964, -109.203056335449, -1.90595288629444, 218, 5, 'PPL', 'P'),
(134813, 'Correll', 45.2308311462402, 0.789426926915493, -96.1591720581055, -1.67829415840567, 218, 28, 'PPL', 'P'),
(63925, 'Correll Park', 35.6025009155273, 0.621380862920248, -80.4994430541992, -1.40498032731746, 218, 33, 'PPL', 'P'),
(46003, 'Correlli Estates', 39.4161109924316, 0.687940915149462, -76.4394378662109, -1.33411986913901, 218, 25, 'PPL', 'P'),
(188362, 'Correo', 34.9550018310547, 0.610079871992551, -107.184173583984, -1.87071673506966, 218, 38, 'PPL', 'P'),
(54207, 'Corridon', 37.3819389343262, 0.652437915183452, -91.0722198486328, -1.58951009345877, 218, 29, 'PPL', 'P'),
(46004, 'Corridor North', 39.1352806091309, 0.683039500321226, -76.8024978637695, -1.34045646147869, 218, 25, 'PPL', 'P'),
(93457, 'Corriente Estates Colonia', 28.0219993591309, 0.489076151808574, -97.5500030517578, -1.70256873858369, 218, 51, 'PPL', 'P'),
(93455, 'Corrigan', 30.9966697692871, 0.540993944627451, -94.8269424438477, -1.6550423652443, 218, 51, 'PPL', 'P'),
(46005, 'Corriganville', 39.6927795410156, 0.692769692258966, -78.7930603027344, -1.37519833000515, 218, 25, 'PPL', 'P'),
(180885, 'Corriganville', 34.2675018310547, 0.59808073338509, -118.66667175293, -2.07112413447197, 218, 6, 'PPL', 'P'),
(63920, 'Corriher Heights', 35.5605583190918, 0.620648826515612, -80.6350021362305, -1.40734627962988, 218, 33, 'PPL', 'P'),
(59113, 'Corrine (historical)', 33.6894416809082, 0.587991680490461, -88.5299987792969, -1.54513996548529, 218, 30, 'PPL', 'P'),
(59114, 'Corrona', 34.4700012207031, 0.601615014467734, -88.767219543457, -1.54928024887398, 218, 30, 'PPL', 'P'),
(188363, 'Corrumpa (historical)', 36.7822189331055, 0.641970826572086, -103.507217407227, -1.80654174333369, 218, 38, 'PPL', 'P'),
(54208, 'Corry', 37.4874992370605, 0.654280290025569, -93.7249984741211, -1.63580981480007, 218, 29, 'PPL', 'P'),
(160437, 'Corry', 41.920280456543, 0.731646917326107, -79.6405563354492, -1.38998992617362, 218, 45, 'PPL', 'P'),
(191323, 'Corry', 34.026668548584, 0.593877399657591, -102.100830078125, -1.78199565388254, 218, 51, 'PPL', 'P'),
(86018, 'Corryton', 36.1536102294922, 0.630999534987341, -83.7825012207031, -1.46228050185744, 218, 50, 'PPL', 'P'),
(72213, 'Corryville', 38.4355583190918, 0.670827042510449, -82.4216690063477, -1.43852949914973, 218, 41, 'PPL', 'P'),
(80490, 'Corsada (historical)', 33.3805618286133, 0.582600710074841, -80.1963882446289, -1.39969102307645, 218, 48, 'PPL', 'P'),
(160439, 'Corsica', 41.1811103820801, 0.718745965794517, -79.2024993896484, -1.38234439015816, 218, 45, 'PPL', 'P'),
(170080, 'Corsica', 43.4252815246582, 0.757914141210749, -98.4069366455078, -1.71752505126558, 218, 49, 'PPL', 'P'),
(46006, 'Corsica Landing', 39.0758285522461, 0.682001866181503, -76.1119384765625, -1.32840392649137, 218, 25, 'PPL', 'P'),
(46007, 'Corsica Landing Estates', 39.060001373291, 0.681725629797435, -76.0752792358398, -1.32776410203948, 218, 25, 'PPL', 'P'),
(54209, 'Corsicana', 36.7988891601563, 0.642261776921177, -93.9947204589844, -1.64051735150095, 218, 29, 'PPL', 'P'),
(93456, 'Corsicana', 32.0952796936035, 0.560168305001858, -96.4686126708984, -1.6836949159383, 218, 51, 'PPL', 'P'),
(39901, 'Corso', 29.9388904571533, 0.522532212871236, -90.3272171020508, -1.57650734259452, 218, 22, 'PPL', 'P'),
(54211, 'Corso', 39.1272201538086, 0.682898818836642, -91.1858291625977, -1.59149295004839, 218, 29, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(170082, 'Corson', 43.6163902282715, 0.761249617318019, -96.5713882446289, -1.68548868809052, 218, 49, 'PPL', 'P'),
(127163, 'Corson Corner', 44.8994407653809, 0.783643073660059, -69.602783203125, -1.21479773544634, 218, 26, 'PPL', 'P'),
(160441, 'Corsons', 40.1083297729492, 0.700022412013634, -75.2750015258789, -1.31379662107034, 218, 45, 'PPL', 'P'),
(127164, 'Corsons Corner', 44.9797210693359, 0.785044229288577, -69.6822204589844, -1.21618417710983, 218, 26, 'PPL', 'P'),
(134815, 'Cort', 47.3327789306641, 0.826112836458689, -93.246940612793, -1.62746613110486, 218, 28, 'PPL', 'P'),
(178012, 'Corta Junction', 31.396110534668, 0.547965501150033, -109.883056640625, -1.91782113053433, 218, 5, 'PPL', 'P'),
(178013, 'Cortaro', 32.3561096191406, 0.564720645990212, -111.087783813477, -1.93884758628883, 218, 5, 'PPL', 'P'),
(180887, 'Corte Madera', 37.9255599975586, 0.66192589262005, -122.526390075684, -2.13848892740358, 218, 6, 'PPL', 'P'),
(1781, 'Cortelyou', 31.4233303070068, 0.54844057579899, -88.0083312988281, -1.53603515035053, 218, 2, 'PPL', 'P'),
(180889, 'Cortena', 39.2191696166992, 0.684503639709524, -122.184997558594, -2.13253050393869, 218, 6, 'PPL', 'P'),
(15632, 'Cortez', 27.4688892364502, 0.479422559041687, -82.686393737793, -1.44314981732491, 218, 12, 'PPL', 'P'),
(160443, 'Cortez', 41.4652786254883, 0.723705637271599, -75.4574966430664, -1.31698176173408, 218, 45, 'PPL', 'P'),
(180890, 'Cortez', 37.4752807617188, 0.654067037401281, -120.738609313965, -2.10728626680778, 218, 6, 'PPL', 'P'),
(186579, 'Cortez', 37.3488883972168, 0.651861074491341, -108.58528137207, -1.89517067914709, 218, 7, 'PPL', 'P'),
(199893, 'Cortez', 40.1411094665527, 0.70059452559481, -116.602500915527, -2.03509755703565, 218, 39, 'PPL', 'P'),
(93458, 'Cortez Colonia', 26.3810005187988, 0.460435319023372, -98.8320007324219, -1.72494381911421, 218, 51, 'PPL', 'P'),
(15633, 'Cortez Estates', 27.4194393157959, 0.47855949511142, -80.3530578613281, -1.40242542372569, 218, 12, 'PPL', 'P'),
(54212, 'Corticelli', 38.5099983215332, 0.672126265648244, -92.5244369506836, -1.61485606334333, 218, 29, 'PPL', 'P'),
(29554, 'Cortland', 38.9730606079102, 0.680208227187335, -85.9641723632813, -1.50035784649117, 218, 19, 'PPL', 'P'),
(108698, 'Cortland', 39.0669403076172, 0.681846737048006, -79.4277801513672, -1.38627628119156, 218, 58, 'PPL', 'P'),
(119231, 'Cortland', 41.9199981689453, 0.73164199047809, -88.688606262207, -1.54790818828037, 218, 18, 'PPL', 'P'),
(141552, 'Cortland', 40.5055618286133, 0.706955419279437, -96.7055587768555, -1.68783040563703, 218, 35, 'PPL', 'P'),
(148053, 'Cortland', 42.6011085510254, 0.743529609214904, -76.1808319091797, -1.32960634372354, 218, 40, 'PPL', 'P'),
(154855, 'Cortland', 41.3302803039551, 0.721349472076179, -80.7255630493164, -1.40892686573685, 218, 41, 'PPL', 'P'),
(173665, 'Cortland (historical)', 44.2138900756836, 0.771677956935524, -91.567497253418, -1.59815431488301, 218, 57, 'PPL', 'P'),
(86019, 'Cortner', 35.4683303833008, 0.619039145373741, -86.2763900756836, -1.50580707355564, 218, 50, 'PPL', 'P'),
(86020, 'Cortners Mill', 35.4749984741211, 0.619155525513377, -86.2724990844727, -1.50573916294784, 218, 50, 'PPL', 'P'),
(108699, 'Corton', 38.4894409179688, 0.671767471270383, -81.2755584716797, -1.41852609672798, 218, 58, 'PPL', 'P'),
(72214, 'Cortsville', 39.7963905334473, 0.694578045218157, -83.7211074829102, -1.46120897899284, 218, 41, 'PPL', 'P'),
(188364, 'Coruco', 35.3661117553711, 0.617255093759497, -105.438056945801, -1.8402412506095, 218, 38, 'PPL', 'P'),
(75536, 'Corum', 34.3622207641602, 0.599733890631757, -98.103889465332, -1.71223588018262, 218, 42, 'PPL', 'P'),
(1782, 'Corum (historical)', 34.9083290100098, 0.609265277594123, -87.331672668457, -1.52422522933852, 218, 2, 'PPL', 'P'),
(122432, 'Corunna', 41.4372215270996, 0.723215948526161, -85.147216796875, -1.48609928201489, 218, 19, 'PPL', 'P'),
(130353, 'Corunna', 42.9819412231445, 0.750176393242551, -84.1177825927734, -1.46813226572067, 218, 27, 'PPL', 'P'),
(178014, 'Corva', 35.2752799987793, 0.6156697805416, -112.348609924316, -1.9608531532181, 218, 5, 'PPL', 'P'),
(196282, 'Corvallis', 46.3141708374023, 0.80833477144381, -114.111938476563, -1.99162904224922, 218, 31, 'PPL', 'P'),
(200631, 'Corvallis', 44.5647201538086, 0.777801096913834, -123.260833740234, -2.15130738752041, 218, 43, 'PPL', 'P'),
(196283, 'Corvallis Mobile Home Park', 46.3158302307129, 0.808363733320665, -114.108062744141, -1.99156139795753, 218, 31, 'PPL', 'P'),
(72215, 'Corvin (historical)', 39.6994400024414, 0.692885939240548, -84.7416687011719, -1.47902113246968, 218, 41, 'PPL', 'P'),
(134816, 'Corvuso', 44.9361114501953, 0.784283097849032, -94.6044387817383, -1.65115894374275, 218, 28, 'PPL', 'P'),
(32152, 'Corwin', 37.084171295166, 0.647240889474217, -98.3041687011719, -1.71573141227141, 218, 20, 'PPL', 'P'),
(72216, 'Corwin', 39.5250015258789, 0.68984141348237, -84.0783309936523, -1.46744370542083, 218, 41, 'PPL', 'P'),
(122433, 'Corwin', 40.2516708374023, 0.702524185541654, -86.9150009155273, -1.51695293534984, 218, 19, 'PPL', 'P'),
(148058, 'Corwin', 43.252498626709, 0.754898510750398, -78.6936111450195, -1.3734626147647, 218, 40, 'PPL', 'P'),
(199895, 'Corwin', 40.021671295166, 0.69850993625155, -115.898063659668, -2.02280280754719, 218, 39, 'PPL', 'P'),
(173666, 'Corwin (historical)', 43.5033302307129, 0.759276348108324, -90.2813873291016, -1.57570746216111, 218, 57, 'PPL', 'P'),
(196284, 'Corwin Springs', 45.1130599975586, 0.787371432607142, -110.789169311523, -1.93363578003554, 218, 31, 'PPL', 'P'),
(160444, 'Corwins Corners', 41.9322204589844, 0.731855309681405, -78.5813903808594, -1.371503992941, 218, 45, 'PPL', 'P'),
(115115, 'Corwith', 42.9927787780762, 0.750365544258974, -93.9572219848633, -1.63986287966307, 218, 16, 'PPL', 'P'),
(29556, 'Cory', 39.3822212219238, 0.687349427071355, -87.2058334350586, -1.52202892038753, 218, 19, 'PPL', 'P'),
(35390, 'Cory', 38.2838897705078, 0.668179926965938, -83.1130599975586, -1.45059654836499, 218, 21, 'PPL', 'P'),
(180891, 'Cory', 39.7683296203613, 0.694088289893692, -122.148612976074, -2.13189547317676, 218, 6, 'PPL', 'P'),
(186580, 'Cory', 38.7880592346191, 0.676979344102696, -107.986671447754, -1.88472296503266, 218, 7, 'PPL', 'P'),
(29558, 'Corydon', 38.2119407653809, 0.666924179932938, -86.121940612793, -1.50311142190026, 218, 19, 'PPL', 'P'),
(35391, 'Corydon', 37.7433280944824, 0.658745345909196, -87.7038879394531, -1.5307216113436, 218, 21, 'PPL', 'P'),
(115116, 'Corydon', 40.7569389343262, 0.711342777438261, -93.3186111450195, -1.62871701786887, 218, 16, 'PPL', 'P'),
(115117, 'Corydon (historical)', 41.747501373291, 0.728631353444783, -93.6872177124023, -1.63515041611417, 218, 16, 'PPL', 'P'),
(160445, 'Corydon (historical)', 41.9877815246582, 0.73282503321333, -78.9805603027344, -1.37847082235264, 218, 45, 'PPL', 'P'),
(29557, 'Corydon Junction', 38.3033294677734, 0.668519213688814, -86.1002807617188, -1.50273338618352, 218, 19, 'PPL', 'P'),
(93459, 'Coryell', 31.5461101531982, 0.550583488370122, -97.6180572509766, -1.70375650842987, 218, 51, 'PPL', 'P'),
(160447, 'Coryland', 41.9005584716797, 0.731302703755214, -76.8586120605469, -1.34143583896957, 218, 45, 'PPL', 'P'),
(63921, 'Corys', 36.5386085510254, 0.637719023312748, -75.9636077880859, -1.32581506759571, 218, 33, 'PPL', 'P'),
(72217, 'Coryville', 38.5436096191406, 0.672712893457362, -82.6647186279297, -1.44277151529206, 218, 41, 'PPL', 'P'),
(160448, 'Coryville', 41.8824996948242, 0.730987518640203, -78.3986129760742, -1.36831392542925, 218, 45, 'PPL', 'P'),
(190079, 'Coryville (historical)', 38.4858283996582, 0.671704420931576, -118.718063354492, -2.07202108712711, 218, 39, 'PPL', 'P'),
(113022, 'Cos Cob', 41.0333290100098, 0.716166694278776, -73.5999984741211, -1.28456230283622, 218, 8, 'PPL', 'P'),
(54213, 'Cosby', 39.8641700744629, 0.695761021374371, -94.6780624389648, -1.65244391896871, 218, 29, 'PPL', 'P'),
(80491, 'Cosby', 32.5816688537598, 0.568657397292595, -81.2483291625977, -1.41805085563146, 218, 48, 'PPL', 'P'),
(86021, 'Cosby', 35.8172187805176, 0.62512839662718, -83.246940612793, -1.45293320590542, 218, 50, 'PPL', 'P'),
(78080, 'Coseytown', 39.7294387817383, 0.693409516710858, -77.7861099243164, -1.35762373049756, 218, 45, 'PPL', 'P'),
(63922, 'Cosfort (historical)', 36.0988883972168, 0.630044458841412, -81.3338928222656, -1.41954422321272, 218, 33, 'PPL', 'P'),
(199896, 'Cosgrave', 40.7966690063477, 0.71203619800709, -118.014717102051, -2.05974537924045, 218, 39, 'PPL', 'P'),
(8237, 'Cosgrove', 33.3063888549805, 0.581306147468953, -91.3994369506836, -1.59522110925839, 218, 4, 'PPL', 'P'),
(115119, 'Cosgrove', 41.6427803039551, 0.726803625988661, -91.7355575561523, -1.60108752050762, 218, 16, 'PPL', 'P'),
(154856, 'Coshocton', 40.2719383239746, 0.702877919913444, -81.8597183227539, -1.42872160948719, 218, 41, 'PPL', 'P'),
(124578, 'Coskata', 41.3541717529297, 0.721766456523858, -70.0208282470703, -1.22209399788483, 218, 23, 'PPL', 'P'),
(15634, 'Cosme', 28.1086101531982, 0.490587795332817, -82.5727767944336, -1.44116682757724, 218, 12, 'PPL', 'P'),
(15635, 'Cosmo', 30.3644409179688, 0.529959469545844, -81.5155563354492, -1.42271484964851, 218, 12, 'PPL', 'P'),
(207108, 'Cosmopolis', 46.9555587768555, 0.819529102769849, -123.772499084473, -2.16023763244571, 218, 56, 'PPL', 'P'),
(134827, 'Cosmos', 44.9361114501953, 0.784283097849032, -94.6963882446289, -1.65276376461563, 218, 28, 'PPL', 'P'),
(154859, 'Cosmos', 40.267219543457, 0.702795561656733, -84.7794418334961, -1.47968039799753, 218, 41, 'PPL', 'P'),
(134818, 'Cosmos Mobile Home Park', 44.9361114501953, 0.784283097849032, -94.6963882446289, -1.65276376461563, 218, 28, 'PPL', 'P'),
(160449, 'Cosmus', 40.9461097717285, 0.714644431399686, -79.5427780151367, -1.3882833725471, 218, 45, 'PPL', 'P'),
(178015, 'Cosnino', 35.2055587768555, 0.614452915660516, -111.474166870117, -1.94559124280113, 218, 5, 'PPL', 'P'),
(180892, 'Coso', 35.978328704834, 0.62794029526414, -117.928611755371, -2.05824255743732, 218, 6, 'PPL', 'P'),
(180893, 'Coso Junction', 36.0449981689453, 0.629103896923423, -117.946388244629, -2.05855281570431, 218, 6, 'PPL', 'P'),
(122434, 'Cosperville', 41.4808311462402, 0.723977079965706, -85.4741668701172, -1.4918056372826, 218, 19, 'PPL', 'P'),
(148059, 'Coss Corners', 42.2813911437988, 0.737949487782861, -77.3658294677734, -1.3502884527491, 218, 40, 'PPL', 'P'),
(78081, 'Cossart', 39.8474998474121, 0.695470071025279, -75.5980606079102, -1.31943506573026, 218, 45, 'PPL', 'P'),
(148060, 'Cossayuna', 43.1836090087891, 0.753696160097254, -73.4272232055664, -1.28154680553392, 218, 40, 'PPL', 'P'),
(39902, 'Cossinade', 30.038890838623, 0.524277548781133, -92.3186111450195, -1.61126372534892, 218, 22, 'PPL', 'P'),
(15637, 'Cosson Mill', 30.7000007629395, 0.535816093678065, -86.1811065673828, -1.50414406261294, 218, 12, 'PPL', 'P'),
(54214, 'Cossville', 37.3258285522461, 0.651458604271603, -94.4480590820313, -1.64842960309958, 218, 29, 'PPL', 'P'),
(9, 'Cost', 29.437219619751, 0.513776404997328, -97.5286102294922, -1.70219536339886, 218, 51, 'PPL', 'P'),
(180894, 'Costa Mesa', 33.6411094665527, 0.587148124215178, -117.917778015137, -2.05805347299992, 218, 6, 'PPL', 'P'),
(160450, 'Costello', 41.5933303833008, 0.725940562058394, -78.0597229003906, -1.36239917780623, 218, 45, 'PPL', 'P'),
(35392, 'Costelow', 36.9908294677734, 0.645611767256388, -86.7677764892578, -1.51438338437208, 218, 21, 'PPL', 'P'),
(46008, 'Costen', 38.1047210693359, 0.665052843213967, -75.6172180175781, -1.31976942560512, 218, 25, 'PPL', 'P'),
(46009, 'Coster', 38.3572196960449, 0.669459775606802, -76.4711074829102, -1.33467260822326, 218, 25, 'PPL', 'P'),
(115120, 'Coster', 42.6716690063477, 0.744761121481984, -92.7113876342773, -1.6181189683109, 218, 16, 'PPL', 'P'),
(86022, 'Coster Yards', 35.9866714477539, 0.62808590359674, -83.9436111450195, -1.4650924004944, 218, 50, 'PPL', 'P'),
(127165, 'Costigan', 45.0127792358398, 0.785621203138742, -68.6399993896484, -1.19799398791626, 218, 26, 'PPL', 'P'),
(188365, 'Costilla', 36.975830078125, 0.645349978521233, -105.530563354492, -1.84185579202036, 218, 38, 'PPL', 'P'),
(1785, 'Costilla (historical)', 31.1069393157959, 0.542918511278711, -85.8880615234375, -1.49902946173944, 218, 2, 'PPL', 'P'),
(63923, 'Costin', 34.5830612182617, 0.603588283677428, -78.1016693115234, -1.3631312807899, 218, 33, 'PPL', 'P'),
(199250, 'Costin', 41.8644409179688, 0.730672333525192, -103.730827331543, -1.81044447275315, 218, 35, 'PPL', 'P'),
(154860, 'Costonia', 40.4269409179688, 0.705583225527774, -80.6180572509766, -1.40705053559083, 218, 41, 'PPL', 'P'),
(180896, 'Cosumne', 38.4925003051758, 0.67182086765024, -121.173889160156, -2.11488333329139, 218, 6, 'PPL', 'P'),
(180898, 'Cosy Dell', 34.2788887023926, 0.598279471781437, -117.452781677246, -2.04993775589401, 218, 6, 'PPL', 'P'),
(180899, 'Cota', 33.8394393920898, 0.590609634421036, -118.206672668457, -2.06309563589177, 218, 6, 'PPL', 'P'),
(180901, 'Cotati', 38.3269386291504, 0.668931271288476, -122.706108093262, -2.14162559853548, 218, 6, 'PPL', 'P'),
(80492, 'Cote Bas Landing', 33.014720916748, 0.576215581624294, -79.9241714477539, -1.39493994369175, 218, 48, 'PPL', 'P'),
(39903, 'Cote Blanche Landing', 29.7397193908691, 0.519056021989869, -91.7083282470703, -1.6006122794111, 218, 22, 'PPL', 'P'),
(127166, 'Cote Corner', 46.8994407653809, 0.818549658699945, -67.873893737793, -1.18462292187325, 218, 26, 'PPL', 'P'),
(54215, 'Cote Sans Dessein (historical)', 38.5833282470703, 0.673406114289109, -91.9111099243164, -1.60415148734176, 218, 29, 'PPL', 'P'),
(39904, 'Coteau', 30.0469398498535, 0.524418030528634, -91.9141693115234, -1.60420488372161, 218, 22, 'PPL', 'P'),
(198143, 'Coteau', 48.7566719055176, 0.850964457065899, -102.31861114502, -1.78579665054836, 218, 34, 'PPL', 'P'),
(39905, 'Coteau Bourgeois', 30.2602806091309, 0.528141529206729, -90.758056640625, -1.58402691109041, 218, 22, 'PPL', 'P'),
(39906, 'Coteau Holmes', 30.1297206878662, 0.525862828709516, -91.7261123657227, -1.60092267083615, 218, 22, 'PPL', 'P'),
(39907, 'Coteau Rodaire', 30.3911094665527, 0.530424923525363, -91.899169921875, -1.60394309498646, 218, 22, 'PPL', 'P'),
(141548, 'Cotesfield', 41.3572196960449, 0.721819653166632, -98.6322174072266, -1.72145694229897, 218, 35, 'PPL', 'P'),
(148061, 'Coteys Corner', 44.7761116027832, 0.781490573709002, -74.6733322143555, -1.30329551057605, 218, 40, 'PPL', 'P'),
(86023, 'Cotham (historical)', 35.7763900756836, 0.624415801298502, -87.9930572509766, -1.53576856792541, 218, 50, 'PPL', 'P'),
(80493, 'Cothran (historical)', 34.2236099243164, 0.597314675097529, -82.2022171020508, -1.43469934086998, 218, 48, 'PPL', 'P'),
(72218, 'Cotillion Village', 39.1069412231445, 0.682544884727771, -84.6402816772461, -1.47725159508337, 218, 41, 'PPL', 'P'),
(101081, 'Cotman (historical)', 37.4258308410645, 0.653203973471013, -77.3016662597656, -1.34916859351072, 218, 53, 'PPL', 'P'),
(1786, 'Cotnam (historical)', 34.267219543457, 0.598075806537073, -85.9408264160156, -1.49995038284439, 218, 2, 'PPL', 'P'),
(180902, 'Cotners Corner', 34.4713897705078, 0.601639249233654, -117.170829772949, -2.04501676683176, 218, 6, 'PPL', 'P'),
(180903, 'Coto De Caza', 33.6041717529297, 0.586503439494298, -117.586112976074, -2.05226482605452, 218, 6, 'PPL', 'P'),
(186582, 'Cotopaxi', 38.3702812194824, 0.669687742196113, -105.6875, -1.84459485320151, 218, 7, 'PPL', 'P'),
(54217, 'Cottage', 39.9833297729492, 0.697840750448641, -92.5813903808594, -1.6158500882202, 218, 29, 'PPL', 'P'),
(148062, 'Cottage', 42.4238891601563, 0.740436547345859, -79.0444412231445, -1.37958575474301, 218, 40, 'PPL', 'P'),
(160451, 'Cottage', 40.6208305358887, 0.70896723774591, -77.9847183227539, -1.36109010097241, 218, 45, 'PPL', 'P'),
(46010, 'Cottage City', 38.938060760498, 0.679597364612298, -76.9486083984375, -1.3430065713805, 218, 25, 'PPL', 'P'),
(148063, 'Cottage City', 42.8111114501953, 0.747194851244153, -77.2597198486328, -1.34843649052706, 218, 40, 'PPL', 'P'),
(180904, 'Cottage Corners', 36.8694381713867, 0.643493089451176, -121.399436950684, -2.11881988485669, 218, 6, 'PPL', 'P'),
(54218, 'Cottage Farm', 38.2394409179688, 0.667404148140398, -90.6686096191406, -1.58246576605941, 218, 29, 'PPL', 'P'),
(101082, 'Cottage Green', 38.2641716003418, 0.667835779974072, -77.4872207641602, -1.35240713055431, 218, 53, 'PPL', 'P'),
(1788, 'Cottage Grove', 32.8555603027344, 0.57343770487026, -86.1224975585938, -1.50312114243824, 218, 2, 'PPL', 'P'),
(26860, 'Cottage Grove', 37.7480583190918, 0.658827903902988, -88.4105606079102, -1.54305537614203, 218, 18, 'PPL', 'P'),
(29559, 'Cottage Grove', 39.5963897705078, 0.691087373398363, -84.8616714477539, -1.48111557550897, 218, 19, 'PPL', 'P'),
(46011, 'Cottage Grove', 38.1019401550293, 0.6650043071031, -75.6711120605469, -1.32071005410213, 218, 25, 'PPL', 'P'),
(86024, 'Cottage Grove', 36.3791694641113, 0.634936286289724, -88.4791717529297, -1.54425286652619, 218, 50, 'PPL', 'P'),
(113016, 'Cottage Grove', 41.8213882446289, 0.729920922623626, -72.6961135864258, -1.26878653548691, 218, 8, 'PPL', 'P'),
(134821, 'Cottage Grove', 44.8277816772461, 0.78239238663313, -92.9436111450195, -1.62217203317389, 218, 28, 'PPL', 'P'),
(154861, 'Cottage Grove', 40.9886093139648, 0.715386188342301, -81.5122222900391, -1.42265665957869, 218, 41, 'PPL', 'P'),
(160452, 'Cottage Grove', 41.0941696166992, 0.717228563184418, -80.3177795410156, -1.40180970088166, 218, 45, 'PPL', 'P'),
(173667, 'Cottage Grove', 43.0761108398438, 0.751819963109293, -89.1994400024414, -1.55682391897774, 218, 57, 'PPL', 'P'),
(193468, 'Cottage Grove', 41.6027793884277, 0.726105478308897, -123.504440307617, -2.15555912420072, 218, 6, 'PPL', 'P'),
(200632, 'Cottage Grove', 43.797779083252, 0.76441545006385, -123.058326721191, -2.14777297327971, 218, 43, 'PPL', 'P'),
(46012, 'Cottage Grove Beach', 39.1547203063965, 0.683378787044102, -76.5119400024414, -1.33538527013096, 218, 25, 'PPL', 'P'),
(1792, 'Cottage Hill', 33.4819412231445, 0.584370114303089, -86.9783325195313, -1.51805828036028, 218, 2, 'PPL', 'P'),
(15638, 'Cottage Hill', 30.6324996948242, 0.534637977790841, -87.3199996948242, -1.52402149751513, 218, 12, 'PPL', 'P'),
(29560, 'Cottage Hill', 39.5169410705566, 0.689700731997786, -87.149169921875, -1.52103995551673, 218, 19, 'PPL', 'P'),
(32154, 'Cottage Hill', 39.5972213745117, 0.691101887626304, -96.7494430541992, -1.68859633076654, 218, 20, 'PPL', 'P'),
(115121, 'Cottage Hill', 42.5852813720703, 0.743253372830835, -90.9136123657227, -1.58674187066369, 218, 16, 'PPL', 'P'),
(124580, 'Cottage Hill', 42.3680610656738, 0.739462163282026, -70.9694366455078, -1.23865033774963, 218, 23, 'PPL', 'P'),
(154862, 'Cottage Hill', 40.0161094665527, 0.698412864029817, -82.1883316040039, -1.43445699321078, 218, 41, 'PPL', 'P'),
(160453, 'Cottage Hill', 41.0102806091309, 0.715764423796119, -79.3475036621094, -1.38487519214207, 218, 45, 'PPL', 'P'),
(8238, 'Cottage Hill (historical)', 36.2419395446777, 0.632541172363361, -93.8963928222656, -1.63880121049451, 218, 4, 'PPL', 'P'),
(26861, 'Cottage Hills', 38.9030609130859, 0.678986502037261, -90.0699996948242, -1.57201805194497, 218, 18, 'PPL', 'P'),
(86025, 'Cottage Home', 35.9908294677734, 0.628158474736445, -86.033332824707, -1.50156492425525, 218, 50, 'PPL', 'P'),
(63928, 'Cottage Home (historical)', 35.415828704834, 0.618122818221672, -81.0313873291016, -1.41426450635164, 218, 33, 'PPL', 'P'),
(207109, 'Cottage Lake', 47.7444381713867, 0.833297645605559, -122.076110839844, -2.13063007218481, 218, 56, 'PPL', 'P'),
(13598, 'Cottage Mill', 39.6533317565918, 0.692081198538154, -75.754997253418, -1.3221741269114, 218, 10, 'PPL', 'P'),
(20261, 'Cottage Mills (historical)', 32.2986106872559, 0.563717100312443, -84.8886108398438, -1.48158575659942, 218, 13, 'PPL', 'P'),
(101083, 'Cottage Park', 36.9377784729004, 0.644685852724395, -76.2272186279297, -1.33041594469493, 218, 53, 'PPL', 'P'),
(124581, 'Cottage Park', 42.3708305358887, 0.739510499655811, -70.9875030517578, -1.2389656560227, 218, 23, 'PPL', 'P'),
(148065, 'Cottage Park', 42.2366714477539, 0.737168981846386, -79.4933319091797, -1.38742037519586, 218, 40, 'PPL', 'P'),
(180906, 'Cottage Springs', 38.3561096191406, 0.669440401109872, -120.210830688477, -2.09807479207136, 218, 6, 'PPL', 'P'),
(35393, 'Cottageville', 38.6044387817383, 0.673774562625922, -83.602783203125, -1.45914383072554, 218, 21, 'PPL', 'P'),
(80494, 'Cottageville', 32.9366683959961, 0.574853308147691, -80.4811096191406, -1.40466034851248, 218, 48, 'PPL', 'P'),
(108700, 'Cottageville', 38.8655586242676, 0.678331963620347, -81.8236083984375, -1.42809137241522, 218, 58, 'PPL', 'P'),
(145045, 'Cottageville', 40.4102783203125, 0.705292408336737, -74.4847183227539, -1.3000035771526, 218, 37, 'PPL', 'P'),
(160454, 'Cottageville', 40.3766708374023, 0.704705847106647, -75.0791702270508, -1.31037872012733, 218, 45, 'PPL', 'P'),
(54219, 'Cottbus', 36.6497192382813, 0.639658270639516, -91.8480606079102, -1.60305106917934, 218, 29, 'PPL', 'P'),
(148066, 'Cottekill', 41.851390838623, 0.730444566672963, -74.1025009155273, -1.29333262493806, 218, 40, 'PPL', 'P'),
(8239, 'Cotter', 36.271110534668, 0.633050302184757, -92.5352783203125, -1.61504528093878, 218, 4, 'PPL', 'P'),
(115122, 'Cotter', 41.2919387817383, 0.720680286273269, -91.4613876342773, -1.59630235266097, 218, 16, 'PPL', 'P'),
(93461, 'Cotter Tract Colonia', 26.250560760498, 0.458158715765518, -98.1561126708984, -1.7131473470657, 218, 51, 'PPL', 'P'),
(194782, 'Cotterel', 42.517219543457, 0.742065469826605, -113.45832824707, -1.98022139171986, 218, 17, 'PPL', 'P'),
(54220, 'Cotterville', 38.7541694641113, 0.676387856024589, -90.6458282470703, -1.58206815610866, 218, 29, 'PPL', 'P'),
(209385, 'Cottier', 42.0222206115723, 0.733426108671361, -104.263061523438, -1.8197337117934, 218, 59, 'PPL', 'P'),
(75537, 'Cottingham', 35.9622192382813, 0.627659132032055, -96.9519424438477, -1.69213061184918, 218, 42, 'PPL', 'P'),
(20258, 'Cottle', 31.2013893127441, 0.544566974703956, -83.3147201538086, -1.45411618206164, 218, 13, 'PPL', 'P'),
(35394, 'Cottle', 37.8888893127441, 0.661285868431077, -83.2038879394531, -1.45218179500386, 218, 21, 'PPL', 'P'),
(108701, 'Cottle', 38.3463897705078, 0.669270757748434, -80.6266708374023, -1.40720087103436, 218, 58, 'PPL', 'P'),
(160455, 'Cottles Corner', 40.1366691589355, 0.700517027607089, -78.341667175293, -1.36732003371043, 218, 45, 'PPL', 'P'),
(54221, 'Cottleville', 38.7461090087891, 0.676247174540006, -90.6538925170898, -1.58220890417227, 218, 29, 'PPL', 'P'),
(1793, 'Cotton', 32.6811103820801, 0.570392979374999, -86.0177764892578, -1.50129341498212, 218, 2, 'PPL', 'P'),
(20259, 'Cotton', 31.1613903045654, 0.543868860313705, -84.0669403076172, -1.46724490044545, 218, 13, 'PPL', 'P'),
(93462, 'Cotton', 30.8313903808594, 0.538109275113705, -95.8944396972656, -1.67367370707244, 218, 51, 'PPL', 'P'),
(108702, 'Cotton', 38.5447196960449, 0.672732267954292, -81.3499984741211, -1.41982531986578, 218, 58, 'PPL', 'P'),
(130356, 'Cotton', 44.6991691589355, 0.78014767472933, -85.0533294677734, -1.48446063899616, 218, 27, 'PPL', 'P'),
(134823, 'Cotton', 47.1694412231445, 0.823262055669813, -92.4761123657227, -1.6140126402261, 218, 28, 'PPL', 'P'),
(194783, 'Cotton', 43.4263916015625, 0.757933515707679, -112.087501525879, -1.95629595196076, 218, 17, 'PPL', 'P'),
(80496, 'Cotton (historical)', 34.8313903808594, 0.607922445193478, -81.4222183227539, -1.42108579400971, 218, 48, 'PPL', 'P'),
(8240, 'Cotton Belt', 36.0930595397949, 0.629942726087771, -90.461669921875, -1.57885398698904, 218, 4, 'PPL', 'P'),
(178016, 'Cotton Center', 33.0872192382813, 0.577480916037218, -112.666107177734, -1.96639452565628, 218, 5, 'PPL', 'P'),
(180907, 'Cotton Center', 36.0661087036133, 0.629472345260235, -119.141937255859, -2.07941908231924, 218, 6, 'PPL', 'P'),
(191325, 'Cotton Center', 33.9930610656738, 0.593290838427501, -101.992500305176, -1.78010494266664, 218, 51, 'PPL', 'P'),
(188368, 'Cotton City', 32.0883293151855, 0.560046998014205, -108.878608703613, -1.90029020686861, 218, 38, 'PPL', 'P'),
(20260, 'Cotton Creek', 33.896110534668, 0.591598732449892, -84.0005569458008, -1.46608629221322, 218, 13, 'PPL', 'P'),
(191326, 'Cotton Flat', 31.9288902282715, 0.557264260991181, -102.059440612793, -1.78127327143686, 218, 51, 'PPL', 'P'),
(93465, 'Cotton Gin', 31.6808300018311, 0.552934793296553, -96.3602828979492, -1.6818042047224, 218, 51, 'PPL', 'P'),
(59115, 'Cotton Gin Port (historical)', 33.9708290100098, 0.592902815856676, -88.5430603027344, -1.5453679320746, 218, 30, 'PPL', 'P'),
(63926, 'Cotton Grove', 35.7388916015625, 0.623761329460615, -80.2627792358398, -1.40084976446674, 218, 33, 'PPL', 'P'),
(86026, 'Cotton Grove', 35.6705589294434, 0.62256869934545, -88.6861114501953, -1.54786464559655, 218, 50, 'PPL', 'P'),
(1794, 'Cotton Hill', 31.8344402313232, 0.555615797565936, -85.2805633544922, -1.48842661849151, 218, 2, 'PPL', 'P'),
(20262, 'Cotton Hill', 31.7308292388916, 0.553807444606745, -84.9669418334961, -1.48295289034501, 218, 13, 'PPL', 'P'),
(26865, 'Cotton Hill', 39.6961097717285, 0.692827815749757, -89.629997253418, -1.56433856062562, 218, 18, 'PPL', 'P'),
(80495, 'Cotton Hill', 33.0088882446289, 0.576113782291626, -80.2416687011719, -1.40048131612993, 218, 48, 'PPL', 'P'),
(108703, 'Cotton Hill', 38.1133308410645, 0.665203112078474, -81.1449966430664, -1.41624736294125, 218, 58, 'PPL', 'P'),
(59116, 'Cotton Hill Gin Estates', 33.9777793884277, 0.593024122844329, -88.5680618286133, -1.54580429101921, 218, 30, 'PPL', 'P'),
(113017, 'Cotton Hollow', 41.663330078125, 0.727162287208468, -72.601936340332, -1.26714283246212, 218, 8, 'PPL', 'P'),
(20263, 'Cotton Indian Creek', 33.5752792358398, 0.585999169941891, -84.2302780151367, -1.47009568123433, 218, 13, 'PPL', 'P'),
(86027, 'Cotton Lake', 35.561939239502, 0.620672928123477, -89.5052795410156, -1.56216182590864, 218, 50, 'PPL', 'P'),
(93464, 'Cotton Patch', 28.9838905334473, 0.50586431984627, -97.6161117553711, -1.70372255312597, 218, 51, 'PPL', 'P'),
(86028, 'Cotton Patch Crossroads', 36.3525009155273, 0.634470832310205, -87.9499969482422, -1.53501702386579, 218, 50, 'PPL', 'P'),
(63929, 'Cotton Patch Landing', 35.4025001525879, 0.617890191100454, -76.966667175293, -1.34332175649551, 218, 33, 'PPL', 'P'),
(188366, 'Cotton Place', 32.2247200012207, 0.562427464554572, -103.662780761719, -1.80925683606503, 218, 38, 'PPL', 'P'),
(8241, 'Cotton Plant', 35.0080604553223, 0.611005919682599, -91.251106262207, -1.59263225036273, 218, 4, 'PPL', 'P'),
(15639, 'Cotton Plant', 29.1800003051758, 0.509287081058268, -82.3186111450195, -1.43673080014949, 218, 12, 'PPL', 'P'),
(39911, 'Cotton Plant', 32.1058311462402, 0.560352462591237, -92.26611328125, -1.61034746477588, 218, 22, 'PPL', 'P'),
(54223, 'Cotton Plant', 36.0900001525879, 0.629889329707915, -90.0911102294922, -1.57238650028178, 218, 29, 'PPL', 'P'),
(59117, 'Cotton Plant', 34.6002807617188, 0.603888821406444, -89.0044403076172, -1.55342053226267, 218, 30, 'PPL', 'P'),
(86029, 'Cotton Port (historical)', 35.4833297729492, 0.619300934108896, -84.8819427490234, -1.48146937645979, 218, 50, 'PPL', 'P'),
(1795, 'Cotton Ridge', 33.6627807617188, 0.587526359668997, -86.5580596923828, -1.51072313576987, 218, 2, 'PPL', 'P'),
(8244, 'Cotton Town', 35.1130599975586, 0.61283850740771, -93.0530624389648, -1.6240823186238, 218, 4, 'PPL', 'P'),
(101084, 'Cotton Town', 37.396671295166, 0.652695043386699, -78.3022232055664, -1.36663160656864, 218, 53, 'PPL', 'P'),
(160456, 'Cotton Town', 40.2794418334961, 0.703008880860048, -78.4811096191406, -1.3697537634726, 218, 45, 'PPL', 'P'),
(196285, 'Cotton Trailer Court', 47.151668548584, 0.822951863981846, -110.215278625488, -1.9236194980177, 218, 31, 'PPL', 'P'),
(1796, 'Cotton Valley', 32.292781829834, 0.563615367558802, -85.6922225952148, -1.49561142763838, 218, 2, 'PPL', 'P'),
(39908, 'Cotton Valley', 32.8191719055176, 0.572802607529303, -93.4175033569336, -1.63044301257135, 218, 22, 'PPL', 'P'),
(75539, 'Cotton Valley', 36.9708290100098, 0.645262693416506, -95.8586120605469, -1.67304839684849, 218, 42, 'PPL', 'P'),
(80497, 'Cotton Valley', 34.478328704834, 0.601760356484225, -79.2847213745117, -1.38377943451155, 218, 48, 'PPL', 'P'),
(191327, 'Cotton Valley Estates Colonia', 31.6219997406006, 0.551908011538273, -106.237998962402, -1.85420287262424, 218, 51, 'PPL', 'P'),
(35395, 'Cottonburg', 37.7305603027344, 0.658522505904983, -84.4619369506836, -1.47413889240129, 218, 21, 'PPL', 'P'),
(1798, 'Cottondale', 33.1894416809082, 0.579265034230489, -87.4516677856445, -1.52631953921976, 218, 2, 'PPL', 'P'),
(8245, 'Cottondale', 34.1802787780762, 0.596558403926973, -91.8602828979492, -1.60326438838265, 218, 4, 'PPL', 'P'),
(15641, 'Cottondale', 30.7969398498535, 0.537507999918592, -85.3766708374023, -1.4901040105041, 218, 12, 'PPL', 'P'),
(20264, 'Cottondale', 31.9086093902588, 0.556910293592796, -84.4369430541992, -1.47370266661473, 218, 13, 'PPL', 'P'),
(59118, 'Cottondale', 33.689998626709, 0.58800140102844, -90.5427780151367, -1.58026959026647, 218, 30, 'PPL', 'P'),
(93466, 'Cottondale', 33.0658302307129, 0.577107607431416, -97.7044372558594, -1.70526412392296, 218, 51, 'PPL', 'P'),
(35396, 'Cottongim', 37.0647201538086, 0.646901403014259, -83.8024978637695, -1.46262950911829, 218, 21, 'PPL', 'P'),
(20265, 'Cottonham (historical)', 31.8697204589844, 0.556231553699476, -81.1777801513672, -1.41681954310146, 218, 13, 'PPL', 'P'),
(141553, 'Cottonmill Mobile Home Court', 40.7000007629395, 0.710349018877498, -99.1333312988281, -1.7302030296349, 218, 35, 'PPL', 'P'),
(39909, 'Cottonport', 30.9838905334473, 0.540770904886157, -92.0533294677734, -1.60663368663577, 218, 22, 'PPL', 'P'),
(148067, 'Cottons', 43.0416717529297, 0.751218887651262, -75.7822189331055, -1.32264923484987, 218, 40, 'PPL', 'P'),
(20268, 'Cottons Crossroads', 32.878059387207, 0.573830387972992, -85.1177825927734, -1.48558555824061, 218, 13, 'PPL', 'P'),
(1799, 'Cottonton', 32.146671295166, 0.561065257656997, -85.0738906860352, -1.48481949995305, 218, 2, 'PPL', 'P'),
(1800, 'Cottontown', 34.6552810668945, 0.604848757821363, -87.4811096191406, -1.52683339615209, 218, 2, 'PPL', 'P'),
(86030, 'Cottontown', 36.4513893127441, 0.636196760433658, -86.5380630493164, -1.51037412850902, 218, 50, 'PPL', 'P'),
(108704, 'Cottontown', 39.6569404602051, 0.692144182297934, -80.4244384765625, -1.40367125048363, 218, 58, 'PPL', 'P'),
(1801, 'Cottonville', 34.4533309936523, 0.601324064118643, -86.335563659668, -1.50683984742637, 218, 2, 'PPL', 'P'),
(59119, 'Cottonville', 34.6594390869141, 0.604921328961068, -90.1847229003906, -1.57402034961055, 218, 30, 'PPL', 'P'),
(63931, 'Cottonville', 35.1983299255371, 0.614326748403873, -80.1900024414063, -1.39957956978483, 218, 33, 'PPL', 'P'),
(115123, 'Cottonville', 42.2369384765625, 0.737173642378293, -90.601936340332, -1.5813020978211, 218, 16, 'PPL', 'P'),
(173670, 'Cottonville', 44.0583305358887, 0.768962930783215, -89.8063888549805, -1.56741717484575, 218, 57, 'PPL', 'P'),
(1802, 'Cottonwood', 31.0486106872559, 0.541900484662514, -85.3050003051758, -1.48885312374009, 218, 2, 'PPL', 'P'),
(20266, 'Cottonwood', 33.4777793884277, 0.584297476584358, -84.4497222900391, -1.47392570635603, 218, 13, 'PPL', 'P'),
(26864, 'Cottonwood', 37.8891716003418, 0.661290795279093, -88.2130584716797, -1.53960831358509, 218, 18, 'PPL', 'P'),
(39910, 'Cottonwood', 32.8883285522461, 0.574009618714354, -91.1016693115234, -1.59002408354916, 218, 22, 'PPL', 'P'),
(75541, 'Cottonwood', 35.3683280944824, 0.61729377617433, -94.5488891601563, -1.6501894199479, 218, 42, 'PPL', 'P'),
(93473, 'Cottonwood', 31.827220916748, 0.555489796756862, -97.041389465332, -1.69369175688018, 218, 51, 'PPL', 'P'),
(134825, 'Cottonwood', 44.6088905334473, 0.778572015470384, -95.6738891601563, -1.66982437403284, 218, 28, 'PPL', 'P'),
(178019, 'Cottonwood', 34.7391700744629, 0.606312897209661, -112.009170532227, -1.95492881821516, 218, 5, 'PPL', 'P'),
(186585, 'Cottonwood', 37.934440612793, 0.662080888595493, -105.643608093262, -1.84382879491395, 218, 7, 'PPL', 'P'),
(188367, 'Cottonwood', 36.8738899230957, 0.643570787175979, -108.392501831055, -1.89180604142589, 218, 38, 'PPL', 'P'),
(193469, 'Cottonwood', 40.3858299255371, 0.704865703351079, -122.279716491699, -2.13418366118536, 218, 6, 'PPL', 'P'),
(194784, 'Cottonwood', 46.0486106872559, 0.803699872461664, -116.348609924316, -2.03066632329787, 218, 17, 'PPL', 'P'),
(196286, 'Cottonwood', 47.0058288574219, 0.820406481190976, -109.51277923584, -1.91135857067509, 218, 31, 'PPL', 'P'),
(202027, 'Cottonwood', 43.9669418334961, 0.767367897027339, -101.905563354492, -1.77858760663557, 218, 49, 'PPL', 'P'),
(203536, 'Cottonwood', 40.6583290100098, 0.709621709583797, -111.83332824707, -1.95185979137496, 218, 52, 'PPL', 'P'),
(211771, 'Cottonwood', 61.5133285522461, 1.07361011709773, -149.564163208008, -2.6103870909699, 218, 1, 'PPL', 'P'),
(194785, 'Cottonwood (historical)', 42.4861106872559, 0.741522517859366, -116.007217407227, -2.02470789983298, 218, 17, 'PPL', 'P'),
(199897, 'Cottonwood (historical)', 40.6333312988281, 0.709185417218215, -115.866668701172, -2.02225486215291, 218, 39, 'PPL', 'P'),
(203538, 'Cottonwood Acres', 40.6433296203613, 0.709359920848642, -111.819717407227, -1.95162223740572, 218, 52, 'PPL', 'P'),
(203540, 'Cottonwood Arms Condo', 40.6091690063477, 0.708763705659601, -111.864440917969, -1.95240280992122, 218, 52, 'PPL', 'P'),
(207110, 'Cottonwood Beach', 48.939998626709, 0.854164111957575, -122.755828857422, -2.14249338957668, 218, 56, 'PPL', 'P'),
(93474, 'Cottonwood Colonia', 26.3810005187988, 0.460435319023372, -98.1600036621094, -1.7132152576735, 218, 51, 'PPL', 'P'),
(8248, 'Cottonwood Corner', 35.0863914489746, 0.612373053428191, -90.6347198486328, -1.5818742779813, 218, 4, 'PPL', 'P'),
(148068, 'Cottonwood Cove', 42.7602806091309, 0.74630768570602, -77.726936340332, -1.35659095662683, 218, 40, 'PPL', 'P'),
(86031, 'Cottonwood Estates', 35.9736099243164, 0.627857937007429, -86.9077835083008, -1.51682696783028, 218, 50, 'PPL', 'P'),
(203543, 'Cottonwood Estates', 40.6472206115723, 0.709427831456439, -111.824996948242, -1.95171438277944, 218, 52, 'PPL', 'P'),
(32156, 'Cottonwood Falls', 38.3722190856934, 0.669721564341957, -96.5425033569336, -1.68498455169617, 218, 20, 'PPL', 'P'),
(203544, 'Cottonwood Glade', 40.6474990844727, 0.709432691725429, -111.82861328125, -1.95177749969727, 218, 52, 'PPL', 'P'),
(86032, 'Cottonwood Grove', 36.2286109924316, 0.632308545242143, -89.5250015258789, -1.56250603947953, 218, 50, 'PPL', 'P'),
(203545, 'Cottonwood Grove Condominium', 40.6311111450195, 0.709146668224354, -111.858329772949, -1.95229615031957, 218, 52, 'PPL', 'P'),
(203551, 'Cottonwood Heights', 40.6197204589844, 0.70894786324898, -111.809440612793, -1.9514428735063, 218, 52, 'PPL', 'P'),
(203549, 'Cottonwood Hills', 40.6616706848145, 0.70968003281167, -111.806106567383, -1.95138468343649, 218, 52, 'PPL', 'P'),
(203550, 'Cottonwood Hills Condo', 40.6041717529297, 0.708676487133901, -111.85417175293, -1.95222357917986, 218, 52, 'PPL', 'P'),
(203552, 'Cottonwood Manor', 40.6266708374023, 0.709069170236633, -111.808326721191, -1.95142343243035, 218, 52, 'PPL', 'P'),
(203554, 'Cottonwood Meadows', 41.1575012207031, 0.718333908194855, -112.09944152832, -1.95650434431605, 218, 52, 'PPL', 'P'),
(203555, 'Cottonwood Meadows Condominium', 40.624439239502, 0.70903022150569, -111.869438171387, -1.95249002844692, 218, 52, 'PPL', 'P'),
(203556, 'Cottonwood Meadows Estates', 40.6577796936035, 0.709612122203873, -111.840278625488, -1.95198109836261, 218, 52, 'PPL', 'P'),
(203557, 'Cottonwood Meadows Twin Homes Condominium', 40.624439239502, 0.70903022150569, -111.869438171387, -1.95249002844692, 218, 52, 'PPL', 'P'),
(203558, 'Cottonwood Park', 40.6411094665527, 0.709321171854782, -111.84944152832, -1.95214102118607, 218, 52, 'PPL', 'P'),
(54224, 'Cottonwood Point', 36.0638885498047, 0.629433596266375, -89.6991729736328, -1.56554590470581, 218, 29, 'PPL', 'P'),
(148069, 'Cottonwood Point', 42.750560760498, 0.746138042344582, -77.7266693115234, -1.35658629609492, 218, 40, 'PPL', 'P'),
(178020, 'Cottonwood Ranch', 33.6055603027344, 0.586527674260217, -112.230560302734, -1.95879279864076, 218, 5, 'PPL', 'P'),
(203559, 'Cottonwood Ridge', 40.6261100769043, 0.709059383119627, -111.813888549805, -1.95152050465208, 218, 52, 'PPL', 'P'),
(93475, 'Cottonwood Shores', 30.5555591583252, 0.533295112100682, -98.3236083984375, -1.71607069899428, 218, 51, 'PPL', 'P'),
(203560, 'Cottonwood Slopes', 40.6158294677734, 0.708879952641183, -111.829719543457, -1.95179680761518, 218, 52, 'PPL', 'P'),
(20267, 'Cottonwood Valley', 33.8147201538086, 0.590178202324443, -84.8838882446289, -1.48150333176368, 218, 13, 'PPL', 'P'),
(203561, 'Cottonwood Village', 40.6402816772461, 0.709306724205868, -111.831672668457, -1.95183089607713, 218, 52, 'PPL', 'P'),
(203562, 'Cottonwoods of Holladay', 40.6622200012207, 0.709689620191594, -111.821670532227, -1.95165632586767, 218, 52, 'PPL', 'P'),
(200633, 'Cottrell', 45.4577789306641, 0.793387912983795, -122.304443359375, -2.13461522644001, 218, 43, 'PPL', 'P'),
(145046, 'Cottrell Corners', 40.4030609130859, 0.705166440817176, -74.29638671875, -1.29671657057717, 218, 37, 'PPL', 'P'),
(124582, 'Cotuit', 41.6166687011719, 0.726347892547121, -70.4375, -1.22936629187351, 218, 23, 'PPL', 'P'),
(124583, 'Cotuit Highlands', 41.6083297729492, 0.726202350793549, -70.4375, -1.22936629187351, 218, 23, 'PPL', 'P'),
(86034, 'Cotula', 36.478328704834, 0.636666941524112, -84.0541687011719, -1.46702199386221, 218, 50, 'PPL', 'P'),
(93476, 'Cotulla', 28.4366703033447, 0.49631352509746, -99.2347183227539, -1.7319725670212, 218, 51, 'PPL', 'P'),
(115124, 'Cou Falls', 41.8172187805176, 0.72984815174684, -91.6725006103516, -1.59998696918715, 218, 16, 'PPL', 'P'),
(1805, 'Couch', 33.8930587768555, 0.59154546922809, -85.7125015258789, -1.49596536174725, 218, 2, 'PPL', 'P'),
(15642, 'Couch', 30.3833293914795, 0.530289135599282, -85.4355621337891, -1.49113185752681, 218, 12, 'PPL', 'P'),
(54225, 'Couch', 36.6061096191406, 0.638897139199971, -91.383056640625, -1.59493521891537, 218, 29, 'PPL', 'P'),
(93477, 'Couch', 28.7701396942139, 0.502133663922747, -97.7486190795898, -1.70603524221659, 218, 51, 'PPL', 'P'),
(108706, 'Couch', 38.7886085510254, 0.67698893148262, -82.0588912963867, -1.43219783365807, 218, 58, 'PPL', 'P'),
(86033, 'Couch (historical)', 36.295280456543, 0.633472146901426, -82.9569396972656, -1.44787173509567, 218, 50, 'PPL', 'P'),
(80533, 'Couchton', 33.5613899230957, 0.585756755703666, -81.6222229003906, -1.42457653240853, 218, 48, 'PPL', 'P'),
(160457, 'Couchtown', 40.3244400024414, 0.703794247065513, -77.4625015258789, -1.35197569845772, 218, 45, 'PPL', 'P'),
(86035, 'Couchville', 36.0974998474121, 0.630020224075492, -86.5538864135742, -1.51065029831406, 218, 50, 'PPL', 'P'),
(39912, 'Couchwood', 32.7586097717285, 0.571745598892651, -93.3908309936523, -1.6299774920128, 218, 22, 'PPL', 'P'),
(173671, 'Couderay', 45.7955589294434, 0.799283286109876, -91.3066711425781, -1.59360204047368, 218, 57, 'PPL', 'P'),
(160458, 'Coudersport', 41.7747192382813, 0.729106394804225, -78.0208282470703, -1.36172033804437, 218, 45, 'PPL', 'P'),
(160460, 'Coudley', 41.0719413757324, 0.71684060719262, -78.2391662597656, -1.36553105524817, 218, 45, 'PPL', 'P'),
(193470, 'Cougar', 41.5833282470703, 0.725765991848939, -122.184173583984, -2.13251612286881, 218, 6, 'PPL', 'P'),
(207111, 'Cougar', 46.0516700744629, 0.80375326884152, -122.298332214355, -2.13450856683835, 218, 56, 'PPL', 'P'),
(207112, 'Cougar Hills', 47.5652809143066, 0.83017076159067, -122.116668701172, -2.13133794040256, 218, 56, 'PPL', 'P'),
(207113, 'Cougar Valley', 47.019718170166, 0.8206488954292, -121.356941223145, -2.11807819449311, 218, 56, 'PPL', 'P'),
(93478, 'Coughlin', 30.1866703033447, 0.526856787007361, -93.857780456543, -1.63812729758066, 218, 51, 'PPL', 'P'),
(119235, 'Coughlin', 40.8958282470703, 0.713766853241478, -89.4963912963867, -1.56200669677514, 218, 18, 'PPL', 'P'),
(196287, 'Coughlin', 46.9336090087891, 0.819146007047041, -112.952781677246, -1.97139793955427, 218, 31, 'PPL', 'P'),
(93479, 'Coughran', 28.9441699981689, 0.505171065725009, -98.413330078125, -1.71763663771525, 218, 51, 'PPL', 'P'),
(194786, 'Coulam', 42.2275009155273, 0.737008925864872, -111.982498168945, -1.95446329765662, 218, 17, 'PPL', 'P'),
(46013, 'Coulborn Mill Valley', 38.314998626709, 0.668722878933178, -75.5713882446289, -1.31896954517171, 218, 25, 'PPL', 'P'),
(198146, 'Coulee', 48.545280456543, 0.847274980270731, -102.011108398438, -1.78042971516157, 218, 34, 'PPL', 'P'),
(207114, 'Coulee City', 47.6113891601563, 0.830975502293064, -119.291107177734, -2.08202258860091, 218, 56, 'PPL', 'P'),
(207115, 'Coulee Dam', 47.9655609130859, 0.837156965499247, -118.974998474121, -2.07650545092864, 218, 56, 'PPL', 'P'),
(39913, 'Couley', 31.8572196960449, 0.556013374227171, -92.8722229003906, -1.62092607325789, 218, 22, 'PPL', 'P'),
(39914, 'Coulon Plantation', 29.8144397735596, 0.520360138686167, -90.8294372558594, -1.58527273784835, 218, 22, 'PPL', 'P'),
(93480, 'Coulson Colonia', 26.3419990539551, 0.459754615048748, -97.4280014038086, -1.70043940813412, 218, 51, 'PPL', 'P'),
(54227, 'Coulstone', 37.5227813720703, 0.654896079448622, -91.751106262207, -1.6013588966227, 218, 29, 'PPL', 'P'),
(54228, 'Coulter', 36.8858299255371, 0.643779179531277, -89.2525024414063, -1.55775003324682, 218, 29, 'PPL', 'P'),
(86036, 'Coulter', 36.1883316040039, 0.631605537293389, -83.3550033569336, -1.45481925658942, 218, 50, 'PPL', 'P'),
(115125, 'Coulter', 42.7372207641602, 0.745905215486282, -93.3697204589844, -1.62960904367599, 218, 16, 'PPL', 'P'),
(154863, 'Coulter', 40.6925010681152, 0.71021812450992, -82.3441696166992, -1.43717687963208, 218, 41, 'PPL', 'P'),
(160462, 'Coulter', 40.2963905334473, 0.703304691478129, -79.8016662597656, -1.39280182481058, 218, 45, 'PPL', 'P'),
(86037, 'Coulter Shoals', 35.7997207641602, 0.624822998629175, -84.1830596923828, -1.469271566035, 218, 50, 'PPL', 'P'),
(26866, 'Coulterville', 38.1863899230957, 0.666478233608404, -89.6055603027344, -1.56391205537704, 218, 18, 'PPL', 'P'),
(86038, 'Coulterville', 35.4099998474121, 0.618021085468031, -85.1050033569336, -1.48536251849932, 218, 50, 'PPL', 'P'),
(180909, 'Coulterville', 37.7105598449707, 0.658173432065101, -120.196937561035, -2.09783231125411, 218, 6, 'PPL', 'P'),
(101085, 'Coulwood', 36.9933280944824, 0.645655376519238, -82.054443359375, -1.43212020251229, 218, 53, 'PPL', 'P'),
(86039, 'Counce', 35.0422210693359, 0.61160213487164, -88.2733306884766, -1.54066026221567, 218, 50, 'PPL', 'P'),
(8249, 'Council', 34.8722190856934, 0.608635040522156, -90.4894409179688, -1.57933868230743, 218, 4, 'PPL', 'P'),
(15643, 'Council', 26.375560760498, 0.46034037733051, -81.8038864135742, -1.42774715884433, 218, 12, 'PPL', 'P'),
(20269, 'Council', 30.6138896942139, 0.534313172006392, -82.5111083984375, -1.44009051102268, 218, 13, 'PPL', 'P'),
(63934, 'Council', 34.4208297729492, 0.600756810806456, -78.4677810668945, -1.36952113635138, 218, 33, 'PPL', 'P'),
(101086, 'Council', 37.0802803039551, 0.64717297886642, -82.0686111450195, -1.4323674770195, 218, 53, 'PPL', 'P'),
(194787, 'Council', 44.7299995422363, 0.78068576642758, -116.437217712402, -2.03221282094288, 218, 17, 'PPL', 'P'),
(211772, 'Council', 64.8949966430664, 1.13263135949218, -163.676391601563, -2.85669194123086, 218, 1, 'PPL', 'P'),
(173674, 'Council Bay', 44.0574989318848, 0.768948416555274, -91.2836074829102, -1.59319950367492, 218, 57, 'PPL', 'P'),
(1806, 'Council Bluff', 34.586669921875, 0.603651267437209, -85.6733322143555, -1.49528172829543, 218, 2, 'PPL', 'P'),
(115126, 'Council Bluffs', 41.2619400024414, 0.72015670880296, -95.8608322143555, -1.67308714584235, 218, 16, 'PPL', 'P'),
(32158, 'Council Grove', 38.6611099243164, 0.674763660654777, -96.4916687011719, -1.68409731957901, 218, 20, 'PPL', 'P'),
(75542, 'Council Hill', 35.5555610656738, 0.620561607989912, -95.6511077880859, -1.66942676408209, 218, 42, 'PPL', 'P'),
(119236, 'Council Hill', 42.4886093139648, 0.741566127122216, -90.3536071777344, -1.57696793630505, 218, 18, 'PPL', 'P'),
(170087, 'Council House', 44.0777816772461, 0.769302417243173, -99.5886077880859, -1.73814910337937, 218, 49, 'PPL', 'P'),
(188369, 'Counselor', 36.209171295166, 0.631969258519267, -107.457221984863, -1.8754823286823, 218, 38, 'PPL', 'P'),
(180910, 'Counsman', 38.749439239502, 0.676305298030797, -121.491386413574, -2.12042470572958, 218, 6, 'PPL', 'P'),
(8257, 'Countiss', 34.2802810668945, 0.598303773126384, -90.878059387207, -1.5861213541297, 218, 4, 'PPL', 'P'),
(20270, 'Country Acres', 33.9561080932617, 0.592645887390511, -84.7888870239258, -1.479845247669, 218, 13, 'PPL', 'P'),
(46040, 'Country Acres', 39.6472206115723, 0.691974538936496, -76.0841674804688, -1.32791923117298, 218, 25, 'PPL', 'P'),
(63963, 'Country Acres', 35.3450012207031, 0.616886645422684, -82.4541702270508, -1.43909675246192, 218, 33, 'PPL', 'P'),
(80498, 'Country Acres', 34.561939239502, 0.603219635603534, -82.6055603027344, -1.44173900773744, 218, 48, 'PPL', 'P'),
(134829, 'Country Acres', 44.973331451416, 0.78493270941793, -94.0524978637695, -1.64152575744771, 218, 28, 'PPL', 'P'),
(170089, 'Country Acres', 43.500560760498, 0.759228011734539, -96.8891677856445, -1.69103498737672, 218, 49, 'PPL', 'P'),
(93484, 'Country Acres Colonia', 27.9249992370605, 0.487383180303611, -97.1689987182617, -1.69591895849982, 218, 51, 'PPL', 'P'),
(20271, 'Country Acres Mobile Home Park', 33.5405616760254, 0.585393234214871, -83.9519424438477, -1.46523780908992, 218, 13, 'PPL', 'P'),
(119238, 'Country Acres Mobile Home Park', 41.7641716003418, 0.728922303793874, -89.7341690063477, -1.56615670070182, 218, 18, 'PPL', 'P'),
(93481, 'Country Acres Number 1 Colonia', 26.3199996948242, 0.459370653798585, -98.3690032958984, -1.71686298941858, 218, 51, 'PPL', 'P'),
(93482, 'Country Aire Estates Number 1 Colonia', 26.1989994049072, 0.457258800343666, -98.0019989013672, -1.71045755436472, 218, 51, 'PPL', 'P'),
(93483, 'Country Aire Estates Number 4 Colonia', 26.2089996337891, 0.457433337263607, -97.9980010986328, -1.71038777954416, 218, 51, 'PPL', 'P'),
(115127, 'Country Aire Home Park', 41.9958305358887, 0.732965514960832, -91.8722229003906, -1.60347278073795, 218, 16, 'PPL', 'P'),
(115128, 'Country Aire Mobile Home Park', 42.0333290100098, 0.733619986798719, -93.9763870239258, -1.64019737269598, 218, 16, 'PPL', 'P'),
(8251, 'Country Club', 34.7294387817383, 0.606143054111141, -92.0733337402344, -1.60698282705468, 218, 4, 'PPL', 'P'),
(15650, 'Country Club', 25.9477806091309, 0.452874205214473, -80.3172225952148, -1.40179998034368, 218, 12, 'PPL', 'P'),
(180911, 'Country Club', 37.9688911437988, 0.662682163790605, -121.339721679688, -2.11777765676409, 218, 6, 'PPL', 'P'),
(1807, 'Country Club Acres', 34.7550010681152, 0.606589200172757, -86.9552764892578, -1.51765587671956, 218, 2, 'PPL', 'P'),
(63937, 'Country Club Acres', 34.7758293151855, 0.606952721661553, -77.3711090087891, -1.35038059812282, 218, 33, 'PPL', 'P'),
(72223, 'Country Club Acres', 39.1811103820801, 0.683839380754631, -84.3794403076172, -1.47269905435794, 218, 41, 'PPL', 'P'),
(80499, 'Country Club Bluff', 32.4430618286133, 0.566238248337394, -80.654167175293, -1.4076807726628, 218, 48, 'PPL', 'P'),
(1810, 'Country Club Estates', 33.473331451416, 0.584219845438582, -86.2813873291016, -1.50589429208134, 218, 2, 'PPL', 'P'),
(13599, 'Country Club Estates', 38.9022216796875, 0.678971854651266, -75.4097213745117, -1.31614792599677, 218, 10, 'PPL', 'P'),
(20306, 'Country Club Estates', 32.4341697692871, 0.56608305262487, -81.8277816772461, -1.42816420987103, 218, 13, 'PPL', 'P'),
(26868, 'Country Club Estates', 39.4694404602051, 0.688871689950445, -88.3294372558594, -1.54163950654849, 218, 18, 'PPL', 'P'),
(46017, 'Country Club Estates', 38.7319412231445, 0.675999900032792, -76.0952835083008, -1.32811324245839, 218, 25, 'PPL', 'P'),
(63944, 'Country Club Estates', 35.2752799987793, 0.6156697805416, -77.6036071777344, -1.35443845667577, 218, 33, 'PPL', 'P'),
(80505, 'Country Club Estates', 34.8855590820313, 0.608867867380456, -81.038330078125, -1.41438568018123, 218, 48, 'PPL', 'P'),
(101089, 'Country Club Estates', 37.2588882446289, 0.650290275501385, -80.0591735839844, -1.3972961754662, 218, 53, 'PPL', 'P'),
(160463, 'Country Club Estates', 40.0066719055176, 0.698248147516396, -76.7813873291016, -1.34008801314188, 218, 45, 'PPL', 'P'),
(203564, 'Country Club Estates', 40.5986099243164, 0.708579414912167, -111.801391601563, -1.9513023917588, 218, 52, 'PPL', 'P'),
(20278, 'Country Club Gardens', 34.3677787780762, 0.599830896274463, -83.8705596923828, -1.46381741212252, 218, 13, 'PPL', 'P'),
(63947, 'Country Club Gardens', 35.2833290100098, 0.615810262289102, -81.5066680908203, -1.42255972051502, 218, 33, 'PPL', 'P'),
(122435, 'Country Club Gardens', 41.0497207641602, 0.716452784358877, -85.2225036621094, -1.48741328569673, 218, 19, 'PPL', 'P'),
(101090, 'Country Club Grove', 38.9194412231445, 0.679272392380281, -77.1297225952148, -1.34616761043636, 218, 53, 'PPL', 'P'),
(35397, 'Country Club Heights', 38.6380615234375, 0.674361390172121, -83.7900009155273, -1.46241139622502, 218, 21, 'PPL', 'P'),
(80513, 'Country Club Heights', 34.6636085510254, 0.604994099837854, -80.7738876342773, -1.40977028885407, 218, 48, 'PPL', 'P'),
(101091, 'Country Club Heights', 39.3141708374023, 0.686161723804207, -78.3244400024414, -1.36701936282336, 218, 53, 'PPL', 'P'),
(122436, 'Country Club Heights', 40.1227798461914, 0.700274613368864, -85.6872177124023, -1.49552407595462, 218, 19, 'PPL', 'P'),
(160464, 'Country Club Heights', 40.0663909912109, 0.699290442188025, -76.2747192382813, -1.33124498674227, 218, 45, 'PPL', 'P'),
(20280, 'Country Club Hills', 33.4902801513672, 0.584515656056662, -82.0166702270508, -1.43146093698444, 218, 13, 'PPL', 'P'),
(54229, 'Country Club Hills', 38.7208290100098, 0.675805955326407, -90.2747192382813, -1.57559108202148, 218, 29, 'PPL', 'P'),
(63949, 'Country Club Hills', 34.7680587768555, 0.60681710018304, -77.3694381713867, -1.35035143650888, 218, 33, 'PPL', 'P'),
(101093, 'Country Club Hills', 38.8574981689453, 0.678191282135764, -77.2938919067383, -1.34903290545318, 218, 53, 'PPL', 'P'),
(119240, 'Country Club Hills', 41.5680618286133, 0.725499542581877, -87.7202835083008, -1.53100776800273, 218, 18, 'PPL', 'P'),
(15644, 'Country Club Isles', 26.2491703033447, 0.458134447710084, -80.0933303833008, -1.39789232407621, 218, 12, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(15645, 'Country Club Manor', 28.7905597686768, 0.502490061455626, -81.2838897705078, -1.4186715053235, 218, 12, 'PPL', 'P'),
(46018, 'Country Club Manor', 39.1699981689453, 0.683645436048246, -76.5936126708984, -1.33681072710443, 218, 25, 'PPL', 'P'),
(101094, 'Country Club Manor', 38.9136085510254, 0.679170593047613, -77.1380615234375, -1.34631315218994, 218, 53, 'PPL', 'P'),
(29562, 'Country Club Meadows', 38.0230598449707, 0.663627585977583, -87.5730590820313, -1.52843821702497, 218, 19, 'PPL', 'P'),
(20281, 'Country Club Park', 31.2172203063965, 0.544843277667052, -81.4763870239258, -1.42203121619669, 218, 13, 'PPL', 'P'),
(46020, 'Country Club Park', 39.524169921875, 0.689826899254429, -76.3213882446289, -1.33205951456167, 218, 25, 'PPL', 'P'),
(63955, 'Country Club Park', 35.0827789306641, 0.612310003089383, -77.1133270263672, -1.34588145377724, 218, 33, 'PPL', 'P'),
(145047, 'Country Club Ridge', 40.0166702270508, 0.698422651146823, -74.8958282470703, -1.30717879891955, 218, 37, 'PPL', 'P'),
(46021, 'Country Club South', 38.6566696166992, 0.674686162667056, -76.8666687011719, -1.34157645387512, 218, 25, 'PPL', 'P'),
(59121, 'Country Club Subdivision', 33.4233283996582, 0.583347127549363, -88.8063888549805, -1.54996388232581, 218, 30, 'PPL', 'P'),
(134830, 'Country Club Terrace Mobile Home Park', 44.8977813720703, 0.783614111783204, -94.3927764892578, -1.64746473983664, 218, 28, 'PPL', 'P'),
(15646, 'Country Club Trail', 26.5272197723389, 0.462987326427454, -80.1202774047852, -1.39836263832472, 218, 12, 'PPL', 'P'),
(178021, 'Country Club Trailer Grove', 33.4811096191406, 0.584355600075149, -112.008331298828, -1.95491417082917, 218, 5, 'PPL', 'P'),
(101097, 'Country Club View', 38.9563903808594, 0.679917276838244, -78.1797180175781, -1.36449348768747, 218, 53, 'PPL', 'P'),
(1822, 'Country Club Village', 30.6941699981689, 0.53571432763491, -88.1647186279297, -1.53876462415175, 218, 2, 'PPL', 'P'),
(54230, 'Country Club Village', 39.832218170166, 0.695203355442108, -94.8213882446289, -1.65494542618062, 218, 29, 'PPL', 'P'),
(178022, 'Country Club Village Mobile Home Park', 33.4530601501465, 0.583866044487765, -111.831672668457, -1.95183089607713, 218, 5, 'PPL', 'P'),
(160465, 'Country Club West', 40.0149993896484, 0.698393489532887, -76.7816696166992, -1.34009293998989, 218, 45, 'PPL', 'P'),
(93485, 'Country Colony Colonia', 26.3299999237061, 0.459545190718526, -98.2480010986328, -1.71475110267415, 218, 51, 'PPL', 'P'),
(46022, 'Country Comforts', 38.3988914489746, 0.670187084900503, -75.5025024414063, -1.3177672610976, 218, 25, 'PPL', 'P'),
(93486, 'Country Corner Estates Colonia', 26.2399997711182, 0.45797439172857, -98.3919982910156, -1.71726432779486, 218, 51, 'PPL', 'P'),
(20282, 'Country Corner Mobile Home Park', 34.0194396972656, 0.593751232400948, -83.3236083984375, -1.45427131119513, 218, 13, 'PPL', 'P'),
(203566, 'Country Corners Condominium', 40.6747207641602, 0.709907799663899, -111.855560302734, -1.95224781394578, 218, 52, 'PPL', 'P'),
(196288, 'Country Court', 45.6055603027344, 0.795967184499537, -111.191673278809, -1.94066079951701, 218, 31, 'PPL', 'P'),
(115129, 'Country Court Mobile Home Park', 41.0472183227539, 0.716409108517, -94.3797225952148, -1.64723690640539, 218, 16, 'PPL', 'P'),
(178023, 'Country Cousins Mobile Mecca', 33.3925018310547, 0.58280910243014, -111.832778930664, -1.95185020399503, 218, 5, 'PPL', 'P'),
(63958, 'Country Cove', 35.9833297729492, 0.628027580368868, -80.4875030517578, -1.40477193496216, 218, 33, 'PPL', 'P'),
(20283, 'Country Creek', 34.0208282470703, 0.593775467166868, -84.647216796875, -1.47737263575492, 218, 13, 'PPL', 'P'),
(203567, 'Country Creek', 40.690559387207, 0.710184235785049, -112.086936950684, -1.95628609826472, 218, 52, 'PPL', 'P'),
(203569, 'Country Creek Estates Five', 40.6897201538086, 0.710169588399054, -112.090278625488, -1.95634442149259, 218, 52, 'PPL', 'P'),
(203570, 'Country Creek Estates One and Two', 40.6897201538086, 0.710169588399054, -112.084167480469, -1.95623776189094, 218, 52, 'PPL', 'P'),
(20284, 'Country Downs', 33.4436111450195, 0.583701128237262, -84.602783203125, -1.47659712324549, 218, 13, 'PPL', 'P'),
(39917, 'Country Estate Acres', 30.5869407653809, 0.53384282446837, -91.0508270263672, -1.58913671827395, 218, 22, 'PPL', 'P'),
(115130, 'Country Estate Village', 41.6236114501953, 0.72646906637672, -93.5500030517578, -1.63275556850392, 218, 16, 'PPL', 'P'),
(1824, 'Country Estates', 33.6344413757324, 0.587031744075542, -86.6666717529297, -1.51261877383379, 218, 2, 'PPL', 'P'),
(13600, 'Country Estates', 38.538890838623, 0.672630535200651, -75.102783203125, -1.31079084430602, 218, 10, 'PPL', 'P'),
(80516, 'Country Estates', 34.5277786254883, 0.602623420414493, -82.6091690063477, -1.44180199149722, 218, 48, 'PPL', 'P'),
(160466, 'Country Estates', 40.1841697692871, 0.70134606965443, -77.0183334350586, -1.34422350284061, 218, 45, 'PPL', 'P'),
(178024, 'Country Estates', 34.5374984741211, 0.602793063775931, -111.849166870117, -1.95213622749611, 218, 5, 'PPL', 'P'),
(93487, 'Country Estates Colonia', 27.8859996795654, 0.4867025096185, -97.1660003662109, -1.6958666273844, 218, 51, 'PPL', 'P'),
(115132, 'Country Estates Mobile Home Park', 41.7538909912109, 0.72874287331543, -90.5374984741211, -1.58017744489276, 218, 16, 'PPL', 'P'),
(141557, 'Country Estates Mobile Home Park', 41.5444412231445, 0.725087285245132, -96.1277770996094, -1.67774621301139, 218, 35, 'PPL', 'P'),
(196289, 'Country Estates Mobile Home Park', 48.3861083984375, 0.844496903779615, -114.191673278809, -1.99302067707684, 218, 31, 'PPL', 'P'),
(170090, 'Country Estates Subdivision', 43.5152816772461, 0.759484940200705, -96.9291687011719, -1.69173313505648, 218, 49, 'PPL', 'P'),
(93488, 'Country Estates West Addition A Colonia', 26.2800006866455, 0.458672539408335, -98.3600006103516, -1.71670586291427, 218, 51, 'PPL', 'P'),
(93489, 'Country Estates West Colonia', 26.2800006866455, 0.458672539408335, -98.3610000610352, -1.71672330661941, 218, 51, 'PPL', 'P'),
(170091, 'Country Gables Subdivision', 43.5805587768555, 0.760624240515041, -96.6122207641602, -1.68620134999823, 218, 49, 'PPL', 'P'),
(211463, 'Country Garden Estates', 19.0688896179199, 0.332814908532066, -155.801116943359, -2.71924246894634, 218, 15, 'PPL', 'P'),
(101099, 'Country Green', 38.0088882446289, 0.663380244891342, -78.5227813720703, -1.3704810727663, 218, 53, 'PPL', 'P'),
(191328, 'Country Green Addition Colonia', 31.6480007171631, 0.552361814188023, -106.261001586914, -1.85460434415857, 218, 51, 'PPL', 'P'),
(178025, 'Country Greens at Villa de Paz', 33.5022201538086, 0.584724048411961, -112.285827636719, -1.95975739558759, 218, 5, 'PPL', 'P'),
(93490, 'Country Grove Estates Colonia', 26.2409992218018, 0.45799183543371, -98.3949966430664, -1.71731665891028, 218, 51, 'PPL', 'P'),
(86040, 'Country Haven', 35.6958312988281, 0.623009785400995, -84.0119400024414, -1.46628496403054, 218, 50, 'PPL', 'P'),
(72220, 'Country Haven Mobile Home Park', 39.8936080932617, 0.696274811727674, -84.0138931274414, -1.46631905249249, 218, 41, 'PPL', 'P'),
(1827, 'Country Hills', 33.1569404602051, 0.578697780918302, -86.8311080932617, -1.51548872938251, 218, 2, 'PPL', 'P'),
(101100, 'Country Hills', 37.2152786254883, 0.64952914406184, -80.0963897705078, -1.39794572045607, 218, 53, 'PPL', 'P'),
(203576, 'Country Hills', 40.642219543457, 0.709340546351712, -111.998611450195, -1.95474452746773, 218, 52, 'PPL', 'P'),
(203579, 'Country Hills Manor Condominiums', 41.1897201538086, 0.718896234659025, -111.956108093262, -1.95400270394609, 218, 52, 'PPL', 'P'),
(178026, 'Country Hills Mobile Estates', 33.4625015258789, 0.584030827580213, -112.315559387207, -1.96027631252599, 218, 5, 'PPL', 'P'),
(203580, 'Country Hills Square Condominium', 41.1852798461914, 0.718818736671304, -111.951110839844, -1.95391548542039, 218, 52, 'PPL', 'P'),
(39918, 'Country Hollow', 29.7372207641602, 0.519012412727019, -90.8288879394531, -1.58526315046842, 218, 22, 'PPL', 'P'),
(80517, 'Country Homes', 34.2125015258789, 0.597120796970171, -82.0936126708984, -1.43280383596411, 218, 48, 'PPL', 'P'),
(207117, 'Country Homes', 47.7486114501953, 0.833370483061373, -117.403327941895, -2.04907462538472, 218, 56, 'PPL', 'P'),
(178027, 'Country Horizons', 33.5736083984375, 0.585970008327955, -111.891670227051, -1.95287805101775, 218, 5, 'PPL', 'P'),
(148070, 'Country Knolls', 42.9150009155273, 0.749008064472333, -73.8055572509766, -1.28814998029872, 218, 40, 'PPL', 'P'),
(20285, 'Country Lake', 33.8916702270508, 0.59152123446217, -84.6430587768555, -1.47730006461521, 218, 13, 'PPL', 'P'),
(70696, 'Country Lake Estates', 39.9425010681152, 0.697128155119963, -74.5444412231445, -1.30104593840326, 218, 37, 'PPL', 'P'),
(46023, 'Country Lakes', 38.4055595397949, 0.67030346504014, -76.7944412231445, -1.34031584657313, 218, 25, 'PPL', 'P'),
(46024, 'Country Life Acres', 38.8708305358887, 0.678423975836009, -75.9283294677734, -1.32519934475168, 218, 25, 'PPL', 'P'),
(54231, 'Country Life Acres', 38.6238899230957, 0.674114049085879, -90.4561080932617, -1.57875691476731, 218, 29, 'PPL', 'P'),
(93491, 'Country Living Estates Colonia', 26.1639995574951, 0.456647937768629, -98.1320037841797, -1.71272656761347, 218, 51, 'PPL', 'P'),
(93492, 'Country Living Estates Number 2 Colonia', 26.1630001068115, 0.456630494063489, -98.1289978027344, -1.71267410334, 218, 51, 'PPL', 'P'),
(13601, 'Country Living Mobile Home Park', 38.5863914489746, 0.673459577247992, -75.3452835083008, -1.31502327306843, 218, 10, 'PPL', 'P'),
(115133, 'Country Living Mobile Home Park', 41.6847190856934, 0.727535595814269, -93.5055618286133, -1.63197992283643, 218, 16, 'PPL', 'P'),
(20287, 'Country Manor', 33.434440612793, 0.583541072255748, -84.6838912963867, -1.47801272652292, 218, 13, 'PPL', 'P'),
(80518, 'Country Manor', 34.1500015258789, 0.596029966187674, -79.7191696166992, -1.39136198676723, 218, 48, 'PPL', 'P'),
(203588, 'Country Manor', 40.6305618286133, 0.70913708084443, -111.82250213623, -1.95167084009561, 218, 52, 'PPL', 'P'),
(154864, 'Country Manor Estates', 41.4288902282715, 0.723070539930643, -83.6763916015625, -1.4604285396354, 218, 41, 'PPL', 'P'),
(180913, 'Country Manor Estates', 33.4813919067383, 0.584360526923165, -117.110832214355, -2.04396961189114, 218, 6, 'PPL', 'P'),
(26869, 'Country Meadows', 39.9808311462402, 0.697797141185791, -91.3611068725586, -1.59455212319257, 218, 18, 'PPL', 'P'),
(154865, 'Country Meadows', 41.5605583190918, 0.725368581635272, -83.5086135864258, -1.4575002608588, 218, 41, 'PPL', 'P'),
(178028, 'Country Meadows', 33.5658302307129, 0.585834253691388, -112.283889770508, -1.95972357344174, 218, 5, 'PPL', 'P'),
(180914, 'Country Mobile Estates', 34.4830589294434, 0.601842914478018, -117.830001831055, -2.05652148958285, 218, 6, 'PPL', 'P'),
(141558, 'Country Mobile Villa', 41.4402809143066, 0.723269344906017, -97.2861099243164, -1.69796293463645, 218, 35, 'PPL', 'P'),
(59126, 'Country Oak Estates', 34.2361106872559, 0.597532854569833, -88.8324966430664, -1.55041954918832, 218, 30, 'PPL', 'P'),
(80520, 'Country Oaks', 34.9747200012207, 0.610424018984416, -81.0883331298828, -1.41525839807045, 218, 48, 'PPL', 'P'),
(203593, 'Country Oaks Condominium', 41.0875015258789, 0.717112183044781, -111.918609619141, -1.9533482321082, 218, 52, 'PPL', 'P'),
(20288, 'Country Park', 34.0022201538086, 0.593450694671933, -84.0111083984375, -1.46627044980259, 218, 13, 'PPL', 'P'),
(86042, 'Country Park', 35.8347206115723, 0.625433861204212, -86.4736099243164, -1.50924920926457, 218, 50, 'PPL', 'P'),
(101111, 'Country Park', 39.1708297729492, 0.683659950276187, -78.1247177124023, -1.36353355127255, 218, 53, 'PPL', 'P'),
(20290, 'Country Pine Estates', 33.6425018310547, 0.587172425560125, -84.2780609130859, -1.47092965012969, 218, 13, 'PPL', 'P'),
(20291, 'Country Place', 33.5430603027344, 0.585436843477721, -82.1436080932617, -1.43367642069528, 218, 13, 'PPL', 'P'),
(39921, 'Country Place', 32.561939239502, 0.568313050563648, -93.6041717529297, -1.6337009906909, 218, 22, 'PPL', 'P'),
(46026, 'Country Place', 39.1333312988281, 0.6830054784383, -76.5374984741211, -1.33583134961355, 218, 25, 'PPL', 'P'),
(63965, 'Country Place', 35.7386093139648, 0.623756402612598, -79.7750015258789, -1.39233643741009, 218, 33, 'PPL', 'P'),
(80522, 'Country Place', 34.5722198486328, 0.603399066081978, -82.6097183227539, -1.44181157887714, 218, 48, 'PPL', 'P'),
(101101, 'Country Place', 38.7666702270508, 0.676606035496894, -77.4944381713867, -1.35253309807387, 218, 53, 'PPL', 'P'),
(20293, 'Country Ridge', 34.1419410705566, 0.595889284703091, -84.2986068725586, -1.47128824477047, 218, 13, 'PPL', 'P'),
(46027, 'Country Ridge', 39.3105583190918, 0.6860986734654, -76.4502792358398, -1.33430908673446, 218, 25, 'PPL', 'P'),
(63967, 'Country Ridge', 35.3197212219238, 0.616445426209086, -82.5038909912109, -1.43996454350312, 218, 33, 'PPL', 'P'),
(178029, 'Country Ridge', 33.6566696166992, 0.587419700067339, -112.122779846191, -1.95691167480478, 218, 5, 'PPL', 'P'),
(39922, 'Country Road', 30.4947204589844, 0.532233276484554, -91.0166702270508, -1.58854056966393, 218, 22, 'PPL', 'P'),
(8255, 'Country Road Estates', 35.0458297729492, 0.611665118631421, -91.9986114501953, -1.60567867706886, 218, 4, 'PPL', 'P'),
(46028, 'Country Road Estates', 38.7347183227539, 0.676048369564631, -76.6536102294922, -1.33785788204504, 218, 25, 'PPL', 'P'),
(180915, 'Country Road Estates', 33.6027793884277, 0.58647913814935, -117.08943939209, -2.04359623670632, 218, 6, 'PPL', 'P'),
(20294, 'Country Roads', 33.5830612182617, 0.586134991157485, -84.2330627441406, -1.47014428392422, 218, 13, 'PPL', 'P'),
(101102, 'Country Roads', 38.7247200012207, 0.675873865934204, -77.4836120605469, -1.35234414679453, 218, 53, 'PPL', 'P'),
(101103, 'Country Scene', 38.792781829834, 0.677061768938434, -77.5194396972656, -1.35296945701848, 218, 53, 'PPL', 'P'),
(46029, 'Country Side', 39.3624992370605, 0.687005213500463, -77.4194412231445, -1.3512241543981, 218, 25, 'PPL', 'P'),
(20296, 'Country Square', 33.8908309936523, 0.591506587076175, -84.8386077880859, -1.4807130387102, 218, 13, 'PPL', 'P'),
(20297, 'Country Squire', 32.4263916015625, 0.565947297988303, -81.8152770996094, -1.4279459638197, 218, 13, 'PPL', 'P'),
(46030, 'Country Squire', 39.3877792358398, 0.687446432714061, -77.345832824707, -1.34993944548824, 218, 25, 'PPL', 'P'),
(20298, 'Country Squire Acres', 33.8227806091309, 0.590318883809027, -84.2708282470703, -1.47080341629402, 218, 13, 'PPL', 'P'),
(203597, 'Country Squire Acres', 40.605281829834, 0.708695861630831, -111.881942749023, -1.95270827449825, 218, 52, 'PPL', 'P'),
(46031, 'Country Squire Estates', 39.6822204589844, 0.692585401511533, -77.5744400024414, -1.3539293934334, 218, 25, 'PPL', 'P'),
(203599, 'Country Station Condominium', 40.8955612182617, 0.71376219270957, -111.885833740234, -1.95277618510605, 218, 52, 'PPL', 'P'),
(20299, 'Country Terrace', 33.5694389343262, 0.585897237451168, -83.9444427490234, -1.46510691472234, 218, 13, 'PPL', 'P'),
(93493, 'Country Terrace Estates Colonia', 26.3190002441406, 0.459353210093445, -98.0699996948242, -1.71164439210452, 218, 51, 'PPL', 'P'),
(178030, 'Country Trace', 33.6347198486328, 0.587036604344531, -111.926391601563, -1.95348405332379, 218, 5, 'PPL', 'P'),
(46032, 'Country Trails', 39.6916694641113, 0.692750317762036, -76.9502792358398, -1.34303573299443, 218, 25, 'PPL', 'P'),
(134831, 'Country Valley Mobile Home Park', 44.0716705322266, 0.769195757641515, -91.725830078125, -1.60091774398813, 218, 28, 'PPL', 'P'),
(20300, 'Country View', 33.6011085510254, 0.586449976535414, -83.9355621337891, -1.4649519187469, 218, 13, 'PPL', 'P'),
(46033, 'Country View', 39.3505592346191, 0.686796821145164, -77.1272201538086, -1.34612393459449, 218, 25, 'PPL', 'P'),
(101104, 'Country View', 38.0513916015625, 0.664122068412984, -78.6277770996094, -1.37231359391238, 218, 53, 'PPL', 'P'),
(93494, 'Country View Colonia', 26.2549991607666, 0.458236180463725, -98.1389999389648, -1.71284867354945, 218, 51, 'PPL', 'P'),
(124584, 'Country View Estates', 42.0958290100098, 0.734710817581215, -71.4375, -1.24681958439345, 218, 23, 'PPL', 'P'),
(203600, 'Country View Lane', 40.6141700744629, 0.708850990764328, -111.827781677246, -1.95176298546933, 218, 52, 'PPL', 'P'),
(115134, 'Country View Mobile Home Park', 42.0144386291504, 0.733290287455767, -95.3291702270508, -1.66380789365619, 218, 16, 'PPL', 'P'),
(178031, 'Country Villa', 33.4411087036133, 0.583657452395384, -112.337783813477, -1.96066420193876, 218, 5, 'PPL', 'P'),
(180916, 'Country Villa Estates Mobile Home Park', 36.9855613708496, 0.645519821619753, -121.944999694824, -2.12834175101816, 218, 6, 'PPL', 'P'),
(115135, 'Country Villa Mobile Home Park', 43.1258316040039, 0.752687754150496, -95.1111068725586, -1.66000197014235, 218, 16, 'PPL', 'P'),
(80523, 'Country Villa Subdivision', 34.7791709899902, 0.607011044889425, -83.0272216796875, -1.44909838709376, 218, 48, 'PPL', 'P'),
(13602, 'Country Village', 38.7163887023926, 0.675728457338685, -75.1500015258789, -1.31161495950535, 218, 10, 'PPL', 'P'),
(20301, 'Country Village', 34.2411117553711, 0.597620139674561, -84.8586120605469, -1.48106217912911, 218, 13, 'PPL', 'P'),
(93495, 'Country Village Colonia Number 1', 26.242000579834, 0.458009312428364, -97.9940032958984, -1.7103180047236, 218, 51, 'PPL', 'P'),
(93496, 'Country Village Colonia Number 2', 26.2409992218018, 0.45799183543371, -97.9940032958984, -1.7103180047236, 218, 51, 'PPL', 'P'),
(134832, 'Country Village Mobile Estates', 45.0736083984375, 0.786682872307302, -94.1983337402344, -1.64407107365955, 218, 28, 'PPL', 'P'),
(170092, 'Country Village Mobile Park', 45.5105590820313, 0.794309100404853, -98.5250015258789, -1.71958567215902, 218, 49, 'PPL', 'P'),
(108708, 'Country Villas', 38.4494400024414, 0.671069323590619, -81.9611129760742, -1.43049128003154, 218, 58, 'PPL', 'P'),
(15647, 'Country Walk', 25.6336097717285, 0.447390889688055, -80.432502746582, -1.40381199854724, 218, 12, 'PPL', 'P'),
(46035, 'Country Walk', 39.4891700744629, 0.689216036679392, -76.3361129760742, -1.33231650960686, 218, 25, 'PPL', 'P'),
(203602, 'Country West', 40.6944389343262, 0.710251946655764, -112.087219238281, -1.95629102511274, 218, 52, 'PPL', 'P'),
(20302, 'Country Wood', 33.5591697692871, 0.585718006709806, -83.9602813720703, -1.46538335084349, 218, 13, 'PPL', 'P'),
(32160, 'Countryside', 39.0166702270508, 0.68096935862688, -94.654167175293, -1.652026867942, 218, 20, 'PPL', 'P'),
(46038, 'Countryside', 39.6972198486328, 0.692847190246688, -77.7483291625977, -1.35696433181165, 218, 25, 'PPL', 'P'),
(86047, 'Countryside', 35.9561080932617, 0.627552472430397, -84.0558319091797, -1.4670510223181, 218, 50, 'PPL', 'P'),
(101105, 'Countryside', 39.040828704834, 0.681391003606466, -77.4138870239258, -1.35112721533442, 218, 53, 'PPL', 'P'),
(119241, 'Countryside', 41.7827796936035, 0.729247076288809, -87.878059387207, -1.53376147656987, 218, 18, 'PPL', 'P'),
(124585, 'Countryside', 42.4419403076172, 0.740751599302815, -71.1944427490234, -1.24257743509306, 218, 23, 'PPL', 'P'),
(203605, 'Countryside Condominium', 40.6258316040039, 0.709054522850637, -111.873611450195, -1.95256286590274, 218, 52, 'PPL', 'P'),
(196290, 'Countryside Court Mobile Home Park', 46.8883285522461, 0.81835571399356, -114.069717407227, -1.99089214557559, 218, 31, 'PPL', 'P'),
(1833, 'Countryside Estates', 33.7133293151855, 0.588408598359113, -86.5838928222656, -1.51117400894242, 218, 2, 'PPL', 'P'),
(20304, 'Countryside Estates', 34.0250015258789, 0.593848304622682, -84.6736068725586, -1.47783322946545, 218, 13, 'PPL', 'P'),
(86049, 'Countryside Estates', 36.1791687011719, 0.63144561446993, -85.4408264160156, -1.49122373658442, 218, 50, 'PPL', 'P'),
(101107, 'Countryside Estates', 37.3158302307129, 0.651284100641175, -79.9858322143555, -1.39601612708825, 218, 53, 'PPL', 'P'),
(141559, 'Countryside Estates', 40.836669921875, 0.712734345686854, -96.7191696166992, -1.68806795960626, 218, 35, 'PPL', 'P'),
(171883, 'Countryside Estates', 43.6427803039551, 0.761710211028548, -72.9725036621094, -1.27361045232743, 218, 55, 'PPL', 'P'),
(13603, 'Countryside Farms', 39.5886116027832, 0.690951618761796, -75.7169418334961, -1.32150993453554, 218, 10, 'PPL', 'P'),
(80524, 'Countryside Manor', 34.7944412231445, 0.607277560735515, -82.5966720581055, -1.44158387860394, 218, 48, 'PPL', 'P'),
(115136, 'Countryside Mobile Home Court', 40.9550018310547, 0.714799627112211, -91.5633316040039, -1.59808161058525, 218, 16, 'PPL', 'P'),
(134833, 'Countryside Mobile Home Park', 43.6666717529297, 0.762127195476227, -92.9749984741211, -1.62271984541012, 218, 28, 'PPL', 'P'),
(141560, 'Countryside Mobile Home Park', 40.4986114501953, 0.706834112291784, -98.9475021362305, -1.72695969890134, 218, 35, 'PPL', 'P'),
(178032, 'Countryside Mobile Home Park', 33.3761100769043, 0.582523012350038, -112.101387023926, -1.95653829961995, 218, 5, 'PPL', 'P'),
(141561, 'Countryside Mobile Park', 40.6994400024414, 0.710339231760492, -99.0811080932617, -1.72929156275182, 218, 35, 'PPL', 'P'),
(141562, 'Countryside Parks', 40.586109161377, 0.708361235439862, -98.3880615234375, -1.71719561823873, 218, 35, 'PPL', 'P'),
(86050, 'Countryside Village', 35.2266693115234, 0.614821363997328, -84.8805618286133, -1.48144527485192, 218, 50, 'PPL', 'P'),
(196291, 'Countryside Village', 47.5394401550293, 0.829719755260065, -111.295829772949, -1.9424786732771, 218, 31, 'PPL', 'P'),
(20305, 'Countryside Village Mobile Home Park', 33.913890838623, 0.591909057295913, -84.1022186279297, -1.46786062328948, 218, 13, 'PPL', 'P'),
(46039, 'Countryside West', 39.4391708374023, 0.6883433853692, -77.5763931274414, -1.35396348189535, 218, 25, 'PPL', 'P'),
(101109, 'Countryside West', 37.7855606079102, 0.659482442319902, -77.9313888549805, -1.36015932617142, 218, 53, 'PPL', 'P'),
(134834, 'Countryview Estates', 44.5180587768555, 0.776986702252488, -94.7183303833008, -1.65314672718038, 218, 28, 'PPL', 'P'),
(141563, 'Countryview Estates', 41.4458312988281, 0.723366217390669, -97.3916702270508, -1.69980530947857, 218, 35, 'PPL', 'P'),
(59130, 'Counts', 34.0694389343262, 0.59462388371114, -90.5597229003906, -1.58056533430553, 218, 30, 'PPL', 'P'),
(75544, 'Counts', 34.6733283996582, 0.605163743199292, -95.57861328125, -1.66816149624819, 218, 42, 'PPL', 'P'),
(101110, 'Counts', 36.9283294677734, 0.644520936473892, -82.2263870239258, -1.43512118558665, 218, 53, 'PPL', 'P'),
(35398, 'Counts Crossroads', 38.3180618286133, 0.668776341892061, -83.1191711425781, -1.45070320796665, 218, 21, 'PPL', 'P'),
(108707, 'Countsville', 38.6933288574219, 0.675325987118947, -81.4408264160156, -1.42141056650465, 218, 58, 'PPL', 'P'),
(32162, 'County Acres', 37.6988906860352, 0.657969766820737, -97.4316711425781, -1.70050345715833, 218, 20, 'PPL', 'P'),
(39923, 'County Acres', 32.5941696166992, 0.5688755767649, -91.9783325195313, -1.60532474295999, 218, 22, 'PPL', 'P'),
(15648, 'County Club Acres', 26.4500007629395, 0.461639600468306, -80.1277770996094, -1.3984935326923, 218, 12, 'PPL', 'P'),
(178033, 'County Fair West', 33.4777793884277, 0.584297476584358, -112.195831298828, -1.95818666317666, 218, 5, 'PPL', 'P'),
(39924, 'County Landing', 32.4000015258789, 0.565486704277774, -91.4855575561523, -1.59672419737764, 218, 22, 'PPL', 'P'),
(1837, 'County Line', 34.2991714477539, 0.598633472469336, -86.6980590820313, -1.51316658607002, 218, 2, 'PPL', 'P'),
(8256, 'County Line', 36.4866714477539, 0.636812549856712, -92.1505584716797, -1.60833065288236, 218, 4, 'PPL', 'P'),
(20307, 'County Line', 32.878059387207, 0.573830387972992, -84.7680587768555, -1.47948172618021, 218, 13, 'PPL', 'P'),
(72221, 'County Line', 39.7447204589844, 0.693676232294029, -84.4819412231445, -1.4744880328202, 218, 41, 'PPL', 'P'),
(93498, 'County Line', 32.9742698669434, 0.575509577619314, -95.7863464355469, -1.67178712375623, 218, 51, 'PPL', 'P'),
(148071, 'County Line', 43.3463897705078, 0.756537220348151, -78.4661102294922, -1.36949197473744, 218, 40, 'PPL', 'P'),
(160467, 'County Line', 40.1650009155273, 0.701011510042489, -75.0605621337891, -1.3100539476324, 218, 45, 'PPL', 'P'),
(173675, 'County Line', 44.9902801513672, 0.78522852003601, -87.8525009155273, -1.53331539708728, 218, 57, 'PPL', 'P'),
(72222, 'County Line (historical)', 39.9208297729492, 0.696749919666144, -84.3147201538086, -1.47156947458158, 218, 41, 'PPL', 'P'),
(101112, 'County Line Cross Roads', 37.1408309936523, 0.648229787765991, -78.5288925170898, -1.37058773236796, 218, 53, 'PPL', 'P'),
(20308, 'County Line Heights', 33.7541694641113, 0.589121393424873, -84.6805572509766, -1.4779545364531, 218, 13, 'PPL', 'P'),
(20309, 'County Line Place', 33.7563896179199, 0.589160142418733, -84.6788864135742, -1.47792537483916, 218, 13, 'PPL', 'P'),
(93499, 'County Road 111 Colonia', 27.7549991607666, 0.48441611924364, -98.2369995117188, -1.71455908875955, 218, 51, 'PPL', 'P'),
(13604, 'County Seat Gardens Mobile Home Park', 38.7166709899902, 0.675733384186702, -75.3894424438477, -1.3157939918879, 218, 10, 'PPL', 'P'),
(39925, 'County Side', 32.5230598449707, 0.567634477117895, -92.1788864135742, -1.60882506873874, 218, 22, 'PPL', 'P'),
(29564, 'County Squire Lakes', 39.0347213745117, 0.681284410583836, -85.6986083984375, -1.49572288093, 218, 19, 'PPL', 'P'),
(46041, 'County View', 39.2680587768555, 0.685356916522785, -77.2080612182617, -1.34753487734001, 218, 25, 'PPL', 'P'),
(75545, 'Countyline', 34.4486083984375, 0.601241639282905, -97.5625, -1.70278685147697, 218, 42, 'PPL', 'P'),
(86051, 'Countyline', 35.3230590820313, 0.616503682857931, -86.3688888549805, -1.50742148180844, 218, 50, 'PPL', 'P'),
(207118, 'Coupeville', 48.2200012207031, 0.841597786616954, -122.684997558594, -2.14125715019867, 218, 56, 'PPL', 'P'),
(93501, 'Coupland', 30.4597206115723, 0.531622413909517, -97.3883285522461, -1.6997469862507, 218, 51, 'PPL', 'P'),
(160470, 'Coupon', 40.5366706848145, 0.707498371246677, -78.5152816772461, -1.37035017839872, 218, 45, 'PPL', 'P'),
(191329, 'Courchesne', 31.7938899993896, 0.554908062506247, -106.531669616699, -1.85932839245821, 218, 51, 'PPL', 'P'),
(32163, 'Coursens Grove (historical)', 39.276668548584, 0.685507185387293, -97.9686126708984, -1.70987485471821, 218, 20, 'PPL', 'P'),
(70697, 'Courses Landing', 39.6611099243164, 0.69221695317472, -75.4094390869141, -1.31614299914876, 218, 37, 'PPL', 'P'),
(101113, 'Court House Hill', 37.4155616760254, 0.653024742729651, -79.1452789306641, -1.38134570474938, 218, 53, 'PPL', 'P'),
(124586, 'Court Park', 42.3727798461914, 0.739544521538737, -70.9952774047852, -1.23910134408024, 218, 23, 'PPL', 'P'),
(39926, 'Courtableau', 30.5491695404053, 0.533183592230035, -91.8813934326172, -1.60363283671946, 218, 22, 'PPL', 'P'),
(160468, 'Courtdale', 41.2799987792969, 0.720471893917971, -75.9124984741211, -1.32492304178858, 218, 45, 'PPL', 'P'),
(15649, 'Courtenay', 28.4566707611084, 0.496662598937342, -80.709716796875, -1.40865029645764, 218, 12, 'PPL', 'P'),
(80525, 'Courtenay', 34.7130584716797, 0.605857163768121, -82.9197235107422, -1.4472221901058, 218, 48, 'PPL', 'P'),
(139837, 'Courtenay', 47.2222213745117, 0.824183243090872, -98.5661087036133, -1.72030312775669, 218, 34, 'PPL', 'P'),
(122437, 'Courter', 40.8369407653809, 0.712739072797789, -86.0630569458008, -1.5020837080356, 218, 19, 'PPL', 'P'),
(101115, 'Courthouse Green', 37.3802795410156, 0.652408953306597, -77.4958267211914, -1.35255733283979, 218, 53, 'PPL', 'P'),
(101117, 'Courthouse Landing', 37.6577796936035, 0.657252244644043, -76.879997253418, -1.34180908099634, 218, 53, 'PPL', 'P'),
(1839, 'Courtland', 34.6688919067383, 0.605086311790598, -87.309440612793, -1.52383720676769, 218, 2, 'PPL', 'P'),
(32164, 'Courtland', 39.7813911437988, 0.694316256483003, -97.8925018310547, -1.70854646996648, 218, 20, 'PPL', 'P'),
(59131, 'Courtland', 34.2408294677734, 0.597615212826544, -89.9427795410156, -1.56979764138612, 218, 30, 'PPL', 'P'),
(86053, 'Courtland', 36.4700012207031, 0.636521599507621, -86.8441696166992, -1.51571669597182, 218, 50, 'PPL', 'P'),
(101120, 'Courtland', 36.7161102294922, 0.64081701202981, -77.0683288574219, -1.34509608757177, 218, 53, 'PPL', 'P'),
(134835, 'Courtland', 44.2683296203613, 0.772628106233437, -94.3399963378906, -1.64654355241558, 218, 28, 'PPL', 'P'),
(178034, 'Courtland', 31.7700004577637, 0.554491111348082, -109.808059692383, -1.91651218685855, 218, 5, 'PPL', 'P'),
(180917, 'Courtland', 38.3311080932617, 0.669004042165263, -121.567497253418, -2.12175309048131, 218, 6, 'PPL', 'P'),
(101119, 'Courtland Park', 38.8488883972168, 0.678041013271256, -77.1397171020508, -1.34634204748776, 218, 53, 'PPL', 'P'),
(54232, 'Courtney', 39.1555595397949, 0.683393434430097, -94.3933334350586, -1.64747446037462, 218, 29, 'PPL', 'P'),
(63976, 'Courtney', 36.060001373291, 0.629365752237605, -80.6208267211914, -1.40709887196461, 218, 33, 'PPL', 'P'),
(75546, 'Courtney', 33.9402809143066, 0.592369651006442, -97.508056640625, -1.70183663560003, 218, 42, 'PPL', 'P'),
(160473, 'Courtney', 40.2186088562012, 0.701947145112461, -79.9688873291016, -1.3957203830492, 218, 45, 'PPL', 'P'),
(191330, 'Courtney', 32.146671295166, 0.561065257656997, -101.905563354492, -1.77858760663557, 218, 51, 'PPL', 'P'),
(122438, 'Courtney Corner', 41.6294403076172, 0.726570799130361, -84.8386077880859, -1.4807130387102, 218, 19, 'PPL', 'P'),
(46042, 'Courtney Manor', 38.7930603027344, 0.677066629207423, -76.6808319091797, -1.33833298998352, 218, 25, 'PPL', 'P'),
(160471, 'Courtneys Mills', 41.1130599975586, 0.717558262527369, -80.0744400024414, -1.39756262473326, 218, 45, 'PPL', 'P'),
(54233, 'Courtois', 37.764720916748, 0.659118721094025, -91.0719375610352, -1.58950516661076, 218, 29, 'PPL', 'P'),
(108709, 'Courtright', 39.2866706848145, 0.685681755596748, -80.2772216796875, -1.40110183266392, 218, 58, 'PPL', 'P'),
(72224, 'Courtright (historical)', 39.4483299255371, 0.688503241613632, -82.9274978637695, -1.44735787816334, 218, 41, 'PPL', 'P'),
(200634, 'Courtrock', 44.6408309936523, 0.779129481665565, -119.366943359375, -2.08334617966267, 218, 43, 'PPL', 'P'),
(46043, 'Courts of Crofton', 39.0008316040039, 0.680692922505729, -76.6761093139648, -1.33825056514778, 218, 25, 'PPL', 'P'),
(46044, 'Courts of Harford Square', 39.4291687011719, 0.688168815159745, -76.3199996948242, -1.33203527979575, 218, 25, 'PPL', 'P'),
(124587, 'Coury Heights', 41.6958312988281, 0.727729540520654, -70.9250030517578, -1.2378748252402, 218, 23, 'PPL', 'P'),
(148072, 'Couse', 42.6194381713867, 0.74384952144085, -73.7024993896484, -1.28635128129848, 218, 40, 'PPL', 'P'),
(39930, 'Coushatta', 32.014720916748, 0.558762289104351, -93.3419418334961, -1.62912421519954, 218, 22, 'PPL', 'P'),
(93502, 'Coushatta Village', 30.2749996185303, 0.528398424383381, -94.7958297729492, -1.65449934669803, 218, 51, 'PPL', 'P'),
(127167, 'Cousins Island', 43.7588882446289, 0.763736676881016, -70.144172668457, -1.22424676415199, 218, 26, 'PPL', 'P'),
(39928, 'Couters Neck', 32.9963912963867, 0.575895669398348, -91.991943359375, -1.60556229692923, 218, 22, 'PPL', 'P'),
(207121, 'Covada', 48.2205581665039, 0.841607507154933, -118.207778930664, -2.06311494380967, 218, 56, 'PPL', 'P'),
(78083, 'Covalt', 39.8224983215332, 0.69503371208067, -78.1452789306641, -1.36389241222944, 218, 45, 'PPL', 'P'),
(91, 'Cove', 36.9819412231445, 0.645456638122891, -78.7458267211914, -1.37437394848972, 218, 53, 'PPL', 'P'),
(310, 'Cove', 34.435001373291, 0.601004151892697, -94.4111099243164, -1.64778471864162, 218, 4, 'PPL', 'P'),
(15653, 'Cove', 30.1455593109131, 0.526139264830666, -85.649169921875, -1.49486001673681, 218, 12, 'PPL', 'P'),
(54235, 'Cove', 36.5805587768555, 0.638451192875438, -94.1025009155273, -1.64239847533693, 218, 29, 'PPL', 'P'),
(63977, 'Cove', 35.6758308410645, 0.622660711561113, -82.9402770996094, -1.44758091790464, 218, 33, 'PPL', 'P'),
(93504, 'Cove', 30.0699996948242, 0.524820500748373, -93.7399978637695, -1.63607160353523, 218, 51, 'PPL', 'P'),
(134838, 'Cove', 46.1086082458496, 0.804747027402283, -93.6183319091797, -1.63394813204005, 218, 28, 'PPL', 'P'),
(160472, 'Cove', 40.3547210693359, 0.704322751383839, -76.9780578613281, -1.34352056147088, 218, 45, 'PPL', 'P'),
(177630, 'Cove', 36.5652809143066, 0.638184543871293, -109.217216491699, -1.9062000276436, 218, 5, 'PPL', 'P'),
(200635, 'Cove', 45.2966690063477, 0.790576014346835, -117.806938171387, -2.05611895278409, 218, 43, 'PPL', 'P'),
(203609, 'Cove', 41.9636116027832, 0.732403188496662, -111.805282592773, -1.9513703023666, 218, 52, 'PPL', 'P'),
(207119, 'Cove', 47.452220916748, 0.828197492380976, -122.50666809082, -2.13814471383269, 218, 56, 'PPL', 'P'),
(75547, 'Cove Acres', 34.8313903808594, 0.607922445193478, -98.336669921875, -1.71629866558359, 218, 42, 'PPL', 'P'),
(63978, 'Cove City', 35.1872215270996, 0.614132870276515, -77.3211135864258, -1.34950801339165, 218, 33, 'PPL', 'P'),
(101121, 'Cove Colony', 37.6888885498047, 0.657795196611283, -76.4936065673828, -1.33506529132599, 218, 53, 'PPL', 'P'),
(154866, 'Cove Cottage Area', 40.5463905334473, 0.707668014608115, -81.248893737793, -1.41806070932749, 218, 41, 'PPL', 'P'),
(63979, 'Cove Creek', 35.6063919067383, 0.621448773528045, -83.0113906860352, -1.44882208413067, 218, 33, 'PPL', 'P'),
(86055, 'Cove Creek', 36.1408309936523, 0.630776495246047, -82.120002746582, -1.43326442967464, 218, 50, 'PPL', 'P'),
(101122, 'Cove Creek', 37.1780586242676, 0.648879532492943, -81.2936096191406, -1.41884114868494, 218, 53, 'PPL', 'P'),
(8260, 'Cove Creek (historical)', 34.4477806091309, 0.601227191633991, -92.8947219848633, -1.62131875636063, 218, 4, 'PPL', 'P'),
(86056, 'Cove Creek Cascades', 35.7627792358398, 0.624178247329267, -83.6205596923828, -1.45945408899254, 218, 50, 'PPL', 'P'),
(78084, 'Cove Gap', 39.8658294677734, 0.695789983251225, -77.9427795410156, -1.3603581311468, 218, 45, 'PPL', 'P'),
(108710, 'Cove Gap', 38.0955581665039, 0.664892920390507, -82.2544403076172, -1.43561080775306, 218, 58, 'PPL', 'P'),
(86057, 'Cove Lake Estates', 36.3005599975586, 0.633564292275142, -84.2102813720703, -1.46974667397348, 218, 50, 'PPL', 'P'),
(148073, 'Cove Neck', 40.8822212219238, 0.71352936585127, -73.5063934326172, -1.28292858666551, 218, 40, 'PPL', 'P'),
(46049, 'Cove of Calvert', 38.3758316040039, 0.669784614680765, -76.3930587768555, -1.33331040132568, 218, 25, 'PPL', 'P'),
(203610, 'Cove on Mount Olympus Place', 40.663890838623, 0.70971878180553, -111.80249786377, -1.95132169967671, 218, 52, 'PPL', 'P'),
(200636, 'Cove Orchard', 45.3752784729004, 0.791948008361416, -123.153610229492, -2.14943598422241, 218, 43, 'PPL', 'P'),
(46045, 'Cove Point', 38.3811111450195, 0.669876760054482, -76.3891677856445, -1.33324249071788, 218, 25, 'PPL', 'P'),
(86058, 'Cove Point', 35.7625007629395, 0.624173387060278, -84.6944427490234, -1.4781968841123, 218, 50, 'PPL', 'P'),
(46046, 'Cove Point Woods', 38.3791694641113, 0.66984287132961, -76.4044418334961, -1.333509073143, 218, 25, 'PPL', 'P'),
(108711, 'Cove Run', 39.2452812194824, 0.684959373151064, -79.9333267211914, -1.39509973335715, 218, 58, 'PPL', 'P'),
(108712, 'Cove Run Station (historical)', 39.2472190856934, 0.684993195296908, -79.9369430541992, -1.39516285027499, 218, 58, 'PPL', 'P'),
(15651, 'Cove Springs', 28.1208305358887, 0.490801081246619, -82.7680587768555, -1.44457514114032, 218, 12, 'PPL', 'P'),
(93505, 'Cove Springs', 32.0097198486328, 0.558675003999624, -95.345832824707, -1.66409871084722, 218, 51, 'PPL', 'P'),
(80527, 'Cove Subdivision', 34.9869384765625, 0.610637271608705, -82.1900024414063, -1.43448615482472, 218, 48, 'PPL', 'P'),
(46048, 'Cove View', 38.7755584716797, 0.676761164630391, -76.2044372558594, -1.33001833474418, 218, 25, 'PPL', 'P'),
(35399, 'Covedale', 38.6594390869141, 0.674734499040841, -83.521110534668, -1.45771837375208, 218, 21, 'PPL', 'P'),
(72225, 'Covedale', 39.1211090087891, 0.682792159234984, -84.6063919067383, -1.47666010700527, 218, 41, 'PPL', 'P'),
(160474, 'Covedale', 40.4824981689453, 0.706552882480671, -78.1730575561523, -1.36437724070589, 218, 45, 'PPL', 'P'),
(101123, 'Covehaven Court', 37.3097190856934, 0.651177441039517, -79.9974975585938, -1.39621972575359, 218, 53, 'PPL', 'P'),
(108713, 'Covel', 37.4908294677734, 0.65433841351636, -81.3227767944336, -1.41935021192731, 218, 58, 'PPL', 'P'),
(148074, 'Covel Corner', 42.749439239502, 0.74611846811057, -77.3636093139648, -1.35024970375524, 218, 40, 'PPL', 'P'),
(207120, 'Coveland', 48.2330589294434, 0.841825686627238, -122.734443664551, -2.14212014754991, 218, 56, 'PPL', 'P'),
(119245, 'Covell', 40.4427795410156, 0.705859661648924, -89.1083297729492, -1.55523374549086, 218, 18, 'PPL', 'P'),
(207123, 'Covello', 46.3833312988281, 0.809541849207889, -117.831939697266, -2.0565553117287, 218, 56, 'PPL', 'P'),
(180918, 'Covelo', 39.7930603027344, 0.694519921727366, -123.246940612793, -2.15106490670316, 218, 6, 'PPL', 'P'),
(20311, 'Covena', 32.496940612793, 0.567178610518301, -82.442497253418, -1.43889302063853, 218, 13, 'PPL', 'P'),
(209945, 'Covenant Life', 59.4172210693359, 1.03702614004526, -136.024993896484, -2.37408400849884, 218, 1, 'PPL', 'P'),
(13605, 'Coventry', 39.6722183227539, 0.692410831302078, -75.6361083984375, -1.32009912494807, 218, 10, 'PPL', 'P'),
(20312, 'Coventry', 33.7855606079102, 0.589669272240129, -83.396110534668, -1.45553671218708, 218, 13, 'PPL', 'P'),
(80528, 'Coventry', 33.5588912963867, 0.585713146440817, -81.9541702270508, -1.43037010620194, 218, 48, 'PPL', 'P'),
(112382, 'Coventry', 39.4033317565918, 0.687717875408168, -76.5550003051758, -1.33613681419058, 218, 25, 'PPL', 'P'),
(113025, 'Coventry', 41.7700004577637, 0.729024036547515, -72.3055572509766, -1.2619700415188, 218, 8, 'PPL', 'P'),
(148075, 'Coventry', 42.3158302307129, 0.738550563240892, -75.6388931274414, -1.32014772763796, 218, 40, 'PPL', 'P'),
(169333, 'Coventry', 41.7000007629395, 0.727802311397441, -71.6833267211914, -1.25111007006762, 218, 47, 'PPL', 'P'),
(171884, 'Coventry', 44.8655586242676, 0.783051718740007, -72.2652816772461, -1.26126710014907, 218, 55, 'PPL', 'P'),
(186586, 'Coventry', 38.1599998474121, 0.666017639897875, -108.374168395996, -1.89148606262091, 218, 7, 'PPL', 'P'),
(160475, 'Coventry Close', 40.2700004577637, 0.7028440977676, -76.9266662597656, -1.34262360881574, 218, 45, 'PPL', 'P'),
(20313, 'Coventry Downs', 34.0491714477539, 0.59427014933935, -84.4216690063477, -1.47343608418962, 218, 13, 'PPL', 'P'),
(20314, 'Coventry Estates', 33.417781829834, 0.583250321643738, -84.4875030517578, -1.47458510504193, 218, 13, 'PPL', 'P'),
(80529, 'Coventry Estates', 34.9713897705078, 0.610365895493626, -81.0502777099609, -1.41459420569459, 218, 48, 'PPL', 'P'),
(46051, 'Coventry Farms', 39.2286109924316, 0.684668422801972, -76.0886077880859, -1.3279967291607, 218, 25, 'PPL', 'P'),
(20315, 'Coventry Green', 34.0341682434082, 0.594008294025168, -84.4124984741211, -1.4732760282081, 218, 13, 'PPL', 'P'),
(113032, 'Coventry Lake', 41.7722206115723, 0.729062785541375, -72.3330612182617, -1.26245007630529, 218, 8, 'PPL', 'P'),
(203612, 'Coventry Manor Condominium', 40.6952781677246, 0.71026659404176, -111.965560913086, -1.95416768677562, 218, 52, 'PPL', 'P'),
(46052, 'Coventry Meadows', 39.6561088562012, 0.692129668069993, -76.4752807617188, -1.33474544567907, 218, 25, 'PPL', 'P'),
(80530, 'Coventry Place', 32.9552803039551, 0.575178147221654, -80.164436340332, -1.39913335714419, 218, 48, 'PPL', 'P'),
(145048, 'Coventry Square', 40.107780456543, 0.700012824633709, -74.2077789306641, -1.29517007293216, 218, 37, 'PPL', 'P'),
(80531, 'Coventry Woods', 33.9911117553711, 0.593256816544575, -81.2249984741211, -1.41764365830078, 218, 48, 'PPL', 'P'),
(148077, 'Coventryville', 42.3133316040039, 0.738506953978042, -75.5986099243164, -1.31944465311018, 218, 40, 'PPL', 'P'),
(160476, 'Coventryville', 40.1733283996582, 0.70115685205898, -75.6897201538086, -1.32103482659707, 218, 45, 'PPL', 'P'),
(46053, 'Cover (historical)', 39.4438896179199, 0.688425743625911, -77.1272201538086, -1.34612393459449, 218, 25, 'PPL', 'P'),
(160477, 'Cover Hill', 40.3255615234375, 0.703813821299525, -78.8891677856445, -1.37687572201774, 218, 45, 'PPL', 'P'),
(20316, 'Coverdale', 31.628059387207, 0.552013772323063, -83.7191696166992, -1.461175156847, 218, 13, 'PPL', 'P'),
(112368, 'Coverdale', 30.4841709136963, 0.532049152184688, -92.7744369506836, -1.61921938647332, 218, 22, 'PPL', 'P'),
(160479, 'Coverdale', 40.8788909912109, 0.713471242360479, -80.3641662597656, -1.40261930185305, 218, 45, 'PPL', 'P'),
(112254, 'Coverdale Crossroads', 38.7102813720703, 0.675621864316055, -75.5313873291016, -1.31827139749195, 218, 10, 'PPL', 'P'),
(20318, 'Covered Bridge', 33.0863914489746, 0.577466468388304, -85.1524963378906, -1.48619142738861, 218, 13, 'PPL', 'P'),
(46055, 'Covered Bridge Estates', 38.3369407653809, 0.669105841497931, -75.6208267211914, -1.3198324093649, 218, 25, 'PPL', 'P'),
(13606, 'Covered Bridge Farms', 39.7000007629395, 0.692895726357554, -75.783332824707, -1.32266867592583, 218, 10, 'PPL', 'P'),
(178035, 'Covered Wagon Mobile Home Park', 33.5319404602051, 0.585242765613281, -112.112503051758, -1.95673231090536, 218, 5, 'PPL', 'P'),
(196292, 'Covered Wagon Mobile Home Park', 45.6916694641113, 0.797470072881696, -111.055557250977, -1.9382851266666, 218, 31, 'PPL', 'P'),
(101124, 'Coverly', 37.4066696166992, 0.652869547017127, -77.8836135864258, -1.35932549043412, 218, 53, 'PPL', 'P'),
(46056, 'Covers Corner', 39.4622192382813, 0.688745655851857, -77.1155624389648, -1.34592046908721, 218, 25, 'PPL', 'P'),
(101125, 'Coverstone', 38.7936096191406, 0.677076216587347, -77.5236129760742, -1.3530422944743, 218, 53, 'PPL', 'P'),
(32166, 'Covert', 39.2802810668945, 0.685570235726101, -98.8105621337891, -1.72456964498105, 218, 20, 'PPL', 'P'),
(130359, 'Covert', 42.2936096191406, 0.738162740407149, -86.2622222900391, -1.50555979904842, 218, 27, 'PPL', 'P'),
(148078, 'Covert', 42.5752792358398, 0.743078802621381, -76.6838912963867, -1.33838638636337, 218, 40, 'PPL', 'P'),
(160480, 'Covert', 41.7488899230957, 0.728655588210702, -76.8533325195313, -1.34134369359585, 218, 45, 'PPL', 'P'),
(199252, 'Covert', 41.8969383239746, 0.731239520258352, -103.714996337891, -1.81016816979005, 218, 35, 'PPL', 'P'),
(160481, 'Coverts', 40.9944381713867, 0.715487921095942, -80.416389465332, -1.40353076873613, 218, 45, 'PPL', 'P'),
(101126, 'Covesville', 37.8899993896484, 0.661305242928007, -78.7050018310547, -1.37366141974007, 218, 53, 'PPL', 'P'),
(148080, 'Coveville', 43.0602798461914, 0.751543660146198, -73.595832824707, -1.28448959853846, 218, 40, 'PPL', 'P'),
(160482, 'Coveville', 41.2122192382813, 0.719288917761757, -75.2683334350586, -1.31368024093071, 218, 45, 'PPL', 'P'),
(8264, 'Covey (historical)', 36.2533302307129, 0.632739977338735, -92.1647186279297, -1.60857779423152, 218, 4, 'PPL', 'P'),
(13607, 'Covey Creek', 38.7563896179199, 0.67642660501845, -75.158332824707, -1.31176036810087, 218, 10, 'PPL', 'P'),
(160488, 'Coveytown', 41.5466690063477, 0.725126167397047, -76.4541702270508, -1.33437699734226, 218, 45, 'PPL', 'P'),
(29563, 'Coveyville', 38.973331451416, 0.68021295429827, -86.4725036621094, -1.50922990134666, 218, 19, 'PPL', 'P'),
(134839, 'Covill', 47.795280456543, 0.834185010880773, -90.1605606079102, -1.57359863805193, 218, 28, 'PPL', 'P'),
(46057, 'Covilla', 39.5561103820801, 0.69038436544961, -76.9850006103516, -1.34364173530048, 218, 25, 'PPL', 'P'),
(207122, 'Coville', 48.1269416809082, 0.839973591247142, -123.628059387207, -2.15771668415785, 218, 56, 'PPL', 'P'),
(1845, 'Covin', 33.689998626709, 0.58800140102844, -87.8891677856445, -1.53395535469723, 218, 2, 'PPL', 'P'),
(180919, 'Covina', 34.0900001525879, 0.594982744668028, -117.889442443848, -2.05755892398549, 218, 6, 'PPL', 'P'),
(101127, 'Covingston Corner', 37.8597183227539, 0.660776738609681, -77.3786087036133, -1.35051149249039, 218, 53, 'PPL', 'P'),
(15652, 'Covington', 30.2683296203613, 0.52828201095423, -83.8308334350586, -1.46312405813272, 218, 12, 'PPL', 'P'),
(20319, 'Covington', 33.5966682434082, 0.586372478547693, -83.8602828979492, -1.46363804822311, 218, 13, 'PPL', 'P'),
(26872, 'Covington', 38.3980598449707, 0.670172570672562, -88.4922180175781, -1.54448056679939, 218, 18, 'PPL', 'P'),
(35400, 'Covington', 39.083610534668, 0.682137687397097, -84.5086135864258, -1.47495355337874, 218, 21, 'PPL', 'P'),
(39929, 'Covington', 30.4834079742432, 0.532035836379238, -90.1110992431641, -1.57273537438458, 218, 22, 'PPL', 'P'),
(54236, 'Covington', 36.1072196960449, 0.63018986743693, -89.8777770996094, -1.56866313476174, 218, 29, 'PPL', 'P'),
(63984, 'Covington', 35.1361083984375, 0.613240777890366, -79.8477783203125, -1.393606632092, 218, 33, 'PPL', 'P'),
(75548, 'Covington', 36.3074989318848, 0.633685399525714, -97.5861129760742, -1.70319897565566, 218, 42, 'PPL', 'P'),
(86059, 'Covington', 35.5641708374023, 0.62071187685442, -89.6463928222656, -1.56462471728475, 218, 50, 'PPL', 'P'),
(93506, 'Covington', 32.1783294677734, 0.561617797004161, -97.2577819824219, -1.69746851878008, 218, 51, 'PPL', 'P'),
(101129, 'Covington', 37.6688919067383, 0.657446189350428, -77.817497253418, -1.35817154273379, 218, 53, 'PPL', 'P'),
(115137, 'Covington', 42.0072212219238, 0.733164319936206, -91.7622222900391, -1.60155290790811, 218, 16, 'PPL', 'P'),
(122439, 'Covington', 40.1416702270508, 0.700604312711816, -87.3947219848633, -1.52532564750094, 218, 19, 'PPL', 'P'),
(130361, 'Covington', 46.541389465332, 0.812300484623047, -88.5369415283203, -1.54526113931489, 218, 27, 'PPL', 'P'),
(148081, 'Covington', 42.853328704834, 0.74793168133875, -78.0105590820313, -1.36154110730301, 218, 40, 'PPL', 'P'),
(154869, 'Covington', 40.1172218322754, 0.700177607726158, -84.353889465332, -1.4722531080334, 218, 41, 'PPL', 'P'),
(160483, 'Covington', 41.7447204589844, 0.728582817333916, -77.0774993896484, -1.34525614355329, 218, 45, 'PPL', 'P'),
(207124, 'Covington', 47.348331451416, 0.826384279152795, -122.113609313965, -2.1312845440227, 218, 56, 'PPL', 'P'),
(141564, 'Covington (historical)', 42.4861106872559, 0.741522517859366, -96.4111099243164, -1.6826913036815, 218, 35, 'PPL', 'P'),
(122440, 'Covington Dells', 41.0694389343262, 0.716796931350743, -85.2330627441406, -1.48759757644417, 218, 19, 'PPL', 'P'),
(101131, 'Covingtons Corner', 38.5999984741211, 0.6736970646382, -77.8005599975586, -1.35787593185279, 218, 53, 'PPL', 'P'),
(160487, 'Covode', 40.8808288574219, 0.713505064506323, -79.0158309936523, -1.37908641203862, 218, 45, 'PPL', 'P'),
(15654, 'Cow Creek', 28.8372192382813, 0.503304422827459, -81.0277786254883, -1.41420152259186, 218, 12, 'PPL', 'P'),
(180920, 'Cow Creek', 38.2405586242676, 0.667423655795382, -119.991111755371, -2.0942399732597, 218, 6, 'PPL', 'P'),
(194788, 'Cow Creek', 46.4958305358887, 0.811505331300577, -115.931938171387, -2.02339402930919, 218, 17, 'PPL', 'P'),
(200637, 'Cow Creek', 42.8566703796387, 0.747990004566623, -123.596389770508, -2.1571639450736, 218, 43, 'PPL', 'P'),
(59133, 'Cow Creek (historical)', 32.829719543457, 0.572986698539655, -88.8372192382813, -1.55050197402406, 218, 30, 'PPL', 'P'),
(80534, 'Cow Head Landing', 33.5752792358398, 0.585999169941891, -79.4091720581055, -1.38595150869662, 218, 48, 'PPL', 'P'),
(209386, 'Cow Hollow', 42.8536109924316, 0.747936608186767, -106.106391906738, -1.85190589618405, 218, 59, 'PPL', 'P'),
(93507, 'Cow Island', 30.0111103057861, 0.52379268701517, -94.6624984741211, -1.65217227653752, 218, 51, 'PPL', 'P'),
(196293, 'Cow Island (historical)', 47.7872200012207, 0.83404432939619, -108.933326721191, -1.90124521643551, 218, 31, 'PPL', 'P'),
(8265, 'Cow Lake (historical)', 35.4577789306641, 0.618854987784362, -91.0569381713867, -1.5892433778756, 218, 4, 'PPL', 'P'),
(8267, 'Cow Mound (historical)', 35.0586090087891, 0.611888158372715, -91.3375015258789, -1.59414013217193, 218, 4, 'PPL', 'P'),
(72226, 'Cow Run', 39.4477806091309, 0.688493654233708, -81.3091735839844, -1.41911279111613, 218, 41, 'PPL', 'P'),
(178036, 'Cow Springs', 36.4130592346191, 0.63552777436783, -110.821670532227, -1.93420303334773, 218, 5, 'PPL', 'P'),
(80536, 'Cow Tail (historical)', 33.1519393920898, 0.578610495813575, -80.6083297729492, -1.40688075907134, 218, 48, 'PPL', 'P'),
(32169, 'Cow Town', 37.6938896179199, 0.65788248171601, -97.3572235107422, -1.69920410086248, 218, 20, 'PPL', 'P'),
(124588, 'Cow Yard', 41.5319404602051, 0.724869105772828, -70.966667175293, -1.23860200137585, 218, 23, 'PPL', 'P'),
(8268, 'Cowan', 36.1752815246582, 0.63137777044116, -92.646110534668, -1.61697966799656, 218, 4, 'PPL', 'P'),
(35401, 'Cowan', 38.4072189331055, 0.670332426916994, -83.8919372558594, -1.46419052099124, 218, 21, 'PPL', 'P'),
(54238, 'Cowan', 37.0780601501465, 0.647134229872559, -93.1727828979492, -1.62617183481508, 218, 29, 'PPL', 'P'),
(86060, 'Cowan', 35.1644401550293, 0.613735260325767, -86.0105590820313, -1.50116744746256, 218, 50, 'PPL', 'P'),
(101133, 'Cowan', 37.1852798461914, 0.649005566591531, -80.5772171020508, -1.40633774052507, 218, 53, 'PPL', 'P'),
(122441, 'Cowan', 40.1058311462402, 0.699978802750784, -85.3886108398438, -1.49031240285939, 218, 19, 'PPL', 'P'),
(160489, 'Cowan', 40.9575004577637, 0.714843236375061, -77.0138931274414, -1.34414600485289, 218, 45, 'PPL', 'P'),
(196294, 'Cowan', 45.7236099243164, 0.798027539076877, -111.184440612793, -1.94053456568134, 218, 31, 'PPL', 'P'),
(148083, 'Cowan Corner', 44.0547218322754, 0.768899947023435, -75.5502777099609, -1.3186010968349, 218, 40, 'PPL', 'P'),
(180921, 'Cowan Heights', 33.7777786254883, 0.589533451024535, -117.773063659668, -2.05552773102209, 218, 6, 'PPL', 'P'),
(101134, 'Cowan Mill', 36.6286087036133, 0.639289822302704, -83.4669418334961, -1.4567729515651, 218, 53, 'PPL', 'P'),
(20320, 'Cowan Mill Estates', 33.7161102294922, 0.58845713446998, -84.7827835083008, -1.4797387212254, 218, 13, 'PPL', 'P'),
(86061, 'Cowan Springs', 35.7502784729004, 0.623960067856962, -83.8091735839844, -1.46274602241598, 218, 50, 'PPL', 'P'),
(160490, 'Cowanesque', 41.9330596923828, 0.731869957067401, -77.4974975585938, -1.35258649445373, 218, 45, 'PPL', 'P'),
(154870, 'Cowans (historical)', 41.3791694641113, 0.72220274888944, -81.4891662597656, -1.42225425593798, 218, 41, 'PPL', 'P'),
(63985, 'Cowans Ferry', 35.7486114501953, 0.623930972822053, -80.3661117553711, -1.40265325715695, 218, 33, 'PPL', 'P'),
(63986, 'Cowans Ford', 35.4266700744629, 0.618312035817122, -80.9569396972656, -1.41296515005579, 218, 33, 'PPL', 'P'),
(160491, 'Cowans Village', 40.0016708374023, 0.698160862411668, -77.9141693115234, -1.35985878844241, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(160492, 'Cowansburg', 40.2544403076172, 0.702572521915439, -79.7538909912109, -1.39196798907327, 218, 45, 'PPL', 'P'),
(86062, 'Cowanstown (historical)', 36.3088912963867, 0.633709700870661, -81.9361114501953, -1.43005492108693, 218, 50, 'PPL', 'P'),
(160493, 'Cowansville', 40.8877792358398, 0.713626371493976, -79.5886077880859, -1.3890832529805, 218, 45, 'PPL', 'P'),
(59134, 'Cowanville', 31.7549991607666, 0.554229289323413, -90.1597213745117, -1.57358399066594, 218, 30, 'PPL', 'P'),
(80535, 'Coward', 33.9730606079102, 0.592941764587619, -79.7472229003906, -1.39185160893364, 218, 48, 'PPL', 'P'),
(101135, 'Cowardin (historical)', 38.045280456543, 0.664015408811326, -79.8652801513672, -1.39391209666903, 218, 53, 'PPL', 'P'),
(59135, 'Cowart', 33.9850006103516, 0.593150156942917, -90.1777801513672, -1.57389917578095, 218, 30, 'PPL', 'P'),
(101136, 'Cowart', 37.9952812194824, 0.663142757501134, -76.4722213745117, -1.33469204929921, 218, 53, 'PPL', 'P'),
(1847, 'Cowarts', 31.2000007629395, 0.544542739938036, -85.3047180175781, -1.48884819689207, 218, 2, 'PPL', 'P'),
(63987, 'Cowarts', 35.2969398498535, 0.616047816258337, -83.1122207641602, -1.45058190097899, 218, 33, 'PPL', 'P'),
(143673, 'Cowbell Corners', 42.8491706848145, 0.747859110199046, -71.2158279418945, -1.24295067711984, 218, 36, 'PPL', 'P'),
(196295, 'Cowboys Heaven', 45.4730606079102, 0.793654628566966, -111.586669921875, -1.94755479147284, 218, 31, 'PPL', 'P'),
(35402, 'Cowcreek', 37.4386100769043, 0.653427013212307, -83.6105575561523, -1.45927951878308, 218, 21, 'PPL', 'P'),
(26874, 'Cowden', 39.2483291625977, 0.685012569793838, -88.8622207641602, -1.55093833296867, 218, 18, 'PPL', 'P'),
(75549, 'Cowden', 35.2477798461914, 0.615189812334141, -98.711669921875, -1.72284365027857, 218, 42, 'PPL', 'P'),
(80537, 'Cowden', 33.2866706848145, 0.580962000477088, -81.79638671875, -1.42761626447675, 218, 48, 'PPL', 'P'),
(86063, 'Cowden', 35.514720916748, 0.619848812924152, -86.7716674804688, -1.51445129497987, 218, 50, 'PPL', 'P'),
(160495, 'Cowden', 40.3177795410156, 0.703678000083931, -80.1972198486328, -1.39970553730439, 218, 45, 'PPL', 'P'),
(75550, 'Cowden Junction', 35.290828704834, 0.615941156656679, -98.7111129760742, -1.72283392974059, 218, 42, 'PPL', 'P'),
(191331, 'Cowden Place', 31.725830078125, 0.553720192791531, -102.803329467773, -1.79425658122516, 218, 51, 'PPL', 'P'),
(148084, 'Cowdens Corner', 42.4091682434082, 0.740179618879693, -79.2761077880859, -1.38362909906802, 218, 40, 'PPL', 'P'),
(46058, 'Cowdensville', 39.246940612793, 0.684988335027918, -76.7024993896484, -1.33871115885831, 218, 25, 'PPL', 'P'),
(194147, 'Cowdrey', 40.8597183227539, 0.713136616169511, -106.3125, -1.85550316102647, 218, 7, 'PPL', 'P'),
(63988, 'Cowee', 35.2611083984375, 0.615422439455359, -83.4080581665039, -1.45574523770044, 218, 33, 'PPL', 'P'),
(8269, 'Cowell', 35.8205604553223, 0.625186719855053, -93.1641693115234, -1.62602149937154, 218, 4, 'PPL', 'P'),
(46059, 'Cowell', 39.4527816772461, 0.688580939338435, -77.5611114501953, -1.35369676631218, 218, 25, 'PPL', 'P'),
(180922, 'Cowell', 37.9527816772461, 0.66240100055852, -121.988327026367, -2.12909795560969, 218, 6, 'PPL', 'P'),
(108714, 'Cowen', 38.4094390869141, 0.670371175910855, -80.5580596923828, -1.40600338065021, 218, 58, 'PPL', 'P'),
(124589, 'Cowen Corner', 41.7688903808594, 0.729004662050584, -70.8433303833008, -1.23644936826674, 218, 23, 'PPL', 'P'),
(46060, 'Cowentown', 39.6805610656738, 0.692556439634678, -75.815559387207, -1.32323113554806, 218, 25, 'PPL', 'P'),
(169335, 'Cowesett', 41.6811103820801, 0.727472612054489, -71.461669921875, -1.24724142911012, 218, 47, 'PPL', 'P'),
(75551, 'Coweta', 35.9516716003418, 0.627475041021703, -95.6505584716797, -1.66941717670217, 218, 42, 'PPL', 'P'),
(657, 'Cowgill', 39.5591697692871, 0.690437761829466, -93.9266662597656, -1.63932958165478, 218, 29, 'PPL', 'P'),
(13609, 'Cowgills Corner', 39.1958312988281, 0.684096309220796, -75.4805603027344, -1.31738429853284, 218, 10, 'PPL', 'P'),
(207125, 'Cowiche', 46.6699981689453, 0.81454512994782, -120.711112976074, -2.10680636517935, 218, 56, 'PPL', 'P'),
(101137, 'Cowie Corner', 36.774169921875, 0.641830344824585, -77.5719375610352, -1.35388571759152, 218, 53, 'PPL', 'P'),
(63990, 'Cowin (historical)', 35.7511100769043, 0.623974582084903, -80.8944396972656, -1.41187431927329, 218, 33, 'PPL', 'P'),
(141567, 'Cowles', 40.1716690063477, 0.701127890182126, -98.4452819824219, -1.71819430364751, 218, 35, 'PPL', 'P'),
(188370, 'Cowles', 35.811939239502, 0.625036251253463, -105.659172058105, -1.84410043734513, 218, 38, 'PPL', 'P'),
(148085, 'Cowles Settlement', 42.7880592346191, 0.746792514182469, -75.9261093139648, -1.32516059575782, 218, 40, 'PPL', 'P'),
(72227, 'Cowlesville', 39.9813919067383, 0.697806928302797, -84.1866683959961, -1.46933454979479, 218, 41, 'PPL', 'P'),
(148086, 'Cowlesville', 42.8433303833008, 0.747757177708323, -78.4691696166992, -1.3695453711173, 218, 40, 'PPL', 'P'),
(93508, 'Cowley', 33.0097198486328, 0.576128296519567, -96.7736129760742, -1.6890181754832, 218, 51, 'PPL', 'P'),
(207126, 'Cowley', 47.4986114501953, 0.829007159931387, -122.463607788086, -2.13739316977307, 218, 56, 'PPL', 'P'),
(209387, 'Cowley', 44.8833312988281, 0.783361910427974, -108.468887329102, -1.89313921986758, 218, 59, 'PPL', 'P'),
(177629, 'Cowlic', 31.8083305358887, 0.55516009741391, -111.988327026367, -1.95456503041026, 218, 5, 'PPL', 'P'),
(26875, 'Cowling', 38.3113899230957, 0.668659895173397, -87.9391708374023, -1.53482807258645, 218, 18, 'PPL', 'P'),
(8270, 'Cowlingsville', 33.848331451416, 0.590764830133561, -94.0677795410156, -1.64179247303088, 218, 4, 'PPL', 'P'),
(75553, 'Cowlington', 35.2752799987793, 0.6156697805416, -94.7283325195313, -1.65332129738984, 218, 42, 'PPL', 'P'),
(207127, 'Cowlitz', 46.4588890075684, 0.810860580000669, -122.84139251709, -2.14398675715794, 218, 56, 'PPL', 'P'),
(46061, 'Cowpen', 39.4049987792969, 0.687746970443077, -76.5597229003906, -1.33621923902632, 218, 25, 'PPL', 'P'),
(59136, 'Cowpen (historical)', 33.0416717529297, 0.576685962451829, -89.4797210693359, -1.56171574642605, 218, 30, 'PPL', 'P'),
(224, 'Cowpens', 33.0352783203125, 0.576574376002155, -85.8227767944336, -1.49789002826705, 218, 2, 'PPL', 'P'),
(80538, 'Cowpens', 35.0166702270508, 0.611156188547107, -81.8041687011719, -1.42775208569234, 218, 48, 'PPL', 'P'),
(8271, 'Cowpens (historical)', 34.3611106872559, 0.599714516134826, -91.0175018310547, -1.58855508389187, 218, 4, 'PPL', 'P'),
(13070, 'Cowtown (historical)', 38.9249992370605, 0.679369398022987, -77.0263900756836, -1.34436411774616, 218, 9, 'PPL', 'P'),
(1850, 'Cox', 30.6424999237061, 0.534812514710782, -88.0833282470703, -1.5373440940263, 218, 2, 'PPL', 'P'),
(15655, 'Cox', 30.601390838623, 0.534095025823601, -85.1391677856445, -1.48595880026739, 218, 12, 'PPL', 'P'),
(20324, 'Cox', 31.2175006866455, 0.544848171225555, -81.5069427490234, -1.42256451420498, 218, 13, 'PPL', 'P'),
(46062, 'Cox', 38.5966682434082, 0.673638941147409, -76.6358337402344, -1.33754762377805, 218, 25, 'PPL', 'P'),
(54239, 'Cox', 39.6372184753418, 0.691799968727041, -92.3827819824219, -1.61238371774536, 218, 29, 'PPL', 'P'),
(93509, 'Cox', 32.8643417358398, 0.573590969790994, -94.8377532958984, -1.65523105020753, 218, 51, 'PPL', 'P'),
(180923, 'Cox', 33.8388900756836, 0.590600047041112, -114.771942138672, -2.00314827922825, 218, 6, 'PPL', 'P'),
(194789, 'Cox', 43.3736114501953, 0.757012328286621, -112.052780151367, -1.95568994965471, 218, 17, 'PPL', 'P'),
(20323, 'Cox (historical)', 32.1030616760254, 0.560304126217452, -83.0213928222656, -1.44899665434012, 218, 13, 'PPL', 'P'),
(72228, 'Cox (historical)', 39.2994384765625, 0.68590459560096, -82.7408294677734, -1.44409990004379, 218, 41, 'PPL', 'P'),
(1849, 'Cox Beach', 30.8519401550293, 0.538467936333511, -88.0400009155273, -1.53658788943477, 218, 2, 'PPL', 'P'),
(75555, 'Cox City', 34.7252807617188, 0.606070482971437, -97.7313919067383, -1.70573457132952, 218, 42, 'PPL', 'P'),
(15656, 'Cox Corner', 27.8788890838623, 0.486578406311703, -81.7611083984375, -1.42700054163272, 218, 12, 'PPL', 'P'),
(101139, 'Cox Corner', 38.2986106872559, 0.668436855432103, -77.3597183227539, -1.35018179314744, 218, 53, 'PPL', 'P'),
(124590, 'Cox Corner', 42.0588912963867, 0.734066132860335, -70.6916732788086, -1.23380245245931, 218, 23, 'PPL', 'P'),
(46063, 'Cox Creek Acres', 38.9311103820801, 0.679476057624645, -76.3102798461914, -1.33186563643431, 218, 25, 'PPL', 'P'),
(39932, 'Cox Crossing', 32.2911109924316, 0.563586205944866, -92.8755569458008, -1.62098426332771, 218, 22, 'PPL', 'P'),
(63991, 'Cox Crossing', 35.5138893127441, 0.619834298696211, -77.3177795410156, -1.34944982332183, 218, 33, 'PPL', 'P'),
(101142, 'Cox Estates', 37.2636108398438, 0.650372700337123, -80.0019378662109, -1.39629722374131, 218, 53, 'PPL', 'P'),
(39931, 'Cox Ferry', 32.7347183227539, 0.571328614444972, -92.3986129760742, -1.61266002070845, 218, 22, 'PPL', 'P'),
(1851, 'Cox Gap', 34.1124992370605, 0.59537542777076, -86.0736083984375, -1.50226786562498, 218, 2, 'PPL', 'P'),
(108715, 'Cox Landing', 38.473331451416, 0.671486308038298, -82.3008270263672, -1.43642040872444, 218, 58, 'PPL', 'P'),
(63992, 'Cox Mill', 35.4083290100098, 0.617991923854095, -80.7283325195313, -1.40897520211063, 218, 33, 'PPL', 'P'),
(101141, 'Cox Mill', 36.6919403076172, 0.640395167313141, -82.5794372558594, -1.44128307455882, 218, 53, 'PPL', 'P'),
(101143, 'Cox Place', 36.8394393920898, 0.642969511980866, -82.6650009155273, -1.44277644214008, 218, 53, 'PPL', 'P'),
(8272, 'Cox Spring', 34.4558296203613, 0.601367673381493, -93.8452835083008, -1.63790918468738, 218, 4, 'PPL', 'P'),
(63993, 'Cox Store', 35.2750015258789, 0.615664920272611, -82.0352783203125, -1.43178570947938, 218, 33, 'PPL', 'P'),
(154871, 'Cox Subdivision', 41.5847206115723, 0.725790293193886, -84.5711135864258, -1.47604438416124, 218, 41, 'PPL', 'P'),
(157, 'Cox Town', 39.0277786254883, 0.681163236754237, -80.4752807617188, -1.40455861575884, 218, 58, 'PPL', 'P'),
(59137, 'Coxburg', 32.9983291625977, 0.575929491544192, -90.2099990844727, -1.57446150224512, 218, 30, 'PPL', 'P'),
(86064, 'Coxburg', 35.899169921875, 0.626558713869634, -88.0361099243164, -1.53651997882698, 218, 50, 'PPL', 'P'),
(46064, 'Coxby Estates', 38.9141693115234, 0.679180380164619, -76.5422210693359, -1.33591377444929, 218, 25, 'PPL', 'P'),
(160496, 'Coxes Village', 40.9352798461914, 0.714455413541318, -75.9266662597656, -1.3251703162958, 218, 45, 'PPL', 'P'),
(1852, 'Coxey', 34.8019409179688, 0.607408455103092, -87.1783294677734, -1.52154888560104, 218, 2, 'PPL', 'P'),
(1856, 'Coxey Creek Subdivision', 34.7616691589355, 0.606705580312393, -87.1744384765625, -1.52148097499325, 218, 2, 'PPL', 'P'),
(1853, 'Coxheath', 32.0877799987793, 0.560037410634281, -87.9102783203125, -1.53432380303404, 218, 2, 'PPL', 'P'),
(46065, 'Coxs Corner', 38.3044395446777, 0.668538588185744, -75.8463897705078, -1.32376922724631, 218, 25, 'PPL', 'P'),
(75556, 'Coxs Corner', 34.6375007629395, 0.604538432975341, -98.2119369506836, -1.71412166455051, 218, 42, 'PPL', 'P'),
(124591, 'Coxs Corner', 42.0805587768555, 0.734444301735126, -70.8874969482422, -1.23722022024426, 218, 23, 'PPL', 'P'),
(145050, 'Coxs Corner', 40.3261108398438, 0.703823408679449, -74.6944427490234, -1.30366395891286, 218, 37, 'PPL', 'P'),
(35404, 'Coxs Creek', 37.898609161377, 0.661455511792515, -85.4736099243164, -1.49179591674462, 218, 21, 'PPL', 'P'),
(20325, 'Coxs Crossing', 33.646110534668, 0.587235409319906, -84.3908309936523, -1.47289785933331, 218, 13, 'PPL', 'P'),
(63994, 'Coxs Crossroads', 35.3697204589844, 0.617318077519277, -76.9524993896484, -1.34307448198829, 218, 33, 'PPL', 'P'),
(1854, 'Coxs Landing', 31.8322200775146, 0.555577048572075, -88.1669387817383, -1.53880337314561, 218, 2, 'PPL', 'P'),
(108716, 'Coxs Mills', 39.0444412231445, 0.681454053945274, -80.8269424438477, -1.41069626996509, 218, 58, 'PPL', 'P'),
(148087, 'Coxsackie', 42.350830078125, 0.739161425815929, -73.8033294677734, -1.2881110981468, 218, 40, 'PPL', 'P'),
(70699, 'Coxstown', 39.648609161377, 0.691998773702416, -74.2966690063477, -1.29672149742519, 218, 37, 'PPL', 'P'),
(29565, 'Coxton', 38.8294410705566, 0.677701593390325, -86.5611114501953, -1.51077639899167, 218, 19, 'PPL', 'P'),
(35403, 'Coxton', 36.8572196960449, 0.643279836826888, -83.2702789306641, -1.45334053639415, 218, 21, 'PPL', 'P'),
(160497, 'Coxtown (historical)', 40.3138885498047, 0.703610089476134, -76.8994369506836, -1.34214836771922, 218, 45, 'PPL', 'P'),
(29566, 'Coxville', 39.6519393920898, 0.692056897193207, -87.2944412231445, -1.52357541803254, 218, 19, 'PPL', 'P'),
(63995, 'Coxville', 35.4091682434082, 0.61800657124009, -77.3302764892578, -1.34966793621511, 218, 33, 'PPL', 'P'),
(86065, 'Coxville', 35.8330612182617, 0.625404899327357, -89.0255584716797, -1.55378911375754, 218, 50, 'PPL', 'P'),
(93510, 'Coxville', 30.4013900756836, 0.530604354003807, -97.6788864135742, -1.70481817759843, 218, 51, 'PPL', 'P'),
(1855, 'Coy', 31.8947200775146, 0.556667879354572, -87.4627838134766, -1.52651355050517, 218, 2, 'PPL', 'P'),
(8273, 'Coy', 34.5386085510254, 0.602812438272861, -91.873893737793, -1.60350194235189, 218, 4, 'PPL', 'P'),
(54240, 'Coy', 36.6611099243164, 0.63985707561489, -94.5319366455078, -1.6498935427508, 218, 29, 'PPL', 'P'),
(59138, 'Coy', 32.9033317565918, 0.574271474028536, -88.9147186279297, -1.55185459354171, 218, 30, 'PPL', 'P'),
(160498, 'Coy', 40.5291709899902, 0.707367476879099, -79.1413879394531, -1.38127779414159, 218, 45, 'PPL', 'P'),
(93511, 'Coy City', 28.8244400024414, 0.503081383086165, -98.0400009155273, -1.71112081463421, 218, 51, 'PPL', 'P'),
(160499, 'Coy Junction', 40.5363883972168, 0.70749344439866, -79.1527786254883, -1.38147659911696, 218, 45, 'PPL', 'P'),
(191332, 'Coyanosa', 31.2427806854248, 0.545289390439154, -103.064170837402, -1.79880912195059, 218, 51, 'PPL', 'P'),
(75557, 'Coyle', 35.9566688537598, 0.627562259547403, -97.2341690063477, -1.69705639460139, 218, 42, 'PPL', 'P'),
(160500, 'Coyle', 40.146110534668, 0.700681810699537, -77.1786117553711, -1.34702088724963, 218, 45, 'PPL', 'P'),
(207129, 'Coyle', 47.6980590820313, 0.832488177792229, -122.804168701172, -2.14333707901002, 218, 56, 'PPL', 'P'),
(160501, 'Coyleville', 40.853328704834, 0.713025096298864, -79.7286071777344, -1.39152670328065, 218, 45, 'PPL', 'P'),
(93512, 'Coymack', 31.1800003051758, 0.544193666098154, -96.8422164916992, -1.6902155327093, 218, 51, 'PPL', 'P'),
(119249, 'Coyne', 42.1836090087891, 0.736242867577311, -88.4519424438477, -1.54377762542966, 218, 18, 'PPL', 'P'),
(119250, 'Coyne Center', 41.4047203063965, 0.722648695213974, -90.5591735839844, -1.5805557469256, 218, 18, 'PPL', 'P'),
(78086, 'Coyne Lock', 39.767219543457, 0.694068915396761, -76.274169921875, -1.33123539936234, 218, 45, 'PPL', 'P'),
(101144, 'Coyner Mountain Overlook', 37.3408317565918, 0.651720459585785, -79.8477783203125, -1.393606632092, 218, 53, 'PPL', 'P'),
(101145, 'Coyner Springs', 37.3344383239746, 0.65160887313611, -79.8591690063477, -1.39380543706737, 218, 53, 'PPL', 'P'),
(119251, 'Coynes', 41.5755615234375, 0.725630436949454, -88.1427764892578, -1.538381661587, 218, 18, 'PPL', 'P'),
(180924, 'Coyote', 37.2166709899902, 0.649553445406787, -121.739440917969, -2.12475407355566, 218, 6, 'PPL', 'P'),
(188373, 'Coyote', 36.1674995422363, 0.631241949225566, -106.615829467773, -1.86079725895744, 218, 38, 'PPL', 'P'),
(188372, 'Coyote (historical)', 35.3566703796387, 0.617090310667048, -106.336669921875, -1.85592500574314, 218, 38, 'PPL', 'P'),
(190080, 'Coyote (historical)', 38.0333290100098, 0.663806816718946, -114.863891601563, -2.00475310010113, 218, 39, 'PPL', 'P'),
(93513, 'Coyote Acres', 27.7127799987793, 0.483679255859529, -98.1333312988281, -1.71274973711495, 218, 51, 'PPL', 'P'),
(93514, 'Coyote Acres Colonia', 27.7310009002686, 0.483997270583198, -98.1279983520508, -1.71265665963486, 218, 51, 'PPL', 'P'),
(178037, 'Coyote Basin Ranch', 34.8424987792969, 0.608116323320836, -111.430282592773, -1.94482531767162, 218, 5, 'PPL', 'P'),
(188374, 'Coyote Canyon', 35.7747192382813, 0.624386639684566, -108.620277404785, -1.8957814751431, 218, 38, 'PPL', 'P'),
(191333, 'Coyote Corner', 32.1069412231445, 0.560371837088168, -102.723892211914, -1.79287013956166, 218, 51, 'PPL', 'P'),
(190081, 'Coyote Hole', 37.7972183227539, 0.659685907827184, -117.804443359375, -2.05607541010026, 218, 39, 'PPL', 'P'),
(191334, 'Coyote Place', 31.7461109161377, 0.554074160189916, -105.855278015137, -1.8475231319781, 218, 51, 'PPL', 'P'),
(178038, 'Coyote Springs', 36.2605590820313, 0.632866144595378, -109.715560913086, -1.91489777860575, 218, 5, 'PPL', 'P'),
(209388, 'Coyote Springs', 41.7830581665039, 0.729251936557798, -106.769996643066, -1.8634879837648, 218, 59, 'PPL', 'P'),
(180925, 'Coyote Valley Rancheria (historical)', 39.2319412231445, 0.684726546292763, -123.166389465332, -2.1496590239637, 218, 6, 'PPL', 'P'),
(180926, 'Coyote Wells', 32.7386093139648, 0.571396525052769, -115.966667175293, -2.02400016477329, 218, 6, 'PPL', 'P'),
(180927, 'Coyoteville', 38.5513916015625, 0.672848714672956, -120.688888549805, -2.10641847576658, 218, 6, 'PPL', 'P'),
(154872, 'Coys Subdivision', 41.476390838623, 0.723899581977984, -84.414436340332, -1.47330985035395, 218, 41, 'PPL', 'P'),
(86066, 'Coytee (historical)', 35.714168548584, 0.623329830784995, -84.2394409179688, -1.47025560405779, 218, 50, 'PPL', 'P'),
(145049, 'Coytesville', 40.8641700744629, 0.713214313894314, -73.9625015258789, -1.29088917463792, 218, 37, 'PPL', 'P'),
(32170, 'Coyville', 37.6861114501953, 0.657746727079443, -95.897216796875, -1.67372217660428, 218, 20, 'PPL', 'P'),
(141570, 'Cozad', 40.8597183227539, 0.713136616169511, -99.9869384765625, -1.74510128540502, 218, 35, 'PPL', 'P'),
(72230, 'Cozaddale', 39.2713890075684, 0.685415040013576, -84.1619415283203, -1.46890298454014, 218, 41, 'PPL', 'P'),
(63996, 'Cozads Mill', 35.1580581665039, 0.613623873613174, -83.394172668457, -1.45550289004124, 218, 33, 'PPL', 'P'),
(8274, 'Cozahome', 36.0449981689453, 0.629103896923423, -92.5013885498047, -1.61445379286067, 218, 4, 'PPL', 'P'),
(63997, 'Cozart', 36.0999984741211, 0.630063833338342, -78.7799987792969, -1.37497036341584, 218, 33, 'PPL', 'P'),
(93515, 'Cozart', 32.3852806091309, 0.565229775811608, -99.9627838134766, -1.74467970700446, 218, 51, 'PPL', 'P'),
(86067, 'Cozette', 35.7583312988281, 0.624100616183491, -88.0686111450195, -1.53708723213916, 218, 50, 'PPL', 'P'),
(93516, 'Cozy Corner', 29.8594398498535, 0.521145538181145, -96.8472213745117, -1.69030288439306, 218, 51, 'PPL', 'P'),
(171886, 'Cozy Corner', 44.6236114501953, 0.77882894393655, -73.1183319091797, -1.27615563538122, 218, 55, 'PPL', 'P'),
(173677, 'Cozy Corner', 46.1647186279297, 0.805726338314132, -92.2377777099609, -1.60985291576145, 218, 57, 'PPL', 'P'),
(186587, 'Cozy Corner', 39.913890838623, 0.696628812415573, -105.025283813477, -1.83303700038667, 218, 7, 'PPL', 'P'),
(127168, 'Cozy Corners', 43.3438911437988, 0.756493611085301, -70.5622177124023, -1.23154302659048, 218, 26, 'PPL', 'P'),
(196296, 'Cozy Court', 46.7547187805176, 0.81602378356406, -114.080558776855, -1.99108136317104, 218, 31, 'PPL', 'P'),
(13610, 'Cozy Cove Mobile Home Park', 38.6263885498047, 0.67415765834873, -75.1263885498047, -1.31120283532666, 218, 10, 'PPL', 'P'),
(171887, 'Cozy Meadow Mobile Home Park', 42.7999992370605, 0.747000906537768, -73.2205581665039, -1.27793982015352, 218, 55, 'PPL', 'P'),
(207130, 'Cozy Nook', 48.3241691589355, 0.843415860114124, -117.704719543457, -2.05433490116984, 218, 56, 'PPL', 'P'),
(203616, 'Cozydale', 41.1722183227539, 0.718590770081993, -112.02082824707, -1.95513228372245, 218, 52, 'PPL', 'P'),
(180928, 'Cozzens Corner', 38.7011108398438, 0.675461808334541, -122.950828552246, -2.14589677629175, 218, 6, 'PPL', 'P'),
(101146, 'Crab', 37.2649993896484, 0.650396935103043, -76.4913864135742, -1.33502654233213, 218, 53, 'PPL', 'P'),
(154873, 'Crab Creek Junction', 41.0833282470703, 0.717039345588967, -80.6166687011719, -1.40702630082491, 218, 41, 'PPL', 'P'),
(148089, 'Crab Meadow', 40.9249992370605, 0.714275983062874, -73.3324966430664, -1.2798935151292, 218, 40, 'PPL', 'P'),
(26876, 'Crab Orchard', 37.7291717529297, 0.658498271139064, -88.8041687011719, -1.54992513333195, 218, 18, 'PPL', 'P'),
(35405, 'Crab Orchard', 37.4644393920898, 0.653877819805831, -84.5066680908203, -1.47491959807484, 218, 21, 'PPL', 'P'),
(86068, 'Crab Orchard', 35.9091682434082, 0.626733217500062, -84.878059387207, -1.48140159901004, 218, 50, 'PPL', 'P'),
(101147, 'Crab Orchard', 36.9269409179688, 0.644496701707972, -82.4322204589844, -1.43871365673911, 218, 53, 'PPL', 'P'),
(108717, 'Crab Orchard', 37.7405586242676, 0.658697009535411, -81.230827331543, -1.41774539105442, 218, 58, 'PPL', 'P'),
(141573, 'Crab Orchard', 40.3349990844727, 0.703978537812946, -96.42138671875, -1.68287066758092, 218, 35, 'PPL', 'P'),
(26877, 'Crab Orchard Estates', 37.749439239502, 0.658852005510853, -89.1474990844727, -1.55591737894268, 218, 18, 'PPL', 'P'),
(63999, 'Crab Point Village', 34.7602806091309, 0.606681345546474, -76.7305603027344, -1.33920091418277, 218, 33, 'PPL', 'P'),
(115139, 'Crab Town', 42.1733283996582, 0.736063437098867, -90.8058319091797, -1.58486074682771, 218, 16, 'PPL', 'P'),
(20326, 'Crabapple', 34.0900001525879, 0.594982744668028, -84.3386077880859, -1.47198639245023, 218, 13, 'PPL', 'P'),
(78085, 'Crabapple', 39.9197196960449, 0.696730545169214, -80.4755630493164, -1.40456354260686, 218, 45, 'PPL', 'P'),
(93517, 'Crabapple', 30.4427795410156, 0.531326736449491, -98.8372192382813, -1.72503489922349, 218, 51, 'PPL', 'P'),
(154874, 'Crabapple', 40.1199989318848, 0.700226077257997, -80.9544372558594, -1.41292147421391, 218, 41, 'PPL', 'P'),
(93518, 'Crabb', 29.5380592346191, 0.51553638829322, -95.709716796875, -1.67044968425679, 218, 51, 'PPL', 'P'),
(101148, 'Crabbe Mill', 37.8875007629395, 0.661261633665157, -76.4505615234375, -1.33431401358248, 218, 53, 'PPL', 'P'),
(54241, 'Crabbs (historical)', 37.1305618286133, 0.648050557024628, -92.7197189331055, -1.61826437690641, 218, 29, 'PPL', 'P'),
(93519, 'Crabbs Prairie', 30.7538890838623, 0.53675662230654, -95.6488876342773, -1.66938801508823, 218, 51, 'PPL', 'P'),
(46067, 'Crabster (historical)', 39.639720916748, 0.691843644568918, -77.2050018310547, -1.34748148096016, 218, 25, 'PPL', 'P'),
(8275, 'Crabtree', 35.6202812194824, 0.621691187766269, -92.5749969482422, -1.61573850177053, 218, 4, 'PPL', 'P'),
(64000, 'Crabtree', 35.6016693115234, 0.621366348692307, -82.9413909912109, -1.44760035898059, 218, 33, 'PPL', 'P'),
(72232, 'Crabtree', 38.8925018310547, 0.678802211289828, -83.1044387817383, -1.4504460797634, 218, 41, 'PPL', 'P'),
(86069, 'Crabtree', 36.2038917541504, 0.63187711314555, -82.1041717529297, -1.43298812671155, 218, 50, 'PPL', 'P'),
(160502, 'Crabtree', 40.3622207641602, 0.704453645751416, -79.470832824707, -1.38702769209312, 218, 45, 'PPL', 'P'),
(180929, 'Crabtree', 36.8436088562012, 0.643042282857652, -119.088890075684, -2.07849323436628, 218, 6, 'PPL', 'P'),
(200638, 'Crabtree', 44.6352806091309, 0.779032609180914, -122.896942138672, -2.14495628095279, 218, 43, 'PPL', 'P'),
(207131, 'Crabtree', 47.0341682434082, 0.820901096784431, -117.190002441406, -2.04535139302273, 218, 56, 'PPL', 'P'),
(86070, 'Crabtree Hills', 35.2027816772461, 0.614404446128676, -85.1880569458008, -1.48681207708065, 218, 50, 'PPL', 'P'),
(160505, 'Crabtree Hollow', 40.1538887023926, 0.700817565336104, -74.8341674804688, -1.30610261552305, 218, 45, 'PPL', 'P'),
(193471, 'Crabtree Place', 40.1536102294922, 0.700812705067115, -123.350280761719, -2.15286853255141, 218, 6, 'PPL', 'P'),
(200639, 'Cracker City (historical)', 44.8238906860352, 0.782324476025333, -118.205558776855, -2.06307619481581, 218, 43, 'PPL', 'P'),
(160503, 'Cracker Jack', 40.1674995422363, 0.701055119305339, -79.9647216796875, -1.39564767875144, 218, 45, 'PPL', 'P'),
(101149, 'Cracker Neck', 36.8466682434082, 0.643095679237509, -82.7091674804688, -1.4435472941176, 218, 53, 'PPL', 'P'),
(86072, 'Crackers Neck', 36.3941688537598, 0.635198075024879, -81.8183288574219, -1.4279992270415, 218, 50, 'PPL', 'P'),
(101150, 'Crackers Neck', 36.7805595397949, 0.641941864695232, -82.4308319091797, -1.43868942197319, 218, 53, 'PPL', 'P'),
(160504, 'Crackersport', 40.6016693115234, 0.708632811292023, -75.5625, -1.31881441603822, 218, 45, 'PPL', 'P'),
(15657, 'Crackertown', 29.0361099243164, 0.506775720150323, -82.6866683959961, -1.44315461101487, 218, 12, 'PPL', 'P'),
(196297, 'Crackerville', 46.0647201538086, 0.803981035693749, -112.804168701172, -1.96880415381058, 218, 31, 'PPL', 'P'),
(54242, 'Craddock', 37.6394386291504, 0.656932132681015, -91.845832824707, -1.60301218702742, 218, 29, 'PPL', 'P'),
(108718, 'Craddock', 38.7224998474121, 0.675835116940343, -80.2663879394531, -1.40091274822652, 218, 58, 'PPL', 'P'),
(101151, 'Craddockville', 37.5816688537598, 0.655923859892311, -75.8691711425781, -1.32416683719706, 218, 53, 'PPL', 'P'),
(29567, 'Cradick Corner', 39.5438919067383, 0.690171112825322, -86.8058319091797, -1.51504757674794, 218, 19, 'PPL', 'P'),
(190082, 'Cradlebaugh (historical)', 39.0433311462402, 0.681434679448344, -119.779998779297, -2.09055535673352, 218, 39, 'PPL', 'P'),
(101152, 'Cradock', 36.7958297729492, 0.642208380541321, -76.3208312988281, -1.33204979402369, 218, 53, 'PPL', 'P'),
(93520, 'Craft', 31.9180603027344, 0.557075243132813, -95.2352828979492, -1.66216925063746, 218, 51, 'PPL', 'P'),
(199253, 'Craft', 41.8158302307129, 0.72982391698092, -103.345832824707, -1.80372505100677, 218, 35, 'PPL', 'P'),
(101153, 'Craft Mill', 36.708610534668, 0.640686117662232, -82.6516723632813, -1.44254381501886, 218, 53, 'PPL', 'P'),
(86073, 'Craft Spring', 36.2733306884766, 0.633089051178618, -82.8102798461914, -1.44531203781394, 218, 50, 'PPL', 'P'),
(93521, 'Crafton', 33.3691711425781, 0.582401905099466, -97.9055633544922, -1.70877443655579, 218, 51, 'PPL', 'P'),
(101154, 'Crafton', 37.9194412231445, 0.661819099860338, -78.295280456543, -1.36651043273904, 218, 53, 'PPL', 'P'),
(160507, 'Crafton', 40.435001373291, 0.705723907012357, -80.0663909912109, -1.39742214298576, 218, 45, 'PPL', 'P'),
(180930, 'Crafton', 34.063060760498, 0.594512563577575, -117.120826721191, -2.04414404894254, 218, 6, 'PPL', 'P'),
(80539, 'Crafton (historical)', 33.6452789306641, 0.587220895091965, -81.9477767944336, -1.43025851975227, 218, 48, 'PPL', 'P'),
(148090, 'Crafts', 41.392219543457, 0.722430515741669, -73.6980590820313, -1.28627378331076, 218, 40, 'PPL', 'P'),
(101155, 'Crafts Point', 37.0577812194824, 0.646780295763688, -79.7347183227539, -1.39163336288231, 218, 53, 'PPL', 'P'),
(171888, 'Craftsbury', 44.6366691589355, 0.779056843946833, -72.3730621337891, -1.26314822398505, 218, 55, 'PPL', 'P'),
(171889, 'Craftsbury Common', 44.6541709899902, 0.779362308523865, -72.3824996948242, -1.26331294049847, 218, 55, 'PPL', 'P'),
(108719, 'Crag', 37.9083290100098, 0.661625155153953, -80.75, -1.40935337098542, 218, 58, 'PPL', 'P'),
(178039, 'Crag', 33.3011093139648, 0.581214002095237, -112.901390075684, -1.97050098689913, 218, 5, 'PPL', 'P'),
(54243, 'Crag O Lea', 36.6091690063477, 0.638950535579828, -94.3522186279297, -1.6467568716189, 218, 29, 'PPL', 'P'),
(1857, 'Cragford', 33.2508316040039, 0.580336490516056, -85.6725006103516, -1.49526721406749, 218, 2, 'PPL', 'P'),
(86074, 'Craggie Hope', 36.0924987792969, 0.629932938970765, -87.1500015258789, -1.52105446974467, 218, 50, 'PPL', 'P'),
(15658, 'Craggs', 29.7786102294922, 0.519734795172703, -82.7411117553711, -1.44410482689181, 218, 12, 'PPL', 'P'),
(64003, 'Craggy', 35.6313896179199, 0.621885065893627, -82.6016693115234, -1.44167109712964, 218, 33, 'PPL', 'P'),
(119252, 'Cragin', 41.920280456543, 0.731646917326107, -87.7561111450195, -1.53163307822668, 218, 18, 'PPL', 'P'),
(145051, 'Cragmere Park', 41.0944404602051, 0.717233290295352, -74.1363906860352, -1.29392411301617, 218, 37, 'PPL', 'P'),
(148091, 'Cragsmoor', 41.6733283996582, 0.727336790838895, -74.3858337402344, -1.29827771560818, 218, 40, 'PPL', 'P'),
(59139, 'Crahen (historical)', 33.4938888549805, 0.584578639816443, -90.5208282470703, -1.57988649454366, 218, 30, 'PPL', 'P'),
(29568, 'Craig', 39.332218170166, 0.686476709182136, -85.5194396972656, -1.49259579717803, 218, 19, 'PPL', 'P'),
(32171, 'Craig', 38.9658317565918, 0.680082059930692, -94.8161087036133, -1.6548532808069, 218, 20, 'PPL', 'P'),
(59140, 'Craig', 32.9300003051758, 0.574736928008055, -90.595832824707, -1.58119557137749, 218, 30, 'PPL', 'P'),
(75559, 'Craig', 34.8402786254883, 0.608077574326975, -95.6272201538086, -1.66900984621344, 218, 42, 'PPL', 'P'),
(93522, 'Craig', 32.2623901367188, 0.563084932448686, -94.7805786132813, -1.65423316374708, 218, 51, 'PPL', 'P'),
(101156, 'Craig', 36.6147193908691, 0.639047408064479, -80.0311126708984, -1.39680642014173, 218, 53, 'PPL', 'P'),
(115140, 'Craig', 42.8958282470703, 0.748673438281365, -96.309440612793, -1.68091683944718, 218, 16, 'PPL', 'P'),
(139107, 'Craig', 40.1947212219238, 0.701530227243809, -95.3708267211914, -1.66453493663378, 218, 29, 'PPL', 'P'),
(141574, 'Craig', 41.7855606079102, 0.729295612399676, -96.3636093139648, -1.68186226163416, 218, 35, 'PPL', 'P'),
(154875, 'Craig', 40.023609161377, 0.698543758397394, -81.5175018310547, -1.42274880495241, 218, 41, 'PPL', 'P'),
(160508, 'Craig', 41.5552787780762, 0.725276436261555, -75.664436340332, -1.32059354080444, 218, 45, 'PPL', 'P'),
(180932, 'Craig', 39.3375015258789, 0.68656892113488, -121.563056945801, -2.12167559249359, 218, 6, 'PPL', 'P'),
(194148, 'Craig', 40.5152816772461, 0.707125062640875, -107.545829772949, -1.87702882632731, 218, 7, 'PPL', 'P'),
(196298, 'Craig', 47.0744400024414, 0.82160397157513, -111.962501525879, -1.95411429039576, 218, 31, 'PPL', 'P'),
(209946, 'Craig', 55.476390838623, 0.96824567725719, -133.148330688477, -2.32387676404812, 218, 1, 'PPL', 'P'),
(1858, 'Craig (historical)', 34.121940612793, 0.595540210863209, -86.4375, -1.5086189721926, 218, 2, 'PPL', 'P'),
(15659, 'Craig (historical)', 24.8383293151855, 0.433510627244616, -80.7583312988281, -1.40949877958094, 218, 12, 'PPL', 'P'),
(180933, 'Craig (historical)', 39.547779083252, 0.690238956854091, -121.386390686035, -2.11859218458349, 218, 6, 'PPL', 'P'),
(188375, 'Craig (historical)', 33.6355590820313, 0.587051251730527, -107.014167785645, -1.86774957414115, 218, 38, 'PPL', 'P'),
(154876, 'Craig Beach', 41.1169395446777, 0.717625973398085, -80.9836120605469, -1.41343067061433, 218, 41, 'PPL', 'P'),
(194790, 'Craig Junction', 46.2755584716797, 0.807660858529966, -116.532783508301, -2.0338807587336, 218, 17, 'PPL', 'P'),
(39933, 'Craig Landing', 31.976390838623, 0.558093303038523, -91.6086120605469, -1.59887190363873, 218, 22, 'PPL', 'P'),
(194149, 'Craig Place', 40.7202796936035, 0.710702952986369, -108.95361328125, -1.90159928370244, 218, 7, 'PPL', 'P'),
(194150, 'Craig South Highlands', 40.4850006103516, 0.706596558322549, -107.5625, -1.8773197766764, 218, 7, 'PPL', 'P'),
(59141, 'Craig Springs', 33.314998626709, 0.581456416333461, -88.9227828979492, -1.55199534160532, 218, 30, 'PPL', 'P'),
(101159, 'Craig Springs', 37.4847183227539, 0.654231753914702, -80.2922210693359, -1.40136362139907, 218, 53, 'PPL', 'P'),
(207132, 'Craige', 46.1355590820313, 0.805217408229818, -117.02278137207, -2.04243283478411, 218, 56, 'PPL', 'P'),
(86075, 'Craigfield', 35.9136085510254, 0.626810715487783, -87.1869430541992, -1.52169922104458, 218, 50, 'PPL', 'P'),
(113290, 'Craighead', 40.1469383239746, 0.700696258348451, -77.1705627441406, -1.34688040550212, 218, 45, 'PPL', 'P'),
(148092, 'Craigie Clair', 41.964168548584, 0.732412909034641, -74.8666687011719, -1.30666986883524, 218, 40, 'PPL', 'P'),
(86076, 'Craigmar (historical)', 35.7394409179688, 0.623770916840539, -84.1694412231445, -1.46903387890772, 218, 50, 'PPL', 'P'),
(194791, 'Craigmont', 46.2413902282715, 0.80706451018287, -116.466110229492, -2.03271709049529, 218, 17, 'PPL', 'P'),
(108721, 'Craigmoor', 39.1933288574219, 0.684052633378919, -80.2794418334961, -1.40114058165778, 218, 58, 'PPL', 'P'),
(148093, 'Craigs', 42.8608283996582, 0.748062575706328, -77.9219436645508, -1.35999447649995, 218, 40, 'PPL', 'P'),
(160509, 'Craigs', 40.832218170166, 0.712656647962051, -76.144172668457, -1.32896651927165, 218, 45, 'PPL', 'P'),
(101160, 'Craigs Creek (historical)', 37.5505599975586, 0.655380907925071, -80.0155563354492, -1.3965349108686, 218, 53, 'PPL', 'P'),
(160510, 'Craigs Meadow', 41.0366706848145, 0.716225017506648, -75.1377792358398, -1.31140164030203, 218, 45, 'PPL', 'P'),
(13613, 'Craigs Mill', 38.6266708374023, 0.674162585196746, -75.6483306884766, -1.32031244415138, 218, 10, 'PPL', 'P'),
(101161, 'Craigs Mill', 36.7483291625977, 0.64137933849398, -82.1619415283203, -1.43399639950025, 218, 53, 'PPL', 'P'),
(59142, 'Craigside', 33.5886116027832, 0.586231863642137, -90.1936111450195, -1.57417547874404, 218, 30, 'PPL', 'P'),
(130363, 'Craigsmere', 46.4213905334473, 0.810206108162782, -89.2408294677734, -1.55754630142343, 218, 27, 'PPL', 'P'),
(101162, 'Craigsville', 38.0786094665527, 0.664597109772427, -79.3833312988281, -1.38550050236602, 218, 53, 'PPL', 'P'),
(108720, 'Craigsville', 38.3305587768555, 0.668994454785338, -80.6533279418945, -1.4076661252768, 218, 58, 'PPL', 'P'),
(160513, 'Craigsville', 40.8522186279297, 0.713005721801933, -79.6497192382813, -1.39014984899708, 218, 45, 'PPL', 'P'),
(154877, 'Craigton', 40.7163887023926, 0.710635042378572, -82.0702819824219, -1.43239663863344, 218, 41, 'PPL', 'P'),
(46068, 'Craigtown', 39.6002807617188, 0.69115528400616, -76.0736083984375, -1.32773494042554, 218, 25, 'PPL', 'P'),
(122442, 'Craigville', 40.7783317565918, 0.71171615262309, -85.0908279418945, -1.48511511083405, 218, 19, 'PPL', 'P'),
(124592, 'Craigville', 41.6394386291504, 0.726745302760788, -70.335563659668, -1.22758716710728, 218, 23, 'PPL', 'P'),
(134841, 'Craigville', 47.9030609130859, 0.836066134716751, -93.6127777099609, -1.63385119297638, 218, 28, 'PPL', 'P'),
(148094, 'Craigville', 41.3858299255371, 0.722318995871022, -74.2391662597656, -1.29571788516839, 218, 40, 'PPL', 'P'),
(124593, 'Craigville Beach', 41.6366691589355, 0.726696966387003, -70.345832824707, -1.22776639784864, 218, 23, 'PPL', 'P'),
(35406, 'Crailhope', 37.1597213745117, 0.648559487108942, -85.6658325195313, -1.49515083392785, 218, 21, 'PPL', 'P'),
(26878, 'Crain', 37.7799987792969, 0.659385370098169, -89.5077819824219, -1.56220550175052, 218, 18, 'PPL', 'P'),
(20327, 'Crain (historical)', 33.3166694641113, 0.581485577947397, -85.258056640625, -1.48803380223072, 218, 13, 'PPL', 'P'),
(8278, 'Crain City', 33.2675018310547, 0.580627440865147, -92.5072174072266, -1.61455552561432, 218, 4, 'PPL', 'P'),
(115141, 'Crain Creek (historical)', 42.5499992370605, 0.742637583407782, -92.2588882446289, -1.61022136409827, 218, 16, 'PPL', 'P'),
(196299, 'Crain Place', 46.0438919067383, 0.803617514204953, -106.309440612793, -1.85544976464662, 218, 31, 'PPL', 'P'),
(148095, 'Crains Mills', 42.7094383239746, 0.745420320430806, -76.0058288574219, -1.32655196426933, 218, 40, 'PPL', 'P'),
(35408, 'Craintown', 38.3877792358398, 0.669993140194118, -83.7861099243164, -1.46234348561722, 218, 21, 'PPL', 'P'),
(26879, 'Crainville', 37.7519416809082, 0.658895681352731, -89.0677795410156, -1.55452601043117, 218, 18, 'PPL', 'P'),
(78087, 'Craley', 39.9474983215332, 0.697215373645663, -76.5108337402344, -1.33536596221306, 218, 45, 'PPL', 'P'),
(8279, 'Cram', 33.5499992370605, 0.585557950728292, -92.3824996948242, -1.61237879089734, 218, 4, 'PPL', 'P'),
(119253, 'Cramer', 40.6911087036133, 0.710193823164973, -89.9469375610352, -1.56987021252582, 218, 18, 'PPL', 'P'),
(134842, 'Cramer', 47.5272216796875, 0.829506502635777, -91.0899963378906, -1.58982035172577, 218, 28, 'PPL', 'P'),
(160512, 'Cramer', 41.014720916748, 0.715841921783841, -78.8305587768555, -1.37585280184304, 218, 45, 'PPL', 'P'),
(70700, 'Cramer Hill', 39.9575004577637, 0.697389943855118, -75.0852813720703, -1.31048537972899, 218, 37, 'PPL', 'P'),
(64006, 'Cramerton', 35.2386093139648, 0.615029756352627, -81.0752792358398, -1.4150305646392, 218, 33, 'PPL', 'P'),
(46069, 'Crampton', 39.415828704834, 0.687935988301445, -77.1969375610352, -1.34734073289654, 218, 25, 'PPL', 'P'),
(127169, 'Crams Corner', 43.1266708374023, 0.752702401536491, -70.8102798461914, -1.23587252757462, 218, 26, 'PPL', 'P'),
(46070, 'Cranberry', 39.6294403076172, 0.691664214090474, -76.9338912963867, -1.34274970949336, 218, 25, 'PPL', 'P'),
(64007, 'Cranberry', 36.1430587768555, 0.630815377397962, -81.9672164916992, -1.43059780647515, 218, 33, 'PPL', 'P'),
(108722, 'Cranberry', 37.8216705322266, 0.66011267939187, -81.1952819824219, -1.41712500767849, 218, 58, 'PPL', 'P'),
(160515, 'Cranberry', 41.3497200012207, 0.721688758799055, -79.7102813720703, -1.39120685763373, 218, 45, 'PPL', 'P'),
(124594, 'Cranberry Bog Corner', 41.5625, 0.725402470360143, -70.9861068725586, -1.23894128809872, 218, 23, 'PPL', 'P'),
(200640, 'Cranberry Corners', 43.1258316040039, 0.752687754150496, -124.386940002441, -2.17096164952325, 218, 43, 'PPL', 'P'),
(148096, 'Cranberry Creek', 43.1555595397949, 0.75320660450987, -74.2200012207031, -1.29538339213548, 218, 40, 'PPL', 'P'),
(64010, 'Cranberry Gap', 36.1161117553711, 0.630345063149454, -81.982780456543, -1.43086944890633, 218, 33, 'PPL', 'P'),
(70704, 'Cranberry Hill', 39.8519401550293, 0.695547569013001, -74.1936111450195, -1.29492279842495, 218, 37, 'PPL', 'P'),
(127170, 'Cranberry Isles', 44.2483291625977, 0.772279032393554, -68.2608337402344, -1.19137629892353, 218, 26, 'PPL', 'P'),
(145052, 'Cranberry Lake', 40.9541702270508, 0.71478511288427, -74.746940612793, -1.30458021948591, 218, 37, 'PPL', 'P'),
(148097, 'Cranberry Lake', 44.2224998474121, 0.771828225800031, -74.836669921875, -1.30614629136493, 218, 40, 'PPL', 'P'),
(173678, 'Cranberry Lake', 45.6402816772461, 0.796573186805584, -90.3472213745117, -1.57685648301343, 218, 57, 'PPL', 'P'),
(173679, 'Cranberry Marsh', 43.5716705322266, 0.760469111381544, -88.085563659668, -1.53738310933627, 218, 57, 'PPL', 'P'),
(154878, 'Cranberry Prairie', 40.3925018310547, 0.704982150069743, -84.5805587768555, -1.47620923383272, 218, 41, 'PPL', 'P'),
(124595, 'Cranberry Village', 41.8358306884766, 0.730172990820802, -70.726936340332, -1.23441790898722, 218, 23, 'PPL', 'P'),
(46071, 'Cranberry Woods', 39.0275001525879, 0.681158376485248, -76.595832824707, -1.33684947609829, 218, 25, 'PPL', 'P'),
(113036, 'Cranbury', 41.1472206115723, 0.718154477716411, -73.3955612182617, -1.28099419960773, 218, 8, 'PPL', 'P'),
(145053, 'Cranbury', 40.3161087036133, 0.703648838469994, -74.5141677856445, -1.30051756724299, 218, 37, 'PPL', 'P'),
(145054, 'Cranbury Station', 40.3019409179688, 0.703401563962781, -74.4922180175781, -1.30013447152018, 218, 37, 'PPL', 'P'),
(15660, 'Crandall', 30.7208309173584, 0.536179648456374, -81.6222229003906, -1.42457653240853, 218, 12, 'PPL', 'P'),
(20328, 'Crandall', 34.8666687011719, 0.608538168037504, -84.7455596923828, -1.47908904307747, 218, 13, 'PPL', 'P'),
(29570, 'Crandall', 38.2874984741211, 0.668242910725718, -86.0663909912109, -1.50214189810542, 218, 19, 'PPL', 'P'),
(59143, 'Crandall', 31.9744396209717, 0.558059247866084, -88.5322189331055, -1.54517871447915, 218, 30, 'PPL', 'P'),
(93523, 'Crandall', 32.6277809143066, 0.569462204574017, -96.4555587768555, -1.68346708250704, 218, 51, 'PPL', 'P'),
(119254, 'Crandall', 40.6327781677246, 0.709175763259263, -89.4319381713867, -1.5608817775307, 218, 18, 'PPL', 'P'),
(154880, 'Crandall', 41.4658317565918, 0.723715291230551, -82.0763931274414, -1.4325032982351, 218, 41, 'PPL', 'P'),
(170093, 'Crandall', 45.1552810668945, 0.788108329280767, -97.9552764892578, -1.70964209443894, 218, 49, 'PPL', 'P'),
(148098, 'Crandall Corners', 42.9550018310547, 0.749706212152097, -73.5719375610352, -1.28407254751175, 218, 40, 'PPL', 'P'),
(46072, 'Crandon', 39.4691696166992, 0.68886696283951, -76.817497253418, -1.34071825021384, 218, 25, 'PPL', 'P'),
(101163, 'Crandon', 37.1472206115723, 0.648341307636638, -80.9633331298828, -1.41307673650546, 218, 53, 'PPL', 'P'),
(170094, 'Crandon', 44.7747192382813, 0.781466272364055, -98.4577789306641, -1.71841241654079, 218, 49, 'PPL', 'P'),
(173680, 'Crandon', 45.5719413757324, 0.795380423532365, -88.9027786254883, -1.55164620118641, 218, 57, 'PPL', 'P'),
(145056, 'Crandon Lakes', 41.1241683959961, 0.717752140654727, -74.8402786254883, -1.30620927512471, 218, 37, 'PPL', 'P'),
(86079, 'Crandull', 36.5433311462402, 0.637801448148485, -81.8955612182617, -1.42934718602725, 218, 50, 'PPL', 'P'),
(29571, 'Crane', 38.8911094665527, 0.678777909944881, -86.9038925170898, -1.51675905722248, 218, 19, 'PPL', 'P'),
(32172, 'Crane', 37.2794418334961, 0.650649003300219, -95.7966690063477, -1.67196728660397, 218, 20, 'PPL', 'P'),
(39934, 'Crane', 31.329719543457, 0.54680675975974, -92.6808319091797, -1.61758567030261, 218, 22, 'PPL', 'P'),
(54244, 'Crane', 36.9052810668945, 0.644118665991235, -93.5713882446289, -1.63312881053069, 218, 29, 'PPL', 'P'),
(101164, 'Crane', 37.9097213745117, 0.6616494564989, -79.6758270263672, -1.39060551585959, 218, 53, 'PPL', 'P'),
(191335, 'Crane', 31.3972206115723, 0.547984875646964, -102.349716186523, -1.78633953593657, 218, 51, 'PPL', 'P'),
(196300, 'Crane', 47.5758285522461, 0.830354852601021, -104.261940002441, -1.81971413755939, 218, 31, 'PPL', 'P'),
(200641, 'Crane', 43.4152793884277, 0.757739571001294, -118.577217102051, -2.06956285628292, 218, 43, 'PPL', 'P'),
(207133, 'Crane', 48.1069412231445, 0.83962451740726, -123.319717407227, -2.15233510138507, 218, 56, 'PPL', 'P'),
(194792, 'Crane (historical)', 44.3852806091309, 0.774669286050928, -116.443061828613, -2.03231482001263, 218, 17, 'PPL', 'P'),
(59144, 'Crane Creek', 30.6097202301025, 0.534240401129606, -89.3847198486328, -1.56005766233137, 218, 30, 'PPL', 'P'),
(143674, 'Crane Crossing', 42.8580589294434, 0.748014239332543, -71.0780563354492, -1.2405461089716, 218, 36, 'PPL', 'P'),
(20329, 'Crane Eater', 34.5250015258789, 0.602574950882653, -84.8724975585938, -1.48130452678831, 218, 13, 'PPL', 'P'),
(80540, 'Crane Forest', 34.0902786254883, 0.594987604937017, -81.0541687011719, -1.41466211630239, 218, 48, 'PPL', 'P'),
(1859, 'Crane Hill', 34.0938911437988, 0.595050655275825, -87.0630569458008, -1.51953700055554, 218, 2, 'PPL', 'P'),
(134843, 'Crane Lake', 48.2666702270508, 0.842412314436355, -92.4883270263672, -1.61422582627136, 218, 28, 'PPL', 'P'),
(124596, 'Crane Lake Camp', 42.3380584716797, 0.738938519232689, -73.3791732788086, -1.28070817610665, 218, 23, 'PPL', 'P'),
(35409, 'Crane Nest', 36.9897193908691, 0.645592392759458, -83.8794403076172, -1.46397240809797, 218, 21, 'PPL', 'P'),
(188376, 'Crane Place', 34.814998626709, 0.607636355113376, -107.383888244629, -1.87420241346241, 218, 38, 'PPL', 'P'),
(119256, 'Crane Road Estates', 41.9408302307129, 0.732005578545913, -88.331672668457, -1.54167852185846, 218, 18, 'PPL', 'P'),
(145063, 'Crane Square', 40.6819381713867, 0.710033767183459, -74.208610534668, -1.29518458716011, 218, 37, 'PPL', 'P'),
(119257, 'Crane Woods Estates', 41.9347190856934, 0.731898918944255, -88.3505630493164, -1.54200822120141, 218, 18, 'PPL', 'P'),
(108723, 'Craneco', 37.7966690063477, 0.65967632044726, -81.7322235107422, -1.42649640523837, 218, 58, 'PPL', 'P'),
(93524, 'Cranell', 28.1677799224854, 0.491620502624523, -97.3925018310547, -1.69981982370651, 218, 51, 'PPL', 'P'),
(72233, 'Cranenest', 39.7269401550293, 0.693365907448008, -81.0625, -1.4148075248979, 218, 41, 'PPL', 'P'),
(101165, 'Cranes Corner', 38.3619384765625, 0.669542133863513, -77.4577789306641, -1.35189327362198, 218, 53, 'PPL', 'P'),
(127174, 'Cranes Corners', 44.5491714477539, 0.777529720798755, -68.741943359375, -1.19977324584055, 218, 26, 'PPL', 'P'),
(148099, 'Cranes Corners', 42.9855613708496, 0.750239576739413, -75.1241683959961, -1.3111640863328, 218, 40, 'PPL', 'P'),
(93525, 'Cranes Mill', 29.920560836792, 0.52221230064529, -98.2900009155273, -1.71548413776419, 218, 51, 'PPL', 'P'),
(101166, 'Cranes Nest', 36.9738883972168, 0.645316089796362, -82.4725036621094, -1.43941673126689, 218, 53, 'PPL', 'P'),
(124597, 'Cranes Station', 41.9519386291504, 0.732199456673271, -71.1466674804688, -1.24174359935576, 218, 23, 'PPL', 'P'),
(108724, 'Cranesville', 39.5530586242676, 0.690331102227808, -79.495002746582, -1.38744953680979, 218, 58, 'PPL', 'P'),
(148100, 'Cranesville', 42.9172210693359, 0.749046813466194, -74.1352767944336, -1.29390467194021, 218, 40, 'PPL', 'P'),
(160520, 'Cranesville', 41.9049987792969, 0.731380201742935, -80.3438873291016, -1.40226536774418, 218, 45, 'PPL', 'P'),
(525, 'Cranetown', 38.2772216796875, 0.668063546826301, -84.5308303833008, -1.47534130963346, 218, 21, 'PPL', 'P'),
(8280, 'Craney', 33.5194396972656, 0.585024586140977, -92.2244415283203, -1.60962015548218, 218, 4, 'PPL', 'P'),
(35410, 'Craney', 38.0672187805176, 0.664398304797052, -83.3552780151367, -1.45482405027938, 218, 21, 'PPL', 'P'),
(46073, 'Craney Creek Estates', 38.9225006103516, 0.679325788760137, -76.3594436645508, -1.33272370693754, 218, 25, 'PPL', 'P'),
(101167, 'Craney Island Estates', 37.6480598449707, 0.657082601282605, -77.4108276367188, -1.35107381895456, 218, 53, 'PPL', 'P'),
(59145, 'Cranfield', 31.5438899993896, 0.550544739376261, -91.2058334350586, -1.5918420904673, 218, 30, 'PPL', 'P'),
(93526, 'Cranfills Gap', 31.773609161377, 0.554554095107862, -97.8255615234375, -1.70737814119626, 218, 51, 'PPL', 'P'),
(72234, 'Cranford', 38.4438896179199, 0.670972451105967, -82.3536071777344, -1.4373415961455, 218, 41, 'PPL', 'P'),
(145057, 'Cranford', 40.6583290100098, 0.709621709583797, -74.3000030517578, -1.29677968749501, 218, 37, 'PPL', 'P'),
(145058, 'Cranford Junction', 40.6619415283203, 0.709684759922605, -74.2916717529297, -1.29663427889949, 218, 37, 'PPL', 'P'),
(35411, 'Cranks', 36.764720916748, 0.641665428574081, -83.1722183227539, -1.45162905591961, 218, 21, 'PPL', 'P'),
(101168, 'Cranks (historical)', 37.9661102294922, 0.662633627679739, -78.1358337402344, -1.36372756255797, 218, 53, 'PPL', 'P'),
(39935, 'Cranky Corner', 30.6205596923828, 0.534429585435542, -90.2613906860352, -1.57535845490026, 218, 22, 'PPL', 'P'),
(154884, 'Cranmer', 41.1330604553223, 0.717907336367251, -81.5486068725586, -1.42329169034062, 218, 41, 'PPL', 'P'),
(203617, 'Cranmer', 40.6166687011719, 0.708894600027178, -111.440002441406, -1.94499496103306, 218, 52, 'PPL', 'P'),
(173683, 'Cranmoor', 44.3147201538086, 0.773437773783848, -90.0327835083008, -1.5713685069551, 218, 57, 'PPL', 'P'),
(70701, 'Cranmoor Manor', 39.9508285522461, 0.697273497136454, -74.1716690063477, -1.2945398358602, 218, 37, 'PPL', 'P'),
(180934, 'Cranmore', 38.9880599975586, 0.68047001592249, -121.805557250977, -2.12590802125599, 218, 6, 'PPL', 'P'),
(86080, 'Cranmore Cove', 35.5013885498047, 0.619616119223907, -85.0508270263672, -1.48441696315429, 218, 50, 'PPL', 'P'),
(193472, 'Crannell', 41.0119400024414, 0.715793385672974, -124.083610534668, -2.16566755159228, 218, 6, 'PPL', 'P'),
(35412, 'Cranston', 38.2633285522461, 0.667821066009049, -83.4355621337891, -1.45622527248692, 218, 21, 'PPL', 'P'),
(115142, 'Cranston', 41.3791694641113, 0.72220274888944, -91.2611083984375, -1.59280682057218, 218, 16, 'PPL', 'P'),
(169337, 'Cranston', 41.7797203063965, 0.729193679908953, -71.4377822875977, -1.24682451124147, 218, 47, 'PPL', 'P'),
(13614, 'Cranston Heights', 39.7333297729492, 0.693477427318655, -75.6308288574219, -1.32000697957435, 218, 10, 'PPL', 'P'),
(169339, 'Cranstons Corner (historical)', 41.5833282470703, 0.725765991848939, -71.501106262207, -1.24792972309385, 218, 47, 'PPL', 'P'),
(46074, 'Cranwood', 39.3938903808594, 0.687553092315719, -76.7091674804688, -1.33882753899794, 218, 25, 'PPL', 'P'),
(108725, 'Crany', 37.7400016784668, 0.658687288997432, -81.5361099243164, -1.42307357744735, 218, 58, 'PPL', 'P'),
(46075, 'Crapo', 38.3197212219238, 0.668805303768916, -76.1313934326172, -1.32874347953036, 218, 25, 'PPL', 'P'),
(139840, 'Crary', 48.0708312988281, 0.838994280335293, -98.6380615234375, -1.72155894136872, 218, 34, 'PPL', 'P'),
(148101, 'Crary Mills', 44.5774993896484, 0.778024136655128, -75.0672225952148, -1.31017019461398, 218, 40, 'PPL', 'P'),
(148102, 'Craryville', 42.1747207641602, 0.736087738443814, -73.5833282470703, -1.28427135248712, 218, 40, 'PPL', 'P'),
(180935, 'Crater', 37.2161102294922, 0.649543658289781, -117.686393737793, -2.05401505552292, 218, 6, 'PPL', 'P'),
(207134, 'Crater', 47.2458305358887, 0.824595300690534, -119.94750213623, -2.09347884182015, 218, 56, 'PPL', 'P'),
(211452, 'Crater Village', 20.9008293151855, 0.364788287947339, -156.664993286133, -2.73431995545783, 218, 15, 'PPL', 'P'),
(148103, 'Craterclub', 44.2869415283203, 0.772952945307399, -73.3505630493164, -1.28020883340226, 218, 40, 'PPL', 'P'),
(160519, 'Crates', 41.1105613708496, 0.717514653264519, -79.2699966430664, -1.38352243946636, 218, 45, 'PPL', 'P'),
(115143, 'Crathorne', 42.8072204589844, 0.747126940636356, -96.3311080932617, -1.68129500832197, 218, 16, 'PPL', 'P'),
(26880, 'Cravat', 38.4236106872559, 0.670618516997096, -89.0930633544922, -1.55496729622379, 218, 18, 'PPL', 'P'),
(64012, 'Craven', 35.6283302307129, 0.621831669513771, -80.3319396972656, -1.40205684223082, 218, 33, 'PPL', 'P'),
(170097, 'Craven', 45.4422187805176, 0.793116337131634, -98.9247207641602, -1.7265620889506, 218, 49, 'PPL', 'P'),
(64013, 'Craven Corner', 34.8666687011719, 0.608538168037504, -76.7502822875977, -1.33954512775366, 218, 33, 'PPL', 'P'),
(170098, 'Craven Corner', 45.4477806091309, 0.793213409353368, -98.9255599975586, -1.72657673633659, 218, 49, 'PPL', 'P'),
(64015, 'Craven Terrace', 35.1091690063477, 0.612770596799913, -77.0511093139648, -1.34479554984276, 218, 33, 'PPL', 'P'),
(80541, 'Cravenhill (historical)', 34.3544387817383, 0.599598069416163, -81.3969421386719, -1.42064464137514, 218, 48, 'PPL', 'P'),
(573, 'Cravens', 30.9666690826416, 0.540470333867628, -93.0350036621094, -1.62376713350879, 218, 22, 'PPL', 'P'),
(8281, 'Cravens', 35.5483283996582, 0.620435374154242, -93.9166717529297, -1.63915514460338, 218, 4, 'PPL', 'P'),
(35413, 'Cravens', 37.8086090087891, 0.659884712802559, -85.5427780151367, -1.49300312766676, 218, 21, 'PPL', 'P'),
(86081, 'Cravenstown', 36.3050003051758, 0.633641790262863, -85.1277770996094, -1.48575999529201, 218, 50, 'PPL', 'P'),
(32173, 'Cravensville', 37.0319404602051, 0.646329289433083, -94.8444366455078, -1.65534769666328, 218, 20, 'PPL', 'P'),
(72235, 'Craver', 39.1427803039551, 0.683170394688803, -84.1791687011719, -1.46920365542721, 218, 41, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(196301, 'Craver', 45.6969413757324, 0.797562085097358, -109.380279541016, -1.90904601474251, 218, 31, 'PPL', 'P'),
(1861, 'Crawford', 30.7638893127441, 0.536931159226481, -88.227783203125, -1.53986530863028, 218, 2, 'PPL', 'P'),
(8282, 'Crawford', 36.1766700744629, 0.63140200520708, -92.9102783203125, -1.62159026563376, 218, 4, 'PPL', 'P'),
(15661, 'Crawford', 30.5086097717285, 0.532475690722778, -81.8811111450195, -1.42909498467201, 218, 12, 'PPL', 'P'),
(20331, 'Crawford', 33.8827781677246, 0.591366038749646, -83.1547164916992, -1.45132359134258, 218, 13, 'PPL', 'P'),
(29572, 'Crawford', 38.8458290100098, 0.6779876168914, -86.397216796875, -1.50791589766482, 218, 19, 'PPL', 'P'),
(32174, 'Crawford', 38.5133285522461, 0.672184389139035, -98.0347213745117, -1.71102866926049, 218, 20, 'PPL', 'P'),
(35414, 'Crawford', 37.1944389343262, 0.649165422835963, -83.9519424438477, -1.46523780908992, 218, 21, 'PPL', 'P'),
(59146, 'Crawford', 33.3013916015625, 0.581218928943253, -88.6147232055664, -1.54661868568056, 218, 30, 'PPL', 'P'),
(75562, 'Crawford', 35.8269386291504, 0.625298039988618, -99.7991714477539, -1.74182413252562, 218, 42, 'PPL', 'P'),
(86083, 'Crawford', 36.2691688537598, 0.633016413459886, -85.1608276367188, -1.48633683598412, 218, 50, 'PPL', 'P'),
(93527, 'Crawford', 31.5341701507568, 0.550375096014823, -97.4427795410156, -1.70069733528569, 218, 51, 'PPL', 'P'),
(108726, 'Crawford', 38.871940612793, 0.67844335033294, -80.4369430541992, -1.40388949653496, 218, 58, 'PPL', 'P'),
(127172, 'Crawford', 45.0527801513672, 0.786319350818507, -67.5519409179688, -1.17900378513124, 218, 26, 'PPL', 'P'),
(130364, 'Crawford', 43.5238914489746, 0.759635209065213, -84.7869415283203, -1.4798112923651, 218, 27, 'PPL', 'P'),
(139106, 'Crawford', 40.4747200012207, 0.706417127844105, -92.2752838134766, -1.6105075207574, 218, 29, 'PPL', 'P'),
(148104, 'Crawford', 41.6555595397949, 0.727026665729955, -74.32861328125, -1.2972790301994, 218, 40, 'PPL', 'P'),
(154886, 'Crawford', 40.9197196960449, 0.714183837689157, -83.3422164916992, -1.45459608369007, 218, 41, 'PPL', 'P'),
(186588, 'Crawford', 38.7038917541504, 0.675510344445408, -107.608329772949, -1.87811965710981, 218, 7, 'PPL', 'P'),
(199254, 'Crawford', 42.6830596923828, 0.744959926457358, -103.412216186523, -1.80488365923901, 218, 35, 'PPL', 'P'),
(207135, 'Crawford', 45.8030586242676, 0.799414180477454, -122.483612060547, -2.13774231019198, 218, 56, 'PPL', 'P'),
(8283, 'Crawford (historical)', 34.1530609130859, 0.596083362567531, -93.7572174072266, -1.63637214126424, 218, 4, 'PPL', 'P'),
(86082, 'Crawford (historical)', 36.3499984741211, 0.634427156468328, -85.4233322143555, -1.49091840516544, 218, 50, 'PPL', 'P'),
(614, 'Crawford Acres (historical)', 39.4063911437988, 0.687771271788024, -75.8833312988281, -1.32441397854622, 218, 25, 'PPL', 'P'),
(119259, 'Crawford Corners', 42.4949989318848, 0.741677646992863, -87.9911117553711, -1.53573461262151, 218, 18, 'PPL', 'P'),
(145060, 'Crawford Corners', 40.3847198486328, 0.704846328854149, -74.1891708374023, -1.29484530043723, 218, 37, 'PPL', 'P'),
(154887, 'Crawford Corners', 41.0099983215332, 0.715759496948103, -82.0547180175781, -1.43212499620225, 218, 41, 'PPL', 'P'),
(160521, 'Crawford Corners', 41.172779083252, 0.718600557198999, -79.7675018310547, -1.39220554304251, 218, 45, 'PPL', 'P'),
(119260, 'Crawford Countryside', 41.5208282470703, 0.724675161066443, -87.7133331298828, -1.53088646101508, 218, 18, 'PPL', 'P'),
(173686, 'Crawford Crossing', 43.4544410705566, 0.758423071295063, -89.7291717529297, -1.56606948217612, 218, 57, 'PPL', 'P'),
(112202, 'Crawford Fork', 32.8177795410156, 0.572778306184356, -88.0541687011719, -1.53683516394199, 218, 2, 'PPL', 'P'),
(39936, 'Crawford Landing', 30.3024997711182, 0.52887839259084, -89.7069396972656, -1.56568145960529, 218, 22, 'PPL', 'P'),
(72236, 'Crawford Mobile Home Park', 39.9263916015625, 0.696846991887878, -83.6547164916992, -1.46005023760255, 218, 41, 'PPL', 'P'),
(8287, 'Crawfordsville', 35.2249984741211, 0.614792202383392, -90.3249969482422, -1.57646859360066, 218, 4, 'PPL', 'P'),
(115147, 'Crawfordsville', 41.2441711425781, 0.71984658369402, -91.5619430541992, -1.59805737581933, 218, 16, 'PPL', 'P'),
(122443, 'Crawfordsville', 40.0411109924316, 0.698849222974426, -86.8744430541992, -1.5162450671321, 218, 19, 'PPL', 'P'),
(200642, 'Crawfordsville', 44.3572196960449, 0.774179530726462, -122.856666564941, -2.14425333958306, 218, 43, 'PPL', 'P'),
(26883, 'Crawfordsville (historical)', 38.8666687011719, 0.678351338117277, -87.6694412231445, -1.53012040272752, 218, 18, 'PPL', 'P'),
(160524, 'Crawfordtown', 40.9900016784668, 0.715410489687248, -78.9694366455078, -1.37827667790918, 218, 45, 'PPL', 'P'),
(15662, 'Crawfordville', 30.1758308410645, 0.526667602701424, -84.3752822875977, -1.47262648321823, 218, 12, 'PPL', 'P'),
(20332, 'Crawfordville', 33.5538902282715, 0.585625861336089, -82.896110534668, -1.44681006592711, 218, 13, 'PPL', 'P'),
(20333, 'Crawley', 31.3858299255371, 0.547786070671589, -82.45361328125, -1.43908703192394, 218, 13, 'PPL', 'P'),
(108727, 'Crawley', 37.9347190856934, 0.662085748864482, -80.6522216796875, -1.4076468173589, 218, 58, 'PPL', 'P'),
(29574, 'Crawleyville', 38.2833290100098, 0.668170139848932, -87.8333282470703, -1.53298077089632, 218, 19, 'PPL', 'P'),
(35415, 'Craycraft', 37.0938911437988, 0.647410532835655, -85.2027816772461, -1.48706907212584, 218, 21, 'PPL', 'P'),
(178040, 'Craycroft', 32.2069396972656, 0.562117139708551, -110.874717712402, -1.9351288813007, 218, 5, 'PPL', 'P'),
(35417, 'Crayne', 37.2705612182617, 0.650494007324776, -88.0824966430664, -1.53732957979836, 218, 21, 'PPL', 'P'),
(35416, 'Craynor', 37.436939239502, 0.653397851598371, -82.6688919067383, -1.44284435274788, 218, 21, 'PPL', 'P'),
(154891, 'Crayon', 40.2002792358398, 0.701627232886515, -83.8949966430664, -1.4642439173711, 218, 41, 'PPL', 'P'),
(20334, 'Craytonia', 34.836109161377, 0.608004803450188, -84.1591720581055, -1.46885464816635, 218, 13, 'PPL', 'P'),
(80542, 'Craytonville', 34.4361114501953, 0.601023526389628, -82.4830627441406, -1.43960102201432, 218, 48, 'PPL', 'P'),
(64017, 'Creadmore', 35.9911117553711, 0.628163401584461, -80.315559387207, -1.4017709518878, 218, 33, 'PPL', 'P'),
(46099, 'Creagerstown', 39.577220916748, 0.690752813786422, -77.3652801513672, -1.35027886536917, 218, 25, 'PPL', 'P'),
(26884, 'Creal Springs', 37.6194381713867, 0.656583058841133, -88.836669921875, -1.55049238664413, 218, 18, 'PPL', 'P'),
(173689, 'Cream', 44.3161087036133, 0.773462008549768, -91.7716674804688, -1.60171775757959, 218, 57, 'PPL', 'P'),
(194793, 'Cream Can Junction', 42.9386100769043, 0.749420122071996, -113.384719848633, -1.97893668281001, 218, 17, 'PPL', 'P'),
(154892, 'Cream City', 40.5644416809082, 0.707983066565071, -80.7180633544922, -1.40879597136927, 218, 41, 'PPL', 'P'),
(171891, 'Cream Hill', 43.9313888549805, 0.766747380493351, -73.3402786254883, -1.28002933634479, 218, 55, 'PPL', 'P'),
(54249, 'Cream Ridge', 39.7852783203125, 0.694384100511772, -93.4625015258789, -1.63122837877681, 218, 29, 'PPL', 'P'),
(145061, 'Cream Ridge', 40.1349983215332, 0.700487865993152, -74.5244369506836, -1.30069679798435, 218, 37, 'PPL', 'P'),
(108728, 'Creamery', 37.642219543457, 0.656980668791882, -80.6780624389648, -1.4080978236895, 218, 58, 'PPL', 'P'),
(115148, 'Creamery', 43.2208290100098, 0.754345771666152, -93.3291702270508, -1.6289013086163, 218, 16, 'PPL', 'P'),
(160525, 'Creamery', 40.2200012207031, 0.701971446457408, -75.4166717529297, -1.31626923298443, 218, 45, 'PPL', 'P'),
(119261, 'Creamery Corners', 42.2797203063965, 0.737920326168924, -87.8786087036133, -1.5337710639498, 218, 18, 'PPL', 'P'),
(160526, 'Creamton', 41.6738891601563, 0.727346577955901, -75.3786087036133, -1.31560490745051, 218, 45, 'PPL', 'P'),
(75563, 'Creata', 34.5191688537598, 0.602473151549985, -99.5466690063477, -1.73741713355376, 218, 42, 'PPL', 'P'),
(93528, 'Creath', 31.4477806091309, 0.548867314074161, -95.2230606079102, -1.66195593143415, 218, 51, 'PPL', 'P'),
(80543, 'Creco (historical)', 33.4219398498535, 0.583322892783443, -81.1297225952148, -1.41598078051614, 218, 48, 'PPL', 'P'),
(93529, 'Crecy', 31.2011108398438, 0.544562114434967, -95.0550003051758, -1.65902272580953, 218, 51, 'PPL', 'P'),
(8289, 'Credit (historical)', 35.7216682434082, 0.623460725152572, -91.0055618286133, -1.58834669153657, 218, 4, 'PPL', 'P'),
(20335, 'Credit Hill', 31.5113906860352, 0.549977519353588, -81.5005569458008, -1.42245306091336, 218, 13, 'PPL', 'P'),
(134847, 'Credit River', 44.6744384765625, 0.779716042895655, -93.3788909912109, -1.6297690996575, 218, 28, 'PPL', 'P'),
(196302, 'Cree Crossing', 48.5405616760254, 0.84719262201402, -107.518608093262, -1.87655371838884, 218, 31, 'PPL', 'P'),
(529, 'Creech', 36.767219543457, 0.641709037836932, -83.3949966430664, -1.45551727111113, 218, 21, 'PPL', 'P'),
(8290, 'Creech', 36.226390838623, 0.632269796248282, -94.0352783203125, -1.6412252197187, 218, 4, 'PPL', 'P'),
(741, 'Creeches Mill', 35.4658317565918, 0.618995536110891, -78.2652816772461, -1.36598685526873, 218, 33, 'PPL', 'P'),
(93530, 'Creechville', 32.3424987792969, 0.564483092020977, -96.5288925170898, -1.68474699772693, 218, 51, 'PPL', 'P'),
(108729, 'Creed', 38.396110534668, 0.670138548789636, -81.5627822875977, -1.42353909800589, 218, 58, 'PPL', 'P'),
(180936, 'Creed', 38.2433280944824, 0.667471992169167, -121.85417175293, -2.12675650437929, 218, 6, 'PPL', 'P'),
(186589, 'Creede', 37.8491706848145, 0.660592647599329, -106.925827026367, -1.86620773702805, 218, 7, 'PPL', 'P'),
(64018, 'Creedmoor', 36.1222190856934, 0.630451656172085, -78.686393737793, -1.37333664724513, 218, 33, 'PPL', 'P'),
(93531, 'Creedmoor', 30.0897197723389, 0.525164681029752, -97.7336120605469, -1.70577332032338, 218, 51, 'PPL', 'P'),
(101169, 'Creeds', 36.6047210693359, 0.638872904434052, -76.0266723632813, -1.32691575207424, 218, 53, 'PPL', 'P'),
(59147, 'Creek (historical)', 31.999439239502, 0.558495573521179, -88.4805603027344, -1.54427710129211, 218, 30, 'PPL', 'P'),
(143676, 'Creek Area', 43.0758285522461, 0.751815036261277, -70.7755584716797, -1.23526652526858, 218, 36, 'PPL', 'P'),
(20336, 'Creek Cove', 33.6330604553223, 0.587007642467677, -84.246940612793, -1.47038649842537, 218, 13, 'PPL', 'P'),
(20337, 'Creek Hollow', 33.5625, 0.585776130200597, -84.2891693115234, -1.47112352825705, 218, 13, 'PPL', 'P'),
(20338, 'Creek Hollow South', 34.1230583190918, 0.595559718518194, -84.3863906860352, -1.47282036134559, 218, 13, 'PPL', 'P'),
(20339, 'Creek Indian', 33.6583290100098, 0.587448661944194, -84.6944427490234, -1.4781968841123, 218, 13, 'PPL', 'P'),
(20340, 'Creek Island', 31.8205604553223, 0.55537354977528, -81.6569366455078, -1.42518240155653, 218, 13, 'PPL', 'P'),
(101170, 'Creek Junction', 36.6472206115723, 0.639614661376666, -81.6783294677734, -1.42555577674135, 218, 53, 'PPL', 'P'),
(54251, 'Creek Nation', 37.5138893127441, 0.654740883736098, -90.3880615234375, -1.57756927807919, 218, 29, 'PPL', 'P'),
(80544, 'Creek Point', 32.7361106872559, 0.571352915789918, -79.956672668457, -1.39550719700394, 218, 48, 'PPL', 'P'),
(20341, 'Creek Ridge', 33.1016693115234, 0.577733117392449, -85.0441665649414, -1.4843007161727, 218, 13, 'PPL', 'P'),
(203620, 'Creek Road Condo', 40.6177787780762, 0.708913974524108, -111.856941223145, -1.95227191555365, 218, 52, 'PPL', 'P'),
(86084, 'Creek Side', 35.5944404602051, 0.621240181435664, -87.0272216796875, -1.51891155717354, 218, 50, 'PPL', 'P'),
(1862, 'Creek Stand', 32.2944412231445, 0.563644329435657, -85.4775009155273, -1.49186382735242, 218, 2, 'PPL', 'P'),
(86085, 'Creek Store', 36.1755599975586, 0.631382630710149, -83.1597213745117, -1.45141094302633, 218, 50, 'PPL', 'P'),
(20342, 'Creek Subdivision', 33.4152793884277, 0.583206645801861, -84.8097229003906, -1.48020890231585, 218, 13, 'PPL', 'P'),
(20344, 'Creek View', 33.5652809143066, 0.585824666311464, -82.1133270263672, -1.43314791637695, 218, 13, 'PPL', 'P'),
(46076, 'Creek View', 39.1583290100098, 0.683441770803882, -76.508056640625, -1.33531749268122, 218, 25, 'PPL', 'P'),
(64019, 'Creek View', 36.2105598449707, 0.631993493285186, -80.3141708374023, -1.40174671712188, 218, 33, 'PPL', 'P'),
(203622, 'Creek View Condominium', 40.6805610656738, 0.710009732154621, -111.879722595215, -1.95266952550439, 218, 52, 'PPL', 'P'),
(148106, 'Creeklocks', 41.8705596923828, 0.730779126284904, -74.0444412231445, -1.29231929214329, 218, 40, 'PPL', 'P'),
(86086, 'Creekmont', 35.9244384765625, 0.626999733346151, -86.4775009155273, -1.50931711987236, 218, 50, 'PPL', 'P'),
(35418, 'Creekmore', 36.6227798461914, 0.639188089549063, -84.3616714477539, -1.472388929249, 218, 21, 'PPL', 'P'),
(20345, 'Creekside', 32.5813903808594, 0.568652537023605, -83.6208267211914, -1.45945874952444, 218, 13, 'PPL', 'P'),
(35419, 'Creekside', 38.291389465332, 0.668310821333515, -85.5694427490234, -1.49346851506725, 218, 21, 'PPL', 'P'),
(80547, 'Creekside', 33.8433303833008, 0.590677545028833, -78.6319427490234, -1.37238629821014, 218, 48, 'PPL', 'P'),
(86088, 'Creekside', 35.9161109924316, 0.62685439132966, -86.5561065673828, -1.51068904730792, 218, 50, 'PPL', 'P'),
(148107, 'Creekside', 42.6916694641113, 0.745110195321866, -78.7830581665039, -1.3750237597957, 218, 40, 'PPL', 'P'),
(160527, 'Creekside', 40.6788902282715, 0.709980570540685, -79.1877822875977, -1.38208752827103, 218, 45, 'PPL', 'P'),
(180938, 'Creekside', 34.0230598449707, 0.59381441589781, -117.588333129883, -2.05230357504838, 218, 6, 'PPL', 'P'),
(203625, 'Creekside Condominium', 41.2427787780762, 0.719822282349073, -111.974716186523, -1.95432747644102, 218, 52, 'PPL', 'P'),
(20346, 'Creekside Crossing Estates', 33.3869400024414, 0.582712030208406, -84.5369415283203, -1.47544796923512, 218, 13, 'PPL', 'P'),
(203626, 'Creekside East Condominium', 40.6555595397949, 0.709573373210012, -111.873611450195, -1.95256286590274, 218, 52, 'PPL', 'P'),
(203627, 'Creekside Estates', 40.6191711425781, 0.708938275869055, -111.856941223145, -1.95227191555365, 218, 52, 'PPL', 'P'),
(80549, 'Creekside Villas', 34.9208297729492, 0.609483457066428, -82.3450012207031, -1.43719139386002, 218, 48, 'PPL', 'P'),
(64022, 'Creeksville', 36.3938903808594, 0.635193214755889, -77.3038864135742, -1.34920734250458, 218, 33, 'PPL', 'P'),
(108730, 'Creekvale', 39.4302787780762, 0.688188189656676, -78.5513916015625, -1.37098041547069, 218, 58, 'PPL', 'P'),
(203628, 'Creekview', 40.6611099243164, 0.709670245694664, -112.021392822266, -1.95514213741848, 218, 52, 'PPL', 'P'),
(203629, 'Creekview Estates', 40.6166687011719, 0.708894600027178, -111.847221374512, -1.95210227219221, 218, 52, 'PPL', 'P'),
(35420, 'Creekville', 37.0777816772461, 0.64712936960357, -83.5491714477539, -1.45820812907654, 218, 21, 'PPL', 'P'),
(20347, 'Creekwood', 33.4047203063965, 0.583022355054428, -84.6694412231445, -1.47776052516769, 218, 13, 'PPL', 'P'),
(29575, 'Creekwood', 39.8772201538086, 0.6959887882266, -86.1188888549805, -1.50305815867846, 218, 19, 'PPL', 'P'),
(64024, 'Creekwood', 36.0088882446289, 0.628473659851456, -80.4583282470703, -1.40426273856173, 218, 33, 'PPL', 'P'),
(80551, 'Creekwood', 33.9652786254883, 0.592805943372025, -81.2750015258789, -1.41851637619, 218, 48, 'PPL', 'P'),
(86089, 'Creekwood', 35.4666709899902, 0.619010183496886, -86.4780578613281, -1.50932684041034, 218, 50, 'PPL', 'P'),
(119265, 'Creekwood', 41.6452789306641, 0.726847235251511, -87.9744415283203, -1.53544366227242, 218, 18, 'PPL', 'P'),
(64025, 'Creekwood Acres', 36.1683311462402, 0.631256463453507, -80.2041702270508, -1.39982684429204, 218, 33, 'PPL', 'P'),
(20352, 'Creekwood Estates', 33.9194412231445, 0.592005929780565, -84.7480621337891, -1.47913271891935, 218, 13, 'PPL', 'P'),
(20353, 'Creekwood Hills', 33.6863899230957, 0.587938417268659, -84.2397232055664, -1.47026053090581, 218, 13, 'PPL', 'P'),
(80552, 'Creekwood Hills', 34.5036087036133, 0.602201575697824, -82.5791702270508, -1.44127841402691, 218, 48, 'PPL', 'P'),
(1865, 'Creel', 33.813060760498, 0.590149240447589, -86.9944381713867, -1.51833937701333, 218, 2, 'PPL', 'P'),
(15663, 'Creels', 29.8216705322266, 0.520486339232323, -84.9091720581055, -1.48194461755631, 218, 12, 'PPL', 'P'),
(108731, 'Creels', 39.1966705322266, 0.684110956606792, -81.5005569458008, -1.42245306091336, 218, 58, 'PPL', 'P'),
(35421, 'Creelsboro', 36.8849983215332, 0.643764665303336, -85.1975021362305, -1.48697692675212, 218, 21, 'PPL', 'P'),
(20354, 'Creelwood', 33.8005599975586, 0.589931060975284, -84.6127777099609, -1.47677156029689, 218, 13, 'PPL', 'P'),
(20355, 'Creelwood Trailer Park', 33.7922210693359, 0.589785519221711, -84.6102828979492, -1.47672801761306, 218, 13, 'PPL', 'P'),
(70702, 'Creesville', 39.7563896179199, 0.693879897538393, -75.0811080932617, -1.31041254227318, 218, 37, 'PPL', 'P'),
(207136, 'Crego (historical)', 46.5986099243164, 0.813299170031827, -123.053329467773, -2.14768575475401, 218, 56, 'PPL', 'P'),
(8296, 'Creigh', 34.4455604553223, 0.601188442640131, -91.0005569458008, -1.58825933985282, 218, 4, 'PPL', 'P'),
(15664, 'Creighton', 28.8872203826904, 0.504177107427164, -80.9222183227539, -1.41235914774974, 218, 12, 'PPL', 'P'),
(54252, 'Creighton', 38.4947204589844, 0.6718596166441, -94.0730590820313, -1.6418846184046, 218, 29, 'PPL', 'P'),
(130366, 'Creighton', 46.3466682434082, 0.80890195817697, -86.2777786254883, -1.50583130832156, 218, 27, 'PPL', 'P'),
(141577, 'Creighton', 42.4666709899902, 0.74118323113649, -97.9058303833008, -1.7087790970877, 218, 35, 'PPL', 'P'),
(160529, 'Creighton', 40.5872192382813, 0.708380609936793, -79.7786102294922, -1.39239942116987, 218, 45, 'PPL', 'P'),
(202034, 'Creighton', 44.2550010681152, 0.772395479112218, -102.207496643066, -1.78385733664256, 218, 49, 'PPL', 'P'),
(20356, 'Creighton (historical)', 34.2930603027344, 0.598526812867678, -84.269172668457, -1.47077452099619, 218, 13, 'PPL', 'P'),
(75570, 'Crekola', 35.7055587768555, 0.623179561920487, -95.4872207641602, -1.66656639591329, 218, 42, 'PPL', 'P'),
(46077, 'Crellin', 39.3888893127441, 0.687465807210992, -79.4655609130859, -1.38693567987746, 218, 25, 'PPL', 'P'),
(64026, 'Cremo', 36.1780586242676, 0.631426239972999, -76.9361114501953, -1.34278845848722, 218, 33, 'PPL', 'P'),
(108732, 'Cremo', 38.8847198486328, 0.678666390074234, -81.2102813720703, -1.41738679641365, 218, 58, 'PPL', 'P'),
(46078, 'Cremona', 38.4563903808594, 0.671190630578272, -76.6569366455078, -1.33791593895681, 218, 25, 'PPL', 'P'),
(101188, 'Cremona (historical)', 37.7188911437988, 0.65831884066062, -78.1600036621094, -1.36414940727463, 218, 53, 'PPL', 'P'),
(112426, 'Crenfree', 33.5808296203613, 0.586096042426543, -90.1116714477539, -1.57274536123867, 218, 30, 'PPL', 'P'),
(35422, 'Crenshaw', 38.0547218322754, 0.664180191903775, -85.4669418334961, -1.49167953660499, 218, 21, 'PPL', 'P'),
(59148, 'Crenshaw', 34.502498626709, 0.602182201200894, -90.1986083984375, -1.57426269726974, 218, 30, 'PPL', 'P'),
(86094, 'Crenshaw', 35.8883285522461, 0.626369496274184, -83.9377822875977, -1.46499066774076, 218, 50, 'PPL', 'P'),
(160530, 'Crenshaw', 41.2486114501953, 0.719924081681741, -78.7622222900391, -1.37466010514885, 218, 45, 'PPL', 'P'),
(1866, 'Crenshaw (historical)', 32.2997207641602, 0.563736474809374, -87.6158294677734, -1.52918470107852, 218, 2, 'PPL', 'P'),
(26885, 'Crenshaw Crossing', 37.7738914489746, 0.659278777075539, -88.9794387817383, -1.55298417331807, 218, 18, 'PPL', 'P'),
(1868, 'Creola', 30.8916702270508, 0.53916135690234, -88.0397186279297, -1.53658296258676, 218, 2, 'PPL', 'P'),
(39937, 'Creola', 31.4741706848145, 0.549327907784691, -92.504997253418, -1.61451677662045, 218, 22, 'PPL', 'P'),
(72241, 'Creola', 39.3152809143066, 0.686181098301137, -82.4663925170898, -1.43931007166523, 218, 41, 'PPL', 'P'),
(39938, 'Creole', 29.7958297729492, 0.520035332901718, -93.1111068725586, -1.62509538510247, 218, 22, 'PPL', 'P'),
(207137, 'Creosote', 47.6144409179688, 0.831028765514866, -122.502777099609, -2.13807680322489, 218, 56, 'PPL', 'P'),
(108733, 'Cresap', 39.8433303833008, 0.695397300148493, -80.8169403076172, -1.41052169975564, 218, 58, 'PPL', 'P'),
(46079, 'Cresaptown', 39.5927810668945, 0.691024389638583, -78.833610534668, -1.37590606506484, 218, 25, 'PPL', 'P'),
(170099, 'Cresbard', 45.1699981689453, 0.788365191167906, -98.9480590820313, -1.72696941943932, 218, 49, 'PPL', 'P'),
(46080, 'Crescendo', 38.7861099243164, 0.67694532221977, -76.2941665649414, -1.3315844066232, 218, 25, 'PPL', 'P'),
(8292, 'Crescent', 35.2847213745117, 0.615834563634049, -94.3619384765625, -1.64692651498034, 218, 4, 'PPL', 'P'),
(20357, 'Crescent', 31.5091705322266, 0.549938770359728, -81.3697204589844, -1.42016953343667, 218, 13, 'PPL', 'P'),
(39940, 'Crescent', 29.6138896942139, 0.516859879486449, -90.7908325195313, -1.58459895809256, 218, 22, 'PPL', 'P'),
(54253, 'Crescent', 38.521110534668, 0.672320210354629, -90.6061096191406, -1.58137493527691, 218, 29, 'PPL', 'P'),
(64027, 'Crescent', 35.5752792358398, 0.620905754981778, -80.420280456543, -1.40359867934392, 218, 33, 'PPL', 'P'),
(75571, 'Crescent', 35.9524993896484, 0.627489488670617, -97.5944366455078, -1.70334425109312, 218, 42, 'PPL', 'P'),
(80553, 'Crescent', 34.7708282470703, 0.606865436556825, -82.1113891601563, -1.43311409423111, 218, 48, 'PPL', 'P'),
(86095, 'Crescent', 35.750560760498, 0.623964994704979, -86.4427795410156, -1.50871111756632, 218, 50, 'PPL', 'P'),
(101171, 'Crescent', 38.8666687011719, 0.678351338117277, -77.6619415283203, -1.35545658316051, 218, 53, 'PPL', 'P'),
(108734, 'Crescent', 38.1736106872559, 0.66625519386711, -81.3088912963867, -1.41910786426811, 218, 58, 'PPL', 'P'),
(115149, 'Crescent', 41.3650016784668, 0.721955474382226, -95.857780456543, -1.67303388262055, 218, 16, 'PPL', 'P'),
(119266, 'Crescent', 40.5472183227539, 0.707682462257028, -89.6655578613281, -1.56495921031766, 218, 18, 'PPL', 'P'),
(148108, 'Crescent', 42.8241691589355, 0.747422751254436, -73.7333297729492, -1.28688937299673, 218, 40, 'PPL', 'P'),
(154893, 'Crescent', 40.1199989318848, 0.700226077257997, -80.8597183227539, -1.41126831696724, 218, 41, 'PPL', 'P'),
(173687, 'Crescent', 45.0677795410156, 0.786581139553661, -91.1466674804688, -1.59080944975462, 218, 57, 'PPL', 'P'),
(186590, 'Crescent', 39.9283294677734, 0.696880814033722, -105.342216491699, -1.83856851912882, 218, 7, 'PPL', 'P'),
(194794, 'Crescent', 46.6433296203613, 0.814079675968302, -116.424438476563, -2.03198978120159, 218, 17, 'PPL', 'P'),
(200643, 'Crescent', 43.4625015258789, 0.758563752779646, -121.694442749023, -2.1239687073502, 218, 43, 'PPL', 'P'),
(203630, 'Crescent', 40.5513916015625, 0.707755299712842, -111.890281677246, -1.95285381625183, 218, 52, 'PPL', 'P'),
(207138, 'Crescent', 48.0947189331055, 0.839411198203945, -123.80583190918, -2.16081939998584, 218, 56, 'PPL', 'P'),
(190083, 'Crescent (historical)', 35.4897193908691, 0.619412453979543, -115.178062438965, -2.01023641562755, 218, 39, 'PPL', 'P'),
(15665, 'Crescent Beach', 29.7686100006104, 0.519560258252762, -81.2538909912109, -1.41814792785319, 218, 12, 'PPL', 'P'),
(80554, 'Crescent Beach', 33.8074989318848, 0.590052168225855, -78.7011108398438, -1.37359350913227, 218, 48, 'PPL', 'P'),
(113042, 'Crescent Beach', 41.314998626709, 0.721082756493007, -72.2024993896484, -1.26017134251856, 218, 8, 'PPL', 'P'),
(124599, 'Crescent Beach', 42.4055595397949, 0.740116635119913, -70.9916687011719, -1.23903836032046, 218, 23, 'PPL', 'P'),
(127175, 'Crescent Beach', 44.0680618286133, 0.769132773881735, -69.0691680908203, -1.20548439479822, 218, 26, 'PPL', 'P'),
(134848, 'Crescent Beach', 44.9144401550293, 0.783904862395214, -93.5983276367188, -1.63359899162115, 218, 28, 'PPL', 'P'),
(148109, 'Crescent Beach', 43.2836112976074, 0.755441529296665, -77.6627807617188, -1.3554712305465, 218, 40, 'PPL', 'P'),
(115150, 'Crescent Beach Resort', 43.3661117553711, 0.756881433919043, -95.1699981689453, -1.66102981716507, 218, 16, 'PPL', 'P'),
(93532, 'Crescent Center', 27.8794403076172, 0.486588026981141, -97.3219375610352, -1.6985882448604, 218, 51, 'PPL', 'P'),
(15666, 'Crescent City', 29.4300003051758, 0.513650404188253, -81.5108337402344, -1.42263242481277, 218, 12, 'PPL', 'P'),
(119267, 'Crescent City', 40.7700004577637, 0.711570744027571, -87.85888671875, -1.5334268503789, 218, 18, 'PPL', 'P'),
(193473, 'Crescent City', 41.7561111450195, 0.72878162230929, -124.200561523438, -2.16770873140977, 218, 6, 'PPL', 'P'),
(196303, 'Crescent City (historical)', 47.0708312988281, 0.82154098781535, -114.813888549805, -2.00388038221191, 218, 31, 'PPL', 'P'),
(15667, 'Crescent City Station', 29.4150009155273, 0.513388615453099, -81.533332824707, -1.42302510791551, 218, 12, 'PPL', 'P'),
(173688, 'Crescent Corner', 45.5699996948242, 0.795346534807494, -89.4891662597656, -1.56188059609753, 218, 57, 'PPL', 'P'),
(203631, 'Crescent Estates', 40.5563888549805, 0.707842518238542, -111.876937866211, -1.9526209228145, 218, 52, 'PPL', 'P'),
(113044, 'Crescent Grove (historical)', 42.024169921875, 0.733460130554287, -72.5250015258789, -1.2658000666405, 218, 8, 'PPL', 'P'),
(1869, 'Crescent Heights', 33.4386100769043, 0.583613843132534, -86.9158325195313, -1.51696744957778, 218, 2, 'PPL', 'P'),
(70703, 'Crescent Heights', 39.9686088562012, 0.697583821982475, -74.7169418334961, -1.3040566420156, 218, 37, 'PPL', 'P'),
(93533, 'Crescent Heights', 32.1866683959961, 0.561763338757734, -95.9430618286133, -1.67452232335379, 218, 51, 'PPL', 'P'),
(101172, 'Crescent Heights', 37.2077789306641, 0.649398249694263, -79.9936065673828, -1.39615181514579, 218, 53, 'PPL', 'P'),
(160531, 'Crescent Heights', 40.0552787780762, 0.69909649748164, -79.9375, -1.39517257081297, 218, 45, 'PPL', 'P'),
(54254, 'Crescent Hill', 38.4322204589844, 0.670768785861604, -94.3472213745117, -1.6466696530932, 218, 29, 'PPL', 'P'),
(101173, 'Crescent Hills', 38.9047203063965, 0.679015463914116, -77.146110534668, -1.34645363393744, 218, 53, 'PPL', 'P'),
(160532, 'Crescent Hills', 40.4708290100098, 0.706349217236308, -79.8249969482422, -1.39320902214125, 218, 45, 'PPL', 'P'),
(192532, 'Crescent Junction', 38.9430618286133, 0.679684649717025, -109.816673278809, -1.91666252230209, 218, 52, 'PPL', 'P'),
(54255, 'Crescent Lake', 39.3255615234375, 0.686360528779582, -94.2402801513672, -1.64480317664322, 218, 29, 'PPL', 'P'),
(127176, 'Crescent Lake', 43.9861106872559, 0.76770245663928, -70.4775009155273, -1.23006443955327, 218, 26, 'PPL', 'P'),
(143677, 'Crescent Lake', 43.2661094665527, 0.755136064719633, -72.2561111450195, -1.26110704416756, 218, 36, 'PPL', 'P'),
(160533, 'Crescent Lake', 41.0747184753418, 0.71688907672446, -75.383056640625, -1.31568253859628, 218, 45, 'PPL', 'P'),
(39941, 'Crescent Landing', 31.8597202301025, 0.556057016779535, -91.5697174072266, -1.59819306387687, 218, 22, 'PPL', 'P'),
(124600, 'Crescent Mills', 42.2194404602051, 0.736868244380289, -72.8605575561523, -1.27165662419369, 218, 23, 'PPL', 'P'),
(193474, 'Crescent Mills', 40.0966682434082, 0.699818879927324, -120.909721374512, -2.11027273565419, 218, 6, 'PPL', 'P'),
(20358, 'Crescent Oak', 33.360279083252, 0.582246709386942, -84.5347213745117, -1.47540922024126, 218, 13, 'PPL', 'P'),
(35423, 'Crescent Park', 39.0433311462402, 0.681434679448344, -84.5741729736328, -1.4760977805411, 218, 21, 'PPL', 'P'),
(101174, 'Crescent Park', 37.4013900756836, 0.65277740164341, -77.4375, -1.35153933951311, 218, 53, 'PPL', 'P'),
(113045, 'Crescent Park', 41.3102798461914, 0.721000398236297, -72.20361328125, -1.26019078359452, 218, 8, 'PPL', 'P'),
(148110, 'Crescent Park', 42.9605598449707, 0.749803217794804, -74.1619415283203, -1.29437005934071, 218, 40, 'PPL', 'P'),
(180941, 'Crescent Ridge Village', 38.6533317565918, 0.67462790601821, -121.077781677246, -2.11320594127881, 218, 6, 'PPL', 'P'),
(35424, 'Crescent Springs', 39.0513916015625, 0.681575360932927, -84.581672668457, -1.47622867490867, 218, 21, 'PPL', 'P'),
(75572, 'Crescent Springs', 35.8963890075684, 0.626510177758768, -97.6022186279297, -1.70348007230872, 218, 42, 'PPL', 'P'),
(148111, 'Crescent Station', 42.7983283996582, 0.746971744923831, -73.7341690063477, -1.28690402038272, 218, 40, 'PPL', 'P'),
(199900, 'Crescent Valley', 40.4161109924316, 0.705394207669405, -116.575561523438, -2.0346273759452, 218, 39, 'PPL', 'P'),
(86096, 'Crescent View', 35.1527786254883, 0.613531728239457, -87.023063659668, -1.51883898603383, 218, 50, 'PPL', 'P'),
(186591, 'Crescent Village', 39.9197196960449, 0.696730545169214, -105.360557556152, -1.83888863109185, 218, 7, 'PPL', 'P'),
(72238, 'Crescentville', 39.3005599975586, 0.685924169834972, -84.4472198486328, -1.47388203051415, 218, 41, 'PPL', 'P'),
(160535, 'Crescentville', 40.0444412231445, 0.698907346465217, -75.1013870239258, -1.31076647638205, 218, 45, 'PPL', 'P'),
(154895, 'Cresceus Farms', 41.5847206115723, 0.725790293193886, -83.4402770996094, -1.45630756416461, 218, 41, 'PPL', 'P'),
(115152, 'Cresco', 43.3813896179199, 0.757148082923187, -92.1138916015625, -1.60769069527242, 218, 16, 'PPL', 'P'),
(122444, 'Cresco', 41.2358283996582, 0.71970097536142, -85.4916687011719, -1.49211110185963, 218, 19, 'PPL', 'P'),
(160536, 'Cresco', 41.1538887023926, 0.718270857856047, -75.2808303833008, -1.31389835382398, 218, 45, 'PPL', 'P'),
(160537, 'Creslo', 40.3330612182617, 0.703944715667102, -78.7594375610352, -1.37461150245896, 218, 45, 'PPL', 'P'),
(86097, 'Creson', 35.1686096191406, 0.613808031202553, -86.5513916015625, -1.51060675563023, 218, 50, 'PPL', 'P'),
(78088, 'Cress', 39.7355613708496, 0.693516376049597, -77.5647201538086, -1.35375975007196, 218, 45, 'PPL', 'P'),
(39942, 'Cress (historical)', 30.0033302307129, 0.52365689908909, -90.6994400024414, -1.58300385775766, 218, 22, 'PPL', 'P'),
(130367, 'Cressey', 42.4280586242676, 0.740509318222645, -85.4713897705078, -1.49175716775076, 218, 27, 'PPL', 'P'),
(180942, 'Cressey', 37.4197196960449, 0.653097313869356, -120.666389465332, -2.10602579266384, 218, 6, 'PPL', 'P'),
(190085, 'Cressid', 39.9297218322754, 0.696905115378669, -118.711112976074, -2.07189978013946, 218, 39, 'PPL', 'P'),
(145062, 'Cresskill', 40.9413909912109, 0.714562073142976, -73.959716796875, -1.29084057194802, 218, 37, 'PPL', 'P'),
(35425, 'Cressmont', 37.5308303833008, 0.655036561196124, -83.7949981689453, -1.46249861475072, 218, 21, 'PPL', 'P'),
(108735, 'Cressmont', 38.4563903808594, 0.671190630578272, -80.9780578613281, -1.41333373155065, 218, 58, 'PPL', 'P'),
(112625, 'Cresson', 32.5325012207031, 0.567799260210344, -97.6175003051758, -1.70374678789189, 218, 51, 'PPL', 'P'),
(134849, 'Cresson', 44.1111106872559, 0.769884118204273, -96.4349975585938, -1.68310822155015, 218, 28, 'PPL', 'P'),
(160538, 'Cresson', 40.4597206115723, 0.70615533910895, -78.5919418334961, -1.37168815053038, 218, 45, 'PPL', 'P'),
(160541, 'Cressona', 40.6266708374023, 0.709069170236633, -76.1930618286133, -1.32981979608491, 218, 45, 'PPL', 'P'),
(46081, 'Cresston Park', 39.0583305358887, 0.681696468183499, -76.5194396972656, -1.33551616449854, 218, 25, 'PPL', 'P'),
(35426, 'Cressy', 37.8247184753418, 0.660165876034644, -84.040283203125, -1.46677964620302, 218, 21, 'PPL', 'P'),
(1886, 'Crest', 33.4361114501953, 0.583570233869684, -86.8300018310547, -1.51546942146461, 218, 2, 'PPL', 'P'),
(8293, 'Crest', 36.4833297729492, 0.636754226628839, -93.2052764892578, -1.62673895496921, 218, 4, 'PPL', 'P'),
(20360, 'Crest', 32.9319381713867, 0.574770750153899, -84.4447174072266, -1.47383835467227, 218, 13, 'PPL', 'P'),
(35427, 'Crest', 37.75, 0.658861792627859, -85.8436126708984, -1.4982536829139, 218, 21, 'PPL', 'P'),
(54256, 'Crest', 38.4502792358398, 0.671083970976615, -93.1347198486328, -1.62550750928116, 218, 29, 'PPL', 'P'),
(193475, 'Crest', 40.7247200012207, 0.71078045097409, -120.369171142578, -2.10083835433453, 218, 6, 'PPL', 'P'),
(46082, 'Crest Acres', 39.314998626709, 0.686176171453121, -76.9305572509766, -1.34269151942354, 218, 25, 'PPL', 'P'),
(101175, 'Crest Hill', 37.2380599975586, 0.649926754012589, -80.0199966430664, -1.39661240885632, 218, 53, 'PPL', 'P'),
(119269, 'Crest Hill', 41.5547218322754, 0.725266715723576, -88.0986099243164, -1.53761080960947, 218, 18, 'PPL', 'P'),
(122445, 'Crest Manor Addition', 41.6163902282715, 0.726343032278132, -86.2333297729492, -1.50505552949602, 218, 19, 'PPL', 'P'),
(46083, 'Crest Manor Estates', 39.4277801513672, 0.688144580393826, -77.5094375610352, -1.35279488680903, 218, 25, 'PPL', 'P'),
(180944, 'Crest Park', 34.2338905334473, 0.597494105575973, -117.195556640625, -2.04544833208641, 218, 6, 'PPL', 'P'),
(46084, 'Crest Valley', 39.6022186279297, 0.691189106152004, -77.6069412231445, -1.35449664674559, 218, 25, 'PPL', 'P'),
(86098, 'Crest View', 36.5194396972656, 0.637384463700806, -82.1986083984375, -1.4346363571102, 218, 50, 'PPL', 'P'),
(160543, 'Crest View', 40.2024993896484, 0.701665981880376, -76.6930618286133, -1.33854644234489, 218, 45, 'PPL', 'P'),
(148112, 'Crest View Heights', 42.0716705322266, 0.734289172601629, -76.1175003051758, -1.32850099871311, 218, 40, 'PPL', 'P'),
(180945, 'Cresta', 39.8436088562012, 0.695402160417482, -121.403327941895, -2.11888779546449, 218, 6, 'PPL', 'P'),
(80555, 'Crestdale', 33.5013885498047, 0.58470953418402, -81.9124984741211, -1.42964279690824, 218, 48, 'PPL', 'P'),
(186592, 'Crested Butte', 38.8697204589844, 0.678404601339079, -106.98722076416, -1.86727925989264, 218, 7, 'PPL', 'P'),
(13615, 'Crestfield', 39.8208312988281, 0.695004617045761, -75.4974975585938, -1.31767990941384, 218, 10, 'PPL', 'P'),
(86099, 'Crestfield', 35.1744384765625, 0.613909763956194, -85.2186126708984, -1.48734537508894, 218, 50, 'PPL', 'P'),
(15668, 'Cresthaven', 26.2688903808594, 0.458478627991463, -80.107780456543, -1.39814452543144, 218, 12, 'PPL', 'P'),
(46085, 'Cresthaven', 39.0250015258789, 0.681114767222398, -76.9913864135742, -1.3437531885921, 218, 25, 'PPL', 'P'),
(20362, 'Cresthill', 31.9897193908691, 0.558325930159741, -81.0875015258789, -1.41524388384251, 218, 13, 'PPL', 'P'),
(101176, 'Cresthill', 38.7675018310547, 0.676620549724835, -78.0086135864258, -1.36150715199911, 218, 53, 'PPL', 'P'),
(122446, 'Crestlawn', 40.0747184753418, 0.699435784204516, -85.6802825927734, -1.49540303528308, 218, 19, 'PPL', 'P'),
(46086, 'Crestleigh', 39.2602806091309, 0.685221161886218, -76.8272171020508, -1.34088789357528, 218, 25, 'PPL', 'P'),
(32179, 'Crestline', 37.1708297729492, 0.6487533652363, -94.7041702270508, -1.65289958583122, 218, 20, 'PPL', 'P'),
(154896, 'Crestline', 40.7874984741211, 0.711876142025576, -82.7366714477539, -1.44402732890409, 218, 41, 'PPL', 'P'),
(180946, 'Crestline', 34.2419395446777, 0.597634587323474, -117.284721374512, -2.0470045502694, 218, 6, 'PPL', 'P'),
(190086, 'Crestline', 37.6636085510254, 0.657353977397684, -114.125282287598, -1.99186193568655, 218, 39, 'PPL', 'P'),
(1873, 'Crestline Gardens', 33.5208282470703, 0.585048820906896, -86.7227783203125, -1.51359801816661, 218, 2, 'PPL', 'P'),
(1874, 'Crestline Heights', 33.5066719055176, 0.584801746136764, -86.7527770996094, -1.51412159563692, 218, 2, 'PPL', 'P'),
(1875, 'Crestline Park', 33.5136108398438, 0.584922853387336, -86.73388671875, -1.51379189629397, 218, 2, 'PPL', 'P'),
(78089, 'Crestlyn Court', 39.9150009155273, 0.696648186912503, -76.6811065673828, -1.33833778367348, 218, 45, 'PPL', 'P'),
(64028, 'Crestmont', 35.752498626709, 0.623998816850823, -83.1102828979492, -1.45054807883315, 218, 33, 'PPL', 'P'),
(160546, 'Crestmont', 41.413890838623, 0.722808751195488, -76.5741729736328, -1.33647144038155, 218, 45, 'PPL', 'P'),
(160547, 'Crestmont Farms', 40.0733299255371, 0.699411549438597, -74.9783325195313, -1.30861877012096, 218, 45, 'PPL', 'P'),
(64029, 'Crestmont Heights', 35.313060760498, 0.616329179227504, -81.539436340332, -1.42313163435911, 218, 33, 'PPL', 'P'),
(160548, 'Crestmont Village', 40.5922203063965, 0.70846789504152, -80.2716674804688, -1.40100489360024, 218, 45, 'PPL', 'P'),
(29576, 'Crestmoor', 39.5138893127441, 0.689647468775985, -85.7638931274414, -1.49686231440239, 218, 19, 'PPL', 'P'),
(35428, 'Crestmoor', 36.9716682434082, 0.645277340802501, -86.4683303833008, -1.50915706389085, 218, 21, 'PPL', 'P'),
(101177, 'Crestmoor', 37.2574996948242, 0.650266040735465, -80.0261077880859, -1.39671906845798, 218, 53, 'PPL', 'P'),
(101178, 'Crestmoor Court', 37.2597198486328, 0.650304789729326, -80.0263900756836, -1.39672399530599, 218, 53, 'PPL', 'P'),
(145065, 'Crestmoore', 40.7483291625977, 0.711192508573753, -74.8269424438477, -1.30597651484543, 218, 37, 'PPL', 'P'),
(180948, 'Crestmore', 34.0444412231445, 0.594187591345558, -117.395278930664, -2.04893414363722, 218, 6, 'PPL', 'P'),
(35429, 'Creston', 37.2666702270508, 0.650426096716979, -85.0422210693359, -1.4842667608688, 218, 21, 'PPL', 'P'),
(39943, 'Creston', 31.975830078125, 0.558083515921517, -93.0497207641602, -1.62402399539593, 218, 22, 'PPL', 'P'),
(64030, 'Creston', 36.4277801513672, 0.635784702833996, -81.623893737793, -1.42460569402247, 218, 33, 'PPL', 'P'),
(80558, 'Creston', 33.5972213745117, 0.586382132506644, -80.6477813720703, -1.40756931937118, 218, 48, 'PPL', 'P'),
(86100, 'Creston', 36.0086097717285, 0.628468799582466, -85.0752792358398, -1.48484373471897, 218, 50, 'PPL', 'P'),
(108736, 'Creston', 38.9469413757324, 0.679752360587741, -81.271110534668, -1.41844846558221, 218, 58, 'PPL', 'P'),
(115154, 'Creston', 41.0586090087891, 0.716607913492375, -94.3611068725586, -1.6469120007524, 218, 16, 'PPL', 'P'),
(119270, 'Creston', 41.9308280944824, 0.731831008336458, -88.9644393920898, -1.55272238458291, 218, 18, 'PPL', 'P'),
(122448, 'Creston', 41.3377799987793, 0.721480366443756, -87.4313888549805, -1.52596560511088, 218, 19, 'PPL', 'P'),
(141580, 'Creston', 41.7066688537598, 0.727918691537077, -97.3622207641602, -1.69929131938818, 218, 35, 'PPL', 'P'),
(145066, 'Creston', 40.2313919067383, 0.702170251432782, -74.6933288574219, -1.30364451783691, 218, 37, 'PPL', 'P'),
(154897, 'Creston', 40.9869384765625, 0.715357026728364, -81.8938903808594, -1.42931802441331, 218, 41, 'PPL', 'P'),
(180950, 'Creston', 35.5188903808594, 0.619921583800939, -120.52278137207, -2.10351935860392, 218, 6, 'PPL', 'P'),
(196304, 'Creston', 48.1894416809082, 0.841064422029639, -114.136390686035, -1.9920558138139, 218, 31, 'PPL', 'P'),
(200644, 'Creston', 43.5013885498047, 0.759242459383453, -118.008888244629, -2.05964364648681, 218, 43, 'PPL', 'P'),
(202035, 'Creston', 43.9105606079102, 0.766383859004555, -102.698333740234, -1.79242406007907, 218, 49, 'PPL', 'P'),
(207139, 'Creston', 47.7586097717285, 0.8335449866918, -118.518608093262, -2.06853993610822, 218, 56, 'PPL', 'P'),
(209389, 'Creston', 41.7038917541504, 0.727870222005238, -107.75611114502, -1.88069892862555, 218, 59, 'PPL', 'P'),
(108737, 'Creston Flats', 38.9444389343262, 0.679708684745863, -81.2399978637695, -1.41790544703594, 218, 58, 'PPL', 'P'),
(209391, 'Creston Junction', 41.7269401550293, 0.728272492487894, -107.726669311523, -1.88018507169322, 218, 59, 'PPL', 'P'),
(186593, 'Crestone', 37.9963912963867, 0.663162131998065, -105.699172973633, -1.8447985850249, 218, 7, 'PPL', 'P'),
(15669, 'Crestview', 30.7619400024414, 0.536897137343555, -86.570556640625, -1.51094124866315, 218, 12, 'PPL', 'P'),
(20363, 'Crestview', 31.3327808380127, 0.54686018942911, -84.6194381713867, -1.47688780727847, 218, 13, 'PPL', 'P'),
(35430, 'Crestview', 39.0252799987793, 0.681119627491387, -84.4175033569336, -1.47336337989186, 218, 21, 'PPL', 'P'),
(46089, 'Crestview', 38.9527816772461, 0.679854293078463, -77.0999984741211, -1.34564882665602, 218, 25, 'PPL', 'P'),
(80560, 'Crestview', 34.2338905334473, 0.597494105575973, -82.1413879394531, -1.43363767170142, 218, 48, 'PPL', 'P'),
(86101, 'Crestview', 35.4366683959961, 0.61848653944755, -87.2958297729492, -1.52359965279846, 218, 50, 'PPL', 'P'),
(101179, 'Crestview', 37.6011085510254, 0.656263146615187, -77.5280609130859, -1.35311992562007, 218, 53, 'PPL', 'P'),
(122449, 'Crestview', 41.4519386291504, 0.723472810413299, -87.0580596923828, -1.51944978202984, 218, 19, 'PPL', 'P'),
(145067, 'Crestview', 40.7449989318848, 0.711134385082962, -74.408332824707, -1.29867039871091, 218, 37, 'PPL', 'P'),
(148113, 'Crestview', 42.0972213745117, 0.734735118926162, -78.4872207641602, -1.36986042307425, 218, 40, 'PPL', 'P'),
(160549, 'Crestview', 40.1813888549805, 0.701297533543564, -79.8636093139648, -1.3938829350551, 218, 45, 'PPL', 'P'),
(173692, 'Crestview', 42.5416717529297, 0.742492241391291, -89.0311126708984, -1.55388605282122, 218, 57, 'PPL', 'P'),
(178041, 'Crestview', 33.3030586242676, 0.581248023978162, -111.941673278809, -1.95375076890697, 218, 5, 'PPL', 'P'),
(180951, 'Crestview', 37.752498626709, 0.658905401890709, -118.983329772949, -2.07665085952416, 218, 6, 'PPL', 'P'),
(203638, 'Crestview', 40.6536102294922, 0.709539351327086, -112.031387329102, -1.95531657446988, 218, 52, 'PPL', 'P'),
(211433, 'Crestview', 21.4088897705078, 0.373655615691895, -157.999435424805, -2.75761036445501, 218, 15, 'PPL', 'P'),
(64033, 'Crestview Acres', 35.0213890075684, 0.611238546803817, -80.5427780151367, -1.40573666506704, 218, 33, 'PPL', 'P'),
(1879, 'Crestview Estates', 33.7311096191406, 0.588718923205134, -87.019172668457, -1.51877107542604, 218, 2, 'PPL', 'P'),
(203639, 'Crestview Estates', 40.6155586242676, 0.708875225530248, -111.834716796875, -1.95188402614088, 218, 52, 'PPL', 'P'),
(1881, 'Crestview Gardens', 33.5941696166992, 0.586328869284843, -86.269172668457, -1.50568110603608, 218, 2, 'PPL', 'P'),
(29577, 'Crestview Heights', 39.5849990844727, 0.690888568422989, -86.3163909912109, -1.5065052212354, 218, 19, 'PPL', 'P'),
(1882, 'Crestview Hills', 33.5233306884766, 0.585092496748774, -86.73388671875, -1.51379189629397, 218, 2, 'PPL', 'P'),
(35431, 'Crestview Hills', 39.0272216796875, 0.681153516216259, -84.5849990844727, -1.47628673182044, 218, 21, 'PPL', 'P'),
(80562, 'Crestview Hills', 34.9694404602051, 0.6103318736107, -82.2188873291016, -1.43499029121907, 218, 48, 'PPL', 'P'),
(160550, 'Crestview Manor', 40.2750015258789, 0.702931382872327, -76.745002746582, -1.33945298237995, 218, 45, 'PPL', 'P'),
(46091, 'Crestview Meadows', 39.6144409179688, 0.69140242535532, -76.8391723632813, -1.34109655224669, 218, 25, 'PPL', 'P'),
(115156, 'Crestview Mobile Home Park', 42.023609161377, 0.733450343437281, -93.6949996948242, -1.63528623732977, 218, 16, 'PPL', 'P'),
(78090, 'Crestview Terrace', 39.9111099243164, 0.696580276304706, -76.6772232055664, -1.33827000622373, 218, 45, 'PPL', 'P'),
(20365, 'Crestwicke', 33.8827781677246, 0.591366038749646, -84.3547210693359, -1.47226762226134, 218, 13, 'PPL', 'P'),
(13069, 'Crestwood', 38.9416694641113, 0.679660348372078, -77.0408325195313, -1.34461618594334, 218, 9, 'PPL', 'P'),
(20366, 'Crestwood', 31.4675006866455, 0.549211494355541, -83.9875030517578, -1.46585845878196, 218, 13, 'PPL', 'P'),
(35433, 'Crestwood', 38.3241691589355, 0.668882934914691, -85.4725036621094, -1.49177660882672, 218, 21, 'PPL', 'P'),
(46094, 'Crestwood', 38.3591690063477, 0.669493797489728, -75.5508270263672, -1.31861068421482, 218, 25, 'PPL', 'P'),
(54257, 'Crestwood', 38.5569381713867, 0.67294552057858, -90.3816680908203, -1.57745769162951, 218, 29, 'PPL', 'P'),
(64035, 'Crestwood', 35.3675003051758, 0.617279328525417, -82.5202789306641, -1.44025056700419, 218, 33, 'PPL', 'P'),
(80563, 'Crestwood', 32.9716682434082, 0.575464170722728, -80.20361328125, -1.39981712375407, 218, 48, 'PPL', 'P'),
(86103, 'Crestwood', 35.8419418334961, 0.6255598953028, -86.5377807617188, -1.510369201661, 218, 50, 'PPL', 'P'),
(101181, 'Crestwood', 37.230281829834, 0.649790999376022, -80.0136108398438, -1.3965009555647, 218, 53, 'PPL', 'P'),
(115157, 'Crestwood', 41.6061096191406, 0.726163601799688, -93.7127838134766, -1.63559662875481, 218, 16, 'PPL', 'P'),
(119271, 'Crestwood', 41.6611099243164, 0.727123538214607, -87.7525024414063, -1.5315700944669, 218, 18, 'PPL', 'P'),
(122450, 'Crestwood', 41.1399993896484, 0.718028443617823, -85.1230621337891, -1.48567770361433, 218, 19, 'PPL', 'P'),
(148114, 'Crestwood', 40.9599990844727, 0.714886845637911, -73.8247222900391, -1.28848447333163, 218, 40, 'PPL', 'P'),
(160551, 'Crestwood', 41.3547210693359, 0.721776043903782, -75.565559387207, -1.31886781241807, 218, 45, 'PPL', 'P'),
(203640, 'Crestwood', 40.6549987792969, 0.709563586093006, -111.843330383301, -1.95203436158441, 218, 52, 'PPL', 'P'),
(46095, 'Crestwood Acres', 39.4388885498047, 0.688338458521183, -76.2552795410156, -1.33090570001939, 218, 25, 'PPL', 'P'),
(72239, 'Crestwood Acres', 39.2324981689453, 0.684736266830742, -84.6050033569336, -1.47663587223935, 218, 41, 'PPL', 'P'),
(119272, 'Crestwood Acres', 41.9324989318848, 0.731860169950395, -89.1494369506836, -1.55595120108852, 218, 18, 'PPL', 'P'),
(78091, 'Crestwood East', 39.9861106872559, 0.697889286559507, -76.6216735839844, -1.33730048242889, 218, 45, 'PPL', 'P'),
(20368, 'Crestwood Estates', 32.6369400024414, 0.569622060818449, -83.6733322143555, -1.46037514325554, 218, 13, 'PPL', 'P'),
(101182, 'Crestwood Farms', 37.5230598449707, 0.654900939717612, -77.5430603027344, -1.35338171435523, 218, 53, 'PPL', 'P'),
(148115, 'Crestwood Gardens', 40.9680595397949, 0.715027527122494, -73.8208312988281, -1.28841656272383, 218, 40, 'PPL', 'P'),
(39944, 'Crestwood Heights', 32.5675010681152, 0.568410122785381, -93.5725021362305, -1.63314825160665, 218, 22, 'PPL', 'P'),
(86104, 'Crestwood Hills', 35.9286117553711, 0.627072570801965, -84.0755615234375, -1.46739536904704, 218, 50, 'PPL', 'P'),
(101184, 'Crestwood Manor', 38.8252792358398, 0.677628955671593, -77.1900024414063, -1.347219692225, 218, 53, 'PPL', 'P'),
(46096, 'Crestwood Mobile Homes', 39.1436080932617, 0.683184842337717, -76.6836090087891, -1.33838145951535, 218, 25, 'PPL', 'P'),
(46097, 'Crestwood Village', 39.3894386291504, 0.687475394590916, -77.4300003051758, -1.35140844514553, 218, 25, 'PPL', 'P'),
(70705, 'Crestwood Village', 39.9480590820313, 0.697225160762669, -74.3611068725586, -1.29784615035353, 218, 37, 'PPL', 'P'),
(101185, 'Crestwood Village', 38.7797203063965, 0.676833802349123, -77.5149993896484, -1.35289195903076, 218, 53, 'PPL', 'P'),
(160552, 'Crestwyck', 40.1049995422363, 0.699964288522843, -75.3916702270508, -1.31583287403982, 218, 45, 'PPL', 'P'),
(1884, 'Creswell', 33.3291702270508, 0.581703757419702, -86.383056640625, -1.50766875631566, 218, 2, 'PPL', 'P'),
(8295, 'Creswell', 36.0908317565918, 0.629903843935856, -92.1241683959961, -1.60787005917184, 218, 4, 'PPL', 'P'),
(35434, 'Creswell', 37.2686080932617, 0.650459918862823, -87.9122161865234, -1.53435762517989, 218, 21, 'PPL', 'P'),
(46098, 'Creswell', 39.5074996948242, 0.689535948905338, -76.2702789306641, -1.33116748875455, 218, 25, 'PPL', 'P'),
(64036, 'Creswell', 35.8702812194824, 0.626054510896255, -76.3925018310547, -1.3333006807877, 218, 33, 'PPL', 'P'),
(78092, 'Creswell', 39.9619407653809, 0.697467441842839, -76.4347229003906, -1.33403757746133, 218, 45, 'PPL', 'P'),
(101186, 'Creswell', 36.8219413757324, 0.642664113982861, -82.2088928222656, -1.43481585416767, 218, 53, 'PPL', 'P'),
(115158, 'Creswell', 41.4208297729492, 0.722929858446059, -92.024169921875, -1.60612475655145, 218, 16, 'PPL', 'P'),
(130368, 'Creswell', 45.0194396972656, 0.785737450120324, -85.3525009155273, -1.48968216578743, 218, 27, 'PPL', 'P'),
(200645, 'Creswell', 43.9180603027344, 0.766514753372132, -123.023330688477, -2.1471621772837, 218, 43, 'PPL', 'P'),
(207140, 'Creswell Heights', 45.689998626709, 0.797440911267759, -122.33528137207, -2.13515345129631, 218, 56, 'PPL', 'P'),
(75575, 'Creta', 34.5166702270508, 0.602429542287135, -99.5494384765625, -1.73746546992754, 218, 42, 'PPL', 'P'),
(54258, 'Cretcher', 39.0313911437988, 0.681226287093045, -93.3238906860352, -1.62880916324258, 218, 29, 'PPL', 'P'),
(119273, 'Crete', 41.4444389343262, 0.723341916045722, -87.6313934326172, -1.52945634350971, 218, 18, 'PPL', 'P'),
(122451, 'Crete', 40.0433311462402, 0.698887971968287, -84.8616714477539, -1.48111557550897, 218, 19, 'PPL', 'P'),
(139843, 'Crete', 46.2002792358398, 0.806346988006175, -97.9625015258789, -1.70976819511656, 218, 34, 'PPL', 'P'),
(160553, 'Crete', 40.5969390869141, 0.708550253298231, -79.2427825927734, -1.38304746468595, 218, 45, 'PPL', 'P'),
(199255, 'Crete', 40.4491691589355, 0.705971181519571, -101.854721069336, -1.77770024136035, 218, 35, 'PPL', 'P'),
(54259, 'Creve Coeur', 38.660831451416, 0.674758800385788, -90.4225006103516, -1.57817035353722, 218, 29, 'PPL', 'P'),
(119275, 'Creve Coeur', 40.6472206115723, 0.709427831456439, -89.5911102294922, -1.56365985402181, 218, 18, 'PPL', 'P'),
(59151, 'Crevi (historical)', 34.0458297729492, 0.594211826111477, -90.0486068725586, -1.57164467676014, 218, 30, 'PPL', 'P'),
(39946, 'Crew Lake', 32.4880599975586, 0.567023614542858, -91.8869400024414, -1.60372964262509, 218, 22, 'PPL', 'P'),
(101187, 'Crewe', 37.1730613708496, 0.648792313967243, -78.1236114501953, -1.36351424335465, 218, 53, 'PPL', 'P'),
(1885, 'Crews', 33.9130592346191, 0.591894543067972, -88.0805587768555, -1.53729575765252, 218, 2, 'PPL', 'P'),
(39947, 'Crews', 31.7177791595459, 0.553579677754516, -92.9277801513672, -1.62189573021079, 218, 22, 'PPL', 'P'),
(93534, 'Crews', 31.934850692749, 0.557368290721262, -99.7805099487305, -1.74149842792431, 218, 51, 'PPL', 'P'),
(20369, 'Crews Crossing', 31.1855602264404, 0.544290705030374, -82.5952835083008, -1.44155964383802, 218, 13, 'PPL', 'P'),
(1887, 'Crews Mobile Home Park', 33.7350006103516, 0.588786833812931, -87.0127792358398, -1.51865948897636, 218, 2, 'PPL', 'P'),
(86105, 'Crewstown', 35.1800003051758, 0.614006836177927, -87.4411087036133, -1.52613524847232, 218, 50, 'PPL', 'P'),
(1888, 'Crewsville', 32.9433288574219, 0.574969555129273, -86.1366729736328, -1.50336855010351, 218, 2, 'PPL', 'P'),
(15670, 'Crewsville', 27.4194393157959, 0.47855949511142, -81.5824966430664, -1.42388317841873, 218, 12, 'PPL', 'P'),
(80564, 'Cribb Crossroads', 33.6444396972656, 0.587206247705969, -79.2850036621094, -1.38378436135957, 218, 48, 'PPL', 'P'),
(64037, 'Cribb Town', 34.211109161377, 0.597096495625224, -78.7983322143555, -1.37529034222082, 218, 33, 'PPL', 'P'),
(148116, 'Cribbs Corner', 43.3772201538086, 0.757075312046401, -76.2699966430664, -1.33116256190653, 218, 40, 'PPL', 'P'),
(1889, 'Crichton', 30.7061100006104, 0.535922719990209, -88.1061096191406, -1.53774170397705, 218, 2, 'PPL', 'P'),
(39949, 'Crichton', 32.124439239502, 0.560677235086172, -93.4333267211914, -1.63071918237639, 218, 22, 'PPL', 'P'),
(108739, 'Crichton', 38.0561103820801, 0.664204426669695, -80.7163925170898, -1.40876680975533, 218, 58, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(80565, 'Crichton Parish', 32.9555587768555, 0.575183007490643, -80.1705627441406, -1.39924028306195, 218, 48, 'PPL', 'P'),
(8297, 'Cricket', 36.4488906860352, 0.636153151170808, -93.2022171020508, -1.62668555858935, 218, 4, 'PPL', 'P'),
(64038, 'Cricket', 36.1713905334473, 0.631309859833363, -81.1941680908203, -1.41710556660253, 218, 33, 'PPL', 'P'),
(115159, 'Cricket', 41.1838912963867, 0.718794501905384, -92.8069381713867, -1.6197866397855, 218, 16, 'PPL', 'P'),
(143678, 'Cricket Corner', 42.8419418334961, 0.747732942942403, -71.5961074829102, -1.24958780718853, 218, 36, 'PPL', 'P'),
(13616, 'Cricket Hill', 39.788890838623, 0.69444715085058, -75.7152786254883, -1.32148090607966, 218, 10, 'PPL', 'P'),
(20370, 'Cricket Hill', 33.9066696166992, 0.591783023197325, -84.0444412231445, -1.46685221734272, 218, 13, 'PPL', 'P'),
(101189, 'Cricket Hill', 37.4830589294434, 0.654202792037847, -76.3099975585938, -1.3318607095863, 218, 53, 'PPL', 'P'),
(108743, 'Crickmer', 37.8916702270508, 0.661334404541943, -80.9063873291016, -1.41208284478664, 218, 58, 'PPL', 'P'),
(35435, 'Crider', 37.1572189331055, 0.648515811267065, -87.9744415283203, -1.53544366227242, 218, 21, 'PPL', 'P'),
(54261, 'Crider', 36.7180595397949, 0.640851033912735, -92.0780563354492, -1.60706525189041, 218, 29, 'PPL', 'P'),
(101190, 'Criders', 38.7513885498047, 0.676339319913722, -79.0044403076172, -1.37888760706324, 218, 53, 'PPL', 'P'),
(160554, 'Criders Corners', 40.6858291625977, 0.710101677791256, -80.100830078125, -1.39802321844379, 218, 45, 'PPL', 'P'),
(154898, 'Cridersville', 40.6541709899902, 0.709549138444092, -84.1508331298828, -1.46870910641278, 218, 41, 'PPL', 'P'),
(127177, 'Criehaven', 43.8338890075684, 0.765045687135817, -68.8897171020508, -1.20235238419823, 218, 26, 'PPL', 'P'),
(86106, 'Crieve Hall', 36.0719413757324, 0.629574144592904, -86.7588882446289, -1.51422825523858, 218, 50, 'PPL', 'P'),
(101191, 'Criggers', 37.0547218322754, 0.646726899383832, -81.5430603027344, -1.423194884435, 218, 53, 'PPL', 'P'),
(8298, 'Crigler', 33.9588890075684, 0.592694423501377, -91.769172668457, -1.60167421489577, 218, 4, 'PPL', 'P'),
(101192, 'Criglersville', 38.4577789306641, 0.671214865344192, -78.3013916015625, -1.3666170923407, 218, 53, 'PPL', 'P'),
(194795, 'Crill Place', 42.8258285522461, 0.747451713131291, -116.452781677246, -2.03248446337407, 218, 17, 'PPL', 'P'),
(93535, 'Crimcrest', 32.1500015258789, 0.561123381147788, -94.8172225952148, -1.65487272188286, 218, 51, 'PPL', 'P'),
(39948, 'Crimea', 31.9769401550293, 0.558102890418447, -91.3363876342773, -1.59412069109597, 218, 22, 'PPL', 'P'),
(101193, 'Crimora', 38.1538887023926, 0.665910980296217, -78.8505630493164, -1.37620194226195, 218, 53, 'PPL', 'P'),
(93536, 'Crims Chapel (historical)', 32.2564582824707, 0.562981402061309, -94.7835464477539, -1.65428496223028, 218, 51, 'PPL', 'P'),
(64040, 'Crims Crossroads', 36.2200012207031, 0.632158276377635, -80.0880584716797, -1.39780031186055, 218, 33, 'PPL', 'P'),
(154899, 'Crimson', 40.7416687011719, 0.711076261592171, -82.3966674804688, -1.43809314020512, 218, 41, 'PPL', 'P'),
(209390, 'Crimson Dawn', 42.7336082458496, 0.745842165147474, -106.27889251709, -1.85491659979638, 218, 59, 'PPL', 'P'),
(108740, 'Crimson Springs', 37.5177803039551, 0.654808794343895, -80.4819412231445, -1.40467486274042, 218, 58, 'PPL', 'P'),
(154900, 'Crimville (historical)', 40.1313896179199, 0.700424882233372, -83.5833282470703, -1.45880427768656, 218, 41, 'PPL', 'P'),
(75576, 'Criner', 34.9713897705078, 0.610365895493626, -97.5641708374023, -1.7028160130909, 218, 42, 'PPL', 'P'),
(13617, 'Cripple Creek', 38.7669410705566, 0.676610762607829, -75.2399978637695, -1.31318569191628, 218, 10, 'PPL', 'P'),
(101194, 'Cripple Creek', 36.8208312988281, 0.642644739485931, -81.0986099243164, -1.41543776196987, 218, 53, 'PPL', 'P'),
(186594, 'Cripple Creek', 38.7466697692871, 0.676256961657012, -105.177780151367, -1.8356985635801, 218, 7, 'PPL', 'P'),
(32181, 'Crisfield', 37.1722183227539, 0.64877760000222, -98.3111114501953, -1.71585258610101, 218, 20, 'PPL', 'P'),
(46122, 'Crisfield', 37.9833297729492, 0.662934165408754, -75.8541717529297, -1.3239050484619, 218, 25, 'PPL', 'P'),
(46100, 'Crisfield Crossing', 39.4702796936035, 0.68888633733644, -76.3252792358398, -1.33212742516947, 218, 25, 'PPL', 'P'),
(122452, 'Crisman', 41.5869407653809, 0.725829042187747, -87.1738891601563, -1.52147138761332, 218, 19, 'PPL', 'P'),
(194152, 'Crisman', 40.040828704834, 0.69884429612641, -105.360832214355, -1.83889342478181, 218, 7, 'PPL', 'P'),
(26888, 'Crisp', 38.4394416809082, 0.670894819960192, -88.5955581665039, -1.54628419264764, 218, 18, 'PPL', 'P'),
(54262, 'Crisp', 37.5697212219238, 0.655715334378958, -93.7877807617188, -1.63690557243059, 218, 29, 'PPL', 'P'),
(64041, 'Crisp', 35.750560760498, 0.623964994704979, -77.6255569458008, -1.35482155239858, 218, 33, 'PPL', 'P'),
(93537, 'Crisp', 32.3977813720703, 0.565447955283913, -96.5808334350586, -1.685653537762, 218, 51, 'PPL', 'P'),
(115160, 'Crisp', 41.5783309936523, 0.725678773323239, -95.7083282470703, -1.67042544949087, 218, 16, 'PPL', 'P'),
(130369, 'Crisp', 42.8852806091309, 0.748489347271013, -86.0802764892578, -1.50238424576461, 218, 27, 'PPL', 'P'),
(188377, 'Crisp', 32.7380599975586, 0.571386937672844, -105.638893127441, -1.84374650323626, 218, 38, 'PPL', 'P'),
(86107, 'Crisp (historical)', 35.6611099243164, 0.622403783094947, -85.9944381713867, -1.50088608449339, 218, 50, 'PPL', 'P'),
(108741, 'Crisp (historical)', 39.3669395446777, 0.687082711488184, -81.1166687011719, -1.41575294708488, 218, 58, 'PPL', 'P'),
(86108, 'Crisp Spring', 35.6652793884277, 0.622476553971734, -85.878059387207, -1.49885489152999, 218, 50, 'PPL', 'P'),
(154901, 'Crissey', 41.610279083252, 0.726236372676474, -83.7619400024414, -1.46192164090055, 218, 41, 'PPL', 'P'),
(13618, 'Cristine Manor', 39.6888885498047, 0.692701781651169, -75.783332824707, -1.32266867592583, 218, 10, 'PPL', 'P'),
(29578, 'Critchfield', 39.6002807617188, 0.69115528400616, -86.163330078125, -1.50383380434594, 218, 19, 'PPL', 'P'),
(200646, 'Criterion (historical)', 45.0424995422363, 0.786139920340063, -120.996673583984, -2.11179033800137, 218, 43, 'PPL', 'P'),
(108742, 'Crites', 37.7983283996582, 0.659705282324115, -81.7622222900391, -1.42701998270868, 218, 58, 'PPL', 'P'),
(54263, 'Crites Corner', 36.9502792358398, 0.6449040321967, -90.8225021362305, -1.58515169717681, 218, 29, 'PPL', 'P'),
(54267, 'Critesville', 37.5152816772461, 0.654765185081045, -89.834716796875, -1.56791159070212, 218, 29, 'PPL', 'P'),
(8299, 'Crittenden', 35.2441711425781, 0.61512682857436, -90.4555587768555, -1.57874732738738, 218, 4, 'PPL', 'P'),
(35436, 'Crittenden', 38.7827796936035, 0.676887198728979, -84.6052780151367, -1.47664066592931, 218, 21, 'PPL', 'P'),
(101195, 'Crittenden', 36.9099998474121, 0.644201024247946, -76.4963912963867, -1.33511389401588, 218, 53, 'PPL', 'P'),
(148123, 'Crittenden', 43.1036109924316, 0.752299931316753, -77.64111328125, -1.35509306167171, 218, 40, 'PPL', 'P'),
(54264, 'Crittenden (historical)', 38.1827812194824, 0.666415249848624, -93.0133285522461, -1.62338883147594, 218, 29, 'PPL', 'P'),
(180952, 'Crittendon (historical)', 38.9955596923828, 0.680600910290067, -123.178886413574, -2.14987713685698, 218, 6, 'PPL', 'P'),
(101196, 'Critz', 36.6300010681152, 0.639314123647651, -80.1449966430664, -1.39879407042131, 218, 53, 'PPL', 'P'),
(112316, 'Critzer', 38.1399993896484, 0.665668566057993, -94.9124984741211, -1.65653559966751, 218, 20, 'PPL', 'P'),
(173693, 'Crivitz', 45.2324981689453, 0.789456021950402, -88.0074996948242, -1.53602063612259, 218, 57, 'PPL', 'P'),
(8301, 'Croak (historical)', 34.0013885498047, 0.593436180443992, -92.4113922119141, -1.61288306044975, 218, 4, 'PPL', 'P'),
(101197, 'Croaker', 37.396671295166, 0.652695043386699, -76.7536087036133, -1.33960318466543, 218, 53, 'PPL', 'P'),
(35438, 'Croakes', 37.776668548584, 0.659327246607378, -85.3322219848633, -1.48932823167856, 218, 21, 'PPL', 'P'),
(64042, 'Croatan', 34.9683303833008, 0.610312499113769, -76.9688873291016, -1.34336050548937, 218, 33, 'PPL', 'P'),
(64043, 'Croatan Shores', 36.0263900756836, 0.628779124428488, -75.6647186279297, -1.32059846765246, 218, 33, 'PPL', 'P'),
(46101, 'Crocheron', 38.2427787780762, 0.667462404789243, -76.0524978637695, -1.32736649208873, 218, 25, 'PPL', 'P'),
(1890, 'Crockard Junction', 33.5355606079102, 0.585305949110143, -86.9852828979492, -1.51817958734793, 218, 2, 'PPL', 'P'),
(8302, 'Crocker', 35.8827781677246, 0.626272623789533, -91.8613891601563, -1.60328369630056, 218, 4, 'PPL', 'P'),
(54265, 'Crocker', 37.9488906860352, 0.662333089950723, -92.2636108398438, -1.610303788934, 218, 29, 'PPL', 'P'),
(115161, 'Crocker', 41.7747192382813, 0.729106394804225, -93.6697235107422, -1.63484508469519, 218, 16, 'PPL', 'P'),
(122453, 'Crocker', 41.5880584716797, 0.725848549842732, -87.1222229003906, -1.52056964126822, 218, 19, 'PPL', 'P'),
(170101, 'Crocker', 45.105281829834, 0.787235677970576, -97.7844390869141, -1.70666041928249, 218, 49, 'PPL', 'P'),
(188379, 'Crocker', 33.3422203063965, 0.581931524271931, -107.029998779297, -1.86802587710424, 218, 38, 'PPL', 'P'),
(1891, 'Crocker Junction', 33.6674995422363, 0.587608717925708, -86.9105606079102, -1.51687543736212, 218, 2, 'PPL', 'P'),
(180953, 'Crocker Place', 39.5569381713867, 0.690398813098523, -123.053886413574, -2.14769547529199, 218, 6, 'PPL', 'P'),
(127179, 'Crocker Turn', 45.0119400024414, 0.785606555752747, -68.4669418334961, -1.19497356376595, 218, 26, 'PPL', 'P'),
(64045, 'Crockers Nub', 35.6966705322266, 0.62302443278699, -78.1808319091797, -1.36451292876343, 218, 33, 'PPL', 'P'),
(1892, 'Crockertown', 33.6708297729492, 0.587666841416499, -86.4097213745117, -1.50813414371615, 218, 2, 'PPL', 'P'),
(127180, 'Crockertown', 45.3950004577637, 0.792292221932309, -68.2972183227539, -1.19201132968545, 218, 26, 'PPL', 'P'),
(54266, 'Crockerville', 38.4427795410156, 0.670953076609037, -93.1041717529297, -1.62497434443092, 218, 29, 'PPL', 'P'),
(92, 'Crockett', 36.8861083984375, 0.643784039800267, -81.1922225952148, -1.41707161129863, 218, 53, 'PPL', 'P'),
(8307, 'Crockett', 36.3758316040039, 0.634878029640878, -90.3305587768555, -1.57656566582239, 218, 4, 'PPL', 'P'),
(35439, 'Crockett', 37.9855613708496, 0.662973114139697, -83.0908279418945, -1.45020852579416, 218, 21, 'PPL', 'P'),
(59152, 'Crockett', 34.6194381713867, 0.604223181281303, -90.0833282470703, -1.57225067906619, 218, 30, 'PPL', 'P'),
(86109, 'Crockett', 36.2980613708496, 0.633520683012292, -89.0427780151367, -1.55408965148656, 218, 50, 'PPL', 'P'),
(93538, 'Crockett', 31.3180599212646, 0.546603260962944, -95.4563903808594, -1.66602830421504, 218, 51, 'PPL', 'P'),
(112642, 'Crockett', 38.2313919067383, 0.667263666392896, -82.3777770996094, -1.43776344086217, 218, 58, 'PPL', 'P'),
(180954, 'Crockett', 38.0525016784668, 0.664141442909914, -122.211936950684, -2.13300068502915, 218, 6, 'PPL', 'P'),
(200647, 'Crockett', 45.9736099243164, 0.802390862206862, -118.396392822266, -2.06640687723312, 218, 43, 'PPL', 'P'),
(39950, 'Crockett (historical)', 32.0661087036133, 0.559659175180462, -92.8413925170898, -1.62038798155964, 218, 22, 'PPL', 'P'),
(127181, 'Crockett Corner', 43.8666687011719, 0.765617800716994, -70.2127838134766, -1.22544425453615, 218, 26, 'PPL', 'P'),
(143679, 'Crockett Corner', 43.399169921875, 0.757458407769209, -71.961669921875, -1.25596807537009, 218, 36, 'PPL', 'P'),
(191338, 'Crockett Heights', 30.7030601501465, 0.535869490057921, -101.114440917969, -1.76477991533183, 218, 51, 'PPL', 'P'),
(86113, 'Crockett Mills', 35.8675003051758, 0.626005974785388, -89.1691665649414, -1.55629554781747, 218, 50, 'PPL', 'P'),
(101198, 'Crockett Spring (historical)', 37.0941696166992, 0.647415393104644, -80.253059387207, -1.40068012110531, 218, 53, 'PPL', 'P'),
(101199, 'Crockett Town', 37.6802787780762, 0.657644927746775, -75.8122177124023, -1.32317281232018, 218, 53, 'PPL', 'P'),
(148118, 'Crocketts', 43.327220916748, 0.756202660736209, -76.6277770996094, -1.33740700887249, 218, 40, 'PPL', 'P'),
(8305, 'Crocketts Bluff', 34.4438896179199, 0.601159281026194, -91.2200012207031, -1.59208936497452, 218, 4, 'PPL', 'P'),
(127182, 'Crocketts Corner', 43.6300010681152, 0.761487171287254, -70.3122177124023, -1.2271797034605, 218, 26, 'PPL', 'P'),
(143680, 'Crocketts Crossing', 43.2405586242676, 0.754690118395099, -70.8488922119141, -1.23654644048847, 218, 36, 'PPL', 'P'),
(80569, 'Crocketts Crossroad', 34.6919403076172, 0.605488582273254, -80.7877807617188, -1.41001276967132, 218, 48, 'PPL', 'P'),
(35440, 'Crockettsville', 37.396671295166, 0.652695043386699, -83.4741668701172, -1.45689905224271, 218, 21, 'PPL', 'P'),
(86115, 'Crockettsville', 35.8452796936035, 0.625618151951646, -83.3852767944336, -1.45534762774969, 218, 50, 'PPL', 'P'),
(80566, 'Crocketville', 32.916389465332, 0.57449937403882, -81.0774993896484, -1.41506931363306, 218, 48, 'PPL', 'P'),
(35441, 'Crocus', 36.9805603027344, 0.645432536515026, -85.2108306884766, -1.48720955387334, 218, 21, 'PPL', 'P'),
(139844, 'Crocus', 48.7088890075684, 0.850130488170541, -99.1611099243164, -1.73068785811135, 218, 34, 'PPL', 'P'),
(198149, 'Croff', 47.7472190856934, 0.833346181716426, -102.940826416016, -1.79665635568343, 218, 34, 'PPL', 'P'),
(737, 'Croft', 35.3447189331055, 0.616881718574668, -80.8244400024414, -1.41065259412322, 218, 33, 'PPL', 'P'),
(32182, 'Croft', 37.5033302307129, 0.654556592988665, -98.9944381713867, -1.72777888725265, 218, 20, 'PPL', 'P'),
(80567, 'Croft', 33.6222190856934, 0.586818424872227, -81.7011108398438, -1.4259533866921, 218, 48, 'PPL', 'P'),
(119276, 'Croft', 40.0480613708496, 0.69897052996208, -89.5883331298828, -1.56361138448997, 218, 18, 'PPL', 'P'),
(160555, 'Croft', 41.0788917541504, 0.716961914180273, -78.334716796875, -1.36719872672277, 218, 45, 'PPL', 'P'),
(180955, 'Croft', 38.5816688537598, 0.673377152412254, -120.433609008789, -2.10196300726287, 218, 6, 'PPL', 'P'),
(20372, 'Crofton', 33.5038909912109, 0.584753210025897, -82.0708312988281, -1.43240622601337, 218, 13, 'PPL', 'P'),
(35442, 'Crofton', 37.047779083252, 0.646605725554233, -87.4850006103516, -1.52690130675988, 218, 21, 'PPL', 'P'),
(46103, 'Crofton', 38.7791709899902, 0.676824214969199, -76.0483322143555, -1.32729378779097, 218, 25, 'PPL', 'P'),
(101200, 'Crofton', 37.271671295166, 0.650513381821706, -79.8680572509766, -1.39396056620087, 218, 53, 'PPL', 'P'),
(130371, 'Crofton', 44.6733283996582, 0.779696668398725, -85.2366714477539, -1.48766056020395, 218, 27, 'PPL', 'P'),
(141585, 'Crofton', 42.728889465332, 0.745759806890763, -97.4952774047852, -1.70161359585873, 218, 35, 'PPL', 'P'),
(46104, 'Crofton Commons', 39.0111083984375, 0.680872286405146, -76.6766662597656, -1.33826028568576, 218, 25, 'PPL', 'P'),
(46105, 'Crofton Highlands', 39.014720916748, 0.680935336743954, -76.6675033569336, -1.3381003628623, 218, 25, 'PPL', 'P'),
(46106, 'Crofton Mews', 39.0275001525879, 0.681158376485248, -76.6791687011719, -1.33830396152763, 218, 25, 'PPL', 'P'),
(46107, 'Crofton Park', 39.0019416809082, 0.68071229700266, -76.6911087036133, -1.33851235388293, 218, 25, 'PPL', 'P'),
(46108, 'Crofton South', 38.9963912963867, 0.680615424518008, -76.6875, -1.33844937012315, 218, 25, 'PPL', 'P'),
(46109, 'Crofton Square', 39.0069389343262, 0.68079951552836, -76.6708297729492, -1.33815841977406, 218, 25, 'PPL', 'P'),
(46110, 'Crofton Village', 39.0297203063965, 0.681197125479109, -76.6741714477539, -1.33821674300193, 218, 25, 'PPL', 'P'),
(46111, 'Crofton Village Green', 39.0113906860352, 0.680877213253163, -76.6947174072266, -1.33857533764271, 218, 25, 'PPL', 'P'),
(46112, 'Crofton Woods', 38.9944381713867, 0.680581336056055, -76.6938934326172, -1.33856095657283, 218, 25, 'PPL', 'P'),
(148119, 'Crofts Corners', 41.3647193908691, 0.72195054753421, -73.8675003051758, -1.28923109054323, 218, 40, 'PPL', 'P'),
(134850, 'Croftville', 47.7649993896484, 0.833656506562447, -90.2755584716797, -1.57560572940747, 218, 28, 'PPL', 'P'),
(148120, 'Croghan', 43.8958282470703, 0.766126730801308, -75.3927764892578, -1.31585218195772, 218, 40, 'PPL', 'P'),
(134851, 'Croix Estates', 45.374439239502, 0.791933360975421, -92.8927764892578, -1.62128480105673, 218, 28, 'PPL', 'P'),
(207141, 'Croker', 47.0927810668945, 0.821924083538158, -122.155563354492, -2.13201678016442, 218, 56, 'PPL', 'P'),
(160558, 'Crolls Mills', 41.0205612182617, 0.715943854274563, -80.0441665649414, -1.39703425357299, 218, 45, 'PPL', 'P'),
(180956, 'Crolona Heights', 38.0547218322754, 0.664180191903775, -122.217498779297, -2.13309775725088, 218, 6, 'PPL', 'P'),
(380, 'Cromanton', 30.1161098480225, 0.525625274740281, -85.6350021362305, -1.4946127422296, 218, 12, 'PPL', 'P'),
(180957, 'Cromberg', 39.860279083252, 0.695693110766573, -120.690559387207, -2.10644763738051, 218, 6, 'PPL', 'P'),
(160556, 'Cromby', 40.1477813720703, 0.700710972313474, -75.5283279418945, -1.31821800111209, 218, 45, 'PPL', 'P'),
(180958, 'Crome', 35.4416694641113, 0.618573824552277, -119.199172973633, -2.08041803404413, 218, 6, 'PPL', 'P'),
(80568, 'Cromer Crossroads', 34.422779083252, 0.600790832689382, -81.6555633544922, -1.42515843310671, 218, 48, 'PPL', 'P'),
(20373, 'Cromers', 34.2758293151855, 0.598226075401581, -83.2655563354492, -1.45325811155841, 218, 13, 'PPL', 'P'),
(154902, 'Cromers', 41.1816711425781, 0.718755752911523, -83.2149963378906, -1.45237567313122, 218, 41, 'PPL', 'P'),
(180959, 'Cromir', 36.8044395446777, 0.642358649405829, -120.420829772949, -2.10173996752158, 218, 6, 'PPL', 'P'),
(72240, 'Cromley (historical)', 39.7016716003418, 0.692924887971491, -82.954719543457, -1.44783298610181, 218, 41, 'PPL', 'P'),
(35443, 'Cromona', 37.1863899230957, 0.649024941088461, -82.6972198486328, -1.44333876860425, 218, 21, 'PPL', 'P'),
(148122, 'Crompond', 41.2949981689453, 0.720733682653125, -73.8658294677734, -1.2892019289293, 218, 40, 'PPL', 'P'),
(169340, 'Crompton', 41.6847190856934, 0.727535595814269, -71.5141677856445, -1.24815768968316, 218, 47, 'PPL', 'P'),
(29579, 'Crompton Hill', 39.6558303833008, 0.692124807801004, -87.4191665649414, -1.52575228590757, 218, 19, 'PPL', 'P'),
(1893, 'Cromwell', 32.2286109924316, 0.562495375162369, -88.2744369506836, -1.54067957013357, 218, 2, 'PPL', 'P'),
(35444, 'Cromwell', 37.3402786254883, 0.651710805626833, -86.7880630493164, -1.514737451639, 218, 21, 'PPL', 'P'),
(75578, 'Cromwell', 35.3400001525879, 0.616799360317957, -96.4569396972656, -1.68349118411491, 218, 42, 'PPL', 'P'),
(101201, 'Cromwell', 38.5380592346191, 0.67261602097271, -77.5686111450195, -1.35382766067976, 218, 53, 'PPL', 'P'),
(113049, 'Cromwell', 41.5950012207031, 0.72596972367233, -72.6458282470703, -1.26790889074968, 218, 8, 'PPL', 'P'),
(115163, 'Cromwell', 41.0394401550293, 0.716273353880433, -94.461669921875, -1.64866715706881, 218, 16, 'PPL', 'P'),
(122454, 'Cromwell', 41.4005584716797, 0.722576057495242, -85.6158294677734, -1.49427811603863, 218, 19, 'PPL', 'P'),
(134853, 'Cromwell', 46.6808280944824, 0.814734147806189, -92.8838882446289, -1.62112967192323, 218, 28, 'PPL', 'P'),
(207142, 'Cromwell', 47.2744407653809, 0.825094643394924, -122.621109008789, -2.14014208465025, 218, 56, 'PPL', 'P'),
(46113, 'Cromwell (historical)', 39.1747207641602, 0.683727860883984, -76.6352767944336, -1.33753790324007, 218, 25, 'PPL', 'P'),
(86117, 'Cromwell Crossroads', 35.1366691589355, 0.613250565007372, -87.8283309936523, -1.53289355237062, 218, 50, 'PPL', 'P'),
(46114, 'Cromwell Fountain', 39.1952781677246, 0.684086655261845, -76.6069412231445, -1.33704335422564, 218, 25, 'PPL', 'P'),
(113052, 'Cromwell Hills', 41.6058311462402, 0.726158741530698, -72.684440612793, -1.26858280366352, 218, 8, 'PPL', 'P'),
(46115, 'Cromwell Manor', 39.1822204589844, 0.683858755251561, -76.6419372558594, -1.33765415022165, 218, 25, 'PPL', 'P'),
(46117, 'Cromwell Station', 39.4069404602051, 0.687780859167948, -76.5469436645508, -1.33599619928502, 218, 25, 'PPL', 'P'),
(46118, 'Cromwell Woods', 39.4180603027344, 0.687974937032388, -76.5388870239258, -1.33585558437947, 218, 25, 'PPL', 'P'),
(46119, 'Cromwood', 39.4013900756836, 0.687683986683296, -76.5538864135742, -1.33611737311462, 218, 25, 'PPL', 'P'),
(86118, 'Cronanville', 36.434440612793, 0.635900949815578, -89.4772186279297, -1.56167207058418, 218, 50, 'PPL', 'P'),
(180960, 'Cronese Valley', 35.0999984741211, 0.612610540818399, -116.272499084473, -2.02933793854614, 218, 6, 'PPL', 'P'),
(46120, 'Cronhardt', 39.4413909912109, 0.688382134363061, -76.7149963378906, -1.33892927175158, 218, 25, 'PPL', 'P'),
(93539, 'Cronin', 31.6761093139648, 0.552852401750329, -95.6163864135742, -1.66882076177604, 218, 51, 'PPL', 'P'),
(180961, 'Cronise (historical)', 35.1155586242676, 0.61288211667056, -116.272499084473, -2.02933793854614, 218, 6, 'PPL', 'P'),
(148124, 'Cronomer Valley', 41.5527801513672, 0.725232826998705, -74.063606262207, -1.2926537851762, 218, 40, 'PPL', 'P'),
(46121, 'Cronshaw', 39.146671295166, 0.6832383052966, -75.9819412231445, -1.32613504640068, 218, 25, 'PPL', 'P'),
(54268, 'Crook', 38.5505599975586, 0.672834200445015, -91.7774963378906, -1.60181949033323, 218, 29, 'PPL', 'P'),
(194151, 'Crook', 40.8588905334473, 0.713122168520597, -102.800559997559, -1.79420824485137, 218, 7, 'PPL', 'P'),
(202036, 'Crook City', 44.4413909912109, 0.775648596962777, -103.633056640625, -1.80873805228468, 218, 49, 'PPL', 'P'),
(86119, 'Crooked Creek', 35.8091697692871, 0.624987914879678, -87.9013900756836, -1.53416867390055, 218, 50, 'PPL', 'P'),
(108744, 'Crooked Creek', 37.8819389343262, 0.661164561443424, -81.9813919067383, -1.43084521414042, 218, 58, 'PPL', 'P'),
(160559, 'Crooked Creek', 41.8558311462402, 0.730522064660684, -77.2375030517578, -1.34804873427234, 218, 45, 'PPL', 'P'),
(211773, 'Crooked Creek', 61.8699989318848, 1.07983518956676, -158.110824584961, -2.75955447205077, 218, 1, 'PPL', 'P'),
(122455, 'Crooked Lake', 41.6797218322754, 0.727448377288569, -85.0366668701172, -1.48416982180513, 218, 19, 'PPL', 'P'),
(15671, 'Crooked Lake Park', 27.8288898468018, 0.485705755001511, -81.5841674804688, -1.42391234003267, 218, 12, 'PPL', 'P'),
(1895, 'Crooked Oak', 34.5849990844727, 0.603622105823272, -87.7994384765625, -1.53238928281821, 218, 2, 'PPL', 'P'),
(46123, 'Crooked Oak', 38.3769416809082, 0.669803989177695, -75.6722183227539, -1.32072936202004, 218, 25, 'PPL', 'P'),
(64049, 'Crooked Oak', 36.5338897705078, 0.637636665056037, -80.7588882446289, -1.40950850011892, 218, 33, 'PPL', 'P'),
(101202, 'Crooked Oak', 36.7200012207031, 0.640884922637607, -80.6080627441406, -1.40687609853943, 218, 53, 'PPL', 'P'),
(20374, 'Crooked River Plantation', 30.8091697692871, 0.537721452279962, -81.5777816772461, -1.42380088674105, 218, 13, 'PPL', 'P'),
(200649, 'Crooked River Ranch', 44.4247207641602, 0.775357646613686, -121.23722076416, -2.11598867830183, 218, 43, 'PPL', 'P'),
(72242, 'Crooked Tree', 39.6377792358398, 0.691809755844047, -81.4991683959961, -1.42242882614744, 218, 41, 'PPL', 'P'),
(86120, 'Crookedfork (historical)', 36.0736083984375, 0.629603239627813, -84.4972229003906, -1.47475474840337, 218, 50, 'PPL', 'P'),
(160560, 'Crookham', 40.209171295166, 0.70178242859904, -79.9844436645508, -1.39599189232233, 218, 45, 'PPL', 'P'),
(170102, 'Crooks', 43.6647186279297, 0.762093107014274, -96.8105621337891, -1.68966305994117, 218, 49, 'PPL', 'P'),
(124601, 'Crooks Corner', 42.0250015258789, 0.733474644782228, -71.4908294677734, -1.24775035919443, 218, 23, 'PPL', 'P'),
(80570, 'Crooks Crossroads', 33.7783317565918, 0.589543104983487, -79.4105606079102, -1.38597574346254, 218, 48, 'PPL', 'P'),
(54272, 'Crooks Springs', 37.9169387817383, 0.661775424018461, -93.8411102294922, -1.63783634723157, 218, 29, 'PPL', 'P'),
(134859, 'Crookston', 47.774169921875, 0.833816562543961, -96.607780456543, -1.68612385201051, 218, 28, 'PPL', 'P'),
(199260, 'Crookston', 42.9283294677734, 0.749240691593551, -100.751937866211, -1.75845304353013, 218, 35, 'PPL', 'P'),
(134860, 'Crookston Junction', 47.7563896179199, 0.833506237697939, -96.621940612793, -1.68637099335966, 218, 28, 'PPL', 'P'),
(72243, 'Crooksville', 39.7688903808594, 0.694098077010698, -82.0922164916992, -1.43277946804014, 218, 41, 'PPL', 'P'),
(178042, 'Crookton', 35.295280456543, 0.616018854381482, -112.707221984863, -1.967112114412, 218, 5, 'PPL', 'P'),
(15672, 'Croom', 28.5874996185303, 0.498945993255976, -82.227783203125, -1.43514555351062, 218, 12, 'PPL', 'P'),
(46124, 'Croom', 38.752498626709, 0.676358694410653, -76.7641677856445, -1.33978747541286, 218, 25, 'PPL', 'P'),
(46126, 'Croom Acres', 38.7605590820313, 0.676499375895236, -76.7458267211914, -1.33946736344983, 218, 25, 'PPL', 'P'),
(46125, 'Cropley', 38.9799995422363, 0.680329334437906, -77.2202835083008, -1.34774819654333, 218, 25, 'PPL', 'P'),
(203653, 'Cropley', 41.6530609130859, 0.726983056467105, -112.172782897949, -1.957784392694, 218, 52, 'PPL', 'P'),
(127183, 'Cropley Turn', 45.6894416809082, 0.797431190729781, -67.8908309936523, -1.18491853275425, 218, 26, 'PPL', 'P'),
(101203, 'Cropp', 38.4738883972168, 0.671496028576277, -77.6102828979492, -1.35455496997346, 218, 53, 'PPL', 'P'),
(35445, 'Cropper', 38.3122215270996, 0.668674409401338, -85.1133270263672, -1.48550779393678, 218, 21, 'PPL', 'P'),
(75579, 'Cropper', 36.4411087036133, 0.636017329955214, -97.6897201538086, -1.70500726203582, 218, 42, 'PPL', 'P'),
(119277, 'Cropsey', 40.6091690063477, 0.708763705659601, -88.4786071777344, -1.54424301283015, 218, 18, 'PPL', 'P'),
(148125, 'Cropseyville', 42.7488899230957, 0.746108880730646, -73.5577774047852, -1.28382540616259, 218, 40, 'PPL', 'P'),
(1896, 'Cropwell', 33.5522193908691, 0.585596699722153, -86.269172668457, -1.50568110603608, 218, 2, 'PPL', 'P'),
(70706, 'Cropwell', 39.8936080932617, 0.696274811727674, -74.9358291625977, -1.30787694659931, 218, 37, 'PPL', 'P'),
(1897, 'Crosby', 31.038610458374, 0.541725947742573, -85.0863876342773, -1.48503761284633, 218, 2, 'PPL', 'P'),
(8311, 'Crosby', 35.2819404602051, 0.615786027523182, -91.8333282470703, -1.60279394097609, 218, 4, 'PPL', 'P'),
(39952, 'Crosby', 31.3011093139648, 0.54630741705535, -91.5472183227539, -1.59780038077414, 218, 22, 'PPL', 'P'),
(46127, 'Crosby', 39.1166687011719, 0.682714661247263, -76.195556640625, -1.32986333876874, 218, 25, 'PPL', 'P'),
(59153, 'Crosby', 31.2836093902588, 0.546001985767832, -91.0630569458008, -1.58935017063532, 218, 30, 'PPL', 'P'),
(86122, 'Crosby', 36.2930603027344, 0.633433397907565, -83.2863922119141, -1.45362176620526, 218, 50, 'PPL', 'P'),
(93540, 'Crosby', 29.9116706848145, 0.522057138222279, -95.0619430541992, -1.65914389963913, 218, 51, 'PPL', 'P'),
(108745, 'Crosby', 38.3208312988281, 0.668824678265846, -81.2094421386719, -1.41737214902765, 218, 58, 'PPL', 'P'),
(134863, 'Crosby', 46.4822196960449, 0.811267777331342, -93.9574966430664, -1.63986767335303, 218, 28, 'PPL', 'P'),
(148126, 'Crosby', 42.5486106872559, 0.742613348641862, -77.0969390869141, -1.34559543027616, 218, 40, 'PPL', 'P'),
(160561, 'Crosby', 41.7449989318848, 0.728587677602905, -78.3905563354492, -1.36817331052369, 218, 45, 'PPL', 'P'),
(198153, 'Crosby', 48.9141693115234, 0.853713305364052, -103.294441223145, -1.80282809835163, 218, 34, 'PPL', 'P'),
(207143, 'Crosby', 47.582218170166, 0.830466372471668, -122.864723205566, -2.14439395448862, 218, 56, 'PPL', 'P'),
(80574, 'Crosby (historical)', 34.4305610656738, 0.600926653904976, -82.3844375610352, -1.43787968784375, 218, 48, 'PPL', 'P'),
(134864, 'Crosby Beach', 46.4716682434082, 0.811083619741963, -93.9494400024414, -1.63972705844747, 218, 28, 'PPL', 'P'),
(178043, 'Crosby Crossing', 33.9116706848145, 0.591870308302052, -109.344436645508, -1.90842043820246, 218, 5, 'PPL', 'P'),
(148127, 'Crosbyside', 43.4180603027344, 0.757788107112161, -73.6969375610352, -1.28625420907674, 218, 40, 'PPL', 'P'),
(191340, 'Crosbyton', 33.6599998474121, 0.58747782355813, -101.237503051758, -1.76692775475098, 218, 51, 'PPL', 'P'),
(207144, 'Croskey', 47.3074989318848, 0.82567161724509, -117.840827941895, -2.05671044086219, 218, 56, 'PPL', 'P'),
(20375, 'Crosland', 31.3041706085205, 0.54636084672472, -83.6430587768555, -1.45984677209527, 218, 13, 'PPL', 'P'),
(80571, 'Crosland Park', 33.5816688537598, 0.586110689812538, -81.7011108398438, -1.4259533866921, 218, 48, 'PPL', 'P'),
(39951, 'Crosley', 32.6069412231445, 0.569098483348139, -92.0449981689453, -1.60648827804025, 218, 22, 'PPL', 'P'),
(54271, 'Crosno', 36.7975006103516, 0.642237542155258, -89.1772232055664, -1.55643616272303, 218, 29, 'PPL', 'P'),
(80572, 'Cross', 33.327220916748, 0.581669735536776, -80.1486129760742, -1.39885718733915, 218, 48, 'PPL', 'P'),
(86121, 'Cross', 36.5605583190918, 0.638102119035555, -82.2900009155273, -1.4362314574451, 218, 50, 'PPL', 'P'),
(93542, 'Cross', 28.6044502258301, 0.49924183716357, -98.5460662841797, -1.71995332154751, 218, 51, 'PPL', 'P'),
(160562, 'Cross', 41.9705581665039, 0.732524428905288, -80.3752822875977, -1.40281331313846, 218, 45, 'PPL', 'P'),
(80573, 'Cross Anchor', 34.6427803039551, 0.604630578349058, -81.8580627441406, -1.42869271418936, 218, 48, 'PPL', 'P'),
(15673, 'Cross Bayou', 27.8575000762939, 0.486205097705901, -82.73388671875, -1.4439787262142, 218, 12, 'PPL', 'P'),
(15675, 'Cross City', 29.6341705322266, 0.517213846884834, -83.1252822875977, -1.4508098675683, 218, 12, 'PPL', 'P'),
(46128, 'Cross Country Estates', 39.5491714477539, 0.690263258199038, -76.4741668701172, -1.33472600460311, 218, 25, 'PPL', 'P'),
(15674, 'Cross Creek', 29.4861106872559, 0.514629715100103, -82.165283203125, -1.43405472272812, 218, 12, 'PPL', 'P'),
(20380, 'Cross Creek', 33.9466705322266, 0.592481170877089, -84.7866668701172, -1.47980649867514, 218, 13, 'PPL', 'P'),
(46129, 'Cross Creek', 39.5305595397949, 0.689938419125076, -76.6236114501953, -1.33733430457474, 218, 25, 'PPL', 'P'),
(160563, 'Cross Creek', 40.3288917541504, 0.703871944790316, -80.4094390869141, -1.40340946174847, 218, 45, 'PPL', 'P'),
(20378, 'Cross Creek Estates', 33.896110534668, 0.591598732449892, -84.7141723632813, -1.47854123084124, 218, 13, 'PPL', 'P'),
(80575, 'Cross Cross Roads', 33.3444404602051, 0.581970273265792, -80.1427764892578, -1.39875532142745, 218, 48, 'PPL', 'P'),
(93553, 'Cross Cut', 32.0336112976074, 0.559091988447303, -99.1322174072266, -1.73018358855894, 218, 51, 'PPL', 'P'),
(160565, 'Cross Fork', 41.4833297729492, 0.724020689228556, -77.8147201538086, -1.35812307320195, 218, 45, 'PPL', 'P'),
(80576, 'Cross Hill', 34.3047218322754, 0.598730344953988, -81.9830627441406, -1.43087437575435, 218, 48, 'PPL', 'P'),
(8314, 'Cross Hollow', 36.2783317565918, 0.633176336283345, -94.1130599975586, -1.64258276608436, 218, 4, 'PPL', 'P'),
(46130, 'Cross Hollow', 39.4813919067383, 0.689080282042825, -77.524169921875, -1.35305201501227, 218, 25, 'PPL', 'P'),
(101204, 'Cross Junction', 39.3202781677246, 0.686268316826838, -78.2936096191406, -1.36648127112511, 218, 53, 'PPL', 'P'),
(1898, 'Cross Key', 34.8711090087891, 0.608615666025225, -87.0183334350586, -1.51875642804004, 218, 2, 'PPL', 'P'),
(1899, 'Cross Keys', 32.333610534668, 0.56432796288748, -85.8933334350586, -1.4991214739551, 218, 2, 'PPL', 'P'),
(13620, 'Cross Keys', 38.5658302307129, 0.673100716291104, -75.3683319091797, -1.31542554355109, 218, 10, 'PPL', 'P'),
(20379, 'Cross Keys', 32.8519401550293, 0.573374521373398, -83.5880584716797, -1.45888683568035, 218, 13, 'PPL', 'P'),
(39956, 'Cross Keys', 31.8838901519775, 0.556478861496203, -91.357780456543, -1.5944940662808, 218, 22, 'PPL', 'P'),
(54273, 'Cross Keys', 38.8088912963867, 0.677342932170519, -90.2986068725586, -1.57600799989013, 218, 29, 'PPL', 'P'),
(70707, 'Cross Keys', 39.7133293151855, 0.693128353478773, -75.0299987792969, -1.30952051646606, 218, 37, 'PPL', 'P'),
(80577, 'Cross Keys', 34.6319389343262, 0.604441360753608, -81.7769393920898, -1.42727684459582, 218, 48, 'PPL', 'P'),
(101206, 'Cross Keys', 36.6202812194824, 0.639144480286213, -77.1877822875977, -1.34718094323114, 218, 53, 'PPL', 'P'),
(160568, 'Cross Keys', 40.357780456543, 0.704376147763695, -77.7038879394531, -1.35618868614417, 218, 45, 'PPL', 'P'),
(72248, 'Cross Keys (historical)', 39.589168548584, 0.690961339299775, -81.2302780151367, -1.4177358036745, 218, 41, 'PPL', 'P'),
(134867, 'Cross Lake', 46.6594390869141, 0.814360839200387, -94.1136093139648, -1.64259235346429, 218, 28, 'PPL', 'P'),
(8315, 'Cross Lanes', 35.3899993896484, 0.617672011628149, -94.2058334350586, -1.64420196802713, 218, 4, 'PPL', 'P'),
(86125, 'Cross Lanes', 36.5222206115723, 0.637432999811673, -86.1494369506836, -1.50359132352869, 218, 50, 'PPL', 'P'),
(108746, 'Cross Lanes', 38.420280456543, 0.670560393506305, -81.7908325195313, -1.42751932541307, 218, 58, 'PPL', 'P'),
(78093, 'Cross Mill', 39.7988891601563, 0.694621654481007, -76.5411071777344, -1.33589433337333, 218, 45, 'PPL', 'P'),
(93543, 'Cross Mountain', 29.6452808380127, 0.517407758301705, -98.6591720581055, -1.72192738970553, 218, 51, 'PPL', 'P'),
(473, 'Cross Plains', 38.9438896179199, 0.679699097365939, -85.204719543457, -1.48710289427168, 218, 19, 'PPL', 'P'),
(20384, 'Cross Plains', 33.5591697692871, 0.585718006709806, -84.9741668701172, -1.48307899102263, 218, 13, 'PPL', 'P'),
(80578, 'Cross Plains', 35.098331451416, 0.61258144578349, -82.4211120605469, -1.43851977861175, 218, 48, 'PPL', 'P'),
(86126, 'Cross Plains', 36.5486106872559, 0.637893593522202, -86.6961135864258, -1.51313263076612, 218, 50, 'PPL', 'P'),
(93544, 'Cross Plains', 32.1261100769043, 0.560706396700109, -99.1650009155273, -1.73075576871914, 218, 51, 'PPL', 'P'),
(173695, 'Cross Plains', 43.1144409179688, 0.752488949175121, -89.6555633544922, -1.56478477326626, 218, 57, 'PPL', 'P'),
(148128, 'Cross River', 41.2622184753418, 0.720161569071949, -73.6149978637695, -1.28482409157137, 218, 40, 'PPL', 'P'),
(35446, 'Cross Road', 37.0133285522461, 0.64600445035912, -88.0922164916992, -1.5374992231598, 218, 21, 'PPL', 'P'),
(93545, 'Cross Road', 33.6994400024414, 0.588166184120889, -95.273063659668, -1.66282864932336, 218, 51, 'PPL', 'P'),
(20381, 'Cross Road Farms', 34.0152816772461, 0.593678661261243, -84.7666702270508, -1.47945749141429, 218, 13, 'PPL', 'P'),
(8322, 'Cross Roads', 33.4208297729492, 0.583303518286513, -92.7188873291016, -1.61824986267847, 218, 4, 'PPL', 'P'),
(20383, 'Cross Roads', 34.0099983215332, 0.593586449308499, -84.7555618286133, -1.47926361328693, 218, 13, 'PPL', 'P'),
(39955, 'Cross Roads', 32.1833305358887, 0.561705082108888, -93.3897171020508, -1.62995805093684, 218, 22, 'PPL', 'P'),
(54277, 'Cross Roads', 36.8219413757324, 0.642664113982861, -93.5327835083008, -1.6324550307749, 218, 29, 'PPL', 'P'),
(59155, 'Cross Roads', 34.9241714477539, 0.609541780294301, -88.2558288574219, -1.54035479763864, 218, 30, 'PPL', 'P'),
(75581, 'Cross Roads', 35.0063896179199, 0.610976758068662, -96.2474975585938, -1.67983572920266, 218, 42, 'PPL', 'P'),
(78094, 'Cross Roads', 39.8194389343262, 0.694980315700814, -76.5769424438477, -1.33651977675533, 218, 45, 'PPL', 'P'),
(80580, 'Cross Roads', 34.0416717529297, 0.594139254971773, -81.1069412231445, -1.41558317056539, 218, 48, 'PPL', 'P'),
(86133, 'Cross Roads', 35.8444404602051, 0.62560350456565, -85.9361114501953, -1.49986809116671, 218, 50, 'PPL', 'P'),
(101207, 'Cross Roads', 36.9047203063965, 0.644108878874229, -80.0833282470703, -1.39771775386676, 218, 53, 'PPL', 'P'),
(122456, 'Cross Roads', 40.0916709899902, 0.699731661401624, -85.4997177124023, -1.49225158360714, 218, 19, 'PPL', 'P'),
(148129, 'Cross Roads', 42.8777809143066, 0.748358452903436, -76.6836090087891, -1.33838145951535, 218, 40, 'PPL', 'P'),
(180962, 'Cross Roads', 34.2144393920898, 0.597154619116015, -114.214996337891, -1.99342774124946, 218, 6, 'PPL', 'P'),
(191341, 'Cross Roads', 32.7986106872559, 0.572443746572415, -100.508056640625, -1.75419651315986, 218, 51, 'PPL', 'P'),
(8324, 'Cross Roads (historical)', 36.1891708374023, 0.631620184679384, -94.1611099243164, -1.64342139551163, 218, 4, 'PPL', 'P'),
(26893, 'Cross Roads (historical)', 37.4672203063965, 0.653926355916697, -88.7769393920898, -1.54944989223542, 218, 18, 'PPL', 'P'),
(59156, 'Cross Roads (historical)', 33.0155601501465, 0.57623022901029, -88.3869400024414, -1.54264311880529, 218, 30, 'PPL', 'P'),
(127185, 'Cross Rock', 47.1111106872559, 0.822243995764103, -68.9736099243164, -1.20381659016556, 218, 26, 'PPL', 'P'),
(93552, 'Cross Timber', 32.5322189331055, 0.567794333362327, -97.3252792358398, -1.69864656808828, 218, 51, 'PPL', 'P'),
(54280, 'Cross Timbers', 38.0247192382813, 0.663656547854438, -93.2266693115234, -1.62711233015404, 218, 29, 'PPL', 'P'),
(86132, 'Cross Timbers', 35.2027816772461, 0.614404446128676, -85.1952819824219, -1.48693817775826, 218, 50, 'PPL', 'P'),
(194796, 'Cross Trails', 45.476390838623, 0.793712752057757, -115.690826416016, -2.0191858353127, 218, 17, 'PPL', 'P'),
(8325, 'Cross Trails (historical)', 34.0875015258789, 0.594939135405178, -94.2858276367188, -1.64559813022861, 218, 4, 'PPL', 'P'),
(130372, 'Cross Village', 45.642219543457, 0.796607008951428, -85.0374984741211, -1.48418433603307, 218, 27, 'PPL', 'P'),
(54279, 'Cross Way', 37.3713912963867, 0.6522538241731, -93.0555572509766, -1.62412586130762, 218, 29, 'PPL', 'P'),
(64054, 'Cross William MHP', 35.353328704834, 0.617031987439176, -82.4497222900391, -1.43901912131614, 218, 33, 'PPL', 'P'),
(72245, 'Crossenville', 39.6805610656738, 0.692556439634678, -82.3563919067383, -1.43739019883539, 218, 41, 'PPL', 'P'),
(8327, 'Crosses', 35.8741683959961, 0.626122354925025, -93.9111099243164, -1.63905807238164, 218, 4, 'PPL', 'P'),
(101208, 'Crosses Corner', 37.7266693115234, 0.658454595297186, -77.3663864135742, -1.35029817328708, 218, 53, 'PPL', 'P'),
(8328, 'Crossett', 33.128059387207, 0.578193711102978, -91.9611129760742, -1.60502420523098, 218, 4, 'PPL', 'P'),
(86134, 'Crossfield', 35.910831451416, 0.626762245955944, -83.8277816772461, -1.46307079491092, 218, 50, 'PPL', 'P'),
(20385, 'Crossgate', 33.9566688537598, 0.592655674507517, -84.4541702270508, -1.4740033375018, 218, 13, 'PPL', 'P'),
(35447, 'Crossgate', 38.2791709899902, 0.668097568709227, -85.629997253418, -1.49452539054584, 218, 21, 'PPL', 'P'),
(13619, 'Crossgates', 39.1388893127441, 0.683102484081006, -75.5361099243164, -1.31835382232769, 218, 10, 'PPL', 'P'),
(59157, 'Crossgates', 32.2944412231445, 0.563644329435657, -90.0250015258789, -1.57123268573951, 218, 30, 'PPL', 'P'),
(160569, 'Crossgrove', 40.7374992370605, 0.711003490715385, -77.3202819824219, -1.34949349916371, 218, 45, 'PPL', 'P'),
(160570, 'Crossingville', 41.829719543457, 0.730066331219144, -80.2391662597656, -1.40043764028805, 218, 45, 'PPL', 'P'),
(39957, 'Crosskeys', 32.2369384765625, 0.562640717178861, -93.4952774047852, -1.63180042577896, 218, 22, 'PPL', 'P'),
(160572, 'Crosskill Mills', 40.4477806091309, 0.705946946753651, -76.3530578613281, -1.33261225364592, 218, 45, 'PPL', 'P'),
(35448, 'Crossland', 36.500560760498, 0.637054964094936, -88.3802795410156, -1.54252687182371, 218, 21, 'PPL', 'P'),
(160571, 'Crossland', 40.0372200012207, 0.698781312366629, -79.605827331543, -1.38938379070952, 218, 45, 'PPL', 'P'),
(15676, 'Crossley', 29.5888900756836, 0.516423553831353, -81.9933319091797, -1.43105360649571, 218, 12, 'PPL', 'P'),
(70708, 'Crossley (historical)', 39.9527816772461, 0.697307585598407, -74.2961120605469, -1.29671177688721, 218, 37, 'PPL', 'P'),
(127184, 'Crossman Corner', 43.9813919067383, 0.76762009838257, -70.0591735839844, -1.22276325026676, 218, 26, 'PPL', 'P'),
(145068, 'Crossmans', 40.4850006103516, 0.706596558322549, -74.3216705322266, -1.2971578563698, 218, 37, 'PPL', 'P'),
(64056, 'Crossnore', 36.021671295166, 0.628696766171777, -81.9297180175781, -1.42994333463726, 218, 33, 'PPL', 'P'),
(186595, 'Crossons', 39.399169921875, 0.687645237689436, -105.385833740234, -1.83932978372642, 218, 7, 'PPL', 'P'),
(203650, 'Crosspointe Condo', 40.6525001525879, 0.709519976830156, -111.932220458984, -1.95358578607744, 218, 52, 'PPL', 'P'),
(194797, 'Crossport', 48.7011108398438, 0.849994733533974, -116.220283508301, -2.02842660482112, 218, 17, 'PPL', 'P'),
(222, 'Crossroad', 34.5055618286133, 0.602235664159777, -86.0502777099609, -1.5018606682943, 218, 2, 'PPL', 'P'),
(8331, 'Crossroad', 34.9336090087891, 0.609706496807722, -91.7194366455078, -1.60080615753845, 218, 4, 'PPL', 'P'),
(35449, 'Crossroad', 36.8666687011719, 0.643444753077391, -87.0219421386719, -1.51881941179982, 218, 21, 'PPL', 'P'),
(59159, 'Crossroad', 34.6119384765625, 0.604092286913726, -89.8369369506836, -1.56795033969598, 218, 30, 'PPL', 'P'),
(93554, 'Crossroad Store', 31.7338905334473, 0.553860874276115, -97.6650009155273, -1.70457582993923, 218, 51, 'PPL', 'P'),
(29581, 'Crossroad Temple', 39.752498626709, 0.693811986930596, -86.0666732788086, -1.50214682495343, 218, 19, 'PPL', 'P'),
(1902, 'Crossroads', 34.3219413757324, 0.599030882683003, -86.331672668457, -1.50677193681857, 218, 2, 'PPL', 'P'),
(8337, 'Crossroads', 35.1941719055176, 0.614254177264168, -93.4933319091797, -1.63176647047506, 218, 4, 'PPL', 'P'),
(15677, 'Crossroads', 30.4919395446777, 0.532184740373687, -83.1341705322266, -1.4509649967018, 218, 12, 'PPL', 'P'),
(20390, 'Crossroads', 31.8341693878174, 0.555611070455001, -84.9911117553711, -1.48337473506168, 218, 13, 'PPL', 'P'),
(26894, 'Crossroads', 37.3488883972168, 0.651861074491341, -88.817497253418, -1.55015776045316, 218, 18, 'PPL', 'P'),
(39959, 'Crossroads', 32.7213897705078, 0.571095987323753, -92.220832824707, -1.6095571717224, 218, 22, 'PPL', 'P'),
(46131, 'Crossroads', 38.3838882446289, 0.669925229586321, -76.1916732788086, -1.32979556131899, 218, 25, 'PPL', 'P'),
(54281, 'Crossroads', 38.0747184753418, 0.66452919916463, -91.2438888549805, -1.59250628284317, 218, 29, 'PPL', 'P'),
(59162, 'Crossroads', 30.7824993133545, 0.53725596501093, -89.7747192382813, -1.5668644357615, 218, 30, 'PPL', 'P'),
(70709, 'Crossroads', 39.9152793884277, 0.696653047181493, -74.8263931274414, -1.30596692746551, 218, 37, 'PPL', 'P'),
(75584, 'Crossroads', 33.9824981689453, 0.59310648110104, -94.7908325195313, -1.65441212817233, 218, 42, 'PPL', 'P'),
(86142, 'Crossroads', 35.0627784729004, 0.611960929249501, -87.727783203125, -1.53113866237031, 218, 50, 'PPL', 'P'),
(101213, 'Crossroads', 36.9266700744629, 0.644491974597037, -78.834716796875, -1.37592537298275, 218, 53, 'PPL', 'P'),
(108748, 'Crossroads', 37.711109161377, 0.658183019445025, -80.813606262207, -1.41046350968582, 218, 58, 'PPL', 'P'),
(154908, 'Crossroads', 40.7269401550293, 0.710819199967951, -81.5738906860352, -1.42373297613325, 218, 41, 'PPL', 'P'),
(160574, 'Crossroads', 40.7722206115723, 0.711609493021432, -75.4205627441406, -1.31633714359222, 218, 45, 'PPL', 'P'),
(188380, 'Crossroads', 33.5122184753418, 0.584898552042389, -103.339172363281, -1.80360880402519, 218, 38, 'PPL', 'P'),
(190087, 'Crossroads', 37.5658302307129, 0.655647423771161, -114.255279541016, -1.99413081577724, 218, 39, 'PPL', 'P'),
(191342, 'Crossroads', 31.5650005340576, 0.550913187713074, -101.606941223145, -1.77337566722423, 218, 51, 'PPL', 'P'),
(203651, 'Crossroads', 41.7125015258789, 0.728020490869746, -112.141387939453, -1.95723644729972, 218, 52, 'PPL', 'P'),
(207145, 'Crossroads', 47.6197204589844, 0.831120910888583, -122.117500305176, -2.1313524546305, 218, 56, 'PPL', 'P'),
(8338, 'Crossroads (historical)', 34.8861083984375, 0.60887745476038, -92.6347198486328, -1.61678086302119, 218, 4, 'PPL', 'P'),
(29582, 'Crossroads (historical)', 38.1019401550293, 0.6650043071031, -87.6458282470703, -1.52970827854883, 218, 19, 'PPL', 'P'),
(93560, 'Crossroads Community Centery', 33.0727806091309, 0.577228914419069, -94.581672668457, -1.65076160010811, 218, 51, 'PPL', 'P'),
(54282, 'Crossroads School', 38.7999992370605, 0.677187736457994, -94.3199996948242, -1.64619454515473, 218, 29, 'PPL', 'P'),
(54283, 'Crossroads Store', 37.1894416809082, 0.649078204310263, -92.3925018310547, -1.61255336110679, 218, 29, 'PPL', 'P'),
(101214, 'Crossroads Store', 37.8244400024414, 0.660161015765655, -79.3288879394531, -1.38455028648908, 218, 53, 'PPL', 'P'),
(112203, 'Crosston', 33.728328704834, 0.588670387094268, -86.7316665649414, -1.51375314730011, 218, 2, 'PPL', 'P'),
(54284, 'Crosstown', 37.7463912963867, 0.658798808868079, -89.727783203125, -1.5660452474102, 218, 29, 'PPL', 'P'),
(72246, 'Crosstown', 39.0916709899902, 0.682278368881681, -84.0061111450195, -1.46618323127689, 218, 41, 'PPL', 'P'),
(86143, 'Crosstown', 35.4455604553223, 0.618641735160074, -89.7925033569336, -1.56717482718655, 218, 50, 'PPL', 'P'),
(108749, 'Crosstown', 39.3561096191406, 0.686893693629815, -79.1769409179688, -1.38189831067558, 218, 58, 'PPL', 'P'),
(1905, 'Crossville', 33.7438888549805, 0.588941962946429, -88.0022201538086, -1.53592849074887, 218, 2, 'PPL', 'P'),
(26896, 'Crossville', 38.1616706848145, 0.666046801511811, -88.0652770996094, -1.53702904206935, 218, 18, 'PPL', 'P'),
(86144, 'Crossville', 35.9488906860352, 0.627426504910837, -85.0269393920898, -1.48400004528563, 218, 50, 'PPL', 'P'),
(86145, 'Crossville Estates', 35.9791717529297, 0.627955009229163, -85.0258331298828, -1.48398073736773, 218, 50, 'PPL', 'P'),
(64057, 'Crossway', 34.7449989318848, 0.606414629963302, -79.5266723632813, -1.38800227589404, 218, 33, 'PPL', 'P'),
(169341, 'Crossways (historical)', 41.6549987792969, 0.727016878612949, -71.4647216796875, -1.24729469233192, 218, 47, 'PPL', 'P'),
(80581, 'Crosswell', 34.8494415283203, 0.608237497150434, -82.4941711425781, -1.43979490014168, 218, 48, 'PPL', 'P'),
(72247, 'Crosswick', 39.5438919067383, 0.690171112825322, -84.0788879394531, -1.46745342595881, 218, 41, 'PPL', 'P'),
(145069, 'Crosswicks', 40.1533317565918, 0.700807844798125, -74.648063659668, -1.30285449109953, 218, 37, 'PPL', 'P'),
(160573, 'Crosswicks', 40.0966682434082, 0.699818879927324, -75.091667175293, -1.31059683302061, 218, 45, 'PPL', 'P'),
(46132, 'Crosswinds', 38.8644409179688, 0.678312455965362, -76.3580627441406, -1.33269960532967, 218, 25, 'PPL', 'P'),
(80582, 'Crosswinds', 33.8027801513672, 0.589969809969145, -79.0169372558594, -1.37910571995652, 218, 48, 'PPL', 'P'),
(154905, 'Crosswoods', 41.5999984741211, 0.72605694219803, -83.4402770996094, -1.45630756416461, 218, 41, 'PPL', 'P'),
(101215, 'Crosswoods West', 37.7083282470703, 0.658134483334159, -77.8683319091797, -1.35905877485095, 218, 53, 'PPL', 'P'),
(130374, 'Croswell', 43.2755584716797, 0.755300980970136, -82.6211090087891, -1.44201038385252, 218, 27, 'PPL', 'P'),
(154906, 'Croswell', 41.0208282470703, 0.715948514806471, -84.1977767944336, -1.46952842792214, 218, 41, 'PPL', 'P'),
(29583, 'Crothersville', 38.8005599975586, 0.677197523575, -85.841667175293, -1.49821972761, 218, 19, 'PPL', 'P'),
(115164, 'Croton', 40.5902786254883, 0.708434006316649, -91.690559387207, -1.60030215430216, 218, 16, 'PPL', 'P'),
(130376, 'Croton', 43.4388885498047, 0.758151628600957, -85.6608276367188, -1.4950634822441, 218, 27, 'PPL', 'P'),
(145070, 'Croton', 40.5108299255371, 0.707047364916072, -74.9305572509766, -1.30778493438365, 218, 37, 'PPL', 'P'),
(154907, 'Croton', 40.2386093139648, 0.702296218952343, -82.692497253418, -1.44325634376851, 218, 41, 'PPL', 'P'),
(191343, 'Croton', 33.6758308410645, 0.587754126521226, -100.747497558594, -1.75837554554241, 218, 51, 'PPL', 'P'),
(209393, 'Croton', 44.524169921875, 0.777093361854145, -105.953056335449, -1.84922968560463, 218, 59, 'PPL', 'P'),
(148130, 'Croton Falls', 41.3472213745117, 0.721645149536205, -73.6613922119141, -1.28563382570081, 218, 40, 'PPL', 'P'),
(130377, 'Croton Heights', 43.4563903808594, 0.758457093177989, -85.6347198486328, -1.49460781538158, 218, 27, 'PPL', 'P'),
(148131, 'Croton Heights', 41.2466697692871, 0.71989019295687, -73.7838897705078, -1.28777181142392, 218, 40, 'PPL', 'P'),
(148132, 'Croton-on-Hudson', 41.2083282470703, 0.71922100715396, -73.8916702270508, -1.2896529352599, 218, 40, 'PPL', 'P'),
(148133, 'Crotonville', 41.1875, 0.718857485665165, -73.8705596923828, -1.28928448692309, 218, 40, 'PPL', 'P'),
(59163, 'Crotts', 31.5569400787354, 0.550772506228491, -89.0838928222656, -1.55480724024228, 218, 30, 'PPL', 'P'),
(101216, 'Crouch', 37.7622184753418, 0.659075045252148, -76.8974990844727, -1.34211454557337, 218, 53, 'PPL', 'P'),
(194798, 'Crouch', 44.1152801513672, 0.76995688908106, -115.970001220703, -2.02405835484311, 218, 17, 'PPL', 'P'),
(86146, 'Crouch Crossroad', 36.3777809143066, 0.634912051523804, -82.4080581665039, -1.43829194518049, 218, 50, 'PPL', 'P'),
(64058, 'Crouse', 35.4208297729492, 0.618210103326399, -81.3055572509766, -1.41904967419829, 218, 33, 'PPL', 'P'),
(93561, 'Crouse Colonia', 26.3279991149902, 0.459510270018733, -98.181999206543, -1.71359915234464, 218, 51, 'PPL', 'P'),
(46133, 'Crouse Mill', 39.6169395446777, 0.69144603461817, -77.2052764892578, -1.34748627465012, 218, 25, 'PPL', 'P'),
(127186, 'Crouseville', 46.7550010681152, 0.816028710412076, -68.0969390869141, -1.18851579759667, 218, 26, 'PPL', 'P'),
(59164, 'Crow', 34.8333282470703, 0.607956267339322, -88.7013931274414, -1.54813136117972, 218, 30, 'PPL', 'P'),
(93563, 'Crow', 32.6155586242676, 0.569248885370701, -95.309440612793, -1.66346354692724, 218, 51, 'PPL', 'P'),
(108750, 'Crow', 37.7591705322266, 0.659021848609373, -81.0769424438477, -1.41505959309508, 218, 58, 'PPL', 'P'),
(200650, 'Crow', 43.9930610656738, 0.767823763626934, -123.338333129883, -2.15266000703806, 218, 43, 'PPL', 'P'),
(59165, 'Crow (historical)', 33.2374992370605, 0.58010379681581, -88.3455581665039, -1.54192086951766, 218, 30, 'PPL', 'P'),
(180963, 'Crow (historical)', 39.9452781677246, 0.697176624651802, -120.451110839844, -2.10226847183991, 218, 6, 'PPL', 'P'),
(196305, 'Crow Agency', 45.6016693115234, 0.79589927389174, -107.460563659668, -1.87554065191017, 218, 31, 'PPL', 'P'),
(8339, 'Crow Creek', 35.0125007629395, 0.61108341767032, -90.7363891601563, -1.58364874221562, 218, 4, 'PPL', 'P'),
(80585, 'Crow Creek', 34.9205589294434, 0.609478729955493, -82.772216796875, -1.44464771228002, 218, 48, 'PPL', 'P'),
(170105, 'Crow Creek', 43.9555587768555, 0.767169225210019, -99.2227783203125, -1.7317641746659, 218, 49, 'PPL', 'P'),
(196306, 'Crow Creek City (historical)', 46.1805610656738, 0.80600284101431, -111.606941223145, -1.94790859242366, 218, 31, 'PPL', 'P'),
(46134, 'Crow Haven Estates', 38.6294403076172, 0.674210921570531, -76.6347198486328, -1.33752818270209, 218, 25, 'PPL', 'P'),
(80583, 'Crow Hill', 33.2158317565918, 0.579725627941019, -79.3902816772461, -1.38562180935367, 218, 48, 'PPL', 'P'),
(130379, 'Crow Island', 43.4697189331055, 0.758689720299207, -83.9038925170898, -1.46439917966265, 218, 27, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(170109, 'Crow Lake', 43.9575004577637, 0.767203113934891, -98.7386093139648, -1.72331383136903, 218, 49, 'PPL', 'P'),
(124602, 'Crow Point', 42.2616691589355, 0.737605274211968, -70.8958282470703, -1.23736562883978, 218, 23, 'PPL', 'P'),
(134870, 'Crow River', 45.2438888549805, 0.789654826925776, -94.7241668701172, -1.65324859309208, 218, 28, 'PPL', 'P'),
(196307, 'Crow Rock', 46.9113883972168, 0.818758184213299, -106.070281982422, -1.85127565911208, 218, 31, 'PPL', 'P'),
(35450, 'Crow Valley', 37.7402801513672, 0.658692149266421, -84.414436340332, -1.47330985035395, 218, 21, 'PPL', 'P'),
(134872, 'Crow Wing', 46.2799987792969, 0.807738356517687, -94.2922210693359, -1.64570971667828, 218, 28, 'PPL', 'P'),
(80584, 'Crowburg', 34.7849998474121, 0.607112777643066, -80.4461135864258, -1.40404955251647, 218, 48, 'PPL', 'P'),
(46143, 'Crowder', 39.2333297729492, 0.684750781058683, -76.8077774047852, -1.34054860685241, 218, 25, 'PPL', 'P'),
(54285, 'Crowder', 36.9625015258789, 0.645117351400015, -89.6833267211914, -1.5652693354266, 218, 29, 'PPL', 'P'),
(59166, 'Crowder', 34.1733283996582, 0.59643709693932, -90.1374969482422, -1.57319610125317, 218, 30, 'PPL', 'P'),
(75585, 'Crowder', 35.1238899230957, 0.613027525266078, -95.6697235107422, -1.66975166973508, 218, 42, 'PPL', 'P'),
(20392, 'Crowder (historical)', 33.0119400024414, 0.576167045513427, -85.1791687011719, -1.48665694794715, 218, 13, 'PPL', 'P'),
(64060, 'Crowders', 35.1861114501953, 0.614113495779585, -81.206672668457, -1.41732381265386, 218, 33, 'PPL', 'P'),
(64061, 'Crowders (historical)', 35.2363891601563, 0.614991007358766, -81.1636123657227, -1.41657226859424, 218, 33, 'PPL', 'P'),
(20393, 'Crowders Crossing', 32.9352798461914, 0.574829073381772, -84.7313919067383, -1.47884176857026, 218, 13, 'PPL', 'P'),
(101221, 'Crowdertown', 38.0091705322266, 0.663385171739359, -79.8511123657227, -1.39366482216182, 218, 53, 'PPL', 'P'),
(32183, 'Croweburg', 37.5569381713867, 0.655492228058637, -94.6658325195313, -1.65223046660734, 218, 20, 'PPL', 'P'),
(93564, 'Crowell', 33.9838905334473, 0.593130782445987, -99.7244415283203, -1.74051984938176, 218, 51, 'PPL', 'P'),
(141588, 'Crowell', 41.7280616760254, 0.728292066721906, -96.7074966430664, -1.68786422778287, 218, 35, 'PPL', 'P'),
(35451, 'Crowell Landing', 37.0552787780762, 0.64673661992181, -88.4952774047852, -1.54453396317924, 218, 21, 'PPL', 'P'),
(101217, 'Crowells Corner', 38.952220916748, 0.679844505961458, -77.3111114501953, -1.3493334431822, 218, 53, 'PPL', 'P'),
(64062, 'Crowells Crossroads', 36.2275009155273, 0.632289170745212, -77.5516662597656, -1.35353191664071, 218, 33, 'PPL', 'P'),
(70712, 'Crowfoot', 39.7944412231445, 0.694544023335232, -74.8994369506836, -1.30724178267933, 218, 37, 'PPL', 'P'),
(200651, 'Crowfoot', 44.5083312988281, 0.776816925732995, -122.888893127441, -2.14481579920528, 218, 43, 'PPL', 'P'),
(101218, 'Crowgeys', 36.9619407653809, 0.645107564283009, -81.1044387817383, -1.41553949472351, 218, 53, 'PPL', 'P'),
(209394, 'Crowheart', 43.3097190856934, 0.755897196159177, -109.193328857422, -1.90578310977495, 218, 59, 'PPL', 'P'),
(8340, 'Crowley', 36.0927810668945, 0.629937865818781, -90.6138916015625, -1.5815107564925, 218, 4, 'PPL', 'P'),
(39960, 'Crowley', 30.2138900756836, 0.527331861656317, -92.3744430541992, -1.61223817599178, 218, 22, 'PPL', 'P'),
(93565, 'Crowley', 32.5788917541504, 0.568608927760755, -97.3622207641602, -1.69929131938818, 218, 51, 'PPL', 'P'),
(180964, 'Crowley', 39.4091682434082, 0.687819741319863, -123.424438476563, -2.15416282884119, 218, 6, 'PPL', 'P'),
(186596, 'Crowley', 38.1930618286133, 0.666594680327068, -103.855560302734, -1.81262147378623, 218, 7, 'PPL', 'P'),
(200652, 'Crowley', 43.2916717529297, 0.755582210781248, -117.893333435059, -2.05762683459329, 218, 43, 'PPL', 'P'),
(113068, 'Crowley Corner', 41.4772186279297, 0.723914029626898, -72.3116683959961, -1.26207670112046, 218, 8, 'PPL', 'P'),
(86147, 'Crowley Store', 36.1366691589355, 0.630703857527315, -88.6927795410156, -1.54798102573619, 218, 50, 'PPL', 'P'),
(113065, 'Crowleys Corner', 41.8166694641113, 0.729838564366915, -72.8677825927734, -1.27178272487131, 218, 8, 'PPL', 'P'),
(70710, 'Crowleytown', 39.6283302307129, 0.691644839593544, -74.6180572509766, -1.30233078047117, 218, 37, 'PPL', 'P'),
(35453, 'Crown', 37.1497192382813, 0.648384916899488, -82.8413925170898, -1.44585505636021, 218, 21, 'PPL', 'P'),
(54286, 'Crown', 37.2644386291504, 0.650387147986036, -92.9511108398438, -1.62230292754147, 218, 29, 'PPL', 'P'),
(93566, 'Crown', 28.9411106109619, 0.505117669345153, -98.7397232055664, -1.72333327244498, 218, 51, 'PPL', 'P'),
(108753, 'Crown', 39.5830612182617, 0.690854746277145, -80.102783203125, -1.39805730690574, 218, 58, 'PPL', 'P'),
(134876, 'Crown', 45.4447212219238, 0.793160012973511, -93.4599990844727, -1.63118470293493, 218, 28, 'PPL', 'P'),
(160575, 'Crown', 41.389720916748, 0.722386906478819, -79.271110534668, -1.38354188054232, 218, 45, 'PPL', 'P'),
(180965, 'Crown', 38.2666702270508, 0.667879389236922, -122.655830383301, -2.1407480869563, 218, 6, 'PPL', 'P'),
(8342, 'Crown (historical)', 36.2944412231445, 0.63345749951543, -94.3938903808594, -1.6474841809126, 218, 4, 'PPL', 'P'),
(29584, 'Crown Center', 39.5794410705566, 0.690791562780283, -86.5897216796875, -1.51127574169606, 218, 19, 'PPL', 'P'),
(72249, 'Crown City', 38.5908317565918, 0.673537075235714, -82.2830581665039, -1.4361102836155, 218, 41, 'PPL', 'P'),
(108754, 'Crown City', 38.5805587768555, 0.673357777915324, -82.2783279418945, -1.43602772562171, 218, 58, 'PPL', 'P'),
(203657, 'Crown Colony', 40.6624984741211, 0.709694480460583, -111.84806060791, -1.9521169195782, 218, 52, 'PPL', 'P'),
(148137, 'Crown Heights', 41.6372184753418, 0.726706553766928, -73.9383316040039, -1.29046732992125, 218, 40, 'PPL', 'P'),
(108755, 'Crown Hill', 38.2000007629395, 0.666715787577639, -81.4138870239258, -1.42094038541419, 218, 58, 'PPL', 'P'),
(207146, 'Crown Hill', 47.6947212219238, 0.832429921143384, -122.374168395996, -2.13583215790012, 218, 56, 'PPL', 'P'),
(180966, 'Crown Jewel', 34.077220916748, 0.594759704926734, -117.209167480469, -2.04568588605565, 218, 6, 'PPL', 'P'),
(178044, 'Crown King', 34.2055587768555, 0.596999623140572, -112.337783813477, -1.96066420193876, 218, 5, 'PPL', 'P'),
(20394, 'Crown Mill Village', 34.7458305358887, 0.606429144191243, -84.970832824707, -1.48302080095281, 218, 13, 'PPL', 'P'),
(15678, 'Crown Point', 28.5880603790283, 0.498955780372982, -81.5672225952148, -1.42361659599361, 218, 12, 'PPL', 'P'),
(20395, 'Crown Point', 34.314998626709, 0.598909708853404, -83.8952789306641, -1.46424884421912, 218, 13, 'PPL', 'P'),
(39961, 'Crown Point', 29.7719402313232, 0.519618381743553, -90.0852813720703, -1.57228476752814, 218, 22, 'PPL', 'P'),
(72250, 'Crown Point', 39.7508316040039, 0.693782891895687, -84.267219543457, -1.47074043253424, 218, 41, 'PPL', 'P'),
(122457, 'Crown Point', 41.4169387817383, 0.722861947838262, -87.3652801513672, -1.52481179056861, 218, 19, 'PPL', 'P'),
(148134, 'Crown Point', 43.9502792358398, 0.767077079836303, -73.4375, -1.28172616943334, 218, 40, 'PPL', 'P'),
(200653, 'Crown Point', 43.3302803039551, 0.756256057116065, -124.306938171387, -2.16956535416372, 218, 43, 'PPL', 'P'),
(211774, 'Crown Point', 60.4225006103516, 1.05457157793892, -149.337493896484, -2.60643096517059, 218, 1, 'PPL', 'P'),
(148135, 'Crown Point Center', 43.9416694641113, 0.766926810971795, -73.4694366455078, -1.28228356904949, 218, 40, 'PPL', 'P'),
(207147, 'Crown Point Vista', 47.9713897705078, 0.837258698252888, -118.985832214355, -2.07669453536604, 218, 56, 'PPL', 'P'),
(180967, 'Crown Village', 38.6952781677246, 0.675360009001873, -121.084167480469, -2.11331739457043, 218, 6, 'PPL', 'P'),
(148138, 'Crowningshield', 44.3205604553223, 0.773539706274571, -73.5136108398438, -1.28305455418507, 218, 40, 'PPL', 'P'),
(72251, 'Crownover Mill', 39.6188888549805, 0.691480056501095, -83.2172164916992, -1.45241442212508, 218, 41, 'PPL', 'P'),
(188381, 'Crownpoint', 35.6780586242676, 0.622699593713028, -108.15055847168, -1.88758333320146, 218, 38, 'PPL', 'P'),
(124603, 'Crownridge Estates', 42.1883316040039, 0.736325292413049, -71.3213882446289, -1.24479305196195, 218, 23, 'PPL', 'P'),
(46135, 'Crownsville', 39.0283317565918, 0.681172890713189, -76.6016693115234, -1.33695134200998, 218, 25, 'PPL', 'P'),
(8343, 'Crows', 34.6141700744629, 0.604131235644668, -92.769172668457, -1.61912750741571, 218, 4, 'PPL', 'P'),
(101220, 'Crows', 37.7194404602051, 0.658328428040544, -80.2027816772461, -1.39980260952612, 218, 53, 'PPL', 'P'),
(80586, 'Crows (historical)', 34.7033309936523, 0.605687387248629, -81.9538879394531, -1.43036517935393, 218, 48, 'PPL', 'P'),
(15679, 'Crows Bluff', 29.0074996948242, 0.506276377445933, -81.3894424438477, -1.42051374700756, 218, 12, 'PPL', 'P'),
(1906, 'Crows Camp (historical)', 34.9008293151855, 0.609134383226546, -88.0361099243164, -1.53651997882698, 218, 2, 'PPL', 'P'),
(180968, 'Crows Landing', 37.3938903808594, 0.652646507275833, -121.070556640625, -2.11307984060119, 218, 6, 'PPL', 'P'),
(78096, 'Crows Mills', 39.9277801513672, 0.696871226653797, -80.5058288574219, -1.40509178060908, 218, 45, 'PPL', 'P'),
(29585, 'Crows Nest', 39.8580589294434, 0.695654361772713, -86.1686096191406, -1.50392594971966, 218, 19, 'PPL', 'P'),
(46136, 'Crows Nest', 38.3113899230957, 0.668659895173397, -75.648063659668, -1.32030778361948, 218, 25, 'PPL', 'P'),
(127187, 'Crows Nest', 44.3088912963867, 0.773336041030207, -68.9633331298828, -1.20363722626614, 218, 26, 'PPL', 'P'),
(190089, 'Crows Nest', 38.3516693115234, 0.669362903122151, -115.662498474121, -2.01869141945633, 218, 39, 'PPL', 'P'),
(115165, 'Crows Nest Resort', 43.3730583190918, 0.757002674327669, -95.1233291625977, -1.66021528934567, 218, 16, 'PPL', 'P'),
(39962, 'Crowson', 32.2794418334961, 0.563382540700502, -92.9844436645508, -1.62288469508159, 218, 22, 'PPL', 'P'),
(86149, 'Crowtexas', 35.2744407653809, 0.615655133155605, -88.1119384765625, -1.53784343673069, 218, 50, 'PPL', 'P'),
(93567, 'Crowther', 28.5883293151855, 0.498960474194404, -98.3916702270508, -1.71725860199851, 218, 51, 'PPL', 'P'),
(188382, 'Crowther Cow Camp', 36.7227783203125, 0.640933392169446, -106.341667175293, -1.85601222426884, 218, 38, 'PPL', 'P'),
(1907, 'Crowtown', 34.5444412231445, 0.602914237605529, -86.9205627441406, -1.51705000757157, 218, 2, 'PPL', 'P'),
(35452, 'Crowtown', 37.1277809143066, 0.648002020913762, -87.8936080932617, -1.53403285268495, 218, 21, 'PPL', 'P'),
(20396, 'Crowville', 34.0447196960449, 0.594192451614547, -84.7758331298828, -1.47961741423774, 218, 13, 'PPL', 'P'),
(39963, 'Crowville', 32.2405586242676, 0.562703900675723, -91.5899963378906, -1.59854699798574, 218, 22, 'PPL', 'P'),
(20397, 'Croxton Crossroads', 31.958610534668, 0.557782978192501, -84.3247222900391, -1.47174404479103, 218, 13, 'PPL', 'P'),
(143681, 'Croydon', 43.4505615234375, 0.758355360424348, -72.1636123657227, -1.25949263591475, 218, 36, 'PPL', 'P'),
(160579, 'Croydon', 40.0872192382813, 0.699653963676821, -74.9038925170898, -1.30731954698316, 218, 45, 'PPL', 'P'),
(203656, 'Croydon', 41.0686111450195, 0.716782483701829, -111.513061523438, -1.94627008256299, 218, 52, 'PPL', 'P'),
(160576, 'Croydon Acres', 40.098331451416, 0.699847908383206, -74.9022216796875, -1.30729038536922, 218, 45, 'PPL', 'P'),
(143682, 'Croydon Flat', 43.4150009155273, 0.757734710732305, -72.1875, -1.25990955378341, 218, 36, 'PPL', 'P'),
(160577, 'Croydon Heights', 40.0961112976074, 0.699809159389346, -74.8952789306641, -1.30716921153963, 218, 45, 'PPL', 'P'),
(46137, 'Croydon Park', 39.0869407653809, 0.682195810887888, -77.1436080932617, -1.34640995809556, 218, 25, 'PPL', 'P'),
(160578, 'Croyland', 41.3574981689453, 0.721824513435622, -78.8172225952148, -1.37562004156377, 218, 45, 'PPL', 'P'),
(101224, 'Crozet', 38.0694389343262, 0.664437053790913, -78.7008285522461, -1.37358858228426, 218, 53, 'PPL', 'P'),
(39964, 'Crozier', 29.5375003814697, 0.515526634465728, -90.7200012207031, -1.58336271871454, 218, 22, 'PPL', 'P'),
(101222, 'Crozier', 37.6366691589355, 0.65688379630723, -77.7975006103516, -1.35782253547293, 218, 53, 'PPL', 'P'),
(178045, 'Crozier', 35.4249992370605, 0.618282874203186, -113.648612976074, -1.98354248675725, 218, 5, 'PPL', 'P'),
(78099, 'Crozierville', 39.8849983215332, 0.696124542863166, -75.4444427490234, -1.31675392830282, 218, 45, 'PPL', 'P'),
(180969, 'Crucero', 35.0472183227539, 0.61168935339734, -116.16471862793, -2.02745681471016, 218, 6, 'PPL', 'P'),
(78098, 'Crucible', 39.9483299255371, 0.697229887873604, -79.9649963378906, -1.3956524724414, 218, 45, 'PPL', 'P'),
(86148, 'Crucifer', 35.646110534668, 0.622141994359792, -88.5500030517578, -1.5454891059042, 218, 50, 'PPL', 'P'),
(1908, 'Crudup', 34.1019401550293, 0.595191137023327, -86.0100021362305, -1.50115772692458, 218, 2, 'PPL', 'P'),
(59167, 'Cruger', 33.3208312988281, 0.581558215666129, -90.2322235107422, -1.57484939165789, 218, 30, 'PPL', 'P'),
(119279, 'Cruger', 40.7219390869141, 0.710731914863224, -89.3099975585938, -1.55875351234556, 218, 18, 'PPL', 'P'),
(148139, 'Crugers', 41.2333297729492, 0.71965736609857, -73.9230575561523, -1.29020074749613, 218, 40, 'PPL', 'P'),
(35454, 'Cruise', 37.3183288574219, 0.651327709904025, -84.1230621337891, -1.46822441109439, 218, 21, 'PPL', 'P'),
(54287, 'Cruise Mill', 38.0825004577637, 0.664665020380224, -90.732780456543, -1.58358575845584, 218, 29, 'PPL', 'P'),
(35455, 'Crum', 38.4597206115723, 0.671248754069063, -83.4505615234375, -1.45648706122208, 218, 21, 'PPL', 'P'),
(108756, 'Crum', 37.9055595397949, 0.661576818780168, -82.4461135864258, -1.43895613755636, 218, 58, 'PPL', 'P'),
(148140, 'Crum Creek', 43.0394401550293, 0.75117993892032, -74.7141723632813, -1.30400830564181, 218, 40, 'PPL', 'P'),
(78100, 'Crum Creek Manor', 39.8811111450195, 0.696056698834397, -75.3775024414063, -1.3155855995326, 218, 45, 'PPL', 'P'),
(78101, 'Crum Lynne', 39.8722190856934, 0.695901503121872, -75.3283309936523, -1.31472739587133, 218, 45, 'PPL', 'P'),
(148141, 'Crum Town', 42.2552795410156, 0.737493754341321, -76.4449996948242, -1.33421694136074, 218, 40, 'PPL', 'P'),
(160581, 'Crumb', 40.1483306884766, 0.700720559693398, -78.726936340332, -1.37404424914677, 218, 45, 'PPL', 'P'),
(122458, 'Crumb Corner', 40.4538917541504, 0.706053606355309, -86.9277801513672, -1.51717597509113, 218, 19, 'PPL', 'P'),
(191344, 'Crume Gin', 34.2724990844727, 0.59816795191079, -101.519721984863, -1.77185340434514, 218, 51, 'PPL', 'P'),
(1909, 'Crumley Chapel', 33.5705604553223, 0.58591681168518, -86.9127807617188, -1.51691418635598, 218, 2, 'PPL', 'P'),
(35456, 'Crummies', 36.7744407653809, 0.64183507193552, -83.2038879394531, -1.45218179500386, 218, 21, 'PPL', 'P'),
(54288, 'Crump', 37.2786102294922, 0.650634489072278, -89.8291702270508, -1.5678147847965, 218, 29, 'PPL', 'P'),
(59168, 'Crump', 32.9888916015625, 0.575764775030771, -90.4194412231445, -1.57811695715736, 218, 30, 'PPL', 'P'),
(86150, 'Crump', 35.2216682434082, 0.614734078892601, -88.3180618286133, -1.54144096788923, 218, 50, 'PPL', 'P'),
(130383, 'Crump', 43.7538909912109, 0.763649458355316, -84.0872192382813, -1.46759883455433, 218, 27, 'PPL', 'P'),
(8344, 'Crump (historical)', 36.4894409179688, 0.636860886230497, -94.5058288574219, -1.64943787588828, 218, 4, 'PPL', 'P'),
(64063, 'Crump Town', 34.8866691589355, 0.608887241877386, -79.3566665649414, -1.38503511496553, 218, 33, 'PPL', 'P'),
(54289, 'Crumpecker (historical)', 36.6083297729492, 0.638935888193832, -89.8663864135742, -1.56846432978637, 218, 29, 'PPL', 'P'),
(64064, 'Crumpler', 36.5038909912109, 0.637113087585727, -81.3944396972656, -1.42060096553326, 218, 33, 'PPL', 'P'),
(108762, 'Crumpler', 37.4247207641602, 0.653184598974083, -81.3419418334961, -1.41968470496022, 218, 58, 'PPL', 'P'),
(8345, 'Crumpler Subdivision', 36.4736099243164, 0.636584583267401, -93.0486068725586, -1.62400455431997, 218, 4, 'PPL', 'P'),
(64065, 'Crumplers Crossroads', 35.5402793884277, 0.620294892406741, -78.2361068725586, -1.36547765886831, 218, 33, 'PPL', 'P'),
(108757, 'Crumps Bottom', 37.5083312988281, 0.654643878093392, -80.8447189331055, -1.41100652823209, 218, 58, 'PPL', 'P'),
(101223, 'Crumps Mill', 37.5400009155273, 0.655196617177638, -77.0888900756836, -1.34545494852866, 218, 53, 'PPL', 'P'),
(46138, 'Crumpton', 39.2413902282715, 0.684891462543267, -75.9219436645508, -1.32508789146006, 218, 25, 'PPL', 'P'),
(1910, 'Crumptonia', 32.2136116027832, 0.562233586427215, -87.289436340332, -1.52348806634878, 218, 2, 'PPL', 'P'),
(8346, 'Crumrod', 34.148609161377, 0.596005664842727, -90.9816665649414, -1.58792964050987, 218, 4, 'PPL', 'P'),
(160582, 'Crums Corners', 40.3616714477539, 0.704444058371492, -77.1716690063477, -1.34689971342003, 218, 45, 'PPL', 'P'),
(122459, 'Crumstown', 41.6241683959961, 0.726478786914699, -86.4080581665039, -1.50810511526027, 218, 19, 'PPL', 'P'),
(59169, 'Crumtown', 34.839168548584, 0.608058199830045, -88.7333297729492, -1.54868876079588, 218, 30, 'PPL', 'P'),
(86151, 'Crunk', 36.4238891601563, 0.635716792226199, -86.8936080932617, -1.51657956016501, 218, 50, 'PPL', 'P'),
(59170, 'Crupp', 32.7852783203125, 0.572211052872169, -90.4663925170898, -1.57893641182478, 218, 30, 'PPL', 'P'),
(32184, 'Cruppers Corner', 37.9700012207031, 0.662701538287536, -97.9400024414063, -1.70937551201382, 218, 20, 'PPL', 'P'),
(26898, 'Cruse', 38.8216705322266, 0.677565971911813, -88.6777801513672, -1.54771923700103, 218, 18, 'PPL', 'P'),
(8347, 'Cruse (historical)', 33.9550018310547, 0.592626579472608, -92.6666717529297, -1.61733852895345, 218, 4, 'PPL', 'P'),
(39965, 'Crusel (historical)', 30.3549995422363, 0.529794686453395, -91.6763916015625, -1.60005487979494, 218, 22, 'PPL', 'P'),
(75587, 'Crusher', 34.3505592346191, 0.599530358545447, -97.029167175293, -1.69347843767687, 218, 42, 'PPL', 'P'),
(191345, 'Crusher', 31.0669403076172, 0.54222039688846, -104.961936950684, -1.83193138906013, 218, 51, 'PPL', 'P'),
(108758, 'Crusher (historical)', 37.2847213745117, 0.650741148673935, -81.1708297729492, -1.41669823611381, 218, 58, 'PPL', 'P'),
(64067, 'Cruso', 35.4174995422363, 0.618151979835608, -82.8108291625977, -1.44532162519387, 218, 33, 'PPL', 'P'),
(35457, 'Crutchfield', 36.5766716003418, 0.638383348846668, -88.9352798461914, -1.5522134544986, 218, 21, 'PPL', 'P'),
(64066, 'Crutchfield', 36.2705612182617, 0.633040714804833, -80.7227783203125, -1.40887826304695, 218, 33, 'PPL', 'P'),
(20398, 'Crutchfield (historical)', 33.1011085510254, 0.577723330275443, -83.6736068725586, -1.4603799369455, 218, 13, 'PPL', 'P'),
(64069, 'Crutchfield Crossroads', 35.8083305358887, 0.624973267493683, -79.4327774047852, -1.38636349971726, 218, 33, 'PPL', 'P'),
(93568, 'Cruz Calle', 27.3866691589355, 0.477987547977812, -98.2702789306641, -1.7151399241933, 218, 51, 'PPL', 'P'),
(207148, 'Cruzatt', 45.5913887023926, 0.795719843413296, -122.151672363281, -2.13194886955662, 218, 56, 'PPL', 'P'),
(101225, 'Cruzes Store', 36.6766700744629, 0.640128651467051, -80.2780609130859, -1.40111648004992, 218, 53, 'PPL', 'P'),
(188383, 'Cruzville', 33.8072204589844, 0.590047307956866, -108.66471862793, -1.89655712081059, 218, 38, 'PPL', 'P'),
(93569, 'Cryer Creek', 32.1291694641113, 0.560759793079965, -96.6566696166992, -1.68697712882377, 218, 51, 'PPL', 'P'),
(29586, 'Crystal', 38.4919395446777, 0.671811080533233, -86.7538909912109, -1.51414103671288, 218, 19, 'PPL', 'P'),
(35458, 'Crystal', 37.663330078125, 0.657349117128694, -83.8255615234375, -1.46303204591706, 218, 21, 'PPL', 'P'),
(75589, 'Crystal', 34.2266693115234, 0.597368071477385, -95.9300003051758, -1.67429435676448, 218, 42, 'PPL', 'P'),
(78102, 'Crystal', 39.747501373291, 0.693724768404896, -79.8247222900391, -1.39320422845129, 218, 45, 'PPL', 'P'),
(86152, 'Crystal', 36.4627799987793, 0.636395565409033, -89.1755599975586, -1.55640713426714, 218, 50, 'PPL', 'P'),
(127188, 'Crystal', 45.959171295166, 0.802138860588714, -68.3608322143555, -1.19312160154391, 218, 26, 'PPL', 'P'),
(130380, 'Crystal', 43.2630615234375, 0.755082868076858, -84.9147186279297, -1.48204142346193, 218, 27, 'PPL', 'P'),
(134877, 'Crystal', 45.0327796936035, 0.785970276978625, -93.3600006103516, -1.62943940031455, 218, 28, 'PPL', 'P'),
(139847, 'Crystal', 48.5969390869141, 0.848176593457777, -97.6691665649414, -1.70464853423699, 218, 34, 'PPL', 'P'),
(143684, 'Crystal', 44.6188888549805, 0.778746519100812, -71.3302764892578, -1.24494818109545, 218, 36, 'PPL', 'P'),
(186598, 'Crystal', 39.0591697692871, 0.681711115569494, -107.100563049316, -1.86925745595035, 218, 7, 'PPL', 'P'),
(188384, 'Crystal', 36.0458297729492, 0.629118411151364, -108.965560913086, -1.90180780921579, 218, 38, 'PPL', 'P'),
(190090, 'Crystal', 36.4916687011719, 0.636899768382412, -116.16667175293, -2.02749090317212, 218, 39, 'PPL', 'P'),
(194800, 'Crystal', 44.1672210693359, 0.770863429116123, -116.889999389648, -2.04011535200353, 218, 17, 'PPL', 'P'),
(190091, 'Crystal (historical)', 36.5013885498047, 0.63706941174385, -114.761940002441, -2.00297370901879, 218, 39, 'PPL', 'P'),
(194801, 'Crystal (historical)', 44.2675018310547, 0.772613658584523, -114.324996948242, -1.9953476140793, 218, 17, 'PPL', 'P'),
(200654, 'Crystal (historical)', 42.5763893127441, 0.743098177118311, -122.080558776855, -2.13070770333059, 218, 43, 'PPL', 'P'),
(20405, 'Crystal Acres', 33.6105613708496, 0.586614959364945, -84.4441680908203, -1.47382876729235, 218, 13, 'PPL', 'P'),
(134878, 'Crystal Bay', 44.9530601501465, 0.784578908467113, -93.5761108398438, -1.63321123536643, 218, 28, 'PPL', 'P'),
(190092, 'Crystal Bay', 39.2261085510254, 0.684624746960095, -120.003059387207, -2.09444849877305, 218, 39, 'PPL', 'P'),
(15680, 'Crystal Beach', 28.0911102294922, 0.490282364045299, -82.7799987792969, -1.44478353349562, 218, 12, 'PPL', 'P'),
(46139, 'Crystal Beach', 39.0713882446289, 0.681924368193782, -76.519172668457, -1.33551150396663, 218, 25, 'PPL', 'P'),
(93570, 'Crystal Beach', 29.4569396972656, 0.514120585278707, -94.6394424438477, -1.65176987289681, 218, 51, 'PPL', 'P'),
(130382, 'Crystal Beach', 42.3566703796387, 0.739263358306651, -86.2980575561523, -1.50618524243043, 218, 27, 'PPL', 'P'),
(148142, 'Crystal Beach', 42.8136100769043, 0.747238460507003, -77.2638931274414, -1.34850932798287, 218, 40, 'PPL', 'P'),
(171892, 'Crystal Beach', 43.6594390869141, 0.762000961640557, -73.190559387207, -1.27741624268321, 218, 55, 'PPL', 'P'),
(108759, 'Crystal Block', 37.7077789306641, 0.658124895954235, -81.9886093139648, -1.43097118165998, 218, 58, 'PPL', 'P'),
(148143, 'Crystal Brook', 40.9477806091309, 0.714673593013623, -73.0425033569336, -1.2748321774775, 218, 40, 'PPL', 'P'),
(54290, 'Crystal City', 38.2211112976074, 0.667084235914452, -90.3788909912109, -1.57740922209767, 218, 29, 'PPL', 'P'),
(93571, 'Crystal City', 28.6772193908691, 0.500511898687429, -99.8277816772461, -1.74232347523001, 218, 51, 'PPL', 'P'),
(180970, 'Crystal Cove', 33.5752792358398, 0.585999169941891, -117.840560913086, -2.05670578033029, 218, 6, 'PPL', 'P'),
(148144, 'Crystal Dale', 43.8213882446289, 0.764827507663513, -75.3333282470703, -1.31481461439703, 218, 40, 'PPL', 'P'),
(80591, 'Crystal Falls', 34.7602806091309, 0.606681345546474, -83.0236129760742, -1.44903540333398, 218, 48, 'PPL', 'P'),
(93572, 'Crystal Falls', 32.8955612182617, 0.574135852550024, -98.9000015258789, -1.726130656854, 218, 51, 'PPL', 'P'),
(130386, 'Crystal Falls', 46.0980606079102, 0.804562936391931, -88.3338928222656, -1.54171727085232, 218, 27, 'PPL', 'P'),
(180973, 'Crystal Falls', 38.0202789306641, 0.663579049866717, -120.27082824707, -2.09912194701198, 218, 6, 'PPL', 'P'),
(211775, 'Crystal Falls', 60.4858283996582, 1.05567685637033, -145.72917175293, -2.54345386329294, 218, 1, 'PPL', 'P'),
(196308, 'Crystal Ford', 48.6088905334473, 0.848385185550158, -113.847778320313, -1.98701857777007, 218, 31, 'PPL', 'P'),
(119281, 'Crystal Gardens', 42.2336082458496, 0.737115518887502, -88.379997253418, -1.54252194497569, 218, 18, 'PPL', 'P'),
(15681, 'Crystal Heights', 28.7574996948242, 0.501913054315947, -81.3344421386719, -1.41955381059264, 218, 12, 'PPL', 'P'),
(8349, 'Crystal Hill', 34.8147201538086, 0.607631494844387, -92.3208312988281, -1.61130247434278, 218, 4, 'PPL', 'P'),
(101226, 'Crystal Hill', 36.8555603027344, 0.643250874950033, -78.9091720581055, -1.37722486243665, 218, 53, 'PPL', 'P'),
(20399, 'Crystal Hills', 33.9072189331055, 0.591792610577249, -83.4172210693359, -1.4559051605239, 218, 13, 'PPL', 'P'),
(15684, 'Crystal Lake', 30.4438896179199, 0.531346110946421, -85.688606262207, -1.49554831072054, 218, 12, 'PPL', 'P'),
(80588, 'Crystal Lake', 33.6522216796875, 0.587342068921563, -78.9541702270508, -1.37801022864212, 218, 48, 'PPL', 'P'),
(93573, 'Crystal Lake', 31.7393207550049, 0.553955649521408, -95.5049285888672, -1.66687545575779, 218, 51, 'PPL', 'P'),
(113067, 'Crystal Lake', 41.9316711425781, 0.731845722301481, -72.3788909912109, -1.26324995673869, 218, 8, 'PPL', 'P'),
(115166, 'Crystal Lake', 43.223331451416, 0.754389447508029, -93.7922210693359, -1.63698307041831, 218, 16, 'PPL', 'P'),
(119282, 'Crystal Lake', 42.2411117553711, 0.737246479834107, -88.3161087036133, -1.54140687942727, 218, 18, 'PPL', 'P'),
(145072, 'Crystal Lake', 41.0188903808594, 0.715914692660627, -74.2127838134766, -1.29525742461592, 218, 37, 'PPL', 'P'),
(180971, 'Crystal Lake', 39.3227806091309, 0.686311992668715, -120.56916809082, -2.1043289595753, 218, 6, 'PPL', 'P'),
(54291, 'Crystal Lake Park', 38.6222190856934, 0.674084887471943, -90.4341735839844, -1.57837408536061, 218, 29, 'PPL', 'P'),
(15685, 'Crystal Lake Shores', 28.7588901519775, 0.50193732237138, -81.3233337402344, -1.41935993246528, 218, 12, 'PPL', 'P'),
(54292, 'Crystal Lakes', 39.3594398498535, 0.686951817120606, -94.1897201538086, -1.64392073821602, 218, 29, 'PPL', 'P'),
(72252, 'Crystal Lakes', 39.8891716003418, 0.69619738031898, -84.0266723632813, -1.46654209223378, 218, 41, 'PPL', 'P'),
(75590, 'Crystal Lakes', 36.2125015258789, 0.632027382010057, -98.2236099243164, -1.7143253963739, 218, 42, 'PPL', 'P'),
(72253, 'Crystal Lakes Mobile Home Park', 39.8916702270508, 0.69624098958183, -84.0227813720703, -1.46647418162599, 218, 41, 'PPL', 'P'),
(119283, 'Crystal Lawns', 41.5702781677246, 0.72553822499671, -88.1580581665039, -1.53864837717017, 218, 18, 'PPL', 'P'),
(119284, 'Crystal Manor', 42.2230606079102, 0.736931427877151, -88.2916717529297, -1.5409803741787, 218, 18, 'PPL', 'P'),
(203660, 'Crystal Manor Condominium', 41.2511100769043, 0.719967690944591, -111.97306060791, -1.9542985811432, 218, 52, 'PPL', 'P'),
(80589, 'Crystal Oaks', 33.5602798461914, 0.585737381206736, -79.033332824707, -1.37939187661565, 218, 48, 'PPL', 'P'),
(154909, 'Crystal Park', 40.8116683959961, 0.712297986742245, -81.3433303833008, -1.41970893972614, 218, 41, 'PPL', 'P'),
(190093, 'Crystal Peak (historical)', 39.5252799987793, 0.689846273751359, -119.995559692383, -2.09431760440547, 218, 39, 'PPL', 'P'),
(39966, 'Crystal Place', 30.5833301544189, 0.533779807419076, -91.0199966430664, -1.58859862657569, 218, 22, 'PPL', 'P'),
(15686, 'Crystal Point', 28.7686100006104, 0.502106965732819, -81.3280563354492, -1.41944235730102, 218, 12, 'PPL', 'P'),
(196309, 'Crystal Point', 48.7516708374023, 0.850877171961172, -113.786666870117, -1.9859519817535, 218, 31, 'PPL', 'P'),
(15687, 'Crystal River', 28.9022197723389, 0.504438896162319, -82.5927810668945, -1.44151596799614, 218, 12, 'PPL', 'P'),
(154910, 'Crystal Rock', 41.4463882446289, 0.723375937928647, -82.8447189331055, -1.44591311327197, 218, 41, 'PPL', 'P'),
(148145, 'Crystal Run', 41.4594383239746, 0.723603704780876, -74.3411102294922, -1.29749714309268, 218, 40, 'PPL', 'P'),
(13622, 'Crystal Run Farm', 39.5149993896484, 0.689666843272915, -75.7002792358398, -1.3212191173445, 218, 10, 'PPL', 'P'),
(78103, 'Crystal Spring', 39.9497184753418, 0.697254122639523, -78.228889465332, -1.36535169134875, 218, 45, 'PPL', 'P'),
(101227, 'Crystal Spring', 37.2452812194824, 0.650052788111177, -79.9555587768555, -1.39548775592798, 218, 53, 'PPL', 'P'),
(130388, 'Crystal Spring', 44.8244400024414, 0.782334063405258, -85.6486129760742, -1.49485029619883, 218, 27, 'PPL', 'P'),
(134880, 'Crystal Spring', 44.0747184753418, 0.76924895428429, -91.9861068725586, -1.60546043101753, 218, 28, 'PPL', 'P'),
(148146, 'Crystal Spring', 42.4877815246582, 0.741551679473302, -77.0522232055664, -1.34481499091871, 218, 40, 'PPL', 'P'),
(101228, 'Crystal Spring Knolls', 38.9033317565918, 0.678991229148196, -77.1052780151367, -1.34574097202973, 218, 53, 'PPL', 'P'),
(108760, 'Crystal Spring Lake', 39.2347183227539, 0.684775015824603, -81.6736068725586, -1.42547335190562, 218, 58, 'PPL', 'P'),
(1911, 'Crystal Springs', 33.8566703796387, 0.590910371887133, -85.908332824707, -1.49938326269026, 218, 2, 'PPL', 'P'),
(8350, 'Crystal Springs', 34.5219383239746, 0.60252148792377, -93.3358306884766, -1.62901755559788, 218, 4, 'PPL', 'P'),
(15688, 'Crystal Springs', 28.1811103820801, 0.491853163035255, -82.1577835083008, -1.43392382836055, 218, 12, 'PPL', 'P'),
(20402, 'Crystal Springs', 33.4041709899902, 0.583012767674503, -84.288330078125, -1.47110888087105, 218, 13, 'PPL', 'P'),
(32186, 'Crystal Springs', 37.2619400024414, 0.650343538723187, -98.1344375610352, -1.71276904503286, 218, 20, 'PPL', 'P'),
(59171, 'Crystal Springs', 31.9872207641602, 0.558282320896891, -90.3569412231445, -1.57702612637486, 218, 30, 'PPL', 'P'),
(86153, 'Crystal Springs', 35.0741691589355, 0.612159734224876, -86.4608306884766, -1.50902616952327, 218, 50, 'PPL', 'P'),
(101229, 'Crystal Springs', 38.8411102294922, 0.677905258634689, -77.3841705322266, -1.35060856471213, 218, 53, 'PPL', 'P'),
(108761, 'Crystal Springs', 38.9408302307129, 0.679645700986083, -79.8775024414063, -1.39412541587235, 218, 58, 'PPL', 'P'),
(139849, 'Crystal Springs', 46.8783302307129, 0.818181210363133, -99.4752807617188, -1.73617117363777, 218, 34, 'PPL', 'P'),
(154911, 'Crystal Springs', 40.8491706848145, 0.712952525159159, -81.5344390869141, -1.42304441583341, 218, 41, 'PPL', 'P'),
(160583, 'Crystal Springs', 41.5361099243164, 0.724941876649614, -79.3300018310547, -1.38456972756503, 218, 45, 'PPL', 'P'),
(190094, 'Crystal Springs', 37.5316696166992, 0.65505120858212, -115.233062744141, -2.01119635204247, 218, 39, 'PPL', 'P'),
(203661, 'Crystal Springs', 41.6602783203125, 0.727109023986666, -112.086669921875, -1.95628143773281, 218, 52, 'PPL', 'P'),
(207149, 'Crystal Springs', 47.6036109924316, 0.830839747656498, -122.573890686035, -2.13931796945092, 218, 56, 'PPL', 'P'),
(180972, 'Crystal Springs (historical)', 39.2594413757324, 0.685206514500223, -120.974998474121, -2.11141203596853, 218, 6, 'PPL', 'P'),
(8351, 'Crystal Springs Landing', 34.5472183227539, 0.602962707137369, -93.3611068725586, -1.62945870823245, 218, 4, 'PPL', 'P'),
(20403, 'Crystal Valley', 32.5158309936523, 0.567508309861253, -84.8855590820313, -1.48153249337762, 218, 13, 'PPL', 'P'),
(130389, 'Crystal Valley', 43.7738914489746, 0.763998532195198, -86.2375030517578, -1.50512836695183, 218, 27, 'PPL', 'P'),
(80590, 'Crystal View', 33.9038887023926, 0.591734487086458, -81.1563873291016, -1.41644616791663, 218, 48, 'PPL', 'P'),
(119285, 'Crystal Vista', 42.2386093139648, 0.73720280399223, -88.3711090087891, -1.54236681584219, 218, 18, 'PPL', 'P'),
(130392, 'Crystallia', 44.6730613708496, 0.779692007866817, -86.2474975585938, -1.50530280400323, 218, 27, 'PPL', 'P'),
(186599, 'Crystola', 38.9558296203613, 0.679907489721238, -105.026672363281, -1.83306123515259, 218, 7, 'PPL', 'P'),
(191347, 'Cuadrilla', 31.5330600738525, 0.550355721517893, -106.199996948242, -1.85353961235476, 218, 51, 'PPL', 'P'),
(188385, 'Cuates (historical)', 36.785831451416, 0.642033876910894, -103.323333740234, -1.80333236790404, 218, 38, 'PPL', 'P'),
(191346, 'Cuatro Caminos', 30.8558292388916, 0.538535813651794, -103.593330383301, -1.80804469829488, 218, 51, 'PPL', 'P'),
(93574, 'Cuatro Vientos Colonia', 26.2280006408691, 0.457764967398349, -98.3649978637695, -1.71679308143997, 218, 51, 'PPL', 'P'),
(158, 'Cub City', 37.6105613708496, 0.656428129444718, -81.7991714477539, -1.42766486716664, 218, 58, 'PPL', 'P'),
(86154, 'Cub Creek', 36.4002799987793, 0.635304734626536, -85.7158279418945, -1.49602341865901, 218, 50, 'PPL', 'P'),
(46140, 'Cub Hill', 39.4088897705078, 0.687814881050874, -76.5138931274414, -1.33541935859291, 218, 25, 'PPL', 'P'),
(46141, 'Cub Hill Farms', 39.4152793884277, 0.687926400921521, -76.5305633544922, -1.33571030894201, 218, 25, 'PPL', 'P'),
(46142, 'Cub Hills', 39.4155616760254, 0.687931327769538, -76.51611328125, -1.33545810758677, 218, 25, 'PPL', 'P'),
(59172, 'Cub Lake', 34.7863883972168, 0.607137012408986, -90.149169921875, -1.57339983307656, 218, 30, 'PPL', 'P'),
(35460, 'Cub Run', 37.3055610656738, 0.651104869899813, -86.0608291625977, -1.50204482588368, 218, 21, 'PPL', 'P'),
(1912, 'Cuba', 32.4280586242676, 0.565976393023212, -88.3763885498047, -1.54245896121591, 218, 2, 'PPL', 'P'),
(20404, 'Cuba', 31.2922191619873, 0.546152254632339, -84.8641662597656, -1.48115911819279, 218, 13, 'PPL', 'P'),
(32188, 'Cuba', 39.8027801513672, 0.694689565088804, -97.4555587768555, -1.70092037502699, 218, 20, 'PPL', 'P'),
(35461, 'Cuba', 36.5849990844727, 0.638528690863159, -88.6291732788086, -1.54687088703579, 218, 21, 'PPL', 'P'),
(39971, 'Cuba', 32.2838897705078, 0.563460171846278, -92.0966720581055, -1.6073901575434, 218, 22, 'PPL', 'P'),
(54294, 'Cuba', 38.0627784729004, 0.664320806809331, -91.4033279418945, -1.59528901986619, 218, 29, 'PPL', 'P'),
(59173, 'Cuba', 34.9749984741211, 0.610428879253406, -88.6944427490234, -1.54801005419207, 218, 30, 'PPL', 'P'),
(86156, 'Cuba', 35.351390838623, 0.616998165293332, -89.9872207641602, -1.5705732870536, 218, 50, 'PPL', 'P'),
(93575, 'Cuba', 32.3138885498047, 0.563983749316587, -97.2688903808594, -1.69766239690744, 218, 51, 'PPL', 'P'),
(108765, 'Cuba', 38.9911117553711, 0.680523279144291, -81.6691665649414, -1.4253958539179, 218, 58, 'PPL', 'P'),
(119287, 'Cuba', 42.1838912963867, 0.736247794425327, -88.1908264160156, -1.53922029101426, 218, 18, 'PPL', 'P'),
(122460, 'Cuba', 41.1855583190918, 0.718823596940293, -84.938606262207, -1.48245834133059, 218, 19, 'PPL', 'P'),
(139853, 'Cuba', 46.8213882446289, 0.817187385223343, -97.8622207641602, -1.70801796564816, 218, 34, 'PPL', 'P'),
(148147, 'Cuba', 42.2174987792969, 0.736834355655417, -78.2755584716797, -1.36616621916815, 218, 40, 'PPL', 'P'),
(154912, 'Cuba', 41.0533294677734, 0.716515768118658, -84.1983337402344, -1.46953814846012, 218, 41, 'PPL', 'P'),
(192940, 'Cuba', 36.0222206115723, 0.628706353551701, -106.957778930664, -1.86676540296031, 218, 38, 'PPL', 'P'),
(64070, 'Cuba (historical)', 35.4747200012207, 0.619150665244388, -82.0041732788086, -1.43124282409116, 218, 33, 'PPL', 'P'),
(86157, 'Cuba (historical)', 35.5061111450195, 0.619698544059645, -86.9622192382813, -1.51777705054916, 218, 50, 'PPL', 'P'),
(180974, 'Cuba (historical)', 37.357780456543, 0.652016270203865, -120.567222595215, -2.1042950042714, 218, 6, 'PPL', 'P'),
(173702, 'Cuba City', 42.6055603027344, 0.743607306939707, -90.4297180175781, -1.57829632105678, 218, 57, 'PPL', 'P'),
(160584, 'Cuba Mills', 40.5905609130859, 0.708438933164665, -77.4069366455078, -1.35100590834677, 218, 45, 'PPL', 'P'),
(35462, 'Cubage', 36.7011108398438, 0.640555223294655, -83.521110534668, -1.45771837375208, 218, 21, 'PPL', 'P'),
(108763, 'Cubana', 38.8230590820313, 0.677590206677733, -80.0991668701172, -1.39799418998791, 218, 58, 'PPL', 'P'),
(180975, 'Cubbler Place', 39.7527809143066, 0.693816913778613, -123.148612976074, -2.14934876569671, 218, 6, 'PPL', 'P'),
(209947, 'Cube Cove', 57.935001373291, 1.01115652611136, -134.71110534668, -2.3511523273005, 218, 1, 'PPL', 'P'),
(188386, 'Cubero', 35.0858306884766, 0.612363266311185, -107.517501831055, -1.87653441047094, 218, 38, 'PPL', 'P'),
(15689, 'Cubitis', 27.2597198486328, 0.475771864529893, -81.8408279418945, -1.42839191014423, 218, 12, 'PPL', 'P'),
(178046, 'Cucamonga Junction', 35.3025016784668, 0.61614488848007, -112.384719848633, -1.96148339029007, 218, 5, 'PPL', 'P'),
(186600, 'Cuchara', 37.3791694641113, 0.652389578809667, -105.099716186523, -1.83433609036641, 218, 7, 'PPL', 'P'),
(186601, 'Cuchara Junction', 37.6669387817383, 0.657412100888475, -104.685562133789, -1.82710773853572, 218, 7, 'PPL', 'P'),
(188388, 'Cuchillo', 33.2358283996582, 0.580074635201873, -107.360000610352, -1.87378549559376, 218, 38, 'PPL', 'P'),
(101231, 'Cuckoo', 37.9519386291504, 0.662386286593498, -77.9002838134766, -1.35961644078321, 218, 53, 'PPL', 'P'),
(108764, 'Cucumber', 37.2777786254883, 0.650619974844337, -81.6269378662109, -1.42465882408622, 218, 58, 'PPL', 'P'),
(173704, 'Cudahy', 42.9597206115723, 0.749788570408808, -87.8613891601563, -1.53347052622078, 218, 57, 'PPL', 'P'),
(180978, 'Cudahy', 33.9605598449707, 0.592723585115314, -118.184440612793, -2.06270761332094, 218, 6, 'PPL', 'P'),
(148149, 'Cuddebackville', 41.4672203063965, 0.723739525996471, -74.5941696166992, -1.30191386260252, 218, 40, 'PPL', 'P'),
(160586, 'Cuddy Hill', 40.3491706848145, 0.704225878899187, -80.1608276367188, -1.39907037338441, 218, 45, 'PPL', 'P'),
(93576, 'Cude Crossing Windmill', 28.8788890838623, 0.504031698831646, -99.2050018310547, -1.73145391639891, 218, 51, 'PPL', 'P'),
(188389, 'Cudei', 36.8583297729492, 0.643299211323818, -108.775833129883, -1.89849643471638, 218, 38, 'PPL', 'P'),
(154913, 'Cudell', 41.4749984741211, 0.723875280633037, -81.7522201538086, -1.42684541249923, 218, 41, 'PPL', 'P'),
(15690, 'Cudjoe Key', 24.6711101531982, 0.430592102295512, -81.4986114501953, -1.42241910560946, 218, 12, 'PPL', 'P'),
(13621, 'Cuelen Acres', 38.5252799987793, 0.672392981231416, -75.2188873291016, -1.31281724357947, 218, 10, 'PPL', 'P'),
(93577, 'Cuellar Colonia', 26.9249992370605, 0.469929887783668, -99.2620010375977, -1.73244874022411, 218, 51, 'PPL', 'P'),
(93578, 'Cuellar Colonia Number 1', 26.132999420166, 0.456106883303666, -97.9700012207031, -1.70989908948413, 218, 51, 'PPL', 'P'),
(93579, 'Cuellar Colonia Number 2', 26.1319999694824, 0.456089439598526, -97.9700012207031, -1.70989908948413, 218, 51, 'PPL', 'P'),
(93580, 'Cuellar Colonia Number 3', 26.1340007781982, 0.45612436029832, -97.9720001220703, -1.70993397689441, 218, 51, 'PPL', 'P'),
(93581, 'Cuellar Colonia Number 4', 26.1340007781982, 0.45612436029832, -97.9700012207031, -1.70989908948413, 218, 51, 'PPL', 'P'),
(186602, 'Cuerna Verde Park', 37.9219398498535, 0.661862709123188, -104.970832824707, -1.83208665135168, 218, 7, 'PPL', 'P'),
(93582, 'Cuero', 29.0936107635498, 0.507779299117606, -97.2888870239258, -1.69801140416829, 218, 51, 'PPL', 'P'),
(188390, 'Cuervo', 35.0311088562012, 0.611408190165255, -104.408058166504, -1.82226438061925, 218, 38, 'PPL', 'P'),
(188391, 'Cuervo Crossing', 35.334171295166, 0.616697627564316, -107.017219543457, -1.86780283736295, 218, 38, 'PPL', 'P'),
(180979, 'Cuesta Oaks', 38.0022201538086, 0.663263864751706, -120.384437561035, -2.1011048036016, 218, 6, 'PPL', 'P'),
(180980, 'Cuesta Serena', 37.9466705322266, 0.662294340956863, -120.38500213623, -2.10111465729763, 218, 6, 'PPL', 'P'),
(180981, 'Cuesta-by-the-Sea', 35.3183288574219, 0.616421124864139, -120.845832824707, -2.10915767010578, 218, 6, 'PPL', 'P'),
(59174, 'Cuevas', 30.3624992370605, 0.529925580820973, -89.2180633544922, -1.55714895778879, 218, 30, 'PPL', 'P'),
(93584, 'Cuevitas', 26.8255596160889, 0.468194338990777, -98.8611068725586, -1.72545181709214, 218, 51, 'PPL', 'P'),
(20407, 'Cuffietown', 31.735559463501, 0.553890002600537, -83.8163909912109, -1.46287198993554, 218, 13, 'PPL', 'P'),
(54295, 'Cuivre Heights', 39.0291709899902, 0.681187538099184, -90.9927825927734, -1.58812365179528, 218, 29, 'PPL', 'P'),
(64071, 'Culberson', 34.9916687011719, 0.610719829602497, -84.1677780151367, -1.46900485045183, 218, 33, 'PPL', 'P'),
(39967, 'Culbertson', 32.6861114501953, 0.570480264479727, -92.5127792358398, -1.61465259783605, 218, 22, 'PPL', 'P'),
(160587, 'Culbertson', 40.253059387207, 0.702548420307574, -77.7538909912109, -1.35706140403339, 218, 45, 'PPL', 'P'),
(196310, 'Culbertson', 48.1444396972656, 0.840278989245147, -104.516387939453, -1.82415509183515, 218, 31, 'PPL', 'P'),
(199257, 'Culbertson', 40.2297210693359, 0.702141089818846, -100.83805847168, -1.75995613164937, 218, 35, 'PPL', 'P'),
(64073, 'Culbreth', 36.2636108398438, 0.632919407817179, -78.727783203125, -1.37405902969082, 218, 33, 'PPL', 'P'),
(194802, 'Culdesac', 46.3747215270996, 0.809391580343381, -116.672218322754, -2.03631435533771, 218, 17, 'PPL', 'P'),
(1913, 'Culebra', 32.8166694641113, 0.572758931687426, -85.5352783203125, -1.49287223329918, 218, 2, 'PPL', 'P'),
(188392, 'Culebra', 34.6824989318848, 0.605323799180806, -105.767776489258, -1.845995942251, 218, 38, 'PPL', 'P'),
(54297, 'Culiver', 39.1691703796387, 0.683630988399332, -91.5663909912109, -1.59813500696511, 218, 29, 'PPL', 'P'),
(59175, 'Culkin', 32.3680610656738, 0.564929238082593, -90.8180618286133, -1.58507419918908, 218, 30, 'PPL', 'P'),
(35463, 'Cull', 38.5722198486328, 0.673212236161751, -84.908332824707, -1.48192997017032, 218, 21, 'PPL', 'P'),
(54298, 'Cull', 36.7272186279297, 0.641010890157167, -91.6841735839844, -1.60019070101054, 218, 29, 'PPL', 'P'),
(64072, 'Cullasaja', 35.1650009155273, 0.613745047442772, -83.3238906860352, -1.45427623804315, 218, 33, 'PPL', 'P'),
(35464, 'Cullen', 37.5894393920898, 0.656059481370823, -87.878059387207, -1.53376147656987, 218, 21, 'PPL', 'P'),
(39968, 'Cullen', 32.9688911437988, 0.575415701190889, -93.4505615234375, -1.63101998642151, 218, 22, 'PPL', 'P'),
(101232, 'Cullen', 37.1175003051758, 0.647822590435317, -78.6494369506836, -1.37269162962912, 218, 53, 'PPL', 'P'),
(148150, 'Cullen', 42.8822212219238, 0.748435950891157, -74.9625015258789, -1.30834246715786, 218, 40, 'PPL', 'P'),
(173706, 'Cullen', 44.961669921875, 0.78472917733162, -87.8530578613281, -1.53332511762526, 218, 57, 'PPL', 'P'),
(32189, 'Cullen Village', 38.9427795410156, 0.679679722869009, -95.7024993896484, -1.67032371673723, 218, 20, 'PPL', 'P'),
(8352, 'Cullendale', 33.5391693115234, 0.585368932869924, -92.8222198486328, -1.62005335536868, 218, 4, 'PPL', 'P'),
(86158, 'Culleoka', 35.4794387817383, 0.619233023501099, -86.9830627441406, -1.51814083835407, 218, 50, 'PPL', 'P'),
(93585, 'Culleoka', 33.1311111450195, 0.578246974324779, -96.4916687011719, -1.68409731957901, 218, 51, 'PPL', 'P'),
(8353, 'Culler', 34.6588897705078, 0.604911741581143, -91.809440612793, -1.60237702310744, 218, 4, 'PPL', 'P'),
(154914, 'Culler Mill', 40.6972198486328, 0.710300482766631, -82.3899993896484, -1.43797676006548, 218, 41, 'PPL', 'P'),
(46144, 'Culler Oaks', 39.4199981689453, 0.688008759178232, -77.4902801513672, -1.35246052693417, 218, 25, 'PPL', 'P'),
(32190, 'Cullison', 37.6305618286133, 0.6567772032846, -98.9049987792969, -1.7262178753797, 218, 20, 'PPL', 'P'),
(1914, 'Cullman', 34.1747207641602, 0.596461398284267, -86.8436126708984, -1.51570697543384, 218, 2, 'PPL', 'P'),
(20406, 'Culloden', 32.8630599975586, 0.573568599237837, -84.0938873291016, -1.46771521469396, 218, 13, 'PPL', 'P'),
(108766, 'Culloden', 38.4199981689453, 0.670555466658288, -82.0555572509766, -1.43213964358825, 218, 58, 'PPL', 'P'),
(119289, 'Cullom', 40.8777809143066, 0.713451867863549, -88.269172668457, -1.54058769107596, 218, 18, 'PPL', 'P'),
(141591, 'Cullom', 41.0558280944824, 0.716559377381508, -96.0233306884766, -1.67592327924523, 218, 35, 'PPL', 'P'),
(86159, 'Cullom (historical)', 36.3416709899902, 0.634281814451837, -85.2563934326172, -1.48800477377484, 218, 50, 'PPL', 'P'),
(1917, 'Cullomburg', 31.7136096954346, 0.553506906877729, -88.2969436645508, -1.54107238639436, 218, 2, 'PPL', 'P'),
(64074, 'Cullowhee', 35.3136100769043, 0.616338766607428, -83.1766662597656, -1.45170668706539, 218, 33, 'PPL', 'P'),
(101235, 'Culls', 37.2780609130859, 0.650624901692353, -75.956672668457, -1.32569402692416, 218, 53, 'PPL', 'P'),
(59176, 'Cullum', 32.6405601501465, 0.569685244315311, -88.6080627441406, -1.54650243869898, 218, 30, 'PPL', 'P'),
(194803, 'Cully Moores', 46.5305595397949, 0.812111466764679, -115.990562438965, -2.0244172158, 218, 17, 'PPL', 'P'),
(160588, 'Culmerville', 40.6541709899902, 0.709549138444092, -79.8391723632813, -1.39345642980652, 218, 45, 'PPL', 'P'),
(101233, 'Culmore', 38.8558311462402, 0.678162187100854, -77.1402816772461, -1.3463519011838, 218, 53, 'PPL', 'P'),
(8354, 'Culp', 36.1097183227539, 0.63023347669978, -92.2188873291016, -1.6095232164185, 218, 4, 'PPL', 'P'),
(160589, 'Culp', 40.5802803039551, 0.708259502686221, -78.2602767944336, -1.36589950358498, 218, 45, 'PPL', 'P'),
(186603, 'Culp', 38.1358299255371, 0.665595795181206, -102.60888671875, -1.79086291504807, 218, 7, 'PPL', 'P'),
(200655, 'Culp Creek', 43.7036094665527, 0.762771880197108, -122.846389770508, -2.14407397568364, 218, 43, 'PPL', 'P'),
(54301, 'Culp Ford', 36.6444396972656, 0.639566125265799, -91.6016693115234, -1.59875072980913, 218, 29, 'PPL', 'P'),
(1918, 'Culpeper', 31.8869400024414, 0.556532091428491, -87.5774993896484, -1.52851571501269, 218, 2, 'PPL', 'P'),
(101234, 'Culpeper', 38.4730606079102, 0.671481580927363, -77.996940612793, -1.36130342017572, 218, 53, 'PPL', 'P'),
(8356, 'Culpepper', 35.5161094665527, 0.619873047690072, -92.5163879394531, -1.61471558159583, 218, 4, 'PPL', 'P'),
(86160, 'Culpepper', 35.8183288574219, 0.62514777112411, -86.1427764892578, -1.50347507654711, 218, 50, 'PPL', 'P'),
(119290, 'Culton (historical)', 41.4841690063477, 0.724035336614551, -89.1172180175781, -1.55538887462435, 218, 18, 'PPL', 'P'),
(86161, 'Culvahouse', 35.6963882446289, 0.623019505938973, -84.6997222900391, -1.47828902948601, 218, 50, 'PPL', 'P'),
(32191, 'Culver', 38.9708290100098, 0.680169278456393, -97.7586135864258, -1.70620967926799, 218, 20, 'PPL', 'P'),
(35469, 'Culver', 38.0838890075684, 0.664689255146144, -82.9911117553711, -1.4484681500218, 218, 21, 'PPL', 'P'),
(119291, 'Culver', 40.0066719055176, 0.698248147516396, -89.6872177124023, -1.5653372460344, 218, 18, 'PPL', 'P'),
(122461, 'Culver', 41.2188911437988, 0.719405364480421, -86.4230575561523, -1.50836690399542, 218, 19, 'PPL', 'P'),
(134884, 'Culver', 46.9258308410645, 0.819010252410475, -92.5583267211914, -1.61544755142144, 218, 28, 'PPL', 'P'),
(194804, 'Culver', 48.3188896179199, 0.843323714740408, -116.455001831055, -2.03252321236793, 218, 17, 'PPL', 'P'),
(200656, 'Culver', 44.5258293151855, 0.777122323731, -121.211936950684, -2.1155473925092, 218, 43, 'PPL', 'P'),
(180985, 'Culver City', 34.021110534668, 0.593780394014884, -118.395561218262, -2.06639236300518, 218, 6, 'PPL', 'P'),
(180983, 'Culver Junction', 34.0283317565918, 0.593906428113473, -118.389442443848, -2.06628557024546, 218, 6, 'PPL', 'P'),
(145073, 'Culvers Inlet', 41.1686096191406, 0.718527786322213, -74.7925033569336, -1.3053754393874, 218, 37, 'PPL', 'P'),
(20408, 'Culverton', 33.3083305358887, 0.581340036193825, -82.8952789306641, -1.44679555169917, 218, 13, 'PPL', 'P'),
(35465, 'Culvertown', 37.7099990844727, 0.658163644948095, -85.5338897705078, -1.49284799853326, 218, 21, 'PPL', 'P'),
(148151, 'Culvertown', 41.5574989318848, 0.725315185255416, -74.5572204589844, -1.30126897814456, 218, 40, 'PPL', 'P'),
(29590, 'Cumback', 38.5586090087891, 0.672974682192516, -87.1474990844727, -1.52101079390279, 218, 19, 'PPL', 'P'),
(1919, 'Cumbee Mill', 33.0686111450195, 0.577156143542283, -85.3141708374023, -1.4890131797216, 218, 2, 'PPL', 'P'),
(130393, 'Cumber', 43.6213912963867, 0.761336902422746, -82.9775009155273, -1.44823059605256, 218, 27, 'PPL', 'P'),
(20409, 'Cumberland', 33.8505592346191, 0.590803712285476, -83.4627838134766, -1.45670038042539, 218, 13, 'PPL', 'P'),
(26899, 'Cumberland', 39.3038902282715, 0.685982293325763, -87.977783203125, -1.53550198550029, 218, 18, 'PPL', 'P'),
(29589, 'Cumberland', 39.7761116027832, 0.694224111109286, -85.9572219848633, -1.50023653950352, 218, 19, 'PPL', 'P'),
(35466, 'Cumberland', 36.9780616760254, 0.645388927252176, -82.9886093139648, -1.44842447417992, 218, 21, 'PPL', 'P'),
(46152, 'Cumberland', 39.6527786254883, 0.692071544579202, -78.7627792358398, -1.37466982568683, 218, 25, 'PPL', 'P'),
(59177, 'Cumberland', 33.6202812194824, 0.586784602726383, -89.0791702270508, -1.55472481540654, 218, 30, 'PPL', 'P'),
(64076, 'Cumberland', 35.0047187805176, 0.610947596454726, -78.9674987792969, -1.37824285576333, 218, 33, 'PPL', 'P'),
(70713, 'Cumberland', 39.3697204589844, 0.687131247599051, -74.9411087036133, -1.30796909197303, 218, 37, 'PPL', 'P'),
(72255, 'Cumberland', 39.8519401550293, 0.695547569013001, -81.6577835083008, -1.42519718210058, 218, 41, 'PPL', 'P'),
(75591, 'Cumberland', 34.0644416809082, 0.59453666518544, -96.5994415283203, -1.68597831025693, 218, 42, 'PPL', 'P'),
(80592, 'Cumberland', 33.3624992370605, 0.582285458380803, -79.4349975585938, -1.38640224871112, 218, 48, 'PPL', 'P'),
(101237, 'Cumberland', 37.4958305358887, 0.654425698621087, -78.2455596923828, -1.36564264169784, 218, 53, 'PPL', 'P'),
(115169, 'Cumberland', 41.274169921875, 0.72037016116433, -94.870002746582, -1.65579390930392, 218, 16, 'PPL', 'P'),
(169342, 'Cumberland', 41.9666709899902, 0.732456584876518, -71.4333267211914, -1.24674674693764, 218, 47, 'PPL', 'P'),
(173707, 'Cumberland', 45.5322189331055, 0.79468713612159, -92.019172668457, -1.60603753802575, 218, 57, 'PPL', 'P'),
(207150, 'Cumberland', 47.2830581665039, 0.825245045417486, -121.925827026367, -2.12800712482719, 218, 56, 'PPL', 'P'),
(8357, 'Cumberland (historical)', 35.4083290100098, 0.617991923854095, -93.165283203125, -1.6260409404475, 218, 4, 'PPL', 'P'),
(127190, 'Cumberland Center', 43.7963905334473, 0.764391215297931, -70.2594375610352, -1.22625851603944, 218, 26, 'PPL', 'P'),
(127191, 'Cumberland Center Station', 43.7758293151855, 0.764032354341042, -70.2544403076172, -1.22617129751374, 218, 26, 'PPL', 'P'),
(35467, 'Cumberland City', 36.8050003051758, 0.642368436522835, -85.0683288574219, -1.48472242773132, 218, 21, 'PPL', 'P'),
(86162, 'Cumberland City', 36.3933296203613, 0.635183427638883, -87.6363906860352, -1.52954356203541, 218, 50, 'PPL', 'P'),
(86164, 'Cumberland Estates', 35.9838905334473, 0.628037367485874, -84.0127792358398, -1.46629961141653, 218, 50, 'PPL', 'P'),
(127193, 'Cumberland Foreside', 43.7700004577637, 0.763930621587401, -70.1980590820313, -1.22518725949095, 218, 26, 'PPL', 'P'),
(20412, 'Cumberland Forest', 33.8330612182617, 0.590498314287471, -84.0722198486328, -1.46733704581917, 218, 13, 'PPL', 'P'),
(86165, 'Cumberland Furnace', 36.2686080932617, 0.63300662634288, -87.3597183227539, -1.52471471834687, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(86166, 'Cumberland Gap', 36.5994415283203, 0.638780759060335, -83.6686096191406, -1.4602927184198, 218, 50, 'PPL', 'P'),
(20413, 'Cumberland Green', 33.6688919067383, 0.587633019270655, -84.1961135864258, -1.46949939946626, 218, 13, 'PPL', 'P'),
(86167, 'Cumberland Grove', 36.3844413757324, 0.635028298505386, -84.9250030517578, -1.48222092051941, 218, 50, 'PPL', 'P'),
(148152, 'Cumberland Head', 44.7163887023926, 0.780448212458345, -73.4030609130859, -1.2811250939753, 218, 40, 'PPL', 'P'),
(86170, 'Cumberland Heights', 36.4908294677734, 0.636885120996416, -87.3994369506836, -1.52540793917862, 218, 50, 'PPL', 'P'),
(108767, 'Cumberland Heights', 37.2597198486328, 0.650304789729326, -81.1936111450195, -1.41709584606455, 218, 58, 'PPL', 'P'),
(20414, 'Cumberland Hill', 33.8752784729004, 0.591235144382068, -84.4811096191406, -1.47447351859226, 218, 13, 'PPL', 'P'),
(169343, 'Cumberland Hill', 41.9744415283203, 0.73259220635503, -71.4674987792969, -1.24734316186376, 218, 47, 'PPL', 'P'),
(86174, 'Cumberland Homesteads', 35.9083290100098, 0.626718570114066, -84.9452819824219, -1.48257485462828, 218, 50, 'PPL', 'P'),
(1920, 'Cumberland Junction', 34.9430618286133, 0.609871479637252, -85.7677764892578, -1.49693009185213, 218, 2, 'PPL', 'P'),
(101240, 'Cumberland Landing', 37.5319404602051, 0.655055935693054, -76.9691696166992, -1.34336543233738, 218, 53, 'PPL', 'P'),
(127194, 'Cumberland Mills', 43.6813888549805, 0.762384057363365, -70.3436126708984, -1.22772764885478, 218, 26, 'PPL', 'P'),
(1921, 'Cumberland Mountain Farm Colony (historical)', 34.7958297729492, 0.607301795501435, -86.1166687011719, -1.5030194096846, 218, 2, 'PPL', 'P'),
(35470, 'Cumberland Shores', 36.7522201538086, 0.641447249101777, -87.9477767944336, -1.53497827487193, 218, 21, 'PPL', 'P'),
(86175, 'Cumberland Spring', 35.5247192382813, 0.62002331655458, -85.0369415283203, -1.48417461549509, 218, 50, 'PPL', 'P'),
(86176, 'Cumberland Springs', 35.3413887023926, 0.616823595083877, -86.295280456543, -1.50613677289859, 218, 50, 'PPL', 'P'),
(86178, 'Cumberland View', 36.476390838623, 0.636633119378268, -87.3833312988281, -1.52512684252556, 218, 50, 'PPL', 'P'),
(86179, 'Cumberland View Estates', 36.2319412231445, 0.632366668732934, -84.1425018310547, -1.46856369781726, 218, 50, 'PPL', 'P'),
(78105, 'Cumberland Village', 39.899169921875, 0.696371883949407, -79.9686126708984, -1.39571558935923, 218, 45, 'PPL', 'P'),
(46146, 'Cumberstone', 38.8588905334473, 0.678215583480711, -76.5527801513672, -1.33609806519672, 218, 25, 'PPL', 'P'),
(160592, 'Cumbola', 40.711669921875, 0.710552684121861, -76.1380615234375, -1.32885985966999, 218, 45, 'PPL', 'P'),
(186604, 'Cumbres', 37.019718170166, 0.646115970229767, -106.447219848633, -1.8578544659529, 218, 7, 'PPL', 'P'),
(93586, 'Cumby', 33.1372184753418, 0.57835356734741, -95.8391723632813, -1.67270911012561, 218, 51, 'PPL', 'P'),
(8358, 'Cumi', 36.4063911437988, 0.635411394228194, -92.1833267211914, -1.60890256672646, 218, 4, 'PPL', 'P'),
(93587, 'Cumings', 29.5780601501465, 0.516234535972985, -95.7986068725586, -1.67200110874982, 218, 51, 'PPL', 'P'),
(160591, 'Cumiskey', 41.5688896179199, 0.72551399023079, -76.3241729736328, -1.33210811725156, 218, 45, 'PPL', 'P'),
(124604, 'Cummaquid', 41.7016716003418, 0.727831473011377, -70.2736129760742, -1.22650592370471, 218, 23, 'PPL', 'P'),
(20417, 'Cumming', 34.207218170166, 0.597028585017427, -84.1402816772461, -1.4685249488234, 218, 13, 'PPL', 'P'),
(115170, 'Cumming', 41.4833297729492, 0.724020689228556, -93.7622222900391, -1.636459492948, 218, 16, 'PPL', 'P'),
(15691, 'Cummings', 27.7972202301025, 0.485153015917265, -80.4622192382813, -1.40433064916953, 218, 12, 'PPL', 'P'),
(32193, 'Cummings', 39.4627799987793, 0.688755442968863, -95.2472229003906, -1.66237764299276, 218, 20, 'PPL', 'P'),
(80593, 'Cummings', 32.7869415283203, 0.572240081328051, -80.9905624389648, -1.41355197760199, 218, 48, 'PPL', 'P'),
(86180, 'Cummings', 35.889720916748, 0.626393797619131, -85.4602813720703, -1.4915632896234, 218, 50, 'PPL', 'P'),
(127196, 'Cummings', 43.2397193908691, 0.754675471009103, -70.8169403076172, -1.23598877455621, 218, 26, 'PPL', 'P'),
(139855, 'Cummings', 47.514720916748, 0.829288323163472, -97.0791702270508, -1.69435115556609, 218, 34, 'PPL', 'P'),
(180984, 'Cummings', 39.8333282470703, 0.695222729939038, -123.630828857422, -2.15776502053163, 218, 6, 'PPL', 'P'),
(154915, 'Cummings (historical)', 41.5583305358887, 0.725329699483357, -83.4930572509766, -1.45722875158567, 218, 41, 'PPL', 'P'),
(148154, 'Cummings Crossing', 42.7738914489746, 0.746545239675255, -76.1197204589844, -1.32853974770697, 218, 40, 'PPL', 'P'),
(86181, 'Cummings Crossroads', 36.478328704834, 0.636666941524112, -86.5761108398438, -1.51103818772683, 218, 50, 'PPL', 'P'),
(101241, 'Cummings Heights', 36.7216682434082, 0.640914017672516, -82.0155563354492, -1.43144149590848, 218, 53, 'PPL', 'P'),
(141595, 'Cummings Park (historical)', 41.7122192382813, 0.728015564021729, -99.501106262207, -1.73662191365226, 218, 35, 'PPL', 'P'),
(188393, 'Cummings Place', 35.2999992370605, 0.616101212638193, -103.38166809082, -1.80435049438877, 218, 38, 'PPL', 'P'),
(8359, 'Cummings Springs', 33.7527809143066, 0.589097158658953, -93.1836090087891, -1.62636078609442, 218, 4, 'PPL', 'P'),
(86182, 'Cummingsville', 35.8083305358887, 0.624973267493683, -85.4622192382813, -1.49159711176925, 218, 50, 'PPL', 'P'),
(124605, 'Cummingsville', 42.4811096191406, 0.741435232754638, -71.1750030517578, -1.24223814837019, 218, 23, 'PPL', 'P'),
(134886, 'Cummingsville', 43.8747215270996, 0.765758349043523, -92.2600021362305, -1.61024080517422, 218, 28, 'PPL', 'P'),
(160594, 'Cummingswood Park', 40.1213912963867, 0.700250378602944, -79.4047164916992, -1.38587374439279, 218, 45, 'PPL', 'P'),
(124606, 'Cummington', 42.461669921875, 0.741095946031762, -72.8944396972656, -1.27224797911374, 218, 23, 'PPL', 'P'),
(8360, 'Cummins', 34.0638885498047, 0.594527011226488, -91.5788879394531, -1.59835311985838, 218, 4, 'PPL', 'P'),
(93588, 'Cummins Crossing', 30.8022193908691, 0.537600145292309, -97.1647186279297, -1.69584425683124, 218, 51, 'PPL', 'P'),
(35476, 'Cumminsville', 38.7180595397949, 0.675757618952622, -84.1050033569336, -1.46790922597937, 218, 21, 'PPL', 'P'),
(72256, 'Cumminsville', 39.163890838623, 0.683538843025615, -84.5400009155273, -1.47550136561497, 218, 41, 'PPL', 'P'),
(141596, 'Cumminsville', 41.9869384765625, 0.732810319248308, -98.5480575561523, -1.71998807579974, 218, 35, 'PPL', 'P'),
(148153, 'Cumminsville', 42.5713882446289, 0.743010892013584, -77.7200012207031, -1.35646991595528, 218, 40, 'PPL', 'P'),
(160597, 'Cumminsville', 40.1208305358887, 0.700240591485938, -77.3161087036133, -1.3494206617079, 218, 45, 'PPL', 'P'),
(101242, 'Cumnberland (historical)', 37.5436096191406, 0.655259600937418, -76.9780578613281, -1.34352056147088, 218, 53, 'PPL', 'P'),
(64080, 'Cumnock', 35.5547218322754, 0.620546960603917, -79.2380599975586, -1.38296503985021, 218, 33, 'PPL', 'P'),
(39969, 'Cumnock (historical)', 30.9516696929932, 0.540208545132473, -90.1797180175781, -1.57393299792679, 218, 22, 'PPL', 'P'),
(101243, 'Cumnor', 37.7249984741211, 0.65842543368325, -76.8836135864258, -1.34187219791418, 218, 53, 'PPL', 'P'),
(46147, 'Cumorah Estates', 39.4261093139648, 0.688115418779889, -77.0802764892578, -1.34530461308512, 218, 25, 'PPL', 'P'),
(15692, 'Cumpressco', 28.3586101531982, 0.494951118462803, -82.039436340332, -1.43185828061908, 218, 12, 'PPL', 'P'),
(141597, 'Cumro', 41.105281829834, 0.717422507890803, -99.4922180175781, -1.73646678451876, 218, 35, 'PPL', 'P'),
(20415, 'Cumslo', 32.9472198486328, 0.57503746573707, -83.5166702270508, -1.45764087576436, 218, 13, 'PPL', 'P'),
(191349, 'Cuna del Valle Colonia', 31.57200050354, 0.551035360228081, -106.268997192383, -1.85474389379969, 218, 51, 'PPL', 'P'),
(180986, 'Cuna Vista Mobile Home Park', 35.0969390869141, 0.612557144438543, -120.601936340332, -2.10490087341939, 218, 6, 'PPL', 'P'),
(108768, 'Cunard', 37.9986114501953, 0.663200880991926, -81.0397186279297, -1.41440991494715, 218, 58, 'PPL', 'P'),
(130395, 'Cunard', 45.7380599975586, 0.798279740432107, -87.6666717529297, -1.53007206635373, 218, 27, 'PPL', 'P'),
(180987, 'Cunard', 38.8138885498047, 0.677430150696219, -121.684722900391, -2.12379906398876, 218, 6, 'PPL', 'P'),
(35471, 'Cundiff', 36.9447212219238, 0.644807026553993, -85.2544403076172, -1.48797068531289, 218, 21, 'PPL', 'P'),
(93589, 'Cundiff', 33.3166694641113, 0.581485577947397, -97.9980621337891, -1.7103888448086, 218, 51, 'PPL', 'P'),
(188394, 'Cundiyo', 35.959171295166, 0.627605935389281, -105.89582824707, -1.84823086703779, 218, 38, 'PPL', 'P'),
(127197, 'Cundys Harbor', 43.7969398498535, 0.764400802677855, -69.8936080932617, -1.21987358732597, 218, 26, 'PPL', 'P'),
(8361, 'Cuneo (historical)', 34.7805595397949, 0.607035279655345, -91.6319427490234, -1.5992791009694, 218, 4, 'PPL', 'P'),
(180988, 'Cuneo (historical)', 36.2483291625977, 0.632652692234008, -119.83332824707, -2.0914861315345, 218, 6, 'PPL', 'P'),
(93590, 'Cuney', 32.0319404602051, 0.559062826833366, -95.4172210693359, -1.66534467076322, 218, 51, 'PPL', 'P'),
(39970, 'Cunnard Place', 30.5527801513672, 0.533246609279329, -91.1722183227539, -1.59125539607916, 218, 22, 'PPL', 'P'),
(1925, 'Cunningham', 33.1738891601563, 0.578993591536383, -88.1074981689453, -1.53776593874297, 218, 2, 'PPL', 'P'),
(20416, 'Cunningham', 34.1650009155273, 0.596291754922829, -85.2633285522461, -1.48812581444638, 218, 13, 'PPL', 'P'),
(32194, 'Cunningham', 37.6438903808594, 0.657009830405818, -98.4308319091797, -1.71794210229228, 218, 20, 'PPL', 'P'),
(35472, 'Cunningham', 36.9075012207031, 0.644157414985096, -88.8897171020508, -1.5514182345971, 218, 21, 'PPL', 'P'),
(54303, 'Cunningham', 36.1969413757324, 0.631755806157897, -89.7002792358398, -1.56556521262371, 218, 29, 'PPL', 'P'),
(64081, 'Cunningham', 36.5380592346191, 0.637709435932823, -79.07861328125, -1.38018216966913, 218, 33, 'PPL', 'P'),
(72257, 'Cunningham', 39.5783309936523, 0.690772188283352, -83.5513916015625, -1.4582468780704, 218, 41, 'PPL', 'P'),
(80595, 'Cunningham', 34.9963912963867, 0.610802254438235, -82.0588912963867, -1.43219783365807, 218, 48, 'PPL', 'P'),
(86184, 'Cunningham', 36.2333297729492, 0.632390903498853, -89.4238891601563, -1.56074129578319, 218, 50, 'PPL', 'P'),
(93591, 'Cunningham', 33.4263916015625, 0.583400590508246, -95.3572235107422, -1.6642975158226, 218, 51, 'PPL', 'P'),
(101244, 'Cunningham', 37.8738899230957, 0.661024079695922, -78.3202819824219, -1.36694679168365, 218, 53, 'PPL', 'P'),
(108769, 'Cunningham', 39.0961112976074, 0.682355866869402, -78.9441680908203, -1.37783565843266, 218, 58, 'PPL', 'P'),
(160596, 'Cunningham', 40.6775016784668, 0.709956335774765, -79.8230590820313, -1.39317519999541, 218, 45, 'PPL', 'P'),
(180989, 'Cunningham', 38.3624992370605, 0.669551920980519, -122.776672363281, -2.14285717738159, 218, 6, 'PPL', 'P'),
(207151, 'Cunningham', 46.8222198486328, 0.817201899451284, -118.805282592773, -2.0735433500062, 218, 56, 'PPL', 'P'),
(8362, 'Cunningham (historical)', 34.4247207641602, 0.600824721414253, -92.6833267211914, -1.61762921298643, 218, 4, 'PPL', 'P'),
(80594, 'Cunningham Acres', 34.8866691589355, 0.608887241877386, -82.3119430541992, -1.43661442000985, 218, 48, 'PPL', 'P'),
(8363, 'Cunningham Corner', 35.1916694641113, 0.614210501422291, -90.2916717529297, -1.57588695921858, 218, 4, 'PPL', 'P'),
(20418, 'Cunningham Corner', 32.8452796936035, 0.573258274391816, -82.3586120605469, -1.43742894782925, 218, 13, 'PPL', 'P'),
(20419, 'Cunningham Crossroads', 32.8224983215332, 0.572860664441067, -84.5702819824219, -1.4760298699333, 218, 13, 'PPL', 'P'),
(15693, 'Cunningham Estates', 28.2638893127441, 0.493297927926623, -82.2072219848633, -1.43478669255373, 218, 12, 'PPL', 'P'),
(192533, 'Cunningham Hill', 38.396110534668, 0.670138548789636, -112.724166870117, -1.96740785845106, 218, 52, 'PPL', 'P'),
(1926, 'Cunningham Landing', 31.9119396209717, 0.556968417083587, -88.084716796875, -1.53736832879222, 218, 2, 'PPL', 'P'),
(46149, 'Cunninghill Cove', 39.3652801513672, 0.687053749611329, -76.3611068725586, -1.33275273539342, 218, 25, 'PPL', 'P'),
(29591, 'Cunot', 39.4563903808594, 0.688643923098216, -86.8547210693359, -1.5159008535612, 218, 19, 'PPL', 'P'),
(180990, 'Cupertino', 37.3230590820313, 0.651410267897818, -122.031112670898, -2.12984470597935, 218, 6, 'PPL', 'P'),
(113077, 'Cupheag (historical)', 41.184440612793, 0.718804089285308, -73.1336135864258, -1.27642235096439, 218, 8, 'PPL', 'P'),
(35473, 'Cupio', 38.0061111450195, 0.663331775359503, -85.8783264160156, -1.49885955206189, 218, 21, 'PPL', 'P'),
(160598, 'Cupola', 40.0991706848145, 0.699862555769202, -75.8455581665039, -1.32375471301837, 218, 45, 'PPL', 'P'),
(86185, 'Cupp Mill', 36.3963890075684, 0.635236824018739, -83.6980590820313, -1.46080670851019, 218, 50, 'PPL', 'P'),
(190095, 'Cuprite (historical)', 37.5283317565918, 0.654992951933274, -117.186111450195, -2.04528348241494, 218, 39, 'PPL', 'P'),
(194805, 'Cuprum', 45.086669921875, 0.786910838896613, -116.688331604004, -2.03659558514882, 218, 17, 'PPL', 'P'),
(1927, 'Curbville', 32.7069396972656, 0.570843785968523, -87.371940612793, -1.52492803755019, 218, 2, 'PPL', 'P'),
(29592, 'Curby', 38.2874984741211, 0.668242910725718, -86.3772201538086, -1.50756689040396, 218, 19, 'PPL', 'P'),
(75592, 'Curchece', 36.2188911437988, 0.632138901880705, -96.2925033569336, -1.68062122856618, 218, 42, 'PPL', 'P'),
(35474, 'Curdsville', 37.7350006103516, 0.658600003892705, -87.331672668457, -1.52422522933852, 218, 21, 'PPL', 'P'),
(101246, 'Curdsville', 37.4155616760254, 0.653024742729651, -78.4561080932617, -1.36931740452799, 218, 53, 'PPL', 'P'),
(54305, 'Curdton', 36.9644393920898, 0.645151173545859, -90.0552825927734, -1.57176119005783, 218, 29, 'PPL', 'P'),
(196311, 'Curdys Cove', 46.2016716003418, 0.806371289351122, -114.14778137207, -1.99225461878928, 218, 31, 'PPL', 'P'),
(54306, 'Cureall', 36.6672210693359, 0.639963735216548, -92.070556640625, -1.60693435752284, 218, 29, 'PPL', 'P'),
(20420, 'Cureton Springs (historical)', 33.3030586242676, 0.581248023978162, -84.8369369506836, -1.48068387709627, 218, 13, 'PPL', 'P'),
(80596, 'Curetons (historical)', 34.8680610656738, 0.608562469382451, -80.7919387817383, -1.41008534081103, 218, 48, 'PPL', 'P'),
(160599, 'Curfew', 40.041389465332, 0.698854083243416, -79.7586135864258, -1.39205041390901, 218, 45, 'PPL', 'P'),
(93592, 'Curl Tex Colonia', 26.3050003051758, 0.459108865063431, -98.2480010986328, -1.71475110267415, 218, 51, 'PPL', 'P'),
(86186, 'Curlee', 35.7775001525879, 0.624435175795432, -86.1594390869141, -1.50376589373815, 218, 50, 'PPL', 'P'),
(15694, 'Curlew', 28.0527801513672, 0.489613377979471, -82.7430572509766, -1.44413878219571, 218, 12, 'PPL', 'P'),
(35475, 'Curlew', 37.5777816772461, 0.655856015863541, -88.086669921875, -1.53740241725417, 218, 21, 'PPL', 'P'),
(115172, 'Curlew', 42.978889465332, 0.750123130020749, -94.7408294677734, -1.65353941028311, 218, 16, 'PPL', 'P'),
(180991, 'Curlew', 32.9333305358887, 0.574795051498846, -115.404716491699, -2.01419227511075, 218, 6, 'PPL', 'P'),
(207152, 'Curlew', 48.8855590820313, 0.853213962659662, -118.598327636719, -2.06993130461973, 218, 56, 'PPL', 'P'),
(203664, 'Curlew Junction', 41.9655609130859, 0.732437210379588, -113.059173583984, -1.97325482862433, 218, 52, 'PPL', 'P'),
(160600, 'Curllsville', 41.0986099243164, 0.717306061172139, -79.4469375610352, -1.38661064106642, 218, 45, 'PPL', 'P'),
(26901, 'Curran', 39.7422218322754, 0.693632623031179, -89.7719421386719, -1.56681596622966, 218, 18, 'PPL', 'P'),
(130396, 'Curran', 44.7147216796875, 0.780419117423436, -83.8077774047852, -1.46272165449201, 218, 27, 'PPL', 'P'),
(173710, 'Curran', 44.3561096191406, 0.774160156229532, -87.7455596923828, -1.5314489206373, 218, 57, 'PPL', 'P'),
(190097, 'Currant', 38.7422218322754, 0.676179330511236, -115.473892211914, -2.01539961919094, 218, 39, 'PPL', 'P'),
(32195, 'Curranville', 37.5136108398438, 0.654736023467109, -94.6313934326172, -1.65162939114931, 218, 20, 'PPL', 'P'),
(134887, 'Current Lake', 44.1386108398438, 0.770364086411733, -95.9430618286133, -1.67452232335379, 218, 28, 'PPL', 'P'),
(8367, 'Current View', 36.4983291625977, 0.637016015363994, -90.779167175293, -1.58439535942722, 218, 4, 'PPL', 'P'),
(54308, 'Current View', 36.4988899230957, 0.637025802481, -90.7780609130859, -1.58437605150932, 218, 29, 'PPL', 'P'),
(35477, 'Currentsville', 38.2608299255371, 0.667777456746199, -84.251106262207, -1.47045920272313, 218, 21, 'PPL', 'P'),
(59180, 'Currie', 31.6313896179199, 0.552071895813854, -89.1469421386719, -1.5559076584047, 218, 30, 'PPL', 'P'),
(64083, 'Currie', 34.4625015258789, 0.601484120100157, -78.1013870239258, -1.36312635394188, 218, 33, 'PPL', 'P'),
(86187, 'Currie', 36.0430603027344, 0.629070074777579, -89.0427780151367, -1.55408965148656, 218, 50, 'PPL', 'P'),
(93593, 'Currie', 31.8636093139648, 0.556124894097818, -96.4433288574219, -1.68325363014567, 218, 51, 'PPL', 'P'),
(134888, 'Currie', 44.0713882446289, 0.769190830793499, -95.6661071777344, -1.66968855281724, 218, 28, 'PPL', 'P'),
(199901, 'Currie', 40.2666702270508, 0.702785974276809, -114.742218017578, -2.0026294954479, 218, 39, 'PPL', 'P'),
(148155, 'Curriers', 42.6205596923828, 0.743869095674862, -78.4177780151367, -1.36864841846216, 218, 40, 'PPL', 'P'),
(143685, 'Curriers Mobile Home Park', 43.648609161377, 0.761811943782189, -72.1666717529297, -1.25954603229461, 218, 36, 'PPL', 'P'),
(200658, 'Currinsville', 45.3152809143066, 0.790900853420797, -122.34139251709, -2.13526011089797, 218, 43, 'PPL', 'P'),
(101249, 'Currioman Landing', 38.1541709899902, 0.665915907144234, -76.7616729736328, -1.33974393272904, 218, 53, 'PPL', 'P'),
(64084, 'Currituck', 36.4497184753418, 0.636167598819722, -76.0158309936523, -1.32672653447879, 218, 33, 'PPL', 'P'),
(101248, 'Currituck Farms', 37.5091705322266, 0.654658525479387, -77.232780456543, -1.3479663094366, 218, 53, 'PPL', 'P'),
(1930, 'Curry', 33.9536094665527, 0.592602278127661, -87.2144393920898, -1.52217912267301, 218, 2, 'PPL', 'P'),
(39972, 'Curry', 31.8622207641602, 0.556100659331898, -92.4400024414063, -1.61338240315414, 218, 22, 'PPL', 'P'),
(148156, 'Curry', 41.8583297729492, 0.730565673923534, -74.581672668457, -1.30169574970924, 218, 40, 'PPL', 'P'),
(160601, 'Curry', 40.3319396972656, 0.70392514143309, -79.9858322143555, -1.39601612708825, 218, 45, 'PPL', 'P'),
(194806, 'Curry', 42.5638885498047, 0.742879997646006, -114.554443359375, -1.99935220941045, 218, 17, 'PPL', 'P'),
(196312, 'Curry', 47.0902786254883, 0.82188040769628, -104.626388549805, -1.82607496466499, 218, 31, 'PPL', 'P'),
(207153, 'Curry', 46.6502799987793, 0.814200982955955, -118.826393127441, -2.07391179834301, 218, 56, 'PPL', 'P'),
(211776, 'Curry', 62.6147193908691, 1.092833013583, -150.011932373047, -2.61820213718874, 218, 1, 'PPL', 'P'),
(39973, 'Curry (historical)', 31.9019393920898, 0.556793880163646, -92.4130630493164, -1.61291222206368, 218, 22, 'PPL', 'P'),
(86188, 'Curry (historical)', 36.0988883972168, 0.630044458841412, -86.7174987792969, -1.51350587279289, 218, 50, 'PPL', 'P'),
(93594, 'Curry Crossing', 31.2027797698975, 0.544591242759389, -97.6372222900391, -1.70409100146278, 218, 51, 'PPL', 'P'),
(20424, 'Curry Hill', 33.8430595397949, 0.590672817917898, -82.5305633544922, -1.44043006406166, 218, 13, 'PPL', 'P'),
(160602, 'Curry Hill', 41.2380599975586, 0.719739924092362, -75.9636077880859, -1.32581506759571, 218, 45, 'PPL', 'P'),
(160603, 'Curry Run', 40.9124984741211, 0.714057803590569, -78.6661071777344, -1.37298257997821, 218, 45, 'PPL', 'P'),
(180992, 'Curry Village', 37.7369384765625, 0.658633826038549, -119.571670532227, -2.08691934289723, 218, 6, 'PPL', 'P'),
(1931, 'Currys', 32.0183296203613, 0.558825272864131, -86.0808334350586, -1.50239396630259, 218, 2, 'PPL', 'P'),
(178047, 'Currys Corner', 33.6986083984375, 0.588151669892948, -111.924438476563, -1.95344996486184, 218, 5, 'PPL', 'P'),
(160604, 'Currys Mills', 41.0880584716797, 0.71712190358276, -80.0641708374023, -1.3973833939919, 218, 45, 'PPL', 'P'),
(64088, 'Currytown', 35.8819389343262, 0.626257976403537, -80.3216705322266, -1.40187761148946, 218, 33, 'PPL', 'P'),
(148157, 'Currytown', 42.8580589294434, 0.748014239332543, -74.4644393920898, -1.29964964304373, 218, 40, 'PPL', 'P'),
(20421, 'Curryville', 34.4436111450195, 0.601154420757205, -85.0788879394531, -1.48490671847875, 218, 13, 'PPL', 'P'),
(54311, 'Curryville', 39.3455581665039, 0.686709536040437, -91.3447189331055, -1.59426609969149, 218, 29, 'PPL', 'P'),
(122462, 'Curryville', 40.7863883972168, 0.711856767528646, -85.0719375610352, -1.4847854114911, 218, 19, 'PPL', 'P'),
(160605, 'Curryville', 40.2758293151855, 0.702945830521241, -78.3386077880859, -1.36726663733057, 218, 45, 'PPL', 'P'),
(1932, 'Curt', 33.3736114501953, 0.582479403087188, -85.4305572509766, -1.49104450584306, 218, 2, 'PPL', 'P'),
(154916, 'Curtice', 41.6183280944824, 0.726376854423976, -83.3677825927734, -1.45504229633071, 218, 41, 'PPL', 'P'),
(108772, 'Curtin', 38.4744415283203, 0.671505682535229, -80.3627777099609, -1.40259506708713, 218, 58, 'PPL', 'P'),
(160606, 'Curtin', 40.9722213745117, 0.715100164841226, -77.7441711425781, -1.35689176067195, 218, 45, 'PPL', 'P'),
(200659, 'Curtin', 43.7224998474121, 0.76310157954006, -123.210830688477, -2.15043466963119, 218, 43, 'PPL', 'P'),
(1933, 'Curtis', 31.3974990844727, 0.547989735915953, -86.1569366455078, -1.50372221789627, 218, 2, 'PPL', 'P'),
(8365, 'Curtis', 33.9977798461914, 0.593373196684211, -93.1055603027344, -1.62499857919684, 218, 4, 'PPL', 'P'),
(15695, 'Curtis', 29.7372207641602, 0.519012412727019, -82.8986129760742, -1.44685374176899, 218, 12, 'PPL', 'P'),
(20423, 'Curtis', 34.9255599975586, 0.60956601506022, -84.3358306884766, -1.47193792291839, 218, 13, 'PPL', 'P'),
(35478, 'Curtis', 36.9330596923828, 0.644603494467684, -85.5763931274414, -1.4935898220549, 218, 21, 'PPL', 'P'),
(39974, 'Curtis', 32.4391708374023, 0.566170337729597, -93.642219543457, -1.63436504990871, 218, 22, 'PPL', 'P'),
(75593, 'Curtis', 36.4391708374023, 0.63598350780937, -99.142219543457, -1.73035815876839, 218, 42, 'PPL', 'P'),
(93595, 'Curtis', 30.9211101531982, 0.539675180545158, -94.0644378662109, -1.64173414980301, 218, 51, 'PPL', 'P'),
(101250, 'Curtis', 37.4766693115234, 0.6540912721672, -79.48388671875, -1.38725552552438, 218, 53, 'PPL', 'P'),
(119293, 'Curtis', 40.0622215270996, 0.699217671311239, -89.790283203125, -1.56713607819269, 218, 18, 'PPL', 'P'),
(130398, 'Curtis', 43.7991714477539, 0.764439751408797, -84.4858322143555, -1.47455594342799, 218, 27, 'PPL', 'P'),
(148159, 'Curtis', 42.207218170166, 0.736654925176973, -77.1699981689453, -1.34687055180609, 218, 40, 'PPL', 'P'),
(193476, 'Curtis', 41.2005615234375, 0.719085452254475, -121.765556335449, -2.12520987357623, 218, 6, 'PPL', 'P'),
(199261, 'Curtis', 40.6300010681152, 0.709127293727424, -100.515281677246, -1.75432261383747, 218, 35, 'PPL', 'P'),
(203666, 'Curtis', 40.2752799987793, 0.702936243141317, -111.69416809082, -1.9494309884608, 218, 52, 'PPL', 'P'),
(207155, 'Curtis', 46.5872192382813, 0.813100365056453, -123.10888671875, -2.14865541170691, 218, 56, 'PPL', 'P'),
(209395, 'Curtis', 42.0897216796875, 0.734604224558585, -104.949440002441, -1.83171327616685, 218, 59, 'PPL', 'P'),
(8366, 'Curtis (historical)', 34.7444381713867, 0.606404842846296, -92.8658294677734, -1.62081448680822, 218, 4, 'PPL', 'P'),
(115173, 'Curtis (historical)', 41.8041687011719, 0.729620384894611, -91.6494369506836, -1.59958443238838, 218, 16, 'PPL', 'P'),
(190099, 'Curtis (historical)', 39.7472190856934, 0.693719841556879, -117.16056060791, -2.0448375360904, 218, 39, 'PPL', 'P'),
(46150, 'Curtis Acres', 39.6730613708496, 0.692425545267101, -76.0713882446289, -1.32769619143168, 218, 25, 'PPL', 'P'),
(46151, 'Curtis Bay', 39.2266693115234, 0.684634534077101, -76.5883331298828, -1.33671858173071, 218, 25, 'PPL', 'P'),
(127198, 'Curtis Corner', 44.2661094665527, 0.772589357239576, -70.0930633544922, -1.22335473834487, 218, 26, 'PPL', 'P'),
(143688, 'Curtis Corner', 42.7425003051758, 0.745997360859998, -72.3883285522461, -1.26341467325211, 218, 36, 'PPL', 'P'),
(148160, 'Curtis Corner', 42.7894401550293, 0.746816615790334, -77.5430603027344, -1.35338171435523, 218, 40, 'PPL', 'P'),
(169345, 'Curtis Corner', 41.4538917541504, 0.723506898875252, -71.5288925170898, -1.24841468472835, 218, 47, 'PPL', 'P'),
(180994, 'Curtis Creek Ranch', 37.9708290100098, 0.662715985936449, -120.291107177734, -2.09947588112085, 218, 6, 'PPL', 'P'),
(124608, 'Curtis Crossing', 42.1027793884277, 0.734832124568868, -70.8236083984375, -1.23610515469584, 218, 23, 'PPL', 'P'),
(1934, 'Curtis Crossroads', 34.077220916748, 0.594759704926734, -87.3566665649414, -1.52466145512507, 218, 2, 'PPL', 'P'),
(15696, 'Curtis Mill', 30.0083293914795, 0.523744150904304, -84.5261077880859, -1.47525888479772, 218, 12, 'PPL', 'P'),
(80597, 'Curtis Park', 33.9102783203125, 0.591846006957105, -80.3783264160156, -1.40286644320221, 218, 48, 'PPL', 'P'),
(59181, 'Curtis Station', 34.3400001525879, 0.599346067798014, -90.1391677856445, -1.5732252628671, 218, 30, 'PPL', 'P'),
(173712, 'Curtiss', 44.9552803039551, 0.784617657460973, -90.434440612793, -1.57837874589252, 218, 57, 'PPL', 'P'),
(178048, 'Curtiss', 31.8844394683838, 0.556488448876128, -110.22917175293, -1.92386197883495, 218, 5, 'PPL', 'P'),
(1935, 'Curtiston', 34.0011100769043, 0.593431320175002, -86.1213912963867, -1.50310183452034, 218, 2, 'PPL', 'P'),
(86189, 'Curtistown', 35.5733299255371, 0.620871733098852, -85.5833282470703, -1.49371086272644, 218, 50, 'PPL', 'P'),
(108773, 'Curtisville', 39.5208282470703, 0.689768576026556, -80.4391708374023, -1.40392837868688, 218, 58, 'PPL', 'P'),
(122463, 'Curtisville', 40.3183288574219, 0.703687587463855, -85.8986129760742, -1.49921361932882, 218, 19, 'PPL', 'P'),
(124609, 'Curtisville', 42.0222206115723, 0.733426108671361, -70.9180603027344, -1.2377536514106, 218, 23, 'PPL', 'P'),
(130400, 'Curtisville', 44.5597190856934, 0.777713811809106, -83.8672180175781, -1.46375908889465, 218, 27, 'PPL', 'P'),
(160608, 'Curtisville', 40.642219543457, 0.709340546351712, -79.8511123657227, -1.39366482216182, 218, 45, 'PPL', 'P'),
(180993, 'Curtner', 37.4697189331055, 0.653969965179547, -121.922500610352, -2.12794906791543, 218, 6, 'PPL', 'P'),
(86191, 'Curve', 35.8047218322754, 0.624910283733902, -89.456672668457, -1.5613134759434, 218, 50, 'PPL', 'P'),
(160609, 'Curwensville', 40.9755592346191, 0.715158421490072, -78.5252838134766, -1.37052474860817, 218, 45, 'PPL', 'P'),
(112409, 'Curzon', 39.9394416809082, 0.697074758740107, -95.1527786254883, -1.66072927943605, 218, 29, 'PPL', 'P'),
(124610, 'Curzon Mill', 42.8208312988281, 0.747364494605591, -70.9375, -1.23809293813348, 218, 23, 'PPL', 'P'),
(80598, 'Cusac Crossroads', 34.017219543457, 0.593712483407087, -79.8463897705078, -1.39358239732608, 218, 48, 'PPL', 'P'),
(101251, 'Cusco Willa', 36.5930595397949, 0.638669372347742, -78.3436126708984, -1.36735398901433, 218, 53, 'PPL', 'P'),
(15697, 'Cuscowilla (historical)', 29.4666690826416, 0.514290395087713, -82.2666702270508, -1.43582426011443, 218, 12, 'PPL', 'P'),
(160611, 'Cush Creek', 40.771671295166, 0.711599905641508, -78.8555603027344, -1.37628916078765, 218, 45, 'PPL', 'P'),
(160612, 'Cush Cushion Crossing', 40.7211112976074, 0.71071746721431, -78.8633270263672, -1.37642471568714, 218, 45, 'PPL', 'P'),
(180995, 'Cushenbury', 34.353889465332, 0.599588482036238, -116.857498168945, -2.03954809869134, 218, 6, 'PPL', 'P'),
(145074, 'Cushetunk', 40.6222190856934, 0.70899147251183, -74.7911071777344, -1.30535107146343, 218, 37, 'PPL', 'P'),
(75594, 'Cushing', 35.9850006103516, 0.628056741982804, -96.7666702270508, -1.6888970016536, 218, 42, 'PPL', 'P'),
(93596, 'Cushing', 31.8144397735596, 0.555266723726054, -94.8402786254883, -1.65527512552357, 218, 51, 'PPL', 'P'),
(115174, 'Cushing', 42.4647216796875, 0.741149209253564, -95.6747207641602, -1.66983888826078, 218, 16, 'PPL', 'P'),
(124611, 'Cushing', 42.8427810668945, 0.747747590328399, -70.8194427490234, -1.23603245039808, 218, 23, 'PPL', 'P'),
(127199, 'Cushing', 44.0191688537598, 0.768279430489446, -69.2402801513672, -1.20847086364464, 218, 26, 'PPL', 'P'),
(134890, 'Cushing', 46.139720916748, 0.80529004594855, -94.5766677856445, -1.65067424842435, 218, 28, 'PPL', 'P'),
(141598, 'Cushing', 41.2972183227539, 0.720772431646986, -98.3680572509766, -1.71684647781982, 218, 35, 'PPL', 'P'),
(173714, 'Cushing', 45.5705604553223, 0.7953563219245, -92.6508331298828, -1.6170620928323, 218, 57, 'PPL', 'P'),
(180996, 'Cushing', 35.4261093139648, 0.618302248700116, -120.603057861328, -2.10492044765341, 218, 6, 'PPL', 'P'),
(127200, 'Cushing Briggs', 43.8308296203613, 0.764992290755961, -70.1016693115234, -1.22350494063035, 218, 26, 'PPL', 'P'),
(127201, 'Cushing Island', 43.6411094665527, 0.761681049414611, -70.2083282470703, -1.22536649023232, 218, 26, 'PPL', 'P'),
(20429, 'Cushingville (historical)', 32.8077812194824, 0.572603802553929, -82.0097198486328, -1.43133962999679, 218, 13, 'PPL', 'P'),
(1936, 'Cushion', 34.475830078125, 0.601716747221375, -86.3708267211914, -1.50745530395429, 218, 2, 'PPL', 'P'),
(8368, 'Cushman', 35.8727798461914, 0.626098120159105, -91.7538909912109, -1.60140749931259, 218, 4, 'PPL', 'P'),
(26903, 'Cushman', 39.6599998474121, 0.69219757867779, -88.6241683959961, -1.54678353535203, 218, 18, 'PPL', 'P'),
(124612, 'Cushman', 42.413890838623, 0.740262043715431, -72.5069427490234, -1.26548488152549, 218, 23, 'PPL', 'P'),
(141599, 'Cushman', 40.8083305358887, 0.712239730093399, -96.7794418334961, -1.68911990823684, 218, 35, 'PPL', 'P'),
(143687, 'Cushman', 44.4058303833008, 0.775027947270734, -71.7230606079102, -1.25180355721548, 218, 36, 'PPL', 'P'),
(200660, 'Cushman', 43.9858283996582, 0.767697529791264, -124.043060302734, -2.16495981653259, 218, 43, 'PPL', 'P'),
(209873, 'Cushman', 46.288330078125, 0.807883765113205, -109.041938781738, -1.90314085449943, 218, 31, 'PPL', 'P'),
(8369, 'Cushman Junction', 35.7688903808594, 0.624284906930925, -91.6894378662109, -1.60028258006814, 218, 4, 'PPL', 'P'),
(112557, 'Cusick', 35.8511085510254, 0.625719884705287, -84.2216720581055, -1.46994547894885, 218, 50, 'PPL', 'P'),
(207154, 'Cusick', 48.3375015258789, 0.84364855381437, -117.296112060547, -2.04720335524477, 218, 56, 'PPL', 'P'),
(108774, 'Cusicks Crossing', 39.6730613708496, 0.692425545267101, -80.4516677856445, -1.40414649158015, 218, 58, 'PPL', 'P'),
(130401, 'Cusino', 46.4449996948242, 0.810618165762444, -86.3586120605469, -1.50724211790903, 218, 27, 'PPL', 'P'),
(1937, 'Cusseta', 32.7847213745117, 0.57220133233419, -85.3058319091797, -1.48886763796803, 218, 2, 'PPL', 'P'),
(20425, 'Cusseta', 32.3052787780762, 0.56383348045208, -84.7727813720703, -1.47956415101594, 218, 13, 'PPL', 'P'),
(93597, 'Cusseta', 33.1622200012207, 0.578789926292019, -94.4572219848633, -1.64858952592304, 218, 51, 'PPL', 'P'),
(134892, 'Cusson', 48.1019401550293, 0.839537232302533, -92.8427810668945, -1.62041221632556, 218, 28, 'PPL', 'P'),
(154917, 'Custaloga (historical)', 40.6705589294434, 0.709835161945167, -82.0727767944336, -1.43244018131726, 218, 41, 'PPL', 'P'),
(154918, 'Custar', 41.2847213745117, 0.720554318753708, -83.8444366455078, -1.4633614789439, 218, 41, 'PPL', 'P'),
(160616, 'Custards', 41.5302810668945, 0.724840143895973, -80.1594390869141, -1.39904613861849, 218, 45, 'PPL', 'P'),
(35479, 'Custer', 37.7383308410645, 0.658658127383496, -86.2547225952148, -1.50542890468085, 218, 21, 'PPL', 'P'),
(54312, 'Custer', 37.5363883972168, 0.65513356683883, -91.5194396972656, -1.59731555229769, 218, 29, 'PPL', 'P'),
(119294, 'Custer', 41.0372200012207, 0.716234604886573, -89.1536102294922, -1.55602403854434, 218, 18, 'PPL', 'P'),
(130402, 'Custer', 43.9519386291504, 0.767106041713157, -86.2194366455078, -1.50481304867877, 218, 27, 'PPL', 'P'),
(160614, 'Custer', 40.7416687011719, 0.711076261592171, -75.6391677856445, -1.32015252132793, 218, 45, 'PPL', 'P'),
(173715, 'Custer', 44.5105590820313, 0.77685580788491, -89.4261093139648, -1.56078004477705, 218, 57, 'PPL', 'P'),
(194807, 'Custer', 44.3875007629395, 0.774708035044788, -114.694999694824, -2.00180538024857, 218, 17, 'PPL', 'P'),
(196313, 'Custer', 46.1291694641113, 0.805105888359171, -107.554443359375, -1.87717916177084, 218, 31, 'PPL', 'P'),
(202040, 'Custer', 43.7666702270508, 0.76387249809661, -103.598327636719, -1.80813191682058, 218, 49, 'PPL', 'P'),
(207157, 'Custer', 47.1766700744629, 0.823388222926456, -122.526390075684, -2.13848892740358, 218, 56, 'PPL', 'P'),
(8371, 'Custer (historical)', 36.4180603027344, 0.635615059472558, -92.2375030517578, -1.60984812207149, 218, 4, 'PPL', 'P'),
(86193, 'Custer (historical)', 36.2583312988281, 0.632827262443463, -84.0133285522461, -1.46630919879646, 218, 50, 'PPL', 'P'),
(108775, 'Custer Addition', 39.2599983215332, 0.685216235038202, -80.3608322143555, -1.40256111178323, 218, 58, 'PPL', 'P'),
(75595, 'Custer City', 35.6650009155273, 0.622471693702744, -98.8827819824219, -1.72583011912499, 218, 42, 'PPL', 'P'),
(93598, 'Custer City', 33.6827812194824, 0.587875433508879, -97.0497207641602, -1.6938371654757, 218, 51, 'PPL', 'P'),
(160615, 'Custer City', 41.9058303833008, 0.731394715970876, -78.6519393920898, -1.372735305471, 218, 45, 'PPL', 'P'),
(119295, 'Custer Park', 41.2452812194824, 0.71986595819095, -88.129997253418, -1.5381586218457, 218, 18, 'PPL', 'P'),
(20427, 'Custer Road Terrace', 32.3891716003418, 0.565297686419405, -84.9416732788086, -1.4825118708685, 218, 13, 'PPL', 'P'),
(93599, 'Cut', 31.2216701507568, 0.544920942102341, -95.4816665649414, -1.66646945684961, 218, 51, 'PPL', 'P'),
(93601, 'Cut and Shoot', 30.3330593109131, 0.529411757178156, -95.357780456543, -1.66430723636058, 218, 51, 'PPL', 'P'),
(196315, 'Cut Bank', 48.6330604553223, 0.848807030266826, -112.32527923584, -1.96044595588743, 218, 31, 'PPL', 'P'),
(39975, 'Cut Off', 29.5424995422363, 0.515613886280942, -90.3380584716797, -1.57669656018997, 218, 22, 'PPL', 'P'),
(39976, 'Cut Off Landing', 31.9963893890381, 0.558442343588891, -91.6097183227539, -1.59889121155663, 218, 22, 'PPL', 'P'),
(39977, 'Cut-off Junction', 32.4361114501953, 0.566116941349741, -93.8036117553711, -1.63718187539368, 218, 22, 'PPL', 'P'),
(101252, 'Cutalong', 38.1211090087891, 0.665338866715041, -78.0527801513672, -1.36227800397664, 218, 53, 'PPL', 'P'),
(20428, 'Cutcane', 34.9363899230957, 0.609755032918589, -84.2372207641602, -1.47021685506393, 218, 13, 'PPL', 'P'),
(130406, 'Cutcheon', 44.4102783203125, 0.77510557841651, -85.1266708374023, -1.48574068737411, 218, 27, 'PPL', 'P'),
(148161, 'Cutchogue', 41.0105590820313, 0.715769284065109, -72.4855575561523, -1.26511163949871, 218, 40, 'PPL', 'P'),
(148162, 'Cutchogue Station', 41.0213890075684, 0.715958301923477, -72.4983291625977, -1.26533454608195, 218, 40, 'PPL', 'P'),
(86194, 'Cute (historical)', 35.5747184753418, 0.620895967864772, -84.7333297729492, -1.4788755907161, 218, 50, 'PPL', 'P'),
(93600, 'Cuthand', 33.4674987792969, 0.584118046105914, -95.0552825927734, -1.65902765265755, 218, 51, 'PPL', 'P'),
(20430, 'Cuthbert', 31.771110534668, 0.554510485845012, -84.789436340332, -1.47985483504893, 218, 13, 'PPL', 'P'),
(170114, 'Cuthbert', 43.9677810668945, 0.767382544413335, -98.2236099243164, -1.7143253963739, 218, 49, 'PPL', 'P'),
(191350, 'Cuthbert', 32.4813919067383, 0.566907234403222, -101.031669616699, -1.76333528359852, 218, 51, 'PPL', 'P'),
(59182, 'Cuthi Uckehaca (historical)', 32.6916694641113, 0.570577270122433, -88.6047210693359, -1.5464441154711, 218, 30, 'PPL', 'P'),
(15698, 'Cutler', 25.6147193908691, 0.447061190345103, -80.3108291625977, -1.40168839389401, 218, 12, 'PPL', 'P'),
(26904, 'Cutler', 38.0322189331055, 0.663787442222015, -89.565559387207, -1.56321390769728, 218, 18, 'PPL', 'P'),
(72258, 'Cutler', 39.3541717529297, 0.686859871483971, -81.790283203125, -1.42750973803315, 218, 41, 'PPL', 'P'),
(122468, 'Cutler', 40.476390838623, 0.706446289458041, -86.524169921875, -1.51013164769176, 218, 19, 'PPL', 'P'),
(127204, 'Cutler', 44.6575012207031, 0.779420432014656, -67.2044372558594, -1.17293870206469, 218, 26, 'PPL', 'P'),
(134894, 'Cutler', 46.3583297729492, 0.809105490263279, -93.7572174072266, -1.63637214126424, 218, 28, 'PPL', 'P'),
(173716, 'Cutler', 44.0258293151855, 0.768395677471028, -90.2366714477539, -1.57492702280366, 218, 57, 'PPL', 'P'),
(180997, 'Cutler', 36.5233306884766, 0.637452374308603, -119.285827636719, -2.08193044322719, 218, 6, 'PPL', 'P'),
(196316, 'Cutler (historical)', 46.2425003051758, 0.8070838846798, -105.747222900391, -1.84563721445216, 218, 31, 'PPL', 'P'),
(15699, 'Cutler Ridge', 25.5802803039551, 0.446460114887072, -80.3469390869141, -1.40231863096598, 218, 12, 'PPL', 'P'),
(46153, 'Cutler Ridge', 39.1363906860352, 0.683058874818156, -76.6719436645508, -1.33817786085002, 218, 25, 'PPL', 'P'),
(80599, 'Cutler Ridge', 34.7838897705078, 0.607093403146136, -82.4180603027344, -1.43846651538995, 218, 48, 'PPL', 'P'),
(15700, 'Cutlers', 28.8624992370605, 0.503745642041058, -82.5830612182617, -1.44134632463471, 218, 12, 'PPL', 'P'),
(130407, 'Cutlerville', 42.8408317565918, 0.747713568445473, -85.6636123657227, -1.49511208493399, 218, 27, 'PPL', 'P'),
(108776, 'Cutlips', 38.7886085510254, 0.67698893148262, -80.7544403076172, -1.40943086897314, 218, 58, 'PPL', 'P'),
(119297, 'Cutmer', 40.6502799987793, 0.709481227836295, -87.5999984741211, -1.52890839811542, 218, 18, 'PPL', 'P'),
(20431, 'Cutoff', 32.2763900756836, 0.5633292774787, -84.0538864135742, -1.4670170670142, 218, 13, 'PPL', 'P'),
(39978, 'Cutoff', 29.9177799224854, 0.522163764534423, -89.977783203125, -1.57040857054018, 218, 22, 'PPL', 'P'),
(64090, 'Cutshalltown', 35.9605598449707, 0.6276301701552, -82.6897201538086, -1.44320787423667, 218, 33, 'PPL', 'P'),
(35480, 'Cutshin', 37.0888900756836, 0.647323247730928, -83.254997253418, -1.45307382081098, 218, 21, 'PPL', 'P'),
(193477, 'Cutten', 40.7700004577637, 0.711570744027571, -124.141670227051, -2.16668088438705, 218, 6, 'PPL', 'P'),
(173718, 'Cutter', 46.6330604553223, 0.81390044522694, -91.958610534668, -1.6049805293891, 218, 57, 'PPL', 'P'),
(178050, 'Cutter', 33.3527793884277, 0.582115815019365, -110.65193939209, -1.93124066610918, 218, 5, 'PPL', 'P'),
(188396, 'Cutter', 33.0602798461914, 0.577010734946765, -107.021942138672, -1.86788526219869, 218, 38, 'PPL', 'P'),
(15701, 'Cutter Bank', 25.3777809143066, 0.442925833804428, -80.2638931274414, -1.4008692055427, 218, 12, 'PPL', 'P'),
(143690, 'Cutter Hill', 42.7486114501953, 0.746104020461656, -71.9899978637695, -1.25646249122646, 218, 36, 'PPL', 'P'),
(20432, 'Cutting', 31.014440536499, 0.541304103025904, -82.8036117553711, -1.44519565767431, 218, 13, 'PPL', 'P'),
(148163, 'Cutting', 42.024169921875, 0.733460130554287, -79.6961135864258, -1.39095958312652, 218, 40, 'PPL', 'P'),
(180998, 'Cuttings Wharf', 38.2266693115234, 0.667181241557158, -122.307777404785, -2.13467341650983, 218, 6, 'PPL', 'P'),
(171893, 'Cuttingsville', 43.4883308410645, 0.75901455937317, -72.8827819824219, -1.27204451360646, 218, 55, 'PPL', 'P'),
(127205, 'Cutts Island', 43.0908317565918, 0.752076891575459, -70.6655578613281, -1.23334665243874, 218, 26, 'PPL', 'P'),
(124613, 'Cuttyhunk', 41.4208297729492, 0.722929858446059, -70.9297180175781, -1.23795711691788, 218, 23, 'PPL', 'P'),
(35482, 'Cutuno', 37.7180595397949, 0.658304326432679, -83.2433319091797, -1.45287022214564, 218, 21, 'PPL', 'P'),
(154920, 'Cuyahoga Falls', 41.1338882446289, 0.717921784016165, -81.4847183227539, -1.42217662479221, 218, 41, 'PPL', 'P'),
(154922, 'Cuyahoga Heights', 41.4352798461914, 0.72318205980129, -81.6575012207031, -1.42519225525256, 218, 41, 'PPL', 'P'),
(180999, 'Cuyama', 34.9352798461914, 0.609735658421658, -119.614166259766, -2.08766103326082, 218, 6, 'PPL', 'P'),
(181002, 'Cuyamaca (historical)', 32.9847183227539, 0.575691937574957, -116.569999694824, -2.03453030372347, 218, 6, 'PPL', 'P'),
(188397, 'Cuyamungue', 35.8697204589844, 0.626044723779249, -106.003608703613, -1.85011199087377, 218, 38, 'PPL', 'P'),
(148164, 'Cuyler', 42.7372207641602, 0.745905215486282, -75.9488906860352, -1.32555820570857, 218, 40, 'PPL', 'P'),
(191351, 'Cuyler', 35.3891716003418, 0.617657563979235, -101.272499084473, -1.76753855074699, 218, 51, 'PPL', 'P'),
(148166, 'Cuylerville', 42.7769393920898, 0.746598436318029, -77.8711090087891, -1.35910724438279, 218, 40, 'PPL', 'P'),
(134895, 'Cuyuna', 46.5169410705566, 0.811873779637389, -93.9227828979492, -1.63926180420504, 218, 28, 'PPL', 'P'),
(29593, 'Cuzco', 38.4749984741211, 0.671515403073207, -86.7227783203125, -1.51359801816661, 218, 19, 'PPL', 'P'),
(101253, 'Cuzco (historical)', 38.0380592346191, 0.663889374712738, -77.8872222900391, -1.3593884741939, 218, 53, 'PPL', 'P'),
(35481, 'Cuzick', 37.834171295166, 0.660330858864174, -84.45361328125, -1.47399361696382, 218, 21, 'PPL', 'P'),
(108777, 'Cuzzart', 39.5936088562012, 0.691038837287496, -79.5650024414063, -1.38867126195987, 218, 58, 'PPL', 'P'),
(108778, 'Cuzzie', 38.1236114501953, 0.665382542556918, -82.2213897705078, -1.43503396706095, 218, 58, 'PPL', 'P'),
(59183, 'Cybur', 30.6277809143066, 0.53455561953413, -89.7708282470703, -1.56679652515371, 218, 30, 'PPL', 'P'),
(64091, 'Cycle', 36.1341705322266, 0.630660248264465, -80.8422164916992, -1.41096285239021, 218, 33, 'PPL', 'P'),
(35483, 'Cyclone', 36.8375015258789, 0.642935689835022, -85.679443359375, -1.49538838789708, 218, 21, 'PPL', 'P'),
(54313, 'Cyclone', 36.6183280944824, 0.639110391824259, -94.2561111450195, -1.64507947960631, 218, 29, 'PPL', 'P'),
(59184, 'Cyclone', 31.8702793121338, 0.556241307526968, -89.8000030517578, -1.56730572155413, 218, 30, 'PPL', 'P'),
(93602, 'Cyclone', 31.0275001525879, 0.541532036325702, -97.1505584716797, -1.69559711548208, 218, 51, 'PPL', 'P'),
(108779, 'Cyclone', 37.732780456543, 0.658561254898844, -81.6888885498047, -1.42574006748879, 218, 58, 'PPL', 'P'),
(122464, 'Cyclone', 40.228328704834, 0.702116788473899, -86.432502746582, -1.5085317536669, 218, 19, 'PPL', 'P'),
(160620, 'Cyclone', 41.832218170166, 0.730109940481995, -78.5861129760742, -1.37158641777674, 218, 45, 'PPL', 'P'),
(86195, 'Cyclone (historical)', 35.1944389343262, 0.614258837796076, -87.6911087036133, -1.53049857160231, 218, 50, 'PPL', 'P'),
(178049, 'Cyclopic', 35.7827796936035, 0.624527321169149, -114.245277404785, -1.99395624556778, 218, 5, 'PPL', 'P'),
(72259, 'Cyclorama Heights', 39.1405601501465, 0.683131645694942, -84.5805587768555, -1.47620923383272, 218, 41, 'PPL', 'P'),
(154924, 'Cygnet', 41.2400016784668, 0.719773812817234, -83.6433334350586, -1.45985156578523, 218, 41, 'PPL', 'P'),
(181003, 'Cygnus', 38.1527786254883, 0.665891605799287, -122.08805847168, -2.13083859769817, 218, 6, 'PPL', 'P'),
(46154, 'Cylburn (historical)', 39.3597183227539, 0.686956677389596, -76.6513900756836, -1.33781913305118, 218, 25, 'PPL', 'P'),
(115175, 'Cylinder', 43.0888900756836, 0.752043002850587, -94.5527801513672, -1.6502573305557, 218, 16, 'PPL', 'P'),
(173719, 'Cylon', 45.1222190856934, 0.787531288851575, -92.352783203125, -1.61186014027505, 218, 57, 'PPL', 'P'),
(113286, 'Cymbria', 40.6575012207031, 0.709607261934883, -78.7483291625977, -1.3744176243316, 218, 45, 'PPL', 'P'),
(59185, 'Cynthia', 32.4027786254883, 0.565535173809613, -90.248893737793, -1.57514034200698, 218, 30, 'PPL', 'P'),
(39979, 'Cynthia Park', 32.4677810668945, 0.566669680433987, -93.8047180175781, -1.63720118331159, 218, 22, 'PPL', 'P'),
(29595, 'Cynthiana', 38.1875, 0.666497608105335, -87.7102813720703, -1.53083319779328, 218, 19, 'PPL', 'P'),
(35484, 'Cynthiana', 38.3902816772461, 0.670036816035995, -84.2941665649414, -1.47121074678275, 218, 21, 'PPL', 'P'),
(72260, 'Cynthiana', 39.1736106872559, 0.683708486387053, -83.3486099243164, -1.45470767013974, 218, 41, 'PPL', 'P'),
(160617, 'Cynwyd Estates', 40.0027809143066, 0.698180236908599, -75.2433319091797, -1.3132438819861, 218, 45, 'PPL', 'P'),
(181004, 'Cypave', 33.9194412231445, 0.592005929780565, -118.327217102051, -2.06519953315293, 218, 6, 'PPL', 'P'),
(8375, 'Cypert', 34.4900016784668, 0.601964088307616, -90.9561080932617, -1.58748356102728, 218, 4, 'PPL', 'P'),
(160618, 'Cypher', 40.0924987792969, 0.699746109050538, -78.311393737793, -1.36679166255016, 218, 45, 'PPL', 'P'),
(39981, 'Cypremort', 29.7747192382813, 0.519666884564906, -91.7744369506836, -1.60176609395337, 218, 22, 'PPL', 'P'),
(39980, 'Cypremort Point', 29.7183303833008, 0.518682713384067, -91.8716735839844, -1.60346319335803, 218, 22, 'PPL', 'P'),
(1938, 'Cypress', 32.9477806091309, 0.575047252854076, -87.6669387817383, -1.53007672688564, 218, 2, 'PPL', 'P'),
(15702, 'Cypress', 30.7130603790283, 0.536044026977862, -85.0738906860352, -1.48481949995305, 218, 12, 'PPL', 'P'),
(26906, 'Cypress', 37.3650016784668, 0.652142304302453, -89.0180587768555, -1.55365821938996, 218, 18, 'PPL', 'P'),
(29596, 'Cypress', 37.9141693115234, 0.661727087644676, -87.6297225952148, -1.52942718189577, 218, 19, 'PPL', 'P'),
(39983, 'Cypress', 31.6052799224854, 0.551616195661828, -93.0386123657227, -1.62383011726857, 218, 22, 'PPL', 'P'),
(86197, 'Cypress', 35.0280609130859, 0.611354993522481, -88.7080612182617, -1.54824774131936, 218, 50, 'PPL', 'P'),
(93604, 'Cypress', 29.9688892364502, 0.523055790341545, -95.6969375610352, -1.6702266445155, 218, 51, 'PPL', 'P'),
(113140, 'Cypress', 40.0513916015625, 0.69902865345287, -94.0572204589844, -1.64160818228345, 218, 29, 'PPL', 'P'),
(181005, 'Cypress', 33.8169403076172, 0.590216951318304, -118.036392211914, -2.06012368127329, 218, 6, 'PPL', 'P'),
(8374, 'Cypress (historical)', 35.5852813720703, 0.621080325191232, -90.45361328125, -1.57871337208348, 218, 4, 'PPL', 'P'),
(196317, 'Cypress (historical)', 48.5666694641113, 0.847648288876533, -109.799438476563, -1.91636171825696, 218, 31, 'PPL', 'P'),
(8376, 'Cypress Corner', 34.6569404602051, 0.604877719698217, -90.7677764892578, -1.58419655445185, 218, 4, 'PPL', 'P'),
(59186, 'Cypress Corner', 34.5541687011719, 0.603084014125022, -90.0930633544922, -1.57242058874374, 218, 30, 'PPL', 'P'),
(15703, 'Cypress Creek', 30.5733299255371, 0.533605270499135, -82.7941665649414, -1.44503080800283, 218, 12, 'PPL', 'P'),
(39985, 'Cypress Creek', 30.8474998474121, 0.53839043834579, -92.5513916015625, -1.61532651074989, 218, 22, 'PPL', 'P'),
(46155, 'Cypress Creek', 39.0724983215332, 0.681943742690712, -76.5283279418945, -1.33567129363204, 218, 25, 'PPL', 'P'),
(64093, 'Cypress Creek', 34.7513885498047, 0.606526149833949, -77.7052764892578, -1.35621292091009, 218, 33, 'PPL', 'P'),
(80601, 'Cypress Creek', 34.9786109924316, 0.610491929592213, -81.8666687011719, -1.42884291647484, 218, 48, 'PPL', 'P'),
(93605, 'Cypress Creek', 30.017219543457, 0.523899313327314, -98.9766693115234, -1.72746876214371, 218, 51, 'PPL', 'P'),
(80602, 'Cypress Crossroads', 34.2166709899902, 0.597193567846957, -80.1350021362305, -1.39861963336991, 218, 48, 'PPL', 'P'),
(178051, 'Cypress Estates', 33.4161109924316, 0.583221160029802, -111.755561828613, -1.9505025113254, 218, 5, 'PPL', 'P'),
(80603, 'Cypress Fork Crossroads', 33.746940612793, 0.58899522616823, -80.0747222900391, -1.39756755158128, 218, 48, 'PPL', 'P'),
(15704, 'Cypress Gardens', 27.9936103820801, 0.488580670687765, -81.6902770996094, -1.42576430225471, 218, 12, 'PPL', 'P'),
(39987, 'Cypress Gardens', 29.6258296966553, 0.517068271841747, -90.7533264160156, -1.58394435309662, 218, 22, 'PPL', 'P'),
(181008, 'Cypress Grove', 38.165828704834, 0.666119372651516, -122.899436950684, -2.14499982363661, 218, 6, 'PPL', 'P'),
(15705, 'Cypress Harbor', 26.2144393920898, 0.457528278956469, -80.120002746582, -1.39835784463476, 218, 12, 'PPL', 'P'),
(1941, 'Cypress Heights', 34.8227806091309, 0.60777217632897, -87.7152786254883, -1.53092041631898, 218, 2, 'PPL', 'P'),
(181009, 'Cypress Hill', 39.2286109924316, 0.684668422801972, -121.058326721191, -2.11286638823982, 218, 6, 'PPL', 'P'),
(148167, 'Cypress Hills', 40.6769409179688, 0.709946548657759, -73.8916702270508, -1.2896529352599, 218, 40, 'PPL', 'P'),
(86198, 'Cypress Inn', 35.0119400024414, 0.611073630553314, -87.8166732788086, -1.53269008686333, 218, 50, 'PPL', 'P'),
(15706, 'Cypress Isles Estates', 26.2213897705078, 0.457649585944122, -80.1113891601563, -1.39820750919122, 218, 12, 'PPL', 'P'),
(46156, 'Cypress Knolls', 38.4944381713867, 0.671854689796084, -76.5858306884766, -1.33667490588883, 218, 25, 'PPL', 'P'),
(15707, 'Cypress Lake', 26.5377807617188, 0.463171650464401, -81.8994369506836, -1.42941483031893, 218, 12, 'PPL', 'P'),
(15708, 'Cypress Lake Estates', 29.0605602264404, 0.507202458425494, -81.2611083984375, -1.41827389537275, 218, 12, 'PPL', 'P'),
(20433, 'Cypress Lake Estates', 30.7474994659424, 0.536645102435893, -81.522216796875, -1.42283109663009, 218, 13, 'PPL', 'P'),
(15709, 'Cypress Lakes', 26.7275009155273, 0.466482891805751, -80.1230621337891, -1.39841124101461, 218, 12, 'PPL', 'P'),
(101256, 'Cypress Manor', 36.7194404602051, 0.6408751355206, -76.5611114501953, -1.33624347379224, 218, 53, 'PPL', 'P'),
(93606, 'Cypress Mill', 30.3808307647705, 0.530245526336432, -98.2502822875977, -1.71479091693245, 218, 51, 'PPL', 'P'),
(20434, 'Cypress Mills', 31.1902809143066, 0.544373096576598, -81.4697189331055, -1.42191483605705, 218, 13, 'PPL', 'P'),
(15710, 'Cypress Point', 29.6977806091309, 0.518324052164261, -81.5902786254883, -1.42401899963432, 218, 12, 'PPL', 'P'),
(39989, 'Cypress Point', 32.540828704834, 0.567944602226835, -92.0411071777344, -1.60642036743245, 218, 22, 'PPL', 'P'),
(15711, 'Cypress Quarters', 27.2516708374023, 0.475631382782391, -80.8141708374023, -1.41047336338185, 218, 12, 'PPL', 'P'),
(64096, 'Cypress Shores', 35.089168548584, 0.61242152296003, -77.105827331543, -1.34575055940966, 218, 33, 'PPL', 'P'),
(20435, 'Cypress Siding', 30.9655609130859, 0.540450992660211, -82.1152801513672, -1.43318200483891, 218, 13, 'PPL', 'P'),
(8378, 'Cypress Valley', 35.2708282470703, 0.615592082816797, -92.629997253418, -1.61669843818545, 218, 4, 'PPL', 'P'),
(203667, 'Cyprus Heights', 40.6980590820313, 0.710315130152626, -112.079170227051, -1.95615054336524, 218, 52, 'PPL', 'P'),
(115176, 'Cypsum City (historical)', 42.4736099243164, 0.741304338387061, -94.1277770996094, -1.6428396279715, 218, 16, 'PPL', 'P'),
(196318, 'Cyr', 47.0102806091309, 0.820484178915779, -114.583892822266, -1.99986619950083, 218, 31, 'PPL', 'P'),
(20438, 'Cyrene', 30.9624996185303, 0.540397562990842, -84.6922225952148, -1.47815813511844, 218, 13, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(54316, 'Cyrene', 39.2863883972168, 0.685676828748731, -91.1063919067383, -1.5901065083849, 218, 29, 'PPL', 'P'),
(1942, 'Cyril', 32.1780586242676, 0.561613069893226, -88.4222183227539, -1.54325884164931, 218, 2, 'PPL', 'P'),
(75597, 'Cyril', 34.8963890075684, 0.609056885238824, -98.2002792358398, -1.71391819904323, 218, 42, 'PPL', 'P'),
(127208, 'Cyrs', 44.9497184753418, 0.78452058523924, -69.4736099243164, -1.21254323642553, 218, 26, 'PPL', 'P'),
(35485, 'Cyrus', 37.7936096191406, 0.659622924067404, -83.040283203125, -1.44932635368307, 218, 21, 'PPL', 'P'),
(54314, 'Cyrus', 36.6594390869141, 0.639827914000954, -90.0555572509766, -1.57176598374779, 218, 29, 'PPL', 'P'),
(64100, 'Cyrus', 34.7205581665039, 0.605988058135699, -77.5791702270508, -1.35401195142719, 218, 33, 'PPL', 'P'),
(108780, 'Cyrus', 38.3052787780762, 0.66855323557174, -82.5727767944336, -1.44116682757724, 218, 58, 'PPL', 'P'),
(134898, 'Cyrus', 45.6147193908691, 0.796127040743969, -95.7377777099609, -1.67093943958126, 218, 28, 'PPL', 'P'),
(160619, 'Cyrus', 41.2397193908691, 0.719768885969217, -79.809440612793, -1.39293751286812, 218, 45, 'PPL', 'P'),
(54315, 'Czar', 37.753059387207, 0.658915189007716, -91.1183319091797, -1.5903149007402, 218, 29, 'PPL', 'P'),
(108787, 'Czar', 38.7299995422363, 0.675966011307921, -80.1872177124023, -1.39953096709494, 218, 58, 'PPL', 'P'),
(173721, 'Czechville', 44.1872215270996, 0.771212502956005, -91.7733306884766, -1.60174678603547, 218, 57, 'PPL', 'P'),
(13623, 'D and K Mobile Home Park', 38.9708290100098, 0.680169278456393, -75.5269393920898, -1.31819376634617, 218, 10, 'PPL', 'P'),
(188399, 'D Candelaria Place', 34.6147193908691, 0.604140823024592, -106.361389160156, -1.85635643783973, 218, 38, 'PPL', 'P'),
(193478, 'D Flourney', 41.2400016784668, 0.719773812817234, -120.531387329102, -2.1036695608894, 218, 6, 'PPL', 'P'),
(93607, 'D T Villareal Colonia', 26.2919998168945, 0.458881963738556, -98.0650024414063, -1.71155717357882, 218, 51, 'PPL', 'P'),
(39990, 'D''Arbonne', 32.6747207641602, 0.570281459504352, -92.4741668701172, -1.6139786849222, 218, 22, 'PPL', 'P'),
(39991, 'D''Arbonne Hills', 32.5591697692871, 0.568264714189863, -92.1694412231445, -1.60866021906726, 218, 22, 'PPL', 'P'),
(46157, 'D''Arcy Hills', 38.8486099243164, 0.678036153002266, -76.8441696166992, -1.34118377077239, 218, 25, 'PPL', 'P'),
(93608, 'D''Hanis', 29.3302803039551, 0.511909961836859, -99.2794418334961, -1.7327531395367, 218, 51, 'PPL', 'P'),
(59187, 'D''Iberville', 30.4261093139648, 0.5310357861004, -88.8908309936523, -1.55143767567306, 218, 30, 'PPL', 'P'),
(59188, 'D''Lo', 31.985559463501, 0.558253325730523, -89.9011077880859, -1.56907033209242, 218, 30, 'PPL', 'P'),
(1943, 'D''Olive', 30.8702793121338, 0.538788015007025, -87.7958297729492, -1.53232629905843, 218, 2, 'PPL', 'P'),
(93609, 'D-5 Acres Colonia', 27.4820003509521, 0.479651391158352, -99.3830032348633, -1.73456062696854, 218, 51, 'PPL', 'P'),
(70715, 'Da Costa', 39.6166687011719, 0.691441307507235, -74.7750015258789, -1.30506997481037, 218, 37, 'PPL', 'P'),
(127207, 'Daaquam', 46.598331451416, 0.813294309762838, -70.0116729736328, -1.22193420821942, 218, 26, 'PPL', 'P'),
(8381, 'Dabney', 35.6316719055176, 0.621889992741644, -92.7863922119141, -1.61942804514472, 218, 4, 'PPL', 'P'),
(29597, 'Dabney', 39.0900001525879, 0.682249207267745, -85.3469390869141, -1.48958509356569, 218, 19, 'PPL', 'P'),
(35486, 'Dabney', 37.1838912963867, 0.648981331825611, -84.5500030517578, -1.47567593582443, 218, 21, 'PPL', 'P'),
(64097, 'Dabney', 36.3527793884277, 0.634475692579195, -78.4977798461914, -1.37004471382169, 218, 33, 'PPL', 'P'),
(108781, 'Dabney', 37.811939239502, 0.65994283629335, -81.9286117553711, -1.42992402671936, 218, 58, 'PPL', 'P'),
(191352, 'Dabney', 29.1622200012207, 0.508976756212246, -100.099166870117, -1.74706004038677, 218, 51, 'PPL', 'P'),
(59189, 'Dabney Crossroads', 32.086109161377, 0.560008249020344, -90.4277801513672, -1.57826249891093, 218, 30, 'PPL', 'P'),
(101257, 'Dabney Estates', 37.1452789306641, 0.648307418911766, -77.5555572509766, -1.3535998272485, 218, 53, 'PPL', 'P'),
(101258, 'Dabneys', 37.7633285522461, 0.659094419749078, -77.8019409179688, -1.35790003346065, 218, 53, 'PPL', 'P'),
(207158, 'Dabob', 47.8472213745117, 0.835091550915836, -122.803062438965, -2.14331777109211, 218, 56, 'PPL', 'P'),
(35487, 'Dabolt', 37.3380584716797, 0.651672056632972, -84.0266723632813, -1.46654209223378, 218, 21, 'PPL', 'P'),
(173722, 'Dacada', 43.5433311462402, 0.759974495788089, -87.9086074829102, -1.53429464142011, 218, 57, 'PPL', 'P'),
(75599, 'Dacoma', 36.6594390869141, 0.639827914000954, -98.5627822875977, -1.72024507084493, 218, 42, 'PPL', 'P'),
(194153, 'Dacono', 40.0847206115723, 0.699610354413971, -104.938888549805, -1.83152911857747, 218, 7, 'PPL', 'P'),
(93610, 'Dacosta', 28.7199993133545, 0.501258549188547, -96.8727798461914, -1.69074896387565, 218, 51, 'PPL', 'P'),
(20436, 'Dacula', 33.9886093139648, 0.593213140702698, -83.898063659668, -1.46429744690901, 218, 13, 'PPL', 'P'),
(93611, 'Dacus', 30.4469394683838, 0.531399340878709, -95.7925033569336, -1.67189458230621, 218, 51, 'PPL', 'P'),
(80605, 'Dacusville', 34.9352798461914, 0.609735658421658, -82.5588912963867, -1.44092447991804, 218, 48, 'PPL', 'P'),
(202044, 'Dacy (historical)', 44.3541717529297, 0.774126334083688, -103.908332824707, -1.81354252804924, 218, 49, 'PPL', 'P'),
(86199, 'Daddys Creek', 35.9263916015625, 0.627033821808104, -84.9283294677734, -1.48227897743117, 218, 50, 'PPL', 'P'),
(64099, 'Daddysville', 35.9075012207031, 0.626704122465153, -78.2219390869141, -1.3652303843611, 218, 33, 'PPL', 'P'),
(15716, 'Dade City', 28.3644409179688, 0.495052884505958, -82.1961135864258, -1.43459281442637, 218, 12, 'PPL', 'P'),
(1944, 'Dadeville', 32.8311080932617, 0.573010933305575, -85.7636108398438, -1.49685738755437, 218, 2, 'PPL', 'P'),
(54317, 'Dadeville', 37.480281829834, 0.654154322506008, -93.6736068725586, -1.63491286214494, 218, 29, 'PPL', 'P'),
(93612, 'Dads Corner', 33.7461090087891, 0.588980711940289, -98.6877822875977, -1.72242673240992, 218, 51, 'PPL', 'P'),
(134899, 'Dads Corner', 46.3327789306641, 0.808659543938745, -93.2588882446289, -1.62767465661821, 218, 28, 'PPL', 'P'),
(200662, 'Dads Creek', 42.8902816772461, 0.74857663237574, -123.559440612793, -2.15651906061564, 218, 43, 'PPL', 'P'),
(72262, 'Dadsville', 39.7444381713867, 0.693671305446013, -84.5008316040039, -1.47481773216315, 218, 41, 'PPL', 'P'),
(148168, 'Dadville', 43.8066711425781, 0.764570645776375, -75.4749984741211, -1.31728722631111, 218, 40, 'PPL', 'P'),
(93613, 'Daffan', 30.3198795318604, 0.529181726639, -97.6264877319336, -1.70390364808009, 218, 51, 'PPL', 'P'),
(101260, 'Daffan', 38.3566703796387, 0.669450188226878, -77.408332824707, -1.35103027627074, 218, 53, 'PPL', 'P'),
(35488, 'Daffenville', 36.9197196960449, 0.644370667609384, -88.3386077880859, -1.54179956253, 218, 21, 'PPL', 'P'),
(20439, 'Daffin Heights', 32.0283317565918, 0.558999843073586, -81.0811080932617, -1.41513229739284, 218, 13, 'PPL', 'P'),
(20440, 'Dafron', 34.9569396972656, 0.610113694138395, -85.2022171020508, -1.48705921842981, 218, 13, 'PPL', 'P'),
(154927, 'Daft Subdivision', 41.5686111450195, 0.725509129961801, -84.5558319091797, -1.47577766857807, 218, 41, 'PPL', 'P'),
(130408, 'Dafter', 46.3600006103516, 0.809134651877216, -84.4272232055664, -1.4735330232533, 218, 27, 'PPL', 'P'),
(178053, 'Dagger', 33.6944389343262, 0.588078899016161, -110.8125, -1.93404297736622, 218, 5, 'PPL', 'P'),
(101259, 'Daggers Springs', 37.6855583190918, 0.657737073120492, -79.7619400024414, -1.39210847082078, 218, 53, 'PPL', 'P'),
(8382, 'Daggett', 35.0341682434082, 0.611461586545111, -91.3197174072266, -1.59382974074688, 218, 4, 'PPL', 'P'),
(29598, 'Daggett', 39.2155609130859, 0.684440655949743, -87.0388870239258, -1.51911515583887, 218, 19, 'PPL', 'P'),
(130410, 'Daggett', 45.4636116027832, 0.793489712316463, -87.6063919067383, -1.5290199845651, 218, 27, 'PPL', 'P'),
(160621, 'Daggett', 41.9486083984375, 0.73214133318248, -76.9263916015625, -1.34261881512578, 218, 45, 'PPL', 'P'),
(181011, 'Daggett', 34.8633308410645, 0.608479911388659, -116.887222290039, -2.04006688247169, 218, 6, 'PPL', 'P'),
(119298, 'Daggett (historical)', 42.0325012207031, 0.733605539149805, -89.9736099243164, -1.57033573308437, 218, 18, 'PPL', 'P'),
(54320, 'Daggetts Ford (historical)', 38.3247184753418, 0.668892522294616, -91.8477783203125, -1.60304614233132, 218, 29, 'PPL', 'P'),
(198160, 'Daglum', 46.7088890075684, 0.815223903130655, -103.019996643066, -1.79803813681501, 218, 34, 'PPL', 'P'),
(8383, 'Dagmar', 34.8561096191406, 0.608353877290071, -91.3005599975586, -1.59349538087202, 218, 4, 'PPL', 'P'),
(196320, 'Dagmar', 48.5833282470703, 0.847939039488542, -104.197776794434, -1.81859427832101, 218, 31, 'PPL', 'P'),
(181012, 'Dagon', 38.3447189331055, 0.669241596134498, -120.96028137207, -2.11115517408139, 218, 6, 'PPL', 'P'),
(54319, 'Dagonia', 37.3122215270996, 0.651221116881395, -91.1222229003906, -1.59038281134799, 218, 29, 'PPL', 'P'),
(13624, 'Dagsboro', 38.5491714477539, 0.672809965679095, -75.2461090087891, -1.31329235151794, 218, 10, 'PPL', 'P'),
(154928, 'Dague', 41.0627784729004, 0.716680684369161, -84.5802764892578, -1.4762043069847, 218, 41, 'PPL', 'P'),
(160622, 'Dagus', 41.3616714477539, 0.721897350891435, -78.6161117553711, -1.37210999524704, 218, 45, 'PPL', 'P'),
(160624, 'Dagus Mines', 41.353889465332, 0.721761529675841, -78.605827331543, -1.37193049818957, 218, 45, 'PPL', 'P'),
(160623, 'Daguscahonda', 41.4194412231445, 0.722905623680139, -78.6558303833008, -1.37280321607879, 218, 45, 'PPL', 'P'),
(119299, 'Dahinda', 40.9247207641602, 0.714271122793884, -90.10888671875, -1.57269675854878, 218, 18, 'PPL', 'P'),
(35489, 'Dahl', 37.1816711425781, 0.64894258283175, -84.4347229003906, -1.47366391762087, 218, 21, 'PPL', 'P'),
(173723, 'Dahl', 44.9902801513672, 0.78522852003601, -92.3183288574219, -1.61125879850091, 218, 57, 'PPL', 'P'),
(212247, 'Dahl', 65.3647232055664, 1.14082963459188, -164.713607788086, -2.87479477874067, 218, 1, 'PPL', 'P'),
(196321, 'Dahl Place', 45.6358299255371, 0.796495489080781, -110.425827026367, -1.92729426084785, 218, 31, 'PPL', 'P'),
(15717, 'Dahlberg', 26.6697196960449, 0.465474419279965, -80.7002792358398, -1.40848557994422, 218, 12, 'PPL', 'P'),
(170115, 'Dahlberg', 45.8558311462402, 0.800335234740457, -97.1849975585938, -1.69619819094011, 218, 49, 'PPL', 'P'),
(139857, 'Dahlen', 48.1580581665039, 0.840516676372437, -97.9291687011719, -1.70918642757643, 218, 34, 'PPL', 'P'),
(26907, 'Dahlgren', 38.1980590820313, 0.666681898852768, -88.684440612793, -1.54783548398261, 218, 18, 'PPL', 'P'),
(101261, 'Dahlgren', 38.3311080932617, 0.669004042165263, -77.0513916015625, -1.34480047669077, 218, 53, 'PPL', 'P'),
(134901, 'Dahlgren', 44.776668548584, 0.781500294246981, -93.6833267211914, -1.63508250550637, 218, 28, 'PPL', 'P'),
(101262, 'Dahlgren Junction', 38.3141708374023, 0.668708431284264, -77.4480590820313, -1.35172363026054, 218, 53, 'PPL', 'P'),
(101263, 'Dahlgrens Corner', 37.7088890075684, 0.658144270451165, -76.9250030517578, -1.34259458035986, 218, 53, 'PPL', 'P'),
(101264, 'Dahlia', 36.5697212219238, 0.638262041859015, -77.5391693115234, -1.35331380374743, 218, 53, 'PPL', 'P'),
(188400, 'Dahlia', 35.1213912963867, 0.612983916003228, -105.276390075684, -1.83741963143456, 218, 38, 'PPL', 'P'),
(207159, 'Dahlia', 46.2613906860352, 0.807413584022752, -123.613059997559, -2.15745489542269, 218, 56, 'PPL', 'P'),
(20441, 'Dahlonega', 34.5325012207031, 0.602705845250231, -83.9850006103516, -1.46581478294008, 218, 13, 'PPL', 'P'),
(115177, 'Dahlonega', 41.0586090087891, 0.716607913492375, -92.3697204589844, -1.61215575115605, 218, 16, 'PPL', 'P'),
(108782, 'Dahmer', 38.5694389343262, 0.673163700050885, -79.3266677856445, -1.38451153749522, 218, 58, 'PPL', 'P'),
(160625, 'Dahoga', 41.5991706848145, 0.726042494549117, -78.7241668701172, -1.37399591277298, 218, 45, 'PPL', 'P'),
(15718, 'Dahoma', 30.4697208404541, 0.531796950829458, -81.9086074829102, -1.42957488630045, 218, 12, 'PPL', 'P'),
(8384, 'Dahoma (historical)', 35.3583297729492, 0.617119272543903, -93.9747161865234, -1.64016821108204, 218, 4, 'PPL', 'P'),
(59190, 'Dahomy', 33.6744384765625, 0.587729825176279, -90.9850006103516, -1.58798783057969, 218, 30, 'PPL', 'P'),
(127209, 'Daigle', 47.1894416809082, 0.823611129509696, -68.4613876342773, -1.19487662470227, 218, 26, 'PPL', 'P'),
(127210, 'Daigle Mill', 47.2363891601563, 0.824430517598086, -68.1247177124023, -1.18900062607312, 218, 26, 'PPL', 'P'),
(108783, 'Dailey', 38.7986106872559, 0.677163501692075, -79.8963928222656, -1.3944551152153, 218, 58, 'PPL', 'P'),
(119300, 'Dailey', 40.2388916015625, 0.70230114580036, -87.9475021362305, -1.53497348118197, 218, 18, 'PPL', 'P'),
(130412, 'Dailey', 41.8869400024414, 0.731065016627924, -86.0891723632813, -1.50253950805617, 218, 27, 'PPL', 'P'),
(194154, 'Dailey', 40.6566696166992, 0.709592747706942, -102.723327636719, -1.79286028586563, 218, 7, 'PPL', 'P'),
(1945, 'Dailey (historical)', 33.9236106872559, 0.592078700657351, -85.5408325195313, -1.49296917236286, 218, 2, 'PPL', 'P'),
(196322, 'Dailey (historical)', 45.290828704834, 0.790474081856112, -110.840827941895, -1.93453739322259, 218, 31, 'PPL', 'P'),
(46158, 'Dailsville', 38.5469398498535, 0.672771016948153, -76.1602783203125, -1.32924761592471, 218, 25, 'PPL', 'P'),
(113149, 'Daily', 46.7174987792969, 0.815374171995162, -97.975830078125, -1.71000082223777, 218, 34, 'PPL', 'P'),
(93614, 'Daingerfield', 33.0316696166992, 0.576511392242375, -94.7216720581055, -1.65320505040825, 218, 51, 'PPL', 'P'),
(72261, 'Dairy', 39.6525001525879, 0.692066684310213, -80.9805603027344, -1.41337740739253, 218, 41, 'PPL', 'P'),
(193132, 'Dairy', 55.3069381713867, 0.96528817028763, -131.566390991211, -2.29626670776284, 218, 1, 'PPL', 'P'),
(200663, 'Dairy', 42.235279083252, 0.737144680501439, -121.519996643066, -2.12092404843397, 218, 43, 'PPL', 'P'),
(194809, 'Dairy Creek', 42.4625015258789, 0.741110460259703, -112.429168701172, -1.96225916911561, 218, 17, 'PPL', 'P'),
(46159, 'Dairy Manor Farms', 39.6488914489746, 0.692003700550432, -76.6730575561523, -1.33819730192598, 218, 25, 'PPL', 'P'),
(148169, 'Dairyland', 41.746940612793, 0.728621566327777, -74.5377807617188, -1.30092969142168, 218, 40, 'PPL', 'P'),
(173724, 'Dairyland', 46.2161102294922, 0.806623290969271, -92.1552810668945, -1.6084130777181, 218, 57, 'PPL', 'P'),
(181013, 'Dairyland', 37.0183296203613, 0.646091735463848, -120.309440612793, -2.09979585992582, 218, 6, 'PPL', 'P'),
(191353, 'Dairyland Colonia', 31.632999420166, 0.552099992163354, -106.15299987793, -1.85271935873901, 218, 51, 'PPL', 'P'),
(115179, 'Dairyville', 42.4847183227539, 0.741498216514419, -92.6524963378906, -1.61709112128818, 218, 16, 'PPL', 'P'),
(193479, 'Dairyville', 40.1300010681152, 0.700400647467452, -122.120002746582, -2.13139613047237, 218, 6, 'PPL', 'P'),
(54321, 'Dairyville (historical)', 37.3486099243164, 0.651856214222352, -91.0830612182617, -1.58969931105422, 218, 29, 'PPL', 'P'),
(93615, 'Daisetta', 30.1130599975586, 0.525572044807993, -94.6427764892578, -1.65182806296663, 218, 51, 'PPL', 'P'),
(1952, 'Daisey City', 33.6169395446777, 0.58672627949851, -86.9216690063477, -1.51706931548947, 218, 2, 'PPL', 'P'),
(1946, 'Daisey City Trailer Park', 33.6199989318848, 0.586779675878366, -86.9244384765625, -1.51711765186326, 218, 2, 'PPL', 'P'),
(181014, 'Daisie', 38.3147201538086, 0.668718018664188, -121.642776489258, -2.1230669610051, 218, 6, 'PPL', 'P'),
(1948, 'Daisy', 34.0675010681152, 0.594590061565296, -85.9574966430664, -1.50024133319348, 218, 2, 'PPL', 'P'),
(8385, 'Daisy', 34.2372207641602, 0.597552229066764, -93.741943359375, -1.63610555883913, 218, 4, 'PPL', 'P'),
(20442, 'Daisy', 32.151668548584, 0.561152476182697, -81.834716796875, -1.42828525054258, 218, 13, 'PPL', 'P'),
(35490, 'Daisy', 37.1136093139648, 0.64775467982752, -83.0950012207031, -1.45028136324998, 218, 21, 'PPL', 'P'),
(46160, 'Daisy', 39.2936096191406, 0.685802862847319, -77.0688934326172, -1.3451059412678, 218, 25, 'PPL', 'P'),
(54322, 'Daisy', 37.523609161377, 0.654910527097536, -89.7930603027344, -1.56718454772453, 218, 29, 'PPL', 'P'),
(75600, 'Daisy', 34.535831451416, 0.602763968741022, -95.7394409179688, -1.67096846803714, 218, 42, 'PPL', 'P'),
(80606, 'Daisy', 33.9952812194824, 0.593329587421361, -78.8675003051758, -1.37649755314295, 218, 48, 'PPL', 'P'),
(86200, 'Daisy', 35.2477798461914, 0.615189812334141, -85.186393737793, -1.48678304862477, 218, 50, 'PPL', 'P'),
(101265, 'Daisy', 37.7611083984375, 0.659055670755217, -76.9219436645508, -1.34254118398, 218, 53, 'PPL', 'P'),
(108784, 'Daisy', 38.0086097717285, 0.663375384622353, -82.0538864135742, -1.43211048197431, 218, 58, 'PPL', 'P'),
(148170, 'Daisy', 42.0558280944824, 0.734012669901451, -74.0880584716797, -1.29308055674089, 218, 40, 'PPL', 'P'),
(207160, 'Daisy', 48.3613891601563, 0.844065471683022, -118.158889770508, -2.06226166699641, 218, 56, 'PPL', 'P'),
(39992, 'Daisy (historical)', 29.4630603790283, 0.514227411327933, -89.6494369506836, -1.56467784734849, 218, 22, 'PPL', 'P'),
(29599, 'Daisy Hill', 38.5061111450195, 0.672058421619475, -85.9394378662109, -1.49992614807847, 218, 19, 'PPL', 'P'),
(32198, 'Daisy Hill', 37.3277816772461, 0.651492692733556, -94.7777786254883, -1.65418429474108, 218, 20, 'PPL', 'P'),
(46161, 'Daisy Hill Estates', 39.2919387817383, 0.685773701233383, -77.0658264160156, -1.34505241172989, 218, 25, 'PPL', 'P'),
(15725, 'Daisy Lake', 29.0244407653809, 0.506572054905959, -81.3791732788086, -1.4203345162662, 218, 12, 'PPL', 'P'),
(46163, 'Daisy Meadows', 39.3208312988281, 0.686277970785789, -77.0633316040039, -1.34500886904607, 218, 25, 'PPL', 'P'),
(46164, 'Daisy Ridge', 39.6069412231445, 0.691271530987742, -77.0699996948242, -1.34512524918571, 218, 25, 'PPL', 'P'),
(64102, 'Daisy Siding', 35.5916709899902, 0.621191845061879, -77.6502838134766, -1.35525311765322, 218, 33, 'PPL', 'P'),
(46165, 'Daisy Woods', 39.2744407653809, 0.685468303235378, -77.0733337402344, -1.34518343925553, 218, 25, 'PPL', 'P'),
(160631, 'Daisytown', 40.0544395446777, 0.699081850095645, -79.9322204589844, -1.39508042543925, 218, 45, 'PPL', 'P'),
(134904, 'Dakomin', 45.7249984741211, 0.798051773842796, -96.6716690063477, -1.68723891755892, 218, 28, 'PPL', 'P'),
(209396, 'Dakoming', 43.5974998474121, 0.760919917975067, -104.072219848633, -1.81640289621804, 218, 59, 'PPL', 'P'),
(20443, 'Dakota', 31.7758293151855, 0.554592844101723, -83.6933288574219, -1.4607241505164, 218, 13, 'PPL', 'P'),
(108785, 'Dakota', 39.5136108398438, 0.689642608506995, -80.1355590820313, -1.39862935390789, 218, 58, 'PPL', 'P'),
(119301, 'Dakota', 42.3886108398438, 0.739820824501832, -89.5261077880859, -1.56252534739744, 218, 18, 'PPL', 'P'),
(134905, 'Dakota', 43.9136085510254, 0.766437055647329, -91.3597183227539, -1.59452788842665, 218, 28, 'PPL', 'P'),
(173726, 'Dakota', 43.9902801513672, 0.767775227516067, -89.3563919067383, -1.559563246475, 218, 57, 'PPL', 'P'),
(115181, 'Dakota City', 42.7222213745117, 0.745643426751127, -94.1969375610352, -1.64404670573558, 218, 16, 'PPL', 'P'),
(141606, 'Dakota City', 42.4155616760254, 0.740291205329367, -96.4180603027344, -1.68281261066916, 218, 35, 'PPL', 'P'),
(170116, 'Dakota Dunes', 42.4874992370605, 0.741546752625285, -96.4861068725586, -1.68400024735728, 218, 49, 'PPL', 'P'),
(134907, 'Dakota Junction', 48.1588897705078, 0.840531190600378, -96.1941680908203, -1.67890495440168, 218, 28, 'PPL', 'P'),
(199264, 'Dakota Junction', 42.8597183227539, 0.748043201209397, -103.093612670898, -1.79932297888292, 218, 35, 'PPL', 'P'),
(115182, 'Dakota Mobile Home Park', 41.7236099243164, 0.728214368997103, -91.7527770996094, -1.60138805823664, 218, 16, 'PPL', 'P'),
(93616, 'Dakota Mobile Home Park Colonia', 25.8850002288818, 0.451778480873474, -97.4229965209961, -1.70035205645036, 218, 51, 'PPL', 'P'),
(35491, 'Dal', 36.7180595397949, 0.640851033912735, -84.0955581665039, -1.4677443763079, 218, 21, 'PPL', 'P'),
(72268, 'Dal-Mar Mobile Home Park', 39.9705581665039, 0.697617843865401, -83.8349990844727, -1.46319676243048, 218, 41, 'PPL', 'P'),
(64101, 'Dal-Wan Heights', 35.7922210693359, 0.624692104261598, -80.841667175293, -1.41095326501029, 218, 33, 'PPL', 'P'),
(8386, 'Dalark', 34.0372200012207, 0.59406155724697, -92.8858337402344, -1.62116362722713, 218, 4, 'PPL', 'P'),
(32199, 'Dalbey', 39.4972190856934, 0.689356518426893, -95.0772171020508, -1.65941048206425, 218, 20, 'PPL', 'P'),
(134909, 'Dalbo', 45.6588897705078, 0.796897959300519, -93.3986129760742, -1.63011331322839, 218, 28, 'PPL', 'P'),
(115183, 'Dalby', 43.2641716003418, 0.755102242573789, -91.2738876342773, -1.59302986031348, 218, 16, 'PPL', 'P'),
(93617, 'Dalby Springs', 33.3688888549805, 0.58239697825145, -94.679443359375, -1.65246802057657, 218, 51, 'PPL', 'P'),
(101266, 'Dalbys', 37.2299995422363, 0.649786072528006, -75.9705581665039, -1.32593637458336, 218, 53, 'PPL', 'P'),
(101267, 'Dalbytown', 37.1261100769043, 0.647972859299825, -76.460563659668, -1.33448858379193, 218, 53, 'PPL', 'P'),
(80608, 'Dalcho', 34.3655586242676, 0.599792147280602, -79.4933319091797, -1.38742037519586, 218, 48, 'PPL', 'P'),
(39993, 'Dalcour', 29.8072204589844, 0.520234137877093, -89.9986114501953, -1.57077209202898, 218, 22, 'PPL', 'P'),
(847, 'Dale', 35.3899993896484, 0.617672011628149, -97.0447235107422, -1.69374994695, 218, 42, 'PPL', 'P'),
(26909, 'Dale', 37.9949989318848, 0.663137830653118, -88.4916687011719, -1.54447097941946, 218, 18, 'PPL', 'P'),
(32200, 'Dale', 37.3375015258789, 0.651662336094994, -97.0536117553711, -1.6939050760835, 218, 20, 'PPL', 'P'),
(35492, 'Dale', 37.6913909912109, 0.65783887245316, -83.2341690063477, -1.45271029932218, 218, 21, 'PPL', 'P'),
(54324, 'Dale', 36.8800010681152, 0.643677446777636, -90.2425003051758, -1.57502875555731, 218, 29, 'PPL', 'P'),
(59191, 'Dale', 30.8347206115723, 0.538167398604496, -88.7830581665039, -1.54955668499513, 218, 30, 'PPL', 'P'),
(72263, 'Dale', 39.4888916015625, 0.689211176410402, -81.7666702270508, -1.42709761385446, 218, 41, 'PPL', 'P'),
(80609, 'Dale', 32.5563888549805, 0.568216178078996, -80.6900024414063, -1.4083062160448, 218, 48, 'PPL', 'P'),
(93618, 'Dale', 29.9272193908691, 0.522328514337358, -97.5641708374023, -1.7028160130909, 218, 51, 'PPL', 'P'),
(108786, 'Dale', 39.4577789306641, 0.688668157864135, -80.6505584716797, -1.40761778890302, 218, 58, 'PPL', 'P'),
(115184, 'Dale', 41.5958290100098, 0.725984171321244, -94.341667175293, -1.64657271402952, 218, 16, 'PPL', 'P'),
(122465, 'Dale', 40.0166702270508, 0.698422651146823, -86.4000015258789, -1.50796450035471, 218, 19, 'PPL', 'P'),
(130413, 'Dale', 43.857780456543, 0.765462671583497, -84.4347229003906, -1.47366391762087, 218, 27, 'PPL', 'P'),
(134911, 'Dale', 46.9052810668945, 0.818651591190668, -96.2194366455078, -1.6793459738782, 218, 28, 'PPL', 'P'),
(148171, 'Dale', 42.8191719055176, 0.747335532728736, -78.1730575561523, -1.36437724070589, 218, 40, 'PPL', 'P'),
(160630, 'Dale', 41.0113906860352, 0.71578379829305, -78.2930603027344, -1.36647168374518, 218, 45, 'PPL', 'P'),
(173728, 'Dale', 44.2730598449707, 0.772710664227229, -88.6783294677734, -1.54772882438096, 218, 57, 'PPL', 'P'),
(193203, 'Dale', 44.9886093139648, 0.785199358422074, -118.946388244629, -2.07600610822425, 218, 43, 'PPL', 'P'),
(1949, 'Dale (historical)', 33.610279083252, 0.586610032516928, -86.649169921875, -1.51231330925676, 218, 2, 'PPL', 'P'),
(8387, 'Dale (historical)', 35.6163902282715, 0.621623277158472, -93.5505599975586, -1.6327652890419, 218, 4, 'PPL', 'P'),
(141610, 'Dale (historical)', 41.5247192382813, 0.72474307167424, -99.8258285522461, -1.74228938676806, 218, 35, 'PPL', 'P'),
(194810, 'Dale (historical)', 44.8383293151855, 0.782576477643482, -116.483329772949, -2.0330176282243, 218, 17, 'PPL', 'P'),
(86201, 'Dale Acres', 35.1236114501953, 0.613022664997089, -85.2458267211914, -1.48782034986935, 218, 50, 'PPL', 'P'),
(101268, 'Dale City', 38.6369400024414, 0.674341815938108, -77.311393737793, -1.34933837003021, 218, 53, 'PPL', 'P'),
(101269, 'Dale Court', 37.3091697692871, 0.651167853659593, -80.0302810668945, -1.39679190591379, 218, 53, 'PPL', 'P'),
(209397, 'Dale Creek', 41.0830612182617, 0.71703468505706, -105.390830993652, -1.83941700225212, 218, 59, 'PPL', 'P'),
(101270, 'Dale Enterprise', 38.4544410705566, 0.671156608695346, -78.9397201538086, -1.37775802728688, 218, 53, 'PPL', 'P'),
(160632, 'Dale Summit', 40.8358306884766, 0.712719698300859, -77.7938919067383, -1.35775955171315, 218, 45, 'PPL', 'P'),
(101275, 'Dalecrest', 38.8144416809082, 0.67743980465517, -77.103889465332, -1.34571673726381, 218, 53, 'PPL', 'P'),
(193480, 'Dales', 40.3138885498047, 0.703610089476134, -122.070556640625, -2.13053313312113, 218, 6, 'PPL', 'P'),
(46166, 'Dales Delight', 39.3797187805176, 0.687305751229478, -77.123893737793, -1.34606587768272, 218, 25, 'PPL', 'P'),
(115187, 'Dales Ford', 42.2144393920898, 0.736780959275561, -91.0666732788086, -1.58941328755315, 218, 16, 'PPL', 'P'),
(35494, 'Dalesburg', 38.4638900756836, 0.67132152494585, -83.6780624389648, -1.46045770124933, 218, 21, 'PPL', 'P'),
(170118, 'Dalesburg', 42.9769401550293, 0.750089108137823, -96.9038925170898, -1.69129198242191, 218, 49, 'PPL', 'P'),
(196323, 'Daleview', 48.913330078125, 0.853698657978056, -104.933326721191, -1.83143204635574, 218, 31, 'PPL', 'P'),
(1951, 'Daleville', 31.3099994659424, 0.546462579478361, -85.7130584716797, -1.49597508228523, 218, 2, 'PPL', 'P'),
(8388, 'Daleville', 34.1155586242676, 0.595428824150616, -93.0283279418945, -1.6236506202111, 218, 4, 'PPL', 'P'),
(59192, 'Daleville', 32.5697212219238, 0.568448871779242, -88.6761093139648, -1.5476900753871, 218, 30, 'PPL', 'P'),
(101273, 'Daleville', 37.4097213745117, 0.652922810238928, -79.9127807617188, -1.39474113871637, 218, 53, 'PPL', 'P'),
(122466, 'Daleville', 40.1211090087891, 0.700245451754928, -85.5580596923828, -1.49326984324993, 218, 19, 'PPL', 'P'),
(160634, 'Daleville', 41.3050003051758, 0.72090825286258, -75.5141677856445, -1.31797085976293, 218, 45, 'PPL', 'P'),
(160635, 'Dalevue', 40.7958297729492, 0.712021550621095, -77.8294372558594, -1.35837993508909, 218, 45, 'PPL', 'P'),
(80610, 'Dalewood', 34.2472190856934, 0.597726732697191, -82.2241668701172, -1.43508243659279, 218, 48, 'PPL', 'P'),
(86204, 'Dalewood', 36.2055587768555, 0.631906208180459, -86.7158279418945, -1.51347671117896, 218, 50, 'PPL', 'P'),
(35496, 'Daley', 37.1358299255371, 0.648142502661263, -83.2322235107422, -1.45267634401829, 218, 21, 'PPL', 'P'),
(160636, 'Daley', 40.0858306884766, 0.699629728910901, -78.7383270263672, -1.37424305412214, 218, 45, 'PPL', 'P'),
(124616, 'Daley Corner', 42.0666694641113, 0.734201887496901, -71.0875015258789, -1.24071095864308, 218, 23, 'PPL', 'P'),
(72264, 'Daleyville', 39.1066703796387, 0.682540157616836, -83.0538864135742, -1.44956377449426, 218, 41, 'PPL', 'P'),
(173729, 'Daleyville', 42.9150009155273, 0.749008064472333, -89.8147201538086, -1.56756258344127, 218, 57, 'PPL', 'P'),
(191354, 'Dalhart', 36.059440612793, 0.629355965120599, -102.51277923584, -1.78918552303548, 218, 51, 'PPL', 'P'),
(15719, 'Dalhousie Acres', 28.9016704559326, 0.504429308782395, -81.6302795410156, -1.42471714731409, 218, 12, 'PPL', 'P'),
(188401, 'Dalies', 34.7719383239746, 0.606884811053756, -106.860000610352, -1.86505884933379, 218, 38, 'PPL', 'P'),
(15720, 'Dalkeith', 30.0055599212646, 0.523695814530519, -85.154167175293, -1.48622058900254, 218, 12, 'PPL', 'P'),
(207162, 'Dalkena', 48.2449989318848, 0.842034078982537, -117.236671447754, -2.04616592084213, 218, 56, 'PPL', 'P'),
(93621, 'Dallam', 30.4200000762939, 0.530929159788256, -96.2161102294922, -1.67928791696644, 218, 51, 'PPL', 'P'),
(93619, 'Dallardsville', 30.6283302307129, 0.534565206914054, -94.6316680908203, -1.65163418483927, 218, 51, 'PPL', 'P'),
(1954, 'Dallas', 33.8494415283203, 0.590784204630491, -86.6605606079102, -1.51251211423213, 218, 2, 'PPL', 'P'),
(8394, 'Dallas', 34.535831451416, 0.602763968741022, -94.2188873291016, -1.64442980145839, 218, 4, 'PPL', 'P'),
(15721, 'Dallas', 28.9708309173584, 0.505636386546473, -82.0411071777344, -1.43188744223302, 218, 12, 'PPL', 'P'),
(20447, 'Dallas', 33.9236106872559, 0.592078700657351, -84.8408279418945, -1.48075178770406, 218, 13, 'PPL', 'P'),
(54325, 'Dallas', 38.9397201538086, 0.679626326489153, -94.602783203125, -1.65113004844492, 218, 29, 'PPL', 'P'),
(64105, 'Dallas', 35.3163909912109, 0.616387302718295, -81.1763916015625, -1.41679530833554, 218, 33, 'PPL', 'P'),
(93620, 'Dallas', 32.7833290100098, 0.572177030989243, -96.8000030517578, -1.68947876919373, 218, 51, 'PPL', 'P'),
(127211, 'Dallas', 44.996940612793, 0.785344767017592, -70.5563888549805, -1.23144129383684, 218, 26, 'PPL', 'P'),
(160641, 'Dallas', 41.336109161377, 0.72145120482982, -75.9636077880859, -1.32581506759571, 218, 45, 'PPL', 'P'),
(170119, 'Dallas', 43.2361106872559, 0.754612487249323, -99.5166702270508, -1.73689355608345, 218, 49, 'PPL', 'P'),
(173730, 'Dallas', 45.2591705322266, 0.789921542508948, -91.8147201538086, -1.60246916848115, 218, 57, 'PPL', 'P'),
(177206, 'Dallas', 40.0161094665527, 0.698412864029817, -80.5272216796875, -1.40546515579391, 218, 58, 'PPL', 'P'),
(186606, 'Dallas', 38.1833305358887, 0.666424837228548, -107.744171142578, -1.88049053627025, 218, 7, 'PPL', 'P'),
(200664, 'Dallas', 44.9194412231445, 0.783992147499941, -123.315826416016, -2.15226719077727, 218, 43, 'PPL', 'P'),
(86210, 'Dallas (historical)', 35.1908302307129, 0.614195854036296, -85.1344375610352, -1.48587624227359, 218, 50, 'PPL', 'P'),
(879, 'Dallas Acres', 39.901668548584, 0.696415493212257, -76.6622161865234, -1.33800808433053, 218, 45, 'PPL', 'P'),
(86205, 'Dallas Branch', 35.2027816772461, 0.614404446128676, -85.1463928222656, -1.486084900945, 218, 50, 'PPL', 'P'),
(115188, 'Dallas Center', 41.684440612793, 0.72753073554528, -93.9608306884766, -1.63992586342285, 218, 16, 'PPL', 'P'),
(119304, 'Dallas City', 40.6361083984375, 0.709233886750054, -91.1672210693359, -1.59116817755346, 218, 18, 'PPL', 'P'),
(160637, 'Dallas City', 41.9408302307129, 0.732005578545913, -78.5558319091797, -1.37105791345841, 218, 45, 'PPL', 'P'),
(86206, 'Dallas Crest', 35.0919418334961, 0.612469925912843, -85.2930603027344, -1.48864473138479, 218, 50, 'PPL', 'P'),
(86207, 'Dallas Gardens', 35.2097206115723, 0.614525553379248, -85.1622161865234, -1.48636107075004, 218, 50, 'PPL', 'P'),
(86208, 'Dallas Heights', 35.086109161377, 0.612368126580174, -85.2961120605469, -1.48869799460659, 218, 50, 'PPL', 'P'),
(86209, 'Dallas Hills', 35.2080612182617, 0.614496591502393, -85.1483306884766, -1.48611872309085, 218, 50, 'PPL', 'P'),
(86211, 'Dallas Hollow', 35.2000007629395, 0.614355910017809, -85.1699981689453, -1.48649689196564, 218, 50, 'PPL', 'P'),
(59193, 'Dallas Jones Crossing', 34.2219390869141, 0.597285513483592, -89.6427764892578, -1.56456160036691, 218, 30, 'PPL', 'P'),
(72265, 'Dallasburg', 39.2722206115723, 0.685429554241517, -84.1913909912109, -1.46941697463052, 218, 41, 'PPL', 'P'),
(78109, 'Dallastown', 39.8994407653809, 0.696376611060342, -76.6405563354492, -1.33763004861379, 218, 45, 'PPL', 'P'),
(207161, 'Dallesport', 45.6175003051758, 0.796175576854835, -121.178329467773, -2.11496083127911, 218, 56, 'PPL', 'P'),
(39994, 'Dalley (historical)', 32.3250007629395, 0.564177694022972, -92.4791717529297, -1.61406603660596, 218, 22, 'PPL', 'P'),
(54329, 'Dallion Ford (historical)', 37.6861114501953, 0.657746727079443, -92.9886093139648, -1.62295739937935, 218, 29, 'PPL', 'P'),
(108788, 'Dallison', 39.2486114501953, 0.685017496641855, -81.3850021362305, -1.42043624901984, 218, 58, 'PPL', 'P'),
(72266, 'Dallmans Corner', 39.1819381713867, 0.683853828403544, -84.4274978637695, -1.47353781694326, 218, 41, 'PPL', 'P'),
(20444, 'Dallondale', 34.9633293151855, 0.610225214009042, -85.248893737793, -1.48787387940726, 218, 13, 'PPL', 'P'),
(15722, 'Dallus Creek Landing', 29.7211093902588, 0.51873121620542, -83.4866714477539, -1.45711729829405, 218, 12, 'PPL', 'P'),
(160640, 'Dalmatia', 40.6541709899902, 0.709549138444092, -76.9027786254883, -1.34220669094709, 218, 45, 'PPL', 'P'),
(93623, 'Dalrock', 32.9105606079102, 0.574397641285179, -96.5308303833008, -1.68478081987278, 218, 51, 'PPL', 'P'),
(154930, 'Dalrymple Corners', 40.4022216796875, 0.705151793431181, -82.6100006103516, -1.44181650572516, 218, 41, 'PPL', 'P'),
(8391, 'Dalton', 36.4211082458496, 0.635668256115332, -91.1413879394531, -1.59071730438091, 218, 4, 'PPL', 'P'),
(20446, 'Dalton', 34.769718170166, 0.606846062059895, -84.9702835083008, -1.48301121357289, 218, 13, 'PPL', 'P'),
(29601, 'Dalton', 39.9833297729492, 0.697840750448641, -85.1813888549805, -1.48669569694101, 218, 19, 'PPL', 'P'),
(32202, 'Dalton', 37.2691688537598, 0.650469705979829, -97.272216796875, -1.6977204538192, 218, 20, 'PPL', 'P'),
(35497, 'Dalton', 37.2997207641602, 0.65100293740909, -87.7619400024414, -1.53173481098032, 218, 21, 'PPL', 'P'),
(54330, 'Dalton', 39.3974990844727, 0.687616076075499, -92.9897232055664, -1.62297684045531, 218, 29, 'PPL', 'P'),
(64104, 'Dalton', 36.3088912963867, 0.633709700870661, -80.4013900756836, -1.40326898000097, 218, 33, 'PPL', 'P'),
(80611, 'Dalton', 34.6666717529297, 0.605047562796737, -82.9688873291016, -1.44808026060903, 218, 48, 'PPL', 'P'),
(93625, 'Dalton', 33.2991714477539, 0.581180179949393, -97.2044372558594, -1.69653747766299, 218, 51, 'PPL', 'P'),
(113168, 'Dalton', 44.415828704834, 0.775202450901162, -71.6952819824219, -1.25131872873903, 218, 36, 'PPL', 'P'),
(124614, 'Dalton', 42.4736099243164, 0.741304338387061, -73.1666717529297, -1.27699932481455, 218, 23, 'PPL', 'P'),
(130415, 'Dalton', 43.3186111450195, 0.756052391871702, -86.2616729736328, -1.5055502116685, 218, 27, 'PPL', 'P'),
(134913, 'Dalton', 46.1738891601563, 0.805886394295646, -95.915283203125, -1.67403749487734, 218, 28, 'PPL', 'P'),
(148172, 'Dalton', 42.540828704834, 0.742477527426268, -77.9527816772461, -1.36053270135625, 218, 40, 'PPL', 'P'),
(154931, 'Dalton', 40.7988891601563, 0.712074947000951, -81.695556640625, -1.42585644762842, 218, 41, 'PPL', 'P'),
(160642, 'Dalton', 41.5341682434082, 0.724907987924743, -75.7363891601563, -1.32184935441647, 218, 45, 'PPL', 'P'),
(173734, 'Dalton', 43.6569404602051, 0.761957352377707, -89.2063903808594, -1.55694522596539, 218, 57, 'PPL', 'P'),
(193481, 'Dalton', 41.9363899230957, 0.731928080558192, -121.418327331543, -2.11914958419965, 218, 6, 'PPL', 'P'),
(199265, 'Dalton', 41.4072189331055, 0.722692304476824, -102.973327636719, -1.79722360899561, 218, 35, 'PPL', 'P'),
(203671, 'Dalton', 40.5611114501953, 0.70792494307428, -112.059722900391, -1.95581112348431, 218, 52, 'PPL', 'P'),
(26910, 'Dalton City', 39.7119407653809, 0.693104118712853, -88.804443359375, -1.54992992702191, 218, 18, 'PPL', 'P'),
(148173, 'Dalton Crossing', 44.8536109924316, 0.782843193226654, -75.1224975585938, -1.31113492471886, 218, 40, 'PPL', 'P'),
(194811, 'Dalton Gardens', 47.7297210693359, 0.833040783718421, -116.769172668457, -2.03800652789435, 218, 17, 'PPL', 'P'),
(101276, 'Daltons', 38.1352806091309, 0.665586207801282, -77.4197235107422, -1.35122908124611, 218, 53, 'PPL', 'P'),
(78111, 'Dalvue', 39.9000015258789, 0.696386398177348, -76.670280456543, -1.33814883239414, 218, 45, 'PPL', 'P'),
(93626, 'Dalworthington Gardens', 32.7027816772461, 0.570771214828818, -97.1549987792969, -1.6956746134698, 218, 51, 'PPL', 'P'),
(181015, 'Daly City', 37.7058296203613, 0.658090874071309, -122.460830688477, -2.13734470024123, 218, 6, 'PPL', 'P'),
(196324, 'Dalys', 45.0852813720703, 0.786886604130694, -112.779167175293, -1.96836779486598, 218, 31, 'PPL', 'P'),
(72267, 'Dalzell', 39.5647201538086, 0.690534634314117, -81.3041687011719, -1.41902543943237, 218, 41, 'PPL', 'P'),
(80612, 'Dalzell', 34.0166702270508, 0.593702896027163, -80.4302825927734, -1.40377324955338, 218, 48, 'PPL', 'P'),
(93627, 'Dalzell', 31.6291694641113, 0.552033146819993, -99.0369415283203, -1.72852071077429, 218, 51, 'PPL', 'P'),
(119306, 'Dalzell', 41.357780456543, 0.721829440283638, -89.1761093139648, -1.55641672164707, 218, 18, 'PPL', 'P'),
(202046, 'Dalzell', 44.3436088562012, 0.773941976757227, -102.396110534668, -1.78714927006601, 218, 49, 'PPL', 'P'),
(101277, 'Dam Neck Corner', 36.7861099243164, 0.642038737179883, -75.9994430541992, -1.32644051097771, 218, 53, 'PPL', 'P'),
(32203, 'Damar', 39.3188896179199, 0.686244082060918, -99.5822219848633, -1.73803765008775, 218, 20, 'PPL', 'P'),
(127213, 'Damariscotta', 44.0327796936035, 0.768516984458681, -69.519172668457, -1.21333845632703, 218, 26, 'PPL', 'P'),
(127214, 'Damariscotta Mills', 44.061939239502, 0.769025914542995, -69.524169921875, -1.21342567485273, 218, 26, 'PPL', 'P'),
(1959, 'Damascus', 31.172779083252, 0.544067631999566, -86.8569412231445, -1.51593960255506, 218, 2, 'PPL', 'P'),
(8393, 'Damascus', 35.3672218322754, 0.617274468256427, -92.4094390869141, -1.61284897198779, 218, 4, 'PPL', 'P'),
(20449, 'Damascus', 34.5499992370605, 0.603011243248235, -84.9358291625977, -1.48240987179875, 218, 13, 'PPL', 'P'),
(46167, 'Damascus', 39.288330078125, 0.685710717473602, -77.2041702270508, -1.34746696673221, 218, 25, 'PPL', 'P'),
(59195, 'Damascus', 32.5552787780762, 0.568196803582066, -89.3883285522461, -1.56012064609115, 218, 30, 'PPL', 'P'),
(86213, 'Damascus', 36.4391708374023, 0.63598350780937, -81.9122161865234, -1.42963787006023, 218, 50, 'PPL', 'P'),
(101278, 'Damascus', 36.6336097717285, 0.639377107407431, -81.7838897705078, -1.42739815158347, 218, 53, 'PPL', 'P'),
(119307, 'Damascus', 42.3722190856934, 0.73953473442173, -89.7061080932617, -1.56566694537735, 218, 18, 'PPL', 'P'),
(127215, 'Damascus', 44.8122215270996, 0.78212081078097, -69.0811080932617, -1.20569278715352, 218, 26, 'PPL', 'P'),
(148174, 'Damascus', 42.0558280944824, 0.734012669901451, -75.6105575561523, -1.31965317862354, 218, 40, 'PPL', 'P'),
(154932, 'Damascus', 40.9019393920898, 0.713873512843136, -80.9552764892578, -1.4129361215999, 218, 41, 'PPL', 'P'),
(160645, 'Damascus', 41.7030601501465, 0.727855707777297, -75.0686111450195, -1.3101944293799, 218, 45, 'PPL', 'P'),
(200665, 'Damascus', 45.417781829834, 0.792689831883058, -122.457778930664, -2.13729143701943, 218, 43, 'PPL', 'P'),
(154933, 'Damascus (historical)', 41.413890838623, 0.722808751195488, -84.0186080932617, -1.46640134417017, 218, 41, 'PPL', 'P'),
(46168, 'Damascus Gardens', 39.2822189331055, 0.685604057871945, -77.2041702270508, -1.34746696673221, 218, 25, 'PPL', 'P'),
(200666, 'Damascus Heights', 45.4208297729492, 0.792743028525832, -122.448059082031, -2.13712179365799, 218, 43, 'PPL', 'P'),
(46169, 'Damascus Hill', 39.2611083984375, 0.685235609535132, -77.2016677856445, -1.34742329089034, 218, 25, 'PPL', 'P'),
(46170, 'Damascus Manor', 39.2797203063965, 0.685560448609094, -77.2113876342773, -1.34759293425178, 218, 25, 'PPL', 'P'),
(46171, 'Damascus Terrace', 39.2822189331055, 0.685604057871945, -77.2005615234375, -1.34740398297243, 218, 25, 'PPL', 'P'),
(46172, 'Damascus Valley Estates', 39.2861099243164, 0.685671968479742, -77.1827774047852, -1.34709359154739, 218, 25, 'PPL', 'P'),
(46173, 'Damascus Valley Park', 39.2786102294922, 0.685541074112164, -77.2052764892578, -1.34748627465012, 218, 25, 'PPL', 'P'),
(46174, 'Damascus View', 39.2791709899902, 0.68555086122917, -77.2138900756836, -1.34763661009365, 218, 25, 'PPL', 'P'),
(46175, 'Dameron', 38.1522216796875, 0.665881885261308, -76.3697204589844, -1.33290307083695, 218, 25, 'PPL', 'P'),
(54331, 'Dameron', 39.2180595397949, 0.684484265212594, -90.8002777099609, -1.58476380776404, 218, 29, 'PPL', 'P'),
(108789, 'Dameron', 37.8252792358398, 0.66017566315165, -81.3694381713867, -1.42016460658865, 218, 58, 'PPL', 'P'),
(20450, 'Dames Ferry', 33.0219383239746, 0.576341549143855, -83.7249984741211, -1.46127688960064, 218, 13, 'PPL', 'P'),
(15723, 'Dames Point', 30.3888893127441, 0.530386174531502, -81.5586090087891, -1.42346626055008, 218, 12, 'PPL', 'P'),
(15724, 'Dames Point Manor', 30.396390914917, 0.530517102188593, -81.5672225952148, -1.42361659599361, 218, 12, 'PPL', 'P'),
(46176, 'Dames Quarter', 38.1886100769043, 0.666516982602265, -75.8994369506836, -1.32469507519927, 218, 25, 'PPL', 'P'),
(26911, 'Damiansville', 38.5099983215332, 0.672126265648244, -89.6194381713867, -1.56415426987818, 218, 18, 'PPL', 'P'),
(54332, 'Damon', 37.1769409179688, 0.648860024837958, -90.6105575561523, -1.58145256642269, 218, 29, 'PPL', 'P'),
(75603, 'Damon', 34.8549995422363, 0.60833450279314, -95.307502746582, -1.6634297247814, 218, 42, 'PPL', 'P'),
(86214, 'Damon', 35.0113906860352, 0.61106404317339, -88.3291702270508, -1.54163484601658, 218, 50, 'PPL', 'P'),
(93628, 'Damon', 29.2902793884277, 0.511211814157095, -95.7344436645508, -1.67088124951144, 218, 51, 'PPL', 'P'),
(101279, 'Damon', 37.8227806091309, 0.6601320538888, -78.6594390869141, -1.37286619983857, 218, 53, 'PPL', 'P'),
(119308, 'Damon', 40.0830612182617, 0.699581392537116, -90.8300018310547, -1.58528259154438, 218, 18, 'PPL', 'P'),
(130417, 'Damon', 44.4775009155273, 0.776278834034745, -84.2283325195313, -1.47006172593043, 218, 27, 'PPL', 'P'),
(171894, 'Damon Crossing', 44.5277786254883, 0.777156345613926, -71.8188934326172, -1.2534761555381, 218, 55, 'PPL', 'P'),
(124617, 'Damons Mills Westvale', 42.4527816772461, 0.740940816898265, -71.4263916015625, -1.24662570626609, 218, 23, 'PPL', 'P'),
(160646, 'Dampman', 40.103889465332, 0.699944914025912, -75.8730621337891, -1.32423474780485, 218, 45, 'PPL', 'P'),
(203676, 'Damron Way', 40.7080612182617, 0.710489700362081, -112.073059082031, -1.95604388376358, 218, 52, 'PPL', 'P'),
(148175, 'Dams Corner', 43.1313896179199, 0.752784759793202, -75.5800018310547, -1.31911988061525, 218, 40, 'PPL', 'P'),
(54333, 'Damsel', 38.1097183227539, 0.665140061739667, -92.6900024414063, -1.61774572628412, 218, 29, 'PPL', 'P'),
(101281, 'Damtown', 38.2083282470703, 0.66686112959413, -78.9255599975586, -1.37751088593773, 218, 53, 'PPL', 'P'),
(35498, 'Dan', 37.9552803039551, 0.66244460982137, -83.459716796875, -1.45664685088748, 218, 21, 'PPL', 'P'),
(101280, 'Dan', 38.1569404602051, 0.665964243518019, -77.8819427490234, -1.35929632882018, 218, 53, 'PPL', 'P'),
(108790, 'Dan', 37.3544387817383, 0.651957946975993, -81.8002777099609, -1.42768417508455, 218, 58, 'PPL', 'P'),
(64108, 'Dan River', 36.4644393920898, 0.636424527285887, -79.7627792358398, -1.39212311820677, 218, 33, 'PPL', 'P'),
(101284, 'Dan River (historical)', 36.5422210693359, 0.637782073651555, -79.4922180175781, -1.3874009341199, 218, 53, 'PPL', 'P'),
(64109, 'Dan River Shores', 36.4324989318848, 0.635867061090706, -80.2772216796875, -1.40110183266392, 218, 33, 'PPL', 'P'),
(193483, 'Dan Ryan Place', 41.1497192382813, 0.718198086979261, -120.816108703613, -2.10863888632543, 218, 6, 'PPL', 'P'),
(64111, 'Dan Valley', 36.4083290100098, 0.635445216374038, -79.9416732788086, -1.39524540826878, 218, 33, 'PPL', 'P'),
(15726, 'Dana', 29.9486103057861, 0.522701856232674, -82.3872222900391, -1.43792829053364, 218, 12, 'PPL', 'P'),
(29603, 'Dana', 39.8077812194824, 0.694776850193532, -87.495002746582, -1.52707587696934, 218, 19, 'PPL', 'P'),
(35499, 'Dana', 37.5541687011719, 0.655443891684852, -82.6911087036133, -1.44323210900259, 218, 21, 'PPL', 'P'),
(64112, 'Dana', 35.3291702270508, 0.616610342459589, -82.3755569458008, -1.43772469186831, 218, 33, 'PPL', 'P'),
(115193, 'Dana', 42.1074981689453, 0.734914482825579, -94.2405624389648, -1.64480810349123, 218, 16, 'PPL', 'P'),
(119309, 'Dana', 40.9577789306641, 0.71484809664405, -88.9499969482422, -1.55247031638573, 218, 18, 'PPL', 'P'),
(193482, 'Dana', 41.1116714477539, 0.71753402776145, -121.563606262207, -2.12168517987351, 218, 6, 'PPL', 'P'),
(198163, 'Dana', 46.5766716003418, 0.812916274046101, -100.233329772949, -1.74940162477522, 218, 34, 'PPL', 'P'),
(124618, 'Dana (historical)', 42.4333305358887, 0.740601330438307, -72.2666702270508, -1.26129133491499, 218, 23, 'PPL', 'P'),
(124619, 'Dana Center', 42.4222183227539, 0.740407385731922, -72.2249984741211, -1.26056402562129, 218, 23, 'PPL', 'P'),
(86215, 'Dana Hills', 35.1888885498047, 0.614161965311424, -85.208610534668, -1.48717080487948, 218, 50, 'PPL', 'P'),
(181016, 'Dana Point', 33.4669418334961, 0.584108325567935, -117.697219848633, -2.05420400680226, 218, 6, 'PPL', 'P'),
(181017, 'Dana Point Marina Mobile Home Estates', 33.4655609130859, 0.58408422396007, -117.683326721191, -2.05396152598501, 218, 6, 'PPL', 'P'),
(130418, 'Danaher', 46.3436088562012, 0.808848561797114, -85.7808303833008, -1.49715792528339, 218, 27, 'PPL', 'P'),
(178054, 'Danas Trailer Ranch', 33.416389465332, 0.583226020298791, -111.605278015137, -1.94787956396778, 218, 5, 'PPL', 'P'),
(160647, 'Danboro', 40.3544387817383, 0.704317824535822, -75.133056640625, -1.3113192154663, 218, 45, 'PPL', 'P'),
(20451, 'Danburg', 33.8683280944824, 0.591113837394415, -82.6522216796875, -1.44255340239878, 218, 13, 'PPL', 'P'),
(64114, 'Danbury', 36.4091682434082, 0.635459863760033, -80.2061080932617, -1.39986066643789, 218, 33, 'PPL', 'P'),
(93629, 'Danbury', 29.2280597686768, 0.510125876933102, -95.3447189331055, -1.66407926977127, 218, 51, 'PPL', 'P'),
(113089, 'Danbury', 41.394718170166, 0.722474125004519, -73.4544372558594, -1.28202178031433, 218, 8, 'PPL', 'P'),
(115194, 'Danbury', 42.2341690063477, 0.737125306004509, -95.7219390869141, -1.6706630034601, 218, 16, 'PPL', 'P'),
(143692, 'Danbury', 43.5255584716797, 0.759664304100122, -71.8622207641602, -1.25423236012963, 218, 36, 'PPL', 'P'),
(154935, 'Danbury', 41.4991683959961, 0.724297125349706, -82.8302764892578, -1.4456610450748, 218, 41, 'PPL', 'P'),
(173735, 'Danbury', 46.0066719055176, 0.802967902636055, -92.3711090087891, -1.61217998592197, 218, 57, 'PPL', 'P'),
(199266, 'Danbury', 40.0394401550293, 0.69882006136049, -100.40389251709, -1.75237850624171, 218, 35, 'PPL', 'P'),
(64116, 'Danbury Forest', 35.8372192382813, 0.625477470467062, -80.8566665649414, -1.41121505374544, 218, 33, 'PPL', 'P'),
(203673, 'Danbury Lane Condominium', 40.8980598449707, 0.71380580197242, -111.886672973633, -1.95279083249205, 218, 52, 'PPL', 'P'),
(20452, 'Danbury Village', 33.9025001525879, 0.591710252320539, -84.2111129760742, -1.46976118820142, 218, 13, 'PPL', 'P'),
(35500, 'Danby', 36.8824996948242, 0.643721056040486, -86.9194412231445, -1.51703043333756, 218, 21, 'PPL', 'P'),
(54334, 'Danby', 38.1091690063477, 0.665130474359742, -90.307502746582, -1.57616326218168, 218, 29, 'PPL', 'P'),
(148176, 'Danby', 42.3522186279297, 0.739185660581848, -76.4811096191406, -1.33484717843271, 218, 40, 'PPL', 'P'),
(171895, 'Danby', 43.3461112976074, 0.756532360079161, -72.9958267211914, -1.27401751650005, 218, 55, 'PPL', 'P'),
(181019, 'Danby', 34.6355590820313, 0.60450454425047, -115.347221374512, -2.01318879601201, 218, 6, 'PPL', 'P'),
(171896, 'Danby Four Corners', 43.3547210693359, 0.756682628943669, -73.0472183227539, -1.27491446915519, 218, 55, 'PPL', 'P'),
(70716, 'Danceys Corner', 39.7013893127441, 0.692919961123474, -75.4391708374023, -1.31666191608716, 218, 37, 'PPL', 'P'),
(93630, 'Danciger', 29.1713905334473, 0.50913681219376, -95.8186111450195, -1.67235024916872, 218, 51, 'PPL', 'P'),
(1960, 'Dancy', 33.0111083984375, 0.576152531285486, -88.2927780151367, -1.5409996820966, 218, 2, 'PPL', 'P'),
(59199, 'Dancy', 33.6694412231445, 0.587642606650579, -89.0588912963867, -1.55437088129767, 218, 30, 'PPL', 'P'),
(173736, 'Dancy', 44.6877784729004, 0.779948869753955, -89.7130584716797, -1.565788252365, 218, 57, 'PPL', 'P'),
(86217, 'Dancyville', 35.4077796936035, 0.61798233647417, -89.2938919067383, -1.5584724156925, 218, 50, 'PPL', 'P'),
(178055, 'Dandrea', 34.3647193908691, 0.599777499894607, -112.376106262207, -1.96133305484653, 218, 5, 'PPL', 'P'),
(86216, 'Dandridge', 36.0152816772461, 0.62858524630113, -83.4150009155273, -1.45586641153004, 218, 50, 'PPL', 'P'),
(101285, 'Dandy', 37.2119407653809, 0.649470887412995, -76.4300003051758, -1.33395515262559, 218, 53, 'PPL', 'P'),
(75605, 'Dane', 36.2169418334961, 0.632104879997779, -98.6191711425781, -1.72122924202577, 218, 42, 'PPL', 'P'),
(173737, 'Dane', 43.250560760498, 0.754864688604554, -89.5013885498047, -1.56209391530084, 218, 57, 'PPL', 'P'),
(59196, 'Dane (historical)', 32.1166687011719, 0.56054161360766, -90.0638885498047, -1.57191139234331, 218, 30, 'PPL', 'P'),
(127217, 'Dane Corner', 44.815559387207, 0.782179067429815, -69.9713897705078, -1.22123113369164, 218, 26, 'PPL', 'P'),
(200667, 'Danebo', 44.0597190856934, 0.768987165549135, -123.17749786377, -2.14985290209106, 218, 43, 'PPL', 'P'),
(203674, 'Daneborg Estates', 40.5977783203125, 0.708564900684226, -111.798606872559, -1.95125378906891, 218, 52, 'PPL', 'P'),
(122472, 'Danes', 40.7611083984375, 0.711415548315047, -86.2611083984375, -1.50554035797247, 218, 19, 'PPL', 'P'),
(108791, 'Danese', 37.9305610656738, 0.662013177724777, -80.9033279418945, -1.41202944840679, 218, 58, 'PPL', 'P'),
(134916, 'Danesville', 44.0938911437988, 0.769583580475258, -92.6786117553711, -1.61754692130875, 218, 28, 'PPL', 'P'),
(93631, 'Danevang', 29.0572204589844, 0.507144168487135, -96.2072219848633, -1.67913278783294, 218, 51, 'PPL', 'P'),
(13626, 'Danfield Acres', 38.6763916015625, 0.675030376237948, -75.2413864135742, -1.3132099266822, 218, 10, 'PPL', 'P'),
(59197, 'Danforth', 34.4638900756836, 0.601508354866076, -90.5038909912109, -1.57959088366267, 218, 30, 'PPL', 'P'),
(119310, 'Danforth', 40.8202781677246, 0.712448255606753, -87.977783203125, -1.53550198550029, 218, 18, 'PPL', 'P'),
(127218, 'Danforth', 45.6602783203125, 0.796922194066439, -67.8688888549805, -1.18453557018949, 218, 26, 'PPL', 'P'),
(139110, 'Danforth', 40.2413902282715, 0.70234475506321, -92.73388671875, -1.61851165141363, 218, 29, 'PPL', 'P'),
(170123, 'Danforth', 44.2541694641113, 0.772380964884277, -98.883056640625, -1.72583491281495, 218, 49, 'PPL', 'P'),
(35502, 'Dango', 37.3694381713867, 0.652219735711147, -84.1147232055664, -1.46807886934081, 218, 21, 'PPL', 'P'),
(15730, 'Dania Beach', 26.0519409179688, 0.454692145553589, -80.144172668457, -1.39877968935143, 218, 12, 'PPL', 'P'),
(20454, 'Daniel', 33.663890838623, 0.587545734165927, -82.9027786254883, -1.44692644606675, 218, 13, 'PPL', 'P'),
(46177, 'Daniel', 39.435001373291, 0.688270614492414, -77.0538864135742, -1.3448440193746, 218, 25, 'PPL', 'P'),
(59198, 'Daniel', 32.128059387207, 0.560740418583034, -89.720832824707, -1.56592394042254, 218, 30, 'PPL', 'P'),
(101286, 'Daniel', 38.1736106872559, 0.66625519386711, -78.022216796875, -1.36174457281029, 218, 53, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(203675, 'Daniel', 40.4708290100098, 0.706349217236308, -111.413887023926, -1.94453916101249, 218, 52, 'PPL', 'P'),
(209398, 'Daniel', 42.8644409179688, 0.748125626045135, -110.070281982422, -1.92108882919185, 218, 59, 'PPL', 'P'),
(35501, 'Daniel Boone', 37.1786117553711, 0.648889186451894, -87.5074996948242, -1.52729398986262, 218, 21, 'PPL', 'P'),
(101287, 'Daniel Corner', 38.0774993896484, 0.664577735275496, -77.1880569458008, -1.3471857369211, 218, 53, 'PPL', 'P'),
(209399, 'Daniel Junction', 42.8899993896484, 0.748571705527724, -110.068061828613, -1.92105008019799, 218, 59, 'PPL', 'P'),
(93632, 'Daniel Ozuna Colonia', 26.2770004272461, 0.458620175003401, -98.443000793457, -1.71815448938922, 218, 51, 'PPL', 'P'),
(39998, 'Daniel Park', 29.916109085083, 0.522134602920487, -89.894172668457, -1.56894929142087, 218, 22, 'PPL', 'P'),
(20456, 'Daniel Plantation', 33.8902816772461, 0.591496999696251, -83.4361114501953, -1.45623485986685, 218, 13, 'PPL', 'P'),
(20457, 'Daniel Springs', 33.6494407653809, 0.587293532810697, -82.9749984741211, -1.44818692021068, 218, 13, 'PPL', 'P'),
(20458, 'Daniel Subdivision', 33.7438888549805, 0.588941962946429, -84.6916732788086, -1.47814854773851, 218, 13, 'PPL', 'P'),
(20459, 'Daniell Mill Estates', 33.6713905334473, 0.587676628533505, -84.8541717529297, -1.48098468114139, 218, 13, 'PPL', 'P'),
(20461, 'Daniels', 34.4166717529297, 0.600684239666751, -84.3641662597656, -1.47243247193282, 218, 13, 'PPL', 'P'),
(46178, 'Daniels', 39.3166694641113, 0.686205333067057, -76.8166732788086, -1.34070386914396, 218, 25, 'PPL', 'P'),
(64117, 'Daniels', 35.5161094665527, 0.619873047690072, -81.3152770996094, -1.41921931755973, 218, 33, 'PPL', 'P'),
(80614, 'Daniels', 32.4786109924316, 0.566858698292355, -80.6275024414063, -1.40721538526231, 218, 48, 'PPL', 'P'),
(93634, 'Daniels', 30.1986103057861, 0.52706517936266, -96.2055587768555, -1.67910375937706, 218, 51, 'PPL', 'P'),
(108792, 'Daniels', 37.7430610656738, 0.658740685377288, -81.1230621337891, -1.41586453353456, 218, 58, 'PPL', 'P'),
(194812, 'Daniels', 42.3730583190918, 0.739549381807726, -112.412216186523, -1.9619632919185, 218, 17, 'PPL', 'P'),
(64118, 'Daniels (historical)', 35.457218170166, 0.618845200667356, -81.2652816772461, -1.41834673282856, 218, 33, 'PPL', 'P'),
(101288, 'Daniels Hill', 37.4233283996582, 0.653160297629136, -79.147216796875, -1.38137952689523, 218, 53, 'PPL', 'P'),
(101289, 'Daniels Mill', 38.648609161377, 0.674545481182472, -77.6016693115234, -1.35440463452993, 218, 53, 'PPL', 'P'),
(113097, 'Daniels Mill', 41.1694412231445, 0.718542300550154, -73.4733276367188, -1.28235147965729, 218, 8, 'PPL', 'P'),
(46179, 'Daniels Park', 39.0063896179199, 0.680789928148436, -76.9252777099609, -1.34259937404982, 218, 25, 'PPL', 'P'),
(86218, 'Daniels Point Landing', 35.7744407653809, 0.624381779415576, -89.7975006103516, -1.56726204571225, 218, 50, 'PPL', 'P'),
(13627, 'Daniels Tract', 39.3833312988281, 0.687368801568286, -75.5347213745117, -1.31832958756177, 218, 10, 'PPL', 'P'),
(113098, 'Danielson', 41.8025016784668, 0.729591289859702, -71.8863906860352, -1.2546542048463, 218, 8, 'PPL', 'P'),
(181020, 'Danielson', 38.2383308410645, 0.667384773643467, -122.103889465332, -2.13111490066126, 218, 6, 'PPL', 'P'),
(148178, 'Danielstown', 43.2588882446289, 0.755010030621045, -73.7850036621094, -1.28779125249988, 218, 40, 'PPL', 'P'),
(1961, 'Danielsville', 31.920560836792, 0.557118885685177, -86.4063873291016, -1.50807595364633, 218, 2, 'PPL', 'P'),
(20462, 'Danielsville', 34.1241683959961, 0.595579093015124, -83.2213897705078, -1.45248725958089, 218, 13, 'PPL', 'P'),
(160648, 'Danielsville', 40.7944412231445, 0.711997315855175, -75.5274963378906, -1.31820348688415, 218, 45, 'PPL', 'P'),
(196326, 'Danielsville', 46.2922210693359, 0.807951675721002, -113.014442443848, -1.97247412295077, 218, 31, 'PPL', 'P'),
(64119, 'Danieltown', 35.2930603027344, 0.615980105387621, -81.9100036621094, -1.42959925422442, 218, 33, 'PPL', 'P'),
(101290, 'Danieltown', 36.9044418334961, 0.64410401860524, -77.9599990844727, -1.36065866887581, 218, 53, 'PPL', 'P'),
(203677, 'Danish Hills', 40.6027793884277, 0.708652185788954, -111.801940917969, -1.95131197913873, 218, 52, 'PPL', 'P'),
(130420, 'Danish Landing', 44.6575012207031, 0.779420432014656, -84.7799987792969, -1.4796901185355, 218, 27, 'PPL', 'P'),
(127220, 'Danish Village (historical)', 43.5849990844727, 0.760701738502762, -70.3583297729492, -1.22798451074192, 218, 26, 'PPL', 'P'),
(39995, 'Danks', 30.7169399261475, 0.536111737848577, -91.878059387207, -1.60357464664965, 218, 22, 'PPL', 'P'),
(15731, 'Danks Corner', 29.0108299255371, 0.506334500936724, -82.120002746582, -1.43326442967464, 218, 12, 'PPL', 'P'),
(26912, 'Danley', 38.0955581665039, 0.664892920390507, -90.1155624389648, -1.57281327184647, 218, 18, 'PPL', 'P'),
(148179, 'Danley Corners', 42.8474998474121, 0.747829948585109, -78.3222198486328, -1.3669806138295, 218, 40, 'PPL', 'P'),
(1962, 'Danleys Crossroads', 31.4188899993896, 0.548363077811269, -86.1677780151367, -1.50391143549172, 218, 2, 'PPL', 'P'),
(35503, 'Danleyton', 38.4916687011719, 0.671806353422299, -82.7694396972656, -1.44459924274818, 218, 21, 'PPL', 'P'),
(80615, 'Dann (historical)', 34.3963890075684, 0.600330238978853, -82.3641662597656, -1.43752588689293, 218, 48, 'PPL', 'P'),
(148180, 'Dann Corner', 42.9469413757324, 0.749565530667514, -77.6133270263672, -1.35460810003721, 218, 40, 'PPL', 'P'),
(141611, 'Dannebrog', 41.1183280944824, 0.717650208164004, -98.5455627441406, -1.71994453311591, 218, 35, 'PPL', 'P'),
(148181, 'Dannemora', 44.7213897705078, 0.780535497563073, -73.7241668701172, -1.28672945017327, 218, 40, 'PPL', 'P'),
(148182, 'Dannemora Crossing', 44.8952789306641, 0.783570435941327, -73.7911071777344, -1.28789777894349, 218, 40, 'PPL', 'P'),
(93635, 'Danner', 33.6752815246582, 0.587744539141302, -96.1133270263672, -1.67749401165616, 218, 51, 'PPL', 'P'),
(200668, 'Danner', 42.9444389343262, 0.749521854825637, -117.339172363281, -2.04795489930439, 218, 43, 'PPL', 'P'),
(160649, 'Dannersville', 40.7436103820801, 0.711110150317042, -75.4352798461914, -1.31659400547936, 218, 45, 'PPL', 'P'),
(86221, 'Dannertown', 36.2436103820801, 0.632570333977297, -87.2425003051758, -1.52266887799748, 218, 50, 'PPL', 'P'),
(141614, 'Dannevirke', 41.3224983215332, 0.721213650860585, -98.7080612182617, -1.72278066651879, 218, 35, 'PPL', 'P'),
(203678, 'Dannich Estates', 40.6688919067383, 0.709806066910258, -111.946670532227, -1.95383798743267, 218, 52, 'PPL', 'P'),
(202047, 'Danoby (historical)', 43.7750015258789, 0.764017906692129, -103.731941223145, -1.81046391382911, 218, 49, 'PPL', 'P'),
(101291, 'Danripple', 36.6297187805176, 0.639309196799634, -79.024169921875, -1.37923195379219, 218, 53, 'PPL', 'P'),
(46180, 'Dans', 39.5327796936035, 0.689977168118936, -75.8277816772461, -1.32344445475137, 218, 25, 'PPL', 'P'),
(194813, 'Dans Place', 42.2724990844727, 0.737794292070336, -115.831390380859, -2.02163913930888, 218, 17, 'PPL', 'P'),
(108793, 'Dans Run', 39.5461082458496, 0.690209795240155, -78.6916732788086, -1.37342879261885, 218, 58, 'PPL', 'P'),
(101292, 'Dansbury Acres', 37.3102798461914, 0.651187228156524, -79.9908294677734, -1.39610334561395, 218, 53, 'PPL', 'P'),
(8396, 'Dansby', 34.8941688537598, 0.609018136244964, -90.6402816772461, -1.58197135020303, 218, 4, 'PPL', 'P'),
(20463, 'Danson Woods', 33.8883285522461, 0.591462911234298, -83.4330596923828, -1.45618159664505, 218, 13, 'PPL', 'P'),
(108794, 'Danstown', 38.7708282470703, 0.676678606636599, -81.7869415283203, -1.42745141480527, 218, 58, 'PPL', 'P'),
(130421, 'Dansville', 42.5558280944824, 0.742739316161423, -84.3033294677734, -1.47137066960621, 218, 27, 'PPL', 'P'),
(148184, 'Dansville', 42.5608291625977, 0.74282660126615, -77.6963882446289, -1.35605779177659, 218, 40, 'PPL', 'P'),
(35504, 'Dant', 37.6358299255371, 0.656869148921235, -85.4558334350586, -1.49148565847763, 218, 21, 'PPL', 'P'),
(200669, 'Dant', 45.038330078125, 0.786067149463276, -121.11222076416, -2.11380701673684, 218, 43, 'PPL', 'P'),
(86219, 'Dante', 36.026668548584, 0.628783984697477, -83.9930572509766, -1.46595539784564, 218, 50, 'PPL', 'P'),
(101293, 'Dante', 36.978328704834, 0.645393587784083, -82.2977828979492, -1.43636727866069, 218, 53, 'PPL', 'P'),
(170124, 'Dante', 43.0386085510254, 0.751165424692379, -98.1838912963867, -1.71363217554215, 218, 49, 'PPL', 'P'),
(101294, 'Danton', 38.1830596923828, 0.666420110117613, -77.9155578613281, -1.35988302320833, 218, 53, 'PPL', 'P'),
(20464, 'Danton (historical)', 32.1947212219238, 0.561903887084263, -82.1527786254883, -1.43383647667679, 218, 13, 'PPL', 'P'),
(181021, 'Dantoni', 39.1650009155273, 0.683558217522546, -121.515281677246, -2.12084175675628, 218, 6, 'PPL', 'P'),
(160650, 'Dantown', 41.7066688537598, 0.727918691537077, -80.3916702270508, -1.40309933663953, 218, 45, 'PPL', 'P'),
(108795, 'Dantown (historical)', 39.1558303833008, 0.683398161541032, -79.9669418334961, -1.3956864277453, 218, 58, 'PPL', 'P'),
(193485, 'Dantuma Place', 40.2936096191406, 0.703256155367262, -121.798889160156, -2.12579164111636, 218, 6, 'PPL', 'P'),
(59201, 'Dantzler', 30.7127799987793, 0.536039133419359, -88.8755569458008, -1.55117109324794, 218, 30, 'PPL', 'P'),
(80616, 'Dantzler', 33.4194412231445, 0.583279283520593, -80.5041732788086, -1.40506288531125, 218, 48, 'PPL', 'P'),
(134919, 'Danube', 44.7919387817383, 0.781766810093071, -95.0969390869141, -1.65975469563514, 218, 28, 'PPL', 'P'),
(119312, 'Danvers', 40.5294418334961, 0.707372203990034, -89.1772232055664, -1.55643616272303, 218, 18, 'PPL', 'P'),
(124620, 'Danvers', 42.5750007629395, 0.743073942352391, -70.9305572509766, -1.23797176430388, 218, 23, 'PPL', 'P'),
(134921, 'Danvers', 45.2819404602051, 0.790318952722615, -95.7516708374023, -1.67118192039851, 218, 28, 'PPL', 'P'),
(196327, 'Danvers', 47.2252807617188, 0.824236639470728, -109.71639251709, -1.91491229283369, 218, 31, 'PPL', 'P'),
(124621, 'Danvers Center', 42.5722198486328, 0.743025406241525, -70.9611129760742, -1.23850506231217, 218, 23, 'PPL', 'P'),
(124623, 'Danversport', 42.5483283996582, 0.742608421793845, -70.9208297729492, -1.23780198778439, 218, 23, 'PPL', 'P'),
(188402, 'Danvik Place', 34.9633293151855, 0.610225214009042, -106.222221374512, -1.85392750176753, 218, 38, 'PPL', 'P'),
(1965, 'Danville', 34.4144401550293, 0.600645290935809, -87.0875015258789, -1.51996363896217, 218, 2, 'PPL', 'P'),
(8397, 'Danville', 35.0538902282715, 0.611805800116004, -93.3933334350586, -1.63002116785468, 218, 4, 'PPL', 'P'),
(15732, 'Danville', 30.0011100769043, 0.523618150095229, -82.3713912963867, -1.43765198757055, 218, 12, 'PPL', 'P'),
(20465, 'Danville', 32.6055603027344, 0.569074381740274, -83.2455596923828, -1.45290910429756, 218, 13, 'PPL', 'P'),
(29606, 'Danville', 39.2644386291504, 0.685293733025923, -87.0911102294922, -1.52002662272195, 218, 19, 'PPL', 'P'),
(32204, 'Danville', 37.2861099243164, 0.650765383439855, -97.8916702270508, -1.70853195573854, 218, 20, 'PPL', 'P'),
(35505, 'Danville', 37.6455612182617, 0.657038992019755, -84.772216796875, -1.47955429731991, 218, 21, 'PPL', 'P'),
(39996, 'Danville', 32.228889465332, 0.562500235431359, -92.8477783203125, -1.62049943485126, 218, 22, 'PPL', 'P'),
(46182, 'Danville', 38.6852798461914, 0.675185505371446, -76.9219436645508, -1.34254118398, 218, 25, 'PPL', 'P'),
(54335, 'Danville', 38.9105606079102, 0.679117396404839, -91.5347213745117, -1.59758226788086, 218, 29, 'PPL', 'P'),
(93636, 'Danville', 32.4008293151855, 0.565501151926687, -94.8266677856445, -1.65503757155434, 218, 51, 'PPL', 'P'),
(101295, 'Danville', 36.5858306884766, 0.6385432050911, -79.3952789306641, -1.38570902787937, 218, 53, 'PPL', 'P'),
(108796, 'Danville', 38.0808296203613, 0.664635858766288, -81.8341674804688, -1.42827566316265, 218, 58, 'PPL', 'P'),
(115195, 'Danville', 40.8644409179688, 0.713219041005249, -91.3144378662109, -1.59373759537317, 218, 16, 'PPL', 'P'),
(119314, 'Danville', 40.124439239502, 0.700303575245719, -87.629997253418, -1.52943197558573, 218, 18, 'PPL', 'P'),
(127221, 'Danville', 44.0222206115723, 0.768332693711248, -70.26611328125, -1.22637502933713, 218, 26, 'PPL', 'P'),
(143694, 'Danville', 42.9124984741211, 0.748964388630456, -71.125, -1.24136543048097, 218, 36, 'PPL', 'P'),
(148187, 'Danville', 42.0088882446289, 0.733193414971116, -75.4791717529297, -1.31736006376692, 218, 40, 'PPL', 'P'),
(154937, 'Danville', 40.4474983215332, 0.705942019905634, -82.2602767944336, -1.43571267366475, 218, 41, 'PPL', 'P'),
(160653, 'Danville', 40.9633293151855, 0.714944969128702, -76.6130599975586, -1.33715014698536, 218, 45, 'PPL', 'P'),
(171898, 'Danville', 44.4111099243164, 0.775120092644451, -72.1397171020508, -1.25907558488805, 218, 55, 'PPL', 'P'),
(173746, 'Danville', 43.3194389343262, 0.756066839520615, -88.9555587768555, -1.55256738860747, 218, 57, 'PPL', 'P'),
(181022, 'Danville', 37.8216705322266, 0.66011267939187, -121.998893737793, -2.12928237951518, 218, 6, 'PPL', 'P'),
(207164, 'Danville', 48.9925003051758, 0.855080439109644, -118.506942749023, -2.06833633744288, 218, 56, 'PPL', 'P'),
(20466, 'Danville (historical)', 32.0561103820801, 0.559484671550035, -83.9875030517578, -1.46585845878196, 218, 13, 'PPL', 'P'),
(86220, 'Danville (historical)', 36.3041687011719, 0.633627276034923, -87.9458312988281, -1.53494431956803, 218, 50, 'PPL', 'P'),
(190100, 'Danville (historical)', 38.7694396972656, 0.676654371870679, -116.517501831055, -2.03361404315043, 218, 39, 'PPL', 'P'),
(115196, 'Danville Center', 40.8569412231445, 0.713088146637671, -91.3133316040039, -1.59371828745526, 218, 16, 'PPL', 'P'),
(171899, 'Danville Center', 44.4199981689453, 0.775275221777948, -72.1208267211914, -1.2587458855451, 218, 55, 'PPL', 'P'),
(127222, 'Danville Corner', 44.0361099243164, 0.768575107949472, -70.2563934326172, -1.22620538597569, 218, 26, 'PPL', 'P'),
(1966, 'Danway', 32.7583312988281, 0.571740738623661, -85.3772201538086, -1.49011359788402, 218, 2, 'PPL', 'P'),
(119316, 'Danway', 41.4324989318848, 0.723133523690423, -88.6916732788086, -1.54796171781828, 218, 18, 'PPL', 'P'),
(46183, 'Danwood', 38.4263916015625, 0.670667053107963, -75.554443359375, -1.31867380113266, 218, 25, 'PPL', 'P'),
(80617, 'Danwood', 34.0852813720703, 0.594900386411317, -79.7652816772461, -1.39216679404865, 218, 48, 'PPL', 'P'),
(46184, 'Danza Village', 39.1333312988281, 0.6830054784383, -76.6666717529297, -1.33808584863436, 218, 25, 'PPL', 'P'),
(1967, 'Danzey', 31.4672203063965, 0.549206600797038, -85.2905578613281, -1.48860105554291, 218, 2, 'PPL', 'P'),
(139861, 'Danzig', 46.1380615234375, 0.805261084071695, -99.4744415283203, -1.73615652625177, 218, 34, 'PPL', 'P'),
(1968, 'Danzler', 33.8766708374023, 0.591259445727016, -86.8819427490234, -1.51637596149967, 218, 2, 'PPL', 'P'),
(101298, 'Daphna', 38.579719543457, 0.673343130529329, -78.8052825927734, -1.37541164920847, 218, 53, 'PPL', 'P'),
(1969, 'Daphne', 30.6033306121826, 0.534128881258959, -87.9036102294922, -1.53420742289441, 218, 2, 'PPL', 'P'),
(93637, 'Daphne', 33.2666702270508, 0.580612926637206, -95.1294403076172, -1.66032194894733, 218, 51, 'PPL', 'P'),
(20467, 'Daphne (historical)', 31.9650001525879, 0.557894498063149, -83.9119415283203, -1.46453966141015, 218, 13, 'PPL', 'P'),
(193484, 'Daphnedale Park', 41.5091705322266, 0.724471695559161, -120.543891906738, -2.10388780694073, 218, 6, 'PPL', 'P'),
(46185, 'Dar', 39.6944389343262, 0.692798654135821, -76.7005615234375, -1.33867733671246, 218, 25, 'PPL', 'P'),
(39997, 'Darbonne', 30.6052799224854, 0.534162903141884, -91.8794403076172, -1.60359874825751, 218, 22, 'PPL', 'P'),
(173742, 'Darboy', 44.2433280944824, 0.772191747288827, -88.3238906860352, -1.54154270064287, 218, 57, 'PPL', 'P'),
(59200, 'Darbun', 31.2761096954346, 0.545871091400254, -90.0469436645508, -1.57161564830426, 218, 30, 'PPL', 'P'),
(15733, 'Darby', 28.3608303070068, 0.494989867456664, -82.3583297729492, -1.43742402098124, 218, 12, 'PPL', 'P'),
(39999, 'Darby', 30.3841705322266, 0.530303816274791, -91.9199981689453, -1.60430661647525, 218, 22, 'PPL', 'P'),
(64120, 'Darby', 36.1211090087891, 0.630432281675155, -81.4955596923828, -1.42236584238766, 218, 33, 'PPL', 'P'),
(78112, 'Darby', 39.9183311462402, 0.696706310403294, -75.2594375610352, -1.31352497863915, 218, 45, 'PPL', 'P'),
(139862, 'Darby', 48.1536102294922, 0.840439045226661, -98.9672164916992, -1.72730377931418, 218, 34, 'PPL', 'P'),
(194814, 'Darby', 43.6941719055176, 0.762607163683686, -111.065277099609, -1.93845477002804, 218, 17, 'PPL', 'P'),
(196328, 'Darby', 46.0227813720703, 0.80324906586814, -114.177223205566, -1.99276847572161, 218, 31, 'PPL', 'P'),
(46186, 'Darby Delight', 39.413890838623, 0.687902166155601, -77.2155609130859, -1.34766577170759, 218, 25, 'PPL', 'P'),
(93638, 'Darby Hill', 30.7718200683594, 0.537069577024138, -95.201057434082, -1.66157190360496, 218, 51, 'PPL', 'P'),
(134924, 'Darby Junction', 47.3594398498535, 0.826578157280153, -91.6319427490234, -1.5992791009694, 218, 28, 'PPL', 'P'),
(46187, 'Darby-Lux', 39.4286117553711, 0.688159094621767, -77.2525024414063, -1.3483105230075, 218, 25, 'PPL', 'P'),
(72272, 'Darbydale', 39.8536109924316, 0.695576730626937, -83.1830596923828, -1.45181827351506, 218, 41, 'PPL', 'P'),
(101301, 'Darbydale', 38.6336097717285, 0.674283692447318, -77.32861328125, -1.34963890775923, 218, 53, 'PPL', 'P'),
(160652, 'Darbytown', 41.6108283996582, 0.726245960056399, -75.0697174072266, -1.3102137372978, 218, 45, 'PPL', 'P'),
(101299, 'Darbytown Estates', 37.4605598449707, 0.653810108935115, -77.3097229003906, -1.34930920841628, 218, 53, 'PPL', 'P'),
(72273, 'Darbyville', 39.6969413757324, 0.692842329977698, -83.1138916015625, -1.45061106259293, 218, 41, 'PPL', 'P'),
(101300, 'Darbyville', 36.8302803039551, 0.642809655736434, -83.0524978637695, -1.44953953972834, 218, 53, 'PPL', 'P'),
(115199, 'Darbyville', 40.8161087036133, 0.712375484729966, -92.8730621337891, -1.62094072064389, 218, 16, 'PPL', 'P'),
(93639, 'Darco', 32.4088897705078, 0.565641833411271, -94.4355621337891, -1.6482114902063, 218, 51, 'PPL', 'P'),
(8399, 'Dardanelle', 35.2230606079102, 0.614758380237548, -93.1577835083008, -1.62591004607992, 218, 4, 'PPL', 'P'),
(181023, 'Dardanelle', 38.3411102294922, 0.669178612374717, -119.832778930664, -2.09147654415458, 218, 6, 'PPL', 'P'),
(200670, 'Dardanelles', 42.4291687011719, 0.740528692719575, -123.056938171387, -2.14774873851379, 218, 43, 'PPL', 'P'),
(59202, 'Darden', 34.503059387207, 0.6021919883179, -89.1936111450195, -1.5567221862241, 218, 30, 'PPL', 'P'),
(86222, 'Darden', 35.6380615234375, 0.622001512612291, -88.2169418334961, -1.53967609103483, 218, 50, 'PPL', 'P'),
(93640, 'Darden', 33.2999992370605, 0.581194627598306, -94.5808334350586, -1.65074695272211, 218, 51, 'PPL', 'P'),
(54337, 'Dardenne', 38.7658309936523, 0.676591388110898, -90.7561111450195, -1.58399295578651, 218, 29, 'PPL', 'P'),
(54338, 'Dardenne Prairie', 38.7694396972656, 0.676654371870679, -90.728889465332, -1.58351784784804, 218, 29, 'PPL', 'P'),
(64121, 'Dardens', 35.8202781677246, 0.625181793007036, -76.8158264160156, -1.34068908859991, 218, 33, 'PPL', 'P'),
(101302, 'Dare', 37.1688919067383, 0.648719543090456, -76.438606262207, -1.33410535491107, 218, 53, 'PPL', 'P'),
(46188, 'Dares (historical)', 38.5586090087891, 0.672974682192516, -76.540283203125, -1.33587995230344, 218, 25, 'PPL', 'P'),
(46189, 'Dares Beach', 38.5616683959961, 0.673028078572372, -76.5158309936523, -1.33545318073876, 218, 25, 'PPL', 'P'),
(70718, 'Daretown', 39.6041717529297, 0.691223194613957, -75.2577819824219, -1.31349608334133, 218, 37, 'PPL', 'P'),
(26913, 'Dareville', 38.1983299255371, 0.666686625963703, -88.9763870239258, -1.55293091009626, 218, 18, 'PPL', 'P'),
(35506, 'Darfork', 37.2838897705078, 0.650726634445994, -83.1875, -1.45189577150278, 218, 21, 'PPL', 'P'),
(134925, 'Darfur', 44.0513916015625, 0.768841823532644, -94.8377838134766, -1.65523158283975, 218, 28, 'PPL', 'P'),
(46191, 'Dargan', 39.3772201538086, 0.687262141966628, -77.7333297729492, -1.3567025430765, 218, 25, 'PPL', 'P'),
(1970, 'Dargin', 33.1522216796875, 0.578615422661592, -86.7588882446289, -1.51422825523858, 218, 2, 'PPL', 'P'),
(20468, 'Darien', 31.3700008392334, 0.547509800998007, -81.4341735839844, -1.42129445268112, 218, 13, 'PPL', 'P'),
(54340, 'Darien', 37.5200004577637, 0.654847543337756, -91.5922164916992, -1.5985857469796, 218, 29, 'PPL', 'P'),
(113100, 'Darien', 41.0786094665527, 0.716956987332257, -73.4697189331055, -1.28228849589751, 218, 8, 'PPL', 'P'),
(119318, 'Darien', 41.7519416809082, 0.728708851432504, -87.9738922119141, -1.5354340748925, 218, 18, 'PPL', 'P'),
(148188, 'Darien', 42.9019393920898, 0.748780097883022, -78.3505630493164, -1.36747529600198, 218, 40, 'PPL', 'P'),
(173743, 'Darien', 42.6016693115234, 0.74353939633191, -88.7074966430664, -1.54823788762333, 218, 57, 'PPL', 'P'),
(148189, 'Darien Center', 42.9011116027832, 0.748765650234109, -78.3888931274414, -1.36814428206781, 218, 40, 'PPL', 'P'),
(93641, 'Darilek', 29.0527801513672, 0.507066670499414, -98.2316665649414, -1.71446601127946, 218, 51, 'PPL', 'P'),
(46190, 'Darinton (historical)', 39.2061080932617, 0.684275673120213, -76.4916687011719, -1.33503146918014, 218, 25, 'PPL', 'P'),
(127223, 'Dark Harbor', 44.2605590820313, 0.772492484754924, -68.9141693115234, -1.20277915576292, 218, 26, 'PPL', 'P'),
(29605, 'Dark Hollow', 38.8888893127441, 0.67873916095102, -86.539436340332, -1.51039809695883, 218, 19, 'PPL', 'P'),
(64124, 'Dark Ridge (historical)', 36.2238883972168, 0.632226120406405, -81.9394378662109, -1.4301129779987, 218, 33, 'PPL', 'P'),
(160654, 'Dark Water', 40.735279083252, 0.710964741721524, -76.1999969482422, -1.32994083675646, 218, 45, 'PPL', 'P'),
(108797, 'Darkesville', 39.3711090087891, 0.68715548236497, -78.0280609130859, -1.36184657188004, 218, 58, 'PPL', 'P'),
(86223, 'Darkey Springs', 35.896671295166, 0.626515104606784, -85.5894393920898, -1.4938175223281, 218, 50, 'PPL', 'P'),
(35507, 'Darkmont', 36.8727798461914, 0.643551412679048, -83.179443359375, -1.45175515659723, 218, 21, 'PPL', 'P'),
(207165, 'Darknell', 47.4280586242676, 0.827775780822361, -117.16471862793, -2.04491010723011, 218, 56, 'PPL', 'P'),
(54341, 'Darksville', 39.5525016784668, 0.690321381689829, -92.5822219848633, -1.61586460244814, 218, 29, 'PPL', 'P'),
(46192, 'Darleigh Manor', 39.3944396972656, 0.687562679695643, -76.4725036621094, -1.33469697614723, 218, 25, 'PPL', 'P'),
(40001, 'Darley', 32.6108283996582, 0.569166327376909, -93.0538864135742, -1.62409669969369, 218, 22, 'PPL', 'P'),
(13628, 'Darley Woods', 39.8166694641113, 0.694931979327029, -75.4736099243164, -1.31726299154519, 218, 10, 'PPL', 'P'),
(59203, 'Darling', 34.3588905334473, 0.599675767140966, -90.274169921875, -1.57558149464155, 218, 30, 'PPL', 'P'),
(78118, 'Darling', 39.9033317565918, 0.696444521668139, -75.4700012207031, -1.31720000778541, 218, 45, 'PPL', 'P'),
(177631, 'Darling', 35.2005615234375, 0.614365697134815, -111.399719238281, -1.94429188650528, 218, 5, 'PPL', 'P'),
(191356, 'Darling', 28.9927806854248, 0.506019482269281, -100.399169921875, -1.75229608140598, 218, 51, 'PPL', 'P'),
(1976, 'Darling Landing', 30.4430599212646, 0.531331630007994, -87.913330078125, -1.53437706625584, 218, 2, 'PPL', 'P'),
(1971, 'Darlington', 31.9775009155273, 0.558112677535453, -87.1305618286133, -1.52071518302179, 218, 2, 'PPL', 'P'),
(15734, 'Darlington', 30.9436092376709, 0.54006786364789, -86.057502746582, -1.50198676897192, 218, 12, 'PPL', 'P'),
(40003, 'Darlington', 30.8777809143066, 0.538918942664116, -90.7813873291016, -1.58443410842108, 218, 22, 'PPL', 'P'),
(46199, 'Darlington', 39.6391716003418, 0.691834057188994, -76.2030563354492, -1.32999423313631, 218, 25, 'PPL', 'P'),
(64125, 'Darlington', 36.3186111450195, 0.633879344232099, -77.7183303833008, -1.35644075434135, 218, 33, 'PPL', 'P'),
(80619, 'Darlington', 34.2997207641602, 0.59864305984926, -79.8763885498047, -1.39410597479639, 218, 48, 'PPL', 'P'),
(122469, 'Darlington', 40.1100006103516, 0.70005157362757, -86.7719421386719, -1.51445608866983, 218, 19, 'PPL', 'P'),
(139111, 'Darlington', 40.1983299255371, 0.70159321100359, -94.3958282470703, -1.64751800305844, 218, 29, 'PPL', 'P'),
(145075, 'Darlington', 41.0802803039551, 0.716986148946193, -74.182502746582, -1.29472892029759, 218, 37, 'PPL', 'P'),
(154941, 'Darlington', 40.5863914489746, 0.708366162287879, -82.6047210693359, -1.44172436035144, 218, 41, 'PPL', 'P'),
(160656, 'Darlington', 40.2574996948242, 0.702625918295295, -79.2886123657227, -1.38384734511935, 218, 45, 'PPL', 'P'),
(169346, 'Darlington', 41.8849983215332, 0.731031127903053, -71.3636093139648, -1.24552994863558, 218, 47, 'PPL', 'P'),
(173749, 'Darlington', 42.6830596923828, 0.744959926457358, -90.1175003051758, -1.57284709399231, 218, 57, 'PPL', 'P'),
(181024, 'Darlington', 38.7291717529297, 0.675951563659007, -120.40055847168, -2.10138616657076, 218, 6, 'PPL', 'P'),
(194815, 'Darlington', 43.8136100769043, 0.764691753026946, -113.413887023926, -1.97944574605238, 218, 17, 'PPL', 'P'),
(207166, 'Darlington', 47.9538917541504, 0.836953300254883, -122.268890380859, -2.13399470990602, 218, 56, 'PPL', 'P'),
(78115, 'Darlington Corners', 39.9197196960449, 0.696730545169214, -75.5769424438477, -1.31906648423539, 218, 45, 'PPL', 'P'),
(112612, 'Darlington Heights', 37.2000007629395, 0.649262495057696, -78.6044387817383, -1.37190626342365, 218, 53, 'PPL', 'P'),
(122470, 'Darlington Woods', 40.1197204589844, 0.700221216989008, -86.8052825927734, -1.51503798936802, 218, 19, 'PPL', 'P'),
(193134, 'Darlingtonia', 41.8363914489746, 0.730182777937808, -123.941940307617, -2.16319493967819, 218, 6, 'PPL', 'P'),
(20470, 'Darlot', 31.9347190856934, 0.557365993744822, -81.6305618286133, -1.4247220741621, 218, 13, 'PPL', 'P'),
(59205, 'Darlove', 33.2319412231445, 0.580006791173104, -90.7844390869141, -1.58448737164288, 218, 30, 'PPL', 'P'),
(32206, 'Darlow', 37.9408302307129, 0.66219240846614, -97.9497222900391, -1.70954515537526, 218, 20, 'PPL', 'P'),
(26917, 'Darmstadt', 38.3208312988281, 0.668824678265846, -89.7316665649414, -1.56611302485994, 218, 18, 'PPL', 'P'),
(29607, 'Darmstadt', 38.0991706848145, 0.664955970729315, -87.5788879394531, -1.52853994977861, 218, 19, 'PPL', 'P'),
(26914, 'Darmstadt (historical)', 38.4550018310547, 0.671166395812352, -90.1449966430664, -1.57332699562074, 218, 18, 'PPL', 'P'),
(46193, 'Darnall', 38.7905616760254, 0.677023019944573, -76.6386108398438, -1.33759609330989, 218, 25, 'PPL', 'P'),
(59204, 'Darnall (historical)', 32.6847190856934, 0.57045596313478, -88.8388900756836, -1.55053113563799, 218, 30, 'PPL', 'P'),
(35508, 'Darnell', 36.6511116027832, 0.639682571984463, -87.0897216796875, -1.52000238795603, 218, 21, 'PPL', 'P'),
(112369, 'Darnell', 32.6775016784668, 0.570329995615219, -91.4530563354492, -1.59615694406545, 218, 22, 'PPL', 'P'),
(154942, 'Darnell', 40.0716705322266, 0.699382587561742, -83.9366683959961, -1.4649712266648, 218, 41, 'PPL', 'P'),
(101303, 'Darnell Town', 36.8644409179688, 0.643405870925476, -82.9000015258789, -1.44687797653491, 218, 53, 'PPL', 'P'),
(46194, 'Darnestown', 39.103328704834, 0.682481834388963, -77.2911071777344, -1.34898430276329, 218, 25, 'PPL', 'P'),
(46195, 'Darnestown Hills', 39.0958290100098, 0.682350940021386, -77.2777786254883, -1.34875167564207, 218, 25, 'PPL', 'P'),
(46196, 'Darnestown Knolls', 39.0991706848145, 0.682409263249258, -77.2916717529297, -1.34899415645932, 218, 25, 'PPL', 'P'),
(141617, 'Darr', 40.8208312988281, 0.712457909565704, -99.8833312988281, -1.74329299902485, 218, 35, 'PPL', 'P'),
(59206, 'Darracott', 33.7236099243164, 0.588588028837557, -88.5319366455078, -1.54517378763114, 218, 30, 'PPL', 'P'),
(130422, 'Darragh', 44.771671295166, 0.781413075721281, -85.0519409179688, -1.48443640423024, 218, 27, 'PPL', 'P'),
(160659, 'Darragh', 40.2663917541504, 0.702781114007819, -79.6788864135742, -1.39065891223945, 218, 45, 'PPL', 'P'),
(1972, 'Darrah', 32.8555603027344, 0.57343770487026, -87.788330078125, -1.53219540469085, 218, 2, 'PPL', 'P'),
(181025, 'Darrah', 37.5180587768555, 0.654813654612884, -119.834167480469, -2.0915007789205, 218, 6, 'PPL', 'P'),
(80621, 'Darraugh', 34.2219390869141, 0.597285513483592, -82.3302764892578, -1.43693439881483, 218, 48, 'PPL', 'P'),
(196329, 'Darrel (historical)', 46.7508316040039, 0.81595593953529, -108.709167480469, -1.89733289963613, 218, 31, 'PPL', 'P'),
(59207, 'Darrington', 31.3066692352295, 0.54640445598757, -91.2355575561523, -1.59236087424765, 218, 30, 'PPL', 'P'),
(207167, 'Darrington', 48.2555618286133, 0.842218436308997, -121.600280761719, -2.12232527064151, 218, 56, 'PPL', 'P'),
(122471, 'Darrough Chapel', 40.4786109924316, 0.706485038451902, -86.0955581665039, -1.50265096134779, 218, 19, 'PPL', 'P'),
(190101, 'Darroughs Hot Springs', 38.8202781677246, 0.677541670566866, -117.179718017578, -2.04517189596526, 218, 39, 'PPL', 'P'),
(191357, 'Darrouzett', 36.4461097717285, 0.636104615059942, -100.324440002441, -1.75099179826211, 218, 51, 'PPL', 'P'),
(40002, 'Darrow', 30.1180591583252, 0.525659296623207, -90.9852828979492, -1.5879927574277, 218, 22, 'PPL', 'P'),
(75608, 'Darrow', 36.0980606079102, 0.630030011192498, -98.3880615234375, -1.71719561823873, 218, 42, 'PPL', 'P'),
(119319, 'Darrow', 40.7188911437988, 0.710678718220449, -87.6030578613281, -1.52896179449528, 218, 18, 'PPL', 'P'),
(148191, 'Darrowsville', 43.6086082458496, 0.761113796102424, -73.8024978637695, -1.28809658391886, 218, 40, 'PPL', 'P'),
(154943, 'Darrowville', 41.2024993896484, 0.719119274400319, -81.440559387207, -1.42140590597274, 218, 41, 'PPL', 'P'),
(72277, 'Darrtown', 39.4955596923828, 0.689327556550039, -84.6613922119141, -1.47762004342019, 218, 41, 'PPL', 'P'),
(46197, 'Darryl Gardens', 39.4099998474121, 0.687834255547804, -76.4058303833008, -1.33353330790892, 218, 25, 'PPL', 'P'),
(15735, 'Darsey', 30.687780380249, 0.535602807764263, -84.3797225952148, -1.47270398120595, 218, 12, 'PPL', 'P'),
(1973, 'Dart', 34.9944381713867, 0.610768165976282, -87.9236068725586, -1.53455643015526, 218, 2, 'PPL', 'P'),
(72275, 'Dart', 39.4861106872559, 0.689162640299536, -81.2744369506836, -1.41850652249397, 218, 41, 'PPL', 'P'),
(139112, 'Dart', 40.0466690063477, 0.698946228617133, -92.5672225952148, -1.61560281371299, 218, 29, 'PPL', 'P'),
(207168, 'Dartford', 47.7847213745117, 0.83400072013334, -117.415832519531, -2.04929287143605, 218, 56, 'PPL', 'P'),
(108799, 'Dartmont', 38.1913909912109, 0.666565518713132, -81.7225036621094, -1.42632676187693, 218, 58, 'PPL', 'P'),
(108798, 'Dartmoor', 38.9952812194824, 0.680596050021078, -79.936393737793, -1.39515326289506, 218, 58, 'PPL', 'P'),
(54342, 'Dartmound (historical)', 38.5680618286133, 0.673139665022047, -90.9016723632813, -1.58653347830839, 218, 29, 'PPL', 'P'),
(32207, 'Dartmouth', 38.3633308410645, 0.66956643520846, -98.6455612182617, -1.7216898357363, 218, 20, 'PPL', 'P'),
(13629, 'Dartmouth Woods', 39.8333282470703, 0.695222729939038, -75.5111083984375, -1.31791746338308, 218, 10, 'PPL', 'P'),
(145076, 'Darts Mills', 40.538890838623, 0.707537120240537, -74.8341674804688, -1.30610261552305, 218, 37, 'PPL', 'P'),
(101304, 'Darvills', 37.063060760498, 0.646872441137404, -77.8341674804688, -1.35846249308288, 218, 53, 'PPL', 'P'),
(26915, 'Darwin', 39.2833290100098, 0.685623432368875, -87.6119384765625, -1.52911679047072, 218, 18, 'PPL', 'P'),
(72276, 'Darwin', 39.146110534668, 0.683228518179594, -82.0236129760742, -1.43158211081404, 218, 41, 'PPL', 'P'),
(75609, 'Darwin', 34.2477798461914, 0.597736519814197, -95.779167175293, -1.67166182202694, 218, 42, 'PPL', 'P'),
(86226, 'Darwin', 35.0202789306641, 0.611219172306887, -90.1172180175781, -1.5728421671443, 218, 50, 'PPL', 'P'),
(101305, 'Darwin', 37.1002807617188, 0.647522052706302, -82.4911117553711, -1.43974150376182, 218, 53, 'PPL', 'P'),
(134929, 'Darwin', 45.0963897705078, 0.787080482258051, -94.4105606079102, -1.64777513126169, 218, 28, 'PPL', 'P'),
(181026, 'Darwin', 36.2680587768555, 0.632997038962955, -117.590827941895, -2.05234711773221, 218, 6, 'PPL', 'P'),
(190102, 'Darwin', 39.5894393920898, 0.69096606641071, -119.101112365723, -2.07870655356959, 218, 39, 'PPL', 'P'),
(173750, 'Darwin (historical)', 43.1286087036133, 0.752736223682335, -89.351936340332, -1.55948548217117, 218, 57, 'PPL', 'P'),
(1974, 'Darwin Downs', 34.7449989318848, 0.606414629963302, -86.5630569458008, -1.51081035429557, 218, 2, 'PPL', 'P'),
(20472, 'Darwin Subdivision', 33.5513916015625, 0.585582252073239, -83.1722183227539, -1.45162905591961, 218, 13, 'PPL', 'P'),
(8404, 'Darysaw (historical)', 34.2374992370605, 0.597557089335753, -92.2399978637695, -1.60989166475531, 218, 4, 'PPL', 'P'),
(207169, 'Dash Point', 47.3191719055176, 0.825875349068481, -122.425277709961, -2.13672418370724, 218, 56, 'PPL', 'P'),
(20473, 'Dasher', 30.7472190856934, 0.53664020887739, -83.220832824707, -1.45247753904291, 218, 13, 'PPL', 'P'),
(613, 'Dasher Green', 39.1902809143066, 0.683999436736145, -76.8497161865234, -1.34128057667801, 218, 25, 'PPL', 'P'),
(148192, 'Dashville', 41.8208312988281, 0.729911202085647, -74.045280456543, -1.29233393952928, 218, 40, 'PPL', 'P'),
(40010, 'Daspit', 30.0405597686768, 0.524306677105556, -91.8002777099609, -1.60221710028398, 218, 22, 'PPL', 'P'),
(134932, 'Dassel', 45.0816688537598, 0.786823553791886, -94.3066711425781, -1.64596191803351, 218, 28, 'PPL', 'P'),
(178056, 'Date', 34.3152809143066, 0.598914635701421, -112.917503356934, -1.97078221671024, 218, 5, 'PPL', 'P'),
(209902, 'Date', 45.3672218322754, 0.79180739345586, -102.679168701172, -1.79208956704616, 218, 49, 'PPL', 'P'),
(181027, 'Date City', 32.7930603027344, 0.572346874087763, -115.309173583984, -2.0125247367942, 218, 6, 'PPL', 'P'),
(178057, 'Dateland', 32.7963905334473, 0.572404997578554, -113.540283203125, -1.98165177554135, 218, 5, 'PPL', 'P'),
(35509, 'Datha', 37.2602806091309, 0.650314576846332, -83.916389465332, -1.46461729255593, 218, 21, 'PPL', 'P'),
(188403, 'Datil', 34.1450004577637, 0.595942681082947, -107.843063354492, -1.88221653097273, 218, 38, 'PPL', 'P'),
(8402, 'Datto', 36.3916702270508, 0.635154465762029, -90.730827331543, -1.58355166999389, 218, 4, 'PPL', 'P'),
(93642, 'Datura', 31.7241706848145, 0.553691230914676, -96.6127777099609, -1.68621107053621, 218, 51, 'PPL', 'P'),
(160660, 'Dauberville', 40.4636116027832, 0.706223249716747, -75.9822235107422, -1.3261399732487, 218, 45, 'PPL', 'P'),
(80622, 'Daufuskie Landing', 32.1041717529297, 0.560323500714383, -80.8855590820313, -1.41171932329785, 218, 48, 'PPL', 'P'),
(54344, 'Daugherty', 38.6036109924316, 0.673760114977008, -94.2813873291016, -1.64552063224088, 218, 29, 'PPL', 'P'),
(101306, 'Daugherty', 37.6894416809082, 0.657804850570234, -75.666389465332, -1.3206276292664, 218, 53, 'PPL', 'P'),
(86228, 'Daugherty Estates', 35.9408302307129, 0.627285823426253, -87.1563873291016, -1.52116592303629, 218, 50, 'PPL', 'P'),
(46198, 'Daugherty Town', 37.9866714477539, 0.662992488636627, -75.8513870239258, -1.32385644577201, 218, 25, 'PPL', 'P'),
(181028, 'Daulton', 37.1191711425781, 0.647851752049254, -119.981109619141, -2.09406540305024, 218, 6, 'PPL', 'P'),
(181029, 'Daum (historical)', 33.8974990844727, 0.591622967215811, -117.841110229492, -2.05671536771021, 218, 6, 'PPL', 'P'),
(93643, 'Dauphin', 32.186939239502, 0.561768065868669, -95.916389465332, -1.67405680279525, 218, 51, 'PPL', 'P'),
(160661, 'Dauphin', 40.3672218322754, 0.704540930856144, -76.9313888549805, -1.34270603365148, 218, 45, 'PPL', 'P'),
(1975, 'Dauphin Island', 30.2552795410156, 0.528054244102001, -88.1097183227539, -1.53780468773683, 218, 2, 'PPL', 'P'),
(86229, 'Daus', 35.3144416809082, 0.616353280835369, -85.4341735839844, -1.49110762276089, 218, 50, 'PPL', 'P'),
(40004, 'Dauterive Landing', 30.0808296203613, 0.525009518606741, -91.6497192382813, -1.5995893592364, 218, 22, 'PPL', 'P'),
(40005, 'Dauterive Trailer Park', 29.9338893890381, 0.522444927766508, -89.9588928222656, -1.57007887119723, 218, 22, 'PPL', 'P'),
(40006, 'Davant', 29.6083297729492, 0.516762840554229, -89.8483276367188, -1.56814914467136, 218, 22, 'PPL', 'P'),
(8403, 'Dave', 33.6425018310547, 0.587172425560125, -93.8808288574219, -1.63852956806332, 218, 4, 'PPL', 'P'),
(35510, 'Davella', 37.7980613708496, 0.659700621792207, -82.5819396972656, -1.44132675040069, 218, 21, 'PPL', 'P'),
(1977, 'Davenport', 32.065559387207, 0.559649587800538, -86.4063873291016, -1.50807595364633, 218, 2, 'PPL', 'P'),
(15736, 'Davenport', 28.1611099243164, 0.491504089195372, -81.601936340332, -1.42422246514161, 218, 12, 'PPL', 'P'),
(54345, 'Davenport', 37.4633293151855, 0.6538584453089, -94.0811080932617, -1.6420251001521, 218, 29, 'PPL', 'P'),
(75611, 'Davenport', 35.704719543457, 0.623164914534492, -96.7649993896484, -1.68886784003967, 218, 42, 'PPL', 'P'),
(93644, 'Davenport', 33.9249992370605, 0.592102935423271, -95.1363906860352, -1.66044325593498, 218, 51, 'PPL', 'P'),
(101307, 'Davenport', 37.1005592346191, 0.647526912975291, -82.1369400024414, -1.43356004055564, 218, 53, 'PPL', 'P'),
(115200, 'Davenport', 41.523609161377, 0.724723697177309, -90.5774993896484, -1.58087559257252, 218, 16, 'PPL', 'P'),
(139864, 'Davenport', 46.714168548584, 0.815316048504371, -97.0697174072266, -1.69418617273656, 218, 34, 'PPL', 'P'),
(141618, 'Davenport', 40.3127784729004, 0.703590714979203, -97.8116683959961, -1.70713566037901, 218, 35, 'PPL', 'P'),
(145077, 'Davenport', 41.0041694641113, 0.715657764194461, -74.4805603027344, -1.2999310060129, 218, 37, 'PPL', 'P'),
(148193, 'Davenport', 42.4716682434082, 0.74127044966219, -74.8450012207031, -1.30629169996044, 218, 40, 'PPL', 'P'),
(181030, 'Davenport', 37.0116691589355, 0.645975488482266, -122.190826416016, -2.13263223669234, 218, 6, 'PPL', 'P'),
(207170, 'Davenport', 47.6541709899902, 0.831722186083695, -118.148887634277, -2.06208709678695, 218, 56, 'PPL', 'P'),
(8405, 'Davenport (historical)', 35.4966697692871, 0.619533760967196, -91.7091674804688, -1.60062692679709, 218, 4, 'PPL', 'P'),
(64126, 'Davenport (historical)', 36.0008316040039, 0.6283330449459, -81.5280609130859, -1.42293309569984, 218, 33, 'PPL', 'P'),
(70717, 'Davenport (historical)', 39.9272193908691, 0.696861439536791, -74.3388900756836, -1.29745839409882, 218, 37, 'PPL', 'P'),
(148194, 'Davenport Center', 42.4480590820313, 0.740858392062527, -74.9194412231445, -1.30759092309824, 218, 40, 'PPL', 'P'),
(64127, 'Davenport Forks', 35.9194412231445, 0.626912514820451, -76.436393737793, -1.33406673907526, 218, 33, 'PPL', 'P'),
(35511, 'Davenport Landing', 37.2363891601563, 0.649897592398653, -86.9199981689453, -1.51704015387554, 218, 21, 'PPL', 'P'),
(181031, 'Davenport Landing', 37.0244407653809, 0.646198395065505, -122.214721679688, -2.13304928771904, 218, 6, 'PPL', 'P'),
(20474, 'Davenport Trace', 34.0322189331055, 0.593974272142242, -84.6891708374023, -1.47810487189663, 218, 13, 'PPL', 'P'),
(78116, 'Daves Gap', 39.9102783203125, 0.696565762076765, -78.1916732788086, -1.36470214635888, 218, 45, 'PPL', 'P'),
(141621, 'Davey', 40.9874992370605, 0.71536681384537, -96.6658325195313, -1.68713705164723, 218, 35, 'PPL', 'P'),
(199902, 'Daveytown', 41.2949981689453, 0.720733682653125, -117.902221679688, -2.05778196372679, 218, 39, 'PPL', 'P'),
(35512, 'David', 37.5994415283203, 0.656234051580278, -82.8908309936523, -1.4467179205534, 218, 21, 'PPL', 'P'),
(20475, 'David (historical)', 33.2613906860352, 0.580520781263489, -82.495002746582, -1.43980941436962, 218, 13, 'PPL', 'P'),
(181032, 'David (historical)', 39.7172203063965, 0.69319626408657, -121.453887939453, -2.11977023389169, 218, 6, 'PPL', 'P'),
(141623, 'David City', 41.2527809143066, 0.719996852558528, -97.1297225952148, -1.69523346083523, 218, 35, 'PPL', 'P'),
(160665, 'David Manor', 40.2916717529297, 0.703222333221418, -76.795280456543, -1.34033049395913, 218, 45, 'PPL', 'P'),
(40007, 'Davids', 29.9513893127441, 0.522750359054027, -91.8736114501953, -1.60349701550387, 218, 22, 'PPL', 'P'),
(101308, 'Davids Crossroads', 38.5611114501953, 0.673018358034394, -77.5352783203125, -1.35324589313963, 218, 53, 'PPL', 'P'),
(78117, 'Davidsburg', 39.9836082458496, 0.69784561071763, -76.8947219848633, -1.34206607604153, 218, 45, 'PPL', 'P'),
(8407, 'Davidson', 33.4569396972656, 0.58393375535848, -93.2388916015625, -1.62732564935735, 218, 4, 'PPL', 'P'),
(29608, 'Davidson', 37.9674987792969, 0.662657862445658, -86.0472183227539, -1.50180727191445, 218, 19, 'PPL', 'P'),
(64128, 'Davidson', 35.4991683959961, 0.619577370230046, -80.8488922119141, -1.4110793656879, 218, 33, 'PPL', 'P'),
(75612, 'Davidson', 34.2408294677734, 0.597615212826544, -99.0752792358398, -1.72918982999818, 218, 42, 'PPL', 'P'),
(78121, 'Davidson', 39.7227783203125, 0.693293269729276, -79.8802795410156, -1.39417388540419, 218, 45, 'PPL', 'P'),
(80623, 'Davidson', 32.7247200012207, 0.571154110814544, -80.9008331298828, -1.41198590572296, 218, 48, 'PPL', 'P'),
(86231, 'Davidson', 36.5680618286133, 0.63823307998216, -85.0224990844727, -1.48392254729791, 218, 50, 'PPL', 'P'),
(93645, 'Davidson', 30.4719390869141, 0.531835666533805, -96.6308288574219, -1.68652612249316, 218, 51, 'PPL', 'P'),
(134935, 'Davidson', 47.8766708374023, 0.835605541006222, -96.8469390869141, -1.69029795754504, 218, 28, 'PPL', 'P'),
(194816, 'Davidson', 45.8430595397949, 0.800112328157218, -116.594436645508, -2.03495680897204, 218, 17, 'PPL', 'P'),
(59208, 'Davidson (historical)', 32.2013893127441, 0.562020267223899, -88.4916687011719, -1.54447097941946, 218, 30, 'PPL', 'P'),
(127224, 'Davidson (historical)', 45.836669921875, 0.800000808286571, -68.4966735839844, -1.19549248070435, 218, 26, 'PPL', 'P'),
(160666, 'Davidson Heights', 40.5833282470703, 0.708312699328996, -80.2600021362305, -1.4008012949349, 218, 45, 'PPL', 'P'),
(64130, 'Davidson River', 35.2533302307129, 0.615286684818792, -82.6841735839844, -1.44311106833105, 218, 33, 'PPL', 'P'),
(113107, 'Davidsons Corner', 41.4286117553711, 0.723065679661653, -72.9766693115234, -1.27368315662519, 218, 8, 'PPL', 'P'),
(1979, 'Davidsons Cross Roads (historical)', 34.7866706848145, 0.607141939257003, -87.5616683959961, -1.52823941204959, 218, 2, 'PPL', 'P'),
(211777, 'Davidsons Landing', 65.241943359375, 1.13868672202074, -165.271667480469, -2.88453475779542, 218, 1, 'PPL', 'P'),
(46200, 'Davidsonville', 38.922779083252, 0.679330649029127, -76.6286087036133, -1.33742152310044, 218, 25, 'PPL', 'P'),
(8409, 'Davidsonville (historical)', 36.1541709899902, 0.631009322104347, -91.0555572509766, -1.58921927626774, 218, 4, 'PPL', 'P'),
(46201, 'Davidsonville Farmettes', 38.9727783203125, 0.680203300339318, -76.6675033569336, -1.3381003628623, 218, 25, 'PPL', 'P'),
(46202, 'Davidsonville Gardens', 38.8852806091309, 0.67867617719124, -76.6611099243164, -1.33798877641262, 218, 25, 'PPL', 'P'),
(46203, 'Davidsonville Woods', 38.9097213745117, 0.679102749018843, -76.663330078125, -1.33802752540648, 218, 25, 'PPL', 'P'),
(160667, 'Davidsville', 40.2269401550293, 0.702092553707979, -78.9366683959961, -1.37770476406508, 218, 45, 'PPL', 'P'),
(15738, 'Davie', 26.0625, 0.454876436301022, -80.2333297729492, -1.40033577437636, 218, 12, 'PPL', 'P'),
(64136, 'Davie Circle', 35.9186096191406, 0.62689800059251, -79.0377807617188, -1.37946950776142, 218, 33, 'PPL', 'P'),
(64133, 'Davie Crossroads', 35.8319396972656, 0.625385325093345, -80.5350036621094, -1.4056009770095, 218, 33, 'PPL', 'P'),
(64134, 'Davie Gardens', 36.0166702270508, 0.62860948106705, -80.4644393920898, -1.40436939816339, 218, 33, 'PPL', 'P'),
(134937, 'Davies', 46.6005592346191, 0.813333191914753, -95.3108291625977, -1.66348778169316, 218, 28, 'PPL', 'P'),
(93646, 'Davilla', 30.7855606079102, 0.537309394680299, -97.2747192382813, -1.69776412966108, 218, 51, 'PPL', 'P'),
(108800, 'Davin', 37.7316703796387, 0.658541880401914, -81.8294372558594, -1.42819310516886, 218, 58, 'PPL', 'P'),
(207171, 'Davin', 46.6086082458496, 0.813473673662254, -118.323333740234, -2.06513175570319, 218, 56, 'PPL', 'P'),
(20476, 'Davis', 31.8983306884766, 0.556730896403866, -82.2566680908203, -1.43564968990497, 218, 13, 'PPL', 'P'),
(35514, 'Davis', 38.3741683959961, 0.669755586224883, -84.4722213745117, -1.47431838945876, 218, 21, 'PPL', 'P'),
(46204, 'Davis', 39.3455581665039, 0.686709536040437, -77.1972198486328, -1.34734565974456, 218, 25, 'PPL', 'P'),
(54348, 'Davis', 37.8216705322266, 0.66011267939187, -90.5911102294922, -1.58111314654175, 218, 29, 'PPL', 'P'),
(59210, 'Davis', 32.6916694641113, 0.570577270122433, -90.023063659668, -1.57119886359366, 218, 30, 'PPL', 'P'),
(64135, 'Davis', 34.7972183227539, 0.607326030267355, -76.460563659668, -1.33448858379193, 218, 33, 'PPL', 'P'),
(75613, 'Davis', 34.5044403076172, 0.602216089925765, -97.1191711425781, -1.69504930324585, 218, 42, 'PPL', 'P'),
(86233, 'Davis', 35.7330589294434, 0.623659530127947, -84.2533264160156, -1.47049795171699, 218, 50, 'PPL', 'P'),
(93647, 'Davis', 28.7994403839111, 0.502645057431069, -98.7569427490234, -1.723633810174, 218, 51, 'PPL', 'P'),
(101309, 'Davis', 37.9186096191406, 0.661804585632397, -79.2638931274414, -1.38341591302276, 218, 53, 'PPL', 'P'),
(108802, 'Davis', 39.1286087036133, 0.682923053602562, -79.4649963378906, -1.38692582618143, 218, 58, 'PPL', 'P'),
(119322, 'Davis', 42.4225006103516, 0.740412312579939, -89.4136123657227, -1.56056193188378, 218, 18, 'PPL', 'P'),
(122473, 'Davis', 41.7147216796875, 0.728059239863606, -86.8261108398438, -1.51540151085681, 218, 19, 'PPL', 'P'),
(130423, 'Davis', 42.7308311462402, 0.745793695615635, -82.9602813720703, -1.44793005832355, 218, 27, 'PPL', 'P'),
(143697, 'Davis', 43.413330078125, 0.757705549118368, -71.1405563354492, -1.2416369397541, 218, 36, 'PPL', 'P'),
(154944, 'Davis', 41.0825004577637, 0.717024897940054, -81.0124969482422, -1.41393480700868, 218, 41, 'PPL', 'P'),
(160668, 'Davis', 40.7411117553711, 0.711066541054192, -79.1588897705078, -1.38158325871862, 218, 45, 'PPL', 'P'),
(170128, 'Davis', 43.2574996948242, 0.754985795855125, -96.9952774047852, -1.69288694959876, 218, 49, 'PPL', 'P'),
(181033, 'Davis', 38.5449981689453, 0.672737128223281, -121.739440917969, -2.12475407355566, 218, 6, 'PPL', 'P'),
(207172, 'Davis', 46.6619415283203, 0.814404515042264, -123.424171447754, -2.15415816830928, 218, 56, 'PPL', 'P'),
(26918, 'Davis (historical)', 39.6794395446777, 0.692536865400666, -90.2183303833008, -1.57460691084064, 218, 18, 'PPL', 'P'),
(40009, 'Davis (historical)', 29.9302806854248, 0.522381944006728, -90.3225021362305, -1.57642505091683, 218, 22, 'PPL', 'P'),
(46205, 'Davis (historical)', 39.3194389343262, 0.686253669440842, -76.8561096191406, -1.34139216312769, 218, 25, 'PPL', 'P'),
(15739, 'Davis Beach', 29.9661102294922, 0.523007287520192, -85.4625015258789, -1.49160203861726, 218, 12, 'PPL', 'P'),
(145078, 'Davis Bridge', 40.6802787780762, 0.710004805306605, -74.5272216796875, -1.30074540067425, 218, 37, 'PPL', 'P'),
(86235, 'Davis Chapel', 35.9363899230957, 0.627208325438532, -88.4055633544922, -1.54296815761633, 218, 50, 'PPL', 'P'),
(115202, 'Davis City', 40.6391716003418, 0.709287349708937, -93.811393737793, -1.63731769660928, 218, 16, 'PPL', 'P'),
(13630, 'Davis Corner', 39.1652793884277, 0.683563077791535, -75.6819381713867, -1.32089900538147, 218, 10, 'PPL', 'P'),
(101312, 'Davis Corner', 36.8541717529297, 0.643226640184113, -76.1769409179688, -1.32953843311575, 218, 53, 'PPL', 'P'),
(127225, 'Davis Corner', 44.1474990844727, 0.77051921554523, -69.3747177124023, -1.21081724172305, 218, 26, 'PPL', 'P'),
(115203, 'Davis Corners', 43.3708305358887, 0.756963792175754, -92.2975006103516, -1.61089527701211, 218, 16, 'PPL', 'P'),
(148196, 'Davis Corners', 41.917781829834, 0.731603308063256, -74.210563659668, -1.29521867562206, 218, 40, 'PPL', 'P'),
(108803, 'Davis Creek', 38.3372192382813, 0.66911070176692, -81.7038879394531, -1.42600185622394, 218, 58, 'PPL', 'P'),
(193486, 'Davis Creek', 41.7333297729492, 0.728384012358541, -120.370826721191, -2.10086724963236, 218, 6, 'PPL', 'P'),
(148197, 'Davis Crossing', 42.5625, 0.742855762880086, -75.357780456543, -1.31524138596171, 218, 40, 'PPL', 'P'),
(1980, 'Davis Crossroads', 32.1355590820313, 0.560871312950612, -86.1758270263672, -1.50405191723922, 218, 2, 'PPL', 'P'),
(20480, 'Davis Crossroads', 34.7552795410156, 0.606594060441746, -85.3680572509766, -1.48995367506056, 218, 13, 'PPL', 'P'),
(35515, 'Davis Crossroads', 37.0513916015625, 0.646668775893041, -86.7413864135742, -1.51392279066155, 218, 21, 'PPL', 'P'),
(80624, 'Davis Crossroads', 33.5686111450195, 0.585882789802255, -80.3330612182617, -1.40207641646483, 218, 48, 'PPL', 'P'),
(178058, 'Davis Dam', 35.1800003051758, 0.614006836177927, -114.565559387207, -1.99954622069586, 218, 5, 'PPL', 'P'),
(8412, 'Davis Ford', 34.235279083252, 0.597518340341892, -94.0155563354492, -1.6408810061478, 218, 4, 'PPL', 'P'),
(54349, 'Davis Ford', 38.0713882446289, 0.664471075673839, -91.8244400024414, -1.60263881184259, 218, 29, 'PPL', 'P'),
(108804, 'Davis Ford', 39.1963882446289, 0.684106029758775, -78.5008316040039, -1.37009797704349, 218, 58, 'PPL', 'P'),
(86236, 'Davis Heights', 35.2000007629395, 0.614355910017809, -84.8925018310547, -1.48165366720722, 218, 50, 'PPL', 'P'),
(35516, 'Davis Hill', 37.648609161377, 0.657092188662529, -84.836669921875, -1.48067921656436, 218, 21, 'PPL', 'P'),
(80625, 'Davis Hill', 32.917781829834, 0.574523675383767, -80.5427780151367, -1.40573666506704, 218, 48, 'PPL', 'P'),
(1981, 'Davis Hills', 34.7655601501465, 0.60677349092019, -86.6119384765625, -1.51166349795078, 218, 2, 'PPL', 'P'),
(119323, 'Davis Junction', 42.1016693115234, 0.734812750071938, -89.0930633544922, -1.55496729622379, 218, 18, 'PPL', 'P'),
(1983, 'Davis Landing', 31.2397193908691, 0.545235960769784, -87.8452835083008, -1.53318942956772, 218, 2, 'PPL', 'P'),
(40011, 'Davis Landing', 30.3250007629395, 0.529271108983086, -89.7083282470703, -1.56570569437121, 218, 22, 'PPL', 'P'),
(80626, 'Davis Landing', 34.0272216796875, 0.593887053616542, -79.3077774047852, -1.38418183815226, 218, 48, 'PPL', 'P'),
(20479, 'Davis Mill', 31.7586097717285, 0.554292306372707, -83.9197235107422, -1.46467548262575, 218, 13, 'PPL', 'P'),
(70719, 'Davis Mill', 39.4247207641602, 0.68809118401397, -75.366943359375, -1.31540130878517, 218, 37, 'PPL', 'P'),
(101313, 'Davis Mill', 37.2041702270508, 0.649335265934482, -79.5827789306641, -1.38898152022686, 218, 53, 'PPL', 'P'),
(148198, 'Davis Park', 40.6838912963867, 0.710067855645412, -73.0052795410156, -1.27418249932958, 218, 40, 'PPL', 'P'),
(40012, 'Davis Plantation', 29.898609161377, 0.521829171632968, -90.3591690063477, -1.57706500852678, 218, 22, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(93648, 'Davis Prairie', 31.420280456543, 0.548387345866702, -96.5252838134766, -1.68468401396715, 218, 51, 'PPL', 'P'),
(101314, 'Davis Shop', 38.2174987792969, 0.667021185575644, -78.5500030517578, -1.37095618070477, 218, 53, 'PPL', 'P'),
(15740, 'Davis Shores', 29.8969402313232, 0.521800043308546, -81.2972183227539, -1.41890413244472, 218, 12, 'PPL', 'P'),
(86238, 'Davis Springs', 36.1769409179688, 0.631406732318014, -82.2758331298828, -1.43598418293789, 218, 50, 'PPL', 'P'),
(8413, 'Davis Spur', 35.726390838623, 0.62354314998831, -90.5444412231445, -1.58029861872235, 218, 4, 'PPL', 'P'),
(80627, 'Davis Station', 33.6025009155273, 0.586474277880361, -80.2647171020508, -1.40088358661259, 218, 48, 'PPL', 'P'),
(160670, 'Davis Station', 41.8216705322266, 0.729925849471643, -77.5755615234375, -1.35394896766741, 218, 45, 'PPL', 'P'),
(190104, 'Davis Station', 39.2797203063965, 0.685560448609094, -119.215560913086, -2.08070405754521, 218, 39, 'PPL', 'P'),
(101315, 'Davis Store', 36.6955604553223, 0.640458350810003, -79.7083282470703, -1.39117276917178, 218, 53, 'PPL', 'P'),
(1991, 'Davis Subdivision', 33.5138893127441, 0.584927713656325, -86.3019409179688, -1.50625301988017, 218, 2, 'PPL', 'P'),
(207173, 'Davis Terrace', 46.1347198486328, 0.805202760843823, -122.895278930664, -2.1449272524969, 218, 56, 'PPL', 'P'),
(127226, 'Davis Town', 45.0872192382813, 0.786920426276538, -70.7861099243164, -1.23545068285796, 218, 26, 'PPL', 'P'),
(101317, 'Davis Wharf', 37.5527801513672, 0.655419656918932, -75.8783264160156, -1.32432662686246, 218, 53, 'PPL', 'P'),
(20481, 'Davisboro', 32.978889465332, 0.575590204821316, -82.6080627441406, -1.44178268357932, 218, 13, 'PPL', 'P'),
(35517, 'Davisburg', 36.6794395446777, 0.640176987840836, -83.8233337402344, -1.46299316376514, 218, 21, 'PPL', 'P'),
(130425, 'Davisburg', 42.7522201538086, 0.746167004221437, -83.541389465332, -1.45807230786095, 218, 27, 'PPL', 'P'),
(20482, 'Davison', 33.454719543457, 0.583895006364619, -82.0213928222656, -1.43154336182018, 218, 13, 'PPL', 'P'),
(130424, 'Davison', 43.0347213745117, 0.751097580663609, -83.5180587768555, -1.45766511053028, 218, 27, 'PPL', 'P'),
(108806, 'Davison (historical)', 38.7216682434082, 0.675820602712402, -80.8399963378906, -1.41092410339635, 218, 58, 'PPL', 'P'),
(148199, 'Davison Beach', 43.3402786254883, 0.756430560746493, -77.771110534668, -1.3573619417624, 218, 40, 'PPL', 'P'),
(35522, 'Davisport', 37.8311080932617, 0.660277395905291, -82.605827331543, -1.44174366826935, 218, 21, 'PPL', 'P'),
(1984, 'Daviston', 33.0527801513672, 0.576879840579187, -85.6397171020508, -1.49469503390728, 218, 2, 'PPL', 'P'),
(80628, 'Daviston', 33.8869400024414, 0.591438676468378, -79.3763885498047, -1.38537932853642, 218, 48, 'PPL', 'P'),
(1985, 'Davistown', 34.5416717529297, 0.602865901231744, -86.0197219848633, -1.50132737028602, 218, 2, 'PPL', 'P'),
(35519, 'Davistown', 38.1413917541504, 0.66569286740294, -84.6516723632813, -1.47745040005875, 218, 21, 'PPL', 'P'),
(64139, 'Davistown', 35.5616683959961, 0.620668201012543, -82.1522216796875, -1.43382675613881, 218, 33, 'PPL', 'P'),
(80629, 'Davistown', 34.0227813720703, 0.593809555628821, -79.5313873291016, -1.38808456757172, 218, 48, 'PPL', 'P'),
(160671, 'Davistown', 40.041389465332, 0.698854083243416, -79.4036102294922, -1.38585443647489, 218, 45, 'PPL', 'P'),
(1986, 'Davisville', 32.3274993896484, 0.564221303285823, -85.6697235107422, -1.49521874453565, 218, 2, 'PPL', 'P'),
(35520, 'Davisville', 37.9702796936035, 0.662706398556525, -82.8300018310547, -1.44565625138484, 218, 21, 'PPL', 'P'),
(54353, 'Davisville', 37.8077812194824, 0.659870265153645, -91.1849975585938, -1.59147843582045, 218, 29, 'PPL', 'P'),
(72278, 'Davisville', 39.0977783203125, 0.682384961904311, -82.6122207641602, -1.44185525471902, 218, 41, 'PPL', 'P'),
(93649, 'Davisville', 31.4027805328369, 0.548081914579183, -94.7102813720703, -1.65300624543288, 218, 51, 'PPL', 'P'),
(108808, 'Davisville', 39.2011108398438, 0.684188454594513, -81.4986114501953, -1.42241910560946, 218, 58, 'PPL', 'P'),
(124625, 'Davisville', 41.5513916015625, 0.725208592232785, -70.5638885498047, -1.23157218820442, 218, 23, 'PPL', 'P'),
(143699, 'Davisville', 43.2519416809082, 0.754888790212419, -71.732780456543, -1.25197320057692, 218, 36, 'PPL', 'P'),
(145079, 'Davisville', 40.1097183227539, 0.700046646779553, -74.6183319091797, -1.30233557416113, 218, 37, 'PPL', 'P'),
(160672, 'Davisville', 40.1830596923828, 0.7013266951575, -75.0591735839844, -1.31002971286648, 218, 45, 'PPL', 'P'),
(169347, 'Davisville', 41.6133308410645, 0.726289635898276, -71.475830078125, -1.24748857045928, 218, 47, 'PPL', 'P'),
(59211, 'Davisville (historical)', 31.961109161377, 0.557826587455352, -88.975830078125, -1.55292118955828, 218, 30, 'PPL', 'P'),
(59212, 'Davo', 31.1058292388916, 0.54289913678178, -90.1111068725586, -1.57273550754264, 218, 30, 'PPL', 'P'),
(29610, 'Davy', 38.8666687011719, 0.678351338117277, -87.5972213745117, -1.52885992858358, 218, 19, 'PPL', 'P'),
(108809, 'Davy', 37.478328704834, 0.654120234044055, -81.6536102294922, -1.42512434464476, 218, 58, 'PPL', 'P'),
(101316, 'Daw', 37.0525016784668, 0.646688150389971, -81.8572235107422, -1.42867806680336, 218, 53, 'PPL', 'P'),
(1987, 'Dawes', 30.6075000762939, 0.534201652135745, -88.2552795410156, -1.54034521025871, 218, 2, 'PPL', 'P'),
(75615, 'Dawes', 36.8813896179199, 0.643701681543556, -94.9911117553711, -1.65790766026112, 218, 42, 'PPL', 'P'),
(108810, 'Dawes', 38.1427803039551, 0.66571710216886, -81.4522171020508, -1.42160937148002, 218, 58, 'PPL', 'P'),
(181034, 'Dawes', 38.9491691589355, 0.679791242739656, -123.083892822266, -2.14821918592035, 218, 6, 'PPL', 'P'),
(20483, 'Dawesville', 30.9222202301025, 0.539694555042088, -84.0091705322266, -1.46623662765675, 218, 13, 'PPL', 'P'),
(35521, 'Dawkins', 37.7902793884277, 0.659564800576613, -82.7847213745117, -1.44486595833136, 218, 21, 'PPL', 'P'),
(80630, 'Dawkins', 34.3555603027344, 0.599617643650175, -81.3683319091797, -1.42014529867075, 218, 48, 'PPL', 'P'),
(101320, 'Dawley Corners', 36.686939239502, 0.640307882208414, -76.0005569458008, -1.32645995205367, 218, 53, 'PPL', 'P'),
(26919, 'Dawleys', 37.2125015258789, 0.649480674530001, -89.2961120605469, -1.55851116468636, 218, 18, 'PPL', 'P'),
(108811, 'Dawmont', 39.3175010681152, 0.686219847294998, -80.3424987792969, -1.40224113297826, 218, 58, 'PPL', 'P'),
(54354, 'Dawn', 39.6683311462402, 0.692342987273308, -93.6352767944336, -1.63424387607911, 218, 29, 'PPL', 'P'),
(154945, 'Dawn', 40.2169418334961, 0.701918050077552, -84.5788879394531, -1.47618007221878, 218, 41, 'PPL', 'P'),
(191358, 'Dawn', 34.9102783203125, 0.609299299477049, -102.199440002441, -1.783716721737, 218, 51, 'PPL', 'P'),
(86239, 'Dawn (historical)', 35.5222206115723, 0.61997970729173, -85.9591674804688, -1.50027049480742, 218, 50, 'PPL', 'P'),
(160673, 'Dawn Acres', 41.3375015258789, 0.721475506174767, -75.5074996948242, -1.3178544796233, 218, 45, 'PPL', 'P'),
(8416, 'Dawn Hill', 36.232780456543, 0.632381316118929, -94.5133285522461, -1.64956877025586, 218, 4, 'PPL', 'P'),
(177207, 'Dawn Ree Acres', 40.1213912963867, 0.700250378602944, -80.6558303833008, -1.40770980111868, 218, 58, 'PPL', 'P'),
(29611, 'Dawnbury', 39.8697204589844, 0.695857893859022, -86.1208267211914, -1.5030919808243, 218, 19, 'PPL', 'P'),
(101318, 'Dawnington Sabot', 37.7052803039551, 0.658081286691384, -77.7149963378906, -1.35638256427153, 218, 53, 'PPL', 'P'),
(20484, 'Dawnville', 34.8191719055176, 0.60770919256919, -84.8791732788086, -1.481421040086, 218, 13, 'PPL', 'P'),
(101319, 'Dawnwood Forest', 37.3011093139648, 0.65102717217501, -80.0061111450195, -1.39637006119712, 218, 53, 'PPL', 'P'),
(148200, 'Daws', 43.0444412231445, 0.751267224025047, -78.192497253418, -1.36471652742877, 218, 40, 'PPL', 'P'),
(1989, 'Dawson', 34.3038902282715, 0.598715830726047, -85.9261093139648, -1.49969352095725, 218, 2, 'PPL', 'P'),
(20485, 'Dawson', 31.7733306884766, 0.554549234838873, -84.4466705322266, -1.47387244313423, 218, 13, 'PPL', 'P'),
(26920, 'Dawson', 39.8527793884277, 0.695562216398996, -89.4633331298828, -1.56142972292498, 218, 18, 'PPL', 'P'),
(46206, 'Dawson', 39.4775009155273, 0.689012371435028, -78.9438934326172, -1.3778308647427, 218, 25, 'PPL', 'P'),
(54355, 'Dawson', 37.2569389343262, 0.650256253618459, -92.3077774047852, -1.61107464091153, 218, 29, 'PPL', 'P'),
(64140, 'Dawson', 35.3450012207031, 0.616886645422684, -77.6366729736328, -1.35501556368399, 218, 33, 'PPL', 'P'),
(75616, 'Dawson', 36.1797218322754, 0.631455268428881, -95.908332824707, -1.67391618788969, 218, 42, 'PPL', 'P'),
(93650, 'Dawson', 31.8938903808594, 0.556653398416144, -96.7144393920898, -1.68798540161247, 218, 51, 'PPL', 'P'),
(108812, 'Dawson', 37.8561096191406, 0.6607137548499, -80.7111129760742, -1.40867466438161, 218, 58, 'PPL', 'P'),
(115220, 'Dawson', 41.8427810668945, 0.730294297808455, -94.2222213745117, -1.64448799152821, 218, 16, 'PPL', 'P'),
(124626, 'Dawson', 42.3397216796875, 0.738967547688571, -71.8513870239258, -1.25404327569223, 218, 23, 'PPL', 'P'),
(134939, 'Dawson', 44.9327812194824, 0.784224974358241, -96.0541687011719, -1.67646150410153, 218, 28, 'PPL', 'P'),
(139867, 'Dawson', 46.8686103820801, 0.818011567001695, -99.751106262207, -1.74098523678225, 218, 34, 'PPL', 'P'),
(141626, 'Dawson', 40.1311111450195, 0.700420021964382, -95.8302764892578, -1.67255384783406, 218, 35, 'PPL', 'P'),
(154946, 'Dawson', 40.2605590820313, 0.702679314675151, -84.3197174072266, -1.47165669310728, 218, 41, 'PPL', 'P'),
(160675, 'Dawson', 40.0469398498535, 0.698950955728067, -79.6547164916992, -1.39023706752278, 218, 45, 'PPL', 'P'),
(188404, 'Dawson', 36.6641693115234, 0.639910471994746, -104.774169921875, -1.82865423618073, 218, 38, 'PPL', 'P'),
(64141, 'Dawson Crossroads', 36.1636085510254, 0.631174038617769, -77.524169921875, -1.35305201501227, 218, 33, 'PPL', 'P'),
(181035, 'Dawson Place', 39.9238891601563, 0.696803316046, -122.706390380859, -2.1416305253835, 218, 6, 'PPL', 'P'),
(160677, 'Dawson Run', 41.5366706848145, 0.72495166376662, -79.4400024414063, -1.38648960039487, 218, 45, 'PPL', 'P'),
(35523, 'Dawson Springs', 37.1672210693359, 0.64869038147652, -87.692497253418, -1.53052280636823, 218, 21, 'PPL', 'P'),
(40013, 'Dawson Switch', 30.7180595397949, 0.536131278793076, -91.5699996948242, -1.59819799072489, 218, 22, 'PPL', 'P'),
(1990, 'Dawsons', 32.1130599975586, 0.56047862984788, -86.9927825927734, -1.51831048171551, 218, 2, 'PPL', 'P'),
(101321, 'Dawsons Shop (historical)', 38.3108291625977, 0.668650108056391, -78.4238891601563, -1.36875507806382, 218, 53, 'PPL', 'P'),
(20489, 'Dawsonville', 34.4211082458496, 0.600761671075445, -84.1191711425781, -1.46815650048659, 218, 13, 'PPL', 'P'),
(46207, 'Dawsonville', 39.1283302307129, 0.682918193333572, -77.3433303833008, -1.34989576964637, 218, 25, 'PPL', 'P'),
(101328, 'Dawsonville', 38.2652816772461, 0.667855154471003, -78.3152770996094, -1.3668594399999, 218, 53, 'PPL', 'P'),
(139114, 'Dawsonville', 40.4644393920898, 0.706237697365661, -95.0991668701172, -1.65979357778706, 218, 29, 'PPL', 'P'),
(54357, 'Dawt', 36.6100006103516, 0.638965049807768, -92.2766723632813, -1.61053175552332, 218, 29, 'PPL', 'P'),
(54358, 'Dawt Mill', 36.6097183227539, 0.638960122959752, -92.2780609130859, -1.61055599028923, 218, 29, 'PPL', 'P'),
(8418, 'Day', 36.2386093139648, 0.63248304887257, -91.7275009155273, -1.60094690560207, 218, 4, 'PPL', 'P'),
(15741, 'Day', 30.1938896179199, 0.526982787816435, -83.291389465332, -1.45370898473096, 218, 12, 'PPL', 'P'),
(35524, 'Day', 37.0713882446289, 0.647017783153895, -82.8466720581055, -1.44594720173393, 218, 21, 'PPL', 'P'),
(40014, 'Day', 30.8600006103516, 0.538608617818094, -90.5111083984375, -1.57971685118223, 218, 22, 'PPL', 'P'),
(46208, 'Day', 39.3872184753418, 0.687436645597055, -77.0555572509766, -1.34487318098853, 218, 25, 'PPL', 'P'),
(54360, 'Day', 36.813060760498, 0.642509118007419, -93.2436065673828, -1.62740794103504, 218, 29, 'PPL', 'P'),
(113294, 'Day', 41.1866683959961, 0.718842971437224, -79.2649993896484, -1.38343522094066, 218, 45, 'PPL', 'P'),
(134941, 'Day', 45.709171295166, 0.797775537458728, -93.3791732788086, -1.62977402650552, 218, 28, 'PPL', 'P'),
(193487, 'Day', 41.211669921875, 0.719279330381833, -121.373329162598, -2.11836421799418, 218, 6, 'PPL', 'P'),
(101322, 'Day - Mar Village', 39.1427803039551, 0.683170394688803, -78.220832824707, -1.36521107644319, 218, 53, 'PPL', 'P'),
(64142, 'Day Acres', 36.1813888549805, 0.63148436346379, -80.2063903808594, -1.3998655932859, 218, 33, 'PPL', 'P'),
(64143, 'Day Book', 35.9791717529297, 0.627955009229163, -82.3000030517578, -1.43640602765455, 218, 33, 'PPL', 'P'),
(148201, 'Day Center', 43.3088912963867, 0.755882748510264, -74.0169372558594, -1.2918392573568, 218, 40, 'PPL', 'P'),
(207174, 'Day City (historical)', 47.7666702270508, 0.833685668176384, -122.154998779297, -2.13200692646838, 218, 56, 'PPL', 'P'),
(207175, 'Day Creek', 48.4983291625977, 0.846455525603314, -122.065277099609, -2.13044098774742, 218, 56, 'PPL', 'P'),
(72279, 'Day Heights', 39.1738891601563, 0.683713346656043, -84.2263870239258, -1.47002777062653, 218, 41, 'PPL', 'P'),
(46209, 'Day Meadows', 39.6755599975586, 0.692469154529951, -76.2683334350586, -1.33113353345065, 218, 25, 'PPL', 'P'),
(141628, 'Day Ranch', 41.9441719055176, 0.732063901773786, -98.4066696166992, -1.71752039073367, 218, 35, 'PPL', 'P'),
(181036, 'Day Valley', 37.035831451416, 0.64639720004088, -121.861389160156, -2.12688247189885, 218, 6, 'PPL', 'P'),
(46210, 'Daybreak Estates', 39.3433303833008, 0.686670653888521, -76.519172668457, -1.33551150396663, 218, 25, 'PPL', 'P'),
(108813, 'Daybrook', 39.666389465332, 0.692309098548437, -80.2133331298828, -1.3999867671155, 218, 58, 'PPL', 'P'),
(115206, 'Dayfield', 41.4650001525879, 0.72370077700261, -91.1511077880859, -1.59088694774235, 218, 16, 'PPL', 'P'),
(141629, 'Daykin', 40.3222198486328, 0.703755498071652, -97.2983322143555, -1.69817625383977, 218, 35, 'PPL', 'P'),
(101323, 'Dayle Acres', 36.8188896179199, 0.64261085076106, -76.4644393920898, -1.33455622808362, 218, 53, 'PPL', 'P'),
(160678, 'Daylesford', 40.038890838623, 0.698810473980566, -75.460563659668, -1.31703529127199, 218, 45, 'PPL', 'P'),
(86240, 'Daylight', 35.7458305358887, 0.623882436711186, -85.8574981689453, -1.4984960305731, 218, 50, 'PPL', 'P'),
(112315, 'Daylight', 38.0936088562012, 0.664858898507582, -87.4905624389648, -1.52699837898162, 218, 19, 'PPL', 'P'),
(59213, 'Days', 34.9111099243164, 0.60931381370499, -90.0777816772461, -1.57215387316056, 218, 30, 'PPL', 'P'),
(148221, 'Days Corners', 42.982780456543, 0.750191040628546, -75.1888885498047, -1.31229366610916, 218, 40, 'PPL', 'P'),
(193204, 'Days Creek', 42.9724998474121, 0.750011610150102, -123.171112060547, -2.14974144879944, 218, 43, 'PPL', 'P'),
(20490, 'Days Crossroads', 31.7216701507568, 0.553647588362313, -85.0441665649414, -1.4843007161727, 218, 13, 'PPL', 'P'),
(64145, 'Days Crossroads', 36.3902816772461, 0.635130230996109, -77.6341705322266, -1.35497188784211, 218, 33, 'PPL', 'P'),
(86245, 'Days Crossroads', 36.5102806091309, 0.637224607456374, -85.9875030517578, -1.50076504382185, 218, 50, 'PPL', 'P'),
(127227, 'Days Ferry', 43.9488906860352, 0.767052845070383, -69.8099975585938, -1.21841430820666, 218, 26, 'PPL', 'P'),
(134942, 'Days High Landing', 47.2522201538086, 0.824706820561181, -93.8055572509766, -1.63721583069758, 218, 28, 'PPL', 'P'),
(127228, 'Days Mill', 43.4577789306641, 0.758481327943908, -70.6097183227539, -1.23237206863782, 218, 26, 'PPL', 'P'),
(148203, 'Days Rock', 42.9702796936035, 0.749972861156242, -74.9613876342773, -1.3083230260819, 218, 40, 'PPL', 'P'),
(35525, 'Daysboro', 37.7933311462402, 0.659618063798415, -83.376106262207, -1.45518757176818, 218, 21, 'PPL', 'P'),
(40015, 'Dayson', 32.8011093139648, 0.572487355835265, -93.4094390869141, -1.63030226450774, 218, 22, 'PPL', 'P'),
(46216, 'Dayspring Estates', 39.6347198486328, 0.691756359464191, -76.9008331298828, -1.34217273564319, 218, 25, 'PPL', 'P'),
(15742, 'Daysville', 29.6275005340576, 0.517097433455684, -82.3697204589844, -1.43762282595661, 218, 12, 'PPL', 'P'),
(35526, 'Daysville', 36.8022193908691, 0.642319900411969, -87.0669403076172, -1.51960477800528, 218, 21, 'PPL', 'P'),
(46211, 'Daysville', 39.4925003051758, 0.689274160170183, -77.2966690063477, -1.34908137498502, 218, 25, 'PPL', 'P'),
(86241, 'Daysville', 35.894718170166, 0.626481016144831, -84.7699966430664, -1.47951554832605, 218, 50, 'PPL', 'P'),
(108818, 'Daysville', 38.9605598449707, 0.67999004771503, -80.1611099243164, -1.39907530023242, 218, 58, 'PPL', 'P'),
(119325, 'Daysville', 41.9844398498535, 0.732766709985458, -89.3183288574219, -1.55889892094108, 218, 18, 'PPL', 'P'),
(148204, 'Daysville', 43.5286102294922, 0.759717567321923, -76.1827774047852, -1.32964029902744, 218, 40, 'PPL', 'P'),
(101324, 'Daysville (historical)', 39.0297203063965, 0.681197125479109, -77.408332824707, -1.35103027627074, 218, 53, 'PPL', 'P'),
(46212, 'Daysville Acres', 39.4866714477539, 0.689172427416542, -77.290283203125, -1.3489699216934, 218, 25, 'PPL', 'P'),
(148205, 'Daysville Corner', 43.5416717529297, 0.759945533911234, -76.1936111450195, -1.32982938346484, 218, 40, 'PPL', 'P'),
(1992, 'Dayton', 32.350830078125, 0.564628500616496, -87.6419372558594, -1.52964036794103, 218, 2, 'PPL', 'P'),
(8420, 'Dayton', 35.1141700744629, 0.61285788190464, -94.2263870239258, -1.64456069582597, 218, 4, 'PPL', 'P'),
(35527, 'Dayton', 39.1127815246582, 0.682646817218493, -84.4727783203125, -1.47432810999674, 218, 21, 'PPL', 'P'),
(46213, 'Dayton', 39.2391700744629, 0.684852713549406, -76.9869384765625, -1.34367555744632, 218, 25, 'PPL', 'P'),
(54361, 'Dayton', 38.485279083252, 0.671694833551651, -94.1936111450195, -1.64398864882382, 218, 29, 'PPL', 'P'),
(72280, 'Dayton', 39.7588882446289, 0.693923506801243, -84.1916732788086, -1.46942190147854, 218, 41, 'PPL', 'P'),
(86242, 'Dayton', 35.4938888549805, 0.619485224856329, -85.0124969482422, -1.48374797708846, 218, 50, 'PPL', 'P'),
(93651, 'Dayton', 30.0463905334473, 0.52440844314871, -94.8850021362305, -1.65605569803907, 218, 51, 'PPL', 'P'),
(101325, 'Dayton', 38.4147186279297, 0.670463321284572, -78.9388885498047, -1.37774351305894, 218, 53, 'PPL', 'P'),
(108814, 'Dayton', 39.3127784729004, 0.68613742245926, -79.5875015258789, -1.3890639450626, 218, 58, 'PPL', 'P'),
(115208, 'Dayton', 42.2613906860352, 0.737600413942979, -94.0683288574219, -1.64180206041081, 218, 16, 'PPL', 'P'),
(119327, 'Dayton', 41.3847198486328, 0.722299621374092, -88.7941665649414, -1.54975056312249, 218, 18, 'PPL', 'P'),
(122477, 'Dayton', 40.3741683959961, 0.70466217126477, -86.7688903808594, -1.51440282544803, 218, 19, 'PPL', 'P'),
(130434, 'Dayton', 41.7983283996582, 0.729518452403888, -86.4394378662109, -1.50865279433844, 218, 27, 'PPL', 'P'),
(134943, 'Dayton', 45.2438888549805, 0.789654826925776, -93.5147171020508, -1.63213971250184, 218, 28, 'PPL', 'P'),
(145080, 'Dayton', 40.372501373291, 0.70463307622986, -74.5105590820313, -1.30045458348321, 218, 37, 'PPL', 'P'),
(148206, 'Dayton', 42.4169387817383, 0.740315240358205, -78.9772186279297, -1.37841249912477, 218, 40, 'PPL', 'P'),
(160681, 'Dayton', 40.8802795410156, 0.713495477126399, -79.2422180175781, -1.38303761098991, 218, 45, 'PPL', 'P'),
(173752, 'Dayton', 42.8269386291504, 0.747471087628221, -89.5130615234375, -1.56229764712424, 218, 57, 'PPL', 'P'),
(181037, 'Dayton', 39.648609161377, 0.691998773702416, -121.871109008789, -2.12705211526029, 218, 6, 'PPL', 'P'),
(188405, 'Dayton', 32.7313919067383, 0.571270557533208, -104.384719848633, -1.82185705013052, 218, 38, 'PPL', 'P'),
(190105, 'Dayton', 39.2372207641602, 0.68481869166648, -119.591941833496, -2.08727314384805, 218, 39, 'PPL', 'P'),
(194817, 'Dayton', 42.1130599975586, 0.735011555047313, -111.992782592773, -1.95464279471409, 218, 17, 'PPL', 'P'),
(196331, 'Dayton', 47.8658294677734, 0.835416323410772, -114.278060913086, -1.99452842572799, 218, 31, 'PPL', 'P'),
(200672, 'Dayton', 45.2208290100098, 0.789252356706038, -123.074996948242, -2.1480639236288, 218, 43, 'PPL', 'P'),
(207178, 'Dayton', 47.2269401550293, 0.824265601347583, -123.223892211914, -2.1506626362205, 218, 56, 'PPL', 'P'),
(209400, 'Dayton', 44.8752784729004, 0.783221362101445, -107.261672973633, -1.87206935458731, 218, 59, 'PPL', 'P'),
(115209, 'Dayton (historical)', 40.7286109924316, 0.710848361581887, -94.9255599975586, -1.65676356625682, 218, 16, 'PPL', 'P'),
(181038, 'Dayton Avenue', 34.0838890075684, 0.59487608506637, -118.221672058105, -2.06335742462692, 218, 6, 'PPL', 'P'),
(130430, 'Dayton Center', 43.5105590820313, 0.759402515364967, -85.9800033569336, -1.50063414945427, 218, 27, 'PPL', 'P'),
(93652, 'Dayton Lakes', 30.1444396972656, 0.526119723886168, -94.8219375610352, -1.65495501356055, 218, 51, 'PPL', 'P'),
(46214, 'Dayton Meadows', 39.2402801513672, 0.684872088046336, -76.9922180175781, -1.34376770282004, 218, 25, 'PPL', 'P'),
(86243, 'Dayton Spur', 35.9599990844727, 0.627620383038194, -84.9922180175781, -1.48339404297959, 218, 50, 'PPL', 'P'),
(15743, 'Daytona Beach', 29.2105598449707, 0.509820445645583, -81.023063659668, -1.41411923091417, 218, 12, 'PPL', 'P'),
(15744, 'Daytona Beach Shores', 29.1758308410645, 0.509214310181481, -80.9830627441406, -1.41342108323441, 218, 12, 'PPL', 'P'),
(130433, 'Daytona Branch', 43.459171295166, 0.758505629288855, -83.2911071777344, -1.45370405788295, 218, 27, 'PPL', 'P'),
(15745, 'Daytona Highridge Estates', 29.1350002288818, 0.50850168156329, -81.1347198486328, -1.41606799904184, 218, 12, 'PPL', 'P'),
(20491, 'Daytona Mobile Home Park', 33.497501373291, 0.58464169015525, -84.6283264160156, -1.47704293641197, 218, 13, 'PPL', 'P'),
(15746, 'Daytona Park Estates', 29.0544395446777, 0.507095632376269, -81.2463912963867, -1.41801703348561, 218, 12, 'PPL', 'P'),
(72283, 'Daytonview', 39.7688903808594, 0.694098077010698, -84.2111129760742, -1.46976118820142, 218, 41, 'PPL', 'P'),
(115216, 'Daytonville', 41.4761085510254, 0.723894655129968, -91.8288879394531, -1.60271644298837, 218, 16, 'PPL', 'P'),
(148208, 'Daytonville', 42.9772186279297, 0.750093968406813, -75.3433303833008, -1.31498918460648, 218, 40, 'PPL', 'P'),
(54364, 'Daytown', 37.8591690063477, 0.660767151229757, -90.5813903808594, -1.58094350318032, 218, 29, 'PPL', 'P'),
(196332, 'Daytown (historical)', 46.6611099243164, 0.814390000814323, -111.696388244629, -1.94946973745466, 218, 31, 'PPL', 'P'),
(29612, 'Dayville', 37.9541702270508, 0.66242523532444, -87.3222198486328, -1.52406024650899, 218, 19, 'PPL', 'P'),
(113115, 'Dayville', 41.8463897705078, 0.730357281568236, -71.8880615234375, -1.25468336646024, 218, 8, 'PPL', 'P'),
(124627, 'Dayville', 42.3027801513672, 0.738322796388663, -72.9055633544922, -1.27244212355721, 218, 23, 'PPL', 'P'),
(200671, 'Dayville', 44.4683303833008, 0.776118778053231, -119.534721374512, -2.08627445843927, 218, 43, 'PPL', 'P'),
(178059, 'Daze', 35.2488899230957, 0.615209186831071, -112.403610229492, -1.96181308963302, 218, 5, 'PPL', 'P'),
(40017, 'Dazet Estates', 29.9330596923828, 0.522430446828081, -89.9266662597656, -1.569516411575, 218, 22, 'PPL', 'P'),
(139870, 'Dazey', 47.190559387207, 0.82363063716468, -98.2013931274414, -1.71393764011918, 218, 34, 'PPL', 'P'),
(178052, 'DC Ranch', 33.6674995422363, 0.587608717925708, -111.864723205566, -1.95240773676924, 218, 5, 'PPL', 'P'),
(93653, 'De Anda Colonia', 26.1520004272461, 0.456438513438408, -97.8629989624023, -1.70803154776972, 218, 51, 'PPL', 'P'),
(8421, 'De Ann', 33.7780609130859, 0.589538377872552, -93.5625, -1.63297368139719, 218, 4, 'PPL', 'P'),
(181040, 'De Anza Trailer Harbor', 32.7933311462402, 0.572351601198698, -117.214996337891, -2.04578761880929, 218, 6, 'PPL', 'P'),
(178060, 'De Anza Village', 31.5516700744629, 0.550680527302342, -110.341667175293, -1.92582539434861, 218, 5, 'PPL', 'P'),
(181041, 'De Anza Village', 33.9883308410645, 0.593208280433708, -117.452499389648, -2.049932829046, 218, 6, 'PPL', 'P'),
(186607, 'De Beque', 39.3344383239746, 0.686515458175997, -108.21443939209, -1.88869826559182, 218, 7, 'PPL', 'P'),
(93654, 'De Berry', 32.3038902282715, 0.56380924568616, -94.166389465332, -1.64351354088535, 218, 51, 'PPL', 'P'),
(8424, 'De Boer', 35.0377807617188, 0.611524636883919, -92.0749969482422, -1.60701185551056, 218, 4, 'PPL', 'P'),
(80631, 'De Bordieu', 33.3722190856934, 0.582455101742241, -79.1516723632813, -1.38145729119906, 218, 48, 'PPL', 'P'),
(80632, 'De Bordieu Colony', 33.3680610656738, 0.582382530602536, -79.1708297729492, -1.38179165107392, 218, 48, 'PPL', 'P'),
(196334, 'De Borgia', 47.3758316040039, 0.826864247360255, -115.345001220703, -2.01315004701815, 218, 31, 'PPL', 'P'),
(40018, 'De Broeck Landing', 32.3224983215332, 0.564134018181095, -93.7094421386719, -1.63553830552694, 218, 22, 'PPL', 'P'),
(112613, 'De Busk Mill', 36.7447204589844, 0.641316354734199, -81.7719421386719, -1.42718962607012, 218, 53, 'PPL', 'P'),
(59214, 'De Buys', 30.3930606842041, 0.530458978697802, -88.9986114501953, -1.55331879950903, 218, 30, 'PPL', 'P'),
(54365, 'De Camp (historical)', 37.9000015258789, 0.661479813137462, -91.5952835083008, -1.59863927651751, 218, 29, 'PPL', 'P'),
(122476, 'De Camp Gardens', 41.6619415283203, 0.727138052442548, -85.9191665649414, -1.49957234712765, 218, 19, 'PPL', 'P'),
(134945, 'De Forest', 47.4599990844727, 0.828333247017542, -92.5791702270508, -1.61581133922634, 218, 28, 'PPL', 'P'),
(173755, 'De Forest', 43.2477798461914, 0.754816152493687, -89.3436126708984, -1.5593402067337, 218, 57, 'PPL', 'P'),
(15747, 'De Funiak Springs', 30.7208309173584, 0.536179648456374, -86.1152801513672, -1.50299517491868, 218, 12, 'PPL', 'P'),
(29613, 'De Gonia Springs', 38.0555610656738, 0.66419483928977, -87.1855621337891, -1.52167511943671, 218, 19, 'PPL', 'P'),
(32210, 'De Graff', 37.9811096191406, 0.662895416414893, -96.8625030517578, -1.69056959997623, 218, 20, 'PPL', 'P'),
(134946, 'De Graff', 45.2633285522461, 0.789994113648653, -95.4674987792969, -1.6662221823424, 218, 28, 'PPL', 'P'),
(154947, 'De Graff', 40.311939239502, 0.703576067593208, -83.9158325195313, -1.46460757201795, 218, 41, 'PPL', 'P'),
(8425, 'De Gray', 34.1749992370605, 0.596466258553257, -93.1474990844727, -1.62573054902245, 218, 4, 'PPL', 'P'),
(170135, 'De Grey', 44.285831451416, 0.772933570810469, -99.9175033569336, -1.74388941395098, 218, 49, 'PPL', 'P'),
(64146, 'De Hart Mill', 35.3916702270508, 0.617701173242085, -83.4875030517578, -1.45713181252199, 218, 33, 'PPL', 'P'),
(101326, 'De Haveland Estates', 39.2555618286133, 0.685138803629508, -78.1269378662109, -1.36357230026641, 218, 53, 'PPL', 'P'),
(101327, 'De Haven', 39.3497200012207, 0.686782173759168, -78.1861114501953, -1.36460507413715, 218, 53, 'PPL', 'P'),
(54366, 'De Kalb', 39.5869407653809, 0.69092245714786, -94.9250030517578, -1.65675384571884, 218, 29, 'PPL', 'P'),
(59215, 'De Kalb', 32.7675018310547, 0.571900794605175, -88.6508331298828, -1.54724892275253, 218, 30, 'PPL', 'P'),
(93655, 'De Kalb', 33.5086097717285, 0.584835568282608, -94.6161117553711, -1.65136267556614, 218, 51, 'PPL', 'P'),
(108815, 'De Kalb', 38.9425010681152, 0.679674862600019, -80.9322204589844, -1.41253371795919, 218, 58, 'PPL', 'P'),
(148209, 'De Kalb', 44.4988899230957, 0.776652142640546, -75.3430633544922, -1.31498452407457, 218, 40, 'PPL', 'P'),
(148210, 'De Kalb Junction', 44.5050010681152, 0.776758802242204, -75.274169921875, -1.3137821068424, 218, 40, 'PPL', 'P'),
(93656, 'De La Cruz Colonia', 26.4009990692139, 0.46078435957374, -99.0149993896484, -1.72813774820954, 218, 51, 'PPL', 'P'),
(93658, 'De La Garza Colonia', 26.4080009460449, 0.460906565378261, -98.9720001220703, -1.72738726941436, 218, 51, 'PPL', 'P'),
(46215, 'De La Plaine Manor', 39.5819396972656, 0.690835172043133, -75.9461135864258, -1.32550973617673, 218, 25, 'PPL', 'P'),
(194818, 'De Lamar', 43.0244407653809, 0.750918150185165, -116.830558776855, -2.03907791760089, 218, 17, 'PPL', 'P'),
(139874, 'De Lamere', 46.267219543457, 0.807515316776393, -97.334716796875, -1.6988112846017, 218, 34, 'PPL', 'P'),
(148212, 'De Lancey', 42.2055587768555, 0.736625963300119, -74.9711074829102, -1.30849266944334, 218, 40, 'PPL', 'P'),
(15748, 'De Land', 29.0280609130859, 0.506635238402821, -81.3033294677734, -1.41901079204638, 218, 12, 'PPL', 'P'),
(119329, 'De Land', 40.1222190856934, 0.700264826251858, -88.6452789306641, -1.54715198368885, 218, 18, 'PPL', 'P'),
(15749, 'De Land Highlands', 29.0705604553223, 0.507376995345435, -81.2644424438477, -1.41833208544257, 218, 12, 'PPL', 'P'),
(86244, 'De Lap', 36.348331451416, 0.634398061433419, -84.1563873291016, -1.46880604547646, 218, 50, 'PPL', 'P'),
(54367, 'De Lassus', 37.7644386291504, 0.659113794246008, -90.4555587768555, -1.57874732738738, 218, 29, 'PPL', 'P'),
(93659, 'De Leon', 32.1108283996582, 0.560439681116937, -98.5355606079102, -1.71976996290646, 218, 51, 'PPL', 'P'),
(15750, 'De Leon Springs', 29.1191692352295, 0.508225378600194, -81.3516693115234, -1.41985448147971, 218, 12, 'PPL', 'P'),
(15751, 'De Leon Springs Heights', 29.1399993896484, 0.508588933378503, -81.3199996948242, -1.41930174239547, 218, 12, 'PPL', 'P'),
(54368, 'De Lisle', 36.3933296203613, 0.635183427638883, -89.7172164916992, -1.56586082350471, 218, 29, 'PPL', 'P'),
(59216, 'De Lisle', 30.3791694641113, 0.530216531170064, -89.2644424438477, -1.55795842560212, 218, 30, 'PPL', 'P'),
(40019, 'De Loach', 32.4483299255371, 0.566330193974029, -92.1047210693359, -1.6075306392909, 218, 22, 'PPL', 'P'),
(80633, 'De Loach', 32.6597213745117, 0.570019670769198, -81.1791687011719, -1.41684377786738, 218, 48, 'PPL', 'P'),
(93660, 'De los Santos Colonia', 26.4150009155273, 0.461028737893269, -98.9759979248047, -1.72745704423492, 218, 51, 'PPL', 'P'),
(40020, 'De Loutre', 32.8325004577637, 0.573035234650522, -92.3111114501953, -1.61113283098135, 218, 22, 'PPL', 'P'),
(181042, 'De Luz', 33.436939239502, 0.583584681518598, -117.323608398438, -2.04768325687321, 218, 6, 'PPL', 'P'),
(181043, 'De Luz Heights', 33.4311103820801, 0.583482948764957, -117.275833129883, -2.0468494211359, 218, 6, 'PPL', 'P'),
(198167, 'De Mores', 46.9219398498535, 0.818942341802678, -103.741943359375, -1.81063848403856, 218, 34, 'PPL', 'P'),
(200673, 'De Moss Springs', 45.5113906860352, 0.794323614632794, -120.681938171387, -2.10629716877892, 218, 43, 'PPL', 'P'),
(173757, 'De Pere', 44.4488906860352, 0.775779491330355, -88.0602798461914, -1.53694182354365, 218, 57, 'PPL', 'P'),
(148213, 'De Peyster', 44.5525016784668, 0.777587844289546, -75.4358291625977, -1.31660359285929, 218, 40, 'PPL', 'P'),
(8426, 'De Queen', 34.0377807617188, 0.594071344363976, -94.3411102294922, -1.64656299349154, 218, 4, 'PPL', 'P'),
(8428, 'De Roche', 34.3277816772461, 0.599132815173726, -93.0566711425781, -1.62414530238358, 218, 4, 'PPL', 'P'),
(86246, 'De Rossett', 35.9505615234375, 0.627455666524773, -85.3088912963867, -1.48892103434788, 218, 50, 'PPL', 'P'),
(181044, 'De Sabla', 39.874439239502, 0.695940252115733, -121.611389160156, -2.12251914876887, 218, 6, 'PPL', 'P'),
(160682, 'De Sale', 41.1405601501465, 0.718038230734829, -79.8249969482422, -1.39320902214125, 218, 45, 'PPL', 'P'),
(198170, 'De Sart', 46.3788909912109, 0.809464351220167, -102.957778930664, -1.79695223288053, 218, 34, 'PPL', 'P'),
(40021, 'De Siard', 32.7080612182617, 0.570863360202535, -92.0625, -1.60679374261728, 218, 22, 'PPL', 'P'),
(170137, 'De Smet', 44.3875007629395, 0.774708035044788, -97.5500030517578, -1.70256873858369, 218, 49, 'PPL', 'P'),
(194819, 'De Smet', 47.146110534668, 0.82285485833914, -116.91471862793, -2.04054678410012, 218, 17, 'PPL', 'P'),
(196333, 'De Smet', 46.9333305358887, 0.819141146778052, -114.10221862793, -1.99145939888778, 218, 31, 'PPL', 'P'),
(26922, 'De Soto', 37.8175010681152, 0.660039908515083, -89.227783203125, -1.55731860115022, 218, 18, 'PPL', 'P'),
(32212, 'De Soto', 38.9791717529297, 0.680314886788993, -94.9683303833008, -1.65751005031037, 218, 20, 'PPL', 'P'),
(54371, 'De Soto', 38.1394386291504, 0.665658778940987, -90.5550003051758, -1.58048290946979, 218, 29, 'PPL', 'P'),
(59218, 'De Soto', 31.9736099243164, 0.558044766927656, -88.7133331298828, -1.54833975353502, 218, 30, 'PPL', 'P'),
(115217, 'De Soto', 41.5316696166992, 0.724864378661893, -94.0094375610352, -1.64077421338809, 218, 16, 'PPL', 'P'),
(141630, 'De Soto', 41.4986114501953, 0.724287404811727, -96.0572204589844, -1.67651476732334, 218, 35, 'PPL', 'P'),
(173760, 'De Soto', 43.4230613708496, 0.757875392216888, -91.1988906860352, -1.5917209166377, 218, 57, 'PPL', 'P'),
(40022, 'De Soto (historical)', 32.2911109924316, 0.563586205944866, -93.6902770996094, -1.63520381249403, 218, 22, 'PPL', 'P'),
(15752, 'De Soto City', 27.4422206878662, 0.478957105062168, -81.4052810668945, -1.42079018312871, 218, 12, 'PPL', 'P'),
(130435, 'De Tour Village', 45.9944381713867, 0.802754383695658, -83.9027786254883, -1.46437973858669, 218, 27, 'PPL', 'P'),
(160683, 'De Turksville', 40.5766716003418, 0.708196518926441, -76.3305587768555, -1.33221957054318, 218, 45, 'PPL', 'P'),
(8430, 'De Valls Bluff', 34.7847213745117, 0.607107917374077, -91.4583282470703, -1.59624895628111, 218, 4, 'PPL', 'P'),
(203692, 'De Ville Acres', 40.6227798461914, 0.709001259628836, -111.836387634277, -1.95191318775481, 218, 52, 'PPL', 'P'),
(8432, 'De Witt', 34.292781829834, 0.598521952598689, -91.3377838134766, -1.59414505901995, 218, 4, 'PPL', 'P'),
(54369, 'De Witt', 39.3844413757324, 0.687388176065216, -93.220832824707, -1.62701046424234, 218, 29, 'PPL', 'P'),
(115218, 'De Witt', 41.8233299255371, 0.729954811348497, -90.5380630493164, -1.58018729858879, 218, 16, 'PPL', 'P'),
(119330, 'De Witt', 40.1811103820801, 0.701292673274574, -88.7861099243164, -1.54960994821693, 218, 18, 'PPL', 'P'),
(141632, 'De Witt', 40.3936080932617, 0.705001457987646, -96.9225006103516, -1.69161675491685, 218, 35, 'PPL', 'P'),
(148215, 'De Witt', 43.0386085510254, 0.751165424692379, -76.0733337402344, -1.32773014673558, 218, 40, 'PPL', 'P'),
(122480, 'Deacon', 40.6338882446289, 0.709195137756193, -86.3172225952148, -1.50651973546334, 218, 19, 'PPL', 'P'),
(101332, 'Deacon (historical)', 37.4063911437988, 0.652864686748137, -79.061393737793, -1.37988163194011, 218, 53, 'PPL', 'P'),
(154951, 'Deacon Creek Corner', 41.3916702270508, 0.722420928361745, -80.8338928222656, -1.41081757695275, 218, 41, 'PPL', 'P'),
(193488, 'Deacon Lee Place', 41.4808311462402, 0.723977079965706, -122.928062438965, -2.14549943265711, 218, 6, 'PPL', 'P'),
(145082, 'Deacons', 40.0377807617188, 0.698791099483635, -74.8277816772461, -1.30599116223143, 218, 37, 'PPL', 'P'),
(211778, 'Deacons Landing', 62.4691696166992, 1.09029269079821, -156.020278930664, -2.72306756722003, 218, 1, 'PPL', 'P'),
(13631, 'Deacons Walk', 39.7249984741211, 0.693332018723137, -75.716667175293, -1.32150514084558, 218, 10, 'PPL', 'P'),
(113118, 'Deaconwood', 41.5016708374023, 0.724340801191583, -72.9222183227539, -1.27273280759019, 218, 8, 'PPL', 'P'),
(29614, 'Dead Mans Crossing', 37.9583282470703, 0.662497806464145, -87.908332824707, -1.53428984773015, 218, 19, 'PPL', 'P'),
(127230, 'Dead River (historical)', 45.0008316040039, 0.785412677625389, -70.5833282470703, -1.23191147492729, 218, 26, 'PPL', 'P'),
(75620, 'Dead Women Crossing', 35.5677795410156, 0.6207748606142, -98.6505584716797, -1.721777054262, 218, 42, 'PPL', 'P'),
(80635, 'Deadfall Crossroads', 34.2058296203613, 0.597004350251507, -81.7030563354492, -1.425987341996, 218, 48, 'PPL', 'P'),
(211780, 'Deadhorse', 70.2055587768555, 1.22531815385853, -148.511672973633, -2.59201767103497, 218, 1, 'PPL', 'P'),
(72285, 'Deadman Crossing', 39.2724990844727, 0.685434414510507, -82.9280624389648, -1.44736773185938, 218, 41, 'PPL', 'P'),
(15755, 'Deadman Landing', 29.2616691589355, 0.510712471452705, -81.5347213745117, -1.42304934268143, 218, 12, 'PPL', 'P'),
(154955, 'Deadmans (historical)', 40.0166702270508, 0.698422651146823, -81.9752807617188, -1.43073855453876, 218, 41, 'PPL', 'P'),
(127232, 'Deadmans Corner', 46.5288887023926, 0.812082305150743, -68.0766677856445, -1.18816199664585, 218, 26, 'PPL', 'P'),
(209401, 'Deadmans Corner', 42.6375007629395, 0.744164773134888, -105.068061828613, -1.83378361759828, 218, 59, 'PPL', 'P'),
(127231, 'Deadwater', 45.1372184753418, 0.787793077586729, -69.8019409179688, -1.21827369330111, 218, 26, 'PPL', 'P'),
(93665, 'Deadwood', 32.139720916748, 0.560943950669344, -94.1416702270508, -1.64308210878875, 218, 51, 'PPL', 'P'),
(193489, 'Deadwood', 40.7194404602051, 0.710688305600374, -122.732498168945, -2.14208619224601, 218, 6, 'PPL', 'P'),
(200674, 'Deadwood', 44.0958290100098, 0.769617402621102, -123.762222290039, -2.1600582685463, 218, 43, 'PPL', 'P'),
(202050, 'Deadwood', 44.3766708374023, 0.77451901718642, -103.72917175293, -1.81041557745532, 218, 49, 'PPL', 'P'),
(181051, 'Deadwood (historical)', 39.6772193908691, 0.692498116406805, -120.85221862793, -2.1092691233974, 218, 6, 'PPL', 'P'),
(46220, 'Deakins Range', 39.079719543457, 0.6820697767893, -77.3019409179688, -1.34917338720068, 218, 25, 'PPL', 'P'),
(13632, 'Deakyneville', 39.3691711425781, 0.687121660219126, -75.5447235107422, -1.31850415777122, 218, 10, 'PPL', 'P'),
(145083, 'Deal', 40.2430610656738, 0.702373916677146, -74.001106262207, -1.29156295439371, 218, 37, 'PPL', 'P'),
(191360, 'Deal', 35.5952796936035, 0.62125482882166, -101.571670532227, -1.77276007753825, 218, 51, 'PPL', 'P'),
(194822, 'Deal', 43.5066719055176, 0.759334671336197, -116.540557861328, -2.03401644679114, 218, 17, 'PPL', 'P'),
(46217, 'Deal Island', 38.1588897705078, 0.665998265400945, -75.9483337402344, -1.32554848517059, 218, 25, 'PPL', 'P'),
(145084, 'Deal Park', 40.2513885498047, 0.702519258693637, -74.0091705322266, -1.29170370245732, 218, 37, 'PPL', 'P'),
(46218, 'Deale', 38.7763900756836, 0.676775678858332, -76.5555572509766, -1.33614653472856, 218, 25, 'PPL', 'P'),
(46219, 'Deale Beach', 38.7819404602051, 0.676872551342984, -76.5386123657227, -1.33585079068951, 218, 25, 'PPL', 'P'),
(20500, 'Deals Landing', 30.8449993133545, 0.538346795793426, -81.6552810668945, -1.4251535062587, 218, 13, 'PPL', 'P'),
(8435, 'Dean', 36.1919403076172, 0.631668521053169, -93.5336074829102, -1.63246941184479, 218, 4, 'PPL', 'P'),
(40028, 'Dean', 32.9066696166992, 0.574329730677382, -92.1508331298828, -1.60833544657233, 218, 22, 'PPL', 'P'),
(54373, 'Dean', 39.8711090087891, 0.695882128624942, -94.831672668457, -1.65512492323809, 218, 29, 'PPL', 'P'),
(64150, 'Dean', 35.214168548584, 0.614603184525023, -83.3597183227539, -1.4549015482671, 218, 33, 'PPL', 'P'),
(86252, 'Dean', 36.3447189331055, 0.634335011094611, -84.353889465332, -1.4722531080334, 218, 50, 'PPL', 'P'),
(93666, 'Dean', 33.9502792358398, 0.59254415463687, -98.345832824707, -1.71645858840705, 218, 51, 'PPL', 'P'),
(108820, 'Dean', 39.6494407653809, 0.692013287930357, -80.5902786254883, -1.40656570711438, 218, 58, 'PPL', 'P'),
(115221, 'Dean', 40.627498626709, 0.709083617885546, -92.7138900756836, -1.61816264415277, 218, 16, 'PPL', 'P'),
(130439, 'Dean', 43.5924987792969, 0.760832632870339, -84.2138900756836, -1.46980965773326, 218, 27, 'PPL', 'P'),
(148222, 'Dean', 42.3230590820313, 0.738676730497534, -79.4347229003906, -1.38639745502116, 218, 40, 'PPL', 'P'),
(160684, 'Dean', 40.621940612793, 0.70898661224284, -78.5008316040039, -1.37009797704349, 218, 45, 'PPL', 'P'),
(181052, 'Dean', 36.5208282470703, 0.637408698466726, -121.461112976074, -2.1198963345693, 218, 6, 'PPL', 'P'),
(196335, 'Dean', 45.4047203063965, 0.792461865293747, -109.689720153809, -1.91444677227514, 218, 31, 'PPL', 'P'),
(72284, 'Dean (historical)', 38.6680603027344, 0.67488496764243, -82.6474990844727, -1.44247097756305, 218, 41, 'PPL', 'P'),
(199903, 'Dean (historical)', 40.4252815246582, 0.705554263650919, -116.855278015137, -2.03950934969748, 218, 39, 'PPL', 'P'),
(54375, 'Dean Ford', 37.8811111450195, 0.66115011379451, -94.3880615234375, -1.64738244815896, 218, 29, 'PPL', 'P'),
(59222, 'Dean Landing', 30.7811107635498, 0.53723173024501, -88.4725036621094, -1.54413648638655, 218, 30, 'PPL', 'P'),
(207179, 'Dean Manor', 48.2174987792969, 0.841554110775077, -122.686393737793, -2.14128151812264, 218, 56, 'PPL', 'P'),
(181053, 'Dean Place', 39.223331451416, 0.684576277428256, -121.779998779297, -2.12546194177341, 218, 6, 'PPL', 'P'),
(8436, 'Dean Springs', 35.5355606079102, 0.62021253415003, -94.1949996948242, -1.64401288358974, 218, 4, 'PPL', 'P'),
(86253, 'Deanburg', 35.4122200012207, 0.618059834461892, -88.8058319091797, -1.54995416178783, 218, 50, 'PPL', 'P'),
(154952, 'Deandale', 40.3091697692871, 0.703527731219423, -80.6166687011719, -1.40702630082491, 218, 41, 'PPL', 'P'),
(528, 'Deane', 37.2386093139648, 0.649936341392513, -82.7733306884766, -1.44466715335598, 218, 21, 'PPL', 'P'),
(8437, 'Deane', 33.5702781677246, 0.585911884837164, -91.6969375610352, -1.60041347443572, 218, 4, 'PPL', 'P'),
(59223, 'Deane (historical)', 31.711669921875, 0.553473051442372, -91.0274963378906, -1.58872952094327, 218, 30, 'PPL', 'P'),
(86254, 'Deane Hill', 35.9291687011719, 0.627082291339944, -84.0194396972656, -1.46641585839811, 218, 50, 'PPL', 'P'),
(35530, 'Deanefield', 37.6594390869141, 0.657281206520897, -86.8069381713867, -1.51506688466584, 218, 21, 'PPL', 'P'),
(101333, 'Deanes', 36.8394393920898, 0.642969511980866, -76.4627838134766, -1.33452733278579, 218, 53, 'PPL', 'P'),
(1998, 'Deans', 33.139720916748, 0.578397243189287, -86.3844375610352, -1.50769285792352, 218, 2, 'PPL', 'P'),
(80638, 'Deans', 34.4019393920898, 0.600427111463504, -82.6877822875977, -1.44317405209083, 218, 48, 'PPL', 'P'),
(86255, 'Deans', 35.7374992370605, 0.623737028115668, -87.4738922119141, -1.52670742863253, 218, 50, 'PPL', 'P'),
(145086, 'Deans', 40.4041709899902, 0.705185815314106, -74.5163879394531, -1.30055631623685, 218, 37, 'PPL', 'P'),
(59224, 'Deans Corner', 34.8752784729004, 0.608688436902012, -90.0777816772461, -1.57215387316056, 218, 30, 'PPL', 'P'),
(148223, 'Deans Corner', 41.3763885498047, 0.722154212778574, -73.6350021362305, -1.28517323199028, 218, 40, 'PPL', 'P'),
(148224, 'Deans Corners', 43.0488891601563, 0.751344855170823, -73.6777801513672, -1.28591984920188, 218, 40, 'PPL', 'P'),
(20501, 'Deans Crossing', 32.0924987792969, 0.560119768890991, -81.9052810668945, -1.42951682938868, 218, 13, 'PPL', 'P'),
(8438, 'Deans Island', 35.4283294677734, 0.618340997693977, -90.0411071777344, -1.57151378239256, 218, 4, 'PPL', 'P'),
(1999, 'Deans Landing', 32.3883285522461, 0.565282972454383, -88.0455627441406, -1.53668496165651, 218, 2, 'PPL', 'P'),
(8439, 'Deans Market', 35.5322189331055, 0.620154210922157, -94.2205581665039, -1.64445896307232, 218, 4, 'PPL', 'P'),
(46222, 'Deans Meadows', 39.0069389343262, 0.68079951552836, -75.914436340332, -1.32495686393443, 218, 25, 'PPL', 'P'),
(64149, 'Deans Mill', 35.2372207641602, 0.615005521586707, -83.4727783203125, -1.45687481747679, 218, 33, 'PPL', 'P'),
(148225, 'Deans Mill', 42.4500007629395, 0.740892280787398, -73.8313903808594, -1.28860085347127, 218, 40, 'PPL', 'P'),
(101334, 'Deans Store', 36.7155609130859, 0.640807424649885, -82.3705596923828, -1.43763747334261, 218, 53, 'PPL', 'P'),
(148226, 'Deansboro', 42.9949989318848, 0.750404293252834, -75.4288864135742, -1.31648241902969, 218, 40, 'PPL', 'P'),
(173762, 'Deansville', 43.1816711425781, 0.75366233795141, -89.1033325195313, -1.55514652696516, 218, 57, 'PPL', 'P'),
(15756, 'Deanville', 29.3427791595459, 0.51212810801965, -81.352783203125, -1.41987392255567, 218, 12, 'PPL', 'P'),
(93668, 'Deanville', 30.4319400787354, 0.531137552143554, -96.7558288574219, -1.68870778405815, 218, 51, 'PPL', 'P'),
(108822, 'Deanville', 38.9897193908691, 0.680498977799344, -80.206672668457, -1.39987052013392, 218, 58, 'PPL', 'P'),
(160686, 'Deanville', 40.9500007629395, 0.714712342007483, -79.3986129760742, -1.38576721794919, 218, 45, 'PPL', 'P'),
(13071, 'Deanwood', 38.8983306884766, 0.678903944043469, -76.9297180175781, -1.34267687203754, 218, 9, 'PPL', 'P'),
(35531, 'Deanwood', 37.3613891601563, 0.652079253963646, -87.9263916015625, -1.53460503284516, 218, 21, 'PPL', 'P'),
(101338, 'Deanwood', 39.0294418334961, 0.681192265210119, -77.3052825927734, -1.34923171042856, 218, 53, 'PPL', 'P'),
(46221, 'Deanwood Park', 38.9058303833008, 0.679034838411046, -76.9236068725586, -1.34257021243589, 218, 25, 'PPL', 'P'),
(93667, 'Deanwright', 31.7363891601563, 0.553904483538965, -95.5425033569336, -1.66753125917623, 218, 51, 'PPL', 'P'),
(8440, 'Deanyville', 33.8619384765625, 0.591002317523768, -93.4991683959961, -1.63186833638676, 218, 4, 'PPL', 'P'),
(40029, 'Dearborn', 32.1819381713867, 0.561680780763941, -91.2786102294922, -1.59311228514922, 218, 22, 'PPL', 'P'),
(54376, 'Dearborn', 39.5219383239746, 0.689787950523486, -94.7697219848633, -1.65404367983552, 218, 29, 'PPL', 'P'),
(130440, 'Dearborn', 42.3222198486328, 0.738662083111539, -83.1763916015625, -1.45170189337543, 218, 27, 'PPL', 'P'),
(196336, 'Dearborn (historical)', 47.1986083984375, 0.823771118912182, -112.090278625488, -1.95634442149259, 218, 31, 'PPL', 'P'),
(130441, 'Dearborn Heights', 42.3369407653809, 0.738919011577704, -83.2733306884766, -1.45339379961595, 218, 27, 'PPL', 'P'),
(181054, 'Dearborn Park', 37.2588882446289, 0.650290275501385, -122.316940307617, -2.13483333933329, 218, 6, 'PPL', 'P'),
(154953, 'Deardoffs Mills (historical)', 40.6352806091309, 0.70921943910114, -81.5591735839844, -1.42347611424611, 218, 41, 'PPL', 'P'),
(160687, 'Deardorffs Mill', 40.0252799987793, 0.698572920011331, -77.0811080932617, -1.34531912731307, 218, 45, 'PPL', 'P'),
(194155, 'Dearfield', 40.2905616760254, 0.703202958724488, -104.258888244629, -1.81966087433759, 218, 7, 'PPL', 'P'),
(20502, 'Dearing', 33.4130592346191, 0.583167896808001, -82.3852767944336, -1.43789433522975, 218, 13, 'PPL', 'P'),
(32213, 'Dearing', 37.0586090087891, 0.646794743412601, -95.7130584716797, -1.67050800748466, 218, 20, 'PPL', 'P'),
(101335, 'Dearington', 37.4116706848145, 0.652956832121854, -79.1627807617188, -1.38165116932642, 218, 53, 'PPL', 'P'),
(8441, 'Dearman', 35.872501373291, 0.626093259890116, -90.0086135864258, -1.57094666223843, 218, 4, 'PPL', 'P'),
(1994, 'DeArmanville', 33.6263885498047, 0.586891195749013, -85.7513885498047, -1.49664406835106, 218, 2, 'PPL', 'P'),
(86247, 'DeArmond', 35.9680595397949, 0.627761064522778, -84.4833297729492, -1.47451226758612, 218, 50, 'PPL', 'P'),
(101336, 'Dearmont Chase', 39.0805587768555, 0.682084424175296, -78.1063919067383, -1.36321370562563, 218, 53, 'PPL', 'P'),
(78122, 'Dearth', 39.9413909912109, 0.697108780623032, -79.7947235107422, -1.39268065098098, 218, 45, 'PPL', 'P'),
(194823, 'Deary', 46.7994384765625, 0.816804289500535, -116.555000305176, -2.03426851498831, 218, 17, 'PPL', 'P'),
(2002, 'Deas', 32.2291717529297, 0.562505162279375, -88.0972213745117, -1.53758657484355, 218, 2, 'PPL', 'P'),
(80636, 'Deas Mill', 34.872501373291, 0.608639967370172, -81.0719375610352, -1.41497224141132, 218, 48, 'PPL', 'P'),
(86256, 'Deason', 35.603328704834, 0.621395310569161, -86.4366683959961, -1.50860445796466, 218, 50, 'PPL', 'P'),
(2004, 'Deason Hill', 33.7477798461914, 0.589009873554226, -87.2249984741211, -1.52236341342044, 218, 2, 'PPL', 'P'),
(59225, 'Deasonville', 32.7922210693359, 0.572332226701768, -90.0927810668945, -1.57241566189572, 218, 30, 'PPL', 'P'),
(181055, 'Death Valley Junction', 36.3022193908691, 0.633593254151997, -116.412780761719, -2.0317863156943, 218, 6, 'PPL', 'P'),
(101337, 'Deatonville', 37.3280601501465, 0.651497553002545, -78.1686096191406, -1.36429960956011, 218, 53, 'PPL', 'P'),
(40030, 'Deats (historical)', 30.9658298492432, 0.540455686481633, -92.0969390869141, -1.60739481807531, 218, 22, 'PPL', 'P'),
(2003, 'Deatsville', 32.6080589294434, 0.569117991003124, -86.3958282470703, -1.5078916628989, 218, 2, 'PPL', 'P'),
(35532, 'Deatsville', 37.8969383239746, 0.661426350178578, -85.5591735839844, -1.49328928432588, 218, 21, 'PPL', 'P'),
(209402, 'Deaver', 44.8886108398438, 0.78345405580169, -108.597221374512, -1.89537907150239, 218, 59, 'PPL', 'P'),
(64154, 'Deaver View', 35.5811080932617, 0.621007487735419, -82.623893737793, -1.44205898654241, 218, 33, 'PPL', 'P'),
(2005, 'Deavers Town', 33.9230613708496, 0.592069113277427, -86.5875015258789, -1.5112369927022, 218, 2, 'PPL', 'P'),
(72286, 'Deavertown', 39.7341690063477, 0.69349207470465, -82.0380630493164, -1.43183431216927, 218, 41, 'PPL', 'P'),
(2006, 'Debardeleben', 33.7958297729492, 0.589848502981492, -87.0055618286133, -1.5185335214568, 218, 2, 'PPL', 'P'),
(211779, 'DeBarr Vista', 61.2122192382813, 1.06835476816062, -149.753067016602, -2.61368408439942, 218, 1, 'PPL', 'P'),
(15753, 'DeBary', 28.8827800750732, 0.504099609439443, -81.3088912963867, -1.41910786426811, 218, 12, 'PPL', 'P'),
(8442, 'Deberrie', 34.9408302307129, 0.60983253090631, -93.0149993896484, -1.62341799308988, 218, 4, 'PPL', 'P'),
(93661, 'DeBerry', 32.3031692504883, 0.563796662250009, -94.1664962768555, -1.64351540509811, 218, 51, 'PPL', 'P'),
(86257, 'Deberry Subdivision', 36.2138900756836, 0.632051616775977, -85.4783325195313, -1.49187834158036, 218, 50, 'PPL', 'P'),
(127233, 'Deblois', 44.7413902282715, 0.780884571402955, -68.0152816772461, -1.18709060693932, 218, 26, 'PPL', 'P'),
(141635, 'Debolt', 41.3236083984375, 0.721233025357515, -96.0113906860352, -1.67571488688993, 218, 35, 'PPL', 'P'),
(35533, 'Debord', 37.8263893127441, 0.66019503764858, -82.5513916015625, -1.44079358555046, 218, 21, 'PPL', 'P'),
(80634, 'DeBordieu', 33.3688888549805, 0.58239697825145, -79.1519393920898, -1.38146195173097, 218, 48, 'PPL', 'P'),
(8443, 'Debrow (historical)', 36.3424987792969, 0.634296262100751, -90.9091720581055, -1.58666437267597, 218, 4, 'PPL', 'P'),
(20492, 'DeBruce', 33.3519401550293, 0.582101167633369, -82.0502777099609, -1.43204749821453, 218, 13, 'PPL', 'P'),
(148227, 'Debruce', 41.9136085510254, 0.731530470607443, -74.7275009155273, -1.30424093276303, 218, 40, 'PPL', 'P'),
(64152, 'Debruhls Landing', 35.0555610656738, 0.61183496172994, -77.1811065673828, -1.34706442993345, 218, 33, 'PPL', 'P'),
(134950, 'Debs', 47.7313919067383, 0.833069945332357, -95.1277770996094, -1.66029292049145, 218, 28, 'PPL', 'P'),
(86248, 'DeBusk', 36.1041717529297, 0.630136670794156, -82.8791732788086, -1.44651445504611, 218, 50, 'PPL', 'P'),
(101343, 'Debusk (historical)', 37.0611114501953, 0.646838419254479, -82.2811126708984, -1.4360763283116, 218, 53, 'PPL', 'P'),
(181045, 'DeCamp', 39.4402809143066, 0.68836275986613, -123.355003356934, -2.15295095738715, 218, 6, 'PPL', 'P'),
(101339, 'Decapolis', 38.4422187805176, 0.670943289492031, -78.2383270263672, -1.36551640786217, 218, 53, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(2007, 'Decatur', 34.6058311462402, 0.603985693891095, -86.9833297729492, -1.51814549888598, 218, 2, 'PPL', 'P'),
(8444, 'Decatur', 36.3358306884766, 0.634179881961114, -94.460563659668, -1.64864784915091, 218, 4, 'PPL', 'P'),
(20503, 'Decatur', 33.7747192382813, 0.589480054644679, -84.29638671875, -1.47124949577661, 218, 13, 'PPL', 'P'),
(26923, 'Decatur', 39.8402786254883, 0.695344036926691, -88.954719543457, -1.55255274122147, 218, 18, 'PPL', 'P'),
(35534, 'Decatur', 37.1252784729004, 0.647958345071884, -84.9980621337891, -1.48349604204934, 218, 21, 'PPL', 'P'),
(54378, 'Decatur', 38.4524993896484, 0.671122719970475, -92.4197235107422, -1.61302846904526, 218, 29, 'PPL', 'P'),
(59226, 'Decatur', 32.4388885498047, 0.56616541088158, -89.1083297729492, -1.55523374549086, 218, 30, 'PPL', 'P'),
(72292, 'Decatur', 38.815559387207, 0.677459312310155, -83.7038879394531, -1.46090844126383, 218, 41, 'PPL', 'P'),
(86258, 'Decatur', 35.514720916748, 0.619848812924152, -84.790283203125, -1.47986961559298, 218, 50, 'PPL', 'P'),
(93669, 'Decatur', 33.2341690063477, 0.580045673325019, -97.5858306884766, -1.70319404880764, 218, 51, 'PPL', 'P'),
(101340, 'Decatur', 37.8763885498047, 0.661067688958772, -79.3358306884766, -1.38467146031868, 218, 53, 'PPL', 'P'),
(122481, 'Decatur', 40.8305587768555, 0.712627686085197, -84.9291687011719, -1.48229362481717, 218, 19, 'PPL', 'P'),
(130446, 'Decatur', 42.1080589294434, 0.734924269942585, -85.9744415283203, -1.50053707723254, 218, 27, 'PPL', 'P'),
(141636, 'Decatur', 42.0074996948242, 0.733169180205196, -96.2494430541992, -1.67986968450656, 218, 35, 'PPL', 'P'),
(148228, 'Decatur', 42.6441688537598, 0.744281153274524, -74.7255630493164, -1.30420711061719, 218, 40, 'PPL', 'P'),
(160688, 'Decatur', 40.6941719055176, 0.710247286123857, -77.4541702270508, -1.3518302898622, 218, 45, 'PPL', 'P'),
(207180, 'Decatur', 48.500560760498, 0.846494474334256, -122.818328857422, -2.14358422035918, 218, 56, 'PPL', 'P'),
(101341, 'Decatur (historical)', 38.4544410705566, 0.671156608695346, -77.3466720581055, -1.34995409287424, 218, 53, 'PPL', 'P'),
(115222, 'Decatur City', 40.7419395446777, 0.711080988703106, -93.833610534668, -1.63770545286399, 218, 16, 'PPL', 'P'),
(86261, 'Decatur Hills', 35.5313911437988, 0.620139763273243, -84.8002777099609, -1.48004405264438, 218, 50, 'PPL', 'P'),
(2008, 'Decatur Junction', 34.6266708374023, 0.604349415116973, -86.970832824707, -1.5179273859927, 218, 2, 'PPL', 'P'),
(54379, 'Decaturville', 37.9075012207031, 0.661610707505039, -92.6997222900391, -1.61791536964556, 218, 29, 'PPL', 'P'),
(72289, 'Decaturville', 39.3347206115723, 0.686520385024014, -81.754997253418, -1.42689388203106, 218, 41, 'PPL', 'P'),
(86262, 'Decaturville', 35.584171295166, 0.621060950694302, -88.1194381713867, -1.53797433109827, 218, 50, 'PPL', 'P'),
(160691, 'Decaturville', 40.9150009155273, 0.714101479432447, -78.2616729736328, -1.36592387150895, 218, 45, 'PPL', 'P'),
(101342, 'Decca (historical)', 38.1027793884277, 0.665018954489095, -78.6011123657227, -1.37184820651189, 218, 53, 'PPL', 'P'),
(86263, 'Decherd', 35.2097206115723, 0.614525553379248, -86.0794372558594, -1.50236959837862, 218, 50, 'PPL', 'P'),
(35535, 'Decide', 36.7733306884766, 0.641815697438589, -85.2041702270508, -1.48709330689176, 218, 21, 'PPL', 'P'),
(148229, 'Deck', 42.9502792358398, 0.749623787316359, -74.8805618286133, -1.30691234965249, 218, 40, 'PPL', 'P'),
(160692, 'Deckard', 41.5244407653809, 0.72473821140525, -79.975830078125, -1.3958415568788, 218, 45, 'PPL', 'P'),
(54380, 'Deckard-Y', 36.5461082458496, 0.637849917680325, -91.2538909912109, -1.59268085305262, 218, 29, 'PPL', 'P'),
(29617, 'Decker', 38.5188903808594, 0.672281461360769, -87.523063659668, -1.5275656322938, 218, 19, 'PPL', 'P'),
(35536, 'Decker', 37.3352813720703, 0.651623587101133, -86.4855575561523, -1.50945773477792, 218, 21, 'PPL', 'P'),
(72290, 'Decker', 39.7594413757324, 0.693933160760195, -81.1908264160156, -1.41704724337466, 218, 41, 'PPL', 'P'),
(93670, 'Decker', 30.3063907623291, 0.528946303198637, -97.6175003051758, -1.70374678789189, 218, 51, 'PPL', 'P'),
(130445, 'Decker', 43.4588890075684, 0.758500702440839, -83.0508270263672, -1.4495103781144, 218, 27, 'PPL', 'P'),
(173764, 'Decker', 43.4705581665039, 0.758704367685203, -87.8625030517578, -1.53348996729674, 218, 57, 'PPL', 'P'),
(196337, 'Decker', 45.0119400024414, 0.785606555752747, -106.862777709961, -1.86510731886562, 218, 31, 'PPL', 'P'),
(8446, 'Decker (historical)', 33.4888916015625, 0.584491421290743, -91.4394378662109, -1.59591925693816, 218, 4, 'PPL', 'P'),
(29619, 'Decker Chapel', 38.4894409179688, 0.671767471270383, -87.5369415283203, -1.52780784679495, 218, 19, 'PPL', 'P'),
(127235, 'Decker Corner', 44.6933288574219, 0.780045742238607, -69.5869369506836, -1.21452116616713, 218, 26, 'PPL', 'P'),
(173765, 'Decker Corner', 43.351390838623, 0.756624505452878, -88.0449981689453, -1.53667510796047, 218, 57, 'PPL', 'P'),
(93671, 'Decker Prairie', 30.1308307647705, 0.525882203206446, -95.6522216796875, -1.66944620515805, 218, 51, 'PPL', 'P'),
(186608, 'Deckers', 39.2547187805176, 0.685124089664485, -105.226387023926, -1.83654691354534, 218, 7, 'PPL', 'P'),
(160693, 'Deckers Point', 40.7611083984375, 0.711415548315047, -78.9800033569336, -1.37846110181467, 218, 45, 'PPL', 'P'),
(148232, 'Deckertown', 41.9249992370605, 0.731729275582817, -74.8330612182617, -1.30608330760515, 218, 40, 'PPL', 'P'),
(160694, 'Deckertown', 41.6599998474121, 0.727104163717677, -75.8277816772461, -1.32344445475137, 218, 45, 'PPL', 'P'),
(8447, 'Deckerville', 35.4449996948242, 0.618631948043068, -90.3050003051758, -1.5761195863398, 218, 4, 'PPL', 'P'),
(130447, 'Deckerville', 43.526668548584, 0.759683678597052, -82.7352828979492, -1.44400309413817, 218, 27, 'PPL', 'P'),
(207181, 'Deckerville', 47.2275009155273, 0.824275388464588, -123.473609924316, -2.15502103250247, 218, 56, 'PPL', 'P'),
(181056, 'Declez', 34.0652809143066, 0.594551312571435, -117.483612060547, -2.05047584759226, 218, 6, 'PPL', 'P'),
(181057, 'Declezville', 34.0444412231445, 0.594187591345558, -117.480560302734, -2.05042258437046, 218, 6, 'PPL', 'P'),
(154948, 'DeCliff', 40.6074981689453, 0.708734544045664, -83.3422164916992, -1.45459608369007, 218, 41, 'PPL', 'P'),
(194824, 'Declo', 42.5183296203613, 0.742084844323536, -113.627220153809, -1.98316911157242, 218, 17, 'PPL', 'P'),
(40025, 'DeClouet', 30.3344402313232, 0.529435858786021, -91.9186096191406, -1.60428238170934, 218, 22, 'PPL', 'P'),
(54381, 'Deco', 36.1699981689453, 0.631285558488416, -89.9319381713867, -1.56960842379067, 218, 29, 'PPL', 'P'),
(93672, 'Deco', 29.9672203063965, 0.523026662017123, -95.5386123657227, -1.66746334856843, 218, 51, 'PPL', 'P'),
(20505, 'Decora', 34.5791702270508, 0.603520373069631, -84.8627777099609, -1.48113488342687, 218, 13, 'PPL', 'P'),
(115225, 'Decorah', 43.3033294677734, 0.75578567628853, -91.7855606079102, -1.60196023839684, 218, 16, 'PPL', 'P'),
(173766, 'Decorah Beach', 43.922779083252, 0.766597111628843, -88.4749984741211, -1.54418002907037, 218, 57, 'PPL', 'P'),
(93662, 'DeCordova', 32.4297218322754, 0.566005421479094, -97.6947174072266, -1.70509448056152, 218, 51, 'PPL', 'P'),
(119338, 'Decorra', 40.7277793884277, 0.710833847353947, -90.9700012207031, -1.58772604184453, 218, 18, 'PPL', 'P'),
(160695, 'Decorum', 40.100830078125, 0.699891517646056, -77.8574981689453, -1.35886969041355, 218, 45, 'PPL', 'P'),
(108824, 'Decota', 38.0177803039551, 0.663535440603867, -81.4208297729492, -1.42106155924379, 218, 58, 'PPL', 'P'),
(35528, 'DeCoursey', 39.0077781677246, 0.680814162914355, -84.4875030517578, -1.47458510504193, 218, 21, 'PPL', 'P'),
(35537, 'Decoy', 37.4955596923828, 0.654420971510152, -83.0941696166992, -1.45026684902204, 218, 21, 'PPL', 'P'),
(199904, 'Decoy', 40.6716690063477, 0.709854536442097, -114.486938476563, -1.9981740269442, 218, 39, 'PPL', 'P'),
(154954, 'Decrow Corners', 40.1936111450195, 0.701510852746879, -82.5991668701172, -1.44162742128776, 218, 41, 'PPL', 'P'),
(59227, 'Dedeaux', 30.4986095428467, 0.532301153802837, -89.3394393920898, -1.55926736927789, 218, 30, 'PPL', 'P'),
(54382, 'Dederick', 37.8572196960449, 0.660733129346831, -94.1275024414063, -1.64283483428154, 218, 29, 'PPL', 'P'),
(115227, 'Dedham', 41.9061088562012, 0.731399576239865, -94.8219375610352, -1.65495501356055, 218, 16, 'PPL', 'P'),
(124628, 'Dedham', 42.2416687011719, 0.737256200372086, -71.1666717529297, -1.24209273977467, 218, 23, 'PPL', 'P'),
(127236, 'Dedham', 44.6916694641113, 0.780016780361752, -68.6624984741211, -1.198386671019, 218, 26, 'PPL', 'P'),
(173767, 'Dedham', 46.5422210693359, 0.812314998850988, -92.1977767944336, -1.60915476808169, 218, 57, 'PPL', 'P'),
(124629, 'Dedham Island', 42.2666702270508, 0.737692559316695, -71.1777801513672, -1.24228661790203, 218, 23, 'PPL', 'P'),
(20506, 'Dedrich', 32.8525009155273, 0.573384308490404, -83.2294387817383, -1.45262774132839, 218, 13, 'PPL', 'P'),
(193490, 'Dedrick', 40.8627815246582, 0.713190079128394, -123.03556060791, -2.14737562964507, 218, 6, 'PPL', 'P'),
(59228, 'Dedwylder', 31.9575004577637, 0.557763603695571, -88.8055572509766, -1.54994936809787, 218, 30, 'PPL', 'P'),
(160696, 'Dee', 40.935001373291, 0.714450553272329, -79.4436111450195, -1.38655258415465, 218, 45, 'PPL', 'P'),
(200675, 'Dee', 45.5883293151855, 0.79566644703344, -121.625556945801, -2.12276642327608, 218, 43, 'PPL', 'P'),
(122482, 'Deedsville', 40.9102783203125, 0.714019054596709, -86.1011123657227, -1.50274790041146, 218, 19, 'PPL', 'P'),
(160697, 'Deegan', 41.1252784729004, 0.717771515151657, -79.8791732788086, -1.39415457748628, 218, 45, 'PPL', 'P'),
(108823, 'Deegans', 38.1527786254883, 0.665891605799287, -80.9458312988281, -1.41277127192843, 218, 58, 'PPL', 'P'),
(101344, 'Deel', 37.2361106872559, 0.649892732129663, -82.0883331298828, -1.4327116905904, 218, 53, 'PPL', 'P'),
(15757, 'Deem City', 26.3377799987793, 0.459680978644607, -80.5411071777344, -1.4057075034531, 218, 12, 'PPL', 'P'),
(59229, 'Deemer', 32.7452812194824, 0.571512971771432, -89.1180572509766, -1.55540352201035, 218, 30, 'PPL', 'P'),
(160698, 'Deemers Crossroads', 41.1186103820801, 0.717655135012021, -78.9280624389648, -1.3775545617796, 218, 45, 'PPL', 'P'),
(72291, 'Deems (historical)', 39.9541702270508, 0.697331820364327, -83.1166687011719, -1.45065953212477, 218, 41, 'PPL', 'P'),
(160699, 'Deemston', 40.0258293151855, 0.698582507391255, -80.0305633544922, -1.39679683276181, 218, 45, 'PPL', 'P'),
(59230, 'Deen', 31.5533294677734, 0.550709489179196, -89.6780624389648, -1.56517745636899, 218, 30, 'PPL', 'P'),
(20507, 'Deenwood', 31.2216701507568, 0.544920942102341, -82.3855590820313, -1.43789926207776, 218, 13, 'PPL', 'P'),
(101345, 'Deep Bottom', 37.4066696166992, 0.652869547017127, -77.3097229003906, -1.34930920841628, 218, 53, 'PPL', 'P'),
(46223, 'Deep Branch', 38.3144416809082, 0.668713158395199, -75.8258285522461, -1.32341036628942, 218, 25, 'PPL', 'P'),
(13633, 'Deep Branch Farm', 39.4258308410645, 0.6881105585109, -75.710563659668, -1.32139861440197, 218, 10, 'PPL', 'P'),
(15759, 'Deep Creek', 30.3727798461914, 0.530105011299417, -82.6230621337891, -1.44204447231447, 218, 12, 'PPL', 'P'),
(35538, 'Deep Creek', 37.6958312988281, 0.657916370440881, -85.0227813720703, -1.48392747414593, 218, 21, 'PPL', 'P'),
(59231, 'Deep Creek', 30.9197196960449, 0.539650912489724, -88.916389465332, -1.55188375515564, 218, 30, 'PPL', 'P'),
(64155, 'Deep Creek', 34.8527793884277, 0.60829575379928, -80.1588897705078, -1.39903655123856, 218, 33, 'PPL', 'P'),
(101348, 'Deep Creek', 37.0825004577637, 0.64721172786028, -76.5149993896484, -1.33543866651082, 218, 53, 'PPL', 'P'),
(199906, 'Deep Creek', 41.5672187805176, 0.725484828616854, -116.14778137207, -2.02716120382916, 218, 39, 'PPL', 'P'),
(207182, 'Deep Creek', 47.6430587768555, 0.83152824137731, -117.711112976074, -2.05444648761952, 218, 56, 'PPL', 'P'),
(209859, 'Deep Creek', 42.5936088562012, 0.743398714847326, -114.845283508301, -2.00442832760619, 218, 17, 'PPL', 'P'),
(196338, 'Deep Creek (historical)', 46.3222198486328, 0.808475253191312, -111.422218322754, -1.94468456960801, 218, 31, 'PPL', 'P'),
(200676, 'Deep Creek (historical)', 45.3863906860352, 0.792141953067801, -122.39582824707, -2.13621019361686, 218, 43, 'PPL', 'P'),
(20508, 'Deep Creek Acres', 33.6313896179199, 0.58697848085374, -84.5986099243164, -1.47652428578967, 218, 13, 'PPL', 'P'),
(127238, 'Deep Cut', 43.9102783203125, 0.766378932156538, -70.0149993896484, -1.22199226513119, 218, 26, 'PPL', 'P'),
(101350, 'Deep Dell', 37.2924995422363, 0.650876903310502, -80.0938873291016, -1.39790204461419, 218, 53, 'PPL', 'P'),
(8449, 'Deep Elm', 33.4911117553711, 0.584530170284603, -91.3994369506836, -1.59522110925839, 218, 4, 'PPL', 'P'),
(54384, 'Deep Ford', 36.6097183227539, 0.638960122959752, -94.3511123657227, -1.646737563701, 218, 29, 'PPL', 'P'),
(46224, 'Deep Harbor', 38.7319412231445, 0.675999900032792, -76.3313903808594, -1.33223408477112, 218, 25, 'PPL', 'P'),
(46225, 'Deep Harbor Estates', 38.5277786254883, 0.672436590494266, -76.1672210693359, -1.32936878975431, 218, 25, 'PPL', 'P'),
(46226, 'Deep Harbour', 38.3013916015625, 0.66848539154297, -75.5805587768555, -1.31912960115323, 218, 25, 'PPL', 'P'),
(46227, 'Deep Harbour Farm Estates', 38.7319412231445, 0.675999900032792, -76.3272171020508, -1.33216124731531, 218, 25, 'PPL', 'P'),
(101351, 'Deep Hole', 37.9372215270996, 0.662129424706359, -75.3536071777344, -1.3151685485059, 218, 53, 'PPL', 'P'),
(199907, 'Deep Hole', 40.7191696166992, 0.710683578489439, -119.482223510742, -2.08535819786623, 218, 39, 'PPL', 'P'),
(15760, 'Deep Lake', 26.0422191619873, 0.454522468902637, -81.3441696166992, -1.41972358711214, 218, 12, 'PPL', 'P'),
(8450, 'Deep Landing', 35.746940612793, 0.623901811208117, -90.4216690063477, -1.57815583930928, 218, 4, 'PPL', 'P'),
(46231, 'Deep Landing', 38.5961112976074, 0.673629220609431, -76.6691665649414, -1.33812939131818, 218, 25, 'PPL', 'P'),
(46230, 'Deep Landing Estates', 38.5902786254883, 0.673527421276762, -76.6694412231445, -1.33813418500814, 218, 25, 'PPL', 'P'),
(64158, 'Deep River', 36.0302810668945, 0.628847035036285, -79.9686126708984, -1.39571558935923, 218, 33, 'PPL', 'P'),
(113124, 'Deep River', 41.3855590820313, 0.722314268760087, -72.4361114501953, -1.26424864214747, 218, 8, 'PPL', 'P'),
(115229, 'Deep River', 41.5802803039551, 0.725712795206165, -92.3747177124023, -1.61224296968175, 218, 16, 'PPL', 'P'),
(122483, 'Deep River', 41.4755592346191, 0.723885067750043, -87.2233276367188, -1.52233425180651, 218, 19, 'PPL', 'P'),
(207183, 'Deep River', 46.3486099243164, 0.808935846901841, -123.683891296387, -2.15869113480071, 218, 56, 'PPL', 'P'),
(46232, 'Deep Run', 39.685001373291, 0.692633937622399, -76.9899978637695, -1.34372895382618, 218, 25, 'PPL', 'P'),
(64159, 'Deep Run', 35.1452789306641, 0.61340083387188, -77.7041702270508, -1.35619361299219, 218, 33, 'PPL', 'P'),
(160701, 'Deep Run', 40.4077796936035, 0.705248799073887, -75.1738891601563, -1.312031877374, 218, 45, 'PPL', 'P'),
(46233, 'Deep Run Park', 39.1908302307129, 0.684009024116069, -76.7888870239258, -1.34021890750945, 218, 25, 'PPL', 'P'),
(35539, 'Deep Springs', 38.063060760498, 0.664325733657348, -84.4447174072266, -1.47383835467227, 218, 21, 'PPL', 'P'),
(64161, 'Deep Springs', 36.4141693115234, 0.635547148864761, -79.878059387207, -1.39413513641033, 218, 33, 'PPL', 'P'),
(86266, 'Deep Springs', 35.9902801513672, 0.628148887356521, -83.5166702270508, -1.45764087576436, 218, 50, 'PPL', 'P'),
(101352, 'Deep Springs', 36.7833290100098, 0.641990201069017, -82.866943359375, -1.44630100268474, 218, 53, 'PPL', 'P'),
(181058, 'Deep Springs', 37.3716697692871, 0.65225868444209, -117.984169006348, -2.05921221439021, 218, 6, 'PPL', 'P'),
(188407, 'Deep Tunnel (historical)', 36.6391716003418, 0.639474179629164, -105.204719543457, -1.83616874467055, 218, 38, 'PPL', 'P'),
(46234, 'Deep Valley', 39.4883308410645, 0.689201389293396, -76.9741668701172, -1.34345265086308, 218, 25, 'PPL', 'P'),
(78123, 'Deep Valley', 39.7547187805176, 0.693850735924457, -80.4697189331055, -1.40446154353711, 218, 45, 'PPL', 'P'),
(108826, 'Deep Valley', 39.3386116027832, 0.686588295631811, -80.8438873291016, -1.41099201400415, 218, 58, 'PPL', 'P'),
(108827, 'Deep Water', 38.1266708374023, 0.665435938936775, -81.2638931274414, -1.41832249806264, 218, 58, 'PPL', 'P'),
(93673, 'Deep Water Point Estates', 33.0566711425781, 0.576947751186984, -96.4519424438477, -1.68340396558921, 218, 51, 'PPL', 'P'),
(93674, 'Deep Well Crossing', 33.3066711425781, 0.58131107431697, -95.6949996948242, -1.67019282236965, 218, 51, 'PPL', 'P'),
(101353, 'Deep Woods', 37.8486099243164, 0.660582860482323, -77.9633331298828, -1.36071685894563, 218, 53, 'PPL', 'P'),
(134952, 'Deephaven', 44.9297218322754, 0.784171577978385, -93.522216796875, -1.63227060686941, 218, 28, 'PPL', 'P'),
(143700, 'Deephaven', 43.769718170166, 0.763925694739385, -71.5391693115234, -1.24859404862777, 218, 36, 'PPL', 'P'),
(20510, 'Deepstep', 33.0180587768555, 0.57627383827314, -82.9691696166992, -1.44808518745704, 218, 13, 'PPL', 'P'),
(54385, 'Deepwater', 38.2605590820313, 0.667772729635265, -93.7727813720703, -1.63664378369543, 218, 29, 'PPL', 'P'),
(70721, 'Deepwater', 39.6833305358887, 0.692604776008463, -75.4908294677734, -1.3175635292742, 218, 37, 'PPL', 'P'),
(108828, 'Deepwell', 38.2341690063477, 0.667312135924735, -80.7566680908203, -1.40946975112506, 218, 58, 'PPL', 'P'),
(8451, 'Deer', 35.8266716003418, 0.62529337945671, -93.2091674804688, -1.62680686557701, 218, 4, 'PPL', 'P'),
(54387, 'Deer', 38.621940612793, 0.674080027202954, -91.7966690063477, -1.6021541165242, 218, 29, 'PPL', 'P'),
(188408, 'Deer', 31.3822193145752, 0.547723053622295, -108.629997253418, -1.89595111850454, 218, 38, 'PPL', 'P'),
(70724, 'Deer Chase Manor', 39.9680595397949, 0.697574234602551, -74.2236099243164, -1.29544637589526, 218, 37, 'PPL', 'P'),
(8452, 'Deer Creek', 34.2438888549805, 0.5976686092064, -92.4033279418945, -1.61274231238614, 218, 4, 'PPL', 'P'),
(13634, 'Deer Creek', 38.7916717529297, 0.677042394441503, -75.5905609130859, -1.31930417136268, 218, 10, 'PPL', 'P'),
(46235, 'Deer Creek', 39.0400009155273, 0.681376555957553, -76.4591674804688, -1.33446421586796, 218, 25, 'PPL', 'P'),
(75622, 'Deer Creek', 36.8058280944824, 0.642382884171749, -97.519172668457, -1.70203064688544, 218, 42, 'PPL', 'P'),
(93675, 'Deer Creek', 33.6363906860352, 0.587065765958468, -98.2872161865234, -1.7154355350743, 218, 51, 'PPL', 'P'),
(101354, 'Deer Creek', 37.3186111450195, 0.651332636752042, -79.2291717529297, -1.38280991071671, 218, 53, 'PPL', 'P'),
(108829, 'Deer Creek', 38.3863906860352, 0.669968905428198, -79.9252777099609, -1.39495925160965, 218, 58, 'PPL', 'P'),
(115231, 'Deer Creek', 43.499439239502, 0.759208437500527, -93.1266708374023, -1.62536702753366, 218, 16, 'PPL', 'P'),
(119340, 'Deer Creek', 40.6300010681152, 0.709127293727424, -89.3324966430664, -1.55914619544829, 218, 18, 'PPL', 'P'),
(122486, 'Deer Creek', 41.4205589294434, 0.722925131335124, -87.258056640625, -1.52294038727061, 218, 19, 'PPL', 'P'),
(130449, 'Deer Creek', 42.7599983215332, 0.746302758858003, -83.9072189331055, -1.46445723657441, 218, 27, 'PPL', 'P'),
(134954, 'Deer Creek', 46.3911094665527, 0.809677603844455, -95.3211135864258, -1.66366727875063, 218, 28, 'PPL', 'P'),
(178062, 'Deer Creek', 33.5833282470703, 0.586139651689393, -112.217498779297, -1.95856483205145, 218, 5, 'PPL', 'P'),
(193491, 'Deer Creek', 40.2599983215332, 0.702669527558145, -121.391937255859, -2.11868899048912, 218, 6, 'PPL', 'P'),
(181059, 'Deer Creek Colony', 35.978328704834, 0.62794029526414, -118.999168395996, -2.07692729564531, 218, 6, 'PPL', 'P'),
(40033, 'Deer Creek Estates', 32.4555587768555, 0.566456361230672, -93.8902816772461, -1.63869455089285, 218, 22, 'PPL', 'P'),
(46236, 'Deer Creek Estates', 39.6022186279297, 0.691189106152004, -76.1833267211914, -1.32964988640737, 218, 25, 'PPL', 'P'),
(188411, 'Deer Creek Landing', 35.7441711425781, 0.623853474834332, -106.774169921875, -1.86356082122062, 218, 38, 'PPL', 'P'),
(181060, 'Deer Creek Park', 39.2583312988281, 0.685187140003293, -120.946113586426, -2.11090789957418, 218, 6, 'PPL', 'P'),
(8453, 'Deer Creek Subdivision', 34.9902801513672, 0.610695594836577, -92.0550003051758, -1.6066628482497, 218, 4, 'PPL', 'P'),
(72293, 'Deer Creek Village (historical)', 39.9688911437988, 0.697588748830492, -83.477783203125, -1.45696216916055, 218, 41, 'PPL', 'P'),
(178063, 'Deer Creek Village Subdivision', 34.0652809143066, 0.594551312571435, -111.355560302734, -1.94352116768581, 218, 5, 'PPL', 'P'),
(188409, 'Deer Creek Wells', 31.434440612793, 0.548634487215861, -108.690559387207, -1.89700812714119, 218, 38, 'PPL', 'P'),
(46237, 'Deer Cross', 39.4305610656738, 0.688193116504692, -76.8566665649414, -1.34140188366567, 218, 25, 'PPL', 'P'),
(46238, 'Deer Crossing', 38.5583305358887, 0.672969821923527, -76.5500030517578, -1.33604959566488, 218, 25, 'PPL', 'P'),
(181061, 'Deer Crossing', 36.689998626709, 0.64036127858827, -119.047782897949, -2.07777577876861, 218, 6, 'PPL', 'P'),
(20511, 'Deer Glen Forest', 33.4713897705078, 0.584185956713711, -84.4186096191406, -1.47338268780976, 218, 13, 'PPL', 'P'),
(119342, 'Deer Grove', 41.607780456543, 0.726192763413624, -89.6894378662109, -1.56537599502826, 218, 18, 'PPL', 'P'),
(46240, 'Deer Haven', 39.538890838623, 0.690083827720594, -75.8455581665039, -1.32375471301837, 218, 25, 'PPL', 'P'),
(101355, 'Deer Haven', 38.8916702270508, 0.678787697061887, -78.2130584716797, -1.36507538838565, 218, 53, 'PPL', 'P'),
(181063, 'Deer Haven', 34.4083290100098, 0.600538631334151, -117.597221374512, -2.05245870418188, 218, 6, 'PPL', 'P'),
(2010, 'Deer Head Cove', 34.7724990844727, 0.606894598170762, -85.5827789306641, -1.49370127534652, 218, 2, 'PPL', 'P'),
(40032, 'Deer Island', 30.228889465332, 0.527593650391472, -89.668327331543, -1.56500754669145, 218, 22, 'PPL', 'P'),
(200677, 'Deer Island', 45.9313888549805, 0.801653965533237, -122.842498779297, -2.14400606507585, 218, 43, 'PPL', 'P'),
(127239, 'Deer Isle', 44.2238883972168, 0.771852460565951, -68.6780624389648, -1.19865831345018, 218, 26, 'PPL', 'P'),
(119343, 'Deer Lake', 42.1502799987793, 0.73566116661621, -88.0997161865234, -1.53763011752738, 218, 18, 'PPL', 'P'),
(160703, 'Deer Lake', 40.625, 0.709040008622696, -76.0608291625977, -1.32751190068425, 218, 45, 'PPL', 'P'),
(188410, 'Deer Lake', 35.9961090087891, 0.628250620110162, -106.858612060547, -1.86503461456787, 218, 38, 'PPL', 'P'),
(181062, 'Deer Lake Highlands', 34.2838897705078, 0.598366756886164, -118.595832824707, -2.0698877619359, 218, 6, 'PPL', 'P'),
(70722, 'Deer Lake Park', 39.7013893127441, 0.692919961123474, -74.2600021362305, -1.29608153981524, 218, 37, 'PPL', 'P'),
(54391, 'Deer Land', 36.1613883972168, 0.631135289623908, -90.0041732788086, -1.57086916425071, 218, 29, 'PPL', 'P'),
(134958, 'Deer Lane', 47.0400009155273, 0.821002896117099, -94.977783203125, -1.6576750331399, 218, 28, 'PPL', 'P'),
(35541, 'Deer Lick', 37.146671295166, 0.648331720256713, -83.9438934326172, -1.46509732734241, 218, 21, 'PPL', 'P'),
(78125, 'Deer Lick', 39.9813919067383, 0.697806928302797, -80.279167175293, -1.40113578796782, 218, 45, 'PPL', 'P'),
(154956, 'Deer Lick (historical)', 41.6175003051758, 0.726362406775062, -84.5744400024414, -1.476102441073, 218, 41, 'PPL', 'P'),
(86267, 'Deer Lodge', 36.2013893127441, 0.631833437303672, -84.7591705322266, -1.47932659704671, 218, 50, 'PPL', 'P'),
(196339, 'Deer Lodge', 46.3958282470703, 0.809759962101166, -112.72917175293, -1.96749521013481, 218, 31, 'PPL', 'P'),
(190107, 'Deer Lodge (historical)', 37.9308280944824, 0.662017838256685, -114.073059082031, -1.99095046880347, 218, 39, 'PPL', 'P'),
(46241, 'Deer Lodge Mobile Home Park', 39.6541709899902, 0.692095845924149, -77.8319396972656, -1.35842361093096, 218, 25, 'PPL', 'P'),
(203696, 'Deer Lodge Summer Home Area', 40.7638893127441, 0.711464084425914, -109.475280761719, -1.9107040988372, 218, 52, 'PPL', 'P'),
(46242, 'Deer Meadows', 39.6519393920898, 0.692056897193207, -76.4894409179688, -1.33499258702823, 218, 25, 'PPL', 'P'),
(29621, 'Deer Mill', 39.9474983215332, 0.697215373645663, -87.0555572509766, -1.51940610618796, 218, 19, 'PPL', 'P'),
(2011, 'Deer Park', 31.2166690826416, 0.544833656997614, -88.3172225952148, -1.54142632050323, 218, 2, 'PPL', 'P'),
(15762, 'Deer Park', 28.0911102294922, 0.490282364045299, -80.898063659668, -1.41193756934918, 218, 12, 'PPL', 'P'),
(40035, 'Deer Park', 31.4172191619873, 0.548333916197332, -91.5813903808594, -1.59839679570026, 218, 22, 'PPL', 'P'),
(46247, 'Deer Park', 39.0675010681152, 0.681856524165012, -76.9505615234375, -1.34304065984245, 218, 25, 'PPL', 'P'),
(54392, 'Deer Park', 38.8613891601563, 0.678259192743561, -92.25, -1.61006623496477, 218, 29, 'PPL', 'P'),
(70723, 'Deer Park', 39.9061088562012, 0.696492991199979, -74.9763870239258, -1.30858481481706, 218, 37, 'PPL', 'P'),
(72296, 'Deer Park', 39.2052803039551, 0.684261225471299, -84.3947219848633, -1.47296576994111, 218, 41, 'PPL', 'P'),
(80639, 'Deer Park', 32.9711112976074, 0.57545445018475, -80.0666732788086, -1.39742706983377, 218, 48, 'PPL', 'P'),
(93676, 'Deer Park', 29.7049999237061, 0.518450052973335, -95.1236114501953, -1.66022021619369, 218, 51, 'PPL', 'P'),
(101356, 'Deer Park', 37.0755615234375, 0.647090620609709, -76.4783325195313, -1.33479870890087, 218, 53, 'PPL', 'P'),
(119345, 'Deer Park', 42.160831451416, 0.735845324205589, -88.0813903808594, -1.53731027188046, 218, 18, 'PPL', 'P'),
(122490, 'Deer Park', 41.1588897705078, 0.718358142960775, -87.1991729736328, -1.52191267340595, 218, 19, 'PPL', 'P'),
(130450, 'Deer Park', 46.6744384765625, 0.814622627935542, -85.6161117553711, -1.49428304288665, 218, 27, 'PPL', 'P'),
(134959, 'Deer Park', 44.7019386291504, 0.780196011103115, -93.317497253418, -1.62869757679291, 218, 28, 'PPL', 'P'),
(148233, 'Deer Park', 40.7616691589355, 0.711425335432053, -73.329719543457, -1.27984504559736, 218, 40, 'PPL', 'P'),
(160705, 'Deer Park', 40.350830078125, 0.704254840776042, -74.9922180175781, -1.30886111778015, 218, 45, 'PPL', 'P'),
(173770, 'Deer Park', 45.188060760498, 0.788680442861944, -92.3852767944336, -1.61242726042918, 218, 57, 'PPL', 'P'),
(181065, 'Deer Park', 38.5327796936035, 0.672523875598993, -122.468612670898, -2.13748052145682, 218, 6, 'PPL', 'P'),
(196341, 'Deer Park', 46.1305618286133, 0.805130189704118, -111.270278930664, -1.94203272695256, 218, 31, 'PPL', 'P'),
(207184, 'Deer Park', 47.9544410705566, 0.836962887634808, -117.475830078125, -2.05034002637667, 218, 56, 'PPL', 'P'),
(46248, 'Deer Park Estates', 39.4963912963867, 0.68934207077798, -76.9333267211914, -1.34273985579732, 218, 25, 'PPL', 'P'),
(46249, 'Deer Park Heights', 38.8258285522461, 0.677638543051518, -76.9508285522461, -1.34304532037436, 218, 25, 'PPL', 'P'),
(46250, 'Deer Park Ridge', 39.4652786254883, 0.688799052231713, -76.899169921875, -1.34214370718731, 218, 25, 'PPL', 'P'),
(26930, 'Deer Plain', 38.9316711425781, 0.679485844741651, -90.5330581665039, -1.58009994690503, 218, 18, 'PPL', 'P'),
(40034, 'Deer Range', 29.6088905334473, 0.516772627671235, -89.896110534668, -1.56898311356672, 218, 22, 'PPL', 'P'),
(26926, 'Deer Ridge', 37.5750007629395, 0.655807479752675, -88.9383316040039, -1.5522667177204, 218, 18, 'PPL', 'P'),
(46251, 'Deer Ridge', 39.4575004577637, 0.688663297595146, -77.4694366455078, -1.35209673912926, 218, 25, 'PPL', 'P'),
(139115, 'Deer Ridge', 40.2127799987793, 0.70184541235882, -91.8955612182617, -1.60388011122668, 218, 29, 'PPL', 'P'),
(80640, 'Deer Ridge Farms', 33.996940612793, 0.593358549298216, -80.8000030517578, -1.41022608887464, 218, 48, 'PPL', 'P'),
(134961, 'Deer River', 47.3330612182617, 0.826117763306705, -93.7925033569336, -1.63698799726633, 218, 28, 'PPL', 'P'),
(148234, 'Deer River', 43.9297218322754, 0.766718285458442, -75.5894393920898, -1.31928459712867, 218, 40, 'PPL', 'P'),
(13635, 'Deer Run', 39.6444396972656, 0.691926002825629, -75.7152786254883, -1.32148090607966, 218, 10, 'PPL', 'P'),
(20513, 'Deer Run', 33.850830078125, 0.590808439396411, -84.7525024414063, -1.47921021690707, 218, 13, 'PPL', 'P'),
(46252, 'Deer Run', 39.4333305358887, 0.688241452878477, -76.6630630493164, -1.33802286487458, 218, 25, 'PPL', 'P'),
(101357, 'Deer Run', 38.1455612182617, 0.665765638279726, -78.4691696166992, -1.3695453711173, 218, 53, 'PPL', 'P'),
(108830, 'Deer Run', 38.7200012207031, 0.675791507677493, -79.230827331543, -1.38283880601454, 218, 58, 'PPL', 'P'),
(119347, 'Deer Run', 41.9483299255371, 0.73213647291349, -88.3936080932617, -1.54275949894492, 218, 18, 'PPL', 'P'),
(20514, 'Deer Run Estates', 31.8283290863037, 0.555509137964278, -81.6138916015625, -1.42443112381301, 218, 13, 'PPL', 'P'),
(191362, 'Deer Run Number 1 Colonia', 28.7730007171631, 0.502183598193186, -100.484001159668, -1.75377666581401, 218, 51, 'PPL', 'P'),
(191363, 'Deer Run Number 2 Colonia', 28.7740001678467, 0.502201041898326, -100.488998413086, -1.75386388433971, 218, 51, 'PPL', 'P'),
(191364, 'Deer Run Number 3 Colonia', 28.7709999084473, 0.502148677493392, -100.478996276855, -1.75368931413025, 218, 51, 'PPL', 'P'),
(191365, 'Deer Run Number 4 Colonia', 28.7679996490479, 0.502096313088458, -100.487998962402, -1.75384644063457, 218, 51, 'PPL', 'P'),
(191366, 'Deer Run Number 5 Colonia', 28.7670001983643, 0.502078869383318, -100.49299621582, -1.75393365916027, 218, 51, 'PPL', 'P'),
(20515, 'Deer Track', 33.5913887023926, 0.586280333173976, -83.7133331298828, -1.46107329093531, 218, 13, 'PPL', 'P'),
(80641, 'Deer Track Villas', 33.6333312988281, 0.587012369578612, -78.9677810668945, -1.37824778261135, 218, 48, 'PPL', 'P'),
(186609, 'Deer Trail', 39.6150016784668, 0.691412212472326, -104.043891906738, -1.81590848036166, 218, 7, 'PPL', 'P'),
(207185, 'Deer Trail', 48.0327796936035, 0.838330154538455, -118.101936340332, -2.06126764211954, 218, 56, 'PPL', 'P'),
(178064, 'Deer Valley', 33.6838912963867, 0.587894808005809, -112.134170532227, -1.95711047978016, 218, 5, 'PPL', 'P'),
(207186, 'Deer Valley', 48.1816711425781, 0.840928800551127, -117.29972076416, -2.04726633900455, 218, 56, 'PPL', 'P'),
(181066, 'Deer View', 38.8433303833008, 0.67794400762855, -120.66667175293, -2.10603071951186, 218, 6, 'PPL', 'P'),
(46269, 'Deer Woods', 39.4388885498047, 0.688338458521183, -76.5269393920898, -1.33564705886612, 218, 25, 'PPL', 'P'),
(20516, 'Deerbrook', 33.9208297729492, 0.592030164546484, -83.5033264160156, -1.45740798232703, 218, 13, 'PPL', 'P'),
(59232, 'Deerbrook', 33.235279083252, 0.580065047821949, -88.4866714477539, -1.54438376089376, 218, 30, 'PPL', 'P'),
(173772, 'Deerbrook', 45.2336082458496, 0.789475396447332, -89.1555633544922, -1.55605812700629, 218, 57, 'PPL', 'P'),
(20517, 'Deerbrook Estates', 33.8383293151855, 0.590590259924106, -84.6988906860352, -1.47827451525807, 218, 13, 'PPL', 'P'),
(20518, 'Deerchase', 34.0963897705078, 0.595094264538675, -84.4633331298828, -1.47416326032526, 218, 13, 'PPL', 'P'),
(46253, 'Deercreek (historical)', 39.6172218322754, 0.691450961466186, -76.2702789306641, -1.33116748875455, 218, 25, 'PPL', 'P'),
(8455, 'Deerfield', 34.086109161377, 0.594914834060231, -90.98388671875, -1.58796838950373, 218, 4, 'PPL', 'P'),
(20522, 'Deerfield', 33.5958290100098, 0.586357831161697, -83.7888870239258, -1.46239195514906, 218, 13, 'PPL', 'P'),
(35542, 'Deerfield', 38.0113906860352, 0.66342392073322, -84.5216674804688, -1.47518138681, 218, 21, 'PPL', 'P'),
(46259, 'Deerfield', 38.3758316040039, 0.669784614680765, -75.5513916015625, -1.31862053791086, 218, 25, 'PPL', 'P'),
(54393, 'Deerfield', 37.8386116027832, 0.660408356851896, -94.5058288574219, -1.64943787588828, 218, 29, 'PPL', 'P'),
(59233, 'Deerfield', 32.5191688537598, 0.567566566510098, -90.0283279418945, -1.57129074265127, 218, 30, 'PPL', 'P'),
(64166, 'Deerfield', 35.476390838623, 0.619179826858325, -82.1944427490234, -1.43456365281244, 218, 33, 'PPL', 'P'),
(70734, 'Deerfield', 39.523609161377, 0.689817112137423, -75.2363891601563, -1.3131227081565, 218, 37, 'PPL', 'P'),
(80645, 'Deerfield', 33.9333305358887, 0.592248344018789, -80.4000015258789, -1.40324474523505, 218, 48, 'PPL', 'P'),
(86271, 'Deerfield', 35.9569396972656, 0.627566986658338, -86.8694381713867, -1.51615771544834, 218, 50, 'PPL', 'P'),
(101361, 'Deerfield', 36.8441696166992, 0.643052069974658, -76.4655609130859, -1.33457580231763, 218, 53, 'PPL', 'P'),
(115235, 'Deerfield', 43.1636085510254, 0.753347086257372, -92.4952774047852, -1.61434713325902, 218, 16, 'PPL', 'P'),
(119348, 'Deerfield', 42.1711082458496, 0.736024688105006, -87.8444366455078, -1.53317464902367, 218, 18, 'PPL', 'P'),
(122491, 'Deerfield', 40.2786102294922, 0.702994366632107, -84.9763870239258, -1.48311774001649, 218, 19, 'PPL', 'P'),
(124631, 'Deerfield', 42.5444412231445, 0.742540577765076, -72.6061096191406, -1.26721566991793, 218, 23, 'PPL', 'P'),
(130451, 'Deerfield', 41.8888893127441, 0.73109903851085, -83.7788925170898, -1.46221751809766, 218, 27, 'PPL', 'P'),
(134965, 'Deerfield', 44.1674995422363, 0.770868289385112, -93.3594436645508, -1.62942967977657, 218, 28, 'PPL', 'P'),
(143707, 'Deerfield', 44.2305603027344, 0.771968907284615, -71.6175003051758, -1.24996118237336, 218, 36, 'PPL', 'P'),
(148240, 'Deerfield', 43.1194381713867, 0.752576167700821, -75.2191696166992, -1.31282217042748, 218, 40, 'PPL', 'P'),
(154957, 'Deerfield', 41.0244407653809, 0.716011565145279, -81.0502777099609, -1.41459420569459, 218, 41, 'PPL', 'P'),
(173773, 'Deerfield', 43.0519409179688, 0.751398118392625, -89.0755615234375, -1.55466183164676, 218, 57, 'PPL', 'P'),
(187643, 'Deerfield', 37.9797210693359, 0.662871181648974, -101.132781982422, -1.76510002729486, 218, 20, 'PPL', 'P'),
(202053, 'Deerfield', 44.017219543457, 0.76824540860652, -103.833610534668, -1.81223837806343, 218, 49, 'PPL', 'P'),
(86273, 'Deerfield Acres', 36.5433311462402, 0.637801448148485, -82.1627807617188, -1.43401104688625, 218, 50, 'PPL', 'P'),
(15763, 'Deerfield Beach', 26.3180599212646, 0.459336798363228, -80.0999984741211, -1.39800870421585, 218, 12, 'PPL', 'P'),
(130453, 'Deerfield Center', 42.7336082458496, 0.745842165147474, -83.8622207641602, -1.46367187036895, 218, 27, 'PPL', 'P'),
(143702, 'Deerfield Center', 43.1324996948242, 0.752804134290132, -71.2416687011719, -1.24340168345044, 218, 36, 'PPL', 'P'),
(196342, 'Deerfield Colony', 47.2597198486328, 0.824837714928759, -109.676666259766, -1.91421893884388, 218, 31, 'PPL', 'P'),
(203700, 'Deerfield Condominium', 40.6583290100098, 0.709621709583797, -111.807502746582, -1.95140905136046, 218, 52, 'PPL', 'P'),
(141640, 'Deerfield Corner', 40.1311111450195, 0.700420021964382, -99.8936080932617, -1.74347236292427, 218, 35, 'PPL', 'P'),
(203701, 'Deerfield Cove', 40.6450004577637, 0.709389082462578, -111.951393127441, -1.9539204122684, 218, 52, 'PPL', 'P'),
(20524, 'Deerfield Estates', 34.146110534668, 0.595962055579877, -84.8161087036133, -1.48032035560747, 218, 13, 'PPL', 'P'),
(101365, 'Deerfield Estates', 37.3944396972656, 0.652656094655757, -75.9522171020508, -1.32561626262033, 218, 53, 'PPL', 'P'),
(20525, 'Deerfield Farm Estates', 31.5116691589355, 0.549982379622578, -83.9658279418945, -1.46548015674911, 218, 13, 'PPL', 'P'),
(148236, 'Deerfield Heights', 43.1294403076172, 0.752750737910276, -75.2144393920898, -1.31273961243369, 218, 40, 'PPL', 'P'),
(143703, 'Deerfield Parade', 43.1438903808594, 0.753002939265506, -71.2344436645508, -1.24327558277283, 218, 36, 'PPL', 'P'),
(191367, 'Deerfield Park Colonia', 31.80299949646, 0.555067053223325, -106.161003112793, -1.85285904153819, 218, 51, 'PPL', 'P'),
(80646, 'Deerfield Plantation', 33.6338882446289, 0.58702209011659, -78.9733276367188, -1.37834458851697, 218, 48, 'PPL', 'P'),
(40036, 'Deerford', 30.6388893127441, 0.534749497661488, -91.0694427490234, -1.58946162392694, 218, 22, 'PPL', 'P'),
(46261, 'Deerhaven', 39.5561103820801, 0.69038436544961, -76.2647171020508, -1.33107041653281, 218, 25, 'PPL', 'P'),
(70726, 'Deerhaven', 39.6902809143066, 0.692726082996116, -74.2777786254883, -1.29639179808224, 218, 37, 'PPL', 'P'),
(32216, 'Deerhead', 37.2383308410645, 0.649931481123524, -98.9113922119141, -1.72632946182938, 218, 20, 'PPL', 'P'),
(148238, 'Deerhead', 44.3522186279297, 0.774092245621735, -73.5436096191406, -1.28357813165538, 218, 40, 'PPL', 'P'),
(130459, 'Deerheart Valley', 44.5369415283203, 0.777316268437385, -84.570556640625, -1.47603466362326, 218, 27, 'PPL', 'P'),
(200678, 'Deerhorn', 44.0819396972656, 0.769374988382878, -122.747222900391, -2.1423431872912, 218, 43, 'PPL', 'P'),
(2015, 'Deerhurst', 33.2830581665039, 0.58089895013828, -86.7636108398438, -1.51431068007432, 218, 2, 'PPL', 'P'),
(13636, 'Deerhurst', 39.7833290100098, 0.694350078628847, -75.5416717529297, -1.31845089454942, 218, 10, 'PPL', 'P'),
(54395, 'Deering', 36.1908302307129, 0.631649146556239, -89.8827819824219, -1.5687504864455, 218, 29, 'PPL', 'P'),
(72301, 'Deering', 38.5033302307129, 0.672009885508608, -82.5833282470703, -1.44135098516661, 218, 41, 'PPL', 'P'),
(127241, 'Deering', 43.6758308410645, 0.762287051720659, -70.2988891601563, -1.22694707633928, 218, 26, 'PPL', 'P'),
(143705, 'Deering', 43.0730590820313, 0.751766699887492, -71.8450012207031, -1.25393182240061, 218, 36, 'PPL', 'P'),
(198176, 'Deering', 48.3955612182617, 0.844661886609145, -101.051391601563, -1.76367949716941, 218, 34, 'PPL', 'P'),
(211781, 'Deering', 66.0755615234375, 1.15323610368806, -162.717224121094, -2.83995131061862, 218, 1, 'PPL', 'P'),
(15764, 'Deering Bay', 25.6377792358398, 0.447463660564841, -80.2905578613281, -1.40133459294319, 218, 12, 'PPL', 'P'),
(26927, 'Deering City', 37.916389465332, 0.661765836638536, -88.8919372558594, -1.55145698359096, 218, 18, 'PPL', 'P'),
(54396, 'Deering Junction', 36.189998626709, 0.631634632328298, -89.9052810668945, -1.56914316954823, 218, 29, 'PPL', 'P'),
(127242, 'Deering Junction', 43.686939239502, 0.762480929848017, -70.2908325195313, -1.22680646143372, 218, 26, 'PPL', 'P'),
(178065, 'Deering Park Estates', 34.5361099243164, 0.602768829010011, -112.565559387207, -1.96463963565597, 218, 5, 'PPL', 'P'),
(188413, 'Deering Place', 33.9544410705566, 0.592616792355602, -104.28971862793, -1.82019896603584, 218, 38, 'PPL', 'P'),
(15765, 'Deerland', 30.7516708374023, 0.536717906602193, -86.4358291625977, -1.50858981057866, 218, 12, 'PPL', 'P'),
(148239, 'Deerland', 43.9386100769043, 0.766873414591939, -74.4608306884766, -1.29958665928395, 218, 40, 'PPL', 'P'),
(86274, 'Deermont', 36.0261116027832, 0.628774264159498, -84.5888900756836, -1.47635464242823, 218, 50, 'PPL', 'P'),
(186610, 'Deermont', 39.5074996948242, 0.689535948905338, -105.183891296387, -1.83580522318176, 218, 7, 'PPL', 'P'),
(46262, 'Deerpark', 39.5144386291504, 0.689657056155909, -76.9633331298828, -1.34326356642569, 218, 25, 'PPL', 'P'),
(119359, 'Deerpath', 42.2480583190918, 0.737367720242733, -87.8594436645508, -1.53343657091688, 218, 18, 'PPL', 'P'),
(119352, 'Deers', 40.0550003051758, 0.699091637212651, -88.1224975585938, -1.53802772747813, 218, 18, 'PPL', 'P'),
(46263, 'Deers Head Manor', 38.3869400024414, 0.669978492808123, -75.5902786254883, -1.31929924451466, 218, 25, 'PPL', 'P'),
(154959, 'Deersville', 40.3074989318848, 0.703498569605487, -81.1866683959961, -1.41697467223496, 218, 41, 'PPL', 'P'),
(196343, 'Deertail Indian Village (historical)', 48.0863914489746, 0.839265856187454, -105.064720153809, -1.8337252943704, 218, 31, 'PPL', 'P'),
(130460, 'Deerton', 46.4744415283203, 0.811132022694775, -87.0419387817383, -1.51916841906067, 218, 27, 'PPL', 'P'),
(108831, 'Deerwalk', 39.2538909912109, 0.685109642015571, -81.3280563354492, -1.41944235730102, 218, 58, 'PPL', 'P'),
(203703, 'Deerwalk Single Unit Condominium', 41.2419395446777, 0.719807634963078, -111.949996948242, -1.95389604434443, 218, 52, 'PPL', 'P'),
(13637, 'Deerwood', 38.7205581665039, 0.675801228215472, -75.3005599975586, -1.31424270055293, 218, 10, 'PPL', 'P'),
(20528, 'Deerwood', 32.5733299255371, 0.568511855539022, -83.5886077880859, -1.45889642306027, 218, 13, 'PPL', 'P'),
(46264, 'Deerwood', 38.6166687011719, 0.673988014987291, -76.9652786254883, -1.34329752172959, 218, 25, 'PPL', 'P'),
(64173, 'Deerwood', 35.2980613708496, 0.616067390492349, -77.8824996948242, -1.35930604935816, 218, 33, 'PPL', 'P'),
(86275, 'Deerwood', 35.9355583190918, 0.627193811210591, -84.7055587768555, -1.47839089539771, 218, 50, 'PPL', 'P'),
(101367, 'Deerwood', 37.7769393920898, 0.659331973718313, -77.9055633544922, -1.35970858615693, 218, 53, 'PPL', 'P'),
(134990, 'Deerwood', 46.4736099243164, 0.811117508466834, -93.8986129760742, -1.63883995948837, 218, 28, 'PPL', 'P'),
(209403, 'Deerwood', 41.2366714477539, 0.719715689326442, -106.13111114502, -1.85233732828064, 218, 59, 'PPL', 'P'),
(20529, 'Deerwood Acres', 33.5616683959961, 0.585761615972656, -82.1369400024414, -1.43356004055564, 218, 13, 'PPL', 'P'),
(15766, 'Deerwood Club', 30.2308292388916, 0.52762750582683, -81.5497207641602, -1.42331113141658, 218, 12, 'PPL', 'P'),
(20531, 'Deerwood Estates', 31.8161106109619, 0.55529588533999, -81.6074981689453, -1.42431953736334, 218, 13, 'PPL', 'P'),
(86277, 'Deerwood Forest', 35.1116714477539, 0.61281427264179, -85.1266708374023, -1.48574068737411, 218, 50, 'PPL', 'P'),
(80648, 'Deerwood Heights', 32.9588890075684, 0.575241130981434, -80.0625, -1.39735423237796, 218, 48, 'PPL', 'P'),
(20533, 'Deerwood Park', 33.5586090087891, 0.5857082195928, -84.4947204589844, -1.47471107256149, 218, 13, 'PPL', 'P'),
(70727, 'Deerwoods', 39.9208297729492, 0.696749919666144, -74.9850006103516, -1.30873515026059, 218, 37, 'PPL', 'P'),
(2017, 'Dees', 30.5638904571533, 0.5334405206962, -88.3433303833008, -1.54188198736574, 218, 2, 'PPL', 'P'),
(26928, 'Dees', 39.2230606079102, 0.684571550317321, -88.1591720581055, -1.53866781824613, 218, 18, 'PPL', 'P'),
(20534, 'Dees (historical)', 30.7605590820313, 0.53687303573569, -83.304443359375, -1.45393681816222, 218, 13, 'PPL', 'P'),
(59235, 'Dees Landing', 30.523609161377, 0.532737479457933, -88.6808319091797, -1.54777250022283, 218, 30, 'PPL', 'P'),
(54397, 'Dees Town', 37.0536117553711, 0.646707524886901, -90.5436096191406, -1.58028410449441, 218, 29, 'PPL', 'P'),
(59236, 'Deeson', 34.0230598449707, 0.59381441589781, -90.8594436645508, -1.58579644847671, 218, 30, 'PPL', 'P'),
(199912, 'Deeth', 41.065559387207, 0.716729220480028, -115.273887634277, -2.01190888079212, 218, 39, 'PPL', 'P'),
(193492, 'Deetz', 41.3580589294434, 0.721834300552628, -122.382217407227, -2.13597263964762, 218, 6, 'PPL', 'P'),
(170156, 'Deevaan Villa Development', 45.5050010681152, 0.794212094762147, -98.4572219848633, -1.71840269600281, 218, 49, 'PPL', 'P'),
(35543, 'Deevert', 38.3844413757324, 0.669934883545273, -83.0425033569336, -1.44936510267694, 218, 21, 'PPL', 'P'),
(86278, 'Defeated', 36.3263893127441, 0.634015098868665, -85.908332824707, -1.49938326269026, 218, 50, 'PPL', 'P'),
(35544, 'Defeated Creek', 37.0516700744629, 0.64667363616203, -82.9930572509766, -1.4485021053257, 218, 21, 'PPL', 'P'),
(46266, 'Defense Heights', 38.9452781677246, 0.679723332131859, -76.904167175293, -1.34223092571301, 218, 25, 'PPL', 'P'),
(148242, 'Deferiet', 44.0355606079102, 0.768565520569548, -75.6841735839844, -1.32093802069144, 218, 40, 'PPL', 'P'),
(78126, 'Deffenbaugh', 39.8525009155273, 0.695557356130007, -79.873893737793, -1.39406243211257, 218, 45, 'PPL', 'P'),
(35545, 'Defiance', 37.2033309936523, 0.649320618548487, -83.0919418334961, -1.45022796687012, 218, 21, 'PPL', 'P'),
(54398, 'Defiance', 38.6322212219238, 0.674259457681398, -90.7783279418945, -1.58438071204123, 218, 29, 'PPL', 'P'),
(112993, 'Defiance', 41.8241691589355, 0.729969458734493, -95.3424987792969, -1.6640405207774, 218, 16, 'PPL', 'P'),
(154960, 'Defiance', 41.2844390869141, 0.720549391905692, -84.355827331543, -1.47228693017925, 218, 41, 'PPL', 'P'),
(160709, 'Defiance', 40.1611099243164, 0.700943599434692, -78.2300033569336, -1.36537113242471, 218, 45, 'PPL', 'P'),
(188412, 'Defiance', 35.4905586242676, 0.619427101365538, -108.89582824707, -1.90059074459762, 218, 38, 'PPL', 'P'),
(8457, 'Defiance (historical)', 35.1080589294434, 0.612751222302982, -91.7324981689453, -1.60103412412777, 218, 4, 'PPL', 'P'),
(35546, 'Defoe', 38.3408317565918, 0.669173752105728, -85.054443359375, -1.48448008007212, 218, 21, 'PPL', 'P'),
(108832, 'Defoe (historical)', 38.5472183227539, 0.672775877217142, -80.5763931274414, -1.40632335945518, 218, 58, 'PPL', 'P'),
(1995, 'DeFoor', 34.2205581665039, 0.597261411875727, -87.5677795410156, -1.52834607165125, 218, 2, 'PPL', 'P'),
(130461, 'Deford', 43.5133285522461, 0.759450851738752, -83.192497253418, -1.45198299002848, 218, 27, 'PPL', 'P'),
(154949, 'DeForest', 41.2027816772461, 0.719124201248336, -80.7797164916992, -1.40987202160771, 218, 41, 'PPL', 'P'),
(148243, 'Deforest Corners', 41.4452781677246, 0.723356563431717, -73.5500030517578, -1.28368971810505, 218, 40, 'PPL', 'P'),
(154950, 'DeForest Junction', 41.2052803039551, 0.719167810511186, -80.7908325195313, -1.41006603289313, 218, 41, 'PPL', 'P'),
(148244, 'Defreestville', 42.6533317565918, 0.744441076097983, -73.6963882446289, -1.28624462169682, 218, 40, 'PPL', 'P'),
(35547, 'Defries', 37.2683296203613, 0.650455058593834, -85.6847229003906, -1.4954805332708, 218, 21, 'PPL', 'P'),
(122484, 'DeFries Landing', 41.3658294677734, 0.72196992203114, -85.7680587768555, -1.49693501870015, 218, 19, 'PPL', 'P'),
(8458, 'Degelow', 35.7441711425781, 0.623853474834332, -90.357780456543, -1.57704077376086, 218, 4, 'PPL', 'P'),
(40037, 'Degeneres', 30.8827800750732, 0.53900619447933, -92.1272201538086, -1.60792332239364, 218, 22, 'PPL', 'P'),
(203693, 'DeGiorgio', 41.2361106872559, 0.719705902209436, -112.073608398438, -1.9560534711435, 218, 52, 'PPL', 'P'),
(8459, 'Deglow', 35.7513885498047, 0.623979442353893, -90.376106262207, -1.57736061940778, 218, 4, 'PPL', 'P'),
(75631, 'Degnan', 34.9472198486328, 0.609944050776957, -95.3530578613281, -1.66422481152484, 218, 42, 'PPL', 'P'),
(26929, 'Degognia', 37.8611106872559, 0.660801039954628, -89.6302795410156, -1.56434348747363, 218, 18, 'PPL', 'P'),
(160708, 'Degolia', 41.9147186279297, 0.731549845104373, -78.6513900756836, -1.37272571809107, 218, 45, 'PPL', 'P'),
(64147, 'DeGraffenried Park', 35.1072196960449, 0.612736574916987, -77.0627822875977, -1.34499928166615, 218, 33, 'PPL', 'P'),
(148248, 'Degrasse', 44.3497200012207, 0.774048636358885, -75.0761108398438, -1.31032532374748, 218, 40, 'PPL', 'P'),
(199270, 'DeGraw', 41.7150001525879, 0.728064100132596, -103.155281066895, -1.80039929543748, 218, 35, 'PPL', 'P'),
(75626, 'Degroat', 36.3363914489746, 0.63418966907812, -95.6036071777344, -1.66859772203475, 218, 42, 'PPL', 'P'),
(148245, 'Degroff', 42.8836097717285, 0.748460185657077, -76.4994430541992, -1.33516715723768, 218, 40, 'PPL', 'P'),
(35548, 'Dehart', 37.9644393920898, 0.662604466065802, -83.3372192382813, -1.45450886516437, 218, 21, 'PPL', 'P'),
(64174, 'Dehart', 36.2999992370605, 0.633554505158136, -81.1352767944336, -1.41607771957982, 218, 33, 'PPL', 'P'),
(101329, 'DeHart Subdivision', 37.1369400024414, 0.648161877158194, -80.3477783203125, -1.40233327835197, 218, 53, 'PPL', 'P'),
(181046, 'DeHaven', 39.6602783203125, 0.692202438946779, -123.783889770508, -2.16043643742109, 218, 6, 'PPL', 'P'),
(188414, 'Dehaven', 36.0616683959961, 0.629394847272514, -103.826667785645, -1.81211720423383, 218, 38, 'PPL', 'P'),
(181067, 'Dehesa', 32.7813911437988, 0.5721432088434, -116.85221862793, -2.03945595331762, 218, 6, 'PPL', 'P'),
(40038, 'Dehlco', 32.3963890075684, 0.565423653938966, -91.7694396972656, -1.60167887542767, 218, 22, 'PPL', 'P'),
(194827, 'Dehlin', 43.3844413757324, 0.757201346144989, -111.708892822266, -1.949687983506, 218, 17, 'PPL', 'P'),
(178066, 'Dehorn', 33.5269393920898, 0.585155480508554, -110.178886413574, -1.92298433409772, 218, 5, 'PPL', 'P'),
(108835, 'Dehue', 37.8061103820801, 0.659841103539709, -81.9061126708984, -1.42953134361662, 218, 58, 'PPL', 'P'),
(130462, 'Deibert', 44.5838890075684, 0.778135656525775, -85.2324981689453, -1.48758772274813, 218, 27, 'PPL', 'P'),
(160713, 'Deibler', 40.8788909912109, 0.713471242360479, -76.628059387207, -1.33741193572051, 218, 45, 'PPL', 'P'),
(139878, 'Deisem', 46.4425010681152, 0.810574556499594, -98.789436340332, -1.72420093032813, 218, 34, 'PPL', 'P'),
(108833, 'Deitz (historical)', 38.1583290100098, 0.665988478283939, -81.0227813720703, -1.41411430406616, 218, 58, 'PPL', 'P'),
(101330, 'DeJarnette', 37.9991683959961, 0.663210601529904, -77.3211135864258, -1.34950801339165, 218, 53, 'PPL', 'P'),
(80649, 'Dekalb', 34.3772201538086, 0.599995679366911, -80.5961074829102, -1.40666743986802, 218, 48, 'PPL', 'P'),
(119333, 'DeKalb', 41.9294395446777, 0.731806773570538, -88.7502822875977, -1.54898463799298, 218, 18, 'PPL', 'P'),
(154963, 'Dekalb', 40.8925018310547, 0.713708796329714, -82.7727813720703, -1.44465756597606, 218, 41, 'PPL', 'P'),
(20494, 'DeKalb Highlands', 33.9397201538086, 0.592359863889436, -84.2861099243164, -1.47107013187719, 218, 13, 'PPL', 'P'),
(145081, 'DeKays', 41.230281829834, 0.719604169455795, -74.4408264160156, -1.29923751886504, 218, 37, 'PPL', 'P'),
(15767, 'Dekle Beach', 29.8488903045654, 0.52096141388128, -83.6194381713867, -1.45943451475852, 218, 12, 'PPL', 'P'),
(173786, 'Dekorra', 43.4575004577637, 0.758476467674919, -89.4674987792969, -1.56150242722274, 218, 57, 'PPL', 'P'),
(35549, 'Dekoven', 37.5747184753418, 0.655802552904658, -88.0722198486328, -1.53715021589894, 218, 21, 'PPL', 'P'),
(181084, 'Del Aire', 33.9161109924316, 0.591947806289774, -118.368606567383, -2.06592191559861, 218, 6, 'PPL', 'P'),
(181068, 'Del Amo', 33.8463897705078, 0.590730941408689, -118.209442138672, -2.06314397226555, 218, 6, 'PPL', 'P'),
(203704, 'Del Ann', 40.6427803039551, 0.709350333468718, -111.839172363281, -1.95196179044471, 218, 52, 'PPL', 'P'),
(196344, 'Del Bonita', 48.9980583190918, 0.85517744475235, -112.787216186523, -1.96850827661348, 218, 31, 'PPL', 'P'),
(75627, 'Del City', 35.4419403076172, 0.618578551663212, -97.440559387207, -1.70065858629183, 218, 42, 'PPL', 'P'),
(181072, 'Del Dios', 33.0727806091309, 0.577228914419069, -117.11833190918, -2.04410050625872, 218, 6, 'PPL', 'P'),
(181073, 'Del Francia Mobile Estates', 34.4355583190918, 0.601013872430676, -119.279441833496, -2.08181898993557, 218, 6, 'PPL', 'P'),
(70728, 'Del Haven', 39.0466690063477, 0.681492936097189, -74.9199981689453, -1.30760064363622, 218, 37, 'PPL', 'P'),
(13639, 'Del Haven Estates', 39.0558280944824, 0.681652792341621, -75.501106262207, -1.31774289317362, 218, 10, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(193493, 'Del Loma', 40.7786102294922, 0.711721012892079, -123.331108093262, -2.15253390636044, 218, 6, 'PPL', 'P'),
(93678, 'Del Mar', 27.5694408416748, 0.481177515621022, -99.4855575561523, -1.73635053753718, 218, 51, 'PPL', 'P'),
(181074, 'Del Mar', 32.9477272033691, 0.575046320747695, -117.259521484375, -2.04656472921537, 218, 6, 'PPL', 'P'),
(93679, 'Del Mar Heights', 26.0566692352295, 0.454774670257868, -97.4236068725586, -1.70036270909472, 218, 51, 'PPL', 'P'),
(181075, 'Del Mar Heights', 32.9483299255371, 0.575056840234001, -117.26000213623, -2.04657311817281, 218, 6, 'PPL', 'P'),
(93680, 'Del Mar Heights Colonia', 26.056999206543, 0.454780429343725, -97.4240036010742, -1.70036963331356, 218, 51, 'PPL', 'P'),
(119353, 'Del Mar Woods', 42.2000007629395, 0.736528957657413, -87.8550033569336, -1.53335907292916, 218, 18, 'PPL', 'P'),
(181076, 'Del Monte', 36.600830078125, 0.638804993826255, -121.868057250977, -2.12699885203849, 218, 6, 'PPL', 'P'),
(190108, 'Del Monte', 38.2944412231445, 0.668364084555317, -118.929168701172, -2.07570557049524, 218, 39, 'PPL', 'P'),
(194826, 'Del Monte', 43.8688888549805, 0.765656549710854, -116.542221069336, -2.03404547524702, 218, 17, 'PPL', 'P'),
(181077, 'Del Monte Forest', 36.5863914489746, 0.638552992208106, -121.946388244629, -2.12836598578408, 218, 6, 'PPL', 'P'),
(181078, 'Del Monte Heights', 36.6116714477539, 0.638994211421705, -121.831108093262, -2.12635396758053, 218, 6, 'PPL', 'P'),
(178067, 'Del Muerto', 36.1847190856934, 0.631542486954581, -109.442222595215, -1.91012712498703, 218, 5, 'PPL', 'P'),
(80650, 'Del Norte', 34.8794403076172, 0.608761074620744, -82.3038864135742, -1.4364738051043, 218, 48, 'PPL', 'P'),
(186611, 'Del Norte', 37.6788902282715, 0.657620692980855, -106.352783203125, -1.85620623555425, 218, 7, 'PPL', 'P'),
(191368, 'Del Norte Acres', 31.8672199249268, 0.556187911147112, -106.434722900391, -1.85763635305963, 218, 51, 'PPL', 'P'),
(93681, 'Del Norte Colonia', 26.2490005493164, 0.458131484943371, -98.3659973144531, -1.71681052514511, 218, 51, 'PPL', 'P'),
(80651, 'Del Norte Estates', 34.8847198486328, 0.608853219994461, -82.2930603027344, -1.43628485382496, 218, 48, 'PPL', 'P'),
(191369, 'Del Norte Heights', 31.7574996948242, 0.554272931875777, -106.364723205566, -1.85641462790955, 218, 51, 'PPL', 'P'),
(93682, 'Del Norte Mobile Home Park Colonia', 27.8129997253418, 0.485428420063493, -98.0820007324219, -1.71185384972425, 218, 51, 'PPL', 'P'),
(181080, 'Del Paso', 38.6527786254883, 0.674618252059259, -121.472221374512, -2.12009021269666, 218, 6, 'PPL', 'P'),
(181081, 'Del Paso Heights', 38.6361083984375, 0.674327301710168, -121.419166564941, -2.11916423158564, 218, 6, 'PPL', 'P'),
(20535, 'Del Pines', 33.6361083984375, 0.587060839110451, -84.216667175293, -1.46985812726509, 218, 13, 'PPL', 'P'),
(181082, 'Del Prado Bolsa', 33.7427787780762, 0.588922588449498, -117.98388671875, -2.0592072875422, 218, 6, 'PPL', 'P'),
(181083, 'Del Prado Mobile Park Club', 33.7763900756836, 0.589509216258615, -117.923889160156, -2.05816013260158, 218, 6, 'PPL', 'P'),
(101368, 'Del Ray', 38.8211097717285, 0.677556184794807, -77.0630569458008, -1.34500407535611, 218, 53, 'PPL', 'P'),
(181085, 'Del Ray', 33.985279083252, 0.593155017211907, -118.424438476563, -2.06689636624147, 218, 6, 'PPL', 'P'),
(181087, 'Del Rey', 36.6591682434082, 0.639823186890019, -119.592781066895, -2.08728779123405, 218, 6, 'PPL', 'P'),
(181088, 'Del Rey Oaks', 36.5933303833008, 0.638674099458677, -121.833892822266, -2.12640257027042, 218, 6, 'PPL', 'P'),
(20536, 'Del Ridge', 33.7208290100098, 0.58853949272669, -84.6636123657227, -1.47765879241405, 218, 13, 'PPL', 'P'),
(15768, 'Del Rio', 28.0088901519775, 0.488847352981423, -82.4000015258789, -1.43815133027494, 218, 12, 'PPL', 'P'),
(86280, 'Del Rio', 35.9197196960449, 0.626917375089441, -83.0258331298828, -1.44907415232784, 218, 50, 'PPL', 'P'),
(178068, 'Del Rio', 34.8230590820313, 0.607777036597959, -112.442779541016, -1.96249672308484, 218, 5, 'PPL', 'P'),
(181089, 'Del Rio', 37.7436103820801, 0.658750272757212, -121.010833740234, -2.11203747935053, 218, 6, 'PPL', 'P'),
(191370, 'Del Rio', 29.3624992370605, 0.51247228830103, -100.896392822266, -1.76097425813411, 218, 51, 'PPL', 'P'),
(181090, 'Del Rio Woods', 38.6230583190918, 0.674099534857939, -122.838333129883, -2.14393336077809, 218, 6, 'PPL', 'P'),
(181091, 'Del Rosa', 34.1488914489746, 0.596010591690744, -117.242500305176, -2.04626765359577, 218, 6, 'PPL', 'P'),
(13640, 'Del Shire', 39.209171295166, 0.684329136079096, -75.5652770996094, -1.31886288557005, 218, 10, 'PPL', 'P'),
(93683, 'Del Sol Colonia', 28.011999130249, 0.488901614888633, -97.5169982910156, -1.70199269683991, 218, 51, 'PPL', 'P'),
(181092, 'Del Sur', 34.6897201538086, 0.605449833279394, -118.287780761719, -2.0645112391692, 218, 6, 'PPL', 'P'),
(93684, 'Del Valle', 30.2105598449707, 0.527273738165526, -97.6544418334961, -1.7043915391918, 218, 51, 'PPL', 'P'),
(181093, 'Del Valle', 34.4194412231445, 0.600732576040536, -118.655563354492, -2.07093025634462, 218, 6, 'PPL', 'P'),
(75628, 'Dela', 34.2002792358398, 0.596907477766856, -95.5219421386719, -1.66717239821934, 218, 42, 'PPL', 'P'),
(160710, 'Delabole', 40.8519401550293, 0.713000861532944, -75.2427825927734, -1.31323429460617, 218, 45, 'PPL', 'P'),
(40040, 'Delacroix', 30.0844402313232, 0.525072535656035, -91.866943359375, -1.60338063536423, 218, 22, 'PPL', 'P'),
(26931, 'Delafield', 38.1477813720703, 0.665804387273587, -88.602783203125, -1.54641029332526, 218, 18, 'PPL', 'P'),
(35550, 'Delafield', 37.0111083984375, 0.64596570136526, -86.4458312988281, -1.50876438078812, 218, 21, 'PPL', 'P'),
(173778, 'Delafield', 43.0608291625977, 0.751553247526122, -88.4036102294922, -1.54293406915438, 218, 57, 'PPL', 'P'),
(186612, 'Delagua (historical)', 37.3400001525879, 0.651705945357844, -104.662498474121, -1.82670520173695, 218, 7, 'PPL', 'P'),
(70729, 'Delair', 39.9813919067383, 0.697806928302797, -75.0519409179688, -1.30990347903081, 218, 37, 'PPL', 'P'),
(70730, 'Delair Junction', 39.9741706848145, 0.697680894204209, -75.0650024414063, -1.31013144562012, 218, 37, 'PPL', 'P'),
(13641, 'Delaire', 39.7750015258789, 0.694204736612355, -75.4875030517578, -1.31750547236244, 218, 10, 'PPL', 'P'),
(160711, 'Delaire Landing', 40.0466690063477, 0.698946228617133, -74.9866714477539, -1.30876431187453, 218, 45, 'PPL', 'P'),
(190110, 'Delamar', 37.4580612182617, 0.653766499672265, -114.769172668457, -2.00309994285446, 218, 39, 'PPL', 'P'),
(160712, 'Delamater Corners', 41.6988906860352, 0.727782936900511, -80.0022201538086, -1.39630215058932, 218, 45, 'PPL', 'P'),
(145087, 'Delanco', 40.0505599975586, 0.69901413922493, -74.9538879394531, -1.30819213171433, 218, 37, 'PPL', 'P'),
(311, 'Delaney', 35.8522186279297, 0.625739259202217, -93.9000015258789, -1.63886419425429, 218, 4, 'PPL', 'P'),
(54399, 'Delaney', 39.6416702270508, 0.691877666451844, -94.4513931274414, -1.6484877931694, 218, 29, 'PPL', 'P'),
(207187, 'Delaney', 46.5108299255371, 0.811767120035732, -117.970832824707, -2.05897945411094, 218, 56, 'PPL', 'P'),
(108834, 'Delaney (historical)', 39.3316688537598, 0.686467121802212, -81.4741668701172, -1.42199246720283, 218, 58, 'PPL', 'P'),
(181094, 'Delaney (historical)', 39.7966690063477, 0.694582905487147, -120.524436950684, -2.10354825390174, 218, 6, 'PPL', 'P'),
(13642, 'Delaney Corner', 39.2991714477539, 0.685899935069052, -75.7474975585938, -1.32204323254383, 218, 10, 'PPL', 'P'),
(72302, 'Delano', 39.4069404602051, 0.687780859167948, -82.9555587768555, -1.44784763348781, 218, 41, 'PPL', 'P'),
(86281, 'Delano', 35.2649993896484, 0.615490350063156, -84.5533294677734, -1.47573399273619, 218, 50, 'PPL', 'P'),
(112611, 'Delano', 37.1883316040039, 0.649058829813332, -82.3249969482422, -1.43684225344111, 218, 53, 'PPL', 'P'),
(130463, 'Delano', 44.0997200012207, 0.769685313228899, -83.626106262207, -1.45955089489816, 218, 27, 'PPL', 'P'),
(134974, 'Delano', 45.0419387817383, 0.786130133223057, -93.7888870239258, -1.63692488034849, 218, 28, 'PPL', 'P'),
(160717, 'Delano', 40.8388900756836, 0.712773094680715, -76.0713882446289, -1.32769619143168, 218, 45, 'PPL', 'P'),
(181095, 'Delano', 35.7688903808594, 0.624284906930925, -119.246109008789, -2.08123722239544, 218, 6, 'PPL', 'P'),
(40042, 'Delano (historical)', 30.7638893127441, 0.536931159226481, -91.7733306884766, -1.60174678603547, 218, 22, 'PPL', 'P'),
(199909, 'Delano (historical)', 41.667781829834, 0.727239984933271, -114.27278137207, -1.99443628035427, 218, 39, 'PPL', 'P'),
(46268, 'Delano Acres', 39.6252784729004, 0.691591576371743, -76.3666687011719, -1.33284980761515, 218, 25, 'PPL', 'P'),
(207188, 'Delano Heights', 47.9336090087891, 0.836599299566985, -119.016937255859, -2.07723742075425, 218, 56, 'PPL', 'P'),
(196346, 'Delano Heights (historical)', 48.0041694641113, 0.837830811834065, -106.497222900391, -1.85872718384212, 218, 31, 'PPL', 'P'),
(127243, 'Delano Park', 43.6161117553711, 0.761244757049029, -70.2141723632813, -1.22546848930207, 218, 26, 'PPL', 'P'),
(196345, 'Delano Place', 45.8988914489746, 0.801086778800078, -112.853889465332, -1.96967194485179, 218, 31, 'PPL', 'P'),
(148246, 'Delanson', 42.7452812194824, 0.746045896970865, -74.188606262207, -1.2948354467412, 218, 40, 'PPL', 'P'),
(35551, 'Delaplain', 38.273609161377, 0.668000496487494, -84.5486068725586, -1.47565156790045, 218, 21, 'PPL', 'P'),
(199911, 'Delaplain', 41.9316711425781, 0.731845722301481, -114.654998779297, -2.00110723256881, 218, 39, 'PPL', 'P'),
(8463, 'Delaplaine', 36.2336082458496, 0.632395763767843, -90.7263870239258, -1.58347417200616, 218, 4, 'PPL', 'P'),
(101369, 'Delaplane', 38.9150009155273, 0.67919489439256, -77.9205627441406, -1.35997037489208, 218, 53, 'PPL', 'P'),
(13643, 'Delaplane Manor', 39.6961097717285, 0.692827815749757, -75.7091674804688, -1.321374246478, 218, 10, 'PPL', 'P'),
(32219, 'Delavan', 38.6561088562012, 0.67467637555005, -96.8130569458008, -1.68970660262499, 218, 20, 'PPL', 'P'),
(119354, 'Delavan', 40.372501373291, 0.70463307622986, -89.5472183227539, -1.56289379573425, 218, 18, 'PPL', 'P'),
(134976, 'Delavan', 43.7677803039551, 0.763891872593541, -94.0194396972656, -1.64094878359755, 218, 28, 'PPL', 'P'),
(173781, 'Delavan', 42.6330604553223, 0.744087275147166, -88.6436080932617, -1.54712282207491, 218, 57, 'PPL', 'P'),
(173782, 'Delavan Lake', 42.584171295166, 0.743233998333905, -88.6324996948242, -1.54692894394755, 218, 57, 'PPL', 'P'),
(145089, 'Delawanna', 40.8288917541504, 0.712598591050288, -74.1413879394531, -1.29401133154187, 218, 37, 'PPL', 'P'),
(8461, 'Delaware', 35.2836112976074, 0.615815189137118, -93.2986068725586, -1.62836787744996, 218, 4, 'PPL', 'P'),
(13647, 'Delaware', 39.0002784729004, 0.680683268546778, -75.5002822875977, -1.31772851210374, 218, 10, 'ADM1', 'A'),
(29622, 'Delaware', 39.1477813720703, 0.68325767979353, -85.2072219848633, -1.48714657011356, 218, 19, 'PPL', 'P'),
(35552, 'Delaware', 37.6838912963867, 0.657707978085583, -87.404167175293, -1.52549049717241, 218, 21, 'PPL', 'P'),
(40044, 'Delaware', 29.891939163208, 0.521712758203818, -91.751106262207, -1.6013588966227, 218, 22, 'PPL', 'P'),
(54401, 'Delaware', 37.103328704834, 0.647575249349076, -91.4080581665039, -1.59537157785998, 218, 29, 'PPL', 'P'),
(75629, 'Delaware', 36.7786102294922, 0.641907842812306, -95.6391677856445, -1.66921837172679, 218, 42, 'PPL', 'P'),
(101370, 'Delaware', 36.6500015258789, 0.639663197487533, -77.0005569458008, -1.34391324457361, 218, 53, 'PPL', 'P'),
(115238, 'Delaware', 42.4752807617188, 0.741333500000997, -91.3452835083008, -1.59427595338753, 218, 16, 'PPL', 'P'),
(130464, 'Delaware', 47.4211082458496, 0.827654473834708, -88.095832824707, -1.53756234007763, 218, 27, 'PPL', 'P'),
(145090, 'Delaware', 40.8927803039551, 0.713713656598704, -75.0650024414063, -1.31013144562012, 218, 37, 'PPL', 'P'),
(154964, 'Delaware', 40.2986106872559, 0.70334344047199, -83.0680618286133, -1.44981118215952, 218, 41, 'PPL', 'P'),
(160715, 'Delaware', 41.160831451416, 0.718392031685646, -74.9097213745117, -1.3074212797368, 218, 45, 'PPL', 'P'),
(13644, 'Delaware City', 39.5777816772461, 0.690762600903428, -75.5891723632813, -1.31927993659676, 218, 10, 'PPL', 'P'),
(70731, 'Delaware Gardens', 39.9605598449707, 0.697443340234974, -75.067497253418, -1.31017498830394, 218, 37, 'PPL', 'P'),
(160718, 'Delaware Grove', 41.3036117553711, 0.72088401809666, -80.295280456543, -1.40141701777893, 218, 45, 'PPL', 'P'),
(13645, 'Delaware Heights', 39.8250007629395, 0.695077387922547, -75.6208267211914, -1.3198324093649, 218, 10, 'PPL', 'P'),
(13646, 'Delaware Junction', 39.7230606079102, 0.693298196577293, -75.5769424438477, -1.31906648423539, 218, 10, 'PPL', 'P'),
(93685, 'Delaware Junction', 31.7863903045654, 0.55477716813867, -98.8686065673828, -1.72558271145972, 218, 51, 'PPL', 'P'),
(101371, 'Delaware Park', 36.6624984741211, 0.63988131038081, -77.0088882446289, -1.34405865316913, 218, 53, 'PPL', 'P'),
(160719, 'Delaware Run', 41.1366691589355, 0.717970320127032, -76.8513870239258, -1.34130973829195, 218, 45, 'PPL', 'P'),
(29623, 'Delaware Trails', 39.8800010681152, 0.696037324337466, -86.1813888549805, -1.50414898946096, 218, 19, 'PPL', 'P'),
(160720, 'Delaware Water Gap', 40.9791717529297, 0.715221471828879, -75.1433334350586, -1.31149857936571, 218, 45, 'PPL', 'P'),
(59237, 'Delay', 34.2488899230957, 0.597755894311128, -89.4038925170898, -1.56039228852234, 218, 30, 'PPL', 'P'),
(86282, 'Delay Estates', 35.9280586242676, 0.627062916843014, -86.2763900756836, -1.50580707355564, 218, 50, 'PPL', 'P'),
(93686, 'Delba', 33.375, 0.582503637853107, -96.3308334350586, -1.68129021463201, 218, 51, 'PPL', 'P'),
(108836, 'Delbarton', 37.7105598449707, 0.658173432065101, -82.1841735839844, -1.43438442207108, 218, 58, 'PPL', 'P'),
(173785, 'Delbern Acres', 43.6002807617188, 0.760968454085933, -88.9138870239258, -1.55184007931377, 218, 57, 'PPL', 'P'),
(119356, 'Delbert Egan Housing Project', 41.139720916748, 0.718023583348833, -88.841667175293, -1.55057960516983, 218, 18, 'PPL', 'P'),
(54403, 'Delbridge', 37.7947196960449, 0.659642298564334, -90.9866714477539, -1.58801699219362, 218, 29, 'PPL', 'P'),
(101372, 'Delbridge Estates', 36.5541687011719, 0.637990599164908, -77.8722229003906, -1.35912668545874, 218, 53, 'PPL', 'P'),
(40043, 'Delcambre', 29.9480590820313, 0.522692235563236, -91.9886093139648, -1.60550410685941, 218, 22, 'PPL', 'P'),
(186613, 'Delcarbon', 37.7125015258789, 0.658207320789972, -104.876388549805, -1.83043828779497, 218, 7, 'PPL', 'P'),
(2018, 'Delchamps', 30.4005603790283, 0.53058987306538, -88.1488876342773, -1.53848832118865, 218, 2, 'PPL', 'P'),
(64178, 'Delco', 34.315559387207, 0.59891949597041, -78.2249984741211, -1.36528378074095, 218, 33, 'PPL', 'P'),
(80652, 'Delemar Crossroads', 32.8461112976074, 0.573272788619757, -80.2844390869141, -1.40122780018348, 218, 48, 'PPL', 'P'),
(200680, 'Delena', 46.0986099243164, 0.804572523771855, -123.072776794434, -2.14802517463494, 218, 43, 'PPL', 'P'),
(15769, 'Delespine', 28.4902801513672, 0.497249193456946, -80.7794418334961, -1.40986722791775, 218, 12, 'PPL', 'P'),
(148250, 'Delevan', 42.4891700744629, 0.741575914239222, -78.4811096191406, -1.3697537634726, 218, 40, 'PPL', 'P'),
(181098, 'Delevan', 39.3541717529297, 0.686859871483971, -122.190002441406, -2.13261785562245, 218, 6, 'PPL', 'P'),
(8465, 'Delfore', 35.920280456543, 0.626927162206447, -90.29638671875, -1.57596925089627, 218, 4, 'PPL', 'P'),
(134980, 'Delft', 43.9863891601563, 0.76770731690827, -95.0886077880859, -1.65960928703962, 218, 28, 'PPL', 'P'),
(181097, 'Delft Colony', 36.5119400024414, 0.637253569333229, -119.444999694824, -2.0847085197183, 218, 6, 'PPL', 'P'),
(101373, 'Delhart', 36.5813903808594, 0.638465707103379, -80.9852828979492, -1.41345983222827, 218, 53, 'PPL', 'P'),
(20537, 'Delhi', 33.9136085510254, 0.591904130447896, -82.6741714477539, -1.44293649812159, 218, 13, 'PPL', 'P'),
(26932, 'Delhi', 39.045280456543, 0.68146870133127, -90.2558288574219, -1.57526138267852, 218, 18, 'PPL', 'P'),
(40045, 'Delhi', 32.4575004577637, 0.566490249955543, -91.4930572509766, -1.59685509174521, 218, 22, 'PPL', 'P'),
(54404, 'Delhi', 38.1283302307129, 0.665464900813629, -91.3475036621094, -1.59431470238139, 218, 29, 'PPL', 'P'),
(72303, 'Delhi', 39.0950012207031, 0.682336492372472, -84.6052780151367, -1.47664066592931, 218, 41, 'PPL', 'P'),
(75633, 'Delhi', 35.1747207641602, 0.613914690804211, -99.6761093139648, -1.73967629310647, 218, 42, 'PPL', 'P'),
(93687, 'Delhi', 29.827220916748, 0.520583211716975, -97.3952789306641, -1.69986829323835, 218, 51, 'PPL', 'P'),
(115243, 'Delhi', 42.4297218322754, 0.740538346678527, -91.3308334350586, -1.5940237520323, 218, 16, 'PPL', 'P'),
(134981, 'Delhi', 44.5991706848145, 0.778402372108946, -95.2108306884766, -1.66174247907278, 218, 28, 'PPL', 'P'),
(148251, 'Delhi', 42.2780609130859, 0.73789136429207, -74.916389465332, -1.30753765987644, 218, 40, 'PPL', 'P'),
(181099, 'Delhi', 37.4322204589844, 0.65331549334166, -120.777496337891, -2.10796497341159, 218, 6, 'PPL', 'P'),
(186615, 'Delhi', 37.642219543457, 0.656980668791882, -104.017501831055, -1.81544788665113, 218, 7, 'PPL', 'P'),
(8466, 'Delhi (historical)', 33.500560760498, 0.584695086535106, -92.6266708374023, -1.61664038127368, 218, 4, 'PPL', 'P'),
(804, 'Delhi Hills', 39.0927810668945, 0.682297743378611, -84.6127777099609, -1.47677156029689, 218, 41, 'PPL', 'P'),
(130466, 'Delhi Mills', 42.3302803039551, 0.738802764596122, -83.8111114501953, -1.46277984456183, 218, 27, 'PPL', 'P'),
(160726, 'Delhill Corners', 42.1549987792969, 0.735743524872921, -79.8633270263672, -1.39387800820708, 218, 45, 'PPL', 'P'),
(40046, 'Delhoste', 31.267219543457, 0.545715928977243, -91.829719543457, -1.60273095721631, 218, 22, 'PPL', 'P'),
(32224, 'Delia', 39.2405586242676, 0.684876948315326, -95.966667175293, -1.67493431437443, 218, 20, 'PPL', 'P'),
(35553, 'Delia', 38.6588897705078, 0.674724911660916, -84.6719436645508, -1.47780420100956, 218, 21, 'PPL', 'P'),
(93688, 'Delia', 31.7066707611084, 0.553385799627158, -96.7675018310547, -1.68891151588155, 218, 51, 'PPL', 'P'),
(8467, 'Delight', 34.0313911437988, 0.593959824493329, -93.5027770996094, -1.63193132014654, 218, 4, 'PPL', 'P'),
(46271, 'Delight', 38.6502799987793, 0.674574642796409, -76.8888931274414, -1.34196434328789, 218, 25, 'PPL', 'P'),
(64176, 'Delight', 35.4680595397949, 0.619034418262806, -81.6333312988281, -1.42477041053589, 218, 33, 'PPL', 'P'),
(46272, 'Delight Meadows', 39.4249992370605, 0.688096044282959, -76.8274993896484, -1.3408928204233, 218, 25, 'PPL', 'P'),
(154970, 'Delightful', 41.2861099243164, 0.720578553519628, -80.9252777099609, -1.4124125441296, 218, 41, 'PPL', 'P'),
(101374, 'Delila', 36.584171295166, 0.638514243214245, -79.1405563354492, -1.38126327991365, 218, 53, 'PPL', 'P'),
(86283, 'Delina', 35.2677803039551, 0.615538886174023, -86.7361068725586, -1.51383064528783, 218, 50, 'PPL', 'P'),
(191371, 'Delip Colonia', 31.6709995269775, 0.552763219143325, -106.278999328613, -1.85491846400914, 218, 51, 'PPL', 'P'),
(154971, 'Delisle', 40.0194396972656, 0.698470987520608, -84.5741729736328, -1.4760977805411, 218, 41, 'PPL', 'P'),
(101375, 'Delk Crossroads', 37.0441703796387, 0.646542741794453, -76.7922210693359, -1.34027709757927, 218, 53, 'PPL', 'P'),
(207189, 'Delkena', 48.247501373291, 0.842077754824414, -117.237503051758, -2.04618043507007, 218, 56, 'PPL', 'P'),
(8468, 'Dell', 35.855281829834, 0.6257927221611, -90.0416717529297, -1.5715236360886, 218, 4, 'PPL', 'P'),
(15771, 'Dell', 30.1363906860352, 0.525979242138666, -83.2399978637695, -1.45281203207582, 218, 12, 'PPL', 'P'),
(54405, 'Dell', 38.1719398498535, 0.666226032253174, -93.3086090087891, -1.62854244765941, 218, 29, 'PPL', 'P'),
(72305, 'Dell', 39.4124984741211, 0.687877864810654, -81.3566665649414, -1.41994170000541, 218, 41, 'PPL', 'P'),
(124633, 'Dell', 42.6708297729492, 0.744746474095988, -72.8486099243164, -1.27144809868034, 218, 23, 'PPL', 'P'),
(134984, 'Dell', 43.6241683959961, 0.761385371954585, -93.9147186279297, -1.63912105614142, 218, 28, 'PPL', 'P'),
(186614, 'Dell', 39.8855590820313, 0.696134329980172, -106.855827331543, -1.86498601187797, 218, 7, 'PPL', 'P'),
(209875, 'Dell', 44.7230606079102, 0.780564659177009, -112.696388244629, -1.96692302997461, 218, 31, 'PPL', 'P'),
(200681, 'Dell (historical)', 44.2013893127441, 0.771459777463219, -117.440277099609, -2.04971950984268, 218, 43, 'PPL', 'P'),
(191372, 'Dell City', 31.9386100769043, 0.557433904352619, -105.200828552246, -1.83610083406275, 218, 51, 'PPL', 'P'),
(54406, 'Dell Junction', 38.1744384765625, 0.666269641516024, -93.3180618286133, -1.62870743048894, 218, 29, 'PPL', 'P'),
(46273, 'Dell Mont', 39.5591697692871, 0.690437761829466, -76.9061126708984, -1.34226488101691, 218, 25, 'PPL', 'P'),
(173787, 'Dell Prairie (historical)', 43.6672210693359, 0.762136782856151, -89.7152786254883, -1.56582700135886, 218, 57, 'PPL', 'P'),
(170144, 'Dell Rapids', 43.8261108398438, 0.764909932499251, -96.7058334350586, -1.68783519932699, 218, 49, 'PPL', 'P'),
(80653, 'Dell Vista Heights', 34.9124984741211, 0.609338048470909, -82.3675003051758, -1.43758407696275, 218, 48, 'PPL', 'P'),
(46274, 'Dellabrooke Estates', 39.1749992370605, 0.683732721152973, -77.040283203125, -1.34460659856341, 218, 25, 'PPL', 'P'),
(64177, 'Dellaplane', 36.1830596923828, 0.631513525077727, -81.029167175293, -1.41422575735778, 218, 33, 'PPL', 'P'),
(203706, 'Delle', 40.7599983215332, 0.711396173818117, -112.776672363281, -1.96832425218215, 218, 52, 'PPL', 'P'),
(46275, 'Delle Bourne', 38.1380615234375, 0.665634743912149, -76.3958282470703, -1.33335873769947, 218, 25, 'PPL', 'P'),
(181100, 'Delleker', 39.8088912963867, 0.694796224690462, -120.496940612793, -2.10306835227331, 218, 6, 'PPL', 'P'),
(70732, 'Dellette', 39.790828704834, 0.694480972996424, -74.7744369506836, -1.30506012111434, 218, 37, 'PPL', 'P'),
(93689, 'Dellinger Colonia', 26.1590003967285, 0.456560685953415, -97.9509963989258, -1.70956739277036, 218, 51, 'PPL', 'P'),
(86284, 'Dellrose', 35.1130599975586, 0.61283850740771, -86.8013916015625, -1.51497007876022, 218, 50, 'PPL', 'P'),
(154972, 'Dellroy', 40.5544395446777, 0.707808496355616, -81.1997222900391, -1.41720250566621, 218, 41, 'PPL', 'P'),
(181101, 'Dells (historical)', 34.2391700744629, 0.59758625094969, -117.652778625488, -2.05342836113478, 218, 6, 'PPL', 'P'),
(2024, 'Dells Vista Shores', 34.7619400024414, 0.606710307423328, -87.2747192382813, -1.52323120446165, 218, 2, 'PPL', 'P'),
(108837, 'Dellslow', 39.6069412231445, 0.691271530987742, -79.892219543457, -1.39438227775949, 218, 58, 'PPL', 'P'),
(187645, 'Dellvale', 39.7722206115723, 0.694156200501489, -100.034721374512, -1.74593525430038, 218, 20, 'PPL', 'P'),
(64179, 'Dellview', 35.3886108398438, 0.617647776862229, -81.4100036621094, -1.42087260796445, 218, 33, 'PPL', 'P'),
(160727, 'Dellville', 40.3638916015625, 0.704482807365353, -77.1161117553711, -1.34593005646713, 218, 45, 'PPL', 'P'),
(15773, 'Dellwood', 27.9825000762939, 0.488386759270894, -82.7091674804688, -1.4435472941176, 218, 12, 'PPL', 'P'),
(20538, 'Dellwood', 32.672779083252, 0.570247570779481, -82.3836135864258, -1.43786530677386, 218, 13, 'PPL', 'P'),
(46276, 'Dellwood', 39.0088882446289, 0.680833537411286, -76.5277786254883, -1.33566170625211, 218, 25, 'PPL', 'P'),
(54407, 'Dellwood', 38.749439239502, 0.676305298030797, -90.2855606079102, -1.57578029961693, 218, 29, 'PPL', 'P'),
(64184, 'Dellwood', 35.5233306884766, 0.61999908178866, -83.0286102294922, -1.44912262185968, 218, 33, 'PPL', 'P'),
(80670, 'Dellwood', 32.7333297729492, 0.571304379679052, -79.9227828979492, -1.39491570892583, 218, 48, 'PPL', 'P'),
(86285, 'Dellwood', 35.7713890075684, 0.624328516193775, -83.914436340332, -1.46458320409397, 218, 50, 'PPL', 'P'),
(101376, 'Dellwood', 37.7099990844727, 0.658163644948095, -77.4691696166992, -1.35209207859735, 218, 53, 'PPL', 'P'),
(134986, 'Dellwood', 45.0900001525879, 0.786968962387404, -92.9722213745117, -1.62267137587828, 218, 28, 'PPL', 'P'),
(148253, 'Dellwood', 42.9166717529297, 0.749037226086269, -78.57861328125, -1.37145552340916, 218, 40, 'PPL', 'P'),
(173791, 'Dellwood', 43.5633316040039, 0.760323569627971, -89.8405609130859, -1.56801358977187, 218, 57, 'PPL', 'P'),
(200682, 'Dellwood', 43.3691711425781, 0.756934830298899, -124.01277923584, -2.16443131221426, 218, 43, 'PPL', 'P'),
(2020, 'Delma', 33.3861083984375, 0.582697515980465, -88.184440612793, -1.53910883772264, 218, 2, 'PPL', 'P'),
(2021, 'Delmar', 34.1699981689453, 0.596378973448529, -87.605827331543, -1.52901013086906, 218, 2, 'PPL', 'P'),
(8469, 'Delmar', 36.1605606079102, 0.631120841974995, -93.3408279418945, -1.62910477412358, 218, 4, 'PPL', 'P'),
(13648, 'Delmar', 38.4563903808594, 0.671190630578272, -75.5774993896484, -1.31907620477337, 218, 10, 'PPL', 'P'),
(20540, 'Delmar', 30.8852806091309, 0.539049837031693, -83.1377792358398, -1.45102798046158, 218, 13, 'PPL', 'P'),
(46277, 'Delmar', 38.4558296203613, 0.671180843461266, -75.5777816772461, -1.31908113162139, 218, 25, 'PPL', 'P'),
(54409, 'Delmar', 37.7825012207031, 0.659429045940046, -92.5500030517578, -1.61530227598397, 218, 29, 'PPL', 'P'),
(64183, 'Delmar', 36.2555618286133, 0.632778926069678, -77.6272201538086, -1.35485058085446, 218, 33, 'PPL', 'P'),
(80658, 'Delmar', 34.922779083252, 0.609517478949353, -81.8777770996094, -1.4290367946022, 218, 48, 'PPL', 'P'),
(101377, 'Delmar', 36.6427803039551, 0.639537163388945, -81.8594436645508, -1.42871681579722, 218, 53, 'PPL', 'P'),
(108838, 'Delmar', 39.6044387817383, 0.691227855145865, -80.0074996948242, -1.39639429596304, 218, 58, 'PPL', 'P'),
(115245, 'Delmar', 42.0022201538086, 0.733077034831479, -90.6069412231445, -1.58138944950485, 218, 16, 'PPL', 'P'),
(148254, 'Delmar', 42.621940612793, 0.743893197282727, -73.8330612182617, -1.2886300150852, 218, 40, 'PPL', 'P'),
(200683, 'Delmar', 43.2605590820313, 0.755039192234981, -124.226112365723, -2.1681546777343, 218, 43, 'PPL', 'P'),
(80659, 'Delmar Estates', 34.913890838623, 0.609362349815856, -81.8694381713867, -1.42889125284862, 218, 48, 'PPL', 'P'),
(35554, 'Delmer', 37.0288887023926, 0.646276026211281, -84.7347183227539, -1.47889982548202, 218, 21, 'PPL', 'P'),
(93690, 'Delmer', 31.8263893127441, 0.555475282528921, -95.2191696166992, -1.66188802082635, 218, 51, 'PPL', 'P'),
(93691, 'Delmita', 26.6797199249268, 0.465648956199906, -98.4122161865234, -1.71761719663929, 218, 51, 'PPL', 'P'),
(54410, 'Delmo', 36.8102798461914, 0.642460581896552, -89.6811065673828, -1.56523058643274, 218, 29, 'PPL', 'P'),
(181102, 'Delmonico Place', 39.9755592346191, 0.697705128970128, -123.317222595215, -2.15229155870125, 218, 6, 'PPL', 'P'),
(46278, 'Delmont', 39.1263885498047, 0.682884304608701, -76.6811065673828, -1.33833778367348, 218, 25, 'PPL', 'P'),
(70733, 'Delmont', 39.214168548584, 0.684416354604796, -74.9502792358398, -1.30812914795454, 218, 37, 'PPL', 'P'),
(72306, 'Delmont', 39.6827812194824, 0.692595188628539, -82.6808319091797, -1.44305274510317, 218, 41, 'PPL', 'P'),
(160729, 'Delmont', 40.4130592346191, 0.705340944447604, -79.570556640625, -1.38876820102354, 218, 45, 'PPL', 'P'),
(170147, 'Delmont', 43.2675018310547, 0.75516036606458, -98.1619415283203, -1.71324907981934, 218, 49, 'PPL', 'P'),
(40047, 'Delmont Place', 30.4947204589844, 0.532233276484554, -91.1580581665039, -1.59100825473, 218, 22, 'PPL', 'P'),
(190112, 'Delmues (historical)', 37.8666687011719, 0.660898045597334, -114.316108703613, -1.9951924849458, 218, 39, 'PPL', 'P'),
(80661, 'Deloach (historical)', 34.1819381713867, 0.596587365803828, -80.583610534668, -1.40644932697474, 218, 48, 'PPL', 'P'),
(113155, 'Deloit', 42.1180610656738, 0.73509884015204, -98.3197174072266, -1.71600278838649, 218, 35, 'PPL', 'P'),
(115246, 'Deloit', 42.0977783203125, 0.734744839464141, -95.3222198486328, -1.66368658666853, 218, 16, 'PPL', 'P'),
(40048, 'Delombre', 30.7194404602051, 0.536155380400941, -91.2738876342773, -1.59302986031348, 218, 22, 'PPL', 'P'),
(108817, 'DeLong', 39.4013900756836, 0.687683986683296, -81.1627807617188, -1.4165577543663, 218, 58, 'PPL', 'P'),
(119336, 'DeLong', 40.8166694641113, 0.712385271846972, -90.304443359375, -1.57610986580182, 218, 18, 'PPL', 'P'),
(122494, 'Delong', 41.1383285522461, 0.717999282003886, -86.416389465332, -1.50825052385579, 218, 19, 'PPL', 'P'),
(108839, 'Delorme', 37.5691719055176, 0.655705746999034, -82.142219543457, -1.43365218592936, 218, 58, 'PPL', 'P'),
(134988, 'Delorme', 47.764720916748, 0.833651646293458, -96.2888870239258, -1.68055811164835, 218, 28, 'PPL', 'P'),
(101378, 'Delos', 38.0963897705078, 0.664907434618448, -77.272216796875, -1.34865460342034, 218, 53, 'PPL', 'P'),
(122495, 'Delp', 40.4894409179688, 0.70667405631027, -86.8091735839844, -1.51510589997581, 218, 19, 'PPL', 'P'),
(13649, 'Delpark Manor', 39.7166709899902, 0.693186676706645, -75.658332824707, -1.32048701436084, 218, 10, 'PPL', 'P'),
(20541, 'Delph (historical)', 33.5727806091309, 0.585955560679041, -82.2505569458008, -1.43554303030331, 218, 13, 'PPL', 'P'),
(78127, 'Delphene', 39.8300018310547, 0.695164673027275, -80.3802795410156, -1.40290053166416, 218, 45, 'PPL', 'P'),
(108840, 'Delphi', 38.3880615234375, 0.669998067042135, -80.670280456543, -1.40796200247391, 218, 58, 'PPL', 'P'),
(122496, 'Delphi', 40.5875015258789, 0.708385536784809, -86.6750030517578, -1.51276418242931, 218, 19, 'PPL', 'P'),
(154973, 'Delphi', 41.0311088562012, 0.716127945284915, -82.607780456543, -1.4417777567313, 218, 41, 'PPL', 'P'),
(160733, 'Delphi', 40.2694396972656, 0.702834310650594, -75.470832824707, -1.31721452201335, 218, 45, 'PPL', 'P'),
(207190, 'Delphi', 46.9791717529297, 0.819941226948539, -123.017501831055, -2.14706044453006, 218, 56, 'PPL', 'P'),
(148255, 'Delphi Falls', 42.8763885498047, 0.748334151558488, -75.9138870239258, -1.3249472765545, 218, 40, 'PPL', 'P'),
(35555, 'Delphia', 37.0294418334961, 0.646285680170233, -83.0869369506836, -1.45014061518637, 218, 21, 'PPL', 'P'),
(80662, 'Delphia', 34.9408302307129, 0.60983253090631, -81.2300033569336, -1.41773100998454, 218, 48, 'PPL', 'P'),
(196347, 'Delphia', 46.5047187805176, 0.811660460434074, -108.218612670898, -1.88877110304763, 218, 31, 'PPL', 'P'),
(32226, 'Delphos', 39.2738914489746, 0.685458715855453, -97.7716674804688, -1.70643751269925, 218, 20, 'PPL', 'P'),
(115247, 'Delphos', 40.6636085510254, 0.709713854957514, -94.3391723632813, -1.6465291713457, 218, 16, 'PPL', 'P'),
(154974, 'Delphos', 40.8433303833008, 0.712850592668436, -84.341667175293, -1.47203978883009, 218, 41, 'PPL', 'P'),
(181103, 'Delphos', 39.1902809143066, 0.683999436736145, -122.168891906738, -2.13224940728564, 218, 6, 'PPL', 'P'),
(188415, 'Delphos', 34.0752792358398, 0.594725816201863, -103.491943359375, -1.80627516090858, 218, 38, 'PPL', 'P'),
(8471, 'Delpro', 35.5522193908691, 0.620503284762039, -90.0844421386719, -1.57227012014215, 218, 4, 'PPL', 'P'),
(160731, 'Delps', 40.8019409179688, 0.712128210222752, -75.4502792358398, -1.31685579421452, 218, 45, 'PPL', 'P'),
(20544, 'Delray', 32.9519386291504, 0.575119823993781, -84.3013916015625, -1.47133684746036, 218, 13, 'PPL', 'P'),
(93692, 'Delray', 32.1533317565918, 0.561181504638579, -94.459716796875, -1.64863306860686, 218, 51, 'PPL', 'P'),
(108841, 'Delray', 39.1944389343262, 0.684072007875849, -78.6044387817383, -1.37190626342365, 218, 58, 'PPL', 'P'),
(130468, 'Delray', 42.2958297729492, 0.738201489401009, -83.1166687011719, -1.45065953212477, 218, 27, 'PPL', 'P'),
(15774, 'Delray Beach', 26.461109161377, 0.461833478595663, -80.0730590820313, -1.39753852312539, 218, 12, 'PPL', 'P'),
(15775, 'Delray Gardens', 26.4797191619873, 0.462158284380112, -80.1227798461914, -1.3984063141666, 218, 12, 'PPL', 'P'),
(15776, 'Delray Shores', 26.4708309173584, 0.462003155246615, -80.0975036621094, -1.39796516153202, 218, 12, 'PPL', 'P'),
(119357, 'Delrey', 40.672779083252, 0.709873910939027, -88.017219543457, -1.53619027948403, 218, 18, 'PPL', 'P'),
(93693, 'Delrose', 32.7855606079102, 0.572215979720186, -94.9558334350586, -1.65729193741709, 218, 51, 'PPL', 'P'),
(78128, 'Delroy', 39.9713897705078, 0.697632358093342, -76.5738906860352, -1.33646651353353, 218, 45, 'PPL', 'P'),
(13650, 'Delshire', 39.2077789306641, 0.684304834734149, -75.5627822875977, -1.31881934288623, 218, 10, 'PPL', 'P'),
(2022, 'Delta', 33.439998626709, 0.583638077898454, -85.690559387207, -1.4955823991825, 218, 2, 'PPL', 'P'),
(8472, 'Delta', 33.4716682434082, 0.5841908169827, -93.2847213745117, -1.62812552979076, 218, 4, 'PPL', 'P'),
(15777, 'Delta', 26.858060836792, 0.468761592302964, -80.2255630493164, -1.40020021947687, 218, 12, 'PPL', 'P'),
(35556, 'Delta', 36.8644409179688, 0.643405870925476, -84.6572189331055, -1.47754720596437, 218, 21, 'PPL', 'P'),
(40049, 'Delta', 32.3255615234375, 0.564187481139979, -90.9269409179688, -1.58697449778491, 218, 22, 'PPL', 'P'),
(54411, 'Delta', 37.1966705322266, 0.649204371566905, -89.7361068725586, -1.56619052284766, 218, 29, 'PPL', 'P'),
(59240, 'Delta', 34.4044418334961, 0.600470787305382, -90.5722198486328, -1.5807834471988, 218, 30, 'PPL', 'P'),
(64185, 'Delta', 36.4744415283203, 0.636599097495342, -80.1013870239258, -1.39803293898177, 218, 33, 'PPL', 'P'),
(78129, 'Delta', 39.7269401550293, 0.693365907448008, -76.3269424438477, -1.33215645362535, 218, 45, 'PPL', 'P'),
(80663, 'Delta', 34.5397186279297, 0.602831812769791, -81.561393737793, -1.42351486323997, 218, 48, 'PPL', 'P'),
(101381, 'Delta', 38.811939239502, 0.677396128813293, -77.0963897705078, -1.34558584289624, 218, 53, 'PPL', 'P'),
(112300, 'Delta', 37.6841697692871, 0.657712838354572, -88.7027816772461, -1.54815559594564, 218, 18, 'PPL', 'P'),
(115248, 'Delta', 41.3227806091309, 0.721218577708602, -92.3300018310547, -1.6114625303243, 218, 16, 'PPL', 'P'),
(154975, 'Delta', 41.5736083984375, 0.725596348487501, -84.0052795410156, -1.46616871704895, 218, 41, 'PPL', 'P'),
(177419, 'Delta', 46.4727783203125, 0.811102994238893, -91.2699966430664, -1.59296194970568, 218, 57, 'PPL', 'P'),
(186616, 'Delta', 38.7422218322754, 0.676179330511236, -108.068328857422, -1.88614815569001, 218, 7, 'PPL', 'P'),
(192534, 'Delta', 39.3522186279297, 0.686825783022018, -112.576393127441, -1.96482872009337, 218, 52, 'PPL', 'P'),
(193495, 'Delta', 40.9444389343262, 0.71461526978575, -122.423606872559, -2.13669502209331, 218, 6, 'PPL', 'P'),
(194828, 'Delta', 47.607780456543, 0.830912518533284, -115.940277099609, -2.02353957106277, 218, 17, 'PPL', 'P'),
(207191, 'Delta', 48.9811096191406, 0.85488163413427, -122.523612976074, -2.13844045787174, 218, 56, 'PPL', 'P'),
(141645, 'Delta (historical)', 40.5955581665039, 0.708526151690366, -96.024169921875, -1.67593792663122, 218, 35, 'PPL', 'P'),
(130469, 'Delta Center', 42.726390838623, 0.745716197627913, -84.6622161865234, -1.47763442449007, 218, 27, 'PPL', 'P'),
(59239, 'Delta City', 33.0738906860352, 0.577248288916, -90.7949981689453, -1.58467166239032, 218, 30, 'PPL', 'P'),
(93695, 'Delta Court Colonia', 26.1860008239746, 0.457031932308305, -98.0130004882813, -1.71064956827932, 218, 51, 'PPL', 'P'),
(46280, 'Delta Heights', 39.2044410705566, 0.684246578085304, -76.2319412231445, -1.33049836953067, 218, 25, 'PPL', 'P'),
(207194, 'Delta Junction', 48.0133285522461, 0.837990668078497, -122.1875, -2.13257417978057, 218, 56, 'PPL', 'P'),
(211782, 'Delta Junction', 64.0377807617188, 1.11767011996227, -145.732223510742, -2.54350712651474, 218, 1, 'PPL', 'P'),
(160732, 'Delta Manor', 40.6575012207031, 0.709607261934883, -75.4075012207031, -1.31610917700291, 218, 45, 'PPL', 'P'),
(130471, 'Delta Mills', 42.7649993896484, 0.746390043962731, -84.6474990844727, -1.47737756260293, 218, 27, 'PPL', 'P'),
(93696, 'Delta West Colonia', 26.3120002746582, 0.459231037578438, -98.0350036621094, -1.71103359610851, 218, 51, 'PPL', 'P'),
(93697, 'Delta-Rodger Colonia', 26.3169994354248, 0.459318289393652, -98.036003112793, -1.71105103981365, 218, 51, 'PPL', 'P'),
(101379, 'Deltaville', 37.5547218322754, 0.655453545643803, -76.3372192382813, -1.33233581752477, 218, 53, 'PPL', 'P'),
(130473, 'Delton', 42.4997215270996, 0.741760071828601, -85.4080581665039, -1.49065182274032, 218, 27, 'PPL', 'P'),
(15778, 'Deltona', 28.9002799987793, 0.504405040726962, -81.2638931274414, -1.41832249806264, 218, 12, 'PPL', 'P'),
(8473, 'Deluce', 34.208610534668, 0.597052886362374, -91.2466735839844, -1.59255488553306, 218, 4, 'PPL', 'P'),
(178061, 'DeLuxe Trailer Court', 33.4516716003418, 0.583841809721845, -112.10417175293, -1.95658690230985, 218, 5, 'PPL', 'P'),
(181047, 'DeLuz', 33.3588905334473, 0.582222474621022, -117.269996643066, -2.04674755522421, 218, 6, 'PPL', 'P'),
(101380, 'Delvale', 36.8197212219238, 0.642625364989001, -82.9522171020508, -1.44778931025994, 218, 53, 'PPL', 'P'),
(35557, 'Delville', 38.4775009155273, 0.671559078915085, -85.0975036621094, -1.48523162413174, 218, 21, 'PPL', 'P'),
(154978, 'Delvin (historical)', 40.3250007629395, 0.703804034182519, -84.5344390869141, -1.47540429339324, 218, 41, 'PPL', 'P'),
(35558, 'Delvinta', 37.5008316040039, 0.654512983725814, -83.7938919067383, -1.46247930683281, 218, 21, 'PPL', 'P'),
(64186, 'Delway', 34.8011093139648, 0.607393940875152, -78.2141723632813, -1.36509482946161, 218, 33, 'PPL', 'P'),
(130474, 'Delwin', 43.6972198486328, 0.762660360326461, -84.6780624389648, -1.47791099376928, 218, 27, 'PPL', 'P'),
(191373, 'Delwin', 33.8763885498047, 0.591254518878999, -100.398612976074, -1.752286360868, 218, 51, 'PPL', 'P'),
(26933, 'Delwood', 37.579719543457, 0.655889838009386, -88.5713882446289, -1.54586234793098, 218, 18, 'PPL', 'P'),
(15779, 'Delwood Beach', 30.1444396972656, 0.526119723886168, -85.7133331298828, -1.49597987597519, 218, 12, 'PPL', 'P'),
(13651, 'Delwoods', 39.7799987792969, 0.694291955138056, -75.5361099243164, -1.31835382232769, 218, 10, 'PPL', 'P'),
(35559, 'Dema', 37.420280456543, 0.653107100986362, -82.8052825927734, -1.44522481928824, 218, 21, 'PPL', 'P'),
(145093, 'Demarest', 40.957218170166, 0.714838309527044, -73.9638900756836, -1.29091340940384, 218, 37, 'PPL', 'P'),
(46279, 'Dembeigh Hill', 39.3752784729004, 0.687228253241757, -76.6430587768555, -1.33767372445567, 218, 25, 'PPL', 'P'),
(20543, 'Demere Park', 31.1380596160889, 0.543461662983032, -81.3902816772461, -1.42052839439356, 218, 13, 'PPL', 'P'),
(196348, 'Demers (historical)', 48.8849983215332, 0.853204175542656, -112.16667175293, -1.95767773309234, 218, 31, 'PPL', 'P'),
(196349, 'Demersville (historical)', 48.1627807617188, 0.840599101208175, -114.268058776855, -1.99435385551853, 218, 31, 'PPL', 'P'),
(122497, 'Deming', 40.1152801513672, 0.700143719001287, -86.0986099243164, -1.50270422456959, 218, 19, 'PPL', 'P'),
(188418, 'Deming', 32.2686080932617, 0.563193456263106, -107.758056640625, -1.88073288392945, 218, 38, 'PPL', 'P'),
(207193, 'Deming', 48.8258285522461, 0.852171468250951, -122.214721679688, -2.13304928771904, 218, 56, 'PPL', 'P'),
(29627, 'Deming Park', 39.4661102294922, 0.688813566459654, -87.3544387817383, -1.52462257297316, 218, 19, 'PPL', 'P'),
(29626, 'Deming Woods', 39.4599990844727, 0.688706906857996, -87.357780456543, -1.52468089620103, 218, 19, 'PPL', 'P'),
(8474, 'Democrat', 35.0202789306641, 0.611219172306887, -90.4250030517578, -1.57821402937909, 218, 4, 'PPL', 'P'),
(35562, 'Democrat', 37.2333297729492, 0.649844196018797, -82.8033294677734, -1.44519073082629, 218, 21, 'PPL', 'P'),
(64188, 'Democrat', 35.7838897705078, 0.624546695666079, -82.4869384765625, -1.43966866630601, 218, 33, 'PPL', 'P'),
(93698, 'Democrat', 31.687219619751, 0.5530463131672, -98.658332824707, -1.72191274231954, 218, 51, 'PPL', 'P'),
(194829, 'Democrat', 43.0963897705078, 0.752173897218165, -116.774436950684, -2.03809840695196, 218, 17, 'PPL', 'P'),
(181105, 'Democrat (historical)', 39.2833290100098, 0.685623432368875, -120.778327941895, -2.10797948763953, 218, 6, 'PPL', 'P'),
(93699, 'Democrat Crossing', 30.8105602264404, 0.537745720335395, -96.1747207641602, -1.67856553452075, 218, 51, 'PPL', 'P'),
(26934, 'Democrat Spring', 39.0838890075684, 0.682142547666087, -90.4836120605469, -1.57923694955379, 218, 18, 'PPL', 'P'),
(108819, 'DeMoor Subdivision', 39.2397193908691, 0.68486230092933, -81.6730575561523, -1.42546376452569, 218, 58, 'PPL', 'P'),
(2025, 'Demopolis', 32.5175018310547, 0.567537471475189, -87.8363876342773, -1.53303416727617, 218, 2, 'PPL', 'P'),
(20545, 'Demorest', 34.564998626709, 0.60327303198339, -83.545280456543, -1.45814021846875, 218, 13, 'PPL', 'P'),
(86287, 'Demory', 36.3363914489746, 0.63418966907812, -84.0661087036133, -1.46723038621751, 218, 50, 'PPL', 'P'),
(35529, 'DeMossville', 38.8050003051758, 0.677275021562722, -84.4169387817383, -1.47335352619582, 218, 21, 'PPL', 'P'),
(122479, 'DeMotte', 41.1949996948242, 0.718988380032742, -87.1986083984375, -1.52190281970991, 218, 19, 'PPL', 'P'),
(35560, 'Demplytown', 38.3844413757324, 0.669934883545273, -85.4744415283203, -1.49181043097256, 218, 21, 'PPL', 'P'),
(2026, 'Dempsey', 34.4841690063477, 0.601862288974948, -87.9497222900391, -1.53501223017583, 218, 2, 'PPL', 'P'),
(20546, 'Dempsey', 32.2463912963867, 0.562805700008391, -83.2375030517578, -1.452768489392, 218, 13, 'PPL', 'P'),
(75636, 'Dempsey', 35.5175018310547, 0.619897349035019, -99.8225021362305, -1.74223132985629, 218, 42, 'PPL', 'P'),
(108842, 'Dempsey', 38.0538902282715, 0.664165677675834, -81.1627807617188, -1.4165577543663, 218, 58, 'PPL', 'P'),
(194830, 'Dempsey (historical)', 42.6236114501953, 0.743922358896663, -111.99388885498, -1.95466210263199, 218, 17, 'PPL', 'P'),
(113133, 'Dempsey Landing', 41.7125015258789, 0.728020490869746, -73.2275009155273, -1.27806099398311, 218, 8, 'PPL', 'P'),
(160734, 'Dempseytown', 41.5130615234375, 0.724539606166958, -79.7783279418945, -1.39239449432185, 218, 45, 'PPL', 'P'),
(35561, 'Dempster', 37.6252784729004, 0.656684991331856, -86.5597229003906, -1.51075216422575, 218, 21, 'PPL', 'P'),
(170149, 'Dempster', 44.6319389343262, 0.778974285953041, -96.9513931274414, -1.69212102446925, 218, 49, 'PPL', 'P'),
(148256, 'Dempster Corners', 43.089168548584, 0.752047863119577, -74.581672668457, -1.30169574970924, 218, 40, 'PPL', 'P'),
(148257, 'Demster', 43.4961090087891, 0.759150314009736, -76.3172225952148, -1.33198681026391, 218, 40, 'PPL', 'P'),
(148258, 'Demster Beach', 43.5141716003418, 0.759465565703774, -76.3091735839844, -1.33184632851641, 218, 40, 'PPL', 'P'),
(160735, 'Demunds Corners', 41.3805618286133, 0.722227050234387, -75.9441680908203, -1.32547578087283, 218, 45, 'PPL', 'P'),
(193496, 'Demuth', 41.3377799987793, 0.721480366443756, -121.264999389648, -2.11647350677828, 218, 6, 'PPL', 'P'),
(20547, 'Den Court', 33.9005584716797, 0.591676363595667, -83.4655609130859, -1.45674884995723, 218, 13, 'PPL', 'P'),
(101382, 'Den Hill', 37.1555595397949, 0.648486849390211, -80.3133316040039, -1.40173206973589, 218, 53, 'PPL', 'P'),
(46286, 'Den Mar', 38.6705589294434, 0.67492857690528, -76.6041717529297, -1.33699501785186, 218, 25, 'PPL', 'P'),
(203709, 'Den-Mar', 40.707218170166, 0.710474986397058, -112.089721679688, -1.95633470095462, 218, 52, 'PPL', 'P'),
(203710, 'Den-Mar Condominium', 40.7069396972656, 0.710470126128069, -112.088890075684, -1.95632018672667, 218, 52, 'PPL', 'P'),
(181106, 'Denair', 37.5263900756836, 0.654959063208403, -120.795829772949, -2.10828495221656, 218, 6, 'PPL', 'P'),
(101383, 'Denaro', 37.2449989318848, 0.65004786126316, -77.9844436645508, -1.36108530728244, 218, 53, 'PPL', 'P'),
(15780, 'Denaud', 26.7419395446777, 0.4667348934239, -81.5102767944336, -1.4226227042748, 218, 12, 'PPL', 'P'),
(148259, 'Denault Corners', 42.6005592346191, 0.74352002183498, -73.5175018310547, -1.28312246479286, 218, 40, 'PPL', 'P'),
(160736, 'Denbeau Heights', 40.024169921875, 0.6985535455144, -79.916389465332, -1.39480412247615, 218, 45, 'PPL', 'P'),
(101384, 'Denbigh', 37.1277809143066, 0.648002020913762, -76.5397186279297, -1.33587009860741, 218, 53, 'PPL', 'P'),
(198180, 'Denbigh', 48.3152809143066, 0.843260730980627, -100.586669921875, -1.75556857375347, 218, 34, 'PPL', 'P'),
(46281, 'Denbigh (historical)', 39.1569404602051, 0.683417536037962, -76.2436065673828, -1.330701968196, 218, 25, 'PPL', 'P'),
(160737, 'Denbo', 40.0122184753418, 0.69834495342202, -79.9319381713867, -1.39507549859123, 218, 45, 'PPL', 'P'),
(202056, 'Denby', 43.0608291625977, 0.751553247526122, -102.337219238281, -1.78612142304329, 218, 49, 'PPL', 'P'),
(46282, 'Denby Hill', 38.2880592346191, 0.668252697842724, -76.7761077880859, -1.33999586776816, 218, 25, 'PPL', 'P'),
(101385, 'Denby Park', 36.9152793884277, 0.644293169621663, -76.2624969482422, -1.33103166753895, 218, 53, 'PPL', 'P'),
(200684, 'Dencer (historical)', 44.8722190856934, 0.783167965721589, -123.080558776855, -2.14816099585053, 218, 43, 'PPL', 'P'),
(46283, 'Dendor Mar Estates', 39.3061103820801, 0.686021042319624, -77.1388931274414, -1.34632766641788, 218, 25, 'PPL', 'P'),
(64189, 'Dendron', 35.649169921875, 0.622195390739648, -82.230827331543, -1.43519868357437, 218, 33, 'PPL', 'P'),
(101386, 'Dendron', 37.045280456543, 0.646562116291383, -76.936393737793, -1.34279338533523, 218, 53, 'PPL', 'P'),
(198182, 'Dengate', 46.8455581665039, 0.817609229940011, -101.63500213623, -1.77386542254869, 218, 34, 'PPL', 'P'),
(59241, 'Denham', 31.6536102294922, 0.552459718647597, -88.5255584716797, -1.54506246749757, 218, 30, 'PPL', 'P'),
(122499, 'Denham', 41.1519393920898, 0.718236835973121, -86.7136077880859, -1.5134379621851, 218, 19, 'PPL', 'P'),
(134991, 'Denham', 46.3638916015625, 0.809202562485013, -92.9427795410156, -1.62215751894595, 218, 28, 'PPL', 'P'),
(40051, 'Denham Springs', 30.4866695404053, 0.532092761447538, -90.9561080932617, -1.58748356102728, 218, 22, 'PPL', 'P'),
(40052, 'Denhart', 31.8972206115723, 0.556711521906935, -91.2975006103516, -1.59344198449217, 218, 22, 'PPL', 'P'),
(115249, 'Denhart', 42.9661102294922, 0.749900090279455, -93.871940612793, -1.63837443892982, 218, 16, 'PPL', 'P'),
(93700, 'Denhawken', 29.1749992370605, 0.50919979595354, -97.9188919067383, -1.70900706367701, 218, 51, 'PPL', 'P'),
(198183, 'Denhoff', 47.4766693115234, 0.828624197366633, -100.259170532227, -1.74985263110583, 218, 34, 'PPL', 'P'),
(160738, 'Denholm', 40.600830078125, 0.708618163906028, -77.4336090087891, -1.35147142890531, 218, 45, 'PPL', 'P'),
(8476, 'Denieville (historical)', 35.8041687011719, 0.624900629774951, -91.7236099243164, -1.60087899499427, 218, 4, 'PPL', 'P'),
(199914, 'Denio', 41.9900016784668, 0.732863782207191, -118.633331298828, -2.07054223377379, 218, 39, 'PPL', 'P'),
(199915, 'Denio Junction', 41.9516716003418, 0.732194796141363, -118.623893737793, -2.07037751726037, 218, 39, 'PPL', 'P'),
(32227, 'Denison', 39.3916702270508, 0.687514343321858, -95.6277770996094, -1.66901956675142, 218, 20, 'PPL', 'P'),
(93704, 'Denison', 33.7555618286133, 0.58914569476982, -96.5363922119141, -1.68487789209451, 218, 51, 'PPL', 'P'),
(115250, 'Denison', 42.0177803039551, 0.73334861068364, -95.3550033569336, -1.66425876682874, 218, 16, 'PPL', 'P'),
(160739, 'Denison', 40.2905616760254, 0.703202958724488, -79.4641723632813, -1.38691144511154, 218, 45, 'PPL', 'P'),
(207195, 'Denison', 47.9097213745117, 0.836182381698333, -117.4375, -2.04967104031084, 218, 56, 'PPL', 'P'),
(148260, 'Denison Corner', 42.8358306884766, 0.747626283340745, -77.5730590820313, -1.35390529182554, 218, 40, 'PPL', 'P'),
(46284, 'Denit Estates', 39.2052803039551, 0.684261225471299, -77.0261077880859, -1.34435919089815, 218, 25, 'PPL', 'P'),
(54412, 'Denlow', 36.9808311462402, 0.645437263625961, -92.3733291625977, -1.61221873491583, 218, 29, 'PPL', 'P'),
(75635, 'Denman', 34.9377784729004, 0.609779267684508, -95.0250015258789, -1.65849914833922, 218, 42, 'PPL', 'P'),
(141646, 'Denman', 40.6994400024414, 0.710339231760492, -98.7241668701172, -1.72306176317185, 218, 35, 'PPL', 'P'),
(181107, 'Denman (historical)', 38.2727813720703, 0.66798604883858, -122.67472076416, -2.14107778629925, 218, 6, 'PPL', 'P'),
(93701, 'Denman Crossroads', 32.398609161377, 0.565462402932827, -95.8902816772461, -1.67360113593274, 218, 51, 'PPL', 'P'),
(108843, 'Denmar', 38.086109161377, 0.664728004140004, -80.2225036621094, -1.40014682309702, 218, 58, 'PPL', 'P'),
(8477, 'Denmark', 35.4841690063477, 0.619315581494891, -91.5830612182617, -1.5984259573142, 218, 4, 'PPL', 'P'),
(20548, 'Denmark', 32.2844390869141, 0.563469759226202, -81.7241668701172, -1.42635579033281, 218, 13, 'PPL', 'P'),
(26936, 'Denmark', 37.997501373291, 0.663181506494995, -89.4972229003906, -1.56202121100309, 218, 18, 'PPL', 'P'),
(29628, 'Denmark', 39.269718170166, 0.68538587839964, -87.0258331298828, -1.51888732240762, 218, 19, 'PPL', 'P'),
(32228, 'Denmark', 39.089168548584, 0.682234693039804, -98.2866668701172, -1.71542594769437, 218, 20, 'PPL', 'P'),
(59242, 'Denmark', 34.3108291625977, 0.598836937976618, -89.3466720581055, -1.55939360311356, 218, 30, 'PPL', 'P'),
(80664, 'Denmark', 33.3224983215332, 0.581587310701038, -81.1425018310547, -1.41620382025743, 218, 48, 'PPL', 'P'),
(86289, 'Denmark', 35.5327796936035, 0.620163998039163, -89.0038909912109, -1.55341094488275, 218, 50, 'PPL', 'P'),
(101387, 'Denmark', 37.8672218322754, 0.660907699556285, -79.5497207641602, -1.38840454637669, 218, 53, 'PPL', 'P'),
(115252, 'Denmark', 40.7416687011719, 0.711076261592171, -91.3372192382813, -1.59413520532392, 218, 16, 'PPL', 'P'),
(127245, 'Denmark', 43.9702796936035, 0.767426153676185, -70.8038864135742, -1.23576094112495, 218, 26, 'PPL', 'P'),
(148262, 'Denmark', 42.1569404602051, 0.735777413597792, -77.0533294677734, -1.34483429883662, 218, 40, 'PPL', 'P'),
(154979, 'Denmark', 40.586669921875, 0.708371022556868, -82.9180603027344, -1.44719316164992, 218, 41, 'PPL', 'P'),
(173795, 'Denmark', 44.3477783203125, 0.774014747634014, -87.8272171020508, -1.53287411129466, 218, 57, 'PPL', 'P'),
(200685, 'Denmark', 42.8908309936523, 0.748586219755665, -124.461387634277, -2.1722610058191, 218, 43, 'PPL', 'P'),
(119360, 'Denmark (historical)', 40.1630592346191, 0.700977621317618, -87.6430587768555, -1.52965994217504, 218, 18, 'PPL', 'P'),
(154980, 'Denmark (historical)', 41.4883308410645, 0.724107974333283, -84.7294387817383, -1.47880768010831, 218, 41, 'PPL', 'P'),
(154981, 'Denmark Center', 41.7516708374023, 0.728704124321569, -80.6680603027344, -1.40792325348005, 218, 41, 'PPL', 'P'),
(130475, 'Denmark Junction', 43.415828704834, 0.757749158381218, -83.6549987792969, -1.46005516445057, 218, 27, 'PPL', 'P'),
(40053, 'Denmark Landing', 31.7999992370605, 0.555014688818391, -91.5774993896484, -1.59832888509246, 218, 22, 'PPL', 'P'),
(46285, 'Denmore Park', 39.3450012207031, 0.686699815502458, -76.67138671875, -1.33816814031204, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(8479, 'Dennard', 35.7566719055176, 0.624071654306637, -92.5244369506836, -1.61485606334333, 218, 4, 'PPL', 'P'),
(178069, 'Dennehotso', 36.8458290100098, 0.643081031851513, -109.845832824707, -1.9171714523864, 218, 5, 'PPL', 'P'),
(15781, 'Dennet', 30.5361099243164, 0.532955658930238, -83.6113891601563, -1.45929403301102, 218, 12, 'PPL', 'P'),
(35563, 'Denney', 36.8133316040039, 0.642513845118354, -84.6569366455078, -1.47754227911636, 218, 21, 'PPL', 'P'),
(46288, 'Denneys Delight', 39.4874992370605, 0.689186875065455, -77.2619400024414, -1.34847523952092, 218, 25, 'PPL', 'P'),
(148264, 'Dennies Crossing', 43.0736083984375, 0.751776287267416, -74.3099975585938, -1.29695412454641, 218, 40, 'PPL', 'P'),
(148265, 'Dennies Hollow', 43.127498626709, 0.752716849185405, -74.2522201538086, -1.29594571859965, 218, 40, 'PPL', 'P'),
(8480, 'Denning', 35.4291687011719, 0.618355645079972, -93.7569427490234, -1.63636734757428, 218, 4, 'PPL', 'P'),
(93702, 'Denning', 31.514440536499, 0.550030749285876, -94.245002746582, -1.64488560147896, 218, 51, 'PPL', 'P'),
(148266, 'Denning', 41.9508285522461, 0.73218008217634, -74.4894409179688, -1.30008600198834, 218, 40, 'PPL', 'P'),
(615, 'Dennings', 39.4916687011719, 0.689259645942242, -77.0725021362305, -1.34516892502758, 218, 25, 'PPL', 'P'),
(20550, 'Dennis', 33.214168548584, 0.579696599485137, -83.3424987792969, -1.45460101053809, 218, 13, 'PPL', 'P'),
(32229, 'Dennis', 37.3469390869141, 0.651827052608415, -95.4124984741211, -1.66526224592748, 218, 20, 'PPL', 'P'),
(35565, 'Dennis', 36.8427810668945, 0.643027835208739, -86.7872161865234, -1.51472267109495, 218, 21, 'PPL', 'P'),
(59243, 'Dennis', 34.5586090087891, 0.603161512112743, -88.2261123657227, -1.53983614701634, 218, 30, 'PPL', 'P'),
(64190, 'Dennis', 36.2249984741211, 0.632245494903335, -80.170280456543, -1.39923535621394, 218, 33, 'PPL', 'P'),
(72307, 'Dennis', 38.7069396972656, 0.675563541088182, -83.0772171020508, -1.44997097182493, 218, 41, 'PPL', 'P'),
(75637, 'Dennis', 36.5391693115234, 0.637728810429754, -94.8838882446289, -1.65603625696312, 218, 42, 'PPL', 'P'),
(93703, 'Dennis', 32.6186103820801, 0.569302148592503, -97.9263916015625, -1.70913795804459, 218, 51, 'PPL', 'P'),
(108844, 'Dennis', 37.9305610656738, 0.662013177724777, -80.711669921875, -1.40868438491959, 218, 58, 'PPL', 'P'),
(124634, 'Dennis', 41.735279083252, 0.728418034241467, -70.1944427490234, -1.22512414257312, 218, 23, 'PPL', 'P'),
(192535, 'Dennis', 39.8333282470703, 0.695222729939038, -112.083061218262, -1.95621845397303, 218, 52, 'PPL', 'P'),
(200686, 'Dennis', 44.0908317565918, 0.769530184095402, -117.322776794434, -2.04766874264526, 218, 43, 'PPL', 'P'),
(202057, 'Dennis', 43.2613906860352, 0.755053706462922, -103.866386413574, -1.81281042506557, 218, 49, 'PPL', 'P'),
(46287, 'Dennis (historical)', 39.3663902282715, 0.687073124108259, -77.3333282470703, -1.34972119943691, 218, 25, 'PPL', 'P'),
(54413, 'Dennis Acres', 37.0466690063477, 0.646586351057303, -94.5052795410156, -1.64942828850836, 218, 29, 'PPL', 'P'),
(188416, 'Dennis Chaves Estates', 35.1227798461914, 0.613008150769148, -106.317497253418, -1.85559037955217, 218, 38, 'PPL', 'P'),
(59244, 'Dennis Crossroads', 31.7580604553223, 0.554282718992783, -90.9594421386719, -1.5875417510971, 218, 30, 'PPL', 'P'),
(59245, 'Dennis Landing', 34.0186080932617, 0.593736718173007, -90.9280624389648, -1.58699407201892, 218, 30, 'PPL', 'P'),
(211784, 'Dennis Manor', 64.8291702270508, 1.13148247179792, -147.53971862793, -2.57505386752338, 218, 1, 'PPL', 'P'),
(160740, 'Dennis Mills', 41.0602798461914, 0.716637075106311, -76.3186111450195, -1.33201104502983, 218, 45, 'PPL', 'P'),
(124635, 'Dennis Port', 41.6583290100098, 0.72707500210374, -70.1291732788086, -1.22398497541684, 218, 23, 'PPL', 'P'),
(59246, 'Dennis Settlement', 32.3608283996582, 0.564803004246923, -89.3491668701172, -1.55943714579738, 218, 30, 'PPL', 'P'),
(462, 'Dennison', 39.4608306884766, 0.688721421085937, -87.5977783203125, -1.52886964912156, 218, 18, 'PPL', 'P'),
(40054, 'Dennison', 29.9491691589355, 0.522711610060166, -91.8361129760742, -1.60284254366598, 218, 22, 'PPL', 'P'),
(130477, 'Dennison', 43.0733299255371, 0.751771426998427, -85.9872207641602, -1.50076011697383, 218, 27, 'PPL', 'P'),
(134994, 'Dennison', 44.4069404602051, 0.775047321767665, -93.0391693115234, -1.62383983780655, 218, 28, 'PPL', 'P'),
(154983, 'Dennison', 40.3933296203613, 0.704996597718656, -81.3338928222656, -1.41954422321272, 218, 41, 'PPL', 'P'),
(178070, 'Dennison', 35.086669921875, 0.61237791369718, -110.904167175293, -1.93564287139108, 218, 5, 'PPL', 'P'),
(196350, 'Dennison (historical)', 46.9638900756836, 0.819674511365368, -111.941673278809, -1.95375076890697, 218, 31, 'PPL', 'P'),
(148269, 'Dennison Corners', 42.9608306884766, 0.749807944905738, -75.0149993896484, -1.3092587277309, 218, 40, 'PPL', 'P'),
(8481, 'Dennison Heights', 35.7374992370605, 0.623737028115668, -91.6391677856445, -1.59940520164702, 218, 4, 'PPL', 'P'),
(188417, 'Dennison Place', 35.2550010681152, 0.615315846432729, -106.04972076416, -1.85091679815519, 218, 38, 'PPL', 'P'),
(35564, 'Denniston', 37.915828704834, 0.66175604952153, -83.5380630493164, -1.45801425094919, 218, 21, 'PPL', 'P'),
(101388, 'Denniston', 36.5705604553223, 0.63827668924501, -78.9400024414063, -1.3777629541349, 218, 53, 'PPL', 'P'),
(148270, 'Denniston', 41.4599990844727, 0.723613491897882, -74.1061096191406, -1.29339560869784, 218, 40, 'PPL', 'P'),
(127246, 'Dennistown', 45.6769409179688, 0.797213011257476, -70.2836074829102, -1.22668036075611, 218, 26, 'PPL', 'P'),
(70735, 'Dennisville', 39.1930618286133, 0.684047972847011, -74.8255615234375, -1.30595241323757, 218, 37, 'PPL', 'P'),
(26939, 'Denny', 38.0475006103516, 0.664054157805187, -89.3269424438477, -1.55904925638461, 218, 18, 'PPL', 'P'),
(75638, 'Denny', 34.5699996948242, 0.603360317088118, -96.8463897705078, -1.69028837016512, 218, 42, 'PPL', 'P'),
(80665, 'Denny', 34.0652809143066, 0.594551312571435, -81.7144393920898, -1.42618601381332, 218, 48, 'PPL', 'P'),
(193497, 'Denny', 40.9441719055176, 0.714610609253842, -123.385559082031, -2.15348425539544, 218, 6, 'PPL', 'P'),
(64191, 'Denny (historical)', 36.0916709899902, 0.629918491321851, -81.4227828979492, -1.42109564770574, 218, 33, 'PPL', 'P'),
(119361, 'Denny (historical)', 40.9947204589844, 0.715492847943958, -90.6986083984375, -1.58298934352972, 218, 18, 'PPL', 'P'),
(29629, 'Denny Corner', 39.8855590820313, 0.696134329980172, -85.8222198486328, -1.49788030772907, 218, 19, 'PPL', 'P'),
(80666, 'Denny Corner', 33.3033294677734, 0.581252751089097, -79.2347183227539, -1.38290671662233, 218, 48, 'PPL', 'P'),
(207196, 'Denny Creek', 47.4130592346191, 0.827513992087207, -121.441108703613, -2.11954719415039, 218, 56, 'PPL', 'P'),
(64192, 'Denny Store', 36.3833312988281, 0.635008924008456, -78.8208312988281, -1.37568302532355, 218, 33, 'PPL', 'P'),
(80667, 'Denny Terrace', 34.0652809143066, 0.594551312571435, -81.063606262207, -1.41482683281581, 218, 48, 'PPL', 'P'),
(160742, 'Dennys Corners', 41.6736106872559, 0.727341717686912, -80.2247161865234, -1.40018543893282, 218, 45, 'PPL', 'P'),
(160743, 'Dennys Mills', 40.7805595397949, 0.711755034775005, -79.7316665649414, -1.3915800996605, 218, 45, 'PPL', 'P'),
(127249, 'Dennysville', 44.9036102294922, 0.783715844536845, -67.2291717529297, -1.17337040047739, 218, 26, 'PPL', 'P'),
(148271, 'Dennytown', 41.4263916015625, 0.723026930667793, -73.8686065673828, -1.28925039846114, 218, 40, 'PPL', 'P'),
(115255, 'Denova', 40.9083290100098, 0.713985032713783, -91.6369400024414, -1.5993663194951, 218, 16, 'PPL', 'P'),
(119362, 'Denrock', 41.6997184753418, 0.727797384549424, -89.9755630493164, -1.57036982154632, 218, 18, 'PPL', 'P'),
(32234, 'Densmore', 39.6383285522461, 0.691819343223972, -99.7388916015625, -1.74077205073699, 218, 20, 'PPL', 'P'),
(2027, 'Denson', 32.9324989318848, 0.574780537270905, -85.3019409179688, -1.48879972736023, 218, 2, 'PPL', 'P'),
(40055, 'Denson', 30.264440536499, 0.528214133635947, -90.6338882446289, -1.58185976375336, 218, 22, 'PPL', 'P'),
(154984, 'Denson', 41.7055587768555, 0.727899317040147, -84.1483306884766, -1.4686654305709, 218, 41, 'PPL', 'P'),
(54414, 'Dent', 37.5533294677734, 0.655429244298856, -91.9736099243164, -1.60524231812425, 218, 29, 'PPL', 'P'),
(72308, 'Dent', 39.1858291625977, 0.683921739011342, -84.6513900756836, -1.47744547321073, 218, 41, 'PPL', 'P'),
(108845, 'Dent', 39.2941703796387, 0.685812649964325, -79.8775024414063, -1.39412541587235, 218, 58, 'PPL', 'P'),
(134996, 'Dent', 46.5536117553711, 0.812513803826363, -95.7161102294922, -1.67056127070646, 218, 28, 'PPL', 'P'),
(194156, 'Dent', 40.3097190856934, 0.703537318599347, -104.83332824707, -1.82968674373535, 218, 7, 'PPL', 'P'),
(194831, 'Dent', 46.6238899230957, 0.813740389245426, -116.202217102051, -2.02811128654805, 218, 17, 'PPL', 'P'),
(86291, 'Dent Acres', 35.1894416809082, 0.614171619270376, -85.204719543457, -1.48710289427168, 218, 50, 'PPL', 'P'),
(54416, 'Dent Ford', 37.7008285522461, 0.658003588966581, -91.4463882446289, -1.59604056392581, 218, 29, 'PPL', 'P'),
(181108, 'Dentens (historical)', 39.7727813720703, 0.694165987618495, -120.611106872559, -2.10506092940091, 218, 6, 'PPL', 'P'),
(8485, 'Denton', 34.836669921875, 0.608014590567195, -94.1908264160156, -1.64394004613392, 218, 4, 'PPL', 'P'),
(20551, 'Denton', 31.7224998474121, 0.55366206930074, -82.6938934326172, -1.44328071169249, 218, 13, 'PPL', 'P'),
(32230, 'Denton', 39.732780456543, 0.693467839938731, -95.269172668457, -1.66276073871557, 218, 20, 'PPL', 'P'),
(46289, 'Denton', 38.8844413757324, 0.678661529805244, -75.8274993896484, -1.32343952790336, 218, 25, 'PPL', 'P'),
(54419, 'Denton', 36.0897216796875, 0.629884469438925, -89.8913879394531, -1.56890068873098, 218, 29, 'PPL', 'P'),
(59251, 'Denton', 34.146110534668, 0.595962055579877, -90.3125, -1.57625048070738, 218, 30, 'PPL', 'P'),
(64193, 'Denton', 35.6333312988281, 0.621918954618498, -80.1161117553711, -1.39828993402696, 218, 33, 'PPL', 'P'),
(75640, 'Denton', 34.666389465332, 0.605042635948721, -98.1241683959961, -1.7125898142915, 218, 42, 'PPL', 'P'),
(86292, 'Denton', 35.8497200012207, 0.625695649939367, -83.1872177124023, -1.45189084465477, 218, 50, 'PPL', 'P'),
(93707, 'Denton', 32.2586097717285, 0.563018952632679, -99.5391693115234, -1.73728623918618, 218, 51, 'PPL', 'P'),
(112333, 'Denton', 38.264720916748, 0.667845367353996, -82.8625030517578, -1.44622350469702, 218, 21, 'PPL', 'P'),
(130478, 'Denton', 42.2577781677246, 0.737537363604171, -83.524169921875, -1.45777177013193, 218, 27, 'PPL', 'P'),
(141647, 'Denton', 40.7377815246582, 0.711008417563401, -96.8441696166992, -1.69024962117126, 218, 35, 'PPL', 'P'),
(148272, 'Denton', 41.4047203063965, 0.722648695213974, -74.404167175293, -1.29859769441315, 218, 40, 'PPL', 'P'),
(160744, 'Denton', 40.8269386291504, 0.712564502588334, -79.182502746582, -1.38199538289731, 218, 45, 'PPL', 'P'),
(194832, 'Denton', 48.2027816772461, 0.841297248887939, -116.247222900391, -2.02889678591157, 218, 17, 'PPL', 'P'),
(196351, 'Denton', 47.3197212219238, 0.825884936448405, -109.946670532227, -1.91893140239278, 218, 31, 'PPL', 'P'),
(2028, 'Denton (historical)', 34.5855598449707, 0.603631892940278, -87.9638900756836, -1.53525950468304, 218, 2, 'PPL', 'P'),
(2029, 'Denton Acres', 31.273889541626, 0.545832342406394, -85.4283294677734, -1.49100562369114, 218, 2, 'PPL', 'P'),
(86293, 'Denton Crossroads', 36.583610534668, 0.638504456097239, -85.6549987792969, -1.49496174949045, 218, 50, 'PPL', 'P'),
(20562, 'Denton Estates', 33.8369407653809, 0.590566025158186, -84.8411102294922, -1.48075671455208, 218, 13, 'PPL', 'P'),
(20552, 'Denton Farms', 33.8033294677734, 0.589979397349069, -84.8152770996094, -1.48030584137953, 218, 13, 'PPL', 'P'),
(160745, 'Denton Hill', 41.7602806091309, 0.728854393186077, -77.8808288574219, -1.35927688774423, 218, 45, 'PPL', 'P'),
(8491, 'Denton Island', 35.7552795410156, 0.62404735296169, -91.0299987792969, -1.58877319678515, 218, 4, 'PPL', 'P'),
(13653, 'Denton Manor', 38.5569381713867, 0.67294552057858, -75.1055603027344, -1.31083931383786, 218, 10, 'PPL', 'P'),
(20553, 'Denton Manor', 33.9230613708496, 0.592069113277427, -84.7855606079102, -1.47978719075724, 218, 13, 'PPL', 'P'),
(13654, 'Denton Mills', 38.5463905334473, 0.672761429568228, -75.1172180175781, -1.31104277934515, 218, 10, 'PPL', 'P'),
(78131, 'Denton Terrace', 39.9086112976074, 0.696536667041856, -76.6449966430664, -1.33770754660151, 218, 45, 'PPL', 'P'),
(13655, 'Denton Woods Mobile Home Park', 38.563060760498, 0.673052379917319, -75.1041717529297, -1.31081507907194, 218, 10, 'PPL', 'P'),
(32231, 'Dentonia', 39.6838912963867, 0.692614563125469, -98.4672164916992, -1.71857713305421, 218, 20, 'PPL', 'P'),
(64194, 'Dentons', 35.2572212219238, 0.615354595426589, -83.9124984741211, -1.46454938194813, 218, 33, 'PPL', 'P'),
(101389, 'Dentons Corner', 37.5555610656738, 0.655468193029799, -78.584716796875, -1.37156204985276, 218, 53, 'PPL', 'P'),
(59247, 'Dentontown', 33.7408294677734, 0.588888566566573, -89.4427795410156, -1.56107099512615, 218, 30, 'PPL', 'P'),
(8487, 'Dentontown (historical)', 35.0083312988281, 0.611010646793534, -93.504997253418, -1.6319700691404, 218, 4, 'PPL', 'P'),
(75641, 'Dentonville', 35.7411117553711, 0.623800078454476, -96.1394424438477, -1.67794981167673, 218, 42, 'PPL', 'P'),
(160746, 'Dents Run', 41.3580589294434, 0.721834300552628, -78.2675018310547, -1.36602560426259, 218, 45, 'PPL', 'P'),
(46290, 'Dentsville', 38.4816703796387, 0.671631849791871, -76.8927764892578, -1.34203212073764, 218, 25, 'PPL', 'P'),
(80668, 'Dentsville', 34.0638885498047, 0.594527011226488, -80.9583282470703, -1.41298938482171, 218, 48, 'PPL', 'P'),
(59248, 'Dentville', 31.9597206115723, 0.557802352689432, -90.5552825927734, -1.5804878363178, 218, 30, 'PPL', 'P'),
(86294, 'Dentville', 35.2816696166992, 0.615781300412247, -84.6069412231445, -1.47666969438519, 218, 50, 'PPL', 'P'),
(2033, 'Denver', 32.9938888549805, 0.575851993556471, -85.6066665649414, -1.49411819321517, 218, 2, 'PPL', 'P'),
(8488, 'Denver', 36.3925018310547, 0.635168979989969, -93.3147201538086, -1.62864910726107, 218, 4, 'PPL', 'P'),
(15782, 'Denver', 29.4041690826416, 0.513199564305217, -81.5269393920898, -1.42291352146583, 218, 12, 'PPL', 'P'),
(20554, 'Denver', 33.1913909912109, 0.579299056113415, -85.1744384765625, -1.48657438995336, 218, 13, 'PPL', 'P'),
(35566, 'Denver', 37.7761116027832, 0.659317526069399, -82.8547210693359, -1.44608768348143, 218, 21, 'PPL', 'P'),
(64195, 'Denver', 35.5311088562012, 0.620134836425227, -81.0299987792969, -1.41424027158572, 218, 33, 'PPL', 'P'),
(75642, 'Denver', 35.2324981689453, 0.614923096750969, -97.2819366455078, -1.69789009718064, 218, 42, 'PPL', 'P'),
(80669, 'Denver', 34.5752792358398, 0.603452462461834, -82.7366714477539, -1.44402732890409, 218, 48, 'PPL', 'P'),
(86295, 'Denver', 36.0469398498535, 0.629137785648294, -87.9208297729492, -1.53450796062342, 218, 50, 'PPL', 'P'),
(108846, 'Denver', 39.3822212219238, 0.687349427071355, -79.7705612182617, -1.39225893942237, 218, 58, 'PPL', 'P'),
(115256, 'Denver', 42.6713905334473, 0.744756261212994, -92.3372192382813, -1.61158849784386, 218, 16, 'PPL', 'P'),
(119363, 'Denver', 40.2905616760254, 0.703202958724488, -91.1069412231445, -1.59011609576482, 218, 18, 'PPL', 'P'),
(122500, 'Denver', 40.8661117553711, 0.713248202619185, -86.0774993896484, -1.50233577623277, 218, 19, 'PPL', 'P'),
(139116, 'Denver', 40.3972206115723, 0.705064508326453, -94.3225021362305, -1.64623822099661, 218, 29, 'PPL', 'P'),
(148273, 'Denver', 42.2125015258789, 0.736747137129717, -74.5697174072266, -1.30148709103783, 218, 40, 'PPL', 'P'),
(154985, 'Denver', 41.1830596923828, 0.718779987677443, -83.7074966430664, -1.46097142502361, 218, 41, 'PPL', 'P'),
(160760, 'Denver', 40.2330589294434, 0.702199346467692, -76.1374969482422, -1.32885000597396, 218, 45, 'PPL', 'P'),
(186618, 'Denver', 39.7391700744629, 0.693579359809378, -104.984169006348, -1.83231941163095, 218, 7, 'PPL', 'P'),
(194833, 'Denver', 45.9983291625977, 0.802822294303455, -116.235000610352, -2.02868346670825, 218, 17, 'PPL', 'P'),
(200687, 'Denver (historical)', 45.9513893127441, 0.80200303937312, -123.566673278809, -2.15664529445131, 218, 43, 'PPL', 'P'),
(191374, 'Denver City', 32.9644393920898, 0.575338003466086, -102.82861328125, -1.79469786701778, 218, 51, 'PPL', 'P'),
(108847, 'Denver Heights', 39.7322196960449, 0.693458052821724, -80.5449981689453, -1.4057754140609, 218, 58, 'PPL', 'P'),
(181109, 'Denverton', 38.2247200012207, 0.667147219674232, -121.896392822266, -2.12749340105292, 218, 6, 'PPL', 'P'),
(145095, 'Denville', 40.892219543457, 0.713703869481698, -74.477783203125, -1.29988253648106, 218, 37, 'PPL', 'P'),
(8489, 'Denwood', 35.4880599975586, 0.619383492102688, -90.2508316040039, -1.57517416415282, 218, 4, 'PPL', 'P'),
(191375, 'Denworth', 35.3938903808594, 0.617739922235946, -100.607498168945, -1.75593209524226, 218, 51, 'PPL', 'P'),
(173797, 'Denzer', 43.3441696166992, 0.75649847135429, -89.8866729736328, -1.56881839705329, 218, 57, 'PPL', 'P'),
(200688, 'Denzer (historical)', 44.3375015258789, 0.773835383734597, -123.827781677246, -2.16120249570865, 218, 43, 'PPL', 'P'),
(160748, 'Deodate', 40.2133293151855, 0.701854999738744, -76.6216735839844, -1.33730048242889, 218, 45, 'PPL', 'P'),
(186620, 'Deora', 37.5802803039551, 0.655899625126392, -102.966110229492, -1.79709764147605, 218, 7, 'PPL', 'P'),
(59249, 'Deovolente', 33.2191696166992, 0.579783884589864, -90.4499969482422, -1.57865025516565, 218, 30, 'PPL', 'P'),
(8490, 'Departe (historical)', 35.5930595397949, 0.621216079827799, -91.5033264160156, -1.59703432248658, 218, 4, 'PPL', 'P'),
(148274, 'Depauville', 44.1383285522461, 0.770359159563716, -76.0658264160156, -1.32759911920995, 218, 40, 'PPL', 'P'),
(29630, 'Depauw', 38.3349990844727, 0.66907195277306, -86.2174987792969, -1.50477922653292, 218, 19, 'PPL', 'P'),
(54420, 'Depew', 37.0224990844727, 0.646164506340634, -92.8627777099609, -1.62076122358642, 218, 29, 'PPL', 'P'),
(75643, 'Depew', 35.8027801513672, 0.624876395009031, -96.5058288574219, -1.68434446092817, 218, 42, 'PPL', 'P'),
(115257, 'Depew', 43.1841697692871, 0.75370594721426, -94.5422210693359, -1.65007303980827, 218, 16, 'PPL', 'P'),
(148275, 'Depew', 42.9038887023926, 0.748814119765948, -78.692497253418, -1.37344317368874, 218, 40, 'PPL', 'P'),
(154986, 'Depew', 40.232780456543, 0.702194486198702, -84.1152801513672, -1.46808858987879, 218, 41, 'PPL', 'P'),
(119364, 'Depler Springs', 40.4330596923828, 0.705690018287486, -90.184440612793, -1.57401542276253, 218, 18, 'PPL', 'P'),
(200689, 'Depoe Bay', 44.8086090087891, 0.782057760442162, -124.061943054199, -2.16528938271749, 218, 43, 'PPL', 'P'),
(93708, 'Deport', 33.5261116027832, 0.58514103285964, -95.315559387207, -1.66357033968695, 218, 51, 'PPL', 'P'),
(2030, 'Deposit', 34.8522186279297, 0.608285966682274, -86.4580612182617, -1.50897783314949, 218, 2, 'PPL', 'P'),
(148276, 'Deposit', 42.060001373291, 0.734085507357265, -75.4280624389648, -1.3164680379598, 218, 40, 'PPL', 'P'),
(59250, 'Deposit (historical)', 33.2316703796387, 0.580002064062169, -88.9119415283203, -1.55180612400987, 218, 30, 'PPL', 'P'),
(35567, 'Depoy', 37.2158317565918, 0.649538798020792, -87.2402801513672, -1.52263012900361, 218, 21, 'PPL', 'P'),
(64196, 'Deppe', 34.848331451416, 0.608218122653504, -77.2827835083008, -1.34883902732582, 218, 33, 'PPL', 'P'),
(86250, 'DePriest Bend', 35.7380599975586, 0.623746815232674, -87.8108291625977, -1.53258808779358, 218, 50, 'PPL', 'P'),
(108848, 'Depue', 38.8380584716797, 0.677851995412887, -81.397216796875, -1.4206494350651, 218, 58, 'PPL', 'P'),
(119365, 'Depue', 41.3241691589355, 0.721242812474521, -89.3066711425781, -1.55869545543379, 218, 18, 'PPL', 'P'),
(29631, 'Deputy', 38.7941703796387, 0.677086003704353, -85.6533279418945, -1.49493258787652, 218, 19, 'PPL', 'P'),
(40026, 'DeQuincy', 30.4502792358398, 0.531457630817068, -93.4330596923828, -1.63071452184448, 218, 22, 'PPL', 'P'),
(46291, 'Der Spring Farms', 39.4194412231445, 0.687999038640253, -77.5180587768555, -1.35294535541062, 218, 25, 'PPL', 'P'),
(2031, 'Derby', 32.3622207641602, 0.56482730559187, -88.1744384765625, -1.53893426751319, 218, 2, 'PPL', 'P'),
(29632, 'Derby', 38.0302810668945, 0.663753620076171, -86.5272216796875, -1.51018491091357, 218, 19, 'PPL', 'P'),
(32232, 'Derby', 37.5455589294434, 0.655293622820344, -97.2686080932617, -1.69765747005942, 218, 20, 'PPL', 'P'),
(35568, 'Derby', 37.459171295166, 0.653785874169196, -87.9024963378906, -1.53418798181845, 218, 21, 'PPL', 'P'),
(54421, 'Derby', 37.8250007629395, 0.660170802882661, -90.5386123657227, -1.58019688596871, 218, 29, 'PPL', 'P'),
(59252, 'Derby', 30.7594394683838, 0.536853494791191, -89.5830612182617, -1.56351937227431, 218, 30, 'PPL', 'P'),
(64197, 'Derby', 35.1452789306641, 0.61340083387188, -79.6350021362305, -1.38989298710994, 218, 33, 'PPL', 'P'),
(72310, 'Derby', 39.7686080932617, 0.694093150162681, -83.2058334350586, -1.45221575030776, 218, 41, 'PPL', 'P'),
(93709, 'Derby', 28.771110534668, 0.502150608285182, -99.1283264160156, -1.73011567795114, 218, 51, 'PPL', 'P'),
(101390, 'Derby', 36.9355583190918, 0.644647103730534, -82.8263931274414, -1.44559326762506, 218, 53, 'PPL', 'P'),
(113139, 'Derby', 41.3205604553223, 0.721179828714741, -73.0894393920898, -1.27565136582881, 218, 8, 'PPL', 'P'),
(115258, 'Derby', 40.9316711425781, 0.714392429781538, -93.4561080932617, -1.63111679232714, 218, 16, 'PPL', 'P'),
(119366, 'Derby', 40.4416694641113, 0.705840287151993, -88.442497253418, -1.54361277575819, 218, 18, 'PPL', 'P'),
(127250, 'Derby', 45.2363891601563, 0.789523932558199, -68.980827331543, -1.20394255768512, 218, 26, 'PPL', 'P'),
(130482, 'Derby', 42.014720916748, 0.733295214303784, -86.4819412231445, -1.50939461786008, 218, 27, 'PPL', 'P'),
(148278, 'Derby', 42.6813888549805, 0.744930764843422, -78.9755630493164, -1.37838360382694, 218, 40, 'PPL', 'P'),
(186621, 'Derby', 39.8394393920898, 0.695329389540696, -104.918060302734, -1.83116559708867, 218, 7, 'PPL', 'P'),
(86297, 'Derby (historical)', 36.1955604553223, 0.631731704550031, -82.845832824707, -1.44593255434793, 218, 50, 'PPL', 'P'),
(101391, 'Derby (historical)', 37.1097183227539, 0.647686769219723, -77.3444366455078, -1.34991507756427, 218, 53, 'PPL', 'P'),
(200690, 'Derby (historical)', 42.5791702270508, 0.743146713229178, -122.698608398438, -2.1414947041679, 218, 43, 'PPL', 'P'),
(181110, 'Derby Acres', 35.2472190856934, 0.615180025217134, -119.594436645508, -2.08731668653187, 218, 6, 'PPL', 'P'),
(171901, 'Derby Center', 44.9477806091309, 0.784486763093396, -72.1333312988281, -1.25896413159643, 218, 55, 'PPL', 'P'),
(93710, 'Derby Colonia', 28.7719993591309, 0.502166121198532, -99.1320037841797, -1.73017986013341, 218, 51, 'PPL', 'P'),
(46292, 'Derby Farms', 39.124439239502, 0.682850282725775, -76.663330078125, -1.33802752540648, 218, 25, 'PPL', 'P'),
(20555, 'Derby Hill', 33.8869400024414, 0.591438676468378, -84.3511123657227, -1.47220463850156, 218, 13, 'PPL', 'P'),
(186622, 'Derby Junction', 39.8688888549805, 0.695843379631081, -106.904998779297, -1.86584421553925, 218, 7, 'PPL', 'P'),
(171902, 'Derby Line', 45.0050010681152, 0.785485448502176, -72.0994415283203, -1.25837264351832, 218, 55, 'PPL', 'P'),
(13656, 'Derby Shores', 39.0863914489746, 0.682186223507964, -75.5699996948242, -1.31894531040579, 218, 10, 'PPL', 'P'),
(124637, 'Derby Wharf', 42.5194396972656, 0.742104218820466, -70.8855590820313, -1.23718639809841, 218, 23, 'PPL', 'P'),
(148279, 'Derbys Corners', 44.4083290100098, 0.775071556533584, -75.1527786254883, -1.31166342903719, 218, 40, 'PPL', 'P'),
(93711, 'Derden', 32.1836090087891, 0.561709942377878, -97.3283309936523, -1.69869983131008, 218, 51, 'PPL', 'P'),
(170152, 'Derian Subdivision', 45.4383316040039, 0.793048493102864, -98.5238876342773, -1.71956623108307, 218, 49, 'PPL', 'P'),
(40027, 'DeRidder', 30.8461093902588, 0.538366170290356, -93.2888870239258, -1.62819823408852, 218, 22, 'PPL', 'P'),
(148280, 'Dering Harbor', 41.0927810668945, 0.717204328418498, -72.3472213745117, -1.26269721765445, 218, 40, 'PPL', 'P'),
(64198, 'Derita', 35.2936096191406, 0.615989692767546, -80.7977828979492, -1.41018733988078, 218, 33, 'PPL', 'P'),
(59253, 'Derma', 33.8555603027344, 0.590890997390203, -89.2844390869141, -1.55830743286297, 218, 30, 'PPL', 'P'),
(35569, 'Dermont', 37.7436103820801, 0.658750272757212, -87.0408325195313, -1.51914911114277, 218, 21, 'PPL', 'P'),
(8493, 'Dermott', 33.5252799987793, 0.585126518631699, -91.4358291625977, -1.59585627317838, 218, 4, 'PPL', 'P'),
(54422, 'Dermott', 37.3833312988281, 0.652462216528399, -92.9372177124023, -1.62206044672421, 218, 29, 'PPL', 'P'),
(191376, 'Dermott', 32.8544387817383, 0.573418130636248, -101.015281677246, -1.76304926009744, 218, 51, 'PPL', 'P'),
(93712, 'Dernal', 28.6952800750732, 0.500827117091954, -96.9441680908203, -1.69199492379164, 218, 51, 'PPL', 'P'),
(193498, 'Derner', 41.2991714477539, 0.720806520108939, -120.559440612793, -2.10415918305581, 218, 6, 'PPL', 'P'),
(173798, 'Deronda', 45.3036117553711, 0.790697188176433, -92.4280624389648, -1.61317401079884, 218, 57, 'PPL', 'P'),
(40057, 'Derouen', 29.9666690826416, 0.523017041347685, -91.9086074829102, -1.60410781149988, 218, 22, 'PPL', 'P'),
(139117, 'Derrahs', 40.2230606079102, 0.702024842837264, -91.6638870239258, -1.59983663374361, 218, 29, 'PPL', 'P'),
(188419, 'Derramadero', 34.8280601501465, 0.607864321702687, -105.334167480469, -1.83842803738132, 218, 38, 'PPL', 'P'),
(139881, 'Derrick', 48.4769401550293, 0.846082216997512, -98.5572204589844, -1.72014799862319, 218, 34, 'PPL', 'P'),
(148281, 'Derrick', 44.3666687011719, 0.774344446976965, -74.4800033569336, -1.29992128547492, 218, 40, 'PPL', 'P'),
(160749, 'Derrick City', 41.9705581665039, 0.732524428905288, -78.5716705322266, -1.37133434957956, 218, 45, 'PPL', 'P'),
(160750, 'Derringer', 40.9497184753418, 0.714707415159467, -76.1444396972656, -1.32897117980356, 218, 45, 'PPL', 'P'),
(160751, 'Derringer Corners', 40.9258308410645, 0.714290497290815, -80.4649963378906, -1.40437911870137, 218, 45, 'PPL', 'P'),
(101392, 'Derrings Mill', 37.0758285522461, 0.647095281141617, -76.8111114501953, -1.34060679692222, 218, 53, 'PPL', 'P'),
(113295, 'Derrs', 41.1883316040039, 0.718871999893105, -76.461669921875, -1.33450789170983, 218, 45, 'PPL', 'P'),
(40058, 'Derry', 31.5338897705078, 0.55037020245632, -92.9475021362305, -1.62223994378168, 218, 22, 'PPL', 'P'),
(143708, 'Derry', 42.8805618286133, 0.748406989014302, -71.3277816772461, -1.24490463841163, 218, 36, 'PPL', 'P'),
(160753, 'Derry', 40.3338890075684, 0.703959163316016, -79.3000030517578, -1.38404615009473, 218, 45, 'PPL', 'P'),
(188420, 'Derry', 32.7880592346191, 0.572259588983036, -107.281669616699, -1.87241836184816, 218, 38, 'PPL', 'P'),
(143709, 'Derry Village', 42.8916702270508, 0.74860086714166, -71.3125, -1.24463792282846, 218, 36, 'PPL', 'P'),
(108849, 'Derryhale', 37.913330078125, 0.66171244025868, -81.1641693115234, -1.41658198913222, 218, 58, 'PPL', 'P'),
(160759, 'Derstines', 40.3441696166992, 0.70413859379446, -75.3088912963867, -1.31438810914845, 218, 45, 'PPL', 'P'),
(112482, 'Derthick', 39.4944381713867, 0.689307982316027, -82.1175003051758, -1.43322075383277, 218, 41, 'PPL', 'P'),
(86251, 'DeRusk', 36.1152801513672, 0.630330548921514, -82.8694381713867, -1.44634454536857, 218, 50, 'PPL', 'P'),
(148217, 'DeRuyter', 42.7583312988281, 0.746273663823094, -75.8847198486328, -1.32443821331214, 218, 40, 'PPL', 'P'),
(72311, 'Derwent', 39.9230613708496, 0.696788868397087, -81.5444412231445, -1.42321898604286, 218, 41, 'PPL', 'P'),
(46293, 'Derwood', 39.1172218322754, 0.682724315206215, -77.1613922119141, -1.34672034952061, 218, 25, 'PPL', 'P'),
(40059, 'Des Allemands', 29.8236103057861, 0.520520194667681, -90.4749984741211, -1.57908661411026, 218, 22, 'PPL', 'P'),
(8494, 'Des Arc', 34.9769401550293, 0.610462767978277, -91.495002746582, -1.59688904704911, 218, 4, 'PPL', 'P'),
(54423, 'Des Arc', 37.2825012207031, 0.650702399680075, -90.6372222900391, -1.58191795382318, 218, 29, 'PPL', 'P'),
(40060, 'Des Glaise', 30.3772201538086, 0.530182509287138, -91.601936340332, -1.59875539034104, 218, 22, 'PPL', 'P'),
(198186, 'Des Lacs', 48.2577781677246, 0.842257118723831, -101.563056945801, -1.77260974209472, 218, 34, 'PPL', 'P'),
(115259, 'Des Moines', 41.6005592346191, 0.726066729315036, -93.60888671875, -1.63378328236858, 218, 16, 'PPL', 'P'),
(181112, 'Des Moines', 33.9319381713867, 0.592224042673842, -117.966941833496, -2.05891154350314, 218, 6, 'PPL', 'P'),
(188421, 'Des Moines', 36.7611083984375, 0.641602378235274, -103.833610534668, -1.81223837806343, 218, 38, 'PPL', 'P'),
(207197, 'Des Moines', 47.4019393920898, 0.827319914222767, -122.323059082031, -2.134940132093, 218, 56, 'PPL', 'P'),
(54424, 'Des Peres', 38.600830078125, 0.673711578866141, -90.4327774047852, -1.57834971743663, 218, 29, 'PPL', 'P'),
(119368, 'Des Plaines', 42.0333290100098, 0.733619986798719, -87.8833312988281, -1.53385348878554, 218, 18, 'PPL', 'P'),
(181048, 'DeSabla', 39.8738899230957, 0.695930664735809, -121.601669311523, -2.12234950540743, 218, 6, 'PPL', 'P'),
(148282, 'Desbrough Park', 43.3025016784668, 0.755771228639617, -76.8313903808594, -1.3409607310311, 218, 40, 'PPL', 'P'),
(181111, 'Descanso', 32.8527793884277, 0.573389168759393, -116.61499786377, -2.03531566992893, 218, 6, 'PPL', 'P'),
(181113, 'Descanso Junction', 32.8411102294922, 0.573185503515029, -116.611938476563, -2.03526227354908, 218, 6, 'PPL', 'P'),
(200691, 'Deschutes', 44.1566696166992, 0.770679271526744, -121.254440307617, -2.11628921603085, 218, 43, 'PPL', 'P'),
(200693, 'Deschutes River Woods', 43.9916687011719, 0.767799462281987, -121.357223510742, -2.11808312134112, 218, 43, 'PPL', 'P'),
(35570, 'Desda', 36.8344383239746, 0.642882226876139, -85.1983337402344, -1.48699144098007, 218, 21, 'PPL', 'P'),
(93713, 'Desdemona', 32.2702789306641, 0.563222617877043, -98.5500030517578, -1.72002203110363, 218, 51, 'PPL', 'P'),
(119369, 'Deselm', 41.249439239502, 0.719938529330655, -87.9744415283203, -1.53544366227242, 218, 18, 'PPL', 'P'),
(178076, 'Deserama Mobile Ranch', 33.4174995422363, 0.583245394795722, -111.778327941895, -1.95089985496004, 218, 5, 'PPL', 'P'),
(192537, 'Deseret', 39.2869415283203, 0.685686482707683, -112.65193939209, -1.96614725114907, 218, 52, 'PPL', 'P'),
(93714, 'Desert', 33.3883285522461, 0.582736264974326, -96.4016723632813, -1.68252658716808, 218, 51, 'PPL', 'P'),
(192536, 'Desert', 39.0880584716797, 0.682215318542873, -110.318061828613, -1.92541340332798, 218, 52, 'PPL', 'P'),
(207198, 'Desert Aire', 46.6794395446777, 0.814709913040269, -119.916107177734, -2.09293089642587, 218, 56, 'PPL', 'P'),
(181114, 'Desert Beach', 33.5127792358398, 0.584908339159395, -115.926391601563, -2.02329722340357, 218, 6, 'PPL', 'P'),
(178071, 'Desert Bell Estates II', 33.6566696166992, 0.587419700067339, -112.051109313965, -1.95566078804077, 218, 5, 'PPL', 'P'),
(181115, 'Desert Camp', 33.5336112976074, 0.585271927227218, -115.982498168945, -2.02427646773639, 218, 6, 'PPL', 'P'),
(181116, 'Desert Center', 33.7125015258789, 0.588394150710199, -115.401390075684, -2.01413421819899, 218, 6, 'PPL', 'P'),
(178072, 'Desert Gem Mobile Home Park', 33.4530601501465, 0.583866044487765, -112.19750213623, -1.95821582479059, 218, 5, 'PPL', 'P'),
(191377, 'Desert Glen Colonia', 31.8099994659424, 0.555189225738332, -106.166999816895, -1.85296370376903, 218, 51, 'PPL', 'P'),
(181117, 'Desert Groves Mobile Home Park', 33.6986083984375, 0.588151669892948, -116.238891601563, -2.02875137731605, 218, 6, 'PPL', 'P'),
(181118, 'Desert Heights', 34.2011108398438, 0.596921991994796, -116.140830993652, -2.02703989684151, 218, 6, 'PPL', 'P'),
(178074, 'Desert Highlands', 33.7138900756836, 0.588418385476119, -111.860557556152, -1.95233503247148, 218, 5, 'PPL', 'P'),
(178075, 'Desert Hills', 34.5538902282715, 0.603079153856032, -114.371673583984, -1.99616227505675, 218, 5, 'PPL', 'P'),
(181119, 'Desert Hills Trailer Park', 33.7841682434082, 0.589644970895182, -116.478057861328, -2.03292561600864, 218, 6, 'PPL', 'P'),
(181120, 'Desert Hot Springs', 33.961109161377, 0.592733172495238, -116.500831604004, -2.03332309280133, 218, 6, 'PPL', 'P'),
(181121, 'Desert Knolls', 34.5244407653809, 0.602565163765647, -117.264442443848, -2.04665061616053, 218, 6, 'PPL', 'P'),
(177658, 'Desert Lake', 35.002498626709, 0.610908847460865, -117.698059082031, -2.05421865418826, 218, 6, 'PPL', 'P'),
(181123, 'Desert Lodge', 33.2105598449707, 0.579633615725356, -116.326393127441, -2.03027856704316, 218, 6, 'PPL', 'P'),
(192538, 'Desert Mound', 37.7105598449707, 0.658173432065101, -113.27278137207, -1.97698298783433, 218, 52, 'PPL', 'P'),
(188422, 'Desert Mountain', 35.3144416809082, 0.616353280835369, -106.514717102051, -1.8590325152611, 218, 38, 'PPL', 'P'),
(178077, 'Desert Pines', 33.6375007629395, 0.587085140455398, -112.143058776855, -1.95726560891365, 218, 5, 'PPL', 'P'),
(181124, 'Desert Relief (historical)', 34.5061111450195, 0.602245251539701, -117.834716796875, -2.05660378126053, 218, 6, 'PPL', 'P'),
(178078, 'Desert Ridge', 33.6341705322266, 0.587027016964607, -111.93083190918, -1.95356155131152, 218, 5, 'PPL', 'P'),
(178079, 'Desert Sage Mobile Manor', 33.4633293151855, 0.584045275229127, -111.980278015137, -1.95442454866276, 218, 5, 'PPL', 'P'),
(178080, 'Desert Sands Mobile Home Park', 33.6925010681152, 0.588045076870317, -112.117782592773, -1.95682445627908, 218, 5, 'PPL', 'P'),
(181125, 'Desert Sands Mobile Home Park', 33.2552795410156, 0.580414121661831, -116.395278930664, -2.03148085111727, 218, 6, 'PPL', 'P'),
(181126, 'Desert Shores', 33.4041709899902, 0.583012767674503, -116.038887023926, -2.02526063891723, 218, 6, 'PPL', 'P'),
(178081, 'Desert Valley Estates', 33.6549987792969, 0.587390538453403, -112.097778320313, -1.95647531586017, 218, 5, 'PPL', 'P'),
(181127, 'Desert View', 33.8013916015625, 0.589945575203225, -116.639999389648, -2.03575202887354, 218, 6, 'PPL', 'P'),
(181128, 'Desert View Highlands', 34.5908317565918, 0.603723905155941, -118.151672363281, -2.06213569947685, 218, 6, 'PPL', 'P'),
(181129, 'Desert View Housing Area', 34.8683280944824, 0.608567129914359, -116.963890075684, -2.0414049877614, 218, 6, 'PPL', 'P'),
(190114, 'Desert View Point', 36.3122215270996, 0.633767824361452, -115.58528137207, -2.0173437267867, 218, 39, 'PPL', 'P'),
(178082, 'Desert Village Mobile Home Park', 33.4124984741211, 0.583158109690994, -111.622497558594, -1.94818010169679, 218, 5, 'PPL', 'P'),
(178083, 'Desert Villas', 33.3527793884277, 0.582115815019365, -111.973609924316, -1.95430816852312, 218, 5, 'PPL', 'P'),
(178084, 'Desert Vista Estates III', 33.4236106872559, 0.583352054397379, -111.628890991211, -1.94829168814647, 218, 5, 'PPL', 'P'),
(178085, 'Desert Wells', 33.7083282470703, 0.588321313254386, -113.820831298828, -1.98654826352156, 218, 5, 'PPL', 'P'),
(178086, 'Desert Wind', 33.7702789306641, 0.589402556656958, -111.968887329102, -1.95422574368738, 218, 5, 'PPL', 'P'),
(178087, 'Desert Wind II', 33.6044387817383, 0.586508100026205, -111.922500610352, -1.953416142716, 218, 5, 'PPL', 'P'),
(8496, 'Desha', 35.7361106872559, 0.623712793349748, -91.6797180175781, -1.60011293670671, 218, 4, 'PPL', 'P'),
(86299, 'Desha', 36.4291687011719, 0.635808937599916, -86.3641662597656, -1.50733905697271, 218, 50, 'PPL', 'P'),
(101393, 'Desha', 37.9155616760254, 0.661751388989623, -76.9205627441406, -1.34251708237214, 218, 53, 'PPL', 'P'),
(141654, 'Deshler', 40.1408309936523, 0.70058966532582, -97.7225036621094, -1.70557944219602, 218, 35, 'PPL', 'P'),
(154987, 'Deshler', 41.2075004577637, 0.719206559505047, -83.899169921875, -1.46431675482691, 218, 41, 'PPL', 'P'),
(40061, 'Deshotel', 30.3116703033447, 0.529038448572354, -92.2094421386719, -1.60935836674703, 218, 22, 'PPL', 'P'),
(160761, 'Desire', 41.0252799987793, 0.716026212531274, -78.8905563354492, -1.37689995678366, 218, 45, 'PPL', 'P'),
(101394, 'Deskins', 37.1813888549805, 0.648937655983734, -82.0774993896484, -1.432522606153, 218, 53, 'PPL', 'P'),
(40062, 'Deslatte', 29.8844394683838, 0.521581863836241, -91.7122192382813, -1.60068019001889, 218, 22, 'PPL', 'P'),
(54425, 'Deslet', 37.1619415283203, 0.648598236102803, -91.1205596923828, -1.59035378289211, 218, 29, 'PPL', 'P'),
(54426, 'Desloge', 37.8708305358887, 0.660970683316066, -90.5272216796875, -1.57999808099334, 218, 29, 'PPL', 'P'),
(20496, 'DeSoto', 31.9552803039551, 0.557724854701711, -84.0622177124023, -1.46716247560972, 218, 13, 'PPL', 'P'),
(93663, 'DeSoto', 32.5897216796875, 0.568797945619124, -96.8566665649414, -1.69046773406453, 218, 51, 'PPL', 'P'),
(122501, 'Desoto', 40.246940612793, 0.702441627547862, -85.2936096191406, -1.48865431876471, 218, 19, 'PPL', 'P'),
(20497, 'DeSoto (historical)', 34.2583312988281, 0.597920677403576, -85.1736068725586, -1.48655987572542, 218, 13, 'PPL', 'P'),
(15783, 'Desoto Lakes', 27.3711109161377, 0.477716005415164, -82.4899978637695, -1.43972206268587, 218, 12, 'PPL', 'P'),
(108852, 'Despard', 39.2886085510254, 0.685715577742592, -80.3061065673828, -1.40160596905827, 218, 58, 'PPL', 'P'),
(40065, 'Dess', 31.4386100769043, 0.548707258092648, -93.5302810668945, -1.63241135493302, 218, 22, 'PPL', 'P'),
(54429, 'Dessa', 36.8069381713867, 0.642402258668679, -94.5213928222656, -1.64970951831947, 218, 29, 'PPL', 'P'),
(93715, 'Dessau', 30.4033298492432, 0.530638209439164, -97.6380615234375, -1.70410564884877, 218, 51, 'PPL', 'P'),
(20556, 'Desser', 30.8861103057861, 0.539064317970121, -84.8627777099609, -1.48113488342687, 218, 13, 'PPL', 'P'),
(108851, 'Dessie', 38.6538887023926, 0.674637626556189, -80.9150009155273, -1.41223318023018, 218, 58, 'PPL', 'P'),
(15784, 'Destin', 30.3933296203613, 0.530463672519223, -86.4958267211914, -1.50963696551928, 218, 12, 'PPL', 'P'),
(20557, 'Destitute Acres', 34.375560760498, 0.599966717490057, -83.8466720581055, -1.46340049425387, 218, 13, 'PPL', 'P'),
(40063, 'Destrehan', 29.9427795410156, 0.522600090189519, -90.3516693115234, -1.5769341141592, 218, 22, 'PPL', 'P'),
(46294, 'Detmold', 39.5541687011719, 0.690350476724738, -78.9897232055664, -1.3786307451761, 218, 25, 'PPL', 'P'),
(54427, 'Detmold', 38.542781829834, 0.672698445808448, -91.290283203125, -1.59331601697261, 218, 29, 'PPL', 'P'),
(93716, 'Detmold', 30.6499996185303, 0.534943409078359, -97.2138900756836, -1.69670246049252, 218, 51, 'PPL', 'P'),
(8499, 'Detonti', 34.4972190856934, 0.602090055827177, -92.5086135864258, -1.61457989353829, 218, 4, 'PPL', 'P'),
(46295, 'Detour', 39.603889465332, 0.691218267765941, -77.2683334350586, -1.34858682597059, 218, 25, 'PPL', 'P'),
(101395, 'Detrick', 38.8452796936035, 0.677978029511475, -78.4150009155273, -1.36859994893032, 218, 53, 'PPL', 'P'),
(2034, 'Detroit', 34.0280609130859, 0.593901701002538, -88.1699981689453, -1.53885676952547, 218, 2, 'PPL', 'P'),
(26943, 'Detroit', 39.6205596923828, 0.691509218115032, -90.6766662597656, -1.58260638096496, 218, 18, 'PPL', 'P'),
(32233, 'Detroit', 38.935001373291, 0.679543968232442, -97.1205596923828, -1.69507353801177, 218, 20, 'PPL', 'P'),
(86300, 'Detroit', 35.5888900756836, 0.621143308951013, -89.813606262207, -1.56754314236531, 218, 50, 'PPL', 'P'),
(93717, 'Detroit', 33.6613883972168, 0.58750205832405, -95.2663879394531, -1.66271213602567, 218, 51, 'PPL', 'P'),
(127251, 'Detroit', 44.7924995422363, 0.781776597210077, -69.2972183227539, -1.2094646222054, 218, 26, 'PPL', 'P'),
(130484, 'Detroit', 42.3313903808594, 0.738822139093053, -83.0458297729492, -1.4494231595887, 218, 27, 'PPL', 'P'),
(200694, 'Detroit', 44.7341690063477, 0.780758537304367, -122.148612976074, -2.13189547317676, 218, 43, 'PPL', 'P'),
(207199, 'Detroit (historical)', 47.3352813720703, 0.826156512300566, -122.830833435059, -2.14380246641051, 218, 56, 'PPL', 'P'),
(130485, 'Detroit Beach', 41.9311103820801, 0.731835935184475, -83.3269424438477, -1.45432950126495, 218, 27, 'PPL', 'P'),
(173799, 'Detroit Harbor', 45.3566703796387, 0.791623235866481, -86.9305572509766, -1.51722444462297, 218, 57, 'PPL', 'P'),
(135002, 'Detroit Lakes', 46.8172187805176, 0.817114614346556, -95.8450012207031, -1.67281084287925, 218, 28, 'PPL', 'P'),
(160762, 'Detters Mill', 40.0141716003418, 0.698379041883973, -76.9274978637695, -1.34263812304368, 218, 45, 'PPL', 'P'),
(160763, 'Detwood', 41.2322196960449, 0.719637991601639, -78.7830581665039, -1.3750237597957, 218, 45, 'PPL', 'P'),
(29633, 'Deuchars', 38.1722183227539, 0.666230892522163, -86.4483337402344, -1.50880805662999, 218, 19, 'PPL', 'P'),
(72312, 'Deucher', 39.4663887023926, 0.688818426728643, -81.1969375610352, -1.41715390297632, 218, 41, 'PPL', 'P'),
(154988, 'Deunquat', 40.9283294677734, 0.714334106553665, -83.1313934326172, -1.45091652716996, 218, 41, 'PPL', 'P'),
(40064, 'Devalls', 30.5261096954346, 0.532781122010297, -91.295280456543, -1.59340323549831, 218, 22, 'PPL', 'P'),
(93718, 'Devan Estates Colonia', 26.3169994354248, 0.459318289393652, -98.3059997558594, -1.71576337020449, 218, 51, 'PPL', 'P'),
(20558, 'Devane', 34.4005584716797, 0.600403009855639, -83.8691711425781, -1.4637931773566, 218, 13, 'PPL', 'P'),
(160764, 'Devault', 40.0744400024414, 0.699430923935527, -75.5355606079102, -1.31834423494776, 218, 45, 'PPL', 'P'),
(80671, 'Devenger Place', 34.8708305358887, 0.608610805756236, -82.3038864135742, -1.4364738051043, 218, 48, 'PPL', 'P'),
(86301, 'Devenport', 35.7516708374023, 0.623984369201909, -85.9625015258789, -1.50032868487724, 218, 50, 'PPL', 'P'),
(86302, 'Devenport (historical)', 35.7516708374023, 0.623984369201909, -85.9630584716797, -1.50033840541522, 218, 50, 'PPL', 'P'),
(124638, 'Devenscrest', 42.5499992370605, 0.742637583407782, -71.5666732788086, -1.24907408341426, 218, 23, 'PPL', 'P'),
(54428, 'Deventer', 36.8222198486328, 0.642668974251851, -89.211669921875, -1.55703737133911, 218, 29, 'PPL', 'P'),
(20559, 'Devenwood', 31.1747207641602, 0.544101520724437, -81.3824996948242, -1.42039257317796, 218, 13, 'PPL', 'P'),
(194820, 'DeVeny Place', 45.3574981689453, 0.791637683515395, -116.394172668457, -2.03146154319937, 218, 17, 'PPL', 'P'),
(130487, 'Devereaux', 42.3199996948242, 0.738623334117678, -84.708610534668, -1.47844415861951, 218, 27, 'PPL', 'P'),
(148283, 'Devereaux', 42.333610534668, 0.738860888086913, -78.5652770996094, -1.37122276312988, 218, 40, 'PPL', 'P'),
(20560, 'Devereaux Estates', 32.5138893127441, 0.567474421136382, -83.7197189331055, -1.46118474422692, 218, 13, 'PPL', 'P'),
(20561, 'Devereux', 33.2219390869141, 0.579832220963649, -83.0736083984375, -1.44990798806515, 218, 13, 'PPL', 'P'),
(26945, 'Devereux Heights', 39.8497200012207, 0.69550882001914, -89.6119384765625, -1.56402337551061, 218, 18, 'PPL', 'P'),
(141653, 'Deverre', 41.8925018310547, 0.731162088849658, -99.086669921875, -1.72938863497355, 218, 35, 'PPL', 'P'),
(93719, 'Devers', 30.0272197723389, 0.524073850247255, -94.5913925170898, -1.65093124346954, 218, 51, 'PPL', 'P'),
(8434, 'DeView', 35.2238883972168, 0.614772827886461, -91.1930618286133, -1.59161918388406, 218, 4, 'PPL', 'P'),
(181130, 'Devil Canyon', 34.1977806091309, 0.596863868504006, -117.331672668457, -2.04782400493682, 218, 6, 'PPL', 'P'),
(154989, 'Devil Town', 40.8452796936035, 0.712884614551362, -81.9736099243164, -1.43070939292482, 218, 41, 'PPL', 'P'),
(46296, 'Devilbiss Estates', 39.5963897705078, 0.691087373398363, -77.4194412231445, -1.3512241543981, 218, 25, 'PPL', 'P'),
(40066, 'Deville', 31.3572196960449, 0.547286727967199, -92.165283203125, -1.60858764792756, 218, 22, 'PPL', 'P'),
(130488, 'Devils Corner', 45.7374992370605, 0.798269953315101, -86.6050033569336, -1.51154245727923, 218, 27, 'PPL', 'P'),
(173800, 'Devils Corner', 44.5108299255371, 0.776860534995845, -92.1350021362305, -1.60805914360923, 218, 57, 'PPL', 'P'),
(80672, 'Devils Cross Roads', 34.3072204589844, 0.598773954216838, -81.6194381713867, -1.42452792971864, 218, 48, 'PPL', 'P'),
(209404, 'Devils Den', 44.892219543457, 0.783517039561471, -110.386940002441, -1.92661555424404, 218, 59, 'PPL', 'P'),
(54430, 'Devils Elbow', 37.8458290100098, 0.660534324371456, -92.063606262207, -1.60681305053518, 218, 29, 'PPL', 'P'),
(130490, 'Devils Elbow', 44.6866683959961, 0.779929495257025, -85.4819412231445, -1.49194132534014, 218, 27, 'PPL', 'P'),
(181131, 'Devils Elbow', 39.3458290100098, 0.686714263151371, -122.427780151367, -2.13676785954912, 218, 6, 'PPL', 'P'),
(141655, 'Devils Gap', 40.5794410705566, 0.708244855300226, -99.8716735839844, -1.74308953351757, 218, 35, 'PPL', 'P'),
(115269, 'Devils Glen Mobile Home Court', 41.5355606079102, 0.72493228926969, -90.4736099243164, -1.57906237934434, 218, 16, 'PPL', 'P'),
(194834, 'Devils Ladder', 45.1783294677734, 0.788510599763424, -116.434440612793, -2.03216435141104, 218, 17, 'PPL', 'P'),
(130489, 'Devils Lake', 42.0077781677246, 0.733174040474185, -84.2925033569336, -1.47118171832686, 218, 27, 'PPL', 'P'),
(139883, 'Devils Lake', 48.1127815246582, 0.839726449897983, -98.8647232055664, -1.72551493400998, 218, 34, 'PPL', 'P'),
(191378, 'Devils Shores', 29.6208305358887, 0.516981020026534, -100.936668395996, -1.76167719950384, 218, 51, 'PPL', 'P'),
(203722, 'Devils Slide', 41.0636100769043, 0.716695198597102, -111.542503356934, -1.94678393949532, 218, 52, 'PPL', 'P'),
(209405, 'Devils Tower', 44.589168548584, 0.778227801899492, -104.696113586426, -1.8272918961251, 218, 59, 'PPL', 'P'),
(112584, 'Devine', 29.139720916748, 0.508584073109514, -98.9049987792969, -1.7262178753797, 218, 51, 'PPL', 'P'),
(186623, 'Devine', 38.2750015258789, 0.668024797832441, -104.456939697266, -1.82311752427445, 218, 7, 'PPL', 'P'),
(187653, 'Devizes', 39.9911117553711, 0.697976571664235, -100.056938171387, -1.74632301055509, 218, 20, 'PPL', 'P'),
(101396, 'Devland Estates', 39.2269401550293, 0.684639261188036, -78.279167175293, -1.36622920292793, 218, 53, 'PPL', 'P'),
(59254, 'Devoe', 32.211109161377, 0.562189910585337, -88.665283203125, -1.54750112410776, 218, 30, 'PPL', 'P'),
(170157, 'Devoe', 45.0916709899902, 0.786998124001341, -98.8783264160156, -1.72575235482116, 218, 49, 'PPL', 'P'),
(75646, 'Devol', 34.1958312988281, 0.59682984662108, -98.5897216796875, -1.72071525193538, 218, 42, 'PPL', 'P'),
(72313, 'Devola', 39.4736099243164, 0.688944460827231, -81.4791717529297, -1.42207981888658, 218, 41, 'PPL', 'P'),
(13663, 'Devon', 39.8277816772461, 0.695125924033414, -75.540283203125, -1.3184266597835, 218, 10, 'PPL', 'P'),
(32235, 'Devon', 37.9222183227539, 0.661867569392177, -94.8188934326172, -1.6549018834968, 218, 20, 'PPL', 'P'),
(35571, 'Devon', 38.9688911437988, 0.680135456310549, -84.6158294677734, -1.47682482351869, 218, 21, 'PPL', 'P'),
(108853, 'Devon', 37.5372200012207, 0.655148081066771, -82.0627822875977, -1.43226574426586, 218, 58, 'PPL', 'P'),
(113144, 'Devon', 41.202220916748, 0.71911441413133, -73.1022186279297, -1.2758744055701, 218, 8, 'PPL', 'P'),
(115270, 'Devon', 43.1197204589844, 0.752581094548838, -92.3574981689453, -1.61194243195273, 218, 16, 'PPL', 'P'),
(148284, 'Devon', 40.9913902282715, 0.715434724453167, -72.1074981689453, -1.25851325842388, 218, 40, 'PPL', 'P'),
(160765, 'Devon', 40.0491714477539, 0.69898990445901, -75.429443359375, -1.31649213956767, 218, 45, 'PPL', 'P'),
(181132, 'Devon', 34.8419418334961, 0.608106602782857, -120.518333435059, -2.10344172745814, 218, 6, 'PPL', 'P'),
(196352, 'Devon', 48.4666709899902, 0.845902986256149, -111.477783203125, -1.94565435971896, 218, 31, 'PPL', 'P'),
(160766, 'Devon Close', 40.0666694641113, 0.699295302457015, -74.9550018310547, -1.30821157279028, 218, 45, 'PPL', 'P'),
(46297, 'Devon Farms', 39.5077781677246, 0.689540809174327, -77.3747177124023, -1.3504435818826, 218, 25, 'PPL', 'P'),
(101397, 'Devon Park', 38.913890838623, 0.67917551989563, -77.1858291625977, -1.34714685476919, 218, 53, 'PPL', 'P'),
(13658, 'Devonshire', 39.8250007629395, 0.695077387922547, -75.540283203125, -1.3184266597835, 218, 10, 'PPL', 'P'),
(20571, 'Devonshire', 33.5716705322266, 0.585936186182111, -84.3005599975586, -1.47132233323242, 218, 13, 'PPL', 'P'),
(29636, 'Devonshire', 39.8805618286133, 0.696047111454472, -86.0588912963867, -1.50201100373784, 218, 19, 'PPL', 'P'),
(46298, 'Devonshire', 39.0533294677734, 0.681609183078771, -76.6430587768555, -1.33767372445567, 218, 25, 'PPL', 'P'),
(70738, 'Devonshire', 39.5424995422363, 0.690146811480374, -74.6677780151367, -1.30319857151237, 218, 37, 'PPL', 'P'),
(80674, 'Devonshire', 34.9799995422363, 0.610516164358133, -81.0366668701172, -1.41435665172535, 218, 48, 'PPL', 'P'),
(101398, 'Devonshire', 38.6411094665527, 0.674414586814895, -77.3863906860352, -1.35064731370599, 218, 53, 'PPL', 'P'),
(181137, 'Devonshire', 37.5013885498047, 0.654522704263793, -122.282783508301, -2.13423719072327, 218, 6, 'PPL', 'P'),
(160767, 'Devonshire Crest', 40.3127784729004, 0.703590714979203, -76.7433319091797, -1.33942382076601, 218, 45, 'PPL', 'P'),
(160768, 'Devonshire Estates', 40.3033294677734, 0.7034257987287, -76.7766723632813, -1.34000572146419, 218, 45, 'PPL', 'P'),
(46299, 'Devonshire Forest', 39.4152793884277, 0.687926400921521, -76.6177825927734, -1.33723257182109, 218, 25, 'PPL', 'P'),
(101399, 'Devonshire Gardens', 38.8708305358887, 0.678423975836009, -77.1877822875977, -1.34718094323114, 218, 53, 'PPL', 'P'),
(160769, 'Devonshire Heights', 40.3127784729004, 0.703590714979203, -76.7766723632813, -1.34000572146419, 218, 45, 'PPL', 'P'),
(160770, 'Devonshire Hills', 40.3050003051758, 0.703454960342637, -76.7916717529297, -1.34026751019935, 218, 45, 'PPL', 'P'),
(86303, 'Devonshire Manor', 36.0466690063477, 0.629133058537359, -86.8894424438477, -1.51650685586725, 218, 50, 'PPL', 'P'),
(64203, 'Devonshire Square', 35.5438919067383, 0.620357942745548, -77.3877792358398, -1.35067154847191, 218, 33, 'PPL', 'P'),
(13659, 'Devonshire Woods', 38.6630592346191, 0.674797682537703, -75.6372222900391, -1.32011856602403, 218, 10, 'PPL', 'P'),
(20565, 'Devonwood', 32.4441719055176, 0.566257622834324, -83.6969375610352, -1.46078713427618, 218, 13, 'PPL', 'P'),
(29634, 'Devore', 39.4297218322754, 0.688178469118697, -86.7527770996094, -1.51412159563692, 218, 19, 'PPL', 'P'),
(181133, 'Devore', 34.2163887023926, 0.597188640998941, -117.40055847168, -2.04902628901093, 218, 6, 'PPL', 'P'),
(181134, 'Devore Heights', 34.2372207641602, 0.597552229066764, -117.41471862793, -2.04927343036009, 218, 6, 'PPL', 'P'),
(64204, 'Devotion', 36.4324989318848, 0.635867061090706, -80.9180603027344, -1.41228657661003, 218, 33, 'PPL', 'P'),
(93720, 'Dew', 31.5949993133545, 0.551436765183383, -96.1397171020508, -1.67795460536669, 218, 51, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(181135, 'Dew Drop', 39.0872192382813, 0.682200671156878, -121.085563659668, -2.1133417624944, 218, 6, 'PPL', 'P'),
(181136, 'Dew Drop (historical)', 38.5133285522461, 0.672184389139035, -120.483329772949, -2.10283079830408, 218, 6, 'PPL', 'P'),
(194835, 'Dew Drop Place', 42.0244407653809, 0.733464857665222, -115.943893432617, -2.0236026879806, 218, 17, 'PPL', 'P'),
(200695, 'Dew Valley', 43.0400009155273, 0.751189726037326, -124.413063049316, -2.17141758270187, 218, 43, 'PPL', 'P'),
(93721, 'Dewalt', 29.5563907623291, 0.51585633380868, -95.5563888549805, -1.66777360683542, 218, 51, 'PPL', 'P'),
(75648, 'Dewar', 35.4580612182617, 0.618859914632379, -95.9411087036133, -1.67448823489184, 218, 42, 'PPL', 'P'),
(115271, 'Dewar', 42.5255584716797, 0.742211011580178, -92.2188873291016, -1.6095232164185, 218, 16, 'PPL', 'P'),
(130493, 'Deward', 44.8405609130859, 0.782615426374424, -84.8266677856445, -1.4805046463549, 218, 27, 'PPL', 'P'),
(160771, 'Dewart', 41.1091690063477, 0.717490351919572, -76.8769378662109, -1.34175568461648, 218, 45, 'PPL', 'P'),
(207200, 'Dewatto', 47.4524993896484, 0.828202352649965, -123.070281982422, -2.14798163195112, 218, 56, 'PPL', 'P'),
(141656, 'Dewaynes Trailer Court', 40.4402809143066, 0.705816052386074, -99.3694381713867, -1.73432387194763, 218, 35, 'PPL', 'P'),
(29635, 'Dewberry', 38.9511108398438, 0.679825131464527, -85.1516723632813, -1.48617704631872, 218, 19, 'PPL', 'P'),
(46300, 'Dewberry Estates', 39.4747200012207, 0.688963835324161, -76.959716796875, -1.34320044950785, 218, 25, 'PPL', 'P'),
(20566, 'Dewberry Town', 34.9458312988281, 0.609919816011037, -85.2736129760742, -1.48830531150386, 218, 13, 'PPL', 'P'),
(35572, 'Dewdrop', 38.1455612182617, 0.665765638279726, -83.1399993896484, -1.45106672945544, 218, 21, 'PPL', 'P'),
(93738, 'Dewees', 29.0202808380127, 0.506499450476741, -98.1719436645508, -1.7134236500288, 218, 51, 'PPL', 'P'),
(59220, 'DeWeese', 32.7099990844727, 0.570897182348379, -88.9375, -1.55225220349246, 218, 30, 'PPL', 'P'),
(64206, 'Deweese', 35.4602813720703, 0.618898663626239, -80.7319412231445, -1.40903818587041, 218, 33, 'PPL', 'P'),
(141657, 'Deweese', 40.3547210693359, 0.704322751383839, -98.1383285522461, -1.71283695564065, 218, 35, 'PPL', 'P'),
(93722, 'Deweesville', 28.9021701812744, 0.504438030634965, -98.1232528686523, -1.71257383532495, 218, 51, 'PPL', 'P'),
(2037, 'Dewey', 34.3261108398438, 0.599103653559789, -85.5077819824219, -1.49239233167075, 218, 2, 'PPL', 'P'),
(8501, 'Dewey', 35.4211082458496, 0.618214963595389, -91.758056640625, -1.60148020361035, 218, 4, 'PPL', 'P'),
(29639, 'Dewey', 39.5094413757324, 0.689569837630209, -87.3758316040039, -1.52499594815799, 218, 19, 'PPL', 'P'),
(75649, 'Dewey', 36.7958297729492, 0.642208380541321, -95.9352798461914, -1.6743865021382, 218, 42, 'PPL', 'P'),
(101400, 'Dewey', 37.0802803039551, 0.64717297886642, -82.6588897705078, -1.44266978253842, 218, 53, 'PPL', 'P'),
(119370, 'Dewey', 40.3188896179199, 0.703697374580861, -88.2819366455078, -1.54081046450115, 218, 18, 'PPL', 'P'),
(173801, 'Dewey', 46.5694389343262, 0.812790040210431, -92.2447204589844, -1.60997408959105, 218, 57, 'PPL', 'P'),
(177318, 'Dewey', 41.186939239502, 0.718847698548158, -94.7574996948242, -1.6538303606322, 218, 16, 'PPL', 'P'),
(177632, 'Dewey', 34.5299987792969, 0.602662169408353, -112.240562438965, -1.95896736885021, 218, 5, 'PPL', 'P'),
(192539, 'Dewey', 38.8102798461914, 0.677367166936439, -109.301109313965, -1.90766423361093, 218, 52, 'PPL', 'P'),
(194836, 'Dewey', 43.0402793884277, 0.751194586306315, -116.761390686035, -2.03787070667875, 218, 17, 'PPL', 'P'),
(196353, 'Dewey', 45.7772216796875, 0.798963240725876, -112.85417175293, -1.9696768716998, 218, 31, 'PPL', 'P'),
(202058, 'Dewey', 43.5308303833008, 0.759756316315784, -104.040557861328, -1.81585029029185, 218, 49, 'PPL', 'P'),
(207202, 'Dewey', 48.4252815246582, 0.845180603810465, -122.607223510742, -2.13989973699105, 218, 56, 'PPL', 'P'),
(54431, 'Dewey (historical)', 37.6674995422363, 0.657421888005481, -93.2652816772461, -1.62778624306788, 218, 29, 'PPL', 'P'),
(154990, 'Dewey (historical)', 41.4683303833008, 0.723758900493401, -80.5875015258789, -1.40651723758254, 218, 41, 'PPL', 'P'),
(200696, 'Dewey (historical)', 45.3819389343262, 0.792064255342998, -123.093063354492, -2.14837924190186, 218, 43, 'PPL', 'P'),
(13660, 'Dewey Beach', 38.6927795410156, 0.675316399739023, -75.0749969482422, -1.31030588267152, 218, 10, 'PPL', 'P'),
(160772, 'Dewey Corner', 41.3280601501465, 0.721310723082318, -76.8225021362305, -1.3408056018976, 218, 45, 'PPL', 'P'),
(173802, 'Dewey Corners', 44.250560760498, 0.772317981124497, -91.4733276367188, -1.59651074501627, 218, 57, 'PPL', 'P'),
(20568, 'Dewey Crossroads', 34.329719543457, 0.59916663731957, -84.7919387817383, -1.4798985108908, 218, 13, 'PPL', 'P'),
(160773, 'Dewey Heights', 40.6836090087891, 0.710062928797396, -75.5130615234375, -1.31795155184503, 218, 45, 'PPL', 'P'),
(8502, 'Dewey Mill', 35.5086097717285, 0.619742153322495, -90.3841705322266, -1.57750136747139, 218, 4, 'PPL', 'P'),
(15785, 'Dewey Park', 30.2316703796387, 0.527642186502339, -81.7027816772461, -1.42598254830604, 218, 12, 'PPL', 'P'),
(80675, 'Deweys Hill', 32.8927803039551, 0.574087316439157, -79.977783203125, -1.39587564534075, 218, 48, 'PPL', 'P'),
(171904, 'Deweys Mills', 43.6413917541504, 0.761685976262628, -72.4055633544922, -1.26371547729724, 218, 55, 'PPL', 'P'),
(93723, 'Deweyville', 30.2975006103516, 0.528791140775626, -93.7433319091797, -1.63612979360505, 218, 51, 'PPL', 'P'),
(154991, 'Deweyville', 41.1316719055176, 0.717883101601332, -83.8199996948242, -1.46293497369532, 218, 41, 'PPL', 'P'),
(203723, 'Deweyville', 41.7105598449707, 0.727986602144874, -112.08943939209, -1.9563297741066, 218, 52, 'PPL', 'P'),
(20499, 'DeWitt', 31.4197196960449, 0.548377558749696, -84.1399993896484, -1.46852002197538, 218, 13, 'PPL', 'P'),
(35573, 'Dewitt', 36.8769416809082, 0.64362405039778, -83.7377777099609, -1.46149992934194, 218, 21, 'PPL', 'P'),
(101331, 'DeWitt', 37.0386085510254, 0.646445669572719, -77.6436080932617, -1.35513660435553, 218, 53, 'PPL', 'P'),
(108854, 'Dewitt', 37.9313888549805, 0.662027625373691, -81.1266708374023, -1.41592751729434, 218, 58, 'PPL', 'P'),
(130436, 'DeWitt', 42.8422203063965, 0.747737803211392, -84.5691680908203, -1.47601042885734, 218, 27, 'PPL', 'P'),
(148219, 'DeWitt', 43.0349998474121, 0.751102440932599, -76.0658264160156, -1.32759911920995, 218, 40, 'PPL', 'P'),
(181138, 'Dewitt', 38.0677795410156, 0.664408091914058, -122.538612365723, -2.1387022466069, 218, 6, 'PPL', 'P'),
(199916, 'Dewitt Mill', 40.6341705322266, 0.70920006460421, -117.107223510742, -2.04390662813136, 218, 39, 'PPL', 'P'),
(148220, 'DeWitt Mills', 41.8555603027344, 0.730517337549749, -73.8833312988281, -1.28950739350633, 218, 40, 'PPL', 'P'),
(148285, 'Dewittville', 42.2391700744629, 0.737212591109236, -79.445556640625, -1.38658653945855, 218, 40, 'PPL', 'P'),
(26946, 'Dewmaine', 37.7805595397949, 0.659395157215175, -89.0769424438477, -1.55468593325463, 218, 18, 'PPL', 'P'),
(194821, 'DeWoff', 42.7066688537598, 0.745371984057021, -113.259719848633, -1.97675502124502, 218, 17, 'PPL', 'P'),
(93724, 'Dewville', 29.3777809143066, 0.512739003884201, -97.8108291625977, -1.70712101299302, 218, 51, 'PPL', 'P'),
(20569, 'Dewy Rose', 34.1697196960449, 0.59637411317954, -82.9530563354492, -1.44780395764593, 218, 13, 'PPL', 'P'),
(2038, 'Dexter', 32.6391716003418, 0.569661009549391, -86.1497192382813, -1.50359625037671, 218, 2, 'PPL', 'P'),
(8503, 'Dexter', 34.3166694641113, 0.598938870467341, -92.1083297729492, -1.60759362305068, 218, 4, 'PPL', 'P'),
(20570, 'Dexter', 32.4322204589844, 0.566049030741944, -83.061393737793, -1.44969480201989, 218, 13, 'PPL', 'P'),
(26947, 'Dexter', 39.0808296203613, 0.682089151286231, -88.6833267211914, -1.54781604290666, 218, 18, 'PPL', 'P'),
(29637, 'Dexter', 38.0591697692871, 0.664257823049551, -86.4786071777344, -1.50933642779027, 218, 19, 'PPL', 'P'),
(32236, 'Dexter', 37.1772193908691, 0.648864885106947, -96.7141723632813, -1.68798074108056, 218, 20, 'PPL', 'P'),
(35574, 'Dexter', 36.7427787780762, 0.641282466009328, -88.29638671875, -1.54106266585638, 218, 21, 'PPL', 'P'),
(54432, 'Dexter', 36.7958297729492, 0.642208380541321, -89.9577789306641, -1.57005943012127, 218, 29, 'PPL', 'P'),
(59255, 'Dexter', 31.0741691589355, 0.542346564145102, -89.9927825927734, -1.57067035927534, 218, 30, 'PPL', 'P'),
(64207, 'Dexter', 36.3886108398438, 0.635101069382172, -78.5138931274414, -1.3703259436328, 218, 33, 'PPL', 'P'),
(72315, 'Dexter', 39.0872192382813, 0.682200671156878, -82.2130584716797, -1.43488855846543, 218, 41, 'PPL', 'P'),
(93725, 'Dexter', 33.8186111450195, 0.59024611293224, -96.9633331298828, -1.69232941682455, 218, 51, 'PPL', 'P'),
(115272, 'Dexter', 41.5183296203613, 0.724631551803593, -94.2261123657227, -1.644555902136, 218, 16, 'PPL', 'P'),
(127253, 'Dexter', 45.0238914489746, 0.785815147845127, -69.290283203125, -1.20934358153385, 218, 26, 'PPL', 'P'),
(130491, 'Dexter', 42.3383293151855, 0.738943246343624, -83.8886108398438, -1.46413246407948, 218, 27, 'PPL', 'P'),
(135007, 'Dexter', 43.7188911437988, 0.763038595780279, -92.7044372558594, -1.61799766132324, 218, 28, 'PPL', 'P'),
(148286, 'Dexter', 44.0077781677246, 0.768080625514072, -76.0447235107422, -1.32723080403119, 218, 40, 'PPL', 'P'),
(160774, 'Dexter', 41.7197189331055, 0.728146458389306, -77.383056640625, -1.35058912363617, 218, 45, 'PPL', 'P'),
(173807, 'Dexter', 43.8424987792969, 0.765195956000325, -88.4877777099609, -1.54440306881167, 218, 57, 'PPL', 'P'),
(188423, 'Dexter', 33.1972198486328, 0.579400788867056, -104.372497558594, -1.8216437309272, 218, 38, 'PPL', 'P'),
(200697, 'Dexter', 43.9161109924316, 0.766480731489207, -122.821670532227, -2.14364254358705, 218, 43, 'PPL', 'P'),
(207203, 'Dexter by the Sea', 46.7213897705078, 0.815442082602959, -124.012496948242, -2.16442638536625, 218, 56, 'PPL', 'P'),
(72314, 'Dexter City', 39.6577796936035, 0.692158829683929, -81.4722213745117, -1.42195851189893, 218, 41, 'PPL', 'P'),
(143711, 'Dexter Corner', 43.3691711425781, 0.756934830298899, -71.1588897705078, -1.24195691855907, 218, 36, 'PPL', 'P'),
(13661, 'Dexter Corners', 39.3344383239746, 0.686515458175997, -75.6999969482422, -1.32121419049649, 218, 10, 'PPL', 'P'),
(35575, 'Dexterville', 37.3175010681152, 0.651313262255112, -86.6561126708984, -1.51243448308636, 218, 21, 'PPL', 'P'),
(148287, 'Dexterville', 43.3233299255371, 0.756134750128412, -76.501106262207, -1.33519618569357, 218, 40, 'PPL', 'P'),
(173809, 'Dexterville', 44.3763885498047, 0.774514090338403, -90.1105575561523, -1.57272592016271, 218, 57, 'PPL', 'P'),
(209406, 'Dexterville (historical)', 41.2613906860352, 0.720147121423035, -107.228057861328, -1.87148266019917, 218, 59, 'PPL', 'P'),
(93726, 'Dextra', 31.809440612793, 0.55517947191084, -94.9305572509766, -1.65685078478252, 218, 51, 'PPL', 'P'),
(154992, 'Deyarmonville', 40.211669921875, 0.70182603786189, -80.7616729736328, -1.40955710280881, 218, 41, 'PPL', 'P'),
(170163, 'Dezera', 43.1652793884277, 0.753376247871308, -98.5013885498047, -1.71917354798033, 218, 49, 'PPL', 'P'),
(173810, 'Dheinsville', 43.25, 0.754854901487548, -88.1427764892578, -1.538381661587, 218, 57, 'PPL', 'P'),
(181139, 'Di Giorgio', 35.2527809143066, 0.615277097438868, -118.850563049316, -2.07433364305968, 218, 6, 'PPL', 'P'),
(181140, 'Diablo', 37.8349990844727, 0.660345306513088, -121.956939697266, -2.12855014337346, 218, 6, 'PPL', 'P'),
(207204, 'Diablo', 48.7136116027832, 0.850212913006279, -121.139999389648, -2.11429184521329, 218, 56, 'PPL', 'P'),
(35576, 'Diablock', 37.228328704834, 0.649756910914069, -83.1722183227539, -1.45162905591961, 218, 21, 'PPL', 'P'),
(115273, 'Diagonal', 40.809440612793, 0.71225910459033, -94.3419418334961, -1.64657750771948, 218, 16, 'PPL', 'P'),
(20572, 'Dial', 34.7597198486328, 0.606671558429468, -84.2169418334961, -1.46986292095506, 218, 13, 'PPL', 'P'),
(108855, 'Dial', 38.4199981689453, 0.670555466658288, -81.4866714477539, -1.42221071325416, 218, 58, 'PPL', 'P'),
(191379, 'Dial', 35.7975006103516, 0.624784249635314, -101.391670227051, -1.76961847955834, 218, 51, 'PPL', 'P'),
(8504, 'Dial (historical)', 34.3388900756836, 0.599326693301084, -94.07861328125, -1.64198155746828, 218, 4, 'PPL', 'P'),
(154993, 'Dialton', 40.0272216796875, 0.698606808736202, -83.940559387207, -1.4650391372726, 218, 41, 'PPL', 'P'),
(8505, 'Dialton (historical)', 34.0422210693359, 0.594148842351697, -92.1022186279297, -1.60748696344903, 218, 4, 'PPL', 'P'),
(20573, 'Dialtown', 33.6472206115723, 0.587254783816836, -83.8633270263672, -1.46369117828685, 218, 13, 'PPL', 'P'),
(93728, 'Dialville', 31.8572196960449, 0.556013374227171, -95.2302780151367, -1.66208189895371, 218, 51, 'PPL', 'P'),
(188424, 'Diamante (historical)', 36.9324989318848, 0.644593707350678, -106.816390991211, -1.86429771789424, 218, 38, 'PPL', 'P'),
(188425, 'Diamante Mill', 33.3283309936523, 0.581689110033707, -104.838333129883, -1.82977409541911, 218, 38, 'PPL', 'P'),
(2039, 'Diamond', 34.3022193908691, 0.59868666911211, -86.3963928222656, -1.50790151659493, 218, 2, 'PPL', 'P'),
(20574, 'Diamond', 34.6741714477539, 0.605178457164315, -84.2761077880859, -1.47089556166774, 218, 13, 'PPL', 'P'),
(29638, 'Diamond', 39.6113891601563, 0.691349162133518, -87.1661071777344, -1.52133556639773, 218, 19, 'PPL', 'P'),
(35577, 'Diamond', 37.4166717529297, 0.653044117226581, -87.8022232055664, -1.5324378855081, 218, 21, 'PPL', 'P'),
(40067, 'Diamond', 29.5352802276611, 0.515487885471867, -89.7619400024414, -1.56664139602021, 218, 22, 'PPL', 'P'),
(54433, 'Diamond', 36.9952812194824, 0.645689464981191, -94.3158264160156, -1.64612170769892, 218, 29, 'PPL', 'P'),
(108857, 'Diamond', 37.8250007629395, 0.660170802882661, -82.081672668457, -1.43259544360882, 218, 58, 'PPL', 'P'),
(115274, 'Diamond', 40.7630615234375, 0.711449636777, -92.9655609130859, -1.6225551288967, 218, 16, 'PPL', 'P'),
(119371, 'Diamond', 41.2886085510254, 0.720622162782478, -88.2516708374023, -1.54028222649893, 218, 18, 'PPL', 'P'),
(154994, 'Diamond', 41.0988883972168, 0.717310921441128, -81.023063659668, -1.41411923091417, 218, 41, 'PPL', 'P'),
(160776, 'Diamond', 41.021110534668, 0.715953441654488, -79.4830627441406, -1.38724114445449, 218, 45, 'PPL', 'P'),
(170164, 'Diamond', 45.7372207641602, 0.798265093046112, -96.6911087036133, -1.6875782042818, 218, 49, 'PPL', 'P'),
(181144, 'Diamond', 38.021671295166, 0.663603351211664, -121.892219543457, -2.1274205635971, 218, 6, 'PPL', 'P'),
(192540, 'Diamond', 39.8816719055176, 0.696066485951403, -112.096672058105, -1.95645600794227, 218, 52, 'PPL', 'P'),
(194837, 'Diamond', 44.4141693115234, 0.775173489024307, -116.775001525879, -2.03810826064799, 218, 17, 'PPL', 'P'),
(200698, 'Diamond', 43.0122184753418, 0.75070483098185, -118.665000915527, -2.07109497285804, 218, 43, 'PPL', 'P'),
(207205, 'Diamond', 46.9180603027344, 0.818874630931962, -117.487503051758, -2.05054375820006, 218, 56, 'PPL', 'P'),
(209407, 'Diamond', 41.6652793884277, 0.727196309091393, -104.997497558594, -1.83255203875217, 218, 59, 'PPL', 'P'),
(93729, 'Diamond ''L'' Colonia', 26.2689990997314, 0.45848052549374, -98.3270034790039, -1.71612995432854, 218, 51, 'PPL', 'P'),
(154995, 'Diamond (historical)', 40.9013900756836, 0.713863925463211, -81.3249969482422, -1.41938896092117, 218, 41, 'PPL', 'P'),
(211785, 'Diamond (historical)', 63.8866691589355, 1.11503272495574, -150.903060913086, -2.63375526427091, 218, 1, 'PPL', 'P'),
(181141, 'Diamond A Ranch Estates', 38.3041687011719, 0.668533861074809, -122.544166564941, -2.13879918567058, 218, 6, 'PPL', 'P'),
(181142, 'Diamond Bar', 34.0286102294922, 0.593911288382462, -117.809440612793, -2.05616262862596, 218, 6, 'PPL', 'P'),
(181143, 'Diamond Bar B Ranch', 37.9674987792969, 0.662657862445658, -120.281936645508, -2.09931582513933, 218, 6, 'PPL', 'P'),
(8506, 'Diamond Bay', 36.3125, 0.633772684630441, -92.2238922119141, -1.60961056810226, 218, 4, 'PPL', 'P'),
(70739, 'Diamond Beach', 38.9594383239746, 0.679970473481018, -74.852783203125, -1.30642752117604, 218, 37, 'PPL', 'P'),
(178088, 'Diamond Bell Ranch', 31.9733295440674, 0.558039873369153, -111.281669616699, -1.94223153192794, 218, 5, 'PPL', 'P'),
(173811, 'Diamond Bluff', 44.6505584716797, 0.779299258185058, -92.6288909912109, -1.61667913026754, 218, 57, 'PPL', 'P'),
(8507, 'Diamond Cave', 35.9850006103516, 0.628056741982804, -93.2324981689453, -1.62721406290768, 218, 4, 'PPL', 'P'),
(8508, 'Diamond City', 36.4644393920898, 0.636424527285887, -92.9199981689453, -1.6217599089952, 218, 4, 'PPL', 'P'),
(26948, 'Diamond City', 38.089168548584, 0.66478140051986, -88.5524978637695, -1.54553264858802, 218, 18, 'PPL', 'P'),
(196354, 'Diamond City', 46.5972213745117, 0.813274935265907, -111.423057556152, -1.944699216994, 218, 31, 'PPL', 'P'),
(207206, 'Diamond City', 48.6166687011719, 0.848520940186724, -117.288887023926, -2.04707725456716, 218, 56, 'PPL', 'P'),
(190115, 'Diamond City (historical)', 39.7377815246582, 0.693555125043458, -115.860000610352, -2.02213848201327, 218, 39, 'PPL', 'P'),
(202060, 'Diamond City (historical)', 44.1500015258789, 0.770562891387107, -103.698608398438, -1.80988214628898, 218, 49, 'PPL', 'P'),
(135010, 'Diamond Corner', 43.9938888549805, 0.767838211275847, -96.1036071777344, -1.67732436829472, 218, 28, 'PPL', 'P'),
(26949, 'Diamond Cross', 37.9844398498535, 0.662953539905684, -89.8397216796875, -1.56799894238588, 218, 18, 'PPL', 'P'),
(178089, 'Diamond Fields', 36.8127784729004, 0.642504191159402, -109.889442443848, -1.91793258382595, 218, 5, 'PPL', 'P'),
(8516, 'Diamond Grove', 35.311939239502, 0.616309604993492, -94.1986083984375, -1.64407586734952, 218, 4, 'PPL', 'P'),
(101401, 'Diamond Grove', 36.708610534668, 0.640686117662232, -77.9372177124023, -1.36026105892506, 218, 53, 'PPL', 'P'),
(173813, 'Diamond Grove', 42.7924995422363, 0.74687001217019, -90.9194412231445, -1.58684360341733, 218, 57, 'PPL', 'P'),
(20575, 'Diamond Hill', 34.0633316040039, 0.594517290688509, -83.2780609130859, -1.45347635760974, 218, 13, 'PPL', 'P'),
(101404, 'Diamond Hill', 37.4055595397949, 0.652850172520196, -79.1455612182617, -1.3813506315974, 218, 53, 'PPL', 'P'),
(169348, 'Diamond Hill', 41.9877815246582, 0.73282503321333, -71.4124984741211, -1.24638322544884, 218, 47, 'PPL', 'P'),
(80676, 'Diamond Hill Spring (historical)', 34.2105598449707, 0.5970869082453, -82.7125015258789, -1.44360548418742, 218, 48, 'PPL', 'P'),
(93730, 'Diamond L Colonia Number 2', 26.2929992675781, 0.458899407443696, -98.3460006713867, -1.71646151788425, 218, 51, 'PPL', 'P'),
(119372, 'Diamond Lake', 42.2444381713867, 0.737304536745871, -88.0100021362305, -1.53606431196446, 218, 18, 'PPL', 'P'),
(200699, 'Diamond Lake', 43.1788902282715, 0.753613801840543, -122.13777923584, -2.13170638873937, 218, 43, 'PPL', 'P'),
(207207, 'Diamond Lake', 48.121940612793, 0.839886306142415, -117.198059082031, -2.04549200792829, 218, 56, 'PPL', 'P'),
(101405, 'Diamond Lake Estates', 36.8794403076172, 0.64366765966063, -76.1836090087891, -1.32965481325538, 218, 53, 'PPL', 'P'),
(148288, 'Diamond Point', 43.4791717529297, 0.758854703128737, -73.6875, -1.28608949256332, 218, 40, 'PPL', 'P'),
(178090, 'Diamond Point Shadows', 34.2694396972656, 0.598114555530934, -111.22444152832, -1.9412327133611, 218, 5, 'PPL', 'P'),
(178091, 'Diamond Point Summer Homes', 34.329719543457, 0.59916663731957, -111.189720153809, -1.94062671105506, 218, 5, 'PPL', 'P'),
(101406, 'Diamond Pointe', 37.148609161377, 0.648365542402557, -80.436393737793, -1.40387990915504, 218, 53, 'PPL', 'P'),
(211786, 'Diamond Ridge', 59.6761093139648, 1.04154459230874, -151.557495117188, -2.64517729587015, 218, 1, 'PPL', 'P'),
(20576, 'Diamond Rock (historical)', 34.045280456543, 0.594202238731553, -83.295280456543, -1.45377689533876, 218, 13, 'PPL', 'P'),
(130494, 'Diamond Shores', 41.8980598449707, 0.731259094492364, -85.9680633544922, -1.50042575709897, 218, 27, 'PPL', 'P'),
(32238, 'Diamond Springs', 38.5574989318848, 0.672955307695586, -96.7441711425781, -1.68850431855087, 218, 20, 'PPL', 'P'),
(35578, 'Diamond Springs', 37.0355606079102, 0.646392472929945, -86.975830078125, -1.5180146045184, 218, 21, 'PPL', 'P'),
(130495, 'Diamond Springs', 42.6805610656738, 0.744916317194508, -85.8969421386719, -1.49918445771488, 218, 27, 'PPL', 'P'),
(181146, 'Diamond Springs', 38.6947212219238, 0.675350288463894, -120.813888549805, -2.10860013733157, 218, 6, 'PPL', 'P'),
(188427, 'Diamond Tail Ranch', 35.3208312988281, 0.616464800706016, -106.388061523438, -1.85682195839828, 218, 38, 'PPL', 'P'),
(154996, 'Diamond Valley', 40.6208305358887, 0.70896723774591, -80.8561096191406, -1.41120533320746, 218, 41, 'PPL', 'P'),
(178092, 'Diamond Valley', 34.5680618286133, 0.603326494942274, -112.374443054199, -1.96130402639065, 218, 5, 'PPL', 'P'),
(196355, 'Diamond Valley', 47.8433303833008, 0.835023640308039, -111.494171142578, -1.94594038322004, 218, 31, 'PPL', 'P'),
(46302, 'Diamond View', 39.2880592346191, 0.685705990362667, -77.220832824707, -1.34775778392325, 218, 25, 'PPL', 'P'),
(8510, 'Diamondhead', 34.4397201538086, 0.601086510149408, -92.9449996948242, -1.62219626793981, 218, 4, 'PPL', 'P'),
(59256, 'Diamondhead', 30.3944396972656, 0.530483047016154, -89.3638916015625, -1.55969414084257, 218, 30, 'PPL', 'P'),
(160779, 'Diamondtown', 40.8011093139648, 0.712113695994811, -76.4177780151367, -1.33374183342227, 218, 45, 'PPL', 'P'),
(160777, 'Diamondville', 40.6650009155273, 0.709738156302461, -78.9674987792969, -1.37824285576333, 218, 45, 'PPL', 'P'),
(209408, 'Diamondville', 41.7794418334961, 0.729188819639963, -110.537780761719, -1.92924822213964, 218, 59, 'PPL', 'P'),
(26950, 'Diana', 38.0997200012207, 0.664965558109239, -88.7513885498047, -1.54900394591089, 218, 18, 'PPL', 'P'),
(86304, 'Diana', 35.2838897705078, 0.615820049406108, -86.8555603027344, -1.5159155009472, 218, 50, 'PPL', 'P'),
(93731, 'Diana', 32.7097206115723, 0.570892322079389, -94.7519378662109, -1.65373328841047, 218, 51, 'PPL', 'P'),
(108858, 'Diana', 38.5736083984375, 0.673236470927671, -80.456672668457, -1.40423384326391, 218, 58, 'PPL', 'P'),
(148291, 'Diana Center', 44.0755615234375, 0.769263668249312, -75.4411087036133, -1.316695738233, 218, 40, 'PPL', 'P'),
(93732, 'Diana Colonia Number 1', 26.1879997253418, 0.457066819718585, -97.9889984130859, -1.71023065303985, 218, 51, 'PPL', 'P'),
(93733, 'Diana Colonia Number 2', 26.1870002746582, 0.457049376013445, -97.9889984130859, -1.71023065303985, 218, 51, 'PPL', 'P'),
(93734, 'Diana Colonia Number 3', 26.1870002746582, 0.457049376013445, -97.9889984130859, -1.71023065303985, 218, 51, 'PPL', 'P'),
(130496, 'Diann', 41.9319381713867, 0.731850382833389, -83.6372222900391, -1.45974490618357, 218, 27, 'PPL', 'P'),
(8511, 'Diantha (historical)', 34.3852806091309, 0.600136360851495, -91.7680587768555, -1.60165477381981, 218, 4, 'PPL', 'P'),
(160778, 'Dias', 40.4811096191406, 0.706528647714752, -79.0447235107422, -1.37959068159102, 218, 45, 'PPL', 'P'),
(70740, 'Dias Creek', 39.0888900756836, 0.682229832770814, -74.8808288574219, -1.3069170101844, 218, 37, 'PPL', 'P'),
(101407, 'Diascund', 37.3941688537598, 0.652651367544822, -76.8708267211914, -1.34164902501483, 218, 53, 'PPL', 'P'),
(8512, 'Diaz', 35.6383285522461, 0.622006173144198, -91.2649993896484, -1.59287473117998, 218, 4, 'PPL', 'P'),
(93735, 'Diaz Colonia', 26.2059993743896, 0.457380972858674, -98.197998046875, -1.71387838478493, 218, 51, 'PPL', 'P'),
(75655, 'Dibble', 35.0333290100098, 0.611446939159116, -97.6294403076172, -1.70395518024719, 218, 42, 'PPL', 'P'),
(148290, 'Dibble Corner', 42.4286117553711, 0.740518972181596, -75.7119369506836, -1.32142258285178, 218, 40, 'PPL', 'P'),
(193499, 'Dibble Place', 41.1894416809082, 0.718891374390036, -120.89582824707, -2.11003025483694, 218, 6, 'PPL', 'P'),
(148292, 'Dibbletown', 43.2802810668945, 0.755383405805874, -75.710563659668, -1.32139861440197, 218, 40, 'PPL', 'P'),
(93736, 'Diboll', 31.186939239502, 0.544314773348725, -94.7808303833008, -1.65423755796288, 218, 51, 'PPL', 'P'),
(86306, 'Dibrell', 35.896110534668, 0.626505317489778, -85.5052795410156, -1.49234865582887, 218, 50, 'PPL', 'P'),
(35579, 'Dice', 37.3627815246582, 0.652103555308593, -83.2275009155273, -1.45259391918255, 218, 21, 'PPL', 'P'),
(130497, 'Dice', 43.4666709899902, 0.758636523656433, -84.1116714477539, -1.46802560611901, 218, 27, 'PPL', 'P'),
(160780, 'Dice', 40.8877792358398, 0.713626371493976, -77.038330078125, -1.34457251010146, 218, 45, 'PPL', 'P'),
(130498, 'Dice Corners', 43.6124992370605, 0.761181706710222, -84.3694381713867, -1.47252448414848, 218, 27, 'PPL', 'P'),
(93737, 'Dicey', 32.8072204589844, 0.572594015436923, -97.6988906860352, -1.70516731801734, 218, 51, 'PPL', 'P'),
(59257, 'Dick', 31.3944396972656, 0.547936339536097, -90.841667175293, -1.58548619020972, 218, 30, 'PPL', 'P'),
(130499, 'Dick', 46.1908302307129, 0.806182071755672, -84.8313903808594, -1.48058707119064, 218, 27, 'PPL', 'P'),
(160781, 'Dick', 40.2580604553223, 0.702635705412301, -79.7355575561523, -1.3916480102683, 218, 45, 'PPL', 'P'),
(194157, 'Dick', 40.0313911437988, 0.698679579612988, -104.936668395996, -1.83149036958361, 218, 7, 'PPL', 'P'),
(46303, 'Dickens', 39.707218170166, 0.693021693877115, -78.6933288574219, -1.37345768791668, 218, 25, 'PPL', 'P'),
(54434, 'Dickens', 36.7275009155273, 0.641015817005184, -93.0472183227539, -1.62398031955405, 218, 29, 'PPL', 'P'),
(115277, 'Dickens', 43.1313896179199, 0.752784759793202, -95.0233306884766, -1.65846998672529, 218, 16, 'PPL', 'P'),
(191381, 'Dickens', 33.6216697692871, 0.586808837492302, -100.836112976074, -1.75992217634547, 218, 51, 'PPL', 'P'),
(199274, 'Dickens', 40.8261108398438, 0.712550054939421, -100.992500305176, -1.7626516501467, 218, 35, 'PPL', 'P'),
(194840, 'Dickens Place', 42.1497192382813, 0.735651379499204, -115.971389770508, -2.02408258960903, 218, 17, 'PPL', 'P'),
(194838, 'Dickensheet Junction', 48.4519386291504, 0.845645858052902, -116.906936645508, -2.04041096288453, 218, 17, 'PPL', 'P'),
(181147, 'Dickenson (historical)', 37.1986083984375, 0.649238193712749, -120.207221984863, -2.09801180831158, 218, 6, 'PPL', 'P'),
(101408, 'Dickenson Corner', 36.8911094665527, 0.643871324904994, -82.2380599975586, -1.43532491741004, 218, 53, 'PPL', 'P'),
(101410, 'Dickensons Store', 38.2088890075684, 0.666870916711136, -78.334716796875, -1.36719872672277, 218, 53, 'PPL', 'P'),
(101411, 'Dickensonville', 36.8416709899902, 0.643008460711809, -82.2252807617188, -1.43510187766874, 218, 53, 'PPL', 'P'),
(46310, 'Dickerson', 39.2200012207031, 0.684518153937465, -77.4244384765625, -1.3513113729238, 218, 25, 'PPL', 'P'),
(59258, 'Dickerson', 34.3211097717285, 0.599016368455062, -90.6363906860352, -1.58190343959524, 218, 30, 'PPL', 'P'),
(64209, 'Dickerson', 36.264720916748, 0.63293878231411, -78.5519409179688, -1.37099000285061, 218, 33, 'PPL', 'P'),
(119373, 'Dickerson', 40.3183288574219, 0.703687587463855, -88.4222183227539, -1.54325884164931, 218, 18, 'PPL', 'P'),
(181148, 'Dickerson (historical)', 36.8005599975586, 0.642290938535114, -119.98722076416, -2.0941720626519, 218, 6, 'PPL', 'P'),
(80677, 'Dickerson Acres', 34.5019416809082, 0.602172480662915, -82.7444381713867, -1.44416288380357, 218, 48, 'PPL', 'P'),
(70741, 'Dickerson Corner', 39.4575004577637, 0.688663297595146, -75.3219375610352, -1.31461580942165, 218, 37, 'PPL', 'P'),
(64210, 'Dickerson Estates', 35.8383293151855, 0.625496844963992, -80.3180618286133, -1.40181462772968, 218, 33, 'PPL', 'P'),
(20577, 'Dickerson Mill', 34.9377784729004, 0.609779267684508, -83.4427795410156, -1.45635124000649, 218, 13, 'PPL', 'P'),
(160782, 'Dickerson Run', 40.0455589294434, 0.698926854120202, -79.6666717529297, -1.39044572619419, 218, 45, 'PPL', 'P'),
(148293, 'Dickersonville', 43.190559387207, 0.753817467084907, -78.9305572509766, -1.37759810446343, 218, 40, 'PPL', 'P'),
(2040, 'Dickert', 33.1316719055176, 0.578256761441785, -85.4730606079102, -1.4917863293647, 218, 2, 'PPL', 'P'),
(15786, 'Dickert', 30.3391704559326, 0.529518416779813, -83.0805587768555, -1.4500292950528, 218, 12, 'PPL', 'P'),
(20578, 'Dickey', 31.5569400787354, 0.550772506228491, -84.6602783203125, -1.47760060234423, 218, 13, 'PPL', 'P'),
(78132, 'Dickey', 39.8680610656738, 0.695828931982168, -77.8958282470703, -1.35953867647938, 218, 45, 'PPL', 'P'),
(127255, 'Dickey', 47.1094398498535, 0.822214834150167, -69.0869369506836, -1.20579451990716, 218, 26, 'PPL', 'P'),
(139887, 'Dickey', 46.5369415283203, 0.812222853477271, -98.4674987792969, -1.71858205990223, 218, 34, 'PPL', 'P'),
(194839, 'Dickey', 44.1344413757324, 0.770291315534947, -113.904441833496, -1.98800754264087, 218, 17, 'PPL', 'P'),
(8514, 'Dickey (historical)', 34.601390838623, 0.603908195903374, -92.1322174072266, -1.60801054091934, 218, 4, 'PPL', 'P'),
(20579, 'Dickey (historical)', 34.9719390869141, 0.61037548287355, -85.3322219848633, -1.48932823167856, 218, 13, 'PPL', 'P'),
(8515, 'Dickey Junction', 35.8375015258789, 0.625482397315079, -92.9544372558594, -1.62236098445323, 218, 4, 'PPL', 'P'),
(40069, 'Dickey Landing', 32.0888900756836, 0.560056785131211, -91.5902786254883, -1.59855192483376, 218, 22, 'PPL', 'P'),
(119374, 'Dickeys', 41.0508308410645, 0.716472158855808, -88.0372161865234, -1.53653928674488, 218, 18, 'PPL', 'P'),
(112516, 'Dickeys Mountain', 39.7797203063965, 0.694287094869066, -78.0777816772461, -1.36271436292125, 218, 45, 'PPL', 'P'),
(29641, 'Dickeyville', 38.1561088562012, 0.665949729290078, -87.2197189331055, -1.52227126804673, 218, 19, 'PPL', 'P'),
(46304, 'Dickeyville', 39.3188896179199, 0.686244082060918, -76.7038879394531, -1.33873539362423, 218, 25, 'PPL', 'P'),
(173814, 'Dickeyville', 42.6272201538086, 0.743985342656444, -90.5919418334961, -1.5811276607697, 218, 57, 'PPL', 'P'),
(115279, 'Dickieville', 41.0011100769043, 0.715604367814605, -94.8958282470703, -1.65624464931842, 218, 16, 'PPL', 'P'),
(2041, 'Dickinson', 31.7633304595947, 0.554374697918932, -87.710563659668, -1.53083812464129, 218, 2, 'PPL', 'P'),
(46305, 'Dickinson', 39.1644401550293, 0.68354843040554, -76.8680572509766, -1.34160068864104, 218, 25, 'PPL', 'P'),
(93739, 'Dickinson', 29.4605598449707, 0.514183768775569, -95.0511093139648, -1.65895481520174, 218, 51, 'PPL', 'P'),
(101413, 'Dickinson', 36.920280456543, 0.64438045472639, -79.7072219848633, -1.39115346125387, 218, 53, 'PPL', 'P'),
(108859, 'Dickinson', 38.2036094665527, 0.66677877133742, -81.5027770996094, -1.42249180990722, 218, 58, 'PPL', 'P'),
(148298, 'Dickinson', 44.7483291625977, 0.781005678653526, -74.5650024414063, -1.30140479936015, 218, 40, 'PPL', 'P'),
(160783, 'Dickinson', 40.1133308410645, 0.700109697118361, -77.3352813720703, -1.34975528789886, 218, 45, 'PPL', 'P'),
(198192, 'Dickinson', 46.8791694641113, 0.818195857749128, -102.789169311523, -1.794009439876, 218, 34, 'PPL', 'P'),
(148294, 'Dickinson Center', 44.7174987792969, 0.780467586955276, -74.5530624389648, -1.30119640700485, 218, 40, 'PPL', 'P'),
(101414, 'Dickinsons Corner', 38.2102813720703, 0.666895218056083, -77.0683288574219, -1.34509608757177, 218, 53, 'PPL', 'P'),
(20580, 'Dicks Hill', 34.5833282470703, 0.603592944209336, -83.4263916015625, -1.45606521650541, 218, 13, 'PPL', 'P'),
(194841, 'Dickshooter', 42.3916702270508, 0.739874220881688, -116.500831604004, -2.03332309280133, 218, 17, 'PPL', 'P'),
(20581, 'Dickson', 33.5708312988281, 0.585921538796115, -83.6069412231445, -1.45921640186525, 218, 13, 'PPL', 'P'),
(75656, 'Dickson', 34.1872215270996, 0.596679577756572, -96.9841690063477, -1.6926930714714, 218, 42, 'PPL', 'P'),
(86307, 'Dickson', 36.0769386291504, 0.629661363118604, -87.3877792358398, -1.52520447367134, 218, 50, 'PPL', 'P'),
(108861, 'Dickson', 37.7691688537598, 0.659196352239801, -80.3463897705078, -1.40230904358605, 218, 58, 'PPL', 'P'),
(160785, 'Dickson City', 41.4713897705078, 0.723812296873257, -75.6080627441406, -1.31960963593971, 218, 45, 'PPL', 'P'),
(86309, 'Dickson Town', 35.0463905334473, 0.611674905748427, -86.8788909912109, -1.51632269827787, 218, 50, 'PPL', 'P'),
(160787, 'Dicksonburg', 41.7052803039551, 0.727894456771158, -80.3522186279297, -1.40241077633969, 218, 45, 'PPL', 'P'),
(72316, 'Dicksonton (historical)', 39.648609161377, 0.691998773702416, -82.2491683959961, -1.4355187955374, 218, 41, 'PPL', 'P'),
(160788, 'Dicksonville', 40.7161102294922, 0.710630182109583, -79.0074996948242, -1.3789410034431, 218, 45, 'PPL', 'P'),
(70744, 'Dicktown', 39.7561111450195, 0.693875037269404, -74.9816665649414, -1.30867696019077, 218, 37, 'PPL', 'P'),
(127256, 'Dickvale', 44.4855613708496, 0.776419515519328, -70.480827331543, -1.23012249646503, 218, 26, 'PPL', 'P'),
(160789, 'Dickville', 41.3080596923828, 0.720961649242436, -75.8675003051758, -1.32413767558312, 218, 45, 'PPL', 'P'),
(93740, 'Dickworsham', 33.7513885498047, 0.589072857314006, -98.1152801513672, -1.712434685158, 218, 51, 'PPL', 'P'),
(8518, 'Dicus', 36.0883293151855, 0.629860168093978, -90.9277801513672, -1.58698914517091, 218, 4, 'PPL', 'P'),
(148297, 'Diddell', 41.6233291625977, 0.726464139528703, -73.8525009155273, -1.28896930180808, 218, 40, 'PPL', 'P'),
(160790, 'Didier', 40.603328704834, 0.708661773168878, -75.341667175293, -1.3149601561506, 218, 45, 'PPL', 'P'),
(40068, 'Dido', 30.9113903045654, 0.53950553718372, -92.8897171020508, -1.62123140467687, 218, 22, 'PPL', 'P'),
(160791, 'Diebertsville', 40.6847190856934, 0.710082303294326, -75.6466674804688, -1.3202834156955, 218, 45, 'PPL', 'P'),
(173816, 'Diefenbach Corners', 43.3536109924316, 0.756663254446739, -88.2605590820313, -1.54043735563243, 218, 57, 'PPL', 'P'),
(160792, 'Dieffenbach', 41.0744400024414, 0.71688421645547, -76.6849975585938, -1.33840569428127, 218, 45, 'PPL', 'P'),
(78133, 'Diehl', 39.9288902282715, 0.696890601150728, -78.4880599975586, -1.36987507046025, 218, 45, 'PPL', 'P'),
(54435, 'Diehlstadt', 36.9583282470703, 0.645044513944201, -89.4308319091797, -1.56086246961279, 218, 29, 'PPL', 'P'),
(160796, 'Diehltown', 40.7861099243164, 0.711851907259657, -78.5652770996094, -1.37122276312988, 218, 45, 'PPL', 'P'),
(188428, 'Diener', 35.1747207641602, 0.613914690804211, -108.126670837402, -1.88716641533281, 218, 38, 'PPL', 'P'),
(160793, 'Dieners Hill', 40.7011108398438, 0.710368393374428, -76.1774978637695, -1.32954815365373, 218, 45, 'PPL', 'P'),
(207208, 'Dieringer', 47.2408294677734, 0.824508015585807, -122.223892211914, -2.13320934370056, 218, 56, 'PPL', 'P'),
(8519, 'Dierks', 34.1191711425781, 0.595491874489424, -94.0163879394531, -1.64089552037574, 218, 4, 'PPL', 'P'),
(93741, 'Dies', 30.3886108398438, 0.530381314262513, -94.3958282470703, -1.64751800305844, 218, 51, 'PPL', 'P'),
(93742, 'Dies Community', 30.8611106872559, 0.538627992315025, -94.4897232055664, -1.64915677923522, 218, 51, 'PPL', 'P'),
(199918, 'Diessner (historical)', 41.8519401550293, 0.730454154052887, -119.812782287598, -2.09112753689372, 218, 39, 'PPL', 'P'),
(26951, 'Dieterich', 39.061939239502, 0.681759451943279, -88.3797225952148, -1.54251715128573, 218, 18, 'PPL', 'P'),
(160794, 'Dietrich', 40.5283317565918, 0.707352829493104, -76.8263931274414, -1.3408735125054, 218, 45, 'PPL', 'P'),
(194842, 'Dietrich', 42.9094390869141, 0.7489109922506, -114.264442443848, -1.9942907386007, 218, 17, 'PPL', 'P'),
(160795, 'Dietrichtown', 40.7050018310547, 0.710436303982225, -75.2083282470703, -1.31263295283203, 218, 45, 'PPL', 'P'),
(115280, 'Dietrick Mobile Home Park', 42.4680595397949, 0.741207465902409, -92.4541702270508, -1.61362967766135, 218, 16, 'PPL', 'P'),
(20582, 'Dietz', 34.9444389343262, 0.60989551466609, -85.2022171020508, -1.48705921842981, 218, 13, 'PPL', 'P'),
(35580, 'Dietz Acres', 37.8655586242676, 0.660878671100404, -85.9499969482422, -1.5001104388259, 218, 21, 'PPL', 'P'),
(86310, 'Difficult', 36.3691711425781, 0.634761782659296, -85.892219543457, -1.49910203287915, 218, 50, 'PPL', 'P'),
(130502, 'Diffin', 46.2099990844727, 0.806516631367613, -87.0338897705078, -1.51902793731317, 218, 27, 'PPL', 'P'),
(20583, 'Digbey', 33.2574996948242, 0.580452870655692, -84.4894409179688, -1.47461892718778, 218, 13, 'PPL', 'P'),
(154997, 'Digby', 41.2944412231445, 0.720723962115147, -83.7091674804688, -1.46100058663755, 218, 41, 'PPL', 'P'),
(54436, 'Diggins', 37.1725006103516, 0.648782526850237, -92.8541717529297, -1.62061102130094, 218, 29, 'PPL', 'P'),
(64211, 'Diggs', 34.8472213745117, 0.608198748156573, -79.8569412231445, -1.39376655491546, 218, 33, 'PPL', 'P'),
(101415, 'Diggs', 37.436939239502, 0.653397851598371, -76.2686080932617, -1.33113832714061, 218, 53, 'PPL', 'P'),
(75657, 'Dighton', 35.4674987792969, 0.6190246311458, -95.8927764892578, -1.67364467861656, 218, 42, 'PPL', 'P'),
(124639, 'Dighton', 41.8138885498047, 0.729790028256049, -71.1208267211914, -1.24129259302515, 218, 23, 'PPL', 'P'),
(130503, 'Dighton', 44.0877799987793, 0.7694769208736, -85.3450012207031, -1.48955127141985, 218, 27, 'PPL', 'P'),
(177705, 'Dighton', 38.4819412231445, 0.671636576902806, -100.466667175293, -1.75347413071417, 218, 20, 'PPL', 'P'),
(93743, 'Dike', 33.2386093139648, 0.58012317131274, -95.4819412231445, -1.66647425053957, 218, 51, 'PPL', 'P'),
(115289, 'Dike', 42.464168548584, 0.741139555294612, -92.628059387207, -1.6166646160396, 218, 16, 'PPL', 'P'),
(190117, 'Dike', 36.3013916015625, 0.633578806503083, -115.012496948242, -2.00734675268676, 218, 39, 'PPL', 'P'),
(101416, 'Dilbeck', 38.8958282470703, 0.678860268201591, -78.3694381713867, -1.36780472902882, 218, 53, 'PPL', 'P'),
(54437, 'Dilday Mill', 37.3252792358398, 0.651449016891678, -93.7805633544922, -1.63677960491103, 218, 29, 'PPL', 'P'),
(64212, 'Dildys Mill', 36.3236083984375, 0.633966562757799, -76.9091720581055, -1.34231827739676, 218, 33, 'PPL', 'P'),
(64213, 'Dilhast', 36.1511116027832, 0.630955925724491, -80.1291732788086, -1.39851790061627, 218, 33, 'PPL', 'P'),
(188429, 'Dilia', 35.1930618286133, 0.614234802767238, -105.063056945801, -1.83369626591452, 218, 38, 'PPL', 'P'),
(70742, 'Dilkes Mills', 39.7347183227539, 0.693501662084575, -75.2819366455078, -1.31391766174189, 218, 37, 'PPL', 'P'),
(70743, 'Dilkesboro', 39.7391700744629, 0.693579359809378, -75.0805587768555, -1.31040295489325, 218, 37, 'PPL', 'P'),
(178093, 'Dilkon', 35.3852806091309, 0.617589653371438, -110.319999694824, -1.92544722547382, 218, 5, 'PPL', 'P'),
(2043, 'Dill', 31.5108299255371, 0.549967732236582, -85.6536102294922, -1.49493751472453, 218, 2, 'PPL', 'P'),
(46306, 'Dill', 39.264720916748, 0.68529865987394, -77.0138931274414, -1.34414600485289, 218, 25, 'PPL', 'P'),
(86311, 'Dill', 35.5563888549805, 0.620576055638826, -85.3583297729492, -1.48978389854107, 218, 50, 'PPL', 'P'),
(75658, 'Dill City', 35.276668548584, 0.61569401530752, -99.1347198486328, -1.73022726440082, 218, 42, 'PPL', 'P'),
(8520, 'Dill Place (historical)', 35.1097183227539, 0.612780184179837, -94.289436340332, -1.64566111398839, 218, 4, 'PPL', 'P'),
(2042, 'Dillard', 31.5174999237061, 0.550084145665732, -85.6949996948242, -1.49565989717022, 218, 2, 'PPL', 'P'),
(20584, 'Dillard', 34.9700012207031, 0.610341660727706, -83.3872222900391, -1.45538158305359, 218, 13, 'PPL', 'P'),
(54438, 'Dillard', 37.7366714477539, 0.658629165506641, -91.2041702270508, -1.59181306201142, 218, 29, 'PPL', 'P'),
(64214, 'Dillard', 36.4022216796875, 0.635338623351408, -80.0938873291016, -1.39790204461419, 218, 33, 'PPL', 'P'),
(75660, 'Dillard', 34.1872215270996, 0.596679577756572, -97.4044418334961, -1.70002821606181, 218, 42, 'PPL', 'P'),
(181149, 'Dillard', 38.4013900756836, 0.670230694163353, -121.255828857422, -2.11631345079677, 218, 6, 'PPL', 'P'),
(200700, 'Dillard', 43.1030616760254, 0.752290343936828, -123.426666259766, -2.1542017109931, 218, 43, 'PPL', 'P'),
(101417, 'Dillard Court', 37.3430595397949, 0.6517593417377, -79.9636077880859, -1.39562823767548, 218, 53, 'PPL', 'P'),
(80681, 'Dillard Crossroads', 34.8205604553223, 0.607733427335109, -82.0980606079102, -1.43288146710989, 218, 48, 'PPL', 'P'),
(2044, 'Dillburg', 33.1936111450195, 0.579337805107276, -88.1013870239258, -1.53765927914131, 218, 2, 'PPL', 'P'),
(108862, 'Dille', 38.4888916015625, 0.671757883890459, -80.8258285522461, -1.41067682888914, 218, 58, 'PPL', 'P'),
(8522, 'Dillen', 35.7080612182617, 0.623223237762365, -93.188606262207, -1.62644800462012, 218, 4, 'PPL', 'P'),
(148299, 'Dillen', 43.8880615234375, 0.765991175901823, -75.9491729736328, -1.32556313255659, 218, 40, 'PPL', 'P'),
(141660, 'Diller', 40.1094398498535, 0.700041786510564, -96.9347229003906, -1.69183007412016, 218, 35, 'PPL', 'P'),
(72317, 'Dilles Bottom', 39.9225006103516, 0.696779081280081, -80.7819366455078, -1.40991077060157, 218, 41, 'PPL', 'P'),
(112583, 'Dilley', 28.6672191619873, 0.500337361767488, -99.170280456543, -1.73084791409286, 218, 51, 'PPL', 'P'),
(200701, 'Dilley', 45.4908294677734, 0.793964753675906, -123.122222900391, -2.14888817198618, 218, 43, 'PPL', 'P'),
(108864, 'Dilleys Mill', 38.2688903808594, 0.667918138230783, -79.9627838134766, -1.39561385660559, 218, 58, 'PPL', 'P'),
(54439, 'Dillia', 36.6208305358887, 0.639154067666137, -92.6091690063477, -1.61633491669665, 218, 29, 'PPL', 'P'),
(78135, 'Dilliner', 39.7516708374023, 0.693797539281682, -79.9252777099609, -1.39495925160965, 218, 45, 'PPL', 'P'),
(160797, 'Dillingerville', 40.4777793884277, 0.706470524223961, -75.4852828979492, -1.31746672336858, 218, 45, 'PPL', 'P'),
(64215, 'Dillingham', 35.7536087036133, 0.624018191347753, -82.4069366455078, -1.43827237094648, 218, 33, 'PPL', 'P'),
(211787, 'Dillingham', 59.0397186279297, 1.0304374795084, -158.457504272461, -2.76560517404743, 218, 1, 'PPL', 'P'),
(64216, 'Dillion Ridge', 35.9308280944824, 0.627111253216799, -76.1819381713867, -1.32962565164145, 218, 33, 'PPL', 'P'),
(72318, 'Dillionvale', 39.2211112976074, 0.684537528434395, -84.4008331298828, -1.47307242954277, 218, 41, 'PPL', 'P'),
(54440, 'Dillman', 36.1847190856934, 0.631542486954581, -90.1047210693359, -1.57262405425102, 218, 29, 'PPL', 'P'),
(122503, 'Dillman', 40.610279083252, 0.708783080156531, -85.4288864135742, -1.49101534422912, 218, 19, 'PPL', 'P'),
(20585, 'Dillon', 30.8994407653809, 0.539296978380853, -83.8925018310547, -1.46420037468728, 218, 13, 'PPL', 'P'),
(32241, 'Dillon', 38.6936111450195, 0.675330913966964, -97.1466674804688, -1.69552920487428, 218, 20, 'PPL', 'P'),
(35581, 'Dillon', 36.9102783203125, 0.644205884516935, -83.2141723632813, -1.45236129206133, 218, 21, 'PPL', 'P'),
(54441, 'Dillon', 37.9719390869141, 0.66273536043338, -91.6977767944336, -1.60042812182172, 218, 29, 'PPL', 'P'),
(59260, 'Dillon', 31.0222206115723, 0.541439890951985, -90.2233276367188, -1.57469412936634, 218, 30, 'PPL', 'P'),
(80678, 'Dillon', 34.416389465332, 0.600679312818735, -79.3713912963867, -1.38529211001072, 218, 48, 'PPL', 'P'),
(101418, 'Dillon', 37.5394401550293, 0.655186830060632, -79.6380615234375, -1.3899463834898, 218, 53, 'PPL', 'P'),
(108863, 'Dillon', 37.7702789306641, 0.659215726736731, -80.9508285522461, -1.41285849045413, 218, 58, 'PPL', 'P'),
(115281, 'Dillon', 41.9769401550293, 0.73263581561788, -92.8238906860352, -1.62008251698261, 218, 16, 'PPL', 'P'),
(119375, 'Dillon', 40.4766693115234, 0.70645114972703, -89.5380630493164, -1.56273400606885, 218, 18, 'PPL', 'P'),
(186624, 'Dillon', 39.6302795410156, 0.69167886147647, -106.042778015137, -1.85079562432559, 218, 7, 'PPL', 'P'),
(188430, 'Dillon', 36.8655586242676, 0.64342537858046, -104.455833435059, -1.82309821635655, 218, 38, 'PPL', 'P'),
(196356, 'Dillon', 45.2163887023926, 0.789174858718317, -112.636672973633, -1.965880801882, 218, 31, 'PPL', 'P'),
(20586, 'Dillon (historical)', 34.7969398498535, 0.607321169998365, -85.4391708374023, -1.49119484128659, 218, 13, 'PPL', 'P'),
(181150, 'Dillon (historical)', 39.3849983215332, 0.687397896603195, -120.780830383301, -2.1080231634814, 218, 6, 'PPL', 'P'),
(209409, 'Dillon (historical)', 41.1766700744629, 0.718668467806796, -107.091667175293, -1.8691021936588, 218, 59, 'PPL', 'P'),
(181151, 'Dillon Beach', 38.2508316040039, 0.667602953115772, -122.964172363281, -2.14612966972907, 218, 6, 'PPL', 'P'),
(72319, 'Dillon Falls', 39.9727783203125, 0.697656592859262, -82.0561065673828, -1.43214923096817, 218, 41, 'PPL', 'P'),
(46307, 'Dillon Park', 38.8658294677734, 0.678336690731282, -76.9375, -1.34281269325314, 218, 25, 'PPL', 'P'),
(101419, 'Dillon Woods', 37.269718170166, 0.650479293359753, -79.8777770996094, -1.39413020956231, 218, 53, 'PPL', 'P'),
(119377, 'Dillonfield', 41.896671295166, 0.731234859726444, -88.4138870239258, -1.5431134330538, 218, 18, 'PPL', 'P'),
(101420, 'Dillons Fork', 36.6955604553223, 0.640458350810003, -80.0063934326172, -1.39637498804514, 218, 53, 'PPL', 'P'),
(101422, 'Dillons Mill', 37.0761108398438, 0.647100207989633, -80.039436340332, -1.39695169557919, 218, 53, 'PPL', 'P'),
(108867, 'Dillons Run (historical)', 39.2361106872559, 0.68479931716955, -78.5138931274414, -1.3703259436328, 218, 58, 'PPL', 'P'),
(160798, 'Dillontown', 41.8686103820801, 0.730745104401978, -75.2666702270508, -1.31365121247482, 218, 45, 'PPL', 'P'),
(154998, 'Dillonvale', 40.1963882446289, 0.701559322278718, -80.7752838134766, -1.40979465677805, 218, 41, 'PPL', 'P'),
(15787, 'Dills', 30.6230602264404, 0.534473227987906, -83.772216796875, -1.46210100479997, 218, 12, 'PPL', 'P'),
(72321, 'Dills', 39.2433280944824, 0.684925284689111, -83.2169418334961, -1.45240962843511, 218, 41, 'PPL', 'P'),
(46308, 'Dills Acres', 38.2999992370605, 0.668461090198023, -75.1774978637695, -1.31209486113378, 218, 25, 'PPL', 'P'),
(8523, 'Dills Mills', 33.667781829834, 0.587613644773724, -93.204719543457, -1.62672923443123, 218, 4, 'PPL', 'P'),
(29642, 'Dillsboro', 39.0177803039551, 0.68098873312381, -85.0588912963867, -1.4845577112179, 218, 19, 'PPL', 'P'),
(64217, 'Dillsboro', 35.3691711425781, 0.617308490139353, -83.2525024414063, -1.45303027812716, 218, 33, 'PPL', 'P'),
(29643, 'Dillsboro Station', 39.0305595397949, 0.681211772865104, -85.0386123657227, -1.48420377710902, 218, 19, 'PPL', 'P'),
(119378, 'Dillsburg', 40.3163909912109, 0.703653765318011, -88.0794372558594, -1.53727618341851, 218, 18, 'PPL', 'P'),
(160799, 'Dillsburg', 40.1108283996582, 0.700066021276484, -77.0352783203125, -1.34451924687966, 218, 45, 'PPL', 'P'),
(160800, 'Dillsburg Junction', 40.2161102294922, 0.701903535849611, -77.0325012207031, -1.34447077734782, 218, 45, 'PPL', 'P'),
(86312, 'Dillton', 35.8005599975586, 0.624837646015171, -86.3230590820313, -1.50662160137504, 218, 50, 'PPL', 'P'),
(160802, 'Dilltown', 40.4663887023926, 0.706271719248586, -79.0027770996094, -1.37885857860736, 218, 45, 'PPL', 'P'),
(32242, 'Dillwyn', 37.9708290100098, 0.662715985936449, -98.8794403076172, -1.72577179589711, 218, 20, 'PPL', 'P'),
(101423, 'Dillwyn', 37.542781829834, 0.655245153288505, -78.4574966430664, -1.36934163929391, 218, 53, 'PPL', 'P'),
(173817, 'Dilly', 43.642219543457, 0.761700423911542, -90.4400024414063, -1.57847581811425, 218, 57, 'PPL', 'P'),
(145097, 'Dilts Corner', 40.4124984741211, 0.705331157330597, -74.9349975585938, -1.30786243237137, 218, 37, 'PPL', 'P'),
(154999, 'Diltz Corners', 40.0391693115234, 0.698815334249555, -84.2619400024414, -1.47064828716052, 218, 41, 'PPL', 'P'),
(2045, 'Dilworth', 33.8022193908691, 0.589960022852139, -87.0536117553711, -1.51937215088407, 218, 2, 'PPL', 'P'),
(8524, 'Dilworth', 33.9397201538086, 0.592359863889436, -94.2491683959961, -1.64495830577671, 218, 4, 'PPL', 'P'),
(75661, 'Dilworth', 36.9413909912109, 0.644748903063203, -97.227783203125, -1.69694494130977, 218, 42, 'PPL', 'P'),
(93745, 'Dilworth', 33.7024993896484, 0.588219580500745, -94.9800033569336, -1.65771378213376, 218, 51, 'PPL', 'P'),
(135013, 'Dilworth', 46.8766708374023, 0.818152248486278, -96.7030563354492, -1.68778672979515, 218, 28, 'PPL', 'P'),
(207209, 'Dilworth', 47.4655609130859, 0.828430319239276, -122.433891296387, -2.13687451915078, 218, 56, 'PPL', 'P'),
(78134, 'Dilworthtown', 39.899169921875, 0.696371883949407, -75.567497253418, -1.31890163456392, 218, 45, 'PPL', 'P'),
(178094, 'Dimario Place', 33.3777809143066, 0.582552173963974, -110.816390991211, -1.93411088797401, 218, 5, 'PPL', 'P'),
(93746, 'Dimas Number 2 Colonia', 26.2000007629395, 0.45727627733832, -98.015998840332, -1.71070189939474, 218, 51, 'PPL', 'P'),
(93747, 'Dimas Number 3 Colonia', 26.201000213623, 0.45729372104346, -98.0179977416992, -1.71073678680502, 218, 51, 'PPL', 'P'),
(160803, 'Dime', 40.6561088562012, 0.709582960589936, -79.5330581665039, -1.38811372918566, 218, 45, 'PPL', 'P'),
(93748, 'Dime Box', 30.3563899993896, 0.529818954508829, -96.8222198486328, -1.68986652544845, 218, 51, 'PPL', 'P'),
(211789, 'Dime Landing', 65.120002746582, 1.13655845683561, -161.159713745117, -2.81276762642386, 218, 1, 'PPL', 'P'),
(64220, 'Dimmette (historical)', 36.2477798461914, 0.632643104854084, -80.9377822875977, -1.41263079018093, 218, 33, 'PPL', 'P'),
(119379, 'Dimmick', 41.4402809143066, 0.723269344906017, -89.1163864135742, -1.55537436039641, 218, 18, 'PPL', 'P'),
(191382, 'Dimmitt', 34.5508308410645, 0.603025757476176, -102.311393737793, -1.7856706830288, 218, 51, 'PPL', 'P'),
(108865, 'Dimmock', 37.9644393920898, 0.662604466065802, -81.0697174072266, -1.41493349241746, 218, 58, 'PPL', 'P'),
(160804, 'Dimmsville', 40.6058311462402, 0.708705449010755, -77.1363906860352, -1.346283990576, 218, 45, 'PPL', 'P'),
(160806, 'Dimock', 41.7463912963867, 0.728611978947852, -75.8986129760742, -1.32468069412939, 218, 45, 'PPL', 'P'),
(170167, 'Dimock', 43.4741706848145, 0.75876741802401, -97.9852828979492, -1.7101658050673, 218, 49, 'PPL', 'P'),
(139890, 'Dimock (historical)', 48.6500015258789, 0.849102707726852, -97.4458312988281, -1.70075059850749, 218, 34, 'PPL', 'P'),
(143712, 'Dimond', 43.2455596923828, 0.754777403499826, -71.7538909912109, -1.25234164891373, 218, 36, 'PPL', 'P'),
(203732, 'Dimond Oaks', 41.0900001525879, 0.717155792307631, -111.91667175293, -1.95331440996236, 218, 52, 'PPL', 'P'),
(130504, 'Dimondale', 42.6455612182617, 0.744305454619471, -84.6488876342773, -1.47740179736885, 218, 27, 'PPL', 'P'),
(8525, 'Dimple', 35.4683303833008, 0.619039145373741, -90.2505569458008, -1.57516937046286, 218, 4, 'PPL', 'P'),
(35582, 'Dimple', 37.1027793884277, 0.647565661969152, -86.7202835083008, -1.51355447548279, 218, 21, 'PPL', 'P'),
(93750, 'Dimple', 33.714168548584, 0.588423245745108, -95.0713882446289, -1.65930874931061, 218, 51, 'PPL', 'P'),
(203736, 'Dimple Dell Oaks Subdivision Number 2', 40.5566711425781, 0.707847445086559, -111.819442749023, -1.95161744371576, 218, 52, 'PPL', 'P'),
(64222, 'Dinah Landing', 35.4797210693359, 0.619237950349115, -76.9322204589844, -1.34272054787942, 218, 33, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(13662, 'Dinahs Corner', 39.1858291625977, 0.683921739011342, -75.6449966430664, -1.32025425408157, 218, 10, 'PPL', 'P'),
(700, 'Dinan', 31.2172203063965, 0.544843277667052, -90.192497253418, -1.57415603766809, 218, 30, 'PPL', 'P'),
(93751, 'Dinas Colonia', 26.2399997711182, 0.45797439172857, -98.3860015869141, -1.71715966556402, 218, 51, 'PPL', 'P'),
(80680, 'Dinber', 34.7936096191406, 0.607263046507574, -81.2069396972656, -1.41732847318577, 218, 48, 'PPL', 'P'),
(130505, 'Dinca', 44.2788887023926, 0.77281239698087, -85.0541687011719, -1.48447528638216, 218, 27, 'PPL', 'P'),
(191383, 'Dindinger Road Colonia', 31.6049995422363, 0.551611302103325, -106.286003112793, -1.85504070310318, 218, 51, 'PPL', 'P'),
(148300, 'Dineharts', 42.4488906860352, 0.740872906290468, -77.313606262207, -1.34937698586602, 218, 40, 'PPL', 'P'),
(93752, 'Dinero', 28.226110458374, 0.492638562530233, -97.9613876342773, -1.7097487540406, 218, 51, 'PPL', 'P'),
(209410, 'Dines (historical)', 41.7261085510254, 0.728257978259953, -109.171943664551, -1.90540986774818, 218, 59, 'PPL', 'P'),
(93753, 'Ding Dong', 30.9818000793457, 0.540734419579223, -97.770866394043, -1.70642353110353, 218, 51, 'PPL', 'P'),
(93754, 'Dingerville', 31.0736103057861, 0.54233681031761, -95.8463897705078, -1.67283507764517, 218, 51, 'PPL', 'P'),
(108866, 'Dingess', 37.8722190856934, 0.660994918081986, -82.1750030517578, -1.43422436608956, 218, 58, 'PPL', 'P'),
(143713, 'Dingit Corner', 43.2966690063477, 0.755669429306948, -71.690559387207, -1.25123630390329, 218, 36, 'PPL', 'P'),
(194843, 'Dingle', 42.2194404602051, 0.736868244380289, -111.267219543457, -1.94197933057271, 218, 17, 'PPL', 'P'),
(2046, 'Dingler', 33.3311080932617, 0.581737579565546, -85.6308288574219, -1.49453990477379, 218, 2, 'PPL', 'P'),
(20589, 'Dingler Crossroads', 33.5444412231445, 0.585460945085586, -84.9347229003906, -1.48239056388084, 218, 13, 'PPL', 'P'),
(20590, 'Dinglewood', 32.4686088562012, 0.566684128082901, -84.9705581665039, -1.48301600726285, 218, 13, 'PPL', 'P'),
(54443, 'Dingley (historical)', 38.3011093139648, 0.668480464694953, -91.6805572509766, -1.6001275840927, 218, 29, 'PPL', 'P'),
(124641, 'Dingley Dell', 42.1188888549805, 0.735113287800954, -72.2583312988281, -1.26114579316142, 218, 23, 'PPL', 'P'),
(160808, 'Dingmans Ferry', 41.2200012207031, 0.719424738977351, -74.8716735839844, -1.30675722051899, 218, 45, 'PPL', 'P'),
(35583, 'Dingus', 37.9080581665039, 0.661620428043018, -83.1022186279297, -1.45040733076954, 218, 21, 'PPL', 'P'),
(108911, 'Dingy', 38.651668548584, 0.674598877562328, -80.9469375610352, -1.41279057984633, 218, 58, 'PPL', 'P'),
(108868, 'Dink', 38.5686111450195, 0.673149252401971, -81.0597229003906, -1.41475905536606, 218, 58, 'PPL', 'P'),
(181152, 'Dinkey Creek', 37.086109161377, 0.647274711620061, -119.156669616699, -2.07967621052249, 218, 6, 'PPL', 'P'),
(80683, 'Dinkins', 33.952220916748, 0.592578043361741, -80.3869400024414, -1.40301677864574, 218, 48, 'PPL', 'P'),
(93755, 'Dinkins', 30.4213905334473, 0.530953427843689, -96.1766662597656, -1.67859948982465, 218, 51, 'PPL', 'P'),
(80682, 'Dinkins Mill', 34.0405616760254, 0.594119880474842, -80.5347213745117, -1.40559605016148, 218, 48, 'PPL', 'P'),
(199919, 'Dinner Station', 41.0999984741211, 0.717330295938059, -115.865280151367, -2.02223062738699, 218, 39, 'PPL', 'P'),
(194158, 'Dinosaur', 40.2436103820801, 0.702383504057071, -109.013893127441, -1.90265136549107, 218, 7, 'PPL', 'P'),
(115282, 'Dinsdale', 42.2591705322266, 0.737561664949118, -92.5447235107422, -1.61521013061026, 218, 16, 'PPL', 'P'),
(8526, 'Dinsmore', 36.1144409179688, 0.630315901535518, -93.4733276367188, -1.63141733005615, 218, 4, 'PPL', 'P'),
(15788, 'Dinsmore', 30.4058303833008, 0.530681851991528, -81.7447204589844, -1.42671451813165, 218, 12, 'PPL', 'P'),
(59261, 'Dinsmore', 33.0888900756836, 0.577510077651154, -88.3530578613281, -1.54205176388524, 218, 30, 'PPL', 'P'),
(93756, 'Dinsmore', 29.3169403076172, 0.511677134978559, -96.0502777099609, -1.67639359349374, 218, 51, 'PPL', 'P'),
(139120, 'Dinsmore', 40.3411102294922, 0.704085197414604, -93.7447204589844, -1.63615402837097, 218, 29, 'PPL', 'P'),
(160809, 'Dinsmore', 40.3805618286133, 0.704773757714444, -80.4305572509766, -1.40377804324334, 218, 45, 'PPL', 'P'),
(193500, 'Dinsmore', 40.4916687011719, 0.706712938462185, -123.605827331543, -2.15732866158702, 218, 6, 'PPL', 'P'),
(193501, 'Dinsmores', 40.7200012207031, 0.71069809271738, -123.737777709961, -2.15963163013967, 218, 6, 'PPL', 'P'),
(46309, 'Dinterman', 39.6319389343262, 0.691707823353324, -77.2577819824219, -1.34840266838121, 218, 25, 'PPL', 'P'),
(181153, 'Dinuba', 36.5433311462402, 0.637801448148485, -119.386108398438, -2.08368067269559, 218, 6, 'PPL', 'P'),
(101424, 'Dinwiddie', 37.0777816772461, 0.64712936960357, -77.5869369506836, -1.35414750632668, 218, 53, 'PPL', 'P'),
(122505, 'Dinwiddie', 41.2894401550293, 0.720636677010419, -87.3011093139648, -1.52369179817217, 218, 19, 'PPL', 'P'),
(101425, 'Dinwiddie Acres', 37.1005592346191, 0.647526912975291, -77.5255584716797, -1.35307624977819, 218, 53, 'PPL', 'P'),
(101427, 'Dinwiddie Gardens', 37.207218170166, 0.649388462577257, -77.4766693115234, -1.35222297296493, 218, 53, 'PPL', 'P'),
(211791, 'Diomede', 65.7708282470703, 1.14791750467507, -168.899993896484, -2.94786100009198, 218, 1, 'PPL', 'P'),
(26952, 'Diona', 39.3766708374023, 0.687252554586704, -88.1391677856445, -1.53831867782722, 218, 18, 'PPL', 'P'),
(35584, 'Dione', 36.9505615234375, 0.644908959044716, -83.0852813720703, -1.45011171988854, 218, 21, 'PPL', 'P'),
(130506, 'Diorite', 46.5091705322266, 0.811738158158877, -87.8302764892578, -1.53292750767451, 218, 27, 'PPL', 'P'),
(160810, 'Dippel Manor', 40.9836082458496, 0.715298903237573, -76.0219421386719, -1.32683319408044, 218, 45, 'PPL', 'P'),
(155001, 'Dipple', 40.202220916748, 0.701661121611387, -83.3169403076172, -1.4541549310555, 218, 41, 'PPL', 'P'),
(93757, 'Direct', 33.8208312988281, 0.590284861926101, -95.8363876342773, -1.67266050743572, 218, 51, 'PPL', 'P'),
(15789, 'Dirego Park', 30.1916694641113, 0.526944038822575, -85.6394424438477, -1.49469024021732, 218, 12, 'PPL', 'P'),
(93758, 'Dirgin', 32.2569389343262, 0.562989791018743, -94.5886077880859, -1.65088264077965, 218, 51, 'PPL', 'P'),
(193502, 'Dirigo', 41.1494407653809, 0.718193226710271, -122.309440612793, -2.13470244496571, 218, 6, 'PPL', 'P'),
(127257, 'Dirigo Corner', 44.4091682434082, 0.77508620391958, -69.521110534668, -1.21337227847287, 218, 26, 'PPL', 'P'),
(8527, 'Dirtdauber (historical)', 34.5494384765625, 0.603001456131229, -92.4883270263672, -1.61422582627136, 218, 4, 'PPL', 'P'),
(207211, 'Disautel', 48.3605613708496, 0.844051024034108, -119.236106872559, -2.08106265218599, 218, 56, 'PPL', 'P'),
(86313, 'Disco', 35.785831451416, 0.624580584390951, -84.158332824707, -1.46884000078036, 218, 50, 'PPL', 'P'),
(119381, 'Disco', 40.6202812194824, 0.708957650365986, -91.021110534668, -1.58861806765165, 218, 18, 'PPL', 'P'),
(130507, 'Disco', 42.6838912963867, 0.744974440685299, -83.0344390869141, -1.44922435461332, 218, 27, 'PPL', 'P'),
(173818, 'Disco', 44.2622184753418, 0.772521446631779, -91.0088882446289, -1.58840474844834, 218, 57, 'PPL', 'P'),
(46416, 'Discovery', 39.4652786254883, 0.688799052231713, -77.3611068725586, -1.35020602791336, 218, 25, 'PPL', 'P'),
(211792, 'Discovery', 62.4524993896484, 1.09000174044911, -157.933883666992, -2.75646627045071, 218, 1, 'PPL', 'P'),
(181154, 'Discovery Bay', 37.9086112976074, 0.661630082001969, -121.599166870117, -2.12230582956555, 218, 6, 'PPL', 'P'),
(207210, 'Discovery Bay', 47.9902801513672, 0.83758839759584, -122.890556335449, -2.14484482766117, 218, 56, 'PPL', 'P'),
(207212, 'Discovery Junction', 47.9938888549805, 0.837651381355621, -122.873329162598, -2.1445441567741, 218, 56, 'PPL', 'P'),
(148301, 'Dishaw', 44.8386116027832, 0.782581404491499, -75.0405578613281, -1.30970480721349, 218, 40, 'PPL', 'P'),
(207213, 'Dishman', 47.6569404602051, 0.83177052245748, -117.282218933105, -2.04696087442752, 218, 56, 'PPL', 'P'),
(35585, 'Dishman Springs', 36.8683280944824, 0.643473714954245, -83.9644393920898, -1.46545592198319, 218, 21, 'PPL', 'P'),
(122504, 'Disko', 41.0022201538086, 0.715623742311536, -85.9444427490234, -1.50001349976223, 218, 19, 'PPL', 'P'),
(15790, 'Dismal Key', 25.8902797698975, 0.451870626247191, -81.557502746582, -1.42344695263217, 218, 12, 'PPL', 'P'),
(75664, 'Disney', 36.4811096191406, 0.636715477634978, -95.0147171020508, -1.65831965128175, 218, 42, 'PPL', 'P'),
(86314, 'Disney', 36.2486114501953, 0.632657619082025, -84.17138671875, -1.46906783421161, 218, 50, 'PPL', 'P'),
(32243, 'Dispatch', 39.5963897705078, 0.691087373398363, -98.5047225952148, -1.71923173805015, 218, 20, 'PPL', 'P'),
(101428, 'Dispatch (historical)', 37.5227813720703, 0.654896079448622, -77.1833267211914, -1.34710317892731, 218, 53, 'PPL', 'P'),
(35587, 'Disputanta', 37.4883308410645, 0.65429480425351, -84.2574996948242, -1.4705707891728, 218, 21, 'PPL', 'P'),
(101429, 'Disputanta', 37.1241683959961, 0.647938970574954, -77.2261123657227, -1.34784992929697, 218, 53, 'PPL', 'P'),
(207214, 'Disque', 48.1391716003418, 0.840187043608512, -123.769172668457, -2.16017957553395, 218, 56, 'PPL', 'P'),
(54445, 'Dissen', 38.5597190856934, 0.672994056689447, -91.2758331298828, -1.59306381561738, 218, 29, 'PPL', 'P'),
(200702, 'Disston', 43.6983299255371, 0.762679734823391, -122.768890380859, -2.14272135616599, 218, 43, 'PPL', 'P'),
(59262, 'Distall', 33.8583297729492, 0.590939333763988, -90.1813888549805, -1.57396215954073, 218, 30, 'PPL', 'P'),
(160811, 'Distant', 40.9694404602051, 0.71505162873036, -79.3569412231445, -1.38503990865549, 218, 45, 'PPL', 'P'),
(46312, 'Distant View', 39.6611099243164, 0.69221695317472, -77.3916702270508, -1.3507394590797, 218, 25, 'PPL', 'P'),
(46611, 'District Heights', 38.8574981689453, 0.678191282135764, -76.8897171020508, -1.34197872435778, 218, 25, 'PPL', 'P'),
(20591, 'District Path', 32.6127815246582, 0.569200415838862, -83.3791732788086, -1.45524110130609, 218, 13, 'PPL', 'P'),
(26953, 'Diswood', 37.2313919067383, 0.649810373872953, -89.3227767944336, -1.55897655208685, 218, 18, 'PPL', 'P'),
(181155, 'Ditch Camp Five', 38.7652816772461, 0.676581800730974, -120.547218322754, -2.10394586385249, 218, 6, 'PPL', 'P'),
(148302, 'Ditch Plains', 41.0405616760254, 0.716292928114445, -71.918327331543, -1.25521160446245, 218, 40, 'PPL', 'P'),
(101434, 'Ditchley', 37.7330589294434, 0.658566115167833, -76.3247222900391, -1.33211770463149, 218, 53, 'PPL', 'P'),
(135020, 'Ditter', 45.0138893127441, 0.785640577635673, -93.522216796875, -1.63227060686941, 218, 28, 'PPL', 'P'),
(93759, 'Dittlinger', 29.6808300018311, 0.518028208256667, -98.1788864135742, -1.7135448238584, 218, 51, 'PPL', 'P'),
(54446, 'Dittmer', 38.3355598449707, 0.669081739890066, -90.6880569458008, -1.58280518594034, 218, 29, 'PPL', 'P'),
(86519, 'Ditty', 36.0938911437988, 0.629957240315712, -85.5805587768555, -1.49366252635266, 218, 50, 'PPL', 'P'),
(26954, 'Divernon', 39.565559387207, 0.690549281700113, -89.6572189331055, -1.56481366856409, 218, 18, 'PPL', 'P'),
(20592, 'Divide', 33.9724998474121, 0.592931977470613, -84.9622192382813, -1.48287046550928, 218, 13, 'PPL', 'P'),
(26956, 'Divide', 38.4469413757324, 0.671025714327769, -88.829719543457, -1.55037107965648, 218, 18, 'PPL', 'P'),
(35586, 'Divide', 36.9358291625977, 0.644651830841469, -83.2127838134766, -1.45233705729541, 218, 21, 'PPL', 'P'),
(75666, 'Divide', 34.475830078125, 0.601716747221375, -95.3091735839844, -1.66345888639533, 218, 42, 'PPL', 'P'),
(93760, 'Divide', 33.0487098693848, 0.576808800757109, -95.7126998901367, -1.6705017490561, 218, 51, 'PPL', 'P'),
(108908, 'Divide', 38.0666694641113, 0.664388717417128, -80.9663925170898, -1.41313013288532, 218, 58, 'PPL', 'P'),
(139891, 'Divide', 47.769718170166, 0.833738864819158, -99.1244430541992, -1.7300479005014, 218, 34, 'PPL', 'P'),
(160813, 'Divide', 41.2566719055176, 0.720064763166325, -76.4341735839844, -1.3340279900814, 218, 45, 'PPL', 'P'),
(186625, 'Divide', 38.9419403076172, 0.679665075483013, -105.156669616699, -1.83533011524328, 218, 7, 'PPL', 'P'),
(190119, 'Divide', 39.2980613708496, 0.685880560572122, -119.654167175293, -2.08835918094059, 218, 39, 'PPL', 'P'),
(196357, 'Divide', 45.7511100769043, 0.798507507284336, -112.746391296387, -1.96779574786383, 218, 31, 'PPL', 'P'),
(8528, 'Divide (historical)', 35.0894393920898, 0.612426250070965, -92.9686126708984, -1.6226083921185, 218, 4, 'PPL', 'P'),
(190120, 'Divide (historical)', 38.002498626709, 0.663268725020695, -117.256942749023, -2.04651972179295, 218, 39, 'PPL', 'P'),
(192541, 'Dividend', 39.954719543457, 0.697341407744251, -112.060562133789, -1.9558257708703, 218, 52, 'PPL', 'P'),
(70745, 'Dividing Creek', 39.2702789306641, 0.685395665516646, -75.1013870239258, -1.31076647638205, 218, 37, 'PPL', 'P'),
(119382, 'Divine', 41.3858299255371, 0.722318995871022, -88.295280456543, -1.54104335793848, 218, 18, 'PPL', 'P'),
(148303, 'Divine Corners', 41.7902793884277, 0.729377970656386, -74.6661071777344, -1.30316940989844, 218, 40, 'PPL', 'P'),
(46612, 'Divinity Cove', 39.0608291625977, 0.681740077446349, -76.5124969482422, -1.33539499066894, 218, 25, 'PPL', 'P'),
(148304, 'Divinity Hill', 40.9463882446289, 0.714649291668676, -72.2080612182617, -1.26026841474029, 218, 40, 'PPL', 'P'),
(93761, 'Divot', 28.7625007629395, 0.502000339420674, -99.2586135864258, -1.73238961804791, 218, 51, 'PPL', 'P'),
(26957, 'Dix', 38.4416694641113, 0.670933702112107, -88.9375, -1.55225220349246, 218, 18, 'PPL', 'P'),
(148305, 'Dix', 43.1655616760254, 0.753381174719325, -75.4625015258789, -1.31706911341783, 218, 40, 'PPL', 'P'),
(191384, 'Dix', 32.1011085510254, 0.560270037755499, -101.86499786377, -1.77787960525977, 218, 51, 'PPL', 'P'),
(199277, 'Dix', 41.235279083252, 0.719691387981496, -103.485832214355, -1.80616850130692, 218, 35, 'PPL', 'P'),
(148306, 'Dix Hills', 40.8047218322754, 0.712176746333619, -73.336669921875, -1.27996635258501, 218, 40, 'PPL', 'P'),
(20593, 'Dix-Leeson', 33.5430603027344, 0.585436843477721, -84.4599990844727, -1.47410507025544, 218, 13, 'PPL', 'P'),
(130508, 'Dixboro', 42.3122215270996, 0.738487579481111, -83.6561126708984, -1.46007460552653, 218, 27, 'PPL', 'P'),
(127258, 'Dixfield', 44.5338897705078, 0.777263005215583, -70.4563903808594, -1.22969599121646, 218, 26, 'PPL', 'P'),
(127259, 'Dixfield Center', 44.540828704834, 0.777384112466155, -70.3827819824219, -1.2284112823066, 218, 26, 'PPL', 'P'),
(80684, 'Dixiana', 33.9191703796387, 0.59200120266963, -81.059440612793, -1.41475412851805, 218, 48, 'PPL', 'P'),
(101435, 'Dixiana', 37.0272216796875, 0.646246931176372, -82.6697235107422, -1.44285886697582, 218, 53, 'PPL', 'P'),
(2048, 'Dixie', 31.1444396972656, 0.543573016406111, -86.7194366455078, -1.51353969493874, 218, 2, 'PPL', 'P'),
(8533, 'Dixie', 35.0766716003418, 0.612203410066753, -91.3630599975586, -1.59458621165452, 218, 4, 'PPL', 'P'),
(15791, 'Dixie', 28.4347190856934, 0.496279469925021, -82.3027801513672, -1.43645449718639, 218, 12, 'PPL', 'P'),
(20596, 'Dixie', 33.5733299255371, 0.585965148058965, -83.7702789306641, -1.46206718265412, 218, 13, 'PPL', 'P'),
(29644, 'Dixie', 38.1599998474121, 0.666017639897875, -86.2122192382813, -1.50468708115921, 218, 19, 'PPL', 'P'),
(35589, 'Dixie', 37.6797218322754, 0.657635207208796, -87.6858291625977, -1.53040642622859, 218, 21, 'PPL', 'P'),
(40665, 'Dixie', 31.1361103057861, 0.543427641100106, -93.2688903808594, -1.62784922682766, 218, 22, 'PPL', 'P'),
(54447, 'Dixie', 38.7188911437988, 0.675772133180563, -92.0091705322266, -1.6058629678163, 218, 29, 'PPL', 'P'),
(59675, 'Dixie', 31.023889541626, 0.541469019276408, -89.2022171020508, -1.55687238850958, 218, 30, 'PPL', 'P'),
(64225, 'Dixie', 35.6725006103516, 0.622602588070322, -77.9486083984375, -1.36045986390044, 218, 33, 'PPL', 'P'),
(72322, 'Dixie', 39.6519393920898, 0.692056897193207, -82.2497177124023, -1.43552838291732, 218, 41, 'PPL', 'P'),
(86521, 'Dixie', 36.4286117553711, 0.635799217061937, -89.2058334350586, -1.55693550542742, 218, 50, 'PPL', 'P'),
(93762, 'Dixie', 33.7166709899902, 0.588466921586986, -96.9044418334961, -1.69130156980184, 218, 51, 'PPL', 'P'),
(101437, 'Dixie', 37.500560760498, 0.65450825661488, -76.4147186279297, -1.33368843704242, 218, 53, 'PPL', 'P'),
(108910, 'Dixie', 38.2508316040039, 0.667602953115772, -81.1933288574219, -1.41709091921654, 218, 58, 'PPL', 'P'),
(115283, 'Dixie', 43.269718170166, 0.755199048479413, -92.9944381713867, -1.62305913213299, 218, 16, 'PPL', 'P'),
(178095, 'Dixie', 33.3594398498535, 0.582232062000947, -112.756942749023, -1.96797990545321, 218, 5, 'PPL', 'P'),
(190122, 'Dixie', 39.8738899230957, 0.695930664735809, -118.014999389648, -2.05975030608846, 218, 39, 'PPL', 'P'),
(193503, 'Dixie', 40.9441719055176, 0.714610609253842, -121.170829772949, -2.11482993691154, 218, 6, 'PPL', 'P'),
(194845, 'Dixie', 45.5541687011719, 0.795070231844398, -115.46028137207, -2.0151620652217, 218, 17, 'PPL', 'P'),
(207215, 'Dixie', 46.1402816772461, 0.805299833065556, -118.154167175293, -2.06217924216067, 218, 56, 'PPL', 'P'),
(8534, 'Dixie (historical)', 35.0291709899902, 0.611374368019411, -92.5972213745117, -1.6161263911833, 218, 4, 'PPL', 'P'),
(40666, 'Dixie (historical)', 31.9058303833008, 0.556861790771443, -91.4180603027344, -1.59554614806944, 218, 22, 'PPL', 'P'),
(59676, 'Dixie (historical)', 33.2338905334473, 0.58004081305603, -88.6399993896484, -1.54705983831513, 218, 30, 'PPL', 'P'),
(86522, 'Dixie (historical)', 35.3880615234375, 0.617638189482305, -86.0686111450195, -1.50218064709928, 218, 50, 'PPL', 'P'),
(200703, 'Dixie (historical)', 45.7305603027344, 0.79814884606453, -123.004173278809, -2.14682781740884, 218, 43, 'PPL', 'P'),
(20597, 'Dixie Acres', 33.5716705322266, 0.585936186182111, -83.7697219848633, -1.46205746211614, 218, 13, 'PPL', 'P'),
(127261, 'Dixie Corner', 44.9497184753418, 0.78452058523924, -69.3230590820313, -1.209915628536, 218, 26, 'PPL', 'P'),
(80686, 'Dixie Crossing', 33.9280586242676, 0.592156331803127, -80.5558319091797, -1.4059644984983, 218, 48, 'PPL', 'P'),
(207216, 'Dixie Crossing', 46.0922203063965, 0.804461003901208, -118.470832824707, -2.06770610037091, 218, 56, 'PPL', 'P'),
(64226, 'Dixie Crossroads', 35.6908302307129, 0.622922500296267, -78.2191696166992, -1.36518204798731, 218, 33, 'PPL', 'P'),
(40668, 'Dixie Gardens', 32.4511108398438, 0.566378730084896, -93.6991729736328, -1.63535907478558, 218, 22, 'PPL', 'P'),
(101438, 'Dixie Heights', 37.2911109924316, 0.650852668544582, -80.0858306884766, -1.39776142970863, 218, 53, 'PPL', 'P'),
(101439, 'Dixie Hill', 38.8516693115234, 0.678089549382123, -77.3625030517578, -1.35023039583734, 218, 53, 'PPL', 'P'),
(20599, 'Dixie Hills', 34.3622207641602, 0.599733890631757, -83.7919387817383, -1.46244521837086, 218, 13, 'PPL', 'P'),
(577, 'Dixie Inn', 32.5950012207031, 0.56889009099284, -93.3383331298828, -1.62906123143976, 218, 22, 'PPL', 'P'),
(40669, 'Dixie Landing', 32.0533294677734, 0.559436135439168, -91.5805587768555, -1.59838228147232, 218, 22, 'PPL', 'P'),
(86524, 'Dixie Lee', 35.0433311462402, 0.611621509368571, -85.6861114501953, -1.49550476803672, 218, 50, 'PPL', 'P'),
(86525, 'Dixie Lee Junction', 35.8605613708496, 0.625884867534817, -84.225830078125, -1.47001805008855, 218, 50, 'PPL', 'P'),
(86526, 'Dixie Mills', 35.6147193908691, 0.621594115544536, -88.1827774047852, -1.53907980926676, 218, 50, 'PPL', 'P'),
(75665, 'Dixie Park', 34.4872207641602, 0.60191555219675, -97.9491729736328, -1.70953556799534, 218, 42, 'PPL', 'P'),
(59677, 'Dixie Pine', 31.2947196960449, 0.546195897184703, -89.2699966430664, -1.55805536466579, 218, 30, 'PPL', 'P'),
(35590, 'Dixie Plantation', 38.0519409179688, 0.664131655792908, -84.440559387207, -1.47376578353257, 218, 21, 'PPL', 'P'),
(40670, 'Dixie Plantation', 29.8372192382813, 0.520757715347402, -90.8919372558594, -1.58636356863085, 218, 22, 'PPL', 'P'),
(15792, 'Dixie Ranch Acres', 27.3233299255371, 0.47688206980932, -80.9077835083008, -1.41210721271062, 218, 12, 'PPL', 'P'),
(2049, 'Dixie Springs', 33.7136116027832, 0.58841352520713, -87.3708267211914, -1.52490859647423, 218, 2, 'PPL', 'P'),
(20600, 'Dixie Union', 31.3391704559326, 0.546971709299757, -82.4633331298828, -1.43925667528538, 218, 13, 'PPL', 'P'),
(190124, 'Dixie Valley', 39.6877784729004, 0.692682407154239, -118.079719543457, -2.06087988586482, 218, 39, 'PPL', 'P'),
(20601, 'Dixie Village', 33.5638885498047, 0.585800364966517, -83.7777786254883, -1.4621980770217, 218, 13, 'PPL', 'P'),
(86527, 'Dixieland', 35.7894401550293, 0.624643568150731, -86.4194412231445, -1.50830378707759, 218, 50, 'PPL', 'P'),
(181157, 'Dixieland', 32.790828704834, 0.572307925356821, -115.769439697266, -2.02055789590631, 218, 6, 'PPL', 'P'),
(15793, 'Dixietown', 29.7077808380127, 0.518498589084202, -82.9844436645508, -1.44835176988216, 218, 12, 'PPL', 'P'),
(178096, 'Dixileta Verde', 33.7555618286133, 0.58914569476982, -111.91667175293, -1.95331440996236, 218, 5, 'PPL', 'P'),
(127262, 'Dixmont', 44.6802787780762, 0.779817975386378, -69.163330078125, -1.20712783150691, 218, 26, 'PPL', 'P'),
(160814, 'Dixmont', 40.5158309936523, 0.707134650020799, -80.1152801513672, -1.39827541979902, 218, 45, 'PPL', 'P'),
(127263, 'Dixmont Center', 44.6894416809082, 0.779977898209837, -69.1208267211914, -1.20638600798527, 218, 26, 'PPL', 'P'),
(119384, 'Dixmoor', 41.6316719055176, 0.726609747861303, -87.6608276367188, -1.52997006728398, 218, 18, 'PPL', 'P'),
(828, 'Dixon', 35.1594390869141, 0.613647975221039, -96.5213928222656, -1.68461610335936, 218, 42, 'PPL', 'P'),
(15794, 'Dixon', 30.7394409179688, 0.536504454240823, -86.1324996948242, -1.50329571264769, 218, 12, 'PPL', 'P'),
(29645, 'Dixon', 39.0708312988281, 0.681914647655803, -87.033332824707, -1.51901821677519, 218, 19, 'PPL', 'P'),
(35591, 'Dixon', 37.5177803039551, 0.654808794343895, -87.6902770996094, -1.53048405737437, 218, 21, 'PPL', 'P'),
(54448, 'Dixon', 37.9916687011719, 0.663079707162327, -92.0936126708984, -1.60733676116355, 218, 29, 'PPL', 'P'),
(59679, 'Dixon', 32.6652793884277, 0.570116676411904, -89.2205581665039, -1.55719250047261, 218, 30, 'PPL', 'P'),
(64228, 'Dixon', 34.5858306884766, 0.603636620051213, -77.4802780151367, -1.35228595672471, 218, 33, 'PPL', 'P'),
(93763, 'Dixon', 33.0691719055176, 0.577165930659289, -96.0266723632813, -1.6759816024731, 218, 51, 'PPL', 'P'),
(115284, 'Dixon', 41.7427787780762, 0.728548928609045, -90.7822189331055, -1.58444862264902, 218, 16, 'PPL', 'P'),
(119385, 'Dixon', 41.8388900756836, 0.730226387200658, -89.4794387817383, -1.56171081957804, 218, 18, 'PPL', 'P'),
(130509, 'Dixon', 46.3325004577637, 0.808654683669756, -86.8530578613281, -1.51587182510532, 218, 27, 'PPL', 'P'),
(141665, 'Dixon', 42.4161109924316, 0.740300792709292, -96.996940612793, -1.69291597805464, 218, 35, 'PPL', 'P'),
(155002, 'Dixon', 40.9505615234375, 0.714722129124489, -84.804443359375, -1.48011675694213, 218, 41, 'PPL', 'P'),
(160815, 'Dixon', 41.5577812194824, 0.725320112103433, -75.898063659668, -1.32467110674946, 218, 45, 'PPL', 'P'),
(170169, 'Dixon', 43.3833312988281, 0.757181971648059, -99.4727783203125, -1.73612749779589, 218, 49, 'PPL', 'P'),
(181156, 'Dixon', 38.4455604553223, 0.671001612719904, -121.822219848633, -2.12619883844703, 218, 6, 'PPL', 'P'),
(188431, 'Dixon', 36.1986083984375, 0.631784901192806, -105.888061523438, -1.84809531213831, 218, 38, 'PPL', 'P'),
(196358, 'Dixon', 47.3166694641113, 0.825831673226604, -114.313056945801, -1.995139221724, 218, 31, 'PPL', 'P'),
(209411, 'Dixon', 41.0333290100098, 0.716166694278776, -107.535003662109, -1.87683987504797, 218, 59, 'PPL', 'P'),
(86529, 'Dixon (historical)', 36.2983283996582, 0.6335253435442, -86.2300033569336, -1.50499747258425, 218, 50, 'PPL', 'P'),
(2050, 'Dixon Corner', 30.451940536499, 0.531486625983436, -88.241943359375, -1.54011244997944, 218, 2, 'PPL', 'P'),
(127265, 'Dixon Corner', 44.711669921875, 0.780365854201635, -69.4938888549805, -1.2128971705344, 218, 26, 'PPL', 'P'),
(160816, 'Dixon Corner', 41.2761116027832, 0.720404049889201, -78.9705581665039, -1.37829625214319, 218, 45, 'PPL', 'P'),
(20603, 'Dixon Crossroads', 34.6252784729004, 0.604325113772026, -83.4974975585938, -1.45730624957339, 218, 13, 'PPL', 'P'),
(80687, 'Dixon Crossroads', 34.6091690063477, 0.604043950539941, -83.147216796875, -1.451192696975, 218, 48, 'PPL', 'P'),
(46613, 'Dixon Estates', 38.9258308410645, 0.679383912250928, -76.6061096191406, -1.3370288399977, 218, 25, 'PPL', 'P'),
(46614, 'Dixon Hill', 39.3697204589844, 0.687131247599051, -76.6636123657227, -1.3380324522545, 218, 25, 'PPL', 'P'),
(64229, 'Dixon Landing', 33.9458312988281, 0.592466523491094, -78.2233276367188, -1.36525461912702, 218, 33, 'PPL', 'P'),
(112201, 'Dixon Shop', 34.1399993896484, 0.59585539597822, -85.7591705322266, -1.49677988956665, 218, 2, 'PPL', 'P'),
(26959, 'Dixon Springs', 37.3844413757324, 0.652481591025329, -88.6686096191406, -1.54755918101952, 218, 18, 'PPL', 'P'),
(86530, 'Dixon Springs', 36.3588905334473, 0.634582352180852, -86.0524978637695, -1.50189941728817, 218, 50, 'PPL', 'P'),
(35592, 'Dixon Town', 37.9372215270996, 0.662129424706359, -84.6586074829102, -1.47757144073029, 218, 21, 'PPL', 'P'),
(101440, 'Dixondale (historical)', 37.4319381713867, 0.653310566493644, -76.4622192382813, -1.33451747908976, 218, 53, 'PPL', 'P'),
(64230, 'Dixons Crossroads', 35.5002784729004, 0.619596744726976, -77.4136123657227, -1.35112242164446, 218, 33, 'PPL', 'P'),
(2052, 'Dixons Mills', 32.0580596923828, 0.559518693432961, -87.7874984741211, -1.53218089046291, 218, 2, 'PPL', 'P'),
(2053, 'Dixonville', 31.000280380249, 0.541056961676745, -87.0361099243164, -1.51906668630703, 218, 2, 'PPL', 'P'),
(86531, 'Dixonville', 35.4230613708496, 0.618249052057342, -89.9458312988281, -1.56985090460792, 218, 50, 'PPL', 'P'),
(160818, 'Dixonville', 40.7163887023926, 0.710635042378572, -79.0072174072266, -1.37893607659508, 218, 45, 'PPL', 'P'),
(200704, 'Dixonville', 43.2077789306641, 0.754118004813923, -123.23999786377, -2.15094373287356, 218, 43, 'PPL', 'P'),
(35593, 'Dixville', 37.7058296203613, 0.658090874071309, -84.9480590820313, -1.48262332416012, 218, 21, 'PPL', 'P'),
(143715, 'Dixville Notch', 44.8708305358887, 0.783143730955669, -71.3063888549805, -1.2445312632268, 218, 36, 'PPL', 'P'),
(35594, 'Dizney', 36.8527793884277, 0.643202338839166, -83.1166687011719, -1.45065953212477, 218, 21, 'PPL', 'P'),
(155004, 'Dlworth', 41.4472198486328, 0.723390452156588, -80.6661071777344, -1.4078891650181, 218, 41, 'PPL', 'P'),
(35595, 'Do Stop', 37.4319381713867, 0.653310566493644, -86.5505599975586, -1.51059224140229, 218, 21, 'PPL', 'P'),
(141667, 'Do-Mar Mobile Home Park', 40.7719383239746, 0.711604566173415, -98.3691711425781, -1.71686591889578, 218, 35, 'PPL', 'P'),
(108914, 'Doak', 39.3202781677246, 0.686268316826838, -80.6336135864258, -1.40732204486396, 218, 58, 'PPL', 'P'),
(93764, 'Doak Springs', 30.359260559082, 0.529869055226836, -96.9692611694336, -1.6924328806329, 218, 51, 'PPL', 'P'),
(196359, 'Doak Trailer Court', 46.5458297729492, 0.812377982610769, -110.894439697266, -1.93547309487159, 218, 31, 'PPL', 'P'),
(86532, 'Doaks Crossroads', 36.1088905334473, 0.630219029050866, -86.2436065673828, -1.50523489339543, 218, 50, 'PPL', 'P'),
(108912, 'Doane', 37.9874992370605, 0.663006936285541, -82.3733291625977, -1.43768580971639, 218, 58, 'PPL', 'P'),
(160817, 'Doane', 41.5727806091309, 0.725581900838587, -77.3352813720703, -1.34975528789886, 218, 45, 'PPL', 'P'),
(113154, 'Doaneville', 41.5716705322266, 0.725562526341657, -71.8755569458008, -1.2544651204089, 218, 8, 'PPL', 'P'),
(29646, 'Doans', 38.9191703796387, 0.679267665269346, -86.8494415283203, -1.51580870818749, 218, 19, 'PPL', 'P'),
(93766, 'Doans', 34.3436088562012, 0.599409051557794, -99.2552795410156, -1.73233142797809, 218, 51, 'PPL', 'P'),
(155005, 'Doans Corners', 41.5041694641113, 0.724384410454433, -81.6125030517578, -1.42440688904709, 218, 41, 'PPL', 'P'),
(72324, 'Doanville', 39.435001373291, 0.688270614492414, -82.1913909912109, -1.43451038959064, 218, 41, 'PPL', 'P'),
(64232, 'Dobbersville', 35.2261085510254, 0.614811576880322, -78.245002746582, -1.36563292115986, 218, 33, 'PPL', 'P'),
(93765, 'Dobbin', 30.3652801513672, 0.52997411693184, -95.7758331298828, -1.67160363195712, 218, 51, 'PPL', 'P'),
(108913, 'Dobbin', 39.2386093139648, 0.6848429264324, -79.414436340332, -1.38604338775423, 218, 58, 'PPL', 'P'),
(35596, 'Dobbins', 38.1569404602051, 0.665964243518019, -82.9297180175781, -1.4473966271572, 218, 21, 'PPL', 'P'),
(181158, 'Dobbins', 39.3716697692871, 0.687165269481976, -121.205001831055, -2.11542635183766, 218, 6, 'PPL', 'P'),
(64231, 'Dobbins (historical)', 35.7158317565918, 0.623358859240877, -80.5822219848633, -1.40642509220882, 218, 33, 'PPL', 'P'),
(13072, 'Dobbins Addition (historical)', 38.9263916015625, 0.679393699367934, -77.0111083984375, -1.34409740216299, 218, 9, 'PPL', 'P'),
(148308, 'Dobbins Corner', 42.9061088562012, 0.748852868759809, -76.9633331298828, -1.34326356642569, 218, 40, 'PPL', 'P'),
(80688, 'Dobbins Estates', 34.526668548584, 0.602604045917562, -82.6166687011719, -1.4419328858648, 218, 48, 'PPL', 'P'),
(112453, 'Dobbins Heights', 34.9047203063965, 0.609202293834343, -79.692497253418, -1.39089646620868, 218, 33, 'PPL', 'P'),
(13664, 'Dobbinsville', 39.6563911437988, 0.69213459491801, -75.5794372558594, -1.31911002691921, 218, 10, 'PPL', 'P'),
(148309, 'Dobbs Ferry', 41.0144386291504, 0.715836994935824, -73.8730621337891, -1.28932816276497, 218, 40, 'PPL', 'P'),
(8539, 'Dobbs Landing', 34.7552795410156, 0.606594060441746, -91.3058319091797, -1.59358739308769, 218, 4, 'PPL', 'P'),
(72325, 'Dobbston', 38.5536117553711, 0.672887463666816, -82.4261093139648, -1.43860699713745, 218, 41, 'PPL', 'P'),
(8536, 'Dobell', 35.6827812194824, 0.622782018548766, -90.5119400024414, -1.57973136541017, 218, 4, 'PPL', 'P'),
(173820, 'Dobie', 46.526668548584, 0.812043556156882, -91.804443359375, -1.60228980458174, 218, 57, 'PPL', 'P'),
(181159, 'Doble', 34.2986106872559, 0.59862368535233, -116.820831298828, -2.03890814108139, 218, 6, 'PPL', 'P'),
(20605, 'Doboy (historical)', 31.3983306884766, 0.548004250143894, -81.3280563354492, -1.41944235730102, 218, 13, 'PPL', 'P'),
(108915, 'Dobra', 37.934440612793, 0.662080888595493, -81.8244400024414, -1.42810588664316, 218, 58, 'PPL', 'P'),
(46615, 'Dobridge', 39.1980590820313, 0.684135191372711, -77.0208282470703, -1.34426704552443, 218, 25, 'PPL', 'P'),
(93767, 'Dobrowolski', 28.8924999237061, 0.504269252800881, -98.6425018310547, -1.72163643935644, 218, 51, 'PPL', 'P'),
(40671, 'Dobs Crossing', 31.7927799224854, 0.554888688009317, -93.4927825927734, -1.63175688309514, 218, 22, 'PPL', 'P'),
(35597, 'Dobson', 37.7419395446777, 0.658721111143276, -82.8850021362305, -1.44661618779976, 218, 21, 'PPL', 'P'),
(64233, 'Dobson', 36.3955612182617, 0.635222376369826, -80.7227783203125, -1.40887826304695, 218, 33, 'PPL', 'P'),
(178097, 'Dobson', 32.473331451416, 0.566766552918639, -111.29167175293, -1.94240610213739, 218, 5, 'PPL', 'P'),
(59681, 'Dobson (historical)', 32.1624984741211, 0.561341494041065, -89.897216796875, -1.56900242148462, 218, 30, 'PPL', 'P'),
(209948, 'Dobson Landing', 58.4905586242676, 1.02085282932423, -134.784164428711, -2.35242744883043, 218, 1, 'PPL', 'P'),
(178098, 'Dobson Ranch', 33.3705596923828, 0.582426139865386, -111.873611450195, -1.95256286590274, 218, 5, 'PPL', 'P'),
(178099, 'Dobson Shores', 33.3769416809082, 0.582537526577979, -111.879997253418, -1.95267431919436, 218, 5, 'PPL', 'P'),
(101441, 'Dobyns', 36.6380615234375, 0.639454805132234, -80.3369369506836, -1.40214406075652, 218, 53, 'PPL', 'P'),
(8538, 'Dobyville', 34.0119400024414, 0.593620338033371, -93.2538909912109, -1.62758743809251, 218, 4, 'PPL', 'P'),
(93768, 'Doc Brown', 30.0844402313232, 0.525072535656035, -93.76611328125, -1.6365274035558, 218, 51, 'PPL', 'P'),
(181160, 'Docas (historical)', 36.083610534668, 0.629777809837268, -120.946937561035, -2.11092228064406, 218, 6, 'PPL', 'P'),
(2056, 'Docena', 33.559440612793, 0.585722733820741, -86.9311065673828, -1.5172340320029, 218, 2, 'PPL', 'P'),
(86534, 'Dochester', 35.9716682434082, 0.627824048282558, -84.8666687011719, -1.48120279403467, 218, 50, 'PPL', 'P'),
(160819, 'Dock Hollow', 40.6986083984375, 0.710324717532551, -79.6694412231445, -1.39049406256797, 218, 45, 'PPL', 'P'),
(20606, 'Dock Junction', 31.202220916748, 0.544581488931897, -81.5169372558594, -1.42273895125638, 218, 13, 'PPL', 'P'),
(160821, 'Dock Junction', 42.1058311462402, 0.73488538779067, -80.1188888549805, -1.3983384035588, 218, 45, 'PPL', 'P'),
(124644, 'Dock Square', 42.3519401550293, 0.739180800312859, -71.0577774047852, -1.24019217486273, 218, 23, 'PPL', 'P'),
(93769, 'Dockberry Estates Colonia', 25.886999130249, 0.451813368283754, -97.4219970703125, -1.70033461274522, 218, 51, 'PPL', 'P'),
(912, 'Dockery', 35.1172218322754, 0.612911145126442, -84.8899993896484, -1.48160999136534, 218, 50, 'PPL', 'P'),
(54449, 'Dockery', 39.3611106872559, 0.686980978734543, -93.9883270263672, -1.64040576505128, 218, 29, 'PPL', 'P'),
(59682, 'Dockery', 33.7286109924316, 0.588675313942284, -90.6166687011719, -1.58155922602434, 218, 30, 'PPL', 'P'),
(64235, 'Dockery', 36.3072204589844, 0.633680539256724, -81.081672668457, -1.41514215108887, 218, 33, 'PPL', 'P'),
(101442, 'Dockery', 36.6797218322754, 0.640181914688853, -78.1777801513672, -1.36445966554163, 218, 53, 'PPL', 'P'),
(143717, 'Dockham Shore', 43.5947189331055, 0.7608713818642, -71.4194412231445, -1.24650439927844, 218, 36, 'PPL', 'P'),
(207217, 'Dockton', 47.371940612793, 0.826796336752458, -122.458061218262, -2.13729636386745, 218, 56, 'PPL', 'P'),
(2057, 'Docray', 33.2236099243164, 0.579861382577585, -87.1655578613281, -1.5213259790178, 218, 2, 'PPL', 'P'),
(15796, 'Doctor Phillips', 28.4491691589355, 0.496531671280251, -81.4925003051758, -1.4223124460078, 218, 12, 'PPL', 'P'),
(80689, 'Doctor Sapps Crossroads', 34.7986106872559, 0.607350331612302, -80.6336135864258, -1.40732204486396, 218, 48, 'PPL', 'P'),
(86535, 'Doctors (historical)', 36.4855613708496, 0.636793175359782, -84.4375, -1.47371238715271, 218, 50, 'PPL', 'P'),
(15797, 'Doctors Inlet', 30.1000003814697, 0.525344111508196, -81.7763900756836, -1.42726725721589, 218, 12, 'PPL', 'P'),
(20607, 'Doctortown', 31.6533298492432, 0.552454825089094, -81.8294372558594, -1.42819310516886, 218, 13, 'PPL', 'P'),
(29647, 'Dodd', 37.9122200012207, 0.66169306576175, -86.6519393920898, -1.51236164563054, 218, 19, 'PPL', 'P'),
(191385, 'Dodd', 34.3349990844727, 0.599258782693286, -102.478607177734, -1.78858910810936, 218, 51, 'PPL', 'P'),
(194159, 'Dodd', 40.2872200012207, 0.703144635496615, -103.706939697266, -1.8100275548845, 218, 7, 'PPL', 'P'),
(8541, 'Dodd City', 36.327220916748, 0.634029613096606, -92.7927780151367, -1.61953949843634, 218, 4, 'PPL', 'P'),
(93770, 'Dodd City', 33.5752792358398, 0.585999169941891, -96.0747222900391, -1.67682023190037, 218, 51, 'PPL', 'P'),
(93771, 'Dodd Colonia', 28.0310001373291, 0.489233245023376, -97.5039978027344, -1.70176579551503, 218, 51, 'PPL', 'P'),
(80690, 'Dodd Hill', 35.0158309936523, 0.611141541161111, -82.0213928222656, -1.43154336182018, 218, 48, 'PPL', 'P'),
(93772, 'Dodd Number 2 Colonia', 28.0300006866455, 0.489215801318236, -97.5029983520508, -1.70174835180989, 218, 51, 'PPL', 'P'),
(8542, 'Doddridge', 33.0916709899902, 0.577558613762021, -93.9080581665039, -1.63900480915984, 218, 4, 'PPL', 'P'),
(54451, 'Dodds', 36.6019401550293, 0.638824368323185, -89.6738891601563, -1.56510461891318, 218, 29, 'PPL', 'P'),
(59683, 'Dodds', 33.0027809143066, 0.576007189268995, -89.5625, -1.56316051131742, 218, 30, 'PPL', 'P'),
(72326, 'Dodds', 39.4938888549805, 0.689298394936102, -84.1533279418945, -1.4687526490966, 218, 41, 'PPL', 'P'),
(29648, 'Dodds Bridge', 39.1572189331055, 0.683422396306952, -87.5238876342773, -1.52758001336369, 218, 19, 'PPL', 'P'),
(101443, 'Dodds Corner', 38.4469413757324, 0.671025714327769, -77.5913925170898, -1.35422527063051, 218, 53, 'PPL', 'P'),
(101444, 'Doddstown', 38.5944404602051, 0.673600058995494, -77.8141708374023, -1.35811348582202, 218, 53, 'PPL', 'P'),
(59684, 'Doddsville', 33.6575012207031, 0.58743421429528, -90.5247192382813, -1.57995440515146, 218, 30, 'PPL', 'P'),
(86536, 'Doddsville', 36.3422203063965, 0.634291401831761, -87.2291717529297, -1.52243625087626, 218, 50, 'PPL', 'P'),
(119387, 'Doddsville', 40.2783317565918, 0.702989506363118, -90.6516723632813, -1.58217015517841, 218, 18, 'PPL', 'P'),
(108917, 'Doddtown', 38.5744400024414, 0.673250985155612, -81.4199981689453, -1.42104704501585, 218, 58, 'PPL', 'P'),
(75669, 'Dodge', 36.5736083984375, 0.638329885887785, -94.6558303833008, -1.65205589639788, 218, 42, 'PPL', 'P'),
(93773, 'Dodge', 30.7452793121338, 0.536606353442032, -95.3977813720703, -1.66500538404034, 218, 51, 'PPL', 'P'),
(124642, 'Dodge', 42.1619415283203, 0.735864698702519, -71.9333267211914, -1.25547339319761, 218, 23, 'PPL', 'P'),
(141668, 'Dodge', 41.7211112976074, 0.728170759734253, -96.8824996948242, -1.69091860723708, 218, 35, 'PPL', 'P'),
(148310, 'Dodge', 42.0011100769043, 0.733057660334549, -79.0908279418945, -1.38039535571439, 218, 40, 'PPL', 'P'),
(173821, 'Dodge', 44.1322212219238, 0.770252566541086, -91.5519409179688, -1.59788280560987, 218, 57, 'PPL', 'P'),
(190126, 'Dodge', 39.6708297729492, 0.692386596536158, -119.311111450195, -2.08237172901981, 218, 39, 'PPL', 'P'),
(198195, 'Dodge', 47.3061103820801, 0.82564738247917, -102.203887939453, -1.78379435288278, 218, 34, 'PPL', 'P'),
(200705, 'Dodge', 45.2150001525879, 0.789150623952397, -122.301109313965, -2.13455703637019, 218, 43, 'PPL', 'P'),
(207218, 'Dodge', 46.5250015258789, 0.812014461121973, -117.820831298828, -2.05636143360134, 218, 56, 'PPL', 'P'),
(135021, 'Dodge Center', 44.0280609130859, 0.768434626201971, -92.8544387817383, -1.62061568183285, 218, 28, 'PPL', 'P'),
(2058, 'Dodge City', 34.0405616760254, 0.594119880474842, -86.8858337402344, -1.51644387210747, 218, 2, 'PPL', 'P'),
(8543, 'Dodge City', 33.0194396972656, 0.576297939881005, -92.9683303833008, -1.62260346527048, 218, 4, 'PPL', 'P'),
(54452, 'Dodge City', 39.7941703796387, 0.694539296224297, -91.5166702270508, -1.5972672159239, 218, 29, 'PPL', 'P'),
(130510, 'Dodge City', 46.7786102294922, 0.816440768011739, -87.873893737793, -1.53368877227211, 218, 27, 'PPL', 'P'),
(187647, 'Dodge City', 37.7527809143066, 0.658910328738726, -100.016670227051, -1.74562020234342, 218, 20, 'PPL', 'P'),
(127267, 'Dodge Corner', 44.6836090087891, 0.779876098877169, -69.3486099243164, -1.21036157486054, 218, 26, 'PPL', 'P'),
(177333, 'Dodge Corner', 42.5999984741211, 0.743510234717974, -72.8430633544922, -1.27135129277471, 218, 23, 'PPL', 'P'),
(20609, 'Dodge High', 32.230281829834, 0.562524536776306, -83.2291717529297, -1.45262308079648, 218, 13, 'PPL', 'P'),
(143718, 'Dodge Hollow', 43.2027816772461, 0.754030786288223, -72.2180633544922, -1.26044298494975, 218, 36, 'PPL', 'P'),
(46616, 'Dodge Park', 38.9275016784668, 0.679413073864865, -76.8772201538086, -1.3417606114645, 218, 25, 'PPL', 'P'),
(181161, 'Dodge Place', 39.9038887023926, 0.696454242206118, -121.678329467773, -2.12368747753909, 218, 6, 'PPL', 'P'),
(196360, 'Dodge Summit', 48.9191703796387, 0.853800590468779, -115.356941223145, -2.01335843937345, 218, 31, 'PPL', 'P'),
(143719, 'Dodge Tavern', 43.103889465332, 0.752304791585742, -72.3894424438477, -1.26343411432807, 218, 36, 'PPL', 'P'),
(181162, 'Dodgeland', 39.5447196960449, 0.690185560474235, -121.906669616699, -2.12767276495234, 218, 6, 'PPL', 'P'),
(64236, 'Dodgetown', 36.4324989318848, 0.635867061090706, -80.101936340332, -1.39804252636169, 218, 33, 'PPL', 'P'),
(196361, 'Dodgetown (historical)', 46.3069381713867, 0.80820853760814, -109.360557556152, -1.90870180117162, 218, 31, 'PPL', 'P'),
(115290, 'Dodgeville', 40.9430618286133, 0.714591234756912, -91.1805572509766, -1.59140093783273, 218, 16, 'PPL', 'P'),
(124643, 'Dodgeville', 41.9208297729492, 0.731656504706031, -71.2972183227539, -1.24437120724528, 218, 23, 'PPL', 'P'),
(130511, 'Dodgeville', 47.0941696166992, 0.821948318304077, -88.5811080932617, -1.54603199129241, 218, 27, 'PPL', 'P'),
(155006, 'Dodgeville', 41.5855598449707, 0.725804940579881, -80.7969436645508, -1.41017269249478, 218, 41, 'PPL', 'P'),
(173823, 'Dodgeville', 42.9602813720703, 0.749798357525814, -90.129997253418, -1.57306520688559, 218, 57, 'PPL', 'P'),
(113158, 'Dodgingtown', 41.3791694641113, 0.72220274888944, -73.3566665649414, -1.28031535984587, 218, 8, 'PPL', 'P'),
(101445, 'Dodlyt', 37.8969383239746, 0.661426350178578, -76.5105590820313, -1.3353611685231, 218, 53, 'PPL', 'P'),
(72328, 'Dodo', 39.9833297729492, 0.697840750448641, -83.9927825927734, -1.46595060415568, 218, 41, 'PPL', 'P'),
(86537, 'Dodoburg (historical)', 36.1536102294922, 0.630999534987341, -86.5163879394531, -1.50999582647617, 218, 50, 'PPL', 'P'),
(46617, 'Dodon', 38.8950004577637, 0.678845820552678, -76.6233291625977, -1.33732937772672, 218, 25, 'PPL', 'P'),
(108918, 'Dodrill', 38.8627815246582, 0.678283494088508, -81.0347213745117, -1.41432269642145, 218, 58, 'PPL', 'P'),
(8544, 'Dodson', 33.2416687011719, 0.580176567692596, -93.3461074829102, -1.6291969194973, 218, 4, 'PPL', 'P'),
(40672, 'Dodson', 32.0802803039551, 0.559906516266703, -92.6602783203125, -1.61722694250377, 218, 22, 'PPL', 'P'),
(54453, 'Dodson', 38.9749984741211, 0.680242049333179, -94.5527801513672, -1.6502573305557, 218, 29, 'PPL', 'P'),
(72327, 'Dodson', 39.8505592346191, 0.695523467405135, -84.4433288574219, -1.47381411990635, 218, 41, 'PPL', 'P'),
(86539, 'Dodson', 35.8125, 0.625046038370469, -85.3730621337891, -1.49004102674431, 218, 50, 'PPL', 'P'),
(101446, 'Dodson', 36.8327789306641, 0.642853264999284, -80.1083297729492, -1.39815411281137, 218, 53, 'PPL', 'P'),
(191386, 'Dodson', 34.7666702270508, 0.606792865417121, -100.023612976074, -1.74574137617302, 218, 51, 'PPL', 'P'),
(196362, 'Dodson', 48.3955612182617, 0.844661886609145, -108.243606567383, -1.88920732883419, 218, 31, 'PPL', 'P'),
(200706, 'Dodson', 45.6055603027344, 0.795967184499537, -122.034439086914, -2.12990276289111, 218, 43, 'PPL', 'P'),
(86540, 'Dodson Branch', 36.3125, 0.633772684630441, -85.5322189331055, -1.49281883691932, 218, 50, 'PPL', 'P'),
(101447, 'Dodson Corner', 36.7338905334473, 0.641127336875831, -78.4300003051758, -1.36886173766547, 218, 53, 'PPL', 'P'),
(108919, 'Dodson Junction', 38.1330604553223, 0.665547458807422, -81.9091720581055, -1.42958473999648, 218, 58, 'PPL', 'P'),
(64237, 'Dodsons Crossroads', 35.9722213745117, 0.62783370224151, -79.1636123657227, -1.38166568355436, 218, 33, 'PPL', 'P'),
(72330, 'Dodsonville', 39.202220916748, 0.684207829091443, -83.8147201538086, -1.46284282832161, 218, 41, 'PPL', 'P'),
(2059, 'Dodsonville (historical)', 34.5791702270508, 0.603520373069631, -86.1208267211914, -1.5030919808243, 218, 2, 'PPL', 'P'),
(207219, 'Doe Bay', 48.6413917541504, 0.848952438862345, -122.779716491699, -2.14291030744533, 218, 56, 'PPL', 'P'),
(64238, 'Doe Creek', 34.0072212219238, 0.59353797977666, -78.3022232055664, -1.36663160656864, 218, 33, 'PPL', 'P'),
(108920, 'Doe Gully', 39.6074981689453, 0.691281251525721, -78.3899993896484, -1.36816358998571, 218, 58, 'PPL', 'P'),
(101448, 'Doe Hill', 38.4319381713867, 0.670763859013587, -79.4447174072266, -1.38657189207256, 218, 53, 'PPL', 'P'),
(46618, 'Doe Run', 38.3050003051758, 0.66854837530275, -75.5927810668945, -1.31934292035654, 218, 25, 'PPL', 'P'),
(54454, 'Doe Run', 37.7427787780762, 0.658735758529271, -90.4974975585938, -1.57947929721299, 218, 29, 'PPL', 'P'),
(112517, 'Doe Run', 39.9161109924316, 0.696667561409434, -75.8180618286133, -1.32327481138993, 218, 45, 'PPL', 'P'),
(186626, 'Doenz Place', 39.9049987792969, 0.696473616703049, -106.401107788086, -1.85704965867148, 218, 7, 'PPL', 'P'),
(173827, 'Doering', 45.235279083252, 0.789504558061269, -89.4580612182617, -1.56133771070932, 218, 57, 'PPL', 'P'),
(20611, 'Doerun', 31.3194408416748, 0.546627362570809, -83.9172210693359, -1.46463180678387, 218, 13, 'PPL', 'P'),
(86541, 'Doeville', 36.3894386291504, 0.635115517031086, -81.9700012207031, -1.43064640916504, 218, 50, 'PPL', 'P'),
(93774, 'Doffing', 26.274169921875, 0.45857077336518, -98.3855590820313, -1.71715194239686, 218, 51, 'PPL', 'P'),
(80691, 'Dog Bluff', 33.9524993896484, 0.59258290363073, -79.2247161865234, -1.38273214641288, 218, 48, 'PPL', 'P'),
(80692, 'Dog Bluff Landing', 33.9661102294922, 0.592820457599965, -79.3363876342773, -1.38468118085665, 218, 48, 'PPL', 'P'),
(188432, 'Dog Canyon Estates', 32.7438888549805, 0.571488670426485, -105.955001831055, -1.84926364090853, 218, 38, 'PPL', 'P'),
(127268, 'Dog Corner', 43.7636108398438, 0.763819101716754, -70.4752807617188, -1.23002569055941, 218, 26, 'PPL', 'P'),
(127269, 'Dog Corners', 44.788330078125, 0.78170382633329, -68.2008285522461, -1.19032901082485, 218, 26, 'PPL', 'P'),
(75670, 'Dog Creek', 35.100830078125, 0.61262505504634, -94.8511123657227, -1.65546420996097, 218, 42, 'PPL', 'P'),
(20615, 'Dog Crossing', 32.9813919067383, 0.575633880663194, -84.2613906860352, -1.4706386997806, 218, 13, 'PPL', 'P'),
(86542, 'Dog Hill', 35.8408317565918, 0.62554052080587, -89.2830581665039, -1.5582833312551, 218, 50, 'PPL', 'P'),
(127270, 'Dog Island Corner', 44.4013900756836, 0.774950449283013, -69.0319366455078, -1.20483458349224, 218, 26, 'PPL', 'P'),
(108921, 'Dog Patch', 37.8194389343262, 0.660073730660927, -81.998893737793, -1.43115067871745, 218, 58, 'PPL', 'P'),
(93775, 'Dog Ridge (historical)', 31.0538902282715, 0.541992630036231, -97.5063934326172, -1.70180760714415, 218, 51, 'PPL', 'P'),
(2060, 'Dog Town', 34.3527793884277, 0.599569107539308, -85.7369384765625, -1.49639186699583, 218, 2, 'PPL', 'P'),
(127271, 'Dog Town', 44.7230606079102, 0.780564659177009, -67.379997253418, -1.17600280205688, 218, 26, 'PPL', 'P'),
(160822, 'Dog Town', 40.7802810668945, 0.711750174506016, -79.5261077880859, -1.387992422198, 218, 45, 'PPL', 'P'),
(181164, 'Dog Town', 38.170280456543, 0.666197070376319, -119.196388244629, -2.08036943135424, 218, 6, 'PPL', 'P'),
(86543, 'Dog Town (historical)', 36.1283302307129, 0.630558315773743, -86.7125015258789, -1.51341865426719, 218, 50, 'PPL', 'P'),
(26961, 'Dog Walk', 37.7591705322266, 0.659021848609373, -88.9327774047852, -1.55216977865672, 218, 18, 'PPL', 'P'),
(35598, 'Dog Walk', 37.3769416809082, 0.652350696657752, -84.5022201538086, -1.47484196692907, 218, 21, 'PPL', 'P'),
(814, 'Doga', 36.5666694641113, 0.638208778637213, -96.795280456543, -1.68939634435799, 218, 42, 'PPL', 'P'),
(35600, 'Dogcreek', 37.3205604553223, 0.651366658634968, -86.1252822875977, -1.50316974512813, 218, 21, 'PPL', 'P'),
(101449, 'Doggetts Fork', 37.898609161377, 0.661455511792515, -77.3522186279297, -1.35005089877986, 218, 53, 'PPL', 'P'),
(181168, 'Doghouse Junction', 32.6002807617188, 0.568982236366557, -116.840278625488, -2.03924756096233, 218, 6, 'PPL', 'P'),
(8545, 'Dogpatch', 36.1097183227539, 0.63023347669978, -93.1347198486328, -1.62550750928116, 218, 4, 'PPL', 'P'),
(211793, 'Dogpatch', 64.8955612182617, 1.13264121318821, -147.806396484375, -2.57970827416052, 218, 1, 'PPL', 'P'),
(145098, 'Dogs Corners', 40.264720916748, 0.702751952393883, -74.0425033569336, -1.29228546999745, 218, 37, 'PPL', 'P'),
(20612, 'Dogsboro', 34.0319404602051, 0.593969411873253, -83.3158264160156, -1.45413548997954, 218, 13, 'PPL', 'P'),
(148311, 'Dogtail Corners', 41.6713905334473, 0.727302968693051, -73.5288925170898, -1.28332126976824, 218, 40, 'PPL', 'P'),
(2062, 'Dogtown', 33.9480590820313, 0.592505405643009, -87.5666732788086, -1.52832676373335, 218, 2, 'PPL', 'P'),
(15798, 'Dogtown', 30.6786098480225, 0.535442751782749, -84.5033264160156, -1.47486127484697, 218, 12, 'PPL', 'P'),
(35599, 'Dogtown', 36.8377799987793, 0.642940550104011, -88.3233337402344, -1.54153298010489, 218, 21, 'PPL', 'P'),
(46623, 'Dogtown', 39.5058288574219, 0.689506787291401, -77.7655563354492, -1.35726500269872, 218, 25, 'PPL', 'P'),
(59685, 'Dogtown', 34.264720916748, 0.598032197274223, -89.2858276367188, -1.55833166762889, 218, 30, 'PPL', 'P'),
(86548, 'Dogtown', 35.3494415283203, 0.616964143410406, -85.6869430541992, -1.49551928226466, 218, 50, 'PPL', 'P'),
(113181, 'Dogtown', 42.8416709899902, 0.747728215831468, -75.0827789306641, -1.31044170388712, 218, 40, 'PPL', 'P'),
(127272, 'Dogtown', 44.7986106872559, 0.781883256811734, -69.3591690063477, -1.21054586560797, 218, 26, 'PPL', 'P'),
(160827, 'Dogtown', 41.5791702270508, 0.725693420709234, -76.9244384765625, -1.34258472666383, 218, 45, 'PPL', 'P'),
(181167, 'Dogtown', 38.2138900756836, 0.666958201815864, -121.087501525879, -2.11337558464024, 218, 6, 'PPL', 'P'),
(155007, 'Dogtown (historical)', 40.3255615234375, 0.703813821299525, -80.7433319091797, -1.40923699084578, 218, 41, 'PPL', 'P'),
(196364, 'Dogtown (historical)', 45.7083282470703, 0.797760823493705, -111.172218322754, -1.94032124647802, 218, 31, 'PPL', 'P'),
(124645, 'Dogtown Commons', 42.6361083984375, 0.744140471789941, -70.665283203125, -1.23334185874878, 218, 23, 'PPL', 'P'),
(101450, 'Dogue', 38.2319412231445, 0.66727325377282, -77.2161102294922, -1.34767535908751, 218, 53, 'PPL', 'P'),
(35601, 'Dogwalk', 37.4047203063965, 0.652835525134201, -86.6302795410156, -1.5119836099138, 218, 21, 'PPL', 'P'),
(108922, 'Dogway', 38.2408294677734, 0.667428382906317, -80.3727798461914, -1.40276963729658, 218, 58, 'PPL', 'P'),
(2064, 'Dogwood', 33.1511116027832, 0.578596048164661, -86.8730621337891, -1.51622096552423, 218, 2, 'PPL', 'P'),
(8548, 'Dogwood', 35.0922203063965, 0.612474786181832, -91.6552810668945, -1.59968643145813, 218, 4, 'PPL', 'P'),
(26962, 'Dogwood', 39.0638885498047, 0.681793473826205, -87.8908309936523, -1.53398438315311, 218, 18, 'PPL', 'P'),
(29649, 'Dogwood', 38.105281829834, 0.665062630330973, -86.0844421386719, -1.50245695006237, 218, 19, 'PPL', 'P'),
(35603, 'Dogwood', 36.9491691589355, 0.644884657699769, -87.4105606079102, -1.52560208362209, 218, 21, 'PPL', 'P'),
(46619, 'Dogwood', 39.1841697692871, 0.683892777134487, -76.9261093139648, -1.34261388827776, 218, 25, 'PPL', 'P'),
(54456, 'Dogwood', 37.0377807617188, 0.646431221923806, -92.8308334350586, -1.62020369081221, 218, 29, 'PPL', 'P'),
(86546, 'Dogwood', 35.7874984741211, 0.62460967942586, -84.4225006103516, -1.47345059841756, 218, 50, 'PPL', 'P'),
(2065, 'Dogwood Acres', 31.7069396972656, 0.553390493448579, -86.0577774047852, -1.50199156266188, 218, 2, 'PPL', 'P'),
(13666, 'Dogwood Acres', 38.5355606079102, 0.67257241170986, -75.5844421386719, -1.31919737860297, 218, 10, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(20614, 'Dogwood Acres', 33.7213897705078, 0.588549279843696, -84.6930618286133, -1.47817278250443, 218, 13, 'PPL', 'P'),
(40673, 'Dogwood Acres', 32.5744400024414, 0.568531230035952, -93.6050033569336, -1.63371550491884, 218, 22, 'PPL', 'P'),
(64240, 'Dogwood Acres', 35.0250015258789, 0.611301597142625, -80.5908279418945, -1.4065752944943, 218, 33, 'PPL', 'P'),
(80694, 'Dogwood Acres', 34.9602813720703, 0.610172017366268, -82.2491683959961, -1.4355187955374, 218, 48, 'PPL', 'P'),
(93776, 'Dogwood Acres', 30.0888900756836, 0.525150200091325, -95.1725006103516, -1.66107349300695, 218, 51, 'PPL', 'P'),
(101452, 'Dogwood Acres', 37.7097206115723, 0.658158784679106, -78.0611114501953, -1.36242341257215, 218, 53, 'PPL', 'P'),
(13667, 'Dogwood Acres Mobile Home Park', 38.5611114501953, 0.673018358034394, -75.1866683959961, -1.3122549171153, 218, 10, 'PPL', 'P'),
(93777, 'Dogwood City', 32.1558609008789, 0.561225646533647, -95.4569702148438, -1.66603842422718, 218, 51, 'PPL', 'P'),
(2066, 'Dogwood Estates', 33.7227783203125, 0.588573514609616, -86.5599975585938, -1.51075695791571, 218, 2, 'PPL', 'P'),
(20617, 'Dogwood Estates', 34.2794418334961, 0.598289125740389, -85.1155624389648, -1.48554680924675, 218, 13, 'PPL', 'P'),
(40674, 'Dogwood Estates', 32.5763893127441, 0.568565251918878, -93.6116714477539, -1.63383188505847, 218, 22, 'PPL', 'P'),
(46620, 'Dogwood Estates', 39.4025001525879, 0.687703361180227, -77.0047225952148, -1.34398594887137, 218, 25, 'PPL', 'P'),
(101451, 'Dogwood Estates', 36.7197189331055, 0.64087999578959, -76.6211090087891, -1.33729062873286, 218, 53, 'PPL', 'P'),
(108923, 'Dogwood Estates', 38.4486083984375, 0.671054809362678, -81.9761123657227, -1.4307530687667, 218, 58, 'PPL', 'P'),
(86549, 'Dogwood Flat', 35.8427810668945, 0.625574542688796, -87.3472213745117, -1.5244966054536, 218, 50, 'PPL', 'P'),
(46621, 'Dogwood Flats', 39.5247192382813, 0.689836486634353, -79.0169372558594, -1.37910571995652, 218, 25, 'PPL', 'P'),
(20618, 'Dogwood Forest', 33.6830596923828, 0.587880293777868, -84.2122192382813, -1.46978049611932, 218, 13, 'PPL', 'P'),
(40675, 'Dogwood Forest', 32.5736083984375, 0.568516715808011, -93.6163864135742, -1.63391417673616, 218, 22, 'PPL', 'P'),
(80704, 'Dogwood Gardens', 32.8313903808594, 0.573015860153591, -80.0341720581055, -1.39685981652159, 218, 48, 'PPL', 'P'),
(64244, 'Dogwood Grove', 35.5974998474121, 0.62129357781552, -82.5091705322266, -1.44005668887684, 218, 33, 'PPL', 'P'),
(80697, 'Dogwood Heights', 34.7705612182617, 0.606860776024918, -82.9527816772461, -1.44779916395597, 218, 48, 'PPL', 'P'),
(86550, 'Dogwood Heights', 35.8722190856934, 0.626088333042099, -84.6361083984375, -1.47717875762756, 218, 50, 'PPL', 'P'),
(101453, 'Dogwood Hill', 38.1411094665527, 0.665687940554923, -79.0763931274414, -1.38014342067527, 218, 53, 'PPL', 'P'),
(20619, 'Dogwood Hills', 33.6722183227539, 0.587691076182418, -84.2122192382813, -1.46978049611932, 218, 13, 'PPL', 'P'),
(40676, 'Dogwood Hills', 32.5722198486328, 0.568492481042092, -93.620002746582, -1.63397729365399, 218, 22, 'PPL', 'P'),
(46622, 'Dogwood Hills', 39.4308280944824, 0.6881977770366, -76.5563888549805, -1.3361610489565, 218, 25, 'PPL', 'P'),
(86552, 'Dogwood Hills', 36.1791687011719, 0.63144561446993, -83.283332824707, -1.45356836982541, 218, 50, 'PPL', 'P'),
(160828, 'Dogwood Hollow', 40.1425018310547, 0.700618826939757, -74.8402786254883, -1.30620927512471, 218, 45, 'PPL', 'P'),
(101455, 'Dogwood Knoll', 37.6175003051758, 0.656549236695289, -77.3327789306641, -1.34971161205699, 218, 53, 'PPL', 'P'),
(59686, 'Dogwood Landing', 32.9527816772461, 0.575134537958804, -90.7850036621094, -1.58449722533892, 218, 30, 'PPL', 'P'),
(80699, 'Dogwood Manor', 33.5102806091309, 0.584864729896544, -81.7008285522461, -1.42594845984409, 218, 48, 'PPL', 'P'),
(8549, 'Dogwood Meadows', 34.9477806091309, 0.609953837893963, -91.966667175293, -1.60512114429466, 218, 4, 'PPL', 'P'),
(80700, 'Dogwood Neck (historical)', 33.853889465332, 0.590861835776267, -78.8194427490234, -1.37565879055763, 218, 48, 'PPL', 'P'),
(8550, 'Dogwood Park', 36.3788909912109, 0.634931426020734, -92.3000030517578, -1.61093895285399, 218, 4, 'PPL', 'P'),
(40677, 'Dogwood Park', 32.5761108398438, 0.568560391649889, -93.6194381713867, -1.63396743995796, 218, 22, 'PPL', 'P'),
(13668, 'Dogwood Park Mobile Home Park', 38.6383285522461, 0.674366050704028, -75.3150024414063, -1.31449476875011, 218, 10, 'PPL', 'P'),
(20620, 'Dogwood Plantation', 32.771110534668, 0.571963778364955, -83.7727813720703, -1.462110858496, 218, 13, 'PPL', 'P'),
(2067, 'Dogwood Point', 33.0947189331055, 0.577611810404795, -86.5213928222656, -1.51008317815992, 218, 2, 'PPL', 'P'),
(86553, 'Dogwood Shores', 35.7591705322266, 0.624115263569487, -84.4394378662109, -1.47374620929856, 218, 50, 'PPL', 'P'),
(46624, 'Dogwood Trailer Park', 39.0444412231445, 0.681454053945274, -76.5152816772461, -1.33544359335883, 218, 25, 'PPL', 'P'),
(46627, 'Dogwood Village', 38.3424987792969, 0.669202847140637, -75.6094436645508, -1.31963373754758, 218, 25, 'PPL', 'P'),
(72331, 'Doherty', 39.8088912963867, 0.694796224690462, -81.309440612793, -1.41911745164803, 218, 41, 'PPL', 'P'),
(108925, 'Dola', 39.3763885498047, 0.687247627738687, -80.4219436645508, -1.40362770779981, 218, 58, 'PPL', 'P'),
(155008, 'Dola', 40.7830581665039, 0.711798644037855, -83.6927795410156, -1.46071456313647, 218, 41, 'PPL', 'P'),
(29650, 'Dolan', 39.2402801513672, 0.684872088046336, -86.4991683959961, -1.50969528874715, 218, 19, 'PPL', 'P'),
(93778, 'Dolan', 31.0880603790283, 0.54258901167284, -94.4316711425781, -1.6481435795985, 218, 51, 'PPL', 'P'),
(178100, 'Dolan Springs', 35.5919418334961, 0.621196572172814, -114.272499084473, -1.99443135350625, 218, 5, 'PPL', 'P'),
(108926, 'Dolan Trailer Park', 39.0522193908691, 0.681589808581841, -80.4836120605469, -1.40470402435436, 218, 58, 'PPL', 'P'),
(181169, 'Dolanco Junction', 33.8450012207031, 0.59070670664277, -118.299171447754, -2.06471004414457, 218, 6, 'PPL', 'P'),
(170173, 'Doland', 44.8958282470703, 0.783580023321251, -98.1002807617188, -1.71217289642284, 218, 49, 'PPL', 'P'),
(75671, 'Dolberg', 34.6266708374023, 0.604349415116973, -96.9186096191406, -1.69154884430905, 218, 42, 'PPL', 'P'),
(127273, 'Dolby', 45.6333312988281, 0.796451879817931, -68.6047210693359, -1.19737826507224, 218, 26, 'PPL', 'P'),
(207220, 'Dole', 45.7833290100098, 0.799069833748506, -122.336669921875, -2.13517768606223, 218, 56, 'PPL', 'P'),
(143720, 'Dole Junction', 42.7544403076172, 0.746205753215297, -72.4694366455078, -1.26483027652955, 218, 36, 'PPL', 'P'),
(93779, 'Dolen', 30.4249992370605, 0.531016411603469, -94.8974990844727, -1.65627381093235, 218, 51, 'PPL', 'P'),
(20621, 'Doles', 31.6991691589355, 0.553254871970067, -83.8852767944336, -1.46407427400966, 218, 13, 'PPL', 'P'),
(194846, 'Doles', 43.6697196960449, 0.762180392119001, -116.782783508301, -2.03824408186358, 218, 17, 'PPL', 'P'),
(124646, 'Doles Corner', 42.726390838623, 0.745716197627913, -70.9027786254883, -1.23748693582743, 218, 23, 'PPL', 'P'),
(101454, 'Doles Crossroads', 36.8600006103516, 0.643328372937754, -76.9047164916992, -1.34224051309293, 218, 53, 'PPL', 'P'),
(40678, 'Dolette (historical)', 31.9733295440674, 0.558039873369153, -93.5458297729492, -1.6326827310481, 218, 22, 'PPL', 'P'),
(78137, 'Dolf', 39.7830581665039, 0.694345351517912, -76.5458297729492, -1.33597675820907, 218, 45, 'PPL', 'P'),
(148312, 'Dolgeville', 43.100830078125, 0.752251395205886, -74.7733306884766, -1.30504081319643, 218, 40, 'PPL', 'P'),
(160829, 'Dolington', 40.2649993896484, 0.702756812662872, -74.8958282470703, -1.30717879891955, 218, 45, 'PPL', 'P'),
(225, 'Doliska', 33.711669921875, 0.588379636482258, -87.1011123657227, -1.52020119293141, 218, 2, 'PPL', 'P'),
(2068, 'Dollar', 32.8786087036133, 0.573839975352916, -86.4241714477539, -1.50838634507138, 218, 2, 'PPL', 'P'),
(86554, 'Dollar', 35.9099998474121, 0.626747731728003, -88.2600021362305, -1.54042763509445, 218, 50, 'PPL', 'P'),
(130512, 'Dollar Bay', 47.1197204589844, 0.822394264628611, -88.5113906860352, -1.54481519299036, 218, 27, 'PPL', 'P'),
(207221, 'Dollar Corner', 45.7802810668945, 0.799016637105732, -122.598892211914, -2.13975432839553, 218, 56, 'PPL', 'P'),
(8552, 'Dollar Junction', 33.0699996948242, 0.577180378308203, -92.1877822875977, -1.60898033103029, 218, 4, 'PPL', 'P'),
(181170, 'Dollar Point', 39.188060760498, 0.683960687742284, -120.098892211914, -2.09612109709568, 218, 6, 'PPL', 'P'),
(130513, 'Dollar Settlement', 46.461669921875, 0.810909116111535, -84.7391662597656, -1.4789774566278, 218, 27, 'PPL', 'P'),
(130514, 'Dollarville', 46.351390838623, 0.808984383012708, -85.5419387817383, -1.49298848028076, 218, 27, 'PPL', 'P'),
(178101, 'Dollbeer Mobile Home Ranch', 33.4124984741211, 0.583158109690994, -111.64778137207, -1.94862138748942, 218, 5, 'PPL', 'P'),
(181171, 'Dolley', 33.8655586242676, 0.59106550102063, -118.090278625488, -2.06106417661225, 218, 6, 'PPL', 'P'),
(127274, 'Dolley Corner', 43.8338890075684, 0.765045687135817, -70.4094390869141, -1.22887653654904, 218, 26, 'PPL', 'P'),
(108927, 'Dollie', 38.0444412231445, 0.664000761425331, -81.9830627441406, -1.43087437575435, 218, 58, 'PPL', 'P'),
(115291, 'Dolliver', 43.4644393920898, 0.75859757492549, -94.625, -1.65151780469963, 218, 16, 'PPL', 'P'),
(26963, 'Dollville', 39.436939239502, 0.688304436638258, -88.9916687011719, -1.55319762567943, 218, 18, 'PPL', 'P'),
(72332, 'Dolly Varden', 39.8424987792969, 0.695382785920552, -83.692497253418, -1.46070963628845, 218, 41, 'PPL', 'P'),
(199922, 'Dolly Varden', 40.5447196960449, 0.707638852994178, -114.534439086914, -1.99900306899154, 218, 39, 'PPL', 'P'),
(2070, 'Dolomite', 33.4627799987793, 0.584035687849203, -86.9613876342773, -1.51776253632122, 218, 2, 'PPL', 'P'),
(86555, 'Dolomite', 36.3611106872559, 0.634621101174713, -87.6577835083008, -1.52991693722023, 218, 50, 'PPL', 'P'),
(181172, 'Dolomite', 36.5530586242676, 0.637971224667978, -117.944442749023, -2.05851886040041, 218, 6, 'PPL', 'P'),
(203742, 'Dolomite', 40.7011108398438, 0.710368393374428, -112.574996948242, -1.96480435216939, 218, 52, 'PPL', 'P'),
(2071, 'Dolonar', 33.3888893127441, 0.582746052091332, -86.9913864135742, -1.51828611379153, 218, 2, 'PPL', 'P'),
(2072, 'Dolonar Junction', 33.4263916015625, 0.583400590508246, -86.9713897705078, -1.51793710653068, 218, 2, 'PPL', 'P'),
(181173, 'Dolores', 33.8330612182617, 0.590498314287471, -118.225563049316, -2.06342533523472, 218, 6, 'PPL', 'P'),
(186627, 'Dolores', 37.4738883972168, 0.654042736056334, -108.503890991211, -1.89375014902164, 218, 7, 'PPL', 'P'),
(188433, 'Dolores (historical)', 35.3424987792969, 0.616842969580807, -106.119171142578, -1.85212893592534, 218, 38, 'PPL', 'P'),
(93780, 'Dolores Colonia', 27.2749996185303, 0.476038546823551, -99.4179992675781, -1.73517142296455, 218, 51, 'PPL', 'P'),
(59688, 'Doloroso', 31.3050003051758, 0.546375327663147, -91.3594436645508, -1.59452309473669, 218, 30, 'PPL', 'P'),
(8553, 'Dolph', 36.228328704834, 0.632303618394126, -92.1125030517578, -1.6076664605065, 218, 4, 'PPL', 'P'),
(130515, 'Dolph', 44.2333297729492, 0.7720172436584, -84.8791732788086, -1.481421040086, 218, 27, 'PPL', 'P'),
(8554, 'Dolph (historical)', 33.7402801513672, 0.588878979186648, -93.6497192382813, -1.63449594427628, 218, 4, 'PPL', 'P'),
(101456, 'Dolphin', 36.8291702270508, 0.642790281239504, -77.7872161865234, -1.35764303841546, 218, 53, 'PPL', 'P'),
(207222, 'Dolphin', 48.651668548584, 0.849131802761761, -122.908058166504, -2.1451502922382, 218, 56, 'PPL', 'P'),
(113162, 'Dolphin Cove', 41.0258293151855, 0.716035799911198, -73.5497207641602, -1.28368479125703, 218, 8, 'PPL', 'P'),
(40679, 'Dolsen', 30.0588893890381, 0.524626589331501, -90.5980606079102, -1.58123445352941, 218, 22, 'PPL', 'P'),
(119389, 'Dolton', 41.6388893127441, 0.726735715380864, -87.6072235107422, -1.52903449879304, 218, 18, 'PPL', 'P'),
(170176, 'Dolton', 43.4908294677734, 0.75905816863602, -97.3852767944336, -1.6996937230289, 218, 49, 'PPL', 'P'),
(8555, 'Dolton (historical)', 34.103328704834, 0.595215371789246, -91.7455596923828, -1.60126209071708, 218, 4, 'PPL', 'P'),
(46628, 'Dolvin', 38.9266700744629, 0.679398559636924, -76.0761108398438, -1.32777861626742, 218, 25, 'PPL', 'P'),
(135025, 'Domaas', 48.1155586242676, 0.839774919429822, -94.5500030517578, -1.65020886102386, 218, 28, 'PPL', 'P'),
(108928, 'Doman (historical)', 39.1105613708496, 0.682608068224633, -78.8105621337891, -1.37550379458219, 218, 58, 'PPL', 'P'),
(108929, 'Dombey (historical)', 39.2041702270508, 0.684241850974369, -81.6222229003906, -1.42457653240853, 218, 58, 'PPL', 'P'),
(177633, 'Dome', 32.7552795410156, 0.57168747540186, -114.361389160156, -1.99598277799928, 218, 5, 'PPL', 'P'),
(186629, 'Dome Rock', 39.4216690063477, 0.688037920792168, -105.196937561035, -1.83603292345496, 218, 7, 'PPL', 'P'),
(155009, 'Domerville (historical)', 41.3841705322266, 0.722290033994168, -84.3241729736328, -1.47173445741111, 218, 41, 'PPL', 'P'),
(122506, 'Domestic', 40.6116714477539, 0.708807381501478, -85.0886077880859, -1.48507636184019, 218, 19, 'PPL', 'P'),
(188434, 'Domingo', 35.5108299255371, 0.619780902316355, -106.319442749023, -1.85562433485607, 218, 38, 'PPL', 'P'),
(181174, 'Dominguez', 33.8347206115723, 0.590527276164325, -118.217781066895, -2.06328951401912, 218, 6, 'PPL', 'P'),
(186630, 'Dominguez', 38.7972183227539, 0.677139200347128, -108.321670532227, -1.89056980204787, 218, 7, 'PPL', 'P'),
(181175, 'Dominguez Junction', 33.8633308410645, 0.591026618868715, -118.216941833496, -2.06327486663313, 218, 6, 'PPL', 'P'),
(200707, 'Dominic (historical)', 45.086109161377, 0.786901051779607, -122.766670227051, -2.14268260717213, 218, 43, 'PPL', 'P'),
(2073, 'Dominick', 32.7947196960449, 0.572375835964618, -87.5319366455078, -1.52772049511119, 218, 2, 'PPL', 'P'),
(80705, 'Dominicks (historical)', 34.0950012207031, 0.595070029772755, -82.0691680908203, -1.43237719755748, 218, 48, 'PPL', 'P'),
(46641, 'Dominion', 38.9469413757324, 0.679752360587741, -76.2813873291016, -1.33136136688191, 218, 25, 'PPL', 'P'),
(93781, 'Dominion', 29.6566696166992, 0.517606529987566, -98.6161117553711, -1.72117584564591, 218, 51, 'PPL', 'P'),
(101457, 'Dominion', 36.8108291625977, 0.642470169276476, -83.0713882446289, -1.44986923907129, 218, 53, 'PPL', 'P'),
(194160, 'Dominion', 40.1430587768555, 0.700628547477736, -105.126388549805, -1.83480161092496, 218, 7, 'PPL', 'P'),
(101458, 'Dominion Heights', 38.8927803039551, 0.678807071558817, -77.1080627441406, -1.34578957471963, 218, 53, 'PPL', 'P'),
(101459, 'Dominion Hills', 38.8758316040039, 0.678511260940737, -77.1413879394531, -1.3463712091017, 218, 53, 'PPL', 'P'),
(93782, 'Domino', 33.2649993896484, 0.580583765023269, -94.1149978637695, -1.64261658823021, 218, 51, 'PPL', 'P'),
(46629, 'Dominos Acres', 39.5555610656738, 0.690374778069685, -76.9061126708984, -1.34226488101691, 218, 25, 'PPL', 'P'),
(207223, 'Domke Lake Resort', 48.1841697692871, 0.840972409813977, -120.593063354492, -2.10474601060201, 218, 56, 'PPL', 'P'),
(108930, 'Don', 37.7419395446777, 0.658721111143276, -81.9391708374023, -1.43010831746679, 218, 58, 'PPL', 'P'),
(193145, 'Don', 42.9094390869141, 0.7489109922506, -112.529167175293, -1.96400447173599, 218, 17, 'PPL', 'P'),
(20622, 'Don (historical)', 34.0008316040039, 0.593426459906013, -84.9977798461914, -1.48349111520132, 218, 13, 'PPL', 'P'),
(181176, 'Don (historical)', 33.311939239502, 0.581403019953605, -117.476387023926, -2.05034974691465, 218, 6, 'PPL', 'P'),
(15805, 'Don Ce-Sar Place (historical)', 27.7091693878174, 0.483616238810235, -82.7369384765625, -1.444031989436, 218, 12, 'PPL', 'P'),
(178102, 'Don Luis', 31.4025001525879, 0.54807702102068, -109.916107177734, -1.91839797122644, 218, 5, 'PPL', 'P'),
(135026, 'Don'' Lakeview Mobile Home Park', 45.9083290100098, 0.801251495313499, -95.4138870239258, -1.6652864806934, 218, 28, 'PPL', 'P'),
(93783, 'Don-Tol', 29.2227802276611, 0.510033731559385, -95.916389465332, -1.67405680279525, 218, 51, 'PPL', 'P'),
(101460, 'Dona', 36.5941696166992, 0.638688746844673, -82.9911117553711, -1.4484681500218, 218, 53, 'PPL', 'P'),
(40680, 'Dona (historical)', 32.0202789306641, 0.558859294747057, -93.876106262207, -1.63844714322758, 218, 22, 'PPL', 'P'),
(188435, 'Dona Ana', 32.3894386291504, 0.565302346951313, -106.813331604004, -1.86424432151438, 218, 38, 'PPL', 'P'),
(15806, 'Dona Vista', 28.8944396972656, 0.504303108236239, -81.6875, -1.42571583272287, 218, 12, 'PPL', 'P'),
(93784, 'Donahoe', 30.8158302307129, 0.537837699261544, -97.3327789306641, -1.69877746245585, 218, 51, 'PPL', 'P'),
(115292, 'Donahue', 41.6947212219238, 0.727710166023724, -90.6752777099609, -1.58258214619904, 218, 16, 'PPL', 'P'),
(207224, 'Donahue', 47.2108306884766, 0.823984438115497, -117.354438781738, -2.04822134857146, 218, 56, 'PPL', 'P'),
(181177, 'Donahue (historical)', 38.1894416809082, 0.666531496830206, -122.540832519531, -2.13874099560076, 218, 6, 'PPL', 'P'),
(130516, 'Donahue Beach', 43.6566696166992, 0.761952625266772, -83.8797225952148, -1.46397733494598, 218, 27, 'PPL', 'P'),
(2074, 'Donald', 32.2491683959961, 0.56285416954023, -87.394172668457, -1.52531606012101, 218, 2, 'PPL', 'P'),
(20623, 'Donald', 31.8213901519775, 0.555388030713707, -81.8502807617188, -1.42855689297376, 218, 13, 'PPL', 'P'),
(108931, 'Donald', 38.2655601501465, 0.667860014739992, -80.7094421386719, -1.40864550276768, 218, 58, 'PPL', 'P'),
(173828, 'Donald', 45.252498626709, 0.789805095790284, -90.8969421386719, -1.5864509203146, 218, 57, 'PPL', 'P'),
(196365, 'Donald', 45.8450012207031, 0.800146216882089, -112.426666259766, -1.96221549327373, 218, 31, 'PPL', 'P'),
(200708, 'Donald', 45.2224998474121, 0.789281518319975, -122.83805847168, -2.14392856708812, 218, 43, 'PPL', 'P'),
(207225, 'Donald', 46.4766693115234, 0.81117090484669, -120.395561218262, -2.10129894804506, 218, 56, 'PPL', 'P'),
(8556, 'Donald (historical)', 35.3300018310547, 0.61662485668753, -93.9574966430664, -1.63986767335303, 218, 4, 'PPL', 'P'),
(141671, 'Donald Price Mobile Home Park', 40.773609161377, 0.711633727787352, -99.7494430541992, -1.74095620832637, 218, 35, 'PPL', 'P'),
(80708, 'Donalds', 34.3769416809082, 0.599990819097922, -82.3475036621094, -1.4372350697019, 218, 48, 'PPL', 'P'),
(101461, 'Donaldsburg', 37.8436088562012, 0.660495575377596, -79.3088912963867, -1.38420127922822, 218, 53, 'PPL', 'P'),
(8558, 'Donaldson', 34.2366714477539, 0.597542641686839, -92.9233322143555, -1.62181809906502, 218, 4, 'PPL', 'P'),
(35604, 'Donaldson', 36.7513885498047, 0.641432734873836, -87.8947219848633, -1.53405229376091, 218, 21, 'PPL', 'P'),
(108933, 'Donaldson', 38.3872184753418, 0.669983353077112, -80.5119400024414, -1.40519844021073, 218, 58, 'PPL', 'P'),
(122507, 'Donaldson', 41.3611106872559, 0.721887563774429, -86.4441680908203, -1.50873535233224, 218, 19, 'PPL', 'P'),
(135027, 'Donaldson', 48.5722198486328, 0.847745161361184, -96.896110534668, -1.69115616120632, 218, 28, 'PPL', 'P'),
(160831, 'Donaldson', 41.6588897705078, 0.727084789220746, -79.0133285522461, -1.37904273619674, 218, 45, 'PPL', 'P'),
(80709, 'Donaldson Heights', 34.7769393920898, 0.606972096158483, -82.3733291625977, -1.43768580971639, 218, 48, 'PPL', 'P'),
(2075, 'Donaldson Mill', 34.2508316040039, 0.597789783035999, -87.6258316040039, -1.52935927128797, 218, 2, 'PPL', 'P'),
(160832, 'Donaldsons Crossroads', 40.2730598449707, 0.702897494147456, -80.1269378662109, -1.3984788853063, 218, 45, 'PPL', 'P'),
(8559, 'Donaldsonville', 34.2763900756836, 0.598235862518587, -92.1388931274414, -1.60812705421703, 218, 4, 'PPL', 'P'),
(29651, 'Donaldsonville', 39.5291709899902, 0.689914184359156, -87.0988922119141, -1.52016244393755, 218, 19, 'PPL', 'P'),
(40681, 'Donaldsonville', 30.100830078125, 0.525358592446623, -90.9927825927734, -1.58812365179528, 218, 22, 'PPL', 'P'),
(20624, 'Donalsonville', 31.0402793884277, 0.541755076066996, -84.8791732788086, -1.481421040086, 218, 13, 'PPL', 'P'),
(35605, 'Donansburg', 37.2372207641602, 0.649912106626594, -85.626106262207, -1.49445747993805, 218, 21, 'PPL', 'P'),
(13671, 'Donas Landing', 39.2125015258789, 0.684387259569887, -75.4313888549805, -1.31652609487156, 218, 10, 'PPL', 'P'),
(160833, 'Donation', 40.5666694641113, 0.708021948716986, -77.9380569458008, -1.36027570631106, 218, 45, 'PPL', 'P'),
(8560, 'Donbey', 33.3022193908691, 0.581233376592167, -91.5500030517578, -1.59784898346403, 218, 4, 'PPL', 'P'),
(46631, 'Doncaster', 38.7841682434082, 0.676911433494899, -76.1319427490234, -1.32875306691028, 218, 25, 'PPL', 'P'),
(46632, 'Doncaster (historical)', 38.8583297729492, 0.678205796363704, -76.1911087036133, -1.32978570762296, 218, 25, 'PPL', 'P'),
(46633, 'Doncaster Village', 39.4124984741211, 0.687877864810654, -76.5277786254883, -1.33566170625211, 218, 25, 'PPL', 'P'),
(20625, 'Donegal', 32.5633316040039, 0.568337351908594, -81.7241668701172, -1.42635579033281, 218, 13, 'PPL', 'P'),
(59689, 'Donegal', 31.0558300018311, 0.542026485471588, -91.3769378662109, -1.59482842615566, 218, 30, 'PPL', 'P'),
(160834, 'Donegal', 40.1124992370605, 0.70009518289042, -79.3827819824219, -1.38549091498609, 218, 45, 'PPL', 'P'),
(160846, 'Donegal Heights', 40.0999984741211, 0.699877003418115, -76.5169372558594, -1.33547248865666, 218, 45, 'PPL', 'P'),
(160835, 'Donegal Springs', 40.0999984741211, 0.699877003418115, -76.5666732788086, -1.33634054601397, 218, 45, 'PPL', 'P'),
(135029, 'Donehower', 43.961109161377, 0.767266097694671, -91.4063873291016, -1.59534241624605, 218, 28, 'PPL', 'P'),
(86556, 'Donelson', 36.1624984741211, 0.631154664120839, -86.6699981689453, -1.51267683074555, 218, 50, 'PPL', 'P'),
(35606, 'Donerail', 38.149169921875, 0.665828622039507, -84.5350036621094, -1.47541414708927, 218, 21, 'PPL', 'P'),
(160840, 'Donerville', 40.0372200012207, 0.698781312366629, -76.4086074829102, -1.33358177744076, 218, 45, 'PPL', 'P'),
(119390, 'Doney', 41.0666694641113, 0.716748594976958, -87.625, -1.52934475706003, 218, 18, 'PPL', 'P'),
(72333, 'Doneys (historical)', 39.9583282470703, 0.697404391504031, -82.9049987792969, -1.44696519506061, 218, 41, 'PPL', 'P'),
(148313, 'Dongan Hills', 40.5883293151855, 0.708399984433723, -74.0966720581055, -1.29323089218442, 218, 40, 'PPL', 'P'),
(46634, 'Donghoregan', 39.2636108398438, 0.685279285377009, -76.9225006103516, -1.34255090451798, 218, 25, 'PPL', 'P'),
(8561, 'Dongola', 35.9086112976074, 0.626723496962083, -92.7583312988281, -1.61893828982026, 218, 4, 'PPL', 'P'),
(26965, 'Dongola', 37.3611106872559, 0.652074393694656, -89.1658325195313, -1.55623735774765, 218, 18, 'PPL', 'P'),
(29652, 'Dongola', 38.371940612793, 0.669716704072968, -87.3402786254883, -1.524375431624, 218, 19, 'PPL', 'P'),
(35607, 'Dongola', 37.0972213745117, 0.647468656326446, -82.8438873291016, -1.44589859904403, 218, 21, 'PPL', 'P'),
(54458, 'Dongola', 37.1680603027344, 0.648705028862515, -89.959716796875, -1.57009325226712, 218, 29, 'PPL', 'P'),
(80710, 'Dongola', 33.7572212219238, 0.589174656646674, -79.1872177124023, -1.38207767457499, 218, 48, 'PPL', 'P'),
(101462, 'Dongola', 37.7683296203613, 0.659181704853805, -77.8391723632813, -1.35854984476663, 218, 53, 'PPL', 'P'),
(54459, 'Donia', 37.9772186279297, 0.662827505807096, -94.041389465332, -1.64133187932035, 218, 29, 'PPL', 'P'),
(93785, 'Donie', 31.4769401550293, 0.549376244158476, -96.2222213745117, -1.67939457656809, 218, 51, 'PPL', 'P'),
(8562, 'Doniphan', 35.2477798461914, 0.615189812334141, -91.6694412231445, -1.59993357280729, 218, 4, 'PPL', 'P'),
(32246, 'Doniphan', 39.6416702270508, 0.691877666451844, -95.0805587768555, -1.65946880529212, 218, 20, 'PPL', 'P'),
(54460, 'Doniphan', 36.6208305358887, 0.639154067666137, -90.8233337402344, -1.58516621140475, 218, 29, 'PPL', 'P'),
(141672, 'Doniphan', 40.7719383239746, 0.711604566173415, -98.3691711425781, -1.71686591889578, 218, 35, 'PPL', 'P'),
(194847, 'Doniphan', 43.410831451416, 0.757661939855518, -114.483612060547, -1.99811597003243, 218, 17, 'PPL', 'P'),
(130517, 'Donken', 46.9416694641113, 0.819286688531625, -88.7944412231445, -1.54975535681245, 218, 27, 'PPL', 'P'),
(26973, 'Donkville', 38.6972198486328, 0.675393897726744, -89.9794387817383, -1.57043746583801, 218, 18, 'PPL', 'P'),
(108935, 'Donlan', 38.958610534668, 0.679956025832105, -80.6772232055664, -1.40808317630351, 218, 58, 'PPL', 'P'),
(196366, 'Donlan', 47.3302803039551, 0.826069227195839, -114.934440612793, -2.00598441263113, 218, 31, 'PPL', 'P'),
(108934, 'Donlan Heights', 39.0466690063477, 0.681492936097189, -80.4633331298828, -1.40435009024549, 218, 58, 'PPL', 'P'),
(46635, 'Donleigh', 39.1838912963867, 0.683887916865498, -76.8652801513672, -1.3415522191092, 218, 25, 'PPL', 'P'),
(160841, 'Donley', 40.1502799987793, 0.700754581576324, -80.4280624389648, -1.40373450055952, 218, 45, 'PPL', 'P'),
(115293, 'Donley Station (historical)', 41.334171295166, 0.721417382683976, -93.1750030517578, -1.62621058380894, 218, 16, 'PPL', 'P'),
(70746, 'Donlontown', 39.9099998474121, 0.696560901807776, -74.9327774047852, -1.30782368337751, 218, 37, 'PPL', 'P'),
(93786, 'Donna', 26.1700000762939, 0.456752666578497, -98.0516662597656, -1.71132441329954, 218, 51, 'PPL', 'P'),
(101464, 'Donna Lee Gardens', 38.8816719055176, 0.678613193431459, -77.1941680908203, -1.34729239652276, 218, 53, 'PPL', 'P'),
(64245, 'Donnaha', 36.2275009155273, 0.632289170745212, -80.4330596923828, -1.40382171908522, 218, 33, 'PPL', 'P'),
(160842, 'Donnally Mills', 40.5169410705566, 0.707154024517729, -77.2372207641602, -1.34804380742433, 218, 45, 'PPL', 'P'),
(115294, 'Donnan', 42.896110534668, 0.748678365129381, -91.8777770996094, -1.60356971980163, 218, 16, 'PPL', 'P'),
(54462, 'Donnell', 38.2136116027832, 0.666953341546874, -90.4588928222656, -1.5788055174572, 218, 29, 'PPL', 'P'),
(86557, 'Donnell Chapel', 35.7463912963867, 0.623892223828192, -86.220832824707, -1.50483741660274, 218, 50, 'PPL', 'P'),
(115295, 'Donnelley', 41.3349990844727, 0.72143183033289, -93.1766662597656, -1.62623961226482, 218, 16, 'PPL', 'P'),
(26968, 'Donnellson', 39.0277786254883, 0.681163236754237, -89.4733276367188, -1.56160415997638, 218, 18, 'PPL', 'P'),
(115296, 'Donnellson', 40.6427803039551, 0.709350333468718, -91.5644378662109, -1.59810091850315, 218, 16, 'PPL', 'P'),
(130518, 'Donnelly', 44.9936103820801, 0.785286643526801, -84.3127822875977, -1.47153565243574, 218, 27, 'PPL', 'P'),
(135030, 'Donnelly', 45.690559387207, 0.797450698384765, -96.0122222900391, -1.67572940111787, 218, 28, 'PPL', 'P'),
(160843, 'Donnelly', 40.1441688537598, 0.700647921974666, -79.5991668701172, -1.38926754372793, 218, 45, 'PPL', 'P'),
(194848, 'Donnelly', 44.7316703796387, 0.780714928041517, -116.080001831055, -2.02597822767295, 218, 17, 'PPL', 'P'),
(211794, 'Donnelly', 63.6736106872559, 1.11131415312566, -145.883331298828, -2.54614445494225, 218, 1, 'PPL', 'P'),
(160844, 'Donnellytown', 40.2855606079102, 0.703115673619761, -77.0980606079102, -1.34561500451017, 218, 45, 'PPL', 'P'),
(72334, 'Donnelsville', 39.9183311462402, 0.696706310403294, -83.9486083984375, -1.4651796190201, 218, 41, 'PPL', 'P'),
(575, 'Donner', 29.6955604553223, 0.5182853031704, -90.9441680908203, -1.58727516867198, 218, 22, 'PPL', 'P'),
(15807, 'Donner', 30.336669921875, 0.52947477422745, -81.4116668701172, -1.42090163642033, 218, 12, 'PPL', 'P'),
(181178, 'Donner', 39.3163909912109, 0.686200472798068, -120.331108093262, -2.10017402880061, 218, 6, 'PPL', 'P'),
(160845, 'Donner Crossroads', 41.4277801513672, 0.723051165433712, -80.3805618286133, -1.40290545851218, 218, 45, 'PPL', 'P'),
(181179, 'Donner Lake Village', 39.3252792358398, 0.686355601931565, -120.284721374512, -2.09936442782923, 218, 6, 'PPL', 'P'),
(181180, 'Donner Pines Tract', 39.3291702270508, 0.686423512539362, -120.244720458984, -2.09866628014946, 218, 6, 'PPL', 'P'),
(181181, 'Donner Woods', 39.3180618286133, 0.686229634412004, -120.289436340332, -2.09944671950691, 218, 6, 'PPL', 'P'),
(155010, 'Donnersville', 40.1188888549805, 0.700206702761067, -80.982780456543, -1.41341615638639, 218, 41, 'PPL', 'P'),
(46636, 'Donney Brook Farms', 39.6674995422363, 0.692328473045367, -76.7777786254883, -1.3400250293821, 218, 25, 'PPL', 'P'),
(8563, 'Donnick', 35.6458282470703, 0.622137067511776, -90.4461135864258, -1.57858247771591, 218, 4, 'PPL', 'P'),
(119391, 'Donny Hill Meadows', 41.8536109924316, 0.730483315666824, -88.4550018310547, -1.54383102180952, 218, 18, 'PPL', 'P'),
(46637, 'Donnybrook', 39.392219543457, 0.687523930701783, -76.5944366455078, -1.33682510817431, 218, 25, 'PPL', 'P'),
(198210, 'Donnybrook', 48.5094413757324, 0.846649470309699, -101.884719848633, -1.77822381883066, 218, 34, 'PPL', 'P'),
(200709, 'Donnybrook (historical)', 44.7544403076172, 0.781112338255184, -120.650001525879, -2.10573976916277, 218, 43, 'PPL', 'P'),
(86558, 'Donoho', 36.3127784729004, 0.63377754489943, -85.8680572509766, -1.49868032132053, 218, 50, 'PPL', 'P'),
(59690, 'Donohoe', 32.351390838623, 0.564638287733502, -89.3824996948242, -1.56001891333751, 218, 30, 'PPL', 'P'),
(160849, 'Donohoe', 40.3141708374023, 0.70361501632415, -79.4747161865234, -1.38709546954287, 218, 45, 'PPL', 'P'),
(160847, 'Donora', 40.1733283996582, 0.70115685205898, -79.857780456543, -1.39378120230146, 218, 45, 'PPL', 'P'),
(80711, 'Donora (historical)', 33.2208290100098, 0.579812846466719, -81.5166702270508, -1.42273429072447, 218, 48, 'PPL', 'P'),
(20627, 'Donovan', 32.771110534668, 0.571963778364955, -82.7130584716797, -1.4436152047254, 218, 13, 'PPL', 'P'),
(119392, 'Donovan', 40.8833312988281, 0.7135487403482, -87.6161117553711, -1.52918962792653, 218, 18, 'PPL', 'P'),
(59691, 'Donovan (historical)', 30.8972206115723, 0.539258229386992, -88.5116729736328, -1.54482011983837, 218, 30, 'PPL', 'P'),
(13670, 'Donovan Development', 38.7636108398438, 0.676552639117038, -75.1377792358398, -1.31140164030203, 218, 10, 'PPL', 'P'),
(196368, 'Donovan Park (historical)', 47.4166717529297, 0.827577042426014, -111.266670227051, -1.94196974319278, 218, 31, 'PPL', 'P'),
(101465, 'Donovans Corner', 38.7666702270508, 0.676606035496894, -77.3141708374023, -1.34938683956205, 218, 53, 'PPL', 'P'),
(46638, 'Donovans Pier', 38.9524993896484, 0.679849366230447, -76.5513916015625, -1.3360738304308, 218, 25, 'PPL', 'P'),
(101466, 'Dons Mobile Home Park', 36.6875, 0.64031766932542, -77.5869369506836, -1.35414750632668, 218, 53, 'PPL', 'P'),
(108936, 'Donwood', 38.1622200012207, 0.666056388891736, -81.3322219848633, -1.41951506159878, 218, 58, 'PPL', 'P'),
(148314, 'Doodletown', 41.2994384765625, 0.720811180640847, -74.003059387207, -1.29159704285566, 218, 40, 'PPL', 'P'),
(20626, 'Doogan', 34.9686088562012, 0.610317359382759, -84.6597213745117, -1.47759088180625, 218, 13, 'PPL', 'P'),
(226, 'Doolans', 34.1761093139648, 0.596485633050187, -86.1986083984375, -1.50444952718997, 218, 2, 'PPL', 'P'),
(93787, 'Doole', 31.3955593109131, 0.547955880480595, -99.5986099243164, -1.73832367358882, 218, 51, 'PPL', 'P'),
(8564, 'Dooley', 33.4686088562012, 0.584137420602844, -93.8572235107422, -1.63811757704268, 218, 4, 'PPL', 'P'),
(59692, 'Dooley', 34.6705589294434, 0.605115406825507, -90.2369384765625, -1.57493168333557, 218, 30, 'PPL', 'P'),
(101467, 'Dooley', 36.9305610656738, 0.644559885204834, -82.6544418334961, -1.44259215139265, 218, 53, 'PPL', 'P'),
(196367, 'Dooley', 48.8811111450195, 0.853136331513886, -104.388893127441, -1.82192988758633, 218, 31, 'PPL', 'P'),
(927, 'Dooley (historical)', 35.5936088562012, 0.621225667207723, -87.0449981689453, -1.51922181544053, 218, 50, 'PPL', 'P'),
(160850, 'Dooleyville', 40.7902793884277, 0.711924678136443, -76.4305572509766, -1.33396487316357, 218, 45, 'PPL', 'P'),
(64246, 'Doolie', 35.6019401550293, 0.621371075803242, -80.8974990844727, -1.41192771565315, 218, 33, 'PPL', 'P'),
(193070, 'Doolin', 36.7988891601563, 0.642261776921177, -101.992500305176, -1.78010494266664, 218, 42, 'PPL', 'P'),
(20628, 'Dooling', 32.230281829834, 0.562524536776306, -83.9280624389648, -1.46482102437932, 218, 13, 'PPL', 'P'),
(148315, 'Doolins Crossing', 44.0847206115723, 0.769423524493744, -75.6783294677734, -1.32083602162169, 218, 40, 'PPL', 'P'),
(54463, 'Doolittle', 37.9402809143066, 0.662182821086216, -91.8808288574219, -1.60362298302343, 218, 29, 'PPL', 'P'),
(93788, 'Doolittle', 26.3466701507568, 0.459836141067618, -98.1202774047852, -1.7125219036837, 218, 51, 'PPL', 'P'),
(59693, 'Doolittle (historical)', 32.3541717529297, 0.564686823844368, -89.1402816772461, -1.55579141142312, 218, 30, 'PPL', 'P'),
(93789, 'Doolittle Acres Colonia', 26.375560760498, 0.46034037733051, -98.1138916015625, -1.71241045039208, 218, 51, 'PPL', 'P'),
(29653, 'Doolittle Mills', 38.2508316040039, 0.667602953115772, -86.6030578613281, -1.51150850197533, 218, 19, 'PPL', 'P'),
(155011, 'Doolittles Corners', 41.2186088562012, 0.719400437632404, -81.3152770996094, -1.41921931755973, 218, 41, 'PPL', 'P'),
(101474, 'Dooms', 38.1088905334473, 0.665125614090753, -78.857780456543, -1.37632790978151, 218, 53, 'PPL', 'P'),
(115297, 'Doon', 43.2794418334961, 0.755368758419878, -96.2324981689453, -1.67957394046751, 218, 16, 'PPL', 'P'),
(173830, 'Door Creek', 43.0308303833008, 0.751029670055812, -89.1997222900391, -1.55682884582576, 218, 57, 'PPL', 'P'),
(122508, 'Door Village', 41.5747184753418, 0.725615722984431, -86.7688903808594, -1.51440282544803, 218, 19, 'PPL', 'P'),
(35608, 'Doorway', 37.2958297729492, 0.650935026801293, -83.539436340332, -1.458038219399, 218, 21, 'PPL', 'P'),
(122509, 'Dooville', 40.5533294677734, 0.707789121858686, -85.5599975585938, -1.49330366539577, 218, 19, 'PPL', 'P'),
(40683, 'Dopson', 32.5219383239746, 0.567614902883883, -92.1638870239258, -1.60856328000358, 218, 22, 'PPL', 'P'),
(746, 'Dora', 35.4977798461914, 0.619553135464126, -81.4288864135742, -1.42120217414935, 218, 33, 'PPL', 'P'),
(2076, 'Dora', 33.7286109924316, 0.588675313942284, -87.0902786254883, -1.52001210849401, 218, 2, 'PPL', 'P'),
(8567, 'Dora', 35.4541702270508, 0.618792004024582, -94.440559387207, -1.648298708732, 218, 4, 'PPL', 'P'),
(54468, 'Dora', 36.7769393920898, 0.64187868119837, -92.2172164916992, -1.60949405480457, 218, 29, 'PPL', 'P'),
(108939, 'Dora', 38.9105606079102, 0.679117396404839, -80.789436340332, -1.41004166496915, 218, 58, 'PPL', 'P'),
(160851, 'Dora', 40.9666709899902, 0.715003292356575, -79.1605606079102, -1.38161242033256, 218, 45, 'PPL', 'P'),
(188438, 'Dora', 33.9386100769043, 0.592340489392506, -103.336112976074, -1.80355540764533, 218, 38, 'PPL', 'P'),
(200712, 'Dora', 43.1561088562012, 0.753216191889795, -123.955001831055, -2.1634229062675, 218, 43, 'PPL', 'P'),
(20630, 'Dora (historical)', 34.9316711425781, 0.609672674661878, -84.1902770996094, -1.46939753355457, 218, 13, 'PPL', 'P'),
(40684, 'Dora (historical)', 30.9791698455811, 0.540688513339933, -92.07861328125, -1.60707497242839, 218, 22, 'PPL', 'P'),
(209949, 'Dora Bay', 55.1888885498047, 0.96322781571029, -132.295272827148, -2.30898809565793, 218, 1, 'PPL', 'P'),
(181182, 'Dora Belle', 37.1127815246582, 0.647740232178607, -119.319999694824, -2.08252685815331, 218, 6, 'PPL', 'P'),
(2077, 'Dora Junction', 33.7608299255371, 0.589237640406455, -87.061393737793, -1.51950797209966, 218, 2, 'PPL', 'P'),
(135034, 'Dora Lake', 47.7386093139648, 0.833195912851918, -94.0400009155273, -1.64130764455443, 218, 28, 'PPL', 'P'),
(101468, 'Dorado', 36.9077796936035, 0.644162275254085, -82.2705612182617, -1.43589217072222, 218, 53, 'PPL', 'P'),
(46639, 'Dorado Hills', 39.0397186279297, 0.681371629109536, -76.4677810668945, -1.33461455131149, 218, 25, 'PPL', 'P'),
(46640, 'Dorado Village', 39.0416717529297, 0.681405717571489, -76.4677810668945, -1.33461455131149, 218, 25, 'PPL', 'P'),
(15808, 'Doral', 25.8191699981689, 0.450629526600186, -80.3555603027344, -1.40246909956757, 218, 12, 'PPL', 'P'),
(101469, 'Doral Acres', 37.3494415283203, 0.651870728450292, -79.2088928222656, -1.38245597660784, 218, 53, 'PPL', 'P'),
(93, 'Doran', 37.0924987792969, 0.647386231490708, -81.833610534668, -1.42826594262467, 218, 53, 'PPL', 'P'),
(135036, 'Doran', 46.1841697692871, 0.80606582477409, -96.4822235107422, -1.68393246990753, 218, 28, 'PPL', 'P'),
(207226, 'Doran', 48.6786117553711, 0.849602050431242, -122.194442749023, -2.13269535361017, 218, 56, 'PPL', 'P'),
(86559, 'Doran Addition', 36.5869407653809, 0.63856257958803, -82.5500030517578, -1.44076935078454, 218, 50, 'PPL', 'P'),
(80717, 'Dorange', 33.2224998474121, 0.579842008080655, -80.7069396972656, -1.4086018269258, 218, 48, 'PPL', 'P'),
(26970, 'Dorans', 39.5511093139648, 0.690297080344882, -88.3444366455078, -1.54190129528365, 218, 18, 'PPL', 'P'),
(20632, 'Doraville', 33.8980598449707, 0.591632754332817, -84.283332824707, -1.47102166234535, 218, 13, 'PPL', 'P'),
(148316, 'Doraville', 42.1502799987793, 0.73566116661621, -75.584716796875, -1.31920217229293, 218, 40, 'PPL', 'P'),
(15809, 'Dorcas', 30.798059463501, 0.53752754086309, -86.4158325195313, -1.50824080331781, 218, 12, 'PPL', 'P'),
(72335, 'Dorcas', 38.9722213745117, 0.68019357980134, -81.8897171020508, -1.4292451869575, 218, 41, 'PPL', 'P'),
(108937, 'Dorcas', 38.9388885498047, 0.679611812261212, -79.1063919067383, -1.38066699814558, 218, 58, 'PPL', 'P'),
(54464, 'Dorcas (historical)', 36.5980606079102, 0.63875665745247, -93.4636077880859, -1.63124768669471, 218, 29, 'PPL', 'P'),
(46648, 'Dorceytown', 39.3875007629395, 0.687441572445072, -77.1438903808594, -1.34641488494358, 218, 25, 'PPL', 'P'),
(40685, 'Dorcheat', 32.6763916015625, 0.570310621118289, -93.3522186279297, -1.62930357909896, 218, 22, 'PPL', 'P'),
(80712, 'Dorchee (historical)', 33.413890838623, 0.583182411035941, -80.290283203125, -1.40132979925323, 218, 48, 'PPL', 'P'),
(20634, 'Dorchester', 33.5019416809082, 0.584719188142972, -82.0522232055664, -1.43208145351843, 218, 13, 'PPL', 'P'),
(26971, 'Dorchester', 39.0855598449707, 0.682171709280023, -89.8874969482422, -1.56883277812318, 218, 18, 'PPL', 'P'),
(46642, 'Dorchester', 38.6180610656738, 0.674012316332238, -76.9436111450195, -1.34291935285479, 218, 25, 'PPL', 'P'),
(64247, 'Dorchester', 36.1586112976074, 0.631086820092069, -80.3894424438477, -1.40306045448762, 218, 33, 'PPL', 'P'),
(70747, 'Dorchester', 39.2727813720703, 0.685439341358523, -74.9772186279297, -1.308599329045, 218, 37, 'PPL', 'P'),
(80714, 'Dorchester', 33.139720916748, 0.578397243189287, -80.3944396972656, -1.40314767301332, 218, 48, 'PPL', 'P'),
(93790, 'Dorchester', 33.5302810668945, 0.585213803736427, -96.6891708374023, -1.68754438213595, 218, 51, 'PPL', 'P'),
(101470, 'Dorchester', 36.9416694641113, 0.644753763332192, -82.6436080932617, -1.44240306695525, 218, 53, 'PPL', 'P'),
(115299, 'Dorchester', 43.4697189331055, 0.758689720299207, -91.5108337402344, -1.59716535001221, 218, 16, 'PPL', 'P'),
(124647, 'Dorchester', 42.2972183227539, 0.738225724166929, -71.0749969482422, -1.24049271259175, 218, 23, 'PPL', 'P'),
(141674, 'Dorchester', 40.6472206115723, 0.709427831456439, -97.1130599975586, -1.69494264364419, 218, 35, 'PPL', 'P'),
(143721, 'Dorchester', 43.7566719055176, 0.763697994466183, -71.9491729736328, -1.25574996247681, 218, 36, 'PPL', 'P'),
(173831, 'Dorchester', 45.003059387207, 0.785451559777304, -90.335563659668, -1.57665301750614, 218, 57, 'PPL', 'P'),
(80715, 'Dorchester (historical)', 32.9500007629395, 0.575086001847937, -80.17138671875, -1.39925466413184, 218, 48, 'PPL', 'P'),
(124649, 'Dorchester Center', 42.2916717529297, 0.738128918261305, -71.0722198486328, -1.24044424305991, 218, 23, 'PPL', 'P'),
(101472, 'Dorchester Court', 37.3080596923828, 0.651148479162663, -79.9569396972656, -1.39551185753584, 218, 53, 'PPL', 'P'),
(80720, 'Dorchester Crossing', 32.9583282470703, 0.575231343864428, -80.1650009155273, -1.39914321084022, 218, 48, 'PPL', 'P'),
(80718, 'Dorchester Estates', 32.9677810668945, 0.575396326693959, -80.1969375610352, -1.39970061045637, 218, 48, 'PPL', 'P'),
(46644, 'Dorchester Heights', 39.2536087036133, 0.685104715167555, -76.6513900756836, -1.33781913305118, 218, 25, 'PPL', 'P'),
(124648, 'Dorchester Heights', 42.3333282470703, 0.738855961238897, -71.0444412231445, -1.23995941458346, 218, 23, 'PPL', 'P'),
(101473, 'Dorchester Junction', 36.9280586242676, 0.644516209362957, -82.654167175293, -1.44258735770268, 218, 53, 'PPL', 'P'),
(80719, 'Dorchester Manor', 32.9244384765625, 0.574639855786321, -80.1022186279297, -1.39804745320971, 218, 48, 'PPL', 'P'),
(46645, 'Dorchester Mobile Home Village', 38.5522193908691, 0.672863162321869, -76.0341720581055, -1.32704664644181, 218, 25, 'PPL', 'P'),
(40687, 'Dorcyville', 30.1791706085205, 0.526725892639784, -91.1594390869141, -1.59103235633786, 218, 22, 'PPL', 'P'),
(198199, 'Dore', 47.9205589294434, 0.836371532714756, -104.030563354492, -1.81567585324045, 218, 34, 'PPL', 'P'),
(155012, 'Dorema', 40.4502792358398, 0.705990556016501, -82.5747222900391, -1.44120078288113, 218, 41, 'PPL', 'P'),
(35609, 'Dorena', 37.0469398498535, 0.646591078168238, -84.9022216796875, -1.48182331056866, 218, 21, 'PPL', 'P'),
(54465, 'Dorena', 36.6161117553711, 0.639071709409426, -89.2372207641602, -1.55748331766364, 218, 29, 'PPL', 'P'),
(200710, 'Dorena', 43.7200012207031, 0.76305797027721, -122.860832214355, -2.14432604388082, 218, 43, 'PPL', 'P'),
(200711, 'Dorena (historical)', 43.7755584716797, 0.764027627230107, -122.927223205566, -2.14548478527111, 218, 43, 'PPL', 'P'),
(54466, 'Dorena Landing', 36.584171295166, 0.638514243214245, -89.2172164916992, -1.55713417724474, 218, 29, 'PPL', 'P'),
(108938, 'Dorfee', 38.4436111450195, 0.670967590836978, -81.1750030517578, -1.41677107356962, 218, 58, 'PPL', 'P'),
(130519, 'Dorgans Crossing', 46.3963890075684, 0.809769749218172, -84.6138916015625, -1.47679100137284, 218, 27, 'PPL', 'P'),
(115300, 'Doris', 42.480281829834, 0.741420785105725, -91.8141708374023, -1.60245958110123, 218, 16, 'PPL', 'P'),
(207227, 'Doris', 46.8677787780762, 0.817997052773754, -120.008613586426, -2.09454543783673, 218, 56, 'PPL', 'P'),
(148317, 'Doris Park', 43.2441711425781, 0.754753168733907, -76.0252838134766, -1.32689151730832, 218, 40, 'PPL', 'P'),
(108940, 'Dority', 39.5011100769043, 0.68942442903469, -79.5547180175781, -1.38849176490239, 218, 58, 'PPL', 'P'),
(203745, 'Dorius Building Condominium', 40.7708282470703, 0.711585191676485, -111.872222900391, -1.95253863113682, 218, 52, 'PPL', 'P'),
(160854, 'Dorlan', 40.0475006103516, 0.698960742845073, -75.7169418334961, -1.32150993453554, 218, 45, 'PPL', 'P'),
(148318, 'Dorloo', 42.7127799987793, 0.745478643658678, -74.6233291625977, -1.30242279268683, 218, 40, 'PPL', 'P'),
(93791, 'Dorman', 29.3819408416748, 0.512811608313419, -96.2186126708984, -1.67933159280831, 218, 51, 'PPL', 'P'),
(127275, 'Dorman', 44.6166687011719, 0.778707770106951, -67.8516693115234, -1.18423503246048, 218, 26, 'PPL', 'P'),
(148319, 'Dormansville', 42.499439239502, 0.741755144980584, -73.995002746582, -1.2914564279501, 218, 40, 'PPL', 'P'),
(54467, 'Dormis', 36.6719398498535, 0.640046093473259, -92.2422180175781, -1.60993041374918, 218, 29, 'PPL', 'P'),
(160852, 'Dormont', 40.3958282470703, 0.705040206981506, -80.033332824707, -1.39684516913559, 218, 45, 'PPL', 'P'),
(72336, 'Dornbusch', 39.2472190856934, 0.684993195296908, -84.601936340332, -1.47658234270144, 218, 41, 'PPL', 'P'),
(72337, 'Dorney (historical)', 39.5577812194824, 0.690413527063546, -82.9411087036133, -1.44759543213258, 218, 41, 'PPL', 'P'),
(160855, 'Dorneyville', 40.5750007629395, 0.708167357312505, -75.5199966430664, -1.31807259251657, 218, 45, 'PPL', 'P'),
(155013, 'Dorninton', 41.0205612182617, 0.715943854274563, -84.2172164916992, -1.46986771464502, 218, 41, 'PPL', 'P'),
(173834, 'Dorns Faro Springs Beach', 44.122501373291, 0.770082923179648, -88.3191680908203, -1.54146027580713, 218, 57, 'PPL', 'P'),
(173833, 'Dorns Twilight Beach', 44.0394401550293, 0.768633231440263, -88.320556640625, -1.54148451057305, 218, 57, 'PPL', 'P'),
(160856, 'Dornsife', 40.7455596923828, 0.711144172199968, -76.789436340332, -1.34022849488938, 218, 45, 'PPL', 'P'),
(80722, 'Dornville (historical)', 33.9186096191406, 0.591991415552624, -82.2411117553711, -1.43537818063184, 218, 48, 'PPL', 'P'),
(8569, 'Dorothy', 35.9086112976074, 0.626723496962083, -90.8191680908203, -1.58509350710699, 218, 4, 'PPL', 'P'),
(70748, 'Dorothy', 39.4005584716797, 0.687669472455355, -74.8241729736328, -1.30592817847165, 218, 37, 'PPL', 'P'),
(108943, 'Dorothy', 37.9550018310547, 0.662439749552381, -81.4497222900391, -1.4215658287962, 218, 58, 'PPL', 'P'),
(135038, 'Dorothy', 47.9277801513672, 0.836497566813344, -96.4463882446289, -1.68330702652553, 218, 28, 'PPL', 'P'),
(160857, 'Dorothy', 40.3027801513672, 0.703416211348776, -79.3936080932617, -1.38567986626543, 218, 45, 'PPL', 'P'),
(124650, 'Dorothy Manor', 42.2166709899902, 0.736819908006504, -71.7563934326172, -1.25238532475561, 218, 23, 'PPL', 'P'),
(124651, 'Dorothy Pond', 42.2205581665039, 0.736887752035273, -71.7602767944336, -1.25245310220535, 218, 23, 'PPL', 'P'),
(108941, 'Dorr', 37.6194381713867, 0.656583058841133, -80.4741668701172, -1.40453917468288, 218, 58, 'PPL', 'P'),
(130520, 'Dorr', 42.7252807617188, 0.745696823130983, -85.7225036621094, -1.49613993195671, 218, 27, 'PPL', 'P'),
(181184, 'Dorr Place', 38.6205596923828, 0.674055925595089, -123.090560913086, -2.14833556605999, 218, 6, 'PPL', 'P'),
(32247, 'Dorrance', 38.8466682434082, 0.678002264277395, -98.5891723632813, -1.72070566455546, 218, 20, 'PPL', 'P'),
(160858, 'Dorrance', 41.1047210693359, 0.717412720773796, -76.0086135864258, -1.32660056695923, 218, 45, 'PPL', 'P'),
(191388, 'Dorras', 33.0010299682617, 0.575976629495487, -100.46981048584, -1.75352899183263, 218, 51, 'PPL', 'P'),
(207228, 'Dorre Don', 47.3980598449707, 0.827252203352052, -122.028327941895, -2.12979610328946, 218, 56, 'PPL', 'P'),
(181185, 'Dorrington', 38.3013916015625, 0.66848539154297, -120.276107788086, -2.09921409238569, 218, 6, 'PPL', 'P'),
(193504, 'Dorris', 41.9674987792969, 0.732471032525432, -121.916938781738, -2.1278519956937, 218, 6, 'PPL', 'P'),
(26974, 'Dorris Heights', 37.749439239502, 0.658852005510853, -88.5530624389648, -1.54554250228406, 218, 18, 'PPL', 'P'),
(26975, 'Dorrisville', 37.7186088562012, 0.658313913812603, -88.5438919067383, -1.54538244630254, 218, 18, 'PPL', 'P'),
(46646, 'Dorrs Corner', 39.0733299255371, 0.681958256918653, -76.6308288574219, -1.3374602720943, 218, 25, 'PPL', 'P'),
(143723, 'Dorrs Corner', 43.752498626709, 0.763625157010369, -71.179443359375, -1.24231564635791, 218, 36, 'PPL', 'P'),
(108942, 'Dorrtown', 38.4838905334473, 0.671670598785732, -80.4225006103516, -1.40363742833778, 218, 58, 'PPL', 'P'),
(113166, 'Dorrville (historical)', 41.6108283996582, 0.726245960056399, -71.9741668701172, -1.25618618826337, 218, 8, 'PPL', 'P'),
(101475, 'Dorset', 37.4680595397949, 0.653941003302693, -77.8055572509766, -1.35796315037849, 218, 53, 'PPL', 'P'),
(135039, 'Dorset', 46.9563903808594, 0.81954361699779, -94.9522171020508, -1.65722882049925, 218, 28, 'PPL', 'P'),
(155014, 'Dorset', 41.6802787780762, 0.727458097826548, -80.6675033569336, -1.40791353294207, 218, 41, 'PPL', 'P'),
(160860, 'Dorset', 40.702220916748, 0.710387767871358, -75.8763885498047, -1.32429280471662, 218, 45, 'PPL', 'P'),
(171905, 'Dorset', 43.2547187805176, 0.754937259744258, -73.0991668701172, -1.2758211423483, 218, 55, 'PPL', 'P'),
(101476, 'Dorset Woods', 37.577220916748, 0.655846228746535, -77.5975036621094, -1.35433193023217, 218, 53, 'PPL', 'P'),
(20636, 'Dorsey', 33.605281829834, 0.586522813991228, -83.5527801513672, -1.45827111283632, 218, 13, 'PPL', 'P'),
(26976, 'Dorsey', 38.9736099243164, 0.680217814567259, -90.0013885498047, -1.57082056156082, 218, 18, 'PPL', 'P'),
(46647, 'Dorsey', 39.1772193908691, 0.683771470146834, -76.7433319091797, -1.33942382076601, 218, 25, 'PPL', 'P'),
(59694, 'Dorsey', 34.2519416809082, 0.597809157532929, -88.5097198486328, -1.54478603137642, 218, 30, 'PPL', 'P'),
(130522, 'Dorsey', 46.3397216796875, 0.808780717768344, -87.0844421386719, -1.51991024258232, 218, 27, 'PPL', 'P'),
(141677, 'Dorsey', 42.6816711425781, 0.744935691691438, -98.3441696166992, -1.71642955995117, 218, 35, 'PPL', 'P'),
(8568, 'Dorsey (historical)', 36.3811111450195, 0.634970175014595, -94.4749984741211, -1.64889978419003, 218, 4, 'PPL', 'P'),
(72338, 'Dorsey (historical)', 39.9180603027344, 0.696701583292359, -80.9166717529297, -1.41226234184411, 218, 41, 'PPL', 'P'),
(194849, 'Dorsey (historical)', 47.4627799987793, 0.828381783128409, -115.747222900391, -2.0201701396516, 218, 17, 'PPL', 'P'),
(46649, 'Dorsey Crossroads', 39.4291687011719, 0.688168815159745, -77.008056640625, -1.34404413894119, 218, 25, 'PPL', 'P'),
(46651, 'Dorsey Hall', 39.2552795410156, 0.685133876781491, -76.8433303833008, -1.34116912338639, 218, 25, 'PPL', 'P'),
(46652, 'Dorsey Heights', 38.9749984741211, 0.680242049333179, -76.5388870239258, -1.33585558437947, 218, 25, 'PPL', 'P'),
(46653, 'Dorsey Hill', 39.3980598449707, 0.687625863192506, -77.0163879394531, -1.34418954753671, 218, 25, 'PPL', 'P'),
(46657, 'Dorseys Run (historical)', 39.313060760498, 0.686142349307277, -76.8313903808594, -1.3409607310311, 218, 25, 'PPL', 'P'),
(80723, 'Dorseytown', 33.6163902282715, 0.586716692118586, -79.4749984741211, -1.38710039639088, 218, 48, 'PPL', 'P'),
(160861, 'Dorseyville', 40.5769386291504, 0.708201179458349, -79.8888931274414, -1.39432422084772, 218, 45, 'PPL', 'P'),
(64248, 'Dort', 36.5294418334961, 0.637559033910261, -76.870002746582, -1.34163464394494, 218, 33, 'PPL', 'P'),
(101477, 'Dortch Store', 36.6580581665039, 0.639803812393089, -78.5550003051758, -1.37104339923047, 218, 53, 'PPL', 'P'),
(64249, 'Dortches', 36.0111083984375, 0.628512408845316, -77.857780456543, -1.35887461726157, 218, 33, 'PPL', 'P'),
(101479, 'Dorter Mill', 36.6202812194824, 0.639144480286213, -82.5255584716797, -1.44034271237791, 218, 53, 'PPL', 'P'),
(35612, 'Dorthae', 36.9933280944824, 0.645655376519238, -84.1047210693359, -1.46790429913136, 218, 21, 'PPL', 'P'),
(35610, 'Dorton', 37.276668548584, 0.650600600347406, -82.5791702270508, -1.44127841402691, 218, 21, 'PPL', 'P'),
(86560, 'Dorton', 35.9527816772461, 0.627494415518634, -84.9561080932617, -1.48276380590762, 218, 50, 'PPL', 'P'),
(35611, 'Dorton Branch', 36.7722206115723, 0.641796322941659, -83.6813888549805, -1.4605157581611, 218, 21, 'PPL', 'P'),
(101478, 'Dorton Fort', 36.7350006103516, 0.641146711372761, -82.4349975585938, -1.43876212627095, 218, 53, 'PPL', 'P'),
(101480, 'Dory', 36.8611106872559, 0.643347747434685, -77.04638671875, -1.34471312500702, 218, 53, 'PPL', 'P'),
(46654, 'Dory Court', 38.6622200012207, 0.674783035151707, -76.5411071777344, -1.33589433337333, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(178103, 'Dos Cabezas', 32.1752815246582, 0.561564600361387, -109.612777709961, -1.91310387329547, 218, 5, 'PPL', 'P'),
(181187, 'Dos Cabezas', 32.7458305358887, 0.571522559151357, -116.139442443848, -2.02701566207559, 218, 6, 'PPL', 'P'),
(181188, 'Dos Palmas Corners', 33.9247207641602, 0.592098075154281, -116.501106262207, -2.0333278864913, 218, 6, 'PPL', 'P'),
(181189, 'Dos Palos', 36.9861106872559, 0.645529408999677, -120.625556945801, -2.10531313075614, 218, 6, 'PPL', 'P'),
(181190, 'Dos Palos Y', 37.0488891601563, 0.646625100051163, -120.634437561035, -2.10546812673158, 218, 6, 'PPL', 'P'),
(181191, 'Dos Rios', 39.7169418334961, 0.69319140381758, -123.35221862793, -2.15290235469726, 218, 6, 'PPL', 'P'),
(188439, 'Dos Tristes', 35.2552795410156, 0.615320706701718, -107.236389160156, -1.87162806879468, 218, 38, 'PPL', 'P'),
(20637, 'Dosaga', 31.5611095428467, 0.550845277105277, -84.1138916015625, -1.46806435511287, 218, 13, 'PPL', 'P'),
(80724, 'Dosheno', 34.4777793884277, 0.601750769104301, -82.4519424438477, -1.43905787031, 218, 48, 'PPL', 'P'),
(59695, 'Doskie', 34.9058303833008, 0.609221668331273, -88.2949981689453, -1.54103843109046, 218, 30, 'PPL', 'P'),
(54469, 'Doss', 37.5761108398438, 0.655826854249605, -91.4847183227539, -1.59670954999164, 218, 29, 'PPL', 'P'),
(93792, 'Doss', 30.4444408416748, 0.531355731615859, -99.1302795410156, -1.7301497664131, 218, 51, 'PPL', 'P'),
(8571, 'Doss (historical)', 35.8263893127441, 0.625288452608694, -90.6416702270508, -1.58199558496895, 218, 4, 'PPL', 'P'),
(40688, 'Doss (historical)', 32.6555595397949, 0.569947033050466, -91.8836135864258, -1.60367158571333, 218, 22, 'PPL', 'P'),
(155016, 'Doss Landing', 40.5027809143066, 0.70690688316857, -84.4902801513672, -1.47463357457377, 218, 41, 'PPL', 'P'),
(86561, 'Dossett', 36.0625, 0.629409361500455, -84.2247161865234, -1.4699986090126, 218, 50, 'PPL', 'P'),
(40689, 'Dossman', 30.8608303070068, 0.538623098756522, -92.2819366455078, -1.61062363458092, 218, 22, 'PPL', 'P'),
(59696, 'Dossville', 32.9305610656738, 0.574746715125061, -89.5497207641602, -1.56293747157613, 218, 30, 'PPL', 'P'),
(2079, 'Doster', 31.6474990844727, 0.552353059045939, -85.6738891601563, -1.49529144883341, 218, 2, 'PPL', 'P'),
(32249, 'Doster', 37.0611114501953, 0.646838419254479, -97.711669921875, -1.70539035775863, 218, 20, 'PPL', 'P'),
(130523, 'Doster', 42.4658317565918, 0.741168583750494, -85.5416717529297, -1.49298381974885, 218, 27, 'PPL', 'P'),
(2080, 'Dosterville', 32.4383316040039, 0.566155690343602, -86.4497222900391, -1.50883229139591, 218, 2, 'PPL', 'P'),
(20638, 'Doswell', 32.2097206115723, 0.562165675819418, -81.3938903808594, -1.42059137815334, 218, 13, 'PPL', 'P'),
(101481, 'Doswell', 37.8600006103516, 0.660781665457698, -77.4644393920898, -1.35200952060356, 218, 53, 'PPL', 'P'),
(35613, 'Dot', 36.6777801513672, 0.640148025963982, -86.9524993896484, -1.51760740718773, 218, 21, 'PPL', 'P'),
(207229, 'Dot', 45.8666687011719, 0.80052438575688, -120.344169616699, -2.10040199538992, 218, 56, 'PPL', 'P'),
(211795, 'Dot Lake', 63.6613883972168, 1.11110083392235, -144.064437866211, -2.51439877580018, 218, 1, 'PPL', 'P'),
(211796, 'Dot Lake Village', 63.6508293151855, 1.11091654317492, -144.043884277344, -2.51404004800134, 218, 1, 'PPL', 'P'),
(8572, 'Dota', 35.7944412231445, 0.624730853255458, -91.3777770996094, -1.59484307354166, 218, 4, 'PPL', 'P'),
(139121, 'Dotham', 40.3352813720703, 0.703983464660963, -95.2361068725586, -1.66218363170735, 218, 29, 'PPL', 'P'),
(2081, 'Dothan', 31.2230606079102, 0.544945210157775, -85.3905563354492, -1.49034635816329, 218, 2, 'PPL', 'P'),
(64250, 'Dothan', 34.0333290100098, 0.593993646639173, -78.7477798461914, -1.37440803695167, 218, 33, 'PPL', 'P'),
(80725, 'Dothan', 34.4008293151855, 0.600407736966574, -79.4336090087891, -1.3863780139452, 218, 48, 'PPL', 'P'),
(93793, 'Dothan', 32.5566711425781, 0.568221104927013, -99.0966720581055, -1.72956320518301, 218, 51, 'PPL', 'P'),
(108944, 'Dothan', 37.9672203063965, 0.662653002176669, -81.2222213745117, -1.41759518876894, 218, 58, 'PPL', 'P'),
(171907, 'Dothan', 43.6972198486328, 0.762660360326461, -72.3436126708984, -1.26263423389467, 218, 55, 'PPL', 'P'),
(186631, 'Dotsero', 39.6497192382813, 0.692018148199346, -107.059722900391, -1.86854466088459, 218, 7, 'PPL', 'P'),
(8574, 'Dotson', 33.9225006103516, 0.592059326160421, -93.5983276367188, -1.63359899162115, 218, 4, 'PPL', 'P'),
(35614, 'Dotson', 37.6469383239746, 0.657063027048593, -82.8580627441406, -1.4461460067093, 218, 21, 'PPL', 'P'),
(86562, 'Dotson', 36.3355598449707, 0.634175154850179, -83.4972229003906, -1.45730145588343, 218, 50, 'PPL', 'P'),
(93795, 'Dotson', 32.0047187805176, 0.558587718894896, -94.5297164916992, -1.64985479375693, 218, 51, 'PPL', 'P'),
(135040, 'Dotson', 44.1719398498535, 0.770945787372834, -94.9944381713867, -1.65796571717288, 218, 28, 'PPL', 'P'),
(8575, 'Dotson Station (historical)', 33.9102783203125, 0.591846006957105, -93.6152801513672, -1.63389486881825, 218, 4, 'PPL', 'P'),
(46655, 'Dotsons Ridge', 39.4550018310547, 0.688619688332296, -77.091667175293, -1.3455034180605, 218, 25, 'PPL', 'P'),
(86563, 'Dotsontown', 36.2383308410645, 0.632478188603581, -82.6655578613281, -1.44278616267806, 218, 50, 'PPL', 'P'),
(86564, 'Dotsonville', 36.4824981689453, 0.636739712400898, -87.4863891601563, -1.5269255415258, 218, 50, 'PPL', 'P'),
(196369, 'Dotsonville (historical)', 46.5999984741211, 0.813323404797747, -112.094436645508, -1.9564169926323, 218, 31, 'PPL', 'P'),
(78138, 'Dott', 39.8141708374023, 0.694888370064179, -78.1891708374023, -1.364658470517, 218, 45, 'PPL', 'P'),
(93796, 'Dott', 31.2613906860352, 0.545614196223602, -97.1245269775391, -1.69514278020011, 218, 51, 'PPL', 'P'),
(108945, 'Dott', 37.4686088562012, 0.653950590682617, -81.2461090087891, -1.4180121066376, 218, 58, 'PPL', 'P'),
(160862, 'Dotter', 41.211669921875, 0.719279330381833, -79.7230606079102, -1.39142989737502, 218, 45, 'PPL', 'P'),
(160863, 'Dotters Corners', 40.9447212219238, 0.714620196633767, -75.5205612182617, -1.31808244621261, 218, 45, 'PPL', 'P'),
(11, 'Doty', 30.1599998474121, 0.526391299738329, -93.9458312988281, -1.63966407468769, 218, 51, 'PPL', 'P'),
(130524, 'Doty', 46.3627815246582, 0.809183187988082, -86.5352783203125, -1.51032552581912, 218, 27, 'PPL', 'P'),
(207230, 'Doty', 46.6347198486328, 0.813929407103794, -123.276390075684, -2.15157889679354, 218, 56, 'PPL', 'P'),
(59697, 'Doty Springs (historical)', 33.0527801513672, 0.576879840579187, -89.3597183227539, -1.55962130338676, 218, 30, 'PPL', 'P'),
(75672, 'Dotyville', 36.8588905334473, 0.643308998440824, -94.9086074829102, -1.65646768905971, 218, 42, 'PPL', 'P'),
(160864, 'Dotyville', 41.6699981689453, 0.727278667348104, -79.6002807617188, -1.38928698480389, 218, 45, 'PPL', 'P'),
(173836, 'Dotyville', 43.7522201538086, 0.76362029674138, -88.2608337402344, -1.54044214932239, 218, 57, 'PPL', 'P'),
(200713, 'Dotyville (historical)', 44.6541709899902, 0.779362308523865, -122.804168701172, -2.14333707901002, 218, 43, 'PPL', 'P'),
(127276, 'Double A Landing', 44.9002799987793, 0.783657721046054, -68.8030624389648, -1.20083997501518, 218, 26, 'PPL', 'P'),
(178104, 'Double Adobe', 31.4666690826416, 0.5491969801276, -109.689437866211, -1.91444184542712, 218, 5, 'PPL', 'P'),
(188440, 'Double Adobes', 31.6450004577637, 0.552309449783089, -108.755279541016, -1.89813770691755, 218, 38, 'PPL', 'P'),
(93797, 'Double Bayou', 29.6924991607666, 0.51823187350103, -94.6288909912109, -1.65158571530743, 218, 51, 'PPL', 'P'),
(113167, 'Double Beach', 41.2580604553223, 0.720088997932244, -72.8324966430664, -1.27116686886923, 218, 8, 'PPL', 'P'),
(20640, 'Double Branches', 33.7519416809082, 0.589082511272958, -82.3330612182617, -1.43698300150472, 218, 13, 'PPL', 'P'),
(2083, 'Double Bridges', 34.2322196960449, 0.597464943962036, -86.1236114501953, -1.5031405835142, 218, 2, 'PPL', 'P'),
(86565, 'Double Bridges', 35.9049987792969, 0.626660446623275, -89.45361328125, -1.56126007956354, 218, 50, 'PPL', 'P'),
(20641, 'Double Churches', 32.5566711425781, 0.568221104927013, -84.9763870239258, -1.48311774001649, 218, 13, 'PPL', 'P'),
(59698, 'Double Churches (historical)', 31.5544395446777, 0.550728863676127, -89.6486129760742, -1.56466346627861, 218, 30, 'PPL', 'P'),
(46658, 'Double Creek Wood', 39.2400016784668, 0.684867227777347, -75.978889465332, -1.32608178317888, 218, 25, 'PPL', 'P'),
(188441, 'Double Crossing', 33.5261116027832, 0.58514103285964, -105.439720153809, -1.84027027906538, 218, 38, 'PPL', 'P'),
(35615, 'Double Culvert', 38.3594398498535, 0.669498524600663, -84.5641708374023, -1.47592321033164, 218, 21, 'PPL', 'P'),
(198200, 'Double Ditch Indian Village', 46.9363899230957, 0.819194543157908, -100.90055847168, -1.76104696243187, 218, 34, 'PPL', 'P'),
(20642, 'Double E Mobile Home Park', 33.538330078125, 0.585354285483928, -84.4208297729492, -1.47342143680362, 218, 13, 'PPL', 'P'),
(93798, 'Double Ford', 31.2894401550293, 0.546103751810986, -98.5975036621094, -1.72085107315098, 218, 51, 'PPL', 'P'),
(20643, 'Double Heads', 32.649169921875, 0.569835513179819, -81.6936111450195, -1.42582249232453, 218, 13, 'PPL', 'P'),
(46659, 'Double Hills Estates', 38.8563919067383, 0.67817197421786, -75.8138885498047, -1.32320197393412, 218, 25, 'PPL', 'P'),
(64251, 'Double Island', 35.9550018310547, 0.627533164512494, -82.2044372558594, -1.43473808986384, 218, 33, 'PPL', 'P'),
(188442, 'Double Mills', 35.065559387207, 0.612009465360368, -104.522499084473, -1.82426175143681, 218, 38, 'PPL', 'P'),
(191389, 'Double Mountain', 33.1358299255371, 0.57832933258149, -100.409172058105, -1.75247065161543, 218, 51, 'PPL', 'P'),
(93799, 'Double Oak', 33.064998626709, 0.577093093203475, -97.1102828979492, -1.69489417411235, 218, 51, 'PPL', 'P'),
(46660, 'Double Oak Estates', 38.5466690063477, 0.672766289837218, -76.5322189331055, -1.33573920423983, 218, 25, 'PPL', 'P'),
(20644, 'Double Run', 31.858060836792, 0.55602805490268, -83.5583267211914, -1.45836791874195, 218, 13, 'PPL', 'P'),
(64252, 'Double Shoals', 35.3808288574219, 0.617511955646635, -81.5483322143555, -1.42328689665066, 218, 33, 'PPL', 'P'),
(2084, 'Double Springs', 34.1463890075684, 0.595966915848867, -87.4022216796875, -1.52545654186852, 218, 2, 'PPL', 'P'),
(59699, 'Double Springs', 33.4813919067383, 0.584360526923165, -89.0608291625977, -1.55440470344351, 218, 30, 'PPL', 'P'),
(80726, 'Double Springs', 34.5038909912109, 0.602206502545841, -82.876106262207, -1.4464609255082, 218, 48, 'PPL', 'P'),
(86569, 'Double Springs', 36.4347190856934, 0.635905810084567, -82.5650024414063, -1.4410311395197, 218, 50, 'PPL', 'P'),
(20645, 'Double Springs (historical)', 34.1944389343262, 0.596805545276133, -84.7130584716797, -1.47852178976529, 218, 13, 'PPL', 'P'),
(190128, 'Double Springs (historical)', 38.7916717529297, 0.677042394441503, -119.597221374512, -2.08736528922177, 218, 39, 'PPL', 'P'),
(86570, 'Double Top', 36.4861106872559, 0.636802762739706, -85.0566711425781, -1.48451896222404, 218, 50, 'PPL', 'P'),
(46661, 'Double Tree Estates', 39.3777809143066, 0.687271929083634, -77.3691711425781, -1.35034677597697, 218, 25, 'PPL', 'P'),
(70749, 'Double Trouble', 39.8977813720703, 0.696347649183488, -74.2211074829102, -1.29540270005338, 218, 37, 'PPL', 'P'),
(8576, 'Double Wells', 34.1549987792969, 0.596117184713374, -92.1958312988281, -1.60912081277779, 218, 4, 'PPL', 'P'),
(115301, 'Doubleday', 43.0863914489746, 0.751999393587737, -92.6333312988281, -1.61675662825527, 218, 16, 'PPL', 'P'),
(8577, 'Doubleday (historical)', 35.1805610656738, 0.614016623294933, -94.3855590820313, -1.64733877231708, 218, 4, 'PPL', 'P'),
(20648, 'Doublegate', 32.5513916015625, 0.568128959553296, -83.646110534668, -1.45990003531707, 218, 13, 'PPL', 'P'),
(2086, 'Doublehead', 33.0941696166992, 0.577602223024871, -85.394172668457, -1.49040947508113, 218, 2, 'PPL', 'P'),
(2087, 'Doubleheads Village (historical)', 34.8208312988281, 0.607738154446044, -87.9513931274414, -1.53504139178977, 218, 2, 'PPL', 'P'),
(178105, 'Doubletree Canyon', 33.5638885498047, 0.585800364966517, -111.982223510742, -1.95445850396665, 218, 5, 'PPL', 'P'),
(80727, 'Doubling (historical)', 34.5472183227539, 0.602962707137369, -82.0694427490234, -1.43238199124745, 218, 48, 'PPL', 'P'),
(160865, 'Doubling Gap', 40.2805595397949, 0.703028388515033, -77.4194412231445, -1.3512241543981, 218, 45, 'PPL', 'P'),
(46662, 'Doubs', 39.3038902282715, 0.685982293325763, -77.4883270263672, -1.35242643847221, 218, 25, 'PPL', 'P'),
(46663, 'Doubs Mill', 39.5780601501465, 0.690767461172418, -77.6544418334961, -1.35532568879293, 218, 25, 'PPL', 'P'),
(93800, 'Doucette', 30.8180599212646, 0.537876614702973, -94.4286117553711, -1.64809018321865, 218, 51, 'PPL', 'P'),
(191392, 'Doud', 33.5544395446777, 0.585635448716013, -101.936111450195, -1.7791207714858, 218, 51, 'PPL', 'P'),
(115302, 'Douds', 40.8394393920898, 0.712782682060639, -92.0863876342773, -1.60721066048593, 218, 16, 'PPL', 'P'),
(181192, 'Douds Landing', 38.2127799987793, 0.666938827318934, -120.324440002441, -2.10005764866098, 218, 6, 'PPL', 'P'),
(35616, 'Dougan Town', 36.8002815246582, 0.642286078266124, -85.3638916015625, -1.4898809707628, 218, 21, 'PPL', 'P'),
(199279, 'Doughboy', 42.6130599975586, 0.743738201307284, -101.276672363281, -1.7676113882028, 218, 35, 'PPL', 'P'),
(20649, 'Dougherty', 34.3822212219238, 0.600082964471639, -84.0650024414063, -1.46721107829961, 218, 13, 'PPL', 'P'),
(75673, 'Dougherty', 34.3994407653809, 0.600383502200654, -97.0552825927734, -1.69393423769744, 218, 42, 'PPL', 'P'),
(115303, 'Dougherty', 42.9222183227539, 0.749134031991894, -93.0419387817383, -1.62388817418033, 218, 16, 'PPL', 'P'),
(160866, 'Dougherty', 40.6175003051758, 0.708909114255119, -78.4608306884766, -1.36939982936373, 218, 45, 'PPL', 'P'),
(181194, 'Dougherty', 38.1624984741211, 0.666061249160725, -121.242218017578, -2.11607589682753, 218, 6, 'PPL', 'P'),
(191390, 'Dougherty', 33.9416694641113, 0.592393885772362, -101.086112976074, -1.76428549947546, 218, 51, 'PPL', 'P'),
(130525, 'Doughertys Corners', 42.2955589294434, 0.738196762290075, -85.7163925170898, -1.49603327235505, 218, 27, 'PPL', 'P'),
(160867, 'Doughertys Mills', 41.0377807617188, 0.716244392003579, -80.0299987792969, -1.39678697906577, 218, 45, 'PPL', 'P'),
(35617, 'Doughton', 38.6438903808594, 0.674463122925762, -84.4986114501953, -1.47477898316929, 218, 21, 'PPL', 'P'),
(64254, 'Doughton', 36.3741683959961, 0.634849001184996, -80.9572219848633, -1.4129700769038, 218, 33, 'PPL', 'P'),
(155017, 'Doughton (historical)', 41.165828704834, 0.718479250211346, -80.5922164916992, -1.40659952926022, 218, 41, 'PPL', 'P'),
(70750, 'Doughty', 39.4452781677246, 0.688449978391831, -74.8619384765625, -1.30658731084144, 218, 37, 'PPL', 'P'),
(127277, 'Doughty Landing', 43.6986083984375, 0.762684595092381, -70.1516723632813, -1.22437765851957, 218, 26, 'PPL', 'P'),
(2089, 'Douglas', 34.1736106872559, 0.596442023787337, -86.3236083984375, -1.50663118875496, 218, 2, 'PPL', 'P'),
(8578, 'Douglas', 34.0419387817383, 0.59414391550368, -91.5344390869141, -1.59757734103284, 218, 4, 'PPL', 'P'),
(20651, 'Douglas', 31.5086097717285, 0.549928983242722, -82.8499984741211, -1.44600525864569, 218, 13, 'PPL', 'P'),
(29654, 'Douglas', 38.3305587768555, 0.668994454785338, -87.5016708374023, -1.52719225710897, 218, 19, 'PPL', 'P'),
(35618, 'Douglas', 37.3794403076172, 0.652394305920602, -82.5425033569336, -1.44063845641696, 218, 21, 'PPL', 'P'),
(40692, 'Douglas', 32.5813903808594, 0.568652537023605, -92.5266723632813, -1.6148950786533, 218, 22, 'PPL', 'P'),
(75675, 'Douglas', 36.1836090087891, 0.631523112457651, -95.8805618286133, -1.6734314925713, 218, 42, 'PPL', 'P'),
(80728, 'Douglas', 34.6647186279297, 0.605013474334784, -80.8097229003906, -1.41039573223608, 218, 48, 'PPL', 'P'),
(86572, 'Douglas', 35.8713912963867, 0.626073885393185, -86.8455581665039, -1.51574093073774, 218, 50, 'PPL', 'P'),
(93804, 'Douglas', 32.350830078125, 0.564628500616496, -95.0680618286133, -1.65925069239884, 218, 51, 'PPL', 'P'),
(108947, 'Douglas', 38.6722183227539, 0.674957538782135, -81.0580596923828, -1.41473002691018, 218, 58, 'PPL', 'P'),
(119394, 'Douglas', 40.7861099243164, 0.711851907259657, -90.0841674804688, -1.57226532645218, 218, 18, 'PPL', 'P'),
(124652, 'Douglas', 42.0541687011719, 0.733983708024597, -71.7399978637695, -1.25209916809648, 218, 23, 'PPL', 'P'),
(130527, 'Douglas', 44.3222198486328, 0.773568668151425, -86.2233276367188, -1.50488095928656, 218, 27, 'PPL', 'P'),
(135041, 'Douglas', 44.1080589294434, 0.769830854982472, -92.5736083984375, -1.61571426700461, 218, 28, 'PPL', 'P'),
(139122, 'Douglas', 40.1044387817383, 0.699954501405837, -94.5966720581055, -1.65102338884326, 218, 29, 'PPL', 'P'),
(141678, 'Douglas', 40.5955581665039, 0.708526151690366, -96.3872222900391, -1.68227438581285, 218, 35, 'PPL', 'P'),
(155031, 'Douglas', 40.9422187805176, 0.714576520791889, -84.3008270263672, -1.47132699376433, 218, 41, 'PPL', 'P'),
(178106, 'Douglas', 31.3444404602051, 0.547063688225905, -109.544723510742, -1.91191610344929, 218, 5, 'PPL', 'P'),
(190130, 'Douglas', 38.8544387817383, 0.678137885755907, -115.143608093262, -2.00963507385341, 218, 39, 'PPL', 'P'),
(198201, 'Douglas', 47.8572196960449, 0.835266054546264, -101.502502441406, -1.77155286661612, 218, 34, 'PPL', 'P'),
(207231, 'Douglas', 47.6213912963867, 0.831150072502519, -120.003608703613, -2.09445808615298, 218, 56, 'PPL', 'P'),
(209412, 'Douglas', 42.7597198486328, 0.746297898589014, -105.38166809082, -1.83925707942866, 218, 59, 'PPL', 'P'),
(209950, 'Douglas', 58.2755584716797, 1.01710036876929, -134.392501831055, -2.34559164694441, 218, 1, 'PPL', 'P'),
(155018, 'Douglas (historical)', 40.9161109924316, 0.714120853929377, -81.871940612793, -1.4289349286905, 218, 41, 'PPL', 'P'),
(196370, 'Douglas (historical)', 48.8611106872559, 0.852787257674004, -113.215278625488, -1.97597937557753, 218, 31, 'PPL', 'P'),
(173838, 'Douglas Center', 43.7008285522461, 0.762723344086241, -89.5552825927734, -1.56303454379786, 218, 57, 'PPL', 'P'),
(15811, 'Douglas City', 30.5938892364502, 0.53396409816651, -84.6416702270508, -1.47727582984929, 218, 12, 'PPL', 'P'),
(193505, 'Douglas City', 40.6522216796875, 0.709515116561167, -122.94361114502, -2.14577080877219, 218, 6, 'PPL', 'P'),
(170180, 'Douglas City (historical)', 43.3791694641113, 0.757109333929327, -98.3152770996094, -1.71592529039876, 218, 49, 'PPL', 'P'),
(8579, 'Douglas Corner', 34.7099990844727, 0.605803767388265, -92.4113922119141, -1.61288306044975, 218, 4, 'PPL', 'P'),
(124653, 'Douglas Corner', 41.7752799987793, 0.729116181921232, -70.7919387817383, -1.2355524156116, 218, 23, 'PPL', 'P'),
(148320, 'Douglas Crossing', 44.1819381713867, 0.771120291003261, -75.8191680908203, -1.32329411930784, 218, 40, 'PPL', 'P'),
(64258, 'Douglas Crossroads', 35.5286102294922, 0.620091227162377, -76.9497222900391, -1.34302601245645, 218, 33, 'PPL', 'P'),
(20653, 'Douglas Estates', 33.6749992370605, 0.587739612293285, -84.7227783203125, -1.47869143312672, 218, 13, 'PPL', 'P'),
(86573, 'Douglas Estates', 35.9988899230957, 0.628299156221028, -83.3611068725586, -1.45492578303302, 218, 50, 'PPL', 'P'),
(181195, 'Douglas Flat', 38.1144409179688, 0.665222486575405, -120.453887939453, -2.10231694137175, 218, 6, 'PPL', 'P'),
(13674, 'Douglas Forge', 38.6458282470703, 0.674496945071606, -75.5777816772461, -1.31908113162139, 218, 10, 'PPL', 'P'),
(108948, 'Douglas Grove', 39.4188919067383, 0.687989451260329, -77.9577789306641, -1.36061991988195, 218, 58, 'PPL', 'P'),
(127278, 'Douglas Hill', 43.8797187805176, 0.765845567569223, -70.6997222900391, -1.23394293420681, 218, 26, 'PPL', 'P'),
(181196, 'Douglas Junction', 33.8558311462402, 0.590895724501138, -118.163887023926, -2.06234888552211, 218, 6, 'PPL', 'P'),
(101482, 'Douglas Landing', 36.6372184753418, 0.639440091167211, -76.3733291625977, -1.33296605459673, 218, 53, 'PPL', 'P'),
(101483, 'Douglas Park', 36.815559387207, 0.642552727270269, -76.3397216796875, -1.33237949336664, 218, 53, 'PPL', 'P'),
(119396, 'Douglas Park', 41.7938919067383, 0.729441020995194, -89.7344436645508, -1.56616149439178, 218, 18, 'PPL', 'P'),
(193506, 'Douglas Park', 41.7874984741211, 0.72932943454552, -124.061668395996, -2.16528458902752, 218, 6, 'PPL', 'P'),
(20654, 'Douglas Ridge', 33.7055587768555, 0.588272976880601, -84.7675018310547, -1.47947200564223, 218, 13, 'PPL', 'P'),
(32253, 'Douglass', 37.5194396972656, 0.65483775622075, -97.0124969482422, -1.69318748732778, 218, 20, 'PPL', 'P'),
(80734, 'Douglass', 34.458610534668, 0.60141620949236, -81.248893737793, -1.41806070932749, 218, 48, 'PPL', 'P'),
(93802, 'Douglass', 31.6677799224854, 0.552707026444324, -94.8805618286133, -1.65597820005135, 218, 51, 'PPL', 'P'),
(115322, 'Douglass', 43.0083312988281, 0.75063698695308, -91.8711090087891, -1.60345333966199, 218, 16, 'PPL', 'P'),
(160868, 'Douglass', 40.2438888549805, 0.70238836432606, -79.8125, -1.39299090924797, 218, 45, 'PPL', 'P'),
(155019, 'Douglass (historical)', 40.8224983215332, 0.712487004600613, -83.2225036621094, -1.45250670065685, 218, 41, 'PPL', 'P'),
(15812, 'Douglass Crossroads', 30.6875, 0.53559791420576, -85.9766693115234, -1.50057595938445, 218, 12, 'PPL', 'P'),
(20655, 'Douglass Crossroads', 31.3033294677734, 0.546346166049211, -84.6733322143555, -1.47782843577548, 218, 13, 'PPL', 'P'),
(13073, 'Douglass Dwellings', 38.848331451416, 0.678031292733277, -76.9780578613281, -1.34352056147088, 218, 9, 'PPL', 'P'),
(35619, 'Douglass Hills', 38.2377815246582, 0.667375186263543, -85.5527801513672, -1.49317769787621, 218, 21, 'PPL', 'P'),
(101484, 'Douglass Park', 38.8497200012207, 0.678055527499197, -77.0933303833008, -1.34553244651638, 218, 53, 'PPL', 'P'),
(93803, 'Douglassville', 33.1919403076172, 0.579308643493339, -94.3533325195313, -1.64677631269486, 218, 51, 'PPL', 'P'),
(160870, 'Douglassville', 40.2577781677246, 0.702630778564284, -75.7266693115234, -1.32167971105503, 218, 45, 'PPL', 'P'),
(160871, 'Douglassville (historical)', 40.7750015258789, 0.711658029132299, -75.336669921875, -1.3148729376249, 218, 45, 'PPL', 'P'),
(148321, 'Douglaston', 40.7686080932617, 0.711546442682624, -73.7474975585938, -1.28713664750394, 218, 40, 'PPL', 'P'),
(2091, 'Douglasville', 33.5541687011719, 0.585630721605079, -86.7983322143555, -1.51491668238036, 218, 2, 'PPL', 'P'),
(8580, 'Douglasville', 34.7144393920898, 0.605881265375987, -92.3597183227539, -1.61198118094659, 218, 4, 'PPL', 'P'),
(20657, 'Douglasville', 31.3597202301025, 0.547330370519563, -84.670280456543, -1.47777517255368, 218, 13, 'PPL', 'P'),
(46664, 'Douglynn Farms', 38.3977813720703, 0.670167710403573, -75.1750030517578, -1.31205131844996, 218, 25, 'PPL', 'P'),
(46665, 'Douglynne Woods', 38.3488883972168, 0.669314367011284, -75.2127838134766, -1.31271071713586, 218, 25, 'PPL', 'P'),
(191391, 'Douro', 31.7616691589355, 0.554345702752563, -102.525283813477, -1.78940376908681, 218, 51, 'PPL', 'P'),
(173840, 'Dousman', 43.0141716003418, 0.750738919443803, -88.4725036621094, -1.54413648638655, 218, 57, 'PPL', 'P'),
(75676, 'Douthat', 36.959171295166, 0.645059227909224, -94.8358306884766, -1.6551974943778, 218, 42, 'PPL', 'P'),
(188443, 'Douthit Place', 35.2638893127441, 0.615470975566226, -105.657783508301, -1.84407620257921, 218, 38, 'PPL', 'P'),
(141685, 'Douthit Trailer Court', 42.4577789306641, 0.741028035423965, -98.647216796875, -1.72171873103412, 218, 35, 'PPL', 'P'),
(2092, 'Douthrittville (historical)', 33.8944396972656, 0.591569570835955, -85.9361114501953, -1.49986809116671, 218, 2, 'PPL', 'P'),
(2093, 'Dove', 32.4913902282715, 0.567081738033649, -88.3913879394531, -1.54272074995106, 218, 2, 'PPL', 'P'),
(54472, 'Dove', 37.790828704834, 0.659574387956537, -92.682502746582, -1.61761483191654, 218, 29, 'PPL', 'P'),
(86574, 'Dove (historical)', 36.2583312988281, 0.632827262443463, -82.4472198486328, -1.43897544547426, 218, 50, 'PPL', 'P'),
(181197, 'Dove (historical)', 35.4505615234375, 0.618729020264801, -120.631942749023, -2.10542458404776, 218, 6, 'PPL', 'P'),
(181198, 'Dove Canyon', 33.6316719055176, 0.586983407701757, -117.565559387207, -2.05190609825569, 218, 6, 'PPL', 'P'),
(20659, 'Dove Cove', 32.6030616760254, 0.569030772477424, -83.7063903808594, -1.46095211710571, 218, 13, 'PPL', 'P'),
(20658, 'Dove Creek', 34.079719543457, 0.594803314189584, -82.9422225952148, -1.44761487320854, 218, 13, 'PPL', 'P'),
(186633, 'Dove Creek', 37.7661094665527, 0.659142955859945, -108.905281066895, -1.90075572742715, 218, 7, 'PPL', 'P'),
(40693, 'Dove Landing', 30.9561100006104, 0.540286043120194, -92.4786071777344, -1.61405618290993, 218, 22, 'PPL', 'P'),
(20660, 'Dove Rest', 33.5666694641113, 0.585848901077383, -84.2247161865234, -1.4699986090126, 218, 13, 'PPL', 'P'),
(46666, 'Dove Ridge', 39.5880584716797, 0.690941964802845, -76.92138671875, -1.34253146344202, 218, 25, 'PPL', 'P'),
(80730, 'Dove Tree', 34.8458290100098, 0.608174446811627, -82.290283203125, -1.43623638429312, 218, 48, 'PPL', 'P'),
(178107, 'Dove Valley Ranch', 33.7994384765625, 0.589911486741272, -111.978057861328, -1.9543857996689, 218, 5, 'PPL', 'P'),
(8583, 'Dover', 35.4013900756836, 0.617870816603523, -93.1141662597656, -1.62514878148232, 218, 4, 'PPL', 'P'),
(13672, 'Dover', 39.1580581665039, 0.683437043692947, -75.5247192382813, -1.31815501735231, 218, 10, 'PPL', 'P'),
(15813, 'Dover', 27.9938907623291, 0.488585564246268, -82.2197189331055, -1.43500480544701, 218, 12, 'PPL', 'P'),
(20661, 'Dover', 32.5769386291504, 0.568574839298802, -81.7152786254883, -1.42620066119932, 218, 13, 'PPL', 'P'),
(32255, 'Dover', 38.9647216796875, 0.680062685433762, -95.9372177124023, -1.67442032428404, 218, 20, 'PPL', 'P'),
(35621, 'Dover', 38.7580604553223, 0.676455766632386, -83.883056640625, -1.4640355250158, 218, 21, 'PPL', 'P'),
(46667, 'Dover', 39.5122184753418, 0.689618307162048, -76.7697219848633, -1.33988441447654, 218, 25, 'PPL', 'P'),
(59702, 'Dover', 32.584171295166, 0.568701073134472, -89.2141723632813, -1.55708104718099, 218, 30, 'PPL', 'P'),
(64257, 'Dover', 35.4438896179199, 0.618612573546138, -79.7225036621094, -1.39142017683705, 218, 33, 'PPL', 'P'),
(75677, 'Dover', 35.9813919067383, 0.627993758223024, -97.9108276367188, -1.7088663156134, 218, 42, 'PPL', 'P'),
(86576, 'Dover', 36.214168548584, 0.632056477044967, -83.2144393920898, -1.45236595259324, 218, 50, 'PPL', 'P'),
(101486, 'Dover', 38.976390838623, 0.680266350678126, -77.6747207641602, -1.3556796229018, 218, 53, 'PPL', 'P'),
(115323, 'Dover', 41.8480606079102, 0.730386443182172, -92.2930603027344, -1.61081777902439, 218, 16, 'PPL', 'P'),
(119398, 'Dover', 41.4366683959961, 0.723206294567209, -89.3933334350586, -1.56020799777491, 218, 18, 'PPL', 'P'),
(122514, 'Dover', 40.0544395446777, 0.699081850095645, -86.620002746582, -1.51180424601439, 218, 19, 'PPL', 'P'),
(124655, 'Dover', 42.2458305358887, 0.737328838090818, -71.283332824707, -1.24412885958609, 218, 23, 'PPL', 'P'),
(127279, 'Dover', 43.9230613708496, 0.76660203847686, -69.6383285522461, -1.21541811882227, 218, 26, 'PPL', 'P'),
(130529, 'Dover', 42.4025001525879, 0.740063238740057, -83.9108276367188, -1.46452022033419, 218, 27, 'PPL', 'P'),
(135044, 'Dover', 43.9736099243164, 0.767484277166976, -92.1388931274414, -1.60812705421703, 218, 28, 'PPL', 'P'),
(139123, 'Dover', 40.0122184753418, 0.69834495342202, -91.5961074829102, -1.5986536575874, 218, 29, 'PPL', 'P'),
(139895, 'Dover', 47.4602813720703, 0.828338173865559, -99.2758331298828, -1.73269015577692, 218, 34, 'PPL', 'P'),
(143725, 'Dover', 43.1977806091309, 0.753943501183495, -70.8741683959961, -1.23698759312304, 218, 36, 'PPL', 'P'),
(145100, 'Dover', 40.8838882446289, 0.713558460886179, -74.5625, -1.30136112351827, 218, 37, 'PPL', 'P'),
(155020, 'Dover', 40.5205612182617, 0.707217208014592, -81.4741668701172, -1.42199246720283, 218, 41, 'PPL', 'P'),
(160872, 'Dover', 40.0016708374023, 0.698160862411668, -76.8505630493164, -1.34129535722206, 218, 45, 'PPL', 'P'),
(171908, 'Dover', 42.9436111450195, 0.749507407176723, -72.804443359375, -1.27067724670282, 218, 55, 'PPL', 'P'),
(173842, 'Dover', 45.6716690063477, 0.797120999041814, -90.1875, -1.57406881914239, 218, 57, 'PPL', 'P'),
(194161, 'Dover', 40.7794418334961, 0.71173552712002, -104.811943054199, -1.82931350170858, 218, 7, 'PPL', 'P'),
(194850, 'Dover', 48.2516708374023, 0.8421505257012, -116.610000610352, -2.03522845140323, 218, 17, 'PPL', 'P'),
(196371, 'Dover', 47.2205581665039, 0.82415421463499, -110.267501831055, -1.92453096490078, 218, 31, 'PPL', 'P'),
(200715, 'Dover', 45.3313903808594, 0.791182016652882, -122.227783203125, -2.13327725430835, 218, 43, 'PPL', 'P'),
(59701, 'Dover (historical)', 32.9874992370605, 0.575740473685824, -90.3708267211914, -1.57726847403406, 218, 30, 'PPL', 'P'),
(80732, 'Dover (historical)', 34.4577789306641, 0.601401695264419, -81.8244400024414, -1.42810588664316, 218, 48, 'PPL', 'P'),
(115324, 'Dover (historical)', 40.7311096191406, 0.710891970844737, -92.2069396972656, -1.60931469090515, 218, 16, 'PPL', 'P'),
(46668, 'Dover Acres', 38.7700004577637, 0.676664158987685, -76.0494384765625, -1.32731309570888, 218, 25, 'PPL', 'P'),
(70751, 'Dover Beaches North', 39.9911117553711, 0.697976571664235, -74.0641708374023, -1.29266363887224, 218, 37, 'PPL', 'P'),
(70752, 'Dover Beaches South', 39.9555587768555, 0.697356055130246, -74.0747222900391, -1.29284779646162, 218, 37, 'PPL', 'P'),
(20662, 'Dover Bluff', 31.016939163208, 0.541347712288755, -81.5272216796875, -1.42291844831385, 218, 13, 'PPL', 'P'),
(70753, 'Dover Forge', 39.9111099243164, 0.696580276304706, -74.2819366455078, -1.29646436922194, 218, 37, 'PPL', 'P'),
(148324, 'Dover Furnace', 41.6841697692871, 0.727526008434345, -73.5877838134766, -1.28434911679095, 218, 40, 'PPL', 'P'),
(29656, 'Dover Hill', 38.7249984741211, 0.675878726203193, -86.8027801513672, -1.51499431352614, 218, 19, 'PPL', 'P'),
(203748, 'Dover Hill Condominium', 40.6583290100098, 0.709621709583797, -111.863891601563, -1.9523932225413, 218, 52, 'PPL', 'P'),
(115325, 'Dover Mills', 43.0194396972656, 0.750830865080438, -91.7291717529297, -1.600976067216, 218, 16, 'PPL', 'P'),
(148322, 'Dover Plains', 41.7411117553711, 0.728519833574136, -73.5769424438477, -1.2841598991955, 218, 40, 'PPL', 'P'),
(101487, 'Dover Run', 37.6380615234375, 0.656908097652177, -77.7213897705078, -1.3564941507212, 218, 53, 'PPL', 'P'),
(127280, 'Dover South Mills', 45.110279083252, 0.787322896496276, -69.1872177124023, -1.20754474937556, 218, 26, 'PPL', 'P'),
(20664, 'Dover Square', 33.4022216796875, 0.582978745791578, -84.5838928222656, -1.47626742390253, 218, 13, 'PPL', 'P'),
(54474, 'Dover Station', 39.2080612182617, 0.684309761582166, -93.6988906860352, -1.63535414793756, 218, 29, 'PPL', 'P'),
(127281, 'Dover-Foxcroft', 45.1833305358887, 0.788597884868151, -69.2275009155273, -1.20824782390334, 218, 26, 'PPL', 'P'),
(20665, 'Doverel', 31.7013893127441, 0.553293620963928, -84.522216796875, -1.47519097418992, 218, 13, 'PPL', 'P'),
(2094, 'Dovertown', 33.7377815246582, 0.588835369923798, -87.1536102294922, -1.52111745350445, 218, 2, 'PPL', 'P'),
(80733, 'Dovesville', 34.4022216796875, 0.600432038311521, -79.8952789306641, -1.39443567413934, 218, 48, 'PPL', 'P'),
(196372, 'Dovetail (historical)', 47.3438911437988, 0.826306781165074, -108.206672668457, -1.88856271069233, 218, 31, 'PPL', 'P'),
(101488, 'Doveville', 38.8369407653809, 0.677832487757903, -77.2594375610352, -1.34843156367904, 218, 53, 'PPL', 'P'),
(135047, 'Dovray', 44.0527801513672, 0.768866058298563, -95.5497207641602, -1.66765722669579, 218, 28, 'PPL', 'P'),
(26981, 'Dow', 39.0133285522461, 0.680911035399007, -90.3413925170898, -1.57675475025979, 218, 18, 'PPL', 'P'),
(35620, 'Dow', 37.1569404602051, 0.648510950998076, -83.1630630493164, -1.45146926625421, 218, 21, 'PPL', 'P'),
(75678, 'Dow', 34.8766708374023, 0.608712738246959, -95.5999984741211, -1.66853473827497, 218, 42, 'PPL', 'P'),
(181199, 'Dow', 35.5041694641113, 0.619664655334773, -119.171669006348, -2.07993799925765, 218, 6, 'PPL', 'P'),
(115328, 'Dow City', 41.9288902282715, 0.731797186190614, -95.4936065673828, -1.66667784920491, 218, 16, 'PPL', 'P'),
(127284, 'Dow Corner', 44.9061088562012, 0.783759453799695, -69.3516693115234, -1.21041497124039, 218, 26, 'PPL', 'P'),
(127285, 'Dow Pines', 44.9530601501465, 0.784578908467113, -68.2838897705078, -1.19177870256424, 218, 26, 'PPL', 'P'),
(130534, 'Dowagiac', 41.9841690063477, 0.732761982874523, -86.1086120605469, -1.50287879477904, 218, 27, 'PPL', 'P'),
(93805, 'Dowdel Settlement', 30.1916694641113, 0.526944038822575, -94.6805572509766, -1.65248746165253, 218, 51, 'PPL', 'P'),
(101489, 'Dowden Terrace', 38.8372192382813, 0.677837348026892, -77.1283264160156, -1.34614324251239, 218, 53, 'PPL', 'P'),
(171910, 'Dowdey Corner', 43.8913917541504, 0.766049299392614, -72.6275024414063, -1.26758904510276, 218, 55, 'PPL', 'P'),
(2095, 'Dowdle', 33.1808280944824, 0.579114698786954, -87.2099990844727, -1.52210162468529, 218, 2, 'PPL', 'P'),
(186634, 'Dowds Junction', 39.6083297729492, 0.691295765753662, -106.447219848633, -1.8578544659529, 218, 7, 'PPL', 'P'),
(59703, 'Dowdville', 32.6858291625977, 0.57047533763171, -89.3036117553711, -1.55864205905394, 218, 30, 'PPL', 'P'),
(8584, 'Dowdy', 35.8516693115234, 0.625729671822293, -91.3041687011719, -1.5935583646318, 218, 4, 'PPL', 'P'),
(20667, 'Dowdy (historical)', 34.0327796936035, 0.593984059259248, -83.2811126708984, -1.45352962083155, 218, 13, 'PPL', 'P'),
(26982, 'Dowell', 37.9397201538086, 0.662173033969209, -89.2377777099609, -1.55749303820162, 218, 18, 'PPL', 'P'),
(46669, 'Dowell', 38.3461112976074, 0.669265897479445, -76.4591674804688, -1.33446421586796, 218, 25, 'PPL', 'P'),
(59704, 'Dowell', 32.9011116027832, 0.574232725034676, -89.5633316040039, -1.56317502554536, 218, 30, 'PPL', 'P'),
(86577, 'Dowell (historical)', 36.476390838623, 0.636633119378268, -81.7172164916992, -1.42623448334516, 218, 50, 'PPL', 'P'),
(86578, 'Dowelltown', 36.0149993896484, 0.628580319453113, -85.9436111450195, -1.49999898553428, 218, 50, 'PPL', 'P'),
(86579, 'Dowler Heights', 35.1813888549805, 0.614031070943847, -85.3405609130859, -1.48947377343213, 218, 50, 'PPL', 'P'),
(160874, 'Dowler Junction', 40.8283309936523, 0.712588803933282, -78.791389465332, -1.37516916839122, 218, 45, 'PPL', 'P'),
(160875, 'Dowley Corners', 41.9488906860352, 0.732146260030496, -80.2649993896484, -1.4008885134606, 218, 45, 'PPL', 'P'),
(160876, 'Dowlin', 40.0386085510254, 0.698805547132549, -75.7069396972656, -1.32133536432608, 218, 45, 'PPL', 'P'),
(93806, 'Dowling', 30.0163898468018, 0.523884832388887, -94.0372161865234, -1.64125904186454, 218, 51, 'PPL', 'P'),
(130536, 'Dowling', 42.5224990844727, 0.742157615200322, -85.253059387207, -1.48794658370502, 218, 27, 'PPL', 'P'),
(155024, 'Dowling', 41.478328704834, 0.723933404123828, -83.5936126708984, -1.45898377474403, 218, 41, 'PPL', 'P'),
(202061, 'Dowling (historical)', 44.333610534668, 0.7737674731268, -101.984169006348, -1.77995953407112, 218, 49, 'PPL', 'P'),
(15814, 'Dowling Park', 30.2433300018311, 0.527845685299135, -83.2363891601563, -1.45274904831604, 218, 12, 'PPL', 'P'),
(80735, 'Dowlingwood', 32.3858299255371, 0.565239363191533, -80.7361068725586, -1.40911089016817, 218, 48, 'PPL', 'P'),
(194851, 'Downata Hot Springs', 42.3886108398438, 0.739820824501832, -112.088333129883, -1.9563104661887, 218, 17, 'PPL', 'P'),
(70756, 'Downer', 39.6944389343262, 0.692798654135821, -75.0522232055664, -1.30990840587883, 218, 37, 'PPL', 'P'),
(135051, 'Downer', 46.7541694641113, 0.816014196184136, -96.4866714477539, -1.68401010105331, 218, 28, 'PPL', 'P'),
(171911, 'Downers', 43.4002799987793, 0.757477782266139, -72.5147171020508, -1.26562056958303, 218, 55, 'PPL', 'P'),
(115329, 'Downers Grove', 42.2449989318848, 0.737314323862877, -91.2808303833008, -1.59315103414308, 218, 16, 'PPL', 'P'),
(119401, 'Downers Grove', 41.8088912963867, 0.729702809730349, -88.0111083984375, -1.53608361988237, 218, 18, 'PPL', 'P'),
(46670, 'Downes', 38.9211082458496, 0.67930148741519, -75.8927764892578, -1.32457882821769, 218, 25, 'PPL', 'P'),
(78140, 'Downey', 39.9677810668945, 0.697569374333562, -78.8802795410156, -1.37672059288424, 218, 45, 'PPL', 'P'),
(115330, 'Downey', 41.6161117553711, 0.726338172009143, -91.3483276367188, -1.59432908345127, 218, 16, 'PPL', 'P'),
(181200, 'Downey', 33.939998626709, 0.592364724158426, -118.13166809082, -2.06178655905794, 218, 6, 'PPL', 'P'),
(194852, 'Downey', 42.4286117553711, 0.740518972181596, -112.123611450195, -1.95692618903272, 218, 17, 'PPL', 'P'),
(29657, 'Downey Corner', 38.9386100769043, 0.679606951992222, -85.0102767944336, -1.4837092280946, 218, 19, 'PPL', 'P'),
(181201, 'Downey Road', 33.9688911437988, 0.592868993710832, -118.105278015137, -2.06132596534741, 218, 6, 'PPL', 'P'),
(29658, 'Downeyville', 39.4275016784668, 0.688139720124836, -85.554443359375, -1.49320672633209, 218, 19, 'PPL', 'P'),
(190131, 'Downeyville (historical)', 38.910831451416, 0.679122123515774, -117.898063659668, -2.05770939258708, 218, 39, 'PPL', 'P'),
(160878, 'Downieville', 40.6802787780762, 0.710004805306605, -80.0013885498047, -1.39628763636138, 218, 45, 'PPL', 'P'),
(181202, 'Downieville', 39.559440612793, 0.690442488940401, -120.825828552246, -2.10880852968687, 218, 6, 'PPL', 'P'),
(186635, 'Downieville', 39.7666702270508, 0.694059328016837, -105.613891601563, -1.84331014429165, 218, 7, 'PPL', 'P'),
(2096, 'Downing', 32.1416702270508, 0.56097797255227, -86.0058288574219, -1.50108488946876, 218, 2, 'PPL', 'P'),
(93807, 'Downing', 32.0238914489746, 0.558922345085865, -98.5502777099609, -1.7200268247936, 218, 51, 'PPL', 'P'),
(139124, 'Downing', 40.4874992370605, 0.706640167585399, -92.3691711425781, -1.61214616377612, 218, 29, 'PPL', 'P'),
(173846, 'Downing', 45.0463905334473, 0.78620783094786, -92.1319427490234, -1.60800574722937, 218, 57, 'PPL', 'P'),
(207233, 'Downing', 48.0422210693359, 0.838494937630903, -119.691940307617, -2.08901844646843, 218, 56, 'PPL', 'P'),
(32259, 'Downing (historical)', 38.7402801513672, 0.676145441786365, -96.5736083984375, -1.68552743708438, 218, 20, 'PPL', 'P'),
(101490, 'Downing (historical)', 38.8791694641113, 0.678569517589582, -78.1758270263672, -1.36442557707968, 218, 53, 'PPL', 'P'),
(101491, 'Downings', 37.8444404602051, 0.660510089605537, -76.6233291625977, -1.33732937772672, 218, 53, 'PPL', 'P'),
(101492, 'Downings Corner', 37.8902816772461, 0.661310169776024, -76.379997253418, -1.33308243473637, 218, 53, 'PPL', 'P'),
(35622, 'Downingsville', 38.6416702270508, 0.674424373931901, -84.7133331298828, -1.47852658345525, 218, 21, 'PPL', 'P'),
(160879, 'Downingtown', 40.0063896179199, 0.698243220668379, -75.70361328125, -1.32127730741432, 218, 45, 'PPL', 'P'),
(171912, 'Downingville', 44.1330604553223, 0.770267213927081, -72.982780456543, -1.27378981622685, 218, 55, 'PPL', 'P'),
(2097, 'Downs', 32.264720916748, 0.563125612234337, -85.7841720581055, -1.49721624851126, 218, 2, 'PPL', 'P'),
(20669, 'Downs', 33.0661087036133, 0.577112467700406, -82.6736068725586, -1.44292664442556, 218, 13, 'PPL', 'P'),
(32257, 'Downs', 39.4986114501953, 0.68938081977184, -98.5416717529297, -1.71987662250812, 218, 20, 'PPL', 'P'),
(93808, 'Downs', 31.4538898468018, 0.548973940386306, -97.0697174072266, -1.69418617273656, 218, 51, 'PPL', 'P'),
(108949, 'Downs', 39.5175018310547, 0.689710519114792, -80.3163909912109, -1.40178546611574, 218, 58, 'PPL', 'P'),
(119403, 'Downs', 40.3969383239746, 0.705059581478437, -88.8705596923828, -1.55108387472224, 218, 18, 'PPL', 'P'),
(200716, 'Downs', 45.0424995422363, 0.786139920340063, -122.792778015137, -2.14313827403464, 218, 43, 'PPL', 'P'),
(207234, 'Downs', 47.3716697692871, 0.826791609641523, -118.396110534668, -2.0664019503851, 218, 56, 'PPL', 'P'),
(13673, 'Downs Chapel', 39.2119407653809, 0.684377472452881, -75.7197189331055, -1.32155840406738, 218, 10, 'PPL', 'P'),
(70757, 'Downs Farms', 39.8677787780762, 0.695824005134151, -75.0016708374023, -1.30902610060968, 218, 37, 'PPL', 'P'),
(46671, 'Downs on the Severn', 39.0191688537598, 0.68101296788973, -76.5422210693359, -1.33591377444929, 218, 25, 'PPL', 'P'),
(80736, 'Downs Siding', 34.2447204589844, 0.597683123434341, -82.2205581665039, -1.43501945283301, 218, 48, 'PPL', 'P'),
(70758, 'Downstown', 39.5397186279297, 0.690098275369508, -74.9561080932617, -1.30823088070819, 218, 37, 'PPL', 'P'),
(40694, 'Downsville', 32.6266708374023, 0.569442830077086, -92.4141693115234, -1.61293152998159, 218, 22, 'PPL', 'P'),
(46672, 'Downsville', 39.5483283996582, 0.690248544234015, -77.8019409179688, -1.35790003346065, 218, 25, 'PPL', 'P'),
(93809, 'Downsville', 31.4555606842041, 0.549003102000242, -97.0666732788086, -1.69413304267281, 218, 51, 'PPL', 'P'),
(148325, 'Downsville', 42.0808296203613, 0.734449028846061, -74.9961090087891, -1.30892902838795, 218, 40, 'PPL', 'P'),
(173848, 'Downsville', 44.7747192382813, 0.781466272364055, -91.9319381713867, -1.60451500883055, 218, 57, 'PPL', 'P'),
(64259, 'Downsville (historical)', 35.8811111450195, 0.626243528754623, -81.3613891601563, -1.42002412484115, 218, 33, 'PPL', 'P'),
(124657, 'Downtown Crossing', 42.3544387817383, 0.739224409575709, -71.0583267211914, -1.24020176224266, 218, 23, 'PPL', 'P'),
(115331, 'Dows', 42.6566696166992, 0.744499332746829, -93.5008316040039, -1.63189736484264, 218, 16, 'PPL', 'P'),
(143726, 'Dows Corner', 42.9702796936035, 0.749972861156242, -70.8986129760742, -1.23741423152967, 218, 36, 'PPL', 'P'),
(171913, 'Dows Crossing', 44.5008316040039, 0.776686031365418, -72.2872161865234, -1.26164992955577, 218, 55, 'PPL', 'P'),
(171914, 'Dowsville', 44.2724990844727, 0.772700877110223, -72.8247222900391, -1.27103118081169, 218, 55, 'PPL', 'P'),
(75681, 'Doxey', 35.3241691589355, 0.616523057354861, -99.5827789306641, -1.73804737062573, 218, 42, 'PPL', 'P'),
(148326, 'Doxtater Corner', 43.1166687011719, 0.752527831327036, -74.7336120605469, -1.30434759236469, 218, 40, 'PPL', 'P'),
(2098, 'Doyle', 32.0902786254883, 0.560081019897131, -87.7813873291016, -1.53207423086125, 218, 2, 'PPL', 'P'),
(8585, 'Doyle', 33.9527816772461, 0.592587830478747, -93.7536087036133, -1.63630915750446, 218, 4, 'PPL', 'P'),
(20670, 'Doyle', 32.2841682434082, 0.563465032115267, -84.4438934326172, -1.47382397360239, 218, 13, 'PPL', 'P'),
(40695, 'Doyle', 30.5033302307129, 0.532383545349062, -90.7388916015625, -1.5836924180575, 218, 22, 'PPL', 'P'),
(54477, 'Doyle', 36.5997200012207, 0.638785619329324, -90.9097213745117, -1.58667396005589, 218, 29, 'PPL', 'P'),
(80740, 'Doyle', 33.9619407653809, 0.592747686723179, -79.1519393920898, -1.38146195173097, 218, 48, 'PPL', 'P'),
(86580, 'Doyle', 35.8530616760254, 0.62575397316724, -85.5124969482422, -1.49247462334843, 218, 50, 'PPL', 'P'),
(93811, 'Doyle', 27.8872203826904, 0.486723814907221, -97.3441696166992, -1.69897626743123, 218, 51, 'PPL', 'P'),
(108950, 'Doyle', 39.2827796936035, 0.685613844988951, -81.376106262207, -1.42028098672829, 218, 58, 'PPL', 'P'),
(122510, 'Doyle', 40.8080596923828, 0.712235002982464, -86.0741729736328, -1.50227771932101, 218, 19, 'PPL', 'P'),
(135052, 'Doyle', 44.3702812194824, 0.774407497315773, -93.5747222900391, -1.63318700060051, 218, 28, 'PPL', 'P'),
(148327, 'Doyle', 42.8794403076172, 0.74838741478029, -78.7850036621094, -1.3750577150996, 218, 40, 'PPL', 'P'),
(193507, 'Doyle', 40.0280609130859, 0.698621456122197, -120.102783203125, -2.09618900770347, 218, 6, 'PPL', 'P'),
(199280, 'Doyle', 41.9894409179688, 0.732853995090185, -103.832778930664, -1.81222386383548, 218, 35, 'PPL', 'P'),
(93812, 'Doyle Addition Colonia', 27.8880004882813, 0.486737430318294, -97.3440017700195, -1.69897333795403, 218, 51, 'PPL', 'P'),
(122511, 'Doyle Ferguson', 40.5786094665527, 0.708230341072285, -85.478889465332, -1.49188806211834, 218, 19, 'PPL', 'P'),
(194853, 'Doyle Place', 42.8452796936035, 0.747791199591249, -116.333061218262, -2.03039494718279, 218, 17, 'PPL', 'P'),
(86581, 'Doyle Springs', 35.7675018310547, 0.624260672165005, -83.7236099243164, -1.46125265483472, 218, 50, 'PPL', 'P'),
(26983, 'Doyles', 39.475830078125, 0.688983209821092, -87.871940612793, -1.53365468381016, 218, 18, 'PPL', 'P'),
(193508, 'Doyles Corner', 40.877498626709, 0.713446941015532, -121.559173583984, -2.12160781504384, 218, 6, 'PPL', 'P'),
(160885, 'Doyles Mills', 40.4844398498535, 0.706586771205543, -77.5149993896484, -1.35289195903076, 218, 45, 'PPL', 'P'),
(160882, 'Doylesburg', 40.2133293151855, 0.701854999738744, -77.7002792358398, -1.35612570238439, 218, 45, 'PPL', 'P'),
(8586, 'Doylestown', 34.2700004577637, 0.59812434264794, -92.20361328125, -1.60925663399338, 218, 4, 'PPL', 'P'),
(155025, 'Doylestown', 40.9700012207031, 0.715061415847365, -81.6966705322266, -1.42587588870438, 218, 41, 'PPL', 'P'),
(160884, 'Doylestown', 40.1974983215332, 0.701578696775649, -77.7216720581055, -1.35649907756922, 218, 45, 'PPL', 'P'),
(173850, 'Doylestown', 43.4277801513672, 0.757957750473599, -89.1500015258789, -1.55596105478456, 218, 57, 'PPL', 'P'),
(35623, 'Doylesville', 37.8441696166992, 0.660505362494602, -84.1608276367188, -1.46888354346418, 218, 21, 'PPL', 'P'),
(101493, 'Doylesville', 38.1505584716797, 0.665852856805426, -78.6680603027344, -1.37301666844016, 218, 53, 'PPL', 'P'),
(186636, 'Doyleville', 38.4516716003418, 0.671108272321562, -106.60888671875, -1.86067608512784, 218, 7, 'PPL', 'P'),
(8587, 'Doyleville (historical)', 35.4744415283203, 0.619145804975399, -91.7486114501953, -1.60131535393888, 218, 4, 'PPL', 'P'),
(40696, 'Doyline', 32.5355606079102, 0.5678526565902, -93.4108276367188, -1.63032649927366, 218, 22, 'PPL', 'P'),
(93813, 'Doyno West Side Number 2 Colonia', 26.3899993896484, 0.460592378948659, -98.8349990844727, -1.72499615022963, 218, 51, 'PPL', 'P'),
(139898, 'Doyon', 48.0527801513672, 0.838679228378337, -98.5363922119141, -1.7197844771344, 218, 34, 'PPL', 'P'),
(26984, 'Dozaville', 37.9069404602051, 0.661600920388033, -89.9563903808594, -1.57003519535535, 218, 18, 'PPL', 'P'),
(101494, 'Dozer Mill Acres', 38.7174987792969, 0.675747831835616, -77.4222183227539, -1.35127262392994, 218, 53, 'PPL', 'P'),
(2099, 'Dozier', 31.4919395446777, 0.54963803289363, -86.3649978637695, -1.50735357120065, 218, 2, 'PPL', 'P'),
(64260, 'Dozier', 36.1916694641113, 0.631663793942234, -80.4063873291016, -1.40335619852667, 218, 33, 'PPL', 'P'),
(86582, 'Dozier', 36.2799987792969, 0.633205431318254, -87.1433334350586, -1.52093808960503, 218, 50, 'PPL', 'P'),
(181203, 'Dozier', 38.2855606079102, 0.668209088579874, -121.815559387207, -2.12608259146545, 218, 6, 'PPL', 'P'),
(191393, 'Dozier', 35.0811080932617, 0.612280841475447, -100.343612670898, -1.75132642445308, 218, 51, 'PPL', 'P'),
(20671, 'Dozier (historical)', 31.2344398498535, 0.545143815396067, -84.7852783203125, -1.47978226390922, 218, 13, 'PPL', 'P'),
(35624, 'Dozier Heights', 37.2963905334473, 0.650944813918299, -87.5077819824219, -1.52729891671063, 218, 21, 'PPL', 'P'),
(86583, 'Doziers (historical)', 36.2036094665527, 0.631872186297533, -86.9913864135742, -1.51828611379153, 218, 50, 'PPL', 'P'),
(101495, 'Doziers Corner', 36.7588882446289, 0.641563629241413, -76.2747192382813, -1.33124498674227, 218, 53, 'PPL', 'P'),
(8588, 'Drab (historical)', 33.8441696166992, 0.590692192414829, -93.5213928222656, -1.63225622579953, 218, 4, 'PPL', 'P'),
(75683, 'Drace', 36.3402786254883, 0.63425751310689, -97.2058334350586, -1.69656184558696, 218, 42, 'PPL', 'P'),
(64261, 'Draco', 35.9430618286133, 0.627324772157196, -81.3855590820313, -1.42044596955782, 218, 33, 'PPL', 'P'),
(78141, 'Draco', 39.7511100769043, 0.693787752164676, -76.5358276367188, -1.33580218799961, 218, 45, 'PPL', 'P'),
(93814, 'Draco', 33.1047210693359, 0.57778638061425, -97.7441711425781, -1.70595761107082, 218, 51, 'PPL', 'P'),
(124658, 'Dracut', 42.670280456543, 0.744736886716064, -71.3024978637695, -1.244463352619, 218, 23, 'PPL', 'P'),
(198205, 'Drady', 48.1519393920898, 0.840409883612725, -101.425277709961, -1.77020504078843, 218, 34, 'PPL', 'P'),
(35625, 'Draffin', 37.3402786254883, 0.651710805626833, -82.3963928222656, -1.43808834651516, 218, 21, 'PPL', 'P'),
(8589, 'Draft (historical)', 36.2999992370605, 0.633554505158136, -91.5569381713867, -1.59797002413557, 218, 4, 'PPL', 'P'),
(192542, 'Dragerton', 39.5424995422363, 0.690146811480374, -110.420562744141, -1.92720238179024, 218, 52, 'PPL', 'P'),
(59707, 'Dragon', 31.3775005340576, 0.547640695365585, -89.2663879394531, -1.55799238090601, 218, 30, 'PPL', 'P'),
(192543, 'Dragon', 39.785831451416, 0.694393754470724, -109.072776794434, -1.90367907935573, 218, 52, 'PPL', 'P'),
(13675, 'Dragon Run Terrace Mobile Home Park', 39.5558280944824, 0.690379438601593, -75.6888885498047, -1.32102031236913, 218, 10, 'PPL', 'P'),
(101496, 'Dragonville', 37.6972198486328, 0.657940605206801, -76.7783279418945, -1.34003461676202, 218, 53, 'PPL', 'P'),
(178108, 'Dragoon', 32.0280609130859, 0.558995115962651, -110.038063049316, -1.92052650272768, 218, 5, 'PPL', 'P'),
(70759, 'Dragston', 39.2655601501465, 0.685313307259935, -75.0725021362305, -1.3102623399877, 218, 37, 'PPL', 'P'),
(200717, 'Drain', 43.6588897705078, 0.761991374260633, -123.317497253418, -2.15229635239121, 218, 43, 'PPL', 'P'),
(35626, 'Drake', 36.836109161377, 0.642911388490075, -86.4097213745117, -1.50813414371615, 218, 21, 'PPL', 'P'),
(54480, 'Drake', 38.4683303833008, 0.671399022933571, -91.4644393920898, -1.59635561588277, 218, 29, 'PPL', 'P'),
(64262, 'Drake', 36.0380592346191, 0.628982789672852, -77.8177795410156, -1.3581764695818, 218, 33, 'PPL', 'P'),
(75684, 'Drake', 34.3977813720703, 0.6003545403238, -96.9505615234375, -1.69210651024131, 218, 42, 'PPL', 'P'),
(80738, 'Drake', 34.4724998474121, 0.601658623730584, -79.6672210693359, -1.39045531357411, 218, 48, 'PPL', 'P'),
(155026, 'Drake', 40.0208282470703, 0.698495222286528, -81.9925003051758, -1.43103909226777, 218, 41, 'PPL', 'P'),
(160888, 'Drake', 41.1169395446777, 0.717625973398085, -80.1880569458008, -1.39954561448093, 218, 45, 'PPL', 'P'),
(178111, 'Drake', 35.0400009155273, 0.61156338587778, -114.121109008789, -1.99178909823073, 218, 5, 'PPL', 'P'),
(181204, 'Drake', 34.4705581665039, 0.601624735005713, -120.302780151367, -2.09967961294424, 218, 6, 'PPL', 'P'),
(194162, 'Drake', 40.4319381713867, 0.705670444053474, -105.339721679688, -1.838524976445, 218, 7, 'PPL', 'P'),
(198206, 'Drake', 47.9241714477539, 0.836434583053563, -100.371940612793, -1.75182084030945, 218, 34, 'PPL', 'P'),
(127286, 'Drake Corner', 44.288890838623, 0.772986967190325, -69.0986099243164, -1.20599825173055, 218, 26, 'PPL', 'P'),
(200718, 'Drake Crossing', 44.9261093139648, 0.784108527639577, -122.654716491699, -2.14072864588034, 218, 43, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(86584, 'Drake Forest', 35.0322189331055, 0.611427564662186, -85.1413879394531, -1.48599754926125, 218, 50, 'PPL', 'P'),
(127287, 'Drake Place (historical)', 45.3683280944824, 0.791826701373763, -68.1319427490234, -1.18912672675074, 218, 26, 'PPL', 'P'),
(72340, 'Drakes', 39.5938911437988, 0.691043764135513, -82.1272201538086, -1.4333903971942, 218, 41, 'PPL', 'P'),
(194163, 'Drakes', 40.5541687011719, 0.707803769244682, -105.079437255859, -1.83398215625754, 218, 7, 'PPL', 'P'),
(101497, 'Drakes Branch', 36.9927787780762, 0.645645789139314, -78.6013870239258, -1.37185300020185, 218, 53, 'PPL', 'P'),
(75685, 'Drakes Corner', 35.9858283996582, 0.628071189631717, -96.8733291625977, -1.69075855125557, 218, 42, 'PPL', 'P'),
(101502, 'Drakes Corner', 36.6116714477539, 0.638994211421705, -77.0047225952148, -1.34398594887137, 218, 53, 'PPL', 'P'),
(148328, 'Drakes Corner', 43.3766708374023, 0.757065724666477, -76.3427810668945, -1.3324328897465, 218, 40, 'PPL', 'P'),
(8594, 'Drakes Creek', 36.0205612182617, 0.628677391674847, -93.8597183227539, -1.63816111972651, 218, 4, 'PPL', 'P'),
(160889, 'Drakes Creek', 40.9716682434082, 0.715090510882275, -75.711669921875, -1.32141792231988, 218, 45, 'PPL', 'P'),
(127288, 'Drakes Island', 43.3255615234375, 0.756173698859355, -70.5538864135742, -1.23139761799496, 218, 26, 'PPL', 'P'),
(20672, 'Drakes Landing', 33.5119400024414, 0.584893691773399, -84.3369369506836, -1.4719572308363, 218, 13, 'PPL', 'P'),
(160890, 'Drakes Mills', 41.829719543457, 0.730066331219144, -80.0822219848633, -1.39769844594885, 218, 45, 'PPL', 'P'),
(193509, 'Drakesbad', 40.4444389343262, 0.705888623525778, -121.403327941895, -2.11888779546449, 218, 6, 'PPL', 'P'),
(35627, 'Drakesboro', 37.2174987792969, 0.649567893055701, -87.0488891601563, -1.51928972604833, 218, 21, 'PPL', 'P'),
(155027, 'Drakesburg', 41.2355613708496, 0.719696314829512, -81.1347198486328, -1.41606799904184, 218, 41, 'PPL', 'P'),
(145102, 'Drakestown', 40.8436088562012, 0.712855452937426, -74.7827835083008, -1.30520579602596, 218, 37, 'PPL', 'P'),
(115333, 'Drakesville', 40.7983283996582, 0.712065159883945, -92.4813919067383, -1.61410478559982, 218, 16, 'PPL', 'P'),
(20673, 'Draketown', 33.8261108398438, 0.590377007299818, -85.0441665649414, -1.4843007161727, 218, 13, 'PPL', 'P'),
(160892, 'Draketown', 41.9111099243164, 0.731486861344593, -80.0758285522461, -1.39758685949918, 218, 45, 'PPL', 'P'),
(113174, 'Drakeville', 41.8549995422363, 0.730507550432743, -73.1577835083008, -1.27684419568106, 218, 8, 'PPL', 'P'),
(93815, 'Drane', 32.0447196960449, 0.55928586657466, -96.5872192382813, -1.68576499105362, 218, 51, 'PPL', 'P'),
(160893, 'Drane', 40.8788909912109, 0.713471242360479, -78.2799987792969, -1.36624371715587, 218, 45, 'PPL', 'P'),
(101498, 'Dranesville', 39.000560760498, 0.680688195394795, -77.3461074829102, -1.34994423917821, 218, 53, 'PPL', 'P'),
(20674, 'Draneville', 32.2105598449707, 0.562180323205413, -84.4872207641602, -1.47458017819391, 218, 13, 'PPL', 'P'),
(35628, 'Draper', 36.8605613708496, 0.64333816005476, -83.2038879394531, -1.45218179500386, 218, 21, 'PPL', 'P'),
(101500, 'Draper', 37.0058288574219, 0.645873555991543, -80.7474975585938, -1.40930969514354, 218, 53, 'PPL', 'P'),
(160894, 'Draper', 41.6566696166992, 0.727046040226886, -77.3686065673828, -1.35033692228094, 218, 45, 'PPL', 'P'),
(173853, 'Draper', 45.8863906860352, 0.800868599327773, -90.8308334350586, -1.58529710577232, 218, 57, 'PPL', 'P'),
(202063, 'Draper', 43.9261093139648, 0.766655235119634, -100.540000915527, -1.75475404593407, 218, 49, 'PPL', 'P'),
(203751, 'Draper', 40.5247192382813, 0.707289779154296, -111.863059997559, -1.95237870831336, 218, 52, 'PPL', 'P'),
(8591, 'Draper (historical)', 33.6313896179199, 0.58697848085374, -92.1911087036133, -1.60903838794205, 218, 4, 'PPL', 'P'),
(64263, 'Draper (historical)', 36.5177803039551, 0.637355501823952, -79.6936111450195, -1.39091590728464, 218, 33, 'PPL', 'P'),
(200719, 'Draper (historical)', 42.3555603027344, 0.739243983809721, -123.119438171387, -2.14883956929628, 218, 43, 'PPL', 'P'),
(203752, 'Draper Commercial Parkway', 40.5202789306641, 0.707212281166575, -111.88777923584, -1.95281014040995, 218, 52, 'PPL', 'P'),
(86585, 'Drapers Crossroads', 36.5119400024414, 0.637253569333229, -85.9088897705078, -1.49939298322824, 218, 50, 'PPL', 'P'),
(101503, 'Drapersville', 36.791389465332, 0.6421308825536, -78.341667175293, -1.36732003371043, 218, 53, 'PPL', 'P'),
(200720, 'Draperville', 44.646110534668, 0.779221627039282, -123.035827636719, -2.14738029017698, 218, 43, 'PPL', 'P'),
(203755, 'Draperville', 40.5288887023926, 0.707362550031083, -111.867782592773, -1.9524611331491, 218, 52, 'PPL', 'P'),
(8592, 'Drasco', 35.6313896179199, 0.621885065893627, -91.9469375610352, -1.60477679756571, 218, 4, 'PPL', 'P'),
(93816, 'Drasco', 32.0763893127441, 0.559838605658906, -99.9872207641602, -1.74510621225304, 218, 51, 'PPL', 'P'),
(64264, 'Draughn', 36.0777816772461, 0.629676077083627, -77.5605621337891, -1.35368717893226, 218, 33, 'PPL', 'P'),
(8593, 'Draughon (historical)', 33.8722190856934, 0.591181748002212, -92.2680587768555, -1.61038142007978, 218, 4, 'PPL', 'P'),
(160895, 'Dravosburg', 40.3505592346191, 0.704250113665107, -79.8863906860352, -1.39428054500585, 218, 45, 'PPL', 'P'),
(191394, 'Draw', 33.0195999145508, 0.576300736200149, -101.667381286621, -1.77443054533201, 218, 51, 'PPL', 'P'),
(13676, 'Drawbridge', 38.790828704834, 0.677027680476481, -75.2522201538086, -1.31339901111959, 218, 10, 'PPL', 'P'),
(181206, 'Drawbridge', 37.4663887023926, 0.653911841688756, -121.973892211914, -2.12884602057057, 218, 6, 'PPL', 'P'),
(417, 'Drawdy', 31.6263904571533, 0.55198464399864, -81.9194412231445, -1.42976397073784, 218, 13, 'PPL', 'P'),
(80739, 'Drawdy', 32.8477783203125, 0.573301883654666, -80.625, -1.40717170942043, 218, 48, 'PPL', 'P'),
(46673, 'Drayden', 38.1786117553711, 0.666342478971838, -76.4819412231445, -1.33486169266065, 218, 25, 'PPL', 'P'),
(20677, 'Drayton', 32.0738906860352, 0.559794996396056, -83.9555587768555, -1.46530092600775, 218, 13, 'PPL', 'P'),
(80749, 'Drayton', 32.8458290100098, 0.57326786177174, -80.0569381713867, -1.39725716015623, 218, 48, 'PPL', 'P'),
(139899, 'Drayton', 48.5711097717285, 0.847725786864254, -97.1774978637695, -1.69606729657253, 218, 34, 'PPL', 'P'),
(130538, 'Drayton Plains', 42.6841697692871, 0.744979300954288, -83.3772201538086, -1.45520701284413, 218, 27, 'PPL', 'P'),
(80742, 'Draytonville', 35.0494384765625, 0.611728102391201, -81.5938873291016, -1.4240819833941, 218, 48, 'PPL', 'P'),
(145101, 'Dreahook', 40.5999984741211, 0.708603649678087, -74.7816696166992, -1.30518635495001, 218, 37, 'PPL', 'P'),
(130539, 'Dreamland', 47.0977783203125, 0.822011302063858, -88.4130630493164, -1.54309905198391, 218, 27, 'PPL', 'P'),
(178110, 'Dreamland Villa', 33.4213905334473, 0.583313305403519, -111.709999084473, -1.9497072914239, 218, 5, 'PPL', 'P'),
(46674, 'Dreams Landing', 39.0055618286133, 0.680775480499522, -76.5124969482422, -1.33539499066894, 218, 25, 'PPL', 'P'),
(122512, 'Dreamwold Heights', 41.7527809143066, 0.728723498818499, -86.2541732788086, -1.50541931730092, 218, 19, 'PPL', 'P'),
(15815, 'Dreamworld', 28.7838897705078, 0.502373648026476, -81.2761077880859, -1.41853568410791, 218, 12, 'PPL', 'P'),
(59708, 'Dredge (historical)', 33.2519416809082, 0.580355865012986, -91.0374984741211, -1.58890409115273, 218, 30, 'PPL', 'P'),
(80743, 'Dreher Colony', 34.797779083252, 0.607335817384361, -82.3811111450195, -1.43782163093199, 218, 48, 'PPL', 'P'),
(160898, 'Drehersville', 40.6425018310547, 0.709345473199729, -76.0177764892578, -1.32676048978268, 218, 45, 'PPL', 'P'),
(160899, 'Dreibelbis', 40.5547218322754, 0.707813423203633, -75.8797225952148, -1.32435099478644, 218, 45, 'PPL', 'P'),
(93821, 'Dreka', 31.6747207641602, 0.552828166984409, -93.9561080932617, -1.63984343858711, 218, 51, 'PPL', 'P'),
(101507, 'Drenn', 36.6194381713867, 0.63912976632119, -80.7783279418945, -1.40984778684179, 218, 53, 'PPL', 'P'),
(112641, 'Drennen', 38.2705612182617, 0.667947299844719, -80.9983291625977, -1.41368753250147, 218, 58, 'PPL', 'P'),
(160900, 'Drennen', 40.523609161377, 0.707270404657366, -79.7013931274414, -1.39105172850023, 218, 45, 'PPL', 'P'),
(35633, 'Drennon Springs', 38.5077781677246, 0.672087516654384, -85.0538864135742, -1.48447035953414, 218, 21, 'PPL', 'P'),
(130540, 'Drenthe', 42.7827796936035, 0.746700368808752, -85.9400024414063, -1.4999360017745, 218, 27, 'PPL', 'P'),
(135054, 'Dresbach', 43.8955612182617, 0.7661220702694, -91.3430633544922, -1.59423720439367, 218, 28, 'PPL', 'P'),
(20675, 'Dresden', 33.351390838623, 0.582091580253445, -84.9186096191406, -1.48210933406973, 218, 13, 'PPL', 'P'),
(54481, 'Dresden', 38.7511100769043, 0.676334459644733, -93.334716796875, -1.62899811452192, 218, 29, 'PPL', 'P'),
(64265, 'Dresden', 36.4580612182617, 0.636313207152322, -81.5458297729492, -1.42324322080878, 218, 33, 'PPL', 'P'),
(86586, 'Dresden', 36.291389465332, 0.633404236293628, -88.7080612182617, -1.54824774131936, 218, 50, 'PPL', 'P'),
(93817, 'Dresden', 32.0305595397949, 0.559038725225501, -96.6802825927734, -1.68738925300246, 218, 51, 'PPL', 'P'),
(115336, 'Dresden', 41.5777816772461, 0.725669185943315, -92.3555603027344, -1.61190860980689, 218, 16, 'PPL', 'P'),
(139902, 'Dresden', 48.8274993896484, 0.852200629864887, -98.480827331543, -1.71881468702345, 218, 34, 'PPL', 'P'),
(148330, 'Dresden', 42.6838912963867, 0.744974440685299, -76.9561080932617, -1.34313746574807, 218, 40, 'PPL', 'P'),
(155028, 'Dresden', 40.1213912963867, 0.700250378602944, -82.0108337402344, -1.43135907107275, 218, 41, 'PPL', 'P'),
(187650, 'Dresden', 39.6241683959961, 0.691572201874812, -100.421943664551, -1.75269355819867, 218, 20, 'PPL', 'P'),
(80744, 'Dresden (historical)', 34.1094398498535, 0.595322031390904, -82.5352783203125, -1.44051235573935, 218, 48, 'PPL', 'P'),
(148331, 'Dresden Center', 43.6333312988281, 0.761545294778045, -73.445556640625, -1.28186678433889, 218, 40, 'PPL', 'P'),
(127289, 'Dresden Mills', 44.1072196960449, 0.769816207596476, -69.7247161865234, -1.21692586747342, 218, 26, 'PPL', 'P'),
(160901, 'Dresher', 40.1408309936523, 0.70058966532582, -75.1672210693359, -1.31191549723437, 218, 45, 'PPL', 'P'),
(160902, 'Dreshertowne', 40.1749992370605, 0.701186013672916, -75.1416702270508, -1.31146955090983, 218, 45, 'PPL', 'P'),
(35629, 'Dressen', 36.8316688537598, 0.642833890502354, -83.3244400024414, -1.45428582542307, 218, 21, 'PPL', 'P'),
(173855, 'Dresser', 45.3561096191406, 0.791613448749475, -92.6333312988281, -1.61675662825527, 218, 57, 'PPL', 'P'),
(181205, 'Dresser', 37.5924987792969, 0.65611287775068, -121.954719543457, -2.1285113943796, 218, 6, 'PPL', 'P'),
(148333, 'Dresserville', 42.7036094665527, 0.745318587677165, -76.3280563354492, -1.33217589470131, 218, 40, 'PPL', 'P'),
(190132, 'Dresslerville', 38.8980598449707, 0.678899216932534, -119.715827941895, -2.08943536433709, 218, 39, 'PPL', 'P'),
(26985, 'Dressor', 39.1730613708496, 0.683698899007129, -89.0511093139648, -1.55423506008208, 218, 18, 'PPL', 'P'),
(20676, 'Drew', 34.2083282470703, 0.597047959514357, -84.2197189331055, -1.4699113904869, 218, 13, 'PPL', 'P'),
(35630, 'Drew', 37.2861099243164, 0.650765383439855, -82.8583297729492, -1.44615066724121, 218, 21, 'PPL', 'P'),
(40697, 'Drew', 32.5449981689453, 0.568017373103621, -92.2411117553711, -1.60991110583127, 218, 22, 'PPL', 'P'),
(54483, 'Drew', 37.5480613708496, 0.655337298662221, -92.4680633544922, -1.6138721584786, 218, 29, 'PPL', 'P'),
(59709, 'Drew', 33.809440612793, 0.590086056950727, -90.5263900756836, -1.5799835667654, 218, 30, 'PPL', 'P'),
(64266, 'Drew', 36.0466690063477, 0.629133058537359, -77.0358276367188, -1.34452883425958, 218, 33, 'PPL', 'P'),
(115338, 'Drew', 42.8472213745117, 0.74782508831612, -93.8058319091797, -1.63722062438754, 218, 16, 'PPL', 'P'),
(122513, 'Drew', 40.2188911437988, 0.701952071960478, -85.3869400024414, -1.49028324124546, 218, 19, 'PPL', 'P'),
(130541, 'Drew', 43.6630592346191, 0.762064145137419, -85.0274963378906, -1.48400976582361, 218, 27, 'PPL', 'P'),
(200721, 'Drew', 42.8819389343262, 0.74843102404314, -122.898330688477, -2.14498051571871, 218, 43, 'PPL', 'P'),
(15816, 'Drew Park', 27.9836101531982, 0.488406133767824, -82.5133285522461, -1.44012926001654, 218, 12, 'PPL', 'P'),
(54484, 'Drewel Ford (historical)', 38.399169921875, 0.670191945169493, -91.6383285522461, -1.59939055426102, 218, 29, 'PPL', 'P'),
(29659, 'Drewersburg', 39.3402786254883, 0.68661739066672, -84.8372192382813, -1.48068880394428, 218, 19, 'PPL', 'P'),
(2102, 'Drewry', 31.4861106872559, 0.549536300139989, -87.253059387207, -1.52285316874491, 218, 2, 'PPL', 'P'),
(64267, 'Drewry', 36.459171295166, 0.636332581649252, -78.3102798461914, -1.3667722214742, 218, 33, 'PPL', 'P'),
(101504, 'Drewrys Bluff', 37.4263916015625, 0.653213760588019, -77.4580612182617, -1.35189820047, 218, 53, 'PPL', 'P'),
(101505, 'Drewryville', 36.7155609130859, 0.640807424649885, -77.3066711425781, -1.34925594519448, 218, 53, 'PPL', 'P'),
(148334, 'Drews Corner', 44.8477783203125, 0.782741393893985, -75.1597213745117, -1.31178460286679, 218, 40, 'PPL', 'P'),
(93818, 'Drews Landing', 30.5436096191406, 0.533086553297815, -94.8608322143555, -1.65563385332241, 218, 51, 'PPL', 'P'),
(200723, 'Drews Valley (historical)', 42.2277793884277, 0.737013786133861, -120.691673278809, -2.10646707845647, 218, 43, 'PPL', 'P'),
(200722, 'Drewsey', 43.8066711425781, 0.764570645776375, -118.376388549805, -2.06605773681421, 218, 43, 'PPL', 'P'),
(143727, 'Drewsville', 43.128059387207, 0.752726636302411, -72.3925018310547, -1.26348751070793, 218, 36, 'PPL', 'P'),
(148335, 'Drewville Heights', 41.3919410705566, 0.72242565547268, -73.6363906860352, -1.2851974667562, 218, 40, 'PPL', 'P'),
(15817, 'Drexel', 28.2425003051758, 0.492924619320821, -82.4599990844727, -1.43919848521556, 218, 12, 'PPL', 'P'),
(46675, 'Drexel', 39.5538902282715, 0.690345616455749, -76.3727798461914, -1.33295646721681, 218, 25, 'PPL', 'P'),
(54485, 'Drexel', 38.4794387817383, 0.671592901060929, -94.6083297729492, -1.65122685435054, 218, 29, 'PPL', 'P'),
(64269, 'Drexel', 35.7577781677246, 0.62409096222454, -81.6044387817383, -1.42426614098348, 218, 33, 'PPL', 'P'),
(72341, 'Drexel', 39.7463912963867, 0.693705393907966, -84.2866668701172, -1.47107985241517, 218, 41, 'PPL', 'P'),
(196373, 'Drexel', 47.3266716003418, 0.826006243436058, -115.251670837402, -2.0115211245374, 218, 31, 'PPL', 'P'),
(32263, 'Drexel Corner', 38.476390838623, 0.671539704418154, -94.6763916015625, -1.65241475735477, 218, 20, 'PPL', 'P'),
(46676, 'Drexel Estates', 39.1049995422363, 0.682510996002899, -76.5972213745117, -1.33687371086421, 218, 25, 'PPL', 'P'),
(29660, 'Drexel Gardens', 39.7405586242676, 0.693603594575297, -86.2463912963867, -1.50528349608533, 218, 19, 'PPL', 'P'),
(178112, 'Drexel Heights', 32.1411094665527, 0.560968185435264, -111.027778625488, -1.93780029819015, 218, 5, 'PPL', 'P'),
(78143, 'Drexel Hill', 39.9469413757324, 0.697205653107684, -75.2925033569336, -1.31410208564737, 218, 45, 'PPL', 'P'),
(160903, 'Drexel Hills', 40.225830078125, 0.702073179211049, -76.8819427490234, -1.34184303630024, 218, 45, 'PPL', 'P'),
(46677, 'Drexel Woods', 39.295280456543, 0.685832024461255, -76.7694396972656, -1.33987948762852, 218, 25, 'PPL', 'P'),
(64271, 'Drexelbrook', 35.586669921875, 0.621104559957152, -77.3613891601563, -1.35021095476138, 218, 33, 'PPL', 'P'),
(93819, 'Dreyer', 29.3669395446777, 0.512549786288751, -97.2727813720703, -1.69773030751523, 218, 51, 'PPL', 'P'),
(191395, 'Dreyfoos', 35.9880599975586, 0.62811013836266, -100.040000915527, -1.74602739967409, 218, 51, 'PPL', 'P'),
(35631, 'Dreyfus', 37.6172218322754, 0.6565443764263, -84.1766662597656, -1.46915997958533, 218, 21, 'PPL', 'P'),
(40698, 'Dreyfus (historical)', 30.2194404602051, 0.527428734140969, -91.0694427490234, -1.58946162392694, 218, 22, 'PPL', 'P'),
(35632, 'Drift', 37.480281829834, 0.654154322506008, -82.7477798461914, -1.44422120703145, 218, 21, 'PPL', 'P'),
(200724, 'Drift Creek', 44.4130592346191, 0.775154114527377, -123.994438171387, -2.16411120025124, 218, 43, 'PPL', 'P'),
(211797, 'Drift River', 60.5916709899902, 1.05752415806046, -152.161117553711, -2.6557124948264, 218, 1, 'PPL', 'P'),
(108951, 'Drift Run', 38.9402809143066, 0.679636113606159, -81.6344375610352, -1.42478971845379, 218, 58, 'PPL', 'P'),
(160904, 'Drifting', 41.024169921875, 0.716006838034344, -78.1086120605469, -1.3632524546195, 218, 45, 'PPL', 'P'),
(2105, 'Drifton', 33.6813888549805, 0.587851132163932, -87.232780456543, -1.52249923463604, 218, 2, 'PPL', 'P'),
(15818, 'Drifton', 30.4952793121338, 0.532243030312046, -83.8794403076172, -1.46397240809797, 218, 12, 'PPL', 'P'),
(160905, 'Drifton', 40.9997215270996, 0.715580133048686, -75.9058303833008, -1.32480666164895, 218, 45, 'PPL', 'P'),
(2103, 'Driftwood', 33.5255584716797, 0.585131378900689, -87.2375030517578, -1.52258165947178, 218, 2, 'PPL', 'P'),
(8596, 'Driftwood', 35.9711112976074, 0.627814327744579, -91.2519378662109, -1.59264676459067, 218, 4, 'PPL', 'P'),
(75686, 'Driftwood', 36.8791694641113, 0.643662932549695, -98.3591690063477, -1.71669134868633, 218, 42, 'PPL', 'P'),
(93820, 'Driftwood', 30.1227798461914, 0.525741688169431, -98.0305633544922, -1.71095609812079, 218, 51, 'PPL', 'P'),
(148336, 'Driftwood', 42.1238899230957, 0.735200572905681, -79.3294372558594, -1.384559873869, 218, 40, 'PPL', 'P'),
(155030, 'Driftwood', 41.7461090087891, 0.728607052099836, -81.3063888549805, -1.41906418842623, 218, 41, 'PPL', 'P'),
(160906, 'Driftwood', 41.3397216796875, 0.721514255168628, -78.1344375610352, -1.36370319463399, 218, 45, 'PPL', 'P'),
(15819, 'Driftwood Acres', 26.0277805328369, 0.454270467284488, -80.2266693115234, -1.40021952739478, 218, 12, 'PPL', 'P'),
(207236, 'Driftwood Acres', 47.2727813720703, 0.82506568151807, -121.073333740234, -2.11312831013303, 218, 56, 'PPL', 'P'),
(46678, 'Driftwood Beach', 38.3502807617188, 0.669338668356231, -76.3986129760742, -1.33340734038936, 218, 25, 'PPL', 'P'),
(15820, 'Driftwood Estates', 26.0327796936035, 0.454357719099702, -80.2408294677734, -1.40046666874394, 218, 12, 'PPL', 'P'),
(203757, 'Driftwood Estates', 40.6363906860352, 0.709238813598071, -111.852783203125, -1.95219934441394, 218, 52, 'PPL', 'P'),
(29661, 'Driftwood Hills', 39.9169387817383, 0.696682009058347, -86.1222229003906, -1.50311634874828, 218, 19, 'PPL', 'P'),
(8597, 'Driftwood Shores', 35.4652786254883, 0.61898588215194, -92.0944366455078, -1.60735114223343, 218, 4, 'PPL', 'P'),
(207235, 'Driftwood Shores', 48.1925010681152, 0.841117818409495, -122.471939086914, -2.13753857836859, 218, 56, 'PPL', 'P'),
(20679, 'Driftwood Station', 34.098331451416, 0.595128153263546, -84.4902801513672, -1.47463357457377, 218, 13, 'PPL', 'P'),
(40699, 'Driftwood Trailer Park', 31.3291702270508, 0.546797172379816, -92.5247192382813, -1.61486099019135, 218, 22, 'PPL', 'P'),
(13677, 'Driftwood Village Mobile Home Park', 38.6097183227539, 0.673866707999638, -75.1963882446289, -1.31242456047673, 218, 10, 'PPL', 'P'),
(80746, 'Drigger Crossroads', 32.9288902282715, 0.574717553511125, -80.5802764892578, -1.40639113690493, 218, 48, 'PPL', 'P'),
(80747, 'Driggerstown', 33.0302810668945, 0.576487157476455, -80.0913925170898, -1.39785850193037, 218, 48, 'PPL', 'P'),
(8598, 'Driggs', 35.2363891601563, 0.614991007358766, -93.772216796875, -1.6366339299994, 218, 4, 'PPL', 'P'),
(194854, 'Driggs', 43.723331451416, 0.763116093768001, -111.110557556152, -1.93924506308152, 218, 17, 'PPL', 'P'),
(160907, 'Drinker', 41.3950004577637, 0.722479051852536, -75.4649963378906, -1.31711265610165, 218, 45, 'PPL', 'P'),
(72342, 'Drinkle', 39.5911102294922, 0.690995228024647, -82.7283325195313, -1.44388178715052, 218, 41, 'PPL', 'P'),
(127292, 'Drinkwater Corner', 44.1108283996582, 0.769879191356257, -70.0908279418945, -1.2233157230349, 218, 26, 'PPL', 'P'),
(35634, 'Drip Rock', 37.5750007629395, 0.655807479752675, -83.9736099243164, -1.46561597796471, 218, 21, 'PPL', 'P'),
(2106, 'Dripping Springs', 34.2422218322754, 0.597639514171491, -87.0044403076172, -1.51851394722279, 218, 2, 'PPL', 'P'),
(8600, 'Dripping Springs', 35.5330581665039, 0.620168858308153, -94.398063659668, -1.64755701836841, 218, 4, 'PPL', 'P'),
(75690, 'Dripping Springs', 36.1738891601563, 0.631353469096213, -94.6719436645508, -1.652337126209, 218, 42, 'PPL', 'P'),
(93822, 'Dripping Springs', 30.1900005340576, 0.526914910498152, -98.0863876342773, -1.71193041560559, 218, 51, 'PPL', 'P'),
(8601, 'Dripping Springs (historical)', 34.5347213745117, 0.602744594244091, -92.9816665649414, -1.62283622554975, 218, 4, 'PPL', 'P'),
(86590, 'Dripping Springs Subdivision', 35.1958312988281, 0.614283139141023, -86.1455612182617, -1.503523679237, 218, 50, 'PPL', 'P'),
(93823, 'Driscoll', 27.6741695404053, 0.483005376235198, -97.7483291625977, -1.70603018221052, 218, 51, 'PPL', 'P'),
(160909, 'Driscoll', 40.5294418334961, 0.707372203990034, -78.6624984741211, -1.37291959621843, 218, 45, 'PPL', 'P'),
(198208, 'Driscoll', 46.8441696166992, 0.817584995174091, -100.14111328125, -1.74779214337043, 218, 34, 'PPL', 'P'),
(40700, 'Driscoll (historical)', 32.4144401550293, 0.565738705895922, -92.8947219848633, -1.62131875636063, 218, 22, 'PPL', 'P'),
(20680, 'Driskolls', 33.7336082458496, 0.588762532467984, -84.9608306884766, -1.48284623074336, 218, 13, 'PPL', 'P'),
(8602, 'Driver', 35.6122207641602, 0.621550506281686, -90.0119400024414, -1.5710047191502, 218, 4, 'PPL', 'P'),
(46685, 'Driver', 39.3380584716797, 0.686578641672859, -76.8944396972656, -1.34206114919352, 218, 25, 'PPL', 'P'),
(101510, 'Driver', 36.8230590820313, 0.642683621637846, -76.5027770996094, -1.3352253473075, 218, 53, 'PPL', 'P'),
(26986, 'Drivers', 38.3305587768555, 0.668994454785338, -88.9930572509766, -1.55322186044535, 218, 18, 'PPL', 'P'),
(64272, 'Drivers Store', 35.6963882446289, 0.623019505938973, -77.8186111450195, -1.35819098380975, 218, 33, 'PPL', 'P'),
(160910, 'Dromgold', 40.3461112976074, 0.704172482519331, -77.1919403076172, -1.34725351437084, 218, 45, 'PPL', 'P'),
(20681, 'Drone', 33.0552787780762, 0.576923449842037, -82.1588897705078, -1.43394313627845, 218, 13, 'PPL', 'P'),
(108953, 'Droop', 38.0769386291504, 0.66456794815849, -80.2852783203125, -1.40124244756948, 218, 58, 'PPL', 'P'),
(108952, 'Droop Mountain', 38.0250015258789, 0.663661474702455, -80.2566680908203, -1.40074310486509, 218, 58, 'PPL', 'P'),
(93824, 'Drop', 33.1308288574219, 0.578242047476763, -97.3555603027344, -1.6991750724066, 218, 51, 'PPL', 'P'),
(86591, 'Drop (historical)', 35.9283294677734, 0.627067643953948, -85.6516723632813, -1.49490369257869, 218, 50, 'PPL', 'P'),
(95, 'Dropmore', 37.2874984741211, 0.650789618205775, -80.0583267211914, -1.39728139492215, 218, 53, 'PPL', 'P'),
(101508, 'Drouin Hill', 37.5833282470703, 0.655952821769166, -77.6113891601563, -1.35457427789136, 218, 53, 'PPL', 'P'),
(173857, 'Drovers Woods', 43.1694412231445, 0.75344888559004, -89.1313934326172, -1.55563628228962, 218, 57, 'PPL', 'P'),
(86592, 'Drowning Creek', 36.0550003051758, 0.629278467132878, -85.1374969482422, -1.48592963865345, 218, 50, 'PPL', 'P'),
(64273, 'Drowning Creek (historical)', 35.7299995422363, 0.623606133748091, -81.4786071777344, -1.42206996519055, 218, 33, 'PPL', 'P'),
(101509, 'Drowning Ford', 36.6513900756836, 0.639687432253452, -81.8411102294922, -1.42839683699225, 218, 53, 'PPL', 'P'),
(119406, 'Druce Lake', 42.3716697692871, 0.739525147041806, -88.0025024414063, -1.53593341759689, 218, 18, 'PPL', 'P'),
(173858, 'Druecker', 43.439998626709, 0.758171003097887, -87.8711090087891, -1.53364016958222, 218, 57, 'PPL', 'P'),
(101513, 'Druid (historical)', 36.7150001525879, 0.640797637532879, -77.1449966430664, -1.34643419286148, 218, 53, 'PPL', 'P'),
(20682, 'Druid Hills', 33.7802810668945, 0.589577126866412, -84.3361129760742, -1.47194284976641, 218, 13, 'PPL', 'P'),
(35635, 'Druid Hills', 38.2636108398438, 0.667825992857066, -85.6616668701172, -1.49507812963009, 218, 21, 'PPL', 'P'),
(64274, 'Druid Hills', 35.3319396972656, 0.616658678833374, -82.4730606079102, -1.43942645180487, 218, 33, 'PPL', 'P'),
(80748, 'Druid Hills', 34.2297210693359, 0.597421334699186, -82.1855621337891, -1.434408656837, 218, 48, 'PPL', 'P'),
(86593, 'Druid Hills', 36.0022201538086, 0.628357279711819, -84.8772201538086, -1.48138695162405, 218, 50, 'PPL', 'P'),
(101511, 'Druid Hills', 37.25, 0.650135146367888, -76.741943359375, -1.33939958600009, 218, 53, 'PPL', 'P'),
(160911, 'Druid Hills', 41.3294410705566, 0.721334824690183, -75.9638900756836, -1.32581999444372, 218, 45, 'PPL', 'P'),
(20683, 'Druid Oaks', 31.1555595397949, 0.543767094270551, -81.3836135864258, -1.42041201425392, 218, 13, 'PPL', 'P'),
(15821, 'Druid Park', 28.7766704559326, 0.502247647217402, -81.2772216796875, -1.41855512518386, 218, 12, 'PPL', 'P'),
(35636, 'Drum', 37.0936088562012, 0.647405605987638, -84.4802780151367, -1.47445900436432, 218, 21, 'PPL', 'P'),
(54486, 'Drum', 37.1886100769043, 0.649063690082322, -89.8936080932617, -1.56893943772484, 218, 29, 'PPL', 'P'),
(181209, 'Drum (historical)', 39.2491683959961, 0.685027217179833, -120.752502441406, -2.10752874762503, 218, 6, 'PPL', 'P'),
(64276, 'Drum Hill', 36.5416717529297, 0.637772486271631, -76.7255630493164, -1.33911369565707, 218, 33, 'PPL', 'P'),
(46680, 'Drum Point', 38.3266716003418, 0.668926610756569, -76.4263916015625, -1.33389216886581, 218, 25, 'PPL', 'P'),
(20684, 'Drum Point Landing', 31.6836109161377, 0.55298332940742, -81.274169921875, -1.41850186196206, 218, 13, 'PPL', 'P'),
(75693, 'Drumb', 34.9297218322754, 0.609638652778952, -95.480827331543, -1.66645480946362, 218, 42, 'PPL', 'P'),
(46681, 'Drumcliff', 38.3899993896484, 0.670031889187979, -76.5699996948242, -1.33639860292574, 218, 25, 'PPL', 'P'),
(46682, 'Drumeldra Hills', 39.0819396972656, 0.682108525783161, -77.0202789306641, -1.34425745814451, 218, 25, 'PPL', 'P'),
(101515, 'Drumgoole (historical)', 36.5522193908691, 0.637956577281983, -77.8294372558594, -1.35837993508909, 218, 53, 'PPL', 'P'),
(124662, 'Drumlin Farms', 42.0783309936523, 0.734405419583211, -70.904167175293, -1.23751117059335, 218, 23, 'PPL', 'P'),
(64277, 'Drummersville', 35.1755599975586, 0.613929338190206, -77.8391723632813, -1.35854984476663, 218, 33, 'PPL', 'P'),
(2109, 'Drummond', 33.7827796936035, 0.589620736129262, -87.0186080932617, -1.51876122173, 218, 2, 'PPL', 'P'),
(46683, 'Drummond', 38.9700012207031, 0.680154830807479, -77.0977783203125, -1.34561007766216, 218, 25, 'PPL', 'P'),
(75691, 'Drummond', 36.3002815246582, 0.633559432006153, -98.0355606079102, -1.71104331664649, 218, 42, 'PPL', 'P'),
(119408, 'Drummond', 41.4058303833008, 0.722668069710904, -88.1766662597656, -1.5389731496651, 218, 18, 'PPL', 'P'),
(130542, 'Drummond', 46.0200004577637, 0.803200529757274, -83.7311096191406, -1.4613835492023, 218, 27, 'PPL', 'P'),
(160912, 'Drummond', 41.3066711425781, 0.720937414476516, -78.7283325195313, -1.37406861707074, 218, 45, 'PPL', 'P'),
(173859, 'Drummond', 46.3369407653809, 0.808732181657477, -91.2577819824219, -1.59274876366042, 218, 57, 'PPL', 'P'),
(194855, 'Drummond', 43.9986114501953, 0.767920636111585, -111.344436645508, -1.94332702324234, 218, 17, 'PPL', 'P'),
(196374, 'Drummond', 46.6674995422363, 0.814501520684971, -113.146392822266, -1.97477709150341, 218, 31, 'PPL', 'P'),
(13678, 'Drummond North', 39.726390838623, 0.693356320068083, -75.716667175293, -1.32150514084558, 218, 10, 'PPL', 'P'),
(13679, 'Drummond Ridge', 39.7194404602051, 0.69323501308043, -75.6986083984375, -1.32118995573057, 218, 10, 'PPL', 'P'),
(86594, 'Drummonds', 35.4633293151855, 0.618951860269014, -89.9100036621094, -1.56922559438397, 218, 50, 'PPL', 'P'),
(101514, 'Drummonds Corner', 37.0933303833008, 0.647400745718649, -76.3927764892578, -1.33330547447766, 218, 53, 'PPL', 'P'),
(78144, 'Drumore', 39.7916717529297, 0.694495686961447, -76.2652816772461, -1.33108027022885, 218, 45, 'PPL', 'P'),
(78145, 'Drumore Center', 39.8375015258789, 0.695295567394852, -76.2161102294922, -1.33022206656757, 218, 45, 'PPL', 'P'),
(75692, 'Drumright', 35.9883308410645, 0.628114865473595, -96.600830078125, -1.68600254502285, 218, 42, 'PPL', 'P'),
(160913, 'Drums', 41.0180587768555, 0.715900178432686, -75.9952774047852, -1.32636780667995, 218, 45, 'PPL', 'P'),
(64278, 'Drums Crossroads', 35.6130599975586, 0.621565153667681, -81.10888671875, -1.41561712586929, 218, 33, 'PPL', 'P'),
(32265, 'Drury', 37.0355606079102, 0.646392472929945, -97.4775009155273, -1.70130333759174, 218, 20, 'PPL', 'P'),
(46684, 'Drury', 38.8122215270996, 0.67740105566131, -76.6930618286133, -1.33854644234489, 218, 25, 'PPL', 'P'),
(54487, 'Drury', 36.9300003051758, 0.644550098087828, -92.3225021362305, -1.61133163595672, 218, 29, 'PPL', 'P'),
(124660, 'Drury', 42.6522216796875, 0.744421701601053, -72.9980621337891, -1.27405653181002, 218, 23, 'PPL', 'P'),
(143728, 'Drury', 42.8444404602051, 0.747776552205253, -71.9649963378906, -1.25602613228185, 218, 36, 'PPL', 'P'),
(160914, 'Drury Run', 41.329719543457, 0.721339684959173, -77.7788925170898, -1.357497762978, 218, 45, 'PPL', 'P'),
(124661, 'Drury Square', 42.2061080932617, 0.736635550680043, -71.8361129760742, -1.25377669326712, 218, 23, 'PPL', 'P'),
(93825, 'Druso', 31.3561096191406, 0.547267353470269, -95.3880615234375, -1.6648357406789, 218, 51, 'PPL', 'P'),
(20685, 'Dry Branch', 32.8005599975586, 0.572477768455341, -83.4986114501953, -1.45732569064935, 218, 13, 'PPL', 'P'),
(80750, 'Dry Branch', 33.4333305358887, 0.583521697758818, -81.7183303833008, -1.42625392442112, 218, 48, 'PPL', 'P'),
(86595, 'Dry Branch', 36.564998626709, 0.638179617023277, -83.147216796875, -1.451192696975, 218, 50, 'PPL', 'P'),
(101516, 'Dry Branch', 37.2344398498535, 0.649863570515727, -80.6183319091797, -1.40705532928079, 218, 53, 'PPL', 'P'),
(108954, 'Dry Branch', 38.1800003051758, 0.666366713737757, -81.4669418334961, -1.42186636652521, 218, 58, 'PPL', 'P'),
(2110, 'Dry Cove (historical)', 34.6213912963867, 0.604257269743256, -86.1419372558594, -1.50346042916112, 218, 2, 'PPL', 'P'),
(35637, 'Dry Creek', 37.3247184753418, 0.651439229774672, -82.7680587768555, -1.44457514114032, 218, 21, 'PPL', 'P'),
(40702, 'Dry Creek', 30.6688899993896, 0.535273108421311, -93.045280456543, -1.62394649740821, 218, 22, 'PPL', 'P'),
(75694, 'Dry Creek', 35.7369384765625, 0.623727240998662, -94.8730621337891, -1.65584730568378, 218, 42, 'PPL', 'P'),
(86596, 'Dry Creek', 36.2066688537598, 0.631925582677389, -82.4352798461914, -1.43876705311896, 218, 50, 'PPL', 'P'),
(108955, 'Dry Creek', 37.8597183227539, 0.660776738609681, -81.4638900756836, -1.42181310330341, 218, 58, 'PPL', 'P'),
(112433, 'Dry Creek', 34.6680603027344, 0.605071797562657, -88.7361068725586, -1.54873723032772, 218, 30, 'PPL', 'P'),
(199925, 'Dry Creek', 40.4425010681152, 0.705854801379934, -115.61833190918, -2.01792056747881, 218, 39, 'PPL', 'P'),
(200725, 'Dry Creek', 44.5052795410156, 0.776763662511193, -123.274436950684, -2.15154480833159, 218, 43, 'PPL', 'P'),
(209413, 'Dry Creek', 44.3136100769043, 0.773418399286918, -108.9375, -1.90131805389132, 218, 59, 'PPL', 'P'),
(211798, 'Dry Creek', 63.6533317565918, 1.11096021901679, -144.665283203125, -2.52488550522458, 218, 1, 'PPL', 'P'),
(8603, 'Dry Creek (historical)', 35.8972206115723, 0.626524691986708, -92.9011077880859, -1.62143020965225, 218, 4, 'PPL', 'P'),
(86597, 'Dry Creek Estates', 35.190559387207, 0.614191126925361, -86.1430587768555, -1.50348000339513, 218, 50, 'PPL', 'P'),
(20686, 'Dry Creek Subdivision', 31.4527797698975, 0.548954565889375, -83.9958267211914, -1.46600373421942, 218, 13, 'PPL', 'P'),
(86598, 'Dry Creek Subdivision', 36.0933303833008, 0.629947453198706, -87.9300003051758, -1.53466801660494, 218, 50, 'PPL', 'P'),
(207237, 'Dry Falls Junction', 47.6263885498047, 0.831237291028219, -119.331108093262, -2.08272073628067, 218, 56, 'PPL', 'P'),
(35639, 'Dry Fork', 37.3305587768555, 0.651541162265395, -82.4319381713867, -1.43870872989109, 218, 21, 'PPL', 'P'),
(101519, 'Dry Fork', 36.9141693115234, 0.644273795124732, -82.3949966430664, -1.43806397859118, 218, 53, 'PPL', 'P'),
(209906, 'Dry Fork', 40.5574989318848, 0.707861892735473, -109.668609619141, -1.91407832393833, 218, 52, 'PPL', 'P'),
(86599, 'Dry Fork (historical)', 36.2586097717285, 0.632832122712452, -86.8522186279297, -1.51585717771933, 218, 50, 'PPL', 'P'),
(2111, 'Dry Forks', 31.9013900756836, 0.556784292783722, -87.3666687011719, -1.52483602533453, 218, 2, 'PPL', 'P'),
(194856, 'Dry Forty', 42.4511108398438, 0.740911655284329, -116.412498474121, -2.03178138884629, 218, 17, 'PPL', 'P'),
(86600, 'Dry Gap', 36.0555610656738, 0.629288254249884, -83.9705581665039, -1.46556271474291, 218, 50, 'PPL', 'P'),
(59710, 'Dry Grove', 32.1288909912109, 0.560754932810975, -90.436393737793, -1.57841283435447, 218, 30, 'PPL', 'P'),
(86603, 'Dry Hill', 36.3263893127441, 0.634015098868665, -81.9511108398438, -1.43031670982209, 218, 50, 'PPL', 'P'),
(108958, 'Dry Hill', 37.814998626709, 0.659996232673206, -81.2200012207031, -1.41755643977508, 218, 58, 'PPL', 'P'),
(112301, 'Dry Hill', 37.8172187805176, 0.660034981667067, -89.5533294677734, -1.56300045533591, 218, 18, 'PPL', 'P'),
(160915, 'Dry Hill', 40.0608291625977, 0.699193369966292, -79.6138916015625, -1.38952453877313, 218, 45, 'PPL', 'P'),
(190134, 'Dry Lake', 36.4566688537598, 0.636288905807375, -114.842216491699, -2.00437479806828, 218, 39, 'PPL', 'P'),
(209874, 'Dry Lake', 48.0511093139648, 0.8386500667644, -108.64582824707, -1.89622742146764, 218, 31, 'PPL', 'P'),
(127293, 'Dry Mills', 43.9191703796387, 0.766534127869063, -70.3586120605469, -1.22798943758994, 218, 26, 'PPL', 'P'),
(20687, 'Dry Pond', 34.1913909912109, 0.596752348633358, -83.5749969482422, -1.45865886909104, 218, 13, 'PPL', 'P'),
(101520, 'Dry Pond', 36.5833282470703, 0.638499529249223, -80.3447189331055, -1.40227988197212, 218, 53, 'PPL', 'P'),
(40703, 'Dry Prong', 31.5811100006104, 0.551194350945159, -92.5327835083008, -1.61500173825496, 218, 22, 'PPL', 'P'),
(35640, 'Dry Ridge', 38.6819381713867, 0.675127182143573, -84.5899963378906, -1.47637395034614, 218, 21, 'PPL', 'P'),
(72343, 'Dry Ridge', 39.2591705322266, 0.685201787389288, -84.6191711425781, -1.47688314674656, 218, 41, 'PPL', 'P'),
(46686, 'Dry Run', 39.7127799987793, 0.693118766098848, -77.8813934326172, -1.35928674144026, 218, 25, 'PPL', 'P'),
(108959, 'Dry Run', 38.6127815246582, 0.673920170958522, -79.5250015258789, -1.3879731142801, 218, 58, 'PPL', 'P'),
(155032, 'Dry Run', 40.6366691589355, 0.70924367386706, -80.5352783203125, -1.40560577069946, 218, 41, 'PPL', 'P'),
(160916, 'Dry Run', 40.1674995422363, 0.701055119305339, -77.7541732788086, -1.3570663308814, 218, 45, 'PPL', 'P'),
(160918, 'Dry Tavern', 40.8069381713867, 0.712215428748452, -75.7213897705078, -1.32158756568131, 218, 45, 'PPL', 'P'),
(160917, 'Dry Top', 40.9566688537598, 0.71482872214712, -77.7966690063477, -1.35780802124499, 218, 45, 'PPL', 'P'),
(2114, 'Dry Valley', 33.5833282470703, 0.586139651689393, -86.0908279418945, -1.50256840335399, 218, 2, 'PPL', 'P'),
(54490, 'Dry Valley', 37.0250015258789, 0.646208182182511, -94.041389465332, -1.64133187932035, 218, 29, 'PPL', 'P'),
(86604, 'Dry Valley', 36.1066703796387, 0.630180280057006, -85.4438934326172, -1.49127726612233, 218, 50, 'PPL', 'P'),
(93826, 'Dry Valley', 33.5544395446777, 0.585635448716013, -97.690559387207, -1.70502190942182, 218, 51, 'PPL', 'P'),
(160919, 'Dry Valley Crossroads', 40.8916702270508, 0.713694282101773, -76.9147186279297, -1.34241508330239, 218, 45, 'PPL', 'P'),
(32266, 'Dry Wood', 37.6597213745117, 0.657286133368914, -94.7125015258789, -1.65304499442674, 218, 20, 'PPL', 'P'),
(207238, 'Dryad', 46.6369400024414, 0.813968156097655, -123.25, -2.15111830308301, 218, 56, 'PPL', 'P'),
(46689, 'Drybranch', 39.6636085510254, 0.69226056243757, -76.5436096191406, -1.33593800921521, 218, 25, 'PPL', 'P'),
(101526, 'Dryburg', 36.7311096191406, 0.641078800764964, -78.7219390869141, -1.37395703062107, 218, 53, 'PPL', 'P'),
(130547, 'Dryburg', 46.2105598449707, 0.806526418484619, -84.6772232055664, -1.47789634638328, 218, 27, 'PPL', 'P'),
(8610, 'Dryden', 35.834171295166, 0.625424273824288, -90.9088897705078, -1.58665944582795, 218, 4, 'PPL', 'P'),
(101521, 'Dryden', 36.7775001525879, 0.641888468315376, -82.9416732788086, -1.44760528582861, 218, 53, 'PPL', 'P'),
(127294, 'Dryden', 44.586669921875, 0.778184192636642, -70.2102813720703, -1.22540057869427, 218, 26, 'PPL', 'P'),
(130544, 'Dryden', 42.9461097717285, 0.749551016439573, -83.123893737793, -1.45078563280238, 218, 27, 'PPL', 'P'),
(148337, 'Dryden', 42.4908294677734, 0.741604876116076, -76.2975006103516, -1.33164259669302, 218, 40, 'PPL', 'P'),
(191396, 'Dryden', 30.0444393157959, 0.524374387976271, -102.114166259766, -1.78222841416181, 218, 51, 'PPL', 'P'),
(194857, 'Dryden', 46.1361083984375, 0.805226995609742, -116.200561523438, -2.02808239125022, 218, 17, 'PPL', 'P'),
(200726, 'Dryden', 42.269718170166, 0.73774575595947, -123.536109924316, -2.15611186328496, 218, 43, 'PPL', 'P'),
(207240, 'Dryden', 47.541389465332, 0.82975377714299, -120.559722900391, -2.10416410990382, 218, 56, 'PPL', 'P'),
(54491, 'Dryden (historical)', 36.6811103820801, 0.640206149454773, -90.7477798461914, -1.58384754719099, 218, 29, 'PPL', 'P'),
(191397, 'Dryden Crossing', 29.8108291625977, 0.520297121636873, -102.14778137207, -1.78281510854996, 218, 51, 'PPL', 'P'),
(35641, 'Dryden Estates', 36.9427795410156, 0.644773137829122, -87.9955596923828, -1.53581224376729, 218, 21, 'PPL', 'P'),
(35642, 'Drydock', 37.9886093139648, 0.663026310782471, -85.0224990844727, -1.48392254729791, 218, 21, 'PPL', 'P'),
(196377, 'Dryer Place', 47.7430610656738, 0.833273610576721, -107.564720153809, -1.87735852567026, 218, 31, 'PPL', 'P'),
(8607, 'Dryfork', 36.1533317565918, 0.630994674718352, -93.4888916015625, -1.63168897248734, 218, 4, 'PPL', 'P'),
(108960, 'Dryfork', 38.9686088562012, 0.680130529462532, -79.503059387207, -1.38759015171535, 218, 58, 'PPL', 'P'),
(196375, 'Dryhead (historical)', 45.1763916015625, 0.78847677761758, -108.27278137207, -1.88971652523461, 218, 31, 'PPL', 'P'),
(35643, 'Dryhill', 37.2219390869141, 0.649645391043422, -83.3775024414063, -1.45521193969215, 218, 21, 'PPL', 'P'),
(196376, 'Dryland (historical)', 47.0116691589355, 0.820508413681699, -108.94750213623, -1.90149262410078, 218, 31, 'PPL', 'P'),
(54492, 'Drynob', 37.6416702270508, 0.656971081411958, -92.4502792358398, -1.61356176705355, 218, 29, 'PPL', 'P'),
(64280, 'Drys Mill (historical)', 35.485279083252, 0.619334955991822, -80.3361129760742, -1.40212967968664, 218, 33, 'PPL', 'P'),
(59712, 'Drysdale', 32.6916694641113, 0.570577270122433, -89.6341705322266, -1.56441139808143, 218, 30, 'PPL', 'P'),
(64281, 'Drysdale Hills', 35.3241691589355, 0.616523057354861, -82.600830078125, -1.44165644974365, 218, 33, 'PPL', 'P'),
(101522, 'Drytown', 37.1472206115723, 0.648341307636638, -81.491943359375, -1.42230272546982, 218, 53, 'PPL', 'P'),
(160920, 'Drytown', 40.2200012207031, 0.701971446457408, -77.1416702270508, -1.34637613594972, 218, 45, 'PPL', 'P'),
(181210, 'Drytown', 38.4411087036133, 0.670923914995101, -120.853332519531, -2.10928856447335, 218, 6, 'PPL', 'P'),
(160921, 'Dryville', 40.464168548584, 0.706232970254726, -75.75, -1.3220869083857, 218, 45, 'PPL', 'P'),
(173861, 'Drywood', 45.0483283996582, 0.786241653093704, -91.1680603027344, -1.59118282493945, 218, 57, 'PPL', 'P'),
(26988, 'Du Bois', 38.2238883972168, 0.667132705446291, -89.2122192382813, -1.55704695871904, 218, 18, 'PPL', 'P'),
(141688, 'Du Bois', 40.0347213745117, 0.698737703103779, -96.0480575561523, -1.67635484449988, 218, 35, 'PPL', 'P'),
(160922, 'Du Bois', 41.1191711425781, 0.717664922129027, -78.7602767944336, -1.37462614984495, 218, 45, 'PPL', 'P'),
(80753, 'Du Bose Park', 34.2477798461914, 0.597736519814197, -80.5833282470703, -1.40644440012673, 218, 48, 'PPL', 'P'),
(20690, 'Du Pont', 30.9883308410645, 0.540848402873878, -82.8716735839844, -1.44638356067854, 218, 13, 'PPL', 'P'),
(26990, 'Du Quoin', 38.0113906860352, 0.66342392073322, -89.2361068725586, -1.55746387658769, 218, 18, 'PPL', 'P'),
(46687, 'Du-Mar Estates', 38.5722198486328, 0.673212236161751, -77.165283203125, -1.34678826012841, 218, 25, 'PPL', 'P'),
(64285, 'Duan', 35.6150016784668, 0.621599042392552, -81.2127838134766, -1.41743047225552, 218, 33, 'PPL', 'P'),
(101523, 'Duane', 37.8663902282715, 0.660893185328345, -77.246940612793, -1.34821345078576, 218, 53, 'PPL', 'P'),
(139905, 'Duane', 46.0722198486328, 0.804111930061326, -98.5419387817383, -1.71988128304002, 218, 34, 'PPL', 'P'),
(148339, 'Duane', 42.7541694641113, 0.746201026104362, -74.1488876342773, -1.29414222590945, 218, 40, 'PPL', 'P'),
(148340, 'Duane Center', 44.6594390869141, 0.7794542541605, -74.2644424438477, -1.29615903780297, 218, 40, 'PPL', 'P'),
(101524, 'Duane Fork', 37.8741683959961, 0.661028939964911, -77.230827331543, -1.34793222097465, 218, 53, 'PPL', 'P'),
(148341, 'Duane Lake', 42.753059387207, 0.746181651607432, -74.1080627441406, -1.2934296971598, 218, 40, 'PPL', 'P'),
(29663, 'Duane Yards', 39.4949989318848, 0.689317769433033, -87.3886108398438, -1.52521898789928, 218, 19, 'PPL', 'P'),
(148343, 'Duanesburg', 42.7619400024414, 0.746336647582875, -74.1341705322266, -1.29388536402231, 218, 40, 'PPL', 'P'),
(64282, 'Duart', 34.7933311462402, 0.607258186238585, -78.8180618286133, -1.37563468894976, 218, 33, 'PPL', 'P'),
(181211, 'Duarte', 34.1394386291504, 0.595845608861214, -117.976387023926, -2.05907639317462, 218, 6, 'PPL', 'P'),
(8609, 'Dub', 35.5222206115723, 0.61997970729173, -90.3574981689453, -1.57703584691284, 218, 4, 'PPL', 'P'),
(40708, 'Dubach', 32.6988906860352, 0.570703304221021, -92.6566696166992, -1.61716395874399, 218, 22, 'PPL', 'P'),
(59711, 'Dubard', 33.7763900756836, 0.589509216258615, -89.9186096191406, -1.56937579666945, 218, 30, 'PPL', 'P'),
(40704, 'Dubberly', 32.5366706848145, 0.56787203108713, -93.2422180175781, -1.62738370626912, 218, 22, 'PPL', 'P'),
(59715, 'Dubbs', 34.5683288574219, 0.603331155474181, -90.3736114501953, -1.57731707672396, 218, 30, 'PPL', 'P'),
(93827, 'Dubina', 29.728609085083, 0.518862110572998, -96.8327789306641, -1.69005081619588, 218, 51, 'PPL', 'P'),
(2113, 'Dublin', 32.0319404602051, 0.559062826833366, -86.1591720581055, -1.50376123320624, 218, 2, 'PPL', 'P'),
(8611, 'Dublin', 35.3619384765625, 0.617182256303683, -93.4711074829102, -1.63137858106229, 218, 4, 'PPL', 'P'),
(15822, 'Dublin', 28.7891693115234, 0.502465793400193, -81.6269378662109, -1.42465882408622, 218, 12, 'PPL', 'P'),
(20688, 'Dublin', 32.5402793884277, 0.567935014846911, -82.9038925170898, -1.44694588714271, 218, 13, 'PPL', 'P'),
(29664, 'Dublin', 39.8122215270996, 0.694854348181253, -85.2088928222656, -1.4871757317275, 218, 19, 'PPL', 'P'),
(35644, 'Dublin', 36.7252807617188, 0.640977068011323, -88.8022232055664, -1.54989117802805, 218, 21, 'PPL', 'P'),
(46688, 'Dublin', 39.6508293151855, 0.692037522696276, -76.2669372558594, -1.33110916552668, 218, 25, 'PPL', 'P'),
(59713, 'Dublin', 34.0722198486328, 0.594672419822007, -90.4905624389648, -1.57935825654145, 218, 30, 'PPL', 'P'),
(64283, 'Dublin', 34.6566696166992, 0.604872992587283, -78.7266693115234, -1.37403958861486, 218, 33, 'PPL', 'P'),
(93828, 'Dublin', 32.0849990844727, 0.559988874523414, -98.341667175293, -1.71638588410929, 218, 51, 'PPL', 'P'),
(101525, 'Dublin', 37.1055603027344, 0.647614198080019, -80.6855621337891, -1.40822871805708, 218, 53, 'PPL', 'P'),
(130546, 'Dublin', 44.1794395446777, 0.771076681740411, -85.9313888549805, -1.49978566633097, 218, 27, 'PPL', 'P'),
(143729, 'Dublin', 42.9075012207031, 0.748877170104756, -72.0630569458008, -1.25773761275639, 218, 36, 'PPL', 'P'),
(148345, 'Dublin', 42.9947204589844, 0.750399432983845, -76.9225006103516, -1.34255090451798, 218, 40, 'PPL', 'P'),
(155034, 'Dublin', 41.003059387207, 0.715638389697531, -80.7858276367188, -1.40997868120937, 218, 41, 'PPL', 'P'),
(160924, 'Dublin', 40.3716697692871, 0.70461856200192, -75.2019424438477, -1.31252149954041, 218, 45, 'PPL', 'P'),
(178113, 'Dublin', 32.896110534668, 0.574145439929948, -109.833610534668, -1.91695813318309, 218, 5, 'PPL', 'P'),
(181212, 'Dublin', 37.702220916748, 0.658027890311528, -121.934722900391, -2.12816238711875, 218, 6, 'PPL', 'P'),
(13680, 'Dublin Hill', 38.753059387207, 0.676368481527659, -75.6538925170898, -1.32040951637312, 218, 10, 'PPL', 'P'),
(46692, 'Dublin Manor', 39.6458282470703, 0.691950237591549, -76.2638931274414, -1.33105603546293, 218, 25, 'PPL', 'P'),
(160925, 'Dublin Mills', 40.1205596923828, 0.700235864375003, -78.0266723632813, -1.36182233711412, 218, 45, 'PPL', 'P'),
(203761, 'Dublin Town', 40.6561088562012, 0.709582960589936, -112.017776489258, -1.95507902050064, 218, 52, 'PPL', 'P'),
(40705, 'Duboin', 29.9233303070068, 0.522260637019075, -91.820556640625, -1.60257103439285, 218, 22, 'PPL', 'P'),
(20689, 'Dubois', 32.3033294677734, 0.563799458569154, -83.2733306884766, -1.45339379961595, 218, 13, 'PPL', 'P'),
(29665, 'Dubois', 38.4452781677246, 0.670996685871887, -86.804443359375, -1.51502334198202, 218, 19, 'PPL', 'P'),
(46693, 'Dubois', 38.4761085510254, 0.671534777570138, -76.8272171020508, -1.34088789357528, 218, 25, 'PPL', 'P'),
(194858, 'Dubois', 44.1763916015625, 0.771023485097637, -112.230003356934, -1.95878307810278, 218, 17, 'PPL', 'P'),
(209415, 'Dubois', 43.5336112976074, 0.759804852426651, -109.629722595215, -1.91339961733452, 218, 59, 'PPL', 'P'),
(27003, 'DuBois Center', 38.2516708374023, 0.667617600501767, -89.2113876342773, -1.55703244449109, 218, 18, 'PPL', 'P'),
(29667, 'Dubois Crossroads', 38.4811096191406, 0.671622062674865, -86.8119430541992, -1.5151542363496, 218, 19, 'PPL', 'P'),
(46694, 'Dubois Park', 38.4755592346191, 0.671525190190213, -76.8391723632813, -1.34109655224669, 218, 25, 'PPL', 'P'),
(148346, 'Duboise Corner', 42.4977798461914, 0.741726183103729, -76.5577774047852, -1.33618528372242, 218, 40, 'PPL', 'P'),
(160929, 'Duboistown', 41.2224998474121, 0.719468348240201, -77.0372161865234, -1.3445530690255, 218, 45, 'PPL', 'P'),
(80751, 'DuBose', 34.0533294677734, 0.594342720479055, -80.3461074829102, -1.40230411673804, 218, 48, 'PPL', 'P'),
(80754, 'Dubose Crossroads', 34.2566719055176, 0.597891715526722, -79.9824981689453, -1.39595793701843, 218, 48, 'PPL', 'P'),
(35645, 'Dubre', 36.8388900756836, 0.642959924600942, -85.5586090087891, -1.49327943062985, 218, 21, 'PPL', 'P'),
(108961, 'Dubree (historical)', 38.0525016784668, 0.664141442909914, -80.9877777099609, -1.41350337491209, 218, 58, 'PPL', 'P'),
(40706, 'Dubuisson', 30.7594394683838, 0.536853494791191, -92.0941696166992, -1.60734648170153, 218, 22, 'PPL', 'P'),
(32268, 'Dubuque', 38.6958312988281, 0.675369662960825, -98.6086120605469, -1.72104495127833, 218, 20, 'PPL', 'P'),
(115339, 'Dubuque', 42.500560760498, 0.741774719214596, -90.664436340332, -1.58239292860359, 218, 16, 'PPL', 'P'),
(155036, 'Ducat', 41.2830581665039, 0.720525290297827, -83.6699981689453, -1.46031695318572, 218, 41, 'PPL', 'P'),
(93829, 'Ducat Settlement', 30.2625007629395, 0.528180278200589, -94.6999969482422, -1.65282674837541, 218, 51, 'PPL', 'P'),
(46695, 'Ducat Town', 38.9538917541504, 0.679873667575394, -76.9199981689453, -1.34250722867611, 218, 25, 'PPL', 'P'),
(305, 'Duce', 33.7772216796875, 0.589523730486556, -91.2750015258789, -1.59304930138944, 218, 4, 'PPL', 'P'),
(72346, 'Duch Addition', 39.9416694641113, 0.697113640892022, -81.4155578613281, -1.42096954702813, 218, 41, 'PPL', 'P'),
(40707, 'Duchamp', 30.1022205352783, 0.525382860502057, -91.9180603027344, -1.60427279432941, 218, 22, 'PPL', 'P'),
(203762, 'Duchesne', 40.163330078125, 0.700982348428553, -110.402221679688, -1.92688226982721, 218, 52, 'PPL', 'P'),
(75696, 'Duchess Landing', 35.3916702270508, 0.617701173242085, -95.4158325195313, -1.6653204359973, 218, 42, 'PPL', 'P'),
(64286, 'Duck', 36.1694412231445, 0.631275837950437, -75.7555618286133, -1.32218398060744, 218, 33, 'PPL', 'P'),
(108962, 'Duck', 38.5833282470703, 0.673406114289109, -80.9369430541992, -1.41261614279493, 218, 58, 'PPL', 'P'),
(64287, 'Duck Creek', 34.5955581665039, 0.603806396570706, -77.2825012207031, -1.34883410047781, 218, 33, 'PPL', 'P'),
(86605, 'Duck Creek', 36.4911117553711, 0.636890047844433, -83.2233276367188, -1.45252108172673, 218, 50, 'PPL', 'P'),
(155038, 'Duck Creek', 41.1655616760254, 0.718474589679438, -80.8866729736328, -1.41173876437381, 218, 41, 'PPL', 'P'),
(173862, 'Duck Creek', 44.561939239502, 0.777752560802967, -88.0691680908203, -1.53709695267714, 218, 57, 'PPL', 'P'),
(20691, 'Duck Creek (historical)', 34.5811080932617, 0.603554195215475, -85.3677825927734, -1.4899488813706, 218, 13, 'PPL', 'P'),
(192544, 'Duck Creek Village', 37.523609161377, 0.654910527097536, -112.662216186523, -1.96632661504848, 218, 52, 'PPL', 'P'),
(124663, 'Duck Harbor (historical)', 42.4155616760254, 0.740291205329367, -71.6894378662109, -1.25121672966928, 218, 23, 'PPL', 'P'),
(59714, 'Duck Hill', 33.6330604553223, 0.587007642467677, -89.7111129760742, -1.5657542970611, 218, 30, 'PPL', 'P'),
(113176, 'Duck Island Roads', 41.2580604553223, 0.720088997932244, -72.5100021362305, -1.26553827790534, 218, 8, 'PPL', 'P'),
(15823, 'Duck Key', 24.7705593109131, 0.432327817535971, -80.9122161865234, -1.41218457754028, 218, 12, 'PPL', 'P'),
(130548, 'Duck Lake', 42.4000015258789, 0.740019629477207, -84.7822189331055, -1.47972886752936, 218, 27, 'PPL', 'P'),
(40709, 'Duck Port (historical)', 32.392219543457, 0.56535088306218, -91.0138931274414, -1.58849210013209, 218, 22, 'PPL', 'P'),
(2115, 'Duck Springs', 34.1458282470703, 0.595957128731861, -85.9991683959961, -1.50096864248718, 218, 2, 'PPL', 'P'),
(101527, 'Duck Woods', 37.1636085510254, 0.648627331137712, -77.3302764892578, -1.34966793621511, 218, 53, 'PPL', 'P'),
(207241, 'Duckabush', 47.6522216796875, 0.83168816420077, -122.93083190918, -2.14554776903089, 218, 56, 'PPL', 'P'),
(20692, 'Ducker', 31.5261096954346, 0.55023441453024, -84.3661117553711, -1.47246642723672, 218, 13, 'PPL', 'P'),
(35646, 'Duckers', 38.1644401550293, 0.666095137885596, -84.7838897705078, -1.4797580291433, 218, 21, 'PPL', 'P'),
(192545, 'Ducket Crossing', 37.7436103820801, 0.658750272757212, -110.279167175293, -1.92473456356612, 218, 52, 'PPL', 'P'),
(8612, 'Duckett', 34.2902793884277, 0.598478276756812, -94.2197189331055, -1.64444431568633, 218, 4, 'PPL', 'P'),
(8613, 'Duckett Ford', 34.2630615234375, 0.598003235397369, -94.1933288574219, -1.6439837219758, 218, 4, 'PPL', 'P'),
(46696, 'Duckettsville', 39.0111083984375, 0.680872286405146, -76.7988891601563, -1.34039347771891, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(113219, 'Duckfoot Landing', 40.5086097717285, 0.707008615922211, -84.4752807617188, -1.47437178583862, 218, 41, 'PPL', 'P'),
(40710, 'Duckroost', 30.2474994659424, 0.527918456175921, -90.8697204589844, -1.58597581237613, 218, 22, 'PPL', 'P'),
(35648, 'Duckrun', 36.7358283996582, 0.641161159021675, -84.3166732788086, -1.47160356304353, 218, 21, 'PPL', 'P'),
(160931, 'Duckrun', 40.9091682434082, 0.713999680099778, -80.2705612182617, -1.40098558568234, 218, 45, 'PPL', 'P'),
(143731, 'Ducks Head', 44.1408309936523, 0.770402835405594, -71.1883316040039, -1.2424707754914, 218, 36, 'PPL', 'P'),
(20693, 'Ducktown', 34.2438888549805, 0.5976686092064, -84.2494430541992, -1.47043017426724, 218, 13, 'PPL', 'P'),
(64288, 'Ducktown', 35.2313919067383, 0.614903788833066, -82.7477798461914, -1.44422120703145, 218, 33, 'PPL', 'P'),
(86607, 'Ducktown', 36.3358306884766, 0.634179881961114, -82.6291732788086, -1.44215113191613, 218, 50, 'PPL', 'P'),
(127295, 'Ducktrap', 44.295280456543, 0.773098487060972, -69.0083312988281, -1.20442259247161, 218, 26, 'PPL', 'P'),
(124665, 'Duckville', 42.2166709899902, 0.736819908006504, -72.3444366455078, -1.26264861496455, 218, 23, 'PPL', 'P'),
(108963, 'Duckwall', 39.5683288574219, 0.690597618073898, -78.1852798461914, -1.36459055990921, 218, 58, 'PPL', 'P'),
(190136, 'Duckwater', 38.9324989318848, 0.679500292390565, -115.713607788086, -2.01958344526345, 218, 39, 'PPL', 'P'),
(108964, 'Duckworth', 39.2772216796875, 0.685516839346245, -80.8763885498047, -1.41155926731633, 218, 58, 'PPL', 'P'),
(35647, 'Duco', 37.6055603027344, 0.65634084433999, -83.0272216796875, -1.44909838709376, 218, 21, 'PPL', 'P'),
(181213, 'Ducor', 35.8916702270508, 0.626427819502057, -119.04638671875, -2.07775141084464, 218, 6, 'PPL', 'P'),
(93830, 'Dude Hill Colonia Number 2', 26.2810001373291, 0.458689983113475, -98.3209991455078, -1.71602515893964, 218, 51, 'PPL', 'P'),
(93831, 'Dude Hill Number 1 Colonia', 26.2779998779297, 0.458637618708541, -98.3239974975586, -1.71607749005506, 218, 51, 'PPL', 'P'),
(54495, 'Dudenville', 37.3055610656738, 0.651104869899813, -94.0830612182617, -1.64205918861405, 218, 29, 'PPL', 'P'),
(96, 'Dudie', 38.7449989318848, 0.676227800043075, -77.8844375610352, -1.35933987150401, 218, 53, 'PPL', 'P'),
(2116, 'Dudley', 33.160831451416, 0.578765691526099, -87.3000030517578, -1.52367249025427, 218, 2, 'PPL', 'P'),
(20697, 'Dudley', 32.5422210693359, 0.567968903571782, -83.070556640625, -1.44985472484335, 218, 13, 'PPL', 'P'),
(27004, 'Dudley', 39.5766716003418, 0.690743226406498, -87.8499984741211, -1.53327172124541, 218, 18, 'PPL', 'P'),
(54496, 'Dudley', 36.7886085510254, 0.642082346442733, -90.0930633544922, -1.57242058874374, 218, 29, 'PPL', 'P'),
(64293, 'Dudley', 35.267219543457, 0.615529099057017, -78.0377807617188, -1.36201621524148, 218, 33, 'PPL', 'P'),
(72347, 'Dudley', 39.7005615234375, 0.69290551347456, -81.5088882446289, -1.42259846950888, 218, 41, 'PPL', 'P'),
(75697, 'Dudley', 35.8113899230957, 0.625026663873539, -97.0661087036133, -1.69412318897678, 218, 42, 'PPL', 'P'),
(80755, 'Dudley', 34.7808303833008, 0.60704000676628, -80.4977798461914, -1.40495129886157, 218, 48, 'PPL', 'P'),
(93832, 'Dudley', 32.2580604553223, 0.563009365252755, -99.6047210693359, -1.73843033319048, 218, 51, 'PPL', 'P'),
(101530, 'Dudley', 36.8030586242676, 0.642334547797964, -78.9105606079102, -1.37724909720257, 218, 53, 'PPL', 'P'),
(113092, 'Dudley', 46.1713905334473, 0.805842785032796, -68.1602783203125, -1.18962127576516, 218, 26, 'PPL', 'P'),
(115343, 'Dudley', 41.0877799987793, 0.71711704331377, -92.591667175293, -1.61602945211962, 218, 16, 'PPL', 'P'),
(124664, 'Dudley', 42.0449981689453, 0.733823652043083, -71.9305572509766, -1.25542505682382, 218, 23, 'PPL', 'P'),
(135058, 'Dudley', 44.4249992370605, 0.775362506882676, -95.6911087036133, -1.67012491176185, 218, 28, 'PPL', 'P'),
(160932, 'Dudley', 40.2052803039551, 0.701714517991243, -78.1816711425781, -1.36452757614943, 218, 45, 'PPL', 'P'),
(173863, 'Dudley', 45.3355598449707, 0.791254787529669, -89.4652786254883, -1.56146367822888, 218, 57, 'PPL', 'P'),
(186637, 'Dudley', 39.2969398498535, 0.68586098633811, -106.071113586426, -1.85129017334002, 218, 7, 'PPL', 'P'),
(194859, 'Dudley', 47.5419387817383, 0.829763364522915, -116.423332214355, -2.03197047328368, 218, 17, 'PPL', 'P'),
(202070, 'Dudley', 43.3113899230957, 0.755926357773114, -103.817779541016, -1.81196207510033, 218, 49, 'PPL', 'P'),
(200727, 'Dudley (historical)', 42.6291694641113, 0.744019364539369, -122.538887023926, -2.13870704029686, 218, 43, 'PPL', 'P'),
(46697, 'Dudley Corners', 39.1838912963867, 0.683887916865498, -75.892219543457, -1.32456910767971, 218, 25, 'PPL', 'P'),
(108965, 'Dudley Gap', 38.5027809143066, 0.672000298128684, -82.1444396972656, -1.43369093492322, 218, 58, 'PPL', 'P'),
(148347, 'Dudley Settlement', 42.3041687011719, 0.738347031154582, -77.3402786254883, -1.34984250642456, 218, 40, 'PPL', 'P'),
(64291, 'Dudley Shoals', 35.8636093139648, 0.625938064177591, -81.3766708374023, -1.42029084042432, 218, 33, 'PPL', 'P'),
(2117, 'Dudleys', 32.3013916015625, 0.56376563642331, -85.1980590820313, -1.4869866472901, 218, 2, 'PPL', 'P'),
(29669, 'Dudleytown', 38.8497200012207, 0.678055527499197, -85.8997192382813, -1.49923292724672, 218, 19, 'PPL', 'P'),
(2118, 'Dudleyville', 32.9150009155273, 0.5744751392729, -85.5999984741211, -1.49400181307554, 218, 2, 'PPL', 'P'),
(27005, 'Dudleyville', 38.8238906860352, 0.677604720905674, -89.4180603027344, -1.56063956302955, 218, 18, 'PPL', 'P'),
(124667, 'Dudleyville', 42.485279083252, 0.741508003631425, -72.4463882446289, -1.26442800604689, 218, 23, 'PPL', 'P'),
(178114, 'Dudleyville', 32.9719390869141, 0.575468897833663, -110.775833129883, -1.93340301975627, 218, 5, 'PPL', 'P'),
(181214, 'Dudmore', 33.8566703796387, 0.590910371887133, -118.349998474121, -2.06559714310368, 218, 6, 'PPL', 'P'),
(86608, 'Dudney Hill', 36.332218170166, 0.634116831622306, -85.6288909912109, -1.49450608262794, 218, 50, 'PPL', 'P'),
(20694, 'Due (historical)', 34.7827796936035, 0.607074028649206, -84.2777786254883, -1.47092472328167, 218, 13, 'PPL', 'P'),
(80756, 'Due West', 34.3333282470703, 0.59922962107935, -82.3880615234375, -1.43794293791964, 218, 48, 'PPL', 'P'),
(20695, 'Due West Estates', 33.9755592346191, 0.592985373850469, -84.7444381713867, -1.47906946884346, 218, 13, 'PPL', 'P'),
(59716, 'Dueitt', 31.1505603790283, 0.543679842455337, -88.5344390869141, -1.54521746347301, 218, 30, 'PPL', 'P'),
(130549, 'Duel', 43.7119407653809, 0.762917288792626, -84.1469421386719, -1.46864119580498, 218, 27, 'PPL', 'P'),
(148348, 'Duells Corner', 42.746940612793, 0.74607485884772, -78.7486114501953, -1.37442255117961, 218, 40, 'PPL', 'P'),
(135060, 'Duelm', 45.5722198486328, 0.795385283801354, -93.9341735839844, -1.63946060918041, 218, 28, 'PPL', 'P'),
(54497, 'Duenweg', 37.083610534668, 0.647231102357211, -94.413330078125, -1.64782346763548, 218, 29, 'PPL', 'P'),
(46698, 'Duers Neck Landing', 38.0986099243164, 0.664946183612309, -75.3158264160156, -1.31450914981999, 218, 25, 'PPL', 'P'),
(135061, 'Duesler', 46.5119400024414, 0.811786494532662, -92.5083312988281, -1.61457496669027, 218, 28, 'PPL', 'P'),
(101528, 'Duet', 38.4747200012207, 0.671510542804218, -78.2566680908203, -1.3658365198252, 218, 53, 'PPL', 'P'),
(15824, 'Duette', 27.5900001525879, 0.481536343288397, -82.1230621337891, -1.4333178260545, 218, 12, 'PPL', 'P'),
(8616, 'Duff', 36.000560760498, 0.628328317834965, -92.7624969482422, -1.61901099411802, 218, 4, 'PPL', 'P'),
(29670, 'Duff', 38.327220916748, 0.668936198136493, -87.0263900756836, -1.5188970429456, 218, 19, 'PPL', 'P'),
(35649, 'Duff', 37.5497207641602, 0.655366260539076, -86.4130630493164, -1.50819246694402, 218, 21, 'PPL', 'P'),
(86609, 'Duff', 36.4466705322266, 0.636114402176948, -84.067497253418, -1.46725462098343, 218, 50, 'PPL', 'P'),
(93833, 'Duff', 31.6391696929932, 0.552207683739934, -94.1288909912109, -1.64285906904746, 218, 51, 'PPL', 'P'),
(177365, 'Duff', 42.2024993896484, 0.736572566920263, -99.603889465332, -1.73841581896254, 218, 35, 'PPL', 'P'),
(160934, 'Duff City', 40.601390838623, 0.708627951023034, -80.1291732788086, -1.39851790061627, 218, 45, 'PPL', 'P'),
(64292, 'Duff Creek', 34.7844390869141, 0.60710299052606, -78.0527801513672, -1.36227800397664, 218, 33, 'PPL', 'P'),
(2119, 'Duff Settlement', 32.9161109924316, 0.57449451376983, -87.2216720581055, -1.52230535650868, 218, 2, 'PPL', 'P'),
(93834, 'Duffau', 32.082218170166, 0.559940338412547, -98.0216674804688, -1.71080083582923, 218, 51, 'PPL', 'P'),
(59717, 'Duffee', 32.4891700744629, 0.567042989039789, -88.9269409179688, -1.55206791274502, 218, 30, 'PPL', 'P'),
(8617, 'Duffie (historical)', 34.2777786254883, 0.598260097284507, -93.1277770996094, -1.62538633545156, 218, 4, 'PPL', 'P'),
(46699, 'Duffield', 39.0794410705566, 0.682064916520311, -76.5738906860352, -1.33646651353353, 218, 25, 'PPL', 'P'),
(78148, 'Duffield', 39.8836097717285, 0.696100308097247, -77.5761108398438, -1.35395855504734, 218, 45, 'PPL', 'P'),
(101529, 'Duffield', 36.7188911437988, 0.640865548140676, -82.7961120605469, -1.44506476330673, 218, 53, 'PPL', 'P'),
(130550, 'Duffield', 42.9280586242676, 0.749235964482617, -83.9100036621094, -1.46450583926431, 218, 27, 'PPL', 'P'),
(186638, 'Duffield', 38.7422218322754, 0.676179330511236, -104.91194152832, -1.83105880432896, 218, 7, 'PPL', 'P'),
(108966, 'Duffields', 39.3624992370605, 0.687005213500463, -77.8277816772461, -1.35835103979126, 218, 58, 'PPL', 'P'),
(64294, 'Duffies', 34.8669395446777, 0.608542895148439, -79.254997253418, -1.38326065073121, 218, 33, 'PPL', 'P'),
(160935, 'Duffryn Mawr', 40.0366706848145, 0.698771724986705, -75.495002746582, -1.31763636673002, 218, 45, 'PPL', 'P'),
(72348, 'Duffy', 39.6438903808594, 0.691916415445705, -80.8722229003906, -1.41148656301857, 218, 41, 'PPL', 'P'),
(108967, 'Duffy', 38.790828704834, 0.677027680476481, -80.4447174072266, -1.4040251845925, 218, 58, 'PPL', 'P'),
(196378, 'Duffy Trailer Court', 45.8349990844727, 0.799971646672634, -109.954719543457, -1.91907188414028, 218, 31, 'PPL', 'P'),
(80757, 'Duford', 34.1911087036133, 0.596747421785342, -79.0641708374023, -1.37993010147195, 218, 48, 'PPL', 'P'),
(194860, 'Dufort', 48.1652793884277, 0.840642710471025, -116.595832824707, -2.03498117689602, 218, 17, 'PPL', 'P'),
(181215, 'Dufour', 38.7619400024414, 0.676523477503101, -121.841941833496, -2.12654305201792, 218, 6, 'PPL', 'P'),
(40711, 'Dufresne', 29.9422206878662, 0.522590336362027, -90.3902816772461, -1.57760802707305, 218, 22, 'PPL', 'P'),
(200728, 'Dufur', 45.4533309936523, 0.793310281838019, -121.129440307617, -2.11410755446585, 218, 43, 'PPL', 'P'),
(93835, 'Dug Ford', 33.0138893127441, 0.576201067396353, -99.3852767944336, -1.73460030806878, 218, 51, 'PPL', 'P'),
(2121, 'Dug Hill', 32.5047187805176, 0.567314365154868, -88.0297164916992, -1.5364083923773, 218, 2, 'PPL', 'P'),
(8618, 'Dug Hill', 36.4736099243164, 0.636584583267401, -94.246940612793, -1.6449194236248, 218, 4, 'PPL', 'P'),
(35650, 'Dug Hill', 37.3530616760254, 0.651933911947155, -86.1486129760742, -1.50357694245881, 218, 21, 'PPL', 'P'),
(46700, 'Dug Hill', 39.6800003051758, 0.692546652517672, -76.892219543457, -1.34202240019966, 218, 25, 'PPL', 'P'),
(86610, 'Dug Hill', 36.0444412231445, 0.629094176385444, -85.3300018310547, -1.48928948268469, 218, 50, 'PPL', 'P'),
(181216, 'Dugan', 38.6044387817383, 0.673774562625922, -120.957778930664, -2.11111149823951, 218, 6, 'PPL', 'P'),
(78149, 'Dugan Hill', 39.8675003051758, 0.695819144865162, -79.857780456543, -1.39378120230146, 218, 45, 'PPL', 'P'),
(40712, 'Dugan Landing', 30.7202796936035, 0.536170027786936, -91.3486099243164, -1.59433401029929, 218, 22, 'PPL', 'P'),
(35651, 'Dugansville', 37.8786087036133, 0.661106437952633, -84.9850006103516, -1.48326807546003, 218, 21, 'PPL', 'P'),
(178115, 'Dugas', 34.3619384765625, 0.59972896378374, -111.977783203125, -1.95438100597893, 218, 5, 'PPL', 'P'),
(135062, 'Dugdale', 47.7016716003418, 0.832551228131037, -96.26611328125, -1.68016063485565, 218, 28, 'PPL', 'P'),
(20696, 'Dugdown', 33.9000015258789, 0.591666643057689, -85.254997253418, -1.48798040585087, 218, 13, 'PPL', 'P'),
(54498, 'Duggan', 37.1941719055176, 0.649160762304055, -92.4136123657227, -1.61292180944361, 218, 29, 'PPL', 'P'),
(8619, 'Dugger', 36.1258316040039, 0.630514706510892, -92.9175033569336, -1.62171636631138, 218, 4, 'PPL', 'P'),
(29671, 'Dugger', 39.0699996948242, 0.681900133427862, -87.2613906860352, -1.52299857734043, 218, 19, 'PPL', 'P'),
(93836, 'Dugger', 29.5022296905518, 0.514911044779756, -97.951057434082, -1.7095684580348, 218, 51, 'PPL', 'P'),
(8620, 'Dugger (historical)', 36.1147193908691, 0.630320761804507, -92.8594436645508, -1.6207030335166, 218, 4, 'PPL', 'P'),
(101531, 'Duggins Store', 37.8613891601563, 0.660805900223617, -77.7663879394531, -1.35727951692667, 218, 53, 'PPL', 'P'),
(54499, 'Dugginsville', 36.5097198486328, 0.637214820339368, -92.6952819824219, -1.61783787165784, 218, 29, 'PPL', 'P'),
(86611, 'Dughill (historical)', 35.9913902282715, 0.628168261853451, -87.8763885498047, -1.53373231495594, 218, 50, 'PPL', 'P'),
(101532, 'Dugspur', 36.8177795410156, 0.642591476264129, -80.6100006103516, -1.40690992068527, 218, 53, 'PPL', 'P'),
(148349, 'Dugway', 43.4613914489746, 0.758544378282716, -76.0819396972656, -1.32788034902106, 218, 40, 'PPL', 'P'),
(203766, 'Dugway', 40.2211112976074, 0.701990820954338, -112.743606567383, -1.96774714517393, 218, 52, 'PPL', 'P'),
(101533, 'Dugwell', 37.0400009155273, 0.646469970917666, -79.9591674804688, -1.39555073968776, 218, 53, 'PPL', 'P'),
(46701, 'Duhamel Corners', 39.1916694641113, 0.684023671502064, -75.8302764892578, -1.3234879974352, 218, 25, 'PPL', 'P'),
(108968, 'Duhring', 37.3474998474121, 0.651836839725421, -81.2638931274414, -1.41832249806264, 218, 58, 'PPL', 'P'),
(75698, 'Duhringe Pass', 34.7294387817383, 0.606143054111141, -98.4897232055664, -1.718969949315, 218, 42, 'PPL', 'P'),
(2124, 'Duke', 33.8505592346191, 0.590803712285476, -85.9024963378906, -1.49928139677856, 218, 2, 'PPL', 'P'),
(54500, 'Duke', 37.6602783203125, 0.657295853906893, -92.0105590820313, -1.60588720258222, 218, 29, 'PPL', 'P'),
(59718, 'Duke', 32.1127815246582, 0.56047376957889, -90.7172164916992, -1.58331411602465, 218, 30, 'PPL', 'P'),
(72352, 'Duke', 38.9988899230957, 0.680659033780858, -83.2336120605469, -1.4527005787842, 218, 41, 'PPL', 'P'),
(75701, 'Duke', 34.6613883972168, 0.604955350843993, -99.5697174072266, -1.73781940403642, 218, 42, 'PPL', 'P'),
(93837, 'Duke', 29.5044403076172, 0.514949627326049, -95.4858322143555, -1.66654216114737, 218, 51, 'PPL', 'P'),
(40713, 'Duke (historical)', 30.0261096954346, 0.524054475750325, -90.601936340332, -1.5813020978211, 218, 22, 'PPL', 'P'),
(80759, 'Duke (historical)', 34.2125015258789, 0.597120796970171, -82.7030563354492, -1.44344063451594, 218, 48, 'PPL', 'P'),
(86612, 'Duke (historical)', 36.2402801513672, 0.632512210486506, -83.9791717529297, -1.46571305018644, 218, 50, 'PPL', 'P'),
(160936, 'Duke Center', 41.952220916748, 0.732204383521287, -78.4802780151367, -1.36973924924466, 218, 45, 'PPL', 'P'),
(93838, 'Duke Crossing', 31.5536098480225, 0.5507143827377, -98.7988891601563, -1.72436591315766, 218, 51, 'PPL', 'P'),
(101534, 'Duke Gardens', 38.8105583190918, 0.677372027205428, -77.0997161865234, -1.345643899808, 218, 53, 'PPL', 'P'),
(40714, 'Dukedale', 32.6349983215332, 0.569588172093577, -93.7455596923828, -1.63616867575696, 218, 22, 'PPL', 'P'),
(86613, 'Dukedom', 36.5022201538086, 0.637083925971791, -88.7149963378906, -1.5483687819909, 218, 50, 'PPL', 'P'),
(35652, 'Dukehurst', 37.5108299255371, 0.654687487356242, -86.857780456543, -1.51595424994106, 218, 21, 'PPL', 'P'),
(15825, 'Dukes', 29.9661102294922, 0.523007287520192, -82.4075012207031, -1.43828222464252, 218, 12, 'PPL', 'P'),
(35653, 'Dukes', 37.8247184753418, 0.660165876034644, -86.6983337402344, -1.51317137975998, 218, 21, 'PPL', 'P'),
(64296, 'Dukes', 36.0597190856934, 0.629360825389588, -77.9783325195313, -1.36097864768079, 218, 33, 'PPL', 'P'),
(80758, 'Dukes', 32.8974990844727, 0.574169674695868, -81.2380599975586, -1.41787162489009, 218, 48, 'PPL', 'P'),
(108969, 'Dukes', 38.8963890075684, 0.678870055318597, -81.4519424438477, -1.42160457779006, 218, 58, 'PPL', 'P'),
(130551, 'Dukes', 46.3477783203125, 0.8089213326739, -87.1577835083008, -1.52119029096026, 218, 27, 'PPL', 'P'),
(20698, 'Dukes (historical)', 32.0011100769043, 0.558524735135116, -81.7133331298828, -1.42616670589542, 218, 13, 'PPL', 'P'),
(70762, 'Dukes Bridge', 39.7947196960449, 0.694548883604221, -74.5247192382813, -1.30070172483237, 218, 37, 'PPL', 'P'),
(46702, 'Dukes Retreat', 38.1952781677246, 0.666633362741901, -76.5269393920898, -1.33564705886612, 218, 25, 'PPL', 'P'),
(86614, 'Dukes Store (historical)', 35.5791702270508, 0.620973665589575, -87.1236114501953, -1.52059387603414, 218, 50, 'PPL', 'P'),
(2123, 'Duketon', 34.3650016784668, 0.599782426742623, -87.8322219848633, -1.53296146297841, 218, 2, 'PPL', 'P'),
(141689, 'Dukeville', 42.6925010681152, 0.745124709549807, -98.1338882446289, -1.71275945765293, 218, 35, 'PPL', 'P'),
(64297, 'Dula Springs', 35.711669921875, 0.623286221522145, -82.5400009155273, -1.44059478057509, 218, 33, 'PPL', 'P'),
(40716, 'Dulac', 29.3886108398438, 0.512928021742569, -90.7138900756836, -1.58325605911289, 218, 22, 'PPL', 'P'),
(64298, 'Dulah', 34.0563888549805, 0.594396116858911, -78.6872177124023, -1.37335102831502, 218, 33, 'PPL', 'P'),
(181217, 'Dulah', 34.3125, 0.598866099590554, -119.35888671875, -2.08320556475712, 218, 6, 'PPL', 'P'),
(75700, 'Duland', 33.9672203063965, 0.592839832096896, -95.704719543457, -1.67036246573109, 218, 42, 'PPL', 'P'),
(35654, 'Dulaney', 37.0969390869141, 0.647463729478429, -87.9805603027344, -1.53555045503213, 218, 21, 'PPL', 'P'),
(86615, 'Dulaney', 36.1336097717285, 0.630650461147459, -82.9150009155273, -1.44713976527006, 218, 50, 'PPL', 'P'),
(108970, 'Dulaney', 39.6347198486328, 0.691756359464191, -80.6297225952148, -1.40725413425617, 218, 58, 'PPL', 'P'),
(46705, 'Dulaney Gate', 39.4716682434082, 0.68891057210236, -76.5986099243164, -1.33689794563013, 218, 25, 'PPL', 'P'),
(46703, 'Dulaney Hills', 39.480281829834, 0.689060907545895, -76.522216796875, -1.33556463403038, 218, 25, 'PPL', 'P'),
(46704, 'Dulaney Ridge', 39.6025009155273, 0.691194033000021, -76.4647216796875, -1.33456115493164, 218, 25, 'PPL', 'P'),
(46716, 'Dulaney Valley (historical)', 39.461109161377, 0.688726281354926, -76.5502777099609, -1.33605438935484, 218, 25, 'PPL', 'P'),
(46706, 'Dulaney Valley Estates', 39.5013885498047, 0.68942928930368, -76.5061111450195, -1.33528353737732, 218, 25, 'PPL', 'P'),
(46707, 'Dulaney Village', 39.4155616760254, 0.687931327769538, -76.6052780151367, -1.33701432576976, 218, 25, 'PPL', 'P'),
(46708, 'Dulany Hills', 39.4697189331055, 0.688876550219434, -77.0772171020508, -1.34525121670527, 218, 25, 'PPL', 'P'),
(188444, 'Dulce', 36.9336090087891, 0.644613081847608, -106.998329162598, -1.86747313802, 218, 38, 'PPL', 'P'),
(46709, 'Duley', 38.7486114501953, 0.676290850381883, -76.7983322143555, -1.34038375718093, 218, 25, 'PPL', 'P'),
(93839, 'Dulin', 31.5316696166992, 0.55033145346246, -99.0986099243164, -1.72959702732885, 218, 51, 'PPL', 'P'),
(86616, 'Dull', 36.2055587768555, 0.631906208180459, -87.2852783203125, -1.52341549520908, 218, 50, 'PPL', 'P'),
(93840, 'Dull', 28.4447193145752, 0.496454006844962, -98.9308319091797, -1.72666874855225, 218, 51, 'PPL', 'P'),
(155040, 'Dull', 40.7641716003418, 0.71146901127393, -84.6666717529297, -1.4777121887939, 218, 41, 'PPL', 'P'),
(46710, 'Dulls Corner', 39.0016708374023, 0.680707569891725, -76.477783203125, -1.33478912152095, 218, 25, 'PPL', 'P'),
(20699, 'Duluth', 34.0027809143066, 0.593460481788939, -84.1447219848633, -1.46860244681112, 218, 13, 'PPL', 'P'),
(32275, 'Duluth', 39.5247192382813, 0.689836486634353, -96.2227783203125, -1.67940429710607, 218, 20, 'PPL', 'P'),
(35655, 'Duluth', 37.5794410705566, 0.655884977740396, -84.168327331543, -1.46901443783176, 218, 21, 'PPL', 'P'),
(135063, 'Duluth', 46.7833290100098, 0.81652312626845, -92.1063919067383, -1.60755980090484, 218, 28, 'PPL', 'P'),
(199285, 'Duluth', 42.0177803039551, 0.73334861068364, -101.635276794434, -1.77387021623865, 218, 35, 'PPL', 'P'),
(190137, 'Duluth (historical)', 39.0769386291504, 0.682021240678434, -117.745277404785, -2.05504276938759, 218, 39, 'PPL', 'P'),
(135064, 'Duluth Heights', 46.8008308410645, 0.816828590845482, -92.1316680908203, -1.60800095353941, 218, 28, 'PPL', 'P'),
(135065, 'Duluth Junction', 45.0766716003418, 0.786736335266186, -92.8997192382813, -1.62140597488633, 218, 28, 'PPL', 'P'),
(59719, 'Dulweber', 33.3416709899902, 0.581921936892007, -90.2372207641602, -1.57493661018359, 218, 30, 'PPL', 'P'),
(207242, 'Dulwich', 48.8474998474121, 0.852549703704769, -118.196388244629, -2.0629161388343, 218, 56, 'PPL', 'P'),
(181218, 'Dulzura', 32.6441688537598, 0.569748228075091, -116.780563354492, -2.03820533286972, 218, 6, 'PPL', 'P'),
(8621, 'Dumas', 33.8869400024414, 0.591438676468378, -91.4916687011719, -1.59683085697929, 218, 4, 'PPL', 'P'),
(20700, 'Dumas', 32.0394401550293, 0.559193721200944, -84.4913864135742, -1.47465288249167, 218, 13, 'PPL', 'P'),
(59720, 'Dumas', 34.6402816772461, 0.604586969086208, -88.8438873291016, -1.55061835416369, 218, 30, 'PPL', 'P'),
(78150, 'Dumas', 39.7855606079102, 0.694389027359789, -79.3194427490234, -1.3843854368176, 218, 45, 'PPL', 'P'),
(139125, 'Dumas', 40.521110534668, 0.707226795394516, -91.6352767944336, -1.59933729103922, 218, 29, 'PPL', 'P'),
(191398, 'Dumas', 35.8655586242676, 0.625972086060517, -101.972778320313, -1.77976072909575, 218, 51, 'PPL', 'P'),
(207243, 'Dumas', 46.2872200012207, 0.807864390616275, -118.060279846191, -2.06054059914194, 218, 56, 'PPL', 'P'),
(8622, 'Dumas City', 33.2588882446289, 0.580477105421612, -92.754997253418, -1.61888009975044, 218, 4, 'PPL', 'P'),
(191399, 'Dumas Junction', 35.2127799987793, 0.614578949759104, -101.801940917969, -1.77677905393929, 218, 51, 'PPL', 'P'),
(46711, 'Dumbarton', 39.3788909912109, 0.687291303580564, -76.7091674804688, -1.33882753899794, 218, 25, 'PPL', 'P'),
(101538, 'Dumbarton', 37.6036109924316, 0.656306822457065, -77.4916687011719, -1.35248476170009, 218, 53, 'PPL', 'P'),
(148350, 'Dumbarton', 43.1622200012207, 0.753322851491452, -75.6619415283203, -1.32054999812062, 218, 40, 'PPL', 'P'),
(209416, 'Dumbell', 44.1022186279297, 0.769728922491749, -108.987777709961, -1.9021955654705, 218, 59, 'PPL', 'P'),
(135068, 'Dumblane', 47.1469383239746, 0.822869305988054, -92.6147232055664, -1.61643185576033, 218, 28, 'PPL', 'P'),
(40715, 'Dumesnil', 29.8469390869141, 0.52092735870884, -91.6163864135742, -1.59900759169627, 218, 22, 'PPL', 'P'),
(101536, 'Dumfries', 38.5675010681152, 0.673129877905041, -77.3283309936523, -1.34963398091121, 218, 53, 'PPL', 'P'),
(115344, 'Dumfries', 41.186939239502, 0.718847698548158, -95.7377777099609, -1.67093943958126, 218, 16, 'PPL', 'P'),
(135069, 'Dumfries', 44.3450012207031, 0.773966278102174, -92.120002746582, -1.60779735487408, 218, 28, 'PPL', 'P'),
(143732, 'Dummer', 44.6105613708496, 0.778601177084321, -71.2013931274414, -1.24269874208072, 218, 36, 'PPL', 'P'),
(171916, 'Dummerston Center', 42.9366683959961, 0.749386233347124, -72.5727767944336, -1.2666339023778, 218, 55, 'PPL', 'P'),
(15826, 'Dummit Grove', 28.7066707611084, 0.501025922067328, -80.7280578613281, -1.40897040842067, 218, 12, 'PPL', 'P'),
(188445, 'Dummoor', 34.6297187805176, 0.604402611759747, -105.704437255859, -1.84489046408251, 218, 38, 'PPL', 'P'),
(115345, 'Dumont', 42.7519416809082, 0.746162143952447, -92.9752807617188, -1.62272477225813, 218, 16, 'PPL', 'P'),
(135070, 'Dumont', 45.7158317565918, 0.79789178444031, -96.4255599975586, -1.68294350503673, 218, 28, 'PPL', 'P'),
(145107, 'Dumont', 40.940559387207, 0.714547558915035, -73.9972229003906, -1.29149517694396, 218, 37, 'PPL', 'P'),
(181219, 'Dumont', 35.6930618286133, 0.62296144902721, -116.175003051758, -2.02763631176763, 218, 6, 'PPL', 'P'),
(186639, 'Dumont', 39.764720916748, 0.694025306133911, -105.599716186523, -1.84306273662638, 218, 7, 'PPL', 'P'),
(191400, 'Dumont', 33.8097190856934, 0.590090917219716, -100.515830993652, -1.7543322012174, 218, 51, 'PPL', 'P'),
(202073, 'Dumont', 44.2386093139648, 0.772109389032116, -103.798332214355, -1.8116226552194, 218, 49, 'PPL', 'P'),
(72349, 'Dumontville', 39.7772216796875, 0.694243485606216, -82.6163864135742, -1.44192795901678, 218, 41, 'PPL', 'P'),
(86617, 'Dumplin', 36.0052795410156, 0.628410676091675, -83.5583267211914, -1.45836791874195, 218, 50, 'PPL', 'P'),
(86618, 'Dumplin Mill', 35.9972190856934, 0.628269994607092, -83.563606262207, -1.45846006411566, 218, 50, 'PPL', 'P'),
(199926, 'Dun Glen (historical)', 40.7419395446777, 0.711080988703106, -117.921112060547, -2.05811166306974, 218, 39, 'PPL', 'P'),
(46712, 'Dun Rovin', 39.4777793884277, 0.689017231704017, -76.6258316040039, -1.3373730535686, 218, 25, 'PPL', 'P'),
(20701, 'Dunagan', 34.3172187805176, 0.598948457847265, -83.7144393920898, -1.46109259885321, 218, 13, 'PPL', 'P'),
(93841, 'Dunagan', 31.3463897705078, 0.547097710108831, -94.6149978637695, -1.65134323449018, 218, 51, 'PPL', 'P'),
(80768, 'Dunagin', 34.9713897705078, 0.610365895493626, -81.855827331543, -1.42865369887939, 218, 48, 'PPL', 'P'),
(2125, 'Dunavant', 33.4933280944824, 0.584568852699437, -86.5441665649414, -1.51048065495262, 218, 2, 'PPL', 'P'),
(32270, 'Dunavant', 39.3019409179688, 0.685948271442837, -95.3324966430664, -1.66386595056795, 218, 20, 'PPL', 'P'),
(101540, 'Dunavant', 38.3622207641602, 0.66954706071153, -77.6650009155273, -1.35550997954036, 218, 53, 'PPL', 'P'),
(20702, 'Dunaway Gardens', 33.478328704834, 0.584307063964282, -84.8191680908203, -1.48037375198733, 218, 13, 'PPL', 'P'),
(2127, 'Dunbar', 31.6780605316162, 0.552886456922768, -88.3461074829102, -1.54193045689758, 218, 2, 'PPL', 'P'),
(35656, 'Dunbar', 37.188060760498, 0.649054102702397, -86.7569427490234, -1.51419429993468, 218, 21, 'PPL', 'P'),
(46713, 'Dunbar', 39.413890838623, 0.687902166155601, -76.772216796875, -1.33992795716036, 218, 25, 'PPL', 'P'),
(64299, 'Dunbar', 35.961109161377, 0.627639757535125, -77.6536102294922, -1.35531117456499, 218, 33, 'PPL', 'P'),
(72350, 'Dunbar', 39.3594398498535, 0.686951817120606, -81.741943359375, -1.42666604859981, 218, 41, 'PPL', 'P'),
(75705, 'Dunbar', 33.9408302307129, 0.592379238386367, -97.2819366455078, -1.69789009718064, 218, 42, 'PPL', 'P'),
(78151, 'Dunbar', 39.9777793884277, 0.697743877963989, -79.6147232055664, -1.38953905300107, 218, 45, 'PPL', 'P'),
(80761, 'Dunbar', 34.5336112976074, 0.602725219747161, -79.561393737793, -1.38860827820009, 218, 48, 'PPL', 'P'),
(86619, 'Dunbar', 35.4588890075684, 0.618874362281292, -88.1444396972656, -1.53841069004288, 218, 50, 'PPL', 'P'),
(93842, 'Dunbar', 32.805908203125, 0.572571112251548, -95.7993011474609, -1.67201322613278, 218, 51, 'PPL', 'P'),
(101539, 'Dunbar', 36.9738883972168, 0.645316089796362, -82.7472229003906, -1.44421148649347, 218, 53, 'PPL', 'P'),
(108972, 'Dunbar', 38.3605613708496, 0.669518098834675, -81.7375030517578, -1.42658855061209, 218, 58, 'PPL', 'P'),
(115346, 'Dunbar', 41.9408302307129, 0.732005578545913, -92.79638671875, -1.61960248219612, 218, 16, 'PPL', 'P'),
(135072, 'Dunbar', 47.6583290100098, 0.8317947572234, -94.2244415283203, -1.64452674052207, 218, 28, 'PPL', 'P'),
(141690, 'Dunbar', 40.6680603027344, 0.709791552682317, -96.0297164916992, -1.67603473253685, 218, 35, 'PPL', 'P'),
(148351, 'Dunbar', 42.1100006103516, 0.734958158667457, -75.7213897705078, -1.32158756568131, 218, 40, 'PPL', 'P'),
(173864, 'Dunbar', 45.6508293151855, 0.796757277815936, -88.17138671875, -1.53888100429139, 218, 57, 'PPL', 'P'),
(86621, 'Dunbar Cave', 36.5475006103516, 0.637874219025272, -87.2911071777344, -1.52351722796272, 218, 50, 'PPL', 'P'),
(35657, 'Dunbar Hill', 37.2158317565918, 0.649538798020792, -85.1716690063477, -1.48652605357957, 218, 21, 'PPL', 'P'),
(80762, 'Dunbar Landing', 33.5355606079102, 0.585305949110143, -79.3502807617188, -1.38492366167391, 218, 48, 'PPL', 'P'),
(40717, 'Dunbarton', 31.7266693115234, 0.553734840177527, -91.6586074829102, -1.59974448836989, 218, 22, 'PPL', 'P'),
(70760, 'Dunbarton', 39.7491683959961, 0.693753863439805, -74.8752822875977, -1.30682020427877, 218, 37, 'PPL', 'P'),
(80763, 'Dunbarton', 34.3069381713867, 0.598769027368821, -79.3380584716797, -1.38471034247059, 218, 48, 'PPL', 'P'),
(173866, 'Dunbarton', 42.5616683959961, 0.742841248652146, -90.133056640625, -1.57311860326545, 218, 57, 'PPL', 'P'),
(80764, 'Dunbarton (historical)', 33.1958312988281, 0.579376554101136, -81.5391693115234, -1.4231269738272, 218, 48, 'PPL', 'P'),
(181220, 'Dunbarton (historical)', 36.8583297729492, 0.643299211323818, -121.64582824707, -2.1231202242269, 218, 6, 'PPL', 'P'),
(143734, 'Dunbarton Center', 43.1025009155273, 0.752280556819822, -71.616943359375, -1.24995146183538, 218, 36, 'PPL', 'P'),
(2128, 'Dunbarton Oaks', 33.4722213745117, 0.584200470941652, -86.7247161865234, -1.51363184031245, 218, 2, 'PPL', 'P'),
(13695, 'Dunbarton Oaks Apartments', 38.6913909912109, 0.675292164973103, -75.397216796875, -1.31592967994544, 218, 10, 'PPL', 'P'),
(155041, 'Dunbridge', 41.4580612182617, 0.723579669752038, -83.6102828979492, -1.45927472509312, 218, 41, 'PPL', 'P'),
(46714, 'Dunbrook', 39.1297187805176, 0.682942428099492, -76.5441665649414, -1.33594772975319, 218, 25, 'PPL', 'P'),
(101541, 'Dunbrooke', 37.8941688537598, 0.661378013804794, -76.9641723632813, -1.34327821381168, 218, 53, 'PPL', 'P'),
(2131, 'Duncan', 32.9708290100098, 0.575449523336733, -85.897216796875, -1.49918925140485, 218, 2, 'PPL', 'P'),
(8623, 'Duncan', 34.6208305358887, 0.60424748262625, -91.251106262207, -1.59263225036273, 218, 4, 'PPL', 'P'),
(29672, 'Duncan', 38.2880592346191, 0.668252697842724, -85.9250030517578, -1.49967421303935, 218, 19, 'PPL', 'P'),
(35659, 'Duncan', 37.8491706848145, 0.660592647599329, -84.9902801513672, -1.48336022083374, 218, 21, 'PPL', 'P'),
(54501, 'Duncan', 37.2816696166992, 0.650687885452134, -92.6916732788086, -1.61777488789806, 218, 29, 'PPL', 'P'),
(59721, 'Duncan', 34.0444412231445, 0.594187591345558, -90.7447204589844, -1.58379415081114, 218, 30, 'PPL', 'P'),
(64300, 'Duncan', 35.5625, 0.620682715240483, -78.8722229003906, -1.37657997797869, 218, 33, 'PPL', 'P'),
(75703, 'Duncan', 34.5022201538086, 0.602177340931904, -97.9574966430664, -1.7096808434328, 218, 42, 'PPL', 'P'),
(80766, 'Duncan', 34.9377784729004, 0.609779267684508, -82.1452789306641, -1.43370558230921, 218, 48, 'PPL', 'P'),
(86620, 'Duncan', 35.7986106872559, 0.624803624132245, -83.9647216796875, -1.46546084883121, 218, 50, 'PPL', 'P'),
(101542, 'Duncan', 36.9119415283203, 0.644234912972817, -80.4899978637695, -1.40481547764598, 218, 53, 'PPL', 'P'),
(108971, 'Duncan', 38.9027786254883, 0.678981575189245, -81.5736083984375, -1.42372804928523, 218, 58, 'PPL', 'P'),
(115347, 'Duncan', 43.1047210693359, 0.752319305813683, -93.7111129760742, -1.63556746714088, 218, 16, 'PPL', 'P'),
(119414, 'Duncan', 40.9836082458496, 0.715298903237573, -89.7891693115234, -1.56711663711673, 218, 18, 'PPL', 'P'),
(141691, 'Duncan', 41.3894386291504, 0.722381979630803, -97.4944381713867, -1.70159894847274, 218, 35, 'PPL', 'P'),
(160938, 'Duncan', 41.6519393920898, 0.726963482233093, -77.258056640625, -1.34840746207118, 218, 45, 'PPL', 'P'),
(178116, 'Duncan', 32.7213897705078, 0.571095987323753, -109.104721069336, -1.90423661212994, 218, 5, 'PPL', 'P'),
(186640, 'Duncan', 37.8741683959961, 0.661028939964911, -105.613891601563, -1.84331014429165, 218, 7, 'PPL', 'P'),
(200729, 'Duncan', 45.5613899230957, 0.795196265942986, -118.315277099609, -2.06499114079763, 218, 43, 'PPL', 'P'),
(207244, 'Duncan', 47.5047187805176, 0.829113752954017, -117.343887329102, -2.04803719098208, 218, 56, 'PPL', 'P'),
(196379, 'Duncan (historical)', 48.204719543457, 0.841331071033783, -114.300003051758, -1.99491138829274, 218, 31, 'PPL', 'P'),
(80767, 'Duncan Chapel', 33.2958297729492, 0.58112185672152, -80.5605621337891, -1.40604705649209, 218, 48, 'PPL', 'P'),
(181221, 'Duncan Corners', 34.4705581665039, 0.601624735005713, -117.398612976074, -2.04899233370703, 218, 6, 'PPL', 'P'),
(46715, 'Duncan Crossing', 38.4033317565918, 0.670264582888224, -75.3061065673828, -1.31433950645856, 218, 25, 'PPL', 'P'),
(2132, 'Duncan Crossroads', 34.5444412231445, 0.602914237605529, -85.914436340332, -1.49948978913386, 218, 2, 'PPL', 'P'),
(72351, 'Duncan Falls', 39.871940612793, 0.695896642852883, -81.9094390869141, -1.42958940052839, 218, 41, 'PPL', 'P'),
(13682, 'Duncan Glen', 39.7430610656738, 0.693647270417175, -75.654167175293, -1.32041431006308, 218, 10, 'PPL', 'P'),
(86622, 'Duncan Hills', 35.0894393920898, 0.612426250070965, -85.320556640625, -1.48912463301322, 218, 50, 'PPL', 'P'),
(124669, 'Duncan Knoll', 42.2055587768555, 0.736625963300119, -72.5541687011719, -1.26630912988287, 218, 23, 'PPL', 'P'),
(101543, 'Duncan Mill', 36.7630615234375, 0.641636466697227, -82.6474990844727, -1.44247097756305, 218, 53, 'PPL', 'P'),
(119415, 'Duncan Mills', 40.3400001525879, 0.704065822917674, -90.1908264160156, -1.57412687605415, 218, 18, 'PPL', 'P'),
(194861, 'Duncan Place', 42.0355606079102, 0.733658935529661, -114.808891296387, -2.00379316368621, 218, 17, 'PPL', 'P'),
(196380, 'Duncan Ranch Colony', 46.4444389343262, 0.810608378645438, -110.023063659668, -1.92026471399253, 218, 31, 'PPL', 'P'),
(181222, 'Duncan Springs', 38.952220916748, 0.679844505961458, -123.123611450195, -2.1489124067521, 218, 6, 'PPL', 'P'),
(80769, 'Duncan Township', 34.563060760498, 0.603239209837546, -82.2677764892578, -1.43584356803233, 218, 48, 'PPL', 'P'),
(13683, 'Duncan Village', 39.7333297729492, 0.693477427318655, -75.6374969482422, -1.32012335971399, 218, 10, 'PPL', 'P'),
(13684, 'Duncan Woods', 39.7355613708496, 0.693516376049597, -75.6388931274414, -1.32014772763796, 218, 10, 'PPL', 'P'),
(160940, 'Duncannon', 40.3980598449707, 0.705079155712449, -77.0233306884766, -1.34431072136631, 218, 45, 'PPL', 'P'),
(35662, 'Duncanon', 37.6594390869141, 0.657281206520897, -84.3480606079102, -1.47215137527976, 218, 21, 'PPL', 'P'),
(54502, 'Duncans Bridge', 39.5755615234375, 0.690723851909567, -92.2636108398438, -1.610303788934, 218, 29, 'PPL', 'P'),
(64301, 'Duncans Creek', 35.4500007629395, 0.618719233147795, -81.716667175293, -1.42622489596524, 218, 33, 'PPL', 'P'),
(8625, 'Duncans Gap (historical)', 35.0444412231445, 0.611640883865501, -92.1916732788086, -1.60904824163809, 218, 4, 'PPL', 'P'),
(46717, 'Duncans Hill', 39.5863914489746, 0.690912869767936, -76.8944396972656, -1.34206114919352, 218, 25, 'PPL', 'P'),
(181223, 'Duncans Mills', 38.4538917541504, 0.671147021315422, -123.053886413574, -2.14769547529199, 218, 6, 'PPL', 'P'),
(160942, 'Duncansville', 40.4233283996582, 0.705520175188966, -78.4341735839844, -1.36893457512129, 218, 45, 'PPL', 'P'),
(86623, 'Duncantown', 35.3252792358398, 0.616542431851792, -86.0405578613281, -1.50169102493287, 218, 50, 'PPL', 'P'),
(2133, 'Duncanville', 33.0616683959961, 0.577034969712684, -87.4422225952148, -1.52615468954828, 218, 2, 'PPL', 'P'),
(27006, 'Duncanville', 38.954719543457, 0.679888115224307, -87.695556640625, -1.53057620274808, 218, 18, 'PPL', 'P'),
(86624, 'Duncanville', 35.4516716003418, 0.618748394761732, -86.8413925170898, -1.51566822643998, 218, 50, 'PPL', 'P'),
(93843, 'Duncanville', 32.651668548584, 0.569879122442669, -96.9080581665039, -1.69136468671967, 218, 51, 'PPL', 'P'),
(101544, 'Duncanville', 36.8233299255371, 0.642688348748781, -81.9886093139648, -1.43097118165998, 218, 53, 'PPL', 'P'),
(155043, 'Duncanwood', 40.1980590820313, 0.701588483892655, -80.9497222900391, -1.41283918253623, 218, 41, 'PPL', 'P'),
(194164, 'Dunckley', 40.3008308410645, 0.70338218946585, -107.19361114502, -1.87088145158308, 218, 7, 'PPL', 'P'),
(115348, 'Duncombe', 42.4705581665039, 0.741251075165259, -93.9933319091797, -1.64049311673503, 218, 16, 'PPL', 'P'),
(160944, 'Duncott', 40.7119407653809, 0.710557411232796, -76.2438888549805, -1.33070689504402, 218, 45, 'PPL', 'P'),
(160945, 'Dundaff', 41.6538887023926, 0.726997504116019, -75.5519409179688, -1.31863012529078, 218, 45, 'PPL', 'P'),
(46718, 'Dundalk', 39.250560760498, 0.68505151852478, -76.5208282470703, -1.33554039926446, 218, 25, 'PPL', 'P'),
(46719, 'Dundalk Mobile Home Court', 39.2538909912109, 0.685109642015571, -76.5016708374023, -1.3352060393896, 218, 25, 'PPL', 'P'),
(64304, 'Dundarrach', 34.9291687011719, 0.609628998820001, -79.1552810668945, -1.38152027495884, 218, 33, 'PPL', 'P'),
(27007, 'Dundas', 38.8349990844727, 0.677798599033031, -88.0849990844727, -1.53737325564024, 218, 18, 'PPL', 'P'),
(72353, 'Dundas', 39.2036094665527, 0.684232063857363, -82.4802780151367, -1.43955241932443, 218, 41, 'PPL', 'P'),
(101545, 'Dundas', 36.9147186279297, 0.644283382504657, -78.0219421386719, -1.36173977912033, 218, 53, 'PPL', 'P'),
(135074, 'Dundas', 44.4294395446777, 0.775440004870397, -93.2016677856445, -1.62667597120943, 218, 28, 'PPL', 'P'),
(139908, 'Dundas', 47.6399993896484, 0.831474844997454, -99.029167175293, -1.72838502271676, 218, 34, 'PPL', 'P'),
(173867, 'Dundas', 44.2341690063477, 0.772031891044395, -88.1983337402344, -1.5393513185399, 218, 57, 'PPL', 'P'),
(2134, 'Dundee', 31.1202793121338, 0.543151338137011, -85.6716690063477, -1.49525269983955, 218, 2, 'PPL', 'P'),
(15827, 'Dundee', 28.0222206115723, 0.489080013392155, -81.6194381713867, -1.42452792971864, 218, 12, 'PPL', 'P'),
(32271, 'Dundee', 38.3086090087891, 0.66861135906253, -98.8902816772461, -1.72596101349256, 218, 20, 'PPL', 'P'),
(35660, 'Dundee', 37.5588912963867, 0.65552631652059, -86.7727813720703, -1.51447073605583, 218, 21, 'PPL', 'P'),
(46720, 'Dundee', 39.1416702270508, 0.683151020191873, -76.6252822875977, -1.33736346618867, 218, 25, 'PPL', 'P'),
(54503, 'Dundee', 38.5933303833008, 0.673580684498564, -91.1244430541992, -1.59042156034185, 218, 29, 'PPL', 'P'),
(59722, 'Dundee', 34.524169921875, 0.602560436654712, -90.4555587768555, -1.57874732738738, 218, 30, 'PPL', 'P'),
(75704, 'Dundee', 34.2311096191406, 0.597445569465106, -97.5447235107422, -1.70247659320997, 218, 42, 'PPL', 'P'),
(93844, 'Dundee', 33.7402801513672, 0.588878979186648, -98.9019393920898, -1.72616447899985, 218, 51, 'PPL', 'P'),
(101549, 'Dundee', 37.2408294677734, 0.649975090386374, -79.8819427490234, -1.39420291386007, 218, 53, 'PPL', 'P'),
(115349, 'Dundee', 42.5791702270508, 0.743146713229178, -91.54638671875, -1.5977858665462, 218, 16, 'PPL', 'P'),
(122516, 'Dundee', 40.2722206115723, 0.70288284676146, -85.7561111450195, -1.4967264931868, 218, 19, 'PPL', 'P'),
(130553, 'Dundee', 41.957218170166, 0.732291602046987, -83.6597213745117, -1.46013758928631, 218, 27, 'PPL', 'P'),
(135076, 'Dundee', 43.8469390869141, 0.765273453988046, -95.466667175293, -1.66620766811446, 218, 28, 'PPL', 'P'),
(143736, 'Dundee', 44.139720916748, 0.770383460908663, -71.1322174072266, -1.24149139800053, 218, 36, 'PPL', 'P'),
(148352, 'Dundee', 42.5233306884766, 0.742172129428263, -76.976936340332, -1.34350098723687, 218, 40, 'PPL', 'P'),
(155042, 'Dundee', 40.586669921875, 0.708371022556868, -81.6083297729492, -1.42433405159128, 218, 41, 'PPL', 'P'),
(160946, 'Dundee', 41.2083282470703, 0.71922100715396, -75.9725036621094, -1.32597032988726, 218, 45, 'PPL', 'P'),
(173868, 'Dundee', 43.6552810668945, 0.761928390500852, -88.164436340332, -1.53875969730373, 218, 57, 'PPL', 'P'),
(200730, 'Dundee', 45.2783317565918, 0.790255968962835, -123.009719848633, -2.14692462331446, 218, 43, 'PPL', 'P'),
(46721, 'Dundee Village', 39.3472213745117, 0.686738564496318, -76.383056640625, -1.33313583111623, 218, 25, 'PPL', 'P'),
(181225, 'Dunderberg Mill', 38.103889465332, 0.665038328986026, -119.249443054199, -2.08129541246526, 218, 6, 'PPL', 'P'),
(108973, 'Dundon', 38.4597206115723, 0.671248754069063, -81.0688934326172, -1.41491911134758, 218, 58, 'PPL', 'P'),
(160947, 'Dundore', 40.7286109924316, 0.710848361581887, -76.8561096191406, -1.34139216312769, 218, 45, 'PPL', 'P'),
(122517, 'Dune Acres', 41.6494407653809, 0.726919872970243, -87.0858306884766, -1.51993447734824, 218, 19, 'PPL', 'P'),
(122518, 'Dune Acres Station', 41.6372184753418, 0.726706553766928, -87.084716796875, -1.51991503627228, 218, 19, 'PPL', 'P'),
(378, 'Dune Allen Beach', 30.3527793884277, 0.529755937459535, -86.2422180175781, -1.50521065862952, 218, 12, 'PPL', 'P'),
(40718, 'Dune Estates', 32.5555610656738, 0.568201730430082, -93.9000015258789, -1.63886419425429, 218, 22, 'PPL', 'P'),
(80771, 'Dunean', 34.8247184753418, 0.607805998474814, -82.4194412231445, -1.43849061699781, 218, 48, 'PPL', 'P'),
(15828, 'Dunedin', 28.0194396972656, 0.489031477281288, -82.7719421386719, -1.44464291859006, 218, 12, 'PPL', 'P'),
(101551, 'Dunedin', 37.2063903808594, 0.649374014928343, -77.4372177124023, -1.35153441266509, 218, 53, 'PPL', 'P'),
(15829, 'Dunedin Isles', 28.0275001525879, 0.489172158765872, -82.7905578613281, -1.44496782424305, 218, 12, 'PPL', 'P'),
(127296, 'Dunegrass Golf Community', 43.5372200012207, 0.759867836186431, -70.3969421386719, -1.22865842365576, 218, 26, 'PPL', 'P'),
(122519, 'Duneland Beach', 41.7561111450195, 0.72878162230929, -86.8333282470703, -1.51552747837637, 218, 19, 'PPL', 'P'),
(145104, 'Dunellen', 40.589168548584, 0.708414631819719, -74.4722213745117, -1.29978546425933, 218, 37, 'PPL', 'P'),
(181224, 'Dunes', 32.7830581665039, 0.572172303878309, -114.79638671875, -2.00357491763488, 218, 6, 'PPL', 'P'),
(188446, 'Dunes', 32.6644401550293, 0.570102029025908, -105.998329162598, -1.85001984550005, 218, 38, 'PPL', 'P'),
(200731, 'Dunes City', 43.8833312988281, 0.76590861790803, -124.113891601563, -2.1661960559106, 218, 43, 'PPL', 'P'),
(119419, 'Dunes Park', 42.4208297729492, 0.740383150966002, -87.8255615234375, -1.53284521599683, 218, 18, 'PPL', 'P'),
(15830, 'Dunes Road', 26.4841709136963, 0.462235982104915, -80.1186065673828, -1.39833347671078, 218, 12, 'PPL', 'P'),
(122521, 'Dunfee', 41.086669921875, 0.71709766881684, -85.3372192382813, -1.48941545020426, 218, 19, 'PPL', 'P'),
(72354, 'Dunfee (historical)', 39.9708290100098, 0.697622570976336, -80.8352813720703, -1.41084181171867, 218, 41, 'PPL', 'P'),
(119420, 'Dunfermline', 40.4911117553711, 0.706703217924206, -90.0316696166992, -1.57134906587914, 218, 18, 'PPL', 'P'),
(101552, 'Dunford Village', 37.1741714477539, 0.648811688464173, -81.6302795410156, -1.42471714731409, 218, 53, 'PPL', 'P'),
(46722, 'Dunfretten Estates', 39.2155609130859, 0.684440655949743, -76.9916687011719, -1.34375811544012, 218, 25, 'PPL', 'P'),
(101553, 'Dungadin Heights', 38.8880615234375, 0.678724713302106, -78.2305603027344, -1.36538085296269, 218, 53, 'PPL', 'P'),
(101554, 'Dungannon', 36.8283309936523, 0.642775633853508, -82.4725036621094, -1.43941673126689, 218, 53, 'PPL', 'P'),
(155044, 'Dungannon', 40.7341690063477, 0.710945367224594, -80.8788909912109, -1.41160294315821, 218, 41, 'PPL', 'P'),
(32272, 'Dungans Crossing', 38.2330589294434, 0.667292761427805, -99.6613922119141, -1.73941943121933, 218, 20, 'PPL', 'P'),
(160948, 'Dungarvin', 40.7088890075684, 0.710504148010995, -78.0822219848633, -1.36279186090897, 218, 45, 'PPL', 'P'),
(20703, 'Dungeness', 30.7480602264404, 0.536654889552899, -81.4674987792969, -1.42187608706319, 218, 13, 'PPL', 'P'),
(207245, 'Dungeness', 48.1469383239746, 0.840322598507997, -123.121940612793, -2.14888324513816, 218, 56, 'PPL', 'P'),
(155046, 'Dunglen', 40.1952781677246, 0.701539947781788, -80.7997207641602, -1.41022116202662, 218, 41, 'PPL', 'P'),
(108974, 'Dungriff', 38.2402801513672, 0.667418795526393, -81.7141723632813, -1.42618135328141, 218, 58, 'PPL', 'P'),
(35661, 'Dunham', 37.189998626709, 0.649087924848241, -82.6477813720703, -1.44247590441106, 218, 21, 'PPL', 'P'),
(72356, 'Dunham', 39.3347206115723, 0.686520385024014, -81.628059387207, -1.42467839832023, 218, 41, 'PPL', 'P'),
(130555, 'Dunham', 46.3822212219238, 0.809522474710958, -89.7858276367188, -1.56705831388886, 218, 27, 'PPL', 'P'),
(196381, 'Dunham', 47.6119384765625, 0.830985089672989, -114.120002746582, -1.99176979031283, 218, 31, 'PPL', 'P'),
(20704, 'Dunham (historical)', 31.7369403839111, 0.553914104208402, -81.2958297729492, -1.4188798976788, 218, 13, 'PPL', 'P'),
(119421, 'Dunham Castle', 41.952220916748, 0.732204383521287, -88.2713928222656, -1.54062644006982, 218, 18, 'PPL', 'P'),
(127298, 'Dunham Corner', 45.211669921875, 0.789092500461606, -69.3013916015625, -1.20953745966121, 218, 26, 'PPL', 'P'),
(148356, 'Dunham Hollow', 42.5849990844727, 0.743248445982819, -73.4850006103516, -1.28255521148068, 218, 40, 'PPL', 'P'),
(145106, 'Dunhams Corners', 40.4238891601563, 0.705529962305972, -74.4222183227539, -1.29891274637011, 218, 37, 'PPL', 'P'),
(80773, 'Dunhill', 34.5463905334473, 0.602948259488455, -82.7197189331055, -1.44373145170698, 218, 48, 'PPL', 'P'),
(178117, 'Dunhill Meadows', 33.5052795410156, 0.584777444791817, -112.224716186523, -1.95869079957101, 218, 5, 'PPL', 'P'),
(178118, 'Dunhill Place', 33.6430587768555, 0.587182146098104, -112.152778625488, -1.95743525227509, 218, 5, 'PPL', 'P'),
(75706, 'Dunjee Park', 35.5133285522461, 0.619824511579205, -97.3002777099609, -1.69821020914367, 218, 42, 'PPL', 'P'),
(78153, 'Dunkard', 39.7411117553711, 0.693613248534249, -79.9749984741211, -1.39582704265085, 218, 45, 'PPL', 'P'),
(27008, 'Dunkel', 39.4680595397949, 0.688847588342579, -89.0627822875977, -1.55443879190547, 218, 18, 'PPL', 'P'),
(113291, 'Dunkelbergers', 40.7666702270508, 0.71151262053678, -76.7333297729492, -1.33924925055656, 218, 45, 'PPL', 'P'),
(46733, 'Dunkeld Manor', 39.0736083984375, 0.681963117187643, -76.5361099243164, -1.33580711484763, 218, 25, 'PPL', 'P'),
(188447, 'Dunken', 32.8127784729004, 0.572691021079629, -105.201942443848, -1.83612027513871, 218, 38, 'PPL', 'P'),
(115350, 'Dunkerton', 42.5699996948242, 0.742986657247664, -92.1602783203125, -1.6085002962438, 218, 16, 'PPL', 'P'),
(127297, 'Dunkertown', 44.045280456543, 0.768735163930986, -70.5155563354492, -1.23072863192914, 218, 26, 'PPL', 'P'),
(72358, 'Dunkinsville', 38.8558311462402, 0.678162187100854, -83.4713897705078, -1.45685058271088, 218, 41, 'PPL', 'P'),
(32273, 'Dunkirk', 37.4844398498535, 0.654226893645713, -94.7416687011719, -1.65355405766911, 218, 20, 'PPL', 'P'),
(46723, 'Dunkirk', 38.7216682434082, 0.675820602712402, -76.6608276367188, -1.33798384956461, 218, 25, 'PPL', 'P'),
(59723, 'Dunkirk', 33.457218170166, 0.583938615627469, -90.8816680908203, -1.58618433788948, 218, 30, 'PPL', 'P'),
(122523, 'Dunkirk', 40.3752784729004, 0.7046815457617, -85.2094421386719, -1.48718531910742, 218, 19, 'PPL', 'P'),
(148353, 'Dunkirk', 42.4794387817383, 0.741406071140702, -79.3341674804688, -1.38464243186279, 218, 40, 'PPL', 'P'),
(155045, 'Dunkirk', 40.7891693115234, 0.711905303639513, -83.6433334350586, -1.45985156578523, 218, 41, 'PPL', 'P'),
(173869, 'Dunkirk', 42.8813896179199, 0.748421436663216, -89.209716796875, -1.55700328287716, 218, 57, 'PPL', 'P'),
(196382, 'Dunkirk', 48.4780616760254, 0.846101791231524, -111.663330078125, -1.9488927636045, 218, 31, 'PPL', 'P'),
(46724, 'Dunkirk Fields', 38.7213897705078, 0.675815742443413, -76.6374969482422, -1.33757665223393, 218, 25, 'PPL', 'P'),
(46725, 'Dunkirk Hall', 38.704719543457, 0.675524792094322, -76.6463928222656, -1.33773191452548, 218, 25, 'PPL', 'P'),
(46726, 'Dunkirk South', 38.7127799987793, 0.675665473578905, -76.6580581665039, -1.33793551319082, 218, 25, 'PPL', 'P'),
(46727, 'Dunkirk Town Center', 38.7202796936035, 0.675796367946483, -76.6588897705078, -1.33795002741876, 218, 25, 'PPL', 'P'),
(46728, 'Dunkirk Woods', 38.732780456543, 0.676014547418787, -76.6377792358398, -1.33758157908195, 218, 25, 'PPL', 'P'),
(160949, 'Dunkle', 40.2130584716797, 0.701850272627809, -80.4188919067383, -1.403574444578, 218, 45, 'PPL', 'P'),
(86625, 'Dunkled Estates', 36.0269393920898, 0.628788711808412, -86.9355621337891, -1.51731179630673, 218, 50, 'PPL', 'P'),
(54505, 'Dunksburg', 38.899169921875, 0.678918591429464, -93.4974975585938, -1.63183917477282, 218, 29, 'PPL', 'P'),
(8626, 'Dunlap', 33.8525009155273, 0.590837601010347, -93.5388870239258, -1.6325615572185, 218, 4, 'PPL', 'P'),
(20705, 'Dunlap', 33.9533309936523, 0.592597417858671, -83.2536087036133, -1.45304958604506, 218, 13, 'PPL', 'P'),
(32274, 'Dunlap', 38.5763893127441, 0.673285007038538, -96.3655624389648, -1.68189635009611, 218, 20, 'PPL', 'P'),
(35663, 'Dunlap', 37.4280586242676, 0.653242855622929, -82.2425003051758, -1.43540241539776, 218, 21, 'PPL', 'P'),
(40720, 'Dunlap', 31.2091693878174, 0.544702762630036, -92.0588912963867, -1.6067307588575, 218, 22, 'PPL', 'P'),
(72359, 'Dunlap', 39.2922210693359, 0.685778628081399, -84.6180572509766, -1.4768637056706, 218, 41, 'PPL', 'P'),
(75707, 'Dunlap', 36.6066703796387, 0.638906926316977, -99.6750030517578, -1.73965698518857, 218, 42, 'PPL', 'P'),
(86626, 'Dunlap', 35.3713912963867, 0.617347239133214, -85.3905563354492, -1.49034635816329, 218, 50, 'PPL', 'P'),
(115351, 'Dunlap', 41.8544387817383, 0.730497763315737, -95.6002807617188, -1.66853966512298, 218, 16, 'PPL', 'P'),
(119423, 'Dunlap', 40.8616714477539, 0.713170704631464, -89.6786117553711, -1.56518704374892, 218, 18, 'PPL', 'P'),
(122532, 'Dunlap', 41.6377792358398, 0.726716340883934, -85.9216690063477, -1.49961602296953, 218, 19, 'PPL', 'P'),
(139127, 'Dunlap', 40.1083297729492, 0.700022412013634, -93.4822235107422, -1.6315725923477, 218, 29, 'PPL', 'P'),
(160950, 'Dunlap', 40.1886100769043, 0.701423567642152, -74.8694381713867, -1.30671820520902, 218, 45, 'PPL', 'P'),
(181226, 'Dunlap', 36.7383308410645, 0.641204834863552, -119.120002746582, -2.07903625291255, 218, 6, 'PPL', 'P'),
(188448, 'Dunlap', 34.0847206115723, 0.594890599294311, -104.528060913086, -1.82435882365854, 218, 38, 'PPL', 'P'),
(191401, 'Dunlap', 34.1405601501465, 0.595865183095226, -100.296112060547, -1.75049738240574, 218, 51, 'PPL', 'P'),
(207246, 'Dunlap', 47.5316696166992, 0.829584133781552, -122.268333435059, -2.13398498936804, 218, 56, 'PPL', 'P'),
(8627, 'Dunlap (historical)', 34.2936096191406, 0.598536400247602, -93.6277770996094, -1.63411298171153, 218, 4, 'PPL', 'P'),
(86627, 'Dunlap (historical)', 36.3472213745117, 0.634378686936488, -88.6055603027344, -1.5464587628571, 218, 50, 'PPL', 'P'),
(181227, 'Dunlap (historical)', 39.351390838623, 0.686811335373105, -123.551391601563, -2.15637857886814, 218, 6, 'PPL', 'P'),
(181228, 'Dunlap Acres', 34.0311088562012, 0.593954897645312, -117.106666564941, -2.04389690759339, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(78156, 'Dunlap Creek Village', 39.9688911437988, 0.697588748830492, -79.8694381713867, -1.39398466780874, 218, 45, 'PPL', 'P'),
(181229, 'Dunlap Place', 39.853889465332, 0.695581590895926, -123.43083190918, -2.15427441529086, 218, 6, 'PPL', 'P'),
(80775, 'Dunlape Crossroads', 34.064998626709, 0.594546385723419, -80.1352767944336, -1.39862442705987, 218, 48, 'PPL', 'P'),
(29673, 'Dunlapsville', 39.5908317565918, 0.690990367755657, -84.9936065673828, -1.48341827774551, 218, 19, 'PPL', 'P'),
(32278, 'Dunlay', 38.2583312988281, 0.667733847483349, -94.9972229003906, -1.65801431986277, 218, 20, 'PPL', 'P'),
(93846, 'Dunlay', 29.3483295440674, 0.512224980504302, -98.9902801513672, -1.72770631611295, 218, 51, 'PPL', 'P'),
(35664, 'Dunleary', 37.3180618286133, 0.651323049372118, -82.3663864135742, -1.43756463588679, 218, 21, 'PPL', 'P'),
(46729, 'Dunleigh', 38.750560760498, 0.676324872264809, -76.6597213745117, -1.3379645416467, 218, 25, 'PPL', 'P'),
(13685, 'Dunleith', 39.708610534668, 0.693045995222062, -75.5558319091797, -1.31869803589858, 218, 10, 'PPL', 'P'),
(59724, 'Dunleith', 33.4358291625977, 0.583565307021668, -90.820556640625, -1.58511774187291, 218, 30, 'PPL', 'P'),
(160955, 'Dunlevy', 40.1100006103516, 0.70005157362757, -79.8516693115234, -1.3936745426998, 218, 45, 'PPL', 'P'),
(101555, 'Dunlin', 39.0569381713867, 0.681672166838552, -77.5763931274414, -1.35396348189535, 218, 53, 'PPL', 'P'),
(13686, 'Dunlinden Acres', 39.7361106872559, 0.693525963429522, -75.6458282470703, -1.32026876830951, 218, 10, 'PPL', 'P'),
(160952, 'Dunlo', 40.2944412231445, 0.703270669595203, -78.7213897705078, -1.37394744324114, 218, 45, 'PPL', 'P'),
(46730, 'Dunloggin', 39.2638893127441, 0.685284145645999, -76.8341674804688, -1.34100920056294, 218, 25, 'PPL', 'P'),
(101556, 'Dunlop', 37.2694396972656, 0.650474433090764, -77.404167175293, -1.35095757197298, 218, 53, 'PPL', 'P'),
(46731, 'Dunlops Hills', 38.9900016784668, 0.680503904647361, -77.0669403076172, -1.34507185280585, 218, 25, 'PPL', 'P'),
(101557, 'Dunlora Plantation', 38.0608291625977, 0.664286784926405, -78.4608306884766, -1.36939982936373, 218, 53, 'PPL', 'P'),
(108975, 'Dunloup', 37.9047203063965, 0.661562171394173, -81.1547164916992, -1.41641700630269, 218, 58, 'PPL', 'P'),
(108977, 'Dunlow', 38.0230598449707, 0.663627585977583, -82.4316711425781, -1.43870406935918, 218, 58, 'PPL', 'P'),
(46732, 'Dunmoor Woods', 39.2583312988281, 0.685187140003293, -76.8563919067383, -1.34139708997571, 218, 25, 'PPL', 'P'),
(35665, 'Dunmor', 37.0736083984375, 0.647056532147756, -86.9961090087891, -1.51836853862727, 218, 21, 'PPL', 'P'),
(108976, 'Dunmore', 38.3594398498535, 0.669498524600663, -79.8811111450195, -1.39418839963213, 218, 58, 'PPL', 'P'),
(160953, 'Dunmore', 41.4197196960449, 0.722910483949129, -75.6327819824219, -1.32004106803631, 218, 45, 'PPL', 'P'),
(196383, 'Dunmore', 45.6786117553711, 0.797242172871412, -107.503890991211, -1.8762968565017, 218, 31, 'PPL', 'P'),
(181230, 'Dunmovin', 36.0886116027832, 0.629865094941995, -117.96028137207, -2.05879529652156, 218, 6, 'PPL', 'P'),
(2135, 'Dunn', 31.8449993133545, 0.555800088313369, -85.896110534668, -1.49916994348694, 218, 2, 'PPL', 'P'),
(8628, 'Dunn', 36.2405586242676, 0.632517070755496, -91.1055603027344, -1.59009199415696, 218, 4, 'PPL', 'P'),
(20707, 'Dunn', 34.2380599975586, 0.597566876452759, -84.1263885498047, -1.46828246800615, 218, 13, 'PPL', 'P'),
(40719, 'Dunn', 32.464168548584, 0.566606630095179, -91.5783309936523, -1.5983433993204, 218, 22, 'PPL', 'P'),
(54507, 'Dunn', 37.1411094665527, 0.64823464803498, -92.1902770996094, -1.60902387371411, 218, 29, 'PPL', 'P'),
(64306, 'Dunn', 35.3061103820801, 0.616207872239851, -78.6091690063477, -1.37198882141745, 218, 33, 'PPL', 'P'),
(86628, 'Dunn', 35.1941719055176, 0.614254177264168, -87.3399963378906, -1.52437050477598, 218, 50, 'PPL', 'P'),
(112299, 'Dunn', 39.6261100769043, 0.691606090599683, -88.6916732788086, -1.54796171781828, 218, 18, 'PPL', 'P'),
(122524, 'Dunn', 40.5638885498047, 0.70797341260612, -87.4638900756836, -1.52653285842307, 218, 19, 'PPL', 'P'),
(181231, 'Dunn', 35.0449981689453, 0.61165060440348, -116.436943054199, -2.03220802725292, 218, 6, 'PPL', 'P'),
(191402, 'Dunn', 32.5669403076172, 0.568400335668375, -100.88500213623, -1.76077545315873, 218, 51, 'PPL', 'P'),
(8629, 'Dunn (historical)', 35.2691688537598, 0.615563120939942, -90.5719375610352, -1.58077852035079, 218, 4, 'PPL', 'P'),
(148357, 'Dunn Brook', 43.3872184753418, 0.757249815676829, -75.3819427490234, -1.31566309752032, 218, 40, 'PPL', 'P'),
(198214, 'Dunn Center', 47.3536109924316, 0.826476424526512, -102.620002746582, -1.79105692633348, 218, 34, 'PPL', 'P'),
(20708, 'Dunn Chapel', 33.6566696166992, 0.587419700067339, -82.3369369506836, -1.43705064579641, 218, 13, 'PPL', 'P'),
(86629, 'Dunn Chapel', 36.2986106872559, 0.633530270392216, -87.3930587768555, -1.52529661904506, 218, 50, 'PPL', 'P'),
(169350, 'Dunn Corner', 41.351390838623, 0.721717920412991, -71.769172668457, -1.2526083644969, 218, 47, 'PPL', 'P'),
(119425, 'Dunn Corners', 42.480281829834, 0.741420785105725, -87.9913864135742, -1.53573940631148, 218, 18, 'PPL', 'P'),
(15831, 'Dunn Creek', 30.4861106872559, 0.532083007620046, -81.5908279418945, -1.42402858701425, 218, 12, 'PPL', 'P'),
(64307, 'Dunn Crossroads', 35.791389465332, 0.624677590033657, -77.9119415283203, -1.35981990629049, 218, 33, 'PPL', 'P'),
(20709, 'Dunn Hill', 33.8116683959961, 0.590124939102642, -84.5933303833008, -1.47643214041596, 218, 13, 'PPL', 'P'),
(169351, 'Dunn Landing', 41.1813888549805, 0.718750826063507, -71.6069412231445, -1.24977689162593, 218, 47, 'PPL', 'P'),
(130556, 'Dunn Location', 46.0680618286133, 0.804039358921621, -88.3747177124023, -1.54242979960197, 218, 27, 'PPL', 'P'),
(101559, 'Dunn Loring', 38.8933296203613, 0.678816658938741, -77.2219390869141, -1.34777709184115, 218, 53, 'PPL', 'P'),
(101558, 'Dunn Loring Woods', 38.8822212219238, 0.678622780811384, -77.2388916015625, -1.34807296903826, 218, 53, 'PPL', 'P'),
(122525, 'Dunn Mill', 41.1622200012207, 0.718416266451566, -85.2358322143555, -1.48764591281795, 218, 19, 'PPL', 'P'),
(188449, 'Dunn Place', 34.9933280944824, 0.610748791479352, -106.154167175293, -1.85273973192135, 218, 38, 'PPL', 'P'),
(93847, 'Dunnam', 30.0752792358398, 0.524912646122089, -95.166389465332, -1.66096683340529, 218, 51, 'PPL', 'P'),
(200732, 'Dunnean', 43.4322204589844, 0.75803524846132, -118.260833740234, -2.06404092492069, 218, 43, 'PPL', 'P'),
(54510, 'Dunnegan', 37.7080612182617, 0.658129822802251, -93.5766677856445, -1.63322095590441, 218, 29, 'PPL', 'P'),
(135079, 'Dunnell', 43.559440612793, 0.760255659020174, -94.774169921875, -1.6541213109813, 218, 28, 'PPL', 'P'),
(15832, 'Dunnellon', 29.0488891601563, 0.506998759891617, -82.4611129760742, -1.43921792629152, 218, 12, 'PPL', 'P'),
(181232, 'Dunneville', 36.940559387207, 0.644734388835262, -121.409439086914, -2.11899445506615, 218, 6, 'PPL', 'P'),
(145108, 'Dunnfield', 40.9711112976074, 0.715080790344296, -75.1241683959961, -1.3111640863328, 218, 37, 'PPL', 'P'),
(181233, 'Dunnigan', 38.8852806091309, 0.67867617719124, -121.968612670898, -2.12875387519685, 218, 6, 'PPL', 'P'),
(119426, 'Dunning', 41.9527816772461, 0.732214170638293, -87.79638671875, -1.53233601959641, 218, 18, 'PPL', 'P'),
(160956, 'Dunning', 41.9333305358887, 0.731874684178336, -76.7988891601563, -1.34039347771891, 218, 45, 'PPL', 'P'),
(198217, 'Dunning', 48.7194404602051, 0.85031464575992, -101.039436340332, -1.763470838498, 218, 34, 'PPL', 'P'),
(199287, 'Dunning', 41.8286094665527, 0.730046956722214, -100.10417175293, -1.74714739207053, 218, 35, 'PPL', 'P'),
(160957, 'Dunningsville', 40.1855583190918, 0.70137030442035, -80.0813903808594, -1.39768393172091, 218, 45, 'PPL', 'P'),
(8630, 'Dunnington', 35.6252784729004, 0.621778406291969, -91.4286117553711, -1.59573030565882, 218, 4, 'PPL', 'P'),
(122526, 'Dunnington', 40.5641708374023, 0.707978339454136, -87.4908294677734, -1.52700303951352, 218, 19, 'PPL', 'P'),
(160958, 'Dunningtown', 40.4211082458496, 0.705481426195105, -79.5824966430664, -1.38897659337884, 218, 45, 'PPL', 'P'),
(130557, 'Dunningville', 42.6127815246582, 0.743733341038295, -85.9486083984375, -1.50008620405998, 218, 27, 'PPL', 'P'),
(101560, 'Dunnmore', 37.2744407653809, 0.650561718195491, -77.0427780151367, -1.34465014124724, 218, 53, 'PPL', 'P'),
(2136, 'Dunns', 31.4319400787354, 0.548590844663498, -86.4697189331055, -1.50918129865677, 218, 2, 'PPL', 'P'),
(108982, 'Dunns', 37.5430603027344, 0.655250013557494, -81.0533294677734, -1.41464746891639, 218, 58, 'PPL', 'P'),
(127300, 'Dunns', 43.8561096191406, 0.76543350996956, -70.2152786254883, -1.22548779721997, 218, 26, 'PPL', 'P'),
(101561, 'Dunns (historical)', 38.0227813720703, 0.663622725708594, -79.8099975585938, -1.3929472334061, 218, 53, 'PPL', 'P'),
(122527, 'Dunns Bridge', 41.2255592346191, 0.719521744620057, -86.9738922119141, -1.51798078237255, 218, 19, 'PPL', 'P'),
(101562, 'Dunns Corner', 36.7461090087891, 0.641340589500119, -78.2744369506836, -1.36614664493414, 218, 53, 'PPL', 'P'),
(127299, 'Dunns Corners', 44.4144401550293, 0.775178216135242, -69.9180603027344, -1.22030035889066, 218, 26, 'PPL', 'P'),
(93848, 'Dunns Fort', 30.8647193908691, 0.538690976074805, -96.4286117553711, -1.68299676825853, 218, 51, 'PPL', 'P'),
(145112, 'Dunns Mills', 40.1291694641113, 0.700386133239511, -74.6938934326172, -1.30365437153294, 218, 37, 'PPL', 'P'),
(64308, 'Dunns Rock', 35.1741714477539, 0.613905103424286, -82.7441711425781, -1.44415822327167, 218, 33, 'PPL', 'P'),
(160960, 'Dunnstown', 41.1458282470703, 0.718130176371464, -77.4216690063477, -1.35126303655001, 218, 45, 'PPL', 'P'),
(101563, 'Dunnsville', 37.8574981689453, 0.66073798961582, -76.8199996948242, -1.34076192605572, 218, 53, 'PPL', 'P'),
(148358, 'Dunnsville', 42.7397193908691, 0.745948824749132, -74.0147171020508, -1.29180050836294, 218, 40, 'PPL', 'P'),
(35666, 'Dunnville', 37.2000007629395, 0.649262495057696, -85.0100021362305, -1.48370443440463, 218, 21, 'PPL', 'P'),
(173874, 'Dunnville', 44.7186088562012, 0.780486961452206, -91.9052810668945, -1.60404975458812, 218, 57, 'PPL', 'P'),
(115355, 'Dunnville (historical)', 40.8277816772461, 0.712579216553357, -92.3791732788086, -1.61232073398558, 218, 16, 'PPL', 'P'),
(209414, 'DuNoir', 43.5658302307129, 0.760367178890821, -109.815002441406, -1.91663336068815, 218, 59, 'PPL', 'P'),
(199928, 'Dunphy', 40.7088890075684, 0.710504148010995, -116.529167175293, -2.03381764181576, 218, 39, 'PPL', 'P'),
(35667, 'Dunraven', 37.3058280944824, 0.65110953043172, -83.3030624389648, -1.45391271655435, 218, 21, 'PPL', 'P'),
(113185, 'Dunraven', 42.1341705322266, 0.735380003384125, -74.6975021362305, -1.30371735529272, 218, 40, 'PPL', 'P'),
(101564, 'Dunreath (historical)', 37.9858283996582, 0.662977774671604, -78.0019378662109, -1.36139063870142, 218, 53, 'PPL', 'P'),
(29676, 'Dunreith', 39.8033294677734, 0.694699152468729, -85.438606262207, -1.49118498759056, 218, 19, 'PPL', 'P'),
(160961, 'Dunring', 41.5099983215332, 0.724486143208074, -78.9977798461914, -1.37877136008166, 218, 45, 'PPL', 'P'),
(86630, 'Dunrovin Estates', 35.8822212219238, 0.626262903251554, -85.0013885498047, -1.4835540989611, 218, 50, 'PPL', 'P'),
(2137, 'Dunrowin', 33.5722198486328, 0.585945773562035, -86.2249984741211, -1.5049101209005, 218, 2, 'PPL', 'P'),
(148359, 'Dunsbach Ferry', 42.7919387817383, 0.746860225053184, -73.7566680908203, -1.28729670348545, 218, 40, 'PPL', 'P'),
(198218, 'Dunseith', 48.813060760498, 0.851948628246738, -100.060562133789, -1.74638626063098, 218, 34, 'PPL', 'P'),
(46737, 'Dunsen Heights', 39.6558303833008, 0.692124807801004, -76.3777770996094, -1.33304368574251, 218, 25, 'PPL', 'P'),
(54508, 'Dunsford', 39.8805618286133, 0.696047111454472, -91.4686126708984, -1.59642845333858, 218, 29, 'PPL', 'P'),
(160962, 'Dunsfort', 40.1902809143066, 0.701452729256088, -80.5002822875977, -1.40499497470345, 218, 45, 'PPL', 'P'),
(193510, 'Dunsmuir', 41.2083282470703, 0.71922100715396, -122.27082824707, -2.13402853205186, 218, 6, 'PPL', 'P'),
(124670, 'Dunstable', 42.6749992370605, 0.744819244972775, -71.4833297729492, -1.24761946482685, 218, 23, 'PPL', 'P'),
(46734, 'Dunstable Green', 39.0183296203613, 0.680998320503734, -76.5500030517578, -1.33604959566488, 218, 25, 'PPL', 'P'),
(80776, 'Dunston Hills', 34.0638885498047, 0.594527011226488, -81.0686111450195, -1.41491418449956, 218, 48, 'PPL', 'P'),
(200733, 'Dunthorpe', 45.4358291625977, 0.793004817260987, -122.65389251709, -2.14071426481045, 218, 43, 'PPL', 'P'),
(186641, 'Dunton', 37.7727813720703, 0.659259402578608, -108.093330383301, -1.88658451463462, 218, 7, 'PPL', 'P'),
(101565, 'Dunton (historical)', 37.6819381713867, 0.65767388962363, -76.3775024414063, -1.33303889205255, 218, 53, 'PPL', 'P'),
(186642, 'Dunul', 37.6622200012207, 0.657329742631764, -106.101936340332, -1.85182813188022, 218, 7, 'PPL', 'P'),
(143737, 'Dunvegan Woods', 42.9388885498047, 0.749424982340985, -70.8050003051758, -1.23578038220091, 218, 36, 'PPL', 'P'),
(135081, 'Dunvilla', 46.6630592346191, 0.814424022697249, -96.0158309936523, -1.67579238487765, 218, 28, 'PPL', 'P'),
(46735, 'Dunwood', 39.4819412231445, 0.689089869422749, -76.3852767944336, -1.33317458011009, 218, 25, 'PPL', 'P'),
(148360, 'Dunwoodie', 40.9283294677734, 0.714334106553665, -73.8641662597656, -1.28917290047342, 218, 40, 'PPL', 'P'),
(148361, 'Dunwoodie Heights', 40.9252815246582, 0.714280909910891, -73.8683319091797, -1.28924560477117, 218, 40, 'PPL', 'P'),
(20710, 'Dunwoody', 33.9461097717285, 0.592471383760083, -84.334716796875, -1.47191848184243, 218, 13, 'PPL', 'P'),
(20711, 'Dunwoody Club Forest', 33.9569396972656, 0.592660401618452, -84.3116683959961, -1.47151621135978, 218, 13, 'PPL', 'P'),
(20712, 'Dunwoody Corners', 33.9486083984375, 0.592514993022933, -84.3150024414063, -1.4715744014296, 218, 13, 'PPL', 'P'),
(20713, 'Dunwoody Heights', 33.9597206115723, 0.592708937729318, -84.32861328125, -1.47181195539883, 218, 13, 'PPL', 'P'),
(135082, 'Dunwoody Junction', 47.4519386291504, 0.828192565532959, -92.8672180175781, -1.62083872157414, 218, 28, 'PPL', 'P'),
(20714, 'Dunwoody Knoll', 33.957218170166, 0.592665261887441, -84.3383331298828, -1.47198159876027, 218, 13, 'PPL', 'P'),
(20715, 'Dunwoody West', 33.9474983215332, 0.592495618526003, -84.341667175293, -1.47203978883009, 218, 13, 'PPL', 'P'),
(203772, 'Dunyon Dell', 40.6327781677246, 0.709175763259263, -111.613059997559, -1.94801538518337, 218, 52, 'PPL', 'P'),
(86631, 'Duo', 36.4830589294434, 0.636749499517904, -83.6316680908203, -1.45964796711989, 218, 50, 'PPL', 'P'),
(108978, 'Duo', 38.0711097717285, 0.664466215404849, -80.5977783203125, -1.40669660148196, 218, 58, 'PPL', 'P'),
(130558, 'Duplain', 43.0466690063477, 0.751306106176962, -84.4524993896484, -1.47397417588787, 218, 27, 'PPL', 'P'),
(173875, 'Duplainville', 43.0738906860352, 0.751781214115433, -88.1980590820313, -1.53934652484993, 218, 57, 'PPL', 'P'),
(40723, 'Duplessis', 30.2694396972656, 0.528301385451161, -90.9383316040039, -1.58717330276028, 218, 22, 'PPL', 'P'),
(86632, 'Duplex', 35.746940612793, 0.623901811208117, -86.8372192382813, -1.51559538898417, 218, 50, 'PPL', 'P'),
(93849, 'Duplex', 33.7777786254883, 0.589533451024535, -96.1388931274414, -1.6779402242968, 218, 51, 'PPL', 'P'),
(86633, 'Duplex Mission', 35.747501373291, 0.623911598325123, -86.8597183227539, -1.5159880720869, 218, 50, 'PPL', 'P'),
(27009, 'Dupo', 38.5161094665527, 0.672232925249902, -90.2102813720703, -1.57446642909313, 218, 18, 'PPL', 'P'),
(13687, 'Dupont', 39.1944389343262, 0.684072007875849, -75.5638885498047, -1.31883865080414, 218, 10, 'PPL', 'P'),
(15833, 'Dupont', 29.4266700744629, 0.513592280697462, -81.2227783203125, -1.41760490930692, 218, 12, 'PPL', 'P'),
(29674, 'Dupont', 38.8899993896484, 0.67875853544795, -85.5141677856445, -1.49250378496237, 218, 19, 'PPL', 'P'),
(40722, 'Dupont', 30.6441707611084, 0.534841676324718, -91.4794387817383, -1.59661740461792, 218, 22, 'PPL', 'P'),
(86634, 'Dupont', 35.8261108398438, 0.625283592339704, -83.7022171020508, -1.46087927964989, 218, 50, 'PPL', 'P'),
(135083, 'Dupont', 45.0958290100098, 0.787070695141045, -93.5986099243164, -1.63360391846916, 218, 28, 'PPL', 'P'),
(155047, 'Dupont', 41.0563888549805, 0.716569164498514, -84.304443359375, -1.47139011068216, 218, 41, 'PPL', 'P'),
(160963, 'Dupont', 41.3250007629395, 0.721257326702462, -75.7458267211914, -1.32201407092989, 218, 45, 'PPL', 'P'),
(186643, 'Dupont', 39.8380584716797, 0.695305287932831, -104.911392211914, -1.83104921694904, 218, 7, 'PPL', 'P'),
(207239, 'DuPont', 47.0969390869141, 0.821996654677862, -122.629997253418, -2.14029721378375, 218, 56, 'PPL', 'P'),
(15834, 'Dupont Center', 29.7561092376709, 0.519342078780457, -81.3133316040039, -1.41918536225583, 218, 12, 'PPL', 'P'),
(13075, 'Dupont Circle', 38.9083290100098, 0.679078447673896, -77.0444412231445, -1.34467916970312, 218, 9, 'PPL', 'P'),
(108979, 'Dupont City', 38.2694396972656, 0.667927725610707, -81.565559387207, -1.42358756753773, 218, 58, 'PPL', 'P'),
(46736, 'Dupont Heights', 38.8619384765625, 0.678268780123485, -76.9247207641602, -1.34258965351184, 218, 25, 'PPL', 'P'),
(13688, 'Dupont Manor', 39.1963882446289, 0.684106029758775, -75.5491714477539, -1.318581788917, 218, 10, 'PPL', 'P'),
(108980, 'Dupont Manor', 39.2541694641113, 0.685114502284561, -81.605827331543, -1.4242903757494, 218, 58, 'PPL', 'P'),
(13076, 'Dupont Park', 38.8713912963867, 0.678433762953015, -76.9505615234375, -1.34304065984245, 218, 9, 'PPL', 'P'),
(86635, 'Dupont Springs', 35.8083305358887, 0.624973267493683, -83.6797180175781, -1.46048659654716, 218, 50, 'PPL', 'P'),
(748, 'Dupont Station', 32.7880592346191, 0.572259588983036, -80.021110534668, -1.39663184993228, 218, 48, 'PPL', 'P'),
(13689, 'Duponts Landing', 39.7513885498047, 0.693792612433666, -75.4944381713867, -1.31762651303399, 218, 10, 'PPL', 'P'),
(93850, 'Dupre', 28.8436107635498, 0.50341597598762, -97.0105590820313, -1.69315366518193, 218, 51, 'PPL', 'P'),
(2139, 'Dupree', 32.4683303833008, 0.566679267813911, -85.3677825927734, -1.4899488813706, 218, 2, 'PPL', 'P'),
(202075, 'Dupree', 45.0475006103516, 0.78622720544479, -101.600563049316, -1.77326434709066, 218, 49, 'PPL', 'P'),
(64315, 'Dupree Crossroads', 35.7008285522461, 0.623097003926695, -77.5386123657227, -1.35330408320945, 218, 33, 'PPL', 'P'),
(15835, 'Dupree Gardens', 28.2374992370605, 0.492837334216093, -82.4469375610352, -1.43897051862625, 218, 12, 'PPL', 'P'),
(64311, 'Dupreeville', 35.2391700744629, 0.615039543469633, -77.5952835083008, -1.35429318123831, 218, 33, 'PPL', 'P'),
(196384, 'Dupuyer', 48.1925010681152, 0.841117818409495, -112.498611450195, -1.9634711737277, 218, 31, 'PPL', 'P'),
(54509, 'Duquesne', 37.0766716003418, 0.647109995106639, -94.4591674804688, -1.64862348122694, 218, 29, 'PPL', 'P'),
(160965, 'Duquesne', 40.3813896179199, 0.704788205363358, -79.8600006103516, -1.39381995129532, 218, 45, 'PPL', 'P'),
(178119, 'Duquesne', 31.3708305358887, 0.547524281936434, -110.684722900391, -1.93181284626938, 218, 5, 'PPL', 'P'),
(160966, 'Duquesne Heights', 40.4352798461914, 0.705728767281346, -80.0202789306641, -1.39661733570434, 218, 45, 'PPL', 'P'),
(135084, 'Duquette', 46.3697204589844, 0.809304295238654, -92.5530624389648, -1.61535567236383, 218, 28, 'PPL', 'P'),
(32276, 'Duquoin', 37.3827781677246, 0.652452562569448, -98.0733337402344, -1.71170258217434, 218, 20, 'PPL', 'P'),
(40724, 'Duralde', 30.5497207641602, 0.533193212899473, -92.5136108398438, -1.61466711206399, 218, 22, 'PPL', 'P'),
(188450, 'Duran', 34.4672203063965, 0.601566478356867, -105.396392822266, -1.83951407447385, 218, 38, 'PPL', 'P'),
(20716, 'Duran Mobile Home Park', 33.4508285522461, 0.583827095756822, -82.0566711425781, -1.43215908466421, 218, 13, 'PPL', 'P'),
(20717, 'Durand', 32.9169387817383, 0.574508961418744, -84.7738876342773, -1.47958345893385, 218, 13, 'PPL', 'P'),
(32277, 'Durand', 37.889720916748, 0.661300382659018, -95.6927795410156, -1.67015407337579, 218, 20, 'PPL', 'P'),
(101567, 'Durand', 36.7200012207031, 0.640884922637607, -77.5883331298828, -1.35417187425065, 218, 53, 'PPL', 'P'),
(119427, 'Durand', 42.4363899230957, 0.740654726818163, -89.3319396972656, -1.55913647491031, 218, 18, 'PPL', 'P'),
(130560, 'Durand', 42.9119415283203, 0.748954668092477, -83.9847183227539, -1.46580985609207, 218, 27, 'PPL', 'P'),
(173877, 'Durand', 44.6263885498047, 0.778877413468389, -91.9655609130859, -1.60510183637675, 218, 57, 'PPL', 'P'),
(188451, 'Duranes', 36.2688903808594, 0.633011553190896, -106.051666259766, -1.85095075345909, 218, 38, 'PPL', 'P'),
(93851, 'Durango', 31.204719543457, 0.544625098194747, -97.1302795410156, -1.69524318137321, 218, 51, 'PPL', 'P'),
(115352, 'Durango', 42.5602798461914, 0.742817013886226, -90.7755584716797, -1.58433237566744, 218, 16, 'PPL', 'P'),
(186644, 'Durango', 37.2752799987793, 0.650576365581487, -107.879440307617, -1.8828514285766, 218, 7, 'PPL', 'P'),
(15836, 'Durant', 27.9083309173584, 0.487092263244034, -82.186393737793, -1.43442317106494, 218, 12, 'PPL', 'P'),
(59725, 'Durant', 33.0750007629395, 0.57726766341293, -89.8544387817383, -1.56825580427302, 218, 30, 'PPL', 'P'),
(64312, 'Durant', 36.1375007629395, 0.630718371755256, -76.2977828979492, -1.33164752354103, 218, 33, 'PPL', 'P'),
(72360, 'Durant', 39.7502784729004, 0.693773237936735, -81.9108276367188, -1.42961363529431, 218, 41, 'PPL', 'P'),
(75708, 'Durant', 33.9938888549805, 0.593305286076414, -96.3705596923828, -1.68198356862181, 218, 42, 'PPL', 'P'),
(80777, 'Durant', 33.829719543457, 0.590439991059598, -80.1544418334961, -1.39895892009279, 218, 48, 'PPL', 'P'),
(93852, 'Durant', 31.4169406890869, 0.548329055928343, -94.833610534668, -1.65515874538394, 218, 51, 'PPL', 'P'),
(115353, 'Durant', 41.5997200012207, 0.726052081929041, -90.9105606079102, -1.58668860744189, 218, 16, 'PPL', 'P'),
(141692, 'Durant', 41.0922203063965, 0.717194541301492, -97.6636123657227, -1.70455159517331, 218, 35, 'PPL', 'P'),
(196385, 'Durant', 46.0213890075684, 0.803224764523193, -112.790000915527, -1.96855687930337, 218, 31, 'PPL', 'P'),
(15837, 'Durant Estates', 29.6563892364502, 0.517601636429063, -82.4047164916992, -1.43823362195262, 218, 12, 'PPL', 'P'),
(15838, 'Durbin', 30.0872192382813, 0.525121038477388, -81.4613876342773, -1.42176942746153, 218, 12, 'PPL', 'P'),
(35669, 'Durbin', 38.2791709899902, 0.668097568709227, -82.5983276367188, -1.44161277390177, 218, 21, 'PPL', 'P'),
(54511, 'Durbin', 37.3758316040039, 0.652331322160822, -92.5013885498047, -1.61445379286067, 218, 29, 'PPL', 'P'),
(78157, 'Durbin', 39.9180603027344, 0.696701583292359, -80.4850006103516, -1.40472825912028, 218, 45, 'PPL', 'P'),
(108981, 'Durbin', 38.5455589294434, 0.672746915340287, -79.8252792358398, -1.39321394898927, 218, 58, 'PPL', 'P'),
(122528, 'Durbin', 40.0563888549805, 0.699115871978571, -85.9108276367188, -1.49942680537408, 218, 19, 'PPL', 'P'),
(139910, 'Durbin', 46.8086090087891, 0.816964345482049, -97.149169921875, -1.69557288071616, 218, 34, 'PPL', 'P'),
(155048, 'Durbin', 40.560001373291, 0.70790556857735, -84.7083282470703, -1.47843923177149, 218, 41, 'PPL', 'P'),
(127301, 'Durbin Corner', 45.0497207641602, 0.786265954438651, -69.1869430541992, -1.2075399556856, 218, 26, 'PPL', 'P'),
(35668, 'Durbintown', 38.5513916015625, 0.672848714672956, -84.4194412231445, -1.4733972020377, 218, 21, 'PPL', 'P'),
(64313, 'Durbro (historical)', 35.2344398498535, 0.61495698547584, -81.4738922119141, -1.42198767351287, 218, 33, 'PPL', 'P'),
(20718, 'Durden', 30.7916698455811, 0.537416020992443, -83.4736099243164, -1.45688933170474, 218, 13, 'PPL', 'P'),
(20719, 'Durdenville', 32.5363883972168, 0.567867104239114, -82.1936111450195, -1.4345491385845, 218, 13, 'PPL', 'P'),
(160968, 'Durell', 41.7252807617188, 0.72824353061104, -76.3680572509766, -1.33287404238107, 218, 45, 'PPL', 'P'),
(93853, 'Durenville', 31.4938907623291, 0.54967208806607, -98.5758285522461, -1.72047277111813, 218, 51, 'PPL', 'P'),
(20721, 'Duresville', 32.8600006103516, 0.573515202857981, -83.57861328125, -1.45872198600887, 218, 13, 'PPL', 'P'),
(203773, 'Durfee Creek Estates', 41.3847198486328, 0.722299621374092, -111.899719238281, -1.95301853276525, 218, 52, 'PPL', 'P'),
(178120, 'Durfee Crossing', 34.5738906860352, 0.603428227695915, -110.804168701172, -1.9338975687707, 218, 5, 'PPL', 'P'),
(72362, 'Durgan', 39.0080604553223, 0.680819089762372, -82.366943359375, -1.43757435642477, 218, 41, 'PPL', 'P'),
(139128, 'Durgen', 40.0724983215332, 0.699397035210656, -91.6327819824219, -1.5992937483554, 218, 29, 'PPL', 'P'),
(127302, 'Durgintown', 43.8274993896484, 0.76493416726517, -70.8247222900391, -1.2361245957718, 218, 26, 'PPL', 'P'),
(108983, 'Durgon', 38.9930610656738, 0.680557301027217, -79.0458297729492, -1.37960998950893, 218, 58, 'PPL', 'P'),
(171917, 'Durgy Hill Heights', 43.6108283996582, 0.761152545096285, -73.0483322143555, -1.27493391023114, 218, 55, 'PPL', 'P'),
(8632, 'Durham', 35.9494400024414, 0.627436092290761, -93.9802780151367, -1.64026528330378, 218, 4, 'PPL', 'P'),
(20722, 'Durham', 34.8580589294434, 0.608387899172996, -85.432502746582, -1.49107846114696, 218, 13, 'PPL', 'P'),
(32279, 'Durham', 38.4861106872559, 0.671709347779592, -97.227783203125, -1.69694494130977, 218, 20, 'PPL', 'P'),
(54512, 'Durham', 39.9761085510254, 0.697714716350053, -91.6677780151367, -1.59990454435141, 218, 29, 'PPL', 'P'),
(59726, 'Durham', 34.1533317565918, 0.596088089678465, -90.5430603027344, -1.58027451711449, 218, 30, 'PPL', 'P'),
(64314, 'Durham', 35.9938888549805, 0.628211871116301, -78.8988876342773, -1.37704536537918, 218, 33, 'PPL', 'P'),
(75709, 'Durham', 35.8419418334961, 0.6255598953028, -99.9244384765625, -1.74401045462252, 218, 42, 'PPL', 'P'),
(93854, 'Durham', 33.3505592346191, 0.582077066025504, -95.9786071777344, -1.67514270672973, 218, 51, 'PPL', 'P'),
(113184, 'Durham', 41.4816703796387, 0.723991727351701, -72.6816711425781, -1.26853446728974, 218, 8, 'PPL', 'P'),
(115354, 'Durham', 41.3202781677246, 0.721174901866724, -92.9555587768555, -1.62238055868724, 218, 16, 'PPL', 'P'),
(119429, 'Durham', 40.5966682434082, 0.708545526187296, -91.0894393920898, -1.58981063118779, 218, 18, 'PPL', 'P'),
(122529, 'Durham', 41.5922203063965, 0.725921187561463, -86.8375015258789, -1.51560031583219, 218, 19, 'PPL', 'P'),
(143738, 'Durham', 43.1338882446289, 0.752828369056052, -70.9269409179688, -1.23790864738604, 218, 36, 'PPL', 'P'),
(148362, 'Durham', 42.3994407653809, 0.740009842360201, -74.1727828979492, -1.29455927693616, 218, 40, 'PPL', 'P'),
(160978, 'Durham', 40.5755615234375, 0.708177144429511, -75.2236099243164, -1.3128996684152, 218, 45, 'PPL', 'P'),
(173881, 'Durham', 42.8663902282715, 0.748159647928061, -88.070556640625, -1.53712118744306, 218, 57, 'PPL', 'P'),
(181234, 'Durham', 39.6463890075684, 0.691960024708555, -121.798889160156, -2.12579164111636, 218, 6, 'PPL', 'P'),
(186646, 'Durham', 39.0877799987793, 0.682210458273884, -108.598327636719, -1.89539837942029, 218, 7, 'PPL', 'P'),
(196386, 'Durham', 48.5188903808594, 0.846814386560202, -113.116111755371, -1.97424858718509, 218, 31, 'PPL', 'P'),
(200734, 'Durham', 45.4022216796875, 0.792418256030897, -122.751670837402, -2.14242081843698, 218, 43, 'PPL', 'P'),
(207247, 'Durham', 47.3383293151855, 0.82620970894334, -121.889717102051, -2.12737688775523, 218, 56, 'PPL', 'P'),
(209417, 'Durham', 41.2055587768555, 0.719172670780175, -104.595283508301, -1.82553207927677, 218, 59, 'PPL', 'P'),
(15839, 'Durham (historical)', 30.4424991607666, 0.531321842890988, -85.0752792358398, -1.48484373471897, 218, 12, 'PPL', 'P'),
(113186, 'Durham Center', 41.4747200012207, 0.723870420364048, -72.6808319091797, -1.26851981990374, 218, 8, 'PPL', 'P'),
(160969, 'Durham Furnace', 40.5794410705566, 0.708244855300226, -75.1975021362305, -1.31244400155269, 218, 45, 'PPL', 'P'),
(160970, 'Durham Hill Farms', 40.563060760498, 0.707958964957206, -75.228889465332, -1.31299181378892, 218, 45, 'PPL', 'P'),
(86638, 'Durham Subdivision', 36.4105606079102, 0.63548416510498, -88.1233291625977, -1.53804224170607, 218, 50, 'PPL', 'P'),
(20723, 'Durham Town', 33.6616706848145, 0.587506985172067, -83.0325012207031, -1.44919053246748, 218, 13, 'PPL', 'P'),
(35670, 'Durhamtown', 37.3997192382813, 0.652748240029474, -85.4138870239258, -1.49075355549397, 218, 21, 'PPL', 'P'),
(86636, 'Durhamville', 35.6680603027344, 0.6225250900826, -89.4930572509766, -1.56194850670533, 218, 50, 'PPL', 'P'),
(148364, 'Durhamville', 43.1205596923828, 0.752595741934833, -75.67138671875, -1.3207148477921, 218, 40, 'PPL', 'P'),
(181236, 'Duri (historical)', 36.8661117553711, 0.643435032539412, -121.409172058105, -2.11898979453424, 218, 6, 'PPL', 'P'),
(8634, 'Durian (historical)', 34.288890838623, 0.598454041990892, -92.7602767944336, -1.61897224512416, 218, 4, 'PPL', 'P'),
(200735, 'Durkee', 44.582218170166, 0.778106494911839, -117.463607788086, -2.05012670717335, 218, 43, 'PPL', 'P'),
(209418, 'Durkee', 44.1305618286133, 0.770223604664231, -107.912780761719, -1.88343332927479, 218, 59, 'PPL', 'P'),
(148365, 'Durkeetown', 43.2466697692871, 0.754796777996757, -73.5327835083008, -1.28338918037604, 218, 40, 'PPL', 'P'),
(160972, 'Durlach', 40.2313919067383, 0.702170251432782, -76.2300033569336, -1.33046454738482, 218, 45, 'PPL', 'P'),
(148366, 'Durland', 41.2827796936035, 0.720520430028837, -74.3083267211914, -1.29692496293247, 218, 40, 'PPL', 'P'),
(148367, 'Durlandville', 41.3505592346191, 0.72170340618505, -74.3886108398438, -1.29832618514002, 218, 40, 'PPL', 'P'),
(27010, 'Durley', 38.934440612793, 0.679534181115436, -89.3680572509766, -1.55976684514033, 218, 18, 'PPL', 'P'),
(181235, 'Durmid', 33.4308280944824, 0.58347802191694, -115.832221984863, -2.02165365353683, 218, 6, 'PPL', 'P'),
(54513, 'Durnell', 36.9686088562012, 0.645223944422645, -89.8141708374023, -1.56755299606134, 218, 29, 'PPL', 'P'),
(13691, 'Duross Heights', 39.6841697692871, 0.692619423394459, -75.6269378662109, -1.31993906896656, 218, 10, 'PPL', 'P'),
(101568, 'Durrett Town', 37.9830589294434, 0.662929438297819, -78.8083267211914, -1.37546477927222, 218, 53, 'PPL', 'P'),
(148368, 'Durso Corner', 42.336669921875, 0.738914284466769, -74.1286087036133, -1.29378829180058, 218, 40, 'PPL', 'P'),
(139913, 'Durupt', 47.0952796936035, 0.821967692801008, -98.4697189331055, -1.71862080889609, 218, 34, 'PPL', 'P'),
(160973, 'Durward', 41.8263893127441, 0.730008207728354, -78.1377792358398, -1.36376151786186, 218, 45, 'PPL', 'P'),
(173882, 'Durwards Glen', 43.4386100769043, 0.758146768331967, -89.5913925170898, -1.56366478086983, 218, 57, 'PPL', 'P'),
(75710, 'Durwood', 34.1766700744629, 0.596495420167193, -96.9644393920898, -1.69234872474246, 218, 42, 'PPL', 'P'),
(160974, 'Duryea', 41.3438911437988, 0.721587026045414, -75.7388916015625, -1.32189303025835, 218, 45, 'PPL', 'P'),
(40725, 'Dusenbury', 31.3213901519775, 0.546661384453735, -93.1344375610352, -1.62550258243314, 218, 22, 'PPL', 'P'),
(160976, 'Dushore', 41.524169921875, 0.724733484294315, -76.4011077880859, -1.33345088307318, 218, 45, 'PPL', 'P'),
(108984, 'Dusk', 38.8638916015625, 0.678302868585438, -80.7513885498047, -1.40937760575134, 218, 58, 'PPL', 'P'),
(178121, 'Dusk File', 33.348331451416, 0.582038183873589, -111.918060302734, -1.95333864472828, 218, 5, 'PPL', 'P'),
(40726, 'Duson', 30.235559463501, 0.527710063820622, -92.1852798461914, -1.60893665518841, 218, 22, 'PPL', 'P'),
(93855, 'Duster', 32.1047210693359, 0.560333088094307, -98.6763916015625, -1.72222792743455, 218, 51, 'PPL', 'P'),
(75711, 'Dustin', 35.2705612182617, 0.615587422284889, -96.0305633544922, -1.6760495130809, 218, 42, 'PPL', 'P'),
(141693, 'Dustin', 42.8269386291504, 0.747471087628221, -99.0697174072266, -1.72909275777644, 218, 35, 'PPL', 'P'),
(86637, 'Dustin (historical)', 35.0999984741211, 0.612610540818399, -87.3000030517578, -1.52367249025427, 218, 50, 'PPL', 'P'),
(181237, 'Dustin Acres', 35.2194404602051, 0.614695196740686, -119.389717102051, -2.08374365645537, 218, 6, 'PPL', 'P'),
(188453, 'Dusty', 33.6269416809082, 0.586900849707965, -107.655281066895, -1.87893911177722, 218, 38, 'PPL', 'P'),
(207248, 'Dusty', 46.8102798461914, 0.816993507095985, -117.650833129883, -2.05339440583088, 218, 56, 'PPL', 'P'),
(188454, 'Dusty (historical)', 33.6122207641602, 0.586643921241799, -107.651107788086, -1.87886627432141, 218, 38, 'PPL', 'P'),
(80778, 'Dusty Bend', 34.2708282470703, 0.598138790296854, -80.6097183227539, -1.40690499383726, 218, 48, 'PPL', 'P'),
(203774, 'Dusty Downs Estates', 40.5513916015625, 0.707755299712842, -111.92749786377, -1.9535033612417, 218, 52, 'PPL', 'P'),
(108985, 'Dutch', 38.8050003051758, 0.677275021562722, -80.6183319091797, -1.40705532928079, 218, 58, 'PPL', 'P'),
(13692, 'Dutch Acres', 38.750560760498, 0.676324872264809, -75.1797180175781, -1.31213361012764, 218, 10, 'PPL', 'P'),
(155050, 'Dutch Alley', 41.4880599975586, 0.724103247222348, -81.6363906860352, -1.42482380691575, 218, 41, 'PPL', 'P'),
(40727, 'Dutch Bayou', 30.0599994659424, 0.524645963828432, -90.5752792358398, -1.58083684357866, 218, 22, 'PPL', 'P'),
(160979, 'Dutch Corner', 40.0897216796875, 0.699697639518698, -78.4280624389648, -1.36882791551963, 218, 45, 'PPL', 'P'),
(155051, 'Dutch Corners', 40.5111083984375, 0.707052225185061, -81.0377807617188, -1.41437609280131, 218, 41, 'PPL', 'P'),
(173883, 'Dutch Corners', 45.2355613708496, 0.789509484909285, -89.5491714477539, -1.5629278841962, 218, 57, 'PPL', 'P'),
(190138, 'Dutch Creek (historical)', 38.6347198486328, 0.674303066944248, -118.753326416016, -2.07263654365503, 218, 39, 'PPL', 'P'),
(181238, 'Dutch Flat', 39.2061080932617, 0.684275673120213, -120.836669921875, -2.10899774728232, 218, 6, 'PPL', 'P'),
(148369, 'Dutch Flats', 42.7722206115723, 0.746516078061319, -78.2636108398438, -1.3659576936548, 218, 40, 'PPL', 'P'),
(80785, 'Dutch Fork', 34.7605590820313, 0.606686205815463, -83.0477828979492, -1.44945724805065, 218, 48, 'PPL', 'P'),
(101569, 'Dutch Gap', 37.3597183227539, 0.652050092349709, -77.4155578613281, -1.35115637694836, 218, 53, 'PPL', 'P'),
(211799, 'Dutch Harbor', 53.9027786254883, 0.940780962988394, -166.511108398438, -2.90616708269792, 218, 1, 'PPL', 'P'),
(160982, 'Dutch Hill', 41.2377815246582, 0.719735063823373, -80.3969421386719, -1.4031913488552, 218, 45, 'PPL', 'P'),
(196387, 'Dutch Hill (historical)', 46.3166694641113, 0.80837838070666, -114.191673278809, -1.99302067707684, 218, 31, 'PPL', 'P'),
(27011, 'Dutch Hollow', 38.5675010681152, 0.673129877905041, -90.0308303833008, -1.57133441849315, 218, 18, 'PPL', 'P'),
(148371, 'Dutch Hollow', 41.2483291625977, 0.719919154833725, -74.2738876342773, -1.29632388747444, 218, 40, 'PPL', 'P'),
(32282, 'Dutch Hollow (historical)', 37.3161087036133, 0.651288960910165, -94.779167175293, -1.654208529507, 218, 20, 'PPL', 'P'),
(203775, 'Dutch John', 40.9291687011719, 0.71434875393966, -109.390281677246, -1.90922058495197, 218, 52, 'PPL', 'P'),
(8636, 'Dutch Mills', 35.875560760498, 0.626146656269972, -94.4913864135742, -1.64918580769111, 218, 4, 'PPL', 'P'),
(27012, 'Dutch Mills', 37.4152793884277, 0.653019815881634, -89.2727813720703, -1.55810396735569, 218, 18, 'PPL', 'P'),
(145109, 'Dutch Neck', 40.2822189331055, 0.703057350391888, -74.6141662597656, -1.30226286986337, 218, 37, 'PPL', 'P'),
(13693, 'Dutch Neck Crossroads', 39.2861099243164, 0.685671968479742, -75.51611328125, -1.31800481506683, 218, 10, 'PPL', 'P'),
(13694, 'Dutch Neck Farms', 39.5294418334961, 0.689918911470091, -75.6324996948242, -1.32003614118829, 218, 10, 'PPL', 'P'),
(155052, 'Dutch Ridge', 41.6425018310547, 0.726798765719672, -83.9550018310547, -1.46529120546977, 218, 41, 'PPL', 'P'),
(148373, 'Dutch Settlement', 43.3244400024414, 0.756154124625343, -76.0777816772461, -1.32780777788136, 218, 40, 'PPL', 'P'),
(207249, 'Dutch Settlement', 47.2538909912109, 0.824735982175118, -120.456672668457, -2.10236554406164, 218, 56, 'PPL', 'P'),
(80779, 'Dutch Square', 34.0269393920898, 0.593882126768526, -81.0838928222656, -1.41518090008273, 218, 48, 'PPL', 'P'),
(40728, 'Dutch Town', 30.2541694641113, 0.528034869605071, -90.9886093139648, -1.58805081433947, 218, 22, 'PPL', 'P'),
(177211, 'Dutch Town', 40.2677803039551, 0.702805348773739, -80.6127777099609, -1.40695839021711, 218, 58, 'PPL', 'P'),
(86639, 'Dutch Valley', 36.1144409179688, 0.630315901535518, -84.208610534668, -1.46971751235954, 218, 50, 'PPL', 'P'),
(80780, 'Dutch Village', 34.1152801513672, 0.595423963881627, -81.1611099243164, -1.41652859275237, 218, 48, 'PPL', 'P'),
(181239, 'Dutch Village', 33.5966682434082, 0.586372478547693, -117.10888671875, -2.04393565658725, 218, 6, 'PPL', 'P'),
(80781, 'Dutchbrook', 34.0330581665039, 0.593988919528238, -81.0988922119141, -1.41544268881789, 218, 48, 'PPL', 'P'),
(148374, 'Dutcherville', 43.288890838623, 0.755533674670381, -75.9574966430664, -1.32570840799405, 218, 40, 'PPL', 'P'),
(148376, 'Dutchess Junction', 41.4744415283203, 0.723865560095059, -73.9791717529297, -1.29118012498701, 218, 40, 'PPL', 'P'),
(80782, 'Dutchman', 34.7413902282715, 0.606351646203522, -81.8433303833008, -1.42843558598611, 218, 48, 'PPL', 'P'),
(108986, 'Dutchman', 39.0605583190918, 0.681735350335414, -81.165283203125, -1.41660143020818, 218, 58, 'PPL', 'P'),
(80783, 'Dutchman Acres', 33.9236106872559, 0.592078700657351, -81.1458282470703, -1.4162618771692, 218, 48, 'PPL', 'P'),
(80784, 'Dutchman Creek', 34.4230613708496, 0.600795759537399, -80.8850021362305, -1.41170960275987, 218, 48, 'PPL', 'P'),
(80786, 'Dutchman Shores', 34.124439239502, 0.595583820126059, -81.3463897705078, -1.419762336106, 218, 48, 'PPL', 'P'),
(46738, 'Dutchmans Cove', 38.1644401550293, 0.666095137885596, -76.4300003051758, -1.33395515262559, 218, 25, 'PPL', 'P'),
(54514, 'Dutchtown', 37.2527809143066, 0.650183682478754, -89.6597213745117, -1.56485734440597, 218, 29, 'PPL', 'P'),
(78159, 'Dutchtown', 39.8969383239746, 0.696332935218465, -77.9230575561523, -1.3600139175759, 218, 45, 'PPL', 'P'),
(115357, 'Dutchtown', 42.5522193908691, 0.742676332401642, -91.4108276367188, -1.59541991423377, 218, 16, 'PPL', 'P'),
(145110, 'Dutchtown', 40.4477806091309, 0.705946946753651, -74.6902770996094, -1.3035912546151, 218, 37, 'PPL', 'P'),
(148377, 'Dutchtown', 42.6197204589844, 0.743854448288866, -78.4830627441406, -1.36978785193455, 218, 40, 'PPL', 'P'),
(155053, 'Dutchtown', 40.6166687011719, 0.708894600027178, -81.3680572509766, -1.42014050498079, 218, 41, 'PPL', 'P'),
(160983, 'Dutotsburg (historical)', 40.9883308410645, 0.715381328073311, -75.1399993896484, -1.31144038929589, 218, 45, 'PPL', 'P'),
(2141, 'Dutton', 34.6108283996582, 0.604072912416796, -85.9169387817383, -1.49953346497574, 218, 2, 'PPL', 'P'),
(8641, 'Dutton', 35.8166694641113, 0.625118809247256, -93.6936111450195, -1.63526200256385, 218, 4, 'PPL', 'P'),
(75713, 'Dutton', 35.2038917541504, 0.614423820625607, -98.0941696166992, -1.71206623682119, 218, 42, 'PPL', 'P'),
(101571, 'Dutton', 37.4977798461914, 0.654459720504013, -76.4577789306641, -1.33443998110204, 218, 53, 'PPL', 'P'),
(130562, 'Dutton', 42.8411102294922, 0.747718428714462, -85.5849990844727, -1.49374002434038, 218, 27, 'PPL', 'P'),
(181240, 'Dutton', 38.0761108398438, 0.664553500509577, -121.882217407227, -2.12724599338765, 218, 6, 'PPL', 'P'),
(196389, 'Dutton', 47.8427810668945, 0.835014052928115, -111.710830688477, -1.94972180565184, 218, 31, 'PPL', 'P'),
(27013, 'Dutton (historical)', 39.6744384765625, 0.692449580295939, -90.7997207641602, -1.58475408722606, 218, 18, 'PPL', 'P'),
(101570, 'Dutton (historical)', 37.5322189331055, 0.655060795962044, -76.6291732788086, -1.33743137679647, 218, 53, 'PPL', 'P'),
(199929, 'Dutton (historical)', 41.1894416809082, 0.718891374390036, -116.737777709961, -2.03745858250006, 218, 39, 'PPL', 'P'),
(78158, 'Dutton Mill', 39.9811096191406, 0.69780200145478, -75.5127792358398, -1.31794662499701, 218, 45, 'PPL', 'P'),
(15840, 'Dutton Still', 28.4811096191406, 0.497089137475432, -82.1505584716797, -1.43379772768293, 218, 12, 'PPL', 'P'),
(145111, 'Duttonville', 41.351390838623, 0.721717920412991, -74.686393737793, -1.30352347716536, 218, 37, 'PPL', 'P'),
(97, 'Duty', 37.0813903808594, 0.64719235336335, -82.1519393920898, -1.4338218292908, 218, 53, 'PPL', 'P'),
(40729, 'Duty', 31.9150009155273, 0.557021846752957, -91.9238891601563, -1.60437452708305, 218, 22, 'PPL', 'P'),
(54515, 'Dutzow', 38.6055603027344, 0.673794136859934, -90.9944381713867, -1.58815254709311, 218, 29, 'PPL', 'P'),
(15841, 'Duval', 30.4847202301025, 0.532058739564613, -81.621940612793, -1.42457160556052, 218, 12, 'PPL', 'P'),
(35671, 'Duval', 38.2463912963867, 0.667525455128051, -84.6413879394531, -1.47727090300128, 218, 21, 'PPL', 'P'),
(178122, 'Duval', 31.9316692352295, 0.557312763812534, -110.957496643066, -1.93657364619206, 218, 5, 'PPL', 'P'),
(2143, 'Duvall', 31.2761096954346, 0.545871091400254, -86.241943359375, -1.50520586493955, 218, 2, 'PPL', 'P'),
(8639, 'Duvall', 35.2083282470703, 0.614501252034301, -90.5599975585938, -1.58057012799549, 218, 4, 'PPL', 'P'),
(27014, 'Duvall', 39.4791717529297, 0.689041533048964, -88.790283203125, -1.54968278567275, 218, 18, 'PPL', 'P'),
(72365, 'Duvall', 39.7719383239746, 0.694151273653472, -82.9577789306641, -1.44788638248167, 218, 41, 'PPL', 'P'),
(173884, 'Duvall', 44.6611099243164, 0.779483415774437, -87.7133331298828, -1.53088646101508, 218, 57, 'PPL', 'P'),
(207250, 'Duvall', 47.7425003051758, 0.833263823459715, -121.984443664551, -2.12903017815995, 218, 56, 'PPL', 'P'),
(46739, 'Duvall Manor', 39.2666702270508, 0.685332681756865, -77.2033309936523, -1.34745231934622, 218, 25, 'PPL', 'P'),
(173885, 'Duveneck', 44.0169410705566, 0.768240548337531, -87.711669921875, -1.5308574325592, 218, 57, 'PPL', 'P'),
(40730, 'Duvic', 29.3133296966553, 0.511614117929265, -89.3852767944336, -1.56006738286935, 218, 22, 'PPL', 'P'),
(124672, 'Duxbury', 42.0416717529297, 0.733765595131319, -70.6727828979492, -1.23347275311635, 218, 23, 'PPL', 'P'),
(135086, 'Duxbury', 46.1277809143066, 0.805081653593251, -92.5086135864258, -1.61457989353829, 218, 28, 'PPL', 'P'),
(170191, 'Duxbury', 45.2411117553711, 0.789606357393937, -98.4947204589844, -1.7190571678407, 218, 49, 'PPL', 'P'),
(171918, 'Duxbury', 44.3269386291504, 0.773651026408136, -72.753059387207, -1.26978042720573, 218, 55, 'PPL', 'P'),
(148378, 'Dwaarkill', 41.648609161377, 0.726905358742302, -74.2641677856445, -1.296154244113, 218, 40, 'PPL', 'P'),
(35672, 'Dwale', 37.6230583190918, 0.656646242337995, -82.7238922119141, -1.4438042891628, 218, 21, 'PPL', 'P'),
(101572, 'Dwale', 37.1911087036133, 0.649107299345172, -82.4055633544922, -1.43824840249667, 218, 53, 'PPL', 'P'),
(530, 'Dwarf', 37.3349990844727, 0.651618660253116, -83.1313934326172, -1.45091652716996, 218, 21, 'PPL', 'P'),
(148380, 'Dwelly Corners', 42.7700004577637, 0.746477329067458, -74.3369369506836, -1.29742430563686, 218, 40, 'PPL', 'P'),
(122530, 'Dwenger Field', 41.0794410705566, 0.716971501560198, -85.1063919067383, -1.48538675326524, 218, 19, 'PPL', 'P'),
(59728, 'Dwiggins', 33.8455581665039, 0.590716427180748, -90.5813903808594, -1.58094350318032, 218, 30, 'PPL', 'P'),
(2144, 'Dwight', 31.1516704559326, 0.543699216952267, -88.2586135864258, -1.54040340032853, 218, 2, 'PPL', 'P'),
(32283, 'Dwight', 38.8444404602051, 0.67796338212548, -96.5930633544922, -1.68586699012337, 218, 20, 'PPL', 'P'),
(72366, 'Dwight', 39.8111114501953, 0.694834973684323, -80.9311065673828, -1.41251427688324, 218, 41, 'PPL', 'P'),
(101574, 'Dwight', 36.8530616760254, 0.643207265687183, -76.8125, -1.34063103168814, 218, 53, 'PPL', 'P'),
(119431, 'Dwight', 41.0944404602051, 0.717233290295352, -88.4250030517578, -1.54330744433921, 218, 18, 'PPL', 'P'),
(124674, 'Dwight', 42.3277816772461, 0.738759155333272, -72.4499969482422, -1.26449098980667, 218, 23, 'PPL', 'P'),
(139914, 'Dwight', 46.3041687011719, 0.808160201234356, -96.7377777099609, -1.6883927321012, 218, 34, 'PPL', 'P'),
(141695, 'Dwight', 41.083610534668, 0.717044272436984, -97.0197219848633, -1.69331358800539, 218, 35, 'PPL', 'P'),
(8640, 'Dwight (historical)', 33.9216690063477, 0.59204481193248, -92.2102813720703, -1.60937301413302, 218, 4, 'PPL', 'P'),
(80787, 'Dwight Crossroads', 34.7441711425781, 0.606400182314389, -80.626106262207, -1.40719101733833, 218, 48, 'PPL', 'P'),
(40731, 'Dwight Fields', 29.8547191619873, 0.521063146634921, -91.0511093139648, -1.58914164512196, 218, 22, 'PPL', 'P'),
(101575, 'Dwight Hills', 37.3424987792969, 0.651749554620694, -79.9705581665039, -1.39574954466313, 218, 53, 'PPL', 'P'),
(75714, 'Dwight Mission', 35.5475006103516, 0.620420926505329, -94.8516693115234, -1.65547393049895, 218, 42, 'PPL', 'P'),
(101576, 'Dwina', 36.9077796936035, 0.644162275254085, -82.3672180175781, -1.43757915011474, 218, 53, 'PPL', 'P'),
(59727, 'Dwyer', 33.5641708374023, 0.585805291814533, -90.5286102294922, -1.58002231575926, 218, 30, 'PPL', 'P'),
(72367, 'Dwyer', 39.6791687011719, 0.692532138289731, -84.2122192382813, -1.46978049611932, 218, 41, 'PPL', 'P'),
(188455, 'Dwyer', 32.6283302307129, 0.569471791953941, -107.866386413574, -1.88262359514535, 218, 38, 'PPL', 'P'),
(209419, 'Dwyer', 42.2422218322754, 0.737265854331037, -104.955558776855, -1.83182006892656, 218, 59, 'PPL', 'P'),
(209420, 'Dwyer Junction', 42.2347183227539, 0.737134893384433, -104.994438171387, -1.83249864237231, 218, 59, 'PPL', 'P'),
(196319, 'DY Junction', 47.7955589294434, 0.834189871149763, -108.632781982422, -1.89599972119443, 218, 31, 'PPL', 'P'),
(15843, 'Dyal', 30.6211109161377, 0.53443920610498, -81.8702774047852, -1.42890590023462, 218, 12, 'PPL', 'P'),
(2145, 'Dyas', 30.9622192382813, 0.540392669432339, -87.6761093139648, -1.53023678286715, 218, 2, 'PPL', 'P'),
(20725, 'Dyas', 32.8661117553711, 0.573621862459639, -83.9944381713867, -1.4659794994535, 218, 13, 'PPL', 'P'),
(160984, 'Dyberry', 41.6363906860352, 0.726692106118014, -75.2594375610352, -1.31352497863915, 218, 45, 'PPL', 'P'),
(173886, 'Dyckesville', 44.6433296203613, 0.779173090928415, -87.7611083984375, -1.53172029675238, 218, 57, 'PPL', 'P'),
(35673, 'Dycusburg', 37.1594390869141, 0.648554560260926, -88.184440612793, -1.53910883772264, 218, 21, 'PPL', 'P'),
(54517, 'Dye', 39.4850006103516, 0.689143265802605, -94.9286117553711, -1.65681682947862, 218, 29, 'PPL', 'P'),
(93857, 'Dye', 33.6205596923828, 0.586789462995372, -97.6122207641602, -1.70365464251817, 218, 51, 'PPL', 'P'),
(101577, 'Dye', 37.0705604553223, 0.647003335504982, -81.9250030517578, -1.42986104295958, 218, 53, 'PPL', 'P'),
(8642, 'Dyer', 35.4922218322754, 0.61945612982142, -94.1374969482422, -1.64300927133294, 218, 4, 'PPL', 'P'),
(35674, 'Dyer', 37.7061080932617, 0.658095734340298, -86.2213897705078, -1.50484713714072, 218, 21, 'PPL', 'P'),
(86640, 'Dyer', 36.0666694641113, 0.629482132377241, -88.9938888549805, -1.5532363746733, 218, 50, 'PPL', 'P'),
(108988, 'Dyer', 38.3811111450195, 0.669876760054482, -80.4749984741211, -1.40455368891083, 218, 58, 'PPL', 'P'),
(122531, 'Dyer', 41.4941711425781, 0.724209906824006, -87.5216674804688, -1.52754126436983, 218, 19, 'PPL', 'P'),
(141696, 'Dyer', 42.8033294677734, 0.747059030028559, -99.4980621337891, -1.73656878358851, 218, 35, 'PPL', 'P'),
(181241, 'Dyer', 33.7099990844727, 0.588350474868322, -117.853607177734, -2.05693348060349, 218, 6, 'PPL', 'P'),
(190139, 'Dyer', 37.6783294677734, 0.657610905863849, -118.083610534668, -2.06094779647262, 218, 39, 'PPL', 'P'),
(207252, 'Dyer', 47.9780616760254, 0.837375144971552, -119.770278930664, -2.09038571337208, 218, 56, 'PPL', 'P'),
(127304, 'Dyer Brook', 46.0813903808594, 0.80427198604284, -68.1838912963867, -1.19003339994385, 218, 26, 'PPL', 'P'),
(127305, 'Dyer Corner', 43.8738899230957, 0.765743834815582, -69.9480590820313, -1.22082393636097, 218, 26, 'PPL', 'P'),
(127306, 'Dyer Cove', 43.8211097717285, 0.764822647394523, -69.9211120605469, -1.22035362211246, 218, 26, 'PPL', 'P'),
(193511, 'Dyer Place (historical)', 41.3286094665527, 0.721320310462243, -123.616668701172, -2.15751787918247, 218, 6, 'PPL', 'P'),
(2146, 'Dyers Crossroads', 34.2491683959961, 0.597760754580117, -86.820556640625, -1.51530457179313, 218, 2, 'PPL', 'P'),
(80788, 'Dyers Hill', 34.5827789306641, 0.603583356829412, -79.7611083984375, -1.39209395659284, 218, 48, 'PPL', 'P'),
(86642, 'Dyersburg', 36.0344390869141, 0.62891960617599, -89.3855590820313, -1.56007230971737, 218, 50, 'PPL', 'P'),
(93858, 'Dyersdale', 29.8913898468018, 0.521703170823894, -95.2574996948242, -1.66255700689218, 218, 51, 'PPL', 'P'),
(160986, 'Dyerstown', 40.3408317565918, 0.704080337145615, -75.1252822875977, -1.31118352740876, 218, 45, 'PPL', 'P'),
(115358, 'Dyersville', 42.4844398498535, 0.741493356245429, -91.1227798461914, -1.59039253188597, 218, 16, 'PPL', 'P'),
(186647, 'Dyersville', 39.4205589294434, 0.688018546295238, -105.983329772949, -1.8497580567649, 218, 7, 'PPL', 'P'),
(127308, 'Dyerville', 45.6413917541504, 0.796592561302515, -70.3069381713867, -1.22708755808678, 218, 26, 'PPL', 'P'),
(169352, 'Dyerville', 41.8258285522461, 0.729998420611347, -71.458610534668, -1.24718803273026, 218, 47, 'PPL', 'P'),
(20726, 'Dyes Crossroad', 33.2105598449707, 0.579633615725356, -82.146110534668, -1.43372009653716, 218, 13, 'PPL', 'P'),
(8645, 'Dyess', 35.5897216796875, 0.621157823178954, -90.2133331298828, -1.57451969231494, 218, 4, 'PPL', 'P'),
(72368, 'Dyesville', 39.128059387207, 0.682913466222637, -82.2300033569336, -1.43518430250448, 218, 41, 'PPL', 'P'),
(20727, 'Dyke', 34.5997200012207, 0.603879034289438, -84.4116668701172, -1.47326151398016, 218, 13, 'PPL', 'P'),
(101578, 'Dyke', 38.2536087036133, 0.667651422647611, -78.5400009155273, -1.37078161049531, 218, 53, 'PPL', 'P'),
(148379, 'Dyke', 42.223331451416, 0.736936154988086, -77.024169921875, -1.3443253687523, 218, 40, 'PPL', 'P'),
(186648, 'Dyke', 37.226390838623, 0.649723088768225, -107.194717407227, -1.87090075950098, 218, 7, 'PPL', 'P'),
(199930, 'Dyke', 41.5747184753418, 0.725615722984431, -118.571388244629, -2.06946112352927, 218, 39, 'PPL', 'P'),
(160987, 'Dykeman Spring', 40.0419387817383, 0.69886367062334, -77.5155563354492, -1.35290167956874, 218, 45, 'PPL', 'P'),
(148381, 'Dykemans', 41.4341697692871, 0.723162685304359, -73.6188888549805, -1.28489200217917, 218, 40, 'PPL', 'P'),
(148382, 'Dyker Heights', 40.6213912963867, 0.708977024862916, -74.0100021362305, -1.29171821668526, 218, 40, 'PPL', 'P'),
(27015, 'Dykersburg', 37.6922187805176, 0.657853320102074, -88.7397232055664, -1.54880034724555, 218, 18, 'PPL', 'P'),
(35675, 'Dykes', 37.0680618286133, 0.646959726242132, -84.4358291625977, -1.47368322553878, 218, 21, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(54518, 'Dykes', 37.333610534668, 0.651594425487197, -92.1155624389648, -1.60771985688635, 218, 29, 'PPL', 'P'),
(86643, 'Dykes', 36.3652801513672, 0.634693872051499, -83.8327789306641, -1.46315801343662, 218, 50, 'PPL', 'P'),
(20728, 'Dykes (historical)', 34.2388916015625, 0.5975813906807, -85.0872192382813, -1.48505212707427, 218, 13, 'PPL', 'P'),
(59729, 'Dykes Crossing', 31.0977802276611, 0.542758655034279, -90.2852783203125, -1.57577537276891, 218, 30, 'PPL', 'P'),
(2147, 'Dykes Crossroad', 31.6000003814697, 0.551524050288111, -85.5611114501953, -1.49332310647173, 218, 2, 'PPL', 'P'),
(86644, 'Dykes Crossroads', 35.9961090087891, 0.628250620110162, -85.0788879394531, -1.48490671847875, 218, 50, 'PPL', 'P'),
(86646, 'Dykes Mill', 36.438060760498, 0.63596413331244, -82.7030563354492, -1.44344063451594, 218, 50, 'PPL', 'P'),
(40732, 'Dykesville', 32.9152793884277, 0.57447999954189, -93.2336120605469, -1.62723350398364, 218, 22, 'PPL', 'P'),
(86645, 'Dyllis', 35.9636116027832, 0.627683433377002, -84.4191665649414, -1.47339240834774, 218, 50, 'PPL', 'P'),
(207253, 'Dynamite', 47.4961090087891, 0.828963484089509, -117.449996948242, -2.04988915320412, 218, 56, 'PPL', 'P'),
(15844, 'Dynamite Docks', 25.2749996185303, 0.441131961783664, -80.2930603027344, -1.40137826878507, 218, 12, 'PPL', 'P'),
(46740, 'Dynard', 38.309440612793, 0.668625873290471, -76.7391662597656, -1.33935111646825, 218, 25, 'PPL', 'P'),
(115359, 'Dysart', 42.1716690063477, 0.736034475222012, -92.3061065673828, -1.61104547929759, 218, 16, 'PPL', 'P'),
(160992, 'Dysart', 40.5966682434082, 0.708545526187296, -78.517219543457, -1.37038400054456, 218, 45, 'PPL', 'P'),
(178123, 'Dysart (historical)', 33.6144409179688, 0.58668267023566, -112.324440002441, -1.96043130850143, 218, 5, 'PPL', 'P'),
(64320, 'Dysartsville', 35.6002807617188, 0.621342113926387, -81.8691711425781, -1.42888659231672, 218, 33, 'PPL', 'P'),
(160988, 'Dysertown', 40.4441719055176, 0.705883962993871, -78.5938873291016, -1.37172210583427, 218, 45, 'PPL', 'P'),
(148383, 'Dysinger', 43.1338882446289, 0.752828369056052, -78.5744400024414, -1.37138268595334, 218, 40, 'PPL', 'P'),
(80789, 'Dyson', 34.1616706848145, 0.596233631432038, -81.932502746582, -1.42999193732715, 218, 48, 'PPL', 'P'),
(20731, 'Dyson (historical)', 33.9630584716797, 0.592767194378164, -82.695556640625, -1.44330974014837, 218, 13, 'PPL', 'P'),
(40733, 'Dyson (historical)', 30.996940612793, 0.540998671738386, -90.2463912963867, -1.5750966661651, 218, 22, 'PPL', 'P'),
(188456, 'E Davis Place', 34.9130592346191, 0.609347835587916, -106.08943939209, -1.85161001898694, 218, 38, 'PPL', 'P'),
(93859, 'E Lopez Colonia', 26.3090000152588, 0.459178673173504, -98.6380004882813, -1.72155787610428, 218, 51, 'PPL', 'P'),
(86647, 'Eads', 35.2044410705566, 0.614433408005531, -89.649169921875, -1.56467318681659, 218, 50, 'PPL', 'P'),
(186649, 'Eads', 38.4805603027344, 0.671612475294941, -102.781387329102, -1.7938736186604, 218, 7, 'PPL', 'P'),
(181242, 'Eads (historical)', 34.9463882446289, 0.609929536549016, -117.277778625488, -2.0468833764398, 218, 6, 'PPL', 'P'),
(108990, 'Eads Mill', 37.4797210693359, 0.654144535389002, -81.0741729736328, -1.41501125672129, 218, 58, 'PPL', 'P'),
(35676, 'Eadsville', 36.8880615234375, 0.64381812826222, -84.8888931274414, -1.48159068344744, 218, 21, 'PPL', 'P'),
(173887, 'Eadsville', 45.0097198486328, 0.785567806758886, -90.8611068725586, -1.5858254769326, 218, 57, 'PPL', 'P'),
(209421, 'Eadsville (historical)', 42.7319412231445, 0.745813070112565, -106.353332519531, -1.85621582293418, 218, 59, 'PPL', 'P'),
(2148, 'Eady City', 32.8280601501465, 0.5729577366628, -85.1750030517578, -1.48658424364939, 218, 2, 'PPL', 'P'),
(80790, 'Eadytown', 33.4122200012207, 0.583153249422005, -80.147216796875, -1.39883281941517, 218, 48, 'PPL', 'P'),
(86648, 'Eagan', 36.5519409179688, 0.637951717012993, -83.976936340332, -1.46567403487647, 218, 50, 'PPL', 'P'),
(135087, 'Eagan', 44.8041687011719, 0.781980262454441, -93.1666717529297, -1.62606517521342, 218, 28, 'PPL', 'P'),
(178124, 'Eagar', 34.1111106872559, 0.595351193004841, -109.290832519531, -1.90748486971151, 218, 5, 'PPL', 'P'),
(27016, 'Eagerville', 39.1116714477539, 0.682627442721563, -89.7838897705078, -1.56702449174302, 218, 18, 'PPL', 'P'),
(2149, 'Eagle', 34.146671295166, 0.595971842696883, -87.1822204589844, -1.52161679620884, 218, 2, 'PPL', 'P'),
(27017, 'Eagle', 37.6511116027832, 0.657135864504406, -88.3927764892578, -1.54274498471698, 218, 18, 'PPL', 'P'),
(70763, 'Eagle', 39.767219543457, 0.694068915396761, -74.5680618286133, -1.30145819574001, 218, 37, 'PPL', 'P'),
(108989, 'Eagle', 38.1583290100098, 0.665988478283939, -81.3047180175781, -1.4190350268123, 218, 58, 'PPL', 'P'),
(130564, 'Eagle', 42.8077812194824, 0.747136727753362, -84.7886123657227, -1.47984045397904, 218, 27, 'PPL', 'P'),
(141697, 'Eagle', 40.8166694641113, 0.712385271846972, -96.4300003051758, -1.68302100302445, 218, 35, 'PPL', 'P'),
(148384, 'Eagle', 42.5486106872559, 0.742613348641862, -78.2983322143555, -1.36656369596085, 218, 40, 'PPL', 'P'),
(160989, 'Eagle', 40.0777816772461, 0.6994892471634, -75.6880569458008, -1.32100579814119, 218, 45, 'PPL', 'P'),
(170187, 'Eagle', 43.5719413757324, 0.760473838492479, -99.0905609130859, -1.72945654558135, 218, 49, 'PPL', 'P'),
(173888, 'Eagle', 42.8794403076172, 0.74838741478029, -88.4741668701172, -1.54416551484243, 218, 57, 'PPL', 'P'),
(186650, 'Eagle', 39.6552810668945, 0.692115220421079, -106.828056335449, -1.86450131655958, 218, 7, 'PPL', 'P'),
(194863, 'Eagle', 47.6436080932617, 0.831537828757235, -115.916938781738, -2.02313224057404, 218, 17, 'PPL', 'P'),
(211800, 'Eagle', 64.7880630493164, 1.13076501620025, -141.199996948242, -2.46440485055277, 218, 1, 'PPL', 'P'),
(101579, 'Eagle (historical)', 36.8363914489746, 0.642916315338092, -81.0455627441406, -1.4145119140169, 218, 53, 'PPL', 'P'),
(196390, 'Eagle (historical)', 45.125560760498, 0.787589612079447, -109.162498474121, -1.9052450180767, 218, 31, 'PPL', 'P'),
(93860, 'Eagle Acres', 32.9858283996582, 0.575711312071888, -97.5186080932617, -1.70202079318941, 218, 51, 'PPL', 'P'),
(148385, 'Eagle Bay', 43.7694396972656, 0.763920834470395, -74.8172225952148, -1.305806871484, 218, 40, 'PPL', 'P'),
(59730, 'Eagle Bend', 32.5202789306641, 0.567585941007029, -91.0066680908203, -1.58836599945448, 218, 30, 'PPL', 'P'),
(135089, 'Eagle Bend', 46.1650009155273, 0.805731265162149, -95.0388870239258, -1.65874149599842, 218, 28, 'PPL', 'P'),
(181243, 'Eagle Bird (historical)', 39.3466682434082, 0.686728910537367, -120.695556640625, -2.10653485590621, 218, 6, 'PPL', 'P'),
(148386, 'Eagle Bridge', 42.9500007629395, 0.74961892704737, -73.3966674804688, -1.28101350752563, 218, 40, 'PPL', 'P'),
(202078, 'Eagle Butte', 45.002498626709, 0.785441772660298, -101.233062744141, -1.76685025676326, 218, 49, 'PPL', 'P'),
(115360, 'Eagle Center', 42.3408317565918, 0.738986922185501, -92.3572235107422, -1.61193763826277, 218, 16, 'PPL', 'P'),
(72369, 'Eagle City', 39.9769401550293, 0.697729230577994, -83.834716796875, -1.46319183558246, 218, 41, 'PPL', 'P'),
(75715, 'Eagle City', 35.9330596923828, 0.627150201947741, -98.5913925170898, -1.72074441354932, 218, 42, 'PPL', 'P'),
(115361, 'Eagle City', 42.4716682434082, 0.74127044966219, -93.1449966430664, -1.62568687318057, 218, 16, 'PPL', 'P'),
(20732, 'Eagle Cliff', 34.9283294677734, 0.609614351434005, -85.352783203125, -1.48968709263544, 218, 13, 'PPL', 'P'),
(155054, 'Eagle Cliff', 41.4983291625977, 0.72428247796371, -81.959716796875, -1.43046691210757, 218, 41, 'PPL', 'P'),
(207254, 'Eagle Cliff', 46.1711082458496, 0.805837858184779, -123.233062744141, -2.15082269220201, 218, 56, 'PPL', 'P'),
(8651, 'Eagle Corner', 36.3016700744629, 0.633583666772073, -94.3675003051758, -1.64702358720207, 218, 4, 'PPL', 'P'),
(20733, 'Eagle Court', 32.4080581665039, 0.56562731918333, -81.7797164916992, -1.42732531412766, 218, 13, 'PPL', 'P'),
(2152, 'Eagle Creek', 32.939998626709, 0.574911431638482, -85.7505569458008, -1.49662955412312, 218, 2, 'PPL', 'P'),
(86649, 'Eagle Creek', 35.913330078125, 0.626805855218794, -87.9872207641602, -1.53566670201372, 218, 50, 'PPL', 'P'),
(200736, 'Eagle Creek', 45.3574981689453, 0.791637683515395, -122.357780456543, -2.13554613439905, 218, 43, 'PPL', 'P'),
(86650, 'Eagle Creek (historical)', 36.4972190856934, 0.636996640867064, -85.2361068725586, -1.48765070650791, 218, 50, 'PPL', 'P'),
(196391, 'Eagle Creek Colony', 48.6980590820313, 0.849941470312173, -111.209716796875, -1.94097571831591, 218, 31, 'PPL', 'P'),
(80791, 'Eagle Crest', 33.5625, 0.585776130200597, -79.0430603027344, -1.37956165313514, 218, 48, 'PPL', 'P'),
(46741, 'Eagle Estates', 39.5800018310547, 0.690801349897289, -76.2802810668945, -1.331342058964, 218, 25, 'PPL', 'P'),
(191403, 'Eagle Flat', 31.1097202301025, 0.542967047389577, -105.132217407227, -1.8349033436786, 218, 51, 'PPL', 'P'),
(93861, 'Eagle Ford', 32.7847213745117, 0.57220133233419, -96.9005584716797, -1.6912337923521, 218, 51, 'PPL', 'P'),
(86651, 'Eagle Furnace', 35.771110534668, 0.624323655924785, -84.7363891601563, -1.47892898709596, 218, 50, 'PPL', 'P'),
(101580, 'Eagle Furnace', 36.8397216796875, 0.642974438828883, -81.0486068725586, -1.41456504408065, 218, 53, 'PPL', 'P'),
(20735, 'Eagle Grove', 34.2961082458496, 0.598580009510453, -83.0069427490234, -1.44874445298489, 218, 13, 'PPL', 'P'),
(115362, 'Eagle Grove', 42.6641693115234, 0.744630227114406, -93.904167175293, -1.63893689855205, 218, 16, 'PPL', 'P'),
(46742, 'Eagle Harbor', 38.5677795410156, 0.67313473817403, -76.686393737793, -1.33843006220525, 218, 25, 'PPL', 'P'),
(130565, 'Eagle Harbor', 47.4583282470703, 0.828304085403606, -88.1622161865234, -1.53872094830987, 218, 27, 'PPL', 'P'),
(148387, 'Eagle Harbor', 43.2533302307129, 0.754913024978338, -78.2533264160156, -1.36577819659733, 218, 40, 'PPL', 'P'),
(148388, 'Eagle Harbor Station', 43.2358283996582, 0.754607560401306, -78.2541732788086, -1.36579297714138, 218, 40, 'PPL', 'P'),
(191407, 'Eagle Heights Number 1 Colonia', 28.6700000762939, 0.500385897878355, -100.483001708984, -1.75375922210887, 218, 51, 'PPL', 'P'),
(191404, 'Eagle Heights Number 2 Colonia', 28.6669998168945, 0.500333533473421, -100.478996276855, -1.75368931413025, 218, 51, 'PPL', 'P'),
(191405, 'Eagle Heights Number 3 Colonia', 28.6700000762939, 0.500385897878355, -100.478996276855, -1.75368931413025, 218, 51, 'PPL', 'P'),
(191406, 'Eagle Heights Number 4 Colonia', 28.6720008850098, 0.500420818578148, -100.481002807617, -1.75372433469859, 218, 51, 'PPL', 'P'),
(35677, 'Eagle Hill', 38.7030601501465, 0.675495830217467, -84.7886123657227, -1.47984045397904, 218, 21, 'PPL', 'P'),
(46743, 'Eagle Hill', 39.089168548584, 0.682234693039804, -76.4738922119141, -1.33472121091315, 218, 25, 'PPL', 'P'),
(86652, 'Eagle Hill', 36.3194389343262, 0.633893791881012, -88.5430603027344, -1.5453679320746, 218, 50, 'PPL', 'P'),
(188457, 'Eagle Hill (historical)', 33.6572189331055, 0.587429287447264, -103.46028137207, -1.80572255498238, 218, 38, 'PPL', 'P'),
(15847, 'Eagle Island', 27.4419403076172, 0.478952211503665, -80.8436126708984, -1.41098722031418, 218, 12, 'PPL', 'P'),
(15848, 'Eagle Lake', 27.9780597686768, 0.488309261283172, -81.7566680908203, -1.426923043645, 218, 12, 'PPL', 'P'),
(93862, 'Eagle Lake', 29.5894393920898, 0.516433141211277, -96.3333282470703, -1.68133375731583, 218, 51, 'PPL', 'P'),
(119433, 'Eagle Lake', 41.3669395446777, 0.72198929652807, -87.5519409179688, -1.5280696355301, 218, 18, 'PPL', 'P'),
(127310, 'Eagle Lake', 47.0400009155273, 0.821002896117099, -68.5899963378906, -1.19712127002704, 218, 26, 'PPL', 'P'),
(135091, 'Eagle Lake', 44.1650009155273, 0.770824680122262, -93.8811111450195, -1.63853449491133, 218, 28, 'PPL', 'P'),
(173889, 'Eagle Lake', 42.7069396972656, 0.745376711167956, -88.128059387207, -1.53812479969986, 218, 57, 'PPL', 'P'),
(173890, 'Eagle Lake Manor', 42.6983299255371, 0.745226442303448, -88.1350021362305, -1.53824597352946, 218, 57, 'PPL', 'P'),
(196392, 'Eagle Lake Ranch', 48.7608299255371, 0.851037028205604, -114.916938781738, -2.00567894805409, 218, 31, 'PPL', 'P'),
(135092, 'Eagle Lake Regency', 44.1541709899902, 0.770635662263894, -93.8772201538086, -1.63846658430354, 218, 28, 'PPL', 'P'),
(173891, 'Eagle Lake Terrace', 42.704719543457, 0.745337962174095, -88.1388931274414, -1.53831388413725, 218, 57, 'PPL', 'P'),
(59731, 'Eagle Landing', 34.5344390869141, 0.602739667396075, -90.5447235107422, -1.58030354557037, 218, 30, 'PPL', 'P'),
(8649, 'Eagle Mills', 33.6824989318848, 0.587870506660862, -92.7044372558594, -1.61799766132324, 218, 4, 'PPL', 'P'),
(64324, 'Eagle Mills', 36.023609161377, 0.628730588317621, -80.8002777099609, -1.4102308825646, 218, 33, 'PPL', 'P'),
(72370, 'Eagle Mills', 39.3286094665527, 0.686413725422356, -82.6922225952148, -1.44325155007855, 218, 41, 'PPL', 'P'),
(130572, 'Eagle Mills', 46.5127792358398, 0.811801141918657, -87.5336074829102, -1.52774965672513, 218, 27, 'PPL', 'P'),
(148389, 'Eagle Mills', 42.7291717529297, 0.74576473373878, -73.6041717529297, -1.28463514029203, 218, 40, 'PPL', 'P'),
(93863, 'Eagle Mountain', 32.8933296203613, 0.574096903819082, -97.4441680908203, -1.70072157005161, 218, 51, 'PPL', 'P'),
(181244, 'Eagle Mountain', 33.8574981689453, 0.590924819536047, -115.486389160156, -2.01561773208422, 218, 6, 'PPL', 'P'),
(203776, 'Eagle Mountain', 40.3141708374023, 0.70361501632415, -112.00611114502, -1.95487542183531, 218, 52, 'PPL', 'P'),
(46744, 'Eagle Nest', 39.2772216796875, 0.685516839346245, -76.3952789306641, -1.33334915031954, 218, 25, 'PPL', 'P'),
(130567, 'Eagle Nest', 47.4075012207031, 0.8274169864445, -88.2774963378906, -1.54073296651343, 218, 27, 'PPL', 'P'),
(148390, 'Eagle Nest', 43.8497200012207, 0.765321990098913, -74.4858322143555, -1.30002301822856, 218, 40, 'PPL', 'P'),
(188459, 'Eagle Nest', 35.4383316040039, 0.618515567903431, -107.323890686035, -1.87315525852179, 218, 38, 'PPL', 'P'),
(194864, 'Eagle Nest', 44.6072196960449, 0.778542853856448, -115.942222595215, -2.02357352636666, 218, 17, 'PPL', 'P'),
(198222, 'Eagle Nest', 46.8525009155273, 0.81773040376961, -101.923889160156, -1.77890745228248, 218, 34, 'PPL', 'P'),
(101584, 'Eagle Oak', 37.0513916015625, 0.646668775893041, -81.1883316040039, -1.41700370069084, 218, 53, 'PPL', 'P'),
(27019, 'Eagle Park', 38.663890838623, 0.674812196765644, -90.1425018310547, -1.57328345293692, 218, 18, 'PPL', 'P'),
(8650, 'Eagle Park (historical)', 34.8958282470703, 0.609047098121818, -91.8652801513672, -1.60335160690835, 218, 4, 'PPL', 'P'),
(191408, 'Eagle Pass', 28.708890914917, 0.501064671061189, -100.499168395996, -1.75404138402636, 218, 51, 'PPL', 'P'),
(80792, 'Eagle Point', 33.5180587768555, 0.585000484533111, -80.1872177124023, -1.39953096709494, 218, 48, 'PPL', 'P'),
(86653, 'Eagle Point', 35.7636108398438, 0.624192761557208, -84.7536087036133, -1.47922952482497, 218, 50, 'PPL', 'P'),
(115364, 'Eagle Point', 42.5347213745117, 0.742370934403638, -90.6444396972656, -1.58204392134274, 218, 16, 'PPL', 'P'),
(119434, 'Eagle Point', 41.9936103820801, 0.732926765966971, -89.6847229003906, -1.56529370335057, 218, 18, 'PPL', 'P'),
(122534, 'Eagle Point', 41.3274993896484, 0.721300935965312, -85.6777801513672, -1.4953593594412, 218, 19, 'PPL', 'P'),
(130568, 'Eagle Point', 41.8952789306641, 0.731210558381497, -85.9830627441406, -1.50068754583412, 218, 27, 'PPL', 'P'),
(148391, 'Eagle Point', 42.7999992370605, 0.747000906537768, -77.7174987792969, -1.3564262401134, 218, 40, 'PPL', 'P'),
(160990, 'Eagle Point', 40.5449981689453, 0.707643713263168, -75.7616729736328, -1.3222906402091, 218, 45, 'PPL', 'P'),
(173892, 'Eagle Point', 45.0316696166992, 0.785950902481694, -91.3958282470703, -1.59515812549861, 218, 57, 'PPL', 'P'),
(200737, 'Eagle Point', 42.4727783203125, 0.74128982415912, -122.801666259766, -2.14329340316814, 218, 43, 'PPL', 'P'),
(27020, 'Eagle Point Bay', 37.5894393920898, 0.656059481370823, -88.9297180175781, -1.55211638227686, 218, 18, 'PPL', 'P'),
(86654, 'Eagle Point Cabin Area', 35.7613906860352, 0.624154012563347, -84.7388916015625, -1.47897266293784, 218, 50, 'PPL', 'P'),
(155056, 'Eagle Point Colony', 41.6094398498535, 0.726221725290479, -83.5733337402344, -1.45862984063516, 218, 41, 'PPL', 'P'),
(86655, 'Eagle Point Heights', 35.7638893127441, 0.624197621826197, -84.7352828979492, -1.47890967917806, 218, 50, 'PPL', 'P'),
(20734, 'Eagle Pond', 31.858060836792, 0.55602805490268, -84.2313919067383, -1.47011512231029, 218, 13, 'PPL', 'P'),
(181245, 'Eagle Ranch', 34.4777793884277, 0.601750769104301, -117.406936645508, -2.0491376091445, 218, 6, 'PPL', 'P'),
(2150, 'Eagle Ridge', 33.6941719055176, 0.588074238484253, -86.6149978637695, -1.51171689433063, 218, 2, 'PPL', 'P'),
(115365, 'Eagle Ridge Community', 42.038890838623, 0.733717059020452, -91.5541687011719, -1.59792168776179, 218, 16, 'PPL', 'P'),
(130569, 'Eagle River', 47.413890838623, 0.827528506315148, -88.2955627441406, -1.54104828478649, 218, 27, 'PPL', 'P'),
(173894, 'Eagle River', 45.9172210693359, 0.801406691026024, -89.2441711425781, -1.5576046246513, 218, 57, 'PPL', 'P'),
(211801, 'Eagle River', 61.3213882446289, 1.07026012676252, -149.567779541016, -2.61045020788774, 218, 1, 'PPL', 'P'),
(54519, 'Eagle Rock', 36.5480613708496, 0.637884006142278, -93.7541732788086, -1.6363190112005, 218, 29, 'PPL', 'P'),
(64326, 'Eagle Rock', 35.7911109924316, 0.624672729764667, -78.4086074829102, -1.36848836248065, 218, 33, 'PPL', 'P'),
(101581, 'Eagle Rock', 37.6405601501465, 0.656951706915027, -79.8013916015625, -1.39279703112062, 218, 53, 'PPL', 'P'),
(160991, 'Eagle Rock', 41.4524993896484, 0.723482597530305, -79.5755615234375, -1.3888555527073, 218, 45, 'PPL', 'P'),
(181246, 'Eagle Rock', 34.1388893127441, 0.595836021481289, -118.21305847168, -2.06320708918339, 218, 6, 'PPL', 'P'),
(64327, 'Eagle Springs', 35.291389465332, 0.615950943773685, -79.6530609130859, -1.39020817222495, 218, 33, 'PPL', 'P'),
(190142, 'Eagle Station (historical)', 39.163890838623, 0.683538843025615, -119.763893127441, -2.09027426008046, 218, 39, 'PPL', 'P'),
(181247, 'Eagle Tree', 38.2013893127441, 0.666740022343559, -121.512222290039, -2.12078836037643, 218, 6, 'PPL', 'P'),
(148392, 'Eagle Valley', 41.1547203063965, 0.718285372083988, -74.2272186279297, -1.29550935965504, 218, 40, 'PPL', 'P'),
(46745, 'Eagle View', 39.5263900756836, 0.689865648248289, -76.4994430541992, -1.33516715723768, 218, 25, 'PPL', 'P'),
(29677, 'Eagle Village', 39.9605598449707, 0.697443340234974, -86.2455596923828, -1.50526898185739, 218, 19, 'PPL', 'P'),
(148393, 'Eagle Village', 43.0130615234375, 0.750719544946873, -75.9430618286133, -1.32545647295493, 218, 40, 'PPL', 'P'),
(211802, 'Eagle Village', 64.7805633544922, 1.13063412183267, -141.113616943359, -2.46289723505968, 218, 1, 'PPL', 'P'),
(46746, 'Eagle Wood Estates', 39.4194412231445, 0.687999038640253, -77.0783309936523, -1.34527065778123, 218, 25, 'PPL', 'P'),
(203777, 'Eaglebrook Estates', 40.603889465332, 0.708671560285884, -111.880279541016, -1.95267924604237, 218, 52, 'PPL', 'P'),
(207255, 'Eagledale', 47.6144409179688, 0.831028765514866, -122.514167785645, -2.13827560820027, 218, 56, 'PPL', 'P'),
(46747, 'Eaglehead Summerfield', 39.401668548584, 0.687688846952286, -77.2955627441406, -1.34906206706712, 218, 25, 'PPL', 'P'),
(160993, 'Eaglehurst', 42.0955581665039, 0.734706090470281, -80.1636123657227, -1.3991189760743, 218, 45, 'PPL', 'P'),
(207256, 'Eaglemount', 47.9700012207031, 0.837234463486969, -122.848327636719, -2.14410779782949, 218, 56, 'PPL', 'P'),
(64328, 'Eaglenest (historical)', 35.4972190856934, 0.61954334834712, -83.043327331543, -1.44937948374682, 218, 33, 'PPL', 'P'),
(72373, 'Eagleport', 39.7372207641602, 0.693545337926452, -81.9155578613281, -1.4296961932881, 218, 41, 'PPL', 'P'),
(101582, 'Eagles Eyrie', 37.4816703796387, 0.654178557271928, -79.2763900756836, -1.38363402591604, 218, 53, 'PPL', 'P'),
(46748, 'Eagles Loft', 39.2763900756836, 0.685502325118304, -76.9661102294922, -1.34331203595753, 218, 25, 'PPL', 'P'),
(160994, 'Eagles Mere', 41.410831451416, 0.722755354815632, -76.5822219848633, -1.33661192212905, 218, 45, 'PPL', 'P'),
(160995, 'Eagles Mere Park', 41.4249992370605, 0.723002629322846, -76.5811080932617, -1.33659248105309, 218, 45, 'PPL', 'P'),
(59732, 'Eagles Nest', 34.2919387817383, 0.598507238633666, -90.4672164916992, -1.57895079289466, 218, 30, 'PPL', 'P'),
(130571, 'Eagles Nest', 45.190559387207, 0.788724052124794, -87.6113891601563, -1.5291072030908, 218, 27, 'PPL', 'P'),
(135099, 'Eagles Nest', 47.8400001525879, 0.834965516817248, -92.0963897705078, -1.60738523069539, 218, 28, 'PPL', 'P'),
(181248, 'Eagles Nest', 33.2880592346191, 0.580986235243008, -116.593330383301, -2.03493750105414, 218, 6, 'PPL', 'P'),
(186652, 'Eagles Nest', 39.6183280944824, 0.691470269384089, -106.385559082031, -1.8567782825564, 218, 7, 'PPL', 'P'),
(13696, 'Eagles Nest Landing', 39.3452796936035, 0.686704675771447, -75.563606262207, -1.31883372395612, 218, 10, 'PPL', 'P'),
(46749, 'Eagles Nest Mobile Home Park', 38.3030586242676, 0.668514486577879, -75.1208267211914, -1.31110576310493, 218, 25, 'PPL', 'P'),
(46750, 'Eagles Passages', 38.9669418334961, 0.680101434427623, -76.6125030517578, -1.33714042644738, 218, 25, 'PPL', 'P'),
(20736, 'Eagles Rest', 33.1041717529297, 0.577776793234326, -85.0627822875977, -1.48462562182569, 218, 13, 'PPL', 'P'),
(101583, 'Eagles Roost', 37.0683288574219, 0.646964386774039, -79.5833282470703, -1.38899110760678, 218, 53, 'PPL', 'P'),
(124675, 'Eaglesville', 42.5499992370605, 0.742637583407782, -72.2708282470703, -1.2613639060547, 218, 23, 'PPL', 'P'),
(70764, 'Eagleswood Village', 39.6686096191406, 0.692347847542298, -74.2827835083008, -1.29647914976599, 218, 37, 'PPL', 'P'),
(181249, 'Eaglet (historical)', 35.4561080932617, 0.618825826170426, -120.622779846191, -2.1052646612243, 218, 6, 'PPL', 'P'),
(8657, 'Eagletie', 33.8824996948242, 0.591361178480657, -92.6074981689453, -1.61630575508272, 218, 4, 'PPL', 'P'),
(8658, 'Eagleton', 34.6802787780762, 0.605285050186945, -94.3000030517578, -1.64584553789387, 218, 4, 'PPL', 'P'),
(64329, 'Eagleton', 36.0200004577637, 0.628667604557841, -75.7133331298828, -1.32144695077576, 218, 33, 'PPL', 'P'),
(173899, 'Eagleton', 45.0602798461914, 0.786450245186084, -91.3891677856445, -1.59504187851703, 218, 57, 'PPL', 'P'),
(196393, 'Eagleton', 47.9449996948242, 0.836798104542359, -109.781669616699, -1.91605159314802, 218, 31, 'PPL', 'P'),
(160997, 'Eagleton Fields', 41.2019386291504, 0.719109487283313, -77.6352767944336, -1.35499119576002, 218, 45, 'PPL', 'P'),
(86656, 'Eagleton Village', 35.7949981689453, 0.624740573793437, -83.9319381713867, -1.46488866867101, 218, 50, 'PPL', 'P'),
(64330, 'Eagletown', 36.2713890075684, 0.633055162453746, -77.2286071777344, -1.34789347198079, 218, 33, 'PPL', 'P'),
(75719, 'Eagletown', 34.0341682434082, 0.594008294025168, -94.5747222900391, -1.65064029312045, 218, 42, 'PPL', 'P'),
(122535, 'Eagletown', 40.0422210693359, 0.698868597471357, -86.1936111450195, -1.50436230866427, 218, 19, 'PPL', 'P'),
(54521, 'Eaglette', 37.0355606079102, 0.646392472929945, -90.039436340332, -1.57148462077863, 218, 29, 'PPL', 'P'),
(86657, 'Eagleville', 35.7416687011719, 0.623809798992454, -86.6497192382813, -1.51232289663668, 218, 50, 'PPL', 'P'),
(113203, 'Eagleville', 41.7866706848145, 0.729314986896606, -72.2769393920898, -1.26147056565636, 218, 8, 'PPL', 'P'),
(139129, 'Eagleville', 40.4691696166992, 0.706320255359453, -93.9869384765625, -1.64038153028536, 218, 29, 'PPL', 'P'),
(148396, 'Eagleville', 43.0844383239746, 0.751965305125784, -73.3133316040039, -1.27955902209628, 218, 40, 'PPL', 'P'),
(155059, 'Eagleville', 41.1972198486328, 0.719027129026602, -83.5552825927734, -1.4583147886782, 218, 41, 'PPL', 'P'),
(160999, 'Eagleville', 40.1594390869141, 0.700914437820756, -75.4086074829102, -1.31612848492082, 218, 45, 'PPL', 'P'),
(169353, 'Eagleville', 41.6577796936035, 0.727065414723816, -71.1527786254883, -1.24185025895742, 218, 47, 'PPL', 'P'),
(173900, 'Eagleville', 42.8547210693359, 0.747955982683697, -88.4327774047852, -1.54344313239675, 218, 57, 'PPL', 'P'),
(193512, 'Eagleville', 41.3163909912109, 0.721107057837954, -120.114723205566, -2.09639740005877, 218, 6, 'PPL', 'P'),
(190145, 'Eagleville (historical)', 39.0261116027832, 0.681134141719328, -118.251937866211, -2.06388566262914, 218, 39, 'PPL', 'P'),
(20737, 'Eaglewood', 34.2144393920898, 0.597154619116015, -83.829719543457, -1.46310461705676, 218, 13, 'PPL', 'P'),
(29679, 'Eaglewood Estates', 39.9513893127441, 0.69728328425346, -86.3130569458008, -1.50644703116558, 218, 19, 'PPL', 'P'),
(181251, 'Eaires (historical)', 34.9302787780762, 0.609648373316931, -118.148887634277, -2.06208709678695, 218, 6, 'PPL', 'P'),
(202081, 'Eakin', 44.6155586242676, 0.778688395610021, -100.032783508301, -1.74590143215453, 218, 49, 'PPL', 'P'),
(161000, 'Eakin Corner', 41.1733283996582, 0.718610144578923, -79.813606262207, -1.39301021716588, 218, 45, 'PPL', 'P'),
(188460, 'Eakins', 31.7208309173584, 0.553632940976317, -108.824172973633, -1.89934012414972, 218, 38, 'PPL', 'P'),
(108991, 'Eakle', 38.4469413757324, 0.671025714327769, -80.9272232055664, -1.41244649943349, 218, 58, 'PPL', 'P'),
(46751, 'Eakles Mills', 39.4680595397949, 0.688847588342579, -77.6849975585938, -1.35585898680122, 218, 25, 'PPL', 'P'),
(75720, 'Eakly', 35.3052787780762, 0.61619335801191, -98.557502746582, -1.72015292547121, 218, 42, 'PPL', 'P'),
(15849, 'Ealum', 30.8402805328369, 0.538264437536715, -86.2436065673828, -1.50523489339543, 218, 12, 'PPL', 'P'),
(29680, 'Eames', 38.0791702270508, 0.664606896889433, -87.1316680908203, -1.5207344909397, 218, 19, 'PPL', 'P'),
(86658, 'Earheart (historical)', 36.5202789306641, 0.637399111086802, -82.2555618286133, -1.43563038198707, 218, 50, 'PPL', 'P'),
(54522, 'Earl', 38.9311103820801, 0.679476057624645, -92.0611114501953, -1.60676950785136, 218, 29, 'PPL', 'P'),
(64334, 'Earl', 35.1933288574219, 0.614239463299146, -81.533332824707, -1.42302510791551, 218, 33, 'PPL', 'P'),
(75721, 'Earl', 34.2016716003418, 0.596931779111803, -96.8974990844727, -1.69118039597224, 218, 42, 'PPL', 'P'),
(173901, 'Earl', 45.9105606079102, 0.801290444044442, -91.7602767944336, -1.60151895260421, 218, 57, 'PPL', 'P'),
(186653, 'Earl', 37.3333282470703, 0.65158949863918, -104.277778625488, -1.81999057368054, 218, 7, 'PPL', 'P'),
(207257, 'Earl', 47.5519409179688, 0.82993793473237, -118.378326416016, -2.06609155896005, 218, 56, 'PPL', 'P'),
(200738, 'Earl (historical)', 43.9419403076172, 0.76693153808273, -123.874443054199, -2.16201689037, 218, 43, 'PPL', 'P'),
(122536, 'Earl Park', 40.6827812194824, 0.710048481148482, -87.4116668701172, -1.52562139153999, 218, 19, 'PPL', 'P'),
(8659, 'Earle', 35.2750015258789, 0.615664920272611, -90.466667175293, -1.57894120551474, 218, 4, 'PPL', 'P'),
(29681, 'Earle', 38.0855598449707, 0.66471841676008, -87.5133285522461, -1.52739572261626, 218, 19, 'PPL', 'P'),
(80793, 'Earle', 33.4647216796875, 0.584069576574074, -79.6363906860352, -1.38991722187586, 218, 48, 'PPL', 'P'),
(93864, 'Earle', 29.2630596160889, 0.510736739508139, -98.4905624389648, -1.71898459670099, 218, 51, 'PPL', 'P'),
(145113, 'Earle', 40.2252807617188, 0.702063591831125, -74.1405563354492, -1.29399681731393, 218, 37, 'PPL', 'P'),
(80794, 'Earle (historical)', 33.6575012207031, 0.58743421429528, -81.5699996948242, -1.42366506552545, 218, 48, 'PPL', 'P'),
(46757, 'Earle Landing', 39.0777816772461, 0.682035954643456, -76.1397171020508, -1.32888875496782, 218, 25, 'PPL', 'P'),
(101586, 'Earlehurst', 37.6691703796387, 0.657451049619417, -80.2344436645508, -1.40035521545232, 218, 53, 'PPL', 'P'),
(46752, 'Earleigh Heights', 39.0924987792969, 0.682292816530595, -76.5758285522461, -1.33650033567938, 218, 25, 'PPL', 'P'),
(35679, 'Earles', 37.2999992370605, 0.651007797678079, -87.3102798461914, -1.52385185415369, 218, 21, 'PPL', 'P'),
(46753, 'Earles Branch', 39.0636100769043, 0.681788613557215, -76.095832824707, -1.32812282983831, 218, 25, 'PPL', 'P'),
(80795, 'Earles Grove', 34.5666694641113, 0.603302193597327, -82.991943359375, -1.44848266424974, 218, 48, 'PPL', 'P'),
(15850, 'Earleton', 29.7436103820801, 0.519123932597666, -82.1036071777344, -1.43297827301551, 218, 12, 'PPL', 'P'),
(46754, 'Earleville', 39.4152793884277, 0.687926400921521, -75.9177780151367, -1.3250151871623, 218, 25, 'PPL', 'P'),
(155060, 'Earley (historical)', 40.6113891601563, 0.708802454653461, -84.5902786254883, -1.47637887719415, 218, 41, 'PPL', 'P'),
(127312, 'Earley Landing', 45.3044395446777, 0.790711635825347, -69.3513870239258, -1.21041004439238, 218, 26, 'PPL', 'P'),
(64335, 'Earleys', 36.2572212219238, 0.632807887946532, -77.0277786254883, -1.34438835251208, 218, 33, 'PPL', 'P'),
(86659, 'Earleyville', 35.7574996948242, 0.62408610195555, -85.857780456543, -1.49850095742112, 218, 50, 'PPL', 'P'),
(115369, 'Earlham', 41.4919395446777, 0.724170958093063, -94.123893737793, -1.64277185052176, 218, 16, 'PPL', 'P'),
(181252, 'Earlimart', 35.8841705322266, 0.626296925134479, -119.271392822266, -2.08167850818807, 218, 6, 'PPL', 'P'),
(108993, 'Earling', 37.7663917541504, 0.659147882707961, -81.9155578613281, -1.4296961932881, 218, 58, 'PPL', 'P'),
(115370, 'Earling', 41.7755584716797, 0.729121042190221, -95.4172210693359, -1.66534467076322, 218, 16, 'PPL', 'P'),
(35678, 'Earlington', 37.274169921875, 0.650556991084556, -87.5119400024414, -1.52737148785034, 218, 21, 'PPL', 'P'),
(161003, 'Earlington', 40.3208312988281, 0.703731263305732, -75.3727798461914, -1.31550317469687, 218, 45, 'PPL', 'P'),
(207258, 'Earlmont', 47.6936111450195, 0.832410546646454, -122.149169921875, -2.13190519371474, 218, 56, 'PPL', 'P'),
(93865, 'Earls', 32.7355613708496, 0.571343328409994, -97.7427825927734, -1.7059333763049, 218, 51, 'PPL', 'P'),
(101585, 'Earls', 37.2299995422363, 0.649786072528006, -77.8933334350586, -1.35949513379556, 218, 53, 'PPL', 'P'),
(155061, 'Earls Island', 40.3699989318848, 0.704589400387983, -84.357780456543, -1.4723210186412, 218, 41, 'PPL', 'P'),
(75723, 'Earlsboro', 35.2675018310547, 0.615534025905033, -96.8030624389648, -1.68953216557359, 218, 42, 'PPL', 'P'),
(161004, 'Earlston', 40.0061111450195, 0.698238360399389, -78.3702774047852, -1.36781937641482, 218, 45, 'PPL', 'P'),
(32287, 'Earlton', 37.5880584716797, 0.656035379762958, -95.4688873291016, -1.66624641710832, 218, 20, 'PPL', 'P'),
(46755, 'Earlton', 39.5733299255371, 0.690684903178625, -76.1486129760742, -1.32904401725937, 218, 25, 'PPL', 'P'),
(148397, 'Earlton', 42.3555603027344, 0.739243983809721, -73.9011077880859, -1.28981765177332, 218, 40, 'PPL', 'P'),
(2153, 'Earlville', 30.9833297729492, 0.540761117769151, -88.4069366455078, -1.54299212606614, 218, 2, 'PPL', 'P'),
(115371, 'Earlville', 42.4816703796387, 0.741445019871644, -91.272216796875, -1.59300069869954, 218, 16, 'PPL', 'P'),
(119439, 'Earlville', 41.5894393920898, 0.725872651450597, -88.9219436645508, -1.55198069421932, 218, 18, 'PPL', 'P'),
(148399, 'Earlville', 42.7397193908691, 0.745948824749132, -75.5455627441406, -1.31851880515722, 218, 40, 'PPL', 'P'),
(155062, 'Earlville', 41.1875, 0.718857485665165, -81.3472213745117, -1.41977685033394, 218, 41, 'PPL', 'P'),
(161005, 'Earlville', 40.3166694641113, 0.703658625587001, -75.7372207641602, -1.32186386864441, 218, 45, 'PPL', 'P'),
(80796, 'Earlwood Park', 34.3288917541504, 0.599152189670656, -79.8916702270508, -1.39437269037956, 218, 48, 'PPL', 'P'),
(15851, 'Early', 30.0283298492432, 0.524093224744186, -85.3119430541992, -1.48897429756968, 218, 12, 'PPL', 'P'),
(93866, 'Early', 31.7419395446777, 0.554001356023616, -98.9452819824219, -1.72692094990748, 218, 51, 'PPL', 'P'),
(101587, 'Early', 36.8072204589844, 0.642407185516696, -80.790283203125, -1.4100564455132, 218, 53, 'PPL', 'P'),
(115372, 'Early', 42.4613914489746, 0.741091085762773, -95.1516723632813, -1.66070997151815, 218, 16, 'PPL', 'P'),
(20738, 'Early (historical)', 34.2477798461914, 0.597736519814197, -85.4427795410156, -1.49125782504637, 218, 13, 'PPL', 'P'),
(200739, 'Early (historical)', 45.6930618286133, 0.797494374226643, -120.56861114502, -2.10431923903732, 218, 43, 'PPL', 'P'),
(15852, 'Early Bird', 29.2155609130859, 0.50990773075031, -82.3677825927734, -1.43758900381077, 218, 12, 'PPL', 'P'),
(80797, 'Early Branch', 32.7455596923828, 0.571517832040422, -80.9280624389648, -1.41246114681949, 218, 48, 'PPL', 'P'),
(59733, 'Early Grove', 34.975830078125, 0.610443393481347, -89.3847198486328, -1.56005766233137, 218, 30, 'PPL', 'P'),
(46756, 'Early Manor', 38.7036094665527, 0.675505417597391, -76.833610534668, -1.34099948002496, 218, 25, 'PPL', 'P'),
(29682, 'Early Station', 39.7633285522461, 0.694001004788964, -87.3852767944336, -1.52516079782946, 218, 19, 'PPL', 'P'),
(70766, 'Earlys Crossing', 39.9086112976074, 0.696536667041856, -74.6061096191406, -1.30212225495782, 218, 37, 'PPL', 'P'),
(80799, 'Earlys Crossroads', 34.3002815246582, 0.598652846966266, -79.9741668701172, -1.39581252842291, 218, 48, 'PPL', 'P'),
(101588, 'Earlysville', 38.1575012207031, 0.665974030635025, -78.4830627441406, -1.36978785193455, 218, 53, 'PPL', 'P'),
(101589, 'Earlysville Heights', 38.1527786254883, 0.665891605799287, -78.4786071777344, -1.36971008763072, 218, 53, 'PPL', 'P'),
(2154, 'Earlytown', 31.1283302307129, 0.543291853174026, -86.1294403076172, -1.50324231626784, 218, 2, 'PPL', 'P'),
(59734, 'Earlyville', 33.0769386291504, 0.577301485558774, -89.709716796875, -1.56572992913713, 218, 30, 'PPL', 'P'),
(161006, 'Earlyville', 41.3613891601563, 0.721892424043419, -78.6222229003906, -1.3722166548487, 218, 45, 'PPL', 'P'),
(93867, 'Earlywine', 30.2163906097412, 0.527375504208681, -96.3072204589844, -1.68087809045332, 218, 51, 'PPL', 'P'),
(101590, 'Earness', 37.1108283996582, 0.647706143716654, -76.341667175293, -1.33241344867054, 218, 53, 'PPL', 'P'),
(86660, 'Earnest (historical)', 35.0002784729004, 0.610870098467005, -84.8427810668945, -1.48078587616602, 218, 50, 'PPL', 'P'),
(127313, 'Earnest Corner', 45.0327796936035, 0.785970276978625, -69.1352767944336, -1.2066382093405, 218, 26, 'PPL', 'P'),
(54523, 'Earnestville', 37.5602798461914, 0.655550551286509, -92.8919372558594, -1.62127015367073, 218, 29, 'PPL', 'P'),
(161007, 'Earnestville', 40.8491706848145, 0.712952525159159, -78.283332824707, -1.36630190722569, 218, 45, 'PPL', 'P'),
(8660, 'Earnheart', 35.7472190856934, 0.623906671477106, -91.7680587768555, -1.60165477381981, 218, 4, 'PPL', 'P'),
(108992, 'Earnshaw', 39.622501373291, 0.691543106839903, -80.4677810668945, -1.40442772139127, 218, 58, 'PPL', 'P'),
(181253, 'Earp', 34.1647186279297, 0.596286828074813, -114.300277709961, -1.9949161819827, 218, 6, 'PPL', 'P'),
(64336, 'Earpsboro', 35.7813911437988, 0.624503086403229, -78.2936096191406, -1.36648127112511, 218, 33, 'PPL', 'P'),
(191409, 'Earth', 34.2330589294434, 0.597479591348032, -102.410278320313, -1.78739654457322, 218, 51, 'PPL', 'P'),
(54524, 'Earth City', 38.7688903808594, 0.676644784490754, -90.4680633544922, -1.57896557343871, 218, 29, 'PPL', 'P'),
(139919, 'Easby', 48.7102813720703, 0.850154789515488, -98.253059387207, -1.71483938646428, 218, 34, 'PPL', 'P'),
(2155, 'Easley', 33.959171295166, 0.592699350349394, -86.5425033569336, -1.51045162649674, 218, 2, 'PPL', 'P'),
(54525, 'Easley', 38.8016700744629, 0.677216898071931, -92.3758316040039, -1.6122624107577, 218, 29, 'PPL', 'P'),
(80798, 'Easley', 34.829719543457, 0.607893283579541, -82.6016693115234, -1.44167109712964, 218, 48, 'PPL', 'P'),
(115373, 'Easley', 42.3111114501953, 0.738468204984181, -94.399169921875, -1.64757632628632, 218, 16, 'PPL', 'P'),
(93868, 'Easley Chapel', 31.5530605316162, 0.550704795357775, -95.1802825927734, -1.66120931422254, 218, 51, 'PPL', 'P'),
(86661, 'Easley Estates', 36.4847183227539, 0.636778461394759, -82.5541687011719, -1.4408420550823, 218, 50, 'PPL', 'P'),
(194865, 'Easley Hot Springs', 43.7805595397949, 0.764114912334835, -114.542221069336, -1.99913889020713, 218, 17, 'PPL', 'P'),
(40734, 'Easleyville', 30.9286098480225, 0.539806074912735, -90.6875, -1.58279546540236, 218, 22, 'PPL', 'P'),
(108998, 'Easly', 38.1522216796875, 0.665881885261308, -81.7333297729492, -1.42651571315627, 218, 58, 'PPL', 'P'),
(20740, 'Eason', 30.8108291625977, 0.537750414156816, -83.8494415283203, -1.46344883062766, 218, 13, 'PPL', 'P'),
(75725, 'Eason', 35.014720916748, 0.611122166664181, -97.129997253418, -1.69523825452519, 218, 42, 'PPL', 'P'),
(20741, 'Eason Bluff', 31.8997192382813, 0.556755131169785, -82.1819381713867, -1.43434540676111, 218, 13, 'PPL', 'P'),
(64337, 'Eason Crossroads', 36.4486083984375, 0.636148224322792, -76.7002792358398, -1.33867240986445, 218, 33, 'PPL', 'P'),
(64339, 'Easonburg', 35.9152793884277, 0.626839877101719, -77.8702774047852, -1.35909273015485, 218, 33, 'PPL', 'P'),
(108994, 'East (historical)', 38.2194404602051, 0.667055074300515, -81.9361114501953, -1.43005492108693, 218, 58, 'PPL', 'P'),
(59735, 'East Abeika (historical)', 32.7958297729492, 0.572395210461548, -88.6222229003906, -1.54674958004814, 218, 30, 'PPL', 'P'),
(59736, 'East Aberdeen', 33.8216705322266, 0.590299509312096, -88.5163879394531, -1.54490241151606, 218, 30, 'PPL', 'P'),
(207259, 'East Aberdeen', 46.9780616760254, 0.819921852451609, -123.800827026367, -2.16073204830209, 218, 56, 'PPL', 'P'),
(124676, 'East Acton', 42.4749984741211, 0.741328573152981, -71.4100036621094, -1.24633968276502, 218, 23, 'PPL', 'P'),
(143740, 'East Acworth', 43.2205581665039, 0.754341044555217, -72.2372207641602, -1.26077734482461, 218, 36, 'PPL', 'P'),
(148400, 'East Afton', 42.2069396972656, 0.736650064907984, -75.4238891601563, -1.31639520050399, 218, 40, 'PPL', 'P'),
(191410, 'East Afton', 33.7480583190918, 0.589014733823215, -100.742500305176, -1.75828832701671, 218, 51, 'PPL', 'P'),
(155063, 'East Akron', 41.0711097717285, 0.716826092964679, -81.4894409179688, -1.42225904962795, 218, 41, 'PPL', 'P'),
(20742, 'East Albany', 31.5755596160889, 0.551097478460507, -84.105827331543, -1.46792360704926, 218, 13, 'PPL', 'P'),
(171920, 'East Albany', 44.7311096191406, 0.780705140924511, -72.3166732788086, -1.26216405280421, 218, 55, 'PPL', 'P'),
(171921, 'East Alburg', 44.9730606079102, 0.784927982306995, -73.2300033569336, -1.27810466982499, 218, 55, 'PPL', 'P'),
(148401, 'East Alexander', 42.9277801513672, 0.749231104213627, -78.1930618286133, -1.3647263811248, 218, 40, 'PPL', 'P'),
(155064, 'East Alliance', 40.913330078125, 0.71407231781851, -81.07861328125, -1.41508875470902, 218, 41, 'PPL', 'P'),
(143741, 'East Alstead', 43.1238899230957, 0.752653865425624, -72.2794418334961, -1.26151424149823, 218, 36, 'PPL', 'P'),
(93869, 'East Alto Bonito Colonia', 26.3020000457764, 0.459056500658497, -98.6360015869141, -1.721522988694, 218, 51, 'PPL', 'P'),
(27021, 'East Alton', 38.8802795410156, 0.678588892086512, -90.1111068725586, -1.57273550754264, 218, 18, 'PPL', 'P'),
(143742, 'East Alton', 43.5180587768555, 0.759533409732544, -71.2002792358398, -1.24267930100476, 218, 36, 'PPL', 'P'),
(161011, 'East Altoona', 40.5472183227539, 0.707682462257028, -78.3649978637695, -1.3677272310411, 218, 45, 'PPL', 'P'),
(115374, 'East Amana', 41.8091697692871, 0.729707669999338, -91.850830078125, -1.60309940555312, 218, 16, 'PPL', 'P'),
(148402, 'East Amboy', 43.3702812194824, 0.75695420479583, -75.9108276367188, -1.32489388017465, 218, 40, 'PPL', 'P'),
(148403, 'East Amherst', 43.0183296203613, 0.750811490583507, -78.6969375610352, -1.37352067167646, 218, 40, 'PPL', 'P'),
(127314, 'East Andover', 44.6161117553711, 0.778698049568972, -70.7152786254883, -1.23421444347994, 218, 26, 'PPL', 'P'),
(143743, 'East Andover', 43.4594383239746, 0.758510289820763, -71.7480621337891, -1.25223991616009, 218, 36, 'PPL', 'P'),
(161012, 'East Ararat', 41.7922210693359, 0.729411859381258, -75.4861068725586, -1.31748110443847, 218, 45, 'PPL', 'P'),
(181254, 'East Arboga', 39.0569381713867, 0.681672166838552, -121.550559997559, -2.12145747960031, 218, 6, 'PPL', 'P'),
(148404, 'East Arcade', 42.5705604553223, 0.74299644436467, -78.3447189331055, -1.36737329693223, 218, 40, 'PPL', 'P'),
(64338, 'East Arcadia', 34.3819389343262, 0.600078037623622, -78.3236083984375, -1.36700484859542, 218, 33, 'PPL', 'P'),
(181255, 'East Arcadia', 34.1055603027344, 0.595254320520189, -118.016670227051, -2.0597794677024, 218, 6, 'PPL', 'P'),
(124677, 'East Arlington', 42.4041709899902, 0.740092400353993, -71.147216796875, -1.24175318673568, 218, 23, 'PPL', 'P'),
(171922, 'East Arlington', 43.0602798461914, 0.751543660146198, -73.14111328125, -1.27655324533197, 218, 55, 'PPL', 'P'),
(101591, 'East Arlington (historical)', 38.8733291625977, 0.678467585098859, -77.0625, -1.34499435481813, 218, 53, 'PPL', 'P'),
(20743, 'East Armuchee', 34.6263885498047, 0.604344488268956, -85.1302795410156, -1.48580367113389, 218, 13, 'PPL', 'P'),
(155065, 'East Ashtabula', 41.8977813720703, 0.731254234223374, -80.788330078125, -1.41002235705125, 218, 41, 'PPL', 'P'),
(161013, 'East Athens', 41.9599990844727, 0.732340138157854, -76.5058288574219, -1.3352786105293, 218, 45, 'PPL', 'P'),
(20744, 'East Atlanta', 33.7400016784668, 0.588874118917659, -84.3450012207031, -1.47209797889991, 218, 13, 'PPL', 'P'),
(148405, 'East Atlantic Beach', 40.7897186279297, 0.711914891019437, -73.7474975585938, -1.28713664750394, 218, 40, 'PPL', 'P'),
(127315, 'East Auburn', 44.1427803039551, 0.770436857288519, -70.2275009155273, -1.22570111642328, 218, 26, 'PPL', 'P'),
(148406, 'East Aurora', 42.7677803039551, 0.746438580073597, -78.6136093139648, -1.37206631940517, 218, 40, 'PPL', 'P'),
(148407, 'East Avon', 42.9091682434082, 0.748906265139665, -77.706672668457, -1.35623728883406, 218, 40, 'PPL', 'P'),
(127316, 'East Baldwin Mattocks Station', 43.8030586242676, 0.764507595437567, -70.6786117553711, -1.23357448586999, 218, 26, 'PPL', 'P'),
(127317, 'East Bangor', 44.8527793884277, 0.782828678998713, -68.8127822875977, -1.20100961837661, 218, 26, 'PPL', 'P'),
(161014, 'East Bangor', 40.8794403076172, 0.713480829740404, -75.1841735839844, -1.31221137443147, 218, 45, 'PPL', 'P'),
(108995, 'East Bank', 38.2180595397949, 0.66703097269265, -81.4430618286133, -1.42144958181462, 218, 58, 'PPL', 'P'),
(35680, 'East Bardstown', 37.8325004577637, 0.660301697250238, -85.4088897705078, -1.49066633696827, 218, 21, 'PPL', 'P'),
(171923, 'East Barnard', 43.7458305358887, 0.763508776870733, -72.543327331543, -1.26611991228742, 218, 55, 'PPL', 'P'),
(171924, 'East Barnet Inwood Station', 44.3266716003418, 0.773646365876228, -72.0380630493164, -1.25730138696984, 218, 55, 'PPL', 'P'),
(148408, 'East Barre', 43.186939239502, 0.753754283588045, -78.1505584716797, -1.36398455760316, 218, 40, 'PPL', 'P'),
(171925, 'East Barre', 44.1580581665039, 0.770703506292664, -72.4508285522461, -1.26450550403461, 218, 55, 'PPL', 'P'),
(143744, 'East Barrington', 43.2155609130859, 0.754253826029517, -71.0072174072266, -1.23930973643553, 218, 36, 'PPL', 'P'),
(155066, 'East Bass Lake', 41.5916709899902, 0.725911600181539, -81.1774978637695, -1.41681461625344, 218, 41, 'PPL', 'P'),
(72374, 'East Batavia Heights', 39.0780601501465, 0.682040814912446, -84.1538925170898, -1.46876250279264, 218, 41, 'PPL', 'P'),
(148409, 'East Bay Park', 43.2919387817383, 0.755586871313156, -76.8952789306641, -1.34207579657951, 218, 40, 'PPL', 'P'),
(143745, 'East Bear Island', 43.6430587768555, 0.761715071297537, -71.394172668457, -1.24606337980192, 218, 36, 'PPL', 'P'),
(135101, 'East Beaver Bay', 47.2677803039551, 0.824978396413342, -91.2827835083008, -1.59318512260503, 218, 28, 'PPL', 'P'),
(108996, 'East Beckley', 37.7691688537598, 0.659196352239801, -81.1722183227539, -1.41672247087972, 218, 58, 'PPL', 'P'),
(161016, 'East Beech', 41.0769386291504, 0.71692782571832, -77.5502777099609, -1.35350768187479, 218, 45, 'PPL', 'P'),
(148410, 'East Beekmantown', 44.752498626709, 0.781078449530312, -73.4705581665039, -1.2823031432835, 218, 40, 'PPL', 'P'),
(190147, 'East Belmont (historical)', 38.5825004577637, 0.673391666640195, -116.860282897949, -2.03959670138123, 218, 39, 'PPL', 'P'),
(196394, 'East Bench (historical)', 45.2416687011719, 0.789616077931916, -112.563888549805, -1.96461047404204, 218, 31, 'PPL', 'P'),
(2157, 'East Bend', 33.4013900756836, 0.582964231563637, -86.3466720581055, -1.50703372555373, 218, 2, 'PPL', 'P'),
(64340, 'East Bend', 36.2163887023926, 0.632095226038827, -80.5127792358398, -1.40521308759673, 218, 33, 'PPL', 'P'),
(148411, 'East Bennington', 42.8586082458496, 0.748023826712467, -78.3375015258789, -1.36724732941267, 218, 40, 'PPL', 'P'),
(127318, 'East Benton', 44.5833282470703, 0.778125869408769, -69.4722213745117, -1.21251900165961, 218, 26, 'PPL', 'P'),
(161017, 'East Benton', 41.5766716003418, 0.725649811446384, -75.6597213745117, -1.32051124912676, 218, 45, 'PPL', 'P'),
(148412, 'East Bergen', 43.1108283996582, 0.752425898836314, -77.9349975585938, -1.3602223099312, 218, 40, 'PPL', 'P'),
(148413, 'East Berkshire', 42.3063888549805, 0.738385780148443, -76.1438903808594, -1.32896159242364, 218, 40, 'PPL', 'P'),
(171926, 'East Berkshire', 44.9352798461914, 0.784268583621091, -72.709716796875, -1.26902395629809, 218, 55, 'PPL', 'P'),
(70767, 'East Berlin', 39.7972183227539, 0.694592492867071, -74.9155578613281, -1.3075231456485, 218, 37, 'PPL', 'P'),
(113211, 'East Berlin', 41.6183280944824, 0.726376854423976, -72.7141723632813, -1.26910172060192, 218, 8, 'PPL', 'P'),
(124678, 'East Berlin', 42.389720916748, 0.739840198998763, -71.5999984741211, -1.24965571779633, 218, 23, 'PPL', 'P'),
(161018, 'East Berlin', 41.5913887023926, 0.725906673333522, -75.0963897705078, -1.31067925785635, 218, 45, 'PPL', 'P'),
(93870, 'East Bernard', 29.5308303833008, 0.515410221036578, -96.0708312988281, -1.67675232129257, 218, 51, 'PPL', 'P'),
(148414, 'East Berne', 42.6163902282715, 0.743796324798075, -74.0749969482422, -1.29285259015158, 218, 40, 'PPL', 'P'),
(35681, 'East Bernstadt', 37.1894416809082, 0.649078204310263, -84.1177825927734, -1.46813226572067, 218, 21, 'PPL', 'P'),
(161019, 'East Berwick', 41.061939239502, 0.716666036983166, -76.2227783203125, -1.33033844670721, 218, 45, 'PPL', 'P'),
(148415, 'East Bethany', 42.9313888549805, 0.749294087973408, -78.1016693115234, -1.3631312807899, 218, 40, 'PPL', 'P'),
(127319, 'East Bethel', 44.4669418334961, 0.776094543287311, -70.7138900756836, -1.23419020871402, 218, 26, 'PPL', 'P'),
(135102, 'East Bethel', 45.3194389343262, 0.790973424560502, -93.2022171020508, -1.62668555858935, 218, 28, 'PPL', 'P'),
(171927, 'East Bethel', 43.8733291625977, 0.765734047698576, -72.584716796875, -1.2668422947331, 218, 55, 'PPL', 'P'),
(181258, 'East Biggs', 39.4152793884277, 0.687926400921521, -121.652778625488, -2.12324153121455, 218, 6, 'PPL', 'P'),
(124679, 'East Billerica', 42.5813903808594, 0.743185462223038, -71.2375030517578, -1.24332897915268, 218, 23, 'PPL', 'P'),
(64342, 'East Biltmore', 35.5586090087891, 0.620614804632686, -82.5197219848633, -1.44024084646621, 218, 33, 'PPL', 'P'),
(2158, 'East Birmingham', 33.5441703796387, 0.585456217974651, -86.7819366455078, -1.51463052572123, 218, 2, 'PPL', 'P'),
(124680, 'East Blackstone', 42.0416717529297, 0.733765595131319, -71.5124969482422, -1.24812852806922, 218, 23, 'PPL', 'P'),
(148416, 'East Bloomfield', 42.8950004577637, 0.748658990632451, -77.4349975585938, -1.35149566367123, 218, 40, 'PPL', 'P'),
(161020, 'East Bloomsburg', 40.9905586242676, 0.715420210225227, -76.4352798461914, -1.33404729799931, 218, 45, 'PPL', 'P'),
(127320, 'East Blue Hill', 44.4174995422363, 0.775231612515098, -68.523063659668, -1.19595307441488, 218, 26, 'PPL', 'P'),
(181257, 'East Blythe', 33.6105613708496, 0.586614959364945, -114.573059082031, -1.99967711506344, 218, 6, 'PPL', 'P'),
(124681, 'East Bolton', 42.4458312988281, 0.740819509910612, -71.5625, -1.24900124595844, 218, 23, 'PPL', 'P'),
(54527, 'East Bonne Terre', 37.9211082458496, 0.661848194895247, -90.5274963378906, -1.5800028746833, 218, 29, 'PPL', 'P'),
(127321, 'East Boothbay', 43.8650016784668, 0.765588705682085, -69.5869369506836, -1.21452116616713, 218, 26, 'PPL', 'P'),
(124682, 'East Boston', 42.375, 0.739583270532597, -71.0397186279297, -1.23987698974772, 218, 23, 'PPL', 'P'),
(148418, 'East Boston', 43.0833282470703, 0.751945930628854, -75.8177795410156, -1.32326988454192, 218, 40, 'PPL', 'P'),
(124683, 'East Boxford', 42.6916694641113, 0.745110195321866, -70.9805603027344, -1.2388444821931, 218, 23, 'PPL', 'P'),
(20746, 'East Boxwood Estates', 34.2138900756836, 0.597145031736091, -84.7472229003906, -1.47911807153336, 218, 13, 'PPL', 'P'),
(2159, 'East Boyles', 33.5666694641113, 0.585848901077383, -86.7844390869141, -1.51467420156311, 218, 2, 'PPL', 'P'),
(148419, 'East Boylston', 43.690559387207, 0.762544113344879, -75.9300003051758, -1.32522850636562, 218, 40, 'PPL', 'P'),
(20745, 'East Boynton', 34.9255599975586, 0.60956601506022, -85.1722183227539, -1.4865356409595, 218, 13, 'PPL', 'P'),
(161021, 'East Brady', 40.9858283996582, 0.715337652231434, -79.6133270263672, -1.38951468507709, 218, 45, 'PPL', 'P'),
(86662, 'East Brainerd', 34.9958305358887, 0.610792467321229, -85.1502838134766, -1.4861528115528, 218, 50, 'PPL', 'P'),
(124684, 'East Braintree', 42.2249984741211, 0.736965250022995, -70.9749984741211, -1.23874740997136, 218, 23, 'PPL', 'P'),
(171928, 'East Braintree', 43.9958305358887, 0.767872100000719, -72.6519393920898, -1.26801555035134, 218, 55, 'PPL', 'P'),
(148420, 'East Branch', 41.9883308410645, 0.732834620593255, -75.1341705322266, -1.31133865654225, 218, 40, 'PPL', 'P'),
(161024, 'East Branch', 41.7986106872559, 0.729523379251905, -79.565559387207, -1.38868098249784, 218, 45, 'PPL', 'P'),
(207260, 'East Bremerton', 47.5980606079102, 0.830742875171846, -122.628326416016, -2.14026805216981, 218, 56, 'PPL', 'P'),
(148421, 'East Brentwood', 40.7919387817383, 0.711953640013298, -73.2316665649414, -1.27813369828087, 218, 40, 'PPL', 'P'),
(124688, 'East Brewster', 41.7680587768555, 0.728990147822643, -70.0602798461914, -1.22278255818467, 218, 23, 'PPL', 'P'),
(2160, 'East Brewton', 31.0930595397949, 0.542676263488054, -87.0627822875977, -1.51953220686558, 218, 2, 'PPL', 'P'),
(113221, 'East Bridgeport', 41.1741714477539, 0.718624858543946, -73.1808319091797, -1.27724646616371, 218, 8, 'PPL', 'P'),
(124685, 'East Bridgewater', 42.0333290100098, 0.733619986798719, -70.959716796875, -1.23848069438819, 218, 23, 'PPL', 'P'),
(2161, 'East Brighton', 33.436939239502, 0.583584681518598, -86.9516677856445, -1.51759289295978, 218, 2, 'PPL', 'P'),
(171929, 'East Brighton', 44.785831451416, 0.78166021707044, -71.807502746582, -1.25327735056273, 218, 55, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(29683, 'East Brightwood (historical)', 39.7975006103516, 0.694597419715088, -86.0669403076172, -1.50215148548534, 218, 19, 'PPL', 'P'),
(124687, 'East Brimfield', 42.1111106872559, 0.734977533164387, -72.1488876342773, -1.25923564086956, 218, 23, 'PPL', 'P'),
(113223, 'East Bristol', 41.666389465332, 0.727215683588324, -72.9122161865234, -1.27255823738074, 218, 8, 'PPL', 'P'),
(173902, 'East Bristol', 43.2683296203613, 0.755174813713493, -89.1524963378906, -1.55600459746838, 218, 57, 'PPL', 'P'),
(64343, 'East Brook', 35.7986106872559, 0.624803624132245, -80.8352813720703, -1.41084181171867, 218, 33, 'PPL', 'P'),
(101592, 'East Brook', 37.3713912963867, 0.6522538241731, -79.1033325195313, -1.38061360176572, 218, 53, 'PPL', 'P'),
(124689, 'East Brookfield', 42.2277793884277, 0.737013786133861, -72.0472183227539, -1.25746117663524, 218, 23, 'PPL', 'P'),
(155067, 'East Brookfield', 40.795280456543, 0.71201196324117, -81.5550003051758, -1.4234032767903, 218, 41, 'PPL', 'P'),
(171930, 'East Brookfield', 44.0275001525879, 0.768424839084965, -72.5719375610352, -1.26661925499181, 218, 55, 'PPL', 'P'),
(46758, 'East Brooklyn', 39.2294387817383, 0.684682870450886, -76.5769424438477, -1.33651977675533, 218, 25, 'PPL', 'P'),
(113226, 'East Brooklyn', 41.7966690063477, 0.729489490527033, -71.8977813720703, -1.25485300982167, 218, 8, 'PPL', 'P'),
(119441, 'East Brooklyn', 41.1733283996582, 0.718610144578923, -88.2638931274414, -1.54049554570225, 218, 18, 'PPL', 'P'),
(2162, 'East Brookwood', 33.2775001525879, 0.580801944495574, -87.290283203125, -1.52350284689283, 218, 2, 'PPL', 'P'),
(127322, 'East Brownfield', 43.9447212219238, 0.766980074193597, -70.8888931274414, -1.23724458816823, 218, 26, 'PPL', 'P'),
(171931, 'East Brownington', 44.8008308410645, 0.781922005805595, -72.0861129760742, -1.2581400163971, 218, 55, 'PPL', 'P'),
(145115, 'East Brunswick', 40.4277801513672, 0.705597872913769, -74.416389465332, -1.29881101361647, 218, 37, 'PPL', 'P'),
(127323, 'East Buckfield', 44.2941703796387, 0.773079112564041, -70.3258285522461, -1.22741725742973, 218, 26, 'PPL', 'P'),
(127324, 'East Bucksport', 44.6744384765625, 0.779716042895655, -68.7024993896484, -1.19908481869876, 218, 26, 'PPL', 'P'),
(93871, 'East Buena Vista Addition Colonia', 27.7469997406006, 0.484276503023493, -98.0640029907227, -1.71153972987368, 218, 51, 'PPL', 'P'),
(171932, 'East Burke', 44.589168548584, 0.778227801899492, -71.9408264160156, -1.25560428756518, 218, 55, 'PPL', 'P'),
(145117, 'East Burlington', 40.0788917541504, 0.69950862166033, -74.8383331298828, -1.30617531982081, 218, 37, 'PPL', 'P'),
(148422, 'East Buskirk', 42.9444389343262, 0.749521854825637, -73.434440612793, -1.28167277305348, 218, 40, 'PPL', 'P'),
(161027, 'East Butler', 40.8777809143066, 0.713451867863549, -79.8466720581055, -1.3935873241741, 218, 45, 'PPL', 'P'),
(196395, 'East Butte', 46.0113906860352, 0.803050260892766, -112.495826721191, -1.96342257103781, 218, 31, 'PPL', 'P'),
(171933, 'East Cabot', 44.389720916748, 0.774746784038649, -72.2516708374023, -1.26102954617984, 218, 55, 'PPL', 'P'),
(155068, 'East Cadiz', 40.3036117553711, 0.703430725576717, -80.9491729736328, -1.4128295951563, 218, 41, 'PPL', 'P'),
(171934, 'East Calais', 44.3663902282715, 0.774339586707976, -72.4302825927734, -1.26414690939383, 218, 55, 'PPL', 'P'),
(124691, 'East Cambridge', 42.3666687011719, 0.739437861937079, -71.0805587768555, -1.24058978481348, 218, 23, 'PPL', 'P'),
(155069, 'East Cambridge', 40.0149993896484, 0.698393489532887, -81.5627822875977, -1.42353909800589, 218, 41, 'PPL', 'P'),
(274, 'East Camden', 33.607780456543, 0.586566423254078, -92.7399978637695, -1.61861831101529, 218, 4, 'PPL', 'P'),
(70768, 'East Camden', 39.9527816772461, 0.697307585598407, -75.101936340332, -1.31077606376197, 218, 37, 'PPL', 'P'),
(188461, 'East Camp (historical)', 32.8411102294922, 0.573185503515029, -108.928886413574, -1.90116771844779, 218, 38, 'PPL', 'P'),
(148423, 'East Campbell', 42.2241706848145, 0.736950802374081, -77.1361083984375, -1.34627906372798, 218, 40, 'PPL', 'P'),
(113228, 'East Canaan', 42.0133285522461, 0.733270912958837, -73.2841720581055, -1.27905009201197, 218, 8, 'PPL', 'P'),
(143746, 'East Candia', 43.0480613708496, 0.751330407521909, -71.2491683959961, -1.24353257781802, 218, 36, 'PPL', 'P'),
(93872, 'East Caney', 33.1316719055176, 0.578256761441785, -95.456672668457, -1.66603323106306, 218, 51, 'PPL', 'P'),
(186654, 'East Canon', 38.4527816772461, 0.671127646818492, -105.212501525879, -1.83630456588614, 218, 7, 'PPL', 'P'),
(115376, 'East Canton', 42.163890838623, 0.735898720585445, -90.8958282470703, -1.58643147923864, 218, 16, 'PPL', 'P'),
(155070, 'East Canton', 40.7872200012207, 0.711871281756587, -81.2827835083008, -1.4186521974056, 218, 41, 'PPL', 'P'),
(161031, 'East Canton', 41.6613883972168, 0.727128398483596, -76.795280456543, -1.34033049395913, 218, 45, 'PPL', 'P'),
(93873, 'East Cantu Country Estates Colonia', 26.2169990539551, 0.457572953483755, -97.8420028686523, -1.70766509680372, 218, 51, 'PPL', 'P'),
(93874, 'East Cantu Road Colonia', 26.2789993286133, 0.458655062413681, -97.8440017700195, -1.707699984214, 218, 51, 'PPL', 'P'),
(27024, 'East Cape Girardeau', 37.2958297729492, 0.650935026801293, -89.4961090087891, -1.56200176992713, 218, 18, 'PPL', 'P'),
(192546, 'East Carbon City', 39.547779083252, 0.690238956854091, -110.414169311523, -1.92709079534056, 218, 52, 'PPL', 'P'),
(155071, 'East Carmel', 40.7769393920898, 0.711691851278143, -80.6141662597656, -1.40698262498303, 218, 41, 'PPL', 'P'),
(161032, 'East Carnegie', 40.4155616760254, 0.705384620289481, -80.0755615234375, -1.39758219896727, 218, 45, 'PPL', 'P'),
(27025, 'East Carondelet', 38.5419387817383, 0.672683731843425, -90.232780456543, -1.57485911219587, 218, 18, 'PPL', 'P'),
(124692, 'East Carver', 41.9272193908691, 0.731768024576678, -70.7513885498047, -1.23484468055191, 218, 23, 'PPL', 'P'),
(207261, 'East Cathlamet', 46.1969413757324, 0.80628873135733, -123.365562438965, -2.15313524813458, 218, 56, 'PPL', 'P'),
(155072, 'East Center', 41.2527809143066, 0.719996852558528, -81.6347198486328, -1.42479464530181, 218, 41, 'PPL', 'P'),
(13077, 'East Central', 38.9000015258789, 0.678933105657405, -77.0124969482422, -1.34412163692891, 218, 9, 'PPL', 'P'),
(2163, 'East Centreville', 32.9438896179199, 0.574979342246279, -87.1355590820313, -1.52080240154749, 218, 2, 'PPL', 'P'),
(135104, 'East Chain', 43.5588912963867, 0.760246071640249, -94.3649978637695, -1.64697991136019, 218, 28, 'PPL', 'P'),
(2164, 'East Chapman', 31.6655597686768, 0.552668277450463, -86.6966705322266, -1.5131423513041, 218, 2, 'PPL', 'P'),
(124693, 'East Charlemont', 42.6222190856934, 0.743898057551716, -72.790283203125, -1.27043010535366, 218, 23, 'PPL', 'P'),
(161034, 'East Charleroi', 40.1391716003418, 0.700560703448966, -79.8883285522461, -1.39431436715169, 218, 45, 'PPL', 'P'),
(171935, 'East Charleston', 44.8380584716797, 0.782571750532547, -71.9899978637695, -1.25646249122646, 218, 55, 'PPL', 'P'),
(171936, 'East Charlotte', 44.3197212219238, 0.773525058888575, -73.1891708374023, -1.27739200791729, 218, 55, 'PPL', 'P'),
(148424, 'East Chatham', 42.4105606079102, 0.74020392022464, -73.5250015258789, -1.28325335916044, 218, 40, 'PPL', 'P'),
(86663, 'East Chattanooga', 35.0652809143066, 0.612004605091378, -85.2491683959961, -1.48787867309723, 218, 50, 'PPL', 'P'),
(207262, 'East Cheney', 47.4311103820801, 0.827829044044163, -117.508888244629, -2.05091700022683, 218, 56, 'PPL', 'P'),
(148425, 'East Chester', 41.3544387817383, 0.721771117055766, -74.2774963378906, -1.29638687123422, 218, 40, 'PPL', 'P'),
(122537, 'East Chicago', 41.6391716003418, 0.726740642228881, -87.454719543457, -1.52637280244156, 218, 19, 'PPL', 'P'),
(124694, 'East Chop', 41.4683303833008, 0.723758900493401, -70.5694427490234, -1.2316691272681, 218, 23, 'PPL', 'P'),
(148426, 'East Clarence', 43.0122184753418, 0.75070483098185, -78.5877838134766, -1.37161557939067, 218, 40, 'PPL', 'P'),
(171937, 'East Clarendon', 43.5247192382813, 0.759649656714126, -72.9394378662109, -1.27303334531921, 218, 55, 'PPL', 'P'),
(155073, 'East Claridon', 41.5325012207031, 0.724878892889834, -81.1158294677734, -1.41573829969889, 218, 41, 'PPL', 'P'),
(72375, 'East Clayton', 39.4544410705566, 0.68860990121529, -82.2705612182617, -1.43589217072222, 218, 41, 'PPL', 'P'),
(86664, 'East Cleveland', 35.160831451416, 0.613672276565986, -84.857780456543, -1.48104766490117, 218, 50, 'PPL', 'P'),
(155074, 'East Cleveland', 41.5330581665039, 0.724888613427812, -81.5791702270508, -1.42382512150697, 218, 41, 'PPL', 'P'),
(191411, 'East Clint Estates Colonia', 31.6049995422363, 0.551611302103325, -106.101997375488, -1.85182919714465, 218, 51, 'PPL', 'P'),
(119442, 'East Clinton', 41.8369407653809, 0.730192365317732, -90.1650009155273, -1.57367613603965, 218, 18, 'PPL', 'P'),
(148427, 'East Cobleskill', 42.6738891601563, 0.744799870475844, -74.3902816772461, -1.29835534675395, 218, 40, 'PPL', 'P'),
(148428, 'East Cochecton', 41.7152786254883, 0.728068960401585, -75.01611328125, -1.30927816880686, 218, 40, 'PPL', 'P'),
(148429, 'East Coldenham', 41.5194396972656, 0.724650926300523, -74.1091690063477, -1.2934490050777, 218, 40, 'PPL', 'P'),
(181259, 'East Colton Heights', 34.0483283996582, 0.594255435374327, -117.297218322754, -2.04722266316268, 218, 6, 'PPL', 'P'),
(93875, 'East Columbia', 29.1411094665527, 0.508608307875434, -95.6155624389648, -1.66880638070616, 218, 51, 'PPL', 'P'),
(29684, 'East Columbus', 39.2016716003418, 0.684198241711519, -85.9016723632813, -1.49926701570868, 218, 19, 'PPL', 'P'),
(72376, 'East Columbus', 39.9850006103516, 0.697869912062577, -82.9277801513672, -1.44736280501136, 218, 41, 'PPL', 'P'),
(196396, 'East Community', 48.0455589294434, 0.838553194279749, -111.473327636719, -1.94557659541513, 218, 31, 'PPL', 'P'),
(181260, 'East Compton', 33.8980598449707, 0.591632754332817, -118.194442749023, -2.0628821835304, 218, 6, 'PPL', 'P'),
(130575, 'East Comstock', 42.2861099243164, 0.738031846039572, -85.4897232055664, -1.49207714655574, 218, 27, 'PPL', 'P'),
(143747, 'East Concord', 43.2419395446777, 0.754714220002964, -71.5386123657227, -1.24858432808979, 218, 36, 'PPL', 'P'),
(148430, 'East Concord', 42.5519409179688, 0.742671472132653, -78.6405563354492, -1.37253663365368, 218, 40, 'PPL', 'P'),
(171938, 'East Concord', 44.4247207641602, 0.775357646613686, -71.7541732788086, -1.25234657576175, 218, 55, 'PPL', 'P'),
(161037, 'East Conemaugh', 40.3486099243164, 0.704216091782181, -78.8838882446289, -1.37678357664402, 218, 45, 'PPL', 'P'),
(155076, 'East Conneaut', 41.9397201538086, 0.731986204048983, -80.5449981689453, -1.4057754140609, 218, 41, 'PPL', 'P'),
(143748, 'East Conway', 44.0224990844727, 0.768337553980237, -71.0058288574219, -1.23928550166961, 218, 36, 'PPL', 'P'),
(59737, 'East Coongetto (historical)', 32.7041702270508, 0.570795449594738, -88.7958297729492, -1.54977959157837, 218, 30, 'PPL', 'P'),
(130576, 'East Cooper', 42.3494415283203, 0.739137191050009, -85.5516662597656, -1.49315825680025, 218, 27, 'PPL', 'P'),
(127327, 'East Corinth', 45.002498626709, 0.785441772660298, -69.024169921875, -1.20469902859276, 218, 26, 'PPL', 'P'),
(171939, 'East Corinth', 44.0638885498047, 0.769059936425921, -72.2227783203125, -1.26052527662743, 218, 55, 'PPL', 'P'),
(148431, 'East Corning', 42.125560760498, 0.735229734519617, -76.9866714477539, -1.34367089691442, 218, 40, 'PPL', 'P'),
(113235, 'East Cornwall', 41.8091697692871, 0.729707669999338, -73.3077774047852, -1.2794620830326, 218, 8, 'PPL', 'P'),
(135107, 'East Cottage Grove', 44.8416709899902, 0.782634800871355, -92.8813934326172, -1.62108612923941, 218, 28, 'PPL', 'P'),
(203782, 'East Cottonwood Heights', 40.6311111450195, 0.709146668224354, -111.826110839844, -1.95173382385539, 218, 52, 'PPL', 'P'),
(101593, 'East Courthouse Estates', 37.6783294677734, 0.657610905863849, -77.8752822875977, -1.3591800818386, 218, 53, 'PPL', 'P'),
(171940, 'East Craftsbury', 44.6425018310547, 0.779158643279502, -72.3436126708984, -1.26263423389467, 218, 55, 'PPL', 'P'),
(148432, 'East Creek', 43.0072212219238, 0.75061761245615, -74.7438888549805, -1.3045269562641, 218, 40, 'PPL', 'P'),
(155081, 'East Crestline', 40.7869415283203, 0.711866421487597, -82.7180633544922, -1.44370255640915, 218, 41, 'PPL', 'P'),
(115377, 'East Creston', 41.0583305358887, 0.716603053223385, -94.335563659668, -1.64646618758592, 218, 16, 'PPL', 'P'),
(20748, 'East Crisp', 31.9566707611084, 0.557749122757144, -83.6797180175781, -1.46048659654716, 218, 13, 'PPL', 'P'),
(207263, 'East Cromwell', 47.274169921875, 0.825089916283989, -122.603057861328, -2.13982703269329, 218, 56, 'PPL', 'P'),
(148447, 'East Cutchogue', 41.0275001525879, 0.716064961525135, -72.470832824707, -1.26485464445352, 218, 40, 'PPL', 'P'),
(86665, 'East Cyruston', 35.1569404602051, 0.613604365958189, -86.7152786254883, -1.51346712379903, 218, 50, 'PPL', 'P'),
(108997, 'East Dailey', 38.7802810668945, 0.676843589466129, -79.89111328125, -1.39436296984158, 218, 58, 'PPL', 'P'),
(72377, 'East Danville', 39.1158294677734, 0.682700013861268, -83.7191696166992, -1.461175156847, 218, 41, 'PPL', 'P'),
(155077, 'East Davis (historical)', 41.1380615234375, 0.717994621471979, -81.1125030517578, -1.41568024278712, 218, 41, 'PPL', 'P'),
(72378, 'East Dayton', 39.7666702270508, 0.694059328016837, -84.147216796875, -1.46864598949495, 218, 41, 'PPL', 'P'),
(130577, 'East Dayton', 43.410831451416, 0.757661939855518, -83.2852783203125, -1.45360232512931, 218, 27, 'PPL', 'P'),
(148433, 'East De Kalb', 44.4824981689453, 0.776366052560445, -75.3008270263672, -1.31424736108484, 218, 40, 'PPL', 'P'),
(124695, 'East Dedham', 42.25, 0.737401608967604, -71.158332824707, -1.24194719802109, 218, 23, 'PPL', 'P'),
(124696, 'East Deerfield', 42.5666694641113, 0.742928533756873, -72.5658264160156, -1.26651259539015, 218, 23, 'PPL', 'P'),
(127328, 'East Deering', 43.6819381713867, 0.762393644743289, -70.2566680908203, -1.22621017966565, 218, 26, 'PPL', 'P'),
(143749, 'East Deering', 43.0738906860352, 0.751781214115433, -71.813606262207, -1.25338387700633, 218, 36, 'PPL', 'P'),
(173903, 'East Delavan', 42.6088905334473, 0.743665430430498, -88.5605621337891, -1.54567339665163, 218, 57, 'PPL', 'P'),
(148434, 'East Delhi', 42.2988891601563, 0.738254885780866, -74.8791732788086, -1.30688811488657, 218, 40, 'PPL', 'P'),
(93876, 'East Delta', 33.3933296203613, 0.582823550079053, -95.5127792358398, -1.66701247539588, 218, 51, 'PPL', 'P'),
(127329, 'East Denmark', 43.9913902282715, 0.767794602012997, -70.774169921875, -1.23524229050266, 218, 26, 'PPL', 'P'),
(124697, 'East Dennis', 41.7425003051758, 0.728544068340055, -70.1624984741211, -1.22456660979891, 218, 23, 'PPL', 'P'),
(113236, 'East Derby', 41.3138885498047, 0.721063381996077, -73.0780563354492, -1.27545269401149, 218, 8, 'PPL', 'P'),
(143750, 'East Derry', 42.8944396972656, 0.748649203515445, -71.2916717529297, -1.24427440133966, 218, 36, 'PPL', 'P'),
(115378, 'East Des Moines', 41.5708312988281, 0.725547878955662, -93.5522232055664, -1.63279431749778, 218, 16, 'PPL', 'P'),
(130578, 'East DeWitt', 42.8541717529297, 0.747946395303773, -84.5430603027344, -1.47555476199483, 218, 27, 'PPL', 'P'),
(148435, 'East Dickinson', 44.7794418334961, 0.781548697199793, -74.4980621337891, -1.30023647058993, 218, 40, 'PPL', 'P'),
(86666, 'East Dickson', 36.0688896179199, 0.629520881371102, -87.3777770996094, -1.52502990346188, 218, 50, 'PPL', 'P'),
(93877, 'East Direct', 33.8162612915039, 0.590205100251453, -95.8070983886719, -1.67214931366448, 218, 51, 'PPL', 'P'),
(127330, 'East Dixfield', 44.5733299255371, 0.777951365778341, -70.3041687011719, -1.22703922171299, 218, 26, 'PPL', 'P'),
(127331, 'East Dixmont', 44.6705589294434, 0.77964833202494, -69.070556640625, -1.20550862956414, 218, 26, 'PPL', 'P'),
(171941, 'East Dorset', 43.2397193908691, 0.754675471009103, -73.0097198486328, -1.2742599973173, 218, 55, 'PPL', 'P'),
(20749, 'East Dougherty', 31.524169921875, 0.550200559094882, -83.9894409179688, -1.4658922809278, 218, 13, 'PPL', 'P'),
(124698, 'East Douglas', 42.0722198486328, 0.734298759981553, -71.7138900756836, -1.25164350123396, 218, 23, 'PPL', 'P'),
(124699, 'East Douglas Station', 42.0611114501953, 0.734104881854195, -71.710563659668, -1.2515854443222, 218, 23, 'PPL', 'P'),
(127332, 'East Dover', 45.1866683959961, 0.788656141516997, -69.1705627441406, -1.20725406534258, 218, 26, 'PPL', 'P'),
(171942, 'East Dover', 42.9511108398438, 0.7496383015443, -72.7694396972656, -1.27006631754875, 218, 55, 'PPL', 'P'),
(20750, 'East Dublin', 32.5480613708496, 0.568070836062505, -82.871940612793, -1.44638822121044, 218, 13, 'PPL', 'P'),
(119444, 'East Dubuque', 42.4922218322754, 0.741629177461023, -90.6427764892578, -1.58201489288686, 218, 18, 'PPL', 'P'),
(171943, 'East Dummerston', 42.9322204589844, 0.749308602201349, -72.5536117553711, -1.26629940934489, 218, 55, 'PPL', 'P'),
(119443, 'East Dundee', 42.0988883972168, 0.734764213961072, -88.2713928222656, -1.54062644006982, 218, 18, 'PPL', 'P'),
(198224, 'East Dunseith', 48.8655586242676, 0.85286488881978, -100.016387939453, -1.7456152754954, 218, 34, 'PPL', 'P'),
(148436, 'East Durham', 42.372501373291, 0.739539661269747, -74.0961074829102, -1.29322103848839, 218, 40, 'PPL', 'P'),
(161042, 'East Earl', 40.1100006103516, 0.70005157362757, -76.0330581665039, -1.32702720536586, 218, 45, 'PPL', 'P'),
(127333, 'East Eddington', 44.7919387817383, 0.781766810093071, -68.5833282470703, -1.19700488988741, 218, 26, 'PPL', 'P'),
(148437, 'East Eden', 42.6666717529297, 0.744673902956284, -78.8277816772461, -1.3758043323112, 218, 40, 'PPL', 'P'),
(127334, 'East Edgecomb', 43.9438896179199, 0.766965559965656, -69.6002807617188, -1.21475405960446, 218, 26, 'PPL', 'P'),
(20751, 'East Edgewood', 32.482780456543, 0.566931469169142, -84.9186096191406, -1.48210933406973, 218, 13, 'PPL', 'P'),
(32290, 'East El Dorado', 37.8208312988281, 0.660098032005874, -96.8352813720703, -1.69009449203776, 218, 20, 'PPL', 'P'),
(148438, 'East Elba', 43.0588912963867, 0.751519425380278, -78.1388931274414, -1.36378095893782, 218, 40, 'PPL', 'P'),
(127335, 'East Eliot', 43.1505584716797, 0.753119319405143, -70.7627792358398, -1.23504348552728, 218, 26, 'PPL', 'P'),
(161044, 'East Elizabeth', 40.2750015258789, 0.702931382872327, -79.89111328125, -1.39436296984158, 218, 45, 'PPL', 'P'),
(20752, 'East Ellijay', 34.6838912963867, 0.605348100525753, -84.4727783203125, -1.47432810999674, 218, 13, 'PPL', 'P'),
(173904, 'East Ellsworth', 44.7341690063477, 0.780758537304367, -92.4677810668945, -1.61386723163058, 218, 57, 'PPL', 'P'),
(148439, 'East Elma', 42.8050003051758, 0.747088191642495, -78.5944366455078, -1.3717316932142, 218, 40, 'PPL', 'P'),
(148440, 'East Elmhurst', 40.7611083984375, 0.711415548315047, -73.8655624389648, -1.28919726839739, 218, 40, 'PPL', 'P'),
(148441, 'East Elmira', 42.0713882446289, 0.734284245753612, -76.7352828979492, -1.33928333901851, 218, 40, 'PPL', 'P'),
(190148, 'East Ely', 39.2550010681152, 0.685129016512502, -114.86833190918, -2.00483059808885, 218, 39, 'PPL', 'P'),
(660, 'East End', 37.6752815246582, 0.657557709221075, -91.0336074829102, -1.58883618054493, 218, 29, 'PPL', 'P'),
(8661, 'East End', 34.5505599975586, 0.603021030365241, -92.3408279418945, -1.61165148160364, 218, 4, 'PPL', 'P'),
(13078, 'East End', 38.8958282470703, 0.678860268201591, -77.0111083984375, -1.34409740216299, 218, 9, 'PPL', 'P'),
(20753, 'East End', 31.1436100006104, 0.543558535467684, -81.3752822875977, -1.4202666056584, 218, 13, 'PPL', 'P'),
(101594, 'East End', 38.0936088562012, 0.664858898507582, -76.8013916015625, -1.34043715356079, 218, 53, 'PPL', 'P'),
(127336, 'East End', 43.6650009155273, 0.762098033862291, -70.2480621337891, -1.22605997738017, 218, 26, 'PPL', 'P'),
(155078, 'East End', 40.6372184753418, 0.709253261246985, -80.5347213745117, -1.40559605016148, 218, 41, 'PPL', 'P'),
(161046, 'East End', 40.9136085510254, 0.714077178087499, -77.7536087036133, -1.35705647718537, 218, 45, 'PPL', 'P'),
(173905, 'East End', 46.7088890075684, 0.815223903130655, -92.0591735839844, -1.60673568570552, 218, 57, 'PPL', 'P'),
(196398, 'East End Colony', 48.749439239502, 0.85083822323023, -109.569442749023, -1.91234753554589, 218, 31, 'PPL', 'P'),
(141699, 'East End Tailer Court', 42.351390838623, 0.739171212932935, -97.7788925170898, -1.70656361337686, 218, 35, 'PPL', 'P'),
(171944, 'East Enosburg', 44.8630599975586, 0.783008109477157, -72.7366714477539, -1.26949440370466, 218, 55, 'PPL', 'P'),
(29685, 'East Enterprise', 38.8727798461914, 0.678457997718935, -84.9880599975586, -1.48332147183988, 218, 19, 'PPL', 'P'),
(59738, 'East Enterprise', 32.1722183227539, 0.561511137402503, -88.8083267211914, -1.54999770447165, 218, 30, 'PPL', 'P'),
(86667, 'East Etowah', 35.3230590820313, 0.616503682857931, -84.5180587768555, -1.47511840305022, 218, 50, 'PPL', 'P'),
(196397, 'East Evergreen Mobile Home Park', 48.2249984741211, 0.841685005142655, -114.275001525879, -1.99447502934813, 218, 31, 'PPL', 'P'),
(127337, 'East Exeter', 44.9608306884766, 0.784714529945625, -69.101936340332, -1.20605630864231, 218, 26, 'PPL', 'P'),
(78165, 'East Fairchance', 39.8216705322266, 0.695019264431756, -79.7408294677734, -1.39174002248396, 218, 45, 'PPL', 'P'),
(155079, 'East Fairfield', 40.8219413757324, 0.712477284062634, -80.6363906860352, -1.4073705143958, 218, 41, 'PPL', 'P'),
(171945, 'East Fairfield', 44.7844390869141, 0.781635915725493, -72.85888671875, -1.27162746257976, 218, 55, 'PPL', 'P'),
(124700, 'East Fairhaven', 41.648609161377, 0.726905358742302, -70.8616714477539, -1.23676948022976, 218, 23, 'PPL', 'P'),
(32291, 'East Fairmount', 39.186939239502, 0.683941113508272, -94.9188919067383, -1.65664718611718, 218, 20, 'PPL', 'P'),
(198225, 'East Fairview', 47.853328704834, 0.835198143938467, -104.039169311523, -1.81582605552593, 218, 34, 'PPL', 'P'),
(161049, 'East Falls', 40.0144386291504, 0.698383702415881, -75.1919403076172, -1.31234692933096, 218, 45, 'PPL', 'P'),
(101596, 'East Falls Church', 38.8872184753418, 0.678709999337084, -77.1547164916992, -1.34660383622292, 218, 53, 'PPL', 'P'),
(113059, 'East Falmouth', 41.5783309936523, 0.725678773323239, -70.5591735839844, -1.23148989652674, 218, 23, 'PPL', 'P'),
(181261, 'East Farmersville', 36.3016700744629, 0.633583666772073, -119.193893432617, -2.08032588867042, 218, 6, 'PPL', 'P'),
(148442, 'East Farmingdale', 40.7291717529297, 0.710858148698894, -73.4172210693359, -1.28137223532446, 218, 40, 'PPL', 'P'),
(155080, 'East Farmington', 41.3908309936523, 0.72240628097575, -80.913330078125, -1.41220401861624, 218, 41, 'PPL', 'P'),
(173906, 'East Farmington', 45.253059387207, 0.78981488290729, -92.6972198486328, -1.61787169380368, 218, 57, 'PPL', 'P'),
(113240, 'East Farmington Heights', 41.7316703796387, 0.728355050481687, -72.7766723632813, -1.27019255138442, 218, 8, 'PPL', 'P'),
(113241, 'East Farms', 41.5461082458496, 0.725116380280041, -72.9830627441406, -1.27379474307486, 218, 8, 'PPL', 'P'),
(124701, 'East Farms', 42.1861114501953, 0.736286543419188, -72.7486114501953, -1.26970279605996, 218, 23, 'PPL', 'P'),
(207264, 'East Farms', 47.7075004577637, 0.832652960884678, -117.051391601563, -2.0429321774885, 218, 56, 'PPL', 'P'),
(64344, 'East Fayetteville', 35.0463905334473, 0.611674905748427, -78.8550033569336, -1.37627944024967, 218, 33, 'PPL', 'P'),
(78167, 'East Fayetteville', 39.9005584716797, 0.696396118715327, -77.5552825927734, -1.35359503355854, 218, 45, 'PPL', 'P'),
(161050, 'East Ferney', 41.1961097717285, 0.719007754529672, -77.5547180175781, -1.35358517986251, 218, 45, 'PPL', 'P'),
(161053, 'East Finley', 40.023609161377, 0.698543758397394, -80.3877792358398, -1.40303142603174, 218, 45, 'PPL', 'P'),
(148443, 'East Fishkill', 41.5533294677734, 0.725242414378629, -73.7961120605469, -1.28798513062724, 218, 40, 'PPL', 'P'),
(178125, 'East Flagstaff', 35.2113914489746, 0.614554714993184, -111.612503051758, -1.94800566464539, 218, 5, 'PPL', 'P'),
(64345, 'East Flat Rock', 35.2799987792969, 0.615752138798311, -82.4222183227539, -1.43853908652965, 218, 33, 'PPL', 'P'),
(148445, 'East Flatbush', 40.6536102294922, 0.709539351327086, -73.9308319091797, -1.29033643555367, 218, 40, 'PPL', 'P'),
(171946, 'East Fletcher', 44.7130584716797, 0.780390088967554, -72.8383331298828, -1.27126873478092, 218, 55, 'PPL', 'P'),
(2167, 'East Florence', 34.809440612793, 0.60753934947067, -87.6494369506836, -1.52977126230861, 218, 2, 'PPL', 'P'),
(148446, 'East Floyd', 43.2730598449707, 0.755257371707286, -75.2680587768555, -1.31367544724074, 218, 40, 'PPL', 'P'),
(161052, 'East Fogelsville', 40.5858306884766, 0.708356375170873, -75.6197204589844, -1.31981310144699, 218, 45, 'PPL', 'P'),
(181262, 'East Foothills', 37.3811111450195, 0.652423467534538, -121.816390991211, -2.12609710569339, 218, 6, 'PPL', 'P'),
(86668, 'East Forest', 35.6911087036133, 0.622927360565257, -83.9736099243164, -1.46561597796471, 218, 50, 'PPL', 'P'),
(124702, 'East Forest Park', 42.0972213745117, 0.734735118926162, -72.5374984741211, -1.26601817953378, 218, 23, 'PPL', 'P'),
(59739, 'East Fork', 31.2030601501465, 0.544596136317892, -90.668327331543, -1.58246083921139, 218, 30, 'PPL', 'P'),
(64347, 'East Fork', 35.1305618286133, 0.613143971984742, -82.7702789306641, -1.44461389013418, 218, 33, 'PPL', 'P'),
(86669, 'East Fork', 35.8450012207031, 0.625613291682656, -83.4175033569336, -1.45591008737191, 218, 50, 'PPL', 'P'),
(178126, 'East Fork', 33.7980613708496, 0.589887451712434, -109.929718017578, -1.91863552519567, 218, 5, 'PPL', 'P'),
(211803, 'East Fork', 64.6927795410156, 1.12910200525755, -164.276382446289, -2.86716375695316, 218, 1, 'PPL', 'P'),
(178127, 'East Fort', 34.1636085510254, 0.596267453577882, -112.254440307617, -1.95920958335136, 218, 5, 'PPL', 'P'),
(124703, 'East Foxboro', 42.0611114501953, 0.734104881854195, -71.2013931274414, -1.24269874208072, 218, 23, 'PPL', 'P'),
(148448, 'East Frankfort', 43.0227813720703, 0.750889188308311, -75.0563888549805, -1.30998111017659, 218, 40, 'PPL', 'P'),
(64349, 'East Franklin', 35.190559387207, 0.614191126925361, -83.3638916015625, -1.45497438572291, 218, 33, 'PPL', 'P'),
(127345, 'East Franklin', 44.5680618286133, 0.777859420141707, -68.1952819824219, -1.19023220491923, 218, 26, 'PPL', 'P'),
(161055, 'East Franklin', 40.6211090087891, 0.708972098014899, -76.4308319091797, -1.33396966685353, 218, 45, 'PPL', 'P'),
(171947, 'East Franklin', 44.9961090087891, 0.785330252789651, -72.8324966430664, -1.27116686886923, 218, 55, 'PPL', 'P'),
(161057, 'East Fredricktown', 40.0027809143066, 0.698180236908599, -79.9936065673828, -1.39615181514579, 218, 45, 'PPL', 'P'),
(143757, 'East Freedom', 43.7930603027344, 0.764333091807139, -70.9927825927734, -1.23905780139641, 218, 36, 'PPL', 'P'),
(161058, 'East Freedom', 40.3574981689453, 0.704371220915679, -78.4300003051758, -1.36886173766547, 218, 45, 'PPL', 'P'),
(145118, 'East Freehold', 40.2808303833008, 0.703033115625968, -74.2516708374023, -1.29593613121973, 218, 37, 'PPL', 'P'),
(124704, 'East Freetown', 41.7750015258789, 0.729111321652242, -70.9583282470703, -1.23845645962227, 218, 23, 'PPL', 'P'),
(148449, 'East Freetown', 42.5519409179688, 0.742671472132653, -75.9875030517578, -1.32623211862241, 218, 40, 'PPL', 'P'),
(12, 'East Fresnos Colonia', 26.1340007781982, 0.45612436029832, -97.4700012207031, -1.70117244322416, 218, 51, 'PPL', 'P'),
(127339, 'East Friendship', 44.0086097717285, 0.768095139742013, -69.2969436645508, -1.20945982851544, 218, 26, 'PPL', 'P'),
(113377, 'East Friesland', 43.600830078125, 0.760978041465858, -89.0469436645508, -1.55416235578432, 218, 57, 'PPL', 'P'),
(64350, 'East Fruitland (historical)', 36.0708312988281, 0.629554770095973, -81.1777801513672, -1.41681954310146, 218, 33, 'PPL', 'P'),
(127340, 'East Fryeburg', 44.0436096191406, 0.76870600231705, -70.873893737793, -1.23698279943308, 218, 26, 'PPL', 'P'),
(72379, 'East Fultonham', 39.8499984741211, 0.695513680288129, -82.1222229003906, -1.4333031786685, 218, 41, 'PPL', 'P'),
(2179, 'East Gadsden', 34.002498626709, 0.593455554940922, -85.9686126708984, -1.50043534447889, 218, 2, 'PPL', 'P'),
(80801, 'East Gaffney', 35.0800018310547, 0.612261533557544, -81.633056640625, -1.42476561684593, 218, 48, 'PPL', 'P'),
(148450, 'East Gaines', 43.2902793884277, 0.755557909436301, -78.1355590820313, -1.363722768868, 218, 40, 'PPL', 'P'),
(32292, 'East Galena', 37.0727806091309, 0.647042084498842, -94.6288909912109, -1.65158571530743, 218, 20, 'PPL', 'P'),
(119445, 'East Galesburg', 40.9477806091309, 0.714673593013623, -90.3099975585938, -1.5762068048655, 218, 18, 'PPL', 'P'),
(148451, 'East Galway', 43.0716705322266, 0.751742465121572, -73.9888916015625, -1.29134976834845, 218, 40, 'PPL', 'P'),
(80802, 'East Gantt', 34.7680587768555, 0.60681710018304, -82.3847198486328, -1.43788461469177, 218, 48, 'PPL', 'P'),
(148452, 'East Garden City', 40.7966690063477, 0.71203619800709, -73.7222213745117, -1.28669549486937, 218, 40, 'PPL', 'P'),
(155082, 'East Gardens', 41.6150016784668, 0.726318797512212, -83.4816665649414, -1.45702994661029, 218, 41, 'PPL', 'P'),
(200740, 'East Gardiner', 43.7200012207031, 0.76305797027721, -124.081108093262, -2.1656238757504, 218, 43, 'PPL', 'P'),
(124705, 'East Gardner', 42.5777816772461, 0.743122478463258, -71.9527816772461, -1.25581294623659, 218, 23, 'PPL', 'P'),
(181263, 'East Garrison', 36.6530609130859, 0.639716593867389, -121.731391906738, -2.12461359180816, 218, 6, 'PPL', 'P'),
(64351, 'East Gastonia', 35.2794418334961, 0.615742418260332, -81.1522216796875, -1.41637346361887, 218, 33, 'PPL', 'P'),
(101597, 'East Gate', 37.2919387817383, 0.650867116193496, -79.9155578613281, -1.39478960824821, 218, 53, 'PPL', 'P'),
(93878, 'East Gate Acres Colonia', 27.6749992370605, 0.483019857173625, -99.1959991455078, -1.73129678989459, 218, 51, 'PPL', 'P'),
(2168, 'East Gate Estates', 31.202220916748, 0.544581488931897, -85.3213882446289, -1.48913914724116, 218, 2, 'PPL', 'P'),
(15853, 'East Gate Park', 26.1563892364502, 0.456515112609262, -80.1969375610352, -1.39970061045637, 218, 12, 'PPL', 'P'),
(80803, 'East Gate Village', 34.8872184753418, 0.60889682925731, -82.2972183227539, -1.43635742496466, 218, 48, 'PPL', 'P'),
(148453, 'East Geneva', 42.8791694641113, 0.748382687669355, -76.9383316040039, -1.34282720748108, 218, 40, 'PPL', 'P'),
(148454, 'East Genoa', 42.6463890075684, 0.744319902268385, -76.5055618286133, -1.3352739499974, 218, 40, 'PPL', 'P'),
(40741, 'East Gentilly', 30.023889541626, 0.524015726756464, -89.9888916015625, -1.57060244866754, 218, 22, 'PPL', 'P'),
(171948, 'East Georgia', 44.6800003051758, 0.779813115117389, -73.083610534668, -1.27554963307517, 218, 55, 'PPL', 'P'),
(29686, 'East Germantown', 39.8125, 0.694859208450242, -85.1374969482422, -1.48592963865345, 218, 19, 'PPL', 'P'),
(130587, 'East Gilead', 41.7819404602051, 0.729232428902813, -85.0830612182617, -1.48497955593456, 218, 27, 'PPL', 'P'),
(27031, 'East Gillespie', 39.1408309936523, 0.683136372805877, -89.8122177124023, -1.56751890759939, 218, 18, 'PPL', 'P'),
(196400, 'East Glacier Park', 48.4413909912109, 0.84546176704255, -113.217216491699, -1.97601319772337, 218, 31, 'PPL', 'P'),
(196399, 'East Glacier Park Village', 48.4469413757324, 0.845558639527202, -113.222221374512, -1.97610054940713, 218, 31, 'PPL', 'P'),
(113273, 'East Glastonbury', 41.6941719055176, 0.7277005786438, -72.5341720581055, -1.26596012262201, 218, 8, 'PPL', 'P'),
(20754, 'East Glen', 33.6541709899902, 0.587376090804489, -84.2447204589844, -1.47034774943151, 218, 13, 'PPL', 'P'),
(29687, 'East Glenn', 39.4858283996582, 0.689157713451519, -87.2955627441406, -1.52359499226655, 218, 19, 'PPL', 'P'),
(148455, 'East Glenville', 42.8944396972656, 0.748649203515445, -73.9283294677734, -1.29029275971179, 218, 40, 'PPL', 'P'),
(124721, 'East Gloucester', 42.6111106872559, 0.743704179424359, -70.6486129760742, -1.23305090839969, 218, 23, 'PPL', 'P'),
(155083, 'East Goshen', 40.9449996948242, 0.714625056902756, -80.9705581665039, -1.41320283718308, 218, 41, 'PPL', 'P'),
(143751, 'East Grafton', 43.5686111450195, 0.760415715001687, -71.9280624389648, -1.25538151414, 218, 36, 'PPL', 'P'),
(148456, 'East Grafton', 42.7669410705566, 0.746423932687602, -73.4111099243164, -1.28126557572281, 218, 40, 'PPL', 'P'),
(113244, 'East Granby', 41.9411087036133, 0.732010438814902, -72.727783203125, -1.26933927457116, 218, 8, 'PPL', 'P'),
(135109, 'East Grand Forks', 47.9300003051758, 0.836536315807204, -97.024169921875, -1.69339121915117, 218, 28, 'PPL', 'P'),
(188462, 'East Grand Plains', 33.3355598449707, 0.581815277290349, -104.436943054199, -1.8227685170136, 218, 38, 'PPL', 'P'),
(130580, 'East Grand Rapids', 42.9411087036133, 0.749463731334846, -85.6100006103516, -1.49417638328499, 218, 27, 'PPL', 'P'),
(143752, 'East Grantham', 43.4866714477539, 0.758985597496315, -72.1183319091797, -1.25870234286127, 218, 36, 'PPL', 'P'),
(171949, 'East Granville', 44.0169410705566, 0.768240548337531, -72.7600021362305, -1.26990160103533, 218, 55, 'PPL', 'P'),
(127341, 'East Gray', 43.8888893127441, 0.766005623550737, -70.2941665649414, -1.22686465150354, 218, 26, 'PPL', 'P'),
(194866, 'East Greenacres', 47.752498626709, 0.833438327090142, -116.968887329102, -2.0414922062871, 218, 17, 'PPL', 'P'),
(148457, 'East Greenbush', 42.5908317565918, 0.743350245315487, -73.7022171020508, -1.28634635445046, 218, 40, 'PPL', 'P'),
(124706, 'East Greenfield', 42.5750007629395, 0.743073942352391, -72.5819396972656, -1.26679382520126, 218, 23, 'PPL', 'P'),
(171965, 'East Greensboro', 44.5713882446289, 0.77791747705347, -72.251106262207, -1.26101969248381, 218, 55, 'PPL', 'P'),
(148459, 'East Greenville', 42.4144401550293, 0.740271631095355, -73.9913864135742, -1.29139331103227, 218, 40, 'PPL', 'P'),
(155084, 'East Greenville', 40.7994384765625, 0.712084534380875, -81.6316680908203, -1.42474138208001, 218, 41, 'PPL', 'P'),
(161059, 'East Greenville', 40.4063911437988, 0.705224564307967, -75.5022201538086, -1.31776233424958, 218, 45, 'PPL', 'P'),
(148460, 'East Greenwich', 43.1455612182617, 0.753032100879443, -73.398063659668, -1.2810378754496, 218, 40, 'PPL', 'P'),
(169354, 'East Greenwich', 41.6602783203125, 0.727109023986666, -71.4563903808594, -1.2471492837364, 218, 47, 'PPL', 'P'),
(155085, 'East Greenwood', 40.0263900756836, 0.698592294508261, -81.9124984741211, -1.42964279690824, 218, 41, 'PPL', 'P'),
(181264, 'East Gridley', 39.3633308410645, 0.687019727728403, -121.660827636719, -2.12338201296205, 218, 6, 'PPL', 'P'),
(20755, 'East Griffin', 33.2436103820801, 0.580210456417467, -84.228889465332, -1.47007144646841, 218, 13, 'PPL', 'P'),
(124707, 'East Groton', 42.6416702270508, 0.744237544011674, -71.5, -1.24791041517595, 218, 23, 'PPL', 'P'),
(148461, 'East Groveland', 42.7405586242676, 0.745963472135127, -77.7591705322266, -1.35715354940711, 218, 40, 'PPL', 'P'),
(148462, 'East Guilford', 42.3408317565918, 0.738986922185501, -75.4072189331055, -1.3161042501549, 218, 40, 'PPL', 'P'),
(135111, 'East Gull Lake', 46.4080581665039, 0.809973414462536, -94.3555603027344, -1.64681519484677, 218, 28, 'PPL', 'P'),
(113252, 'East Haddam', 41.4530601501465, 0.723492384647311, -72.461669921875, -1.26469472163006, 218, 8, 'PPL', 'P'),
(124708, 'East Hadley', 42.3286094665527, 0.738773602982186, -72.5599975585938, -1.26641086263651, 218, 23, 'PPL', 'P'),
(72380, 'East Hamilton', 39.3841705322266, 0.687383448954281, -84.543327331543, -1.47555942252674, 218, 41, 'PPL', 'P'),
(93880, 'East Hamilton', 31.5958309173584, 0.551451279411324, -93.841667175293, -1.63784606776955, 218, 51, 'PPL', 'P'),
(148463, 'East Hamilton', 42.7991714477539, 0.746986458888854, -75.4658279418945, -1.3171271703296, 218, 40, 'PPL', 'P'),
(64352, 'East Hamlet', 34.8816719055176, 0.608800023351686, -79.6855621337891, -1.39077542553714, 218, 33, 'PPL', 'P'),
(127342, 'East Hampden', 44.7705612182617, 0.781393701224351, -68.7955627441406, -1.2007090806476, 218, 26, 'PPL', 'P'),
(143753, 'East Hampstead', 42.8911094665527, 0.748591080024654, -71.1436080932617, -1.2416902029759, 218, 36, 'PPL', 'P'),
(2169, 'East Hampton', 34.792781829834, 0.60724859885866, -86.9319381713867, -1.51724854623084, 218, 2, 'PPL', 'P'),
(101598, 'East Hampton', 37.0372200012207, 0.646421434806799, -76.3319396972656, -1.33224367215105, 218, 53, 'PPL', 'P'),
(113258, 'East Hampton', 41.5758285522461, 0.725635097481362, -72.503059387207, -1.26541710407574, 218, 8, 'PPL', 'P'),
(148464, 'East Hampton', 40.9633293151855, 0.714944969128702, -72.1852798461914, -1.25987080478955, 218, 40, 'PPL', 'P'),
(27029, 'East Hannibal', 39.7297210693359, 0.693414443558874, -91.350830078125, -1.59437275929315, 218, 18, 'PPL', 'P'),
(145119, 'East Hanover', 40.8199996948242, 0.712443395337763, -74.3652801513672, -1.29791898780934, 218, 37, 'PPL', 'P'),
(161061, 'East Hanover', 40.3974990844727, 0.705069368595443, -76.5922164916992, -1.33678635918045, 218, 45, 'PPL', 'P'),
(27030, 'East Hardin', 39.1599998474121, 0.683470932417818, -90.60888671875, -1.58142340480875, 218, 18, 'PPL', 'P'),
(171950, 'East Hardwick', 44.521671295166, 0.777049752591295, -72.3091735839844, -1.26203315843664, 218, 55, 'PPL', 'P'),
(127344, 'East Harpswell', 43.833610534668, 0.765040826866828, -69.8988876342773, -1.21996573269969, 218, 26, 'PPL', 'P'),
(113262, 'East Hartford', 41.7822189331055, 0.729237289171803, -72.6125030517578, -1.2673272563676, 218, 8, 'PPL', 'P'),
(148466, 'East Hartford', 43.334171295166, 0.756323967723862, -73.3836135864258, -1.28078567409437, 218, 40, 'PPL', 'P'),
(113263, 'East Hartford Gardens', 41.735279083252, 0.728418034241467, -72.6133270263672, -1.26734163743749, 218, 8, 'PPL', 'P'),
(113265, 'East Hartland', 41.9988899230957, 0.733018911340688, -72.9058303833008, -1.27244678408912, 218, 8, 'PPL', 'P'),
(124709, 'East Harwich', 41.7000007629395, 0.727802311397441, -70.0277786254883, -1.22221530487248, 218, 23, 'PPL', 'P'),
(148467, 'East Hauppauge', 40.8347206115723, 0.712700323803929, -73.1511077880859, -1.27672768238337, 218, 40, 'PPL', 'P'),
(2170, 'East Haven', 33.6230583190918, 0.586833072258222, -86.6838912963867, -1.5129193115628, 218, 2, 'PPL', 'P'),
(29688, 'East Haven', 39.839168548584, 0.695324662429761, -84.9308319091797, -1.48232265327305, 218, 19, 'PPL', 'P'),
(93879, 'East Haven', 29.639720916748, 0.517310719369485, -95.2522201538086, -1.66246486151846, 218, 51, 'PPL', 'P'),
(101599, 'East Haven', 36.8933296203613, 0.643910073898855, -76.2822189331055, -1.33137588110985, 218, 53, 'PPL', 'P'),
(113266, 'East Haven', 41.2761116027832, 0.720404049889201, -72.8688888549805, -1.27180203278921, 218, 8, 'PPL', 'P'),
(171951, 'East Haven', 44.6641693115234, 0.779536812154293, -71.8888931274414, -1.25469788068818, 218, 55, 'PPL', 'P'),
(143754, 'East Haverhill', 44.026668548584, 0.768410324857024, -71.9716720581055, -1.25614264557954, 218, 36, 'PPL', 'P'),
(119449, 'East Hazel Crest', 41.5736083984375, 0.725596348487501, -87.6463928222656, -1.52971813224486, 218, 18, 'PPL', 'P'),
(127349, 'East Hebron', 44.2244415283203, 0.771862114524903, -70.3188934326172, -1.22729621675819, 218, 26, 'PPL', 'P'),
(143755, 'East Hebron', 43.6933288574219, 0.762592449718664, -71.7699966430664, -1.25262274556679, 218, 36, 'PPL', 'P'),
(148468, 'East Hebron', 43.2616691589355, 0.755058566731911, -73.2869415283203, -1.27909842838575, 218, 40, 'PPL', 'P'),
(196401, 'East Helena', 46.5897216796875, 0.81314404089833, -111.91471862793, -1.9532803215004, 218, 31, 'PPL', 'P'),
(181265, 'East Hemet', 33.7400016784668, 0.588874118917659, -116.938056945801, -2.04095411458885, 218, 6, 'PPL', 'P'),
(148469, 'East Herkimer', 43.0302810668945, 0.751020082675888, -74.9644393920898, -1.3083762893037, 218, 40, 'PPL', 'P'),
(161065, 'East Herrick', 41.8055610656738, 0.729644686239558, -76.2172164916992, -1.33024137448547, 218, 45, 'PPL', 'P'),
(35682, 'East Hickman', 37.9233283996582, 0.661886943889108, -84.470832824707, -1.47429415469284, 218, 21, 'PPL', 'P'),
(161066, 'East Hickory', 41.5838890075684, 0.725775778965945, -79.4019393920898, -1.38582527486095, 218, 45, 'PPL', 'P'),
(171953, 'East Highgate', 44.9272193908691, 0.784127902136508, -72.9883270263672, -1.27388662213247, 218, 55, 'PPL', 'P'),
(130582, 'East Highland', 42.6549987792969, 0.744470171132893, -83.5716705322266, -1.45860081217928, 218, 27, 'PPL', 'P'),
(101602, 'East Highland Park', 37.5808296203613, 0.655909212506316, -77.4072189331055, -1.35101083519478, 218, 53, 'PPL', 'P'),
(20756, 'East Highlands', 32.478889465332, 0.566863558561345, -84.9719390869141, -1.48304010887071, 218, 13, 'PPL', 'P'),
(181266, 'East Highlands', 34.1097183227539, 0.595326891659894, -117.169723510742, -2.04499745891386, 218, 6, 'PPL', 'P'),
(86670, 'East Hill', 35.0647201538086, 0.611994817974373, -85.5752792358398, -1.49357038097894, 218, 50, 'PPL', 'P'),
(161067, 'East Hill', 41.3455581665039, 0.721616121080323, -77.3169403076172, -1.34943517593584, 218, 45, 'PPL', 'P'),
(207265, 'East Hill', 47.3863906860352, 0.827048538107688, -122.199172973633, -2.13277791160396, 218, 56, 'PPL', 'P'),
(148470, 'East Hills', 40.7936096191406, 0.711982801627234, -73.6275024414063, -1.2850423376227, 218, 40, 'PPL', 'P'),
(59740, 'East Hillsboro', 32.4524993896484, 0.566402964850815, -89.48388671875, -1.56178845072381, 218, 30, 'PPL', 'P'),
(148471, 'East Hillsdale', 42.1830596923828, 0.736233280197386, -73.5013885498047, -1.28284123498175, 218, 40, 'PPL', 'P'),
(127346, 'East Hiram', 43.8811111450195, 0.76586986891417, -70.7916717529297, -1.23554775507969, 218, 26, 'PPL', 'P'),
(127347, 'East Hodgdon', 46.0913887023926, 0.804446489673267, -67.8088912963867, -1.18348841524887, 218, 26, 'PPL', 'P'),
(40743, 'East Hodge', 32.2777786254883, 0.56335351224462, -92.7138900756836, -1.61816264415277, 218, 22, 'PPL', 'P'),
(127348, 'East Holden', 44.7374992370605, 0.780816660795158, -68.6336135864258, -1.19788253462464, 218, 26, 'PPL', 'P'),
(143756, 'East Holderness', 43.7166709899902, 0.762999846786419, -71.5313873291016, -1.24845822741217, 218, 36, 'PPL', 'P'),
(203784, 'East Holladay Condominium', 40.6666717529297, 0.709767317916397, -111.806938171387, -1.95139919766443, 218, 52, 'PPL', 'P'),
(124710, 'East Holliston', 42.2125015258789, 0.736747137129717, -71.4208297729492, -1.24652863404436, 218, 23, 'PPL', 'P'),
(148472, 'East Homer', 42.6661109924316, 0.744664115839278, -76.101936340332, -1.32822935628192, 218, 40, 'PPL', 'P'),
(161069, 'East Honesdale', 41.5627784729004, 0.725407330629133, -75.2474975585938, -1.31331658628386, 218, 45, 'PPL', 'P'),
(148473, 'East Hoosick', 42.9030609130859, 0.748799672117034, -73.2863922119141, -1.27908884100583, 218, 40, 'PPL', 'P'),
(194867, 'East Hope', 48.2419395446777, 0.841980682602681, -116.294441223145, -2.02972090111089, 218, 17, 'PPL', 'P'),
(207266, 'East Hoquiam', 46.9752807617188, 0.819873316340742, -123.864166259766, -2.16183752647058, 218, 56, 'PPL', 'P'),
(148474, 'East Hounsfield', 43.9713897705078, 0.767445528173115, -75.9863891601563, -1.32621267754646, 218, 40, 'PPL', 'P'),
(93881, 'East Houston', 29.829439163208, 0.520621927421322, -95.2697219848633, -1.66277032609549, 218, 51, 'PPL', 'P'),
(171954, 'East Hubbardton', 43.6930618286133, 0.762587789186756, -73.1386108398438, -1.27650956949009, 218, 55, 'PPL', 'P'),
(54534, 'East Independence', 39.0955581665039, 0.682346212910451, -94.3550033569336, -1.64680547430879, 218, 29, 'PPL', 'P'),
(115381, 'East Iron Hills', 42.1430587768555, 0.735535132517622, -90.7375030517578, -1.58366818329158, 218, 16, 'PPL', 'P'),
(2172, 'East Irondale', 33.5305595397949, 0.585218664005416, -86.6888885498047, -1.5130065300885, 218, 2, 'PPL', 'P'),
(181267, 'East Irvine', 33.6758308410645, 0.587754126521226, -117.758888244629, -2.05528032335682, 218, 6, 'PPL', 'P'),
(148475, 'East Irvington', 41.0475006103516, 0.716414035365017, -73.8491668701172, -1.28891111173826, 218, 40, 'PPL', 'P'),
(148476, 'East Islip', 40.7319412231445, 0.710906485072678, -73.1861114501953, -1.27733861153743, 218, 40, 'PPL', 'P'),
(148477, 'East Ithaca', 42.4394416809082, 0.740707990039965, -76.478889465332, -1.33480842943885, 218, 40, 'PPL', 'P'),
(171955, 'East Jamaica', 43.0738906860352, 0.751781214115433, -72.7352828979492, -1.26947016893874, 218, 55, 'PPL', 'P'),
(86671, 'East Jamestown', 36.4647216796875, 0.636429454133904, -84.8733291625977, -1.48131904101625, 218, 50, 'PPL', 'P'),
(148478, 'East Jefferson', 42.5038909912109, 0.741832842705387, -74.5802764892578, -1.30167138178527, 218, 40, 'PPL', 'P'),
(35686, 'East Jenkins', 37.1877784729004, 0.649049175854381, -82.6041717529297, -1.44171477297152, 218, 21, 'PPL', 'P'),
(161071, 'East Jermyn', 41.5255584716797, 0.724757719060235, -75.545280456543, -1.3185138783092, 218, 45, 'PPL', 'P'),
(75729, 'East Jesse', 34.5811080932617, 0.603554195215475, -96.5119400024414, -1.68445112052983, 218, 42, 'PPL', 'P'),
(148479, 'East Jewett', 42.2350006103516, 0.737139820232449, -74.1458282470703, -1.29408882952959, 218, 40, 'PPL', 'P'),
(171956, 'East Johnson', 44.6399993896484, 0.779114967437624, -72.6619415283203, -1.26819012056079, 218, 55, 'PPL', 'P'),
(119457, 'East Joliet', 41.5349998474121, 0.724922502152684, -88.0516662597656, -1.53679148810011, 218, 18, 'PPL', 'P'),
(54535, 'East Joplin', 37.083610534668, 0.647231102357211, -94.4861068725586, -1.64909366231739, 218, 29, 'PPL', 'P'),
(130583, 'East Jordan', 45.1580581665039, 0.788156798812607, -85.1241683959961, -1.48569701153223, 218, 27, 'PPL', 'P'),
(20757, 'East Juliette', 33.1086082458496, 0.57785422464302, -83.7925033569336, -1.46245507206689, 218, 13, 'PPL', 'P'),
(75731, 'East Junction', 35.5263900756836, 0.620052478168516, -98.9641723632813, -1.72725064925044, 218, 42, 'PPL', 'P'),
(86672, 'East Junction', 35.0755615234375, 0.612184035569823, -90.0516662597656, -1.57169807314, 218, 50, 'PPL', 'P'),
(124711, 'East Junction', 41.9083290100098, 0.731438325233726, -71.3083267211914, -1.24456508537264, 218, 23, 'PPL', 'P'),
(194868, 'East Kamiah', 46.2027816772461, 0.806390663848052, -116.006942749023, -2.02470310614302, 218, 17, 'PPL', 'P'),
(161075, 'East Kane', 41.6547203063965, 0.72701201834396, -78.7919387817383, -1.37517875577114, 218, 45, 'PPL', 'P'),
(171957, 'East Kansas', 43.0577812194824, 0.751500050883347, -73.1188888549805, -1.2761653559192, 218, 55, 'PPL', 'P'),
(54536, 'East Kansas City', 39.1599998474121, 0.683470932417818, -94.495002746582, -1.64924892460894, 218, 29, 'PPL', 'P'),
(145121, 'East Keansburg', 40.4388885498047, 0.705791751041127, -74.1172180175781, -1.2935894868252, 218, 37, 'PPL', 'P'),
(113270, 'East Kent', 41.7344398498535, 0.728403386855472, -73.404167175293, -1.28114440189321, 218, 8, 'PPL', 'P'),
(108999, 'East Kermit', 37.8136100769043, 0.659971997907286, -82.4008331298828, -1.43816584450288, 218, 58, 'PPL', 'P'),
(2173, 'East Killen', 34.8613891601563, 0.608446022663787, -87.5255584716797, -1.52760917497763, 218, 2, 'PPL', 'P'),
(113271, 'East Killingly', 41.8491706848145, 0.730405817679102, -71.8191680908203, -1.25348094922806, 218, 8, 'PPL', 'P'),
(148482, 'East Kilns', 44.4794387817383, 0.776312656180588, -73.7850036621094, -1.28779125249988, 218, 40, 'PPL', 'P'),
(130585, 'East Kingsford', 45.7949981689453, 0.79927349899287, -88.0644378662109, -1.53701439468335, 218, 27, 'PPL', 'P'),
(86673, 'East Kingsport', 36.5724983215332, 0.638310511390854, -82.521110534668, -1.44026508123213, 218, 50, 'PPL', 'P'),
(109000, 'East Kingston', 37.978328704834, 0.662846880304027, -81.2947235107422, -1.4188605897609, 218, 58, 'PPL', 'P'),
(143758, 'East Kingston', 42.9255599975586, 0.749192355219767, -71.017219543457, -1.23948430664499, 218, 36, 'PPL', 'P'),
(148480, 'East Kingston', 41.9538917541504, 0.732233545135224, -73.9683303833008, -1.29099090739156, 218, 40, 'PPL', 'P'),
(207267, 'East Kittitas', 46.9744415283203, 0.819858668954747, -120.363327026367, -2.10073635526478, 218, 56, 'PPL', 'P'),
(127350, 'East Knox', 44.5066719055176, 0.77678796385614, -69.2127838134766, -1.2079909620162, 218, 26, 'PPL', 'P'),
(148481, 'East Koy', 42.540828704834, 0.742477527426268, -78.1047210693359, -1.3631845440117, 218, 40, 'PPL', 'P'),
(173908, 'East Krok', 44.4288902282715, 0.775430417490472, -87.6022186279297, -1.52894714710928, 218, 57, 'PPL', 'P'),
(181268, 'East La Mirada', 33.9244384765625, 0.592093148306265, -117.988059997559, -2.05928012499801, 218, 6, 'PPL', 'P'),
(93882, 'East La Porte', 29.670560836792, 0.517848977515304, -95.0111083984375, -1.65825666752197, 218, 51, 'PPL', 'P'),
(194165, 'East La Salle', 40.3547210693359, 0.704322751383839, -104.681938171387, -1.82704448845983, 218, 7, 'PPL', 'P'),
(2174, 'East Lake', 33.5666694641113, 0.585848901077383, -86.7249984741211, -1.51363676716047, 218, 2, 'PPL', 'P'),
(15854, 'East Lake', 28.110559463501, 0.490621817215743, -82.6949996948242, -1.44330001961039, 218, 12, 'PPL', 'P'),
(20758, 'East Lake', 33.752498626709, 0.589092231810936, -84.304443359375, -1.47139011068216, 218, 13, 'PPL', 'P'),
(54537, 'East Lake', 36.8069381713867, 0.642402258668679, -89.5202789306641, -1.5624236146438, 218, 29, 'PPL', 'P'),
(64353, 'East Lake', 35.8911094665527, 0.626418032385051, -75.9630584716797, -1.32580548021578, 218, 33, 'PPL', 'P'),
(70770, 'East Lake', 39.6444396972656, 0.691926002825629, -75.3144378662109, -1.31448491505407, 218, 37, 'PPL', 'P'),
(80805, 'East Lake', 34.103889465332, 0.595225158906252, -81.2266693115234, -1.41767281991472, 218, 48, 'PPL', 'P'),
(86674, 'East Lake', 35.0052795410156, 0.610957383571732, -85.279167175293, -1.48840225056753, 218, 50, 'PPL', 'P'),
(130586, 'East Lake', 44.2444381713867, 0.772211121785757, -86.2961120605469, -1.50615128712653, 218, 27, 'PPL', 'P'),
(135114, 'East Lake', 46.538330078125, 0.812247088243191, -93.283332824707, -1.62810129502484, 218, 28, 'PPL', 'P'),
(86675, 'East Lake Estates', 36.1230583190918, 0.63046630355808, -85.4408264160156, -1.49122373658442, 218, 50, 'PPL', 'P'),
(122538, 'East Lake Estates', 41.6977806091309, 0.72776356240358, -85.9297180175781, -1.49975650471703, 218, 19, 'PPL', 'P'),
(135115, 'East Lake Francis Shores', 45.5038909912109, 0.794192720265217, -93.3236083984375, -1.62880423639457, 218, 28, 'PPL', 'P'),
(13697, 'East Lake Gardens', 39.1736106872559, 0.683708486387053, -75.5250015258789, -1.31815994420033, 218, 10, 'PPL', 'P'),
(64354, 'East Lake Landing', 35.8963890075684, 0.626510177758768, -75.9702835083008, -1.3259315808934, 218, 33, 'PPL', 'P'),
(127351, 'East Lamoine', 44.4647216796875, 0.77605579429345, -68.3169403076172, -1.19235554325635, 218, 26, 'PPL', 'P'),
(148483, 'East Lancaster', 42.8958282470703, 0.748673438281365, -78.6383285522461, -1.37249775150176, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(78171, 'East Lansdowne', 39.9455604553223, 0.697181551499819, -75.2616729736328, -1.31356399394912, 218, 45, 'PPL', 'P'),
(130588, 'East Lansing', 42.7369384765625, 0.745900288638265, -84.48388671875, -1.4745219881241, 218, 27, 'PPL', 'P'),
(148484, 'East Lansing', 42.5683288574219, 0.742957495633728, -76.4697189331055, -1.33464837345734, 218, 40, 'PPL', 'P'),
(64356, 'East Laport', 35.3016700744629, 0.616130374252129, -83.1505584716797, -1.45125102020287, 218, 33, 'PPL', 'P'),
(190150, 'East Las Vegas', 36.0944404602051, 0.629966827695636, -115.041107177734, -2.00784609539115, 218, 39, 'PPL', 'P'),
(188463, 'East Las Vegas (historical)', 35.5969390869141, 0.621283790698514, -105.199996948242, -1.83608631983481, 218, 38, 'PPL', 'P'),
(64357, 'East Laurinburg', 34.771110534668, 0.606870363404842, -79.4438934326172, -1.38655751100267, 218, 33, 'PPL', 'P'),
(155087, 'East Lawn', 41.5763893127441, 0.725644884598368, -83.4272232055664, -1.45607973073335, 218, 41, 'PPL', 'P'),
(161077, 'East Lawn', 40.7502784729004, 0.711226530456679, -75.2947235107422, -1.31414083464124, 218, 45, 'PPL', 'P'),
(141701, 'East Lawn Mobile Home Estates', 40.7055587768555, 0.710446024520204, -99.0569381713867, -1.72886971803515, 218, 35, 'PPL', 'P'),
(119451, 'East Lawndale', 40.5633316040039, 0.707963692068141, -90.022216796875, -1.57118408304961, 218, 18, 'PPL', 'P'),
(161078, 'East Lawrence', 41.9822196960449, 0.732727960991597, -77.0763931274414, -1.34523683563538, 218, 45, 'PPL', 'P'),
(203786, 'East Layton', 41.0811080932617, 0.717000596595107, -111.919166564941, -1.95335795264618, 218, 52, 'PPL', 'P'),
(101600, 'East Leake', 37.8105583190918, 0.659918734685485, -77.9497222900391, -1.3604793049764, 218, 53, 'PPL', 'P'),
(54538, 'East Leavenworth', 39.3144416809082, 0.686166450915142, -94.8516693115234, -1.65547393049895, 218, 29, 'PPL', 'P'),
(127352, 'East Lebanon', 43.4124984741211, 0.757691034890427, -70.8677825927734, -1.23687613983142, 218, 26, 'PPL', 'P'),
(124712, 'East Lee', 42.2972183227539, 0.738225724166929, -73.2249984741211, -1.27801731814124, 218, 23, 'PPL', 'P'),
(161079, 'East Lemon', 41.586109161377, 0.725814527959806, -75.8661117553711, -1.3241134408172, 218, 45, 'PPL', 'P'),
(143760, 'East Lempster', 43.2249984741211, 0.754418542542938, -72.1788864135742, -1.25975921833987, 218, 36, 'PPL', 'P'),
(161080, 'East Lenox', 41.7005615234375, 0.727812098514447, -75.6438903808594, -1.32023494616366, 218, 45, 'PPL', 'P'),
(148485, 'East Leon', 42.3472213745117, 0.739098442056148, -78.9580612182617, -1.37807813924991, 218, 40, 'PPL', 'P'),
(130590, 'East Leroy', 42.1661109924316, 0.735937469579306, -85.2174987792969, -1.48732593401298, 218, 27, 'PPL', 'P'),
(72381, 'East Letart', 38.9061088562012, 0.679039698680036, -81.8836135864258, -1.42913866051389, 218, 41, 'PPL', 'P'),
(124713, 'East Leverett', 42.4397201538086, 0.740712850308954, -72.4805603027344, -1.26502442097301, 218, 23, 'PPL', 'P'),
(161081, 'East Lewisburg', 40.9688911437988, 0.715042041350435, -76.871940612793, -1.34166846609078, 218, 45, 'PPL', 'P'),
(155088, 'East Lewistown', 40.9441719055176, 0.714610609253842, -80.6986083984375, -1.40845641833028, 218, 41, 'PPL', 'P'),
(101601, 'East Lexington', 37.792781829834, 0.65960847641849, -79.4255599975586, -1.3862375321977, 218, 53, 'PPL', 'P'),
(124714, 'East Lexington', 42.4272193908691, 0.74049467083665, -71.2041702270508, -1.24274721161255, 218, 23, 'PPL', 'P'),
(93884, 'East Liberty', 31.6411094665527, 0.552241539175292, -94.0236129760742, -1.64102162105336, 218, 51, 'PPL', 'P'),
(122539, 'East Liberty', 40.9355583190918, 0.714460273810307, -84.8616714477539, -1.48111557550897, 218, 19, 'PPL', 'P'),
(155091, 'East Liberty', 40.9749984741211, 0.715148634373066, -81.4930572509766, -1.42232216654578, 218, 41, 'PPL', 'P'),
(161082, 'East Liberty', 40.4605598449707, 0.706169986494945, -79.9230575561523, -1.39492050261579, 218, 45, 'PPL', 'P'),
(2176, 'East Limestone', 34.7808303833008, 0.60704000676628, -86.8327789306641, -1.51551789099645, 218, 2, 'PPL', 'P'),
(127353, 'East Limington', 43.7338905334473, 0.763300384515434, -70.658332824707, -1.23322055176112, 218, 26, 'PPL', 'P'),
(699, 'East Lincoln', 31.4850006103516, 0.549516925643059, -90.2919387817383, -1.57589161975049, 218, 30, 'PPL', 'P'),
(155092, 'East Linden', 40.0166702270508, 0.698422651146823, -82.9499969482422, -1.44775056126607, 218, 41, 'PPL', 'P'),
(148491, 'East Lindley', 42.0447196960449, 0.733818791774093, -77.0983276367188, -1.34561966504208, 218, 40, 'PPL', 'P'),
(148486, 'East Line', 42.9713897705078, 0.749992235653172, -73.8311080932617, -1.28859592662325, 218, 40, 'PPL', 'P'),
(113276, 'East Litchfield', 41.7619400024414, 0.728883355062931, -73.1188888549805, -1.2761653559192, 218, 8, 'PPL', 'P'),
(124715, 'East Littleton', 42.560001373291, 0.742812153617237, -71.4541702270508, -1.24711053474254, 218, 23, 'PPL', 'P'),
(127354, 'East Livermore', 44.4130592346191, 0.775154114527377, -70.1444396972656, -1.2242514246839, 218, 26, 'PPL', 'P'),
(155093, 'East Liverpool', 40.6186103820801, 0.708928488752049, -80.5774993896484, -1.40634266737309, 218, 41, 'PPL', 'P'),
(145122, 'East Long Branch', 40.3133316040039, 0.703600368938155, -73.9783325195313, -1.29116547760101, 218, 37, 'PPL', 'P'),
(124716, 'East Longmeadow', 42.0644416809082, 0.734163005344986, -72.5130615234375, -1.2655916742852, 218, 23, 'PPL', 'P'),
(181269, 'East Los Angeles', 34.0238914489746, 0.593828930125751, -118.171112060547, -2.06247498619972, 218, 6, 'PPL', 'P'),
(127355, 'East Lowell', 45.2050018310547, 0.78897612032197, -68.45361328125, -1.19474093664473, 218, 26, 'PPL', 'P'),
(64358, 'East Lumberton', 34.610279083252, 0.604063325036871, -78.9925003051758, -1.37867921470794, 218, 33, 'PPL', 'P'),
(127356, 'East Lyndon', 46.8325004577637, 0.817381329929728, -67.9397201538086, -1.18577180956751, 218, 26, 'PPL', 'P'),
(171958, 'East Lyndon', 44.519718170166, 0.777015664129342, -71.9583282470703, -1.25590975214222, 218, 55, 'PPL', 'P'),
(109001, 'East Lynn', 38.167781829834, 0.666153461113469, -82.378059387207, -1.43776836771019, 218, 58, 'PPL', 'P'),
(119453, 'East Lynn', 40.4663887023926, 0.706271719248586, -87.8000030517578, -1.53239913651424, 218, 18, 'PPL', 'P'),
(124718, 'East Lynn', 42.4694404602051, 0.741231567510274, -70.9277801513672, -1.23792329477204, 218, 23, 'PPL', 'P'),
(161083, 'East Lynn', 41.6588897705078, 0.727084789220746, -75.9000015258789, -1.32470492889531, 218, 45, 'PPL', 'P'),
(54539, 'East Lynne', 38.6683311462402, 0.674889694753365, -94.2291717529297, -1.64460929851586, 218, 29, 'PPL', 'P'),
(59742, 'East Macedonia', 33.0155601501465, 0.57623022901029, -89.345832824707, -1.55937895572756, 218, 30, 'PPL', 'P'),
(127357, 'East Machias', 44.7391700744629, 0.780845822409094, -67.3905563354492, -1.17618709280431, 218, 26, 'PPL', 'P'),
(20761, 'East Macon', 32.836669921875, 0.573108005527308, -83.5602798461914, -1.4584020072039, 218, 13, 'PPL', 'P'),
(127359, 'East Madison', 44.8494415283203, 0.782770422349867, -69.7569427490234, -1.21748832709564, 218, 26, 'PPL', 'P'),
(143761, 'East Madison', 43.8605613708496, 0.765511207694363, -71.0886077880859, -1.24073026656098, 218, 36, 'PPL', 'P'),
(72382, 'East Madisonville', 39.1616706848145, 0.683500094031755, -84.3819427490234, -1.47274273019981, 218, 41, 'PPL', 'P'),
(127360, 'East Madrid', 44.9105606079102, 0.783837151524498, -70.3847198486328, -1.22844510445245, 218, 26, 'PPL', 'P'),
(161084, 'East Mahanoy Junction', 40.8113899230957, 0.712293126473255, -76.043327331543, -1.32720643610722, 218, 45, 'PPL', 'P'),
(148487, 'East Maine', 42.1919403076172, 0.736388276172829, -75.9933319091797, -1.32633385137605, 218, 40, 'PPL', 'P'),
(196402, 'East Malta Colony', 48.3516693115234, 0.843895828321584, -107.608612060547, -1.87812458395782, 218, 31, 'PPL', 'P'),
(155095, 'East Mandale', 41.023609161377, 0.715997050917338, -84.3424987792969, -1.47205430305803, 218, 41, 'PPL', 'P'),
(15855, 'East Mandarin', 30.1530609130859, 0.526270192487757, -81.6413879394531, -1.42491102544145, 218, 12, 'PPL', 'P'),
(86676, 'East Manor', 36.2649993896484, 0.632943642583099, -83.2127838134766, -1.45233705729541, 218, 50, 'PPL', 'P'),
(124719, 'East Mansfield', 42.0230598449707, 0.733440756057357, -71.1777801513672, -1.24228661790203, 218, 23, 'PPL', 'P'),
(155096, 'East Mansfield', 40.7580604553223, 0.711362351672273, -82.4894409179688, -1.43971234214789, 218, 41, 'PPL', 'P'),
(207271, 'East Marcus', 48.6686096191406, 0.849427480221787, -118.043891906738, -2.06025457564087, 218, 56, 'PPL', 'P'),
(161087, 'East Marianna', 40.021671295166, 0.69850993625155, -80.0936126708984, -1.39789725092423, 218, 45, 'PPL', 'P'),
(64359, 'East Marion', 35.6841697692871, 0.622806253314685, -81.991943359375, -1.43102937172979, 218, 33, 'PPL', 'P'),
(124720, 'East Marion', 41.7125015258789, 0.728020490869746, -70.7458267211914, -1.23474760833017, 218, 23, 'PPL', 'P'),
(148488, 'East Marion', 41.127498626709, 0.717810264145518, -72.3405609130859, -1.26258097067287, 218, 40, 'PPL', 'P'),
(148489, 'East Martinsburg', 43.7447204589844, 0.763489402373802, -75.4277801513672, -1.31646311111178, 218, 40, 'PPL', 'P'),
(148490, 'East Masonville', 42.2636108398438, 0.737639162936839, -75.3027801513672, -1.31428144954679, 218, 40, 'PPL', 'P'),
(148494, 'East Massapequa', 40.6733283996582, 0.709883498318952, -73.4369430541992, -1.28171644889536, 218, 40, 'PPL', 'P'),
(200741, 'East Maupin', 45.1722183227539, 0.788403940161766, -121.073890686035, -2.11313803067101, 218, 43, 'PPL', 'P'),
(15856, 'East Mayport', 30.3794403076172, 0.530221258280999, -81.4072189331055, -1.42082400527456, 218, 12, 'PPL', 'P'),
(15857, 'East Mayport (historical)', 30.3805599212646, 0.530240799225497, -81.408332824707, -1.42084344635051, 218, 12, 'PPL', 'P'),
(148492, 'East McDonough', 42.4972190856934, 0.741716395986723, -75.6858291625977, -1.32096691598927, 218, 40, 'PPL', 'P'),
(35683, 'East McDowell', 37.4474983215332, 0.653582142345805, -82.7252807617188, -1.44382852392872, 218, 21, 'PPL', 'P'),
(161088, 'East McKeesport', 40.3830604553223, 0.704817366977294, -79.8066711425781, -1.39288917649433, 218, 45, 'PPL', 'P'),
(148493, 'East Meadow', 40.7138900756836, 0.710591433115722, -73.559440612793, -1.28385443461847, 218, 40, 'PPL', 'P'),
(127361, 'East Mercer', 44.6805610656738, 0.779822902234395, -69.8916702270508, -1.21983976518013, 218, 26, 'PPL', 'P'),
(148495, 'East Meredith', 42.4213905334473, 0.740392938083008, -74.8872222900391, -1.30702859663407, 218, 40, 'PPL', 'P'),
(113285, 'East Meriden', 41.5297203063965, 0.724830356778967, -72.7619400024414, -1.26993542318117, 218, 8, 'PPL', 'P'),
(143764, 'East Merrimack', 42.8680610656738, 0.748188809541997, -71.48388671875, -1.24762918536483, 218, 36, 'PPL', 'P'),
(178128, 'East Mesa', 33.4152793884277, 0.583206645801861, -111.657218933105, -1.94878610400284, 218, 5, 'PPL', 'P'),
(171959, 'East Middlebury', 43.973331451416, 0.767479416897986, -73.1066665649414, -1.27595203671588, 218, 55, 'PPL', 'P'),
(148496, 'East Middletown', 41.4441719055176, 0.723337255513814, -74.4002838134766, -1.29852991696341, 218, 40, 'PPL', 'P'),
(143762, 'East Milford', 42.8233299255371, 0.747408103868441, -71.626106262207, -1.25011138465884, 218, 36, 'PPL', 'P'),
(2177, 'East Mill', 33.1302795410156, 0.578232460096838, -86.0527801513672, -1.50190434413618, 218, 2, 'PPL', 'P'),
(13698, 'East Mill Run', 38.7619400024414, 0.676523477503101, -75.2069396972656, -1.31260871806611, 218, 10, 'PPL', 'P'),
(124722, 'East Millbury', 42.2277793884277, 0.737013786133861, -71.7458267211914, -1.25220090085012, 218, 23, 'PPL', 'P'),
(203791, 'East Millcreek', 40.7000007629395, 0.710349018877498, -111.809722900391, -1.95144780035432, 218, 52, 'PPL', 'P'),
(72383, 'East Millersport', 39.9036102294922, 0.696449381937129, -82.5088882446289, -1.44005176202882, 218, 41, 'PPL', 'P'),
(72384, 'East Millfield', 39.4322204589844, 0.688222078381547, -82.0888900756836, -1.43272141112838, 218, 41, 'PPL', 'P'),
(127362, 'East Millinocket', 45.627498626709, 0.796350080485263, -68.5749969482422, -1.19685948129189, 218, 26, 'PPL', 'P'),
(78174, 'East Millsboro', 39.9811096191406, 0.69780200145478, -79.9936065673828, -1.39615181514579, 218, 45, 'PPL', 'P'),
(145123, 'East Millstone', 40.5013885498047, 0.706882581823623, -74.5811080932617, -1.30168589601321, 218, 37, 'PPL', 'P'),
(161091, 'East Millville', 41.1241683959961, 0.717752140654727, -76.5202789306641, -1.33553081188453, 218, 45, 'PPL', 'P'),
(15858, 'East Milton', 30.6149997711182, 0.534332546503322, -87.0216674804688, -1.51881461810986, 218, 12, 'PPL', 'P'),
(124723, 'East Milton', 42.2583312988281, 0.737547017563123, -71.0430603027344, -1.23993531297559, 218, 23, 'PPL', 'P'),
(127364, 'East Milton', 44.4544410705566, 0.775876363815006, -70.5994415283203, -1.23219270473841, 218, 26, 'PPL', 'P'),
(15859, 'East Mims', 28.6588897705078, 0.500191986461483, -80.8280563354492, -1.41071571104105, 218, 12, 'PPL', 'P'),
(32295, 'East Mineral (historical)', 37.2813911437988, 0.650683025183144, -94.9047164916992, -1.65639977845191, 218, 20, 'PPL', 'P'),
(161092, 'East Mines', 40.7102813720703, 0.710528449355942, -76.1913909912109, -1.32979063447098, 218, 45, 'PPL', 'P'),
(13699, 'East Minquadale', 39.7041702270508, 0.692968497234341, -75.5644378662109, -1.31884823818406, 218, 10, 'PPL', 'P'),
(196403, 'East Missoula', 46.8708305358887, 0.818050315995556, -113.94361114502, -1.9886911760927, 218, 31, 'PPL', 'P'),
(119454, 'East Moline', 41.5008316040039, 0.724326153805588, -90.4441680908203, -1.57854852241201, 218, 18, 'PPL', 'P'),
(64360, 'East Monbo', 35.6713905334473, 0.622583213573391, -80.958610534668, -1.41299431166972, 218, 33, 'PPL', 'P'),
(171960, 'East Monkton', 44.2088890075684, 0.771590671830796, -73.1149978637695, -1.2760974453114, 218, 55, 'PPL', 'P'),
(127365, 'East Monmouth', 44.2427787780762, 0.772182159908903, -69.978889465332, -1.22136202805922, 218, 26, 'PPL', 'P'),
(161117, 'East Monongahela', 40.202220916748, 0.701661121611387, -79.9169387817383, -1.39481370985608, 218, 45, 'PPL', 'P'),
(72385, 'East Monroe', 39.3586082458496, 0.686937302892666, -83.498893737793, -1.45733061749736, 218, 41, 'PPL', 'P'),
(115385, 'East Monticello', 42.2488899230957, 0.737382234470674, -91.17138671875, -1.59124088185122, 218, 16, 'PPL', 'P'),
(122540, 'East Monticello', 40.7461090087891, 0.711153759579892, -86.7533264160156, -1.51413118301684, 218, 19, 'PPL', 'P'),
(171961, 'East Montpelier', 44.271110534668, 0.772676642344303, -72.4875030517578, -1.26514559480261, 218, 55, 'PPL', 'P'),
(171962, 'East Montpelier Center', 44.2836112976074, 0.772894821816608, -72.5258331298828, -1.26581458086844, 218, 55, 'PPL', 'P'),
(161093, 'East Moravia', 40.9277801513672, 0.714324519173741, -80.3686065673828, -1.40269679984077, 218, 45, 'PPL', 'P'),
(148497, 'East Moriches', 40.8050003051758, 0.712181606602608, -72.7613906860352, -1.26992583580125, 218, 40, 'PPL', 'P'),
(113287, 'East Morris', 41.6883316040039, 0.727598646153077, -73.1805572509766, -1.27724167247375, 218, 8, 'PPL', 'P'),
(59744, 'East Moss Point', 30.413330078125, 0.530812746359105, -88.4916687011719, -1.54447097941946, 218, 30, 'PPL', 'P'),
(29690, 'East Mount Carmel', 38.3933296203613, 0.67009001267877, -87.7447204589844, -1.53143427325131, 218, 19, 'PPL', 'P'),
(93885, 'East Mountain', 32.5936088562012, 0.568865789647893, -94.8552780151367, -1.65553691425873, 218, 51, 'PPL', 'P'),
(113289, 'East Mountain', 41.5299987792969, 0.724835217047956, -73.0138931274414, -1.27433283477311, 218, 8, 'PPL', 'P'),
(8664, 'East Mountain (historical)', 35.4922218322754, 0.61945612982142, -92.3819427490234, -1.61236907035936, 218, 4, 'PPL', 'P'),
(15860, 'East Mulberry', 27.8944396972656, 0.486849815716295, -81.9652786254883, -1.4305639843293, 218, 12, 'PPL', 'P'),
(161094, 'East Nantmeal', 40.1222190856934, 0.700264826251858, -75.7297210693359, -1.32173297427683, 218, 45, 'PPL', 'P'),
(15861, 'East Naples', 26.1380596160889, 0.456195200383316, -81.7666702270508, -1.42709761385446, 218, 12, 'PPL', 'P'),
(86677, 'East Nashville', 36.1725006103516, 0.631329234330293, -86.7597198486328, -1.51424276946652, 218, 50, 'PPL', 'P'),
(148498, 'East Nassau', 42.5077781677246, 0.741900686734157, -73.5069427490234, -1.28293817404543, 218, 40, 'PPL', 'P'),
(40744, 'East Natchitoches', 31.7566699981689, 0.55425845093735, -93.0833282470703, -1.62461055662602, 218, 22, 'PPL', 'P'),
(124724, 'East Natick', 42.3041687011719, 0.738347031154582, -71.3249969482422, -1.24485603572173, 218, 23, 'PPL', 'P'),
(169356, 'East Natick', 41.7186088562012, 0.728127083892376, -71.4824981689453, -1.24760495059891, 218, 47, 'PPL', 'P'),
(161096, 'East New Castle', 40.9741706848145, 0.715134186724152, -80.317497253418, -1.40180477403365, 218, 45, 'PPL', 'P'),
(113292, 'East New London', 41.3663902282715, 0.721979709148146, -72.0997161865234, -1.25837743720828, 218, 8, 'PPL', 'P'),
(46759, 'East New Market', 38.5988883972168, 0.67367769014127, -75.9263916015625, -1.32516552260584, 218, 25, 'PPL', 'P'),
(127366, 'East New Portland', 44.901668548584, 0.783681955811974, -70.0238876342773, -1.22214739426468, 218, 26, 'PPL', 'P'),
(145124, 'East Newark', 40.7483291625977, 0.711192508573753, -74.1622161865234, -1.29437485303067, 218, 37, 'PPL', 'P'),
(148500, 'East Newark', 42.2033309936523, 0.736587081148203, -76.1486129760742, -1.32904401725937, 218, 40, 'PPL', 'P'),
(27034, 'East Newbern', 39.0144386291504, 0.680930409895937, -90.3133316040039, -1.57626499493532, 218, 18, 'PPL', 'P'),
(20763, 'East Newnan', 33.3505592346191, 0.582077066025504, -84.7766723632813, -1.47963206162374, 218, 13, 'PPL', 'P'),
(127367, 'East Newport', 44.8208312988281, 0.782271079645477, -69.2230606079102, -1.20817032591562, 218, 26, 'PPL', 'P'),
(148501, 'East Nichols', 42.0066719055176, 0.733154732556282, -76.2830581665039, -1.33139052849584, 218, 40, 'PPL', 'P'),
(181273, 'East Nicolaus', 38.9102783203125, 0.679112469556822, -121.543891906738, -2.12134109946067, 218, 6, 'PPL', 'P'),
(109003, 'East Nitro', 38.3997192382813, 0.670201532549417, -81.8363876342773, -1.42831441215651, 218, 58, 'PPL', 'P'),
(161097, 'East Norriton', 40.151668548584, 0.700778816342243, -75.3369369506836, -1.31487759815681, 218, 45, 'PPL', 'P'),
(124725, 'East Northfield', 42.6930618286133, 0.745134496666813, -72.4388885498047, -1.26429711167931, 218, 23, 'PPL', 'P'),
(124726, 'East Northfield Station', 42.7249984741211, 0.745691896282966, -72.4611129760742, -1.26468500109208, 218, 23, 'PPL', 'P'),
(127368, 'East Northport', 44.3819389343262, 0.774610962823055, -68.9805603027344, -1.20393789715321, 218, 26, 'PPL', 'P'),
(148502, 'East Northport', 40.8766708374023, 0.713432493366619, -73.3249969482422, -1.27976262076162, 218, 40, 'PPL', 'P'),
(124727, 'East Norton', 41.9749984741211, 0.732601926893009, -71.1708297729492, -1.24216531091437, 218, 23, 'PPL', 'P'),
(101603, 'East Norview', 36.8950004577637, 0.643939235512791, -76.2302780151367, -1.33046934107478, 218, 53, 'PPL', 'P'),
(113293, 'East Norwalk', 41.1055603027344, 0.717427368159792, -73.3988876342773, -1.28105225651949, 218, 8, 'PPL', 'P'),
(155097, 'East Norwalk', 41.271110534668, 0.720316764784473, -82.5699996948242, -1.4411183580454, 218, 41, 'PPL', 'P'),
(148503, 'East Norwich', 40.8466682434082, 0.712908849317282, -73.5355606079102, -1.28343764990788, 218, 40, 'PPL', 'P'),
(72386, 'East Norwood', 39.4169387817383, 0.687955362798376, -81.4286117553711, -1.42119738045938, 218, 41, 'PPL', 'P'),
(109004, 'East Oak Hill', 37.9936103820801, 0.663113595887198, -81.1324996948242, -1.41602925004798, 218, 58, 'PPL', 'P'),
(161100, 'East Oak Lane', 40.0499992370605, 0.699004352107924, -75.1333312988281, -1.31132400915626, 218, 45, 'PPL', 'P'),
(181270, 'East Oakdale', 37.7880592346191, 0.659526051582752, -120.802780151367, -2.10840625920421, 218, 6, 'PPL', 'P'),
(148504, 'East Oakfield', 43.0980606079102, 0.752203058832101, -78.2474975585938, -1.36567646384369, 218, 40, 'PPL', 'P'),
(161101, 'East Oakmont', 40.5230598449707, 0.707260817277442, -79.8116683959961, -1.39297639502003, 218, 45, 'PPL', 'P'),
(101604, 'East Ocean View', 36.9313888549805, 0.644574332853748, -76.2061080932617, -1.33004749635812, 218, 53, 'PPL', 'P'),
(148505, 'East Olean', 42.0800018310547, 0.734434581197147, -78.420280456543, -1.36869209430404, 218, 40, 'PPL', 'P'),
(207269, 'East Olympia', 46.9677810668945, 0.819742421973165, -122.834442138672, -2.14386545017029, 218, 56, 'PPL', 'P'),
(141707, 'East Omaha', 41.2849998474121, 0.720559179022698, -95.9000015258789, -1.67377077929417, 218, 35, 'PPL', 'P'),
(29689, 'East Oolitic', 38.8988914489746, 0.678913731160475, -86.5119400024414, -1.50991819533039, 218, 19, 'PPL', 'P'),
(145126, 'East Orange', 40.767219543457, 0.711522207916705, -74.2052764892578, -1.29512639709029, 218, 37, 'PPL', 'P'),
(171964, 'East Orange', 44.0947189331055, 0.769598028124172, -72.3419418334961, -1.26260507228073, 218, 55, 'PPL', 'P'),
(161102, 'East Oreland', 40.1199989318848, 0.700226077257997, -75.1849975585938, -1.31222575550136, 218, 45, 'PPL', 'P'),
(127369, 'East Orland', 44.5666694641113, 0.777835118796759, -68.6802825927734, -1.19869706244404, 218, 26, 'PPL', 'P'),
(124728, 'East Orleans', 41.7849998474121, 0.72928582528267, -69.970832824707, -1.22122141315366, 218, 23, 'PPL', 'P'),
(181271, 'East Orosi', 36.5480613708496, 0.637884006142278, -119.259719848633, -2.08147477636468, 218, 6, 'PPL', 'P'),
(127370, 'East Orrington', 44.7355613708496, 0.780782838649314, -68.7680587768555, -1.20022904586111, 218, 26, 'PPL', 'P'),
(155099, 'East Orwell', 41.5349998474121, 0.724922502152684, -80.8438873291016, -1.41099201400415, 218, 41, 'PPL', 'P'),
(124729, 'East Otis', 42.1733283996582, 0.736063437098867, -73.0350036621094, -1.27470128310992, 218, 23, 'PPL', 'P'),
(127371, 'East Otisfield', 44.0944404602051, 0.769593167855182, -70.5261077880859, -1.23091278951851, 218, 26, 'PPL', 'P'),
(148506, 'East Otto', 42.389720916748, 0.739840198998763, -78.754997253418, -1.37453400447123, 218, 40, 'PPL', 'P'),
(115387, 'East Ottumwa', 41.0050010681152, 0.715672278422402, -92.3783264160156, -1.61230595344153, 218, 16, 'PPL', 'P'),
(15862, 'East Palatka', 29.6580600738525, 0.517630798042999, -81.5986099243164, -1.42416440822984, 218, 12, 'PPL', 'P'),
(127376, 'East Palermo', 44.3702812194824, 0.774407497315773, -69.392219543457, -1.21112270630008, 218, 26, 'PPL', 'P'),
(148507, 'East Palermo', 43.3511085510254, 0.756619578604861, -76.2333297729492, -1.33052260429659, 218, 40, 'PPL', 'P'),
(155110, 'East Palestine', 40.8338890075684, 0.712685809575988, -80.5405578613281, -1.40569791607318, 218, 41, 'PPL', 'P'),
(148508, 'East Palmyra', 43.0849990844727, 0.75197509224279, -77.1572189331055, -1.3466475120648, 218, 40, 'PPL', 'P'),
(181272, 'East Palo Alto', 37.4688911437988, 0.653955517530634, -122.139999389648, -2.13174513773323, 218, 6, 'PPL', 'P'),
(130591, 'East Paris', 42.9099998474121, 0.748920779367606, -85.5683288574219, -1.49344907399129, 218, 27, 'PPL', 'P'),
(124730, 'East Parish', 42.663890838623, 0.744625366845417, -71.0166702270508, -1.23947471926507, 218, 23, 'PPL', 'P'),
(122541, 'East Park', 40.2844390869141, 0.703096099385749, -86.4922180175781, -1.5095739817595, 218, 19, 'PPL', 'P'),
(148509, 'East Park', 41.7886085510254, 0.72934880904245, -73.9147186279297, -1.29005520574256, 218, 40, 'PPL', 'P'),
(46760, 'East Park Village', 39.1324996948242, 0.682990964210359, -76.6419372558594, -1.33765415022165, 218, 25, 'PPL', 'P'),
(64361, 'East Parkland', 35.7447204589844, 0.623863062214256, -78.6313934326172, -1.37237671083022, 218, 33, 'PPL', 'P'),
(40745, 'East Parkview', 32.4936103820801, 0.56712048702751, -92.0788879394531, -1.60707976611835, 218, 22, 'PPL', 'P'),
(127372, 'East Parsonsfield', 43.7333297729492, 0.763290597398428, -70.8438873291016, -1.23645908880471, 218, 26, 'PPL', 'P'),
(148510, 'East Part', 44.7655601501465, 0.781306416119623, -74.8066711425781, -1.30562271389462, 218, 40, 'PPL', 'P'),
(181274, 'East Pasadena', 34.146110534668, 0.595962055579877, -118.093330383301, -2.06111743983406, 218, 6, 'PPL', 'P'),
(59745, 'East Pascagoula', 30.3452796936035, 0.529625043091957, -88.545280456543, -1.54540668106846, 218, 30, 'PPL', 'P'),
(148511, 'East Patchogue', 40.7669410705566, 0.711517347647715, -72.9966735839844, -1.2740322970441, 218, 40, 'PPL', 'P'),
(119455, 'East Paw Paw', 41.688060760498, 0.727593919042142, -88.9391708374023, -1.55228136510639, 218, 18, 'PPL', 'P'),
(109005, 'East Pea Ridge', 38.4180603027344, 0.670521644512444, -82.309440612793, -1.43657074416798, 218, 58, 'PPL', 'P'),
(171966, 'East Peacham', 44.3380584716797, 0.773845104272576, -72.1577835083008, -1.25939090316111, 218, 55, 'PPL', 'P'),
(93886, 'East Pearson Street Colonia', 27.8819999694824, 0.486632701508427, -98.6060028076172, -1.72099941122369, 218, 51, 'PPL', 'P'),
(188464, 'East Pecos', 35.5736083984375, 0.620876593367841, -105.663330078125, -1.84417300848484, 218, 38, 'PPL', 'P'),
(124731, 'East Pembroke', 42.0791702270508, 0.734420066969206, -70.7624969482422, -1.23503855867927, 218, 23, 'PPL', 'P'),
(148512, 'East Pembroke', 42.9955596923828, 0.75041408036984, -78.3102798461914, -1.3667722214742, 218, 40, 'PPL', 'P'),
(148513, 'East Penfield', 43.1294403076172, 0.752750737910276, -77.4124984741211, -1.3511029805685, 218, 40, 'PPL', 'P'),
(70771, 'East Pennsauken', 39.9711112976074, 0.697627497824353, -75.0227813720703, -1.3093945489465, 218, 37, 'PPL', 'P'),
(15863, 'East Pensacola Heights', 30.4286098480225, 0.531079428652763, -87.1800003051758, -1.52157804721498, 218, 12, 'PPL', 'P'),
(119456, 'East Peoria', 40.6661109924316, 0.709757530799391, -89.5800018310547, -1.56346597589445, 218, 18, 'PPL', 'P'),
(124732, 'East Pepperell', 42.6652793884277, 0.744649601611337, -71.5736083984375, -1.2491951240858, 218, 23, 'PPL', 'P'),
(15864, 'East Perrine', 25.6083297729492, 0.446949670474456, -80.3391723632813, -1.40218307606649, 218, 12, 'PPL', 'P'),
(178129, 'East Pershing Plaza', 31.5550003051758, 0.550738650793133, -110.343063354492, -1.92584976227259, 218, 5, 'PPL', 'P'),
(115388, 'East Peru', 41.2269401550293, 0.719545846227923, -93.9261093139648, -1.6393198611168, 218, 16, 'PPL', 'P'),
(127373, 'East Peru', 44.4883308410645, 0.776467851893113, -70.3794403076172, -1.22835295907873, 218, 26, 'PPL', 'P'),
(181275, 'East Petaluma', 38.2400016784668, 0.667413935257404, -122.633056640625, -2.1403506101636, 218, 6, 'PPL', 'P'),
(161105, 'East Petersburg', 40.0999984741211, 0.699877003418115, -76.3544387817383, -1.33263635525378, 218, 45, 'PPL', 'P'),
(148514, 'East Pharsalia', 42.5580596923828, 0.742778264892365, -75.7174987792969, -1.32151965507352, 218, 40, 'PPL', 'P'),
(155100, 'East Piedmont', 40.1894416809082, 0.701438081870092, -81.1986083984375, -1.41718306459025, 218, 41, 'PPL', 'P'),
(46761, 'East Pines', 38.9597206115723, 0.679975400329035, -76.9097213745117, -1.34232786477669, 218, 25, 'PPL', 'P'),
(35684, 'East Pineville', 36.7347183227539, 0.641141784524745, -83.6711120605469, -1.46033639426168, 218, 21, 'PPL', 'P'),
(148515, 'East Pitcairn', 44.2180595397949, 0.77175072781231, -75.2227783203125, -1.31288515418726, 218, 40, 'PPL', 'P'),
(161108, 'East Pittsburgh', 40.3955612182617, 0.705035546449599, -79.8388900756836, -1.3934515029585, 218, 45, 'PPL', 'P'),
(171967, 'East Pittsford', 43.6711082458496, 0.762204626884921, -72.9433288574219, -1.27310125592701, 218, 55, 'PPL', 'P'),
(127374, 'East Pittston', 44.1741714477539, 0.770984736103776, -69.6736068725586, -1.2160338416663, 218, 26, 'PPL', 'P'),
(148516, 'East Pittstown', 42.9025001525879, 0.748789885000028, -73.4627838134766, -1.28216745522596, 218, 40, 'PPL', 'P'),
(143763, 'East Plainfield', 43.5763893127441, 0.760551469638254, -72.2261123657227, -1.26058346669725, 218, 36, 'PPL', 'P'),
(178130, 'East Plantsite', 33.0469398498535, 0.576777908088464, -109.318061828613, -1.90796011080803, 218, 5, 'PPL', 'P'),
(115389, 'East Pleasant Plain', 41.1366691589355, 0.717970320127032, -91.8499984741211, -1.60308489132518, 218, 16, 'PPL', 'P'),
(181276, 'East Pleasanton', 37.6736106872559, 0.657528547607139, -121.828887939453, -2.12631521858667, 218, 6, 'PPL', 'P'),
(113298, 'East Plymouth', 41.6930618286133, 0.72768120414687, -72.9986114501953, -1.27406611918994, 218, 8, 'PPL', 'P'),
(8666, 'East Pocahontas', 36.250560760498, 0.63269164096495, -90.9619369506836, -1.58758529378092, 218, 4, 'PPL', 'P'),
(148518, 'East Poestenkill', 42.6824989318848, 0.744950139340352, -73.495002746582, -1.28272978169013, 218, 40, 'PPL', 'P'),
(2180, 'East Point', 34.1830596923828, 0.59660694003784, -86.7936096191406, -1.51483425754463, 218, 2, 'PPL', 'P'),
(20762, 'East Point', 33.6794395446777, 0.587817110281006, -84.4394378662109, -1.47374620929856, 218, 13, 'PPL', 'P'),
(35685, 'East Point', 37.7461090087891, 0.658793882020062, -82.7908325195313, -1.44497261793301, 218, 21, 'PPL', 'P'),
(40746, 'East Point', 32.1652793884277, 0.561390030151932, -93.4311065673828, -1.63068043338253, 218, 22, 'PPL', 'P'),
(86679, 'East Point', 36.1408309936523, 0.630776495246047, -86.5377807617188, -1.510369201661, 218, 50, 'PPL', 'P'),
(93887, 'East Point', 32.8311080932617, 0.573010933305575, -95.2975006103516, -1.66325515457194, 218, 51, 'PPL', 'P'),
(101607, 'East Point', 38.4191703796387, 0.670541019009375, -78.6600036621094, -1.37287605353461, 218, 53, 'PPL', 'P'),
(161111, 'East Point', 41.5869407653809, 0.725829042187747, -77.0400009155273, -1.3446016717154, 218, 45, 'PPL', 'P'),
(101608, 'East Pointe', 37.2138900756836, 0.649504909295921, -79.9258270263672, -1.39496883898958, 218, 53, 'PPL', 'P'),
(127375, 'East Poland', 44.0705604553223, 0.769176383144585, -70.32861328125, -1.22746586011963, 218, 26, 'PPL', 'P'),
(115390, 'East Port (historical)', 40.6788902282715, 0.709980570540685, -95.8352813720703, -1.67264119951782, 218, 16, 'PPL', 'P'),
(113300, 'East Port Chester (historical)', 41.0086097717285, 0.715735262182183, -73.6547164916992, -1.28551731240312, 218, 8, 'PPL', 'P'),
(207270, 'East Port Orchard', 47.523609161377, 0.829443452296969, -122.623062133789, -2.1401761731122, 218, 56, 'PPL', 'P'),
(186655, 'East Portal', 39.9033317565918, 0.696444521668139, -105.643890380859, -1.84383372176196, 218, 7, 'PPL', 'P'),
(196404, 'East Portal', 47.3972206115723, 0.827237555966056, -115.634170532227, -2.01819700359996, 218, 31, 'PPL', 'P'),
(181277, 'East Porterville', 36.0574989318848, 0.629322076395728, -118.974716186523, -2.07650052408063, 218, 6, 'PPL', 'P'),
(200742, 'East Portland', 45.5155601501465, 0.794396385509581, -122.659172058105, -2.14080641018417, 218, 43, 'PPL', 'P'),
(72387, 'East Portsmouth (historical)', 38.7555618286133, 0.676412157369536, -82.9113922119141, -1.44707678151028, 218, 41, 'PPL', 'P'),
(148519, 'East Potter', 42.7388916015625, 0.745934377100218, -77.1444396972656, -1.3464244723235, 218, 40, 'PPL', 'P'),
(171968, 'East Poultney', 43.5263900756836, 0.759678818328063, -73.2050018310547, -1.27766831088038, 218, 55, 'PPL', 'P'),
(54541, 'East Prairie', 36.7797203063965, 0.641927217309236, -89.3855590820313, -1.56007230971737, 218, 29, 'PPL', 'P'),
(59746, 'East Prentiss', 34.5297203063965, 0.602657309139364, -88.3694381713867, -1.54233765422826, 218, 30, 'PPL', 'P'),
(124733, 'East Princeton', 42.4727783203125, 0.74128982415912, -71.8394393920898, -1.25383475017888, 218, 23, 'PPL', 'P'),
(78176, 'East Prospect', 39.9719390869141, 0.697641945473266, -76.5202789306641, -1.33553081188453, 218, 45, 'PPL', 'P'),
(46762, 'East Prospect Plantation', 38.9222183227539, 0.679320861912121, -76.184440612793, -1.32966932748332, 218, 25, 'PPL', 'P'),
(169357, 'East Providence', 41.8136100769043, 0.729785167987059, -71.3705596923828, -1.24565125562323, 218, 47, 'PPL', 'P'),
(169358, 'East Providence Center', 41.8344383239746, 0.730148689475855, -71.3483276367188, -1.24526323305241, 218, 47, 'PPL', 'P'),
(54542, 'East Purdy', 36.8152809143066, 0.642547867001279, -93.8783264160156, -1.63848589222144, 218, 29, 'PPL', 'P'),
(113302, 'East Putnam', 41.9136085510254, 0.731530470607443, -71.8172225952148, -1.25344699392417, 218, 8, 'PPL', 'P'),
(171969, 'East Putney', 42.9938888549805, 0.750384918755904, -72.48388671875, -1.26508247788478, 218, 55, 'PPL', 'P'),
(207278, 'East Quilcene', 47.8269386291504, 0.834737550227938, -122.850830078125, -2.14415147367136, 218, 56, 'PPL', 'P'),
(181278, 'East Quincy', 39.9341697692871, 0.696982746524444, -120.896942138672, -2.1100496959129, 218, 6, 'PPL', 'P'),
(148520, 'East Quogue', 40.8405609130859, 0.712802256294651, -72.5819396972656, -1.26679382520126, 218, 40, 'PPL', 'P'),
(101609, 'East Radford', 37.1369400024414, 0.648161877158194, -80.5533294677734, -1.40592082265642, 218, 53, 'PPL', 'P'),
(148521, 'East Randolph', 42.172779083252, 0.736053849718942, -78.9480590820313, -1.37790356904046, 218, 40, 'PPL', 'P'),
(171970, 'East Randolph', 43.939998626709, 0.766897649357859, -72.5555572509766, -1.26633336464879, 218, 55, 'PPL', 'P'),
(115391, 'East Rapids', 41.9599990844727, 0.732340138157854, -91.6391677856445, -1.59940520164702, 218, 16, 'PPL', 'P'),
(127381, 'East Raymond', 43.9341697692871, 0.766795916604218, -70.4433288574219, -1.22946802462715, 218, 26, 'PPL', 'P'),
(207272, 'East Raymond', 46.6686096191406, 0.814520895181901, -123.691108703613, -2.15881710232027, 218, 56, 'PPL', 'P'),
(124734, 'East Renfrew', 42.6366691589355, 0.744150258906947, -73.102783203125, -1.27588425926614, 218, 23, 'PPL', 'P'),
(207273, 'East Renton Highlands', 47.4850006103516, 0.828769605962152, -122.111106872559, -2.13124086818082, 218, 56, 'PPL', 'P'),
(148522, 'East Richford', 42.3713912963867, 0.739520286772817, -76.1544418334961, -1.32914575001301, 218, 40, 'PPL', 'P'),
(171971, 'East Richford', 45.0111083984375, 0.785592041524806, -72.5863876342773, -1.26687145634704, 218, 55, 'PPL', 'P'),
(155101, 'East Richland', 40.0724983215332, 0.699397035210656, -80.9541702270508, -1.412916813682, 218, 41, 'PPL', 'P'),
(181279, 'East Richmond', 37.9436111450195, 0.662240944577006, -122.314170837402, -2.1347850029595, 218, 6, 'PPL', 'P'),
(181280, 'East Richmond Heights', 37.9449996948242, 0.662265179342926, -122.3125, -2.13475584134556, 218, 6, 'PPL', 'P'),
(8667, 'East Richwoods', 35.8458290100098, 0.62562773933157, -92.1344375610352, -1.6080492899132, 218, 4, 'PPL', 'P'),
(115392, 'East Rickardsville', 42.5736083984375, 0.743049641007444, -90.857780456543, -1.58576742002083, 218, 16, 'PPL', 'P'),
(86681, 'East Ridge', 35.0141716003418, 0.611112579284256, -85.2519378662109, -1.48792700947101, 218, 50, 'PPL', 'P'),
(40750, 'East Ridgewood', 30.500560760498, 0.532335208975277, -91.0280609130859, -1.58873937463931, 218, 22, 'PPL', 'P'),
(143765, 'East Rindge', 42.7374992370605, 0.745910075755271, -71.9663925170898, -1.25605050020583, 218, 36, 'PPL', 'P'),
(72389, 'East Ringgold', 39.6694412231445, 0.692362361770239, -82.8611068725586, -1.44619913677305, 218, 41, 'PPL', 'P'),
(72390, 'East Ripley', 38.7394409179688, 0.676130794400369, -83.841667175293, -1.46331314257012, 218, 41, 'PPL', 'P'),
(148523, 'East Ripley', 42.2838897705078, 0.737993097045711, -79.6727828979492, -1.39055238579584, 218, 40, 'PPL', 'P'),
(93888, 'East River', 30.2786102294922, 0.528461441432675, -95.1333312988281, -1.66038985955512, 218, 51, 'PPL', 'P'),
(113307, 'East River', 41.2852783203125, 0.720564039291687, -72.6388931274414, -1.26778785007813, 218, 8, 'PPL', 'P'),
(148524, 'East River', 42.6477813720703, 0.744344203613332, -76.1144409179688, -1.32844760233325, 218, 40, 'PPL', 'P'),
(109006, 'East River (historical)', 37.3166694641113, 0.651298748027171, -81.0224990844727, -1.41410937721814, 218, 58, 'PPL', 'P'),
(46763, 'East Riverdale', 38.9619407653809, 0.680014149322896, -76.9222183227539, -1.34254597766997, 218, 25, 'PPL', 'P'),
(78178, 'East Riverside', 39.9316711425781, 0.696939137261594, -79.9274978637695, -1.39499800060351, 218, 45, 'PPL', 'P'),
(145128, 'East Riverton', 40.0175018310547, 0.698437165374764, -74.9952774047852, -1.30891451416001, 218, 37, 'PPL', 'P'),
(143766, 'East Rochester', 43.3330612182617, 0.756304593226932, -70.9419403076172, -1.2381704361212, 218, 36, 'PPL', 'P'),
(148525, 'East Rochester', 43.1086082458496, 0.752387149842453, -77.4877777099609, -1.35241685109229, 218, 40, 'PPL', 'P'),
(155102, 'East Rochester', 40.7461090087891, 0.711153759579892, -81.0352783203125, -1.41433241695943, 218, 41, 'PPL', 'P'),
(161113, 'East Rochester', 40.7000007629395, 0.710349018877498, -80.2683334350586, -1.40094670353042, 218, 45, 'PPL', 'P'),
(199932, 'East Rochester (historical)', 40.2894401550293, 0.703183384490476, -118.159172058105, -2.06226659384442, 218, 39, 'PPL', 'P'),
(148527, 'East Rockaway', 40.6419410705566, 0.709335686082722, -73.6699981689453, -1.28578402798629, 218, 40, 'PPL', 'P'),
(64363, 'East Rockingham', 34.9180603027344, 0.609435120692643, -79.7627792358398, -1.39212311820677, 218, 33, 'PPL', 'P'),
(130592, 'East Rockwood', 42.0483283996582, 0.733881775533874, -83.2108306884766, -1.45230296883346, 218, 27, 'PPL', 'P'),
(148528, 'East Rodman', 43.8699989318848, 0.765675924207785, -75.8536071777344, -1.32389519476587, 218, 40, 'PPL', 'P'),
(46764, 'East Rolling Hills', 39.3555603027344, 0.686884106249891, -77.1833267211914, -1.34710317892731, 218, 25, 'PPL', 'P'),
(171972, 'East Roxbury', 44.079719543457, 0.769336239389017, -72.6522216796875, -1.26802047719935, 218, 55, 'PPL', 'P'),
(161116, 'East Run', 40.7519416809082, 0.711255558912561, -78.9230575561523, -1.37746721009585, 218, 45, 'PPL', 'P'),
(171973, 'East Rupert', 43.2730598449707, 0.755257371707286, -73.1255569458008, -1.27628173605883, 218, 55, 'PPL', 'P'),
(161122, 'East Rush', 41.7602806091309, 0.728854393186077, -75.9977798461914, -1.32641148252183, 218, 45, 'PPL', 'P'),
(145129, 'East Rutherford', 40.8338890075684, 0.712685809575988, -74.0975036621094, -1.29324540641236, 218, 37, 'PPL', 'P'),
(161118, 'East Rutherford', 40.3702812194824, 0.704594327236, -77.6050033569336, -1.35446282459974, 218, 45, 'PPL', 'P'),
(171974, 'East Ryegate', 44.2050018310547, 0.771522827802026, -72.0616683959961, -1.25771337799047, 218, 55, 'PPL', 'P'),
(2181, 'East Saginaw', 33.2852783203125, 0.580937699132141, -86.6575012207031, -1.51245871785227, 218, 2, 'PPL', 'P'),
(178131, 'East Sahuarita', 31.9427795410156, 0.557506675229406, -110.927780151367, -1.93605499556977, 218, 5, 'PPL', 'P'),
(171975, 'East Saint Johnsbury', 44.4386100769043, 0.77560006085191, -71.9461135864258, -1.25569656609696, 218, 55, 'PPL', 'P'),
(27037, 'East Saint Louis', 38.624439239502, 0.674123636465804, -90.1508331298828, -1.57342886153244, 218, 18, 'PPL', 'P'),
(109007, 'East Salem', 39.288890838623, 0.685720504590608, -80.5363922119141, -1.40562521177542, 218, 58, 'PPL', 'P'),
(161120, 'East Salem', 40.6088905334473, 0.708758845390611, -77.2383270263672, -1.34806311534223, 218, 45, 'PPL', 'P'),
(155103, 'East Salineville (historical)', 40.6241683959961, 0.709025494394755, -80.8166732788086, -1.41051703922373, 218, 41, 'PPL', 'P'),
(181281, 'East San Diego', 32.749439239502, 0.571585542911137, -117.109169006348, -2.04394058343526, 218, 6, 'PPL', 'P'),
(124735, 'East Sandwich', 41.7416687011719, 0.728529554112114, -70.4522171020508, -1.22962315376064, 218, 23, 'PPL', 'P'),
(143767, 'East Sandwich', 43.8097190856934, 0.764623842419149, -71.3541717529297, -1.24536523212216, 218, 36, 'PPL', 'P'),
(161121, 'East Sandy', 41.3311080932617, 0.721363919725093, -79.7688903808594, -1.39222977780843, 218, 45, 'PPL', 'P'),
(127377, 'East Sangerville', 45.1525001525879, 0.788059793169901, -69.2919387817383, -1.20937247683168, 218, 26, 'PPL', 'P'),
(148529, 'East Saratoga Junciton', 42.9219398498535, 0.749129171722904, -73.6827774047852, -1.28600706772758, 218, 40, 'PPL', 'P'),
(130593, 'East Saugatuck', 42.6816711425781, 0.744935691691438, -86.0930633544922, -1.50260741866396, 218, 27, 'PPL', 'P'),
(161123, 'East Saxton', 40.2205581665039, 0.701981166995387, -78.2361068725586, -1.36547765886831, 218, 45, 'PPL', 'P'),
(148530, 'East Schodack', 42.561939239502, 0.74284597576308, -73.6338882446289, -1.28515379091432, 218, 40, 'PPL', 'P'),
(148531, 'East Schuyler', 43.0536117553711, 0.751427280006561, -75.0747222900391, -1.31030108898156, 218, 40, 'PPL', 'P'),
(148532, 'East Scott', 42.7219390869141, 0.74563849990311, -76.1947174072266, -1.32984869138274, 218, 40, 'PPL', 'P'),
(127378, 'East Sebago', 43.855281829834, 0.765419062320647, -70.6399993896484, -1.23290057295615, 218, 26, 'PPL', 'P'),
(207275, 'East Selah', 46.6647186279297, 0.814452984574104, -120.486671447754, -2.10288912153195, 218, 56, 'PPL', 'P'),
(148533, 'East Seneca', 42.8347206115723, 0.747606908843815, -78.7125015258789, -1.37379231410765, 218, 40, 'PPL', 'P'),
(148534, 'East Setauket', 40.9413909912109, 0.714562073142976, -73.1063919067383, -1.27594724302592, 218, 40, 'PPL', 'P'),
(109008, 'East Sewell (historical)', 37.982780456543, 0.66292457802883, -81.0258331298828, -1.41416756728796, 218, 58, 'PPL', 'P'),
(161124, 'East Shamburg', 41.5691719055176, 0.725518917078807, -79.6105575561523, -1.38946634870331, 218, 45, 'PPL', 'P'),
(124736, 'East Sharon', 42.1349983215332, 0.735394451033039, -71.1616668701172, -1.24200538809091, 218, 23, 'PPL', 'P'),
(161125, 'East Sharon', 41.9777793884277, 0.732650463003876, -78.148063659668, -1.36394101491934, 218, 45, 'PPL', 'P'),
(161126, 'East Sharpsburg', 40.3325004577637, 0.703934928550096, -78.3694381713867, -1.36780472902882, 218, 45, 'PPL', 'P'),
(2186, 'East Sheffield', 34.7708282470703, 0.606865436556825, -87.6777801513672, -1.53026594448109, 218, 2, 'PPL', 'P'),
(124737, 'East Sheffield', 42.047779083252, 0.73387218815395, -73.3013916015625, -1.27935062974099, 218, 23, 'PPL', 'P'),
(29691, 'East Shelburn', 39.1744384765625, 0.683722934035967, -87.3797225952148, -1.52506385876578, 218, 19, 'PPL', 'P'),
(124738, 'East Shelburne', 42.6352806091309, 0.744126024141027, -72.6672210693359, -1.26828226593451, 218, 23, 'PPL', 'P'),
(148535, 'East Shelby', 43.1705589294434, 0.753468393245025, -78.3255615234375, -1.36703893705737, 218, 40, 'PPL', 'P'),
(171976, 'East Sheldon', 44.8988914489746, 0.783633486280135, -72.8744430541992, -1.27189897185289, 218, 55, 'PPL', 'P'),
(80807, 'East Shore', 34.0897216796875, 0.594977884399039, -81.2305603027344, -1.41774073052252, 218, 48, 'PPL', 'P'),
(193513, 'East Shore', 40.2366714477539, 0.702262396806499, -121.076110839844, -2.11317677966487, 218, 6, 'PPL', 'P'),
(155104, 'East Shore Cottage Area', 40.3472213745117, 0.704191857016262, -81.1933288574219, -1.41709091921654, 218, 41, 'PPL', 'P'),
(148536, 'East Shoreham', 40.9447212219238, 0.714620196633767, -72.879997253418, -1.27199591091657, 218, 40, 'PPL', 'P'),
(171977, 'East Shoreham', 43.860279083252, 0.765506280846347, -73.2533264160156, -1.27851173399761, 218, 55, 'PPL', 'P'),
(40748, 'East Side', 31.1433296203613, 0.543553641909181, -93.2591705322266, -1.62767958346623, 218, 22, 'PPL', 'P'),
(59747, 'East Side', 31.3547191619873, 0.547243085414836, -88.9111099243164, -1.55179160978193, 218, 30, 'PPL', 'P'),
(86683, 'East Side', 36.3383293151855, 0.634223491223964, -82.1988906860352, -1.43464128395821, 218, 50, 'PPL', 'P'),
(109009, 'East Side', 38.3541717529297, 0.669406578964028, -81.6408309936523, -1.42490130490347, 218, 58, 'PPL', 'P'),
(119458, 'East Side', 41.7122192382813, 0.728015564021729, -87.5319366455078, -1.52772049511119, 218, 18, 'PPL', 'P'),
(155105, 'East Side', 41.1005592346191, 0.717340083055065, -80.6369400024414, -1.40738010177573, 218, 41, 'PPL', 'P'),
(161127, 'East Side', 41.0613899230957, 0.716656449603241, -75.7697219848633, -1.3224311219566, 218, 45, 'PPL', 'P'),
(181283, 'East Side', 38.1352806091309, 0.665586207801282, -121.242218017578, -2.11607589682753, 218, 6, 'PPL', 'P'),
(64365, 'East Side Park', 34.5041694641113, 0.60221136281483, -79.0933303833008, -1.38043903155627, 218, 33, 'PPL', 'P'),
(40749, 'East Side Subdivision', 32.999439239502, 0.575948866041123, -93.456672668457, -1.63112664602317, 218, 22, 'PPL', 'P'),
(13700, 'East Side Village', 38.774169921875, 0.676736929864471, -75.3019409179688, -1.3142668021608, 218, 10, 'PPL', 'P'),
(148537, 'East Sidney', 42.3300018310547, 0.738797904327133, -75.2324981689453, -1.3130547975487, 218, 40, 'PPL', 'P'),
(15865, 'East Silver Springs Shore', 29.0416698455811, 0.506872759082543, -81.8755569458008, -1.42899804560834, 218, 12, 'PPL', 'P'),
(170196, 'East Sioux Falls', 43.5269393920898, 0.759688405707987, -96.6083297729492, -1.68613343939043, 218, 49, 'PPL', 'P'),
(161129, 'East Smethport', 41.8086090087891, 0.729697882882332, -78.4197235107422, -1.36868237376606, 218, 45, 'PPL', 'P'),
(161130, 'East Smithfield', 41.8644409179688, 0.730672333525192, -76.6258316040039, -1.3373730535686, 218, 45, 'PPL', 'P'),
(124739, 'East Somerville', 42.3855590820313, 0.739767561280031, -71.0861129760742, -1.24068672387716, 218, 23, 'PPL', 'P'),
(181284, 'East Sonora', 37.9777793884277, 0.662837292924102, -120.360282897949, -2.10068322520104, 218, 6, 'PPL', 'P'),
(155106, 'East Sparta', 40.6672210693359, 0.709776905296321, -81.3550033569336, -1.41991267154953, 218, 41, 'PPL', 'P'),
(80808, 'East Spartanburg', 34.9324989318848, 0.609687122310792, -81.8916702270508, -1.42927927541945, 218, 48, 'PPL', 'P'),
(64366, 'East Spencer', 35.6816711425781, 0.622762644051835, -80.432502746582, -1.40381199854724, 218, 33, 'PPL', 'P'),
(207276, 'East Spokane', 47.6536102294922, 0.831712398966689, -117.314170837402, -2.04751854035978, 218, 56, 'PPL', 'P'),
(145131, 'East Spotswood', 40.4113883972168, 0.705311782833667, -74.3647232055664, -1.29790926727137, 218, 37, 'PPL', 'P'),
(46765, 'East Springbrook', 39.0583305358887, 0.681696468183499, -76.9877777099609, -1.34369020483232, 218, 25, 'PPL', 'P'),
(86684, 'East Springbrook', 35.7975006103516, 0.624784249635314, -83.9747161865234, -1.46563528588261, 218, 50, 'PPL', 'P'),
(27039, 'East Springfield', 39.7980613708496, 0.694607206832094, -89.6272201538086, -1.56429009109378, 218, 18, 'PPL', 'P'),
(124740, 'East Springfield', 42.1416702270508, 0.735510897751703, -72.5625, -1.26645453847839, 218, 23, 'PPL', 'P'),
(143768, 'East Springfield', 43.4863891601563, 0.758980670648298, -71.978889465332, -1.2562686130991, 218, 36, 'PPL', 'P'),
(148538, 'East Springfield', 42.8308296203613, 0.747538998236018, -74.815559387207, -1.30577784302811, 218, 40, 'PPL', 'P'),
(155107, 'East Springfield', 40.4505615234375, 0.705995482864518, -80.8605575561523, -1.41128296435324, 218, 41, 'PPL', 'P'),
(161167, 'East Springfield', 41.9650001525879, 0.732427423262581, -80.4075012207031, -1.40337563960263, 218, 45, 'PPL', 'P'),
(161131, 'East Spruce', 41.8400001525879, 0.730245761697589, -75.3300018310547, -1.31475655748526, 218, 45, 'PPL', 'P'),
(207277, 'East Stanwood', 48.2441711425781, 0.842019631333623, -122.345558166504, -2.13533281519573, 218, 56, 'PPL', 'P'),
(148539, 'East Steamburg', 42.5294418334961, 0.742278789029921, -76.7716674804688, -1.33991836978044, 218, 40, 'PPL', 'P'),
(155108, 'East Steels Corners', 41.1808280944824, 0.718741038946501, -81.5086135864258, -1.42259367581891, 218, 41, 'PPL', 'P'),
(93889, 'East Stenger Street Colonia', 26.1189994812012, 0.455862538273651, -97.6119995117188, -1.70365078093459, 218, 51, 'PPL', 'P'),
(161132, 'East Sterling', 41.3266716003418, 0.721286488316399, -75.3372192382813, -1.31488252500482, 218, 45, 'PPL', 'P'),
(127379, 'East Steuben', 44.5027809143066, 0.776720053248343, -67.9261093139648, -1.18553425559827, 218, 26, 'PPL', 'P'),
(148540, 'East Steuben', 43.3763885498047, 0.75706079781846, -75.2297210693359, -1.31300632801686, 218, 40, 'PPL', 'P'),
(177212, 'East Steubenville', 40.3566703796387, 0.704356773266765, -80.5994415283203, -1.40672562993784, 218, 58, 'PPL', 'P'),
(119461, 'East Stockton (historical)', 42.3422203063965, 0.739011156951421, -89.9805603027344, -1.57045704007202, 218, 18, 'PPL', 'P'),
(148541, 'East Stone Arabia', 42.9583282470703, 0.749764269063861, -74.5183334350586, -1.30059027154075, 218, 40, 'PPL', 'P'),
(101612, 'East Stone Gap', 36.8666687011719, 0.643444753077391, -82.7425003051758, -1.44412906165773, 218, 53, 'PPL', 'P'),
(127380, 'East Stoneham', 44.2502784729004, 0.77231305427648, -70.8130569458008, -1.23592099710646, 218, 26, 'PPL', 'P'),
(161133, 'East Stroudsburg', 40.999439239502, 0.715575206200669, -75.1816711425781, -1.3121676985896, 218, 45, 'PPL', 'P'),
(124741, 'East Sudbury Station', 42.360279083252, 0.739326342066432, -71.4022216796875, -1.24620386154942, 218, 23, 'PPL', 'P'),
(101611, 'East Suffolk Gardens', 36.7236099243164, 0.640947906397387, -76.5583267211914, -1.33619487110234, 218, 53, 'PPL', 'P'),
(127382, 'East Sullivan', 44.5036087036133, 0.776734500897257, -68.1527786254883, -1.18949038139759, 218, 26, 'PPL', 'P'),
(143769, 'East Sullivan', 42.9938888549805, 0.750384918755904, -72.1961135864258, -1.26005988922694, 218, 36, 'PPL', 'P'),
(127383, 'East Sumner', 44.3566703796387, 0.774169943346538, -70.3769378662109, -1.22830928323685, 218, 26, 'PPL', 'P'),
(80809, 'East Sumter', 33.9252815246582, 0.592107862271288, -80.29638671875, -1.40143632569683, 218, 48, 'PPL', 'P'),
(127384, 'East Surry', 44.496940612793, 0.776618120757621, -68.4438934326172, -1.19457129328329, 218, 26, 'PPL', 'P'),
(124742, 'East Sutton', 42.1624984741211, 0.735874419240498, -71.7022171020508, -1.25143976941057, 218, 23, 'PPL', 'P'),
(143770, 'East Sutton', 43.3011093139648, 0.75574692729467, -71.8561096191406, -1.25412570052797, 218, 36, 'PPL', 'P'),
(155109, 'East Swanton', 41.5827789306641, 0.725756404469015, -83.8544387817383, -1.46353604915336, 218, 41, 'PPL', 'P'),
(143771, 'East Swanzey', 42.851390838623, 0.747897859192906, -72.2588882446289, -1.2611555136994, 218, 36, 'PPL', 'P'),
(93890, 'East Sweden', 31.1672191619873, 0.543970593067346, -99.2558288574219, -1.73234101535801, 218, 51, 'PPL', 'P'),
(127385, 'East Sweden', 44.1444396972656, 0.770465819165374, -70.7811126708984, -1.23536346433226, 218, 26, 'PPL', 'P'),
(86685, 'East Sweetwater', 35.6072196960449, 0.621463221176958, -84.4138870239258, -1.47330026297402, 218, 50, 'PPL', 'P'),
(161135, 'East Swiftwater', 41.1055603027344, 0.717427368159792, -75.3072204589844, -1.31435894753451, 218, 45, 'PPL', 'P'),
(148542, 'East Syracuse', 43.0652809143066, 0.751630945250925, -76.0788879394531, -1.32782708579926, 218, 40, 'PPL', 'P'),
(64372, 'East Tabor', 34.1602783203125, 0.596209330087091, -78.8475036621094, -1.3761485458821, 218, 33, 'PPL', 'P'),
(148543, 'East Taghkanic', 42.1319389343262, 0.735341054653183, -73.6577835083008, -1.28557084194103, 218, 40, 'PPL', 'P'),
(15866, 'East Tampa', 27.8641700744629, 0.486321511135051, -82.3802795410156, -1.43780711670405, 218, 12, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(124743, 'East Taunton', 41.8833312988281, 0.731002032868144, -71.029167175293, -1.23969283215834, 218, 23, 'PPL', 'P'),
(93891, 'East Tawakoni', 32.8841705322266, 0.57393704757465, -95.9288864135742, -1.67427491568853, 218, 51, 'PPL', 'P'),
(130594, 'East Tawas', 44.2794418334961, 0.772822050939822, -83.4902801513672, -1.45718028205383, 218, 27, 'PPL', 'P'),
(93892, 'East Tempe', 30.70339012146, 0.535875249143778, -94.9846267700195, -1.65779447591479, 218, 51, 'PPL', 'P'),
(124744, 'East Templeton', 42.563060760498, 0.742865549997093, -72.0374984741211, -1.2572915332738, 218, 23, 'PPL', 'P'),
(161137, 'East Texas', 40.5475006103516, 0.707687389105045, -75.5616683959961, -1.31879990181027, 218, 45, 'PPL', 'P'),
(209422, 'East Thermopolis', 43.6463890075684, 0.761773194788328, -108.19750213623, -1.88840265471082, 218, 59, 'PPL', 'P'),
(171978, 'East Thetford', 43.8116683959961, 0.764657864302075, -72.1891708374023, -1.25993871539734, 218, 55, 'PPL', 'P'),
(2182, 'East Thomas', 33.5194396972656, 0.585024586140977, -86.8380584716797, -1.51561003637017, 218, 2, 'PPL', 'P'),
(2183, 'East Thomas Gardens', 33.5297203063965, 0.585204016619421, -86.8652801513672, -1.51608514430864, 218, 2, 'PPL', 'P'),
(20764, 'East Thomaston', 32.8894386291504, 0.574028993211285, -84.315559387207, -1.47158412196758, 218, 13, 'PPL', 'P'),
(113316, 'East Thompson', 42.0088882446289, 0.733193414971116, -71.8091735839844, -1.25330651217666, 218, 8, 'PPL', 'P'),
(127386, 'East Thorndike', 44.5916709899902, 0.778271477741369, -69.2016677856445, -1.20779695073079, 218, 26, 'PPL', 'P'),
(143772, 'East Tilton', 43.4797210693359, 0.758864290508662, -71.5408325195313, -1.24862307708365, 218, 36, 'PPL', 'P'),
(161138, 'East Titusville', 41.621940612793, 0.726439904762784, -79.6425018310547, -1.39002388147752, 218, 45, 'PPL', 'P'),
(155113, 'East Toledo', 41.6333312988281, 0.726638709738158, -83.5166702270508, -1.45764087576436, 218, 41, 'PPL', 'P'),
(171979, 'East Topsham', 44.1211090087891, 0.770058621834701, -72.2333297729492, -1.26070943421681, 218, 55, 'PPL', 'P'),
(161139, 'East Towanda', 41.7649993896484, 0.728936751442787, -76.4333267211914, -1.33401320953735, 218, 45, 'PPL', 'P'),
(2184, 'East Town', 32.9452781677246, 0.575003577012199, -87.1319427490234, -1.52073928462966, 218, 2, 'PPL', 'P'),
(155111, 'East Townsend', 41.2486114501953, 0.719924081681741, -82.491943359375, -1.43975601798977, 218, 41, 'PPL', 'P'),
(148544, 'East Township', 42.6997184753418, 0.745250677069368, -74.1013870239258, -1.29331318386211, 218, 40, 'PPL', 'P'),
(148545, 'East Tremont', 40.8452796936035, 0.712884614551362, -73.8913879394531, -1.28964800841189, 218, 40, 'PPL', 'P'),
(145132, 'East Trenton Heights', 40.2586097717285, 0.702645292792225, -74.7102813720703, -1.30394039503401, 218, 37, 'PPL', 'P'),
(20770, 'East Trion', 34.5463905334473, 0.602948259488455, -85.2916717529297, -1.48862049661887, 218, 13, 'PPL', 'P'),
(127387, 'East Troy', 44.6705589294434, 0.77964833202494, -69.2061080932617, -1.20787444871851, 218, 26, 'PPL', 'P'),
(161140, 'East Troy', 41.7700004577637, 0.729024036547515, -76.7375030517578, -1.33932208801237, 218, 45, 'PPL', 'P'),
(173911, 'East Troy', 42.7852783203125, 0.746743978071602, -88.4049987792969, -1.5429583039203, 218, 57, 'PPL', 'P'),
(155112, 'East Trumbull', 41.6613883972168, 0.727128398483596, -80.9147186279297, -1.41222825338216, 218, 41, 'PPL', 'P'),
(2185, 'East Trussville (historical)', 33.6344413757324, 0.587031744075542, -86.5763931274414, -1.51104311457484, 218, 2, 'PPL', 'P'),
(75734, 'East Tulsa', 36.1725006103516, 0.631329234330293, -95.940559387207, -1.67447864751192, 218, 42, 'PPL', 'P'),
(35687, 'East Union', 38.2400016784668, 0.667413935257404, -83.9805603027344, -1.46573728495236, 218, 21, 'PPL', 'P'),
(86686, 'East Union', 35.6049995422363, 0.621424472183098, -88.7669372558594, -1.54927532202597, 218, 50, 'PPL', 'P'),
(113058, 'East Union', 40.2172203063965, 0.701922910346541, -86.1283264160156, -1.50322287519188, 218, 19, 'PPL', 'P'),
(127399, 'East Union', 44.2130584716797, 0.771663442707583, -69.2236099243164, -1.20817991329554, 218, 26, 'PPL', 'P'),
(135120, 'East Union', 44.7180595397949, 0.780477374072282, -93.6813888549805, -1.63504868336053, 218, 28, 'PPL', 'P'),
(148546, 'East Union', 42.297779083252, 0.738235511283935, -77.3249969482422, -1.34957579084139, 218, 40, 'PPL', 'P'),
(155133, 'East Union', 40.7958297729492, 0.712021550621095, -81.817497253418, -1.42798471281356, 218, 41, 'PPL', 'P'),
(78179, 'East Uniontown', 39.8997192382813, 0.696381471329332, -79.6980590820313, -1.39099353843041, 218, 45, 'PPL', 'P'),
(143773, 'East Unity', 43.297779083252, 0.755688803803879, -72.1963882446289, -1.2600646829169, 218, 36, 'PPL', 'P'),
(186656, 'East Vancorum', 38.2277793884277, 0.667200616054088, -108.594436645508, -1.8953304688125, 218, 7, 'PPL', 'P'),
(161142, 'East Vandergrift', 40.5980606079102, 0.708569827532243, -79.561393737793, -1.38860827820009, 218, 45, 'PPL', 'P'),
(148572, 'East Varick', 42.7700004577637, 0.746477329067458, -76.7697219848633, -1.33988441447654, 218, 40, 'PPL', 'P'),
(127388, 'East Vassalboro', 44.4477806091309, 0.775760116833424, -69.6063919067383, -1.21486071920612, 218, 26, 'PPL', 'P'),
(148547, 'East Venice', 42.6908302307129, 0.74509554793587, -76.5008316040039, -1.3351913920036, 218, 40, 'PPL', 'P'),
(148548, 'East Verona', 43.2180595397949, 0.754297435292367, -75.5491714477539, -1.318581788917, 218, 40, 'PPL', 'P'),
(148549, 'East Victor', 42.9744415283203, 0.750045498874973, -77.3811111450195, -1.35055516833227, 218, 40, 'PPL', 'P'),
(78180, 'East View', 39.8936080932617, 0.696274811727674, -80.2300033569336, -1.40027771746459, 218, 45, 'PPL', 'P'),
(80812, 'East View', 34.639720916748, 0.604577181969202, -82.4372177124023, -1.43880087526481, 218, 48, 'PPL', 'P'),
(86688, 'East View', 35.3394393920898, 0.616789573200951, -84.9330596923828, -1.48236153542496, 218, 50, 'PPL', 'P'),
(109010, 'East View', 39.2691688537598, 0.685376291019716, -80.3125, -1.40171755550795, 218, 58, 'PPL', 'P'),
(80811, 'East View Estates', 34.1444396972656, 0.595932893965941, -79.7252807617188, -1.39146864636889, 218, 48, 'PPL', 'P'),
(86689, 'East Village', 36.2313919067383, 0.632357081353009, -83.2247161865234, -1.45254531649265, 218, 50, 'PPL', 'P'),
(113348, 'East Village', 41.3583297729492, 0.721839027663563, -73.1869430541992, -1.27735312576537, 218, 8, 'PPL', 'P'),
(119459, 'East Village', 40.464168548584, 0.706232970254726, -90.6791687011719, -1.58265005680684, 218, 18, 'PPL', 'P'),
(124746, 'East Village', 42.0611114501953, 0.734104881854195, -71.8644409179688, -1.25427110912349, 218, 23, 'PPL', 'P'),
(181285, 'East Village', 35.5663909912109, 0.62075062584828, -121.077781677246, -2.11320594127881, 218, 6, 'PPL', 'P'),
(46766, 'East Vindex', 39.417781829834, 0.687970076763398, -79.1875, -1.38208260142301, 218, 25, 'PPL', 'P'),
(70772, 'East Vineland', 39.4808311462402, 0.689070494925819, -74.9197235107422, -1.30759584994626, 218, 37, 'PPL', 'P'),
(148551, 'East Virgil', 42.4911117553711, 0.741609802964093, -76.0983276367188, -1.32816637252214, 218, 40, 'PPL', 'P'),
(93893, 'East Waco', 31.5569400787354, 0.550772506228491, -97.0966720581055, -1.69465662014312, 218, 51, 'PPL', 'P'),
(72392, 'East Wahlsburg', 38.9111099243164, 0.679126983784763, -83.8591690063477, -1.46361860714715, 218, 41, 'PPL', 'P'),
(143774, 'East Wakefield', 43.6141700744629, 0.761210868324158, -71.0055618286133, -1.23928084113771, 218, 36, 'PPL', 'P'),
(148552, 'East Walden', 41.5586090087891, 0.725334559752346, -74.1580581665039, -1.29430228189096, 218, 40, 'PPL', 'P'),
(127389, 'East Wales', 44.1575012207031, 0.770693785754685, -70.0411071777344, -1.2224479319937, 218, 26, 'PPL', 'P'),
(113317, 'East Wallingford', 41.4436111450195, 0.723327468396808, -72.789436340332, -1.27041532480961, 218, 8, 'PPL', 'P'),
(171980, 'East Wallingford', 43.4494400024414, 0.758335786190336, -72.8763885498047, -1.27193292715679, 218, 55, 'PPL', 'P'),
(124747, 'East Walpole', 42.1619415283203, 0.735864698702519, -71.2111129760742, -1.24286838544215, 218, 23, 'PPL', 'P'),
(124748, 'East Wareham', 41.7580604553223, 0.728815644192216, -70.6741714477539, -1.23349698788227, 218, 23, 'PPL', 'P'),
(127390, 'East Warren', 44.1322212219238, 0.770252566541086, -69.2008285522461, -1.2077823033448, 218, 26, 'PPL', 'P'),
(161145, 'East Warren', 41.8466682434082, 0.730362141837225, -79.1366729736328, -1.3811955024639, 218, 45, 'PPL', 'P'),
(169361, 'East Warren', 41.7305603027344, 0.728335675984756, -71.2605590820313, -1.24373138279339, 218, 47, 'PPL', 'P'),
(171981, 'East Warren', 44.1094398498535, 0.769854956590337, -72.8202819824219, -1.27095368282397, 218, 55, 'PPL', 'P'),
(20767, 'East Warrenton', 33.4066696166992, 0.583056376937353, -82.6399993896484, -1.44234008319547, 218, 13, 'PPL', 'P'),
(143775, 'East Washington', 43.1911087036133, 0.753827054464831, -72.0188903808594, -1.25696676077887, 218, 36, 'PPL', 'P'),
(161146, 'East Washington', 40.1736106872559, 0.701161778906997, -80.2377777099609, -1.40041340552213, 218, 45, 'PPL', 'P'),
(127391, 'East Waterboro', 43.5713882446289, 0.760464184533527, -70.679443359375, -1.23358900009794, 218, 26, 'PPL', 'P'),
(127392, 'East Waterford', 44.211669921875, 0.771639207941663, -70.682502746582, -1.23364239647779, 218, 26, 'PPL', 'P'),
(161148, 'East Waterford', 40.3702812194824, 0.704594327236, -77.6050033569336, -1.35446282459974, 218, 45, 'PPL', 'P'),
(124749, 'East Watertown', 42.3694381713867, 0.739486198310864, -71.1624984741211, -1.24201990231885, 218, 23, 'PPL', 'P'),
(148553, 'East Watertown', 43.9583282470703, 0.767217561583804, -75.8550033569336, -1.32391956268984, 218, 40, 'PPL', 'P'),
(173912, 'East Waupun', 43.6241683959961, 0.761385371954585, -88.690559387207, -1.54794227674233, 218, 57, 'PPL', 'P'),
(148554, 'East Waverly', 42.0105590820313, 0.733222576585052, -76.5183334350586, -1.33549685658064, 218, 40, 'PPL', 'P'),
(161149, 'East Wayne', 41.5722198486328, 0.725572113721581, -79.9080581665039, -1.39465871388064, 218, 45, 'PPL', 'P'),
(143776, 'East Weare (historical)', 43.0969390869141, 0.752183484598089, -71.6747207641602, -1.25095986778214, 218, 36, 'PPL', 'P'),
(161150, 'East Weissport', 40.8372192382813, 0.712743933066779, -75.6855621337891, -1.32096225545736, 218, 45, 'PPL', 'P'),
(171982, 'East Wells', 43.4216690063477, 0.757851090871941, -73.1416702270508, -1.27656296586994, 218, 55, 'PPL', 'P'),
(207279, 'East Wenatchee', 47.415828704834, 0.827562328460992, -120.291938781738, -2.09949039534879, 218, 56, 'PPL', 'P'),
(207280, 'East Wenatchee Bench', 47.4258308410645, 0.827736898670446, -120.279998779297, -2.09928200299349, 218, 56, 'PPL', 'P'),
(143777, 'East Westmoreland', 42.9902801513672, 0.750321934996124, -72.3908309936523, -1.26345834909399, 218, 36, 'PPL', 'P'),
(124750, 'East Weymouth', 42.2138900756836, 0.736771371895637, -70.9208297729492, -1.23780198778439, 218, 23, 'PPL', 'P'),
(124751, 'East Whately', 42.4458312988281, 0.740819509910612, -72.6152801513672, -1.26737572589944, 218, 23, 'PPL', 'P'),
(207281, 'East White Bluffs', 46.6736106872559, 0.814608180286628, -119.459999084473, -2.08497030845346, 218, 56, 'PPL', 'P'),
(64367, 'East White Oak', 36.1011085510254, 0.630083207835272, -79.7624969482422, -1.39211819135876, 218, 33, 'PPL', 'P'),
(148555, 'East White Plains', 41.038890838623, 0.716263766500509, -73.7480621337891, -1.28714650119997, 218, 40, 'PPL', 'P'),
(148556, 'East Whitehall', 43.5363883972168, 0.75985332195849, -73.3272171020508, -1.27980136975548, 218, 40, 'PPL', 'P'),
(181286, 'East Whittier', 33.9633293151855, 0.592771921489099, -118.017219543457, -2.05978905508232, 218, 6, 'PPL', 'P'),
(124752, 'East Wilbraham', 42.1541709899902, 0.735729077224007, -72.3958282470703, -1.26354556761969, 218, 23, 'PPL', 'P'),
(143778, 'East Wilder', 43.6819381713867, 0.762393644743289, -72.295280456543, -1.26179067761938, 218, 36, 'PPL', 'P'),
(161153, 'East William Penn', 40.8122215270996, 0.712307640701196, -76.2211074829102, -1.33030928509327, 218, 45, 'PPL', 'P'),
(109011, 'East Williamson', 37.6622200012207, 0.657329742631764, -82.2633285522461, -1.43576593688655, 218, 58, 'PPL', 'P'),
(148557, 'East Williamson', 43.2305603027344, 0.754515614764671, -77.1455612182617, -1.34644404655751, 218, 40, 'PPL', 'P'),
(113319, 'East Willington', 41.8736114501953, 0.730832389506706, -72.2375030517578, -1.26078227167263, 218, 8, 'PPL', 'P'),
(148558, 'East Williston', 40.7583312988281, 0.711367078783208, -73.6352767944336, -1.28517802568024, 218, 40, 'PPL', 'P'),
(113187, 'East Wilson', 43.2411117553711, 0.75469977235405, -78.7594375610352, -1.37461150245896, 218, 40, 'PPL', 'P'),
(127393, 'East Wilton', 44.6158294677734, 0.778693122720956, -70.1933288574219, -1.22510470149716, 218, 26, 'PPL', 'P'),
(191412, 'East Wind Estates Colonia', 31.8229999542236, 0.555416127063207, -106.177001953125, -1.85313827397848, 218, 51, 'PPL', 'P'),
(148559, 'East Windham', 42.336669921875, 0.738914284466769, -74.1594390869141, -1.29432638349883, 218, 40, 'PPL', 'P'),
(46767, 'East Winds', 38.413890838623, 0.670448873635658, -75.4574966430664, -1.31698176173408, 218, 25, 'PPL', 'P'),
(124753, 'East Windsor', 42.4777793884277, 0.741377109263847, -72.9861068725586, -1.27384787313861, 218, 23, 'PPL', 'P'),
(148560, 'East Windsor', 42.1111106872559, 0.734977533164387, -75.60888671875, -1.3196240170096, 218, 40, 'PPL', 'P'),
(181287, 'East Windsor', 38.5441703796387, 0.672722680574368, -122.800827026367, -2.14327875578214, 218, 6, 'PPL', 'P'),
(113321, 'East Windsor Hill', 41.860279083252, 0.73059969580646, -72.6036071777344, -1.26717199407605, 218, 8, 'PPL', 'P'),
(148561, 'East Winfield', 42.8886108398438, 0.748547470761804, -75.1455612182617, -1.31153746151763, 218, 40, 'PPL', 'P'),
(127394, 'East Winn', 45.4258308410645, 0.79283031363056, -68.3069381713867, -1.19218097304689, 218, 26, 'PPL', 'P'),
(173913, 'East Winona', 44.047779083252, 0.768778773193836, -91.5950012207031, -1.59863434966949, 218, 57, 'PPL', 'P'),
(127395, 'East Winslow', 44.5441703796387, 0.777442435694027, -69.5386123657227, -1.2136777430499, 218, 26, 'PPL', 'P'),
(64368, 'East Winston', 36.1002807617188, 0.630068760186359, -80.2291717529297, -1.40026320323665, 218, 33, 'PPL', 'P'),
(127396, 'East Winthrop', 44.3216705322266, 0.773559080771501, -69.8969421386719, -1.21993177739579, 218, 26, 'PPL', 'P'),
(143779, 'East Wolfeboro', 43.6100006103516, 0.761138097447371, -71.1086120605469, -1.24107940697989, 218, 36, 'PPL', 'P'),
(20768, 'East Wood', 33.5994415283203, 0.586420881500505, -83.7783279418945, -1.46220766440162, 218, 13, 'PPL', 'P'),
(148562, 'East Woodhull', 42.084171295166, 0.734507352073933, -77.3550033569336, -1.35009950146976, 218, 40, 'PPL', 'P'),
(148563, 'East Woods', 41.211109161377, 0.719269543264827, -73.5313873291016, -1.28336481245206, 218, 40, 'PPL', 'P'),
(113327, 'East Woodstock', 41.9836082458496, 0.732752195757517, -71.977783203125, -1.2562493051812, 218, 8, 'PPL', 'P'),
(148564, 'East Worcester', 42.6233291625977, 0.743917432048647, -74.6719436645508, -1.30327127581013, 218, 40, 'PPL', 'P'),
(59749, 'East Yazo Skatane (historical)', 32.6847190856934, 0.57045596313478, -88.6347198486328, -1.54696769294141, 218, 30, 'PPL', 'P'),
(78181, 'East Yoe', 39.9161109924316, 0.696667561409434, -76.6297225952148, -1.33744096417639, 218, 45, 'PPL', 'P'),
(78182, 'East York', 39.9736099243164, 0.697671107087203, -76.6866683959961, -1.33843485589521, 218, 45, 'PPL', 'P'),
(2187, 'Eastaboga', 33.6058311462402, 0.586532401371152, -86.0213928222656, -1.50135653189995, 218, 2, 'PPL', 'P'),
(59750, 'Eastabuchie', 31.4352798461914, 0.548649134601857, -89.283332824707, -1.55828812494507, 218, 30, 'PPL', 'P'),
(20769, 'Eastanollee', 34.5202789306641, 0.602492526046915, -83.2555618286133, -1.45308367450701, 218, 13, 'PPL', 'P'),
(80813, 'Eastatoe', 34.9519386291504, 0.610026409033668, -82.9005584716797, -1.44688769707289, 218, 48, 'PPL', 'P'),
(32297, 'Eastborough', 37.688060760498, 0.657780748962369, -97.2633285522461, -1.6975653246857, 218, 20, 'PPL', 'P'),
(64370, 'Eastbronk', 35.6411094665527, 0.622054709255065, -80.4097213745117, -1.40341438859649, 218, 33, 'PPL', 'P'),
(64371, 'Eastbrook', 34.2758293151855, 0.598226075401581, -78.0488891601563, -1.36221009336884, 218, 33, 'PPL', 'P'),
(86690, 'Eastbrook', 35.2347183227539, 0.61496184574483, -86.1588897705078, -1.50375630635822, 218, 50, 'PPL', 'P'),
(127397, 'Eastbrook', 44.6786117553711, 0.779788880351469, -68.2649993896484, -1.19144900322128, 218, 26, 'PPL', 'P'),
(161154, 'Eastbrook', 41.041389465332, 0.716307375763359, -80.2783279418945, -1.40112114058182, 218, 45, 'PPL', 'P'),
(119460, 'Eastburn', 40.7730598449707, 0.711624140407428, -87.6355590820313, -1.52952904780746, 218, 18, 'PPL', 'P'),
(20771, 'Eastburn (historical)', 34.6086082458496, 0.604034163422935, -83.6725006103516, -1.4603606290276, 218, 13, 'PPL', 'P'),
(72393, 'Eastburn (historical)', 39.1041717529297, 0.682496548353986, -82.7558288574219, -1.44436168877895, 218, 41, 'PPL', 'P'),
(13701, 'Eastburn Acres', 39.7055587768555, 0.69299273200026, -75.6833267211914, -1.32092324014739, 218, 10, 'PPL', 'P'),
(13702, 'Eastburn Farms', 39.7388916015625, 0.693574499540388, -75.6999969482422, -1.32121419049649, 218, 10, 'PPL', 'P'),
(13703, 'Eastburn Heights', 39.709171295166, 0.693055782339068, -75.6811065673828, -1.32088449115353, 218, 10, 'PPL', 'P'),
(148566, 'Eastchester', 40.8875007629395, 0.713621511224987, -73.8333282470703, -1.28863467561711, 218, 40, 'PPL', 'P'),
(155117, 'Eastcleft', 40.0166702270508, 0.698422651146823, -83.0833282470703, -1.45007763142659, 218, 41, 'PPL', 'P'),
(80815, 'Eastcliff', 34.7722206115723, 0.606889737901772, -83.0205612182617, -1.44898214011218, 218, 48, 'PPL', 'P'),
(86691, 'Eastdale', 35.0422210693359, 0.61160213487164, -85.2388916015625, -1.48769930919781, 218, 50, 'PPL', 'P'),
(186657, 'Eastdale', 37.0286102294922, 0.646271165942292, -105.650283813477, -1.84394530821164, 218, 7, 'PPL', 'P'),
(139926, 'Eastedge', 46.6566696166992, 0.814312502826602, -97.8919372558594, -1.70853661627045, 218, 34, 'PPL', 'P'),
(191413, 'Easter', 34.6455612182617, 0.604679114459925, -102.396392822266, -1.78715419691402, 218, 51, 'PPL', 'P'),
(181288, 'Easter Cross', 32.8397216796875, 0.57316126874911, -117.243606567383, -2.04628696151368, 218, 6, 'PPL', 'P'),
(173914, 'Easter Rock', 43.1511116027832, 0.753128973364094, -90.720832824707, -1.58337723294249, 218, 57, 'PPL', 'P'),
(35688, 'Easterday', 38.6755599975586, 0.675015862010008, -85.0744400024414, -1.48482908733298, 218, 21, 'PPL', 'P'),
(20773, 'Easterling (historical)', 32.0188903808594, 0.558835059981137, -81.8513870239258, -1.42857620089167, 218, 13, 'PPL', 'P'),
(93894, 'Easterly', 31.1052799224854, 0.542889549401856, -96.3838882446289, -1.68221619574303, 218, 51, 'PPL', 'P'),
(35689, 'Eastern', 37.5169410705566, 0.6547941469579, -82.8061065673828, -1.44523920035813, 218, 21, 'PPL', 'P'),
(203800, 'Eastern Addition Sandy Plat A', 40.5911102294922, 0.70844852054459, -111.880279541016, -1.95267924604237, 218, 52, 'PPL', 'P'),
(64373, 'Eastern Heights', 35.8013916015625, 0.624852160243112, -80.2313919067383, -1.40030195223051, 218, 33, 'PPL', 'P'),
(122542, 'Eastern Heights', 40.1088905334473, 0.70003219913064, -85.6572189331055, -1.49500049848431, 218, 19, 'PPL', 'P'),
(148568, 'Eastern Parkway', 40.6691703796387, 0.709810927179247, -73.9397201538086, -1.29049156468717, 218, 40, 'PPL', 'P'),
(15867, 'Eastern Shores', 25.9333305358887, 0.452622003859243, -80.1358337402344, -1.39863414759785, 218, 12, 'PPL', 'P'),
(124754, 'Eastern Summit', 42.6725006103516, 0.744775635709925, -73.0144424438477, -1.27434242215304, 218, 23, 'PPL', 'P'),
(46768, 'Eastern Terrace', 39.3066711425781, 0.68603082943663, -76.4863891601563, -1.33493932380643, 218, 25, 'PPL', 'P'),
(2191, 'Eastern Valley', 33.3594398498535, 0.582232062000947, -86.9686126708984, -1.51788863699884, 218, 2, 'PPL', 'P'),
(101616, 'Eastern View', 37.6263885498047, 0.656704365828786, -77.1444396972656, -1.3464244723235, 218, 53, 'PPL', 'P'),
(54545, 'Easterville', 39.6272201538086, 0.691625465096614, -93.8988876342773, -1.63884475317833, 218, 29, 'PPL', 'P'),
(46769, 'Eastfield', 39.2627792358398, 0.685264771149068, -76.5105590820313, -1.3353611685231, 218, 25, 'PPL', 'P'),
(64374, 'Eastfield (historical)', 35.3436088562012, 0.616862344077738, -80.7152786254883, -1.40874736867937, 218, 33, 'PPL', 'P'),
(64376, 'Eastfield Estates', 35.7938919067383, 0.624721265875534, -80.8511123657227, -1.41111811468176, 218, 33, 'PPL', 'P'),
(113335, 'Eastford', 41.9019393920898, 0.731326805363079, -72.0802764892578, -1.25803815048541, 218, 8, 'PPL', 'P'),
(15869, 'Eastgate', 27.0972194671631, 0.472935697837499, -82.42138671875, -1.43852457230171, 218, 12, 'PPL', 'P'),
(29693, 'Eastgate', 39.9308280944824, 0.696924423296572, -85.829719543457, -1.49801120209665, 218, 19, 'PPL', 'P'),
(93895, 'Eastgate', 30.0552806854248, 0.524563605571721, -95.0116729736328, -1.658266521218, 218, 51, 'PPL', 'P'),
(190151, 'Eastgate', 39.3055610656738, 0.6860114549397, -117.878059387207, -2.05736025216817, 218, 39, 'PPL', 'P'),
(207282, 'Eastgate', 47.5669403076172, 0.830199723467524, -122.157218933105, -2.13204567546225, 218, 56, 'PPL', 'P'),
(115396, 'Eastgate Estate Park', 42.4930610656738, 0.741643824847019, -92.3055572509766, -1.61103589191767, 218, 16, 'PPL', 'P'),
(20775, 'Eastgate Mobile Home Park', 34.100830078125, 0.595171762526396, -84.5791702270508, -1.4761849990668, 218, 13, 'PPL', 'P'),
(8669, 'Eastgate Place', 35.4561080932617, 0.618825826170426, -94.3008270263672, -1.64585991896376, 218, 4, 'PPL', 'P'),
(203801, 'Eastgrove Condominium', 41.2308311462402, 0.71961375683572, -111.94361114502, -1.95378459105281, 218, 52, 'PPL', 'P'),
(203802, 'Eastgrove Condominium Phase 2-7', 41.2308311462402, 0.71961375683572, -111.94361114502, -1.95378459105281, 218, 52, 'PPL', 'P'),
(109016, 'Eastgulf', 37.6294403076172, 0.656757629050588, -81.2949981689453, -1.41886538345086, 218, 58, 'PPL', 'P'),
(101617, 'Eastham', 38.0716705322266, 0.664476002521855, -78.4119415283203, -1.36854655255046, 218, 53, 'PPL', 'P'),
(124755, 'Eastham', 41.8300018310547, 0.730071258067161, -69.9744415283203, -1.22128439691344, 218, 23, 'PPL', 'P'),
(196405, 'Eastham Junction', 47.7291717529297, 0.833031196338497, -112.093330383301, -1.9563976847144, 218, 31, 'PPL', 'P'),
(124757, 'Easthampton', 42.2666702270508, 0.737692559316695, -72.6694412231445, -1.26832101492837, 218, 23, 'PPL', 'P'),
(64378, 'Easthaven', 35.5952796936035, 0.62125482882166, -77.3547210693359, -1.35009457462174, 218, 33, 'PPL', 'P'),
(155118, 'Eastlake', 41.6538887023926, 0.726997504116019, -81.4505615234375, -1.42158047618219, 218, 41, 'PPL', 'P'),
(181290, 'Eastlake', 32.6597213745117, 0.570019670769198, -116.978057861328, -2.04165226226861, 218, 6, 'PPL', 'P'),
(192923, 'Eastlake', 39.9238891601563, 0.696803316046, -104.960830688477, -1.83191208114222, 218, 7, 'PPL', 'P'),
(181291, 'Eastlake (historical)', 39.0077781677246, 0.680814162914355, -122.66667175293, -2.14093730455175, 218, 6, 'PPL', 'P'),
(181292, 'Eastlake Greens', 32.6433296203613, 0.569733580689096, -116.961669921875, -2.04136623876754, 218, 6, 'PPL', 'P'),
(15870, 'Eastlake Weir', 29.0200004577637, 0.506494556918238, -81.908332824707, -1.42957009261049, 218, 12, 'PPL', 'P'),
(35690, 'Eastland', 38.0461082458496, 0.66402985646024, -84.459716796875, -1.47410014340743, 218, 21, 'PPL', 'P'),
(59754, 'Eastland', 33.6505584716797, 0.587313040465682, -90.5219421386719, -1.57990593561962, 218, 30, 'PPL', 'P'),
(78183, 'Eastland', 39.7544403076172, 0.693845875655467, -76.1155624389648, -1.32846717656726, 218, 45, 'PPL', 'P'),
(86693, 'Eastland', 35.8980598449707, 0.626539339372704, -85.2369384765625, -1.48766522073586, 218, 50, 'PPL', 'P'),
(93896, 'Eastland', 32.4013900756836, 0.565510939043693, -98.8172225952148, -1.72468589196263, 218, 51, 'PPL', 'P'),
(192547, 'Eastland', 37.8036117553711, 0.659797494276859, -109.133331298828, -1.90473595483433, 218, 52, 'PPL', 'P'),
(207283, 'Eastland', 47.6133308410645, 0.831009391017936, -122.22444152832, -2.13321893108048, 218, 56, 'PPL', 'P'),
(13081, 'Eastland Gardens', 38.9083290100098, 0.679078447673896, -76.9430618286133, -1.34290976547487, 218, 9, 'PPL', 'P'),
(122543, 'Eastland Gardens', 41.019718170166, 0.715929140309541, -85.1002807617188, -1.48528009366358, 218, 19, 'PPL', 'P'),
(20776, 'Eastland Heights', 33.7188911437988, 0.588505670580846, -84.3300018310547, -1.47183619016475, 218, 13, 'PPL', 'P'),
(124759, 'Eastland Heights', 41.8499984741211, 0.730420265328016, -70.5458297729492, -1.23125700308941, 218, 23, 'PPL', 'P'),
(161155, 'Eastland Hills', 40.0352783203125, 0.698747423641758, -76.2547225952148, -1.33089597948141, 218, 45, 'PPL', 'P'),
(35692, 'Eastland Park', 36.9594383239746, 0.645063888441132, -86.4383316040039, -1.50863348642054, 218, 21, 'PPL', 'P'),
(93898, 'Eastland Park Colonia', 26.1529998779297, 0.456455957143548, -97.8880004882813, -1.70846790671432, 218, 51, 'PPL', 'P'),
(130596, 'Eastlawn', 42.2355613708496, 0.737149607349455, -83.5880584716797, -1.45888683568035, 218, 27, 'PPL', 'P'),
(161156, 'Eastlawn Gardens', 40.750560760498, 0.711231457304695, -75.2961120605469, -1.31416506940715, 218, 45, 'PPL', 'P'),
(199933, 'Eastline', 40.735279083252, 0.710964741721524, -114.044998168945, -1.990460713479, 218, 39, 'PPL', 'P'),
(20777, 'Eastman', 32.1974983215332, 0.561952356616102, -83.1777801513672, -1.45172612814134, 218, 13, 'PPL', 'P'),
(59755, 'Eastman', 34.3383293151855, 0.599316906184078, -88.2361068725586, -1.54001058406774, 218, 30, 'PPL', 'P'),
(75735, 'Eastman', 33.9883308410645, 0.593208280433708, -97.2644424438477, -1.69758476576166, 218, 42, 'PPL', 'P'),
(143780, 'Eastman', 43.5138893127441, 0.759460638855758, -72.1166687011719, -1.25867331440539, 218, 36, 'PPL', 'P'),
(173915, 'Eastman', 43.166389465332, 0.753395622368239, -91.0175018310547, -1.58855508389187, 218, 57, 'PPL', 'P'),
(207284, 'Eastman', 46.1347198486328, 0.805202760843823, -118.139167785645, -2.06191745342552, 218, 56, 'PPL', 'P'),
(86694, 'Eastman (historical)', 36.3511085510254, 0.634446530965258, -81.9749984741211, -1.43073362769074, 218, 50, 'PPL', 'P'),
(143781, 'Eastman Corners', 42.9069404602051, 0.74886738298775, -70.9269409179688, -1.23790864738604, 218, 36, 'PPL', 'P'),
(13704, 'Eastman Heights', 38.889720916748, 0.678753675178961, -75.4166717529297, -1.31626923298443, 218, 10, 'PPL', 'P'),
(193514, 'Eastman Place', 40.5113906860352, 0.707057152033078, -121.731391906738, -2.12461359180816, 218, 6, 'PPL', 'P'),
(143782, 'Eastman Point', 42.9166717529297, 0.749037226086269, -70.8222198486328, -1.23608091992992, 218, 36, 'PPL', 'P'),
(130597, 'Eastmanville', 43.0169410705566, 0.750787255817588, -85.9563903808594, -1.50022202527558, 218, 27, 'PPL', 'P'),
(20778, 'Eastmeadow', 33.9394416809082, 0.592355003620447, -83.3166732788086, -1.45415027052359, 218, 13, 'PPL', 'P'),
(80825, 'Eastminster', 34.6591682434082, 0.604916601850133, -83.0844421386719, -1.45009707250254, 218, 48, 'PPL', 'P'),
(130598, 'Eastmont', 42.9511108398438, 0.7496383015443, -85.5558319091797, -1.49323096109801, 218, 27, 'PPL', 'P'),
(161158, 'Eastmont', 40.0286102294922, 0.698631043502122, -76.8280563354492, -1.34090254096128, 218, 45, 'PPL', 'P'),
(72395, 'Eastmoor', 39.9677810668945, 0.697569374333562, -82.9111099243164, -1.44707185466227, 218, 41, 'PPL', 'P'),
(72396, 'Eastmoor Subdivision', 39.5963897705078, 0.691087373398363, -82.932502746582, -1.4474452298471, 218, 41, 'PPL', 'P'),
(148569, 'Eastmor', 42.684440612793, 0.744984028065223, -73.6322174072266, -1.28512462930039, 218, 40, 'PPL', 'P'),
(200743, 'Eastmoreland', 45.473331451416, 0.793659355677901, -122.623062133789, -2.1401761731122, 218, 43, 'PPL', 'P'),
(2193, 'Easton', 32.9091682434082, 0.574373339940232, -85.6966705322266, -1.49568905878415, 218, 2, 'PPL', 'P'),
(32298, 'Easton', 39.3450012207031, 0.686699815502458, -95.1155624389648, -1.66007973444618, 218, 20, 'PPL', 'P'),
(35693, 'Easton', 37.7061080932617, 0.658095734340298, -86.6816711425781, -1.51288056256894, 218, 21, 'PPL', 'P'),
(40754, 'Easton', 30.7511100769043, 0.536708119485187, -92.4286117553711, -1.61318359817876, 218, 22, 'PPL', 'P'),
(46770, 'Easton', 38.774169921875, 0.676736929864471, -76.0766677856445, -1.3277883368054, 218, 25, 'PPL', 'P'),
(54550, 'Easton', 39.7222213745117, 0.693283549191297, -94.6413879394531, -1.65180382820071, 218, 29, 'PPL', 'P'),
(93899, 'Easton', 32.3872184753418, 0.565263597957452, -94.5827789306641, -1.65078090802601, 218, 51, 'PPL', 'P'),
(109017, 'Easton', 39.6525001525879, 0.692066684310213, -79.9130630493164, -1.39474606556439, 218, 58, 'PPL', 'P'),
(113340, 'Easton', 41.2527809143066, 0.719996852558528, -73.2977828979492, -1.2792876459812, 218, 8, 'PPL', 'P'),
(119462, 'Easton', 40.2324981689453, 0.702189559350686, -89.8424987792969, -1.56804741191772, 218, 18, 'PPL', 'P'),
(124769, 'Easton', 42.0244407653809, 0.733464857665222, -71.1291732788086, -1.24143826793678, 218, 23, 'PPL', 'P'),
(127400, 'Easton', 46.6411094665527, 0.814040926974441, -67.9100036621094, -1.18525315894522, 218, 26, 'PPL', 'P'),
(130599, 'Easton', 43.1138916015625, 0.752479361795197, -84.0883331298828, -1.46761827563028, 218, 27, 'PPL', 'P'),
(135123, 'Easton', 43.7658309936523, 0.763857850710615, -93.9008331298828, -1.63887870848223, 218, 28, 'PPL', 'P'),
(143783, 'Easton', 44.146110534668, 0.77049498077931, -71.7905578613281, -1.25298160652367, 218, 36, 'PPL', 'P'),
(148570, 'Easton', 42.9933280944824, 0.750375131638898, -73.5527801513672, -1.28373818763689, 218, 40, 'PPL', 'P'),
(155122, 'Easton', 40.9524993896484, 0.714755951270333, -81.7355575561523, -1.42655459530819, 218, 41, 'PPL', 'P'),
(161160, 'Easton', 40.6883316040039, 0.710145353633134, -75.2211074829102, -1.31285599257333, 218, 45, 'PPL', 'P'),
(173918, 'Easton', 43.8380584716797, 0.765118458012604, -89.8066711425781, -1.56742210169377, 218, 57, 'PPL', 'P'),
(181295, 'Easton', 36.6502799987793, 0.639668057756522, -119.78971862793, -2.09072500009496, 218, 6, 'PPL', 'P'),
(207285, 'Easton', 47.2372207641602, 0.824445031826027, -121.177780151367, -2.11495124389919, 218, 56, 'PPL', 'P'),
(161161, 'Easton Anglers', 41.1786117553711, 0.718702356531667, -75.1616668701172, -1.31181855817069, 218, 45, 'PPL', 'P'),
(124760, 'Easton Center', 42.0361099243164, 0.733668522909586, -71.0972213745117, -1.24088060200452, 218, 23, 'PPL', 'P'),
(127401, 'Easton Center', 46.6438903808594, 0.814089463085308, -67.8672180175781, -1.18450640857556, 218, 26, 'PPL', 'P'),
(124761, 'Easton Green', 42.0416717529297, 0.733765595131319, -71.07861328125, -1.24055582950958, 218, 23, 'PPL', 'P'),
(203803, 'Easton in Holladay Condominium', 40.6661109924316, 0.709757530799391, -111.828056335449, -1.95176777915929, 218, 52, 'PPL', 'P'),
(101618, 'Easton Place', 36.8416709899902, 0.643008460711809, -76.1922225952148, -1.32980514869892, 218, 53, 'PPL', 'P'),
(115397, 'Easton Place', 41.610279083252, 0.726236372676474, -93.5661087036133, -1.63303666515698, 218, 16, 'PPL', 'P'),
(113094, 'Easton Station', 46.6611099243164, 0.814390000814323, -67.9102783203125, -1.18525795263518, 218, 26, 'PPL', 'P'),
(124762, 'Easton Station', 42.038330078125, 0.733707271903446, -71.0950012207031, -1.24084185301066, 218, 23, 'PPL', 'P'),
(64380, 'Easton View', 36.0561103820801, 0.629297841629808, -80.2099990844727, -1.39992857704569, 218, 33, 'PPL', 'P'),
(124764, 'Eastondale', 42.0361099243164, 0.733668522909586, -71.0694427490234, -1.24039577352807, 218, 23, 'PPL', 'P'),
(186658, 'Eastonville', 39.0611114501953, 0.681745004294365, -104.561668395996, -1.82494538488863, 218, 7, 'PPL', 'P'),
(64381, 'Eastover', 35.0963897705078, 0.612547557058618, -78.7841720581055, -1.37504320087166, 218, 33, 'PPL', 'P'),
(80818, 'Eastover', 33.8766708374023, 0.591259445727016, -80.6930618286133, -1.40835961242466, 218, 48, 'PPL', 'P'),
(86696, 'Eastover', 35.7244415283203, 0.623509128105385, -83.9602813720703, -1.46538335084349, 218, 50, 'PPL', 'P'),
(101620, 'Eastover', 37.1980590820313, 0.649228606332825, -76.8930587768555, -1.34203704758565, 218, 53, 'PPL', 'P'),
(124765, 'Eastover', 42.3708305358887, 0.739510499655811, -73.258056640625, -1.2785942919914, 218, 23, 'PPL', 'P'),
(64384, 'Eastover Acres', 35.8105583190918, 0.625012149645598, -80.870002746582, -1.41144781402471, 218, 33, 'PPL', 'P'),
(101621, 'Eastover Gardens', 37.5233306884766, 0.654905666828547, -77.3708267211914, -1.3503756712748, 218, 53, 'PPL', 'P'),
(15871, 'Eastpoint', 29.7363891601563, 0.518997898499078, -84.8786087036133, -1.48141118638997, 218, 12, 'PPL', 'P'),
(46771, 'Eastpoint', 39.2844390869141, 0.685642806865805, -76.5152816772461, -1.33544359335883, 218, 25, 'PPL', 'P'),
(122544, 'Eastpoint Terminal', 41.6652793884277, 0.727196309091393, -84.8530578613281, -1.48096524006543, 218, 19, 'PPL', 'P'),
(130601, 'Eastpointe', 42.4683303833008, 0.741212193013344, -82.9555587768555, -1.44784763348781, 218, 27, 'PPL', 'P'),
(155123, 'Eastpointe On The Mall', 41.5969390869141, 0.726003545818174, -83.4524993896484, -1.45652088336792, 218, 41, 'PPL', 'P'),
(8671, 'Eastport', 33.7886085510254, 0.589722468882903, -94.4813919067383, -1.64901137063971, 218, 4, 'PPL', 'P'),
(15872, 'Eastport', 30.423059463501, 0.530982556168112, -81.5991668701172, -1.42417412876782, 218, 12, 'PPL', 'P'),
(46772, 'Eastport', 38.9713897705078, 0.680179065573399, -76.4786071777344, -1.33480350259083, 218, 25, 'PPL', 'P'),
(59757, 'Eastport', 34.8855590820313, 0.608867867380456, -88.1005630493164, -1.53764489807143, 218, 30, 'PPL', 'P'),
(75736, 'Eastport', 33.788890838623, 0.58972739573092, -94.4816665649414, -1.64901616432967, 218, 42, 'PPL', 'P'),
(86698, 'Eastport', 36.4486083984375, 0.636148224322792, -85.1236114501953, -1.48568729099425, 218, 50, 'PPL', 'P'),
(127403, 'Eastport', 44.9061088562012, 0.783759453799695, -66.9905624389648, -1.16920588232278, 218, 26, 'PPL', 'P'),
(130602, 'Eastport', 45.1072196960449, 0.78726950011642, -85.3499984741211, -1.48963848994555, 218, 27, 'PPL', 'P'),
(148573, 'Eastport', 40.8258285522461, 0.712545128091404, -72.7322235107422, -1.26941677255888, 218, 40, 'PPL', 'P'),
(155124, 'Eastport', 40.4258308410645, 0.705563851030843, -81.3533325195313, -1.41988350993559, 218, 41, 'PPL', 'P'),
(181296, 'Eastport', 37.8397216796875, 0.660427731348826, -122.179443359375, -2.13243356487502, 218, 6, 'PPL', 'P'),
(194869, 'Eastport', 48.999439239502, 0.855201546360215, -116.180282592773, -2.02772845714135, 218, 17, 'PPL', 'P'),
(171983, 'Eastridge Acres', 43.6108283996582, 0.761152545096285, -72.9319381713867, -1.27290245095163, 218, 55, 'PPL', 'P'),
(32300, 'Eastshore', 38.3819389343262, 0.669891207703395, -97.0736083984375, -1.69425408334435, 218, 20, 'PPL', 'P'),
(59758, 'Eastside', 31.2819404602051, 0.545972857443409, -89.1936111450195, -1.5567221862241, 218, 30, 'PPL', 'P'),
(64388, 'Eastside', 35.788890838623, 0.624633980770807, -80.8602828979492, -1.41127817066328, 218, 33, 'PPL', 'P'),
(75737, 'Eastside', 36.8713912963867, 0.643527177913129, -94.7163925170898, -1.65311290503454, 218, 42, 'PPL', 'P'),
(148574, 'Eastside', 41.003059387207, 0.715638389697531, -72.1333312988281, -1.25896413159643, 218, 40, 'PPL', 'P'),
(200744, 'Eastside', 43.3638916015625, 0.756842684925183, -124.191673278809, -2.16755360227627, 218, 43, 'PPL', 'P'),
(135125, 'Eastside Mobile Home Park', 43.6327781677246, 0.761535640819093, -91.4861068725586, -1.59673378475756, 218, 28, 'PPL', 'P'),
(207286, 'Eastsound', 48.6969413757324, 0.849921962657188, -122.904167175293, -2.1450823816304, 218, 56, 'PPL', 'P'),
(161164, 'Eastvale', 40.7666702270508, 0.71151262053678, -80.3150024414063, -1.40176123134982, 218, 45, 'PPL', 'P'),
(8673, 'Eastview', 35.7197189331055, 0.623426703269647, -90.1263885498047, -1.57300222312581, 218, 4, 'PPL', 'P'),
(35694, 'Eastview', 37.5888900756836, 0.656049893990899, -86.0558319091797, -1.50195760735798, 218, 21, 'PPL', 'P'),
(46775, 'Eastview', 39.4372215270996, 0.688309363486274, -77.4727783203125, -1.35215506235714, 218, 25, 'PPL', 'P'),
(59759, 'Eastview', 31.6969394683838, 0.553215956528638, -89.0911102294922, -1.55493320776184, 218, 30, 'PPL', 'P'),
(86700, 'Eastview', 35.0755615234375, 0.612184035569823, -88.545280456543, -1.54540668106846, 218, 50, 'PPL', 'P'),
(143785, 'Eastview', 42.9319381713867, 0.749303675353332, -72.0374984741211, -1.2572915332738, 218, 36, 'PPL', 'P'),
(148575, 'Eastview', 41.0813903808594, 0.717005523443123, -73.829719543457, -1.28857169185733, 218, 40, 'PPL', 'P'),
(54546, 'Eastview (historical)', 36.7305603027344, 0.64106921338504, -92.7777786254883, -1.61927770970119, 218, 29, 'PPL', 'P'),
(46776, 'Eastview Estates', 39.5008316040039, 0.689419568765701, -76.9352798461914, -1.34277394425928, 218, 25, 'PPL', 'P'),
(203810, 'Eastview Estates', 40.6652793884277, 0.70974301657145, -111.966110229492, -1.95417727415554, 218, 52, 'PPL', 'P'),
(135126, 'Eastview Mobile Home Park', 45.2652816772461, 0.790028202110606, -94.1050033569336, -1.64244215117881, 218, 28, 'PPL', 'P'),
(124766, 'Eastview Park', 42.4008293151855, 0.74003407712612, -71.2152786254883, -1.24294108973991, 218, 23, 'PPL', 'P'),
(20780, 'Eastville', 33.877498626709, 0.591273893375929, -83.504997253418, -1.45743714394097, 218, 13, 'PPL', 'P'),
(54547, 'Eastville', 38.9524993896484, 0.679849366230447, -92.0319366455078, -1.60626031145094, 218, 29, 'PPL', 'P'),
(101622, 'Eastville', 37.3525009155273, 0.651924124830149, -75.9461135864258, -1.32550973617673, 218, 53, 'PPL', 'P'),
(124768, 'Eastville', 42.0377807617188, 0.733697684523522, -70.9222183227539, -1.23782622255031, 218, 23, 'PPL', 'P'),
(161166, 'Eastville', 41.0355606079102, 0.716205643009718, -77.2233276367188, -1.34780132660707, 218, 45, 'PPL', 'P'),
(101623, 'Eastville Station', 37.3472213745117, 0.651831979456432, -75.9322204589844, -1.32526725535948, 218, 53, 'PPL', 'P'),
(161189, 'Eastvue', 40.4658317565918, 0.706261998710607, -79.8022232055664, -1.39281154534856, 218, 45, 'PPL', 'P'),
(207287, 'Eastward', 47.1455612182617, 0.822845270959216, -122.621940612793, -2.14015659887819, 218, 56, 'PPL', 'P'),
(178132, 'Eastway Mobile Home Park', 33.4533309936523, 0.5838707715987, -111.817497253418, -1.95158348841186, 218, 5, 'PPL', 'P'),
(15873, 'Eastway Park', 26.2936096191406, 0.458910060088056, -80.0908279418945, -1.39784864823433, 218, 12, 'PPL', 'P'),
(80819, 'Eastway Park', 33.9319381713867, 0.592224042673842, -80.9722213745117, -1.41323186563896, 218, 48, 'PPL', 'P'),
(46778, 'Eastwick', 39.3222198486328, 0.686302205551709, -77.602783203125, -1.35442407560588, 218, 25, 'PPL', 'P'),
(78185, 'Eastwick', 39.8902816772461, 0.69621675481591, -75.2427825927734, -1.31323429460617, 218, 45, 'PPL', 'P'),
(20781, 'Eastwind', 30.8775005340576, 0.538914049105613, -83.2583312988281, -1.4531320108808, 218, 13, 'PPL', 'P'),
(122545, 'Eastwitch', 40.4269409179688, 0.705583225527774, -86.8499984741211, -1.51581842872546, 218, 19, 'PPL', 'P'),
(2200, 'Eastwood', 33.5480613708496, 0.585524128582448, -86.7613906860352, -1.51427193108046, 218, 2, 'PPL', 'P'),
(8674, 'Eastwood', 34.3494415283203, 0.599510850890463, -92.144172668457, -1.60821919959074, 218, 4, 'PPL', 'P'),
(15874, 'Eastwood', 28.023889541626, 0.489109141716578, -81.6705627441406, -1.42542022184187, 218, 12, 'PPL', 'P'),
(35695, 'Eastwood', 38.2330589294434, 0.667292761427805, -85.4558334350586, -1.49148565847763, 218, 21, 'PPL', 'P'),
(40756, 'Eastwood', 32.5561103820801, 0.568211317810006, -93.5669403076172, -1.63305117938492, 218, 22, 'PPL', 'P'),
(54549, 'Eastwood', 39.0347213745117, 0.681284410583836, -94.5072174072266, -1.6494621106542, 218, 29, 'PPL', 'P'),
(64391, 'Eastwood', 35.2455596923828, 0.61515106334028, -79.4480590820313, -1.38663021530043, 218, 33, 'PPL', 'P'),
(72398, 'Eastwood', 39.0488891601563, 0.68153168509105, -83.9847183227539, -1.46580985609207, 218, 41, 'PPL', 'P'),
(86702, 'Eastwood', 36.0063896179199, 0.628430050588606, -86.5666732788086, -1.51087347121341, 218, 50, 'PPL', 'P'),
(101624, 'Eastwood', 37.1130599975586, 0.647745092447596, -76.519172668457, -1.33551150396663, 218, 53, 'PPL', 'P'),
(130603, 'Eastwood', 42.3030586242676, 0.738327656657652, -85.5502777099609, -1.49313402203433, 218, 27, 'PPL', 'P'),
(148576, 'Eastwood', 43.0661087036133, 0.751645392899839, -76.1050033569336, -1.32828288581983, 218, 40, 'PPL', 'P'),
(161169, 'Eastwood', 40.2916717529297, 0.703222333221418, -79.5186080932617, -1.38786152783043, 218, 45, 'PPL', 'P'),
(207288, 'Eastwood', 47.610279083252, 0.830956127796134, -122.638893127441, -2.1404524760753, 218, 56, 'PPL', 'P'),
(109018, 'Eastwood Addition', 39.2577781677246, 0.685177486044341, -81.4763870239258, -1.42203121619669, 218, 58, 'PPL', 'P'),
(20782, 'Eastwood Estates', 33.4061088562012, 0.583046589820347, -84.7102813720703, -1.47847332023345, 218, 13, 'PPL', 'P'),
(40757, 'Eastwood Estates', 32.5458297729492, 0.568031887331562, -91.9980621337891, -1.60566908968894, 218, 22, 'PPL', 'P'),
(46779, 'Eastwood Estates', 39.5900001525879, 0.690975853527716, -75.7930603027344, -1.32283845244532, 218, 25, 'PPL', 'P'),
(86705, 'Eastwood Estates', 35.0138893127441, 0.61110765243624, -86.5566711425781, -1.51069890100395, 218, 50, 'PPL', 'P'),
(35696, 'Eastwood Hills', 37.9988899230957, 0.663205741260915, -86.1655578613281, -1.50387268649786, 218, 21, 'PPL', 'P'),
(119463, 'Eastwood Manor', 42.3455581665039, 0.739069413600266, -88.2411117553711, -1.5400979357515, 218, 18, 'PPL', 'P'),
(135127, 'Eastwood Manor Mobile Home Park', 44.1541709899902, 0.770635662263894, -93.966667175293, -1.64002772933454, 218, 28, 'PPL', 'P'),
(64396, 'Eastwood Park', 35.3641700744629, 0.617221205034626, -80.1666717529297, -1.39917237245416, 218, 33, 'PPL', 'P'),
(203814, 'Eastwood Subdivision Number 1', 41.1494407653809, 0.718193226710271, -111.913612365723, -1.9532610135825, 218, 52, 'PPL', 'P'),
(203815, 'Eastwood Subdivision Number 2', 41.1494407653809, 0.718193226710271, -111.913612365723, -1.9532610135825, 218, 52, 'PPL', 'P'),
(203816, 'Eastwood Subdivision Number 3', 41.1494407653809, 0.718193226710271, -111.913612365723, -1.9532610135825, 218, 52, 'PPL', 'P'),
(203817, 'Eastwood Subdivision Number 4', 41.1494407653809, 0.718193226710271, -111.913612365723, -1.9532610135825, 218, 52, 'PPL', 'P'),
(203818, 'Eastwood Subdivision Number 5', 41.151668548584, 0.718232108862187, -111.922218322754, -1.95341121586798, 218, 52, 'PPL', 'P'),
(203819, 'Eastwood Subdivision Number 6', 41.151668548584, 0.718232108862187, -111.922218322754, -1.95341121586798, 218, 52, 'PPL', 'P'),
(203820, 'Eastwood Subdivision Number 7', 41.151668548584, 0.718232108862187, -111.922218322754, -1.95341121586798, 218, 52, 'PPL', 'P'),
(64400, 'Easy Hill', 34.2222213745117, 0.597290440331609, -78.0083312988281, -1.3615022251511, 218, 33, 'PPL', 'P'),
(29694, 'Easytown', 39.6105613708496, 0.691334714484604, -87.5002822875977, -1.52716802234306, 218, 19, 'PPL', 'P'),
(8676, 'Eaton', 36.0400009155273, 0.629016678397723, -91.2161102294922, -1.59202145436672, 218, 4, 'PPL', 'P'),
(32301, 'Eaton', 37.2297210693359, 0.649781212259016, -96.7699966430664, -1.68895505856537, 218, 20, 'PPL', 'P'),
(86707, 'Eaton', 35.839168548584, 0.625511492349988, -84.2825012207031, -1.47100714811741, 218, 50, 'PPL', 'P'),
(109019, 'Eaton', 39.1961097717285, 0.684101169489786, -81.3138885498047, -1.41919508279381, 218, 58, 'PPL', 'P'),
(112582, 'Eaton', 30.9727802276611, 0.540576993469286, -96.3394393920898, -1.68144041691749, 218, 51, 'PPL', 'P'),
(122546, 'Eaton', 40.3402786254883, 0.704070683186663, -85.350830078125, -1.48965300417349, 218, 19, 'PPL', 'P'),
(127405, 'Eaton', 45.605281829834, 0.795962324230547, -67.8061065673828, -1.18343981255898, 218, 26, 'PPL', 'P'),
(148577, 'Eaton', 42.8497200012207, 0.74786869757897, -75.6122207641602, -1.31968220707942, 218, 40, 'PPL', 'P'),
(155125, 'Eaton', 41.3138885498047, 0.721063381996077, -82.0208282470703, -1.43153350812415, 218, 41, 'PPL', 'P'),
(194166, 'Eaton', 40.5302810668945, 0.70738685137603, -104.710830688477, -1.82754875801224, 218, 7, 'PPL', 'P'),
(194870, 'Eaton', 44.2758293151855, 0.772759000601014, -117.080276489258, -2.04343631388286, 218, 17, 'PPL', 'P'),
(139929, 'Eaton (historical)', 45.9630584716797, 0.802206704617483, -98.1755599975586, -1.71348676694663, 218, 34, 'PPL', 'P'),
(143786, 'Eaton Center', 43.9091682434082, 0.766359557659608, -71.0841674804688, -1.24065276857326, 218, 36, 'PPL', 'P'),
(148585, 'Eaton Corners', 43.1375007629395, 0.752891419394859, -75.8977813720703, -1.32466617990145, 218, 40, 'PPL', 'P'),
(86709, 'Eaton Crossroads', 35.8363914489746, 0.625463022818148, -84.2941665649414, -1.47121074678275, 218, 50, 'PPL', 'P'),
(155126, 'Eaton Estates', 41.3088912963867, 0.720976163470377, -82.0058288574219, -1.43127171938899, 218, 41, 'PPL', 'P'),
(86708, 'Eaton Forest', 35.8347206115723, 0.625433861204212, -84.3183288574219, -1.47163245834136, 218, 50, 'PPL', 'P'),
(15875, 'Eaton Park', 28.0083293914795, 0.488837565864417, -81.9077835083008, -1.42956050523056, 218, 12, 'PPL', 'P'),
(188465, 'Eaton Place', 31.6805591583252, 0.552930066185618, -108.936111450195, -1.9012938191254, 218, 38, 'PPL', 'P'),
(130605, 'Eaton Rapids', 42.5091705322266, 0.741924988079104, -84.6558303833008, -1.47752297119845, 218, 27, 'PPL', 'P'),
(46780, 'Eatons Landing', 38.9569396972656, 0.679926864218168, -76.5344390869141, -1.33577795323369, 218, 25, 'PPL', 'P'),
(148580, 'Eatons Neck', 40.9305610656738, 0.714373055284607, -73.4019393920898, -1.28110551974129, 218, 40, 'PPL', 'P'),
(20783, 'Eatonton', 33.3266716003418, 0.581660148156852, -83.3886108398438, -1.45540581781951, 218, 13, 'PPL', 'P'),
(145135, 'Eatontown', 40.2961082458496, 0.703299764630112, -74.0513916015625, -1.29244059913094, 218, 37, 'PPL', 'P'),
(15876, 'Eatonville', 28.6144409179688, 0.499416207635943, -81.3808288574219, -1.42036341156403, 218, 12, 'PPL', 'P'),
(59762, 'Eatonville', 31.413890838623, 0.548275825996055, -89.3291702270508, -1.55908813853653, 218, 30, 'PPL', 'P'),
(148581, 'Eatonville', 43.0808296203613, 0.751902321366004, -74.9319381713867, -1.30780903599152, 218, 40, 'PPL', 'P'),
(161171, 'Eatonville', 41.5144386291504, 0.724563641195796, -75.9613876342773, -1.32577631860185, 218, 45, 'PPL', 'P'),
(207289, 'Eatonville', 46.8675003051758, 0.817992192504765, -122.265281677246, -2.13393172614624, 218, 56, 'PPL', 'P'),
(207290, 'Eatonville Junction', 46.8797187805176, 0.818205445129053, -122.261108398438, -2.13385888869043, 218, 56, 'PPL', 'P'),
(196406, 'Eau Clair (historical)', 45.8430595397949, 0.800112328157218, -111.918891906738, -1.95335315895622, 218, 31, 'PPL', 'P'),
(80820, 'Eau Claire', 34.0344390869141, 0.594013021136103, -81.045280456543, -1.41450698716889, 218, 48, 'PPL', 'P'),
(130609, 'Eau Claire', 41.9850006103516, 0.732776497102464, -86.2997207641602, -1.50621427088631, 218, 27, 'PPL', 'P'),
(161172, 'Eau Claire', 41.1361083984375, 0.717960533010026, -79.7983322143555, -1.39274363474076, 218, 45, 'PPL', 'P'),
(173924, 'Eau Claire', 44.8113899230957, 0.782106296553029, -91.4983291625977, -1.59694710396088, 218, 57, 'PPL', 'P'),
(173927, 'Eau Galle', 44.6922187805176, 0.780026367741677, -92.0113906860352, -1.60590171681016, 218, 57, 'PPL', 'P'),
(15877, 'Eau Gallie', 28.1288890838623, 0.490941729441689, -80.6305618286133, -1.40726878164216, 218, 12, 'PPL', 'P'),
(54551, 'Eaudevie (historical)', 36.8433303833008, 0.643037422588663, -93.1988906860352, -1.62662750167759, 218, 29, 'PPL', 'P'),
(148582, 'Eavesport', 42.1172218322754, 0.735084192766045, -73.9361114501953, -1.29042858092739, 218, 40, 'PPL', 'P'),
(70773, 'Eayrestown', 39.9449996948242, 0.697171764382813, -74.7905578613281, -1.3053414840835, 218, 37, 'PPL', 'P'),
(46781, 'Eazee Acres', 39.3694381713867, 0.687126320751034, -76.9380569458008, -1.34282241379112, 218, 25, 'PPL', 'P'),
(86710, 'Ebaneezer (historical)', 36.2680587768555, 0.632997038962955, -86.3330612182617, -1.50679617158449, 218, 50, 'PPL', 'P'),
(8678, 'Ebb', 34.3202781677246, 0.599001854227121, -92.3230590820313, -1.6113413564947, 218, 4, 'PPL', 'P'),
(15883, 'Ebb', 30.3533306121826, 0.529765558128973, -83.6519393920898, -1.46000176807071, 218, 12, 'PPL', 'P'),
(54552, 'Ebb (historical)', 37.9311103820801, 0.662022765104702, -93.876106262207, -1.63844714322758, 218, 29, 'PPL', 'P'),
(181297, 'Ebbetts Pass Highlands', 38.208610534668, 0.666866056442147, -120.368606567383, -2.1008285006385, 218, 6, 'PPL', 'P'),
(113349, 'Ebbs Corner', 42.0186080932617, 0.733363058332554, -72.7483291625977, -1.26969786921194, 218, 8, 'PPL', 'P'),
(64401, 'Ebbs Mill', 35.8211097717285, 0.625196307234977, -82.9072189331055, -1.44700394405447, 218, 33, 'PPL', 'P'),
(46796, 'Ebbvale', 39.6772193908691, 0.692498116406805, -76.9191665649414, -1.34249271444816, 218, 25, 'PPL', 'P'),
(46782, 'Ebbvale Estates', 39.6952781677246, 0.692813301521816, -76.9230575561523, -1.34256062505596, 218, 25, 'PPL', 'P'),
(148583, 'Eben', 44.6269416809082, 0.778887067427341, -75.065559387207, -1.3101411661581, 218, 40, 'PPL', 'P'),
(130610, 'Eben Junction', 46.3549995422363, 0.809047366772488, -86.9700012207031, -1.51791287176476, 218, 27, 'PPL', 'P'),
(8681, 'Ebenezer', 36.023609161377, 0.628730588317621, -90.6836090087891, -1.58272755479456, 218, 4, 'PPL', 'P'),
(15879, 'Ebenezer', 30.4577808380127, 0.531588558474159, -84.591667175293, -1.47640311196007, 218, 12, 'PPL', 'P'),
(20786, 'Ebenezer', 33.711109161377, 0.588369849365252, -83.621940612793, -1.4594781906004, 218, 13, 'PPL', 'P'),
(35698, 'Ebenezer', 37.2038917541504, 0.649330405665493, -87.0808334350586, -1.51984725882254, 218, 21, 'PPL', 'P'),
(40759, 'Ebenezer', 32.1916694641113, 0.561850623862461, -93.1549987792969, -1.62586144339003, 218, 22, 'PPL', 'P'),
(54553, 'Ebenezer', 37.3402786254883, 0.651710805626833, -93.3069381713867, -1.62851328604548, 218, 29, 'PPL', 'P'),
(59766, 'Ebenezer', 32.3616714477539, 0.564817718211946, -89.227783203125, -1.55731860115022, 218, 30, 'PPL', 'P'),
(64402, 'Ebenezer', 35.1513900756836, 0.613507493473538, -84.061393737793, -1.46714809453983, 218, 33, 'PPL', 'P'),
(72401, 'Ebenezer', 39.8422203063965, 0.695377925651563, -84.6969375610352, -1.47824042679612, 218, 41, 'PPL', 'P'),
(80824, 'Ebenezer', 34.9569396972656, 0.610113694138395, -81.0466690063477, -1.41453122193481, 218, 48, 'PPL', 'P'),
(86715, 'Ebenezer', 35.413890838623, 0.618088996075828, -89.6180572509766, -1.56413016827032, 218, 50, 'PPL', 'P'),
(93901, 'Ebenezer', 31.0377807617188, 0.541711466804146, -94.1608276367188, -1.64341646866361, 218, 51, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(101625, 'Ebenezer', 36.8172187805176, 0.642581689147123, -79.1908264160156, -1.38214065833477, 218, 53, 'PPL', 'P'),
(145137, 'Ebenezer', 40.954719543457, 0.714794700264194, -74.9300003051758, -1.30777521384567, 218, 37, 'PPL', 'P'),
(148584, 'Ebenezer', 42.8302803039551, 0.747529410856094, -78.7538909912109, -1.37451469655333, 218, 40, 'PPL', 'P'),
(161175, 'Ebenezer', 40.357780456543, 0.704376147763695, -76.4577789306641, -1.33443998110204, 218, 45, 'PPL', 'P'),
(173932, 'Ebenezer', 43.1383285522461, 0.752905867043773, -88.7377777099609, -1.54876639194165, 218, 57, 'PPL', 'P'),
(64403, 'Ebenezers', 35.9033317565918, 0.626631351588366, -80.2197189331055, -1.40009822040712, 218, 33, 'PPL', 'P'),
(161176, 'Ebensburg', 40.4850006103516, 0.706596558322549, -78.7249984741211, -1.37401042700093, 218, 45, 'PPL', 'P'),
(161177, 'Ebensburg Junction', 40.4988899230957, 0.706838972560773, -78.6616668701172, -1.37290508199049, 218, 45, 'PPL', 'P'),
(124770, 'Ebenville', 42.4375, 0.740674101315094, -71.7027816772461, -1.25144962310661, 218, 23, 'PPL', 'P'),
(40760, 'Ebenzer', 32.4461097717285, 0.566291444980168, -92.5572204589844, -1.61542824350353, 218, 22, 'PPL', 'P'),
(72402, 'Eber', 39.5727806091309, 0.690675315798701, -83.4713897705078, -1.45685058271088, 218, 41, 'PPL', 'P'),
(190153, 'Eberhardt', 39.1949996948242, 0.684081794992855, -115.479721069336, -2.01550135194458, 218, 39, 'PPL', 'P'),
(27041, 'Eberle', 38.9425010681152, 0.679674862600019, -88.4569396972656, -1.54386484395536, 218, 18, 'PPL', 'P'),
(35699, 'Eberle', 37.2994384765625, 0.650998010561073, -84.0802764892578, -1.46747766072473, 218, 21, 'PPL', 'P'),
(181299, 'Eberly', 37.5724983215332, 0.655763803910797, -121.992218017578, -2.12916586621749, 218, 6, 'PPL', 'P'),
(161179, 'Eberlys Mill', 40.2255592346191, 0.702068452100114, -76.9058303833008, -1.34225995416889, 218, 45, 'PPL', 'P'),
(13706, 'Eberton', 39.2208290100098, 0.684532601586378, -75.5722198486328, -1.31898405939965, 218, 10, 'PPL', 'P'),
(161180, 'Ebervale', 40.9861106872559, 0.715342579079451, -75.9416732788086, -1.32543223818901, 218, 45, 'PPL', 'P'),
(207291, 'Ebeys Landing', 48.1919403076172, 0.841108031292489, -122.706672668457, -2.14163545223151, 218, 56, 'PPL', 'P'),
(86716, 'Eblen Estates', 35.8522186279297, 0.625739259202217, -84.4866714477539, -1.47457059081399, 218, 50, 'PPL', 'P'),
(8682, 'Ebling', 34.9083290100098, 0.609265277594123, -90.6230621337891, -1.58167081247402, 218, 4, 'PPL', 'P'),
(119464, 'Ebner', 41.9319381713867, 0.731850382833389, -90.1074981689453, -1.57267252378286, 218, 18, 'PPL', 'P'),
(54554, 'Ebo', 38.0263900756836, 0.663685709468374, -90.899169921875, -1.58648980246652, 218, 29, 'PPL', 'P'),
(20787, 'Ebo Landing', 31.188060760498, 0.544334347582738, -81.3872222900391, -1.4204749980137, 218, 13, 'PPL', 'P'),
(35700, 'Ebon', 37.9552803039551, 0.66244460982137, -83.434440612793, -1.45620569825291, 218, 21, 'PPL', 'P'),
(8683, 'Ebony', 35.1974983215332, 0.614312234175932, -90.2613906860352, -1.57535845490026, 218, 4, 'PPL', 'P'),
(93902, 'Ebony', 31.5025005340576, 0.549822356930577, -98.8974990844727, -1.72608698101213, 218, 51, 'PPL', 'P'),
(101626, 'Ebony', 36.5786094665527, 0.638417170992512, -77.9911117553711, -1.36120168742208, 218, 53, 'PPL', 'P'),
(93903, 'Ebony Acres Colonia', 26.2919998168945, 0.458881963738556, -98.0630035400391, -1.71152228616854, 218, 51, 'PPL', 'P'),
(93904, 'Ebony Hollow Colonia Number 1', 26.2269992828369, 0.457747490403696, -98.3939971923828, -1.71729921520514, 218, 51, 'PPL', 'P'),
(13707, 'Ebright', 39.836669921875, 0.695281053166911, -75.5286102294922, -1.31822292796011, 218, 10, 'PPL', 'P'),
(15880, 'Ebro', 30.4477806091309, 0.531414021554218, -85.8741683959961, -1.49878698092219, 218, 12, 'PPL', 'P'),
(135128, 'Ebro', 47.4955596923828, 0.828953896709585, -95.529167175293, -1.66729849889695, 218, 28, 'PPL', 'P'),
(72403, 'Ebush (historical)', 39.3111114501953, 0.686108327424351, -83.120002746582, -1.45071772219459, 218, 41, 'PPL', 'P'),
(29695, 'Eby', 38.1419410705566, 0.665702454782864, -87.2613906860352, -1.52299857734043, 218, 19, 'PPL', 'P'),
(35701, 'Eby', 38.4388885498047, 0.67088516600124, -83.2044372558594, -1.45219138238378, 218, 21, 'PPL', 'P'),
(109020, 'Eby', 39.3188896179199, 0.686244082060918, -79.8994369506836, -1.39450824527905, 218, 58, 'PPL', 'P'),
(115398, 'Ebys Mill', 42.1997184753418, 0.736524030809396, -91.0588912963867, -1.58927746633756, 218, 16, 'PPL', 'P'),
(54555, 'Eccles', 39.4891700744629, 0.689216036679392, -92.8686065673828, -1.62086295634006, 218, 29, 'PPL', 'P'),
(109021, 'Eccles', 37.7830581665039, 0.659438766478025, -81.26611328125, -1.41836124705651, 218, 58, 'PPL', 'P'),
(190155, 'Eccles', 37.6152801513672, 0.656510487701428, -114.43083190918, -1.99719478261137, 218, 39, 'PPL', 'P'),
(194872, 'Eccles', 44.3269386291504, 0.773651026408136, -111.300827026367, -1.9425658918028, 218, 17, 'PPL', 'P'),
(209423, 'Eccles', 44.1383285522461, 0.770359159563716, -107.907783508301, -1.88334611074909, 218, 59, 'PPL', 'P'),
(46783, 'Eccleston', 39.4052810668945, 0.687751897291094, -76.7291717529297, -1.33917667941685, 218, 25, 'PPL', 'P'),
(46784, 'Eccleston Valley', 39.416389465332, 0.687945775418451, -76.7427825927734, -1.33941423338609, 218, 25, 'PPL', 'P'),
(40761, 'Ecco', 32.7791709899902, 0.572104459849539, -93.4000015258789, -1.63013754799431, 218, 22, 'PPL', 'P'),
(109022, 'Echart (historical)', 37.8111114501953, 0.659928388644436, -81.6138916015625, -1.42443112381301, 218, 58, 'PPL', 'P'),
(20788, 'Echeconnee', 32.685001373291, 0.570460889982796, -83.7005615234375, -1.46085038435207, 218, 13, 'PPL', 'P'),
(20789, 'Echeconnee Acres', 32.7200012207031, 0.571071752557833, -83.7569427490234, -1.46183442237485, 218, 13, 'PPL', 'P'),
(70774, 'Echelon', 39.848331451416, 0.69548458525322, -74.9961090087891, -1.30892902838795, 218, 37, 'PPL', 'P'),
(209424, 'Echeta', 44.4580612182617, 0.775939547311868, -105.875831604004, -1.84788185977694, 218, 59, 'PPL', 'P'),
(178133, 'Echinique Place', 34.7177810668945, 0.605939588603859, -110.966110229492, -1.9367239816356, 218, 5, 'PPL', 'P'),
(2207, 'Echo', 31.4755592346191, 0.54935214255061, -85.4658279418945, -1.49166009552903, 218, 2, 'PPL', 'P'),
(8684, 'Echo', 35.0972213745117, 0.612562071286559, -94.1347198486328, -1.6429608018011, 218, 4, 'PPL', 'P'),
(35702, 'Echo', 37.0277786254883, 0.646256651714351, -85.7474975585938, -1.49657615774326, 218, 21, 'PPL', 'P'),
(40762, 'Echo', 31.1100006103516, 0.54297194094808, -92.2416687011719, -1.60992082636925, 218, 22, 'PPL', 'P'),
(54556, 'Echo', 39.5980606079102, 0.6911165350123, -92.8483276367188, -1.62050902223119, 218, 29, 'PPL', 'P'),
(64405, 'Echo', 34.499439239502, 0.602128804821038, -79.2777786254883, -1.38365826068196, 218, 33, 'PPL', 'P'),
(93906, 'Echo', 30.1525001525879, 0.526260405370751, -93.7322235107422, -1.63593591547769, 218, 51, 'PPL', 'P'),
(109023, 'Echo', 38.1777801513672, 0.666327964743897, -82.4819412231445, -1.43958144778031, 218, 58, 'PPL', 'P'),
(115399, 'Echo', 41.7419395446777, 0.728534281223049, -95.9413909912109, -1.67449316173986, 218, 16, 'PPL', 'P'),
(135129, 'Echo', 44.6169395446777, 0.778712497217886, -95.4172210693359, -1.66534467076322, 218, 28, 'PPL', 'P'),
(155128, 'Echo', 40.035831451416, 0.69875707760071, -80.8288879394531, -1.41073022526899, 218, 41, 'PPL', 'P'),
(161182, 'Echo', 40.3769416809082, 0.704710574217582, -78.857780456543, -1.37632790978151, 218, 45, 'PPL', 'P'),
(181300, 'Echo', 35.3008308410645, 0.616115726866134, -116.804168701172, -2.03861732389036, 218, 6, 'PPL', 'P'),
(186659, 'Echo', 38.4427795410156, 0.670953076609037, -105.538330078125, -1.84199134691985, 218, 7, 'PPL', 'P'),
(193246, 'Echo', 48.6480598449707, 0.849068819001981, -117.931671142578, -2.05829595381717, 218, 56, 'PPL', 'P'),
(199934, 'Echo', 41.6808280944824, 0.727467685206472, -116.171669006348, -2.02757812169782, 218, 39, 'PPL', 'P'),
(200745, 'Echo', 45.7425003051758, 0.798357238419828, -119.194442749023, -2.08033547605034, 218, 43, 'PPL', 'P'),
(203822, 'Echo', 40.9777793884277, 0.715197170483932, -111.442497253418, -1.94503850371688, 218, 52, 'PPL', 'P'),
(64406, 'Echo Acres', 35.3025016784668, 0.61614488848007, -82.4977798461914, -1.43985788390146, 218, 33, 'PPL', 'P'),
(190156, 'Echo Bay', 36.3091697692871, 0.63371456113965, -114.426666259766, -1.99712207831362, 218, 39, 'PPL', 'P'),
(161183, 'Echo Beach', 40.0666694641113, 0.699295302457015, -74.9466705322266, -1.30806616419476, 218, 45, 'PPL', 'P'),
(194871, 'Echo Beach', 47.8877792358398, 0.835799419133579, -116.875556945801, -2.03986328380635, 218, 17, 'PPL', 'P'),
(64407, 'Echo Bluff Trailer Park', 36.0261116027832, 0.628774264159498, -80.3138885498047, -1.40174179027387, 218, 33, 'PPL', 'P'),
(20794, 'Echo Brook Park', 33.8908309936523, 0.591506587076175, -83.4713897705078, -1.45685058271088, 218, 13, 'PPL', 'P'),
(29696, 'Echo Crest', 39.9505615234375, 0.697268836604546, -86.1294403076172, -1.50324231626784, 218, 19, 'PPL', 'P'),
(200746, 'Echo Dell', 45.3325004577637, 0.791201391149813, -122.526390075684, -2.13848892740358, 218, 43, 'PPL', 'P'),
(155129, 'Echo Dell Trailer Park', 40.7130584716797, 0.710576918887781, -80.6130599975586, -1.40696331706513, 218, 41, 'PPL', 'P'),
(93907, 'Echo Forest', 30.1891708374023, 0.526900429559725, -94.0530624389648, -1.64153561114374, 218, 51, 'PPL', 'P'),
(20790, 'Echo Glen', 32.6463890075684, 0.569786977068952, -83.6569366455078, -1.46008898659641, 218, 13, 'PPL', 'P'),
(64409, 'Echo Heights', 35.7011108398438, 0.623101930774711, -78.648063659668, -1.37266766117931, 218, 33, 'PPL', 'P'),
(46785, 'Echo Hill', 39.3630599975586, 0.687015000617469, -76.1149978637695, -1.32845732287123, 218, 25, 'PPL', 'P'),
(2209, 'Echo Hills', 33.6541709899902, 0.587376090804489, -86.6091690063477, -1.51161516157699, 218, 2, 'PPL', 'P'),
(64410, 'Echo Hills', 35.5877799987793, 0.621123934454082, -82.6133270263672, -1.44187456263692, 218, 33, 'PPL', 'P'),
(186660, 'Echo House (historical)', 37.167781829834, 0.648700168593526, -108.499443054199, -1.89367251787587, 218, 7, 'PPL', 'P'),
(119465, 'Echo Lake', 42.208610534668, 0.73667922652192, -88.0861129760742, -1.5373926967162, 218, 18, 'PPL', 'P'),
(145138, 'Echo Lake', 41.0586090087891, 0.716607913492375, -74.3949966430664, -1.29843763843164, 218, 37, 'PPL', 'P'),
(161184, 'Echo Lake', 41.064998626709, 0.716719433363022, -75.0569381713867, -1.30999069755651, 218, 45, 'PPL', 'P'),
(181301, 'Echo Lake', 38.8338890075684, 0.677779224536101, -120.040557861328, -2.09510297061094, 218, 6, 'PPL', 'P'),
(207293, 'Echo Lake', 47.7844390869141, 0.833995793285323, -122.045562744141, -2.13009690733458, 218, 56, 'PPL', 'P'),
(196407, 'Echo Lake (historical)', 46.2333297729492, 0.806923828698286, -113.266670227051, -1.97687632823267, 218, 31, 'PPL', 'P'),
(155130, 'Echo Lake Glen', 41.2275009155273, 0.719555633344929, -81.7183303833008, -1.42625392442112, 218, 41, 'PPL', 'P'),
(54557, 'Echo Lake Ranch', 38.4544410705566, 0.671156608695346, -90.5794372558594, -1.58090941471836, 218, 29, 'PPL', 'P'),
(64411, 'Echo Lakes', 35.2994384765625, 0.616091425521187, -82.4961090087891, -1.43982872228752, 218, 33, 'PPL', 'P'),
(64412, 'Echo Park', 36.1308288574219, 0.630601925036593, -81.6686096191406, -1.42538613337992, 218, 33, 'PPL', 'P'),
(72404, 'Echo Point', 39.9416694641113, 0.697113640892022, -81.4055633544922, -1.42079510997673, 218, 41, 'PPL', 'P'),
(177214, 'Echo Point', 40.0816688537598, 0.699557091192169, -80.6791687011719, -1.40811713160741, 218, 58, 'PPL', 'P'),
(161185, 'Echo Reach', 40.064998626709, 0.699266140843078, -74.9472198486328, -1.30807575157469, 218, 45, 'PPL', 'P'),
(203823, 'Echo Resort', 40.9625015258789, 0.714930521479788, -111.410827636719, -1.94448576463264, 218, 52, 'PPL', 'P'),
(20791, 'Echo Ridge', 33.8925018310547, 0.591535748690111, -84.76611328125, -1.47944777087631, 218, 13, 'PPL', 'P'),
(181302, 'Echo Ridge Estates', 39.2472190856934, 0.684993195296908, -121.050003051758, -2.11272111280236, 218, 6, 'PPL', 'P'),
(181303, 'Echo Ridge Trails', 39.2472190856934, 0.684993195296908, -121.055557250977, -2.11281805186604, 218, 6, 'PPL', 'P'),
(86719, 'Echo Valley', 35.9049987792969, 0.626660446623275, -84.0633316040039, -1.46718191668567, 218, 50, 'PPL', 'P'),
(161186, 'Echo Valley', 40.5999984741211, 0.708603649678087, -76.392219543457, -1.33329575393968, 218, 45, 'PPL', 'P'),
(115400, 'Echo Valley Mobile Home Park', 40.8416709899902, 0.712821630791582, -91.2152786254883, -1.59200694013878, 218, 16, 'PPL', 'P'),
(101628, 'Echo Village', 39.1252784729004, 0.682864930111771, -78.1963882446289, -1.36478443803656, 218, 53, 'PPL', 'P'),
(2211, 'Echola', 33.3447189331055, 0.581975133534781, -87.789436340332, -1.53221471260876, 218, 2, 'PPL', 'P'),
(35703, 'Echols', 37.333610534668, 0.651594425487197, -86.9641723632813, -1.51781113901112, 218, 21, 'PPL', 'P'),
(93908, 'Echols', 31.6858291625977, 0.553022045111767, -96.6372222900391, -1.68663770894284, 218, 51, 'PPL', 'P'),
(135132, 'Echols', 43.9238891601563, 0.766616486125773, -94.6747207641602, -1.65238559574084, 218, 28, 'PPL', 'P'),
(2212, 'Echols Crossroads', 34.526668548584, 0.602604045917562, -86.7891693115234, -1.5147567595569, 218, 2, 'PPL', 'P'),
(2213, 'Echols Hill', 34.7313919067383, 0.606177142573094, -86.5752792358398, -1.51102367349889, 218, 2, 'PPL', 'P'),
(20793, 'Echota', 34.5200004577637, 0.602487665777926, -84.942497253418, -1.48252625193838, 218, 13, 'PPL', 'P'),
(119466, 'Eckard', 40.3197212219238, 0.703711888808802, -89.9888916015625, -1.57060244866754, 218, 18, 'PPL', 'P'),
(115401, 'Eckards', 42.8563919067383, 0.747985144297634, -91.1041717529297, -1.59006775939104, 218, 16, 'PPL', 'P'),
(139931, 'Eckelson', 46.938060760498, 0.819223704771844, -98.3327789306641, -1.7162307549758, 218, 34, 'PPL', 'P'),
(161187, 'Eckenrode Mill', 40.598331451416, 0.708574554643178, -78.6527786254883, -1.37274995285699, 218, 45, 'PPL', 'P'),
(130612, 'Eckerman', 46.3652801513672, 0.809226797250932, -85.0352783203125, -1.48414558703921, 218, 27, 'PPL', 'P'),
(130613, 'Eckerman Corner', 46.3458290100098, 0.808887310790974, -85.0305633544922, -1.48406329536152, 218, 27, 'PPL', 'P'),
(130614, 'Eckerman Corner Lookout Tower', 46.3408317565918, 0.808800092265274, -85.017219543457, -1.4838304019242, 218, 27, 'PPL', 'P'),
(173933, 'Eckers Lakeland', 44.0033302307129, 0.768002994368296, -88.3227767944336, -1.54152325956691, 218, 57, 'PPL', 'P'),
(93909, 'Eckert', 30.4141693115234, 0.530827393745101, -98.7363891601563, -1.72327508237517, 218, 51, 'PPL', 'P'),
(186661, 'Eckert', 38.8427810668945, 0.677934420248625, -107.962219238281, -1.88429619346797, 218, 7, 'PPL', 'P'),
(161188, 'Eckert (historical)', 40.6155586242676, 0.708875225530248, -75.5341720581055, -1.31832000018184, 218, 45, 'PPL', 'P'),
(29697, 'Eckerty', 38.3202781677246, 0.668815024306894, -86.6119384765625, -1.51166349795078, 218, 19, 'PPL', 'P'),
(130617, 'Eckford', 42.2019386291504, 0.736562779803257, -84.8663864135742, -1.48119786718665, 218, 27, 'PPL', 'P'),
(46786, 'Eckhart Junction', 39.6708297729492, 0.692386596536158, -78.7886123657227, -1.37512069885938, 218, 25, 'PPL', 'P'),
(46787, 'Eckhart Mines', 39.6525001525879, 0.692066684310213, -78.897216796875, -1.37701620376524, 218, 25, 'PPL', 'P'),
(13082, 'Eckington', 38.9124984741211, 0.679151218550683, -77.0094375610352, -1.34406824054906, 218, 9, 'PPL', 'P'),
(155132, 'Eckley', 41.5636100769043, 0.725421844857074, -84.2494430541992, -1.47043017426724, 218, 41, 'PPL', 'P'),
(161190, 'Eckley', 40.9933280944824, 0.715468546599011, -75.8627777099609, -1.32405525074738, 218, 45, 'PPL', 'P'),
(181304, 'Eckley', 38.0538902282715, 0.664165677675834, -122.201667785645, -2.13282145428779, 218, 6, 'PPL', 'P'),
(194167, 'Eckley', 40.1138916015625, 0.700119484235367, -102.490280151367, -1.78879283993275, 218, 7, 'PPL', 'P'),
(200747, 'Eckley (historical)', 42.8388900756836, 0.747679679720602, -124.183326721191, -2.16740792736464, 218, 43, 'PPL', 'P'),
(109024, 'Eckman', 37.4044418334961, 0.652830664865211, -81.4644393920898, -1.42182269068334, 218, 58, 'PPL', 'P'),
(198237, 'Eckman', 48.6580581665039, 0.849243322632408, -101.057502746582, -1.76378615677107, 218, 34, 'PPL', 'P'),
(72405, 'Eckmansville', 38.8658294677734, 0.678336690731282, -83.6427764892578, -1.45984184524725, 218, 41, 'PPL', 'P'),
(161191, 'Eckville', 40.6327781677246, 0.709175763259263, -75.9530563354492, -1.32563091000633, 218, 45, 'PPL', 'P'),
(2214, 'Eclectic', 32.6352806091309, 0.569593098941594, -86.0344390869141, -1.50158423217315, 218, 2, 'PPL', 'P'),
(93910, 'Ecleto', 29.0461101531982, 0.506950257070264, -97.751106262207, -1.70607865174236, 218, 51, 'PPL', 'P'),
(93911, 'Eclipse', 30.7525005340576, 0.53673238754062, -93.977783203125, -1.64022174061995, 218, 51, 'PPL', 'P'),
(101629, 'Eclipse', 36.9169387817383, 0.644322131498517, -76.4888916015625, -1.3349829996483, 218, 53, 'PPL', 'P'),
(171984, 'Ecole Champlain', 44.2416687011719, 0.772162785411972, -73.2969436645508, -1.27927299859521, 218, 55, 'PPL', 'P'),
(15882, 'Econfina', 30.1313896179199, 0.525891957033939, -83.8649978637695, -1.46372033990079, 218, 12, 'PPL', 'P'),
(8685, 'Economy', 35.2999992370605, 0.616101212638193, -92.8927764892578, -1.62128480105673, 218, 4, 'PPL', 'P'),
(29698, 'Economy', 39.9780616760254, 0.697748804812006, -85.0880584716797, -1.48506677446026, 218, 19, 'PPL', 'P'),
(54558, 'Economy', 39.8891716003418, 0.69619738031898, -92.4205627441406, -1.61304311643126, 218, 29, 'PPL', 'P'),
(161192, 'Economy', 40.5999984741211, 0.708603649678087, -80.2249984741211, -1.40019036578084, 218, 45, 'PPL', 'P'),
(86720, 'Economy (historical)', 35.2291717529297, 0.614865039839205, -88.192497253418, -1.5392494526282, 218, 50, 'PPL', 'P'),
(75738, 'Econtuchka', 35.4055595397949, 0.61794358748031, -96.7886123657227, -1.68927996421836, 218, 42, 'PPL', 'P'),
(130616, 'Ecorse', 42.2444381713867, 0.737304536745871, -83.1458282470703, -1.45116846220908, 218, 27, 'PPL', 'P'),
(59768, 'Ecru', 34.3530616760254, 0.599574034387325, -89.023063659668, -1.55374557107372, 218, 30, 'PPL', 'P'),
(54559, 'Ectonville', 39.3677787780762, 0.687097358874179, -94.477783203125, -1.64894838687993, 218, 29, 'PPL', 'P'),
(93912, 'Ector', 33.577220916748, 0.586033058666762, -96.273063659668, -1.68028194184331, 218, 51, 'PPL', 'P'),
(64444, 'Ecusta', 35.2722206115723, 0.615616384161744, -82.7063903808594, -1.44349882458576, 218, 33, 'PPL', 'P'),
(32302, 'Edalgo', 38.9716682434082, 0.680183925842388, -98.0466690063477, -1.71123719477384, 218, 20, 'PPL', 'P'),
(54560, 'Edanville', 37.5933303833008, 0.656127391978621, -92.0483322143555, -1.60654646811007, 218, 29, 'PPL', 'P'),
(93913, 'Edcouch', 26.2936096191406, 0.458910060088056, -97.9602813720703, -1.7097294461227, 218, 51, 'PPL', 'P'),
(59769, 'Eddiceton', 31.5019397735596, 0.549812569813571, -90.791389465332, -1.58460867863054, 218, 30, 'PPL', 'P'),
(196408, 'Eddies Corner', 46.9833297729492, 0.820013798088244, -109.744720458984, -1.91540670869006, 218, 31, 'PPL', 'P'),
(2215, 'Eddings Town', 33.1383285522461, 0.57837294184434, -86.9791717529297, -1.51807292774627, 218, 2, 'PPL', 'P'),
(127406, 'Eddington', 44.8261108398438, 0.782363225019194, -68.6938934326172, -1.19893461641328, 218, 26, 'PPL', 'P'),
(161194, 'Eddington', 40.0844383239746, 0.699605427565954, -74.9452819824219, -1.30804192942884, 218, 45, 'PPL', 'P'),
(161195, 'Eddington Gardens', 40.0991706848145, 0.699862555769202, -74.9555587768555, -1.30822129332826, 218, 45, 'PPL', 'P'),
(161196, 'Eddington Park', 40.0916709899902, 0.699731661401624, -74.9449996948242, -1.30803700258083, 218, 45, 'PPL', 'P'),
(101630, 'Edds Mill', 36.6322212219238, 0.639352872641511, -83.3600006103516, -1.45490647511512, 218, 53, 'PPL', 'P'),
(2216, 'Eddy', 34.355281829834, 0.599612783381185, -86.5094375610352, -1.50987451948852, 218, 2, 'PPL', 'P'),
(15884, 'Eddy', 30.5433292388916, 0.533081659739312, -82.3388900756836, -1.43708473425836, 218, 12, 'PPL', 'P'),
(75740, 'Eddy', 36.7316703796387, 0.64108858788197, -97.4583282470703, -1.70096871140077, 218, 42, 'PPL', 'P'),
(93914, 'Eddy', 31.2944393157959, 0.5461910036262, -97.2519378662109, -1.69736651971033, 218, 51, 'PPL', 'P'),
(119467, 'Eddy', 42.4613914489746, 0.741091085762773, -87.8983306884766, -1.53411527752069, 218, 18, 'PPL', 'P'),
(122547, 'Eddy', 41.5363883972168, 0.724946736918603, -85.4383316040039, -1.4911801939006, 218, 19, 'PPL', 'P'),
(148586, 'Eddy', 44.5400009155273, 0.777369664817241, -75.2369384765625, -1.31313229553642, 218, 40, 'PPL', 'P'),
(196409, 'Eddy', 47.5583305358887, 0.830049454603017, -115.132217407227, -2.00943626887803, 218, 31, 'PPL', 'P'),
(200748, 'Eddy (historical)', 45.7061080932617, 0.797722074499844, -120.179168701172, -2.09752218614517, 218, 43, 'PPL', 'P'),
(35704, 'Eddy Bay', 37.0083312988281, 0.64591723183342, -88.0113906860352, -1.53608854673038, 218, 21, 'PPL', 'P'),
(148587, 'Eddy Corners', 43.0569381713867, 0.751485336918325, -73.769172668457, -1.28751494953679, 218, 40, 'PPL', 'P'),
(80826, 'Eddy Lake (historical)', 33.6500015258789, 0.587303319927703, -79.1208267211914, -1.3809189331847, 218, 48, 'PPL', 'P'),
(178134, 'Eddy Place', 34.9605598449707, 0.610176877635257, -112.601936340332, -1.96527453325985, 218, 5, 'PPL', 'P'),
(78196, 'Eddystone', 39.8600006103516, 0.695688250497584, -75.3447189331055, -1.3150134193724, 218, 45, 'PPL', 'P'),
(27042, 'Eddyville', 37.4988899230957, 0.654479095000943, -88.5877838134766, -1.5461485045901, 218, 18, 'PPL', 'P'),
(35705, 'Eddyville', 37.0944404602051, 0.647420120215579, -88.0802764892578, -1.5372908308045, 218, 21, 'PPL', 'P'),
(115419, 'Eddyville', 41.1605606079102, 0.718387304574711, -92.6311111450195, -1.61671787926141, 218, 16, 'PPL', 'P'),
(124771, 'Eddyville', 41.9241714477539, 0.731714827933904, -70.8477783203125, -1.23652699941251, 218, 23, 'PPL', 'P'),
(141714, 'Eddyville', 41.0113906860352, 0.71578379829305, -99.623893737793, -1.73876495938145, 218, 35, 'PPL', 'P'),
(148589, 'Eddyville', 41.8941688537598, 0.731191183884567, -74.0263900756836, -1.29200424018633, 218, 40, 'PPL', 'P'),
(161234, 'Eddyville', 40.9427795410156, 0.714586307908895, -79.2777786254883, -1.38365826068196, 218, 45, 'PPL', 'P'),
(194873, 'Eddyville', 47.6161117553711, 0.831057927128802, -116.730560302734, -2.0373326149805, 218, 17, 'PPL', 'P'),
(200749, 'Eddyville', 44.6347198486328, 0.779022822063908, -123.775283813477, -2.16028623513561, 218, 43, 'PPL', 'P'),
(193515, 'Eddyville (historical)', 40.7808303833008, 0.71175976188594, -124.075561523438, -2.16552706984478, 218, 6, 'PPL', 'P'),
(161197, 'Ededburg', 40.5663909912109, 0.708017088447997, -75.9608306884766, -1.32576659806387, 218, 45, 'PPL', 'P'),
(46788, 'Edelen Estates', 38.5486106872559, 0.672800178562089, -76.8319396972656, -1.34097031841102, 218, 25, 'PPL', 'P'),
(161198, 'Edella', 41.5136108398438, 0.724549193546882, -75.6605606079102, -1.32052589651275, 218, 45, 'PPL', 'P'),
(161199, 'Edelman', 40.7902793884277, 0.711924678136443, -75.2652816772461, -1.3136269777089, 218, 45, 'PPL', 'P'),
(119468, 'Edelstein', 40.9408302307129, 0.71455228602597, -89.6291732788086, -1.56432417955573, 218, 18, 'PPL', 'P'),
(2217, 'Eden', 33.5919418334961, 0.586289987132928, -86.3102798461914, -1.50639856163375, 218, 2, 'PPL', 'P'),
(8687, 'Eden', 34.8636093139648, 0.608484771657648, -91.2744369506836, -1.5930394476934, 218, 4, 'PPL', 'P'),
(15885, 'Eden', 27.2763900756836, 0.476062814878984, -80.2430572509766, -1.40050555089585, 218, 12, 'PPL', 'P'),
(20795, 'Eden', 32.1736106872559, 0.56153543874745, -81.3908309936523, -1.42053798177348, 218, 13, 'PPL', 'P'),
(29699, 'Eden', 39.9061088562012, 0.696492991199979, -85.7699966430664, -1.49696884084599, 218, 19, 'PPL', 'P'),
(35706, 'Eden', 37.2755584716797, 0.650581225850476, -86.7044372558594, -1.51327790620358, 218, 21, 'PPL', 'P'),
(40763, 'Eden', 31.6538906097412, 0.5524646122061, -92.2149963378906, -1.6094553058107, 218, 22, 'PPL', 'P'),
(46789, 'Eden', 38.2805595397949, 0.668121803475147, -75.6513900756836, -1.32036584053124, 218, 25, 'PPL', 'P'),
(59770, 'Eden', 32.9847183227539, 0.575691937574957, -90.3233337402344, -1.57643956514477, 218, 30, 'PPL', 'P'),
(64413, 'Eden', 36.4883308410645, 0.636841511733567, -79.7669372558594, -1.39219568934648, 218, 33, 'PPL', 'P'),
(72406, 'Eden', 39.1566696166992, 0.683412808927027, -81.7591705322266, -1.42696671948688, 218, 41, 'PPL', 'P'),
(93916, 'Eden', 31.5924301147461, 0.551391924208529, -94.8491973876953, -1.65543078728929, 218, 51, 'PPL', 'P'),
(115402, 'Eden', 42.1091690063477, 0.734943644439516, -91.9694366455078, -1.60516948066844, 218, 16, 'PPL', 'P'),
(119469, 'Eden', 40.6888885498047, 0.710155074171113, -89.8327789306641, -1.56787776855628, 218, 18, 'PPL', 'P'),
(127408, 'Eden', 44.4308280944824, 0.775464239636317, -68.3213882446289, -1.19243317440212, 218, 26, 'PPL', 'P'),
(130619, 'Eden', 42.5238914489746, 0.742181916545269, -84.4283294677734, -1.4735523311712, 218, 27, 'PPL', 'P'),
(135136, 'Eden', 44.0880584716797, 0.76948178114259, -92.8847198486328, -1.62114418615117, 218, 28, 'PPL', 'P'),
(148591, 'Eden', 41.2886085510254, 0.720622162782478, -74.4947204589844, -1.30017814736206, 218, 40, 'PPL', 'P'),
(161201, 'Eden', 40.0702781677246, 0.699358286216795, -76.2699966430664, -1.33116256190653, 218, 45, 'PPL', 'P'),
(170202, 'Eden', 45.6166687011719, 0.796161062626895, -97.4194412231445, -1.70029000479696, 218, 49, 'PPL', 'P'),
(171985, 'Eden', 44.707218170166, 0.780288156476831, -72.5461120605469, -1.26616851497731, 218, 55, 'PPL', 'P'),
(173934, 'Eden', 43.6936111450195, 0.76259737656668, -88.3608322143555, -1.54218745194278, 218, 57, 'PPL', 'P'),
(177215, 'Eden', 40.0669403076172, 0.69930002956795, -80.6386108398438, -1.40740926338966, 218, 58, 'PPL', 'P'),
(178135, 'Eden', 32.961109161377, 0.575279879975295, -109.894721984863, -1.91802472919966, 218, 5, 'PPL', 'P'),
(181305, 'Eden', 33.878059387207, 0.591283680492935, -117.054168701172, -2.04298064702034, 218, 6, 'PPL', 'P'),
(186663, 'Eden', 38.3163909912109, 0.668747180278125, -104.615829467773, -1.82589067391755, 218, 7, 'PPL', 'P'),
(194874, 'Eden', 42.6058311462402, 0.743612034050642, -114.209999084473, -1.99334052272376, 218, 17, 'PPL', 'P'),
(196410, 'Eden', 47.2700004577637, 0.825017145407203, -111.271392822266, -1.94205216802852, 218, 31, 'PPL', 'P'),
(200750, 'Eden', 45.9069404602051, 0.80122726054758, -117.555557250977, -2.05173152804623, 218, 43, 'PPL', 'P'),
(203824, 'Eden', 41.3005599975586, 0.720830754874859, -111.811393737793, -1.95147696196826, 218, 52, 'PPL', 'P'),
(207295, 'Eden', 46.2986106872559, 0.808063195591649, -123.651107788086, -2.1581189546405, 218, 56, 'PPL', 'P'),
(209425, 'Eden', 42.0508308410645, 0.733925451375751, -109.436393737793, -1.91002539223339, 218, 59, 'PPL', 'P'),
(40764, 'Eden (historical)', 30.9805603027344, 0.540712781395366, -91.7666702270508, -1.60163053905389, 218, 22, 'PPL', 'P'),
(64414, 'Eden (historical)', 35.839168548584, 0.625511492349988, -80.0608291625977, -1.39732507076402, 218, 33, 'PPL', 'P'),
(190157, 'Eden (historical)', 37.9402809143066, 0.662182821086216, -116.418891906738, -2.03189297529596, 218, 39, 'PPL', 'P'),
(35707, 'Eden Bay', 37.0299987792969, 0.646295400708212, -88.040283203125, -1.53659281628279, 218, 21, 'PPL', 'P'),
(86721, 'Eden Corner', 36.5175018310547, 0.637350641554962, -86.7461090087891, -1.51400521549728, 218, 50, 'PPL', 'P'),
(46790, 'Eden Farms', 39.5927810668945, 0.691024389638583, -76.9824981689453, -1.3435980594586, 218, 25, 'PPL', 'P'),
(181307, 'Eden Gardens', 32.9872207641602, 0.575735613416835, -117.257217407227, -2.04652451548291, 218, 6, 'PPL', 'P'),
(161202, 'Eden Heights', 40.0719413757324, 0.699387314672677, -76.2708282470703, -1.33117707613447, 218, 45, 'PPL', 'P'),
(46791, 'Eden Hills', 39.6722183227539, 0.692410831302078, -76.4611129760742, -1.33449817117186, 218, 25, 'PPL', 'P'),
(203826, 'Eden Hills', 41.3202781677246, 0.721174901866724, -111.840278625488, -1.95198109836261, 218, 52, 'PPL', 'P'),
(181306, 'Eden Hot Springs', 33.8955612182617, 0.591589145069967, -117.054443359375, -2.04298544071031, 218, 6, 'PPL', 'P'),
(40765, 'Eden Isle', 30.2283306121826, 0.52758389656398, -89.7986068725586, -1.56728135363016, 218, 22, 'PPL', 'P'),
(203827, 'Eden Meadows', 41.3088912963867, 0.720976163470377, -111.82861328125, -1.95177749969727, 218, 52, 'PPL', 'P'),
(171986, 'Eden Mills', 44.7133293151855, 0.780394816078489, -72.5305633544922, -1.26589713886223, 218, 55, 'PPL', 'P'),
(86723, 'Eden of the Lake', 35.7291717529297, 0.623591686099177, -84.7272186279297, -1.47876893111445, 218, 50, 'PPL', 'P'),
(27045, 'Eden Park', 37.7550010681152, 0.658949077732587, -89.0238876342773, -1.55375995214361, 218, 18, 'PPL', 'P'),
(40766, 'Eden Park', 30.4580593109131, 0.531593418743149, -91.1549987792969, -1.59095485835014, 218, 22, 'PPL', 'P'),
(72407, 'Eden Park', 38.7747192382813, 0.676746517244396, -82.9422225952148, -1.44761487320854, 218, 41, 'PPL', 'P'),
(101631, 'Eden Park', 37.3125, 0.651225977150384, -79.9569396972656, -1.39551185753584, 218, 53, 'PPL', 'P'),
(161203, 'Eden Park', 40.3316688537598, 0.703920414322155, -79.8450012207031, -1.39355816256016, 218, 45, 'PPL', 'P'),
(109027, 'Eden Park (historical)', 38.0583305358887, 0.664243175663555, -82.146110534668, -1.43372009653716, 218, 58, 'PPL', 'P'),
(13708, 'Eden Park Gardens', 39.7200012207031, 0.693244800197436, -75.5438919067383, -1.31848964354328, 218, 10, 'PPL', 'P'),
(135138, 'Eden Prairie', 44.8547210693359, 0.782862567723584, -93.4705581665039, -1.63136899368237, 218, 28, 'PPL', 'P'),
(2218, 'Eden Ridge', 33.336109161377, 0.581824864670274, -86.8797225952148, -1.51633721250581, 218, 2, 'PPL', 'P'),
(86722, 'Eden Ridge (historical)', 36.5277786254883, 0.637530005454379, -82.5194396972656, -1.4402359196182, 218, 50, 'PPL', 'P'),
(13709, 'Eden Roc', 39.2000007629395, 0.684169080097583, -75.5969390869141, -1.31941549149625, 218, 10, 'PPL', 'P'),
(46792, 'Eden Roc', 39.3930587768555, 0.687538578087778, -76.6930618286133, -1.33854644234489, 218, 25, 'PPL', 'P'),
(211322, 'Eden Roc', 19.4902801513672, 0.340169560777456, -155.102783203125, -2.70705424590149, 218, 15, 'PPL', 'P'),
(124772, 'Eden Square', 42.6452789306641, 0.744300527771455, -70.5955581665039, -1.23212492728866, 218, 23, 'PPL', 'P'),
(135140, 'Eden Valley', 45.3261108398438, 0.791089871279166, -94.5458297729492, -1.65013602356805, 218, 28, 'PPL', 'P'),
(148592, 'Eden Valley', 42.6788902282715, 0.744887155580572, -78.8722229003906, -1.37657997797869, 218, 40, 'PPL', 'P'),
(181308, 'Eden Valley', 39.0566711425781, 0.681667506306644, -120.995277404785, -2.1117659700774, 218, 6, 'PPL', 'P'),
(203828, 'Eden Village', 41.3027801513672, 0.720869503868719, -111.800559997559, -1.95128787753086, 218, 52, 'PPL', 'P'),
(78190, 'Edenborn', 39.8841705322266, 0.696110095214253, -79.8819427490234, -1.39420291386007, 218, 45, 'PPL', 'P'),
(200751, 'Edenbower', 43.2347183227539, 0.754588185904376, -123.38111114502, -2.15340662424966, 218, 43, 'PPL', 'P'),
(161204, 'Edendale', 40.8375015258789, 0.712748859914795, -78.267219543457, -1.36602067741458, 218, 45, 'PPL', 'P'),
(181309, 'Edendale', 38.4850006103516, 0.671689973282662, -123.001670837402, -2.14678414156696, 218, 6, 'PPL', 'P'),
(181310, 'Edendale (historical)', 37.4486083984375, 0.653601516842735, -120.502777099609, -2.10317021818501, 218, 6, 'PPL', 'P'),
(207296, 'Edendale (historical)', 48.315559387207, 0.843265591249617, -118.148887634277, -2.06208709678695, 218, 56, 'PPL', 'P'),
(64419, 'Edenhouse', 36.0430603027344, 0.629070074777579, -76.709716796875, -1.33883712637787, 218, 33, 'PPL', 'P'),
(13710, 'Edenridge', 39.7986106872559, 0.694616794212018, -75.5625, -1.31881441603822, 218, 10, 'PPL', 'P'),
(80827, 'Edens (historical)', 34.5755615234375, 0.603457389309851, -82.1838912963867, -1.43437949522306, 218, 48, 'PPL', 'P'),
(101632, 'Edenshire', 37.3511085510254, 0.651899823485201, -77.4913864135742, -1.35247983485207, 218, 53, 'PPL', 'P'),
(35708, 'Edenton', 37.7669410705566, 0.659157470087886, -84.4847183227539, -1.47453650235204, 218, 21, 'PPL', 'P'),
(64421, 'Edenton', 36.0577812194824, 0.629327003243744, -76.6080627441406, -1.33706292845966, 218, 33, 'PPL', 'P'),
(72408, 'Edenton', 39.228328704834, 0.684663495953956, -84.0530624389648, -1.46700268594431, 218, 41, 'PPL', 'P'),
(78191, 'Edenton', 39.8566703796387, 0.695630127006793, -75.9327774047852, -1.32527697589746, 218, 45, 'PPL', 'P'),
(181312, 'Edenvale', 37.2649993896484, 0.650396935103043, -121.816940307617, -2.12610669307331, 218, 6, 'PPL', 'P'),
(78192, 'Edenville', 39.9575004577637, 0.697389943855118, -77.8041687011719, -1.35793891561257, 218, 45, 'PPL', 'P'),
(115411, 'Edenville', 41.9269409179688, 0.731763164307689, -93.1833267211914, -1.6263558592464, 218, 16, 'PPL', 'P'),
(130622, 'Edenville', 43.7994384765625, 0.764444411940705, -84.3816680908203, -1.47273793650985, 218, 27, 'PPL', 'P'),
(148594, 'Edenville', 41.2758293151855, 0.720399123041184, -74.4113922119141, -1.29872379509077, 218, 40, 'PPL', 'P'),
(155137, 'Edenville', 40.8197212219238, 0.712438535068774, -83.1597213745117, -1.45141094302633, 218, 41, 'PPL', 'P'),
(86743, 'Edenwold', 36.2900009155273, 0.633380001527709, -86.6936111450195, -1.51308895492424, 218, 50, 'PPL', 'P'),
(20796, 'Edenwood', 33.4144401550293, 0.583191998415866, -82.0216674804688, -1.43154815551014, 218, 13, 'PPL', 'P'),
(80828, 'Edenwood', 33.9536094665527, 0.592602278127661, -81.0599975585938, -1.41476384905603, 218, 48, 'PPL', 'P'),
(46793, 'Eder', 39.6277809143066, 0.69163525221362, -75.9091720581055, -1.32486498487682, 218, 25, 'PPL', 'P'),
(181313, 'Eder', 39.2997207641602, 0.685909522448977, -120.291389465332, -2.09948080796887, 218, 6, 'PPL', 'P'),
(93917, 'Ederville', 32.7572212219238, 0.571721364126731, -97.210563659668, -1.69664440358075, 218, 51, 'PPL', 'P'),
(127414, 'Edes Corner', 45.2113914489746, 0.789087640192617, -69.3880615234375, -1.21105013516038, 218, 26, 'PPL', 'P'),
(127409, 'Edes Falls', 43.9988899230957, 0.767925496380575, -70.5691680908203, -1.23166433357814, 218, 26, 'PPL', 'P'),
(46794, 'Edesville', 39.1549987792969, 0.683383647313091, -76.2077789306641, -1.33007665797205, 218, 25, 'PPL', 'P'),
(188467, 'Edgal Place', 32.6808280944824, 0.570388052526983, -108.581108093262, -1.89509784169128, 218, 38, 'PPL', 'P'),
(15886, 'Edgar', 29.5947208404541, 0.516525319874508, -81.9508285522461, -1.43031178297407, 218, 12, 'PPL', 'P'),
(27046, 'Edgar', 39.7555618286133, 0.693865449889479, -87.7011108398438, -1.53067314181176, 218, 18, 'PPL', 'P'),
(64422, 'Edgar', 35.8561096191406, 0.625807169810014, -79.9055633544922, -1.39461517119681, 218, 33, 'PPL', 'P'),
(93918, 'Edgar', 29.2049999237061, 0.509723406713363, -97.23388671875, -1.69705146775337, 218, 51, 'PPL', 'P'),
(101656, 'Edgar', 37.8530616760254, 0.660660558207126, -77.2969436645508, -1.34908616867498, 218, 53, 'PPL', 'P'),
(141716, 'Edgar', 40.3722190856934, 0.704628149381844, -97.9711074829102, -1.70991839740204, 218, 35, 'PPL', 'P'),
(145139, 'Edgar', 40.5675010681152, 0.708036462944927, -74.2761077880859, -1.2963626364683, 218, 37, 'PPL', 'P'),
(173938, 'Edgar', 44.9272193908691, 0.784127902136508, -89.9633331298828, -1.57015636918495, 218, 57, 'PPL', 'P'),
(181314, 'Edgar', 32.788890838623, 0.572274103210977, -115.732498168945, -2.0199131446064, 218, 6, 'PPL', 'P'),
(196411, 'Edgar', 45.4647216796875, 0.793509086813394, -108.851669311523, -1.89982002577815, 218, 31, 'PPL', 'P'),
(20797, 'Edgar (historical)', 34.9441719055176, 0.609890854134183, -84.8949966430664, -1.48169720989104, 218, 13, 'PPL', 'P'),
(109028, 'Edgar (historical)', 38.6788902282715, 0.675073985500799, -81.7041702270508, -1.42600678307196, 218, 58, 'PPL', 'P'),
(54561, 'Edgar Springs', 37.7044410705566, 0.658066639305389, -91.8663864135742, -1.60337091482626, 218, 29, 'PPL', 'P'),
(40767, 'Edgard', 30.0430603027344, 0.524350319657919, -90.5599975585938, -1.58057012799549, 218, 22, 'PPL', 'P'),
(20798, 'Edgars', 32.8450012207031, 0.573253414122826, -83.2125015258789, -1.45233213044739, 218, 13, 'PPL', 'P'),
(124773, 'Edgartown', 41.3888893127441, 0.722372392250878, -70.5138931274414, -1.23069960347325, 218, 23, 'PPL', 'P'),
(93919, 'Edge', 30.889720916748, 0.539127335019415, -96.2944412231445, -1.68065505071203, 218, 51, 'PPL', 'P'),
(8688, 'Edge (historical)', 35.5105590820313, 0.619776175205421, -92.6474990844727, -1.61700390276248, 218, 4, 'PPL', 'P'),
(13711, 'Edge Hill', 39.1680603027344, 0.683611613902402, -75.517219543457, -1.31802412298473, 218, 10, 'PPL', 'P'),
(161206, 'Edge Hill', 40.103328704834, 0.699935126908906, -75.1636123657227, -1.31185251347458, 218, 45, 'PPL', 'P'),
(101633, 'Edge Hill Park', 37.2166709899902, 0.649553445406787, -77.4583282470703, -1.3519028610019, 218, 53, 'PPL', 'P'),
(161207, 'Edgeboro', 40.2355613708496, 0.702243022309569, -74.9305572509766, -1.30778493438365, 218, 45, 'PPL', 'P'),
(145141, 'Edgebrook', 40.4847183227539, 0.706591631474532, -74.4036102294922, -1.29858797387517, 218, 37, 'PPL', 'P'),
(161209, 'Edgebrook', 40.3058280944824, 0.70346940799155, -80.0952835083008, -1.39792641253816, 218, 45, 'PPL', 'P'),
(119473, 'Edgebrook Mobile Home Park', 41.9702796936035, 0.732519568636298, -88.7236099243164, -1.54851911743444, 218, 18, 'PPL', 'P'),
(13712, 'Edgebrooke', 39.6694412231445, 0.692362361770239, -75.6630630493164, -1.32056957235463, 218, 10, 'PPL', 'P'),
(161210, 'Edgecliff', 40.5997200012207, 0.708598789409097, -79.7238922119141, -1.39144441160297, 218, 45, 'PPL', 'P'),
(93920, 'Edgecliff Village', 32.6575012207031, 0.569980921775337, -97.3424987792969, -1.69894710581729, 218, 51, 'PPL', 'P'),
(127410, 'Edgecomb', 43.9583282470703, 0.767217561583804, -69.6311111450195, -1.21529215130271, 218, 26, 'PPL', 'P'),
(207297, 'Edgecomb', 48.1519393920898, 0.840409883612725, -122.139442443848, -2.13173541719525, 218, 56, 'PPL', 'P'),
(64423, 'Edgecombe', 34.4627799987793, 0.601488980369146, -77.5952835083008, -1.35429318123831, 218, 33, 'PPL', 'P'),
(2220, 'Edgefield', 34.9038887023926, 0.609187779606402, -85.8083267211914, -1.49763782691182, 218, 2, 'PPL', 'P'),
(40768, 'Edgefield', 32.0505599975586, 0.559387799065383, -93.3327789306641, -1.62896429237608, 218, 22, 'PPL', 'P'),
(80829, 'Edgefield', 33.7894401550293, 0.589736983110844, -81.9297180175781, -1.42994333463726, 218, 48, 'PPL', 'P'),
(86725, 'Edgefield', 36.3305587768555, 0.634087869745452, -85.9044418334961, -1.49931535208246, 218, 50, 'PPL', 'P'),
(101634, 'Edgefield', 36.889720916748, 0.643847090139074, -76.3913879394531, -1.33328123971174, 218, 53, 'PPL', 'P'),
(155138, 'Edgefield', 40.8388900756836, 0.712773094680715, -81.3869400024414, -1.42047007116568, 218, 41, 'PPL', 'P'),
(59771, 'Edgefield (historical)', 33.124439239502, 0.578130527606116, -89.3375015258789, -1.55923354713205, 218, 30, 'PPL', 'P'),
(78193, 'Edgegrove', 39.8183288574219, 0.694960941203884, -77.033332824707, -1.34448529157576, 218, 45, 'PPL', 'P'),
(101635, 'Edgegrove', 39.1936111450195, 0.684057560226936, -77.7602767944336, -1.35717285732501, 218, 53, 'PPL', 'P'),
(20799, 'Edgehill', 33.1522216796875, 0.578615422661592, -82.6244430541992, -1.44206857392234, 218, 13, 'PPL', 'P'),
(54562, 'Edgehill', 37.5883293151855, 0.656040106873893, -90.9333267211914, -1.58708595107653, 218, 29, 'PPL', 'P'),
(101640, 'Edgehill', 36.7150001525879, 0.640797637532879, -76.9411087036133, -1.34287567701292, 218, 53, 'PPL', 'P'),
(101641, 'Edgehill Estates', 37.2319412231445, 0.649819961252877, -79.9655609130859, -1.39566232613743, 218, 53, 'PPL', 'P'),
(101642, 'Edgelawn', 37.2988891601563, 0.650988423181149, -80.0124969482422, -1.39648151448874, 218, 53, 'PPL', 'P'),
(101643, 'Edgelea', 38.8127784729004, 0.677410776199289, -77.4005584716797, -1.3508945882132, 218, 53, 'PPL', 'P'),
(139937, 'Edgeley', 46.3591690063477, 0.809120137649275, -98.7152786254883, -1.72290663403835, 218, 34, 'PPL', 'P'),
(161211, 'Edgely', 40.1286087036133, 0.700376346122505, -74.834716796875, -1.30611220290297, 218, 45, 'PPL', 'P'),
(181315, 'Edgemar', 37.6538887023926, 0.657184334036246, -122.489723205566, -2.13784896979364, 218, 6, 'PPL', 'P'),
(20800, 'Edgemere', 32.0391693115234, 0.559188994090009, -81.0877838134766, -1.41524881069053, 218, 13, 'PPL', 'P'),
(46795, 'Edgemere', 39.2419395446777, 0.684901049923191, -76.4483337402344, -1.33427513143056, 218, 25, 'PPL', 'P'),
(80832, 'Edgemere', 34.2230606079102, 0.597305087717604, -82.1849975585938, -1.43439880314096, 218, 48, 'PPL', 'P'),
(124775, 'Edgemere', 42.2486114501953, 0.737377374201684, -71.7416687011719, -1.25212832971041, 218, 23, 'PPL', 'P'),
(148595, 'Edgemere', 40.5961112976074, 0.708535805649317, -73.7680587768555, -1.28749550846083, 218, 40, 'PPL', 'P'),
(161212, 'Edgemere', 41.2563896179199, 0.720059836318308, -74.98388671875, -1.30871570918463, 218, 45, 'PPL', 'P'),
(194875, 'Edgemere', 48.0758285522461, 0.839081498860993, -116.814170837402, -2.03879189409981, 218, 17, 'PPL', 'P'),
(145142, 'Edgemere Estates', 40.0202789306641, 0.698485634906603, -74.2369384765625, -1.29567900301648, 218, 37, 'PPL', 'P'),
(2222, 'Edgemont', 33.4655609130859, 0.58408422396007, -86.8225021362305, -1.51533852709703, 218, 2, 'PPL', 'P'),
(8689, 'Edgemont', 35.6022186279297, 0.621375936072231, -92.1961135864258, -1.60912573962581, 218, 4, 'PPL', 'P'),
(27049, 'Edgemont', 38.5936088562012, 0.673585544767553, -90.063606262207, -1.5719064654953, 218, 18, 'PPL', 'P'),
(46798, 'Edgemont', 39.4233283996582, 0.688066882669023, -77.4941711425781, -1.35252843754196, 218, 25, 'PPL', 'P'),
(64429, 'Edgemont', 36.0022201538086, 0.628357279711819, -81.7750015258789, -1.42724302244997, 218, 33, 'PPL', 'P'),
(72410, 'Edgemont', 39.2005615234375, 0.684178867214589, -84.4647216796875, -1.47418749509118, 218, 41, 'PPL', 'P'),
(86728, 'Edgemont', 36.5786094665527, 0.638417170992512, -82.1838912963867, -1.43437949522306, 218, 50, 'PPL', 'P'),
(101644, 'Edgemont', 37.7616691589355, 0.659065457872223, -79.9897232055664, -1.39608403769605, 218, 53, 'PPL', 'P'),
(109035, 'Edgemont', 38.4333305358887, 0.670788160358534, -82.3638916015625, -1.43752109320297, 218, 58, 'PPL', 'P'),
(143788, 'Edgemont', 43.3402786254883, 0.756430560746493, -72.0602798461914, -1.25768914322455, 218, 36, 'PPL', 'P'),
(161214, 'Edgemont', 40.7780609130859, 0.711711425512155, -75.5513916015625, -1.31862053791086, 218, 45, 'PPL', 'P'),
(181316, 'Edgemont', 33.920280456543, 0.59202057716656, -117.277778625488, -2.0468833764398, 218, 6, 'PPL', 'P'),
(186662, 'Edgemont', 39.7311096191406, 0.693438678324794, -105.130279541016, -1.83486952153276, 218, 7, 'PPL', 'P'),
(202091, 'Edgemont', 43.3011093139648, 0.75574692729467, -103.824996948242, -1.81208804261989, 218, 49, 'PPL', 'P'),
(203832, 'Edgemont', 40.2861099243164, 0.703125260999685, -111.651107788086, -1.94867944440118, 218, 52, 'PPL', 'P'),
(207298, 'Edgemont', 46.9249992370605, 0.818995738182534, -120.459716796875, -2.10241867412539, 218, 56, 'PPL', 'P'),
(193517, 'Edgemont (historical)', 40.3116683959961, 0.703571340482273, -120.443893432617, -2.10214250432034, 218, 6, 'PPL', 'P'),
(2226, 'Edgemont Park', 33.4530601501465, 0.583866044487765, -86.8324966430664, -1.51551296414843, 218, 2, 'PPL', 'P'),
(130624, 'Edgemont Park', 42.7466697692871, 0.746070131736785, -84.5936126708984, -1.47643706726397, 218, 27, 'PPL', 'P'),
(203835, 'Edgemont Park', 40.6477813720703, 0.709437618573445, -111.986106872559, -1.9545262814164, 218, 52, 'PPL', 'P'),
(13713, 'Edgemoor', 39.75, 0.693768377667746, -75.5, -1.31772358525572, 218, 10, 'PPL', 'P'),
(20801, 'Edgemoor', 33.9444389343262, 0.592442222146147, -84.1897201538086, -1.46938781301659, 218, 13, 'PPL', 'P'),
(46799, 'Edgemoor', 38.9858283996582, 0.680431067191547, -77.1036071777344, -1.3457118104158, 218, 25, 'PPL', 'P'),
(80833, 'Edgemoor', 34.8055610656738, 0.607471638599955, -81.0116729736328, -1.4139204259388, 218, 48, 'PPL', 'P'),
(86730, 'Edgemoor', 36.014720916748, 0.628575459184124, -84.1575012207031, -1.46882548655242, 218, 50, 'PPL', 'P'),
(207299, 'Edgemoor', 48.7083282470703, 0.850120701053535, -122.506942749023, -2.13814950752265, 218, 56, 'PPL', 'P'),
(2227, 'Edgemoor Estates', 33.4569396972656, 0.58393375535848, -86.8322219848633, -1.51550817045847, 218, 2, 'PPL', 'P'),
(13714, 'Edgemoor Gardens', 39.7583312988281, 0.693913786263264, -75.4972229003906, -1.31767511572388, 218, 10, 'PPL', 'P'),
(20802, 'Edgemoor Manor', 33.5766716003418, 0.586023471286838, -84.3694381713867, -1.47252448414848, 218, 13, 'PPL', 'P'),
(203836, 'Edgemoor Park', 40.6652793884277, 0.70974301657145, -111.949172973633, -1.95388166327454, 218, 52, 'PPL', 'P'),
(13715, 'Edgemoor Terrace', 39.7555618286133, 0.693865449889479, -75.5041732788086, -1.31779642271153, 218, 10, 'PPL', 'P'),
(40769, 'Edgerly', 30.2325000762939, 0.527656667440766, -93.5058288574219, -1.63198458336834, 218, 22, 'PPL', 'P'),
(32304, 'Edgerton', 38.764720916748, 0.676572013613968, -95.0077819824219, -1.65819861061021, 218, 20, 'PPL', 'P'),
(54563, 'Edgerton', 39.5050010681152, 0.689492339642488, -94.633056640625, -1.65165841960519, 218, 29, 'PPL', 'P'),
(101645, 'Edgerton', 36.7788887023926, 0.641912703081295, -77.7777786254883, -1.35747832190204, 218, 53, 'PPL', 'P'),
(122549, 'Edgerton', 41.0766716003418, 0.716923165186413, -84.8061065673828, -1.48014578539802, 218, 19, 'PPL', 'P'),
(130625, 'Edgerton', 43.160831451416, 0.753298616725532, -85.5658264160156, -1.49340539814941, 218, 27, 'PPL', 'P'),
(135145, 'Edgerton', 43.872501373291, 0.765719600049662, -96.1283264160156, -1.67775580039131, 218, 28, 'PPL', 'P'),
(155139, 'Edgerton', 41.4486083984375, 0.723414686922508, -84.7480621337891, -1.47913271891935, 218, 41, 'PPL', 'P'),
(173940, 'Edgerton', 42.8352813720703, 0.747616695960821, -89.067497253418, -1.55452108358315, 218, 57, 'PPL', 'P'),
(209426, 'Edgerton', 43.4130592346191, 0.757700822007433, -106.248893737793, -1.85439302232607, 218, 59, 'PPL', 'P'),
(173941, 'Edgerton Beach Park', 42.8675003051758, 0.748179022424991, -89.021110534668, -1.55371148261177, 218, 57, 'PPL', 'P'),
(54564, 'Edgerton Junction', 39.4775009155273, 0.689012371435028, -94.6747207641602, -1.65238559574084, 218, 29, 'PPL', 'P'),
(119474, 'Edgetown', 41.1794395446777, 0.718716804180581, -87.5755615234375, -1.52848189286685, 218, 18, 'PPL', 'P'),
(130626, 'Edgetts', 44.0566711425781, 0.76893396890636, -85.5830612182617, -1.49370620219454, 218, 27, 'PPL', 'P'),
(46800, 'Edgeview', 38.7388916015625, 0.676121207020445, -76.2005615234375, -1.32995069045249, 218, 25, 'PPL', 'P'),
(15887, 'Edgeville', 27.3141708374023, 0.476722213564888, -82.1083297729492, -1.43306069785125, 218, 12, 'PPL', 'P'),
(64430, 'Edgeville', 36.0930595397949, 0.629942726087771, -79.7622222900391, -1.39211339766879, 218, 33, 'PPL', 'P'),
(2228, 'Edgewater', 33.526668548584, 0.585150753397619, -86.9577789306641, -1.51769955256144, 218, 2, 'PPL', 'P'),
(13716, 'Edgewater', 38.753059387207, 0.676368481527659, -75.2052764892578, -1.31257968961023, 218, 10, 'PPL', 'P'),
(15888, 'Edgewater', 28.9886093139648, 0.505946678102981, -80.9024963378906, -1.41201493417885, 218, 12, 'PPL', 'P'),
(20803, 'Edgewater', 33.4011116027832, 0.582959371294647, -84.5741729736328, -1.4760977805411, 218, 13, 'PPL', 'P'),
(35709, 'Edgewater', 37.2894401550293, 0.650823506930646, -82.4583282470703, -1.43916932360162, 218, 21, 'PPL', 'P'),
(40770, 'Edgewater', 32.5258293151855, 0.56768281349168, -92.0680618286133, -1.60689081483901, 218, 22, 'PPL', 'P'),
(46802, 'Edgewater', 39.3258285522461, 0.686365189311489, -76.4486083984375, -1.33427992512052, 218, 25, 'PPL', 'P'),
(86731, 'Edgewater', 35.4886093139648, 0.619393079482613, -84.9994430541992, -1.4835201436572, 218, 50, 'PPL', 'P'),
(101646, 'Edgewater', 36.894718170166, 0.643934308664775, -76.3080596923828, -1.33182688744045, 218, 53, 'PPL', 'P'),
(122550, 'Edgewater', 41.5161094665527, 0.724592802809732, -87.0466690063477, -1.51925097705447, 218, 19, 'PPL', 'P'),
(145156, 'Edgewater', 40.8269386291504, 0.712564502588334, -73.9761123657227, -1.29112672860715, 218, 37, 'PPL', 'P'),
(148597, 'Edgewater', 43.0463905334473, 0.751301245907973, -78.9100036621094, -1.37723937666459, 218, 40, 'PPL', 'P'),
(171988, 'Edgewater', 44.3236083984375, 0.773592902917345, -72.334716796875, -1.26247897160312, 218, 55, 'PPL', 'P'),
(173943, 'Edgewater', 45.7422218322754, 0.798352378150839, -91.4749984741211, -1.5965399066302, 218, 57, 'PPL', 'P'),
(186664, 'Edgewater', 39.753059387207, 0.693821774047602, -105.063606262207, -1.83370585329445, 218, 7, 'PPL', 'P'),
(207300, 'Edgewater', 47.9527816772461, 0.836933925757953, -122.279441833496, -2.1341788674954, 218, 56, 'PPL', 'P'),
(207301, 'Edgewater (historical)', 47.6547203063965, 0.83173177346362, -122.33943939209, -2.13522602243602, 218, 56, 'PPL', 'P'),
(46803, 'Edgewater Acres', 38.4502792358398, 0.671083970976615, -75.0680618286133, -1.31018484199998, 218, 25, 'PPL', 'P'),
(75742, 'Edgewater Acres', 36.4422187805176, 0.636036704452145, -95.6286087036133, -1.66903408097936, 218, 42, 'PPL', 'P'),
(46804, 'Edgewater Beach', 38.9483299255371, 0.67977659535366, -76.5688934326172, -1.33637929500783, 218, 25, 'PPL', 'P'),
(54565, 'Edgewater Beach', 36.6613883972168, 0.63986193588388, -93.1416702270508, -1.62562881626881, 218, 29, 'PPL', 'P'),
(72412, 'Edgewater Beach', 39.9252815246582, 0.696827617390947, -82.4108276367188, -1.43834028155428, 218, 41, 'PPL', 'P'),
(86732, 'Edgewater Beach', 36.3563919067383, 0.634538742918002, -89.4319381713867, -1.5608817775307, 218, 50, 'PPL', 'P'),
(93921, 'Edgewater Beach', 30.4030609130859, 0.530633515617743, -97.9986114501953, -1.71039843218852, 218, 51, 'PPL', 'P'),
(130627, 'Edgewater Beach', 45.7686080932617, 0.798812905282341, -84.7249984741211, -1.47873018212058, 218, 27, 'PPL', 'P'),
(148598, 'Edgewater Beach', 43.2186088562012, 0.754307022672291, -75.7305603027344, -1.32174762166283, 218, 40, 'PPL', 'P'),
(173944, 'Edgewater Beach', 44.6236114501953, 0.77882894393655, -87.829719543457, -1.53291778713654, 218, 57, 'PPL', 'P'),
(207302, 'Edgewater Beach', 47.1511116027832, 0.822942143443868, -122.93083190918, -2.14554776903089, 218, 56, 'PPL', 'P'),
(86733, 'Edgewater Estates', 35.848331451416, 0.625671415173447, -84.4819412231445, -1.4744880328202, 218, 50, 'PPL', 'P'),
(93922, 'Edgewater Estates Number 1 Colonia', 28.0970001220703, 0.490385162063376, -97.8649978637695, -1.70806643518, 218, 51, 'PPL', 'P'),
(93923, 'Edgewater Estates Number 3 Colonia', 28.0970001220703, 0.490385162063376, -97.8629989624023, -1.70803154776972, 218, 51, 'PPL', 'P'),
(15889, 'Edgewater Gulf Beach', 30.1861095428467, 0.526846999890355, -85.8208312988281, -1.49785607296315, 218, 12, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(130628, 'Edgewater Heights', 42.2038917541504, 0.73659686826521, -83.5119400024414, -1.45755831777056, 218, 27, 'PPL', 'P'),
(2229, 'Edgewater Junction', 33.5308303833008, 0.585223391116351, -86.9588928222656, -1.5177189936374, 218, 2, 'PPL', 'P'),
(15890, 'Edgewater Junction', 28.9766693115234, 0.505738285747682, -80.9466705322266, -1.41278591931442, 218, 12, 'PPL', 'P'),
(93924, 'Edgewater Paisano', 28.0958309173584, 0.490364755591523, -97.8627777099609, -1.70802768618613, 218, 51, 'PPL', 'P'),
(59773, 'Edgewater Park', 30.3933296203613, 0.530463672519223, -88.9869384765625, -1.55311506768564, 218, 30, 'PPL', 'P'),
(72413, 'Edgewater Park', 39.9080581665039, 0.696527013082905, -82.8827819824219, -1.44657743880589, 218, 41, 'PPL', 'P'),
(75743, 'Edgewater Park', 34.8258285522461, 0.607825372971744, -98.3777770996094, -1.71701612118126, 218, 42, 'PPL', 'P'),
(80835, 'Edgewater Park', 32.771671295166, 0.571973565481961, -80.0016708374023, -1.3962925632094, 218, 48, 'PPL', 'P'),
(145143, 'Edgewater Park', 40.0680618286133, 0.699319603801962, -74.9011077880859, -1.30727094429327, 218, 37, 'PPL', 'P'),
(148600, 'Edgewater Park', 44.5999984741211, 0.77841681975786, -75.6352767944336, -1.32008461072013, 218, 40, 'PPL', 'P'),
(207303, 'Edgewater Park', 47.6419410705566, 0.831508733722325, -122.277778625488, -2.13414983903952, 218, 56, 'PPL', 'P'),
(161215, 'Edgewater Terrace', 40.2861099243164, 0.703125260999685, -79.3513870239258, -1.38494296959181, 218, 45, 'PPL', 'P'),
(46805, 'Edgewater Village', 39.4297218322754, 0.688178469118697, -76.3138885498047, -1.33192862019409, 218, 25, 'PPL', 'P'),
(207304, 'Edgewick', 47.4486083984375, 0.828134442042168, -121.724998474121, -2.12450200535849, 218, 56, 'PPL', 'P'),
(2230, 'Edgewood', 33.4674987792969, 0.584118046105914, -86.8108291625977, -1.51513479527364, 218, 2, 'PPL', 'P'),
(8690, 'Edgewood', 34.6352806091309, 0.604499683981481, -90.7855606079102, -1.5845069458769, 218, 4, 'PPL', 'P'),
(13083, 'Edgewood', 38.9225006103516, 0.679325788760137, -77.0008316040039, -1.34391803826357, 218, 9, 'PPL', 'P'),
(15892, 'Edgewood', 28.4858303070068, 0.497171529021656, -81.3724975585938, -1.42021800296851, 218, 12, 'PPL', 'P'),
(20807, 'Edgewood', 32.5563888549805, 0.568216178078996, -83.8402786254883, -1.4632889078042, 218, 13, 'PPL', 'P'),
(35713, 'Edgewood', 36.6133308410645, 0.639023173298559, -83.7813873291016, -1.46226106078148, 218, 21, 'PPL', 'P'),
(46810, 'Edgewood', 39.0149993896484, 0.680940197012943, -76.9166717529297, -1.34244917176434, 218, 25, 'PPL', 'P'),
(54566, 'Edgewood', 39.271671295166, 0.685419966861593, -91.0747222900391, -1.58955376930065, 218, 29, 'PPL', 'P'),
(64434, 'Edgewood', 36.1283302307129, 0.630558315773743, -81.1069412231445, -1.41558317056539, 218, 33, 'PPL', 'P'),
(93925, 'Edgewood', 32.6980590820313, 0.57068878999308, -95.8850021362305, -1.67350899055902, 218, 51, 'PPL', 'P'),
(101651, 'Edgewood', 37.3013916015625, 0.651032099023026, -80.0288925170898, -1.39676767114787, 218, 53, 'PPL', 'P'),
(112559, 'Edgewood', 36.084171295166, 0.629787596954274, -89.2275009155273, -1.55731367430221, 218, 50, 'PPL', 'P'),
(113359, 'Edgewood', 41.7024993896484, 0.727845920660291, -72.9247207641602, -1.27277648343207, 218, 8, 'PPL', 'P'),
(115412, 'Edgewood', 42.6444396972656, 0.744285880385459, -91.4011077880859, -1.59525027087233, 218, 16, 'PPL', 'P'),
(119476, 'Edgewood', 42.2411117553711, 0.737246479834107, -88.9208297729492, -1.55196125314337, 218, 18, 'PPL', 'P'),
(122551, 'Edgewood', 40.103328704834, 0.699935126908906, -85.7341690063477, -1.49634353062204, 218, 19, 'PPL', 'P'),
(130629, 'Edgewood', 43.2919387817383, 0.755586871313156, -84.4288864135742, -1.47356205170918, 218, 27, 'PPL', 'P'),
(135147, 'Edgewood', 45.5363883972168, 0.794759906998377, -93.2305603027344, -1.62718024076184, 218, 28, 'PPL', 'P'),
(148601, 'Edgewood', 42.1402816772461, 0.735486662985783, -74.2127838134766, -1.29525742461592, 218, 40, 'PPL', 'P'),
(155140, 'Edgewood', 41.8727798461914, 0.730817875278765, -80.773063659668, -1.40975590778419, 218, 41, 'PPL', 'P'),
(161219, 'Edgewood', 40.788330078125, 0.711890656253517, -76.5727767944336, -1.33644707245758, 218, 45, 'PPL', 'P'),
(169360, 'Edgewood', 41.7813911437988, 0.729222841522889, -71.398063659668, -1.24613129040972, 218, 47, 'PPL', 'P'),
(173946, 'Edgewood', 43.0625, 0.751582409140058, -88.3016662597656, -1.5411548112301, 218, 57, 'PPL', 'P'),
(177216, 'Edgewood', 40.0786094665527, 0.699503694812313, -80.6841735839844, -1.40820448329116, 218, 58, 'PPL', 'P'),
(188468, 'Edgewood', 35.0613899230957, 0.611936694483581, -106.190826416016, -1.85337955637324, 218, 38, 'PPL', 'P'),
(190159, 'Edgewood', 38.9608306884766, 0.679994774825965, -119.940826416016, -2.09336232852246, 218, 39, 'PPL', 'P'),
(193516, 'Edgewood', 41.4583282470703, 0.723584330283946, -122.430557250977, -2.13681632908096, 218, 6, 'PPL', 'P'),
(207305, 'Edgewood', 47.2502784729004, 0.82467293183631, -122.292503356934, -2.13440683408471, 218, 56, 'PPL', 'P'),
(72414, 'Edgewood (historical)', 39.5458297729492, 0.690204934971165, -84.1369400024414, -1.46846662559553, 218, 41, 'PPL', 'P'),
(86736, 'Edgewood Acres', 35.8083305358887, 0.624973267493683, -83.936393737793, -1.46496643297484, 218, 50, 'PPL', 'P'),
(109033, 'Edgewood Acres', 38.3811111450195, 0.669876760054482, -81.6313934326172, -1.42473658839005, 218, 58, 'PPL', 'P'),
(20810, 'Edgewood Crossroads', 33.6130599975586, 0.586658568627795, -82.8775024414063, -1.44648529343218, 218, 13, 'PPL', 'P'),
(20811, 'Edgewood Estates', 34.0333290100098, 0.593993646639173, -84.6952819824219, -1.47821153149829, 218, 13, 'PPL', 'P'),
(203838, 'Edgewood Estates', 40.6538887023926, 0.709544211596076, -111.848892211914, -1.95213143380614, 218, 52, 'PPL', 'P'),
(148602, 'Edgewood Garden', 43.0869407653809, 0.752008980967662, -76.2688903808594, -1.33114325398863, 218, 40, 'PPL', 'P'),
(46811, 'Edgewood Heights', 39.4263916015625, 0.688120345627906, -76.2994384765625, -1.33167641883886, 218, 25, 'PPL', 'P'),
(86737, 'Edgewood Heights', 36.0400009155273, 0.629016678397723, -84.1374969482422, -1.46847634613351, 218, 50, 'PPL', 'P'),
(13717, 'Edgewood Hills', 39.7583312988281, 0.693913786263264, -75.5041732788086, -1.31779642271153, 218, 10, 'PPL', 'P'),
(46813, 'Edgewood Hills', 39.6758308410645, 0.692473881640886, -75.932502746582, -1.32527218220749, 218, 25, 'PPL', 'P'),
(86738, 'Edgewood Hills', 35.7044410705566, 0.623160054265502, -84.8755569458008, -1.48135792316817, 218, 50, 'PPL', 'P'),
(161220, 'Edgewood Hills', 40.2400016784668, 0.70232052029729, -76.684440612793, -1.3383959737433, 218, 45, 'PPL', 'P'),
(29701, 'Edgewood Lake', 39.6394386291504, 0.691838717720902, -86.7991714477539, -1.51493132976636, 218, 19, 'PPL', 'P'),
(13718, 'Edgewood Manor', 38.5533294677734, 0.6728825368188, -75.1527786254883, -1.31166342903719, 218, 10, 'PPL', 'P'),
(46814, 'Edgewood Meadows', 39.4263916015625, 0.688120345627906, -76.3061065673828, -1.3317927989785, 218, 25, 'PPL', 'P'),
(2232, 'Edgewood Mobile Home Park', 31.7652797698975, 0.554408719801857, -85.9625015258789, -1.50032868487724, 218, 2, 'PPL', 'P'),
(72417, 'Edgewood Mobile Home Park', 39.9033317565918, 0.696444521668139, -83.8852767944336, -1.46407427400966, 218, 41, 'PPL', 'P'),
(46815, 'Edgewood Park', 38.4263916015625, 0.670667053107963, -75.6597213745117, -1.32051124912676, 218, 25, 'PPL', 'P'),
(64438, 'Edgewood Park', 34.8238906860352, 0.6077915508259, -77.4572219848633, -1.351883553084, 218, 33, 'PPL', 'P'),
(145146, 'Edgewood Park', 40.1463890075684, 0.700686670968527, -74.2624969482422, -1.29612508249907, 218, 37, 'PPL', 'P'),
(148603, 'Edgewood Park', 44.329719543457, 0.773699562519003, -75.9188919067383, -1.32503462823826, 218, 40, 'PPL', 'P'),
(155141, 'Edgewood Park', 40.7916717529297, 0.71194897948139, -81.4583282470703, -1.42171603108168, 218, 41, 'PPL', 'P'),
(13084, 'Edgewood Terrace', 38.9233283996582, 0.679340236409051, -76.9930572509766, -1.34378235020604, 218, 9, 'PPL', 'P'),
(64439, 'Edgewood Terrace', 35.2316703796387, 0.614908649102055, -79.5697174072266, -1.38875355363755, 218, 33, 'PPL', 'P'),
(46816, 'Edgewood View', 39.4463882446289, 0.688469352888761, -77.4749984741211, -1.352193811351, 218, 25, 'PPL', 'P'),
(40771, 'Edgewood Village', 32.4005584716797, 0.565496424815752, -93.8424987792969, -1.63786058199749, 218, 22, 'PPL', 'P'),
(122552, 'Edgewood Village', 40.101390838623, 0.699901304763062, -85.753059387207, -1.49667322996499, 218, 19, 'PPL', 'P'),
(93926, 'Edgeworth', 30.9513893127441, 0.54020365157397, -97.1402816772461, -1.69541775158266, 218, 51, 'PPL', 'P'),
(124776, 'Edgeworth', 42.4188919067383, 0.740349328820158, -71.0805587768555, -1.24058978481348, 218, 23, 'PPL', 'P'),
(161222, 'Edgeworth', 40.5511093139648, 0.707750372864826, -80.1930618286133, -1.39963296616469, 218, 45, 'PPL', 'P'),
(86739, 'Edgeworth (historical)', 36.5416717529297, 0.637772486271631, -82.3930587768555, -1.43803015644534, 218, 50, 'PPL', 'P'),
(93927, 'Edgeworth Place', 29.8850002288818, 0.521591650953247, -95.3083267211914, -1.66344410585128, 218, 51, 'PPL', 'P'),
(2233, 'Edgil', 33.9019393920898, 0.591700465203533, -87.3550033569336, -1.52463242666919, 218, 2, 'PPL', 'P'),
(35711, 'Edgington', 38.6800003051758, 0.675093359997729, -82.8824996948242, -1.44657251195788, 218, 21, 'PPL', 'P'),
(119477, 'Edgington', 41.3869400024414, 0.722338370367953, -90.7636108398438, -1.58412385015409, 218, 18, 'PPL', 'P'),
(35712, 'Edgoten', 36.6416702270508, 0.639517788892014, -87.4238891601563, -1.52583471074331, 218, 21, 'PPL', 'P'),
(141718, 'Edholm', 41.3941688537598, 0.722464537624595, -97.0386123657227, -1.69364328734834, 218, 35, 'PPL', 'P'),
(93928, 'Edhube', 33.5263900756836, 0.58514589312863, -96.2174987792969, -1.67931215173236, 218, 51, 'PPL', 'P'),
(148604, 'Edicks', 42.9674987792969, 0.749924325045375, -74.9300003051758, -1.30777521384567, 218, 40, 'PPL', 'P'),
(161224, 'Edie', 40.086669921875, 0.699644376296897, -79.1272201538086, -1.38103051963437, 218, 45, 'PPL', 'P'),
(20814, 'Edie (historical)', 33.3027801513672, 0.581243163709173, -82.1513900756836, -1.43381224191087, 218, 13, 'PPL', 'P'),
(196412, 'Edilou', 45.8788909912109, 0.800737704960196, -111.195831298828, -1.94073337065671, 218, 31, 'PPL', 'P'),
(113131, 'Edina', 40.1674995422363, 0.701055119305339, -92.1725006103516, -1.60871361544712, 218, 29, 'PPL', 'P'),
(135148, 'Edina', 44.889720916748, 0.783473430298621, -93.3497161865234, -1.62925990325708, 218, 28, 'PPL', 'P'),
(161225, 'Edinboro', 41.8741683959961, 0.730842110044685, -80.1319427490234, -1.39856623699006, 218, 45, 'PPL', 'P'),
(46817, 'Edinboro Estates', 39.0924987792969, 0.682292816530595, -76.5838928222656, -1.33664108374299, 218, 25, 'PPL', 'P'),
(27051, 'Edinburg', 39.6572189331055, 0.692149042566923, -89.3894424438477, -1.56014008716711, 218, 18, 'PPL', 'P'),
(59775, 'Edinburg', 32.7991714477539, 0.572453533689421, -89.3361129760742, -1.55920931236613, 218, 30, 'PPL', 'P'),
(93929, 'Edinburg', 26.3013896942139, 0.459045848014137, -98.1630630493164, -1.71326865405336, 218, 51, 'PPL', 'P'),
(101655, 'Edinburg', 38.8208312988281, 0.677551324525817, -78.5661087036133, -1.37123727735783, 218, 53, 'PPL', 'P'),
(115413, 'Edinburg', 42.1333312988281, 0.73536535599813, -91.1338882446289, -1.59058641001333, 218, 16, 'PPL', 'P'),
(139132, 'Edinburg', 40.3736114501953, 0.704652450726791, -92.184440612793, -1.60892200780242, 218, 29, 'PPL', 'P'),
(139939, 'Edinburg', 48.4966697692871, 0.846426563726459, -97.8616714477539, -1.70800837826823, 218, 34, 'PPL', 'P'),
(145147, 'Edinburg', 40.2580604553223, 0.702635705412301, -74.6163864135742, -1.30230161885723, 218, 37, 'PPL', 'P'),
(148605, 'Edinburg', 43.2216682434082, 0.754360419052147, -74.1044387817383, -1.29336644708391, 218, 40, 'PPL', 'P'),
(155142, 'Edinburg', 41.0997200012207, 0.717325435669069, -81.146110534668, -1.41626680401721, 218, 41, 'PPL', 'P'),
(161227, 'Edinburg', 41.0144386291504, 0.715836994935824, -80.4369430541992, -1.40388949653496, 218, 45, 'PPL', 'P'),
(20815, 'Edinburg (historical)', 34.1822204589844, 0.596592292651845, -82.7355575561523, -1.44400788782813, 218, 13, 'PPL', 'P'),
(93930, 'Edinburg Acres Colonia', 26.3810005187988, 0.460435319023372, -98.0899963378906, -1.71199339936537, 218, 51, 'PPL', 'P'),
(46818, 'Edinburg Forest', 39.4311103820801, 0.688202703884617, -77.5069427490234, -1.3527513441252, 218, 25, 'PPL', 'P'),
(145148, 'Edinburg Park', 40.2686080932617, 0.702819796422653, -74.6172180175781, -1.30231613308517, 218, 37, 'PPL', 'P'),
(29702, 'Edinburgh', 39.3541717529297, 0.686859871483971, -85.966667175293, -1.500401389175, 218, 19, 'PPL', 'P'),
(64440, 'Edinburgh', 34.9055595397949, 0.609216941220338, -79.3102798461914, -1.38422551399414, 218, 33, 'PPL', 'P'),
(80837, 'Edinburgh', 34.0849990844727, 0.594895459563301, -80.9486083984375, -1.41281974146027, 218, 48, 'PPL', 'P'),
(155144, 'Edinburgh', 40.7552795410156, 0.711313815561406, -81.8441696166992, -1.42845023337211, 218, 41, 'PPL', 'P'),
(203841, 'Edinburgh of Holladay Condominium', 40.6661109924316, 0.709757530799391, -111.859718322754, -1.95232038508548, 218, 52, 'PPL', 'P'),
(86740, 'Edington (historical)', 35.8911094665527, 0.626418032385051, -84.0888900756836, -1.46762799616826, 218, 50, 'PPL', 'P'),
(15893, 'Edison', 27.8649997711182, 0.486335992073478, -82.0666732788086, -1.43233365487366, 218, 12, 'PPL', 'P'),
(20816, 'Edison', 31.5580596923828, 0.550792047172989, -84.7383270263672, -1.4789628092418, 218, 13, 'PPL', 'P'),
(32306, 'Edison', 37.5138893127441, 0.654740883736098, -94.7463912963867, -1.65363648250485, 218, 20, 'PPL', 'P'),
(86741, 'Edison', 35.8955612182617, 0.626495730109854, -88.9638900756836, -1.55271279720299, 218, 50, 'PPL', 'P'),
(109034, 'Edison', 37.3036117553711, 0.651070848016887, -81.1555633544922, -1.41643178684674, 218, 58, 'PPL', 'P'),
(141719, 'Edison', 40.2772216796875, 0.702970131866188, -99.7766723632813, -1.74143144942289, 218, 35, 'PPL', 'P'),
(145150, 'Edison', 41.0638885498047, 0.716700058866091, -74.5680618286133, -1.30145819574001, 218, 37, 'PPL', 'P'),
(155145, 'Edison', 40.5574989318848, 0.707861892735473, -82.8625030517578, -1.44622350469702, 218, 41, 'PPL', 'P'),
(161228, 'Edison', 40.2802810668945, 0.703023528246044, -75.1297225952148, -1.31126102539648, 218, 45, 'PPL', 'P'),
(181317, 'Edison', 35.3474998474121, 0.616930254685535, -118.870826721191, -2.07468731085245, 218, 6, 'PPL', 'P'),
(207306, 'Edison', 48.5625, 0.847575517999746, -122.442497253418, -2.13702472143626, 218, 56, 'PPL', 'P'),
(15894, 'Edison Center', 25.8333301544189, 0.450876667949346, -80.2013931274414, -1.3997783747602, 218, 12, 'PPL', 'P'),
(207307, 'Edison Station', 48.5658302307129, 0.847633641490537, -122.420829772949, -2.13664655256147, 218, 56, 'PPL', 'P'),
(161229, 'Edisonville', 40.3077812194824, 0.703503496453503, -76.4049987792969, -1.33351879368098, 218, 45, 'PPL', 'P'),
(80838, 'Edisto', 33.476390838623, 0.584273241818438, -80.8988876342773, -1.41195195041907, 218, 48, 'PPL', 'P'),
(80839, 'Edisto Beach', 32.4791717529297, 0.566868485409361, -80.3349990844727, -1.40211023861068, 218, 48, 'PPL', 'P'),
(80840, 'Edisto Club', 33.4027786254883, 0.582988466329556, -81.1563873291016, -1.41644616791663, 218, 48, 'PPL', 'P'),
(80841, 'Edisto Island', 32.560001373291, 0.568279228417804, -80.2799987792969, -1.40115030219576, 218, 48, 'PPL', 'P'),
(80842, 'Edistone (historical)', 33.4680595397949, 0.58412783322292, -80.8844375610352, -1.41169974906384, 218, 48, 'PPL', 'P'),
(20817, 'Edith', 30.6783294677734, 0.535437858224246, -82.5513916015625, -1.44079358555046, 218, 13, 'PPL', 'P'),
(40772, 'Edith', 30.5161094665527, 0.532606585090356, -93.1555633544922, -1.62587129708606, 218, 22, 'PPL', 'P'),
(75744, 'Edith', 36.8027801513672, 0.642329687528975, -99.2108306884766, -1.73155564915255, 218, 42, 'PPL', 'P'),
(86742, 'Edith', 35.848331451416, 0.625671415173447, -89.5330581665039, -1.56264665438509, 218, 50, 'PPL', 'P'),
(109036, 'Edith', 37.6766700744629, 0.657581943986995, -81.6074981689453, -1.42431953736334, 218, 58, 'PPL', 'P'),
(186665, 'Edith', 37.0055618286133, 0.645868895459635, -106.909721374512, -1.86592664037499, 218, 7, 'PPL', 'P'),
(191415, 'Edith', 31.9033298492432, 0.556818148219079, -100.610282897949, -1.75598069793216, 218, 51, 'PPL', 'P'),
(196413, 'Edith Nelson Trailer Court', 47.1536102294922, 0.822985752706718, -110.213890075684, -1.92359526325178, 218, 31, 'PPL', 'P'),
(186666, 'Edler', 37.1763916015625, 0.648850437458034, -102.777778625488, -1.79381063490062, 218, 7, 'PPL', 'P'),
(20818, 'Edman', 33.0363883972168, 0.576593750499085, -84.5644378662109, -1.47592787086355, 218, 13, 'PPL', 'P'),
(181318, 'Edmanton (historical)', 39.9022216796875, 0.696425147171209, -121.103607177734, -2.1136566812933, 218, 6, 'PPL', 'P'),
(148607, 'Edmeston', 42.6977806091309, 0.745216854923524, -75.2441711425781, -1.31325852937209, 218, 40, 'PPL', 'P'),
(181319, 'Edmiston', 36.7788887023926, 0.641912703081295, -119.539436340332, -2.08635675011695, 218, 6, 'PPL', 'P'),
(161230, 'Edmon', 40.5263900756836, 0.707318940768233, -79.4933319091797, -1.38742037519586, 218, 45, 'PPL', 'P'),
(2234, 'Edmond', 34.6388893127441, 0.604562667741261, -87.470832824707, -1.52665403225267, 218, 2, 'PPL', 'P'),
(32307, 'Edmond', 39.6272201538086, 0.691625465096614, -99.8222198486328, -1.74222640300828, 218, 20, 'PPL', 'P'),
(75745, 'Edmond', 35.6527786254883, 0.622258374499429, -97.477783203125, -1.70130826443976, 218, 42, 'PPL', 'P'),
(109037, 'Edmond', 38.0622215270996, 0.664311086271352, -81.0274963378906, -1.41419659574384, 218, 58, 'PPL', 'P'),
(64441, 'Edmonds', 36.5605583190918, 0.638102119035555, -80.9436111450195, -1.41273252293457, 218, 33, 'PPL', 'P'),
(194876, 'Edmonds', 43.9130592346191, 0.766427468267405, -111.879997253418, -1.95267431919436, 218, 17, 'PPL', 'P'),
(207308, 'Edmonds', 47.8108291625977, 0.834456386995852, -122.376106262207, -2.13586598004596, 218, 56, 'PPL', 'P'),
(101664, 'Edmonds Corner', 36.7916717529297, 0.642135809401617, -76.2608337402344, -1.33100263908307, 218, 53, 'PPL', 'P'),
(8692, 'Edmondson', 35.1063919067383, 0.612722127268073, -90.3102798461914, -1.57621173171352, 218, 4, 'PPL', 'P'),
(64442, 'Edmondson', 35.5550003051758, 0.620551820872906, -78.5997161865234, -1.37182383858792, 218, 33, 'PPL', 'P'),
(86744, 'Edmondson (historical)', 36.4116706848145, 0.635503539601911, -83.67138671875, -1.46034118795164, 218, 50, 'PPL', 'P'),
(46819, 'Edmondson Ridge', 39.2830581665039, 0.68561870525794, -76.7291717529297, -1.33917667941685, 218, 25, 'PPL', 'P'),
(46820, 'Edmondson Village', 39.2949981689453, 0.685827097613239, -76.6819381713867, -1.33835229790142, 218, 25, 'PPL', 'P'),
(54570, 'Edmonson', 38.309440612793, 0.668625873290471, -93.2238922119141, -1.6270638606222, 218, 29, 'PPL', 'P'),
(191416, 'Edmonson', 34.2825012207031, 0.598342522120245, -101.899719238281, -1.77848560756582, 218, 51, 'PPL', 'P'),
(8693, 'Edmonson (historical)', 35.8911094665527, 0.626418032385051, -91.8161087036133, -1.60249340324707, 218, 4, 'PPL', 'P'),
(46821, 'Edmonston', 38.9466705322266, 0.679747633476806, -76.9313888549805, -1.34270603365148, 218, 25, 'PPL', 'P'),
(35715, 'Edmonton', 36.9799995422363, 0.64542274939802, -85.6122207641602, -1.49421513227885, 218, 21, 'PPL', 'P'),
(2235, 'Edmonton Heights', 34.7775001525879, 0.606981883275489, -86.5663909912109, -1.51086854436539, 218, 2, 'PPL', 'P'),
(115414, 'Edmore', 42.5561103820801, 0.742744243009439, -90.6786117553711, -1.58264033626886, 218, 16, 'PPL', 'P'),
(130630, 'Edmore', 43.4080581665039, 0.757613536902706, -85.0386123657227, -1.48420377710902, 218, 27, 'PPL', 'P'),
(139941, 'Edmore', 48.413330078125, 0.844972011718085, -98.4538879394531, -1.71834450593299, 218, 34, 'PPL', 'P'),
(80843, 'Edmund', 33.8613891601563, 0.590992730143844, -81.2002792358398, -1.41721222620419, 218, 48, 'PPL', 'P'),
(173947, 'Edmund', 42.9674987792969, 0.749924325045375, -90.2644424438477, -1.57541171812206, 218, 57, 'PPL', 'P'),
(127413, 'Edmunds', 44.871940612793, 0.783163105452599, -67.1647186279297, -1.17224548123294, 218, 26, 'PPL', 'P'),
(139943, 'Edmunds', 47.2472190856934, 0.824619535456454, -98.9677810668945, -1.72731363301022, 218, 34, 'PPL', 'P'),
(101657, 'Edmunds Store', 36.8763885498047, 0.643614396438829, -77.9422225952148, -1.36034841060882, 218, 53, 'PPL', 'P'),
(72418, 'Edmunds Switch', 38.8080596923828, 0.677328417942578, -82.7594375610352, -1.44442467253873, 218, 41, 'PPL', 'P'),
(54567, 'Edmundson', 38.7358283996582, 0.676067744061562, -90.3638916015625, -1.57714743336252, 218, 29, 'PPL', 'P'),
(181320, 'Edmundson Acres', 35.228889465332, 0.614860112991189, -118.822219848633, -2.0738389608872, 218, 6, 'PPL', 'P'),
(64443, 'Edmundson Crossroads', 35.502498626709, 0.619635493720837, -77.8988876342773, -1.35959207285924, 218, 33, 'PPL', 'P'),
(13, 'Edna', 28.9783306121826, 0.505767280914051, -96.6458282470703, -1.68678791122832, 218, 51, 'PPL', 'P'),
(2238, 'Edna', 32.2866706848145, 0.563508707957145, -88.0741729736328, -1.5371843043609, 218, 2, 'PPL', 'P'),
(8694, 'Edna', 35.5547218322754, 0.620546960603917, -93.6319427490234, -1.63418568600929, 218, 4, 'PPL', 'P'),
(20820, 'Edna', 32.2311096191406, 0.562538984425219, -81.8308334350586, -1.42821747309283, 218, 13, 'PPL', 'P'),
(32308, 'Edna', 37.0597190856934, 0.646814117909532, -95.3591690063477, -1.6643314711265, 218, 20, 'PPL', 'P'),
(35716, 'Edna', 37.7933311462402, 0.659618063798415, -83.1505584716797, -1.45125102020287, 218, 21, 'PPL', 'P'),
(40773, 'Edna', 30.4208297729492, 0.530943640726683, -92.8863906860352, -1.62117334776511, 218, 22, 'PPL', 'P'),
(59776, 'Edna', 31.1769409179688, 0.544140269718298, -89.7861099243164, -1.56706324073688, 218, 30, 'PPL', 'P'),
(75747, 'Edna', 35.7038917541504, 0.623150466885578, -96.2102813720703, -1.67918618421279, 218, 42, 'PPL', 'P'),
(86745, 'Edna', 36.103328704834, 0.630121956829133, -83.3763885498047, -1.45519249861619, 218, 50, 'PPL', 'P'),
(109040, 'Edna', 39.5750007629395, 0.690714064792561, -80.0541687011719, -1.39720882378244, 218, 58, 'PPL', 'P'),
(115415, 'Edna', 43.3849983215332, 0.757211066682968, -96.0941696166992, -1.6771596517813, 218, 16, 'PPL', 'P'),
(181321, 'Edna', 35.2038917541504, 0.614423820625607, -120.611938476563, -2.10507544362885, 218, 6, 'PPL', 'P'),
(207309, 'Edna', 46.5897216796875, 0.81314404089833, -119.413330078125, -2.08415578063406, 218, 56, 'PPL', 'P'),
(72419, 'Edna (historical)', 38.9724998474121, 0.680198440070329, -82.4086074829102, -1.43830153256042, 218, 41, 'PPL', 'P'),
(209951, 'Edna Bay', 55.9488906860352, 0.976492355309702, -133.662216186523, -2.33284575796729, 218, 1, 'PPL', 'P'),
(93931, 'Edna Hill', 31.9563903808594, 0.557744229198641, -98.3300018310547, -1.71618228544396, 218, 51, 'PPL', 'P'),
(122553, 'Edna Mills', 40.4174995422363, 0.705418442435325, -86.6677780151367, -1.51263808175169, 218, 19, 'PPL', 'P'),
(161231, 'Edna Number One', 40.3008308410645, 0.70338218946585, -79.6516723632813, -1.39018393745903, 218, 45, 'PPL', 'P'),
(161232, 'Edna Number Two', 40.292781829834, 0.703241707718349, -79.6888885498047, -1.3908334824489, 218, 45, 'PPL', 'P'),
(101658, 'Ednam', 38.0511093139648, 0.664117141564967, -78.5388870239258, -1.37076216941936, 218, 53, 'PPL', 'P'),
(101659, 'Ednam Forest', 38.0461082458496, 0.66402985646024, -78.5461120605469, -1.37088827009697, 218, 53, 'PPL', 'P'),
(101660, 'Ednam Village', 38.0483283996582, 0.664068605454101, -78.5377807617188, -1.37074286150145, 218, 53, 'PPL', 'P'),
(101661, 'Ednas Mill', 37.4569396972656, 0.653746925438253, -77.1302795410156, -1.34617733097434, 218, 53, 'PPL', 'P'),
(20819, 'Ednaville', 34.1288909912109, 0.595661517850862, -83.7708282470703, -1.46207677003405, 218, 13, 'PPL', 'P'),
(46822, 'Ednor', 39.1358299255371, 0.68304908770115, -76.9952774047852, -1.3438210991999, 218, 25, 'PPL', 'P'),
(46823, 'Ednor Acres', 39.139720916748, 0.683116998308947, -76.9933319091797, -1.343787143896, 218, 25, 'PPL', 'P'),
(46824, 'Ednor Farms', 39.139720916748, 0.683116998308947, -76.9986114501953, -1.34387928926971, 218, 25, 'PPL', 'P'),
(46825, 'Ednor View', 39.1500015258789, 0.683296428787391, -76.9822235107422, -1.34359326576864, 218, 25, 'PPL', 'P'),
(46826, 'Ednor Woods', 39.1355590820313, 0.683044360590215, -77.0041732788086, -1.34397636149145, 218, 25, 'PPL', 'P'),
(93934, 'Edom', 32.3722190856934, 0.565001809222297, -95.6086120605469, -1.6686850737185, 218, 51, 'PPL', 'P'),
(101662, 'Edom', 38.5255584716797, 0.672397841500405, -78.8591690063477, -1.37635214454743, 218, 53, 'PPL', 'P'),
(181322, 'Edom', 33.8069381713867, 0.590042381108849, -116.390281677246, -2.03139363259157, 218, 6, 'PPL', 'P'),
(72420, 'Edoma Trail Subdivision', 38.9222183227539, 0.679320861912121, -82.3613891601563, -1.43747741736109, 218, 41, 'PPL', 'P'),
(155147, 'Edon', 41.5563888549805, 0.725295810758486, -84.7688903808594, -1.47949624040815, 218, 41, 'PPL', 'P'),
(109038, 'Edray', 38.2744407653809, 0.668015010715434, -80.091667175293, -1.39786329562033, 218, 58, 'PPL', 'P'),
(93932, 'Edroy', 27.9733295440674, 0.48822670328938, -97.6758270263672, -1.70476478121857, 218, 51, 'PPL', 'P'),
(93933, 'Edroy Colonia', 27.9750003814697, 0.488255864903316, -97.677001953125, -1.70478528755896, 218, 51, 'PPL', 'P'),
(54568, 'Edsall (historical)', 37.7400016784668, 0.658687288997432, -93.9002838134766, -1.6388691211023, 218, 29, 'PPL', 'P'),
(101663, 'Edsall Park', 38.8066711425781, 0.677304183176658, -77.1763916015625, -1.34698213825577, 218, 53, 'PPL', 'P'),
(200752, 'Edsalla (historical)', 42.5458297729492, 0.742564812530995, -122.636108398438, -2.1404038733854, 218, 43, 'PPL', 'P'),
(35717, 'Edsel', 38.1177787780762, 0.66528074322425, -82.9094390869141, -1.44704269304833, 218, 21, 'PPL', 'P'),
(148609, 'Edson', 42.026668548584, 0.733503739817137, -75.6616668701172, -1.32054520443066, 218, 40, 'PPL', 'P'),
(173948, 'Edson', 44.9300003051758, 0.784176438247374, -91.0347213745117, -1.58885562162089, 218, 57, 'PPL', 'P'),
(187660, 'Edson', 39.3372192382813, 0.686563994286864, -101.540000915527, -1.77220733845401, 218, 20, 'PPL', 'P'),
(209427, 'Edson', 41.8125, 0.729765793490129, -106.789436340332, -1.86382727048768, 218, 59, 'PPL', 'P'),
(2236, 'Edsons', 32.3180618286133, 0.564056586772401, -86.7752838134766, -1.51451441189771, 218, 2, 'PPL', 'P'),
(59777, 'Edsville', 33.1725006103516, 0.578969356770463, -89.8333282470703, -1.5678873559362, 218, 30, 'PPL', 'P'),
(207311, 'Edwall', 47.5047187805176, 0.829113752954017, -117.949996948242, -2.05861579946409, 218, 56, 'PPL', 'P'),
(32309, 'Edward', 37.7833290100098, 0.65944349358896, -94.6972198486328, -1.65277827884357, 218, 20, 'PPL', 'P'),
(64446, 'Edward', 35.3241691589355, 0.616523057354861, -76.8755569458008, -1.34173158300862, 218, 33, 'PPL', 'P'),
(72421, 'Edward', 39.8833312988281, 0.696095447828257, -82.9308319091797, -1.44741606823316, 218, 41, 'PPL', 'P'),
(13719, 'Edward Cordrey Subdivision', 38.6288909912109, 0.674201334190607, -75.2813873291016, -1.31390807436196, 218, 10, 'PPL', 'P'),
(40774, 'Edward Daigle', 29.6388893127441, 0.517296205141545, -90.7608337402344, -1.58407538062225, 218, 22, 'PPL', 'P'),
(86746, 'Edward Grove', 35.7052803039551, 0.623174701651498, -89.4274978637695, -1.56080427954297, 218, 50, 'PPL', 'P'),
(8695, 'Edwards', 35.0233306884766, 0.611272435528688, -91.7972183227539, -1.60216370390412, 218, 4, 'PPL', 'P'),
(35718, 'Edwards', 36.959171295166, 0.645059227909224, -86.9408264160156, -1.51740367536433, 218, 21, 'PPL', 'P'),
(54569, 'Edwards', 38.1366691589355, 0.665610442567202, -93.1694412231445, -1.62611351158721, 218, 29, 'PPL', 'P'),
(59778, 'Edwards', 32.3300018310547, 0.5642649791277, -90.6055603027344, -1.58136534789699, 218, 30, 'PPL', 'P'),
(80844, 'Edwards', 33.5641708374023, 0.585805291814533, -79.9550018310547, -1.39547803539, 218, 48, 'PPL', 'P'),
(93935, 'Edwards', 33.8261108398438, 0.590377007299818, -98.0305633544922, -1.71095609812079, 218, 51, 'PPL', 'P'),
(119481, 'Edwards', 40.7458305358887, 0.711148899310903, -89.7441711425781, -1.56633127091127, 218, 18, 'PPL', 'P'),
(130631, 'Edwards', 44.1763916015625, 0.771023485097637, -84.2666702270508, -1.47073084515431, 218, 27, 'PPL', 'P'),
(135152, 'Edwards', 46.4488906860352, 0.810686076370241, -95.9886093139648, -1.67531727693918, 218, 28, 'PPL', 'P'),
(148610, 'Edwards', 44.3244400024414, 0.773607417145286, -75.2513885498047, -1.31338449689165, 218, 40, 'PPL', 'P'),
(181323, 'Edwards', 34.9261093139648, 0.609575602440144, -117.934173583984, -2.05833962965905, 218, 6, 'PPL', 'P'),
(186667, 'Edwards', 39.6450004577637, 0.691935789942635, -106.593612670898, -1.86040950270272, 218, 7, 'PPL', 'P'),
(196414, 'Edwards', 47.1402816772461, 0.822753125585499, -107.333061218262, -1.8733153145033, 218, 31, 'PPL', 'P'),
(207310, 'Edwards', 46.5497207641602, 0.812445893218566, -119.003608703613, -2.07700479363303, 218, 56, 'PPL', 'P'),
(20821, 'Edwards (historical)', 31.8758296966553, 0.55633818001162, -84.293327331543, -1.47119609939675, 218, 13, 'PPL', 'P'),
(115417, 'Edwards (historical)', 42.5702781677246, 0.742991517516653, -92.2588882446289, -1.61022136409827, 218, 16, 'PPL', 'P'),
(64447, 'Edwards Acres', 35.5766716003418, 0.620930056326725, -77.3008270263672, -1.34915394612473, 218, 33, 'PPL', 'P'),
(190161, 'Edwards Creek Station (historical)', 39.5169410705566, 0.689700731997786, -117.754173278809, -2.05519803167914, 218, 39, 'PPL', 'P'),
(161233, 'Edwards Crossing', 40.5344390869141, 0.707459422515734, -78.8433303833008, -1.37607570842628, 218, 45, 'PPL', 'P'),
(196415, 'Edwards Crossing', 48.4669418334961, 0.845907713367084, -112.451110839844, -1.96264213168036, 218, 31, 'PPL', 'P'),
(64455, 'Edwards Crossroads', 36.0152816772461, 0.62858524630113, -78.0944366455078, -1.36300504695423, 218, 33, 'PPL', 'P'),
(80845, 'Edwards Forest Heights', 34.9263916015625, 0.609580529288161, -82.3163909912109, -1.43669205115563, 218, 48, 'PPL', 'P'),
(64450, 'Edwards Fork', 36.1188888549805, 0.630393532681294, -77.3891677856445, -1.35069578323783, 218, 33, 'PPL', 'P'),
(148611, 'Edwards Hill', 43.6283302307129, 0.761458009673317, -74.0461120605469, -1.29234845375723, 218, 40, 'PPL', 'P'),
(8696, 'Edwards Junction', 35.848331451416, 0.625671415173447, -93.3611068725586, -1.62945870823245, 218, 4, 'PPL', 'P'),
(191418, 'Edwards Place', 30.4025001525879, 0.530623728500737, -103.416938781738, -1.80496608407475, 218, 51, 'PPL', 'P'),
(86747, 'Edwards Point', 35.1483306884766, 0.613454097093681, -85.3702774047852, -1.48999242405442, 218, 50, 'PPL', 'P'),
(130633, 'Edwardsburg', 41.7955589294434, 0.729470116030103, -86.0808334350586, -1.50239396630259, 218, 27, 'PPL', 'P'),
(194877, 'Edwardsburg', 45.1188888549805, 0.787473165360783, -115.324996948242, -2.01280090659924, 218, 17, 'PPL', 'P'),
(29703, 'Edwardsport', 38.811939239502, 0.677396128813293, -87.2522201538086, -1.52283852135891, 218, 19, 'PPL', 'P'),
(2240, 'Edwardsville', 34.0394401550293, 0.59410030624083, -85.9269409179688, -1.49970803518519, 218, 2, 'PPL', 'P'),
(13720, 'Edwardsville', 38.9963912963867, 0.680615424518008, -75.7141723632813, -1.32146159816175, 218, 10, 'PPL', 'P'),
(27053, 'Edwardsville', 38.8113899230957, 0.677386541433369, -89.9530563354492, -1.56997700528553, 218, 18, 'PPL', 'P'),
(29704, 'Edwardsville', 38.2841682434082, 0.668184787234927, -85.9094390869141, -1.49940257060816, 218, 19, 'PPL', 'P'),
(32312, 'Edwardsville', 39.0611114501953, 0.681745004294365, -94.8194427490234, -1.65491147087672, 218, 20, 'PPL', 'P'),
(72422, 'Edwardsville', 39.3369407653809, 0.686559134017874, -84.0274963378906, -1.46655647330367, 218, 41, 'PPL', 'P'),
(101666, 'Edwardsville', 37.9063911437988, 0.661591333008109, -76.3655624389648, -1.33283049969725, 218, 53, 'PPL', 'P'),
(148613, 'Edwardsville', 44.5222206115723, 0.777059339971219, -75.5933303833008, -1.31935250773647, 218, 40, 'PPL', 'P'),
(161237, 'Edwardsville', 41.2694396972656, 0.720287603170537, -75.9166717529297, -1.3249958792444, 218, 45, 'PPL', 'P'),
(20822, 'Edwardsville (historical)', 33.8327789306641, 0.590493387439454, -84.3616714477539, -1.472388929249, 218, 13, 'PPL', 'P'),
(109041, 'Edwight', 37.8844413757324, 0.661208237285301, -81.5325012207031, -1.42301059368757, 218, 58, 'PPL', 'P'),
(2241, 'Edwin', 31.6652793884277, 0.55266338389196, -85.3752822875977, -1.49007977573818, 218, 2, 'PPL', 'P'),
(181324, 'Edwin', 38.3786087036133, 0.669833084212604, -120.986671447754, -2.11161576779192, 218, 6, 'PPL', 'P'),
(46827, 'Edwin (historical)', 38.1474990844727, 0.66579946042557, -75.7561111450195, -1.32219356798736, 218, 25, 'PPL', 'P'),
(72423, 'Edwina', 39.7155609130859, 0.693167302209715, -81.1555633544922, -1.41643178684674, 218, 41, 'PPL', 'P'),
(86748, 'Edwina', 35.9113883972168, 0.626771966493922, -83.1725006103516, -1.45163398276763, 218, 50, 'PPL', 'P'),
(211804, 'Eek', 60.2188911437988, 1.05101792235934, -162.024444580078, -2.82786002663744, 218, 1, 'PPL', 'P'),
(29705, 'Eel River', 39.3233299255371, 0.686321580048639, -87.1236114501953, -1.52059387603414, 218, 19, 'PPL', 'P'),
(20823, 'Eelbeck', 32.4416694641113, 0.566213946992447, -84.7527770996094, -1.47921501059703, 218, 13, 'PPL', 'P'),
(8697, 'Effa (historical)', 35.2680587768555, 0.615543746443012, -93.9555587768555, -1.63983385120718, 218, 4, 'PPL', 'P'),
(40775, 'Effie', 31.2158298492432, 0.544819009611618, -92.1555633544922, -1.60841800456612, 218, 22, 'PPL', 'P'),
(59779, 'Effie', 33.9347190856934, 0.592272578784709, -90.1772232055664, -1.57388945524297, 218, 30, 'PPL', 'P'),
(109042, 'Effie', 38.0944404602051, 0.664873412735522, -82.5083312988281, -1.44004204149084, 218, 58, 'PPL', 'P'),
(135154, 'Effie', 47.8402786254883, 0.834970377086238, -93.6427764892578, -1.63437477044669, 218, 28, 'PPL', 'P'),
(54571, 'Effie (historical)', 38.6261100769043, 0.67415279807974, -91.9527816772461, -1.60487879663546, 218, 29, 'PPL', 'P'),
(101667, 'Effinger', 37.7627792358398, 0.659084832369153, -79.5505599975586, -1.38841919376269, 218, 53, 'PPL', 'P'),
(27055, 'Effingham', 39.1199989318848, 0.682772784738054, -88.543327331543, -1.54537259260651, 218, 18, 'PPL', 'P'),
(32313, 'Effingham', 39.5222206115723, 0.689792877371503, -95.4005584716797, -1.66505385357218, 218, 20, 'PPL', 'P'),
(80846, 'Effingham', 34.0577812194824, 0.594420418203858, -79.7533264160156, -1.39195813537724, 218, 48, 'PPL', 'P'),
(139133, 'Effingham', 40.204719543457, 0.701704730874237, -94.2636108398438, -1.64521037397389, 218, 29, 'PPL', 'P'),
(143789, 'Effingham', 43.7611083984375, 0.763775425874877, -70.996940612793, -1.23913037253612, 218, 36, 'PPL', 'P'),
(143790, 'Effingham Falls', 43.7958297729492, 0.764381428180924, -71.0552825927734, -1.24014863217891, 218, 36, 'PPL', 'P'),
(109043, 'Effler', 37.3452796936035, 0.65179809073156, -81.4463882446289, -1.42150763872638, 218, 58, 'PPL', 'P'),
(101668, 'Effna', 37.0586090087891, 0.646794743412601, -81.2438888549805, -1.41797335764374, 218, 53, 'PPL', 'P'),
(119482, 'Effner', 40.7705612182617, 0.711580531144577, -87.5261077880859, -1.52761876235755, 218, 18, 'PPL', 'P'),
(122556, 'Effner', 40.7705612182617, 0.711580531144577, -87.5252838134766, -1.52760438128766, 218, 19, 'PPL', 'P'),
(161236, 'Effort', 40.9391708374023, 0.714523324149115, -75.4352798461914, -1.31659400547936, 218, 45, 'PPL', 'P'),
(64452, 'Efland', 36.0811080932617, 0.62973413399539, -79.1694412231445, -1.381767416308, 218, 33, 'PPL', 'P'),
(86749, 'Egam', 35.1872215270996, 0.614132870276515, -86.647216796875, -1.5122792207948, 218, 50, 'PPL', 'P'),
(928, 'Egan', 36.2219390869141, 0.632192098523479, -86.345832824707, -1.50701907816773, 218, 50, 'PPL', 'P'),
(40776, 'Egan', 30.2366695404053, 0.527729438317553, -92.5058288574219, -1.6145312908484, 218, 22, 'PPL', 'P'),
(93936, 'Egan', 32.4527816772461, 0.566407891698832, -97.2994384765625, -1.69819556175767, 218, 51, 'PPL', 'P'),
(115418, 'Egan', 43.1566696166992, 0.753225979006801, -91.289436340332, -1.59330123642856, 218, 16, 'PPL', 'P'),
(119483, 'Egan', 42.1883316040039, 0.736325292413049, -89.4058303833008, -1.56042611066818, 218, 18, 'PPL', 'P'),
(170214, 'Egan', 43.9991683959961, 0.767930356649564, -96.6486129760742, -1.68683651391821, 218, 49, 'PPL', 'P'),
(181325, 'Egan', 33.7322196960449, 0.588738297702065, -117.011108398438, -2.04222910296072, 218, 6, 'PPL', 'P'),
(190160, 'Egan (historical)', 39.8608283996582, 0.695702698146498, -114.935279846191, -2.00599906001712, 218, 39, 'PPL', 'P'),
(122557, 'Egans Point', 41.3358306884766, 0.72144634456083, -85.3605575561523, -1.48982278069298, 218, 19, 'PPL', 'P'),
(211805, 'Egavik', 64.040283203125, 1.11771379580415, -160.922500610352, -2.80862747619322, 218, 1, 'PPL', 'P'),
(54572, 'Egbert', 38.7597198486328, 0.676484728509241, -91.6333312988281, -1.59930333573532, 218, 29, 'PPL', 'P'),
(209428, 'Egbert', 41.1697196960449, 0.718547160819143, -104.256393432617, -1.81961733165376, 218, 59, 'PPL', 'P'),
(8700, 'Egbert (historical)', 35.0902786254883, 0.612440897456961, -91.6463928222656, -1.59953130232463, 218, 4, 'PPL', 'P'),
(122558, 'Ege', 41.292781829834, 0.720695000238292, -85.2877807617188, -1.48855258601107, 218, 19, 'PPL', 'P'),
(211806, 'Egegik', 58.2155609130859, 1.01605321382867, -157.375823974609, -2.74672629139596, 218, 1, 'PPL', 'P'),
(139946, 'Egeland', 48.6263885498047, 0.848690583548163, -99.0969390869141, -1.72956786571491, 218, 34, 'PPL', 'P'),
(109044, 'Egeria', 37.5391693115234, 0.655182102949697, -81.2002792358398, -1.41721222620419, 218, 58, 'PPL', 'P'),
(40777, 'Egg Bend', 31.1336097717285, 0.543383998547743, -92.1900024414063, -1.60901908002415, 218, 22, 'PPL', 'P'),
(29707, 'Egg Harbor', 38.2286109924316, 0.667215130282029, -87.7905578613281, -1.53223428684277, 218, 19, 'PPL', 'P'),
(173950, 'Egg Harbor', 45.0463905334473, 0.78620783094786, -87.2969436645508, -1.52361909387442, 218, 57, 'PPL', 'P'),
(70775, 'Egg Harbor City', 39.5286102294922, 0.68990439724215, -74.6483306884766, -1.30285915163144, 218, 37, 'PPL', 'P'),
(101669, 'Eggbornsville', 38.5805587768555, 0.673357777915324, -78.0591735839844, -1.36238959042631, 218, 53, 'PPL', 'P'),
(127416, 'Eggemoggin', 44.3061103820801, 0.77328750491934, -68.7341690063477, -1.19963755778301, 218, 26, 'PPL', 'P'),
(194168, 'Eggers', 40.6908302307129, 0.710188962895984, -105.486938476563, -1.84109439426471, 218, 7, 'PPL', 'P'),
(93937, 'Eggers Colonia', 26.2479991912842, 0.458114007948718, -97.7570037841797, -1.70618158291849, 218, 51, 'PPL', 'P'),
(148614, 'Eggertsville', 42.9633293151855, 0.749851554168588, -78.8041687011719, -1.37539220813251, 218, 40, 'PPL', 'P'),
(101670, 'Eggleston', 37.2872200012207, 0.650784757936785, -80.6188888549805, -1.40706504981877, 218, 53, 'PPL', 'P'),
(135158, 'Eggleston', 44.6199989318848, 0.778765893597742, -92.6719436645508, -1.61743054116911, 218, 28, 'PPL', 'P'),
(15901, 'Eggleston Heights', 30.3405609130859, 0.529542684835247, -81.5983276367188, -1.42415948138183, 218, 12, 'PPL', 'P'),
(109045, 'Eggleton', 38.2930603027344, 0.668339982947451, -82.0208282470703, -1.43153350812415, 218, 58, 'PPL', 'P'),
(192548, 'Eggnog', 37.7724990844727, 0.659254475730592, -110.844718933105, -1.93460530383039, 218, 52, 'PPL', 'P'),
(59780, 'Eggville', 34.3308296203613, 0.5991860118165, -88.5683288574219, -1.54580895155112, 218, 30, 'PPL', 'P'),
(194878, 'Egin', 43.9366683959961, 0.766839525867068, -111.836669921875, -1.95191811460283, 218, 17, 'PPL', 'P'),
(8698, 'Eglantine', 35.5794410705566, 0.620978392700509, -92.3061065673828, -1.61104547929759, 218, 4, 'PPL', 'P'),
(15897, 'Eglin Village', 30.4627799987793, 0.531675810289373, -86.539436340332, -1.51039809695883, 218, 12, 'PPL', 'P'),
(35719, 'Eglon', 37.4613914489746, 0.653824623163056, -84.129997253418, -1.46834545176593, 218, 21, 'PPL', 'P'),
(109046, 'Eglon', 39.3013916015625, 0.685938684062913, -79.5194396972656, -1.38787604205837, 218, 58, 'PPL', 'P'),
(207312, 'Eglon', 47.8627815246582, 0.835363126767997, -122.513328552246, -2.13826096081427, 218, 56, 'PPL', 'P'),
(186668, 'Egnar', 37.916389465332, 0.661765836638536, -108.939437866211, -1.90135187603717, 218, 7, 'PPL', 'P'),
(211807, 'Egorkovskoi', 53.5638885498047, 0.934866215365383, -168, -2.93215314335047, 218, 1, 'PPL', 'P'),
(115420, 'Egralharve', 43.4022216796875, 0.757511670991011, -95.1727828979492, -1.66107841985496, 218, 16, 'PPL', 'P'),
(59781, 'Egremont', 32.8605613708496, 0.573524989974987, -90.9033279418945, -1.58656237360622, 218, 30, 'PPL', 'P'),
(124777, 'Egremont Plain', 42.1847190856934, 0.736262242074241, -73.414436340332, -1.28132363263457, 218, 23, 'PPL', 'P'),
(2245, 'Egypt', 34.0736083984375, 0.594696654587926, -86.1558303833008, -1.50370290997837, 218, 2, 'PPL', 'P'),
(8699, 'Egypt', 35.8680610656738, 0.626015761902394, -90.945556640625, -1.5872994034379, 218, 4, 'PPL', 'P'),
(20825, 'Egypt', 32.461669921875, 0.566563020832329, -81.4741668701172, -1.42199246720283, 218, 13, 'PPL', 'P'),
(35720, 'Egypt', 37.313060760498, 0.65123576426739, -83.896110534668, -1.46426335844706, 218, 21, 'PPL', 'P'),
(59783, 'Egypt', 33.3411102294922, 0.581912149775001, -90.2772216796875, -1.57563475786335, 218, 30, 'PPL', 'P'),
(64453, 'Egypt', 35.3158302307129, 0.616377515601289, -76.9499969482422, -1.34303080614641, 218, 33, 'PPL', 'P'),
(86751, 'Egypt', 35.4911117553711, 0.61943675532449, -89.7838897705078, -1.56702449174302, 218, 50, 'PPL', 'P'),
(93939, 'Egypt', 29.4047203063965, 0.513209184974655, -96.2366714477539, -1.67964677792332, 218, 51, 'PPL', 'P'),
(109047, 'Egypt', 39.3519401550293, 0.686820922753029, -77.9477767944336, -1.3604453496725, 218, 58, 'PPL', 'P'),
(122559, 'Egypt', 40.8591690063477, 0.713127028789586, -87.2038879394531, -1.52199496508363, 218, 19, 'PPL', 'P'),
(124779, 'Egypt', 42.2125015258789, 0.736747137129717, -70.7588882446289, -1.23497557491949, 218, 23, 'PPL', 'P'),
(127417, 'Egypt', 44.5588912963867, 0.777699364160193, -68.2813873291016, -1.19173502672236, 218, 26, 'PPL', 'P'),
(148615, 'Egypt', 43.0641708374023, 0.751611570753995, -77.4077835083008, -1.35102068889082, 218, 40, 'PPL', 'P'),
(155149, 'Egypt', 40.0849990844727, 0.699615214682961, -81.128059387207, -1.41595175206026, 218, 41, 'PPL', 'P'),
(161240, 'Egypt', 40.6800003051758, 0.709999945037615, -75.5302810668945, -1.31825208957405, 218, 45, 'PPL', 'P'),
(171989, 'Egypt', 44.5741691589355, 0.777966013164337, -71.9877777099609, -1.2564237422326, 218, 55, 'PPL', 'P'),
(194879, 'Egypt', 42.0966682434082, 0.734725464967211, -111.836669921875, -1.95191811460283, 218, 17, 'PPL', 'P'),
(2243, 'Egypt (historical)', 33.0102806091309, 0.576138083636573, -87.3024978637695, -1.52371603293809, 218, 2, 'PPL', 'P'),
(109048, 'Egypt (historical)', 37.6477813720703, 0.657077741013615, -80.7202835083008, -1.40883472036313, 218, 58, 'PPL', 'P'),
(155150, 'Egypt (historical)', 40.5083312988281, 0.707003755653222, -81.3727798461914, -1.42022292981653, 218, 41, 'PPL', 'P'),
(124780, 'Egypt Beach', 42.2200012207031, 0.736878031497295, -70.7452774047852, -1.23473802095025, 218, 23, 'PPL', 'P'),
(101671, 'Egypt Bend Estates', 38.6791687011719, 0.675078845769788, -78.5083312988281, -1.37022887141107, 218, 53, 'PPL', 'P'),
(161241, 'Egypt Corners', 41.3547210693359, 0.721776043903782, -79.7294387817383, -1.39154121750859, 218, 45, 'PPL', 'P'),
(54573, 'Egypt Grove', 36.6141700744629, 0.639037820684555, -92.0308303833008, -1.60624100353303, 218, 29, 'PPL', 'P'),
(59784, 'Egypt Hill', 32.0099983215332, 0.558679864268613, -90.2622222900391, -1.5753729691282, 218, 30, 'PPL', 'P'),
(15898, 'Egypt Lake', 28.0166702270508, 0.488983140907503, -82.4955596923828, -1.4398191349076, 218, 12, 'PPL', 'P'),
(15899, 'Egypt Lake-Leto', 28.0166702270508, 0.488983140907503, -82.4955596923828, -1.4398191349076, 218, 12, 'PPL', 'P'),
(54574, 'Egypt Mills', 37.4049987792969, 0.65284038540319, -89.4636077880859, -1.56143451661494, 218, 29, 'PPL', 'P'),
(161242, 'Egypt Mills', 41.125560760498, 0.717776441999674, -74.9561080932617, -1.30823088070819, 218, 45, 'PPL', 'P'),
(27057, 'Egypt Shores', 37.6036109924316, 0.656306822457065, -88.9236068725586, -1.55200972267521, 218, 18, 'PPL', 'P'),
(27058, 'Egyptian Acres', 37.5999984741211, 0.656243772118257, -88.9175033569336, -1.5519031962316, 218, 18, 'PPL', 'P'),
(27059, 'Egyptian Hills', 37.5888900756836, 0.656049893990899, -88.8874969482422, -1.55137948560324, 218, 18, 'PPL', 'P'),
(101672, 'Ehart', 38.1772193908691, 0.666318177626891, -78.4994430541992, -1.37007374227757, 218, 53, 'PPL', 'P'),
(101673, 'Eheart', 38.2036094665527, 0.66677877133742, -78.3233337402344, -1.36700005490545, 218, 53, 'PPL', 'P'),
(115421, 'Ehler', 42.3102798461914, 0.73845369075624, -91.5124969482422, -1.59719437846809, 218, 16, 'PPL', 'P'),
(15900, 'Ehren', 28.2661094665527, 0.493336676920483, -82.4480590820313, -1.43899009286026, 218, 12, 'PPL', 'P'),
(178136, 'Ehrenberg', 33.6041717529297, 0.586503439494298, -114.524436950684, -1.99882849878208, 218, 5, 'PPL', 'P'),
(161243, 'Ehrenfeld', 40.3713912963867, 0.70461370173293, -78.7777786254883, -1.37493161442198, 218, 45, 'PPL', 'P'),
(80847, 'Ehrhardt', 33.0966682434082, 0.577645832287721, -81.0144424438477, -1.41396876231258, 218, 48, 'PPL', 'P'),
(29708, 'Ehrmandale', 39.5349998474121, 0.690015917112797, -87.2388916015625, -1.52260589423769, 218, 19, 'PPL', 'P'),
(46828, 'Ehrmansville', 39.1986083984375, 0.684144778752636, -76.7024993896484, -1.33871115885831, 218, 25, 'PPL', 'P'),
(93940, 'Eichelberger Crossing', 31.6166706085205, 0.551815000637202, -97.3077774047852, -1.69834110351124, 218, 51, 'PPL', 'P'),
(161245, 'Eichelbergertown', 40.1430587768555, 0.700628547477736, -78.29638671875, -1.36652974065695, 218, 45, 'PPL', 'P'),
(27060, 'Eichorn', 37.4911117553711, 0.654343340364376, -88.4052810668945, -1.54296323076832, 218, 18, 'PPL', 'P'),
(46829, 'Eickelberry Woods', 38.9486083984375, 0.67978145562265, -76.6097183227539, -1.33709182375748, 218, 25, 'PPL', 'P'),
(161246, 'Eidenau', 40.7916717529297, 0.71194897948139, -80.0961074829102, -1.39794079360805, 218, 45, 'PPL', 'P'),
(86753, 'Eidson', 36.5111083984375, 0.637239055105288, -83.0286102294922, -1.44912262185968, 218, 50, 'PPL', 'P'),
(191419, 'Eidson Road', 28.6769409179688, 0.50050703841844, -100.486671447754, -1.75382327113308, 218, 51, 'PPL', 'P'),
(173953, 'Eidsvold', 44.964168548584, 0.78477278659447, -90.8663864135742, -1.58591762230631, 218, 57, 'PPL', 'P'),
(135161, 'Eidswold', 44.561939239502, 0.777752560802967, -93.2836074829102, -1.6281060887148, 218, 28, 'PPL', 'P'),
(194881, 'Eiffie', 44.0255584716797, 0.768390950360093, -116.917221069336, -2.040590459942, 218, 17, 'PPL', 'P'),
(115422, 'Eifield (historical)', 41.4116706848145, 0.722770002201627, -93.0325012207031, -1.62372345766691, 218, 16, 'PPL', 'P'),
(72425, 'Eifort', 38.8333282470703, 0.677769437419095, -82.6530609130859, -1.44256804978478, 218, 41, 'PPL', 'P'),
(148616, 'Eighmyville', 41.9436111450195, 0.73205411465678, -73.857780456543, -1.2890614471818, 218, 40, 'PPL', 'P'),
(127418, 'Eight Corners', 43.6186103820801, 0.761288366311879, -70.3450012207031, -1.2277518836207, 218, 26, 'PPL', 'P'),
(173954, 'Eight Corners', 44.4677810668945, 0.776109190673306, -89.9252777099609, -1.56949217680908, 218, 57, 'PPL', 'P'),
(2244, 'Eight Mile', 30.7633304595947, 0.536921405398988, -88.1269378662109, -1.53810522546585, 218, 2, 'PPL', 'P'),
(196416, 'Eight Mile (historical)', 46.6411094665527, 0.814040926974441, -113.951393127441, -1.98882699730829, 218, 31, 'PPL', 'P'),
(155151, 'Eight Square (historical)', 40.8580589294434, 0.713107654292656, -82.0708312988281, -1.43240622601337, 218, 41, 'PPL', 'P'),
(178137, 'Eighteen Bells Mobile Home Park', 33.642219543457, 0.587167498712109, -112.042778015137, -1.95551537944525, 218, 5, 'PPL', 'P'),
(194880, 'Eighteenmile', 44.3002815246582, 0.773185772165699, -111.901672363281, -1.9530526212272, 218, 17, 'PPL', 'P'),
(72426, 'Eightmile', 39.0344390869141, 0.681279483735819, -84.3327789306641, -1.47188465969659, 218, 41, 'PPL', 'P'),
(200753, 'Eightmile', 45.2555618286133, 0.789858558749168, -119.815002441406, -2.09116628588758, 218, 43, 'PPL', 'P'),
(8702, 'Eightmile (historical)', 35.4491691589355, 0.618704718919854, -91.1130599975586, -1.59022288852453, 218, 4, 'PPL', 'P'),
(130635, 'Eightmile Corner', 46.4188919067383, 0.810162498899932, -85.5938873291016, -1.49389515347388, 218, 27, 'PPL', 'P'),
(192549, 'Eightmile Point', 38.7574996948242, 0.67644597951538, -112.550559997559, -1.96437784692082, 218, 52, 'PPL', 'P'),
(196417, 'Eightmile Saddle', 46.6586112976074, 0.814346391551473, -113.824996948242, -1.98662096781932, 218, 31, 'PPL', 'P'),
(20828, 'Eightmile Still', 31.0680599212646, 0.542239937832958, -82.8802795410156, -1.44653376296402, 218, 13, 'PPL', 'P'),
(35721, 'Eighty Eight', 36.9183311462402, 0.644346432843464, -85.7863922119141, -1.49725499750512, 218, 21, 'PPL', 'P'),
(161247, 'Eighty Four', 40.1816711425781, 0.70130246039158, -80.1333312988281, -1.39859047175598, 218, 45, 'PPL', 'P'),
(188469, 'Eiland (historical)', 34.1133308410645, 0.595389941998701, -103.194999694824, -1.80109251626923, 218, 38, 'PPL', 'P'),
(119485, 'Eileen', 41.2941703796387, 0.720719235004212, -88.271110534668, -1.54062151322181, 218, 18, 'PPL', 'P'),
(193518, 'Eileen', 41.9630584716797, 0.73239353453771, -123.10417175293, -2.14857312002922, 218, 6, 'PPL', 'P'),
(194882, 'Eileen', 48.7763900756836, 0.851308604057765, -116.162498474121, -2.0274180657163, 218, 17, 'PPL', 'P'),
(72427, 'Eileen Gardens', 39.1002807617188, 0.682428637746189, -84.6177825927734, -1.47685891198064, 218, 41, 'PPL', 'P'),
(2248, 'Eiler', 31.9624996185303, 0.557850855510785, -88.4236068725586, -1.54328307641523, 218, 2, 'PPL', 'P'),
(145152, 'Eilers Corner', 40.2333297729492, 0.702204073578626, -74.5313873291016, -1.300818104972, 218, 37, 'PPL', 'P'),
(80848, 'Eison Crossroads', 34.4686088562012, 0.601590713122787, -81.6363906860352, -1.42482380691575, 218, 48, 'PPL', 'P'),
(135162, 'Eitzen', 43.5080604553223, 0.759358906102117, -91.4613876342773, -1.59630235266097, 218, 28, 'PPL', 'P'),
(196418, 'Ekalaka', 45.8888893127441, 0.800912208590623, -104.552223205566, -1.82478053521715, 218, 31, 'PPL', 'P'),
(15902, 'Ekanachatte (historical)', 29.9916706085205, 0.523453400292294, -85.0111083984375, -1.48372374232254, 218, 12, 'PPL', 'P'),
(161248, 'Ekastown', 40.711109161377, 0.710542897004855, -79.7766723632813, -1.39236559902402, 218, 45, 'PPL', 'P'),
(155152, 'Ekerts Corners', 41.2052803039551, 0.719167810511186, -80.7405624389648, -1.409188654472, 218, 41, 'PPL', 'P'),
(122560, 'Ekin', 40.2169418334961, 0.701918050077552, -86.1616668701172, -1.50380477589006, 218, 19, 'PPL', 'P'),
(46830, 'Eklo', 39.6802787780762, 0.692551512786661, -76.7294387817383, -1.33918133994876, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(211808, 'Eklutna', 61.4580612182617, 1.0726455201509, -149.362213134766, -2.60686239726718, 218, 1, 'PPL', 'P'),
(80851, 'Ekom', 34.4313888549805, 0.60094110155389, -82.1408309936523, -1.43362795116344, 218, 48, 'PPL', 'P'),
(113368, 'Ekonk', 41.6455612182617, 0.726852162099528, -71.8480606079102, -1.25398521878047, 218, 8, 'PPL', 'P'),
(198244, 'Ekre', 46.7891693115234, 0.816625058759172, -103.969436645508, -1.81460899090776, 218, 34, 'PPL', 'P'),
(35722, 'Ekron', 37.9291687011719, 0.66198887637983, -86.179443359375, -1.50411503415706, 218, 21, 'PPL', 'P'),
(211809, 'Ekwok', 59.3497200012207, 1.03584802415803, -157.475280761719, -2.74846213979448, 218, 1, 'PPL', 'P'),
(188470, 'El Alto', 35.978889465332, 0.627950082381146, -105.307502746582, -1.83796264998083, 218, 38, 'PPL', 'P'),
(188471, 'El Ancon', 35.3894386291504, 0.617662224511143, -105.45832824707, -1.84059505156032, 218, 38, 'PPL', 'P'),
(93941, 'El Bernardo', 29.0400009155273, 0.50684363075812, -95.6524963378906, -1.66945099884801, 218, 51, 'PPL', 'P'),
(80849, 'El Bethel', 33.8638916015625, 0.591036405985721, -79.091667175293, -1.38041000310039, 218, 48, 'PPL', 'P'),
(181329, 'El Bonita', 38.5122184753418, 0.672165014642105, -122.982780456543, -2.14645444222401, 218, 6, 'PPL', 'P'),
(93942, 'El Bosque Number 1 Colonia', 26.4050006866455, 0.460854200973328, -98.9940032958984, -1.72777129724355, 218, 51, 'PPL', 'P'),
(93943, 'El Bosque Number 2 Colonia', 26.4060001373291, 0.460871644678468, -98.9940032958984, -1.72777129724355, 218, 51, 'PPL', 'P'),
(93944, 'El Bosque Number 3 Colonia', 26.4080009460449, 0.460906565378261, -98.9929962158203, -1.72775372038035, 218, 51, 'PPL', 'P'),
(93945, 'El Bosque Number 4 Colonia', 26.4090003967285, 0.460924009083401, -98.9929962158203, -1.72775372038035, 218, 51, 'PPL', 'P'),
(181330, 'El Cajon', 32.7947196960449, 0.572375835964618, -116.961669921875, -2.04136623876754, 218, 6, 'PPL', 'P'),
(93946, 'El Calaboz', 26.0308303833008, 0.454323697216776, -97.6477813720703, -1.70427529221021, 218, 51, 'PPL', 'P'),
(93947, 'El Calabozo Colonia', 26.0310001373291, 0.454326659983489, -97.6490020751953, -1.70429659749893, 218, 51, 'PPL', 'P'),
(193519, 'El Camino', 40.0411109924316, 0.698849222974426, -122.169441223145, -2.13225899466556, 218, 6, 'PPL', 'P'),
(181332, 'El Camino 76 Trailer Park', 33.2291717529297, 0.579958454799319, -117.332778930664, -2.04784331285472, 218, 6, 'PPL', 'P'),
(93948, 'El Camino Al Lago Colonia', 27.9890003204346, 0.488500209933331, -97.9329986572266, -1.70925327291979, 218, 51, 'PPL', 'P'),
(93949, 'El Camino Angosto', 26.1119403839111, 0.455739333783721, -97.6444396972656, -1.70421696898234, 218, 51, 'PPL', 'P'),
(93950, 'El Camino Angosto Colonia', 26.1119995117188, 0.455740365758644, -97.6429977416992, -1.70419180211004, 218, 51, 'PPL', 'P'),
(203849, 'El Camino Estates', 40.6783294677734, 0.709970783423679, -111.940277099609, -1.95372640098299, 218, 52, 'PPL', 'P'),
(178138, 'El Camino Mobile Home Park', 33.646671295166, 0.587245196436912, -112.027496337891, -1.95524866386208, 218, 5, 'PPL', 'P'),
(191420, 'El Campestre Colonia', 31.613000869751, 0.551750951612986, -106.286003112793, -1.85504070310318, 218, 51, 'PPL', 'P'),
(93951, 'El Campo', 29.1963901519775, 0.509573137848856, -96.2694396972656, -1.68021869176742, 218, 51, 'PPL', 'P'),
(181333, 'El Campo', 37.8974990844727, 0.661436137295584, -122.464172363281, -2.1374030234691, 218, 6, 'PPL', 'P'),
(93952, 'El Campo Club Community', 28.6569404602051, 0.500157964578558, -96.3583297729492, -1.68177011626044, 218, 51, 'PPL', 'P'),
(93953, 'El Caney', 31.4402809143066, 0.548736419706584, -95.4983291625977, -1.66676027404065, 218, 51, 'PPL', 'P'),
(181334, 'El Capitan (historical)', 32.9347190856934, 0.574819286264766, -116.77278137207, -2.03806951165413, 218, 6, 'PPL', 'P'),
(93954, 'El Carro', 27.9099998474121, 0.487121391568456, -98.1613922119141, -1.71323949243942, 218, 51, 'PPL', 'P'),
(181336, 'El Casco', 33.9811096191406, 0.59308224633512, -117.117500305176, -2.04408599203078, 218, 6, 'PPL', 'P'),
(93955, 'El Castillo Colonia', 26.3349990844727, 0.45963244253374, -98.6389999389648, -1.72157531980942, 218, 51, 'PPL', 'P'),
(93956, 'El Cenizo', 27.3519401550293, 0.477381412513709, -99.4922180175781, -1.73646678451876, 218, 51, 'PPL', 'P'),
(93957, 'El Cenizo Colonia', 26.4109992980957, 0.460958896493681, -98.9160003662109, -1.7264098892943, 218, 51, 'PPL', 'P'),
(93958, 'El Cenizo Colonia Number 1', 27.3320007324219, 0.477033403938263, -99.5019989013672, -1.73663749314464, 218, 51, 'PPL', 'P'),
(93959, 'El Centro', 26.6799602508545, 0.465653150678623, -98.4331436157227, -1.7179824491828, 218, 51, 'PPL', 'P'),
(181337, 'El Centro', 32.7919387817383, 0.572327299853751, -115.562217712402, -2.01694118998793, 218, 6, 'PPL', 'P'),
(109049, 'El Centro (historical)', 37.3208312988281, 0.651371385745903, -81.1369400024414, -1.4161067480357, 218, 58, 'PPL', 'P'),
(181339, 'El Cerrito', 33.8405609130859, 0.590629208655048, -117.521942138672, -2.05114483365809, 218, 6, 'PPL', 'P'),
(188472, 'El Cerrito', 35.2755584716797, 0.615674640810589, -105.311393737793, -1.83803056058863, 218, 38, 'PPL', 'P'),
(188473, 'El Cerro', 34.7269401550293, 0.606099444848291, -106.71028137207, -1.8624457556722, 218, 38, 'PPL', 'P'),
(93960, 'El Chaparral Number 1 Colonia', 26.3500003814697, 0.459894264558409, -98.7679977416992, -1.72382675619498, 218, 51, 'PPL', 'P'),
(93961, 'El Chaparral Number 2 Colonia', 26.3470001220703, 0.459841900153475, -98.7679977416992, -1.72382675619498, 218, 51, 'PPL', 'P'),
(93962, 'El Chapote Colonia', 26.5270004272461, 0.462983498133387, -97.7890014648438, -1.70674004779908, 218, 51, 'PPL', 'P'),
(188474, 'El Chapparal', 35.3327789306641, 0.616673326219369, -106.539436340332, -1.85946394735769, 218, 38, 'PPL', 'P'),
(93963, 'El Charro Colonia', 26.2399997711182, 0.45797439172857, -98.1539993286133, -1.71311046228461, 218, 51, 'PPL', 'P'),
(93964, 'El Charro Number 2 Colonia', 26.2399997711182, 0.45797439172857, -98.1029968261719, -1.71222030069025, 218, 51, 'PPL', 'P'),
(15903, 'El Chico', 24.5980606079102, 0.42931714721315, -81.6611099243164, -1.42525523901234, 218, 12, 'PPL', 'P'),
(188475, 'El Curuco', 36.2069396972656, 0.631930309788324, -106.32250213623, -1.85567773123593, 218, 38, 'PPL', 'P'),
(188476, 'El Dado', 35.5155601501465, 0.619863460310148, -107.516670227051, -1.876519896243, 218, 38, 'PPL', 'P'),
(27061, 'El Dara', 39.622501373291, 0.691543106839903, -90.9916687011719, -1.58810421071932, 218, 18, 'PPL', 'P'),
(15904, 'El Destinado', 30.5052795410156, 0.532417567231987, -84.2774963378906, -1.47091979643365, 218, 12, 'PPL', 'P'),
(46831, 'El Dondo Acres', 39.3344383239746, 0.686515458175997, -75.855827331543, -1.32393394375973, 218, 25, 'PPL', 'P'),
(8703, 'El Dorado', 33.2075004577637, 0.5795802193455, -92.6661071777344, -1.61732867525742, 218, 4, 'PPL', 'P'),
(20826, 'El Dorado', 31.1791706085205, 0.544179185159727, -81.3841705322266, -1.4204217347919, 218, 13, 'PPL', 'P'),
(29709, 'El Dorado', 39.5911102294922, 0.690995228024647, -86.1624984741211, -1.503819290118, 218, 19, 'PPL', 'P'),
(32314, 'El Dorado', 37.8172187805176, 0.660034981667067, -96.8619384765625, -1.6905597462802, 218, 20, 'PPL', 'P'),
(181346, 'El Dorado', 38.6827812194824, 0.675141896108596, -120.846672058105, -2.10917231749177, 218, 6, 'PPL', 'P'),
(188477, 'El Dorado', 35.5416717529297, 0.620319193751688, -105.91667175293, -1.8485946548427, 218, 38, 'PPL', 'P'),
(188478, 'El Dorado at Santa Fe', 35.5486106872559, 0.620440301002259, -105.908332824707, -1.84844911308912, 218, 38, 'PPL', 'P'),
(181348, 'El Dorado Hills', 38.6858291625977, 0.67519509275137, -121.081108093262, -2.11326399819057, 218, 6, 'PPL', 'P'),
(178139, 'El Dorado Mobile Home Resort', 33.464168548584, 0.584059922615123, -111.988891601563, -1.95457488410629, 218, 5, 'PPL', 'P'),
(54576, 'El Dorado Springs', 37.8769416809082, 0.661077342917724, -94.021110534668, -1.64097794521148, 218, 29, 'PPL', 'P'),
(188479, 'El Duende', 36.0741691589355, 0.629613026744819, -106.119438171387, -1.85213359645725, 218, 38, 'PPL', 'P'),
(181350, 'El Encano Heights', 34.436939239502, 0.601037974038541, -119.883613586426, -2.09236377627174, 218, 6, 'PPL', 'P'),
(93965, 'El Flaco Chiquito Colonia', 26.3250007629395, 0.459457938903313, -98.3880004882813, -1.7171945529743, 218, 51, 'PPL', 'P'),
(112586, 'El Gato', 26.1536102294922, 0.456466609787908, -98.0991668701172, -1.71215345534689, 218, 51, 'PPL', 'P'),
(188480, 'El Gato', 34.6222190856934, 0.60427171739217, -106.299171447754, -1.85527053390525, 218, 38, 'PPL', 'P'),
(191421, 'El Gran Valle Colonia', 31.6110000610352, 0.551716030913192, -106.292999267578, -1.85516280903916, 218, 51, 'PPL', 'P'),
(191422, 'El Gran Valle Number 2 Colonia', 31.6079998016357, 0.551663666508258, -106.296997070313, -1.85523258385972, 218, 51, 'PPL', 'P'),
(181353, 'El Granada', 37.5027809143066, 0.65454700560874, -122.468330383301, -2.13747559460881, 218, 6, 'PPL', 'P'),
(181354, 'El Granada Mobile Home Park', 37.5086097717285, 0.654648738362381, -122.498329162598, -2.13799917207912, 218, 6, 'PPL', 'P'),
(188481, 'El Guacho', 36.0066719055176, 0.628434977436622, -106.086387634277, -1.85155675576514, 218, 38, 'PPL', 'P'),
(191423, 'El Indio', 28.5116691589355, 0.497622502062748, -100.310829162598, -1.75075424429288, 218, 51, 'PPL', 'P'),
(93966, 'El Jardin Del Mar', 29.5983295440674, 0.516588303634288, -94.9877777099609, -1.6578494701913, 218, 51, 'PPL', 'P'),
(186669, 'El Jebel', 39.3950004577637, 0.687572466812649, -107.089721679688, -1.8690682383549, 218, 7, 'PPL', 'P'),
(15905, 'El Jobean', 26.9641704559326, 0.470613554525005, -82.2108306884766, -1.43484967631351, 218, 12, 'PPL', 'P'),
(203852, 'El Joy Plaza', 40.6683311462402, 0.709796279793252, -111.986938476563, -1.95454079564434, 218, 52, 'PPL', 'P'),
(93967, 'El Lago', 29.5633296966553, 0.515977441059251, -95.0449981689453, -1.65884815560008, 218, 51, 'PPL', 'P'),
(188482, 'El Llanito', 35.3300018310547, 0.61662485668753, -106.530830383301, -1.85931374507221, 218, 38, 'PPL', 'P'),
(188484, 'El Llano', 35.646110534668, 0.622141994359792, -105.269721984863, -1.83730325129492, 218, 38, 'PPL', 'P'),
(181355, 'El Macero', 38.5469398498535, 0.672771016948153, -121.693061828613, -2.12394460574233, 218, 6, 'PPL', 'P'),
(188485, 'El Macho', 35.6747207641602, 0.622641337064182, -105.689720153809, -1.84463360219537, 218, 38, 'PPL', 'P'),
(178140, 'El Mar Trailer Court', 33.413330078125, 0.583172623918935, -111.758331298828, -1.95055084769918, 218, 5, 'PPL', 'P'),
(93968, 'El Martillo', 27.3405609130859, 0.477182807275417, -97.4480590820313, -1.70078948065941, 218, 51, 'PPL', 'P'),
(181356, 'El Merrie Dell', 34.295280456543, 0.598565561861539, -118.377777099609, -2.06608197158013, 218, 6, 'PPL', 'P'),
(93970, 'El Mesquite Colonia', 26.3850002288818, 0.460505127133445, -98.7720031738281, -1.72389666417359, 218, 51, 'PPL', 'P'),
(181357, 'El Mirador', 36.1777801513672, 0.63142137970401, -119.017501831055, -2.07724727445028, 218, 6, 'PPL', 'P'),
(178142, 'El Mirage', 33.6130599975586, 0.586658568627795, -112.323890686035, -1.96042172112151, 218, 5, 'PPL', 'P'),
(181358, 'El Mirage', 34.6022186279297, 0.603922643552288, -117.630279541016, -2.05303567803205, 218, 6, 'PPL', 'P'),
(181359, 'El Modena', 33.7877807617188, 0.58970802123399, -117.808609008789, -2.05614811439802, 218, 6, 'PPL', 'P'),
(181360, 'El Monte', 34.0686111450195, 0.594609436062226, -118.026672363281, -2.05995403791185, 218, 6, 'PPL', 'P'),
(14, 'El Monte Colonia', 26.3299999237061, 0.459545190718526, -97.9860000610352, -1.71017832192443, 218, 51, 'PPL', 'P'),
(188486, 'El Monte Rojo', 36.334171295166, 0.634150920084259, -106.49388885498, -1.8586689937723, 218, 38, 'PPL', 'P'),
(186670, 'El Moro', 37.2244415283203, 0.649689066885299, -104.466110229492, -1.82327758025597, 218, 7, 'PPL', 'P'),
(181361, 'El Moro Beach Mobile Home Park', 33.5633316040039, 0.585790644428538, -117.820831298828, -2.05636143360134, 218, 6, 'PPL', 'P'),
(188488, 'El Morro', 35.0444412231445, 0.611640883865501, -108.319717407227, -1.89053571358592, 218, 38, 'PPL', 'P'),
(101674, 'El Nido', 38.9180603027344, 0.679248290772416, -77.1666717529297, -1.34681249489433, 218, 53, 'PPL', 'P'),
(181364, 'El Nido', 37.1349983215332, 0.648127988433322, -120.491111755371, -2.10296661951967, 218, 6, 'PPL', 'P'),
(93971, 'El Nogal Colonia', 26.257999420166, 0.458288544868659, -97.8150024414063, -1.70719385044883, 218, 51, 'PPL', 'P'),
(93972, 'El Nopal Colonia', 26.1849994659424, 0.457014455313651, -98.0910034179688, -1.71201097622857, 218, 51, 'PPL', 'P'),
(188489, 'El Ojito', 32.0052795410156, 0.558597506011902, -106.67749786377, -1.861873575512, 218, 38, 'PPL', 'P'),
(93973, 'El Oso', 28.7347202301025, 0.501515477654712, -98.0019378662109, -1.71045648910029, 218, 51, 'PPL', 'P'),
(46832, 'El Paco Farms', 39.6619415283203, 0.692231467402661, -75.8652801513672, -1.32409892658926, 218, 25, 'PPL', 'P'),
(188490, 'El Padro', 36.4316711425781, 0.635852613441793, -105.574172973633, -1.84261692345991, 218, 38, 'PPL', 'P'),
(93974, 'El Paraiso Colonia', 26.3050003051758, 0.459108865063431, -98.3259963989258, -1.71611237746534, 218, 51, 'PPL', 'P'),
(178143, 'El Paseo', 33.5616683959961, 0.585761615972656, -111.895561218262, -1.95294596162554, 218, 5, 'PPL', 'P'),
(8705, 'El Paso', 35.1261100769043, 0.613066274259939, -92.0952835083008, -1.60736592277748, 218, 4, 'PPL', 'P'),
(119486, 'El Paso', 40.7391700744629, 0.711032652329321, -89.0163879394531, -1.55362905777603, 218, 18, 'PPL', 'P'),
(173957, 'El Paso', 44.769718170166, 0.781378987259328, -92.3438873291016, -1.61170487798349, 218, 57, 'PPL', 'P'),
(191424, 'El Paso', 31.7586097717285, 0.554292306372707, -106.486389160156, -1.85853809940473, 218, 51, 'PPL', 'P'),
(54577, 'El Paso (historical)', 36.7102813720703, 0.640715279276168, -94.0252838134766, -1.6410507826673, 218, 29, 'PPL', 'P'),
(181369, 'El Pinal', 37.9805603027344, 0.662885829034969, -121.281112670898, -2.11675473658939, 218, 6, 'PPL', 'P'),
(15906, 'El Portal', 25.8549995422363, 0.451254870113651, -80.1933288574219, -1.39963762669659, 218, 12, 'PPL', 'P'),
(181371, 'El Portal', 37.6747207641602, 0.657547922104069, -119.783058166504, -2.09060875311338, 218, 6, 'PPL', 'P'),
(188491, 'El Porvenir', 35.6966705322266, 0.62302443278699, -105.382217407227, -1.83926666680859, 218, 38, 'PPL', 'P'),
(188492, 'El Prado', 36.4486083984375, 0.636148224322792, -105.574996948242, -1.84263130452979, 218, 38, 'PPL', 'P'),
(181374, 'El Prado (historical)', 36.9063911437988, 0.644138040488166, -119.730560302734, -2.08969249254033, 218, 6, 'PPL', 'P'),
(93975, 'El Quiote Colonia', 26.3850002288818, 0.460505127133445, -98.9089965820313, -1.72628765020026, 218, 51, 'PPL', 'P'),
(40778, 'El Ranchito', 30.5858306884766, 0.53382344997144, -91.0088882446289, -1.58840474844834, 218, 22, 'PPL', 'P'),
(93976, 'El Ranchito Colonia', 27.9759998321533, 0.488273308608456, -98.0309982299805, -1.71096368812989, 218, 51, 'PPL', 'P'),
(86754, 'El Rancho', 36.3788909912109, 0.634931426020734, -82.3994369506836, -1.43814147657891, 218, 50, 'PPL', 'P'),
(186672, 'El Rancho', 39.6986083984375, 0.692871425012607, -105.333061218262, -1.83840872946342, 218, 7, 'PPL', 'P'),
(188494, 'El Rancho', 35.8891716003418, 0.626384210239207, -106.079170227051, -1.85143078824558, 218, 38, 'PPL', 'P'),
(170219, 'El Rancho Acres', 43.5013885498047, 0.759242459383453, -96.8727798461914, -1.69074896387565, 218, 49, 'PPL', 'P'),
(46833, 'El Rancho Mobile Home Park', 39.5844383239746, 0.690878781305983, -77.6750030517578, -1.35568454974982, 218, 25, 'PPL', 'P'),
(181376, 'El Rancho Mobile Home Park', 33.2572212219238, 0.580448010386703, -116.369171142578, -2.03102518425476, 218, 6, 'PPL', 'P'),
(93977, 'El Rancho Vela Colonia', 26.4060001373291, 0.460871644678468, -98.7669982910156, -1.72380931248984, 218, 51, 'PPL', 'P'),
(93978, 'El Refugio', 26.3400001525879, 0.459719727638467, -98.7555618286133, -1.72360970856613, 218, 51, 'PPL', 'P'),
(188495, 'El Refugio', 35.1175003051758, 0.612916005395431, -106.337501525879, -1.85593951997108, 218, 38, 'PPL', 'P'),
(93979, 'El Refugio Colonia', 26.3379993438721, 0.459684806938674, -98.7570037841797, -1.72363487543844, 218, 51, 'PPL', 'P'),
(75748, 'El Reno', 35.5322189331055, 0.620154210922157, -97.954719543457, -1.70963237390096, 218, 42, 'PPL', 'P'),
(178144, 'El Rio', 32.235279083252, 0.562611755302006, -110.988891601563, -1.93712159158635, 218, 5, 'PPL', 'P'),
(181379, 'El Rio', 34.2322196960449, 0.597464943962036, -119.171669006348, -2.07993799925765, 218, 6, 'PPL', 'P'),
(93980, 'El Rio Colonia', 26.2430000305176, 0.458026756133504, -98.4530029296875, -1.71832905959867, 218, 51, 'PPL', 'P'),
(181380, 'El Rio Villa', 38.5347213745117, 0.672557764323864, -121.943061828613, -2.12830792887232, 218, 6, 'PPL', 'P'),
(181381, 'El Rita', 35.2174987792969, 0.614661308015814, -118.555557250977, -2.06918482056618, 218, 6, 'PPL', 'P'),
(188499, 'El Rito', 36.7999992370605, 0.642281151418108, -105.567222595215, -1.84249561647225, 218, 38, 'PPL', 'P'),
(181382, 'El Roble', 39.0897216796875, 0.682244346998755, -123.179718017578, -2.14989165108492, 218, 6, 'PPL', 'P'),
(178145, 'El San Juan Trailer Park', 33.5833282470703, 0.586139651689393, -112.254173278809, -1.95920492281945, 218, 5, 'PPL', 'P'),
(93981, 'El Sauz', 26.5736103057861, 0.463796993977865, -98.8713912963867, -1.72563131414961, 218, 51, 'PPL', 'P'),
(93982, 'El Seco Colonia', 26.3339996337891, 0.4596149988286, -98.1269989013672, -1.71263921592972, 218, 51, 'PPL', 'P'),
(181383, 'El Segundo', 33.9191703796387, 0.59200120266963, -118.415557861328, -2.06674137026603, 218, 6, 'PPL', 'P'),
(181384, 'El Sereno', 34.0811080932617, 0.594827548955504, -118.176940917969, -2.06257671895336, 218, 6, 'PPL', 'P'),
(181385, 'El Sereno Estates Mobile Home Park', 34.4341697692871, 0.600989637664756, -119.294166564941, -2.08207598498076, 218, 6, 'PPL', 'P'),
(178146, 'El Sereno-La Rosa Trailer Inn', 33.4663887023926, 0.584098671608983, -112.030830383301, -1.9553068539319, 218, 5, 'PPL', 'P'),
(203856, 'El Sid Condominium', 40.6494407653809, 0.7094665804503, -111.879173278809, -1.95265993812447, 218, 52, 'PPL', 'P'),
(181386, 'El Sobrante', 37.9772186279297, 0.662827505807096, -122.294166564941, -2.13443586254059, 218, 6, 'PPL', 'P'),
(93983, 'El Socio Colonia', 26.3409996032715, 0.459737171343608, -98.6370010375977, -1.72154043239914, 218, 51, 'PPL', 'P'),
(93984, 'El Sol Colonia', 26.1310005187988, 0.456071995893386, -98.1969985961914, -1.71386094107979, 218, 51, 'PPL', 'P'),
(93985, 'El Sol Colonia Number 2', 26.2730007171631, 0.458550366893327, -98.3300018310547, -1.71618228544396, 218, 51, 'PPL', 'P'),
(181389, 'El Sueno', 34.4436111450195, 0.601154420757205, -119.770278930664, -2.09038571337208, 218, 6, 'PPL', 'P'),
(188500, 'El Tablazon', 35.103889465332, 0.612678451426196, -106.33943939209, -1.85597334211693, 218, 38, 'PPL', 'P'),
(93986, 'El Tesoro', 32.3925018310547, 0.565355809910196, -97.6483306884766, -1.70428487959014, 218, 51, 'PPL', 'P'),
(93987, 'El Toro', 28.9477806091309, 0.505234082774303, -96.7050018310547, -1.68782068509905, 218, 51, 'PPL', 'P'),
(181393, 'El Toro', 33.6469383239746, 0.587249856968819, -117.682777404785, -2.05395193860509, 218, 6, 'PPL', 'P'),
(181394, 'El Toro Mobile Home Estates', 33.6202812194824, 0.586784602726383, -117.692222595215, -2.05411678827656, 218, 6, 'PPL', 'P'),
(178147, 'El Tule', 34.3797187805176, 0.600039288629762, -109.396667480469, -1.90933203824359, 218, 5, 'PPL', 'P'),
(188501, 'El Turquillo', 36.079719543457, 0.629709899229471, -105.250556945801, -1.83696875826201, 218, 38, 'PPL', 'P'),
(188502, 'El Vado', 36.5938911437988, 0.638683886575683, -106.728057861328, -1.86275601393919, 218, 38, 'PPL', 'P'),
(194169, 'El Vado', 40.0058288574219, 0.698233433551373, -105.345832824707, -1.83863163604666, 218, 7, 'PPL', 'P'),
(188503, 'El Valle', 36.110279083252, 0.630243263816786, -105.726112365723, -1.84526876611535, 218, 38, 'PPL', 'P'),
(188505, 'El Valle de Arroyo Seco', 35.9627799987793, 0.627668919149061, -106.02889251709, -1.8505532766664, 218, 38, 'PPL', 'P'),
(93988, 'El Venadito Colonia', 26.0550003051758, 0.454745541933445, -97.7710037231445, -1.70642592794851, 218, 51, 'PPL', 'P'),
(181396, 'El Verano', 38.297779083252, 0.668422341204162, -122.490562438965, -2.13786361717963, 218, 6, 'PPL', 'P'),
(119488, 'El Vista', 40.728889465332, 0.710853221850877, -89.6291732788086, -1.56432417955573, 218, 18, 'PPL', 'P'),
(161249, 'El-Do Lake', 40.9597206115723, 0.714881985368921, -75.5344390869141, -1.31832466071375, 218, 45, 'PPL', 'P'),
(64457, 'Ela', 35.4494400024414, 0.618709446030789, -83.3908309936523, -1.45544456681337, 218, 33, 'PPL', 'P'),
(8707, 'Elaine', 34.3083305358887, 0.598793328713768, -90.851936340332, -1.58566542095108, 218, 4, 'PPL', 'P'),
(199936, 'Elaine (historical)', 40.7402801513672, 0.711052026826251, -114.774169921875, -2.00318716138016, 218, 39, 'PPL', 'P'),
(86756, 'Elajay (historical)', 35.7750015258789, 0.624391566532582, -83.8480606079102, -1.46342472901979, 218, 50, 'PPL', 'P'),
(40779, 'Elam', 31.954719543457, 0.557715067584704, -91.6566696166992, -1.59971066622405, 218, 22, 'PPL', 'P'),
(78197, 'Elam', 39.8549995422363, 0.695600965392857, -75.541389465332, -1.3184459677014, 218, 45, 'PPL', 'P'),
(101675, 'Elam', 37.2861099243164, 0.650765383439855, -78.6138916015625, -1.37207124625318, 218, 53, 'PPL', 'P'),
(64458, 'Elams', 36.5411109924316, 0.637762699154625, -77.9430618286133, -1.36036305799481, 218, 33, 'PPL', 'P'),
(101676, 'Elamsville', 36.7675018310547, 0.641713964684948, -80.1941680908203, -1.39965227408259, 218, 53, 'PPL', 'P'),
(35723, 'Elamton', 37.9275016784668, 0.661959781344921, -83.1474990844727, -1.45119762382302, 218, 21, 'PPL', 'P'),
(101677, 'Elamtown', 36.6261100769043, 0.639246213039854, -78.2727813720703, -1.36611774963631, 218, 53, 'PPL', 'P'),
(2249, 'Elamville', 31.6674995422363, 0.552702132885821, -85.6563873291016, -1.49498598425637, 218, 2, 'PPL', 'P'),
(109050, 'Elana', 38.6183280944824, 0.674016976864146, -81.1086120605469, -1.41561233217933, 218, 58, 'PPL', 'P'),
(173961, 'Eland', 44.8705596923828, 0.783139003844734, -89.2149963378906, -1.55709542825087, 218, 57, 'PPL', 'P'),
(198245, 'Eland', 46.8622207641602, 0.817900047131048, -102.881393432617, -1.79561905443884, 218, 34, 'PPL', 'P'),
(207313, 'Elanor', 47.6041717529297, 0.830849534773504, -117.888893127441, -2.05754933660557, 218, 56, 'PPL', 'P'),
(54578, 'Elaver', 37.9686088562012, 0.662677236942589, -91.2783279418945, -1.5931073583012, 218, 29, 'PPL', 'P'),
(181398, 'Elayon', 34.3644409179688, 0.599772639625617, -118.522499084473, -2.06860784671601, 218, 6, 'PPL', 'P'),
(316, 'Elba', 35.7688903808594, 0.624284906930925, -92.4458312988281, -1.61348413590778, 218, 4, 'PPL', 'P'),
(27062, 'Elba', 37.8263893127441, 0.66019503764858, -88.3263931274414, -1.54158637648474, 218, 18, 'PPL', 'P'),
(35724, 'Elba', 37.6533317565918, 0.657174613498267, -87.3627777099609, -1.52476811472673, 218, 21, 'PPL', 'P'),
(40780, 'Elba', 30.7552795410156, 0.536780890361973, -91.7638931274414, -1.60158206952205, 218, 22, 'PPL', 'P'),
(72428, 'Elba', 39.6080589294434, 0.691291038642727, -81.413330078125, -1.42093066487621, 218, 41, 'PPL', 'P'),
(75750, 'Elba', 36.4027786254883, 0.635348343889386, -95.6791687011719, -1.66991651940656, 218, 42, 'PPL', 'P'),
(86757, 'Elba', 35.1108283996582, 0.612799558676767, -89.5744400024414, -1.56336890367272, 218, 50, 'PPL', 'P'),
(112199, 'Elba', 31.4144401550293, 0.548285413375979, -86.0677795410156, -1.50216613287134, 218, 2, 'PPL', 'P'),
(130636, 'Elba', 43.0363883972168, 0.751126675698518, -83.4400024414063, -1.45630277047465, 218, 27, 'PPL', 'P'),
(135164, 'Elba', 44.0886116027832, 0.769491435101541, -92.0186080932617, -1.60602768432972, 218, 28, 'PPL', 'P'),
(141724, 'Elba', 41.2855606079102, 0.720568966139704, -98.567497253418, -1.72032736252261, 218, 35, 'PPL', 'P'),
(148617, 'Elba', 43.077220916748, 0.751839337606224, -78.1872177124023, -1.36462438205505, 218, 40, 'PPL', 'P'),
(177697, 'Elba', 39.9483299255371, 0.697229887873604, -103.217781066895, -1.80149012621998, 218, 7, 'PPL', 'P'),
(181397, 'Elba', 36.2311096191406, 0.632352154504993, -119.312217712402, -2.08239103693772, 218, 6, 'PPL', 'P'),
(192550, 'Elba', 38.9500007629395, 0.679805756967597, -109.50611114502, -1.91124219053545, 218, 52, 'PPL', 'P'),
(194883, 'Elba', 42.2483291625977, 0.737372447353668, -113.560562133789, -1.98200570965022, 218, 17, 'PPL', 'P'),
(119490, 'Elba Center', 40.8441696166992, 0.712865240054432, -90.0430603027344, -1.57154787085452, 218, 18, 'PPL', 'P'),
(64459, 'Elbaville', 35.9213905334473, 0.626946536703377, -80.4055633544922, -1.40334181745679, 218, 33, 'PPL', 'P'),
(207314, 'Elbe', 46.7649993896484, 0.816203214042504, -122.192497253418, -2.13266139830627, 218, 56, 'PPL', 'P'),
(46834, 'Elbeekay Farms', 39.4597206115723, 0.688702046589006, -77.0216674804688, -1.34428169291043, 218, 25, 'PPL', 'P'),
(161250, 'Elbell', 40.9111099243164, 0.714033568824649, -78.9097213745117, -1.37723444981657, 218, 45, 'PPL', 'P'),
(161251, 'Elben', 40.2472190856934, 0.702446487816851, -79.9341735839844, -1.3951145139012, 218, 45, 'PPL', 'P'),
(29710, 'Elberfeld', 38.1597213745117, 0.666012779628886, -87.4483337402344, -1.52626134914994, 218, 19, 'PPL', 'P'),
(64460, 'Elberon', 36.313060760498, 0.633782471747447, -78.2194366455078, -1.36518670851922, 218, 33, 'PPL', 'P'),
(101678, 'Elberon', 37.0741691589355, 0.647066319264762, -76.8838882446289, -1.34187699160414, 218, 53, 'PPL', 'P'),
(115423, 'Elberon', 42.0061111450195, 0.733144945439276, -92.3166732788086, -1.61122990320308, 218, 16, 'PPL', 'P'),
(141727, 'Elberon', 40.6450004577637, 0.709389082462578, -95.9380569458008, -1.67443497167004, 218, 35, 'PPL', 'P'),
(145153, 'Elberon', 40.2691688537598, 0.702829583539659, -73.9922180175781, -1.29140782526021, 218, 37, 'PPL', 'P'),
(145154, 'Elberon Park', 40.2613906860352, 0.702693828903092, -74.0063934326172, -1.29165523292548, 218, 37, 'PPL', 'P'),
(94000, 'Elbert', 33.2661094665527, 0.5806031395202, -98.9936065673828, -1.72776437302471, 218, 51, 'PPL', 'P'),
(109051, 'Elbert', 37.3352813720703, 0.651623587101133, -81.539436340332, -1.42313163435911, 218, 58, 'PPL', 'P'),
(186673, 'Elbert', 39.2194404602051, 0.684508366820459, -104.536666870117, -1.82450902594402, 218, 7, 'PPL', 'P'),
(2250, 'Elberta', 30.4141693115234, 0.530827393745101, -87.5977783203125, -1.52886964912156, 218, 2, 'PPL', 'P'),
(8710, 'Elberta', 35.8499984741211, 0.625700510208356, -92.5019378662109, -1.6144633802406, 218, 4, 'PPL', 'P'),
(20829, 'Elberta', 32.6591682434082, 0.570010016810246, -83.6188888549805, -1.4594249273786, 218, 13, 'PPL', 'P'),
(64461, 'Elberta', 35.2847213745117, 0.615834563634049, -79.6327819824219, -1.38985423811608, 218, 33, 'PPL', 'P'),
(93989, 'Elberta', 32.2924995422363, 0.563610440710786, -95.2463912963867, -1.66236312876482, 218, 51, 'PPL', 'P'),
(130639, 'Elberta', 44.6194381713867, 0.778756106480736, -86.2263870239258, -1.50493435566642, 218, 27, 'PPL', 'P'),
(148619, 'Elberta', 43.2638893127441, 0.755097315725772, -78.8705596923828, -1.37655094952281, 218, 40, 'PPL', 'P'),
(161252, 'Elberta', 40.5141716003418, 0.707105688143945, -78.3222198486328, -1.3669806138295, 218, 45, 'PPL', 'P'),
(192551, 'Elberta', 39.9527816772461, 0.697307585598407, -111.955558776855, -1.95399311656616, 218, 52, 'PPL', 'P'),
(8709, 'Elberta (historical)', 33.6977806091309, 0.588137222244034, -92.4522171020508, -1.6135955891994, 218, 4, 'PPL', 'P'),
(155153, 'Elberta Beach', 41.4283294677734, 0.723060752813637, -82.3402786254883, -1.43710896902428, 218, 41, 'PPL', 'P'),
(20830, 'Elberton', 34.1111106872559, 0.595351193004841, -82.8672180175781, -1.44630579637471, 218, 13, 'PPL', 'P'),
(207315, 'Elberton', 46.9813919067383, 0.8199799759424, -117.220283508301, -2.04587989734106, 218, 56, 'PPL', 'P'),
(86758, 'Elbethel', 35.5183296203613, 0.619911796683933, -86.5066680908203, -1.50982618311473, 218, 50, 'PPL', 'P'),
(64462, 'Elbethel (historical)', 35.2174987792969, 0.614661308015814, -81.413330078125, -1.42093066487621, 218, 33, 'PPL', 'P'),
(32317, 'Elbing', 38.0527801513672, 0.664146303178904, -97.1275024414063, -1.69519471184137, 218, 20, 'PPL', 'P'),
(78198, 'Elbinsville', 39.7547187805176, 0.693850735924457, -78.475830078125, -1.36966161809888, 218, 45, 'PPL', 'P'),
(161253, 'Elbon', 41.3038902282715, 0.72088887836565, -78.686393737793, -1.37333664724513, 218, 45, 'PPL', 'P'),
(202094, 'Elbon', 44.2808303833008, 0.772846285705741, -101.688056945801, -1.77479140365971, 218, 49, 'PPL', 'P'),
(27063, 'Elbow', 38.642219543457, 0.674433961311825, -88.1216735839844, -1.53801334640824, 218, 18, 'PPL', 'P'),
(177736, 'Elbow', 32.1602783203125, 0.561302745047205, -101.511672973633, -1.77171292259764, 218, 51, 'PPL', 'P'),
(130640, 'Elbow Lake', 44.2152786254883, 0.771702191701443, -84.0355606079102, -1.46669722136728, 218, 27, 'PPL', 'P'),
(135168, 'Elbow Lake', 45.9941711425781, 0.802749723163751, -95.9763870239258, -1.67510395773587, 218, 28, 'PPL', 'P'),
(135169, 'Elbow Lake Village', 47.146671295166, 0.822864645456146, -95.5516662597656, -1.66769118199969, 218, 28, 'PPL', 'P'),
(190162, 'Elbow Stage Station (historical)', 38.4249992370605, 0.670642751763016, -119.02082824707, -2.07730533136205, 218, 39, 'PPL', 'P'),
(27064, 'Elbridge', 39.5125007629395, 0.689623234010065, -87.5827789306641, -1.52860786038641, 218, 18, 'PPL', 'P'),
(86759, 'Elbridge', 36.2602806091309, 0.632861284326389, -89.3219375610352, -1.55896190470086, 218, 50, 'PPL', 'P'),
(130641, 'Elbridge', 43.6858291625977, 0.762461555351086, -86.2188873291016, -1.50480346129884, 218, 27, 'PPL', 'P'),
(148620, 'Elbridge', 43.0344390869141, 0.751092653815593, -76.4483337402344, -1.33427513143056, 218, 40, 'PPL', 'P'),
(161254, 'Elbridge', 41.9208297729492, 0.731656504706031, -77.2744369506836, -1.3486933524142, 218, 45, 'PPL', 'P'),
(78199, 'Elbrook', 39.8177795410156, 0.694951353823959, -77.6069412231445, -1.35449664674559, 218, 45, 'PPL', 'P'),
(119492, 'Elburn', 41.892219543457, 0.731157162001641, -88.4722213745117, -1.54413155953853, 218, 18, 'PPL', 'P'),
(199937, 'Elburz', 40.9291687011719, 0.71434875393966, -115.504173278809, -2.01592812350926, 218, 39, 'PPL', 'P'),
(8711, 'Elcana', 34.9352798461914, 0.609735658421658, -90.8622207641602, -1.58584491800855, 218, 4, 'PPL', 'P'),
(173962, 'Elcho', 45.4358291625977, 0.793004817260987, -89.1833267211914, -1.55654268916663, 218, 57, 'PPL', 'P'),
(27066, 'Elco', 37.3005599975586, 0.651017584795086, -89.2658309936523, -1.55798266036803, 218, 18, 'PPL', 'P'),
(161255, 'Elco', 40.0774993896484, 0.699484320315383, -79.8694381713867, -1.39398466780874, 218, 45, 'PPL', 'P'),
(35725, 'Elcomb', 36.8211097717285, 0.64264959975492, -83.3327789306641, -1.45443136717665, 218, 21, 'PPL', 'P'),
(135175, 'Elcor', 47.5052795410156, 0.829123540071023, -92.4408264160156, -1.61339678422402, 218, 28, 'PPL', 'P'),
(155154, 'Eldean', 40.0777816772461, 0.6994892471634, -84.2225036621094, -1.46995999317679, 218, 41, 'PPL', 'P'),
(72429, 'Elden (historical)', 39.0038909912109, 0.680746318885586, -81.8069381713867, -1.42780042206613, 218, 41, 'PPL', 'P'),
(178148, 'Elden Pueblo', 35.2425003051758, 0.615097666960424, -111.567222595215, -1.94721537159191, 218, 5, 'PPL', 'P'),
(119493, 'Eldena', 41.771110534668, 0.729043411044445, -89.4100036621094, -1.560498948124, 218, 18, 'PPL', 'P'),
(20831, 'Elder', 33.7680587768555, 0.589363807663097, -83.3472213745117, -1.45468343537382, 218, 13, 'PPL', 'P'),
(40781, 'Elder', 30.5677795410156, 0.533508398014484, -92.7969436645508, -1.6196122027341, 218, 22, 'PPL', 'P'),
(186675, 'Elder', 38.1233291625977, 0.665377615708902, -103.966667175293, -1.81456065453398, 218, 7, 'PPL', 'P'),
(2251, 'Elder (historical)', 33.4599990844727, 0.583987151738336, -85.772216796875, -1.49700758983985, 218, 2, 'PPL', 'P'),
(20833, 'Elder Heights', 33.8455581665039, 0.590716427180748, -83.4858322143555, -1.45710265090805, 218, 13, 'PPL', 'P'),
(46835, 'Elder Hill', 39.624439239502, 0.691576928985747, -79.3913879394531, -1.38564111727157, 218, 25, 'PPL', 'P'),
(86760, 'Elder Mountain', 35.0680618286133, 0.612053141202245, -85.3691711425781, -1.48997311613652, 218, 50, 'PPL', 'P'),
(20834, 'Elder Ridge', 33.8472213745117, 0.59074545563663, -83.4858322143555, -1.45710265090805, 218, 13, 'PPL', 'P'),
(15907, 'Elder Springs', 28.7408294677734, 0.501622103966856, -81.293327331543, -1.41883622183692, 218, 12, 'PPL', 'P'),
(161257, 'Elderberry Pond', 40.1597213745117, 0.700919364668772, -74.8247222900391, -1.30593776585157, 218, 45, 'PPL', 'P'),
(115424, 'Eldergrove', 43.2397193908691, 0.754675471009103, -91.2197189331055, -1.5920844381265, 218, 16, 'PPL', 'P'),
(173964, 'Elderon', 44.7838897705078, 0.781626328345569, -89.2447204589844, -1.55761421203122, 218, 57, 'PPL', 'P'),
(20835, 'Elders', 34.6974983215332, 0.605585587915961, -84.5738906860352, -1.47609285369308, 218, 13, 'PPL', 'P'),
(181399, 'Elders Corner', 38.9566688537598, 0.679922137107233, -121.099998474121, -2.11359369753352, 218, 6, 'PPL', 'P'),
(20836, 'Elders Mill', 33.2744407653809, 0.580748548115718, -84.6288909912109, -1.477052790108, 218, 13, 'PPL', 'P'),
(161259, 'Elders Ridge', 40.5736083984375, 0.708143055967558, -79.4052810668945, -1.38588359808883, 218, 45, 'PPL', 'P'),
(46836, 'Eldersburg', 39.4036102294922, 0.687722735677157, -76.9505615234375, -1.34304065984245, 218, 25, 'PPL', 'P'),
(161260, 'Eldersville', 40.3519401550293, 0.704274215272972, -80.4786071777344, -1.40461667267061, 218, 45, 'PPL', 'P'),
(161261, 'Elderton', 40.6949996948242, 0.71026173377277, -79.341667175293, -1.38477332623037, 218, 45, 'PPL', 'P'),
(93990, 'Elderville', 32.3722190856934, 0.565001809222297, -94.7283325195313, -1.65332129738984, 218, 51, 'PPL', 'P'),
(119494, 'Elderville', 40.3302803039551, 0.703896179556236, -91.2944412231445, -1.59338858811231, 218, 18, 'PPL', 'P'),
(181400, 'Elderwood', 36.4716682434082, 0.63655069454253, -119.121391296387, -2.07906048767846, 218, 6, 'PPL', 'P'),
(135172, 'Eldes Corner', 46.7099990844727, 0.815243277627585, -92.2797164916992, -1.61058488558706, 218, 28, 'PPL', 'P'),
(54579, 'Eldon', 38.348331451416, 0.669304646473305, -92.5813903808594, -1.6158500882202, 218, 29, 'PPL', 'P'),
(75752, 'Eldon', 35.9280586242676, 0.627062916843014, -94.8399963378906, -1.65527019867556, 218, 42, 'PPL', 'P'),
(93991, 'Eldon', 29.8150005340576, 0.520369925803173, -94.9175033569336, -1.65662295135126, 218, 51, 'PPL', 'P'),
(115425, 'Eldon', 40.9186096191406, 0.714164463192227, -92.2227783203125, -1.6095911270263, 218, 16, 'PPL', 'P'),
(209914, 'Eldon', 47.5455589294434, 0.829826548019777, -123.044723510742, -2.14753555246853, 218, 56, 'PPL', 'P'),
(101682, 'Eldon Knolls', 36.8344383239746, 0.642882226876139, -79.3783264160156, -1.38541315068226, 218, 53, 'PPL', 'P'),
(15908, 'Eldora', 28.9088897705078, 0.504555309591469, -80.8199996948242, -1.4105750961355, 218, 12, 'PPL', 'P'),
(70778, 'Eldora', 39.2152786254883, 0.684435729101727, -74.9063873291016, -1.30736308966698, 218, 37, 'PPL', 'P'),
(109053, 'Eldora', 39.4172210693359, 0.687960289646392, -80.2044372558594, -1.39983150482395, 218, 58, 'PPL', 'P'),
(115426, 'Eldora', 42.3608283996582, 0.739335929446356, -93.0994415283203, -1.62489178643713, 218, 16, 'PPL', 'P'),
(161263, 'Eldora', 40.1708297729492, 0.70111324279613, -79.8938903808594, -1.39441143937342, 218, 45, 'PPL', 'P'),
(186676, 'Eldora', 39.9486083984375, 0.697234748142593, -105.563331604004, -1.84242770586446, 218, 7, 'PPL', 'P'),
(93992, 'Eldora Colonia', 26.2250003814697, 0.457712602993416, -98.1640014648438, -1.71328503249406, 218, 51, 'PPL', 'P'),
(93993, 'Eldora Gardens Colonia', 26.2250003814697, 0.457712602993416, -98.1569976806641, -1.71316279340003, 218, 51, 'PPL', 'P'),
(93994, 'Eldora Rd-FM 1426 Colonia', 26.2250003814697, 0.457712602993416, -98.1470031738281, -1.71298835634863, 218, 51, 'PPL', 'P'),
(101679, 'Eldorada', 38.5558280944824, 0.67292614608165, -78.0586090087891, -1.36237973673028, 218, 53, 'PPL', 'P'),
(15909, 'Eldorado', 28.7958297729492, 0.502582040381775, -81.8249969482422, -1.42811560718114, 218, 12, 'PPL', 'P'),
(20837, 'Eldorado', 31.353609085083, 0.547223710917905, -83.4855575561523, -1.45709785721809, 218, 13, 'PPL', 'P'),
(27068, 'Eldorado', 37.8136100769043, 0.659971997907286, -88.4380569458008, -1.54353527777046, 218, 18, 'PPL', 'P'),
(46837, 'Eldorado', 38.584171295166, 0.673420828254132, -75.789436340332, -1.32277520236944, 218, 25, 'PPL', 'P'),
(59785, 'Eldorado', 32.5794410705566, 0.56861851514068, -90.6594390869141, -1.58230571007789, 218, 30, 'PPL', 'P'),
(64464, 'Eldorado', 35.4669418334961, 0.619014910607821, -80.0294418334961, -1.39677725852779, 218, 33, 'PPL', 'P'),
(72431, 'Eldorado', 39.9019393920898, 0.696420220323192, -84.6750030517578, -1.47785759738942, 218, 41, 'PPL', 'P'),
(75753, 'Eldorado', 34.4719390869141, 0.601648836613578, -99.6477813720703, -1.7391818772501, 218, 42, 'PPL', 'P'),
(115429, 'Eldorado', 43.0505599975586, 0.751374016784759, -91.8352813720703, -1.60282802943804, 218, 16, 'PPL', 'P'),
(130643, 'Eldorado', 44.5916709899902, 0.778271477741369, -84.4008331298828, -1.47307242954277, 218, 27, 'PPL', 'P'),
(139134, 'Eldorado', 40.454719543457, 0.706068054004222, -91.8880615234375, -1.6037492168591, 218, 29, 'PPL', 'P'),
(141728, 'Eldorado', 40.6841697692871, 0.710072715914402, -97.9952774047852, -1.71034024211871, 218, 35, 'PPL', 'P'),
(161265, 'Eldorado', 41.0913887023926, 0.717180027073551, -79.7472229003906, -1.39185160893364, 218, 45, 'PPL', 'P'),
(173967, 'Eldorado', 43.8247184753418, 0.764885631154304, -88.6216735839844, -1.54673999266821, 218, 57, 'PPL', 'P'),
(191426, 'Eldorado', 30.8600006103516, 0.538608617818094, -100.600563049316, -1.75581105457072, 218, 51, 'PPL', 'P'),
(200754, 'Eldorado', 44.4263916015625, 0.775386808227622, -117.744720458984, -2.05503304884961, 218, 43, 'PPL', 'P'),
(86761, 'Eldorado Acres', 35.9638900756836, 0.627688293645991, -86.7966690063477, -1.51488765392448, 218, 50, 'PPL', 'P'),
(188506, 'Eldorado at Santa Fe', 35.5263900756836, 0.620052478168516, -105.934173583984, -1.84890011941973, 218, 38, 'PPL', 'P'),
(190163, 'Eldorado Canyon (historical)', 35.7077789306641, 0.623218310914348, -114.710830688477, -2.00208168321167, 218, 39, 'PPL', 'P'),
(93995, 'Eldorado Center', 31.851110458374, 0.555906747915027, -96.6277770996094, -1.68647285927136, 218, 51, 'PPL', 'P'),
(207316, 'Eldorado Hills', 47.6166687011719, 0.831067647666781, -122.716667175293, -2.14180988928291, 218, 56, 'PPL', 'P'),
(186677, 'Eldorado Springs', 39.9324989318848, 0.696953584910508, -105.276390075684, -1.83741963143456, 218, 7, 'PPL', 'P'),
(8714, 'Eldorado Springs (historical)', 36.3680610656738, 0.634742408162366, -94.5347213745117, -1.64994214544069, 218, 4, 'PPL', 'P'),
(20838, 'Eldorendo', 31.0438899993896, 0.54181809311629, -84.6519393920898, -1.47745506059065, 218, 13, 'PPL', 'P'),
(15910, 'Eldred', 27.3333301544189, 0.477056606729261, -80.2716674804688, -1.40100489360024, 218, 12, 'PPL', 'P'),
(27069, 'Eldred', 39.2874984741211, 0.685696203245661, -90.5522232055664, -1.58043443993795, 218, 18, 'PPL', 'P'),
(32318, 'Eldred', 37.0505599975586, 0.6466542616651, -98.7675018310547, -1.72381810092143, 218, 20, 'PPL', 'P'),
(135174, 'Eldred', 47.6827812194824, 0.832221528788085, -96.7799987792969, -1.68912962877482, 218, 28, 'PPL', 'P'),
(148622, 'Eldred', 41.5269393920898, 0.7247818206681, -74.8844375610352, -1.30697999394418, 218, 40, 'PPL', 'P'),
(161266, 'Eldred', 41.9577789306641, 0.732301389163993, -78.3855590820313, -1.36808609199799, 218, 45, 'PPL', 'P'),
(161267, 'Eldred Center', 41.7452812194824, 0.728592604450922, -79.5563888549805, -1.38852092651633, 218, 45, 'PPL', 'P'),
(186678, 'Eldredge', 38.2877807617188, 0.668247837573735, -107.766670227051, -1.88088321937298, 218, 7, 'PPL', 'P'),
(161275, 'Eldredsville', 41.5444412231445, 0.725087285245132, -76.6324996948242, -1.33748943370823, 218, 45, 'PPL', 'P'),
(2252, 'Eldridge', 33.922779083252, 0.59206418642941, -87.6172180175781, -1.52920893584444, 218, 2, 'PPL', 'P'),
(15911, 'Eldridge', 29.211109161377, 0.509830033025507, -81.4574966430664, -1.42170151685374, 218, 12, 'PPL', 'P'),
(35726, 'Eldridge', 38.0361099243164, 0.663855352829812, -83.0572204589844, -1.44962196456407, 218, 21, 'PPL', 'P'),
(46838, 'Eldridge', 39.5888900756836, 0.690956479030786, -77.5513916015625, -1.35352712295074, 218, 25, 'PPL', 'P'),
(54580, 'Eldridge', 37.829719543457, 0.660253161139371, -92.748893737793, -1.61877357330684, 218, 29, 'PPL', 'P'),
(59786, 'Eldridge', 34.1113891601563, 0.59535605327383, -90.8411102294922, -1.58547646967174, 218, 30, 'PPL', 'P'),
(93996, 'Eldridge', 29.4677791595459, 0.514309769584643, -96.3550033569336, -1.68171205934868, 218, 51, 'PPL', 'P'),
(115431, 'Eldridge', 41.6580581665039, 0.727070274992805, -90.5844421386719, -1.58099676640212, 218, 16, 'PPL', 'P'),
(119496, 'Eldridge', 41.1594390869141, 0.718367730340699, -87.7200012207031, -1.53100284115471, 218, 18, 'PPL', 'P'),
(139952, 'Eldridge', 46.9025001525879, 0.818603055079801, -98.8513870239258, -1.7252821737307, 218, 34, 'PPL', 'P'),
(181402, 'Eldridge', 38.3488883972168, 0.669314367011284, -122.509719848633, -2.13819797705449, 218, 6, 'PPL', 'P'),
(196419, 'Eldridge (historical)', 45.101390838623, 0.787167767362779, -111.218063354492, -1.94112139322754, 218, 31, 'PPL', 'P'),
(8713, 'Eldridge Corner', 34.2972183227539, 0.598599384007383, -91.4736099243164, -1.59651567186428, 218, 4, 'PPL', 'P'),
(101680, 'Eldridge Corner', 37.5844383239746, 0.655972196266096, -78.8161087036133, -1.37560060048781, 218, 53, 'PPL', 'P'),
(70779, 'Eldridge Hill', 39.6644401550293, 0.692275076665511, -75.3038864135742, -1.31430075746469, 218, 37, 'PPL', 'P'),
(101681, 'Eldridge Mill', 37.6097183227539, 0.656413415479695, -78.4611129760742, -1.36940475621174, 218, 53, 'PPL', 'P'),
(145155, 'Eldridge Park', 40.2652816772461, 0.702761739510889, -74.7452774047852, -1.30455119103002, 218, 37, 'PPL', 'P'),
(196420, 'Eldridge Trailer Court', 45.6783294677734, 0.797237246023396, -111.052223205566, -1.93822693659679, 218, 31, 'PPL', 'P'),
(2253, 'Eleanor', 32.3400001525879, 0.564439482758127, -87.3191680908203, -1.52400698328719, 218, 2, 'PPL', 'P'),
(15912, 'Eleanor', 30.9647197723389, 0.540436311984702, -85.5533294677734, -1.49318728525613, 218, 12, 'PPL', 'P'),
(109052, 'Eleanor', 38.5374984741211, 0.672606233855704, -81.932502746582, -1.42999193732715, 218, 58, 'PPL', 'P'),
(115432, 'Eleanor', 42.6141700744629, 0.743757575804215, -92.8491668701172, -1.62052366961718, 218, 16, 'PPL', 'P'),
(119497, 'Eleanor', 40.982780456543, 0.71528445558866, -90.6949996948242, -1.58292635976994, 218, 18, 'PPL', 'P'),
(59787, 'Eleanor (historical)', 34.4361114501953, 0.601023526389628, -90.4763870239258, -1.57911084887618, 218, 30, 'PPL', 'P'),
(64466, 'Eleanors Crossroads', 36.4366683959961, 0.635939831967493, -76.7583312988281, -1.33968560950117, 218, 33, 'PPL', 'P'),
(64467, 'Elease', 34.8650016784668, 0.608509073002595, -78.7966690063477, -1.37526131376494, 218, 33, 'PPL', 'P'),
(64468, 'Eleazer', 35.514720916748, 0.619848812924152, -79.9688873291016, -1.3957203830492, 218, 33, 'PPL', 'P'),
(15915, 'Electra', 29.1269397735596, 0.508361000078706, -81.8877792358398, -1.42921136481165, 218, 12, 'PPL', 'P'),
(93997, 'Electra', 34.0291709899902, 0.593921075499468, -98.9186096191406, -1.72645542934894, 218, 51, 'PPL', 'P'),
(181404, 'Electra', 38.332218170166, 0.669023416662193, -120.670280456543, -2.10609370327164, 218, 6, 'PPL', 'P'),
(193167, 'Electric', 45.0786094665527, 0.78677015741203, -110.781112670898, -1.93349516512999, 218, 31, 'PPL', 'P'),
(8715, 'Electric (historical)', 34.735279083252, 0.606244986601864, -92.9108276367188, -1.62159985301368, 218, 4, 'PPL', 'P'),
(191427, 'Electric City', 35.7102813720703, 0.623261986756225, -101.412498474121, -1.76998200104714, 218, 51, 'PPL', 'P'),
(207318, 'Electric City', 47.9324989318848, 0.836579925070054, -119.03694152832, -2.07758656117316, 218, 56, 'PPL', 'P'),
(59788, 'Electric Mills', 32.7691688537598, 0.571929889640084, -88.4638900756836, -1.54398615094301, 218, 30, 'PPL', 'P'),
(8716, 'Electric Springs (historical)', 36.3424987792969, 0.634296262100751, -94.0999984741211, -1.64235479949505, 218, 4, 'PPL', 'P'),
(207317, 'Electron', 46.9927787780762, 0.820178714338747, -122.193061828613, -2.13267125200231, 218, 56, 'PPL', 'P'),
(211323, 'Eleele', 21.9102802276611, 0.3824065300073, -159.587219238281, -2.78532241981004, 218, 15, 'PPL', 'P'),
(46839, 'Elen Acres', 38.5166702270508, 0.672242712366908, -76.5466690063477, -1.33599140559506, 218, 25, 'PPL', 'P'),
(72432, 'Elenor', 39.1769409179688, 0.683766609877844, -84.1969375610352, -1.46951378053615, 218, 41, 'PPL', 'P'),
(161276, 'Elephant', 40.4247207641602, 0.705544476533913, -75.241943359375, -1.31321964722018, 218, 45, 'PPL', 'P'),
(188508, 'Elephant Butte', 33.148609161377, 0.578552372322784, -107.184173583984, -1.87071673506966, 218, 38, 'PPL', 'P'),
(188509, 'Elephant Butte Estates', 33.186939239502, 0.579221358388612, -107.206939697266, -1.8711140787043, 218, 38, 'PPL', 'P'),
(101685, 'Elephant Fork', 36.7591705322266, 0.64156855608943, -76.5872192382813, -1.33669914065475, 218, 53, 'PPL', 'P'),
(186679, 'Elephant Park', 39.6288909912109, 0.69165462671055, -105.36222076416, -1.83891765954773, 218, 7, 'PPL', 'P'),
(211810, 'Elephant Point', 66.2597198486328, 1.15645027280768, -161.346115112305, -2.8160209440115, 218, 1, 'PPL', 'P'),
(119498, 'Eleroy', 42.3325004577637, 0.738841513589983, -89.7605590820313, -1.56661729441234, 218, 18, 'PPL', 'P'),
(20840, 'Elery', 33.355281829834, 0.582159490861242, -85.1338882446289, -1.48586665489367, 218, 13, 'PPL', 'P'),
(155156, 'Elery', 41.2983283996582, 0.720791806143916, -84.0686111450195, -1.46727406205939, 218, 41, 'PPL', 'P'),
(173969, 'Eleva', 44.5758285522461, 0.777994975041192, -91.4700012207031, -1.5964526881045, 218, 57, 'PPL', 'P'),
(93998, 'Elevation', 30.6533298492432, 0.53500153256915, -96.8186111450195, -1.68980354168867, 218, 51, 'PPL', 'P'),
(46840, 'Eleven Cedars', 39.038330078125, 0.681347394343616, -76.9250030517578, -1.34259458035986, 218, 25, 'PPL', 'P'),
(46841, 'Eleven Meadows', 39.6852798461914, 0.692638797891389, -77.1322174072266, -1.34621115312019, 218, 25, 'PPL', 'P'),
(15916, 'Eleven Mile', 29.7099990844727, 0.518537304788549, -85.1538925170898, -1.48621579531258, 218, 12, 'PPL', 'P'),
(161277, 'Eleven Mile', 41.9822196960449, 0.732727960991597, -77.9863891601563, -1.36111926258634, 218, 45, 'PPL', 'P'),
(178149, 'Eleven Mile Corner', 32.8794403076172, 0.573854489580857, -111.566390991211, -1.94720085736397, 218, 5, 'PPL', 'P'),
(80852, 'Eleven Oaks', 34.7333297729492, 0.606210964718938, -82.9847183227539, -1.44835656357212, 218, 48, 'PPL', 'P'),
(135176, 'Elevenmile Corner', 47.1958312988281, 0.823722649380343, -93.9561080932617, -1.63984343858711, 218, 28, 'PPL', 'P'),
(202096, 'Elevenmile Corner', 44.1972198486328, 0.771387006586432, -101.667221069336, -1.77442774901286, 218, 49, 'PPL', 'P'),
(211688, 'Elevenmile Homestead', 19.6063899993896, 0.342196059919438, -155.075286865234, -2.70657434427306, 218, 15, 'PPL', 'P'),
(8717, 'Elevenpoint', 36.3416709899902, 0.634281814451837, -91.1275024414063, -1.59047495672171, 218, 4, 'PPL', 'P'),
(101683, 'Elevon', 37.9938888549805, 0.663118456156188, -77.0733337402344, -1.34518343925553, 218, 53, 'PPL', 'P'),
(64470, 'Elf', 35.0213890075684, 0.611238546803817, -83.7480621337891, -1.46167942639941, 218, 33, 'PPL', 'P'),
(15917, 'Elfers', 28.2163906097412, 0.492468919168795, -82.7225036621094, -1.44378005439688, 218, 12, 'PPL', 'P'),
(209952, 'Elfin Cove', 58.1944389343262, 1.01568456575477, -136.343322753906, -2.37963989516497, 218, 1, 'PPL', 'P'),
(181405, 'Elfin Forest', 33.0736083984375, 0.577243362067983, -117.163330078125, -2.04488587246419, 218, 6, 'PPL', 'P'),
(161278, 'Elfinwild', 40.5497207641602, 0.707726138098906, -79.958610534668, -1.39554101914978, 218, 45, 'PPL', 'P'),
(178150, 'Elfrida', 31.6852798461914, 0.553012457731842, -109.686393737793, -1.91438871536338, 218, 5, 'PPL', 'P'),
(181406, 'Elftman', 33.8402786254883, 0.590624281807032, -118.222221374512, -2.06336701200685, 218, 6, 'PPL', 'P'),
(200755, 'Elgarose', 43.2583312988281, 0.755000310083066, -123.484718322754, -2.15521491062983, 218, 43, 'PPL', 'P'),
(2254, 'Elgin', 34.8486099243164, 0.608222982922493, -87.39111328125, -1.52526266374116, 218, 2, 'PPL', 'P'),
(32319, 'Elgin', 37.0044403076172, 0.645849321225623, -96.2763900756836, -1.68033999875507, 218, 20, 'PPL', 'P'),
(54582, 'Elgin', 39.9355583190918, 0.697006981290364, -91.9966735839844, -1.60564485492302, 218, 29, 'PPL', 'P'),
(75755, 'Elgin', 34.7802810668945, 0.607030419386356, -98.2919387817383, -1.71551795991004, 218, 42, 'PPL', 'P'),
(80854, 'Elgin', 34.672779083252, 0.605154155819368, -80.7191696166992, -1.40881527928717, 218, 48, 'PPL', 'P'),
(86762, 'Elgin', 36.332218170166, 0.634116831622306, -84.6063919067383, -1.47666010700527, 218, 50, 'PPL', 'P'),
(93999, 'Elgin', 30.3494396209717, 0.529697647521176, -97.370002746582, -1.69942714060378, 218, 51, 'PPL', 'P'),
(112231, 'Elgin', 35.7638893127441, 0.624197621826197, -91.2925033569336, -1.59335476596647, 218, 4, 'PPL', 'P'),
(115433, 'Elgin', 42.9575004577637, 0.749749821414947, -91.6305618286133, -1.59925499936154, 218, 16, 'PPL', 'P'),
(119499, 'Elgin', 42.0372200012207, 0.733687897406516, -88.2811126708984, -1.54079608343126, 218, 18, 'PPL', 'P'),
(135177, 'Elgin', 44.1302795410156, 0.770218677816215, -92.2513885498047, -1.61009046973069, 218, 28, 'PPL', 'P'),
(141731, 'Elgin', 41.9833297729492, 0.732747335488527, -98.0833282470703, -1.71187701922574, 218, 35, 'PPL', 'P'),
(148623, 'Elgin', 42.3050003051758, 0.738361545382523, -78.353889465332, -1.36753335291374, 218, 40, 'PPL', 'P'),
(155157, 'Elgin', 40.7425003051758, 0.711090775820112, -84.475830078125, -1.47438137321854, 218, 41, 'PPL', 'P'),
(161279, 'Elgin', 41.9030609130859, 0.731346379597091, -79.7438888549805, -1.39179341886382, 218, 45, 'PPL', 'P'),
(178151, 'Elgin', 31.6597194671631, 0.552566344959741, -110.524719238281, -1.92902025555033, 218, 5, 'PPL', 'P'),
(190166, 'Elgin', 37.3519401550293, 0.651914337713142, -114.535003662109, -1.99901292268757, 218, 39, 'PPL', 'P'),
(192552, 'Elgin', 38.9880599975586, 0.68047001592249, -110.144721984863, -1.92238805232965, 218, 52, 'PPL', 'P'),
(198246, 'Elgin', 46.4038887023926, 0.80990064358575, -101.845558166504, -1.77754031853689, 218, 34, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(200756, 'Elgin', 45.564998626709, 0.795259249702766, -117.916389465332, -2.058029238234, 218, 43, 'PPL', 'P'),
(20841, 'Elgin (historical)', 33.226390838623, 0.579909918688452, -84.0044403076172, -1.46615406966296, 218, 13, 'PPL', 'P'),
(196421, 'Elgin (historical)', 45.7522201538086, 0.798526881781266, -104.423057556152, -1.8225261693544, 218, 31, 'PPL', 'P'),
(80855, 'Elgin Acres', 34.1852798461914, 0.596645689031701, -80.7844390869141, -1.40995444644345, 218, 48, 'PPL', 'P'),
(101684, 'Elgin Corner', 38.7852783203125, 0.676930807991829, -77.3252792358398, -1.34958071768941, 218, 53, 'PPL', 'P'),
(80856, 'Elgin Farms', 34.2222213745117, 0.597290440331609, -80.8202819824219, -1.41058002298351, 218, 48, 'PPL', 'P'),
(80857, 'Elgin Woods', 34.6841697692871, 0.605352960794742, -80.7055587768555, -1.40857772531794, 218, 48, 'PPL', 'P'),
(109054, 'Elgood', 37.3994407653809, 0.652743379760484, -80.9313888549805, -1.41251920373125, 218, 58, 'PPL', 'P'),
(75756, 'Eli', 35.9874992370605, 0.628100351245654, -95.1891708374023, -1.66136444335604, 218, 42, 'PPL', 'P'),
(109055, 'Eli', 39.1933288574219, 0.684052633378919, -81.6486129760742, -1.42503712611906, 218, 58, 'PPL', 'P'),
(112334, 'Eli', 37.0438919067383, 0.646537881525463, -84.9644393920898, -1.48290921450314, 218, 21, 'PPL', 'P'),
(177734, 'Eli', 34.6936111450195, 0.605517743887191, -100.628326416016, -1.75629561673106, 218, 51, 'PPL', 'P'),
(209886, 'Eli', 42.9436111450195, 0.749507407176723, -101.490829467773, -1.77134913479273, 218, 35, 'PPL', 'P'),
(59789, 'Eli (historical)', 33.189998626709, 0.579274754768468, -88.6752777099609, -1.54767556115916, 218, 30, 'PPL', 'P'),
(64471, 'Eli Whitney', 35.9066696166992, 0.626689608237212, -79.307502746582, -1.3841770444623, 218, 33, 'PPL', 'P'),
(64472, 'Eliah', 34.2427787780762, 0.59764923470947, -78.0569381713867, -1.36235057511634, 218, 33, 'PPL', 'P'),
(35727, 'Elias', 37.3894386291504, 0.652568809551029, -83.8311080932617, -1.46312885182268, 218, 21, 'PPL', 'P'),
(94001, 'Eliasville', 32.9597206115723, 0.575255645209375, -98.7649993896484, -1.72377442507956, 218, 51, 'PPL', 'P'),
(155158, 'Elida', 40.7886085510254, 0.711895516522507, -84.2038879394531, -1.4696350875238, 218, 41, 'PPL', 'P'),
(188510, 'Elida', 33.9466705322266, 0.592481170877089, -103.656112670898, -1.80914045592539, 218, 38, 'PPL', 'P'),
(94002, 'Elida Colonia', 26.2530002593994, 0.458201293053445, -98.3170013427734, -1.71595538411908, 218, 51, 'PPL', 'P'),
(35728, 'Elihu', 37.0463905334473, 0.646581490788313, -84.5922164916992, -1.47641269934, 218, 21, 'PPL', 'P'),
(54584, 'Elijah', 36.6116714477539, 0.638994211421705, -92.1488876342773, -1.60830149126843, 218, 29, 'PPL', 'P'),
(161281, 'Elijah', 41.8186111450195, 0.729872453091787, -78.9463882446289, -1.37787440742652, 218, 45, 'PPL', 'P'),
(86763, 'Elijah (historical)', 35.9588890075684, 0.627601008541264, -85.5502777099609, -1.49313402203433, 218, 50, 'PPL', 'P'),
(211812, 'Elilakok', 59.5499992370605, 1.03934355624682, -157.08332824707, -2.74162127790239, 218, 1, 'PPL', 'P'),
(86767, 'Elils Ranch Acres', 35.7133293151855, 0.623315183398999, -86.415283203125, -1.50823121593788, 218, 50, 'PPL', 'P'),
(20842, 'Elim', 31.7947196960449, 0.554922543444675, -81.6747207641602, -1.42549279298157, 218, 13, 'PPL', 'P'),
(80858, 'Elim', 34.0475006103516, 0.594240987725414, -79.7980575561523, -1.3927388410508, 218, 48, 'PPL', 'P'),
(161284, 'Elim', 40.297779083252, 0.703328926244049, -78.9427795410156, -1.37781142366674, 218, 45, 'PPL', 'P'),
(211811, 'Elim', 64.6175003051758, 1.12778813473376, -162.260559082031, -2.83198100210823, 218, 1, 'PPL', 'P'),
(35729, 'Elimer', 37.2511100769043, 0.650154520864818, -82.5627822875977, -1.44099239052584, 218, 21, 'PPL', 'P'),
(161282, 'Elimsport', 41.1277809143066, 0.717815190993535, -77.0208282470703, -1.34426704552443, 218, 45, 'PPL', 'P'),
(193521, 'Elinor (historical)', 40.4502792358398, 0.705990556016501, -124.014717102051, -2.16446513436011, 218, 6, 'PPL', 'P'),
(46842, 'Elioak', 39.2347183227539, 0.684775015824603, -76.8869400024414, -1.34193025482594, 218, 25, 'PPL', 'P'),
(124781, 'Eliot', 42.3194389343262, 0.738613547000672, -71.2138900756836, -1.24291685497399, 218, 23, 'PPL', 'P'),
(127419, 'Eliot', 43.1530609130859, 0.75316299524702, -70.8005599975586, -1.23570288421319, 218, 26, 'PPL', 'P'),
(59790, 'Eliphaz', 34.6555595397949, 0.604853618090352, -90.1186065673828, -1.57286640191022, 218, 30, 'PPL', 'P'),
(227, 'Eliska', 31.3525009155273, 0.547204369710489, -87.6830596923828, -1.53035808985481, 218, 2, 'PPL', 'P'),
(54583, 'Elixer', 37.8919410705566, 0.661339131652878, -93.1183319091797, -1.62522148578008, 218, 29, 'PPL', 'P'),
(2255, 'Eliza', 34.8638916015625, 0.608489698505665, -85.6130599975586, -1.49422977966485, 218, 2, 'PPL', 'P'),
(40782, 'Eliza', 30.3286094665527, 0.529334092742866, -91.228889465332, -1.59224449410801, 218, 22, 'PPL', 'P'),
(119501, 'Eliza', 41.2958297729492, 0.720748196881066, -90.9674987792969, -1.58768236600265, 218, 18, 'PPL', 'P'),
(8719, 'Elizabeth', 36.3313903808594, 0.634102383973393, -92.095832824707, -1.60737551015741, 218, 4, 'PPL', 'P'),
(20843, 'Elizabeth', 33.9761085510254, 0.592994961230393, -84.5475006103516, -1.47563225998255, 218, 13, 'PPL', 'P'),
(29711, 'Elizabeth', 38.1211090087891, 0.665338866715041, -85.9741668701172, -1.50053228354257, 218, 19, 'PPL', 'P'),
(40783, 'Elizabeth', 30.8683300018311, 0.538753993124099, -92.7927780151367, -1.61953949843634, 218, 22, 'PPL', 'P'),
(59791, 'Elizabeth', 33.4236106872559, 0.583352054397379, -90.8811111450195, -1.5861746173515, 218, 30, 'PPL', 'P'),
(72433, 'Elizabeth', 39.8752784729004, 0.695954899501728, -82.0619430541992, -1.43225109687987, 218, 41, 'PPL', 'P'),
(86765, 'Elizabeth', 36.1541709899902, 0.631009322104347, -84.5763931274414, -1.47613652953496, 218, 50, 'PPL', 'P'),
(94003, 'Elizabeth', 30.0763893127441, 0.52493202061902, -94.188606262207, -1.64390129714006, 218, 51, 'PPL', 'P'),
(109056, 'Elizabeth', 39.0633316040039, 0.681783753288226, -81.3952789306641, -1.42061561291926, 218, 58, 'PPL', 'P'),
(119503, 'Elizabeth', 42.3177795410156, 0.738584585123817, -90.2213897705078, -1.57466030722049, 218, 18, 'PPL', 'P'),
(135180, 'Elizabeth', 46.3797187805176, 0.809478798869081, -96.1288909912109, -1.67776565408735, 218, 28, 'PPL', 'P'),
(145157, 'Elizabeth', 40.663890838623, 0.70971878180553, -74.2111129760742, -1.29522826300198, 218, 37, 'PPL', 'P'),
(161283, 'Elizabeth', 40.2691688537598, 0.702829583539659, -79.8899993896484, -1.39434352876563, 218, 45, 'PPL', 'P'),
(186680, 'Elizabeth', 39.360279083252, 0.686966464506602, -104.596389770508, -1.82555138719468, 218, 7, 'PPL', 'P'),
(64475, 'Elizabeth City', 36.2944412231445, 0.63345749951543, -76.2513885498047, -1.3308377894116, 218, 33, 'PPL', 'P'),
(64476, 'Elizabeth City Beach', 36.2544403076172, 0.632759351835666, -76.0983276367188, -1.32816637252214, 218, 33, 'PPL', 'P'),
(94004, 'Elizabeth Colonia', 26.1830005645752, 0.456979567903371, -97.8820037841797, -1.70836324448348, 218, 51, 'PPL', 'P'),
(80859, 'Elizabeth Heights', 34.7955589294434, 0.6072970683905, -82.4447174072266, -1.43893176963239, 218, 48, 'PPL', 'P'),
(20844, 'Elizabeth Park', 33.6425018310547, 0.587172425560125, -84.3441696166992, -1.47208346467196, 218, 13, 'PPL', 'P'),
(101688, 'Elizabeth Park', 36.8402786254883, 0.642984159366861, -76.2183303833008, -1.33026081556143, 218, 53, 'PPL', 'P'),
(127421, 'Elizabeth Park', 43.5938911437988, 0.760856934215286, -70.2358322143555, -1.2258465250188, 218, 26, 'PPL', 'P'),
(194884, 'Elizabeth Park', 47.5297203063965, 0.829550111898627, -116.091941833496, -2.02618662002825, 218, 17, 'PPL', 'P'),
(101689, 'Elizabeth River Shores', 36.8286094665527, 0.642780494122498, -76.2113876342773, -1.33013964173183, 218, 53, 'PPL', 'P'),
(20845, 'Elizabeth Village Mobile Home Park', 33.5819396972656, 0.586115416923473, -85.1041717529297, -1.48534800427138, 218, 13, 'PPL', 'P'),
(145159, 'Elizabethport', 40.6500015258789, 0.709476367567306, -74.1875, -1.29481613882329, 218, 37, 'PPL', 'P'),
(46845, 'Elizabeths Landing', 39.1555595397949, 0.683393434430097, -76.5286102294922, -1.33567622048005, 218, 25, 'PPL', 'P'),
(86766, 'Elizabethton', 36.3486099243164, 0.634402921702408, -82.2108306884766, -1.43484967631351, 218, 50, 'PPL', 'P'),
(27070, 'Elizabethtown', 37.4458312988281, 0.653553047310895, -88.3050003051758, -1.54121300129991, 218, 18, 'PPL', 'P'),
(29712, 'Elizabethtown', 39.1349983215332, 0.683034573473209, -85.8133316040039, -1.49772517859558, 218, 19, 'PPL', 'P'),
(35730, 'Elizabethtown', 37.6938896179199, 0.65788248171601, -85.8591690063477, -1.49852519218703, 218, 21, 'PPL', 'P'),
(64479, 'Elizabethtown', 34.6291694641113, 0.604393024379823, -78.6055603027344, -1.37192583765767, 218, 33, 'PPL', 'P'),
(94007, 'Elizabethtown', 33.021671295166, 0.576336888611947, -97.2763900756836, -1.69779329127501, 218, 51, 'PPL', 'P'),
(148625, 'Elizabethtown', 42.9661102294922, 0.749900090279455, -75.0794372558594, -1.31038338065924, 218, 40, 'PPL', 'P'),
(155159, 'Elizabethtown', 40.035831451416, 0.69875707760071, -81.4066696166992, -1.42081441789463, 218, 41, 'PPL', 'P'),
(161288, 'Elizabethtown', 40.1527786254883, 0.700798190839174, -76.6030578613281, -1.3369755767759, 218, 45, 'PPL', 'P'),
(188511, 'Elizabethtown', 36.6191711425781, 0.639125105789282, -105.283889770508, -1.83755052580214, 218, 38, 'PPL', 'P'),
(155160, 'Elizabethtown (historical)', 41.0666694641113, 0.716748594976958, -83.0686111450195, -1.44982076953945, 218, 41, 'PPL', 'P'),
(202095, 'Elizabethtown (historical)', 44.3875007629395, 0.774708035044788, -103.702781677246, -1.80995498374479, 218, 49, 'PPL', 'P'),
(161290, 'Elizabethville', 40.5488891601563, 0.707711623870965, -76.8122177124023, -1.34062610484013, 218, 45, 'PPL', 'P'),
(207319, 'Elizan Beach', 47.1291694641113, 0.822559180879114, -122.999717712402, -2.14675005310501, 218, 56, 'PPL', 'P'),
(35731, 'Elizaville', 38.4194412231445, 0.67054574612031, -83.8255615234375, -1.46303204591706, 218, 21, 'PPL', 'P'),
(122561, 'Elizaville', 40.1266708374023, 0.700342523976661, -86.3758316040039, -1.50754265563804, 218, 19, 'PPL', 'P'),
(148627, 'Elizaville', 42.0508308410645, 0.733925451375751, -73.7941665649414, -1.28795117532334, 218, 40, 'PPL', 'P'),
(59792, 'Elize (historical)', 33.8408317565918, 0.590633935765983, -88.9000015258789, -1.55159773165457, 218, 30, 'PPL', 'P'),
(29713, 'Elk', 39.4458312988281, 0.688459632350782, -86.4291687011719, -1.50847356359708, 218, 19, 'PPL', 'P'),
(46846, 'Elk', 39.5449981689453, 0.690190420743225, -75.8375015258789, -1.32361409811281, 218, 25, 'PPL', 'P'),
(72437, 'Elk', 39.6730613708496, 0.692425545267101, -81.3361129760742, -1.41958297220658, 218, 41, 'PPL', 'P'),
(94005, 'Elk', 31.6163902282715, 0.551810107078699, -96.9355621337891, -1.69184472150616, 218, 51, 'PPL', 'P'),
(109058, 'Elk', 39.021671295166, 0.681056643731607, -79.5380630493164, -1.38820108086941, 218, 58, 'PPL', 'P'),
(181408, 'Elk', 39.1302795410156, 0.682952215216498, -123.716667175293, -2.15926318180286, 218, 6, 'PPL', 'P'),
(188512, 'Elk', 32.9430618286133, 0.574964894597366, -105.333892822266, -1.83842324369136, 218, 38, 'PPL', 'P'),
(207320, 'Elk', 48.0163917541504, 0.83804413103738, -117.27555847168, -2.04684462744594, 218, 56, 'PPL', 'P'),
(209429, 'Elk', 43.7866706848145, 0.764221571936492, -110.546669006348, -1.92940335127313, 218, 59, 'PPL', 'P'),
(8720, 'Elk (historical)', 34.1652793884277, 0.596296615191819, -93.5133285522461, -1.63211547773592, 218, 4, 'PPL', 'P'),
(209430, 'Elk Basin', 44.9905586242676, 0.785233380305, -108.863327026367, -1.90002349128544, 218, 59, 'PPL', 'P'),
(194885, 'Elk Bend', 44.8844413757324, 0.783381284924904, -113.968063354492, -1.98911794765738, 218, 17, 'PPL', 'P'),
(109059, 'Elk Branch (historical)', 39.5002784729004, 0.68940991480675, -78.1152801513672, -1.36336883475913, 218, 58, 'PPL', 'P'),
(148628, 'Elk Brook', 41.9741706848145, 0.732587479244095, -75.0552825927734, -1.30996180225868, 218, 40, 'PPL', 'P'),
(35732, 'Elk Chester', 38.0719413757324, 0.66448072963279, -84.6180572509766, -1.4768637056706, 218, 21, 'PPL', 'P'),
(32320, 'Elk City', 37.2891693115234, 0.650818779819711, -95.9113922119141, -1.67396958426955, 218, 20, 'PPL', 'P'),
(75757, 'Elk City', 35.4119415283203, 0.618054974192902, -99.4038925170898, -1.73492521372177, 218, 42, 'PPL', 'P'),
(109060, 'Elk City', 39.142219543457, 0.683160607571797, -80.1083297729492, -1.39815411281137, 218, 58, 'PPL', 'P'),
(141733, 'Elk City', 41.3716697692871, 0.722071854521863, -96.2675018310547, -1.68018486962157, 218, 35, 'PPL', 'P'),
(161293, 'Elk City', 41.2441711425781, 0.71984658369402, -79.5019378662109, -1.38757057748134, 218, 45, 'PPL', 'P'),
(194886, 'Elk City', 45.8269386291504, 0.799830965188051, -115.435829162598, -2.01473529365702, 218, 17, 'PPL', 'P'),
(200757, 'Elk City', 44.6197204589844, 0.778761033328753, -123.878326416016, -2.16208466781974, 218, 43, 'PPL', 'P'),
(35733, 'Elk Creek', 38.1002807617188, 0.664975345226245, -85.3711090087891, -1.49000693828236, 218, 21, 'PPL', 'P'),
(54585, 'Elk Creek', 37.1888885498047, 0.649068550351311, -91.996940612793, -1.60564951545493, 218, 29, 'PPL', 'P'),
(101690, 'Elk Creek', 36.7213897705078, 0.640909157403526, -81.1772232055664, -1.41680982256348, 218, 53, 'PPL', 'P'),
(141734, 'Elk Creek', 40.2861099243164, 0.703125260999685, -96.1291732788086, -1.67777058093536, 218, 35, 'PPL', 'P'),
(148629, 'Elk Creek', 42.5913887023926, 0.743359965853466, -74.8238906860352, -1.30592325162363, 218, 40, 'PPL', 'P'),
(173971, 'Elk Creek', 44.4269409179688, 0.775396395607547, -91.3994369506836, -1.59522110925839, 218, 57, 'PPL', 'P'),
(181409, 'Elk Creek', 39.605281829834, 0.691242569110888, -122.538063049316, -2.13869265922697, 218, 6, 'PPL', 'P'),
(194887, 'Elk Creek', 47.5338897705078, 0.829622882775413, -116.056938171387, -2.02557569087419, 218, 17, 'PPL', 'P'),
(207321, 'Elk Creek', 46.6650009155273, 0.81445791142212, -123.445831298828, -2.15453620402602, 218, 56, 'PPL', 'P'),
(2256, 'Elk Estates', 34.8277816772461, 0.607859461433697, -87.1366729736328, -1.52082184262345, 218, 2, 'PPL', 'P'),
(32323, 'Elk Falls', 37.3672218322754, 0.652181053296314, -96.1883316040039, -1.67880308848999, 218, 20, 'PPL', 'P'),
(200758, 'Elk Flat (historical)', 45.5694389343262, 0.795336747690488, -117.818061828613, -2.05631309722755, 218, 43, 'PPL', 'P'),
(46847, 'Elk Forest', 39.5338897705078, 0.689996542615867, -75.8672180175781, -1.3241327487351, 218, 25, 'PPL', 'P'),
(109061, 'Elk Forest', 38.3894386291504, 0.670022102070973, -81.5933303833008, -1.42407226285613, 218, 58, 'PPL', 'P'),
(72438, 'Elk Fork', 39.2825012207031, 0.685608984719961, -82.4683303833008, -1.43934389381108, 218, 41, 'PPL', 'P'),
(101692, 'Elk Garden', 36.9088897705078, 0.644181649751016, -81.9802780151367, -1.43082577306446, 218, 53, 'PPL', 'P'),
(109062, 'Elk Garden', 39.3833312988281, 0.687368801568286, -79.1544418334961, -1.38150562757284, 218, 58, 'PPL', 'P'),
(119505, 'Elk Grove', 42.0072212219238, 0.733164319936206, -87.9402770996094, -1.53484738050435, 218, 18, 'PPL', 'P'),
(161295, 'Elk Grove', 41.3061103820801, 0.72092762735951, -76.4072189331055, -1.33355754267484, 218, 45, 'PPL', 'P'),
(173972, 'Elk Grove', 42.6716690063477, 0.744761121481984, -90.3908309936523, -1.57761761445297, 218, 57, 'PPL', 'P'),
(181410, 'Elk Grove', 38.4088897705078, 0.670361588530931, -121.370559692383, -2.1183158816204, 218, 6, 'PPL', 'P'),
(193522, 'Elk Grove (historical)', 41.3644409179688, 0.72194568726522, -124.021392822266, -2.1645816476578, 218, 6, 'PPL', 'P'),
(119506, 'Elk Grove Village', 42.0038909912109, 0.733106196445415, -87.9702835083008, -1.53537109113272, 218, 18, 'PPL', 'P'),
(46848, 'Elk Haven', 39.5669403076172, 0.690573383307978, -75.8586120605469, -1.32398254644962, 218, 25, 'PPL', 'P'),
(101693, 'Elk Hill', 37.7174987792969, 0.658294539315673, -78.0877838134766, -1.3628889331307, 218, 53, 'PPL', 'P'),
(109063, 'Elk Hills', 38.4000015258789, 0.670206459397433, -81.5736083984375, -1.42372804928523, 218, 58, 'PPL', 'P'),
(35734, 'Elk Horn', 37.3163909912109, 0.651293887758181, -85.2852783203125, -1.48850891016919, 218, 21, 'PPL', 'P'),
(115438, 'Elk Horn', 41.5916709899902, 0.725911600181539, -95.0597229003906, -1.65910515064527, 218, 16, 'PPL', 'P'),
(161296, 'Elk Lake', 41.7516708374023, 0.728704124321569, -75.9505615234375, -1.3255873673225, 218, 45, 'PPL', 'P'),
(200759, 'Elk Lake', 43.9816703796387, 0.767624958651559, -121.804718017578, -2.12589337387, 218, 43, 'PPL', 'P'),
(72439, 'Elk Lick', 39.026668548584, 0.681143862257307, -84.1297225952148, -1.46834065807597, 218, 41, 'PPL', 'P'),
(72440, 'Elk Lick (historical)', 39.0277786254883, 0.681163236754237, -84.1311111450195, -1.46836489284189, 218, 41, 'PPL', 'P'),
(86769, 'Elk Mill Village', 35.1622200012207, 0.613696511331906, -86.5666732788086, -1.51087347121341, 218, 50, 'PPL', 'P'),
(46849, 'Elk Mills', 39.6586112976074, 0.69217334391187, -75.8263931274414, -1.32342021998545, 218, 25, 'PPL', 'P'),
(78203, 'Elk Mills', 39.7277793884277, 0.693380554834003, -75.9227828979492, -1.32510253884606, 218, 45, 'PPL', 'P'),
(86768, 'Elk Mills', 36.2724990844727, 0.633074536950677, -81.9899978637695, -1.4309954164259, 218, 50, 'PPL', 'P'),
(173974, 'Elk Mound', 44.8730583190918, 0.783182613107584, -91.6908264160156, -1.60030681483406, 218, 57, 'PPL', 'P'),
(64481, 'Elk Mountain', 35.6377792358398, 0.621996585764274, -82.5936126708984, -1.44153048222409, 218, 33, 'PPL', 'P'),
(209431, 'Elk Mountain', 41.6875, 0.727584131925136, -106.412780761719, -1.85725339049487, 218, 59, 'PPL', 'P'),
(46850, 'Elk Neck', 39.5127792358398, 0.689628094279054, -75.9516677856445, -1.32560667524041, 218, 25, 'PPL', 'P'),
(64482, 'Elk Park', 36.1572189331055, 0.631062518747122, -81.9783325195313, -1.43079181776056, 218, 33, 'PPL', 'P'),
(78204, 'Elk Park', 39.7619400024414, 0.693976770023045, -79.4524993896484, -1.38670771328815, 218, 45, 'PPL', 'P'),
(196422, 'Elk Park', 46.1650009155273, 0.805731265162149, -112.371391296387, -1.96125076316885, 218, 31, 'PPL', 'P'),
(207322, 'Elk Plain', 47.0533294677734, 0.821235523238318, -122.396392822266, -2.13622004731289, 218, 56, 'PPL', 'P'),
(170223, 'Elk Point', 42.6833305358887, 0.744964653568293, -96.6833267211914, -1.6874423830662, 218, 49, 'PPL', 'P'),
(190167, 'Elk Point', 38.9861106872559, 0.680435994039564, -119.955558776855, -2.09361945672571, 218, 39, 'PPL', 'P'),
(46851, 'Elk Ranch Park', 39.5386085510254, 0.690078900872578, -75.8905563354492, -1.32454007922383, 218, 25, 'PPL', 'P'),
(130644, 'Elk Rapids', 44.8955612182617, 0.783575362789344, -85.416389465332, -1.49079723133584, 218, 27, 'PPL', 'P'),
(20846, 'Elk Ridge', 33.5830612182617, 0.586134991157485, -83.8027801513672, -1.46263443596631, 218, 13, 'PPL', 'P'),
(203859, 'Elk Ridge', 40.0113906860352, 0.698330505773106, -111.676109313965, -1.94911580334579, 218, 52, 'PPL', 'P'),
(135184, 'Elk River', 45.3038902282715, 0.790702048445423, -93.5669403076172, -1.63305117938492, 218, 28, 'PPL', 'P'),
(193523, 'Elk River', 40.7363891601563, 0.710984116218454, -124.173057556152, -2.16722869662328, 218, 6, 'PPL', 'P'),
(194888, 'Elk River', 46.7836112976074, 0.816528053116466, -116.178886413574, -2.02770408921738, 218, 17, 'PPL', 'P'),
(46854, 'Elk River Basin', 39.5111083984375, 0.689598932665118, -75.8697204589844, -1.32417642457698, 218, 25, 'PPL', 'P'),
(46852, 'Elk River Estates', 39.5550003051758, 0.690364990952679, -75.8863906860352, -1.32446737492607, 218, 25, 'PPL', 'P'),
(109064, 'Elk River Junction', 38.7916717529297, 0.677042394441503, -79.7613906860352, -1.39209888344085, 218, 58, 'PPL', 'P'),
(115440, 'Elk River Junction', 41.9797210693359, 0.732684351728747, -90.1738891601563, -1.57383126517315, 218, 16, 'PPL', 'P'),
(101694, 'Elk Run', 38.5550003051758, 0.672911698432736, -77.6711120605469, -1.35561663914202, 218, 53, 'PPL', 'P'),
(115441, 'Elk Run Heights', 42.4669418334961, 0.741187958247424, -92.2563934326172, -1.61017782141444, 218, 16, 'PPL', 'P'),
(109065, 'Elk Run Junction', 37.9919395446777, 0.663084434273262, -81.5430603027344, -1.423194884435, 218, 58, 'PPL', 'P'),
(64483, 'Elk Shoal', 35.9422187805176, 0.627310058192173, -82.3908309936523, -1.43799127429342, 218, 33, 'PPL', 'P'),
(54591, 'Elk Springs', 36.583610534668, 0.638504456097239, -94.4561080932617, -1.64857008484708, 218, 29, 'PPL', 'P'),
(194170, 'Elk Springs', 40.3555603027344, 0.704337398769834, -108.447776794434, -1.89277077153077, 218, 7, 'PPL', 'P'),
(194889, 'Elk Summit', 46.3238906860352, 0.808504414805248, -114.648887634277, -2.00100057296715, 218, 17, 'PPL', 'P'),
(64484, 'Elk Valley', 36.1719398498535, 0.631319447213287, -81.9113922119141, -1.42962348899034, 218, 33, 'PPL', 'P'),
(86770, 'Elk Valley', 36.4836082458496, 0.636759086897829, -84.2458267211914, -1.47036705734941, 218, 50, 'PPL', 'P'),
(148630, 'Elka Park', 42.1591682434082, 0.735816295749707, -74.1577835083008, -1.294297488201, 218, 40, 'PPL', 'P'),
(115445, 'Elkader', 42.853889465332, 0.747941468455756, -91.4052810668945, -1.59532310832814, 218, 16, 'PPL', 'P'),
(187662, 'Elkader', 38.7933311462402, 0.677071356318358, -100.858329772949, -1.76030993260019, 218, 20, 'PPL', 'P'),
(35735, 'Elkatawa', 37.5569381713867, 0.655492228058637, -83.4269409179688, -1.45607480388534, 218, 21, 'PPL', 'P'),
(148631, 'Elkdale', 42.2150001525879, 0.736790746392567, -78.7538909912109, -1.37451469655333, 218, 40, 'PPL', 'P'),
(161300, 'Elkdale', 41.6816711425781, 0.727482399171495, -75.5536117553711, -1.31865928690472, 218, 45, 'PPL', 'P'),
(194171, 'Elkdale', 40.0402793884277, 0.698834708746485, -105.880561828613, -1.84796441777073, 218, 7, 'PPL', 'P'),
(35736, 'Elkfork', 37.9647216796875, 0.662609392913819, -83.133056640625, -1.45094555562584, 218, 21, 'PPL', 'P'),
(94006, 'Elkhart', 31.625, 0.551960375943207, -95.5791702270508, -1.66817121678617, 218, 51, 'PPL', 'P'),
(115446, 'Elkhart', 41.7916717529297, 0.729402272001333, -93.5219421386719, -1.63226581317945, 218, 16, 'PPL', 'P'),
(119508, 'Elkhart', 40.0205612182617, 0.69849056175462, -89.482780456543, -1.56176914280591, 218, 18, 'PPL', 'P'),
(122562, 'Elkhart', 41.6819381713867, 0.727487059703403, -85.9766693115234, -1.50057595938445, 218, 19, 'PPL', 'P'),
(187664, 'Elkhart', 37.0080604553223, 0.645912504722485, -101.889717102051, -1.77831103735636, 218, 20, 'PPL', 'P'),
(173978, 'Elkhart Lake', 43.8333282470703, 0.765035900018812, -88.0177764892578, -1.536200000022, 218, 57, 'PPL', 'P'),
(54593, 'Elkhead', 37.0136108398438, 0.646009377207137, -92.9302825927734, -1.62193940605267, 218, 29, 'PPL', 'P'),
(86771, 'Elkhead', 35.3583297729492, 0.617119272543903, -85.8313903808594, -1.49804036371059, 218, 50, 'PPL', 'P'),
(194172, 'Elkhead', 40.648609161377, 0.709452066222359, -107.206939697266, -1.8711140787043, 218, 7, 'PPL', 'P'),
(200760, 'Elkhead', 43.540828704834, 0.759930819946211, -123.183891296387, -2.14996448854073, 218, 43, 'PPL', 'P'),
(159, 'Elkhorn', 37.3855590820313, 0.652501098680314, -81.4111099243164, -1.42089191588235, 218, 58, 'PPL', 'P'),
(40784, 'Elkhorn', 31.6163902282715, 0.551810107078699, -91.6661071777344, -1.59987538273747, 218, 22, 'PPL', 'P'),
(46853, 'Elkhorn', 39.1872215270996, 0.683946040356288, -76.8369369506836, -1.34105753693672, 218, 25, 'PPL', 'P'),
(54594, 'Elkhorn', 39.3091697692871, 0.68607443869948, -94.1125030517578, -1.64257304554639, 218, 29, 'PPL', 'P'),
(86772, 'Elkhorn', 36.3338890075684, 0.634145993236243, -88.1591720581055, -1.53866781824613, 218, 50, 'PPL', 'P'),
(101695, 'Elkhorn', 36.8644409179688, 0.643405870925476, -79.1100006103516, -1.38072998190536, 218, 53, 'PPL', 'P'),
(130647, 'Elkhorn', 45.954719543457, 0.802061162863911, -86.4066696166992, -1.50808088049435, 218, 27, 'PPL', 'P'),
(141743, 'Elkhorn', 41.2863883972168, 0.720583413788618, -96.2341690063477, -1.67960310208145, 218, 35, 'PPL', 'P'),
(161301, 'Elkhorn', 40.2219390869141, 0.702005268603252, -79.9638900756836, -1.3956331645235, 218, 45, 'PPL', 'P'),
(173980, 'Elkhorn', 42.672779083252, 0.744780495978914, -88.5444412231445, -1.54539203368247, 218, 57, 'PPL', 'P'),
(181411, 'Elkhorn', 36.8244400024414, 0.642707723245711, -121.739440917969, -2.12475407355566, 218, 6, 'PPL', 'P'),
(196423, 'Elkhorn', 45.4894409179688, 0.793940518909987, -113.03556060791, -1.97284270444564, 218, 31, 'PPL', 'P'),
(200761, 'Elkhorn', 44.8358306884766, 0.782532868380632, -122.360832214355, -2.13559939762085, 218, 43, 'PPL', 'P'),
(35737, 'Elkhorn City', 37.3038902282715, 0.651075708285876, -82.3511123657227, -1.43729805346168, 218, 21, 'PPL', 'P'),
(119509, 'Elkhorn Grove', 42.0080604553223, 0.733178967322202, -89.7344436645508, -1.56616149439178, 218, 18, 'PPL', 'P'),
(196424, 'Elkhorn Hot Springs', 45.4555587768555, 0.793349163989934, -113.10888671875, -1.97412248650747, 218, 31, 'PPL', 'P'),
(209434, 'Elkhorn Junction', 42.4322204589844, 0.740581955941377, -109.240829467773, -1.90661215182229, 218, 59, 'PPL', 'P'),
(8722, 'Elkhorn Tavern', 36.4536094665527, 0.636235509427519, -94.0155563354492, -1.6408810061478, 218, 4, 'PPL', 'P'),
(194890, 'Elkhorn Village', 43.6794395446777, 0.762350035480439, -114.331672668457, -1.99546412737699, 218, 17, 'PPL', 'P'),
(200762, 'Elkhorn Woods', 44.8133316040039, 0.7821401852779, -122.400001525879, -2.13628303107267, 218, 43, 'PPL', 'P'),
(54596, 'Elkhurst', 38.8325004577637, 0.677754989770181, -92.2519378662109, -1.61010005711061, 218, 29, 'PPL', 'P'),
(109067, 'Elkhurst', 38.4474983215332, 0.671035434865748, -81.1561126708984, -1.41644137422667, 218, 58, 'PPL', 'P'),
(209432, 'Elkhurst', 41.4919395446777, 0.724170958093063, -110.349716186523, -1.92596587609612, 218, 59, 'PPL', 'P'),
(35739, 'Elkin', 37.9127807617188, 0.661702852878756, -84.2238922119141, -1.46998422794271, 218, 21, 'PPL', 'P'),
(64488, 'Elkin', 36.2441711425781, 0.632580121094303, -80.8486099243164, -1.41107443883988, 218, 33, 'PPL', 'P'),
(161308, 'Elkin', 40.8038902282715, 0.712162232105678, -79.1083297729492, -1.38070082029142, 218, 45, 'PPL', 'P'),
(64489, 'Elkin Valley', 36.2730598449707, 0.633084324067683, -80.8533325195313, -1.41115686367562, 218, 33, 'PPL', 'P'),
(8723, 'Elkins', 36.0013885498047, 0.628342765483878, -94.008056640625, -1.64075011178023, 218, 4, 'PPL', 'P'),
(86774, 'Elkins', 35.8224983215332, 0.625220542000897, -87.4802780151367, -1.52681888192415, 218, 50, 'PPL', 'P'),
(109066, 'Elkins', 38.9258308410645, 0.679383912250928, -79.8469390869141, -1.39359198470601, 218, 58, 'PPL', 'P'),
(143792, 'Elkins', 43.4208297729492, 0.757836443485946, -71.9377822875977, -1.25555115750144, 218, 36, 'PPL', 'P'),
(188513, 'Elkins', 33.6944389343262, 0.588078899016161, -104.054443359375, -1.81609263795104, 218, 38, 'PPL', 'P'),
(86775, 'Elkins (historical)', 35.8013916015625, 0.624852160243112, -86.0041732788086, -1.50105599417094, 218, 50, 'PPL', 'P'),
(109068, 'Elkins Junction', 38.9141693115234, 0.679180380164619, -79.8649978637695, -1.39390716982102, 218, 58, 'PPL', 'P'),
(8725, 'Elkins Park', 36.4097213745117, 0.635469517718985, -90.899169921875, -1.58648980246652, 218, 4, 'PPL', 'P'),
(161302, 'Elkins Park', 40.0769386291504, 0.699474533198377, -75.1272201538086, -1.3112173495546, 218, 45, 'PPL', 'P'),
(161303, 'Elkins Park Gardens', 40.0750007629395, 0.699440711052533, -75.1233291625977, -1.3111494389468, 218, 45, 'PPL', 'P'),
(29714, 'Elkinsville', 39.0761108398438, 0.68200679302952, -86.2647171020508, -1.50560334173225, 218, 19, 'PPL', 'P'),
(54597, 'Elkland', 37.4430618286133, 0.65350471093711, -93.0308303833008, -1.62369429605298, 218, 29, 'PPL', 'P'),
(161304, 'Elkland', 41.9861106872559, 0.732795871599394, -77.3111114501953, -1.3493334431822, 218, 45, 'PPL', 'P'),
(2259, 'Elkmont', 34.9288902282715, 0.609624138551011, -86.9738922119141, -1.51798078237255, 218, 2, 'PPL', 'P'),
(86776, 'Elkmont', 35.6536102294922, 0.62227288872737, -83.5805587768555, -1.45875594131277, 218, 50, 'PPL', 'P'),
(86777, 'Elkmont Springs', 35.0050010681152, 0.610952523302743, -86.866943359375, -1.51611417276452, 218, 50, 'PPL', 'P'),
(46855, 'Elkmore', 39.5563888549805, 0.690389225718599, -75.8783264160156, -1.32432662686246, 218, 25, 'PPL', 'P'),
(2260, 'Elko', 34.709171295166, 0.605789319739352, -86.6711120605469, -1.51269627182151, 218, 2, 'PPL', 'P'),
(20847, 'Elko', 32.3308296203613, 0.564279426776613, -83.7063903808594, -1.46095211710571, 218, 13, 'PPL', 'P'),
(35740, 'Elko', 37.1616706848145, 0.648593508991868, -86.1352767944336, -1.50334418217953, 218, 21, 'PPL', 'P'),
(80860, 'Elko', 33.3802795410156, 0.582595783226824, -81.3797225952148, -1.42034410364612, 218, 48, 'PPL', 'P'),
(101703, 'Elko', 37.4727783203125, 0.654023361559403, -77.211669921875, -1.34759786109979, 218, 53, 'PPL', 'P'),
(135187, 'Elko', 44.5647201538086, 0.777801096913834, -93.3266677856445, -1.62885763277442, 218, 28, 'PPL', 'P'),
(139135, 'Elko', 40.4150009155273, 0.705374833172475, -92.8647232055664, -1.62079517889032, 218, 29, 'PPL', 'P'),
(199939, 'Elko', 40.8325004577637, 0.712661574810068, -115.762222290039, -2.02043192838675, 218, 39, 'PPL', 'P'),
(209433, 'Elkol', 41.7238883972168, 0.728219229266093, -110.611671447754, -1.93053785789751, 218, 59, 'PPL', 'P'),
(115449, 'Elkport', 42.7397193908691, 0.745948824749132, -91.2777786254883, -1.59309777092127, 218, 16, 'PPL', 'P'),
(46864, 'Elkridge', 39.2125015258789, 0.684387259569887, -76.7138900756836, -1.33890996383368, 218, 25, 'PPL', 'P'),
(109069, 'Elkridge', 38.0802803039551, 0.664626271386363, -81.3341674804688, -1.41954901690268, 218, 58, 'PPL', 'P'),
(46856, 'Elkridge Heights', 39.2119407653809, 0.684377472452881, -76.7183303833008, -1.3389874618214, 218, 25, 'PPL', 'P'),
(40786, 'Elks', 30.1825008392334, 0.526784016130574, -91.9891662597656, -1.60551382739739, 218, 22, 'PPL', 'P'),
(70781, 'Elks Terrace', 39.5588912963867, 0.690432901560476, -75.4413909912109, -1.31670066508102, 218, 37, 'PPL', 'P'),
(15918, 'Elkton', 29.7827796936035, 0.519807566049489, -81.4261093139648, -1.42115370461751, 218, 12, 'PPL', 'P'),
(27075, 'Elkton', 38.2916717529297, 0.668315748181532, -89.5566711425781, -1.56305877856378, 218, 18, 'PPL', 'P'),
(35741, 'Elkton', 36.810001373291, 0.642455721627562, -87.154167175293, -1.52112717404243, 218, 21, 'PPL', 'P'),
(46857, 'Elkton', 39.6066703796387, 0.691266803876807, -75.833610534668, -1.32354618750501, 218, 25, 'PPL', 'P'),
(54598, 'Elkton', 37.8525009155273, 0.66065077109012, -93.4258270263672, -1.63058828800881, 218, 29, 'PPL', 'P'),
(64492, 'Elkton', 34.4666709899902, 0.601556890976943, -78.6055603027344, -1.37192583765767, 218, 33, 'PPL', 'P'),
(86778, 'Elkton', 35.0522193908691, 0.611776638502068, -86.8886108398438, -1.51649234163931, 218, 50, 'PPL', 'P'),
(101696, 'Elkton', 38.4077796936035, 0.670342214034, -78.623893737793, -1.37224581646264, 218, 53, 'PPL', 'P'),
(115450, 'Elkton', 42.7975006103516, 0.746957297274918, -95.3680572509766, -1.66448660025999, 218, 16, 'PPL', 'P'),
(130649, 'Elkton', 43.8194389343262, 0.764793485780587, -83.1808319091797, -1.45177939136315, 218, 27, 'PPL', 'P'),
(135189, 'Elkton', 43.6627807617188, 0.76205928486843, -92.7083282470703, -1.61806557193104, 218, 28, 'PPL', 'P'),
(155162, 'Elkton', 40.7619400024414, 0.711430062542988, -80.6988906860352, -1.4084613451783, 218, 41, 'PPL', 'P'),
(170227, 'Elkton', 44.2361106872559, 0.772065779769266, -96.480827331543, -1.68390810198356, 218, 49, 'PPL', 'P'),
(186682, 'Elkton', 38.7222213745117, 0.675830256671354, -105.150001525879, -1.83521373510365, 218, 7, 'PPL', 'P'),
(200764, 'Elkton', 43.6377792358398, 0.76162292592382, -123.566940307617, -2.15664995498321, 218, 43, 'PPL', 'P'),
(46858, 'Elkton Heights', 39.6150016784668, 0.691412212472326, -75.8338928222656, -1.32355111435303, 218, 25, 'PPL', 'P'),
(46859, 'Elkton Landing', 39.5974998474121, 0.691106747895294, -75.8411102294922, -1.32367708187259, 218, 25, 'PPL', 'P'),
(46860, 'Elktonia', 38.961669921875, 0.680009422211961, -76.475830078125, -1.33475503305899, 218, 25, 'PPL', 'P'),
(78207, 'Elkview', 39.8083305358887, 0.694786437573456, -75.8955612182617, -1.32462743090759, 218, 45, 'PPL', 'P'),
(109071, 'Elkview', 38.4427795410156, 0.670953076609037, -81.4805603027344, -1.4221040536525, 218, 58, 'PPL', 'P'),
(27076, 'Elkville', 37.9099998474121, 0.661654316767889, -89.2358322143555, -1.55745908289773, 218, 18, 'PPL', 'P'),
(64493, 'Elkville', 36.0697212219238, 0.629535395599043, -81.4019393920898, -1.42073185990084, 218, 33, 'PPL', 'P'),
(109070, 'Elkwater', 38.6363906860352, 0.674332228558184, -80.0155563354492, -1.3965349108686, 218, 58, 'PPL', 'P'),
(2261, 'Elkwood', 34.9775009155273, 0.610472555095283, -86.7236099243164, -1.51361253239455, 218, 2, 'PPL', 'P'),
(101697, 'Elkwood', 38.5116691589355, 0.672155427262181, -77.8561096191406, -1.35884545564763, 218, 53, 'PPL', 'P'),
(35742, 'Ella', 37.1566696166992, 0.648506223887141, -85.1397171020508, -1.48596838764731, 218, 21, 'PPL', 'P'),
(80861, 'Ella', 34.0641708374023, 0.594531938074505, -81.4261093139648, -1.42115370461751, 218, 48, 'PPL', 'P'),
(94008, 'Ella', 27.4733295440674, 0.479500057029408, -98.1055603027344, -1.71226504179656, 218, 51, 'PPL', 'P'),
(161309, 'Ella', 41.310001373291, 0.720995537967307, -79.1908264160156, -1.38214065833477, 218, 45, 'PPL', 'P'),
(173982, 'Ella', 44.5366706848145, 0.77731154132645, -92.0500030517578, -1.606575629724, 218, 57, 'PPL', 'P'),
(200763, 'Ella', 45.6313896179199, 0.79641799109306, -119.807777404785, -2.09104018520997, 218, 43, 'PPL', 'P'),
(8726, 'Ella (historical)', 35.7013893127441, 0.623106791043701, -92.8138885498047, -1.61990794677316, 218, 4, 'PPL', 'P'),
(20859, 'Ella Gap', 34.6419410705566, 0.604615930963063, -84.4991683959961, -1.47478870370727, 218, 13, 'PPL', 'P'),
(20848, 'Ella Park (historical)', 31.059440612793, 0.542089502520883, -81.5691680908203, -1.42365055129751, 218, 13, 'PPL', 'P'),
(20849, 'Ellabell', 32.1233291625977, 0.560657860589242, -81.4858322143555, -1.42219606586816, 218, 13, 'PPL', 'P'),
(211813, 'Ellamar', 60.8955612182617, 1.06282804310844, -146.697494506836, -2.56035428357058, 218, 1, 'PPL', 'P'),
(109072, 'Ellamore', 38.9241714477539, 0.679354950374074, -80.0905609130859, -1.39784398770243, 218, 58, 'PPL', 'P'),
(59793, 'Ellard', 34.0158309936523, 0.593688248641168, -89.4147186279297, -1.56058123980168, 218, 30, 'PPL', 'P'),
(2262, 'Ellards', 32.8147201538086, 0.5727249098045, -87.2608337402344, -1.52298885680245, 218, 2, 'PPL', 'P'),
(2263, 'Ellaville', 34.2572212219238, 0.597901302906646, -87.3199996948242, -1.52402149751513, 218, 2, 'PPL', 'P'),
(15920, 'Ellaville', 30.3811092376709, 0.530250386605422, -83.1727828979492, -1.45163890961564, 218, 12, 'PPL', 'P'),
(20850, 'Ellaville', 32.2380599975586, 0.562660291412873, -84.3091735839844, -1.47147266867596, 218, 13, 'PPL', 'P'),
(46862, 'Ellaville', 38.959171295166, 0.679965812949111, -76.9433288574219, -1.34291442600678, 218, 25, 'PPL', 'P'),
(75760, 'Ellaville', 35.101390838623, 0.612634842163346, -96.8091735839844, -1.68963882517525, 218, 42, 'PPL', 'P'),
(46863, 'Ellegood Estates', 38.4341697692871, 0.670802807744529, -75.5741729736328, -1.31901814786161, 218, 25, 'PPL', 'P'),
(86779, 'Ellejoy', 35.809440612793, 0.624992641990613, -83.7552795410156, -1.46180539391897, 218, 50, 'PPL', 'P'),
(155163, 'Ellemans (historical)', 40.0083312988281, 0.69827710939325, -84.3394393920898, -1.47200090667817, 218, 41, 'PPL', 'P'),
(20851, 'Ellen', 33.8005599975586, 0.589931060975284, -84.442497253418, -1.47379960567841, 218, 13, 'PPL', 'P'),
(35743, 'Ellen', 38.0513916015625, 0.664122068412984, -82.7458267211914, -1.44418711856949, 218, 21, 'PPL', 'P'),
(191428, 'Ellen', 34.0213890075684, 0.593785254283874, -101.626106262207, -1.77371016025714, 218, 51, 'PPL', 'P'),
(8727, 'Ellen (historical)', 35.1433296203613, 0.613366811988954, -91.591667175293, -1.59857615959968, 218, 4, 'PPL', 'P'),
(161310, 'Ellen Gowan', 40.8172187805176, 0.712394859226896, -76.1766662597656, -1.32953363942578, 218, 45, 'PPL', 'P'),
(191429, 'Ellen Park Colonia', 31.6529998779297, 0.552449066003236, -106.273002624512, -1.8548138017783, 218, 51, 'PPL', 'P'),
(40787, 'Ellen Place', 30.5513896942139, 0.533222341223896, -91.1341705322266, -1.59059133686135, 218, 22, 'PPL', 'P'),
(64494, 'Ellenboro', 35.3288917541504, 0.616605482190599, -81.7588882446289, -1.42696179263886, 218, 33, 'PPL', 'P'),
(109073, 'Ellenboro', 39.2644386291504, 0.685293733025923, -81.0563888549805, -1.41470086529625, 218, 58, 'PPL', 'P'),
(173983, 'Ellenboro', 42.7833290100098, 0.746709956188676, -90.6136093139648, -1.58150582964449, 218, 57, 'PPL', 'P'),
(46865, 'Ellenborough', 38.7322196960449, 0.676004760301781, -76.1097183227539, -1.32836517749751, 218, 25, 'PPL', 'P'),
(148632, 'Ellenburg', 44.8938903808594, 0.783546201175407, -73.8369369506836, -1.28869765937689, 218, 40, 'PPL', 'P'),
(148633, 'Ellenburg Center', 44.8647193908691, 0.783037071354011, -73.8974990844727, -1.28975466801354, 218, 40, 'PPL', 'P'),
(148634, 'Ellenburg Depot', 44.9058303833008, 0.783754593530706, -73.8013916015625, -1.28807727600096, 218, 40, 'PPL', 'P'),
(13721, 'Ellendale', 38.8069381713867, 0.677308843708566, -75.4230575561523, -1.31638068627605, 218, 10, 'PPL', 'P'),
(40788, 'Ellendale', 29.6319408416748, 0.517174931443405, -90.8091735839844, -1.58491907005559, 218, 22, 'PPL', 'P'),
(54599, 'Ellendale', 38.6130599975586, 0.673925031227511, -90.3122177124023, -1.57624555385936, 218, 29, 'PPL', 'P'),
(64495, 'Ellendale', 35.9255599975586, 0.627019307580163, -81.2797164916992, -1.41859866786769, 218, 33, 'PPL', 'P'),
(86781, 'Ellendale', 35.2305603027344, 0.614889274605125, -89.8258285522461, -1.56775646156863, 218, 50, 'PPL', 'P'),
(101698, 'Ellendale', 36.916389465332, 0.644312544118593, -81.5699996948242, -1.42366506552545, 218, 53, 'PPL', 'P'),
(135192, 'Ellendale', 43.8727798461914, 0.765724460318651, -93.3011093139648, -1.62841155329183, 218, 28, 'PPL', 'P'),
(139957, 'Ellendale', 46.0027809143066, 0.802899992028258, -98.5266723632813, -1.71961483377296, 218, 34, 'PPL', 'P'),
(200765, 'Ellendale', 44.9300003051758, 0.784176438247374, -123.355003356934, -2.15295095738715, 218, 43, 'PPL', 'P'),
(190168, 'Ellendale (historical)', 38.0986099243164, 0.664946183612309, -116.75611114502, -2.03777856130504, 218, 39, 'PPL', 'P'),
(161311, 'Ellendale Forge', 40.3994407653809, 0.705103257320314, -76.852783203125, -1.34133410621593, 218, 45, 'PPL', 'P'),
(72443, 'Ellenora', 39.0833282470703, 0.682132760549081, -84.3747177124023, -1.4726166295222, 218, 41, 'PPL', 'P'),
(139136, 'Ellenorah', 40.3386116027832, 0.704041588151754, -94.331672668457, -1.64639827697812, 218, 29, 'PPL', 'P'),
(207323, 'Ellensburg', 46.9966697692871, 0.820246624946544, -120.546669006348, -2.10393627647257, 218, 56, 'PPL', 'P'),
(15921, 'Ellenton', 27.521390914917, 0.480338886193756, -82.5277786254883, -1.44038146137177, 218, 12, 'PPL', 'P'),
(20852, 'Ellenton', 31.1758308410645, 0.544120895221368, -83.5875015258789, -1.45887711514237, 218, 13, 'PPL', 'P'),
(161312, 'Ellenton', 41.5394401550293, 0.725000000140405, -76.804443359375, -1.34049041678259, 218, 45, 'PPL', 'P'),
(80869, 'Ellenton (historical)', 33.1986083984375, 0.579425023632976, -81.7561111450195, -1.42691332310702, 218, 48, 'PPL', 'P'),
(148636, 'Ellenville', 41.7169418334961, 0.728097988857467, -74.396110534668, -1.2984570795076, 218, 40, 'PPL', 'P'),
(20853, 'Ellenwood', 33.6100006103516, 0.586605172247939, -84.2880630493164, -1.47110422033914, 218, 13, 'PPL', 'P'),
(46866, 'Ellenwood', 38.521671295166, 0.672329997471635, -76.9416732788086, -1.34288553070895, 218, 25, 'PPL', 'P'),
(80862, 'Ellenwood Acres', 34.1694412231445, 0.596369252910551, -82.1875, -1.43444247898284, 218, 48, 'PPL', 'P'),
(20854, 'Ellenwood Homes', 33.6147193908691, 0.586687530504649, -84.3011093139648, -1.47133192061234, 218, 13, 'PPL', 'P'),
(188514, 'Eller Place', 32.0224990844727, 0.558898043740918, -107.972778320313, -1.88448048421541, 218, 38, 'PPL', 'P'),
(64497, 'Ellerbe', 35.0711097717285, 0.61210633784502, -79.7616729736328, -1.39210381028887, 218, 33, 'PPL', 'P'),
(64498, 'Ellerbe Grove', 34.8647193908691, 0.608504146154578, -79.7783279418945, -1.39239449432185, 218, 33, 'PPL', 'P'),
(40789, 'Ellerbe Road Estates', 32.3866691589355, 0.565254010577528, -93.720832824707, -1.63573711050232, 218, 22, 'PPL', 'P'),
(40790, 'Ellerbe Woods', 32.3702812194824, 0.564967987076453, -93.7041702270508, -1.63544629331128, 218, 22, 'PPL', 'P'),
(15922, 'Ellerbee', 30.1052799224854, 0.525436256881913, -82.2055587768555, -1.43475766409785, 218, 12, 'PPL', 'P'),
(80864, 'Ellerbee (historical)', 34.1094398498535, 0.595322031390904, -80.5472183227539, -1.40581416305476, 218, 48, 'PPL', 'P'),
(80865, 'Ellerbees Mill', 34.0677795410156, 0.594594921834285, -80.5319366455078, -1.40554744747159, 218, 48, 'PPL', 'P'),
(20855, 'Ellerbeetown', 32.9099998474121, 0.574387854168173, -84.4569396972656, -1.47405167387559, 218, 13, 'PPL', 'P'),
(15923, 'Ellerslie', 28.3102798461914, 0.494107595477034, -82.149169921875, -1.43377349291701, 218, 12, 'PPL', 'P'),
(20856, 'Ellerslie', 32.6313896179199, 0.569525188333797, -84.8013916015625, -1.48006349372033, 218, 13, 'PPL', 'P'),
(40791, 'Ellerslie', 29.639440536499, 0.517305825810983, -91.5094375610352, -1.59714098208823, 218, 22, 'PPL', 'P'),
(46867, 'Ellerslie', 39.7205581665039, 0.693254520735415, -78.7744369506836, -1.37487329119411, 218, 25, 'PPL', 'P'),
(148637, 'Ellerslie', 41.8941688537598, 0.731191183884567, -73.9433288574219, -1.29055454844695, 218, 40, 'PPL', 'P'),
(161313, 'Ellerslie', 40.1074981689453, 0.700007897785693, -74.9166717529297, -1.30754258672445, 218, 45, 'PPL', 'P'),
(54600, 'Ellerslie (historical)', 38.7208290100098, 0.675805955326407, -92.0944366455078, -1.60735114223343, 218, 29, 'PPL', 'P'),
(46868, 'Ellerslie Heights', 38.5002784729004, 0.671956622286806, -77.0483322143555, -1.34474708031092, 218, 25, 'PPL', 'P'),
(101699, 'Ellerson', 37.6177787780762, 0.656554096964278, -77.3977813720703, -1.35084611868136, 218, 53, 'PPL', 'P'),
(101700, 'Ellerson Mill', 37.5950012207031, 0.656156553592557, -77.3580627441406, -1.35015289784961, 218, 53, 'PPL', 'P'),
(135194, 'Ellerth', 48.3549995422363, 0.843953951812375, -96.4772186279297, -1.68384511822378, 218, 28, 'PPL', 'P'),
(46869, 'Ellerton', 39.5272216796875, 0.68988016247623, -77.5436096191406, -1.35339130173515, 218, 25, 'PPL', 'P'),
(72444, 'Ellerton', 39.6775016784668, 0.692503043254822, -84.309440612793, -1.47147732920786, 218, 41, 'PPL', 'P'),
(75761, 'Ellerville', 36.0311088562012, 0.628861482685199, -94.9019393920898, -1.65635130892007, 218, 42, 'PPL', 'P'),
(27077, 'Ellery', 38.3547210693359, 0.669416166343952, -88.1486129760742, -1.53848352749869, 218, 18, 'PPL', 'P'),
(148638, 'Ellery Center', 42.1827812194824, 0.736228419928397, -79.3472213745117, -1.38487026529405, 218, 40, 'PPL', 'P'),
(59794, 'Elleslie', 32.8730583190918, 0.573743102868265, -91.0513916015625, -1.58914657196998, 218, 30, 'PPL', 'P'),
(155164, 'Ellet', 41.0513916015625, 0.716481945972814, -81.4355621337891, -1.42131868744704, 218, 41, 'PPL', 'P'),
(101701, 'Ellett', 37.1913909912109, 0.649112226193188, -80.366943359375, -1.40266777138489, 218, 53, 'PPL', 'P'),
(101702, 'Elletts Crossing', 37.7983283996582, 0.659705282324115, -77.4697189331055, -1.35210166597728, 218, 53, 'PPL', 'P'),
(29715, 'Ellettsville', 39.2338905334473, 0.684760568175689, -86.625, -1.51189146454009, 218, 19, 'PPL', 'P'),
(148640, 'Ellicott', 42.7344398498535, 0.745856679375415, -78.7316665649414, -1.37412680714056, 218, 40, 'PPL', 'P'),
(181412, 'Ellicott', 36.9216690063477, 0.64440468949231, -121.835830688477, -2.12643639241627, 218, 6, 'PPL', 'P'),
(186683, 'Ellicott', 38.8383293151855, 0.677856722523822, -104.386390686035, -1.82188621174446, 218, 7, 'PPL', 'P'),
(46870, 'Ellicott City', 39.267219543457, 0.68534226913679, -76.7986068725586, -1.34038855087089, 218, 25, 'PPL', 'P'),
(46871, 'Ellicott Hills', 39.2713890075684, 0.685415040013576, -76.8097229003906, -1.34058256215631, 218, 25, 'PPL', 'P'),
(148642, 'Ellicottville', 42.2750015258789, 0.737837967912214, -78.6730575561523, -1.37310388696586, 218, 40, 'PPL', 'P'),
(20857, 'Ellie Spring', 34.9233283996582, 0.609527066329278, -85.166389465332, -1.48643390820586, 218, 13, 'PPL', 'P'),
(54601, 'Elliff', 36.6977806091309, 0.640497099803864, -94.4322204589844, -1.64815316697843, 218, 29, 'PPL', 'P'),
(20858, 'Ellijay', 34.6947212219238, 0.605537118384121, -84.4822235107422, -1.47449295966821, 218, 13, 'PPL', 'P'),
(64499, 'Ellijay', 35.1916694641113, 0.614210501422291, -83.2705612182617, -1.45334546324217, 218, 33, 'PPL', 'P'),
(94009, 'Ellinger', 29.8391704559326, 0.520791770519842, -96.7050018310547, -1.68782068509905, 218, 51, 'PPL', 'P'),
(202097, 'Ellingson (historical)', 45.8666687011719, 0.80052438575688, -102.869438171387, -1.79541039576743, 218, 49, 'PPL', 'P'),
(35744, 'Ellington', 36.7572212219238, 0.641534534206504, -85.4230575561523, -1.49091361147548, 218, 21, 'PPL', 'P'),
(40792, 'Ellington', 29.9055595397949, 0.521950478620622, -90.3805618286133, -1.57743838371161, 218, 22, 'PPL', 'P'),
(54602, 'Ellington', 37.2416687011719, 0.649989737772369, -90.9686126708984, -1.58770180707861, 218, 29, 'PPL', 'P'),
(113378, 'Ellington', 41.9038887023926, 0.731360827246005, -72.4702835083008, -1.2648450570736, 218, 8, 'PPL', 'P'),
(130650, 'Ellington', 43.5538902282715, 0.760158786535522, -83.3213882446289, -1.45423256220127, 218, 27, 'PPL', 'P'),
(148644, 'Ellington', 42.2166709899902, 0.736819908006504, -79.1080627441406, -1.38069615975951, 218, 40, 'PPL', 'P'),
(86780, 'Ellington Park', 35.871940612793, 0.62608347277311, -86.8397216796875, -1.51563906482605, 218, 50, 'PPL', 'P'),
(127422, 'Ellingwood Corner', 44.6749992370605, 0.779725830012661, -68.9188919067383, -1.20286158059866, 218, 26, 'PPL', 'P'),
(32327, 'Ellinor', 38.3933296203613, 0.67009001267877, -96.4277801513672, -1.68298225403059, 218, 20, 'PPL', 'P'),
(15924, 'Ellinor Village', 29.2797203063965, 0.511027523409662, -81.0411071777344, -1.41443414971307, 218, 12, 'PPL', 'P'),
(32328, 'Ellinwood', 38.3555603027344, 0.669430813729948, -98.5805587768555, -1.72055532911192, 218, 20, 'PPL', 'P'),
(46872, 'Elliot', 39.398609161377, 0.68763545057243, -77.2880630493164, -1.34893117269954, 218, 25, 'PPL', 'P'),
(94010, 'Elliot', 30.9536094665527, 0.540242400567831, -96.5683288574219, -1.68543529171067, 218, 51, 'PPL', 'P'),
(109075, 'Elliot (historical)', 38.1791687011719, 0.666352199509816, -80.9894409179688, -1.41353240336797, 218, 58, 'PPL', 'P'),
(181413, 'Elliot (historical)', 37.672779083252, 0.657514033379198, -121.837783813477, -2.12647048087822, 218, 6, 'PPL', 'P'),
(40793, 'Elliot Acres', 30.3630599975586, 0.529935367937979, -90.9902801513672, -1.5880799759534, 218, 22, 'PPL', 'P'),
(40794, 'Elliot City (historical)', 30.5555591583252, 0.533295112100682, -91.6838912963867, -1.60018577416252, 218, 22, 'PPL', 'P'),
(54603, 'Elliot Ford', 36.6624984741211, 0.63988131038081, -91.6222229003906, -1.59910945760797, 218, 29, 'PPL', 'P'),
(127423, 'Elliot Landing', 44.8936080932617, 0.783541274327391, -68.7727813720703, -1.20031147069685, 218, 26, 'PPL', 'P'),
(46873, 'Elliots Place', 38.4363899230957, 0.67084155673839, -75.6833267211914, -1.32092324014739, 218, 25, 'PPL', 'P'),
(2266, 'Elliotsville', 33.2000007629395, 0.579449324977923, -86.8291702270508, -1.51545490723667, 218, 2, 'PPL', 'P'),
(109074, 'Elliotsville', 39.2894401550293, 0.685730091970533, -80.0458297729492, -1.39706328202887, 218, 58, 'PPL', 'P'),
(8728, 'Elliott', 33.457218170166, 0.583938615627469, -92.8277816772461, -1.62015042759041, 218, 4, 'PPL', 'P'),
(29716, 'Elliott', 38.1216697692871, 0.665348653832047, -87.4727783203125, -1.52668798755657, 218, 19, 'PPL', 'P'),
(46874, 'Elliott', 38.310001373291, 0.668635660407477, -75.9966735839844, -1.32639217460393, 218, 25, 'PPL', 'P'),
(54604, 'Elliott', 37.042781829834, 0.646518507028533, -93.7474975585938, -1.63620249790281, 218, 29, 'PPL', 'P'),
(59795, 'Elliott', 33.6833305358887, 0.587885020888803, -89.7491683959961, -1.56641848943697, 218, 30, 'PPL', 'P'),
(64503, 'Elliott', 34.9838905334473, 0.61058407496593, -78.2138900756836, -1.3650899026136, 218, 33, 'PPL', 'P'),
(75762, 'Elliott', 36.9422187805176, 0.644763350712116, -95.6291732788086, -1.66904393467539, 218, 42, 'PPL', 'P'),
(80867, 'Elliott', 34.1069412231445, 0.595278422128054, -80.1638870239258, -1.39912376976426, 218, 48, 'PPL', 'P'),
(94011, 'Elliott', 34.1500015258789, 0.596029966187674, -99.0552825927734, -1.72884082273732, 218, 51, 'PPL', 'P'),
(115454, 'Elliott', 41.149169921875, 0.718188499599337, -95.1636123657227, -1.66091836387345, 218, 16, 'PPL', 'P'),
(119511, 'Elliott', 40.4647216796875, 0.706242624213677, -88.272216796875, -1.54064082113971, 218, 18, 'PPL', 'P'),
(139960, 'Elliott', 46.4022216796875, 0.80987154855084, -97.8144378662109, -1.7071839967528, 218, 34, 'PPL', 'P'),
(161316, 'Elliott', 40.4500007629395, 0.705985695747512, -80.0591735839844, -1.3972961754662, 218, 45, 'PPL', 'P'),
(207324, 'Elliott', 47.4658317565918, 0.828435046350211, -122.138610839844, -2.13172090296731, 218, 56, 'PPL', 'P'),
(181414, 'Elliott (historical)', 38.2347183227539, 0.66732172330466, -121.179718017578, -2.11498506604503, 218, 6, 'PPL', 'P'),
(207325, 'Elliott Ave', 46.5922203063965, 0.81318765016118, -120.66471862793, -2.10599663104991, 218, 56, 'PPL', 'P'),
(181415, 'Elliott Corner', 37.4627799987793, 0.653848857928976, -119.773612976074, -2.0904439034419, 218, 6, 'PPL', 'P'),
(2267, 'Elliott Crossroads', 34.6127815246582, 0.604107000878748, -85.7686080932617, -1.49694460608007, 218, 2, 'PPL', 'P'),
(72445, 'Elliott Crossroads', 39.5308303833008, 0.689943146236011, -81.9438934326172, -1.43019074230253, 218, 41, 'PPL', 'P'),
(200766, 'Elliott Prairie', 45.1361083984375, 0.787773703089799, -122.755561828613, -2.14248872904477, 218, 43, 'PPL', 'P'),
(113381, 'Elliotts', 41.8333282470703, 0.730129314978925, -72.0122222900391, -1.25685038063923, 218, 8, 'PPL', 'P'),
(20860, 'Elliotts Bluff', 30.8455600738525, 0.538356582910432, -81.5616683959961, -1.42351965692993, 218, 13, 'PPL', 'P'),
(161314, 'Elliotts Mill', 40.2102813720703, 0.70180180309597, -77.2727813720703, -1.34866445711637, 218, 45, 'PPL', 'P'),
(161315, 'Elliotts Mills', 41.0349998474121, 0.716195855892712, -80.1436080932617, -1.39876983565539, 218, 45, 'PPL', 'P'),
(20861, 'Elliotts Plantation', 30.8388900756836, 0.538240169481282, -81.5749969482422, -1.42375228405115, 218, 13, 'PPL', 'P'),
(161318, 'Elliottsburg', 40.3888893127441, 0.704919099730935, -77.2891693115234, -1.34895048061744, 218, 45, 'PPL', 'P'),
(161317, 'Elliottson', 40.2000007629395, 0.701622372617526, -77.2727813720703, -1.34866445711637, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(27084, 'Elliottstown', 39.0011100769043, 0.680697782774719, -88.4527816772461, -1.54379227281566, 218, 18, 'PPL', 'P'),
(78208, 'Elliottsville', 39.7694396972656, 0.694107664390622, -79.6266708374023, -1.38974757851442, 218, 45, 'PPL', 'P'),
(35746, 'Elliottville', 38.1827812194824, 0.666415249848624, -83.2758331298828, -1.45343747545783, 218, 21, 'PPL', 'P'),
(72446, 'Elliottville', 39.311939239502, 0.686122775073265, -82.1227798461914, -1.43331289920648, 218, 41, 'PPL', 'P'),
(113382, 'Elliotville (historical)', 41.8416709899902, 0.730274923311525, -71.8300018310547, -1.25367003366546, 218, 8, 'PPL', 'P'),
(2268, 'Ellis', 32.1361083984375, 0.560880900330536, -87.2352828979492, -1.52254291047791, 218, 2, 'PPL', 'P'),
(8729, 'Ellis', 36.2452812194824, 0.632599495591234, -92.2649993896484, -1.61032802369992, 218, 4, 'PPL', 'P'),
(15925, 'Ellis', 30.9325008392334, 0.539873985520532, -85.2361068725586, -1.48765070650791, 218, 12, 'PPL', 'P'),
(20862, 'Ellis', 33.7738914489746, 0.589465606995765, -84.7069396972656, -1.47841499700557, 218, 13, 'PPL', 'P'),
(32330, 'Ellis', 38.938060760498, 0.679597364612298, -99.5602798461914, -1.73765468752299, 218, 20, 'PPL', 'P'),
(40795, 'Ellis', 30.3033294677734, 0.528892873529267, -92.4066696166992, -1.61280063561401, 218, 22, 'PPL', 'P'),
(54605, 'Ellis', 37.8247184753418, 0.660165876034644, -94.4483337402344, -1.64843439678954, 218, 29, 'PPL', 'P'),
(109076, 'Ellis', 38.9377784729004, 0.679592437764281, -80.716667175293, -1.40877160344529, 218, 58, 'PPL', 'P'),
(119512, 'Ellis', 40.355281829834, 0.704332538500845, -87.8850021362305, -1.53388265039947, 218, 18, 'PPL', 'P'),
(122567, 'Ellis', 41.6324996948242, 0.726624195510217, -84.915283203125, -1.48205127715797, 218, 19, 'PPL', 'P'),
(124782, 'Ellis', 42.2138900756836, 0.736771371895637, -71.1916732788086, -1.24252909871928, 218, 23, 'PPL', 'P'),
(135196, 'Ellis', 46.5141716003418, 0.811825443263604, -94.6966705322266, -1.65276869146364, 218, 28, 'PPL', 'P'),
(141749, 'Ellis', 40.2183303833008, 0.701942284843472, -96.8755569458008, -1.69079743340749, 218, 35, 'PPL', 'P'),
(148646, 'Ellis', 42.4252815246582, 0.740460848690806, -76.3816680908203, -1.33311159635031, 218, 40, 'PPL', 'P'),
(155165, 'Ellis', 40.0461082458496, 0.698936441500126, -81.9830627441406, -1.43087437575435, 218, 41, 'PPL', 'P'),
(170231, 'Ellis', 43.5625, 0.76030905540003, -96.8302764892578, -1.690007140354, 218, 49, 'PPL', 'P'),
(173986, 'Ellis', 44.5752792358398, 0.777985387661267, -89.4463882446289, -1.56113397888593, 218, 57, 'PPL', 'P'),
(181416, 'Ellis', 33.7719383239746, 0.589431518533812, -117.218330383301, -2.04584580887911, 218, 6, 'PPL', 'P'),
(194891, 'Ellis', 44.6919403076172, 0.780021507472687, -114.047500610352, -1.99050438932088, 218, 17, 'PPL', 'P'),
(20863, 'Ellis (historical)', 31.6763896942139, 0.552857295308832, -82.7074966430664, -1.44351813250367, 218, 13, 'PPL', 'P'),
(80868, 'Ellis (historical)', 34.1327781677246, 0.595729361879632, -81.773063659668, -1.42720920030413, 218, 48, 'PPL', 'P'),
(193524, 'Ellis (historical)', 40.5583305358887, 0.707876406963413, -122.041389465332, -2.13002406987877, 218, 6, 'PPL', 'P'),
(8731, 'Ellis Chapel', 35.1930618286133, 0.614234802767238, -90.8994369506836, -1.58649446299842, 218, 4, 'PPL', 'P'),
(15926, 'Ellis Church', 30.9650001525879, 0.540441205543205, -85.2397232055664, -1.48771382342575, 218, 12, 'PPL', 'P'),
(59796, 'Ellis Cliffs', 31.4013900756836, 0.54805764652375, -91.4519424438477, -1.59613750298949, 218, 30, 'PPL', 'P'),
(127426, 'Ellis Corner', 44.8027801513672, 0.781956027688521, -69.8300018310547, -1.21876344862557, 218, 26, 'PPL', 'P'),
(170232, 'Ellis Corner', 43.6016693115234, 0.760992688851853, -96.8305587768555, -1.69001206720202, 218, 49, 'PPL', 'P'),
(2269, 'Ellis Crossroads', 31.9780597686768, 0.558122431362946, -86.4513931274414, -1.50886145300985, 218, 2, 'PPL', 'P'),
(64504, 'Ellis Crossroads', 35.7244415283203, 0.623509128105385, -80.4658279418945, -1.40439363292931, 218, 33, 'PPL', 'P'),
(169362, 'Ellis Flats', 41.4558296203613, 0.723540721021096, -71.6986083984375, -1.25137678565079, 218, 47, 'PPL', 'P'),
(101704, 'Ellis Fork', 37.003059387207, 0.645825219617758, -76.9008331298828, -1.34217273564319, 218, 53, 'PPL', 'P'),
(27082, 'Ellis Grove', 38.0088882446289, 0.663380244891342, -89.9058303833008, -1.56915275692815, 218, 18, 'PPL', 'P'),
(86782, 'Ellis Mill', 35.389720916748, 0.61766715135916, -84.373893737793, -1.47260224845231, 218, 50, 'PPL', 'P'),
(86783, 'Ellis Mills', 36.3066711425781, 0.6336709518768, -87.557502746582, -1.52816670775183, 218, 50, 'PPL', 'P'),
(181418, 'Ellis Place', 36.521110534668, 0.637413625314743, -119.018058776855, -2.07725699498826, 218, 6, 'PPL', 'P'),
(20864, 'Ellis Plantation', 33.1094398498535, 0.577868738870961, -82.3386077880859, -1.43707980741035, 218, 13, 'PPL', 'P'),
(20865, 'Ellis Point', 31.2099990844727, 0.544717243568464, -81.5197219848633, -1.42278755394627, 218, 13, 'PPL', 'P'),
(54606, 'Ellis Prairie', 37.413330078125, 0.652985793998709, -92.039436340332, -1.60639120581851, 218, 29, 'PPL', 'P'),
(64505, 'Ellis Store', 35.9691696166992, 0.627780439019708, -76.8797225952148, -1.34180428730638, 218, 33, 'PPL', 'P'),
(64506, 'Ellisboro', 36.3325004577637, 0.634121758470323, -79.9780578613281, -1.39588043903071, 218, 33, 'PPL', 'P'),
(35747, 'Ellisburg', 37.4672203063965, 0.653926355916697, -84.9194412231445, -1.48212384829767, 218, 21, 'PPL', 'P'),
(70782, 'Ellisburg', 39.9136085510254, 0.696623885567556, -75.0108337402344, -1.30918602343314, 218, 37, 'PPL', 'P'),
(148647, 'Ellisburg', 43.732780456543, 0.763281010018504, -76.1363906860352, -1.32883069805606, 218, 40, 'PPL', 'P'),
(161319, 'Ellisburg', 41.9311103820801, 0.731835935184475, -77.8936080932617, -1.35949992748552, 218, 45, 'PPL', 'P'),
(145160, 'Ellisdale', 40.1316719055176, 0.700429809081388, -74.5844421386719, -1.30174408608303, 218, 37, 'PPL', 'P'),
(207326, 'Ellisforde', 48.7900009155273, 0.851546158027, -119.400001525879, -2.08392315351284, 218, 56, 'PPL', 'P'),
(8733, 'Ellison', 34.3436088562012, 0.599409051557794, -91.9019393920898, -1.60399143136024, 218, 4, 'PPL', 'P'),
(109077, 'Ellison', 37.5838890075684, 0.655962608886172, -80.991943359375, -1.41357607920985, 218, 58, 'PPL', 'P'),
(122568, 'Ellison', 41.0277786254883, 0.716069821794124, -85.2558288574219, -1.48799492007881, 218, 19, 'PPL', 'P'),
(199943, 'Ellison', 40.8488883972168, 0.712947598311142, -117.097503662109, -2.04373698476993, 218, 39, 'PPL', 'P'),
(2270, 'Ellison (historical)', 32.0330581665039, 0.559082334488351, -87.7125015258789, -1.53087194678714, 218, 2, 'PPL', 'P'),
(119513, 'Ellison (historical)', 40.7713890075684, 0.711594978793491, -90.7694396972656, -1.58422558290773, 218, 18, 'PPL', 'P'),
(173987, 'Ellison Bay', 45.2547187805176, 0.789843844784145, -87.0713882446289, -1.51968240915106, 218, 57, 'PPL', 'P'),
(178152, 'Ellison Creek Estates', 34.360279083252, 0.599700001906885, -111.183609008789, -1.9405200514534, 218, 5, 'PPL', 'P'),
(178154, 'Ellison Creek Summer Homes', 34.3497200012207, 0.599515711159452, -111.197776794434, -1.94076732596061, 218, 5, 'PPL', 'P'),
(2271, 'Ellison Crossroads', 34.045280456543, 0.594202238731553, -86.3352813720703, -1.50683492057835, 218, 2, 'PPL', 'P'),
(20891, 'Ellison Estates', 33.7938919067383, 0.589814680835647, -84.5824966430664, -1.47624305597856, 218, 13, 'PPL', 'P'),
(178153, 'Ellison Place', 33.0097198486328, 0.576128296519567, -110.315002441406, -1.92536000694812, 218, 5, 'PPL', 'P'),
(59798, 'Ellison Ridge', 33.0677795410156, 0.577141629314342, -88.8811111450195, -1.55126803231162, 218, 30, 'PPL', 'P'),
(109078, 'Ellison Ridge', 37.577220916748, 0.655846228746535, -81.0405578613281, -1.41442456233315, 218, 58, 'PPL', 'P'),
(94013, 'Ellison Springs (historical)', 32.2413597106934, 0.562717882271446, -98.6307601928711, -1.72143150911056, 218, 51, 'PPL', 'P'),
(72447, 'Ellisonville', 38.6044387817383, 0.673774562625922, -82.6469421386719, -1.44246125702507, 218, 41, 'PPL', 'P'),
(207329, 'Ellisport', 47.4205589294434, 0.827644886454784, -122.434173583984, -2.13687944599879, 218, 56, 'PPL', 'P'),
(29718, 'Elliston', 39.0277786254883, 0.681163236754237, -86.970832824707, -1.5179273859927, 218, 19, 'PPL', 'P'),
(35749, 'Elliston', 37.7408294677734, 0.658701736646346, -84.1552810668945, -1.46878673755856, 218, 21, 'PPL', 'P'),
(101705, 'Elliston', 37.2163887023926, 0.649548518558771, -80.232780456543, -1.40032618699643, 218, 53, 'PPL', 'P'),
(155182, 'Elliston', 41.5475006103516, 0.725140681624988, -83.2802810668945, -1.45351510660361, 218, 41, 'PPL', 'P'),
(196425, 'Elliston', 46.5622215270996, 0.81266407269087, -112.430000305176, -1.96227368334355, 218, 31, 'PPL', 'P'),
(59799, 'Ellistown', 34.4447212219238, 0.601173795254135, -88.8408279418945, -1.55056495778384, 218, 30, 'PPL', 'P'),
(148649, 'Ellistown', 42.0086097717285, 0.733188554702126, -76.477783203125, -1.33478912152095, 218, 40, 'PPL', 'P'),
(2274, 'Ellisville', 31.545280456543, 0.550569007431695, -88.2133331298828, -1.53961310727505, 218, 2, 'PPL', 'P'),
(8734, 'Ellisville', 33.7008285522461, 0.588190418886808, -92.3569412231445, -1.61193271141475, 218, 4, 'PPL', 'P'),
(15927, 'Ellisville', 30.0036106109619, 0.523661792647593, -82.5975036621094, -1.44159839283188, 218, 12, 'PPL', 'P'),
(35750, 'Ellisville', 38.3908309936523, 0.67004640341592, -84.0208282470703, -1.46644009316403, 218, 21, 'PPL', 'P'),
(54607, 'Ellisville', 38.5924987792969, 0.673566170270623, -90.5869369506836, -1.58104030908594, 218, 29, 'PPL', 'P'),
(59800, 'Ellisville', 31.603889465332, 0.551591927606394, -89.195556640625, -1.556756141528, 218, 30, 'PPL', 'P'),
(101706, 'Ellisville', 38.0972213745117, 0.664921948846389, -77.9947204589844, -1.36126467118186, 218, 53, 'PPL', 'P'),
(119515, 'Ellisville', 40.6266708374023, 0.709069170236633, -90.3050003051758, -1.5761195863398, 218, 18, 'PPL', 'P'),
(122569, 'Ellisville', 41.0180587768555, 0.715900178432686, -85.2841720581055, -1.48848960225129, 218, 19, 'PPL', 'P'),
(124783, 'Ellisville', 41.8444404602051, 0.73032325968531, -70.5422210693359, -1.23119401932963, 218, 23, 'PPL', 'P'),
(143795, 'Ellisville', 43.0191688537598, 0.750826137969503, -72.1999969482422, -1.26012766667668, 218, 36, 'PPL', 'P'),
(173988, 'Ellisville', 44.4577789306641, 0.775934620463852, -87.6841735839844, -1.53037753093076, 218, 57, 'PPL', 'P'),
(207327, 'Ellisville', 47.5224990844727, 0.829424077800039, -121.756942749023, -2.12505953813269, 218, 56, 'PPL', 'P'),
(113386, 'Ellithorpe', 41.9949989318848, 0.732951000732891, -72.3144378662109, -1.26212503749424, 218, 8, 'PPL', 'P'),
(115457, 'Ellmaker', 40.9727783203125, 0.715109885379205, -92.0824966430664, -1.60714274987813, 218, 16, 'PPL', 'P'),
(35751, 'Ellmitch', 37.6294403076172, 0.656757629050588, -86.6997222900391, -1.5131956145259, 218, 21, 'PPL', 'P'),
(196426, 'Elloam (historical)', 48.8866691589355, 0.853233337156592, -109.388893127441, -1.90919635018605, 218, 31, 'PPL', 'P'),
(80870, 'Elloree', 33.5308303833008, 0.585223391116351, -80.5722198486328, -1.40625052199937, 218, 48, 'PPL', 'P'),
(161322, 'Ellport', 40.8638916015625, 0.713209453625324, -80.2591705322266, -1.40078678070696, 218, 45, 'PPL', 'P'),
(72456, 'Ellsberry', 38.6791687011719, 0.675078845769788, -83.7211074829102, -1.46120897899284, 218, 41, 'PPL', 'P'),
(54608, 'Ellsinore', 36.9341697692871, 0.644622868964615, -90.7466735839844, -1.58382823927309, 218, 29, 'PPL', 'P'),
(135199, 'Ellson', 46.3175010681152, 0.808392894934601, -93.0111083984375, -1.62335008248208, 218, 28, 'PPL', 'P'),
(115458, 'Ellston', 40.8402786254883, 0.712797329446635, -94.1083297729492, -1.64250020809057, 218, 16, 'PPL', 'P'),
(579, 'Ellsworth', 29.673059463501, 0.517892586778154, -90.8150024414063, -1.58502080280923, 218, 22, 'PPL', 'P'),
(29719, 'Ellsworth', 38.4277801513672, 0.670691287873882, -86.7183303833008, -1.51352038702083, 218, 19, 'PPL', 'P'),
(32334, 'Ellsworth', 38.7305603027344, 0.675975798424927, -98.227783203125, -1.71439823382971, 218, 20, 'PPL', 'P'),
(54609, 'Ellsworth', 37.4530601501465, 0.653679214567538, -92.0113906860352, -1.60590171681016, 218, 29, 'PPL', 'P'),
(94014, 'Ellsworth', 33.7044410705566, 0.588253469225616, -96.5808334350586, -1.685653537762, 218, 51, 'PPL', 'P'),
(113388, 'Ellsworth', 41.8300018310547, 0.730071258067161, -73.4274978637695, -1.28155159922388, 218, 8, 'PPL', 'P'),
(115459, 'Ellsworth', 42.3127784729004, 0.73849730001909, -93.57861328125, -1.63325491120831, 218, 16, 'PPL', 'P'),
(119517, 'Ellsworth', 40.4502792358398, 0.705990556016501, -88.716667175293, -1.54839794360484, 218, 18, 'PPL', 'P'),
(127427, 'Ellsworth', 44.5433311462402, 0.777427788308032, -68.4199981689453, -1.19415424225659, 218, 26, 'PPL', 'P'),
(130654, 'Ellsworth', 45.1655616760254, 0.788287759759212, -85.2461090087891, -1.48782527671737, 218, 27, 'PPL', 'P'),
(135200, 'Ellsworth', 43.5180587768555, 0.759533409732544, -96.0180587768555, -1.67583126702957, 218, 28, 'PPL', 'P'),
(143793, 'Ellsworth', 43.8738899230957, 0.765743834815582, -71.7369384765625, -1.25204577171662, 218, 36, 'PPL', 'P'),
(155166, 'Ellsworth', 41.024169921875, 0.716006838034344, -80.8574981689453, -1.41122956797338, 218, 41, 'PPL', 'P'),
(161321, 'Ellsworth', 40.1119384765625, 0.700085395773414, -80.0175018310547, -1.3965688661725, 218, 45, 'PPL', 'P'),
(173989, 'Ellsworth', 44.7322196960449, 0.780724515421441, -92.4872207641602, -1.61420651835346, 218, 57, 'PPL', 'P'),
(199300, 'Ellsworth', 42.0586090087891, 0.734061206012318, -102.280281066895, -1.78512766448253, 218, 35, 'PPL', 'P'),
(207328, 'Ellsworth', 45.6041717529297, 0.795942949733617, -122.563056945801, -2.13912888501353, 218, 56, 'PPL', 'P'),
(8735, 'Ellsworth (historical)', 35.290828704834, 0.615941156656679, -93.5580596923828, -1.63289618340947, 218, 4, 'PPL', 'P'),
(190171, 'Ellsworth (historical)', 38.9730606079102, 0.680208227187335, -117.753890991211, -2.05519310483112, 218, 39, 'PPL', 'P'),
(127428, 'Ellsworth Falls', 44.5622215270996, 0.777757487650984, -68.4391708374023, -1.19448886844756, 218, 26, 'PPL', 'P'),
(15928, 'Ellsworth Junction', 28.7633304595947, 0.502014820359102, -81.725830078125, -1.4263848187887, 218, 12, 'PPL', 'P'),
(161323, 'Ellwell', 41.5750007629395, 0.725620649832448, -76.2638931274414, -1.33105603546293, 218, 45, 'PPL', 'P'),
(20866, 'Ellwood', 33.3041687011719, 0.581267398475093, -82.1294403076172, -1.43342914618806, 218, 13, 'PPL', 'P'),
(35752, 'Ellwood', 37.3244400024414, 0.651434369505683, -82.57861328125, -1.44126869348893, 218, 21, 'PPL', 'P'),
(46875, 'Ellwood', 38.6866683959961, 0.675209740137365, -75.8877792358398, -1.32449160969199, 218, 25, 'PPL', 'P'),
(80871, 'Ellwood', 33.1108283996582, 0.577892973636881, -79.936393737793, -1.39515326289506, 218, 48, 'PPL', 'P'),
(181419, 'Ellwood', 34.4316711425781, 0.600946028401906, -119.886940002441, -2.0924218331835, 218, 6, 'PPL', 'P'),
(161324, 'Ellwood City', 40.8616714477539, 0.713170704631464, -80.2866668701172, -1.4012666823354, 218, 45, 'PPL', 'P'),
(59801, 'Ellwood Landing', 32.7055587768555, 0.570819684360657, -90.6872177124023, -1.58279053855434, 218, 30, 'PPL', 'P'),
(148650, 'Ellwood Park', 42.9755592346191, 0.750065006529958, -78.8533325195313, -1.37625027863574, 218, 40, 'PPL', 'P'),
(101707, 'Elly', 38.3380584716797, 0.669125349152916, -78.2074966430664, -1.36497831616392, 218, 53, 'PPL', 'P'),
(15929, 'Ellzey', 29.3108291625977, 0.511570475376901, -82.7936096191406, -1.44502108746485, 218, 12, 'PPL', 'P'),
(54610, 'Elm', 38.853328704834, 0.678118511258977, -94.0422210693359, -1.64134639354829, 218, 29, 'PPL', 'P'),
(70789, 'Elm', 39.6791687011719, 0.692532138289731, -74.8294372558594, -1.30602005752926, 218, 37, 'PPL', 'P'),
(130656, 'Elm', 42.3766708374023, 0.739612432146533, -83.3313903808594, -1.45440713241073, 218, 27, 'PPL', 'P'),
(161326, 'Elm', 40.2038917541504, 0.701690283225323, -76.3491668701172, -1.33254434303812, 218, 45, 'PPL', 'P'),
(194173, 'Elm', 40.3536109924316, 0.704303376886909, -104.783332824707, -1.82881415900419, 218, 7, 'PPL', 'P'),
(8737, 'Elm (historical)', 34.3277816772461, 0.599132815173726, -93.3902816772461, -1.62996790463288, 218, 4, 'PPL', 'P'),
(155168, 'Elm (historical)', 40.311939239502, 0.703576067593208, -81.4102783203125, -1.42087740165441, 218, 41, 'PPL', 'P'),
(80872, 'Elm Abode', 34.0316696166992, 0.593964684762318, -81.0819396972656, -1.41514681162078, 218, 48, 'PPL', 'P'),
(148651, 'Elm Beach', 42.7011108398438, 0.745274978414314, -76.745002746582, -1.33945298237995, 218, 40, 'PPL', 'P'),
(2276, 'Elm Bluff', 32.1527786254883, 0.561171850679627, -87.0719375610352, -1.51969199653098, 218, 2, 'PPL', 'P'),
(155169, 'Elm Center', 41.1022186279297, 0.717369044931919, -84.0930633544922, -1.46770083362408, 218, 41, 'PPL', 'P'),
(64507, 'Elm City', 35.8063888549805, 0.624939378768812, -77.8636093139648, -1.35897635001521, 218, 33, 'PPL', 'P'),
(141751, 'Elm Creek', 40.7194404602051, 0.710688305600374, -99.3716735839844, -1.7343628872576, 218, 35, 'PPL', 'P'),
(191430, 'Elm Creek', 28.774169921875, 0.502204004665038, -100.491386413574, -1.75390556281077, 218, 51, 'PPL', 'P'),
(191434, 'Elm Creek Number 1 Colonia', 28.7740001678467, 0.502201041898326, -100.500999450684, -1.75407334195944, 218, 51, 'PPL', 'P'),
(191431, 'Elm Creek Number 2 Colonia', 28.7770004272461, 0.502253406303259, -100.504997253418, -1.75414311678, 218, 51, 'PPL', 'P'),
(135204, 'Elm Estates', 45.392219543457, 0.792243685821442, -92.8552780151367, -1.62063032921884, 218, 28, 'PPL', 'P'),
(101708, 'Elm Farm Mobile Home Park', 38.6597213745117, 0.674739425888857, -77.3213882446289, -1.34951280708161, 218, 53, 'PPL', 'P'),
(94015, 'Elm Flat', 32.083610534668, 0.559964639757494, -96.3000030517578, -1.68075212293376, 218, 51, 'PPL', 'P'),
(8738, 'Elm Grove', 35.728889465332, 0.62358675925116, -90.4841690063477, -1.57924667009177, 218, 4, 'PPL', 'P'),
(40796, 'Elm Grove', 32.3480606079102, 0.564580164242711, -93.5524978637695, -1.63279911118774, 218, 22, 'PPL', 'P'),
(64509, 'Elm Grove', 35.1452789306641, 0.61340083387188, -77.5366668701172, -1.35327012790555, 218, 33, 'PPL', 'P'),
(72448, 'Elm Grove', 39.0463905334473, 0.6814880758282, -83.1638870239258, -1.45148364732409, 218, 41, 'PPL', 'P'),
(78209, 'Elm Grove', 39.9888916015625, 0.697937822670374, -79.6986083984375, -1.39100312581034, 218, 45, 'PPL', 'P'),
(86784, 'Elm Grove', 35.5727806091309, 0.620862145718928, -89.8125, -1.56752383444741, 218, 50, 'PPL', 'P'),
(94021, 'Elm Grove', 29.8905601501465, 0.521688689885467, -97.4872207641602, -1.70147298095318, 218, 51, 'PPL', 'P'),
(113406, 'Elm Grove', 40.0455589294434, 0.698926854120202, -80.6516723632813, -1.40763722997897, 218, 58, 'PPL', 'P'),
(124785, 'Elm Grove', 42.7097206115723, 0.745425247278822, -72.7041702270508, -1.26892715039247, 218, 23, 'PPL', 'P'),
(148652, 'Elm Grove', 42.5552787780762, 0.742729728781499, -75.225830078125, -1.31293841740906, 218, 40, 'PPL', 'P'),
(173992, 'Elm Grove', 43.0430603027344, 0.751243122417182, -88.0788879394531, -1.53726659603858, 218, 57, 'PPL', 'P'),
(27085, 'Elm Grove (historical)', 37.9949989318848, 0.663137830653118, -88.1247177124023, -1.53806647647199, 218, 18, 'PPL', 'P'),
(135205, 'Elm Grove Mobile Home Park', 45.2627792358398, 0.789984526268728, -94.1241683959961, -1.64277664421172, 218, 28, 'PPL', 'P'),
(40798, 'Elm Hall', 29.9338893890381, 0.522444927766508, -91.0505599975586, -1.58913205774204, 218, 22, 'PPL', 'P'),
(130657, 'Elm Hall', 43.3650016784668, 0.756862059422113, -84.8352813720703, -1.48065498179844, 218, 27, 'PPL', 'P'),
(40799, 'Elm Hall Junction', 29.9200000762939, 0.522202513528284, -91.0419387817383, -1.58898158914045, 218, 22, 'PPL', 'P'),
(86785, 'Elm Hill', 35.3905601501465, 0.617681798745155, -85.3324966430664, -1.48933302536852, 218, 50, 'PPL', 'P'),
(113393, 'Elm Hill', 41.6744384765625, 0.727356165335825, -72.7452774047852, -1.26964460599014, 218, 8, 'PPL', 'P'),
(32342, 'Elm Hollow Corner', 39.1894416809082, 0.683984789350149, -96.7119369506836, -1.68794172577059, 218, 20, 'PPL', 'P'),
(32343, 'Elm Mills', 37.4338912963867, 0.653344654955597, -98.6866683959961, -1.72240729133396, 218, 20, 'PPL', 'P'),
(94022, 'Elm Mott', 31.6716709136963, 0.552774937052121, -97.0986099243164, -1.69469044228896, 218, 51, 'PPL', 'P'),
(8739, 'Elm Park', 35.0213890075684, 0.611238546803817, -94.1188888549805, -1.642684498838, 218, 4, 'PPL', 'P'),
(40800, 'Elm Park', 30.8261108398438, 0.538017129739988, -91.3341674804688, -1.59408194210211, 218, 22, 'PPL', 'P'),
(135206, 'Elm Park', 45.6730613708496, 0.797145300386761, -93.2758331298828, -1.62797040065726, 218, 28, 'PPL', 'P'),
(148653, 'Elm Park', 40.6313896179199, 0.709151528493343, -74.149169921875, -1.29414715275747, 218, 40, 'PPL', 'P'),
(54611, 'Elm Point', 38.8180618286133, 0.677502988152033, -90.4869384765625, -1.57929500646556, 218, 29, 'PPL', 'P'),
(27086, 'Elm Point (historical)', 39.0058288574219, 0.68078014103143, -89.4736099243164, -1.5616090868244, 218, 18, 'PPL', 'P'),
(94023, 'Elm Ridge', 30.8473701477051, 0.538388174658863, -97.0412063598633, -1.69368856108688, 218, 51, 'PPL', 'P'),
(115464, 'Elm Spring', 43.3105583190918, 0.755911843545173, -96.4911117553711, -1.68408759904103, 218, 16, 'PPL', 'P'),
(8740, 'Elm Springs', 36.2061080932617, 0.631915795560383, -94.2341690063477, -1.64469651704156, 218, 4, 'PPL', 'P'),
(86786, 'Elm Springs', 36.336109161377, 0.634184742230103, -83.600830078125, -1.45910974226359, 218, 50, 'PPL', 'P'),
(202098, 'Elm Springs', 44.3133316040039, 0.773413539017928, -102.527221679688, -1.78943759123266, 218, 49, 'PPL', 'P'),
(124784, 'Elm Square', 42.0166702270508, 0.73332923618671, -71.0208282470703, -1.23954729040477, 218, 23, 'PPL', 'P'),
(8742, 'Elm Store', 36.4808311462402, 0.636710617365989, -91.1872177124023, -1.59151718481431, 218, 4, 'PPL', 'P'),
(177217, 'Elm Terrace', 40.0325012207031, 0.698698954109919, -80.6641693115234, -1.40785534287225, 218, 58, 'PPL', 'P'),
(148654, 'Elm Tree', 42.1558303833008, 0.735758039100862, -79.4741668701172, -1.38708588216294, 218, 40, 'PPL', 'P'),
(173994, 'Elm Tree Corners', 44.5547218322754, 0.777626593283406, -88.0980606079102, -1.53760122222955, 218, 57, 'PPL', 'P'),
(122570, 'Elm Tree Crossroads', 40.788330078125, 0.711890656253517, -84.9561080932617, -1.48276380590762, 218, 19, 'PPL', 'P'),
(135207, 'Elm Tree Mobile Home Park', 43.6669387817383, 0.762131856008134, -94.6191711425781, -1.65141607194599, 218, 28, 'PPL', 'P'),
(148655, 'Elm Valley', 42.1511116027832, 0.735675680844151, -77.8586120605469, -1.35888913148951, 218, 40, 'PPL', 'P'),
(94024, 'Elm View', 33.4944381713867, 0.584588227196367, -96.7352828979492, -1.68834918941738, 218, 51, 'PPL', 'P'),
(181421, 'Elm View', 36.5475006103516, 0.637874219025272, -119.790283203125, -2.09073485379099, 218, 6, 'PPL', 'P'),
(101709, 'Elma', 37.7536087036133, 0.65892477638764, -78.795280456543, -1.37523707899902, 218, 53, 'PPL', 'P'),
(115465, 'Elma', 43.2466697692871, 0.754796777996757, -92.4358291625977, -1.61330956569832, 218, 16, 'PPL', 'P'),
(148656, 'Elma', 42.850830078125, 0.7478880720759, -78.6405563354492, -1.37253663365368, 218, 40, 'PPL', 'P'),
(207330, 'Elma', 47.0036087036133, 0.820367732197115, -123.407501220703, -2.15386721796019, 218, 56, 'PPL', 'P'),
(148657, 'Elma Center', 42.829719543457, 0.747519623739088, -78.6363906860352, -1.37246392935592, 218, 40, 'PPL', 'P'),
(94025, 'Elmaton', 28.8861103057861, 0.504157732930234, -96.1397171020508, -1.67795460536669, 218, 51, 'PPL', 'P'),
(148659, 'Elmbois', 42.4841690063477, 0.741488629134494, -77.2302780151367, -1.34792263359473, 218, 40, 'PPL', 'P'),
(161328, 'Elmbrook Terrace', 41.3588905334473, 0.721848814780569, -75.567497253418, -1.31890163456392, 218, 45, 'PPL', 'P'),
(35753, 'Elmburg', 38.3211097717285, 0.668829538534835, -85.0713882446289, -1.48477582411117, 218, 21, 'PPL', 'P'),
(181422, 'Elmco', 35.9925003051758, 0.628187636350381, -119.041938781738, -2.07767377969886, 218, 6, 'PPL', 'P'),
(148660, 'Elmcrest', 43.1330604553223, 0.752813921407138, -76.2361068725586, -1.33057107382842, 218, 40, 'PPL', 'P'),
(32346, 'Elmdale', 38.3736114501953, 0.669745865686904, -96.6444396972656, -1.6867636764624, 218, 20, 'PPL', 'P'),
(94026, 'Elmdale', 32.4305610656738, 0.566020068865089, -99.6394424438477, -1.73903633549653, 218, 51, 'PPL', 'P'),
(122571, 'Elmdale', 40.1366691589355, 0.700517027607089, -87.0175018310547, -1.5187419138121, 218, 19, 'PPL', 'P'),
(130659, 'Elmdale', 42.8536109924316, 0.747936608186767, -85.3111114501953, -1.48895978334174, 218, 27, 'PPL', 'P'),
(135208, 'Elmdale', 45.8333282470703, 0.799942485058698, -94.4922180175781, -1.64920032191905, 218, 28, 'PPL', 'P'),
(148661, 'Elmdale', 44.360279083252, 0.774232927106318, -75.5436096191406, -1.31848471669526, 218, 40, 'PPL', 'P'),
(161329, 'Elmdale', 41.4116706848145, 0.722770002201627, -75.4608306884766, -1.3170399518039, 218, 45, 'PPL', 'P'),
(169363, 'Elmdale (historical)', 41.8394393920898, 0.730235974580583, -71.6097183227539, -1.24982536115777, 218, 47, 'PPL', 'P'),
(20867, 'Elmdale Estates', 32.5511093139648, 0.568124032705279, -83.6388931274414, -1.45977406779751, 218, 13, 'PPL', 'P'),
(40801, 'Elmelhine', 31.1155605316162, 0.5430689798803, -92.6900024414063, -1.61774572628412, 218, 22, 'PPL', 'P'),
(94027, 'Elmendorf', 29.2558307647705, 0.510610572251496, -98.3324966430664, -1.71622582812778, 218, 51, 'PPL', 'P'),
(32348, 'Elmer', 37.9694404602051, 0.66269175117053, -97.9300003051758, -1.70920094180437, 218, 20, 'PPL', 'P'),
(40803, 'Elmer', 31.1322193145752, 0.543359730492309, -92.6808319091797, -1.61758567030261, 218, 22, 'PPL', 'P'),
(46876, 'Elmer', 39.1361083984375, 0.683053947970139, -77.48388671875, -1.35234894048449, 218, 25, 'PPL', 'P'),
(54612, 'Elmer', 39.9569396972656, 0.697380156738111, -92.6502838134766, -1.61705250545237, 218, 29, 'PPL', 'P'),
(70783, 'Elmer', 39.5950012207031, 0.691063138632444, -75.1705627441406, -1.31197382046224, 218, 37, 'PPL', 'P'),
(75765, 'Elmer', 34.4811096191406, 0.601808892595092, -99.3505630493164, -1.73399443892079, 218, 42, 'PPL', 'P'),
(130660, 'Elmer', 43.4197196960449, 0.757817068989015, -82.9291687011719, -1.44738703977728, 218, 27, 'PPL', 'P'),
(135211, 'Elmer', 47.1036109924316, 0.822113101396526, -92.7769393920898, -1.61926306231519, 218, 28, 'PPL', 'P'),
(161330, 'Elmer', 41.9194412231445, 0.731632269940111, -77.6236114501953, -1.35478759709468, 218, 45, 'PPL', 'P'),
(207331, 'Elmer City', 47.9980583190918, 0.837724152232407, -118.953330993652, -2.07612728205385, 218, 56, 'PPL', 'P'),
(148662, 'Elmer Hill', 43.2797203063965, 0.755373618688868, -75.4499969482422, -1.3168508673665, 218, 40, 'PPL', 'P'),
(40804, 'Elmfield', 29.9366703033447, 0.522493463877375, -90.9952774047852, -1.5881671944791, 218, 22, 'PPL', 'P'),
(94028, 'Elmgrove', 29.4630603790283, 0.514227411327933, -94.6738891601563, -1.6523710815129, 218, 51, 'PPL', 'P'),
(148663, 'Elmgrove', 43.1816711425781, 0.75366233795141, -77.7319412231445, -1.35667830831058, 218, 40, 'PPL', 'P'),
(13723, 'Elmhurst', 39.7305603027344, 0.69342909094487, -75.5902786254883, -1.31929924451466, 218, 10, 'PPL', 'P'),
(32349, 'Elmhurst', 38.9744415283203, 0.6802323287952, -94.6847229003906, -1.65256016595029, 218, 20, 'PPL', 'P'),
(46877, 'Elmhurst', 39.1399993896484, 0.683121858577936, -76.663330078125, -1.33802752540648, 218, 25, 'PPL', 'P'),
(101710, 'Elmhurst', 36.8833312988281, 0.643735570268427, -76.2305603027344, -1.3304742679228, 218, 53, 'PPL', 'P'),
(109079, 'Elmhurst', 37.6336097717285, 0.656830399927374, -80.6297225952148, -1.40725413425617, 218, 58, 'PPL', 'P'),
(119520, 'Elmhurst', 41.8994407653809, 0.731283196100229, -87.9402770996094, -1.53484738050435, 218, 18, 'PPL', 'P'),
(122572, 'Elmhurst', 40.0977783203125, 0.699838254424255, -85.7213897705078, -1.49612049088075, 218, 19, 'PPL', 'P'),
(130673, 'Elmhurst', 45.4961090087891, 0.794056899049623, -84.688606262207, -1.4780950182006, 218, 27, 'PPL', 'P'),
(148665, 'Elmhurst', 40.7363891601563, 0.710984116218454, -73.8783264160156, -1.28942004182257, 218, 40, 'PPL', 'P'),
(161331, 'Elmhurst', 41.3777809143066, 0.722178514123521, -75.5449981689453, -1.31850895146118, 218, 45, 'PPL', 'P'),
(173995, 'Elmhurst', 45.0583305358887, 0.786416223303158, -89.1841735839844, -1.55655746971068, 218, 57, 'PPL', 'P'),
(46878, 'Elmhurst Estates', 39.1441688537598, 0.683194629454723, -76.6686096191406, -1.3381196707802, 218, 25, 'PPL', 'P'),
(46879, 'Elmhurst Ridge', 39.1425018310547, 0.683165534419814, -76.6547164916992, -1.33787718996295, 218, 25, 'PPL', 'P'),
(94029, 'Elmina', 30.559440612793, 0.533362856260911, -95.4752807617188, -1.66635800355799, 218, 51, 'PPL', 'P'),
(101711, 'Elmington', 37.4244384765625, 0.653179672126066, -76.4558334350586, -1.33440602579814, 218, 53, 'PPL', 'P'),
(54613, 'Elmira', 39.5072212219238, 0.689531088636348, -94.1544418334961, -1.64330501537199, 218, 29, 'PPL', 'P'),
(109080, 'Elmira', 38.6513900756836, 0.674594017293339, -80.9911117553711, -1.41356156498191, 218, 58, 'PPL', 'P'),
(115466, 'Elmira', 41.7227783203125, 0.728199854769162, -91.4247207641602, -1.59566239505102, 218, 16, 'PPL', 'P'),
(119521, 'Elmira', 41.1797218322754, 0.718721731028598, -89.831672668457, -1.56785846063838, 218, 18, 'PPL', 'P'),
(122573, 'Elmira', 41.5919418334961, 0.725916327292474, -85.2044372558594, -1.48709796742367, 218, 19, 'PPL', 'P'),
(130663, 'Elmira', 45.0644416809082, 0.786522882904816, -84.8561096191406, -1.48101850328724, 218, 27, 'PPL', 'P'),
(148666, 'Elmira', 42.0897216796875, 0.734604224558585, -76.8080596923828, -1.34055353370042, 218, 40, 'PPL', 'P'),
(155170, 'Elmira', 41.5791702270508, 0.725693420709234, -84.3083267211914, -1.47145788813191, 218, 41, 'PPL', 'P'),
(181424, 'Elmira', 38.348331451416, 0.669304646473305, -121.908889770508, -2.1277115139462, 218, 6, 'PPL', 'P'),
(194894, 'Elmira', 48.4797210693359, 0.846130753108378, -116.461387634277, -2.03263466565955, 218, 17, 'PPL', 'P'),
(200767, 'Elmira', 44.0658302307129, 0.769093825150792, -123.35417175293, -2.15293644315921, 218, 43, 'PPL', 'P'),
(54614, 'Elmira Camp', 39.4963912963867, 0.68934207077798, -94.1575012207031, -1.64335841175185, 218, 29, 'PPL', 'P'),
(64510, 'Elmira Crossroads', 35.4291687011719, 0.618355645079972, -77.2022171020508, -1.34743287827026, 218, 33, 'PPL', 'P'),
(148667, 'Elmira Heights', 42.1297187805176, 0.735302305659322, -76.8211135864258, -1.34078136713168, 218, 40, 'PPL', 'P'),
(8744, 'Elmo', 35.6208305358887, 0.621700775146193, -91.3916702270508, -1.59508555435891, 218, 4, 'PPL', 'P'),
(32350, 'Elmo', 38.6841697692871, 0.675166130874515, -97.2297210693359, -1.69697876345561, 218, 20, 'PPL', 'P'),
(59802, 'Elmo', 31.6216697692871, 0.551902252452416, -90.9383316040039, -1.58717330276028, 218, 30, 'PPL', 'P'),
(94035, 'Elmo', 32.7219390869141, 0.571105574703677, -96.1647186279297, -1.6783909643113, 218, 51, 'PPL', 'P'),
(101712, 'Elmo', 36.6763916015625, 0.640123791198062, -79.1224975585938, -1.38094809479864, 218, 53, 'PPL', 'P'),
(139138, 'Elmo', 40.5183296203613, 0.707178259283649, -95.1152801513672, -1.66007480759817, 218, 29, 'PPL', 'P'),
(161333, 'Elmo', 41.273609161377, 0.720360374047323, -79.5377807617188, -1.3881961540214, 218, 45, 'PPL', 'P'),
(173996, 'Elmo', 42.6427803039551, 0.744256918508604, -90.4358291625977, -1.57840298065844, 218, 57, 'PPL', 'P'),
(181425, 'Elmo', 35.6794395446777, 0.622723695320893, -119.329437255859, -2.08269157466673, 218, 6, 'PPL', 'P'),
(192553, 'Elmo', 39.389720916748, 0.687480321438933, -110.814437866211, -1.93407679951206, 218, 52, 'PPL', 'P'),
(193168, 'Elmo', 47.8305587768555, 0.8348007337248, -114.348609924316, -1.99575973825799, 218, 31, 'PPL', 'P'),
(209435, 'Elmo', 41.8788909912109, 0.730924534880423, -106.53556060791, -1.859396303066, 218, 59, 'PPL', 'P'),
(20868, 'Elmodel', 31.3455600738525, 0.547083229170404, -84.4725036621094, -1.47432331630678, 218, 13, 'PPL', 'P'),
(200768, 'Elmonica', 45.5127792358398, 0.794347849398714, -122.853607177734, -2.1441999432032, 218, 43, 'PPL', 'P'),
(32351, 'Elmont', 39.1652793884277, 0.683563077791535, -95.7027816772461, -1.67032864358525, 218, 20, 'PPL', 'P'),
(54615, 'Elmont', 38.2355613708496, 0.667336437269682, -91.2425003051758, -1.59248204807725, 218, 29, 'PPL', 'P'),
(94030, 'Elmont', 33.422779083252, 0.583337540169439, -96.6374969482422, -1.6866425026328, 218, 51, 'PPL', 'P'),
(101713, 'Elmont', 37.711109161377, 0.658183019445025, -77.4927825927734, -1.35250420277604, 218, 53, 'PPL', 'P'),
(148670, 'Elmont', 40.7008285522461, 0.710363466526411, -73.7133331298828, -1.28654036573587, 218, 40, 'PPL', 'P'),
(145162, 'Elmora', 40.6622200012207, 0.709689620191594, -74.227783203125, -1.29551921335107, 218, 37, 'PPL', 'P'),
(161334, 'Elmora', 40.6016693115234, 0.708632811292023, -78.7466735839844, -1.37438872903377, 218, 45, 'PPL', 'P'),
(64511, 'Elmore', 34.7944412231445, 0.607277560735515, -79.5088882446289, -1.38769188446899, 218, 33, 'PPL', 'P'),
(86788, 'Elmore', 36.1183280944824, 0.630383745564288, -85.0794372558594, -1.48491630585868, 218, 50, 'PPL', 'P'),
(109086, 'Elmore', 37.5666694641113, 0.655662071157156, -81.4055633544922, -1.42079510997673, 218, 58, 'PPL', 'P'),
(112205, 'Elmore', 32.5386085510254, 0.567905853232974, -86.3150024414063, -1.50648098646948, 218, 2, 'PPL', 'P'),
(119523, 'Elmore', 40.9566688537598, 0.71482872214712, -89.976936340332, -1.57039378999613, 218, 18, 'PPL', 'P'),
(127430, 'Elmore', 43.9602813720703, 0.767251650045757, -69.1963882446289, -1.20770480535707, 218, 26, 'PPL', 'P'),
(135216, 'Elmore', 43.5050010681152, 0.759305509722261, -94.0877838134766, -1.64214161344979, 218, 28, 'PPL', 'P'),
(139968, 'Elmore', 46.1958312988281, 0.806269356860399, -96.6050033569336, -1.68607538247867, 218, 34, 'PPL', 'P'),
(155171, 'Elmore', 41.4761085510254, 0.723894655129968, -83.2958297729492, -1.45378648271868, 218, 41, 'PPL', 'P'),
(173997, 'Elmore', 43.5750007629395, 0.760527234872335, -88.3027801513672, -1.54117425230605, 218, 57, 'PPL', 'P'),
(202099, 'Elmore', 44.315559387207, 0.773452421169843, -103.886940002441, -1.81316915286441, 218, 49, 'PPL', 'P'),
(8745, 'Elmore (historical)', 34.276668548584, 0.598240722787576, -92.8694381713867, -1.620877470568, 218, 4, 'PPL', 'P'),
(20869, 'Elmore (historical)', 33.1136093139648, 0.577941509747747, -82.0891723632813, -1.43272633797639, 218, 13, 'PPL', 'P'),
(193525, 'Elmore (historical)', 40.8102798461914, 0.712273751976325, -122.393890380859, -2.13617637147101, 218, 6, 'PPL', 'P'),
(75767, 'Elmore City', 34.6227798461914, 0.604281504509176, -97.396110534668, -1.69988280746629, 218, 42, 'PPL', 'P'),
(64529, 'Elmore Crossroads', 34.792781829834, 0.60724859885866, -79.5119400024414, -1.38774514769079, 218, 33, 'PPL', 'P'),
(181426, 'Elmore Desert Ranch', 33.1036109924316, 0.57776700611732, -115.79972076416, -2.02108640022464, 218, 6, 'PPL', 'P'),
(86794, 'Elmore Park', 35.1994400024414, 0.614346122900803, -89.8566665649414, -1.56829468642493, 218, 50, 'PPL', 'P'),
(64512, 'Elmores Crossroads', 35.2227783203125, 0.614753453389531, -81.1011123657227, -1.41548143781175, 218, 33, 'PPL', 'P'),
(119524, 'Elmoville', 42.2655601501465, 0.737673184819765, -90.0469436645508, -1.57161564830426, 218, 18, 'PPL', 'P'),
(35755, 'Elmrock', 37.452220916748, 0.653664567181543, -83.0258331298828, -1.44907415232784, 218, 21, 'PPL', 'P'),
(127431, 'Elms', 43.3411102294922, 0.756445074974434, -70.5644378662109, -1.23158177558434, 218, 26, 'PPL', 'P'),
(155172, 'Elms Acres', 40.7961082458496, 0.712026410890084, -81.5963897705078, -1.42412565923598, 218, 41, 'PPL', 'P'),
(46880, 'Elms Beach', 38.1911087036133, 0.666560591865115, -76.3630599975586, -1.33278682385537, 218, 25, 'PPL', 'P'),
(148671, 'Elmsford', 41.0550003051758, 0.716544929732594, -73.820556640625, -1.28841176903387, 218, 40, 'PPL', 'P'),
(173998, 'Elmside', 43.0922203063965, 0.752101126341378, -89.3438873291016, -1.55934500042366, 218, 57, 'PPL', 'P'),
(20870, 'Elmside Village', 33.9513893127441, 0.5925635291338, -84.2541732788086, -1.47051273226104, 218, 13, 'PPL', 'P'),
(148672, 'Elmsmere', 40.9283294677734, 0.714334106553665, -73.8211135864258, -1.28842148957185, 218, 40, 'PPL', 'P'),
(94031, 'Elmtown', 31.8958301544189, 0.556687253851502, -95.6283264160156, -1.66902915413134, 218, 51, 'PPL', 'P'),
(20871, 'Elmview', 32.3111114501953, 0.563935279784748, -84.5630569458008, -1.47590376925568, 218, 13, 'PPL', 'P'),
(155173, 'Elmview', 40.6863899230957, 0.710111464908262, -84.1511077880859, -1.46871390010274, 218, 41, 'PPL', 'P'),
(35758, 'Elmville', 38.3411102294922, 0.669178612374717, -84.7613906860352, -1.47936534604057, 218, 21, 'PPL', 'P'),
(72449, 'Elmville', 39.064998626709, 0.681812848323135, -83.4519424438477, -1.45651116282994, 218, 41, 'PPL', 'P'),
(113398, 'Elmville', 41.8313903808594, 0.730095492833081, -71.8769378662109, -1.25448922201677, 218, 8, 'PPL', 'P'),
(8748, 'Elmwood', 34.228328704834, 0.597397033354239, -91.7205581665039, -1.60082573177247, 218, 4, 'PPL', 'P'),
(35756, 'Elmwood', 37.5269393920898, 0.654968650588327, -87.491943359375, -1.52702248058948, 218, 21, 'PPL', 'P'),
(40806, 'Elmwood', 31.0363903045654, 0.541687198748712, -93.3061065673828, -1.62849877181753, 218, 22, 'PPL', 'P'),
(46881, 'Elmwood', 39.3522186279297, 0.686825783022018, -76.5224990844727, -1.33556956087839, 218, 25, 'PPL', 'P'),
(54617, 'Elmwood', 39.0686111450195, 0.681875898661943, -93.4327774047852, -1.63070959499646, 218, 29, 'PPL', 'P'),
(64514, 'Elmwood', 35.7511100769043, 0.623974582084903, -80.7611083984375, -1.40954724911278, 218, 33, 'PPL', 'P'),
(72450, 'Elmwood', 39.500560760498, 0.689414841654766, -82.9280624389648, -1.44736773185938, 218, 41, 'PPL', 'P'),
(78211, 'Elmwood', 39.9694404602051, 0.697598336210416, -76.6986083984375, -1.33864324825051, 218, 45, 'PPL', 'P'),
(86789, 'Elmwood', 36.225830078125, 0.632260009131276, -85.8847198486328, -1.49897113851157, 218, 50, 'PPL', 'P'),
(94032, 'Elmwood', 31.9194393157959, 0.557099311451165, -95.6308288574219, -1.66907282997322, 218, 51, 'PPL', 'P'),
(109082, 'Elmwood', 38.208610534668, 0.666866056442147, -82.4375, -1.43880580211283, 218, 58, 'PPL', 'P'),
(113399, 'Elmwood', 41.7330589294434, 0.728379285247607, -72.7230606079102, -1.26925684973542, 218, 8, 'PPL', 'P'),
(119525, 'Elmwood', 40.7777786254883, 0.711706498664138, -89.9663925170898, -1.57020976556481, 218, 18, 'PPL', 'P'),
(122574, 'Elmwood', 40.0677795410156, 0.699314676953945, -86.4619369506836, -1.50904547744117, 218, 19, 'PPL', 'P'),
(124787, 'Elmwood', 42.0097198486328, 0.733207929199056, -70.9625015258789, -1.23852929707809, 218, 23, 'PPL', 'P'),
(127432, 'Elmwood', 43.7224998474121, 0.76310157954006, -70.5672225952148, -1.23163037827424, 218, 26, 'PPL', 'P'),
(130666, 'Elmwood', 43.5847206115723, 0.760696878233773, -83.283332824707, -1.45356836982541, 218, 27, 'PPL', 'P'),
(141757, 'Elmwood', 40.8416709899902, 0.712821630791582, -96.293327331543, -1.68063560963607, 218, 35, 'PPL', 'P'),
(143797, 'Elmwood', 43.5177803039551, 0.759528549463555, -71.841667175293, -1.2538736323308, 218, 36, 'PPL', 'P'),
(148673, 'Elmwood', 42.8266716003418, 0.747466427096314, -76.5236129760742, -1.33558900195435, 218, 40, 'PPL', 'P'),
(169364, 'Elmwood', 41.797779083252, 0.729508865023964, -71.4266662597656, -1.24663049995605, 218, 47, 'PPL', 'P'),
(173999, 'Elmwood', 44.7811088562012, 0.781577792234702, -92.1458282470703, -1.60824809488857, 218, 57, 'PPL', 'P'),
(192954, 'Elmwood', 36.6163902282715, 0.639076569678416, -100.522216796875, -1.75444365450902, 218, 42, 'PPL', 'P'),
(40807, 'Elmwood (historical)', 32.0094413757324, 0.558670143730634, -93.6374969482422, -1.63428262507297, 218, 22, 'PPL', 'P'),
(54618, 'Elmwood (historical)', 37.2527809143066, 0.650183682478754, -89.5813903808594, -1.56349021066037, 218, 29, 'PPL', 'P'),
(143798, 'Elmwood Corners', 42.9308280944824, 0.749284300856402, -70.82861328125, -1.2361925063796, 218, 36, 'PPL', 'P'),
(101721, 'Elmwood Estates', 38.9430618286133, 0.679684649717025, -77.2002792358398, -1.34739905612442, 218, 53, 'PPL', 'P'),
(109083, 'Elmwood Heights', 39.3408317565918, 0.686627044625671, -81.4274978637695, -1.42117793938343, 218, 58, 'PPL', 'P'),
(80874, 'Elmwood Park', 33.5041694641113, 0.584758070294887, -81.7033309936523, -1.42599213568596, 218, 48, 'PPL', 'P'),
(119527, 'Elmwood Park', 41.9211082458496, 0.73166136497502, -87.8091735839844, -1.53255919249576, 218, 18, 'PPL', 'P'),
(145163, 'Elmwood Park', 40.9038887023926, 0.713907534726062, -74.1188888549805, -1.29361864843914, 218, 37, 'PPL', 'P'),
(174000, 'Elmwood Park', 42.6922187805176, 0.74511978270179, -87.8222198486328, -1.53278689276896, 218, 57, 'PPL', 'P'),
(72451, 'Elmwood Place', 39.1872215270996, 0.683946040356288, -84.4880599975586, -1.47459482557991, 218, 41, 'PPL', 'P'),
(124788, 'Elmwood Station', 42.0183296203613, 0.733358198063564, -70.970832824707, -1.23867470567361, 218, 23, 'PPL', 'P'),
(161335, 'Elmwood Terrace', 40.167781829834, 0.701060046153356, -74.8766708374023, -1.30684443904469, 218, 45, 'PPL', 'P'),
(178155, 'Elmwood Trailer Park', 33.3063888549805, 0.581306147468953, -111.829170227051, -1.95178722023525, 218, 5, 'PPL', 'P'),
(35757, 'Elna', 37.9083290100098, 0.661625155153953, -82.961669921875, -1.44795429308947, 218, 21, 'PPL', 'P'),
(181428, 'Elna (historical)', 37.0938911437988, 0.647410532835655, -118.223609924316, -2.06339124677277, 218, 6, 'PPL', 'P'),
(8750, 'Elnora', 36.1722183227539, 0.631324307482277, -90.9630584716797, -1.58760486801493, 218, 4, 'PPL', 'P'),
(29721, 'Elnora', 38.8783302307129, 0.678554870203587, -87.0858306884766, -1.51993447734824, 218, 19, 'PPL', 'P'),
(148674, 'Elnora', 42.8927803039551, 0.74862024163859, -73.8216705322266, -1.28843121010983, 218, 40, 'PPL', 'P'),
(130669, 'Elo', 46.8733291625977, 0.818093925258406, -88.6369400024414, -1.54700644193527, 218, 27, 'PPL', 'P'),
(174003, 'Elo', 43.9383316040039, 0.766868554322949, -88.7061080932617, -1.54821365285741, 218, 57, 'PPL', 'P'),
(194893, 'Elo (historical)', 44.8833312988281, 0.783361910427974, -116.059440612793, -2.02561936671606, 218, 17, 'PPL', 'P'),
(94033, 'Elodias Colonia', 26.3929996490479, 0.460644743353593, -98.9209976196289, -1.72649710782, 218, 51, 'PPL', 'P'),
(15930, 'Eloise', 27.9944400787354, 0.488595151626192, -81.7383270263672, -1.42660293168197, 218, 12, 'PPL', 'P'),
(94034, 'Eloise', 31.1227798461914, 0.543194980689374, -96.8083267211914, -1.6896240446312, 218, 51, 'PPL', 'P'),
(130670, 'Eloise', 42.285831451416, 0.738026985770582, -83.3388900756836, -1.45453802677831, 218, 27, 'PPL', 'P'),
(15931, 'Eloise Woods', 28.0027809143066, 0.488740726669279, -81.6966705322266, -1.42587588870438, 218, 12, 'PPL', 'P'),
(2280, 'Elon', 34.542781829834, 0.602885275728675, -86.4688873291016, -1.50916678442883, 218, 2, 'PPL', 'P'),
(64515, 'Elon', 36.1027793884277, 0.630112369449209, -79.5069427490234, -1.38765792916509, 218, 33, 'PPL', 'P'),
(101714, 'Elon', 37.5175018310547, 0.654803934074906, -79.1952819824219, -1.3822184226386, 218, 53, 'PPL', 'P'),
(115467, 'Elon', 43.2641716003418, 0.755102242573789, -91.3238906860352, -1.5939025782027, 218, 16, 'PPL', 'P'),
(8751, 'Elon (historical)', 33.0361099243164, 0.576588890230096, -91.852783203125, -1.60313349401507, 218, 4, 'PPL', 'P'),
(59803, 'Elon (historical)', 33.0611114501953, 0.577025249174705, -88.5116729736328, -1.54482011983837, 218, 30, 'PPL', 'P'),
(86791, 'Elora', 35.0133285522461, 0.611097865319234, -86.355827331543, -1.50719351521913, 218, 50, 'PPL', 'P'),
(161336, 'Elora', 40.9938888549805, 0.715478333716017, -79.9897232055664, -1.39608403769605, 218, 45, 'PPL', 'P'),
(181429, 'Elora', 35.1380615234375, 0.613274866352319, -115.528060913086, -2.01634504137792, 218, 6, 'PPL', 'P'),
(178156, 'Eloy', 32.7558288574219, 0.571697062781784, -111.554168701172, -1.94698753816066, 218, 5, 'PPL', 'P'),
(20874, 'Elpino', 30.996940612793, 0.540998671738386, -84.2313919067383, -1.47011512231029, 218, 13, 'PPL', 'P'),
(148677, 'Elpis', 43.2836112976074, 0.755441529296665, -75.8225021362305, -1.32335230937766, 218, 40, 'PPL', 'P'),
(161337, 'Elrama', 40.2519416809082, 0.702528912652589, -79.9252777099609, -1.39495925160965, 218, 45, 'PPL', 'P'),
(2281, 'Elrath', 34.1380615234375, 0.595821573832376, -85.7430572509766, -1.49649865975554, 218, 2, 'PPL', 'P'),
(115468, 'Elrick Junction', 41.0986099243164, 0.717306061172139, -91.1175003051758, -1.59030038651226, 218, 16, 'PPL', 'P'),
(2282, 'Elrod', 33.2561111450195, 0.580428635889772, -87.7922210693359, -1.53226331529865, 218, 2, 'PPL', 'P'),
(20875, 'Elrod', 34.4086112976074, 0.600543558182168, -83.8855590820313, -1.46407920085768, 218, 13, 'PPL', 'P'),
(29722, 'Elrod', 39.0547218322754, 0.681633484423718, -85.1638870239258, -1.48639023236398, 218, 19, 'PPL', 'P'),
(35759, 'Elrod', 37.2191696166992, 0.649597054669637, -84.4694366455078, -1.47426978676887, 218, 21, 'PPL', 'P'),
(64516, 'Elrod', 34.6138916015625, 0.604126375375679, -79.2422180175781, -1.38303761098991, 218, 33, 'PPL', 'P'),
(170237, 'Elrod', 44.8863906860352, 0.78341530680783, -97.5733337402344, -1.70297593591436, 218, 49, 'PPL', 'P'),
(20876, 'Elrod Mill', 34.8669395446777, 0.608542895148439, -84.2969436645508, -1.47125921631459, 218, 13, 'PPL', 'P'),
(135220, 'Elrosa', 45.5627784729004, 0.795220500708906, -94.9469375610352, -1.65713667512554, 218, 28, 'PPL', 'P'),
(64517, 'Elroy', 35.3424987792969, 0.616842969580807, -77.9088897705078, -1.35976664306869, 218, 33, 'PPL', 'P'),
(94036, 'Elroy', 30.1205596923828, 0.52570293917557, -97.6350021362305, -1.70405225246892, 218, 51, 'PPL', 'P'),
(155175, 'Elroy', 40.2063903808594, 0.701733892488173, -84.7094421386719, -1.47845867284745, 218, 41, 'PPL', 'P'),
(161338, 'Elroy', 40.2819404602051, 0.703052490122899, -75.336669921875, -1.3148729376249, 218, 45, 'PPL', 'P'),
(174004, 'Elroy', 43.7408294677734, 0.763421491766005, -90.272216796875, -1.5755474061796, 218, 57, 'PPL', 'P'),
(94037, 'Elsa', 26.2930603027344, 0.458900472708132, -97.9927825927734, -1.71029669943488, 218, 51, 'PPL', 'P'),
(181430, 'Elsa', 36.2508316040039, 0.632696368075885, -121.13777923584, -2.11425309621943, 218, 6, 'PPL', 'P'),
(27089, 'Elsah', 38.9561080932617, 0.679912349990227, -90.3597183227539, -1.5770745959067, 218, 18, 'PPL', 'P'),
(2283, 'Elsanor', 30.5450000762939, 0.533110821353249, -87.583610534668, -1.52862237461435, 218, 2, 'PPL', 'P'),
(54620, 'Elsberry', 39.1666717529297, 0.683587379136482, -90.7808303833008, -1.5844243878831, 218, 29, 'PPL', 'P'),
(119529, 'Elsdon', 41.7936096191406, 0.729436094147177, -87.7216720581055, -1.53103200276865, 218, 18, 'PPL', 'P'),
(127433, 'Elsemore Landing', 45.1811103820801, 0.788559135874291, -67.8986129760742, -1.18505435396984, 218, 26, 'PPL', 'P'),
(54621, 'Elsey', 36.8541717529297, 0.643226640184113, -93.5405578613281, -1.63259071883244, 218, 29, 'PPL', 'P'),
(181431, 'Elsey', 39.6074981689453, 0.691281251525721, -121.593330383301, -2.12220396365386, 218, 6, 'PPL', 'P'),
(35760, 'Elsie', 37.7783317565918, 0.65935627506326, -83.1361083984375, -1.45099881884764, 218, 21, 'PPL', 'P'),
(80875, 'Elsie', 33.9319381713867, 0.592224042673842, -81.3341674804688, -1.41954901690268, 218, 48, 'PPL', 'P'),
(130671, 'Elsie', 43.0886116027832, 0.752038142581598, -84.3869400024414, -1.47282994872551, 218, 27, 'PPL', 'P'),
(199302, 'Elsie', 40.8474998474121, 0.712923363545223, -101.388061523438, -1.76955549579856, 218, 35, 'PPL', 'P'),
(200769, 'Elsie', 45.8658294677734, 0.800509738370885, -123.593612670898, -2.15711547554176, 218, 43, 'PPL', 'P'),
(101715, 'Elsing Green', 37.6025009155273, 0.656287447960134, -77.0511093139648, -1.34479554984276, 218, 53, 'PPL', 'P'),
(35761, 'Elsinore', 38.2205581665039, 0.6670745819555, -84.7961120605469, -1.47997134834662, 218, 21, 'PPL', 'P'),
(148675, 'Elsinore', 44.6936111450195, 0.780050669086624, -73.6672210693359, -1.28573555845445, 218, 40, 'PPL', 'P'),
(192554, 'Elsinore', 38.6827812194824, 0.675141896108596, -112.147499084473, -1.95734310690137, 218, 52, 'PPL', 'P'),
(13725, 'Elsmere', 39.7391700744629, 0.693579359809378, -75.5983276367188, -1.31943972626217, 218, 10, 'PPL', 'P'),
(35762, 'Elsmere', 39.0125007629395, 0.680896587750093, -84.6047210693359, -1.47663094539133, 218, 21, 'PPL', 'P'),
(70786, 'Elsmere', 39.6963882446289, 0.692832676018747, -75.1374969482422, -1.31139671345402, 218, 37, 'PPL', 'P'),
(148676, 'Elsmere', 42.6216697692871, 0.743888470171792, -73.8186111450195, -1.28837781372997, 218, 40, 'PPL', 'P'),
(186684, 'Elsmere', 38.8647193908691, 0.678317316234352, -104.709999084473, -1.8275342437843, 218, 7, 'PPL', 'P'),
(199304, 'Elsmere', 42.1652793884277, 0.735922955351365, -100.184997558594, -1.74855806849994, 218, 35, 'PPL', 'P'),
(32352, 'Elsmore', 37.7944412231445, 0.659637438295345, -95.1500015258789, -1.66068080990422, 218, 20, 'PPL', 'P'),
(196427, 'Elso', 46.3486099243164, 0.808935846901841, -108.676666259766, -1.89676564632394, 218, 31, 'PPL', 'P'),
(101716, 'Elsom', 37.5713882446289, 0.655744429413867, -76.7544403076172, -1.33961769889337, 218, 53, 'PPL', 'P'),
(161339, 'Elstie', 40.5200004577637, 0.707207420897586, -78.5319366455078, -1.3706408624317, 218, 45, 'PPL', 'P'),
(54622, 'Elston', 38.6127815246582, 0.673920170958522, -92.3236083984375, -1.61135094387462, 218, 29, 'PPL', 'P'),
(122575, 'Elston', 40.3930587768555, 0.704991870607721, -86.9097213745117, -1.51686078997612, 218, 19, 'PPL', 'P'),
(46882, 'Elston Shores', 38.7152786254883, 0.675709082841755, -76.2755584716797, -1.33125963412826, 218, 25, 'PPL', 'P'),
(161340, 'Elstonville', 40.2077789306641, 0.701758127254093, -76.4199981689453, -1.33378058241613, 218, 45, 'PPL', 'P'),
(101717, 'Eltham', 37.523609161377, 0.654910527097536, -76.8263931274414, -1.3408735125054, 218, 53, 'PPL', 'P'),
(27091, 'Eltham (historical)', 37.6694412231445, 0.657455776730352, -89.334716796875, -1.55918494444215, 218, 18, 'PPL', 'P'),
(148678, 'Elting Corners', 41.7411117553711, 0.728519833574136, -74.0352783203125, -1.29215936931983, 218, 40, 'PPL', 'P'),
(148679, 'Eltingville', 40.545280456543, 0.707648640111184, -74.1661071777344, -1.29444276363846, 218, 40, 'PPL', 'P'),
(40808, 'Elton', 30.4811096191406, 0.531995722515319, -92.695556640625, -1.6178426653478, 218, 22, 'PPL', 'P'),
(59804, 'Elton', 32.2208290100098, 0.562359553946775, -90.2191696166992, -1.57462155822663, 218, 30, 'PPL', 'P'),
(109084, 'Elton', 37.8283309936523, 0.660228926373452, -80.8033294677734, -1.4102841457864, 218, 58, 'PPL', 'P'),
(145165, 'Elton', 40.2169418334961, 0.701918050077552, -74.341667175293, -1.29750686363065, 218, 37, 'PPL', 'P'),
(148680, 'Elton', 42.4508285522461, 0.740906728436312, -78.4291687011719, -1.36884722343753, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(155176, 'Elton', 40.7286109924316, 0.710848361581887, -81.6163864135742, -1.42447466649684, 218, 41, 'PPL', 'P'),
(161341, 'Elton', 40.2797203063965, 0.703013741129038, -78.8024978637695, -1.37536304651858, 218, 45, 'PPL', 'P'),
(174006, 'Elton', 45.1683311462402, 0.788336096132996, -88.8863906860352, -1.55136017768533, 218, 57, 'PPL', 'P'),
(191432, 'Elton', 33.7044410705566, 0.588253469225616, -100.841110229492, -1.76000939487117, 218, 51, 'PPL', 'P'),
(196428, 'Elton', 45.6958312988281, 0.797542710600428, -110.307220458984, -1.92522418573253, 218, 31, 'PPL', 'P'),
(20877, 'Elton (historical)', 32.2555618286133, 0.562965755989905, -82.2461090087891, -1.43546539915754, 218, 13, 'PPL', 'P'),
(141760, 'Elton (historical)', 41.5033302307129, 0.724369763068438, -99.4727783203125, -1.73612749779589, 218, 35, 'PPL', 'P'),
(20878, 'Elton Estates', 33.8869400024414, 0.591438676468378, -84.3625030517578, -1.47240344347694, 218, 13, 'PPL', 'P'),
(207332, 'Eltopia', 46.4588890075684, 0.810860580000669, -119.01611328125, -2.07722303968436, 218, 56, 'PPL', 'P'),
(40809, 'Eltringham Landing', 31.8077793121338, 0.555150476744472, -91.5761108398438, -1.59830465032654, 218, 22, 'PPL', 'P'),
(35763, 'Elva', 36.9286117553711, 0.644525863321908, -88.4736099243164, -1.54415579430445, 218, 21, 'PPL', 'P'),
(94038, 'Elva', 32.526668548584, 0.567697460877676, -96.7944412231445, -1.689381696972, 218, 51, 'PPL', 'P'),
(119530, 'Elva', 41.8641700744629, 0.730667606414257, -88.7761077880859, -1.54943537800748, 218, 18, 'PPL', 'P'),
(86792, 'Elva (historical)', 36.5847206115723, 0.63852383059417, -84.6458282470703, -1.477348400989, 218, 50, 'PPL', 'P'),
(101718, 'Elvan', 39.2772216796875, 0.685516839346245, -77.6694412231445, -1.35558747752808, 218, 53, 'PPL', 'P'),
(181432, 'Elvas', 38.5833282470703, 0.673406114289109, -121.44750213623, -2.11965878060007, 218, 6, 'PPL', 'P'),
(119531, 'Elvaston', 40.3950004577637, 0.705025759332593, -91.2494430541992, -1.59260322190685, 218, 18, 'PPL', 'P'),
(46883, 'Elvaton', 39.1199989318848, 0.682772784738054, -76.5888900756836, -1.33672830226869, 218, 25, 'PPL', 'P'),
(181433, 'Elvaton (historical)', 38.7272186279297, 0.675917475197054, -121.805282592773, -2.12590322756603, 218, 6, 'PPL', 'P'),
(46884, 'Elvaton Acres', 39.1122207641602, 0.682637030101487, -76.5930633544922, -1.3368011397245, 218, 25, 'PPL', 'P'),
(174007, 'Elvers', 43.0697212219238, 0.751708443238646, -89.7977828979492, -1.56726697256027, 218, 57, 'PPL', 'P'),
(161342, 'Elverson', 40.1566696166992, 0.700866101446971, -75.8330612182617, -1.32353660012509, 218, 45, 'PPL', 'P'),
(181434, 'Elverta', 38.7138900756836, 0.675684848075835, -121.461669921875, -2.11990605510728, 218, 6, 'PPL', 'P'),
(86793, 'Elverton', 35.9786109924316, 0.627945222112157, -84.4430618286133, -1.47380945937445, 218, 50, 'PPL', 'P'),
(109085, 'Elverton', 38.0277786254883, 0.663709944234294, -81.0347213745117, -1.41432269642145, 218, 58, 'PPL', 'P'),
(54623, 'Elvins', 37.836669921875, 0.660374468127024, -90.5327835083008, -1.58009515321507, 218, 29, 'PPL', 'P'),
(2285, 'Elvira', 33.3233299255371, 0.581601824928979, -86.8658294677734, -1.51609473168856, 218, 2, 'PPL', 'P'),
(27092, 'Elvira', 37.4933280944824, 0.65438202277921, -89.0294418334961, -1.55385689120728, 218, 18, 'PPL', 'P'),
(115469, 'Elvira', 41.8588905334473, 0.73057546104054, -90.3552780151367, -1.57699709791898, 218, 16, 'PPL', 'P'),
(181435, 'Elvira', 32.8375015258789, 0.573122519755249, -117.232498168945, -2.04609308338632, 218, 6, 'PPL', 'P'),
(130672, 'Elwell', 43.3875007629395, 0.757254742524845, -84.7458267211914, -1.47909370360938, 218, 27, 'PPL', 'P'),
(194174, 'Elwell', 40.336109161377, 0.703997912309877, -104.941390991211, -1.83157279441935, 218, 7, 'PPL', 'P'),
(207333, 'Elwha', 48.0608291625977, 0.838819710125838, -123.593063354492, -2.15710588816184, 218, 56, 'PPL', 'P'),
(27095, 'Elwin', 39.7788887023926, 0.694272580641125, -88.9800033569336, -1.5529940270141, 218, 18, 'PPL', 'P'),
(15933, 'Elwood', 29.9986095428467, 0.523574507542866, -81.543327331543, -1.42319954496691, 218, 12, 'PPL', 'P'),
(32354, 'Elwood', 39.7555618286133, 0.693865449889479, -94.8722229003906, -1.65583265829778, 218, 20, 'PPL', 'P'),
(54624, 'Elwood', 37.2280616760254, 0.649752250382162, -93.4311065673828, -1.63068043338253, 218, 29, 'PPL', 'P'),
(59806, 'Elwood', 32.0180587768555, 0.558820545753196, -88.8016662597656, -1.54988145749007, 218, 30, 'PPL', 'P'),
(70787, 'Elwood', 39.5763893127441, 0.690738299558481, -74.7172164916992, -1.30406143570556, 218, 37, 'PPL', 'P'),
(94041, 'Elwood', 32.7383308410645, 0.571391664783779, -95.9494400024414, -1.67463364348736, 218, 51, 'PPL', 'P'),
(101719, 'Elwood', 36.6761093139648, 0.640118864350045, -76.8241729736328, -1.34083476351154, 218, 53, 'PPL', 'P'),
(115470, 'Elwood', 41.9916687011719, 0.7328928772421, -90.7388916015625, -1.5836924180575, 218, 16, 'PPL', 'P'),
(119532, 'Elwood', 41.4038887023926, 0.722634180986033, -88.1116714477539, -1.53783877619878, 218, 18, 'PPL', 'P'),
(122576, 'Elwood', 40.2769393920898, 0.702965205018171, -85.8419418334961, -1.49822452129996, 218, 19, 'PPL', 'P'),
(141761, 'Elwood', 40.5902786254883, 0.708434006316649, -99.8605575561523, -1.74289552223216, 218, 35, 'PPL', 'P'),
(148681, 'Elwood', 40.8452796936035, 0.712884614551362, -73.335563659668, -1.27994704466711, 218, 40, 'PPL', 'P'),
(188515, 'Elwood', 32.2936096191406, 0.563629815207716, -106.136672973633, -1.85243440050237, 218, 38, 'PPL', 'P'),
(200770, 'Elwood', 45.2083282470703, 0.789034177233733, -122.36888885498, -2.1357400125264, 218, 43, 'PPL', 'P'),
(203866, 'Elwood', 41.690559387207, 0.727637528304992, -112.140281677246, -1.95721713938181, 218, 52, 'PPL', 'P'),
(207334, 'Elwood', 46.3822212219238, 0.809522474710958, -118.514167785645, -2.06846243812049, 218, 56, 'PPL', 'P'),
(209436, 'Elwood (historical)', 41.1813888549805, 0.718750826063507, -106.883331298828, -1.86546604666446, 218, 59, 'PPL', 'P'),
(101720, 'Elwood Acres', 38.8791694641113, 0.678569517589582, -78.2347183227539, -1.36545342410239, 218, 53, 'PPL', 'P'),
(15939, 'Elwood Park', 27.4688892364502, 0.479422559041687, -82.5061111450195, -1.44000329249698, 218, 12, 'PPL', 'P'),
(161344, 'Elwood Park', 40.163890838623, 0.700992135545559, -80.2825012207031, -1.40119397803764, 218, 45, 'PPL', 'P'),
(29723, 'Elwren', 39.1086082458496, 0.68257397976268, -86.6697235107422, -1.51267203705559, 218, 19, 'PPL', 'P'),
(78212, 'Elwyn', 39.9077796936035, 0.696522152813915, -75.4105606079102, -1.31616257338277, 218, 45, 'PPL', 'P'),
(143799, 'Elwyn Park', 43.0380592346191, 0.751155837312455, -70.774169921875, -1.23524229050266, 218, 36, 'PPL', 'P'),
(161345, 'Elwyn Terrace', 40.1561088562012, 0.700856314329965, -76.3869400024414, -1.33320360856597, 218, 45, 'PPL', 'P'),
(54625, 'Ely', 39.6916694641113, 0.692750317762036, -91.633056640625, -1.59929854204536, 218, 29, 'PPL', 'P'),
(94042, 'Ely', 33.5227813720703, 0.585082909368849, -96.3125, -1.68097023582704, 218, 51, 'PPL', 'P'),
(101722, 'Ely', 36.7691688537598, 0.641743059719857, -82.9897232055664, -1.44844391525588, 218, 53, 'PPL', 'P'),
(115471, 'Ely', 41.8736114501953, 0.730832389506706, -91.5849990844727, -1.59845977946004, 218, 16, 'PPL', 'P'),
(135222, 'Ely', 47.9033317565918, 0.836070861827686, -91.866943359375, -1.60338063536423, 218, 28, 'PPL', 'P'),
(145166, 'Ely', 40.2030601501465, 0.701675768997382, -74.3874969482422, -1.29830674406406, 218, 37, 'PPL', 'P'),
(171991, 'Ely', 43.8763885498047, 0.765787444078432, -72.1769409179688, -1.25972526303597, 218, 55, 'PPL', 'P'),
(190172, 'Ely', 39.247501373291, 0.684998122144924, -114.88777923584, -2.00517001796978, 218, 39, 'PPL', 'P'),
(181436, 'Ely (historical)', 38.2791709899902, 0.668097568709227, -122.664436340332, -2.14089828924178, 218, 6, 'PPL', 'P'),
(32356, 'Elyria', 38.2905616760254, 0.668296373684601, -97.6266708374023, -1.7039068438734, 218, 20, 'PPL', 'P'),
(141765, 'Elyria', 41.6808280944824, 0.727467685206472, -99.0058288574219, -1.72797769222803, 218, 35, 'PPL', 'P'),
(155177, 'Elyria', 41.3683280944824, 0.72201353129399, -82.107780456543, -1.43305111047133, 218, 41, 'PPL', 'P'),
(145167, 'Elys Corner', 40.2363891601563, 0.702257469958483, -74.477783203125, -1.29988253648106, 218, 37, 'PPL', 'P'),
(161346, 'Elysburg', 40.8644409179688, 0.713219041005249, -76.5527801513672, -1.33609806519672, 218, 45, 'PPL', 'P'),
(135224, 'Elysian', 44.1986083984375, 0.771411241352352, -93.6736068725586, -1.63491286214494, 218, 28, 'PPL', 'P'),
(94043, 'Elysian Fields', 32.3683280944824, 0.564933898614501, -94.1827774047852, -1.64379956438642, 218, 51, 'PPL', 'P'),
(86795, 'Elysian Grove', 36.0263900756836, 0.628779124428488, -87.85888671875, -1.5334268503789, 218, 50, 'PPL', 'P'),
(94044, 'Elysium', 30.166690826416, 0.526508079352129, -97.5151214599609, -1.7019599399585, 218, 51, 'PPL', 'P'),
(2286, 'Elyton', 33.5013885498047, 0.58470953418402, -86.8408279418945, -1.51565837274395, 218, 2, 'PPL', 'P'),
(86796, 'Elza', 36.0525016784668, 0.629234857870028, -84.2030563354492, -1.46962057329586, 218, 50, 'PPL', 'P'),
(112367, 'Emad', 30.5074996948242, 0.532456316225848, -92.8666687011719, -1.62082913419422, 218, 22, 'PPL', 'P'),
(64518, 'Emandell (historical)', 35.7075004577637, 0.623213450645358, -76.8277816772461, -1.34089774727132, 218, 33, 'PPL', 'P'),
(35764, 'Emanuel', 36.9061088562012, 0.644133113640149, -83.9311065673828, -1.46487415444307, 218, 21, 'PPL', 'P'),
(64519, 'Emanuel (historical)', 35.9536094665527, 0.627508863167547, -81.4563903808594, -1.42168220893583, 218, 33, 'PPL', 'P'),
(161347, 'Emanuelsville', 40.7602806091309, 0.711401100666133, -75.460563659668, -1.31703529127199, 218, 45, 'PPL', 'P'),
(15934, 'Emathla', 29.2824993133545, 0.511076026231015, -82.2922210693359, -1.43627020643896, 218, 12, 'PPL', 'P'),
(2287, 'Emauhee', 33.2202796936035, 0.579803259086794, -86.1927795410156, -1.50434779443633, 218, 2, 'PPL', 'P'),
(209437, 'Embar', 43.7138900756836, 0.762951310675552, -108.673057556152, -1.89670266256416, 218, 59, 'PPL', 'P'),
(181437, 'Embarcadero', 38.2400016784668, 0.667413935257404, -122.448608398438, -2.13713138103792, 218, 6, 'PPL', 'P'),
(27100, 'Embarrass', 39.517219543457, 0.689705592266776, -88.0911102294922, -1.5374799152419, 218, 18, 'PPL', 'P'),
(135228, 'Embarrass', 47.6591682434082, 0.831809404609395, -92.1977767944336, -1.60915476808169, 218, 28, 'PPL', 'P'),
(174008, 'Embarrass', 44.6655616760254, 0.77956111349924, -88.7072219848633, -1.54823309393336, 218, 57, 'PPL', 'P'),
(20880, 'Embassy Estates', 33.5533294677734, 0.585616074219083, -84.4458312988281, -1.47385779574823, 218, 13, 'PPL', 'P'),
(13087, 'Embassy Park', 38.9355583190918, 0.679553688770421, -77.0833282470703, -1.34535787630693, 218, 9, 'PPL', 'P'),
(113152, 'Embden', 46.8022193908691, 0.816852825611401, -97.4327774047852, -1.70052276507624, 218, 34, 'PPL', 'P'),
(127434, 'Embden', 44.9180603027344, 0.783968045892076, -69.8672180175781, -1.21941299361544, 218, 26, 'PPL', 'P'),
(94045, 'Emberson', 33.7608299255371, 0.589237640406455, -95.6522216796875, -1.66944620515805, 218, 51, 'PPL', 'P'),
(35765, 'Emberton', 36.7130584716797, 0.640763748808008, -85.8063888549805, -1.49760400476598, 218, 21, 'PPL', 'P'),
(94046, 'Emblem', 33.2472190856934, 0.580273440177248, -95.7658309936523, -1.67142906174767, 218, 51, 'PPL', 'P'),
(161348, 'Emblem', 40.3177795410156, 0.703678000083931, -79.7855606079102, -1.39252072815752, 218, 45, 'PPL', 'P'),
(209438, 'Emblem', 44.5058288574219, 0.776773249891118, -108.39111328125, -1.89178180665997, 218, 59, 'PPL', 'P'),
(54626, 'Embree', 37.4122200012207, 0.652966419501778, -92.2566680908203, -1.61018261510441, 218, 29, 'PPL', 'P'),
(80876, 'Embree', 33.2577781677246, 0.580457730924681, -80.892219543457, -1.41183557027943, 218, 48, 'PPL', 'P'),
(94047, 'Embree (historical)', 32.9239692687988, 0.57463166656597, -96.6279830932617, -1.68647645453883, 218, 51, 'PPL', 'P'),
(78213, 'Embreeville', 39.9300003051758, 0.696909975647658, -75.7347183227539, -1.32182019280253, 218, 45, 'PPL', 'P'),
(86797, 'Embreeville', 36.1811103820801, 0.631479503194801, -82.458610534668, -1.43917425044964, 218, 50, 'PPL', 'P'),
(20881, 'Embrey Hills', 33.5202789306641, 0.585039233526972, -84.3380584716797, -1.47197680507031, 218, 13, 'PPL', 'P'),
(64521, 'Embro', 36.3763885498047, 0.634887750178857, -78.0552825927734, -1.36232167981851, 218, 33, 'PPL', 'P'),
(59807, 'Embry', 33.6561088562012, 0.587409912950333, -89.3688888549805, -1.55978135936827, 218, 30, 'PPL', 'P'),
(2288, 'Embry Bend', 33.6894416809082, 0.587991680490461, -86.1938934326172, -1.50436723551229, 218, 2, 'PPL', 'P'),
(2289, 'Embry Crossroads', 33.5930595397949, 0.586309494787913, -86.1611099243164, -1.50379505535208, 218, 2, 'PPL', 'P'),
(20882, 'Embry Hills', 33.8813896179199, 0.591341803983726, -84.2558288574219, -1.47054162755886, 218, 13, 'PPL', 'P'),
(188516, 'Embudo', 36.2075004577637, 0.63194009690533, -105.960563659668, -1.84936071313026, 218, 38, 'PPL', 'P'),
(2290, 'Emco-Listerhill Junction', 34.7136116027832, 0.605866817727073, -87.5933303833008, -1.52879201797579, 218, 2, 'PPL', 'P'),
(40811, 'Emden', 31.7427806854248, 0.554016036699125, -92.7588882446289, -1.61894801035824, 218, 22, 'PPL', 'P'),
(54627, 'Emden', 39.7963905334473, 0.694578045218157, -91.8627777099609, -1.60330793106647, 218, 29, 'PPL', 'P'),
(119533, 'Emden', 40.2986106872559, 0.70334344047199, -89.4850006103516, -1.56180789179977, 218, 18, 'PPL', 'P'),
(207335, 'Emden', 47.1047210693359, 0.822132475893456, -118.121673583984, -2.06161212200654, 218, 56, 'PPL', 'P'),
(161349, 'Emeigh', 40.6947212219238, 0.710256873503781, -78.7872161865234, -1.37509633093541, 218, 45, 'PPL', 'P'),
(115472, 'Emeline', 42.1552810668945, 0.735748451720938, -90.8305587768555, -1.58529231208236, 218, 16, 'PPL', 'P'),
(2291, 'Emelle', 32.7291717529297, 0.571231808539347, -88.3144378662109, -1.54137771781334, 218, 2, 'PPL', 'P'),
(139971, 'Emerado', 47.9188919067383, 0.836342437679847, -97.3647232055664, -1.69933499523006, 218, 34, 'PPL', 'P'),
(59812, 'Emerald', 31.076940536499, 0.542394933808401, -90.3636093139648, -1.5771425065145, 218, 30, 'PPL', 'P'),
(72453, 'Emerald', 39.0011100769043, 0.680697782774719, -83.6575012207031, -1.46009884029244, 218, 41, 'PPL', 'P'),
(141767, 'Emerald', 40.8138885498047, 0.712336735736105, -96.834716796875, -1.69008463834173, 218, 35, 'PPL', 'P'),
(161352, 'Emerald', 40.7449989318848, 0.711134385082962, -75.6350021362305, -1.32007981703017, 218, 45, 'PPL', 'P'),
(174009, 'Emerald', 45.0830612182617, 0.786847855136833, -92.258056640625, -1.61020684987033, 218, 57, 'PPL', 'P'),
(207336, 'Emerald', 46.3027801513672, 0.808135966468436, -120.080276489258, -2.09579619144269, 218, 56, 'PPL', 'P'),
(119534, 'Emerald Acres', 41.6530609130859, 0.726983056467105, -88.0047225952148, -1.53597216659075, 218, 18, 'PPL', 'P'),
(181440, 'Emerald Bay', 33.5525016784668, 0.585601626570169, -117.808326721191, -2.05614318755001, 218, 6, 'PPL', 'P'),
(54628, 'Emerald Beach', 36.5755615234375, 0.638363974349738, -93.6716690063477, -1.63487903999909, 218, 29, 'PPL', 'P'),
(190175, 'Emerald City (historical)', 35.4597206115723, 0.618888876509233, -114.86888885498, -2.00484031862683, 218, 39, 'PPL', 'P'),
(46885, 'Emerald Cove', 38.4691696166992, 0.671413670319566, -76.5883331298828, -1.33671858173071, 218, 25, 'PPL', 'P'),
(194895, 'Emerald Creek', 47.0719413757324, 0.82156036231228, -116.327217102051, -2.03029294811304, 218, 17, 'PPL', 'P'),
(20885, 'Emerald Forest', 33.8736114501953, 0.591206049347159, -84.8541717529297, -1.48098468114139, 218, 13, 'PPL', 'P'),
(174010, 'Emerald Grove', 42.6561088562012, 0.744489545629823, -88.8805618286133, -1.55125844493169, 218, 57, 'PPL', 'P'),
(20886, 'Emerald Hills', 33.5149993896484, 0.584947088153255, -84.3327789306641, -1.47188465969659, 218, 13, 'PPL', 'P'),
(101723, 'Emerald Hills', 38.1130599975586, 0.665198384967539, -78.9569396972656, -1.3780585650159, 218, 53, 'PPL', 'P'),
(203870, 'Emerald Hills Condominium', 41.1630592346191, 0.718430913837561, -111.955833435059, -1.95399791025613, 218, 52, 'PPL', 'P'),
(64524, 'Emerald Isle', 34.6777801513672, 0.605241440924095, -76.9511108398438, -1.34305024722237, 218, 33, 'PPL', 'P'),
(203871, 'Emerald Isle', 40.6483306884766, 0.70944720595337, -111.894172668457, -1.95292172685962, 218, 52, 'PPL', 'P'),
(181443, 'Emerald Lake', 37.4666709899902, 0.653916768536773, -122.261940002441, -2.13387340291837, 218, 6, 'PPL', 'P'),
(181444, 'Emerald Lake Hills', 37.4647216796875, 0.653882746653847, -122.266937255859, -2.13396062144407, 218, 6, 'PPL', 'P'),
(161350, 'Emerald Lakes', 41.0883293151855, 0.717126630693695, -75.4199981689453, -1.31632728989619, 218, 45, 'PPL', 'P'),
(119535, 'Emerald Park', 42.3188896179199, 0.738603959620748, -88.2502822875977, -1.54025799173301, 218, 18, 'PPL', 'P'),
(80877, 'Emerald Place', 34.2080612182617, 0.59704329898245, -82.1141662597656, -1.43316256376295, 218, 48, 'PPL', 'P'),
(2292, 'Emerald Shores', 34.8580589294434, 0.608387899172996, -87.5691680908203, -1.52837030641717, 218, 2, 'PPL', 'P'),
(64525, 'Emerald Shores', 35.2502784729004, 0.615233421596991, -80.0808334350586, -1.39767421118293, 218, 33, 'PPL', 'P'),
(46886, 'Emerald Valley', 39.4091682434082, 0.687819741319863, -76.9752807617188, -1.34347209193904, 218, 25, 'PPL', 'P'),
(80878, 'Emerald Valley', 34.0449981689453, 0.594197311883536, -81.084716796875, -1.41519528115262, 218, 48, 'PPL', 'P'),
(64526, 'Emerald Village', 35.7188911437988, 0.623412255620733, -78.5480575561523, -1.37092222540087, 218, 33, 'PPL', 'P'),
(20888, 'Emerich', 32.2833290100098, 0.563450384729272, -83.7938919067383, -1.46247930683281, 218, 13, 'PPL', 'P'),
(141768, 'Emerick', 41.9019393920898, 0.731326805363079, -97.7363891601563, -1.70582178985522, 218, 35, 'PPL', 'P'),
(161351, 'Emerickville', 41.1324996948242, 0.717897549250245, -78.9883270263672, -1.37860637725213, 218, 45, 'PPL', 'P'),
(8753, 'Emerson', 33.0974998474121, 0.577660346515662, -93.1927795410156, -1.62652084207593, 218, 4, 'PPL', 'P'),
(20890, 'Emerson', 30.7758293151855, 0.53713955158178, -83.6319427490234, -1.45965276080986, 218, 13, 'PPL', 'P'),
(35766, 'Emerson', 38.353889465332, 0.669401652116012, -83.2525024414063, -1.45303027812716, 218, 21, 'PPL', 'P'),
(54629, 'Emerson', 39.8894386291504, 0.696202040850888, -91.6975021362305, -1.60042332813176, 218, 29, 'PPL', 'P'),
(64528, 'Emerson', 34.1808280944824, 0.596567991306898, -78.8663864135742, -1.37647811206699, 218, 33, 'PPL', 'P'),
(78214, 'Emerson', 39.9136085510254, 0.696623885567556, -78.3300018310547, -1.36711643504509, 218, 45, 'PPL', 'P'),
(109087, 'Emerson', 37.9408302307129, 0.66219240846614, -81.4977798461914, -1.42240459138152, 218, 58, 'PPL', 'P'),
(115473, 'Emerson', 41.017219543457, 0.715885531046691, -95.4019393920898, -1.66507795518005, 218, 16, 'PPL', 'P'),
(119536, 'Emerson', 41.8061103820801, 0.729654273619482, -89.7647171020508, -1.56668986555205, 218, 18, 'PPL', 'P'),
(130675, 'Emerson', 46.5563888549805, 0.812562273358202, -85.029167175293, -1.48403892743755, 218, 27, 'PPL', 'P'),
(141770, 'Emerson', 42.2786102294922, 0.737900951671994, -96.7263870239258, -1.68819392712582, 218, 35, 'PPL', 'P'),
(145168, 'Emerson', 40.9761085510254, 0.715168008869996, -74.0266723632813, -1.29200916703435, 218, 37, 'PPL', 'P'),
(148682, 'Emerson', 43.0999984741211, 0.752236880977945, -76.6144409179688, -1.33717424859322, 218, 40, 'PPL', 'P'),
(155181, 'Emerson', 40.1775016784668, 0.701229689514794, -80.8230590820313, -1.41062849251535, 218, 41, 'PPL', 'P'),
(171992, 'Emerson', 43.8408317565918, 0.765166860965416, -72.7975006103516, -1.27055607287322, 218, 55, 'PPL', 'P'),
(191433, 'Emerson', 30.148609161377, 0.526192494762954, -102.535827636719, -1.78958779351814, 218, 51, 'PPL', 'P'),
(198259, 'Emerson', 47.1836090087891, 0.823509330177027, -102.634437561035, -1.7913088613726, 218, 34, 'PPL', 'P'),
(200771, 'Emerson', 45.5458297729492, 0.794924690090825, -120.97917175293, -2.11148487342434, 218, 43, 'PPL', 'P'),
(27098, 'Emerson City', 38.1394386291504, 0.665658778940987, -89.045280456543, -1.55413332732843, 218, 18, 'PPL', 'P'),
(127436, 'Emerson Corner', 44.7986106872559, 0.781883256811734, -69.4747161865234, -1.21256254434343, 218, 26, 'PPL', 'P'),
(46887, 'Emerson Heights', 39.6041717529297, 0.691223194613957, -76.1708297729492, -1.32943177351409, 218, 25, 'PPL', 'P'),
(148683, 'Emerson Hill', 40.6086082458496, 0.708753918542595, -74.0963897705078, -1.29322596533641, 218, 40, 'PPL', 'P'),
(196429, 'Emerson Junction', 47.5200004577637, 0.829380468537189, -111.36888885498, -1.94375379480703, 218, 31, 'PPL', 'P'),
(20892, 'Emerson Park', 31.1886100769043, 0.544343934962662, -82.3977813720703, -1.43811258128108, 218, 13, 'PPL', 'P'),
(94048, 'Emerson Place', 29.8794403076172, 0.521494612021027, -95.3169403076172, -1.66359444129482, 218, 51, 'PPL', 'P'),
(130676, 'Emerson Station', 45.0641708374023, 0.786518155793881, -83.654167175293, -1.46004065022263, 218, 27, 'PPL', 'P'),
(27099, 'Emery', 39.9791717529297, 0.697768179308936, -88.9511108398438, -1.55248975746169, 218, 18, 'PPL', 'P'),
(64530, 'Emery', 35.2472190856934, 0.615180025217134, -79.7227783203125, -1.39142497052701, 218, 33, 'PPL', 'P'),
(115474, 'Emery', 43.1336097717285, 0.752823508787062, -93.2799987792969, -1.62804310495502, 218, 16, 'PPL', 'P'),
(130678, 'Emery', 42.3600006103516, 0.739321481797442, -83.6830596923828, -1.46054491977503, 218, 27, 'PPL', 'P'),
(161353, 'Emery', 40.1749992370605, 0.701186013672916, -80.086669921875, -1.39777607709463, 218, 45, 'PPL', 'P'),
(170243, 'Emery', 43.6016693115234, 0.760992688851853, -97.6222229003906, -1.70382921272762, 218, 49, 'PPL', 'P'),
(178157, 'Emery', 33.0697212219238, 0.577175518039213, -110.016387939453, -1.92014820069484, 218, 5, 'PPL', 'P'),
(192555, 'Emery', 38.9230613708496, 0.679335575877143, -111.248062133789, -1.94164497069785, 218, 52, 'PPL', 'P'),
(196430, 'Emery (historical)', 46.377498626709, 0.80944004987522, -112.579170227051, -1.96487718962521, 218, 31, 'PPL', 'P'),
(46888, 'Emery Corners', 38.9922218322754, 0.680542653641222, -77.1613922119141, -1.34672034952061, 218, 25, 'PPL', 'P'),
(86799, 'Emery Estates', 35.8911094665527, 0.626418032385051, -86.3444366455078, -1.50699471024376, 218, 50, 'PPL', 'P'),
(188517, 'Emery Gap (historical)', 36.9961090087891, 0.645703912630105, -103.866386413574, -1.81281042506557, 218, 38, 'PPL', 'P'),
(86800, 'Emery Mill', 35.6522216796875, 0.62224865396145, -85.1833267211914, -1.48672951908686, 218, 50, 'PPL', 'P'),
(127437, 'Emery Mills', 43.4944381713867, 0.7591211523958, -70.8436126708984, -1.23645429511475, 218, 26, 'PPL', 'P'),
(178158, 'Emery Park', 32.1411094665527, 0.560968185435264, -110.955276489258, -1.9365348971982, 218, 5, 'PPL', 'P'),
(127438, 'Emerys Bridge', 43.2463912963867, 0.754791917727767, -70.7275009155273, -1.23442776268326, 218, 26, 'PPL', 'P'),
(127439, 'Emerys Corner', 43.7255592346191, 0.763154975919916, -70.7624969482422, -1.23503855867927, 218, 26, 'PPL', 'P'),
(148684, 'Emeryville', 44.2949981689453, 0.773093560212955, -75.3677825927734, -1.31541595617117, 218, 40, 'PPL', 'P'),
(181445, 'Emeryville', 37.8313903808594, 0.660282322753308, -122.284172058105, -2.13426142548919, 218, 6, 'PPL', 'P'),
(75769, 'Emet', 34.2024993896484, 0.596946226760716, -96.5419387817383, -1.68497469800014, 218, 42, 'PPL', 'P'),
(94049, 'Emhouse', 32.1624984741211, 0.561341494041065, -96.5769424438477, -1.6855856271542, 218, 51, 'PPL', 'P'),
(209860, 'Emida', 47.1158294677734, 0.822326354020814, -116.596939086914, -2.03500048481392, 218, 17, 'PPL', 'P'),
(196431, 'Emigrant', 45.3702812194824, 0.791860789835716, -110.732780456543, -1.9326516088547, 218, 31, 'PPL', 'P'),
(194896, 'Emigrant Crossing', 43.0480613708496, 0.751330407521909, -115.28556060791, -2.01211261261551, 218, 17, 'PPL', 'P'),
(181446, 'Emigrant Gap', 39.2969398498535, 0.68586098633811, -120.671669006348, -2.10611793803756, 218, 6, 'PPL', 'P'),
(200772, 'Emigrant Springs (historical)', 45.6227798461914, 0.796267722228552, -120.561393737793, -2.10419327151776, 218, 43, 'PPL', 'P'),
(203874, 'Emigration Oaks', 40.7755584716797, 0.711667749670278, -111.754440307617, -1.95048293709138, 218, 52, 'PPL', 'P'),
(203877, 'Emigration Passive Solar Home Condominium', 40.7727813720703, 0.711619280138438, -111.756393432617, -1.95051702555334, 218, 52, 'PPL', 'P'),
(161357, 'Emigsville', 40.021671295166, 0.69850993625155, -76.7283325195313, -1.33916203203086, 218, 45, 'PPL', 'P'),
(178159, 'Emika', 32.4333305358887, 0.566068405238874, -112.485832214355, -1.96324813398641, 218, 5, 'PPL', 'P'),
(161354, 'Emilie', 40.1538887023926, 0.700817565336104, -74.8555603027344, -1.30647599070788, 218, 45, 'PPL', 'P'),
(94050, 'Emille', 30.8434391021729, 0.53831956497128, -94.2625579833984, -1.64519199816237, 218, 51, 'PPL', 'P'),
(135230, 'Emily', 46.7311096191406, 0.815611725964397, -93.9577789306641, -1.63987260020104, 218, 28, 'PPL', 'P'),
(20897, 'Emily (historical)', 33.5675010681152, 0.585863415305324, -84.920280456543, -1.48213849568367, 218, 13, 'PPL', 'P'),
(8755, 'Eminence', 33.2275009155273, 0.579929293185382, -91.1891708374023, -1.59155127327627, 218, 4, 'PPL', 'P'),
(29724, 'Eminence', 39.5213890075684, 0.689778363143562, -86.6413879394531, -1.51217748804116, 218, 19, 'PPL', 'P'),
(35767, 'Eminence', 38.3699989318848, 0.669682815348097, -85.1805572509766, -1.48668118271307, 218, 21, 'PPL', 'P'),
(54630, 'Eminence', 37.1505584716797, 0.648399564285483, -91.3574981689453, -1.59448913943279, 218, 29, 'PPL', 'P'),
(59808, 'Eminence', 31.6127796173096, 0.551747090029405, -89.4338912963867, -1.56091586599265, 218, 30, 'PPL', 'P'),
(94051, 'Eminence', 29.833610534668, 0.520694731587622, -94.6911087036133, -1.65267161924191, 218, 51, 'PPL', 'P'),
(148685, 'Eminence', 42.5252799987793, 0.742206151311189, -74.5358276367188, -1.30089560295973, 218, 40, 'PPL', 'P'),
(119538, 'Emington', 40.9697189331055, 0.715056488999349, -88.3580627441406, -1.54213911556899, 218, 18, 'PPL', 'P'),
(29725, 'Emison', 38.8050003051758, 0.677275021562722, -87.4580612182617, -1.52643112566943, 218, 19, 'PPL', 'P'),
(20893, 'Emit', 32.3436088562012, 0.564502466517908, -81.7399978637695, -1.42663209329591, 218, 13, 'PPL', 'P'),
(64531, 'Emit', 35.7397193908691, 0.623775777109529, -78.2569427490234, -1.36584131351516, 218, 33, 'PPL', 'P'),
(161355, 'Emlenton', 41.1772193908691, 0.71867805518672, -79.7080612182617, -1.39116810863987, 218, 45, 'PPL', 'P'),
(145170, 'Emleys Hill', 40.1430587768555, 0.700628547477736, -74.4833297729492, -1.29997934238668, 218, 37, 'PPL', 'P'),
(35768, 'Emlyn', 36.7044410705566, 0.640613346785446, -84.1433334350586, -1.4685782120452, 218, 21, 'PPL', 'P'),
(20894, 'Emma', 34.5077781677246, 0.60227434657461, -84.2241668701172, -1.46998902163267, 218, 13, 'PPL', 'P'),
(27101, 'Emma', 37.9747200012207, 0.662783896544246, -88.1202774047852, -1.53798897848426, 218, 18, 'PPL', 'P'),
(35769, 'Emma', 37.6352806091309, 0.656859561541311, -82.7002792358398, -1.44339216498411, 218, 21, 'PPL', 'P'),
(40812, 'Emma', 29.9383296966553, 0.52252242575423, -91.8855590820313, -1.60370554101722, 218, 22, 'PPL', 'P'),
(54632, 'Emma', 38.9716682434082, 0.680183925842388, -93.4944381713867, -1.63178577839296, 218, 29, 'PPL', 'P'),
(64532, 'Emma', 35.5966682434082, 0.621279063587579, -82.5919418334961, -1.44150132061015, 218, 33, 'PPL', 'P'),
(109088, 'Emma', 38.6369400024414, 0.674341815938108, -81.7141723632813, -1.42618135328141, 218, 58, 'PPL', 'P'),
(122577, 'Emma', 41.6111106872559, 0.726250886904415, -85.5411071777344, -1.49297396605282, 218, 19, 'PPL', 'P'),
(186685, 'Emma', 39.3650016784668, 0.68704888934234, -107.061111450195, -1.86856889565051, 218, 7, 'PPL', 'P'),
(20895, 'Emmalane', 32.7597198486328, 0.571764973389581, -81.9983291625977, -1.43114082502141, 218, 13, 'PPL', 'P'),
(35770, 'Emmalena', 37.334171295166, 0.651604212604203, -83.0744400024414, -1.44992250229309, 218, 21, 'PPL', 'P'),
(59809, 'Emmanuel', 31.3066692352295, 0.54640445598757, -89.8202819824219, -1.567659655663, 218, 30, 'PPL', 'P'),
(178160, 'Emmanuel Mission', 36.8022193908691, 0.642319900411969, -109.396667480469, -1.90933203824359, 218, 5, 'PPL', 'P'),
(109089, 'Emmart', 38.8830604553223, 0.678637428197379, -80.4738922119141, -1.40453438099292, 218, 58, 'PPL', 'P'),
(181447, 'Emmaton', 38.0802803039551, 0.664626271386363, -121.731109619141, -2.12460866496014, 218, 6, 'PPL', 'P'),
(94052, 'Emmaus', 32.0149993896484, 0.55876714937334, -95.0486068725586, -1.65891113935986, 218, 51, 'PPL', 'P'),
(161358, 'Emmaus', 40.5394401550293, 0.707546707620462, -75.4972229003906, -1.31767511572388, 218, 45, 'PPL', 'P'),
(101724, 'Emmaus (historical)', 37.2366714477539, 0.649902519246669, -79.658332824707, -1.39030018444061, 218, 53, 'PPL', 'P'),
(78216, 'Emmaville', 39.9102783203125, 0.696565762076765, -78.2497177124023, -1.36571521283755, 218, 45, 'PPL', 'P'),
(135233, 'Emmaville', 47.065559387207, 0.821448975599687, -94.9802780151367, -1.65771857582372, 218, 28, 'PPL', 'P'),
(70788, 'Emmelsville', 39.4877815246582, 0.689191801913472, -74.7677764892578, -1.30494387413276, 218, 37, 'PPL', 'P'),
(32359, 'Emmeram', 38.958610534668, 0.679956025832105, -99.1319427490234, -1.73017879486898, 218, 20, 'PPL', 'P'),
(174014, 'Emmerich', 45.0908317565918, 0.786983476615345, -89.8291702270508, -1.5678147847965, 218, 57, 'PPL', 'P'),
(101725, 'Emmerton', 37.899169921875, 0.661465298909521, -76.6800003051758, -1.33831847575557, 218, 53, 'PPL', 'P'),
(46889, 'Emmertsville', 39.5372200012207, 0.690054666106658, -77.7333297729492, -1.3567025430765, 218, 25, 'PPL', 'P'),
(8756, 'Emmet', 33.7261085510254, 0.588631638100407, -93.4702835083008, -1.63136419999241, 218, 4, 'PPL', 'P'),
(141775, 'Emmet', 42.4755592346191, 0.741338360269987, -98.8058319091797, -1.72448708698726, 218, 35, 'PPL', 'P'),
(170246, 'Emmet', 42.982780456543, 0.750191040628546, -96.7458267211914, -1.6885332138487, 218, 49, 'PPL', 'P'),
(198260, 'Emmet', 47.6463890075684, 0.831586364868101, -101.653060913086, -1.7741806076637, 218, 34, 'PPL', 'P'),
(115477, 'Emmetsburg', 43.1127815246582, 0.752459987298267, -94.6827774047852, -1.65252621064639, 218, 16, 'PPL', 'P'),
(32360, 'Emmett', 39.3072204589844, 0.686040416816554, -96.0558319091797, -1.67649053255742, 218, 20, 'PPL', 'P'),
(40813, 'Emmett', 32.0716705322266, 0.559756247402196, -93.442497253418, -1.6308792383579, 218, 22, 'PPL', 'P'),
(86801, 'Emmett', 36.5311088562012, 0.63758812894517, -82.1141662597656, -1.43316256376295, 218, 50, 'PPL', 'P'),
(109090, 'Emmett', 37.6824989318848, 0.657683676740636, -81.8272171020508, -1.428154356175, 218, 58, 'PPL', 'P'),
(112587, 'Emmett', 31.9874992370605, 0.558287181165881, -96.7925033569336, -1.68934787482616, 218, 51, 'PPL', 'P'),
(113202, 'Emmett', 41.230281829834, 0.719604169455795, -84.5538864135742, -1.47574371327417, 218, 41, 'PPL', 'P'),
(130680, 'Emmett', 42.9905586242676, 0.750326795265113, -82.7649993896484, -1.44452174476046, 218, 27, 'PPL', 'P'),
(194897, 'Emmett', 43.8736114501953, 0.765738974546592, -116.498329162598, -2.03327941695946, 218, 17, 'PPL', 'P'),
(54633, 'Emmett (historical)', 37.3261108398438, 0.651463531119619, -93.6530609130859, -1.63455426750416, 218, 29, 'PPL', 'P'),
(46890, 'Emmit Ridge', 39.7066688537598, 0.693012106497191, -77.3283309936523, -1.34963398091121, 218, 25, 'PPL', 'P'),
(46891, 'Emmitsburg', 39.7044410705566, 0.692973224345276, -77.3272171020508, -1.34961453983525, 218, 25, 'PPL', 'P'),
(46892, 'Emmitsburg Junction', 39.6080589294434, 0.691291038642727, -77.320556640625, -1.34949829285367, 218, 25, 'PPL', 'P'),
(86802, 'Emmitt Heights', 35.8972206115723, 0.626524691986708, -86.5661087036133, -1.51086361751737, 218, 50, 'PPL', 'P'),
(211814, 'Emmonak', 62.7777786254883, 1.09567893410289, -164.523056030273, -2.87146902317138, 218, 1, 'PPL', 'P'),
(8758, 'Emmons', 34.8086090087891, 0.607524835242729, -91.1549987792969, -1.59095485835014, 218, 4, 'PPL', 'P'),
(109091, 'Emmons', 38.2044410705566, 0.666793285565361, -81.7533264160156, -1.42686472041713, 218, 58, 'PPL', 'P'),
(135235, 'Emmons', 43.5019416809082, 0.759252113342405, -93.4880599975586, -1.6316744582594, 218, 28, 'PPL', 'P'),
(148686, 'Emmons', 42.4633293151855, 0.741124907908617, -75.0122222900391, -1.30921025819906, 218, 40, 'PPL', 'P'),
(161361, 'Emmons', 41.3072204589844, 0.720947001856441, -76.4388885498047, -1.33411028175909, 218, 45, 'PPL', 'P'),
(113407, 'Emmons City (historical)', 41.6894416809082, 0.727618020650007, -73.2602767944336, -1.27863304098526, 218, 8, 'PPL', 'P'),
(155183, 'Emmons Corner', 41.3263893127441, 0.721281561468382, -81.5369415283203, -1.42308809167529, 218, 41, 'PPL', 'P'),
(135236, 'Emmons Trailer Court', 43.5019416809082, 0.759252113342405, -93.4880599975586, -1.6316744582594, 218, 28, 'PPL', 'P'),
(148687, 'Emmonsburg', 43.1530609130859, 0.75316299524702, -74.7099990844727, -1.303935468186, 218, 40, 'PPL', 'P'),
(621, 'Emmorton', 39.4952812194824, 0.689322696281049, -76.3230590820313, -1.33208867617561, 218, 25, 'PPL', 'P'),
(8759, 'Emon', 33.3544387817383, 0.582144776896219, -93.2377777099609, -1.6273062082814, 218, 4, 'PPL', 'P'),
(2293, 'Emory', 31.8105602264404, 0.555199012855338, -88.4574966430664, -1.54387456449334, 218, 2, 'PPL', 'P'),
(20896, 'Emory', 33.788890838623, 0.58972739573092, -84.3208312988281, -1.47167613418324, 218, 13, 'PPL', 'P'),
(59810, 'Emory', 33.252498626709, 0.580365585550965, -89.9238891601563, -1.56946794204317, 218, 30, 'PPL', 'P'),
(80879, 'Emory', 33.9872207641602, 0.593188905936778, -81.70361328125, -1.42599706253398, 218, 48, 'PPL', 'P'),
(94053, 'Emory', 32.874439239502, 0.57376720447613, -95.7652816772461, -1.67141947436774, 218, 51, 'PPL', 'P'),
(101726, 'Emory', 36.7727813720703, 0.641806110058665, -81.8363876342773, -1.42831441215651, 218, 53, 'PPL', 'P'),
(203875, 'Emory', 41.0488891601563, 0.716438270130937, -111.303611755371, -1.94261449449269, 218, 52, 'PPL', 'P'),
(86805, 'Emory (historical)', 36.1763916015625, 0.63139714493809, -84.5908279418945, -1.47638846457408, 218, 50, 'PPL', 'P'),
(196432, 'Emory (historical)', 46.5338897705078, 0.81216959025547, -108.945831298828, -1.90146346248684, 218, 31, 'PPL', 'P'),
(127440, 'Emory Corner', 43.6122207641602, 0.761176846441232, -70.541389465332, -1.23117950510169, 218, 26, 'PPL', 'P'),
(20898, 'Emory Estates', 33.7902793884277, 0.58975163049684, -84.3144378662109, -1.47156454773356, 218, 13, 'PPL', 'P'),
(86803, 'Emory Estates', 36.0763893127441, 0.62965177573868, -83.9736099243164, -1.46561597796471, 218, 50, 'PPL', 'P'),
(86804, 'Emory Gap', 35.9166717529297, 0.626864178446666, -84.5749969482422, -1.47611216161098, 218, 50, 'PPL', 'P'),
(46894, 'Emory Grove', 39.148609161377, 0.683272127442444, -77.1677780151367, -1.34683180281223, 218, 25, 'PPL', 'P'),
(86807, 'Emory Heights', 35.9308280944824, 0.627111253216799, -84.5272216796875, -1.47527832587368, 218, 50, 'PPL', 'P'),
(20899, 'Emory Highlands', 33.7886085510254, 0.589722468882903, -84.317497253418, -1.47161794411342, 218, 13, 'PPL', 'P'),
(86809, 'Emory Valley', 36.0269393920898, 0.628788711808412, -84.2122192382813, -1.46978049611932, 218, 50, 'PPL', 'P'),
(109093, 'Emoryville', 39.353328704834, 0.686845157518949, -79.1705627441406, -1.38178699054201, 218, 58, 'PPL', 'P'),
(64535, 'Emorywood Estates', 36.1411094665527, 0.630781355515037, -80.0800018310547, -1.39765969695499, 218, 33, 'PPL', 'P'),
(148688, 'Empeyville', 43.396671295166, 0.757414798506359, -75.6852798461914, -1.32095732860935, 218, 40, 'PPL', 'P'),
(2294, 'Empire', 33.8083305358887, 0.590066682453796, -87.0105590820313, -1.5186207399825, 218, 2, 'PPL', 'P'),
(8760, 'Empire', 33.121940612793, 0.578086918343266, -91.4352798461914, -1.59584668579845, 218, 4, 'PPL', 'P'),
(20900, 'Empire', 32.3402786254883, 0.564444343027117, -83.29638671875, -1.45379620325666, 218, 13, 'PPL', 'P'),
(35773, 'Empire', 37.0863914489746, 0.647279638468078, -87.4972229003906, -1.5271146259632, 218, 21, 'PPL', 'P'),
(40814, 'Empire', 29.3875007629395, 0.512908647245639, -89.5972213745117, -1.56376651362347, 218, 22, 'PPL', 'P'),
(54634, 'Empire', 36.7633285522461, 0.641641127229135, -90.315559387207, -1.57630387708723, 218, 29, 'PPL', 'P'),
(59811, 'Empire', 33.2188911437988, 0.579779024320875, -90.8313903808594, -1.5853068263103, 218, 30, 'PPL', 'P'),
(119540, 'Empire', 40.3055610656738, 0.703464747459643, -88.7074966430664, -1.54823788762333, 218, 18, 'PPL', 'P'),
(127441, 'Empire', 44.0538902282715, 0.768885432795494, -70.3247222900391, -1.22739794951183, 218, 26, 'PPL', 'P'),
(130685, 'Empire', 44.8111114501953, 0.782101436284039, -86.0599975585938, -1.50203031165574, 218, 27, 'PPL', 'P'),
(135238, 'Empire', 44.6591682434082, 0.779449527049566, -93.0144424438477, -1.6234082725519, 218, 28, 'PPL', 'P'),
(155184, 'Empire', 40.5074996948242, 0.706989241425281, -80.6241683959961, -1.40715719519249, 218, 41, 'PPL', 'P'),
(181448, 'Empire', 37.6383285522461, 0.656912758184085, -120.901107788086, -2.11012240021066, 218, 6, 'PPL', 'P'),
(186686, 'Empire', 39.7613906860352, 0.69396718264312, -105.683891296387, -1.84453186944173, 218, 7, 'PPL', 'P'),
(199944, 'Empire', 40.5758285522461, 0.708181804961418, -119.341110229492, -2.08289530649012, 218, 39, 'PPL', 'P'),
(202100, 'Empire', 44.6175003051758, 0.778722284334892, -103.320831298828, -1.80328869206216, 218, 49, 'PPL', 'P'),
(181450, 'Empire (historical)', 39.8261108398438, 0.695096762419477, -123.593063354492, -2.15710588816184, 218, 6, 'PPL', 'P'),
(32362, 'Empire City', 37.089168548584, 0.647328107999917, -94.6416702270508, -1.65180875504873, 218, 20, 'PPL', 'P'),
(75770, 'Empire City', 34.420280456543, 0.600747223426532, -98.0266723632813, -1.71088818751299, 218, 42, 'PPL', 'P'),
(194898, 'Empire City (historical)', 42.978328704834, 0.750113342903743, -116.71028137207, -2.03697868087163, 218, 17, 'PPL', 'P'),
(119541, 'Empire Hills', 41.9566688537598, 0.732282014667063, -88.4283294677734, -1.54336550125097, 218, 18, 'PPL', 'P'),
(139139, 'Empire Prairie', 40.0830612182617, 0.699581392537116, -94.6388931274414, -1.65176028551689, 218, 29, 'PPL', 'P'),
(188518, 'Emplazado', 35.7394409179688, 0.623770916840539, -105.188888549805, -1.83589244170746, 218, 38, 'PPL', 'P'),
(15935, 'Emporia', 29.1988906860352, 0.509616780401219, -81.4683303833008, -1.42189060129113, 218, 12, 'PPL', 'P'),
(32365, 'Emporia', 38.4038887023926, 0.670274303426203, -96.1813888549805, -1.67868191466039, 218, 20, 'PPL', 'P'),
(101727, 'Emporia', 36.6858291625977, 0.640288507711483, -77.5427780151367, -1.35337678750721, 218, 53, 'PPL', 'P'),
(122578, 'Emporia', 40.0044403076172, 0.698209198785453, -85.6338882446289, -1.49459330115364, 218, 19, 'PPL', 'P'),
(32366, 'Emporia Junction', 38.4027786254883, 0.670254928929273, -96.1611099243164, -1.67832798055152, 218, 20, 'PPL', 'P'),
(161362, 'Emporium', 41.5113906860352, 0.724510444553021, -78.2355575561523, -1.36546807148839, 218, 45, 'PPL', 'P'),
(20901, 'Empress', 30.6713905334473, 0.535316750973675, -83.5658264160156, -1.45849881310953, 218, 13, 'PPL', 'P'),
(203878, 'Empress Condominium', 40.7791709899902, 0.711730800009085, -111.861106872559, -1.9523446198514, 218, 52, 'PPL', 'P'),
(75771, 'Empy', 36.2222213745117, 0.632197025371496, -96.3197174072266, -1.6810962033466, 218, 42, 'PPL', 'P'),
(139974, 'Emrick', 47.5947189331055, 0.830684551943973, -99.5116729736328, -1.73680633755775, 218, 34, 'PPL', 'P'),
(75772, 'Emsey', 35.7675018310547, 0.624260672165005, -97.024169921875, -1.69339121915117, 218, 42, 'PPL', 'P'),
(161364, 'Emsworth', 40.5099983215332, 0.707032850688131, -80.0947189331055, -1.39791655884213, 218, 45, 'PPL', 'P'),
(188519, 'En Medio', 35.8258285522461, 0.625278665491688, -105.90389251709, -1.8483716151014, 218, 38, 'PPL', 'P'),
(20902, 'Enal (historical)', 32.3013916015625, 0.56376563642331, -81.7766723632813, -1.42727218406391, 218, 13, 'PPL', 'P'),
(8761, 'Enarc (historical)', 35.0291709899902, 0.611374368019411, -91.5508270263672, -1.59786336453392, 218, 4, 'PPL', 'P'),
(194899, 'Enaville', 47.5625, 0.830122225479803, -116.249168395996, -2.02893074121547, 218, 17, 'PPL', 'P'),
(40815, 'Encalade', 29.5191707611084, 0.515206722239782, -89.7302780151367, -1.56608879009402, 218, 22, 'PPL', 'P'),
(209439, 'Encampment', 41.2094383239746, 0.719240381650891, -106.789169311523, -1.86382260995577, 218, 59, 'PPL', 'P'),
(94054, 'Encantada Colonia', 26.0289993286133, 0.454291739283695, -97.6279983520508, -1.70393001337488, 218, 51, 'PPL', 'P'),
(94055, 'Encantada-Ranchito El Calaboz', 26.0259208679199, 0.454238010008703, -97.630126953125, -1.70396716447209, 218, 51, 'PPL', 'P'),
(181452, 'Encanto', 32.7119407653809, 0.57093107107325, -117.049438476563, -2.04289808902655, 218, 6, 'PPL', 'P'),
(13726, 'Enchanted Acres Mobile Home Park', 38.6305618286133, 0.674230495804543, -75.1763916015625, -1.31207555321588, 218, 10, 'PPL', 'P'),
(80880, 'Enchanted Forest', 34.8716697692871, 0.608625453142231, -82.4622192382813, -1.43923723420942, 218, 48, 'PPL', 'P'),
(2295, 'Enchanted Hills', 33.517219543457, 0.584985837147116, -86.2375030517578, -1.50512836695183, 218, 2, 'PPL', 'P'),
(80881, 'Enchanted Hills', 34.7069396972656, 0.605750371008409, -82.9105606079102, -1.44706226728234, 218, 48, 'PPL', 'P'),
(122579, 'Enchanted Hills', 41.4019393920898, 0.722600159103107, -85.6666717529297, -1.49516548131385, 218, 19, 'PPL', 'P'),
(181453, 'Enchanted Hills', 38.3830604553223, 0.669910781937407, -122.425003051758, -2.13671939001728, 218, 6, 'PPL', 'P'),
(203885, 'Enchanted Hills', 40.6155586242676, 0.708875225530248, -111.797218322754, -1.95122955430299, 218, 52, 'PPL', 'P'),
(80882, 'Enchanted Meadows', 34.1591682434082, 0.596189955590161, -79.8038864135742, -1.39284057380444, 218, 48, 'PPL', 'P'),
(94056, 'Enchanted Oaks', 32.2652816772461, 0.563135399351343, -96.1091690063477, -1.67742144051645, 218, 51, 'PPL', 'P'),
(15936, 'Enchanted Park', 30.2455596923828, 0.527884600740563, -81.7702789306641, -1.42716059761424, 218, 12, 'PPL', 'P'),
(94057, 'Enchanted Valley Ranch Colonia', 26.2439994812012, 0.458044199838644, -98.4049987792969, -1.71749122911973, 218, 51, 'PPL', 'P'),
(200774, 'Encina', 44.6916694641113, 0.780016780361752, -117.690277099609, -2.05408283297267, 218, 43, 'PPL', 'P'),
(94058, 'Encinal', 28.0408306121826, 0.489404819176604, -99.3541717529297, -1.73405742268057, 218, 51, 'PPL', 'P'),
(177659, 'Encinal', 39.2155609130859, 0.684440655949743, -121.66056060791, -2.12337735243015, 218, 6, 'PPL', 'P'),
(188520, 'Encinal', 35.1172218322754, 0.612911145126442, -107.464172363281, -1.87560363566995, 218, 38, 'PPL', 'P'),
(181455, 'Encinitas', 33.0369415283203, 0.576603404458037, -117.291107177734, -2.04711600356102, 218, 6, 'PPL', 'P'),
(94059, 'Encino', 26.9358291625977, 0.470118905642036, -98.1350021362305, -1.71277889872889, 218, 51, 'PPL', 'P'),
(181456, 'Encino', 34.1591682434082, 0.596189955590161, -118.500282287598, -2.0682200904613, 218, 6, 'PPL', 'P'),
(188521, 'Encino', 34.6511116027832, 0.604775986944576, -105.461112976074, -1.84064365425021, 218, 38, 'PPL', 'P'),
(94060, 'Encino Heights Colonia', 26.2189998626709, 0.457607874183548, -98.1480026245117, -1.71300580005377, 218, 51, 'PPL', 'P'),
(94061, 'Encino Number 1 Colonia', 26.1429996490479, 0.456281420223607, -97.9970016479492, -1.71037033583902, 218, 51, 'PPL', 'P'),
(188522, 'Encinoso', 33.6855583190918, 0.587923903040719, -105.482780456543, -1.841021823125, 218, 38, 'PPL', 'P'),
(161366, 'Endeavor', 41.5894393920898, 0.725872651450597, -79.3852767944336, -1.38553445766992, 218, 45, 'PPL', 'P'),
(174018, 'Endeavor', 43.7158317565918, 0.762985199400423, -89.4661102294922, -1.56147819245682, 218, 57, 'PPL', 'P'),
(35771, 'Endee', 37.4297218322754, 0.65327188407881, -83.7541732788086, -1.46178608600106, 218, 21, 'PPL', 'P'),
(188523, 'Endee', 35.1377792358398, 0.613269939504302, -103.107223510742, -1.79956053285216, 218, 38, 'PPL', 'P'),
(139975, 'Enderlin', 46.6230583190918, 0.813725875017485, -97.6011123657227, -1.70346076439081, 218, 34, 'PPL', 'P'),
(8762, 'Enders', 35.3266716003418, 0.616566733196739, -92.2283325195313, -1.60968806608998, 218, 4, 'PPL', 'P'),
(161367, 'Enders', 40.4916687011719, 0.706712938462185, -76.8499984741211, -1.34128550352603, 218, 45, 'PPL', 'P'),
(199305, 'Enders', 40.4552803039551, 0.706077841121229, -101.533332824707, -1.77209095831437, 218, 35, 'PPL', 'P'),
(200775, 'Endersby', 45.4925003051758, 0.793993915289843, -121.150833129883, -2.11448092965068, 218, 43, 'PPL', 'P'),
(35772, 'Endicott', 37.666389465332, 0.657402513508551, -82.6386108398438, -1.44231584842955, 218, 21, 'PPL', 'P'),
(101729, 'Endicott', 36.8875007629395, 0.643808341145214, -80.1500015258789, -1.39888142210507, 218, 53, 'PPL', 'P'),
(109092, 'Endicott', 39.6780586242676, 0.692512763792801, -80.5838928222656, -1.40645425382276, 218, 58, 'PPL', 'P'),
(124789, 'Endicott', 42.2316703796387, 0.737081696741658, -71.158332824707, -1.24194719802109, 218, 23, 'PPL', 'P'),
(141777, 'Endicott', 40.0833282470703, 0.699586053069024, -97.0980606079102, -1.69468085490904, 218, 35, 'PPL', 'P'),
(148689, 'Endicott', 42.098331451416, 0.734754493423093, -76.0497207641602, -1.32731802255689, 218, 40, 'PPL', 'P'),
(207337, 'Endicott', 46.9258308410645, 0.819010252410475, -117.681938171387, -2.05393729121909, 218, 56, 'PPL', 'P'),
(193224, 'Endot', 40.5880584716797, 0.708395257322788, -111.902496337891, -1.95306700229709, 218, 52, 'PPL', 'P'),
(59814, 'Endville', 34.3222198486328, 0.599035742951992, -88.883056640625, -1.55130198761552, 218, 30, 'PPL', 'P'),
(148690, 'Endwell', 42.1127815246582, 0.735006694778323, -76.0213928222656, -1.32682360670052, 218, 40, 'PPL', 'P'),
(64536, 'Endy', 35.3047218322754, 0.616183637473931, -80.2758331298828, -1.401077597898, 218, 33, 'PPL', 'P'),
(20903, 'Eneck (historical)', 32.600830078125, 0.568991823746482, -81.4027786254883, -1.42074650728683, 218, 13, 'PPL', 'P'),
(27103, 'Energy', 37.7738914489746, 0.659278777075539, -89.0263900756836, -1.55380362798548, 218, 18, 'PPL', 'P'),
(59813, 'Energy', 32.1794395446777, 0.561637171501091, -88.5497207641602, -1.54548417905618, 218, 30, 'PPL', 'P'),
(94063, 'Energy', 31.7627792358398, 0.554365077249494, -98.3691711425781, -1.71686591889578, 218, 51, 'PPL', 'P'),
(139141, 'Energy', 40.4041709899902, 0.705185815314106, -92.3455581665039, -1.61173403959743, 218, 29, 'PPL', 'P'),
(161368, 'Energy', 40.9294395446777, 0.714353481050595, -80.2649993896484, -1.4008885134606, 218, 45, 'PPL', 'P'),
(207339, 'Enetai', 47.5849990844727, 0.830514908582535, -122.597503662109, -2.13973009362961, 218, 56, 'PPL', 'P'),
(27104, 'Enfield', 38.0994415283203, 0.66496069784025, -88.3375015258789, -1.5417802546121, 218, 18, 'PPL', 'P'),
(64538, 'Enfield', 36.1808280944824, 0.631474576346784, -77.6669387817383, -1.35554380168621, 218, 33, 'PPL', 'P'),
(101730, 'Enfield', 37.7452812194824, 0.658779434371149, -77.2188873291016, -1.34772382861935, 218, 53, 'PPL', 'P'),
(113408, 'Enfield', 41.9761085510254, 0.732621301389939, -72.5922164916992, -1.26697318910068, 218, 8, 'PPL', 'P'),
(127442, 'Enfield', 45.2488899230957, 0.789742112030504, -68.5688934326172, -1.19675295484829, 218, 26, 'PPL', 'P'),
(135240, 'Enfield', 45.3574981689453, 0.791637683515395, -93.9311065673828, -1.6394070796425, 218, 28, 'PPL', 'P'),
(143800, 'Enfield', 43.6405601501465, 0.761671462034687, -72.1444396972656, -1.25915800972379, 218, 36, 'PPL', 'P'),
(148691, 'Enfield', 42.4358291625977, 0.740644939701157, -76.6316680908203, -1.33747491948029, 218, 40, 'PPL', 'P'),
(161369, 'Enfield', 40.0961112976074, 0.699809159389346, -75.1969375610352, -1.31243414785666, 218, 45, 'PPL', 'P'),
(124790, 'Enfield (historical)', 42.3166694641113, 0.738565210626887, -72.3333282470703, -1.2624547368372, 218, 23, 'PPL', 'P'),
(155185, 'Enfield (historical)', 40.2930603027344, 0.703246567987338, -81.0597229003906, -1.41475905536606, 218, 41, 'PPL', 'P'),
(143801, 'Enfield Center', 43.5900001525879, 0.760789023607489, -72.1113891601563, -1.25858116903168, 218, 36, 'PPL', 'P'),
(130684, 'Engadine', 46.1166687011719, 0.804887708886866, -85.5708312988281, -1.49349274983317, 218, 27, 'PPL', 'P'),
(8763, 'Engelberg', 36.3377799987793, 0.63421390384404, -90.9091720581055, -1.58666437267597, 218, 4, 'PPL', 'P'),
(64540, 'Engelhard', 35.5094413757324, 0.619756667550436, -75.9963912963867, -1.32638724775591, 218, 33, 'PPL', 'P'),
(178161, 'Engesser Junction', 33.2011108398438, 0.579468699474853, -113.871673583984, -1.98743562879678, 218, 5, 'PPL', 'P'),
(181457, 'Engineer Springs', 32.628059387207, 0.569467064843006, -116.764167785645, -2.03791917621059, 218, 6, 'PPL', 'P'),
(8764, 'England', 34.5441703796387, 0.602909510494594, -91.9688873291016, -1.60515989328852, 218, 4, 'PPL', 'P'),
(75773, 'England', 35.8844413757324, 0.626301652245414, -94.6677780151367, -1.65226442191124, 218, 42, 'PPL', 'P'),
(155186, 'England', 40.8402786254883, 0.712797329446635, -82.2394409179688, -1.4353490190179, 218, 41, 'PPL', 'P'),
(46895, 'England Estates', 39.621940612793, 0.691533319722897, -76.8258285522461, -1.34086365880936, 218, 25, 'PPL', 'P'),
(101731, 'England Run', 38.3566703796387, 0.669450188226878, -77.503059387207, -1.35268356667546, 218, 53, 'PPL', 'P'),
(46896, 'Englandtowne', 39.3408317565918, 0.686627044625671, -77.2577819824219, -1.34840266838121, 218, 25, 'PPL', 'P'),
(46897, 'Englars Mill', 39.5108299255371, 0.689594072396129, -77.1266708374023, -1.34611434721456, 218, 25, 'PPL', 'P'),
(35774, 'Engle', 37.3861083984375, 0.652510686060238, -83.2705612182617, -1.45334546324217, 218, 21, 'PPL', 'P'),
(94064, 'Engle', 29.6808300018311, 0.518028208256667, -97.0091705322266, -1.69312943041601, 218, 51, 'PPL', 'P'),
(109094, 'Engle', 39.3441696166992, 0.686685301274517, -77.7813873291016, -1.35754130566182, 218, 58, 'PPL', 'P'),
(188524, 'Engle', 33.1769409179688, 0.579046854758185, -107.030830383301, -1.86804039133218, 218, 38, 'PPL', 'P'),
(54637, 'Engle (historical)', 38.3213882446289, 0.668834398803825, -90.399169921875, -1.57776315620654, 218, 29, 'PPL', 'P'),
(46898, 'Engle Mill', 39.6469383239746, 0.691969612088479, -79.2866668701172, -1.38381338981545, 218, 25, 'PPL', 'P'),
(8765, 'Engledale (historical)', 35.4041709899902, 0.61791935271439, -90.2519378662109, -1.57519347207073, 218, 4, 'PPL', 'P'),
(94065, 'Engleman Estates Colonia', 26.3419990539551, 0.459754615048748, -98.0339965820313, -1.71101601924531, 218, 51, 'PPL', 'P'),
(94066, 'Engleman Gardens', 26.3311100006104, 0.459564565215457, -98.0188903808594, -1.71075236629739, 218, 51, 'PPL', 'P'),
(78217, 'Engles Mill', 39.7527809143066, 0.693816913778613, -79.061393737793, -1.37988163194011, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(161374, 'Engleside', 40.0230598449707, 0.69853417101747, -76.3047180175781, -1.33176856421258, 218, 45, 'PPL', 'P'),
(161370, 'Englesville', 40.3177795410156, 0.703678000083931, -75.6427764892578, -1.32021550508771, 218, 45, 'PPL', 'P'),
(40816, 'Engleswood', 30.5561103820801, 0.53330473277012, -91.1458282470703, -1.59079480236863, 218, 22, 'PPL', 'P'),
(32369, 'Englevale', 37.5938911437988, 0.656137179095627, -94.7272186279297, -1.65330185631388, 218, 20, 'PPL', 'P'),
(139978, 'Englevale', 46.3927803039551, 0.809706765458392, -97.9130630493164, -1.70890533092337, 218, 34, 'PPL', 'P'),
(148693, 'Engleville', 42.7550010681152, 0.746215540332303, -74.6488876342773, -1.30286887216942, 218, 40, 'PPL', 'P'),
(186687, 'Engleville', 37.1494407653809, 0.648380056630498, -104.474716186523, -1.82342778254145, 218, 7, 'PPL', 'P'),
(2297, 'Englewood', 33.1116714477539, 0.577907687601903, -87.5597229003906, -1.5282054567457, 218, 2, 'PPL', 'P'),
(15938, 'Englewood', 26.961669921875, 0.470569911972641, -82.352783203125, -1.43732721507561, 218, 12, 'PPL', 'P'),
(20905, 'Englewood', 33.934440612793, 0.592267718515719, -83.5625, -1.45844075619776, 218, 13, 'PPL', 'P'),
(29726, 'Englewood', 38.8444404602051, 0.67796338212548, -86.4980621337891, -1.50967598082925, 218, 19, 'PPL', 'P'),
(32370, 'Englewood', 37.038330078125, 0.64644080930373, -99.9830627441406, -1.74503364111333, 218, 20, 'PPL', 'P'),
(40818, 'Englewood', 29.663890838623, 0.517732564086154, -91.1291732788086, -1.59050411833565, 218, 22, 'PPL', 'P'),
(54636, 'Englewood', 39.0869407653809, 0.682195810887888, -94.4558334350586, -1.64856529115712, 218, 29, 'PPL', 'P'),
(64541, 'Englewood', 35.5916709899902, 0.621191845061879, -77.3550033569336, -1.35009950146976, 218, 33, 'PPL', 'P'),
(72457, 'Englewood', 39.877498626709, 0.695993648495589, -84.3022232055664, -1.4713513616883, 218, 41, 'PPL', 'P'),
(80888, 'Englewood', 34.5563888549805, 0.603122763118882, -82.6263885498047, -1.44210252922623, 218, 48, 'PPL', 'P'),
(86814, 'Englewood', 36.3763885498047, 0.634887750178857, -82.4008331298828, -1.43816584450288, 218, 50, 'PPL', 'P'),
(101733, 'Englewood', 37.2358283996582, 0.649887805281647, -79.9430618286133, -1.3952696430347, 218, 53, 'PPL', 'P'),
(119543, 'Englewood', 41.7797203063965, 0.729193679908953, -87.6458282470703, -1.52970827854883, 218, 18, 'PPL', 'P'),
(124791, 'Englewood', 41.6458282470703, 0.726856822631435, -70.2472229003906, -1.22604532999418, 218, 23, 'PPL', 'P'),
(145171, 'Englewood', 40.8927803039551, 0.713713656598704, -73.9730606079102, -1.29107346538535, 218, 37, 'PPL', 'P'),
(161372, 'Englewood', 40.7838897705078, 0.711813158265796, -76.2422180175781, -1.33067773343008, 218, 45, 'PPL', 'P'),
(174020, 'Englewood', 43.4286117553711, 0.75797226470154, -89.0749969482422, -1.55465197795073, 218, 57, 'PPL', 'P'),
(186688, 'Englewood', 39.6477813720703, 0.691984326053502, -104.98722076416, -1.83237267485275, 218, 7, 'PPL', 'P'),
(193526, 'Englewood', 40.396671295166, 0.705054920946529, -123.937782287598, -2.16312236853849, 218, 6, 'PPL', 'P'),
(200776, 'Englewood', 45.4361114501953, 0.793009744109004, -122.695281982422, -2.14143664725614, 218, 43, 'PPL', 'P'),
(202101, 'Englewood', 44.2969398498535, 0.773127448937826, -103.784172058105, -1.81137551387024, 218, 49, 'PPL', 'P'),
(145172, 'Englewood Cliffs', 40.8852806091309, 0.713582762231126, -73.9527816772461, -1.29071953127648, 218, 37, 'PPL', 'P'),
(203883, 'Englewood Heights', 40.6586112976074, 0.709626636431814, -111.975563049316, -1.95434225698507, 218, 52, 'PPL', 'P'),
(8766, 'English', 34.1766700744629, 0.596495420167193, -91.6549987792969, -1.59968150461011, 218, 4, 'PPL', 'P'),
(29727, 'English', 38.3344383239746, 0.669062165656054, -86.4641723632813, -1.50908449275114, 218, 19, 'PPL', 'P'),
(35775, 'English', 38.6283302307129, 0.674191547073601, -85.128059387207, -1.48576492214003, 218, 21, 'PPL', 'P'),
(40819, 'English', 32.2597198486328, 0.563038327129609, -92.7916717529297, -1.61952019051844, 218, 22, 'PPL', 'P'),
(64544, 'English', 35.9502792358398, 0.627450739676756, -82.5269393920898, -1.44036681398578, 218, 33, 'PPL', 'P'),
(94069, 'English', 33.627498626709, 0.586910570245943, -94.8591690063477, -1.65560482486652, 218, 51, 'PPL', 'P'),
(109096, 'English', 37.3377799987793, 0.651667196363983, -81.7152786254883, -1.42620066119932, 218, 58, 'PPL', 'P'),
(207340, 'English', 48.1525001525879, 0.840419670729731, -122.206939697266, -2.13291346650345, 218, 56, 'PPL', 'P'),
(80883, 'English (historical)', 34.0777816772461, 0.59476949204374, -80.6947174072266, -1.40838850772249, 218, 48, 'PPL', 'P'),
(200777, 'English (historical)', 45.5916709899902, 0.795724770261312, -121.012496948242, -2.11206650780642, 218, 43, 'PPL', 'P'),
(94070, 'English Acres Colonia', 27.7099990844727, 0.483630719748662, -98.129997253418, -1.71269154704514, 218, 51, 'PPL', 'P'),
(181458, 'English Bar (historical)', 39.8705596923828, 0.695872541245018, -120.815559387207, -2.10862929894551, 218, 6, 'PPL', 'P'),
(161373, 'English Center', 41.4372215270996, 0.723215948526161, -77.2799987792969, -1.34879042463593, 218, 45, 'PPL', 'P'),
(46899, 'English Consul', 39.2452812194824, 0.684959373151064, -76.6405563354492, -1.33763004861379, 218, 25, 'PPL', 'P'),
(70790, 'English Creek', 39.3491706848145, 0.686772586379244, -74.6711120605469, -1.30325676158219, 218, 37, 'PPL', 'P'),
(86815, 'English Creek', 35.9013900756836, 0.626597462863495, -83.2244415283203, -1.45254052280269, 218, 50, 'PPL', 'P'),
(70803, 'English Creek Landing', 39.3347206115723, 0.686520385024014, -74.6783294677734, -1.30338272910175, 218, 37, 'PPL', 'P'),
(94071, 'English Crossing', 29.6813907623291, 0.518037995373673, -98.9755630493164, -1.72744945422581, 218, 51, 'PPL', 'P'),
(80884, 'English Crossroads', 34.1155586242676, 0.595428824150616, -80.2225036621094, -1.40014682309702, 218, 48, 'PPL', 'P'),
(20906, 'English Eddy', 31.9691696166992, 0.557967268939935, -82.3566665649414, -1.43739499252536, 218, 13, 'PPL', 'P'),
(20907, 'English Heights', 33.7644386291504, 0.589300624166235, -84.7108306884766, -1.47848290761337, 218, 13, 'PPL', 'P'),
(101734, 'English Hills', 37.6277809143066, 0.656728667173733, -77.5569381713867, -1.35362392885637, 218, 53, 'PPL', 'P'),
(122581, 'English Lake', 41.2658309936523, 0.720224619410757, -86.8236083984375, -1.51535783501494, 218, 19, 'PPL', 'P'),
(46935, 'English Manor', 39.0877799987793, 0.682210458273884, -77.086669921875, -1.3454161995348, 218, 25, 'PPL', 'P'),
(161376, 'English Manor', 40.2561111450195, 0.702601683529375, -76.7724990844727, -1.33993288400838, 218, 45, 'PPL', 'P'),
(161375, 'English Mills', 41.3458290100098, 0.721620848191258, -77.3583297729492, -1.35015755838152, 218, 45, 'PPL', 'P'),
(8767, 'English Place', 34.3908309936523, 0.600233233336147, -92.1841735839844, -1.60891734727051, 218, 4, 'PPL', 'P'),
(194900, 'English point', 47.7866706848145, 0.834034742016266, -116.708892822266, -2.03695444610571, 218, 17, 'PPL', 'P'),
(54638, 'English Town', 37.622501373291, 0.656636521800016, -90.6402816772461, -1.58197135020303, 218, 29, 'PPL', 'P'),
(181459, 'English Town', 37.1794395446777, 0.648903634100808, -121.83805847168, -2.12647527456818, 218, 6, 'PPL', 'P'),
(40820, 'English Turn', 29.875280380249, 0.521422007591809, -89.9649963378906, -1.57018539764083, 218, 22, 'PPL', 'P'),
(2301, 'English Village', 34.6263885498047, 0.604344488268956, -86.5697174072266, -1.51092660127715, 218, 2, 'PPL', 'P'),
(13727, 'English Village', 39.7208290100098, 0.69325924784635, -75.6986083984375, -1.32118995573057, 218, 10, 'PPL', 'P'),
(46901, 'English Village', 38.9880599975586, 0.68047001592249, -77.1155624389648, -1.34592046908721, 218, 25, 'PPL', 'P'),
(72458, 'English Woods', 39.139720916748, 0.683116998308947, -84.5569381713867, -1.47579697649597, 218, 41, 'PPL', 'P'),
(145175, 'Englishtown', 40.2972183227539, 0.703319139127043, -74.3586120605469, -1.29780260766971, 218, 37, 'PPL', 'P'),
(72459, 'Englishville', 39.1127815246582, 0.682646817218493, -82.6069412231445, -1.4417631093453, 218, 41, 'PPL', 'P'),
(130695, 'Englishville', 43.1166687011719, 0.752527831327036, -85.6902770996094, -1.49557747233448, 218, 27, 'PPL', 'P'),
(135241, 'Englund', 48.4858283996582, 0.846237346131009, -96.6277770996094, -1.68647285927136, 218, 28, 'PPL', 'P'),
(8768, 'Engman (historical)', 35.519718170166, 0.619936031449852, -90.5827789306641, -1.58096773794624, 218, 4, 'PPL', 'P'),
(161377, 'Enhaut', 40.2316703796387, 0.702175111701772, -76.8272171020508, -1.34088789357528, 218, 45, 'PPL', 'P'),
(59815, 'Enid', 34.1163902282715, 0.595443338378557, -89.9397201538086, -1.56974424500626, 218, 30, 'PPL', 'P'),
(75774, 'Enid', 36.3955612182617, 0.635222376369826, -97.878059387207, -1.70829440176931, 218, 42, 'PPL', 'P'),
(161378, 'Enid', 40.1005592346191, 0.699886790535121, -78.1158294677734, -1.36337842213906, 218, 45, 'PPL', 'P'),
(178162, 'Enid', 33.0724983215332, 0.577223987571053, -112.201110839844, -1.95827880855037, 218, 5, 'PPL', 'P'),
(196433, 'Enid', 47.6955604553223, 0.832444568529379, -104.779167175293, -1.82874145470643, 218, 31, 'PPL', 'P'),
(20909, 'Enigma', 31.4127807617188, 0.548256451499125, -83.3291702270508, -1.45436838341687, 218, 13, 'PPL', 'P'),
(119544, 'Enion', 40.2750015258789, 0.702931382872327, -90.1772232055664, -1.57388945524297, 218, 18, 'PPL', 'P'),
(181460, 'Eniwetok Housing Area', 34.8716697692871, 0.608625453142231, -116.962219238281, -2.04137582614746, 218, 6, 'PPL', 'P'),
(64545, 'Enka', 35.5497207641602, 0.620459675499189, -82.6502838134766, -1.44251958025294, 218, 33, 'PPL', 'P'),
(64546, 'Enka Village', 35.540828704834, 0.620304479786665, -82.6447219848633, -1.44242250803121, 218, 33, 'PPL', 'P'),
(94072, 'Enloe', 33.4327812194824, 0.583512110378893, -95.6572189331055, -1.66953342368375, 218, 51, 'PPL', 'P'),
(139979, 'Enloe', 46.4997215270996, 0.811573241908374, -96.7572174072266, -1.68873201882407, 218, 34, 'PPL', 'P'),
(161379, 'Enlow', 40.4541702270508, 0.706058466624298, -80.2333297729492, -1.40033577437636, 218, 45, 'PPL', 'P'),
(46902, 'Ennalls (historical)', 38.6005592346191, 0.673706851755206, -75.8475036621094, -1.32378866832227, 218, 25, 'PPL', 'P'),
(148694, 'Ennerdale', 42.8758316040039, 0.74832443102051, -77.1797180175781, -1.34704019516753, 218, 40, 'PPL', 'P'),
(64548, 'Ennice', 36.5533294677734, 0.637975951778913, -80.9961090087891, -1.41364878350761, 218, 33, 'PPL', 'P'),
(202103, 'Enning', 44.5755615234375, 0.777990314509284, -102.562782287598, -1.7900582409247, 218, 49, 'PPL', 'P'),
(20908, 'Ennis', 32.9105606079102, 0.574397641285179, -82.9822235107422, -1.4483130208883, 218, 13, 'PPL', 'P'),
(35776, 'Ennis', 37.1983299255371, 0.64923333344376, -86.9741668701172, -1.51798557606252, 218, 21, 'PPL', 'P'),
(94073, 'Ennis', 32.3291702270508, 0.564250464899759, -96.625, -1.68642438973952, 218, 51, 'PPL', 'P'),
(109097, 'Ennis', 37.3758316040039, 0.652331322160822, -81.3930587768555, -1.4205768639254, 218, 58, 'PPL', 'P'),
(181461, 'Ennis', 34.0094413757324, 0.593576728770521, -117.428611755371, -2.04951591117734, 218, 6, 'PPL', 'P'),
(196434, 'Ennis', 45.3488883972168, 0.791487414650887, -111.728889465332, -1.95003699076685, 218, 31, 'PPL', 'P'),
(207341, 'Ennis', 46.2374992370605, 0.806996599575073, -118.368057250977, -2.06591232821869, 218, 56, 'PPL', 'P'),
(161380, 'Ennisville', 40.6361083984375, 0.709233886750054, -77.8466720581055, -1.35868073913421, 218, 45, 'PPL', 'P'),
(64549, 'Eno', 36.0411109924316, 0.629036052894653, -79.0144424438477, -1.3790621772727, 218, 33, 'PPL', 'P'),
(72460, 'Eno', 38.9722213745117, 0.68019357980134, -82.2372207641602, -1.43531027002404, 218, 41, 'PPL', 'P'),
(86816, 'Eno', 36.0597190856934, 0.629360825389588, -87.4533309936523, -1.52634856767564, 218, 50, 'PPL', 'P'),
(186689, 'Eno', 39.8872184753418, 0.696163291857027, -104.843612670898, -1.82986624079282, 218, 7, 'PPL', 'P'),
(35777, 'Enoch', 37.5433311462402, 0.655254740668429, -83.6755599975586, -1.46041402540746, 218, 21, 'PPL', 'P'),
(94074, 'Enoch', 32.7200012207031, 0.571071752557833, -94.9983291625977, -1.65803362778068, 218, 51, 'PPL', 'P'),
(109098, 'Enoch', 38.4244384765625, 0.67063296464601, -80.9347229003906, -1.41257739380107, 218, 58, 'PPL', 'P'),
(161381, 'Enoch', 40.0777816772461, 0.6994892471634, -79.0997161865234, -1.38055048484789, 218, 45, 'PPL', 'P'),
(192557, 'Enoch', 37.7733306884766, 0.659268989958533, -113.023612976074, -1.97263417893228, 218, 52, 'PPL', 'P'),
(191435, 'Enochs', 33.8730583190918, 0.591196395388208, -102.759437561035, -1.7934905229376, 218, 51, 'PPL', 'P'),
(29728, 'Enochsburg', 39.334171295166, 0.686510797644089, -85.2975006103516, -1.48872222937251, 218, 19, 'PPL', 'P'),
(64556, 'Enochville', 35.5297203063965, 0.620110601659307, -80.668327331543, -1.40792791401196, 218, 33, 'PPL', 'P'),
(2303, 'Enoe', 33.6777801513672, 0.587788148404152, -87.3886108398438, -1.52521898789928, 218, 2, 'PPL', 'P'),
(135242, 'Enok', 48.6538887023926, 0.849170551755622, -96.758056640625, -1.68874666621007, 218, 28, 'PPL', 'P'),
(40830, 'Enoka', 32.5302810668945, 0.567760511216483, -91.1672210693359, -1.59116817755346, 218, 22, 'PPL', 'P'),
(8769, 'Enola', 35.1952781677246, 0.614273485182071, -92.2030563354492, -1.60924691345541, 218, 4, 'PPL', 'P'),
(40821, 'Enola', 29.9422206878662, 0.522590336362027, -91.0524978637695, -1.58916587988788, 218, 22, 'PPL', 'P'),
(59816, 'Enola', 32.7272186279297, 0.571197720077394, -90.584716796875, -1.58100156009208, 218, 30, 'PPL', 'P'),
(64551, 'Enola', 35.6650009155273, 0.622471693702744, -81.654167175293, -1.42513406518274, 218, 33, 'PPL', 'P'),
(80886, 'Enola', 35.0152816772461, 0.611131953781187, -81.8677825927734, -1.4288623575508, 218, 48, 'PPL', 'P'),
(101735, 'Enola', 38.8983306884766, 0.678903944043469, -77.2291717529297, -1.34790332567682, 218, 53, 'PPL', 'P'),
(141780, 'Enola', 41.9038887023926, 0.731360827246005, -97.4625015258789, -1.70104154885658, 218, 35, 'PPL', 'P'),
(161382, 'Enola', 40.2900009155273, 0.703193171607482, -76.9341735839844, -1.34275463634137, 218, 45, 'PPL', 'P'),
(2307, 'Enon', 31.8255596160889, 0.555460801590493, -85.7063903808594, -1.49585870214559, 218, 2, 'PPL', 'P'),
(8771, 'Enon', 33.5883293151855, 0.58622693679412, -91.6777801513672, -1.60007911456086, 218, 4, 'PPL', 'P'),
(15940, 'Enon', 30.7927799224854, 0.537435395489374, -87.5244369506836, -1.52758960074361, 218, 12, 'PPL', 'P'),
(20911, 'Enon', 31.0127792358398, 0.541275107859536, -83.8002777099609, -1.46259076012443, 218, 13, 'PPL', 'P'),
(35781, 'Enon', 37.2536087036133, 0.650198130127668, -87.9899978637695, -1.53571517154556, 218, 21, 'PPL', 'P'),
(40822, 'Enon', 30.7272205352783, 0.536291168327021, -90.0841674804688, -1.57226532645218, 218, 22, 'PPL', 'P'),
(54640, 'Enon', 38.8630599975586, 0.678288354357497, -90.8311080932617, -1.58530189946229, 218, 29, 'PPL', 'P'),
(59819, 'Enon', 31.3036098480225, 0.546351059607714, -90.2230606079102, -1.57468946883443, 218, 30, 'PPL', 'P'),
(64552, 'Enon', 36.139720916748, 0.630757120749117, -80.4691696166992, -1.40445195615718, 218, 33, 'PPL', 'P'),
(72462, 'Enon', 39.878059387207, 0.696003435612595, -83.9369430541992, -1.46497602035476, 218, 41, 'PPL', 'P'),
(78221, 'Enon', 39.9749984741211, 0.697695341853122, -80.4208297729492, -1.40360826672385, 218, 45, 'PPL', 'P'),
(86819, 'Enon', 36.0972213745117, 0.630015363806503, -88.5430603027344, -1.5453679320746, 218, 50, 'PPL', 'P'),
(94075, 'Enon', 32.7705612182617, 0.571954190985031, -95.0294418334961, -1.65857664632694, 218, 51, 'PPL', 'P'),
(101737, 'Enon', 37.7636108398438, 0.659099346597094, -78.0105590820313, -1.36154110730301, 218, 53, 'PPL', 'P'),
(109099, 'Enon', 38.309440612793, 0.668625873290471, -80.8969421386719, -1.41191799511517, 218, 58, 'PPL', 'P'),
(8772, 'Enon (historical)', 36.4622192382813, 0.636385778292027, -93.3111114501953, -1.62858612350129, 218, 4, 'PPL', 'P'),
(20912, 'Enon Forest', 33.6911087036133, 0.58802077552537, -84.5625, -1.47589404871771, 218, 13, 'PPL', 'P'),
(20913, 'Enon Grove', 33.3397216796875, 0.581887915009081, -85.0158309936523, -1.48380616715828, 218, 13, 'PPL', 'P'),
(72463, 'Enon Heights Mobile Home Park', 39.8977813720703, 0.696347649183488, -83.8969421386719, -1.464277872675, 218, 41, 'PPL', 'P'),
(72464, 'Enon Mobile Home Park', 39.8800010681152, 0.696037324337466, -83.938606262207, -1.46500504881064, 218, 41, 'PPL', 'P'),
(161383, 'Enon Valley', 40.8547210693359, 0.713049397643811, -80.4572219848633, -1.40424343064383, 218, 45, 'PPL', 'P'),
(59820, 'Enondale', 32.6352806091309, 0.569593098941594, -88.4683303833008, -1.54406364893074, 218, 30, 'PPL', 'P'),
(101738, 'Enonville', 37.4997215270996, 0.654493609228884, -78.5236129760742, -1.37049558699424, 218, 53, 'PPL', 'P'),
(80887, 'Enoree', 34.6563911437988, 0.604868132318293, -81.9652786254883, -1.4305639843293, 218, 48, 'PPL', 'P'),
(80889, 'Enoree Hills', 34.9063911437988, 0.609231455448279, -82.2819366455078, -1.43609070938149, 218, 48, 'PPL', 'P'),
(27108, 'Enos', 39.3011093139648, 0.685933757214896, -90.0074996948242, -1.57092722116247, 218, 18, 'PPL', 'P'),
(80890, 'Enos', 33.7972183227539, 0.589872737747411, -81.04638671875, -1.41452629508679, 218, 48, 'PPL', 'P'),
(122580, 'Enos', 41.0138893127441, 0.7158274075559, -87.4491729736328, -1.52627599653593, 218, 19, 'PPL', 'P'),
(29729, 'Enos Corner', 38.2891693115234, 0.668272072339654, -87.2611083984375, -1.52299365049241, 218, 19, 'PPL', 'P'),
(171993, 'Enosburg Center', 44.8833312988281, 0.783361910427974, -72.7552795410156, -1.26981917619959, 218, 55, 'PPL', 'P'),
(171994, 'Enosburg Falls', 44.9069404602051, 0.783773968027636, -72.8069381713867, -1.27072078938664, 218, 55, 'PPL', 'P'),
(32372, 'Enosdale', 39.771110534668, 0.694136826004559, -97.1611099243164, -1.69578127307146, 218, 20, 'PPL', 'P'),
(54641, 'Enough', 37.707218170166, 0.658115108837228, -90.9166717529297, -1.58679526704355, 218, 29, 'PPL', 'P'),
(8773, 'Enright', 35.1544418334961, 0.613560756695339, -91.5022201538086, -1.59701501456867, 218, 4, 'PPL', 'P'),
(94076, 'Enright', 30.5058307647705, 0.532427187901425, -96.29638671875, -1.68068900601593, 218, 51, 'PPL', 'P'),
(119545, 'Enright', 40.7397193908691, 0.711042239709245, -88.9669418334961, -1.55276606042479, 218, 18, 'PPL', 'P'),
(200778, 'Enright', 45.7238883972168, 0.798032399345866, -123.56861114502, -2.15667911659715, 218, 43, 'PPL', 'P'),
(94077, 'Enrique Bazan Colonia', 26.2810001373291, 0.458689983113475, -98.3789978027344, -1.71703742646998, 218, 51, 'PPL', 'P'),
(194901, 'Enrose', 43.7016716003418, 0.762738058051264, -116.745826721191, -2.03759906424757, 218, 17, 'PPL', 'P'),
(188525, 'Ensenada', 36.7272186279297, 0.641010890157167, -106.532783508301, -1.85934783353416, 218, 38, 'PPL', 'P'),
(178163, 'Ensenada del Oro', 33.579719543457, 0.586076667929612, -111.869438171387, -1.95249002844692, 218, 5, 'PPL', 'P'),
(80891, 'Ensenaka (historical)', 34.6800003051758, 0.605280189917956, -82.8550033569336, -1.44609261032945, 218, 48, 'PPL', 'P'),
(94078, 'Ensign', 32.2652816772461, 0.563135399351343, -96.6152801513672, -1.68625474637808, 218, 51, 'PPL', 'P'),
(130686, 'Ensign', 45.8974990844727, 0.801062477455131, -86.8688888549805, -1.51614812806842, 218, 27, 'PPL', 'P'),
(187665, 'Ensign', 37.6527786254883, 0.657164959539315, -100.233329772949, -1.74940162477522, 218, 20, 'PPL', 'P'),
(181462, 'Ensign (historical)', 39.9880599975586, 0.697923308442433, -122.082221984863, -2.13073673178647, 218, 6, 'PPL', 'P'),
(2308, 'Ensley', 33.5094413757324, 0.584850082510549, -86.8861083984375, -1.51644866579743, 218, 2, 'PPL', 'P'),
(15941, 'Ensley', 30.5186100006104, 0.532650227642719, -87.2727813720703, -1.5231973823158, 218, 12, 'PPL', 'P'),
(181463, 'Ensley', 38.8074989318848, 0.677318630825572, -121.671669006348, -2.1235712305575, 218, 6, 'PPL', 'P'),
(130688, 'Ensley Center', 43.3377799987793, 0.756386951483643, -85.6227798461914, -1.49439942302628, 218, 27, 'PPL', 'P'),
(2310, 'Ensley Junction', 33.4933280944824, 0.584568852699437, -86.9180603027344, -1.51700633172969, 218, 2, 'PPL', 'P'),
(181464, 'Enson', 36.5591697692871, 0.638077884269636, -119.374168395996, -2.08347228034029, 218, 6, 'PPL', 'P'),
(35778, 'Ensor', 37.7891693115234, 0.659545426079683, -86.9805603027344, -1.51809716251219, 218, 21, 'PPL', 'P'),
(86818, 'Ensor', 36.167781829834, 0.631246876073583, -85.6577835083008, -1.49501035218035, 218, 50, 'PPL', 'P'),
(161385, 'Enterline', 40.4633293151855, 0.70621832286873, -76.8427810668945, -1.34115953600647, 218, 45, 'PPL', 'P'),
(2312, 'Enterprise', 31.3150005340576, 0.546549864583088, -85.8552780151367, -1.49845728157924, 218, 2, 'PPL', 'P'),
(8774, 'Enterprise', 35.2655601501465, 0.615500137180162, -94.4288864135742, -1.64809497690861, 218, 4, 'PPL', 'P'),
(15942, 'Enterprise', 28.8688907623291, 0.503857195201219, -81.2669372558594, -1.41837562812639, 218, 12, 'PPL', 'P'),
(20915, 'Enterprise', 33.9261093139648, 0.592122309920201, -82.9700012207031, -1.44809970168498, 218, 13, 'PPL', 'P'),
(27109, 'Enterprise', 38.5222206115723, 0.67233958485156, -88.3574981689453, -1.54212926187296, 218, 18, 'PPL', 'P'),
(29730, 'Enterprise', 37.8424987792969, 0.660476200880665, -87.1819381713867, -1.52161186936082, 218, 19, 'PPL', 'P'),
(32373, 'Enterprise', 38.9027786254883, 0.678981575189245, -97.1166687011719, -1.69500562740397, 218, 20, 'PPL', 'P'),
(35779, 'Enterprise', 38.2597198486328, 0.667758082249269, -83.2547225952148, -1.45306902712102, 218, 21, 'PPL', 'P'),
(40824, 'Enterprise', 31.9030609130859, 0.556813454397658, -91.883056640625, -1.60366186517535, 218, 22, 'PPL', 'P'),
(59824, 'Enterprise', 34.4669418334961, 0.601561618087878, -89.1572189331055, -1.55608702230412, 218, 30, 'PPL', 'P'),
(64554, 'Enterprise', 36.4655609130859, 0.636444101519899, -77.9486083984375, -1.36045986390044, 218, 33, 'PPL', 'P'),
(72466, 'Enterprise', 39.6969413757324, 0.692842329977698, -84.5005569458008, -1.47481293847319, 218, 41, 'PPL', 'P'),
(75776, 'Enterprise', 35.2297210693359, 0.61487462721913, -95.3797225952148, -1.66469019892533, 218, 42, 'PPL', 'P'),
(86822, 'Enterprise', 35.4716682434082, 0.619097402022587, -87.179443359375, -1.521568326677, 218, 50, 'PPL', 'P'),
(94079, 'Enterprise', 33.521671295166, 0.585063534871919, -96.3497161865234, -1.68161978081691, 218, 51, 'PPL', 'P'),
(109102, 'Enterprise', 39.0069389343262, 0.68079951552836, -81.3697204589844, -1.42016953343667, 218, 58, 'PPL', 'P'),
(115483, 'Enterprise', 41.7319412231445, 0.728359777592622, -93.5299987792969, -1.63240642808501, 218, 16, 'PPL', 'P'),
(139142, 'Enterprise', 40.0244407653809, 0.698558272625335, -93.0849990844727, -1.62463971823996, 218, 29, 'PPL', 'P'),
(161389, 'Enterprise', 40.2027816772461, 0.701670908728393, -80.2411117553711, -1.40047159559195, 218, 45, 'PPL', 'P'),
(174021, 'Enterprise', 45.4972190856934, 0.794076273546553, -89.2583312988281, -1.55785176600046, 218, 57, 'PPL', 'P'),
(190178, 'Enterprise', 36.0252799987793, 0.628759749931557, -115.241111755371, -2.01133683378997, 218, 39, 'PPL', 'P'),
(193527, 'Enterprise', 40.5638885498047, 0.70797341260612, -122.341667175293, -2.13526490458793, 218, 6, 'PPL', 'P'),
(200779, 'Enterprise', 45.4263916015625, 0.792840100747566, -117.277778625488, -2.0468833764398, 218, 43, 'PPL', 'P'),
(203888, 'Enterprise', 41.0997200012207, 0.717325435669069, -111.735557556152, -1.95015337090649, 218, 52, 'PPL', 'P'),
(207343, 'Enterprise', 48.0138893127441, 0.838000455195503, -118.217498779297, -2.06328458717111, 218, 56, 'PPL', 'P'),
(54643, 'Enterprise (historical)', 36.6722183227539, 0.640050953742248, -94.6083297729492, -1.65122685435054, 218, 29, 'PPL', 'P'),
(155187, 'Enterprise (historical)', 41.2930603027344, 0.720699860507281, -81.6622161865234, -1.42527454693024, 218, 41, 'PPL', 'P'),
(181467, 'Enterprise (historical)', 39.5363883972168, 0.690040151878717, -121.363059997559, -2.11818498725282, 218, 6, 'PPL', 'P'),
(80892, 'Enterprise Landing', 33.6688919067383, 0.587633019270655, -79.0608291625977, -1.37987177824408, 218, 48, 'PPL', 'P'),
(207345, 'Entiat', 47.6761093139648, 0.832105082069421, -120.207221984863, -2.09801180831158, 218, 56, 'PPL', 'P'),
(207344, 'Entiat (historical)', 47.6630592346191, 0.831877315217192, -120.222503662109, -2.09827852389475, 218, 56, 'PPL', 'P'),
(161390, 'Entlerville', 40.2625007629395, 0.702713203400022, -77.3461074829102, -1.34994423917821, 218, 45, 'PPL', 'P'),
(130691, 'Entrican', 43.3502807617188, 0.756605130955948, -85.1536102294922, -1.48621086846456, 218, 27, 'PPL', 'P'),
(161391, 'Entriken', 40.3338890075684, 0.703959163316016, -78.1991729736328, -1.36483304072646, 218, 45, 'PPL', 'P'),
(178164, 'Entro', 34.6069412231445, 0.604005068388026, -112.403327941895, -1.961808162785, 218, 5, 'PPL', 'P'),
(109103, 'Entry', 38.639720916748, 0.674390352048975, -79.3486099243164, -1.38489450005997, 218, 58, 'PPL', 'P'),
(207346, 'Enumclaw', 47.2044410705566, 0.82387291824485, -121.990280151367, -2.12913204407164, 218, 56, 'PPL', 'P'),
(75777, 'Enville', 33.9836082458496, 0.59312585559797, -96.9861068725586, -1.69272689361725, 218, 42, 'PPL', 'P'),
(86823, 'Enville', 35.3847198486328, 0.617579866254432, -88.4274978637695, -1.54335098702303, 218, 50, 'PPL', 'P'),
(139144, 'Enyart', 40.3622207641602, 0.704453645751416, -94.5477828979492, -1.65017011203, 218, 29, 'PPL', 'P'),
(59825, 'Enzor', 32.3116683959961, 0.563945000322727, -88.6197204589844, -1.54670590420626, 218, 30, 'PPL', 'P'),
(2313, 'Eoda', 31.374439239502, 0.547587265696215, -86.3191680908203, -1.50655369076724, 218, 2, 'PPL', 'P'),
(40825, 'Eola', 30.9111099243164, 0.539500643625217, -92.2158279418945, -1.60946982003865, 218, 22, 'PPL', 'P'),
(75778, 'Eola', 34.5502815246582, 0.603016170096252, -97.4400024414063, -1.70064886575385, 218, 42, 'PPL', 'P'),
(119546, 'Eola', 41.7775001525879, 0.729154930915092, -88.2427825927734, -1.54012709736544, 218, 18, 'PPL', 'P'),
(191436, 'Eola', 31.398609161377, 0.548009110412883, -100.088890075684, -1.74688067648736, 218, 51, 'PPL', 'P'),
(200780, 'Eola', 44.9324989318848, 0.784220047510224, -123.118606567383, -2.14882505506834, 218, 43, 'PPL', 'P'),
(200781, 'Eola Crest', 45.0988883972168, 0.787124091520901, -123.139442443848, -2.14918870971519, 218, 43, 'PPL', 'P'),
(200782, 'Eola Village', 45.1597213745117, 0.788185827268489, -123.148330688477, -2.14934383884869, 218, 43, 'PPL', 'P'),
(35780, 'Eolia', 37.0536117553711, 0.646707524886901, -82.7916717529297, -1.44498726531901, 218, 21, 'PPL', 'P'),
(54644, 'Eolia', 39.2358283996582, 0.684794390321533, -91.008056640625, -1.5883902342204, 218, 29, 'PPL', 'P'),
(94080, 'Eolian', 32.6666717529297, 0.570140977756851, -99.0158309936523, -1.72815226243748, 218, 51, 'PPL', 'P'),
(2314, 'Eoline', 32.9949989318848, 0.575871368053401, -87.2322235107422, -1.52248951409806, 218, 2, 'PPL', 'P'),
(101739, 'Eona', 36.726390838623, 0.640996442508254, -80.7675018310547, -1.40965883556245, 218, 53, 'PPL', 'P'),
(2315, 'Epes', 32.6902809143066, 0.570553035356513, -88.126106262207, -1.53809071123791, 218, 2, 'PPL', 'P'),
(20916, 'Ephesus', 33.4069404602051, 0.583061104048288, -85.2544403076172, -1.48797068531289, 218, 13, 'PPL', 'P'),
(64555, 'Ephesus', 35.8419418334961, 0.6255598953028, -80.5461120605469, -1.40579485513686, 218, 33, 'PPL', 'P'),
(86824, 'Ephesus', 36.1302795410156, 0.630592337656668, -88.2886123657227, -1.54092697779884, 218, 50, 'PPL', 'P'),
(20917, 'Ephesus Heights', 33.7125015258789, 0.588394150710199, -84.8466720581055, -1.48085378677381, 218, 13, 'PPL', 'P'),
(177414, 'Ephraim', 45.1563911437988, 0.788127703777698, -87.1680603027344, -1.52136965485968, 218, 57, 'PPL', 'P'),
(192558, 'Ephraim', 39.3597183227539, 0.686956677389596, -111.585563659668, -1.94753548355494, 218, 52, 'PPL', 'P'),
(64557, 'Ephraim Place', 36.0877799987793, 0.629850580714054, -82.4036102294922, -1.43821431403472, 218, 33, 'PPL', 'P'),
(109104, 'Ephram (historical)', 37.9088897705078, 0.661634942270959, -81.0136108398438, -1.41395424808464, 218, 58, 'PPL', 'P'),
(161392, 'Ephrata', 40.1797218322754, 0.701268438508654, -76.1791687011719, -1.32957731526766, 218, 45, 'PPL', 'P'),
(207347, 'Ephrata', 47.3177795410156, 0.825851047723534, -119.55249786377, -2.08658471670627, 218, 56, 'PPL', 'P'),
(148695, 'Ephratah', 43.0008316040039, 0.750506092585503, -74.5427780151367, -1.30101690994738, 218, 40, 'PPL', 'P'),
(59826, 'Epico (historical)', 30.4152793884277, 0.530846768242031, -89.0583267211914, -1.55436102760164, 218, 30, 'PPL', 'P'),
(170251, 'Epiphany', 43.8491706848145, 0.765312402718989, -97.6613922119141, -1.70451284617945, 218, 49, 'PPL', 'P'),
(59828, 'Epley', 31.3763904571533, 0.547621320868654, -89.5111083984375, -1.56226355866228, 218, 30, 'PPL', 'P'),
(207348, 'Epley (historical)', 48.422779083252, 0.845136927968588, -119.558326721191, -2.08668644945991, 218, 56, 'PPL', 'P'),
(35782, 'Epleys', 36.9269409179688, 0.644496701707972, -86.938606262207, -1.51736492637047, 218, 21, 'PPL', 'P'),
(40826, 'Epney (historical)', 30.7099990844727, 0.535990597308492, -90.3211135864258, -1.57640081615091, 218, 22, 'PPL', 'P'),
(130692, 'Epoufette', 46.0555610656738, 0.803821179449317, -85.168327331543, -1.4864677303517, 218, 27, 'PPL', 'P'),
(109105, 'Epperly', 37.6722183227539, 0.657504246262192, -81.2422180175781, -1.4179441960298, 218, 58, 'PPL', 'P'),
(35783, 'Epperson', 37.0258293151855, 0.646222629831425, -88.5344390869141, -1.54521746347301, 218, 21, 'PPL', 'P'),
(86825, 'Epperson', 35.2574996948242, 0.615359455695579, -84.3375015258789, -1.47196708453233, 218, 50, 'PPL', 'P'),
(101740, 'Eppes Falls (historical)', 37.2827796936035, 0.650707259949064, -77.7330627441406, -1.35669788254459, 218, 53, 'PPL', 'P'),
(101749, 'Eppes Fork', 36.5527801513672, 0.637966364398989, -78.3619384765625, -1.36767383466124, 218, 53, 'PPL', 'P'),
(148697, 'Eppie Corners', 43.0052795410156, 0.750583723731278, -74.4711074829102, -1.29976602318337, 218, 40, 'PPL', 'P'),
(127444, 'Epping', 44.6819381713867, 0.779846937263233, -67.7666702270508, -1.18275151857525, 218, 26, 'PPL', 'P'),
(143803, 'Epping', 43.0333290100098, 0.751073279318662, -71.0747222900391, -1.24048791890179, 218, 36, 'PPL', 'P'),
(198264, 'Epping', 48.2791709899902, 0.84263049390866, -103.356666564941, -1.80391413544417, 218, 34, 'PPL', 'P'),
(46903, 'Epping Farms', 39.0116691589355, 0.680882073522152, -76.5347213745117, -1.33578288008171, 218, 25, 'PPL', 'P'),
(46904, 'Epping Forest', 39.0141716003418, 0.68092574936403, -76.5319366455078, -1.33573427739182, 218, 25, 'PPL', 'P'),
(46905, 'Epping Forest Manor', 39.0027809143066, 0.680726944388655, -76.5530624389648, -1.33610299204474, 218, 25, 'PPL', 'P'),
(119565, 'Epplyanna', 42.4249992370605, 0.740455921842789, -89.4441680908203, -1.56109522989207, 218, 18, 'PPL', 'P'),
(40827, 'Epps', 32.603889465332, 0.569045220126338, -91.477783203125, -1.5965885093201, 218, 22, 'PPL', 'P'),
(59827, 'Epps', 31.1308307647705, 0.54333549572639, -89.1958312988281, -1.55676093521796, 218, 30, 'PPL', 'P'),
(20918, 'Epps Bridge Crossing', 33.9249992370605, 0.592102935423271, -83.4375, -1.45625909463277, 218, 13, 'PPL', 'P'),
(196435, 'Epsie', 45.4916687011719, 0.793979401061902, -105.65055847168, -1.8439501019016, 218, 31, 'PPL', 'P'),
(130693, 'Epsilon', 45.3627815246582, 0.791729895468139, -84.8019409179688, -1.48007308110026, 218, 27, 'PPL', 'P'),
(29731, 'Epsom', 38.7852783203125, 0.676930807991829, -87.0630569458008, -1.51953700055554, 218, 19, 'PPL', 'P'),
(64558, 'Epsom', 36.2452812194824, 0.632599495591234, -78.3288879394531, -1.36709699396913, 218, 33, 'PPL', 'P'),
(135245, 'Epsom', 44.2622184753418, 0.772521446631779, -93.0558319091797, -1.62413065499759, 218, 28, 'PPL', 'P'),
(143805, 'Epsom', 43.2227783203125, 0.754379793549077, -71.3324966430664, -1.24498693008931, 218, 36, 'PPL', 'P'),
(143806, 'Epsom Circle', 43.2277793884277, 0.754467078653805, -71.3608322143555, -1.24548147910374, 218, 36, 'PPL', 'P'),
(35785, 'Epson', 37.7444381713867, 0.658764720406126, -83.2177810668945, -1.45242427582111, 218, 21, 'PPL', 'P'),
(2316, 'Epworth', 31.2605590820313, 0.545599681995661, -88.4241714477539, -1.54329293011127, 218, 2, 'PPL', 'P'),
(20919, 'Epworth', 34.9505615234375, 0.61000237400483, -84.3850021362305, -1.47279612657967, 218, 13, 'PPL', 'P'),
(27110, 'Epworth', 38.0705604553223, 0.664456628024925, -88.1061096191406, -1.53774170397705, 218, 18, 'PPL', 'P'),
(35784, 'Epworth', 38.5111083984375, 0.672145640145175, -83.5927810668945, -1.45896926051609, 218, 21, 'PPL', 'P'),
(54646, 'Epworth', 39.8941688537598, 0.69628459884468, -92.0941696166992, -1.60734648170153, 218, 29, 'PPL', 'P'),
(80893, 'Epworth', 34.0886116027832, 0.594958509902108, -82.0422210693359, -1.43190688330898, 218, 48, 'PPL', 'P'),
(86829, 'Epworth', 35.8736114501953, 0.626112634387046, -86.7916717529297, -1.51480043539878, 218, 50, 'PPL', 'P'),
(101741, 'Epworth', 37.790828704834, 0.659574387956537, -77.2122192382813, -1.34760744847972, 218, 53, 'PPL', 'P'),
(115485, 'Epworth', 42.4449996948242, 0.740804995682671, -90.9319381713867, -1.58706171631061, 218, 16, 'PPL', 'P'),
(155188, 'Epworth', 40.8491706848145, 0.712952525159159, -82.4649963378906, -1.43928570374126, 218, 41, 'PPL', 'P'),
(181469, 'Epworth', 34.314998626709, 0.598909708853404, -118.89111328125, -2.07504137811937, 218, 6, 'PPL', 'P'),
(198266, 'Epworth', 48.1161117553711, 0.839784573388774, -102.223892211914, -1.78414349330169, 218, 34, 'PPL', 'P'),
(20920, 'Epworth Acres', 31.1786098480225, 0.544169398042721, -81.4027786254883, -1.42074650728683, 218, 13, 'PPL', 'P'),
(130694, 'Epworth Assembly', 43.9794387817383, 0.767586009920617, -86.4655609130859, -1.50910872751706, 218, 27, 'PPL', 'P'),
(122582, 'Epworth Forest', 41.3330612182617, 0.721398008187046, -85.6861114501953, -1.49550476803672, 218, 19, 'PPL', 'P'),
(72467, 'Epworth Heights', 39.2491683959961, 0.685027217179833, -84.2788925170898, -1.47094416435763, 218, 41, 'PPL', 'P'),
(2317, 'Equality', 32.7619400024414, 0.571803722383442, -86.101936340332, -1.50276228148135, 218, 2, 'PPL', 'P'),
(27111, 'Equality', 37.7338905334473, 0.658580629395774, -88.3433303833008, -1.54188198736574, 218, 18, 'PPL', 'P'),
(35786, 'Equality', 37.3958282470703, 0.652680329421677, -87.0658264160156, -1.51958533692933, 218, 21, 'PPL', 'P'),
(207349, 'Equality (historical)', 48.5755615234375, 0.847803484589057, -122.396942138672, -2.13622963469281, 218, 56, 'PPL', 'P'),
(46906, 'Equestrian Estates', 39.4291687011719, 0.688168815159745, -77.0111083984375, -1.34409740216299, 218, 25, 'PPL', 'P'),
(119548, 'Equestrian Estates', 41.6763916015625, 0.727390253797778, -87.9277801513672, -1.53462926761108, 218, 18, 'PPL', 'P'),
(181470, 'Equestrian Village', 38.723331451416, 0.675849631168284, -121.073608398438, -2.11313310382299, 218, 6, 'PPL', 'P'),
(119549, 'Equestrian Woods', 41.6830596923828, 0.727506633937415, -87.9266662597656, -1.53460982653512, 218, 18, 'PPL', 'P'),
(161395, 'Equinunk', 41.8558311462402, 0.730522064660684, -75.2241668701172, -1.31290938895318, 218, 45, 'PPL', 'P'),
(72468, 'Equity', 39.5588912963867, 0.690432901560476, -81.5758285522461, -1.42376679827909, 218, 41, 'PPL', 'P'),
(35787, 'Era', 37.0088882446289, 0.645926952371399, -87.581672668457, -1.5285885524685, 218, 21, 'PPL', 'P'),
(72469, 'Era', 39.7411117553711, 0.693613248534249, -83.2405624389648, -1.45282188577186, 218, 41, 'PPL', 'P'),
(94081, 'Era', 33.4952812194824, 0.58460294116139, -97.2877807617188, -1.69799209625039, 218, 51, 'PPL', 'P'),
(194902, 'Era', 43.5805587768555, 0.760624240515041, -113.57861328125, -1.98232076160717, 218, 17, 'PPL', 'P'),
(8775, 'Era (historical)', 33.0330581665039, 0.576535627008294, -93.9877777099609, -1.64039617767135, 218, 4, 'PPL', 'P'),
(75779, 'Eram', 35.6169395446777, 0.621632864538397, -95.7547225952148, -1.67123518362031, 218, 42, 'PPL', 'P'),
(86826, 'Erasmus', 35.8869400024414, 0.626345261508264, -85.1849975585938, -1.48675868070079, 218, 50, 'PPL', 'P'),
(20935, 'Erastus', 34.252498626709, 0.597818878070908, -83.3411102294922, -1.45457677577217, 218, 13, 'PPL', 'P'),
(64559, 'Erastus', 35.190559387207, 0.614191126925361, -83.1877822875977, -1.4519006983508, 218, 33, 'PPL', 'P'),
(155189, 'Erastus', 40.5088882446289, 0.707013476191201, -84.7077789306641, -1.47842964439157, 218, 41, 'PPL', 'P'),
(40828, 'Erath', 29.9580593109131, 0.522866772483177, -92.0358276367188, -1.60632822205873, 218, 22, 'PPL', 'P'),
(94082, 'Erath', 31.6330604553223, 0.55210105742779, -97.2633285522461, -1.6975653246857, 218, 51, 'PPL', 'P'),
(109106, 'Erbacon', 38.5188903808594, 0.672281461360769, -80.5891723632813, -1.40654639919648, 218, 58, 'PPL', 'P'),
(8776, 'Erbie', 36.083610534668, 0.629777809837268, -93.2330627441406, -1.62722391660371, 218, 4, 'PPL', 'P'),
(78218, 'Erbs Mill', 39.8627815246582, 0.695736786608451, -76.3380584716797, -1.33235046491076, 218, 45, 'PPL', 'P'),
(78219, 'Ercildoun', 39.9463882446289, 0.697195999148732, -75.8394393920898, -1.32364792025865, 218, 45, 'PPL', 'P'),
(40829, 'Erco', 32.4066696166992, 0.56560308441741, -92.1069412231445, -1.60756938828477, 218, 22, 'PPL', 'P'),
(203891, 'Erda', 40.6127815246582, 0.708826755998408, -112.303611755371, -1.96006778701263, 218, 52, 'PPL', 'P'),
(135247, 'Erdahl', 45.9919395446777, 0.802710774432808, -95.817497253418, -1.67233080809277, 218, 28, 'PPL', 'P'),
(161396, 'Erdenheim', 40.0919418334961, 0.699736388512559, -75.2141723632813, -1.31273495190178, 218, 45, 'PPL', 'P'),
(161397, 'Erdman', 40.6455612182617, 0.709398869579585, -76.6900024414063, -1.33849304596503, 218, 45, 'PPL', 'P'),
(174024, 'Erdman', 43.7900009155273, 0.764279695427283, -87.7594375610352, -1.53169113513845, 218, 57, 'PPL', 'P'),
(115484, 'Erdmann Trailer Court', 42.7941703796387, 0.746899173784127, -96.165283203125, -1.67840081800733, 218, 16, 'PPL', 'P'),
(59829, 'Eret', 31.4699993133545, 0.549255103618391, -88.4822235107422, -1.54430612974799, 218, 30, 'PPL', 'P'),
(135249, 'Erhard', 46.4855613708496, 0.811326100559215, -96.0983276367188, -1.677232222921, 218, 28, 'PPL', 'P'),
(161398, 'Erhard', 40.8450012207031, 0.712879754282373, -78.503059387207, -1.3701368591954, 218, 45, 'PPL', 'P'),
(155190, 'Erhart', 41.1997184753418, 0.719070738289453, -81.9744415283203, -1.43072390715276, 218, 41, 'PPL', 'P'),
(70791, 'Erial', 39.7733306884766, 0.694175574998419, -75.0066680908203, -1.30911331913538, 218, 37, 'PPL', 'P'),
(181471, 'Eric (historical)', 35.1116714477539, 0.61281427264179, -118.327499389648, -2.06520446000095, 218, 6, 'PPL', 'P'),
(101742, 'Erica', 38.1183280944824, 0.665290330604174, -76.6791687011719, -1.33830396152763, 218, 53, 'PPL', 'P'),
(20921, 'Erick', 32.1230583190918, 0.560653133478307, -82.831672668457, -1.44568541299877, 218, 13, 'PPL', 'P'),
(75780, 'Erick', 35.2152786254883, 0.614622559021954, -99.8661117553711, -1.74299246129584, 218, 42, 'PPL', 'P'),
(193528, 'Erickson', 41.6502799987793, 0.726934520356239, -122.113327026367, -2.13127961717468, 218, 6, 'PPL', 'P'),
(196436, 'Erickson (historical)', 48.1136093139648, 0.839740897546897, -112.089996337891, -1.95633949464458, 218, 31, 'PPL', 'P'),
(113413, 'Erickson Corner', 41.6636085510254, 0.727167147477457, -73.4225006103516, -1.28146438069818, 218, 8, 'PPL', 'P'),
(130696, 'Erickson Landing', 46.1416702270508, 0.805324067831476, -88.404167175293, -1.54294378969236, 218, 27, 'PPL', 'P'),
(170252, 'Erickson Subdivision', 43.6080589294434, 0.7611042087225, -96.710563659668, -1.68791775732078, 218, 49, 'PPL', 'P'),
(135252, 'Erickson Trailer Court', 43.7580604553223, 0.763722229232103, -91.5672225952148, -1.59814952119305, 218, 28, 'PPL', 'P'),
(135253, 'Ericsburg', 48.4877815246582, 0.846271434592962, -93.3311080932617, -1.62893513076214, 218, 28, 'PPL', 'P'),
(115487, 'Ericson', 42.0286102294922, 0.733537628542008, -93.7961120605469, -1.63705098102611, 218, 16, 'PPL', 'P'),
(141783, 'Ericson', 41.7799987792969, 0.729198540177942, -98.6769409179688, -1.72223751481447, 218, 35, 'PPL', 'P'),
(207350, 'Ericson View Tracts', 45.7266693115234, 0.798080935456733, -121.598892211914, -2.12230103587559, 218, 56, 'PPL', 'P'),
(15947, 'Eridu', 30.3016700744629, 0.528863911652413, -83.7472229003906, -1.46166477901341, 218, 12, 'PPL', 'P'),
(15943, 'Erie', 27.5708293914795, 0.481201750386942, -82.4783325195313, -1.43951846402053, 218, 12, 'PPL', 'P'),
(32376, 'Erie', 37.5680618286133, 0.655686372502103, -95.2430572509766, -1.662304938695, 218, 20, 'PPL', 'P'),
(54648, 'Erie', 36.7277793884277, 0.641020677274173, -94.3630599975586, -1.64694608921435, 218, 29, 'PPL', 'P'),
(86827, 'Erie', 35.6474990844727, 0.622166229125712, -84.5747222900391, -1.47610736792102, 218, 50, 'PPL', 'P'),
(109107, 'Erie', 39.3400001525879, 0.68661253039773, -80.3269424438477, -1.40196962370512, 218, 58, 'PPL', 'P'),
(119550, 'Erie', 41.6563911437988, 0.727041179957896, -90.0791702270508, -1.57217810792648, 218, 18, 'PPL', 'P'),
(122583, 'Erie', 40.8011093139648, 0.712113695994811, -85.9913864135742, -1.50083282127159, 218, 19, 'PPL', 'P'),
(130697, 'Erie', 41.7941703796387, 0.729445881264183, -83.4963912963867, -1.45728694165548, 218, 27, 'PPL', 'P'),
(135255, 'Erie', 48.0702781677246, 0.838984626376341, -95.7216720581055, -1.6706583429282, 218, 28, 'PPL', 'P'),
(139981, 'Erie', 47.1152801513672, 0.82231676664089, -97.3874969482422, -1.69973247202276, 218, 34, 'PPL', 'P'),
(161399, 'Erie', 42.1291694641113, 0.735292718279398, -80.0852813720703, -1.39775184232871, 218, 45, 'PPL', 'P'),
(190179, 'Erie', 35.8705596923828, 0.626059371165244, -115.236106872559, -2.01124948210621, 218, 39, 'PPL', 'P'),
(194175, 'Erie', 40.0502815246582, 0.69900927895594, -105.049438476563, -1.83345857878723, 218, 7, 'PPL', 'P'),
(80894, 'Erie (historical)', 34.4722213745117, 0.601653763461595, -82.2708282470703, -1.43589683125413, 218, 48, 'PPL', 'P'),
(161401, 'Erie Heights', 42.0849990844727, 0.734521799722847, -80.1091690063477, -1.39816876019736, 218, 45, 'PPL', 'P'),
(139982, 'Erie Junction', 47.0933303833008, 0.821933670918082, -97.3841705322266, -1.69967441511099, 218, 34, 'PPL', 'P'),
(161402, 'Erie Junction', 41.2430610656738, 0.71982720919709, -78.7738876342773, -1.37486370381419, 218, 45, 'PPL', 'P'),
(155192, 'Erie Side', 41.6450004577637, 0.726842374982522, -81.4633331298828, -1.42180338276543, 218, 41, 'PPL', 'P'),
(148699, 'Erieville', 42.8516693115234, 0.747902719461896, -75.7558288574219, -1.32218864113935, 218, 40, 'PPL', 'P'),
(35788, 'Eriline', 37.1886100769043, 0.649063690082322, -83.5930633544922, -1.4589741873641, 218, 21, 'PPL', 'P'),
(2319, 'Erin', 33.3624992370605, 0.582285458380803, -85.9086074829102, -1.49938805638022, 218, 2, 'PPL', 'P'),
(86828, 'Erin', 36.3183288574219, 0.633874417384082, -87.6947174072266, -1.53056155536209, 218, 50, 'PPL', 'P'),
(94084, 'Erin', 30.7794399261475, 0.537202568631074, -93.9966735839844, -1.64055143996291, 218, 51, 'PPL', 'P'),
(109108, 'Erin', 37.4413909912109, 0.653475549323174, -81.6927795410156, -1.42580797809658, 218, 58, 'PPL', 'P'),
(148700, 'Erin', 42.1858291625977, 0.736281616571171, -76.670280456543, -1.33814883239414, 218, 40, 'PPL', 'P'),
(174025, 'Erin Corner', 45.0794410705566, 0.786784671639971, -92.4369430541992, -1.61332900677428, 218, 57, 'PPL', 'P'),
(203900, 'Erin Meadows', 40.665828704834, 0.709752603951374, -111.923332214355, -1.95343065694394, 218, 52, 'PPL', 'P'),
(101743, 'Erin Shades', 37.6477813720703, 0.657077741013615, -77.5911102294922, -1.35422034378249, 218, 53, 'PPL', 'P'),
(75782, 'Erin Springs', 34.8108291625977, 0.60756358423659, -97.6063919067383, -1.70355290976453, 218, 42, 'PPL', 'P'),
(101744, 'Erinbrook', 38.6805610656738, 0.675103147114735, -77.9488906860352, -1.36046479074846, 218, 53, 'PPL', 'P'),
(155194, 'Eris', 40.1561088562012, 0.700856314329965, -83.852783203125, -1.46350715385553, 218, 41, 'PPL', 'P'),
(161404, 'Eriton', 41.0733299255371, 0.71686484195854, -78.7900009155273, -1.3751449336253, 218, 45, 'PPL', 'P'),
(207351, 'Erlands Point', 47.5999984741211, 0.83077669731769, -122.691673278809, -2.14137366349636, 218, 56, 'PPL', 'P'),
(35789, 'Erlanger', 39.0166702270508, 0.68096935862688, -84.600830078125, -1.47656303478353, 218, 21, 'PPL', 'P'),
(64560, 'Erlanger', 35.8388900756836, 0.625506632080998, -80.2536087036133, -1.40068970848523, 218, 33, 'PPL', 'P'),
(181472, 'Erle (historical)', 39.100830078125, 0.682438225126113, -121.394721984863, -2.11873759317901, 218, 6, 'PPL', 'P'),
(155195, 'Erlin', 41.3658294677734, 0.72196992203114, -83.0124969482422, -1.44884139204857, 218, 41, 'PPL', 'P'),
(194903, 'Erlmo', 47.2597198486328, 0.824837714928759, -116.049171447754, -2.0254401359747, 218, 17, 'PPL', 'P'),
(70792, 'Erlton', 39.9169387817383, 0.696682009058347, -75.0183334350586, -1.30931691780072, 218, 37, 'PPL', 'P'),
(161405, 'Erly', 40.4088897705078, 0.705268173570817, -77.3391723632813, -1.34982319850666, 218, 45, 'PPL', 'P'),
(70793, 'Erma', 38.9805603027344, 0.680339121554912, -74.908332824707, -1.30739704497088, 218, 37, 'PPL', 'P'),
(70794, 'Erma Park', 39.0058288574219, 0.68078014103143, -74.8838882446289, -1.30697040656425, 218, 37, 'PPL', 'P'),
(35790, 'Ermine', 37.1211090087891, 0.647885574195098, -82.7922210693359, -1.44499685269893, 218, 21, 'PPL', 'P'),
(196437, 'Ermont Mill', 45.2669410705566, 0.79005716398746, -112.91471862793, -1.97073361402035, 218, 31, 'PPL', 'P'),
(94085, 'Erna', 30.750560760498, 0.536698532105262, -99.4855575561523, -1.73635053753718, 218, 51, 'PPL', 'P'),
(193529, 'Erner (historical)', 41.4230613708496, 0.722968807177002, -123.926666259766, -2.16292835725308, 218, 6, 'PPL', 'P'),
(20922, 'Ernest', 30.7788906097412, 0.537192981251149, -82.6602783203125, -1.44269401730434, 218, 13, 'PPL', 'P'),
(161407, 'Ernest', 40.103889465332, 0.699944914025912, -75.3180618286133, -1.31454816512996, 218, 45, 'PPL', 'P'),
(54652, 'Ernestville', 38.9322204589844, 0.679495432121575, -93.629997253418, -1.63415173070539, 218, 29, 'PPL', 'P'),
(86830, 'Ernestville', 36.0713882446289, 0.629564490633952, -82.5027770996094, -1.43994510242716, 218, 50, 'PPL', 'P'),
(161409, 'Erney', 40.1027793884277, 0.699925539528982, -76.8330612182617, -1.34098989264503, 218, 45, 'PPL', 'P'),
(207352, 'Ernies Grove', 47.5352783203125, 0.829647117541333, -121.744171142578, -2.12483663154946, 218, 56, 'PPL', 'P'),
(27113, 'Ernst', 39.3161087036133, 0.686195545950051, -87.6730575561523, -1.53018351964535, 218, 18, 'PPL', 'P'),
(145177, 'Ernston', 40.4561080932617, 0.706092288770142, -74.3108291625977, -1.29696863877435, 218, 37, 'PPL', 'P'),
(620, 'Ernstville', 39.6327781677246, 0.69172247073932, -78.0269393920898, -1.36182699764603, 218, 25, 'PPL', 'P'),
(64561, 'Ernul', 35.252498626709, 0.615272170590851, -77.0800018310547, -1.34529981939516, 218, 33, 'PPL', 'P'),
(8777, 'Eros', 36.1833305358887, 0.631518252188662, -92.8505630493164, -1.62054803754116, 218, 4, 'PPL', 'P'),
(40831, 'Eros', 32.392219543457, 0.56535088306218, -92.4238891601563, -1.61310117334302, 218, 22, 'PPL', 'P'),
(35791, 'Erose', 36.9272193908691, 0.644501561976961, -83.6194381713867, -1.45943451475852, 218, 21, 'PPL', 'P'),
(209440, 'Erramouspe Place', 42.417781829834, 0.740329954323228, -108.804718017578, -1.89900057111074, 218, 59, 'PPL', 'P'),
(59832, 'Errata', 31.7586097717285, 0.554292306372707, -89.0599975585938, -1.55439018921557, 218, 30, 'PPL', 'P'),
(2318, 'Erratta', 33.3002815246582, 0.581199554446323, -86.3722229003906, -1.50747967187826, 218, 2, 'PPL', 'P'),
(143808, 'Errol', 44.7813911437988, 0.781582719082719, -71.1383285522461, -1.24159805760219, 218, 36, 'PPL', 'P'),
(200783, 'Errol Heights', 45.4686088562012, 0.793576930842163, -122.608329772949, -2.13991904490896, 218, 43, 'PPL', 'P'),
(135258, 'Erskine', 47.6674995422363, 0.831954813204914, -96.0097198486328, -1.67568572527599, 218, 28, 'PPL', 'P'),
(145178, 'Erskine', 41.0908317565918, 0.717170306535572, -74.2586135864258, -1.29605730504932, 218, 37, 'PPL', 'P'),
(193205, 'Erskine', 45.4383316040039, 0.793048493102864, -120.777496337891, -2.10796497341159, 218, 43, 'PPL', 'P'),
(202105, 'Erskine', 43.4330596923828, 0.758049895847316, -103.564437866211, -1.80754042874247, 218, 49, 'PPL', 'P'),
(109109, 'Erskine (historical)', 37.9666709899902, 0.662643414796745, -81.0811080932617, -1.41513229739284, 218, 58, 'PPL', 'P'),
(80895, 'Erskine Estates', 34.5027809143066, 0.60218712804891, -82.5727767944336, -1.44116682757724, 218, 48, 'PPL', 'P'),
(145179, 'Erskine Lakes', 41.1055603027344, 0.717427368159792, -74.2513885498047, -1.29593120437171, 218, 37, 'PPL', 'P'),
(29733, 'Erskine Station', 38.040828704834, 0.663937711086523, -87.5411071777344, -1.52788055109271, 218, 19, 'PPL', 'P'),
(193530, 'Ertlerger (historical)', 41.1841697692871, 0.718799362174373, -123.706939697266, -2.15909340528336, 218, 6, 'PPL', 'P'),
(124792, 'Erving', 42.5999984741211, 0.743510234717974, -72.3986129760742, -1.26359417030959, 218, 23, 'PPL', 'P'),
(64562, 'Ervintown', 34.9080581665039, 0.609260550483188, -77.5622177124023, -1.35371607423009, 218, 33, 'PPL', 'P'),
(8779, 'Erwin', 34.9719390869141, 0.61037548287355, -91.4466705322266, -1.59604549077383, 218, 4, 'PPL', 'P'),
(29734, 'Erwin', 37.9799995422363, 0.662876041917963, -87.9191665649414, -1.53447893216754, 218, 19, 'PPL', 'P'),
(59830, 'Erwin', 33.103889465332, 0.577771866386309, -91.0436096191406, -1.58901075075438, 218, 30, 'PPL', 'P'),
(64563, 'Erwin', 35.3266716003418, 0.616566733196739, -78.6763916015625, -1.37316207703568, 218, 33, 'PPL', 'P'),
(80896, 'Erwin', 34.6916694641113, 0.60548385516232, -80.8152770996094, -1.41049267129976, 218, 48, 'PPL', 'P'),
(86831, 'Erwin', 36.1450004577637, 0.630849266122834, -82.4169387817383, -1.43844694115594, 218, 50, 'PPL', 'P'),
(94086, 'Erwin', 30.4858303070068, 0.532078114061543, -96.0597229003906, -1.67655844316521, 218, 51, 'PPL', 'P'),
(109110, 'Erwin', 39.2963905334473, 0.685851398958186, -79.6386108398438, -1.38995597086972, 218, 58, 'PPL', 'P'),
(119554, 'Erwin', 40.1319389343262, 0.700434469613296, -90.7088928222656, -1.58316884058719, 218, 18, 'PPL', 'P'),
(170254, 'Erwin', 44.4874992370605, 0.776453337665172, -97.4447174072266, -1.70073115743154, 218, 49, 'PPL', 'P'),
(200784, 'Erwin (historical)', 44.8880615234375, 0.783444468421766, -117.604721069336, -2.05258959854946, 218, 43, 'PPL', 'P'),
(64564, 'Erwin Heights', 35.9008293151855, 0.626587675746489, -80.0738906860352, -1.39755303735333, 218, 33, 'PPL', 'P'),
(80897, 'Erwin Park', 34.3400001525879, 0.599346067798014, -80.0475006103516, -1.39709244364281, 218, 48, 'PPL', 'P'),
(161410, 'Erwinna', 40.500560760498, 0.70686813417471, -75.0730590820313, -1.31027206052568, 218, 45, 'PPL', 'P'),
(177380, 'Erwins', 42.1124992370605, 0.735001767930307, -77.1458282470703, -1.34644870708942, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(64565, 'Erwinsville (historical)', 35.1841697692871, 0.614079607054714, -81.6230621337891, -1.42459117979453, 218, 33, 'PPL', 'P'),
(40832, 'Erwinville', 30.5308303833008, 0.532863513556521, -91.4077835083008, -1.59536678417002, 218, 22, 'PPL', 'P'),
(75783, 'Esau Junction', 36.3536109924316, 0.634490206807136, -96.7044372558594, -1.68781083140302, 218, 42, 'PPL', 'P'),
(32380, 'Esbon', 39.8222198486328, 0.695028851811681, -98.4355621337891, -1.71802466028607, 218, 20, 'PPL', 'P'),
(188526, 'Escabosa', 34.9249992370605, 0.609556227943214, -106.289436340332, -1.85510062422771, 218, 38, 'PPL', 'P'),
(186690, 'Escalante', 38.7577781677246, 0.676450839784369, -108.261108398438, -1.88951279341122, 218, 7, 'PPL', 'P'),
(192560, 'Escalante', 37.7702789306641, 0.659215726736731, -111.601387023926, -1.94781165335998, 218, 52, 'PPL', 'P'),
(178165, 'Escalante Crossing', 31.8611106872559, 0.556081284834968, -110.209167480469, -1.92351283841604, 218, 5, 'PPL', 'P'),
(181474, 'Escalle', 37.9433288574219, 0.66223601772899, -122.543891906738, -2.13879439198061, 218, 6, 'PPL', 'P'),
(181475, 'Escalon', 37.7975006103516, 0.659690834675201, -120.995559692383, -2.11177089692542, 218, 6, 'PPL', 'P'),
(15944, 'Escambia (historical)', 30.0499992370605, 0.524471426908491, -85.0500030517578, -1.4844025820844, 218, 12, 'PPL', 'P'),
(15946, 'Escambia Farms', 30.9577808380127, 0.540315204734131, -86.633056640625, -1.51203207944564, 218, 12, 'PPL', 'P'),
(130700, 'Escanaba', 45.7452812194824, 0.798405774530695, -87.0644378662109, -1.51956110216341, 218, 27, 'PPL', 'P'),
(148703, 'Escarpment', 43.1686096191406, 0.753434371362099, -79.0069427490234, -1.37893128290512, 218, 40, 'PPL', 'P'),
(2321, 'Escatawpa', 31.2894401550293, 0.546103751810986, -88.3872222900391, -1.5426480456533, 218, 2, 'PPL', 'P'),
(59831, 'Escatawpa', 30.4402809143066, 0.531283127186641, -88.5436096191406, -1.54537751945453, 218, 30, 'PPL', 'P'),
(207353, 'Eschbach', 46.6697196960449, 0.814540269678831, -120.629997253418, -2.10539062874386, 218, 56, 'PPL', 'P'),
(32382, 'Eschs (historical)', 37.1361083984375, 0.648147362930253, -96.7877807617188, -1.68926544999042, 218, 20, 'PPL', 'P'),
(35792, 'Esco', 37.3669395446777, 0.652176126448297, -82.5508270263672, -1.44078373185443, 218, 21, 'PPL', 'P'),
(94087, 'Escobares', 26.4102802276611, 0.460946346347044, -98.9622192382813, -1.72721656078848, 218, 51, 'PPL', 'P'),
(94088, 'Escobares Number 1 Colonia', 26.4139995574951, 0.461011260898615, -98.9670028686523, -1.72730005088866, 218, 51, 'PPL', 'P'),
(94089, 'Escobas', 27.062219619751, 0.472324835262462, -99.0233306884766, -1.72828315680506, 218, 51, 'PPL', 'P'),
(169365, 'Escoheag', 41.6036109924316, 0.726119992536838, -71.7652816772461, -1.2525404538891, 218, 47, 'PPL', 'P'),
(35793, 'Escondida', 38.1261100769043, 0.665426151819769, -84.2280578613281, -1.47005693224047, 218, 21, 'PPL', 'P'),
(188527, 'Escondida', 34.101390838623, 0.595181549643402, -106.89582824707, -1.86568415955774, 218, 38, 'PPL', 'P'),
(181476, 'Escondido', 33.1191711425781, 0.578038581969481, -117.085563659668, -2.04352859241463, 218, 6, 'PPL', 'P'),
(188528, 'Escondido (historical)', 33.4897193908691, 0.584505868939656, -105.244438171387, -1.8368619655023, 218, 38, 'PPL', 'P'),
(181477, 'Escondido Junction', 33.1816711425781, 0.579129412751977, -117.367782592773, -2.04845424200878, 218, 6, 'PPL', 'P'),
(181479, 'Escondido Village', 37.4263916015625, 0.653213760588019, -122.154167175293, -2.13199241224044, 218, 6, 'PPL', 'P'),
(188529, 'Escondillo', 35.9527816772461, 0.627494415518634, -105.890281677246, -1.84813406113217, 218, 38, 'PPL', 'P'),
(174028, 'Esdaile', 44.6208305358887, 0.778780407825683, -92.438606262207, -1.61335803523016, 218, 57, 'PPL', 'P'),
(161411, 'Eshbach', 40.3849983215332, 0.704851189123138, -75.6202774047852, -1.31982282198497, 218, 45, 'PPL', 'P'),
(161412, 'Eshcol', 40.4561080932617, 0.706092288770142, -77.3055572509766, -1.34923650411852, 218, 45, 'PPL', 'P'),
(181480, 'Eshel (historical)', 36.7222213745117, 0.640923671631467, -119.70832824707, -2.08930446996951, 218, 6, 'PPL', 'P'),
(211815, 'Eska', 61.7377815246582, 1.07752756048221, -148.908615112305, -2.5989456182947, 218, 1, 'PPL', 'P'),
(196438, 'Eskay (historical)', 47.8300018310547, 0.834791013186821, -109.635276794434, -1.9134965563982, 218, 31, 'PPL', 'P'),
(109111, 'Eskdale', 38.0911102294922, 0.664815289244732, -81.4438934326172, -1.42146409604256, 218, 58, 'PPL', 'P'),
(192561, 'Eskdale', 39.1072196960449, 0.68254974499676, -113.951667785645, -1.98883179099825, 218, 52, 'PPL', 'P'),
(181482, 'Eskini (historical)', 39.6444396972656, 0.691926002825629, -121.800003051758, -2.12581108219232, 218, 6, 'PPL', 'P'),
(135260, 'Esko', 46.7058296203613, 0.815170506750798, -92.3630599975586, -1.61203950417446, 218, 28, 'PPL', 'P'),
(64566, 'Eskota', 35.7955589294434, 0.624750360910443, -82.309440612793, -1.43657074416798, 218, 33, 'PPL', 'P'),
(191437, 'Eskota', 32.5247192382813, 0.56766343899475, -100.246673583984, -1.74963451821255, 218, 51, 'PPL', 'P'),
(32383, 'Eskridge', 38.8588905334473, 0.678215583480711, -96.10888671875, -1.67741651366844, 218, 20, 'PPL', 'P'),
(59833, 'Eskridge', 33.5752792358398, 0.585999169941891, -89.7008285522461, -1.56557480000363, 218, 30, 'PPL', 'P'),
(181481, 'Esmar (historical)', 37.5680618286133, 0.655686372502103, -120.928611755371, -2.11060243499715, 218, 6, 'PPL', 'P'),
(64567, 'Esmeralda (historical)', 35.4427795410156, 0.618593199049207, -82.2638931274414, -1.43577579058259, 218, 33, 'PPL', 'P'),
(190180, 'Esmeralda (historical)', 38.2866706848145, 0.668228463076804, -118.880561828613, -2.07485722052999, 218, 39, 'PPL', 'P'),
(20923, 'Esmond', 33.2655601501465, 0.580593552140275, -84.3333282470703, -1.47189424707651, 218, 13, 'PPL', 'P'),
(119556, 'Esmond', 42.0336112976074, 0.733624913646736, -88.9355621337891, -1.55221838134661, 218, 18, 'PPL', 'P'),
(139985, 'Esmond', 48.035831451416, 0.838383417760256, -99.7616729736328, -1.74116966068773, 218, 34, 'PPL', 'P'),
(169366, 'Esmond', 41.8722190856934, 0.730808088161759, -71.495002746582, -1.24782319665025, 218, 47, 'PPL', 'P'),
(170256, 'Esmond', 44.2622184753418, 0.772521446631779, -97.771110534668, -1.70642779216127, 218, 49, 'PPL', 'P'),
(178166, 'Esmond', 32.0933303833008, 0.560134283118932, -110.764167785645, -1.93319942109093, 218, 5, 'PPL', 'P'),
(101746, 'Esmont', 37.8311080932617, 0.660277395905291, -78.6074981689453, -1.37195965980351, 218, 53, 'PPL', 'P'),
(101747, 'Esnon', 36.7555618286133, 0.641505572329649, -78.4722213745117, -1.3695986343391, 218, 53, 'PPL', 'P'),
(174029, 'Esofea', 43.6311111450195, 0.761506545784184, -90.9630584716797, -1.58760486801493, 218, 57, 'PPL', 'P'),
(20924, 'Esom Hill', 33.9488906860352, 0.59251991987095, -85.3877792358398, -1.49029788863145, 218, 13, 'PPL', 'P'),
(148704, 'Esopus', 41.8277816772461, 0.730032509073301, -73.9655609130859, -1.29094257101777, 218, 40, 'PPL', 'P'),
(40833, 'Espanita Forest', 32.5513916015625, 0.568128959553296, -93.6136093139648, -1.63386570720432, 218, 22, 'PPL', 'P'),
(40834, 'Espanita Village', 32.5499992370605, 0.568104658208349, -93.6097183227539, -1.63379779659652, 218, 22, 'PPL', 'P'),
(15948, 'Espanola', 29.5069408416748, 0.514993269878412, -81.3097229003906, -1.41912237849605, 218, 12, 'PPL', 'P'),
(188531, 'Espanola', 36.0027809143066, 0.628367066828825, -106.057220458984, -1.85104769252277, 218, 38, 'PPL', 'P'),
(207354, 'Espanola', 47.603328704834, 0.830834820808481, -117.740562438965, -2.0549604777099, 218, 56, 'PPL', 'P'),
(94090, 'Espantosa Colonia', 28.6270008087158, 0.499635419083171, -99.8330001831055, -1.74241455533929, 218, 51, 'PPL', 'P'),
(181483, 'Esparto', 38.6922187805176, 0.675306612622017, -122.01611328125, -2.12958291724419, 218, 6, 'PPL', 'P'),
(94092, 'Esparza Colonia Number 1', 26.0270004272461, 0.454256851873415, -97.6259994506836, -1.7038951259646, 218, 51, 'PPL', 'P'),
(94091, 'Esparza Colonia Number 2', 26.0279998779297, 0.454274295578555, -97.6269989013672, -1.70391256966974, 218, 51, 'PPL', 'P'),
(135261, 'Espelie', 48.2236099243164, 0.841660770376735, -95.6800003051758, -1.6699310336345, 218, 28, 'PPL', 'P'),
(211816, 'Espenberg', 66.5927810668945, 1.16226328767705, -163.964721679688, -2.86172425042667, 218, 1, 'PPL', 'P'),
(139145, 'Esper', 40.5288887023926, 0.707362550031083, -92.851936340332, -1.62057200599097, 218, 29, 'PPL', 'P'),
(148706, 'Esperance', 42.7611083984375, 0.746322133354934, -74.2569427490234, -1.29602814343539, 218, 40, 'PPL', 'P'),
(207355, 'Esperance', 47.7891693115234, 0.834078351279116, -122.35417175293, -2.13548315063926, 218, 56, 'PPL', 'P'),
(40835, 'Esperance Landing', 31.4044399261475, 0.548110876456038, -91.4833297729492, -1.59668531522572, 218, 22, 'PPL', 'P'),
(59835, 'Esperanza', 34.357780456543, 0.599656392644035, -89.1608276367188, -1.5561500060639, 218, 30, 'PPL', 'P'),
(181484, 'Esperanza', 33.875560760498, 0.591240071230085, -117.755828857422, -2.05522692697696, 218, 6, 'PPL', 'P'),
(191438, 'Esperanza', 31.1594390869141, 0.543834805141266, -105.709999084473, -1.84498753630424, 218, 51, 'PPL', 'P'),
(193531, 'Esperanza (historical)', 41.2633285522461, 0.720180943568879, -122.048889160156, -2.13015496424634, 218, 6, 'PPL', 'P'),
(94096, 'Esperanza Estates Colonia', 26.1609992980957, 0.456595573363696, -98.1070022583008, -1.71229020866886, 218, 51, 'PPL', 'P'),
(46907, 'Esperanza Farm', 38.3036117553711, 0.66852414053683, -76.4752807617188, -1.33474544567907, 218, 25, 'PPL', 'P'),
(94094, 'Esperson', 29.9552803039551, 0.522818269661824, -94.9172210693359, -1.65661802450325, 218, 51, 'PPL', 'P'),
(94095, 'Espey', 29.1123294830322, 0.508106002404331, -98.4887237548828, -1.71895250560986, 218, 51, 'PPL', 'P'),
(186691, 'Espinosa', 37.1305618286133, 0.648050557024628, -105.945556640625, -1.84909879123705, 218, 7, 'PPL', 'P'),
(192880, 'Esplanada', 33.3525009155273, 0.582110954750375, -111.846939086914, -1.95209734534419, 218, 5, 'PPL', 'P'),
(161413, 'Esplen', 40.4575004577637, 0.706116590115089, -80.0508270263672, -1.39715050055457, 218, 45, 'PPL', 'P'),
(188532, 'Espuela', 32.9297218322754, 0.574732067739065, -104.387222290039, -1.8219007259724, 218, 38, 'PPL', 'P'),
(161414, 'Espy', 41.0061111450195, 0.715691652919333, -76.4102783203125, -1.3336109390547, 218, 45, 'PPL', 'P'),
(155196, 'Espyville', 40.5969390869141, 0.708550253298231, -83.2552795410156, -1.453078747659, 218, 41, 'PPL', 'P'),
(161417, 'Espyville', 41.6063919067383, 0.726168528647705, -80.4944381713867, -1.4048929756337, 218, 45, 'PPL', 'P'),
(20925, 'Esquiline (historical)', 32.4180603027344, 0.565801889392785, -84.9241714477539, -1.48220640629147, 218, 13, 'PPL', 'P'),
(94099, 'Esquina Colonia', 26.1280002593994, 0.456019631488452, -97.4690017700195, -1.70115499951902, 218, 51, 'PPL', 'P'),
(86832, 'Esquire Estates', 35.9072189331055, 0.626699195617136, -86.3694381713867, -1.50743106918837, 218, 50, 'PPL', 'P'),
(203897, 'Esquire Estates', 40.5969390869141, 0.708550253298231, -111.793609619141, -1.95116657054321, 218, 52, 'PPL', 'P'),
(181485, 'Esquon', 39.6058311462402, 0.691252156490812, -121.765830993652, -2.12521466726619, 218, 6, 'PPL', 'P'),
(54653, 'Esrom', 37.4066696166992, 0.652869547017127, -94.3269424438477, -1.64631571898433, 218, 29, 'PPL', 'P'),
(86833, 'Essary Springs', 35.0119400024414, 0.611073630553314, -88.7980575561523, -1.54981847373029, 218, 50, 'PPL', 'P'),
(155197, 'Esselburn', 41.026668548584, 0.716050447297194, -82.0780563354492, -1.43253232669098, 218, 41, 'PPL', 'P'),
(40836, 'Essen', 30.3983306884766, 0.530550957623951, -91.1069412231445, -1.59011609576482, 218, 22, 'PPL', 'P'),
(141786, 'Essen', 41.7833290100098, 0.729256663668733, -96.4880599975586, -1.68403433581923, 218, 35, 'PPL', 'P'),
(161415, 'Essen', 40.3619384765625, 0.7044487189034, -80.0824966430664, -1.39770323963881, 218, 45, 'PPL', 'P'),
(101748, 'Esserville', 36.9552803039551, 0.644991317301427, -82.6111068725586, -1.44183581364306, 218, 53, 'PPL', 'P'),
(94097, 'Esseville', 28.6849994659424, 0.50064768661351, -98.2052764892578, -1.71400541756893, 218, 51, 'PPL', 'P'),
(8781, 'Essex', 35.1308288574219, 0.613148632516649, -91.8797225952148, -1.60360367510553, 218, 4, 'PPL', 'P'),
(20927, 'Essex', 33.788890838623, 0.58972739573092, -83.3958282470703, -1.45553178533907, 218, 13, 'PPL', 'P'),
(46908, 'Essex', 39.3091697692871, 0.68607443869948, -76.4752807617188, -1.33474544567907, 218, 25, 'PPL', 'P'),
(54654, 'Essex', 36.8125, 0.642499330890413, -89.8613891601563, -1.56837711126067, 218, 29, 'PPL', 'P'),
(59836, 'Essex', 34.329719543457, 0.59916663731957, -90.2747192382813, -1.57559108202148, 218, 30, 'PPL', 'P'),
(64569, 'Essex', 35.336109161377, 0.61673144971016, -82.4927825927734, -1.43977066537576, 218, 33, 'PPL', 'P'),
(113410, 'Essex', 41.353328704834, 0.721751742558835, -72.39111328125, -1.26346327594201, 218, 8, 'PPL', 'P'),
(115492, 'Essex', 40.833610534668, 0.712680949306998, -95.3080596923828, -1.66343944531937, 218, 16, 'PPL', 'P'),
(119557, 'Essex', 41.1772193908691, 0.71867805518672, -88.1855621337891, -1.53912841195666, 218, 18, 'PPL', 'P'),
(124794, 'Essex', 42.6319389343262, 0.744067700913154, -70.783332824707, -1.23540221332612, 218, 23, 'PPL', 'P'),
(139987, 'Essex', 48.122501373291, 0.839896093259421, -98.7455596923828, -1.72343513835668, 218, 34, 'PPL', 'P'),
(148708, 'Essex', 44.310001373291, 0.773355415527137, -73.3530578613281, -1.28025237608609, 218, 40, 'PPL', 'P'),
(155198, 'Essex', 40.4824981689453, 0.706552882480671, -83.3158264160156, -1.45413548997954, 218, 41, 'PPL', 'P'),
(193532, 'Essex', 40.9061088562012, 0.713946283719922, -124.034172058105, -2.16480468739909, 218, 6, 'PPL', 'P'),
(196439, 'Essex', 48.2780609130859, 0.84261111941173, -113.611671447754, -1.98289773545734, 218, 31, 'PPL', 'P'),
(209915, 'Essex', 46.8041687011719, 0.816886847494327, -123.005279541016, -2.14684712532674, 218, 56, 'PPL', 'P'),
(8782, 'Essex (historical)', 35.1097183227539, 0.612780184179837, -91.9008331298828, -1.60397212344234, 218, 4, 'PPL', 'P'),
(171996, 'Essex Center', 44.5119400024414, 0.776879909492775, -73.0599975585938, -1.27513750889648, 218, 55, 'PPL', 'P'),
(203898, 'Essex Court Condo', 40.6241683959961, 0.709025494394755, -111.863327026367, -1.95238336884527, 218, 52, 'PPL', 'P'),
(124796, 'Essex Falls', 42.625, 0.743946593662583, -70.7916717529297, -1.23554775507969, 218, 23, 'PPL', 'P'),
(145181, 'Essex Fells', 40.8244400024414, 0.712520893325484, -74.2850036621094, -1.29651789875985, 218, 37, 'PPL', 'P'),
(171998, 'Essex Junction', 44.4905586242676, 0.776506734045028, -73.1113891601563, -1.27603446155162, 218, 55, 'PPL', 'P'),
(101750, 'Essex Meadows', 36.7611083984375, 0.641602378235274, -76.2466735839844, -1.33075549773391, 218, 53, 'PPL', 'P'),
(46909, 'Essex Ridge', 38.4236106872559, 0.670618516997096, -75.504997253418, -1.31781080378142, 218, 25, 'PPL', 'P'),
(46910, 'Essex South', 38.2569389343262, 0.667709546138402, -76.460563659668, -1.33448858379193, 218, 25, 'PPL', 'P'),
(20928, 'Essex Village', 33.6377792358398, 0.587090000724387, -83.852783203125, -1.46350715385553, 218, 13, 'PPL', 'P'),
(46911, 'Essexshire', 39.3055610656738, 0.6860114549397, -76.4444427490234, -1.33420722082276, 218, 25, 'PPL', 'P'),
(46912, 'Essexshire Gate', 39.3063888549805, 0.686025902588613, -76.4499969482422, -1.33430415988644, 218, 25, 'PPL', 'P'),
(130704, 'Essexville', 43.6152801513672, 0.761230242821088, -83.8419418334961, -1.46331793626008, 218, 27, 'PPL', 'P'),
(35794, 'Essie', 37.0616683959961, 0.646848139792457, -83.4519424438477, -1.45651116282994, 218, 21, 'PPL', 'P'),
(135263, 'Essig', 44.3241691589355, 0.773602690034351, -94.6041717529297, -1.65115428321084, 218, 28, 'PPL', 'P'),
(135264, 'Essig Trailer Court', 44.3241691589355, 0.773602690034351, -94.6041717529297, -1.65115428321084, 218, 28, 'PPL', 'P'),
(78220, 'Essington', 39.8619384765625, 0.695722072643428, -75.2975006103516, -1.31418930417307, 218, 45, 'PPL', 'P'),
(101751, 'Estabrook', 36.8794403076172, 0.64366765966063, -76.246940612793, -1.33076015826582, 218, 53, 'PPL', 'P'),
(186692, 'Estabrook', 39.3830604553223, 0.687364074457351, -105.428886413574, -1.84008119462799, 218, 7, 'PPL', 'P'),
(200785, 'Estabrook', 43.0441703796387, 0.751262496914112, -124.133613586426, -2.1665402694815, 218, 43, 'PPL', 'P'),
(101752, 'Estabrook Park', 36.8727798461914, 0.643551412679048, -76.2408294677734, -1.33065349866416, 218, 53, 'PPL', 'P'),
(127445, 'Estabrook Settlement', 45.920280456543, 0.80146008740588, -67.8850021362305, -1.18481680000061, 218, 26, 'PPL', 'P'),
(188533, 'Estaca', 36.1119384765625, 0.630272225693641, -106.058059692383, -1.85106233990876, 218, 38, 'PPL', 'P'),
(200786, 'Estacada', 45.2897186279297, 0.790454707359182, -122.332496643066, -2.13510484860642, 218, 43, 'PPL', 'P'),
(191439, 'Estacado', 33.7522201538086, 0.589087371541947, -101.561393737793, -1.77258071363884, 218, 51, 'PPL', 'P'),
(178167, 'Estados de La Mancha II', 33.5763893127441, 0.586018544438821, -111.901390075684, -1.95304769437919, 218, 5, 'PPL', 'P'),
(101753, 'Estaline', 38.063060760498, 0.664325733657348, -79.3572235107422, -1.3850448355035, 218, 53, 'PPL', 'P'),
(86834, 'Estanaula (historical)', 35.4597206115723, 0.618888876509233, -89.091667175293, -1.55494292829982, 218, 50, 'PPL', 'P'),
(188535, 'Estancia', 34.7583312988281, 0.606647323663548, -106.055282592773, -1.85101387037693, 218, 38, 'PPL', 'P'),
(188534, 'Estancia Ranchettes', 34.9938888549805, 0.610758578596358, -105.917778015137, -1.8486139627606, 218, 38, 'PPL', 'P'),
(15949, 'Estanifanulga (historical)', 30.1666698455811, 0.526507713167479, -85.1333312988281, -1.48585693435569, 218, 12, 'PPL', 'P'),
(109112, 'Estar', 38.8980598449707, 0.678899216932534, -81.841667175293, -1.42840655753023, 218, 58, 'PPL', 'P'),
(178168, 'Estate Monterra', 33.5319404602051, 0.585242765613281, -112.040283203125, -1.95547183676143, 218, 5, 'PPL', 'P'),
(46914, 'Estates At Rivers Edge', 39.0561103820801, 0.681657719189638, -77.2825012207031, -1.34883410047781, 218, 25, 'PPL', 'P'),
(178169, 'Estates La Colina', 33.3380584716797, 0.581858886553199, -111.901107788086, -1.95304276753117, 218, 5, 'PPL', 'P'),
(115488, 'Estates West', 42.4066696166992, 0.740136009616843, -96.3644409179688, -1.6818767758621, 218, 16, 'PPL', 'P'),
(64571, 'Estatoe', 35.9033317565918, 0.626631351588366, -82.1197204589844, -1.43325950282663, 218, 33, 'PPL', 'P'),
(2324, 'Estaville (historical)', 34.9738883972168, 0.610409504756475, -86.8805618286133, -1.51635185989181, 218, 2, 'PPL', 'P'),
(127446, 'Estcourt', 47.4594383239746, 0.828323459900536, -69.2252807617188, -1.20820907490948, 218, 26, 'PPL', 'P'),
(70795, 'Estell Manor', 39.4119415283203, 0.687868144272675, -74.7427825927734, -1.3045076483462, 218, 37, 'PPL', 'P'),
(75784, 'Estella', 36.6847190856934, 0.640269133214553, -95.2869415283203, -1.66307086382451, 218, 42, 'PPL', 'P'),
(161416, 'Estella', 41.5105590820313, 0.72449593032508, -76.6227798461914, -1.33731979034679, 218, 45, 'PPL', 'P'),
(20929, 'Estelle', 34.746940612793, 0.606448518688173, -85.3411102294922, -1.48948336081205, 218, 13, 'PPL', 'P'),
(40839, 'Estelle', 29.8455600738525, 0.520903290390489, -90.1066665649414, -1.57265800955492, 218, 22, 'PPL', 'P'),
(64572, 'Estelle', 36.5019416809082, 0.637079065702802, -79.2413864135742, -1.38302309676197, 218, 33, 'PPL', 'P'),
(94098, 'Estelle', 32.8661117553711, 0.573621862459639, -97.0127792358398, -1.69319241417579, 218, 51, 'PPL', 'P'),
(112206, 'Estelle', 31.9691696166992, 0.557967268939935, -87.2024993896484, -1.52197073031771, 218, 2, 'PPL', 'P'),
(181488, 'Estelle', 33.1763916015625, 0.57903726737826, -115.507781982422, -2.01599110726904, 218, 6, 'PPL', 'P'),
(20930, 'Estelle Station (historical)', 34.7519416809082, 0.606535803792901, -85.352783203125, -1.48968709263544, 218, 13, 'PPL', 'P'),
(170258, 'Estelline', 44.5747184753418, 0.777975600544261, -96.9019393920898, -1.69125789395996, 218, 49, 'PPL', 'P'),
(191440, 'Estelline', 34.5466690063477, 0.602953119757444, -100.437782287598, -1.75296999431982, 218, 51, 'PPL', 'P'),
(70797, 'Estellville', 39.3958282470703, 0.687586914461563, -74.7474975585938, -1.30458994002388, 218, 37, 'PPL', 'P'),
(109113, 'Estep', 38.0233306884766, 0.663632313088518, -81.9194412231445, -1.42976397073784, 218, 58, 'PPL', 'P'),
(2322, 'Estep (historical)', 34.8722190856934, 0.608635040522156, -87.2513885498047, -1.52282400713097, 218, 2, 'PPL', 'P'),
(211817, 'Ester', 64.8472213745117, 1.13179752375487, -148.014434814453, -2.58333922799073, 218, 1, 'PPL', 'P'),
(209441, 'Esterbrook', 42.4116706848145, 0.74022329472157, -105.360282897949, -1.83888383740189, 218, 59, 'PPL', 'P'),
(135265, 'Esterdy', 46.4766693115234, 0.81117090484669, -94.7322235107422, -1.65338920799763, 218, 28, 'PPL', 'P'),
(15950, 'Estero', 26.437780380249, 0.461426314554504, -81.8069381713867, -1.42780042206613, 218, 12, 'PPL', 'P'),
(54655, 'Estes', 39.2366714477539, 0.684809104286556, -91.376106262207, -1.59481391192772, 218, 29, 'PPL', 'P'),
(59837, 'Estes', 33.0611114501953, 0.577025249174705, -89.0491714477539, -1.55420123793623, 218, 30, 'PPL', 'P'),
(94101, 'Estes', 32.4383316040039, 0.566155690343602, -94.6666717529297, -1.65224511399334, 218, 51, 'PPL', 'P'),
(101755, 'Estes', 38.6194381713867, 0.674036351361076, -78.061393737793, -1.36242833942017, 218, 53, 'PPL', 'P'),
(112232, 'Estes', 34.6083297729492, 0.604029303153945, -92.1186065673828, -1.6077729869501, 218, 4, 'PPL', 'P'),
(194904, 'Estes', 46.7777786254883, 0.816426253783798, -117.018890380859, -2.04236492417632, 218, 17, 'PPL', 'P'),
(207358, 'Estes', 46.6338882446289, 0.813914892875853, -118.65193939209, -2.07086700626873, 218, 56, 'PPL', 'P'),
(200787, 'Estes (historical)', 44.7847213745117, 0.78164084257351, -117.845832824707, -2.05679779254595, 218, 43, 'PPL', 'P'),
(86835, 'Estes Acres', 35.9630584716797, 0.62767377941805, -86.3716735839844, -1.50747008449834, 218, 50, 'PPL', 'P'),
(135266, 'Estes Brook', 45.6488914489746, 0.796723455670092, -93.7369384765625, -1.63601820715537, 218, 28, 'PPL', 'P'),
(2323, 'Estes Crossroads', 33.9958305358887, 0.593339174801286, -85.7099990844727, -1.49592168590537, 218, 2, 'PPL', 'P'),
(127447, 'Estes Hill', 43.3708305358887, 0.756963792175754, -70.8013916015625, -1.23571739844113, 218, 26, 'PPL', 'P'),
(194176, 'Estes Park', 40.3772201538086, 0.704715434486571, -105.521110534668, -1.84169080919083, 218, 7, 'PPL', 'P'),
(188536, 'Estes Place', 32.8852806091309, 0.57395642207158, -108.920562744141, -1.90102244301032, 218, 38, 'PPL', 'P'),
(86836, 'Estes Pond', 36.4330596923828, 0.635876848207713, -89.4488906860352, -1.5611776547278, 218, 50, 'PPL', 'P'),
(35795, 'Estesburg', 37.2574996948242, 0.650266040735465, -84.5936126708984, -1.47643706726397, 218, 21, 'PPL', 'P'),
(59838, 'Estesmill', 32.6505584716797, 0.569859747945738, -89.4700012207031, -1.56154610306462, 218, 30, 'PPL', 'P'),
(130706, 'Estey', 43.8699989318848, 0.765675924207785, -84.2055587768555, -1.46966424913774, 218, 27, 'PPL', 'P'),
(40843, 'Esther', 29.8441696166992, 0.520879022335055, -92.1750030517578, -1.608757291289, 218, 22, 'PPL', 'P'),
(54656, 'Esther', 37.8502807617188, 0.660612022096259, -90.4986114501953, -1.57949873828895, 218, 29, 'PPL', 'P'),
(161426, 'Esther (historical)', 40.6936111450195, 0.710237499006851, -80.4691696166992, -1.40445195615718, 218, 45, 'PPL', 'P'),
(115489, 'Estherville', 43.401668548584, 0.757502017032059, -94.8324966430664, -1.65513930430798, 218, 16, 'PPL', 'P'),
(40840, 'Estherwood', 30.1805591583252, 0.526750127405703, -92.4641723632813, -1.6138042478708, 218, 22, 'PPL', 'P'),
(8783, 'Estico', 35.6230583190918, 0.621739657298109, -91.1133270263672, -1.59022754905644, 218, 4, 'PPL', 'P'),
(15951, 'Estiffanulga', 30.3080596923828, 0.52897543152306, -85.0325012207031, -1.48409711750737, 218, 12, 'PPL', 'P'),
(35796, 'Estill', 37.4569396972656, 0.653746925438253, -82.8188934326172, -1.44546237325748, 218, 21, 'PPL', 'P'),
(54670, 'Estill', 39.0483283996582, 0.681521897974044, -92.7441711425781, -1.6186911484711, 218, 29, 'PPL', 'P'),
(59839, 'Estill', 33.2180595397949, 0.579764510092934, -90.8708267211914, -1.58599512029403, 218, 30, 'PPL', 'P'),
(80900, 'Estill', 32.7547187805176, 0.571677688284854, -81.2422180175781, -1.4179441960298, 218, 48, 'PPL', 'P'),
(86839, 'Estill Springs', 35.2705612182617, 0.615587422284889, -86.128059387207, -1.50321821465997, 218, 50, 'PPL', 'P'),
(2325, 'Estillfork', 34.9099998474121, 0.609294439208059, -86.1705627441406, -1.50396003818161, 218, 2, 'PPL', 'P'),
(15952, 'Esto', 30.9872207641602, 0.540829028376948, -85.646110534668, -1.49480662035696, 218, 12, 'PPL', 'P'),
(35798, 'Esto', 37.0041694641113, 0.645844594114688, -85.1108322143555, -1.48546425125296, 218, 21, 'PPL', 'P'),
(40841, 'Esto', 31.392219543457, 0.547897590542236, -93.6086120605469, -1.63377848867862, 218, 22, 'PPL', 'P'),
(155199, 'Esto', 40.3338890075684, 0.703959163316016, -82.2302780151367, -1.43518909619444, 218, 41, 'PPL', 'P'),
(2327, 'Estothel', 31.2444400787354, 0.545318352316008, -86.1983337402344, -1.50444473350001, 218, 2, 'PPL', 'P'),
(130707, 'Estral Beach', 41.9841690063477, 0.732761982874523, -83.2358322143555, -1.45273932777807, 218, 27, 'PPL', 'P'),
(178170, 'Estrella', 33.0011100769043, 0.575978027655059, -112.41667175293, -1.96204105622233, 218, 5, 'PPL', 'P'),
(181490, 'Estrella', 35.7055587768555, 0.623179561920487, -120.609169006348, -2.10502710725506, 218, 6, 'PPL', 'P'),
(186693, 'Estrella', 37.3661117553711, 0.652161678799384, -105.923889160156, -1.84872062236226, 218, 7, 'PPL', 'P'),
(178171, 'Estrella Camp', 33.4486083984375, 0.583788346762962, -112.373893737793, -1.96129443901072, 218, 5, 'PPL', 'P'),
(178172, 'Estrella Estates Family Park', 33.4686088562012, 0.584137420602844, -112.089721679688, -1.95633470095462, 218, 5, 'PPL', 'P'),
(193533, 'Estrellita', 40.8594398498535, 0.713131755900521, -122.78971862793, -2.14308487765479, 218, 6, 'PPL', 'P'),
(200788, 'Estrup (historical)', 44.2166709899902, 0.77172649304639, -123.404167175293, -2.15380902789037, 218, 43, 'PPL', 'P'),
(109114, 'Esty', 38.0149993896484, 0.663486904493, -80.383056640625, -1.402949001196, 218, 58, 'PPL', 'P'),
(46915, 'Esworthy Estates', 39.0669403076172, 0.681846737048006, -77.2847213745117, -1.34887284947167, 218, 25, 'PPL', 'P'),
(46916, 'Esworthy Park', 39.0680618286133, 0.681866311282018, -77.2880630493164, -1.34893117269954, 218, 25, 'PPL', 'P'),
(109115, 'Etam', 39.2852783203125, 0.685657454251801, -79.7283325195313, -1.39152190959069, 218, 58, 'PPL', 'P'),
(59840, 'Etchehoma (historical)', 31.9491691589355, 0.557618195100053, -89.3000030517578, -1.55857907529416, 218, 30, 'PPL', 'P'),
(196440, 'Etchetah (historical)', 46.2036094665527, 0.806405111496966, -107.440277099609, -1.87518658464325, 218, 31, 'PPL', 'P'),
(46917, 'Etchison', 39.2544403076172, 0.685119229395496, -77.1438903808594, -1.34641488494358, 218, 25, 'PPL', 'P'),
(200789, 'Etelka (historical)', 42.9625015258789, 0.749837106519675, -124.108329772949, -2.16609898368887, 218, 43, 'PPL', 'P'),
(170262, 'Ethan', 43.547779083252, 0.760052126933864, -97.9877777099609, -1.71020934775113, 218, 49, 'PPL', 'P'),
(181491, 'Etheda Springs', 36.6941719055176, 0.640434116044083, -119.006393432617, -2.07705339632293, 218, 6, 'PPL', 'P'),
(8784, 'Ethel', 34.2863883972168, 0.598410366149015, -91.1636123657227, -1.59110519379368, 218, 4, 'PPL', 'P'),
(15953, 'Ethel', 28.8019409179688, 0.502688699983433, -81.4436111450195, -1.42145916919454, 218, 12, 'PPL', 'P'),
(29737, 'Ethel', 38.4036102294922, 0.670269443157214, -86.5244369506836, -1.51013630822367, 218, 19, 'PPL', 'P'),
(40842, 'Ethel', 30.791109085083, 0.537406233875437, -91.1305618286133, -1.59052835310157, 218, 22, 'PPL', 'P'),
(54657, 'Ethel', 39.894718170166, 0.696294186224604, -92.7377777099609, -1.61857956202143, 218, 29, 'PPL', 'P'),
(59841, 'Ethel', 33.1202812194824, 0.578057956466411, -89.4658279418945, -1.5614732656088, 218, 30, 'PPL', 'P'),
(75785, 'Ethel', 34.2294387817383, 0.59741640785117, -95.5438919067383, -1.66755549394215, 218, 42, 'PPL', 'P'),
(94102, 'Ethel', 33.5436096191406, 0.585446430857645, -96.8438873291016, -1.69024469432324, 218, 51, 'PPL', 'P'),
(101756, 'Ethel', 37.9961090087891, 0.663157205150048, -76.7811126708984, -1.34008321945192, 218, 53, 'PPL', 'P'),
(109116, 'Ethel', 37.8663902282715, 0.660893185328345, -81.9124984741211, -1.42964279690824, 218, 58, 'PPL', 'P'),
(207357, 'Ethel', 46.5322189331055, 0.812140428641533, -122.739166259766, -2.14220257238564, 218, 56, 'PPL', 'P'),
(86837, 'Ethel (historical)', 35.980281829834, 0.627974383726093, -84.3341674804688, -1.47190889446251, 218, 50, 'PPL', 'P'),
(2326, 'Ethelsville', 33.4155616760254, 0.583211572649878, -88.216667175293, -1.53967129734487, 218, 2, 'PPL', 'P'),
(194905, 'Ethelton', 47.2550010681152, 0.824755356672048, -115.904716491699, -2.02291892137072, 218, 17, 'PPL', 'P'),
(130708, 'Ethelwood', 46.4872207641602, 0.811355062436069, -89.7244415283203, -1.56598692418232, 218, 27, 'PPL', 'P'),
(64573, 'Ether', 35.4397201538086, 0.618539802669351, -79.7841720581055, -1.3924964933916, 218, 33, 'PPL', 'P'),
(20931, 'Etheridge Glen', 34.0149993896484, 0.593673734413227, -84.6800003051758, -1.47794481591512, 218, 13, 'PPL', 'P'),
(27114, 'Etherton', 37.6852798461914, 0.657732212851502, -89.3211135864258, -1.55894752363097, 218, 18, 'PPL', 'P'),
(209442, 'Ethete', 43.0250015258789, 0.750927937302171, -108.771942138672, -1.89842852410859, 218, 59, 'PPL', 'P'),
(54658, 'Ethlyn', 38.9408302307129, 0.679645700986083, -90.8258285522461, -1.58520975408857, 218, 29, 'PPL', 'P'),
(191441, 'Etholen', 31.1922206878662, 0.544406952011956, -105.423889160156, -1.83999397610229, 218, 51, 'PPL', 'P'),
(80901, 'Ethon Crossroads', 33.9311103820801, 0.592209595024929, -81.3130569458008, -1.41918056856587, 218, 48, 'PPL', 'P'),
(20933, 'Ethridge', 33.1344413757324, 0.57830509781557, -83.4683303833008, -1.45679718633102, 218, 13, 'PPL', 'P'),
(35799, 'Ethridge', 38.7713890075684, 0.676688393753605, -84.9524993896484, -1.48270082214784, 218, 21, 'PPL', 'P'),
(86838, 'Ethridge', 35.3236083984375, 0.616513270237855, -87.3036117553711, -1.52373547401405, 218, 50, 'PPL', 'P'),
(196441, 'Ethridge', 48.5577812194824, 0.847493159743036, -112.119720458984, -1.95685827842493, 218, 31, 'PPL', 'P'),
(101757, 'Ethridge Estates', 37.1552810668945, 0.648481989121221, -77.3611068725586, -1.35020602791336, 218, 53, 'PPL', 'P'),
(181495, 'Etiwa (historical)', 34.0647201538086, 0.594541525454429, -117.523330688477, -2.05116906842401, 218, 6, 'PPL', 'P'),
(181492, 'Etiwanda', 34.1261100769043, 0.595612981739995, -117.52278137207, -2.05115948104409, 218, 6, 'PPL', 'P'),
(54659, 'Etlah', 38.6391716003418, 0.674380764669051, -91.2763900756836, -1.59307353615536, 218, 29, 'PPL', 'P'),
(101758, 'Etlan', 38.5252799987793, 0.672392981231416, -78.2627792358398, -1.36594317942686, 218, 53, 'PPL', 'P'),
(314, 'Etna', 35.3730583190918, 0.617376334168123, -93.8511123657227, -1.63801091744102, 218, 4, 'PPL', 'P'),
(20934, 'Etna', 34.0074996948242, 0.593542840045649, -85.3955612182617, -1.49043370984705, 218, 13, 'PPL', 'P'),
(27115, 'Etna', 39.3894386291504, 0.687475394590916, -88.4197235107422, -1.54321529896549, 218, 18, 'PPL', 'P'),
(35800, 'Etna', 37.225830078125, 0.649713301651219, -84.5802764892578, -1.4762043069847, 218, 21, 'PPL', 'P'),
(72472, 'Etna', 39.957218170166, 0.697385017007101, -82.6819381713867, -1.44307205302108, 218, 41, 'PPL', 'P'),
(75786, 'Etna', 36.3705596923828, 0.634786017425216, -97.7463912963867, -1.70599636006468, 218, 42, 'PPL', 'P'),
(122590, 'Etna', 41.273609161377, 0.720360374047323, -85.5736083984375, -1.49354121936501, 218, 19, 'PPL', 'P'),
(127448, 'Etna', 44.8208312988281, 0.782271079645477, -69.1116714477539, -1.20622621831986, 218, 26, 'PPL', 'P'),
(135268, 'Etna', 43.6022186279297, 0.761002276231777, -92.3466720581055, -1.61175348067339, 218, 28, 'PPL', 'P'),
(139146, 'Etna', 40.4174995422363, 0.705418442435325, -91.9791717529297, -1.60533939034599, 218, 29, 'PPL', 'P'),
(143811, 'Etna', 43.6927795410156, 0.76258286233874, -72.2222213745117, -1.26051555608945, 218, 36, 'PPL', 'P'),
(148711, 'Etna', 42.4850006103516, 0.741503143362435, -76.3838882446289, -1.33315034534417, 218, 40, 'PPL', 'P'),
(161418, 'Etna', 40.5041694641113, 0.70693111793449, -79.9491729736328, -1.39537630263636, 218, 45, 'PPL', 'P'),
(174032, 'Etna', 42.5658302307129, 0.742913886370878, -90.3274993896484, -1.57651226944253, 218, 57, 'PPL', 'P'),
(190183, 'Etna', 37.5552787780762, 0.655463266181782, -114.570556640625, -1.99963343922156, 218, 39, 'PPL', 'P'),
(193534, 'Etna', 41.4569396972656, 0.723560095518026, -122.893608093262, -2.14489809088297, 218, 6, 'PPL', 'P'),
(199306, 'Etna', 41.1405601501465, 0.718038230734829, -100.156936645508, -1.74806831317548, 218, 35, 'PPL', 'P'),
(203901, 'Etna', 41.6716690063477, 0.72730782896204, -113.95361328125, -1.98886574630215, 218, 52, 'PPL', 'P'),
(207359, 'Etna', 45.9383316040039, 0.801775139362836, -122.597221374512, -2.1397251667816, 218, 56, 'PPL', 'P'),
(209443, 'Etna', 43.0333290100098, 0.751073279318662, -111.010276794434, -1.93749483361312, 218, 59, 'PPL', 'P'),
(86840, 'Etna (historical)', 35.7591705322266, 0.624115263569487, -88.0811080932617, -1.53730534503244, 218, 50, 'PPL', 'P'),
(196443, 'Etna (historical)', 46.4361114501953, 0.810463036628947, -114.08332824707, -1.99112969954483, 218, 31, 'PPL', 'P'),
(200790, 'Etna (historical)', 42.5972213745117, 0.743461765186134, -122.818061828613, -2.14357955982727, 218, 43, 'PPL', 'P'),
(127449, 'Etna Center', 44.7866706848145, 0.781674864456436, -69.1063919067383, -1.20613407294615, 218, 26, 'PPL', 'P'),
(161419, 'Etna Furnace', 40.5233306884766, 0.707265544388377, -78.1797180175781, -1.36449348768747, 218, 45, 'PPL', 'P'),
(122586, 'Etna Green', 41.2788887023926, 0.72045251942104, -86.0461120605469, -1.50178796399655, 218, 19, 'PPL', 'P'),
(101759, 'Etna Mills', 37.7655601501465, 0.65913336848002, -77.26611328125, -1.34854807697673, 218, 53, 'PPL', 'P'),
(35801, 'Etoile', 36.8355598449707, 0.642901801110151, -85.9000015258789, -1.49923785409474, 218, 21, 'PPL', 'P'),
(94103, 'Etoile', 31.3866691589355, 0.547800718057585, -94.4358291625977, -1.64821615073821, 218, 51, 'PPL', 'P'),
(86841, 'Etola', 35.311939239502, 0.616309604993492, -84.8944396972656, -1.48168748935306, 218, 50, 'PPL', 'P'),
(20940, 'Eton', 34.8250007629395, 0.607810925322831, -84.7633285522461, -1.47939916818641, 218, 13, 'PPL', 'P'),
(54660, 'Eton', 39.1708297729492, 0.683659950276187, -94.3472213745117, -1.6466696530932, 218, 29, 'PPL', 'P'),
(98, 'Eton Hill', 37.2255592346191, 0.649708574540284, -80.0083312988281, -1.39640881019098, 218, 53, 'PPL', 'P'),
(15962, 'Etotulga (historical)', 30.6222190856934, 0.534458547312397, -83.3333282470703, -1.45444095455657, 218, 12, 'PPL', 'P'),
(8785, 'Etowah', 35.728889465332, 0.62358675925116, -90.2322235107422, -1.57484939165789, 218, 4, 'PPL', 'P'),
(20936, 'Etowah', 34.1988906860352, 0.596883243000936, -85.0841674804688, -1.48499886385247, 218, 13, 'PPL', 'P'),
(64574, 'Etowah', 35.3175010681152, 0.616406677215225, -82.5944366455078, -1.44154486329397, 218, 33, 'PPL', 'P'),
(75787, 'Etowah', 35.1269416809082, 0.61308078848788, -97.1686096191406, -1.69591216743904, 218, 42, 'PPL', 'P'),
(86842, 'Etowah', 35.3233299255371, 0.616508409968866, -84.5250015258789, -1.47523957687982, 218, 50, 'PPL', 'P'),
(109123, 'Etowah', 38.3761100769043, 0.669789474949754, -81.6011123657227, -1.42420808407172, 218, 58, 'PPL', 'P'),
(20937, 'Etowah (historical)', 34.4777793884277, 0.601750769104301, -84.0494384765625, -1.46693943586842, 218, 13, 'PPL', 'P'),
(20939, 'Etowah Mills', 34.1230583190918, 0.595559718518194, -84.6427764892578, -1.4772951377672, 218, 13, 'PPL', 'P'),
(2329, 'Etowahton (historical)', 33.9208297729492, 0.592030164546484, -86.0972213745117, -1.50267998980367, 218, 2, 'PPL', 'P'),
(145182, 'Etra', 40.252498626709, 0.702538633190568, -74.5072174072266, -1.30039626025534, 218, 37, 'PPL', 'P'),
(59842, 'Etta', 34.4702796936035, 0.601619874736724, -89.2275009155273, -1.55731367430221, 218, 30, 'PPL', 'P'),
(101760, 'Etta', 38.1427803039551, 0.66571710216886, -77.1736068725586, -1.34693353556587, 218, 53, 'PPL', 'P'),
(8786, 'Etta (historical)', 34.2894401550293, 0.598463629370816, -92.8797225952148, -1.62105696762547, 218, 4, 'PPL', 'P'),
(20941, 'Etta (historical)', 33.9916687011719, 0.593266537082554, -84.7927780151367, -1.4799131582768, 218, 13, 'PPL', 'P'),
(80902, 'Etta (historical)', 34.9291687011719, 0.609628998820001, -81.4902801513672, -1.42227369701394, 218, 48, 'PPL', 'P'),
(181493, 'Ettawa Springs', 38.8511085510254, 0.678079762265116, -122.694999694824, -2.14143172040812, 218, 6, 'PPL', 'P'),
(32384, 'Ettenson', 39.225830078125, 0.684619886691106, -94.8627777099609, -1.6556678086263, 218, 20, 'PPL', 'P'),
(86843, 'Etter', 36.5613899230957, 0.638116633263496, -85.0980606079102, -1.48524134466972, 218, 50, 'PPL', 'P'),
(135269, 'Etter', 44.6616706848145, 0.779493202891443, -92.7436065673828, -1.61868129477507, 218, 28, 'PPL', 'P'),
(191442, 'Etter', 36.0269393920898, 0.628788711808412, -101.999168395996, -1.78022132280628, 218, 51, 'PPL', 'P'),
(193535, 'Ettersburg', 40.1386108398438, 0.70055091633196, -123.996109008789, -2.16414036186517, 218, 6, 'PPL', 'P'),
(54661, 'Etterville', 38.3675003051758, 0.669639206085247, -92.4700012207031, -1.61390598062445, 218, 29, 'PPL', 'P'),
(155200, 'Etties-Burg (historical)', 41.0930595397949, 0.717209188687487, -84.3608322143555, -1.472374281863, 218, 41, 'PPL', 'P'),
(101761, 'Ettrick', 37.2400016784668, 0.64996064273746, -77.4302825927734, -1.35141337199355, 218, 53, 'PPL', 'P'),
(174033, 'Ettrick', 44.1683311462402, 0.770882803613053, -91.2688903808594, -1.59294264178778, 218, 57, 'PPL', 'P'),
(35802, 'Etty', 37.2522201538086, 0.650173895361748, -82.6772232055664, -1.44298976134339, 218, 21, 'PPL', 'P'),
(35803, 'Eubank', 37.2783317565918, 0.650629628803288, -84.6586074829102, -1.47757144073029, 218, 21, 'PPL', 'P'),
(101762, 'Eubank', 37.8519401550293, 0.660640983973114, -76.773063659668, -1.33994273770441, 218, 53, 'PPL', 'P'),
(20942, 'Eubank (historical)', 33.6788902282715, 0.587807522901082, -82.2630615234375, -1.43576127635465, 218, 13, 'PPL', 'P'),
(94104, 'Eubank Acres', 30.3850002288818, 0.530318297213219, -97.682502746582, -1.70488129451626, 218, 51, 'PPL', 'P'),
(101763, 'Eubank Corner', 38.1375007629395, 0.665624956795143, -77.3111114501953, -1.3493334431822, 218, 53, 'PPL', 'P'),
(64575, 'Eubanks', 35.9697189331055, 0.627790026399632, -79.0758285522461, -1.38013356697924, 218, 33, 'PPL', 'P'),
(75788, 'Eubanks', 34.4219398498535, 0.600776185303386, -95.584716796875, -1.6682680226918, 218, 42, 'PPL', 'P'),
(101764, 'Eubanks', 39.1583290100098, 0.683441770803882, -77.7699966430664, -1.35734250068645, 218, 53, 'PPL', 'P'),
(59843, 'Eubanks (historical)', 30.9541702270508, 0.540252187684837, -88.6402816772461, -1.54706476516315, 218, 30, 'PPL', 'P'),
(35804, 'Eubanks Ford', 36.6925010681152, 0.640404954430147, -86.4136123657227, -1.50820205432395, 218, 21, 'PPL', 'P'),
(161421, 'Eubuna Gardens', 40.3441696166992, 0.70413859379446, -76.783332824707, -1.34012196844578, 218, 45, 'PPL', 'P'),
(181494, 'Eucalyptus Hills', 32.8797187805176, 0.573859349849847, -116.945831298828, -2.04108980264639, 218, 6, 'PPL', 'P'),
(75789, 'Eucha', 36.3919410705566, 0.635159192872963, -94.8827819824219, -1.65601694904521, 218, 42, 'PPL', 'P'),
(86844, 'Euchee', 35.6758308410645, 0.622660711561113, -84.7169418334961, -1.47858956721503, 218, 50, 'PPL', 'P'),
(15954, 'Eucheeanna', 30.6455593109131, 0.534865911090638, -86.0449981689453, -1.50176852292059, 218, 12, 'PPL', 'P'),
(8787, 'Euclid', 34.1736106872559, 0.596442023787337, -94.0183334350586, -1.64092947567964, 218, 4, 'PPL', 'P'),
(101765, 'Euclid', 36.8402786254883, 0.642984159366861, -76.1555633544922, -1.32916532424703, 218, 53, 'PPL', 'P'),
(109117, 'Euclid', 38.7330589294434, 0.676019407687777, -81.0447235107422, -1.41449726663091, 218, 58, 'PPL', 'P'),
(115493, 'Euclid', 41.5438919067383, 0.725077697865208, -95.8605575561523, -1.67308235215239, 218, 16, 'PPL', 'P'),
(135270, 'Euclid', 47.9719390869141, 0.837268285632813, -96.6386108398438, -1.68666194370876, 218, 28, 'PPL', 'P'),
(148712, 'Euclid', 43.1863899230957, 0.753744696208121, -76.2174987792969, -1.33024630133349, 218, 40, 'PPL', 'P'),
(155201, 'Euclid', 41.5930595397949, 0.725935834947459, -81.5269393920898, -1.42291352146583, 218, 41, 'PPL', 'P'),
(161422, 'Euclid', 40.9933280944824, 0.715468546599011, -79.9291687011719, -1.39502716221745, 218, 45, 'PPL', 'P'),
(200791, 'Euclid (historical)', 44.2874984741211, 0.772962665845378, -123.940277099609, -2.16316591122231, 218, 43, 'PPL', 'P'),
(2330, 'Euclid Estates', 33.5105590820313, 0.584869590165534, -86.7452774047852, -1.51399070126934, 218, 2, 'PPL', 'P'),
(8788, 'Euclid Heights', 34.502498626709, 0.602182201200894, -93.0283279418945, -1.6236506202111, 218, 4, 'PPL', 'P'),
(46918, 'Euclid Heights', 39.3555603027344, 0.686884106249891, -76.688606262207, -1.33846867804105, 218, 25, 'PPL', 'P'),
(155202, 'Euclid Heights', 41.5044403076172, 0.724389137565368, -81.5844421386719, -1.42391713372263, 218, 41, 'PPL', 'P'),
(101766, 'Euclid Terrace', 36.8522186279297, 0.64319255172216, -76.1622161865234, -1.32928143807055, 218, 53, 'PPL', 'P'),
(59844, 'Eucutta', 31.8050003051758, 0.555101973923119, -88.8722229003906, -1.55111290317812, 218, 30, 'PPL', 'P'),
(8789, 'Eudora', 33.1094398498535, 0.577868738870961, -91.2619400024414, -1.59282133480012, 218, 4, 'PPL', 'P'),
(32396, 'Eudora', 38.9433288574219, 0.679689310248933, -95.0983276367188, -1.65977893040106, 218, 20, 'PPL', 'P'),
(54662, 'Eudora', 37.4824981689453, 0.654193004920842, -93.5374984741211, -1.63253732245259, 218, 29, 'PPL', 'P'),
(59845, 'Eudora', 34.8302803039551, 0.607903070696547, -90.149169921875, -1.57339983307656, 218, 30, 'PPL', 'P'),
(40844, 'Eudora (historical)', 31.985279083252, 0.55824843217202, -93.6677780151367, -1.63481112939129, 218, 22, 'PPL', 'P'),
(46919, 'Eudowood', 39.3988914489746, 0.687640377420446, -76.5875015258789, -1.33670406750277, 218, 25, 'PPL', 'P'),
(15955, 'Eufala (historical)', 30.5, 0.53232542185827, -85.033332824707, -1.48411163173531, 218, 12, 'PPL', 'P'),
(2331, 'Eufaula', 31.8911094665527, 0.556604862305278, -85.1455612182617, -1.48607038671706, 218, 2, 'PPL', 'P'),
(75790, 'Eufaula', 35.2872200012207, 0.615878172896899, -95.5822219848633, -1.66822448000797, 218, 42, 'PPL', 'P'),
(207360, 'Eufaula', 46.1958312988281, 0.806269356860399, -123.046669006348, -2.14756950777243, 218, 56, 'PPL', 'P'),
(193244, 'Eufaula Heights', 46.2161102294922, 0.806623290969271, -123.051666259766, -2.14765672629813, 218, 56, 'PPL', 'P'),
(64580, 'Eufola', 35.7222213745117, 0.623470379111524, -80.9861068725586, -1.41347421329816, 218, 33, 'PPL', 'P'),
(346, 'Eugene', 29.6113891601563, 0.516816236934085, -83.0880584716797, -1.45016018942038, 218, 12, 'PPL', 'P'),
(29735, 'Eugene', 39.9663887023926, 0.697545072988615, -87.4727783203125, -1.52668798755657, 218, 19, 'PPL', 'P'),
(54663, 'Eugene', 38.3527793884277, 0.669382277619081, -92.4036102294922, -1.61274723923415, 218, 29, 'PPL', 'P'),
(119563, 'Eugene', 40.8875007629395, 0.713621511224987, -90.0141677856445, -1.57104360130211, 218, 18, 'PPL', 'P'),
(130709, 'Eugene', 43.2922210693359, 0.755591798161173, -84.7069396972656, -1.47841499700557, 218, 27, 'PPL', 'P'),
(181496, 'Eugene', 37.8930587768555, 0.661358639307863, -120.845832824707, -2.10915767010578, 218, 6, 'PPL', 'P'),
(194906, 'Eugene', 46.4444389343262, 0.810608378645438, -116.551109313965, -2.03420060438052, 218, 17, 'PPL', 'P'),
(200792, 'Eugene', 44.0522193908691, 0.768856271181557, -123.085563659668, -2.14824834753429, 218, 43, 'PPL', 'P'),
(94105, 'Eugenio Saenz Colonia', 26.3579998016357, 0.460033880778556, -98.6330032348633, -1.72147065757858, 218, 51, 'PPL', 'P'),
(127451, 'Eugley Corner', 44.0666694641113, 0.769108472536788, -69.4011077880859, -1.21127783543358, 218, 26, 'PPL', 'P'),
(20944, 'Euharlee', 34.144718170166, 0.59593775423493, -84.9330596923828, -1.48236153542496, 218, 13, 'PPL', 'P'),
(8790, 'Eula', 35.9022216796875, 0.626611977091436, -92.8958282470703, -1.62133806427853, 218, 4, 'PPL', 'P'),
(94106, 'Eula', 32.3422203063965, 0.564478231751988, -99.561393737793, -1.73767412859895, 218, 51, 'PPL', 'P'),
(80907, 'Eulala', 34.0305595397949, 0.593945310265388, -81.9194412231445, -1.42976397073784, 218, 48, 'PPL', 'P'),
(2332, 'Eulaton', 33.6455612182617, 0.587225821939982, -85.9124984741211, -1.49945596698802, 218, 2, 'PPL', 'P'),
(94107, 'Euless', 32.8369407653809, 0.573112732638243, -97.081672668457, -1.69439483140796, 218, 51, 'PPL', 'P'),
(932, 'Eulia', 36.5244407653809, 0.637471748805534, -86.1727828979492, -1.50399878717547, 218, 50, 'PPL', 'P'),
(59846, 'Eulogy', 33.0336112976074, 0.576545280967246, -90.1747207641602, -1.57384577940109, 218, 30, 'PPL', 'P'),
(94108, 'Eulogy', 32.1691703796387, 0.561457940759729, -97.6554794311523, -1.70440964868721, 218, 51, 'PPL', 'P'),
(20945, 'Eulonia', 31.5330600738525, 0.550355721517893, -81.4272232055664, -1.42117314569347, 218, 13, 'PPL', 'P'),
(80903, 'Eulonia', 33.9863891601563, 0.593174391708837, -79.3836135864258, -1.38550542921403, 218, 48, 'PPL', 'P'),
(661, 'Eunice', 37.2449989318848, 0.65004786126316, -91.7794418334961, -1.60185344563713, 218, 29, 'PPL', 'P'),
(8791, 'Eunice', 34.0386085510254, 0.594085792012889, -91.9905624389648, -1.60553819532136, 218, 4, 'PPL', 'P'),
(35805, 'Eunice', 37.1830596923828, 0.64896681759767, -85.1222229003906, -1.48566305622833, 218, 21, 'PPL', 'P'),
(40845, 'Eunice', 30.4941692352295, 0.532223655815116, -92.4175033569336, -1.6129897200514, 218, 22, 'PPL', 'P'),
(59847, 'Eunice', 31.2891693115234, 0.546099024700051, -90.9744415283203, -1.58780353983225, 218, 30, 'PPL', 'P'),
(109118, 'Eunice', 37.9463882446289, 0.662289414108846, -81.5436096191406, -1.42320447181492, 218, 58, 'PPL', 'P'),
(188539, 'Eunice', 32.4372215270996, 0.566136315846671, -103.15860748291, -1.80045735234924, 218, 38, 'PPL', 'P'),
(191443, 'Eunice', 34.4705581665039, 0.601624735005713, -101.767776489258, -1.77618277217122, 218, 51, 'PPL', 'P'),
(190184, 'Eunice Place', 39.5641708374023, 0.690525046934193, -115.904441833496, -2.02291412768076, 218, 39, 'PPL', 'P'),
(2333, 'Eunola', 31.0397205352783, 0.541745322239503, -85.8475036621094, -1.4983215935217, 218, 2, 'PPL', 'P'),
(72477, 'Euphemia', 39.8541717529297, 0.695586517743943, -84.5388870239258, -1.47548192453902, 218, 41, 'PPL', 'P'),
(59848, 'Eupora', 33.5405616760254, 0.585393234214871, -89.2669372558594, -1.55800196828594, 218, 30, 'PPL', 'P'),
(64576, 'Eure', 36.4272193908691, 0.63577491571699, -76.8536071777344, -1.34134848728581, 218, 33, 'PPL', 'P'),
(2335, 'Eureka', 33.563060760498, 0.585785917317603, -86.1655578613281, -1.50387268649786, 218, 2, 'PPL', 'P'),
(15956, 'Eureka', 29.371940612793, 0.512637071393478, -81.9047164916992, -1.42950697569265, 218, 12, 'PPL', 'P'),
(20946, 'Eureka', 32.5175018310547, 0.567537471475189, -81.7155609130859, -1.42620558804733, 218, 13, 'PPL', 'P'),
(29739, 'Eureka', 38.8708305358887, 0.678423975836009, -86.5627822875977, -1.51080556060561, 218, 19, 'PPL', 'P'),
(32386, 'Eureka', 37.8238906860352, 0.66015142838573, -96.2888870239258, -1.68055811164835, 218, 20, 'PPL', 'P'),
(40846, 'Eureka', 32.5680618286133, 0.568419909902387, -92.3547210693359, -1.61189396242089, 218, 22, 'PPL', 'P'),
(54666, 'Eureka', 38.502498626709, 0.671995371280667, -90.6277770996094, -1.5817531041517, 218, 29, 'PPL', 'P'),
(59849, 'Eureka', 32.5088882446289, 0.567387136031654, -89.7858276367188, -1.56705831388886, 218, 30, 'PPL', 'P'),
(64577, 'Eureka', 35.5424995422363, 0.620333641400601, -77.8766708374023, -1.35920431660452, 218, 33, 'PPL', 'P'),
(80904, 'Eureka', 33.6938896179199, 0.588069311636237, -81.767219543457, -1.42710720123438, 218, 48, 'PPL', 'P'),
(86847, 'Eureka', 35.8411102294922, 0.625545381074859, -84.6705627441406, -1.4777800994017, 218, 50, 'PPL', 'P'),
(94113, 'Eureka', 32.5822715759277, 0.568667916778901, -99.0563278198242, -1.72885906539079, 218, 51, 'PPL', 'P'),
(101767, 'Eureka', 37.0463905334473, 0.646581490788313, -78.5530624389648, -1.37100957708462, 218, 53, 'PPL', 'P'),
(109119, 'Eureka', 39.372501373291, 0.687179783709917, -81.2811126708984, -1.41862303579166, 218, 58, 'PPL', 'P'),
(115494, 'Eureka', 40.7655601501465, 0.71149324603985, -95.8375015258789, -1.67267994851168, 218, 16, 'PPL', 'P'),
(119564, 'Eureka', 40.7213897705078, 0.710722327483299, -89.2727813720703, -1.55810396735569, 218, 18, 'PPL', 'P'),
(130710, 'Eureka', 43.1036109924316, 0.752299931316753, -84.5138931274414, -1.47504569875246, 218, 27, 'PPL', 'P'),
(155204, 'Eureka', 40.9147186279297, 0.71409655258443, -80.6797180175781, -1.40812671898733, 218, 41, 'PPL', 'P'),
(161425, 'Eureka', 40.146671295166, 0.700691597816543, -79.7366714477539, -1.39166745134426, 218, 45, 'PPL', 'P'),
(170264, 'Eureka', 45.7694396972656, 0.798827419510282, -99.6191711425781, -1.73868253454571, 218, 49, 'PPL', 'P'),
(174036, 'Eureka', 44.0044403076172, 0.768022368865226, -88.841667175293, -1.55057960516983, 218, 57, 'PPL', 'P'),
(186694, 'Eureka', 37.8797187805176, 0.661125812449563, -107.564437866211, -1.87735359882224, 218, 7, 'PPL', 'P'),
(190185, 'Eureka', 39.5127792358398, 0.689628094279054, -115.959716796875, -2.02387885778564, 218, 39, 'PPL', 'P'),
(192562, 'Eureka', 39.9541702270508, 0.697331820364327, -112.119438171387, -1.95685335157691, 218, 52, 'PPL', 'P'),
(193536, 'Eureka', 40.8022193908691, 0.712133070491742, -124.162498474121, -2.16704440587585, 218, 6, 'PPL', 'P'),
(196444, 'Eureka', 48.8800010681152, 0.853116957016956, -115.05249786377, -2.00804490036652, 218, 31, 'PPL', 'P'),
(207362, 'Eureka', 48.7630615234375, 0.851075976936546, -122.450561523438, -2.13716546949987, 218, 56, 'PPL', 'P'),
(211818, 'Eureka', 65.179443359375, 1.13759589123825, -150.214447021484, -2.62173668458749, 218, 1, 'PPL', 'P'),
(20947, 'Eureka (historical)', 33.204719543457, 0.579531683234634, -82.8333282470703, -1.4457143082966, 218, 13, 'PPL', 'P'),
(54667, 'Eureka (historical)', 38.7338905334473, 0.676033921915718, -92.3694381713867, -1.61215082430803, 218, 29, 'PPL', 'P'),
(115495, 'Eureka (historical)', 41.2205581665039, 0.71943445951533, -91.7136077880859, -1.60070442478481, 218, 16, 'PPL', 'P'),
(181497, 'Eureka (historical)', 39.6108283996582, 0.691339375016512, -120.894996643066, -2.110015740609, 218, 6, 'PPL', 'P'),
(190186, 'Eureka (historical)', 39.2005615234375, 0.684178867214589, -119.636672973633, -2.08805384952161, 218, 39, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(135273, 'Eureka Center', 44.5872192382813, 0.778193780016566, -93.2177810668945, -1.62695720102054, 218, 28, 'PPL', 'P'),
(174037, 'Eureka Center', 45.5127792358398, 0.794347849398714, -92.6513900756836, -1.61707181337028, 218, 57, 'PPL', 'P'),
(8792, 'Eureka Garden', 34.7969398498535, 0.607321169998365, -92.1822204589844, -1.60888325880856, 218, 4, 'PPL', 'P'),
(86849, 'Eureka Hills', 36.1913909912109, 0.631658933673245, -83.2633285522461, -1.4532192294065, 218, 50, 'PPL', 'P'),
(32387, 'Eureka Lake', 39.1519393920898, 0.683330250933235, -96.6388931274414, -1.68666687055677, 218, 20, 'PPL', 'P'),
(2336, 'Eureka Landing', 31.4022197723389, 0.548072127462177, -87.6975021362305, -1.53061015805198, 218, 2, 'PPL', 'P'),
(80905, 'Eureka Mill', 34.7174987792969, 0.605934661755843, -81.1938934326172, -1.41710077291257, 218, 48, 'PPL', 'P'),
(64578, 'Eureka Mills', 35.9197196960449, 0.626917375089441, -80.3708267211914, -1.40273554883463, 218, 33, 'PPL', 'P'),
(80906, 'Eureka Mills', 34.7180595397949, 0.605944448872849, -81.1972198486328, -1.41715882982433, 218, 48, 'PPL', 'P'),
(101768, 'Eureka Park', 36.8397216796875, 0.642974438828883, -76.0611114501953, -1.32751682753227, 218, 53, 'PPL', 'P'),
(130711, 'Eureka Place', 43.1863899230957, 0.753744696208121, -85.2030563354492, -1.4870738658158, 218, 27, 'PPL', 'P'),
(211819, 'Eureka Roadhouse', 61.9386100769043, 1.08103267995092, -147.168060302734, -2.56856720605628, 218, 1, 'PPL', 'P'),
(8793, 'Eureka Springs', 36.4011116027832, 0.635319248854477, -93.7377777099609, -1.63603285454137, 218, 4, 'PPL', 'P'),
(59850, 'Eureka Springs', 34.2436103820801, 0.597663748937411, -89.8644409179688, -1.56843037448247, 218, 30, 'PPL', 'P'),
(20948, 'Eureka Springs (historical)', 32.6069412231445, 0.569098483348139, -81.517219543457, -1.42274387810439, 218, 13, 'PPL', 'P'),
(86850, 'Eurekaton', 35.4327812194824, 0.61841869541878, -89.2191696166992, -1.55716826570669, 218, 50, 'PPL', 'P'),
(174039, 'Euren', 44.6183280944824, 0.778736731983806, -87.6022186279297, -1.52894714710928, 218, 57, 'PPL', 'P'),
(54668, 'Europa', 36.0900001525879, 0.629889329707915, -90.1774978637695, -1.57389424893293, 218, 29, 'PPL', 'P'),
(94114, 'Eustace', 32.3069381713867, 0.563862442328934, -96.0063934326172, -1.67562766836423, 218, 51, 'PPL', 'P'),
(101769, 'Eustaces Corner', 38.6175003051758, 0.674002529215232, -77.7011108398438, -1.35614021661233, 218, 53, 'PPL', 'P'),
(101770, 'Eustacestown', 38.6061096191406, 0.673803724239858, -77.6813888549805, -1.35579600304144, 218, 53, 'PPL', 'P'),
(15957, 'Eustis', 28.8525009155273, 0.503571138410631, -81.6855621337891, -1.42568201057702, 218, 12, 'PPL', 'P'),
(127452, 'Eustis', 45.2172203063965, 0.789189372946258, -70.478889465332, -1.23008867431919, 218, 26, 'PPL', 'P'),
(130713, 'Eustis', 45.7586097717285, 0.798638401651913, -87.3352813720703, -1.5242882130983, 218, 27, 'PPL', 'P'),
(196445, 'Eustis', 45.9897193908691, 0.802672025438948, -111.465827941895, -1.94544570104755, 218, 31, 'PPL', 'P'),
(199307, 'Eustis', 40.6624984741211, 0.709694480460583, -100.029167175293, -1.7458383152367, 218, 35, 'PPL', 'P'),
(72475, 'Eustis (historical)', 39.3711090087891, 0.68715548236497, -82.9744415283203, -1.44817719967271, 218, 41, 'PPL', 'P'),
(200793, 'Eustis (historical)', 45.7430610656738, 0.798367025536834, -117.665283203125, -2.05364660718611, 218, 43, 'PPL', 'P'),
(2338, 'Eutaw', 32.8405609130859, 0.573175916135105, -87.8874969482422, -1.53392619308329, 218, 2, 'PPL', 'P'),
(59851, 'Eutaw', 33.6586112976074, 0.587453588792211, -91.1505584716797, -1.59087736036242, 218, 30, 'PPL', 'P'),
(46920, 'Eutaw Forest', 38.6277809143066, 0.674181959693676, -77.0263900756836, -1.34436411774616, 218, 25, 'PPL', 'P'),
(59852, 'Eutaw Landing', 33.651668548584, 0.587332414962612, -91.1699981689453, -1.5912166470853, 218, 30, 'PPL', 'P'),
(80911, 'Eutaw Springs', 33.4066696166992, 0.583056376937353, -80.3011093139648, -1.40151875053257, 218, 48, 'PPL', 'P'),
(80908, 'Eutawville', 33.3944396972656, 0.582842924575984, -80.3475036621094, -1.40232848466201, 218, 48, 'PPL', 'P'),
(35806, 'Euterpe', 37.7150001525879, 0.658250930052822, -87.4433288574219, -1.52617399746618, 218, 21, 'PPL', 'P'),
(20949, 'Euthtilloga (historical)', 34.5833282470703, 0.603592944209336, -85.3661117553711, -1.48991971975666, 218, 13, 'PPL', 'P'),
(2339, 'Eva', 34.332218170166, 0.59921024658242, -86.7588882446289, -1.51422825523858, 218, 2, 'PPL', 'P'),
(40847, 'Eva', 31.4288902282715, 0.54853761473121, -91.7874984741211, -1.60199406054268, 218, 22, 'PPL', 'P'),
(86851, 'Eva', 36.0644416809082, 0.629443250225326, -88.0041732788086, -1.53596257921082, 218, 50, 'PPL', 'P'),
(109120, 'Eva', 39.0330581665039, 0.681255382127954, -81.0283279418945, -1.41421110997178, 218, 58, 'PPL', 'P'),
(112258, 'Eva', 28.3261108398438, 0.49438389844013, -81.833610534668, -1.42826594262467, 218, 12, 'PPL', 'P'),
(190970, 'Eva', 36.7983283996582, 0.642251989804171, -101.906387329102, -1.77860198770545, 218, 42, 'PPL', 'P'),
(86852, 'Eva Subdivision', 36.0591697692871, 0.629351238009664, -88.0133285522461, -1.53612236887623, 218, 50, 'PPL', 'P'),
(8794, 'Evadale', 35.5511093139648, 0.620483910265109, -90.1061096191406, -1.57264828901694, 218, 4, 'PPL', 'P'),
(94115, 'Evadale', 30.3547191619873, 0.529789792894892, -94.0725021362305, -1.64187489786662, 218, 51, 'PPL', 'P'),
(207363, 'Evaline', 46.5397186279297, 0.812271323009111, -122.936943054199, -2.14565442863255, 218, 56, 'PPL', 'P'),
(135275, 'Evan', 44.3541717529297, 0.774126334083688, -94.8411102294922, -1.65528963975151, 218, 28, 'PPL', 'P'),
(109121, 'Evandale Terrace', 39.2577781677246, 0.685177486044341, -81.6130599975586, -1.42441660958507, 218, 58, 'PPL', 'P'),
(115498, 'Evander', 43.1786117553711, 0.753608941571554, -95.7622222900391, -1.67136607798789, 218, 16, 'PPL', 'P'),
(40848, 'Evangeline', 30.2622203826904, 0.528175384642086, -92.570556640625, -1.61566100378281, 218, 22, 'PPL', 'P'),
(94116, 'Evangeline Gardens Colonia', 26.3320007324219, 0.45958011141832, -98.1309967041016, -1.71270899075028, 218, 51, 'PPL', 'P'),
(40849, 'Evangeline Hermitage Estates', 30.3500003814697, 0.529707434638182, -91.1286087036133, -1.59049426463961, 218, 22, 'PPL', 'P'),
(188537, 'Evanola', 34.415828704834, 0.600669525701729, -104.493606567383, -1.8237574818844, 218, 38, 'PPL', 'P'),
(15, 'Evans', 32.9411087036133, 0.574930806135413, -94.2525024414063, -1.64501649584653, 218, 51, 'PPL', 'P'),
(20950, 'Evans', 33.5336112976074, 0.585271927227218, -82.1308288574219, -1.43345338095398, 218, 13, 'PPL', 'P'),
(40851, 'Evans', 30.9888896942139, 0.540858156701371, -93.5019378662109, -1.63191667276054, 218, 22, 'PPL', 'P'),
(54669, 'Evans', 36.8958282470703, 0.643953683161705, -92.440559387207, -1.61339212369211, 218, 29, 'PPL', 'P'),
(59853, 'Evans', 32.8530616760254, 0.57339409560741, -90.1747207641602, -1.57384577940109, 218, 30, 'PPL', 'P'),
(78245, 'Evans', 39.9077796936035, 0.696522152813915, -79.6883316040039, -1.39082376191092, 218, 45, 'PPL', 'P'),
(80909, 'Evans', 34.6697196960449, 0.605100759439512, -81.1908264160156, -1.41704724337466, 218, 48, 'PPL', 'P'),
(109122, 'Evans', 38.8202781677246, 0.677541670566866, -81.7797164916992, -1.42732531412766, 218, 58, 'PPL', 'P'),
(115499, 'Evans', 41.3027801513672, 0.720869503868719, -92.726936340332, -1.61839034442598, 218, 16, 'PPL', 'P'),
(119566, 'Evans', 40.2216682434082, 0.702000541492317, -89.3638916015625, -1.55969414084257, 218, 18, 'PPL', 'P'),
(130715, 'Evans', 43.1952781677246, 0.753899825341618, -85.4552764892578, -1.49147593793965, 218, 27, 'PPL', 'P'),
(194177, 'Evans', 40.3763885498047, 0.70470092025863, -104.691673278809, -1.82721439813738, 218, 7, 'PPL', 'P'),
(196446, 'Evans', 47.1736106872559, 0.8233348265466, -111.091667175293, -1.93891536373857, 218, 31, 'PPL', 'P'),
(200794, 'Evans', 45.5016708374023, 0.794153971271356, -117.421669006348, -2.04939473734775, 218, 43, 'PPL', 'P'),
(203903, 'Evans', 41.6236114501953, 0.72646906637672, -112.176109313965, -1.95784244960576, 218, 52, 'PPL', 'P'),
(207364, 'Evans', 48.7136116027832, 0.850212913006279, -118.024169921875, -2.05991036206998, 218, 56, 'PPL', 'P'),
(80910, 'Evans Acres', 34.9047203063965, 0.609202293834343, -81.9561080932617, -1.43040392834779, 218, 48, 'PPL', 'P'),
(148713, 'Evans Center', 42.6580581665039, 0.744523567512749, -79.0350036621094, -1.37942103822958, 218, 40, 'PPL', 'P'),
(161427, 'Evans City', 40.7691688537598, 0.711556229799631, -80.0630569458008, -1.39736395291594, 218, 45, 'PPL', 'P'),
(70798, 'Evans Corner', 39.878059387207, 0.696003435612595, -74.9036102294922, -1.30731462013514, 218, 37, 'PPL', 'P'),
(127454, 'Evans Corner', 44.4905586242676, 0.776506734045028, -69.1002807617188, -1.20602741334449, 218, 26, 'PPL', 'P'),
(148714, 'Evans Corner', 43.0222206115723, 0.750879401191304, -76.7699966430664, -1.3398892081665, 218, 40, 'PPL', 'P'),
(80912, 'Evans Crossroads', 33.9638900756836, 0.592781708606105, -79.5144424438477, -1.38778882353267, 218, 48, 'PPL', 'P'),
(8795, 'Evans Estates', 34.9813919067383, 0.61054046570308, -92.070556640625, -1.60693435752284, 218, 4, 'PPL', 'P'),
(161429, 'Evans Falls', 41.4658317565918, 0.723715291230551, -76.0183334350586, -1.32677021032066, 218, 45, 'PPL', 'P'),
(35807, 'Evans Ford', 37.2311096191406, 0.649805447024936, -84.9855575561523, -1.483277795998, 218, 21, 'PPL', 'P'),
(119567, 'Evans Heights Housing Project', 41.1361083984375, 0.717960533010026, -88.8152770996094, -1.5501190114593, 218, 18, 'PPL', 'P'),
(46921, 'Evans Hill', 39.0238914489746, 0.681095392725468, -76.5497207641602, -1.33604466881686, 218, 25, 'PPL', 'P'),
(101771, 'Evans Hill', 37.2944412231445, 0.650910792035373, -80.0436096191406, -1.39702453303501, 218, 53, 'PPL', 'P'),
(29740, 'Evans Landing', 38.0041694641113, 0.663297886634632, -85.9847183227539, -1.50071644113195, 218, 19, 'PPL', 'P'),
(193147, 'Evans Landing', 48.0755615234375, 0.839076838329085, -116.530563354492, -2.03384200973974, 218, 17, 'PPL', 'P'),
(78222, 'Evans Manor', 39.9197196960449, 0.696730545169214, -79.682502746582, -1.39072202915728, 218, 45, 'PPL', 'P'),
(20952, 'Evans Mill', 33.5349998474121, 0.585296161993137, -82.1224975585938, -1.43330797235847, 218, 13, 'PPL', 'P'),
(80913, 'Evans Mill', 34.7266693115234, 0.606094717737356, -80.3502807617188, -1.40237695419385, 218, 48, 'PPL', 'P'),
(148716, 'Evans Mills', 44.0880584716797, 0.76948178114259, -75.807502746582, -1.3230905206425, 218, 40, 'PPL', 'P'),
(20953, 'Evans Park', 33.5658302307129, 0.585834253691388, -84.4263916015625, -1.47351850902535, 218, 13, 'PPL', 'P'),
(64582, 'Evans Park', 35.5897216796875, 0.621157823178954, -77.3855590820313, -1.35063279947805, 218, 33, 'PPL', 'P'),
(13728, 'Evans Park Mobile Home Park', 38.5344390869141, 0.672552837475848, -75.2819366455078, -1.31391766174189, 218, 10, 'PPL', 'P'),
(15958, 'Evans Pines', 27.9291706085205, 0.487455984469911, -80.4930572509766, -1.40486887402584, 218, 12, 'PPL', 'P'),
(193537, 'Evans Place', 41.060001373291, 0.716632214837322, -120.228607177734, -2.09838505033835, 218, 6, 'PPL', 'P'),
(15959, 'Evans Subdivision', 28.7763900756836, 0.502242753658899, -81.2683334350586, -1.41839999605037, 218, 12, 'PPL', 'P'),
(64583, 'Evans Trailer Park', 35.5550003051758, 0.620551820872906, -77.370002746582, -1.35036129020491, 218, 33, 'PPL', 'P'),
(2340, 'Evansboro', 31.8836097717285, 0.5564739679377, -88.4680633544922, -1.54405898839883, 218, 2, 'PPL', 'P'),
(161430, 'Evansburg', 40.1808280944824, 0.701287746426557, -75.429443359375, -1.31649213956767, 218, 45, 'PPL', 'P'),
(15960, 'Evansdale', 28.7480602264404, 0.501748304513012, -81.3194427490234, -1.41929202185749, 218, 12, 'PPL', 'P'),
(64584, 'Evansdale', 35.6549987792969, 0.622297123493289, -77.870002746582, -1.35908793646488, 218, 33, 'PPL', 'P'),
(101772, 'Evansdale', 38.6349983215332, 0.674307927213237, -77.3430633544922, -1.34989110911446, 218, 53, 'PPL', 'P'),
(109124, 'Evansdale', 39.649169921875, 0.692008560819422, -79.9644393920898, -1.39564275190342, 218, 58, 'PPL', 'P'),
(115500, 'Evansdale', 42.4691696166992, 0.74122684039934, -92.2808303833008, -1.61060432666302, 218, 16, 'PPL', 'P'),
(155205, 'Evansport', 41.4261093139648, 0.723022003819776, -84.3963928222656, -1.47299493155504, 218, 41, 'PPL', 'P'),
(20954, 'Evanston', 33.5250015258789, 0.58512165836271, -82.1497192382813, -1.43378308029694, 218, 13, 'PPL', 'P'),
(29741, 'Evanston', 38.0394401550293, 0.663913476320603, -86.841667175293, -1.51567302012995, 218, 19, 'PPL', 'P'),
(35816, 'Evanston', 37.5419387817383, 0.655230439323482, -83.0316696166992, -1.44917601823954, 218, 21, 'PPL', 'P'),
(59854, 'Evanston', 30.9072208404541, 0.539432766306933, -88.563606262207, -1.54572652671538, 218, 30, 'PPL', 'P'),
(72484, 'Evanston', 39.1444396972656, 0.683199356565658, -84.4694366455078, -1.47426978676887, 218, 41, 'PPL', 'P'),
(86858, 'Evanston', 36.5074996948242, 0.637176071345508, -83.2872161865234, -1.45363614727515, 218, 50, 'PPL', 'P'),
(115501, 'Evanston', 42.4341697692871, 0.740615977824303, -94.057502746582, -1.64161310913147, 218, 16, 'PPL', 'P'),
(119569, 'Evanston', 42.0411109924316, 0.733755808014313, -87.6900024414063, -1.53047926368441, 218, 18, 'PPL', 'P'),
(194178, 'Evanston', 40.1069412231445, 0.699998177247714, -104.938056945801, -1.83151460434953, 218, 7, 'PPL', 'P'),
(209444, 'Evanston', 41.2683296203613, 0.720268228673607, -110.962501525879, -1.93666099787582, 218, 59, 'PPL', 'P'),
(86853, 'Evanston (historical)', 35.8180618286133, 0.625143110592203, -85.8736114501953, -1.49877726038421, 218, 50, 'PPL', 'P'),
(161431, 'Evanstown', 40.264720916748, 0.702751952393883, -79.6894378662109, -1.39084306982883, 218, 45, 'PPL', 'P'),
(2341, 'Evansville', 32.8380584716797, 0.573132240293228, -87.7525024414063, -1.5315700944669, 218, 2, 'PPL', 'P'),
(8796, 'Evansville', 35.795280456543, 0.624745500641454, -94.4966735839844, -1.64927808622288, 218, 4, 'PPL', 'P'),
(20955, 'Evansville', 33.0661087036133, 0.577112467700406, -85.2241668701172, -1.48744231415262, 218, 13, 'PPL', 'P'),
(27116, 'Evansville', 38.0902786254883, 0.664800775016791, -89.9383316040039, -1.56972001024034, 218, 18, 'PPL', 'P'),
(29742, 'Evansville', 37.9747200012207, 0.662783896544246, -87.5558319091797, -1.5281375461379, 218, 19, 'PPL', 'P'),
(54673, 'Evansville', 39.4497184753418, 0.688527476379552, -92.3022232055664, -1.61097770184785, 218, 29, 'PPL', 'P'),
(59856, 'Evansville', 34.6402816772461, 0.604586969086208, -90.3886108398438, -1.57757886545911, 218, 30, 'PPL', 'P'),
(86854, 'Evansville', 36.0341682434082, 0.628914879065055, -89.4216690063477, -1.56070254678933, 218, 50, 'PPL', 'P'),
(109125, 'Evansville', 39.3330612182617, 0.686491423147159, -79.8688888549805, -1.39397508042881, 218, 58, 'PPL', 'P'),
(135277, 'Evansville', 46.0041694641113, 0.802924226794178, -95.682502746582, -1.66997470947637, 218, 28, 'PPL', 'P'),
(155206, 'Evansville', 41.1558303833008, 0.718304746580919, -80.7630615234375, -1.40958133757473, 218, 41, 'PPL', 'P'),
(161433, 'Evansville', 41.0730590820313, 0.716860114847605, -76.295280456543, -1.33160384769916, 218, 45, 'PPL', 'P'),
(172000, 'Evansville', 44.8030586242676, 0.78196088795751, -72.1308288574219, -1.25892045575455, 218, 55, 'PPL', 'P'),
(174040, 'Evansville', 42.7802810668945, 0.746656759545902, -89.2991714477539, -1.55856456106622, 218, 57, 'PPL', 'P'),
(186695, 'Evansville', 37.6711082458496, 0.657484871765261, -106.318328857422, -1.85560489378011, 218, 7, 'PPL', 'P'),
(207365, 'Evansville', 47.4813919067383, 0.828706622202371, -122.331672668457, -2.13509046753653, 218, 56, 'PPL', 'P'),
(209445, 'Evansville', 42.8600006103516, 0.748048128057414, -106.267776489258, -1.85472258851097, 218, 59, 'PPL', 'P'),
(211820, 'Evansville', 66.9227828979492, 1.16802290616657, -151.508056640625, -2.64431443167697, 218, 1, 'PPL', 'P'),
(200795, 'Evansville (historical)', 44.5238914489746, 0.777088501585156, -122.899719238281, -2.14500475048463, 218, 43, 'PPL', 'P'),
(119571, 'Evanswood', 41.9302787780762, 0.731821420956534, -88.3724975585938, -1.54239105060811, 218, 18, 'PPL', 'P'),
(174042, 'Evanswood', 44.2897186279297, 0.773001414839238, -88.9313888549805, -1.5521455438908, 218, 57, 'PPL', 'P'),
(94117, 'Evant', 31.476110458374, 0.549361763220048, -98.1516723632813, -1.71306984907798, 218, 51, 'PPL', 'P'),
(196447, 'Evaro', 47.0322189331055, 0.820867074901505, -114.090560913086, -1.9912559333805, 218, 31, 'PPL', 'P'),
(130716, 'Evart', 43.9005584716797, 0.7662092887951, -85.258056640625, -1.48803380223072, 218, 27, 'PPL', 'P'),
(40852, 'Evart (historical)', 30.4936103820801, 0.532213901987623, -93.3000030517578, -1.62839224537393, 218, 22, 'PPL', 'P'),
(35808, 'Evarts', 36.8658294677734, 0.643430105691395, -83.190559387207, -1.45194916788264, 218, 21, 'PPL', 'P'),
(119572, 'Evarts', 42.253059387207, 0.73745500534746, -89.4744415283203, -1.56162360105234, 218, 18, 'PPL', 'P'),
(35809, 'Eve', 37.3111114501953, 0.651201742384464, -85.6786117553711, -1.49537387366914, 218, 21, 'PPL', 'P'),
(54674, 'Eve', 37.8397216796875, 0.660427731348826, -94.5833282470703, -1.65079049540593, 218, 29, 'PPL', 'P'),
(86855, 'Eve Mills', 35.6438903808594, 0.622103245365932, -84.3125, -1.47153072558772, 218, 50, 'PPL', 'P'),
(115502, 'Eveland', 41.1697196960449, 0.718547160819143, -92.8005599975586, -1.61967531965194, 218, 16, 'PPL', 'P'),
(35810, 'Eveleigh', 37.5875015258789, 0.65602565922498, -86.3274993896484, -1.50669909936276, 218, 21, 'PPL', 'P'),
(135280, 'Eveleth', 47.4625015258789, 0.82837692285942, -92.5397186279297, -1.6151227789265, 218, 28, 'PPL', 'P'),
(20956, 'Evelyn', 31.3147201538086, 0.546544971024585, -81.4716720581055, -1.42194892451901, 218, 13, 'PPL', 'P'),
(35811, 'Evelyn', 37.6122207641602, 0.656457091321572, -83.857780456543, -1.46359437238123, 218, 21, 'PPL', 'P'),
(40853, 'Evelyn', 31.9877796173096, 0.558292074724384, -93.4430618286133, -1.63088909205394, 218, 22, 'PPL', 'P'),
(94118, 'Evelyn', 32.3069381713867, 0.563862442328934, -95.5325012207031, -1.66735668896677, 218, 51, 'PPL', 'P'),
(130720, 'Evelyn', 46.3669395446777, 0.809255759127787, -86.5341720581055, -1.51030621790122, 218, 27, 'PPL', 'P'),
(181498, 'Evelyn', 36.146671295166, 0.63087842773677, -116.315277099609, -2.03008455575774, 218, 6, 'PPL', 'P'),
(109126, 'Evelyn (historical)', 38.9383316040039, 0.679602091723233, -81.3444366455078, -1.41972824764404, 218, 58, 'PPL', 'P'),
(46922, 'Evemar Mobile Home Park', 39.1338882446289, 0.683015198976279, -76.8349990844727, -1.34102371479088, 218, 25, 'PPL', 'P'),
(72479, 'Evendale', 39.2561111450195, 0.685148391009432, -84.4180603027344, -1.47337310042984, 218, 41, 'PPL', 'P'),
(161434, 'Evendale', 40.6730613708496, 0.709878837787044, -77.1744384765625, -1.34694804979381, 218, 45, 'PPL', 'P'),
(8799, 'Evening Shade', 36.0716705322266, 0.629569417481969, -91.6191711425781, -1.59905619438616, 218, 4, 'PPL', 'P'),
(54675, 'Evening Shade', 37.5755615234375, 0.655817266869681, -92.1413879394531, -1.60817059690085, 218, 29, 'PPL', 'P'),
(75795, 'Evening Shade', 35.624439239502, 0.621763758905974, -94.9283294677734, -1.6568119026306, 218, 42, 'PPL', 'P'),
(8802, 'Evening Star', 36.0288887023926, 0.628822733691338, -92.5458297729492, -1.61522943852816, 218, 4, 'PPL', 'P'),
(86856, 'Evensville', 35.5644416809082, 0.620716603965355, -84.954719543457, -1.4827395711417, 218, 50, 'PPL', 'P'),
(109127, 'Evenwood', 38.8955612182617, 0.678855607669684, -79.6486129760742, -1.39013054107917, 218, 58, 'PPL', 'P'),
(35812, 'Ever', 37.8486099243164, 0.660582860482323, -83.0519409179688, -1.44952981919036, 218, 21, 'PPL', 'P'),
(46923, 'Everbreeze', 39.663890838623, 0.692265489285587, -75.8677825927734, -1.32414260243114, 218, 25, 'PPL', 'P'),
(161463, 'Everbreeze Plateau', 40.5247192382813, 0.707289779154296, -75.0791702270508, -1.31037872012733, 218, 45, 'PPL', 'P'),
(135282, 'Everdell', 46.2675018310547, 0.80752024362441, -96.4077835083008, -1.68263324676974, 218, 28, 'PPL', 'P'),
(32397, 'Everest', 39.6772193908691, 0.692498116406805, -95.4244384765625, -1.66547063828278, 218, 20, 'PPL', 'P'),
(139989, 'Everest', 46.8597183227539, 0.817856371289171, -97.220832824707, -1.69682363432212, 218, 34, 'PPL', 'P'),
(101773, 'Everets', 36.839168548584, 0.642964784869931, -76.6258316040039, -1.3373730535686, 218, 53, 'PPL', 'P'),
(20958, 'Everett', 30.7038898468018, 0.535883970996348, -83.804443359375, -1.46266346442219, 218, 13, 'PPL', 'P'),
(35813, 'Everett', 36.9363899230957, 0.644661617958475, -87.0541687011719, -1.51938187142204, 218, 21, 'PPL', 'P'),
(54676, 'Everett', 38.5044403076172, 0.672029260005538, -94.4269409179688, -1.64806102160471, 218, 29, 'PPL', 'P'),
(59857, 'Everett', 32.0275001525879, 0.558985328845645, -89.8222198486328, -1.56769347780885, 218, 30, 'PPL', 'P'),
(109128, 'Everett', 39.4880599975586, 0.689196662182461, -81.0347213745117, -1.41432269642145, 218, 58, 'PPL', 'P'),
(124798, 'Everett', 42.4083290100098, 0.740164971493698, -71.0541687011719, -1.24012919110295, 218, 23, 'PPL', 'P'),
(145183, 'Everett', 40.3541717529297, 0.704313164003915, -74.1469421386719, -1.29410827060555, 218, 37, 'PPL', 'P'),
(155207, 'Everett', 41.2044410705566, 0.719153163125191, -81.5725021362305, -1.42370874136733, 218, 41, 'PPL', 'P'),
(161435, 'Everett', 40.0113906860352, 0.698330505773106, -78.3736114501953, -1.36787756648464, 218, 45, 'PPL', 'P'),
(186696, 'Everett', 39.0677795410156, 0.681861384434002, -106.501388549805, -1.85879988813988, 218, 7, 'PPL', 'P'),
(191444, 'Everett', 35.2255592346191, 0.614801989500398, -102.32861328125, -1.78597122075781, 218, 51, 'PPL', 'P'),
(207366, 'Everett', 47.9791717529297, 0.837394519468482, -122.200828552246, -2.13280680690179, 218, 56, 'PPL', 'P'),
(8803, 'Everett (historical)', 35.6800003051758, 0.622733482437899, -92.0824966430664, -1.60714274987813, 218, 4, 'PPL', 'P'),
(40854, 'Everett (historical)', 31.2986106872559, 0.5462638077925, -93.3666687011719, -1.62955578045419, 218, 22, 'PPL', 'P'),
(54677, 'Everett (historical)', 39.0622215270996, 0.681764378791296, -92.4658279418945, -1.61383314316863, 218, 29, 'PPL', 'P'),
(143812, 'Everett (historical)', 43.0844383239746, 0.751965305125784, -71.6580581665039, -1.2506690505911, 218, 36, 'PPL', 'P'),
(207367, 'Everett Junction', 47.9691696166992, 0.837219949259028, -122.225830078125, -2.1332431658464, 218, 56, 'PPL', 'P'),
(20959, 'Everett Springs', 34.4947204589844, 0.602046446564327, -85.1138916015625, -1.48551764763282, 218, 13, 'PPL', 'P'),
(64585, 'Everetts', 35.8347206115723, 0.625433861204212, -77.1738891601563, -1.34693846241389, 218, 33, 'PPL', 'P'),
(80915, 'Everetts (historical)', 34.672779083252, 0.605154155819368, -79.7888870239258, -1.39257878506928, 218, 48, 'PPL', 'P'),
(13729, 'Everetts Corner', 39.2005615234375, 0.684178867214589, -75.7463912963867, -1.32202392462592, 218, 10, 'PPL', 'P'),
(64586, 'Everetts Crossroads', 35.5227813720703, 0.619989494408736, -76.8424987792969, -1.34115460915845, 218, 33, 'PPL', 'P'),
(64587, 'Everetts Mill', 34.8141708374023, 0.607621907464462, -79.892219543457, -1.39438227775949, 218, 33, 'PPL', 'P'),
(101774, 'Everettsville', 38.0133285522461, 0.663457742879064, -78.3747177124023, -1.36789687440254, 218, 53, 'PPL', 'P'),
(109129, 'Everettville', 39.5636100769043, 0.690515259817187, -80.0633316040039, -1.3973687466059, 218, 58, 'PPL', 'P'),
(2342, 'Everglade', 32.9977798461914, 0.575919904164268, -85.6552810668945, -1.49496667633847, 218, 2, 'PPL', 'P'),
(181499, 'Everglade', 38.9824981689453, 0.680372943700756, -121.766387939453, -2.12522438780417, 218, 6, 'PPL', 'P'),
(15961, 'Everglades City', 25.8597202301025, 0.451337261659875, -81.3805618286133, -1.42035875103212, 218, 12, 'PPL', 'P'),
(2344, 'Evergreen', 31.4333305358887, 0.548615112718931, -86.9569396972656, -1.51768490517545, 218, 2, 'PPL', 'P'),
(15984, 'Evergreen', 30.7000007629395, 0.535816093678065, -81.7522201538086, -1.42684541249923, 218, 12, 'PPL', 'P'),
(20960, 'Evergreen', 33.7277793884277, 0.588660799714343, -84.7391662597656, -1.4789774566278, 218, 13, 'PPL', 'P'),
(35815, 'Evergreen', 38.0627784729004, 0.664320806809331, -82.6866683959961, -1.44315461101487, 218, 21, 'PPL', 'P'),
(40863, 'Evergreen', 30.9524993896484, 0.5402230260709, -92.1086120605469, -1.6075985498987, 218, 22, 'PPL', 'P'),
(46925, 'Evergreen', 39.3450012207031, 0.686699815502458, -76.6277770996094, -1.33740700887249, 218, 25, 'PPL', 'P'),
(54679, 'Evergreen', 37.5430603027344, 0.655250013557494, -92.5966720581055, -1.61611680380337, 218, 29, 'PPL', 'P'),
(59860, 'Evergreen', 33.1811103820801, 0.579119625634971, -89.0069427490234, -1.55346420810455, 218, 30, 'PPL', 'P'),
(64589, 'Evergreen', 34.4080581665039, 0.600533904223216, -78.9019393920898, -1.37709862860098, 218, 33, 'PPL', 'P'),
(72481, 'Evergreen', 38.8911094665527, 0.678777909944881, -82.2738876342773, -1.43595022763399, 218, 41, 'PPL', 'P'),
(80917, 'Evergreen', 34.0683288574219, 0.594604509214209, -79.6791687011719, -1.39066383908746, 218, 48, 'PPL', 'P'),
(86860, 'Evergreen', 36.1777801513672, 0.63142137970401, -82.021110534668, -1.43153843497216, 218, 50, 'PPL', 'P'),
(94120, 'Evergreen', 30.5608291625977, 0.533387091026831, -95.2383270263672, -1.66222238070121, 218, 51, 'PPL', 'P'),
(101775, 'Evergreen', 37.3183288574219, 0.651327709904025, -78.76611328125, -1.37472801575665, 218, 53, 'PPL', 'P'),
(109130, 'Evergreen', 38.8541717529297, 0.678133225224, -80.2583312988281, -1.40077213332097, 218, 58, 'PPL', 'P'),
(135284, 'Evergreen', 46.7599983215332, 0.816115928937777, -95.4505615234375, -1.6659265714614, 218, 28, 'PPL', 'P'),
(161437, 'Evergreen', 41.6199989318848, 0.726406016037912, -76.414436340332, -1.3336835101944, 218, 45, 'PPL', 'P'),
(174043, 'Evergreen', 44.8424987792969, 0.782649248520269, -89.6374969482422, -1.5644694549932, 218, 57, 'PPL', 'P'),
(181500, 'Evergreen', 37.3097190856934, 0.651177441039517, -121.782501220703, -2.12550561761528, 218, 6, 'PPL', 'P'),
(186697, 'Evergreen', 39.6333312988281, 0.691732124698271, -105.316673278809, -1.83812270596234, 218, 7, 'PPL', 'P'),
(194907, 'Evergreen', 44.8902816772461, 0.783483217415627, -116.389167785645, -2.03137419151561, 218, 17, 'PPL', 'P'),
(196448, 'Evergreen', 48.225830078125, 0.841699519370596, -114.275283813477, -1.99447995619615, 218, 31, 'PPL', 'P'),
(207369, 'Evergreen', 47.7355613708496, 0.833142716209144, -122.335563659668, -2.13515837814433, 218, 56, 'PPL', 'P'),
(59861, 'Evergreen (historical)', 32.4249992370605, 0.565922996643356, -88.9388885498047, -1.55227643825838, 218, 30, 'PPL', 'P'),
(181501, 'Evergreen (historical)', 33.9686088562012, 0.592864066862815, -118.046669006348, -2.06030304517271, 218, 6, 'PPL', 'P'),
(13731, 'Evergreen Acres', 38.9055595397949, 0.679030111300111, -75.4480590820313, -1.31681704522066, 218, 10, 'PPL', 'P'),
(80918, 'Evergreen Acres', 34.728328704834, 0.606123679614211, -80.7027816772461, -1.4085292557861, 218, 48, 'PPL', 'P'),
(130722, 'Evergreen Acres', 41.9072189331055, 0.731418950736796, -83.4311065673828, -1.45614750818309, 218, 27, 'PPL', 'P'),
(130723, 'Evergreen Beach', 45.4936103820801, 0.794013289786773, -83.9786071777344, -1.46570319649041, 218, 27, 'PPL', 'P'),
(94121, 'Evergreen Colonia', 26.4249992370605, 0.461203241523696, -99.0240020751953, -1.72829487471386, 218, 51, 'PPL', 'P'),
(196449, 'Evergreen Court', 46.6444396972656, 0.814099050465232, -112.019439697266, -1.95510804895653, 218, 31, 'PPL', 'P'),
(46926, 'Evergreen Estates', 39.0705604553223, 0.681909920544868, -76.5638885498047, -1.33629194332408, 218, 25, 'PPL', 'P'),
(181502, 'Evergreen Estates', 39.2436103820801, 0.684930211537127, -121.044166564941, -2.11261924689066, 218, 6, 'PPL', 'P'),
(199308, 'Evergreen Estates Mobile Homes', 41.8236083984375, 0.729959671617487, -103.644996643066, -1.80894644463998, 218, 35, 'PPL', 'P'),
(13732, 'Evergreen Farms', 39.4541702270508, 0.688605174104355, -75.6694412231445, -1.3206808924882, 218, 10, 'PPL', 'P'),
(101777, 'Evergreen Farms', 38.8822212219238, 0.678622780811384, -77.6686096191406, -1.35557296330014, 218, 53, 'PPL', 'P'),
(20971, 'Evergreen Heights', 34.2380599975586, 0.597566876452759, -83.8047180175781, -1.46266825811215, 218, 13, 'PPL', 'P'),
(46927, 'Evergreen Heights', 39.5077781677246, 0.689540809174327, -76.3338928222656, -1.332277760613, 218, 25, 'PPL', 'P'),
(40857, 'Evergreen Hills', 30.5041694641113, 0.532398192735057, -90.9997177124023, -1.58824469246682, 218, 22, 'PPL', 'P'),
(46928, 'Evergreen Hills', 39.5397186279297, 0.690098275369508, -76.8986129760742, -1.34213398664933, 218, 25, 'PPL', 'P'),
(80919, 'Evergreen Hills', 34.5194396972656, 0.60247787866092, -82.686393737793, -1.44314981732491, 218, 48, 'PPL', 'P'),
(101778, 'Evergreen Hills', 36.6530609130859, 0.639716593867389, -82.0758285522461, -1.43249344453907, 218, 53, 'PPL', 'P'),
(109131, 'Evergreen Hills', 38.8650016784668, 0.678322243082368, -81.8469390869141, -1.42849856974589, 218, 58, 'PPL', 'P'),
(188538, 'Evergreen Hills Subdivision', 35.2299995422363, 0.614879487488119, -106.486938476563, -1.85854768678465, 218, 38, 'PPL', 'P'),
(127455, 'Evergreen Landing', 43.6733283996582, 0.762243375878782, -70.1877822875977, -1.22500789559154, 218, 26, 'PPL', 'P'),
(101779, 'Evergreen Mills', 39.0175018310547, 0.680983872854821, -77.5752792358398, -1.3539440408194, 218, 53, 'PPL', 'P'),
(135286, 'Evergreen Mobile Home Park', 45.0944404602051, 0.787046460375126, -94.5111083984375, -1.649530021262, 218, 28, 'PPL', 'P'),
(46930, 'Evergreen Park', 38.2094383239746, 0.666880504091061, -76.3894424438477, -1.33324728440785, 218, 25, 'PPL', 'P'),
(80920, 'Evergreen Park', 34.0827789306641, 0.59485671056944, -81.0430603027344, -1.41446823817503, 218, 48, 'PPL', 'P'),
(119574, 'Evergreen Park', 41.7205581665039, 0.728161105775302, -87.7016677856445, -1.53068286234974, 218, 18, 'PPL', 'P'),
(135287, 'Evergreen Park', 46.0113906860352, 0.803050260892766, -92.9441680908203, -1.62218175371187, 218, 28, 'PPL', 'P'),
(161438, 'Evergreen Park', 40.6413917541504, 0.709326098702798, -75.4850006103516, -1.31746179652056, 218, 45, 'PPL', 'P'),
(203907, 'Evergreen Park', 41.3069381713867, 0.720942075008424, -111.636108398438, -1.94841765566603, 218, 52, 'PPL', 'P'),
(8805, 'Evergreen Place', 34.9419403076172, 0.60985190540324, -91.9850006103516, -1.60544112309963, 218, 4, 'PPL', 'P'),
(40858, 'Evergreen Plantation', 30.2697200775146, 0.528306279009664, -91.1991729736328, -1.59172584348572, 218, 22, 'PPL', 'P'),
(46931, 'Evergreen Point', 39.3958282470703, 0.687586914461563, -77.4063873291016, -1.35099632096684, 218, 25, 'PPL', 'P'),
(101780, 'Evergreen Shores', 37.1872215270996, 0.649039455316402, -76.4169387817383, -1.33372718603628, 218, 53, 'PPL', 'P'),
(130725, 'Evergreen Shores', 45.9738883972168, 0.802395722475852, -86.3108291625977, -1.50640814901367, 218, 27, 'PPL', 'P'),
(145184, 'Evergreen Shores', 40.0047187805176, 0.698214059054443, -74.1377792358398, -1.29394834778209, 218, 37, 'PPL', 'P'),
(27118, 'Evergreen Terrace', 37.6991691589355, 0.657974627089727, -89.2355575561523, -1.55745428920776, 218, 18, 'PPL', 'P'),
(207370, 'Evergreen Terrace', 46.1811103820801, 0.806012428394234, -122.997779846191, -2.14671623095916, 218, 56, 'PPL', 'P'),
(46932, 'Evergreen Valley Estates', 39.285831451416, 0.685667108210752, -76.9272232055664, -1.34263332935372, 218, 25, 'PPL', 'P'),
(178173, 'Evergreen Villa Mobile Home Park', 33.3283309936523, 0.581689110033707, -111.853607177734, -1.95221372548383, 218, 5, 'PPL', 'P'),
(115503, 'Evergreen Village', 42.5597190856934, 0.74280722676922, -96.3402786254883, -1.68145506430349, 218, 16, 'PPL', 'P'),
(135289, 'Evergreen Village', 45.6216697692871, 0.796248347731622, -94.206672668457, -1.64421661541313, 218, 28, 'PPL', 'P'),
(101781, 'Everharts Crossroads', 39.2119407653809, 0.684377472452881, -77.6313934326172, -1.35492341831027, 218, 53, 'PPL', 'P'),
(20963, 'Everhill', 33.3852806091309, 0.582683068331552, -84.5538864135742, -1.47574371327417, 218, 13, 'PPL', 'P'),
(145185, 'Everittstown', 40.5658302307129, 0.708007301330991, -75.029167175293, -1.30950600223812, 218, 37, 'PPL', 'P'),
(46934, 'Everlea', 39.3288917541504, 0.686418652270373, -76.9258270263672, -1.34260896142975, 218, 25, 'PPL', 'P'),
(115504, 'Everly', 43.1599998474121, 0.753284102497592, -95.3272171020508, -1.66377380519423, 218, 16, 'PPL', 'P'),
(94122, 'Everman', 32.6308288574219, 0.569515401216791, -97.2888870239258, -1.69801140416829, 218, 51, 'PPL', 'P'),
(101782, 'Evermay', 38.9408302307129, 0.679645700986083, -77.154167175293, -1.346594248843, 218, 53, 'PPL', 'P'),
(101783, 'Everona', 38.3047218322754, 0.668543515033761, -77.9674987792969, -1.36078956324339, 218, 53, 'PPL', 'P'),
(29743, 'Everroad Park', 39.228328704834, 0.684663495953956, -85.8880615234375, -1.49902946173944, 218, 19, 'PPL', 'P'),
(27119, 'Evers', 39.0980606079102, 0.682389888752328, -88.4533309936523, -1.54380186019558, 218, 18, 'PPL', 'P'),
(35817, 'Eversole', 37.4474983215332, 0.653582142345805, -83.6427764892578, -1.45984184524725, 218, 21, 'PPL', 'P'),
(109132, 'Everson', 39.4494400024414, 0.688522616110562, -80.2422180175781, -1.40049090350986, 218, 58, 'PPL', 'P'),
(161439, 'Everson', 40.0911102294922, 0.699721874284618, -79.5877838134766, -1.38906887191061, 218, 45, 'PPL', 'P'),
(207371, 'Everson', 48.920280456543, 0.85381996496571, -122.34139251709, -2.13526011089797, 218, 56, 'PPL', 'P'),
(196450, 'Everson (historical)', 47.6236114501953, 0.83118882149638, -109.758331298828, -1.9156442626593, 218, 31, 'PPL', 'P'),
(54680, 'Eversonville', 39.9088897705078, 0.696541527310846, -93.3597183227539, -1.62943447346653, 218, 29, 'PPL', 'P'),
(8806, 'Everton', 36.1552810668945, 0.631028696601278, -92.9066696166992, -1.62152728187398, 218, 4, 'PPL', 'P'),
(29745, 'Everton', 39.5627784729004, 0.690500745589246, -85.0897216796875, -1.48509580291615, 218, 19, 'PPL', 'P'),
(54681, 'Everton', 37.3424987792969, 0.651749554620694, -93.7022171020508, -1.63541220484933, 218, 29, 'PPL', 'P'),
(64592, 'Everton', 35.0377807617188, 0.611524636883919, -78.0461120605469, -1.362161623837, 218, 33, 'PPL', 'P'),
(72482, 'Evertonville', 38.6855583190918, 0.675190365640435, -83.6891708374023, -1.46065157937669, 218, 41, 'PPL', 'P'),
(20964, 'Eves (historical)', 34.250560760498, 0.597785055925064, -85.0238876342773, -1.48394678206383, 218, 13, 'PPL', 'P'),
(70799, 'Evesboro', 39.913330078125, 0.696619025298567, -74.9238891601563, -1.30766855424402, 218, 37, 'PPL', 'P'),
(20965, 'Evian', 33.3624992370605, 0.582285458380803, -84.5416717529297, -1.47553052722891, 218, 13, 'PPL', 'P'),
(94123, 'Evie Colonia', 26.2339992523193, 0.457869662918703, -98.2429962158203, -1.71466375099039, 218, 51, 'PPL', 'P'),
(75794, 'Eville', 34.0050010681152, 0.593499230782799, -96.9869384765625, -1.69274140784519, 218, 42, 'PPL', 'P'),
(101784, 'Evington', 37.2336082458496, 0.649849056287786, -79.2897186279297, -1.38386665303725, 218, 53, 'PPL', 'P'),
(15963, 'Evinston', 29.4866695404053, 0.514639468927595, -82.2313919067383, -1.4352085372704, 218, 12, 'PPL', 'P'),
(80923, 'Evinsville', 34.6836090087891, 0.605343173677736, -81.8880615234375, -1.42921629165967, 218, 48, 'PPL', 'P'),
(46945, 'Evitts Creek', 39.6241683959961, 0.691572201874812, -78.7341690063477, -1.37417048298244, 218, 25, 'PPL', 'P'),
(46936, 'Evna', 39.5897216796875, 0.690970993258727, -76.6969375610352, -1.33861408663657, 218, 25, 'PPL', 'P'),
(35819, 'Evona', 37.1941719055176, 0.649160762304055, -84.9105606079102, -1.48196885232223, 218, 21, 'PPL', 'P'),
(139147, 'Evona', 40.1977806091309, 0.701583623623665, -94.3288879394531, -1.64634967428823, 218, 29, 'PPL', 'P'),
(203910, 'Evona', 41.2227783203125, 0.719473208509191, -112.000556945801, -1.95477848277163, 218, 52, 'PPL', 'P'),
(54682, 'Evorge', 36.0175018310547, 0.628623995294991, -90.1627807617188, -1.57363738704579, 218, 29, 'PPL', 'P'),
(8807, 'Ewal', 34.3650016784668, 0.599782426742623, -90.8311080932617, -1.58530189946229, 218, 4, 'PPL', 'P'),
(35818, 'Ewalt Crossroads', 38.2738914489746, 0.66800542333551, -84.2994384765625, -1.47130275899841, 218, 21, 'PPL', 'P'),
(70801, 'Ewan', 39.6986083984375, 0.692871425012607, -75.186393737793, -1.31225012342533, 218, 37, 'PPL', 'P'),
(207372, 'Ewan', 47.1169395446777, 0.822345728517744, -117.73388671875, -2.05484396441221, 218, 56, 'PPL', 'P'),
(70802, 'Ewansville', 39.978328704834, 0.697753465343913, -74.7355575561523, -1.30438154766859, 218, 37, 'PPL', 'P'),
(115505, 'Ewart', 41.6411094665527, 0.726774464374725, -92.6102828979492, -1.61635435777261, 218, 16, 'PPL', 'P'),
(64593, 'Ewart (historical)', 36.0825004577637, 0.629758435340337, -82.2041702270508, -1.43473342933193, 218, 33, 'PPL', 'P'),
(207373, 'Ewartsville', 46.7033309936523, 0.815126897487948, -117.301391601563, -2.04729550061849, 218, 56, 'PPL', 'P'),
(27120, 'Ewbanks', 39.9786109924316, 0.69775839219193, -91.3194427490234, -1.59382494705692, 218, 18, 'PPL', 'P'),
(94124, 'Ewelder', 28.1158294677734, 0.490713796141891, -97.4472198486328, -1.70077483327341, 218, 51, 'PPL', 'P'),
(2346, 'Ewell', 31.4213905334473, 0.548406720363632, -85.5747222900391, -1.49356066044096, 218, 2, 'PPL', 'P'),
(15964, 'Ewell', 27.8930606842041, 0.486825747397944, -81.9250030517578, -1.42986104295958, 218, 12, 'PPL', 'P'),
(32399, 'Ewell', 37.3400001525879, 0.651705945357844, -97.6902770996094, -1.7050169825738, 218, 20, 'PPL', 'P'),
(46937, 'Ewell', 37.9955596923828, 0.663147617770124, -76.0336074829102, -1.32703679274578, 218, 25, 'PPL', 'P'),
(94125, 'Ewell', 32.8624992370605, 0.573558812120831, -94.9166717529297, -1.65660843712332, 218, 51, 'PPL', 'P'),
(101785, 'Ewell', 37.3288917541504, 0.651512067230486, -76.7425003051758, -1.33940930653807, 218, 53, 'PPL', 'P'),
(148717, 'Ewells Corner', 42.8313903808594, 0.747548785353024, -78.1241683959961, -1.36352396389263, 218, 40, 'PPL', 'P'),
(172001, 'Ewells Mills', 44.3600006103516, 0.774228066837329, -72.1719436645508, -1.25963804451027, 218, 55, 'PPL', 'P'),
(130728, 'Ewen', 46.5352783203125, 0.81219382502139, -89.2811126708984, -1.55824937595121, 218, 27, 'PPL', 'P'),
(161441, 'Ewen', 41.310001373291, 0.720995537967307, -75.8108291625977, -1.32314857755426, 218, 45, 'PPL', 'P'),
(2348, 'Ewing', 33.9905586242676, 0.593247162585623, -85.9058303833008, -1.49933958684838, 218, 2, 'PPL', 'P'),
(27121, 'Ewing', 38.0886116027832, 0.664771679981881, -88.8522186279297, -1.55076376275921, 218, 18, 'PPL', 'P'),
(29744, 'Ewing', 38.8847198486328, 0.678666390074234, -86.0552825927734, -1.50194801997806, 218, 19, 'PPL', 'P'),
(35820, 'Ewing', 38.4272193908691, 0.670681500756876, -83.8633270263672, -1.46369117828685, 218, 21, 'PPL', 'P'),
(40859, 'Ewing', 29.7580604553223, 0.519376133952897, -90.6861114501953, -1.58277123063644, 218, 22, 'PPL', 'P'),
(72483, 'Ewing', 39.4724998474121, 0.688925086330301, -82.4333267211914, -1.43873296465701, 218, 41, 'PPL', 'P'),
(94126, 'Ewing', 31.3724994659424, 0.547553410260857, -94.4902801513672, -1.6491664997732, 218, 51, 'PPL', 'P'),
(101786, 'Ewing', 36.6366691589355, 0.639430503787287, -83.4316711425781, -1.45615736187913, 218, 53, 'PPL', 'P'),
(139148, 'Ewing', 40.0061111450195, 0.698238360399389, -91.7136077880859, -1.60070442478481, 218, 29, 'PPL', 'P'),
(141792, 'Ewing', 42.2577781677246, 0.737537363604171, -98.3461074829102, -1.71646338209702, 218, 35, 'PPL', 'P'),
(145186, 'Ewing', 40.269718170166, 0.702839170919583, -74.8002777099609, -1.30551112744494, 218, 37, 'PPL', 'P'),
(86863, 'Ewing (historical)', 35.8199996948242, 0.625176932738047, -84.1125030517578, -1.46804012034695, 218, 50, 'PPL', 'P'),
(2349, 'Ewing Farms', 31.0825004577637, 0.542491972740621, -87.5875015258789, -1.52869028522214, 218, 2, 'PPL', 'P'),
(161443, 'Ewings Mill', 40.5752792358398, 0.708172217581494, -78.9925003051758, -1.37867921470794, 218, 45, 'PPL', 'P'),
(161444, 'Ewingsville', 40.3994407653809, 0.705103257320314, -80.1127777099609, -1.39823174395714, 218, 45, 'PPL', 'P'),
(86864, 'Ewingsville (historical)', 35.9741706848145, 0.627867724124435, -86.1736068725586, -1.50401316824536, 218, 50, 'PPL', 'P'),
(27123, 'Ewington', 39.1016693115234, 0.682452872512108, -88.5972213745117, -1.54631322110353, 218, 18, 'PPL', 'P'),
(29746, 'Ewington', 39.3263893127441, 0.686374976428495, -85.5680618286133, -1.49344441345938, 218, 19, 'PPL', 'P'),
(35821, 'Ewington', 38.0833282470703, 0.664679468029137, -83.9013900756836, -1.46435550382077, 218, 21, 'PPL', 'P'),
(72485, 'Ewington', 39.0094413757324, 0.680843191370237, -82.3530578613281, -1.43733200876558, 218, 41, 'PPL', 'P'),
(46938, 'Ewingville', 39.2008285522461, 0.684183527746496, -75.982780456543, -1.32614969378668, 218, 25, 'PPL', 'P'),
(86865, 'Ewingville', 35.9216690063477, 0.626951396972366, -86.857780456543, -1.51595424994106, 218, 50, 'PPL', 'P'),
(145188, 'Ewingville', 40.2769393920898, 0.702965205018171, -74.7811126708984, -1.30517663441203, 218, 37, 'PPL', 'P'),
(46939, 'Ewingville (historical)', 39.6972198486328, 0.692847190246688, -75.9075012207031, -1.32483582326288, 218, 25, 'PPL', 'P'),
(64594, 'Ex-Way', 35.1719398498535, 0.613866154693344, -79.871940612793, -1.39402834365061, 218, 33, 'PPL', 'P'),
(2350, 'Excel', 31.4277801513672, 0.548518240234279, -87.3413925170898, -1.52439487269996, 218, 2, 'PPL', 'P'),
(86866, 'Excell', 36.4861106872559, 0.636802762739706, -87.2600021362305, -1.52297434257451, 218, 50, 'PPL', 'P'),
(54683, 'Excello', 39.6361083984375, 0.691780594230111, -92.4752807617188, -1.61399812599816, 218, 29, 'PPL', 'P'),
(72486, 'Excello', 39.4808311462402, 0.689070494925819, -84.4188919067383, -1.47338761465778, 218, 41, 'PPL', 'P'),
(8809, 'Excelsior', 35.2000007629395, 0.614355910017809, -94.3141708374023, -1.64609281240109, 218, 4, 'PPL', 'P'),
(20967, 'Excelsior', 31.4044399261475, 0.548110876456038, -83.6080627441406, -1.45923597609926, 218, 13, 'PPL', 'P'),
(54684, 'Excelsior', 38.4775009155273, 0.671559078915085, -92.7219390869141, -1.61830312590028, 218, 29, 'PPL', 'P'),
(109137, 'Excelsior', 37.309440612793, 0.651172580770528, -81.6941680908203, -1.4258322128625, 218, 58, 'PPL', 'P'),
(135293, 'Excelsior', 44.9033317565918, 0.783710984267856, -93.5661087036133, -1.63303666515698, 218, 28, 'PPL', 'P'),
(161445, 'Excelsior', 40.7730598449707, 0.711624140407428, -76.4966735839844, -1.3351188208639, 218, 45, 'PPL', 'P'),
(174046, 'Excelsior', 43.2516708374023, 0.754884063101484, -90.628059387207, -1.58175803099972, 218, 57, 'PPL', 'P'),
(207374, 'Excelsior', 47.2033309936523, 0.82385354374792, -122.454719543457, -2.13723804063957, 218, 56, 'PPL', 'P'),
(80921, 'Excelsior (historical)', 34.6958312988281, 0.605556492881051, -79.9319381713867, -1.39507549859123, 218, 48, 'PPL', 'P'),
(199947, 'Excelsior (historical)', 41.7044410705566, 0.727879809385162, -116.168060302734, -2.02751513793804, 218, 39, 'PPL', 'P'),
(194908, 'Excelsior Beach', 47.8802795410156, 0.835668524766002, -116.875831604004, -2.03986807749631, 218, 17, 'PPL', 'P'),
(161446, 'Excelsior Corner', 41.6963882446289, 0.727739261058633, -79.482780456543, -1.38723621760648, 218, 45, 'PPL', 'P'),
(54685, 'Excelsior Estates', 39.3902816772461, 0.687490108555939, -94.2074966430664, -1.64423099648301, 218, 29, 'PPL', 'P'),
(54686, 'Excelsior Springs', 39.339168548584, 0.686598016169789, -94.225830078125, -1.64455097528799, 218, 29, 'PPL', 'P'),
(148718, 'Excelsior Springs', 42.7516708374023, 0.746157416841512, -77.7130584716797, -1.35634874212568, 218, 40, 'PPL', 'P'),
(54687, 'Excelsior Springs Junction', 39.2377815246582, 0.684828478783486, -94.2402801513672, -1.64480317664322, 218, 29, 'PPL', 'P'),
(29747, 'Exchange', 39.5016708374023, 0.689434216151697, -86.3222198486328, -1.50660695398904, 218, 19, 'PPL', 'P'),
(161447, 'Exchange', 41.1130599975586, 0.717558262527369, -76.6841735839844, -1.33839131321139, 218, 45, 'PPL', 'P'),
(209953, 'Excursion Inlet', 58.4188919067383, 1.01960200913925, -135.426666259766, -2.36364122123242, 218, 1, 'PPL', 'P'),
(20968, 'Executive Heights', 33.711109161377, 0.588369849365252, -84.7872161865234, -1.47981608605506, 218, 13, 'PPL', 'P'),
(203912, 'Executive House Condominiums', 41.2236099243164, 0.719487722737132, -111.956939697266, -1.95401721817403, 218, 52, 'PPL', 'P'),
(203913, 'Executive Suites of Fountain East', 40.6611099243164, 0.709670245694664, -111.859718322754, -1.95232038508548, 218, 52, 'PPL', 'P'),
(115508, 'Exeelsior', 41.2569389343262, 0.720069423698232, -92.5122222900391, -1.61464287729807, 218, 16, 'PPL', 'P'),
(174048, 'Exeland', 45.6680603027344, 0.797058015282033, -91.2438888549805, -1.59250628284317, 218, 57, 'PPL', 'P'),
(191445, 'Exell', 35.6305618286133, 0.621870618244713, -101.974166870117, -1.77978496386167, 218, 51, 'PPL', 'P'),
(27124, 'Exermont', 38.6477813720703, 0.674531033533559, -90.04638671875, -1.57160592776628, 218, 18, 'PPL', 'P'),
(27125, 'Exeter', 39.7208290100098, 0.69325924784635, -90.4963912963867, -1.57945998929509, 218, 18, 'PPL', 'P'),
(54688, 'Exeter', 36.6722183227539, 0.640050953742248, -93.9408264160156, -1.63957672300394, 218, 29, 'PPL', 'P'),
(101787, 'Exeter', 36.8758316040039, 0.64360467590085, -82.8541717529297, -1.4460780961015, 218, 53, 'PPL', 'P'),
(113412, 'Exeter', 41.6197204589844, 0.726401155768923, -72.2647171020508, -1.26125724645304, 218, 8, 'PPL', 'P'),
(141794, 'Exeter', 40.6441688537598, 0.709374568234638, -97.4499969482422, -1.70082330280525, 218, 35, 'PPL', 'P'),
(143813, 'Exeter', 42.9813919067383, 0.750166805862627, -70.9483337402344, -1.23828202257087, 218, 36, 'PPL', 'P'),
(161448, 'Exeter', 41.3205604553223, 0.721179828714741, -75.8194427490234, -1.3232989129978, 218, 45, 'PPL', 'P'),
(169367, 'Exeter', 41.5774993896484, 0.725664259095298, -71.5380630493164, -1.24857474070987, 218, 47, 'PPL', 'P'),
(174050, 'Exeter', 42.7905616760254, 0.746836190024346, -89.5830612182617, -1.56351937227431, 218, 57, 'PPL', 'P'),
(181508, 'Exeter', 36.2961082458496, 0.633486594550339, -119.14111328125, -2.07940470124936, 218, 6, 'PPL', 'P'),
(64595, 'Exeter (historical)', 34.5572204589844, 0.603137277346823, -77.8080596923828, -1.35800682622037, 218, 33, 'PPL', 'P'),
(127456, 'Exeter Center', 44.9700012207031, 0.784874585927139, -69.1405563354492, -1.20673035471421, 218, 26, 'PPL', 'P'),
(148719, 'Exeter Corner', 42.7886085510254, 0.746802101562393, -75.0749969482422, -1.31030588267152, 218, 40, 'PPL', 'P'),
(127457, 'Exeter Corners', 44.9847183227539, 0.785131447814277, -69.1458282470703, -1.20682236692988, 218, 26, 'PPL', 'P'),
(46940, 'Exeter Green', 39.4833297729492, 0.689114104188669, -76.3777770996094, -1.33304368574251, 218, 25, 'PPL', 'P'),
(127458, 'Exeter Mills', 44.9700012207031, 0.784874585927139, -69.0791702270508, -1.20565896500768, 218, 26, 'PPL', 'P'),
(517, 'Exie', 37.1597213745117, 0.648559487108942, -85.5358276367188, -1.4928818206791, 218, 21, 'PPL', 'P'),
(2352, 'Exie', 34.0491714477539, 0.59427014933935, -85.5486068725586, -1.4931048604204, 218, 2, 'PPL', 'P'),
(174052, 'Exile', 44.6991691589355, 0.78014767472933, -92.1655578613281, -1.60859244161752, 218, 57, 'PPL', 'P'),
(115509, 'Exira', 41.5908317565918, 0.725896952795544, -94.8752822875977, -1.65588605467764, 218, 16, 'PPL', 'P'),
(20969, 'Exley', 32.2455596923828, 0.56279118578045, -81.2291717529297, -1.4177164957566, 218, 13, 'PPL', 'P'),
(46941, 'Exline', 39.6711082458496, 0.692391456805148, -78.2813873291016, -1.36626795192179, 218, 25, 'PPL', 'P'),
(115511, 'Exline', 40.649169921875, 0.709461853339365, -92.8402786254883, -1.62036854048369, 218, 16, 'PPL', 'P'),
(119576, 'Exline', 41.1500015258789, 0.718203013827277, -87.7683334350586, -1.53184639743, 218, 18, 'PPL', 'P'),
(2353, 'Exmoor', 32.0563888549805, 0.559489531819024, -87.8741683959961, -1.53369356596208, 218, 2, 'PPL', 'P'),
(161453, 'Exmoor', 40.5333290100098, 0.707440048018804, -76.4122161865234, -1.33364476120054, 218, 45, 'PPL', 'P'),
(101788, 'Exmore', 37.5316696166992, 0.65505120858212, -75.8233337402344, -1.3233668236056, 218, 53, 'PPL', 'P'),
(54690, 'Expansion', 37.1349983215332, 0.648127988433322, -93.1986083984375, -1.62662257482957, 218, 29, 'PPL', 'P'),
(8810, 'Experiment', 33.2024993896484, 0.579492934240773, -93.4658279418945, -1.63128643568857, 218, 4, 'PPL', 'P'),
(20970, 'Experiment', 33.2652816772461, 0.580588691871286, -84.2816696166992, -1.47099263388947, 218, 13, 'PPL', 'P'),
(161454, 'Experiment', 40.3091697692871, 0.703527731219423, -79.975830078125, -1.3958415568788, 218, 45, 'PPL', 'P'),
(161456, 'Export', 40.4180603027344, 0.705428229552331, -79.6258316040039, -1.38973293112843, 218, 45, 'PPL', 'P'),
(109135, 'Export (historical)', 37.857780456543, 0.660742916463837, -81.0008316040039, -1.41373120834335, 218, 58, 'PPL', 'P'),
(59863, 'Expose', 31.3227806091309, 0.546685652509169, -89.8633270263672, -1.56841093340651, 218, 30, 'PPL', 'P'),
(119577, 'Exposition View', 41.7924995422363, 0.729416719650247, -88.3436126708984, -1.54188691421376, 218, 18, 'PPL', 'P'),
(94127, 'Expressway 83-77 Colonia', 26.1140003204346, 0.455775286458438, -97.6129989624023, -1.70366822463973, 218, 51, 'PPL', 'P'),
(40861, 'Expressway Acres', 32.4172210693359, 0.565787242006789, -93.9444427490234, -1.63963983992177, 218, 22, 'PPL', 'P'),
(94128, 'Expressway Acres Colonia', 26.2369995117188, 0.457922027323637, -98.3949966430664, -1.71731665891028, 218, 51, 'PPL', 'P'),
(94129, 'Expressway Heights Colonia', 26.1760005950928, 0.456857395388364, -98.0100021362305, -1.7105972371639, 218, 51, 'PPL', 'P'),
(40862, 'Extension', 31.9705600738525, 0.557991536995368, -91.8058319091797, -1.60231403934766, 218, 22, 'PPL', 'P'),
(122589, 'Extension Heights', 40.1047210693359, 0.699959428253853, -85.6602783203125, -1.49505389486417, 218, 19, 'PPL', 'P'),
(161458, 'Exton', 40.0288887023926, 0.698635903771111, -75.6211090087891, -1.31983733621291, 218, 45, 'PPL', 'P'),
(145189, 'Extonville', 40.1433296203613, 0.700633274588671, -74.5991668701172, -1.30200108112822, 218, 37, 'PPL', 'P'),
(109136, 'Extra', 38.6172218322754, 0.673997668946243, -81.8516693115234, -1.42858112773968, 218, 58, 'PPL', 'P'),
(2354, 'Exum', 33.5027809143066, 0.584733835528967, -86.9333267211914, -1.51727278099676, 218, 2, 'PPL', 'P'),
(64596, 'Exum', 34.1100006103516, 0.59533181850791, -78.4644393920898, -1.36946281312351, 218, 33, 'PPL', 'P'),
(191446, 'Exum', 36.0269393920898, 0.628788711808412, -102.193893432617, -1.78361991583138, 218, 51, 'PPL', 'P'),
(211821, 'Eyak', 60.5250015258789, 1.05636055640118, -145.600006103516, -2.54119949743019, 218, 1, 'PPL', 'P'),
(130734, 'Eyedylwild Beach', 44.9619407653809, 0.784733904442555, -84.7041702270508, -1.47836666063179, 218, 27, 'PPL', 'P'),
(46942, 'Eyeler (historical)', 39.6861114501953, 0.69265331211933, -77.4072189331055, -1.35101083519478, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(161459, 'Eyer', 40.6891708374023, 0.710160001019129, -78.1763916015625, -1.36443543077571, 218, 45, 'PPL', 'P'),
(161460, 'Eyers Grove', 41.0886116027832, 0.717131557541711, -76.5175018310547, -1.33548234235269, 218, 45, 'PPL', 'P'),
(193538, 'Eyese Bar (historical)', 41.5041694641113, 0.724384410454433, -123.527496337891, -2.15596152784143, 218, 6, 'PPL', 'P'),
(119578, 'Eylar', 40.9122200012207, 0.71405294332158, -88.4527816772461, -1.54379227281566, 218, 18, 'PPL', 'P'),
(94130, 'Eylau', 33.3791694641113, 0.582576408729894, -94.1161117553711, -1.64263602930617, 218, 51, 'PPL', 'P'),
(46943, 'Eyler Springs', 39.4688911437988, 0.68886210257052, -77.4638900756836, -1.35199993322364, 218, 25, 'PPL', 'P'),
(161461, 'Eynon', 41.4955596923828, 0.724234141589926, -75.5747222900391, -1.31902773524153, 218, 45, 'PPL', 'P'),
(135296, 'Eyota', 43.9883308410645, 0.767741205633141, -92.2283325195313, -1.60968806608998, 218, 28, 'PPL', 'P'),
(46944, 'Eyre View', 39.3097190856934, 0.686084026079404, -77.070556640625, -1.34513496972369, 218, 25, 'PPL', 'P'),
(35824, 'Ezel', 37.8911094665527, 0.661324617424937, -83.4444427490234, -1.45638026846237, 218, 21, 'PPL', 'P'),
(2355, 'Ezell', 31.9174995422363, 0.557065456015807, -85.8555603027344, -1.49846220842725, 218, 2, 'PPL', 'P'),
(101789, 'Ezell', 36.6941719055176, 0.640434116044083, -77.855827331543, -1.35884052879962, 218, 53, 'PPL', 'P'),
(80922, 'Ezell (historical)', 35.1377792358398, 0.613269939504302, -81.8169403076172, -1.42797499227558, 218, 48, 'PPL', 'P'),
(94131, 'Ezequiel Acevedo Colonia', 26.2169990539551, 0.457572953483755, -98.3860015869141, -1.71715966556402, 218, 51, 'PPL', 'P'),
(94132, 'Ezequiel Acevedo Junior Colonia Number 2', 26.2180004119873, 0.457590430478408, -98.3860015869141, -1.71715966556402, 218, 51, 'PPL', 'P'),
(2357, 'Ezra', 33.4458312988281, 0.583739877231122, -87.1430587768555, -1.52093329591507, 218, 2, 'PPL', 'P'),
(54691, 'Ezra (historical)', 37.5558280944824, 0.655472853561706, -90.0983276367188, -1.57251246780134, 218, 29, 'PPL', 'P'),
(94133, 'Ezzell', 29.2822208404541, 0.511071165962025, -96.9005584716797, -1.6912337923521, 218, 51, 'PPL', 'P'),
(64597, 'Ezzelltown', 34.6652793884277, 0.60502326145179, -78.2024993896484, -1.36489109763822, 218, 33, 'PPL', 'P'),
(161462, 'F M Corners', 41.2197189331055, 0.719419812129335, -80.4711074829102, -1.40448577830303, 218, 45, 'PPL', 'P'),
(191447, 'Fabens', 31.5022201538086, 0.549817463372074, -106.158058166504, -1.85280764252915, 218, 51, 'PPL', 'P'),
(8812, 'Faber', 34.1683311462402, 0.59634987841362, -92.9361114501953, -1.62204113880631, 218, 4, 'PPL', 'P'),
(35822, 'Faber', 36.8736114501953, 0.643565926906989, -84.1302795410156, -1.46835037861395, 218, 21, 'PPL', 'P'),
(101790, 'Faber', 37.8316688537598, 0.660287183022297, -78.7377777099609, -1.37423346674222, 218, 53, 'PPL', 'P'),
(2358, 'Fabius', 34.8108291625977, 0.60756358423659, -85.7774963378906, -1.49709973521357, 218, 2, 'PPL', 'P'),
(130732, 'Fabius', 41.9105606079102, 0.731477273964668, -85.7216720581055, -1.49612541772876, 218, 27, 'PPL', 'P'),
(139149, 'Fabius', 40.2886085510254, 0.703168870262535, -92.1377792358398, -1.60810761314107, 218, 29, 'PPL', 'P'),
(148721, 'Fabius', 42.8349990844727, 0.747611769112804, -75.9863891601563, -1.32621267754646, 218, 40, 'PPL', 'P'),
(109138, 'Fabius (historical)', 39.0938911437988, 0.682317117875542, -78.8369369506836, -1.37596412197661, 218, 58, 'PPL', 'P'),
(113414, 'Fabyan', 42.0136108398438, 0.733275839806854, -71.9402770996094, -1.25559470018526, 218, 8, 'PPL', 'P'),
(143815, 'Fabyan', 44.2633285522461, 0.772540821128709, -71.4588928222656, -1.24719295957828, 218, 36, 'PPL', 'P'),
(20972, 'Faceville', 30.753059387207, 0.536742141368112, -84.6399993896484, -1.47724666823536, 218, 13, 'PPL', 'P'),
(193539, 'Facht Place', 40.2425003051758, 0.70236412956014, -121.962219238281, -2.12864228874718, 218, 6, 'PPL', 'P'),
(15974, 'Facil', 30.3655605316162, 0.529979010490343, -82.7916717529297, -1.44498726531901, 218, 12, 'PPL', 'P'),
(2359, 'Fackler', 34.7924995422363, 0.607243672010644, -85.9100036621094, -1.49941242430419, 218, 2, 'PPL', 'P'),
(207375, 'Factoria', 47.582218170166, 0.830466372471668, -122.165832519531, -2.13219601090578, 218, 56, 'PPL', 'P'),
(78224, 'Factory Hill', 39.9661102294922, 0.697540212719625, -79.603889465332, -1.38934996856367, 218, 45, 'PPL', 'P'),
(101791, 'Factory Hill', 36.5613899230957, 0.638116633263496, -76.8586120605469, -1.34143583896957, 218, 53, 'PPL', 'P'),
(124801, 'Factory Hollow', 42.4152793884277, 0.740286278481351, -72.519172668457, -1.26569833388686, 218, 23, 'PPL', 'P'),
(148723, 'Factory Hollow', 42.8375015258789, 0.747655444954682, -73.4938888549805, -1.28271034061417, 218, 40, 'PPL', 'P'),
(148742, 'Factory Village', 43.0258293151855, 0.750942384951085, -73.866943359375, -1.28922137000525, 218, 40, 'PPL', 'P'),
(124800, 'Factory Village (historical)', 42.6166687011719, 0.743801185067065, -72.5541687011719, -1.26630912988287, 218, 23, 'PPL', 'P'),
(148724, 'Factoryville', 43.9516716003418, 0.76710138118125, -73.4419403076172, -1.28180366742106, 218, 40, 'PPL', 'P'),
(161465, 'Factoryville', 41.563060760498, 0.725412257477149, -75.7830581665039, -1.32266388223587, 218, 45, 'PPL', 'P'),
(94137, 'Fada', 32.610279083252, 0.569156739996985, -95.2947235107422, -1.6632066850401, 218, 51, 'PPL', 'P'),
(161467, 'Fades', 41.3205604553223, 0.721179828714741, -76.1211090087891, -1.32856398247289, 218, 45, 'PPL', 'P'),
(2360, 'Fadette', 31.0444393157959, 0.541827680496214, -85.5374984741211, -1.49291098229304, 218, 2, 'PPL', 'P'),
(20973, 'Fagan', 32.519718170166, 0.567576153890023, -83.8636093139648, -1.46369610513487, 218, 13, 'PPL', 'P'),
(35823, 'Fagan', 37.916389465332, 0.661765836638536, -83.7130584716797, -1.46106849724534, 218, 21, 'PPL', 'P'),
(181509, 'Fagan', 39.336109161377, 0.686544619789933, -121.682502746582, -2.1237603149949, 218, 6, 'PPL', 'P'),
(101792, 'Fagg', 37.1961097717285, 0.649194584449899, -80.3233337402344, -1.40190663994534, 218, 53, 'PPL', 'P'),
(64598, 'Faggarts Crossroads', 35.3613891601563, 0.617172668923759, -80.5430603027344, -1.40574159191506, 218, 33, 'PPL', 'P'),
(78225, 'Faggs Manor', 39.857780456543, 0.695649501503724, -75.9097213745117, -1.32487457225675, 218, 45, 'PPL', 'P'),
(86867, 'Fagin', 35.5547218322754, 0.620546960603917, -84.3186111450195, -1.47163738518938, 218, 50, 'PPL', 'P'),
(161469, 'Fagleysville', 40.2763900756836, 0.702955617638247, -75.5652770996094, -1.31886288557005, 218, 45, 'PPL', 'P'),
(161468, 'Fagundus', 41.6324996948242, 0.726624195510217, -79.4333267211914, -1.38637308709718, 218, 45, 'PPL', 'P'),
(54694, 'Fagus', 36.5113906860352, 0.637243981953305, -90.2669372558594, -1.57545526080588, 218, 29, 'PPL', 'P'),
(2361, 'Failetown', 31.9277801513672, 0.557244886494251, -88.0163879394531, -1.53617576525608, 218, 2, 'PPL', 'P'),
(20974, 'Fain', 34.8244400024414, 0.607801138205825, -83.8713912963867, -1.46383192635046, 218, 13, 'PPL', 'P'),
(20975, 'Fains Store', 34.2355613708496, 0.597523267189909, -82.7877807617188, -1.44491935471121, 218, 13, 'PPL', 'P'),
(29748, 'Fair Acres', 38.6041717529297, 0.673769902094014, -86.0902786254883, -1.50255881597407, 218, 19, 'PPL', 'P'),
(86868, 'Fair Acres', 36.5461082458496, 0.637849917680325, -82.5330581665039, -1.44047360674549, 218, 50, 'PPL', 'P'),
(161472, 'Fair Acres', 40.1877784729004, 0.701409053414211, -76.8925018310547, -1.34202732704767, 218, 45, 'PPL', 'P'),
(64599, 'Fair Bluff', 34.3133316040039, 0.598880613818495, -79.0374984741211, -1.37946458091341, 218, 33, 'PPL', 'P'),
(46971, 'Fair Brook', 39.311939239502, 0.686122775073265, -76.7694396972656, -1.33987948762852, 218, 25, 'PPL', 'P'),
(101793, 'Fair Estates', 38.690559387207, 0.675277650745162, -77.4244384765625, -1.3513113729238, 218, 53, 'PPL', 'P'),
(8813, 'Fair Field', 35.3269386291504, 0.616571393728646, -90.8258285522461, -1.58520975408857, 218, 4, 'PPL', 'P'),
(15975, 'Fair Gate', 26.2280597686768, 0.457765999373272, -80.2102813720703, -1.3999335038937, 218, 12, 'PPL', 'P'),
(54695, 'Fair Grove', 37.3838882446289, 0.652471937066378, -93.1511077880859, -1.62579353278223, 218, 29, 'PPL', 'P'),
(64601, 'Fair Grove', 35.8519401550293, 0.625734398933227, -80.0777816772461, -1.39762094796113, 218, 33, 'PPL', 'P'),
(148725, 'Fair Harbor', 40.6391716003418, 0.709287349708937, -73.1847229003906, -1.27731437677151, 218, 40, 'PPL', 'P'),
(207376, 'Fair Harbor', 47.3422203063965, 0.826277619551137, -122.830833435059, -2.14380246641051, 218, 56, 'PPL', 'P'),
(54696, 'Fair Haven', 37.976390838623, 0.662813058158183, -94.1730575561523, -1.64362992102498, 218, 29, 'PPL', 'P'),
(101794, 'Fair Haven', 38.7849998474121, 0.67692594772284, -77.0747222900391, -1.34520767402145, 218, 53, 'PPL', 'P'),
(113415, 'Fair Haven', 41.3111114501953, 0.721014912464238, -72.896110534668, -1.27227714072768, 218, 8, 'PPL', 'P'),
(119580, 'Fair Haven', 41.9455604553223, 0.732088136539705, -89.9291687011719, -1.56956008741688, 218, 18, 'PPL', 'P'),
(130737, 'Fair Haven', 42.6791687011719, 0.744892015849561, -82.6538925170898, -1.44258256401272, 218, 27, 'PPL', 'P'),
(145190, 'Fair Haven', 40.3605613708496, 0.704424683874562, -74.0386123657227, -1.29221755938965, 218, 37, 'PPL', 'P'),
(148727, 'Fair Haven', 42.7691688537598, 0.746462814839517, -76.2686080932617, -1.33113832714061, 218, 40, 'PPL', 'P'),
(172007, 'Fair Haven', 43.5947189331055, 0.7608713818642, -73.26611328125, -1.27873490689696, 218, 55, 'PPL', 'P'),
(196451, 'Fair Haven Colony', 47.4036102294922, 0.827349075836703, -111.627502441406, -1.94826745338055, 218, 31, 'PPL', 'P'),
(113416, 'Fair Haven East', 41.297779083252, 0.720782218763992, -72.8877792358398, -1.27213173213216, 218, 8, 'PPL', 'P'),
(46947, 'Fair Hill', 39.5713882446289, 0.690651014453754, -76.1658325195313, -1.32934455498839, 218, 25, 'PPL', 'P'),
(101795, 'Fair Hill', 37.3952789306641, 0.652670742041752, -77.3300018310547, -1.34966314252515, 218, 53, 'PPL', 'P'),
(161470, 'Fair Hill', 40.3197212219238, 0.703711888808802, -75.2808303833008, -1.31389835382398, 218, 45, 'PPL', 'P'),
(46948, 'Fair Hill Meadows', 39.6872215270996, 0.69267268661626, -75.8916702270508, -1.32455952029979, 218, 25, 'PPL', 'P'),
(161471, 'Fair Hills', 40.2333297729492, 0.702204073578626, -75.4000015258789, -1.31597828263534, 218, 45, 'PPL', 'P'),
(8814, 'Fair Landing', 34.2566719055176, 0.597891715526722, -90.8394393920898, -1.5854473080578, 218, 4, 'PPL', 'P'),
(113417, 'Fair Lawn', 41.5458297729492, 0.725111520011052, -73.0038909912109, -1.27415826456366, 218, 8, 'PPL', 'P'),
(145192, 'Fair Lawn', 40.9402809143066, 0.714542698646045, -74.1322174072266, -1.29385127556036, 218, 37, 'PPL', 'P'),
(101796, 'Fair Meadows', 36.8505592346191, 0.643163589845306, -76.1752777099609, -1.32950940465986, 218, 53, 'PPL', 'P'),
(72487, 'Fair Oak (historical)', 38.9958305358887, 0.680605637401002, -84.1750030517578, -1.46913095112945, 218, 41, 'PPL', 'P'),
(59864, 'Fair Oak Springs', 31.5544395446777, 0.550728863676127, -90.3202819824219, -1.57638630192297, 218, 30, 'PPL', 'P'),
(2362, 'Fair Oaks', 32.9394416809082, 0.574901711100504, -88.2516708374023, -1.54028222649893, 218, 2, 'PPL', 'P'),
(8815, 'Fair Oaks', 35.2433280944824, 0.615112114609337, -91.0311126708984, -1.58879263786111, 218, 4, 'PPL', 'P'),
(20976, 'Fair Oaks', 33.916389465332, 0.591952666558763, -84.5447235107422, -1.47558379045071, 218, 13, 'PPL', 'P'),
(72488, 'Fair Oaks', 38.7805595397949, 0.676848449735118, -82.8386077880859, -1.44580645367032, 218, 41, 'PPL', 'P'),
(75797, 'Fair Oaks', 36.1480598449707, 0.63090266250269, -95.7083282470703, -1.67042544949087, 218, 42, 'PPL', 'P'),
(86870, 'Fair Oaks', 35.9711112976074, 0.627814327744579, -84.0355606079102, -1.46669722136728, 218, 50, 'PPL', 'P'),
(94138, 'Fair Oaks', 31.4866695404053, 0.549546053967482, -96.3072204589844, -1.68087809045332, 218, 51, 'PPL', 'P'),
(101798, 'Fair Oaks', 37.5305595397949, 0.655031834085189, -77.3163909912109, -1.34942558855591, 218, 53, 'PPL', 'P'),
(119581, 'Fair Oaks', 41.958610534668, 0.732315903391934, -88.4013900756836, -1.54289532016052, 218, 18, 'PPL', 'P'),
(122591, 'Fair Oaks', 41.0750007629395, 0.716894003572476, -87.2574996948242, -1.52293066673263, 218, 19, 'PPL', 'P'),
(148728, 'Fair Oaks', 41.5069389343262, 0.724432746828218, -74.4105606079102, -1.29870928086283, 218, 40, 'PPL', 'P'),
(181512, 'Fair Oaks', 37.9552803039551, 0.66244460982137, -121.257499694824, -2.1163426124107, 218, 6, 'PPL', 'P'),
(200797, 'Fair Oaks', 43.4174995422363, 0.757778319995155, -123.212219238281, -2.15045890439711, 218, 43, 'PPL', 'P'),
(94139, 'Fair Oaks Ranch', 29.7455596923828, 0.519157954480592, -98.6430587768555, -1.72164615989442, 218, 51, 'PPL', 'P'),
(109139, 'Fair Oaks Trailer Park', 37.785831451416, 0.659487169430837, -80.4572219848633, -1.40424343064383, 218, 58, 'PPL', 'P'),
(2363, 'Fair Park', 33.4258308410645, 0.58339080339124, -86.182502746582, -1.50416843053691, 218, 2, 'PPL', 'P'),
(72489, 'Fair Place', 38.4469413757324, 0.671025714327769, -82.3305587768555, -1.43693932566284, 218, 41, 'PPL', 'P'),
(130735, 'Fair Plain', 42.0869407653809, 0.734555688447718, -86.4558334350586, -1.50893895099757, 218, 27, 'PPL', 'P'),
(54697, 'Fair Play', 37.6300010681152, 0.656767416167594, -93.5730590820313, -1.63315797214463, 218, 29, 'PPL', 'P'),
(80925, 'Fair Play', 34.5111083984375, 0.602332470065401, -82.9855575561523, -1.44837121095812, 218, 48, 'PPL', 'P'),
(94140, 'Fair Play', 32.1469383239746, 0.561069918188905, -94.5311126708984, -1.64987916168091, 218, 51, 'PPL', 'P'),
(145194, 'Fair Play', 40.2366714477539, 0.702262396806499, -74.4649963378906, -1.29965936358171, 218, 37, 'PPL', 'P'),
(174053, 'Fair Play', 42.5355606079102, 0.742385581789633, -90.5605621337891, -1.58057998169152, 218, 57, 'PPL', 'P'),
(181513, 'Fair Play', 38.5936088562012, 0.673585544767553, -120.659439086914, -2.10590448567619, 218, 6, 'PPL', 'P'),
(199946, 'Fair Play (historical)', 40.6111106872559, 0.708797594384472, -115.270561218262, -2.01185082388035, 218, 39, 'PPL', 'P'),
(59865, 'Fair River', 31.5458297729492, 0.550578594811619, -90.269172668457, -1.57549427611585, 218, 30, 'PPL', 'P'),
(101800, 'Fair Vernon', 38.7683296203613, 0.676634997373748, -77.1897201538086, -1.34721476537698, 218, 53, 'PPL', 'P'),
(2364, 'Fair View', 34.6266708374023, 0.604349415116973, -85.790283203125, -1.49732290811292, 218, 2, 'PPL', 'P'),
(86872, 'Fair View', 36.4958305358887, 0.636972406101144, -87.897216796875, -1.53409583644473, 218, 50, 'PPL', 'P'),
(46949, 'Fair Wind Estates', 39.4000015258789, 0.687659751917377, -77.1397171020508, -1.34634204748776, 218, 25, 'PPL', 'P'),
(46950, 'Fair Winds', 39.0808296203613, 0.682089151286231, -76.5905609130859, -1.33675746388262, 218, 25, 'PPL', 'P'),
(101801, 'Fair Woods', 37.6997184753418, 0.657984214469651, -77.8411102294922, -1.35858366691248, 218, 53, 'PPL', 'P'),
(188540, 'Fairacres', 32.3038902282715, 0.56380924568616, -106.84610748291, -1.86481636851653, 218, 38, 'PPL', 'P'),
(46951, 'Fairbank', 38.6855583190918, 0.675190365640435, -76.3383331298828, -1.33235525860072, 218, 25, 'PPL', 'P'),
(78227, 'Fairbank', 39.9433288574219, 0.697142602768876, -79.8497161865234, -1.39364045423784, 218, 45, 'PPL', 'P'),
(115513, 'Fairbank', 42.6391716003418, 0.744193934748824, -92.0469436645508, -1.60652223334415, 218, 16, 'PPL', 'P'),
(178174, 'Fairbank (historical)', 31.7230606079102, 0.553671856417746, -110.187782287598, -1.92313959638927, 218, 5, 'PPL', 'P'),
(8817, 'Fairbanks', 35.4444389343262, 0.618622160926062, -92.2719421386719, -1.61044919752952, 218, 4, 'PPL', 'P'),
(15976, 'Fairbanks', 29.7244396209717, 0.518789339696211, -82.2641677856445, -1.43578058427255, 218, 12, 'PPL', 'P'),
(27127, 'Fairbanks', 39.7172203063965, 0.69319626408657, -88.5299987792969, -1.54513996548529, 218, 18, 'PPL', 'P'),
(29749, 'Fairbanks', 39.2194404602051, 0.684508366820459, -87.522216796875, -1.52755085174975, 218, 19, 'PPL', 'P'),
(35826, 'Fairbanks', 38.4333305358887, 0.670788160358534, -84.7324981689453, -1.47886107648816, 218, 21, 'PPL', 'P'),
(40864, 'Fairbanks', 32.6441688537598, 0.569748228075091, -92.0363922119141, -1.60633807575477, 218, 22, 'PPL', 'P'),
(94141, 'Fairbanks', 29.8525009155273, 0.521024430930574, -95.524169921875, -1.66721128037125, 218, 51, 'PPL', 'P'),
(109140, 'Fairbanks', 38.7266693115234, 0.67590788781713, -80.682502746582, -1.40817532167722, 218, 58, 'PPL', 'P'),
(127460, 'Fairbanks', 44.7030601501465, 0.780215585337127, -70.163330078125, -1.22458112402685, 218, 26, 'PPL', 'P'),
(135301, 'Fairbanks', 47.3705596923828, 0.826772235144592, -91.9263916015625, -1.60441820292493, 218, 28, 'PPL', 'P'),
(161473, 'Fairbanks', 40.4841690063477, 0.706582044094608, -79.4855575561523, -1.38728468713832, 218, 45, 'PPL', 'P'),
(181514, 'Fairbanks', 38.8658294677734, 0.678336690731282, -120.669166564941, -2.10607426219568, 218, 6, 'PPL', 'P'),
(188541, 'Fairbanks', 33.3530616760254, 0.582120741867381, -104.485000610352, -1.82360727959892, 218, 38, 'PPL', 'P'),
(200798, 'Fairbanks', 45.6241683959961, 0.796291956994472, -121.000831604004, -2.11186290914108, 218, 43, 'PPL', 'P'),
(207377, 'Fairbanks', 47.2244415283203, 0.824221992084732, -117.214172363281, -2.0457732377394, 218, 56, 'PPL', 'P'),
(211822, 'Fairbanks', 64.8377838134766, 1.13163280724145, -147.716384887695, -2.57813727543348, 218, 1, 'PPL', 'P'),
(169369, 'Fairbanks Corner', 41.7077789306641, 0.727938066034008, -71.7572174072266, -1.25239970582549, 218, 47, 'PPL', 'P'),
(192563, 'Fairbanks Crossing', 39.7297210693359, 0.693414443558874, -109.732223510742, -1.91518859579678, 218, 52, 'PPL', 'P'),
(72490, 'Fairborn', 39.8208312988281, 0.695004617045761, -84.0194396972656, -1.46641585839811, 218, 41, 'PPL', 'P'),
(64602, 'Fairbrook', 35.7027816772461, 0.623131092388648, -81.2961120605469, -1.41888482452681, 218, 33, 'PPL', 'P'),
(161474, 'Fairbrook', 40.7272186279297, 0.71082406023694, -77.9377822875977, -1.3602709126211, 218, 45, 'PPL', 'P'),
(203939, 'Fairbrook Condominium', 40.6483306884766, 0.70944720595337, -111.843063354492, -1.9520297010525, 218, 52, 'PPL', 'P'),
(20978, 'Fairburn', 33.5669403076172, 0.585853628188318, -84.5811080932617, -1.47621882121264, 218, 13, 'PPL', 'P'),
(174054, 'Fairburn', 43.9711112976074, 0.767440667904126, -89.0372161865234, -1.55399257926482, 218, 57, 'PPL', 'P'),
(202117, 'Fairburn', 43.6861114501953, 0.762466482199103, -103.211112976074, -1.80137374608034, 218, 49, 'PPL', 'P'),
(194909, 'Fairburn (historical)', 46.2538909912109, 0.807282689655174, -116.731109619141, -2.03734220236043, 218, 17, 'PPL', 'P'),
(119582, 'Fairbury', 40.7472190856934, 0.711173134076823, -88.5147171020508, -1.54487324990212, 218, 18, 'PPL', 'P'),
(141797, 'Fairbury', 40.1372184753418, 0.700526614987013, -97.1802825927734, -1.69611589926243, 218, 35, 'PPL', 'P'),
(78229, 'Fairchance', 39.7461090087891, 0.693700467059949, -80.0611114501953, -1.39732999761204, 218, 45, 'PPL', 'P'),
(101802, 'Fairchester', 38.8566703796387, 0.67817683448685, -77.3225021362305, -1.34953224815757, 218, 53, 'PPL', 'P'),
(20980, 'Fairchild', 30.8244400024414, 0.537987968126052, -84.9066696166992, -1.48190094171443, 218, 13, 'PPL', 'P'),
(174055, 'Fairchild', 44.6002807617188, 0.778421746605877, -90.9627838134766, -1.58760007432497, 218, 57, 'PPL', 'P'),
(207378, 'Fairchild', 47.6341705322266, 0.831373112243813, -117.667503356934, -2.05368535617997, 218, 56, 'PPL', 'P'),
(64603, 'Fairchild Heights Subdivision', 36.103328704834, 0.630121956829133, -79.4011077880859, -1.38581076063301, 218, 33, 'PPL', 'P'),
(113418, 'Fairchild Heights Trailer Park', 41.2694396972656, 0.720287603170537, -73.1266708374023, -1.27630117713479, 218, 8, 'PPL', 'P'),
(94142, 'Fairchilds', 29.4311103820801, 0.513669778685184, -95.7799987792969, -1.67167633625488, 218, 51, 'PPL', 'P'),
(59877, 'Fairchilds Crossroads', 32.204719543457, 0.56207839071469, -90.4727783203125, -1.5790478651164, 218, 30, 'PPL', 'P'),
(40865, 'Faircloth', 31.6141700744629, 0.551771358084838, -92.6047210693359, -1.61625728555088, 218, 22, 'PPL', 'P'),
(2365, 'Fairdale', 32.9311103820801, 0.574756302504985, -87.146110534668, -1.52098655913687, 218, 2, 'PPL', 'P'),
(29751, 'Fairdale', 38.3261108398438, 0.668916823639563, -86.1711120605469, -1.50396962556154, 218, 19, 'PPL', 'P'),
(35827, 'Fairdale', 38.1049995422363, 0.665057703482956, -85.7588882446289, -1.49677496271863, 218, 21, 'PPL', 'P'),
(94166, 'Fairdale', 31.2302799224854, 0.545071210966849, -93.6616668701172, -1.63470446978964, 218, 51, 'PPL', 'P'),
(109141, 'Fairdale', 37.7813911437988, 0.659409671443116, -81.3633270263672, -1.42005794698699, 218, 58, 'PPL', 'P'),
(119583, 'Fairdale', 42.0999984741211, 0.734783588458002, -88.9327774047852, -1.55216977865672, 218, 18, 'PPL', 'P'),
(139992, 'Fairdale', 48.4908294677734, 0.846324631235736, -98.230827331543, -1.71445136389346, 218, 34, 'PPL', 'P'),
(148729, 'Fairdale', 43.3236083984375, 0.756139610397402, -76.5391693115234, -1.33586051122749, 218, 40, 'PPL', 'P'),
(155208, 'Fairdale', 40.014720916748, 0.698388629263897, -81.6208267211914, -1.42455216448456, 218, 41, 'PPL', 'P'),
(161475, 'Fairdale', 41.8102798461914, 0.729727044496268, -75.961669921875, -1.32578124544986, 218, 45, 'PPL', 'P'),
(200799, 'Fairdale (historical)', 45.3600006103516, 0.791681359357272, -123.334167480469, -2.1525873027403, 218, 43, 'PPL', 'P'),
(35828, 'Fairdealing', 36.8466682434082, 0.643095679237509, -88.2391662597656, -1.5400639804476, 218, 21, 'PPL', 'P'),
(54699, 'Fairdealing', 36.6627807617188, 0.639886237228827, -90.6166687011719, -1.58155922602434, 218, 29, 'PPL', 'P'),
(13733, 'Fairfax', 39.7863883972168, 0.694403475008703, -75.5436096191406, -1.31848471669526, 218, 10, 'PPL', 'P'),
(20982, 'Fairfax', 31.2602806091309, 0.545594821726672, -82.607780456543, -1.4417777567313, 218, 13, 'PPL', 'P'),
(32401, 'Fairfax', 39.1416702270508, 0.683151020191873, -94.6125030517578, -1.65129969180636, 218, 20, 'PPL', 'P'),
(40866, 'Fairfax', 29.728609085083, 0.518862110572998, -91.3883285522461, -1.59502723113104, 218, 22, 'PPL', 'P'),
(64604, 'Fairfax', 35.4530601501465, 0.618772629527651, -83.8399963378906, -1.46328398095618, 218, 33, 'PPL', 'P'),
(72492, 'Fairfax', 39.047779083252, 0.68151231059412, -83.5875015258789, -1.45887711514237, 218, 41, 'PPL', 'P'),
(75798, 'Fairfax', 36.5736083984375, 0.638329885887785, -96.7038879394531, -1.68780124402309, 218, 42, 'PPL', 'P'),
(80926, 'Fairfax', 32.9588890075684, 0.575241130981434, -81.2366714477539, -1.41784739012417, 218, 48, 'PPL', 'P'),
(101803, 'Fairfax', 38.8461112976074, 0.677992543739416, -77.3066711425781, -1.34925594519448, 218, 53, 'PPL', 'P'),
(109142, 'Fairfax', 39.1888885498047, 0.683975135391198, -79.476936340332, -1.38713421853673, 218, 58, 'PPL', 'P'),
(115515, 'Fairfax', 41.9194412231445, 0.731632269940111, -91.7808303833008, -1.60187768040305, 218, 16, 'PPL', 'P'),
(122593, 'Fairfax', 40.1041717529297, 0.699949840873929, -85.6500015258789, -1.49487453096475, 218, 19, 'PPL', 'P'),
(130749, 'Fairfax', 41.9552803039551, 0.732257779901143, -85.3661117553711, -1.48991971975666, 218, 27, 'PPL', 'P'),
(135303, 'Fairfax', 44.5291709899902, 0.777180646958873, -94.7205581665039, -1.6531856093323, 218, 28, 'PPL', 'P'),
(139151, 'Fairfax', 40.3386116027832, 0.704041588151754, -95.3930587768555, -1.6649229592046, 218, 29, 'PPL', 'P'),
(170270, 'Fairfax', 43.0275001525879, 0.750971546565021, -98.8880615234375, -1.7259222644987, 218, 49, 'PPL', 'P'),
(172003, 'Fairfax', 44.6652793884277, 0.779556186651223, -73.0091705322266, -1.27425040993737, 218, 55, 'PPL', 'P'),
(181515, 'Fairfax', 37.9872207641602, 0.663002076016551, -122.587783813477, -2.13956045026818, 218, 6, 'PPL', 'P'),
(207379, 'Fairfax', 47.0105590820313, 0.820489039184768, -122.014999389648, -2.12956347616824, 218, 56, 'PPL', 'P'),
(101804, 'Fairfax Acres', 38.8716697692871, 0.678438623222005, -77.3186111450195, -1.34946433754977, 218, 53, 'PPL', 'P'),
(172004, 'Fairfax Falls', 44.6502799987793, 0.779294397916068, -72.9883270263672, -1.27388662213247, 218, 55, 'PPL', 'P'),
(101806, 'Fairfax Farms', 38.8691711425781, 0.678395013959155, -77.350830078125, -1.35002666401394, 218, 53, 'PPL', 'P'),
(101807, 'Fairfax Forest', 38.8611106872559, 0.678254332474571, -77.2519378662109, -1.34830066931146, 218, 53, 'PPL', 'P'),
(86873, 'Fairfax Heights', 35.1094398498535, 0.612775323910847, -85.2641677856445, -1.48814046183238, 218, 50, 'PPL', 'P'),
(101808, 'Fairfax Hills', 38.834171295166, 0.677784151384118, -77.2236099243164, -1.34780625345509, 218, 53, 'PPL', 'P'),
(101809, 'Fairfax Park', 38.7775001525879, 0.676795053355262, -77.2408294677734, -1.34810679118411, 218, 53, 'PPL', 'P'),
(101810, 'Fairfax Station', 38.8008308410645, 0.677202250685935, -77.3258285522461, -1.34959030506933, 218, 53, 'PPL', 'P'),
(13093, 'Fairfax Village', 38.8619384765625, 0.678268780123485, -76.9513931274414, -1.34305517407039, 218, 9, 'PPL', 'P'),
(101811, 'Fairfax Woods', 38.8605613708496, 0.678244745094647, -77.3141708374023, -1.34938683956205, 218, 53, 'PPL', 'P'),
(2370, 'Fairfield', 34.4741706848145, 0.601687785344521, -87.1930618286133, -1.52180601380429, 218, 2, 'PPL', 'P'),
(8818, 'Fairfield', 34.2125015258789, 0.597120796970171, -91.8949966430664, -1.60387025753065, 218, 4, 'PPL', 'P'),
(13735, 'Fairfield', 39.6958312988281, 0.692822955480768, -75.7708282470703, -1.3224504298745, 218, 10, 'PPL', 'P'),
(15977, 'Fairfield', 29.3666706085205, 0.51254509246733, -82.2513885498047, -1.43555754453126, 218, 12, 'PPL', 'P'),
(20986, 'Fairfield', 33.5930595397949, 0.586309494787913, -83.8225021362305, -1.4629786495372, 218, 13, 'PPL', 'P'),
(29753, 'Fairfield', 39.5186080932617, 0.689729827032695, -84.9955596923828, -1.48345236620746, 218, 19, 'PPL', 'P'),
(35830, 'Fairfield', 37.9336090087891, 0.662066374367552, -85.3836135864258, -1.49022518433369, 218, 21, 'PPL', 'P'),
(40868, 'Fairfield', 31.5805606842041, 0.551184763565235, -92.5905609130859, -1.61601014420172, 218, 22, 'PPL', 'P'),
(46953, 'Fairfield', 39.5522193908691, 0.690316454841813, -76.9875030517578, -1.34368541114236, 218, 25, 'PPL', 'P'),
(59866, 'Fairfield', 34.4219398498535, 0.600776185303386, -88.841667175293, -1.55057960516983, 218, 30, 'PPL', 'P'),
(64610, 'Fairfield', 35.0602798461914, 0.611917319986651, -80.3874969482422, -1.40302649918372, 218, 33, 'PPL', 'P'),
(75800, 'Fairfield', 35.8472213745117, 0.625652040676517, -94.6122207641602, -1.65129476495834, 218, 42, 'PPL', 'P'),
(86877, 'Fairfield', 36.6197204589844, 0.639134693169206, -86.3455581665039, -1.50701428447777, 218, 50, 'PPL', 'P'),
(94143, 'Fairfield', 31.7244396209717, 0.553695924736098, -96.1650009155273, -1.67839589115931, 218, 51, 'PPL', 'P'),
(101815, 'Fairfield', 37.276668548584, 0.650600600347406, -80.0355606079102, -1.39688405128751, 218, 53, 'PPL', 'P'),
(113419, 'Fairfield', 41.1411094665527, 0.718047818114753, -73.2641677856445, -1.27870095159306, 218, 8, 'PPL', 'P'),
(115517, 'Fairfield', 41.0086097717285, 0.715735262182183, -91.9625015258789, -1.6050484399969, 218, 16, 'PPL', 'P'),
(119585, 'Fairfield', 42.2191696166992, 0.736863517269354, -88.061393737793, -1.5369612646196, 218, 18, 'PPL', 'P'),
(127461, 'Fairfield', 44.5883293151855, 0.778213154513496, -69.5991668701172, -1.2147346185285, 218, 26, 'PPL', 'P'),
(130738, 'Fairfield', 41.8127784729004, 0.729770653759118, -84.0411071777344, -1.4667940272729, 218, 27, 'PPL', 'P'),
(135306, 'Fairfield', 45.3838882446289, 0.792098277225924, -95.9733276367188, -1.67505056135601, 218, 28, 'PPL', 'P'),
(141802, 'Fairfield', 40.4316711425781, 0.705665783521566, -98.1055603027344, -1.71226504179656, 218, 35, 'PPL', 'P'),
(145196, 'Fairfield', 40.2052803039551, 0.701714517991243, -74.2141723632813, -1.29528165938184, 218, 37, 'PPL', 'P'),
(148731, 'Fairfield', 42.2324981689453, 0.737096144390572, -76.2788925170898, -1.33131782419808, 218, 40, 'PPL', 'P'),
(155209, 'Fairfield', 40.439998626709, 0.705811125538057, -80.8147201538086, -1.41048295076178, 218, 41, 'PPL', 'P'),
(161477, 'Fairfield', 40.0133285522461, 0.69836432791895, -80.0713882446289, -1.39750936151146, 218, 45, 'PPL', 'P'),
(172006, 'Fairfield', 44.8019409179688, 0.781941380302525, -72.9461135864258, -1.2731498586169, 218, 55, 'PPL', 'P'),
(174058, 'Fairfield', 42.6330604553223, 0.744087275147166, -88.7763900756836, -1.5494403048555, 218, 57, 'PPL', 'P'),
(181516, 'Fairfield', 38.249439239502, 0.667578651770825, -122.038887023926, -2.12998039403689, 218, 6, 'PPL', 'P'),
(194910, 'Fairfield', 43.3466682434082, 0.75654208061714, -114.790832519531, -2.0034779785712, 218, 17, 'PPL', 'P'),
(196452, 'Fairfield', 47.6147193908691, 0.831033625783855, -111.979438781738, -1.95440990127676, 218, 31, 'PPL', 'P'),
(198273, 'Fairfield', 47.1894416809082, 0.823611129509696, -103.221672058105, -1.80155803682777, 218, 34, 'PPL', 'P'),
(200800, 'Fairfield', 45.1347198486328, 0.787749468323879, -123.004997253418, -2.14684219847873, 218, 43, 'PPL', 'P'),
(203919, 'Fairfield', 40.2622184753418, 0.702708276552006, -112.092216491699, -1.95637824363844, 218, 52, 'PPL', 'P'),
(207380, 'Fairfield', 47.3852806091309, 0.827029163610758, -117.170562744141, -2.04501210629986, 218, 56, 'PPL', 'P'),
(2371, 'Fairfield (historical)', 34.7661094665527, 0.606783078300115, -85.9986114501953, -1.5009589219492, 218, 2, 'PPL', 'P'),
(54700, 'Fairfield (historical)', 38.1513900756836, 0.665867371033367, -93.394172668457, -1.63003581524067, 218, 29, 'PPL', 'P'),
(72494, 'Fairfield Acres', 38.8250007629395, 0.677624095402604, -82.2758331298828, -1.43598418293789, 218, 41, 'PPL', 'P'),
(80930, 'Fairfield Acres', 34.7730598449707, 0.606904385287768, -82.3944396972656, -1.43805425805321, 218, 48, 'PPL', 'P'),
(86879, 'Fairfield Acres', 36.2627792358398, 0.632904893589239, -83.2377777099609, -1.45277328308196, 218, 50, 'PPL', 'P'),
(8819, 'Fairfield Bay', 35.5941696166992, 0.621235454324729, -92.2777786254883, -1.61055106344122, 218, 4, 'PPL', 'P'),
(72495, 'Fairfield Beach', 39.915828704834, 0.696662634561417, -82.4752807617188, -1.43946520079873, 218, 41, 'PPL', 'P'),
(122594, 'Fairfield Center', 41.4824981689453, 0.724006175000615, -85.128059387207, -1.48576492214003, 218, 19, 'PPL', 'P'),
(127462, 'Fairfield Center', 44.6061096191406, 0.778523479359518, -69.663330078125, -1.21585447776688, 218, 26, 'PPL', 'P'),
(193228, 'Fairfield Condominium', 41.0680618286133, 0.716772896321905, -111.948890686035, -1.95387673642653, 218, 52, 'PPL', 'P'),
(13736, 'Fairfield Crest', 39.6958312988281, 0.692822955480768, -75.7624969482422, -1.32230502127898, 218, 10, 'PPL', 'P'),
(86880, 'Fairfield Estates', 35.899169921875, 0.626558713869634, -86.3613891601563, -1.50729058744087, 218, 50, 'PPL', 'P'),
(13737, 'Fairfield Farms', 39.1230583190918, 0.68282618111791, -75.5263900756836, -1.31818417896625, 218, 10, 'PPL', 'P'),
(20988, 'Fairfield Farms', 33.8930587768555, 0.59154546922809, -84.0111083984375, -1.46627044980259, 218, 13, 'PPL', 'P'),
(86881, 'Fairfield Glade', 36.0002784729004, 0.628323390986948, -84.8863906860352, -1.48154700760556, 218, 50, 'PPL', 'P'),
(20989, 'Fairfield Glen', 33.6208305358887, 0.586794190106307, -84.227783203125, -1.47005213855051, 218, 13, 'PPL', 'P'),
(64612, 'Fairfield Harbour', 35.0763893127441, 0.612198483218736, -76.9638900756836, -1.34327328696367, 218, 33, 'PPL', 'P'),
(46955, 'Fairfield Heights', 39.3141708374023, 0.686161723804207, -77.2966690063477, -1.34908137498502, 218, 25, 'PPL', 'P'),
(161478, 'Fairfield Heights', 40.4683303833008, 0.706305607973458, -79.179443359375, -1.38194198651745, 218, 45, 'PPL', 'P'),
(2373, 'Fairfield Highlands', 33.4533309936523, 0.5838707715987, -86.942497253418, -1.51743283697827, 218, 2, 'PPL', 'P'),
(46956, 'Fairfield Homes', 39.235279083252, 0.684784802941609, -76.5861129760742, -1.33667983273685, 218, 25, 'PPL', 'P'),
(20990, 'Fairfield Lakes', 33.6327781677246, 0.58700271561966, -84.2555618286133, -1.47053696702696, 218, 13, 'PPL', 'P'),
(101816, 'Fairfield Landing', 37.5394401550293, 0.655186830060632, -76.4763870239258, -1.33476475359697, 218, 53, 'PPL', 'P'),
(64613, 'Fairfield Mountains', 35.4655609130859, 0.618990808999956, -82.1916732788086, -1.43451531643865, 218, 33, 'PPL', 'P'),
(101818, 'Fairfield Park', 36.6605606079102, 0.639847488234966, -79.4175033569336, -1.38609691729214, 218, 53, 'PPL', 'P'),
(80934, 'Fairfield Terrace', 34.0791702270508, 0.59479372680966, -81.0277786254883, -1.41420152259186, 218, 48, 'PPL', 'P'),
(2374, 'Fairfield Village', 33.4752807617188, 0.584253867321508, -86.9124984741211, -1.51690925950796, 218, 2, 'PPL', 'P'),
(46957, 'Fairfields', 39.6875, 0.69267754688525, -75.9652786254883, -1.32584422920964, 218, 25, 'PPL', 'P'),
(101819, 'Fairfields', 37.2980613708496, 0.650973975532235, -79.2516708374023, -1.38320259381944, 218, 53, 'PPL', 'P'),
(78234, 'Fairfiled', 39.7847213745117, 0.694374379973793, -76.2247161865234, -1.33037226885305, 218, 45, 'PPL', 'P'),
(2375, 'Fairford', 31.1680603027344, 0.543985273742855, -88.0641708374023, -1.53700973415144, 218, 2, 'PPL', 'P'),
(80936, 'Fairforest', 34.9563903808594, 0.610104106758471, -82.0102767944336, -1.43134935053477, 218, 48, 'PPL', 'P'),
(27129, 'Fairgrange', 39.5786094665527, 0.690777048552342, -88.1716690063477, -1.5388859311394, 218, 18, 'PPL', 'P'),
(46958, 'Fairgreen', 38.7633285522461, 0.676547712269021, -76.8024978637695, -1.34045646147869, 218, 25, 'PPL', 'P'),
(46959, 'Fairgreen Acres', 39.6797218322754, 0.692541792248683, -77.7130584716797, -1.35634874212568, 218, 25, 'PPL', 'P'),
(64617, 'Fairgrove', 35.707218170166, 0.623208523797342, -81.2655563354492, -1.41835152651853, 218, 33, 'PPL', 'P'),
(101820, 'Fairgrove', 38.1344413757324, 0.665571560415287, -78.5236129760742, -1.37049558699424, 218, 53, 'PPL', 'P'),
(130741, 'Fairgrove', 43.523609161377, 0.759630282217196, -83.543327331543, -1.45810613000679, 218, 27, 'PPL', 'P'),
(46963, 'Fairhaven', 39.5397186279297, 0.690098275369508, -77.2569427490234, -1.34838802099522, 218, 25, 'PPL', 'P'),
(59869, 'Fairhaven', 34.9338912963867, 0.609711423655738, -89.7986068725586, -1.56728135363016, 218, 30, 'PPL', 'P'),
(72502, 'Fairhaven', 39.6388893127441, 0.691829130340978, -84.7716674804688, -1.47954470993999, 218, 41, 'PPL', 'P'),
(124802, 'Fairhaven', 41.6375007629395, 0.726711480614944, -70.904167175293, -1.23751117059335, 218, 23, 'PPL', 'P'),
(135309, 'Fairhaven', 45.3216705322266, 0.791012373291444, -94.2111129760742, -1.64429411340085, 218, 28, 'PPL', 'P'),
(177218, 'Fairhaven', 40.5616683959961, 0.707934663612259, -80.5602798461914, -1.40604212964407, 218, 58, 'PPL', 'P'),
(193540, 'Fairhaven', 40.7852783203125, 0.711837393031716, -124.201667785645, -2.16772803932767, 218, 6, 'PPL', 'P'),
(200801, 'Fairhaven', 42.1833305358887, 0.736238007308321, -121.821937561035, -2.12619391159901, 218, 43, 'PPL', 'P'),
(209954, 'Fairhaven', 58.378059387207, 1.01888934723155, -134.70361328125, -2.35102156609097, 218, 1, 'PPL', 'P'),
(46964, 'Fairhaven Beach', 39.1455612182617, 0.68321893079967, -76.4936065673828, -1.33506529132599, 218, 25, 'PPL', 'P'),
(46965, 'Fairhaven-on-the-Bay', 38.7516708374023, 0.676344246761739, -76.5563888549805, -1.3361610489565, 218, 25, 'PPL', 'P'),
(46966, 'Fairhill', 39.209171295166, 0.684329136079096, -77.0999984741211, -1.34564882665602, 218, 25, 'PPL', 'P'),
(59870, 'Fairhill', 32.9441719055176, 0.574984269094296, -88.6650009155273, -1.54749619725974, 218, 30, 'PPL', 'P'),
(80937, 'Fairhill', 33.9566688537598, 0.592655674507517, -81.1244430541992, -1.41588863514242, 218, 48, 'PPL', 'P'),
(143816, 'Fairhill Manor', 43.0313911437988, 0.751039457172818, -70.725830078125, -1.23439860106932, 218, 36, 'PPL', 'P'),
(2376, 'Fairhope', 30.5227794647217, 0.532722998519506, -87.9033279418945, -1.53420249604639, 218, 2, 'PPL', 'P'),
(20991, 'Fairhope', 31.5372200012207, 0.550428325947111, -81.3888931274414, -1.42050415962764, 218, 13, 'PPL', 'P'),
(101821, 'Fairhope', 37.3066711425781, 0.651124244396743, -79.9911117553711, -1.39610827246197, 218, 53, 'PPL', 'P'),
(155213, 'Fairhope', 40.8288917541504, 0.712598591050288, -81.2988891601563, -1.41893329405865, 218, 41, 'PPL', 'P'),
(161482, 'Fairhope', 40.1136093139648, 0.70011455738735, -79.8399963378906, -1.39347081087641, 218, 45, 'PPL', 'P'),
(20993, 'Fairington', 33.3783302307129, 0.582561761343898, -82.0919418334961, -1.43277467435018, 218, 13, 'PPL', 'P'),
(20994, 'Fairington Estates', 33.5222206115723, 0.585073122251843, -82.1958312988281, -1.43458788757836, 218, 13, 'PPL', 'P'),
(46967, 'Fairknoll', 39.0761108398438, 0.68200679302952, -76.9830627441406, -1.34360791315464, 218, 25, 'PPL', 'P'),
(8820, 'Fairland', 33.2305603027344, 0.579982689565238, -93.8436126708984, -1.63788002307345, 218, 4, 'PPL', 'P'),
(27130, 'Fairland', 39.8763885498047, 0.695974273998659, -88.1016693115234, -1.53766420598933, 218, 18, 'PPL', 'P'),
(29755, 'Fairland', 39.5858306884766, 0.69090308265093, -85.8636093139648, -1.49860269017476, 218, 19, 'PPL', 'P'),
(46968, 'Fairland', 39.0761108398438, 0.68200679302952, -76.9580612182617, -1.34317155421003, 218, 25, 'PPL', 'P'),
(72503, 'Fairland', 38.4438896179199, 0.670972451105967, -82.3675003051758, -1.43758407696275, 218, 41, 'PPL', 'P'),
(75801, 'Fairland', 36.7511100769043, 0.641427874604846, -94.8472213745117, -1.65539629935317, 218, 42, 'PPL', 'P'),
(94144, 'Fairland', 30.6438903808594, 0.534836782766215, -98.2844390869141, -1.71538706554246, 218, 51, 'PPL', 'P'),
(101823, 'Fairland', 37.3025016784668, 0.651051473519957, -79.9711074829102, -1.39575913204306, 218, 53, 'PPL', 'P'),
(130744, 'Fairland', 41.899169921875, 0.731278468989294, -86.2822189331055, -1.50590880630928, 218, 27, 'PPL', 'P'),
(135310, 'Fairland', 48.4674987792969, 0.845917433905063, -94.1544418334961, -1.64330501537199, 218, 28, 'PPL', 'P'),
(161483, 'Fairland', 40.1483306884766, 0.700720559693398, -76.3547210693359, -1.3326412821018, 218, 45, 'PPL', 'P'),
(46969, 'Fairland Heights', 39.0847206115723, 0.682157061894028, -76.961669921875, -1.34323453796981, 218, 25, 'PPL', 'P'),
(2377, 'Fairlane', 31.2083301544189, 0.544688115244041, -85.3775024414063, -1.49011852473204, 218, 2, 'PPL', 'P'),
(20995, 'Fairlane', 33.5480613708496, 0.585524128582448, -84.2555618286133, -1.47053696702696, 218, 13, 'PPL', 'P'),
(40869, 'Fairlane', 29.6836109161377, 0.518076744367533, -90.7866668701172, -1.5845262537948, 218, 22, 'PPL', 'P'),
(64618, 'Fairlane', 35.5827789306641, 0.621036649349355, -77.3925018310547, -1.35075397330764, 218, 33, 'PPL', 'P'),
(86883, 'Fairlane', 35.6269416809082, 0.621807434747851, -84.454719543457, -1.47401292488173, 218, 50, 'PPL', 'P'),
(15978, 'Fairlane Estates', 28.753059387207, 0.501835556328226, -81.2969436645508, -1.41889933875476, 218, 12, 'PPL', 'P'),
(86884, 'Fairlane Estates', 35.5038909912109, 0.619659795065784, -86.478889465332, -1.50934135463828, 218, 50, 'PPL', 'P'),
(124804, 'Fairlane Mobile Home Park', 42.5938911437988, 0.743403641695343, -71.6708297729492, -1.25089195717434, 218, 23, 'PPL', 'P'),
(13090, 'Fairlawn', 38.8708305358887, 0.678423975836009, -76.9791717529297, -1.34354000254684, 218, 9, 'PPL', 'P'),
(15979, 'Fairlawn', 26.2991695404053, 0.459007099020276, -80.1005630493164, -1.39801855791188, 218, 12, 'PPL', 'P'),
(101825, 'Fairlawn', 37.1483306884766, 0.648360682133568, -80.57861328125, -1.40636210844904, 218, 53, 'PPL', 'P'),
(124805, 'Fairlawn', 42.2750015258789, 0.737837967912214, -71.7416687011719, -1.25212832971041, 218, 23, 'PPL', 'P'),
(155214, 'Fairlawn', 41.1277809143066, 0.717815190993535, -81.6100006103516, -1.42436321320522, 218, 41, 'PPL', 'P'),
(161484, 'Fairlawn', 41.292781829834, 0.720695000238292, -77.0622177124023, -1.34498942797011, 218, 45, 'PPL', 'P'),
(169370, 'Fairlawn', 41.8761100769043, 0.730875998769556, -71.413330078125, -1.24639773967678, 218, 47, 'PPL', 'P'),
(199948, 'Fairlawn (historical)', 41.1722183227539, 0.718590770081993, -116.775001525879, -2.03810826064799, 218, 39, 'PPL', 'P'),
(20996, 'Fairlawn Acres', 34.9461097717285, 0.609924676280027, -85.2538909912109, -1.48796109793296, 218, 13, 'PPL', 'P'),
(20997, 'Fairlawn Estates', 33.5538902282715, 0.585625861336089, -85.1180572509766, -1.48559035193057, 218, 13, 'PPL', 'P'),
(101826, 'Fairlawn Estates', 36.857780456543, 0.643289623943894, -76.1997222900391, -1.3299360430665, 218, 53, 'PPL', 'P'),
(101827, 'Fairlawn Heights', 37.5416717529297, 0.655225778791574, -77.3086090087891, -1.34928976734032, 218, 53, 'PPL', 'P'),
(80940, 'Fairlawn Terrace', 32.9749984741211, 0.575522294213519, -80.1402816772461, -1.39871177874363, 218, 48, 'PPL', 'P'),
(109143, 'Fairlea', 37.7805595397949, 0.659395157215175, -80.4572219848633, -1.40424343064383, 218, 58, 'PPL', 'P'),
(99, 'Fairlee', 38.8736114501953, 0.678472511946876, -77.2716674804688, -1.34864501604041, 218, 53, 'PPL', 'P'),
(46970, 'Fairlee', 39.2224998474121, 0.684561763200315, -76.1722183227539, -1.32945600828001, 218, 25, 'PPL', 'P'),
(172009, 'Fairlee', 43.9075012207031, 0.766330462624699, -72.1438903808594, -1.25914842234386, 218, 55, 'PPL', 'P'),
(161485, 'Fairless Hills', 40.1794395446777, 0.701263511660638, -74.8555603027344, -1.30647599070788, 218, 45, 'PPL', 'P'),
(161486, 'Fairless Junction', 40.1763916015625, 0.701210315017863, -74.8974990844727, -1.30720796053349, 218, 45, 'PPL', 'P'),
(94145, 'Fairlie', 33.3133316040039, 0.581427321298552, -95.9580612182617, -1.67478411208895, 218, 51, 'PPL', 'P'),
(8821, 'Fairman', 34.7788887023926, 0.607006118041409, -92.2119369506836, -1.60940190943085, 218, 4, 'PPL', 'P'),
(27131, 'Fairman', 38.6777801513672, 0.675054611003868, -89.1047210693359, -1.55517076173107, 218, 18, 'PPL', 'P'),
(181517, 'Fairmead', 37.0763893127441, 0.647105068258623, -120.191940307617, -2.09774509272841, 218, 6, 'PPL', 'P'),
(35831, 'Fairmeade', 38.2488899230957, 0.667569064390901, -85.6338882446289, -1.49459330115364, 218, 21, 'PPL', 'P'),
(203925, 'Fairmeadows Condo', 40.625560760498, 0.709049795739702, -111.870277404785, -1.95250467583292, 218, 52, 'PPL', 'P'),
(32404, 'Fairmont', 39.1769409179688, 0.683766609877844, -96.5486068725586, -1.68509107813977, 218, 20, 'PPL', 'P'),
(35832, 'Fairmont', 37.4599990844727, 0.653800321818109, -87.8499984741211, -1.53327172124541, 218, 21, 'PPL', 'P'),
(46972, 'Fairmont', 39.521671295166, 0.689783289991579, -76.3333282470703, -1.33226790691697, 218, 25, 'PPL', 'P'),
(64621, 'Fairmont', 34.4966697692871, 0.602080468447253, -79.1144409179688, -1.38080747989308, 218, 33, 'PPL', 'P'),
(75802, 'Fairmont', 36.3555603027344, 0.634524228690061, -97.7052764892578, -1.70527877130896, 218, 42, 'PPL', 'P'),
(78236, 'Fairmont', 39.9413909912109, 0.697108780623032, -79.4413909912109, -1.38651383516079, 218, 45, 'PPL', 'P'),
(80941, 'Fairmont', 34.899169921875, 0.609105421349691, -82.0580596923828, -1.43218331943013, 218, 48, 'PPL', 'P'),
(86886, 'Fairmont', 35.9205589294434, 0.626932022475436, -86.3863906860352, -1.50772694638548, 218, 50, 'PPL', 'P'),
(109144, 'Fairmont', 39.4850006103516, 0.689143265802605, -80.1427764892578, -1.39875532142745, 218, 58, 'PPL', 'P'),
(119588, 'Fairmont', 41.5561103820801, 0.725290950489496, -88.0591735839844, -1.53692251562574, 218, 18, 'PPL', 'P'),
(135311, 'Fairmont', 43.6522216796875, 0.761874994120996, -94.4608306884766, -1.64865250968282, 218, 28, 'PPL', 'P'),
(139152, 'Fairmont', 40.3313903808594, 0.703915554053166, -91.9097213745117, -1.60412725257584, 218, 29, 'PPL', 'P'),
(141805, 'Fairmont', 40.6369400024414, 0.709248400977995, -97.5849990844727, -1.7031795345797, 218, 35, 'PPL', 'P'),
(191448, 'Fairmont', 34.253059387207, 0.597828665187914, -101.059440612793, -1.76381997891691, 218, 51, 'PPL', 'P'),
(192900, 'Fairmont', 34.7347183227539, 0.606235199484858, -118.423889160156, -2.06688677886155, 218, 6, 'PPL', 'P'),
(203926, 'Fairmont', 41.2408294677734, 0.719788260466147, -111.90193939209, -1.95305728175911, 218, 52, 'PPL', 'P'),
(207383, 'Fairmont', 47.9022216796875, 0.836051487330755, -122.253059387207, -2.13371840694292, 218, 56, 'PPL', 'P'),
(27133, 'Fairmont City', 38.6497192382813, 0.674564855679403, -90.0930633544922, -1.57242058874374, 218, 18, 'PPL', 'P'),
(161487, 'Fairmont City', 41.0080604553223, 0.715725674802259, -79.3133316040039, -1.38427877721594, 218, 45, 'PPL', 'P'),
(135312, 'Fairmont Estates', 43.6680603027344, 0.762151430242147, -94.4430618286133, -1.64834238457388, 218, 28, 'PPL', 'P'),
(196453, 'Fairmont Hot Springs', 46.0430603027344, 0.803602999977012, -112.809173583984, -1.96889150549434, 218, 31, 'PPL', 'P'),
(80942, 'Fairmont Mills', 34.9286117553711, 0.609619278282022, -82.0599975585938, -1.43221714157597, 218, 48, 'PPL', 'P'),
(109146, 'Fairmor', 39.6319389343262, 0.691707823353324, -79.9866714477539, -1.39603077447425, 218, 58, 'PPL', 'P'),
(2379, 'Fairmount', 34.8030586242676, 0.607427962758077, -86.8769378662109, -1.51628860981592, 218, 2, 'PPL', 'P'),
(8823, 'Fairmount', 34.5955581665039, 0.603806396570706, -91.5988922119141, -1.59870226027729, 218, 4, 'PPL', 'P'),
(13744, 'Fairmount', 38.666389465332, 0.674855806028494, -75.2216720581055, -1.31286584626936, 218, 10, 'PPL', 'P'),
(20998, 'Fairmount', 34.4361114501953, 0.601023526389628, -84.6999969482422, -1.47829382317598, 218, 13, 'PPL', 'P'),
(32405, 'Fairmount', 39.1916694641113, 0.684023671502064, -94.9352798461914, -1.65693320961826, 218, 20, 'PPL', 'P'),
(35833, 'Fairmount', 38.1163902282715, 0.66525650845833, -85.5708312988281, -1.49349274983317, 218, 21, 'PPL', 'P'),
(40871, 'Fairmount', 31.4375, 0.548687883595717, -92.6774978637695, -1.61752748023279, 218, 22, 'PPL', 'P'),
(46974, 'Fairmount', 38.0902786254883, 0.664800775016791, -75.8177795410156, -1.32326988454192, 218, 25, 'PPL', 'P'),
(54702, 'Fairmount', 39.1105613708496, 0.682608068224633, -94.4627838134766, -1.64868659814477, 218, 29, 'PPL', 'P'),
(86888, 'Fairmount', 36.5849990844727, 0.638528690863159, -82.1711120605469, -1.43415645548177, 218, 50, 'PPL', 'P'),
(94146, 'Fairmount', 31.1966705322266, 0.544484616447245, -93.7330627441406, -1.63595056286369, 218, 51, 'PPL', 'P'),
(101828, 'Fairmount', 37.2861099243164, 0.650765383439855, -79.9250030517578, -1.39495445791969, 218, 53, 'PPL', 'P'),
(113422, 'Fairmount', 41.586109161377, 0.725814527959806, -73.0558319091797, -1.27506480459872, 218, 8, 'PPL', 'P'),
(119589, 'Fairmount', 40.0455589294434, 0.698926854120202, -87.8305587768555, -1.53293243452253, 218, 18, 'PPL', 'P'),
(122597, 'Fairmount', 40.4152793884277, 0.705379693441464, -85.6505584716797, -1.49488425150273, 218, 19, 'PPL', 'P'),
(124806, 'Fairmount', 42.2513885498047, 0.737425843733524, -71.1152801513672, -1.24119578711953, 218, 23, 'PPL', 'P'),
(127464, 'Fairmount', 46.6963882446289, 0.81500572365835, -67.8680572509766, -1.18452105596155, 218, 26, 'PPL', 'P'),
(139995, 'Fairmount', 46.0550003051758, 0.803811392332311, -96.601936340332, -1.68602185294076, 218, 34, 'PPL', 'P'),
(145199, 'Fairmount', 40.7416687011719, 0.711076261592171, -74.773063659668, -1.30503615266453, 218, 37, 'PPL', 'P'),
(148733, 'Fairmount', 43.0472183227539, 0.751315693556887, -76.2388916015625, -1.33061967651832, 218, 40, 'PPL', 'P'),
(155216, 'Fairmount', 41.5158309936523, 0.724587942540742, -81.5694427490234, -1.42365534498747, 218, 41, 'PPL', 'P'),
(161490, 'Fairmount', 40.3222198486328, 0.703755498071652, -79.7133331298828, -1.39126012085553, 218, 45, 'PPL', 'P'),
(203927, 'Fairmount', 41.2419395446777, 0.719807634963078, -111.898612976074, -1.95299922484735, 218, 52, 'PPL', 'P'),
(46975, 'Fairmount Heights', 38.9008293151855, 0.678947553306319, -76.9158325195313, -1.34243452437835, 218, 25, 'PPL', 'P'),
(46976, 'Fairmount North', 39.6419410705566, 0.691882393562779, -76.834716796875, -1.34101878794286, 218, 25, 'PPL', 'P'),
(101829, 'Fairmount Park', 36.8783302307129, 0.6436482851637, -76.2555618286133, -1.33091062686741, 218, 53, 'PPL', 'P'),
(161491, 'Fairmount Springs', 41.2477798461914, 0.7199095674538, -76.307502746582, -1.33181716690247, 218, 45, 'PPL', 'P'),
(2380, 'Fairnelson', 31.5636100769043, 0.550888919657641, -87.0766677856445, -1.51977455452478, 218, 2, 'PPL', 'P'),
(64624, 'Fairntosh', 36.1061096191406, 0.63017049294, -78.850830078125, -1.37620660279386, 218, 33, 'PPL', 'P'),
(46977, 'Fairoaks', 39.0852813720703, 0.682166849011034, -76.5338897705078, -1.33576836585377, 218, 25, 'PPL', 'P'),
(161494, 'Fairoaks', 40.1766700744629, 0.701215175286853, -75.1258316040039, -1.31119311478868, 218, 45, 'PPL', 'P'),
(181518, 'Fairoaks', 35.1186103820801, 0.612935379892361, -120.601387023926, -2.10489128603947, 218, 6, 'PPL', 'P'),
(203931, 'Fairoaks', 40.5958290100098, 0.708530878801301, -111.873062133789, -1.95255327852281, 218, 52, 'PPL', 'P'),
(181519, 'Fairoaks Bridge (historical)', 38.6338882446289, 0.674288552716307, -121.262222290039, -2.11642503724644, 218, 6, 'PPL', 'P'),
(101830, 'Fairpines', 37.4377784729004, 0.653412498984366, -77.5180587768555, -1.35294535541062, 218, 53, 'PPL', 'P'),
(109147, 'Fairplain', 38.752498626709, 0.676358694410653, -81.6861114501953, -1.42569159795695, 218, 58, 'PPL', 'P'),
(161495, 'Fairplain', 42.0380592346191, 0.733702544792511, -80.3036117553711, -1.40156242637445, 218, 45, 'PPL', 'P'),
(64625, 'Fairplains', 36.1983299255371, 0.631780040923816, -81.1530609130859, -1.41638811100487, 218, 33, 'PPL', 'P'),
(21000, 'Fairplay', 33.6877784729004, 0.587962652034579, -83.5830612182617, -1.45879961715465, 218, 13, 'PPL', 'P'),
(35834, 'Fairplay', 37.0122184753418, 0.64598507586219, -85.3038864135742, -1.48883368266413, 218, 21, 'PPL', 'P'),
(46979, 'Fairplay', 39.5363883972168, 0.690040151878717, -77.7477798461914, -1.35695474443173, 218, 25, 'PPL', 'P'),
(78239, 'Fairplay', 39.7422218322754, 0.693632623031179, -77.2861099243164, -1.34889708423759, 218, 45, 'PPL', 'P'),
(101831, 'Fairplay', 37.8372192382813, 0.660384055506949, -76.6197204589844, -1.33726639396694, 218, 53, 'PPL', 'P'),
(155217, 'Fairplay', 40.3627815246582, 0.704463432868423, -80.8161087036133, -1.4105071855277, 218, 41, 'PPL', 'P'),
(186698, 'Fairplay', 39.2247200012207, 0.684600512194176, -106.001388549805, -1.85007324187991, 218, 7, 'PPL', 'P'),
(8824, 'Fairplay (historical)', 34.5311088562012, 0.602681543905284, -92.6847229003906, -1.6176535809104, 218, 4, 'PPL', 'P'),
(46980, 'Fairplay Farms', 39.5347213745117, 0.690011056843808, -77.7766723632813, -1.35745901398414, 218, 25, 'PPL', 'P'),
(80943, 'Fairplay Shores', 34.5050010681152, 0.602225877042771, -83.0447235107422, -1.4494038516708, 218, 48, 'PPL', 'P'),
(155218, 'Fairpoint', 40.1202812194824, 0.700231004106014, -80.9330596923828, -1.41254836534519, 218, 41, 'PPL', 'P'),
(202109, 'Fairpoint', 44.7483291625977, 0.781005678653526, -102.796112060547, -1.7941306137056, 218, 49, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(32409, 'Fairport', 39.0458297729492, 0.681478288711194, -99.0302810668945, -1.72840446379271, 218, 20, 'PPL', 'P'),
(54703, 'Fairport', 39.9877815246582, 0.697918448173444, -94.345832824707, -1.64664541832728, 218, 29, 'PPL', 'P'),
(64626, 'Fairport', 36.2272186279297, 0.632284243897196, -78.522216796875, -1.37047121907026, 218, 33, 'PPL', 'P'),
(101832, 'Fairport', 37.8333282470703, 0.660316144899152, -76.2905578613281, -1.33152142286342, 218, 53, 'PPL', 'P'),
(115525, 'Fairport', 41.4358291625977, 0.723191647181214, -90.9044418334961, -1.58658181468218, 218, 16, 'PPL', 'P'),
(130746, 'Fairport', 45.6211090087891, 0.796238560614616, -86.658332824707, -1.51247323208022, 218, 27, 'PPL', 'P'),
(148734, 'Fairport', 43.0986099243164, 0.752212646212025, -77.4422225952148, -1.35162176434885, 218, 40, 'PPL', 'P'),
(193541, 'Fairport', 41.985279083252, 0.732781357371453, -120.320831298828, -2.0999946649012, 218, 6, 'PPL', 'P'),
(59871, 'Fairport (historical)', 33.2783317565918, 0.580816458723515, -88.6986083984375, -1.54808275848983, 218, 30, 'PPL', 'P'),
(155219, 'Fairport Harbor', 41.75, 0.728674962707633, -81.274169921875, -1.41850186196206, 218, 41, 'PPL', 'P'),
(80944, 'Fairs Crossroads', 34.2811088562012, 0.598318220775298, -82.4319381713867, -1.43870872989109, 218, 48, 'PPL', 'P'),
(13738, 'Fairthorne', 39.7727813720703, 0.694165987618495, -75.6036071777344, -1.31953187163588, 218, 10, 'PPL', 'P'),
(70804, 'Fairton', 39.3816719055176, 0.687339839691431, -75.2202835083008, -1.31284161150344, 218, 37, 'PPL', 'P'),
(80945, 'Fairtraid', 33.8736114501953, 0.591206049347159, -78.9797210693359, -1.37845617496665, 218, 48, 'PPL', 'P'),
(21001, 'Fairvale', 33.4041709899902, 0.583012767674503, -82.0155563354492, -1.43144149590848, 218, 13, 'PPL', 'P'),
(75804, 'Fairvalley', 36.7355613708496, 0.641156498489767, -99.024169921875, -1.72829780419105, 218, 42, 'PPL', 'P'),
(2399, 'Fairview', 34.1408309936523, 0.595869910206161, -87.3572235107422, -1.52467117566305, 218, 2, 'PPL', 'P'),
(8834, 'Fairview', 34.1513900756836, 0.596054200953594, -94.2561111450195, -1.64507947960631, 218, 4, 'PPL', 'P'),
(13739, 'Fairview', 39.1694412231445, 0.683635715510267, -75.5361099243164, -1.31835382232769, 218, 10, 'PPL', 'P'),
(15981, 'Fairview', 29.7211093902588, 0.51873121620542, -81.5800018310547, -1.42383963573491, 218, 12, 'PPL', 'P'),
(21008, 'Fairview', 34.9455604553223, 0.609915088900102, -85.2844390869141, -1.4884942627832, 218, 13, 'PPL', 'P'),
(32410, 'Fairview', 39.8411102294922, 0.695358551154632, -95.727783203125, -1.67076500252986, 218, 20, 'PPL', 'P'),
(35840, 'Fairview', 36.5999984741211, 0.638790479598314, -84.1116714477539, -1.46802560611901, 218, 21, 'PPL', 'P'),
(40872, 'Fairview', 31.3250007629395, 0.546724401503029, -91.5322189331055, -1.59753859203898, 218, 22, 'PPL', 'P'),
(46987, 'Fairview', 39.7036094665527, 0.692958710117335, -78.1780624389648, -1.36446459238965, 218, 25, 'PPL', 'P'),
(54707, 'Fairview', 37.2983283996582, 0.650978636064143, -92.1636123657227, -1.60855848631362, 218, 29, 'PPL', 'P'),
(59875, 'Fairview', 34.4000015258789, 0.60039328931766, -89.0869369506836, -1.55486037030603, 218, 30, 'PPL', 'P'),
(64632, 'Fairview', 35.1383285522461, 0.613279526884227, -80.5377807617188, -1.40564944654134, 218, 33, 'PPL', 'P'),
(75805, 'Fairview', 36.2688903808594, 0.633011553190896, -98.4794387817383, -1.71879045225753, 218, 42, 'PPL', 'P'),
(80949, 'Fairview', 34.7458305358887, 0.606429144191243, -82.9686126708984, -1.44807546691906, 218, 48, 'PPL', 'P'),
(86915, 'Fairview', 35.9819412231445, 0.628003345602948, -87.1213912963867, -1.52055512704028, 218, 50, 'PPL', 'P'),
(101843, 'Fairview', 36.8566703796387, 0.643270249446963, -81.2763900756836, -1.41854061095592, 218, 53, 'PPL', 'P'),
(109155, 'Fairview', 39.5397186279297, 0.690098275369508, -80.5500030517578, -1.40586276574465, 218, 58, 'PPL', 'P'),
(115527, 'Fairview', 42.0780601501465, 0.734400692472276, -91.329719543457, -1.59400431095634, 218, 16, 'PPL', 'P'),
(119590, 'Fairview', 40.6333312988281, 0.709185417218215, -90.1636123657227, -1.57365190127373, 218, 18, 'PPL', 'P'),
(122599, 'Fairview', 40.2980613708496, 0.703333853092065, -85.1952819824219, -1.48693817775826, 218, 19, 'PPL', 'P'),
(124807, 'Fairview', 42.2041702270508, 0.736601728534199, -72.5749969482422, -1.26667265137166, 218, 23, 'PPL', 'P'),
(130747, 'Fairview', 44.7249984741211, 0.780598481322853, -84.0511093139648, -1.46696859748236, 218, 27, 'PPL', 'P'),
(143817, 'Fairview', 44.0152816772461, 0.768211586460676, -71.6777801513672, -1.251013264162, 218, 36, 'PPL', 'P'),
(145203, 'Fairview', 40.4333305358887, 0.705694745398421, -74.7177810668945, -1.30407128940159, 218, 37, 'PPL', 'P'),
(148738, 'Fairview', 42.6794395446777, 0.744896742960496, -78.0366668701172, -1.36199677416552, 218, 40, 'PPL', 'P'),
(155221, 'Fairview', 40.0569381713867, 0.699125459358495, -81.2330627441406, -1.41778440636439, 218, 41, 'PPL', 'P'),
(161507, 'Fairview', 40.7838897705078, 0.711813158265796, -76.5702819824219, -1.33640352977375, 218, 45, 'PPL', 'P'),
(170276, 'Fairview', 43.2216682434082, 0.754360419052147, -96.4897232055664, -1.68406336427511, 218, 49, 'PPL', 'P'),
(174060, 'Fairview', 43.3680610656738, 0.756915455801969, -90.9427795410156, -1.58725093390606, 218, 57, 'PPL', 'P'),
(186701, 'Fairview', 38.7438888549805, 0.676208425546145, -105.157783508301, -1.83534955631924, 218, 7, 'PPL', 'P'),
(188542, 'Fairview', 36.0097198486328, 0.628488174079397, -106.063888549805, -1.85116407266241, 218, 38, 'PPL', 'P'),
(191452, 'Fairview', 32.3558311462402, 0.564715785721223, -101.518608093262, -1.77183396326918, 218, 51, 'PPL', 'P'),
(192564, 'Fairview', 39.6263885498047, 0.691610950868673, -111.438888549805, -1.9449755199571, 218, 52, 'PPL', 'P'),
(193542, 'Fairview', 40.8166694641113, 0.712385271846972, -122.765556335449, -2.14266316609617, 218, 6, 'PPL', 'P'),
(194913, 'Fairview', 42.5349998474121, 0.742375794672627, -114.789169311523, -2.00344895011532, 218, 17, 'PPL', 'P'),
(196454, 'Fairview', 47.8563919067383, 0.83525160689735, -104.044441223145, -1.81591806774159, 218, 31, 'PPL', 'P'),
(200805, 'Fairview', 45.4577789306641, 0.793387912983795, -123.787780761719, -2.16050434802889, 218, 43, 'PPL', 'P'),
(207386, 'Fairview', 48.3624992370605, 0.844084846179952, -117.720558166504, -2.05461133729099, 218, 56, 'PPL', 'P'),
(209447, 'Fairview', 43.8002815246582, 0.764459125905728, -104.658058166504, -1.82662770374923, 218, 59, 'PPL', 'P'),
(21010, 'Fairview (historical)', 34.4858283996582, 0.601891250851803, -85.4361114501953, -1.49114144490674, 218, 13, 'PPL', 'P'),
(54708, 'Fairview (historical)', 37.8125, 0.659952623410356, -93.8688888549805, -1.63832117570802, 218, 29, 'PPL', 'P'),
(59876, 'Fairview (historical)', 33.2341690063477, 0.580045673325019, -88.658332824707, -1.5473798171201, 218, 30, 'PPL', 'P'),
(72513, 'Fairview (historical)', 39.6469383239746, 0.691969612088479, -82.9522171020508, -1.44778931025994, 218, 41, 'PPL', 'P'),
(86916, 'Fairview (historical)', 36.0688896179199, 0.629520881371102, -84.2750015258789, -1.47087625374983, 218, 50, 'PPL', 'P'),
(109156, 'Fairview (historical)', 37.9977798461914, 0.663186366763985, -80.7491683959961, -1.40933885675748, 218, 58, 'PPL', 'P'),
(141808, 'Fairview (historical)', 41.0999984741211, 0.717330295938059, -96.0500030517578, -1.67638879980378, 218, 35, 'PPL', 'P'),
(196455, 'Fairview (historical)', 45.2305603027344, 0.789422199804558, -112.54167175293, -1.96422271778732, 218, 31, 'PPL', 'P'),
(199949, 'Fairview (historical)', 40.9258308410645, 0.714290497290815, -117.526390075684, -2.05122246480387, 218, 39, 'PPL', 'P'),
(202110, 'Fairview (historical)', 44.101390838623, 0.769714474842835, -103.651390075684, -1.80905803108965, 218, 49, 'PPL', 'P'),
(40873, 'Fairview Acres', 31.7963905334473, 0.554951705058611, -93.1258316040039, -1.62535238014766, 218, 22, 'PPL', 'P'),
(46989, 'Fairview Acres', 39.6988906860352, 0.692876351860624, -77.7991714477539, -1.35785169708687, 218, 25, 'PPL', 'P'),
(54709, 'Fairview Acres', 37.8583297729492, 0.660752503843761, -90.533332824707, -1.580104740595, 218, 29, 'PPL', 'P'),
(86917, 'Fairview Acres', 35.7916717529297, 0.624682516881673, -84.5749969482422, -1.47611216161098, 218, 50, 'PPL', 'P'),
(101845, 'Fairview Acres', 36.7055587768555, 0.640632854440431, -78.642219543457, -1.37256566210956, 218, 53, 'PPL', 'P'),
(109157, 'Fairview Acres', 39.2188911437988, 0.684498779440534, -81.6594390869141, -1.4252260773984, 218, 58, 'PPL', 'P'),
(40874, 'Fairview Alpha', 31.9708309173584, 0.557996264106303, -93.186393737793, -1.62640938878431, 218, 22, 'PPL', 'P'),
(101846, 'Fairview Beach', 38.3300018310547, 0.66898473424736, -77.2474975585938, -1.34822317132374, 218, 53, 'PPL', 'P'),
(174061, 'Fairview Beach', 44.0849990844727, 0.769428384762734, -88.5113906860352, -1.54481519299036, 218, 57, 'PPL', 'P'),
(21012, 'Fairview Commons', 33.6111106872559, 0.586624546744869, -83.9436111450195, -1.4650924004944, 218, 13, 'PPL', 'P'),
(155222, 'Fairview Corners', 40.2738914489746, 0.702912008375397, -83.2152786254883, -1.45238059997923, 218, 41, 'PPL', 'P'),
(80950, 'Fairview Crossroads', 33.7586097717285, 0.589198891412594, -81.3663864135742, -1.42011134336685, 218, 48, 'PPL', 'P'),
(21013, 'Fairview Estates', 32.6263885498047, 0.56943790322907, -83.6761093139648, -1.46042361278738, 218, 13, 'PPL', 'P'),
(46991, 'Fairview Estates', 39.064998626709, 0.681812848323135, -76.9866714477539, -1.34367089691442, 218, 25, 'PPL', 'P'),
(70808, 'Fairview Estates', 39.9833297729492, 0.697840750448641, -74.1458282470703, -1.29408882952959, 218, 37, 'PPL', 'P'),
(86918, 'Fairview Estates', 36.2563896179199, 0.632793373718592, -85.4911117553711, -1.49210138132165, 218, 50, 'PPL', 'P'),
(101847, 'Fairview Estates', 38.4241714477539, 0.670628304114102, -78.0327835083008, -1.36192899671578, 218, 53, 'PPL', 'P'),
(101848, 'Fairview Farms', 37.0475006103516, 0.646600865285244, -76.3516693115234, -1.33258801888, 218, 53, 'PPL', 'P'),
(203932, 'Fairview Gardens', 40.6616706848145, 0.70968003281167, -111.826393127441, -1.95173875070341, 218, 52, 'PPL', 'P'),
(21014, 'Fairview Heights', 34.7377815246582, 0.606288662443741, -85.2708282470703, -1.48825670881396, 218, 13, 'PPL', 'P'),
(27137, 'Fairview Heights', 38.5888900756836, 0.673503186510843, -89.9902801513672, -1.57062668343346, 218, 18, 'PPL', 'P'),
(80952, 'Fairview Heights', 34.9652786254883, 0.610259235891968, -81.9208297729492, -1.42978820550376, 218, 48, 'PPL', 'P'),
(86921, 'Fairview Heights', 35.6213912963867, 0.6217105622632, -87.0405578613281, -1.51914431745281, 218, 50, 'PPL', 'P'),
(101850, 'Fairview Heights', 37.3877792358398, 0.652539847674175, -79.1458282470703, -1.38135529212931, 218, 53, 'PPL', 'P'),
(155223, 'Fairview Heights', 40.461669921875, 0.706189360991876, -80.6180572509766, -1.40705053559083, 218, 41, 'PPL', 'P'),
(161511, 'Fairview Heights', 41.9736099243164, 0.732577692127089, -78.5961074829102, -1.37176085482814, 218, 45, 'PPL', 'P'),
(170278, 'Fairview Heights', 42.8672218322754, 0.748174162156002, -97.5250015258789, -1.70213237963908, 218, 49, 'PPL', 'P'),
(13091, 'Fairview Heights (historical)', 38.9319381713867, 0.679490505273559, -77.0805587768555, -1.34530953993314, 218, 9, 'PPL', 'P'),
(35841, 'Fairview Hill', 38.2844390869141, 0.668189514345862, -82.9199981689453, -1.44722698379577, 218, 21, 'PPL', 'P'),
(139999, 'Fairview Junction', 46.2683296203613, 0.807534691273323, -96.8236083984375, -1.68989076021437, 218, 34, 'PPL', 'P'),
(145204, 'Fairview Knolls', 40.4291687011719, 0.705622107679689, -74.4263916015625, -1.29898558382592, 218, 37, 'PPL', 'P'),
(59878, 'Fairview Landing', 32.7483291625977, 0.571566168414207, -90.7016677856445, -1.58304273990957, 218, 30, 'PPL', 'P'),
(21015, 'Fairview Manor', 33.6100006103516, 0.586605172247939, -84.1980590820313, -1.46953335477016, 218, 13, 'PPL', 'P'),
(46992, 'Fairview Mill', 39.7005615234375, 0.69290551347456, -77.8305587768555, -1.3583995093231, 218, 25, 'PPL', 'P'),
(29760, 'Fairview Park', 39.6802787780762, 0.692551512786661, -87.4175033569336, -1.52572325745169, 218, 19, 'PPL', 'P'),
(64637, 'Fairview Park', 35.8830604553223, 0.626277550637549, -81.1188888549805, -1.41579169607874, 218, 33, 'PPL', 'P'),
(155225, 'Fairview Park', 41.4413909912109, 0.723288719402947, -81.8644409179688, -1.42880403432292, 218, 41, 'PPL', 'P'),
(161513, 'Fairview Park', 40.1863899230957, 0.701384818648291, -76.8483276367188, -1.3412563419121, 218, 45, 'PPL', 'P'),
(203933, 'Fairview Park', 40.709171295166, 0.710509074859011, -112.10221862793, -1.95655281384789, 218, 52, 'PPL', 'P'),
(15982, 'Fairview Shores', 28.5908298492432, 0.499004116746767, -81.3944396972656, -1.42060096553326, 218, 12, 'PPL', 'P'),
(80953, 'Fairview Shores', 34.7419395446777, 0.606361233583446, -82.9469375610352, -1.44769716488622, 218, 48, 'PPL', 'P'),
(21017, 'Fairview Station', 33.6205596923828, 0.586789462995372, -84.2458267211914, -1.47036705734941, 218, 13, 'PPL', 'P'),
(29761, 'Fairview Station', 39.7536087036133, 0.693831361427526, -86.226936340332, -1.50494394304634, 218, 19, 'PPL', 'P'),
(196456, 'Fairview Terrace Trailer Court', 48.5499992370605, 0.847357338527442, -109.654167175293, -1.91382625574115, 218, 31, 'PPL', 'P'),
(161514, 'Fairview Village', 40.1577796936035, 0.700885475943901, -75.3874969482422, -1.315760036584, 218, 45, 'PPL', 'P'),
(172011, 'Fairview Village', 42.8402786254883, 0.747703914486521, -72.5669403076172, -1.26653203646611, 218, 55, 'PPL', 'P'),
(2403, 'Fairview West', 34.0330581665039, 0.593988919528238, -86.7955627441406, -1.51486834600658, 218, 2, 'PPL', 'P'),
(15983, 'Fairvilla', 28.5786094665527, 0.498790830832965, -81.4088897705078, -1.42085316688849, 218, 12, 'PPL', 'P'),
(40875, 'Fairville', 29.7152805328369, 0.518629483451779, -91.2291717529297, -1.59224942095603, 218, 22, 'PPL', 'P'),
(54713, 'Fairville', 39.2319412231445, 0.684726546292763, -93.2180633544922, -1.62696212786856, 218, 29, 'PPL', 'P'),
(115534, 'Fairville', 43.1561088562012, 0.753216191889795, -94.4630584716797, -1.64869139183473, 218, 16, 'PPL', 'P'),
(148739, 'Fairville', 43.1169395446777, 0.752532558437971, -77.0794372558594, -1.34528996569913, 218, 40, 'PPL', 'P'),
(161522, 'Fairville', 40.9516716003418, 0.71474150362142, -76.9024963378906, -1.34220176409907, 218, 45, 'PPL', 'P'),
(181525, 'Fairville', 38.1780586242676, 0.666332825012886, -122.444442749023, -2.13705867674016, 218, 6, 'PPL', 'P'),
(174062, 'Fairwater', 43.7438888549805, 0.763474888145862, -88.866943359375, -1.5510207578044, 218, 57, 'PPL', 'P'),
(32420, 'Fairway', 39.0222206115723, 0.681066231111531, -94.6316680908203, -1.65163418483927, 218, 20, 'PPL', 'P'),
(35842, 'Fairway', 38.0308303833008, 0.663763207456096, -84.4711074829102, -1.4742989483828, 218, 21, 'PPL', 'P'),
(46994, 'Fairway', 39.0188903808594, 0.68100810762074, -77.019172668457, -1.3442381502266, 218, 25, 'PPL', 'P'),
(78244, 'Fairway', 39.9761085510254, 0.697714716350053, -76.7658309936523, -1.33981650386874, 218, 45, 'PPL', 'P'),
(64641, 'Fairway Acres', 35.7394409179688, 0.623770916840539, -78.6675033569336, -1.37300694790218, 218, 33, 'PPL', 'P'),
(181526, 'Fairway Acres', 37.9674987792969, 0.662657862445658, -120.402778625488, -2.10142491556462, 218, 6, 'PPL', 'P'),
(80954, 'Fairway Bridge', 35.1055603027344, 0.612707613040132, -81.0666732788086, -1.41488036235372, 218, 48, 'PPL', 'P'),
(80955, 'Fairway Estates', 34.9791717529297, 0.610501716709219, -82.2174987792969, -1.43496605645315, 218, 48, 'PPL', 'P'),
(86923, 'Fairway Estates', 35.7194404602051, 0.623421843000657, -84.0180587768555, -1.46639175679025, 218, 50, 'PPL', 'P'),
(101852, 'Fairway Estates', 39.1686096191406, 0.683621201282326, -78.142219543457, -1.36383901584959, 218, 53, 'PPL', 'P'),
(203935, 'Fairway Estates Condominium', 40.6547203063965, 0.709558725824017, -111.869720458984, -1.95249495529494, 218, 52, 'PPL', 'P'),
(13740, 'Fairway Falls', 39.7277793884277, 0.693380554834003, -75.7027816772461, -1.32126279318638, 218, 10, 'PPL', 'P'),
(203936, 'Fairway Fields', 41.0008316040039, 0.715599507545616, -111.91194152832, -1.95323185196856, 218, 52, 'PPL', 'P'),
(101853, 'Fairway Forest', 37.2519416809082, 0.650169035092759, -80.0538864135742, -1.39720389693443, 218, 53, 'PPL', 'P'),
(109160, 'Fairway Gardens', 38.4466705322266, 0.671020987216834, -81.9672164916992, -1.43059780647515, 218, 58, 'PPL', 'P'),
(101854, 'Fairway Heights', 39.3233299255371, 0.686321580048639, -78.3305587768555, -1.36712615558307, 218, 53, 'PPL', 'P'),
(46995, 'Fairway Hill', 39.2761116027832, 0.685497464849314, -76.8722229003906, -1.3416733929388, 218, 25, 'PPL', 'P'),
(46996, 'Fairway Hills', 38.9705581665039, 0.680164551345458, -77.1383285522461, -1.34631781272185, 218, 25, 'PPL', 'P'),
(64644, 'Fairway Hills', 35.5175018310547, 0.619897349035019, -82.9816665649414, -1.44830330035032, 218, 33, 'PPL', 'P'),
(101855, 'Fairway Meadows', 39.3202781677246, 0.686268316826838, -78.3180618286133, -1.36690804268979, 218, 53, 'PPL', 'P'),
(21019, 'Fairway Oaks', 31.2227802276611, 0.544940316599271, -81.4694366455078, -1.42190990920904, 218, 13, 'PPL', 'P'),
(80956, 'Fairway Oaks', 32.1388893127441, 0.560929436441403, -80.7916717529297, -1.41008068027912, 218, 48, 'PPL', 'P'),
(181527, 'Fairway Park', 37.6208305358887, 0.65660736018608, -122.48722076416, -2.13780529395176, 218, 6, 'PPL', 'P'),
(72516, 'Fairway Terrace Mobile Home Park', 39.8608283996582, 0.695702698146498, -84.0494384765625, -1.46693943586842, 218, 41, 'PPL', 'P'),
(13741, 'Fairway Villas', 38.5755615234375, 0.673270559389624, -75.1430587768555, -1.31149378567575, 218, 10, 'PPL', 'P'),
(46997, 'Fairways', 38.8388900756836, 0.677866509640828, -75.8438873291016, -1.32372555140443, 218, 25, 'PPL', 'P'),
(148740, 'Fairweather Corners', 43.017219543457, 0.750792116086577, -74.0541687011719, -1.29248906866278, 218, 40, 'PPL', 'P'),
(72517, 'Fairwind Acres', 39.2438888549805, 0.684935071806117, -84.3586120605469, -1.47233553286914, 218, 41, 'PPL', 'P'),
(46998, 'Fairwind Farms', 39.5125007629395, 0.689623234010065, -76.3536071777344, -1.33262184102584, 218, 25, 'PPL', 'P'),
(13742, 'Fairwinds', 39.6436080932617, 0.691911488597688, -75.6433334350586, -1.32022522562568, 218, 10, 'PPL', 'P'),
(13743, 'Fairwinds Mobile Home Park', 39.6427803039551, 0.691897040948775, -75.6388931274414, -1.32014772763796, 218, 10, 'PPL', 'P'),
(80958, 'Fairwold', 34.0608291625977, 0.594473614846632, -80.9916687011719, -1.41357128551989, 218, 48, 'PPL', 'P'),
(46999, 'Fairwood', 39.1188888549805, 0.682753410241124, -76.4899978637695, -1.33500230756621, 218, 25, 'PPL', 'P'),
(101856, 'Fairwood', 36.6997184753418, 0.640530921949708, -81.4850006103516, -1.42218155164022, 218, 53, 'PPL', 'P'),
(207388, 'Fairwood', 47.7669410705566, 0.833690395287318, -117.416389465332, -2.04930259197403, 218, 56, 'PPL', 'P'),
(101857, 'Fairwood Acres', 38.7813911437988, 0.676862963963059, -77.3199996948242, -1.34948857231569, 218, 53, 'PPL', 'P'),
(47000, 'Fairwood Heights', 39.563060760498, 0.690505672437263, -76.3163909912109, -1.33197229603597, 218, 25, 'PPL', 'P'),
(29763, 'Fairwood Hills', 39.8833312988281, 0.696095447828257, -86.0299987792969, -1.50150673418543, 218, 19, 'PPL', 'P'),
(47001, 'Fairwood of Hunt Valley', 39.5133285522461, 0.689637681658979, -76.5977783203125, -1.33688343140218, 218, 25, 'PPL', 'P'),
(178175, 'Fairwood VIII', 33.5877799987793, 0.586217349414196, -112.205558776855, -1.95835643969615, 218, 5, 'PPL', 'P'),
(145206, 'Fairwoods', 40.7686080932617, 0.711546442682624, -74.4288864135742, -1.29902912650974, 218, 37, 'PPL', 'P'),
(112623, 'Fairy', 31.8458309173584, 0.55581460254131, -97.9822235107422, -1.71011240868745, 218, 51, 'PPL', 'P'),
(86924, 'Fairyland', 35.9124984741211, 0.626791340990853, -85.0513916015625, -1.48442681685032, 218, 50, 'PPL', 'P'),
(194914, 'Fairylawn', 42.5697212219238, 0.742981796978675, -116.988327026367, -2.04183149300997, 218, 17, 'PPL', 'P'),
(21020, 'Fairystone', 32.7188911437988, 0.571052378060903, -83.7069396972656, -1.46096170448563, 218, 13, 'PPL', 'P'),
(64654, 'Faison', 35.1161117553711, 0.612891770629511, -78.1363906860352, -1.36373728309594, 218, 33, 'PPL', 'P'),
(59879, 'Faisonia', 33.5055618286133, 0.584782371639834, -90.6319427490234, -1.58182580844946, 218, 30, 'PPL', 'P'),
(64646, 'Faisons', 36.4444389343262, 0.636075453446005, -77.3249969482422, -1.34957579084139, 218, 33, 'PPL', 'P'),
(101858, 'Faisons Mobile Home Park', 36.7075004577637, 0.640666743165302, -77.4613876342773, -1.35195625738176, 218, 53, 'PPL', 'P'),
(747, 'Faith', 35.5869407653809, 0.621109287068087, -80.4630584716797, -1.40434529655553, 218, 33, 'PPL', 'P'),
(8836, 'Faith', 34.1036109924316, 0.595220298637263, -92.1033325195313, -1.60750640452498, 218, 4, 'PPL', 'P'),
(54714, 'Faith', 38.0544395446777, 0.664175265055758, -92.3974990844727, -1.61264057963249, 218, 29, 'PPL', 'P'),
(113126, 'Faith', 47.2869415283203, 0.825312822867229, -96.0986099243164, -1.67723714976902, 218, 28, 'PPL', 'P'),
(202115, 'Faith', 45.0230598449707, 0.785800633617187, -102.03556060791, -1.78085648672626, 218, 49, 'PPL', 'P'),
(196457, 'Faith Mobile Home Court', 45.7605590820313, 0.798672423534839, -111.138061523438, -1.93972509786801, 218, 31, 'PPL', 'P'),
(130748, 'Faithorn', 45.6797218322754, 0.797261547368343, -87.7519378662109, -1.53156024077087, 218, 27, 'PPL', 'P'),
(177326, 'Faithorn', 41.4280586242676, 0.723056025702702, -87.6080627441406, -1.52904914617903, 218, 18, 'PPL', 'P'),
(86925, 'Faix', 36.5141716003418, 0.637292518064171, -85.1255569458008, -1.48572124629815, 218, 50, 'PPL', 'P'),
(15985, 'Fakahatchee', 25.8680591583252, 0.451482803413448, -81.4894409179688, -1.42225904962795, 218, 12, 'PPL', 'P'),
(2405, 'Fakit Chipunta (historical)', 31.764720916748, 0.554398965974365, -88.154167175293, -1.53858046656237, 218, 2, 'PPL', 'P'),
(2406, 'Falakto', 32.8047218322754, 0.572550406174073, -86.5941696166992, -1.51135337284184, 218, 2, 'PPL', 'P'),
(2407, 'Falco', 31.0488891601563, 0.541905344931504, -86.6183319091797, -1.51177508440045, 218, 2, 'PPL', 'P'),
(8837, 'Falcon', 33.4644393920898, 0.584064649726057, -93.413330078125, -1.63037017511553, 218, 4, 'PPL', 'P'),
(35843, 'Falcon', 37.7897186279297, 0.659555013459607, -83.0019378662109, -1.44865710130114, 218, 21, 'PPL', 'P'),
(54715, 'Falcon', 37.6049995422363, 0.656331057222984, -92.3786087036133, -1.61231088028954, 218, 29, 'PPL', 'P'),
(59880, 'Falcon', 34.3930587768555, 0.600272115488062, -90.2563934326172, -1.57527123637456, 218, 30, 'PPL', 'P'),
(64647, 'Falcon', 35.1897201538086, 0.614176479539365, -78.6486129760742, -1.37267724855923, 218, 33, 'PPL', 'P'),
(86926, 'Falcon', 35.144718170166, 0.613391046754874, -88.6013870239258, -1.54638592540128, 218, 50, 'PPL', 'P'),
(94156, 'Falcon', 26.6377792358398, 0.464916953084784, -99.0952835083008, -1.72953897041709, 218, 51, 'PPL', 'P'),
(186702, 'Falcon', 38.9330596923828, 0.679510079507571, -104.608062744141, -1.82575511901807, 218, 7, 'PPL', 'P'),
(194915, 'Falcon', 47.3488883972168, 0.826393999690774, -115.673889160156, -2.01889022443171, 218, 17, 'PPL', 'P'),
(21021, 'Falcon Acres', 33.8077812194824, 0.590057095073872, -84.6747207641602, -1.4778526705414, 218, 13, 'PPL', 'P'),
(64649, 'Falcon Crest', 36.0877799987793, 0.629850580714054, -81.6338882446289, -1.42478013107387, 218, 33, 'PPL', 'P'),
(94157, 'Falcon Estates Colonia', 26.8899993896484, 0.469319025208631, -99.2649993896484, -1.73250107133953, 218, 51, 'PPL', 'P'),
(94158, 'Falcon Heights', 26.5586109161377, 0.46353520524271, -99.1227798461914, -1.73001887204552, 218, 51, 'PPL', 'P'),
(135317, 'Falcon Heights', 44.9916687011719, 0.78525275480193, -93.1661071777344, -1.62605532151739, 218, 28, 'PPL', 'P'),
(200806, 'Falcon Heights', 42.1375007629395, 0.735438126874916, -121.755561828613, -2.12503543652483, 218, 43, 'PPL', 'P'),
(21022, 'Falcon Hills', 34.0736083984375, 0.594696654587926, -84.5458297729492, -1.47560309836861, 218, 13, 'PPL', 'P'),
(94159, 'Falcon Lake', 26.8713893890381, 0.468994219424182, -99.2552795410156, -1.73233142797809, 218, 51, 'PPL', 'P'),
(94160, 'Falcon Lake Estates', 26.8724994659424, 0.469013593921112, -99.254997253418, -1.73232650113007, 218, 51, 'PPL', 'P'),
(94161, 'Falcon Mesa', 26.8724994659424, 0.469013593921112, -99.2891693115234, -1.7329229160562, 218, 51, 'PPL', 'P'),
(21023, 'Falcon Ridge', 33.8647193908691, 0.591050853634635, -83.9833297729492, -1.46578562132615, 218, 13, 'PPL', 'P'),
(47002, 'Falcon Ridge', 39.3802795410156, 0.687315538346484, -76.7872161865234, -1.34018974589552, 218, 25, 'PPL', 'P'),
(101859, 'Falcon Ridge Estates', 37.1991691589355, 0.649247980829755, -80.0586090087891, -1.39728632177016, 218, 53, 'PPL', 'P'),
(21024, 'Falcon Shores', 34.0527801513672, 0.594333133099131, -84.7202835083008, -1.4786478904429, 218, 13, 'PPL', 'P'),
(94162, 'Falcon Shores', 26.8955593109131, 0.469416064140851, -99.253059387207, -1.73229267898423, 218, 51, 'PPL', 'P'),
(94163, 'Falcon Village', 26.5611095428467, 0.46357881450556, -99.1341705322266, -1.73021767702089, 218, 51, 'PPL', 'P'),
(94164, 'Falconaire Colonia', 26.5520000457764, 0.463419823788483, -99.1169967651367, -1.7299179382402, 218, 51, 'PPL', 'P'),
(21025, 'Falconcrest', 34.0058288574219, 0.593513678431713, -84.0586090087891, -1.46709949184994, 218, 13, 'PPL', 'P'),
(148741, 'Falconer', 42.1186103820801, 0.735108427531964, -79.1986083984375, -1.38227647955037, 218, 40, 'PPL', 'P'),
(40878, 'Faleau (historical)', 29.391939163208, 0.512986111943847, -90.3472213745117, -1.57685648301343, 218, 22, 'PPL', 'P'),
(8838, 'Falerno (historical)', 35.4527816772461, 0.618767769258662, -93.2138900756836, -1.62688929041275, 218, 4, 'PPL', 'P'),
(181528, 'Fales Hot Springs', 38.3511085510254, 0.669353116005145, -119.399169921875, -2.0839086392849, 218, 6, 'PPL', 'P'),
(178176, 'Falfa', 33.3461112976074, 0.581999434879728, -111.831939697266, -1.95183555660904, 218, 5, 'PPL', 'P'),
(186703, 'Falfa', 37.2130584716797, 0.64949039506798, -107.790283203125, -1.88129534355167, 218, 7, 'PPL', 'P'),
(94165, 'Falfurrias', 27.2266693115234, 0.475195023837782, -98.1438903808594, -1.71293402786239, 218, 51, 'PPL', 'P'),
(54716, 'Falk Mill (historical)', 37.4394416809082, 0.653441527440248, -91.3008270263672, -1.59350004140393, 218, 29, 'PPL', 'P'),
(198275, 'Falkirk', 47.3619384765625, 0.826621766543003, -101.094169616699, -1.76442611438102, 218, 34, 'PPL', 'P'),
(64652, 'Falkland', 35.6991691589355, 0.62306804204984, -77.5133285522461, -1.35286279741682, 218, 33, 'PPL', 'P'),
(2409, 'Falkner', 32.6952781677246, 0.570640253882213, -86.0502777099609, -1.5018606682943, 218, 2, 'PPL', 'P'),
(59881, 'Falkner', 34.8419418334961, 0.608106602782857, -88.9341735839844, -1.55219414658069, 218, 30, 'PPL', 'P'),
(2410, 'Falkville', 34.3683280944824, 0.599840483654387, -86.9086074829102, -1.51684134890016, 218, 2, 'PPL', 'P'),
(86927, 'Fall Branch', 36.4180603027344, 0.635615059472558, -82.623893737793, -1.44205898654241, 218, 50, 'PPL', 'P'),
(161524, 'Fall Brook', 41.6772193908691, 0.727404701446692, -76.9861068725586, -1.34366104321838, 218, 45, 'PPL', 'P'),
(86928, 'Fall City', 35.8055610656738, 0.624924931119898, -85.6483306884766, -1.49484536935082, 218, 50, 'PPL', 'P'),
(207389, 'Fall City', 47.5675010681152, 0.83020951058453, -121.887496948242, -2.12733813876137, 218, 56, 'PPL', 'P'),
(27138, 'Fall Creek', 39.7788887023926, 0.694272580641125, -91.3022232055664, -1.59352440932791, 218, 18, 'PPL', 'P'),
(80959, 'Fall Creek', 34.9013900756836, 0.609144170343552, -82.9205627441406, -1.4472368374918, 218, 48, 'PPL', 'P'),
(86930, 'Fall Creek', 36.5333290100098, 0.637626877939031, -82.4513931274414, -1.43904828293008, 218, 50, 'PPL', 'P'),
(94167, 'Fall Creek', 32.3977813720703, 0.565447955283913, -97.6511077880859, -1.70433334912198, 218, 51, 'PPL', 'P'),
(174064, 'Fall Creek', 44.7636108398438, 0.781272394236698, -91.2769393920898, -1.59308312353528, 218, 57, 'PPL', 'P'),
(193207, 'Fall Creek', 43.9597206115723, 0.767241862928751, -122.81916809082, -2.14359886774517, 218, 43, 'PPL', 'P'),
(194916, 'Fall Creek', 45.8122215270996, 0.799574103300913, -115.651672363281, -2.01850246817699, 218, 17, 'PPL', 'P'),
(29764, 'Fall Creek Highland', 39.896671295166, 0.696328274686557, -85.9911117553711, -1.50082802758163, 218, 19, 'PPL', 'P'),
(174067, 'Fall Hall Glen', 44.1963882446289, 0.771372492358491, -90.8397216796875, -1.58545223490582, 218, 57, 'PPL', 'P'),
(32422, 'Fall Leaf', 38.9741706848145, 0.680227601684265, -95.1102828979492, -1.65998758907247, 218, 20, 'PPL', 'P'),
(32423, 'Fall River', 37.607780456543, 0.656379593333851, -96.0277786254883, -1.67600091039101, 218, 20, 'PPL', 'P'),
(86931, 'Fall River', 35.1344413757324, 0.613211682855457, -87.2183303833008, -1.52224703328081, 218, 50, 'PPL', 'P'),
(124808, 'Fall River', 41.7013893127441, 0.727826546163361, -71.1555633544922, -1.24189886164731, 218, 23, 'PPL', 'P'),
(174068, 'Fall River', 43.3844413757324, 0.757201346144989, -89.0449981689453, -1.55412840048042, 218, 57, 'PPL', 'P'),
(194179, 'Fall River Estates Subdivision', 40.3902816772461, 0.704943401075882, -105.580558776855, -1.84272837675153, 218, 7, 'PPL', 'P'),
(193543, 'Fall River Mills', 41.0047187805176, 0.715667351574386, -121.437217712402, -2.1194792835426, 218, 6, 'PPL', 'P'),
(124809, 'Fall River Station', 41.7138900756836, 0.728044725635665, -71.154167175293, -1.24187449372334, 218, 23, 'PPL', 'P'),
(35844, 'Fall Rock', 37.2197189331055, 0.649606642049562, -83.788330078125, -1.46238223461108, 218, 21, 'PPL', 'P'),
(130751, 'Fallassburg', 42.9822196960449, 0.75018125351154, -85.3227767944336, -1.48916338200708, 218, 27, 'PPL', 'P'),
(181532, 'Fallbrook', 38.4191703796387, 0.670541019009375, -121.361106872559, -2.11815089879087, 218, 6, 'PPL', 'P'),
(181530, 'Fallbrook Junction', 33.223331451416, 0.579856522308596, -117.393333435059, -2.04890018833332, 218, 6, 'PPL', 'P'),
(112450, 'Fallcliff', 35.2588882446289, 0.615383690461498, -83.1805572509766, -1.45177459767318, 218, 33, 'PPL', 'P'),
(64656, 'Fallcrest', 35.2177810668945, 0.614666234863831, -81.2463912963867, -1.41801703348561, 218, 33, 'PPL', 'P'),
(181531, 'Fallen Leaf', 38.8830604553223, 0.678637428197379, -120.071670532227, -2.09564598915721, 218, 6, 'PPL', 'P'),
(161525, 'Fallentimber', 40.6866683959961, 0.710116325177252, -78.4994430541992, -1.37007374227757, 218, 45, 'PPL', 'P'),
(35845, 'Falling Branch', 37.5947189331055, 0.65615162674454, -86.4972229003906, -1.50966133344326, 218, 21, 'PPL', 'P'),
(64657, 'Falling Creek', 35.2619400024414, 0.6154369536833, -77.6908264160156, -1.35596071955486, 218, 33, 'PPL', 'P'),
(101861, 'Falling Creek', 37.2966690063477, 0.650949674187288, -79.8600006103516, -1.39381995129532, 218, 53, 'PPL', 'P'),
(101862, 'Falling Creek Farms', 37.4430618286133, 0.65350471093711, -77.5691680908203, -1.35383738121774, 218, 53, 'PPL', 'P'),
(109161, 'Falling Rock', 38.4688911437988, 0.671408810050577, -81.4019393920898, -1.42073185990084, 218, 58, 'PPL', 'P'),
(21026, 'Falling Rocks', 31.9400005340576, 0.557458172408053, -82.3733291625977, -1.43768580971639, 218, 13, 'PPL', 'P'),
(27140, 'Falling Spring', 38.5325012207031, 0.672519015330004, -90.1866683959961, -1.57405430491445, 218, 18, 'PPL', 'P'),
(101863, 'Falling Spring', 37.8863906860352, 0.661242259168227, -79.9797210693359, -1.39590946748659, 218, 53, 'PPL', 'P'),
(109162, 'Falling Spring', 37.9916687011719, 0.663079707162327, -80.3541717529297, -1.40244486480165, 218, 58, 'PPL', 'P'),
(161526, 'Falling Spring', 40.3519401550293, 0.704274215272972, -77.211669921875, -1.34759786109979, 218, 45, 'PPL', 'P'),
(8839, 'Falling Springs', 36.3333282470703, 0.634136206119237, -94.5180587768555, -1.64965132824965, 218, 4, 'PPL', 'P'),
(181534, 'Falling Springs', 34.3016700744629, 0.598677081732186, -117.838333129883, -2.05666689817837, 218, 6, 'PPL', 'P'),
(86932, 'Falling Water', 35.2030601501465, 0.614409306397666, -85.2536087036133, -1.48795617108495, 218, 50, 'PPL', 'P'),
(109163, 'Falling Waters', 39.5591697692871, 0.690437761829466, -77.89111328125, -1.3594563848017, 218, 58, 'PPL', 'P'),
(8840, 'Fallis', 35.7849998474121, 0.62456607016301, -90.6605606079102, -1.5823252843119, 218, 4, 'PPL', 'P'),
(35846, 'Fallis', 38.4300003051758, 0.670730036867743, -84.9352798461914, -1.48240028441882, 218, 21, 'PPL', 'P'),
(75808, 'Fallis', 35.7483291625977, 0.623926045974036, -97.1202774047852, -1.69506861116375, 218, 42, 'PPL', 'P'),
(2412, 'Falliston', 33.2894401550293, 0.581010336850873, -86.8600006103516, -1.51599299893492, 218, 2, 'PPL', 'P'),
(75809, 'Fallon', 33.9977798461914, 0.593373196684211, -95.4166717529297, -1.66533508338329, 218, 42, 'PPL', 'P'),
(94168, 'Fallon', 31.5808296203613, 0.551189457386656, -96.4061126708984, -1.6826040851558, 218, 51, 'PPL', 'P'),
(181533, 'Fallon', 38.2747192382813, 0.668019870984424, -122.904716491699, -2.14509196901033, 218, 6, 'PPL', 'P'),
(190192, 'Fallon', 39.4736099243164, 0.688944460827231, -118.776390075684, -2.0730390804538, 218, 39, 'PPL', 'P'),
(196459, 'Fallon', 46.8355598449707, 0.817434726309584, -105.11888885498, -1.83467071655738, 218, 31, 'PPL', 'P'),
(198276, 'Fallon', 46.5122184753418, 0.811791354801651, -101.090560913086, -1.76436313062123, 218, 34, 'PPL', 'P'),
(207390, 'Fallon', 46.8347206115723, 0.817420078923588, -117.114723205566, -2.04403752249894, 218, 56, 'PPL', 'P'),
(115535, 'Fallow', 43.1977806091309, 0.753943501183495, -94.8019409179688, -1.65460600629969, 218, 16, 'PPL', 'P'),
(64659, 'Falls', 35.9397201538086, 0.627266448929323, -78.579719543457, -1.37147483132706, 218, 33, 'PPL', 'P'),
(109164, 'Falls', 39.1749992370605, 0.683732721152973, -79.1191711425781, -1.38089003788687, 218, 58, 'PPL', 'P'),
(161528, 'Falls', 41.4605598449707, 0.723623279014889, -75.8491668701172, -1.32381769677815, 218, 45, 'PPL', 'P'),
(211824, 'Falls', 60.4199981689453, 1.05452790209704, -149.37028503418, -2.60700327848885, 218, 1, 'PPL', 'P'),
(101865, 'Falls Church', 38.8822212219238, 0.678622780811384, -77.17138671875, -1.34689478657201, 218, 53, 'PPL', 'P'),
(2413, 'Falls City', 34.024169921875, 0.593833790394741, -87.2827835083008, -1.52337195252526, 218, 2, 'PPL', 'P'),
(94169, 'Falls City', 28.9825000762939, 0.505840051790837, -98.017219543457, -1.71072320468346, 218, 51, 'PPL', 'P'),
(141814, 'Falls City', 40.0608291625977, 0.699193369966292, -95.6016693115234, -1.6685638998889, 218, 35, 'PPL', 'P'),
(174070, 'Falls City', 44.7972183227539, 0.781858955466788, -91.7686080932617, -1.60166436119973, 218, 57, 'PPL', 'P'),
(194917, 'Falls City', 42.6805610656738, 0.744916317194508, -114.423332214355, -1.9970638882438, 218, 17, 'PPL', 'P'),
(200807, 'Falls City', 44.8663902282715, 0.783066232967948, -123.434722900391, -2.15434232589866, 218, 43, 'PPL', 'P'),
(161529, 'Falls Creek', 41.1450004577637, 0.71811572872255, -78.8047180175781, -1.37540179551244, 218, 45, 'PPL', 'P'),
(75811, 'Falls Creek Assembly', 34.4263916015625, 0.600853883028189, -97.1108322143555, -1.69490376149228, 218, 42, 'PPL', 'P'),
(47005, 'Falls Crest', 39.5275001525879, 0.68988502274522, -76.4222183227539, -1.33381933140999, 218, 25, 'PPL', 'P'),
(47003, 'Falls Gable', 39.3805618286133, 0.687320465194501, -76.6730575561523, -1.33819730192598, 218, 25, 'PPL', 'P'),
(101867, 'Falls Hill', 38.8919410705566, 0.678792424172822, -77.2011108398438, -1.34741357035236, 218, 53, 'PPL', 'P'),
(2414, 'Falls Junction', 33.5033302307129, 0.584743422908891, -86.9233322143555, -1.51709834394536, 218, 2, 'PPL', 'P'),
(135321, 'Falls Junction', 48.6027793884277, 0.8482785259485, -93.3427810668945, -1.62913886258554, 218, 28, 'PPL', 'P'),
(155227, 'Falls Junction', 41.3566703796387, 0.721810065786708, -81.466667175293, -1.42186157283525, 218, 41, 'PPL', 'P'),
(86933, 'Falls Mill', 35.0986099243164, 0.612586306052479, -86.2613906860352, -1.50554528482048, 218, 50, 'PPL', 'P'),
(109166, 'Falls Mill', 38.773609161377, 0.676727142747465, -80.5500030517578, -1.40586276574465, 218, 58, 'PPL', 'P'),
(101868, 'Falls Mills', 37.2763900756836, 0.650595740078417, -81.3086090087891, -1.41910293742009, 218, 53, 'PPL', 'P'),
(109165, 'Falls Mills', 39.4408302307129, 0.688372347246055, -81.0083312988281, -1.41386210271093, 218, 58, 'PPL', 'P'),
(148743, 'Falls Mills', 41.7308311462402, 0.728340403095691, -74.9824981689453, -1.30869147441872, 218, 40, 'PPL', 'P'),
(35847, 'Falls of Rough', 37.5900001525879, 0.65606926848783, -86.5488891601563, -1.51056307978836, 218, 21, 'PPL', 'P'),
(47004, 'Falls Orchard', 39.065559387207, 0.681822635440141, -77.1719436645508, -1.34690450710999, 218, 25, 'PPL', 'P'),
(109173, 'Falls View', 38.1261100769043, 0.665426151819769, -81.2463912963867, -1.41801703348561, 218, 58, 'PPL', 'P'),
(113423, 'Falls Village', 41.9558296203613, 0.732267367281068, -73.3636093139648, -1.28043653367546, 218, 8, 'PPL', 'P'),
(35849, 'Fallsburg', 38.1749992370605, 0.66627942863303, -82.6736068725586, -1.44292664442556, 218, 21, 'PPL', 'P'),
(148744, 'Fallsburg', 41.7319412231445, 0.728359777592622, -74.6016693115234, -1.3020447569701, 218, 40, 'PPL', 'P'),
(155228, 'Fallsburg', 40.2027816772461, 0.701670908728393, -82.2361068725586, -1.43529082894808, 218, 41, 'PPL', 'P'),
(161533, 'Fallsdale', 41.6783294677734, 0.727424075943622, -75.1547164916992, -1.31169725118303, 218, 45, 'PPL', 'P'),
(161534, 'Fallsington', 40.1872215270996, 0.701399332876232, -74.8191680908203, -1.30584082678789, 218, 45, 'PPL', 'P'),
(47006, 'Fallsmont', 39.5152816772461, 0.689671770120932, -76.4469375610352, -1.33425076350659, 218, 25, 'PPL', 'P'),
(47007, 'Fallstaff', 39.3683280944824, 0.687106946254104, -76.7069396972656, -1.33878865684603, 218, 25, 'PPL', 'P'),
(47008, 'Fallston', 39.5144386291504, 0.689657056155909, -76.4113922119141, -1.33363038013065, 218, 25, 'PPL', 'P'),
(64663, 'Fallston', 35.4288902282715, 0.618350784810983, -81.5016708374023, -1.42247250198932, 218, 33, 'PPL', 'P'),
(161535, 'Fallston', 40.7255592346191, 0.710795098360086, -80.3158264160156, -1.40177561241971, 218, 45, 'PPL', 'P'),
(8842, 'Fallsville', 35.7763900756836, 0.624415801298502, -93.4652786254883, -1.63127684830865, 218, 4, 'PPL', 'P'),
(72519, 'Fallsville (historical)', 39.2922210693359, 0.685778628081399, -83.6313934326172, -1.45964317342993, 218, 41, 'PPL', 'P'),
(47009, 'Fallswood', 39.4458312988281, 0.688459632350782, -76.679443359375, -1.3383087552176, 218, 25, 'PPL', 'P'),
(101870, 'Fallville', 36.7455596923828, 0.641331002120195, -81.1033325195313, -1.41552018680561, 218, 53, 'PPL', 'P'),
(15986, 'Falmouth', 30.3627796173096, 0.529930474379476, -83.1313934326172, -1.45091652716996, 218, 12, 'PPL', 'P'),
(27141, 'Falmouth', 39.0547218322754, 0.681633484423718, -88.1455612182617, -1.53843026427689, 218, 18, 'PPL', 'P'),
(29767, 'Falmouth', 39.7008285522461, 0.692910174006468, -85.3011093139648, -1.48878521313229, 218, 19, 'PPL', 'P'),
(35848, 'Falmouth', 38.6766700744629, 0.675035236506938, -84.3302764892578, -1.47184098385471, 218, 21, 'PPL', 'P'),
(101869, 'Falmouth', 38.3238906860352, 0.668878074645702, -77.4686126708984, -1.35208235805938, 218, 53, 'PPL', 'P'),
(124811, 'Falmouth', 41.5513916015625, 0.725208592232785, -70.6152801513672, -1.23246914085956, 218, 23, 'PPL', 'P'),
(127465, 'Falmouth', 43.7294387817383, 0.763222686790631, -70.2425003051758, -1.22596290515844, 218, 26, 'PPL', 'P'),
(130752, 'Falmouth', 44.2433280944824, 0.772191747288827, -85.0869369506836, -1.48504720022625, 218, 27, 'PPL', 'P'),
(161537, 'Falmouth', 40.1294403076172, 0.700390860350446, -76.7141723632813, -1.3389148906817, 218, 45, 'PPL', 'P'),
(127466, 'Falmouth Foreside', 43.7347183227539, 0.763314832164348, -70.2083282470703, -1.22536649023232, 218, 26, 'PPL', 'P'),
(124812, 'Falmouth Heights', 41.5458297729492, 0.725111520011052, -70.595832824707, -1.23212972097863, 218, 23, 'PPL', 'P'),
(200808, 'Faloma', 45.6019401550293, 0.795904001002675, -122.668060302734, -2.14096153931767, 218, 43, 'PPL', 'P'),
(101876, 'False Cape Landing', 36.5941696166992, 0.638688746844673, -75.8880615234375, -1.32449653654001, 218, 53, 'PPL', 'P'),
(193544, 'False Klamath', 41.5919418334961, 0.725916327292474, -124.094169616699, -2.16585184233971, 218, 6, 'PPL', 'P'),
(211825, 'False Pass', 54.850830078125, 0.95732758231522, -163.414993286133, -2.85212967996745, 218, 1, 'PPL', 'P'),
(40879, 'False River', 30.5702800750732, 0.533552040566847, -91.5927810668945, -1.59859560067563, 218, 22, 'PPL', 'P'),
(196460, 'False Summit', 48.371940612793, 0.844249629272401, -113.278610229492, -1.97708472058797, 218, 31, 'PPL', 'P'),
(199314, 'Falter Place', 42.1438903808594, 0.735549646745563, -100.270561218262, -1.7500514360812, 218, 35, 'PPL', 'P'),
(32428, 'Falun', 38.6711082458496, 0.674938164285204, -97.7591705322266, -1.70621939980597, 218, 20, 'PPL', 'P'),
(174071, 'Falun', 45.7719383239746, 0.798871028773132, -92.5274963378906, -1.61490945972319, 218, 57, 'PPL', 'P'),
(21027, 'Fambro (historical)', 34.4888916015625, 0.601944713810686, -84.7863922119141, -1.47980170498518, 218, 13, 'PPL', 'P'),
(59882, 'Fame', 33.663890838623, 0.587545734165927, -89.2013931274414, -1.55685800743969, 218, 30, 'PPL', 'P'),
(75810, 'Fame', 35.3622207641602, 0.6171871831517, -95.6455612182617, -1.66932995817647, 218, 42, 'PPL', 'P'),
(109167, 'Fame', 38.7419395446777, 0.676174403663219, -79.1622161865234, -1.38164131563038, 218, 58, 'PPL', 'P'),
(196461, 'Family (historical)', 48.4819412231445, 0.846169502102239, -112.743606567383, -1.96774714517393, 218, 31, 'PPL', 'P'),
(59883, 'Famosla', 33.2386093139648, 0.58012317131274, -90.3899993896484, -1.57760310022503, 218, 30, 'PPL', 'P'),
(181535, 'Famoso', 35.5980606079102, 0.621303364932526, -119.207221984863, -2.08055851579163, 218, 6, 'PPL', 'P'),
(54718, 'Famous', 39.0349998474121, 0.681289270852825, -91.0119400024414, -1.58845801167014, 218, 29, 'PPL', 'P'),
(8841, 'Famous (historical)', 35.4122200012207, 0.618059834461892, -93.2102813720703, -1.62682630665296, 218, 4, 'PPL', 'P'),
(191453, 'Famuliner', 33.6802787780762, 0.587831757667002, -102.865562438965, -1.79534275147575, 218, 51, 'PPL', 'P'),
(27142, 'Fancher', 39.2675018310547, 0.685347195984806, -88.773063659668, -1.54938224794373, 218, 18, 'PPL', 'P'),
(148745, 'Fancher', 43.2447204589844, 0.754762756113831, -78.0913925170898, -1.36295191689048, 218, 40, 'PPL', 'P'),
(174072, 'Fancher', 44.4630584716797, 0.776026765837568, -89.3855590820313, -1.56007230971737, 218, 57, 'PPL', 'P'),
(86936, 'Fanchers Mills', 35.9991683959961, 0.628304016490018, -85.6161117553711, -1.49428304288665, 218, 50, 'PPL', 'P'),
(54719, 'Fanchon', 36.7949981689453, 0.64219386631338, -91.7002792358398, -1.60047179766359, 218, 29, 'PPL', 'P'),
(109168, 'Fanco', 37.776668548584, 0.659327246607378, -81.8186111450195, -1.42800415388952, 218, 58, 'PPL', 'P'),
(86934, 'Fancy', 36.3663902282715, 0.63471324654843, -88.6544418334961, -1.54731190651231, 218, 50, 'PPL', 'P'),
(64665, 'Fancy (historical)', 35.3083305358887, 0.616246621233711, -81.394172668457, -1.42059630500135, 218, 33, 'PPL', 'P'),
(21028, 'Fancy Bluff', 31.139720916748, 0.5434906581494, -81.5583267211914, -1.42346133370206, 218, 13, 'PPL', 'P'),
(35850, 'Fancy Farm', 36.7994384765625, 0.642271364301102, -88.791389465332, -1.54970209359065, 218, 21, 'PPL', 'P'),
(101871, 'Fancy Gap', 36.665828704834, 0.639939433871601, -80.692497253418, -1.40834975872862, 218, 53, 'PPL', 'P'),
(101873, 'Fancy Grove (historical)', 37.1472206115723, 0.648341307636638, -79.533332824707, -1.38811852287562, 218, 53, 'PPL', 'P'),
(21029, 'Fancy Hall', 31.7686100006104, 0.554466843292648, -81.245002746582, -1.41799279871969, 218, 13, 'PPL', 'P'),
(101875, 'Fancy Hill', 37.6775016784668, 0.657596458214936, -79.5005569458008, -1.38754647587347, 218, 53, 'PPL', 'P'),
(27144, 'Fancy Prairie', 39.997501373291, 0.698088091534882, -89.5994415283203, -1.56380526261733, 218, 18, 'PPL', 'P'),
(119595, 'Fandon', 40.3683280944824, 0.704560238774047, -90.7613906860352, -1.58408510116023, 218, 18, 'PPL', 'P'),
(181536, 'Fane', 36.3699989318848, 0.63477623030821, -119.133613586426, -2.07927380688178, 218, 6, 'PPL', 'P'),
(86935, 'Fanetta Gardens', 35.1800003051758, 0.614006836177927, -85.2305603027344, -1.48755390060229, 218, 50, 'PPL', 'P'),
(124814, 'Faneuil', 42.3555603027344, 0.739243983809721, -71.1638870239258, -1.24204413708477, 218, 23, 'PPL', 'P'),
(15987, 'Fanlew', 30.271390914917, 0.5283354406236, -84.057502746582, -1.46708018393203, 218, 12, 'PPL', 'P'),
(47010, 'Fannells Meadow', 39.2080612182617, 0.684309761582166, -76.0930633544922, -1.32807449346453, 218, 25, 'PPL', 'P'),
(94171, 'Fannett', 29.9258308410645, 0.522304279571439, -94.2505569458008, -1.64498254054263, 218, 51, 'PPL', 'P'),
(161539, 'Fannettsburg', 40.064998626709, 0.699266140843078, -77.829719543457, -1.3583848619371, 218, 45, 'PPL', 'P'),
(8843, 'Fannie', 34.6994400024414, 0.605619476640832, -93.4494400024414, -1.6310004121875, 218, 4, 'PPL', 'P'),
(35851, 'Fannin', 38.0683288574219, 0.664417679293983, -83.0897216796875, -1.45018921787626, 218, 21, 'PPL', 'P'),
(59888, 'Fannin', 32.4172210693359, 0.565787242006789, -89.956672668457, -1.57004012220337, 218, 30, 'PPL', 'P'),
(94172, 'Fannin', 28.6952800750732, 0.500827117091954, -97.2355575561523, -1.69708062936731, 218, 51, 'PPL', 'P'),
(32431, 'Fanning', 39.8347206115723, 0.695247031283985, -95.1611099243164, -1.66087468803157, 218, 20, 'PPL', 'P'),
(54720, 'Fanning', 38.0372200012207, 0.663874727326743, -91.4697189331055, -1.59644776125649, 218, 29, 'PPL', 'P'),
(59884, 'Fanning', 31.0597190856934, 0.542094362789872, -89.5444412231445, -1.56284532620241, 218, 30, 'PPL', 'P'),
(15988, 'Fanning Springs', 29.5905609130859, 0.516452715445289, -82.929443359375, -1.44739183346724, 218, 12, 'PPL', 'P'),
(2415, 'Fannings Crossing', 34.8838882446289, 0.60883870576652, -86.4427795410156, -1.50871111756632, 218, 2, 'PPL', 'P'),
(109169, 'Fanny', 37.5636100769043, 0.6556086747773, -81.6294403076172, -1.42470249992809, 218, 58, 'PPL', 'P'),
(109170, 'Fanrock', 37.5669403076172, 0.655666798268091, -81.6522216796875, -1.42510010987884, 218, 58, 'PPL', 'P'),
(75817, 'Fanshawe', 34.9508285522461, 0.610007034536737, -94.9080581665039, -1.65645810167979, 218, 42, 'PPL', 'P'),
(115539, 'Fanslers', 41.749439239502, 0.728665175590626, -94.4555587768555, -1.64856049746716, 218, 16, 'PPL', 'P'),
(21031, 'Fantasy Hills', 34.9458312988281, 0.609919816011037, -85.3308334350586, -1.48930399691264, 218, 13, 'PPL', 'P'),
(148764, 'Fantinekill', 41.8019409179688, 0.729581502742696, -74.3050003051758, -1.29686690602071, 218, 40, 'PPL', 'P'),
(145207, 'Fanwood', 40.6408309936523, 0.709316311585792, -74.3838882446289, -1.29824376030428, 218, 37, 'PPL', 'P'),
(145209, 'Far Hills', 40.6841697692871, 0.710072715914402, -74.6361083984375, -1.30264583242813, 218, 37, 'PPL', 'P'),
(148747, 'Far Rockaway', 40.605281829834, 0.708695861630831, -73.7555618286133, -1.28727739556755, 218, 40, 'PPL', 'P'),
(119594, 'Far View', 41.9569396972656, 0.732286741777998, -88.4177780151367, -1.54318134366159, 218, 18, 'PPL', 'P'),
(54721, 'Far West', 39.6711082458496, 0.692391456805148, -94.1313934326172, -1.64290274488934, 218, 29, 'PPL', 'P'),
(29770, 'Farabee', 38.5569381713867, 0.67294552057858, -86.0158309936523, -1.50125945967822, 218, 19, 'PPL', 'P'),
(109171, 'Faraday', 37.2063903808594, 0.649374014928343, -81.6374969482422, -1.42484311483365, 218, 58, 'PPL', 'P'),
(54722, 'Farber', 39.2724990844727, 0.685434414510507, -91.5744400024414, -1.59827548871261, 218, 29, 'PPL', 'P'),
(145211, 'Fardale', 41.040828704834, 0.716297588646353, -74.1769409179688, -1.29463184807586, 218, 37, 'PPL', 'P'),
(203943, 'Fardown Estates', 40.6425018310547, 0.709345473199729, -111.831939697266, -1.95183555660904, 218, 52, 'PPL', 'P'),
(8844, 'Farelly Lake', 34.1047210693359, 0.595239673134193, -91.5305633544922, -1.59750969674115, 218, 4, 'PPL', 'P'),
(8845, 'Farewell', 36.392219543457, 0.635164053141953, -93.3694381713867, -1.62960411682797, 218, 4, 'PPL', 'P'),
(54723, 'Farewell', 36.5011100769043, 0.637064551474861, -91.3613891601563, -1.59455705004058, 218, 29, 'PPL', 'P'),
(80968, 'Farewell Corner', 33.2227783203125, 0.579846868349644, -79.7474975585938, -1.3918564026236, 218, 48, 'PPL', 'P'),
(59885, 'Farewells (historical)', 33.1624984741211, 0.578794786561009, -88.7777786254883, -1.54946453962142, 218, 30, 'PPL', 'P'),
(200809, 'Fargher (historical)', 45.2638893127441, 0.790003900765659, -121.021667480469, -2.11222656378793, 218, 43, 'PPL', 'P'),
(207391, 'Fargher Lake', 45.8886108398438, 0.800907348321634, -122.513061523438, -2.13825630028236, 218, 56, 'PPL', 'P'),
(8846, 'Fargo', 34.9513893127441, 0.610016821653743, -91.1800003051758, -1.59139121729475, 218, 4, 'PPL', 'P'),
(21032, 'Fargo', 30.6816692352295, 0.535496148162605, -82.5666732788086, -1.44106030113363, 218, 13, 'PPL', 'P'),
(27145, 'Fargo', 39.9736099243164, 0.697671107087203, -90.8547210693359, -1.58571402364098, 218, 18, 'PPL', 'P'),
(75812, 'Fargo', 36.3761100769043, 0.634882889909868, -99.6233291625977, -1.73875510568541, 218, 42, 'PPL', 'P'),
(94174, 'Fargo', 34.2947196960449, 0.598555774744533, -99.2772216796875, -1.73271439054284, 218, 51, 'PPL', 'P'),
(122600, 'Fargo', 40.5188903808594, 0.707188046400655, -87.2794418334961, -1.52331362929738, 218, 19, 'PPL', 'P'),
(130753, 'Fargo', 43.1030616760254, 0.752290343936828, -82.6591720581055, -1.44267470938644, 218, 27, 'PPL', 'P'),
(140003, 'Fargo', 46.8772201538086, 0.818161835866203, -96.789436340332, -1.68929434528824, 218, 34, 'PPL', 'P'),
(148748, 'Fargo', 44.0338897705078, 0.768536358955612, -75.5824966430664, -1.31916342329907, 218, 40, 'PPL', 'P'),
(155230, 'Fargo', 40.3580589294434, 0.704381008032685, -82.8313903808594, -1.44568048615076, 218, 41, 'PPL', 'P'),
(174073, 'Fargo', 43.4558296203613, 0.758447306060983, -90.9572219848633, -1.58750300210324, 218, 57, 'PPL', 'P'),
(181537, 'Fargo (historical)', 36.6369400024414, 0.639435230898222, -119.513893127441, -2.08591093695048, 218, 6, 'PPL', 'P'),
(32432, 'Farhman', 38.5794410705566, 0.673338270260339, -98.498893737793, -1.71913000529651, 218, 20, 'PPL', 'P'),
(181541, 'Faria', 34.3180618286133, 0.598963171812288, -119.386672973633, -2.08369052639162, 218, 6, 'PPL', 'P'),
(135325, 'Faribault', 44.2949981689453, 0.773093560212955, -93.2686080932617, -1.62784429997965, 218, 28, 'PPL', 'P'),
(27146, 'Faries Park (historical)', 39.8713912963867, 0.695887055472958, -88.8769378662109, -1.5511951948558, 218, 18, 'PPL', 'P'),
(64666, 'Faries Trailer Park', 34.7558288574219, 0.606603647821671, -77.4897232055664, -1.35245080639619, 218, 33, 'PPL', 'P'),
(2416, 'Farill', 34.2461090087891, 0.597707358200261, -85.4933319091797, -1.49214013031552, 218, 2, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(27147, 'Farina', 38.834171295166, 0.677784151384118, -88.772216796875, -1.54936746739968, 218, 18, 'PPL', 'P'),
(8847, 'Farindale', 34.0927810668945, 0.595031280778895, -92.408332824707, -1.61282966406989, 218, 4, 'PPL', 'P'),
(54724, 'Faris', 36.1855583190918, 0.631557134340577, -89.7986068725586, -1.56728135363016, 218, 29, 'PPL', 'P'),
(47011, 'Farish Farms', 39.0083312988281, 0.680823816873307, -76.595832824707, -1.33684947609829, 218, 25, 'PPL', 'P'),
(186704, 'Farisita', 37.7447204589844, 0.658769647254143, -105.070831298828, -1.83383195397206, 218, 7, 'PPL', 'P'),
(35852, 'Fariston', 37.0699996948242, 0.646993548387976, -84.0566711425781, -1.46706566970409, 218, 21, 'PPL', 'P'),
(29769, 'Farlen', 38.8505592346191, 0.678070174885192, -86.9227828979492, -1.51708875656543, 218, 19, 'PPL', 'P'),
(35853, 'Farler', 37.1547203063965, 0.648472202004215, -83.1922225952148, -1.45197819633852, 218, 21, 'PPL', 'P'),
(2417, 'Farley', 34.5952796936035, 0.603801536301716, -86.5622177124023, -1.51079570690957, 218, 2, 'PPL', 'P'),
(54725, 'Farley', 39.2822189331055, 0.685604057871945, -94.8311080932617, -1.65511506954206, 218, 29, 'PPL', 'P'),
(109172, 'Farley', 37.535831451416, 0.655123846300851, -80.9241714477539, -1.41239323621169, 218, 58, 'PPL', 'P'),
(115537, 'Farley', 42.4427795410156, 0.74076624668881, -91.0061111450195, -1.5883562789165, 218, 16, 'PPL', 'P'),
(124815, 'Farley', 42.5999984741211, 0.743510234717974, -72.4394378662109, -1.26430669905924, 218, 23, 'PPL', 'P'),
(181538, 'Farley', 39.6147193908691, 0.691407285624309, -123.366111755371, -2.15314483551451, 218, 6, 'PPL', 'P'),
(188543, 'Farley', 36.3527793884277, 0.634475692579195, -104.038612365723, -1.81581633498795, 218, 38, 'PPL', 'P'),
(181539, 'Farley (historical)', 36.9686088562012, 0.645223944422645, -121.893058776855, -2.1274352109831, 218, 6, 'PPL', 'P'),
(101877, 'Farley Park Corner', 37.6425018310547, 0.656985595639899, -76.6763916015625, -1.33825549199579, 218, 53, 'PPL', 'P'),
(148749, 'Farleys', 42.8180618286133, 0.747316158231806, -76.6999969482422, -1.33866748301643, 218, 40, 'PPL', 'P'),
(29771, 'Farleys Addition', 39.7833290100098, 0.694350078628847, -86.2788925170898, -1.50585074939752, 218, 19, 'PPL', 'P'),
(115538, 'Farlin', 42.0763893127441, 0.734371530858339, -94.4483337402344, -1.64843439678954, 218, 16, 'PPL', 'P'),
(32433, 'Farlington', 37.6177787780762, 0.656554096964278, -94.8274993896484, -1.65505208578228, 218, 20, 'PPL', 'P'),
(32434, 'Farlinville', 38.2333297729492, 0.66729748853874, -94.8536071777344, -1.65550775264479, 218, 20, 'PPL', 'P'),
(15989, 'Farm Hill', 30.6136093139648, 0.534308278447889, -87.3536071777344, -1.52460805874522, 218, 12, 'PPL', 'P'),
(124816, 'Farm Hill', 42.4938888549805, 0.741658272495932, -71.0911102294922, -1.24077394240286, 218, 23, 'PPL', 'P'),
(203948, 'Farm Meadows', 40.5305595397949, 0.707391711645019, -111.930557250977, -1.95355675762155, 218, 52, 'PPL', 'P'),
(119596, 'Farm Ridge', 41.2249984741211, 0.719511957503051, -88.9130630493164, -1.55182569824388, 218, 18, 'PPL', 'P'),
(161542, 'Farm School', 40.2944412231445, 0.703270669595203, -75.1730575561523, -1.31201736314606, 218, 45, 'PPL', 'P'),
(124820, 'Farm Street Station', 42.2108306884766, 0.736717975515781, -71.3147201538086, -1.24467667182232, 218, 23, 'PPL', 'P'),
(13766, 'Farm View Park', 38.8761100769043, 0.678516121209726, -75.4483337402344, -1.31682183891062, 218, 10, 'PPL', 'P'),
(47012, 'Farmbrook', 39.389720916748, 0.687480321438933, -77.4380569458008, -1.35154906005109, 218, 25, 'PPL', 'P'),
(161540, 'Farmbrook', 40.1427803039551, 0.700623687208746, -74.8358306884766, -1.30613164397893, 218, 45, 'PPL', 'P'),
(47013, 'Farmcrest', 39.6736106872559, 0.692435132647025, -75.9541702270508, -1.32565035108229, 218, 25, 'PPL', 'P'),
(15990, 'Farmdale', 30.0177803039551, 0.52390910044432, -85.4697189331055, -1.49172800613683, 218, 12, 'PPL', 'P'),
(21033, 'Farmdale', 32.6994400024414, 0.570712891600945, -81.6102828979492, -1.42436814005323, 218, 13, 'PPL', 'P'),
(35854, 'Farmdale', 38.1094398498535, 0.665135201470677, -84.9166717529297, -1.48207551192389, 218, 21, 'PPL', 'P'),
(80960, 'Farmdale', 32.9730606079102, 0.575488472067675, -80.220832824707, -1.40011766148308, 218, 48, 'PPL', 'P'),
(109182, 'Farmdale', 37.9047203063965, 0.661562171394173, -80.7111129760742, -1.40867466438161, 218, 58, 'PPL', 'P'),
(119598, 'Farmdale', 40.665828704834, 0.709752603951374, -89.5111083984375, -1.56226355866228, 218, 18, 'PPL', 'P'),
(155231, 'Farmdale', 41.436939239502, 0.723211021678144, -80.6083297729492, -1.40688075907134, 218, 41, 'PPL', 'P'),
(161541, 'Farmdale', 40.0686111450195, 0.699329191181886, -76.4686126708984, -1.33462906553943, 218, 45, 'PPL', 'P'),
(21034, 'Farmdale (historical)', 33.2347183227539, 0.580055260704943, -84.6211090087891, -1.4769169688924, 218, 13, 'PPL', 'P'),
(54726, 'Farmer', 39.2572212219238, 0.685167765506362, -91.3091735839844, -1.59364571631556, 218, 29, 'PPL', 'P'),
(64667, 'Farmer', 35.6533317565918, 0.62226802845838, -79.9772186279297, -1.39586579164471, 218, 33, 'PPL', 'P'),
(155232, 'Farmer', 41.3830604553223, 0.722270659497237, -84.6305618286133, -1.47708195172193, 218, 41, 'PPL', 'P'),
(170287, 'Farmer', 43.7238883972168, 0.763125814305979, -97.6880569458008, -1.70497823357994, 218, 49, 'PPL', 'P'),
(191454, 'Farmer', 33.7833290100098, 0.589630323509187, -101.456672668457, -1.77075298618272, 218, 51, 'PPL', 'P'),
(207392, 'Farmer', 47.6127815246582, 0.830999803638011, -119.810829162598, -2.09109344843177, 218, 56, 'PPL', 'P'),
(119599, 'Farmer City', 40.2433280944824, 0.702378577209054, -88.6425018310547, -1.54710351415701, 218, 18, 'PPL', 'P'),
(86937, 'Farmer Mill', 36.2358283996582, 0.632434512761703, -81.9644393920898, -1.43054933694331, 218, 50, 'PPL', 'P'),
(190193, 'Farmer Station', 37.2511100769043, 0.650154520864818, -117.003059387207, -2.04208862121322, 218, 39, 'PPL', 'P'),
(876, 'Farmers', 39.9174995422363, 0.696691796175353, -76.9113922119141, -1.34235702639062, 218, 45, 'PPL', 'P'),
(29773, 'Farmers', 39.6988906860352, 0.692876351860624, -85.5372161865234, -1.49290605544502, 218, 19, 'PPL', 'P'),
(35855, 'Farmers', 38.1427803039551, 0.66571710216886, -83.5461120605469, -1.45815473269669, 218, 21, 'PPL', 'P'),
(40883, 'Farmers', 29.8619403839111, 0.521189180733509, -91.6369400024414, -1.5993663194951, 218, 22, 'PPL', 'P'),
(72522, 'Farmers', 39.3216705322266, 0.686292618171785, -83.7636108398438, -1.46195080251449, 218, 41, 'PPL', 'P'),
(101878, 'Farmers', 36.9666709899902, 0.645190122276801, -79.4052810668945, -1.38588359808883, 218, 53, 'PPL', 'P'),
(194180, 'Farmers', 40.4519386291504, 0.706019517893356, -104.778610229492, -1.82873173416845, 218, 7, 'PPL', 'P'),
(94176, 'Farmers Academy', 33.1580696105957, 0.578717488310369, -95.0252380371094, -1.65850327623891, 218, 51, 'PPL', 'P'),
(94177, 'Farmers Branch', 32.9263916015625, 0.574673944248275, -96.8958282470703, -1.6911512343583, 218, 51, 'PPL', 'P'),
(139153, 'Farmers City', 40.5530586242676, 0.707784394747751, -95.4488906860352, -1.66589740984746, 218, 29, 'PPL', 'P'),
(148750, 'Farmers Corner', 43.5508308410645, 0.760105390155666, -76.1272201538086, -1.32867064207454, 218, 40, 'PPL', 'P'),
(130754, 'Farmers Creek', 42.9627799987793, 0.749841966788664, -83.3399963378906, -1.45455733469621, 218, 27, 'PPL', 'P'),
(101880, 'Farmers Fork', 38.0377807617188, 0.663884514443749, -76.795280456543, -1.34033049395913, 218, 53, 'PPL', 'P'),
(21035, 'Farmers High', 33.5325012207031, 0.585252552730287, -85.1883316040039, -1.48681687077061, 218, 13, 'PPL', 'P'),
(75813, 'Farmers Hill', 33.9244384765625, 0.592093148306265, -95.017219543457, -1.65836332712363, 218, 42, 'PPL', 'P'),
(35859, 'Farmers Mill', 36.8144416809082, 0.642533219615284, -83.2830581665039, -1.45356357613545, 218, 21, 'PPL', 'P'),
(148752, 'Farmers Mills', 41.4955596923828, 0.724234141589926, -73.7397232055664, -1.2870009594464, 218, 40, 'PPL', 'P'),
(161543, 'Farmers Mills', 40.8655586242676, 0.713238548660234, -77.607780456543, -1.35451129413158, 218, 45, 'PPL', 'P'),
(29774, 'Farmers Retreat', 38.976390838623, 0.680266350678126, -85.1022186279297, -1.48531391580942, 218, 19, 'PPL', 'P'),
(101881, 'Farmers Shop Corner', 37.6419410705566, 0.656975808522893, -77.195556640625, -1.34731663128868, 218, 53, 'PPL', 'P'),
(101882, 'Farmers Store', 36.9297218322754, 0.644545237818839, -80.9411087036133, -1.41268884709269, 218, 53, 'PPL', 'P'),
(64668, 'Farmers Union', 34.4150009155273, 0.600655078052815, -78.6094436645508, -1.37199361510741, 218, 33, 'PPL', 'P'),
(86938, 'Farmers Union Landing', 35.3630599975586, 0.617201830537695, -88.204719543457, -1.53946277183151, 218, 50, 'PPL', 'P'),
(94178, 'Farmers Valley', 34.1674880981445, 0.596335164448598, -99.4557495117188, -1.73583028901823, 218, 51, 'PPL', 'P'),
(161545, 'Farmers Valley', 41.8608283996582, 0.730609283186384, -78.4488906860352, -1.36919143700843, 218, 45, 'PPL', 'P'),
(174074, 'Farmers Valley', 43.899169921875, 0.766185054029181, -90.7477798461914, -1.58384754719099, 218, 57, 'PPL', 'P'),
(29784, 'Farmersburg', 39.2486114501953, 0.685017496641855, -87.3819427490234, -1.52510260775964, 218, 19, 'PPL', 'P'),
(115540, 'Farmersburg', 42.961109161377, 0.749812805174728, -91.3677825927734, -1.59466863649026, 218, 16, 'PPL', 'P'),
(155234, 'Farmerstown', 40.4872207641602, 0.706635307316409, -81.725830078125, -1.4263848187887, 218, 41, 'PPL', 'P'),
(2418, 'Farmersville', 32.0780601501465, 0.559867767272843, -86.8919372558594, -1.51655039855107, 218, 2, 'PPL', 'P'),
(21036, 'Farmersville', 34.4861106872559, 0.601896177699819, -85.230827331543, -1.4875585611342, 218, 13, 'PPL', 'P'),
(27148, 'Farmersville', 39.4433288574219, 0.688415956508905, -89.6516723632813, -1.56471686265846, 218, 18, 'PPL', 'P'),
(29775, 'Farmersville', 37.980281829834, 0.66288096876598, -87.896110534668, -1.53407652852683, 218, 19, 'PPL', 'P'),
(35856, 'Farmersville', 37.2024993896484, 0.649306104320546, -87.9069366455078, -1.53426547980617, 218, 21, 'PPL', 'P'),
(54727, 'Farmersville', 39.9608306884766, 0.697448067345908, -93.5416717529297, -1.6326101599084, 218, 29, 'PPL', 'P'),
(72523, 'Farmersville', 39.6794395446777, 0.692536865400666, -84.4291687011719, -1.47356697855719, 218, 41, 'PPL', 'P'),
(94179, 'Farmersville', 33.163330078125, 0.57880930078895, -96.3597183227539, -1.68179435102636, 218, 51, 'PPL', 'P'),
(124817, 'Farmersville', 41.6902809143066, 0.727632668036003, -70.4441680908203, -1.22948267201314, 218, 23, 'PPL', 'P'),
(145212, 'Farmersville', 40.7261085510254, 0.71080468574001, -74.8072204589844, -1.30563230127454, 218, 37, 'PPL', 'P'),
(148753, 'Farmersville', 42.3875007629395, 0.739801450004902, -78.3763885498047, -1.36792603601648, 218, 40, 'PPL', 'P'),
(161547, 'Farmersville', 40.666389465332, 0.70976239106838, -75.3058319091797, -1.31433471276859, 218, 45, 'PPL', 'P'),
(174075, 'Farmersville', 43.5583305358887, 0.760236284523243, -88.5313873291016, -1.54516420025121, 218, 57, 'PPL', 'P'),
(181542, 'Farmersville', 36.297779083252, 0.633515756164275, -119.205833435059, -2.08053428102571, 218, 6, 'PPL', 'P'),
(148754, 'Farmersville Station', 42.4275016784668, 0.740499597684666, -78.3611068725586, -1.3676593204333, 218, 40, 'PPL', 'P'),
(40880, 'Farmerville', 32.7733306884766, 0.572002527358816, -92.4055633544922, -1.6127813276961, 218, 22, 'PPL', 'P'),
(47014, 'Farmfield Estates', 39.3402786254883, 0.68661739066672, -77.2344436645508, -1.34799533789249, 218, 25, 'PPL', 'P'),
(80961, 'Farmfields', 34.9869384765625, 0.610637271608705, -81.8966674804688, -1.42936649394515, 218, 48, 'PPL', 'P'),
(59886, 'Farmhaven', 32.6474990844727, 0.569806351565882, -89.8105621337891, -1.56749001230156, 218, 30, 'PPL', 'P'),
(135330, 'Farming', 45.5152816772461, 0.794391525240591, -94.5977783203125, -1.65104269676116, 218, 28, 'PPL', 'P'),
(27149, 'Farmingdale', 39.8227806091309, 0.695038638928687, -89.8061065673828, -1.56741224799773, 218, 18, 'PPL', 'P'),
(101883, 'Farmingdale', 37.2569389343262, 0.650256253618459, -80.039436340332, -1.39695169557919, 218, 53, 'PPL', 'P'),
(127468, 'Farmingdale', 44.2444381713867, 0.772211121785757, -69.7719421386719, -1.2177501158308, 218, 26, 'PPL', 'P'),
(145213, 'Farmingdale', 40.1963882446289, 0.701559322278718, -74.1688919067383, -1.29449136632836, 218, 37, 'PPL', 'P'),
(148757, 'Farmingdale', 41.4002799987793, 0.722571197226253, -74.2366714477539, -1.29567434248457, 218, 40, 'PPL', 'P'),
(172012, 'Farmingdale', 43.9647216796875, 0.767329148033479, -73.1355590820313, -1.27645630626829, 218, 55, 'PPL', 'P'),
(202119, 'Farmingdale', 43.959171295166, 0.767232275548827, -102.883331298828, -1.79565287658468, 218, 49, 'PPL', 'P'),
(47016, 'Farmingdale Estates', 39.1558303833008, 0.683398161541032, -77.2750015258789, -1.34870320611023, 218, 25, 'PPL', 'P'),
(8849, 'Farmington', 36.0419387817383, 0.629050500543567, -94.246940612793, -1.6449194236248, 218, 4, 'PPL', 'P'),
(13745, 'Farmington', 38.8691711425781, 0.678395013959155, -75.5788879394531, -1.31910043953929, 218, 10, 'PPL', 'P'),
(21040, 'Farmington', 33.7761116027832, 0.589504355989626, -83.4236068725586, -1.45601661381552, 218, 13, 'PPL', 'P'),
(29776, 'Farmington', 39.6180610656738, 0.691465608852182, -85.35888671875, -1.48979361907905, 218, 19, 'PPL', 'P'),
(32436, 'Farmington', 39.5186080932617, 0.689729827032695, -95.309440612793, -1.66346354692724, 218, 20, 'PPL', 'P'),
(35857, 'Farmington', 36.6694412231445, 0.640002484210409, -88.5258331298828, -1.54506726118753, 218, 21, 'PPL', 'P'),
(47018, 'Farmington', 39.6319389343262, 0.691707823353324, -76.5397186279297, -1.33587009860741, 218, 25, 'PPL', 'P'),
(54728, 'Farmington', 37.7808303833008, 0.65939988432611, -90.4216690063477, -1.57815583930928, 218, 29, 'PPL', 'P'),
(59887, 'Farmington', 34.9300003051758, 0.609643513047942, -88.4522171020508, -1.54378241911962, 218, 30, 'PPL', 'P'),
(64669, 'Farmington', 36.0155601501465, 0.628590106570119, -80.5325012207031, -1.40555730116762, 218, 33, 'PPL', 'P'),
(80962, 'Farmington', 32.7272186279297, 0.571197720077394, -79.9527816772461, -1.39543928639614, 218, 48, 'PPL', 'P'),
(86941, 'Farmington', 35.9808311462402, 0.627983971106017, -86.8755569458008, -1.51626450820805, 218, 50, 'PPL', 'P'),
(94180, 'Farmington', 33.4688911437988, 0.58414234745086, -96.6449966430664, -1.68677339700038, 218, 51, 'PPL', 'P'),
(101885, 'Farmington', 37.2291717529297, 0.649771624879092, -80.0236129760742, -1.39667552577415, 218, 53, 'PPL', 'P'),
(109174, 'Farmington', 39.5127792358398, 0.689628094279054, -80.2491683959961, -1.40061221049751, 218, 58, 'PPL', 'P'),
(113424, 'Farmington', 41.7197189331055, 0.728146458389306, -72.8324966430664, -1.27116686886923, 218, 8, 'PPL', 'P'),
(115542, 'Farmington', 40.6402816772461, 0.709306724205868, -91.7427825927734, -1.60121362118524, 218, 16, 'PPL', 'P'),
(119601, 'Farmington', 41.9447212219238, 0.73207348915371, -88.3158264160156, -1.54140195257926, 218, 18, 'PPL', 'P'),
(127470, 'Farmington', 44.6705589294434, 0.77964833202494, -70.1516723632813, -1.22437765851957, 218, 26, 'PPL', 'P'),
(130755, 'Farmington', 42.4644393920898, 0.741144282405547, -83.3763885498047, -1.45519249861619, 218, 27, 'PPL', 'P'),
(135332, 'Farmington', 44.6402816772461, 0.779119894285641, -93.1433334350586, -1.62565784472469, 218, 28, 'PPL', 'P'),
(140005, 'Farmington', 46.2677803039551, 0.807525103893399, -96.751106262207, -1.68862535922242, 218, 34, 'PPL', 'P'),
(143818, 'Farmington', 43.389720916748, 0.757293491518706, -71.065559387207, -1.24032799607833, 218, 36, 'PPL', 'P'),
(148759, 'Farmington', 42.9836082458496, 0.75020548827746, -77.3261108398438, -1.34959523191735, 218, 40, 'PPL', 'P'),
(155236, 'Farmington', 41.3905601501465, 0.722401553864815, -80.954719543457, -1.41292640106193, 218, 41, 'PPL', 'P'),
(161549, 'Farmington', 40.5902786254883, 0.708434006316649, -75.4322204589844, -1.31654060909951, 218, 45, 'PPL', 'P'),
(174076, 'Farmington', 43.0761108398438, 0.751819963109293, -88.6719436645508, -1.54761737108934, 218, 57, 'PPL', 'P'),
(181543, 'Farmington', 37.9300003051758, 0.662003390607771, -120.999168395996, -2.1118338806852, 218, 6, 'PPL', 'P'),
(188544, 'Farmington', 36.7280616760254, 0.64102560412219, -108.218063354492, -1.88876151566771, 218, 38, 'PPL', 'P'),
(196462, 'Farmington', 47.8869400024414, 0.835784771747584, -112.168060302734, -1.95770196785826, 218, 31, 'PPL', 'P'),
(200810, 'Farmington', 45.4491691589355, 0.793237644119287, -122.946670532227, -2.14582420515204, 218, 43, 'PPL', 'P'),
(203949, 'Farmington', 40.9805603027344, 0.715245706594799, -111.886672973633, -1.95279083249205, 218, 52, 'PPL', 'P'),
(207393, 'Farmington', 47.0894393920898, 0.821865760310285, -117.043060302734, -2.04278676889299, 218, 56, 'PPL', 'P'),
(80963, 'Farmington Acres', 34.8680610656738, 0.608562469382451, -82.4591674804688, -1.43918397098762, 218, 48, 'PPL', 'P'),
(130756, 'Farmington Acres', 42.4449996948242, 0.740804995682671, -83.3855590820313, -1.45535255459771, 218, 27, 'PPL', 'P'),
(86942, 'Farmington Estates', 35.9008293151855, 0.626587675746489, -86.3433303833008, -1.50697540232586, 218, 50, 'PPL', 'P'),
(127471, 'Farmington Falls', 44.6208305358887, 0.778780407825683, -70.0758285522461, -1.22305393429975, 218, 26, 'PPL', 'P'),
(161550, 'Farmington Hill', 41.9225006103516, 0.731685666319967, -77.2413864135742, -1.34811651172208, 218, 45, 'PPL', 'P'),
(130757, 'Farmington Hills', 42.485279083252, 0.741508003631425, -83.3772201538086, -1.45520701284413, 218, 27, 'PPL', 'P'),
(101886, 'Farmington Lake', 37.230281829834, 0.649790999376022, -80.0233306884766, -1.39667059892614, 218, 53, 'PPL', 'P'),
(203953, 'Farmington Orchards', 41.0055618286133, 0.715682065539409, -111.898063659668, -1.95298963746742, 218, 52, 'PPL', 'P'),
(47019, 'Farmington Road Estates', 38.6722183227539, 0.674957538782135, -77.023063659668, -1.3443060608344, 218, 25, 'PPL', 'P'),
(113425, 'Farmington Station', 41.7208290100098, 0.728165832886237, -72.8633270263672, -1.27170496056748, 218, 8, 'PPL', 'P'),
(148761, 'Farmingville', 40.8311080932617, 0.712637273465121, -73.0299987792969, -1.27461393142617, 218, 40, 'PPL', 'P'),
(40882, 'Farmland', 31.5527801513672, 0.550699901799272, -92.3938903808594, -1.61257759587271, 218, 22, 'PPL', 'P'),
(122601, 'Farmland', 40.1877784729004, 0.701409053414211, -85.1275024414063, -1.48575520160205, 218, 19, 'PPL', 'P'),
(64674, 'Farmland Acres', 35.9261093139648, 0.627028894960088, -80.5522232055664, -1.40590151473852, 218, 33, 'PPL', 'P'),
(47020, 'Farmlands', 39.0744400024414, 0.681977631415584, -77.2816696166992, -1.34881958624987, 218, 25, 'PPL', 'P'),
(64675, 'Farmlife', 35.7350006103516, 0.623693418852818, -76.9797210693359, -1.34354958992676, 218, 33, 'PPL', 'P'),
(119604, 'Farmsville (historical)', 40.6208305358887, 0.70896723774591, -89.2397232055664, -1.55752699350552, 218, 18, 'PPL', 'P'),
(15991, 'Farmton', 28.8466701507568, 0.503469372367476, -81.0608291625977, -1.41477836328397, 218, 12, 'PPL', 'P'),
(2420, 'Farmville', 32.665828704834, 0.570126263791828, -85.4899978637695, -1.4920819402457, 218, 2, 'PPL', 'P'),
(8850, 'Farmville', 33.5155601501465, 0.584956875270261, -92.1902770996094, -1.60902387371411, 218, 4, 'PPL', 'P'),
(21042, 'Farmville', 34.4483299255371, 0.601236779013916, -84.8444366455078, -1.48081477146384, 218, 13, 'PPL', 'P'),
(64677, 'Farmville', 35.5952796936035, 0.62125482882166, -77.585563659668, -1.35412353787687, 218, 33, 'PPL', 'P'),
(101888, 'Farmville', 37.3019409179688, 0.651041686402951, -78.392219543457, -1.36820233897957, 218, 53, 'PPL', 'P'),
(86943, 'Farmville (historical)', 35.8097190856934, 0.624997502259603, -88.3055572509766, -1.54122272183789, 218, 50, 'PPL', 'P'),
(80964, 'Farmwood', 34.1777801513672, 0.596514794664123, -79.8861083984375, -1.39427561815783, 218, 48, 'PPL', 'P'),
(199316, 'Farnam', 40.7058296203613, 0.710450751631139, -100.21443939209, -1.74907192543227, 218, 35, 'PPL', 'P'),
(124818, 'Farnams', 42.5416717529297, 0.742492241391291, -73.1861114501953, -1.27733861153743, 218, 23, 'PPL', 'P'),
(2421, 'Farnell', 30.6433296203613, 0.534826995649209, -88.1033325195313, -1.53769323444521, 218, 2, 'PPL', 'P'),
(86944, 'Farner', 35.1541709899902, 0.613556029584404, -84.3152770996094, -1.47157919511956, 218, 50, 'PPL', 'P'),
(145215, 'Farnerville', 40.0694389343262, 0.6993436388308, -74.8647232055664, -1.30663591353134, 218, 37, 'PPL', 'P'),
(101889, 'Farnham', 37.8852806091309, 0.661222884671296, -76.6252822875977, -1.33736346618867, 218, 53, 'PPL', 'P'),
(148762, 'Farnham', 42.5944404602051, 0.743413229075267, -79.0913925170898, -1.38040520941042, 218, 40, 'PPL', 'P'),
(155238, 'Farnham', 41.9002799987793, 0.731297843486224, -80.5719375610352, -1.40624559515135, 218, 41, 'PPL', 'P'),
(155239, 'Farnham (historical)', 41.2319412231445, 0.71963313133265, -83.8822174072266, -1.4640208776298, 218, 41, 'PPL', 'P'),
(113427, 'Farnhams', 41.8627815246582, 0.730643371648337, -72.5599975585938, -1.26641086263651, 218, 8, 'PPL', 'P'),
(115545, 'Farnhamville', 42.2761116027832, 0.737857342409144, -94.4036102294922, -1.64765382427404, 218, 16, 'PPL', 'P'),
(13746, 'Farnhurst', 39.6930618286133, 0.692774619106983, -75.5777816772461, -1.31908113162139, 218, 10, 'PPL', 'P'),
(161554, 'Farnsworth', 40.7963905334473, 0.712031337738101, -76.6758270263672, -1.33824563829976, 218, 45, 'PPL', 'P'),
(191455, 'Farnsworth', 36.3211097717285, 0.633922953494949, -100.965827941895, -1.76218612958815, 218, 51, 'PPL', 'P'),
(29777, 'Farnsworth (historical)', 39.0991706848145, 0.682409263249258, -87.3236083984375, -1.52408448127491, 218, 19, 'PPL', 'P'),
(203954, 'Farnsworth Condominium', 40.6311111450195, 0.709146668224354, -111.84944152832, -1.95214102118607, 218, 52, 'PPL', 'P'),
(109175, 'Farnum', 39.3222198486328, 0.686302205551709, -80.3269424438477, -1.40196962370512, 218, 58, 'PPL', 'P'),
(194918, 'Farnum', 43.9986114501953, 0.767920636111585, -111.408889770508, -1.94445194248679, 218, 17, 'PPL', 'P'),
(124819, 'Farnumsville', 42.1769409179688, 0.736126487437674, -71.6813888549805, -1.25107624792178, 218, 23, 'PPL', 'P'),
(54729, 'Faro', 37.4472198486328, 0.653577282076815, -90.4375, -1.57843214227237, 218, 29, 'PPL', 'P'),
(64680, 'Faro', 35.5113906860352, 0.619790689433361, -77.8441696166992, -1.35863706329233, 218, 33, 'PPL', 'P'),
(161555, 'Farquhar', 40.1355590820313, 0.700497653110158, -80.0058288574219, -1.3963651343491, 218, 45, 'PPL', 'P'),
(78247, 'Farquhar Estates', 39.9438896179199, 0.697152389885882, -76.7222213745117, -1.3390553724292, 218, 45, 'PPL', 'P'),
(181544, 'Farr', 33.1302795410156, 0.578232460096838, -117.32861328125, -2.04777060855696, 218, 6, 'PPL', 'P'),
(203957, 'Farr West', 41.2972183227539, 0.720772431646986, -112.02693939209, -1.9552389433241, 218, 52, 'PPL', 'P'),
(35858, 'Farraday', 37.163890838623, 0.648632257985729, -82.7708282470703, -1.4446234775141, 218, 21, 'PPL', 'P'),
(86945, 'Farragut', 35.8844413757324, 0.626301652245414, -84.1536102294922, -1.46875757594462, 218, 50, 'PPL', 'P'),
(115546, 'Farragut', 40.7219390869141, 0.710731914863224, -95.4805603027344, -1.66645014893171, 218, 16, 'PPL', 'P'),
(161556, 'Farragut', 41.2930603027344, 0.720699860507281, -76.9069366455078, -1.34227926208679, 218, 45, 'PPL', 'P'),
(13092, 'Farragut Square', 38.9027786254883, 0.678981575189245, -77.0444412231445, -1.34467916970312, 218, 9, 'PPL', 'P'),
(209448, 'Farrall', 44.5838890075684, 0.778135656525775, -104.256942749023, -1.81962691903369, 218, 59, 'PPL', 'P'),
(196463, 'Farralltown', 46.3963890075684, 0.809769749218172, -108.548057556152, -1.89452100099917, 218, 31, 'PPL', 'P'),
(161557, 'Farrandsville', 41.1749992370605, 0.71863930619286, -77.5127792358398, -1.3528532100369, 218, 45, 'PPL', 'P'),
(130760, 'Farrandville', 43.1941719055176, 0.753880517423715, -83.7266693115234, -1.46130605121458, 218, 27, 'PPL', 'P'),
(21043, 'Farrar', 33.4627799987793, 0.584035687849203, -83.6341705322266, -1.45969164296177, 218, 13, 'PPL', 'P'),
(54730, 'Farrar', 37.702220916748, 0.658027890311528, -89.688606262207, -1.56536148080032, 218, 29, 'PPL', 'P'),
(64681, 'Farrar', 35.8952789306641, 0.626490803261837, -77.5430603027344, -1.35338171435523, 218, 33, 'PPL', 'P'),
(94181, 'Farrar', 31.4566707611084, 0.549022476497172, -96.2805633544922, -1.68041283621089, 218, 51, 'PPL', 'P'),
(115547, 'Farrar', 41.8058280944824, 0.729649346771465, -93.3697204589844, -1.62960904367599, 218, 16, 'PPL', 'P'),
(86946, 'Farrar Hill', 35.5780601501465, 0.620954291092644, -86.1622161865234, -1.50381436326999, 218, 50, 'PPL', 'P'),
(130761, 'Farrar Landing', 44.8766708374023, 0.783245663446392, -84.6044387817383, -1.47662601854331, 218, 27, 'PPL', 'P'),
(148763, 'Farrel Corner', 43.1711082458496, 0.753477980624949, -75.0719375610352, -1.31025248629166, 218, 40, 'PPL', 'P'),
(59889, 'Farrell', 34.2641716003418, 0.598022609894299, -90.6722183227539, -1.58252874981919, 218, 30, 'PPL', 'P'),
(161558, 'Farrell', 41.2122192382813, 0.719288917761757, -80.496940612793, -1.40493665147558, 218, 45, 'PPL', 'P'),
(199950, 'Farrell (historical)', 40.5244407653809, 0.707284918885307, -118.728057861328, -2.07219552417851, 218, 39, 'PPL', 'P'),
(80965, 'Farrell Crossroads', 33.2138900756836, 0.579691739216147, -80.8736114501953, -1.41151079778449, 218, 48, 'PPL', 'P'),
(80966, 'Farrells Mill', 33.3386116027832, 0.581868540512151, -81.3516693115234, -1.41985448147971, 218, 48, 'PPL', 'P'),
(54731, 'Farrenburg', 36.688060760498, 0.640327456442426, -89.5005569458008, -1.5620794010729, 218, 29, 'PPL', 'P'),
(190194, 'Farrier', 36.8127784729004, 0.642504191159402, -114.653060913086, -2.00107341042297, 218, 39, 'PPL', 'P'),
(27150, 'Farrington', 39.4700012207031, 0.688881477067451, -87.5461120605469, -1.52796790277646, 218, 18, 'PPL', 'P'),
(64682, 'Farrington', 35.8016700744629, 0.624857020512101, -79.0141677856445, -1.37905738358273, 218, 33, 'PPL', 'P'),
(86947, 'Farrington', 35.8888893127441, 0.62637928339119, -84.0627822875977, -1.46717232930575, 218, 50, 'PPL', 'P'),
(101890, 'Farrington', 37.7322196960449, 0.658551467781838, -77.5841674804688, -1.35409916995289, 218, 53, 'PPL', 'P'),
(155240, 'Farrington', 40.1055603027344, 0.699974075639849, -84.2313919067383, -1.47011512231029, 218, 41, 'PPL', 'P'),
(207397, 'Farrington', 46.5397186279297, 0.812271323009111, -118.577499389648, -2.06956778313093, 218, 56, 'PPL', 'P'),
(86948, 'Farrington Forest', 35.1772193908691, 0.613958300067061, -85.2222213745117, -1.48740835884872, 218, 50, 'PPL', 'P'),
(145216, 'Farrington Lake Heights', 40.4355583190918, 0.705733627550336, -74.4569396972656, -1.29951874867616, 218, 37, 'PPL', 'P'),
(75814, 'Farris', 34.2625007629395, 0.597993448280363, -95.8663864135742, -1.67318408490603, 218, 42, 'PPL', 'P'),
(135335, 'Farris', 47.3766708374023, 0.82687889474625, -94.7024993896484, -1.65287042421729, 218, 28, 'PPL', 'P'),
(207394, 'Farris', 47.6927795410156, 0.832396032418513, -120.315826416016, -2.09990731321744, 218, 56, 'PPL', 'P'),
(101891, 'Farris Heights', 37.204719543457, 0.649344853314407, -80.0497207641602, -1.39713119263667, 218, 53, 'PPL', 'P'),
(8851, 'Farris Springs', 35.644718170166, 0.622117693014845, -93.4633331298828, -1.63124289300475, 218, 4, 'PPL', 'P'),
(2422, 'Farriss (historical)', 34.0119400024414, 0.593620338033371, -87.5930633544922, -1.52878735744388, 218, 2, 'PPL', 'P'),
(35860, 'Farristown', 37.622501373291, 0.656636521800016, -84.3002777099609, -1.4713174063844, 218, 21, 'PPL', 'P'),
(207395, 'Farron', 46.4047203063965, 0.809915157813691, -120.520278930664, -2.10347568276204, 218, 56, 'PPL', 'P'),
(80967, 'Farrowoods', 34.103328704834, 0.595215371789246, -80.9408264160156, -1.41268392024467, 218, 48, 'PPL', 'P'),
(86949, 'Farrport', 35.8205604553223, 0.625186719855053, -83.978889465332, -1.46570812333842, 218, 50, 'PPL', 'P'),
(101893, 'Farrs Corner', 38.7422218322754, 0.676179330511236, -77.3411102294922, -1.34985702065251, 218, 53, 'PPL', 'P'),
(94182, 'Farrsville', 30.9833297729492, 0.540761117769151, -93.8072204589844, -1.63724485915346, 218, 51, 'PPL', 'P'),
(8853, 'Farrville', 35.8641700744629, 0.625947851294597, -90.6097183227539, -1.58143791903669, 218, 4, 'PPL', 'P'),
(122602, 'Farrville', 40.5811080932617, 0.708273950335135, -85.4663925170898, -1.49166994922506, 218, 19, 'PPL', 'P'),
(47021, 'Farside', 39.2497215270996, 0.685036871138785, -76.9175033569336, -1.34246368599228, 218, 25, 'PPL', 'P'),
(115548, 'Farson', 41.1222190856934, 0.717718118771801, -92.254997253418, -1.61015345349047, 218, 16, 'PPL', 'P'),
(209449, 'Farson', 42.1105613708496, 0.734967945784463, -109.440277099609, -1.91009316968313, 218, 59, 'PPL', 'P'),
(209450, 'Farthing', 41.5463905334473, 0.725121307128058, -105.214721679688, -1.83634331488001, 218, 59, 'PPL', 'P'),
(86950, 'Farthing (historical)', 36.3547210693359, 0.634509581304066, -81.970832824707, -1.43066092339298, 218, 50, 'PPL', 'P'),
(75816, 'Farwell', 34.8858299255371, 0.608872594491391, -98.0052795410156, -1.71051481232816, 218, 42, 'PPL', 'P'),
(130762, 'Farwell', 43.8349990844727, 0.765065061632748, -84.866943359375, -1.48120758772463, 218, 27, 'PPL', 'P'),
(135336, 'Farwell', 45.7522201538086, 0.798526881781266, -95.616943359375, -1.66883048231402, 218, 28, 'PPL', 'P'),
(141818, 'Farwell', 41.2155609130859, 0.71934724098963, -98.6277770996094, -1.72137944431125, 218, 35, 'PPL', 'P'),
(161560, 'Farwell', 41.3327789306641, 0.721393081339029, -77.7147216796875, -1.35637777058156, 218, 45, 'PPL', 'P'),
(170293, 'Farwell', 43.8505592346191, 0.765336637484909, -97.9111099243164, -1.70887124246142, 218, 49, 'PPL', 'P'),
(181545, 'Farwell', 37.598331451416, 0.656214677083348, -121.94416809082, -2.12832723679022, 218, 6, 'PPL', 'P'),
(191456, 'Farwell', 34.3833312988281, 0.600102338968569, -103.037498474121, -1.79834360139205, 218, 51, 'PPL', 'P'),
(127473, 'Farwells Corner', 44.577220916748, 0.778019276386139, -69.3083267211914, -1.20965850033276, 218, 26, 'PPL', 'P'),
(94183, 'Fashing', 28.7922191619873, 0.502519023332481, -98.1394424438477, -1.71285639671661, 218, 51, 'PPL', 'P'),
(72524, 'Fashion Heights', 39.1138916015625, 0.682666191715424, -84.6163864135742, -1.47683454405667, 218, 41, 'PPL', 'P'),
(161561, 'Fassett', 41.9861106872559, 0.732795871599394, -76.7736129760742, -1.33995232508434, 218, 45, 'PPL', 'P'),
(2423, 'Fatama', 31.898889541626, 0.556740650231358, -87.2355575561523, -1.52254770416788, 218, 2, 'PPL', 'P'),
(94184, 'Fate', 32.9413909912109, 0.574935732983429, -96.3811111450195, -1.68216772621119, 218, 51, 'PPL', 'P'),
(15992, 'Fatio', 28.9808292388916, 0.505810890176901, -81.3322219848633, -1.41951506159878, 218, 12, 'PPL', 'P'),
(196464, 'Fattig (historical)', 46.3650016784668, 0.809221936981943, -108.263328552246, -1.88955154240508, 218, 31, 'PPL', 'P'),
(200811, 'Faubion', 45.3433303833008, 0.791390409008181, -121.933891296387, -2.12814787289081, 218, 43, 'PPL', 'P'),
(94185, 'Faubion Crossing', 31.3905601501465, 0.547868628665382, -98.1897201538086, -1.71373390829579, 218, 51, 'PPL', 'P'),
(40884, 'Faubourg', 30.7138900756836, 0.536058507916289, -92.1688919067383, -1.60865063168734, 218, 22, 'PPL', 'P'),
(35861, 'Faubush', 37.0658302307129, 0.646920777511189, -84.8266677856445, -1.4805046463549, 218, 21, 'PPL', 'P'),
(54732, 'Faucett', 39.5999984741211, 0.691150357158144, -94.7972183227539, -1.65452358146395, 218, 29, 'PPL', 'P'),
(94186, 'Faught', 33.7372207641602, 0.588825582806792, -95.4205627441406, -1.66540299399109, 218, 51, 'PPL', 'P'),
(35868, 'Faulconer', 37.7069396972656, 0.658110248568239, -84.7777786254883, -1.47965136954164, 218, 21, 'PPL', 'P'),
(101892, 'Faulconerville', 37.5322189331055, 0.655060795962044, -79.1005630493164, -1.38056526539194, 218, 53, 'PPL', 'P'),
(13747, 'Faulkland', 39.747501373291, 0.693724768404896, -75.6358337402344, -1.32009433125811, 218, 10, 'PPL', 'P'),
(13748, 'Faulkland Heights', 39.7430610656738, 0.693647270417175, -75.6305618286133, -1.32000231904245, 218, 10, 'PPL', 'P'),
(13749, 'Faulkland Woods', 39.7486114501953, 0.693744142901826, -75.6374969482422, -1.32012335971399, 218, 10, 'PPL', 'P'),
(32440, 'Faulkner', 37.101390838623, 0.647541427203232, -95.0113906860352, -1.65826159436999, 218, 20, 'PPL', 'P'),
(47022, 'Faulkner', 38.4388885498047, 0.67088516600124, -76.9786071777344, -1.3435301488508, 218, 25, 'PPL', 'P'),
(94194, 'Faulkner', 33.8588905334473, 0.590949120880994, -95.3399963378906, -1.66399684493553, 218, 51, 'PPL', 'P'),
(109176, 'Faulkner', 38.9094390869141, 0.679097822170826, -79.7266693115234, -1.3914928811348, 218, 58, 'PPL', 'P'),
(115549, 'Faulkner', 42.6152801513672, 0.743776950301145, -93.0858306884766, -1.6246542324679, 218, 16, 'PPL', 'P'),
(124821, 'Faulkner', 42.4291687011719, 0.740528692719575, -71.0555572509766, -1.24015342586887, 218, 23, 'PPL', 'P'),
(64689, 'Faulkner Crossroads', 36.3161087036133, 0.633835668390221, -78.3622207641602, -1.36767876150926, 218, 33, 'PPL', 'P'),
(47023, 'Faulkner Ridge', 39.2236099243164, 0.684581137697245, -76.8777770996094, -1.34177033200248, 218, 25, 'PPL', 'P'),
(8855, 'Faulkner Springs', 34.3402786254883, 0.599350928067003, -94.0861129760742, -1.64211245183586, 218, 4, 'PPL', 'P'),
(86951, 'Faulkner Springs', 35.7172203063965, 0.623383094006797, -85.7616729736328, -1.49682356540853, 218, 50, 'PPL', 'P'),
(8857, 'Faulknerville', 36.1022186279297, 0.630102582332203, -90.7458267211914, -1.58381345872904, 218, 4, 'PPL', 'P'),
(170295, 'Faulkton', 45.0349998474121, 0.786009025972485, -99.1236114501953, -1.73003338627346, 218, 49, 'PPL', 'P'),
(64687, 'Fauna (historical)', 36.3847198486328, 0.635033158774375, -76.3033294677734, -1.33174432944666, 218, 33, 'PPL', 'P'),
(135338, 'Faunce', 48.5930595397949, 0.848108882587062, -94.9522171020508, -1.65722882049925, 218, 28, 'PPL', 'P'),
(161563, 'Faunce', 40.9122200012207, 0.71405294332158, -78.4358291625977, -1.36896347041912, 218, 45, 'PPL', 'P'),
(124822, 'Faunce Corner', 41.6791687011719, 0.727438723329618, -70.9888916015625, -1.23898989078862, 218, 23, 'PPL', 'P'),
(161562, 'Fauncetown', 41.6191711425781, 0.726391568388999, -79.8572235107422, -1.39377148176348, 218, 45, 'PPL', 'P'),
(2424, 'Faunsdale', 32.4597206115723, 0.566528998949403, -87.5938873291016, -1.52880173851376, 218, 2, 'PPL', 'P'),
(207396, 'Fauntleroy', 47.5233306884766, 0.82943859202798, -122.391670227051, -2.13613762247715, 218, 56, 'PPL', 'P'),
(130768, 'Faunus', 45.8925018310547, 0.800975258929431, -87.5088882446289, -1.52731822462854, 218, 27, 'PPL', 'P'),
(155241, 'Fauser (historical)', 40.9211082458496, 0.714208072455077, -82.9402770996094, -1.44758091790464, 218, 41, 'PPL', 'P'),
(64688, 'Faust', 35.9111099243164, 0.626767106224933, -82.5302810668945, -1.44042513721365, 218, 33, 'PPL', 'P'),
(203958, 'Faust', 40.1841697692871, 0.70134606965443, -112.39111328125, -1.96159497673974, 218, 52, 'PPL', 'P'),
(2425, 'Faustinas', 30.4336109161377, 0.531166713757491, -88.1055603027344, -1.53773211659713, 218, 2, 'PPL', 'P'),
(193545, 'Favinger Place', 40.0447196960449, 0.698912206734207, -121.976387023926, -2.12888956325439, 218, 6, 'PPL', 'P'),
(101895, 'Favonia', 36.973331451416, 0.645306369258383, -81.1841735839844, -1.41693112955113, 218, 53, 'PPL', 'P'),
(15993, 'Favoretta', 29.3666706085205, 0.51254509246733, -81.1750030517578, -1.41677107356962, 218, 12, 'PPL', 'P'),
(72525, 'Fawcett', 38.8669395446777, 0.678356065228212, -83.4052810668945, -1.4556967681686, 218, 41, 'PPL', 'P'),
(94187, 'Fawil', 30.726110458374, 0.536271793830091, -93.7074966430664, -1.63550435022304, 218, 51, 'PPL', 'P'),
(54733, 'Fawn', 37.5438919067383, 0.655264527785435, -91.4761123657227, -1.59655934770616, 218, 29, 'PPL', 'P'),
(80971, 'Fawn Brook', 34.1827812194824, 0.596602079768851, -82.2305603027344, -1.43519402304246, 218, 48, 'PPL', 'P'),
(15994, 'Fawn Ford', 30.3050003051758, 0.528922035143204, -84.914436340332, -1.48203649661392, 218, 12, 'PPL', 'P'),
(78248, 'Fawn Grove', 39.7277793884277, 0.693380554834003, -76.4522171020508, -1.3343429088803, 218, 45, 'PPL', 'P'),
(161564, 'Fawn Haven Number One', 40.6233291625977, 0.70901084700876, -79.9166717529297, -1.39480904932417, 218, 45, 'PPL', 'P'),
(161565, 'Fawn Haven Number Two', 40.6161117553711, 0.708884879489199, -79.92138671875, -1.39489134100185, 218, 45, 'PPL', 'P'),
(161566, 'Fawn Lake Forest', 41.5083312988281, 0.724457048173165, -75.0647201538086, -1.3101265187721, 218, 45, 'PPL', 'P'),
(59890, 'Fawn Meadows', 34.2333297729492, 0.597484318458967, -88.8625030517578, -1.55094325981668, 218, 30, 'PPL', 'P'),
(8858, 'Fawn Park', 36.3916702270508, 0.635154465762029, -92.357780456543, -1.61194735880075, 218, 4, 'PPL', 'P'),
(130763, 'Fawn River', 41.7816696166992, 0.729227701791879, -85.3444366455078, -1.48954141772382, 218, 27, 'PPL', 'P'),
(181546, 'Fawnskin', 34.2680587768555, 0.598090453923069, -116.941673278809, -2.04101723150668, 218, 6, 'PPL', 'P'),
(21045, 'Fawnwood', 30.7727794647217, 0.537086321649492, -81.7069396972656, -1.42605511944574, 218, 13, 'PPL', 'P'),
(47030, 'Fawsett Farms', 38.9977798461914, 0.680639659283928, -77.2222213745117, -1.34778201868917, 218, 25, 'PPL', 'P'),
(35862, 'Faxon', 36.6786117553711, 0.640162540191923, -88.1474990844727, -1.53846408642274, 218, 21, 'PPL', 'P'),
(75819, 'Faxon', 34.4569396972656, 0.601387047878423, -98.57861328125, -1.72052137380802, 218, 42, 'PPL', 'P'),
(86952, 'Faxon', 36.2552795410156, 0.632773999221661, -88.0019378662109, -1.53592356390085, 218, 50, 'PPL', 'P'),
(161568, 'Faxon', 41.2483291625977, 0.719919154833725, -76.9775009155273, -1.3435108409329, 218, 45, 'PPL', 'P'),
(72526, 'Faxon Hills', 39.1324996948242, 0.682990964210359, -84.4377822875977, -1.47371731400073, 218, 41, 'PPL', 'P'),
(54734, 'Fay', 36.5552787780762, 0.638009973661839, -92.3433303833008, -1.61169515744552, 218, 29, 'PPL', 'P'),
(72527, 'Fay', 39.4680595397949, 0.688847588342579, -81.2788925170898, -1.4185842867978, 218, 41, 'PPL', 'P'),
(75818, 'Fay', 35.8133316040039, 0.62506055259841, -98.6575012207031, -1.72189822809159, 218, 42, 'PPL', 'P'),
(148765, 'Fay', 44.8927803039551, 0.783526826678477, -74.3430633544922, -1.29753123155463, 218, 40, 'PPL', 'P'),
(21046, 'Fay (historical)', 33.6202812194824, 0.586784602726383, -84.2358322143555, -1.47019262029801, 218, 13, 'PPL', 'P'),
(40886, 'Fay (historical)', 31.9658298492432, 0.557908979001576, -92.6875, -1.61770205044224, 218, 22, 'PPL', 'P'),
(190195, 'Fay (historical)', 37.9080581665039, 0.661620428043018, -114.06916809082, -1.99088255819567, 218, 39, 'PPL', 'P'),
(72528, 'Fayal (historical)', 39.107780456543, 0.682559532113766, -81.8138885498047, -1.42792172905378, 218, 41, 'PPL', 'P'),
(94188, 'Fayburg', 33.2691688537598, 0.580656535900056, -96.3874969482422, -1.68227917950281, 218, 51, 'PPL', 'P'),
(35863, 'Faye', 38.0686111450195, 0.664422606141999, -83.1622161865234, -1.45145448571016, 218, 21, 'PPL', 'P'),
(2426, 'Fayette', 33.684440612793, 0.587904395385734, -87.8308334350586, -1.53293722821249, 218, 2, 'PPL', 'P'),
(27152, 'Fayette', 39.3199996948242, 0.686263456557848, -90.1536102294922, -1.57347733106428, 218, 18, 'PPL', 'P'),
(29778, 'Fayette', 39.9311103820801, 0.696929350144588, -86.397216796875, -1.50791589766482, 218, 19, 'PPL', 'P'),
(54735, 'Fayette', 39.1458282470703, 0.683223591331577, -92.6836090087891, -1.61763413983445, 218, 29, 'PPL', 'P'),
(59891, 'Fayette', 31.711389541626, 0.553468157883869, -91.0605621337891, -1.58930662795149, 218, 30, 'PPL', 'P'),
(109177, 'Fayette', 38.0633316040039, 0.664330460768283, -81.0736083984375, -1.41500140302526, 218, 58, 'PPL', 'P'),
(115551, 'Fayette', 42.8419418334961, 0.747732942942403, -91.8019409179688, -1.60224612873986, 218, 16, 'PPL', 'P'),
(127474, 'Fayette', 44.4088897705078, 0.77508134365059, -70.0341720581055, -1.22232689132215, 218, 26, 'PPL', 'P'),
(130765, 'Fayette', 45.7174987792969, 0.797920879475219, -86.6677780151367, -1.51263808175169, 218, 27, 'PPL', 'P'),
(148766, 'Fayette', 42.8141708374023, 0.747248247624009, -76.809440612793, -1.34057763530829, 218, 40, 'PPL', 'P'),
(155242, 'Fayette', 41.6733283996582, 0.727336790838895, -84.3269424438477, -1.4717827937849, 218, 41, 'PPL', 'P'),
(161577, 'Fayette', 41.103889465332, 0.717398206545856, -80.3099975585938, -1.40167387966607, 218, 45, 'PPL', 'P'),
(174082, 'Fayette', 42.7541694641113, 0.746201026104362, -90.0352783203125, -1.57141204963892, 218, 57, 'PPL', 'P'),
(181547, 'Fayette', 36.2019386291504, 0.631843024683597, -119.063888549805, -2.07805687542167, 218, 6, 'PPL', 'P'),
(186705, 'Fayette', 38.0727806091309, 0.664495377018786, -103.768890380859, -1.81110879828707, 218, 7, 'PPL', 'P'),
(192565, 'Fayette', 39.2252807617188, 0.684610299311182, -111.855827331543, -1.95225247447769, 218, 52, 'PPL', 'P'),
(198280, 'Fayette', 47.2616691589355, 0.824871736811685, -102.943328857422, -1.7967000315253, 218, 34, 'PPL', 'P'),
(207398, 'Fayette', 46.6477813720703, 0.814157373693105, -123.116668701172, -2.1487912329225, 218, 56, 'PPL', 'P'),
(40887, 'Fayette (historical)', 30.5597190856934, 0.5333677165299, -93.2011108398438, -1.62666625067145, 218, 22, 'PPL', 'P'),
(21047, 'Fayette Acres', 33.4916687011719, 0.584539890822582, -84.4886093139648, -1.47460441295983, 218, 13, 'PPL', 'P'),
(161569, 'Fayette City', 40.1002807617188, 0.699881930266132, -79.8408279418945, -1.39348532510435, 218, 45, 'PPL', 'P'),
(127475, 'Fayette Corner', 44.4205589294434, 0.775285008894954, -70.0725021362305, -1.22299587738798, 218, 26, 'PPL', 'P'),
(86953, 'Fayette Corners', 35.3661117553711, 0.617255093759497, -89.2094421386719, -1.5569984891872, 218, 50, 'PPL', 'P'),
(109179, 'Fayette Heights', 38.024169921875, 0.663646960474514, -81.1152801513672, -1.41572871231896, 218, 58, 'PPL', 'P'),
(8859, 'Fayette Junction', 36.0416717529297, 0.629045840011659, -94.1802825927734, -1.6437560217026, 218, 4, 'PPL', 'P'),
(101897, 'Fayette Park', 37.5961112976074, 0.656175928089487, -77.4225006103516, -1.35127755077795, 218, 53, 'PPL', 'P'),
(78252, 'Fayette Springs', 39.8394393920898, 0.695329389540696, -79.6233291625977, -1.38968925528655, 218, 45, 'PPL', 'P'),
(21049, 'Fayette Villa Estates', 33.4430618286133, 0.583691540857337, -84.5458297729492, -1.47560309836861, 218, 13, 'PPL', 'P'),
(59892, 'Fayettehill', 31.9605598449707, 0.557817000075427, -89.7688903808594, -1.56676270300786, 218, 30, 'PPL', 'P'),
(130767, 'Fayettes Corner', 44.4069404602051, 0.775047321767665, -84.0961074829102, -1.46775396368782, 218, 27, 'PPL', 'P'),
(101898, 'Fayettesville', 38.6138916015625, 0.673939545455452, -77.7944412231445, -1.35776913909308, 218, 53, 'PPL', 'P'),
(2428, 'Fayetteville', 33.1455612182617, 0.57849917568001, -86.4058303833008, -1.50806623310835, 218, 2, 'PPL', 'P'),
(8861, 'Fayetteville', 36.0625, 0.629409361500455, -94.1572189331055, -1.64335348490383, 218, 4, 'PPL', 'P'),
(21050, 'Fayetteville', 33.4486083984375, 0.583788346762962, -84.4550018310547, -1.47401785172974, 218, 13, 'PPL', 'P'),
(27154, 'Fayetteville', 38.377498626709, 0.669813709715674, -89.795280456543, -1.56722329671839, 218, 18, 'PPL', 'P'),
(29782, 'Fayetteville', 38.4516716003418, 0.671108272321562, -86.2627792358398, -1.5055695195864, 218, 19, 'PPL', 'P'),
(54736, 'Fayetteville', 38.8811111450195, 0.678603406314453, -93.7561111450195, -1.63635283334634, 218, 29, 'PPL', 'P'),
(64692, 'Fayetteville', 35.0525016784668, 0.611781565350084, -78.8786087036133, -1.37669143127031, 218, 33, 'PPL', 'P'),
(72531, 'Fayetteville', 39.1866683959961, 0.683936386397337, -83.9322204589844, -1.46489359551902, 218, 41, 'PPL', 'P'),
(86955, 'Fayetteville', 35.1519393920898, 0.613517080853462, -86.570556640625, -1.51094124866315, 218, 50, 'PPL', 'P'),
(94190, 'Fayetteville', 29.9055595397949, 0.521950478620622, -96.6725006103516, -1.68725343178686, 218, 51, 'PPL', 'P'),
(109180, 'Fayetteville', 38.0527801513672, 0.664146303178904, -81.1041717529297, -1.4155348341916, 218, 58, 'PPL', 'P'),
(148768, 'Fayetteville', 43.0297203063965, 0.751010295558882, -76.0047225952148, -1.32653265635143, 218, 40, 'PPL', 'P'),
(161573, 'Fayetteville', 40.4388885498047, 0.705791751041127, -80.2138900756836, -1.39999648765348, 218, 45, 'PPL', 'P'),
(78254, 'Fayfield', 39.9672203063965, 0.697559587216556, -76.6830596923828, -1.33837187213543, 218, 45, 'PPL', 'P'),
(29783, 'Fayne Siding', 39.975830078125, 0.697709856081063, -85.3883285522461, -1.49030747601138, 218, 19, 'PPL', 'P'),
(2429, 'Fays', 32.4805603027344, 0.566892720175281, -86.4100036621094, -1.50813907056417, 218, 2, 'PPL', 'P'),
(94191, 'Fays Corner', 26.0938892364502, 0.455424281826765, -98.1994400024414, -1.71390355165723, 218, 51, 'PPL', 'P'),
(172013, 'Fays Corner', 44.401668548584, 0.774955309552002, -73.0416717529297, -1.27481766324956, 218, 55, 'PPL', 'P'),
(203961, 'Fays Trailer Park', 41.9166717529297, 0.731583933566326, -111.41667175293, -1.94458776370239, 218, 52, 'PPL', 'P'),
(145217, 'Fayson Lakes', 40.975830078125, 0.715163148601007, -74.3574981689453, -1.29778316659375, 218, 37, 'PPL', 'P'),
(94192, 'Faysville', 26.4099998474121, 0.460941452788541, -98.1350021362305, -1.71277889872889, 218, 51, 'PPL', 'P'),
(27156, 'Fayville', 37.1647186279297, 0.648646705634642, -89.4266662597656, -1.56078976531503, 218, 18, 'PPL', 'P'),
(124823, 'Fayville', 42.2944412231445, 0.73817725463509, -71.5061111450195, -1.2480170747776, 218, 23, 'PPL', 'P'),
(148769, 'Fayville', 43.1469383239746, 0.753056135908281, -74.1208267211914, -1.29365247058498, 218, 40, 'PPL', 'P'),
(172015, 'Fayville', 43.0061111450195, 0.750598237959219, -73.1119384765625, -1.27604404893154, 218, 55, 'PPL', 'P'),
(35865, 'Faywood', 38.1027793884277, 0.665018954489095, -84.6416702270508, -1.47727582984929, 218, 21, 'PPL', 'P'),
(188545, 'Faywood (historical)', 32.5641708374023, 0.56835199929459, -108.023612976074, -1.88536771633257, 218, 38, 'PPL', 'P'),
(40888, 'Fazende (historical)', 29.9375, 0.522507944815802, -89.9897232055664, -1.57061696289548, 218, 22, 'PPL', 'P'),
(47025, 'Feagaville', 39.3858299255371, 0.687412410831136, -77.475830078125, -1.35220832557894, 218, 25, 'PPL', 'P'),
(8862, 'Fealey (historical)', 35.3202781677246, 0.616455146747064, -93.9980621337891, -1.64057567472883, 218, 4, 'PPL', 'P'),
(21051, 'Fearing (historical)', 34.003059387207, 0.593465342057928, -85.4044418334961, -1.49058870582249, 218, 13, 'PPL', 'P'),
(35866, 'Fearisville', 38.625560760498, 0.674143210699816, -83.5980606079102, -1.4590614058898, 218, 21, 'PPL', 'P'),
(161574, 'Fearnot', 40.6438903808594, 0.709369707965648, -76.6366729736328, -1.33756227116405, 218, 45, 'PPL', 'P'),
(186707, 'Fearnowville', 38.2791709899902, 0.668097568709227, -104.559722900391, -1.82491142958473, 218, 7, 'PPL', 'P'),
(59893, 'Fearns Springs', 33.0069389343262, 0.5760797604087, -88.845832824707, -1.55065230946759, 218, 30, 'PPL', 'P'),
(64690, 'Fearrington', 35.8063888549805, 0.624939378768812, -79.0736083984375, -1.38009481798537, 218, 33, 'PPL', 'P'),
(64691, 'Fearrington Village', 35.8036117553711, 0.624890909236972, -79.0905609130859, -1.38039069518248, 218, 33, 'PPL', 'P'),
(101899, 'Fears Corner', 37.0458297729492, 0.646571703671307, -78.7163925170898, -1.37386022471544, 218, 53, 'PPL', 'P'),
(35867, 'Fearsville', 36.9838905334473, 0.645490660005817, -87.3574981689453, -1.52467596935301, 218, 21, 'PPL', 'P'),
(178177, 'Feaster', 33.9916687011719, 0.593266537082554, -109.144721984863, -1.9049347598097, 218, 5, 'PPL', 'P'),
(145218, 'Feaster Park', 40.4844398498535, 0.706586771205543, -74.4430618286133, -1.29927653417501, 218, 37, 'PPL', 'P'),
(80969, 'Feasterville', 34.5022201538086, 0.602177340931904, -81.3605575561523, -1.42000961061321, 218, 48, 'PPL', 'P'),
(161575, 'Feasterville', 40.1438903808594, 0.700643061705677, -75.0055618286133, -1.30909401121748, 218, 45, 'PPL', 'P'),
(40890, 'Feasterville (historical)', 32.6722183227539, 0.570237783662475, -92.8036117553711, -1.61972858287374, 218, 22, 'PPL', 'P'),
(181548, 'Feather Falls', 39.5933303833008, 0.691033977018507, -121.255279541016, -2.11630386341684, 218, 6, 'PPL', 'P'),
(181549, 'Feather River Inn', 39.7905616760254, 0.694476312464516, -120.628608703613, -2.10536639397794, 218, 6, 'PPL', 'P'),
(181550, 'Feather River Park', 39.7783317565918, 0.694262860103146, -120.628608703613, -2.10536639397794, 218, 6, 'PPL', 'P'),
(15995, 'Feather Sound', 27.9094390869141, 0.48711160445145, -82.6572189331055, -1.44264062092449, 218, 12, 'PPL', 'P'),
(47026, 'Featherbed', 39.3244400024414, 0.68634095454557, -76.7430572509766, -1.33941902707605, 218, 25, 'PPL', 'P'),
(86956, 'Feathers Chapel', 35.2574996948242, 0.615359455695579, -89.4199981689453, -1.5606733851754, 218, 50, 'PPL', 'P'),
(35869, 'Feathersburg', 37.3113899230957, 0.651206602653454, -85.1691665649414, -1.4864823777377, 218, 21, 'PPL', 'P'),
(75820, 'Featherston', 35.0786094665527, 0.612237232212597, -95.4897232055664, -1.66661007175517, 218, 42, 'PPL', 'P'),
(101903, 'Featherstone', 38.6349983215332, 0.674307927213237, -77.2641677856445, -1.34851412167283, 218, 53, 'PPL', 'P'),
(101900, 'Featherstone Fork', 38.2016716003418, 0.666744949191576, -77.3294372558594, -1.34965328882911, 218, 53, 'PPL', 'P'),
(101901, 'Featherstone Mobile Home Park', 38.6386108398438, 0.674370977552045, -77.2713928222656, -1.34864022235045, 218, 53, 'PPL', 'P'),
(101902, 'Featherstone Shores', 38.6297187805176, 0.67421578183952, -77.2491683959961, -1.34825233293768, 218, 53, 'PPL', 'P'),
(194919, 'Featherville', 43.6100006103516, 0.761138097447371, -115.257217407227, -2.01161793044303, 218, 17, 'PPL', 'P'),
(145219, 'Febletown', 40.9316711425781, 0.714392429781538, -74.9625015258789, -1.30834246715786, 218, 37, 'PPL', 'P'),
(86957, 'February', 36.3333282470703, 0.634136206119237, -82.4997177124023, -1.43989170604731, 218, 50, 'PPL', 'P'),
(80970, 'Fechtig', 32.7688903808594, 0.571925029371095, -80.9641723632813, -1.41309138389146, 218, 48, 'PPL', 'P'),
(2430, 'Feddisburg', 33.4144401550293, 0.583191998415866, -86.2624969482422, -1.50556459273839, 218, 2, 'PPL', 'P'),
(35870, 'Federal', 37.3113899230957, 0.651206602653454, -82.3611068725586, -1.43747249051308, 218, 21, 'PPL', 'P'),
(54737, 'Federal', 37.8419418334961, 0.660466480342687, -90.5047225952148, -1.57960539789061, 218, 29, 'PPL', 'P'),
(72533, 'Federal', 39.4519386291504, 0.688566225373413, -81.9894409179688, -1.43098569588792, 218, 41, 'PPL', 'P'),
(161576, 'Federal', 40.3786087036133, 0.704739669252491, -80.148063659668, -1.39884759995922, 218, 45, 'PPL', 'P'),
(109181, 'Federal (historical)', 39.3925018310547, 0.687528857549799, -81.0869369506836, -1.41523403014648, 218, 58, 'PPL', 'P'),
(143820, 'Federal Corner', 43.6622200012207, 0.762049497751424, -71.2294387817383, -1.24318823108907, 218, 36, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(135343, 'Federal Dam', 47.2452812194824, 0.82458571331061, -94.2108306884766, -1.64428918655283, 218, 28, 'PPL', 'P'),
(186706, 'Federal Heights', 39.851390838623, 0.695537981633076, -104.998062133789, -1.8325618924482, 218, 7, 'PPL', 'P'),
(47027, 'Federal Hill', 39.6408309936523, 0.691863019065849, -76.4716720581055, -1.33468246191929, 218, 25, 'PPL', 'P'),
(101904, 'Federal Hill', 37.4119415283203, 0.652961559232789, -79.147216796875, -1.38137952689523, 218, 53, 'PPL', 'P'),
(122604, 'Federal Hill', 40.0461082458496, 0.698936441500126, -86.0238876342773, -1.50140007458378, 218, 19, 'PPL', 'P'),
(101905, 'Federal Hill Estates', 37.3138885498047, 0.651250211916304, -79.2808303833008, -1.38371152390376, 218, 53, 'PPL', 'P'),
(47028, 'Federal Hill Heights', 39.6266708374023, 0.691615877716689, -76.4694366455078, -1.33464344660932, 218, 25, 'PPL', 'P'),
(21052, 'Federal Hills', 32.9858283996582, 0.575711312071888, -85.0055618286133, -1.48362693641691, 218, 13, 'PPL', 'P'),
(47029, 'Federal Oak Estates', 38.6605606079102, 0.674754073274853, -76.5988922119141, -1.33690287247814, 218, 25, 'PPL', 'P'),
(15996, 'Federal Point', 29.7477798461914, 0.519196703474452, -81.5444412231445, -1.42321898604286, 218, 12, 'PPL', 'P'),
(207400, 'Federal Way', 47.3224983215332, 0.825933405980245, -122.311393737793, -2.13473653342766, 218, 56, 'PPL', 'P'),
(13750, 'Federalsburg', 38.8280601501465, 0.67767749178246, -75.4297180175781, -1.31649693325763, 218, 10, 'PPL', 'P'),
(47031, 'Federalsburg', 38.6941719055176, 0.67534070108397, -75.7724990844727, -1.32247959148844, 218, 25, 'PPL', 'P'),
(47032, 'Federalsburg Estates', 38.7461090087891, 0.676247174540006, -75.8163909912109, -1.323245649776, 218, 25, 'PPL', 'P'),
(15997, 'Fedhaven', 27.8569393157959, 0.486195310588895, -81.4127807617188, -1.42092107749629, 218, 12, 'PPL', 'P'),
(94193, 'Fedor', 30.3158302307129, 0.529111053001572, -97.0524978637695, -1.69388563500754, 218, 51, 'PPL', 'P'),
(170298, 'Fedora', 44.0088882446289, 0.768100000011002, -97.7905578613281, -1.7067672120422, 218, 49, 'PPL', 'P'),
(35872, 'Fedscreek', 37.4033317565918, 0.652811290368281, -82.2452774047852, -1.4354508849296, 218, 21, 'PPL', 'P'),
(196465, 'Fee', 46.0877799987793, 0.804383505913487, -107.678886413574, -1.87935110279786, 218, 31, 'PPL', 'P'),
(155243, 'Feed Springs', 40.3491706848145, 0.704225878899187, -81.2533264160156, -1.41813807415716, 218, 41, 'PPL', 'P'),
(124824, 'Feeding Hills', 42.0680618286133, 0.734226188841848, -72.6791687011719, -1.26849079144786, 218, 23, 'PPL', 'P'),
(196466, 'Feely', 45.8766708374023, 0.800698955966335, -112.688331604004, -1.96678241506905, 218, 31, 'PPL', 'P'),
(8866, 'Feenyville', 33.9772186279297, 0.593014335727323, -91.9091720581055, -1.60411766519591, 218, 4, 'PPL', 'P'),
(72534, 'Feesburg', 38.8783302307129, 0.678554870203587, -83.998893737793, -1.46605726375733, 218, 41, 'PPL', 'P'),
(47033, 'Feesersburg', 39.5933303833008, 0.691033977018507, -77.2027816772461, -1.34744273196629, 218, 25, 'PPL', 'P'),
(64694, 'Feezor', 35.6883316040039, 0.622878891033417, -80.269172668457, -1.40096135091642, 218, 33, 'PPL', 'P'),
(139155, 'Fegley', 40.2861099243164, 0.703125260999685, -92.649169921875, -1.61703306437642, 218, 29, 'PPL', 'P'),
(72535, 'Feightner (historical)', 39.4124984741211, 0.687877864810654, -82.7472229003906, -1.44421148649347, 218, 41, 'PPL', 'P'),
(54738, 'Feigler Ferry', 38.5638885498047, 0.673066827566233, -91.6108322143555, -1.59891065263259, 218, 29, 'PPL', 'P'),
(40889, 'Feitel', 30.0016708374023, 0.523627937212235, -90.7738876342773, -1.58430321405351, 218, 22, 'PPL', 'P'),
(130771, 'Felch', 45.9972190856934, 0.802802919806525, -87.8255615234375, -1.53284521599683, 218, 27, 'PPL', 'P'),
(127477, 'Felch Corner', 43.6788902282715, 0.762340448100515, -70.7866668701172, -1.23546040339593, 218, 26, 'PPL', 'P'),
(130769, 'Felch Mountain', 46.0011100769043, 0.802870830414322, -87.8319396972656, -1.5329565361304, 218, 27, 'PPL', 'P'),
(124825, 'Felchville', 42.297779083252, 0.738235511283935, -71.3597183227539, -1.24546203802778, 218, 23, 'PPL', 'P'),
(172016, 'Felchville', 43.4563903808594, 0.758457093177989, -72.538330078125, -1.26603269376172, 218, 55, 'PPL', 'P'),
(8863, 'Felco', 35.2305603027344, 0.614889274605125, -90.399169921875, -1.57776315620654, 218, 4, 'PPL', 'P'),
(15998, 'Felda', 26.5394401550293, 0.463200612341256, -81.4358291625977, -1.42132334797895, 218, 12, 'PPL', 'P'),
(80972, 'Felder', 33.4324989318848, 0.583507183530877, -80.8513870239258, -1.41112290837172, 218, 48, 'PPL', 'P'),
(21053, 'Felder (historical)', 31.8238906860352, 0.55543167326607, -83.5641708374023, -1.4584699178117, 218, 13, 'PPL', 'P'),
(80973, 'Felderville', 33.4633293151855, 0.584045275229127, -80.5438919067383, -1.405756106143, 218, 48, 'PPL', 'P'),
(181551, 'Felice (historical)', 38.3908309936523, 0.67004640341592, -122.532218933105, -2.13859066015722, 218, 6, 'PPL', 'P'),
(15999, 'Felicia', 28.9297199249268, 0.504918864369779, -82.3955612182617, -1.43807383228722, 218, 12, 'PPL', 'P'),
(94195, 'Felicia', 30.023889541626, 0.524015726756464, -94.5077819824219, -1.64947196435024, 218, 51, 'PPL', 'P'),
(101906, 'Felicia (historical)', 37.0597190856934, 0.646814117909532, -79.7577819824219, -1.39203589968107, 218, 53, 'PPL', 'P'),
(35871, 'Feliciana', 36.5497207641602, 0.637912968019133, -88.791389465332, -1.54970209359065, 218, 21, 'PPL', 'P'),
(40891, 'Feliciana', 30.5747203826904, 0.533629538554569, -91.1255569458008, -1.59044100141781, 218, 22, 'PPL', 'P'),
(72536, 'Felicity', 38.8388900756836, 0.677866509640828, -84.0963897705078, -1.46775889053584, 218, 41, 'PPL', 'P'),
(181552, 'Felicity', 32.9555587768555, 0.575183007490643, -114.810562133789, -2.00382232530015, 218, 6, 'PPL', 'P'),
(47034, 'Felicity Cove', 38.8472213745117, 0.678011918236347, -76.4941711425781, -1.33507514502202, 218, 25, 'PPL', 'P'),
(207399, 'Felida', 45.7097206115723, 0.797785124838652, -122.706108093262, -2.14162559853548, 218, 56, 'PPL', 'P'),
(101907, 'Felipos Mobile Court', 37.3866691589355, 0.652520473177244, -77.4272232055664, -1.35135997561369, 218, 53, 'PPL', 'P'),
(181553, 'Felix', 38.0283317565918, 0.663719598193246, -120.714721679688, -2.10686934893913, 218, 6, 'PPL', 'P'),
(40893, 'Felixville', 30.9422206878662, 0.54004362888197, -90.8766708374023, -1.58609711936378, 218, 22, 'PPL', 'P'),
(101908, 'Felixville (historical)', 37.4569396972656, 0.653746925438253, -78.1680603027344, -1.36429002218019, 218, 53, 'PPL', 'P'),
(16000, 'Felkel', 30.5969390869141, 0.534017328098798, -84.1177825927734, -1.46813226572067, 218, 12, 'PPL', 'P'),
(75821, 'Felker', 34.0405616760254, 0.594119880474842, -95.0519409179688, -1.65896932942968, 218, 42, 'PPL', 'P'),
(86958, 'Felker', 35.0302810668945, 0.611393742516342, -84.8000030517578, -1.48003925895441, 218, 50, 'PPL', 'P'),
(8864, 'Felker (historical)', 36.2272186279297, 0.632284243897196, -94.4680633544922, -1.64877874351849, 218, 4, 'PPL', 'P'),
(8867, 'Felkner Town', 35.5494384765625, 0.620454748651173, -93.8602828979492, -1.63817097342254, 218, 4, 'PPL', 'P'),
(181555, 'Fellows', 35.1786117553711, 0.613982601412008, -119.540283203125, -2.086371530661, 218, 6, 'PPL', 'P'),
(174087, 'Fellows (historical)', 42.7480583190918, 0.746094366502705, -89.2008285522461, -1.55684815374366, 218, 57, 'PPL', 'P'),
(16001, 'Fellowship', 29.246940612793, 0.510455409828485, -82.2922210693359, -1.43627020643896, 218, 12, 'PPL', 'P'),
(21056, 'Fellowship', 31.0427799224854, 0.541798718619359, -83.3566665649414, -1.4548482850453, 218, 13, 'PPL', 'P'),
(40892, 'Fellowship', 31.6344394683838, 0.552125125746142, -92.1949996948242, -1.60910629854985, 218, 22, 'PPL', 'P'),
(59894, 'Fellowship', 32.1949996948242, 0.561908747353252, -88.940559387207, -1.55230559987231, 218, 30, 'PPL', 'P'),
(70811, 'Fellowship', 39.9275016784668, 0.696866366384808, -74.9669418334961, -1.30841996514558, 218, 37, 'PPL', 'P'),
(94196, 'Fellowship', 31.937780380249, 0.557419423414192, -94.0316696166992, -1.64116223595892, 218, 51, 'PPL', 'P'),
(47035, 'Fellowship Forest', 39.3913917541504, 0.687509483052869, -76.5869369506836, -1.33669421380673, 218, 25, 'PPL', 'P'),
(16002, 'Fellowship Park', 30.0216693878174, 0.523976977762604, -81.7222213745117, -1.42632183502892, 218, 12, 'PPL', 'P'),
(109183, 'Fellowsville', 39.3305587768555, 0.686447747305282, -79.8247222900391, -1.39320422845129, 218, 58, 'PPL', 'P'),
(124826, 'Fells', 42.4416694641113, 0.74074687219188, -71.0716705322266, -1.24043465567998, 218, 23, 'PPL', 'P'),
(155244, 'Fells (historical)', 40.2911109924316, 0.703212546104412, -80.7183303833008, -1.40880063190118, 218, 41, 'PPL', 'P'),
(161579, 'Fells Corners', 41.3030586242676, 0.720874364137709, -75.533332824707, -1.31830535279585, 218, 45, 'PPL', 'P'),
(47036, 'Fells Point', 39.2825012207031, 0.685608984719961, -76.5936126708984, -1.33681072710443, 218, 25, 'PPL', 'P'),
(32441, 'Fellsburg', 37.811939239502, 0.65994283629335, -99.1750030517578, -1.7309303389286, 218, 20, 'PPL', 'P'),
(161580, 'Fellsburg', 40.1830596923828, 0.7013266951575, -79.8244400024414, -1.39319930160327, 218, 45, 'PPL', 'P'),
(16003, 'Fellsmere', 27.7674999237061, 0.484634298715945, -80.6016693115234, -1.40676451208976, 218, 12, 'PPL', 'P'),
(40894, 'Felps', 30.9769401550293, 0.540649597898504, -90.9186096191406, -1.58682908918939, 218, 22, 'PPL', 'P'),
(8868, 'Felsenthal', 33.059440612793, 0.576996087560769, -92.1566696166992, -1.60843731248402, 218, 4, 'PPL', 'P'),
(190971, 'Felt', 36.5675010681152, 0.638223292865154, -102.793060302734, -1.79407735048379, 218, 42, 'PPL', 'P'),
(194920, 'Felt', 43.8730583190918, 0.765729320587641, -111.183891296387, -1.94052497830141, 218, 17, 'PPL', 'P'),
(148770, 'Felters Corners', 41.1986083984375, 0.719051363792522, -74.0097198486328, -1.29171328983724, 218, 40, 'PPL', 'P'),
(194921, 'Feltham', 44.207218170166, 0.77156151021686, -116.930000305176, -2.04081349968329, 218, 17, 'PPL', 'P'),
(8869, 'Felton', 34.8041687011719, 0.607447337255008, -90.7961120605469, -1.58469110346628, 218, 4, 'PPL', 'P'),
(13751, 'Felton', 39.0083312988281, 0.680823816873307, -75.5783309936523, -1.31909071900131, 218, 10, 'PPL', 'P'),
(21054, 'Felton', 33.8880615234375, 0.59145825070239, -85.2236099243164, -1.48743259361464, 218, 13, 'PPL', 'P'),
(78255, 'Felton', 39.8547210693359, 0.695596105123867, -76.5647201538086, -1.33630645755202, 218, 45, 'PPL', 'P'),
(135346, 'Felton', 47.0786094665527, 0.821676742451916, -96.5061111450195, -1.68434938777619, 218, 28, 'PPL', 'P'),
(181556, 'Felton', 37.0513916015625, 0.646668775893041, -122.072219848633, -2.13056216157702, 218, 6, 'PPL', 'P'),
(13752, 'Felton Heights', 39.0208282470703, 0.681041929766584, -75.5661087036133, -1.318877399798, 218, 10, 'PPL', 'P'),
(13753, 'Felton Manor', 39.0069389343262, 0.68079951552836, -75.5680618286133, -1.31891148825995, 218, 10, 'PPL', 'P'),
(13754, 'Felton Station', 39.0080604553223, 0.680819089762372, -75.5749969482422, -1.31903252893149, 218, 10, 'PPL', 'P'),
(64695, 'Feltonville', 35.6830596923828, 0.622786878817755, -78.8338928222656, -1.37591099191286, 218, 33, 'PPL', 'P'),
(161581, 'Feltonville', 40.021671295166, 0.69850993625155, -75.126106262207, -1.31119790847864, 218, 45, 'PPL', 'P'),
(86959, 'Felts', 35.2269401550293, 0.614826091108263, -90.0147171020508, -1.57105318868203, 218, 50, 'PPL', 'P'),
(148771, 'Felts Mills', 44.0222206115723, 0.768332693711248, -75.7636108398438, -1.32232446235494, 218, 40, 'PPL', 'P'),
(35873, 'Felty', 37.3030586242676, 0.651061194057936, -83.710563659668, -1.46102495456152, 218, 21, 'PPL', 'P'),
(54739, 'Femme Osage', 38.6366691589355, 0.674337088827174, -90.9416732788086, -1.58723162598816, 218, 29, 'PPL', 'P'),
(181557, 'Femmons', 37.9383316040039, 0.66214879920329, -120.021392822266, -2.09476847757802, 218, 6, 'PPL', 'P'),
(47037, 'Fenby', 39.5272216796875, 0.68988016247623, -76.9927825927734, -1.34377755651607, 218, 25, 'PPL', 'P'),
(174084, 'Fence', 45.7444381713867, 0.798391060565672, -88.4241714477539, -1.54329293011127, 218, 57, 'PPL', 'P'),
(188548, 'Fence Lake', 34.6533317565918, 0.604814735938437, -108.677223205566, -1.89677536686192, 218, 38, 'PPL', 'P'),
(80974, 'Fendall', 34.1388893127441, 0.595836021481289, -79.6880569458008, -1.39081896822096, 218, 48, 'PPL', 'P'),
(8870, 'Fender', 36.1749992370605, 0.631372843593143, -90.8958282470703, -1.58643147923864, 218, 4, 'PPL', 'P'),
(186708, 'Fenders', 39.5738906860352, 0.690694690295631, -105.21639251709, -1.83637247649394, 218, 7, 'PPL', 'P'),
(21055, 'Fendig', 31.3400001525879, 0.546986190238184, -81.8405609130859, -1.42838724961233, 218, 13, 'PPL', 'P'),
(8871, 'Fendley', 34.2322196960449, 0.597464943962036, -93.3333282470703, -1.628973879756, 218, 4, 'PPL', 'P'),
(101909, 'Fendley (historical)', 37.3716697692871, 0.65225868444209, -77.5597229003906, -1.35367253154626, 218, 53, 'PPL', 'P'),
(199952, 'Fenelon', 41.202220916748, 0.71911441413133, -114.662216186523, -2.00123320008837, 218, 39, 'PPL', 'P'),
(161582, 'Fenelton', 40.8702812194824, 0.713320973495971, -79.7263870239258, -1.39148795428679, 218, 45, 'PPL', 'P'),
(16004, 'Fenholloway', 30.077220916748, 0.524946534846961, -83.496940612793, -1.45729652903541, 218, 12, 'PPL', 'P'),
(148772, 'Fenimore', 43.3022193908691, 0.7557663017916, -73.5950012207031, -1.28447508431052, 218, 40, 'PPL', 'P'),
(64696, 'Fenix', 35.0330581665039, 0.611442212048181, -79.0350036621094, -1.37942103822958, 218, 33, 'PPL', 'P'),
(78258, 'Fenmore', 39.8375015258789, 0.695295567394852, -76.5269393920898, -1.33564705886612, 218, 45, 'PPL', 'P'),
(130772, 'Fenmore', 43.172779083252, 0.753507142238886, -84.3452835083008, -1.47210290574792, 218, 27, 'PPL', 'P'),
(148775, 'Fenmore Park', 40.9866714477539, 0.715352366196457, -73.7197189331055, -1.28665181902749, 218, 40, 'PPL', 'P'),
(194922, 'Fenn', 45.9633293151855, 0.802211431728418, -116.255279541016, -2.02903740081713, 218, 17, 'PPL', 'P'),
(29785, 'Fenn Haven', 37.9313888549805, 0.662027625373691, -86.7566680908203, -1.51418950624472, 218, 19, 'PPL', 'P'),
(80975, 'Fennell Hill Landing', 32.9277801513672, 0.574698179014194, -81.4897232055664, -1.42226397647596, 218, 48, 'PPL', 'P'),
(178178, 'Fennemore', 33.5702781677246, 0.585911884837164, -112.426666259766, -1.96221549327373, 218, 5, 'PPL', 'P'),
(148774, 'Fenner', 43.0583305358887, 0.751509638263272, -77.6675033569336, -1.35555365538224, 218, 40, 'PPL', 'P'),
(178179, 'Fenner', 31.9699993133545, 0.557981749878362, -110.230560302734, -1.92388621360087, 218, 5, 'PPL', 'P'),
(181558, 'Fenner', 34.8158302307129, 0.607650869341317, -115.178329467773, -2.01024107615945, 218, 6, 'PPL', 'P'),
(124827, 'Fennerville', 42.0374984741211, 0.733692757675505, -71.8833312988281, -1.25460080846644, 218, 23, 'PPL', 'P'),
(174086, 'Fennimore', 42.9836082458496, 0.75020548827746, -90.6552810668945, -1.58223313893819, 218, 57, 'PPL', 'P'),
(13755, 'Fennimore Landing', 39.4449996948242, 0.688445118122841, -75.5927810668945, -1.31934292035654, 218, 10, 'PPL', 'P'),
(29786, 'Fenns', 39.4575004577637, 0.688663297595146, -85.7977828979492, -1.4974538024805, 218, 19, 'PPL', 'P'),
(130773, 'Fennville', 42.5938911437988, 0.743403641695343, -86.1016693115234, -1.50275762094944, 218, 27, 'PPL', 'P'),
(40895, 'Fenris', 30.5605602264404, 0.533382397205409, -92.4297180175781, -1.61320290609666, 218, 22, 'PPL', 'P'),
(8872, 'Fenter', 34.3766708374023, 0.599986091986987, -92.6374969482422, -1.61682933255303, 218, 4, 'PPL', 'P'),
(2431, 'Fenton', 34.1797218322754, 0.596548683388995, -86.1055603027344, -1.50282553155724, 218, 2, 'PPL', 'P'),
(35874, 'Fenton', 36.7769393920898, 0.64187868119837, -88.102783203125, -1.53768364706529, 218, 21, 'PPL', 'P'),
(40896, 'Fenton', 30.3669395446777, 0.530003078808694, -92.9180603027344, -1.62172608684935, 218, 22, 'PPL', 'P'),
(54740, 'Fenton', 38.5130615234375, 0.672179728607128, -90.4358291625977, -1.57840298065844, 218, 29, 'PPL', 'P'),
(59897, 'Fenton', 30.4147205352783, 0.530837014414539, -89.3808288574219, -1.55998975172357, 218, 30, 'PPL', 'P'),
(115557, 'Fenton', 43.2197189331055, 0.754326397169221, -94.4302825927734, -1.64811934483258, 218, 16, 'PPL', 'P'),
(119608, 'Fenton', 41.7305603027344, 0.728335675984756, -90.0299987792969, -1.57131990426521, 218, 18, 'PPL', 'P'),
(130775, 'Fenton', 42.797779083252, 0.746962157543907, -83.7050018310547, -1.46092788233979, 218, 27, 'PPL', 'P'),
(209451, 'Fenton', 44.3980598449707, 0.774892325792222, -108.573890686035, -1.89497187417172, 218, 59, 'PPL', 'P'),
(155245, 'Fenton (historical)', 41.4541702270508, 0.723511759144241, -83.5583267211914, -1.45836791874195, 218, 41, 'PPL', 'P'),
(124828, 'Fentonville', 42.1402816772461, 0.735486662985783, -72.2736129760742, -1.26141250874459, 218, 23, 'PPL', 'P'),
(148778, 'Fentonville', 42.0038909912109, 0.733106196445415, -79.1405563354492, -1.38126327991365, 218, 40, 'PPL', 'P'),
(59895, 'Fentress', 33.2966690063477, 0.581136504107515, -89.2222213745117, -1.55722152892849, 218, 30, 'PPL', 'P'),
(94198, 'Fentress', 29.7558307647705, 0.519337218511468, -97.7761077880859, -1.70651501068697, 218, 51, 'PPL', 'P'),
(101912, 'Fentress', 36.7019386291504, 0.640569670943568, -76.1972198486328, -1.32989236722462, 218, 53, 'PPL', 'P'),
(35875, 'Fentress McMahan', 37.6044387817383, 0.656321270105978, -86.4922180175781, -1.5095739817595, 218, 21, 'PPL', 'P'),
(35876, 'Fenwick', 38.0786094665527, 0.664597109772427, -84.3555603027344, -1.47228226964734, 218, 21, 'PPL', 'P'),
(47038, 'Fenwick', 38.6427803039551, 0.674443748428831, -77.1083297729492, -1.34579423525154, 218, 25, 'PPL', 'P'),
(54741, 'Fenwick', 38.6697196960449, 0.674913929519285, -94.1050033569336, -1.64244215117881, 218, 29, 'PPL', 'P'),
(59896, 'Fenwick', 31.5558300018311, 0.55075313173156, -91.248893737793, -1.59259363452692, 218, 30, 'PPL', 'P'),
(70812, 'Fenwick', 39.6175003051758, 0.691455821735176, -75.3372192382813, -1.31488252500482, 218, 37, 'PPL', 'P'),
(80976, 'Fenwick', 32.6513900756836, 0.569874262173679, -80.4516677856445, -1.40414649158015, 218, 48, 'PPL', 'P'),
(112643, 'Fenwick', 38.2286109924316, 0.667215130282029, -80.5824966430664, -1.40642988589879, 218, 58, 'PPL', 'P'),
(113431, 'Fenwick', 41.2708282470703, 0.720311837936457, -72.3541717529297, -1.2628185246421, 218, 8, 'PPL', 'P'),
(130778, 'Fenwick', 43.149169921875, 0.753095084639223, -85.0802764892578, -1.48493095324467, 218, 27, 'PPL', 'P'),
(80977, 'Fenwick Crossroads', 32.7205581665039, 0.571081473095812, -80.0824966430664, -1.39770323963881, 218, 48, 'PPL', 'P'),
(13757, 'Fenwick Estates', 38.452220916748, 0.671117859701486, -75.0508270263672, -1.30988403795485, 218, 10, 'PPL', 'P'),
(80978, 'Fenwick Grove', 34.1402816772461, 0.595860322826236, -79.7388916015625, -1.39170620033812, 218, 48, 'PPL', 'P'),
(80979, 'Fenwick Hills', 32.7347183227539, 0.571328614444972, -80.0738906860352, -1.39755303735333, 218, 48, 'PPL', 'P'),
(13758, 'Fenwick Island', 38.4622192382813, 0.671292363331913, -75.0516662597656, -1.30989868534085, 218, 10, 'PPL', 'P'),
(13759, 'Fenwick Landing', 38.4538917541504, 0.671147021315422, -75.0663909912109, -1.31015568038604, 218, 10, 'PPL', 'P'),
(47040, 'Fenwick Manor', 38.3536109924316, 0.669396791847022, -76.5611114501953, -1.33624347379224, 218, 25, 'PPL', 'P'),
(101911, 'Fenwick Park', 38.8688888549805, 0.678390087111138, -77.2027816772461, -1.34744273196629, 218, 53, 'PPL', 'P'),
(47041, 'Fenwick Shores', 38.6472206115723, 0.674521246416553, -77.1055603027344, -1.34574589887775, 218, 25, 'PPL', 'P'),
(13760, 'Fenwick West', 38.4719390869141, 0.671462006693351, -75.1241683959961, -1.3111640863328, 218, 10, 'PPL', 'P'),
(174090, 'Fenwood', 44.8661117553711, 0.783061372698958, -90.0152816772461, -1.57106304237807, 218, 57, 'PPL', 'P'),
(47042, 'Fenwood Heights', 39.514720916748, 0.689661983003926, -76.871940612793, -1.34166846609078, 218, 25, 'PPL', 'P'),
(181560, 'Fep (historical)', 36.9466705322266, 0.644841048436919, -121.507499694824, -2.12070593554069, 218, 6, 'PPL', 'P'),
(27157, 'Ferber', 37.9069404602051, 0.661600920388033, -88.7422180175781, -1.54884388992937, 218, 18, 'PPL', 'P'),
(8875, 'Ferda', 34.4588890075684, 0.601421069761349, -91.9544372558594, -1.60490769193329, 218, 4, 'PPL', 'P'),
(196467, 'Ferdig', 48.7541694641113, 0.850920781224022, -111.774169921875, -1.95082728382033, 218, 31, 'PPL', 'P'),
(29787, 'Ferdinand', 38.2238883972168, 0.667132705446291, -86.8622207641602, -1.51603174792878, 218, 19, 'PPL', 'P'),
(194923, 'Ferdinand', 46.1525001525879, 0.805513085689844, -116.388328552246, -2.03135954412962, 218, 17, 'PPL', 'P'),
(47043, 'Ferdinand Heights', 39.1794395446777, 0.683810219140695, -76.6369400024414, -1.33756693169595, 218, 25, 'PPL', 'P'),
(145220, 'Ferdinands Mills', 41.0255584716797, 0.716031072800263, -74.1930618286133, -1.29491321104503, 218, 37, 'PPL', 'P'),
(148779, 'Ferenbaugh', 42.1974983215332, 0.736485281815535, -77.008056640625, -1.34404413894119, 218, 40, 'PPL', 'P'),
(27158, 'Fergestown', 37.7924995422363, 0.659603549570474, -88.9647216796875, -1.55272731143093, 218, 18, 'PPL', 'P'),
(181559, 'Fergus', 37.3194389343262, 0.651347084400956, -120.537216186523, -2.10377129364304, 218, 6, 'PPL', 'P'),
(196468, 'Fergus', 47.3308296203613, 0.826078814575763, -109.066390991211, -1.90356762606411, 218, 31, 'PPL', 'P'),
(135350, 'Fergus Falls', 46.2830581665039, 0.807791752897543, -96.0772171020508, -1.67686377458419, 218, 28, 'PPL', 'P'),
(2432, 'Ferguson', 34.1388893127441, 0.595836021481289, -85.5908279418945, -1.49384175709402, 218, 2, 'PPL', 'P'),
(8876, 'Ferguson', 34.1380615234375, 0.595821573832376, -90.98388671875, -1.58796838950373, 218, 4, 'PPL', 'P'),
(35878, 'Ferguson', 37.0666694641113, 0.646935424897185, -84.5999984741211, -1.47654852055559, 218, 21, 'PPL', 'P'),
(40897, 'Ferguson', 32.5505599975586, 0.568114445325355, -93.6752777099609, -1.63494202375887, 218, 22, 'PPL', 'P'),
(47044, 'Ferguson', 38.6333312988281, 0.674278832178328, -76.6347198486328, -1.33752818270209, 218, 25, 'PPL', 'P'),
(54742, 'Ferguson', 38.7441711425781, 0.676213352394162, -90.3052825927734, -1.57612451318782, 218, 29, 'PPL', 'P'),
(59901, 'Ferguson', 31.6322193145752, 0.552086376752281, -90.081672668457, -1.57222178376836, 218, 30, 'PPL', 'P'),
(64698, 'Ferguson', 36.0855598449707, 0.629811831720193, -81.3686065673828, -1.42015009236071, 218, 33, 'PPL', 'P'),
(78259, 'Ferguson', 39.959171295166, 0.697419105469054, -79.6230621337891, -1.38968459475464, 218, 45, 'PPL', 'P'),
(94197, 'Ferguson', 31.0358295440674, 0.541677411631706, -94.1391677856445, -1.64303843294688, 218, 51, 'PPL', 'P'),
(109184, 'Ferguson', 38.0755615234375, 0.664543913129652, -82.4333267211914, -1.43873296465701, 218, 58, 'PPL', 'P'),
(115559, 'Ferguson', 41.936939239502, 0.731937667938116, -92.8655624389648, -1.62080982627631, 218, 16, 'PPL', 'P'),
(194924, 'Ferguson', 47.560001373291, 0.830078616216953, -115.923332214355, -2.02324382702371, 218, 17, 'PPL', 'P'),
(80980, 'Ferguson (historical)', 33.4319381713867, 0.583497396413871, -80.2805633544922, -1.40116015589179, 218, 48, 'PPL', 'P'),
(190196, 'Ferguson (historical)', 37.458610534668, 0.65377608705219, -114.763061523438, -2.0029932832528, 218, 39, 'PPL', 'P'),
(209452, 'Ferguson Corner', 41.9588890075684, 0.732320763660924, -104.981666564941, -1.83227573578907, 218, 59, 'PPL', 'P'),
(94199, 'Ferguson Crossing', 30.6075000762939, 0.534201652135745, -96.1813888549805, -1.67868191466039, 218, 51, 'PPL', 'P'),
(2433, 'Ferguson Crossroad', 33.9474983215332, 0.592495618526003, -86.2986068725586, -1.50619482981035, 218, 2, 'PPL', 'P'),
(8877, 'Ferguson Crossroads', 33.3327789306641, 0.581766741179483, -93.9530563354492, -1.63979017536531, 218, 4, 'PPL', 'P'),
(29789, 'Ferguson Hill', 39.4816703796387, 0.689085142311814, -87.4563903808594, -1.52640196405549, 218, 19, 'PPL', 'P'),
(8878, 'Ferguson Landing', 34.127498626709, 0.595637216505915, -90.9638900756836, -1.58761938224287, 218, 4, 'PPL', 'P'),
(80981, 'Ferguson Landing', 33.4305610656738, 0.583473361385033, -80.2811126708984, -1.40116974327172, 218, 48, 'PPL', 'P'),
(47045, 'Ferguson Meadows', 39.4086112976074, 0.687810020781884, -76.4972229003906, -1.33512840824382, 218, 25, 'PPL', 'P'),
(178180, 'Ferguson Place Windmill', 34.3466682434082, 0.59946244793765, -112.732780456543, -1.96755819389459, 218, 5, 'PPL', 'P'),
(35879, 'Ferguson Spring', 36.8511085510254, 0.64317317722523, -88.0391693115234, -1.53657337520683, 218, 21, 'PPL', 'P'),
(101913, 'Fergusonville', 37.2174987792969, 0.649567893055701, -78.0708312988281, -1.36259305593359, 218, 53, 'PPL', 'P'),
(148780, 'Fergusonville', 42.4927787780762, 0.741638897999002, -74.8052825927734, -1.3055984791287, 218, 40, 'PPL', 'P'),
(161585, 'Fergusonville', 40.1163902282715, 0.700163093498217, -74.9005584716797, -1.30726135691334, 218, 45, 'PPL', 'P'),
(207401, 'Feriton', 47.6694412231445, 0.831988701929785, -122.196670532227, -2.13273423576209, 218, 56, 'PPL', 'P'),
(161587, 'Fermoy', 41.5533294677734, 0.725242414378629, -75.3547210693359, -1.31518798958185, 218, 45, 'PPL', 'P'),
(32443, 'Fern', 37.3469390869141, 0.651827052608415, -95.376106262207, -1.66462708200749, 218, 20, 'PPL', 'P'),
(40898, 'Fern', 31.5108299255371, 0.549967732236582, -92.8952789306641, -1.62132847689861, 218, 22, 'PPL', 'P'),
(109185, 'Fern', 39.3477783203125, 0.686748285034297, -81.0666732788086, -1.41488036235372, 218, 58, 'PPL', 'P'),
(112230, 'Fern', 35.6388893127441, 0.622015960261204, -94.01611328125, -1.64089072668578, 218, 4, 'PPL', 'P'),
(113301, 'Fern', 41.2991714477539, 0.720806520108939, -79.5427780151367, -1.3882833725471, 218, 45, 'PPL', 'P'),
(115560, 'Fern', 42.4847183227539, 0.741498216514419, -92.7702789306641, -1.61914681533361, 218, 16, 'PPL', 'P'),
(130779, 'Fern', 43.8463897705078, 0.765263866608122, -86.2180633544922, -1.50478908022896, 218, 27, 'PPL', 'P'),
(174091, 'Fern', 45.836109161377, 0.799991021169565, -88.3858337402344, -1.54262381088738, 218, 57, 'PPL', 'P'),
(193546, 'Fern', 40.6883316040039, 0.710145353633134, -121.930557250977, -2.12808968282099, 218, 6, 'PPL', 'P'),
(211331, 'Fern Acres', 19.5122203826904, 0.340552490052696, -155.080276489258, -2.7066614296407, 218, 15, 'PPL', 'P'),
(181561, 'Fern Ann Falls', 34.2847213745117, 0.598381271114105, -118.615562438965, -2.07023210866485, 218, 6, 'PPL', 'P'),
(161588, 'Fern Brook', 41.3300018310547, 0.721344611807189, -75.9416732788086, -1.32543223818901, 218, 45, 'PPL', 'P'),
(35880, 'Fern Creek', 38.1597213745117, 0.666012779628886, -85.5877838134766, -1.49378862703027, 218, 21, 'PPL', 'P'),
(80982, 'Fern Creek', 34.7563896179199, 0.606613434938677, -82.3402786254883, -1.43710896902428, 218, 48, 'PPL', 'P'),
(16006, 'Fern Crest Village', 26.0888900756836, 0.455337030011551, -80.2194366455078, -1.40009329355911, 218, 12, 'PPL', 'P'),
(211332, 'Fern Forest', 19.4655609130859, 0.339738128680863, -155.135559082031, -2.70762629290364, 218, 15, 'PPL', 'P'),
(54744, 'Fern Glen', 38.5519409179688, 0.67285830205288, -90.5313873291016, -1.5800707852911, 218, 29, 'PPL', 'P'),
(161589, 'Fern Glen', 40.9466705322266, 0.714654218516692, -76.1591720581055, -1.32922830800681, 218, 45, 'PPL', 'P'),
(207402, 'Fern Heath', 47.3963890075684, 0.827223041738115, -122.409721374512, -2.13645267443411, 218, 56, 'PPL', 'P'),
(78261, 'Fern Hill', 39.9794387817383, 0.697772839840844, -75.5911102294922, -1.31931375874261, 218, 45, 'PPL', 'P'),
(200812, 'Fern Hill', 46.1647186279297, 0.805726338314132, -123.735832214355, -2.15959767483577, 218, 43, 'PPL', 'P'),
(207403, 'Fern Hill', 47.1811103820801, 0.823465720914177, -122.432220458984, -2.13684535753684, 218, 56, 'PPL', 'P'),
(13761, 'Fern Hook', 39.7027816772461, 0.692944262468421, -75.5722198486328, -1.31898405939965, 218, 10, 'PPL', 'P'),
(16007, 'Fern Park', 28.648889541626, 0.500017449541542, -81.3513870239258, -1.4198495546317, 218, 12, 'PPL', 'P'),
(207404, 'Fern Prairie', 45.6366691589355, 0.796510136466777, -122.397499084473, -2.13623935523079, 218, 56, 'PPL', 'P'),
(200813, 'Fern Ridge Shores', 44.0819396972656, 0.769374988382878, -123.306938171387, -2.15211206164377, 218, 43, 'PPL', 'P'),
(161590, 'Fern Rock', 40.0438919067383, 0.698897759085293, -75.1397171020508, -1.31143546244788, 218, 45, 'PPL', 'P'),
(47046, 'Fern Valley', 39.601390838623, 0.691174658503091, -76.6055603027344, -1.33701925261778, 218, 25, 'PPL', 'P'),
(181562, 'Fern Valley', 33.7586097717285, 0.589198891412594, -116.697219848633, -2.03675071428232, 218, 6, 'PPL', 'P'),
(191457, 'Fern Village Number 1 Colonia', 31.8269996643066, 0.555485935173281, -106.160003662109, -1.85284159783305, 218, 51, 'PPL', 'P'),
(72537, 'Fernald', 39.2755584716797, 0.685487810890363, -84.6897201538086, -1.47811445927656, 218, 41, 'PPL', 'P'),
(115562, 'Fernald', 42.0708312988281, 0.734274525215633, -93.3947219848633, -1.6300454026206, 218, 16, 'PPL', 'P'),
(143821, 'Fernald', 43.6133308410645, 0.761196220938162, -71.1697235107422, -1.24214600299647, 218, 36, 'PPL', 'P'),
(127478, 'Fernald Shore', 43.4338912963867, 0.758064410075256, -70.9580612182617, -1.23845179909037, 218, 26, 'PPL', 'P'),
(194925, 'Fernan Lake Village', 47.6738891601563, 0.832066333075561, -116.744438171387, -2.03757482948165, 218, 17, 'PPL', 'P'),
(211330, 'Fernandez Village', 21.3502807617188, 0.372632695517195, -158.033325195313, -2.75820185253311, 218, 15, 'PPL', 'P'),
(16008, 'Fernandina Beach', 30.6694393157959, 0.535282695801235, -81.4627838134766, -1.42179379538551, 218, 12, 'PPL', 'P'),
(177359, 'Fernando', 44.651668548584, 0.779318632681988, -94.4574966430664, -1.648594319613, 218, 28, 'PPL', 'P'),
(2434, 'Fernbank', 33.5791702270508, 0.586067080549688, -88.1416702270508, -1.53836235366909, 218, 2, 'PPL', 'P'),
(72541, 'Fernbank', 39.125560760498, 0.682869856959788, -84.7024993896484, -1.47833749901785, 218, 41, 'PPL', 'P'),
(193547, 'Fernbridge', 40.6163902282715, 0.708889739758189, -124.199996948242, -2.16769887771374, 218, 6, 'PPL', 'P'),
(21058, 'Fernbrook', 33.5716705322266, 0.585936186182111, -82.1194381713867, -1.43325457597861, 218, 13, 'PPL', 'P'),
(47047, 'Fernbrook', 39.0611114501953, 0.681745004294365, -76.5061111450195, -1.33528353737732, 218, 25, 'PPL', 'P'),
(181564, 'Fernbrook', 32.9680595397949, 0.575401186962948, -116.910827636719, -2.04047887349232, 218, 6, 'PPL', 'P'),
(47048, 'Ferncliff', 39.6213912963867, 0.691523732342973, -76.4011077880859, -1.33345088307318, 218, 25, 'PPL', 'P'),
(101914, 'Ferncliff', 37.9330596923828, 0.662056786987627, -78.1102828979492, -1.36328161623343, 218, 53, 'PPL', 'P'),
(194181, 'Ferncliff', 40.1908302307129, 0.701462316636012, -105.512496948242, -1.8415404737473, 218, 7, 'PPL', 'P'),
(207405, 'Ferncliff', 47.6427803039551, 0.831523381108321, -122.509170532227, -2.13818838967457, 218, 56, 'PPL', 'P'),
(2435, 'Ferncliff (historical)', 34.6194381713867, 0.604223181281303, -85.9680633544922, -1.50042575709897, 218, 2, 'PPL', 'P'),
(155246, 'Ferncliff (historical)', 40.1191711425781, 0.700211629609084, -81.8324966430664, -1.42824650154872, 218, 41, 'PPL', 'P'),
(124829, 'Ferncroft', 42.5791702270508, 0.743146713229178, -70.9583282470703, -1.23845645962227, 218, 23, 'PPL', 'P'),
(143822, 'Ferncroft', 43.9122200012207, 0.76641282088141, -71.3602828979492, -1.24547189172381, 218, 36, 'PPL', 'P'),
(8879, 'Ferndale', 34.7788887023926, 0.607006118041409, -92.557502746582, -1.61543317035155, 218, 4, 'PPL', 'P'),
(16009, 'Ferndale', 28.6216697692871, 0.499542374892586, -81.70361328125, -1.42599706253398, 218, 12, 'PPL', 'P'),
(29790, 'Ferndale', 39.707218170166, 0.693021693877115, -87.0669403076172, -1.51960477800528, 218, 19, 'PPL', 'P'),
(35881, 'Ferndale', 36.6961097717285, 0.640467938189927, -83.6847229003906, -1.46057394823092, 218, 21, 'PPL', 'P'),
(47049, 'Ferndale', 39.1830596923828, 0.683873402637557, -76.6405563354492, -1.33763004861379, 218, 25, 'PPL', 'P'),
(80984, 'Ferndale', 35.021671295166, 0.611243473651834, -81.9475021362305, -1.43025372606231, 218, 48, 'PPL', 'P'),
(119610, 'Ferndale', 42.3019409179688, 0.738308149002667, -88.2413864135742, -1.54010272944146, 218, 18, 'PPL', 'P'),
(130780, 'Ferndale', 42.4605598449707, 0.741076571534832, -83.1347198486328, -1.45097458408172, 218, 27, 'PPL', 'P'),
(148781, 'Ferndale', 41.7738914489746, 0.729091947155312, -74.7388916015625, -1.3044397377384, 218, 40, 'PPL', 'P'),
(161594, 'Ferndale', 40.8819389343262, 0.713524439003254, -76.2444381713867, -1.33071648242394, 218, 45, 'PPL', 'P'),
(186709, 'Ferndale', 39.4061088562012, 0.687766344940007, -105.254997253418, -1.83704625624973, 218, 7, 'PPL', 'P'),
(193548, 'Ferndale', 40.5763893127441, 0.708191592078424, -124.26277923584, -2.16879463534425, 218, 6, 'PPL', 'P'),
(200817, 'Ferndale', 45.9813919067383, 0.802526683422456, -118.396392822266, -2.06640687723312, 218, 43, 'PPL', 'P'),
(207406, 'Ferndale', 48.8466682434082, 0.852535189476828, -122.589721679688, -2.13959427241402, 218, 56, 'PPL', 'P'),
(209866, 'Ferndale', 48.0516700744629, 0.838659853881406, -114.006393432617, -1.98978693372321, 218, 31, 'PPL', 'P'),
(211333, 'Ferndale (historical)', 19.577220916748, 0.341686963387556, -155.078323364258, -2.70662734117875, 218, 15, 'PPL', 'P'),
(47050, 'Ferndale Farms', 39.1855583190918, 0.683917011900407, -76.6374969482422, -1.33757665223393, 218, 25, 'PPL', 'P'),
(101915, 'Ferndale Gardens', 37.2188911437988, 0.649592194400648, -77.4655609130859, -1.35202909483757, 218, 53, 'PPL', 'P'),
(47051, 'Ferndale Manor', 39.1763916015625, 0.68375702249792, -76.6322174072266, -1.33748450686022, 218, 25, 'PPL', 'P'),
(196470, 'Ferndale Mobile Court', 48.0519409179688, 0.838664580992341, -114.005561828613, -1.98977241949527, 218, 31, 'PPL', 'P'),
(101916, 'Ferndale Park', 37.2213897705078, 0.649635803663498, -77.4747161865234, -1.35218888450298, 218, 53, 'PPL', 'P'),
(72538, 'Fernell Heights', 39.1116714477539, 0.682627442721563, -84.2888870239258, -1.47111860140903, 218, 41, 'PPL', 'P'),
(161596, 'Ferney', 41.2241706848145, 0.719497509854138, -77.5633316040039, -1.35373551530604, 218, 45, 'PPL', 'P'),
(170299, 'Ferney', 45.3305587768555, 0.791167502424941, -98.0975036621094, -1.712124426891, 218, 49, 'PPL', 'P'),
(78262, 'Fernglen', 39.8102798461914, 0.694820459456382, -76.2663879394531, -1.33109957814675, 218, 45, 'PPL', 'P'),
(2436, 'Fernland', 30.483060836792, 0.532029777687758, -88.2930603027344, -1.54100460894462, 218, 2, 'PPL', 'P'),
(35882, 'Fernleaf', 38.6561088562012, 0.67467637555005, -83.913330078125, -1.46456389617607, 218, 21, 'PPL', 'P'),
(190197, 'Fernley', 39.6080589294434, 0.691291038642727, -119.250831604004, -2.08131964723118, 218, 39, 'PPL', 'P'),
(54745, 'Fernridge', 38.6808280944824, 0.675107807646643, -90.4775009155273, -1.57913028995214, 218, 29, 'PPL', 'P'),
(161597, 'Fernridge', 41.0716705322266, 0.716835880081685, -75.5663909912109, -1.31888232664601, 218, 45, 'PPL', 'P'),
(113428, 'Fernridge Place', 41.7688903808594, 0.729004662050584, -72.7380599975586, -1.26951863847058, 218, 8, 'PPL', 'P'),
(200814, 'Ferns (historical)', 44.8555603027344, 0.782877215109579, -123.366668701172, -2.15315455605249, 218, 43, 'PPL', 'P'),
(2438, 'Ferns Quarter (historical)', 34.4338912963867, 0.600984777395767, -86.4033279418945, -1.50802255726648, 218, 2, 'PPL', 'P'),
(47053, 'Fernshire Woods', 39.1324996948242, 0.682990964210359, -77.2480621337891, -1.34823302501978, 218, 25, 'PPL', 'P'),
(86961, 'Fernvale', 35.9544410705566, 0.627523377395488, -87.0791702270508, -1.51981823036665, 218, 50, 'PPL', 'P'),
(200815, 'Fernvale', 42.7786102294922, 0.746627597931966, -123.370277404785, -2.15321753981227, 218, 43, 'PPL', 'P'),
(86962, 'Fernvale Springs (historical)', 35.9563903808594, 0.627557399278414, -87.0749969482422, -1.51974539291084, 218, 50, 'PPL', 'P'),
(161598, 'Fernville', 41.0038909912109, 0.715652903925472, -76.4641723632813, -1.33455156755171, 218, 45, 'PPL', 'P'),
(172018, 'Fernville', 43.8608283996582, 0.765515868226271, -73.0683288574219, -1.275282917492, 218, 55, 'PPL', 'P'),
(119612, 'Fernway', 41.5699996948242, 0.725533364727721, -87.8233337402344, -1.53280633384492, 218, 18, 'PPL', 'P'),
(161599, 'Fernway', 40.6947212219238, 0.710256873503781, -80.1311111450195, -1.39855172276211, 218, 45, 'PPL', 'P'),
(21059, 'Fernway Estates', 33.4744415283203, 0.584239219935512, -84.470832824707, -1.47429415469284, 218, 13, 'PPL', 'P'),
(119613, 'Fernway Park', 41.5869407653809, 0.725829042187747, -87.8300018310547, -1.53292271398455, 218, 18, 'PPL', 'P'),
(13762, 'Fernwood', 38.6533317565918, 0.67462790601821, -75.5722198486328, -1.31898405939965, 218, 10, 'PPL', 'P'),
(21064, 'Fernwood', 33.0888900756836, 0.577510077651154, -85.0305633544922, -1.48406329536152, 218, 13, 'PPL', 'P'),
(47054, 'Fernwood', 39.0180587768555, 0.680993593392799, -77.1374969482422, -1.3463032984939, 218, 25, 'PPL', 'P'),
(59899, 'Fernwood', 31.1852798461914, 0.544285811471871, -90.4488906860352, -1.57863094724775, 218, 30, 'PPL', 'P'),
(80986, 'Fernwood', 34.4527816772461, 0.601314476738719, -82.6458282470703, -1.44244181594911, 218, 48, 'PPL', 'P'),
(86963, 'Fernwood', 36.1594390869141, 0.631101267740982, -83.3058319091797, -1.45396105292814, 218, 50, 'PPL', 'P'),
(113429, 'Fernwood', 41.2691688537598, 0.720282876059602, -72.366943359375, -1.26304143122534, 218, 8, 'PPL', 'P'),
(143823, 'Fernwood', 43.4080581665039, 0.757613536902706, -72.0650024414063, -1.25777156806029, 218, 36, 'PPL', 'P'),
(145221, 'Fernwood', 40.2588882446289, 0.702650153061215, -74.79638671875, -1.30544321683715, 218, 37, 'PPL', 'P'),
(148784, 'Fernwood', 41.874439239502, 0.730846837155619, -75.0699996948242, -1.31021866414582, 218, 40, 'PPL', 'P'),
(155248, 'Fernwood', 40.334171295166, 0.703964090164033, -80.7077789306641, -1.4086164743118, 218, 41, 'PPL', 'P'),
(161600, 'Fernwood', 40.773609161377, 0.711633727787352, -78.3986129760742, -1.36831392542925, 218, 45, 'PPL', 'P'),
(193549, 'Fernwood', 40.8691711425781, 0.713301598999041, -123.84944152832, -2.16158053142539, 218, 6, 'PPL', 'P'),
(194926, 'Fernwood', 47.1122207641602, 0.822263370261034, -116.391670227051, -2.03141786735749, 218, 17, 'PPL', 'P'),
(200816, 'Fernwood', 45.1247215270996, 0.787574964693452, -122.470001220703, -2.13750475622274, 218, 43, 'PPL', 'P'),
(207407, 'Fernwood', 47.5066719055176, 0.82914784141597, -122.651672363281, -2.14067551581659, 218, 56, 'PPL', 'P'),
(80987, 'Fernwood Acres', 34.7702789306641, 0.606855849176901, -82.9986114501953, -1.44859904438937, 218, 48, 'PPL', 'P'),
(2440, 'Fernwood Estates', 33.6261100769043, 0.586886335480024, -86.6788864135742, -1.51283195987905, 218, 2, 'PPL', 'P'),
(113430, 'Fernwood Estates', 41.4569396972656, 0.723560095518026, -72.904167175293, -1.27241775563324, 218, 8, 'PPL', 'P'),
(86964, 'Fernwood Heights', 36.1622200012207, 0.631149803851849, -83.2997207641602, -1.45385439332648, 218, 50, 'PPL', 'P'),
(13094, 'Fernwood Heights (historical)', 38.9416694641113, 0.679660348372078, -77.0597229003906, -1.34494588528629, 218, 9, 'PPL', 'P'),
(47055, 'Fernwood Mobile Home Park', 38.8633308410645, 0.678293081468432, -76.8436126708984, -1.34117405023441, 218, 25, 'PPL', 'P'),
(64701, 'Fero', 35.586669921875, 0.621104559957152, -81.977783203125, -1.43078223038063, 218, 33, 'PPL', 'P'),
(27159, 'Ferrel', 39.4961090087891, 0.689337143929963, -87.5849990844727, -1.52864660938027, 218, 18, 'PPL', 'P'),
(203967, 'Ferreland Acres', 40.6222190856934, 0.70899147251183, -111.841667175293, -1.95200533312853, 218, 52, 'PPL', 'P'),
(70813, 'Ferrell', 39.6752815246582, 0.692464294260961, -75.1991729736328, -1.31247316316663, 218, 37, 'PPL', 'P'),
(109186, 'Ferrell', 38.3527793884277, 0.669382277619081, -81.833610534668, -1.42826594262467, 218, 58, 'PPL', 'P'),
(8881, 'Ferrell (historical)', 33.4019393920898, 0.582973818943561, -92.0536117553711, -1.60663861348378, 218, 4, 'PPL', 'P'),
(21065, 'Ferrell Crossroads', 31.4841709136963, 0.549502444704632, -84.9161071777344, -1.48206565822785, 218, 13, 'PPL', 'P'),
(109187, 'Ferrellsburg', 38.0250015258789, 0.663661474702455, -82.1055603027344, -1.43301236147747, 218, 58, 'PPL', 'P'),
(161601, 'Ferrellton', 40.1474990844727, 0.700706045465457, -79.0408325195313, -1.37952277098323, 218, 45, 'PPL', 'P'),
(54746, 'Ferrelview', 39.3111114501953, 0.686108327424351, -94.6647186279297, -1.65221102553138, 218, 29, 'PPL', 'P'),
(40900, 'Ferriday', 31.6299991607666, 0.55204762775842, -91.554443359375, -1.59792648145175, 218, 22, 'PPL', 'P'),
(27160, 'Ferrin', 38.6094398498535, 0.673861847730649, -89.2333297729492, -1.55741540705585, 218, 18, 'PPL', 'P'),
(94200, 'Ferris', 32.5338897705078, 0.567823494976264, -96.665283203125, -1.6871274642673, 218, 51, 'PPL', 'P'),
(119614, 'Ferris', 40.4688911437988, 0.706315395090464, -91.170280456543, -1.59122157393331, 218, 18, 'PPL', 'P'),
(161602, 'Ferris', 41.1011085510254, 0.717349670434989, -79.8605575561523, -1.39382967183329, 218, 45, 'PPL', 'P'),
(196471, 'Ferris (historical)', 46.6911087036133, 0.814913578284633, -112.388061523438, -1.96154171351794, 218, 31, 'PPL', 'P'),
(209453, 'Ferris (historical)', 42.1949996948242, 0.736441672552685, -107.180282592773, -1.87064882446186, 218, 59, 'PPL', 'P'),
(161605, 'Ferris Corners', 41.7941703796387, 0.729445881264183, -79.9625015258789, -1.39560892975758, 218, 45, 'PPL', 'P'),
(172019, 'Ferrisburgh', 44.2055587768555, 0.771532548340005, -73.2466735839844, -1.27839562017408, 218, 55, 'PPL', 'P'),
(72539, 'Ferristown', 39.2358283996582, 0.684794390321533, -83.9238891601563, -1.46474818692351, 218, 41, 'PPL', 'P'),
(101918, 'Ferrol', 38.1086082458496, 0.665120687242736, -79.2855606079102, -1.38379408189755, 218, 53, 'PPL', 'P'),
(192566, 'Ferron', 39.0936088562012, 0.682312191027525, -111.132499694824, -1.93962802564628, 218, 52, 'PPL', 'P'),
(192567, 'Ferron Mill', 39.0997200012207, 0.682418850629183, -111.183609008789, -1.9405200514534, 218, 52, 'PPL', 'P'),
(101919, 'Ferrum', 36.922779083252, 0.64442406398924, -80.0136108398438, -1.3965009555647, 218, 53, 'PPL', 'P'),
(181569, 'Ferrum', 33.458610534668, 0.583962916972416, -115.860000610352, -2.02213848201327, 218, 6, 'PPL', 'P'),
(72540, 'Ferry', 39.5802803039551, 0.690806210166278, -84.1044387817383, -1.46789937228334, 218, 41, 'PPL', 'P'),
(130783, 'Ferry', 43.584171295166, 0.760687290853848, -86.2247161865234, -1.50490519405248, 218, 27, 'PPL', 'P'),
(211827, 'Ferry', 64.0166702270508, 1.11730167162546, -149.116668701172, -2.60257683844103, 218, 1, 'PPL', 'P'),
(127479, 'Ferry Beach', 43.4705581665039, 0.758704367685203, -70.3863906860352, -1.22847426606638, 218, 26, 'PPL', 'P'),
(101920, 'Ferry Farm', 38.2930603027344, 0.668339982947451, -77.4377822875977, -1.35154426636113, 218, 53, 'PPL', 'P'),
(47067, 'Ferry Farms', 38.9941711425781, 0.680576675524147, -76.4791717529297, -1.33481335628687, 218, 25, 'PPL', 'P'),
(124830, 'Ferry Hill', 42.1394386291504, 0.73547194902076, -70.6997222900391, -1.23394293420681, 218, 23, 'PPL', 'P'),
(21066, 'Ferry Lake', 31.4672203063965, 0.549206600797038, -83.4730606079102, -1.45687974432481, 218, 13, 'PPL', 'P'),
(40901, 'Ferry Lake', 32.7394409179688, 0.571411039280709, -94.0074996948242, -1.64074039124225, 218, 22, 'PPL', 'P'),
(13763, 'Ferry Landing', 38.5922203063965, 0.673561310001634, -75.2444381713867, -1.313263189904, 218, 10, 'PPL', 'P'),
(21067, 'Ferry Landing', 30.7827796936035, 0.537260858569433, -82.0247192382813, -1.43160141873194, 218, 13, 'PPL', 'P'),
(47056, 'Ferry Landing Woods', 38.7222213745117, 0.675830256671354, -76.6819381713867, -1.33835229790142, 218, 25, 'PPL', 'P'),
(40902, 'Ferry Newlight Landing', 32.103889465332, 0.560318573866366, -91.4291687011719, -1.5957400261968, 218, 22, 'PPL', 'P'),
(16010, 'Ferry Pass', 30.5100002288818, 0.532499958778212, -87.2125015258789, -1.52214530052717, 218, 12, 'PPL', 'P'),
(47057, 'Ferry Point', 38.5955581665039, 0.673619566650479, -76.0516662597656, -1.32735197786079, 218, 25, 'PPL', 'P'),
(193550, 'Ferry Point (historical)', 41.6705589294434, 0.72728845446511, -123.427780151367, -2.15422115206906, 218, 6, 'PPL', 'P'),
(47058, 'Ferry Road', 38.2994384765625, 0.668451303081017, -75.6908264160156, -1.32105413451497, 218, 25, 'PPL', 'P'),
(145222, 'Ferry Road Manor', 40.2533302307129, 0.702553147418509, -74.8047180175781, -1.30558862543266, 218, 37, 'PPL', 'P'),
(2441, 'Ferry Shores', 34.7758293151855, 0.606952721661553, -87.3066711425781, -1.52378887039391, 218, 2, 'PPL', 'P'),
(148785, 'Ferry Village', 42.9708290100098, 0.749982448536166, -78.9486083984375, -1.37791315642038, 218, 40, 'PPL', 'P'),
(54747, 'Ferrys (historical)', 36.9388885498047, 0.644705227221325, -90.2880630493164, -1.5758239754588, 218, 29, 'PPL', 'P'),
(130785, 'Ferrysburg', 43.0844383239746, 0.751965305125784, -86.2202835083008, -1.50482782922282, 218, 27, 'PPL', 'P'),
(174093, 'Ferryville', 43.3505592346191, 0.756609991224937, -91.101936340332, -1.59002874408107, 218, 57, 'PPL', 'P'),
(80989, 'Fersners', 33.538890838623, 0.585364072600934, -80.7663879394531, -1.4096393944865, 218, 48, 'PPL', 'P'),
(119615, 'Ferson Creek Woods', 41.9588890075684, 0.732320763660924, -88.3647232055664, -1.54225536255057, 218, 18, 'PPL', 'P'),
(161603, 'Fertigs', 41.3505592346191, 0.72170340618505, -79.5833282470703, -1.38899110760678, 218, 45, 'PPL', 'P'),
(54748, 'Fertile', 38.0738906860352, 0.664514751515716, -90.6855621337891, -1.58276164325651, 218, 29, 'PPL', 'P'),
(115563, 'Fertile', 43.2644386291504, 0.755106903105696, -93.4180603027344, -1.63045273310933, 218, 16, 'PPL', 'P'),
(135354, 'Fertile', 47.5361099243164, 0.829661631769274, -96.2799987792969, -1.68040298251485, 218, 28, 'PPL', 'P'),
(161604, 'Fertility', 40.0269393920898, 0.698601881888185, -76.2433319091797, -1.33069717450604, 218, 45, 'PPL', 'P'),
(140010, 'Fessenden', 47.649169921875, 0.831634900978968, -99.6288909912109, -1.73885217790715, 218, 34, 'PPL', 'P'),
(143825, 'Fessenden (historical)', 43.0969390869141, 0.752183484598089, -71.6922225952148, -1.25126533235917, 218, 36, 'PPL', 'P'),
(115565, 'Festina', 43.1194381713867, 0.752576167700821, -91.866943359375, -1.60338063536423, 218, 16, 'PPL', 'P'),
(16011, 'Festus', 30.601390838623, 0.534095025823601, -83.9688873291016, -1.46553355312897, 218, 12, 'PPL', 'P'),
(54749, 'Festus', 38.2205581665039, 0.6670745819555, -90.3958282470703, -1.57770483297867, 218, 29, 'PPL', 'P'),
(109188, 'Festus', 39.4705581665039, 0.688891197605429, -80.2874984741211, -1.40128119656334, 218, 58, 'PPL', 'P'),
(161606, 'Fetherolfsville', 40.6319389343262, 0.709161115873268, -75.8349990844727, -1.32357042227093, 218, 45, 'PPL', 'P'),
(21068, 'Fetlock Meadows', 33.4055595397949, 0.583037002440423, -84.5597229003906, -1.47584557918587, 218, 13, 'PPL', 'P'),
(47059, 'Fetrows', 39.2294387817383, 0.684682870450886, -77.2350006103516, -1.34800505843046, 218, 25, 'PPL', 'P'),
(109189, 'Fetterman', 39.3494415283203, 0.686777313490179, -80.038330078125, -1.39693238766129, 218, 58, 'PPL', 'P'),
(181568, 'Fetters Hot Springs', 38.3199996948242, 0.668810164037905, -122.485000610352, -2.1377665449579, 218, 6, 'PPL', 'P'),
(161607, 'Fetterville', 40.1097183227539, 0.700046646779553, -76.0069427490234, -1.32657140534529, 218, 45, 'PPL', 'P'),
(94201, 'Fetzer', 30.2411098480225, 0.527806936305274, -95.817497253418, -1.67233080809277, 218, 51, 'PPL', 'P'),
(86966, 'Fetzerton (historical)', 35.0847206115723, 0.612343891814255, -84.6708297729492, -1.47778475993361, 218, 50, 'PPL', 'P'),
(161608, 'Fetzertown', 40.9888916015625, 0.715391115190317, -77.8277816772461, -1.35835103979126, 218, 45, 'PPL', 'P'),
(148786, 'Feura Bush', 42.5777816772461, 0.743122478463258, -73.8791732788086, -1.28943482236662, 218, 40, 'PPL', 'P'),
(64703, 'Few', 35.9336090087891, 0.627159789327665, -78.8883285522461, -1.37686107463175, 218, 33, 'PPL', 'P'),
(86965, 'Few Chapel', 36.1063919067383, 0.630175419788016, -87.5791702270508, -1.52854487662663, 218, 50, 'PPL', 'P'),
(59900, 'Fewell', 34.0611114501953, 0.594478541694649, -90.3561096191406, -1.57701161214692, 218, 30, 'PPL', 'P'),
(75823, 'Fewell', 34.5180587768555, 0.602453777053055, -95.0536117553711, -1.65899849104361, 218, 42, 'PPL', 'P'),
(29791, 'Fewell Rhoades', 39.4213905334473, 0.688033060523179, -86.3994369506836, -1.50795464665868, 218, 19, 'PPL', 'P'),
(86967, 'Fewville (historical)', 36.0063896179199, 0.628430050588606, -87.5188903808594, -1.52749279483799, 218, 50, 'PPL', 'P'),
(148790, 'Fey Mill', 43.4452781677246, 0.758263148471604, -75.5449981689453, -1.31850895146118, 218, 40, 'PPL', 'P'),
(127481, 'Feylers Corner', 44.1372184753418, 0.770339785066786, -69.3711090087891, -1.21075425796327, 218, 26, 'PPL', 'P'),
(161609, 'Feys Grove', 41.0897216796875, 0.717150932038642, -76.004997253418, -1.32653745004139, 218, 45, 'PPL', 'P'),
(32444, 'Fiat', 37.540828704834, 0.655211064826552, -96.2072219848633, -1.67913278783294, 218, 20, 'PPL', 'P'),
(122605, 'Fiat', 40.5533294677734, 0.707789121858686, -85.1500015258789, -1.48614788470478, 218, 19, 'PPL', 'P'),
(155250, 'Fiat', 40.413330078125, 0.705345671558538, -81.6619415283203, -1.42526975324028, 218, 41, 'PPL', 'P'),
(119616, 'Fiatt', 40.5602798461914, 0.707910428846339, -90.1797180175781, -1.57393299792679, 218, 18, 'PPL', 'P'),
(124836, 'Fiberloid', 42.1513900756836, 0.735680541113141, -72.533332824707, -1.26594547523602, 218, 23, 'PPL', 'P'),
(130787, 'Fibre', 46.2055587768555, 0.806439133379892, -84.7286071777344, -1.47879316588037, 218, 27, 'PPL', 'P'),
(64704, 'Fibreville', 35.5400009155273, 0.620290032137751, -82.8483276367188, -1.44597609703175, 218, 33, 'PPL', 'P'),
(122606, 'Fickle', 40.2611083984375, 0.702688902055075, -86.6750030517578, -1.51276418242931, 218, 19, 'PPL', 'P'),
(193551, 'Fickle Hill', 40.8638916015625, 0.713209453625324, -124.04167175293, -2.16493558176667, 218, 6, 'PPL', 'P'),
(148787, 'Fickles Corner', 42.2613906860352, 0.737600413942979, -75.8186111450195, -1.32328439876986, 218, 40, 'PPL', 'P'),
(21069, 'Ficklin', 33.6341705322266, 0.587027016964607, -82.7794418334961, -1.44477381295764, 218, 13, 'PPL', 'P'),
(27161, 'Ficklin', 39.7986106872559, 0.694616794212018, -88.3552780151367, -1.5420905128791, 218, 18, 'PPL', 'P'),
(21070, 'Fickling Mill', 32.6538887023926, 0.569917871436529, -84.1777801513672, -1.46917942066129, 218, 13, 'PPL', 'P'),
(35883, 'Fiddle Bow', 37.271671295166, 0.650513381821706, -87.6580581665039, -1.5299217309102, 218, 21, 'PPL', 'P'),
(161611, 'Fiddlergreen', 41.7461090087891, 0.728607052099836, -79.5419387817383, -1.3882687251611, 218, 45, 'PPL', 'P'),
(54750, 'Fiddlers Ford', 37.3838882446289, 0.652471937066378, -93.7988891601563, -1.63709945055795, 218, 29, 'PPL', 'P'),
(161610, 'Fiddlers Green', 40.3713912963867, 0.70461370173293, -78.6597213745117, -1.37287112668659, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(181572, 'Fiddlers Green', 39.728889465332, 0.693399929330934, -122.714172363281, -2.14176634659909, 218, 6, 'PPL', 'P'),
(190198, 'Fiddlers Green', 39.1547203063965, 0.683378787044102, -119.611671447754, -2.087617490577, 218, 39, 'PPL', 'P'),
(47060, 'Fiddlers Point', 38.5738906860352, 0.673241397775688, -76.6374969482422, -1.33757665223393, 218, 25, 'PPL', 'P'),
(47061, 'Fiddlesburg', 39.6575012207031, 0.69215396941494, -77.6888885498047, -1.35592689740901, 218, 25, 'PPL', 'P'),
(161612, 'Fiddletown', 40.8669395446777, 0.713262650268099, -75.4433288574219, -1.31673448722686, 218, 45, 'PPL', 'P'),
(181570, 'Fiddletown', 38.5038909912109, 0.672019672625614, -120.754440307617, -2.10756256977087, 218, 6, 'PPL', 'P'),
(35886, 'Fidelio', 36.732780456543, 0.641107962378901, -87.458610534668, -1.52644071304935, 218, 21, 'PPL', 'P'),
(16012, 'Fidelis', 30.9361095428467, 0.539936969280312, -87.024169921875, -1.51885829395174, 218, 12, 'PPL', 'P'),
(27162, 'Fidelity', 39.1527786254883, 0.68334489831923, -90.164436340332, -1.57366628234362, 218, 18, 'PPL', 'P'),
(32445, 'Fidelity', 39.7900009155273, 0.69446652534751, -95.7886123657227, -1.67182667169842, 218, 20, 'PPL', 'P'),
(35884, 'Fidelity', 36.6636085510254, 0.639900684877741, -84.6100006103516, -1.47672309076505, 218, 21, 'PPL', 'P'),
(54751, 'Fidelity', 37.0680618286133, 0.646959726242132, -94.3130569458008, -1.64607337132513, 218, 29, 'PPL', 'P'),
(8882, 'Fidelity (historical)', 35.2333297729492, 0.61493761097891, -94.2130584716797, -1.64432806870475, 218, 4, 'PPL', 'P'),
(21071, 'Fidelle', 34.6041717529297, 0.603956732014241, -84.820556640625, -1.48039798675325, 218, 13, 'PPL', 'P'),
(161613, 'Fiedler', 40.9047203063965, 0.713922048954002, -77.39111328125, -1.35072973854173, 218, 45, 'PPL', 'P'),
(35885, 'Field', 36.8927803039551, 0.643900486518931, -83.6022186279297, -1.45913397702951, 218, 21, 'PPL', 'P'),
(188549, 'Field', 34.6286087036133, 0.604383237262817, -103.565002441406, -1.8075502824385, 218, 38, 'PPL', 'P'),
(47062, 'Field Acres', 38.649169921875, 0.674555268299478, -76.6413879394531, -1.33764456284173, 218, 25, 'PPL', 'P'),
(143824, 'Field and Stream Travel Trailer Park', 42.8088912963867, 0.747156102250292, -71.6505584716797, -1.25053815622353, 218, 36, 'PPL', 'P'),
(148788, 'Field Corners', 41.4477806091309, 0.723400239273594, -73.6449966430664, -1.28534766904168, 218, 40, 'PPL', 'P'),
(94202, 'Field Creek', 30.9013900756836, 0.539331000263778, -98.9447174072266, -1.72691109621145, 218, 51, 'PPL', 'P'),
(86968, 'Field Crest', 35.6047210693359, 0.621419611914108, -87.0849990844727, -1.5199199631203, 218, 50, 'PPL', 'P'),
(148789, 'Field Crossing', 42.6775016784668, 0.744862920814652, -75.0313873291016, -1.30954475123198, 218, 40, 'PPL', 'P'),
(169372, 'Field Station (historical)', 41.9558296203613, 0.732267367281068, -71.5841674804688, -1.24937941483323, 218, 47, 'PPL', 'P'),
(101924, 'Fieldale', 36.7000007629395, 0.640535848797724, -79.9388885498047, -1.39519680557889, 218, 53, 'PPL', 'P'),
(101921, 'Fieldbrook', 38.0838890075684, 0.664689255146144, -78.4591674804688, -1.36937080090784, 218, 53, 'PPL', 'P'),
(193552, 'Fieldbrook', 40.9658317565918, 0.714988644970579, -124.034439086914, -2.164809347931, 218, 6, 'PPL', 'P'),
(47064, 'Fieldcrest', 39.4888916015625, 0.689211176410402, -76.995002746582, -1.34381630550993, 218, 25, 'PPL', 'P'),
(86969, 'Fieldcrest', 35.9083290100098, 0.626718570114066, -86.3380584716797, -1.50688339011019, 218, 50, 'PPL', 'P'),
(109190, 'Fieldcrest', 39.6583290100098, 0.692168417063854, -79.9308319091797, -1.39505619067333, 218, 58, 'PPL', 'P'),
(80991, 'Fieldcrest Acres', 34.5083312988281, 0.602284000533562, -82.7227783203125, -1.44378484808684, 218, 48, 'PPL', 'P'),
(35887, 'Fielden', 38.1027793884277, 0.665018954489095, -82.9477767944336, -1.44771181227221, 218, 21, 'PPL', 'P'),
(54752, 'Fielden', 36.8619384765625, 0.643362195083598, -92.383056640625, -1.61238851143532, 218, 29, 'PPL', 'P'),
(21072, 'Fielder Manor', 33.5458297729492, 0.585485179851506, -84.3091735839844, -1.47147266867596, 218, 13, 'PPL', 'P'),
(115566, 'Fielding', 42.6630592346191, 0.744610852617476, -95.8000030517578, -1.67202547667379, 218, 16, 'PPL', 'P'),
(203968, 'Fielding', 41.8147201538086, 0.72980454248399, -112.115280151367, -1.9567807804372, 218, 52, 'PPL', 'P'),
(27165, 'Fieldon', 39.1086082458496, 0.68257397976268, -90.4983291625977, -1.57949381144093, 218, 18, 'PPL', 'P'),
(21073, 'Fields', 32.2730598449707, 0.56327115398791, -83.9961090087891, -1.46600866106744, 218, 13, 'PPL', 'P'),
(29795, 'Fields', 39.5461082458496, 0.690209795240155, -86.3333282470703, -1.5068008321164, 218, 19, 'PPL', 'P'),
(40904, 'Fields', 30.5261096954346, 0.532781122010297, -93.5747222900391, -1.63318700060051, 218, 22, 'PPL', 'P'),
(64705, 'Fields', 35.2836112976074, 0.615815189137118, -77.7311096191406, -1.35666379408264, 218, 33, 'PPL', 'P'),
(155249, 'Fields', 41.3683280944824, 0.72201353129399, -81.9977798461914, -1.43113123764149, 218, 41, 'PPL', 'P'),
(196472, 'Fields', 47.4505615234375, 0.828168530504121, -111.238891601563, -1.94148491471633, 218, 31, 'PPL', 'P'),
(200818, 'Fields', 42.2644386291504, 0.737653610585753, -118.674171447754, -2.07125502883955, 218, 43, 'PPL', 'P'),
(101922, 'Fields At Griffinsburg', 38.5011100769043, 0.671971136514747, -78.120002746582, -1.36345125959487, 218, 53, 'PPL', 'P'),
(124831, 'Fields Corner', 42.2999992370605, 0.738274260277796, -71.0583267211914, -1.24020176224266, 218, 23, 'PPL', 'P'),
(21074, 'Fields Crossroads', 34.1144409179688, 0.595409316495631, -84.3133316040039, -1.47154523981566, 218, 13, 'PPL', 'P'),
(101923, 'Fields Crossroads', 36.8316688537598, 0.642833890502354, -77.5494384765625, -1.35349303448879, 218, 53, 'PPL', 'P'),
(21075, 'Fields Landing', 34.1969413757324, 0.59684922111801, -84.5738906860352, -1.47609285369308, 218, 13, 'PPL', 'P'),
(193553, 'Fields Landing', 40.7247200012207, 0.71078045097409, -124.213890075684, -2.16794135853099, 218, 6, 'PPL', 'P'),
(47065, 'Fields of Harvest', 39.3536109924316, 0.686850084366965, -76.8402786254883, -1.34111586016459, 218, 25, 'PPL', 'P'),
(47066, 'Fields of Stevenson', 39.3861083984375, 0.687417271100125, -76.7163925170898, -1.33895363967556, 218, 25, 'PPL', 'P'),
(64706, 'Fields of the Wood', 35.1233291625977, 0.613017738149072, -84.2574996948242, -1.4705707891728, 218, 33, 'PPL', 'P'),
(148791, 'Fields Settlement', 43.9436111450195, 0.766960699696666, -75.9797210693359, -1.32609629740682, 218, 40, 'PPL', 'P'),
(94203, 'Fields Store', 30.1445693969727, 0.526121987573094, -95.9558486938477, -1.67474549625314, 218, 51, 'PPL', 'P'),
(13764, 'Fieldsboro', 39.4172210693359, 0.687960289646392, -75.6588897705078, -1.32049673489882, 218, 10, 'PPL', 'P'),
(64707, 'Fieldsboro', 35.6055603027344, 0.621434259300104, -77.6741714477539, -1.35567003552188, 218, 33, 'PPL', 'P'),
(145223, 'Fieldsboro', 40.1363906860352, 0.700512167338099, -74.7291717529297, -1.30427009437697, 218, 37, 'PPL', 'P'),
(101925, 'Fieldshire', 37.6300010681152, 0.656767416167594, -77.3247222900391, -1.34957099715143, 218, 53, 'PPL', 'P'),
(78264, 'Fieldsons Crossroads', 39.7900009155273, 0.69446652534751, -79.940559387207, -1.39522596719282, 218, 45, 'PPL', 'P'),
(124832, 'Fieldston', 42.1072196960449, 0.73490962255659, -70.664436340332, -1.23332707820473, 218, 23, 'PPL', 'P'),
(21077, 'Fieldstone', 33.9111099243164, 0.591860521185046, -83.4819412231445, -1.45703474030025, 218, 13, 'PPL', 'P'),
(2442, 'Fieldstown', 33.6419410705566, 0.587162638443119, -86.855827331543, -1.51592016147911, 218, 2, 'PPL', 'P'),
(101926, 'Fieldstown', 37.3852806091309, 0.652496238411325, -77.9475021362305, -1.36044055598254, 218, 53, 'PPL', 'P'),
(172021, 'Fieldsville', 43.5386085510254, 0.759892070952351, -72.4438934326172, -1.26438446336307, 218, 55, 'PPL', 'P'),
(191458, 'Fieldton', 34.0391693115234, 0.594095579129895, -102.222778320313, -1.78412405222573, 218, 51, 'PPL', 'P'),
(86970, 'Fieldview', 36.0627784729004, 0.629414221769445, -83.9583282470703, -1.46534926238154, 218, 50, 'PPL', 'P'),
(145225, 'Fieldville', 40.5472183227539, 0.707682462257028, -74.5069427490234, -1.30039146656537, 218, 37, 'PPL', 'P'),
(21078, 'Fieldwood', 34.2619400024414, 0.597983661163357, -85.1341705322266, -1.48587158174169, 218, 13, 'PPL', 'P'),
(13765, 'Fieldwood Addition', 38.7324981689453, 0.676009620570771, -75.1241683959961, -1.3111640863328, 218, 10, 'PPL', 'P'),
(188550, 'Fierro', 32.8452796936035, 0.573258274391816, -108.077499389648, -1.88630821167153, 218, 38, 'PPL', 'P'),
(35888, 'Fies', 37.3222198486328, 0.651395620511822, -87.373893737793, -1.52496212601214, 218, 21, 'PPL', 'P'),
(178181, 'Fiesta Park', 33.4213905334473, 0.583313305403519, -111.748329162598, -1.95037627748973, 218, 5, 'PPL', 'P'),
(181571, 'Fiesta Shores', 32.7822189331055, 0.572157656492313, -117.219718933105, -2.04587004364503, 218, 6, 'PPL', 'P'),
(21079, 'Fife', 33.5347213745117, 0.585291301724148, -84.5455627441406, -1.47559843783671, 218, 13, 'PPL', 'P'),
(94204, 'Fife', 31.3902797698975, 0.547863735106879, -99.3841705322266, -1.73458100015088, 218, 51, 'PPL', 'P'),
(101927, 'Fife', 37.7491683959961, 0.658847278399919, -78.0622177124023, -1.36244272049006, 218, 53, 'PPL', 'P'),
(140013, 'Fife', 46.8852806091309, 0.818302517350786, -96.9638900756836, -1.69233913736253, 218, 34, 'PPL', 'P'),
(196473, 'Fife', 47.4558296203613, 0.828260476140756, -111.022216796875, -1.93770322596842, 218, 31, 'PPL', 'P'),
(207409, 'Fife', 47.2394409179688, 0.824483780819887, -122.355827331543, -2.13551204593709, 218, 56, 'PPL', 'P'),
(207410, 'Fife Heights', 47.2591705322266, 0.824828127548835, -122.344436645508, -2.13531324096172, 218, 56, 'PPL', 'P'),
(130788, 'Fife Lake', 44.5769386291504, 0.778014349538122, -85.3505630493164, -1.48964834364158, 218, 27, 'PPL', 'P'),
(174095, 'Fifield', 45.8797187805176, 0.800752152609109, -90.4219436645508, -1.57816063299924, 218, 57, 'PPL', 'P'),
(94205, 'Fifth Hidalgo Colonia', 27.9750003814697, 0.488255864903316, -97.4120025634766, -1.70016017569382, 218, 51, 'PPL', 'P'),
(94206, 'Fifth Street', 29.5980606079102, 0.516583609812867, -95.5511093139648, -1.66768146146171, 218, 51, 'PPL', 'P'),
(40905, 'Fifth Ward', 31.1299991607666, 0.543320981498449, -92.1727828979492, -1.60871854229513, 218, 22, 'PPL', 'P'),
(16013, 'Fiftone', 30.2488899230957, 0.527942724231354, -81.9961090087891, -1.43110207602755, 218, 12, 'PPL', 'P'),
(80992, 'Fifty Eight (historical)', 33.2347183227539, 0.580055260704943, -80.7555618286133, -1.40945044320715, 218, 48, 'PPL', 'P'),
(135358, 'Fifty Lakes', 46.7391700744629, 0.815752407448981, -94.0927810668945, -1.64222883197549, 218, 28, 'PPL', 'P'),
(8884, 'Fiftysix', 35.9575004577637, 0.627576773775344, -92.2183303833008, -1.60951349588052, 218, 4, 'PPL', 'P'),
(64709, 'Fig', 36.4527816772461, 0.636221061778605, -81.6044387817383, -1.42426614098348, 218, 33, 'PPL', 'P'),
(181573, 'Fig Orchard', 35.3086090087891, 0.616251481502701, -118.581672668457, -2.06964062058675, 218, 6, 'PPL', 'P'),
(181574, 'Figarden', 36.8227806091309, 0.642678761368857, -119.861389160156, -2.09197588685897, 218, 6, 'PPL', 'P'),
(35889, 'Figgs', 38.1147193908691, 0.665227346844394, -85.2713928222656, -1.48826656251, 218, 21, 'PPL', 'P'),
(47068, 'Figgs Landing', 38.1208305358887, 0.665334006446052, -75.29638671875, -1.31416986309712, 218, 25, 'PPL', 'P'),
(21080, 'Fighting Pine', 34.5647201538086, 0.603268171714401, -83.2455596923828, -1.45290910429756, 218, 13, 'PPL', 'P'),
(124833, 'Fighting Rock Corner', 41.7347183227539, 0.728408247124461, -71.0902786254883, -1.24075942817492, 218, 23, 'PPL', 'P'),
(94208, 'Figridge', 29.7627792358398, 0.519458492209607, -94.3766708374023, -1.64718364318358, 218, 51, 'PPL', 'P'),
(101928, 'Figsboro', 36.7863883972168, 0.642043597448873, -79.85888671875, -1.39380051021936, 218, 53, 'PPL', 'P'),
(8885, 'Figure Five', 35.5169410705566, 0.619887561918013, -94.3536071777344, -1.64678110638482, 218, 4, 'PPL', 'P'),
(8886, 'Fikes (historical)', 34.1194381713867, 0.595496535021332, -92.2586135864258, -1.6102165704083, 218, 4, 'PPL', 'P'),
(86971, 'Fikes Mill', 35.6961097717285, 0.623014645669984, -87.2200012207031, -1.52227619489474, 218, 50, 'PPL', 'P'),
(59904, 'Fikestown', 32.3033294677734, 0.563799458569154, -89.4036102294922, -1.56038736167432, 218, 30, 'PPL', 'P'),
(2443, 'Fikestown (historical)', 33.084171295166, 0.577427719394444, -87.1505584716797, -1.52106419028265, 218, 2, 'PPL', 'P'),
(86972, 'Fiketon', 35.503059387207, 0.619645280837843, -84.6872177124023, -1.47807078343468, 218, 50, 'PPL', 'P'),
(78269, 'Fiketown', 39.7411117553711, 0.693613248534249, -79.4886093139648, -1.38733795036012, 218, 45, 'PPL', 'P'),
(160, 'Filbert', 37.3180618286133, 0.651323049372118, -81.5441665649414, -1.4232141923529, 218, 58, 'PPL', 'P'),
(78265, 'Filbert', 39.9430618286133, 0.697137942236969, -79.8541717529297, -1.39371821854168, 218, 45, 'PPL', 'P'),
(80993, 'Filbert', 35.0486106872559, 0.611713654742287, -81.2544403076172, -1.41815751523311, 218, 48, 'PPL', 'P'),
(155251, 'Filburns Island', 40.3694381713867, 0.704579613270977, -84.3441696166992, -1.47208346467196, 218, 41, 'PPL', 'P'),
(54754, 'Filer', 37.0297203063965, 0.646290540439222, -92.414436340332, -1.61293619051349, 218, 29, 'PPL', 'P'),
(194927, 'Filer', 42.5702781677246, 0.742991517516653, -114.606941223145, -2.00026846998349, 218, 17, 'PPL', 'P'),
(130790, 'Filer City', 44.2152786254883, 0.771702191701443, -86.2872161865234, -1.50599602483498, 218, 27, 'PPL', 'P'),
(161614, 'Filer Corners', 41.3038902282715, 0.72088887836565, -80.1263885498047, -1.39846929792638, 218, 45, 'PPL', 'P'),
(109191, 'Files Crossroad', 39.4566688537598, 0.688648783367205, -77.904167175293, -1.35968421823295, 218, 58, 'PPL', 'P'),
(94207, 'Files Valley', 32.2224998474121, 0.562388715560712, -97.0766677856445, -1.69430747972421, 218, 51, 'PPL', 'P'),
(161615, 'Filetown', 40.7730598449707, 0.711624140407428, -75.3008270263672, -1.31424736108484, 218, 45, 'PPL', 'P'),
(40906, 'Filhiol', 32.3416709899902, 0.564468644372064, -92.1083297729492, -1.60759362305068, 218, 22, 'PPL', 'P'),
(130794, 'Filion', 43.8955612182617, 0.7661220702694, -83.0036087036133, -1.44868626291507, 218, 27, 'PPL', 'P'),
(40907, 'Filipino (historical)', 29.5608291625977, 0.515933798506887, -89.8144378662109, -1.56755765659325, 218, 22, 'PPL', 'P'),
(32446, 'Filler', 37.3824996948242, 0.652447702300458, -94.8249969482422, -1.6550084099404, 218, 20, 'PPL', 'P'),
(54758, 'Filley', 37.7588882446289, 0.659016921761357, -93.9488906860352, -1.63971747106755, 218, 29, 'PPL', 'P'),
(141819, 'Filley', 40.2861099243164, 0.703125260999685, -96.5350036621094, -1.68485365732859, 218, 35, 'PPL', 'P'),
(27166, 'Fillmore', 39.1152801513672, 0.682690426481343, -89.2788925170898, -1.55821062695735, 218, 18, 'PPL', 'P'),
(29792, 'Fillmore', 39.6674995422363, 0.692328473045367, -86.7533264160156, -1.51413118301684, 218, 19, 'PPL', 'P'),
(35890, 'Fillmore', 37.6044387817383, 0.656321270105978, -83.5497207641602, -1.45821771645647, 218, 21, 'PPL', 'P'),
(40908, 'Fillmore', 32.5627784729004, 0.568327697949643, -93.5149993896484, -1.63214463934985, 218, 22, 'PPL', 'P'),
(64710, 'Fillmore', 35.7186088562012, 0.623407328772716, -78.0316696166992, -1.36190955563982, 218, 33, 'PPL', 'P'),
(72542, 'Fillmore', 39.3033294677734, 0.685972506208757, -81.7452774047852, -1.42672423866963, 218, 41, 'PPL', 'P'),
(75826, 'Fillmore', 34.274169921875, 0.598197113524726, -96.4958267211914, -1.68416989071871, 218, 42, 'PPL', 'P'),
(115567, 'Fillmore', 42.3191719055176, 0.738608886468764, -90.9166717529297, -1.58679526704355, 218, 16, 'PPL', 'P'),
(130792, 'Fillmore', 42.7211112976074, 0.745624052254197, -86.041389465332, -1.50170553916081, 218, 27, 'PPL', 'P'),
(135360, 'Fillmore', 43.7486114501953, 0.763557312981599, -92.2680587768555, -1.61038142007978, 218, 28, 'PPL', 'P'),
(139154, 'Fillmore', 40.0252799987793, 0.698572920011331, -94.9733276367188, -1.65759726883607, 218, 29, 'PPL', 'P'),
(140014, 'Fillmore', 48.1802787780762, 0.84090449920618, -99.8002777099609, -1.74184344044352, 218, 34, 'PPL', 'P'),
(148792, 'Fillmore', 42.4661102294922, 0.741173444019483, -78.1152801513672, -1.36336883475913, 218, 40, 'PPL', 'P'),
(161617, 'Fillmore', 40.4633293151855, 0.70621832286873, -79.3308334350586, -1.38458424179298, 218, 45, 'PPL', 'P'),
(174097, 'Fillmore', 43.4983291625977, 0.759189063003597, -88.0605621337891, -1.53694675039166, 218, 57, 'PPL', 'P'),
(177650, 'Fillmore', 34.399169921875, 0.600378775089719, -118.917221069336, -2.07549704498188, 218, 6, 'PPL', 'P'),
(192568, 'Fillmore', 38.9688911437988, 0.680135456310549, -112.322776794434, -1.96040228004555, 218, 52, 'PPL', 'P'),
(21085, 'Fillmore (historical)', 34.8127784729004, 0.607597606119515, -84.915283203125, -1.48205127715797, 218, 13, 'PPL', 'P'),
(27167, 'Fillmore (historical)', 39.7133293151855, 0.693128353478773, -88.3811111450195, -1.54254138605165, 218, 18, 'PPL', 'P'),
(190199, 'Fillmore (historical)', 39.811939239502, 0.694849421333236, -118.995002746582, -2.07685459134755, 218, 39, 'PPL', 'P'),
(148793, 'Fillmore Corner', 42.9911117553711, 0.750336449224065, -76.0180587768555, -1.3267654166307, 218, 40, 'PPL', 'P'),
(27169, 'Filson', 39.6894416809082, 0.692711435610121, -88.2319412231445, -1.53993787976999, 218, 18, 'PPL', 'P'),
(29793, 'Fincastle', 39.8080596923828, 0.694781710462521, -86.8949966430664, -1.51660379493093, 218, 19, 'PPL', 'P'),
(35892, 'Fincastle', 37.6452789306641, 0.657034065171738, -83.6488876342773, -1.45994850484891, 218, 21, 'PPL', 'P'),
(72543, 'Fincastle', 38.9916687011719, 0.68053299968227, -83.7147216796875, -1.46109752570122, 218, 41, 'PPL', 'P'),
(86973, 'Fincastle', 36.4097213745117, 0.635469517718985, -84.0477828979492, -1.4669105405706, 218, 50, 'PPL', 'P'),
(94209, 'Fincastle', 32.1291694641113, 0.560759793079965, -95.567497253418, -1.66796748496278, 218, 51, 'PPL', 'P'),
(101929, 'Fincastle', 37.4991683959961, 0.654483955269933, -79.8775024414063, -1.39412541587235, 218, 53, 'PPL', 'P'),
(8887, 'Finch', 36.0097198486328, 0.628488174079397, -90.6277770996094, -1.5817531041517, 218, 4, 'PPL', 'P'),
(109192, 'Finch', 39.3122215270996, 0.686127701921281, -81.0813903808594, -1.41513722424086, 218, 58, 'PPL', 'P'),
(196474, 'Finch', 46.2836112976074, 0.807801406856495, -106.975563049316, -1.86707579438536, 218, 31, 'PPL', 'P'),
(64711, 'Finch Mill', 35.7619400024414, 0.624163599943272, -77.996940612793, -1.36130342017572, 218, 33, 'PPL', 'P'),
(2444, 'Finchburg', 31.6424999237061, 0.552265807230725, -87.5108337402344, -1.52735217993243, 218, 2, 'PPL', 'P'),
(16014, 'Fincher', 30.6599998474121, 0.5351179459983, -83.9661102294922, -1.46548508359713, 218, 12, 'PPL', 'P'),
(21081, 'Fincher Farms', 33.4375, 0.583594468635604, -83.8652801513672, -1.46372526674881, 218, 13, 'PPL', 'P'),
(21082, 'Fincherville', 33.4091682434082, 0.583099986200204, -83.9533309936523, -1.46526204385584, 218, 13, 'PPL', 'P'),
(115569, 'Finchford', 42.6272201538086, 0.743985342656444, -92.5436096191406, -1.6151906895343, 218, 16, 'PPL', 'P'),
(101931, 'Finchley', 36.6522216796875, 0.639701946481393, -78.4925003051758, -1.36995256844797, 218, 53, 'PPL', 'P'),
(35893, 'Finchville', 38.1536102294922, 0.665906120027228, -85.3127822875977, -1.48898894495568, 218, 21, 'PPL', 'P'),
(47069, 'Finchville', 38.6319389343262, 0.674254530833381, -75.7713928222656, -1.32246028357053, 218, 25, 'PPL', 'P'),
(148794, 'Finchville', 41.4277801513672, 0.723051165433712, -74.5716705322266, -1.30152117949979, 218, 40, 'PPL', 'P'),
(199319, 'Finchville', 41.3711090087891, 0.722062067404857, -100.083061218262, -1.74677894373371, 218, 35, 'PPL', 'P'),
(145226, 'Finderne', 40.563060760498, 0.707958964957206, -74.5780563354492, -1.30163263279141, 218, 37, 'PPL', 'P'),
(21083, 'Findlay', 32.1538887023926, 0.561191225176558, -83.7716674804688, -1.46209141742004, 218, 13, 'PPL', 'P'),
(27170, 'Findlay', 39.5224990844727, 0.689797737640492, -88.7536087036133, -1.54904269490475, 218, 18, 'PPL', 'P'),
(86974, 'Findlay', 35.9577789306641, 0.627581634044334, -85.4797210693359, -1.49190257634628, 218, 50, 'PPL', 'P'),
(155252, 'Findlay', 41.0441703796387, 0.716355911874226, -83.6500015258789, -1.45996794592487, 218, 41, 'PPL', 'P'),
(115570, 'Findley', 41.5286102294922, 0.724810982282037, -95.8788909912109, -1.67340233095736, 218, 16, 'PPL', 'P'),
(130795, 'Findley', 41.8941688537598, 0.731191183884567, -85.3716735839844, -1.4900167919784, 218, 27, 'PPL', 'P'),
(109195, 'Findley (historical)', 38.9527816772461, 0.679854293078463, -79.9986114501953, -1.39623916682954, 218, 58, 'PPL', 'P'),
(148795, 'Findley Lake', 42.1191711425781, 0.73511821464897, -79.732780456543, -1.39159954073646, 218, 40, 'PPL', 'P'),
(196475, 'Findon (historical)', 46.6074981689453, 0.813454299165324, -110.348609924316, -1.92594656817821, 218, 31, 'PPL', 'P'),
(148796, 'Fine', 44.2477798461914, 0.77226944501363, -75.1380615234375, -1.31140656715005, 218, 40, 'PPL', 'P'),
(101932, 'Fine Creek Mills', 37.5977783203125, 0.656205023124396, -77.8194427490234, -1.35820549803769, 218, 53, 'PPL', 'P'),
(181575, 'Fine Gold', 37.1908302307129, 0.649102439076182, -119.617782592773, -2.08772415017866, 218, 6, 'PPL', 'P'),
(109193, 'Finegan Ford', 38.9838905334473, 0.680397245045703, -80.0527801513672, -1.39718458901652, 218, 58, 'PPL', 'P'),
(101933, 'Fines Corner', 38.3219413757324, 0.668844052762776, -77.3688888549805, -1.35034184912895, 218, 53, 'PPL', 'P'),
(64712, 'Fines Creek', 35.6811103820801, 0.622752856934829, -82.9516677856445, -1.44777972288001, 218, 33, 'PPL', 'P'),
(145227, 'Finesville', 40.6083297729492, 0.708749058273605, -75.17138671875, -1.31198820153212, 218, 37, 'PPL', 'P'),
(148798, 'Fineview', 44.2874984741211, 0.772962665845378, -76.0124969482422, -1.32666834440897, 218, 40, 'PPL', 'P'),
(54757, 'Finey', 38.2338905334473, 0.667307275655746, -93.5455627441406, -1.6326780705162, 218, 29, 'PPL', 'P'),
(140015, 'Fingal', 46.7605590820313, 0.816125716054783, -97.7900009155273, -1.70675749150422, 218, 34, 'PPL', 'P'),
(194928, 'Fingal', 42.9680595397949, 0.749934112162381, -112.808891296387, -1.96888657864632, 218, 17, 'PPL', 'P'),
(64714, 'Finger', 35.3847198486328, 0.617579866254432, -80.3580627441406, -1.40251277540944, 218, 33, 'PPL', 'P'),
(86975, 'Finger', 35.3583297729492, 0.617119272543903, -88.5988922119141, -1.54634238271746, 218, 50, 'PPL', 'P'),
(101934, 'Finger Lake Estates', 39.2347183227539, 0.684775015824603, -78.3927764892578, -1.36821205951755, 218, 53, 'PPL', 'P'),
(130796, 'Fingerboard Corner', 45.3736114501953, 0.791918913326507, -84.4502792358398, -1.47393542689401, 218, 27, 'PPL', 'P'),
(80994, 'Fingerville', 35.1338882446289, 0.613202028896505, -82.0066680908203, -1.43128636677499, 218, 48, 'PPL', 'P'),
(59902, 'Finis Hook (historical)', 32.9541702270508, 0.575158772724723, -89.1666717529297, -1.55625200513365, 218, 30, 'PPL', 'P'),
(94210, 'Fink', 33.8036117553711, 0.589984324197086, -96.6769409179688, -1.68733092977458, 218, 51, 'PPL', 'P'),
(109194, 'Fink', 39.1100006103516, 0.682598281107627, -80.6488876342773, -1.40758862728908, 218, 58, 'PPL', 'P'),
(186710, 'Fink', 38.4888916015625, 0.671757883890459, -105.380561828613, -1.83923777151076, 218, 7, 'PPL', 'P'),
(148799, 'Fink Basin', 43.0269393920898, 0.750961759448015, -74.8255615234375, -1.30595241323757, 218, 40, 'PPL', 'P'),
(59903, 'Fink Bine (historical)', 32.1480598449707, 0.561089492422917, -89.8791732788086, -1.56868750268572, 218, 30, 'PPL', 'P'),
(211828, 'Fink Creek', 65.8955612182617, 1.15009450570815, -163.018615722656, -2.84521158640375, 218, 1, 'PPL', 'P'),
(148800, 'Fink Hollow', 43.3525009155273, 0.756643879949808, -75.2794418334961, -1.31387411905806, 218, 40, 'PPL', 'P'),
(135364, 'Finkle', 46.8138885498047, 0.817056490855765, -96.746940612793, -1.68855265492466, 218, 28, 'PPL', 'P'),
(80995, 'Finklea', 34.0980606079102, 0.595123426152611, -78.9786071777344, -1.37843673389069, 218, 48, 'PPL', 'P'),
(47070, 'Finksburg', 39.4927787780762, 0.689279020439172, -76.8897171020508, -1.34197872435778, 218, 25, 'PPL', 'P'),
(80996, 'Finland', 33.3658294677734, 0.582343581871594, -81.0933303833008, -1.41534561659615, 218, 48, 'PPL', 'P'),
(135365, 'Finland', 47.4147186279297, 0.827542953964061, -91.248893737793, -1.59259363452692, 218, 28, 'PPL', 'P'),
(161621, 'Finland', 40.3841705322266, 0.704836741474224, -75.4197235107422, -1.31632249620623, 218, 45, 'PPL', 'P'),
(47071, 'Finlandia', 39.5833282470703, 0.690859406809052, -76.9011077880859, -1.34217752933315, 218, 25, 'PPL', 'P'),
(203969, 'Finlandia', 40.603889465332, 0.708671560285884, -111.808326721191, -1.95142343243035, 218, 52, 'PPL', 'P'),
(191459, 'Finlay', 31.2586097717285, 0.545565660112736, -105.629440307617, -1.84358152040673, 218, 51, 'PPL', 'P'),
(135366, 'Finlayson', 46.2016716003418, 0.806371289351122, -92.9158325195313, -1.62168720469744, 218, 28, 'PPL', 'P'),
(196476, 'Finlen', 46.038330078125, 0.803520441983219, -112.790283203125, -1.96856180615139, 218, 31, 'PPL', 'P'),
(2445, 'Finley', 33.059440612793, 0.576996087560769, -85.2830581665039, -1.48847016117533, 218, 2, 'PPL', 'P'),
(35894, 'Finley', 37.4613914489746, 0.653824623163056, -85.3394393920898, -1.48945419919812, 218, 21, 'PPL', 'P'),
(64716, 'Finley', 36.0741691589355, 0.629613026744819, -81.5919418334961, -1.42404802809021, 218, 33, 'PPL', 'P'),
(70814, 'Finley', 39.4772186279297, 0.689007444587011, -75.2024993896484, -1.31253122007839, 218, 37, 'PPL', 'P'),
(75824, 'Finley', 34.3283309936523, 0.59914240255365, -95.4947204589844, -1.66669729028087, 218, 42, 'PPL', 'P'),
(94211, 'Finley', 33.7461090087891, 0.588980711940289, -96.1858291625977, -1.67875941264811, 218, 51, 'PPL', 'P'),
(112558, 'Finley', 36.035831451416, 0.628943907520937, -89.4797210693359, -1.56171574642605, 218, 50, 'PPL', 'P'),
(140017, 'Finley', 47.5141716003418, 0.829278735783548, -97.835563659668, -1.70755271140572, 218, 34, 'PPL', 'P'),
(174100, 'Finley', 44.2133293151855, 0.771668169818517, -90.1361083984375, -1.57317186648725, 218, 57, 'PPL', 'P'),
(181576, 'Finley', 39.0044403076172, 0.68075590626551, -122.874443054199, -2.14456359785005, 218, 6, 'PPL', 'P'),
(207411, 'Finley', 46.1541709899902, 0.80554224730378, -119.032783508301, -2.07751399003346, 218, 56, 'PPL', 'P'),
(35896, 'Finley Addition', 37.8013916015625, 0.659758745282998, -87.6197204589844, -1.52925261168631, 218, 21, 'PPL', 'P'),
(2446, 'Finley Crossing', 31.961669921875, 0.557836374572358, -87.6858291625977, -1.53040642622859, 218, 2, 'PPL', 'P'),
(54759, 'Finley Falls', 37.1386108398438, 0.64819103877213, -92.8399963378906, -1.62036361363567, 218, 29, 'PPL', 'P'),
(193554, 'Finley Place', 40.2933311462402, 0.703251295098273, -121.791938781738, -2.1256703341287, 218, 6, 'PPL', 'P'),
(196477, 'Finley Point', 47.7380599975586, 0.833186325471994, -114.0625, -1.99076617805603, 218, 31, 'PPL', 'P'),
(21084, 'Finleyson', 32.1297187805176, 0.560769380459889, -83.5008316040039, -1.45736443964321, 218, 13, 'PPL', 'P'),
(161623, 'Finleyville', 40.2522201538086, 0.702533772921578, -80.003059387207, -1.39631679797532, 218, 45, 'PPL', 'P'),
(109196, 'Finlow (historical)', 37.9822196960449, 0.662914790911824, -81.0277786254883, -1.41420152259186, 218, 58, 'PPL', 'P'),
(196478, 'Finn', 46.7661094665527, 0.816222588539434, -112.702781677246, -1.96703461642428, 218, 31, 'PPL', 'P'),
(207412, 'Finn Hill', 47.7174987792969, 0.832827464515105, -122.226112365723, -2.13324809269442, 218, 56, 'PPL', 'P'),
(200819, 'Finn Rock', 44.1291694641113, 0.770199303319284, -122.38166809082, -2.1359630522677, 218, 43, 'PPL', 'P'),
(148802, 'Finnegans Corners', 41.3661117553711, 0.721974848879157, -74.3602828979492, -1.29783176928364, 218, 40, 'PPL', 'P'),
(35895, 'Finney', 36.9152793884277, 0.644293169621663, -86.1050033569336, -1.50281581101926, 218, 21, 'PPL', 'P'),
(72544, 'Finney', 39.1188888549805, 0.682753410241124, -84.7886123657227, -1.47984045397904, 218, 41, 'PPL', 'P'),
(161625, 'Finney', 40.1569404602051, 0.700870828557906, -80.3177795410156, -1.40180970088166, 218, 45, 'PPL', 'P'),
(191461, 'Finney', 34.2775001525879, 0.598255237015517, -101.715827941895, -1.77527609897811, 218, 51, 'PPL', 'P'),
(86976, 'Finney Patch', 35.8638916015625, 0.625942991025608, -83.1363906860352, -1.45100374569566, 218, 50, 'PPL', 'P'),
(72545, 'Finneytown', 39.2002792358398, 0.684173940366572, -84.5205612182617, -1.4751620788921, 218, 41, 'PPL', 'P'),
(27171, 'Finneyville', 37.5444412231445, 0.655274115165359, -88.1052780151367, -1.53772718974911, 218, 18, 'PPL', 'P'),
(101935, 'Finneywood', 36.8752784729004, 0.643595021941898, -78.4805603027344, -1.36974417609267, 218, 53, 'PPL', 'P'),
(196479, 'Finnicum Mobile Home Park', 48.1497192382813, 0.840371134618864, -104.522216796875, -1.82425682458879, 218, 31, 'PPL', 'P'),
(124834, 'Finnville', 42.1944389343262, 0.736431885435679, -70.8994369506836, -1.23742861259956, 218, 23, 'PPL', 'P'),
(109197, 'Finster', 38.938060760498, 0.679597364612298, -80.579719543457, -1.40638141636695, 218, 58, 'PPL', 'P'),
(148801, 'Fintches Corners', 43.2797203063965, 0.755373618688868, -76.6447219848633, -1.33770275291155, 218, 40, 'PPL', 'P'),
(161626, 'Finton', 40.7152786254883, 0.710615667881642, -78.5183334350586, -1.37040344162052, 218, 45, 'PPL', 'P'),
(47072, 'Finzel', 39.7144393920898, 0.693147727975703, -78.945556640625, -1.37785989319858, 218, 25, 'PPL', 'P'),
(21086, 'Fippin (historical)', 33.0952796936035, 0.577621597521802, -83.6961135864258, -1.46077275320629, 218, 13, 'PPL', 'P'),
(64717, 'Fipps Crossing', 34.2941703796387, 0.598546187364609, -78.8269424438477, -1.37578968492521, 218, 33, 'PPL', 'P'),
(186711, 'Fir', 37.485279083252, 0.654241541031708, -105.178886413574, -1.835717871498, 218, 7, 'PPL', 'P'),
(8888, 'Fir (historical)', 34.5875015258789, 0.60366578166515, -93.4388885498047, -1.63081625459812, 218, 4, 'PPL', 'P'),
(194929, 'Fir Grove', 47.8944396972656, 0.835915666115161, -116.909172058105, -2.0404499781945, 218, 17, 'PPL', 'P'),
(200820, 'Fir Grove', 44.1191711425781, 0.770024799688857, -123.136940002441, -2.14914503387332, 218, 43, 'PPL', 'P'),
(207413, 'Fir Tree', 46.9563903808594, 0.81954361699779, -122.781936645508, -2.14294905643919, 218, 56, 'PPL', 'P'),
(200821, 'Fir Villa', 44.9283294677734, 0.784147276633438, -123.273063659668, -2.15152083988178, 218, 43, 'PPL', 'P'),
(207414, 'Fircrest', 47.2397193908691, 0.824488641088877, -122.514717102051, -2.13828519558019, 218, 56, 'PPL', 'P'),
(207415, 'Firdale', 46.6241683959961, 0.813745249514415, -123.571113586426, -2.15672279243903, 218, 56, 'PPL', 'P'),
(109199, 'Fire Creek (historical)', 37.9583282470703, 0.662497806464145, -81.029167175293, -1.41422575735778, 218, 58, 'PPL', 'P'),
(148803, 'Fire Island', 40.6474990844727, 0.709432691725429, -73.1463928222656, -1.27664539070568, 218, 40, 'PPL', 'P'),
(148804, 'Fire Island Pines', 40.6652793884277, 0.70974301657145, -73.0686111450195, -1.27528784434001, 218, 40, 'PPL', 'P'),
(181577, 'Firebaugh', 36.8588905334473, 0.643308998440824, -120.455001831055, -2.1023363824477, 218, 6, 'PPL', 'P'),
(178182, 'Firebrand Ranch', 33.5766716003418, 0.586023471286838, -111.981391906738, -1.95444398973871, 218, 5, 'PPL', 'P'),
(35897, 'Firebrick', 38.6875, 0.675224254365306, -83.0472183227539, -1.44944739435462, 218, 21, 'PPL', 'P'),
(72546, 'Firebrick', 38.839168548584, 0.677871369909818, -82.6455612182617, -1.4424371554172, 218, 41, 'PPL', 'P'),
(181578, 'Firebrick', 38.3344383239746, 0.669062165656054, -120.924171447754, -2.11052493700942, 218, 6, 'PPL', 'P'),
(203970, 'Fireclay Plaza Condo', 40.6777801513672, 0.709961196043755, -111.89111328125, -1.95286833047977, 218, 52, 'PPL', 'P'),
(109198, 'Fireco', 37.644718170166, 0.657024278054732, -81.1983337402344, -1.41717827090029, 218, 58, 'PPL', 'P'),
(72547, 'Firemans Park', 39.9269409179688, 0.696856579267802, -82.4433288574219, -1.43890753486647, 218, 41, 'PPL', 'P'),
(148805, 'Fireplace', 41.0463905334473, 0.716394660868086, -72.1530609130859, -1.25930847832538, 218, 40, 'PPL', 'P'),
(148806, 'Fireplace Lodge Girls Camp', 41.0494384765625, 0.716447857510861, -72.1524963378906, -1.25929862462934, 218, 40, 'PPL', 'P'),
(64719, 'Fires Creek', 35.0769386291504, 0.612208070598661, -83.8641662597656, -1.46370582567285, 218, 33, 'PPL', 'P'),
(155254, 'Fireside', 41.226390838623, 0.719536258847998, -82.9119415283203, -1.44708636889021, 218, 41, 'PPL', 'P'),
(78266, 'Fireside Park', 39.9780616760254, 0.697748804812006, -76.7519378662109, -1.33957402305149, 218, 45, 'PPL', 'P'),
(78267, 'Fireside Terrace', 39.9822196960449, 0.69782137595171, -76.7411117553711, -1.33938507177215, 218, 45, 'PPL', 'P'),
(130797, 'Firesteel', 46.8663902282715, 0.817972818007834, -89.2183303833008, -1.55715361832069, 218, 27, 'PPL', 'P'),
(202124, 'Firesteel', 45.4247207641602, 0.792810939133629, -101.284721374512, -1.76775186995031, 218, 49, 'PPL', 'P'),
(194182, 'Firestone', 40.1124992370605, 0.70009518289042, -104.936111450195, -1.83148064904563, 218, 7, 'PPL', 'P'),
(155255, 'Firestone Park', 41.0349998474121, 0.716195855892712, -81.5163879394531, -1.42272936387645, 218, 41, 'PPL', 'P'),
(181579, 'Firestone Park', 33.9630584716797, 0.592767194378164, -118.231666564941, -2.06353186167832, 218, 6, 'PPL', 'P'),
(113432, 'Firetown', 41.9049987792969, 0.731380201742935, -72.8233337402344, -1.27100694604577, 218, 8, 'PPL', 'P'),
(124835, 'Fireworks', 42.1041717529297, 0.734856425913816, -70.8722229003906, -1.23695363781914, 218, 23, 'PPL', 'P'),
(207417, 'Firloch', 47.7033309936523, 0.832580190007892, -122.173332214355, -2.13232690527336, 218, 56, 'PPL', 'P'),
(54762, 'Firma', 38.8891716003418, 0.678744087799037, -90.6758270263672, -1.58259173357897, 218, 29, 'PPL', 'P'),
(35898, 'Firmantown', 38.0597190856934, 0.664267410429475, -84.6888885498047, -1.47809994504862, 218, 21, 'PPL', 'P'),
(177332, 'First Cliff', 42.1994400024414, 0.736519170540407, -70.716667175293, -1.23423867824586, 218, 23, 'PPL', 'P'),
(94212, 'First Colony', 29.5744400024414, 0.516171352476122, -95.6083297729492, -1.66868014687049, 218, 51, 'PPL', 'P'),
(101936, 'First Colony', 37.2383308410645, 0.649931481123524, -76.8027801513672, -1.34046138832671, 218, 53, 'PPL', 'P'),
(196480, 'First Creek (historical)', 47.8730583190918, 0.835542490667414, -107.877220153809, -1.88281267958274, 218, 31, 'PPL', 'P'),
(94214, 'First Crossing', 29.7649993896484, 0.519497241203468, -98.1413879394531, -1.71289035202051, 218, 51, 'PPL', 'P'),
(124837, 'First Encounter Beach', 41.8227806091309, 0.729945223968573, -70.0041732788086, -1.22180331385184, 218, 23, 'PPL', 'P'),
(101937, 'First Ford', 37.2663917541504, 0.65042123644799, -80.9633331298828, -1.41307673650546, 218, 53, 'PPL', 'P'),
(161627, 'First Fork', 41.4533309936523, 0.723497111758246, -78.0494384765625, -1.36221968074876, 218, 45, 'PPL', 'P'),
(178183, 'First Mesa', 35.836669921875, 0.625467883087138, -110.380828857422, -1.92650889464238, 218, 5, 'PPL', 'P'),
(186712, 'Firstview', 38.8158302307129, 0.67746403942109, -102.539169311523, -1.78964611674601, 218, 7, 'PPL', 'P'),
(141822, 'Firth', 40.5325012207031, 0.70742560036989, -96.605827331543, -1.68608976354855, 218, 35, 'PPL', 'P'),
(194931, 'Firth', 43.3052787780762, 0.755819698171456, -112.182220458984, -1.95794910920742, 218, 17, 'PPL', 'P'),
(148807, 'Firthcliffe', 41.4391708374023, 0.723249970409087, -74.0455627441406, -1.2923388663773, 218, 40, 'PPL', 'P'),
(148808, 'Firthcliffe Heights', 41.4483299255371, 0.723409826653519, -74.0577774047852, -1.29255205242256, 218, 40, 'PPL', 'P'),
(200822, 'Firwood', 45.377498626709, 0.791986757355277, -122.223609924316, -2.13320441685254, 218, 43, 'PPL', 'P'),
(207418, 'Firwood', 45.9313888549805, 0.801653965533237, -120.911666870117, -2.11030669095809, 218, 56, 'PPL', 'P'),
(78268, 'Fiscal', 39.7275009155273, 0.693375694565014, -76.7938919067383, -1.34030625919321, 218, 45, 'PPL', 'P'),
(17, 'Fischer', 29.9766693115234, 0.523191578267626, -98.2655563354492, -1.71505749935756, 218, 51, 'PPL', 'P'),
(47073, 'Fischer', 39.4594383239746, 0.68869711974099, -77.1202774047852, -1.34600276076489, 218, 25, 'PPL', 'P'),
(194930, 'Fischer', 43.6194381713867, 0.761302813960793, -116.582778930664, -2.03475334346476, 218, 17, 'PPL', 'P'),
(196481, 'Fischer Park', 47.7166709899902, 0.832813016866192, -104.144439697266, -1.81766337036197, 218, 31, 'PPL', 'P'),
(21087, 'Fischers Crossroad', 33.3963890075684, 0.582876946458909, -84.6166687011719, -1.47683947090468, 218, 13, 'PPL', 'P'),
(135369, 'Fischers Garden Mobile Park', 45.6063919067383, 0.795981698727478, -94.1922225952148, -1.6439644140579, 218, 28, 'PPL', 'P'),
(203971, 'Fischner Phillips Condominium', 40.6622200012207, 0.709689620191594, -111.870826721191, -1.95251426321284, 218, 52, 'PPL', 'P'),
(115571, 'Fiscus', 41.7388916015625, 0.728481084580275, -95.0927810668945, -1.65968212449544, 218, 16, 'PPL', 'P'),
(21088, 'Fish', 33.9986114501953, 0.593387710912152, -85.1408309936523, -1.48598782872327, 218, 13, 'PPL', 'P'),
(181580, 'Fish Camp', 37.4786109924316, 0.654125160892072, -119.639442443848, -2.08810218589539, 218, 6, 'PPL', 'P'),
(130798, 'Fish Corners', 42.2591705322266, 0.737561664949118, -86.3022232055664, -1.50625794672819, 218, 27, 'PPL', 'P'),
(16015, 'Fish Creek', 29.7861099243164, 0.51986568954028, -83.5722198486328, -1.4586103995592, 218, 12, 'PPL', 'P'),
(21090, 'Fish Creek', 34.0099983215332, 0.593586449308499, -85.1316680908203, -1.48582790589981, 218, 13, 'PPL', 'P'),
(40911, 'Fish Creek', 32.5366706848145, 0.56787203108713, -92.0911102294922, -1.60729308532167, 218, 22, 'PPL', 'P'),
(148810, 'Fish Creek', 42.061939239502, 0.734119329503109, -74.0133285522461, -1.29177627359702, 218, 40, 'PPL', 'P'),
(155256, 'Fish Creek', 41.1555595397949, 0.718300019469984, -81.4022216796875, -1.42073678674886, 218, 41, 'PPL', 'P'),
(174102, 'Fish Creek', 45.1277809143066, 0.787628361073308, -87.246940612793, -1.5227463759852, 218, 57, 'PPL', 'P'),
(178184, 'Fish Creek (historical)', 33.5333290100098, 0.585267000379201, -111.305557250977, -1.94264844979659, 218, 5, 'PPL', 'P'),
(148811, 'Fish Creek Landing', 43.2208290100098, 0.754345771666152, -75.7002792358398, -1.3212191173445, 218, 40, 'PPL', 'P'),
(148812, 'Fish Creek Station', 43.1961097717285, 0.753914339569559, -75.7133331298828, -1.32144695077576, 218, 40, 'PPL', 'P'),
(8890, 'Fish Dock (historical)', 34.0888900756836, 0.594963370171098, -91.4319381713867, -1.59578836257058, 218, 4, 'PPL', 'P'),
(194932, 'Fish Haven', 42.0369415283203, 0.733683037137527, -111.395561218262, -1.94421931536557, 218, 17, 'PPL', 'P'),
(16016, 'Fish Hawk', 27.8502807617188, 0.486079096896827, -82.2111129760742, -1.43485460316153, 218, 12, 'PPL', 'P'),
(13767, 'Fish Hook Mobile Home Court', 38.6430587768555, 0.674448608697821, -75.3302764892578, -1.31476135117522, 218, 10, 'PPL', 'P'),
(148813, 'Fish House', 43.1444396972656, 0.753012526645431, -74.1333312988281, -1.29387071663632, 218, 40, 'PPL', 'P'),
(40909, 'Fish Island', 29.9680595397949, 0.523041309403118, -91.5430603027344, -1.59772780963443, 218, 22, 'PPL', 'P'),
(122607, 'Fish Lake', 41.5666694641113, 0.72547524123693, -86.5519409179688, -1.51061634301016, 218, 19, 'PPL', 'P'),
(190200, 'Fish Lake (historical)', 37.871940612793, 0.660990057812996, -117.948608398438, -2.05859156469817, 218, 39, 'PPL', 'P'),
(196482, 'Fish Lake (historical)', 48.6791687011719, 0.849611770969221, -114.726387023926, -2.0023531924848, 218, 31, 'PPL', 'P'),
(2447, 'Fish Pond', 34.6425018310547, 0.604625718080069, -87.1405563354492, -1.52088962007319, 218, 2, 'PPL', 'P'),
(181581, 'Fish Rock', 38.8050003051758, 0.677275021562722, -123.584167480469, -2.15695062587028, 218, 6, 'PPL', 'P'),
(86977, 'Fish Springs', 36.3172187805176, 0.633855042887152, -82.0586090087891, -1.43219290681005, 218, 50, 'PPL', 'P'),
(181582, 'Fish Springs', 37.0750007629395, 0.647080833492703, -118.252777099609, -2.06390031001513, 218, 6, 'PPL', 'P'),
(207419, 'Fish Town', 48.3641700744629, 0.844114007793889, -122.469169616699, -2.1374902419948, 218, 56, 'PPL', 'P'),
(211830, 'Fish Village', 62.521110534668, 1.09119923083327, -163.843322753906, -2.85960543946341, 218, 1, 'PPL', 'P'),
(86978, 'Fishdam (historical)', 36.5277786254883, 0.637530005454379, -82.0458297729492, -1.43196986706876, 218, 50, 'PPL', 'P'),
(181583, 'Fishel', 34.3125, 0.598866099590554, -115.241386413574, -2.01134162747993, 218, 6, 'PPL', 'P'),
(8892, 'Fisher', 35.4913902282715, 0.619441615593479, -90.9741668701172, -1.58779874614229, 218, 4, 'PPL', 'P'),
(35899, 'Fisher', 37.5763893127441, 0.655831714518594, -86.3683319091797, -1.50741176127047, 218, 21, 'PPL', 'P'),
(40910, 'Fisher', 31.4936103820801, 0.549667194507567, -93.4655609130859, -1.63128177515667, 218, 22, 'PPL', 'P'),
(72548, 'Fisher', 39.2791709899902, 0.68555086122917, -82.1449966430664, -1.4337006554612, 218, 41, 'PPL', 'P'),
(75827, 'Fisher', 36.1291694641113, 0.630572963159738, -96.1419372558594, -1.67799335436055, 218, 42, 'PPL', 'P'),
(109201, 'Fisher', 39.0513916015625, 0.681575360932927, -79.0036087036133, -1.3788730928353, 218, 58, 'PPL', 'P'),
(119620, 'Fisher', 40.3147201538086, 0.703624603704075, -88.3499984741211, -1.54199836750538, 218, 18, 'PPL', 'P'),
(130799, 'Fisher', 41.8844413757324, 0.731021407365074, -84.883056640625, -1.48148881753574, 218, 27, 'PPL', 'P'),
(135371, 'Fisher', 47.8002815246582, 0.834272295985501, -96.8011093139648, -1.68949807711164, 218, 28, 'PPL', 'P'),
(161630, 'Fisher', 41.2663917541504, 0.720234406527763, -79.2427825927734, -1.38304746468595, 218, 45, 'PPL', 'P'),
(191462, 'Fisher', 32.7936096191406, 0.572356461467688, -100.389442443848, -1.75212630488648, 218, 51, 'PPL', 'P'),
(193556, 'Fisher', 40.9416694641113, 0.714566933411965, -124.117218017578, -2.16625411282237, 218, 6, 'PPL', 'P'),
(200823, 'Fisher', 44.2919387817383, 0.773040163833099, -123.838890075684, -2.16139637383601, 218, 43, 'PPL', 'P'),
(207420, 'Fisher', 45.5900001525879, 0.795695608647376, -122.502502441406, -2.13807200953493, 218, 56, 'PPL', 'P'),
(54763, 'Fisher (historical)', 39.5608291625977, 0.69046672370632, -93.6069412231445, -1.63374932706468, 218, 29, 'PPL', 'P'),
(109200, 'Fisher (historical)', 38.8802795410156, 0.678588892086512, -79.9749984741211, -1.39582704265085, 218, 58, 'PPL', 'P'),
(16017, 'Fisher Corner', 30.3813896179199, 0.530255280163925, -85.2152786254883, -1.48728718501912, 218, 12, 'PPL', 'P'),
(78270, 'Fisher Corners', 39.872501373291, 0.695906429969889, -75.4452819824219, -1.31676857568882, 218, 45, 'PPL', 'P'),
(64721, 'Fisher Creek', 35.4036102294922, 0.617909565597384, -83.1963882446289, -1.45205090063628, 218, 33, 'PPL', 'P'),
(86979, 'Fisher Creek', 36.5250015258789, 0.63748153592254, -82.9383316040039, -1.44754696260074, 218, 50, 'PPL', 'P'),
(2448, 'Fisher Crossroads', 34.4669418334961, 0.601561618087878, -85.6486129760742, -1.49485029619883, 218, 2, 'PPL', 'P'),
(170302, 'Fisher Estates', 45.5194396972656, 0.794464096380296, -98.5141677856445, -1.71939658772163, 218, 49, 'PPL', 'P'),
(161629, 'Fisher Heights', 40.9252815246582, 0.714280909910891, -79.9541702270508, -1.39546352116206, 218, 45, 'PPL', 'P'),
(80997, 'Fisher Hill', 34.6761093139648, 0.605212279310159, -79.9313888549805, -1.39506591121131, 218, 48, 'PPL', 'P'),
(101938, 'Fisher Hill', 39.0541687011719, 0.681623830464767, -77.9527816772461, -1.36053270135625, 218, 53, 'PPL', 'P'),
(109202, 'Fisher Hill', 39.0736083984375, 0.681963117187643, -80.4194412231445, -1.40358403195793, 218, 58, 'PPL', 'P'),
(16018, 'Fisher Island', 25.7605590820313, 0.449606573135973, -80.1402816772461, -1.39871177874363, 218, 12, 'PPL', 'P'),
(13768, 'Fisher Landing', 38.7125015258789, 0.675660613309916, -75.1755599975586, -1.31206103898794, 218, 10, 'PPL', 'P'),
(47074, 'Fisher Manor', 38.954719543457, 0.679888115224307, -76.1908264160156, -1.32978078077494, 218, 25, 'PPL', 'P'),
(13769, 'Fisher Mill Park', 38.6902809143066, 0.675272790476173, -75.5516662597656, -1.31862533160082, 218, 10, 'PPL', 'P'),
(64722, 'Fisher Park', 36.079719543457, 0.629709899229471, -79.790283203125, -1.39260315299326, 218, 33, 'PPL', 'P'),
(181584, 'Fisher Place', 38.235279083252, 0.667331510421666, -120.449722290039, -2.10224423707399, 218, 6, 'PPL', 'P'),
(203972, 'Fisher Place', 40.6399993896484, 0.709301797357851, -111.882217407227, -1.95271306818822, 218, 52, 'PPL', 'P'),
(64723, 'Fisher Town', 35.4947204589844, 0.61949973908427, -80.6638870239258, -1.40785041602423, 218, 33, 'PPL', 'P'),
(161631, 'Fisherdale', 40.8541717529297, 0.713039810263886, -76.4444427490234, -1.33420722082276, 218, 45, 'PPL', 'P'),
(124838, 'Fishermans Landing', 41.9061088562012, 0.731399576239865, -70.5472183227539, -1.23128123785533, 218, 23, 'PPL', 'P'),
(161632, 'Fishermans Paradise', 40.8805618286133, 0.713500403974416, -77.7930603027344, -1.35774503748521, 218, 45, 'PPL', 'P'),
(13770, 'Fishermans Park Mobile Home Park', 38.6269416809082, 0.674167312307681, -75.1066665649414, -1.31085862175577, 218, 10, 'PPL', 'P'),
(2449, 'Fishermans Resort', 34.7841682434082, 0.607098263415126, -87.3938903808594, -1.525311133273, 218, 2, 'PPL', 'P'),
(16019, 'Fishermens Village', 26.9283294677734, 0.469988011274459, -82.0616683959961, -1.43224630318991, 218, 12, 'PPL', 'P'),
(29796, 'Fishers', 39.9555587768555, 0.697356055130246, -86.0138931274414, -1.50122563753238, 218, 19, 'PPL', 'P'),
(148814, 'Fishers', 43.0086097717285, 0.750641847222069, -77.4649963378906, -1.35201924114154, 218, 40, 'PPL', 'P'),
(21091, 'Fishers Bank', 33.389720916748, 0.582760566319273, -84.5663909912109, -1.4759619593255, 218, 13, 'PPL', 'P'),
(200824, 'Fishers Corner', 45.2905616760254, 0.790469421324204, -122.563331604004, -2.13913367870349, 218, 43, 'PPL', 'P'),
(109203, 'Fishers Crossing', 38.649169921875, 0.674555268299478, -80.482780456543, -1.40468951012642, 218, 58, 'PPL', 'P'),
(161634, 'Fishers Ferry', 40.7691688537598, 0.711556229799631, -76.8450012207031, -1.34119828500033, 218, 45, 'PPL', 'P'),
(47075, 'Fishers Hollow', 39.5074996948242, 0.689535948905338, -77.5133285522461, -1.35286279741682, 218, 25, 'PPL', 'P'),
(148815, 'Fishers Island', 41.2569389343262, 0.720069423698232, -72.0244369506836, -1.25706356668449, 218, 40, 'PPL', 'P'),
(124839, 'Fishers Landing', 41.2936096191406, 0.720709447887206, -70.1797180175781, -1.22486714752793, 218, 23, 'PPL', 'P'),
(148816, 'Fishers Landing', 44.2763900756836, 0.77276878771802, -76.0083312988281, -1.32659564011121, 218, 40, 'PPL', 'P'),
(178185, 'Fishers Landing', 32.9727783203125, 0.575483545219659, -114.462783813477, -1.99775244854364, 218, 5, 'PPL', 'P'),
(122608, 'Fishersburg', 40.0719413757324, 0.699387314672677, -85.8594436645508, -1.498529985877, 218, 19, 'PPL', 'P'),
(101939, 'Fishersville', 38.0988883972168, 0.664951043881298, -78.9694366455078, -1.37827667790918, 218, 53, 'PPL', 'P'),
(155257, 'Fishersville', 40.3505592346191, 0.704250113665107, -80.6255569458008, -1.40718142995841, 218, 41, 'PPL', 'P'),
(161636, 'Fishertown', 40.351390838623, 0.704264627893048, -78.7738876342773, -1.37486370381419, 218, 45, 'PPL', 'P'),
(29797, 'Fisherville', 38.0852813720703, 0.664713556491091, -87.4330596923828, -1.52599476672482, 218, 19, 'PPL', 'P'),
(35900, 'Fisherville', 38.1897201538086, 0.666536357099195, -85.4630584716797, -1.49161175915524, 218, 21, 'PPL', 'P'),
(40912, 'Fisherville', 31.3352794647217, 0.54690379869196, -93.1408309936523, -1.62561416888282, 218, 22, 'PPL', 'P'),
(86980, 'Fisherville', 35.1591682434082, 0.613643248110104, -89.6636123657227, -1.56492525501376, 218, 50, 'PPL', 'P'),
(124840, 'Fisherville', 42.1749992370605, 0.736092598712803, -71.6930618286133, -1.25127997974517, 218, 23, 'PPL', 'P'),
(130800, 'Fisherville', 43.6041717529297, 0.76103636469373, -84.10888671875, -1.46797700342912, 218, 27, 'PPL', 'P'),
(148817, 'Fisherville', 42.1563911437988, 0.735767826217868, -76.8691711425781, -1.341620129717, 218, 40, 'PPL', 'P'),
(161638, 'Fisherville', 40.5011100769043, 0.706877721554634, -76.8841705322266, -1.34188191845215, 218, 45, 'PPL', 'P'),
(169373, 'Fisherville', 41.5647201538086, 0.725441219354004, -71.5627822875977, -1.24900617280646, 218, 47, 'PPL', 'P'),
(174103, 'Fisherville', 44.2405586242676, 0.772143410915042, -87.6800003051758, -1.53030469347495, 218, 57, 'PPL', 'P'),
(200825, 'Fishhawk (historical)', 46.0055618286133, 0.802948528139125, -123.334716796875, -2.15259689012022, 218, 43, 'PPL', 'P'),
(27172, 'Fishhook', 39.8055610656738, 0.694738101199671, -90.8852767944336, -1.58624732164926, 218, 18, 'PPL', 'P'),
(47076, 'Fishing Creek', 38.3222198486328, 0.668848913031766, -76.2247161865234, -1.33037226885305, 218, 25, 'PPL', 'P'),
(64724, 'Fishing Creek', 36.1324996948242, 0.630631086650529, -81.0658264160156, -1.41486558180967, 218, 33, 'PPL', 'P'),
(70815, 'Fishing Creek', 39.0227813720703, 0.681076018228537, -74.9341735839844, -1.30784805130149, 218, 37, 'PPL', 'P'),
(47077, 'Fishing Creek Farms', 38.9252815246582, 0.679374324871004, -76.477783203125, -1.33478912152095, 218, 25, 'PPL', 'P'),
(148818, 'Fishkill', 41.5355606079102, 0.72493228926969, -73.8994369506836, -1.28978849015939, 218, 40, 'PPL', 'P'),
(148819, 'Fishkill Landing (historical)', 41.5208282470703, 0.724675161066443, -73.9833297729492, -1.29125269612671, 218, 40, 'PPL', 'P'),
(148820, 'Fishkill Plains', 41.6069412231445, 0.726178116027629, -73.8308334350586, -1.28859113293329, 218, 40, 'PPL', 'P'),
(192569, 'Fishlake Resort', 38.5475006103516, 0.672780804065159, -111.723609924316, -1.94994484539313, 218, 52, 'PPL', 'P'),
(2450, 'Fishpond', 32.8677787780762, 0.573650957494548, -86.0233306884766, -1.5013903540458, 218, 2, 'PPL', 'P'),
(148822, 'Fishs Eddy', 41.9636116027832, 0.732403188496662, -75.1752777099609, -1.31205611213992, 218, 40, 'PPL', 'P'),
(196483, 'Fishtail', 45.4536094665527, 0.793315142107009, -109.503608703613, -1.91119851469357, 218, 31, 'PPL', 'P'),
(29798, 'Fishtown', 38.0694389343262, 0.664437053790913, -85.9175033569336, -1.49954331867177, 218, 19, 'PPL', 'P'),
(47078, 'Fishtown', 39.3861083984375, 0.687417271100125, -76.7361068725586, -1.3392977200884, 218, 25, 'PPL', 'P'),
(2451, 'Fishtrap', 33.4902801513672, 0.584515656056662, -86.2405624389648, -1.50518176333169, 218, 2, 'PPL', 'P'),
(196484, 'Fishtrap', 45.8722190856934, 0.800621258241532, -113.228607177734, -1.97621200269875, 218, 31, 'PPL', 'P'),
(207421, 'Fishtrap', 47.3886108398438, 0.827087287101549, -117.829719543457, -2.05651656273484, 218, 56, 'PPL', 'P'),
(40915, 'Fishville', 31.521390914917, 0.550152056273529, -92.3619384765625, -1.61201992994045, 218, 22, 'PPL', 'P'),
(2452, 'Fisk', 34.9613914489746, 0.610191391863198, -86.5733337402344, -1.51098971819499, 218, 2, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(54766, 'Fisk', 36.7819404602051, 0.641965966303097, -90.208610534668, -1.5744372674792, 218, 29, 'PPL', 'P'),
(94215, 'Fisk', 31.6708297729492, 0.552760256376612, -99.4888916015625, -1.736408727607, 218, 51, 'PPL', 'P'),
(115573, 'Fisk', 41.2011108398438, 0.7190950396344, -94.5277786254883, -1.64982097161109, 218, 16, 'PPL', 'P'),
(174104, 'Fisk', 43.9558296203613, 0.767173952320954, -88.6780624389648, -1.54772416384905, 218, 57, 'PPL', 'P'),
(94217, 'Fisk Crossing', 31.5938892364502, 0.551417390686453, -98.8216705322266, -1.72476352310841, 218, 51, 'PPL', 'P'),
(161640, 'Fisk Mill', 41.8902816772461, 0.731123339855797, -75.8936080932617, -1.32459334244563, 218, 45, 'PPL', 'P'),
(35901, 'Fiskburg', 38.8105583190918, 0.677372027205428, -84.5069427490234, -1.47492439176481, 218, 21, 'PPL', 'P'),
(124841, 'Fiskdale', 42.1161117553711, 0.735064818269114, -72.1138916015625, -1.25862484487355, 218, 23, 'PPL', 'P'),
(40913, 'Fiske', 32.8866691589355, 0.5739806568375, -91.4922180175781, -1.59684044435922, 218, 22, 'PPL', 'P'),
(161641, 'Fiske', 40.6761093139648, 0.709932034429818, -78.5055618286133, -1.37018053503728, 218, 45, 'PPL', 'P'),
(169374, 'Fiskeville', 41.7341690063477, 0.728398659744537, -71.5486068725586, -1.24875876514119, 218, 47, 'PPL', 'P'),
(122609, 'Fiskville', 40.0486106872559, 0.698980117342004, -86.8947219848633, -1.51659900124097, 218, 19, 'PPL', 'P'),
(35902, 'Fisty', 37.3338890075684, 0.651599285756186, -83.1016693115234, -1.45039774338961, 218, 21, 'PPL', 'P'),
(35903, 'Fitch', 38.3199996948242, 0.668810164037905, -83.3375015258789, -1.45451379201239, 218, 21, 'PPL', 'P'),
(64726, 'Fitch', 36.3236083984375, 0.633966562757799, -79.3619384765625, -1.38512712718119, 218, 33, 'PPL', 'P'),
(148823, 'Fitch', 42.2627792358398, 0.737624648708898, -78.4377822875977, -1.36899755888107, 218, 40, 'PPL', 'P'),
(155259, 'Fitch', 41.0905609130859, 0.717165579424637, -80.5449981689453, -1.4057754140609, 218, 41, 'PPL', 'P'),
(59905, 'Fitch (historical)', 34.0308303833008, 0.593950037376323, -90.4563903808594, -1.57876184161532, 218, 30, 'PPL', 'P'),
(113433, 'Fitch Corner', 41.454719543457, 0.723521346524166, -72.1061096191406, -1.25848902365796, 218, 8, 'PPL', 'P'),
(148824, 'Fitch Point', 43.1500015258789, 0.753109598867164, -73.3802795410156, -1.28072748402456, 218, 40, 'PPL', 'P'),
(35904, 'Fitchburg', 37.7324981689453, 0.658556328050827, -83.851936340332, -1.46349237331148, 218, 21, 'PPL', 'P'),
(124842, 'Fitchburg', 42.5833282470703, 0.743219284368882, -71.8027801513672, -1.25319492572699, 218, 23, 'PPL', 'P'),
(130801, 'Fitchburg', 42.4391708374023, 0.74070326292903, -84.2777786254883, -1.47092472328167, 218, 27, 'PPL', 'P'),
(174109, 'Fitchburg', 42.9608306884766, 0.749807944905738, -89.4697189331055, -1.5615411762166, 218, 57, 'PPL', 'P'),
(101941, 'Fitchetts', 37.4588890075684, 0.653780947321179, -76.290283203125, -1.33151662917346, 218, 53, 'PPL', 'P'),
(119625, 'Fitchmoor', 41.4619407653809, 0.723647380622754, -89.1650009155273, -1.55622284351971, 218, 18, 'PPL', 'P'),
(113434, 'Fitchville', 41.5647201538086, 0.725441219354004, -72.1544418334961, -1.25933257993324, 218, 8, 'PPL', 'P'),
(155260, 'Fitchville', 41.0947189331055, 0.717238150564342, -82.4886093139648, -1.43969782791995, 218, 41, 'PPL', 'P'),
(75828, 'Fite', 36.723331451416, 0.640943046128397, -96.0791702270508, -1.67689786304614, 218, 42, 'PPL', 'P'),
(161642, 'Fite Station', 40.3713912963867, 0.70461370173293, -79.8266677856445, -1.39323818375519, 218, 45, 'PPL', 'P'),
(2453, 'Fitee', 31.5438899993896, 0.550544739376261, -88.3494415283203, -1.5419886469674, 218, 2, 'PPL', 'P'),
(119621, 'Fithian', 40.1138916015625, 0.700119484235367, -87.8730621337891, -1.53367425804417, 218, 18, 'PPL', 'P'),
(70816, 'Fithians Corner', 39.4269409179688, 0.68812993300783, -75.2919387817383, -1.31409223195134, 218, 37, 'PPL', 'P'),
(59906, 'Fitler', 32.7252807617188, 0.57116389793155, -91.0336074829102, -1.58883618054493, 218, 30, 'PPL', 'P'),
(161643, 'Fitler', 40.0091705322266, 0.698291756779246, -75.0591735839844, -1.31002971286648, 218, 45, 'PPL', 'P'),
(199955, 'Fitting', 40.3363914489746, 0.704002839157893, -118.10417175293, -2.06130665742951, 218, 39, 'PPL', 'P'),
(148838, 'Fitts Corners', 42.5636100769043, 0.742875137377017, -76.3236083984375, -1.33209826355553, 218, 40, 'PPL', 'P'),
(75829, 'Fittstown', 34.6147193908691, 0.604140823024592, -96.6341705322266, -1.68658444572103, 218, 42, 'PPL', 'P'),
(161644, 'Fitz Henry', 40.167781829834, 0.701060046153356, -79.7561111450195, -1.39200673806714, 218, 45, 'PPL', 'P'),
(94216, 'Fitze', 31.7855606079102, 0.554762687200243, -94.5341720581055, -1.64993255806076, 218, 51, 'PPL', 'P'),
(619, 'Fitzell', 39.2333297729492, 0.684750781058683, -76.4638900756836, -1.33454664070369, 218, 25, 'PPL', 'P'),
(47079, 'Fitzell (historical)', 39.2311096191406, 0.684712032064823, -76.4652786254883, -1.33457087546961, 218, 25, 'PPL', 'P'),
(8893, 'Fitzgerald', 35.6525001525879, 0.622253514230439, -91.2886123657227, -1.59328685535867, 218, 4, 'PPL', 'P'),
(21092, 'Fitzgerald', 31.7147197723389, 0.55352628137466, -83.2527770996094, -1.45303507181712, 218, 13, 'PPL', 'P'),
(64744, 'Fitzgerald', 36.5330581665039, 0.637622150828096, -79.6733322143555, -1.39056197317577, 218, 33, 'PPL', 'P'),
(174106, 'Fitzgerald', 43.9822196960449, 0.767634546031484, -88.6211090087891, -1.54673013897218, 218, 57, 'PPL', 'P'),
(40914, 'Fitzgerald (historical)', 31.108060836792, 0.542938085512723, -92.5083312988281, -1.61457496669027, 218, 22, 'PPL', 'P'),
(8894, 'Fitzgerald Crossing', 35.1786117553711, 0.613982601412008, -90.8033294677734, -1.58481707098584, 218, 4, 'PPL', 'P'),
(2455, 'Fitzgerald Estates', 33.702220916748, 0.588214720231755, -86.6766662597656, -1.51279321088519, 218, 2, 'PPL', 'P'),
(27173, 'Fitzgerrell (historical)', 38.1380615234375, 0.665634743912149, -89.0141677856445, -1.55359030878217, 218, 18, 'PPL', 'P'),
(8895, 'Fitzhugh', 35.3580589294434, 0.617114545432968, -91.3227767944336, -1.59388313712674, 218, 4, 'PPL', 'P'),
(59907, 'Fitzhugh', 33.8883285522461, 0.591462911234298, -90.5086135864258, -1.5796733084984, 218, 30, 'PPL', 'P'),
(75830, 'Fitzhugh', 34.665828704834, 0.605032848831715, -96.7747192382813, -1.68903748340111, 218, 42, 'PPL', 'P'),
(94218, 'Fitzhugh', 30.2450008392334, 0.527874846913071, -98.0269393920898, -1.7108928480449, 218, 51, 'PPL', 'P'),
(101940, 'Fitzhugh', 36.6655616760254, 0.639934773339694, -77.7644424438477, -1.35724556162277, 218, 53, 'PPL', 'P'),
(2456, 'Fitzpatrick', 32.2163887023926, 0.562282055959054, -85.8888931274414, -1.49904397596738, 218, 2, 'PPL', 'P'),
(21093, 'Fitzpatrick', 32.7486114501953, 0.571571095262223, -83.4375, -1.45625909463277, 218, 13, 'PPL', 'P'),
(109204, 'Fitzpatrick', 37.7438888549805, 0.658755133026202, -81.1866683959961, -1.41697467223496, 218, 58, 'PPL', 'P'),
(193557, 'Fitzpatrick (historical)', 40.7077789306641, 0.710484773514064, -122.144996643066, -2.13183235625893, 218, 6, 'PPL', 'P'),
(161676, 'Fitzwatertown', 40.124439239502, 0.700303575245719, -75.1600036621094, -1.3117895297148, 218, 45, 'PPL', 'P'),
(143826, 'Fitzwilliam', 42.7805595397949, 0.746661619814892, -72.142219543457, -1.25911926072993, 218, 36, 'PPL', 'P'),
(143827, 'Fitzwilliam Depot', 42.764720916748, 0.746385183693741, -72.1513900756836, -1.25927931671144, 218, 36, 'PPL', 'P'),
(16020, 'Fivay Junction', 28.3236103057861, 0.494340255887766, -82.5186080932617, -1.44022140539026, 218, 12, 'PPL', 'P'),
(21094, 'Five Acres Estates', 34.1288909912109, 0.595661517850862, -84.2719421386719, -1.47082285736998, 218, 13, 'PPL', 'P'),
(109209, 'Five Block', 37.8950004577637, 0.661392528032734, -81.8241729736328, -1.42810122611125, 218, 58, 'PPL', 'P'),
(181585, 'Five Brooks', 38.0011100769043, 0.663244490254776, -122.75666809082, -2.14250803696268, 218, 6, 'PPL', 'P'),
(148825, 'Five Chimneys Corner', 43.0333290100098, 0.751073279318662, -75.6194381713867, -1.31980817459898, 218, 40, 'PPL', 'P'),
(124847, 'Five Corners', 42.4436111450195, 0.740780760916751, -71.6666717529297, -1.25081938603464, 218, 23, 'PPL', 'P'),
(127483, 'Five Corners', 43.3280601501465, 0.756217308122205, -70.7658309936523, -1.23509674874908, 218, 26, 'PPL', 'P'),
(130802, 'Five Corners', 44.6369400024414, 0.779061571057768, -84.5283279418945, -1.47529763379158, 218, 27, 'PPL', 'P'),
(135374, 'Five Corners', 46.8077812194824, 0.816949897833135, -92.2797164916992, -1.61058488558706, 218, 28, 'PPL', 'P'),
(143830, 'Five Corners', 42.9386100769043, 0.749420122071996, -70.9252777099609, -1.23787961893016, 218, 36, 'PPL', 'P'),
(148832, 'Five Corners', 43.2627792358398, 0.755077941228842, -78.1930618286133, -1.3647263811248, 218, 40, 'PPL', 'P'),
(155265, 'Five Corners', 40.7791709899902, 0.711730800009085, -82.6522216796875, -1.44255340239878, 218, 41, 'PPL', 'P'),
(161645, 'Five Corners', 41.7033309936523, 0.727860434888232, -79.7472229003906, -1.39185160893364, 218, 45, 'PPL', 'P'),
(174108, 'Five Corners', 44.8111114501953, 0.782101436284039, -89.0425033569336, -1.55408485779659, 218, 57, 'PPL', 'P'),
(181586, 'Five Corners', 37.8269386291504, 0.660204625028505, -121.143058776855, -2.11434524159314, 218, 6, 'PPL', 'P'),
(194933, 'Five Corners', 46.6399993896484, 0.814021552477511, -116.172218322754, -2.02758770907774, 218, 17, 'PPL', 'P'),
(200826, 'Five Corners', 42.1863899230957, 0.736291403688177, -120.433059692383, -2.10195341988295, 218, 43, 'PPL', 'P'),
(207425, 'Five Corners', 46.9330596923828, 0.819136419667117, -122.588333129883, -2.1395700376481, 218, 56, 'PPL', 'P'),
(2457, 'Five Forks', 34.3697204589844, 0.599864784999334, -86.0758285522461, -1.50230661461884, 218, 2, 'PPL', 'P'),
(21097, 'Five Forks', 30.8772201538086, 0.53890915554711, -83.7983322143555, -1.46255680482053, 218, 13, 'PPL', 'P'),
(35905, 'Five Forks', 38.1286087036133, 0.665469761082618, -82.6561126708984, -1.44262131300658, 218, 21, 'PPL', 'P'),
(40917, 'Five Forks', 31.8113899230957, 0.555213493793766, -92.6958312988281, -1.61784745903776, 218, 22, 'PPL', 'P'),
(47085, 'Five Forks', 39.6788902282715, 0.692527278020742, -76.658332824707, -1.33794030688078, 218, 25, 'PPL', 'P'),
(64731, 'Five Forks', 36.2286109924316, 0.632308545242143, -80.5944366455078, -1.40663827825409, 218, 33, 'PPL', 'P'),
(78273, 'Five Forks', 39.8013916015625, 0.694665330322885, -77.60888671875, -1.35453060204949, 218, 45, 'PPL', 'P'),
(81003, 'Five Forks', 34.7661094665527, 0.606783078300115, -82.6561126708984, -1.44262131300658, 218, 48, 'PPL', 'P'),
(86982, 'Five Forks', 35.3877792358398, 0.617633262634288, -88.2441711425781, -1.54015133213135, 218, 50, 'PPL', 'P'),
(101960, 'Five Forks', 37.5180587768555, 0.654813654612884, -79.1211090087891, -1.38092386003272, 218, 53, 'PPL', 'P'),
(109208, 'Five Forks', 39.0061111450195, 0.680785067879446, -80.0999984741211, -1.39800870421585, 218, 58, 'PPL', 'P'),
(155267, 'Five Forks', 40.0080604553223, 0.698272382282315, -81.6013870239258, -1.42421287776168, 218, 41, 'PPL', 'P'),
(101956, 'Five Forks (historical)', 37.3255615234375, 0.651453943739695, -77.9894409179688, -1.36117252580814, 218, 53, 'PPL', 'P'),
(47082, 'Five Forks Estates', 39.5541687011719, 0.690350476724738, -77.501106262207, -1.35264947821351, 218, 25, 'PPL', 'P'),
(119622, 'Five Island Park', 41.9716682434082, 0.732543803402218, -88.3097229003906, -1.54129542613565, 218, 18, 'PPL', 'P'),
(127484, 'Five Islands', 43.8238906860352, 0.76487118350539, -69.711669921875, -1.21669816720022, 218, 26, 'PPL', 'P'),
(130803, 'Five Lakes', 43.1427803039551, 0.752983564768576, -83.2319412231445, -1.45267141717027, 218, 27, 'PPL', 'P'),
(161646, 'Five Locks', 40.5261116027832, 0.707314080499243, -75.9863891601563, -1.32621267754646, 218, 45, 'PPL', 'P'),
(75833, 'Five Mile', 36.9833297729492, 0.645480872888811, -94.6927795410156, -1.65270078085585, 218, 42, 'PPL', 'P'),
(127485, 'Five Mile Corners', 44.5588912963867, 0.777699364160193, -68.7030563354492, -1.19909453923674, 218, 26, 'PPL', 'P'),
(101957, 'Five Mile Fork', 38.2900009155273, 0.668286586567595, -77.5536117553711, -1.3535658719446, 218, 53, 'PPL', 'P'),
(190205, 'Five Mile House (historical)', 39.3663902282715, 0.687073124108259, -119.665557861328, -2.08855798591596, 218, 39, 'PPL', 'P'),
(181587, 'Five Mile Terrace', 38.7383308410645, 0.676111419903439, -120.711936950684, -2.10682074624923, 218, 6, 'PPL', 'P'),
(21098, 'Five Notch Acres', 33.648609161377, 0.587279018582756, -84.7324981689453, -1.47886107648816, 218, 13, 'PPL', 'P'),
(81004, 'Five Oaks', 35.1713905334473, 0.61385656731342, -82.1680603027344, -1.43410319225996, 218, 48, 'PPL', 'P'),
(101958, 'Five Oaks', 37.1494407653809, 0.648380056630498, -81.4888916015625, -1.42224946224802, 218, 53, 'PPL', 'P'),
(155268, 'Five Point Mobile Home Court', 41.5063896179199, 0.724423159448294, -83.5933303833008, -1.45897884789601, 218, 41, 'PPL', 'P'),
(2473, 'Five Points', 33.8883285522461, 0.591462911234298, -87.283332824707, -1.52338153990518, 218, 2, 'PPL', 'P'),
(13771, 'Five Points', 38.7486114501953, 0.676290850381883, -75.1736068725586, -1.31202695052598, 218, 10, 'PPL', 'P'),
(16022, 'Five Points', 30.7127799987793, 0.536039133419359, -85.7513885498047, -1.49664406835106, 218, 12, 'PPL', 'P'),
(21120, 'Five Points', 34.2411117553711, 0.597620139674561, -83.3905563354492, -1.45543977312341, 218, 13, 'PPL', 'P'),
(32448, 'Five Points', 39.230281829834, 0.684697584415909, -95.0311126708984, -1.65860580794088, 218, 20, 'PPL', 'P'),
(35907, 'Five Points', 36.6166687011719, 0.639081429947405, -88.3291702270508, -1.54163484601658, 218, 21, 'PPL', 'P'),
(64742, 'Five Points', 35.5958290100098, 0.621264416201584, -78.7591705322266, -1.37460684192705, 218, 33, 'PPL', 'P'),
(81006, 'Five Points', 35.0916709899902, 0.612465198801908, -81.0983276367188, -1.41543283512185, 218, 48, 'PPL', 'P'),
(86986, 'Five Points', 35.4447212219238, 0.618627087774078, -85.0175018310547, -1.48383532877221, 218, 50, 'PPL', 'P'),
(94220, 'Five Points', 27.8555603027344, 0.486171242270543, -97.6294403076172, -1.70395518024719, 218, 51, 'PPL', 'P'),
(113436, 'Five Points', 41.9955596923828, 0.732960787849897, -72.7958297729492, -1.27052691125928, 218, 8, 'PPL', 'P'),
(115574, 'Five Points', 42.5513916015625, 0.742661884752729, -90.8583297729492, -1.58577700740076, 218, 16, 'PPL', 'P'),
(119623, 'Five Points', 42.002498626709, 0.733081895100469, -88.7402801513672, -1.54881006778353, 218, 18, 'PPL', 'P'),
(122613, 'Five Points', 41.1927795410156, 0.718949631038881, -85.4916687011719, -1.49211110185963, 218, 19, 'PPL', 'P'),
(127486, 'Five Points', 43.4830589294434, 0.758922547157507, -70.4711074829102, -1.2299528531036, 218, 26, 'PPL', 'P'),
(130805, 'Five Points', 42.9977798461914, 0.750452829363701, -84.225830078125, -1.47001805008855, 218, 27, 'PPL', 'P'),
(135375, 'Five Points', 45.607780456543, 0.796005933493397, -94.2608337402344, -1.64516190444205, 218, 28, 'PPL', 'P'),
(145228, 'Five Points', 41.086109161377, 0.717087881699834, -74.8580627441406, -1.30651966654976, 218, 37, 'PPL', 'P'),
(148837, 'Five Points', 42.6786117553711, 0.744882295311582, -74.8130569458008, -1.30573416718624, 218, 40, 'PPL', 'P'),
(155275, 'Five Points', 40.8736114501953, 0.713379096986763, -81.8424987792969, -1.42842107175817, 218, 41, 'PPL', 'P'),
(161675, 'Five Points', 40.4030609130859, 0.705166440817176, -79.523063659668, -1.38793929213426, 218, 45, 'PPL', 'P'),
(174112, 'Five Points', 43.3197212219238, 0.756071766368632, -90.5952835083008, -1.58118598399757, 218, 57, 'PPL', 'P'),
(181593, 'Five Points', 38.290828704834, 0.668301034216509, -121.643333435059, -2.12307668154308, 218, 6, 'PPL', 'P'),
(188551, 'Five Points', 35.0661087036133, 0.612019052740292, -106.666107177734, -1.86167477053662, 218, 38, 'PPL', 'P'),
(199320, 'Five Points', 42.7805595397949, 0.746661619814892, -103.689170837402, -1.80971742977556, 218, 35, 'PPL', 'P'),
(202126, 'Five Points', 43.9713897705078, 0.767445528173115, -103.550003051758, -1.80728849370335, 218, 49, 'PPL', 'P'),
(203973, 'Five Points', 41.2594413757324, 0.72011309954011, -111.969436645508, -1.95423533106731, 218, 52, 'PPL', 'P'),
(207426, 'Five Points', 46.0802803039551, 0.80425261154591, -118.110832214355, -2.06142290441109, 218, 56, 'PPL', 'P'),
(47083, 'Five Points (historical)', 39.6986083984375, 0.692871425012607, -76.1741714477539, -1.32949009674196, 218, 25, 'PPL', 'P'),
(109210, 'Five Points (historical)', 39.6819381713867, 0.692580474663516, -80.7238922119141, -1.40889770412291, 218, 58, 'PPL', 'P'),
(122614, 'Five Points Corner', 41.3327789306641, 0.721393081339029, -87.0358276367188, -1.51906175945902, 218, 19, 'PPL', 'P'),
(130806, 'Five Points Corner', 42.5091705322266, 0.741924988079104, -84.835563659668, -1.48065990864646, 218, 27, 'PPL', 'P'),
(2476, 'Five Points East', 33.5311088562012, 0.58522825138534, -86.708610534668, -1.5133507436594, 218, 2, 'PPL', 'P'),
(130807, 'Five Points North', 43.0736083984375, 0.751776287267416, -84.1675033569336, -1.46900005676187, 218, 27, 'PPL', 'P'),
(2475, 'Five Points South', 33.500560760498, 0.584695086535106, -86.8000030517578, -1.5149458439943, 218, 2, 'PPL', 'P'),
(124848, 'Five Pound Island', 42.6136093139648, 0.743747788687209, -70.6538925170898, -1.2331430537734, 218, 23, 'PPL', 'P'),
(115575, 'Five Seasons Manufactured Home Community', 42.0333290100098, 0.733619986798719, -91.6888885498047, -1.60027299268822, 218, 16, 'PPL', 'P'),
(115576, 'Five Seasons Mobile Home Park', 42.5027809143066, 0.741813468208457, -92.4094390869141, -1.61284897198779, 218, 16, 'PPL', 'P'),
(21119, 'Five Springs', 34.7127799987793, 0.605852303499132, -84.9744415283203, -1.48308378471259, 218, 13, 'PPL', 'P'),
(47084, 'Five Springs West', 39.4366683959961, 0.688299709527323, -76.7108306884766, -1.33885656745382, 218, 25, 'PPL', 'P'),
(8896, 'Fivemile', 35.6736106872559, 0.622621962567252, -91.9594421386719, -1.60499504361704, 218, 4, 'PPL', 'P'),
(35906, 'Fivemile', 37.5941696166992, 0.656142039364616, -83.4100036621094, -1.45577919300434, 218, 21, 'PPL', 'P'),
(72557, 'Fivemile', 39.1055603027344, 0.682520783119905, -83.9313888549805, -1.46487908129108, 218, 41, 'PPL', 'P'),
(109212, 'Fivemile', 38.7508316040039, 0.676329599375744, -82.081672668457, -1.43259544360882, 218, 58, 'PPL', 'P'),
(191464, 'Fivemile', 32.6311111450195, 0.569520328064808, -101.889167785645, -1.77830144997644, 218, 51, 'PPL', 'P'),
(75832, 'Fivemile Corner', 34.3622207641602, 0.599733890631757, -98.2261123657227, -1.71436907221578, 218, 42, 'PPL', 'P'),
(130808, 'Fivemile Corner', 44.7466697692871, 0.780976716776671, -85.5227813720703, -1.4926541204059, 218, 27, 'PPL', 'P'),
(94221, 'Fivemile Crossing', 30.9127807617188, 0.539529805239153, -99.7083282470703, -1.74023861957064, 218, 51, 'PPL', 'P'),
(188552, 'Fivemile Crossing', 36.6919403076172, 0.640395167313141, -107.752777099609, -1.88064073855573, 218, 38, 'PPL', 'P'),
(178186, 'Fivemile Landing', 34.795280456543, 0.607292208121511, -114.504997253418, -1.99848921205921, 218, 5, 'PPL', 'P'),
(40918, 'Fivemile Oaks', 29.5583305358887, 0.515890189244037, -91.3855590820313, -1.59497889475725, 218, 22, 'PPL', 'P'),
(148839, 'Fivemile Point', 42.0911102294922, 0.734628459324505, -75.8233337402344, -1.3233668236056, 218, 40, 'PPL', 'P'),
(21125, 'Fivemile Still', 31.0874996185303, 0.542579224555835, -82.8050003051758, -1.44521989244023, 218, 13, 'PPL', 'P'),
(161677, 'Fivepointville', 40.1827812194824, 0.701321834888511, -76.0513916015625, -1.32734718417083, 218, 45, 'PPL', 'P'),
(35908, 'Fixer', 37.6780586242676, 0.657606178752914, -83.7183303833008, -1.46116050946101, 218, 21, 'PPL', 'P'),
(181594, 'Fizzben Heights', 34.4213905334473, 0.600766597923462, -117.08943939209, -2.04359623670632, 218, 6, 'PPL', 'P'),
(29805, 'Flackville', 39.8097190856934, 0.694810672339376, -86.220832824707, -1.50483741660274, 218, 19, 'PPL', 'P'),
(148840, 'Flackville', 44.6652793884277, 0.779556186651223, -75.357780456543, -1.31524138596171, 218, 40, 'PPL', 'P'),
(101959, 'Flactem Manor', 37.1624984741211, 0.648607956640782, -77.3569412231445, -1.3501333236156, 218, 53, 'PPL', 'P'),
(8897, 'Flag', 35.8191719055176, 0.625162485089133, -92.394172668457, -1.61258252272073, 218, 4, 'PPL', 'P'),
(72558, 'Flag', 39.6863899230957, 0.692658172388319, -81.3050003051758, -1.41903995366031, 218, 41, 'PPL', 'P'),
(54768, 'Flag (historical)', 36.6016693115234, 0.63881964121225, -93.2975006103516, -1.62834856953205, 218, 29, 'PPL', 'P'),
(35909, 'Flag Fork', 38.3213882446289, 0.668834398803825, -84.9483337402344, -1.48262811785008, 218, 21, 'PPL', 'P'),
(47086, 'Flag Harbor', 38.4644393920898, 0.671331112325774, -76.4749984741211, -1.33474051883105, 218, 25, 'PPL', 'P'),
(8898, 'Flag Lake Crossing', 35.2236099243164, 0.614767967617472, -90.6430587768555, -1.58201981973487, 218, 4, 'PPL', 'P'),
(47087, 'Flag Marsh Heights', 39.3711090087891, 0.68715548236497, -77.0924987792969, -1.34551793228844, 218, 25, 'PPL', 'P'),
(86987, 'Flag Pond', 36.0152816772461, 0.62858524630113, -82.5572204589844, -1.4408953183041, 218, 50, 'PPL', 'P'),
(101961, 'Flag Pond Landing', 37.9355583190918, 0.662100396250478, -75.6566696166992, -1.32045798590496, 218, 53, 'PPL', 'P'),
(54769, 'Flag Spring', 38.0250015258789, 0.663661474702455, -91.6036071777344, -1.59878455195498, 218, 29, 'PPL', 'P'),
(72559, 'Flag Spring', 38.7238883972168, 0.675859351706263, -82.4558334350586, -1.4391257809178, 218, 41, 'PPL', 'P'),
(94222, 'Flag Springs', 33.5163917541504, 0.584971389498202, -96.0113906860352, -1.67571488688993, 218, 51, 'PPL', 'P'),
(139156, 'Flag Springs', 40.0250015258789, 0.698568059742341, -94.6666717529297, -1.65224511399334, 218, 29, 'PPL', 'P'),
(16023, 'Flagami', 25.7619400024414, 0.449630674743839, -80.3163909912109, -1.40178546611574, 218, 12, 'PPL', 'P'),
(119626, 'Flagg', 41.8958282470703, 0.731220145761421, -89.1408309936523, -1.55580099880304, 218, 18, 'PPL', 'P'),
(191465, 'Flagg', 34.4261093139648, 0.600848956180173, -102.409439086914, -1.78738189718723, 218, 51, 'PPL', 'P'),
(119632, 'Flagg Center', 41.940559387207, 0.732000851434978, -89.1222229003906, -1.55547622630811, 218, 18, 'PPL', 'P'),
(47088, 'Flagg Meadows', 39.4902801513672, 0.689235411176322, -76.9119415283203, -1.34236661377055, 218, 25, 'PPL', 'P'),
(35910, 'Flagg Spring', 38.8855590820313, 0.678681037460229, -84.2647171020508, -1.47069675669236, 218, 21, 'PPL', 'P'),
(127487, 'Flaggs Trailer Park', 43.1594390869141, 0.753274315380586, -70.6247177124023, -1.23263385737298, 218, 26, 'PPL', 'P'),
(109213, 'Flaggy Meadow', 39.5713882446289, 0.690651014453754, -80.0344390869141, -1.39686447705349, 218, 58, 'PPL', 'P'),
(115577, 'Flagler', 41.3247184753418, 0.721252399854445, -93.0216674804688, -1.62353437322952, 218, 16, 'PPL', 'P'),
(186713, 'Flagler', 39.2930603027344, 0.685793275467395, -103.066673278809, -1.79885279779247, 218, 7, 'PPL', 'P'),
(16024, 'Flagler Beach', 29.4747200012207, 0.514430910124728, -81.1272201538086, -1.41593710467426, 218, 12, 'PPL', 'P'),
(148841, 'Flagler Corners', 42.8547210693359, 0.747955982683697, -73.7949981689453, -1.28796568955128, 218, 40, 'PPL', 'P'),
(178187, 'Flagstaff', 35.1980590820313, 0.614322021292938, -111.65055847168, -1.94866985702126, 218, 5, 'PPL', 'P'),
(21121, 'Flagstone', 33.7786102294922, 0.589547965252476, -84.5650024414063, -1.47593772455958, 218, 13, 'PPL', 'P'),
(145229, 'Flagtown', 40.5169410705566, 0.707154024517729, -74.6847229003906, -1.30349431555143, 218, 37, 'PPL', 'P'),
(40919, 'Flagville', 29.9644393920898, 0.522978125906256, -90.4055633544922, -1.57787474265622, 218, 22, 'PPL', 'P'),
(35912, 'Flaherty', 37.8363914489746, 0.660369607858035, -86.065559387207, -1.50212738387748, 218, 21, 'PPL', 'P'),
(209913, 'Flaig', 47.1605606079102, 0.823107059694371, -117.265830993652, -2.04667485092645, 218, 56, 'PPL', 'P'),
(21123, 'Flakes Crossing', 33.5750007629395, 0.585994309672902, -84.2005615234375, -1.46957703061204, 218, 13, 'PPL', 'P'),
(47089, 'Flamewood', 39.166389465332, 0.683582452288465, -76.9069366455078, -1.34227926208679, 218, 25, 'PPL', 'P'),
(135376, 'Flaming', 47.4566688537598, 0.828275123526751, -96.2702789306641, -1.68023333915341, 218, 28, 'PPL', 'P'),
(203977, 'Flaming Gorge Lodge', 40.8844413757324, 0.713568114845131, -109.464721679688, -1.91051980808976, 218, 52, 'PPL', 'P'),
(203978, 'Flaming Gorge Summer Home Area', 40.889720916748, 0.713660260218848, -109.475280761719, -1.9107040988372, 218, 52, 'PPL', 'P'),
(16027, 'Flamingo', 28.3816699981689, 0.495353588682541, -81.373893737793, -1.42024237089248, 218, 12, 'PPL', 'P'),
(16028, 'Flamingo Bay', 26.5716705322266, 0.463763138542508, -82.1041717529297, -1.43298812671155, 218, 12, 'PPL', 'P'),
(181595, 'Flamingo Heights', 34.2405586242676, 0.597610485715609, -116.438056945801, -2.03222746832888, 218, 6, 'PPL', 'P'),
(203979, 'Flamingo Hills', 40.6611099243164, 0.709670245694664, -111.816108703613, -1.95155925364594, 218, 52, 'PPL', 'P'),
(178188, 'Flamingo Mobile Home Resort', 33.5261116027832, 0.58514103285964, -112.165557861328, -1.95765829201639, 218, 5, 'PPL', 'P'),
(16029, 'Flamingo Village', 26.1566696166992, 0.456520006167765, -80.1816711425781, -1.39943416118931, 218, 12, 'PPL', 'P'),
(54770, 'Flamm City', 38.4169387817383, 0.670502070278432, -90.3566665649414, -1.5770213326849, 218, 29, 'PPL', 'P'),
(35911, 'Flanagan', 37.9338912963867, 0.662071301215568, -84.210563659668, -1.46975160082149, 218, 21, 'PPL', 'P'),
(119628, 'Flanagan', 40.878059387207, 0.713456728132538, -88.8611068725586, -1.55091889189271, 218, 18, 'PPL', 'P'),
(2477, 'Flanders', 34.207218170166, 0.597028585017427, -85.9027786254883, -1.49928632362658, 218, 2, 'PPL', 'P'),
(40920, 'Flanders', 30.0988903045654, 0.525324737011266, -92.0322189331055, -1.60626523829895, 218, 22, 'PPL', 'P'),
(113438, 'Flanders', 41.3688888549805, 0.722023318410996, -72.2180633544922, -1.26044298494975, 218, 8, 'PPL', 'P'),
(130809, 'Flanders', 45.060001373291, 0.786445384917095, -83.7466735839844, -1.46165519163349, 218, 27, 'PPL', 'P'),
(145230, 'Flanders', 40.8455581665039, 0.712889474820351, -74.6952819824219, -1.30367860629886, 218, 37, 'PPL', 'P'),
(148842, 'Flanders', 40.9033317565918, 0.713897814188083, -72.6180572509766, -1.26742419543128, 218, 40, 'PPL', 'P'),
(113439, 'Flanders (historical)', 41.3030586242676, 0.720874364137709, -72.6041717529297, -1.26718184777209, 218, 8, 'PPL', 'P'),
(127488, 'Flanders Corner', 44.189998626709, 0.771260972487844, -69.4047164916992, -1.21134081919336, 218, 26, 'PPL', 'P'),
(207427, 'Flandersville', 46.1541709899902, 0.80554224730378, -123.294441223145, -2.1518939487505, 218, 56, 'PPL', 'P'),
(170303, 'Flandreau', 44.0494384765625, 0.768807735070691, -96.5950012207031, -1.68590081226921, 218, 49, 'PPL', 'P'),
(203980, 'Flangas', 40.7066688537598, 0.710465399017134, -112.091667175293, -1.95636865625851, 218, 52, 'PPL', 'P'),
(199957, 'Flanigan', 40.1708297729492, 0.70111324279613, -119.885559082031, -2.09239773157564, 218, 39, 'PPL', 'P'),
(64745, 'Flanner Beach', 34.9836082458496, 0.610579148117914, -76.9486083984375, -1.3430065713805, 218, 33, 'PPL', 'P'),
(198288, 'Flasher', 46.4561080932617, 0.810812043889802, -101.232223510742, -1.76683560937726, 218, 34, 'PPL', 'P'),
(8900, 'Flat', 35.9594383239746, 0.627610595921188, -92.9858322143555, -1.62290892984751, 218, 4, 'PPL', 'P'),
(54771, 'Flat', 37.7452812194824, 0.658779434371149, -91.9288864135742, -1.60446174560875, 218, 29, 'PPL', 'P'),
(94223, 'Flat', 31.3086109161377, 0.546438344712441, -97.6297225952148, -1.7039601070952, 218, 51, 'PPL', 'P'),
(211831, 'Flat', 62.4536094665527, 1.09002111494604, -158.007507324219, -2.75775124567667, 218, 1, 'PPL', 'P'),
(21124, 'Flat Branch', 34.7691688537598, 0.606836474679971, -84.4899978637695, -1.47462864772575, 218, 13, 'PPL', 'P'),
(64747, 'Flat Branch', 35.3133316040039, 0.616333906338439, -78.8847198486328, -1.37679809087197, 218, 33, 'PPL', 'P'),
(86988, 'Flat Branch', 35.3066711425781, 0.616217659356857, -85.7080612182617, -1.49588786375953, 218, 50, 'PPL', 'P'),
(2478, 'Flat Creek', 33.6441688537598, 0.587201520595035, -87.0924987792969, -1.52005085748787, 218, 2, 'PPL', 'P'),
(21126, 'Flat Creek', 34.2458305358887, 0.597702497931272, -83.9300003051758, -1.46485484652516, 218, 13, 'PPL', 'P'),
(40921, 'Flat Creek', 31.9711093902588, 0.558001124375293, -92.3908309936523, -1.61252419949286, 218, 22, 'PPL', 'P'),
(54772, 'Flat Creek', 36.7613906860352, 0.641607305083291, -93.6127777099609, -1.63385119297638, 218, 29, 'PPL', 'P'),
(64748, 'Flat Creek', 35.7527809143066, 0.624003743698839, -82.5466690063477, -1.44071116071472, 218, 33, 'PPL', 'P'),
(86990, 'Flat Creek', 36.3849983215332, 0.635038019043365, -85.3822174072266, -1.49020081640972, 218, 50, 'PPL', 'P'),
(148844, 'Flat Creek', 42.4300003051758, 0.740543206947516, -74.4019393920898, -1.29855881226124, 218, 40, 'PPL', 'P'),
(194934, 'Flat Creek', 47.2322196960449, 0.824357746721299, -116.490280151367, -2.03313893521196, 218, 17, 'PPL', 'P'),
(21127, 'Flat Ford', 31.2211093902588, 0.544911154985335, -83.5038909912109, -1.45741783602306, 218, 13, 'PPL', 'P'),
(35913, 'Flat Fork', 37.8377799987793, 0.660393842623955, -83.0286102294922, -1.44912262185968, 218, 21, 'PPL', 'P'),
(94224, 'Flat Fork', 31.8808307647705, 0.556425465116347, -94.2108306884766, -1.64428918655283, 218, 51, 'PPL', 'P'),
(64750, 'Flat Gap', 35.7202796936035, 0.623436490386653, -81.5713882446289, -1.42368930029137, 218, 33, 'PPL', 'P'),
(86991, 'Flat Gap', 36.0622215270996, 0.629404501231466, -83.477783203125, -1.45696216916055, 218, 50, 'PPL', 'P'),
(101962, 'Flat Gap', 37.0741691589355, 0.647066319264762, -82.7030563354492, -1.44344063451594, 218, 53, 'PPL', 'P'),
(86992, 'Flat Hollow', 36.4105606079102, 0.63548416510498, -83.9388885498047, -1.46500997565866, 218, 50, 'PPL', 'P'),
(72560, 'Flat Iron', 39.5322189331055, 0.68996738100193, -84.248893737793, -1.47042058688732, 218, 41, 'PPL', 'P'),
(101966, 'Flat Iron', 38.1477813720703, 0.665804387273587, -76.92138671875, -1.34253146344202, 218, 53, 'PPL', 'P'),
(122615, 'Flat Iron', 40.0533294677734, 0.699062475598714, -87.4899978637695, -1.52698852528558, 218, 19, 'PPL', 'P'),
(155278, 'Flat Iron Corner', 40.2638893127441, 0.702737438165942, -81.6569366455078, -1.42518240155653, 218, 41, 'PPL', 'P'),
(127489, 'Flat Landing', 44.3586082458496, 0.774203765492382, -68.7699966430664, -1.20026286800696, 218, 26, 'PPL', 'P'),
(35914, 'Flat Lick', 36.8288917541504, 0.642785420970514, -83.7702789306641, -1.46206718265412, 218, 21, 'PPL', 'P'),
(190206, 'Flat Nose', 37.8933296203613, 0.661363366418798, -114.29972076416, -1.99490646144472, 218, 39, 'PPL', 'P'),
(94225, 'Flat Prairie', 33.4625015258789, 0.584030827580213, -95.9780578613281, -1.6751331193498, 218, 51, 'PPL', 'P'),
(181596, 'Flat Ravine (historical)', 39.1341705322266, 0.683020125824295, -120.517501831055, -2.1034272132302, 218, 6, 'PPL', 'P'),
(101963, 'Flat Ridge', 36.6969413757324, 0.640482452417868, -81.345832824707, -1.41975261556802, 218, 53, 'PPL', 'P'),
(155276, 'Flat Ridge', 40.1302795410156, 0.700405507736442, -81.6733322143555, -1.42546855821565, 218, 41, 'PPL', 'P'),
(54777, 'Flat River', 37.8499984741211, 0.660607095248243, -90.5166702270508, -1.57981392340396, 218, 29, 'PPL', 'P'),
(2481, 'Flat Rock', 34.5366706848145, 0.602778616127017, -87.4852828979492, -1.5269062336079, 218, 2, 'PPL', 'P'),
(21129, 'Flat Rock', 33.2372207641602, 0.58009893654682, -83.317497253418, -1.45416465159348, 218, 13, 'PPL', 'P'),
(27176, 'Flat Rock', 38.901668548584, 0.678962200692314, -87.6716690063477, -1.53015928487943, 218, 18, 'PPL', 'P'),
(29806, 'Flat Rock', 39.3641700744629, 0.687034375114399, -85.831672668457, -1.4980452905586, 218, 19, 'PPL', 'P'),
(35918, 'Flat Rock', 36.6758308410645, 0.640114004081056, -86.5619430541992, -1.51079091321961, 218, 21, 'PPL', 'P'),
(59908, 'Flat Rock', 31.4074993133545, 0.548164272835894, -91.0930633544922, -1.58987388126368, 218, 30, 'PPL', 'P'),
(64755, 'Flat Rock', 36.3911094665527, 0.635144678645022, -78.3680572509766, -1.36778062742096, 218, 33, 'PPL', 'P'),
(81008, 'Flat Rock', 34.4702796936035, 0.601619874736724, -80.6341705322266, -1.40733176540194, 218, 48, 'PPL', 'P'),
(86995, 'Flat Rock', 36.1630592346191, 0.631164451237845, -86.3144378662109, -1.50647113277345, 218, 50, 'PPL', 'P'),
(101965, 'Flat Rock', 36.610279083252, 0.638969910076758, -82.8419418334961, -1.44586464374014, 218, 53, 'PPL', 'P'),
(130811, 'Flat Rock', 42.0963897705078, 0.734720604698221, -83.2919387817383, -1.45371857211089, 218, 27, 'PPL', 'P'),
(155277, 'Flat Rock', 41.2358283996582, 0.71970097536142, -82.8602828979492, -1.44618475570316, 218, 41, 'PPL', 'P'),
(161678, 'Flat Rock', 40.8250007629395, 0.71253068044249, -78.1066665649414, -1.3632184993156, 218, 45, 'PPL', 'P'),
(178189, 'Flat Rock', 36.0055618286133, 0.628415602939692, -109.555000305176, -1.91209546734871, 218, 5, 'PPL', 'P'),
(191466, 'Flat Rock', 31.225830078125, 0.544993546531559, -101.848892211914, -1.77759850860671, 218, 51, 'PPL', 'P'),
(194935, 'Flat Rock', 44.500560760498, 0.776681304254483, -111.335563659668, -1.94317216042495, 218, 17, 'PPL', 'P'),
(21130, 'Flat Rock (historical)', 33.4644393920898, 0.584064649726057, -83.1319427490234, -1.45092611454989, 218, 13, 'PPL', 'P'),
(81009, 'Flat Rock (historical)', 34.8616714477539, 0.608450949511804, -81.5950012207031, -1.42410142447006, 218, 48, 'PPL', 'P'),
(86996, 'Flat Rock (historical)', 35.5833282470703, 0.621046236729279, -87.5527801513672, -1.5280842829161, 218, 50, 'PPL', 'P'),
(64756, 'Flat Rock Forest', 35.2775001525879, 0.615708529535461, -82.4430618286133, -1.43890287433456, 218, 33, 'PPL', 'P'),
(29807, 'Flat Rock Park', 39.2527809143066, 0.685090267518641, -85.9155578613281, -1.49950936336787, 218, 19, 'PPL', 'P'),
(101967, 'Flat Run', 38.3647193908691, 0.66959066997438, -77.7666702270508, -1.35728444377468, 218, 53, 'PPL', 'P'),
(21132, 'Flat Shoals', 34.3555603027344, 0.599617643650175, -82.9875030517578, -1.44840516626202, 218, 13, 'PPL', 'P'),
(64757, 'Flat Shoals', 36.3650016784668, 0.63468901178251, -80.2438888549805, -1.40052006512379, 218, 33, 'PPL', 'P'),
(81010, 'Flat Shoals', 34.857780456543, 0.608383038904007, -83.0152816772461, -1.44888999473847, 218, 48, 'PPL', 'P'),
(64758, 'Flat Shoals (historical)', 36.4061088562012, 0.635406467380177, -80.5616683959961, -1.40606636440999, 218, 33, 'PPL', 'P'),
(21133, 'Flat Shoals Estates', 33.5825004577637, 0.586125204040479, -84.4680633544922, -1.47424581831906, 218, 13, 'PPL', 'P'),
(64759, 'Flat Springs', 36.2519416809082, 0.632715742572816, -81.9338912963867, -1.43001617209307, 218, 33, 'PPL', 'P'),
(2483, 'Flat Top', 33.1236114501953, 0.578116079957202, -87.0991668701172, -1.52016723762751, 218, 2, 'PPL', 'P'),
(59911, 'Flat Top', 30.4797191619873, 0.531971454459885, -89.5955581665039, -1.56373748516759, 218, 30, 'PPL', 'P'),
(64760, 'Flat Top', 35.5683288574219, 0.620784447994124, -82.3816680908203, -1.43783135146997, 218, 33, 'PPL', 'P'),
(86997, 'Flat Top', 35.3574981689453, 0.617104758315962, -85.2247161865234, -1.48745190153254, 218, 50, 'PPL', 'P'),
(101968, 'Flat Top', 37.0288887023926, 0.646276026211281, -82.3974990844727, -1.43810765443306, 218, 53, 'PPL', 'P'),
(109214, 'Flat Top', 37.5894393920898, 0.656059481370823, -81.1069412231445, -1.41558317056539, 218, 58, 'PPL', 'P'),
(191467, 'Flat Top', 33.0244407653809, 0.576385224985732, -100.097503662109, -1.74703101193089, 218, 51, 'PPL', 'P'),
(86998, 'Flat Woods', 35.4769401550293, 0.619189414238249, -87.8274993896484, -1.53287903814268, 218, 50, 'PPL', 'P'),
(148845, 'Flatbrook', 42.3769416809082, 0.739617159257468, -73.429443359375, -1.28158555452778, 218, 40, 'PPL', 'P'),
(145231, 'Flatbrookville', 41.1002807617188, 0.717335222786075, -74.9638900756836, -1.30836670192378, 218, 37, 'PPL', 'P'),
(148847, 'Flatbush', 42.0152816772461, 0.73330500142079, -73.9608306884766, -1.29086001302398, 218, 40, 'PPL', 'P'),
(109215, 'Flatfork', 38.7075004577637, 0.675573328205188, -81.4966735839844, -1.42238528346361, 218, 58, 'PPL', 'P'),
(35919, 'Flatgap', 37.9341697692871, 0.662076161484558, -82.8874969482422, -1.44665973048358, 218, 21, 'PPL', 'P'),
(72561, 'Flatiron', 39.7452812194824, 0.693686019411035, -82.0977783203125, -1.43287654026187, 218, 41, 'PPL', 'P'),
(202130, 'Flatiron I (historical)', 44.3263893127441, 0.773641439028212, -103.768058776855, -1.81109428405913, 218, 49, 'PPL', 'P'),
(148848, 'Flatlands', 40.6211090087891, 0.708972098014899, -73.9352798461914, -1.29041406669945, 218, 40, 'PPL', 'P'),
(94226, 'Flatonia', 29.6875, 0.518144621685817, -97.1083297729492, -1.6948600856504, 218, 51, 'PPL', 'P'),
(101969, 'Flatrock', 37.0541687011719, 0.64671724542488, -81.9824981689453, -1.43086452205832, 218, 53, 'PPL', 'P'),
(109216, 'Flatrock', 38.8486099243164, 0.678036153002266, -82.0166702270508, -1.43146093698444, 218, 58, 'PPL', 'P'),
(94227, 'Flatrock Crossing', 29.5725002288818, 0.516137497040765, -99.4019393920898, -1.73489112525982, 218, 51, 'PPL', 'P'),
(94228, 'Flatrock Ford', 30.0702800750732, 0.524825394306876, -97.8905563354492, -1.70851251466258, 218, 51, 'PPL', 'P'),
(94229, 'Flats', 32.8383293151855, 0.573136967404163, -95.8824996948242, -1.67346531471714, 218, 51, 'PPL', 'P'),
(199321, 'Flats', 41.5688896179199, 0.72551399023079, -101.351387023926, -1.76891540503056, 218, 35, 'PPL', 'P'),
(119629, 'Flatville', 40.2394409179688, 0.702310733180284, -88.0591735839844, -1.53692251562574, 218, 18, 'PPL', 'P'),
(196487, 'Flatwillow', 46.8319396972656, 0.817371542812722, -108.399436950684, -1.89192708209743, 218, 31, 'PPL', 'P'),
(196488, 'Flatwillow Colony', 46.7244415283203, 0.815495345824761, -108.488891601563, -1.89348836028649, 218, 31, 'PPL', 'P'),
(2490, 'Flatwood', 31.7966709136963, 0.554956598617114, -88.2375030517578, -1.54003495199172, 218, 2, 'PPL', 'P'),
(35920, 'Flatwood', 37.047779083252, 0.646605725554233, -85.3616714477539, -1.48984222176894, 218, 21, 'PPL', 'P'),
(54778, 'Flatwood', 37.2211112976074, 0.649630943394509, -91.4475021362305, -1.59606000500177, 218, 29, 'PPL', 'P'),
(59909, 'Flatwood', 34.3888893127441, 0.600199344611275, -89.1286087036133, -1.55558767959973, 218, 30, 'PPL', 'P'),
(64762, 'Flatwood', 36.5555610656738, 0.638014900509855, -81.6536102294922, -1.42512434464476, 218, 33, 'PPL', 'P'),
(87000, 'Flatwood', 35.5233306884766, 0.61999908178866, -89.82861328125, -1.56780506425852, 218, 50, 'PPL', 'P'),
(101970, 'Flatwood', 36.8530616760254, 0.643207265687183, -80.8874969482422, -1.41175314544369, 218, 53, 'PPL', 'P'),
(2489, 'Flatwoods', 33.2544403076172, 0.580399474275836, -87.5719375610352, -1.52841864279096, 218, 2, 'PPL', 'P'),
(8902, 'Flatwoods', 36.0072212219238, 0.628444564816547, -93.1344375610352, -1.62550258243314, 218, 4, 'PPL', 'P'),
(27177, 'Flatwoods', 37.4236106872559, 0.653165224477153, -88.7241668701172, -1.54852883797242, 218, 18, 'PPL', 'P'),
(35921, 'Flatwoods', 38.5224990844727, 0.672344445120549, -82.7172164916992, -1.4436877758651, 218, 21, 'PPL', 'P'),
(40923, 'Flatwoods', 31.4025001525879, 0.54807702102068, -92.8680572509766, -1.62085336896014, 218, 22, 'PPL', 'P'),
(54779, 'Flatwoods', 36.6805610656738, 0.640196562074848, -90.7002792358398, -1.58301850514365, 218, 29, 'PPL', 'P'),
(72562, 'Flatwoods', 39.0702781677246, 0.681904993696852, -81.976936340332, -1.43076744983658, 218, 41, 'PPL', 'P'),
(87001, 'Flatwoods', 35.3005599975586, 0.616110999755199, -87.3505630493164, -1.52455492868147, 218, 50, 'PPL', 'P'),
(101973, 'Flatwoods', 36.8905601501465, 0.64386173752507, -82.4288864135742, -1.43865546666929, 218, 53, 'PPL', 'P'),
(109218, 'Flatwoods', 38.7230606079102, 0.675844904057349, -80.6500015258789, -1.40760806836504, 218, 58, 'PPL', 'P'),
(161679, 'Flatwoods', 40.0283317565918, 0.698626183233132, -79.7261123657227, -1.39148316059683, 218, 45, 'PPL', 'P'),
(59910, 'Flautt', 33.8972206115723, 0.591618106946822, -90.3850021362305, -1.57751588169933, 218, 30, 'PPL', 'P'),
(200827, 'Flavel (historical)', 46.1902809143066, 0.806172484375748, -123.927780151367, -2.16294779832903, 218, 43, 'PPL', 'P'),
(122616, 'Flax', 40.6416702270508, 0.709330958971788, -86.5166702270508, -1.51000075332419, 218, 19, 'PPL', 'P'),
(113440, 'Flax Hill Elderly Housing', 41.8172187805176, 0.72984815174684, -72.5338897705078, -1.265955195774, 218, 8, 'PPL', 'P'),
(198293, 'Flaxton', 48.898609161377, 0.853441729511891, -102.391937255859, -1.78707643261019, 218, 34, 'PPL', 'P'),
(109219, 'Flaxton (historical)', 38.7222213745117, 0.675830256671354, -82.040283203125, -1.43187306116313, 218, 58, 'PPL', 'P'),
(196489, 'Flaxville', 48.8038902282715, 0.851788572265224, -105.172218322754, -1.83560149135836, 218, 31, 'PPL', 'P'),
(64763, 'Flay', 35.4630584716797, 0.618947133158079, -81.4361114501953, -1.42132827482696, 218, 33, 'PPL', 'P'),
(13772, 'Flea Hill', 38.6622200012207, 0.674783035151707, -75.4361114501953, -1.3166085197073, 218, 10, 'PPL', 'P'),
(21134, 'Flea Hill', 30.7927799224854, 0.537435395489374, -81.8394393920898, -1.42836767537831, 218, 13, 'PPL', 'P'),
(181597, 'Flea Valley (historical)', 39.829719543457, 0.695159746179258, -121.481941223145, -2.1202598560581, 218, 6, 'PPL', 'P'),
(94230, 'Fleamarket Colonia', 26.2910003662109, 0.458864520033416, -98.0179977416992, -1.71073678680502, 218, 51, 'PPL', 'P'),
(72563, 'Fleatown', 39.9930610656738, 0.69801059354716, -82.4047164916992, -1.43823362195262, 218, 41, 'PPL', 'P'),
(155280, 'Fleaville (historical)', 40.3916702270508, 0.704967635841802, -82.466667175293, -1.43931486535519, 218, 41, 'PPL', 'P'),
(155281, 'Flechtner Heights', 41.1933288574219, 0.718959218418806, -83.4280624389648, -1.45609437811935, 218, 41, 'PPL', 'P'),
(101974, 'Fleeburg', 38.4727783203125, 0.671476654079347, -78.5950012207031, -1.37174154691023, 218, 53, 'PPL', 'P'),
(140021, 'Fleece', 48.7602806091309, 0.85102744082568, -97.2063903808594, -1.69657156612494, 218, 34, 'PPL', 'P'),
(29809, 'Fleener', 39.2825012207031, 0.685608984719961, -86.4124984741211, -1.50818261324799, 218, 19, 'PPL', 'P'),
(193558, 'Fleener Place', 41.8477783203125, 0.730381516334155, -121.58943939209, -2.12213605304606, 218, 6, 'PPL', 'P'),
(101975, 'Fleenor Spring', 36.6819381713867, 0.640220597103686, -82.1380615234375, -1.43357961478965, 218, 53, 'PPL', 'P'),
(87002, 'Fleenora Park (historical)', 36.5680618286133, 0.63823307998216, -82.0072174072266, -1.43129595415491, 218, 50, 'PPL', 'P'),
(101976, 'Fleenors', 36.7041702270508, 0.640608619674511, -82.1630630493164, -1.43401597373426, 218, 53, 'PPL', 'P'),
(101977, 'Fleenortown', 36.7052803039551, 0.640627994171441, -83.1305618286133, -1.45090201294202, 218, 53, 'PPL', 'P'),
(35922, 'Fleet', 36.6536102294922, 0.639726181247313, -86.2938919067383, -1.50611253813267, 218, 21, 'PPL', 'P'),
(81011, 'Fleet', 33.9588890075684, 0.592694423501377, -79.5266723632813, -1.38800227589404, 218, 48, 'PPL', 'P'),
(101979, 'Fleet', 36.7916717529297, 0.642135809401617, -81.7413864135742, -1.42665632806183, 218, 53, 'PPL', 'P'),
(101978, 'Fleeton', 37.814998626709, 0.659996232673206, -76.2813873291016, -1.33136136688191, 218, 53, 'PPL', 'P'),
(181598, 'Fleetridge', 32.7277793884277, 0.5712075071944, -117.247222900391, -2.04635007843151, 218, 6, 'PPL', 'P'),
(87003, 'Fleetvile (historical)', 36.1933288574219, 0.631692755819089, -87.466667175293, -1.52658132795491, 218, 50, 'PPL', 'P'),
(161682, 'Fleetville', 41.5980606079102, 0.726023120052186, -75.7149963378906, -1.32147597923164, 218, 45, 'PPL', 'P'),
(2491, 'Fleetwood', 33.2391700744629, 0.580132958429746, -87.4044418334961, -1.52549529086238, 218, 2, 'PPL', 'P'),
(21136, 'Fleetwood', 34.288890838623, 0.598454041990892, -83.7888870239258, -1.46239195514906, 218, 13, 'PPL', 'P'),
(64764, 'Fleetwood', 36.3061103820801, 0.633661164759794, -81.5136108398438, -1.42268089434461, 218, 33, 'PPL', 'P'),
(75834, 'Fleetwood', 33.896671295166, 0.591608519566898, -97.850830078125, -1.70781916067278, 218, 42, 'PPL', 'P'),
(148849, 'Fleetwood', 40.9249992370605, 0.714275983062874, -73.8363876342773, -1.28868807199697, 218, 40, 'PPL', 'P'),
(161680, 'Fleetwood', 40.4538917541504, 0.706053606355309, -75.8183288574219, -1.32327947192184, 218, 45, 'PPL', 'P'),
(21137, 'Fleetwood Hills', 33.8713912963867, 0.591167300353299, -84.8191680908203, -1.48037375198733, 218, 13, 'PPL', 'P'),
(16030, 'Fleetwood Manor', 26.0166702270508, 0.454076555867617, -80.2222213745117, -1.400141896249, 218, 12, 'PPL', 'P'),
(40922, 'Fleetwood Park', 32.5444412231445, 0.568007652565643, -91.9847183227539, -1.60543619625161, 218, 22, 'PPL', 'P'),
(155282, 'Fleetwood Park', 40.2508316040039, 0.702509538155659, -83.3655624389648, -1.45500354733685, 218, 41, 'PPL', 'P'),
(148850, 'Fleischmanns', 42.1552810668945, 0.735748451720938, -74.5327835083008, -1.30084247289598, 218, 40, 'PPL', 'P'),
(190207, 'Fleish', 39.4813919067383, 0.689080282042825, -119.992782592773, -2.09426913487363, 218, 39, 'PPL', 'P'),
(21138, 'Fleming', 31.8805599212646, 0.556420738005412, -81.4266662597656, -1.42116342515549, 218, 13, 'PPL', 'P'),
(29810, 'Fleming', 38.9736099243164, 0.680217814567259, -85.8063888549805, -1.49760400476598, 218, 19, 'PPL', 'P'),
(32449, 'Fleming', 37.3680610656738, 0.652195700682309, -94.7827835083008, -1.65427164642483, 218, 20, 'PPL', 'P'),
(35923, 'Fleming', 37.1955604553223, 0.649184997069975, -82.6991729736328, -1.4433728570662, 218, 21, 'PPL', 'P'),
(54781, 'Fleming', 39.1991691589355, 0.684154565869642, -94.0652770996094, -1.64174879718901, 218, 29, 'PPL', 'P'),
(72564, 'Fleming', 39.3916702270508, 0.687514343321858, -81.6108322143555, -1.42437772743316, 218, 41, 'PPL', 'P'),
(94231, 'Fleming', 31.813060760498, 0.555242655407702, -98.4722213745117, -1.71866448473797, 218, 51, 'PPL', 'P'),
(109220, 'Fleming', 38.0877799987793, 0.664757165753941, -82.4711074829102, -1.43939236334292, 218, 58, 'PPL', 'P'),
(130813, 'Fleming', 42.6436080932617, 0.744271366157518, -84.0133285522461, -1.46630919879646, 218, 27, 'PPL', 'P'),
(148851, 'Fleming', 42.8616714477539, 0.74807728967135, -76.5744400024414, -1.33647610091346, 218, 40, 'PPL', 'P'),
(194183, 'Fleming', 40.6800003051758, 0.709999945037615, -102.838890075684, -1.7948772309172, 218, 7, 'PPL', 'P'),
(8904, 'Fleming (historical)', 34.2841682434082, 0.598371617155154, -92.7858276367188, -1.61941819144869, 218, 4, 'PPL', 'P'),
(21139, 'Fleming (historical)', 33.8769416809082, 0.59126417283795, -84.1533279418945, -1.4687526490966, 218, 13, 'PPL', 'P'),
(101980, 'Fleming Corner', 36.7036094665527, 0.640598832557505, -78.6908264160156, -1.3734140120748, 218, 53, 'PPL', 'P'),
(13773, 'Fleming Corners', 38.9183311462402, 0.679253017883351, -75.5983276367188, -1.31943972626217, 218, 10, 'PPL', 'P'),
(101981, 'Fleming Court', 37.3111114501953, 0.651201742384464, -79.9391708374023, -1.3952017324269, 218, 53, 'PPL', 'P'),
(81012, 'Fleming Crossroad', 34.6775016784668, 0.605236580655106, -80.7619400024414, -1.40956176334072, 218, 48, 'PPL', 'P'),
(155283, 'Fleming Falls', 40.8005599975586, 0.712104108614887, -82.4433288574219, -1.43890753486647, 218, 41, 'PPL', 'P'),
(2492, 'Fleming Hills', 34.6613883972168, 0.604955350843993, -86.5827789306641, -1.51115456786646, 218, 2, 'PPL', 'P'),
(2493, 'Fleming Meadows', 34.6827812194824, 0.605328726028822, -86.5719375610352, -1.51096535027101, 218, 2, 'PPL', 'P'),
(101982, 'Fleming Oaks', 37.3191719055176, 0.651342423869048, -79.9383316040039, -1.39518708504091, 218, 53, 'PPL', 'P'),
(161685, 'Fleming Summit', 40.7238883972168, 0.71076593674615, -78.9044418334961, -1.37714230444286, 218, 45, 'PPL', 'P'),
(47090, 'Fleming Way Estates', 39.4297218322754, 0.688178469118697, -77.085563659668, -1.3453968916169, 218, 25, 'PPL', 'P'),
(35925, 'Fleming-Neon', 37.1922187805176, 0.649126673842102, -82.7058334350586, -1.44348910404778, 218, 21, 'PPL', 'P'),
(13774, 'Flemings Landing', 39.353889465332, 0.686854944635955, -75.5488891601563, -1.31857686206898, 218, 10, 'PPL', 'P'),
(35926, 'Flemingsburg', 38.4222183227539, 0.670594215652149, -83.73388671875, -1.46143201873414, 218, 21, 'PPL', 'P'),
(27178, 'Flemingsburg (historical)', 38.9355583190918, 0.679553688770421, -88.5400009155273, -1.54531453569475, 218, 18, 'PPL', 'P'),
(87004, 'Flemingsburg (historical)', 35.8519401550293, 0.625734398933227, -86.6486129760742, -1.51230358871878, 218, 50, 'PPL', 'P'),
(35927, 'Flemingsburg Junction', 38.4588890075684, 0.671234239841122, -83.8069381713867, -1.46270700710601, 218, 21, 'PPL', 'P'),
(16031, 'Flemington', 29.4074993133545, 0.513257687796008, -82.2977828979492, -1.43636727866069, 218, 12, 'PPL', 'P'),
(21141, 'Flemington', 31.8594398498535, 0.556052123221032, -81.5641708374023, -1.42356333277181, 218, 13, 'PPL', 'P'),
(54782, 'Flemington', 37.8047218322754, 0.659816868773789, -93.501106262207, -1.6319021585326, 218, 29, 'PPL', 'P'),
(109221, 'Flemington', 39.2663917541504, 0.685327821487876, -80.1322174072266, -1.39857103068002, 218, 58, 'PPL', 'P'),
(145242, 'Flemington', 40.5122184753418, 0.707071599681992, -74.8597183227539, -1.30654856184758, 218, 37, 'PPL', 'P'),
(161683, 'Flemington', 41.1263885498047, 0.717790889648588, -77.4719390869141, -1.35214041497114, 218, 45, 'PPL', 'P'),
(2494, 'Flemington Heights', 34.6691703796387, 0.605091172059587, -86.559440612793, -1.51074723737774, 218, 2, 'PPL', 'P'),
(145232, 'Flemington Junction', 40.5316696166992, 0.707411086141949, -74.8399963378906, -1.30620434827669, 218, 37, 'PPL', 'P'),
(81013, 'Flemingtown', 33.9575004577637, 0.592670188735458, -79.5097198486328, -1.38770639869693, 218, 48, 'PPL', 'P'),
(101984, 'Flemingtown', 37.1752815246582, 0.648831062961103, -82.4252777099609, -1.43859248290951, 218, 53, 'PPL', 'P'),
(148853, 'Flemingville', 42.1647186279297, 0.735913168234359, -76.2491683959961, -1.33079904041774, 218, 40, 'PPL', 'P'),
(35928, 'Flener', 37.2894401550293, 0.650823506930646, -86.6666717529297, -1.51261877383379, 218, 21, 'PPL', 'P'),
(135379, 'Flensburg', 45.9552803039551, 0.802070949980917, -94.5347213745117, -1.64994214544069, 218, 28, 'PPL', 'P'),
(2495, 'Fleta', 32.1094398498535, 0.560415446351018, -86.3522186279297, -1.50713053145935, 218, 2, 'PPL', 'P'),
(181599, 'Fleta', 35.0033302307129, 0.610923361688806, -118.157218933105, -2.06223250538247, 218, 6, 'PPL', 'P'),
(16032, 'Fletcher', 29.7408294677734, 0.519075396486799, -82.9850006103516, -1.44836149042014, 218, 12, 'PPL', 'P'),
(35929, 'Fletcher', 37.0050010681152, 0.645859108342629, -83.9702835083008, -1.46555792105294, 218, 21, 'PPL', 'P'),
(54784, 'Fletcher', 38.165828704834, 0.666119372651516, -90.7333297729492, -1.58359534583576, 218, 29, 'PPL', 'P'),
(64767, 'Fletcher', 35.4305610656738, 0.618379946424919, -82.5013885498047, -1.43992086766124, 218, 33, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(75835, 'Fletcher', 34.8230590820313, 0.607777036597959, -98.2438888549805, -1.71467933048277, 218, 42, 'PPL', 'P'),
(81014, 'Fletcher', 34.714168548584, 0.605876538265052, -79.5955581665039, -1.38920455996815, 218, 48, 'PPL', 'P'),
(94232, 'Fletcher', 30.2655601501465, 0.528233674580446, -94.1888885498047, -1.64390622398808, 218, 51, 'PPL', 'P'),
(101983, 'Fletcher', 38.3927803039551, 0.670080425298845, -78.4336090087891, -1.36892472142526, 218, 53, 'PPL', 'P'),
(109222, 'Fletcher', 38.6536102294922, 0.6746327662872, -81.5752792358398, -1.42375721089917, 218, 58, 'PPL', 'P'),
(119630, 'Fletcher', 40.5269393920898, 0.707328528148157, -88.7836074829102, -1.54956627237506, 218, 18, 'PPL', 'P'),
(122618, 'Fletcher', 40.9119415283203, 0.71404808305259, -86.3327789306641, -1.50679124473648, 218, 19, 'PPL', 'P'),
(130814, 'Fletcher', 44.5394401550293, 0.777359877700235, -84.9522171020508, -1.48269589529982, 218, 27, 'PPL', 'P'),
(135381, 'Fletcher', 45.1725006103516, 0.788408867009783, -93.5411071777344, -1.63260030621237, 218, 28, 'PPL', 'P'),
(155284, 'Fletcher', 40.144718170166, 0.70065750935459, -84.1125030517578, -1.46804012034695, 218, 41, 'PPL', 'P'),
(172022, 'Fletcher', 44.6833305358887, 0.77987123860818, -72.9141693115234, -1.27259232584269, 218, 55, 'PPL', 'P'),
(190208, 'Fletcher', 38.3569412231445, 0.669454915337813, -118.897499084473, -2.07515283141099, 218, 39, 'PPL', 'P'),
(194936, 'Fletcher', 46.2894401550293, 0.807903139610136, -116.410003662109, -2.03173784616247, 218, 17, 'PPL', 'P'),
(207428, 'Fletcher', 46.8686103820801, 0.818011567001695, -118.323059082031, -2.06512696201322, 218, 56, 'PPL', 'P'),
(64768, 'Fletcher (historical)', 36.1566696166992, 0.631052931367198, -81.133056640625, -1.41603897058596, 218, 33, 'PPL', 'P'),
(193559, 'Fletcher (historical)', 41.4458312988281, 0.723366217390669, -120.753326416016, -2.10754312869492, 218, 6, 'PPL', 'P'),
(207429, 'Fletcher Bay', 47.6408309936523, 0.831489359225395, -122.575828552246, -2.13935179159677, 218, 56, 'PPL', 'P'),
(127491, 'Fletcher Field', 45.0349998474121, 0.786009025972485, -67.8908309936523, -1.18491853275425, 218, 26, 'PPL', 'P'),
(101985, 'Fletcher Mill', 38.6472206115723, 0.674521246416553, -78.206672668457, -1.36496393509403, 218, 53, 'PPL', 'P'),
(193561, 'Fletcher Place', 41.7374992370605, 0.728456783235328, -120.513610839844, -2.1033593026224, 218, 6, 'PPL', 'P'),
(127490, 'Fletchers Landing', 44.6055603027344, 0.778513891979593, -68.3933334350586, -1.1936888548561, 218, 26, 'PPL', 'P'),
(21142, 'Fletcherville', 30.8311100006104, 0.538104381555202, -83.9819412231445, -1.46576138656023, 218, 13, 'PPL', 'P'),
(101986, 'Fletcherville', 38.7511100769043, 0.676334459644733, -77.8152770996094, -1.35813279373993, 218, 53, 'PPL', 'P'),
(87005, 'Flewellyn', 36.4813919067383, 0.636720404482995, -86.9744415283203, -1.51799036975248, 218, 50, 'PPL', 'P'),
(47091, 'Flickersville', 39.4502792358398, 0.688537263496558, -77.7024993896484, -1.35616445137825, 218, 25, 'PPL', 'P'),
(78280, 'Flickerville', 39.8563919067383, 0.695625266737804, -78.2386093139648, -1.36552133471019, 218, 45, 'PPL', 'P'),
(119631, 'Flickerville', 41.2200012207031, 0.719424738977351, -87.9561080932617, -1.53512368346745, 218, 18, 'PPL', 'P'),
(47092, 'Flickerwood', 39.5888900756836, 0.690956479030786, -76.6958312988281, -1.33859477871867, 218, 25, 'PPL', 'P'),
(155285, 'Flicks Corners', 41.0988883972168, 0.717310921441128, -81.0019378662109, -1.41375051626125, 218, 41, 'PPL', 'P'),
(161686, 'Flicksville', 40.8441696166992, 0.712865240054432, -75.2019424438477, -1.31252149954041, 218, 45, 'PPL', 'P'),
(109223, 'Flinderation', 39.297779083252, 0.685875633724105, -80.5124969482422, -1.40520816074871, 218, 58, 'PPL', 'P'),
(35931, 'Flingsville', 38.7733306884766, 0.676722282478476, -84.554443359375, -1.47575343381215, 218, 21, 'PPL', 'P'),
(54785, 'Flinn', 38.9580612182617, 0.67994643845218, -94.5491714477539, -1.65019434679592, 218, 29, 'PPL', 'P'),
(59912, 'Flinn', 34.0461082458496, 0.594216686380467, -88.4291687011719, -1.54338014863697, 218, 30, 'PPL', 'P'),
(109224, 'Flinn', 39.0750007629395, 0.68198741853259, -81.6911087036133, -1.42577881648265, 218, 58, 'PPL', 'P'),
(181600, 'Flinn Springs', 32.8549995422363, 0.573427917753254, -116.851669311523, -2.0394463659377, 218, 6, 'PPL', 'P'),
(81015, 'Flinns Crossroads', 34.3236083984375, 0.599059977717912, -80.0416717529297, -1.39699071088916, 218, 48, 'PPL', 'P'),
(21143, 'Flint', 31.3163890838623, 0.546574099349008, -84.1791687011719, -1.46920365542721, 218, 13, 'PPL', 'P'),
(27179, 'Flint', 38.0633316040039, 0.664330460768283, -88.6272201538086, -1.54683679857384, 218, 18, 'PPL', 'P'),
(35930, 'Flint', 37.0508308410645, 0.646658988776035, -82.9336090087891, -1.447464537765, 218, 21, 'PPL', 'P'),
(47093, 'Flint', 39.6577796936035, 0.692158829683929, -77.4438934326172, -1.35165092596278, 218, 25, 'PPL', 'P'),
(75836, 'Flint', 36.1872215270996, 0.631586162796459, -94.7077789306641, -1.652962569591, 218, 42, 'PPL', 'P'),
(94233, 'Flint', 32.2038917541504, 0.562063943065777, -95.3483276367188, -1.66414225353105, 218, 51, 'PPL', 'P'),
(109226, 'Flint', 38.8536109924316, 0.678123438106994, -79.7302780151367, -1.39155586489459, 218, 58, 'PPL', 'P'),
(122617, 'Flint', 41.6500015258789, 0.726929660087249, -85.1272201538086, -1.48575027475403, 218, 19, 'PPL', 'P'),
(130817, 'Flint', 43.0125007629395, 0.750709757829866, -83.6875, -1.46062241776275, 218, 27, 'PPL', 'P'),
(148855, 'Flint', 41.6372184753418, 0.726706553766928, -74.1369400024414, -1.2939337003961, 218, 40, 'PPL', 'P'),
(155286, 'Flint', 40.1272201538086, 0.700352111356585, -83.0058288574219, -1.44872501190893, 218, 41, 'PPL', 'P'),
(194937, 'Flint', 42.9166717529297, 0.749037226086269, -116.781936645508, -2.03822930131953, 218, 17, 'PPL', 'P'),
(207430, 'Flint', 46.4463882446289, 0.810642400528364, -120.344169616699, -2.10040199538992, 218, 56, 'PPL', 'P'),
(8907, 'Flint (historical)', 36.2236099243164, 0.632221260137415, -94.4680633544922, -1.64877874351849, 218, 4, 'PPL', 'P'),
(2496, 'Flint City', 34.5230598449707, 0.602541062157782, -86.9702835083008, -1.51791779861277, 218, 2, 'PPL', 'P'),
(75837, 'Flint Creek', 36.1772193908691, 0.631411592587004, -94.7405624389648, -1.65353474975121, 218, 42, 'PPL', 'P'),
(2498, 'Flint Hill', 32.9263916015625, 0.574673944248275, -85.9091720581055, -1.49939791007625, 218, 2, 'PPL', 'P'),
(21145, 'Flint Hill', 32.8224983215332, 0.572860664441067, -84.6447219848633, -1.47732909307109, 218, 13, 'PPL', 'P'),
(35932, 'Flint Hill', 37.4983291625977, 0.654469307883937, -85.9905624389648, -1.5008184402017, 218, 21, 'PPL', 'P'),
(47094, 'Flint Hill', 39.3136100769043, 0.686151936687201, -77.3974990844727, -1.35084119183334, 218, 25, 'PPL', 'P'),
(54787, 'Flint Hill', 38.8549995422363, 0.678147672872913, -90.8611068725586, -1.5858254769326, 218, 29, 'PPL', 'P'),
(59913, 'Flint Hill', 33.7161102294922, 0.58845713446998, -88.2755584716797, -1.54069914436758, 218, 30, 'PPL', 'P'),
(64771, 'Flint Hill', 36.1749992370605, 0.631372843593143, -80.4780578613281, -1.40460708529068, 218, 33, 'PPL', 'P'),
(81026, 'Flint Hill', 34.4075012207031, 0.600524183685238, -80.9511108398438, -1.41286341730215, 218, 48, 'PPL', 'P'),
(101990, 'Flint Hill', 38.7627792358398, 0.676538124889097, -78.1002807617188, -1.36310704602398, 218, 53, 'PPL', 'P'),
(155287, 'Flint Hill', 41.0727806091309, 0.716855254578616, -80.6466674804688, -1.40754987829522, 218, 41, 'PPL', 'P'),
(8908, 'Flint Springs', 36.3997192382813, 0.63529494750953, -91.9288864135742, -1.60446174560875, 218, 4, 'PPL', 'P'),
(87007, 'Flint Springs', 35.0344390869141, 0.611466313656046, -84.9061126708984, -1.48189122117645, 218, 50, 'PPL', 'P'),
(112336, 'Flint Springs', 37.3433303833008, 0.651764068848635, -86.7136077880859, -1.5134379621851, 218, 21, 'PPL', 'P'),
(109227, 'Flint Town', 38.7491683959961, 0.676300570919862, -81.4977798461914, -1.42240459138152, 218, 58, 'PPL', 'P'),
(148856, 'Flint Town', 43.3994407653809, 0.757463134880144, -75.440559387207, -1.31668615085308, 218, 40, 'PPL', 'P'),
(87006, 'Flint Valley (historical)', 35.6749992370605, 0.622646197333172, -87.0002822875977, -1.51844137608308, 218, 50, 'PPL', 'P'),
(161687, 'Flintlock Ridge', 40.1944389343262, 0.701525300395793, -76.9622192382813, -1.34324412534973, 218, 45, 'PPL', 'P'),
(21147, 'Flintlook', 33.5886116027832, 0.586231863642137, -84.2283325195313, -1.47006172593043, 218, 13, 'PPL', 'P'),
(161688, 'Flinton', 40.714168548584, 0.710596293384711, -78.5199966430664, -1.3704324700764, 218, 45, 'PPL', 'P'),
(47095, 'Flintridge', 39.2236099243164, 0.684581137697245, -77.0708312988281, -1.34513976341365, 218, 25, 'PPL', 'P'),
(124850, 'Flints Corner', 42.6549987792969, 0.744470171132893, -71.4333267211914, -1.24674674693764, 218, 23, 'PPL', 'P'),
(21148, 'Flintside', 31.954719543457, 0.557715067584704, -83.9544372558594, -1.46528135177374, 218, 13, 'PPL', 'P'),
(21150, 'Flintstone', 34.9416694641113, 0.609847178292305, -85.3436126708984, -1.48952703665393, 218, 13, 'PPL', 'P'),
(47096, 'Flintstone', 39.7030601501465, 0.69294912273741, -78.5680618286133, -1.37127136581978, 218, 25, 'PPL', 'P'),
(35933, 'Flintville', 37.4847183227539, 0.654231753914702, -83.3005599975586, -1.45386904071248, 218, 21, 'PPL', 'P'),
(87008, 'Flintville', 35.0625, 0.611956068980512, -86.4197235107422, -1.5083087139256, 218, 50, 'PPL', 'P'),
(113376, 'Flintville', 44.646671295166, 0.779231414156288, -88.1177825927734, -1.53794543580044, 218, 57, 'PPL', 'P'),
(161689, 'Flintville', 40.3086090087891, 0.703517944102417, -76.329719543457, -1.33220492315719, 218, 45, 'PPL', 'P'),
(47097, 'Flintville (historical)', 39.6944389343262, 0.692798654135821, -76.2416687011719, -1.33066814605016, 218, 25, 'PPL', 'P'),
(21151, 'Flippen', 33.4830589294434, 0.584389621958074, -84.1875, -1.46934906402273, 218, 13, 'PPL', 'P'),
(8910, 'Flippin', 36.2788887023926, 0.633186056821324, -92.5969390869141, -1.61612146433528, 218, 4, 'PPL', 'P'),
(35934, 'Flippin', 36.7202796936035, 0.640889782906596, -85.8741683959961, -1.49878698092219, 218, 21, 'PPL', 'P'),
(87009, 'Flippin', 35.7872200012207, 0.62460481915687, -89.4927825927734, -1.56194371301536, 218, 50, 'PPL', 'P'),
(109228, 'Flipping', 37.3444404602051, 0.651783443345565, -81.26611328125, -1.41836124705651, 218, 58, 'PPL', 'P'),
(2499, 'Flippo Ford', 34.7272186279297, 0.606104305117281, -86.2477798461914, -1.50530773085125, 218, 2, 'PPL', 'P'),
(101994, 'Flippos Corner', 38.151668548584, 0.665872231302357, -77.4322204589844, -1.35144719413939, 218, 53, 'PPL', 'P'),
(209454, 'Flitners Corner', 44.5305595397949, 0.777204881724792, -107.861938476563, -1.88254596399957, 218, 59, 'PPL', 'P'),
(94234, 'Flo', 31.4180603027344, 0.548348596872841, -95.9127807617188, -1.67399381903547, 218, 51, 'PPL', 'P'),
(72565, 'Flockton', 39.3522186279297, 0.686825783022018, -84.4908294677734, -1.47464316195369, 218, 41, 'PPL', 'P'),
(109229, 'Floe', 38.6438903808594, 0.674463122925762, -81.0124969482422, -1.41393480700868, 218, 58, 'PPL', 'P'),
(47098, 'Flohrville', 39.3919410705566, 0.687519070432793, -76.9655609130859, -1.3433024485776, 218, 25, 'PPL', 'P'),
(135382, 'Flom', 47.1661109924316, 0.823203932179022, -96.1305618286133, -1.67779481570128, 218, 28, 'PPL', 'P'),
(2503, 'Flomaton', 31, 0.541052068118242, -87.2608337402344, -1.52298885680245, 218, 2, 'PPL', 'P'),
(191468, 'Flomot', 34.2269401550293, 0.59737279858832, -100.988609313965, -1.7625837395389, 218, 51, 'PPL', 'P'),
(181601, 'Flonellis', 38.5694389343262, 0.673163700050885, -120.963607788086, -2.11121323099316, 218, 6, 'PPL', 'P'),
(101991, 'Flood', 37.2922210693359, 0.650872043041513, -78.73388671875, -1.37416555613442, 218, 53, 'PPL', 'P'),
(196490, 'Flood (historical)', 47.4491691589355, 0.828144229159174, -111.341667175293, -1.94327868686856, 218, 31, 'PPL', 'P'),
(64772, 'Floods Chapel', 35.8661117553711, 0.625981740019469, -78.100830078125, -1.3631166334039, 218, 33, 'PPL', 'P'),
(8911, 'Floodway', 35.7786102294922, 0.624454550292363, -90.1780624389648, -1.57390410262896, 218, 4, 'PPL', 'P'),
(130818, 'Floodwood', 46.2227783203125, 0.806739671108907, -88.0091705322266, -1.53604979773652, 218, 27, 'PPL', 'P'),
(135384, 'Floodwood', 46.9291687011719, 0.81906850905932, -92.9194412231445, -1.62175018845722, 218, 28, 'PPL', 'P'),
(148857, 'Floodwood', 44.333610534668, 0.7737674731268, -74.4066696166992, -1.29864137025503, 218, 40, 'PPL', 'P'),
(47108, 'Flook Farm', 39.5175018310547, 0.689710519114792, -77.5780563354492, -1.35399251035124, 218, 25, 'PPL', 'P'),
(94235, 'Flor del Rio Colonia', 26.4009990692139, 0.46078435957374, -98.9010009765625, -1.72614810055914, 218, 51, 'PPL', 'P'),
(27181, 'Flora', 38.6688919067383, 0.674899481870371, -88.4855575561523, -1.54436431981781, 218, 18, 'PPL', 'P'),
(40924, 'Flora', 31.6122207641602, 0.551737336201913, -93.0975036621094, -1.62485796429129, 218, 22, 'PPL', 'P'),
(59914, 'Flora', 32.5430603027344, 0.567983550957777, -90.3091735839844, -1.57619242379562, 218, 30, 'PPL', 'P'),
(72566, 'Flora', 39.1647186279297, 0.683553290674529, -81.9783325195313, -1.43079181776056, 218, 41, 'PPL', 'P'),
(75838, 'Flora', 34.5258293151855, 0.602589398531567, -96.0316696166992, -1.6760688209988, 218, 42, 'PPL', 'P'),
(94236, 'Flora', 33.2544403076172, 0.580399474275836, -95.4330596923828, -1.66562110688437, 218, 51, 'PPL', 'P'),
(122621, 'Flora', 40.5472183227539, 0.707682462257028, -86.5244369506836, -1.51013630822367, 218, 19, 'PPL', 'P'),
(140023, 'Flora', 47.9502792358398, 0.836890249916076, -99.4175033569336, -1.73516276769101, 218, 34, 'PPL', 'P'),
(161695, 'Flora', 40.892219543457, 0.713703869481698, -78.871940612793, -1.37657505113067, 218, 45, 'PPL', 'P'),
(200828, 'Flora', 45.9002799987793, 0.801111013565998, -117.308891296387, -2.04742639498607, 218, 43, 'PPL', 'P'),
(109233, 'Flora (historical)', 39.0705604553223, 0.681909920544868, -79.92138671875, -1.39489134100185, 218, 58, 'PPL', 'P'),
(94237, 'Flora Colonia', 26.1749992370605, 0.45683991839371, -98.015998840332, -1.71070189939474, 218, 51, 'PPL', 'P'),
(174115, 'Flora Fountain', 42.8319396972656, 0.747558372732948, -90.8397216796875, -1.58545223490582, 218, 57, 'PPL', 'P'),
(16034, 'Flora Heights', 28.767219543457, 0.502082697677385, -81.2655563354492, -1.41835152651853, 218, 12, 'PPL', 'P'),
(188553, 'Flora Vista', 36.7944412231445, 0.642184145775402, -108.079719543457, -1.88634696066539, 218, 38, 'PPL', 'P'),
(78278, 'Floradale', 39.958610534668, 0.697409318352048, -77.2486114501953, -1.3482426123997, 218, 45, 'PPL', 'P'),
(16035, 'Florahome', 29.7325000762939, 0.518930021180795, -81.8836135864258, -1.42913866051389, 218, 12, 'PPL', 'P'),
(8912, 'Floral', 35.5872192382813, 0.621114147337076, -91.7569427490234, -1.6014607625344, 218, 4, 'PPL', 'P'),
(32451, 'Floral', 37.3527793884277, 0.651928985099138, -96.9205627441406, -1.691582932771, 218, 20, 'PPL', 'P'),
(35936, 'Floral', 37.7866706848145, 0.659501816816833, -86.8108291625977, -1.51513479527364, 218, 21, 'PPL', 'P'),
(16036, 'Floral Bluff', 30.3427791595459, 0.529581400539594, -81.6080627441406, -1.42432939105937, 218, 12, 'PPL', 'P'),
(16037, 'Floral City', 28.749719619751, 0.501777266389867, -82.2969436645508, -1.4363526312747, 218, 12, 'PPL', 'P'),
(64773, 'Floral College', 34.7783317565918, 0.60699639750343, -79.3186111450195, -1.38437092258966, 218, 33, 'PPL', 'P'),
(2500, 'Floral Crest', 34.8736114501953, 0.608659341867103, -85.5902786254883, -1.4938321697141, 218, 2, 'PPL', 'P'),
(21152, 'Floral Hill', 33.8338890075684, 0.590512761936385, -82.6252822875977, -1.44208322130833, 218, 13, 'PPL', 'P'),
(145234, 'Floral Hill', 40.7294387817383, 0.710862809230801, -74.4063873291016, -1.29863644340701, 218, 37, 'PPL', 'P'),
(113441, 'Floral Park', 41.3211097717285, 0.721189416094665, -72.3597183227539, -1.26291533054772, 218, 8, 'PPL', 'P'),
(148858, 'Floral Park', 40.7236099243164, 0.71076107647716, -73.7052764892578, -1.28639975083032, 218, 40, 'PPL', 'P'),
(196491, 'Floral Park', 45.9861106872559, 0.802609041679167, -112.492782592773, -1.96336944097406, 218, 31, 'PPL', 'P'),
(2501, 'Florala', 31.0049991607666, 0.541139319933456, -86.3280563354492, -1.50670881990074, 218, 2, 'PPL', 'P'),
(87010, 'Floraton', 35.7922210693359, 0.624692104261598, -86.2569427490234, -1.50546765367471, 218, 50, 'PPL', 'P'),
(27182, 'Floraville', 38.3763885498047, 0.669794335218744, -90.0561065673828, -1.57177557112772, 218, 18, 'PPL', 'P'),
(54788, 'Flordell Hills', 38.7174987792969, 0.675747831835616, -90.2655563354492, -1.57543115919802, 218, 29, 'PPL', 'P'),
(101992, 'Flordon', 38.0558280944824, 0.664199499821678, -78.5566711425781, -1.3710725608444, 218, 53, 'PPL', 'P'),
(161690, 'Floreffe', 40.2574996948242, 0.702625918295295, -79.9199981689453, -1.39486710623594, 218, 45, 'PPL', 'P'),
(2502, 'Florence', 34.7997207641602, 0.607369706109232, -87.6772232055664, -1.53025622394311, 218, 2, 'PPL', 'P'),
(8913, 'Florence', 33.7655601501465, 0.589320198400247, -91.6455612182617, -1.59951678809669, 218, 4, 'PPL', 'P'),
(13775, 'Florence', 39.0833282470703, 0.682132760549081, -75.4638900756836, -1.31709334818375, 218, 10, 'PPL', 'P'),
(16039, 'Florence', 29.9899997711182, 0.523424238678358, -81.5774993896484, -1.42379595989303, 218, 12, 'PPL', 'P'),
(21154, 'Florence', 32.0911102294922, 0.560095534125072, -85.0411071777344, -1.48424731979285, 218, 13, 'PPL', 'P'),
(29811, 'Florence', 38.7841682434082, 0.676911433494899, -84.9244384765625, -1.48221106682337, 218, 19, 'PPL', 'P'),
(32452, 'Florence', 38.2444381713867, 0.667491366666098, -96.9277801513672, -1.69170890029057, 218, 20, 'PPL', 'P'),
(35935, 'Florence', 38.9988899230957, 0.680659033780858, -84.6266708374023, -1.47701404111414, 218, 21, 'PPL', 'P'),
(40925, 'Florence', 29.7875003814697, 0.519889957595714, -91.7236099243164, -1.60087899499427, 218, 22, 'PPL', 'P'),
(47099, 'Florence', 39.3102798461914, 0.68609381319641, -77.10888671875, -1.34580395578951, 218, 25, 'PPL', 'P'),
(54789, 'Florence', 38.5888900756836, 0.673503186510843, -92.978889465332, -1.62278775601791, 218, 29, 'PPL', 'P'),
(59915, 'Florence', 32.1533317565918, 0.561181504638579, -90.1311111450195, -1.57308464796155, 218, 30, 'PPL', 'P'),
(64775, 'Florence', 35.1441688537598, 0.613381459374949, -76.6313934326172, -1.33747012579033, 218, 33, 'PPL', 'P'),
(81017, 'Florence', 34.1952781677246, 0.596820192662128, -79.7627792358398, -1.39212311820677, 218, 48, 'PPL', 'P'),
(87011, 'Florence', 35.9186096191406, 0.62689800059251, -86.4683303833008, -1.50915706389085, 218, 50, 'PPL', 'P'),
(94238, 'Florence', 30.8411102294922, 0.538278918475143, -97.793327331543, -1.70681554841599, 218, 51, 'PPL', 'P'),
(115579, 'Florence', 42.7024993896484, 0.745299213180234, -93.8183288574219, -1.63743873728082, 218, 16, 'PPL', 'P'),
(119634, 'Florence', 42.2144393920898, 0.736780959275561, -89.6597213745117, -1.56485734440597, 218, 18, 'PPL', 'P'),
(124852, 'Florence', 42.3355598449707, 0.738894909969839, -72.6722183227539, -1.26836948446021, 218, 23, 'PPL', 'P'),
(135387, 'Florence', 44.2372207641602, 0.772085154266197, -96.0516662597656, -1.67641782825966, 218, 28, 'PPL', 'P'),
(145235, 'Florence', 40.1194381713867, 0.700216290140991, -74.8058319091797, -1.30560806650862, 218, 37, 'PPL', 'P'),
(148859, 'Florence', 43.4383316040039, 0.758141908062978, -75.7497177124023, -1.32208198153769, 218, 40, 'PPL', 'P'),
(155289, 'Florence', 41.3233299255371, 0.721228165088526, -82.4138870239258, -1.43839367793414, 218, 41, 'PPL', 'P'),
(161691, 'Florence', 40.4322204589844, 0.70567537090149, -80.4338912963867, -1.40383623331316, 218, 45, 'PPL', 'P'),
(170306, 'Florence', 45.0547218322754, 0.786353239543378, -97.3294372558594, -1.69871913922798, 218, 49, 'PPL', 'P'),
(172024, 'Florence', 43.7163887023926, 0.762994919938402, -73.0619430541992, -1.27517146420038, 218, 55, 'PPL', 'P'),
(174116, 'Florence', 45.9222183227539, 0.801493909551724, -88.2516708374023, -1.54028222649893, 218, 57, 'PPL', 'P'),
(178190, 'Florence', 33.0313911437988, 0.576506531973385, -111.386672973633, -1.94406418623208, 218, 5, 'PPL', 'P'),
(181602, 'Florence', 33.9744415283203, 0.592965866195484, -118.247222900391, -2.06380337095146, 218, 6, 'PPL', 'P'),
(186714, 'Florence', 38.3902816772461, 0.670036816035995, -105.118057250977, -1.83465620232944, 218, 7, 'PPL', 'P'),
(194938, 'Florence', 45.5011100769043, 0.79414418415435, -116.027496337891, -2.02506183394185, 218, 17, 'PPL', 'P'),
(196492, 'Florence', 46.6316719055176, 0.81387621046102, -114.078056335449, -1.99103768732917, 218, 31, 'PPL', 'P'),
(200829, 'Florence', 43.982780456543, 0.76764433314849, -124.098609924316, -2.16592934032743, 218, 43, 'PPL', 'P'),
(207431, 'Florence', 48.2208290100098, 0.841612234265868, -122.330558776855, -2.13507102646058, 218, 56, 'PPL', 'P'),
(109231, 'Florence (historical)', 38.6427803039551, 0.674443748428831, -80.2147216796875, -1.40001100188142, 218, 58, 'PPL', 'P'),
(202132, 'Florence (historical)', 44.1358299255371, 0.770315550300866, -103.779716491699, -1.81129774956641, 218, 49, 'PPL', 'P'),
(47100, 'Florence Estates', 39.3138885498047, 0.68615679695619, -77.1399993896484, -1.34634697433578, 218, 25, 'PPL', 'P'),
(47101, 'Florence Farms', 39.2966690063477, 0.685856259227175, -77.1180572509766, -1.34596401177103, 218, 25, 'PPL', 'P'),
(94239, 'Florence Hill', 32.6730613708496, 0.570252497627498, -97.0149993896484, -1.69323116316965, 218, 51, 'PPL', 'P'),
(148868, 'Florence Hill', 43.4230613708496, 0.757875392216888, -75.793327331543, -1.32284311297723, 218, 40, 'PPL', 'P'),
(190209, 'Florence Hill', 37.7077789306641, 0.658124895954235, -117.217781066895, -2.04583622149918, 218, 39, 'PPL', 'P'),
(178191, 'Florence Junction', 33.2594413757324, 0.580486759380563, -111.336387634277, -1.94318654149484, 218, 5, 'PPL', 'P'),
(40926, 'Florence Landing', 29.9194393157959, 0.522192726411278, -92.5130615234375, -1.61465752468407, 218, 22, 'PPL', 'P'),
(47102, 'Florence Manor', 39.3219413757324, 0.686297345282719, -77.1194381713867, -1.34598811337889, 218, 25, 'PPL', 'P'),
(145236, 'Florence Station', 40.1083297729492, 0.700022412013634, -74.7844390869141, -1.30523469132379, 218, 37, 'PPL', 'P'),
(64776, 'Florence Town', 36.0774993896484, 0.62967115023561, -79.3166732788086, -1.38433710044382, 218, 33, 'PPL', 'P'),
(16040, 'Florence Villa', 28.0433292388916, 0.489448428439454, -81.7169418334961, -1.4262296896552, 218, 12, 'PPL', 'P'),
(115581, 'Florenceville', 43.4991683959961, 0.759203710389592, -92.1324996948242, -1.60801546776735, 218, 16, 'PPL', 'P'),
(191469, 'Florentino Ramos Colonia', 28.6240005493164, 0.499583054678237, -100.438003540039, -1.7529738559034, 218, 51, 'PPL', 'P'),
(94240, 'Florentino Sosa Colonia', 26.4020004272461, 0.460801836568394, -98.984001159668, -1.72759672703409, 218, 51, 'PPL', 'P'),
(40927, 'Florenville', 30.416389465332, 0.530866142738962, -89.831672668457, -1.56785846063838, 218, 22, 'PPL', 'P'),
(178192, 'Flores', 34.0625, 0.594502776460568, -112.820831298828, -1.96909497100162, 218, 5, 'PPL', 'P'),
(94241, 'Flores Addition Colonia', 26.9120006561279, 0.469703019748307, -99.2610015869141, -1.73243129651897, 218, 51, 'PPL', 'P'),
(94242, 'Flores Brothers Colonia', 26.2800006866455, 0.458672539408335, -98.6470031738281, -1.7217150026086, 218, 51, 'PPL', 'P'),
(16041, 'Floresta', 26.353609085083, 0.459957248318189, -80.1025009155273, -1.39805238005772, 218, 12, 'PPL', 'P'),
(186715, 'Floresta', 38.8419418334961, 0.67791977286263, -107.122222900391, -1.86963549166709, 218, 7, 'PPL', 'P'),
(94243, 'Floresta Colonia', 26.3360004425049, 0.459649919528394, -98.1849975585938, -1.71365148346005, 218, 51, 'PPL', 'P'),
(16042, 'Floresta Estates', 26.2988891601563, 0.459002205461773, -80.0875015258789, -1.39779059132257, 218, 12, 'PPL', 'P'),
(94244, 'Floresville', 29.1333293914795, 0.508472519949353, -98.1558303833008, -1.71314242021769, 218, 51, 'PPL', 'P'),
(2504, 'Florette', 34.416389465332, 0.600679312818735, -86.7030563354492, -1.51325380459572, 218, 2, 'PPL', 'P'),
(191470, 'Florey', 32.4527816772461, 0.566407891698832, -102.58943939209, -1.79052349516714, 218, 51, 'PPL', 'P'),
(145238, 'Florham Park', 40.7877807617188, 0.711881068873593, -74.3886108398438, -1.29832618514002, 218, 37, 'PPL', 'P'),
(135390, 'Florian', 48.4422187805176, 0.845476214691464, -96.6277770996094, -1.68647285927136, 218, 28, 'PPL', 'P'),
(203985, 'Floribunda Heights', 40.6622200012207, 0.709689620191594, -111.809997558594, -1.95145259404428, 218, 52, 'PPL', 'P'),
(81019, 'Floricane (historical)', 33.4269409179688, 0.583410177888171, -79.8688888549805, -1.39397508042881, 218, 48, 'PPL', 'P'),
(119637, 'Florid', 41.2286109924316, 0.719575007841859, -89.2808303833008, -1.55824444910319, 218, 18, 'PPL', 'P'),
(16048, 'Florida', 28.750280380249, 0.501787053506873, -82.5002822875977, -1.43990155974334, 218, 12, 'ADM1', 'A'),
(54790, 'Florida', 39.4930610656738, 0.689283947287189, -91.7869415283203, -1.60198434000471, 218, 29, 'PPL', 'P'),
(113242, 'Florida', 41.3219413757324, 0.721203930322606, -84.2044372558594, -1.46964467490373, 218, 41, 'PPL', 'P'),
(122620, 'Florida', 40.1602783203125, 0.700929085206751, -85.7102813720703, -1.49592661275339, 218, 19, 'PPL', 'P'),
(124851, 'Florida', 42.6666717529297, 0.744673902956284, -73.0116729736328, -1.27429408577925, 218, 23, 'PPL', 'P'),
(148861, 'Florida', 41.3316688537598, 0.721373706842099, -74.3572235107422, -1.29777837290379, 218, 40, 'PPL', 'P'),
(186716, 'Florida', 37.2150001525879, 0.649524283792851, -107.751937866211, -1.88062609116973, 218, 7, 'PPL', 'P'),
(188555, 'Florida', 32.415828704834, 0.565762940661842, -107.576110839844, -1.87755733064564, 218, 38, 'PPL', 'P'),
(16043, 'Florida Beach', 30.2008304595947, 0.52710392835652, -85.8513870239258, -1.49838937097144, 218, 12, 'PPL', 'P'),
(16044, 'Florida City', 25.4475002288818, 0.444142665395999, -80.4794387817383, -1.40463118689855, 218, 12, 'PPL', 'P'),
(16045, 'Florida Gardens', 26.6088905334473, 0.464412750111405, -80.1705627441406, -1.39924028306195, 218, 12, 'PPL', 'P'),
(16046, 'Florida Hills', 28.9463901519775, 0.50520981471887, -81.4255599975586, -1.42114411723758, 218, 12, 'PPL', 'P'),
(21155, 'Florida Junction', 32.0702781677246, 0.559731946057249, -81.1297225952148, -1.41598078051614, 218, 13, 'PPL', 'P'),
(78279, 'Florida Park', 39.9780616760254, 0.697748804812006, -75.4297180175781, -1.31649693325763, 218, 45, 'PPL', 'P'),
(16047, 'Florida Ridge', 27.5799999237061, 0.481361806368456, -80.3869400024414, -1.40301677864574, 218, 12, 'PPL', 'P'),
(16049, 'Floridale', 30.6813907623291, 0.535491287893616, -86.8369369506836, -1.51559046213615, 218, 12, 'PPL', 'P'),
(16050, 'Floridana Beach', 27.9461097717285, 0.487751628640424, -80.4958267211914, -1.40491721039962, 218, 12, 'PPL', 'P'),
(16051, 'Floridatown', 30.5811100006104, 0.533741058425216, -87.1547164916992, -1.52113676142235, 218, 12, 'PPL', 'P'),
(148863, 'Floridaville', 43.2386093139648, 0.754656096512173, -76.4875030517578, -1.33495876488238, 218, 40, 'PPL', 'P'),
(40929, 'Florien', 31.4436092376709, 0.548794509907861, -93.4572219848633, -1.63113623340309, 218, 22, 'PPL', 'P'),
(161692, 'Florin', 40.1083297729492, 0.700022412013634, -76.533332824707, -1.33575864531579, 218, 45, 'PPL', 'P'),
(181603, 'Florin', 38.4961090087891, 0.67188385141002, -121.407783508301, -2.11896555976832, 218, 6, 'PPL', 'P'),
(101993, 'Floris', 38.936939239502, 0.679577790378286, -77.4130630493164, -1.35111283426453, 218, 53, 'PPL', 'P'),
(115582, 'Floris', 40.8650016784668, 0.713228828122255, -92.3327789306641, -1.61151099985614, 218, 16, 'PPL', 'P'),
(190972, 'Floris', 36.8697204589844, 0.643498016299192, -100.710830688477, -1.75773558793246, 218, 42, 'PPL', 'P'),
(54791, 'Florissant', 38.7891693115234, 0.676998718599626, -90.3225021362305, -1.57642505091683, 218, 29, 'PPL', 'P'),
(186717, 'Florissant', 38.9458312988281, 0.67973298609081, -105.288887023926, -1.83763774432784, 218, 7, 'PPL', 'P'),
(181604, 'Floriston', 39.394718170166, 0.687567539964633, -120.020278930664, -2.09474903650207, 218, 6, 'PPL', 'P'),
(16052, 'Floritan', 27.9030609130859, 0.487000284317885, -81.6247177124023, -1.42462007509235, 218, 12, 'PPL', 'P'),
(35937, 'Florress', 37.8852806091309, 0.661222884671296, -83.1772232055664, -1.45171640760337, 218, 21, 'PPL', 'P'),
(54793, 'Flory (historical)', 37.5663909912109, 0.655657210888167, -94.0572204589844, -1.64160818228345, 218, 29, 'PPL', 'P'),
(161693, 'Florys Mill', 40.0813903808594, 0.69955223092318, -76.350830078125, -1.332573371494, 218, 45, 'PPL', 'P'),
(181605, 'Flosden (historical)', 38.1452789306641, 0.66576071143171, -122.250831604004, -2.13367952479101, 218, 6, 'PPL', 'P'),
(181606, 'Flosden Acres', 38.1363906860352, 0.665605582298213, -122.251106262207, -2.13368431848097, 218, 6, 'PPL', 'P'),
(8914, 'Floss', 35.7949981689453, 0.624740573793437, -94.3608322143555, -1.64690720706243, 218, 4, 'PPL', 'P'),
(119638, 'Flossmoor', 41.542781829834, 0.725058323368278, -87.6847229003906, -1.53038711831069, 218, 18, 'PPL', 'P'),
(119639, 'Flossmoor Highlands', 41.5461082458496, 0.725116380280041, -87.7133331298828, -1.53088646101508, 218, 18, 'PPL', 'P'),
(94245, 'Flour Bluff', 27.6736106872559, 0.482995622407706, -97.2786102294922, -1.69783204026888, 218, 51, 'PPL', 'P'),
(94246, 'Flour Bluff Junction', 27.7849998474121, 0.484939730003463, -97.4925003051758, -1.70156512632689, 218, 51, 'PPL', 'P'),
(193560, 'Flourney', 41.2350006103516, 0.719686527712506, -120.297218322754, -2.09958254072251, 218, 6, 'PPL', 'P'),
(35938, 'Flournoy', 37.6955604553223, 0.657911643329946, -87.8613891601563, -1.53347052622078, 218, 21, 'PPL', 'P'),
(112372, 'Flournoy', 32.4491691589355, 0.566344841360025, -93.9000015258789, -1.63886419425429, 218, 22, 'PPL', 'P'),
(181607, 'Flournoy', 39.9205589294434, 0.696745192555209, -122.434997558594, -2.13689382706868, 218, 6, 'PPL', 'P'),
(2505, 'Flournoys', 32.3697204589844, 0.564958199959447, -85.0077819824219, -1.48366568541077, 218, 2, 'PPL', 'P'),
(161694, 'Flourtown', 40.103328704834, 0.699935126908906, -75.2127838134766, -1.31271071713586, 218, 45, 'PPL', 'P'),
(87012, 'Flourville', 36.3916702270508, 0.635154465762029, -82.3944396972656, -1.43805425805321, 218, 50, 'PPL', 'P'),
(21156, 'Flovilla', 33.2536087036133, 0.580384960047895, -83.8986129760742, -1.46430703428893, 218, 13, 'PPL', 'P'),
(192570, 'Flowell', 38.9791717529297, 0.680314886788993, -112.427780151367, -1.96223493434969, 218, 52, 'PPL', 'P'),
(94247, 'Flowella', 27.2161102294922, 0.475010733090348, -98.0641708374023, -1.71154265935088, 218, 51, 'PPL', 'P'),
(109232, 'Flower', 38.8313903808594, 0.677735615273251, -80.7733306884766, -1.40976056831609, 218, 58, 'PPL', 'P'),
(191472, 'Flower Grove', 32.4986114501953, 0.567207772132237, -101.814437866211, -1.77699716683257, 218, 51, 'PPL', 'P'),
(2506, 'Flower Hill', 34.6802787780762, 0.605285050186945, -87.1561126708984, -1.52116112934633, 218, 2, 'PPL', 'P'),
(40930, 'Flower Hill', 30.8816699981689, 0.538986819982399, -91.4166717529297, -1.59552191330352, 218, 22, 'PPL', 'P'),
(47103, 'Flower Hill', 39.1588897705078, 0.683451557920888, -77.1725006103516, -1.34691422764797, 218, 25, 'PPL', 'P'),
(94248, 'Flower Hill', 29.9650001525879, 0.522987913023262, -97.1313934326172, -1.69526262244917, 218, 51, 'PPL', 'P'),
(148864, 'Flower Hill', 40.8072204589844, 0.712220355596469, -73.6816711425781, -1.28598775980968, 218, 40, 'PPL', 'P'),
(94249, 'Flower Mound', 33.0144386291504, 0.576210654776278, -97.0966720581055, -1.69465662014312, 218, 51, 'PPL', 'P'),
(178193, 'Flower Pot', 34.5033302307129, 0.602196715428835, -111.970001220703, -1.95424518476334, 218, 5, 'PPL', 'P'),
(59916, 'Flowerdale', 34.2849998474121, 0.598386131383095, -88.7375030517578, -1.54876159825169, 218, 30, 'PPL', 'P'),
(59919, 'Floweree', 32.5441703796387, 0.568002925454708, -90.8499984741211, -1.58563159880524, 218, 30, 'PPL', 'P'),
(196493, 'Floweree', 47.7297210693359, 0.833040783718421, -111.026672363281, -1.93778099027225, 218, 31, 'PPL', 'P'),
(119640, 'Flowerfield', 41.8672218322754, 0.730720869636059, -88.0338897705078, -1.53648122983312, 218, 18, 'PPL', 'P'),
(130820, 'Flowerfield', 42.0658302307129, 0.734187240110906, -85.6580581665039, -1.49501514587031, 218, 27, 'PPL', 'P'),
(59918, 'Flowers', 32.3891716003418, 0.565297686419405, -90.6738891601563, -1.58255791143312, 218, 30, 'PPL', 'P'),
(64777, 'Flowers', 35.6536102294922, 0.62227288872737, -78.3452835083008, -1.36738315062826, 218, 33, 'PPL', 'P'),
(148865, 'Flowers', 42.0436096191406, 0.733799417277163, -75.6888885498047, -1.32102031236913, 218, 40, 'PPL', 'P'),
(193066, 'Flowers Camp', 38.6647186279297, 0.674826644414557, -116.917221069336, -2.040590459942, 218, 39, 'PPL', 'P'),
(64778, 'Flowers Corner', 34.1624984741211, 0.596248079080952, -78.2080612182617, -1.36498816985995, 218, 33, 'PPL', 'P'),
(21158, 'Flowers Crossing', 33.9049987792969, 0.591753861583389, -84.0311126708984, -1.4666195902215, 218, 13, 'PPL', 'P'),
(21157, 'Flowers Estates', 33.7249984741211, 0.588612263603477, -84.6680603027344, -1.47773642355982, 218, 13, 'PPL', 'P'),
(47104, 'Flowers of the Forest', 38.2416687011719, 0.667443030292313, -76.4580612182617, -1.33444490795005, 218, 25, 'PPL', 'P'),
(16053, 'Flowersville', 30.9536094665527, 0.540242400567831, -86.3383331298828, -1.50688818380016, 218, 12, 'PPL', 'P'),
(87013, 'Flowertown', 35.3938903808594, 0.617739922235946, -86.2422180175781, -1.50521065862952, 218, 50, 'PPL', 'P'),
(81022, 'Flowertown Village', 32.9941711425781, 0.575856920404488, -80.2236099243164, -1.40016613101492, 218, 48, 'PPL', 'P'),
(47105, 'Flowerwood Estates', 39.413330078125, 0.687892379038595, -77.103889465332, -1.34571673726381, 218, 25, 'PPL', 'P'),
(21161, 'Flowery Branch', 34.185001373291, 0.596640828762711, -83.9252777099609, -1.46477242168943, 218, 13, 'PPL', 'P'),
(190210, 'Flowery City (historical)', 39.3161087036133, 0.686195545950051, -119.592498779297, -2.08728286438603, 218, 39, 'PPL', 'P'),
(40931, 'Flowery Mound (historical)', 31.4291706085205, 0.548542508289713, -91.7641677856445, -1.60158686321201, 218, 22, 'PPL', 'P'),
(161696, 'Flowing Spring', 40.4722213745117, 0.706373518581255, -78.2683334350586, -1.36604011849054, 218, 45, 'PPL', 'P'),
(178194, 'Flowing Springs', 34.3152809143066, 0.598914635701421, -111.333892822266, -1.94314299881102, 218, 5, 'PPL', 'P'),
(178195, 'Flowing Wells', 32.2938919067383, 0.563634742055733, -111.009170532227, -1.93747552569522, 218, 5, 'PPL', 'P'),
(59921, 'Flowood', 32.309440612793, 0.563906118170812, -90.1388931274414, -1.57322046917714, 218, 30, 'PPL', 'P'),
(64779, 'Flows Store', 35.2988891601563, 0.616081838141263, -80.5577774047852, -1.40599845380219, 218, 33, 'PPL', 'P'),
(94250, 'Floy', 29.7827796936035, 0.519807566049489, -97.0988922119141, -1.69469536913698, 218, 51, 'PPL', 'P'),
(192571, 'Floy', 38.9244384765625, 0.679359610905981, -109.935279846191, -1.91873259741741, 218, 52, 'PPL', 'P'),
(2507, 'Floy (historical)', 34.3800010681152, 0.600044215477778, -85.9266662597656, -1.49970324149523, 218, 2, 'PPL', 'P'),
(2508, 'Floyd', 32.5999984741211, 0.568977309518541, -86.017219543457, -1.50128369444414, 218, 2, 'PPL', 'P'),
(8915, 'Floyd', 35.1947212219238, 0.614263764644093, -91.9674987792969, -1.6051356585226, 218, 4, 'PPL', 'P'),
(21159, 'Floyd', 33.8469390869141, 0.590740528788614, -84.585563659668, -1.47629658551647, 218, 13, 'PPL', 'P'),
(35939, 'Floyd', 37.2508316040039, 0.650149660595829, -84.6524963378906, -1.47746478112863, 218, 21, 'PPL', 'P'),
(40932, 'Floyd', 32.6775016784668, 0.570329995615219, -91.4058303833008, -1.59533269570807, 218, 22, 'PPL', 'P'),
(47106, 'Floyd', 39.5041694641113, 0.689477825414547, -79.1558303833008, -1.38152986233876, 218, 25, 'PPL', 'P'),
(54795, 'Floyd', 37.9541702270508, 0.66242523532444, -90.9486083984375, -1.5873526666597, 218, 29, 'PPL', 'P'),
(59920, 'Floyd', 33.2558288574219, 0.580423709041756, -90.7319412231445, -1.58357111106984, 218, 30, 'PPL', 'P'),
(81023, 'Floyd', 34.3708305358887, 0.599884159496264, -79.9038925170898, -1.39458600958288, 218, 48, 'PPL', 'P'),
(94251, 'Floyd', 33.148609161377, 0.578552372322784, -96.2447204589844, -1.67978725967083, 218, 51, 'PPL', 'P'),
(101995, 'Floyd', 36.9111099243164, 0.644220398744876, -80.3202819824219, -1.40185337672354, 218, 53, 'PPL', 'P'),
(115583, 'Floyd', 43.1277809143066, 0.752721776033421, -92.7361068725586, -1.61855040040749, 218, 16, 'PPL', 'P'),
(130822, 'Floyd', 43.589168548584, 0.760774509379548, -84.4091720581055, -1.47321797129634, 218, 27, 'PPL', 'P'),
(148866, 'Floyd', 43.2197189331055, 0.754326397169221, -75.334716796875, -1.31483884916295, 218, 40, 'PPL', 'P'),
(181608, 'Floyd', 36.7350006103516, 0.641146711372761, -119.991943359375, -2.09425448748764, 218, 6, 'PPL', 'P'),
(188556, 'Floyd', 34.214168548584, 0.59714989200508, -103.580001831055, -1.80781207117366, 218, 38, 'PPL', 'P'),
(115585, 'Floyd Crossing', 43.0911102294922, 0.752081751844448, -92.741943359375, -1.61865226631918, 218, 16, 'PPL', 'P'),
(40933, 'Floyd Landing', 32.6794395446777, 0.570363817761063, -91.4030609130859, -1.59528435933428, 218, 22, 'PPL', 'P'),
(21163, 'Floyd Springs', 34.4266700744629, 0.600858743297179, -85.1549987792969, -1.48623510323048, 218, 13, 'PPL', 'P'),
(191474, 'Floydada', 33.9844398498535, 0.593140369825911, -101.337219238281, -1.76866813052335, 218, 51, 'PPL', 'P'),
(81024, 'Floydale', 34.3236083984375, 0.599059977717912, -79.3363876342773, -1.38468118085665, 218, 48, 'PPL', 'P'),
(81025, 'Floyds Crossroads', 34.2144393920898, 0.597154619116015, -79.107780456543, -1.3806912329115, 218, 48, 'PPL', 'P'),
(29815, 'Floyds Knobs', 38.3244400024414, 0.668887662025626, -85.8736114501953, -1.49877726038421, 218, 19, 'PPL', 'P'),
(35941, 'Floydsburg', 38.3111114501953, 0.668655034904408, -85.459716796875, -1.49155343592737, 218, 21, 'PPL', 'P'),
(21164, 'Floydtown (historical)', 31.1336097717285, 0.543383998547743, -84.767219543457, -1.47946707879421, 218, 13, 'PPL', 'P'),
(113442, 'Floydville', 41.9286117553711, 0.731792325921625, -72.7802810668945, -1.2702555351442, 218, 8, 'PPL', 'P'),
(64780, 'Floytan Crossroads', 36.2561111450195, 0.632788513449602, -78.4613876342773, -1.3694095499017, 218, 33, 'PPL', 'P'),
(59922, 'Floyton (historical)', 34.0050010681152, 0.593499230782799, -88.3841705322266, -1.5425947824315, 218, 30, 'PPL', 'P'),
(87014, 'Floyville (historical)', 35.7999992370605, 0.624827858898165, -88.4499969482422, -1.54374367012576, 218, 50, 'PPL', 'P'),
(54796, 'Flucom', 38.1011085510254, 0.664989792875159, -90.442497253418, -1.57851936079807, 218, 29, 'PPL', 'P'),
(16054, 'Fluffy Landing', 30.4308300018311, 0.531118177646624, -86.1361083984375, -1.50335869640747, 218, 12, 'PPL', 'P'),
(94254, 'Flugrath', 30.1027793884277, 0.525392614329549, -98.5194396972656, -1.71948859993729, 218, 51, 'PPL', 'P'),
(115590, 'Flugstad (historical)', 42.4716682434082, 0.74127044966219, -93.9369430541992, -1.63950894555419, 218, 16, 'PPL', 'P'),
(181609, 'Fluhr', 37.3627815246582, 0.652103555308593, -120.576667785645, -2.10445985394288, 218, 6, 'PPL', 'P'),
(181610, 'Fluhr (historical)', 34.9430618286133, 0.609871479637252, -117.949996948242, -2.05861579946409, 218, 6, 'PPL', 'P'),
(40935, 'Fluker', 30.8213901519775, 0.537934738193764, -90.5108337402344, -1.57971205749226, 218, 22, 'PPL', 'P'),
(181611, 'Flumeville', 38.9294395446777, 0.679446896010709, -123.708610534668, -2.1591225668973, 218, 6, 'PPL', 'P'),
(192955, 'Fluor', 36.9663887023926, 0.645185195428785, -101.050559997559, -1.76366498294147, 218, 42, 'PPL', 'P'),
(190211, 'Fluorine (historical)', 36.8863906860352, 0.643788966648283, -116.696113586426, -2.03673140636442, 218, 39, 'PPL', 'P'),
(75839, 'Flusche', 35.667781829834, 0.622520229813611, -95.5352783203125, -1.66740515849861, 218, 42, 'PPL', 'P'),
(32454, 'Flush', 39.2944412231445, 0.68581737707526, -96.4402770996094, -1.68320036692387, 218, 20, 'PPL', 'P'),
(113299, 'Flushing', 40.1183280944824, 0.700196915644061, -74.9069366455078, -1.30737267704691, 218, 45, 'PPL', 'P'),
(130823, 'Flushing', 43.063060760498, 0.751592196257064, -83.8511123657227, -1.46347799224159, 218, 27, 'PPL', 'P'),
(148869, 'Flushing', 40.7652816772461, 0.711488385770861, -73.8177795410156, -1.28836329950203, 218, 40, 'PPL', 'P'),
(155292, 'Flushing', 40.1494407653809, 0.700739934190328, -81.0663909912109, -1.4148754355057, 218, 41, 'PPL', 'P'),
(75840, 'Flute Springs', 35.6194381713867, 0.621676473801246, -94.8055572509766, -1.65466912321753, 218, 42, 'PPL', 'P'),
(148870, 'Fluvanna', 42.1191711425781, 0.73511821464897, -79.2922210693359, -1.38391032887913, 218, 40, 'PPL', 'P'),
(191475, 'Fluvanna', 32.8855590820313, 0.573961282340569, -101.148330688477, -1.76537140340994, 218, 51, 'PPL', 'P'),
(203987, 'Flux', 40.6813888549805, 0.710024179803535, -112.553886413574, -1.96443590383258, 218, 52, 'PPL', 'P'),
(72569, 'Fly', 39.5647201538086, 0.690534634314117, -81.0086135864258, -1.41386702955894, 218, 41, 'PPL', 'P'),
(87015, 'Fly', 35.7894401550293, 0.624643568150731, -87.1586074829102, -1.52120467203015, 218, 50, 'PPL', 'P'),
(148871, 'Fly Creek', 42.7183303833008, 0.74557551614333, -74.9836120605469, -1.30871091549467, 218, 40, 'PPL', 'P'),
(8916, 'Fly Gap (historical)', 35.7522201538086, 0.623993956581833, -93.8050003051758, -1.6372061101596, 218, 4, 'PPL', 'P'),
(148872, 'Fly Summit', 43.0125007629395, 0.750709757829866, -73.4847183227539, -1.28255028463266, 218, 40, 'PPL', 'P'),
(181612, 'Fly-In Acres', 38.2319412231445, 0.66727325377282, -120.336112976074, -2.10026138048437, 218, 6, 'PPL', 'P'),
(70819, 'Flyat', 39.8227806091309, 0.695038638928687, -74.7574996948242, -1.30476451023334, 218, 37, 'PPL', 'P'),
(109234, 'Flyblow (historical)', 39.6113891601563, 0.691349162133518, -80.3138885498047, -1.40174179027387, 218, 58, 'PPL', 'P'),
(161697, 'Flying Hills', 40.276668548584, 0.702960477907236, -75.914436340332, -1.32495686393443, 218, 45, 'PPL', 'P'),
(148873, 'Flying Point', 40.8941688537598, 0.713737891364623, -72.3547210693359, -1.26282811202202, 218, 40, 'PPL', 'P'),
(21165, 'Flying S Ranchettes', 33.7472190856934, 0.58900008643722, -84.8952789306641, -1.48170213673906, 218, 13, 'PPL', 'P'),
(8917, 'Flynn', 33.9708290100098, 0.592902815856676, -91.5852813720703, -1.59846470630806, 218, 4, 'PPL', 'P'),
(75841, 'Flynn', 35.401668548584, 0.617875676872513, -97.4872207641602, -1.70147298095318, 218, 42, 'PPL', 'P'),
(94253, 'Flynn', 31.1508293151855, 0.543684536276758, -96.1241683959961, -1.67768322925161, 218, 51, 'PPL', 'P'),
(181613, 'Flynn', 34.9786109924316, 0.610491929592213, -115.731391906738, -2.0198938366885, 218, 6, 'PPL', 'P'),
(196494, 'Flynn', 46.2938919067383, 0.807980837334939, -106.541389465332, -1.85949803581964, 218, 31, 'PPL', 'P'),
(200830, 'Flynn', 44.5411109924316, 0.777389039314171, -123.385559082031, -2.15348425539544, 218, 43, 'PPL', 'P'),
(8918, 'Flynn (historical)', 35.1513900756836, 0.613507493473538, -91.3047180175781, -1.59356795201173, 218, 4, 'PPL', 'P'),
(59924, 'Flynn (historical)', 33.5377807617188, 0.585344698104004, -88.4458312988281, -1.543670965828, 218, 30, 'PPL', 'P'),
(2509, 'Flynn Gin Landing', 31.4274997711182, 0.548513346675776, -87.5858306884766, -1.52866112360821, 218, 2, 'PPL', 'P'),
(141826, 'Flynn Junction', 40.1313896179199, 0.700424882233372, -99.5158309936523, -1.73687890869745, 218, 35, 'PPL', 'P'),
(87017, 'Flynns Lick', 36.3263893127441, 0.634015098868665, -85.7136077880859, -1.49598466966515, 218, 50, 'PPL', 'P'),
(59923, 'Flynt', 31.6980590820313, 0.553235497473137, -89.1841735839844, -1.55655746971068, 218, 30, 'PPL', 'P'),
(94134, 'FM 1426-Minnesota Road Colonia', 26.2329998016357, 0.457852219213563, -98.1460037231445, -1.71297091264349, 218, 51, 'PPL', 'P'),
(94135, 'FM 1925-Floral Rd Colonia', 26.3159999847412, 0.459300845688512, -98.0120010375977, -1.71063212457418, 218, 51, 'PPL', 'P'),
(94136, 'FM 802-511 Colonia', 25.9379997253418, 0.452703496588599, -97.4100036621094, -1.70012528828354, 218, 51, 'PPL', 'P'),
(94255, 'Foard City', 33.8808288574219, 0.59133201686672, -99.7994384765625, -1.74182879305753, 218, 51, 'PPL', 'P'),
(75844, 'Fobb', 33.9111099243164, 0.591860521185046, -96.845832824707, -1.69027864962714, 218, 42, 'PPL', 'P'),
(207432, 'Fobes Hill', 47.9491691589355, 0.836870875419146, -122.118606567383, -2.1313717625484, 218, 56, 'PPL', 'P'),
(109235, 'Foch', 38.0400009155273, 0.66392326343761, -81.7930603027344, -1.42755820756498, 218, 58, 'PPL', 'P'),
(87016, 'Fochee', 35.7005615234375, 0.623092343394787, -84.4861068725586, -1.47456073711796, 218, 50, 'PPL', 'P'),
(94258, 'Fodice', 31.172779083252, 0.544067631999566, -95.3016662597656, -1.6633278588697, 218, 51, 'PPL', 'P'),
(21166, 'Fodie', 30.8491706848145, 0.538419599959726, -83.5408325195313, -1.45806258732297, 218, 13, 'PPL', 'P'),
(94257, 'Fog Town', 31.3349990844727, 0.546898905133457, -95.1305618286133, -1.66034152318134, 218, 51, 'PPL', 'P'),
(119642, 'Fogarty', 40.0936088562012, 0.699765483547468, -89.4197235107422, -1.56066859148543, 218, 18, 'PPL', 'P'),
(8919, 'Fogel', 34.7069396972656, 0.605750371008409, -94.4541702270508, -1.64853626270124, 218, 4, 'PPL', 'P'),
(75845, 'Fogel', 34.7069396972656, 0.605750371008409, -94.4552764892578, -1.64855557061914, 218, 42, 'PPL', 'P'),
(113443, 'Fogelmarks Corners', 41.6022186279297, 0.726095691191891, -72.6036071777344, -1.26717199407605, 218, 8, 'PPL', 'P'),
(161698, 'Fogelsville', 40.5830612182617, 0.708308038797088, -75.633056640625, -1.32004586172627, 218, 45, 'PPL', 'P'),
(35942, 'Fogertown', 37.2194404602051, 0.649601781780572, -83.9011077880859, -1.46435057697276, 218, 21, 'PPL', 'P'),
(87018, 'Fogg (historical)', 35.7686080932617, 0.624279980082908, -87.3672180175781, -1.52484561271445, 218, 50, 'PPL', 'P'),
(143831, 'Fogg Corner', 42.961669921875, 0.749822592291734, -70.8274993896484, -1.23617306530364, 218, 36, 'PPL', 'P'),
(143832, 'Fogg Corners', 42.9030609130859, 0.748799672117034, -70.8769378662109, -1.23703592949683, 218, 36, 'PPL', 'P'),
(127493, 'Foggs Corner', 43.9372215270996, 0.766849179826019, -70.2483291625977, -1.22606463791208, 218, 26, 'PPL', 'P'),
(13097, 'Foggy Bottom', 38.9013900756836, 0.678957340423325, -77.0625, -1.34499435481813, 218, 9, 'PPL', 'P'),
(81027, 'Fogles (historical)', 33.3397216796875, 0.581887915009081, -81.1805572509766, -1.4168680126333, 218, 48, 'PPL', 'P'),
(54797, 'Foil', 36.7561111450195, 0.641515159709574, -92.6352767944336, -1.61679058355916, 218, 29, 'PPL', 'P'),
(109236, 'Fola', 38.3574981689453, 0.669464635875792, -81.103889465332, -1.41552990734359, 218, 58, 'PPL', 'P'),
(78284, 'Folcroft', 39.8908309936523, 0.696226342195835, -75.2841720581055, -1.31395667705186, 218, 45, 'PPL', 'P'),
(135394, 'Foldahl', 48.3333282470703, 0.843575716358556, -96.5500030517578, -1.68511544606375, 218, 28, 'PPL', 'P'),
(2510, 'Foley', 30.4063892364502, 0.530691605819021, -87.6836090087891, -1.53036767723473, 218, 2, 'PPL', 'P'),
(16055, 'Foley', 30.0691699981689, 0.524806019809945, -83.5308303833008, -1.45788801711352, 218, 12, 'PPL', 'P'),
(29816, 'Foley', 39.9652786254883, 0.697525698491684, -85.3777770996094, -1.490123318422, 218, 19, 'PPL', 'P'),
(40937, 'Foley', 29.923059463501, 0.52225590990814, -91.0247192382813, -1.58868105141143, 218, 22, 'PPL', 'P'),
(54798, 'Foley', 39.0463905334473, 0.6814880758282, -90.7422180175781, -1.58375047496926, 218, 29, 'PPL', 'P'),
(75846, 'Foley', 35.6838912963867, 0.622801393045696, -98.8491668701172, -1.72524342473684, 218, 42, 'PPL', 'P'),
(78282, 'Foley', 39.8294410705566, 0.695154885910269, -78.8183288574219, -1.37563934948167, 218, 45, 'PPL', 'P'),
(135397, 'Foley', 45.6647186279297, 0.79699969205416, -93.9094390869141, -1.63902891076771, 218, 28, 'PPL', 'P'),
(170312, 'Foley', 44.8394393920898, 0.782595852140412, -97.147216796875, -1.69553879225421, 218, 49, 'PPL', 'P'),
(113444, 'Foley (historical)', 42.0213890075684, 0.73341159444342, -73.3694381713867, -1.28053826642911, 218, 8, 'PPL', 'P'),
(200831, 'Foley (historical)', 45.6583290100098, 0.796888172183513, -123.840278625488, -2.16142060860193, 218, 43, 'PPL', 'P'),
(161699, 'Foley Corner', 41.4766693115234, 0.723904442246974, -76.4199981689453, -1.33378058241613, 218, 45, 'PPL', 'P'),
(135398, 'Foley Mobile Home Park', 45.6697196960449, 0.797086977158888, -93.9033279418945, -1.63892225116605, 218, 28, 'PPL', 'P'),
(135399, 'Foley Mobile Home Park South', 45.663330078125, 0.796975457288241, -93.9038925170898, -1.63893210486208, 218, 28, 'PPL', 'P'),
(200832, 'Foley Springs', 44.1541709899902, 0.770635662263894, -122.097503662109, -2.13100344736964, 218, 43, 'PPL', 'P'),
(196495, 'Foleys Trailer Court', 46.7547187805176, 0.81602378356406, -114.082778930664, -1.9911201121649, 218, 31, 'PPL', 'P'),
(211832, 'Folger', 63.5616683959961, 1.10936039157095, -156.08332824707, -2.72416798538245, 218, 1, 'PPL', 'P'),
(87019, 'Folger (historical)', 35.3833312988281, 0.617555631488512, -84.7936096191406, -1.47992767250474, 218, 50, 'PPL', 'P'),
(155294, 'Folger (historical)', 41.478328704834, 0.723933404123828, -82.0194396972656, -1.43150927335823, 218, 41, 'PPL', 'P'),
(54799, 'Folk', 38.4213905334473, 0.670579768003235, -92.0977783203125, -1.60740946546131, 218, 29, 'PPL', 'P'),
(200833, 'Folkenberg', 45.6291694641113, 0.796379242099199, -122.86499786377, -2.14439874817858, 218, 43, 'PPL', 'P'),
(81028, 'Folkestone', 34.1027793884277, 0.595205784409322, -80.9358291625977, -1.41259670171897, 218, 48, 'PPL', 'P'),
(21167, 'Folks (historical)', 31.6194400787354, 0.551863337010987, -84.6063919067383, -1.47666010700527, 218, 13, 'PPL', 'P'),
(21168, 'Folkston', 30.8302803039551, 0.538089900616774, -82.0100021362305, -1.4313445568448, 218, 13, 'PPL', 'P'),
(64782, 'Folkstone', 34.5363883972168, 0.602773689279, -77.5044403076172, -1.35270766828333, 218, 33, 'PPL', 'P'),
(177219, 'Follansbee', 40.3274993896484, 0.703847643445369, -80.5961074829102, -1.40666743986802, 218, 58, 'PPL', 'P'),
(124854, 'Follen Heights', 42.4324989318848, 0.740586816210366, -71.2138900756836, -1.24291685497399, 218, 23, 'PPL', 'P'),
(191476, 'Follett', 36.4338912963867, 0.635891362435653, -100.14111328125, -1.74779214337043, 218, 51, 'PPL', 'P'),
(112998, 'Folletts', 41.7486114501953, 0.728650727941713, -90.3547210693359, -1.576987377381, 218, 16, 'PPL', 'P'),
(191477, 'Folley', 34.2924995422363, 0.598517025750672, -100.9375, -1.76169171373178, 218, 51, 'PPL', 'P'),
(155295, 'Follmer (historical)', 41.0327796936035, 0.716157106898851, -84.5880584716797, -1.47634012820029, 218, 41, 'PPL', 'P'),
(101998, 'Folly', 37.8794403076172, 0.661120952180574, -76.3280563354492, -1.33217589470131, 218, 53, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(81029, 'Folly Beach', 32.6549987792969, 0.56993724593346, -79.940559387207, -1.39522596719282, 218, 48, 'PPL', 'P'),
(47109, 'Folly Farms', 39.4338912963867, 0.688251239995483, -76.8811111450195, -1.3418285220723, 218, 25, 'PPL', 'P'),
(81030, 'Folly Field', 32.2019386291504, 0.562029854603824, -80.690559387207, -1.40831593658278, 218, 48, 'PPL', 'P'),
(64783, 'Folly Fork', 36.4850006103516, 0.636783388242775, -76.5777816772461, -1.33653442414133, 218, 33, 'PPL', 'P'),
(169375, 'Folly Landing', 41.6811103820801, 0.727472612054489, -71.4491729736328, -1.24702331621684, 218, 47, 'PPL', 'P'),
(101999, 'Folly Mills', 38.098331451416, 0.66494132334332, -79.0988922119141, -1.380536103778, 218, 53, 'PPL', 'P'),
(47114, 'Follywoods', 38.4991683959961, 0.671937247789876, -76.6374969482422, -1.33757665223393, 218, 25, 'PPL', 'P'),
(2512, 'Folsom', 33.4538917541504, 0.583880558715706, -85.5500030517578, -1.49312922834437, 218, 2, 'PPL', 'P'),
(21169, 'Folsom', 34.3827781677246, 0.600092685009618, -84.82861328125, -1.4805386016588, 218, 13, 'PPL', 'P'),
(35946, 'Folsom', 38.7119407653809, 0.67565082619291, -84.7474975585938, -1.47912286522332, 218, 21, 'PPL', 'P'),
(40940, 'Folsom', 30.6299991607666, 0.534594335238477, -90.1872177124023, -1.57406389229437, 218, 22, 'PPL', 'P'),
(54800, 'Folsom', 38.7333297729492, 0.676024134798712, -92.154167175293, -1.60839363664214, 218, 29, 'PPL', 'P'),
(70820, 'Folsom', 39.6019401550293, 0.691184245883015, -74.8430633544922, -1.3062578778146, 218, 37, 'PPL', 'P'),
(72570, 'Folsom', 39.0950012207031, 0.682336492372472, -83.5927810668945, -1.45896926051609, 218, 41, 'PPL', 'P'),
(75847, 'Folsom', 34.1933288574219, 0.596786170779202, -96.420280456543, -1.68285135966302, 218, 42, 'PPL', 'P'),
(78283, 'Folsom', 39.889720916748, 0.696206967698904, -75.3255615234375, -1.31467905949754, 218, 45, 'PPL', 'P'),
(109239, 'Folsom', 39.4705581665039, 0.688891197605429, -80.5205612182617, -1.40534890881232, 218, 58, 'PPL', 'P'),
(115591, 'Folsom', 41.0900001525879, 0.717155792307631, -95.8172225952148, -1.6723260144028, 218, 16, 'PPL', 'P'),
(172025, 'Folsom', 44.584171295166, 0.778140583373792, -71.980827331543, -1.25630243524495, 218, 55, 'PPL', 'P'),
(174119, 'Folsom', 43.4383316040039, 0.758141908062978, -90.8383331298828, -1.5854280001399, 218, 57, 'PPL', 'P'),
(181614, 'Folsom', 38.6780586242676, 0.675059471272858, -121.175003051758, -2.11490277436735, 218, 6, 'PPL', 'P'),
(188557, 'Folsom', 36.8450012207031, 0.643066584202599, -103.917221069336, -1.81369765718273, 218, 38, 'PPL', 'P'),
(191478, 'Folsom', 35.2358283996582, 0.61498122024176, -101.705276489258, -1.77509194138873, 218, 51, 'PPL', 'P'),
(202133, 'Folsom', 43.8252792358398, 0.76489541827131, -102.869438171387, -1.79541039576743, 218, 49, 'PPL', 'P'),
(181615, 'Folsom Junction', 38.6683311462402, 0.674889694753365, -121.181106567383, -2.11500930081095, 218, 6, 'PPL', 'P'),
(35943, 'Folsomdale', 36.8836097717285, 0.643740430537417, -88.6744384765625, -1.54766091377316, 218, 21, 'PPL', 'P'),
(148875, 'Folsomdale', 42.827220916748, 0.747476014476238, -78.4483337402344, -1.36918171647045, 218, 40, 'PPL', 'P'),
(29817, 'Folsomville', 38.1291694641113, 0.665479548199625, -87.1641693115234, -1.52130174425188, 218, 19, 'PPL', 'P'),
(161700, 'Folstown', 41.160831451416, 0.718392031685646, -76.0102767944336, -1.32662959541511, 218, 45, 'PPL', 'P'),
(59926, 'Foltz', 33.4341697692871, 0.583536345144813, -89.7441711425781, -1.56633127091127, 218, 30, 'PPL', 'P'),
(109237, 'Foltz (historical)', 39.4991683959961, 0.689390540309819, -77.8616714477539, -1.35894252786937, 218, 58, 'PPL', 'P'),
(199958, 'Foltz (historical)', 40.2491683959961, 0.702480509699777, -118.18138885498, -2.06265435009914, 218, 39, 'PPL', 'P'),
(145240, 'Folwell', 40.0438919067383, 0.698897759085293, -74.7091674804688, -1.30392095395806, 218, 37, 'PPL', 'P'),
(161701, 'Fombell', 40.809440612793, 0.71225910459033, -80.2019424438477, -1.39978796214013, 218, 45, 'PPL', 'P'),
(8921, 'Fomby', 33.6794395446777, 0.587817110281006, -94.0086135864258, -1.6407598323182, 218, 4, 'PPL', 'P'),
(124855, 'Fomer', 42.2449989318848, 0.737314323862877, -72.7944412231445, -1.27050267649336, 218, 23, 'PPL', 'P'),
(119643, 'Fond du Lac', 40.666389465332, 0.70976239106838, -89.5800018310547, -1.56346597589445, 218, 18, 'PPL', 'P'),
(135402, 'Fond du Lac', 46.6597213745117, 0.814365766048404, -92.273063659668, -1.61046877176353, 218, 28, 'PPL', 'P'),
(174120, 'Fond du Lac', 43.7730598449707, 0.763984017967257, -88.4469375610352, -1.54369027374591, 218, 57, 'PPL', 'P'),
(75848, 'Fonda', 36.1474990844727, 0.630892875385684, -98.7586135864258, -1.72366297178794, 218, 42, 'PPL', 'P'),
(115592, 'Fonda', 42.5813903808594, 0.743185462223038, -94.845832824707, -1.65537206458725, 218, 16, 'PPL', 'P'),
(148874, 'Fonda', 42.9544410705566, 0.749696425035091, -74.3769378662109, -1.29812245331663, 218, 40, 'PPL', 'P'),
(172026, 'Fonda', 44.8713912963867, 0.783153518072675, -73.0980606079102, -1.2758018344304, 218, 55, 'PPL', 'P'),
(198292, 'Fonda', 48.6697196960449, 0.849446854718718, -100.018333435059, -1.7456492307993, 218, 34, 'PPL', 'P'),
(209455, 'Fonda', 41.8408317565918, 0.73026027592553, -104.303329467773, -1.82043652000507, 218, 59, 'PPL', 'P'),
(40938, 'Fondale', 32.3544387817383, 0.564691484376276, -92.107780456543, -1.60758403567076, 218, 22, 'PPL', 'P'),
(35944, 'Fonde', 36.5941696166992, 0.638688746844673, -83.8775024414063, -1.46393858595212, 218, 21, 'PPL', 'P'),
(186718, 'Fondis', 39.2158317565918, 0.684445383060678, -104.346672058105, -1.82119299091271, 218, 7, 'PPL', 'P'),
(181616, 'Fondo', 33.1113891601563, 0.577902760753887, -115.623611450195, -2.01801271285252, 218, 6, 'PPL', 'P'),
(119644, 'Fondulac Plaza Shopping Center', 40.6749992370605, 0.709912659932888, -89.5377807617188, -1.56272907922083, 218, 18, 'PPL', 'P'),
(102000, 'Foneswood', 38.1047210693359, 0.665052843213967, -76.9013900756836, -1.34218245618117, 218, 53, 'PPL', 'P'),
(47110, 'Font Hill', 39.2266693115234, 0.684634534077101, -76.7847213745117, -1.3401462032117, 218, 25, 'PPL', 'P'),
(47111, 'Font Hill Manor', 39.2747192382813, 0.685473163504367, -76.8555603027344, -1.34138257574776, 218, 25, 'PPL', 'P'),
(47112, 'Font Hill Village', 39.2688903808594, 0.685371430750726, -76.8613891601563, -1.34148430850141, 218, 25, 'PPL', 'P'),
(21172, 'Fontainbleau Forest', 33.9524993896484, 0.59258290363073, -84.2763900756836, -1.47090048851575, 218, 13, 'PPL', 'P'),
(8922, 'Fontaine', 36.000560760498, 0.628328317834965, -90.8133316040039, -1.58499164119529, 218, 4, 'PPL', 'P'),
(102001, 'Fontaine', 36.644718170166, 0.639570985534789, -79.8600006103516, -1.39381995129532, 218, 53, 'PPL', 'P'),
(161702, 'Fontaine', 40.1211090087891, 0.700245451754928, -75.8613891601563, -1.32403101598146, 218, 45, 'PPL', 'P'),
(203989, 'Fontaine Bleu', 40.6444396972656, 0.709379295345572, -111.844436645508, -1.95205366950231, 218, 52, 'PPL', 'P'),
(32455, 'Fontana', 38.4258308410645, 0.670657265990957, -94.8380584716797, -1.65523637652971, 218, 20, 'PPL', 'P'),
(161703, 'Fontana', 40.2841682434082, 0.703091372274814, -76.4994430541992, -1.33516715723768, 218, 45, 'PPL', 'P'),
(174123, 'Fontana', 42.5513916015625, 0.742661884752729, -88.5749969482422, -1.54592533169076, 218, 57, 'PPL', 'P'),
(181617, 'Fontana', 34.0922203063965, 0.595021493661889, -117.434173583984, -2.04961298339908, 218, 6, 'PPL', 'P'),
(47113, 'Fontana Village', 39.3416709899902, 0.686641692011667, -76.4913864135742, -1.33502654233213, 218, 25, 'PPL', 'P'),
(64784, 'Fontana Village', 35.4355583190918, 0.618467164950619, -83.8191680908203, -1.46292045946738, 218, 33, 'PPL', 'P'),
(115593, 'Fontanelle', 41.2897186279297, 0.720641537279409, -94.561393737793, -1.65040766599923, 218, 16, 'PPL', 'P'),
(141827, 'Fontanelle', 41.5386085510254, 0.724985485912464, -96.4277801513672, -1.68298225403059, 218, 35, 'PPL', 'P'),
(29818, 'Fontanet', 39.5761108398438, 0.690733439289492, -87.2436065673828, -1.52268818591538, 218, 19, 'PPL', 'P'),
(181618, 'Fontenay Villa', 37.0811080932617, 0.647187426515334, -121.97306060791, -2.12883150634263, 218, 6, 'PPL', 'P'),
(209456, 'Fontenelle', 41.9850006103516, 0.732776497102464, -110.058326721191, -1.92088017052045, 218, 59, 'PPL', 'P'),
(40939, 'Fontenot', 30.438060760498, 0.53124437819278, -92.8772201538086, -1.62101329178359, 218, 22, 'PPL', 'P'),
(174125, 'Fontenoy', 44.3711090087891, 0.774421944964687, -87.7861099243164, -1.53215665569699, 218, 57, 'PPL', 'P'),
(35945, 'Fonthill', 37.0838890075684, 0.6472359626262, -85.0036087036133, -1.48359284795496, 218, 21, 'PPL', 'P'),
(64785, 'Fonville', 35.2900009155273, 0.615926709007765, -78.7699966430664, -1.37479579320639, 218, 33, 'PPL', 'P'),
(109238, 'Fonzo', 39.0730590820313, 0.681953529807719, -81.0516662597656, -1.41461844046051, 218, 58, 'PPL', 'P'),
(13776, 'Foord Landing', 38.8349990844727, 0.677798599033031, -75.258056640625, -1.31350087703129, 218, 10, 'PPL', 'P'),
(54801, 'Foose', 37.5613899230957, 0.65556992578344, -93.1463928222656, -1.62571124110455, 218, 29, 'PPL', 'P'),
(87020, 'Fooshee Bend (historical)', 35.6575012207031, 0.622340799335167, -84.7633285522461, -1.47939916818641, 218, 50, 'PPL', 'P'),
(119646, 'Foosland', 40.3613891601563, 0.704439131523475, -88.4280624389648, -1.54336084071906, 218, 18, 'PPL', 'P'),
(87021, 'Foot (historical)', 36.0250015258789, 0.628754889662568, -85.3183288574219, -1.4890857508613, 218, 50, 'PPL', 'P'),
(161704, 'Foot of Ten', 40.415828704834, 0.705389280821389, -78.4555587768555, -1.36930781714806, 218, 45, 'PPL', 'P'),
(59925, 'Foote', 33.0913887023926, 0.577553686914004, -91.0327835083008, -1.58882179947504, 218, 30, 'PPL', 'P'),
(113445, 'Foote Corners', 41.7555618286133, 0.728772034929366, -72.7647171020508, -1.26998389271301, 218, 8, 'PPL', 'P'),
(130827, 'Foote Site Village', 44.4266700744629, 0.775391668496612, -83.4447174072266, -1.45638506215233, 218, 27, 'PPL', 'P'),
(78291, 'Footedale', 39.9091682434082, 0.696546387579835, -79.8252792358398, -1.39321394898927, 218, 45, 'PPL', 'P'),
(148877, 'Footes', 42.5849990844727, 0.743248445982819, -78.6447219848633, -1.37260933795143, 218, 40, 'PPL', 'P'),
(203991, 'Foothill', 40.7430610656738, 0.711100562937118, -111.83332824707, -1.95185979137496, 218, 52, 'PPL', 'P'),
(181620, 'Foothill Farms', 38.6763916015625, 0.675030376237948, -121.33528137207, -2.11770015877637, 218, 6, 'PPL', 'P'),
(181621, 'Foothill Ranch', 33.6863899230957, 0.587938417268659, -117.660003662109, -2.05355446181239, 218, 6, 'PPL', 'P'),
(102004, 'Foothill Village', 38.0713882446289, 0.664471075673839, -78.7194366455078, -1.37391335477919, 218, 53, 'PPL', 'P'),
(203993, 'Foothill Village', 40.7416687011719, 0.711076261592171, -111.829719543457, -1.95179680761518, 218, 52, 'PPL', 'P'),
(203994, 'Foothills', 40.4955596923828, 0.706780849069982, -112.014442443848, -1.95502083043083, 218, 52, 'PPL', 'P'),
(181622, 'Foothills of San Marcos Mobile Home Park', 33.1527786254883, 0.578625143199571, -117.13777923584, -2.04443992613965, 218, 6, 'PPL', 'P'),
(16056, 'Footman', 28.3302803039551, 0.494456669316916, -80.6908264160156, -1.40832059711469, 218, 12, 'PPL', 'P'),
(148876, 'Foots Corners', 42.7463912963867, 0.746065271467796, -77.6777801513672, -1.35573301928166, 218, 40, 'PPL', 'P'),
(200834, 'Foots Creek', 42.4049987792969, 0.740106848002907, -123.13777923584, -2.14915968125931, 218, 43, 'PPL', 'P'),
(2514, 'Foots Landing', 30.4055595397949, 0.530677124880593, -87.8988876342773, -1.53412499805867, 218, 2, 'PPL', 'P'),
(64786, 'Footville', 36.0605583190918, 0.629375472775584, -80.7022171020508, -1.40851940209006, 218, 33, 'PPL', 'P'),
(155296, 'Footville', 41.6616706848145, 0.727133325331613, -80.9783325195313, -1.41333852524062, 218, 41, 'PPL', 'P'),
(174126, 'Footville', 42.6708297729492, 0.744746474095988, -89.2088928222656, -1.55698890180727, 218, 57, 'PPL', 'P'),
(27184, 'Fopal', 37.6063919067383, 0.656355358567931, -88.9402770996094, -1.5523006730243, 218, 18, 'PPL', 'P'),
(181623, 'Foppiano', 38.0219383239746, 0.663608011743571, -121.240280151367, -2.11604207468169, 218, 6, 'PPL', 'P'),
(135403, 'Forada', 45.7922210693359, 0.799225029461031, -95.3552780151367, -1.6642635605187, 218, 28, 'PPL', 'P'),
(35947, 'Foraker', 37.6599998474121, 0.657290993637903, -83.1372222900391, -1.4510182599236, 218, 21, 'PPL', 'P'),
(75851, 'Foraker', 36.8722190856934, 0.643541625562042, -96.5652770996094, -1.68538202848886, 218, 42, 'PPL', 'P'),
(102002, 'Foraker', 37.0761108398438, 0.647100207989633, -82.4888916015625, -1.43970275476796, 218, 53, 'PPL', 'P'),
(122622, 'Foraker', 41.5158309936523, 0.724587942540742, -85.9241714477539, -1.49965969881141, 218, 19, 'PPL', 'P'),
(155297, 'Foraker', 40.6775016784668, 0.709956335774765, -83.7416687011719, -1.46156783994973, 218, 41, 'PPL', 'P'),
(196496, 'Foraker', 47.3005599975586, 0.825550509994519, -115.196113586426, -2.0105514675845, 218, 31, 'PPL', 'P'),
(54802, 'Forbes', 39.9027786254883, 0.696434867709188, -95.0824966430664, -1.65950262743796, 218, 29, 'PPL', 'P'),
(94260, 'Forbes', 30.5091705322266, 0.532485477839784, -93.9272232055664, -1.63933930219276, 218, 51, 'PPL', 'P'),
(135405, 'Forbes', 47.3716697692871, 0.826791609641523, -92.603889465332, -1.61624277132294, 218, 28, 'PPL', 'P'),
(140025, 'Forbes', 45.9436111450195, 0.801867284736553, -98.7816696166992, -1.72406537542865, 218, 34, 'PPL', 'P'),
(207433, 'Forbes', 47.1105613708496, 0.822234408384179, -123.129722595215, -2.14901906635376, 218, 56, 'PPL', 'P'),
(102003, 'Forbes (historical)', 37.4352798461914, 0.653368889721517, -78.6355590820313, -1.37244941512798, 218, 53, 'PPL', 'P'),
(181624, 'Forbes (historical)', 38.0013885498047, 0.663249350523765, -122.536666870117, -2.138668291303, 218, 6, 'PPL', 'P'),
(186719, 'Forbes (historical)', 37.2599983215332, 0.650309649998315, -104.564170837402, -1.82498906073051, 218, 7, 'PPL', 'P'),
(81032, 'Forbes Corner', 33.4811096191406, 0.584355600075149, -79.4274978637695, -1.38627135434354, 218, 48, 'PPL', 'P'),
(130828, 'Forbes Location', 46.1202812194824, 0.804950759225674, -88.6477813720703, -1.54719565953072, 218, 27, 'PPL', 'P'),
(161705, 'Forbes Road', 40.353889465332, 0.704308237155898, -79.5219421386719, -1.38791971790025, 218, 45, 'PPL', 'P'),
(113446, 'Forbes Village', 41.7333297729492, 0.728384012358541, -72.5999984741211, -1.26710901031627, 218, 8, 'PPL', 'P'),
(124856, 'Forbes Wharf', 42.2666702270508, 0.737692559316695, -71.0608291625977, -1.24024543808453, 218, 23, 'PPL', 'P'),
(181625, 'Forbestown', 39.517219543457, 0.689705592266776, -121.26611328125, -2.11649294785424, 218, 6, 'PPL', 'P'),
(40941, 'Forbing', 32.3925018310547, 0.565355809910196, -93.7272186279297, -1.63584856379394, 218, 22, 'PPL', 'P'),
(178196, 'Forbing Park', 34.565559387207, 0.603282819100396, -112.495002746582, -1.96340818996792, 218, 5, 'PPL', 'P'),
(87023, 'Forbus', 36.5527801513672, 0.637966364398989, -84.9916687011719, -1.48338445559966, 218, 50, 'PPL', 'P'),
(64787, 'Forbush', 36.1977806091309, 0.631770453543892, -80.5744400024414, -1.40628927099323, 218, 33, 'PPL', 'P'),
(115594, 'Forbush', 40.7688903808594, 0.711551369530641, -92.8769378662109, -1.62100836493558, 218, 16, 'PPL', 'P'),
(130829, 'Forbush Corner', 44.7855606079102, 0.781655489959505, -84.7063903808594, -1.47840540962565, 218, 27, 'PPL', 'P'),
(161706, 'Force', 41.2577781677246, 0.720084071084228, -78.5013885498047, -1.37010769758147, 218, 45, 'PPL', 'P'),
(32456, 'Ford', 37.6361083984375, 0.656874009190224, -99.7536087036133, -1.74102891262412, 218, 20, 'PPL', 'P'),
(35948, 'Ford', 37.8816719055176, 0.661159900911516, -84.2602767944336, -1.47061925870464, 218, 21, 'PPL', 'P'),
(59928, 'Ford', 33.1055603027344, 0.577801028000246, -89.1791687011719, -1.55647011802692, 218, 30, 'PPL', 'P'),
(87024, 'Ford', 35.8316688537598, 0.625380597982411, -84.2433319091797, -1.47032351466559, 218, 50, 'PPL', 'P'),
(115595, 'Ford', 41.4850006103516, 0.724049850842492, -93.3883285522461, -1.62993381617092, 218, 16, 'PPL', 'P'),
(191479, 'Ford', 35.1010208129883, 0.612628383997702, -102.401481628418, -1.78724301333638, 218, 51, 'PPL', 'P'),
(196498, 'Ford', 48.875560760498, 0.853039459029235, -114.377220153809, -1.99625908096238, 218, 31, 'PPL', 'P'),
(209917, 'Ford', 47.9083290100098, 0.836158080353386, -117.804718017578, -2.05608020379023, 218, 56, 'PPL', 'P'),
(21171, 'Ford (historical)', 31.327220916748, 0.54676315049689, -81.6816711425781, -1.42561409996923, 218, 13, 'PPL', 'P'),
(2515, 'Ford City', 34.785831451416, 0.607127291871007, -87.5286102294922, -1.52766243819943, 218, 2, 'PPL', 'P'),
(139159, 'Ford City', 40.1116714477539, 0.700080735241506, -94.4644393920898, -1.6487154934426, 218, 29, 'PPL', 'P'),
(161710, 'Ford City', 40.7722206115723, 0.711609493021432, -79.5299987792969, -1.3880603328058, 218, 45, 'PPL', 'P'),
(181626, 'Ford City', 35.1544418334961, 0.613560756695339, -119.455276489258, -2.08488788361772, 218, 6, 'PPL', 'P'),
(161708, 'Ford Cliff', 40.7602806091309, 0.711401100666133, -79.5338897705078, -1.3881282434136, 218, 45, 'PPL', 'P'),
(148878, 'Ford Corner', 42.9752807617188, 0.750060146260969, -77.5274963378906, -1.35311007192404, 218, 40, 'PPL', 'P'),
(87026, 'Ford Crossing', 36.2724990844727, 0.633074536950677, -82.5044403076172, -1.43997413088304, 218, 50, 'PPL', 'P'),
(87027, 'Ford Estates', 36.1605606079102, 0.631120841974995, -85.2630615234375, -1.48812115391448, 218, 50, 'PPL', 'P'),
(21173, 'Ford Heights', 33.8066711425781, 0.590037720576942, -84.6066665649414, -1.47666490069523, 218, 13, 'PPL', 'P'),
(119648, 'Ford Heights', 41.5063896179199, 0.724423159448294, -87.591667175293, -1.5287629895199, 218, 18, 'PPL', 'P'),
(47115, 'Ford Landing', 39.2461090087891, 0.684973820799977, -75.8947219848633, -1.32461278352159, 218, 25, 'PPL', 'P'),
(94261, 'Ford Oaks', 30.172779083252, 0.526614339479623, -97.8319396972656, -1.70748946132983, 218, 51, 'PPL', 'P'),
(196499, 'Ford Place', 46.253059387207, 0.807268175427234, -110.803062438965, -1.9338782608528, 218, 31, 'PPL', 'P'),
(130830, 'Ford River', 45.6794395446777, 0.797256620520326, -87.1399993896484, -1.52087989953521, 218, 27, 'PPL', 'P'),
(47116, 'Ford Road Acres', 39.485279083252, 0.689148126071595, -77.4327774047852, -1.35145691467737, 218, 25, 'PPL', 'P'),
(207434, 'Fordair', 47.6361083984375, 0.831406934389657, -119.268333435059, -2.08162511180821, 218, 56, 'PPL', 'P'),
(54804, 'Fordham', 39.8300018310547, 0.695164673027275, -94.2702789306641, -1.64532675411353, 218, 29, 'PPL', 'P'),
(102005, 'Fordham', 37.0374984741211, 0.646426295075789, -76.3144378662109, -1.33193820757402, 218, 53, 'PPL', 'P'),
(148879, 'Fordham', 40.8591690063477, 0.713127028789586, -73.8988876342773, -1.28977890277946, 218, 40, 'PPL', 'P'),
(161711, 'Fordham', 40.9150009155273, 0.714101479432447, -79.033332824707, -1.37939187661565, 218, 45, 'PPL', 'P'),
(174130, 'Fordham (historical)', 43.9819412231445, 0.767629685762494, -89.7388916015625, -1.56623912553755, 218, 57, 'PPL', 'P'),
(54805, 'Fordland', 37.1575012207031, 0.648520738115082, -92.940559387207, -1.62211876995209, 218, 29, 'PPL', 'P'),
(102006, 'Fordland Estates', 36.7333297729492, 0.641117549758825, -78.8944396972656, -1.3769677342334, 218, 53, 'PPL', 'P'),
(130832, 'Fordney', 43.2730598449707, 0.755257371707286, -84.309440612793, -1.47147732920786, 218, 27, 'PPL', 'P'),
(40942, 'Fordoche', 30.5958309173584, 0.533997986891381, -91.6163864135742, -1.59900759169627, 218, 22, 'PPL', 'P'),
(40944, 'Fords', 32.5480613708496, 0.568070836062505, -92.9952774047852, -1.62307377951899, 218, 22, 'PPL', 'P'),
(102007, 'Fords', 37.6861114501953, 0.657746727079443, -77.7147216796875, -1.35637777058156, 218, 53, 'PPL', 'P'),
(145241, 'Fords', 40.5291709899902, 0.707367476879099, -74.3163909912109, -1.29706571099608, 218, 37, 'PPL', 'P'),
(40943, 'Fords (historical)', 30.5722198486328, 0.533585896002205, -92.7930603027344, -1.61954442528436, 218, 22, 'PPL', 'P'),
(35949, 'Fords Branch', 37.4330596923828, 0.653330140727656, -82.5111083984375, -1.44009051102268, 218, 21, 'PPL', 'P'),
(13777, 'Fords Corner', 39.1925010681152, 0.684038185730005, -75.6999969482422, -1.32121419049649, 218, 10, 'PPL', 'P'),
(94262, 'Fords Corner', 31.4816703796387, 0.549458802152268, -94.0058288574219, -1.64071122962831, 218, 51, 'PPL', 'P'),
(59929, 'Fords Creek', 30.9483299255371, 0.540150255194114, -89.6897201538086, -1.56538092187627, 218, 30, 'PPL', 'P'),
(143833, 'Fords Crossing', 43.547779083252, 0.760052126933864, -71.8908309936523, -1.25473170283402, 218, 36, 'PPL', 'P'),
(161726, 'Fords Edge', 40.1816711425781, 0.70130246039158, -75.529167175293, -1.31823264849809, 218, 45, 'PPL', 'P'),
(143834, 'Fords Mill', 43.541389465332, 0.759940607063217, -71.9002838134766, -1.25489668566355, 218, 36, 'PPL', 'P'),
(200835, 'Fords Mill', 44.5641708374023, 0.77779150953391, -122.720832824707, -2.14188259358067, 218, 43, 'PPL', 'P'),
(94263, 'Fords Prairie', 29.8958301544189, 0.521780668811615, -97.1600036621094, -1.69576196515356, 218, 51, 'PPL', 'P'),
(207435, 'Fords Prairie', 46.735279083252, 0.815684496841184, -122.987777709961, -2.14654166074971, 218, 56, 'PPL', 'P'),
(47117, 'Fords Wharf (historical)', 38.0697212219238, 0.66444198063893, -75.8308334350586, -1.32349771797317, 218, 25, 'PPL', 'P'),
(148880, 'Fordsbush', 42.9594383239746, 0.749783643560791, -74.7425003051758, -1.30450272149818, 218, 40, 'PPL', 'P'),
(35950, 'Fordsville', 37.6361083984375, 0.656874009190224, -86.7174987792969, -1.51350587279289, 218, 21, 'PPL', 'P'),
(102008, 'Fordsville', 38.4013900756836, 0.670230694163353, -78.1163864135742, -1.36338814267703, 218, 53, 'PPL', 'P'),
(59930, 'Fordsville (historical)', 31.0588893890381, 0.542079881851445, -89.7608337402344, -1.56662208810231, 218, 30, 'PPL', 'P'),
(87029, 'Fordtown', 36.4527816772461, 0.636221061778605, -82.5036087036133, -1.4399596166551, 218, 50, 'PPL', 'P'),
(94264, 'Fordtran', 29.0669403076172, 0.507313811848573, -97.0083312988281, -1.69311478303002, 218, 51, 'PPL', 'P'),
(161712, 'Fordview', 40.7702789306641, 0.711575604296561, -79.523063659668, -1.38793929213426, 218, 45, 'PPL', 'P'),
(16057, 'Fordville', 27.3377799987793, 0.47713427116455, -82.4161071777344, -1.438432426928, 218, 12, 'PPL', 'P'),
(70827, 'Fordville', 39.4252815246582, 0.688100971130976, -75.170280456543, -1.31196889361422, 218, 37, 'PPL', 'P'),
(78285, 'Fordville', 39.9513893127441, 0.69728328425346, -76.9127807617188, -1.34238126115654, 218, 45, 'PPL', 'P'),
(140028, 'Fordville', 48.2174987792969, 0.841554110775077, -97.790283203125, -1.70676241835224, 218, 34, 'PPL', 'P'),
(178197, 'Fordville', 32.7044410705566, 0.570800176705673, -110.69361114502, -1.93196797540288, 218, 5, 'PPL', 'P'),
(87030, 'Fordville (historical)', 36.0936088562012, 0.629952313467695, -82.476936340332, -1.43949409609656, 218, 50, 'PPL', 'P'),
(102009, 'Fordwick', 38.0733299255371, 0.66450496439871, -79.3741683959961, -1.38534057954256, 218, 53, 'PPL', 'P'),
(2516, 'Fordyce', 32.9497184753418, 0.57508107499992, -85.585563659668, -1.49374987803641, 218, 2, 'PPL', 'P'),
(8926, 'Fordyce', 33.8136100769043, 0.590158827827513, -92.4127807617188, -1.61290729521567, 218, 4, 'PPL', 'P'),
(78286, 'Fordyce', 39.8474998474121, 0.695470071025279, -80.0811080932617, -1.3976790048729, 218, 45, 'PPL', 'P'),
(141829, 'Fordyce', 42.6986083984375, 0.745231302572437, -97.3619384765625, -1.69928639254017, 218, 35, 'PPL', 'P'),
(112434, 'Fordyke', 32.9049987792969, 0.574300569063445, -90.1275024414063, -1.57302166420177, 218, 30, 'PPL', 'P'),
(102010, 'Fore Store', 37.4019393920898, 0.652786989023334, -78.6736068725586, -1.37311347434579, 218, 53, 'PPL', 'P'),
(181627, 'Forebay', 39.2366714477539, 0.684809104286556, -120.735557556152, -2.10723300358598, 218, 6, 'PPL', 'P'),
(194939, 'Forebay', 46.4236106872559, 0.810244857156642, -116.959167480469, -2.04132256292566, 218, 17, 'PPL', 'P'),
(8924, 'Foreman', 33.7216682434082, 0.588554140112686, -94.3966674804688, -1.64753265044444, 218, 4, 'PPL', 'P'),
(40945, 'Foreman', 30.3688907623291, 0.530037133981134, -91.0097198486328, -1.58841926267628, 218, 22, 'PPL', 'P'),
(75850, 'Foreman', 35.3347206115723, 0.61670721494424, -94.6366729736328, -1.65172153652303, 218, 42, 'PPL', 'P'),
(161713, 'Foreman', 40.0777816772461, 0.6994892471634, -78.3916702270508, -1.36819275159965, 218, 45, 'PPL', 'P'),
(47130, 'Foremans Corner', 39.1858291625977, 0.683921739011342, -76.5519409179688, -1.33608341781073, 218, 25, 'PPL', 'P'),
(40946, 'Foremans Hall', 30.1861095428467, 0.526846999890355, -92.9291687011719, -1.62191996497671, 218, 22, 'PPL', 'P'),
(178198, 'Forepaugh', 33.9713897705078, 0.592912602973682, -113.045562744141, -1.97301727465509, 218, 5, 'PPL', 'P'),
(122624, 'Foresman', 40.8661117553711, 0.713248202619185, -87.2949981689453, -1.52358513857052, 218, 19, 'PPL', 'P'),
(2517, 'Forest', 33.4908294677734, 0.584525243436587, -88.2758331298828, -1.54070393805755, 218, 2, 'PPL', 'P'),
(13778, 'Forest', 39.3666687011719, 0.687077984377249, -75.6777801513672, -1.32082643424177, 218, 10, 'PPL', 'P'),
(40948, 'Forest', 32.7919387817383, 0.572327299853751, -91.413330078125, -1.59546359007565, 218, 22, 'PPL', 'P'),
(59931, 'Forest', 32.3644409179688, 0.564866054585731, -89.4741668701172, -1.56161880736237, 218, 30, 'PPL', 'P'),
(64796, 'Forest', 35.1613883972168, 0.613681997103965, -77.0475006103516, -1.34473256608298, 218, 33, 'PPL', 'P'),
(94265, 'Forest', 31.5157108306885, 0.550052920101951, -95.01171875, -1.65826732016633, 218, 51, 'PPL', 'P'),
(102013, 'Forest', 37.3636093139648, 0.652118002957506, -79.2900009155273, -1.38387157988527, 218, 53, 'PPL', 'P'),
(122625, 'Forest', 40.3736114501953, 0.704652450726791, -86.3327789306641, -1.50679124473648, 218, 19, 'PPL', 'P'),
(127494, 'Forest', 45.5711097717285, 0.795365909304424, -67.7283325195313, -1.18208239935137, 218, 26, 'PPL', 'P'),
(148897, 'Forest', 44.9019393920898, 0.783686682922909, -73.7563934326172, -1.28729190979549, 218, 40, 'PPL', 'P'),
(155298, 'Forest', 40.8016700744629, 0.712123483111817, -83.5105590820313, -1.4575342161627, 218, 41, 'PPL', 'P'),
(161714, 'Forest', 40.9247207641602, 0.714271122793884, -77.6894378662109, -1.35593648478894, 218, 45, 'PPL', 'P'),
(174131, 'Forest', 45.1366691589355, 0.787783490206805, -92.2594375610352, -1.61023095147819, 218, 57, 'PPL', 'P'),
(181628, 'Forest', 39.4913902282715, 0.689254785673252, -120.851936340332, -2.10926419654938, 218, 6, 'PPL', 'P'),
(194940, 'Forest', 46.1480598449707, 0.805435587702123, -116.656669616699, -2.03604297922263, 218, 17, 'PPL', 'P'),
(155299, 'Forest (historical)', 40.9519386291504, 0.714746164153327, -82.686393737793, -1.44314981732491, 218, 41, 'PPL', 'P'),
(2518, 'Forest Acres', 33.625560760498, 0.586876748100099, -86.6897201538086, -1.51302104431645, 218, 2, 'PPL', 'P'),
(21175, 'Forest Acres', 33.7813911437988, 0.589596501363343, -84.6438903808594, -1.47731457884315, 218, 13, 'PPL', 'P'),
(70822, 'Forest Acres', 39.9613914489746, 0.697457854462915, -74.1736068725586, -1.29457365800604, 218, 37, 'PPL', 'P'),
(81036, 'Forest Acres', 35.0097198486328, 0.611034881559453, -81.039436340332, -1.41440498809914, 218, 48, 'PPL', 'P'),
(102011, 'Forest Acres', 37.1366691589355, 0.648157150047259, -77.352783203125, -1.3500607524759, 218, 53, 'PPL', 'P'),
(196500, 'Forest Acres Mobile Home Park', 48.3333282470703, 0.843575716358556, -114.33332824707, -1.99549302267481, 218, 31, 'PPL', 'P'),
(81042, 'Forest Beach', 32.1463890075684, 0.56106033080898, -80.7438888549805, -1.40924671138376, 218, 48, 'PPL', 'P'),
(130833, 'Forest Beach', 45.434440612793, 0.792980582495067, -85.022216796875, -1.4839176204499, 218, 27, 'PPL', 'P'),
(148881, 'Forest Beach', 43.2205581665039, 0.754341044555217, -76.0919418334961, -1.32805491923052, 218, 40, 'PPL', 'P'),
(207437, 'Forest Beach', 47.2941703796387, 0.825438990123871, -122.687217712402, -2.14129589919253, 218, 56, 'PPL', 'P'),
(21177, 'Forest Brook', 33.9766693115234, 0.593004748347399, -84.399169921875, -1.47304340108688, 218, 13, 'PPL', 'P'),
(13779, 'Forest Brook Glen', 39.7166709899902, 0.693186676706645, -75.5999984741211, -1.3194688878761, 218, 10, 'PPL', 'P'),
(102012, 'Forest Brook Hills', 37.4091682434082, 0.652913156279977, -79.208610534668, -1.38245104975982, 218, 53, 'PPL', 'P'),
(135407, 'Forest Center', 47.7949981689453, 0.834180084032757, -91.307502746582, -1.59361655470162, 218, 28, 'PPL', 'P'),
(94266, 'Forest Chapel', 33.8650016784668, 0.591055780482652, -95.616943359375, -1.66883048231402, 218, 51, 'PPL', 'P'),
(161715, 'Forest Chapel', 41.9811096191406, 0.732708586494667, -79.3977813720703, -1.38575270372125, 218, 45, 'PPL', 'P'),
(16058, 'Forest City', 28.6613903045654, 0.500235629013847, -81.4191665649414, -1.42103253078791, 218, 12, 'PPL', 'P'),
(32459, 'Forest City', 37.3224983215332, 0.651400480780812, -98.7302780151367, -1.72316842277351, 218, 20, 'PPL', 'P'),
(54806, 'Forest City', 39.9824981689453, 0.6978262362207, -95.1916732788086, -1.66140811919792, 218, 29, 'PPL', 'P'),
(64792, 'Forest City', 35.3338890075684, 0.616692700716299, -81.8652801513672, -1.42881868170892, 218, 33, 'PPL', 'P'),
(115596, 'Forest City', 43.2625007629395, 0.755073080959852, -93.6369400024414, -1.63427290453499, 218, 16, 'PPL', 'P'),
(119649, 'Forest City', 40.3699989318848, 0.704589400387983, -89.8274993896484, -1.56778562318256, 218, 18, 'PPL', 'P'),
(122626, 'Forest City', 41.1947212219238, 0.718983519763753, -87.2666702270508, -1.52309072271414, 218, 19, 'PPL', 'P'),
(127495, 'Forest City', 45.6597213745117, 0.79691247352846, -67.7302780151367, -1.18211635465527, 218, 26, 'PPL', 'P'),
(135408, 'Forest City', 45.2063903808594, 0.789000355087889, -94.4661102294922, -1.64874465505653, 218, 28, 'PPL', 'P'),
(148882, 'Forest City', 43.9519386291504, 0.767106041713157, -75.442497253418, -1.31671997299892, 218, 40, 'PPL', 'P'),
(161716, 'Forest City', 41.6513900756836, 0.726953894853169, -75.4669418334961, -1.31714661140555, 218, 45, 'PPL', 'P'),
(202134, 'Forest City', 45.0027809143066, 0.785446699508315, -100.300003051758, -1.75056529301353, 218, 49, 'PPL', 'P'),
(115597, 'Forest City (historical)', 43.485279083252, 0.758961296151368, -92.2380599975586, -1.60985784260947, 218, 16, 'PPL', 'P'),
(127496, 'Forest City Landing', 45.6591682434082, 0.796902819569509, -67.7041702270508, -1.18166068779275, 218, 26, 'PPL', 'P'),
(161717, 'Forest City Station', 41.6500015258789, 0.726929660087249, -75.4577789306641, -1.31698668858209, 218, 45, 'PPL', 'P'),
(21178, 'Forest Creek', 33.5391693115234, 0.585368932869924, -82.0838928222656, -1.43263419260268, 218, 13, 'PPL', 'P'),
(21179, 'Forest Creek Colony', 33.9613914489746, 0.592738099343255, -84.7805633544922, -1.47969997223154, 218, 13, 'PPL', 'P'),
(203995, 'Forest Creek Cove', 40.6133308410645, 0.708836343378333, -111.834167480469, -1.95187443876095, 218, 52, 'PPL', 'P'),
(200836, 'Forest Crossing', 44.3488883972168, 0.774034122130944, -121.079719543457, -2.11323976342465, 218, 43, 'PPL', 'P'),
(102037, 'Forest Dale', 37.371940612793, 0.652263411553025, -79.2472229003906, -1.38312496267367, 218, 53, 'PPL', 'P'),
(172027, 'Forest Dale', 43.8277816772461, 0.764939094113187, -73.0541687011719, -1.27503577614284, 218, 55, 'PPL', 'P'),
(203996, 'Forest Dale', 40.7166709899902, 0.710639969226589, -111.861106872559, -1.9523446198514, 218, 52, 'PPL', 'P'),
(64793, 'Forest Drive', 35.377498626709, 0.617453832155844, -80.1819381713867, -1.39943882172122, 218, 33, 'PPL', 'P'),
(21181, 'Forest Echo', 33.8916702270508, 0.59152123446217, -84.815559387207, -1.48031076822755, 218, 13, 'PPL', 'P'),
(21183, 'Forest Estates', 33.4791717529297, 0.584321777929305, -82.0722198486328, -1.43243046077928, 218, 13, 'PPL', 'P'),
(47119, 'Forest Estates', 39.021110534668, 0.681046856614601, -77.0400009155273, -1.3446016717154, 218, 25, 'PPL', 'P'),
(181629, 'Forest Falls', 34.0883293151855, 0.594953583054092, -116.919441223145, -2.04062920893586, 218, 6, 'PPL', 'P'),
(172028, 'Forest Farms', 43.1277809143066, 0.752721776033421, -72.8775024414063, -1.27195236823274, 218, 55, 'PPL', 'P'),
(81044, 'Forest Fields', 32.4091682434082, 0.56564669368026, -80.7388916015625, -1.40915949285806, 218, 48, 'PPL', 'P'),
(47120, 'Forest Gardens', 38.8352813720703, 0.677803525881048, -75.9824981689453, -1.32614476693866, 218, 25, 'PPL', 'P'),
(47121, 'Forest Glade', 38.461109161377, 0.671272988834983, -76.5472183227539, -1.33600099297499, 218, 25, 'PPL', 'P'),
(94267, 'Forest Glade', 31.6305599212646, 0.552057414875426, -96.5216674804688, -1.68462089704932, 218, 51, 'PPL', 'P'),
(207438, 'Forest Glade', 47.9816703796387, 0.837438128731332, -121.971939086914, -2.12881193210862, 218, 56, 'PPL', 'P'),
(21185, 'Forest Glen', 31.8716697692871, 0.556265575582402, -83.2436065673828, -1.45287501583561, 218, 13, 'PPL', 'P'),
(47122, 'Forest Glen', 39.0144386291504, 0.680930409895937, -77.0550003051758, -1.34486346045055, 218, 25, 'PPL', 'P'),
(87031, 'Forest Glen', 35.6755599975586, 0.622655984450178, -84.0063934326172, -1.46618815812491, 218, 50, 'PPL', 'P'),
(122627, 'Forest Glen', 41.3266716003418, 0.721286488316399, -85.7636108398438, -1.49685738755437, 218, 19, 'PPL', 'P'),
(148884, 'Forest Glen', 41.7038917541504, 0.727870222005238, -74.1286087036133, -1.29378829180058, 218, 40, 'PPL', 'P'),
(161720, 'Forest Glen', 41.1150016784668, 0.717592151252241, -75.5599975585938, -1.31877074019634, 218, 45, 'PPL', 'P'),
(193562, 'Forest Glen', 40.3733291625977, 0.704647523878774, -123.324172973633, -2.1524128656889, 218, 6, 'PPL', 'P'),
(203997, 'Forest Glen', 40.6152801513672, 0.708870365261258, -111.580558776855, -1.94744813187118, 218, 52, 'PPL', 'P'),
(40949, 'Forest Glen (historical)', 30.3250007629395, 0.529271108983086, -89.9730606079102, -1.57032614570444, 218, 22, 'PPL', 'P'),
(174133, 'Forest Glen Beach', 43.8169403076172, 0.764749876517737, -88.9322204589844, -1.55216005811874, 218, 57, 'PPL', 'P'),
(40950, 'Forest Glen Estates', 30.5119400024414, 0.532533814213569, -91.0038909912109, -1.58831752992264, 218, 22, 'PPL', 'P'),
(47123, 'Forest Glen Estates', 38.6150016784668, 0.673958919952382, -76.8166732788086, -1.34070386914396, 218, 25, 'PPL', 'P'),
(47124, 'Forest Glen Park', 39.0113906860352, 0.680877213253163, -77.059440612793, -1.34494095843827, 218, 25, 'PPL', 'P'),
(102014, 'Forest Glen Terrace', 36.7158317565918, 0.64081215176082, -76.6597213745117, -1.3379645416467, 218, 53, 'PPL', 'P'),
(2521, 'Forest Green', 33.230281829834, 0.579977829296249, -87.7077789306641, -1.5307895219514, 218, 2, 'PPL', 'P'),
(54807, 'Forest Green', 39.314998626709, 0.686176171453121, -92.8375015258789, -1.62032007095185, 218, 29, 'PPL', 'P'),
(196501, 'Forest Green', 46.7613906860352, 0.816140230282724, -110.739723205566, -1.9327727826843, 218, 31, 'PPL', 'P'),
(47125, 'Forest Green Court', 39.6322212219238, 0.691712750201341, -75.8902816772461, -1.32453528553387, 218, 25, 'PPL', 'P'),
(130844, 'Forest Green Estates', 42.814998626709, 0.747262695272922, -84.2702789306641, -1.47079382891409, 218, 27, 'PPL', 'P'),
(2522, 'Forest Green Park', 33.2366714477539, 0.580089349166896, -87.7169418334961, -1.53094944477486, 218, 2, 'PPL', 'P'),
(47126, 'Forest Greens', 39.4569396972656, 0.68865351047814, -76.2291717529297, -1.33045003315688, 218, 25, 'PPL', 'P'),
(8928, 'Forest Grove', 33.1338882446289, 0.578295443856619, -93.5122222900391, -1.63209616981801, 218, 4, 'PPL', 'P'),
(16059, 'Forest Grove', 29.7416706085205, 0.519090077162308, -82.5822219848633, -1.44133167724871, 218, 12, 'PPL', 'P'),
(35951, 'Forest Grove', 37.9455604553223, 0.662274966459932, -84.2244415283203, -1.46999381532263, 218, 21, 'PPL', 'P'),
(40951, 'Forest Grove', 32.8194389343262, 0.572807268061211, -92.9700012207031, -1.62263262688442, 218, 22, 'PPL', 'P'),
(47128, 'Forest Grove', 38.3727798461914, 0.669731351458963, -75.4744415283203, -1.31727750577313, 218, 25, 'PPL', 'P'),
(59933, 'Forest Grove', 32.7305603027344, 0.571256043305267, -89.7127838134766, -1.56578345867504, 218, 30, 'PPL', 'P'),
(64794, 'Forest Grove', 36.3002815246582, 0.633559432006153, -81.807502746582, -1.42781027576216, 218, 33, 'PPL', 'P'),
(70824, 'Forest Grove', 39.5272216796875, 0.68988016247623, -74.9866714477539, -1.30876431187453, 218, 37, 'PPL', 'P'),
(87033, 'Forest Grove', 35.5819396972656, 0.62102200196336, -84.7930603027344, -1.47991808512481, 218, 50, 'PPL', 'P'),
(94269, 'Forest Grove', 30.5461292266846, 0.533130528745315, -96.9993591308594, -1.69295818915792, 218, 51, 'PPL', 'P'),
(130834, 'Forest Grove', 42.7966690063477, 0.746942783046977, -85.8616714477539, -1.49856886802891, 218, 27, 'PPL', 'P'),
(135410, 'Forest Grove', 47.9766693115234, 0.837350843626605, -94.2311096191406, -1.6446431206617, 218, 28, 'PPL', 'P'),
(161722, 'Forest Grove', 40.2922210693359, 0.703231920601343, -75.059440612793, -1.31003437339839, 218, 45, 'PPL', 'P'),
(200837, 'Forest Grove', 45.5200004577637, 0.794473883497302, -123.109443664551, -2.14866513224488, 218, 43, 'PPL', 'P'),
(47129, 'Forest Grove (historical)', 39.0169410705566, 0.680974085737815, -77.0411071777344, -1.3446209796333, 218, 25, 'PPL', 'P'),
(130835, 'Forest Grove Station', 42.8111114501953, 0.747194851244153, -85.8816680908203, -1.49891787528977, 218, 27, 'PPL', 'P'),
(21186, 'Forest Heights', 32.4327812194824, 0.56605881785895, -81.8241729736328, -1.42810122611125, 218, 13, 'PPL', 'P'),
(47131, 'Forest Heights', 38.809440612793, 0.677352519550443, -76.9983291625977, -1.3438743624217, 218, 25, 'PPL', 'P'),
(81045, 'Forest Heights', 33.8855590820313, 0.591414574860513, -80.3047180175781, -1.40158173429235, 218, 48, 'PPL', 'P'),
(87034, 'Forest Heights', 35.8274993896484, 0.625307827105624, -84.2358322143555, -1.47019262029801, 218, 50, 'PPL', 'P'),
(94270, 'Forest Heights', 30.2380599975586, 0.527753706372986, -93.7586135864258, -1.63639650918822, 218, 51, 'PPL', 'P'),
(113447, 'Forest Heights', 41.2391700744629, 0.719759298589293, -73.0438919067383, -1.27485641224342, 218, 8, 'PPL', 'P'),
(196502, 'Forest Heights', 46.5783309936523, 0.812945235922955, -112.295562744141, -1.95992730526513, 218, 31, 'PPL', 'P'),
(16060, 'Forest Highlands', 30.7069396972656, 0.535937200928636, -86.3838882446289, -1.5076832705436, 218, 12, 'PPL', 'P'),
(87035, 'Forest Highlands', 35.1202812194824, 0.612964541506298, -85.2688903808594, -1.48822288666812, 218, 50, 'PPL', 'P'),
(2524, 'Forest Hill', 30.7147197723389, 0.536072988854716, -88.1533279418945, -1.53856581917638, 218, 2, 'PPL', 'P'),
(29820, 'Forest Hill', 37.978328704834, 0.662846880304027, -87.6097183227539, -1.52907804147686, 218, 19, 'PPL', 'P'),
(35952, 'Forest Hill', 37.0533294677734, 0.646702598038885, -88.6383285522461, -1.54703067670119, 218, 21, 'PPL', 'P'),
(40953, 'Forest Hill', 31.0416698455811, 0.541779344122429, -92.5311126708984, -1.61497257664102, 218, 22, 'PPL', 'P'),
(47132, 'Forest Hill', 39.5849990844727, 0.690888568422989, -76.3880615234375, -1.33322318279998, 218, 25, 'PPL', 'P'),
(59934, 'Forest Hill', 32.2652816772461, 0.563135399351343, -90.2808303833008, -1.57569774162313, 218, 30, 'PPL', 'P'),
(75852, 'Forest Hill', 34.9275016784668, 0.609599903785091, -94.6194381713867, -1.6514207324779, 218, 42, 'PPL', 'P'),
(87039, 'Forest Hill', 35.063060760498, 0.611965856097518, -89.7591705322266, -1.56659305964642, 218, 50, 'PPL', 'P'),
(94274, 'Forest Hill', 32.8363914489746, 0.573103145258319, -95.4177780151367, -1.6653543913012, 218, 51, 'PPL', 'P'),
(102015, 'Forest Hill', 37.415828704834, 0.653029403261559, -79.2038879394531, -1.38236862492408, 218, 53, 'PPL', 'P'),
(109240, 'Forest Hill', 37.5699996948242, 0.655720194647947, -80.7897186279297, -1.41004659181717, 218, 58, 'PPL', 'P'),
(130836, 'Forest Hill', 43.4366683959961, 0.758112879607096, -84.6855621337891, -1.47804188813685, 218, 27, 'PPL', 'P'),
(155300, 'Forest Hill', 41.0963897705078, 0.717267312178278, -81.4925003051758, -1.4223124460078, 218, 41, 'PPL', 'P'),
(161723, 'Forest Hill', 40.9744415283203, 0.715138913835087, -77.0497207641602, -1.34477131507684, 218, 45, 'PPL', 'P'),
(87041, 'Forest Hill (historical)', 35.3213882446289, 0.616474521243995, -86.9711074829102, -1.51793217968266, 218, 50, 'PPL', 'P'),
(47133, 'Forest Hill Farms', 39.3752784729004, 0.687228253241757, -76.9141693115234, -1.34240549592246, 218, 25, 'PPL', 'P'),
(102018, 'Forest Hill Park', 37.2813911437988, 0.650683025183144, -76.6888885498047, -1.33847360488907, 218, 53, 'PPL', 'P'),
(196503, 'Forest Hill Village', 48.1180610656738, 0.8398185952717, -114.256942749023, -1.99415984423312, 218, 31, 'PPL', 'P'),
(2527, 'Forest Hills', 33.2958297729492, 0.58112185672152, -86.3361129760742, -1.5068494348063, 218, 2, 'PPL', 'P'),
(13098, 'Forest Hills', 38.9508285522461, 0.67982020461651, -77.0583267211914, -1.34492151736232, 218, 9, 'PPL', 'P'),
(16062, 'Forest Hills', 28.1777801513672, 0.491795039544464, -82.7319412231445, -1.4439447709103, 218, 12, 'PPL', 'P'),
(21193, 'Forest Hills', 33.4811096191406, 0.584355600075149, -82.0397186279297, -1.4318632074671, 218, 13, 'PPL', 'P'),
(32460, 'Forest Hills', 37.6902809143066, 0.65781949795623, -97.2383270263672, -1.69712896574109, 218, 20, 'PPL', 'P'),
(35955, 'Forest Hills', 37.6380615234375, 0.656908097652177, -82.2938919067383, -1.4362993680529, 218, 21, 'PPL', 'P'),
(47136, 'Forest Hills', 39.6852798461914, 0.692638797891389, -77.7180633544922, -1.35643609380944, 218, 25, 'PPL', 'P'),
(64804, 'Forest Hills', 35.7038917541504, 0.623150466885578, -78.6188888549805, -1.37215846477888, 218, 33, 'PPL', 'P'),
(72572, 'Forest Hills', 39.1091690063477, 0.682583766879686, -83.0100021362305, -1.44879784936475, 218, 41, 'PPL', 'P'),
(81055, 'Forest Hills', 34.9863891601563, 0.61062768422878, -81.0186080932617, -1.41404146661034, 218, 48, 'PPL', 'P'),
(87046, 'Forest Hills', 36.5902786254883, 0.638620836236876, -82.1458282470703, -1.43371516968914, 218, 50, 'PPL', 'P'),
(102022, 'Forest Hills', 36.8863906860352, 0.643788966648283, -76.0638885498047, -1.32756529706411, 218, 53, 'PPL', 'P'),
(119653, 'Forest Hills', 41.9161109924316, 0.73157414644932, -88.4236068725586, -1.54328307641523, 218, 18, 'PPL', 'P'),
(122628, 'Forest Hills', 40.1236114501953, 0.700289127596805, -85.6966705322266, -1.49568905878415, 218, 19, 'PPL', 'P'),
(124858, 'Forest Hills', 42.2966690063477, 0.738216136787005, -71.1041717529297, -1.24100190899217, 218, 23, 'PPL', 'P'),
(130838, 'Forest Hills', 42.9594383239746, 0.749783643560791, -85.4897232055664, -1.49207714655574, 218, 27, 'PPL', 'P'),
(148885, 'Forest Hills', 40.7161102294922, 0.710630182109583, -73.8505630493164, -1.28893547966223, 218, 40, 'PPL', 'P'),
(161725, 'Forest Hills', 40.3416709899902, 0.70409498453161, -76.836669921875, -1.34105287640481, 218, 45, 'PPL', 'P'),
(177221, 'Forest Hills', 40.0872192382813, 0.699653963676821, -80.6986083984375, -1.40845641833028, 218, 58, 'PPL', 'P'),
(181631, 'Forest Hills', 38.5080604553223, 0.6720924435024, -122.923332214355, -2.14541687466332, 218, 6, 'PPL', 'P'),
(102023, 'Forest Hills (historical)', 37.2150001525879, 0.649524283792851, -80.39111328125, -1.40308961610155, 218, 53, 'PPL', 'P'),
(72574, 'Forest Hills Estates', 39.086109161377, 0.682181296659948, -84.3219375610352, -1.47169544210114, 218, 41, 'PPL', 'P'),
(102026, 'Forest Hills Estates', 38.8863906860352, 0.67869555168817, -77.5738906860352, -1.35391980605348, 218, 53, 'PPL', 'P'),
(21195, 'Forest Hills Mobile Home Park', 33.6338882446289, 0.58702209011659, -84.3822174072266, -1.47274752388978, 218, 13, 'PPL', 'P'),
(13780, 'Forest Hills Park', 39.7874984741211, 0.694422849505633, -75.5250015258789, -1.31815994420033, 218, 10, 'PPL', 'P'),
(2533, 'Forest Home', 31.8622207641602, 0.556100659331898, -86.8427810668945, -1.5156924612059, 218, 2, 'PPL', 'P'),
(40955, 'Forest Home', 32.5463905334473, 0.568041674448568, -92.0894393920898, -1.60726392370773, 218, 22, 'PPL', 'P'),
(87052, 'Forest Home', 35.975830078125, 0.62789668600129, -86.9269409179688, -1.51716132770514, 218, 50, 'PPL', 'P'),
(148886, 'Forest Home', 42.4536094665527, 0.740955264547179, -76.4683303833008, -1.33462413869142, 218, 40, 'PPL', 'P'),
(203999, 'Forest Home', 40.7066688537598, 0.710465399017134, -111.615562438965, -1.94805906102525, 218, 52, 'PPL', 'P'),
(181632, 'Forest Home (historical)', 38.4650001525879, 0.67134089944278, -120.96305847168, -2.11120364361323, 218, 6, 'PPL', 'P'),
(87053, 'Forest Home Farms', 35.9708290100098, 0.627809400896563, -86.9499969482422, -1.51756373134585, 218, 50, 'PPL', 'P'),
(27185, 'Forest Homes', 38.9144401550293, 0.679185107275554, -90.0858306884766, -1.57229435490807, 218, 18, 'PPL', 'P'),
(16063, 'Forest Island Park', 26.4911098480225, 0.462357089355487, -81.8611068725586, -1.42874584425311, 218, 12, 'PPL', 'P'),
(174134, 'Forest Junction', 44.2125015258789, 0.771653722169604, -88.144172668457, -1.53840602951097, 218, 57, 'PPL', 'P'),
(47137, 'Forest Knoll', 39.6916694641113, 0.692750317762036, -76.8530578613281, -1.34133889990589, 218, 25, 'PPL', 'P'),
(148887, 'Forest Knolls', 40.9386100769043, 0.714513537032109, -73.7761077880859, -1.28763599020833, 218, 40, 'PPL', 'P'),
(181634, 'Forest Knolls', 39.2383308410645, 0.684838066163411, -121.004173278809, -2.11192123236895, 218, 6, 'PPL', 'P'),
(47138, 'Forest Lake', 39.5569381713867, 0.690398813098523, -76.3888931274414, -1.33323769702792, 218, 25, 'PPL', 'P'),
(81061, 'Forest Lake', 35.0688896179199, 0.612067588851159, -80.9361114501953, -1.41260162856699, 218, 48, 'PPL', 'P'),
(119654, 'Forest Lake', 42.2075004577637, 0.73665985202499, -88.0555572509766, -1.53685939870791, 218, 18, 'PPL', 'P'),
(135411, 'Forest Lake', 45.2788887023926, 0.790265689500813, -92.9850006103516, -1.62289441561957, 218, 28, 'PPL', 'P'),
(161727, 'Forest Lake', 41.8841705322266, 0.731016680254139, -75.959716796875, -1.32574715698791, 218, 45, 'PPL', 'P'),
(181635, 'Forest Lake', 38.8180618286133, 0.677502988152033, -122.716667175293, -2.14180988928291, 218, 6, 'PPL', 'P'),
(81063, 'Forest Lake Estates', 33.851390838623, 0.590818226513417, -80.4136123657227, -1.40348229920429, 218, 48, 'PPL', 'P'),
(102027, 'Forest Lake Estates', 38.9266700744629, 0.679398559636924, -77.6452789306641, -1.35516576596947, 218, 53, 'PPL', 'P'),
(102028, 'Forest Lake Hills', 37.7030601501465, 0.658042537697524, -77.4069366455078, -1.35100590834677, 218, 53, 'PPL', 'P'),
(81065, 'Forest Lake Homes', 35.1069412231445, 0.612731714647997, -81.6425018310547, -1.4249304665174, 218, 48, 'PPL', 'P'),
(161729, 'Forest Lake Park', 41.5363883972168, 0.724946736918603, -75.0952835083008, -1.31065994993845, 218, 45, 'PPL', 'P'),
(81066, 'Forest Lake South', 34.1538887023926, 0.596097810216444, -79.8424987792969, -1.39351448671828, 218, 48, 'PPL', 'P'),
(21197, 'Forest Lakes', 33.5486106872559, 0.585533715962372, -83.9661102294922, -1.46548508359713, 218, 13, 'PPL', 'P'),
(81067, 'Forest Lakes', 32.8166694641113, 0.572758931687426, -80.0486068725586, -1.39711175156071, 218, 48, 'PPL', 'P'),
(178199, 'Forest Lakes Estates', 34.3388900756836, 0.599326693301084, -110.799171447754, -1.933810350245, 218, 5, 'PPL', 'P'),
(16064, 'Forest Lakes Park', 29.0783290863037, 0.507512583534434, -81.8375015258789, -1.42833385323247, 218, 12, 'PPL', 'P'),
(13781, 'Forest Landing', 39.1175003051758, 0.682729175475204, -75.5036087036133, -1.3177865690155, 218, 10, 'PPL', 'P'),
(47139, 'Forest Lawn', 39.5180587768555, 0.689720239652771, -76.3372192382813, -1.33233581752477, 218, 25, 'PPL', 'P'),
(102029, 'Forest Lawn', 37.3033294677734, 0.65106592116887, -80.0355606079102, -1.39688405128751, 218, 53, 'PPL', 'P'),
(148888, 'Forest Lawn', 43.2488899230957, 0.754835526990617, -77.5036087036133, -1.35269315405539, 218, 40, 'PPL', 'P'),
(47140, 'Forest Manor', 38.8394393920898, 0.677876097020753, -76.8833312988281, -1.34186727106616, 218, 25, 'PPL', 'P'),
(21198, 'Forest Manor North', 33.9902801513672, 0.593242302316634, -84.1419372558594, -1.46855384412123, 218, 13, 'PPL', 'P'),
(102030, 'Forest Meadow Mobile Home Park', 37.5299987792969, 0.655022046968183, -77.2991714477539, -1.3491250508269, 218, 53, 'PPL', 'P'),
(47141, 'Forest Meadows', 39.0097198486328, 0.680848051639227, -76.4830627441406, -1.33488126689466, 218, 25, 'PPL', 'P'),
(181636, 'Forest Meadows', 38.1680603027344, 0.666158321382458, -120.404441833496, -2.10145394402051, 218, 6, 'PPL', 'P'),
(21199, 'Forest Mill', 33.5625, 0.585776130200597, -83.9416732788086, -1.46505857834855, 218, 13, 'PPL', 'P'),
(87055, 'Forest Mill', 35.5158309936523, 0.619868187421083, -86.0369415283203, -1.50162790801503, 218, 50, 'PPL', 'P'),
(54808, 'Forest Mills', 37.1766700744629, 0.648855297727023, -94.2152786254883, -1.64436681769861, 218, 29, 'PPL', 'P'),
(135414, 'Forest Mills', 44.297779083252, 0.773142096323822, -92.6405563354492, -1.61688272893288, 218, 28, 'PPL', 'P'),
(87056, 'Forest Mills (historical)', 36.6166687011719, 0.639081429947405, -87.0944366455078, -1.52008467963372, 218, 50, 'PPL', 'P'),
(40959, 'Forest Oaks', 32.4397201538086, 0.566179925109521, -92.0808334350586, -1.60711372142225, 218, 22, 'PPL', 'P'),
(47142, 'Forest Oaks', 39.4033317565918, 0.687717875408168, -76.9169387817383, -1.34245383229625, 218, 25, 'PPL', 'P'),
(64817, 'Forest Oaks', 35.9880599975586, 0.62811013836266, -79.7063903808594, -1.39113894702593, 218, 33, 'PPL', 'P'),
(87059, 'Forest of Brentwood', 36.0180587768555, 0.62863371583297, -86.8430633544922, -1.51569738805392, 218, 50, 'PPL', 'P'),
(2538, 'Forest Park', 30.6286106109619, 0.534570100472557, -88.0888900756836, -1.53744116624804, 218, 2, 'PPL', 'P'),
(13782, 'Forest Park', 39.7374992370605, 0.693550198195441, -75.6083297729492, -1.31961429647162, 218, 10, 'PPL', 'P'),
(21202, 'Forest Park', 33.5097198486328, 0.584854942779538, -82.0069427490234, -1.43129116046495, 218, 13, 'PPL', 'P'),
(40961, 'Forest Park', 32.547779083252, 0.568065909214488, -92.1533279418945, -1.60837898925615, 218, 22, 'PPL', 'P'),
(47146, 'Forest Park', 39.7027816772461, 0.692944262468421, -78.2997207641602, -1.36658793072677, 218, 25, 'PPL', 'P'),
(75853, 'Forest Park', 35.5041694641113, 0.619664655334773, -97.4458312988281, -1.70075059850749, 218, 42, 'PPL', 'P'),
(81070, 'Forest Park', 34.9513893127441, 0.610016821653743, -82.0158309936523, -1.43144628959845, 218, 48, 'PPL', 'P'),
(87057, 'Forest Park', 35.1808280944824, 0.614021283826841, -85.2880630493164, -1.48855751285909, 218, 50, 'PPL', 'P'),
(102032, 'Forest Park', 37.2897186279297, 0.650828367199635, -79.9822235107422, -1.39595314332847, 218, 53, 'PPL', 'P'),
(119656, 'Forest Park', 41.5458297729492, 0.725111520011052, -88.0563888549805, -1.53687391293585, 218, 18, 'PPL', 'P'),
(122629, 'Forest Park', 41.5505599975586, 0.725194078004844, -84.9252777099609, -1.48222571420937, 218, 19, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(124860, 'Forest Park', 42.0972213745117, 0.734735118926162, -71.4819412231445, -1.24759523006093, 218, 23, 'PPL', 'P'),
(148889, 'Forest Park', 42.3338890075684, 0.738865748355903, -79.6050033569336, -1.38936940963963, 218, 40, 'PPL', 'P'),
(155301, 'Forest Park', 41.5447196960449, 0.725092145514122, -83.3788909912109, -1.45523617445807, 218, 41, 'PPL', 'P'),
(161733, 'Forest Park', 41.1391716003418, 0.718013995968909, -75.0186080932617, -1.30932171149068, 218, 45, 'PPL', 'P'),
(181638, 'Forest Park', 37.1338882446289, 0.648108613936392, -122.137496948242, -2.13170146189135, 218, 6, 'PPL', 'P'),
(188558, 'Forest Park', 35.1163902282715, 0.612896630898501, -106.371940612793, -1.85654059542911, 218, 38, 'PPL', 'P'),
(196504, 'Forest Park', 47.1047210693359, 0.822132475893456, -104.757781982422, -1.82836821267965, 218, 31, 'PPL', 'P'),
(54809, 'Forest Park (historical)', 36.9327812194824, 0.644598634198695, -93.9230575561523, -1.639266597895, 218, 29, 'PPL', 'P'),
(29822, 'Forest Park Heights', 39.2094383239746, 0.684333796611004, -86.5886077880859, -1.5112563006201, 218, 19, 'PPL', 'P'),
(196505, 'Forest Park Mobile Home and RV Park', 45.6749992370605, 0.797179122532605, -111.206939697266, -1.94092724878407, 218, 31, 'PPL', 'P'),
(115599, 'Forest Park Mobile Home Court', 43.2733306884766, 0.755262098818221, -93.6355590820313, -1.63424880292712, 218, 16, 'PPL', 'P'),
(13783, 'Forest Park Mobile Home Park', 38.6183280944824, 0.674016976864146, -75.3280563354492, -1.31472260218136, 218, 10, 'PPL', 'P'),
(102034, 'Forest Park Mobile Home Village', 38.6644401550293, 0.674821784145568, -77.4361114501953, -1.35151510474719, 218, 53, 'PPL', 'P'),
(21205, 'Forest Pointe', 32.5672187805176, 0.568405195937364, -83.5738906860352, -1.45863956117314, 218, 13, 'PPL', 'P'),
(181639, 'Forest Ranch', 39.8822212219238, 0.696076073331327, -121.671669006348, -2.1235712305575, 218, 6, 'PPL', 'P'),
(21206, 'Forest Ridge', 33.6791687011719, 0.587812383170071, -84.2719421386719, -1.47082285736998, 218, 13, 'PPL', 'P'),
(122630, 'Forest Ridge', 41.0219383239746, 0.715967889303401, -85.2733306884766, -1.48830038465584, 218, 19, 'PPL', 'P'),
(21212, 'Forest River', 33.9838905334473, 0.593130782445987, -83.9941711425781, -1.4659748389216, 218, 13, 'PPL', 'P'),
(119657, 'Forest River', 42.0766716003418, 0.734376457706356, -87.8949966430664, -1.53405708745087, 218, 18, 'PPL', 'P'),
(140030, 'Forest River', 48.2152786254883, 0.841515361781216, -97.4677810668945, -1.7011336942303, 218, 34, 'PPL', 'P'),
(140032, 'Forest River Colony', 48.1822204589844, 0.840938387931051, -97.7030563354492, -1.70524002231509, 218, 34, 'PPL', 'P'),
(21208, 'Forest River Farms', 31.9902801513672, 0.558335717276747, -81.1758270263672, -1.41678545463951, 218, 13, 'PPL', 'P'),
(72577, 'Forest Run', 39.0327796936035, 0.681250521858965, -81.980827331543, -1.43083536044438, 218, 41, 'PPL', 'P'),
(181640, 'Forest Spring (historical)', 39.163330078125, 0.683529055908609, -121.062782287598, -2.11294415254365, 218, 6, 'PPL', 'P'),
(35956, 'Forest Springs', 36.6588897705078, 0.63981832662103, -86.1611099243164, -1.50379505535208, 218, 21, 'PPL', 'P'),
(139160, 'Forest Springs', 40.1861114501953, 0.701379958379301, -91.9550018310547, -1.60491754562932, 218, 29, 'PPL', 'P'),
(181641, 'Forest Springs', 37.1388893127441, 0.648195899041119, -122.14778137207, -2.13188095894882, 218, 6, 'PPL', 'P'),
(54810, 'Forest Spur', 36.5397186279297, 0.637738397809678, -89.8177795410156, -1.56761597982112, 218, 29, 'PPL', 'P'),
(21209, 'Forest Valley', 33.8899993896484, 0.591492072848234, -84.3713912963867, -1.47255857261044, 218, 13, 'PPL', 'P'),
(64823, 'Forest Valley Mobile Home Subdivision', 36.0441703796387, 0.629089449274509, -79.4458312988281, -1.38659133314851, 218, 33, 'PPL', 'P'),
(81073, 'Forest View', 34.8888893127441, 0.608925990871247, -82.3658294677734, -1.43755491534882, 218, 48, 'PPL', 'P'),
(119658, 'Forest View', 41.8086090087891, 0.729697882882332, -87.793327331543, -1.53228262321655, 218, 18, 'PPL', 'P'),
(2542, 'Forest View Estates', 33.5791702270508, 0.586067080549688, -86.8888931274414, -1.51649726848733, 218, 2, 'PPL', 'P'),
(115600, 'Forest View Trailer Court', 41.6847190856934, 0.727535595814269, -91.5438919067383, -1.59774232386237, 218, 16, 'PPL', 'P'),
(47147, 'Forest Villa', 38.9722213745117, 0.68019357980134, -76.5219421386719, -1.33555984034042, 218, 25, 'PPL', 'P'),
(113448, 'Forest Village', 41.7477798461914, 0.728636213713772, -72.5969390869141, -1.26705561393642, 218, 8, 'PPL', 'P'),
(181642, 'Foresta', 37.6983299255371, 0.657959979703731, -119.754173278809, -2.09010461671902, 218, 6, 'PPL', 'P'),
(81074, 'Forestbrook', 33.7222213745117, 0.588563794071637, -78.9583282470703, -1.37808279978182, 218, 48, 'PPL', 'P'),
(64824, 'Forestburg', 36.1908302307129, 0.631649146556239, -76.3783264160156, -1.33305327312243, 218, 33, 'PPL', 'P'),
(94275, 'Forestburg', 33.5330581665039, 0.585262273268266, -97.5563888549805, -1.70268019187531, 218, 51, 'PPL', 'P'),
(148890, 'Forestburg', 41.5499992370605, 0.725184290887838, -74.7516708374023, -1.3046627774797, 218, 40, 'PPL', 'P'),
(170315, 'Forestburg', 44.0222206115723, 0.768332693711248, -98.107780456543, -1.71230379079042, 218, 49, 'PPL', 'P'),
(2544, 'Forestdale', 33.5699996948242, 0.585907024568174, -86.8963928222656, -1.5166281628549, 218, 2, 'PPL', 'P'),
(59938, 'Forestdale', 32.7788887023926, 0.572099533001522, -88.9488906860352, -1.55245100846783, 218, 30, 'PPL', 'P'),
(72578, 'Forestdale', 38.5022201538086, 0.671990511011678, -82.6036071777344, -1.44170491927549, 218, 41, 'PPL', 'P'),
(81075, 'Forestdale', 32.9263916015625, 0.574673944248275, -80.040283203125, -1.39696647612324, 218, 48, 'PPL', 'P'),
(102035, 'Forestdale', 38.642219543457, 0.674433961311825, -77.3261108398438, -1.34959523191735, 218, 53, 'PPL', 'P'),
(124861, 'Forestdale', 41.6916694641113, 0.727656902801923, -70.5, -1.230457122656, 218, 23, 'PPL', 'P'),
(148892, 'Forestdale', 44.4363899230957, 0.77556131185805, -73.9205627441406, -1.29015720481231, 218, 40, 'PPL', 'P'),
(169376, 'Forestdale', 41.9944381713867, 0.732941213615885, -71.5638885498047, -1.24902548072436, 218, 47, 'PPL', 'P'),
(21211, 'Forestdale Estates', 33.8911094665527, 0.591511447345164, -84.3705596923828, -1.47254405838249, 218, 13, 'PPL', 'P'),
(81076, 'Forestdale Heights', 34.8891716003418, 0.608930917719264, -82.3263931274414, -1.43686662136508, 218, 48, 'PPL', 'P'),
(2546, 'Forestdale Mobile Home Park', 33.6116714477539, 0.586634333861875, -86.8933334350586, -1.51657476647505, 218, 2, 'PPL', 'P'),
(2548, 'Forester', 32.436939239502, 0.566131388998655, -86.5980606079102, -1.51142128344963, 218, 2, 'PPL', 'P'),
(8931, 'Forester', 34.7708282470703, 0.606865436556825, -93.8161087036133, -1.63739998828696, 218, 4, 'PPL', 'P'),
(130843, 'Forester', 43.4991683959961, 0.759203710389592, -82.5694427490234, -1.44110863750742, 218, 27, 'PPL', 'P'),
(2549, 'Forester Chapel', 33.1611099243164, 0.578770551795089, -85.5388870239258, -1.49293521705896, 218, 2, 'PPL', 'P'),
(196506, 'Forestgrove', 46.9913902282715, 0.820154479572827, -109.079437255859, -1.90379532633731, 218, 31, 'PPL', 'P'),
(181643, 'Foresthill', 39.0202789306641, 0.68103234238666, -120.816940307617, -2.10865340055337, 218, 6, 'PPL', 'P'),
(47148, 'Foreston', 39.6136093139648, 0.691387911127379, -76.7555618286133, -1.33963727312738, 218, 25, 'PPL', 'P'),
(81077, 'Foreston', 33.6316719055176, 0.586983407701757, -80.0619430541992, -1.39734451183998, 218, 48, 'PPL', 'P'),
(135417, 'Foreston', 45.7344398498535, 0.798216556935245, -93.7102813720703, -1.63555295291294, 218, 28, 'PPL', 'P'),
(21213, 'Foreston Place', 33.3499984741211, 0.582067278908498, -84.5325012207031, -1.4753704712474, 218, 13, 'PPL', 'P'),
(47149, 'Foreston Ridge Estates', 39.6283302307129, 0.691644839593544, -76.7705612182617, -1.33989906186254, 218, 25, 'PPL', 'P'),
(148893, 'Forestport', 43.4419403076172, 0.758204891822758, -75.2074966430664, -1.31261843860409, 218, 40, 'PPL', 'P'),
(21214, 'Forestview', 30.9266700744629, 0.539772219477377, -81.5930633544922, -1.42406760232422, 218, 13, 'PPL', 'P'),
(35957, 'Forestville', 37.2683296203613, 0.650455058593834, -85.9966735839844, -1.50092509980336, 218, 21, 'PPL', 'P'),
(47150, 'Forestville', 38.8450012207031, 0.677973169242486, -76.8752822875977, -1.34172678931866, 218, 25, 'PPL', 'P'),
(64826, 'Forestville', 35.9613914489746, 0.627644684383141, -78.5183334350586, -1.37040344162052, 218, 33, 'PPL', 'P'),
(72579, 'Forestville', 39.0750007629395, 0.68198741853259, -84.3450012207031, -1.47209797889991, 218, 41, 'PPL', 'P'),
(102036, 'Forestville', 38.7150001525879, 0.675704222572766, -78.7225036621094, -1.3739668843171, 218, 53, 'PPL', 'P'),
(113449, 'Forestville', 41.6766700744629, 0.727395114066768, -72.9205627441406, -1.27270391229237, 218, 8, 'PPL', 'P'),
(115602, 'Forestville', 42.5966682434082, 0.743452111227182, -91.5283279418945, -1.59747068143118, 218, 16, 'PPL', 'P'),
(130846, 'Forestville', 43.6619415283203, 0.762044637482434, -82.6094436645508, -1.44180678518718, 218, 27, 'PPL', 'P'),
(135419, 'Forestville', 43.6427803039551, 0.761710211028548, -92.2147216796875, -1.60945051212074, 218, 28, 'PPL', 'P'),
(148895, 'Forestville', 42.4683303833008, 0.741212193013344, -79.1772232055664, -1.38190323752359, 218, 40, 'PPL', 'P'),
(161735, 'Forestville', 40.6922187805176, 0.710213197661903, -76.3016662597656, -1.33171530099078, 218, 45, 'PPL', 'P'),
(174139, 'Forestville', 44.689998626709, 0.779987618747816, -87.4791717529297, -1.52679957400624, 218, 57, 'PPL', 'P'),
(181644, 'Forestville', 38.4736099243164, 0.671491168307288, -122.889167785645, -2.14482059289525, 218, 6, 'PPL', 'P'),
(87061, 'Forestwood', 35.1822204589844, 0.614045585171788, -85.225830078125, -1.4874713426085, 218, 50, 'PPL', 'P'),
(81078, 'Forestwood Estates', 34.0897216796875, 0.594977884399039, -80.9336090087891, -1.41255795272511, 218, 48, 'PPL', 'P'),
(198295, 'Forfar', 48.5705604553223, 0.84771619948433, -101.298057556152, -1.76798463022958, 218, 34, 'PPL', 'P'),
(200838, 'Forfar', 44.5527801513672, 0.777592704558535, -124.066673278809, -2.16537194071128, 218, 43, 'PPL', 'P'),
(190973, 'Forgan', 36.9069404602051, 0.64414762786809, -100.538887023926, -1.75473460485811, 218, 42, 'PPL', 'P'),
(47151, 'Forge Acres', 39.4119415283203, 0.687868144272675, -76.4208297729492, -1.33379509664407, 218, 25, 'PPL', 'P'),
(47152, 'Forge Heights', 39.4116706848145, 0.687863417161741, -76.4302825927734, -1.3339600794736, 218, 25, 'PPL', 'P'),
(109243, 'Forge Hill', 39.4502792358398, 0.688537263496558, -78.9550018310547, -1.37802474287006, 218, 58, 'PPL', 'P'),
(47153, 'Forge Hill Estates', 39.4505615234375, 0.688542190344575, -77.7494430541992, -1.35698377288761, 218, 25, 'PPL', 'P'),
(148896, 'Forge Hollow', 42.9627799987793, 0.749841966788664, -75.4091720581055, -1.31613833861685, 218, 40, 'PPL', 'P'),
(21215, 'Forge Mill', 34.8933296203613, 0.609003488858968, -84.2463912963867, -1.47037691104544, 218, 13, 'PPL', 'P'),
(87063, 'Forge Ridge', 36.5727806091309, 0.638315438238871, -83.5802764892578, -1.45875101446476, 218, 50, 'PPL', 'P'),
(124862, 'Forge Village', 42.5800018310547, 0.743161227457119, -71.4875030517578, -1.24769230228267, 218, 23, 'PPL', 'P'),
(72580, 'Forgy', 39.9130592346191, 0.696614298187632, -83.9916687011719, -1.46593116307972, 218, 41, 'PPL', 'P'),
(8932, 'Forgy (historical)', 33.9480590820313, 0.592505405643009, -93.9438934326172, -1.63963025254185, 218, 4, 'PPL', 'P'),
(127497, 'Foristall Corners', 43.2130584716797, 0.754210150187639, -70.6647186279297, -1.23333200505274, 218, 26, 'PPL', 'P'),
(54812, 'Foristell', 38.814998626709, 0.677449525193149, -90.9558334350586, -1.58747876733732, 218, 29, 'PPL', 'P'),
(47154, 'Fork', 39.4680595397949, 0.688847588342579, -76.4422225952148, -1.3341684718289, 218, 25, 'PPL', 'P'),
(64827, 'Fork', 35.8805618286133, 0.626233941374699, -80.4458312988281, -1.40404462566846, 218, 33, 'PPL', 'P'),
(81079, 'Fork', 34.2880592346191, 0.598439527762951, -79.2755584716797, -1.38361951168809, 218, 48, 'PPL', 'P'),
(81080, 'Fork Hill Crossroads', 34.6641693115234, 0.60500388695486, -80.6205596923828, -1.40709421143271, 218, 48, 'PPL', 'P'),
(109249, 'Fork Junction', 38.1572189331055, 0.665969103787008, -81.897216796875, -1.42937608132507, 218, 58, 'PPL', 'P'),
(70825, 'Fork Landing', 39.9777793884277, 0.697743877963989, -75.0130615234375, -1.30922490558506, 218, 37, 'PPL', 'P'),
(87064, 'Fork Mountain', 36.1266708374023, 0.630529353896888, -84.4199981689453, -1.47340692257568, 218, 50, 'PPL', 'P'),
(102040, 'Fork Mountain', 36.8455581665039, 0.643076304740578, -79.899169921875, -1.39450358474714, 218, 53, 'PPL', 'P'),
(87065, 'Fork Ridge', 36.5802803039551, 0.638446332606448, -83.7988891601563, -1.46256652535851, 218, 50, 'PPL', 'P'),
(102041, 'Fork Ridge', 37.1338882446289, 0.648108613936392, -81.8833312988281, -1.42913373366588, 218, 53, 'PPL', 'P'),
(81081, 'Fork Shoals', 34.622501373291, 0.604276644240187, -82.3069381713867, -1.4365270683261, 218, 48, 'PPL', 'P'),
(102042, 'Fork Union', 37.7630615234375, 0.65908975921717, -78.2624969482422, -1.36593825257884, 218, 53, 'PPL', 'P'),
(87066, 'Forked Deer', 35.774169921875, 0.624377052304641, -89.3850021362305, -1.56006258917939, 218, 50, 'PPL', 'P'),
(40965, 'Forked Island', 29.8311100006104, 0.520651089035258, -92.3000030517578, -1.61093895285399, 218, 22, 'PPL', 'P'),
(70826, 'Forked River', 39.8397216796875, 0.695334316388713, -74.190559387207, -1.29486953520315, 218, 37, 'PPL', 'P'),
(70832, 'Forked River Beach', 39.8169403076172, 0.694936706437964, -74.1705627441406, -1.29452052794229, 218, 37, 'PPL', 'P'),
(70828, 'Forked River Point', 39.8261108398438, 0.695096762419477, -74.1977767944336, -1.29499550272271, 218, 37, 'PPL', 'P'),
(54813, 'Forker', 39.7191696166992, 0.693230285969495, -93.1855621337891, -1.62639487455637, 218, 29, 'PPL', 'P'),
(2550, 'Forkland', 32.6480598449707, 0.569816138682888, -87.8833312988281, -1.53385348878554, 218, 2, 'PPL', 'P'),
(35961, 'Forkland', 37.5525016784668, 0.655414796649943, -84.9800033569336, -1.48318085693433, 218, 21, 'PPL', 'P'),
(59939, 'Forkland', 33.5263900756836, 0.58514589312863, -91.0141677856445, -1.58849689382205, 218, 30, 'PPL', 'P'),
(102044, 'Forkland (historical)', 37.0094413757324, 0.645936606330351, -77.9561080932617, -1.36059075826802, 218, 53, 'PPL', 'P'),
(54814, 'Forkners Hill', 37.4727783203125, 0.654023361559403, -92.9088897705078, -1.62156603086784, 218, 29, 'PPL', 'P'),
(148898, 'Forks', 42.9038887023926, 0.748814119765948, -78.7544403076172, -1.37452428393326, 218, 40, 'PPL', 'P'),
(207440, 'Forks', 47.9505615234375, 0.836895176764093, -124.384170532227, -2.17091331314946, 218, 56, 'PPL', 'P'),
(161736, 'Forks Church', 40.6744384765625, 0.709902872815882, -79.5941696166992, -1.38918032520223, 218, 45, 'PPL', 'P'),
(87067, 'Forks of Blue Creek', 36.0638885498047, 0.629433596266375, -87.7316665649414, -1.53120643982005, 218, 50, 'PPL', 'P'),
(102045, 'Forks of Buffalo', 37.6794395446777, 0.65763028036078, -79.2222213745117, -1.38268860372906, 218, 53, 'PPL', 'P'),
(109244, 'Forks of Coal', 38.276668548584, 0.66805389286735, -81.8002777099609, -1.42768417508455, 218, 58, 'PPL', 'P'),
(35958, 'Forks of Elkhorn', 38.2155609130859, 0.6669873634298, -84.7977828979492, -1.48000050996055, 218, 21, 'PPL', 'P'),
(64830, 'Forks of Ivy', 35.7916717529297, 0.624682516881673, -82.5391693115234, -1.44058026634715, 218, 33, 'PPL', 'P'),
(87068, 'Forks of Piney (historical)', 36.0111083984375, 0.628512408845316, -87.4441680908203, -1.52618864485218, 218, 50, 'PPL', 'P'),
(87070, 'Forks of the River', 35.9597206115723, 0.627615522769205, -83.8377838134766, -1.46324536512037, 218, 50, 'PPL', 'P'),
(190213, 'Forks Station', 37.4958305358887, 0.654425698621087, -117.165283203125, -2.04491996092614, 218, 39, 'PPL', 'P'),
(109245, 'Forksburg', 39.4786109924316, 0.689031745931958, -80.0472183227539, -1.39708751679479, 218, 58, 'PPL', 'P'),
(161739, 'Forkston', 41.5283317565918, 0.724806122013047, -76.126106262207, -1.32865120099859, 218, 45, 'PPL', 'P'),
(40966, 'Forksville', 32.5074996948242, 0.567362901265735, -92.3236083984375, -1.61135094387462, 218, 22, 'PPL', 'P'),
(102046, 'Forksville', 36.7522201538086, 0.641447249101777, -78.04638671875, -1.36216641752696, 218, 53, 'PPL', 'P'),
(161741, 'Forksville', 41.4869384765625, 0.724083672988336, -76.6025009155273, -1.33696585623792, 218, 45, 'PPL', 'P'),
(35959, 'Forkton', 36.7480583190918, 0.641374611383045, -85.7197189331055, -1.49609132926681, 218, 21, 'PPL', 'P'),
(87071, 'Forktown', 36.1886100769043, 0.631610397562378, -86.3033294677734, -1.50627725464609, 218, 50, 'PPL', 'P'),
(87072, 'Forkvale (historical)', 36.3038902282715, 0.633622415765933, -83.9797210693359, -1.46572263756637, 218, 50, 'PPL', 'P'),
(2551, 'Forkville', 34.2691688537598, 0.598109828419999, -87.5513916015625, -1.52806004815018, 218, 2, 'PPL', 'P'),
(59940, 'Forkville', 32.4605598449707, 0.566543646335399, -89.6608276367188, -1.56487665232387, 218, 30, 'PPL', 'P'),
(21216, 'Forkwood', 33.8499984741211, 0.59079392516847, -84.7305603027344, -1.47882725434232, 218, 13, 'PPL', 'P'),
(27186, 'Forman', 37.3466682434082, 0.65182232549748, -88.9072189331055, -1.55172369917413, 218, 18, 'PPL', 'P'),
(109246, 'Forman', 39.1399993896484, 0.683121858577936, -79.0752792358398, -1.38012397959931, 218, 58, 'PPL', 'P'),
(140035, 'Forman', 46.107780456543, 0.804732579753369, -97.6361083984375, -1.70407156038682, 218, 34, 'PPL', 'P'),
(190214, 'Formanville (historical)', 39.2816696166992, 0.68559447049202, -119.642219543457, -2.08815065542723, 218, 39, 'PPL', 'P'),
(8936, 'Formosa', 35.4630584716797, 0.618947133158079, -92.5100021362305, -1.61460412830421, 218, 4, 'PPL', 'P'),
(102047, 'Formosa', 36.8811111450195, 0.643696821274567, -78.6558303833008, -1.37280321607879, 218, 53, 'PPL', 'P'),
(27187, 'Formosa Junction', 38.707218170166, 0.675568401357172, -89.9280624389648, -1.56954077949898, 218, 18, 'PPL', 'P'),
(32461, 'Formoso', 39.7799987792969, 0.694291955138056, -97.991943359375, -1.71028205204889, 218, 20, 'PPL', 'P'),
(2552, 'Forney', 34.086109161377, 0.594914834060231, -85.4619369506836, -1.49159218492123, 218, 2, 'PPL', 'P'),
(32462, 'Forney', 39.4155616760254, 0.687931327769538, -98.6197204589844, -1.72123882940569, 218, 20, 'PPL', 'P'),
(75856, 'Forney', 34.0297203063965, 0.593930662879392, -95.6194381713867, -1.66887402499784, 218, 42, 'PPL', 'P'),
(81082, 'Forney', 33.8352813720703, 0.590537063281331, -79.1741714477539, -1.38184997430179, 218, 48, 'PPL', 'P'),
(94276, 'Forney', 32.7480583190918, 0.571561441303272, -96.4716720581055, -1.68374831231815, 218, 51, 'PPL', 'P'),
(194941, 'Forney', 44.9997215270996, 0.785393303128459, -114.334716796875, -1.99551725744073, 218, 17, 'PPL', 'P'),
(181645, 'Fornis', 38.8925018310547, 0.678802211289828, -120.860282897949, -2.10940987146101, 218, 6, 'PPL', 'P'),
(119660, 'Forrest', 40.7519416809082, 0.711255558912561, -88.4111099243164, -1.54306496352196, 218, 18, 'PPL', 'P'),
(178200, 'Forrest', 31.3666706085205, 0.547451677507216, -109.726936340332, -1.91509631726501, 218, 5, 'PPL', 'P'),
(188559, 'Forrest', 34.7947196960449, 0.607282421004504, -103.600830078125, -1.80817559266246, 218, 38, 'PPL', 'P'),
(21217, 'Forrest (historical)', 33.4388885498047, 0.583618703401524, -82.1927795410156, -1.43453462435656, 218, 13, 'PPL', 'P'),
(59941, 'Forrest (historical)', 33.1758308410645, 0.579027480261254, -89.517219543457, -1.56237021826394, 218, 30, 'PPL', 'P'),
(8934, 'Forrest Bonner', 33.839168548584, 0.590604907310101, -92.5444412231445, -1.61520520376224, 218, 4, 'PPL', 'P'),
(8935, 'Forrest City', 35.0080604553223, 0.611005919682599, -90.7897186279297, -1.5845795170166, 218, 4, 'PPL', 'P'),
(59942, 'Forrest City (historical)', 33.1927795410156, 0.579323290879335, -90.9250030517578, -1.58694067563907, 218, 30, 'PPL', 'P'),
(13807, 'Forrest Grove Village Mobile Home Park', 39.1694412231445, 0.683635715510267, -75.6788864135742, -1.32084574215967, 218, 10, 'PPL', 'P'),
(47167, 'Forrest Hall Estates', 38.4288902282715, 0.670710662370813, -76.73388671875, -1.33925897109454, 218, 25, 'PPL', 'P'),
(21218, 'Forrest Heights', 34.2008285522461, 0.59691706514678, -85.1677780151367, -1.48645814297178, 218, 13, 'PPL', 'P'),
(21219, 'Forrest Hills', 32.0219383239746, 0.558888256623912, -81.0813903808594, -1.41513722424086, 218, 13, 'PPL', 'P'),
(81083, 'Forrest Hills', 34.3444404602051, 0.599423565785735, -79.4427795410156, -1.38653806992671, 218, 48, 'PPL', 'P'),
(87073, 'Forrest Hills', 35.6236114501953, 0.62174931125706, -87.0536117553711, -1.51937215088407, 218, 50, 'PPL', 'P'),
(35960, 'Forrest Park', 38.0002784729004, 0.663229976026835, -84.1933288574219, -1.46945079677637, 218, 21, 'PPL', 'P'),
(81084, 'Forrest Park', 33.601390838623, 0.586454903383431, -81.7291717529297, -1.42644314201657, 218, 48, 'PPL', 'P'),
(87076, 'Forrest Park', 35.3549995422363, 0.617061149053112, -86.1922225952148, -1.50433807389835, 218, 50, 'PPL', 'P'),
(21222, 'Forrester', 31.6497192382813, 0.5523918080398, -84.1627807617188, -1.46891763192613, 218, 13, 'PPL', 'P'),
(75857, 'Forrester', 34.8722190856934, 0.608635040522156, -94.5263900756836, -1.64979673684517, 218, 42, 'PPL', 'P'),
(59946, 'Forreston', 33.3372192382813, 0.581844239167204, -88.313606262207, -1.5413632035854, 218, 30, 'PPL', 'P'),
(94277, 'Forreston', 32.2561111450195, 0.562975343369829, -96.8649978637695, -1.69061314266005, 218, 51, 'PPL', 'P'),
(119662, 'Forreston', 42.1261100769043, 0.735239321899542, -89.5791702270508, -1.56345146166651, 218, 18, 'PPL', 'P'),
(21225, 'Forrister', 33.9555587768555, 0.592636300010586, -84.8411102294922, -1.48075671455208, 218, 13, 'PPL', 'P'),
(204002, 'Fors', 40.6500015258789, 0.709476367567306, -111.844436645508, -1.95205366950231, 218, 52, 'PPL', 'P'),
(191480, 'Forsan', 32.1097183227539, 0.560420306620007, -101.365829467773, -1.76916747322774, 218, 51, 'PPL', 'P'),
(135423, 'Forsman', 47.7080612182617, 0.832662748001684, -92.57861328125, -1.61580161868836, 218, 28, 'PPL', 'P'),
(148899, 'Forsonville', 41.3680610656738, 0.722008870762083, -73.9300003051758, -1.29032192132573, 218, 40, 'PPL', 'P'),
(40967, 'Forstall (historical)', 30.0027809143066, 0.523647311709166, -90.8600006103516, -1.58580616901469, 218, 22, 'PPL', 'P'),
(130855, 'Forster', 42.5611114501953, 0.742831528114167, -82.6183319091797, -1.44196191432068, 218, 27, 'PPL', 'P'),
(21226, 'Forsyth', 33.0341682434082, 0.576555001505225, -83.9383316040039, -1.46500025512068, 218, 13, 'PPL', 'P'),
(27188, 'Forsyth', 39.9324989318848, 0.696953584910508, -88.9511108398438, -1.55248975746169, 218, 18, 'PPL', 'P'),
(54815, 'Forsyth', 36.685001373291, 0.64027406006257, -93.1197204589844, -1.625245720546, 218, 29, 'PPL', 'P'),
(115603, 'Forsyth', 43.2555618286133, 0.754951973709281, -94.4727783203125, -1.64886103519617, 218, 16, 'PPL', 'P'),
(148900, 'Forsyth', 42.2922210693359, 0.738138505641229, -79.6538925170898, -1.39022268645289, 218, 40, 'PPL', 'P'),
(196507, 'Forsyth', 46.2663917541504, 0.807500869127479, -106.677223205566, -1.86186878182203, 218, 31, 'PPL', 'P'),
(47156, 'Forsythe', 39.6763916015625, 0.692483668757892, -77.9880599975586, -1.36114842420028, 218, 25, 'PPL', 'P'),
(59947, 'Fort Adams', 31.086389541626, 0.542559850058904, -91.5480575561523, -1.59781502816013, 218, 30, 'PPL', 'P'),
(161743, 'Fort Allen', 40.2805595397949, 0.703028388515033, -79.5861129760742, -1.38903971029668, 218, 45, 'PPL', 'P'),
(124863, 'Fort Andrews', 42.2997207641602, 0.738269400008807, -70.9288864135742, -1.23794260268994, 218, 23, 'PPL', 'P'),
(148901, 'Fort Ann', 43.4141693115234, 0.757720196504364, -73.4880599975586, -1.28260860786053, 218, 40, 'PPL', 'P'),
(178201, 'Fort Apache', 33.7905616760254, 0.589756557344857, -109.988059997559, -1.91965378483846, 218, 5, 'PPL', 'P'),
(178202, 'Fort Apache Junction', 33.7897186279297, 0.589741843379834, -110.001106262207, -1.91988148511167, 218, 5, 'PPL', 'P'),
(109247, 'Fort Ashby', 39.503059387207, 0.689458450917616, -78.7688903808594, -1.37477648528849, 218, 58, 'PPL', 'P'),
(112997, 'Fort Atkinson', 43.1433296203613, 0.7529931521485, -91.932502746582, -1.60452486252659, 218, 16, 'PPL', 'P'),
(174142, 'Fort Atkinson', 42.9288902282715, 0.749250478710558, -88.8369369506836, -1.55049704717604, 218, 57, 'PPL', 'P'),
(127498, 'Fort Baldwin', 43.7488899230957, 0.763562173250589, -69.7886123657227, -1.21804106617989, 218, 26, 'PPL', 'P'),
(102048, 'Fort Barnard Heights', 38.8463897705078, 0.677997404008406, -77.0897216796875, -1.3454694627566, 218, 53, 'PPL', 'P'),
(64835, 'Fort Barnwell', 35.2911109924316, 0.615946083504696, -77.3352813720703, -1.34975528789886, 218, 33, 'PPL', 'P'),
(16065, 'Fort Barrancas', 30.3477802276611, 0.529668685644321, -87.2972183227539, -1.52362388756438, 218, 12, 'PPL', 'P'),
(16066, 'Fort Basinger', 27.3619403839111, 0.477555949433651, -81.0572204589844, -1.41471537952419, 218, 12, 'PPL', 'P'),
(188560, 'Fort Bayard', 32.7961082458496, 0.572400070730538, -108.149719238281, -1.88756868581546, 218, 38, 'PPL', 'P'),
(59948, 'Fort Bayou (historical)', 30.4472198486328, 0.531404234437212, -88.7180633544922, -1.54842231152881, 218, 30, 'PPL', 'P'),
(196508, 'Fort Belknap', 48.4830589294434, 0.846189009757224, -108.766387939453, -1.89833158504491, 218, 31, 'PPL', 'P'),
(196509, 'Fort Belknap Agency', 48.4824981689453, 0.846179222640218, -108.764717102051, -1.89830242343097, 218, 31, 'PPL', 'P'),
(54816, 'Fort Bellefontaine', 38.836109161377, 0.677817973529962, -90.241943359375, -1.57501903501933, 218, 29, 'PPL', 'P'),
(21228, 'Fort Benning', 32.3522186279297, 0.564652735382415, -84.9688873291016, -1.48298684564891, 218, 13, 'PPL', 'P'),
(196510, 'Fort Benton', 47.8183288574219, 0.83458728136343, -110.66667175293, -1.93149779431243, 218, 31, 'PPL', 'P'),
(193563, 'Fort Bidwell', 41.8605613708496, 0.730604622654477, -120.150283813477, -2.09701804975081, 218, 6, 'PPL', 'P'),
(186720, 'Fort Big Spring', 38.9333305358887, 0.679514806618506, -102.829170227051, -1.79470758755576, 218, 7, 'PPL', 'P'),
(102049, 'Fort Blackmore', 36.7744407653809, 0.64183507193552, -82.5869369506836, -1.44141396892639, 218, 53, 'PPL', 'P'),
(194190, 'Fort Boettcher', 40.8044395446777, 0.712171819485602, -106.543327331543, -1.85953185796549, 218, 7, 'PPL', 'P'),
(194942, 'Fort Boise (historical)', 43.8291702270508, 0.764963328879107, -117.012222290039, -2.04224854403668, 218, 17, 'PPL', 'P'),
(16067, 'Fort Braden', 30.422779083252, 0.530977662609609, -84.5377807617188, -1.47546261662111, 218, 12, 'PPL', 'P'),
(181646, 'Fort Bragg', 39.4458312988281, 0.688459632350782, -123.804168701172, -2.16079037152996, 218, 6, 'PPL', 'P'),
(29823, 'Fort Branch', 38.2511100769043, 0.667607813384761, -87.5811080932617, -1.52857869877247, 218, 19, 'PPL', 'P'),
(109248, 'Fort Branch', 37.8491706848145, 0.660592647599329, -81.9438934326172, -1.43019074230253, 218, 58, 'PPL', 'P'),
(209457, 'Fort Bridger', 41.3166694641113, 0.721111918106944, -110.383613586426, -1.92655749733228, 218, 59, 'PPL', 'P'),
(16068, 'Fort Brook Landing', 29.514440536499, 0.51512416424599, -81.9077835083008, -1.42956050523056, 218, 12, 'PPL', 'P'),
(155303, 'Fort Brown', 41.1119384765625, 0.717538688293357, -84.420280456543, -1.4734118494237, 218, 41, 'PPL', 'P'),
(40968, 'Fort Buhlow', 31.3274993896484, 0.546768010765879, -92.4494400024414, -1.61354711966756, 218, 22, 'PPL', 'P'),
(81086, 'Fort Bull', 32.8416709899902, 0.573195290632035, -80.0563888549805, -1.3972475727763, 218, 48, 'PPL', 'P'),
(141832, 'Fort Calhoun', 41.4558296203613, 0.723540721021096, -96.0261077880859, -1.67597174877707, 218, 35, 'PPL', 'P'),
(190215, 'Fort Callville (historical)', 36.1133308410645, 0.630296527038588, -114.688056945801, -2.00168420641898, 218, 39, 'PPL', 'P'),
(181647, 'Fort Camp (historical)', 36.764720916748, 0.641665428574081, -119.672218322754, -2.08867423289754, 218, 6, 'PPL', 'P'),
(207441, 'Fort Canby', 46.2836112976074, 0.807801406856495, -124.052780151367, -2.16512945989403, 218, 56, 'PPL', 'P'),
(16069, 'Fort Caroline', 30.3866691589355, 0.530347425537641, -81.5005569458008, -1.42245306091336, 218, 12, 'PPL', 'P'),
(186721, 'Fort Carson', 38.7374992370605, 0.676096905675498, -104.788330078125, -1.82890137752989, 218, 7, 'PPL', 'P'),
(207442, 'Fort Casey', 48.1644401550293, 0.840628063085029, -122.67749786377, -2.14112625583109, 218, 56, 'PPL', 'P'),
(64836, 'Fort Caswell', 33.892219543457, 0.591530821842095, -78.0208282470703, -1.36172033804437, 218, 33, 'PPL', 'P'),
(16070, 'Fort Centre', 26.954439163208, 0.470443711426485, -81.1619415283203, -1.41654310698031, 218, 12, 'PPL', 'P'),
(191481, 'Fort Chadbourne', 32.000560760498, 0.558515147755192, -100.289169311523, -1.75037620857614, 218, 51, 'PPL', 'P'),
(8941, 'Fort Chaffee', 35.3122215270996, 0.616314531841508, -94.3058319091797, -1.64594727064752, 218, 4, 'PPL', 'P'),
(87077, 'Fort Cheatham', 35.0122184753418, 0.611078490822303, -85.2755584716797, -1.48833926680775, 218, 50, 'PPL', 'P'),
(102050, 'Fort Chiswell', 36.9469413757324, 0.644845775547854, -80.9416732788086, -1.41269870078872, 218, 53, 'PPL', 'P'),
(102052, 'Fort Christanna', 36.7133293151855, 0.640768475918943, -77.8708267211914, -1.35910231753477, 218, 53, 'PPL', 'P'),
(198296, 'Fort Clark', 47.2400016784668, 0.824493567936893, -101.251670837402, -1.7671750292582, 218, 34, 'PPL', 'P'),
(94279, 'Fort Clark Road Colonia', 29.201000213623, 0.50965359860329, -99.8190002441406, -1.74217021030928, 218, 51, 'PPL', 'P'),
(191482, 'Fort Clark Springs', 29.3058300018311, 0.511483223561688, -100.421669006348, -1.75268876450871, 218, 51, 'PPL', 'P'),
(148903, 'Fort Clinton', 41.3186111450195, 0.721145806831815, -73.9883270263672, -1.29133991465241, 218, 40, 'PPL', 'P'),
(75858, 'Fort Cobb', 35.0977783203125, 0.612571791824538, -98.4352798461914, -1.71801973343806, 218, 42, 'PPL', 'P'),
(75860, 'Fort Coffee', 35.2891693115234, 0.615912194779825, -94.5841674804688, -1.65080514279193, 218, 42, 'PPL', 'P'),
(194184, 'Fort Collins', 40.5852813720703, 0.708346787790949, -105.083892822266, -1.83405992056137, 218, 7, 'PPL', 'P'),
(81087, 'Fort Corner', 33.0788917541504, 0.577335574020727, -79.6258316040039, -1.38973293112843, 218, 48, 'PPL', 'P'),
(161744, 'Fort Couch', 40.2461090087891, 0.702427113319921, -76.9047164916992, -1.34224051309293, 218, 45, 'PPL', 'P'),
(148904, 'Fort Covington', 44.9891700744629, 0.78520914553908, -74.495002746582, -1.30018307421008, 218, 40, 'PPL', 'P'),
(148905, 'Fort Covington Center', 44.9483299255371, 0.78449635047332, -74.4644393920898, -1.29964964304373, 218, 40, 'PPL', 'P'),
(94280, 'Fort Crockett', 29.2716693878174, 0.510887008372646, -94.815559387207, -1.65484369342698, 218, 51, 'PPL', 'P'),
(141834, 'Fort Crook', 41.125560760498, 0.717776441999674, -95.9274978637695, -1.67425068092261, 218, 35, 'PPL', 'P'),
(2553, 'Fort Dale', 31.8913898468018, 0.556609755863781, -86.6575012207031, -1.51245871785227, 218, 2, 'PPL', 'P'),
(2554, 'Fort Davis', 32.2430610656738, 0.5627475765176, -85.709716796875, -1.49591675905736, 218, 2, 'PPL', 'P'),
(13099, 'Fort Davis', 38.8666687011719, 0.678351338117277, -76.9463882446289, -1.34296782238663, 218, 9, 'PPL', 'P'),
(191483, 'Fort Davis', 30.5880603790283, 0.533862365412869, -103.894172668457, -1.81329538670008, 218, 51, 'PPL', 'P'),
(124864, 'Fort Dawes', 42.3499984741211, 0.739146911587988, -70.9569396972656, -1.23843222485635, 218, 23, 'PPL', 'P'),
(16071, 'Fort De Soto', 27.6152801513672, 0.481977562501995, -82.7363891601563, -1.44402240205607, 218, 12, 'PPL', 'P'),
(64837, 'Fort Defiance', 36.0169410705566, 0.628614208177985, -81.4952774047852, -1.42236091553964, 218, 33, 'PPL', 'P'),
(102053, 'Fort Defiance', 38.2402801513672, 0.667418795526393, -78.9722213745117, -1.37832528059907, 218, 53, 'PPL', 'P'),
(178203, 'Fort Defiance', 35.7444381713867, 0.623858135366239, -109.075828552246, -1.90373234257753, 218, 5, 'PPL', 'P'),
(13784, 'Fort Delaware', 39.5894393920898, 0.69096606641071, -75.5666732788086, -1.31888725349403, 218, 10, 'PPL', 'P'),
(2555, 'Fort Deposit', 31.9844398498535, 0.558233784786025, -86.57861328125, -1.5110818635687, 218, 2, 'PPL', 'P'),
(2556, 'Fort Deposit (historical)', 34.4338912963867, 0.600984777395767, -86.3333282470703, -1.5068008321164, 218, 2, 'PPL', 'P'),
(115604, 'Fort Des Moines', 41.5202789306641, 0.724665573686518, -93.6155624389648, -1.63389979566627, 218, 16, 'PPL', 'P'),
(47157, 'Fort Deterick', 39.4352798461914, 0.688275474761403, -77.4288864135742, -1.35138900406957, 218, 25, 'PPL', 'P'),
(193564, 'Fort Dick', 41.8680610656738, 0.730735517022054, -124.14778137207, -2.16678754398871, 218, 6, 'PPL', 'P'),
(145243, 'Fort Dix', 40.0297203063965, 0.698650417999052, -74.6188888549805, -1.30234529469911, 218, 37, 'PPL', 'P'),
(32464, 'Fort Dodge', 37.7319412231445, 0.658546607512849, -99.9349975585938, -1.74419474536996, 218, 20, 'PPL', 'P'),
(115605, 'Fort Dodge', 42.497501373291, 0.74172132283474, -94.1677780151367, -1.64353777565127, 218, 16, 'PPL', 'P'),
(109257, 'Fort Donnally', 37.9436111450195, 0.662240944577006, -80.4761123657227, -1.40457312998678, 218, 58, 'PPL', 'P'),
(8938, 'Fort Douglas', 35.6841697692871, 0.622806253314685, -93.2416687011719, -1.62737411888919, 218, 4, 'PPL', 'P'),
(204003, 'Fort Douglas', 40.7636108398438, 0.711459224156924, -111.831108093262, -1.95182104238109, 218, 52, 'PPL', 'P'),
(32465, 'Fort Downer', 38.8408317565918, 0.6779003983657, -99.977783203125, -1.74494149573961, 218, 20, 'PPL', 'P'),
(16072, 'Fort Drane', 29.3861103057861, 0.512884379190206, -82.2522201538086, -1.4355720587592, 218, 12, 'PPL', 'P'),
(16073, 'Fort Drum', 27.5263900756836, 0.48042613800897, -80.8069381713867, -1.41034712954618, 218, 12, 'PPL', 'P'),
(204004, 'Fort Duchesne', 40.2880592346191, 0.703159282882611, -109.853889465332, -1.91731206729196, 218, 52, 'PPL', 'P'),
(13100, 'Fort Dupont', 38.872501373291, 0.678453137449946, -76.9388885498047, -1.34283692801906, 218, 9, 'PPL', 'P'),
(124865, 'Fort Duvall', 42.2999992370605, 0.738274260277796, -70.8963928222656, -1.23737548253581, 218, 23, 'PPL', 'P'),
(127499, 'Fort Edgecomb', 43.9947204589844, 0.767852725503788, -69.6580581665039, -1.21576246555122, 218, 26, 'PPL', 'P'),
(148907, 'Fort Edward', 43.2669410705566, 0.755150578947574, -73.5849990844727, -1.28430051410106, 218, 40, 'PPL', 'P'),
(70829, 'Fort Elfsborg', 39.5483283996582, 0.690248544234015, -75.5258331298828, -1.31817445842827, 218, 37, 'PPL', 'P'),
(127500, 'Fort Fairfield', 46.7722206115723, 0.816329248141092, -67.8344421386719, -1.18393436157341, 218, 26, 'PPL', 'P'),
(161745, 'Fort Fetter', 40.4283294677734, 0.705607460293693, -78.4091720581055, -1.36849821617668, 218, 45, 'PPL', 'P'),
(155304, 'Fort Fizzle', 40.4927787780762, 0.706732312959115, -82.0930633544922, -1.43279424858419, 218, 41, 'PPL', 'P'),
(207443, 'Fort Flagler', 48.0969390869141, 0.839449947197806, -122.693893432617, -2.14141241249022, 218, 56, 'PPL', 'P'),
(16074, 'Fort Florida', 28.8675003051758, 0.503832927145785, -81.3547210693359, -1.41990774470151, 218, 12, 'PPL', 'P'),
(47158, 'Fort Foote Estates', 38.7413902282715, 0.676164816283295, -76.9755630493164, -1.34347701878706, 218, 25, 'PPL', 'P'),
(47159, 'Fort Foote Village', 38.769718170166, 0.676659232139668, -77.0177764892578, -1.34421378230263, 218, 25, 'PPL', 'P'),
(81088, 'Fort Fremont', 32.3083305358887, 0.563886743673881, -80.6380615234375, -1.40739967600974, 218, 48, 'PPL', 'P'),
(16075, 'Fort Gadsden', 29.9169406890869, 0.522149117148428, -84.9772186279297, -1.48313225424443, 218, 12, 'PPL', 'P'),
(27189, 'Fort Gage', 37.9605598449707, 0.662536755195087, -89.9044418334961, -1.56912852216223, 218, 18, 'PPL', 'P'),
(2557, 'Fort Gaines', 30.2486095428467, 0.527937830672851, -88.0749969482422, -1.53719868543078, 218, 2, 'PPL', 'P'),
(21229, 'Fort Gaines', 31.6088905334473, 0.551679212711122, -85.0472183227539, -1.48435397939451, 218, 13, 'PPL', 'P'),
(186722, 'Fort Garland', 37.4288902282715, 0.653257369850869, -105.433326721191, -1.84015869261571, 218, 7, 'PPL', 'P'),
(72581, 'Fort Gass (historical)', 39.2174987792969, 0.684474478095587, -84.7858276367188, -1.47979185128914, 218, 41, 'PPL', 'P'),
(16076, 'Fort Gates', 29.4172191619873, 0.513427331157446, -81.6580581665039, -1.42520197579054, 218, 12, 'PPL', 'P'),
(94281, 'Fort Gates', 31.3994407653809, 0.548023624640824, -97.7074966430664, -1.70531752030282, 218, 51, 'PPL', 'P'),
(109250, 'Fort Gay', 38.1161117553711, 0.665251648189341, -82.595832824707, -1.44156923121795, 218, 58, 'PPL', 'P'),
(127502, 'Fort George', 44.3908309936523, 0.77476615853558, -68.8058319091797, -1.20088831138896, 218, 26, 'PPL', 'P'),
(47160, 'Fort George G Mead Junction', 39.1258316040039, 0.682874584070722, -76.789436340332, -1.34022849488938, 218, 25, 'PPL', 'P'),
(16077, 'Fort George Island', 30.4027805328369, 0.53062862205924, -81.4302825927734, -1.42122654207332, 218, 12, 'PPL', 'P'),
(75861, 'Fort Gibson', 35.7975006103516, 0.624784249635314, -95.2502822875977, -1.66243103937262, 218, 42, 'PPL', 'P'),
(29824, 'Fort Gibson (historical)', 38.2772216796875, 0.668063546826301, -87.5077819824219, -1.52729891671063, 218, 19, 'PPL', 'P'),
(193565, 'Fort Goff', 41.8622207641602, 0.730633584531331, -123.255561828613, -2.15121537530474, 218, 6, 'PPL', 'P'),
(21230, 'Fort Gordon', 33.4208297729492, 0.583303518286513, -82.1622161865234, -1.43400119319021, 218, 13, 'PPL', 'P'),
(127503, 'Fort Gorges', 43.6627807617188, 0.76205928486843, -70.2216720581055, -1.22559938366964, 218, 26, 'PPL', 'P'),
(109251, 'Fort Grand', 39.5752792358398, 0.690718925061551, -80.085563659668, -1.39775676917673, 218, 58, 'PPL', 'P'),
(16078, 'Fort Green', 27.6122207641602, 0.481924166122139, -81.9436111450195, -1.43018581545451, 218, 12, 'PPL', 'P'),
(16079, 'Fort Green Springs', 27.5913906097412, 0.48156061134383, -81.9394378662109, -1.4301129779987, 218, 12, 'PPL', 'P'),
(94282, 'Fort Griffin', 32.9319381713867, 0.574770750153899, -99.2297210693359, -1.7318853484955, 218, 51, 'PPL', 'P'),
(194943, 'Fort Hall', 43.0333290100098, 0.751073279318662, -112.4375, -1.96240457771112, 218, 17, 'PPL', 'P'),
(16080, 'Fort Hamer', 27.5249996185303, 0.480401869953537, -82.4302825927734, -1.43867983459326, 218, 12, 'PPL', 'P'),
(148910, 'Fort Hamilton', 40.6186103820801, 0.708928488752049, -74.0336074829102, -1.29213020770589, 218, 40, 'PPL', 'P'),
(145244, 'Fort Hancock', 40.4638900756836, 0.706228109985736, -74.003059387207, -1.29159704285566, 218, 37, 'PPL', 'P'),
(191484, 'Fort Hancock', 31.2983303070068, 0.546258914233997, -105.844718933105, -1.84733884123067, 218, 51, 'PPL', 'P'),
(191485, 'Fort Hancock East Unit Number 1 Colonia', 31.2849998474121, 0.546026253823265, -105.83699798584, -1.84720408527951, 218, 51, 'PPL', 'P'),
(191486, 'Fort Hancock East Unit Number 2 Colonia', 31.2819995880127, 0.545973889418331, -105.829002380371, -1.84706453563839, 218, 51, 'PPL', 'P'),
(87078, 'Fort Harry', 35.6386108398438, 0.622011099992215, -83.4744415283203, -1.45690384593268, 218, 50, 'PPL', 'P'),
(35963, 'Fort Heiman', 36.5019416809082, 0.637079065702802, -88.0558319091797, -1.53686419239787, 218, 21, 'PPL', 'P'),
(54819, 'Fort Henry', 39.4636116027832, 0.688769957196804, -92.6074981689453, -1.61630575508272, 218, 29, 'PPL', 'P'),
(87079, 'Fort Henry', 36.5072212219238, 0.637171211076518, -88.0158309936523, -1.53616604471811, 218, 50, 'PPL', 'P'),
(148911, 'Fort Herkimer', 43.0169410705566, 0.750787255817588, -74.9527816772461, -1.30817282379642, 218, 40, 'PPL', 'P'),
(78288, 'Fort Hill', 39.8302803039551, 0.695169533296264, -79.2727813720703, -1.38357104215626, 218, 45, 'PPL', 'P'),
(102054, 'Fort Hill', 37.3861083984375, 0.652510686060238, -79.1833267211914, -1.3820097639672, 218, 53, 'PPL', 'P'),
(109252, 'Fort Hill', 38.3527793884277, 0.669382277619081, -81.6538925170898, -1.42512927149278, 218, 58, 'PPL', 'P'),
(119665, 'Fort Hill', 42.3349990844727, 0.738885122852833, -88.1122207641602, -1.53784836357871, 218, 18, 'PPL', 'P'),
(124866, 'Fort Hill', 42.2374992370605, 0.737183429495299, -70.904167175293, -1.23751117059335, 218, 23, 'PPL', 'P'),
(148915, 'Fort Hill', 43.0533294677734, 0.751422353158544, -76.753059387207, -1.3395935972855, 218, 40, 'PPL', 'P'),
(169377, 'Fort Hill (historical)', 41.8127784729004, 0.729770653759118, -71.3850021362305, -1.24590332382041, 218, 47, 'PPL', 'P'),
(130851, 'Fort Holmes', 45.8583297729492, 0.800378844003308, -84.6163864135742, -1.47683454405667, 218, 27, 'PPL', 'P'),
(47161, 'Fort Howard', 39.207218170166, 0.684295047617143, -76.4452819824219, -1.33422186820876, 218, 25, 'PPL', 'P'),
(100, 'Fort Hunt', 38.732780456543, 0.676014547418787, -77.0583267211914, -1.34492151736232, 218, 53, 'PPL', 'P'),
(148917, 'Fort Hunter', 42.9422187805176, 0.749483105831776, -74.2855606079102, -1.29652761929783, 218, 40, 'PPL', 'P'),
(161746, 'Fort Hunter', 40.3461112976074, 0.704172482519331, -76.9124984741211, -1.34237633430853, 218, 45, 'PPL', 'P'),
(124867, 'Fort Independence', 42.3380584716797, 0.738938519232689, -71.0122222900391, -1.23939708811929, 218, 23, 'PPL', 'P'),
(161747, 'Fort Indiantown Gap', 40.4397201538086, 0.705806265269068, -76.5986099243164, -1.33689794563013, 218, 45, 'PPL', 'P'),
(94283, 'Fort Inge', 29.1774997711182, 0.509243438505904, -99.7641677856445, -1.74121320337156, 218, 51, 'PPL', 'P'),
(181648, 'Fort Irwin', 35.2627792358398, 0.615451601069295, -116.683891296387, -2.0365180871611, 218, 6, 'PPL', 'P'),
(40969, 'Fort Jackson', 29.3575000762939, 0.512385036485816, -89.4550018310547, -1.56128431432946, 218, 22, 'PPL', 'P'),
(148918, 'Fort Jackson', 44.7055587768555, 0.780259194599977, -74.7152786254883, -1.30402761355971, 218, 40, 'PPL', 'P'),
(16081, 'Fort Jefferson', 24.6275005340576, 0.429830970855967, -82.8730621337891, -1.44640779544446, 218, 12, 'PPL', 'P'),
(155305, 'Fort Jefferson', 40.0263900756836, 0.698592294508261, -84.6552810668945, -1.47751338381853, 218, 41, 'PPL', 'P'),
(155306, 'Fort Jennings', 40.9063911437988, 0.713951210567939, -84.2966690063477, -1.47125442262462, 218, 41, 'PPL', 'P'),
(40970, 'Fort Jesup', 31.6127796173096, 0.551747090029405, -93.4027786254883, -1.63018601752615, 218, 22, 'PPL', 'P'),
(148919, 'Fort Johnson', 42.9583282470703, 0.749764269063861, -74.2333297729492, -1.2956160192567, 218, 40, 'PPL', 'P'),
(192572, 'Fort Johnson', 37.7791709899902, 0.659370922449255, -113.031387329102, -1.97276986698982, 218, 52, 'PPL', 'P'),
(81094, 'Fort Johnson Estates', 32.7419395446777, 0.57145464854356, -79.9086074829102, -1.39466830126056, 218, 48, 'PPL', 'P'),
(193566, 'Fort Jones', 41.607780456543, 0.726192763413624, -122.839172363281, -2.14394800816408, 218, 6, 'PPL', 'P'),
(194185, 'Fort Julesburg (historical)', 40.9430618286133, 0.714591234756912, -102.357780456543, -1.78648028400018, 218, 7, 'PPL', 'P'),
(127504, 'Fort Kent', 47.2586097717285, 0.824818340431828, -68.5899963378906, -1.19712127002704, 218, 26, 'PPL', 'P'),
(127505, 'Fort Kent Mills', 47.2388916015625, 0.824474193439963, -68.5844421386719, -1.19702433096337, 218, 26, 'PPL', 'P'),
(127506, 'Fort Kent Village', 47.2455596923828, 0.824590573579599, -68.6080627441406, -1.19743658830011, 218, 26, 'PPL', 'P'),
(16082, 'Fort King Acres', 28.2616691589355, 0.493259178932762, -82.1999969482422, -1.43466059187612, 218, 12, 'PPL', 'P'),
(196511, 'Fort Kipp', 48.146671295166, 0.84031793797609, -104.715278625488, -1.82762638915801, 218, 31, 'PPL', 'P'),
(16102, 'Fort Kissimmee', 27.5858306884766, 0.48146357241161, -81.1605606079102, -1.41651900537244, 218, 12, 'PPL', 'P'),
(200839, 'Fort Klamath', 42.704719543457, 0.745337962174095, -121.994720458984, -2.12920954205937, 218, 43, 'PPL', 'P'),
(209458, 'Fort LaClede (historical)', 41.4152793884277, 0.722832985961408, -108.388610839844, -1.89173813081809, 218, 59, 'PPL', 'P'),
(21232, 'Fort Lamar', 34.2400016784668, 0.59760076517763, -83.2738876342773, -1.45340352015393, 218, 13, 'PPL', 'P'),
(191487, 'Fort Lancaster', 30.6666698455811, 0.53523435942745, -101.695556640625, -1.77492229802729, 218, 51, 'PPL', 'P'),
(64838, 'Fort Landing', 35.9444389343262, 0.627348807186034, -76.0644378662109, -1.32757488444403, 218, 33, 'PPL', 'P'),
(204006, 'Fort Lane Plaza Condominium', 41.0550003051758, 0.716544929732594, -111.957496643066, -1.95402693871201, 218, 52, 'PPL', 'P'),
(209459, 'Fort Laramie', 42.2127799987793, 0.736751997398707, -104.516670227051, -1.82416001868317, 218, 59, 'PPL', 'P'),
(16083, 'Fort Lauderdale', 26.121940612793, 0.455913870703663, -80.1436080932617, -1.39876983565539, 218, 12, 'PPL', 'P'),
(81089, 'Fort Lawn', 34.7019386291504, 0.605663085903682, -80.8949966430664, -1.41188403981127, 218, 48, 'PPL', 'P'),
(196512, 'Fort Lazy Y Trailer Park', 47.8283309936523, 0.834761851572885, -114.346672058105, -1.99572591611214, 218, 31, 'PPL', 'P'),
(191488, 'Fort Leaton (historical)', 29.5425605773926, 0.515614951545378, -104.321708679199, -1.82075729775837, 218, 51, 'PPL', 'P'),
(102055, 'Fort Lee', 37.4955596923828, 0.654420971510152, -77.335563659668, -1.34976021474688, 218, 53, 'PPL', 'P'),
(145245, 'Fort Lee', 40.850830078125, 0.712981487036014, -73.9705581665039, -1.29102978954347, 218, 37, 'PPL', 'P'),
(127508, 'Fort Levett', 43.6430587768555, 0.761715071297537, -70.1958312988281, -1.22514837733904, 218, 26, 'PPL', 'P'),
(102056, 'Fort Lewis', 38.1269416809082, 0.665440666047709, -79.620002746582, -1.38963119837478, 218, 53, 'PPL', 'P'),
(102057, 'Fort Lewis (historical)', 38.1230583190918, 0.665372888597967, -79.6083297729492, -1.38942746655139, 218, 53, 'PPL', 'P'),
(102058, 'Fort Lewis Terrace', 37.2900009155273, 0.650833294047652, -80.102783203125, -1.39805730690574, 218, 53, 'PPL', 'P'),
(13101, 'Fort Lincoln New Town', 38.9222183227539, 0.679320861912121, -76.956672668457, -1.34314731944411, 218, 9, 'PPL', 'P'),
(161748, 'Fort Littleton', 40.0627784729004, 0.699227391849218, -77.9638900756836, -1.36072657948361, 218, 45, 'PPL', 'P'),
(196513, 'Fort Logan', 46.6786117553711, 0.814695465391356, -111.171943664551, -1.94031645278806, 218, 31, 'PPL', 'P'),
(16084, 'Fort Lonely', 27.6466693878174, 0.482525408027738, -82.5522232055664, -1.4408080997784, 218, 12, 'PPL', 'P'),
(16085, 'Fort Lonesome', 27.704439163208, 0.483533680816442, -82.146110534668, -1.43372009653716, 218, 12, 'PPL', 'P'),
(155307, 'Fort Loramie', 40.351390838623, 0.704264627893048, -84.373893737793, -1.47260224845231, 218, 41, 'PPL', 'P'),
(59949, 'Fort Loring', 33.5066719055176, 0.584801746136764, -90.2513885498047, -1.5751838846908, 218, 30, 'PPL', 'P'),
(59950, 'Fort Loring Landing', 33.4891700744629, 0.584496281559732, -90.2466735839844, -1.57510159301312, 218, 30, 'PPL', 'P'),
(78289, 'Fort Loudon', 39.9147186279297, 0.696643260064487, -77.9049987792969, -1.35969873246089, 218, 45, 'PPL', 'P'),
(87080, 'Fort Loudon', 35.5958290100098, 0.621264416201584, -84.2063903808594, -1.46967876336568, 218, 50, 'PPL', 'P'),
(87081, 'Fort Loudon Estates', 35.7813911437988, 0.624503086403229, -84.2319412231445, -1.47012470969021, 218, 50, 'PPL', 'P'),
(124868, 'Fort Lucas', 42.670280456543, 0.744736886716064, -72.6744384765625, -1.26840823345407, 218, 23, 'PPL', 'P'),
(194186, 'Fort Lupton', 40.0847206115723, 0.699610354413971, -104.8125, -1.82932322224656, 218, 7, 'PPL', 'P'),
(8939, 'Fort Lynn', 33.1650009155273, 0.578838462402886, -93.8838882446289, -1.63858296444317, 218, 4, 'PPL', 'P'),
(127509, 'Fort Lyon', 43.6913909912109, 0.76255862757282, -70.1847229003906, -1.22495449921168, 218, 26, 'PPL', 'P'),
(186723, 'Fort Lyon', 38.0922203063965, 0.664834663741662, -103.151672363281, -1.8003363116777, 218, 7, 'PPL', 'P'),
(130852, 'Fort Mackinac', 45.8530616760254, 0.800286898366673, -84.6177825927734, -1.47685891198064, 218, 27, 'PPL', 'P'),
(115607, 'Fort Madison', 40.6297187805176, 0.709122366879407, -91.3150024414063, -1.5937474490692, 218, 16, 'PPL', 'P'),
(109253, 'Fort Martin', 39.7125015258789, 0.693113905829859, -79.9499969482422, -1.39539068370624, 218, 58, 'PPL', 'P'),
(16086, 'Fort Mason', 28.8766708374023, 0.503992983127299, -81.7011108398438, -1.4259533866921, 218, 12, 'PPL', 'P'),
(16087, 'Fort Matanzas', 29.7147197723389, 0.518619696334773, -81.2388916015625, -1.41788613911804, 218, 12, 'PPL', 'P'),
(21233, 'Fort McAllister', 31.8905601501465, 0.556595274925353, -81.1961135864258, -1.41713952190643, 218, 13, 'PPL', 'P'),
(16088, 'Fort McCoy', 29.3647193908691, 0.51251103729489, -81.9672164916992, -1.43059780647515, 218, 12, 'PPL', 'P'),
(230, 'Fort McDermott', 30.670560836792, 0.535302270035247, -87.9172210693359, -1.53444497686364, 218, 2, 'PPL', 'P'),
(178204, 'Fort McDonald', 34.2350006103516, 0.597513480072903, -111.347503662109, -1.94338055278025, 218, 5, 'PPL', 'P'),
(178205, 'Fort McDowell', 33.6366691589355, 0.587070626227457, -111.673889160156, -1.94907705435193, 218, 5, 'PPL', 'P'),
(94284, 'Fort McIntosh', 27.5074996948242, 0.480096438666018, -99.5213928222656, -1.73697598091919, 218, 51, 'PPL', 'P'),
(191489, 'Fort McKavett', 30.826940536499, 0.538031610678415, -100.106391906738, -1.74718614106439, 218, 51, 'PPL', 'P'),
(72585, 'Fort McKinley', 39.7975006103516, 0.694597419715088, -84.2536087036133, -1.470502878565, 218, 41, 'PPL', 'P'),
(21234, 'Fort McPherson', 33.707218170166, 0.588301938757455, -84.4336090087891, -1.47364447654492, 218, 13, 'PPL', 'P'),
(16089, 'Fort McRee', 30.3250007629395, 0.529271108983086, -87.3150024414063, -1.52393427898943, 218, 12, 'PPL', 'P'),
(16090, 'Fort Meade', 27.7519397735596, 0.484362722863784, -81.8019409179688, -1.42771320354043, 218, 12, 'PPL', 'P'),
(155308, 'Fort Meigs Place', 41.538330078125, 0.724980625643475, -83.6513900756836, -1.45999218069079, 218, 41, 'PPL', 'P'),
(81090, 'Fort Mill', 35.0072212219238, 0.610991272296603, -80.9452819824219, -1.4127616845485, 218, 48, 'PPL', 'P'),
(148920, 'Fort Miller', 43.160831451416, 0.753298616725532, -73.5783309936523, -1.28418413396142, 218, 40, 'PPL', 'P'),
(181650, 'Fort Miller (historical)', 37.0152816772461, 0.646038538821073, -119.658332824707, -2.08843188523834, 218, 6, 'PPL', 'P'),
(178206, 'Fort Misery', 34.1402816772461, 0.595860322826236, -112.365829467773, -1.96115369094711, 218, 5, 'PPL', 'P'),
(2558, 'Fort Mitchell', 32.3413887023926, 0.564463717524047, -85.0216674804688, -1.48390803306997, 218, 2, 'PPL', 'P'),
(35962, 'Fort Mitchell', 39.059440612793, 0.681715842680429, -84.5475006103516, -1.47563225998255, 218, 21, 'PPL', 'P'),
(102059, 'Fort Mitchell', 36.9180603027344, 0.644341705732529, -78.4863891601563, -1.36984590884631, 218, 53, 'PPL', 'P'),
(148921, 'Fort Montgomery', 41.3313903808594, 0.721368846573109, -73.9872207641602, -1.29132060673451, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(2559, 'Fort Morgan', 30.2283306121826, 0.52758389656398, -88.023063659668, -1.53629227855378, 218, 2, 'PPL', 'P'),
(194187, 'Fort Morgan', 40.2502784729004, 0.702499884196707, -103.799438476563, -1.8116419631373, 218, 7, 'PPL', 'P'),
(124869, 'Fort Morris', 42.6513900756836, 0.744407187373112, -72.6822204589844, -1.26854405466966, 218, 23, 'PPL', 'P'),
(124870, 'Fort Morrison', 42.6972198486328, 0.745207067806517, -72.6966705322266, -1.26879625602489, 218, 23, 'PPL', 'P'),
(70830, 'Fort Mott', 39.6047210693359, 0.691232781993882, -75.5505599975586, -1.31860602368292, 218, 37, 'PPL', 'P'),
(81091, 'Fort Motte', 33.7388916015625, 0.588854744420728, -80.6927795410156, -1.40835468557664, 218, 48, 'PPL', 'P'),
(81092, 'Fort Moultrie', 32.7588882446289, 0.57175045916164, -79.8580627441406, -1.39378612914947, 218, 48, 'PPL', 'P'),
(21235, 'Fort Mountain (historical)', 34.7722206115723, 0.606889737901772, -84.7505569458008, -1.47917626160317, 218, 13, 'PPL', 'P'),
(21236, 'Fort Mudge', 31.0641708374023, 0.542172060514675, -82.1866683959961, -1.4344279647549, 218, 13, 'PPL', 'P'),
(102060, 'Fort Myer Heights', 38.8919410705566, 0.678792424172822, -77.079719543457, -1.34529489254715, 218, 53, 'PPL', 'P'),
(16091, 'Fort Myers', 26.6402797698975, 0.464960595637148, -81.8724975585938, -1.42894464922848, 218, 12, 'PPL', 'P'),
(16092, 'Fort Myers Beach', 26.4516696929932, 0.461668728792728, -81.9483337402344, -1.43026824029025, 218, 12, 'PPL', 'P'),
(16093, 'Fort Myers Shores', 26.708890914917, 0.466158086021302, -81.7461090087891, -1.42673875289757, 218, 12, 'PPL', 'P'),
(16094, 'Fort Myers Villas', 26.5611095428467, 0.46357881450556, -81.8638916015625, -1.428794446943, 218, 12, 'PPL', 'P'),
(40971, 'Fort Necessity', 32.047779083252, 0.559339262954517, -91.8177795410156, -1.60252256486101, 218, 22, 'PPL', 'P'),
(148922, 'Fort Niagara Beach', 43.2677803039551, 0.755165226333569, -79.0377807617188, -1.37946950776142, 218, 40, 'PPL', 'P'),
(169378, 'Fort Ninigret', 41.3805618286133, 0.722227050234387, -71.6497192382813, -1.25052350883753, 218, 47, 'PPL', 'P'),
(207444, 'Fort Nisqually', 47.3030586242676, 0.825594119257368, -122.52693939209, -2.13849851478351, 218, 56, 'PPL', 'P'),
(102061, 'Fort Nonsense', 37.4650001525879, 0.653887606922837, -76.4452819824219, -1.33422186820876, 218, 53, 'PPL', 'P'),
(102062, 'Fort Nottoway', 36.8855590820313, 0.643774452420342, -77.4241714477539, -1.35130671239189, 218, 53, 'PPL', 'P'),
(16095, 'Fort Ogden', 27.0869407653809, 0.472756300648569, -81.9524993896484, -1.43034094458801, 218, 12, 'PPL', 'P'),
(21237, 'Fort Oglethorpe', 34.9488906860352, 0.609973212390893, -85.2569427490234, -1.48801436115476, 218, 13, 'PPL', 'P'),
(148923, 'Fort Ontario', 43.4658317565918, 0.758621876270437, -76.5086135864258, -1.3353272132192, 218, 40, 'PPL', 'P'),
(181651, 'Fort Ord Village (historical)', 36.6236114501953, 0.639202603777003, -121.833610534668, -2.12639764342241, 218, 6, 'PPL', 'P'),
(94285, 'Fort Parker', 31.5636100769043, 0.550888919657641, -96.5469436645508, -1.68506204968389, 218, 51, 'PPL', 'P'),
(2560, 'Fort Payne', 34.4441719055176, 0.601164207874211, -85.7197189331055, -1.49609132926681, 218, 2, 'PPL', 'P'),
(47162, 'Fort Pendleton', 39.295280456543, 0.685832024461255, -79.3744430541992, -1.38534537323252, 218, 25, 'PPL', 'P'),
(16096, 'Fort Peyton', 29.8263893127441, 0.520568697489034, -81.3544387817383, -1.4199028178535, 218, 12, 'PPL', 'P'),
(94286, 'Fort Phantom Hill (historical)', 32.6328201293945, 0.569550155469017, -99.6829681396484, -1.73979600219747, 218, 51, 'PPL', 'P'),
(16097, 'Fort Pickens', 30.3286094665527, 0.529334092742866, -87.2991714477539, -1.52365797602633, 218, 12, 'PPL', 'P'),
(196514, 'Fort Piegan', 48.6305618286133, 0.848763421003976, -112.646667480469, -1.9660552389334, 218, 31, 'PPL', 'P'),
(16098, 'Fort Pierce', 27.4463901519775, 0.479029875938955, -80.3258285522461, -1.40195018262916, 218, 12, 'PPL', 'P'),
(16099, 'Fort Pierce Shores', 27.4863891601563, 0.479727990329206, -80.2994384765625, -1.40148958891864, 218, 12, 'PPL', 'P'),
(202138, 'Fort Pierre', 44.3536109924316, 0.774116546966682, -100.373329162598, -1.75184507507537, 218, 49, 'PPL', 'P'),
(87082, 'Fort Pillow', 35.663330078125, 0.622442532088808, -89.7388916015625, -1.56623912553755, 218, 50, 'PPL', 'P'),
(181652, 'Fort Piute (historical)', 35.1150016784668, 0.612872396132581, -114.984443664551, -2.00685713052035, 218, 6, 'PPL', 'P'),
(148924, 'Fort Plain', 42.9313888549805, 0.749294087973408, -74.6230621337891, -1.30241813215492, 218, 40, 'PPL', 'P'),
(145247, 'Fort Plains', 40.1833305358887, 0.701331422268435, -74.2547225952148, -1.29598939444153, 218, 37, 'PPL', 'P'),
(40972, 'Fort Polk', 31.0463905334473, 0.541861735668653, -93.2052764892578, -1.62673895496921, 218, 22, 'PPL', 'P'),
(127510, 'Fort Popham', 43.7550010681152, 0.763668832852247, -69.7838897705078, -1.21795864134415, 218, 26, 'PPL', 'P'),
(102063, 'Fort Powhatan', 37.2708282470703, 0.650498667856684, -77.0802764892578, -1.34530461308512, 218, 53, 'PPL', 'P'),
(127511, 'Fort Preble', 43.6483306884766, 0.761807083513199, -70.2263870239258, -1.22568167534733, 218, 26, 'PPL', 'P'),
(81093, 'Fort Prince Farms', 34.9722213745117, 0.610380409721566, -82.057502746582, -1.43217359889215, 218, 48, 'PPL', 'P'),
(148925, 'Fort Putnam', 41.3905601501465, 0.722401553864815, -73.9641723632813, -1.29091833625185, 218, 40, 'PPL', 'P'),
(191490, 'Fort Quitman', 31.0625, 0.542142898900739, -105.58332824707, -1.84277671312531, 218, 51, 'PPL', 'P'),
(207445, 'Fort Rains', 45.6527786254883, 0.796791299698862, -121.917221069336, -2.12785692254171, 218, 56, 'PPL', 'P'),
(64839, 'Fort Raleigh City', 35.9363899230957, 0.627208325438532, -75.7072219848633, -1.3213402911741, 218, 33, 'PPL', 'P'),
(170316, 'Fort Randall', 43.0244407653809, 0.750918150185165, -98.623893737793, -1.7213116668615, 218, 49, 'PPL', 'P'),
(40973, 'Fort Randolph', 31.3233299255371, 0.546695239889093, -92.4486083984375, -1.61353260543962, 218, 22, 'PPL', 'P'),
(140038, 'Fort Ransom', 46.5208282470703, 0.811941623666159, -97.9258270263672, -1.70912810434856, 218, 34, 'PPL', 'P'),
(155309, 'Fort Recovery', 40.4127807617188, 0.705336084178614, -84.7763900756836, -1.47962713477572, 218, 41, 'PPL', 'P'),
(16100, 'Fort Redoubt', 30.3552799224854, 0.529799580011899, -87.2969436645508, -1.52361909387442, 218, 12, 'PPL', 'P'),
(124871, 'Fort Revere', 42.3061103820801, 0.738380919879454, -70.908332824707, -1.23758387489111, 218, 23, 'PPL', 'P'),
(186724, 'Fort Reynolds', 38.2305603027344, 0.667249152164955, -104.302780151367, -1.82042693262515, 218, 7, 'PPL', 'P'),
(198297, 'Fort Rice', 46.5261116027832, 0.812033835618903, -100.583892822266, -1.75552010422163, 218, 34, 'PPL', 'P'),
(211833, 'Fort Richardson', 61.2544403076172, 1.06909166483425, -149.688323974609, -2.6125541051489, 218, 1, 'PPL', 'P'),
(135424, 'Fort Ripley', 46.1661109924316, 0.805750639659079, -94.3600006103516, -1.64689269283449, 218, 28, 'PPL', 'P'),
(29825, 'Fort Ritner', 38.7730598449707, 0.676717555367541, -86.2811126708984, -1.50588949839138, 218, 19, 'PPL', 'P'),
(178207, 'Fort River Caves', 34.5680618286133, 0.603326494942274, -111.846389770508, -1.95208775796427, 218, 5, 'PPL', 'P'),
(161749, 'Fort Robertson', 40.3605613708496, 0.704424683874562, -77.3844375610352, -1.35061322524403, 218, 45, 'PPL', 'P'),
(934, 'Fort Robinson', 36.5550003051758, 0.638005113392849, -82.5902786254883, -1.44147229215427, 218, 50, 'PPL', 'P'),
(200840, 'Fort Rock', 43.3566703796387, 0.756716650826595, -121.052780151367, -2.1127695823342, 218, 43, 'PPL', 'P'),
(181653, 'Fort Romie', 36.4002799987793, 0.635304734626536, -121.345283508301, -2.11787472898582, 218, 6, 'PPL', 'P'),
(181654, 'Fort Roosevelt', 36.3175010681152, 0.633859969735168, -119.656936645508, -2.08840751731437, 218, 6, 'PPL', 'P'),
(181655, 'Fort Rosecrans', 32.6841697692871, 0.570446375754855, -117.245277404785, -2.04631612312761, 218, 6, 'PPL', 'P'),
(181656, 'Fort Ross', 38.5141716003418, 0.672199103104058, -123.242500305176, -2.15098740871543, 218, 6, 'PPL', 'P'),
(109254, 'Fort Run', 39.0666694641113, 0.681842009937071, -78.9227828979492, -1.37746241640589, 218, 58, 'PPL', 'P'),
(135427, 'Fort Saint Charles', 49.3619384765625, 0.861528351582889, -94.9805603027344, -1.65772350267174, 218, 28, 'PPL', 'P'),
(40974, 'Fort Saint Phillip', 29.3622207641602, 0.51246742803204, -89.4647216796875, -1.5614539576909, 218, 22, 'PPL', 'P'),
(194188, 'Fort Saint Vrain (historical)', 40.2788887023926, 0.702999226901097, -104.854438781738, -1.83005519207216, 218, 7, 'PPL', 'P'),
(148926, 'Fort Salonga', 40.9124984741211, 0.714057803590569, -73.3013916015625, -1.27935062974099, 218, 40, 'PPL', 'P'),
(16101, 'Fort San Carlos', 30.3469390869141, 0.529654004968812, -87.2969436645508, -1.52361909387442, 218, 12, 'PPL', 'P'),
(13785, 'Fort Saulsbury', 38.9338912963867, 0.679524593735512, -75.3319396972656, -1.31479037963111, 218, 10, 'PPL', 'P'),
(127512, 'Fort Scammel', 43.6502799987793, 0.761841105396125, -70.2133331298828, -1.22545384191607, 218, 26, 'PPL', 'P'),
(32466, 'Fort Scott', 37.8397216796875, 0.660427731348826, -94.7080612182617, -1.65296749643902, 218, 20, 'PPL', 'P'),
(72582, 'Fort Scott', 39.2708282470703, 0.68540525289657, -84.6597213745117, -1.47759088180625, 218, 41, 'PPL', 'P'),
(21238, 'Fort Screven', 32.0208282470703, 0.558868882126981, -80.8444366455078, -1.41100160138407, 218, 13, 'PPL', 'P'),
(194189, 'Fort Sedgwick (historical)', 40.9430618286133, 0.714591234756912, -102.379997253418, -1.78686804025489, 218, 7, 'PPL', 'P'),
(188561, 'Fort Selden', 32.4836082458496, 0.566945916818055, -106.912498474121, -1.86597510990683, 218, 38, 'PPL', 'P'),
(155310, 'Fort Seneca', 41.209171295166, 0.719235721118983, -83.1688919067383, -1.45157099900785, 218, 41, 'PPL', 'P'),
(193567, 'Fort Seward', 40.2230606079102, 0.702024842837264, -123.642219543457, -2.15796382550701, 218, 6, 'PPL', 'P'),
(109255, 'Fort Seybert', 38.6938896179199, 0.675335774235953, -79.192497253418, -1.38216981994871, 218, 58, 'PPL', 'P'),
(196515, 'Fort Shaw', 47.5055618286133, 0.82912846691904, -111.809440612793, -1.9514428735063, 218, 31, 'PPL', 'P'),
(155311, 'Fort Shawnee', 40.6866683959961, 0.710116325177252, -84.1377792358398, -1.46848127298152, 218, 41, 'PPL', 'P'),
(8940, 'Fort Smith', 35.3858299255371, 0.617599240751362, -94.3983306884766, -1.64756167890032, 218, 4, 'PPL', 'P'),
(21239, 'Fort Smith', 34.6297187805176, 0.604402611759747, -83.9730606079102, -1.46560639058478, 218, 13, 'PPL', 'P'),
(196516, 'Fort Smith', 45.3127784729004, 0.79085717757892, -107.936393737793, -1.88384545345348, 218, 31, 'PPL', 'P'),
(207446, 'Fort Spokane', 47.9047203063965, 0.836095096593605, -118.308059692383, -2.06486517327807, 218, 56, 'PPL', 'P'),
(35966, 'Fort Spring', 38.041389465332, 0.663947498203529, -84.6263885498047, -1.47700911426612, 218, 21, 'PPL', 'P'),
(109256, 'Fort Spring', 37.7449989318848, 0.658774507523132, -80.539436340332, -1.40567834183917, 218, 58, 'PPL', 'P'),
(94287, 'Fort Spunky', 32.3252792358398, 0.564182554291962, -97.6447219848633, -1.70422189583036, 218, 51, 'PPL', 'P'),
(124872, 'Fort Standish', 41.9972190856934, 0.732989749726752, -70.6291732788086, -1.23271162167681, 218, 23, 'PPL', 'P'),
(188562, 'Fort Stanton', 33.4958305358887, 0.584612528541314, -105.522499084473, -1.84171504395675, 218, 38, 'PPL', 'P'),
(209460, 'Fort Steele', 41.7780609130859, 0.729164718032098, -106.945831298828, -1.86655687744695, 218, 59, 'PPL', 'P'),
(200841, 'Fort Stevens', 46.202220916748, 0.806380876731046, -123.961112976074, -2.16352956586916, 218, 43, 'PPL', 'P'),
(21240, 'Fort Stewart', 31.8624992370605, 0.556105519600888, -81.5177764892578, -1.42275359864237, 218, 13, 'PPL', 'P'),
(191491, 'Fort Stockton', 30.8938903808594, 0.539200105896201, -102.878890991211, -1.79557537859696, 218, 51, 'PPL', 'P'),
(2561, 'Fort Stoddard', 31.0997200012207, 0.542792510469636, -87.9791717529297, -1.53552622026621, 218, 2, 'PPL', 'P'),
(188563, 'Fort Sumner', 34.4716682434082, 0.601644109502643, -104.245002746582, -1.81941852667839, 218, 38, 'PPL', 'P'),
(75862, 'Fort Supply', 36.5736083984375, 0.638329885887785, -99.5719375610352, -1.73785815303028, 218, 42, 'PPL', 'P'),
(35964, 'Fort Thomas', 39.0750007629395, 0.68198741853259, -84.4472198486328, -1.47388203051415, 218, 21, 'PPL', 'P'),
(178208, 'Fort Thomas', 33.0369415283203, 0.576603404458037, -109.964721679688, -1.91924645434974, 218, 5, 'PPL', 'P'),
(170317, 'Fort Thompson', 44.0686111450195, 0.769142361261659, -99.4375, -1.73551177495186, 218, 49, 'PPL', 'P'),
(148927, 'Fort Ticonderoga', 43.8413887023926, 0.765176581503395, -73.3880615234375, -1.28086330524015, 218, 40, 'PPL', 'P'),
(148928, 'Fort Tilden', 40.5622215270996, 0.707944317571211, -73.8913879394531, -1.28964800841189, 218, 40, 'PPL', 'P'),
(140042, 'Fort Totten', 47.9799995422363, 0.837408967117396, -98.9925003051758, -1.72774506510681, 218, 34, 'PPL', 'P'),
(75863, 'Fort Towson', 34.0186080932617, 0.593736718173007, -95.26611328125, -1.66270734233571, 218, 42, 'PPL', 'P'),
(94288, 'Fort Travis', 29.3633308410645, 0.512486802528971, -94.7574996948242, -1.6538303606322, 218, 51, 'PPL', 'P'),
(113451, 'Fort Trumbull', 41.3436088562012, 0.721582099197397, -72.0936126708984, -1.25827091076468, 218, 8, 'PPL', 'P'),
(178209, 'Fort Tuthill', 35.1416702270508, 0.613337850112099, -111.69361114502, -1.94942126792282, 218, 5, 'PPL', 'P'),
(16103, 'Fort Union', 30.4072208404541, 0.530706120046961, -83.0475006103516, -1.44945232120264, 218, 12, 'PPL', 'P'),
(196517, 'Fort Union (historical)', 48.0097198486328, 0.837927684318716, -104.048332214355, -1.81598597834939, 218, 31, 'PPL', 'P'),
(204007, 'Fort Union Cove Condo', 40.6186103820801, 0.708928488752049, -111.875556945801, -1.95259682120663, 218, 52, 'PPL', 'P'),
(21241, 'Fort Valley', 32.5536117553711, 0.568167708547156, -83.8874969482422, -1.46411302300352, 218, 13, 'PPL', 'P'),
(178210, 'Fort Verde Estates', 34.5405616760254, 0.602846526734814, -111.856109619141, -1.9522574013257, 218, 5, 'PPL', 'P'),
(148929, 'Fort Wadsworth', 40.6088905334473, 0.708758845390611, -74.0630569458008, -1.29264419779628, 218, 40, 'PPL', 'P'),
(16104, 'Fort Walton Beach', 30.4055595397949, 0.530677124880593, -86.6188888549805, -1.51178480493843, 218, 12, 'PPL', 'P'),
(207447, 'Fort Ward', 47.5811080932617, 0.830446997974738, -122.513893127441, -2.13827081451031, 218, 56, 'PPL', 'P'),
(102064, 'Fort Ward Heights', 38.8358306884766, 0.677813113260972, -77.1083297729492, -1.34579423525154, 218, 53, 'PPL', 'P'),
(124873, 'Fort Warren', 42.3194389343262, 0.738613547000672, -70.9291687011719, -1.23794752953796, 218, 23, 'PPL', 'P'),
(209461, 'Fort Washakie', 43.0063896179199, 0.750603098228209, -108.88166809082, -1.90034360324846, 218, 59, 'PPL', 'P'),
(47163, 'Fort Washington', 38.707218170166, 0.675568401357172, -77.0233306884766, -1.34431072136631, 218, 25, 'PPL', 'P'),
(161750, 'Fort Washington', 40.1416702270508, 0.700604312711816, -75.2094421386719, -1.31265239390799, 218, 45, 'PPL', 'P'),
(47164, 'Fort Washington Estates', 38.7075004577637, 0.675573328205188, -77.0233306884766, -1.34431072136631, 218, 25, 'PPL', 'P'),
(47165, 'Fort Washington Forest', 38.7147216796875, 0.675699362303776, -76.9822235107422, -1.34359326576864, 218, 25, 'PPL', 'P'),
(75864, 'Fort Washita', 34.1027793884277, 0.595205784409322, -96.5461120605469, -1.68504753545595, 218, 42, 'PPL', 'P'),
(122632, 'Fort Wayne', 41.1305618286133, 0.717863727104401, -85.1288909912109, -1.48577943636797, 218, 19, 'PPL', 'P'),
(130853, 'Fort Wayne', 42.2994384765625, 0.73826447316079, -83.0961074829102, -1.45030067116788, 218, 27, 'PPL', 'P'),
(178211, 'Fort Whipple', 34.5547218322754, 0.603093668083973, -112.451942443848, -1.9626566459083, 218, 5, 'PPL', 'P'),
(16105, 'Fort White', 29.923059463501, 0.52225590990814, -82.7138900756836, -1.44362971895334, 218, 12, 'PPL', 'P'),
(148930, 'Fort William Henry', 43.4205589294434, 0.757831716375011, -73.709716796875, -1.28647724881804, 218, 40, 'PPL', 'P'),
(194944, 'Fort Wilson', 44.0291709899902, 0.768454000698901, -116.844169616699, -2.03931547157012, 218, 17, 'PPL', 'P'),
(188564, 'Fort Wingate', 35.4677810668945, 0.619029557993817, -108.540557861328, -1.89439010663159, 218, 38, 'PPL', 'P'),
(124874, 'Fort Winthrop (historical)', 42.3519401550293, 0.739180800312859, -71.0124969482422, -1.23940188180925, 218, 23, 'PPL', 'P'),
(94289, 'Fort Worth', 32.7252807617188, 0.57116389793155, -97.320556640625, -1.69856414325254, 218, 51, 'PPL', 'P'),
(35965, 'Fort Wright', 39.0516700744629, 0.681580221201917, -84.5341720581055, -1.47539963286133, 218, 21, 'PPL', 'P'),
(198298, 'Fort Yates', 46.0869407653809, 0.804368858527492, -100.629722595215, -1.75631998465503, 218, 34, 'PPL', 'P'),
(211834, 'Fort Yukon', 66.5647201538086, 1.16177353235259, -145.273895263672, -2.53550778954847, 218, 1, 'PPL', 'P'),
(59951, 'Fortenberry', 31.3072204589844, 0.546414076657008, -89.8552780151367, -1.56827045165901, 218, 30, 'PPL', 'P'),
(161751, 'Fortenia', 41.5774993896484, 0.725664259095298, -75.2938919067383, -1.31412632041329, 218, 45, 'PPL', 'P'),
(70831, 'Fortescue', 39.2374992370605, 0.68482355193547, -75.1719436645508, -1.3119979220701, 218, 37, 'PPL', 'P'),
(139161, 'Fortescue', 40.0522193908691, 0.699043101101784, -95.3180618286133, -1.66361401552883, 218, 29, 'PPL', 'P'),
(196518, 'Fortine', 48.7644386291504, 0.851100011965384, -114.902221679688, -2.00542208616696, 218, 31, 'PPL', 'P'),
(161752, 'Fortney', 40.0988883972168, 0.699857628921185, -76.9072189331055, -1.34228418893481, 218, 45, 'PPL', 'P'),
(47166, 'Fortney Mobile Home Park', 39.7052803039551, 0.692987871731271, -77.7188873291016, -1.35645047487932, 218, 25, 'PPL', 'P'),
(87083, 'Forts (historical)', 36.5924987792969, 0.638659585230736, -87.0888900756836, -1.51998787372809, 218, 50, 'PPL', 'P'),
(21242, 'Fortson', 32.6069412231445, 0.569098483348139, -84.9372177124023, -1.48243410656467, 218, 13, 'PPL', 'P'),
(207448, 'Fortson', 48.2686080932617, 0.842446136582199, -121.726112365723, -2.12452144643444, 218, 56, 'PPL', 'P'),
(40977, 'Fortson (historical)', 32.0513916015625, 0.559402313293324, -93.4861068725586, -1.63164036979745, 218, 22, 'PPL', 'P'),
(21245, 'Fortsonia', 34.0149993896484, 0.593673734413227, -82.779167175293, -1.44476901926768, 218, 13, 'PPL', 'P'),
(148931, 'Fortsville', 43.2299995422363, 0.754505827647665, -73.6822204589844, -1.2859973471896, 218, 40, 'PPL', 'P'),
(54818, 'Fortuna', 38.5666694641113, 0.6731153636771, -92.7977828979492, -1.6196268501201, 218, 29, 'PPL', 'P'),
(161753, 'Fortuna', 40.2588882446289, 0.702650153061215, -75.2649993896484, -1.31362205086089, 218, 45, 'PPL', 'P'),
(178212, 'Fortuna', 32.690559387207, 0.570557895625503, -114.452217102051, -1.99756802463815, 218, 5, 'PPL', 'P'),
(193568, 'Fortuna', 40.598331451416, 0.708574554643178, -124.156112670898, -2.16693295258423, 218, 6, 'PPL', 'P'),
(198302, 'Fortuna', 48.9099998474121, 0.853640534487266, -103.77889251709, -1.81128336849652, 218, 34, 'PPL', 'P'),
(207449, 'Fortuna', 47.5811080932617, 0.830446997974738, -122.218612670898, -2.13311719832684, 218, 56, 'PPL', 'P'),
(178213, 'Fortuna Foothills', 32.6577796936035, 0.569985782044326, -114.411109924316, -1.99685056904048, 218, 5, 'PPL', 'P'),
(8942, 'Fortune', 35.4147186279297, 0.618103443724742, -90.5530624389648, -1.58044908732394, 218, 4, 'PPL', 'P'),
(200842, 'Fortune Branch', 42.7750015258789, 0.746564614172185, -123.316390991211, -2.1522770444733, 218, 43, 'PPL', 'P'),
(40976, 'Fortune Fork', 32.3591690063477, 0.564774042370068, -91.1258316040039, -1.59044579510777, 218, 22, 'PPL', 'P'),
(130854, 'Fortune Lake', 46.0947189331055, 0.804504613164058, -88.4161071777344, -1.54315218204766, 218, 27, 'PPL', 'P'),
(127513, 'Fortunes Rocks', 43.4241714477539, 0.757894766713819, -70.3783264160156, -1.22833351800277, 218, 26, 'PPL', 'P'),
(21246, 'Fortville', 33.0533294677734, 0.576889427959111, -83.4574966430664, -1.45660810189362, 218, 13, 'PPL', 'P'),
(29826, 'Fortville', 39.9322204589844, 0.696948724641519, -85.8480606079102, -1.49833131405968, 218, 19, 'PPL', 'P'),
(59952, 'Forty (historical)', 32.5183296203613, 0.567551919124103, -89.7763900756836, -1.56689359737544, 218, 30, 'PPL', 'P'),
(119666, 'Forty Acres', 40.6794395446777, 0.709990157920609, -90.024169921875, -1.57121817151157, 218, 18, 'PPL', 'P'),
(87085, 'Forty Five', 35.0572204589844, 0.611863923606795, -89.3088912963867, -1.55873420442766, 218, 50, 'PPL', 'P'),
(87084, 'Forty Forks', 35.2936096191406, 0.615989692767546, -88.5822219848633, -1.54605143236837, 218, 50, 'PPL', 'P'),
(161761, 'Forty Fort', 41.2788887023926, 0.72045251942104, -75.8786087036133, -1.32433155371048, 218, 45, 'PPL', 'P'),
(8943, 'Forty Four', 36.1436080932617, 0.630824964777887, -92.0608291625977, -1.60676458100334, 218, 4, 'PPL', 'P'),
(196519, 'Forty Mile Colony', 45.2700004577637, 0.790110560367316, -107.349998474121, -1.8736109253843, 218, 31, 'PPL', 'P'),
(16106, 'Fortymile Bend', 25.7611103057861, 0.449616193805411, -80.8272171020508, -1.41070106365506, 218, 12, 'PPL', 'P'),
(54820, 'Fortyville (historical)', 39.0047187805176, 0.680760766534499, -93.8077774047852, -1.63725457969144, 218, 29, 'PPL', 'P'),
(8944, 'Forum', 36.1816711425781, 0.631489290311807, -93.7147216796875, -1.63563045090066, 218, 4, 'PPL', 'P'),
(161755, 'Forward', 40.1313896179199, 0.700424882233372, -78.8649978637695, -1.37645387730107, 218, 45, 'PPL', 'P'),
(174145, 'Forward', 42.8969383239746, 0.748692812778295, -89.7561111450195, -1.56653966326657, 218, 57, 'PPL', 'P'),
(161758, 'Forwardstown', 40.2186088562012, 0.701947145112461, -79.0299987792969, -1.37933368654583, 218, 45, 'PPL', 'P'),
(13786, 'Forwood', 39.7988891601563, 0.694621654481007, -75.5013885498047, -1.31774782002164, 218, 10, 'PPL', 'P'),
(64840, 'Foscoe', 36.1616706848145, 0.631140216471925, -81.7658309936523, -1.42708296646846, 218, 33, 'PPL', 'P'),
(2562, 'Foshee', 31.1166706085205, 0.54308835437723, -87.2263870239258, -1.52238764818636, 218, 2, 'PPL', 'P'),
(2563, 'Fosheeton', 32.9977798461914, 0.575919904164268, -85.8269424438477, -1.49796273256481, 218, 2, 'PPL', 'P'),
(75865, 'Foss', 35.4544410705566, 0.618796731135517, -99.1694412231445, -1.73083326670686, 218, 42, 'PPL', 'P'),
(200843, 'Foss', 45.6963882446289, 0.797552431138406, -123.79638671875, -2.16065455031437, 218, 43, 'PPL', 'P'),
(8945, 'Foss (historical)', 33.670280456543, 0.587657254036574, -93.1255569458008, -1.6253475864577, 218, 4, 'PPL', 'P'),
(200844, 'Fossil', 44.9983291625977, 0.785369001783512, -120.214996337891, -2.09814749636912, 218, 43, 'PPL', 'P'),
(209462, 'Fossil', 41.8161087036133, 0.729828777249909, -110.723327636719, -1.93248662602517, 218, 59, 'PPL', 'P'),
(209463, 'Fossil Forest', 44.8605613708496, 0.782964500214307, -110.23388671875, -1.92394427051264, 218, 59, 'PPL', 'P'),
(78290, 'Fossilville', 39.8669395446777, 0.695809357748155, -78.6947174072266, -1.3734819226826, 218, 45, 'PPL', 'P'),
(119667, 'Fossland', 42.4944381713867, 0.741667859875857, -87.9516677856445, -1.53504618547973, 218, 18, 'PPL', 'P'),
(135430, 'Fosston', 47.5763893127441, 0.830364639718027, -95.751106262207, -1.67117206670247, 218, 28, 'PPL', 'P'),
(194191, 'Fosston', 40.5686111450195, 0.708055837441858, -104.359443664551, -1.82141589749595, 218, 7, 'PPL', 'P'),
(135432, 'Fossum', 47.2386093139648, 0.824469266591946, -96.1758270263672, -1.67858484243865, 218, 28, 'PPL', 'P'),
(35967, 'Foster', 38.7991714477539, 0.677173288809081, -84.2130584716797, -1.46979514350531, 218, 21, 'PPL', 'P'),
(54821, 'Foster', 38.1661109924316, 0.666124299499533, -94.5072174072266, -1.6494621106542, 218, 29, 'PPL', 'P'),
(59954, 'Foster', 31.6002807617188, 0.551528943846614, -91.3288879394531, -1.5939897967284, 218, 30, 'PPL', 'P'),
(64841, 'Foster', 35.3972206115723, 0.617798045726737, -83.1830596923828, -1.45181827351506, 218, 33, 'PPL', 'P'),
(72583, 'Foster', 39.3191719055176, 0.686249008908934, -84.253059387207, -1.47049329118508, 218, 41, 'PPL', 'P'),
(75866, 'Foster', 34.6163902282715, 0.604169984638529, -97.4888916015625, -1.70150214256711, 218, 42, 'PPL', 'P'),
(102065, 'Foster', 37.4527816772461, 0.653674354298549, -76.3852767944336, -1.33317458011009, 218, 53, 'PPL', 'P'),
(109258, 'Foster', 38.0972213745117, 0.664921948846389, -81.7799987792969, -1.42733024097567, 218, 58, 'PPL', 'P'),
(115608, 'Foster', 40.9327812194824, 0.714411804278468, -92.7572174072266, -1.6189188487443, 218, 16, 'PPL', 'P'),
(122633, 'Foster', 40.146671295166, 0.700691597816543, -87.4713897705078, -1.52666375279065, 218, 19, 'PPL', 'P'),
(130856, 'Foster', 42.3144416809082, 0.738526328474972, -83.7811126708984, -1.46225626709152, 218, 27, 'PPL', 'P'),
(135434, 'Foster', 45.416389465332, 0.792665530538111, -96.6755599975586, -1.68730682816672, 218, 28, 'PPL', 'P'),
(141835, 'Foster', 42.2738914489746, 0.737818593415283, -97.6641693115234, -1.70456131571129, 218, 35, 'PPL', 'P'),
(148932, 'Foster', 42.1291694641113, 0.735292718279398, -76.1436080932617, -1.32895666557562, 218, 40, 'PPL', 'P'),
(161760, 'Foster', 41.3250007629395, 0.721257326702462, -79.8055572509766, -1.39286973541838, 218, 45, 'PPL', 'P'),
(169379, 'Foster', 41.8536109924316, 0.730483315666824, -71.7586135864258, -1.25242407374947, 218, 47, 'PPL', 'P'),
(174146, 'Foster', 44.6430587768555, 0.77916836381748, -91.3116683959961, -1.59368925899938, 218, 57, 'PPL', 'P'),
(191492, 'Foster', 33.064998626709, 0.577093093203475, -102.290832519531, -1.78531182207191, 218, 51, 'PPL', 'P'),
(193569, 'Foster', 41.2538909912109, 0.720016227055458, -122.957778930664, -2.1460180832794, 218, 6, 'PPL', 'P'),
(196520, 'Foster', 45.9249992370605, 0.80154244566259, -107.590278625488, -1.87780460515285, 218, 31, 'PPL', 'P'),
(200845, 'Foster', 44.4105606079102, 0.775110505264527, -122.671112060547, -2.14101480253947, 218, 43, 'PPL', 'P'),
(207450, 'Foster', 47.4816703796387, 0.828711482471361, -122.274436950684, -2.13409151581164, 218, 56, 'PPL', 'P'),
(181658, 'Foster Bar (historical)', 39.4361114501953, 0.688289988989344, -121.128890991211, -2.11409796708593, 218, 6, 'PPL', 'P'),
(47190, 'Foster Branch', 39.4083290100098, 0.687805093933868, -76.3388900756836, -1.3323649791387, 218, 25, 'PPL', 'P'),
(161762, 'Foster Brook', 41.9749984741211, 0.732601926893009, -78.6175003051758, -1.37213423001296, 218, 45, 'PPL', 'P'),
(130857, 'Foster City', 45.9633293151855, 0.802211431728418, -87.7438888549805, -1.53141975902337, 218, 27, 'PPL', 'P'),
(181659, 'Foster City', 37.5586090087891, 0.655521389672573, -122.269996643066, -2.13401401782392, 218, 6, 'PPL', 'P'),
(94291, 'Foster Colonia', 26.3050003051758, 0.459108865063431, -98.1230010986328, -1.71256944110916, 218, 51, 'PPL', 'P'),
(81095, 'Foster Corner', 33.3205604553223, 0.581553488555195, -79.4250030517578, -1.38622781165972, 218, 48, 'PPL', 'P'),
(161763, 'Foster Corner', 41.413890838623, 0.722808751195488, -79.8533325195313, -1.39370357115568, 218, 45, 'PPL', 'P'),
(143835, 'Foster Corners', 42.7691688537598, 0.746462814839517, -71.204719543457, -1.24275679899248, 218, 36, 'PPL', 'P'),
(64842, 'Foster Creek', 35.9225006103516, 0.626965911200307, -82.6141662597656, -1.44188921002292, 218, 33, 'PPL', 'P'),
(2564, 'Foster Crossroad', 33.4225006103516, 0.583332679900449, -85.5552825927734, -1.49322137371809, 218, 2, 'PPL', 'P'),
(2569, 'Foster Crossroads', 32.9936103820801, 0.575847133287482, -85.5180587768555, -1.49257169557016, 218, 2, 'PPL', 'P'),
(87086, 'Foster Crossroads', 36.5830612182617, 0.638494868717315, -84.5555572509766, -1.47577287488811, 218, 50, 'PPL', 'P'),
(102066, 'Foster Fork', 38.7747192382813, 0.676746517244396, -77.7536087036133, -1.35705647718537, 218, 53, 'PPL', 'P'),
(8946, 'Foster Hill', 33.1230583190918, 0.57810642599825, -92.7261123657227, -1.61837596335609, 218, 4, 'PPL', 'P'),
(21247, 'Foster Hills', 34.9688911437988, 0.610322286230775, -85.1819381713867, -1.48670528432094, 218, 13, 'PPL', 'P'),
(174147, 'Foster Junction', 46.3136100769043, 0.808324984326804, -90.7038879394531, -1.58308148890343, 218, 57, 'PPL', 'P'),
(2565, 'Foster Landing', 31.7186107635498, 0.553594191982457, -87.5066680908203, -1.52727947563467, 218, 2, 'PPL', 'P'),
(81096, 'Foster Mill', 34.8558311462402, 0.608349017021081, -81.8277816772461, -1.42816420987103, 218, 48, 'PPL', 'P'),
(21248, 'Foster Mills', 34.1661109924316, 0.59631112941976, -85.3427810668945, -1.48951252242599, 218, 13, 'PPL', 'P'),
(196521, 'Foster Mobile Home Park', 48.226390838623, 0.841709306487601, -114.130561828613, -1.99195408106026, 218, 31, 'PPL', 'P'),
(181660, 'Foster Park', 34.3527793884277, 0.599569107539308, -119.304168701172, -2.08225055519022, 218, 6, 'PPL', 'P'),
(94292, 'Foster Place', 29.6941699981689, 0.518261035114967, -95.3516693115234, -1.66420057675892, 218, 51, 'PPL', 'P'),
(27191, 'Foster Pond (historical)', 38.3116683959961, 0.668664755442387, -90.2275009155273, -1.57476696682215, 218, 18, 'PPL', 'P'),
(211334, 'Foster Village', 21.3652801513672, 0.37289448425235, -157.927780151367, -2.75635974400711, 218, 15, 'PPL', 'P'),
(27194, 'Fosterburg', 38.9716682434082, 0.680183925842388, -90.0749969482422, -1.57210527047067, 218, 18, 'PPL', 'P'),
(148933, 'Fosterdale', 41.7075004577637, 0.727933205765018, -74.9725036621094, -1.30851703736732, 218, 40, 'PPL', 'P'),
(102067, 'Fostern Estates', 38.714168548584, 0.675689708344825, -77.4841690063477, -1.35235386733251, 218, 53, 'PPL', 'P'),
(2566, 'Fosters', 33.0947189331055, 0.577611810404795, -87.6858291625977, -1.53040642622859, 218, 2, 'PPL', 'P'),
(40978, 'Fosters', 32.5263900756836, 0.567692600608686, -93.6705627441406, -1.63485973208119, 218, 22, 'PPL', 'P'),
(130859, 'Fosters', 43.2980613708496, 0.755693730651895, -83.916389465332, -1.46461729255593, 218, 27, 'PPL', 'P'),
(40979, 'Fosters Canal', 29.5283298492432, 0.515366578484214, -89.75, -1.56643300366491, 218, 22, 'PPL', 'P'),
(127517, 'Fosters Corner', 44.497501373291, 0.776627907874627, -69.1888885498047, -1.2075739109895, 218, 26, 'PPL', 'P'),
(161767, 'Fosters Corner', 41.4744415283203, 0.723865560095059, -79.7347183227539, -1.39163336288231, 218, 45, 'PPL', 'P'),
(81097, 'Fosters Crossroads', 34.7863883972168, 0.607137012408986, -80.8413925170898, -1.41094847132032, 218, 48, 'PPL', 'P'),
(102068, 'Fosters Falls', 36.8833312988281, 0.643735570268427, -80.8525009155273, -1.41114234944768, 218, 53, 'PPL', 'P'),
(81098, 'Fosters Grove', 35.0627784729004, 0.611960929249501, -81.897216796875, -1.42937608132507, 218, 48, 'PPL', 'P'),
(2567, 'Fosters Mill', 34.767219543457, 0.606802452797045, -87.4180603027344, -1.52573297798967, 218, 2, 'PPL', 'P'),
(161768, 'Fosters Mills', 40.9049987792969, 0.713926909222992, -79.6341705322266, -1.389878472882, 218, 45, 'PPL', 'P'),
(29827, 'Fosters Ridge', 38.232780456543, 0.667287901158816, -86.6624984741211, -1.51254593637798, 218, 19, 'PPL', 'P'),
(70833, 'Fostertown', 39.9427795410156, 0.697133015388952, -74.8177795410156, -1.30581659202197, 218, 37, 'PPL', 'P'),
(148935, 'Fostertown', 41.5533294677734, 0.725242414378629, -74.0458297729492, -1.29234352690921, 218, 40, 'PPL', 'P'),
(87087, 'Fosterville', 35.6549987792969, 0.622297123493289, -86.4030609130859, -1.50801789673457, 218, 50, 'PPL', 'P'),
(94293, 'Fosterville', 32.0105590820313, 0.558689651385619, -95.6144409179688, -1.66878680647214, 218, 51, 'PPL', 'P'),
(109259, 'Fosterville', 38.0919418334961, 0.664829803472673, -81.6041717529297, -1.42426148045158, 218, 58, 'PPL', 'P'),
(148934, 'Fosterville', 42.9580612182617, 0.749759608531953, -76.6733322143555, -1.33820209561594, 218, 40, 'PPL', 'P'),
(155312, 'Fosterville', 41.0769386291504, 0.71692782571832, -80.6758270263672, -1.40805880837953, 218, 41, 'PPL', 'P'),
(2568, 'Fostoria', 32.0863914489746, 0.560013175868361, -86.8300018310547, -1.51546942146461, 218, 2, 'PPL', 'P'),
(32468, 'Fostoria', 39.4397201538086, 0.688352972749124, -96.5074996948242, -1.68437362254211, 218, 20, 'PPL', 'P'),
(94294, 'Fostoria', 30.3261108398438, 0.529290483480016, -95.1661071777344, -1.66096190655727, 218, 51, 'PPL', 'P'),
(115609, 'Fostoria', 43.2422218322754, 0.754719146850981, -95.1552810668945, -1.66077295527793, 218, 16, 'PPL', 'P'),
(130860, 'Fostoria', 43.2533302307129, 0.754913024978338, -83.371940612793, -1.45511486747042, 218, 27, 'PPL', 'P'),
(155313, 'Fostoria', 41.1569404602051, 0.718324121077849, -83.4169387817383, -1.45590023367588, 218, 41, 'PPL', 'P'),
(161769, 'Fostoria', 40.6183280944824, 0.708923561904033, -78.3208312988281, -1.36695637906358, 218, 45, 'PPL', 'P'),
(130861, 'Fouch', 44.8338890075684, 0.782498979655761, -85.7211074829102, -1.49611556403273, 218, 27, 'PPL', 'P'),
(21249, 'Fouche', 34.3622207641602, 0.599733890631757, -85.3119430541992, -1.48897429756968, 218, 13, 'PPL', 'P'),
(8948, 'Fouke', 33.2611083984375, 0.580515854415472, -93.8852767944336, -1.63860719920909, 218, 4, 'PPL', 'P'),
(59955, 'Fouke', 32.0288887023926, 0.559009563611565, -89.1161117553711, -1.55536956670645, 218, 30, 'PPL', 'P'),
(94295, 'Fouke', 32.6277809143066, 0.569462204574017, -95.2738876342773, -1.66284303039325, 218, 51, 'PPL', 'P'),
(145248, 'Foul Rift', 40.8022193908691, 0.712133070491742, -75.0980606079102, -1.31070841947029, 218, 37, 'PPL', 'P'),
(40981, 'Foules', 31.8222198486328, 0.555402511652134, -91.5950012207031, -1.59863434966949, 218, 22, 'PPL', 'P'),
(13787, 'Foulk Woods', 39.8125, 0.694859208450242, -75.5208282470703, -1.31808710674451, 218, 10, 'PPL', 'P'),
(196522, 'Foundation (historical)', 46.2594413757324, 0.807379562139826, -104.960563659668, -1.83190742061032, 218, 31, 'PPL', 'P'),
(102069, 'Foundation Park', 36.8152809143066, 0.642547867001279, -76.248893737793, -1.33079424672777, 218, 53, 'PPL', 'P'),
(143836, 'Foundry', 43.2516708374023, 0.754884063101484, -70.8552780151367, -1.23665789378009, 218, 36, 'PPL', 'P'),
(87088, 'Foundry Hill', 36.4097213745117, 0.635469517718985, -88.3550033569336, -1.54208571918913, 218, 50, 'PPL', 'P'),
(124875, 'Foundry Village', 42.6736106872559, 0.744795010206855, -72.7188873291016, -1.26918401227961, 218, 23, 'PPL', 'P'),
(161770, 'Foundryville', 41.0783309936523, 0.716952127063267, -76.2358322143555, -1.33056628013846, 218, 45, 'PPL', 'P'),
(161780, 'Foundryville (historical)', 40.9916687011719, 0.715439584722157, -75.8824996948242, -1.32439946431828, 218, 45, 'PPL', 'P'),
(2573, 'Fountain', 31.5944404602051, 0.551427011355891, -87.4088897705078, -1.52557292200815, 218, 2, 'PPL', 'P'),
(16107, 'Fountain', 30.478609085083, 0.531952079962955, -85.4197235107422, -1.49085542140566, 218, 12, 'PPL', 'P'),
(27195, 'Fountain', 38.3624992370605, 0.669551920980519, -90.2827835083008, -1.57573183008509, 218, 18, 'PPL', 'P'),
(64844, 'Fountain', 35.6738891601563, 0.622626822836241, -77.6402816772461, -1.35507854744377, 218, 33, 'PPL', 'P'),
(94296, 'Fountain', 30.6722202301025, 0.535331231912102, -96.4836120605469, -1.68395670467345, 218, 51, 'PPL', 'P'),
(122634, 'Fountain', 40.2222213745117, 0.702010195451269, -87.3352813720703, -1.5242882130983, 218, 19, 'PPL', 'P'),
(130862, 'Fountain', 44.0466690063477, 0.768759398696906, -86.1786117553711, -1.50410051992912, 218, 27, 'PPL', 'P'),
(135437, 'Fountain', 43.7400016784668, 0.763407044117092, -92.1361083984375, -1.60807845152713, 218, 28, 'PPL', 'P'),
(161772, 'Fountain', 40.6552810668945, 0.709568512941023, -76.4469375610352, -1.33425076350659, 218, 45, 'PPL', 'P'),
(186725, 'Fountain', 38.6822204589844, 0.675132108991589, -104.70027923584, -1.82736460042286, 218, 7, 'PPL', 'P'),
(29828, 'Fountain City', 39.9555587768555, 0.697356055130246, -84.9175033569336, -1.48209002615183, 218, 19, 'PPL', 'P'),
(87089, 'Fountain City', 36.0319404602051, 0.628875996913139, -83.9375, -1.46498574089274, 218, 50, 'PPL', 'P'),
(174149, 'Fountain City', 44.1319389343262, 0.770247639693069, -91.7186126708984, -1.60079177646857, 218, 57, 'PPL', 'P'),
(119671, 'Fountain Creek', 40.5161094665527, 0.707139510289789, -87.8108291625977, -1.53258808779358, 218, 18, 'PPL', 'P'),
(47168, 'Fountain Dale', 39.4338912963867, 0.688251239995483, -77.5122222900391, -1.35284348949892, 218, 25, 'PPL', 'P'),
(78292, 'Fountain Dale', 39.7402801513672, 0.693598734306308, -77.4336090087891, -1.35147142890531, 218, 45, 'PPL', 'P'),
(178214, 'Fountain East', 33.4102783203125, 0.583119360697134, -111.699440002441, -1.94952300067647, 218, 5, 'PPL', 'P'),
(54822, 'Fountain Farm', 37.9777793884277, 0.662837292924102, -90.7186126708984, -1.58333848394862, 218, 29, 'PPL', 'P'),
(64845, 'Fountain Fork', 35.9069404602051, 0.626694335348147, -77.3716735839844, -1.35039045181885, 218, 33, 'PPL', 'P'),
(27197, 'Fountain Gap', 38.3875007629395, 0.669988279925129, -90.254997253418, -1.57524686845058, 218, 18, 'PPL', 'P'),
(47169, 'Fountain Glen', 39.5338897705078, 0.689996542615867, -76.3066711425781, -1.33180265267453, 218, 25, 'PPL', 'P'),
(47170, 'Fountain Green', 39.5472183227539, 0.690229169737085, -76.3138885498047, -1.33192862019409, 218, 25, 'PPL', 'P'),
(119669, 'Fountain Green', 40.475830078125, 0.706436502341035, -90.9691696166992, -1.58771152761659, 218, 18, 'PPL', 'P'),
(192573, 'Fountain Green', 39.6300010681152, 0.69167400120748, -111.634437561035, -1.94838849405209, 218, 52, 'PPL', 'P'),
(47171, 'Fountain Green Estates', 39.5713882446289, 0.690651014453754, -76.3333282470703, -1.33226790691697, 218, 25, 'PPL', 'P'),
(47172, 'Fountain Green Heights', 39.5422210693359, 0.690141951211385, -76.3199996948242, -1.33203527979575, 218, 25, 'PPL', 'P'),
(54823, 'Fountain Grove', 39.7108306884766, 0.693084744215923, -93.315559387207, -1.62866375464706, 218, 29, 'PPL', 'P'),
(87090, 'Fountain Grove', 35.5605583190918, 0.620648826515612, -85.9436111450195, -1.49999898553428, 218, 50, 'PPL', 'P'),
(47173, 'Fountain Head', 39.6691703796387, 0.692357634659304, -77.7133331298828, -1.35635353581565, 218, 25, 'PPL', 'P'),
(87091, 'Fountain Head', 36.5508308410645, 0.637932342516063, -86.495002746582, -1.50962258444939, 218, 50, 'PPL', 'P'),
(47174, 'Fountain Head Heights', 39.6738891601563, 0.692439992916014, -77.7074966430664, -1.35625166990395, 218, 25, 'PPL', 'P'),
(935, 'Fountain Heights', 35.5447196960449, 0.620372390394462, -86.9663925170898, -1.51784988800498, 218, 50, 'PPL', 'P'),
(2570, 'Fountain Heights', 33.5291709899902, 0.585194429239496, -86.8263931274414, -1.51540643770483, 218, 2, 'PPL', 'P'),
(16108, 'Fountain Heights', 27.9930591583252, 0.488571050018327, -81.956672668457, -1.43041378204382, 218, 12, 'PPL', 'P'),
(8949, 'Fountain Hill', 33.357780456543, 0.582203100124092, -91.8502807617188, -1.6030898181732, 218, 4, 'PPL', 'P'),
(64852, 'Fountain Hill', 35.0774993896484, 0.612217857715667, -80.2886123657227, -1.40130063763929, 218, 33, 'PPL', 'P'),
(161773, 'Fountain Hill', 40.601390838623, 0.708627951023034, -75.3955612182617, -1.31590078464761, 218, 45, 'PPL', 'P'),
(21250, 'Fountain Hill (historical)', 33.6127815246582, 0.586653708358805, -83.9927825927734, -1.46595060415568, 218, 13, 'PPL', 'P'),
(178216, 'Fountain Hills', 33.6333312988281, 0.587012369578612, -111.741668701172, -1.95026003050815, 218, 5, 'PPL', 'P'),
(161775, 'Fountain House Corners', 41.6997184753418, 0.727797384549424, -80.1138916015625, -1.3982511850331, 218, 45, 'PPL', 'P'),
(81099, 'Fountain Inn', 34.6888885498047, 0.605435319051453, -82.1958312988281, -1.43458788757836, 218, 48, 'PPL', 'P'),
(8950, 'Fountain Lake', 34.5727806091309, 0.603408853198984, -92.9875030517578, -1.62293809146145, 218, 4, 'PPL', 'P'),
(81100, 'Fountain Lake', 33.4172210693359, 0.583240534526732, -80.3266677856445, -1.40196483001516, 218, 48, 'PPL', 'P'),
(21251, 'Fountain Lake Mobile Home Park', 34.1205596923828, 0.595516109255344, -84.4824981689453, -1.47449775335818, 218, 13, 'PPL', 'P'),
(47175, 'Fountain Mills', 39.3413887023926, 0.68663676516365, -77.2683334350586, -1.34858682597059, 218, 25, 'PPL', 'P'),
(54824, 'Fountain N'' Lakes', 38.9688911437988, 0.680135456310549, -90.8499984741211, -1.58563159880524, 218, 29, 'PPL', 'P'),
(178218, 'Fountain of the Sun', 33.4019393920898, 0.582973818943561, -111.654167175293, -1.94873284078104, 218, 5, 'PPL', 'P'),
(122637, 'Fountain Park', 41.563060760498, 0.725412257477149, -84.9141693115234, -1.48203183608201, 218, 19, 'PPL', 'P'),
(130864, 'Fountain Park', 41.8313903808594, 0.730095492833081, -84.529167175293, -1.47531228117758, 218, 27, 'PPL', 'P'),
(155315, 'Fountain Park', 40.1650009155273, 0.701011510042489, -83.5541687011719, -1.45829534760224, 218, 41, 'PPL', 'P'),
(181661, 'Fountain Place', 38.8511085510254, 0.678079762265116, -119.933059692383, -2.09322677362298, 218, 6, 'PPL', 'P'),
(130863, 'Fountain Point', 44.9694404602051, 0.784864798810133, -85.7052764892578, -1.49583926106964, 218, 27, 'PPL', 'P'),
(47176, 'Fountain Rock', 39.4747200012207, 0.688963835324161, -77.3722229003906, -1.35040003919877, 218, 25, 'PPL', 'P'),
(35968, 'Fountain Run', 36.7152786254883, 0.640802497801869, -85.9658279418945, -1.500386741789, 218, 21, 'PPL', 'P'),
(109260, 'Fountain Spring', 39.146110534668, 0.683228518179594, -81.5449981689453, -1.42322870658084, 218, 58, 'PPL', 'P'),
(169381, 'Fountain Spring', 41.8616714477539, 0.730623997151407, -71.5316696166992, -1.24846315426019, 218, 47, 'PPL', 'P'),
(161776, 'Fountain Springs', 40.771110534668, 0.711590118524502, -76.3249969482422, -1.33212249832145, 218, 45, 'PPL', 'P'),
(181662, 'Fountain Springs', 35.8911094665527, 0.626418032385051, -118.91471862793, -2.07545336914001, 218, 6, 'PPL', 'P'),
(47179, 'Fountain Valley', 39.5969390869141, 0.691096960778288, -77.0466690063477, -1.34471805185503, 218, 25, 'PPL', 'P'),
(174152, 'Fountain Valley', 44.0908317565918, 0.769530184095402, -88.9861068725586, -1.5531005534577, 218, 57, 'PPL', 'P'),
(181663, 'Fountain Valley', 33.709171295166, 0.588336027219408, -117.952781677246, -2.05866440215398, 218, 6, 'PPL', 'P'),
(47180, 'Fountain View', 39.246940612793, 0.684988335027918, -77.2577819824219, -1.34840266838121, 218, 25, 'PPL', 'P'),
(178217, 'Fountain View', 33.607780456543, 0.586566423254078, -111.731109619141, -1.95007573976071, 218, 5, 'PPL', 'P'),
(16109, 'Fountainbleau', 25.7724990844727, 0.449814965491272, -80.3480606079102, -1.40233820519999, 218, 12, 'PPL', 'P'),
(54825, 'Fountainbleau', 39.9741706848145, 0.697680894204209, -94.7069396972656, -1.65294792220501, 218, 29, 'PPL', 'P'),
(87094, 'Fountaincrest', 36.0741691589355, 0.629613026744819, -83.9416732788086, -1.46505857834855, 218, 50, 'PPL', 'P'),
(47181, 'Fountaindale South', 39.4291687011719, 0.688168815159745, -77.5152816772461, -1.35289688587878, 218, 25, 'PPL', 'P'),
(59956, 'Fountainebleau', 30.4019393920898, 0.530613941383731, -88.7197189331055, -1.54845120682664, 218, 30, 'PPL', 'P'),
(2571, 'Fountainrun (historical)', 33.4991683959961, 0.584670785190159, -86.3188934326172, -1.50654889707728, 218, 2, 'PPL', 'P'),
(29829, 'Fountaintown', 39.6947212219238, 0.692803580983838, -85.7830581665039, -1.4971968074353, 218, 19, 'PPL', 'P'),
(21252, 'Fountainville', 32.2833290100098, 0.563450384729272, -84.1572189331055, -1.4688205597044, 218, 13, 'PPL', 'P'),
(161777, 'Fountainville', 40.3411102294922, 0.704085197414604, -75.1508331298828, -1.31162947373329, 218, 45, 'PPL', 'P'),
(94297, 'Four A''s Colonia', 27.8020000457764, 0.485236439438412, -98.2519989013672, -1.71482087749471, 218, 51, 'PPL', 'P'),
(181665, 'Four Acres', 39.0086097717285, 0.680828677142296, -120.787498474121, -2.10813954362104, 218, 6, 'PPL', 'P'),
(198304, 'Four Bears Village (historical)', 47.982780456543, 0.837457503228263, -102.578056335449, -1.79032482334982, 218, 34, 'PPL', 'P'),
(196523, 'Four Buttes', 48.8097190856934, 0.851890305018865, -105.605827331543, -1.84316939622804, 218, 31, 'PPL', 'P'),
(200846, 'Four Cabin Corner', 44.9647216796875, 0.784782440553422, -123.766387939453, -2.16013097284406, 218, 43, 'PPL', 'P'),
(191494, 'Four Corner Windmill', 31.2919406890869, 0.54614739436335, -101.59944152832, -1.77324477285665, 218, 51, 'PPL', 'P'),
(16110, 'Four Corners', 27.9158306121826, 0.487223157611611, -82.7297210693359, -1.44390602191644, 218, 12, 'PPL', 'P'),
(27198, 'Four Corners', 38.7183303833008, 0.675762346063557, -90.0755615234375, -1.5721151241667, 218, 18, 'PPL', 'P'),
(29830, 'Four Corners', 38.9541702270508, 0.679878527844383, -85.7402801513672, -1.4964501902237, 218, 19, 'PPL', 'P'),
(32470, 'Four Corners', 38.7825012207031, 0.67688233845999, -95.6861114501953, -1.67003769323615, 218, 20, 'PPL', 'P'),
(35970, 'Four Corners', 37.7488899230957, 0.658842418130929, -86.0880584716797, -1.50252006698021, 218, 21, 'PPL', 'P'),
(40982, 'Four Corners', 29.8488903045654, 0.52096141388128, -91.6397171020508, -1.59941478902694, 218, 22, 'PPL', 'P'),
(47183, 'Four Corners', 39.0202789306641, 0.68103234238666, -77.0130615234375, -1.34413149062494, 218, 25, 'PPL', 'P'),
(64848, 'Four Corners', 36.0361099243164, 0.628948767789926, -80.6083297729492, -1.40688075907134, 218, 33, 'PPL', 'P'),
(94301, 'Four Corners', 30.2931594848633, 0.528715373842614, -95.3842010498047, -1.66476836270332, 218, 51, 'PPL', 'P'),
(102071, 'Four Corners', 38.9302787780762, 0.679461543396704, -77.2713928222656, -1.34864022235045, 218, 53, 'PPL', 'P'),
(113453, 'Four Corners', 41.4494400024414, 0.723429201150449, -72.1952819824219, -1.260045374999, 218, 8, 'PPL', 'P'),
(124878, 'Four Corners', 42.1338882446289, 0.735375076536108, -71.1105575561523, -1.24111336228379, 218, 23, 'PPL', 'P'),
(127516, 'Four Corners', 43.3544387817383, 0.756677702095652, -70.5058288574219, -1.23055885540964, 218, 26, 'PPL', 'P'),
(135441, 'Four Corners', 46.853328704834, 0.817744851418523, -92.2799987792969, -1.61058981243508, 218, 28, 'PPL', 'P'),
(143837, 'Four Corners', 43.0633316040039, 0.751596923367999, -70.9697189331055, -1.23865526459765, 218, 36, 'PPL', 'P'),
(145249, 'Four Corners', 41.2880592346191, 0.720612575402554, -74.7630615234375, -1.30486158245507, 218, 37, 'PPL', 'P'),
(155316, 'Four Corners', 40.5074996948242, 0.706989241425281, -82.3811111450195, -1.43782163093199, 218, 41, 'PPL', 'P'),
(161778, 'Four Corners', 41.5294418334961, 0.724825496509978, -78.9336090087891, -1.37765136768523, 218, 45, 'PPL', 'P'),
(174156, 'Four Corners', 44.0750007629395, 0.769253881132306, -90.9136123657227, -1.58674187066369, 218, 57, 'PPL', 'P'),
(193571, 'Four Corners', 40.9383316040039, 0.71450867676312, -121.605560302734, -2.12241741601523, 218, 6, 'PPL', 'P'),
(194946, 'Four Corners', 42.105281829834, 0.734875800410746, -116.606941223145, -2.03517505502338, 218, 17, 'PPL', 'P'),
(196524, 'Four Corners', 45.6297187805176, 0.796388829479124, -111.185279846191, -1.94054921306733, 218, 31, 'PPL', 'P'),
(200848, 'Four Corners', 44.9280586242676, 0.784142549522503, -122.982498168945, -2.14644951537599, 218, 43, 'PPL', 'P'),
(207453, 'Four Corners', 46.9199981689453, 0.818908453077806, -122.567779541016, -2.13921130984927, 218, 56, 'PPL', 'P'),
(87096, 'Four Corners (historical)', 36.0555610656738, 0.629288254249884, -86.5852813720703, -1.51119824370834, 218, 50, 'PPL', 'P'),
(209464, 'Four Corners (historical)', 44.0774993896484, 0.769297490395156, -104.13777923584, -1.81754712338039, 218, 59, 'PPL', 'P'),
(186726, 'Four Corners Crossing', 38.026668548584, 0.663690569737364, -102.777496337891, -1.79380570805261, 218, 7, 'PPL', 'P'),
(47184, 'Four County Farm', 39.3555603027344, 0.686884106249891, -77.1719436645508, -1.34690450710999, 218, 25, 'PPL', 'P'),
(8952, 'Four Forks', 35.0622215270996, 0.611951208711522, -91.2388916015625, -1.59241906431747, 218, 4, 'PPL', 'P'),
(40984, 'Four Forks', 32.3199996948242, 0.564090408918245, -91.8694381713867, -1.60342417804806, 218, 22, 'PPL', 'P'),
(59957, 'Four Forks', 31.628059387207, 0.552013772323063, -91.1275024414063, -1.59047495672171, 218, 30, 'PPL', 'P'),
(102070, 'Four Forks', 37.5819396972656, 0.655928587003246, -78.8447189331055, -1.3760999431922, 218, 53, 'PPL', 'P'),
(188565, 'Four Forks', 32.3902816772461, 0.565317060916336, -104.359718322754, -1.82142069118591, 218, 38, 'PPL', 'P'),
(8953, 'Four Groves (historical)', 34.0069389343262, 0.593533052928643, -91.6861114501953, -1.60022452315638, 218, 4, 'PPL', 'P'),
(8954, 'Four Gums', 35.0138893127441, 0.61110765243624, -91.0130615234375, -1.58847758590415, 218, 4, 'PPL', 'P'),
(81101, 'Four Holes', 33.2783317565918, 0.580816458723515, -80.4333267211914, -1.40382637961713, 218, 48, 'PPL', 'P'),
(135443, 'Four Jays Mobile Home Park', 45.1505584716797, 0.78802590444503, -94.6827774047852, -1.65252621064639, 218, 28, 'PPL', 'P'),
(207454, 'Four Lakes', 47.5613899230957, 0.830102850982873, -117.593063354492, -2.05238613304218, 218, 56, 'PPL', 'P'),
(47185, 'Four Locks', 39.6155586242676, 0.691421933010304, -77.9475021362305, -1.36044055598254, 218, 25, 'PPL', 'P'),
(2572, 'Four Mile', 33.7652816772461, 0.589315338131258, -85.7708282470703, -1.49698335507393, 218, 2, 'PPL', 'P'),
(59958, 'Four Mile', 33.2872200012207, 0.580971587857012, -90.4722213745117, -1.57903814457842, 218, 30, 'PPL', 'P'),
(70834, 'Four Mile', 39.8913917541504, 0.696236129312841, -74.5813903808594, -1.30169082286122, 218, 37, 'PPL', 'P'),
(72586, 'Four Mile', 38.9833297729492, 0.680387457928697, -82.642219543457, -1.44237883218933, 218, 41, 'PPL', 'P'),
(109261, 'Four Mile', 39.5869407653809, 0.69092245714786, -80.6191711425781, -1.40706997666679, 218, 58, 'PPL', 'P'),
(148936, 'Four Mile', 42.019718170166, 0.733382432829484, -78.4652786254883, -1.3694774605095, 218, 40, 'PPL', 'P'),
(70835, 'Four Mile Circle', 39.8980598449707, 0.696352509452477, -74.595832824707, -1.3019428910584, 218, 37, 'PPL', 'P'),
(75867, 'Four Mile Crossing', 34.6861114501953, 0.605386849519613, -98.4449996948242, -1.7181893767995, 218, 42, 'PPL', 'P'),
(16111, 'Four Mile Village', 30.3722190856934, 0.530095224182411, -86.3219375610352, -1.50660202714103, 218, 12, 'PPL', 'P'),
(21253, 'Four Oaks', 33.9411087036133, 0.592384098655356, -84.2758331298828, -1.47089076797777, 218, 13, 'PPL', 'P'),
(35971, 'Four Oaks', 38.6338882446289, 0.674288552716307, -84.3180618286133, -1.47162779780945, 218, 21, 'PPL', 'P'),
(64849, 'Four Oaks', 35.4447212219238, 0.618627087774078, -78.4272232055664, -1.36881326813364, 218, 33, 'PPL', 'P'),
(181669, 'Four Pines', 39.6100006103516, 0.691324927367598, -123.011672973633, -2.14695871177642, 218, 6, 'PPL', 'P'),
(2574, 'Four Point', 31.3011093139648, 0.54630741705535, -88.3644409179688, -1.54225043570256, 218, 2, 'PPL', 'P'),
(16112, 'Four Points', 30.3999996185303, 0.530580085948373, -84.2808303833008, -1.47097798650347, 218, 12, 'PPL', 'P'),
(21257, 'Four Points', 33.2933311462402, 0.58107824745867, -82.7444381713867, -1.44416288380357, 218, 13, 'PPL', 'P'),
(54826, 'Four Points', 37.9527816772461, 0.66240100055852, -91.0955581665039, -1.5899174239475, 218, 29, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(59959, 'Four Points', 31.2511100769043, 0.545434765745158, -89.1861114501953, -1.55659129185652, 218, 30, 'PPL', 'P'),
(87099, 'Four Points', 35.9761085510254, 0.62790154627028, -89.3908309936523, -1.56016432193303, 218, 50, 'PPL', 'P'),
(94302, 'Four Points', 30.4036102294922, 0.530643102997667, -97.8533325195313, -1.70786283651466, 218, 51, 'PPL', 'P'),
(155317, 'Four Points', 41.5605583190918, 0.725368581635272, -81.5758285522461, -1.42376679827909, 218, 41, 'PPL', 'P'),
(161779, 'Four Points', 41.2863883972168, 0.720583413788618, -78.6180572509766, -1.37214395055094, 218, 45, 'PPL', 'P'),
(181670, 'Four Points', 34.5424995422363, 0.602880348880658, -118.029167175293, -2.05999758059568, 218, 6, 'PPL', 'P'),
(188566, 'Four Points', 32.2649993896484, 0.563130472503326, -106.78556060791, -1.86375962619599, 218, 38, 'PPL', 'P'),
(94303, 'Four Points Colonia', 27.7959995269775, 0.485131710628544, -99.4550018310547, -1.73581723952889, 218, 51, 'PPL', 'P'),
(122638, 'Four Presidents Corners', 41.0080604553223, 0.715725674802259, -84.853889465332, -1.48097975429337, 218, 19, 'PPL', 'P'),
(196525, 'Four Range', 46.5830612182617, 0.813027793916748, -111.926940917969, -1.95349364070372, 218, 31, 'PPL', 'P'),
(13788, 'Four Seasons', 39.6277809143066, 0.69163525221362, -75.7624969482422, -1.32230502127898, 218, 10, 'PPL', 'P'),
(16113, 'Four Seasons', 26.267219543457, 0.458449466377527, -81.7647171020508, -1.4270635253925, 218, 12, 'PPL', 'P'),
(47186, 'Four Seasons', 39.4894409179688, 0.689220763790327, -76.9647216796875, -1.34328780119161, 218, 25, 'PPL', 'P'),
(54827, 'Four Seasons', 38.1980590820313, 0.666681898852768, -92.7108306884766, -1.61810924777292, 218, 29, 'PPL', 'P'),
(64850, 'Four Seasons', 36.0563888549805, 0.629302701898797, -80.1555633544922, -1.3989784943268, 218, 33, 'PPL', 'P'),
(81102, 'Four Seasons', 34.2030601501465, 0.596956013877722, -80.7236099243164, -1.40889277727489, 218, 48, 'PPL', 'P'),
(102072, 'Four Seasons', 38.0838890075684, 0.664689255146144, -78.4852828979492, -1.36982660092841, 218, 53, 'PPL', 'P'),
(94304, 'Four Seasons Colonia', 26.8740005493164, 0.469039792768336, -99.2929992675781, -1.73298976139956, 218, 51, 'PPL', 'P'),
(47187, 'Four Seasons Estates', 39.0616683959961, 0.681754724832344, -76.6947174072266, -1.33857533764271, 218, 25, 'PPL', 'P'),
(13789, 'Four Seasons Park', 39.6222190856934, 0.691538179991886, -75.7502822875977, -1.32209183523372, 218, 10, 'PPL', 'P'),
(196526, 'Four Seasons Trailer Court', 47.7191696166992, 0.832856626129042, -104.153610229492, -1.81782342634349, 218, 31, 'PPL', 'P'),
(204011, 'Four Seasons Village Condominium', 40.7597198486328, 0.711391313549127, -111.936111450195, -1.95365369668523, 218, 52, 'PPL', 'P'),
(109262, 'Four States', 39.4797210693359, 0.689051120428889, -80.3099975585938, -1.40167387966607, 218, 58, 'PPL', 'P'),
(94305, 'Four Sure All Right Colonia', 26.2119998931885, 0.457485701668541, -98.3769989013672, -1.7170025390597, 218, 51, 'PPL', 'P'),
(135444, 'Four Town', 48.2811088562012, 0.842664316054504, -95.3352813720703, -1.66391455325784, 218, 28, 'PPL', 'P'),
(130865, 'Four Towns', 42.6177787780762, 0.743820559563995, -83.4136123657227, -1.45584217676412, 218, 27, 'PPL', 'P'),
(191495, 'Four Way', 35.6902809143066, 0.622912912916343, -101.964721679688, -1.77962011419019, 218, 51, 'PPL', 'P'),
(188567, 'Four Wells', 32.3730583190918, 0.565016456608293, -104.716667175293, -1.82765062392393, 218, 38, 'PPL', 'P'),
(21258, 'Four Winds', 33.8638916015625, 0.591036405985721, -84.1508331298828, -1.46870910641278, 218, 13, 'PPL', 'P'),
(47188, 'Four Winds', 39.3955612182617, 0.687582253929655, -76.6319427490234, -1.33747971317025, 218, 25, 'PPL', 'P'),
(8955, 'Fourche', 34.9938888549805, 0.610758578596358, -92.6208267211914, -1.61653838220393, 218, 4, 'PPL', 'P'),
(8956, 'Fourche (historical)', 34.7144393920898, 0.605881265375987, -92.2350006103516, -1.60980444622961, 218, 4, 'PPL', 'P'),
(54828, 'Fourche a Renault (historical)', 38.0133285522461, 0.663457742879064, -90.8775024414063, -1.58611163359172, 218, 29, 'PPL', 'P'),
(8958, 'Fourche Junction', 34.9563903808594, 0.610104106758471, -93.1569366455078, -1.62589526553587, 218, 4, 'PPL', 'P'),
(8960, 'Fourche Valley', 34.9180603027344, 0.609435120692643, -93.5361099243164, -1.63251308768667, 218, 4, 'PPL', 'P'),
(196527, 'Fourchette (historical)', 47.7333297729492, 0.833103767478201, -107.969436645508, -1.88442216098753, 218, 31, 'PPL', 'P'),
(155318, 'Fourmans Corners', 40.0200004577637, 0.698480774637614, -84.5177764892578, -1.4751134762022, 218, 41, 'PPL', 'P'),
(2576, 'Fourmile', 33.2486114501953, 0.580297741522195, -86.5530624389648, -1.51063591724417, 218, 2, 'PPL', 'P'),
(35972, 'Fourmile', 36.7933311462402, 0.642164771278471, -83.741943359375, -1.46157263363969, 218, 21, 'PPL', 'P'),
(200849, 'Fourmile', 43.0083312988281, 0.75063698695308, -124.413887023926, -2.17143196377175, 218, 43, 'PPL', 'P'),
(202141, 'Fourmile', 43.732780456543, 0.763281010018504, -103.675003051758, -1.80947015526834, 218, 49, 'PPL', 'P'),
(87100, 'Fourmile Bridge (historical)', 35.5827789306641, 0.621036649349355, -84.2291717529297, -1.47007637331643, 218, 50, 'PPL', 'P'),
(8961, 'Fourmile Corner', 34.978328704834, 0.610487002744197, -91.563606262207, -1.59808640427521, 218, 4, 'PPL', 'P'),
(54829, 'Fourmile Corner', 38.5111083984375, 0.672145640145175, -91.0461120605469, -1.58905442659626, 218, 29, 'PPL', 'P'),
(130866, 'Fourmile Corner', 46.4191703796387, 0.810167359168921, -85.5105590820313, -1.49244080120259, 218, 27, 'PPL', 'P'),
(191496, 'Fourmile Crossing', 30.2055606842041, 0.527186486350313, -103.180282592773, -1.80083565438209, 218, 51, 'PPL', 'P'),
(102073, 'Fourmile Fork', 38.2552795410156, 0.667680584261548, -77.4980621337891, -1.35259634814976, 218, 53, 'PPL', 'P'),
(8962, 'Fourmile Hill', 35.2905616760254, 0.615936496124772, -91.7702789306641, -1.60169352281367, 218, 4, 'PPL', 'P'),
(155319, 'Fourmile House Corner', 41.3727798461914, 0.722091229018793, -83.1766662597656, -1.45170668706539, 218, 41, 'PPL', 'P'),
(130867, 'Fourmile Lake', 42.3250007629395, 0.738710619222405, -83.966667175293, -1.46549480413511, 218, 27, 'PPL', 'P'),
(155320, 'Fourmile Run', 41.1194381713867, 0.717669582660935, -80.7324981689453, -1.40904790640839, 218, 41, 'PPL', 'P'),
(127518, 'Fournier', 47.3466682434082, 0.826355250696913, -68.2622222900391, -1.19140053368945, 218, 26, 'PPL', 'P'),
(47189, 'Fourpoints', 39.6716690063477, 0.692401243922154, -77.2994384765625, -1.34912971135881, 218, 25, 'PPL', 'P'),
(35973, 'Fourseam', 37.2205581665039, 0.649621289435557, -83.1786117553711, -1.45174064236929, 218, 21, 'PPL', 'P'),
(102074, 'Foursquare', 36.964168548584, 0.645146446434924, -76.6922225952148, -1.33853179495889, 218, 53, 'PPL', 'P'),
(109263, 'Fourteen (historical)', 38.0666694641113, 0.664388717417128, -82.1894378662109, -1.43447630112868, 218, 58, 'PPL', 'P'),
(54830, 'Fourteen Bend (historical)', 36.2802810668945, 0.633210358166271, -89.5888900756836, -1.56362110502795, 218, 29, 'PPL', 'P'),
(124879, 'Fourth Cliff', 42.1599998474121, 0.735830809977648, -70.7050018310547, -1.23403507958052, 218, 23, 'PPL', 'P'),
(94307, 'Fourth Crossing', 29.8425006866455, 0.520849894010633, -98.1675033569336, -1.71334615204108, 218, 51, 'PPL', 'P'),
(181671, 'Fourth Crossing', 38.1313896179199, 0.665518297193485, -120.633613586426, -2.10545374566169, 218, 6, 'PPL', 'P'),
(94308, 'Fourth Hidalgo Colonia', 27.9729995727539, 0.488220944203523, -97.4089965820313, -1.70010771142035, 218, 51, 'PPL', 'P'),
(148937, 'Fourth Lake', 43.3569412231445, 0.75672137793753, -73.8302764892578, -1.28858141239531, 218, 40, 'PPL', 'P'),
(94309, 'Fourth Site Colonia', 26.4090003967285, 0.460924009083401, -98.9759979248047, -1.72745704423492, 218, 51, 'PPL', 'P'),
(87101, 'Fourville', 36.3919410705566, 0.635159192872963, -82.3974990844727, -1.43810765443306, 218, 50, 'PPL', 'P'),
(64854, 'Fourway', 35.4408302307129, 0.618559177166282, -77.5788879394531, -1.35400702457918, 218, 33, 'PPL', 'P'),
(102076, 'Fourway', 37.1327781677246, 0.648089239439462, -81.4936065673828, -1.4223317539257, 218, 53, 'PPL', 'P'),
(194947, 'Fourway Junction', 45.3327789306641, 0.791206251418802, -115.36222076416, -2.01345058474716, 218, 17, 'PPL', 'P'),
(161781, 'Fousetown', 40.4516716003418, 0.706014857361448, -77.9180603027344, -1.3599266990502, 218, 45, 'PPL', 'P'),
(64855, 'Foushee', 36.292781829834, 0.633428537638575, -79.6538925170898, -1.39022268645289, 218, 33, 'PPL', 'P'),
(87102, 'Foust', 35.0161094665527, 0.6111464014301, -85.2888870239258, -1.48857189392897, 218, 50, 'PPL', 'P'),
(78293, 'Foustown', 39.9949989318848, 0.698044415693004, -76.7719421386719, -1.3399231634704, 218, 45, 'PPL', 'P'),
(161782, 'Foustwell', 40.2180595397949, 0.701937557732537, -78.8997192382813, -1.37705987960712, 218, 45, 'PPL', 'P'),
(21259, 'Fouts Corner', 33.9680595397949, 0.592854479482891, -84.2583312988281, -1.47058530340074, 218, 13, 'PPL', 'P'),
(21260, 'Fouts Mill', 33.6494407653809, 0.587293532810697, -84.7761077880859, -1.47962220792771, 218, 13, 'PPL', 'P'),
(181672, 'Fouts Springs', 39.353328704834, 0.686845157518949, -122.663887023926, -2.14088870186185, 218, 6, 'PPL', 'P'),
(47191, 'Fowblesburg', 39.5438919067383, 0.690171112825322, -76.8377838134766, -1.34107231748077, 218, 25, 'PPL', 'P'),
(204012, 'Fowers', 41.1627807617188, 0.718426053568572, -112.113059997559, -1.95674203144334, 218, 52, 'PPL', 'P'),
(54832, 'Fowkes', 39.4830589294434, 0.689109377077734, -92.0713882446289, -1.60694887175078, 218, 29, 'PPL', 'P'),
(2577, 'Fowl River', 30.4622192382813, 0.531666023172367, -88.1688919067383, -1.53883746160756, 218, 2, 'PPL', 'P'),
(2579, 'Fowler', 32.728889465332, 0.571226881691331, -88.0619430541992, -1.53697085199953, 218, 2, 'PPL', 'P'),
(8964, 'Fowler', 35.1483306884766, 0.613454097093681, -93.0199966430664, -1.62350521161558, 218, 4, 'PPL', 'P'),
(40986, 'Fowler', 32.6566696166992, 0.569966407547396, -92.0327835083008, -1.60627509199499, 218, 22, 'PPL', 'P'),
(54831, 'Fowler', 37.2333297729492, 0.649844196018797, -92.2163925170898, -1.60947967373468, 218, 29, 'PPL', 'P'),
(75868, 'Fowler', 35.5072212219238, 0.619717918556575, -97.0527801513672, -1.69389056185556, 218, 42, 'PPL', 'P'),
(81103, 'Fowler', 33.7024993896484, 0.588219580500745, -79.6969375610352, -1.3909739641964, 218, 48, 'PPL', 'P'),
(119672, 'Fowler', 40.0077781677246, 0.698267455434299, -91.2583312988281, -1.59275835104034, 218, 18, 'PPL', 'P'),
(122639, 'Fowler', 40.6166687011719, 0.708894600027178, -87.3208312988281, -1.52403601174307, 218, 19, 'PPL', 'P'),
(130868, 'Fowler', 43.0016708374023, 0.750520739971498, -84.7397232055664, -1.47898717716578, 218, 27, 'PPL', 'P'),
(148938, 'Fowler', 44.2786102294922, 0.772807536711881, -75.3866729736328, -1.31574565551412, 218, 40, 'PPL', 'P'),
(155321, 'Fowler', 41.3111114501953, 0.721014912464238, -80.6558303833008, -1.40770980111868, 218, 41, 'PPL', 'P'),
(178219, 'Fowler', 33.4513893127441, 0.583836882873828, -112.203056335449, -1.95831276385427, 218, 5, 'PPL', 'P'),
(181673, 'Fowler', 36.6305618286133, 0.639323910764657, -119.67749786377, -2.08876637827126, 218, 6, 'PPL', 'P'),
(186727, 'Fowler', 38.1291694641113, 0.665479548199625, -104.02278137207, -1.81554003202485, 218, 7, 'PPL', 'P'),
(187671, 'Fowler', 37.3855590820313, 0.652501098680314, -100.195281982422, -1.74873756555741, 218, 20, 'PPL', 'P'),
(196528, 'Fowler', 48.3158302307129, 0.843270318360551, -111.784172058105, -1.95100185402979, 218, 31, 'PPL', 'P'),
(2580, 'Fowler (historical)', 34.2083282470703, 0.597047959514357, -86.4263916015625, -1.50842509406524, 218, 2, 'PPL', 'P'),
(64856, 'Fowler Crossroads', 35.0308303833008, 0.611403329896266, -80.538330078125, -1.40565903392126, 218, 33, 'PPL', 'P'),
(87103, 'Fowler Grove', 36.0486106872559, 0.629166947262231, -83.1341705322266, -1.4509649967018, 218, 50, 'PPL', 'P'),
(161783, 'Fowler Heights', 40.6394386291504, 0.709292010240845, -79.1394424438477, -1.38124383883769, 218, 45, 'PPL', 'P'),
(109264, 'Fowler Knob', 38.1838912963867, 0.666434624345554, -80.8125, -1.41044420176792, 218, 58, 'PPL', 'P'),
(64857, 'Fowler Landing', 34.6819381713867, 0.6053140120638, -78.3483276367188, -1.36743628069201, 218, 33, 'PPL', 'P'),
(127519, 'Fowler Landing', 44.7780609130859, 0.781524595591928, -68.9375, -1.20318635309359, 218, 26, 'PPL', 'P'),
(193572, 'Fowler Place', 40.202220916748, 0.701661121611387, -122.559440612793, -2.13906576809569, 218, 6, 'PPL', 'P'),
(2581, 'Fowler Spring', 34.0338897705078, 0.594003433756179, -86.5872192382813, -1.51123206585418, 218, 2, 'PPL', 'P'),
(16114, 'Fowlers Bluff', 29.396390914917, 0.51306380966865, -83.0244369506836, -1.44904978440387, 218, 12, 'PPL', 'P'),
(2582, 'Fowlers Crossroads', 33.8011093139648, 0.589940648355208, -87.663330078125, -1.53001374312586, 218, 2, 'PPL', 'P'),
(64858, 'Fowlers Crossroads', 35.8925018310547, 0.626442333729998, -78.429443359375, -1.3688520171275, 218, 33, 'PPL', 'P'),
(155323, 'Fowlers Mill', 41.5275001525879, 0.724791607785106, -81.2561111450195, -1.41818667684705, 218, 41, 'PPL', 'P'),
(177222, 'Fowlerston', 40.2797203063965, 0.703013741129038, -80.5555572509766, -1.40595970480833, 218, 58, 'PPL', 'P'),
(148940, 'Fowlersville', 43.6238899230957, 0.761380511685596, -75.2744369506836, -1.31378676737431, 218, 40, 'PPL', 'P'),
(161789, 'Fowlersville', 41.0602798461914, 0.716637075106311, -76.3288879394531, -1.33219040892925, 218, 45, 'PPL', 'P'),
(94310, 'Fowlerton', 28.4652805328369, 0.49681286780185, -98.8105621337891, -1.72456964498105, 218, 51, 'PPL', 'P'),
(122640, 'Fowlerton', 40.4094390869141, 0.705277760950741, -85.5736083984375, -1.49354121936501, 218, 19, 'PPL', 'P'),
(21261, 'Fowlertown', 34.5525016784668, 0.603054919090113, -83.3211135864258, -1.45422776851131, 218, 13, 'PPL', 'P'),
(130869, 'Fowlerville', 42.6605606079102, 0.744567243354626, -84.0730590820313, -1.46735169320517, 218, 27, 'PPL', 'P'),
(148943, 'Fowlerville', 41.5561103820801, 0.725290950489496, -74.7608337402344, -1.30482270030316, 218, 40, 'PPL', 'P'),
(87104, 'Fowlkes', 35.9705581665039, 0.627804673785628, -89.3861083984375, -1.56008189709729, 218, 50, 'PPL', 'P'),
(94311, 'Fowlkes', 33.9933280944824, 0.593295498959408, -98.8341674804688, -1.72498163600169, 218, 51, 'PPL', 'P'),
(21262, 'Fowlstown', 30.8024997711182, 0.537605038850812, -84.5472183227539, -1.47562733313453, 218, 13, 'PPL', 'P'),
(8963, 'Fox', 35.791389465332, 0.624677590033657, -92.2975006103516, -1.61089527701211, 218, 4, 'PPL', 'P'),
(35976, 'Fox', 37.7591705322266, 0.659021848609373, -84.0669403076172, -1.46724490044545, 218, 21, 'PPL', 'P'),
(59960, 'Fox', 33.5169410705566, 0.584980976878126, -89.6650009155273, -1.56494948977968, 218, 30, 'PPL', 'P'),
(72588, 'Fox', 39.6433296203613, 0.691906628328699, -83.0124969482422, -1.44884139204857, 218, 41, 'PPL', 'P'),
(75869, 'Fox', 34.3636093139648, 0.599758125397676, -97.491943359375, -1.70155540578892, 218, 42, 'PPL', 'P'),
(94312, 'Fox', 32.7719383239746, 0.571978226013869, -97.904167175293, -1.70875006863182, 218, 51, 'PPL', 'P'),
(102077, 'Fox', 36.6091690063477, 0.638950535579828, -81.2936096191406, -1.41884114868494, 218, 53, 'PPL', 'P'),
(119673, 'Fox', 41.6230583190918, 0.726459412417768, -88.495002746582, -1.54452916948928, 218, 18, 'PPL', 'P'),
(122649, 'Fox', 40.639720916748, 0.709296937088862, -85.6949996948242, -1.49565989717022, 218, 19, 'PPL', 'P'),
(130870, 'Fox', 45.4844398498535, 0.793853233805259, -87.3030624389648, -1.52372588663413, 218, 27, 'PPL', 'P'),
(135445, 'Fox', 48.8388900756836, 0.852399434840261, -95.8986129760742, -1.67374654452825, 218, 28, 'PPL', 'P'),
(148944, 'Fox', 42.4180603027344, 0.740334814592218, -78.642219543457, -1.37256566210956, 218, 40, 'PPL', 'P'),
(178220, 'Fox', 32.7430610656738, 0.571474222777572, -109.13777923584, -1.90481358598011, 218, 5, 'PPL', 'P'),
(196529, 'Fox', 45.2769393920898, 0.790231667617888, -109.21639251709, -1.90618564657372, 218, 31, 'PPL', 'P'),
(200850, 'Fox', 44.6488914489746, 0.779270163150149, -119.143058776855, -2.07943865655326, 218, 43, 'PPL', 'P'),
(211835, 'Fox', 64.9580612182617, 1.13373204397071, -147.61833190918, -2.57642592811699, 218, 1, 'PPL', 'P'),
(87105, 'Fox (historical)', 35.9091682434082, 0.626733217500062, -83.3958282470703, -1.45553178533907, 218, 50, 'PPL', 'P'),
(72587, 'Fox Acres', 39.1955604553223, 0.684091582109861, -84.5699996948242, -1.47602494308528, 218, 41, 'PPL', 'P'),
(81104, 'Fox Bank (historical)', 33.1188888549805, 0.578033655121464, -80.0611114501953, -1.39732999761204, 218, 48, 'PPL', 'P'),
(87106, 'Fox Bluff', 36.3161087036133, 0.633835668390221, -87.1902770996094, -1.5217574111144, 218, 50, 'PPL', 'P'),
(47212, 'Fox Bow', 39.5133285522461, 0.689637681658979, -76.3602828979492, -1.33273835432353, 218, 25, 'PPL', 'P'),
(87107, 'Fox Branch', 36.5869407653809, 0.63856257958803, -83.10888671875, -1.45052371090917, 218, 50, 'PPL', 'P'),
(87108, 'Fox Camp Meadows', 35.7963905334473, 0.624764875138384, -86.3241729736328, -1.506641042451, 218, 50, 'PPL', 'P'),
(47193, 'Fox Chapel', 39.1713905334473, 0.683669737393193, -77.2397232055664, -1.3480874832662, 218, 25, 'PPL', 'P'),
(161784, 'Fox Chapel', 40.5133285522461, 0.707090974178922, -79.879997253418, -1.39416895855617, 218, 45, 'PPL', 'P'),
(35974, 'Fox Chase', 38.0455589294434, 0.664020269080316, -85.6927795410156, -1.49562114817636, 218, 21, 'PPL', 'P'),
(47194, 'Fox Chase', 39.1319389343262, 0.682981177093353, -76.6041717529297, -1.33699501785186, 218, 25, 'PPL', 'P'),
(70836, 'Fox Chase', 39.8563919067383, 0.695625266737804, -74.7266693115234, -1.30422641853509, 218, 37, 'PPL', 'P'),
(102079, 'Fox Chase', 39.1041717529297, 0.682496548353986, -77.6341705322266, -1.35497188784211, 218, 53, 'PPL', 'P'),
(161786, 'Fox Chase', 40.0811080932617, 0.699547304075163, -75.0805587768555, -1.31040295489325, 218, 45, 'PPL', 'P'),
(119674, 'Fox Chase Estates', 41.6458282470703, 0.726856822631435, -87.9466705322266, -1.53495896695403, 218, 18, 'PPL', 'P'),
(13790, 'Fox Chase Park', 39.6749992370605, 0.692459367412945, -75.6833267211914, -1.32092324014739, 218, 10, 'PPL', 'P'),
(102078, 'Fox Corner', 37.0419387817383, 0.64650379306351, -76.4277801513672, -1.33391640363173, 218, 53, 'PPL', 'P'),
(35975, 'Fox Creek', 37.9877815246582, 0.663011863133557, -84.9680633544922, -1.48297246457903, 218, 21, 'PPL', 'P'),
(54833, 'Fox Creek', 38.5711097717285, 0.673192861664821, -90.6888885498047, -1.58281970016828, 218, 29, 'PPL', 'P'),
(174158, 'Fox Creek', 45.4836082458496, 0.793838719577318, -92.3452835083008, -1.61172924590747, 218, 57, 'PPL', 'P'),
(186728, 'Fox Creek', 37.065559387207, 0.646916050400254, -106.200828552246, -1.8535541265827, 218, 7, 'PPL', 'P'),
(194948, 'Fox Creek', 43.6505584716797, 0.761845965665115, -111.110000610352, -1.93923534254354, 218, 17, 'PPL', 'P'),
(196530, 'Fox Crossing', 48.9605598449707, 0.854522972914463, -110.650833129883, -1.93122135819128, 218, 31, 'PPL', 'P'),
(47195, 'Fox Dale Woods', 38.7058296203613, 0.675544166591252, -76.6177825927734, -1.33723257182109, 218, 25, 'PPL', 'P'),
(47196, 'Fox Den', 38.6158294677734, 0.673973367601296, -76.6622161865234, -1.33800808433053, 218, 25, 'PPL', 'P'),
(87109, 'Fox Den', 36.1800003051758, 0.631460128697871, -83.4033279418945, -1.45566267970665, 218, 50, 'PPL', 'P'),
(47197, 'Fox Den Farms', 39.2630615234375, 0.685269697997085, -76.9494400024414, -1.34302108560844, 218, 25, 'PPL', 'P'),
(102080, 'Fox Downs', 37.6930618286133, 0.657868034067096, -77.7652816772461, -1.35726020900876, 218, 53, 'PPL', 'P'),
(47198, 'Fox Field', 38.9938888549805, 0.680571748676131, -75.9158325195313, -1.3249812318584, 218, 25, 'PPL', 'P'),
(87112, 'Fox Fire', 36.5533294677734, 0.637975951778913, -82.4394378662109, -1.43883962425867, 218, 50, 'PPL', 'P'),
(178221, 'Fox Glen', 33.5922203063965, 0.586294847401917, -112.215560913086, -1.9585310099056, 218, 5, 'PPL', 'P'),
(13791, 'Fox Hall', 39.1736106872559, 0.683708486387053, -75.5597229003906, -1.31876594650638, 218, 10, 'PPL', 'P'),
(102081, 'Fox Hall (historical)', 36.8680610656738, 0.643469054422338, -76.2486114501953, -1.33078931987976, 218, 53, 'PPL', 'P'),
(109265, 'Fox Hall (historical)', 39.1966705322266, 0.684110956606792, -80.0180587768555, -1.39657858671047, 218, 58, 'PPL', 'P'),
(102082, 'Fox Hall Park', 36.871940612793, 0.643536765293053, -76.2213897705078, -1.33031421194129, 218, 53, 'PPL', 'P'),
(47199, 'Fox Haven Estates', 39.4377784729004, 0.688319084024253, -76.8150024414063, -1.34067470753002, 218, 25, 'PPL', 'P'),
(8965, 'Fox Hill', 35.0958290100098, 0.612537769941612, -94.2911071777344, -1.64569027560232, 218, 4, 'PPL', 'P'),
(29831, 'Fox Hill', 39.6005592346191, 0.69116014427515, -86.2838897705078, -1.50593796792322, 218, 19, 'PPL', 'P'),
(47201, 'Fox Hill', 39.2538909912109, 0.685109642015571, -76.8530578613281, -1.34133889990589, 218, 25, 'PPL', 'P'),
(102083, 'Fox Hill', 37.0808296203613, 0.647182566246344, -76.2958297729492, -1.33161343507908, 218, 53, 'PPL', 'P'),
(113454, 'Fox Hill', 41.2983283996582, 0.720791806143916, -73.4791717529297, -1.28245347872704, 218, 8, 'PPL', 'P'),
(124880, 'Fox Hill', 42.5288887023926, 0.742269135070969, -71.1916732788086, -1.24252909871928, 218, 23, 'PPL', 'P'),
(145250, 'Fox Hill', 40.877498626709, 0.713446941015532, -74.4444427490234, -1.29930063578288, 218, 37, 'PPL', 'P'),
(148945, 'Fox Hill', 43.1930618286133, 0.753861142926784, -74.045280456543, -1.29233393952928, 218, 40, 'PPL', 'P'),
(161788, 'Fox Hill', 41.8522186279297, 0.730459014321877, -77.7708282470703, -1.35735701491439, 218, 45, 'PPL', 'P'),
(47202, 'Fox Hills', 39.0402793884277, 0.681381416226542, -77.17138671875, -1.34689478657201, 218, 25, 'PPL', 'P'),
(87113, 'Fox Hills', 35.8722190856934, 0.626088333042099, -83.9875030517578, -1.46585845878196, 218, 50, 'PPL', 'P'),
(119689, 'Fox Hills', 41.6522216796875, 0.72696840908111, -87.9516677856445, -1.53504618547973, 218, 18, 'PPL', 'P'),
(148946, 'Fox Hills', 40.6150016784668, 0.708865504992269, -74.0849990844727, -1.29302716036103, 218, 40, 'PPL', 'P'),
(204014, 'Fox Hills', 40.6405601501465, 0.709311584474857, -111.978057861328, -1.9543857996689, 218, 52, 'PPL', 'P'),
(47203, 'Fox Hills Green', 39.0999984741211, 0.682423710898172, -77.2624969482422, -1.3484849600589, 218, 25, 'PPL', 'P'),
(47204, 'Fox Hills North', 39.1055603027344, 0.682520783119905, -77.2611083984375, -1.34846072529298, 218, 25, 'PPL', 'P'),
(13792, 'Fox Hollow', 38.7013893127441, 0.675466668603531, -75.1708297729492, -1.31197848099415, 218, 10, 'PPL', 'P'),
(21265, 'Fox Hollow', 34.3563919067383, 0.599632157878116, -83.8541717529297, -1.46353138862145, 218, 13, 'PPL', 'P'),
(64861, 'Fox Hollow', 35.8572196960449, 0.625826544306944, -77.6255569458008, -1.35482155239858, 218, 33, 'PPL', 'P'),
(102084, 'Fox Hollow', 36.6088905334473, 0.638945675310838, -79.4844436645508, -1.38726524606236, 218, 53, 'PPL', 'P'),
(113456, 'Fox Hollow', 41.5180587768555, 0.724626824692658, -72.8805618286133, -1.2720057646126, 218, 8, 'PPL', 'P'),
(200852, 'Fox Hollow (historical)', 43.9388885498047, 0.766878274860928, -123.206939697266, -2.15036675902339, 218, 43, 'PPL', 'P'),
(70837, 'Fox Hollow Woods', 39.8788909912109, 0.696017949840536, -74.9563903808594, -1.3082358075562, 218, 37, 'PPL', 'P'),
(81107, 'Fox Hunt', 34.9102783203125, 0.609299299477049, -82.0205612182617, -1.43152884759224, 218, 48, 'PPL', 'P'),
(47205, 'Fox Hunt Estates', 38.7400016784668, 0.676140581517375, -76.6444396972656, -1.33769782606353, 218, 25, 'PPL', 'P'),
(59963, 'Fox Island', 34.6749992370605, 0.605192904813228, -90.4458312988281, -1.57857755086789, 218, 30, 'PPL', 'P'),
(207455, 'Fox Island', 47.2516708374023, 0.824697233181257, -122.627777099609, -2.14025846478989, 218, 56, 'PPL', 'P'),
(119675, 'Fox Lake', 42.396671295166, 0.739961505986416, -88.1836090087891, -1.5390943234947, 218, 18, 'PPL', 'P'),
(135446, 'Fox Lake', 43.6766700744629, 0.762301699106654, -94.6586074829102, -1.65210436592972, 218, 28, 'PPL', 'P'),
(174159, 'Fox Lake', 43.565559387207, 0.760362451779886, -88.9063873291016, -1.55170918494619, 218, 57, 'PPL', 'P'),
(196531, 'Fox Lake', 47.6830596923828, 0.832226389057075, -104.621940612793, -1.82599733351921, 218, 31, 'PPL', 'P'),
(119676, 'Fox Lake Hills', 42.4080581665039, 0.740160244382763, -88.1316680908203, -1.53818778345964, 218, 18, 'PPL', 'P'),
(174160, 'Fox Lake Junction', 43.5311088562012, 0.759761176584773, -88.9024963378906, -1.55164127433839, 218, 57, 'PPL', 'P'),
(94313, 'Fox Landing', 30.9908294677734, 0.540892012136728, -94.2377777099609, -1.64475950080134, 218, 51, 'PPL', 'P'),
(13793, 'Fox Meadow', 39.8027801513672, 0.694689565088804, -75.6986083984375, -1.32118995573057, 218, 10, 'PPL', 'P'),
(47206, 'Fox Meadow', 38.9599990844727, 0.679980260598024, -76.0119400024414, -1.32665862387099, 218, 25, 'PPL', 'P'),
(148947, 'Fox Meadow', 41.0016708374023, 0.715614154931612, -73.7930603027344, -1.28793186740544, 218, 40, 'PPL', 'P'),
(21267, 'Fox Meadows', 33.5727806091309, 0.585955560679041, -83.938606262207, -1.46500504881064, 218, 13, 'PPL', 'P'),
(47207, 'Fox Meadows', 39.5930595397949, 0.691029249907572, -76.5086135864258, -1.3353272132192, 218, 25, 'PPL', 'P'),
(113457, 'Fox Meadows', 41.6058311462402, 0.726158741530698, -72.6900024414063, -1.26867987588526, 218, 8, 'PPL', 'P'),
(47208, 'Fox Meadows Purchase', 39.5888900756836, 0.690956479030786, -76.5141677856445, -1.33542415228288, 218, 25, 'PPL', 'P'),
(47209, 'Fox Meadows Woods', 39.5919418334961, 0.691009742252587, -76.5158309936523, -1.33545318073876, 218, 25, 'PPL', 'P'),
(47210, 'Fox Pass', 39.457218170166, 0.688658370747129, -77.2536087036133, -1.3483298309254, 218, 25, 'PPL', 'P'),
(47211, 'Fox Pause', 39.1883316040039, 0.683965414853219, -76.9305572509766, -1.34269151942354, 218, 25, 'PPL', 'P'),
(174163, 'Fox Point', 43.1575012207031, 0.753240493234742, -87.9016723632813, -1.53417360074856, 218, 57, 'PPL', 'P'),
(47213, 'Fox Rest', 39.082218170166, 0.68211338605215, -76.852783203125, -1.34133410621593, 218, 25, 'PPL', 'P'),
(21268, 'Fox Ridge', 33.9319381713867, 0.592224042673842, -84.7347183227539, -1.47889982548202, 218, 13, 'PPL', 'P'),
(29832, 'Fox Ridge', 39.6324996948242, 0.69171761047033, -86.8486099243164, -1.51579419395954, 218, 19, 'PPL', 'P'),
(64862, 'Fox Ridge', 35.1458282470703, 0.613410421251804, -82.9225006103516, -1.44727065963764, 218, 33, 'PPL', 'P'),
(148948, 'Fox Ridge', 43.0552787780762, 0.75145637504147, -76.6911087036133, -1.33851235388293, 218, 40, 'PPL', 'P'),
(161790, 'Fox Ridge', 40.5608291625977, 0.707920016226264, -80.0316696166992, -1.39681614067971, 218, 45, 'PPL', 'P'),
(202142, 'Fox Ridge', 44.9944381713867, 0.785301091175715, -102.525001525879, -1.7893988422388, 218, 49, 'PPL', 'P'),
(21269, 'Fox Ridge Estates', 32.4791717529297, 0.566868485409361, -83.6966705322266, -1.46078247374427, 218, 13, 'PPL', 'P'),
(47216, 'Fox Ridge Estates', 39.3224983215332, 0.686307065820698, -77.2102813720703, -1.34757362633387, 218, 25, 'PPL', 'P'),
(47217, 'Fox Ridge Manor', 39.2972183227539, 0.685865846607099, -76.4527816772461, -1.33435276257634, 218, 25, 'PPL', 'P'),
(174165, 'Fox River', 42.5569381713867, 0.742758690658353, -88.184440612793, -1.53910883772264, 218, 57, 'PPL', 'P'),
(211836, 'Fox River', 59.8583297729492, 1.04472493928251, -150.95832824707, -2.63471986121774, 218, 1, 'PPL', 'P'),
(119678, 'Fox River Estates', 41.9599990844727, 0.732340138157854, -88.3097229003906, -1.54129542613565, 218, 18, 'PPL', 'P'),
(119679, 'Fox River Grove', 42.2008285522461, 0.736543405306326, -88.2144393920898, -1.53963241519295, 218, 18, 'PPL', 'P'),
(119680, 'Fox River Heights', 41.9655609130859, 0.732437210379588, -88.3105621337891, -1.54131007352165, 218, 18, 'PPL', 'P'),
(119681, 'Fox River Shores', 42.2583312988281, 0.737547017563123, -88.2133331298828, -1.53961310727505, 218, 18, 'PPL', 'P'),
(21270, 'Fox Run', 33.5325012207031, 0.585252552730287, -84.3963928222656, -1.47299493155504, 218, 13, 'PPL', 'P'),
(40987, 'Fox Run', 30.3758296966553, 0.530158241231705, -91.0152816772461, -1.58851633489801, 218, 22, 'PPL', 'P'),
(47219, 'Fox Run', 38.6511116027832, 0.67458915702435, -76.9375, -1.34281269325314, 218, 25, 'PPL', 'P'),
(54834, 'Fox Run', 38.1822204589844, 0.666405462731618, -93.5730590820313, -1.63315797214463, 218, 29, 'PPL', 'P'),
(64865, 'Fox Run', 35.0155601501465, 0.611136814050176, -80.7297210693359, -1.40899943687655, 218, 33, 'PPL', 'P'),
(87114, 'Fox Run', 36.5374984741211, 0.637699648815817, -82.5027770996094, -1.43994510242716, 218, 50, 'PPL', 'P'),
(161792, 'Fox Run', 40.702220916748, 0.710387767871358, -80.0830612182617, -1.39771309333485, 218, 45, 'PPL', 'P'),
(13794, 'Fox Run Mobile Home Park', 38.5208282470703, 0.672315283506613, -75.1055603027344, -1.31083931383786, 218, 10, 'PPL', 'P'),
(54835, 'Fox Springs', 38.0086097717285, 0.663375384622353, -91.4591674804688, -1.59626360366711, 218, 29, 'PPL', 'P'),
(87115, 'Fox Springs (historical)', 36.5436096191406, 0.637806308417475, -85.3963928222656, -1.49044822407499, 218, 50, 'PPL', 'P'),
(16115, 'Fox Town', 28.1522197723389, 0.491348926772362, -81.9261093139648, -1.42988035087748, 218, 12, 'PPL', 'P'),
(32471, 'Fox Town', 37.5136108398438, 0.654736023467109, -94.6486129760742, -1.65192992887832, 218, 20, 'PPL', 'P'),
(2585, 'Fox Trace', 33.2777786254883, 0.580806804764563, -86.9452819824219, -1.51748143966816, 218, 2, 'PPL', 'P'),
(21271, 'Fox Trace', 34.2577781677246, 0.597911023444625, -83.8930587768555, -1.46421009522525, 218, 13, 'PPL', 'P'),
(81108, 'Fox Valley', 34.5311088562012, 0.602681543905284, -82.6033325195313, -1.44170012558552, 218, 48, 'PPL', 'P'),
(200851, 'Fox Valley', 44.7597198486328, 0.7812044836289, -122.550559997559, -2.13891077212025, 218, 43, 'PPL', 'P'),
(21272, 'Foxboro', 33.8574981689453, 0.590924819536047, -84.726936340332, -1.47876400426643, 218, 13, 'PPL', 'P'),
(124881, 'Foxboro', 42.0583305358887, 0.734056345743328, -71.25, -1.24354709204596, 218, 23, 'PPL', 'P'),
(174166, 'Foxboro', 46.4986114501953, 0.811553867411444, -92.2877807617188, -1.61072563365067, 218, 57, 'PPL', 'P'),
(21273, 'Foxborough', 30.892219543457, 0.539170944282265, -83.3252792358398, -1.45430047280907, 218, 13, 'PPL', 'P'),
(124882, 'Foxborough', 42.0652809143066, 0.734177652730982, -71.2483291625977, -1.24351793043202, 218, 23, 'PPL', 'P'),
(155324, 'Foxborough', 41.579719543457, 0.725703008089159, -83.6013870239258, -1.45911946280157, 218, 41, 'PPL', 'P'),
(47220, 'Foxborough Farms', 39.5272216796875, 0.68988016247623, -76.3055572509766, -1.33178321159857, 218, 25, 'PPL', 'P'),
(161797, 'Foxburg', 40.9622192382813, 0.714925594631772, -78.8791732788086, -1.37670128496634, 218, 45, 'PPL', 'P'),
(47221, 'Foxcatcher at Fair Hill', 39.7122192382813, 0.693108978981842, -75.8733291625977, -1.32423940833676, 218, 25, 'PPL', 'P'),
(47223, 'Foxchase', 38.2919387817383, 0.668320408713439, -75.5500030517578, -1.31859630314494, 218, 25, 'PPL', 'P'),
(81110, 'Foxchase', 33.5333290100098, 0.585267000379201, -81.7605590820313, -1.4269909542528, 218, 48, 'PPL', 'P'),
(47224, 'Foxchase Manor', 39.6827812194824, 0.692595188628539, -75.8591690063477, -1.3239922669876, 218, 25, 'PPL', 'P'),
(64880, 'Foxcroff', 35.7333297729492, 0.623664257238882, -80.2847213745117, -1.4012327270315, 218, 33, 'PPL', 'P'),
(21274, 'Foxcroft', 33.0666694641113, 0.577122254817412, -85.0908279418945, -1.48511511083405, 218, 13, 'PPL', 'P'),
(47225, 'Foxcroft', 39.3905601501465, 0.687494968824928, -77.4208297729492, -1.35124838916402, 218, 25, 'PPL', 'P'),
(78295, 'Foxcroft', 39.9952812194824, 0.698049342541021, -75.3555603027344, -1.31520263696785, 218, 45, 'PPL', 'P'),
(81112, 'Foxcroft', 34.8666687011719, 0.608538168037504, -82.3022232055664, -1.43644477664842, 218, 48, 'PPL', 'P'),
(119684, 'Foxcroft', 41.836109161377, 0.730177851089792, -88.0752792358398, -1.5372036122788, 218, 18, 'PPL', 'P'),
(64873, 'Foxcroft Apartments', 35.7794418334961, 0.624469064520304, -80.8661117553711, -1.41137990341692, 218, 33, 'PPL', 'P'),
(169382, 'Foxes Hill', 41.8166694641113, 0.729838564366915, -71.4000015258789, -1.24616511255556, 218, 47, 'PPL', 'P'),
(13796, 'Foxfield', 39.6763916015625, 0.692483668757892, -75.7777786254883, -1.32257173686215, 218, 10, 'PPL', 'P'),
(21275, 'Foxfield', 33.5958290100098, 0.586357831161697, -84.2561111450195, -1.47054655440688, 218, 13, 'PPL', 'P'),
(119686, 'Foxfield', 41.9316711425781, 0.731845722301481, -88.4419403076172, -1.54360305522021, 218, 18, 'PPL', 'P'),
(186729, 'Foxfield', 39.5916709899902, 0.691005015141653, -104.791938781738, -1.82896436128967, 218, 7, 'PPL', 'P'),
(47226, 'Foxfield Middletown', 39.440559387207, 0.68836762013512, -77.5308303833008, -1.35316826199386, 218, 25, 'PPL', 'P'),
(13797, 'Foxfire', 39.7333297729492, 0.693477427318655, -75.7138900756836, -1.32145667131374, 218, 10, 'PPL', 'P'),
(21276, 'Foxfire', 32.542781829834, 0.567978690688788, -84.9044418334961, -1.48186205956252, 218, 13, 'PPL', 'P'),
(64875, 'Foxfire', 35.2944412231445, 0.616004206995487, -78.0113906860352, -1.36155562153095, 218, 33, 'PPL', 'P'),
(87118, 'Foxfire', 35.9194412231445, 0.626912514820451, -85.040283203125, -1.48423293872296, 218, 50, 'PPL', 'P'),
(102085, 'Foxfire', 37.2580604553223, 0.650275827852471, -79.8716735839844, -1.39402368311871, 218, 53, 'PPL', 'P'),
(13798, 'Foxfire Meadow', 38.5255584716797, 0.672397841500405, -75.0833282470703, -1.31045129126704, 218, 10, 'PPL', 'P'),
(47227, 'Foxgrape Farm', 38.9627799987793, 0.680028796708891, -75.8066711425781, -1.32307600641456, 218, 25, 'PPL', 'P'),
(13102, 'Foxhall', 38.9222183227539, 0.679320861912121, -77.0944366455078, -1.34555175443428, 218, 9, 'PPL', 'P'),
(21277, 'Foxhall', 33.5016708374023, 0.584714461032037, -82.0774993896484, -1.432522606153, 218, 13, 'PPL', 'P'),
(47228, 'Foxhall', 39.0697212219238, 0.681895273158873, -77.0588912963867, -1.34493137105835, 218, 25, 'PPL', 'P'),
(102086, 'Foxhall', 38.9116706848145, 0.679136770901769, -77.1802825927734, -1.34705004886356, 218, 53, 'PPL', 'P'),
(13799, 'Foxhall Courtside', 39.1766700744629, 0.68376188276691, -75.5880584716797, -1.3192604955208, 218, 10, 'PPL', 'P'),
(13103, 'Foxhall Crescent', 38.9230613708496, 0.679335575877143, -77.0924987792969, -1.34551793228844, 218, 9, 'PPL', 'P'),
(47230, 'Foxhall Estates', 38.6083297729492, 0.673842473233719, -77.0263900756836, -1.34436411774616, 218, 25, 'PPL', 'P'),
(47231, 'Foxhall Farm', 39.2430610656738, 0.684920624157203, -76.732780456543, -1.33923966317663, 218, 25, 'PPL', 'P'),
(13104, 'Foxhall Terrace', 38.913890838623, 0.67917551989563, -77.0736083984375, -1.34518823294549, 218, 9, 'PPL', 'P'),
(13105, 'Foxhall Village', 38.9116706848145, 0.679136770901769, -77.084716796875, -1.34538211107285, 218, 9, 'PPL', 'P'),
(47232, 'Foxhall Villas', 39.2125015258789, 0.684387259569887, -76.9744415283203, -1.34345744455305, 218, 25, 'PPL', 'P'),
(155325, 'Foxhaven', 41.5644416809082, 0.725436359085014, -82.8280563354492, -1.44562229608094, 218, 41, 'PPL', 'P'),
(47233, 'Foxhollow', 39.1002807617188, 0.682428637746189, -76.601936340332, -1.33695600254189, 218, 25, 'PPL', 'P'),
(174167, 'Foxhollow', 42.5138893127441, 0.742007346335815, -88.9077835083008, -1.55173355287016, 218, 57, 'PPL', 'P'),
(198305, 'Foxholm', 48.3694381713867, 0.844205953430524, -101.570831298828, -1.77274543015226, 218, 34, 'PPL', 'P'),
(135448, 'Foxhome', 46.2772216796875, 0.807689886985848, -96.3097229003906, -1.6809217662952, 218, 28, 'PPL', 'P'),
(72589, 'Foxhunter Lane', 39.2358283996582, 0.684794390321533, -84.3166732788086, -1.47160356304353, 218, 41, 'PPL', 'P'),
(47246, 'Foxlair Acres', 39.2169418334961, 0.684464757557609, -77.1966705322266, -1.34733607236464, 218, 25, 'PPL', 'P'),
(21278, 'Foxlake', 32.4716682434082, 0.566737524462757, -81.7944412231445, -1.42758230917285, 218, 13, 'PPL', 'P'),
(87119, 'Foxland Forest', 35.9252815246582, 0.627014447311174, -86.5524978637695, -1.51062606354814, 218, 50, 'PPL', 'P'),
(16116, 'Foxleigh', 27.4986095428467, 0.479941276243007, -82.4336090087891, -1.43873789150503, 218, 12, 'PPL', 'P'),
(47234, 'Foxley Manor', 39.2277793884277, 0.684653908574032, -76.0744400024414, -1.32774945465349, 218, 25, 'PPL', 'P'),
(47235, 'Foxmoor', 39.0430603027344, 0.681429952337409, -76.4902801513672, -1.33500723441422, 218, 25, 'PPL', 'P'),
(174168, 'Foxmoor Hills', 43.1916694641113, 0.753836841581838, -89.2675018310547, -1.55801182198197, 218, 57, 'PPL', 'P'),
(204020, 'Foxmoor Subdivision Number 2', 40.5411109924316, 0.707575869234398, -111.824440002441, -1.95170466224146, 218, 52, 'PPL', 'P'),
(113458, 'Foxon', 41.3244400024414, 0.721247539585456, -72.8358306884766, -1.27122505893904, 218, 8, 'PPL', 'P'),
(209465, 'Foxpark', 41.0794410705566, 0.716971501560198, -106.15193939209, -1.85270084976944, 218, 59, 'PPL', 'P'),
(35977, 'Foxport', 38.4747200012207, 0.671510542804218, -83.5924987792969, -1.45896433366807, 218, 21, 'PPL', 'P'),
(47237, 'Foxridge', 39.5763893127441, 0.690738299558481, -76.1722183227539, -1.32945600828001, 218, 25, 'PPL', 'P'),
(87122, 'Foxridge', 35.8416709899902, 0.625555168191865, -86.5186080932617, -1.51003457547003, 218, 50, 'PPL', 'P'),
(102087, 'Foxridge', 38.7094383239746, 0.675607150351032, -77.4583282470703, -1.3519028610019, 218, 53, 'PPL', 'P'),
(47238, 'Foxridge West', 39.5736083984375, 0.690689763447614, -76.1752777099609, -1.32950940465986, 218, 25, 'PPL', 'P'),
(21279, 'Foxrun', 32.5361099243164, 0.567862243970124, -84.8722229003906, -1.48129973309835, 218, 13, 'PPL', 'P'),
(16117, 'Foxs Corner', 28.1136093139648, 0.490675047148031, -82.5808334350586, -1.44130744248279, 218, 12, 'PPL', 'P'),
(70838, 'Foxs Mill', 39.6133308410645, 0.691383050858389, -75.2541732788086, -1.31343309958155, 218, 37, 'PPL', 'P'),
(102088, 'Foxsport', 37.0552787780762, 0.64673661992181, -79.6777801513672, -1.39063960432154, 218, 53, 'PPL', 'P'),
(161799, 'Foxton', 40.2649993896484, 0.702756812662872, -78.2461090087891, -1.36565222907777, 218, 45, 'PPL', 'P'),
(186730, 'Foxton', 39.4244384765625, 0.688086257165953, -105.235557556152, -1.83670696952686, 218, 7, 'PPL', 'P'),
(35980, 'Foxtown', 37.5041694641113, 0.65457124037466, -83.9936065673828, -1.46596498522556, 218, 21, 'PPL', 'P'),
(47239, 'Foxtown', 39.6324996948242, 0.69171761047033, -79.2386093139648, -1.38297462723013, 218, 25, 'PPL', 'P'),
(72590, 'Foxtown', 39.6686096191406, 0.692347847542298, -81.0122222900391, -1.41393001331872, 218, 41, 'PPL', 'P'),
(81114, 'Foxtown', 33.7130584716797, 0.588403871248178, -81.5697174072266, -1.42366013867744, 218, 48, 'PPL', 'P'),
(161800, 'Foxtown', 40.2252807617188, 0.702063591831125, -79.5861129760742, -1.38903971029668, 218, 45, 'PPL', 'P'),
(161801, 'Foxtown Hill', 40.9772186279297, 0.715187383366926, -75.1791687011719, -1.31212402274772, 218, 45, 'PPL', 'P'),
(59964, 'Foxtrap (historical)', 33.0825004577637, 0.577398557780507, -88.3319396972656, -1.54168318239037, 218, 30, 'PPL', 'P'),
(124884, 'Foxvale', 42.0424995422363, 0.733780042780233, -71.2347183227539, -1.24328037646279, 218, 23, 'PPL', 'P'),
(27202, 'Foxville', 38.5200004577637, 0.672300835857699, -88.8797225952148, -1.5512437975457, 218, 18, 'PPL', 'P'),
(47240, 'Foxville', 39.6363906860352, 0.691785521078128, -77.4972229003906, -1.35258170076377, 218, 25, 'PPL', 'P'),
(81115, 'Foxville', 33.8858299255371, 0.591419301971448, -80.5561065673828, -1.40596929218826, 218, 48, 'PPL', 'P'),
(172029, 'Foxville', 44.1372184753418, 0.770339785066786, -72.482780456543, -1.26506316996687, 218, 55, 'PPL', 'P'),
(81116, 'Foxville Crossroads', 34.3894386291504, 0.6002089319912, -82.35888671875, -1.43743374151922, 218, 48, 'PPL', 'P'),
(102089, 'Foxwells', 37.6291694641113, 0.656752901939653, -76.311393737793, -1.33188507751027, 218, 53, 'PPL', 'P'),
(21280, 'Foxwood', 30.8397197723389, 0.538254650419709, -81.5694427490234, -1.42365534498747, 218, 13, 'PPL', 'P'),
(47242, 'Foxwood', 39.5530586242676, 0.690331102227808, -76.5069427490234, -1.33529805160526, 218, 25, 'PPL', 'P'),
(102091, 'Foxwood', 37.2861099243164, 0.650765383439855, -80.0055618286133, -1.3963604738172, 218, 53, 'PPL', 'P'),
(59965, 'Foxworth', 31.2380599975586, 0.545206998892929, -89.8686065673828, -1.56850307878023, 218, 30, 'PPL', 'P'),
(207456, 'Foy', 47.7341690063477, 0.833118414864197, -122.343887329102, -2.13530365358179, 218, 56, 'PPL', 'P'),
(143838, 'Foyes Corner', 43.0458297729492, 0.751291458790967, -70.7472229003906, -1.23477197625415, 218, 36, 'PPL', 'P'),
(75874, 'Foyil', 36.4347190856934, 0.635905810084567, -95.519172668457, -1.66712406184555, 218, 42, 'PPL', 'P'),
(47244, 'Foys Hill (historical)', 39.6005592346191, 0.69116014427515, -76.004997253418, -1.32653745004139, 218, 25, 'PPL', 'P'),
(161802, 'Frackville', 40.7838897705078, 0.711813158265796, -76.2305603027344, -1.3304742679228, 218, 45, 'PPL', 'P'),
(161803, 'Frackville Junction', 40.7866706848145, 0.711861694376663, -76.2313919067383, -1.33048878215074, 218, 45, 'PPL', 'P'),
(102092, 'Fractionville', 36.7094383239746, 0.640700565311146, -82.0036087036133, -1.43123297039513, 218, 53, 'PPL', 'P'),
(207457, 'Fragaria', 47.464168548584, 0.828406017894329, -122.529998779297, -2.13855191116336, 218, 56, 'PPL', 'P'),
(35978, 'Fragrant', 37.4541702270508, 0.653698589064468, -86.1697235107422, -1.50394539079562, 218, 21, 'PPL', 'P'),
(119687, 'Frahms Country Acres', 41.9363899230957, 0.731928080558192, -89.1511077880859, -1.55598036270246, 218, 18, 'PPL', 'P'),
(54837, 'Frailie', 36.4180603027344, 0.635615059472558, -89.8172225952148, -1.56760625928315, 218, 29, 'PPL', 'P'),
(130871, 'Frain Lake', 42.3291702270508, 0.738783390099192, -83.616943359375, -1.4593909720747, 218, 27, 'PPL', 'P'),
(35979, 'Frakes', 36.6427803039551, 0.639537163388945, -83.9277801513672, -1.4648160975313, 218, 21, 'PPL', 'P'),
(148949, 'Fraleighs', 42.0033302307129, 0.733096409328409, -73.8344421386719, -1.28865411669307, 218, 40, 'PPL', 'P'),
(47245, 'Fraley Acres', 39.5858306884766, 0.69090308265093, -77.4188919067383, -1.35121456701817, 218, 25, 'PPL', 'P'),
(102093, 'Fraleytown', 36.7044410705566, 0.640613346785446, -82.8227767944336, -1.44553015070722, 218, 53, 'PPL', 'P'),
(102094, 'Fralin Park', 37.2433280944824, 0.650018699649224, -79.9791717529297, -1.39589988010667, 218, 53, 'PPL', 'P'),
(181675, 'Fram (historical)', 35.0994415283203, 0.61260082028042, -118.185562133789, -2.06272718755495, 218, 6, 'PPL', 'P'),
(94314, 'Frame', 33.8147201538086, 0.590178202324443, -98.2213897705078, -1.71428664738004, 218, 51, 'PPL', 'P'),
(109266, 'Frame', 38.5041694641113, 0.672024532894603, -81.4761123657227, -1.42202642250673, 218, 58, 'PPL', 'P'),
(109267, 'Frame Knob (historical)', 38.5697212219238, 0.673168626898901, -80.954719543457, -1.41292640106193, 218, 58, 'PPL', 'P'),
(94315, 'Frame Switch', 30.5590305328369, 0.533355699015481, -97.4614181518555, -1.70102264041284, 218, 51, 'PPL', 'P'),
(70839, 'Frames Corner', 39.3033294677734, 0.685972506208757, -75.1641693115234, -1.31186223401256, 218, 37, 'PPL', 'P'),
(109268, 'Frametown', 38.6377792358398, 0.674356463324104, -80.8586120605469, -1.41124900904934, 218, 58, 'PPL', 'P'),
(124885, 'Framingham', 42.2791709899902, 0.737910738789, -71.4166717529297, -1.24645606290465, 218, 23, 'PPL', 'P'),
(124886, 'Framingham Center', 42.2972183227539, 0.738225724166929, -71.4375, -1.24681958439345, 218, 23, 'PPL', 'P'),
(155326, 'Frampton', 40.2272186279297, 0.702097413976969, -82.2063903808594, -1.43477217832579, 218, 41, 'PPL', 'P'),
(21281, 'Fran Mar Heights', 34.3491706848145, 0.599506123779528, -83.9063873291016, -1.46444272234647, 218, 13, 'PPL', 'P'),
(194949, 'France', 43.9724998474121, 0.767464902670046, -111.274436950684, -1.94210529809227, 218, 17, 'PPL', 'P'),
(29833, 'Frances', 39.6058311462402, 0.691252156490812, -86.1688919067383, -1.50393087656768, 218, 19, 'PPL', 'P'),
(35981, 'Frances', 37.2197189331055, 0.649606642049562, -88.14111328125, -1.53835263313112, 218, 21, 'PPL', 'P'),
(181676, 'Frances', 33.7119407653809, 0.588384363593193, -117.763610839844, -2.05536274819256, 218, 6, 'PPL', 'P'),
(207458, 'Frances', 46.5424995422363, 0.812319859119978, -123.503608703613, -2.15554460997278, 218, 56, 'PPL', 'P'),
(2590, 'Frances Heights', 33.6130599975586, 0.586658568627795, -86.836669921875, -1.51558580160425, 218, 2, 'PPL', 'P'),
(40989, 'Frances Place', 29.9174995422363, 0.52215887097592, -89.9097213745117, -1.56922066753595, 218, 22, 'PPL', 'P'),
(143839, 'Francestown', 42.9874992370605, 0.750273398885257, -71.8130569458008, -1.25337428962641, 218, 36, 'PPL', 'P'),
(122641, 'Francesville', 40.985279083252, 0.71532806485151, -86.8794403076172, -1.5163322856578, 218, 19, 'PPL', 'P'),
(2591, 'Francis', 33.7747192382813, 0.589480054644679, -86.0336074829102, -1.50156971794521, 218, 2, 'PPL', 'P'),
(8967, 'Francis', 36.2919387817383, 0.633413823673553, -93.1813888549805, -1.62632203710056, 218, 4, 'PPL', 'P'),
(16118, 'Francis', 29.6341705322266, 0.517213846884834, -81.7080612182617, -1.42607469367976, 218, 12, 'PPL', 'P'),
(27203, 'Francis', 37.8997192382813, 0.661474886289445, -88.4530563354492, -1.54379706650562, 218, 18, 'PPL', 'P'),
(59971, 'Francis', 34.0816688537598, 0.59483733607251, -90.8547210693359, -1.58571402364098, 218, 30, 'PPL', 'P'),
(75871, 'Francis', 34.8736114501953, 0.608659341867103, -96.5952835083008, -1.68590573911723, 218, 42, 'PPL', 'P'),
(94316, 'Francis', 30.0894393920898, 0.525159787471249, -93.7763900756836, -1.63670676745521, 218, 51, 'PPL', 'P'),
(109269, 'Francis', 39.4080581665039, 0.687800366822933, -80.245002746582, -1.40053950619975, 218, 58, 'PPL', 'P'),
(113304, 'Francis', 41.9594383239746, 0.732330351040848, -80.2649993896484, -1.4008885134606, 218, 45, 'PPL', 'P'),
(196532, 'Francis', 46.1458282470703, 0.80539663897118, -111.088333129883, -1.93885717366875, 218, 31, 'PPL', 'P'),
(204022, 'Francis', 40.6105613708496, 0.708788007004548, -111.279998779297, -1.942202370314, 218, 52, 'PPL', 'P'),
(94317, 'Francis Addition Colonia', 26.1949996948242, 0.457188992233592, -98.2160034179688, -1.71419263779356, 218, 51, 'PPL', 'P'),
(148950, 'Francis Corners', 43.0133285522461, 0.75072420547878, -73.7786102294922, -1.28767966605021, 218, 40, 'PPL', 'P'),
(174169, 'Francis Creek', 44.1994400024414, 0.771425755580293, -87.7213897705078, -1.53102707592063, 218, 57, 'PPL', 'P'),
(130872, 'Francis Grove', 43.7208290100098, 0.763072417926123, -84.3899993896484, -1.47288334510537, 218, 27, 'PPL', 'P'),
(81117, 'Francis Marion Estates', 33.5283317565918, 0.585179781853501, -79.4222183227539, -1.38617920896982, 218, 48, 'PPL', 'P'),
(64882, 'Francis Mill', 36.1358299255371, 0.63068921014132, -77.1083297729492, -1.34579423525154, 218, 33, 'PPL', 'P'),
(145251, 'Francis Mills', 40.1347198486328, 0.700483005724163, -74.3977813720703, -1.29848624112153, 218, 37, 'PPL', 'P'),
(94318, 'Francisca Colonia', 26.386999130249, 0.460540014543726, -98.8420028686523, -1.72511838932366, 218, 51, 'PPL', 'P'),
(181678, 'Franciscan Village', 34.4077796936035, 0.600529043954227, -119.537216186523, -2.08631800112309, 218, 6, 'PPL', 'P'),
(2593, 'Francisco', 34.9872207641602, 0.610642198456721, -86.2491683959961, -1.50533196561717, 218, 2, 'PPL', 'P'),
(29834, 'Francisco', 38.332218170166, 0.669023416662193, -87.4452819824219, -1.52620808592814, 218, 19, 'PPL', 'P'),
(64883, 'Francisco', 36.5088882446289, 0.637200306111427, -80.3561096191406, -1.40247868694749, 218, 33, 'PPL', 'P'),
(130873, 'Francisco', 42.2772216796875, 0.737876716906074, -84.1405563354492, -1.46852974251336, 218, 27, 'PPL', 'P'),
(188569, 'Francisco Rascon Place', 33.0116691589355, 0.576162318402493, -107.622222900391, -1.87836213792706, 218, 38, 'PPL', 'P'),
(94319, 'Francisco Rodriguez Colonia', 26.4120006561279, 0.460976373488335, -98.963996887207, -1.72724758661518, 218, 51, 'PPL', 'P'),
(21282, 'Francisville', 32.6741714477539, 0.570271872124428, -84.0911102294922, -1.46766674516212, 218, 13, 'PPL', 'P'),
(35982, 'Francisville', 39.1049995422363, 0.682510996002899, -84.7244415283203, -1.47872046158261, 218, 21, 'PPL', 'P'),
(94320, 'Francitas', 28.8594398498535, 0.503692245661202, -96.3383331298828, -1.68142110899959, 218, 51, 'PPL', 'P'),
(64884, 'Francktown', 34.913330078125, 0.60935256269885, -77.5100021362305, -1.35280474050506, 218, 33, 'PPL', 'P'),
(102095, 'Franco', 36.976390838623, 0.645359765638239, -82.4208297729492, -1.43851485176373, 218, 53, 'PPL', 'P'),
(102096, 'Franconia', 38.7819404602051, 0.676872551342984, -77.1466674804688, -1.34646335447542, 218, 53, 'PPL', 'P'),
(135452, 'Franconia', 45.3702812194824, 0.791860789835716, -92.6913909912109, -1.61776996105004, 218, 28, 'PPL', 'P'),
(143841, 'Franconia', 44.2269401550293, 0.771905723787753, -71.7483291625977, -1.252244576692, 218, 36, 'PPL', 'P'),
(161806, 'Franconia', 40.3077812194824, 0.703503496453503, -75.3580627441406, -1.31524631280973, 218, 45, 'PPL', 'P'),
(178222, 'Franconia', 34.7394409179688, 0.606317624320596, -114.267501831055, -1.99434413498055, 218, 5, 'PPL', 'P'),
(155328, 'Franconia (historical)', 41.0422210693359, 0.7163218899913, -84.3022232055664, -1.4713513616883, 218, 41, 'PPL', 'P'),
(16134, 'Franjo', 25.5791702270508, 0.446440740390142, -80.3363876342773, -1.4021344733766, 218, 12, 'PPL', 'P'),
(47247, 'Frank', 39.6394386291504, 0.691838717720902, -76.107780456543, -1.32833135535167, 218, 25, 'PPL', 'P'),
(64885, 'Frank', 36.0705604553223, 0.629550042985039, -82.0027770996094, -1.43121845616719, 218, 33, 'PPL', 'P'),
(109270, 'Frank', 38.5483283996582, 0.672795251714072, -79.8058319091797, -1.39287452910834, 218, 58, 'PPL', 'P'),
(155329, 'Frank', 41.1897201538086, 0.718896234659025, -82.8580627441406, -1.4461460067093, 218, 41, 'PPL', 'P'),
(40990, 'Frank Bell Subdivision', 31.1513900756836, 0.543694323393764, -93.2819366455078, -1.62807692710087, 218, 22, 'PPL', 'P'),
(191497, 'Frank Colonia', 31.6599998474121, 0.552571238518244, -106.306999206543, -1.85540715406917, 218, 51, 'PPL', 'P'),
(191498, 'Frank-Anita Estates Colonia', 31.5909996032715, 0.55136695707331, -106.271003723145, -1.85477891436802, 218, 51, 'PPL', 'P'),
(54838, 'Frankclay', 37.8616714477539, 0.660810827071634, -90.6149978637695, -1.58153006441041, 218, 29, 'PPL', 'P'),
(191499, 'Frankel City', 32.3841705322266, 0.565210401314678, -102.781669616699, -1.79387854550842, 218, 51, 'PPL', 'P'),
(94321, 'Frankell', 32.6241683959961, 0.569399154235209, -98.7180633544922, -1.72295523672825, 218, 51, 'PPL', 'P'),
(130875, 'Frankenmuth', 43.3316688537598, 0.756280291881985, -83.7380599975586, -1.46150485618995, 218, 27, 'PPL', 'P'),
(54839, 'Frankenstein', 38.5741691589355, 0.673246258044677, -91.8822174072266, -1.60364721778935, 218, 29, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(130878, 'Frankentrost', 43.4072189331055, 0.757598889516711, -83.7919387817383, -1.46244521837086, 218, 27, 'PPL', 'P'),
(87126, 'Frankewing', 35.1925010681152, 0.614225015650232, -86.8511123657227, -1.51583786980142, 218, 50, 'PPL', 'P'),
(13800, 'Frankford', 38.517219543457, 0.672252299746832, -75.2352828979492, -1.31310340023859, 218, 10, 'PPL', 'P'),
(47248, 'Frankford', 38.746940612793, 0.676261688767947, -76.0719375610352, -1.32770577881161, 218, 25, 'PPL', 'P'),
(54840, 'Frankford', 39.4900016784668, 0.689230550907333, -91.3199996948242, -1.5938346675949, 218, 29, 'PPL', 'P'),
(109271, 'Frankford', 37.9249992370605, 0.661916105503044, -80.3847198486328, -1.40297802965188, 218, 58, 'PPL', 'P'),
(161808, 'Frankford', 40.0280609130859, 0.698621456122197, -75.0852813720703, -1.31048537972899, 218, 45, 'PPL', 'P'),
(47249, 'Frankford (historical)', 38.3597183227539, 0.669503384869653, -75.5972213745117, -1.31942041834426, 218, 25, 'PPL', 'P'),
(2594, 'Frankfort', 34.5633316040039, 0.603243936948481, -87.8422164916992, -1.53313590002981, 218, 2, 'PPL', 'P'),
(32473, 'Frankfort', 39.7055587768555, 0.69299273200026, -96.4166717529297, -1.68278837590324, 218, 20, 'PPL', 'P'),
(35983, 'Frankfort', 38.2008285522461, 0.666730235226553, -84.8733291625977, -1.48131904101625, 218, 21, 'PPLA', 'P'),
(75875, 'Frankfort', 36.975830078125, 0.645349978521233, -96.679443359375, -1.68737460561646, 218, 42, 'PPL', 'P'),
(87127, 'Frankfort', 36.1025009155273, 0.630107509180219, -84.8036117553711, -1.48010224271419, 218, 50, 'PPL', 'P'),
(119690, 'Frankfort', 41.4958305358887, 0.72423886870086, -87.8486099243164, -1.53324748647949, 218, 18, 'PPL', 'P'),
(122642, 'Frankfort', 40.2794418334961, 0.703008880860048, -86.5108337402344, -1.50989888741249, 218, 19, 'PPL', 'P'),
(127520, 'Frankfort', 44.6097183227539, 0.778586463119298, -68.8772201538086, -1.20213427130496, 218, 26, 'PPL', 'P'),
(130879, 'Frankfort', 44.6336097717285, 0.779003447566977, -86.2344436645508, -1.50507497057198, 218, 27, 'PPL', 'P'),
(145253, 'Frankfort', 40.5086097717285, 0.707008615922211, -74.6836090087891, -1.30347487447547, 218, 37, 'PPL', 'P'),
(148951, 'Frankfort', 43.038890838623, 0.751170351540396, -75.0708312988281, -1.31023317837376, 218, 40, 'PPL', 'P'),
(155349, 'Frankfort', 41.6438903808594, 0.726823000485591, -83.8563919067383, -1.46357013761531, 218, 41, 'PPL', 'P'),
(170323, 'Frankfort', 44.8766708374023, 0.783245663446392, -98.3050003051758, -1.71574592649935, 218, 49, 'PPL', 'P'),
(207459, 'Frankfort', 46.2805595397949, 0.807748143634693, -123.754722595215, -2.15992737417872, 218, 56, 'PPL', 'P'),
(115613, 'Frankfort (historical)', 41.0327796936035, 0.716157106898851, -95.1338882446289, -1.6603995800931, 218, 16, 'PPL', 'P'),
(148952, 'Frankfort Center', 43.0511093139648, 0.751383604164684, -75.1447219848633, -1.31152281413163, 218, 40, 'PPL', 'P'),
(161809, 'Frankfort Springs', 40.478889465332, 0.706489898720891, -80.4427795410156, -1.40399136244666, 218, 45, 'PPL', 'P'),
(119691, 'Frankfort Square', 41.5188903808594, 0.724641338920599, -87.8030624389648, -1.5324525328941, 218, 18, 'PPL', 'P'),
(2596, 'Franklin', 31.7144393920898, 0.553521387816157, -87.4113922119141, -1.52561659785003, 218, 2, 'PPL', 'P'),
(8970, 'Franklin', 36.170280456543, 0.631290485336433, -91.7758331298828, -1.60179046187735, 218, 4, 'PPL', 'P'),
(16135, 'Franklin', 29.7480602264404, 0.519201597032955, -85.0280609130859, -1.48401961951965, 218, 12, 'PPL', 'P'),
(21283, 'Franklin', 33.2775001525879, 0.580801944495574, -85.0980606079102, -1.48524134466972, 218, 13, 'PPL', 'P'),
(27206, 'Franklin', 39.6202812194824, 0.691504357846042, -90.0438919067383, -1.57156238508246, 218, 18, 'PPL', 'P'),
(32474, 'Franklin', 37.5263900756836, 0.654959063208403, -94.7055587768555, -1.65292382059714, 218, 20, 'PPL', 'P'),
(35984, 'Franklin', 36.7222213745117, 0.640923671631467, -86.5772171020508, -1.51105749564473, 218, 21, 'PPL', 'P'),
(40991, 'Franklin', 29.7958297729492, 0.520035332901718, -91.5013885498047, -1.59700050034073, 218, 22, 'PPL', 'P'),
(47250, 'Franklin', 39.4980583190918, 0.689371165812889, -79.04638671875, -1.3796197100469, 218, 25, 'PPL', 'P'),
(54841, 'Franklin', 39.0116691589355, 0.680882073522152, -92.753059387207, -1.6188462776046, 218, 29, 'PPL', 'P'),
(59969, 'Franklin', 33.035831451416, 0.576584029961107, -90.0019378662109, -1.57083014894074, 218, 30, 'PPL', 'P'),
(64888, 'Franklin', 36.4891700744629, 0.636856159119562, -80.6338882446289, -1.40732683855393, 218, 33, 'PPL', 'P'),
(75876, 'Franklin', 35.2763900756836, 0.61568915503853, -97.3352813720703, -1.69882113829773, 218, 42, 'PPL', 'P'),
(87128, 'Franklin', 35.9249992370605, 0.627009520463157, -86.8688888549805, -1.51614812806842, 218, 50, 'PPL', 'P'),
(94323, 'Franklin', 31.0258293151855, 0.541502874711765, -96.4850006103516, -1.68398093943937, 218, 51, 'PPL', 'P'),
(102099, 'Franklin', 36.6775016784668, 0.640143165694992, -76.9227828979492, -1.342555831366, 218, 53, 'PPL', 'P'),
(112306, 'Franklin', 39.4805603027344, 0.689065767814884, -86.0550003051758, -1.50194309313004, 218, 19, 'PPL', 'P'),
(113459, 'Franklin', 41.6088905334473, 0.726212137910555, -72.1463928222656, -1.25919209818574, 218, 8, 'PPL', 'P'),
(115615, 'Franklin', 40.6680603027344, 0.709791552682317, -91.5111083984375, -1.59717014370217, 218, 16, 'PPL', 'P'),
(124888, 'Franklin', 42.0833282470703, 0.734492638108911, -71.397216796875, -1.24611650986567, 218, 23, 'PPL', 'P'),
(127522, 'Franklin', 44.5869407653809, 0.778188919747577, -68.232780456543, -1.19088667675711, 218, 26, 'PPL', 'P'),
(130881, 'Franklin', 42.5222206115723, 0.742152754931333, -83.3061065673828, -1.4539658466181, 218, 27, 'PPL', 'P'),
(135456, 'Franklin', 44.5283317565918, 0.777165999572877, -94.8802795410156, -1.65597327320334, 218, 28, 'PPL', 'P'),
(141842, 'Franklin', 40.0961112976074, 0.699809159389346, -98.9522171020508, -1.72704199057903, 218, 35, 'PPL', 'P'),
(143843, 'Franklin', 43.4441719055176, 0.758243840553701, -71.6477813720703, -1.25048968669169, 218, 36, 'PPL', 'P'),
(145257, 'Franklin', 41.121940612793, 0.717713258502812, -74.5808334350586, -1.30168110232325, 218, 37, 'PPL', 'P'),
(148954, 'Franklin', 42.3405609130859, 0.738982195074566, -75.1655578613281, -1.31188646877848, 218, 40, 'PPL', 'P'),
(155331, 'Franklin', 40.2138900756836, 0.70186478685575, -81.8819427490234, -1.42910949889996, 218, 41, 'PPL', 'P'),
(161813, 'Franklin', 40.4566688537598, 0.706102075887148, -79.6600036621094, -1.39032934605455, 218, 45, 'PPL', 'P'),
(170327, 'Franklin', 43.8916702270508, 0.766054159661603, -97.0686111450195, -1.69416686481865, 218, 49, 'PPL', 'P'),
(172030, 'Franklin', 44.9819412231445, 0.785082978282437, -72.9166717529297, -1.27263600168457, 218, 55, 'PPL', 'P'),
(174175, 'Franklin', 43.8355598449707, 0.765074848749754, -87.9013900756836, -1.53416867390055, 218, 57, 'PPL', 'P'),
(177223, 'Franklin', 40.2744407653809, 0.702921595755321, -80.5425033569336, -1.40573187137708, 218, 58, 'PPL', 'P'),
(178223, 'Franklin', 32.6775016784668, 0.570329995615219, -109.07861328125, -1.90378094526743, 218, 5, 'PPL', 'P'),
(181680, 'Franklin', 38.3791694641113, 0.66984287132961, -121.453330993652, -2.11976051335371, 218, 6, 'PPL', 'P'),
(194950, 'Franklin', 42.0136108398438, 0.733275839806854, -111.80638885498, -1.9513896102845, 218, 17, 'PPL', 'P'),
(196533, 'Franklin', 46.3716697692871, 0.809338317121579, -109.266937255859, -1.9070678186848, 218, 31, 'PPL', 'P'),
(200853, 'Franklin', 44.1611099243164, 0.770756769514465, -123.303329467773, -2.15204907788399, 218, 43, 'PPL', 'P'),
(207460, 'Franklin', 47.3011093139648, 0.825560097374443, -121.951667785645, -2.1284581311578, 218, 56, 'PPL', 'P'),
(72593, 'Franklin (historical)', 39.3638916015625, 0.68702951484541, -82.9738922119141, -1.44816761229278, 218, 41, 'PPL', 'P'),
(161814, 'Franklin Center', 41.9355583190918, 0.731913566330251, -80.2249984741211, -1.40019036578084, 218, 45, 'PPL', 'P'),
(191500, 'Franklin Center', 32.7297210693359, 0.571241395919271, -101.031112670898, -1.76332556306054, 218, 51, 'PPL', 'P'),
(102100, 'Franklin City', 38.0077781677246, 0.663360870394412, -75.3838882446289, -1.31569705282422, 218, 53, 'PPL', 'P'),
(145258, 'Franklin Corner', 40.2802810668945, 0.703023528246044, -74.7169418334961, -1.3040566420156, 218, 37, 'PPL', 'P'),
(119693, 'Franklin Corners', 41.9169387817383, 0.731588594098234, -89.9105606079102, -1.56923531492195, 218, 18, 'PPL', 'P'),
(102102, 'Franklin Court', 37.3161087036133, 0.651288960910165, -79.9241714477539, -1.39493994369175, 218, 53, 'PPL', 'P'),
(35986, 'Franklin Cross Roads', 37.6699981689453, 0.657465497268331, -86.0149993896484, -1.50124494545028, 218, 21, 'PPL', 'P'),
(148956, 'Franklin Depot', 42.2825012207031, 0.737968862279791, -75.209716796875, -1.31265718759795, 218, 40, 'PPL', 'P'),
(148957, 'Franklin Falls', 44.4366683959961, 0.775566172127039, -73.970832824707, -1.29103458323344, 218, 40, 'PPL', 'P'),
(21286, 'Franklin Farms', 33.514720916748, 0.584942227884266, -84.4775009155273, -1.47441053483248, 218, 13, 'PPL', 'P'),
(102103, 'Franklin Farms', 37.1497192382813, 0.648384916899488, -77.3636093139648, -1.35024970375524, 218, 53, 'PPL', 'P'),
(161816, 'Franklin Farms', 40.1549987792969, 0.700836939833034, -80.2705612182617, -1.40098558568234, 218, 45, 'PPL', 'P'),
(102104, 'Franklin Forest', 38.9091682434082, 0.679093095059892, -77.1605606079102, -1.34670583529267, 218, 53, 'PPL', 'P'),
(161817, 'Franklin Forge', 40.4727783203125, 0.706383239119233, -78.2352828979492, -1.36546327779842, 218, 45, 'PPL', 'P'),
(161818, 'Franklin Forks', 41.9180603027344, 0.731608168332246, -75.8477783203125, -1.32379346201223, 218, 45, 'PPL', 'P'),
(72595, 'Franklin Furnace', 38.6450004577637, 0.674482497422692, -82.8488922119141, -1.44598595072779, 218, 41, 'PPL', 'P'),
(161819, 'Franklin Furnace', 40.9886093139648, 0.715386188342301, -76.6513900756836, -1.33781913305118, 218, 45, 'PPL', 'P'),
(2598, 'Franklin Gardens', 33.5583305358887, 0.58570335932381, -86.8352813720703, -1.51556156683833, 218, 2, 'PPL', 'P'),
(64891, 'Franklin Grove', 35.4355583190918, 0.618467164950619, -83.4630584716797, -1.45670517411536, 218, 33, 'PPL', 'P'),
(119695, 'Franklin Grove', 41.8416709899902, 0.730274923311525, -89.3002777099609, -1.55858386898412, 218, 18, 'PPL', 'P'),
(145259, 'Franklin Grove', 41.0311088562012, 0.716127945284915, -74.9572219848633, -1.30825032178414, 218, 37, 'PPL', 'P'),
(87130, 'Franklin Hill', 35.901668548584, 0.626602323132484, -84.1105575561523, -1.46800616504305, 218, 50, 'PPL', 'P'),
(81118, 'Franklin Hills', 34.8055610656738, 0.607471638599955, -82.3341674804688, -1.43700230942262, 218, 48, 'PPL', 'P'),
(102105, 'Franklin Junction', 36.6133308410645, 0.639023173298559, -76.6455612182617, -1.33771740029754, 218, 53, 'PPL', 'P'),
(155332, 'Franklin Junction', 41.6719398498535, 0.727312556072975, -84.414436340332, -1.47330985035395, 218, 41, 'PPL', 'P'),
(161820, 'Franklin Junction', 41.2227783203125, 0.719473208509191, -75.9036102294922, -1.32476791265509, 218, 45, 'PPL', 'P'),
(47252, 'Franklin Knolls', 39.014720916748, 0.680935336743954, -76.9980621337891, -1.34386970188979, 218, 25, 'PPL', 'P'),
(145260, 'Franklin Lakes', 41.0166702270508, 0.715875943666766, -74.2061080932617, -1.29514091131823, 218, 37, 'PPL', 'P'),
(47253, 'Franklin Manor Beach', 38.8044395446777, 0.677265234445716, -76.522216796875, -1.33556463403038, 218, 25, 'PPL', 'P'),
(47254, 'Franklin Manor-on-the-Bay', 38.8013916015625, 0.677212037802941, -76.5149993896484, -1.33543866651082, 218, 25, 'PPL', 'P'),
(13106, 'Franklin McPherson Square', 38.9013900756836, 0.678957340423325, -77.033332824707, -1.34448529157576, 218, 9, 'PPL', 'P'),
(130882, 'Franklin Mine', 47.1399993896484, 0.822748198737483, -88.5730590820313, -1.54589150954491, 218, 27, 'PPL', 'P'),
(47255, 'Franklin Park', 39.0536117553711, 0.681614109926788, -77.0961074829102, -1.34558091604822, 218, 25, 'PPL', 'P'),
(102107, 'Franklin Park', 38.9099998474121, 0.679107609287833, -77.1536102294922, -1.34658452830502, 218, 53, 'PPL', 'P'),
(119696, 'Franklin Park', 41.9352798461914, 0.731908706061261, -87.8655624389648, -1.5335433636766, 218, 18, 'PPL', 'P'),
(124890, 'Franklin Park', 42.4416694641113, 0.74074687219188, -71.0166702270508, -1.23947471926507, 218, 23, 'PPL', 'P'),
(145263, 'Franklin Park', 40.4388885498047, 0.705791751041127, -74.5355606079102, -1.30089094242782, 218, 37, 'PPL', 'P'),
(148958, 'Franklin Park', 43.0825004577637, 0.75193148297994, -76.0752792358398, -1.32776410203948, 218, 40, 'PPL', 'P'),
(161821, 'Franklin Park', 40.5833282470703, 0.708312699328996, -80.0880584716797, -1.39780031186055, 218, 45, 'PPL', 'P'),
(161822, 'Franklin Pike Corners', 41.6133308410645, 0.726289635898276, -80.1486129760742, -1.39885718733915, 218, 45, 'PPL', 'P'),
(127524, 'Franklin Road', 44.5394401550293, 0.777359877700235, -68.3188934326172, -1.1923896317183, 218, 26, 'PPL', 'P'),
(87132, 'Franklin Road Estates', 35.8444404602051, 0.62560350456565, -86.4872207641602, -1.5094867632338, 218, 50, 'PPL', 'P'),
(21287, 'Franklin Springs', 34.2847213745117, 0.598381271114105, -83.1444396972656, -1.45114422744316, 218, 13, 'PPL', 'P'),
(148959, 'Franklin Springs', 43.0366706848145, 0.751131602546535, -75.3925018310547, -1.31584738826776, 218, 40, 'PPL', 'P'),
(148960, 'Franklin Square', 40.707218170166, 0.710474986397058, -73.6763916015625, -1.28589561443596, 218, 40, 'PPL', 'P'),
(155333, 'Franklin Square', 40.8561096191406, 0.71307363240973, -80.7919387817383, -1.41008534081103, 218, 41, 'PPL', 'P'),
(47256, 'Franklin Valley', 39.4647216796875, 0.688789331693734, -76.8555603027344, -1.34138257574776, 218, 25, 'PPL', 'P'),
(81120, 'Franklin Village', 34.940559387207, 0.609827803795375, -82.0036087036133, -1.43123297039513, 218, 48, 'PPL', 'P'),
(161838, 'Franklindale', 41.7027816772461, 0.727850847508308, -76.5547180175781, -1.33613188734256, 218, 45, 'PPL', 'P'),
(47257, 'Franklins Chance', 39.5513916015625, 0.690302007192899, -76.4813919067383, -1.33485210528073, 218, 25, 'PPL', 'P'),
(21288, 'Franklinton', 32.8041687011719, 0.572540752215121, -83.5355606079102, -1.45797057510731, 218, 13, 'PPL', 'P'),
(35987, 'Franklinton', 38.4524993896484, 0.671122719970475, -85.0555572509766, -1.48449952114808, 218, 21, 'PPL', 'P'),
(40993, 'Franklinton', 30.8469390869141, 0.538380651228784, -90.1530609130859, -1.57346774368436, 218, 22, 'PPL', 'P'),
(64897, 'Franklinton', 36.1016693115234, 0.630092994952278, -78.4583282470703, -1.36935615352185, 218, 33, 'PPL', 'P'),
(148963, 'Franklinton', 42.5208282470703, 0.742128453586386, -74.3038864135742, -1.29684746494475, 218, 40, 'PPL', 'P'),
(16137, 'Franklintown', 30.5561103820801, 0.53330473277012, -81.4497222900391, -1.4215658287962, 218, 12, 'PPL', 'P'),
(47258, 'Franklintown', 39.3044395446777, 0.685991880705687, -76.7119369506836, -1.33887587537173, 218, 25, 'PPL', 'P'),
(109274, 'Franklintown', 39.204719543457, 0.684251438354293, -77.934440612793, -1.36021258939322, 218, 58, 'PPL', 'P'),
(161839, 'Franklintown', 40.0766716003418, 0.699469872666469, -77.0286102294922, -1.34440286674002, 218, 45, 'PPL', 'P'),
(21289, 'Franklinville', 30.9819393157959, 0.540736849713718, -83.283332824707, -1.45356836982541, 218, 13, 'PPL', 'P'),
(47260, 'Franklinville', 39.4588890075684, 0.688687532361066, -77.0994415283203, -1.34563910611804, 218, 25, 'PPL', 'P'),
(64898, 'Franklinville', 35.7436103820801, 0.623843687717326, -79.692497253418, -1.39089646620868, 218, 33, 'PPL', 'P'),
(70841, 'Franklinville', 39.6180610656738, 0.691465608852182, -75.0761108398438, -1.31032532374748, 218, 37, 'PPL', 'P'),
(119698, 'Franklinville', 42.276668548584, 0.737867062947123, -88.5111083984375, -1.54481026614234, 218, 18, 'PPL', 'P'),
(148964, 'Franklinville', 42.3369407653809, 0.738919011577704, -78.4583282470703, -1.36935615352185, 218, 40, 'PPL', 'P'),
(161843, 'Franklinville', 40.0105590820313, 0.698315991545165, -75.1355590820313, -1.31136289130817, 218, 45, 'PPL', 'P'),
(54850, 'Franks', 37.9527816772461, 0.66240100055852, -92.0366668701172, -1.60634286944473, 218, 29, 'PPL', 'P'),
(75877, 'Franks', 34.6063919067383, 0.603995481008101, -96.6425018310547, -1.68672985431655, 218, 42, 'PPL', 'P'),
(119699, 'Franks', 41.7108306884766, 0.727991329255809, -88.6797180175781, -1.54775305914688, 218, 18, 'PPL', 'P'),
(155347, 'Franks Corner', 41.2374992370605, 0.719730136975356, -81.9541702270508, -1.43037010620194, 218, 41, 'PPL', 'P'),
(161844, 'Franks Corner', 40.7036094665527, 0.710412002637278, -75.418327331543, -1.31629812828225, 218, 45, 'PPL', 'P'),
(101, 'Franks Mill', 38.2219390869141, 0.667098683563365, -79.1072235107422, -1.38068151237352, 218, 53, 'PPL', 'P'),
(188570, 'Franks Place', 33.4063911437988, 0.583051516668364, -107.803062438965, -1.88151838329297, 218, 38, 'PPL', 'P'),
(94325, 'Frankston', 32.0525016784668, 0.559421687790254, -95.5061111450195, -1.66689609525624, 218, 51, 'PPL', 'P'),
(59973, 'Frankstown', 34.5763893127441, 0.603471836958765, -88.6297225952148, -1.54688047441571, 218, 30, 'PPL', 'P'),
(161845, 'Frankstown', 40.4438896179199, 0.705879036145854, -78.3550033569336, -1.3675527939897, 218, 45, 'PPL', 'P'),
(174183, 'Franksville', 42.7599983215332, 0.746302758858003, -87.913330078125, -1.53437706625584, 218, 57, 'PPL', 'P'),
(122655, 'Frankton', 40.2227783203125, 0.702019915989248, -85.7788925170898, -1.49712410313754, 218, 19, 'PPL', 'P'),
(102110, 'Franktown', 37.4786109924316, 0.654125160892072, -75.8791732788086, -1.32434140740651, 218, 53, 'PPL', 'P'),
(186731, 'Franktown', 39.3913917541504, 0.687509483052869, -104.752220153809, -1.82827114045792, 218, 7, 'PPL', 'P'),
(190216, 'Franktown', 39.271671295166, 0.685419966861593, -119.839721679688, -2.09159771798418, 218, 39, 'PPL', 'P'),
(2599, 'Frankville', 31.646390914917, 0.552333717838522, -88.1474990844727, -1.53846408642274, 218, 2, 'PPL', 'P'),
(54851, 'Frankville', 36.6972198486328, 0.640487312686858, -91.8055572509766, -1.6023092456577, 218, 29, 'PPL', 'P'),
(115634, 'Frankville', 43.1891708374023, 0.753793232318987, -91.6172180175781, -1.59902210592421, 218, 16, 'PPL', 'P'),
(209466, 'Frannie', 44.9691696166992, 0.784860071699198, -108.620826721191, -1.89579106252303, 218, 59, 'PPL', 'P'),
(27210, 'Fransonia (historical)', 38.6455612182617, 0.674492284539698, -88.1580581665039, -1.53864837717017, 218, 18, 'PPL', 'P'),
(32484, 'Frantz (historical)', 38.5513916015625, 0.672848714672956, -98.2380599975586, -1.71457759772913, 218, 20, 'PPL', 'P'),
(16138, 'Franwood Pines', 26.4633293151855, 0.461872227589524, -80.1172180175781, -1.39830924194486, 218, 12, 'PPL', 'P'),
(115636, 'Fraser', 42.1272201538086, 0.735258696396472, -93.9647216796875, -1.63999377403064, 218, 16, 'PPL', 'P'),
(130886, 'Fraser', 42.5391693115234, 0.742448565549413, -82.9494400024414, -1.4477408407281, 218, 27, 'PPL', 'P'),
(148967, 'Fraser', 42.9144401550293, 0.748998277355327, -77.8713912963867, -1.3591121712308, 218, 40, 'PPL', 'P'),
(186732, 'Fraser', 39.9449996948242, 0.697171764382813, -105.816673278809, -1.84684935222231, 218, 7, 'PPL', 'P'),
(194952, 'Fraser', 46.3911094665527, 0.809677603844455, -116.137496948242, -2.02698170677169, 218, 17, 'PPL', 'P'),
(13801, 'Frasers Corner', 39.579719543457, 0.690796423049272, -75.7666702270508, -1.3223778587348, 218, 10, 'PPL', 'P'),
(81121, 'Fraserville', 33.4427795410156, 0.583686614009321, -79.1313934326172, -1.38110335709019, 218, 48, 'PPL', 'P'),
(87133, 'Fraterville', 36.1966705322266, 0.631751079046962, -84.1722183227539, -1.46908234843955, 218, 50, 'PPL', 'P'),
(94326, 'Fratt', 29.517219543457, 0.515172667067343, -98.3966674804688, -1.71734582052421, 218, 51, 'PPL', 'P'),
(119700, 'Fravert', 40.4488906860352, 0.705966321250581, -89.3705596923828, -1.55981052098221, 218, 18, 'PPL', 'P'),
(102111, 'Frays Mountain Estates', 38.1866683959961, 0.666483093877394, -78.4847183227539, -1.36981674723238, 218, 53, 'PPL', 'P'),
(87134, 'Frayser', 35.2174987792969, 0.614661308015814, -90.0033264160156, -1.57085438370666, 218, 50, 'PPL', 'P'),
(135462, 'Frazee', 46.7280616760254, 0.815558529321623, -95.7005615234375, -1.67028989459138, 218, 28, 'PPL', 'P'),
(35988, 'Frazer', 36.9563903808594, 0.645010691798357, -84.7050018310547, -1.47838117485973, 218, 21, 'PPL', 'P'),
(161847, 'Frazer', 40.0322189331055, 0.698694027261902, -75.5563888549805, -1.31870775643656, 218, 45, 'PPL', 'P'),
(209877, 'Frazer', 48.0591697692871, 0.838790748248984, -106.04167175293, -1.85077631640769, 218, 31, 'PPL', 'P'),
(174185, 'Frazer Corners', 44.6744384765625, 0.779716042895655, -88.3622207641602, -1.54221168670869, 218, 57, 'PPL', 'P'),
(21296, 'Frazers Crossing', 31.2986106872559, 0.5462638077925, -81.567497253418, -1.42362138968358, 218, 13, 'PPL', 'P'),
(155348, 'Frazeysburg', 40.1172218322754, 0.700177607726158, -82.1194381713867, -1.43325457597861, 218, 41, 'PPL', 'P'),
(21292, 'Frazier', 34.2191696166992, 0.597237177109807, -83.8580627441406, -1.46359929922925, 218, 13, 'PPL', 'P'),
(54852, 'Frazier', 39.6288909912109, 0.69165462671055, -94.6675033569336, -1.65225962822128, 218, 29, 'PPL', 'P'),
(59972, 'Frazier', 33.5669403076172, 0.585853628188318, -90.7319412231445, -1.58357111106984, 218, 30, 'PPL', 'P'),
(72604, 'Frazier', 39.8791694641113, 0.696022810109525, -81.978889465332, -1.43080153829854, 218, 41, 'PPL', 'P'),
(109275, 'Frazier', 37.7411117553711, 0.658706663494362, -80.5630569458008, -1.40609059917591, 218, 58, 'PPL', 'P'),
(188571, 'Frazier (historical)', 33.5977783203125, 0.586391853044623, -104.331939697266, -1.82093586270946, 218, 38, 'PPL', 'P'),
(193573, 'Frazier Corners', 40.6375007629395, 0.709258188095001, -122.235557556152, -2.13341294236589, 218, 6, 'PPL', 'P'),
(751, 'Frazier Crossroads', 35.8758316040039, 0.626151383380907, -78.1372222900391, -1.36375179732389, 218, 33, 'PPL', 'P'),
(81122, 'Frazier Hill', 33.2041702270508, 0.579522095854709, -80.0299987792969, -1.39678697906577, 218, 48, 'PPL', 'P'),
(161849, 'Frazier Mill', 40.753059387207, 0.711275066567545, -79.8547210693359, -1.3937278059216, 218, 45, 'PPL', 'P'),
(181681, 'Frazier Park', 34.8227806091309, 0.60777217632897, -118.943893432617, -2.07596256554043, 218, 6, 'PPL', 'P'),
(178224, 'Frazier Wells', 35.7825012207031, 0.62452246090016, -113.071388244629, -1.97346801466959, 218, 5, 'PPL', 'P'),
(190217, 'Frazier Wells (historical)', 38.1602783203125, 0.666022500166864, -117.234443664551, -2.04612703869022, 218, 39, 'PPL', 'P'),
(109276, 'Fraziers Bottom', 38.5702781677246, 0.67317834743688, -81.9908294677734, -1.43100993065384, 218, 58, 'PPL', 'P'),
(64900, 'Fraziers Crossroads', 36.3063888549805, 0.633666025028783, -77.0252838134766, -1.34434480982826, 218, 33, 'PPL', 'P'),
(181682, 'Fraziers Landing', 39.0050010681152, 0.680765693382516, -121.818061828613, -2.12612626730733, 218, 6, 'PPL', 'P'),
(35989, 'Fraziertown', 38.3138885498047, 0.668703504436247, -85.5044403076172, -1.49233400844287, 218, 21, 'PPL', 'P'),
(148968, 'Frear Park', 42.7447204589844, 0.746036109853859, -73.6738891601563, -1.28585193859409, 218, 40, 'PPL', 'P'),
(8985, 'Freck', 36.1072196960449, 0.63018986743693, -92.6999969482422, -1.61792016333552, 218, 4, 'PPL', 'P'),
(40994, 'Fred', 30.648609161377, 0.534919141022926, -91.1052780151367, -1.59008706730894, 218, 22, 'PPL', 'P'),
(94327, 'Fred', 30.5763893127441, 0.533658666878991, -94.1761093139648, -1.64368318424678, 218, 51, 'PPL', 'P'),
(94328, 'Fred Adams Colonia', 26.2029991149902, 0.45732860845374, -97.7279968261719, -1.70567531599527, 218, 51, 'PPL', 'P'),
(130889, 'Freda', 47.1352806091309, 0.822665840480772, -88.8186111450195, -1.55017720152912, 218, 27, 'PPL', 'P'),
(181683, 'Freda', 34.1022186279297, 0.595195997292316, -114.909721374512, -2.00555298053453, 218, 6, 'PPL', 'P'),
(198308, 'Freda', 46.3472213745117, 0.808911612135921, -101.173332214355, -1.76580776235455, 218, 34, 'PPL', 'P'),
(181684, 'Fredalba', 34.2016716003418, 0.596931779111803, -117.131393432617, -2.04432847284803, 218, 6, 'PPL', 'P'),
(135464, 'Fredenberg', 46.9738883972168, 0.819849014995795, -92.2169418334961, -1.6094892611146, 218, 28, 'PPL', 'P'),
(115662, 'Frederic', 41.0908317565918, 0.717170306535572, -92.6780624389648, -1.61753733392882, 218, 16, 'PPL', 'P'),
(130890, 'Frederic', 44.7786102294922, 0.781534182971852, -84.7544403076172, -1.47924403905292, 218, 27, 'PPL', 'P'),
(174186, 'Frederic', 45.6591682434082, 0.796902819569509, -92.4669418334961, -1.61385258424459, 218, 57, 'PPL', 'P'),
(13802, 'Frederica', 39.0088882446289, 0.680833537411286, -75.4661102294922, -1.31713209717761, 218, 10, 'PPL', 'P'),
(32485, 'Frederick', 38.5133285522461, 0.672184389139035, -98.2680587768555, -1.71510117519944, 218, 20, 'PPL', 'P'),
(47261, 'Frederick', 39.4141693115234, 0.687907026424591, -77.4108276367188, -1.35107381895456, 218, 25, 'PPL', 'P'),
(72606, 'Frederick', 38.8111114501953, 0.677381681164379, -82.7777786254883, -1.44474478450176, 218, 41, 'PPL', 'P'),
(75878, 'Frederick', 34.3919410705566, 0.600252607833077, -99.0180587768555, -1.7281911445894, 218, 42, 'PPL', 'P'),
(119701, 'Frederick', 40.0699996948242, 0.699353425947806, -90.4288864135742, -1.57828180682884, 218, 18, 'PPL', 'P'),
(161850, 'Frederick', 40.3027801513672, 0.703416211348776, -75.5297164916992, -1.31824223587801, 218, 45, 'PPL', 'P'),
(170333, 'Frederick', 45.8325004577637, 0.799928037409784, -98.5058288574219, -1.71925104596806, 218, 49, 'PPL', 'P'),
(194192, 'Frederick', 40.0991706848145, 0.699862555769202, -104.936668395996, -1.83149036958361, 218, 7, 'PPL', 'P'),
(47262, 'Frederick (historical)', 39.5491714477539, 0.690263258199038, -77.2072219848633, -1.34752022995402, 218, 25, 'PPL', 'P'),
(13803, 'Frederick Acres', 38.5999984741211, 0.6736970646382, -75.5119400024414, -1.31793197761102, 218, 10, 'PPL', 'P'),
(124892, 'Frederick Corner', 42.6483306884766, 0.744353790993256, -71.4749984741211, -1.24747405623134, 218, 23, 'PPL', 'P'),
(47264, 'Frederick Douglass Homes', 39.2938919067383, 0.685807789695336, -76.5966720581055, -1.33686412348428, 218, 25, 'PPL', 'P'),
(102113, 'Frederick Heights', 39.1719398498535, 0.683679324773117, -78.1283264160156, -1.36359653503233, 218, 53, 'PPL', 'P'),
(47266, 'Frederick Junction', 39.3716697692871, 0.687165269481976, -77.3886108398438, -1.35068606269985, 218, 25, 'PPL', 'P'),
(47268, 'Frederick Village', 39.267219543457, 0.68534226913679, -76.7694396972656, -1.33987948762852, 218, 25, 'PPL', 'P'),
(47269, 'Frederick Villas', 39.3861083984375, 0.687417271100125, -77.4219436645508, -1.35126783023998, 218, 25, 'PPL', 'P'),
(181686, 'Fredericks', 38.3736114501953, 0.669745865686904, -122.793609619141, -2.14315278826258, 218, 6, 'PPL', 'P'),
(29848, 'Fredericksburg', 38.4330596923828, 0.670783433247599, -86.1897201538086, -1.50429439805647, 218, 19, 'PPL', 'P'),
(54853, 'Fredericksburg', 38.6074981689453, 0.673827959005778, -91.6413879394531, -1.59944395064088, 218, 29, 'PPL', 'P'),
(94329, 'Fredericksburg', 30.2749996185303, 0.528398424383381, -98.8716735839844, -1.72563624099763, 218, 51, 'PPL', 'P'),
(102115, 'Fredericksburg', 37.8927803039551, 0.661353779038874, -79.4380569458008, -1.38645564509097, 218, 53, 'PPL', 'P'),
(115637, 'Fredericksburg', 42.9652786254883, 0.749885576051514, -92.1994400024414, -1.60918379653757, 218, 16, 'PPL', 'P'),
(155351, 'Fredericksburg', 40.6766700744629, 0.709941821546825, -81.8705596923828, -1.42891082708264, 218, 41, 'PPL', 'P'),
(161854, 'Fredericksburg', 40.4436111450195, 0.705874175876865, -76.4286117553711, -1.33393091785967, 218, 45, 'PPL', 'P'),
(181687, 'Fredericksburg', 38.8288917541504, 0.677692006010401, -119.785827636719, -2.09065708948716, 218, 6, 'PPL', 'P'),
(40995, 'Fredericksburg (historical)', 32.0227813720703, 0.558902970588934, -91.9763870239258, -1.60529078765609, 218, 22, 'PPL', 'P'),
(72609, 'Fredericksdale', 39.8030586242676, 0.694694425357794, -81.4269409179688, -1.42116821884545, 218, 41, 'PPL', 'P'),
(207462, 'Frederickson', 47.0963897705078, 0.821987067297938, -122.357498168945, -2.13554120755103, 218, 56, 'PPL', 'P'),
(161855, 'Fredericksville', 40.4530601501465, 0.706039092127368, -75.6894378662109, -1.32102989974905, 218, 45, 'PPL', 'P'),
(35990, 'Fredericktown', 37.7588882446289, 0.659016921761357, -85.3419418334961, -1.48949787503999, 218, 21, 'PPL', 'P'),
(47270, 'Fredericktown', 39.3661117553711, 0.68706826383927, -75.8841705322266, -1.32442862593221, 218, 25, 'PPL', 'P'),
(54854, 'Fredericktown', 37.5597190856934, 0.655540764169503, -90.2938919067383, -1.57592570821244, 218, 29, 'PPL', 'P'),
(155353, 'Fredericktown', 40.4811096191406, 0.706528647714752, -82.5408325195313, -1.44060929480303, 218, 41, 'PPL', 'P'),
(161856, 'Fredericktown', 40.002498626709, 0.698175310060582, -79.9983291625977, -1.39623423998153, 218, 45, 'PPL', 'P'),
(161857, 'Fredericktown Hill', 40.0013885498047, 0.698155935563652, -80.001106262207, -1.39628270951337, 218, 45, 'PPL', 'P'),
(115639, 'Frederika', 42.8816719055176, 0.748426363511232, -92.3080596923828, -1.61107956775954, 218, 16, 'PPL', 'P'),
(145268, 'Fredon', 41.0391693115234, 0.716268626769498, -74.8091735839844, -1.30566638973649, 218, 37, 'PPL', 'P'),
(2600, 'Fredonia', 32.9897193908691, 0.575779222679685, -85.2886123657227, -1.48856710023901, 218, 2, 'PPL', 'P'),
(21293, 'Fredonia', 30.9125003814697, 0.53952491168065, -83.9466705322266, -1.46514579687425, 218, 13, 'PPL', 'P'),
(27211, 'Fredonia', 37.7708282470703, 0.659225314116655, -89.1194381713867, -1.55542762361821, 218, 18, 'PPL', 'P'),
(29849, 'Fredonia', 38.1780586242676, 0.666332825012886, -86.383056640625, -1.50766875631566, 218, 19, 'PPL', 'P'),
(32486, 'Fredonia', 37.5338897705078, 0.65508995757598, -95.8263931274414, -1.67248607038432, 218, 20, 'PPL', 'P'),
(35992, 'Fredonia', 37.2080612182617, 0.64940317654228, -88.0566711425781, -1.53687883978387, 218, 21, 'PPL', 'P'),
(81123, 'Fredonia', 33.9272193908691, 0.592141684417132, -81.4622192382813, -1.42178394168947, 218, 48, 'PPL', 'P'),
(87138, 'Fredonia', 35.399169921875, 0.617832067609663, -85.4322204589844, -1.49107353429894, 218, 50, 'PPL', 'P'),
(94331, 'Fredonia', 30.9319400787354, 0.539864198403526, -99.1130599975586, -1.72984922868408, 218, 51, 'PPL', 'P'),
(115641, 'Fredonia', 41.2847213745117, 0.720554318753708, -91.3386077880859, -1.59415944008983, 218, 16, 'PPL', 'P'),
(140048, 'Fredonia', 46.3288917541504, 0.808591699909976, -99.0952835083008, -1.72953897041709, 218, 34, 'PPL', 'P'),
(148969, 'Fredonia', 42.439998626709, 0.740717710577944, -79.3319396972656, -1.38460354971088, 218, 40, 'PPL', 'P'),
(155355, 'Fredonia', 40.1519393920898, 0.700783543453178, -82.5199966430664, -1.44024564015618, 218, 41, 'PPL', 'P'),
(161858, 'Fredonia', 41.3216705322266, 0.721199203211671, -80.2588882446289, -1.40078185385895, 218, 45, 'PPL', 'P'),
(174188, 'Fredonia', 43.4705581665039, 0.758704367685203, -87.9505615234375, -1.53502687756182, 218, 57, 'PPL', 'P'),
(178225, 'Fredonia', 36.9455604553223, 0.644821673939989, -112.525833129883, -1.96394628166617, 218, 5, 'PPL', 'P'),
(207463, 'Fredonia', 48.4463882446289, 0.845548985568251, -122.442779541016, -2.13702964828427, 218, 56, 'PPL', 'P'),
(27212, 'Fredonia (historical)', 37.7677803039551, 0.659172117473881, -89.1188888549805, -1.55541803623829, 218, 18, 'PPL', 'P'),
(94332, 'Fredonia Hill', 31.5922203063965, 0.55138826236203, -94.664436340332, -1.65220609868337, 218, 51, 'PPL', 'P'),
(13805, 'Fredrick Lodge Mobile Home Park', 39.3555603027344, 0.686884106249891, -75.6463928222656, -1.32027862200554, 218, 10, 'PPL', 'P'),
(196534, 'Fredrickson (historical)', 46.2383308410645, 0.807011113803014, -112.824996948242, -1.96916767529938, 218, 31, 'PPL', 'P'),
(196535, 'Freds Trailer Court', 48.0355606079102, 0.838378690649321, -111.839172363281, -1.95196179044471, 218, 31, 'PPL', 'P'),
(115643, 'Fredsville', 42.4841690063477, 0.741488629134494, -92.5738906860352, -1.61571919385263, 218, 16, 'PPL', 'P'),
(35991, 'Fredville', 37.605281829834, 0.656335984071001, -82.9647216796875, -1.44800755631127, 218, 21, 'PPL', 'P'),
(54855, 'Fredville', 36.9094390869141, 0.64419123713094, -94.4124984741211, -1.64780895340754, 218, 29, 'PPL', 'P'),
(122650, 'Free', 40.6216697692871, 0.708981885131905, -87.4572219848633, -1.52641647828343, 218, 19, 'PPL', 'P'),
(145270, 'Free Acres', 40.6605606079102, 0.709660658314739, -74.4441680908203, -1.29929584209292, 218, 37, 'PPL', 'P'),
(87139, 'Free Communion', 36.4819412231445, 0.636729991862919, -85.2727813720703, -1.48829079727591, 218, 50, 'PPL', 'P'),
(196536, 'Free Deal (historical)', 48.038890838623, 0.838436814140112, -106.438888549805, -1.85770905735738, 218, 31, 'PPL', 'P'),
(47272, 'Free Farms', 39.5916709899902, 0.691005015141653, -77.4030609130859, -1.35093826405508, 218, 25, 'PPL', 'P'),
(87140, 'Free Hill', 36.5663909912109, 0.638203918368224, -85.4908294677734, -1.49209645447364, 218, 50, 'PPL', 'P'),
(21294, 'Free Home', 34.2386093139648, 0.597576463832683, -84.2888870239258, -1.47111860140903, 218, 13, 'PPL', 'P'),
(8986, 'Free Hope', 33.2916717529297, 0.581049285581815, -93.1638870239258, -1.62601657252353, 218, 4, 'PPL', 'P'),
(59976, 'Free Run', 32.9519386291504, 0.575119823993781, -90.274169921875, -1.57558149464155, 218, 30, 'PPL', 'P'),
(102120, 'Free Shade Corner', 37.5602798461914, 0.655550551286509, -76.4505615234375, -1.33431401358248, 218, 53, 'PPL', 'P'),
(130893, 'Free Soil', 44.1069412231445, 0.769811347327487, -86.216667175293, -1.50476471230498, 218, 27, 'PPL', 'P'),
(59974, 'Free Springs', 34.5255584716797, 0.602584671420632, -89.6500015258789, -1.56468770104453, 218, 30, 'PPL', 'P'),
(40996, 'Free Town', 30.0397205352783, 0.52429202971956, -90.8536071777344, -1.58569458256502, 218, 22, 'PPL', 'P'),
(59975, 'Free Trade', 32.6961097717285, 0.570654768110154, -89.4150009155273, -1.5605861666497, 218, 30, 'PPL', 'P'),
(35995, 'Free Union', 37.5252799987793, 0.654939688711472, -87.7541732788086, -1.53159925608084, 218, 21, 'PPL', 'P'),
(102117, 'Free Union', 38.1547203063965, 0.665925494524158, -78.5647201538086, -1.37121304259191, 218, 53, 'PPL', 'P'),
(135466, 'Freeborn', 43.7658309936523, 0.763857850710615, -93.5638885498047, -1.63299791616311, 218, 28, 'PPL', 'P'),
(27213, 'Freeburg', 38.4275016784668, 0.670686427604893, -89.9136123657227, -1.56928857814375, 218, 18, 'PPL', 'P'),
(54857, 'Freeburg', 38.314998626709, 0.668722878933178, -91.9225006103516, -1.60435029231713, 218, 29, 'PPL', 'P'),
(135470, 'Freeburg', 43.6111106872559, 0.761157471944302, -91.3641662597656, -1.59460551957242, 218, 28, 'PPL', 'P'),
(155356, 'Freeburg', 40.833610534668, 0.712680949306998, -81.1483306884766, -1.41630555301107, 218, 41, 'PPL', 'P'),
(161860, 'Freeburg', 40.7630615234375, 0.711449636777, -76.9397201538086, -1.342851442247, 218, 45, 'PPL', 'P'),
(35993, 'Freeburn', 37.5644416809082, 0.655623189005241, -82.1419372558594, -1.43364725908134, 218, 21, 'PPL', 'P'),
(109277, 'Freed', 39.0108299255371, 0.680867426136157, -81.1380615234375, -1.41612632226971, 218, 58, 'PPL', 'P'),
(135471, 'Freedhem', 46.0563888549805, 0.80383562709823, -94.2083282470703, -1.64424551071096, 218, 28, 'PPL', 'P'),
(172033, 'Freedleyville', 43.2574996948242, 0.754985795855125, -73.0083312988281, -1.27423576255138, 218, 55, 'PPL', 'P'),
(81124, 'Freedman', 32.5363883972168, 0.567867104239114, -80.2949981689453, -1.40141209093091, 218, 48, 'PPL', 'P'),
(29850, 'Freedom', 39.2069396972656, 0.684290187348154, -86.8691711425781, -1.51615305491643, 218, 19, 'PPL', 'P'),
(35994, 'Freedom', 36.922779083252, 0.64442406398924, -85.1055603027344, -1.4853722390373, 218, 21, 'PPL', 'P'),
(47273, 'Freedom', 39.4094390869141, 0.687824468430798, -76.9725036621094, -1.3434236224072, 218, 25, 'PPL', 'P'),
(54859, 'Freedom', 38.4636116027832, 0.67131666467686, -91.690559387207, -1.60030215430216, 218, 29, 'PPL', 'P'),
(75879, 'Freedom', 36.7688903808594, 0.641738199450868, -99.1125030517578, -1.7298395081461, 218, 42, 'PPL', 'P'),
(127526, 'Freedom', 44.5302810668945, 0.777200021455803, -69.2983322143555, -1.20948406328136, 218, 26, 'PPL', 'P'),
(130895, 'Freedom', 45.7361106872559, 0.798245718549181, -84.64111328125, -1.47726610931131, 218, 27, 'PPL', 'P'),
(143845, 'Freedom', 43.8122215270996, 0.764667518261026, -71.0361099243164, -1.23981400598794, 218, 36, 'PPL', 'P'),
(148970, 'Freedom', 42.4847183227539, 0.741498216514419, -78.3313903808594, -1.36714066981101, 218, 40, 'PPL', 'P'),
(155357, 'Freedom', 41.2361106872559, 0.719705902209436, -81.149169921875, -1.41632020039707, 218, 41, 'PPL', 'P'),
(161862, 'Freedom', 40.6855583190918, 0.710096950680322, -80.2519378662109, -1.40066054687129, 218, 45, 'PPL', 'P'),
(174191, 'Freedom', 44.3863906860352, 0.774688660547858, -88.2886123657227, -1.54092697779884, 218, 57, 'PPL', 'P'),
(181688, 'Freedom', 36.9352798461914, 0.644642243461545, -121.771942138672, -2.12532132686785, 218, 6, 'PPL', 'P'),
(192575, 'Freedom', 39.5424995422363, 0.690146811480374, -111.648612976074, -1.94863590171736, 218, 52, 'PPL', 'P'),
(194953, 'Freedom', 42.982780456543, 0.750191040628546, -111.043060302734, -1.93806701377333, 218, 17, 'PPL', 'P'),
(199323, 'Freedom', 40.4244384765625, 0.705539549685896, -100.36888885498, -1.75176757708765, 218, 35, 'PPL', 'P'),
(207464, 'Freedom', 47.3763885498047, 0.826873967898233, -117.38166809082, -2.04869658966798, 218, 56, 'PPL', 'P'),
(155358, 'Freedom (historical)', 41.4277801513672, 0.723051165433712, -84.5555572509766, -1.47577287488811, 218, 41, 'PPL', 'P'),
(196537, 'Freedom (historical)', 47.1800003051758, 0.823446346417247, -106.890281677246, -1.86558735365211, 218, 31, 'PPL', 'P'),
(178226, 'Freedom Acres', 34.3172187805176, 0.598948457847265, -111.29972076416, -1.94254658388489, 218, 5, 'PPL', 'P'),
(204028, 'Freedom Acres', 41.2616691589355, 0.720151981692025, -112.092216491699, -1.95637824363844, 218, 52, 'PPL', 'P'),
(119703, 'Freedom Centre (historical)', 41.4844398498535, 0.724040063725486, -88.8805618286133, -1.55125844493169, 218, 18, 'PPL', 'P'),
(155359, 'Freedom Dam', 41.2444381713867, 0.719851244225928, -81.2850036621094, -1.41869094639946, 218, 41, 'PPL', 'P'),
(47275, 'Freedom Forest', 39.2063903808594, 0.68428059996823, -77.2261123657227, -1.34784992929697, 218, 25, 'PPL', 'P'),
(148971, 'Freedom Plains', 41.6725006103516, 0.727322343189981, -73.8000030517578, -1.28805304123504, 218, 40, 'PPL', 'P'),
(155360, 'Freedom Station', 41.2055587768555, 0.719172670780175, -81.1477813720703, -1.41629596563115, 218, 41, 'PPL', 'P'),
(47277, 'Freedom Village', 38.6136093139648, 0.673934618607435, -77.0377807617188, -1.34456292272154, 218, 25, 'PPL', 'P'),
(119706, 'Freedville', 40.8608283996582, 0.713155990666441, -87.7430572509766, -1.53140524479543, 218, 18, 'PPL', 'P'),
(145271, 'Freehold', 40.2599983215332, 0.702669527558145, -74.274169921875, -1.29632881432246, 218, 37, 'PPL', 'P'),
(148972, 'Freehold', 42.3591690063477, 0.739306967569501, -74.0502777099609, -1.29242115805498, 218, 40, 'PPL', 'P'),
(40997, 'Freeland', 30.7780609130859, 0.537178500312722, -91.2669372558594, -1.59290855332582, 218, 22, 'PPL', 'P'),
(47278, 'Freeland', 39.704719543457, 0.692978084614265, -76.6841735839844, -1.33839131321139, 218, 25, 'PPL', 'P'),
(64901, 'Freeland', 34.1069412231445, 0.595278422128054, -78.5374984741211, -1.37073793465344, 218, 33, 'PPL', 'P'),
(72608, 'Freeland', 39.8811111450195, 0.696056698834397, -81.7755584716797, -1.42725274298795, 218, 41, 'PPL', 'P'),
(87141, 'Freeland', 36.4991683959961, 0.637030662749989, -88.1941680908203, -1.53927861424214, 218, 50, 'PPL', 'P'),
(94333, 'Freeland', 32.1969413757324, 0.561942636078123, -97.5661087036133, -1.70284983523675, 218, 51, 'PPL', 'P'),
(130897, 'Freeland', 43.5250015258789, 0.759654583562143, -84.1227798461914, -1.46821948424637, 218, 27, 'PPL', 'P'),
(161866, 'Freeland', 41.0166702270508, 0.715875943666766, -75.8974990844727, -1.32466125305343, 218, 45, 'PPL', 'P'),
(186733, 'Freeland', 39.7441711425781, 0.693666644914105, -105.595001220703, -1.8429804449487, 218, 7, 'PPL', 'P'),
(207466, 'Freeland', 48.0097198486328, 0.837927684318716, -122.524719238281, -2.13845976578965, 218, 56, 'PPL', 'P'),
(47279, 'Freeland Farms', 39.709171295166, 0.693055782339068, -76.7055587768555, -1.33876455523816, 218, 25, 'PPL', 'P'),
(122651, 'Freeland Park', 40.6144409179688, 0.708855717875263, -87.4911117553711, -1.52700796636154, 218, 19, 'PPL', 'P'),
(29851, 'Freelandville', 38.8647193908691, 0.678317316234352, -87.3058319091797, -1.52377422300791, 218, 19, 'PPL', 'P'),
(102118, 'Freeling', 37.1741714477539, 0.648811688464173, -82.4861068725586, -1.43965415207807, 218, 53, 'PPL', 'P'),
(21295, 'Freeman', 31.360559463501, 0.547345017905559, -85.0627822875977, -1.48462562182569, 218, 13, 'PPL', 'P'),
(29852, 'Freeman', 39.1952781677246, 0.684086655261845, -86.7336120605469, -1.51378710260401, 218, 19, 'PPL', 'P'),
(54861, 'Freeman', 38.6183280944824, 0.674016976864146, -94.504997253418, -1.64942336166034, 218, 29, 'PPL', 'P'),
(64902, 'Freeman', 34.3169403076172, 0.598943597578276, -78.2844390869141, -1.36632121514359, 218, 33, 'PPL', 'P'),
(102119, 'Freeman', 36.7547187805176, 0.641490858364627, -77.6936111450195, -1.35600932224475, 218, 53, 'PPL', 'P'),
(109280, 'Freeman', 38.917781829834, 0.679243430503427, -80.32861328125, -1.40199878531906, 218, 58, 'PPL', 'P'),
(115646, 'Freeman', 43.2130584716797, 0.754210150187639, -93.1997222900391, -1.62664201590553, 218, 16, 'PPL', 'P'),
(119707, 'Freeman', 42.1247215270996, 0.735215087133622, -88.3883285522461, -1.54266735357121, 218, 18, 'PPL', 'P'),
(135474, 'Freeman', 47.8194389343262, 0.83460665586036, -96.7605590820313, -1.68879034205195, 218, 28, 'PPL', 'P'),
(148973, 'Freeman', 42.0555610656738, 0.734008009369543, -77.2727813720703, -1.34866445711637, 218, 40, 'PPL', 'P'),
(161868, 'Freeman', 41.690559387207, 0.727637528304992, -78.6524963378906, -1.37274502600897, 218, 45, 'PPL', 'P'),
(170338, 'Freeman', 43.3525009155273, 0.756643879949808, -97.4369430541992, -1.700595469374, 218, 49, 'PPL', 'P'),
(174195, 'Freeman', 45.3497200012207, 0.791501928878828, -88.8288879394531, -1.55035656542854, 218, 57, 'PPL', 'P'),
(178227, 'Freeman', 32.8458290100098, 0.57326786177174, -112.295829772949, -1.95993196579704, 218, 5, 'PPL', 'P'),
(207465, 'Freeman', 47.5183296203613, 0.829351306923252, -117.194717407227, -2.04543368470042, 218, 56, 'PPL', 'P'),
(8989, 'Freeman (historical)', 36.4097213745117, 0.635469517718985, -93.5730590820313, -1.63315797214463, 218, 4, 'PPL', 'P'),
(2601, 'Freeman Acres', 34.7827796936035, 0.607074028649206, -87.3461074829102, -1.52447716437764, 218, 2, 'PPL', 'P'),
(13806, 'Freeman Corner', 38.8866691589355, 0.678700411957159, -75.4574966430664, -1.31698176173408, 218, 10, 'PPL', 'P'),
(124893, 'Freeman Knoll', 42.1980590820313, 0.736495068932541, -72.5500030517578, -1.26623642558511, 218, 23, 'PPL', 'P'),
(130898, 'Freeman Landing', 46.6188888549805, 0.813653104140698, -87.4661102294922, -1.52657160741693, 218, 27, 'PPL', 'P'),
(64903, 'Freeman Mill', 35.938060760498, 0.627237487052468, -79.8905563354492, -1.3943532493036, 218, 33, 'PPL', 'P'),
(148974, 'Freeman Mill', 43.4608306884766, 0.75853459116571, -75.5788879394531, -1.31910043953929, 218, 40, 'PPL', 'P'),
(8990, 'Freeman Springs', 35.6616706848145, 0.622413570211953, -93.07861328125, -1.62452826494834, 218, 4, 'PPL', 'P'),
(27215, 'Freeman Spur', 37.8611106872559, 0.660801039954628, -88.9972229003906, -1.55329456474311, 218, 18, 'PPL', 'P'),
(21297, 'Freemans (historical)', 34.2344398498535, 0.597503692955897, -85.1061096191406, -1.48538182641722, 218, 13, 'PPL', 'P'),
(155364, 'Freemans Gardens', 41.6413917541504, 0.726779391222741, -83.607780456543, -1.45923104925124, 218, 41, 'PPL', 'P'),
(109281, 'Freemansburg', 39.0888900756836, 0.682229832770814, -80.529167175293, -1.4054991110978, 218, 58, 'PPL', 'P'),
(161876, 'Freemansburg', 40.6263885498047, 0.709064243388616, -75.3461074829102, -1.31503765413832, 218, 45, 'PPL', 'P'),
(2602, 'Freemanville', 31.0716705322266, 0.542302954882252, -87.5208282470703, -1.52752661698383, 218, 2, 'PPL', 'P'),
(161870, 'Freemanville', 40.2799987792969, 0.703018601398027, -75.938606262207, -1.3253787086511, 218, 45, 'PPL', 'P'),
(16141, 'Freemont', 30.6144409179688, 0.53432279267583, -84.4524993896484, -1.47397417588787, 218, 12, 'PPL', 'P'),
(35996, 'Freemont', 36.9727783203125, 0.645296715299432, -88.6119384765625, -1.54657008299066, 218, 21, 'PPL', 'P'),
(78304, 'Freemont', 39.7449989318848, 0.693681092563019, -76.0666732788086, -1.327613899754, 218, 45, 'PPL', 'P'),
(81125, 'Freemont', 33.9427795410156, 0.592413260269292, -78.7458267211914, -1.37437394848972, 218, 48, 'PPL', 'P'),
(87142, 'Freemont', 35.3613891601563, 0.617172668923759, -85.7350006103516, -1.49635804484998, 218, 50, 'PPL', 'P'),
(102121, 'Freemoor Estates', 37.1427803039551, 0.648263809648916, -76.408332824707, -1.3335769837508, 218, 53, 'PPL', 'P'),
(94334, 'Freemound', 33.5605583190918, 0.585742241475726, -97.4761123657227, -1.70127910282582, 218, 51, 'PPL', 'P'),
(32492, 'Freemount', 38.545280456543, 0.672742055071298, -97.7772216796875, -1.70653445176293, 218, 20, 'PPL', 'P'),
(27216, 'Freenanton (historical)', 39.0758285522461, 0.682001866181503, -88.6805572509766, -1.54776770653287, 218, 18, 'PPL', 'P'),
(94335, 'Freeneytown', 31.9513893127441, 0.557656944093913, -94.8680572509766, -1.65575995400002, 218, 51, 'PPL', 'P'),
(59977, 'Freeny', 32.7008285522461, 0.570737126366865, -89.4813919067383, -1.56174490803999, 218, 30, 'PPL', 'P'),
(16142, 'Freeport', 30.4980602264404, 0.532291566422913, -86.1361083984375, -1.50335869640747, 218, 12, 'PPL', 'P'),
(29854, 'Freeport', 39.6586112976074, 0.69217334391187, -85.725830078125, -1.49619798886847, 218, 19, 'PPL', 'P'),
(32493, 'Freeport', 37.1986083984375, 0.649238193712749, -97.8566665649414, -1.70792102658448, 218, 20, 'PPL', 'P'),
(94336, 'Freeport', 28.9538898468018, 0.505340709086447, -95.3594436645508, -1.66433626481646, 218, 51, 'PPL', 'P'),
(102122, 'Freeport', 37.5394401550293, 0.655186830060632, -76.5074996948242, -1.33530777214324, 218, 53, 'PPL', 'P'),
(109283, 'Freeport', 39.1427803039551, 0.683170394688803, -81.3377838134766, -1.41961213382052, 218, 58, 'PPL', 'P'),
(115648, 'Freeport', 43.3022193908691, 0.7557663017916, -91.7433319091797, -1.60122320856516, 218, 16, 'PPL', 'P'),
(119708, 'Freeport', 42.2966690063477, 0.738216136787005, -89.6211090087891, -1.56418343149212, 218, 18, 'PPL', 'P'),
(127528, 'Freeport', 43.8569412231445, 0.765448024197501, -70.1036071777344, -1.22353876277619, 218, 26, 'PPL', 'P'),
(130900, 'Freeport', 42.7661094665527, 0.746409418459661, -85.3133316040039, -1.4889985323356, 218, 27, 'PPL', 'P'),
(135476, 'Freeport', 45.6627807617188, 0.796965869908317, -94.6897201538086, -1.65264738447599, 218, 28, 'PPL', 'P'),
(148975, 'Freeport', 40.6575012207031, 0.709607261934883, -73.583610534668, -1.28427627933514, 218, 40, 'PPL', 'P'),
(155365, 'Freeport', 40.2105598449707, 0.701806663364959, -81.2663879394531, -1.41836604074647, 218, 41, 'PPL', 'P'),
(161872, 'Freeport', 42.2397193908691, 0.73722217848916, -79.8330612182617, -1.39334977020486, 218, 45, 'PPL', 'P'),
(181689, 'Freeport', 38.4619407653809, 0.671287503062924, -121.500556945801, -2.12058476171109, 218, 6, 'PPL', 'P'),
(161873, 'Freeport Mills', 40.401668548584, 0.705142139472229, -76.4138870239258, -1.33367392281448, 218, 45, 'PPL', 'P'),
(94337, 'Freer', 27.8824996948242, 0.486641423360997, -98.6175003051758, -1.72120008041183, 218, 51, 'PPL', 'P'),
(148976, 'Freer Corner', 42.4730606079102, 0.741294751007137, -75.2611083984375, -1.31355414025309, 218, 40, 'PPL', 'P'),
(94338, 'Freestone', 31.5422191619873, 0.550515577762325, -96.2477798461914, -1.67984065605068, 218, 51, 'PPL', 'P'),
(161875, 'Freestone', 40.0149993896484, 0.698393489532887, -77.8338928222656, -1.35845769939292, 218, 45, 'PPL', 'P'),
(181690, 'Freestone', 38.372501373291, 0.669726491189974, -122.914436340332, -2.14526161237176, 218, 6, 'PPL', 'P'),
(2604, 'Freetown', 32.3880615234375, 0.565278311922475, -87.5111083984375, -1.5273569736224, 218, 2, 'PPL', 'P'),
(29853, 'Freetown', 38.9730606079102, 0.680208227187335, -86.1294403076172, -1.50324231626784, 218, 19, 'PPL', 'P'),
(35997, 'Freetown', 36.6802787780762, 0.640191635226832, -85.7972183227539, -1.49744394878446, 218, 21, 'PPL', 'P'),
(41000, 'Freetown', 29.7838897705078, 0.51982694054642, -91.6661071777344, -1.59987538273747, 218, 22, 'PPL', 'P'),
(47286, 'Freetown', 39.1419410705566, 0.683155747302807, -76.5749969482422, -1.33648582145144, 218, 25, 'PPL', 'P'),
(102124, 'Freetown', 38.0483283996582, 0.664068605454101, -78.7125015258789, -1.37379231410765, 218, 53, 'PPL', 'P'),
(148977, 'Freetown', 40.9755592346191, 0.715158421490072, -72.1827774047852, -1.25982712894767, 218, 40, 'PPL', 'P'),
(21298, 'Freetown (historical)', 34.8133316040039, 0.607607260078467, -85.2416687011719, -1.48774777872965, 218, 13, 'PPL', 'P'),
(102123, 'Freetown (historical)', 37.3699989318848, 0.652229522828153, -77.1322174072266, -1.34621115312019, 218, 53, 'PPL', 'P'),
(148978, 'Freetown Corners', 42.5219383239746, 0.742147828083316, -76.0363922119141, -1.32708539543567, 218, 40, 'PPL', 'P'),
(47280, 'Freetown Village', 39.1358299255371, 0.68304908770115, -76.5777816772461, -1.33653442414133, 218, 25, 'PPL', 'P'),
(148980, 'Freeville', 42.5138893127441, 0.742007346335815, -76.3469390869141, -1.3325054608862, 218, 40, 'PPL', 'P'),
(87143, 'Freeway', 36.0833282470703, 0.629772882989251, -83.9419403076172, -1.46506323888046, 218, 50, 'PPL', 'P'),
(141849, 'Freeway Homes', 42.4472198486328, 0.740843744676532, -96.4341735839844, -1.68309384048027, 218, 35, 'PPL', 'P'),
(87145, 'Freewill', 36.2975006103516, 0.633510895895286, -85.5858306884766, -1.49375453856832, 218, 50, 'PPL', 'P'),
(64904, 'Freewood Acres', 35.8608283996582, 0.625889528066725, -80.3622207641602, -1.40258534654915, 218, 33, 'PPL', 'P'),
(145274, 'Freewood Acres', 40.1688919067383, 0.701079420650286, -74.2383270263672, -1.2957032377824, 218, 37, 'PPL', 'P'),
(59978, 'Freewoods', 31.3455600738525, 0.547083229170404, -91.0747222900391, -1.58955376930065, 218, 30, 'PPL', 'P'),
(194954, 'Freeze', 46.9619407653809, 0.819640489482442, -116.941673278809, -2.04101723150668, 218, 17, 'PPL', 'P'),
(109285, 'Freeze Fork', 37.8611106872559, 0.660801039954628, -81.9024963378906, -1.42946822669879, 218, 58, 'PPL', 'P'),
(190219, 'Freiburg (historical)', 37.9230613708496, 0.6618822833572, -115.583610534668, -2.01731456517276, 218, 39, 'PPL', 'P'),
(130901, 'Freidberger', 43.6233291625977, 0.76137072456859, -82.9175033569336, -1.44718344111194, 218, 27, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(94339, 'Freiheit', 29.7169399261475, 0.518658445328634, -98.0686111450195, -1.7116201573386, 218, 51, 'PPL', 'P'),
(135481, 'Freiheit Spring', 43.7058296203613, 0.762810629190969, -92.3172225952148, -1.611239490583, 218, 28, 'PPL', 'P'),
(174197, 'Freistadt', 43.2361106872559, 0.754612487249323, -88.0425033569336, -1.53663156527665, 218, 57, 'PPL', 'P'),
(54862, 'Freistatt', 37.0183296203613, 0.646091735463848, -93.8974990844727, -1.63882051841241, 218, 29, 'PPL', 'P'),
(41001, 'Frellsen', 29.9702796936035, 0.523080058396979, -90.2900009155273, -1.57585779760465, 218, 22, 'PPL', 'P'),
(94340, 'Frelsburg', 29.8708305358887, 0.52134434315652, -96.54638671875, -1.68505232914591, 218, 51, 'PPL', 'P'),
(2605, 'Fremont', 32.545280456543, 0.568022299951638, -86.8947219848633, -1.51659900124097, 218, 2, 'PPL', 'P'),
(54864, 'Fremont', 36.952220916748, 0.644937920921571, -91.1641693115234, -1.59111491433166, 218, 29, 'PPL', 'P'),
(64905, 'Fremont', 35.545280456543, 0.620382177511468, -77.9749984741211, -1.36092045761097, 218, 33, 'PPL', 'P'),
(87146, 'Fremont', 36.438060760498, 0.63596413331244, -89.1975021362305, -1.5567900968319, 218, 50, 'PPL', 'P'),
(102126, 'Fremont', 37.125560760498, 0.647963271919901, -82.3852767944336, -1.43789433522975, 218, 53, 'PPL', 'P'),
(115649, 'Fremont', 41.2125015258789, 0.719293844609774, -92.4352798461914, -1.6132999783184, 218, 16, 'PPL', 'P'),
(122652, 'Fremont', 41.7308311462402, 0.728340403095691, -84.9327774047852, -1.48235660857695, 218, 19, 'PPL', 'P'),
(130902, 'Fremont', 43.4674987792969, 0.758650971305346, -85.9419403076172, -1.49996982392035, 218, 27, 'PPL', 'P'),
(135478, 'Fremont', 43.913890838623, 0.766441982495346, -91.8988876342773, -1.60393816813844, 218, 28, 'PPL', 'P'),
(141850, 'Fremont', 41.4333305358887, 0.723148037918364, -96.4977798461914, -1.68420397918067, 218, 35, 'PPL', 'P'),
(143847, 'Fremont', 42.9908294677734, 0.750331522376048, -71.1430587768555, -1.24168061559598, 218, 36, 'PPL', 'P'),
(148981, 'Fremont', 42.3944396972656, 0.739922557255473, -77.6277770996094, -1.35486030139244, 218, 40, 'PPL', 'P'),
(155367, 'Fremont', 41.3502807617188, 0.721698545916061, -83.121940612793, -1.45075154434043, 218, 41, 'PPL', 'P'),
(174198, 'Fremont', 44.2597198486328, 0.772477837368929, -88.8647232055664, -1.55098200881054, 218, 57, 'PPL', 'P'),
(181693, 'Fremont', 38.6766700744629, 0.675035236506938, -121.633888244629, -2.1229118318716, 218, 6, 'PPL', 'P'),
(192574, 'Fremont', 38.4575004577637, 0.671210005075203, -111.61888885498, -1.94811711793701, 218, 52, 'PPL', 'P'),
(207467, 'Fremont', 47.6597213745117, 0.831819058568347, -122.355827331543, -2.13551204593709, 218, 56, 'PPL', 'P'),
(27217, 'Fremont (historical)', 38.7275009155273, 0.67592240204507, -89.5199966430664, -1.56241868779578, 218, 18, 'PPL', 'P'),
(47281, 'Fremont Acres', 39.3263893127441, 0.686374976428495, -77.2361068725586, -1.34802436634837, 218, 25, 'PPL', 'P'),
(119710, 'Fremont Center', 42.297779083252, 0.738235511283935, -88.0713882446289, -1.537135701671, 218, 18, 'PPL', 'P'),
(148982, 'Fremont Center', 41.8422203063965, 0.730284510691449, -75.043327331543, -1.30975314358728, 218, 40, 'PPL', 'P'),
(47282, 'Fremont Hills', 39.329719543457, 0.686433099919286, -77.273063659668, -1.34866938396439, 218, 25, 'PPL', 'P'),
(54865, 'Fremont Hills', 37.064998626709, 0.646906263283248, -93.2486114501953, -1.62749529271879, 218, 29, 'PPL', 'P'),
(192576, 'Fremont Junction', 38.7558288574219, 0.676416817901444, -111.380828857422, -1.94396218716233, 218, 52, 'PPL', 'P'),
(143848, 'Fremont Station', 42.9797210693359, 0.75013764424869, -71.1241683959961, -1.24135091625303, 218, 36, 'PPL', 'P'),
(8993, 'French', 36.3605613708496, 0.634611513794789, -91.6933288574219, -1.60035049067594, 218, 4, 'PPL', 'P'),
(102125, 'French', 37.2958297729492, 0.650935026801293, -80.8708267211914, -1.4114621950946, 218, 53, 'PPL', 'P'),
(135480, 'French', 46.2880592346191, 0.80787903800227, -96.2013931274414, -1.6790310550793, 218, 28, 'PPL', 'P'),
(188572, 'French', 36.4741706848145, 0.636594370384407, -104.557777404785, -1.82487747428083, 218, 38, 'PPL', 'P'),
(194956, 'French (historical)', 44.1222190856934, 0.770077996331631, -116.643058776855, -2.0358054252534, 218, 17, 'PPL', 'P'),
(87147, 'French Broad', 35.9072189331055, 0.626699195617136, -82.9844436645508, -1.44835176988216, 218, 50, 'PPL', 'P'),
(87148, 'French Broad (historical)', 35.9508285522461, 0.627460327056681, -83.5688934326172, -1.45855234264744, 218, 50, 'PPL', 'P'),
(59979, 'French Camp', 33.2930603027344, 0.581073520347735, -89.3994369506836, -1.56031452421851, 218, 30, 'PPL', 'P'),
(181694, 'French Camp', 37.8841705322266, 0.661203510174366, -121.269996643066, -2.11656072530398, 218, 6, 'PPL', 'P'),
(194957, 'French Corner', 44.0574989318848, 0.768948416555274, -116.579437255859, -2.03469502023689, 218, 17, 'PPL', 'P'),
(181695, 'French Corral', 39.3061103820801, 0.686021042319624, -121.160278320313, -2.11464577932216, 218, 6, 'PPL', 'P'),
(204031, 'French Cort Village Condominium', 40.6744384765625, 0.709902872815882, -111.881942749023, -1.95270827449825, 218, 52, 'PPL', 'P'),
(109286, 'French Creek', 38.8855590820313, 0.678681037460229, -80.2975006103516, -1.40145576677279, 218, 58, 'PPL', 'P'),
(148985, 'French Creek', 42.0677795410156, 0.734221261993832, -79.7038879394531, -1.39109527118406, 218, 40, 'PPL', 'P'),
(194958, 'French Creek', 45.4233283996582, 0.792786637788682, -116.026390075684, -2.02504252602395, 218, 17, 'PPL', 'P'),
(193574, 'French Gulch', 40.7008285522461, 0.710363466526411, -122.637222290039, -2.14042331446136, 218, 6, 'PPL', 'P'),
(196538, 'French Gulch (historical)', 45.9444389343262, 0.801881732385466, -113.030563354492, -1.97275548591994, 218, 31, 'PPL', 'P'),
(102127, 'French Hay', 37.686939239502, 0.657761174728357, -77.4622192382813, -1.3519707716097, 218, 53, 'PPL', 'P'),
(193575, 'French Hill', 41.8250007629395, 0.729983972962434, -123.971389770508, -2.16370892976858, 218, 6, 'PPL', 'P'),
(172034, 'French Hollow', 43.1791687011719, 0.753618662109533, -72.8822174072266, -1.27203465991043, 218, 55, 'PPL', 'P'),
(174202, 'French Island', 43.8583297729492, 0.765472258963421, -91.2602767944336, -1.59279230634424, 218, 57, 'PPL', 'P'),
(135482, 'French Lake', 45.2000007629395, 0.788888835217242, -94.1852798461914, -1.6438432402283, 218, 28, 'PPL', 'P'),
(130908, 'French Landing', 42.2099990844727, 0.73670346128784, -83.4397201538086, -1.45629784362663, 218, 27, 'PPL', 'P'),
(29855, 'French Lick', 38.5488891601563, 0.672805038831078, -86.620002746582, -1.51180424601439, 218, 19, 'PPL', 'P'),
(2607, 'French Mill', 34.7666702270508, 0.606792865417121, -86.8777770996094, -1.51630325720191, 218, 2, 'PPL', 'P'),
(127530, 'French Mill', 44.9516716003418, 0.784554673701193, -69.1366729736328, -1.20666257726447, 218, 26, 'PPL', 'P'),
(54866, 'French Mills', 37.4558296203613, 0.653727550941323, -90.4891662597656, -1.57933388861747, 218, 29, 'PPL', 'P'),
(148987, 'French Mountain', 43.3691711425781, 0.756934830298899, -73.6988906860352, -1.2862882975387, 218, 40, 'PPL', 'P'),
(135484, 'French River', 46.8980598449707, 0.81852555709208, -91.8969421386719, -1.60390421283454, 218, 28, 'PPL', 'P'),
(41003, 'French Settlement', 30.2950000762939, 0.528747498223263, -90.7949981689453, -1.58467166239032, 218, 22, 'PPL', 'P'),
(127531, 'French Settlement', 44.9697189331055, 0.784869659079122, -68.7266693115234, -1.19950666341543, 218, 26, 'PPL', 'P'),
(161878, 'French Settlement', 41.2108306884766, 0.719264682995838, -77.0130615234375, -1.34413149062494, 218, 45, 'PPL', 'P'),
(54867, 'French Town', 37.9550018310547, 0.662439749552381, -90.6744384765625, -1.58256749881305, 218, 29, 'PPL', 'P'),
(130909, 'French Town', 43.7708282470703, 0.763945069236315, -86.4372177124023, -1.50861404534458, 218, 27, 'PPL', 'P'),
(196539, 'French Town', 45.9372215270996, 0.801755764865906, -112.990829467773, -1.97206199877208, 218, 31, 'PPL', 'P'),
(209468, 'French Vee', 43.7188911437988, 0.763038595780279, -107.235282897949, -1.87160876087678, 218, 59, 'PPL', 'P'),
(27218, 'French Village', 38.6002807617188, 0.673701991486217, -90.0500030517578, -1.57166904468412, 218, 18, 'PPL', 'P'),
(54868, 'French Village', 37.9724998474121, 0.662745147550386, -90.3897171020508, -1.57759817337701, 218, 29, 'PPL', 'P'),
(54869, 'French Village (historical)', 38.5766716003418, 0.673289933886554, -91.9688873291016, -1.60515989328852, 218, 29, 'PPL', 'P'),
(148988, 'French Woods', 41.9211082458496, 0.73166136497502, -75.186393737793, -1.31225012342533, 218, 40, 'PPL', 'P'),
(127532, 'Frenchboro', 44.1180610656738, 0.770005425191927, -68.3630599975586, -1.19316048369582, 218, 26, 'PPL', 'P'),
(161, 'Frenchburg', 39.3152809143066, 0.686181098301137, -78.6608276367188, -1.37289043460449, 218, 58, 'PPL', 'P'),
(35998, 'Frenchburg', 37.9508285522461, 0.662366912096567, -83.6258316040039, -1.4595461012082, 218, 21, 'PPL', 'P'),
(181696, 'Frenches Ravine (historical)', 39.3208312988281, 0.686277970785789, -121.202217102051, -2.11537774914777, 218, 6, 'PPL', 'P'),
(200854, 'Frenchglen', 42.8269386291504, 0.747471087628221, -118.914436340332, -2.07544844229199, 218, 43, 'PPL', 'P'),
(196540, 'Frenchie Place', 45.1113891601563, 0.787342270993206, -112.879173278809, -1.97011323064441, 218, 31, 'PPL', 'P'),
(190220, 'Frenchman', 39.2794418334961, 0.685555588340105, -118.269172668457, -2.06418646667426, 218, 39, 'PPL', 'P'),
(9004, 'Frenchmans Bayou', 35.4661102294922, 0.61900039637988, -90.1808319091797, -1.57395243900275, 218, 4, 'PPL', 'P'),
(72610, 'Frenchmens Corner (historical)', 39.1227798461914, 0.682821320848921, -84.5352783203125, -1.47541894077923, 218, 41, 'PPL', 'P'),
(41004, 'Frenchmens Estates', 30.2772197723389, 0.528437173377241, -89.7200012207031, -1.5659094261946, 218, 22, 'PPL', 'P'),
(8996, 'Frenchport', 33.4711112976074, 0.584181096444721, -92.7777786254883, -1.61927770970119, 218, 4, 'PPL', 'P'),
(127534, 'Frenchs Corner', 44.2363891601563, 0.772070640038256, -69.8877792358398, -1.21977185457233, 218, 26, 'PPL', 'P'),
(161889, 'Frenchs Corners', 40.8988914489746, 0.713820316200361, -79.5016708374023, -1.38756591694943, 218, 45, 'PPL', 'P'),
(13820, 'Frenchs Mobile Homes', 39.0077781677246, 0.680814162914355, -75.366943359375, -1.31540130878517, 218, 10, 'PPL', 'P'),
(109288, 'Frenchton', 38.8727798461914, 0.678457997718935, -80.3566665649414, -1.40248840748547, 218, 58, 'PPL', 'P'),
(2608, 'Frenchtown', 33.5205612182617, 0.585044160374989, -86.8813934326172, -1.51636637411975, 218, 2, 'PPL', 'P'),
(29857, 'Frenchtown', 38.3147201538086, 0.668718018664188, -86.2144393920898, -1.50472583015307, 218, 19, 'PPL', 'P'),
(47284, 'Frenchtown', 38.0830612182617, 0.66467480749723, -75.8625030517578, -1.32405045705742, 218, 25, 'PPL', 'P'),
(130910, 'Frenchtown', 46.473331451416, 0.811112648197845, -87.6788864135742, -1.53028525239899, 218, 27, 'PPL', 'P'),
(145276, 'Frenchtown', 40.5261116027832, 0.707314080499243, -75.0619430541992, -1.31007804924026, 218, 37, 'PPL', 'P'),
(155370, 'Frenchtown', 41.0288887023926, 0.716089196291054, -83.3436126708984, -1.45462045161404, 218, 41, 'PPL', 'P'),
(161883, 'Frenchtown', 41.350830078125, 0.721708133295985, -74.9219436645508, -1.30763459894012, 218, 45, 'PPL', 'P'),
(169383, 'Frenchtown', 41.6272201538086, 0.7265320501365, -71.4930572509766, -1.24778924134635, 218, 47, 'PPL', 'P'),
(181698, 'Frenchtown', 39.3880615234375, 0.687451359562078, -121.253890991211, -2.11627962865092, 218, 6, 'PPL', 'P'),
(196541, 'Frenchtown', 47.0149993896484, 0.82056653717249, -114.228889465332, -1.99367022206671, 218, 31, 'PPL', 'P'),
(202147, 'Frenchtown (historical)', 43.8875007629395, 0.765981388784817, -103.381942749023, -1.80435528807874, 218, 49, 'PPL', 'P'),
(41005, 'Frenchtown Acres', 30.4902801513672, 0.532155778496832, -90.9933319091797, -1.5881332391752, 218, 22, 'PPL', 'P'),
(127536, 'Frenchville', 47.2808303833008, 0.825206163265571, -68.3802795410156, -1.19346102142484, 218, 26, 'PPL', 'P'),
(148989, 'Frenchville', 43.3250007629395, 0.756163911742349, -75.3586120605469, -1.31525590018965, 218, 40, 'PPL', 'P'),
(161884, 'Frenchville', 41.1047210693359, 0.717412720773796, -78.2202835083008, -1.36520148906327, 218, 45, 'PPL', 'P'),
(174203, 'Frenchville', 44.1497192382813, 0.770557964539091, -91.3227767944336, -1.59388313712674, 218, 57, 'PPL', 'P'),
(145278, 'Freneau', 40.401668548584, 0.705142139472229, -74.2380599975586, -1.29569857725049, 218, 37, 'PPL', 'P'),
(41006, 'Frenier', 30.1075000762939, 0.525475005875773, -90.4266662597656, -1.57824305783498, 218, 22, 'PPL', 'P'),
(94348, 'Frenstat', 30.3972206115723, 0.53053158312702, -96.6530609130859, -1.68691414506399, 218, 51, 'PPL', 'P'),
(94342, 'Fresenius', 30.375560760498, 0.530153547410284, -94.2372207641602, -1.64474978026336, 218, 51, 'PPL', 'P'),
(124895, 'Fresh Brook', 41.8933296203613, 0.731176536498571, -69.9875030517578, -1.22151236350275, 218, 23, 'PPL', 'P'),
(148990, 'Fresh Kills', 40.5641708374023, 0.707978339454136, -74.1866683959961, -1.29480162459535, 218, 40, 'PPL', 'P'),
(35999, 'Fresh Meadows', 36.8430595397949, 0.643032695477728, -83.3736114501953, -1.45514402908435, 218, 21, 'PPL', 'P'),
(148991, 'Fresh Meadows', 40.7347183227539, 0.710954954604518, -73.7938919067383, -1.28794638163338, 218, 40, 'PPL', 'P'),
(148992, 'Fresh Pond', 40.7069396972656, 0.710470126128069, -73.9038925170898, -1.28986625446322, 218, 40, 'PPL', 'P'),
(181699, 'Fresh Pond', 38.7602806091309, 0.676494515626247, -120.52889251709, -2.10362601820557, 218, 6, 'PPL', 'P'),
(148993, 'Fresh Pond Junction', 40.7038917541504, 0.710416929485295, -73.8919372558594, -1.28965759579181, 218, 40, 'PPL', 'P'),
(148994, 'Fresh Pond Landing', 40.9947204589844, 0.715492847943958, -72.1108322143555, -1.2585714484937, 218, 40, 'PPL', 'P'),
(145279, 'Fresh Ponds', 40.4052810668945, 0.705205189811037, -74.4661102294922, -1.29967880465767, 218, 37, 'PPL', 'P'),
(102128, 'Freshwater', 37.7502784729004, 0.658866652896849, -78.9272232055664, -1.37753991439361, 218, 53, 'PPL', 'P'),
(193576, 'Freshwater', 40.7616691589355, 0.711425335432053, -124.060562133789, -2.16526528110962, 218, 6, 'PPL', 'P'),
(209955, 'Freshwater Bay', 57.8916702270508, 1.01040025494081, -135.079437255859, -2.35758093185584, 218, 1, 'PPL', 'P'),
(193577, 'Freshwater Corners', 40.7855606079102, 0.711842319879732, -124.084167480469, -2.16567727213026, 218, 6, 'PPL', 'P'),
(124896, 'Freshwater Cove Village', 42.5958290100098, 0.743437463841187, -70.6875, -1.23372961500349, 218, 23, 'PPL', 'P'),
(8997, 'Fresno', 33.9630584716797, 0.592767194378164, -91.7069396972656, -1.60058804464518, 218, 4, 'PPL', 'P'),
(155371, 'Fresno', 40.3325004577637, 0.703934928550096, -81.7416687011719, -1.42666125490985, 218, 41, 'PPL', 'P'),
(181700, 'Fresno', 36.7477798461914, 0.641369751114055, -119.771392822266, -2.09040515444804, 218, 6, 'PPL', 'P'),
(191501, 'Fresno', 34.7760810852051, 0.606957115877351, -100.15225982666, -1.74798668728807, 218, 51, 'PPL', 'P'),
(196542, 'Fresno', 48.5677795410156, 0.847667663373463, -109.985832214355, -1.91961490268655, 218, 31, 'PPL', 'P'),
(8998, 'Fresno (historical)', 35.7066688537598, 0.623198936417418, -93.8444366455078, -1.63789440414333, 218, 4, 'PPL', 'P'),
(181701, 'Fresno Beach (historical)', 36.8594398498535, 0.643318585820748, -119.844169616699, -2.09167534912995, 218, 6, 'PPL', 'P'),
(181702, 'Fresno City (historical)', 36.6611099243164, 0.63985707561489, -120.26000213623, -2.09893299573264, 218, 6, 'PPL', 'P'),
(181704, 'Fresno Crossing', 37.2372207641602, 0.649912106626594, -119.774169921875, -2.09045362397988, 218, 6, 'PPL', 'P'),
(36000, 'Frew', 37.1824989318848, 0.648957030480664, -83.2458267211914, -1.45291376482947, 218, 21, 'PPL', 'P'),
(109287, 'Frew', 39.4672203063965, 0.688832940956584, -80.8363876342773, -1.41086111963657, 218, 58, 'PPL', 'P'),
(148995, 'Frewsburg', 42.0544395446777, 0.733988435135531, -79.158332824707, -1.38157353818064, 218, 40, 'PPL', 'P'),
(41007, 'Frey', 30.4019393920898, 0.530613941383731, -92.4447174072266, -1.61346469483182, 218, 22, 'PPL', 'P'),
(75880, 'Frey', 36.019718170166, 0.628662677709824, -96.6100006103516, -1.68616260100437, 218, 42, 'PPL', 'P'),
(94344, 'Freyburg', 29.7574996948242, 0.51936634683589, -96.9663925170898, -1.69238281320441, 218, 51, 'PPL', 'P'),
(102129, 'Freyco', 39.2411117553711, 0.684886602274277, -78.0980606079102, -1.36306829703012, 218, 53, 'PPL', 'P'),
(161885, 'Freys Grove', 40.2155609130859, 0.701893948469687, -76.7238922119141, -1.33908453404314, 218, 45, 'PPL', 'P'),
(36001, 'Freys Hill', 38.2922210693359, 0.668325335561456, -85.5630569458008, -1.49335706177563, 218, 21, 'PPL', 'P'),
(148996, 'Freysbush', 42.9091682434082, 0.748906265139665, -74.663330078125, -1.3031209403666, 218, 40, 'PPL', 'P'),
(78306, 'Freysville', 39.9280586242676, 0.696876086922787, -76.6063919067383, -1.33703376684572, 218, 45, 'PPL', 'P'),
(161886, 'Freytown', 41.2972183227539, 0.720772431646986, -75.445556640625, -1.31677336937878, 218, 45, 'PPL', 'P'),
(181705, 'Friant', 36.9877815246582, 0.645558570613614, -119.710830688477, -2.08934814581139, 218, 6, 'PPL', 'P'),
(94345, 'Friars', 32.2316703796387, 0.562548771542225, -94.904167175293, -1.65639019107199, 218, 51, 'PPL', 'P'),
(109289, 'Friars Hill', 38.0141716003418, 0.663472456844086, -80.4394378662109, -1.40393303921878, 218, 58, 'PPL', 'P'),
(70842, 'Friars Landing', 39.8291702270508, 0.695150158799334, -75.227783203125, -1.31297250587102, 218, 37, 'PPL', 'P'),
(59980, 'Friars Point', 34.3666687011719, 0.599811521777533, -90.6374969482422, -1.58192274751314, 218, 30, 'PPL', 'P'),
(81126, 'Friarsgate', 34.1019401550293, 0.595191137023327, -81.2030563354492, -1.41726069573603, 218, 48, 'PPL', 'P'),
(186735, 'Frick', 37.5852813720703, 0.655986910231119, -102.955001831055, -1.7969037633487, 218, 7, 'PPL', 'P'),
(21299, 'Frick Gap (historical)', 34.7949981689453, 0.607287281273494, -85.3949966430664, -1.49042385615101, 218, 13, 'PPL', 'P'),
(8999, 'Frickenger (historical)', 36.4222183227539, 0.635687630612262, -91.5130615234375, -1.59720423216412, 218, 4, 'PPL', 'P'),
(47285, 'Fricks Crossing', 39.4113883972168, 0.687858490313724, -79.333610534668, -1.38463271132482, 218, 25, 'PPL', 'P'),
(161888, 'Fricks Lock', 40.2222213745117, 0.702010195451269, -75.595832824707, -1.31939618357834, 218, 45, 'PPL', 'P'),
(94347, 'Friday', 31.1082897186279, 0.542942080254358, -95.2628326416016, -1.66265008437227, 218, 51, 'PPL', 'P'),
(207468, 'Friday Harbor', 48.5344390869141, 0.847085762675281, -123.015830993652, -2.14703128291612, 218, 56, 'PPL', 'P'),
(2609, 'Fridays Crossing', 34.0597190856934, 0.594454240349702, -86.4338912963867, -1.50855598843282, 218, 2, 'PPL', 'P'),
(47292, 'Fridinger Estates', 39.6549987792969, 0.692110293573063, -76.9297180175781, -1.34267687203754, 218, 25, 'PPL', 'P'),
(135487, 'Fridley', 45.086109161377, 0.786901051779607, -93.2630615234375, -1.62774749407402, 218, 28, 'PPL', 'P'),
(140054, 'Fried', 47.0458297729492, 0.82110462887074, -98.6575012207031, -1.72189822809159, 218, 34, 'PPL', 'P'),
(64918, 'Friedburg', 35.9944381713867, 0.628221458496225, -80.2949981689453, -1.40141209093091, 218, 33, 'PPL', 'P'),
(13808, 'Friedel Property', 38.6569404602051, 0.674690889777991, -75.5802764892578, -1.31912467430521, 218, 10, 'PPL', 'P'),
(54870, 'Friedenberg', 37.7008285522461, 0.658003588966581, -89.7938919067383, -1.56719906195247, 218, 29, 'PPL', 'P'),
(102130, 'Friedens', 38.3494415283203, 0.669324020970236, -78.8763885498047, -1.37665268227645, 218, 53, 'PPL', 'P'),
(161891, 'Friedens', 40.0499992370605, 0.699004352107924, -78.9986114501953, -1.3787858743096, 218, 45, 'PPL', 'P'),
(161892, 'Friedensburg', 40.6025009155273, 0.708647325519964, -76.2411117553711, -1.33065842551218, 218, 45, 'PPL', 'P'),
(161893, 'Friedensville', 40.5591697692871, 0.707891054349409, -75.3949966430664, -1.31589093095158, 218, 45, 'PPL', 'P'),
(161894, 'Friedenthal', 40.7522201538086, 0.71126041918155, -75.271110534668, -1.31372871046255, 218, 45, 'PPL', 'P'),
(54872, 'Friedheim', 37.5699996948242, 0.655720194647947, -89.8199996948242, -1.56765472881498, 218, 29, 'PPL', 'P'),
(191502, 'Friedman Estates Number 1 Colonia', 31.617000579834, 0.551820759723059, -106.281997680664, -1.85497079512456, 218, 51, 'PPL', 'P'),
(191503, 'Friedman Estates Number 2 Colonia', 31.617000579834, 0.551820759723059, -106.276000976563, -1.85486613289372, 218, 51, 'PPL', 'P'),
(81127, 'Frieds Bay', 34.0308303833008, 0.593950037376323, -78.7713928222656, -1.37482016113036, 218, 48, 'PPL', 'P'),
(119712, 'Frielings', 41.1605606079102, 0.718387304574711, -88.1130599975586, -1.5378630109647, 218, 18, 'PPL', 'P'),
(141854, 'Friend', 40.6536102294922, 0.709539351327086, -97.2858276367188, -1.69795800778844, 218, 35, 'PPL', 'P'),
(148997, 'Friend', 42.6627807617188, 0.744605992348487, -77.1838912963867, -1.34711303262334, 218, 40, 'PPL', 'P'),
(187674, 'Friend', 38.2599983215332, 0.667762942518259, -100.911109924316, -1.76123112002125, 218, 20, 'PPL', 'P'),
(200855, 'Friend', 45.3469390869141, 0.791453392767961, -121.26611328125, -2.11649294785424, 218, 43, 'PPL', 'P'),
(102131, 'Friend (historical)', 37.2416687011719, 0.649989737772369, -77.3216705322266, -1.34951773392963, 218, 53, 'PPL', 'P'),
(193578, 'Friend Place', 40.4858283996582, 0.706611005971462, -123.362503051758, -2.15308185175473, 218, 6, 'PPL', 'P'),
(81129, 'Friendfield', 33.3358306884766, 0.581820004401284, -79.2377777099609, -1.38296011300219, 218, 48, 'PPL', 'P'),
(47287, 'Friendly', 38.7516708374023, 0.676344246761739, -76.978889465332, -1.34353507569882, 218, 25, 'PPL', 'P'),
(109291, 'Friendly', 39.5158309936523, 0.689681357500856, -81.059440612793, -1.41475412851805, 218, 58, 'PPL', 'P'),
(161895, 'Friendly Acres', 41.4225006103516, 0.722959020059996, -75.0547180175781, -1.30995194856265, 218, 45, 'PPL', 'P'),
(94349, 'Friendly Acres Colonia', 26.2770004272461, 0.458620175003401, -98.3379974365234, -1.71632183508508, 218, 51, 'PPL', 'P'),
(94350, 'Friendly Corner', 29.4972190856934, 0.514823593227461, -98.1949996948242, -1.71382605366951, 218, 51, 'PPL', 'P'),
(122659, 'Friendly Corner', 40.5533294677734, 0.707789121858686, -85.5036087036133, -1.49231949421493, 218, 19, 'PPL', 'P'),
(178228, 'Friendly Corners', 32.6177787780762, 0.569287634364562, -111.550277709961, -1.94691962755286, 218, 5, 'PPL', 'P'),
(47288, 'Friendly Farms', 38.735279083252, 0.676058156681637, -76.9763870239258, -1.34349139985694, 218, 25, 'PPL', 'P'),
(47289, 'Friendly Hills', 38.7561111450195, 0.67642174474946, -76.9891662597656, -1.34371443959824, 218, 25, 'PPL', 'P'),
(181706, 'Friendly Hills', 33.9536094665527, 0.592602278127661, -118.002777099609, -2.05953698688515, 218, 6, 'PPL', 'P'),
(47290, 'Friendly Pines', 38.2644386291504, 0.66784044050598, -76.4916687011719, -1.33503146918014, 218, 25, 'PPL', 'P'),
(196543, 'Friendly Trailer Court', 45.7630615234375, 0.798716099376717, -111.183326721191, -1.94051512460538, 218, 31, 'PPL', 'P'),
(54873, 'Friendly Valley', 37.689998626709, 0.657814571108213, -89.9105606079102, -1.56923531492195, 218, 29, 'PPL', 'P'),
(109290, 'Friendly View', 37.8572196960449, 0.660733129346831, -81.4588928222656, -1.42172588477771, 218, 58, 'PPL', 'P'),
(155372, 'Friendly Village I Mobile Home Park', 41.5527801513672, 0.725232826998705, -83.5330581665039, -1.45792689926543, 218, 41, 'PPL', 'P'),
(155373, 'Friendly Village II Mobile Home Park', 41.5602798461914, 0.725363721366283, -83.533332824707, -1.45793169295539, 218, 41, 'PPL', 'P'),
(181708, 'Friendly Village Mobile Home Park', 34.276668548584, 0.598240722787576, -118.801940917969, -2.07348502677833, 218, 6, 'PPL', 'P'),
(21300, 'Friendly Village of Crooked Creek', 33.9744415283203, 0.592965866195484, -84.0833282470703, -1.46753092394653, 218, 13, 'PPL', 'P'),
(47291, 'Friends Choice', 38.9130592346191, 0.679161005667689, -76.6505584716797, -1.33780461882324, 218, 25, 'PPL', 'P'),
(47311, 'Friends Creek', 39.7144393920898, 0.693147727975703, -77.4036102294922, -1.350947851435, 218, 25, 'PPL', 'P'),
(87149, 'Friends Station', 36.0947189331055, 0.629971687964625, -83.5791702270508, -1.45873170654685, 218, 50, 'PPL', 'P'),
(47293, 'Friends View', 39.5311088562012, 0.689948006505, -76.6680603027344, -1.33811008340028, 218, 25, 'PPL', 'P'),
(2616, 'Friendship', 33.1841697692871, 0.579173022014827, -85.4866714477539, -1.49202388333393, 218, 2, 'PPL', 'P'),
(9003, 'Friendship', 34.2230606079102, 0.597305087717604, -93.0027770996094, -1.62320467388657, 218, 4, 'PPL', 'P'),
(21307, 'Friendship', 34.9638900756836, 0.610235001126048, -83.7872161865234, -1.46236279353512, 218, 13, 'PPL', 'P'),
(29858, 'Friendship', 38.9702796936035, 0.680159691076468, -85.1477813720703, -1.48610913571092, 218, 19, 'PPL', 'P'),
(36002, 'Friendship', 37.0569381713867, 0.646765581798665, -87.7663879394531, -1.5318124421261, 218, 21, 'PPL', 'P'),
(41010, 'Friendship', 32.2394409179688, 0.562684393020738, -92.8824996948242, -1.62110543715731, 218, 22, 'PPL', 'P'),
(47298, 'Friendship', 38.3716697692871, 0.669711976962033, -75.211669921875, -1.31269127605991, 218, 25, 'PPL', 'P'),
(59983, 'Friendship', 34.3238906860352, 0.599064904565929, -89.0374984741211, -1.55399750611284, 218, 30, 'PPL', 'P'),
(64915, 'Friendship', 36.2638893127441, 0.632924268086169, -80.5641708374023, -1.40611004025187, 218, 33, 'PPL', 'P'),
(70846, 'Friendship', 39.6222190856934, 0.691538179991886, -75.1827774047852, -1.3121870065075, 218, 37, 'PPL', 'P'),
(72612, 'Friendship', 38.6977806091309, 0.67540368484375, -83.0938873291016, -1.45026192217402, 218, 41, 'PPL', 'P'),
(75881, 'Friendship', 34.6958312988281, 0.605556492881051, -99.2286071777344, -1.73186590741954, 218, 42, 'PPL', 'P'),
(81134, 'Friendship', 34.9205589294434, 0.609478729955493, -80.9147186279297, -1.41222825338216, 218, 48, 'PPL', 'P'),
(87155, 'Friendship', 36.5458297729492, 0.637845057411336, -82.0163879394531, -1.43145601013642, 218, 50, 'PPL', 'P'),
(102132, 'Friendship', 36.7299995422363, 0.641059426268034, -81.7416687011719, -1.42666125490985, 218, 53, 'PPL', 'P'),
(127538, 'Friendship', 43.9836082458496, 0.767658780797403, -69.3344421386719, -1.21011430035332, 218, 26, 'PPL', 'P'),
(148998, 'Friendship', 42.2063903808594, 0.73664047752806, -78.1377792358398, -1.36376151786186, 218, 40, 'PPL', 'P'),
(174204, 'Friendship', 43.9705581665039, 0.767431013945174, -89.8166732788086, -1.56759667190322, 218, 57, 'PPL', 'P'),
(191505, 'Friendship', 33.9874992370605, 0.593193766205767, -102.573333740234, -1.79024239851408, 218, 51, 'PPL', 'P'),
(2617, 'Friendship (historical)', 34.1508293151855, 0.596044413836588, -86.2841720581055, -1.50594289477123, 218, 2, 'PPL', 'P'),
(59984, 'Friendship (historical)', 33.2852783203125, 0.580937699132141, -89.5458297729492, -1.56286956096833, 218, 30, 'PPL', 'P'),
(47299, 'Friendship Acres', 38.4430618286133, 0.670958003457054, -77.1486129760742, -1.34649730977932, 218, 25, 'PPL', 'P'),
(47301, 'Friendship Estates', 38.3666687011719, 0.669624691857306, -75.2241668701172, -1.31290938895318, 218, 25, 'PPL', 'P'),
(13107, 'Friendship Heights', 38.9569396972656, 0.679926864218168, -77.0791702270508, -1.34528530516722, 218, 9, 'PPL', 'P'),
(47303, 'Friendship Heights', 38.9633293151855, 0.680038384088815, -77.0894393920898, -1.34546453590858, 218, 25, 'PPL', 'P'),
(78308, 'Friendship Heights', 39.7827796936035, 0.694340491248922, -79.9172210693359, -1.3948186367041, 218, 45, 'PPL', 'P'),
(102133, 'Friendship Heights', 38.4505615234375, 0.671088897824631, -78.022216796875, -1.36174457281029, 218, 53, 'PPL', 'P'),
(47304, 'Friendship Knolls', 39.3208312988281, 0.686277970785789, -77.2069396972656, -1.347515303106, 218, 25, 'PPL', 'P'),
(47305, 'Friendship Manor', 39.2980613708496, 0.685880560572122, -76.9480590820313, -1.34299698400057, 218, 25, 'PPL', 'P'),
(47306, 'Friendship Park', 39.6130599975586, 0.691378323747454, -77.769172668457, -1.35732811961656, 218, 25, 'PPL', 'P'),
(81135, 'Friendship Shores', 34.6055603027344, 0.603980966780161, -82.8994369506836, -1.44686812283888, 218, 48, 'PPL', 'P'),
(70847, 'Friendship Station', 39.7341690063477, 0.69349207470465, -75.4591674804688, -1.31701092334801, 218, 37, 'PPL', 'P'),
(47307, 'Friendship Village', 38.9627799987793, 0.680028796708891, -77.0891723632813, -1.34545987537668, 218, 25, 'PPL', 'P'),
(47308, 'Friendship Woods', 38.7472190856934, 0.676266549036936, -76.5941696166992, -1.3368204476424, 218, 25, 'PPL', 'P'),
(27220, 'Friendsville', 38.503059387207, 0.672005158397673, -87.8163909912109, -1.53268516001532, 218, 18, 'PPL', 'P'),
(47309, 'Friendsville', 39.6636085510254, 0.69226056243757, -79.4055633544922, -1.38588852493684, 218, 25, 'PPL', 'P'),
(87156, 'Friendsville', 35.7602806091309, 0.624134638066417, -84.1358337402344, -1.46844731767763, 218, 50, 'PPL', 'P'),
(130913, 'Friendsville', 42.3077812194824, 0.73841008149339, -86.2236099243164, -1.50488588613458, 218, 27, 'PPL', 'P'),
(155374, 'Friendsville', 41.0272216796875, 0.716060101256145, -81.9658279418945, -1.43057357170923, 218, 41, 'PPL', 'P'),
(161897, 'Friendsville', 41.9169387817383, 0.731588594098234, -76.0458297729492, -1.3272501119491, 218, 45, 'PPL', 'P'),
(29861, 'Friendswood', 39.6463890075684, 0.691960024708555, -86.3327789306641, -1.50679124473648, 218, 19, 'PPL', 'P'),
(94359, 'Friendswood', 29.5291690826416, 0.51538122587021, -95.2008285522461, -1.66156790886332, 218, 51, 'PPL', 'P'),
(94360, 'Friendswood Acres Number 1 Colonia', 27.92799949646, 0.487435544708545, -97.5770034790039, -1.70303998493858, 218, 51, 'PPL', 'P'),
(94361, 'Friendswood Acres Number 2 Colonia', 27.9370002746582, 0.487592637923346, -97.5709991455078, -1.70293518954969, 218, 51, 'PPL', 'P'),
(41009, 'Frierson', 32.2516708374023, 0.562897845382108, -93.6897201538086, -1.63519409195605, 218, 22, 'PPL', 'P'),
(81136, 'Frierson', 33.5333290100098, 0.585267000379201, -80.2172164916992, -1.40005454456525, 218, 48, 'PPL', 'P'),
(87157, 'Frierson Town', 35.5261116027832, 0.620047617899527, -87.1800003051758, -1.52157804721498, 218, 50, 'PPL', 'P'),
(102134, 'Fries', 36.7161102294922, 0.64081701202981, -80.978889465332, -1.41334824577859, 218, 53, 'PPL', 'P'),
(102135, 'Fries Junction', 36.7619400024414, 0.641616892463215, -80.9555587768555, -1.41294104844792, 218, 53, 'PPL', 'P'),
(70849, 'Fries Mill', 39.6561088562012, 0.692129668069993, -75.0455627441406, -1.30979215889724, 218, 37, 'PPL', 'P'),
(196544, 'Fries Place', 45.0608291625977, 0.786459832566008, -112.248893737793, -1.95911277744573, 218, 31, 'PPL', 'P'),
(70848, 'Friesburg', 39.5447196960449, 0.690185560474235, -75.289436340332, -1.31404855610946, 218, 37, 'PPL', 'P'),
(135490, 'Friesland', 46.0855598449707, 0.804344756919626, -92.929443359375, -1.62192475866667, 218, 28, 'PPL', 'P'),
(174207, 'Friesland', 43.5886116027832, 0.76076478884157, -89.0672225952148, -1.55451628989319, 218, 57, 'PPL', 'P'),
(161899, 'Friesville', 40.2947196960449, 0.703275529864193, -78.4625015258789, -1.36942899097766, 218, 45, 'PPL', 'P'),
(94362, 'Frige Settlement', 30.1124992370605, 0.525562257690987, -94.716667175293, -1.6531176987245, 218, 51, 'PPL', 'P'),
(196545, 'Frigon Trailer Court', 48.5541687011719, 0.847430109404228, -109.693061828613, -1.91450509550301, 218, 31, 'PPL', 'P'),
(191506, 'Frijole (historical)', 31.9051399230957, 0.55684973996751, -104.782432556152, -1.82879844635376, 218, 51, 'PPL', 'P'),
(188573, 'Frijoles', 35.7788887023926, 0.624459410561352, -106.270561218262, -1.85477119120086, 218, 38, 'PPL', 'P'),
(188574, 'Frijoles Spring', 36.1611099243164, 0.631130429354919, -106.370002746582, -1.85650677328327, 218, 38, 'PPL', 'P'),
(9006, 'Friley', 35.7291717529297, 0.623591686099177, -93.6277770996094, -1.63411298171153, 218, 4, 'PPL', 'P'),
(161900, 'Frills Corners', 41.3955612182617, 0.722488838969542, -79.3683319091797, -1.38523871363086, 218, 45, 'PPL', 'P'),
(41011, 'Frilot Cove', 30.6266708374023, 0.5345362450372, -92.204719543457, -1.60927594191129, 218, 22, 'PPL', 'P'),
(16143, 'Frink', 30.3683300018311, 0.530027346864128, -85.2141723632813, -1.48726787710122, 218, 12, 'PPL', 'P'),
(75882, 'Frink', 34.8841705322266, 0.608843632614536, -95.7891693115234, -1.67183639223639, 218, 42, 'PPL', 'P'),
(181711, 'Frink', 33.3624992370605, 0.582285458380803, -115.647216796875, -2.01842470387316, 218, 6, 'PPL', 'P'),
(149000, 'Frink Corner', 43.0816688537598, 0.751916968751999, -73.9369430541992, -1.29044309515533, 218, 40, 'PPL', 'P'),
(64919, 'Frink Crossing', 34.3216705322266, 0.599026155572068, -78.8933334350586, -1.3769484263155, 218, 33, 'PPL', 'P'),
(161904, 'Frinks', 41.814998626709, 0.729809402752979, -77.9841690063477, -1.36108051359248, 218, 45, 'PPL', 'P'),
(149001, 'Frinks Corner', 42.704719543457, 0.745337962174095, -78.3883285522461, -1.36813442837177, 218, 40, 'PPL', 'P'),
(191507, 'Frio', 34.7153511047363, 0.6058971777635, -102.406951904297, -1.78733848766146, 218, 51, 'PPL', 'P'),
(94364, 'Frio Heights Colonia', 28.8969993591309, 0.504347782763525, -99.109001159668, -1.72977838859908, 218, 51, 'PPL', 'P'),
(94365, 'Frio Town', 29.0191707611084, 0.50648007597981, -99.3024978637695, -1.73315554317741, 218, 51, 'PPL', 'P'),
(191508, 'Friona', 34.6416702270508, 0.604611203852128, -102.723609924316, -1.79286521271364, 218, 51, 'PPL', 'P'),
(81137, 'Fripp Landing', 32.3591690063477, 0.564774042370068, -80.8499984741211, -1.4110986736058, 218, 48, 'PPL', 'P'),
(54874, 'Frisbee', 36.3499984741211, 0.634427156468328, -90.0286102294922, -1.57129566949929, 218, 29, 'PPL', 'P'),
(9010, 'Frisbee (historical)', 36.1791687011719, 0.63144561446993, -91.3249969482422, -1.5939218861206, 218, 4, 'PPL', 'P'),
(32495, 'Frisbie', 39.0144386291504, 0.680930409895937, -94.8869400024414, -1.65608952018492, 218, 20, 'PPL', 'P'),
(161901, 'Frisbie', 40.6641693115234, 0.70972364207452, -76.0663909912109, -1.32760897290598, 218, 45, 'PPL', 'P'),
(41014, 'Frisbie (historical)', 30.5097198486328, 0.532495065219709, -91.9625015258789, -1.6050484399969, 218, 22, 'PPL', 'P'),
(199959, 'Frisbie (historical)', 40.2727813720703, 0.702892633878466, -116.692779541016, -2.0366732162946, 218, 39, 'PPL', 'P'),
(36003, 'Frisby', 36.8480606079102, 0.643119980582456, -84.9102783203125, -1.48196392547421, 218, 21, 'PPL', 'P'),
(170342, 'Frisby (historical)', 45.75, 0.798488132787406, -97.9388885498047, -1.70935607093787, 218, 49, 'PPL', 'P'),
(2620, 'Frisco', 31.5952796936035, 0.551441658741887, -85.8655624389648, -1.49863677863671, 218, 2, 'PPL', 'P'),
(9007, 'Frisco', 36.2563896179199, 0.632793373718592, -94.0780563354492, -1.6419718369303, 218, 4, 'PPL', 'P'),
(27222, 'Frisco', 38.1133308410645, 0.665203112078474, -88.7783279418945, -1.54947412700134, 218, 18, 'PPL', 'P'),
(41012, 'Frisco', 30.5855598449707, 0.533818722860505, -91.5255584716797, -1.5974223450574, 218, 22, 'PPL', 'P'),
(54875, 'Frisco', 36.7588882446289, 0.641563629241413, -89.8622207641602, -1.56839162548861, 218, 29, 'PPL', 'P'),
(64920, 'Frisco', 35.2350006103516, 0.614966772592846, -75.6288909912109, -1.31997315742851, 218, 33, 'PPL', 'P'),
(75883, 'Frisco', 34.6477813720703, 0.604717863453785, -96.57861328125, -1.68561478876814, 218, 42, 'PPL', 'P'),
(87158, 'Frisco', 36.5894393920898, 0.63860618885088, -82.6350021362305, -1.44225286466977, 218, 50, 'PPL', 'P'),
(94366, 'Frisco', 33.1505584716797, 0.57858639420571, -96.8233337402344, -1.68988596652441, 218, 51, 'PPL', 'P'),
(102136, 'Frisco', 36.5938911437988, 0.638683886575683, -82.6324996948242, -1.44220918882789, 218, 53, 'PPL', 'P'),
(161902, 'Frisco', 40.8477783203125, 0.712928223814212, -80.2680587768555, -1.40094190984046, 218, 45, 'PPL', 'P'),
(186736, 'Frisco', 39.5744400024414, 0.690704277675555, -106.096939086914, -1.85174091335452, 218, 7, 'PPL', 'P'),
(192577, 'Frisco', 38.4563903808594, 0.671190630578272, -113.258056640625, -1.97672599278913, 218, 52, 'PPL', 'P'),
(194959, 'Frisco', 47.5122184753418, 0.829244647321595, -115.858329772949, -2.02210932039934, 218, 17, 'PPL', 'P'),
(41013, 'Frisco (historical)', 30.4727802276611, 0.531850347209314, -91.2313919067383, -1.59228816994989, 218, 22, 'PPL', 'P'),
(2618, 'Frisco City', 31.4333305358887, 0.548615112718931, -87.4013900756836, -1.52544202764057, 218, 2, 'PPL', 'P'),
(2619, 'Frisco Quarters', 33.8241691589355, 0.590343118574946, -87.2697219848633, -1.52314398593595, 218, 2, 'PPL', 'P'),
(9009, 'Frisco Springs (historical)', 36.2677803039551, 0.632992178693966, -94.0800018310547, -1.6420057922342, 218, 4, 'PPL', 'P'),
(207469, 'Frisken Wye', 47.2344398498535, 0.82439649571516, -123.481391906738, -2.15515685371806, 218, 56, 'PPL', 'P'),
(54876, 'Fristoe', 38.1166687011719, 0.66526136872732, -93.2755584716797, -1.6279656069673, 218, 29, 'PPL', 'P'),
(191509, 'Fritch', 35.639720916748, 0.622030474489145, -101.602783203125, -1.77330309608452, 218, 51, 'PPL', 'P'),
(155375, 'Fritchleys Corners', 40.6341705322266, 0.70920006460421, -81.2138900756836, -1.41744978017343, 218, 41, 'PPL', 'P'),
(29859, 'Fritchton', 38.6802787780762, 0.675098220266718, -87.4230575561523, -1.52582019651537, 218, 19, 'PPL', 'P'),
(115664, 'Frith Spur', 42.5497207641602, 0.742632723138792, -90.7016677856445, -1.58304273990957, 218, 16, 'PPL', 'P'),
(41023, 'Friths (historical)', 30.9355602264404, 0.539927381900388, -92.1688919067383, -1.60865063168734, 218, 22, 'PPL', 'P'),
(194960, 'Fritser Ford', 45.086669921875, 0.786910838896613, -115.627777099609, -2.01808541715028, 218, 17, 'PPL', 'P'),
(102137, 'Fritters Corner', 38.378059387207, 0.66982349683268, -77.3566665649414, -1.35012852992564, 218, 53, 'PPL', 'P'),
(9011, 'Fritz', 36.1858291625977, 0.631561861451512, -90.2852783203125, -1.57577537276891, 218, 4, 'PPL', 'P'),
(36004, 'Fritz', 37.7013893127441, 0.658013376083587, -83.1516723632813, -1.45127046127883, 218, 21, 'PPL', 'P'),
(161903, 'Fritz (historical)', 41.1419410705566, 0.718062332342694, -76.8955612182617, -1.34208072342753, 218, 45, 'PPL', 'P'),
(29860, 'Fritz Corner', 38.2975006103516, 0.668417480935173, -87.1588897705078, -1.52120959887817, 218, 19, 'PPL', 'P'),
(211837, 'Fritz Creek', 59.7361106872559, 1.04259181382839, -151.295272827148, -2.64060065353685, 218, 1, 'PPL', 'P'),
(130914, 'Fritzburg', 42.1269416809082, 0.735253836127483, -86.0480575561523, -1.50182191930044, 218, 27, 'PPL', 'P'),
(161906, 'Fritztown', 40.295280456543, 0.703285316981199, -76.0688934326172, -1.32765264874786, 218, 45, 'PPL', 'P'),
(32496, 'Frizell', 38.1661109924316, 0.666124299499533, -99.2138900756836, -1.7316090455324, 218, 20, 'PPL', 'P'),
(41015, 'Frizzell Spur', 32.5508308410645, 0.56811917243629, -92.0111083984375, -1.60589678996214, 218, 22, 'PPL', 'P'),
(47310, 'Frizzellburg', 39.6049995422363, 0.691237642262871, -77.0627822875977, -1.34499928166615, 218, 25, 'PPL', 'P'),
(161905, 'Frizzleburg', 41.0763893127441, 0.716918238338396, -80.4550018310547, -1.40420468164997, 218, 45, 'PPL', 'P'),
(115665, 'Froelich', 43.0066719055176, 0.750608025076225, -91.3216705322266, -1.59386382920884, 218, 16, 'PPL', 'P'),
(170343, 'Froelich Addition', 43.5838890075684, 0.760682364005832, -96.7161102294922, -1.68801456322641, 218, 49, 'PPL', 'P'),
(94367, 'Frog', 32.7183303833008, 0.571042590943897, -96.1399993896484, -1.6779595322147, 218, 51, 'PPL', 'P'),
(16144, 'Frog City', 25.7597198486328, 0.449591925749978, -80.5991668701172, -1.40672083624788, 218, 12, 'PPL', 'P'),
(2621, 'Frog Eye', 33.0325012207031, 0.576525906470316, -85.5941696166992, -1.49390008032189, 218, 2, 'PPL', 'P'),
(21309, 'Frog Hollow', 33.5724983215332, 0.585950633831024, -84.4352798461914, -1.47367363815885, 218, 13, 'PPL', 'P'),
(94368, 'Frog Hop', 33.5102806091309, 0.584864729896544, -95.5374984741211, -1.66744390749247, 218, 51, 'PPL', 'P'),
(59987, 'Frog Island', 34.3652801513672, 0.599787287011613, -88.7563934326172, -1.54909129759464, 218, 30, 'PPL', 'P'),
(64923, 'Frog Island', 36.1402816772461, 0.630766907866123, -76.1047210693359, -1.32827795897181, 218, 33, 'PPL', 'P'),
(87160, 'Frog Jump', 35.9155616760254, 0.626844803949736, -89.0083312988281, -1.55348844287047, 218, 50, 'PPL', 'P'),
(64922, 'Frog Level', 35.3352813720703, 0.616717002061246, -81.9208297729492, -1.42978820550376, 218, 33, 'PPL', 'P'),
(102138, 'Frog Level', 37.0997200012207, 0.647512265589296, -81.563606262207, -1.42355347907578, 218, 53, 'PPL', 'P'),
(41016, 'Frog Level (historical)', 32.9880599975586, 0.57575026080283, -93.9550018310547, -1.63982413066921, 218, 22, 'PPL', 'P'),
(2622, 'Frog Mountain', 34.0224990844727, 0.593804628780804, -85.5741729736328, -1.49355107306104, 218, 2, 'PPL', 'P'),
(64924, 'Frog Pond', 35.2733306884766, 0.615635758658674, -80.3166732788086, -1.40179039296376, 218, 33, 'PPL', 'P'),
(87162, 'Frog Pond', 36.5463905334473, 0.637854844528342, -85.9700012207031, -1.50045957924481, 218, 50, 'PPL', 'P'),
(9012, 'Frog Town', 35.0397186279297, 0.611558459029763, -94.3541717529297, -1.64679096008085, 218, 4, 'PPL', 'P'),
(47312, 'Frogeye', 38.0275001525879, 0.663705083965305, -75.690559387207, -1.32104947398306, 218, 25, 'PPL', 'P'),
(41018, 'Frogmore', 30.5191707611084, 0.532660014759725, -91.524169921875, -1.59739811029148, 218, 22, 'PPL', 'P'),
(81138, 'Frogmore', 32.396671295166, 0.565428580786983, -80.5763931274414, -1.40632335945518, 218, 48, 'PPL', 'P'),
(135491, 'Frogner', 46.5541687011719, 0.812523524364341, -92.3063888549805, -1.61105040614561, 218, 28, 'PPL', 'P'),
(94374, 'Frognot', 33.3036117553711, 0.581257677937114, -96.3594436645508, -1.6817895573364, 218, 51, 'PPL', 'P'),
(64925, 'Frogsboro', 36.3452796936035, 0.634344798211617, -79.1822204589844, -1.38199045604929, 218, 33, 'PPL', 'P'),
(21308, 'Frogtown', 33.9002799987793, 0.591671503326678, -83.6013870239258, -1.45911946280157, 218, 13, 'PPL', 'P'),
(27223, 'Frogtown', 38.4422187805176, 0.670943289492031, -89.4916687011719, -1.56192427193941, 218, 18, 'PPL', 'P'),
(36007, 'Frogtown', 37.5902786254883, 0.656074128756819, -85.3724975585938, -1.49003117304828, 218, 21, 'PPL', 'P'),
(47313, 'Frogtown', 39.5580596923828, 0.690418387332535, -76.3705596923828, -1.33291771822295, 218, 25, 'PPL', 'P'),
(54878, 'Frogtown', 37.9797210693359, 0.662871181648974, -90.7663879394531, -1.58417231968593, 218, 29, 'PPL', 'P'),
(59985, 'Frogtown', 32.3041687011719, 0.563814105955149, -89.5755615234375, -1.56338847790673, 218, 30, 'PPL', 'P'),
(102140, 'Frogtown', 39.0661087036133, 0.681832222820065, -77.9338912963867, -1.3602030020133, 218, 53, 'PPL', 'P'),
(109292, 'Frogtown', 37.8280601501465, 0.660224199262517, -82.0677795410156, -1.43235296279156, 218, 58, 'PPL', 'P'),
(161912, 'Frogtown', 40.9511108398438, 0.714731716504414, -79.6572189331055, -1.39028074336466, 218, 45, 'PPL', 'P'),
(36006, 'Frogue', 36.6661109924316, 0.639944360719618, -85.2983322143555, -1.48873674360045, 218, 21, 'PPL', 'P'),
(75887, 'Frogville', 33.8974990844727, 0.591622967215811, -95.3125, -1.6635169433071, 218, 42, 'PPL', 'P'),
(54879, 'Frohna', 37.6386108398438, 0.656917685032102, -89.6213912963867, -1.56418835834014, 218, 29, 'PPL', 'P'),
(64926, 'Frohock Mill (historical)', 35.6569404602051, 0.622331012218161, -80.517219543457, -1.40529058558445, 218, 33, 'PPL', 'P'),
(64927, 'Frohock Mill site', 35.834171295166, 0.625424273824288, -80.6050033569336, -1.40682270215957, 218, 33, 'PPL', 'P'),
(196546, 'Froid', 48.3344383239746, 0.843595090855487, -104.495559692383, -1.82379157034635, 218, 31, 'PPL', 'P'),
(21310, 'Frolona', 33.3244400024414, 0.58162119942591, -85.2361068725586, -1.48765070650791, 218, 13, 'PPL', 'P'),
(161911, 'Froman', 40.2341690063477, 0.702218720964622, -79.9886093139648, -1.39606459662009, 218, 45, 'PPL', 'P'),
(196547, 'Fromberg', 45.392219543457, 0.792243685821442, -108.905830383301, -1.90076531480708, 218, 31, 'PPL', 'P'),
(149003, 'Frone Corner', 42.4583282470703, 0.741037622803889, -75.320556640625, -1.31459170781379, 218, 40, 'PPL', 'P'),
(102141, 'Front Royal', 38.9180603027344, 0.679248290772416, -78.1947174072266, -1.36475527642263, 218, 53, 'PPL', 'P'),
(155376, 'Front Royal (historical)', 40.2986106872559, 0.70334344047199, -82.2619400024414, -1.43574170212063, 218, 41, 'PPL', 'P'),
(102142, 'Front Royal Junction', 38.9311103820801, 0.679476057624645, -78.1855621337891, -1.36459548675722, 218, 53, 'PPL', 'P'),
(16145, 'Frontenac', 28.461389541626, 0.496744957194053, -80.7636108398438, -1.40959092495466, 218, 12, 'PPL', 'P'),
(32511, 'Frontenac', 37.4555587768555, 0.653722823830388, -94.6888885498047, -1.65263287024805, 218, 20, 'PPL', 'P'),
(54880, 'Frontenac', 38.6355590820313, 0.674317714330243, -90.4150009155273, -1.57803945916964, 218, 29, 'PPL', 'P'),
(119715, 'Frontenac', 41.7447204589844, 0.728582817333916, -88.232780456543, -1.53995252715598, 218, 18, 'PPL', 'P'),
(135493, 'Frontenac', 44.5111083984375, 0.776865395264834, -92.3563919067383, -1.61192312403483, 218, 28, 'PPL', 'P'),
(149002, 'Frontenac', 44.2569389343262, 0.772429301258062, -76.0500030517578, -1.32732294940491, 218, 40, 'PPL', 'P'),
(130915, 'Frontier', 41.7816696166992, 0.729227701791879, -84.6047210693359, -1.47663094539133, 218, 27, 'PPL', 'P'),
(135494, 'Frontier', 48.6563911437988, 0.849214227597499, -94.2563934326172, -1.64508440645433, 218, 28, 'PPL', 'P'),
(140056, 'Frontier', 46.8005599975586, 0.816823863734547, -96.8327789306641, -1.69005081619588, 218, 34, 'PPL', 'P'),
(207470, 'Frontier', 48.9997215270996, 0.855206473208232, -117.830001831055, -2.05652148958285, 218, 56, 'PPL', 'P'),
(209469, 'Frontier', 41.8141708374023, 0.729794955104065, -110.536392211914, -1.92922398737372, 218, 59, 'PPL', 'P'),
(188575, 'Frontier Post', 32.6886100769043, 0.570523873742577, -104.394721984863, -1.82203162033997, 218, 38, 'PPL', 'P'),
(196548, 'Frontier Town', 46.5694389343262, 0.812790040210431, -112.305557250977, -1.96010174231653, 218, 31, 'PPL', 'P'),
(21312, 'Frontier Trail', 34.2605590820313, 0.597959559555491, -83.7508316040039, -1.46172776277319, 218, 13, 'PPL', 'P'),
(94369, 'Frontier Village', 33.7291717529297, 0.58868510105929, -96.5875015258789, -1.68576991790163, 218, 51, 'PPL', 'P'),
(140057, 'Frontier Village', 46.8894386291504, 0.818375088490491, -98.7002792358398, -1.7226448453032, 218, 34, 'PPL', 'P'),
(64928, 'Frontis', 36.0661087036133, 0.629472345260235, -80.3086090087891, -1.40164964490015, 218, 33, 'PPL', 'P'),
(94370, 'Fronton', 26.4066696166992, 0.46088332929775, -99.083610534668, -1.7293352385937, 218, 51, 'PPL', 'P'),
(94371, 'Fronton Ranchettes Colonia', 26.4249992370605, 0.461203241523696, -99.0270004272461, -1.72834720582928, 218, 51, 'PPL', 'P'),
(94372, 'Frosa', 31.6272201538086, 0.551999124937067, -96.6972198486328, -1.68768486388346, 218, 51, 'PPL', 'P'),
(162, 'Frost', 38.2705612182617, 0.667947299844719, -79.8808288574219, -1.39418347278411, 218, 58, 'PPL', 'P'),
(36008, 'Frost', 38.728889465332, 0.67594663681099, -82.9274978637695, -1.44735787816334, 218, 21, 'PPL', 'P'),
(41019, 'Frost', 30.4038906097412, 0.53064799655617, -90.7391662597656, -1.58369721174746, 218, 22, 'PPL', 'P'),
(47314, 'Frost', 39.0974998474121, 0.682380101635322, -76.5694427490234, -1.33638888238776, 218, 25, 'PPL', 'P'),
(72613, 'Frost', 39.276668548584, 0.685507185387293, -81.829719543457, -1.42819803201688, 218, 41, 'PPL', 'P'),
(75888, 'Frost', 35.8841705322266, 0.626296925134479, -97.2466735839844, -1.69727464065272, 218, 42, 'PPL', 'P'),
(81139, 'Frost', 34.0761108398438, 0.594740330429804, -81.0858306884766, -1.41521472222858, 218, 48, 'PPL', 'P'),
(87163, 'Frost', 36.0938911437988, 0.629957240315712, -84.2847213745117, -1.47104589711127, 218, 50, 'PPL', 'P'),
(94373, 'Frost', 32.0800018310547, 0.559901655997714, -96.8063888549805, -1.68959022248535, 218, 51, 'PPL', 'P'),
(130917, 'Frost', 43.4527816772461, 0.758394109418208, -84.1213912963867, -1.46819524948045, 218, 27, 'PPL', 'P'),
(135495, 'Frost', 43.5863914489746, 0.760726039847709, -93.9263916015625, -1.63932478796482, 218, 28, 'PPL', 'P'),
(181716, 'Frost', 34.5108299255371, 0.602327609796412, -117.276672363281, -2.0468640685219, 218, 6, 'PPL', 'P'),
(186737, 'Frost', 38.5672187805176, 0.673124951057024, -107.969436645508, -1.88442216098753, 218, 7, 'PPL', 'P'),
(47315, 'Frost (historical)', 39.5569381713867, 0.690398813098523, -78.8627777099609, -1.37641512830721, 218, 25, 'PPL', 'P'),
(188576, 'Frost (historical)', 35.1438903808594, 0.61337659910596, -106.284721374512, -1.85501833255002, 218, 38, 'PPL', 'P'),
(196549, 'Frost (historical)', 47.2916717529297, 0.825395380861021, -112.58332824707, -1.96494976076491, 218, 31, 'PPL', 'P'),
(87164, 'Frost Bottom', 36.0888900756836, 0.629869955210984, -84.2813873291016, -1.47098770704145, 218, 50, 'PPL', 'P'),
(130918, 'Frost Corners', 42.8427810668945, 0.747747590328399, -84.8666687011719, -1.48120279403467, 218, 27, 'PPL', 'P'),
(149004, 'Frost Hollow', 42.8266716003418, 0.747466427096314, -77.5647201538086, -1.35375975007196, 218, 40, 'PPL', 'P'),
(200856, 'Frost Mill', 44.0308303833008, 0.768482962575756, -118.636672973633, -2.07060055700166, 218, 43, 'PPL', 'P'),
(194961, 'Frost Place', 42.1925010681152, 0.736398063289835, -115.940002441406, -2.0235347773728, 218, 17, 'PPL', 'P'),
(41020, 'Frost Town', 32.5569381713867, 0.56822576545892, -92.3888931274414, -1.61249037734701, 218, 22, 'PPL', 'P'),
(149005, 'Frost Valley', 41.9869384765625, 0.732810319248308, -74.5108337402344, -1.30045937717317, 218, 40, 'PPL', 'P'),
(47316, 'Frostburg', 39.6580581665039, 0.692163689952919, -78.9286117553711, -1.37756414915953, 218, 25, 'PPL', 'P'),
(161914, 'Frostburg', 40.9644393920898, 0.714964343625632, -79.0336074829102, -1.37939667030561, 218, 45, 'PPL', 'P'),
(47317, 'Frostown', 39.4830589294434, 0.689109377077734, -77.5897216796875, -1.35419610901657, 218, 25, 'PPL', 'P'),
(16146, 'Frostproof', 27.7455596923828, 0.484251369440705, -81.5308303833008, -1.42298143207363, 218, 12, 'PPL', 'P'),
(181712, 'Frosts (historical)', 39.0008316040039, 0.680692922505729, -120.103332519531, -2.0961985950834, 218, 6, 'PPL', 'P'),
(174210, 'Frostville', 45.0052795410156, 0.785490308771165, -88.3249969482422, -1.54156200856077, 218, 57, 'PPL', 'P'),
(41021, 'Frozard', 30.4058303833008, 0.530681851991528, -91.9933319091797, -1.60558653169515, 218, 22, 'PPL', 'P'),
(36009, 'Frozen Creek', 37.5911102294922, 0.65608864298476, -83.4219436645508, -1.45598758535964, 218, 21, 'PPL', 'P'),
(161915, 'Frugality', 40.6530609130859, 0.709529763947162, -78.4888916015625, -1.36988958468819, 218, 45, 'PPL', 'P'),
(27224, 'Fruit', 38.8308296203613, 0.677725828156245, -89.8625030517578, -1.56839655233663, 218, 18, 'PPL', 'P'),
(54881, 'Fruit City', 37.2905616760254, 0.650843081164658, -91.0388870239258, -1.58892832591865, 218, 29, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(16147, 'Fruit Cove', 30.1108303070068, 0.525533129366564, -81.6419372558594, -1.42492061282137, 218, 12, 'PPL', 'P'),
(204039, 'Fruit Heights', 41.0322189331055, 0.716147319781845, -111.901390075684, -1.95304769437919, 218, 52, 'PPL', 'P'),
(36010, 'Fruit Hill', 37.0047187805176, 0.645854181494613, -87.3683319091797, -1.52486505379041, 218, 21, 'PPL', 'P'),
(72615, 'Fruit Hill', 39.0755615234375, 0.681997205649596, -84.3644409179688, -1.47243726562278, 218, 41, 'PPL', 'P'),
(81140, 'Fruit Hill', 33.9430618286133, 0.592418187117309, -81.8547210693359, -1.42863439096149, 218, 48, 'PPL', 'P'),
(169384, 'Fruit Hill', 41.8499984741211, 0.730420265328016, -71.4625015258789, -1.24725594333806, 218, 47, 'PPL', 'P'),
(130920, 'Fruit Ridge Center', 43.1180610656738, 0.752552132671983, -85.769172668457, -1.49695445977611, 218, 27, 'PPL', 'P'),
(149006, 'Fruit Valley', 43.4352798461914, 0.758088644841176, -76.5641708374023, -1.3362968701721, 218, 40, 'PPL', 'P'),
(16148, 'Fruita', 27.1286106109619, 0.473483576652756, -80.1694412231445, -1.39922070882794, 218, 12, 'PPL', 'P'),
(186738, 'Fruita', 39.1588897705078, 0.683451557920888, -108.728332519531, -1.89766739266904, 218, 7, 'PPL', 'P'),
(192578, 'Fruita', 38.2855606079102, 0.668209088579874, -111.246109008789, -1.94161088223589, 218, 52, 'PPL', 'P'),
(200857, 'Fruita', 45.2361106872559, 0.78951907228921, -116.844436645508, -2.03932013210203, 218, 43, 'PPL', 'P'),
(2625, 'Fruitdale', 31.3425006866455, 0.547029832790548, -88.4077835083008, -1.54300690661019, 218, 2, 'PPL', 'P'),
(29862, 'Fruitdale', 39.3219413757324, 0.686297345282719, -86.2577819824219, -1.5054823010607, 218, 19, 'PPL', 'P'),
(72614, 'Fruitdale', 39.3016700744629, 0.685943544331902, -83.3397216796875, -1.45455254100625, 218, 41, 'PPL', 'P'),
(94375, 'Fruitdale', 32.7069396972656, 0.570843785968523, -96.7688903808594, -1.68893575064747, 218, 51, 'PPL', 'P'),
(181714, 'Fruitdale', 37.3083305358887, 0.651153206273598, -121.91667175293, -2.12784733516179, 218, 6, 'PPL', 'P'),
(202148, 'Fruitdale', 44.6683311462402, 0.779609449873025, -103.696670532227, -1.80984832414313, 218, 49, 'PPL', 'P'),
(209892, 'Fruitdale', 42.4222183227539, 0.740407385731922, -123.306938171387, -2.15211206164377, 218, 43, 'PPL', 'P'),
(2623, 'Fruithurst', 33.7308311462402, 0.588714062936145, -85.4338912963867, -1.49110269591288, 218, 2, 'PPL', 'P'),
(16149, 'Fruitland', 29.4269409179688, 0.513597007808397, -81.6438903808594, -1.42495470128332, 218, 12, 'PPL', 'P'),
(21313, 'Fruitland', 30.8233299255371, 0.537968593629121, -82.8550033569336, -1.44609261032945, 218, 13, 'PPL', 'P'),
(32498, 'Fruitland', 37.2038917541504, 0.649330405665493, -95.710563659668, -1.67046446480084, 218, 20, 'PPL', 'P'),
(47318, 'Fruitland', 38.3219413757324, 0.668844052762776, -75.6205596923828, -1.31982774883299, 218, 25, 'PPL', 'P'),
(54883, 'Fruitland', 37.3891716003418, 0.652564149019122, -93.2333297729492, -1.62722857713562, 218, 29, 'PPL', 'P'),
(64930, 'Fruitland', 34.9244384765625, 0.609546440826208, -79.6505584716797, -1.39016449638307, 218, 33, 'PPL', 'P'),
(87165, 'Fruitland', 35.8933296203613, 0.626456781378911, -88.9319381713867, -1.55215513127072, 218, 50, 'PPL', 'P'),
(94376, 'Fruitland', 33.5016708374023, 0.584714461032037, -97.795280456543, -1.70684963687794, 218, 51, 'PPL', 'P'),
(115666, 'Fruitland', 41.3561096191406, 0.721800278669702, -91.1291732788086, -1.59050411833565, 218, 16, 'PPL', 'P'),
(119716, 'Fruitland', 41.4713897705078, 0.723812296873257, -90.5166702270508, -1.57981392340396, 218, 18, 'PPL', 'P'),
(149007, 'Fruitland', 43.2241706848145, 0.754404094894024, -77.3377838134766, -1.34979896374074, 218, 40, 'PPL', 'P'),
(188577, 'Fruitland', 36.7391700744629, 0.641219482249548, -108.394996643066, -1.89184958410971, 218, 38, 'PPL', 'P'),
(193579, 'Fruitland', 40.2958297729492, 0.703294904361123, -123.824172973633, -2.16113951194887, 218, 6, 'PPL', 'P'),
(194962, 'Fruitland', 44.0077781677246, 0.768080625514072, -116.915557861328, -2.04056143148612, 218, 17, 'PPL', 'P'),
(200858, 'Fruitland', 44.9411087036133, 0.784370316374732, -122.929443359375, -2.14552353426497, 218, 43, 'PPL', 'P'),
(204036, 'Fruitland', 40.2127799987793, 0.70184541235882, -110.838890075684, -1.93450357107675, 218, 52, 'PPL', 'P'),
(207471, 'Fruitland', 48.0711097717285, 0.838999140604282, -118.197776794434, -2.06294037360022, 218, 56, 'PPL', 'P'),
(16150, 'Fruitland Park', 28.8611106872559, 0.503721407275138, -81.9066696166992, -1.4295410641546, 218, 12, 'PPL', 'P'),
(59986, 'Fruitland Park', 30.9158306121826, 0.539583035171441, -89.1711120605469, -1.55632950312137, 218, 30, 'PPL', 'P'),
(130922, 'Fruitport', 43.1319389343262, 0.752794347173126, -86.1547164916992, -1.50368346890241, 218, 27, 'PPL', 'P'),
(181715, 'Fruitridge Manor', 38.5250015258789, 0.672388120962426, -121.441108703613, -2.11954719415039, 218, 6, 'PPL', 'P'),
(161916, 'Fruittown', 40.7775001525879, 0.711701638395149, -77.665283203125, -1.35551490638838, 218, 45, 'PPL', 'P'),
(87166, 'Fruitvale', 35.7466697692871, 0.623897084097182, -89.0305633544922, -1.5538764654413, 218, 50, 'PPL', 'P'),
(94377, 'Fruitvale', 32.6830596923828, 0.570427001257925, -95.8030624389648, -1.67207887305365, 218, 51, 'PPL', 'P'),
(177660, 'Fruitvale', 35.3833312988281, 0.617555631488512, -119.082221984863, -2.07837685422664, 218, 6, 'PPL', 'P'),
(186739, 'Fruitvale', 39.0816688537598, 0.682103798672226, -108.496109008789, -1.89361432780605, 218, 7, 'PPL', 'P'),
(194963, 'Fruitvale', 44.8152809143066, 0.782174207160826, -116.439170837402, -2.03224690940483, 218, 17, 'PPL', 'P'),
(200859, 'Fruitvale', 44.6544418334961, 0.7793670356348, -123.97917175293, -2.16384475098417, 218, 43, 'PPL', 'P'),
(207472, 'Fruitvale', 46.6180610656738, 0.813638656491785, -120.551940917969, -2.10402828868823, 218, 56, 'PPL', 'P'),
(188578, 'Fruitvale (historical)', 35.0341682434082, 0.611461586545111, -106.938606262207, -1.86643077676934, 218, 38, 'PPL', 'P'),
(16151, 'Fruitville', 27.329439163208, 0.476988696121464, -82.4577789306641, -1.4391597362217, 218, 12, 'PPL', 'P'),
(54884, 'Fruitville', 36.6161117553711, 0.639071709409426, -91.7652816772461, -1.60160630428797, 218, 29, 'PPL', 'P'),
(135496, 'Fruitville', 45.7130584716797, 0.797843381487498, -94.0791702270508, -1.64199127800626, 218, 28, 'PPL', 'P'),
(161919, 'Fruitville', 40.394718170166, 0.705020832484576, -75.5350036621094, -1.31833451440978, 218, 45, 'PPL', 'P'),
(54885, 'Frumet', 38.1594390869141, 0.666007852780869, -90.6930618286133, -1.58289253762409, 218, 29, 'PPL', 'P'),
(161920, 'Frush Valley', 40.3969383239746, 0.705059581478437, -75.9100036621094, -1.32487949910476, 218, 45, 'PPL', 'P'),
(161921, 'Frutchey', 41.0533294677734, 0.716515768118658, -75.0963897705078, -1.31067925785635, 218, 45, 'PPL', 'P'),
(181717, 'Fruto', 39.5900001525879, 0.690975853527716, -122.448890686035, -2.13713630788593, 218, 6, 'PPL', 'P'),
(21314, 'Fry', 34.9869384765625, 0.610637271608705, -84.3930587768555, -1.47293674148523, 218, 13, 'PPL', 'P'),
(36011, 'Fry', 37.146671295166, 0.648331720256713, -85.4883270263672, -1.49205277863176, 218, 21, 'PPL', 'P'),
(94378, 'Fry', 31.8250007629395, 0.555451047763001, -99.1833267211914, -1.73107561436606, 218, 51, 'PPL', 'P'),
(109293, 'Fry', 38.0149993896484, 0.663486904493, -82.0833282470703, -1.43262433890664, 218, 58, 'PPL', 'P'),
(178229, 'Fry', 31.5566692352295, 0.550767779117556, -110.294441223145, -1.92500114599123, 218, 5, 'PPL', 'P'),
(192579, 'Fry Canyon', 37.6311111450195, 0.656786790664524, -110.155563354492, -1.9225772699251, 218, 52, 'PPL', 'P'),
(9013, 'Fryatt', 36.4636116027832, 0.636410079636974, -91.6511077880859, -1.59961359400232, 218, 4, 'PPL', 'P'),
(155378, 'Fryburg', 40.6136093139648, 0.708841203647322, -81.8255615234375, -1.42812546087717, 218, 41, 'PPL', 'P'),
(161923, 'Fryburg', 41.3536109924316, 0.721756669406852, -79.4383316040039, -1.38646043878094, 218, 45, 'PPL', 'P'),
(198313, 'Fryburg', 46.8705596923828, 0.818045588884621, -103.30249786377, -1.80296871325719, 218, 34, 'PPL', 'P'),
(94379, 'Frydek', 29.753059387207, 0.519288848848169, -96.0880584716797, -1.67705299217964, 218, 51, 'PPL', 'P'),
(127540, 'Frye', 44.6213912963867, 0.778790194942689, -70.5805587768555, -1.23186313855351, 218, 26, 'PPL', 'P'),
(161922, 'Frye', 40.1838912963867, 0.701341209385441, -79.9355621337891, -1.39513874866712, 218, 45, 'PPL', 'P'),
(127541, 'Frye Island', 43.8472213745117, 0.765278380836063, -70.5194396972656, -1.23079640937888, 218, 26, 'PPL', 'P'),
(41022, 'Fryeburg', 32.4127807617188, 0.565709744019068, -93.2341690063477, -1.62724322452162, 218, 22, 'PPL', 'P'),
(127542, 'Fryeburg', 44.0163917541504, 0.768230960957607, -70.9811096191406, -1.23885406957302, 218, 26, 'PPL', 'P'),
(127543, 'Fryeburg Center', 44.0694389343262, 0.769156808910573, -70.9452819824219, -1.23822875934907, 218, 26, 'PPL', 'P'),
(207473, 'Fryelands', 47.8716697692871, 0.835518255901494, -122.007781982422, -2.12943750864868, 218, 56, 'PPL', 'P'),
(36012, 'Fryer', 37.2622184753418, 0.650348398992176, -87.8197174072266, -1.53274321692708, 218, 21, 'PPL', 'P'),
(135498, 'Fryers Mobile Home Park', 44.0691719055176, 0.769152148378665, -92.7555618286133, -1.61888995344647, 218, 28, 'PPL', 'P'),
(102143, 'Fryes Store (historical)', 36.6855583190918, 0.640283780600548, -80.033332824707, -1.39684516913559, 218, 53, 'PPL', 'P'),
(124897, 'Fryeville', 42.6277809143066, 0.74399512977345, -72.2255630493164, -1.26057387931733, 218, 23, 'PPL', 'P'),
(64932, 'Frying Pan', 35.8025016784668, 0.624871534740042, -76.103889465332, -1.32826344474387, 218, 33, 'PPL', 'P'),
(36013, 'Frymire', 37.9605598449707, 0.662536755195087, -86.3963928222656, -1.50790151659493, 218, 21, 'PPL', 'P'),
(169385, 'Frys Corner', 41.6455612182617, 0.726852162099528, -71.4958267211914, -1.24783757772013, 218, 47, 'PPL', 'P'),
(155379, 'Frys Corners', 40.0480613708496, 0.69897052996208, -84.6305618286133, -1.47708195172193, 218, 41, 'PPL', 'P'),
(9014, 'Frys Mill', 35.5483283996582, 0.620435374154242, -90.334716796875, -1.57663823696209, 218, 4, 'PPL', 'P'),
(161925, 'Frystown', 40.4497184753418, 0.705980768899495, -76.3344421386719, -1.33228734799293, 218, 45, 'PPL', 'P'),
(161924, 'Frysville', 40.1697196960449, 0.7010938682992, -76.1022186279297, -1.32823428312993, 218, 45, 'PPL', 'P'),
(72617, 'Frytown', 39.7169418334961, 0.69319140381758, -84.2738876342773, -1.47085681267387, 218, 41, 'PPL', 'P'),
(102144, 'Frytown', 38.707218170166, 0.675568401357172, -77.7658309936523, -1.35726979638869, 218, 53, 'PPL', 'P'),
(124898, 'Fryville', 42.4083290100098, 0.740164971493698, -71.6202774047852, -1.2500096519052, 218, 23, 'PPL', 'P'),
(181718, 'Fuchs', 38.3474998474121, 0.669290132245364, -120.455001831055, -2.1023363824477, 218, 6, 'PPL', 'P'),
(87167, 'Fudgearound', 35.6824989318848, 0.622777091700749, -86.1797180175781, -1.50411982784702, 218, 50, 'PPL', 'P'),
(81141, 'Fudges (historical)', 34.723331451416, 0.606036461088511, -80.9047164916992, -1.41205368317271, 218, 48, 'PPL', 'P'),
(109294, 'Fudges Creek', 38.4066696166992, 0.67032283953707, -82.206672668457, -1.43477710517381, 218, 58, 'PPL', 'P'),
(54886, 'Fuersville', 38.3936080932617, 0.670094872947759, -91.6747207641602, -1.60002571818101, 218, 29, 'PPL', 'P'),
(59989, 'Fugate', 32.7488899230957, 0.571575955531213, -90.2019424438477, -1.57432088733956, 218, 30, 'PPL', 'P'),
(75890, 'Fugate', 34.457218170166, 0.601391908147413, -95.9216690063477, -1.67414894816896, 218, 42, 'PPL', 'P'),
(102145, 'Fugates Hill', 36.7491683959961, 0.641393985879975, -82.3050003051758, -1.43649324618026, 218, 53, 'PPL', 'P'),
(36014, 'Fuget', 37.8883285522461, 0.661276081314071, -82.9236068725586, -1.44728996755555, 218, 21, 'PPL', 'P'),
(54887, 'Fuget', 36.8088912963867, 0.642436347130632, -89.1919403076172, -1.55669302461016, 218, 29, 'PPL', 'P'),
(78310, 'Fuhrmans Mill', 39.7580604553223, 0.693909059152329, -76.9241714477539, -1.34258006613192, 218, 45, 'PPL', 'P'),
(94380, 'Fulbright', 33.5483283996582, 0.585528789114356, -95.2508316040039, -1.66244062675254, 218, 51, 'PPL', 'P'),
(59988, 'Fulcher', 33.3380584716797, 0.581858886553199, -89.1230621337891, -1.5554908736941, 218, 30, 'PPL', 'P'),
(64933, 'Fulcher Landing', 34.5652809143066, 0.603277958831407, -77.383056640625, -1.35058912363617, 218, 33, 'PPL', 'P'),
(64935, 'Fulchertown', 35.1222190856934, 0.612998363652142, -83.3583297729492, -1.45487731350118, 218, 33, 'PPL', 'P'),
(29863, 'Fulda', 38.1113891601563, 0.665169223353603, -86.8361129760742, -1.51557608106627, 218, 19, 'PPL', 'P'),
(72616, 'Fulda', 39.7244415283203, 0.693322298185158, -81.4158325195313, -1.42097434071809, 218, 41, 'PPL', 'P'),
(94381, 'Fulda', 33.6872215270996, 0.5879529314966, -99.0227813720703, -1.72827356942514, 218, 51, 'PPL', 'P'),
(135499, 'Fulda', 43.8705596923828, 0.765685711324791, -95.5999984741211, -1.66853473827497, 218, 28, 'PPL', 'P'),
(41026, 'Fulda (historical)', 30.7830600738525, 0.537265752127936, -91.4111099243164, -1.59542484108179, 218, 22, 'PPL', 'P'),
(64934, 'Fulford', 33.9674987792969, 0.592844692365885, -78.3302764892578, -1.36712122873505, 218, 33, 'PPL', 'P'),
(186740, 'Fulford', 39.5149993896484, 0.689666843272915, -106.655830383301, -1.8614954066372, 218, 7, 'PPL', 'P'),
(36015, 'Fulgham', 36.6527786254883, 0.639711667019372, -88.8702774047852, -1.55107894787422, 218, 21, 'PPL', 'P'),
(102146, 'Fulkerson', 36.6624984741211, 0.63988131038081, -82.4347229003906, -1.43875733258099, 218, 53, 'PPL', 'P'),
(112898, 'Fulkerson', 38.8544387817383, 0.678137885755907, -94.0888900756836, -1.6421609213677, 218, 29, 'PPL', 'P'),
(102147, 'Fulks Run', 38.6599998474121, 0.674744286157847, -78.9063873291016, -1.37717625974676, 218, 53, 'PPL', 'P'),
(2624, 'Fuller', 32.9647216796875, 0.575342930314102, -85.904167175293, -1.4993105583925, 218, 2, 'PPL', 'P'),
(27225, 'Fuller', 39.5938911437988, 0.691043764135513, -88.4700012207031, -1.54409281054467, 218, 18, 'PPL', 'P'),
(32499, 'Fuller', 37.5222206115723, 0.654886292331616, -94.6194381713867, -1.6514207324779, 218, 20, 'PPL', 'P'),
(47329, 'Fuller', 39.4136085510254, 0.687897239307585, -77.4705581665039, -1.35211631336327, 218, 25, 'PPL', 'P'),
(87168, 'Fuller', 36.5230598449707, 0.637447647197669, -81.8080596923828, -1.42781999630014, 218, 50, 'PPL', 'P'),
(130924, 'Fuller', 46.2969398498535, 0.808034033977713, -89.1036071777344, -1.55515132065512, 218, 27, 'PPL', 'P'),
(161927, 'Fuller', 41.0980606079102, 0.717296473792215, -78.9847183227539, -1.37854339349235, 218, 45, 'PPL', 'P'),
(181719, 'Fuller', 32.860279083252, 0.57352006312697, -115.405281066895, -2.01420212880678, 218, 6, 'PPL', 'P'),
(191510, 'Fuller', 35.2413902282715, 0.615078292463493, -100.081390380859, -1.74674978211978, 218, 51, 'PPL', 'P'),
(194964, 'Fuller', 42.9294395446777, 0.749260066090482, -114.82250213623, -2.00403071765544, 218, 17, 'PPL', 'P'),
(196550, 'Fuller', 46.2619400024414, 0.807423171402676, -112.202781677246, -1.95830797016431, 218, 31, 'PPL', 'P'),
(207474, 'Fuller', 46.9741706848145, 0.819853941843812, -123.469718933105, -2.15495312189467, 218, 56, 'PPL', 'P'),
(181720, 'Fuller Acres', 35.2999992370605, 0.616101212638193, -118.910827636719, -2.07538545853221, 218, 6, 'PPL', 'P'),
(102148, 'Fuller Corner', 37.042781829834, 0.646518507028533, -82.0250015258789, -1.43160634557996, 218, 53, 'PPL', 'P'),
(2626, 'Fuller Crossroad', 33.389720916748, 0.582760566319273, -85.6152801513672, -1.49426852865871, 218, 2, 'PPL', 'P'),
(16156, 'Fuller Heights', 27.9088897705078, 0.487102017071526, -81.9983291625977, -1.43114082502141, 218, 12, 'PPL', 'P'),
(124899, 'Fuller Heights', 42.4452781677246, 0.74080985595166, -71.2138900756836, -1.24291685497399, 218, 23, 'PPL', 'P'),
(64936, 'Fuller Mill', 35.7777786254883, 0.624440036064422, -80.0227813720703, -1.39666101154621, 218, 33, 'PPL', 'P'),
(178230, 'Fuller Ranch', 33.4047203063965, 0.583022355054428, -111.783889770508, -1.95099692718177, 218, 5, 'PPL', 'P'),
(124900, 'Fuller Shores', 41.8180618286133, 0.729862865711862, -70.9402770996094, -1.23814140766532, 218, 23, 'PPL', 'P'),
(109295, 'Fuller Trailer Park', 37.7836112976074, 0.659448420436977, -80.458610534668, -1.40426766540975, 218, 58, 'PPL', 'P'),
(64937, 'Fullerdale', 35.815559387207, 0.625099434750325, -80.0950012207031, -1.39792148569015, 218, 33, 'PPL', 'P'),
(16152, 'Fullers', 28.5991706848145, 0.499149691789854, -81.5538864135742, -1.42338383571434, 218, 12, 'PPL', 'P'),
(36016, 'Fullers', 38.170280456543, 0.666197070376319, -82.6433334350586, -1.44239827326529, 218, 21, 'PPL', 'P'),
(102149, 'Fullers', 36.9986114501953, 0.645747588471982, -82.0999984741211, -1.43291528925573, 218, 53, 'PPL', 'P'),
(149009, 'Fullers', 43.4775009155273, 0.758825541514801, -74.0950012207031, -1.29320173057049, 218, 40, 'PPL', 'P'),
(2629, 'Fullers Crossroads', 31.8177795410156, 0.555325013664413, -86.3111114501953, -1.50641307586169, 218, 2, 'PPL', 'P'),
(16153, 'Fullers Earth', 27.5194396972656, 0.480304831021317, -82.5175018310547, -1.44020209747235, 218, 12, 'PPL', 'P'),
(119718, 'Fullersburg', 41.8180618286133, 0.729862865711862, -87.918327331543, -1.53446428478155, 218, 18, 'PPL', 'P'),
(2627, 'Fullerton', 34.2961082458496, 0.598580009510453, -85.4933319091797, -1.49214013031552, 218, 2, 'PPL', 'P'),
(36017, 'Fullerton', 38.7216682434082, 0.675820602712402, -82.9819412231445, -1.44830809404028, 218, 21, 'PPL', 'P'),
(41024, 'Fullerton', 30.9930591583252, 0.540930927578157, -92.9819412231445, -1.62284101923972, 218, 22, 'PPL', 'P'),
(47320, 'Fullerton', 39.3716697692871, 0.687165269481976, -76.5113906860352, -1.33537568275104, 218, 25, 'PPL', 'P'),
(94382, 'Fullerton', 30.1000003814697, 0.525344111508196, -94.8874969482422, -1.6560992407229, 218, 51, 'PPL', 'P'),
(119719, 'Fullerton', 40.2102813720703, 0.70180180309597, -88.7444381713867, -1.54888263892323, 218, 18, 'PPL', 'P'),
(140059, 'Fullerton', 46.1652793884277, 0.805736125431138, -98.4266662597656, -1.71786939799452, 218, 34, 'PPL', 'P'),
(141857, 'Fullerton', 41.3633308410645, 0.72192631276829, -97.9688873291016, -1.70987964840818, 218, 35, 'PPL', 'P'),
(161932, 'Fullerton', 40.6316719055176, 0.70915645534136, -75.4736099243164, -1.31726299154519, 218, 45, 'PPL', 'P'),
(181722, 'Fullerton', 33.8702812194824, 0.591147925856368, -117.924438476563, -2.0581697199815, 218, 6, 'PPL', 'P'),
(188579, 'Fullerton (historical)', 33.8061103820801, 0.590027933459936, -108.146667480469, -1.88751542259366, 218, 38, 'PPL', 'P'),
(112454, 'Fullerton Apartments', 35.3011093139648, 0.616120587135123, -81.522216796875, -1.42283109663009, 218, 33, 'PPL', 'P'),
(47321, 'Fullerton Farms', 39.3916702270508, 0.687514343321858, -76.4933319091797, -1.33506049763603, 218, 25, 'PPL', 'P'),
(47322, 'Fullerton Heights', 39.3638916015625, 0.68702951484541, -76.5236129760742, -1.33558900195435, 218, 25, 'PPL', 'P'),
(155380, 'Fullertown', 41.4925003051758, 0.724180745210069, -81.2986068725586, -1.41892836721064, 218, 41, 'PPL', 'P'),
(16154, 'Fullerville', 29.0086097717285, 0.506295751942863, -81.4544372558594, -1.42164812047388, 218, 12, 'PPL', 'P'),
(149010, 'Fullerville', 44.2680587768555, 0.772623379122502, -75.3422164916992, -1.31496974353052, 218, 40, 'PPL', 'P'),
(191511, 'Fullerville', 32.9252815246582, 0.574654569751344, -101.065002441406, -1.76391705113865, 218, 51, 'PPL', 'P'),
(124901, 'Fullerville (historical)', 42.4266700744629, 0.740485083456725, -71.6847229003906, -1.2511344379916, 218, 23, 'PPL', 'P'),
(194965, 'Fullmer', 43.3086090087891, 0.755877821662247, -112.668891906738, -1.96644312834618, 218, 17, 'PPL', 'P'),
(119720, 'Fulls', 40.1133308410645, 0.700109697118361, -88.0902786254883, -1.53746540101396, 218, 18, 'PPL', 'P'),
(72618, 'Fullview Heights', 39.2811088562012, 0.685584683375014, -82.1500015258789, -1.43378800714495, 218, 41, 'PPL', 'P'),
(21316, 'Fullwood Springs', 33.9191703796387, 0.59200120266963, -85.3133316040039, -1.4889985323356, 218, 13, 'PPL', 'P'),
(9015, 'Fulmer Field Estates', 34.9488906860352, 0.609973212390893, -91.9555587768555, -1.6049272661673, 218, 4, 'PPL', 'P'),
(149011, 'Fulmer Valley', 42.0977783203125, 0.734744839464141, -77.8302764892578, -1.35839458247508, 218, 40, 'PPL', 'P'),
(113303, 'Fulmor', 40.1655616760254, 0.701021297159495, -75.1050033569336, -1.31082959329989, 218, 45, 'PPL', 'P'),
(64938, 'Fulp', 36.2586097717285, 0.632832122712452, -80.147216796875, -1.39883281941517, 218, 33, 'PPL', 'P'),
(94383, 'Fulshear', 29.6897201538086, 0.518183370679677, -95.8994369506836, -1.67376092559814, 218, 51, 'PPL', 'P'),
(2628, 'Fulton', 31.788330078125, 0.554811023574028, -87.7272186279297, -1.53112880867428, 218, 2, 'PPL', 'P'),
(9016, 'Fulton', 33.6144409179688, 0.58668267023566, -93.8133316040039, -1.63735151875512, 218, 4, 'PPL', 'P'),
(16155, 'Fulton', 30.3838901519775, 0.530298922716288, -81.4930572509766, -1.42232216654578, 218, 12, 'PPL', 'P'),
(32500, 'Fulton', 38.0099983215332, 0.663399619388273, -94.7194366455078, -1.65316603509828, 218, 20, 'PPL', 'P'),
(36018, 'Fulton', 36.5041694641113, 0.637117947854717, -88.8741683959961, -1.55114685848202, 218, 21, 'PPL', 'P'),
(41025, 'Fulton', 30.5125007629395, 0.532543601330575, -93.2005615234375, -1.62665666329153, 218, 22, 'PPL', 'P'),
(47324, 'Fulton', 39.1508293151855, 0.683310876436305, -76.9233322143555, -1.34256541874592, 218, 25, 'PPL', 'P'),
(54888, 'Fulton', 38.8466682434082, 0.678002264277395, -91.9477767944336, -1.6047914449517, 218, 29, 'PPL', 'P'),
(59990, 'Fulton', 34.2738914489746, 0.598192253255737, -88.4091720581055, -1.54303114137611, 218, 30, 'PPL', 'P'),
(81142, 'Fulton', 34.7780609130859, 0.606991670392495, -79.7919387817383, -1.39263204829109, 218, 48, 'PPL', 'P'),
(87170, 'Fulton', 35.6119384765625, 0.621545579433669, -89.8824996948242, -1.56874555959748, 218, 50, 'PPL', 'P'),
(94384, 'Fulton', 28.0611095428467, 0.489758753285475, -97.0408325195313, -1.6936820363422, 218, 51, 'PPL', 'P'),
(115670, 'Fulton', 42.1536102294922, 0.735719290107001, -90.6780624389648, -1.58263074888894, 218, 16, 'PPL', 'P'),
(119721, 'Fulton', 41.8672218322754, 0.730720869636059, -90.1594390869141, -1.57357906381792, 218, 18, 'PPL', 'P'),
(122656, 'Fulton', 40.9472198486328, 0.714663805896617, -86.2627792358398, -1.5055695195864, 218, 19, 'PPL', 'P'),
(130926, 'Fulton', 47.2988891601563, 0.825521348380582, -88.3600006103516, -1.54217293771483, 218, 27, 'PPL', 'P'),
(149017, 'Fulton', 43.3227806091309, 0.756125162748488, -76.4175033569336, -1.33373703973231, 218, 40, 'PPL', 'P'),
(155381, 'Fulton', 40.4625015258789, 0.706203875219817, -82.8288879394531, -1.44563681030888, 218, 41, 'PPL', 'P'),
(161929, 'Fulton', 40.2733306884766, 0.702902221258391, -79.7216720581055, -1.3914056626091, 218, 45, 'PPL', 'P'),
(170345, 'Fulton', 43.7247200012207, 0.76314032853392, -97.8233337402344, -1.70733925904435, 218, 49, 'PPL', 'P'),
(174211, 'Fulton', 42.8080596923828, 0.747141588022351, -89.1275024414063, -1.55556837168182, 218, 57, 'PPL', 'P'),
(177224, 'Fulton', 40.077220916748, 0.699479460046394, -80.7119369506836, -1.4086890454515, 218, 58, 'PPL', 'P'),
(181723, 'Fulton', 38.4963912963867, 0.671888778258037, -122.768890380859, -2.14272135616599, 218, 6, 'PPL', 'P'),
(200860, 'Fulton', 45.7305603027344, 0.79814884606453, -118.748062133789, -2.07254466459742, 218, 43, 'PPL', 'P'),
(64939, 'Fulton (historical)', 35.8886108398438, 0.626374423122201, -80.4166717529297, -1.40353569558414, 218, 33, 'PPL', 'P'),
(200861, 'Fulton (historical)', 45.4708290100098, 0.793615679836024, -122.670562744141, -2.14100521515954, 218, 43, 'PPL', 'P'),
(81143, 'Fulton Acres', 34.898609161377, 0.609095634232685, -82.1963882446289, -1.43459760811634, 218, 48, 'PPL', 'P'),
(2630, 'Fulton Bridge', 34.0883293151855, 0.594953583054092, -88.0122222900391, -1.53610306095833, 218, 2, 'PPL', 'P'),
(119722, 'Fulton Center (historical)', 40.5097198486328, 0.707027990419142, -90.1233291625977, -1.57294882674595, 218, 18, 'PPL', 'P'),
(81144, 'Fulton Crossroads', 33.7277793884277, 0.588660799714343, -80.5105590820313, -1.40517433860287, 218, 48, 'PPL', 'P'),
(161931, 'Fulton Run', 40.6641693115234, 0.70972364207452, -79.2027816772461, -1.38234931700618, 218, 45, 'PPL', 'P'),
(2631, 'Fulton Springs', 33.6183280944824, 0.58675051426443, -86.8016662597656, -1.51497487245018, 218, 2, 'PPL', 'P'),
(181724, 'Fulton Wells', 33.9427795410156, 0.592413260269292, -118.081672668457, -2.06091397432677, 218, 6, 'PPL', 'P'),
(2632, 'Fultondale', 33.6047210693359, 0.586513026874222, -86.7938919067383, -1.51483918439264, 218, 2, 'PPL', 'P'),
(72620, 'Fultonham', 39.8555603027344, 0.695610752509863, -82.1416702270508, -1.43364259854943, 218, 41, 'PPL', 'P'),
(149015, 'Fultonham', 42.5683288574219, 0.742957495633728, -74.3958282470703, -1.29845215265958, 218, 40, 'PPL', 'P'),
(149016, 'Fultonville', 42.9477806091309, 0.749580178053509, -74.3708267211914, -1.29801579371497, 218, 40, 'PPL', 'P'),
(27226, 'Fults', 38.1661109924316, 0.666124299499533, -90.2158279418945, -1.57456323499876, 218, 18, 'PPL', 'P'),
(36020, 'Fultz', 38.2827796936035, 0.668160552469007, -83.0122222900391, -1.44883659835861, 218, 21, 'PPL', 'P'),
(72621, 'Funderberg (historical)', 39.9305610656738, 0.696919762764664, -84.0005569458008, -1.46608629221322, 218, 41, 'PPL', 'P'),
(141860, 'Funk', 40.4625015258789, 0.706203875219817, -99.248893737793, -1.73221997468647, 218, 35, 'PPL', 'P'),
(155385, 'Funk', 40.753059387207, 0.711275066567545, -82.1163864135742, -1.43320131275681, 218, 41, 'PPL', 'P'),
(21320, 'Funkhouser', 34.3869400024414, 0.600165322728349, -84.7019424438477, -1.47832777847987, 218, 13, 'PPL', 'P'),
(27227, 'Funkhouser', 39.0941696166992, 0.682321978144531, -88.6211090087891, -1.54673013897218, 218, 18, 'PPL', 'P'),
(135501, 'Funkley', 47.7836112976074, 0.83398134563641, -94.4311065673828, -1.64813372590247, 218, 28, 'PPL', 'P'),
(119726, 'Funks Grove', 40.3636093139648, 0.704477880517336, -89.1144409179688, -1.55534040509251, 218, 18, 'PPL', 'P'),
(47325, 'Funkstown', 39.6088905334473, 0.691305552870668, -77.704719543457, -1.35620320037211, 218, 25, 'PPL', 'P'),
(211838, 'Funny River', 60.5019416809082, 1.05595808618144, -150.762222290039, -2.63129716658477, 218, 1, 'PPL', 'P'),
(9023, 'Funston', 35.0572204589844, 0.611863923606795, -92.1869430541992, -1.60896568364429, 218, 4, 'PPL', 'P'),
(21318, 'Funston', 31.1997203826904, 0.544537846379533, -83.8736114501953, -1.46387067534432, 218, 13, 'PPL', 'P'),
(36021, 'Funston', 36.8969383239746, 0.643973057658635, -84.4058303833008, -1.47315964806847, 218, 21, 'PPL', 'P'),
(41027, 'Funston', 32.0497207641602, 0.559373151679388, -93.9688873291016, -1.6400664783284, 218, 22, 'PPL', 'P'),
(64942, 'Funston', 34.100830078125, 0.595171762526396, -78.0272216796875, -1.36183192449405, 218, 33, 'PPL', 'P'),
(94385, 'Funston', 32.7513885498047, 0.571619564794063, -99.7997207641602, -1.74183371990555, 218, 51, 'PPL', 'P'),
(186741, 'Funston', 39.5605583190918, 0.690461996595385, -107.348609924316, -1.87358669061838, 218, 7, 'PPL', 'P'),
(198314, 'Funston', 47.9958305358887, 0.837685270080492, -100.26277923584, -1.74991561486561, 218, 34, 'PPL', 'P'),
(209957, 'Funter', 58.2563896179199, 1.01676580915734, -134.89582824707, -2.35437635011615, 218, 1, 'PPL', 'P'),
(94386, 'Fuqua', 30.4469394683838, 0.531399340878709, -94.7361068725586, -1.65345698544738, 218, 51, 'PPL', 'P'),
(64943, 'Fuquay-Varina', 35.584171295166, 0.621060950694302, -78.8002777099609, -1.37532429752472, 218, 33, 'PPL', 'P'),
(64946, 'Furches', 36.4533309936523, 0.63623064915853, -81.2811126708984, -1.41862303579166, 218, 33, 'PPL', 'P'),
(191512, 'Furguson', 34.1286087036133, 0.595656591002845, -101.748329162598, -1.77584335229029, 218, 51, 'PPL', 'P'),
(32501, 'Furley', 37.8791694641113, 0.661116225069639, -97.2125015258789, -1.6966782257266, 218, 20, 'PPL', 'P'),
(161933, 'Furlong', 40.2961082458496, 0.703299764630112, -75.0824966430664, -1.3104367770391, 218, 45, 'PPL', 'P'),
(9020, 'Furlow', 34.8330612182617, 0.607951606807414, -91.9802780151367, -1.60535869826389, 218, 4, 'PPL', 'P'),
(2635, 'Furman', 32.0066719055176, 0.558621807356849, -86.9669418334961, -1.5178594753849, 218, 2, 'PPL', 'P'),
(27228, 'Furman', 38.601390838623, 0.673721365983147, -89.966667175293, -1.57021455925477, 218, 18, 'PPL', 'P'),
(81145, 'Furman', 32.6813888549805, 0.570397839643989, -81.1883316040039, -1.41700370069084, 218, 48, 'PPL', 'P'),
(72622, 'Furmandale', 39.3436088562012, 0.686675514157511, -84.5377807617188, -1.47546261662111, 218, 41, 'PPL', 'P'),
(145280, 'Furmans Corner', 40.4597206115723, 0.70615533910895, -74.7869415283203, -1.30527836716567, 218, 37, 'PPL', 'P'),
(29871, 'Furnace', 39.0141716003418, 0.68092574936403, -86.9130630493164, -1.51691911320399, 218, 19, 'PPL', 'P'),
(36022, 'Furnace', 37.7619400024414, 0.659070184983158, -83.831672668457, -1.46313870551872, 218, 21, 'PPL', 'P'),
(47327, 'Furnace', 38.2041702270508, 0.666788558454426, -75.4719390869141, -1.31723382993125, 218, 25, 'PPL', 'P'),
(87171, 'Furnace', 35.8933296203613, 0.626456781378911, -87.6405563354492, -1.52961626633316, 218, 50, 'PPL', 'P'),
(102150, 'Furnace', 38.4466705322266, 0.671020987216834, -78.5577774047852, -1.37109186876231, 218, 53, 'PPL', 'P'),
(124902, 'Furnace', 42.3458290100098, 0.739074140711201, -72.1611099243164, -1.25944896007288, 218, 23, 'PPL', 'P'),
(21319, 'Furnace (historical)', 34.6488914489746, 0.604737237950716, -85.0905609130859, -1.48511045030214, 218, 13, 'PPL', 'P'),
(109296, 'Furnace (historical)', 39.0325012207031, 0.681245661589975, -78.6030578613281, -1.37188216181579, 218, 58, 'PPL', 'P'),
(47328, 'Furnace Branch', 39.1813888549805, 0.68384424102362, -76.6138916015625, -1.3371646612133, 218, 25, 'PPL', 'P'),
(181725, 'Furnace Creek', 36.4580612182617, 0.636313207152322, -116.870002746582, -2.03976634474267, 218, 6, 'PPL', 'P'),
(47336, 'Furnace Ford', 39.2430610656738, 0.684920624157203, -77.4397201538086, -1.35157808850697, 218, 25, 'PPL', 'P'),
(102152, 'Furnace Hill', 36.8236083984375, 0.64269320901777, -81.4908294677734, -1.42228328439386, 218, 53, 'PPL', 'P'),
(161934, 'Furnace Hill', 41.1705589294434, 0.718561808205138, -80.4658279418945, -1.40439363292931, 218, 45, 'PPL', 'P'),
(2637, 'Furnace Hill (historical)', 34.7555618286133, 0.606598987289763, -87.7055587768555, -1.53075077295754, 218, 2, 'PPL', 'P'),
(102151, 'Furnace Mountain', 39.2594413757324, 0.685206514500223, -77.5447235107422, -1.35341074281111, 218, 53, 'PPL', 'P'),
(161935, 'Furnace Run', 40.8527793884277, 0.713015508918939, -79.5500030517578, -1.38840947322471, 218, 45, 'PPL', 'P'),
(149018, 'Furnace Village', 43.2411117553711, 0.75469977235405, -76.8213882446289, -1.34078616082164, 218, 40, 'PPL', 'P'),
(149019, 'Furnace Woods', 41.264720916748, 0.720205244913826, -73.8863906860352, -1.28956078988619, 218, 40, 'PPL', 'P'),
(149021, 'Furnaceville', 43.2522201538086, 0.754893650481408, -77.274169921875, -1.34868869188229, 218, 40, 'PPL', 'P'),
(193580, 'Furnaceville (historical)', 40.7430610656738, 0.711100562937118, -122.064437866211, -2.13042634036142, 218, 6, 'PPL', 'P'),
(54890, 'Furner', 38.9174995422363, 0.67923850365541, -92.4000015258789, -1.61268425547437, 218, 29, 'PPL', 'P'),
(122658, 'Furnessville', 41.651668548584, 0.726958755122158, -87.0074996948242, -1.51856734360264, 218, 19, 'PPL', 'P'),
(78312, 'Furniss', 39.7938919067383, 0.694534435955307, -76.2222213745117, -1.33032872616923, 218, 45, 'PPL', 'P'),
(149022, 'Furniss', 43.3952789306641, 0.757390497161412, -76.5336074829102, -1.33576343900575, 218, 40, 'PPL', 'P'),
(21321, 'Furniture City', 33.8047218322754, 0.590003698694016, -84.6108322143555, -1.47673760499299, 218, 13, 'PPL', 'P'),
(207475, 'Furport', 48.2419395446777, 0.841980682602681, -117.175003051758, -2.04508960428758, 218, 56, 'PPL', 'P'),
(59991, 'Furrs', 34.2350006103516, 0.597513480072903, -88.8600006103516, -1.55089958397481, 218, 30, 'PPL', 'P'),
(64945, 'Furrs (historical)', 35.2613906860352, 0.615427366303376, -80.4916687011719, -1.40484463925992, 218, 33, 'PPL', 'P'),
(9022, 'Furry', 35.4805603027344, 0.619252597735111, -94.3022232055664, -1.64588428688774, 218, 4, 'PPL', 'P'),
(59992, 'Furry', 33.5202789306641, 0.585039233526972, -90.5297164916992, -1.58004162367716, 218, 30, 'PPL', 'P'),
(155386, 'Fursville', 40.003059387207, 0.698185097177588, -82.7163925170898, -1.44367339479522, 218, 41, 'PPL', 'P'),
(124903, 'Further Creek (historical)', 41.2805595397949, 0.720481681034977, -70.227783203125, -1.2257060432713, 218, 23, 'PPL', 'P'),
(2636, 'Fusihatchi (historical)', 32.4244384765625, 0.56591320952635, -86.1236114501953, -1.5031405835142, 218, 2, 'PPL', 'P'),
(54889, 'Fuson', 37.332218170166, 0.65157012414225, -92.4983291625977, -1.61440039648082, 218, 29, 'PPL', 'P'),
(36023, 'Fusonia', 37.1738891601563, 0.648806761616156, -83.0905609130859, -1.45020386526226, 218, 21, 'PPL', 'P'),
(16157, 'Fussells Corner', 28.0694408416748, 0.489904161880994, -81.8502807617188, -1.42855689297376, 218, 12, 'PPL', 'P'),
(16158, 'Fussels Corner', 28.0538902282715, 0.489632752476401, -81.8608322143555, -1.42874105056314, 218, 12, 'PPL', 'P'),
(174213, 'Fussville', 43.151668548584, 0.753138693902073, -88.0777816772461, -1.53724728812068, 218, 57, 'PPL', 'P'),
(59993, 'Futheyville', 33.7811088562012, 0.589591574515326, -89.7761077880859, -1.56688867052742, 218, 30, 'PPL', 'P'),
(36024, 'Futrell', 37.0916709899902, 0.647371783841794, -88.6894378662109, -1.54792270250832, 218, 21, 'PPL', 'P'),
(27229, 'Future City', 37.0288887023926, 0.646276026211281, -89.1880569458008, -1.55662524716042, 218, 18, 'PPL', 'P'),
(36025, 'Future City', 37.0625, 0.646862654020398, -88.8016662597656, -1.54988145749007, 218, 21, 'PPL', 'P'),
(186742, 'Futurity', 38.7363891601563, 0.676077531178568, -105.953330993652, -1.84923447929459, 218, 7, 'PPL', 'P'),
(204041, 'Fyandale', 40.6216697692871, 0.708981885131905, -111.824996948242, -1.95171438277944, 218, 52, 'PPL', 'P'),
(2639, 'Fyffe', 34.4466705322266, 0.601207817137061, -85.904167175293, -1.4993105583925, 218, 2, 'PPL', 'P'),
(149023, 'Fyler Settlement', 43.0952796936035, 0.752154522721234, -75.92138671875, -1.32507817092208, 218, 40, 'PPL', 'P'),
(94387, 'G and R Colonia', 26.2709999084473, 0.458515446193534, -98.3499984741211, -1.71653129270481, 218, 51, 'PPL', 'P'),
(75891, 'Gaar Corner', 34.7966690063477, 0.60731644288743, -96.8616714477539, -1.69055508574829, 218, 42, 'PPL', 'P'),
(41028, 'Gaars Mill', 32.1027793884277, 0.560299199369436, -92.5688934326172, -1.61563197532693, 218, 22, 'PPL', 'P'),
(130928, 'Gaastra', 46.0583305358887, 0.803869515823102, -88.605827331543, -1.54646342338901, 218, 27, 'PPL', 'P'),
(188580, 'Gabaldon', 35.4755592346191, 0.619165312630384, -105.291107177734, -1.8376764933217, 218, 38, 'PPL', 'P'),
(21322, 'Gabbettville', 32.9444389343262, 0.574988929626204, -85.1333312988281, -1.48585693435569, 218, 13, 'PPL', 'P'),
(190221, 'Gabbs', 38.8688888549805, 0.678390087111138, -117.921112060547, -2.05811166306974, 218, 39, 'PPL', 'P'),
(161936, 'Gabby Heights', 40.1530609130859, 0.70080311768719, -80.2605590820313, -1.40081101547288, 218, 45, 'PPL', 'P'),
(36026, 'Gabe', 37.3077812194824, 0.651143618893674, -85.5741729736328, -1.49355107306104, 218, 21, 'PPL', 'P'),
(87172, 'Gabe (historical)', 36.2069396972656, 0.631930309788324, -83.9277801513672, -1.4648160975313, 218, 50, 'PPL', 'P'),
(155387, 'Gabels Corner', 41.327220916748, 0.721296075696323, -83.1969375610352, -1.4520604880162, 218, 41, 'PPL', 'P'),
(161937, 'Gabelsville', 40.3369407653809, 0.704012426537818, -75.6558303833008, -1.32044333851896, 218, 45, 'PPL', 'P'),
(16163, 'Gaberonne', 30.4686107635498, 0.531777576332528, -87.1608276367188, -1.52124342102401, 218, 12, 'PPL', 'P'),
(181726, 'Gabilan (historical)', 36.5466690063477, 0.637859704797331, -121.493057250977, -2.12045386734351, 218, 6, 'PPL', 'P'),
(181727, 'Gabilan Acres', 36.7552795410156, 0.641500645481633, -121.61833190918, -2.12264032259847, 218, 6, 'PPL', 'P'),
(81146, 'Gable', 33.8250007629395, 0.590357632802887, -80.1094436645508, -1.39817355388732, 218, 48, 'PPL', 'P'),
(2638, 'Gable Cove', 33.6522216796875, 0.587342068921563, -86.6619415283203, -1.51253621584, 218, 2, 'PPL', 'P'),
(141862, 'Gables', 41.9383316040039, 0.731961969283063, -98.8497161865234, -1.72525301211677, 218, 35, 'PPL', 'P'),
(204044, 'Gables Condo', 40.6222190856934, 0.70899147251183, -111.86888885498, -1.952480441067, 218, 52, 'PPL', 'P'),
(75892, 'Gabriel', 35.9283294677734, 0.627067643953948, -95.0647201538086, -1.65919236917097, 218, 42, 'PPL', 'P'),
(9024, 'Gabriel (historical)', 35.6011085510254, 0.621356561575301, -92.920280456543, -1.62176483584321, 218, 4, 'PPL', 'P'),
(16165, 'Gabriella', 28.6261100769043, 0.499619872880307, -81.2447204589844, -1.41798787187168, 218, 12, 'PPL', 'P'),
(149024, 'Gabriels', 44.4319381713867, 0.775483614133247, -74.1813888549805, -1.29470947922164, 218, 40, 'PPL', 'P'),
(149025, 'Gabriels Junction', 42.4213905334473, 0.740392938083008, -76.9038925170898, -1.34222613202305, 218, 40, 'PPL', 'P'),
(54891, 'Gabriels Mills', 38.1808280944824, 0.666381161386671, -93.3436126708984, -1.62915337681348, 218, 29, 'PPL', 'P'),
(87173, 'Gabtown', 36.3899993896484, 0.635125304148092, -82.6161117553711, -1.44192316532682, 218, 50, 'PPL', 'P'),
(87175, 'Gaby Hills', 36.2502784729004, 0.632686714116934, -83.2988891601563, -1.45383987909854, 218, 50, 'PPL', 'P'),
(140061, 'Gackle', 46.6258316040039, 0.813774277970297, -99.1416702270508, -1.73034857138847, 218, 34, 'PPL', 'P'),
(36027, 'Gadberry', 37.0436096191406, 0.646532954677447, -85.309440612793, -1.48893062172781, 218, 21, 'PPL', 'P'),
(21323, 'Gaddistown', 34.7038917541504, 0.605697174365635, -84.0788879394531, -1.46745342595881, 218, 13, 'PPL', 'P'),
(75894, 'Gaddy', 35.3330612182617, 0.616678253067386, -97.0005569458008, -1.69297909497248, 218, 42, 'PPL', 'P'),
(81147, 'Gaddys Crossroads', 34.3994407653809, 0.600383502200654, -79.2577819824219, -1.3833092534211, 218, 48, 'PPL', 'P'),
(81148, 'Gaddys Mill', 34.3941688537598, 0.600291489984992, -79.2372207641602, -1.38295039246421, 218, 48, 'PPL', 'P'),
(64948, 'Gaddysville', 34.4486083984375, 0.601241639282905, -79.2236099243164, -1.38271283849498, 218, 33, 'PPL', 'P'),
(54892, 'Gads Hill', 37.2383308410645, 0.649931481123524, -90.6966705322266, -1.58295552138387, 218, 29, 'PPL', 'P'),
(2640, 'Gadsden', 34.0141716003418, 0.593659286764313, -86.0066680908203, -1.50109953685476, 218, 2, 'PPL', 'P'),
(81149, 'Gadsden', 33.8455581665039, 0.590716427180748, -80.76611328125, -1.40963460079653, 218, 48, 'PPL', 'P'),
(87174, 'Gadsden', 35.7758293151855, 0.624406014181496, -88.9899978637695, -1.5531684640655, 218, 50, 'PPL', 'P'),
(122661, 'Gadsden', 40.0472183227539, 0.698955815997057, -86.345832824707, -1.50701907816773, 218, 19, 'PPL', 'P'),
(192879, 'Gadsden', 32.5544395446777, 0.56818215619607, -114.784172058105, -2.00336173158962, 218, 5, 'PPL', 'P'),
(94388, 'Gadston', 33.4808311462402, 0.584350739806159, -95.5872192382813, -1.66831169853367, 218, 51, 'PPL', 'P'),
(181728, 'Gadwall (historical)', 37.021671295166, 0.64615005869172, -120.763893127441, -2.1077275526004, 218, 6, 'PPL', 'P'),
(36028, 'Gaffey Heights', 37.8858299255371, 0.661232472051221, -85.9688873291016, -1.50044013816886, 218, 21, 'PPL', 'P'),
(81153, 'Gaffney', 35.0716705322266, 0.612116124962026, -81.6500015258789, -1.42506136088498, 218, 48, 'PPL', 'P'),
(161938, 'Gaffney', 41.7563896179199, 0.72878648257828, -78.6061096191406, -1.37193542503759, 218, 45, 'PPL', 'P'),
(94389, 'Gafford', 33.1644592285156, 0.578829008181016, -95.6946411132813, -1.67018656394109, 218, 51, 'PPL', 'P'),
(127545, 'Gag Corner', 43.7422218322754, 0.763445793110952, -70.45361328125, -1.22964752168462, 218, 26, 'PPL', 'P'),
(2641, 'Gage', 33.2452812194824, 0.580239618031404, -86.0008316040039, -1.50099767094306, 218, 2, 'PPL', 'P'),
(36029, 'Gage', 36.9911117553711, 0.645616694104405, -88.8894424438477, -1.55141344090714, 218, 21, 'PPL', 'P'),
(72623, 'Gage', 38.7961082458496, 0.677119825850197, -82.3977813720703, -1.43811258128108, 218, 41, 'PPL', 'P'),
(75893, 'Gage', 36.315559387207, 0.633826081010297, -99.7572174072266, -1.7410918963839, 218, 42, 'PPL', 'P'),
(94390, 'Gage', 33.6749992370605, 0.587739612293285, -96.7577819824219, -1.68874187252011, 218, 51, 'PPL', 'P'),
(109297, 'Gage', 38.9702796936035, 0.680159691076468, -79.9608306884766, -1.39557976814364, 218, 58, 'PPL', 'P'),
(181729, 'Gage', 33.9752807617188, 0.592980513581479, -118.125831604004, -2.06168469314624, 218, 6, 'PPL', 'P'),
(188581, 'Gage', 32.2294387817383, 0.562509822811283, -108.085563659668, -1.88644895973514, 218, 38, 'PPL', 'P'),
(196551, 'Gage', 46.4766693115234, 0.81117090484669, -108.392501831055, -1.89180604142589, 218, 31, 'PPL', 'P'),
(64949, 'Gage (historical)', 35.482780456543, 0.619291346728972, -82.1208267211914, -1.43327881074453, 218, 33, 'PPL', 'P'),
(191513, 'Gage Corner Windmill', 33.6713905334473, 0.587676628533505, -100.499443054199, -1.75404617771632, 218, 51, 'PPL', 'P'),
(191514, 'Gageby', 35.6197204589844, 0.621681400649263, -100.339721679688, -1.75125851384528, 218, 51, 'PPL', 'P'),
(174214, 'Gagen', 45.6624984741211, 0.7969609430603, -89.1380615234375, -1.55575266242926, 218, 57, 'PPL', 'P'),
(119728, 'Gages Lake', 42.3516693115234, 0.739176073201924, -87.9824981689453, -1.53558427717798, 218, 18, 'PPL', 'P'),
(130930, 'Gagetown', 43.6572189331055, 0.761962212646697, -83.245002746582, -1.45289938375958, 218, 27, 'PPL', 'P'),
(113246, 'Gageville', 41.8455581665039, 0.730342767340295, -80.6658325195313, -1.40788437132813, 218, 41, 'PPL', 'P'),
(41029, 'Gahagan', 32.0397186279297, 0.559198581469933, -93.4063873291016, -1.63024900128593, 218, 22, 'PPL', 'P'),
(161939, 'Gahagen', 40.0622215270996, 0.699217671311239, -78.8022232055664, -1.37535825282861, 218, 45, 'PPL', 'P'),
(155388, 'Gahanna', 40.0191688537598, 0.698466260409673, -82.8794403076172, -1.44651911557802, 218, 41, 'PPL', 'P'),
(41030, 'Gahn', 29.8608303070068, 0.521169806236578, -91.6555633544922, -1.59969135830615, 218, 22, 'PPL', 'P'),
(161940, 'Gaiblton', 40.7247200012207, 0.71078045097409, -79.1016693115234, -1.38058457330984, 218, 45, 'PPL', 'P'),
(191515, 'Gail', 32.7702789306641, 0.571949264137014, -101.444999694824, -1.77054925435933, 218, 51, 'PPL', 'P'),
(87176, 'Gail (historical)', 35.351390838623, 0.616998165293332, -88.7361068725586, -1.54873723032772, 218, 50, 'PPL', 'P'),
(102153, 'Gaila Woods', 38.6563911437988, 0.674681302398066, -77.4172210693359, -1.35118540540424, 218, 53, 'PPL', 'P'),
(21324, 'Gaillard', 32.6433296203613, 0.569733580689096, -84.0052795410156, -1.46616871704895, 218, 13, 'PPL', 'P'),
(81154, 'Gaillard Crossroads', 34.0491714477539, 0.59427014933935, -80.4347229003906, -1.4038507475411, 218, 48, 'PPL', 'P'),
(81155, 'Gailmoor', 33.0063896179199, 0.576070173028776, -80.0891723632813, -1.39781975293651, 218, 48, 'PPL', 'P'),
(87177, 'Gailor', 35.4291687011719, 0.618355645079972, -89.4980621337891, -1.56203585838908, 218, 50, 'PPL', 'P'),
(54893, 'Gaines', 38.2872200012207, 0.668238050456729, -93.6613922119141, -1.63469967609968, 218, 29, 'PPL', 'P'),
(109298, 'Gaines', 38.7802810668945, 0.676843589466129, -80.3202819824219, -1.40185337672354, 218, 58, 'PPL', 'P'),
(130931, 'Gaines', 42.872501373291, 0.748266307529719, -83.9141693115234, -1.46457854356207, 218, 27, 'PPL', 'P'),
(149026, 'Gaines', 43.2849998474121, 0.755465764062584, -78.2155609130859, -1.36511906422753, 218, 40, 'PPL', 'P'),
(161941, 'Gaines', 41.7519416809082, 0.728708851432504, -77.5577774047852, -1.35363857624236, 218, 45, 'PPL', 'P'),
(149027, 'Gaines Basin', 43.2586097717285, 0.755005170352055, -78.2233276367188, -1.36525461912702, 218, 40, 'PPL', 'P'),
(21326, 'Gaines Court', 33.5125007629395, 0.584903478890405, -82.0097198486328, -1.43133962999679, 218, 13, 'PPL', 'P'),
(81156, 'Gaines Crossroads', 34.0638885498047, 0.594527011226488, -82.086669921875, -1.43268266213452, 218, 48, 'PPL', 'P'),
(54894, 'Gaines Ford (historical)', 38.060001373291, 0.664272337277492, -91.8925018310547, -1.60382671484682, 218, 29, 'PPL', 'P'),
(161942, 'Gaines Junction', 41.7472190856934, 0.728626426596766, -77.5738906860352, -1.35391980605348, 218, 45, 'PPL', 'P'),
(102154, 'Gaines Mill', 37.5875015258789, 0.65602565922498, -77.3016662597656, -1.34916859351072, 218, 53, 'PPL', 'P'),
(87179, 'Gainesboro', 36.3555603027344, 0.634524228690061, -85.6588897705078, -1.49502966009825, 218, 50, 'PPL', 'P'),
(102162, 'Gainesboro', 39.2783317565918, 0.685536213843175, -78.2594375610352, -1.36588485619898, 218, 53, 'PPL', 'P'),
(94394, 'Gainesmore', 28.9174995422363, 0.504705578455977, -95.6908264160156, -1.67011998491384, 218, 51, 'PPL', 'P'),
(2642, 'Gainestown', 31.4452800750732, 0.548823671521798, -87.6933288574219, -1.53053732059617, 218, 2, 'PPL', 'P'),
(2643, 'Gainestown Landing', 31.4055595397949, 0.548130417400536, -87.6980590820313, -1.53061987858996, 218, 2, 'PPL', 'P'),
(2644, 'Gainesville', 32.8208312988281, 0.572831569406158, -88.1588897705078, -1.53866289139811, 218, 2, 'PPL', 'P'),
(9026, 'Gainesville', 36.1647186279297, 0.631193413114699, -90.5105590820313, -1.5797072638023, 218, 4, 'PPL', 'P'),
(16167, 'Gainesville', 29.6513900756836, 0.517514384613849, -82.3249969482422, -1.43684225344111, 218, 12, 'PPL', 'P'),
(21327, 'Gainesville', 34.297779083252, 0.598609171124389, -83.8241729736328, -1.46300781115114, 218, 13, 'PPL', 'P'),
(36030, 'Gainesville', 36.8505592346191, 0.643163589845306, -86.158332824707, -1.50374658582024, 218, 21, 'PPL', 'P'),
(54895, 'Gainesville', 36.6030616760254, 0.638843942557197, -92.4280624389648, -1.61317401079884, 218, 29, 'PPL', 'P'),
(59996, 'Gainesville', 30.350830078125, 0.529721915576609, -89.6397171020508, -1.56450820398706, 218, 30, 'PPL', 'P'),
(87178, 'Gainesville', 35.413330078125, 0.618079208958822, -89.6091690063477, -1.56397503913682, 218, 50, 'PPL', 'P'),
(94393, 'Gainesville', 30.6774997711182, 0.535423377285819, -98.521110534668, -1.71951776155123, 218, 51, 'PPL', 'P'),
(102156, 'Gainesville', 38.7955589294434, 0.677110238470273, -77.6141662597656, -1.3546227474232, 218, 53, 'PPL', 'P'),
(149029, 'Gainesville', 42.6408309936523, 0.744222896625679, -78.1341705322266, -1.36369853410208, 218, 40, 'PPL', 'P'),
(21328, 'Gainesville Mills', 34.2772216796875, 0.598250376746528, -83.8177795410156, -1.46289622470146, 218, 13, 'PPL', 'P'),
(178231, 'Gainey Ranch', 33.5711097717285, 0.585926399065105, -111.91667175293, -1.95331440996236, 218, 5, 'PPL', 'P'),
(64950, 'Gaineys Place', 34.9550018310547, 0.610079871992551, -79.3455581665039, -1.38484123683817, 218, 33, 'PPL', 'P'),
(2645, 'Gaino', 31.8411102294922, 0.555732210995086, -85.3441696166992, -1.48953675719191, 218, 2, 'PPL', 'P'),
(9027, 'Gainsboro', 35.7966690063477, 0.624769735407374, -91.5313873291016, -1.59752407781104, 218, 4, 'PPL', 'P'),
(9029, 'Gaither', 36.1436080932617, 0.630824964777887, -93.1666717529297, -1.62606517521342, 218, 4, 'PPL', 'P'),
(47331, 'Gaither', 39.3613891601563, 0.686985839003532, -76.9933319091797, -1.343787143896, 218, 25, 'PPL', 'P'),
(54896, 'Gaither (historical)', 37.1530609130859, 0.64844324012736, -93.8847198486328, -1.63859747867111, 218, 29, 'PPL', 'P'),
(47332, 'Gaither Farm Estates', 39.2377815246582, 0.684828478783486, -76.8969421386719, -1.34210482503539, 218, 25, 'PPL', 'P'),
(47333, 'Gaither Heights', 39.3666687011719, 0.687077984377249, -76.9955596923828, -1.34382602604791, 218, 25, 'PPL', 'P'),
(47334, 'Gaither Manor', 39.372501373291, 0.687179783709917, -76.9916687011719, -1.34375811544012, 218, 25, 'PPL', 'P'),
(21329, 'Gaither Park', 34.2027816772461, 0.596951153608733, -85.1738891601563, -1.48656480257343, 218, 13, 'PPL', 'P'),
(36031, 'Gaithers', 37.6575012207031, 0.657247384375053, -85.8997192382813, -1.49923292724672, 218, 21, 'PPL', 'P'),
(47335, 'Gaithersburg', 39.1433296203613, 0.683179982068727, -77.2016677856445, -1.34742329089034, 218, 25, 'PPL', 'P'),
(87180, 'Gaitherville', 35.2455596923828, 0.61515106334028, -87.3652801513672, -1.52481179056861, 218, 50, 'PPL', 'P'),
(41031, 'Gajan', 29.9908294677734, 0.523438719616785, -91.7758331298828, -1.60179046187735, 218, 22, 'PPL', 'P'),
(211840, 'Gakona', 62.3019409179688, 1.08737399940153, -145.301940917969, -2.53599727855683, 218, 1, 'PPL', 'P'),
(211839, 'Gakona Junction', 62.2886085510254, 1.08714130570129, -145.35139465332, -2.53686040906612, 218, 1, 'PPL', 'P'),
(102158, 'Gala', 37.6886100769043, 0.657790336342293, -79.809440612793, -1.39293751286812, 218, 53, 'PPL', 'P'),
(29866, 'Galader Station', 39.6847190856934, 0.692629010774383, -86.01611328125, -1.50126438652624, 218, 19, 'PPL', 'P'),
(196552, 'Galata', 48.4755592346191, 0.846058115389646, -111.351387023926, -1.94344833022999, 218, 31, 'PPL', 'P'),
(155389, 'Galatea', 41.1777801513672, 0.718687842303726, -83.6447219848633, -1.45987580055115, 218, 41, 'PPL', 'P'),
(186743, 'Galatea', 38.5044403076172, 0.672029260005538, -103.024169921875, -1.79811097427083, 218, 7, 'PPL', 'P'),
(27230, 'Galatia', 37.8405609130859, 0.660442378734821, -88.6091690063477, -1.54652174661688, 218, 18, 'PPL', 'P'),
(32502, 'Galatia', 38.6416702270508, 0.674424373931901, -98.9583282470703, -1.72714865018069, 218, 20, 'PPL', 'P'),
(64951, 'Galatia', 36.4713897705078, 0.63654583427354, -77.3027801513672, -1.34918803458668, 218, 33, 'PPL', 'P'),
(149031, 'Galatia', 42.485279083252, 0.741508003631425, -76.0316696166992, -1.32700297059994, 218, 40, 'PPL', 'P'),
(81157, 'Galavon', 34.4972190856934, 0.602090055827177, -79.4522171020508, -1.38670278644013, 218, 48, 'PPL', 'P'),
(102159, 'Galax', 36.6611099243164, 0.63985707561489, -80.9241714477539, -1.41239323621169, 218, 53, 'PPL', 'P'),
(72624, 'Galaxy Acres', 39.2408294677734, 0.684881675426261, -84.5811080932617, -1.47621882121264, 218, 41, 'PPL', 'P'),
(87181, 'Galaxy Heights', 35.1261100769043, 0.613066274259939, -85.2583312988281, -1.48803859592068, 218, 50, 'PPL', 'P'),
(41032, 'Galbraith', 31.4911098480225, 0.549623551955203, -92.8122177124023, -1.61987878515922, 218, 22, 'PPL', 'P'),
(87182, 'Galbraith', 36.3605613708496, 0.634611513794789, -83.1755599975586, -1.45168737914748, 218, 50, 'PPL', 'P'),
(115671, 'Galbraith', 42.9805603027344, 0.750152291634686, -94.1588897705078, -1.64338264651777, 218, 16, 'PPL', 'P'),
(196554, 'Galbraith', 46.5986099243164, 0.813299170031827, -107.475563049316, -1.87580244064533, 218, 31, 'PPL', 'P'),
(211335, 'Galbraith (historical)', 21.5086097717285, 0.375396058043289, -158.036392211914, -2.75825538207102, 218, 15, 'PPL', 'P'),
(87183, 'Galbraith Springs', 36.3691711425781, 0.634761782659296, -83.1791687011719, -1.45175036290726, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(140063, 'Galchutt', 46.3875007629395, 0.809614620084675, -96.8091735839844, -1.68963882517525, 218, 34, 'PPL', 'P'),
(36032, 'Galdia', 37.6330604553223, 0.65682081254745, -82.9886093139648, -1.44842447417992, 218, 21, 'PPL', 'P'),
(27232, 'Gale', 37.2488899230957, 0.650115771870957, -89.4475021362305, -1.56115341996188, 218, 18, 'PPL', 'P'),
(29867, 'Gale', 39.7666702270508, 0.694059328016837, -86.466667175293, -1.50912803543497, 218, 19, 'PPL', 'P'),
(109299, 'Gale', 38.9044418334961, 0.679010603645126, -80.1036071777344, -1.39807168797563, 218, 58, 'PPL', 'P'),
(149032, 'Gale', 44.2675018310547, 0.772613658584523, -74.6313934326172, -1.30256354075044, 218, 40, 'PPL', 'P'),
(161944, 'Gale', 40.0325012207031, 0.698698954109919, -80.3572235107422, -1.40249812802345, 218, 45, 'PPL', 'P'),
(181730, 'Gale', 34.8561096191406, 0.608353877290071, -116.84139251709, -2.03926700203828, 218, 6, 'PPL', 'P'),
(194966, 'Gale', 43.7652816772461, 0.763848263330691, -111.718612670898, -1.94985762686743, 218, 17, 'PPL', 'P'),
(87184, 'Galen', 36.5766716003418, 0.638383348846668, -85.9619369506836, -1.5003188311812, 218, 50, 'PPL', 'P'),
(196553, 'Galen', 46.2355613708496, 0.806962777429229, -112.775283813477, -1.96830001741623, 218, 31, 'PPL', 'P'),
(59994, 'Galen (historical)', 33.7833290100098, 0.589630323509187, -90.5347213745117, -1.58012897536092, 218, 30, 'PPL', 'P'),
(9031, 'Galena', 34.2513885498047, 0.597799503573978, -94.1127777099609, -1.64257783923635, 218, 4, 'PPL', 'P'),
(29868, 'Galena', 38.3516693115234, 0.669362903122151, -85.9416732788086, -1.49996516338844, 218, 19, 'PPL', 'P'),
(32504, 'Galena', 37.0758285522461, 0.647095281141617, -94.6394424438477, -1.65176987289681, 218, 20, 'PPL', 'P'),
(47337, 'Galena', 39.3405609130859, 0.686622317514736, -75.8791732788086, -1.32434140740651, 218, 25, 'PPL', 'P'),
(54897, 'Galena', 36.8052787780762, 0.642373296791825, -93.4663925170898, -1.63129628938461, 218, 29, 'PPL', 'P'),
(59995, 'Galena', 34.6569404602051, 0.604877719698217, -89.5522232055664, -1.562981147418, 218, 30, 'PPL', 'P'),
(102161, 'Galena', 36.8811111450195, 0.643696821274567, -80.8933334350586, -1.41185501135539, 218, 53, 'PPL', 'P'),
(119729, 'Galena', 42.4166717529297, 0.740310579826298, -90.4288864135742, -1.57828180682884, 218, 18, 'PPL', 'P'),
(149034, 'Galena', 42.6130599975586, 0.743738201307284, -75.5311126708984, -1.31826660380199, 218, 40, 'PPL', 'P'),
(155390, 'Galena', 40.2150001525879, 0.701884161352681, -82.879997253418, -1.446528836116, 218, 41, 'PPL', 'P'),
(178232, 'Galena', 31.4219398498535, 0.548416307743557, -109.892501831055, -1.9179859802058, 218, 5, 'PPL', 'P'),
(186744, 'Galena', 38.2619400024414, 0.66779683124313, -105.277221679688, -1.8374341456625, 218, 7, 'PPL', 'P'),
(194967, 'Galena', 43.8713912963867, 0.765700225552732, -114.656387329102, -2.00113146733473, 218, 17, 'PPL', 'P'),
(200862, 'Galena', 44.7105598449707, 0.780346479704704, -118.815277099609, -2.0737177870576, 218, 43, 'PPL', 'P'),
(202150, 'Galena', 44.333610534668, 0.7737674731268, -103.640556335449, -1.80886894665226, 218, 49, 'PPL', 'P'),
(207476, 'Galena', 47.8925018310547, 0.835881843969317, -121.442222595215, -2.11956663522635, 218, 56, 'PPL', 'P'),
(211841, 'Galena', 64.7333297729492, 1.12980974031724, -156.927505493164, -2.7389016577972, 218, 1, 'PPL', 'P'),
(199960, 'Galena (historical)', 40.5644416809082, 0.707983066565071, -117.129173278809, -2.04428972385417, 218, 39, 'PPL', 'P'),
(161945, 'Galena Hill', 41.3944396972656, 0.72246926473553, -79.8433303833008, -1.39352900094622, 218, 45, 'PPL', 'P'),
(181731, 'Galena Hill (historical)', 39.4736099243164, 0.688944460827231, -121.054443359375, -2.11279861079008, 218, 6, 'PPL', 'P'),
(119730, 'Galena Junction', 42.3738899230957, 0.739563896035667, -90.4430618286133, -1.57852921449411, 218, 18, 'PPL', 'P'),
(94395, 'Galena Park', 29.7333297729492, 0.518944502119222, -95.2300033569336, -1.66207710526374, 218, 51, 'PPL', 'P'),
(200863, 'Gales Creek', 45.586669921875, 0.795637485156585, -123.213607788086, -2.15048313916303, 218, 43, 'PPL', 'P'),
(113461, 'Gales Ferry', 41.4297218322754, 0.723085054158583, -72.0824966430664, -1.25807689947927, 218, 8, 'PPL', 'P'),
(32506, 'Galesburg', 37.4736099243164, 0.654037875787344, -95.3583297729492, -1.6643168237405, 218, 20, 'PPL', 'P'),
(115672, 'Galesburg', 41.5588912963867, 0.725339486600363, -92.9461135864258, -1.62221570901577, 218, 16, 'PPL', 'P'),
(119731, 'Galesburg', 40.9477806091309, 0.714673593013623, -90.3711090087891, -1.57727340088208, 218, 18, 'PPL', 'P'),
(130934, 'Galesburg', 42.2886085510254, 0.738075455302422, -85.4180603027344, -1.49082639294978, 218, 27, 'PPL', 'P'),
(139164, 'Galesburg', 40.5188903808594, 0.707188046400655, -93.3125, -1.62861035826721, 218, 29, 'PPL', 'P'),
(140064, 'Galesburg', 47.2700004577637, 0.825017145407203, -97.4061126708984, -1.70005737767575, 218, 34, 'PPL', 'P'),
(47345, 'Galestown', 38.5661087036133, 0.673105576560094, -75.7152786254883, -1.32148090607966, 218, 25, 'PPL', 'P'),
(47338, 'Galesville', 38.8430595397949, 0.677939280517615, -76.5438919067383, -1.33594293606322, 218, 25, 'PPL', 'P'),
(113031, 'Galesville', 40.1552810668945, 0.700841866681051, -88.5563888549805, -1.54560055919582, 218, 18, 'PPL', 'P'),
(174216, 'Galesville', 44.0816688537598, 0.769370261271943, -91.3488922119141, -1.59433893714731, 218, 57, 'PPL', 'P'),
(200864, 'Galesville', 42.7783317565918, 0.746622737662976, -123.294723510742, -2.15189887559851, 218, 43, 'PPL', 'P'),
(47339, 'Galesville Estates', 38.8436088562012, 0.677948867897539, -76.5513916015625, -1.3360738304308, 218, 25, 'PPL', 'P'),
(9032, 'Galet', 35.1152801513672, 0.61287725640157, -90.2130584716797, -1.57451489862497, 218, 4, 'PPL', 'P'),
(161946, 'Galeton', 41.7330589294434, 0.728379285247607, -77.642219543457, -1.35511236958961, 218, 45, 'PPL', 'P'),
(194193, 'Galeton', 40.5208282470703, 0.707221868546499, -104.58528137207, -1.82535750906732, 218, 7, 'PPL', 'P'),
(155391, 'Galetown', 41.2663917541504, 0.720234406527763, -82.9966735839844, -1.44856522224353, 218, 41, 'PPL', 'P'),
(149036, 'Galeville', 41.6363906860352, 0.726692106118014, -74.1913909912109, -1.29488404943109, 218, 40, 'PPL', 'P'),
(13809, 'Galewood', 39.7916717529297, 0.694495686961447, -75.5263900756836, -1.31818417896625, 218, 10, 'PPL', 'P'),
(87185, 'Galewood', 35.8980598449707, 0.626539339372704, -84.0299987792969, -1.46660014914555, 218, 50, 'PPL', 'P'),
(178233, 'Galeyville', 31.9502792358398, 0.557637569596983, -109.217781066895, -1.90620988133963, 218, 5, 'PPL', 'P'),
(200865, 'Galice', 42.5697212219238, 0.742981796978675, -123.59610748291, -2.15715901822558, 218, 43, 'PPL', 'P'),
(130936, 'Galien', 41.7980613708496, 0.72951379187198, -86.4991683959961, -1.50969528874715, 218, 27, 'PPL', 'P'),
(194194, 'Galien', 40.6877784729004, 0.710135699674182, -103.007781982422, -1.79782495076975, 218, 7, 'PPL', 'P'),
(9033, 'Galilee', 35.4361114501953, 0.618476818909571, -90.3850021362305, -1.57751588169933, 218, 4, 'PPL', 'P'),
(59997, 'Galilee', 32.0499992370605, 0.559378011948377, -89.7341690063477, -1.56615670070182, 218, 30, 'PPL', 'P'),
(94397, 'Galilee', 30.6966705322266, 0.535757970187274, -95.6394424438477, -1.66922316541675, 218, 51, 'PPL', 'P'),
(145281, 'Galilee', 40.3363914489746, 0.704002839157893, -73.9747161865234, -1.29110236068318, 218, 37, 'PPL', 'P'),
(149037, 'Galilee', 44.6169395446777, 0.778712497217886, -75.5083312988281, -1.31786899385124, 218, 40, 'PPL', 'P'),
(161948, 'Galilee', 41.7350006103516, 0.728413173972478, -75.1399993896484, -1.31144038929589, 218, 45, 'PPL', 'P'),
(169387, 'Galilee', 41.3769416809082, 0.722163866737525, -71.5119400024414, -1.24811880753124, 218, 47, 'PPL', 'P'),
(64952, 'Galilee Mission', 35.7930603027344, 0.624706751647593, -76.4005584716797, -1.33344129569326, 218, 33, 'PPL', 'P'),
(41033, 'Galion', 32.8594398498535, 0.573505415740975, -91.753059387207, -1.60139298508465, 218, 22, 'PPL', 'P'),
(155392, 'Galion', 40.7336082458496, 0.710935580107588, -82.7900009155273, -1.44495810370507, 218, 41, 'PPL', 'P'),
(188582, 'Galisteo', 35.3955612182617, 0.617769083849882, -105.945831298828, -1.84910358492701, 218, 38, 'PPL', 'P'),
(181732, 'Galivan', 33.5694389343262, 0.585897237451168, -117.673057556152, -2.05378229524365, 218, 6, 'PPL', 'P'),
(81159, 'Galivants Ferry', 34.0561103820801, 0.594391256589921, -79.2466735839844, -1.38311537529374, 218, 48, 'PPL', 'P'),
(41034, 'Gall', 29.9430599212646, 0.522604983748022, -91.8227767944336, -1.60260978338671, 218, 22, 'PPL', 'P'),
(72625, 'Gall (historical)', 39.0919418334961, 0.682283095992616, -83.4611129760742, -1.45667121881146, 218, 41, 'PPL', 'P'),
(9034, 'Galla Rock', 35.1777801513672, 0.613968087184067, -92.9694366455078, -1.62262277318838, 218, 4, 'PPL', 'P'),
(27233, 'Gallagher', 38.6344413757324, 0.674298206675258, -88.1672210693359, -1.53880829999363, 218, 18, 'PPL', 'P'),
(109300, 'Gallagher', 38.1730613708496, 0.666245606487186, -81.4019393920898, -1.42073185990084, 218, 58, 'PPL', 'P'),
(161949, 'Gallagher', 41.2569389343262, 0.720069423698232, -77.4358291625977, -1.35151017789917, 218, 45, 'PPL', 'P'),
(47340, 'Gallagher Estates', 39.4313888549805, 0.688207564153606, -77.1919403076172, -1.34725351437084, 218, 25, 'PPL', 'P'),
(47341, 'Gallagher Park', 39.3549995422363, 0.686874319132885, -76.6136093139648, -1.33715973436528, 218, 25, 'PPL', 'P'),
(78313, 'Gallagherville', 39.9988899230957, 0.698112326300801, -75.7272186279297, -1.32168929843496, 218, 45, 'PPL', 'P'),
(188584, 'Gallaher', 34.4027786254883, 0.6004417588495, -103.29638671875, -1.80286205365553, 218, 38, 'PPL', 'P'),
(115673, 'Galland', 40.500560760498, 0.70686813417471, -91.3744430541992, -1.59478488347184, 218, 16, 'PPL', 'P'),
(2646, 'Gallant', 33.9986114501953, 0.593387710912152, -86.2452774047852, -1.50526405500937, 218, 2, 'PPL', 'P'),
(47342, 'Gallant Acres', 38.5875015258789, 0.673478951744923, -76.8077774047852, -1.34054860685241, 218, 25, 'PPL', 'P'),
(47343, 'Gallant Green Woods', 38.5852813720703, 0.673440202751062, -76.7750015258789, -1.33997655985026, 218, 25, 'PPL', 'P'),
(9037, 'Gallatin', 36.2061080932617, 0.631915795560383, -94.4269409179688, -1.64806102160471, 218, 4, 'PPL', 'P'),
(54901, 'Gallatin', 39.9144401550293, 0.696638399795497, -93.9619369506836, -1.63994517134075, 218, 29, 'PPL', 'P'),
(60003, 'Gallatin', 31.8505592346191, 0.555897127245589, -90.45361328125, -1.57871337208348, 218, 30, 'PPL', 'P'),
(87187, 'Gallatin', 36.3883285522461, 0.635096142534156, -86.4466705322266, -1.50877902817411, 218, 50, 'PPL', 'P'),
(94398, 'Gallatin', 31.8908290863037, 0.556599968746775, -95.1452789306641, -1.66059838506848, 218, 51, 'PPL', 'P'),
(161951, 'Gallatin', 40.1974983215332, 0.701578696775649, -79.8891677856445, -1.39432901453768, 218, 45, 'PPL', 'P'),
(9038, 'Gallatin (historical)', 36.3788909912109, 0.634931426020734, -94.4263916015625, -1.64805143422479, 218, 4, 'PPL', 'P'),
(196555, 'Gallatin (historical)', 45.9277801513672, 0.801590981773457, -111.497222900391, -1.94599364644184, 218, 31, 'PPL', 'P'),
(196556, 'Gallatin Gateway', 45.5916709899902, 0.795724770261312, -111.196937561035, -1.94075267857462, 218, 31, 'PPL', 'P'),
(196557, 'Gallatin Gateway Inn Park', 45.5916709899902, 0.795724770261312, -111.196937561035, -1.94075267857462, 218, 31, 'PPL', 'P'),
(149039, 'Gallatinville', 42.0344390869141, 0.733639361295649, -73.6711120605469, -1.28580346906225, 218, 40, 'PPL', 'P'),
(87186, 'Gallaway', 35.3258285522461, 0.616552019231716, -89.6161117553711, -1.56409621296642, 218, 50, 'PPL', 'P'),
(181733, 'Gallaway', 38.8691711425781, 0.678395013959155, -123.652221679688, -2.15813839571646, 218, 6, 'PPL', 'P'),
(94399, 'Galle', 29.7380599975586, 0.519027060113014, -97.9138870239258, -1.70891971199326, 218, 51, 'PPL', 'P'),
(188587, 'Gallegos', 35.0352783203125, 0.611480961042042, -106.155563354492, -1.85276409984533, 218, 38, 'PPL', 'P'),
(72626, 'Gallia', 38.8308296203613, 0.677725828156245, -82.5177764892578, -1.44020689116232, 218, 41, 'PPL', 'P'),
(41035, 'Galliano', 29.4419403076172, 0.513858796543552, -90.2991714477539, -1.57601785358616, 218, 22, 'PPL', 'P'),
(102163, 'Gallimore', 37.0800018310547, 0.647168118597431, -80.7708282470703, -1.40971689247422, 218, 53, 'PPL', 'P'),
(94400, 'Gallimore Addition Colonia', 27.7390003204346, 0.484136886803345, -98.0979995727539, -1.71213308216455, 218, 51, 'PPL', 'P'),
(181734, 'Gallinas', 38.0202789306641, 0.663579049866717, -122.524169921875, -2.13845017840972, 218, 6, 'PPL', 'P'),
(188588, 'Gallinas', 35.6791687011719, 0.622718968209958, -105.352783203125, -1.83875294303431, 218, 38, 'PPL', 'P'),
(2647, 'Gallion', 32.4966697692871, 0.567173883407366, -87.7161102294922, -1.53093493054692, 218, 2, 'PPL', 'P'),
(47344, 'Gallions Corner', 39.6530609130859, 0.692076471427219, -76.2361068725586, -1.33057107382842, 218, 25, 'PPL', 'P'),
(72628, 'Gallipolis', 38.8097190856934, 0.677357379819432, -82.2024993896484, -1.43470426771799, 218, 41, 'PPL', 'P'),
(109304, 'Gallipolis', 38.7905616760254, 0.677023019944573, -82.2005615234375, -1.43467044557215, 218, 58, 'PPL', 'P'),
(109301, 'Gallipolis Ferry', 38.7705612182617, 0.676673946104691, -82.1988906860352, -1.43464128395821, 218, 58, 'PPL', 'P'),
(161957, 'Gallitzin', 40.4822196960449, 0.706548022211682, -78.5519409179688, -1.37099000285061, 218, 45, 'PPL', 'P'),
(16168, 'Galliver', 30.7241706848145, 0.536237938394733, -86.7072219848633, -1.51332650889348, 218, 12, 'PPL', 'P'),
(59998, 'Gallman', 31.9319400787354, 0.557317490923469, -90.3891677856445, -1.57758858599709, 218, 30, 'PPL', 'P'),
(196559, 'Gallop (historical)', 45.976390838623, 0.802439398317729, -111.098609924316, -1.93903653756817, 218, 31, 'PPL', 'P'),
(102164, 'Gallops Corner', 36.7997207641602, 0.642276291149118, -76.1297225952148, -1.32871431791642, 218, 53, 'PPL', 'P'),
(9041, 'Galloway', 34.7797203063965, 0.60702063226935, -92.1286087036133, -1.60794755715956, 218, 4, 'PPL', 'P'),
(16169, 'Galloway', 28.0961093902588, 0.490369615860512, -82.0066680908203, -1.43128636677499, 218, 12, 'PPL', 'P'),
(21330, 'Galloway', 34.9358291625977, 0.609745245801583, -84.3552780151367, -1.47227734279932, 218, 13, 'PPL', 'P'),
(54902, 'Galloway', 37.1366691589355, 0.648157150047259, -93.2377777099609, -1.6273062082814, 218, 29, 'PPL', 'P'),
(59999, 'Galloway', 32.0663909912109, 0.559664102028479, -90.966667175293, -1.58766785177471, 218, 30, 'PPL', 'P'),
(72630, 'Galloway', 39.9130592346191, 0.696614298187632, -83.1624984741211, -1.45145941255817, 218, 41, 'PPL', 'P'),
(94402, 'Galloway', 32.0480804443359, 0.559344522697669, -94.0804214477539, -1.6420131159272, 218, 51, 'PPL', 'P'),
(109302, 'Galloway', 39.2316703796387, 0.684721819181829, -80.1222229003906, -1.39839659362862, 218, 58, 'PPL', 'P'),
(130938, 'Galloway', 43.3316688537598, 0.756280291881985, -84.3694381713867, -1.47252448414848, 218, 27, 'PPL', 'P'),
(161954, 'Galloway', 41.4247207641602, 0.722997769053856, -79.817497253418, -1.39307812777367, 218, 45, 'PPL', 'P'),
(174217, 'Galloway', 44.7127799987793, 0.780385228698565, -89.2641677856445, -1.55795363191215, 218, 57, 'PPL', 'P'),
(200866, 'Galloway (historical)', 45.5580596923828, 0.795138142452195, -119.444717407227, -2.08470359287029, 218, 43, 'PPL', 'P'),
(64953, 'Galloway Crossroads', 35.5461082458496, 0.620396625160382, -77.2619400024414, -1.34847523952092, 218, 33, 'PPL', 'P'),
(64954, 'Galloway Farms', 35.5483283996582, 0.620435374154242, -77.2644424438477, -1.3485189153628, 218, 33, 'PPL', 'P'),
(2648, 'Galloway Landing', 30.610559463501, 0.534255048515601, -88.39111328125, -1.5427159562611, 218, 2, 'PPL', 'P'),
(21331, 'Galloway Mill', 34.9013900756836, 0.609144170343552, -84.3850021362305, -1.47279612657967, 218, 13, 'PPL', 'P'),
(87188, 'Galloway Mill', 36.4988899230957, 0.637025802481, -82.2988891601563, -1.4363865865786, 218, 50, 'PPL', 'P'),
(29869, 'Galloways Station', 38.8402786254883, 0.677890744406748, -85.4622192382813, -1.49159711176925, 218, 19, 'PPL', 'P'),
(161955, 'Gallows Harbor', 41.0558280944824, 0.716559377381508, -78.2630615234375, -1.36594810627487, 218, 45, 'PPL', 'P'),
(149040, 'Gallows Hill', 41.3213882446289, 0.721194276363655, -73.908332824707, -1.28994375245094, 218, 40, 'PPL', 'P'),
(161956, 'Gallows Hill', 40.5305595397949, 0.707391711645019, -75.2222213745117, -1.31287543364928, 218, 45, 'PPL', 'P'),
(36034, 'Gallup', 38.0130615234375, 0.663453082347156, -82.6227798461914, -1.44203954546645, 218, 21, 'PPL', 'P'),
(155395, 'Gallup', 41.1883316040039, 0.718871999893105, -84.029167175293, -1.46658563491761, 218, 41, 'PPL', 'P'),
(170349, 'Gallup', 45.0705604553223, 0.786629675664528, -98.495002746582, -1.71906209468871, 218, 49, 'PPL', 'P'),
(188589, 'Gallup', 35.5280609130859, 0.620081639782453, -108.741943359375, -1.89790494663828, 218, 38, 'PPL', 'P'),
(196560, 'Gallup City', 48.0938911437988, 0.839396750555031, -112.11222076416, -1.95672738405735, 218, 31, 'PPL', 'P'),
(172035, 'Gallup Mills', 44.5750007629395, 0.777980527392278, -71.7847213745117, -1.25287974061198, 218, 55, 'PPL', 'P'),
(178234, 'Gallups', 34.0786094665527, 0.594783939692654, -111.185829162598, -1.94055880044726, 218, 5, 'PPL', 'P'),
(2649, 'Gallups Crossroads', 33.3491706848145, 0.582052831259584, -86.4608306884766, -1.50902616952327, 218, 2, 'PPL', 'P'),
(149041, 'Gallupville', 42.6624984741211, 0.74460106550047, -74.2330627441406, -1.29561135872479, 218, 40, 'PPL', 'P'),
(60000, 'Gallway', 34.4888916015625, 0.601944713810686, -89.1922225952148, -1.55669795145818, 218, 30, 'PPL', 'P'),
(54903, 'Galmey', 37.8941688537598, 0.661378013804794, -93.3619384765625, -1.62947322246039, 218, 29, 'PPL', 'P'),
(109303, 'Galmish', 39.5647201538086, 0.690534634314117, -80.7052764892578, -1.40857279846992, 218, 58, 'PPL', 'P'),
(94403, 'Galpin Colonia', 26.2210006713867, 0.457642794883342, -97.8310012817383, -1.70747308288913, 218, 51, 'PPL', 'P'),
(32508, 'Galt', 38.4644393920898, 0.671331112325774, -98.0841674804688, -1.71189166661173, 218, 20, 'PPL', 'P'),
(47346, 'Galt', 39.6888885498047, 0.692701781651169, -77.1391677856445, -1.34633246010784, 218, 25, 'PPL', 'P'),
(115678, 'Galt', 42.6936111450195, 0.745144084046737, -93.6052780151367, -1.6337202986088, 218, 16, 'PPL', 'P'),
(119735, 'Galt', 41.7894401550293, 0.729363323270391, -89.7622222900391, -1.56664632286823, 218, 18, 'PPL', 'P'),
(139165, 'Galt', 40.1286087036133, 0.700376346122505, -93.3866729736328, -1.6299049208731, 218, 29, 'PPL', 'P'),
(181735, 'Galt', 38.2547187805176, 0.667670797144542, -121.298889160156, -2.11706499485639, 218, 6, 'PPL', 'P'),
(190225, 'Galt', 37.0175018310547, 0.646077287814934, -114.605003356934, -2.00023464783765, 218, 39, 'PPL', 'P'),
(16170, 'Galt City', 30.5891704559326, 0.533881739909799, -87.0580596923828, -1.51944978202984, 218, 12, 'PPL', 'P'),
(27235, 'Galton', 39.7394409179688, 0.693584086920312, -88.3002777099609, -1.54113057646418, 218, 18, 'PPL', 'P'),
(102165, 'Galts Mill', 37.4477806091309, 0.653587069193821, -79.0127792358398, -1.37903314881681, 218, 53, 'PPL', 'P'),
(32510, 'Galva', 38.3819389343262, 0.669891207703395, -97.5372161865234, -1.70234556568434, 218, 20, 'PPL', 'P'),
(41036, 'Galva', 30.2797203063965, 0.528480815929605, -90.3988876342773, -1.57775822935853, 218, 22, 'PPL', 'P'),
(115674, 'Galva', 42.5069389343262, 0.741886039348161, -95.4169387817383, -1.6653397439152, 218, 16, 'PPL', 'P'),
(119736, 'Galva', 41.1674995422363, 0.718508411825282, -90.0425033569336, -1.57153815031654, 218, 18, 'PPL', 'P'),
(36036, 'Galveston', 37.439998626709, 0.653451247978227, -82.6288909912109, -1.44214620506811, 218, 21, 'PPL', 'P'),
(94405, 'Galveston', 29.3011093139648, 0.511400832015463, -94.7975006103516, -1.65452850831197, 218, 51, 'PPL', 'P'),
(102166, 'Galveston', 36.9197196960449, 0.644370667609384, -79.3836135864258, -1.38550542921403, 218, 53, 'PPL', 'P'),
(122662, 'Galveston', 40.5788917541504, 0.708235267920302, -86.1902770996094, -1.50430411859445, 218, 19, 'PPL', 'P'),
(36035, 'Galveston PO (historical)', 37.439998626709, 0.653451247978227, -82.6288909912109, -1.44214620506811, 218, 21, 'PPL', 'P'),
(41037, 'Galvez', 30.2988891601563, 0.528815375541546, -90.9047164916992, -1.58658660837214, 218, 22, 'PPL', 'P'),
(41038, 'Galvez Town', 30.3449993133545, 0.529620149533454, -90.8930587768555, -1.58638314286486, 218, 22, 'PPL', 'P'),
(207477, 'Galvin', 46.7425003051758, 0.815810530939772, -123.025833129883, -2.14720585312558, 218, 56, 'PPL', 'P'),
(149042, 'Galway', 43.0186080932617, 0.750816350852497, -74.0319366455078, -1.29210104609196, 218, 40, 'PPL', 'P'),
(60001, 'Gama', 32.0222206115723, 0.558893183471928, -90.091667175293, -1.57239622081976, 218, 30, 'PPL', 'P'),
(9040, 'Gamaliel', 36.4566688537598, 0.636288905807375, -92.2330627441406, -1.60977062408377, 218, 4, 'PPL', 'P'),
(112337, 'Gamaliel', 36.639720916748, 0.639483767009089, -85.7966690063477, -1.49743436140454, 218, 21, 'PPL', 'P'),
(211842, 'Gambell', 63.7797203063965, 1.11316611534771, -171.741104125977, -2.99744772800871, 218, 1, 'PPL', 'P'),
(47347, 'Gamber', 39.4647216796875, 0.688789331693734, -76.9341735839844, -1.34275463634137, 218, 25, 'PPL', 'P'),
(155396, 'Gambier', 40.375560760498, 0.704686472609717, -82.397216796875, -1.43810272758504, 218, 41, 'PPL', 'P'),
(29870, 'Gambill', 39.0488891601563, 0.68153168509105, -87.2597198486328, -1.52296941572649, 218, 19, 'PPL', 'P'),
(2650, 'Gamble', 33.8794403076172, 0.5913077821008, -87.3344421386719, -1.5242735657123, 218, 2, 'PPL', 'P'),
(149044, 'Gamble Mill', 42.8569412231445, 0.747994731677558, -76.2525024414063, -1.33085723048755, 218, 40, 'PPL', 'P'),
(41039, 'Gamble Spur', 30.5047206878662, 0.532407813404495, -90.5666732788086, -1.58068664129318, 218, 22, 'PPL', 'P'),
(161959, 'Gambles', 40.2105598449707, 0.701806663364959, -80.1311111450195, -1.39855172276211, 218, 45, 'PPL', 'P'),
(94406, 'Gamblin', 32.8913917541504, 0.574063081673238, -95.5827789306641, -1.66823420054595, 218, 51, 'PPL', 'P'),
(60002, 'Gambrell', 31.8083305358887, 0.55516009741391, -89.3916702270508, -1.56017896931902, 218, 30, 'PPL', 'P'),
(115676, 'Gambrill (historical)', 41.7519416809082, 0.728708851432504, -90.5355606079102, -1.58014362274691, 218, 16, 'PPL', 'P'),
(47348, 'Gambrill South', 39.4666709899902, 0.68882335357666, -77.5166702270508, -1.3529211206447, 218, 25, 'PPL', 'P'),
(47349, 'Gambrills', 39.0669403076172, 0.681846737048006, -76.6655578613281, -1.3380664075584, 218, 25, 'PPL', 'P'),
(155397, 'Gambrinus', 40.7719383239746, 0.711604566173415, -81.4188919067383, -1.42102773709795, 218, 41, 'PPL', 'P'),
(54905, 'Gamburg', 36.6372184753418, 0.639440091167211, -90.6399993896484, -1.58196642335502, 218, 29, 'PPL', 'P'),
(209956, 'Game Creek', 58.0566711425781, 1.01328006418557, -135.507781982422, -2.36505695766791, 218, 1, 'PPL', 'P'),
(188590, 'Gamerco', 35.5722198486328, 0.620852358601921, -108.764717102051, -1.89830242343097, 218, 38, 'PPL', 'P'),
(36037, 'Gamesway', 37.9877815246582, 0.663011863133557, -84.48388671875, -1.4745219881241, 218, 21, 'PPL', 'P'),
(64955, 'Gamewell', 35.8691711425781, 0.626035136399325, -81.5963897705078, -1.42412565923598, 218, 33, 'PPL', 'P'),
(64956, 'Gamewell Heights', 35.8641700744629, 0.625947851294597, -81.6166687011719, -1.42447959334485, 218, 33, 'PPL', 'P'),
(21332, 'Gamma', 33.5077781677246, 0.584821054054667, -84.4397201538086, -1.47375113614657, 218, 13, 'PPL', 'P'),
(54904, 'Gamma', 39.0672187805176, 0.681851597316996, -91.3413925170898, -1.59420804277973, 218, 29, 'PPL', 'P'),
(21333, 'Gammage', 31.541389465332, 0.550501096823898, -83.8763885498047, -1.46391914487616, 218, 13, 'PPL', 'P'),
(9042, 'Gammon', 35.2480583190918, 0.61519467260313, -90.1524963378906, -1.57345788998832, 218, 4, 'PPL', 'P'),
(109305, 'Gamoca', 38.1933288574219, 0.666599340858976, -81.1852798461914, -1.41695043746904, 218, 58, 'PPL', 'P'),
(13810, 'Gams Crest', 39.5499992370605, 0.690277705847952, -75.647216796875, -1.32029300307543, 218, 10, 'PPL', 'P'),
(94407, 'Ganado', 29.0402793884277, 0.506848491027109, -96.5133285522461, -1.68447535529575, 218, 51, 'PPL', 'P'),
(178235, 'Ganado', 35.7113914489746, 0.623281361253155, -109.541389465332, -1.91185791337947, 218, 5, 'PPL', 'P'),
(109306, 'Gandeeville', 38.7050018310547, 0.675529718942338, -81.4105606079102, -1.42088232850243, 218, 58, 'PPL', 'P'),
(13811, 'Gander Hill', 39.4180603027344, 0.687974937032388, -75.6672210693359, -1.32064214349434, 218, 10, 'PPL', 'P'),
(36038, 'Gandertown', 37.6830596923828, 0.657693463857642, -85.3899993896484, -1.49033663762531, 218, 21, 'PPL', 'P'),
(60004, 'Gandsi', 31.5705604553223, 0.551010226645294, -89.498893737793, -1.56205037261702, 218, 30, 'PPL', 'P'),
(580, 'Gandy', 31.4025001525879, 0.54807702102068, -93.4475021362305, -1.63096659004166, 218, 22, 'PPL', 'P'),
(16171, 'Gandy', 27.8999996185303, 0.486946854648515, -82.6036071777344, -1.44170491927549, 218, 12, 'PPL', 'P'),
(81160, 'Gandy', 34.4413909912109, 0.601115671763344, -79.8569412231445, -1.39376655491546, 218, 48, 'PPL', 'P'),
(87189, 'Gandy', 35.2200012207031, 0.614704983857692, -87.4038925170898, -1.52548570348245, 218, 50, 'PPL', 'P'),
(94408, 'Gandy', 30.7186107635498, 0.536140899462513, -98.2313919067383, -1.71446121758949, 218, 51, 'PPL', 'P'),
(109307, 'Gandy', 38.8269386291504, 0.677657917548448, -79.5699996948242, -1.38875848048557, 218, 58, 'PPL', 'P'),
(192580, 'Gandy', 39.4500007629395, 0.688532403227568, -113.982223510742, -1.98936508900654, 218, 52, 'PPL', 'P'),
(199330, 'Gandy', 41.4697189331055, 0.723783135259321, -100.458061218262, -1.75332392842869, 218, 35, 'PPL', 'P'),
(70851, 'Gandys Beach', 39.2719383239746, 0.685424627393501, -75.2352828979492, -1.31310340023859, 218, 37, 'PPL', 'P'),
(16172, 'Gandyville', 30.996940612793, 0.540998671738386, -87.288330078125, -1.52346875843088, 218, 12, 'PPL', 'P'),
(2651, 'Ganer', 31.0830593109131, 0.542501726568113, -86.1069412231445, -1.50284963316511, 218, 2, 'PPL', 'P'),
(211843, 'Ganes Creek', 63.0897216796875, 1.10112336747739, -156.430557250977, -2.73022827475903, 218, 1, 'PPL', 'P'),
(41040, 'Ganeyville', 31.7199993133545, 0.553618426748376, -92.2811126708984, -1.61060925351104, 218, 22, 'PPL', 'P'),
(54906, 'Gang', 37.2066688537598, 0.649378875197333, -91.2305603027344, -1.59227365572195, 218, 29, 'PPL', 'P'),
(149054, 'Gang Mills', 42.146110534668, 0.735588395739424, -77.1119384765625, -1.34585721901132, 218, 40, 'PPL', 'P'),
(130939, 'Ganges', 42.5769386291504, 0.743107764498235, -86.2102813720703, -1.50465325901336, 218, 27, 'PPL', 'P'),
(155399, 'Ganges', 40.9061088562012, 0.713946283719922, -82.561393737793, -1.44096815575992, 218, 41, 'PPL', 'P'),
(161960, 'Ganister', 40.4747200012207, 0.706417127844105, -78.2261123657227, -1.36530322181691, 218, 45, 'PPL', 'P'),
(87190, 'Gann', 36.0086097717285, 0.628468799582466, -88.7369384765625, -1.54875174455566, 218, 50, 'PPL', 'P'),
(9043, 'Gann (historical)', 34.5472183227539, 0.602962707137369, -94.3444366455078, -1.64662105040331, 218, 4, 'PPL', 'P'),
(2662, 'Gann Crossroad', 34.7261085510254, 0.60608493062035, -85.6166687011719, -1.49429276342463, 218, 2, 'PPL', 'P'),
(193148, 'Gannett', 43.3600006103516, 0.756774774317386, -114.175003051758, -1.99272972672775, 218, 17, 'PPL', 'P'),
(124904, 'Gannett Corners', 42.2186088562012, 0.736853730152348, -70.7874984741211, -1.23547491762388, 218, 23, 'PPL', 'P'),
(47350, 'Gannon', 39.5091705322266, 0.689565110519274, -79.0427780151367, -1.37955672628712, 218, 25, 'PPL', 'P'),
(191517, 'Gannon', 32.5566711425781, 0.568221104927013, -100.483062744141, -1.7537602873733, 218, 51, 'PPL', 'P'),
(81161, 'Gannon (historical)', 32.686939239502, 0.57049471212864, -80.2774963378906, -1.40110662635388, 218, 48, 'PPL', 'P'),
(181736, 'Ganns', 38.4044418334961, 0.670283957385155, -120.158058166504, -2.09715373780835, 218, 6, 'PPL', 'P'),
(27236, 'Ganntown', 37.3633308410645, 0.652113142688517, -88.7841720581055, -1.54957612607109, 218, 18, 'PPL', 'P'),
(170350, 'Gannvalley', 44.0333290100098, 0.768526571838606, -98.9875030517578, -1.72765784658111, 218, 49, 'PPL', 'P'),
(36039, 'Gano', 36.9011116027832, 0.644045895114449, -83.1341705322266, -1.4509649967018, 218, 21, 'PPL', 'P'),
(72631, 'Gano', 39.3022193908691, 0.685953131711827, -84.408332824707, -1.47320332391034, 218, 41, 'PPL', 'P'),
(75896, 'Gano', 36.014720916748, 0.628575459184124, -96.7547225952148, -1.68868847614025, 218, 42, 'PPL', 'P'),
(187676, 'Gano', 38.1922187805176, 0.666579966362045, -100.910827636719, -1.76122619317323, 218, 20, 'PPL', 'P'),
(21334, 'Ganor', 31.1522197723389, 0.543708804332192, -83.7813873291016, -1.46226106078148, 218, 13, 'PPL', 'P'),
(109308, 'Ganotown', 39.4038887023926, 0.687727595946147, -78.1497192382813, -1.36396991021716, 218, 58, 'PPL', 'P'),
(75897, 'Gans', 35.3888893127441, 0.617652637131219, -94.6919403076172, -1.65268613346985, 218, 42, 'PPL', 'P'),
(78315, 'Gans', 39.7427787780762, 0.693642343569158, -79.8244400024414, -1.39319930160327, 218, 45, 'PPL', 'P'),
(75899, 'Gansel', 36.2799987792969, 0.633205431318254, -97.371940612793, -1.69946096274962, 218, 42, 'PPL', 'P'),
(149045, 'Gansevoort', 43.1961097717285, 0.753914339569559, -73.6522216796875, -1.2854737697193, 218, 40, 'PPL', 'P'),
(41041, 'Gansville', 32.1352806091309, 0.560866452681623, -92.7341690063477, -1.61851657826164, 218, 22, 'PPL', 'P'),
(87191, 'Gant', 35.6561088562012, 0.62231649799022, -87.1650009155273, -1.52131625847982, 218, 50, 'PPL', 'P'),
(127546, 'Gantners Landing', 45.7733306884766, 0.798895330118079, -68.4475021362305, -1.19463427704307, 218, 26, 'PPL', 'P'),
(2652, 'Gantt', 31.4066696166992, 0.548149791897467, -86.4841690063477, -1.509433500012, 218, 2, 'PPL', 'P'),
(81162, 'Gantt', 34.7999992370605, 0.607374566378221, -82.4244384765625, -1.43857783552351, 218, 48, 'PPL', 'P'),
(21335, 'Gantt Acres', 33.3677787780762, 0.58237760375452, -84.4277801513672, -1.47354274379127, 218, 13, 'PPL', 'P'),
(2653, 'Gantts Junction', 33.1680603027344, 0.578891858782742, -86.2980575561523, -1.50618524243043, 218, 2, 'PPL', 'P'),
(2654, 'Gantts Quarry', 33.1483306884766, 0.578547512053795, -86.289436340332, -1.50603477382884, 218, 2, 'PPL', 'P'),
(78316, 'Gap', 39.9872207641602, 0.697908661056438, -76.0208282470703, -1.32681375300449, 218, 45, 'PPL', 'P'),
(81164, 'Gap Creek', 35.1508293151855, 0.613497706356531, -82.4916687011719, -1.4397512242998, 218, 48, 'PPL', 'P'),
(87192, 'Gap Creek', 36.2855606079102, 0.633302503539987, -82.2324981689453, -1.4352278451883, 218, 50, 'PPL', 'P'),
(36040, 'Gap in Knob', 38.0166702270508, 0.663516066106936, -85.7030563354492, -1.49580051207577, 218, 21, 'PPL', 'P'),
(109309, 'Gap Mills', 37.5622215270996, 0.655584440011381, -80.408332824707, -1.40339015383057, 218, 58, 'PPL', 'P'),
(2655, 'Gap of the Mountain', 32.9111099243164, 0.574407228665103, -86.6074981689453, -1.51158599996306, 218, 2, 'PPL', 'P'),
(87195, 'Gap of the Ridge', 36.526668548584, 0.637510630957449, -86.1111068725586, -1.50292233746286, 218, 50, 'PPL', 'P'),
(9044, 'Gap Rancheros', 35.0036087036133, 0.610928221957796, -92.0875015258789, -1.60723010156189, 218, 4, 'PPL', 'P'),
(87193, 'Gap Run', 36.2616691589355, 0.632885519092308, -82.2291717529297, -1.43516978827654, 218, 50, 'PPL', 'P'),
(87194, 'Gap Spring', 35.0055618286133, 0.610962310419749, -84.7850036621094, -1.47977747021926, 218, 50, 'PPL', 'P'),
(102167, 'Gap Store', 37.1352806091309, 0.648132915281339, -81.6313934326172, -1.42473658839005, 218, 53, 'PPL', 'P'),
(36041, 'Gapcreek', 36.7447204589844, 0.641316354734199, -84.9952774047852, -1.48344743935944, 218, 21, 'PPL', 'P'),
(87196, 'Gapcreek (historical)', 35.9338912963867, 0.627164716175682, -83.7347183227539, -1.46144653296208, 218, 50, 'PPL', 'P'),
(47351, 'Gapgalleon', 39.2125015258789, 0.684387259569887, -76.658332824707, -1.33794030688078, 218, 25, 'PPL', 'P'),
(47352, 'Gapland', 39.4027786254883, 0.687708221449216, -77.6605606079102, -1.35543248155264, 218, 25, 'PPL', 'P'),
(78317, 'Gapsville', 39.9533309936523, 0.697317172978331, -78.241943359375, -1.36557952478001, 218, 45, 'PPL', 'P'),
(36042, 'Gapville', 37.6300010681152, 0.656767416167594, -82.9591674804688, -1.44791061724759, 218, 21, 'PPL', 'P'),
(81163, 'Gapway', 34.1575012207031, 0.596160860555252, -79.246940612793, -1.38312003582565, 218, 48, 'PPL', 'P'),
(188591, 'Garanbuio', 35.3158302307129, 0.616377515601289, -105.413330078125, -1.83980968535485, 218, 38, 'PPL', 'P'),
(78318, 'Garards Fort', 39.8158302307129, 0.694917331941033, -80.0266723632813, -1.39672892215401, 218, 45, 'PPL', 'P'),
(9047, 'Garber', 35.6650009155273, 0.622471693702744, -93.3675003051758, -1.62957029468213, 218, 4, 'PPL', 'P'),
(54907, 'Garber', 36.6916694641113, 0.640390440202206, -93.2988891601563, -1.62837280429797, 218, 29, 'PPL', 'P'),
(75902, 'Garber', 36.436939239502, 0.635944559078428, -97.5852813720703, -1.70318446142772, 218, 42, 'PPL', 'P'),
(87197, 'Garber', 36.2188911437988, 0.632138901880705, -82.4613876342773, -1.43922271998148, 218, 50, 'PPL', 'P'),
(115677, 'Garber', 42.7419395446777, 0.745987573742992, -91.2619400024414, -1.59282133480012, 218, 16, 'PPL', 'P'),
(119740, 'Garber', 40.5158309936523, 0.707134650020799, -88.3816680908203, -1.54255110658963, 218, 18, 'PPL', 'P'),
(193581, 'Garberville', 40.1002807617188, 0.699881930266132, -123.793891906738, -2.16061100763054, 218, 6, 'PPL', 'P'),
(81171, 'Garbon Subdivision', 33.0041694641113, 0.576031424034915, -80.1736068725586, -1.3992934131257, 218, 48, 'PPL', 'P'),
(149046, 'Garbutt', 43.0127792358398, 0.750714618098856, -77.7919387817383, -1.3577254632512, 218, 40, 'PPL', 'P'),
(94409, 'Garceno', 26.4061107635498, 0.460873575470258, -98.9391708374023, -1.72681429030583, 218, 51, 'PPL', 'P'),
(186745, 'Garcia', 37.0041694641113, 0.645844594114688, -105.536666870117, -1.84196231846396, 218, 7, 'PPL', 'P'),
(188592, 'Garcia', 31.333890914917, 0.54687956392604, -108.862503051758, -1.90000911021555, 218, 38, 'PPL', 'P'),
(207478, 'Garcia', 47.4238891601563, 0.827703009945575, -121.621109008789, -2.12268879213031, 218, 56, 'PPL', 'P'),
(188593, 'Garcia (historical)', 36.160831451416, 0.631125569085929, -103.514999389648, -1.80667756454929, 218, 38, 'PPL', 'P'),
(188595, 'Garcia Place', 33.1711082458496, 0.578945055425516, -107.486671447754, -1.87599631877269, 218, 38, 'PPL', 'P'),
(94410, 'Garcia''s Colonia', 26.3969993591309, 0.460714551463667, -98.8399963378906, -1.72508336875533, 218, 51, 'PPL', 'P'),
(94411, 'Garciasville', 26.3188896179199, 0.459351279301655, -98.6936111450195, -1.72252846516356, 218, 51, 'PPL', 'P'),
(27237, 'Gard', 38.8622207641602, 0.678273706971501, -89.9599990844727, -1.57009817911513, 218, 18, 'PPL', 'P'),
(140069, 'Gardar', 48.589168548584, 0.848040971979265, -97.8736114501953, -1.70821677062353, 218, 34, 'PPL', 'P'),
(161961, 'Gardeau', 41.6211090087891, 0.726425390534843, -78.2244415283203, -1.36527406020297, 218, 45, 'PPL', 'P'),
(2656, 'Garden', 33.1566696166992, 0.578693053807368, -88.1833267211914, -1.53908939664669, 218, 2, 'PPL', 'P'),
(102168, 'Garden', 37.1144409179688, 0.647769194055461, -81.9974975585938, -1.43112631079347, 218, 53, 'PPL', 'P'),
(130941, 'Garden', 45.7747192382813, 0.798919564883999, -86.5505599975586, -1.51059224140229, 218, 27, 'PPL', 'P'),
(155400, 'Garden', 41.6041717529297, 0.726129779653844, -83.79638671875, -1.46252284951664, 218, 41, 'PPL', 'P'),
(161962, 'Garden', 40.0666694641113, 0.699295302457015, -75.4488906860352, -1.3168315594486, 218, 45, 'PPL', 'P'),
(204048, 'Garden', 41.8891716003418, 0.731103965358867, -111.38500213623, -1.94403502461814, 218, 52, 'PPL', 'P'),
(29872, 'Garden Acres', 39.124439239502, 0.682850282725775, -86.5780563354492, -1.51107214303073, 218, 19, 'PPL', 'P'),
(94412, 'Garden Acres', 32.5944404602051, 0.568880303875834, -97.3022232055664, -1.69824416444757, 218, 51, 'PPL', 'P'),
(181738, 'Garden Acres', 37.9638900756836, 0.662594878685878, -121.228332519531, -2.11583354916833, 218, 6, 'PPL', 'P'),
(209909, 'Garden Acres', 41.228889465332, 0.719579868110849, -112.059722900391, -1.95581112348431, 218, 52, 'PPL', 'P'),
(21337, 'Garden Acres Estates', 32.103328704834, 0.56030878674936, -81.2508316040039, -1.41809453147333, 218, 13, 'PPL', 'P'),
(2657, 'Garden City', 34.0144386291504, 0.593663947296221, -86.746940612793, -1.51401972972522, 218, 2, 'PPL', 'P'),
(16174, 'Garden City', 30.8322200775146, 0.538123756052132, -86.533332824707, -1.51029157051522, 218, 12, 'PPL', 'P'),
(21338, 'Garden City', 32.1141700744629, 0.56049800434481, -81.154167175293, -1.41640741892277, 218, 13, 'PPL', 'P'),
(29873, 'Garden City', 39.1833305358887, 0.683878129748491, -85.9333267211914, -1.49981948847681, 218, 19, 'PPL', 'P'),
(41042, 'Garden City', 29.7652797698975, 0.519502134761971, -91.4655609130859, -1.59637519011678, 218, 22, 'PPL', 'P'),
(54908, 'Garden City', 38.5611114501953, 0.673018358034394, -94.1911087036133, -1.64394497298194, 218, 29, 'PPL', 'P'),
(60005, 'Garden City', 31.3669395446777, 0.547456371328637, -91.1277770996094, -1.59047975041167, 218, 30, 'PPL', 'P'),
(70857, 'Garden City', 39.7724990844727, 0.694161060770478, -75.0708312988281, -1.31023317837376, 218, 37, 'PPL', 'P'),
(72634, 'Garden City', 38.7077789306641, 0.675578188474178, -82.853889465332, -1.44607316925349, 218, 41, 'PPL', 'P'),
(75900, 'Garden City', 36.1105613708496, 0.630248190664803, -96.0027770996094, -1.6755645514464, 218, 42, 'PPL', 'P'),
(81165, 'Garden City', 33.5927810668945, 0.586304634518923, -79.0088882446289, -1.37896523820902, 218, 48, 'PPL', 'P'),
(102170, 'Garden City', 37.2316703796387, 0.649815234141942, -79.9286117553711, -1.39501744167947, 218, 53, 'PPL', 'P'),
(115679, 'Garden City', 42.2455596923828, 0.737324110979883, -93.3952789306641, -1.63005512315858, 218, 16, 'PPL', 'P'),
(130942, 'Garden City', 42.3255615234375, 0.738720406339412, -83.3311080932617, -1.45440220556271, 218, 27, 'PPL', 'P'),
(135506, 'Garden City', 44.0472183227539, 0.76876898607683, -94.1647186279297, -1.64348437927141, 218, 28, 'PPL', 'P'),
(149047, 'Garden City', 40.7266693115234, 0.710814472857016, -73.6347198486328, -1.28516830514226, 218, 40, 'PPL', 'P'),
(161963, 'Garden City', 40.4474983215332, 0.705942019905634, -79.7797164916992, -1.39241872908777, 218, 45, 'PPL', 'P'),
(169388, 'Garden City', 41.7622184753418, 0.728888215331921, -71.4522171020508, -1.24707644628059, 218, 47, 'PPL', 'P'),
(170351, 'Garden City', 44.9583282470703, 0.784670854103748, -97.5811080932617, -1.7031116239719, 218, 49, 'PPL', 'P'),
(187677, 'Garden City', 37.9716682434082, 0.662730633322445, -100.872222900391, -1.76055241341744, 218, 20, 'PPL', 'P'),
(191518, 'Garden City', 31.8638896942139, 0.556129787656321, -101.480827331543, -1.77117456458328, 218, 51, 'PPL', 'P'),
(194195, 'Garden City', 40.3938903808594, 0.705006384835662, -104.688888549805, -1.82716579544748, 218, 7, 'PPL', 'P'),
(194969, 'Garden City', 43.6222190856934, 0.76135135007166, -116.23722076416, -2.02872221570211, 218, 17, 'PPL', 'P'),
(204050, 'Garden City', 41.9469413757324, 0.732112238147571, -111.392776489258, -1.94417071267568, 218, 52, 'PPL', 'P'),
(207479, 'Garden City', 47.0544395446777, 0.821254897735248, -123.301940917969, -2.15202484311807, 218, 56, 'PPL', 'P'),
(194968, 'Garden City (historical)', 44.5074996948242, 0.776802411505054, -114.223892211914, -1.99358300354101, 218, 17, 'PPL', 'P'),
(81166, 'Garden City Beach', 33.5736083984375, 0.585970008327955, -79.0027770996094, -1.37885857860736, 218, 48, 'PPL', 'P'),
(149048, 'Garden City Park', 40.7408294677734, 0.711061614206176, -73.6630630493164, -1.28566298731475, 218, 40, 'PPL', 'P'),
(149049, 'Garden City South', 40.7122192382813, 0.710562271501786, -73.6613922119141, -1.28563382570081, 218, 40, 'PPL', 'P'),
(130944, 'Garden Corners', 45.8902816772461, 0.80093650993557, -86.5366668701172, -1.51034976058504, 218, 27, 'PPL', 'P'),
(16175, 'Garden Cove', 25.172779083252, 0.439347876879906, -80.3683319091797, -1.40269200615081, 218, 12, 'PPL', 'P'),
(64958, 'Garden Creek', 35.7044410705566, 0.623160054265502, -82.0361099243164, -1.43180022370732, 218, 33, 'PPL', 'P'),
(41044, 'Garden District', 29.9291706085205, 0.522362569509798, -90.0811080932617, -1.57221193007233, 218, 22, 'PPL', 'P'),
(47353, 'Garden Estates', 38.521671295166, 0.672329997471635, -77.1050033569336, -1.34573617833977, 218, 25, 'PPL', 'P'),
(87198, 'Garden Farms', 35.1930618286133, 0.614234802767238, -85.1847229003906, -1.48675388701083, 218, 50, 'PPL', 'P'),
(109310, 'Garden Farms', 38.3902816772461, 0.670036816035995, -82.3805618286133, -1.43781204355206, 218, 58, 'PPL', 'P'),
(181741, 'Garden Farms', 35.4180603027344, 0.618161766952614, -120.605278015137, -2.10495919664727, 218, 6, 'PPL', 'P'),
(16176, 'Garden Grove', 28.4799995422363, 0.497069762978502, -82.4352798461914, -1.43876705311896, 218, 12, 'PPL', 'P'),
(75901, 'Garden Grove', 35.4194412231445, 0.61818586856048, -96.7708282470703, -1.68896957279331, 218, 42, 'PPL', 'P'),
(115680, 'Garden Grove', 40.827220916748, 0.712569429436351, -93.6069412231445, -1.63374932706468, 218, 16, 'PPL', 'P'),
(181742, 'Garden Grove', 33.7738914489746, 0.589465606995765, -117.940559387207, -2.05845108295067, 218, 6, 'PPL', 'P'),
(21339, 'Garden Heights', 31.8291702270508, 0.555523818639787, -81.6016693115234, -1.4242178046097, 218, 13, 'PPL', 'P'),
(27238, 'Garden Heights', 37.7202796936035, 0.658343075426539, -88.5269393920898, -1.54508656910544, 218, 18, 'PPL', 'P'),
(21340, 'Garden Hill', 31.5352802276611, 0.550394470511754, -84.1305618286133, -1.46835530546196, 218, 13, 'PPL', 'P'),
(161964, 'Garden Hills', 40.0302810668945, 0.698660205116058, -76.3561096191406, -1.33266551686772, 218, 45, 'PPL', 'P'),
(200867, 'Garden Home', 45.4661102294922, 0.793533321579313, -122.752220153809, -2.1424304058169, 218, 43, 'PPL', 'P'),
(155406, 'Garden Isle', 41.0069389343262, 0.715706100568246, -82.0186080932617, -1.43149475913029, 218, 41, 'PPL', 'P'),
(16177, 'Garden Isles', 26.2236099243164, 0.457688334937982, -80.1188888549805, -1.3983384035588, 218, 12, 'PPL', 'P'),
(204053, 'Garden Lot Addition', 40.708610534668, 0.710499287742005, -112.103332519531, -1.95657225492385, 218, 52, 'PPL', 'P'),
(119745, 'Garden of Eden', 41.1697196960449, 0.718547160819143, -87.5616683959961, -1.52823941204959, 218, 18, 'PPL', 'P'),
(41043, 'Garden Park', 32.4686088562012, 0.566684128082901, -92.0597229003906, -1.60674527308544, 218, 22, 'PPL', 'P'),
(81168, 'Garden Park', 35.1199989318848, 0.612959614658281, -81.692497253418, -1.42580305124857, 218, 48, 'PPL', 'P'),
(32518, 'Garden Plain', 37.6583290100098, 0.657261832023967, -97.6833267211914, -1.70489567558615, 218, 20, 'PPL', 'P'),
(119742, 'Garden Plain', 41.8008308410645, 0.729562128245765, -90.1302795410156, -1.57307013373361, 218, 18, 'PPL', 'P'),
(119744, 'Garden Prairie', 42.2533302307129, 0.737459732458395, -88.7247161865234, -1.54853842535234, 218, 18, 'PPL', 'P'),
(94413, 'Garden Ridge', 29.6344394683838, 0.517218540706255, -98.3050003051758, -1.71574592649935, 218, 51, 'PPL', 'P'),
(36043, 'Garden Springs', 38.0288887023926, 0.663729318731224, -84.5486068725586, -1.47565156790045, 218, 21, 'PPL', 'P'),
(149050, 'Garden Terrace', 43.0855598449707, 0.751984879359796, -76.2841720581055, -1.3314099695718, 218, 40, 'PPL', 'P'),
(204054, 'Garden Towers Condominium', 40.7708282470703, 0.711585191676485, -111.884437561035, -1.95275181718208, 218, 52, 'PPL', 'P'),
(21343, 'Garden Valley', 32.4397201538086, 0.566179925109521, -84.1183319091797, -1.46814185310059, 218, 13, 'PPL', 'P'),
(94414, 'Garden Valley', 32.5259590148926, 0.567685077178607, -95.542121887207, -1.6675246012735, 218, 51, 'PPL', 'P'),
(181744, 'Garden Valley', 38.8541717529297, 0.678133225224, -120.858329772949, -2.10937578299905, 218, 6, 'PPL', 'P'),
(194970, 'Garden Valley', 44.0900001525879, 0.769515669867461, -115.951110839844, -2.02372865550016, 218, 17, 'PPL', 'P'),
(181745, 'Garden Valley (historical)', 39.4347190856934, 0.688265687644397, -121.10417175293, -2.11366653498934, 218, 6, 'PPL', 'P'),
(141867, 'Garden Valley Courts', 41.3083305358887, 0.720966376353371, -95.9380569458008, -1.67443497167004, 218, 35, 'PPL', 'P'),
(161966, 'Garden View', 40.7097206115723, 0.710518662238936, -77.5913925170898, -1.35422527063051, 218, 45, 'PPL', 'P'),
(36044, 'Garden Village', 37.4208297729492, 0.653116688366286, -82.4652786254883, -1.43929063058927, 218, 21, 'PPL', 'P'),
(109311, 'Garden Village', 39.4841690063477, 0.689128751574664, -80.1669387817383, -1.39917703298606, 218, 58, 'PPL', 'P'),
(122663, 'Garden Village', 41.6952781677246, 0.727719886561703, -85.914436340332, -1.49948978913386, 218, 19, 'PPL', 'P'),
(174219, 'Garden Village', 42.5547218322754, 0.74272000824352, -89.029167175293, -1.55385209751732, 218, 57, 'PPL', 'P'),
(47355, 'Garden Village Park', 39.3291702270508, 0.686423512539362, -76.5280609130859, -1.33566663310013, 218, 25, 'PPL', 'P'),
(102172, 'Garden Wood Park', 36.8963890075684, 0.643963470278711, -76.1741714477539, -1.32949009674196, 218, 53, 'PPL', 'P'),
(119746, 'Gardena', 40.6363906860352, 0.709238813598071, -89.5052795410156, -1.56216182590864, 218, 18, 'PPL', 'P'),
(181746, 'Gardena', 33.8883285522461, 0.591462911234298, -118.308059692383, -2.06486517327807, 218, 6, 'PPL', 'P'),
(194971, 'Gardena', 43.975830078125, 0.767523026160836, -116.190002441406, -2.02789810050279, 218, 17, 'PPL', 'P'),
(198315, 'Gardena', 48.7008285522461, 0.849989806685958, -100.497222900391, -1.75400742872246, 218, 34, 'PPL', 'P'),
(207480, 'Gardena', 46.0191688537598, 0.803186015529333, -118.673606872559, -2.07124517514352, 218, 56, 'PPL', 'P'),
(2659, 'Gardendale', 33.6599998474121, 0.58747782355813, -86.8127822875977, -1.51516888373559, 218, 2, 'PPL', 'P'),
(78321, 'Gardendale', 39.8422203063965, 0.695377925651563, -75.4466705322266, -1.31679281045474, 218, 45, 'PPL', 'P'),
(81169, 'Gardendale', 34.0374984741211, 0.594066417515959, -81.1391677856445, -1.41614563018761, 218, 48, 'PPL', 'P'),
(130946, 'Gardendale', 43.0386085510254, 0.751165424692379, -82.4925003051758, -1.43976573852774, 218, 27, 'PPL', 'P'),
(191519, 'Gardendale', 32.0202789306641, 0.558859294747057, -102.379722595215, -1.78686324656493, 218, 51, 'PPL', 'P'),
(181747, 'Gardenland', 38.6111106872559, 0.673891009344585, -121.473892211914, -2.1201193743106, 218, 6, 'PPL', 'P'),
(81170, 'Gardens Corner', 32.6005592346191, 0.568987096635547, -80.7613906860352, -1.4095521759608, 218, 48, 'PPL', 'P'),
(204056, 'Gardens of Eden', 41.297779083252, 0.720782218763992, -111.808326721191, -1.95142343243035, 218, 52, 'PPL', 'P'),
(36045, 'Gardenside', 38.038330078125, 0.663894101823673, -84.5422210693359, -1.47554011460883, 218, 21, 'PPL', 'P'),
(47356, 'Gardenspot', 39.688060760498, 0.692687334002256, -77.7527770996094, -1.35704196295743, 218, 25, 'PPL', 'P'),
(16178, 'Gardenville', 27.8461093902588, 0.486006292730526, -82.3819427490234, -1.43783614515993, 218, 12, 'PPL', 'P'),
(47357, 'Gardenville', 39.3308296203613, 0.686452474416217, -76.561393737793, -1.33624840064026, 218, 25, 'PPL', 'P'),
(70852, 'Gardenville', 39.8224983215332, 0.69503371208067, -75.1211090087891, -1.31111068995294, 218, 37, 'PPL', 'P'),
(130959, 'Gardenville', 46.4625015258789, 0.810923630339476, -84.3013916015625, -1.47133684746036, 218, 27, 'PPL', 'P'),
(149051, 'Gardenville', 42.8586082458496, 0.748023826712467, -78.7547225952148, -1.37452921078127, 218, 40, 'PPL', 'P'),
(161967, 'Gardenville', 40.372501373291, 0.70463307622986, -75.1080627441406, -1.31088298967974, 218, 45, 'PPL', 'P'),
(70853, 'Gardenville Center', 39.8300018310547, 0.695164673027275, -75.1227798461914, -1.31113985156688, 218, 37, 'PPL', 'P'),
(41050, 'Gardere', 30.3455600738525, 0.52962993665046, -91.1399993896484, -1.59069306961499, 218, 22, 'PPL', 'P'),
(41045, 'Gardere Place', 30.3472194671631, 0.529658898527315, -91.1350021362305, -1.59060585108929, 218, 22, 'PPL', 'P'),
(21344, 'Gardi', 31.5380592346191, 0.550442973333107, -81.7983322143555, -1.42765021978065, 218, 13, 'PPL', 'P'),
(115683, 'Gardiner', 41.8244400024414, 0.729974185845428, -94.0277786254883, -1.64109432535112, 218, 16, 'PPL', 'P'),
(127547, 'Gardiner', 44.2299995422363, 0.771959120167609, -69.7758331298828, -1.2178180264386, 218, 26, 'PPL', 'P'),
(141868, 'Gardiner', 41.3574981689453, 0.721824513435622, -97.5644378662109, -1.70282067362281, 218, 35, 'PPL', 'P'),
(149052, 'Gardiner', 41.6797218322754, 0.727448377288569, -74.1508331298828, -1.29417618121335, 218, 40, 'PPL', 'P'),
(188596, 'Gardiner', 36.8852806091309, 0.643769592151353, -104.481941223145, -1.82355388321906, 218, 38, 'PPL', 'P'),
(196561, 'Gardiner', 45.0319404602051, 0.785955629592629, -110.705001831055, -1.93216678037826, 218, 31, 'PPL', 'P'),
(200868, 'Gardiner', 43.730281829834, 0.763237400755654, -124.109169006348, -2.16611363107487, 218, 43, 'PPL', 'P'),
(207481, 'Gardiner', 48.0499992370605, 0.83863069226747, -122.914436340332, -2.14526161237176, 218, 56, 'PPL', 'P'),
(204055, 'Gardiner Estates', 40.4972190856934, 0.706809810946837, -111.988891601563, -1.95457488410629, 218, 52, 'PPL', 'P'),
(2661, 'Gardiners Gin', 33.8147201538086, 0.590178202324443, -87.2019424438477, -1.52196100977973, 218, 2, 'PPL', 'P'),
(70854, 'Gardiners Landing', 39.625, 0.691586716102753, -74.6402816772461, -1.30271866988394, 218, 37, 'PPL', 'P'),
(9048, 'Gardner', 33.1061096191406, 0.57781061538017, -92.3808288574219, -1.6123496292834, 218, 4, 'PPL', 'P'),
(16180, 'Gardner', 30.4913902282715, 0.532175152993763, -84.1255569458008, -1.46826795377821, 218, 12, 'PPL', 'P'),
(21345, 'Gardner', 32.853328704834, 0.573398756139317, -82.9627838134766, -1.44797373416542, 218, 13, 'PPL', 'P'),
(32515, 'Gardner', 38.8108291625977, 0.677376754316363, -94.9269409179688, -1.65678766786468, 218, 20, 'PPL', 'P'),
(36046, 'Gardner', 36.9680595397949, 0.645214357042721, -83.5386123657227, -1.45802383832911, 218, 21, 'PPL', 'P'),
(41046, 'Gardner', 31.2694396972656, 0.545754677971104, -92.6927795410156, -1.61779419581596, 218, 22, 'PPL', 'P'),
(87199, 'Gardner', 36.3583297729492, 0.634572565063846, -88.898063659668, -1.55156390950873, 218, 50, 'PPL', 'P'),
(102173, 'Gardner', 37.0305595397949, 0.646305187825218, -81.9358291625977, -1.43004999423892, 218, 53, 'PPL', 'P'),
(109313, 'Gardner', 37.4236106872559, 0.653165224477153, -81.0744400024414, -1.4150159172532, 218, 58, 'PPL', 'P'),
(115684, 'Gardner', 41.6744384765625, 0.727356165335825, -94.7636108398438, -1.65393702023386, 218, 16, 'PPL', 'P'),
(119747, 'Gardner', 41.1855583190918, 0.718823596940293, -88.3097229003906, -1.54129542613565, 218, 18, 'PPL', 'P'),
(124905, 'Gardner', 42.5750007629395, 0.743073942352391, -71.9986114501953, -1.25661282667, 218, 23, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(130947, 'Gardner', 45.5363883972168, 0.794759906998377, -87.7077789306641, -1.5307895219514, 218, 27, 'PPL', 'P'),
(139166, 'Gardner', 40.311939239502, 0.703576067593208, -93.9752807617188, -1.64017806477808, 218, 29, 'PPL', 'P'),
(140071, 'Gardner', 47.1472206115723, 0.822874232836071, -96.9674987792969, -1.69240212112231, 218, 34, 'PPL', 'P'),
(155402, 'Gardner', 40.9819412231445, 0.715269808202664, -82.7438888549805, -1.44415329642365, 218, 41, 'PPL', 'P'),
(161968, 'Gardner', 40.7436103820801, 0.711110150317042, -78.2297210693359, -1.36536620557669, 218, 45, 'PPL', 'P'),
(186746, 'Gardner', 37.7833290100098, 0.65944349358896, -105.165000915527, -1.8354755238388, 218, 7, 'PPL', 'P'),
(81172, 'Gardner Crossroads', 34.042781829834, 0.594158629468703, -79.6580581665039, -1.39029539075065, 218, 48, 'PPL', 'P'),
(204057, 'Gardner Gardens', 40.6199989318848, 0.708952723517969, -111.877777099609, -1.9526355702005, 218, 52, 'PPL', 'P'),
(161969, 'Gardner Hill', 41.2808303833008, 0.720486408145911, -78.5563888549805, -1.37106763399639, 218, 45, 'PPL', 'P'),
(109315, 'Gardner Junction', 37.3958282470703, 0.652680329421677, -81.0858306884766, -1.41521472222858, 218, 58, 'PPL', 'P'),
(102177, 'Gardner Mills', 36.7386093139648, 0.641209695132542, -80.753059387207, -1.40940676736528, 218, 53, 'PPL', 'P'),
(64961, 'Gardner Park', 35.2541694641113, 0.615301332204788, -81.1311111450195, -1.41600501528206, 218, 33, 'PPL', 'P'),
(72637, 'Gardner Terrace', 38.452220916748, 0.671117859701486, -82.3397216796875, -1.4370992484863, 218, 41, 'PPL', 'P'),
(21346, 'Gardner Woods', 33.7949981689453, 0.589833988753551, -84.5777816772461, -1.47616076430088, 218, 13, 'PPL', 'P'),
(161970, 'Gardners', 40.0055618286133, 0.698228773019465, -77.2072219848633, -1.34752022995402, 218, 45, 'PPL', 'P'),
(169389, 'Gardners Corner', 41.5472183227539, 0.725135754776972, -71.5338897705078, -1.24850190325405, 218, 47, 'PPL', 'P'),
(130948, 'Gardners Corners', 42.1291694641113, 0.735292718279398, -85.3530578613281, -1.48969188632541, 218, 27, 'PPL', 'P'),
(102174, 'Gardners Crossroads', 37.8944396972656, 0.661382740915728, -77.8477783203125, -1.35870004705211, 218, 53, 'PPL', 'P'),
(143850, 'Gardners Grove', 43.4583282470703, 0.758490915323833, -71.5319366455078, -1.2484678147921, 218, 36, 'PPL', 'P'),
(36047, 'Gardnersville', 38.7666702270508, 0.676606035496894, -84.5044403076172, -1.47488071592293, 218, 21, 'PPL', 'P'),
(149055, 'Gardnersville', 42.7238883972168, 0.745672521786036, -74.5824966430664, -1.30171013077913, 218, 40, 'PPL', 'P'),
(149056, 'Gardnertown', 41.5349998474121, 0.724922502152684, -74.070556640625, -1.29277509216386, 218, 40, 'PPL', 'P'),
(54909, 'Gardnerville', 38.8113899230957, 0.677386541433369, -90.5261077880859, -1.57997863991738, 218, 29, 'PPL', 'P'),
(64964, 'Gardnerville', 35.3894386291504, 0.617662224511143, -77.2991714477539, -1.3491250508269, 218, 33, 'PPL', 'P'),
(149057, 'Gardnerville', 41.3444404602051, 0.721596613425338, -74.4872207641602, -1.30004725299448, 218, 40, 'PPL', 'P'),
(190226, 'Gardnerville', 38.9413909912109, 0.679655488103089, -119.748611450195, -2.09000754449729, 218, 39, 'PPL', 'P'),
(190228, 'Gardnerville Ranchos', 38.8883285522461, 0.678729373834014, -119.740280151367, -2.08986213590177, 218, 39, 'PPL', 'P'),
(27241, 'Gards Point', 38.4744415283203, 0.671505682535229, -87.9111099243164, -1.53433831726198, 218, 18, 'PPL', 'P'),
(181749, 'Garey', 34.8886108398438, 0.608921130602258, -120.313888549805, -2.0998734910716, 218, 6, 'PPL', 'P'),
(47373, 'Gareys (historical)', 38.9208297729492, 0.679296627146201, -75.7558288574219, -1.32218864113935, 218, 25, 'PPL', 'P'),
(9050, 'Garfield', 36.4483299255371, 0.636143364053802, -93.9738922119141, -1.64015383001216, 218, 4, 'PPL', 'P'),
(21347, 'Garfield', 32.6497192382813, 0.569845100559743, -82.0983276367188, -1.4328861276418, 218, 13, 'PPL', 'P'),
(32536, 'Garfield', 38.0777816772461, 0.664582662123513, -99.2444381713867, -1.73214221038264, 218, 20, 'PPL', 'P'),
(36048, 'Garfield', 37.7827796936035, 0.659433906209036, -86.3574981689453, -1.50722267683307, 218, 21, 'PPL', 'P'),
(47358, 'Garfield', 39.603889465332, 0.691218267765941, -77.522216796875, -1.35301792655032, 218, 25, 'PPL', 'P'),
(54910, 'Garfield', 36.5852813720703, 0.638533617711176, -91.3258285522461, -1.59393640034854, 218, 29, 'PPL', 'P'),
(94421, 'Garfield', 29.0422191619873, 0.506882346462467, -97.6516723632813, -1.70434320281801, 218, 51, 'PPL', 'P'),
(109314, 'Garfield', 38.954719543457, 0.679888115224307, -81.5447235107422, -1.42322391289088, 218, 58, 'PPL', 'P'),
(115685, 'Garfield', 40.7686080932617, 0.711546442682624, -93.0016708374023, -1.62318536596866, 218, 16, 'PPL', 'P'),
(119748, 'Garfield', 41.0849990844727, 0.717068507202904, -88.9561080932617, -1.55257697598739, 218, 18, 'PPL', 'P'),
(122664, 'Garfield', 40.0830612182617, 0.699581392537116, -86.8238906860352, -1.51536276186295, 218, 19, 'PPL', 'P'),
(130949, 'Garfield', 43.351390838623, 0.756624505452878, -84.1338882446289, -1.46841336237373, 218, 27, 'PPL', 'P'),
(135509, 'Garfield', 45.9408302307129, 0.801818748625686, -95.4916687011719, -1.66664402705907, 218, 28, 'PPL', 'P'),
(145282, 'Garfield', 40.8813896179199, 0.713514851623329, -74.1136093139648, -1.29352650306542, 218, 37, 'PPL', 'P'),
(149058, 'Garfield', 42.5400009155273, 0.742463079777354, -73.3944396972656, -1.28097462537372, 218, 40, 'PPL', 'P'),
(155403, 'Garfield', 40.9183311462402, 0.714159602923237, -80.9552764892578, -1.4129361215999, 218, 41, 'PPL', 'P'),
(161971, 'Garfield', 40.4305610656738, 0.705646409024636, -76.0400009155273, -1.32714837919545, 218, 45, 'PPL', 'P'),
(172036, 'Garfield', 44.6025009155273, 0.778460495599737, -72.5366668701172, -1.26600366530583, 218, 55, 'PPL', 'P'),
(174221, 'Garfield', 44.561939239502, 0.777752560802967, -89.2941665649414, -1.55847720938246, 218, 57, 'PPL', 'P'),
(188597, 'Garfield', 32.7569389343262, 0.571716437278714, -107.263893127441, -1.87210810358117, 218, 38, 'PPL', 'P'),
(194973, 'Garfield', 43.6352806091309, 0.76157931666097, -111.96305847168, -1.95412401093374, 218, 17, 'PPL', 'P'),
(204059, 'Garfield', 40.7272186279297, 0.71082406023694, -112.165000915527, -1.95764857147841, 218, 52, 'PPL', 'P'),
(207482, 'Garfield', 47.0080604553223, 0.820445429921918, -117.139999389648, -2.04447867513351, 218, 56, 'PPL', 'P'),
(41047, 'Garfield (historical)', 32.9119415283203, 0.574421742893044, -94.0341720581055, -1.64120591180079, 218, 22, 'PPL', 'P'),
(64965, 'Garfield (historical)', 35.5458297729492, 0.620391764891392, -80.3788909912109, -1.40287629689824, 218, 33, 'PPL', 'P'),
(186747, 'Garfield (historical)', 38.5516700744629, 0.672853574941945, -106.29167175293, -1.85513963953768, 218, 7, 'PPL', 'P'),
(190229, 'Garfield (historical)', 38.4513893127441, 0.671103345473545, -118.313056945801, -2.06495239180377, 218, 39, 'PPL', 'P'),
(200869, 'Garfield (historical)', 45.2772216796875, 0.790236594465904, -122.277496337891, -2.1341449121915, 218, 43, 'PPL', 'P'),
(32519, 'Garfield Center', 39.523609161377, 0.689817112137423, -97.1277770996094, -1.69519950553133, 218, 20, 'PPL', 'P'),
(102175, 'Garfield Estates', 38.6055603027344, 0.673794136859934, -77.2977828979492, -1.34910081606098, 218, 53, 'PPL', 'P'),
(13109, 'Garfield Heights', 38.8555603027344, 0.67815745998992, -76.9697189331055, -1.34337501971731, 218, 9, 'PPL', 'P'),
(155404, 'Garfield Heights', 41.4169387817383, 0.722861947838262, -81.6061096191406, -1.42429530259742, 218, 41, 'PPL', 'P'),
(204061, 'Garfield Junction', 40.728889465332, 0.710853221850877, -112.186943054199, -1.95803153404316, 218, 52, 'PPL', 'P'),
(47359, 'Garfield Manor', 39.2430610656738, 0.684920624157203, -77.1822204589844, -1.34708387100941, 218, 25, 'PPL', 'P'),
(13812, 'Garfield Park', 39.7019386291504, 0.692929548503398, -75.5561065673828, -1.31870282958854, 218, 10, 'PPL', 'P'),
(145283, 'Garfield Park', 40.0208282470703, 0.698495222286528, -74.8797225952148, -1.30689770226649, 218, 37, 'PPL', 'P'),
(145284, 'Garfield Park East', 40.0230598449707, 0.69853417101747, -74.8675003051758, -1.30668438306318, 218, 37, 'PPL', 'P'),
(145285, 'Garfield Park North', 40.0311088562012, 0.698674652764972, -74.8622207641602, -1.30659223768946, 218, 37, 'PPL', 'P'),
(102176, 'Gargatha', 37.7999992370605, 0.659734443938051, -75.5983276367188, -1.31943972626217, 218, 53, 'PPL', 'P'),
(161973, 'Gargol', 40.0158309936523, 0.698408003760828, -77.1730575561523, -1.34692394818595, 218, 45, 'PPL', 'P'),
(200870, 'Garibaldi', 45.560001373291, 0.795172031177066, -123.909721374512, -2.16263261321402, 218, 43, 'PPL', 'P'),
(2663, 'Garland', 31.5563907623291, 0.550762918848566, -86.8233337402344, -1.51535304132497, 218, 2, 'PPL', 'P'),
(9052, 'Garland', 33.3627815246582, 0.582290385228819, -93.709716796875, -1.6355430992169, 218, 4, 'PPL', 'P'),
(21348, 'Garland', 34.5152816772461, 0.602405307521215, -83.9055633544922, -1.46442834127659, 218, 13, 'PPL', 'P'),
(27242, 'Garland', 39.7183303833008, 0.6932156385835, -87.811393737793, -1.53259794148962, 218, 18, 'PPL', 'P'),
(32529, 'Garland', 37.7316703796387, 0.658541880401914, -94.6222229003906, -1.65146933516779, 218, 20, 'PPL', 'P'),
(41048, 'Garland', 30.7269401550293, 0.536286274768518, -92.0722198486328, -1.60696338597872, 218, 22, 'PPL', 'P'),
(47361, 'Garland', 39.589168548584, 0.690961339299775, -76.1730575561523, -1.329470655666, 218, 25, 'PPL', 'P'),
(54911, 'Garland', 38.4433288574219, 0.670962663988961, -93.853889465332, -1.63805938697286, 218, 29, 'PPL', 'P'),
(64966, 'Garland', 34.7861099243164, 0.607132152139997, -78.3944396972656, -1.36824108797343, 218, 33, 'PPL', 'P'),
(72636, 'Garland', 39.9347190856934, 0.696992333904369, -84.3694381713867, -1.47252448414848, 218, 41, 'PPL', 'P'),
(75905, 'Garland', 35.3188896179199, 0.616430911981145, -95.0513916015625, -1.65895974204975, 218, 42, 'PPL', 'P'),
(87202, 'Garland', 35.5883293151855, 0.621133521834007, -89.7525024414063, -1.56647667950679, 218, 50, 'PPL', 'P'),
(94419, 'Garland', 32.9124984741211, 0.574431463431023, -96.6386108398438, -1.68666194370876, 218, 51, 'PPL', 'P'),
(109316, 'Garland', 37.4005584716797, 0.652762887415469, -81.7847213745117, -1.42741266581141, 218, 58, 'PPL', 'P'),
(115697, 'Garland', 41.0591697692871, 0.716617700609381, -91.2174987792969, -1.59204568913264, 218, 16, 'PPL', 'P'),
(127550, 'Garland', 45.038330078125, 0.786067149463276, -69.1608276367188, -1.20708415566503, 218, 26, 'PPL', 'P'),
(141882, 'Garland', 40.9447212219238, 0.714620196633767, -96.9852828979492, -1.69271251254736, 218, 35, 'PPL', 'P'),
(149059, 'Garland', 43.2249984741211, 0.754418542542938, -77.8902816772461, -1.35944187057376, 218, 40, 'PPL', 'P'),
(161974, 'Garland', 41.8161087036133, 0.729828777249909, -79.4441680908203, -1.38656230469263, 218, 45, 'PPL', 'P'),
(196562, 'Garland', 46.0483283996582, 0.803694945613647, -105.930000305176, -1.84882728196392, 218, 31, 'PPL', 'P'),
(204060, 'Garland', 41.7411117553711, 0.728519833574136, -112.160827636719, -1.95757573402259, 218, 52, 'PPL', 'P'),
(209470, 'Garland', 44.7797203063965, 0.781553557468783, -108.659721374512, -1.89646990228489, 218, 59, 'PPL', 'P'),
(186749, 'Garland City (historical)', 37.4524993896484, 0.653669427450532, -105.341667175293, -1.8385589317489, 218, 7, 'PPL', 'P'),
(102178, 'Garland Hill', 37.4169387817383, 0.653048777758489, -79.154167175293, -1.38150083388288, 218, 53, 'PPL', 'P'),
(47362, 'Garland Park', 39.1877784729004, 0.683955760894267, -76.646110534668, -1.33772698767747, 218, 25, 'PPL', 'P'),
(9054, 'Garland Springs', 35.2275009155273, 0.614835878225269, -92.1527786254883, -1.60836940187623, 218, 4, 'PPL', 'P'),
(130956, 'Garland Village', 44.8594398498535, 0.782944925980295, -84.3030624389648, -1.4713660090743, 218, 27, 'PPL', 'P'),
(9060, 'Garlandville', 33.8116683959961, 0.590124939102642, -93.4844436645508, -1.63161134134156, 218, 4, 'PPL', 'P'),
(60008, 'Garlandville', 32.2194404602051, 0.562335319180856, -89.1224975585938, -1.55548101999807, 218, 30, 'PPL', 'P'),
(130957, 'Garletts Corner', 44.2222213745117, 0.771823365531042, -85.8041687011719, -1.49756525577212, 218, 27, 'PPL', 'P'),
(36049, 'Garlin', 37.1138916015625, 0.647759606675537, -85.2522201538086, -1.48793193631903, 218, 21, 'PPL', 'P'),
(149060, 'Garlinghouse', 42.6088905334473, 0.743665430430498, -77.4719390869141, -1.35214041497114, 218, 40, 'PPL', 'P'),
(81173, 'Garlington (historical)', 34.4930610656738, 0.602017484687472, -81.6750030517578, -1.42549771982959, 218, 48, 'PPL', 'P'),
(21349, 'Garlington Heights Housing Project', 31.2072200775146, 0.544668740747111, -82.3758316040039, -1.43772948555827, 218, 13, 'PPL', 'P'),
(181750, 'Garlock', 35.4025001525879, 0.617890191100454, -117.789169311523, -2.05580882767515, 218, 6, 'PPL', 'P'),
(161975, 'Garmantown', 40.6797218322754, 0.709995084768626, -78.8083267211914, -1.37546477927222, 218, 45, 'PPL', 'P'),
(87204, 'Garmar Subdivision', 36.2138900756836, 0.632051616775977, -85.4905624389648, -1.49209179394173, 218, 50, 'PPL', 'P'),
(36050, 'Garmeada', 36.625, 0.639226838542923, -83.8424987792969, -1.46332765679806, 218, 21, 'PPL', 'P'),
(2668, 'Garmon Crossroads', 31.9394397735596, 0.557448385291047, -85.5533294677734, -1.49318728525613, 218, 2, 'PPL', 'P'),
(64968, 'Garmons (historical)', 35.2761116027832, 0.615684294769541, -80.4516677856445, -1.40414649158015, 218, 33, 'PPL', 'P'),
(115698, 'Garnavillo', 42.8686103820801, 0.748198396921922, -91.2358322143555, -1.59236566793761, 218, 16, 'PPL', 'P'),
(196564, 'Garneill', 46.752498626709, 0.815985034570199, -109.751937866211, -1.91553267620962, 218, 31, 'PPL', 'P'),
(9061, 'Garner', 35.1413917541504, 0.61333298984311, -91.7861099243164, -1.60196982577676, 218, 4, 'PPL', 'P'),
(36052, 'Garner', 38.2947196960449, 0.668368944824306, -82.7358322143555, -1.44401268151809, 218, 21, 'PPL', 'P'),
(54912, 'Garner', 39.9658317565918, 0.697535352450636, -92.9763870239258, -1.62274408017604, 218, 29, 'PPL', 'P'),
(64969, 'Garner', 35.711109161377, 0.623276434405139, -78.6144409179688, -1.37208083363311, 218, 33, 'PPL', 'P'),
(94420, 'Garner', 32.8330612182617, 0.573045021767528, -97.9850006103516, -1.71016087821929, 218, 51, 'PPL', 'P'),
(115700, 'Garner', 43.1025009155273, 0.752280556819822, -93.6016693115234, -1.63365731484902, 218, 16, 'PPL', 'P'),
(211844, 'Garner', 63.8291702270508, 1.11402917927797, -148.973327636719, -2.60007506491301, 218, 1, 'PPL', 'P'),
(2664, 'Garner (historical)', 34.7358283996582, 0.606254573981788, -86.8805618286133, -1.51635185989181, 218, 2, 'PPL', 'P'),
(102180, 'Garners Mill', 36.5558280944824, 0.638019561041763, -77.6708297729492, -1.355611712294, 218, 53, 'PPL', 'P'),
(81174, 'Garners Quarter (historical)', 33.9430618286133, 0.592418187117309, -80.6427764892578, -1.40748196768742, 218, 48, 'PPL', 'P'),
(64971, 'Garners Store', 35.4047203063965, 0.617928940094314, -79.5744400024414, -1.38883597847329, 218, 33, 'PPL', 'P'),
(2665, 'Garnersville', 31.8761100769043, 0.556343073570123, -86.2727813720703, -1.50574408979586, 218, 2, 'PPL', 'P'),
(21350, 'Garnersville', 31.7516708374023, 0.554171199122136, -85.0005569458008, -1.48353958473316, 218, 13, 'PPL', 'P'),
(27243, 'Garnerville', 38.1144409179688, 0.665222486575405, -88.0530624389648, -1.53681585602409, 218, 18, 'PPL', 'P'),
(149061, 'Garnerville', 41.2016716003418, 0.719104826751406, -73.9947204589844, -1.29145150110209, 218, 40, 'PPL', 'P'),
(135513, 'Garnes', 47.9063911437988, 0.836124258207542, -95.8805618286133, -1.6734314925713, 218, 28, 'PPL', 'P'),
(130958, 'Garnet', 46.1583290100098, 0.805614818443485, -85.3066711425781, -1.48888228535402, 218, 27, 'PPL', 'P'),
(174224, 'Garnet', 43.9355583190918, 0.766820151370137, -88.2627792358398, -1.54047610462629, 218, 57, 'PPL', 'P'),
(181751, 'Garnet', 33.9019393920898, 0.591700465203533, -116.544723510742, -2.0340891510889, 218, 6, 'PPL', 'P'),
(190231, 'Garnet', 36.3886108398438, 0.635101069382172, -114.870277404785, -2.00486455339275, 218, 39, 'PPL', 'P'),
(196565, 'Garnet', 46.8252792358398, 0.81725529583114, -113.33805847168, -1.97812228814866, 218, 31, 'PPL', 'P'),
(149062, 'Garnet Lake', 43.5416717529297, 0.759945533911234, -74.0124969482422, -1.29176175936908, 218, 40, 'PPL', 'P'),
(9064, 'Garnett', 33.8441696166992, 0.590692192414829, -91.7774963378906, -1.60181949033323, 218, 4, 'PPL', 'P'),
(32530, 'Garnett', 38.2805595397949, 0.668121803475147, -95.2416687011719, -1.66228070392908, 218, 20, 'PPL', 'P'),
(36053, 'Garnett', 38.459171295166, 0.671239166689139, -84.3274993896484, -1.47179251432287, 218, 21, 'PPL', 'P'),
(75908, 'Garnett', 36.186939239502, 0.631581235948442, -95.8263931274414, -1.67248607038432, 218, 42, 'PPL', 'P'),
(81175, 'Garnett', 32.6061096191406, 0.569083969120198, -81.2455596923828, -1.41800251925767, 218, 48, 'PPL', 'P'),
(41049, 'Garnett (historical)', 31.4624996185303, 0.549124209250813, -92.4674987792969, -1.61386230478257, 218, 22, 'PPL', 'P'),
(102179, 'Garnett Crossing', 37.848331451416, 0.660578000213334, -77.4436111450195, -1.35164599911477, 218, 53, 'PPL', 'P'),
(16181, 'Garnier', 30.4577808380127, 0.531588558474159, -86.6013870239258, -1.5114793403614, 218, 12, 'PPL', 'P'),
(2666, 'Garnsey', 33.1322212219238, 0.57826634882171, -87.0074996948242, -1.51856734360264, 218, 2, 'PPL', 'P'),
(54913, 'Garnsey', 37.8236083984375, 0.660146501537714, -92.4569396972656, -1.61367801403513, 218, 29, 'PPL', 'P'),
(181752, 'Garnsey', 34.1686096191406, 0.59635473868261, -118.401107788086, -2.0664891689108, 218, 6, 'PPL', 'P'),
(2667, 'Garnsey Number 2', 33.1569404602051, 0.578697780918302, -86.9888916015625, -1.51824257110771, 218, 2, 'PPL', 'P'),
(186750, 'Garo', 39.107780456543, 0.682559532113766, -105.889717102051, -1.84812420743613, 218, 7, 'PPL', 'P'),
(149063, 'Garoga', 43.0438919067383, 0.751257636645123, -74.5169372558594, -1.30056590361677, 218, 40, 'PPL', 'P'),
(36054, 'Garrard', 37.1236114501953, 0.647929250036975, -83.7463912963867, -1.46165026478547, 218, 21, 'PPL', 'P'),
(194974, 'Garrard Ranch', 42.3166694641113, 0.738565210626887, -114.000831604004, -1.98968986150148, 218, 17, 'PPL', 'P'),
(21351, 'Garrards Crossing', 34.0361099243164, 0.594042182750039, -84.4088897705078, -1.47321304444832, 218, 13, 'PPL', 'P'),
(149064, 'Garrattsville', 42.6472206115723, 0.744334416496326, -75.1722183227539, -1.31200271576007, 218, 40, 'PPL', 'P'),
(64972, 'Garren Hill', 35.1872215270996, 0.614132870276515, -79.5022201538086, -1.38757550432935, 218, 33, 'PPL', 'P'),
(170363, 'Garretson', 43.7174987792969, 0.763014294435332, -96.5025024414063, -1.68428640401641, 218, 49, 'PPL', 'P'),
(9065, 'Garrett', 35.4055595397949, 0.61794358748031, -93.3594436645508, -1.62942967977657, 218, 4, 'PPL', 'P'),
(27244, 'Garrett', 39.7986106872559, 0.694616794212018, -88.4241714477539, -1.54329293011127, 218, 18, 'PPL', 'P'),
(36057, 'Garrett', 37.8977813720703, 0.661441064143601, -86.1130599975586, -1.50295642592482, 218, 21, 'PPL', 'P'),
(78322, 'Garrett', 39.8630599975586, 0.69574164687744, -79.0583267211914, -1.3798281024022, 218, 45, 'PPL', 'P'),
(87205, 'Garrett', 35.6019401550293, 0.621371075803242, -88.1761093139648, -1.53896342912713, 218, 50, 'PPL', 'P'),
(94422, 'Garrett', 32.3633308410645, 0.5648466800888, -96.6544418334961, -1.68693824667185, 218, 51, 'PPL', 'P'),
(122665, 'Garrett', 41.3494415283203, 0.721683898530066, -85.1355590820313, -1.48589581650761, 218, 19, 'PPL', 'P'),
(207484, 'Garrett', 46.0522193908691, 0.803762856221444, -118.401672363281, -2.06649902260683, 218, 56, 'PPL', 'P'),
(54914, 'Garrett (historical)', 38.7999992370605, 0.677187736457994, -91.6486129760742, -1.59957005131849, 218, 29, 'PPL', 'P'),
(9066, 'Garrett Bridge', 33.8669395446777, 0.591089602628496, -91.6549987792969, -1.59968150461011, 218, 4, 'PPL', 'P'),
(9067, 'Garrett Grove', 34.8005599975586, 0.607384353495227, -91.0827789306641, -1.58969438420621, 218, 4, 'PPL', 'P'),
(161976, 'Garrett Hill', 40.0269393920898, 0.698601881888185, -75.3377838134766, -1.31489237870086, 218, 45, 'PPL', 'P'),
(196566, 'Garrett Mobile Home Park', 47.5055618286133, 0.82912846691904, -111.349998474121, -1.94342409546408, 218, 31, 'PPL', 'P'),
(47364, 'Garrett Park', 39.0380592346191, 0.681342667232682, -77.0933303833008, -1.34553244651638, 218, 25, 'PPL', 'P'),
(47365, 'Garrett Park Estates', 39.0369415283203, 0.681323159577697, -77.1030578613281, -1.34570222303587, 218, 25, 'PPL', 'P'),
(21352, 'Garretta', 32.4500007629395, 0.566359355587965, -82.9441680908203, -1.44764882851243, 218, 13, 'PPL', 'P'),
(78324, 'Garrettford', 39.9452781677246, 0.697176624651802, -75.2941665649414, -1.31413111410326, 218, 45, 'PPL', 'P'),
(109317, 'Garretts Bend', 38.3038902282715, 0.66852900080582, -81.9150009155273, -1.42968647275012, 218, 58, 'PPL', 'P'),
(94423, 'Garretts Bluff', 33.8713912963867, 0.591167300353299, -95.7205581665039, -1.67063890185224, 218, 51, 'PPL', 'P'),
(2670, 'Garretts Crossroads', 31.0458297729492, 0.541851948551647, -85.4388885498047, -1.49118991443858, 218, 2, 'PPL', 'P'),
(47366, 'Garretts Mill', 39.3522186279297, 0.686825783022018, -77.6847229003906, -1.35585419311126, 218, 25, 'PPL', 'P'),
(87206, 'Garretts Mill', 36.4263916015625, 0.635760468068076, -85.2983322143555, -1.48873674360045, 218, 50, 'PPL', 'P'),
(161977, 'Garretts Run', 40.7933311462402, 0.711977941358245, -79.5130615234375, -1.3877647219248, 218, 45, 'PPL', 'P'),
(36058, 'Garrettsburg', 36.6686096191406, 0.639987969982468, -87.5427780151367, -1.52790971270664, 218, 21, 'PPL', 'P'),
(54915, 'Garrettsburg', 39.6875, 0.69267754688525, -94.7008285522461, -1.65284126260335, 218, 29, 'PPL', 'P'),
(87207, 'Garrettsburg', 35.9563903808594, 0.627557399278414, -88.2763900756836, -1.54071365859553, 218, 50, 'PPL', 'P'),
(155408, 'Garrettsville', 41.2841682434082, 0.720544664794757, -81.0966720581055, -1.41540393982403, 218, 41, 'PPL', 'P'),
(115718, 'Garretville', 41.5175018310547, 0.724617104154679, -94.079719543457, -1.64200086538618, 218, 16, 'PPL', 'P'),
(47367, 'Garrian Orchards', 39.2377815246582, 0.684828478783486, -76.7975006103516, -1.34036924295299, 218, 25, 'PPL', 'P'),
(81176, 'Garris (historical)', 33.2844390869141, 0.580923051746145, -81.211669921875, -1.41741103117956, 218, 48, 'PPL', 'P'),
(27246, 'Garrison', 38.2483291625977, 0.667559277273895, -88.519172668457, -1.54495101420595, 218, 18, 'PPL', 'P'),
(36059, 'Garrison', 38.6061096191406, 0.673803724239858, -83.1733322143555, -1.45164849699557, 218, 21, 'PPL', 'P'),
(47368, 'Garrison', 39.4058303833008, 0.687761484671018, -76.7608337402344, -1.33972928534304, 218, 25, 'PPL', 'P'),
(54916, 'Garrison', 36.8388900756836, 0.642959924600942, -93.0194396972656, -1.6234954910776, 218, 29, 'PPL', 'P'),
(78325, 'Garrison', 39.7294387817383, 0.693409516710858, -80.4227828979492, -1.4036423551858, 218, 45, 'PPL', 'P'),
(94424, 'Garrison', 31.8241691589355, 0.55543653353506, -94.4908294677734, -1.64917608715313, 218, 51, 'PPL', 'P'),
(109318, 'Garrison', 37.9961090087891, 0.663157205150048, -81.5069427490234, -1.42256451420498, 218, 58, 'PPL', 'P'),
(115702, 'Garrison', 42.1441688537598, 0.735554507014552, -92.1436080932617, -1.60820934589471, 218, 16, 'PPL', 'P'),
(135515, 'Garrison', 46.2944412231445, 0.807990424714863, -93.8266677856445, -1.63758427903439, 218, 28, 'PPL', 'P'),
(141883, 'Garrison', 41.1772193908691, 0.71867805518672, -97.1669387817383, -1.6958830058251, 218, 35, 'PPL', 'P'),
(149065, 'Garrison', 41.3838882446289, 0.722285107146151, -73.9461135864258, -1.29060315113684, 218, 40, 'PPL', 'P'),
(188599, 'Garrison', 36.0480613708496, 0.629157359882306, -106.930000305176, -1.86628057448386, 218, 38, 'PPL', 'P'),
(192582, 'Garrison', 38.934440612793, 0.679534181115436, -114.032218933105, -1.99023767373771, 218, 52, 'PPL', 'P'),
(196567, 'Garrison', 46.5233306884766, 0.811985299508036, -112.810829162598, -1.96892040079217, 218, 31, 'PPL', 'P'),
(198319, 'Garrison', 47.6522216796875, 0.83168816420077, -101.415283203125, -1.77003060373703, 218, 34, 'PPL', 'P'),
(196568, 'Garrison (historical)', 47.3805618286133, 0.826946805354047, -111.558326721191, -1.94706010930036, 218, 31, 'PPL', 'P'),
(70855, 'Garrison Corner', 39.4458312988281, 0.688459632350782, -75.3905563354492, -1.31581343296386, 218, 37, 'PPL', 'P'),
(47369, 'Garrison Farms', 39.4002799987793, 0.687664612186366, -76.716667175293, -1.33895843336552, 218, 25, 'PPL', 'P'),
(47370, 'Garrison Forest', 39.4197196960449, 0.688003898909242, -76.7752838134766, -1.33998148669827, 218, 25, 'PPL', 'P'),
(113189, 'Garrison Manor', 42.9180603027344, 0.749061460852189, -73.9086074829102, -1.2899485461409, 218, 40, 'PPL', 'P'),
(47371, 'Garrison Ridge', 39.4172210693359, 0.687960289646392, -76.7874984741211, -1.34019467274354, 218, 25, 'PPL', 'P'),
(102184, 'Garrisons Corners (historical)', 38.5416717529297, 0.672679071311518, -77.4619369506836, -1.35196584476169, 218, 53, 'PPL', 'P'),
(102181, 'Garrisonville', 38.4824981689453, 0.671646297440785, -77.4269409179688, -1.35135504876568, 218, 53, 'PPL', 'P'),
(102182, 'Garrisonville Estates', 38.4727783203125, 0.671476654079347, -77.4747161865234, -1.35218888450298, 218, 53, 'PPL', 'P'),
(115703, 'Garry Owen', 42.2833290100098, 0.737983309928705, -90.831672668457, -1.58531175315832, 218, 16, 'PPL', 'P'),
(196569, 'Garryowen', 45.526668548584, 0.794590263636939, -107.418891906738, -1.87481334261647, 218, 31, 'PPL', 'P'),
(140077, 'Garske', 48.357780456543, 0.844002487923242, -98.8769378662109, -1.72572812005524, 218, 34, 'PPL', 'P'),
(9068, 'Garson', 35.9738883972168, 0.627862797276419, -90.2275009155273, -1.57476696682215, 218, 4, 'PPL', 'P'),
(109319, 'Garten', 38.0344390869141, 0.663826191215876, -81.0769424438477, -1.41505959309508, 218, 58, 'PPL', 'P'),
(2671, 'Garth', 34.7252807617188, 0.606070482971437, -86.3030624389648, -1.50627259411418, 218, 2, 'PPL', 'P'),
(130960, 'Garth', 45.9000015258789, 0.801106153297008, -86.9491729736328, -1.51754935027596, 218, 27, 'PPL', 'P'),
(94425, 'Gartman View', 31.9413890838623, 0.557482407173972, -98.5711135864258, -1.72039047944045, 218, 51, 'PPL', 'P'),
(70856, 'Garton', 39.4686088562012, 0.688857175722504, -75.1694412231445, -1.31195424622823, 218, 37, 'PPL', 'P'),
(13813, 'Garton Development', 39.1124992370605, 0.682641890370477, -75.5597229003906, -1.31876594650638, 218, 10, 'PPL', 'P'),
(109320, 'Garton Village', 39.0111083984375, 0.680872286405146, -80.3986129760742, -1.40322051046913, 218, 58, 'PPL', 'P'),
(21353, 'Gartrell (historical)', 34.5666694641113, 0.603302193597327, -84.5083312988281, -1.47494862653073, 218, 13, 'PPL', 'P'),
(27247, 'Gartside', 38.5438919067383, 0.672717820305378, -90.0361099243164, -1.57142656386686, 218, 18, 'PPL', 'P'),
(181753, 'Garvanza', 34.1163902282715, 0.595443338378557, -118.179443359375, -2.06262039479524, 218, 6, 'PPL', 'P'),
(54918, 'Garver', 36.3861083984375, 0.635057393540295, -89.8177795410156, -1.56761597982112, 218, 29, 'PPL', 'P'),
(161979, 'Garvers Ferry', 40.6655616760254, 0.709747943419467, -79.6902770996094, -1.39085771721482, 218, 45, 'PPL', 'P'),
(161978, 'Garvey Melton', 40.3486099243164, 0.704216091782181, -80.040283203125, -1.39696647612324, 218, 45, 'PPL', 'P'),
(32532, 'Garvin', 37.2419395446777, 0.649994464883304, -95.1938934326172, -1.66144686819178, 218, 20, 'PPL', 'P'),
(75910, 'Garvin', 33.9538917541504, 0.592607204975677, -94.9422225952148, -1.65705438344785, 218, 42, 'PPL', 'P'),
(135517, 'Garvin', 44.2144393920898, 0.771687544315448, -95.7555618286133, -1.6712498310063, 218, 28, 'PPL', 'P'),
(135519, 'Garvin Park', 44.4469413757324, 0.775745469447429, -95.7880630493164, -1.67181708431849, 218, 28, 'PPL', 'P'),
(36060, 'Garvin Ridge', 38.2999992370605, 0.668461090198023, -83.2091674804688, -1.45227394037757, 218, 21, 'PPL', 'P'),
(115704, 'Garwin', 42.0936088562012, 0.734672068587355, -92.6755599975586, -1.61749365808695, 218, 16, 'PPL', 'P'),
(54919, 'Garwood', 37.0663909912109, 0.646930564628195, -90.8777770996094, -1.58611642728169, 218, 29, 'PPL', 'P'),
(94426, 'Garwood', 29.4494400024414, 0.513989690911129, -96.3966674804688, -1.68243923548433, 218, 51, 'PPL', 'P'),
(109321, 'Garwood', 37.4819412231445, 0.654183284382863, -81.3213882446289, -1.41932597716139, 218, 58, 'PPL', 'P'),
(145287, 'Garwood', 40.651668548584, 0.709505462602215, -74.3233337402344, -1.29718688482568, 218, 37, 'PPL', 'P'),
(194975, 'Garwood', 47.8319396972656, 0.834824835332665, -116.776390075684, -2.03813249541391, 218, 17, 'PPL', 'P'),
(13814, 'Garwood Estates', 39.6133308410645, 0.691383050858389, -75.6588897705078, -1.32049673489882, 218, 10, 'PPL', 'P'),
(149066, 'Garwoods', 42.4594383239746, 0.74105699730082, -77.8249969482422, -1.35830243710137, 218, 40, 'PPL', 'P'),
(16182, 'Gary', 27.9555606842041, 0.48791657818044, -82.4283294677734, -1.43864574613131, 218, 12, 'PPL', 'P'),
(21354, 'Gary', 32.5574989318848, 0.568235552575926, -82.3186111450195, -1.43673080014949, 218, 13, 'PPL', 'P'),
(47372, 'Gary', 39.2599983215332, 0.685216235038202, -77.0091705322266, -1.34406358001715, 218, 25, 'PPL', 'P'),
(81178, 'Gary', 34.3522186279297, 0.599559320422302, -81.7316665649414, -1.42648668470039, 218, 48, 'PPL', 'P'),
(94428, 'Gary', 32.0286102294922, 0.559004703342575, -94.3708267211914, -1.64708164411384, 218, 51, 'PPL', 'P'),
(102188, 'Gary', 36.8650016784668, 0.643415658042482, -78.2005615234375, -1.36485727549238, 218, 53, 'PPL', 'P'),
(109322, 'Gary', 37.3636093139648, 0.652118002957506, -81.5502777099609, -1.42332085195456, 218, 58, 'PPL', 'P'),
(119753, 'Gary', 41.7705612182617, 0.729033823664521, -87.8555603027344, -1.53336879346714, 218, 18, 'PPL', 'P'),
(122666, 'Gary', 41.5933303833008, 0.725940562058394, -87.3463897705078, -1.52448209122566, 218, 19, 'PPL', 'P'),
(135522, 'Gary', 46.670280456543, 0.814550056795837, -92.2255630493164, -1.60963972971619, 218, 28, 'PPL', 'P'),
(170365, 'Gary', 44.7924995422363, 0.781776597210077, -96.4555587768555, -1.68346708250704, 218, 49, 'PPL', 'P'),
(188600, 'Gary', 32.3241691589355, 0.564163179795032, -108.817779541016, -1.89922853770005, 218, 38, 'PPL', 'P'),
(194196, 'Gary', 40.0738906860352, 0.699421336555603, -103.584442138672, -1.80788956916138, 218, 7, 'PPL', 'P'),
(145289, 'Gary Corner', 40.5305595397949, 0.707391711645019, -74.9211120605469, -1.30762008471218, 218, 37, 'PPL', 'P'),
(81179, 'Gary Creek', 34.9883308410645, 0.610661572953652, -82.0697174072266, -1.43238678493741, 218, 48, 'PPL', 'P'),
(2672, 'Gary Springs', 32.9674987792969, 0.575391399845942, -87.0880584716797, -1.51997335950015, 218, 2, 'PPL', 'P'),
(64973, 'Garysburg', 36.4508285522461, 0.636186973316652, -77.5591735839844, -1.35366294416634, 218, 33, 'PPL', 'P'),
(102185, 'Garysville', 37.2497215270996, 0.650130286098898, -77.1580581665039, -1.34666215945079, 218, 53, 'PPL', 'P'),
(122667, 'Garyton', 41.5697212219238, 0.725528504458731, -87.2102813720703, -1.52210655153331, 218, 19, 'PPL', 'P'),
(41051, 'Garyville', 30.0558300018311, 0.524573192951645, -90.6191711425781, -1.58160290186622, 218, 22, 'PPL', 'P'),
(2673, 'Garywood', 33.4597206115723, 0.583982291469347, -86.9638900756836, -1.5178062121631, 218, 2, 'PPL', 'P'),
(94429, 'Garza Addition Colonia', 26.4020004272461, 0.460801836568394, -98.9990005493164, -1.72785851576925, 218, 51, 'PPL', 'P'),
(94430, 'Garza Colonia Number 1', 26.2719993591309, 0.458532889898674, -97.9990005493164, -1.7104052232493, 218, 51, 'PPL', 'P'),
(94431, 'Garza Colonia Number 2', 26.2730007171631, 0.458550366893327, -97.9990005493164, -1.7104052232493, 218, 51, 'PPL', 'P'),
(94432, 'Garza Crossing', 29.2830600738525, 0.511085813348021, -98.6136093139648, -1.72113216980403, 218, 51, 'PPL', 'P'),
(94433, 'Garza Estates Colonia', 26.2229995727539, 0.457677682293622, -98.3659973144531, -1.71681052514511, 218, 51, 'PPL', 'P'),
(94434, 'Garza-4th-6th Streets Colonia', 27.863000869751, 0.486301104663198, -97.193000793457, -1.69633787373929, 218, 51, 'PPL', 'P'),
(94435, 'Garza-Gutierrez Colonia', 26.3880004882813, 0.460557491538379, -98.8199996948242, -1.72473436149447, 218, 51, 'PPL', 'P'),
(94436, 'Garza-Salinas Colonia', 26.3729991912842, 0.460295669513711, -98.7959976196289, -1.724315446255, 218, 51, 'PPL', 'P'),
(94437, 'Garza-Salinas Number 2 Colonia', 26.3519992828369, 0.459929151968689, -98.7600021362305, -1.72368720655386, 218, 51, 'PPL', 'P'),
(32533, 'Gas', 37.9236106872559, 0.661891870737124, -95.345832824707, -1.66409871084722, 218, 20, 'PPL', 'P'),
(41052, 'Gas Center', 32.5255584716797, 0.567678086380745, -93.8244400024414, -1.63754539688248, 218, 22, 'PPL', 'P'),
(75913, 'Gas City', 34.4497184753418, 0.601261013779835, -98.086669921875, -1.71193534245361, 218, 42, 'PPL', 'P'),
(122668, 'Gas City', 40.4872207641602, 0.706635307316409, -85.6130599975586, -1.49422977966485, 218, 19, 'PPL', 'P'),
(115705, 'Gas Light Mobile Home Villa', 42.541389465332, 0.742487314543274, -92.416389465332, -1.61297027897545, 218, 16, 'PPL', 'P'),
(193583, 'Gas Point', 40.4155616760254, 0.705384620289481, -122.533332824707, -2.13861010123318, 218, 6, 'PPL', 'P'),
(149067, 'Gas Spring', 42.4152793884277, 0.740286278481351, -77.8344421386719, -1.35846728677284, 218, 40, 'PPL', 'P'),
(29874, 'Gasburg', 39.5944404602051, 0.691053351515437, -86.4369430541992, -1.50860925165462, 218, 19, 'PPL', 'P'),
(102186, 'Gasburg', 36.5666694641113, 0.638208778637213, -77.8958282470703, -1.35953867647938, 218, 53, 'PPL', 'P'),
(113306, 'Gascola', 40.452220916748, 0.706024444741372, -79.7961120605469, -1.3927048857469, 218, 45, 'PPL', 'P'),
(36061, 'Gascon', 37.0036087036133, 0.645834806997682, -85.5711135864258, -1.49349767668118, 218, 21, 'PPL', 'P'),
(188601, 'Gascon', 35.8866691589355, 0.62634053439733, -105.445556640625, -1.84037214497708, 218, 38, 'PPL', 'P'),
(54920, 'Gasconade', 38.6694412231445, 0.674909069250295, -91.5599975585938, -1.59802342051543, 218, 29, 'PPL', 'P'),
(54923, 'Gascondy', 38.2994384765625, 0.668451303081017, -91.8591690063477, -1.60324494730669, 218, 29, 'PPL', 'P'),
(198322, 'Gascoyne', 46.1183280944824, 0.804916670763721, -103.079437255859, -1.79907557121765, 218, 34, 'PPL', 'P'),
(54924, 'Gascozark', 37.7675018310547, 0.659167257204891, -92.4038925170898, -1.61275216608217, 218, 29, 'PPL', 'P'),
(64974, 'Gashes Creek', 35.5666694641113, 0.62075548611727, -82.4952774047852, -1.43981420805958, 218, 33, 'PPL', 'P'),
(54925, 'Gashland', 39.2463912963867, 0.684978747647994, -94.5755615234375, -1.65065494050645, 218, 29, 'PPL', 'P'),
(194198, 'Gaskil', 40.3305587768555, 0.703901039825225, -105.861671447754, -1.84763471842778, 218, 7, 'PPL', 'P'),
(533, 'Gaskill', 37.185001373291, 0.649000706322541, -82.6111068725586, -1.44183581364306, 218, 21, 'PPL', 'P'),
(149071, 'Gaskill', 42.1300010681152, 0.735307232507339, -76.1819381713867, -1.32962565164145, 218, 40, 'PPL', 'P'),
(16183, 'Gaskin', 30.9708309173584, 0.54054297158636, -86.1355590820313, -1.50334910902755, 218, 12, 'PPL', 'P'),
(16184, 'Gaskins', 30.3055591583252, 0.528931788970696, -85.1266708374023, -1.48574068737411, 218, 12, 'PPL', 'P'),
(9069, 'Gaskins (historical)', 36.4452781677246, 0.636090100832001, -93.7430572509766, -1.63612499991509, 218, 4, 'PPL', 'P'),
(102187, 'Gaskins (historical)', 36.5713882446289, 0.638291136893924, -77.4058303833008, -1.35098660042886, 218, 53, 'PPL', 'P'),
(27248, 'Gaskins City', 37.7305603027344, 0.658522505904983, -88.5263900756836, -1.54507698172551, 218, 18, 'PPL', 'P'),
(21355, 'Gaskins Mobile Home Park', 33.4550018310547, 0.583899933212636, -82.0486068725586, -1.4320183366006, 218, 13, 'PPL', 'P'),
(16185, 'Gaskins Still', 30.0380592346191, 0.524263034553192, -85.1813888549805, -1.48669569694101, 218, 12, 'PPL', 'P'),
(115706, 'Gaslight Square Trailer Park', 41.4013900756836, 0.722590571723183, -91.0694427490234, -1.58946162392694, 218, 16, 'PPL', 'P'),
(119754, 'Gaslight Village', 41.3452796936035, 0.721611260811334, -88.3936080932617, -1.54275949894492, 218, 18, 'PPL', 'P'),
(141884, 'Gaslight Village', 40.836669921875, 0.712734345686854, -96.7191696166992, -1.68806795960626, 218, 35, 'PPL', 'P'),
(47378, 'Gasnell Estates', 39.4461097717285, 0.688464492619771, -77.083610534668, -1.34536280315494, 218, 25, 'PPL', 'P'),
(16186, 'Gasparilla', 26.8044395446777, 0.467825724206396, -82.2769393920898, -1.43600349085579, 218, 12, 'PPL', 'P'),
(36062, 'Gasper', 36.9500007629395, 0.64489917192771, -86.741943359375, -1.51393251119952, 218, 21, 'PPL', 'P'),
(149068, 'Gasport', 43.1991691589355, 0.753967735949415, -78.5763931274414, -1.3714167744153, 218, 40, 'PPL', 'P'),
(181757, 'Gaspur (historical)', 33.7813911437988, 0.589596501363343, -118.220283508301, -2.063333189861, 218, 6, 'PPL', 'P'),
(2674, 'Gasque', 30.253059387207, 0.528015495108141, -87.8197174072266, -1.53274321692708, 218, 2, 'PPL', 'P'),
(193582, 'Gasquet', 41.8455581665039, 0.730342767340295, -123.968330383301, -2.16365553338872, 218, 6, 'PPL', 'P'),
(21356, 'Gass', 34.8636093139648, 0.608484771657648, -85.5491714477539, -1.49311471411643, 218, 13, 'PPL', 'P'),
(87208, 'Gassaway', 35.9397201538086, 0.627266448929323, -85.9955596923828, -1.5009056587274, 218, 50, 'PPL', 'P'),
(109323, 'Gassaway', 38.6730613708496, 0.674972252747157, -80.7750015258789, -1.40978972993003, 218, 58, 'PPL', 'P'),
(9070, 'Gassett', 34.8738899230957, 0.608664202136092, -90.5622177124023, -1.58060887698935, 218, 4, 'PPL', 'P'),
(172037, 'Gassetts', 43.3244400024414, 0.756154124625343, -72.6072235107422, -1.26723511099389, 218, 55, 'PPL', 'P'),
(41053, 'Gassoway', 32.9897193908691, 0.575779222679685, -91.2247161865234, -1.5921716566522, 218, 22, 'PPL', 'P'),
(9071, 'Gassville', 36.2830581665039, 0.63325882769811, -92.4938888549805, -1.6143228984931, 218, 4, 'PPL', 'P'),
(155409, 'Gast Corner', 40.4500007629395, 0.705985695747512, -83.2216720581055, -1.45249218642891, 218, 41, 'PPL', 'P'),
(2675, 'Gaston', 32.350830078125, 0.564628500616496, -88.2236099243164, -1.53979247117447, 218, 2, 'PPL', 'P'),
(9072, 'Gaston', 34.5466690063477, 0.602953119757444, -93.7588882446289, -1.63640130287818, 218, 4, 'PPL', 'P'),
(60010, 'Gaston', 34.7041702270508, 0.605702034634624, -88.5980606079102, -1.54632786848952, 218, 30, 'PPL', 'P'),
(64986, 'Gaston', 36.5002784729004, 0.63705003724692, -77.6452789306641, -1.35516576596947, 218, 33, 'PPL', 'P'),
(81180, 'Gaston', 33.8169403076172, 0.590216951318304, -81.1011123657227, -1.41548143781175, 218, 48, 'PPL', 'P'),
(109325, 'Gaston', 39.4625015258789, 0.688750582699873, -80.1786117553711, -1.39938076480946, 218, 58, 'PPL', 'P'),
(122669, 'Gaston', 40.3138885498047, 0.703610089476134, -85.5005569458008, -1.49226623099313, 218, 19, 'PPL', 'P'),
(181754, 'Gaston', 39.3941688537598, 0.687557952584708, -120.740562438965, -2.10732035526973, 218, 6, 'PPL', 'P'),
(200871, 'Gaston', 45.4363899230957, 0.793014604377993, -123.138328552246, -2.14916926863924, 218, 43, 'PPL', 'P'),
(109326, 'Gaston Junction', 39.4686088562012, 0.688857175722504, -80.147216796875, -1.39883281941517, 218, 58, 'PPL', 'P'),
(109327, 'Gaston Manor', 39.0661087036133, 0.681832222820065, -80.4491729736328, -1.40410294889633, 218, 58, 'PPL', 'P'),
(81181, 'Gaston Mill', 34.4511108398438, 0.601285315124782, -80.579719543457, -1.40638141636695, 218, 48, 'PPL', 'P'),
(81182, 'Gaston Shoals (historical)', 35.1388893127441, 0.613289314001233, -81.5955581665039, -1.42411114500804, 218, 48, 'PPL', 'P'),
(2676, 'Gastonburg', 32.207218170166, 0.56212199997754, -87.4375, -1.52607226471254, 218, 2, 'PPL', 'P'),
(64977, 'Gastonia', 35.2619400024414, 0.6154369536833, -81.1875, -1.4169891864629, 218, 33, 'PPL', 'P'),
(94438, 'Gastonia', 32.6116714477539, 0.569181041341932, -96.4022216796875, -1.68253617454801, 218, 51, 'PPL', 'P'),
(161981, 'Gastonville', 40.2572212219238, 0.702621058026306, -79.9961090087891, -1.39619549098767, 218, 45, 'PPL', 'P'),
(161982, 'Gastown', 40.709171295166, 0.710509074859011, -79.3158264160156, -1.38432231989977, 218, 45, 'PPL', 'P'),
(72639, 'Gasville', 39.5288887023926, 0.689909257511139, -81.3180618286133, -1.41926792024962, 218, 41, 'PPL', 'P'),
(29875, 'Gatchel', 38.0466690063477, 0.664039643577246, -86.6505584716797, -1.51233754402268, 218, 19, 'PPL', 'P'),
(78326, 'Gatchellville', 39.7688903808594, 0.694098077010698, -76.4672164916992, -1.33460469761546, 218, 45, 'PPL', 'P'),
(192953, 'Gate', 36.853328704834, 0.643211926219091, -100.055000305176, -1.74628918840925, 218, 42, 'PPL', 'P'),
(9074, 'Gate (historical)', 34.7163887023926, 0.605915287258912, -94.1672210693359, -1.64352805511329, 218, 4, 'PPL', 'P'),
(2677, 'Gate City', 33.547779083252, 0.585519201734432, -86.7266693115234, -1.51366592877441, 218, 2, 'PPL', 'P'),
(102189, 'Gate City', 36.6377792358398, 0.639449878284217, -82.5811080932617, -1.44131223617275, 218, 53, 'PPL', 'P'),
(94439, 'Gate City Acres Colonia', 26.2999992370605, 0.459021579958703, -98.1360015869141, -1.71279634243403, 218, 51, 'PPL', 'P'),
(181755, 'Gate Place', 39.9291687011719, 0.696895461419717, -120.576667785645, -2.10445985394288, 218, 6, 'PPL', 'P'),
(181756, 'Gateley', 38.0072212219238, 0.663351149856433, -122.308891296387, -2.13469285758578, 218, 6, 'PPL', 'P'),
(865, 'Gates', 39.889720916748, 0.696206967698904, -79.9113922119141, -1.39471690395045, 218, 45, 'PPL', 'P'),
(36063, 'Gates', 38.2338905334473, 0.667307275655746, -83.3666687011719, -1.45502285525475, 218, 21, 'PPL', 'P'),
(64979, 'Gates', 36.5033302307129, 0.637103300468721, -76.7694396972656, -1.33987948762852, 218, 33, 'PPL', 'P'),
(87209, 'Gates', 35.8383293151855, 0.625496844963992, -89.4061126708984, -1.5604310375162, 218, 50, 'PPL', 'P'),
(109328, 'Gates', 37.565559387207, 0.655642696660226, -80.4899978637695, -1.40481547764598, 218, 58, 'PPL', 'P'),
(141885, 'Gates', 41.6402816772461, 0.726760016725811, -99.6355590820313, -1.73896855804678, 218, 35, 'PPL', 'P'),
(149069, 'Gates', 43.0913887023926, 0.752086612113437, -73.6386108398438, -1.28523621575006, 218, 40, 'PPL', 'P'),
(194197, 'Gates', 40.5313911437988, 0.70740622587296, -104.754722595215, -1.8283148162998, 218, 7, 'PPL', 'P'),
(200873, 'Gates', 44.7563896179199, 0.78114636013811, -122.415557861328, -2.1365545403458, 218, 43, 'PPL', 'P'),
(21358, 'Gates (historical)', 34.6452789306641, 0.604674187611908, -83.892219543457, -1.46419544783926, 218, 13, 'PPL', 'P'),
(149070, 'Gates Center', 43.1533317565918, 0.753167722357955, -77.6911087036133, -1.35596564640288, 218, 40, 'PPL', 'P'),
(122671, 'Gates Corner', 41.420280456543, 0.722920271066135, -87.123893737793, -1.52059880288216, 218, 19, 'PPL', 'P'),
(135525, 'Gates Corner', 48.2191696166992, 0.841583272389014, -94.1025009155273, -1.64239847533693, 218, 28, 'PPL', 'P'),
(143852, 'Gates Corner', 43.2216682434082, 0.754360419052147, -70.8866729736328, -1.23720583917437, 218, 36, 'PPL', 'P'),
(124907, 'Gates Crossing', 42.4958305358887, 0.741692161220804, -71.7375030517578, -1.25205562541265, 218, 23, 'PPL', 'P'),
(127553, 'Gates Hill (historical)', 43.8169403076172, 0.764749876517737, -70.432502746582, -1.22927907334781, 218, 26, 'PPL', 'P'),
(155410, 'Gates Mills', 41.5175018310547, 0.724617104154679, -81.4036102294922, -1.42076102151478, 218, 41, 'PPL', 'P'),
(161983, 'Gatesburg', 40.7447204589844, 0.711129524813973, -78.0052795410156, -1.36144896192929, 218, 45, 'PPL', 'P'),
(29876, 'Gatesville', 39.2616691589355, 0.685245396652138, -86.1463928222656, -1.50353819346495, 218, 19, 'PPL', 'P'),
(36064, 'Gatesville', 37.5169410705566, 0.6547941469579, -87.6080627441406, -1.52904914617903, 218, 21, 'PPL', 'P'),
(60011, 'Gatesville', 31.9977798461914, 0.558466611644325, -90.2433319091797, -1.57504326978525, 218, 30, 'PPL', 'P'),
(64981, 'Gatesville', 36.4033317565918, 0.635357997848338, -76.7533264160156, -1.33959825781741, 218, 33, 'PPL', 'P'),
(94440, 'Gatesville', 31.4349994659424, 0.548644241043354, -97.7436065673828, -1.70594775737478, 218, 51, 'PPL', 'P'),
(115707, 'Gatesville', 42.4416694641113, 0.74074687219188, -91.8322219848633, -1.60277463305819, 218, 16, 'PPL', 'P'),
(2678, 'Gatesville (historical)', 34.7297210693359, 0.606147980959158, -87.845832824707, -1.53319901694765, 218, 2, 'PPL', 'P'),
(2679, 'Gateswood', 30.7208309173584, 0.536179648456374, -87.5808334350586, -1.52857390508251, 218, 2, 'PPL', 'P'),
(186751, 'Gateview', 38.2936096191406, 0.668349570327376, -107.218063354492, -1.87130822314776, 218, 7, 'PPL', 'P'),
(47374, 'Gatewater', 39.1680603027344, 0.683611613902402, -76.5897216796875, -1.33674281649663, 218, 25, 'PPL', 'P'),
(9075, 'Gateway', 36.4902801513672, 0.636875533616492, -93.9316711425781, -1.63941693333853, 218, 4, 'PPL', 'P'),
(13110, 'Gateway', 38.9208297729492, 0.679296627146201, -76.9638900756836, -1.34327328696367, 218, 9, 'PPL', 'P'),
(16187, 'Gateway', 26.577220916748, 0.463860011027159, -81.7505569458008, -1.42681638404334, 218, 12, 'PPL', 'P'),
(181758, 'Gateway', 39.3261108398438, 0.686370116159506, -120.202499389648, -2.09792938347584, 218, 6, 'PPL', 'P'),
(186752, 'Gateway', 39.5491714477539, 0.690263258199038, -104.905563354492, -1.8309474841954, 218, 7, 'PPL', 'P'),
(200872, 'Gateway', 44.7755584716797, 0.781480919750051, -121.081672668457, -2.1132738518866, 218, 43, 'PPL', 'P'),
(211845, 'Gateway', 61.5727806091309, 1.07464775123745, -149.240829467773, -2.60474385262002, 218, 1, 'PPL', 'P'),
(196570, 'Gateway (historical)', 48.9991683959961, 0.855196819249281, -115.172218322754, -2.0101344165578, 218, 31, 'PPL', 'P'),
(204063, 'Gateway Condominium', 40.7702789306641, 0.711575604296561, -111.887222290039, -1.95280041987197, 218, 52, 'PPL', 'P'),
(54927, 'Gateway Drive', 37.0519409179688, 0.646678363272965, -94.4783325195313, -1.64895797425985, 218, 29, 'PPL', 'P'),
(13815, 'Gateway Farms', 39.7769393920898, 0.6942385587582, -75.6900024414063, -1.32103975344509, 218, 10, 'PPL', 'P'),
(143851, 'Gateway Trailer Park', 44.396671295166, 0.774868091026302, -71.1991729736328, -1.24265999308685, 218, 36, 'PPL', 'P'),
(21360, 'Gatewood', 32.0230598449707, 0.558907830857924, -84.1758270263672, -1.46914533219934, 218, 13, 'PPL', 'P'),
(36065, 'Gatewood', 37.8330612182617, 0.660311484367244, -86.8661117553711, -1.51609965853658, 218, 21, 'PPL', 'P'),
(54928, 'Gatewood', 36.5769386291504, 0.638388009378576, -91.0897216796875, -1.58981555803581, 218, 29, 'PPL', 'P'),
(60013, 'Gatewood', 33.9747200012207, 0.592970726464473, -89.7644424438477, -1.56668507186209, 218, 30, 'PPL', 'P'),
(64984, 'Gatewood', 35.0280609130859, 0.611354993522481, -80.7230606079102, -1.40888318989497, 218, 33, 'PPL', 'P'),
(81183, 'Gatewood', 34.857780456543, 0.608383038904007, -81.966667175293, -1.43058821909522, 218, 48, 'PPL', 'P'),
(102190, 'Gatewood', 38.0819396972656, 0.664655233263218, -77.6691665649414, -1.35558268383812, 218, 53, 'PPL', 'P'),
(109329, 'Gatewood', 38.0105590820313, 0.663409406505279, -81.0611114501953, -1.41478329013198, 218, 58, 'PPL', 'P'),
(204064, 'Gatewood Condo', 40.586109161377, 0.708361235439862, -111.869720458984, -1.95249495529494, 218, 52, 'PPL', 'P'),
(178236, 'Gatewood Housing', 31.5550003051758, 0.550738650793133, -110.334716796875, -1.92570408736096, 218, 5, 'PPL', 'P'),
(102191, 'Gatewood Park', 36.833610534668, 0.642867779227225, -76.0477828979492, -1.32728420041105, 218, 53, 'PPL', 'P'),
(72640, 'Gath', 39.0633316040039, 0.681783753288226, -83.8041687011719, -1.46265867073223, 218, 41, 'PPL', 'P'),
(87210, 'Gath', 35.7799987792969, 0.624478785058282, -85.7908325195313, -1.49733249549284, 218, 50, 'PPL', 'P'),
(109330, 'Gath (historical)', 39.4383316040039, 0.688328737983205, -80.0811080932617, -1.3976790048729, 218, 58, 'PPL', 'P'),
(64985, 'Gather (historical)', 35.9113883972168, 0.626771966493922, -80.7483291625977, -1.40932420937148, 218, 33, 'PPL', 'P'),
(36066, 'Gatliff', 36.6816711425781, 0.640215936571779, -84.0263900756836, -1.46653716538577, 218, 21, 'PPL', 'P'),
(87211, 'Gatlinburg', 35.714168548584, 0.623329830784995, -83.5102767944336, -1.45752928931468, 218, 50, 'PPL', 'P'),
(181759, 'Gato', 34.4575004577637, 0.601396834995429, -120.376670837402, -2.10096924870211, 218, 6, 'PPL', 'P'),
(186753, 'Gato', 37.0449981689453, 0.646557189443366, -107.196670532227, -1.87093484796294, 218, 7, 'PPL', 'P'),
(81186, 'Gator Field', 32.2430610656738, 0.5627475765176, -80.692497253418, -1.40834975872862, 218, 48, 'PPL', 'P'),
(87212, 'Gattistown', 35.2080612182617, 0.614496591502393, -86.3958282470703, -1.5078916628989, 218, 50, 'PPL', 'P'),
(60014, 'Gattman', 33.8852806091309, 0.591409714591523, -88.2352828979492, -1.53999620299786, 218, 30, 'PPL', 'P'),
(155412, 'Gatton Rock', 40.6019401550293, 0.708637538402958, -82.4741668701172, -1.43944575972277, 218, 41, 'PPL', 'P'),
(47376, 'Gatts Corner', 38.8936080932617, 0.678821519207731, -76.5102767944336, -1.33535624167508, 218, 25, 'PPL', 'P'),
(36067, 'Gatun', 36.8733291625977, 0.643561000058973, -83.3027801513672, -1.45390778970634, 218, 21, 'PPL', 'P'),
(135526, 'Gatzke', 48.4244384765625, 0.845165889845443, -95.7838897705078, -1.67174424686268, 218, 28, 'PPL', 'P'),
(109331, 'Gatzmer', 39.185001373291, 0.683907291362428, -79.3836135864258, -1.38550542921403, 218, 58, 'PPL', 'P'),
(161984, 'Gauff Hill', 40.5913887023926, 0.708453380813579, -75.4155578613281, -1.31624979190847, 218, 45, 'PPL', 'P'),
(196571, 'Gauglersville (historical)', 46.4916687011719, 0.811432693581845, -110.275001525879, -1.92466185926836, 218, 31, 'PPL', 'P'),
(2681, 'Gauldinville', 33.6222190856934, 0.586818424872227, -85.9236068725586, -1.49964984511538, 218, 2, 'PPL', 'P'),
(9076, 'Gaulett', 35.6502799987793, 0.622214765236579, -90.7099990844727, -1.58318814850509, 218, 4, 'PPL', 'P'),
(163, 'Gauley', 38.149169921875, 0.665828622039507, -81.179443359375, -1.41684857155734, 218, 58, 'PPL', 'P'),
(109332, 'Gauley Bridge', 38.1683311462402, 0.666163048493393, -81.1949996948242, -1.41712008083047, 218, 58, 'PPL', 'P'),
(109333, 'Gauley Mills', 38.3613891601563, 0.669532546483589, -80.583610534668, -1.40644932697474, 218, 58, 'PPL', 'P'),
(54930, 'Gaunt Ford (historical)', 37.5997200012207, 0.656238911849268, -92.9872207641602, -1.62293316461343, 218, 29, 'PPL', 'P'),
(36068, 'Gausdale', 36.7577781677246, 0.641544254744483, -83.9752807617188, -1.46564513957864, 218, 21, 'PPL', 'P'),
(87213, 'Gause', 36.4366683959961, 0.635939831967493, -87.0508270263672, -1.51932354819417, 218, 50, 'PPL', 'P'),
(94441, 'Gause', 30.7849998474121, 0.537299607563293, -96.7211074829102, -1.68810178175211, 218, 51, 'PPL', 'P'),
(41054, 'Gauthier (historical)', 30.1949996948242, 0.527002162313366, -91.8294372558594, -1.60272603036829, 218, 22, 'PPL', 'P'),
(60015, 'Gautier', 30.3855590820313, 0.530328051040711, -88.6116714477539, -1.54656542245876, 218, 30, 'PPL', 'P'),
(155413, 'Gavers', 40.7069396972656, 0.710470126128069, -80.8058319091797, -1.41032782162828, 218, 41, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(181760, 'Gavilan Hills', 33.7844390869141, 0.589649698006117, -117.36833190918, -2.04846382938871, 218, 6, 'PPL', 'P'),
(9077, 'Gavin', 35.1908302307129, 0.614195854036296, -90.2197189331055, -1.57463114560656, 218, 4, 'PPL', 'P'),
(181761, 'Gaviota', 34.4716682434082, 0.601644109502643, -120.213890075684, -2.09812818845121, 218, 6, 'PPL', 'P'),
(21361, 'Gay', 33.0936088562012, 0.577592435907865, -84.5738906860352, -1.47609285369308, 218, 13, 'PPL', 'P'),
(64987, 'Gay', 35.291389465332, 0.615950943773685, -83.2733306884766, -1.45339379961595, 218, 33, 'PPL', 'P'),
(75914, 'Gay', 33.9533309936523, 0.592597417858671, -95.6211090087891, -1.66890318661178, 218, 42, 'PPL', 'P'),
(109334, 'Gay', 38.7705612182617, 0.676673946104691, -81.5533294677734, -1.42337411517636, 218, 58, 'PPL', 'P'),
(130961, 'Gay', 47.2275009155273, 0.824275388464588, -88.1636123657227, -1.53874531623385, 218, 27, 'PPL', 'P'),
(194976, 'Gay', 43.0483283996582, 0.751335068053817, -112.117500305176, -1.95681952943106, 218, 17, 'PPL', 'P'),
(102199, 'Gay Farms', 37.3499984741211, 0.651880448988271, -77.4211120605469, -1.35125331601203, 218, 53, 'PPL', 'P'),
(124908, 'Gay Head', 41.3436088562012, 0.721582099197397, -70.8152770996094, -1.23595974610032, 218, 23, 'PPL', 'P'),
(94443, 'Gay Hill', 30.2716693878174, 0.52834030089259, -96.4938888549805, -1.68413606857287, 218, 51, 'PPL', 'P'),
(21362, 'Gay Lan', 34.1630592346191, 0.596257866197958, -83.9763870239258, -1.46566444749655, 218, 13, 'PPL', 'P'),
(81187, 'Gay Oaks', 32.4180603027344, 0.565801889392785, -80.6486129760742, -1.40758383359912, 218, 48, 'PPL', 'P'),
(36069, 'Gaybourn', 38.042781829834, 0.663971799548476, -84.6666717529297, -1.4777121887939, 218, 21, 'PPL', 'P'),
(47377, 'Gayfields', 39.1066703796387, 0.682540157616836, -77.0374984741211, -1.34455799587352, 218, 25, 'PPL', 'P'),
(149073, 'Gayhead', 42.3413887023926, 0.73899664272348, -73.9705581665039, -1.29102978954347, 218, 40, 'PPL', 'P'),
(87214, 'Gaylan Heights', 35.0727806091309, 0.612135499458956, -85.2300033569336, -1.48754418006431, 218, 50, 'PPL', 'P'),
(81196, 'Gayle Mill', 34.7019386291504, 0.605663085903682, -81.2402801513672, -1.41791037388395, 218, 48, 'PPL', 'P'),
(9078, 'Gayler', 35.9272193908691, 0.627048269457018, -92.1699981689453, -1.60866993960524, 218, 4, 'PPL', 'P'),
(109335, 'Gaylersville', 38.4049987792969, 0.670293677923134, -82.4055633544922, -1.43824840249667, 218, 58, 'PPL', 'P'),
(41055, 'Gayles', 32.3477783203125, 0.564575237394694, -93.6258316040039, -1.63407902640763, 218, 22, 'PPL', 'P'),
(102192, 'Gayles', 38.2969398498535, 0.668407693818167, -77.3150024414063, -1.34940135378999, 218, 53, 'PPL', 'P'),
(2682, 'Gaylesville', 34.2683296203613, 0.598095181034004, -85.5569381713867, -1.49325026901591, 218, 2, 'PPL', 'P'),
(54931, 'Gaylor', 37.0966682434082, 0.647459002367494, -90.7138900756836, -1.58325605911289, 218, 29, 'PPL', 'P'),
(32534, 'Gaylord', 39.6438903808594, 0.691916415445705, -98.8472213745117, -1.72520946943294, 218, 20, 'PPL', 'P'),
(64989, 'Gaylord', 35.6055603027344, 0.621434259300104, -76.7494430541992, -1.33953048036767, 218, 33, 'PPL', 'P'),
(102193, 'Gaylord', 39.1875, 0.683950900625278, -77.9308319091797, -1.36014960563344, 218, 53, 'PPL', 'P'),
(130962, 'Gaylord', 45.0275001525879, 0.785878131604908, -84.6747207641602, -1.4778526705414, 218, 27, 'PPL', 'P'),
(135529, 'Gaylord', 44.5530586242676, 0.777597564827524, -94.2202835083008, -1.64445416938236, 218, 28, 'PPL', 'P'),
(192964, 'Gaylord', 36.4416694641113, 0.63602711707222, -100.440277099609, -1.75301353700364, 218, 51, 'PPL', 'P'),
(198326, 'Gaylord', 46.7486114501953, 0.815917190541429, -103.188888549805, -1.80098585666757, 218, 34, 'PPL', 'P'),
(200876, 'Gaylord', 42.9555587768555, 0.749715932690076, -124.105560302734, -2.16605064731509, 218, 43, 'PPL', 'P'),
(135527, 'Gaylord Mobile Home Park', 44.5608291625977, 0.777733186306037, -94.2069396972656, -1.64422127594504, 218, 28, 'PPL', 'P'),
(81188, 'Gaylords Crossroads', 34.7416687011719, 0.606356506472511, -82.1913909912109, -1.43451038959064, 218, 48, 'PPL', 'P'),
(113462, 'Gaylordsville', 41.6463890075684, 0.726866609748442, -73.4847183227539, -1.28255028463266, 218, 8, 'PPL', 'P'),
(161987, 'Gayly', 40.4441719055176, 0.705883962993871, -80.1469421386719, -1.39882802572521, 218, 45, 'PPL', 'P'),
(102194, 'Gaymont', 37.2519416809082, 0.650169035092759, -79.9661102294922, -1.39567191351736, 218, 53, 'PPL', 'P'),
(109336, 'Gaymont', 38.1147193908691, 0.665227346844394, -81.0966720581055, -1.41540393982403, 218, 58, 'PPL', 'P'),
(139167, 'Gaynor', 40.4877815246582, 0.706645094433415, -94.7077789306641, -1.652962569591, 218, 29, 'PPL', 'P'),
(29877, 'Gaynorsville', 39.2427787780762, 0.684915697309186, -85.5199966430664, -1.49260551771601, 218, 19, 'PPL', 'P'),
(2683, 'Gayosa', 33.7155609130859, 0.588447547090055, -87.3255615234375, -1.52411856973686, 218, 2, 'PPL', 'P'),
(54933, 'Gayoso', 36.2561111450195, 0.632788513449602, -89.7050018310547, -1.56564763745945, 218, 29, 'PPL', 'P'),
(112303, 'Gays', 39.4580612182617, 0.688673084712152, -88.4938888549805, -1.54450972841332, 218, 18, 'PPL', 'P'),
(102195, 'Gays (historical)', 37.8622207641602, 0.660820414451558, -77.8502807617188, -1.35874372289399, 218, 53, 'PPL', 'P'),
(36070, 'Gays Creek', 37.3280601501465, 0.651497553002545, -83.4277801513672, -1.45608945127133, 218, 21, 'PPL', 'P'),
(174225, 'Gays Mills', 43.3175010681152, 0.756033017374771, -90.8447189331055, -1.58553945343152, 218, 57, 'PPL', 'P'),
(72641, 'Gaysport', 39.8027801513672, 0.694689565088804, -81.8908309936523, -1.42926462803345, 218, 41, 'PPL', 'P'),
(161985, 'Gaysport', 40.4275016784668, 0.70559301264478, -78.3977813720703, -1.3682994112013, 218, 45, 'PPL', 'P'),
(172038, 'Gaysville', 43.7783317565918, 0.76407603018292, -72.6994400024414, -1.26884459239868, 218, 55, 'PPL', 'P'),
(41060, 'Gaytine', 30.4477806091309, 0.531414021554218, -93.2011108398438, -1.62666625067145, 218, 22, 'PPL', 'P'),
(102196, 'Gayton', 37.6097183227539, 0.656413415479695, -77.6116714477539, -1.35457920473938, 218, 53, 'PPL', 'P'),
(102197, 'Gayton (historical)', 37.6369400024414, 0.656888523418165, -77.6344375610352, -1.35497654837402, 218, 53, 'PPL', 'P'),
(149074, 'Gayville', 43.3058280944824, 0.75582928555138, -76.0138931274414, -1.32669271233294, 218, 40, 'PPL', 'P'),
(202154, 'Gayville', 44.3708305358887, 0.774417084695697, -103.759719848633, -1.81094874230556, 218, 49, 'PPL', 'P'),
(194977, 'Gayway Corner', 44.0258293151855, 0.768395677471028, -116.922500610352, -2.04068260531571, 218, 17, 'PPL', 'P'),
(115709, 'Gaza', 43.0202789306641, 0.750845512466433, -95.579719543457, -1.6681808041661, 218, 16, 'PPL', 'P'),
(143853, 'Gaza', 43.5219383239746, 0.759601120603259, -71.5950012207031, -1.24956849927063, 218, 36, 'PPL', 'P'),
(81189, 'Gaza (historical)', 32.5547218322754, 0.568187083044087, -80.6655578613281, -1.40787957763817, 218, 48, 'PPL', 'P'),
(193584, 'Gazelle', 41.5208282470703, 0.724675161066443, -122.519172668457, -2.13836295988402, 218, 6, 'PPL', 'P'),
(54932, 'Gazette', 39.2044410705566, 0.684246578085304, -91.3958282470703, -1.59515812549861, 218, 29, 'PPL', 'P'),
(109337, 'Gazil (historical)', 38.3847198486328, 0.669939743814262, -81.320556640625, -1.41931146293345, 218, 58, 'PPL', 'P'),
(200874, 'Gazley', 42.9536094665527, 0.74968191080715, -123.241668701172, -2.15097289448749, 218, 43, 'PPL', 'P'),
(161986, 'Gazzam', 40.8669395446777, 0.713262650268099, -78.5744400024414, -1.37138268595334, 218, 45, 'PPL', 'P'),
(169390, 'Gazzaville', 41.9397201538086, 0.731986204048983, -71.647216796875, -1.25047983299565, 218, 47, 'PPL', 'P'),
(200875, 'Gearhart', 46.0244407653809, 0.803278027744995, -123.910003662109, -2.16263754006204, 218, 43, 'PPL', 'P'),
(161988, 'Gearhartville', 40.8891716003418, 0.713650672838923, -78.2516708374023, -1.3657493012995, 218, 45, 'PPL', 'P'),
(196572, 'Gearing', 46.7144393920898, 0.815320775615306, -112.133056640625, -1.9570910387042, 218, 31, 'PPL', 'P'),
(119755, 'Gears Ferry', 42.3891716003418, 0.739830611618838, -90.4649963378906, -1.5789120439008, 218, 18, 'PPL', 'P'),
(75915, 'Geary', 35.6311111450195, 0.621880205624638, -98.3169403076172, -1.71595431885465, 218, 42, 'PPL', 'P'),
(196573, 'Geary', 47.0313911437988, 0.820852627252591, -113.020278930664, -1.97257598886246, 218, 31, 'PPL', 'P'),
(41056, 'Geary (historical)', 30.1116695404053, 0.52554777675256, -91.0316696166992, -1.58880235839909, 218, 22, 'PPL', 'P'),
(155415, 'Geauga Lake', 41.3444404602051, 0.721596613425338, -81.3819427490234, -1.42038285263998, 218, 41, 'PPL', 'P'),
(172039, 'Gebbie Corner', 44.6319389343262, 0.778974285953041, -72.2852783203125, -1.26161610740993, 218, 55, 'PPL', 'P'),
(78327, 'Gebhart', 39.9441719055176, 0.697157316733899, -79.1774978637695, -1.38190803121356, 218, 45, 'PPL', 'P'),
(41057, 'Gecko', 30.295560836792, 0.528757285340269, -91.9349975585938, -1.60456840521041, 218, 22, 'PPL', 'P'),
(41058, 'Ged', 30.139440536499, 0.526032472070954, -93.5924987792969, -1.6334972588675, 218, 22, 'PPL', 'P'),
(36071, 'Geddes', 36.6566696166992, 0.639779577627169, -86.5497207641602, -1.5105775940163, 218, 21, 'PPL', 'P'),
(130964, 'Geddes', 42.2669410705566, 0.73769728642763, -83.6677780151367, -1.46027820419186, 218, 27, 'PPL', 'P'),
(170372, 'Geddes', 43.2536087036133, 0.754917885247328, -98.6949996948242, -1.72255269992948, 218, 49, 'PPL', 'P'),
(41059, 'Geddie', 33.0036087036133, 0.576021636917909, -91.8708267211914, -1.60344841281398, 218, 22, 'PPL', 'P'),
(81190, 'Geddie Gardens', 33.9244384765625, 0.592093148306265, -80.283332824707, -1.40120849226558, 218, 48, 'PPL', 'P'),
(170374, 'Gederos Estates', 45.5133285522461, 0.794357436778638, -98.5127792358398, -1.71937235295571, 218, 49, 'PPL', 'P'),
(196574, 'Geduhn (historical)', 48.6349983215332, 0.84884085241267, -113.862503051758, -1.98727557281527, 218, 31, 'PPL', 'P'),
(36072, 'Gee', 38.0449981689453, 0.66401048196331, -85.0630569458008, -1.48463041551566, 218, 21, 'PPL', 'P'),
(149076, 'Gee Brook', 42.5091705322266, 0.741924988079104, -75.9186096191406, -1.32502970139024, 218, 40, 'PPL', 'P'),
(143855, 'Gee Mill', 43.1522216796875, 0.753148347861025, -72.2038879394531, -1.26019557728448, 218, 36, 'PPL', 'P'),
(155416, 'Geeburg', 41.0488891601563, 0.716438270130937, -80.8386077880859, -1.41089986863043, 218, 41, 'PPL', 'P'),
(87215, 'Geedville', 35.7075004577637, 0.623213450645358, -86.0152816772461, -1.50124987229829, 218, 50, 'PPL', 'P'),
(130965, 'Geels', 44.4219398498535, 0.775309110502819, -84.4836120605469, -1.47451719443413, 218, 27, 'PPL', 'P'),
(102198, 'Geer', 38.2980613708496, 0.668427268052179, -78.498893737793, -1.37006415489765, 218, 53, 'PPL', 'P'),
(149077, 'Geers Corners', 44.1811103820801, 0.771105843354347, -75.3383331298828, -1.31490196608078, 218, 40, 'PPL', 'P'),
(149078, 'Gees Corner', 43.1358299255371, 0.752862257780923, -75.8277816772461, -1.32344445475137, 218, 40, 'PPL', 'P'),
(161989, 'Geeseytown', 40.4486083984375, 0.705961394402565, -78.345832824707, -1.36739273800819, 218, 45, 'PPL', 'P'),
(60020, 'Geeslin Corner', 33.8238906860352, 0.590338258305957, -89.8388900756836, -1.56798442815794, 218, 30, 'PPL', 'P'),
(122672, 'Geetingsville', 40.416389465332, 0.705399067938395, -86.4686126708984, -1.50916199073887, 218, 19, 'PPL', 'P'),
(60016, 'Geeville', 34.5761108398438, 0.603466976689775, -88.6908264160156, -1.54794693727423, 218, 30, 'PPL', 'P'),
(27249, 'Geff', 38.4425010681152, 0.670948216340048, -88.404167175293, -1.54294378969236, 218, 18, 'PPL', 'P'),
(81191, 'Gehlkin (historical)', 32.9152793884277, 0.57447999954189, -79.8861083984375, -1.39427561815783, 218, 48, 'PPL', 'P'),
(122673, 'Gehring and Gumz Ditch', 40.2344398498535, 0.702223448075557, -85.5783309936523, -1.49362364420074, 218, 19, 'PPL', 'P'),
(209918, 'Geib', 47.434440612793, 0.827887167534954, -117.659439086914, -2.05354460811636, 218, 56, 'PPL', 'P'),
(47379, 'Geices (historical)', 39.707218170166, 0.693021693877115, -79.3888931274414, -1.38559757458775, 218, 25, 'PPL', 'P'),
(2685, 'Geiger', 32.8680610656738, 0.573655884342565, -88.3050003051758, -1.54121300129991, 218, 2, 'PPL', 'P'),
(161990, 'Geiger', 40.0341682434082, 0.698728049144828, -79.0405578613281, -1.37951797729326, 218, 45, 'PPL', 'P'),
(207485, 'Geiger Heights', 47.5927810668945, 0.830650729798129, -117.489723205566, -2.05058250719392, 218, 56, 'PPL', 'P'),
(16188, 'Geigers Landing', 28.7891693115234, 0.502465793400193, -81.148063659668, -1.41630089247917, 218, 12, 'PPL', 'P'),
(161991, 'Geigertown', 40.2024993896484, 0.701665981880376, -75.836669921875, -1.32359958388487, 218, 45, 'PPL', 'P'),
(155417, 'Geisingers Corners (historical)', 41.0747184753418, 0.71688907672446, -82.0247192382813, -1.43160141873194, 218, 41, 'PPL', 'P'),
(41061, 'Geismar', 30.2041702270508, 0.527162218294879, -91.0224990844727, -1.58864230241757, 218, 22, 'PPL', 'P'),
(161992, 'Geistown', 40.290828704834, 0.703207619256396, -78.8691711425781, -1.37652671475689, 218, 45, 'PPL', 'P'),
(41062, 'Gekop', 30.4724998474121, 0.531845453650811, -93.3550033569336, -1.62935218178885, 218, 22, 'PPL', 'P'),
(64990, 'Gela', 36.4144401550293, 0.635551875975696, -78.5902786254883, -1.37165912207449, 218, 33, 'PPL', 'P'),
(161994, 'Gelatt', 41.8066711425781, 0.729664060736488, -75.5833282470703, -1.31917793752701, 218, 45, 'PPL', 'P'),
(181762, 'Gelatt', 39.3211097717285, 0.686282831054779, -120.290283203125, -2.09946150005096, 218, 6, 'PPL', 'P'),
(161995, 'Gelnett', 41.1091690063477, 0.717490351919572, -78.6958312988281, -1.37350136375856, 218, 45, 'PPL', 'P'),
(29878, 'Gem', 39.7794418334961, 0.694282234600077, -85.8966674804688, -1.49917966402492, 218, 19, 'PPL', 'P'),
(72642, 'Gem', 39.663890838623, 0.692265489285587, -81.4263916015625, -1.42115863146552, 218, 41, 'PPL', 'P'),
(109340, 'Gem', 38.8291702270508, 0.67769686627939, -80.6677780151367, -1.40791832663203, 218, 58, 'PPL', 'P'),
(187684, 'Gem', 39.4277801513672, 0.688144580393826, -100.897216796875, -1.760988639204, 218, 20, 'PPL', 'P'),
(191521, 'Gem', 35.7852783203125, 0.624570930431999, -100.123062133789, -1.74747709141348, 218, 51, 'PPL', 'P'),
(194978, 'Gem', 47.5083312988281, 0.829176803292825, -115.866943359375, -2.02225965584287, 218, 17, 'PPL', 'P'),
(155418, 'Gem Beach', 41.5694389343262, 0.725523577610715, -82.8225021362305, -1.44552535701726, 218, 41, 'PPL', 'P'),
(135530, 'Gem Lake', 45.0574989318848, 0.786401709075217, -93.0322189331055, -1.6237185308189, 218, 28, 'PPL', 'P'),
(81192, 'Gem Lake Estates', 33.5063896179199, 0.584796819288747, -81.7433319091797, -1.42669028336573, 218, 48, 'PPL', 'P'),
(186754, 'Gem Village', 37.2191696166992, 0.649597054669637, -107.636672973633, -1.87861433928229, 218, 7, 'PPL', 'P'),
(181763, 'Gemco', 34.209171295166, 0.59706267347938, -118.436668395996, -2.06710981860284, 218, 6, 'PPL', 'P'),
(190233, 'Gemfield', 37.7397193908691, 0.658682362149415, -117.294166564941, -2.04716939994087, 218, 39, 'PPL', 'P'),
(135532, 'Gemmell', 47.973331451416, 0.83729258697776, -94.1236114501953, -1.64276692367374, 218, 28, 'PPL', 'P'),
(72643, 'Gemmer', 38.7172203063965, 0.675742971566626, -83.4466705322266, -1.45641915061428, 218, 41, 'PPL', 'P'),
(75916, 'Gene Autry', 34.2836112976074, 0.598361896617175, -97.0377807617188, -1.6936287731204, 218, 42, 'PPL', 'P'),
(149079, 'Genegantslet', 42.3502807617188, 0.739151838436004, -75.8108291625977, -1.32314857755426, 218, 40, 'PPL', 'P'),
(60017, 'Geneill', 33.3888893127441, 0.582746052091332, -90.7994384765625, -1.58474916037804, 218, 30, 'PPL', 'P'),
(81193, 'General Hamiltons Settlement (historical)', 32.1124992370605, 0.560468842730874, -81.0972213745117, -1.41541352720395, 218, 48, 'PPL', 'P'),
(81194, 'General Sumter Estates', 33.9680595397949, 0.592854479482891, -80.495002746582, -1.40490282932974, 218, 48, 'PPL', 'P'),
(161996, 'General Warren Village', 40.0416717529297, 0.698859010091432, -75.5236129760742, -1.31813570943441, 218, 45, 'PPL', 'P'),
(13816, 'Generals Greene', 39.1258316040039, 0.682874584070722, -75.4172210693359, -1.31627882036435, 218, 10, 'PPL', 'P'),
(2686, 'Genery', 33.3086090087891, 0.581344896462814, -86.9038925170898, -1.51675905722248, 218, 2, 'PPL', 'P'),
(181764, 'Genes Mobile Home Park', 37.3647193908691, 0.652137377454437, -118.423889160156, -2.06688677886155, 218, 6, 'PPL', 'P'),
(141886, 'Genes Trailer Court', 41.4463882446289, 0.723375937928647, -97.0625, -1.694060205217, 218, 35, 'PPL', 'P'),
(130966, 'Genesee', 43.1124992370605, 0.75245506045025, -83.6177825927734, -1.4594056194607, 218, 27, 'PPL', 'P'),
(161997, 'Genesee', 41.9891700744629, 0.73284926797925, -77.8661117553711, -1.35902002585709, 218, 45, 'PPL', 'P'),
(174227, 'Genesee', 42.9527816772461, 0.749667463158237, -88.35888671875, -1.54215349663888, 218, 57, 'PPL', 'P'),
(186755, 'Genesee', 39.6858291625977, 0.692648385271313, -105.272216796875, -1.83734679397875, 218, 7, 'PPL', 'P'),
(193585, 'Genesee', 40.0430603027344, 0.698883244857352, -120.752777099609, -2.10753354131499, 218, 6, 'PPL', 'P'),
(194980, 'Genesee', 46.5508308410645, 0.812465267715496, -116.924438476563, -2.04071642746156, 218, 17, 'PPL', 'P'),
(174235, 'Genesee Depot', 42.9666709899902, 0.749909877396461, -88.3711090087891, -1.54236681584219, 218, 57, 'PPL', 'P'),
(149082, 'Genesee Junction', 43.098331451416, 0.752207785943036, -77.686393737793, -1.35588335472519, 218, 40, 'PPL', 'P'),
(32546, 'Geneseo', 38.5161094665527, 0.672232925249902, -98.1563873291016, -1.71315214075567, 218, 20, 'PPL', 'P'),
(119757, 'Geneseo', 41.4480590820313, 0.723405099542584, -90.154167175293, -1.57348705160226, 218, 18, 'PPL', 'P'),
(140079, 'Geneseo', 46.0738906860352, 0.804141091675262, -97.2783279418945, -1.69782711342086, 218, 34, 'PPL', 'P'),
(149084, 'Geneseo', 42.7958297729492, 0.746928135660981, -77.8172225952148, -1.35816674904383, 218, 40, 'PPL', 'P'),
(87216, 'Genesis', 36.1091690063477, 0.630223889319856, -84.9172210693359, -1.48208509930381, 218, 50, 'PPL', 'P'),
(41063, 'Genessee', 30.5597190856934, 0.5333677165299, -90.482780456543, -1.57922243532585, 218, 22, 'PPL', 'P'),
(119759, 'Genet', 42.3424987792969, 0.73901601722041, -89.0755615234375, -1.55466183164676, 218, 18, 'PPL', 'P'),
(2688, 'Geneva', 32.1588897705078, 0.561278510281285, -87.9638900756836, -1.53525950468304, 218, 2, 'PPL', 'P'),
(9079, 'Geneva', 34.0208282470703, 0.593775467166868, -94.241943359375, -1.6448322050991, 218, 4, 'PPL', 'P'),
(16189, 'Geneva', 28.7394409179688, 0.501597869200936, -81.1152801513672, -1.41572871231896, 218, 12, 'PPL', 'P'),
(21363, 'Geneva', 32.579719543457, 0.568623375409669, -84.5508270263672, -1.47569031689431, 218, 13, 'PPL', 'P'),
(32537, 'Geneva', 38.0169410705566, 0.663520793217871, -95.4938888549805, -1.66668277605293, 218, 20, 'PPL', 'P'),
(36074, 'Geneva', 37.4394416809082, 0.653441527440248, -84.7463912963867, -1.47910355730541, 218, 21, 'PPL', 'P'),
(87217, 'Geneva', 35.1213912963867, 0.612983916003228, -87.6222229003906, -1.52929628752819, 218, 50, 'PPL', 'P'),
(94444, 'Geneva', 31.4769401550293, 0.549376244158476, -93.9172210693359, -1.6391647319833, 218, 51, 'PPL', 'P'),
(109338, 'Geneva', 38.7388916015625, 0.676121207020445, -81.4894409179688, -1.42225904962795, 218, 58, 'PPL', 'P'),
(115713, 'Geneva', 42.6755599975586, 0.744829032089781, -93.1291732788086, -1.62541070337553, 218, 16, 'PPL', 'P'),
(119760, 'Geneva', 41.8875007629395, 0.73107480374493, -88.3052825927734, -1.54121792814793, 218, 18, 'PPL', 'P'),
(122674, 'Geneva', 40.5919418334961, 0.708463034772531, -84.9572219848633, -1.48278324698358, 218, 19, 'PPL', 'P'),
(130969, 'Geneva', 41.9580612182617, 0.73230631601201, -84.2805633544922, -1.47097332597157, 218, 27, 'PPL', 'P'),
(135533, 'Geneva', 43.8233299255371, 0.764861396388384, -93.2675018310547, -1.62782499206174, 218, 28, 'PPL', 'P'),
(141887, 'Geneva', 40.5269393920898, 0.707328528148157, -97.5955581665039, -1.70336382532713, 218, 35, 'PPL', 'P'),
(149086, 'Geneva', 42.8688888549805, 0.748203257190911, -76.9780578613281, -1.34352056147088, 218, 40, 'PPL', 'P'),
(155419, 'Geneva', 41.8050003051758, 0.729634899122552, -80.9483337402344, -1.41281494777031, 218, 41, 'PPL', 'P'),
(161998, 'Geneva', 41.5625, 0.725402470360143, -80.2252807617188, -1.40019529262886, 218, 45, 'PPL', 'P'),
(169391, 'Geneva', 41.8572196960449, 0.730546299426604, -71.4433288574219, -1.24692131714709, 218, 47, 'PPL', 'P'),
(194981, 'Geneva', 42.3586082458496, 0.739297180452495, -111.064437866211, -1.93844012264205, 218, 17, 'PPL', 'P'),
(200877, 'Geneva', 44.4736099243164, 0.776210923426947, -121.390556335449, -2.11866488888125, 218, 43, 'PPL', 'P'),
(204066, 'Geneva', 40.2825012207031, 0.703062277239905, -111.731391906738, -1.95008066660873, 218, 52, 'PPL', 'P'),
(207486, 'Geneva', 48.7458305358887, 0.850775239470449, -122.40055847168, -2.13629275161065, 218, 56, 'PPL', 'P'),
(190234, 'Geneva (historical)', 39.3972206115723, 0.68761121580651, -117.045829772949, -2.04283510526677, 218, 39, 'PPL', 'P'),
(207487, 'Geneva Junction', 46.4658317565918, 0.810981753830267, -119.324440002441, -2.08260435614103, 218, 56, 'PPL', 'P'),
(102200, 'Geneva Park', 36.7808303833008, 0.641946591806167, -76.3363876342773, -1.33232130329682, 218, 53, 'PPL', 'P'),
(119761, 'Geneva Road', 41.8880615234375, 0.731084590861936, -88.1513900756836, -1.53853199703053, 218, 18, 'PPL', 'P'),
(155421, 'Geneva-on-the-Lake', 41.8594398498535, 0.730585048420465, -80.9541702270508, -1.412916813682, 218, 41, 'PPL', 'P'),
(196575, 'Genevieve (historical)', 48.7266693115234, 0.850440813016562, -107.162498474121, -1.87033843303681, 218, 31, 'PPL', 'P'),
(191522, 'Geneview', 33.3108901977539, 0.581384710721111, -100.202308654785, -1.74886020412561, 218, 51, 'PPL', 'P'),
(181765, 'Genevra', 39.0699996948242, 0.681900133427862, -122.090560913086, -2.13088227354004, 218, 6, 'PPL', 'P'),
(47380, 'Genezer Estates', 38.2244415283203, 0.667142359405243, -75.1933288574219, -1.31237116409688, 218, 25, 'PPL', 'P'),
(102, 'Genito', 37.4619407653809, 0.653834210542981, -77.8594436645508, -1.35890364571745, 218, 53, 'PPL', 'P'),
(102203, 'Genito Estates', 37.4313888549805, 0.653300979113719, -77.6138916015625, -1.35461795373324, 218, 53, 'PPL', 'P'),
(64991, 'Genlee', 35.8708305358887, 0.626064098276179, -78.8916702270508, -1.37691939785962, 218, 33, 'PPL', 'P'),
(87218, 'Gennett Camp', 36.2341690063477, 0.632405550884849, -84.291389465332, -1.47116227725091, 218, 50, 'PPL', 'P'),
(72645, 'Genntown', 39.4602813720703, 0.688711833706013, -84.1708297729492, -1.46905811367363, 218, 41, 'PPL', 'P'),
(9080, 'Genoa', 33.3836097717285, 0.582653906717615, -93.9094390869141, -1.63902891076771, 218, 4, 'PPL', 'P'),
(16190, 'Genoa', 30.4002799987793, 0.530584979506876, -82.8349990844727, -1.44574346991054, 218, 12, 'PPL', 'P'),
(64992, 'Genoa', 35.3261108398438, 0.616556946079733, -78.0405578613281, -1.36206468477332, 218, 33, 'PPL', 'P'),
(81195, 'Genoa', 34.4561080932617, 0.601372533650482, -79.6622161865234, -1.39036796189036, 218, 48, 'PPL', 'P'),
(94445, 'Genoa', 29.6230602264404, 0.517019935467963, -95.1969375610352, -1.66149999825552, 218, 51, 'PPL', 'P'),
(102201, 'Genoa', 38.6402816772461, 0.674400139165981, -78.9180603027344, -1.37737999157015, 218, 53, 'PPL', 'P'),
(109339, 'Genoa', 38.121940612793, 0.665353380942982, -82.4599990844727, -1.43919848521556, 218, 58, 'PPL', 'P'),
(115715, 'Genoa', 40.6041717529297, 0.708676487133901, -93.1138916015625, -1.62514398779236, 218, 16, 'PPL', 'P'),
(119763, 'Genoa', 42.0972213745117, 0.734735118926162, -88.6927795410156, -1.54798102573619, 218, 18, 'PPL', 'P'),
(135538, 'Genoa', 47.4644393920898, 0.828410745005264, -92.5086135864258, -1.61457989353829, 218, 28, 'PPL', 'P'),
(141889, 'Genoa', 41.4486083984375, 0.723414686922508, -97.7302780151367, -1.70571513025356, 218, 35, 'PPL', 'P'),
(149089, 'Genoa', 42.667781829834, 0.744693277453214, -76.5361099243164, -1.33580711484763, 218, 40, 'PPL', 'P'),
(155422, 'Genoa', 40.7827796936035, 0.711793783768866, -81.466667175293, -1.42186157283525, 218, 41, 'PPL', 'P'),
(174230, 'Genoa', 43.5766716003418, 0.760556396486271, -91.2241668701172, -1.59216206927228, 218, 57, 'PPL', 'P'),
(186756, 'Genoa', 39.2783317565918, 0.685536213843175, -103.499717712402, -1.80641084896611, 218, 7, 'PPL', 'P'),
(190235, 'Genoa', 39.0044403076172, 0.68075590626551, -119.84610748291, -2.0917091712758, 218, 39, 'PPL', 'P'),
(198328, 'Genoa', 48.1936111450195, 0.841137192906425, -100.99388885498, -1.76267588491262, 218, 34, 'PPL', 'P'),
(174231, 'Genoa City', 42.4983291625977, 0.741735770483654, -88.3280563354492, -1.54161540494063, 218, 57, 'PPL', 'P'),
(135539, 'Genola', 45.9602813720703, 0.802158235085644, -94.1161117553711, -1.64263602930617, 218, 28, 'PPL', 'P'),
(192583, 'Genola', 39.9963912963867, 0.698068717037951, -111.842498779297, -1.95201984735647, 218, 52, 'PPL', 'P'),
(196576, 'Genou (historical)', 48.0013885498047, 0.837782275723198, -111.258331298828, -1.94182420143921, 218, 31, 'PPL', 'P'),
(112412, 'Genova', 39.9058303833008, 0.696488130930989, -93.7044372558594, -1.63545095384319, 218, 29, 'PPL', 'P'),
(102202, 'Genovar', 37.077220916748, 0.647119582486564, -76.7016677856445, -1.33869664463037, 218, 53, 'PPL', 'P'),
(21364, 'Gentian', 32.5108299255371, 0.567421024756525, -84.9291687011719, -1.48229362481717, 218, 13, 'PPL', 'P'),
(130973, 'Gentian', 46.4311103820801, 0.81037575152422, -87.466667175293, -1.52658132795491, 218, 27, 'PPL', 'P'),
(41064, 'Gentilly', 30.0036106109619, 0.523661792647593, -90.0286102294922, -1.57129566949929, 218, 22, 'PPL', 'P'),
(135541, 'Gentilly', 47.7891693115234, 0.834078351279116, -96.4488906860352, -1.68335070236741, 218, 28, 'PPL', 'P'),
(41065, 'Gentilly Terrace', 30.0063896179199, 0.523710295468946, -90.0533294677734, -1.57172710159588, 218, 22, 'PPL', 'P'),
(47381, 'Gently Savage', 39.3330612182617, 0.686491423147159, -77.2755584716797, -1.34871292664821, 218, 25, 'PPL', 'P'),
(9081, 'Gentry', 36.2675018310547, 0.632987318424977, -94.4844436645508, -1.64906463386151, 218, 4, 'PPL', 'P'),
(87219, 'Gentry', 36.1813888549805, 0.63148436346379, -85.7461090087891, -1.49655192297734, 218, 50, 'PPL', 'P'),
(139168, 'Gentry', 40.3316688537598, 0.703920414322155, -94.4199981689453, -1.64793984777511, 218, 29, 'PPL', 'P'),
(191523, 'Gentry', 35.2961082458496, 0.616033302030396, -101.991943359375, -1.78009522212866, 218, 51, 'PPL', 'P'),
(194982, 'Gentry', 47.4741706848145, 0.828580588103783, -115.894172668457, -2.0227348969394, 218, 17, 'PPL', 'P'),
(9082, 'Gentry Corner', 34.9575004577637, 0.610123481255401, -92.2908325195313, -1.61077889687247, 218, 4, 'PPL', 'P'),
(94448, 'Gentry Crossing', 33.0558280944824, 0.576933037221962, -99.3405609130859, -1.73381986871133, 218, 51, 'PPL', 'P'),
(64993, 'Gentry Store', 36.4599990844727, 0.636347029298166, -78.9205627441406, -1.37742366741203, 218, 33, 'PPL', 'P'),
(36075, 'Gentrys Mill', 37.0847206115723, 0.647250476854141, -85.1536102294922, -1.48621086846456, 218, 21, 'PPL', 'P'),
(94446, 'Gentrys Mill', 31.7919406890869, 0.554874040623322, -98.2252807617188, -1.71435455798784, 218, 51, 'PPL', 'P'),
(29881, 'Gentryville', 38.1041717529297, 0.665043255834042, -87.0330581665039, -1.51901342308523, 218, 19, 'PPL', 'P'),
(139170, 'Gentryville', 40.1330604553223, 0.700454043847308, -94.3438873291016, -1.64661146302338, 218, 29, 'PPL', 'P'),
(47383, 'Gentsville', 39.5099983215332, 0.689579558168188, -76.7027816772461, -1.33871608570632, 218, 25, 'PPL', 'P'),
(155424, 'Genung Corners', 41.7897186279297, 0.72936818353938, -81.0488891601563, -1.41456997092867, 218, 41, 'PPL', 'P'),
(155425, 'Geography Hall', 41.1194381713867, 0.717669582660935, -80.5708312988281, -1.40622628723345, 218, 41, 'PPL', 'P'),
(9084, 'Geopel (historical)', 33.4294395446777, 0.58345378715102, -92.0749969482422, -1.60701185551056, 218, 4, 'PPL', 'P'),
(9085, 'George', 36.079719543457, 0.629709899229471, -93.4002838134766, -1.63014247484233, 218, 4, 'PPL', 'P'),
(60018, 'George', 32.8499984741211, 0.573340632648526, -90.7016677856445, -1.58304273990957, 218, 30, 'PPL', 'P'),
(64994, 'George', 36.3222198486328, 0.633942327991879, -77.230827331543, -1.34793222097465, 218, 33, 'PPL', 'P'),
(94447, 'George', 30.9716701507568, 0.540557618972355, -96.10888671875, -1.67741651366844, 218, 51, 'PPL', 'P'),
(115716, 'George', 43.3438911437988, 0.756493611085301, -96.0019378662109, -1.6755499040604, 218, 16, 'PPL', 'P'),
(200878, 'George', 45.2949981689453, 0.790546852732898, -122.228607177734, -2.13329163537824, 218, 43, 'PPL', 'P'),
(207488, 'George', 47.0791702270508, 0.821686529568923, -119.854721069336, -2.09185950671933, 218, 56, 'PPL', 'P'),
(54935, 'George (historical)', 38.2452812194824, 0.66750608063112, -90.9488906860352, -1.58735759350772, 218, 29, 'PPL', 'P'),
(60019, 'George (historical)', 32.0511093139648, 0.559397386445307, -89.9966735839844, -1.57073826988313, 218, 30, 'PPL', 'P'),
(196577, 'George (historical)', 48.3277816772461, 0.843478910452932, -110.942497253418, -1.93631185745691, 218, 31, 'PPL', 'P'),
(47384, 'George Island Landing', 38.042781829834, 0.663971799548476, -75.3619384765625, -1.31531395710142, 218, 25, 'PPL', 'P'),
(94453, 'George Lookingbill Number 1 Colonia', 26.3269996643066, 0.459492826313593, -97.9820022583008, -1.71010854710387, 218, 51, 'PPL', 'P'),
(94449, 'George Lookingbill Number 2 Colonia', 26.3269996643066, 0.459492826313593, -97.9789962768555, -1.71005608283039, 218, 51, 'PPL', 'P'),
(81197, 'George Martin Acres', 34.7380599975586, 0.606293522712731, -82.9588928222656, -1.44790582355763, 218, 48, 'PPL', 'P'),
(13817, 'George Meyers Development', 39.0897216796875, 0.682244346998755, -75.4986114501953, -1.3176993504898, 218, 10, 'PPL', 'P'),
(196578, 'George Norman Trailer Court', 45.250560760498, 0.78977127364444, -111.251388549805, -1.94170302760961, 218, 31, 'PPL', 'P'),
(196579, 'George Place', 45.360279083252, 0.791686219626262, -109.497779846191, -1.91109678193993, 218, 31, 'PPL', 'P'),
(196580, 'George Place (historical)', 45.3591690063477, 0.791666845129331, -109.51611328125, -1.9114167607449, 218, 31, 'PPL', 'P'),
(204068, 'George T Sharp', 40.6111106872559, 0.708797594384472, -111.886672973633, -1.95279083249205, 218, 52, 'PPL', 'P'),
(64995, 'George Town Sands', 36.1583290100098, 0.631081893244052, -75.7425003051758, -1.32195601401813, 218, 33, 'PPL', 'P'),
(94450, 'George W Ward Addition Colonia', 27.8740005493164, 0.486493085288279, -98.609001159668, -1.72105174233911, 218, 51, 'PPL', 'P'),
(94451, 'George W Ward Addition Number 2 Colonia', 27.8740005493164, 0.486493085288279, -98.6070022583008, -1.72101685492883, 218, 51, 'PPL', 'P'),
(94452, 'George West', 28.3322200775146, 0.494490524752274, -98.1172180175781, -1.71246850730384, 218, 51, 'PPL', 'P'),
(87225, 'Georgemere', 36.2222213745117, 0.632197025371496, -86.5427780151367, -1.5104564201867, 218, 50, 'PPL', 'P'),
(143854, 'Georges', 44.7833290100098, 0.781616541228563, -71.5811080932617, -1.24932601845338, 218, 36, 'PPL', 'P'),
(9086, 'Georges Creek', 36.2508316040039, 0.632696368075885, -92.7613906860352, -1.61899168620012, 218, 4, 'PPL', 'P'),
(36076, 'Georges Creek', 37.9777793884277, 0.662837292924102, -82.6566696166992, -1.44263103354456, 218, 21, 'PPL', 'P'),
(47385, 'Georges Creek', 39.6977806091309, 0.692856977363694, -78.8536071777344, -1.3762550723257, 218, 25, 'PPL', 'P'),
(94454, 'Georges Creek', 32.2938919067383, 0.563634742055733, -97.6374969482422, -1.70409579515274, 218, 51, 'PPL', 'P'),
(102205, 'Georges Fork', 37.1488914489746, 0.648370469250574, -82.4863891601563, -1.43965907892609, 218, 53, 'PPL', 'P'),
(16201, 'Georges Lake', 29.7936096191406, 0.519996583907858, -81.8683319091797, -1.42887194493072, 218, 12, 'PPL', 'P'),
(102206, 'Georges Landing', 37.7541694641113, 0.658934563504646, -78.0113906860352, -1.36155562153095, 218, 53, 'PPL', 'P'),
(65004, 'Georges Mill', 36.5144386291504, 0.637297178596079, -80.3030624389648, -1.40155283899452, 218, 33, 'PPL', 'P'),
(102207, 'Georges Mill', 39.2877807617188, 0.685701130093678, -77.6630630493164, -1.35547615739452, 218, 53, 'PPL', 'P'),
(143857, 'Georges Mills', 43.4316711425781, 0.758025661081396, -72.0677795410156, -1.25782003759213, 218, 36, 'PPL', 'P'),
(155449, 'Georges Run', 40.3005599975586, 0.703377462354915, -80.6255569458008, -1.40718142995841, 218, 41, 'PPL', 'P'),
(162000, 'Georges Station', 40.3177795410156, 0.703678000083931, -79.4880599975586, -1.38732836298019, 218, 45, 'PPL', 'P'),
(102208, 'Georges Tavern', 37.7355613708496, 0.658609791009711, -78.0541687011719, -1.36230223874256, 218, 53, 'PPL', 'P'),
(72651, 'Georgesville', 39.8908309936523, 0.696226342195835, -83.2219390869141, -1.45249684696081, 218, 41, 'PPL', 'P'),
(2696, 'Georgetown', 30.8883304595947, 0.539103066963981, -88.2702789306641, -1.54060699899387, 218, 2, 'PPL', 'P'),
(9089, 'Georgetown', 35.1269416809082, 0.61308078848788, -91.4550018310547, -1.59619089936935, 218, 4, 'PPL', 'P'),
(13112, 'Georgetown', 38.9047203063965, 0.679015463914116, -77.0627822875977, -1.34499928166615, 218, 9, 'PPL', 'P'),
(13818, 'Georgetown', 38.689998626709, 0.675267863628156, -75.3858337402344, -1.31573100812812, 218, 10, 'PPL', 'P'),
(16202, 'Georgetown', 29.3911094665527, 0.512971631005419, -81.6388931274414, -1.42486748275762, 218, 12, 'PPL', 'P'),
(21367, 'Georgetown', 31.8844394683838, 0.556488448876128, -85.1074981689453, -1.48540606118314, 218, 13, 'PPL', 'P'),
(36078, 'Georgetown', 38.2097206115723, 0.666885430939077, -84.5588912963867, -1.47583106495792, 218, 21, 'PPL', 'P'),
(41070, 'Georgetown', 31.7608299255371, 0.554331055366568, -92.3844375610352, -1.61241261304318, 218, 22, 'PPL', 'P'),
(47388, 'Georgetown', 39.2222213745117, 0.684556902931325, -76.195556640625, -1.32986333876874, 218, 25, 'PPL', 'P'),
(54936, 'Georgetown', 38.7586097717285, 0.67646535401231, -93.2377777099609, -1.6273062082814, 218, 29, 'PPL', 'P'),
(60023, 'Georgetown', 31.8713893890381, 0.556260682023899, -90.164436340332, -1.57366628234362, 218, 30, 'PPL', 'P'),
(65000, 'Georgetown', 34.7411117553711, 0.606346785934532, -77.4433288574219, -1.35164107226675, 218, 33, 'PPL', 'P'),
(81200, 'Georgetown', 34.8630599975586, 0.608475184277724, -82.5216674804688, -1.44027480177011, 218, 48, 'PPL', 'P'),
(87223, 'Georgetown', 36.5269393920898, 0.637515358068384, -87.2958297729492, -1.52359965279846, 218, 50, 'PPL', 'P'),
(94455, 'Georgetown', 30.6324996948242, 0.534637977790841, -97.6769409179688, -1.70478422229453, 218, 51, 'PPL', 'P'),
(102215, 'Georgetown', 37.6838912963867, 0.657707978085583, -77.3544387817383, -1.35008964777372, 218, 53, 'PPL', 'P'),
(109345, 'Georgetown', 38.9605598449707, 0.67999004771503, -80.3847198486328, -1.40297802965188, 218, 58, 'PPL', 'P'),
(113463, 'Georgetown', 41.2555618286133, 0.720045388669394, -73.4352798461914, -1.28168742043948, 218, 8, 'PPL', 'P'),
(115717, 'Georgetown', 41.0127792358398, 0.715808033058969, -92.9550018310547, -1.62237083814926, 218, 16, 'PPL', 'P'),
(119765, 'Georgetown', 42.139720916748, 0.735476875868777, -89.82861328125, -1.56780506425852, 218, 18, 'PPL', 'P'),
(122678, 'Georgetown', 41.7294387817383, 0.728316101750744, -86.2283325195313, -1.50496831097032, 218, 19, 'PPL', 'P'),
(124909, 'Georgetown', 42.7249984741211, 0.745691896282966, -70.9916687011719, -1.23903836032046, 218, 23, 'PPL', 'P'),
(127555, 'Georgetown', 44.6352806091309, 0.779032609180914, -67.8263931274414, -1.18379387982591, 218, 26, 'PPL', 'P'),
(135543, 'Georgetown', 47.0800018310547, 0.821701043796863, -96.7938919067383, -1.68937210959208, 218, 28, 'PPL', 'P'),
(145290, 'Georgetown', 40.0794410705566, 0.699518209040254, -74.6536102294922, -1.30295129700516, 218, 37, 'PPL', 'P'),
(149092, 'Georgetown', 42.7683296203613, 0.746448167453522, -75.7369384765625, -1.32185894179639, 218, 40, 'PPL', 'P'),
(155427, 'Georgetown', 40.2075004577637, 0.701753266985103, -80.9208297729492, -1.41233491298382, 218, 41, 'PPL', 'P'),
(162008, 'Georgetown', 40.6413917541504, 0.709326098702798, -80.4980621337891, -1.40495622570959, 218, 45, 'PPL', 'P'),
(174236, 'Georgetown', 42.6241683959961, 0.743932079434642, -90.4844436645508, -1.57925146378173, 218, 57, 'PPL', 'P'),
(181766, 'Georgetown', 38.9069404602051, 0.679054212907976, -120.837501525879, -2.10901226151026, 218, 6, 'PPL', 'P'),
(186757, 'Georgetown', 39.7061080932617, 0.693002319380185, -105.696937561035, -1.84475956971493, 218, 7, 'PPL', 'P'),
(194983, 'Georgetown', 42.4822196960449, 0.741454607251569, -111.370002746582, -1.94377323588298, 218, 17, 'PPL', 'P'),
(196581, 'Georgetown', 46.1994400024414, 0.80633234062018, -113.245559692383, -1.97650787989586, 218, 31, 'PPL', 'P'),
(204069, 'Georgetown', 40.639720916748, 0.709296937088862, -111.995559692383, -1.95469126424593, 218, 52, 'PPL', 'P'),
(207490, 'Georgetown', 47.5519409179688, 0.82993793473237, -122.327781677246, -2.13502255692874, 218, 56, 'PPL', 'P'),
(65002, 'Georgetown Condominiums', 35.8247184753418, 0.625259290994757, -80.2727813720703, -1.4010243346762, 218, 33, 'PPL', 'P'),
(21369, 'Georgetown Estates', 33.4188919067383, 0.583269696140669, -82.0622177124023, -1.43225589056983, 218, 13, 'PPL', 'P'),
(102211, 'Georgetown Green', 38.0722198486328, 0.66448558990178, -78.5019378662109, -1.37011728496139, 218, 53, 'PPL', 'P'),
(13111, 'Georgetown Heights (historical)', 38.9152793884277, 0.679199754661549, -77.0749969482422, -1.34521246771141, 218, 9, 'PPL', 'P'),
(162004, 'Georgetown of Philadelphia', 40.1583290100098, 0.700895063323825, -75.2044372558594, -1.31256504222424, 218, 45, 'PPL', 'P'),
(102212, 'Georgetown Park', 37.235279083252, 0.649878217901722, -79.9927825927734, -1.3961374340759, 218, 53, 'PPL', 'P'),
(47389, 'Georgetown Village', 39.019718170166, 0.681022555269654, -77.1313934326172, -1.3461967720503, 218, 25, 'PPL', 'P'),
(102214, 'Georgetown Village', 38.5913887023926, 0.673546795773693, -77.2988891601563, -1.34912012397888, 218, 53, 'PPL', 'P'),
(41068, 'Georgeville', 30.6494407653809, 0.534933655250867, -90.621940612793, -1.58165123824001, 218, 22, 'PPL', 'P'),
(54937, 'Georgeville', 39.4961090087891, 0.689337143929963, -93.9080581665039, -1.63900480915984, 218, 29, 'PPL', 'P'),
(65003, 'Georgeville', 35.3138885498047, 0.616343626876417, -80.4594421386719, -1.40428217963769, 218, 33, 'PPL', 'P'),
(135546, 'Georgeville', 45.4286117553711, 0.792878849741426, -94.9269409179688, -1.65678766786468, 218, 28, 'PPL', 'P'),
(162006, 'Georgeville', 40.8338890075684, 0.712685809575988, -79.0941696166992, -1.38045367894226, 218, 45, 'PPL', 'P'),
(2698, 'Georgia', 34.4533309936523, 0.601324064118643, -86.9280624389648, -1.51718090193915, 218, 2, 'PPL', 'P'),
(21372, 'Georgia', 32.7502784729004, 0.571600190297132, -83.5002822875977, -1.45735485226328, 218, 13, 'ADM1', 'A'),
(29885, 'Georgia', 38.7099990844727, 0.675616937468038, -86.5722198486328, -1.51097027711903, 218, 19, 'PPL', 'P'),
(32539, 'Georgia', 37.6277809143066, 0.656728667173733, -98.0083312988281, -1.71056807554996, 218, 20, 'PPL', 'P'),
(41069, 'Georgia', 29.8400001525879, 0.520806251458269, -90.9883270263672, -1.58804588749145, 218, 22, 'PPL', 'P'),
(94456, 'Georgia', 33.7538909912109, 0.589116533155883, -95.8311080932617, -1.672568362062, 218, 51, 'PPL', 'P'),
(145291, 'Georgia', 40.1872215270996, 0.701399332876232, -74.2850036621094, -1.29651789875985, 218, 37, 'PPL', 'P'),
(21370, 'Georgia Acres', 34.9711112976074, 0.610361035224636, -85.279167175293, -1.48840225056753, 218, 13, 'PPL', 'P'),
(172040, 'Georgia Center', 44.7275009155273, 0.78064215716473, -73.1180572509766, -1.27615084169125, 218, 55, 'PPL', 'P'),
(172041, 'Georgia Plains', 44.7211112976074, 0.780530637294083, -73.164436340332, -1.27696030950458, 218, 55, 'PPL', 'P'),
(21371, 'Georgia Southern', 32.413330078125, 0.565719331398992, -81.783332824707, -1.42738843104549, 218, 13, 'PPL', 'P'),
(47390, 'Georgia Woods', 38.8841705322266, 0.678656802694309, -76.0486068725586, -1.32729858148094, 218, 25, 'PPL', 'P'),
(47391, 'Georgian Forest', 39.0733299255371, 0.681958256918653, -77.0650024414063, -1.34503803066001, 218, 25, 'PPL', 'P'),
(21373, 'Georgian Heights', 33.8436088562012, 0.590682405297823, -84.7044372558594, -1.4783713211637, 218, 13, 'PPL', 'P'),
(21374, 'Georgian Hills', 33.9236106872559, 0.592078700657351, -83.4158325195313, -1.45588092575798, 218, 13, 'PPL', 'P'),
(13821, 'Georgian Terrace', 39.7708282470703, 0.694131899156542, -75.5138931274414, -1.31796606607297, 218, 10, 'PPL', 'P'),
(21376, 'Georgian Walk', 32.4938888549805, 0.567125347296499, -81.7763900756836, -1.42726725721589, 218, 13, 'PPL', 'P'),
(2699, 'Georgiana', 31.6369400024414, 0.552168768298505, -86.741943359375, -1.51393251119952, 218, 2, 'PPL', 'P'),
(16203, 'Georgiana', 28.2880592346191, 0.493719772643291, -80.6752777099609, -1.40804922099961, 218, 12, 'PPL', 'P'),
(2700, 'Georgiaville', 31.2366695404053, 0.545182730837496, -86.7305603027344, -1.5137338393822, 218, 2, 'PPL', 'P'),
(169392, 'Georgiaville', 41.8869400024414, 0.731065016627924, -71.5088882446289, -1.24806554430944, 218, 47, 'PPL', 'P'),
(149094, 'Georgica', 40.9452781677246, 0.714629917171745, -72.2202835083008, -1.26048173394361, 218, 40, 'PPL', 'P'),
(81203, 'Georgieville', 33.4930610656738, 0.584564192167529, -79.0891723632813, -1.38036646041656, 218, 48, 'PPL', 'P'),
(181767, 'Gepford', 36.3983306884766, 0.63527071274361, -119.808326721191, -2.09104977258989, 218, 6, 'PPL', 'P'),
(72650, 'Gephart', 38.7866706848145, 0.676955109336776, -82.7944412231445, -1.44503560169279, 218, 41, 'PPL', 'P'),
(319, 'Gepp', 36.3877792358398, 0.635086555154232, -92.1041717529297, -1.60752105191098, 218, 4, 'PPL', 'P'),
(102216, 'Gera', 38.2338905334473, 0.667307275655746, -77.1800003051758, -1.34704512201555, 218, 53, 'PPL', 'P'),
(130975, 'Gera', 43.3872184753418, 0.757249815676829, -83.7386093139648, -1.46151444356988, 218, 27, 'PPL', 'P'),
(47392, 'Geraghty Village', 39.0997200012207, 0.682418850629183, -76.7347183227539, -1.33927348532248, 218, 25, 'PPL', 'P'),
(2701, 'Gerald', 31.3236103057861, 0.546700133447596, -85.7572174072266, -1.4967458011047, 218, 2, 'PPL', 'P'),
(29886, 'Gerald', 38.0074996948242, 0.663356010125423, -86.5730590820313, -1.51098492450503, 218, 19, 'PPL', 'P'),
(54938, 'Gerald', 38.3997192382813, 0.670201532549417, -91.3305587768555, -1.59401895834233, 218, 29, 'PPL', 'P'),
(119767, 'Gerald', 40.2705612182617, 0.702853884884606, -87.9300003051758, -1.53466801660494, 218, 18, 'PPL', 'P'),
(155428, 'Gerald', 41.4569396972656, 0.723560095518026, -84.144172668457, -1.4685928594312, 218, 41, 'PPL', 'P'),
(60024, 'Gerald (historical)', 34.4013900756836, 0.60041752408358, -90.5741729736328, -1.58081753566076, 218, 30, 'PPL', 'P'),
(199961, 'Gerald (historical)', 40.583610534668, 0.708317626177012, -116.248611450195, -2.02892102067749, 218, 39, 'PPL', 'P'),
(2702, 'Geraldine', 34.351390838623, 0.599544872773388, -86.0008316040039, -1.50099767094306, 218, 2, 'PPL', 'P'),
(196582, 'Geraldine', 47.6036109924316, 0.830839747656498, -110.264999389648, -1.9244872890589, 218, 31, 'PPL', 'P'),
(141892, 'Geranium (historical)', 41.610279083252, 0.726236372676474, -99.1305618286133, -1.73015469326111, 218, 35, 'PPL', 'P'),
(65005, 'Gerard Landing', 35.4244384765625, 0.61827308708618, -76.9633331298828, -1.34326356642569, 218, 33, 'PPL', 'P'),
(149095, 'Gerard Park', 41.0433311462402, 0.71634126448823, -72.1466674804688, -1.2591968918757, 218, 40, 'PPL', 'P'),
(47393, 'Gerard Plaza', 39.146671295166, 0.6832383052966, -76.6016693115234, -1.33695134200998, 218, 25, 'PPL', 'P'),
(193586, 'Gerber', 40.0563888549805, 0.699115871978571, -122.149169921875, -2.13190519371474, 218, 6, 'PPL', 'P'),
(196583, 'Gerber', 47.4511108398438, 0.828178117884045, -111.164169311523, -1.94018076473052, 218, 31, 'PPL', 'P'),
(21377, 'Gerber (historical)', 34.9361114501953, 0.609750172649599, -85.3680572509766, -1.48995367506056, 218, 13, 'PPL', 'P'),
(47394, 'Gerber Knoll', 39.336109161377, 0.686544619789933, -76.9902801513672, -1.3437338806742, 218, 25, 'PPL', 'P'),
(9093, 'Geren (historical)', 35.374439239502, 0.617400435775988, -93.4244384765625, -1.63056405324289, 218, 4, 'PPL', 'P'),
(162007, 'Gerhards', 40.8950004577637, 0.713752405592564, -75.8977813720703, -1.32466617990145, 218, 45, 'PPL', 'P'),
(9094, 'Geridge', 34.5400009155273, 0.602836739617808, -91.7061080932617, -1.60057353041724, 218, 4, 'PPL', 'P'),
(199337, 'Gering', 41.8258285522461, 0.729998420611347, -103.660003662109, -1.80920836653319, 218, 35, 'PPL', 'P'),
(75919, 'Gerlach', 36.4358291625977, 0.635925184581497, -99.4522171020508, -1.735768636839, 218, 42, 'PPL', 'P'),
(199962, 'Gerlach', 40.651668548584, 0.709505462602215, -119.35417175293, -2.08312327307944, 218, 39, 'PPL', 'P'),
(60025, 'Gerlach Mill', 34.5027809143066, 0.60218712804891, -90.3327789306641, -1.57660441481625, 218, 30, 'PPL', 'P'),
(472, 'Gerlane', 37.1525001525879, 0.648433453010354, -98.5494384765625, -1.7200121774076, 218, 20, 'PPL', 'P'),
(119768, 'Gerlaw', 40.9869384765625, 0.715357026728364, -90.6016693115234, -1.58129743728919, 218, 18, 'PPL', 'P'),
(115719, 'Gerled', 43.3833312988281, 0.757181971648059, -94.1875, -1.64388198922216, 218, 16, 'PPL', 'P'),
(102217, 'German', 38.9324989318848, 0.679500292390565, -77.5274963378906, -1.35311007192404, 218, 53, 'PPL', 'P'),
(109344, 'German (historical)', 38.7700004577637, 0.676664158987685, -80.8199996948242, -1.4105750961355, 218, 58, 'PPL', 'P'),
(47396, 'German Chapel Woods', 38.5175018310547, 0.672257226594849, -76.5913925170898, -1.33677197811057, 218, 25, 'PPL', 'P'),
(119769, 'German Corner', 41.2936096191406, 0.720709447887206, -90.0308303833008, -1.57133441849315, 218, 18, 'PPL', 'P'),
(2703, 'German Crossing', 34.0525016784668, 0.594328272830141, -87.5658264160156, -1.5283119831893, 218, 2, 'PPL', 'P'),
(2704, 'German Ford', 31.3855590820313, 0.547781343560654, -87.9972229003906, -1.53584127222317, 218, 2, 'PPL', 'P'),
(149097, 'German Four Corners', 42.4916687011719, 0.741619523502072, -75.8611068725586, -1.32402608913345, 218, 40, 'PPL', 'P'),
(162009, 'German Settlement', 41.0647201538086, 0.716714573094032, -78.004997253418, -1.36144403508128, 218, 45, 'PPL', 'P'),
(194984, 'German Settlement', 46.4186096191406, 0.810157572051915, -116.500831604004, -2.03332309280133, 218, 17, 'PPL', 'P'),
(115720, 'German Valley', 43.2700004577637, 0.75520397532743, -94.029167175293, -1.64111856011704, 218, 16, 'PPL', 'P'),
(119770, 'German Valley', 42.2155609130859, 0.736800533509573, -89.4733276367188, -1.56160415997638, 218, 18, 'PPL', 'P'),
(21378, 'German Village', 31.2216701507568, 0.544920942102341, -81.357780456543, -1.41996114108137, 218, 13, 'PPL', 'P'),
(149098, 'German Village', 43.2238883972168, 0.754399168046008, -77.5422210693359, -1.35336706696923, 218, 40, 'PPL', 'P'),
(2705, 'Germania', 33.4775009155273, 0.584292616315368, -86.8724975585938, -1.5162111118282, 218, 2, 'PPL', 'P'),
(60026, 'Germania', 32.6061096191406, 0.569083969120198, -90.5922164916992, -1.58113245445966, 218, 30, 'PPL', 'P'),
(70858, 'Germania', 39.5116691589355, 0.689608719782124, -74.5997161865234, -1.30201066850814, 218, 37, 'PPL', 'P'),
(139171, 'Germania', 40.4291687011719, 0.705622107679689, -92.4791717529297, -1.61406603660596, 218, 29, 'PPL', 'P'),
(162010, 'Germania', 41.6474990844727, 0.726885984245372, -77.6605606079102, -1.35543248155264, 218, 45, 'PPL', 'P'),
(174240, 'Germania', 43.8905601501465, 0.766034785164673, -89.2569427490234, -1.55782753123454, 218, 57, 'PPL', 'P'),
(191524, 'Germania', 32.0647201538086, 0.559634940414543, -101.939720153809, -1.77918375524558, 218, 51, 'PPL', 'P'),
(70859, 'Germania Gardens', 39.5033302307129, 0.689463178028551, -74.6094436645508, -1.30218044502763, 218, 37, 'PPL', 'P'),
(2706, 'Germania Springs (historical)', 33.8480606079102, 0.590760103022626, -85.7555618286133, -1.49671690580687, 218, 2, 'PPL', 'P'),
(178237, 'Germann', 33.2780609130859, 0.58081173161258, -111.668609619141, -1.94898490897822, 218, 5, 'PPL', 'P'),
(155432, 'Germano', 40.4083290100098, 0.705258386453811, -80.9472198486328, -1.41279550669435, 218, 41, 'PPL', 'P'),
(162011, 'Germans', 40.7644386291504, 0.711473671805838, -75.7408294677734, -1.32192685240419, 218, 45, 'PPL', 'P'),
(102218, 'Germans Corner', 38.0022201538086, 0.663263864751706, -76.8555603027344, -1.34138257574776, 218, 53, 'PPL', 'P'),
(162012, 'Germansville', 40.7013893127441, 0.710373253643417, -75.7072219848633, -1.3213402911741, 218, 45, 'PPL', 'P'),
(65006, 'Germanton', 36.2627792358398, 0.632904893589239, -80.2311096191406, -1.4002970253825, 218, 33, 'PPL', 'P'),
(27253, 'Germantown', 38.5536117553711, 0.672887463666816, -89.538330078125, -1.56273866660075, 218, 18, 'PPL', 'P'),
(29890, 'Germantown', 39.4152793884277, 0.687926400921521, -85.6263885498047, -1.49446240678606, 218, 19, 'PPL', 'P'),
(36083, 'Germantown', 38.2244415283203, 0.667142359405243, -85.7366714477539, -1.49638720646392, 218, 21, 'PPL', 'P'),
(41071, 'Germantown', 32.7000007629395, 0.570722678717951, -93.230827331543, -1.62718490129374, 218, 22, 'PPL', 'P'),
(47400, 'Germantown', 38.3083305358887, 0.668606498793541, -75.2099990844727, -1.31266211444597, 218, 25, 'PPL', 'P'),
(54939, 'Germantown', 38.2900009155273, 0.668286586567595, -94.0186080932617, -1.64093426936961, 218, 29, 'PPL', 'P'),
(65007, 'Germantown', 35.4316711425781, 0.618399320921849, -76.4633331298828, -1.33453692016572, 218, 33, 'PPL', 'P'),
(81204, 'Germantown', 33.1952781677246, 0.579366900142185, -79.4475021362305, -1.38662049476245, 218, 48, 'PPL', 'P'),
(87229, 'Germantown', 35.086669921875, 0.61237791369718, -89.8099975585938, -1.56748015860553, 218, 50, 'PPL', 'P'),
(102219, 'Germantown', 38.6136093139648, 0.673934618607435, -77.741943359375, -1.35685287852004, 218, 53, 'PPL', 'P'),
(113464, 'Germantown', 41.4080581665039, 0.72270695186282, -73.4427795410156, -1.28181831480705, 218, 8, 'PPL', 'P'),
(115723, 'Germantown', 42.9533309936523, 0.749677050538161, -95.7805633544922, -1.67168618995091, 218, 16, 'PPL', 'P'),
(124912, 'Germantown', 42.2625007629395, 0.737619788439909, -71.1547164916992, -1.24188408110326, 218, 23, 'PPL', 'P'),
(149102, 'Germantown', 41.3805618286133, 0.722227050234387, -74.7052764892578, -1.30385304335026, 218, 40, 'PPL', 'P'),
(155433, 'Germantown', 40.9147186279297, 0.71409655258443, -80.726936340332, -1.40895083418666, 218, 41, 'PPL', 'P'),
(162015, 'Germantown', 41.4191703796387, 0.722900896569205, -75.0725021362305, -1.3102623399877, 218, 45, 'PPL', 'P'),
(174243, 'Germantown', 43.2286109924316, 0.754481592881746, -88.1102828979492, -1.53781454143286, 218, 57, 'PPL', 'P'),
(21379, 'Germantown (historical)', 30.7894401550293, 0.537377105551015, -81.804443359375, -1.4277568793823, 218, 13, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(54940, 'Germantown (historical)', 39.0672187805176, 0.681851597316996, -92.4022216796875, -1.61272300446823, 218, 29, 'PPL', 'P'),
(102220, 'Germantown (historical)', 38.0491714477539, 0.664083319419123, -79.7916717529297, -1.39262738775918, 218, 53, 'PPL', 'P'),
(155434, 'Germantown (historical)', 41.1838912963867, 0.718794501905384, -80.5686111450195, -1.40618753823959, 218, 41, 'PPL', 'P'),
(47401, 'Germantown Estates', 39.1708297729492, 0.683659950276187, -77.291389465332, -1.3489892296113, 218, 25, 'PPL', 'P'),
(119771, 'Germantown Hills', 40.7663917541504, 0.711507760267791, -89.4677810668945, -1.56150735407075, 218, 18, 'PPL', 'P'),
(47402, 'Germantown Park', 39.1616706848145, 0.683500094031755, -77.2652816772461, -1.34853356274879, 218, 25, 'PPL', 'P'),
(47403, 'Germantown View', 39.1672210693359, 0.683596966516406, -77.2705612182617, -1.34862570812251, 218, 25, 'PPL', 'P'),
(115724, 'Germanville', 41.1041717529297, 0.717403133393872, -91.769172668457, -1.60167421489577, 218, 16, 'PPL', 'P'),
(21380, 'Germany', 34.8958282470703, 0.609047098121818, -83.466667175293, -1.45676815787514, 218, 13, 'PPL', 'P'),
(72656, 'Germany', 39.0027809143066, 0.680726944388655, -82.9055633544922, -1.44697504875664, 218, 41, 'PPL', 'P'),
(94457, 'Germany', 31.4397201538086, 0.548726632589578, -95.3505630493164, -1.66418126884102, 218, 51, 'PPL', 'P'),
(112317, 'Germany', 38.4622192382813, 0.671292363331913, -85.5427780151367, -1.49300312766676, 218, 19, 'PPL', 'P'),
(162017, 'Germany', 40.420280456543, 0.705466978546192, -79.116943359375, -1.38085115573496, 218, 45, 'PPL', 'P'),
(149104, 'Germany Hill', 42.1488914489746, 0.73563693185029, -76.352783203125, -1.33260745995595, 218, 40, 'PPL', 'P'),
(130976, 'Germfask', 46.249439239502, 0.807204991930371, -85.9258270263672, -1.49968859410924, 218, 27, 'PPL', 'P'),
(149105, 'Germonds', 41.1202812194824, 0.717684296625957, -73.9936065673828, -1.29143206002613, 218, 40, 'PPL', 'P'),
(94458, 'Gernentz Colonia', 26.2959995269775, 0.45895177184863, -98.1360015869141, -1.71279634243403, 218, 51, 'PPL', 'P'),
(72657, 'Gernon (historical)', 39.1186103820801, 0.682748549972134, -84.2094421386719, -1.46973202658748, 218, 41, 'PPL', 'P'),
(87230, 'Gernt', 36.4452781677246, 0.636090100832001, -84.7147216796875, -1.47855081822117, 218, 50, 'PPL', 'P'),
(75920, 'Geronimo', 34.4811096191406, 0.601808892595092, -98.3827819824219, -1.71710347286502, 218, 42, 'PPL', 'P'),
(94459, 'Geronimo', 29.6627807617188, 0.517713189589224, -97.966667175293, -1.70984089941432, 218, 51, 'PPL', 'P'),
(178238, 'Geronimo', 33.0769386291504, 0.577301485558774, -110.034439086914, -1.92046325265179, 218, 5, 'PPL', 'P'),
(188602, 'Geronimo', 35.8224983215332, 0.625220542000897, -105.644172668457, -1.84383864860998, 218, 38, 'PPL', 'P'),
(178239, 'Geronimo Estates', 34.3669395446777, 0.599816248888467, -111.358062744141, -1.94356484352769, 218, 5, 'PPL', 'P'),
(186758, 'Gerrard', 37.6772193908691, 0.657591531366919, -106.592498779297, -1.86039006162677, 218, 7, 'PPL', 'P'),
(194985, 'Gerrard', 43.3844413757324, 0.757201346144989, -112.039169311523, -1.95545239568547, 218, 17, 'PPL', 'P'),
(109347, 'Gerrardstown', 39.3702812194824, 0.687141034716057, -78.095832824707, -1.3630294148782, 218, 58, 'PPL', 'P'),
(87231, 'Gerren Heights', 35.5825004577637, 0.621031789080366, -85.1352767944336, -1.48589088965959, 218, 50, 'PPL', 'P'),
(143856, 'Gerrish', 43.3613891601563, 0.756799009083305, -71.6511077880859, -1.25054774360345, 218, 36, 'PPL', 'P'),
(127557, 'Gerrish Corner', 44.6375007629395, 0.779071358174774, -69.2786102294922, -1.20913984971046, 218, 26, 'PPL', 'P'),
(143858, 'Gerrish Corner', 43.2658309936523, 0.755131204450643, -71.6983337402344, -1.25137199196083, 218, 36, 'PPL', 'P'),
(127558, 'Gerrishville', 44.4013900756836, 0.774950449283013, -68.101936340332, -1.18860301612237, 218, 26, 'PPL', 'P'),
(194986, 'Gerrit', 44.208610534668, 0.771585811561807, -111.270278930664, -1.94203272695256, 218, 17, 'PPL', 'P'),
(149106, 'Gerritsen', 40.5927810668945, 0.708477682158526, -73.9261093139648, -1.29025401071793, 218, 40, 'PPL', 'P'),
(127559, 'Gerry', 45.0169410705566, 0.785693840857474, -68.8188934326172, -1.20111627797827, 218, 26, 'PPL', 'P'),
(149107, 'Gerry', 42.1933288574219, 0.736412510938749, -79.248893737793, -1.3831541242876, 218, 40, 'PPL', 'P'),
(60027, 'Gershorm', 34.0886116027832, 0.594958509902108, -89.0266723632813, -1.5538085548335, 218, 30, 'PPL', 'P'),
(109346, 'Gerstell', 39.4833297729492, 0.689114104188669, -78.9330596923828, -1.3776417803053, 218, 58, 'PPL', 'P'),
(54941, 'Gerster', 37.9533309936523, 0.662410587938445, -93.5755615234375, -1.63320164798651, 218, 29, 'PPL', 'P'),
(65008, 'Gerton', 35.4791717529297, 0.619228362969191, -82.3483276367188, -1.43724945077178, 218, 33, 'PPL', 'P'),
(535, 'Gertrude', 38.7394409179688, 0.676130794400369, -84.0547180175781, -1.46703158124214, 218, 21, 'PPL', 'P'),
(9095, 'Gertrude', 33.4088897705078, 0.583095125931214, -93.9783325195313, -1.64023132799988, 218, 4, 'PPL', 'P'),
(21381, 'Gertrude', 32.8447189331055, 0.57324848727481, -82.2966690063477, -1.43634783758474, 218, 13, 'PPL', 'P'),
(207491, 'Gertrude', 47.2144393920898, 0.824047421875278, -122.66667175293, -2.14093730455175, 218, 56, 'PPL', 'P'),
(87237, 'Gertrude (historical)', 36.1500015258789, 0.630936551227561, -86.6116714477539, -1.51165883741887, 218, 50, 'PPL', 'P'),
(109348, 'Gertrude (historical)', 38.6688919067383, 0.674899481870371, -79.7863922119141, -1.39253524238546, 218, 58, 'PPL', 'P'),
(75921, 'Gerty', 34.836669921875, 0.608014590567195, -96.289436340332, -1.68056769902827, 218, 42, 'PPL', 'P'),
(200879, 'Gervais', 45.1083297729492, 0.78728887461335, -122.896392822266, -2.14494669357286, 218, 43, 'PPL', 'P'),
(162018, 'Geryville', 40.4152793884277, 0.705379693441464, -75.4755630493164, -1.31729708000714, 218, 45, 'PPL', 'P'),
(36080, 'Gesling', 38.4230613708496, 0.670608929617172, -83.0924987792969, -1.4502376874081, 218, 21, 'PPL', 'P'),
(122681, 'Gessie', 40.0825004577637, 0.69957160542011, -87.4997177124023, -1.52715816864702, 218, 19, 'PPL', 'P'),
(36081, 'Gest', 38.4174995422363, 0.670511857395438, -84.8827819824219, -1.48148402384578, 218, 21, 'PPL', 'P'),
(72660, 'Getaway', 38.4866714477539, 0.671719134896598, -82.4680633544922, -1.43933923327917, 218, 41, 'PPL', 'P'),
(199964, 'Getchell', 41.2180595397949, 0.71939085025248, -117.254173278809, -2.04647138541917, 218, 39, 'PPL', 'P'),
(207492, 'Getchell', 48.0722198486328, 0.839018515101213, -122.095832824707, -2.13097428575571, 218, 56, 'PPL', 'P'),
(127561, 'Getchell Corner', 44.459171295166, 0.775958921808799, -69.665283203125, -1.21588856622883, 218, 26, 'PPL', 'P'),
(102221, 'Gether', 37.9161109924316, 0.661760976369547, -77.2074966430664, -1.34752502364398, 218, 53, 'PPL', 'P'),
(9096, 'Gethsemane', 34.4166717529297, 0.600684239666751, -91.8672180175781, -1.6033854290542, 218, 4, 'PPL', 'P'),
(36082, 'Gethsemane', 37.646110534668, 0.657048579399679, -85.5422210693359, -1.49299340712878, 218, 21, 'PPL', 'P'),
(65009, 'Gethsemane', 36.0791702270508, 0.629700311849546, -77.6563873291016, -1.35535964409683, 218, 33, 'PPL', 'P'),
(94461, 'Gethsemane', 32.8025016784668, 0.572511657180212, -94.1091690063477, -1.64251485547657, 218, 51, 'PPL', 'P'),
(87232, 'Gethsemane (historical)', 35.1686096191406, 0.613808031202553, -86.5077819824219, -1.50984562419069, 218, 50, 'PPL', 'P'),
(149109, 'Getman Corners', 42.9500007629395, 0.74961892704737, -75.0141677856445, -1.30924421350296, 218, 40, 'PPL', 'P'),
(162019, 'Getty Heights', 40.6124992370605, 0.708821829150392, -79.1769409179688, -1.38189831067558, 218, 45, 'PPL', 'P'),
(78335, 'Gettysburg', 39.8308296203613, 0.695179120676188, -77.2313919067383, -1.34794207467068, 218, 45, 'PPL', 'P'),
(81206, 'Gettysburg', 34.2180595397949, 0.597217802612877, -80.7138900756836, -1.40872313391345, 218, 48, 'PPL', 'P'),
(155435, 'Gettysburg', 40.1113891601563, 0.70007580839349, -84.4952774047852, -1.47472079309947, 218, 41, 'PPL', 'P'),
(170381, 'Gettysburg', 45.0116691589355, 0.785601828641812, -99.9552764892578, -1.74454867947883, 218, 49, 'PPL', 'P'),
(81207, 'Gettysville', 32.901668548584, 0.574242445572654, -80.3641662597656, -1.40261930185305, 218, 48, 'PPL', 'P'),
(178240, 'Getz', 35.204719543457, 0.61443826827452, -114.019439697266, -1.99001463399641, 218, 5, 'PPL', 'P'),
(102222, 'Getz Corner', 38.7430610656738, 0.676193977897231, -78.7627792358398, -1.37466982568683, 218, 53, 'PPL', 'P'),
(149110, 'Getzville', 43.0238914489746, 0.750908562805241, -78.7680587768555, -1.37476197106055, 218, 40, 'PPL', 'P'),
(32541, 'Geuda Springs', 37.1141700744629, 0.647764466944527, -97.1488876342773, -1.69556795386814, 218, 20, 'PPL', 'P'),
(155436, 'Geyer', 40.5083312988281, 0.707003755653222, -84.0638885498047, -1.46719163722365, 218, 41, 'PPL', 'P'),
(9097, 'Geyer Springs', 34.7013893127441, 0.605653498523757, -92.3349990844727, -1.61154974885, 218, 4, 'PPL', 'P'),
(196584, 'Geyser', 47.2591705322266, 0.824828127548835, -110.492500305176, -1.92845792908616, 218, 31, 'PPL', 'P'),
(190237, 'Geyser (historical)', 38.6747207641602, 0.675001214624012, -114.629997253418, -2.0006708736242, 218, 39, 'PPL', 'P'),
(196585, 'Geyser Trailer Park', 45.6624984741211, 0.7969609430603, -110.560279846191, -1.92964090524237, 218, 31, 'PPL', 'P'),
(181769, 'Geyserville', 38.7077789306641, 0.675578188474178, -122.901390075684, -2.14503391209856, 218, 6, 'PPL', 'P'),
(54947, 'Gheen', 36.5994415283203, 0.638780759060335, -90.5838928222656, -1.58098717902219, 218, 29, 'PPL', 'P'),
(135551, 'Gheen', 47.9680595397949, 0.837200574762097, -92.8080596923828, -1.61980621401952, 218, 28, 'PPL', 'P'),
(135552, 'Gheen Corner', 47.964168548584, 0.8371326641543, -92.8288879394531, -1.62016973550831, 218, 28, 'PPL', 'P'),
(41072, 'Gheens', 29.6791706085205, 0.517999246379812, -90.4625015258789, -1.57886850121698, 218, 22, 'PPL', 'P'),
(162025, 'Ghennes Heights', 40.1538887023926, 0.700817565336104, -79.9397201538086, -1.39521131980683, 218, 45, 'PPL', 'P'),
(36085, 'Ghent', 38.7374992370605, 0.676096905675498, -85.0583267211914, -1.48454785752186, 218, 21, 'PPL', 'P'),
(102224, 'Ghent', 37.2638893127441, 0.650377560606112, -79.9736099243164, -1.39580280788493, 218, 53, 'PPL', 'P'),
(109349, 'Ghent', 37.6169395446777, 0.656539449578283, -81.1149978637695, -1.41572378547095, 218, 58, 'PPL', 'P'),
(127560, 'Ghent', 44.336109161377, 0.77381108238965, -69.2005615234375, -1.20777764281289, 218, 26, 'PPL', 'P'),
(135554, 'Ghent', 44.5127792358398, 0.776894556878771, -95.8908309936523, -1.67361072331266, 218, 28, 'PPL', 'P'),
(149112, 'Ghent', 42.3291702270508, 0.738783390099192, -73.6161117553711, -1.28484353264733, 218, 40, 'PPL', 'P'),
(155437, 'Ghent', 41.1583290100098, 0.718348355843769, -81.6369400024414, -1.42483339429567, 218, 41, 'PPL', 'P'),
(162020, 'Ghent', 41.8630599975586, 0.730648231917327, -76.4397201538086, -1.33412479598703, 218, 45, 'PPL', 'P'),
(54942, 'Ghermanville', 37.6488914489746, 0.657097115510546, -90.6699981689453, -1.58249000082533, 218, 29, 'PPL', 'P'),
(65010, 'Ghio Scholl Station', 34.8166694641113, 0.607665516727312, -79.6511077880859, -1.390174083763, 218, 33, 'PPL', 'P'),
(60028, 'Gholson', 32.9363899230957, 0.574848447878702, -88.73388671875, -1.54869848133386, 218, 30, 'PPL', 'P'),
(94460, 'Gholson', 31.7008304595947, 0.553283867136435, -97.2161102294922, -1.69674120948638, 218, 51, 'PPL', 'P'),
(102225, 'Gholsonville', 36.6474990844727, 0.639619521645655, -77.8955612182617, -1.35953401594747, 218, 53, 'PPL', 'P'),
(21382, 'Gholston Stand Crossroads', 34.0927810668945, 0.595031280778895, -83.1458282470703, -1.45116846220908, 218, 13, 'PPL', 'P'),
(72659, 'Ghormley (historical)', 39.4094390869141, 0.687824468430798, -83.3788909912109, -1.45523617445807, 218, 41, 'PPL', 'P'),
(81208, 'Giant', 33.2369384765625, 0.580094009698804, -80.4449996948242, -1.40403011144052, 218, 48, 'PPL', 'P'),
(181770, 'Giant', 37.9905586242676, 0.663060332665397, -122.356109619141, -2.13551697278511, 218, 6, 'PPL', 'P'),
(181771, 'Giant Oak (historical)', 36.3047218322754, 0.633636929993874, -119.1875, -2.08021430222074, 218, 6, 'PPL', 'P'),
(113465, 'Giants Neck', 41.3002815246582, 0.720825894605869, -72.2330627441406, -1.2607047736849, 218, 8, 'PPL', 'P'),
(115725, 'Giard', 43.0055618286133, 0.750588650579295, -91.2891693115234, -1.59329657589665, 218, 16, 'PPL', 'P'),
(115726, 'Giard Station (historical)', 43.0347213745117, 0.751097580663609, -91.2677764892578, -1.59292320071182, 218, 16, 'PPL', 'P'),
(109350, 'Giatto', 37.4174995422363, 0.653058564875495, -81.2561111450195, -1.41818667684705, 218, 58, 'PPL', 'P'),
(130979, 'Giauque Beach', 45.4836082458496, 0.793838719577318, -84.5941696166992, -1.47644678780195, 218, 27, 'PPL', 'P'),
(41073, 'Gibbens Place', 30.5497207641602, 0.533193212899473, -91.1416702270508, -1.59072223122892, 218, 22, 'PPL', 'P'),
(75922, 'Gibbon', 36.9427795410156, 0.644773137829122, -97.9819412231445, -1.71010748183943, 218, 42, 'PPL', 'P'),
(135556, 'Gibbon', 44.5338897705078, 0.777263005215583, -94.5261077880859, -1.64979180999715, 218, 28, 'PPL', 'P'),
(141894, 'Gibbon', 40.7483291625977, 0.711192508573753, -98.8444366455078, -1.72516086674305, 218, 35, 'PPL', 'P'),
(200880, 'Gibbon', 45.6997184753418, 0.797610554629197, -118.363891601563, -2.06583962392093, 218, 43, 'PPL', 'P'),
(207493, 'Gibbon', 46.2361106872559, 0.806972364809153, -119.66056060791, -2.08847076739026, 218, 56, 'PPL', 'P'),
(78337, 'Gibbon Glade', 39.7397193908691, 0.693588947189302, -79.5947189331055, -1.38918991258216, 218, 45, 'PPL', 'P'),
(135557, 'Gibbon Trailer Park', 44.5361099243164, 0.777301754209444, -94.5166702270508, -1.64962709348373, 218, 28, 'PPL', 'P'),
(54943, 'Gibbons', 36.1324996948242, 0.630631086650529, -89.977783203125, -1.57040857054018, 218, 29, 'PPL', 'P'),
(2707, 'Gibbons (historical)', 32.538890838623, 0.567910780080991, -86.5972213745117, -1.51140663606364, 218, 2, 'PPL', 'P'),
(9099, 'Gibbons (historical)', 34.5750007629395, 0.603447602192845, -92.5166702270508, -1.61472050844385, 218, 4, 'PPL', 'P'),
(194987, 'Gibbonsville', 45.5555610656738, 0.795094533189345, -113.922218322754, -1.98831780090787, 218, 17, 'PPL', 'P'),
(9098, 'Gibbs', 34.6591682434082, 0.604916601850133, -93.6186065673828, -1.63395292573002, 218, 4, 'PPL', 'P'),
(32542, 'Gibbs', 37.1375007629395, 0.6481716642752, -96.3266677856445, -1.68121751033425, 218, 20, 'PPL', 'P'),
(36084, 'Gibbs', 37.0208282470703, 0.646135344726698, -83.9024963378906, -1.46437481173868, 218, 21, 'PPL', 'P'),
(41074, 'Gibbs', 30.5430603027344, 0.533076965917891, -91.991943359375, -1.60556229692923, 218, 22, 'PPL', 'P'),
(87233, 'Gibbs', 36.4111099243164, 0.635493752484905, -89.0038909912109, -1.55341094488275, 218, 50, 'PPL', 'P'),
(139172, 'Gibbs', 40.0977783203125, 0.699838254424255, -92.4166717529297, -1.61297520582346, 218, 29, 'PPL', 'P'),
(194988, 'Gibbs', 47.6908302307129, 0.832362010535587, -116.802780151367, -2.03859308912444, 218, 17, 'PPL', 'P'),
(87234, 'Gibbs (historical)', 35.0597190856934, 0.611907532869645, -88.1819381713867, -1.53906516188077, 218, 50, 'PPL', 'P'),
(130984, 'Gibbs City', 46.225830078125, 0.806792934330709, -88.7005615234375, -1.54811684695178, 218, 27, 'PPL', 'P'),
(124913, 'Gibbs Crossing', 42.2372207641602, 0.73717856922631, -72.2888870239258, -1.26167909116971, 218, 23, 'PPL', 'P'),
(81209, 'Gibbs Crossroads', 34.0263900756836, 0.593872539388601, -79.6005630493164, -1.38929191165191, 218, 48, 'PPL', 'P'),
(87235, 'Gibbs Crossroads', 36.4491691589355, 0.636158011439798, -85.8805618286133, -1.49889856737186, 218, 50, 'PPL', 'P'),
(124914, 'Gibbs Grove', 41.8680610656738, 0.730735517022054, -70.8619384765625, -1.23677414076167, 218, 23, 'PPL', 'P'),
(162021, 'Gibbs Hill', 41.7425003051758, 0.728544068340055, -78.9127807617188, -1.37728784619643, 218, 45, 'PPL', 'P'),
(188603, 'Gibbs Place', 34.2677803039551, 0.598085593654079, -106.729438781738, -1.86278011554706, 218, 38, 'PPL', 'P'),
(181772, 'Gibbs Ranch', 37.9883308410645, 0.663021450513481, -120.404441833496, -2.10145394402051, 218, 6, 'PPL', 'P'),
(70860, 'Gibbsboro', 39.8380584716797, 0.695305287932831, -74.9652786254883, -1.3083909366897, 218, 37, 'PPL', 'P'),
(41075, 'Gibbstown', 29.9341697692871, 0.522449821325011, -93.0763931274414, -1.62448951595447, 218, 22, 'PPL', 'P'),
(70862, 'Gibbstown', 39.8250007629395, 0.695077387922547, -75.2838897705078, -1.31395175020384, 218, 37, 'PPL', 'P'),
(115728, 'Gibbsville', 41.8008308410645, 0.729562128245765, -93.8236083984375, -1.63753088265454, 218, 16, 'PPL', 'P'),
(174247, 'Gibbsville', 43.6522216796875, 0.761874994120996, -87.8266677856445, -1.53286452391473, 218, 57, 'PPL', 'P'),
(65011, 'Gibbton', 35.0988883972168, 0.612591166321468, -76.7280578613281, -1.33915723834089, 218, 33, 'PPL', 'P'),
(196586, 'Gibbtown', 46.4136085510254, 0.810070286947188, -108.555000305176, -1.89464217482877, 218, 31, 'PPL', 'P'),
(102226, 'Gibeon', 37.9722213745117, 0.662740287281396, -76.620002746582, -1.33727132081495, 218, 53, 'PPL', 'P'),
(72663, 'Gibisonville', 39.4997215270996, 0.689400194268771, -82.5666732788086, -1.44106030113363, 218, 41, 'PPL', 'P'),
(194989, 'Gibler', 45.7380599975586, 0.798279740432107, -115.388610839844, -2.01391117845769, 218, 17, 'PPL', 'P'),
(119773, 'Giblin', 40.0175018310547, 0.698437165374764, -88.4066696166992, -1.54298746553423, 218, 18, 'PPL', 'P'),
(54944, 'Giboney', 37.8047218322754, 0.659816868773789, -89.9905624389648, -1.57063161028148, 218, 29, 'PPL', 'P'),
(130980, 'Gibos Corners (historical)', 43.8572196960449, 0.765452884466491, -85.147216796875, -1.48609928201489, 218, 27, 'PPL', 'P'),
(130981, 'Gibraltar', 42.0950012207031, 0.734696369932302, -83.1897201538086, -1.45193452049664, 218, 27, 'PPL', 'P'),
(162022, 'Gibraltar', 40.2841682434082, 0.703091372274814, -75.8722229003906, -1.32422010041886, 218, 45, 'PPL', 'P'),
(207494, 'Gibraltar', 48.4308280944824, 0.84527740971609, -122.581390380859, -2.1394488638185, 218, 56, 'PPL', 'P'),
(47404, 'Gibralter Acres', 39.3033294677734, 0.685972506208757, -77.331672668457, -1.34969230413908, 218, 25, 'PPL', 'P'),
(41076, 'Gibsland', 32.5438919067383, 0.567998065185718, -93.0527801513672, -1.62407739177578, 218, 22, 'PPL', 'P'),
(2709, 'Gibson', 32.0933303833008, 0.560134283118932, -86.1561126708984, -1.50370783682638, 218, 2, 'PPL', 'P'),
(9101, 'Gibson', 34.8841705322266, 0.608843632614536, -92.2355575561523, -1.60981416676759, 218, 4, 'PPL', 'P'),
(16205, 'Gibson', 30.5661106109619, 0.533479269690061, -84.3994369506836, -1.47304806161879, 218, 12, 'PPL', 'P'),
(21383, 'Gibson', 33.2333297729492, 0.580031025939023, -82.5955581665039, -1.44156443752798, 218, 13, 'PPL', 'P'),
(41077, 'Gibson', 29.6866703033447, 0.518130140747389, -90.9905624389648, -1.58808490280142, 218, 22, 'PPL', 'P'),
(47405, 'Gibson', 39.5930595397949, 0.691029249907572, -76.3241729736328, -1.33210811725156, 218, 25, 'PPL', 'P'),
(54946, 'Gibson', 36.1177787780762, 0.630374158184364, -89.8450012207031, -1.56809108775959, 218, 29, 'PPL', 'P'),
(60029, 'Gibson', 33.8400001525879, 0.590619421538042, -88.684440612793, -1.54783548398261, 218, 30, 'PPL', 'P'),
(65012, 'Gibson', 34.7588882446289, 0.606657044201527, -79.6108322143555, -1.38947114239327, 218, 33, 'PPL', 'P'),
(72661, 'Gibson', 39.976390838623, 0.697719643198069, -81.413330078125, -1.42093066487621, 218, 41, 'PPL', 'P'),
(75923, 'Gibson', 35.8708305358887, 0.626064098276179, -95.3516693115234, -1.66420057675892, 218, 42, 'PPL', 'P'),
(81210, 'Gibson', 32.6988906860352, 0.570703304221021, -80.2588882446289, -1.40078185385895, 218, 48, 'PPL', 'P'),
(87236, 'Gibson', 35.8752784729004, 0.626141729421955, -88.8466720581055, -1.55066695685359, 218, 50, 'PPL', 'P'),
(115729, 'Gibson', 41.4811096191406, 0.723981940234695, -92.3933334350586, -1.61256787533474, 218, 16, 'PPL', 'P'),
(122682, 'Gibson', 41.605281829834, 0.726149154150774, -87.4613876342773, -1.52648918258119, 218, 19, 'PPL', 'P'),
(130983, 'Gibson', 42.7102813720703, 0.745435034395828, -86.1852798461914, -1.50421690006875, 218, 27, 'PPL', 'P'),
(149113, 'Gibson', 42.1399993896484, 0.735481736137766, -77.0311126708984, -1.3444465425819, 218, 40, 'PPL', 'P'),
(162024, 'Gibson', 40.1341705322266, 0.700473418344238, -79.9944381713867, -1.39616632937373, 218, 45, 'PPL', 'P'),
(178241, 'Gibson', 32.3786087036133, 0.565113329092945, -112.872222900391, -1.96999192365676, 218, 5, 'PPL', 'P'),
(188604, 'Gibson', 31.6366691589355, 0.552164041187571, -108.938606262207, -1.90133736180923, 218, 38, 'PPL', 'P'),
(193587, 'Gibson', 41.0119400024414, 0.715793385672974, -122.407783508301, -2.13641885228826, 218, 6, 'PPL', 'P'),
(194990, 'Gibson', 43.1005592346191, 0.752246668094951, -112.417503356934, -1.96205557045027, 218, 17, 'PPL', 'P'),
(209471, 'Gibson', 42.0186080932617, 0.733363058332554, -104.956939697266, -1.83184417053443, 218, 59, 'PPL', 'P'),
(188605, 'Gibson (historical)', 35.5672187805176, 0.620765073497194, -108.743606567383, -1.89793397509416, 218, 38, 'PPL', 'P'),
(21384, 'Gibson Acres', 34.0875015258789, 0.594939135405178, -84.6130599975586, -1.4767764871449, 218, 13, 'PPL', 'P'),
(119774, 'Gibson City', 40.4652786254883, 0.706252344751656, -88.3758316040039, -1.54244924067793, 218, 18, 'PPL', 'P'),
(149114, 'Gibson Corners', 42.040828704834, 0.733750881166296, -76.2591705322266, -1.33097361062719, 218, 40, 'PPL', 'P'),
(2710, 'Gibson Crossroads', 34.4622192382813, 0.60147919325214, -85.9527816772461, -1.5001590415158, 218, 2, 'PPL', 'P'),
(87240, 'Gibson Farm Subdivision', 35.3166694641113, 0.616392162987284, -84.8394393920898, -1.48072755293814, 218, 50, 'PPL', 'P'),
(196587, 'Gibson Flats', 47.4697189331055, 0.82850289037898, -111.246109008789, -1.94161088223589, 218, 31, 'PPL', 'P'),
(143859, 'Gibson Four Corners', 42.728328704834, 0.745750019773757, -71.8505630493164, -1.25402889462235, 218, 36, 'PPL', 'P'),
(87239, 'Gibson Hall', 36.5158309936523, 0.637321479941026, -83.480827331543, -1.4570152992243, 218, 50, 'PPL', 'P'),
(47406, 'Gibson Island', 39.0741691589355, 0.681972904304649, -76.4241714477539, -1.33385341987195, 218, 25, 'PPL', 'P'),
(130985, 'Gibson Lake', 46.2030601501465, 0.806395524117042, -88.4300003051758, -1.54339466286491, 218, 27, 'PPL', 'P'),
(41078, 'Gibson Landing', 31.6894397735596, 0.553085062161061, -91.404167175293, -1.59530366725219, 218, 22, 'PPL', 'P'),
(60031, 'Gibson Landing', 30.767219543457, 0.536989282717272, -88.670280456543, -1.54758834263346, 218, 30, 'PPL', 'P'),
(70863, 'Gibson Landing', 39.3561096191406, 0.686893693629815, -74.7266693115234, -1.30422641853509, 218, 37, 'PPL', 'P'),
(149115, 'Gibson Landing', 42.4988899230957, 0.74174555760066, -77.1588897705078, -1.34667667367873, 218, 40, 'PPL', 'P'),
(47407, 'Gibson Manor', 39.5938911437988, 0.691043764135513, -76.3180618286133, -1.33200145764991, 218, 25, 'PPL', 'P'),
(47408, 'Gibson Meadows', 38.6063919067383, 0.673808651087875, -76.6277770996094, -1.33740700887249, 218, 25, 'PPL', 'P'),
(103, 'Gibson Mill', 36.6061096191406, 0.638897139199971, -83.5761108398438, -1.458678310167, 218, 53, 'PPL', 'P'),
(65013, 'Gibson Mill', 34.8388900756836, 0.608053339561055, -79.4674987792969, -1.38696950202331, 218, 33, 'PPL', 'P'),
(188606, 'Gibson Place', 31.7641696929932, 0.554389345304927, -108.794166564941, -1.89881641352136, 218, 38, 'PPL', 'P'),
(102227, 'Gibson Station', 36.6041717529297, 0.638863317054127, -83.5975036621094, -1.45905168535183, 218, 53, 'PPL', 'P'),
(87242, 'Gibson Wells', 35.8805618286133, 0.626233941374699, -89.039436340332, -1.55403132825868, 218, 50, 'PPL', 'P'),
(155439, 'Gibsonburg', 41.3844413757324, 0.722294761105102, -83.320556640625, -1.45421804797333, 218, 41, 'PPL', 'P'),
(155440, 'Gibsonburg Junction (historical)', 41.4324989318848, 0.723133523690423, -83.3188934326172, -1.45418901951745, 218, 41, 'PPL', 'P'),
(162028, 'Gibsondale', 40.9930610656738, 0.715463886067104, -80.2480621337891, -1.40059290257961, 218, 45, 'PPL', 'P'),
(16206, 'Gibsonia', 28.1144409179688, 0.490689561375972, -81.9738922119141, -1.43071431977284, 218, 12, 'PPL', 'P'),
(27255, 'Gibsonia', 37.6469383239746, 0.657063027048593, -88.2624969482422, -1.54047117777827, 218, 18, 'PPL', 'P'),
(162029, 'Gibsonia', 40.6300010681152, 0.709127293727424, -79.9697189331055, -1.39573489727714, 218, 45, 'PPL', 'P'),
(16207, 'Gibsonton', 27.8533306121826, 0.486132326829115, -82.3827819824219, -1.43785079254592, 218, 12, 'PPL', 'P'),
(162030, 'Gibsonton', 40.1336097717285, 0.700463631227232, -79.8822174072266, -1.39420770755003, 218, 45, 'PPL', 'P'),
(65014, 'Gibsontown', 35.5275001525879, 0.620071852665447, -82.8216705322266, -1.44551084278932, 218, 33, 'PPL', 'P'),
(87243, 'Gibsontown', 36.5511093139648, 0.637937202785052, -82.545280456543, -1.4406869259488, 218, 50, 'PPL', 'P'),
(2712, 'Gibsonville', 33.1936111450195, 0.579337805107276, -85.7819366455078, -1.49717723320129, 218, 2, 'PPL', 'P'),
(65015, 'Gibsonville', 36.1055603027344, 0.630160905560075, -79.5425033569336, -1.38827857885713, 218, 33, 'PPL', 'P'),
(181773, 'Gibsonville', 39.7402801513672, 0.693598734306308, -120.907783508301, -2.11023891350835, 218, 6, 'PPL', 'P'),
(94462, 'Gibtown', 33.0319404602051, 0.57651611935331, -97.9480590820313, -1.70951612691938, 218, 51, 'PPL', 'P'),
(9102, 'Gid', 35.9797210693359, 0.627964596609087, -91.8563919067383, -1.60319647777486, 218, 4, 'PPL', 'P'),
(65016, 'Giddensville', 35.1388893127441, 0.613289314001233, -78.2186126708984, -1.36517232744933, 218, 33, 'PPL', 'P'),
(94463, 'Giddings', 30.1825008392334, 0.526784016130574, -96.9361114501953, -1.69185430888608, 218, 51, 'PPL', 'P'),
(130987, 'Giddings', 44.5844383239746, 0.778145243905699, -85.1961135864258, -1.4869526919862, 218, 27, 'PPL', 'P'),
(194199, 'Giddings', 40.6213912963867, 0.708977024862916, -105.01000213623, -1.8327702848035, 218, 7, 'PPL', 'P'),
(149116, 'Giddingsville', 43.7783317565918, 0.76407603018292, -76.0358276367188, -1.32707554173964, 218, 40, 'PPL', 'P'),
(54948, 'Gideon', 36.4519386291504, 0.636206347813583, -89.9191665649414, -1.56938551720743, 218, 29, 'PPL', 'P'),
(75924, 'Gideon', 36.0094413757324, 0.628483313810407, -95.0330581665039, -1.65863976324478, 218, 42, 'PPL', 'P'),
(81211, 'Gideon', 33.9519386291504, 0.592573116513724, -79.2225036621094, -1.38269353057707, 218, 48, 'PPL', 'P'),
(162031, 'Gideon', 40.0763893127441, 0.699464945818453, -79.045280456543, -1.379600402129, 218, 45, 'PPL', 'P'),
(124915, 'Gidleys Corner', 41.5819396972656, 0.725741757083019, -71.040283203125, -1.23988684344375, 218, 23, 'PPL', 'P'),
(65017, 'Gidney Homes', 35.2825012207031, 0.615795814640188, -81.5391693115234, -1.4231269738272, 218, 33, 'PPL', 'P'),
(54949, 'Gidson', 36.329719543457, 0.634073222359456, -89.9338912963867, -1.56964251225262, 218, 29, 'PPL', 'P'),
(102228, 'Gidsville', 37.6938896179199, 0.65788248171601, -79.1080627441406, -1.38069615975951, 218, 53, 'PPL', 'P'),
(72662, 'Gieringer', 39.1977806091309, 0.684130331103722, -84.7372207641602, -1.4789435013239, 218, 41, 'PPL', 'P'),
(13113, 'Giesboro', 38.8444404602051, 0.67796338212548, -77.0166702270508, -1.34419447438472, 218, 9, 'PPL', 'P'),
(135559, 'Giese', 46.2161102294922, 0.806623290969271, -93.1163864135742, -1.62518753047618, 218, 28, 'PPL', 'P'),
(9104, 'Gieseck', 35.1800003051758, 0.614006836177927, -90.5602798461914, -1.5805750548435, 218, 4, 'PPL', 'P'),
(102229, 'Giesley Mill', 36.7794418334961, 0.641922357040247, -81.8816680908203, -1.42910470520999, 218, 53, 'PPL', 'P'),
(196588, 'Giffen', 47.3138885498047, 0.825783137115737, -111.185829162598, -1.94055880044726, 218, 31, 'PPL', 'P'),
(181774, 'Giffen Cantua Ranch', 36.4747200012207, 0.636603957764331, -120.391387939453, -2.10122611058925, 218, 6, 'PPL', 'P'),
(9105, 'Gifford', 34.375560760498, 0.599966717490057, -92.7441711425781, -1.6186911484711, 218, 4, 'PPL', 'P'),
(16208, 'Gifford', 27.6749992370605, 0.483019857173625, -80.4094390869141, -1.40340946174847, 218, 12, 'PPL', 'P'),
(36086, 'Gifford', 37.7574996948242, 0.658992686995437, -83.1213912963867, -1.45074195696051, 218, 21, 'PPL', 'P'),
(41079, 'Gifford', 32.5933303833008, 0.568860929378904, -93.334716796875, -1.62899811452192, 218, 22, 'PPL', 'P'),
(81214, 'Gifford', 32.8594398498535, 0.573505415740975, -81.2391662597656, -1.417890932808, 218, 48, 'PPL', 'P'),
(94464, 'Gifford', 32.8977813720703, 0.574174601543885, -96.7655563354492, -1.68887756057765, 218, 51, 'PPL', 'P'),
(115730, 'Gifford', 42.288330078125, 0.738070595033432, -93.0902786254883, -1.62473186361367, 218, 16, 'PPL', 'P'),
(119775, 'Gifford', 40.3058280944824, 0.70346940799155, -88.021110534668, -1.53625819009182, 218, 18, 'PPL', 'P'),
(122683, 'Gifford', 41.0708312988281, 0.71682123269569, -87.0524978637695, -1.51935270980811, 218, 19, 'PPL', 'P'),
(139173, 'Gifford', 40.0255584716797, 0.69857778028032, -92.6813888549805, -1.61759539084059, 218, 29, 'PPL', 'P'),
(149117, 'Gifford', 42.7508316040039, 0.746142769455517, -74.0488891601563, -1.29239692328907, 218, 40, 'PPL', 'P'),
(162032, 'Gifford', 41.8580589294434, 0.730560946812599, -78.5966720581055, -1.37177070852417, 218, 45, 'PPL', 'P'),
(194991, 'Gifford', 46.4433288574219, 0.810589004148508, -116.555557250977, -2.03427823552629, 218, 17, 'PPL', 'P'),
(207495, 'Gifford', 48.3063888549805, 0.843105535268103, -118.145278930664, -2.06202411302717, 218, 56, 'PPL', 'P'),
(124916, 'Giffords Corner', 41.6222190856934, 0.726444765031773, -71.0805587768555, -1.24058978481348, 218, 23, 'PPL', 'P'),
(70878, 'Giffordtown', 39.6002807617188, 0.69115528400616, -74.3722229003906, -1.29804016163894, 218, 37, 'PPL', 'P'),
(60032, 'Gift', 34.9455604553223, 0.609915088900102, -88.64111328125, -1.54707927939109, 218, 30, 'PPL', 'P'),
(87244, 'Gift', 35.5522193908691, 0.620503284762039, -89.5644378662109, -1.56319433346327, 218, 50, 'PPL', 'P'),
(207496, 'Gig Harbor', 47.3294410705566, 0.826054579809843, -122.578887939453, -2.13940518797662, 218, 56, 'PPL', 'P'),
(70864, 'Gigantic City', 39.4963912963867, 0.68934207077798, -74.8238906860352, -1.30592325162363, 218, 37, 'PPL', 'P'),
(27256, 'Gila', 39.1127815246582, 0.682646817218493, -88.2602767944336, -1.54043242878441, 218, 18, 'PPL', 'P'),
(54950, 'Gila', 37.4302787780762, 0.653281604616789, -91.3077774047852, -1.59362134839158, 218, 29, 'PPL', 'P'),
(188607, 'Gila', 32.9658317565918, 0.575362304811033, -108.576110839844, -1.89501062316558, 218, 38, 'PPL', 'P'),
(178242, 'Gila Bend', 32.9477806091309, 0.575047252854076, -112.716110229492, -1.9672672435455, 218, 5, 'PPL', 'P'),
(178244, 'Gila Crossing', 33.276668548584, 0.580787430267633, -112.166107177734, -1.95766787939631, 218, 5, 'PPL', 'P'),
(188608, 'Gila Hot Springs', 33.1958312988281, 0.579376554101136, -108.206390380859, -1.88855778384432, 218, 38, 'PPL', 'P'),
(41080, 'Gilark', 32.6386108398438, 0.569651222432385, -93.309440612793, -1.62855696188735, 218, 22, 'PPL', 'P'),
(2713, 'Gilbert', 33.9147186279297, 0.591923504944827, -86.2319412231445, -1.5050312947301, 218, 2, 'PPL', 'P'),
(9107, 'Gilbert', 35.9877815246582, 0.628105278093671, -92.7161102294922, -1.61820139314663, 218, 4, 'PPL', 'P'),
(32543, 'Gilbert', 39.482780456543, 0.689104516808745, -98.0408325195313, -1.71113532886215, 218, 20, 'PPL', 'P'),
(36087, 'Gilbert', 37.5738906860352, 0.655788105255744, -84.5941696166992, -1.47644678780195, 218, 21, 'PPL', 'P'),
(41081, 'Gilbert', 32.0491714477539, 0.559363564299464, -91.6580581665039, -1.59973490098997, 218, 22, 'PPL', 'P'),
(54951, 'Gilbert', 36.0330581665039, 0.628895504568124, -90.0427780151367, -1.5715429440065, 218, 29, 'PPL', 'P'),
(75925, 'Gilbert', 36.7897186279297, 0.642101720939664, -97.9472198486328, -1.70950147953338, 218, 42, 'PPL', 'P'),
(81212, 'Gilbert', 33.9241714477539, 0.592088487774357, -81.3938903808594, -1.42059137815334, 218, 48, 'PPL', 'P'),
(102230, 'Gilbert', 38.1458282470703, 0.665770298811634, -78.3741683959961, -1.36788728702261, 218, 53, 'PPL', 'P'),
(109351, 'Gilbert', 37.6141700744629, 0.656491113204498, -81.8666687011719, -1.42884291647484, 218, 58, 'PPL', 'P'),
(115731, 'Gilbert', 42.1069412231445, 0.7349047622876, -93.6494369506836, -1.63449101742827, 218, 16, 'PPL', 'P'),
(130988, 'Gilbert', 44.375560760498, 0.77449964268949, -85.4186096191406, -1.4908359803297, 218, 27, 'PPL', 'P'),
(135560, 'Gilbert', 47.4888916015625, 0.828837516569949, -92.4647216796875, -1.61381383525073, 218, 28, 'PPL', 'P'),
(149121, 'Gilbert', 42.6688919067383, 0.744712651950144, -76.8550033569336, -1.34137285520979, 218, 40, 'PPL', 'P'),
(155441, 'Gilbert', 40.0213890075684, 0.698505009403534, -81.9766693115234, -1.43076278930468, 218, 41, 'PPL', 'P'),
(162033, 'Gilbert', 40.915828704834, 0.71411592708136, -75.4397201538086, -1.31667150346708, 218, 45, 'PPL', 'P'),
(174250, 'Gilbert', 45.4313888549805, 0.792927319273266, -89.6930618286133, -1.56543924510415, 218, 57, 'PPL', 'P'),
(178245, 'Gilbert', 33.3527793884277, 0.582115815019365, -111.788330078125, -1.95107442516949, 218, 5, 'PPL', 'P'),
(200881, 'Gilbert', 45.4769401550293, 0.793722339437682, -122.530563354492, -2.1385617648594, 218, 43, 'PPL', 'P'),
(207497, 'Gilbert', 48.4569396972656, 0.845733143157629, -120.559173583984, -2.1041545225239, 218, 56, 'PPL', 'P'),
(190238, 'Gilbert (historical)', 38.1961097717285, 0.666647876969842, -117.695831298828, -2.05417977203635, 218, 39, 'PPL', 'P'),
(47409, 'Gilbert Acres', 38.4444389343262, 0.670982038485892, -76.9077835083008, -1.34229404263084, 218, 25, 'PPL', 'P'),
(113466, 'Gilbert Corners', 41.1755599975586, 0.718649093309866, -73.4400024414063, -1.28176984527521, 218, 8, 'PPL', 'P'),
(149120, 'Gilbert Corners', 42.7838897705078, 0.746719743305682, -74.5522232055664, -1.30118175961886, 218, 40, 'PPL', 'P'),
(109353, 'Gilbert Creek', 37.5758285522461, 0.655821927401589, -81.8949966430664, -1.42933733233121, 218, 58, 'PPL', 'P'),
(2714, 'Gilbert Crossroads', 34.3619384765625, 0.59972896378374, -85.9355621337891, -1.49985850378678, 218, 2, 'PPL', 'P'),
(81213, 'Gilbert Crossroads', 33.7249984741211, 0.588612263603477, -79.1680603027344, -1.38174331470013, 218, 48, 'PPL', 'P'),
(102236, 'Gilbert Gardens', 37.5191688537598, 0.654833029109815, -77.3705596923828, -1.35037101074289, 218, 53, 'PPL', 'P'),
(65018, 'Gilbert Green Apartments', 35.2833290100098, 0.615810262289102, -81.5405578613281, -1.42315120859312, 218, 33, 'PPL', 'P'),
(102231, 'Gilbert Heights', 38.1547203063965, 0.665925494524158, -78.3899993896484, -1.36816358998571, 218, 53, 'PPL', 'P'),
(94465, 'Gilbert Landing', 29.7997207641602, 0.520103243509515, -95.0558319091797, -1.65903724003747, 218, 51, 'PPL', 'P'),
(102232, 'Gilbert Mill', 36.5849990844727, 0.638528690863159, -80.245002746582, -1.40053950619975, 218, 53, 'PPL', 'P'),
(149122, 'Gilbert Mills', 43.3147201538086, 0.755984481263905, -76.309440612793, -1.33185098904832, 218, 40, 'PPL', 'P'),
(162037, 'Gilberton', 40.7994384765625, 0.712084534380875, -76.2127838134766, -1.33016400965581, 218, 45, 'PPL', 'P'),
(207498, 'Gilberton', 47.6391716003418, 0.831460397348541, -122.603607177734, -2.13983662007322, 218, 56, 'PPL', 'P'),
(2715, 'Gilbertown', 31.8769397735596, 0.55635755450855, -88.3213882446289, -1.54149902480099, 218, 2, 'PPL', 'P'),
(119776, 'Gilberts', 42.103328704834, 0.734841711948793, -88.3727798461914, -1.54239597745613, 218, 18, 'PPL', 'P'),
(181776, 'Gilberts', 39.0116691589355, 0.680882073522152, -120.47110748291, -2.10261747910076, 218, 6, 'PPL', 'P'),
(102233, 'Gilberts Corner', 38.9688911437988, 0.680135456310549, -77.6227798461914, -1.35477308286674, 218, 53, 'PPL', 'P'),
(149123, 'Gilberts Corner', 43.1549987792969, 0.753196817392864, -78.5205612182617, -1.37044232377244, 218, 40, 'PPL', 'P'),
(16209, 'Gilberts Mill', 30.6341705322266, 0.534667139404777, -85.4925003051758, -1.49212561608757, 218, 12, 'PPL', 'P'),
(172043, 'Gilberts Tannery', 44.8624992370605, 0.782998322360151, -72.7605590820313, -1.26991132157331, 218, 55, 'PPL', 'P'),
(54952, 'Gilbertson Ford (historical)', 37.7911109924316, 0.659579314804554, -92.8405609130859, -1.6203734673317, 218, 29, 'PPL', 'P'),
(36088, 'Gilbertsville', 37.0244407653809, 0.646198395065505, -88.2997207641602, -1.5411208559262, 218, 21, 'PPL', 'P'),
(149124, 'Gilbertsville', 42.4713897705078, 0.7412655893932, -75.3261108398438, -1.31468864687746, 218, 40, 'PPL', 'P'),
(162035, 'Gilbertsville', 40.3199996948242, 0.703716749077791, -75.6105575561523, -1.31965317862354, 218, 45, 'PPL', 'P'),
(115732, 'Gilbertville', 42.4161109924316, 0.740300792709292, -92.2147216796875, -1.60945051212074, 218, 16, 'PPL', 'P'),
(124917, 'Gilbertville', 42.3125, 0.738492439750101, -72.2083282470703, -1.2602730752722, 218, 23, 'PPL', 'P'),
(127562, 'Gilbertville', 44.4569396972656, 0.775919973077856, -70.3072204589844, -1.2270924849348, 218, 26, 'PPL', 'P'),
(27257, 'Gilbirds', 39.9230613708496, 0.696788868397087, -90.7013931274414, -1.58303794621961, 218, 18, 'PPL', 'P'),
(47429, 'Gilboa', 39.3886108398438, 0.687460946942002, -77.123893737793, -1.34606587768272, 218, 25, 'PPL', 'P'),
(109352, 'Gilboa', 38.3033294677734, 0.668519213688814, -80.9366683959961, -1.41261134910497, 218, 58, 'PPL', 'P'),
(143860, 'Gilboa', 42.9952812194824, 0.750409220100851, -72.3905563354492, -1.26345355540403, 218, 36, 'PPL', 'P'),
(149125, 'Gilboa', 42.3972206115723, 0.73997109336634, -74.4463882446289, -1.29933459108678, 218, 40, 'PPL', 'P'),
(155442, 'Gilboa', 41.0180587768555, 0.715900178432686, -83.9219436645508, -1.46471423161961, 218, 41, 'PPL', 'P'),
(87245, 'Gilbreath', 36.2366714477539, 0.632449226726726, -82.9802780151367, -1.4482790655844, 218, 50, 'PPL', 'P'),
(94466, 'Gilbreth', 32.896110534668, 0.574145439929948, -95.559440612793, -1.66782687005723, 218, 51, 'PPL', 'P'),
(94467, 'Gilburg', 30.1436100006104, 0.526105242947741, -94.170280456543, -1.64358145149314, 218, 51, 'PPL', 'P'),
(140086, 'Gilby', 48.0852813720703, 0.839246481690524, -97.4702835083008, -1.70117737007218, 218, 34, 'PPL', 'P'),
(16213, 'Gilchrist', 26.7749996185303, 0.467311900563579, -81.8925018310547, -1.42929378964739, 218, 12, 'PPL', 'P'),
(87246, 'Gilchrist', 35.2055587768555, 0.614452915660516, -88.4261093139648, -1.54332675225711, 218, 50, 'PPL', 'P'),
(94468, 'Gilchrist', 29.5122203826904, 0.515085415252129, -94.4888916015625, -1.64914226500728, 218, 51, 'PPL', 'P'),
(119778, 'Gilchrist', 41.2052803039551, 0.719167810511186, -90.6241683959961, -1.58169012039192, 218, 18, 'PPL', 'P'),
(130989, 'Gilchrist', 46.1427803039551, 0.805343442328406, -85.3847198486328, -1.4902444922516, 218, 27, 'PPL', 'P'),
(200882, 'Gilchrist', 43.4772186279297, 0.758820614666785, -121.684173583984, -2.12378947660884, 218, 43, 'PPL', 'P'),
(194200, 'Gilcrest', 40.2819404602051, 0.703052490122899, -104.777221679688, -1.82870749940253, 218, 7, 'PPL', 'P'),
(54953, 'Gildehouse', 38.4847183227539, 0.671685046434645, -90.9383316040039, -1.58717330276028, 218, 29, 'PPL', 'P'),
(113467, 'Gildersleeve', 41.5966682434082, 0.725998818707239, -72.6213912963867, -1.2674823855011, 218, 8, 'PPL', 'P'),
(87247, 'Gildfield', 35.3044395446777, 0.616178710625914, -89.7861099243164, -1.56706324073688, 218, 50, 'PPL', 'P'),
(196589, 'Gildford', 48.5694389343262, 0.847696625250318, -110.298889160156, -1.92507877713701, 218, 31, 'PPL', 'P'),
(196590, 'Gildford Colony', 48.7874984741211, 0.851502482185123, -110.27082824707, -1.92458902181254, 218, 31, 'PPL', 'P'),
(149127, 'Gile', 44.6127815246582, 0.778639926078181, -74.4986114501953, -1.30024605796986, 218, 40, 'PPL', 'P'),
(174251, 'Gile', 46.4283294677734, 0.810327215413353, -90.2249984741211, -1.57472329098027, 218, 57, 'PPL', 'P'),
(27258, 'Gilead', 39.1241683959961, 0.682845555614841, -90.6672210693359, -1.58244153129349, 218, 18, 'PPL', 'P'),
(41082, 'Gilead', 30.7941703796387, 0.537459663544807, -90.8619384765625, -1.58583999116054, 218, 22, 'PPL', 'P'),
(65019, 'Gilead', 35.4524993896484, 0.618762842410645, -76.9852828979492, -1.3436466621485, 218, 33, 'PPL', 'P'),
(113468, 'Gilead', 41.6733283996582, 0.727336790838895, -72.4088897705078, -1.263773534209, 218, 8, 'PPL', 'P'),
(115733, 'Gilead', 41.1725006103516, 0.71859569693001, -94.585563659668, -1.6508295107159, 218, 16, 'PPL', 'P'),
(122685, 'Gilead', 40.9702796936035, 0.715066276116355, -86.0186080932617, -1.50130792921006, 218, 19, 'PPL', 'P'),
(127563, 'Gilead', 44.3941688537598, 0.774824415184425, -70.9733276367188, -1.23871824835743, 218, 26, 'PPL', 'P'),
(130990, 'Gilead', 41.8008308410645, 0.729562128245765, -85.1555633544922, -1.48624495692652, 218, 27, 'PPL', 'P'),
(139174, 'Gilead', 40.0194396972656, 0.698470987520608, -91.6813888549805, -1.60014209832064, 218, 29, 'PPL', 'P'),
(141898, 'Gilead', 40.1463890075684, 0.700686670968527, -97.4127807617188, -1.70017375781538, 218, 35, 'PPL', 'P'),
(211, 'Giles', 33.2313919067383, 0.579997203793179, -87.1508331298828, -1.52106898397261, 218, 2, 'PPL', 'P'),
(60035, 'Giles', 32.8308296203613, 0.573006073036585, -88.379997253418, -1.54252194497569, 218, 30, 'PPL', 'P'),
(109355, 'Giles', 38.1341705322266, 0.665566833304352, -81.4475021362305, -1.42152707980234, 218, 58, 'PPL', 'P'),
(191525, 'Giles', 34.8188896179199, 0.607704265721173, -100.585563659668, -1.75554926583556, 218, 51, 'PPL', 'P'),
(102235, 'Giles Mill', 37.4819412231445, 0.654183284382863, -77.9677810668945, -1.36079449009141, 218, 53, 'PPL', 'P'),
(87250, 'Giles Town', 35.3244400024414, 0.616527784465796, -90.0430603027344, -1.57154787085452, 218, 50, 'PPL', 'P'),
(87249, 'Gileston (historical)', 35.3666687011719, 0.617264814297476, -87.0166702270508, -1.51872739958416, 218, 50, 'PPL', 'P'),
(135563, 'Gilfillan', 44.459171295166, 0.775958921808799, -94.9941711425781, -1.65796105664097, 218, 28, 'PPL', 'P'),
(127565, 'Gilford', 45.3641700744629, 0.791754130234059, -68.6688919067383, -1.19849825746867, 218, 26, 'PPL', 'P'),
(130992, 'Gilford', 43.4941711425781, 0.759116491863892, -83.621940612793, -1.4594781906004, 218, 27, 'PPL', 'P'),
(143861, 'Gilford', 43.5475006103516, 0.760047266664875, -71.4072189331055, -1.24629108007512, 218, 36, 'PPL', 'P'),
(70865, 'Gilford Park', 39.9486083984375, 0.697234748142593, -74.1374969482422, -1.29394342093407, 218, 37, 'PPL', 'P'),
(162036, 'Gilfoyle', 41.4391708374023, 0.723249970409087, -79.1819381713867, -1.38198552920128, 218, 45, 'PPL', 'P'),
(81215, 'Gilgal', 34.2769393920898, 0.598245449898511, -82.3494415283203, -1.43726889184774, 218, 48, 'PPL', 'P'),
(149128, 'Gilgo Beach', 40.6183280944824, 0.708923561904033, -73.398063659668, -1.2810378754496, 218, 40, 'PPL', 'P'),
(9109, 'Gilkerson', 35.8038902282715, 0.624895769505962, -90.8063888549805, -1.58487046736569, 218, 4, 'PPL', 'P'),
(109354, 'Gilkerson', 38.2083282470703, 0.66686112959413, -82.3238906860352, -1.43682294552321, 218, 58, 'PPL', 'P'),
(162038, 'Gilkeson', 40.2208290100098, 0.701985894106322, -80.1061096191406, -1.3981153638175, 218, 45, 'PPL', 'P'),
(65020, 'Gilkey', 35.4425010681152, 0.618588338780218, -81.9780578613281, -1.4307870240706, 218, 33, 'PPL', 'P'),
(318, 'Gilkey (historical)', 34.9991683959961, 0.610850723970074, -93.3755569458008, -1.62971090958768, 218, 4, 'PPL', 'P'),
(9111, 'Gill', 34.877498626709, 0.608727185895872, -90.9075012207031, -1.58663521106203, 218, 4, 'PPL', 'P'),
(21387, 'Gill', 33.9347190856934, 0.592272578784709, -82.6222229003906, -1.44202982492848, 218, 13, 'PPL', 'P'),
(54954, 'Gill', 36.2191696166992, 0.632143762149694, -89.789436340332, -1.56712129764864, 218, 29, 'PPL', 'P'),
(60034, 'Gill', 32.6794395446777, 0.570363817761063, -89.5316696166992, -1.56262241961917, 218, 30, 'PPL', 'P'),
(65022, 'Gill', 36.2658309936523, 0.63295815681104, -78.408332824707, -1.36848356879068, 218, 33, 'PPL', 'P'),
(94469, 'Gill', 32.3927803039551, 0.565360670179186, -94.3408279418945, -1.64655806664353, 218, 51, 'PPL', 'P'),
(109356, 'Gill', 38.0877799987793, 0.664757165753941, -82.1213912963867, -1.43328866444056, 218, 58, 'PPL', 'P'),
(124918, 'Gill', 42.6402816772461, 0.744213309245754, -72.5, -1.26536370769589, 218, 23, 'PPL', 'P'),
(194201, 'Gill', 40.4541702270508, 0.706058466624298, -104.54167175293, -1.82459637762777, 218, 7, 'PPL', 'P'),
(47410, 'Gill Estates', 39.4605598449707, 0.688716693975002, -76.9119415283203, -1.34236661377055, 218, 25, 'PPL', 'P'),
(162039, 'Gill Hall', 40.2991714477539, 0.703353227588996, -79.9622192382813, -1.39560400290956, 218, 45, 'PPL', 'P'),
(124919, 'Gill Station', 42.6500015258789, 0.744382952607192, -72.4644393920898, -1.26474305800385, 218, 23, 'PPL', 'P'),
(9112, 'Gillam Park', 34.7066688537598, 0.605745643897474, -92.2558288574219, -1.61016796771841, 218, 4, 'PPL', 'P'),
(75927, 'Gilland', 36.5330581665039, 0.637622150828096, -96.1538925170898, -1.67820201303196, 218, 42, 'PPL', 'P'),
(65023, 'Gillburg', 36.2763900756836, 0.633142447558474, -78.3686065673828, -1.36779021480088, 218, 33, 'PPL', 'P'),
(47411, 'Gillcrest', 39.6208305358887, 0.691513945225967, -76.6616668701172, -1.3379984969506, 218, 25, 'PPL', 'P'),
(21388, 'Gilleland', 34.2208290100098, 0.597266138986662, -83.845832824707, -1.46338584686788, 218, 13, 'PPL', 'P'),
(47412, 'Gillens Grove', 38.3661117553711, 0.669614971319327, -76.6055603027344, -1.33701925261778, 218, 25, 'PPL', 'P'),
(87251, 'Gillentine (historical)', 35.6380615234375, 0.622001512612291, -85.4569396972656, -1.49150496639553, 218, 50, 'PPL', 'P'),
(87252, 'Gillenwater (historical)', 36.4847183227539, 0.636778461394759, -82.9630584716797, -1.44797852785539, 218, 50, 'PPL', 'P'),
(27260, 'Gillespie', 39.1297187805176, 0.682942428099492, -89.8194427490234, -1.56764500827701, 218, 18, 'PPL', 'P'),
(102238, 'Gillespie', 37.0916709899902, 0.647371783841794, -81.6708297729492, -1.42542488237378, 218, 53, 'PPL', 'P'),
(109357, 'Gillespie', 38.6636085510254, 0.674807269917627, -80.6180572509766, -1.40705053559083, 218, 58, 'PPL', 'P'),
(145292, 'Gillespie', 40.4519386291504, 0.706019517893356, -74.3563919067383, -1.29776385867585, 218, 37, 'PPL', 'P'),
(162040, 'Gillespie', 40.0833282470703, 0.699586053069024, -79.8288879394531, -1.39327693274905, 218, 45, 'PPL', 'P'),
(178246, 'Gillespie', 33.2616691589355, 0.580525641532478, -112.980560302734, -1.97188276803072, 218, 5, 'PPL', 'P'),
(81216, 'Gillespie (historical)', 34.6252784729004, 0.604325113772026, -79.9888916015625, -1.39606952346811, 218, 48, 'PPL', 'P'),
(47413, 'Gillespie Mobile Home Court', 38.651668548584, 0.674598877562328, -76.8847198486328, -1.34189150583208, 218, 25, 'PPL', 'P'),
(130994, 'Gillet Landing', 46.8711090087891, 0.818055176264545, -87.7783279418945, -1.5320208344814, 218, 27, 'PPL', 'P'),
(181777, 'Gillete', 36.1738891601563, 0.631353469096213, -119.035278320313, -2.07755753271728, 218, 6, 'PPL', 'P'),
(9113, 'Gillett', 34.1172218322754, 0.595457852606498, -91.3763885498047, -1.59481883877574, 218, 4, 'PPL', 'P'),
(112589, 'Gillett', 29.128059387207, 0.508380541023205, -97.7847213745117, -1.7066653461305, 218, 51, 'PPL', 'P'),
(162041, 'Gillett', 41.9511108398438, 0.732185009024357, -76.7947235107422, -1.34032077342115, 218, 45, 'PPL', 'P'),
(174252, 'Gillett', 44.8899993896484, 0.78347829056761, -88.3072204589844, -1.54125175029378, 218, 57, 'PPL', 'P'),
(186759, 'Gillett (historical)', 38.7819404602051, 0.676872551342984, -105.122222900391, -1.8347289066272, 218, 7, 'PPL', 'P'),
(124921, 'Gillett Corner', 42.0255584716797, 0.733484365320207, -72.7861099243164, -1.27035726789784, 218, 23, 'PPL', 'P'),
(115734, 'Gillett Grove', 43.0158309936523, 0.750767881320657, -95.0372161865234, -1.65871233438448, 218, 16, 'PPL', 'P'),
(16211, 'Gillette', 27.600830078125, 0.481725361146765, -82.5272216796875, -1.44037174083379, 218, 12, 'PPL', 'P'),
(72664, 'Gillette', 38.4605598449707, 0.671263401455059, -82.3255615234375, -1.43685210713714, 218, 41, 'PPL', 'P'),
(145293, 'Gillette', 40.6738891601563, 0.709893285435958, -74.4663925170898, -1.29968373150569, 218, 37, 'PPL', 'P'),
(178247, 'Gillette', 34.0188903808594, 0.593741645021024, -112.162780761719, -1.95760982248455, 218, 5, 'PPL', 'P'),
(209472, 'Gillette', 44.2911109924316, 0.773025716184185, -105.501670837402, -1.84135152246795, 218, 59, 'PPL', 'P'),
(119779, 'Gilletts', 41.517219543457, 0.724612177306662, -87.9369430541992, -1.53478919043453, 218, 18, 'PPL', 'P'),
(36089, 'Gilley', 36.9741706848145, 0.645321016644379, -83.1122207641602, -1.45058190097899, 218, 21, 'PPL', 'P'),
(102239, 'Gilley', 37.0991706848145, 0.647502678209372, -82.6750030517578, -1.44295101234953, 218, 53, 'PPL', 'P'),
(41084, 'Gilleyville', 32.3027801513672, 0.56378987118923, -91.8944396972656, -1.60386053699267, 218, 22, 'PPL', 'P'),
(9114, 'Gillham', 34.1691703796387, 0.596364525799616, -94.3161087036133, -1.64612663454693, 218, 4, 'PPL', 'P'),
(41083, 'Gilliam', 32.8269386291504, 0.572938162428788, -93.8450012207031, -1.63790425783937, 218, 22, 'PPL', 'P'),
(54955, 'Gilliam', 39.2333297729492, 0.684750781058683, -93.0044403076172, -1.62323370234245, 218, 29, 'PPL', 'P'),
(109363, 'Gilliam', 37.4238891601563, 0.653170084746142, -81.415283203125, -1.42096475333817, 218, 58, 'PPL', 'P'),
(193250, 'Gilliam', 46.127498626709, 0.805076726745235, -118.17749786377, -2.06258643949134, 218, 56, 'PPL', 'P'),
(193588, 'Gilliam Place', 40.1372184753418, 0.700526614987013, -122.586936950684, -2.13954566972413, 218, 6, 'PPL', 'P'),
(81217, 'Gilliam Spring (historical)', 34.4161109924316, 0.600674452549745, -81.4652786254883, -1.42183733806933, 218, 48, 'PPL', 'P'),
(102240, 'Gilliamsville', 37.6674995422363, 0.657421888005481, -78.2602767944336, -1.36589950358498, 218, 53, 'PPL', 'P'),
(9115, 'Gillian Settlement', 35.6316719055176, 0.621889992741644, -93.4016723632813, -1.63016670960825, 218, 4, 'PPL', 'P'),
(81218, 'Gilliard', 33.5141716003418, 0.584932640504341, -79.2102813720703, -1.38248021137376, 218, 48, 'PPL', 'P'),
(115736, 'Gilliatt', 41.2911109924316, 0.720665838624356, -95.7583312988281, -1.67129816738009, 218, 16, 'PPL', 'P'),
(102241, 'Gillick Corner', 37.892219543457, 0.661343991921868, -76.5013885498047, -1.33520111254158, 218, 53, 'PPL', 'P'),
(21389, 'Gillicon', 31.0244407653809, 0.541478639945846, -82.774169921875, -1.44468180074198, 218, 13, 'PPL', 'P'),
(94471, 'Gilliland', 33.7313919067383, 0.588723850053151, -99.6830596923828, -1.73979760009413, 218, 51, 'PPL', 'P'),
(145294, 'Gillilandtown', 40.3969383239746, 0.705059581478437, -74.4199981689453, -1.29887399737625, 218, 37, 'PPL', 'P'),
(162042, 'Gillingham', 41.1172218322754, 0.717630900246101, -78.3130569458008, -1.36682069100604, 218, 45, 'PPL', 'P'),
(174255, 'Gillingham', 43.4263916015625, 0.757933515707679, -90.4449996948242, -1.57856303663995, 218, 57, 'PPL', 'P'),
(162043, 'Gillintown', 41.0327796936035, 0.716157106898851, -77.9899978637695, -1.36118224634612, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(21390, 'Gillionville', 31.5869407653809, 0.551296116988314, -84.4333267211914, -1.4736395496969, 218, 13, 'PPL', 'P'),
(21391, 'Gillionville Forest', 31.5883293151855, 0.551320351754233, -84.279167175293, -1.47094895804759, 218, 13, 'PPL', 'P'),
(41085, 'Gillis', 30.3736095428467, 0.530119492237844, -93.2008285522461, -1.62666132382343, 218, 22, 'PPL', 'P'),
(94472, 'Gillis', 33.0261116027832, 0.576414386599669, -94.7638931274414, -1.65394194708188, 218, 51, 'PPL', 'P'),
(193589, 'Gillis', 41.9583282470703, 0.732310976543918, -122.095832824707, -2.13097428575571, 218, 6, 'PPL', 'P'),
(47414, 'Gillis Falls Estates', 39.4222183227539, 0.688047508172092, -77.0802764892578, -1.34530461308512, 218, 25, 'PPL', 'P'),
(21392, 'Gillis Place', 32.1713905334473, 0.56149668975359, -84.9761123657227, -1.48311294632653, 218, 13, 'PPL', 'P'),
(21393, 'Gillis Springs', 32.459171295166, 0.566519411569479, -82.4916687011719, -1.4397512242998, 218, 13, 'PPL', 'P'),
(87253, 'Gillises Mills', 35.1355590820313, 0.613231190510442, -88.0352783203125, -1.53650546459904, 218, 50, 'PPL', 'P'),
(81219, 'Gillisonville', 32.6108283996582, 0.569166327376909, -81.0038909912109, -1.4137846047232, 218, 48, 'PPL', 'P'),
(72665, 'Gillivan', 39.9886093139648, 0.697932895822357, -83.3369369506836, -1.45450393831635, 218, 41, 'PPL', 'P'),
(109358, 'Gillman Bottom', 37.7286109924316, 0.658488484022058, -81.7941665649414, -1.42757751548289, 218, 58, 'PPL', 'P'),
(36090, 'Gillmore', 37.7372207641602, 0.658638752886565, -83.3694381713867, -1.45507119162854, 218, 21, 'PPL', 'P'),
(109359, 'Gillooly', 38.9775009155273, 0.680285725175056, -80.5702819824219, -1.40621669985353, 218, 58, 'PPL', 'P'),
(102243, 'Gills', 36.6713905334473, 0.640036506093335, -78.2888870239258, -1.36639884628937, 218, 53, 'PPL', 'P'),
(102244, 'Gills Corner', 36.8605613708496, 0.64333816005476, -78.0352783203125, -1.3619725393996, 218, 53, 'PPL', 'P'),
(41086, 'Gills Ferry', 32.7180595397949, 0.571037863832962, -92.522216796875, -1.61481731434947, 218, 22, 'PPL', 'P'),
(174256, 'Gills Landing', 44.3027801513672, 0.773229381428549, -88.8833312988281, -1.55130678130548, 218, 57, 'PPL', 'P'),
(174257, 'Gills Rock', 45.2900009155273, 0.790459634207198, -87.0216674804688, -1.51881461810986, 218, 57, 'PPL', 'P'),
(60036, 'Gillsburg', 31.0249996185303, 0.541488393773338, -90.6558303833008, -1.58224272631811, 218, 30, 'PPL', 'P'),
(21394, 'Gillsville', 34.3077812194824, 0.598783741333844, -83.6336135864258, -1.45968192242379, 218, 13, 'PPL', 'P'),
(192585, 'Gilluly', 39.9305610656738, 0.696919762764664, -111.164169311523, -1.94018076473052, 218, 52, 'PPL', 'P'),
(119780, 'Gillum', 40.4077796936035, 0.705248799073887, -88.8994369506836, -1.55158787795854, 218, 18, 'PPL', 'P'),
(102246, 'Gilman', 37.7783317565918, 0.65935627506326, -77.5808334350586, -1.35404097988307, 218, 53, 'PPL', 'P'),
(109360, 'Gilman', 38.9730606079102, 0.680208227187335, -79.8399963378906, -1.39347081087641, 218, 58, 'PPL', 'P'),
(113469, 'Gilman', 41.5769386291504, 0.725654471978292, -72.1997222900391, -1.26012287298672, 218, 8, 'PPL', 'P'),
(115737, 'Gilman', 41.8788909912109, 0.730924534880423, -92.7891693115234, -1.61947651467656, 218, 16, 'PPL', 'P'),
(119781, 'Gilman', 40.7666702270508, 0.71151262053678, -87.9922180175781, -1.53575392053942, 218, 18, 'PPL', 'P'),
(135565, 'Gilman', 45.735279083252, 0.79823120432124, -93.9488906860352, -1.63971747106755, 218, 28, 'PPL', 'P'),
(172044, 'Gilman', 44.4122200012207, 0.775139467141381, -71.7227783203125, -1.25179863036746, 218, 55, 'PPL', 'P'),
(174258, 'Gilman', 45.1666717529297, 0.788307134256142, -90.807502746582, -1.58488990844165, 218, 57, 'PPL', 'P'),
(177698, 'Gilman', 39.5327796936035, 0.689977168118936, -106.393333435059, -1.85691397061394, 218, 7, 'PPL', 'P'),
(188610, 'Gilman', 35.7161102294922, 0.623363719509866, -106.759437561035, -1.86330369301737, 218, 38, 'PPL', 'P'),
(196591, 'Gilman', 47.5091705322266, 0.82919145067882, -112.364440917969, -1.96112945618119, 218, 31, 'PPL', 'P'),
(139175, 'Gilman City', 40.1416702270508, 0.700604312711816, -93.8722229003906, -1.63837936577784, 218, 29, 'PPL', 'P'),
(127566, 'Gilman Corner', 45.0963897705078, 0.787080482258051, -69.2697219848633, -1.20898472057697, 218, 26, 'PPL', 'P'),
(181779, 'Gilman Hot Springs', 33.8358306884766, 0.590546650661256, -116.988059997559, -2.04182683247807, 218, 6, 'PPL', 'P'),
(143863, 'Gilman Mobile Park', 44.3086090087891, 0.77333111418219, -71.7536087036133, -1.25233672206571, 218, 36, 'PPL', 'P'),
(81220, 'Gilmania', 32.6116714477539, 0.569181041341932, -80.9108276367188, -1.41216034277436, 218, 48, 'PPL', 'P'),
(143864, 'Gilmans Corner', 43.9025001525879, 0.766243177519972, -71.9902801513672, -1.25646741807448, 218, 36, 'PPL', 'P'),
(143865, 'Gilmanton', 43.4241714477539, 0.757894766713819, -71.4150009155273, -1.24642690129072, 218, 36, 'PPL', 'P'),
(174261, 'Gilmanton', 44.4708290100098, 0.776162387316081, -91.6758270263672, -1.60004502609891, 218, 57, 'PPL', 'P'),
(143866, 'Gilmanton Ironworks', 43.4172210693359, 0.757773459726165, -71.2977828979492, -1.24438106094132, 218, 36, 'PPL', 'P'),
(149129, 'Gilmantown', 43.438060760498, 0.758137180952043, -74.3163909912109, -1.29706571099608, 218, 40, 'PPL', 'P'),
(94473, 'Gilmer', 32.7286109924316, 0.571222021422341, -94.9422225952148, -1.65705438344785, 218, 51, 'PPL', 'P'),
(109361, 'Gilmer', 38.8791694641113, 0.678569517589582, -80.7169418334961, -1.40877639713526, 218, 58, 'PPL', 'P'),
(119782, 'Gilmer', 42.2350006103516, 0.737139820232449, -88.0461120605469, -1.53669454903643, 218, 18, 'PPL', 'P'),
(207499, 'Gilmer', 45.8713912963867, 0.800606810592618, -121.464172363281, -2.11994973094916, 218, 56, 'PPL', 'P'),
(81221, 'Gilmer Estates', 34.5294418334961, 0.602652448870375, -82.7102813720703, -1.44356673519356, 218, 48, 'PPL', 'P'),
(122687, 'Gilmer Park', 41.6197204589844, 0.726401155768923, -86.2516708374023, -1.50537564145905, 218, 19, 'PPL', 'P'),
(102248, 'Gilmerton', 36.7708282470703, 0.641772021596712, -76.3122177124023, -1.33189945858016, 218, 53, 'PPL', 'P'),
(47415, 'Gilmor Homes', 39.3050003051758, 0.686001667822693, -76.6444396972656, -1.33769782606353, 218, 25, 'PPL', 'P'),
(2716, 'Gilmore', 33.5163917541504, 0.584971389498202, -87.1466674804688, -1.52099627967485, 218, 2, 'PPL', 'P'),
(9117, 'Gilmore', 35.4116706848145, 0.618050247081967, -90.2783279418945, -1.57565406578126, 218, 4, 'PPL', 'P'),
(16212, 'Gilmore', 30.3649997711182, 0.529969223373337, -81.5569381713867, -1.42343709893614, 218, 12, 'PPL', 'P'),
(21396, 'Gilmore', 33.8480606079102, 0.590760103022626, -84.4941711425781, -1.47470148518157, 218, 13, 'PPL', 'P'),
(27264, 'Gilmore', 38.9874992370605, 0.680460228805484, -88.7174987792969, -1.54841245783278, 218, 18, 'PPL', 'P'),
(47416, 'Gilmore', 39.5827789306641, 0.690849819429128, -78.9502792358398, -1.37794231803432, 218, 25, 'PPL', 'P'),
(54957, 'Gilmore', 38.8102798461914, 0.677367166936439, -90.8061065673828, -1.58486554051768, 218, 29, 'PPL', 'P'),
(60037, 'Gilmore', 31.7797203063965, 0.55466075470952, -89.4916687011719, -1.56192427193941, 218, 30, 'PPL', 'P'),
(75928, 'Gilmore', 35.0527801513672, 0.611786425619074, -94.5227813720703, -1.64973375308539, 218, 42, 'PPL', 'P'),
(87255, 'Gilmore', 35.6877784729004, 0.622869237074466, -88.8069381713867, -1.54997346970573, 218, 50, 'PPL', 'P'),
(141903, 'Gilmore', 41.1444396972656, 0.718105941605544, -95.9511108398438, -1.6746628051013, 218, 35, 'PPL', 'P'),
(155444, 'Gilmore', 40.290828704834, 0.703207619256396, -81.440559387207, -1.42140590597274, 218, 41, 'PPL', 'P'),
(162044, 'Gilmore', 41.9708290100098, 0.732529156016222, -78.5661087036133, -1.37123727735783, 218, 45, 'PPL', 'P'),
(194992, 'Gilmore', 44.4588890075684, 0.775953994960782, -113.268890380859, -1.97691507722653, 218, 17, 'PPL', 'P'),
(115739, 'Gilmore City', 42.7294387817383, 0.745769394270688, -94.4475021362305, -1.6484198825616, 218, 16, 'PPL', 'P'),
(72666, 'Gilmore Heights', 38.8486099243164, 0.678036153002266, -82.1463928222656, -1.43372502338517, 218, 41, 'PPL', 'P'),
(141907, 'Gilmore Junction', 41.1500015258789, 0.718203013827277, -95.9347229003906, -1.67437678160022, 218, 35, 'PPL', 'P'),
(102249, 'Gilmore Mills', 37.6086082458496, 0.656394040982765, -79.5416717529297, -1.38826406462919, 218, 53, 'PPL', 'P'),
(2717, 'Gilmore Quarters', 32.6311111450195, 0.569520328064808, -87.7794418334961, -1.53204027555736, 218, 2, 'PPL', 'P'),
(29894, 'Gilmour', 39.1313896179199, 0.682971589713429, -87.2408294677734, -1.52263971638354, 218, 19, 'PPL', 'P'),
(47417, 'Gilnock Hall', 38.7324981689453, 0.676009620570771, -76.0869369506836, -1.32796756754676, 218, 25, 'PPL', 'P'),
(211846, 'Gilpatricks', 60.601390838623, 1.0576938014219, -149.537506103516, -2.60992183672746, 218, 1, 'PPL', 'P'),
(36091, 'Gilpin', 37.2566719055176, 0.650251593086551, -84.8819427490234, -1.48146937645979, 218, 21, 'PPL', 'P'),
(47418, 'Gilpin', 39.6966705322266, 0.692837602866763, -78.5569381713867, -1.37107722137631, 218, 25, 'PPL', 'P'),
(162045, 'Gilpin', 40.7083282470703, 0.710494360893989, -79.1002807617188, -1.38056033854392, 218, 45, 'PPL', 'P'),
(186761, 'Gilpin', 39.8908309936523, 0.696226342195835, -105.507499694824, -1.8414532552216, 218, 7, 'PPL', 'P'),
(190240, 'Gilpin', 39.5980606079102, 0.6911165350123, -119.334716796875, -2.08278372004045, 218, 39, 'PPL', 'P'),
(191526, 'Gilpin', 33.4150009155273, 0.583201785532872, -100.716110229492, -1.75782773330618, 218, 51, 'PPL', 'P'),
(47419, 'Gilpin Farms', 39.6263885498047, 0.691610950868673, -75.8249969482422, -1.32339585206148, 218, 25, 'PPL', 'P'),
(36092, 'Gilreath', 36.6805610656738, 0.640196562074848, -84.3997192382813, -1.47305298846681, 218, 21, 'PPL', 'P'),
(65025, 'Gilreath', 36.0497207641602, 0.629186321759161, -81.07861328125, -1.41508875470902, 218, 33, 'PPL', 'P'),
(87256, 'Gilreath Mill', 36.5544395446777, 0.637995326275843, -85.0325012207031, -1.48409711750737, 218, 50, 'PPL', 'P'),
(181780, 'Gilroy', 37.0058288574219, 0.645873555991543, -121.567222595215, -2.12174829679135, 218, 6, 'PPL', 'P'),
(196592, 'Gilroy', 45.6599998474121, 0.79691733379745, -111.164169311523, -1.94018076473052, 218, 31, 'PPL', 'P'),
(87257, 'Gilroy (historical)', 36.0041694641113, 0.628391301594745, -86.6266708374023, -1.51192062615402, 218, 50, 'PPL', 'P'),
(119783, 'Gilson', 40.8616714477539, 0.713170704631464, -90.2013931274414, -1.57431129995964, 218, 18, 'PPL', 'P'),
(94474, 'Gilson Groves', 28.2691707611084, 0.493390106589853, -99.7552795410156, -1.74105807423806, 218, 51, 'PPL', 'P'),
(186764, 'Gilson Gulch', 39.7616691589355, 0.69397204291211, -105.507499694824, -1.8414532552216, 218, 7, 'PPL', 'P'),
(186763, 'Gilsonite', 39.1769409179688, 0.683766609877844, -108.778060913086, -1.8985353168683, 218, 7, 'PPL', 'P'),
(36093, 'Gilstrap', 37.3152809143066, 0.651274513261251, -86.706672668457, -1.51331692151355, 218, 21, 'PPL', 'P'),
(81223, 'Gilstrap', 34.6991691589355, 0.605614749529897, -82.9869384765625, -1.44839531256598, 218, 48, 'PPL', 'P'),
(81222, 'Gilstrap Heights', 34.8880615234375, 0.608911543222333, -82.3691711425781, -1.43761323857669, 218, 48, 'PPL', 'P'),
(143868, 'Gilsum', 43.0483283996582, 0.751335068053817, -72.2633285522461, -1.26123301168712, 218, 36, 'PPL', 'P'),
(87258, 'Gilt Edge', 35.5511093139648, 0.620483910265109, -89.8244400024414, -1.56773222680271, 218, 50, 'PPL', 'P'),
(115740, 'Gilt Edge', 42.4408302307129, 0.740732224805885, -91.204719543457, -1.59182264939134, 218, 16, 'PPL', 'P'),
(193590, 'Gilta (historical)', 41.1955604553223, 0.718998167149748, -123.323890686035, -2.15240793884088, 218, 6, 'PPL', 'P'),
(196593, 'Giltedge', 47.1269416809082, 0.822520298727199, -109.201393127441, -1.90592385783856, 218, 31, 'PPL', 'P'),
(141908, 'Giltner', 40.7738914489746, 0.711638654635368, -98.1533279418945, -1.71309874437581, 218, 35, 'PPL', 'P'),
(60038, 'Gilton', 34.7194404602051, 0.605968550480714, -89.4480590820313, -1.56116314049986, 218, 30, 'PPL', 'P'),
(162047, 'Gimberlings Mill', 40.6333312988281, 0.709185417218215, -77.2058334350586, -1.3474959951881, 218, 45, 'PPL', 'P'),
(122698, 'Gimco City', 40.2583312988281, 0.702640432523236, -85.6838912963867, -1.49546601904286, 218, 19, 'PPL', 'P'),
(36094, 'Gimlet', 38.2188911437988, 0.667045486920591, -83.1374969482422, -1.45102305361356, 218, 21, 'PPL', 'P'),
(194993, 'Gimlet', 43.6041717529297, 0.76103636469373, -114.348892211914, -1.995764665106, 218, 17, 'PPL', 'P'),
(9118, 'Gin (historical)', 33.5741691589355, 0.585979795444961, -92.1786117553711, -1.60882027504878, 218, 4, 'PPL', 'P'),
(60039, 'Gin (historical)', 31.9155597686768, 0.557031600580449, -88.6305618286133, -1.54689512180171, 218, 30, 'PPL', 'P'),
(9119, 'Gin City', 33.1069412231445, 0.577825129608111, -93.7227783203125, -1.63577106580621, 218, 4, 'PPL', 'P'),
(130997, 'Gingellville', 42.7216682434082, 0.745633772792175, -83.3077774047852, -1.45399500823204, 218, 27, 'PPL', 'P'),
(94475, 'Ginger', 32.8497200012207, 0.573335772379537, -95.7194366455078, -1.67061932761823, 218, 51, 'PPL', 'P'),
(207501, 'Ginger', 46.6808280944824, 0.814734147806189, -119.504722595215, -2.08575088096896, 218, 56, 'PPL', 'P'),
(54958, 'Ginger Blue', 36.5886116027832, 0.638591741201967, -94.460563659668, -1.64864784915091, 218, 29, 'PPL', 'P'),
(47421, 'Ginger Cove', 38.961669921875, 0.680009422211961, -76.559440612793, -1.3362143121783, 218, 25, 'PPL', 'P'),
(119793, 'Ginger Hill', 41.438060760498, 0.723230595912156, -90.5672225952148, -1.5806962286731, 218, 18, 'PPL', 'P'),
(155445, 'Ginger Hill', 40.9727783203125, 0.715109885379205, -80.5694427490234, -1.40620205246753, 218, 41, 'PPL', 'P'),
(162048, 'Ginger Hill', 40.1947212219238, 0.701530227243809, -79.9983291625977, -1.39623423998153, 218, 45, 'PPL', 'P'),
(21397, 'Ginger Hills', 33.4886093139648, 0.584486494442726, -84.4861068725586, -1.47456073711796, 218, 13, 'PPL', 'P'),
(47422, 'Gingerville', 38.9613914489746, 0.680004561942971, -76.5508270263672, -1.33606397673477, 218, 25, 'PPL', 'P'),
(47423, 'Gingerville Manor Estates', 38.9683303833008, 0.680125669193543, -76.5513916015625, -1.3360738304308, 218, 25, 'PPL', 'P'),
(47424, 'Gingerville Woods', 38.9688911437988, 0.680135456310549, -76.5566711425781, -1.33616597580452, 218, 25, 'PPL', 'P'),
(72667, 'Ginghamsburg', 39.9297218322754, 0.696905115378669, -84.1994400024414, -1.46955745637802, 218, 41, 'PPL', 'P'),
(119784, 'Gingle Corners', 41.2630615234375, 0.720176283036972, -90.7358322143555, -1.58363902167764, 218, 18, 'PPL', 'P'),
(122688, 'Gingrich Addition', 40.6738891601563, 0.709893285435958, -86.7541732788086, -1.51414596356089, 218, 19, 'PPL', 'P'),
(29895, 'Gings', 39.6708297729492, 0.692386596536158, -85.3708267211914, -1.49000201143435, 218, 19, 'PPL', 'P'),
(54960, 'Ginlet', 38.8597183227539, 0.678230031129624, -92.1922225952148, -1.60905782901801, 218, 29, 'PPL', 'P'),
(47425, 'Ginns Corner', 39.3905601501465, 0.687494968824928, -75.8011093139648, -1.32297893419283, 218, 25, 'PPL', 'P'),
(36095, 'Ginseng', 37.5047187805176, 0.654580827754584, -85.5811080932617, -1.49367211373258, 218, 21, 'PPL', 'P'),
(191527, 'Ginsite', 33.9477806091309, 0.59250054537402, -100.360832214355, -1.75162696218209, 218, 51, 'PPL', 'P'),
(162049, 'Ginter', 40.7724990844727, 0.711614353290421, -78.3822174072266, -1.36802776877012, 218, 45, 'PPL', 'P'),
(102250, 'Ginter Park', 37.5875015258789, 0.65602565922498, -77.4558334350586, -1.35185931831808, 218, 53, 'PPL', 'P'),
(162050, 'Ginther', 40.860279083252, 0.713146403286517, -76.003059387207, -1.32650362789555, 218, 45, 'PPL', 'P'),
(155446, 'Ginther (historical)', 40.2491683959961, 0.702480509699777, -80.9166717529297, -1.41226234184411, 218, 41, 'PPL', 'P'),
(21398, 'Gintown (historical)', 31.4633293151855, 0.549138690189241, -83.9824981689453, -1.4657711070982, 218, 13, 'PPL', 'P'),
(124922, 'Ginty Corner', 42.014720916748, 0.733295214303784, -71.1627807617188, -1.24202482916687, 218, 23, 'PPL', 'P'),
(109364, 'Gip', 38.6777801513672, 0.675054611003868, -80.9941711425781, -1.41361496136177, 218, 58, 'PPL', 'P'),
(9120, 'Gipson', 34.8983306884766, 0.609090773963696, -94.3869400024414, -1.64736287392495, 218, 4, 'PPL', 'P'),
(87259, 'Gipsonville', 35.4219398498535, 0.61822947782333, -87.1025009155273, -1.52022542769733, 218, 50, 'PPL', 'P'),
(54959, 'Gipsy', 37.1469383239746, 0.648336380788621, -90.179443359375, -1.57392820423683, 218, 29, 'PPL', 'P'),
(112207, 'Gipsy', 34.8936080932617, 0.609008349127958, -87.0824966430664, -1.51987628727842, 218, 2, 'PPL', 'P'),
(162051, 'Gipsy', 40.8072204589844, 0.712220355596469, -78.8766708374023, -1.37665760912446, 218, 45, 'PPL', 'P'),
(2718, 'Girard', 32.4563903808594, 0.566470875458612, -85.0044403076172, -1.4836073621829, 218, 2, 'PPL', 'P'),
(21399, 'Girard', 33.0402793884277, 0.576661661106882, -81.7122192382813, -1.42614726481946, 218, 13, 'PPL', 'P'),
(27274, 'Girard', 39.4463882446289, 0.688469352888761, -89.7808303833008, -1.56697109536316, 218, 18, 'PPL', 'P'),
(32547, 'Girard', 37.5111083984375, 0.654692347625231, -94.8377838134766, -1.65523158283975, 218, 20, 'PPL', 'P'),
(41088, 'Girard', 32.4816703796387, 0.566912094672211, -91.8063888549805, -1.60232375988564, 218, 22, 'PPL', 'P'),
(109365, 'Girard', 38.167781829834, 0.666153461113469, -82.315559387207, -1.43667753692769, 218, 58, 'PPL', 'P'),
(130999, 'Girard', 42.0294418334961, 0.733552142769949, -85.0013885498047, -1.4835540989611, 218, 27, 'PPL', 'P'),
(135568, 'Girard', 47.7286109924316, 0.83302140922149, -96.6738891601563, -1.68727766655278, 218, 28, 'PPL', 'P'),
(155447, 'Girard', 41.1538887023926, 0.718270857856047, -80.7016677856445, -1.40850981471014, 218, 41, 'PPL', 'P'),
(162052, 'Girard', 42.0002784729004, 0.733043146106608, -80.3183288574219, -1.40181928826159, 218, 45, 'PPL', 'P'),
(191532, 'Girard', 33.3622207641602, 0.582280598111813, -100.662498474121, -1.75689203165718, 218, 51, 'PPL', 'P'),
(196594, 'Girard', 47.8677787780762, 0.835450345293697, -104.421112060547, -1.8224922140505, 218, 31, 'PPL', 'P'),
(9121, 'Girard (historical)', 35.0052795410156, 0.610957383571732, -93.9427795410156, -1.63961081146589, 218, 4, 'PPL', 'P'),
(162053, 'Girard Junction', 42.0130615234375, 0.733266252426929, -80.3716735839844, -1.40275032937868, 218, 45, 'PPL', 'P'),
(162054, 'Girard Manor', 40.8672218322754, 0.713267577116115, -76.1013870239258, -1.32821976890199, 218, 45, 'PPL', 'P'),
(149130, 'Girarde', 41.4433288574219, 0.723322541548791, -74.2280578613281, -1.29552400704104, 218, 40, 'PPL', 'P'),
(149131, 'Girards Sugarbush', 43.4700012207031, 0.758694647147224, -74.1958312988281, -1.29496154741881, 218, 40, 'PPL', 'P'),
(162058, 'Girardville', 40.791389465332, 0.711944052633373, -76.2838897705078, -1.33140504272378, 218, 45, 'PPL', 'P'),
(196595, 'Gird Point', 46.2075004577637, 0.806473022104763, -113.91056060791, -1.98811433540059, 218, 31, 'PPL', 'P'),
(162060, 'Girdland', 41.6819381713867, 0.727487059703403, -75.2030563354492, -1.31254094061637, 218, 45, 'PPL', 'P'),
(36099, 'Girdler', 36.9397201538086, 0.644719741449266, -83.8433303833008, -1.463342171026, 218, 21, 'PPL', 'P'),
(47426, 'Girdletree', 38.0944404602051, 0.664873412735522, -75.3977813720703, -1.31593953364147, 218, 25, 'PPL', 'P'),
(54961, 'Girdner', 36.853889465332, 0.643221713336097, -92.5869369506836, -1.61594689412583, 218, 29, 'PPL', 'P'),
(211847, 'Girdwood', 60.9425010681152, 1.06364729803877, -149.166397094727, -2.60344476264028, 218, 1, 'PPL', 'P'),
(36096, 'Girkin', 37.0675010681152, 0.646949939125126, -86.3583297729492, -1.50723719106101, 218, 21, 'PPL', 'P'),
(191528, 'Girlstown USA', 33.4870491027832, 0.58445926362058, -102.615837097168, -1.79098422203572, 218, 51, 'PPL', 'P'),
(87260, 'Girlton (historical)', 36.3472213745117, 0.634378686936488, -83.9944381713867, -1.4659794994535, 218, 50, 'PPL', 'P'),
(29896, 'Giro', 38.5111083984375, 0.672145640145175, -87.470832824707, -1.52665403225267, 218, 19, 'PPL', 'P'),
(109366, 'Girta', 39.0849990844727, 0.682161922163017, -81.2605590820313, -1.41826430799283, 218, 58, 'PPL', 'P'),
(155448, 'Girton', 41.2836112976074, 0.720534944256778, -83.3597183227539, -1.4549015482671, 218, 41, 'PPL', 'P'),
(162061, 'Girty', 40.6472206115723, 0.709427831456439, -79.4111099243164, -1.38598533084247, 218, 45, 'PPL', 'P'),
(193591, 'Girvan', 40.5127792358398, 0.707081386798998, -122.378890991211, -2.13591458273586, 218, 6, 'PPL', 'P'),
(191529, 'Girvin', 31.062780380249, 0.542147792459242, -102.388061523438, -1.78700878831851, 218, 51, 'PPL', 'P'),
(188611, 'Gise', 35.4430618286133, 0.618598125897224, -105.616111755371, -1.84334889328551, 218, 38, 'PPL', 'P'),
(178248, 'Gisela', 34.1016693115234, 0.595186409912392, -111.279167175293, -1.94218785608606, 218, 5, 'PPL', 'P'),
(36097, 'Gishton', 37.3252792358398, 0.651449016891678, -87.2177810668945, -1.52223744590088, 218, 21, 'PPL', 'P'),
(87261, 'Gismonda', 35.959171295166, 0.627605935389281, -88.1180572509766, -1.5379502294904, 218, 50, 'PPL', 'P'),
(47427, 'Gist', 39.4505615234375, 0.688542190344575, -76.9899978637695, -1.34372895382618, 218, 25, 'PPL', 'P'),
(94476, 'Gist', 30.274169921875, 0.528383943444953, -93.9055633544922, -1.63896126647602, 218, 51, 'PPL', 'P'),
(72668, 'Gist Settlement', 39.3158302307129, 0.686190685681062, -83.647216796875, -1.45991934323497, 218, 41, 'PPL', 'P'),
(60040, 'Gitano', 31.7780609130859, 0.554631792832665, -89.3244400024414, -1.55900558054273, 218, 30, 'PPL', 'P'),
(131006, 'Gitchel', 42.7822189331055, 0.746690581691746, -85.841667175293, -1.49821972761, 218, 27, 'PPL', 'P'),
(47428, 'Gittings', 39.4694404602051, 0.688871689950445, -76.4905624389648, -1.33501216126224, 218, 25, 'PPL', 'P'),
(109367, 'Given', 38.7341690063477, 0.676038782184707, -81.7336120605469, -1.42652064000429, 218, 58, 'PPL', 'P'),
(36098, 'Givens', 37.6111106872559, 0.656437716824642, -87.772216796875, -1.53191417487974, 218, 21, 'PPL', 'P'),
(72669, 'Givens', 39.0530586242676, 0.681604455967836, -82.9244384765625, -1.44730448178349, 218, 41, 'PPL', 'P'),
(94477, 'Givens', 33.6933288574219, 0.588059524519231, -95.504997253418, -1.66687665418028, 218, 51, 'PPL', 'P'),
(41087, 'Givens (historical)', 31.5527801513672, 0.550699901799272, -92.7402801513672, -1.6186232378633, 218, 22, 'PPL', 'P'),
(207500, 'Givens Corner', 46.2511100769043, 0.807234153544308, -119.998062133789, -2.09436128024735, 218, 56, 'PPL', 'P'),
(194994, 'Givens Hot Springs', 43.4222183227539, 0.757860678251865, -116.713890075684, -2.03704166463141, 218, 17, 'PPL', 'P'),
(194995, 'Giveout', 42.4186096191406, 0.740344401972142, -111.157783508301, -1.9400693114389, 218, 17, 'PPL', 'P'),
(81224, 'Givhans', 33.0113906860352, 0.576157458133503, -80.3377838134766, -1.40215884130057, 218, 48, 'PPL', 'P'),
(115741, 'Givin', 41.2249984741211, 0.719511957503051, -92.6624984741211, -1.61726569149763, 218, 16, 'PPL', 'P'),
(109368, 'Glace', 37.6769409179688, 0.657586671097929, -80.3436126708984, -1.40226057405421, 218, 58, 'PPL', 'P'),
(207502, 'Glacier', 48.8902816772461, 0.8532963874954, -121.944442749023, -2.12833203048018, 218, 56, 'PPL', 'P'),
(196596, 'Glacier Colony', 48.8327789306641, 0.852292775238604, -112.218063354492, -1.95857468574748, 218, 31, 'PPL', 'P'),
(202155, 'Glad Valley', 45.399169921875, 0.792364992809096, -101.777221679688, -1.7763476218427, 218, 49, 'PPL', 'P'),
(112999, 'Gladbrook', 42.1877784729004, 0.736315638454097, -92.7149963378906, -1.61818195207068, 218, 16, 'PPL', 'P'),
(9122, 'Gladden', 35.1644401550293, 0.613735260325767, -90.5602798461914, -1.5805750548435, 218, 4, 'PPL', 'P'),
(54962, 'Gladden', 37.4986114501953, 0.654474234731954, -91.4563903808594, -1.59621513413527, 218, 29, 'PPL', 'P'),
(162062, 'Gladden', 40.339168548584, 0.704051308689733, -80.1788864135742, -1.39938555849942, 218, 45, 'PPL', 'P'),
(178249, 'Gladden', 33.9025001525879, 0.591710252320539, -113.298606872559, -1.97743372784882, 218, 5, 'PPL', 'P'),
(81225, 'Gladden Grove (historical)', 34.5002784729004, 0.602143452207033, -81.0124969482422, -1.41393480700868, 218, 48, 'PPL', 'P'),
(162063, 'Gladden Heights', 40.3619384765625, 0.7044487189034, -80.2461090087891, -1.40055881411765, 218, 45, 'PPL', 'P'),
(87262, 'Gladdice', 36.3463897705078, 0.634364172708548, -85.8055572509766, -1.49758949053804, 218, 50, 'PPL', 'P'),
(149132, 'Gladding Corner', 42.8016700744629, 0.747030068151704, -77.4513931274414, -1.35178182033036, 218, 40, 'PPL', 'P'),
(9123, 'Glade', 36.3680610656738, 0.634742408162366, -93.9138870239258, -1.63910654191348, 218, 4, 'PPL', 'P'),
(32549, 'Glade', 39.6847190856934, 0.692629010774383, -99.309440612793, -1.73327671700701, 218, 20, 'PPL', 'P'),
(36100, 'Glade', 36.8188896179199, 0.64261085076106, -88.3116683959961, -1.54132938143955, 218, 21, 'PPL', 'P'),
(41089, 'Glade', 31.4930591583252, 0.549657573838129, -91.8613891601563, -1.60328369630056, 218, 22, 'PPL', 'P'),
(60041, 'Glade', 31.6550006866455, 0.55248398670303, -89.1072235107422, -1.55521443757295, 218, 30, 'PPL', 'P'),
(72670, 'Glade', 39.0133285522461, 0.680911035399007, -82.7827835083008, -1.44483213618551, 218, 41, 'PPL', 'P'),
(87263, 'Glade', 35.7400016784668, 0.623780703957545, -83.4622192382813, -1.45669052672936, 218, 50, 'PPL', 'P'),
(109369, 'Glade', 37.832218170166, 0.660296770402221, -81.001106262207, -1.41373600203331, 218, 58, 'PPL', 'P'),
(115742, 'Glade', 43.3427810668945, 0.75647423658837, -93.1608276367188, -1.62596317614367, 218, 16, 'PPL', 'P'),
(162064, 'Glade', 41.8274993896484, 0.730027582225284, -79.1208267211914, -1.3809189331847, 218, 45, 'PPL', 'P'),
(207503, 'Glade', 46.336109161377, 0.808717667429536, -119.110000610352, -2.07886168270309, 218, 56, 'PPL', 'P'),
(41090, 'Glade Bayou Landing', 32.1027793884277, 0.560299199369436, -91.3930587768555, -1.59510978912483, 218, 22, 'PPL', 'P'),
(78341, 'Glade City', 39.8186111450195, 0.6949658680519, -78.995002746582, -1.37872289054982, 218, 45, 'PPL', 'P'),
(47431, 'Glade Creek', 39.5194396972656, 0.689744341260636, -77.3436126708984, -1.34990069649438, 218, 25, 'PPL', 'P'),
(87264, 'Glade Creek', 36.0052795410156, 0.628410676091675, -85.2716674804688, -1.48827135619996, 218, 50, 'PPL', 'P'),
(109370, 'Glade Creek', 38.3180618286133, 0.668776341892061, -80.7988891601563, -1.41020664779868, 218, 58, 'PPL', 'P'),
(109371, 'Glade Farms', 39.7055587768555, 0.69299273200026, -79.5244369506836, -1.38796326058407, 218, 58, 'PPL', 'P'),
(162065, 'Glade Mills', 40.7244415283203, 0.710775590705101, -79.9244384765625, -1.39494460422366, 218, 45, 'PPL', 'P'),
(102251, 'Glade Road Heights', 37.235279083252, 0.649878217901722, -80.456672668457, -1.40423384326391, 218, 53, 'PPL', 'P'),
(102252, 'Glade Spring', 36.7911109924316, 0.642126022284611, -81.7713928222656, -1.42718003869019, 218, 53, 'PPL', 'P'),
(109372, 'Glade Springs', 37.7177810668945, 0.658299466163689, -81.0638885498047, -1.41483175966382, 218, 58, 'PPL', 'P'),
(65027, 'Glade Valley', 36.4716682434082, 0.63655069454253, -81.0516662597656, -1.41461844046051, 218, 33, 'PPL', 'P'),
(109373, 'Glade View', 38.4061088562012, 0.670313052420064, -80.5288925170898, -1.40549431740784, 218, 58, 'PPL', 'P'),
(87265, 'Gladecreek (historical)', 35.6513900756836, 0.622234139733509, -85.2388916015625, -1.48769930919781, 218, 50, 'PPL', 'P'),
(102253, 'Gladehill', 36.9894409179688, 0.645587532490468, -79.7630615234375, -1.39212804505479, 218, 53, 'PPL', 'P'),
(122689, 'Gladens Corner', 40.2586097717285, 0.702645292792225, -86.8283309936523, -1.51544025985067, 218, 19, 'PPL', 'P'),
(2719, 'Glades', 33.211109161377, 0.579643203105281, -85.9897232055664, -1.50080379281571, 218, 2, 'PPL', 'P'),
(21400, 'Glades', 34.4286117553711, 0.60089263202205, -83.7311096191406, -1.4613835492023, 218, 13, 'PPL', 'P'),
(87266, 'Glades', 36.2425003051758, 0.632550959480367, -84.7900009155273, -1.47986468874496, 218, 50, 'PPL', 'P'),
(162067, 'Glades', 40.0099983215332, 0.698306204428159, -76.6805572509766, -1.33832819629355, 218, 45, 'PPL', 'P'),
(21401, 'Glades Cross-Roads', 33.4658317565918, 0.584088951071004, -83.3161087036133, -1.45414041682756, 218, 13, 'PPL', 'P'),
(102254, 'Gladesboro', 36.6858291625977, 0.640288507711483, -80.6100006103516, -1.40690992068527, 218, 53, 'PPL', 'P'),
(21402, 'Gladesville', 33.1938896179199, 0.579342665376265, -83.7783279418945, -1.46220766440162, 218, 13, 'PPL', 'P'),
(109374, 'Gladesville', 39.4669418334961, 0.688828080687594, -79.8772201538086, -1.39412048902433, 218, 58, 'PPL', 'P'),
(16215, 'Gladeview', 25.8388900756836, 0.450973706881566, -80.2358322143555, -1.40037945021824, 218, 12, 'PPL', 'P'),
(87267, 'Gladeville', 36.1124992370605, 0.630282012810647, -86.416389465332, -1.50825052385579, 218, 50, 'PPL', 'P'),
(94479, 'Gladewater', 33.2444381713867, 0.580224904066381, -94.945556640625, -1.65711257351767, 218, 51, 'PPL', 'P'),
(94480, 'Gladewater Park', 32.5113906860352, 0.567430811873532, -94.976936340332, -1.65766025259585, 218, 51, 'PPL', 'P'),
(102255, 'Gladewood', 37.2333297729492, 0.649844196018797, -80.4458312988281, -1.40404462566846, 218, 53, 'PPL', 'P'),
(9124, 'Gladewood Addition', 34.9513893127441, 0.610016821653743, -92.0897216796875, -1.60726885055575, 218, 4, 'PPL', 'P'),
(78344, 'Gladhill', 39.7516708374023, 0.693797539281682, -77.4499969482422, -1.35175745240639, 218, 45, 'PPL', 'P'),
(60044, 'Gladhurst', 31.0294399261475, 0.541565891761059, -90.3741683959961, -1.57732679726193, 218, 30, 'PPL', 'P'),
(60042, 'Glading', 31.1424999237061, 0.543539160970754, -90.6402816772461, -1.58197135020303, 218, 30, 'PPL', 'P'),
(188612, 'Gladiola', 33.2572212219238, 0.580448010386703, -103.179443359375, -1.80082100699609, 218, 38, 'PPL', 'P'),
(60043, 'Gladneyville (historical)', 33.8347206115723, 0.590527276164325, -88.5666732788086, -1.54578005625329, 218, 30, 'PPL', 'P'),
(94481, 'Gladstell', 30.2847194671631, 0.528568067744819, -95.1125030517578, -1.66002633806633, 218, 51, 'PPL', 'P'),
(2726, 'Gladstone', 34.872501373291, 0.608639967370172, -86.6430587768555, -1.5122066496551, 218, 2, 'PPL', 'P'),
(32550, 'Gladstone', 38.3430595397949, 0.669212634257643, -96.4938888549805, -1.68413606857287, 218, 20, 'PPL', 'P'),
(54963, 'Gladstone', 39.2038917541504, 0.68423699070538, -94.554443359375, -1.65028635901158, 218, 29, 'PPL', 'P'),
(72671, 'Gladstone', 39.7436103820801, 0.693656857797099, -83.6849975585938, -1.46057874192088, 218, 41, 'PPL', 'P'),
(87268, 'Gladstone', 36.184440612793, 0.631537626685592, -82.5733337402344, -1.44117654811521, 218, 50, 'PPL', 'P'),
(102256, 'Gladstone', 37.5466690063477, 0.655312997317274, -78.8497161865234, -1.3761871617179, 218, 53, 'PPL', 'P'),
(115743, 'Gladstone', 41.9638900756836, 0.732408048765651, -92.4972229003906, -1.61438108856292, 218, 16, 'PPL', 'P'),
(119785, 'Gladstone', 40.8644409179688, 0.713219041005249, -90.9611129760742, -1.58757091271103, 218, 18, 'PPL', 'P'),
(131000, 'Gladstone', 45.8527793884277, 0.800281971518656, -87.0216674804688, -1.51881461810986, 218, 27, 'PPL', 'P'),
(135570, 'Gladstone', 45.0016708374023, 0.785427325011385, -93.0302810668945, -1.62368470867305, 218, 28, 'PPL', 'P'),
(141909, 'Gladstone', 40.1597213745117, 0.700919364668772, -97.3077774047852, -1.69834110351124, 218, 35, 'PPL', 'P'),
(145295, 'Gladstone', 40.7224998474121, 0.71074170198023, -74.6658325195313, -1.30316461620847, 218, 37, 'PPL', 'P'),
(186765, 'Gladstone', 37.8902816772461, 0.661310169776024, -107.649719238281, -1.87884203955549, 218, 7, 'PPL', 'P'),
(188613, 'Gladstone', 36.3047218322754, 0.633636929993874, -103.972503662109, -1.81466252044567, 218, 38, 'PPL', 'P'),
(198333, 'Gladstone', 46.8608283996582, 0.817875745786101, -102.567497253418, -1.79014053260238, 218, 34, 'PPL', 'P'),
(200884, 'Gladstone', 45.3808288574219, 0.792044880846068, -122.593612670898, -2.13966218302182, 218, 43, 'PPL', 'P'),
(9125, 'Gladstone (historical)', 34.7458305358887, 0.606429144191243, -93.3041687011719, -1.62846494967169, 218, 4, 'PPL', 'P'),
(47432, 'Gladstone Acres', 39.6455612182617, 0.691945577059641, -76.2486114501953, -1.33078931987976, 218, 25, 'PPL', 'P'),
(81226, 'Gladstone Acres', 34.4608306884766, 0.60145495848622, -82.6305618286133, -1.44217536668205, 218, 48, 'PPL', 'P'),
(174264, 'Gladstone Beach', 43.8655586242676, 0.765598426220063, -88.3688888549805, -1.54232806684833, 218, 57, 'PPL', 'P'),
(109375, 'Gladwin', 39.0069389343262, 0.68079951552836, -79.5449981689453, -1.38832212154096, 218, 58, 'PPL', 'P'),
(115744, 'Gladwin', 41.3597183227539, 0.721863262429482, -91.4508285522461, -1.59611806191353, 218, 16, 'PPL', 'P'),
(131002, 'Gladwin', 43.9808311462402, 0.767610311265564, -84.4863891601563, -1.47456566396597, 218, 27, 'PPL', 'P'),
(162068, 'Gladwyne', 40.0405616760254, 0.698839635594502, -75.2794418334961, -1.31387411905806, 218, 45, 'PPL', 'P'),
(65028, 'Glady', 35.5086097717285, 0.619742153322495, -82.7272186279297, -1.44386234607456, 218, 33, 'PPL', 'P'),
(109376, 'Glady', 38.7983283996582, 0.677158574844058, -79.7197189331055, -1.39137157414715, 218, 58, 'PPL', 'P'),
(21403, 'Gladys', 31.4699993133545, 0.549255103618391, -83.2377777099609, -1.45277328308196, 218, 13, 'PPL', 'P'),
(94483, 'Gladys', 33.6175003051758, 0.586736066615516, -97.5163879394531, -1.70198204419555, 218, 51, 'PPL', 'P'),
(102258, 'Gladys', 37.1630592346191, 0.648617743757788, -79.0738906860352, -1.38009974483339, 218, 53, 'PPL', 'P'),
(198335, 'Gladys', 48.4952812194824, 0.846402328960539, -103.819717407227, -1.81199589724617, 218, 34, 'PPL', 'P'),
(9126, 'Gladys (historical)', 35.5675010681152, 0.620770000345211, -92.6125030517578, -1.61639310676647, 218, 4, 'PPL', 'P'),
(2721, 'Gladys Landing', 32.7844390869141, 0.572196405486174, -88.0663909912109, -1.5370484831453, 218, 2, 'PPL', 'P'),
(54964, 'Glaize (historical)', 37.9355583190918, 0.662100396250478, -92.4449996948242, -1.61346962167984, 218, 29, 'PPL', 'P'),
(181781, 'Glamis', 32.997501373291, 0.575915043895279, -115.071113586426, -2.00836980601951, 218, 6, 'PPL', 'P'),
(102257, 'Glamorgan', 36.9986114501953, 0.645747588471982, -82.5944366455078, -1.44154486329397, 218, 53, 'PPL', 'P'),
(60045, 'Glancy', 31.8183307647705, 0.555334634333851, -90.4963912963867, -1.57945998929509, 218, 30, 'PPL', 'P'),
(174265, 'Glandon', 45.0888900756836, 0.786949587890474, -89.4269409179688, -1.560794559005, 218, 57, 'PPL', 'P'),
(155450, 'Glandorf', 41.0288887023926, 0.716089196291054, -84.0791702270508, -1.46745835280682, 218, 41, 'PPL', 'P'),
(127567, 'Glantz Corner', 43.8427810668945, 0.765200882848342, -70.4002838134766, -1.22871674688364, 218, 26, 'PPL', 'P'),
(32551, 'Glasco', 39.3566703796387, 0.686903480746822, -97.8408279418945, -1.70764459046333, 218, 20, 'PPL', 'P'),
(149133, 'Glasco', 42.0436096191406, 0.733799417277163, -73.9477767944336, -1.29063217959272, 218, 40, 'PPL', 'P'),
(54966, 'Glaser Ford', 38.2324981689453, 0.667282974310799, -91.5197219848633, -1.5973204791457, 218, 29, 'PPL', 'P'),
(47434, 'Glasers Hill', 39.6391716003418, 0.691834057188994, -76.8850021362305, -1.3418964326801, 218, 25, 'PPL', 'P'),
(119788, 'Glasford', 40.5724983215332, 0.708123681470627, -89.8133316040039, -1.56753834867535, 218, 18, 'PPL', 'P'),
(113470, 'Glasgo', 41.5558280944824, 0.72528602364148, -71.8886108398438, -1.25469295384016, 218, 8, 'PPL', 'P'),
(2723, 'Glasgow', 33.6105613708496, 0.586614959364945, -86.9527816772461, -1.51761233403574, 218, 2, 'PPL', 'P'),
(13830, 'Glasgow', 39.6047210693359, 0.691232781993882, -75.7455596923828, -1.32200941039798, 218, 10, 'PPL', 'P'),
(21405, 'Glasgow', 30.7222194671631, 0.536203883222294, -83.8755569458008, -1.46390463064822, 218, 13, 'PPL', 'P'),
(27266, 'Glasgow', 39.5505599975586, 0.690287492964958, -90.4800033569336, -1.57917396579401, 218, 18, 'PPL', 'P'),
(36101, 'Glasgow', 36.9958305358887, 0.645699052361115, -85.9119415283203, -1.49944624645004, 218, 21, 'PPL', 'P'),
(54968, 'Glasgow', 39.2272186279297, 0.684644121457025, -92.8463897705078, -1.62047520008534, 218, 29, 'PPL', 'P'),
(102259, 'Glasgow', 37.6338882446289, 0.656835260196364, -79.4505615234375, -1.38667389114231, 218, 53, 'PPL', 'P'),
(109377, 'Glasgow', 38.2152786254883, 0.666982436581783, -81.4247207641602, -1.42112946985159, 218, 58, 'PPL', 'P'),
(115745, 'Glasgow', 40.9408302307129, 0.71455228602597, -91.7802810668945, -1.60186809302312, 218, 16, 'PPL', 'P'),
(155452, 'Glasgow', 40.3086090087891, 0.703517944102417, -81.5508270263672, -1.42333043933448, 218, 41, 'PPL', 'P'),
(162071, 'Glasgow', 40.2636108398438, 0.702732577896953, -75.6611099243164, -1.32053548389268, 218, 45, 'PPL', 'P'),
(181782, 'Glasgow', 34.9836082458496, 0.610579148117914, -115.86888885498, -2.02229361114677, 218, 6, 'PPL', 'P'),
(196598, 'Glasgow', 48.1969413757324, 0.841195316397216, -106.636108398438, -1.86115119306631, 218, 31, 'PPL', 'P'),
(200885, 'Glasgow', 43.4347190856934, 0.75807885772417, -124.209999084473, -2.16787344792319, 218, 43, 'PPL', 'P'),
(87269, 'Glasgow (historical)', 36.3180618286133, 0.633869756852174, -88.6458282470703, -1.54716157106877, 218, 50, 'PPL', 'P'),
(115746, 'Glasgow (historical)', 42.6049995422363, 0.743597519822701, -92.3480606079102, -1.61177771543931, 218, 16, 'PPL', 'P'),
(2724, 'Glasgow Corner', 34.436939239502, 0.601037974038541, -87.8675003051758, -1.53357718582244, 218, 2, 'PPL', 'P'),
(13822, 'Glasgow Court', 39.6222190856934, 0.691538179991886, -75.6986083984375, -1.32118995573057, 218, 10, 'PPL', 'P'),
(81227, 'Glasgow Landing', 32.1352806091309, 0.560866452681623, -80.9911117553711, -1.41356156498191, 218, 48, 'PPL', 'P'),
(149135, 'Glasgow Mills', 43.1027793884277, 0.752285417088812, -74.5311126708984, -1.30081331128204, 218, 40, 'PPL', 'P'),
(13823, 'Glasgow Pines', 39.6166687011719, 0.691441307507235, -75.7111129760742, -1.3214082017819, 218, 10, 'PPL', 'P'),
(54967, 'Glasgow Village', 38.7536087036133, 0.676378068907583, -90.1983337402344, -1.57425790357978, 218, 29, 'PPL', 'P'),
(2725, 'Glass', 32.7849998474121, 0.57220619260318, -85.1738891601563, -1.48656480257343, 218, 2, 'PPL', 'P'),
(16216, 'Glass', 30.8641700744629, 0.538681388694881, -85.4286117553711, -1.49101055053916, 218, 12, 'PPL', 'P'),
(47435, 'Glass', 39.6666717529297, 0.692314025396454, -77.2916717529297, -1.34899415645932, 218, 25, 'PPL', 'P'),
(65029, 'Glass', 35.4772186279297, 0.619194274507238, -80.6266708374023, -1.40720087103436, 218, 33, 'PPL', 'P'),
(72672, 'Glass', 39.5486106872559, 0.690253471082032, -81.1294403076172, -1.41597585366812, 218, 41, 'PPL', 'P'),
(87270, 'Glass', 36.264720916748, 0.63293878231411, -89.2536087036133, -1.55776934116472, 218, 50, 'PPL', 'P'),
(94484, 'Glass', 32.1911087036133, 0.561840836745455, -97.836669921875, -1.70757201932362, 218, 51, 'PPL', 'P'),
(109378, 'Glass Addition', 38.4563903808594, 0.671190630578272, -81.8166732788086, -1.42797033174367, 218, 58, 'PPL', 'P'),
(162073, 'Glass City', 40.8713912963867, 0.713340347992902, -78.2152786254883, -1.36511413737952, 218, 45, 'PPL', 'P'),
(47436, 'Glass Hill', 38.3894386291504, 0.670022102070973, -75.4394378662109, -1.31666657661907, 218, 25, 'PPL', 'P'),
(149134, 'Glass Lake', 42.6300010681152, 0.74403387876731, -73.5313873291016, -1.28336481245206, 218, 40, 'PPL', 'P'),
(72673, 'Glass Rock', 39.8772201538086, 0.6959887882266, -82.2891693115234, -1.43621694321716, 218, 41, 'PPL', 'P'),
(190241, 'Glassand', 36.5569381713867, 0.638038935538693, -114.463890075684, -1.99777175646154, 218, 39, 'PPL', 'P'),
(70866, 'Glassboro', 39.7027816772461, 0.692944262468421, -75.1122207641602, -1.31095556081945, 218, 37, 'PPL', 'P'),
(41091, 'Glasscock (historical)', 31.3652801513672, 0.547427409451783, -91.5924987792969, -1.59859067382762, 218, 22, 'PPL', 'P'),
(94485, 'Glasscock Estates Colonia', 26.2469997406006, 0.458096564243578, -98.286003112793, -1.71541436294363, 218, 51, 'PPL', 'P'),
(94486, 'Glasscock North Colonia', 26.2950000762939, 0.45893432814349, -98.2819976806641, -1.71534445496502, 218, 51, 'PPL', 'P'),
(47437, 'Glassmanor', 38.8188896179199, 0.677517435800946, -76.998893737793, -1.34388421611773, 218, 25, 'PPL', 'P'),
(162077, 'Glassmere', 40.5763893127441, 0.708191592078424, -79.7805633544922, -1.39243350963182, 218, 45, 'PPL', 'P'),
(162074, 'Glassport', 40.3247184753418, 0.703799107334502, -79.8925018310547, -1.3943872046075, 218, 45, 'PPL', 'P'),
(140092, 'Glasston', 48.7058296203613, 0.850077091790685, -97.4472198486328, -1.70077483327341, 218, 34, 'PPL', 'P'),
(78345, 'Glassworks', 39.8019409179688, 0.694674917702809, -79.914436340332, -1.3947700340142, 218, 45, 'PPL', 'P'),
(81228, 'Glassy', 35.1230583190918, 0.613013011038137, -82.3133316040039, -1.43663865477577, 218, 48, 'PPL', 'P'),
(172045, 'Glastenbury', 43.0002784729004, 0.750496438626551, -73.0833282470703, -1.27554470622715, 218, 55, 'PPL', 'P'),
(60046, 'Glaston', 31.6588897705078, 0.552551864021313, -89.0783309936523, -1.55471016802055, 218, 30, 'PPL', 'P'),
(113471, 'Glastonbury', 41.7122192382813, 0.728015564021729, -72.6086120605469, -1.26725934575981, 218, 8, 'PPL', 'P'),
(113472, 'Glastonbury Center', 41.7008285522461, 0.727816759046355, -72.5999984741211, -1.26710901031627, 218, 8, 'PPL', 'P'),
(78346, 'Glatfelters', 39.874439239502, 0.695940252115733, -76.7508316040039, -1.33955471513359, 218, 45, 'PPL', 'P'),
(94487, 'Glaze City', 29.4069404602051, 0.513247933968515, -97.288330078125, -1.69800168363031, 218, 51, 'PPL', 'P'),
(9129, 'Glaze Creek', 36.4794387817383, 0.636686316021042, -90.8827819824219, -1.58620377896544, 218, 4, 'PPL', 'P'),
(191531, 'Glazier', 36.0113906860352, 0.628517335693333, -100.263328552246, -1.74992520224553, 218, 51, 'PPL', 'P'),
(36111, 'Gleanings', 37.5583305358887, 0.655516529403584, -85.5338897705078, -1.49284799853326, 218, 21, 'PPL', 'P'),
(9130, 'Gleason', 35.1108283996582, 0.612799558676767, -92.5158309936523, -1.61470586105785, 218, 4, 'PPL', 'P'),
(87272, 'Gleason', 36.2136116027832, 0.632046756506988, -88.6125030517578, -1.5465799366867, 218, 50, 'PPL', 'P'),
(162076, 'Gleason', 41.6336097717285, 0.726643570007147, -76.9322204589844, -1.34272054787942, 218, 45, 'PPL', 'P'),
(174266, 'Gleason', 45.3088912963867, 0.79078933355015, -89.4963912963867, -1.56200669677514, 218, 57, 'PPL', 'P'),
(209473, 'Gleason', 41.0083312988281, 0.715730401913193, -104.873611450195, -1.83038981826313, 218, 59, 'PPL', 'P'),
(109379, 'Gleason (historical)', 39.3627815246582, 0.687010140348479, -79.2174987792969, -1.38260617889332, 218, 58, 'PPL', 'P'),
(124923, 'Gleasondale', 42.4061088562012, 0.740126222499837, -71.5272216796875, -1.24838552311442, 218, 23, 'PPL', 'P'),
(124924, 'Gleasondale Station', 42.3958282470703, 0.739946792021393, -71.5238876342773, -1.2483273330446, 218, 23, 'PPL', 'P'),
(149136, 'Gleasons Mill', 44.4605598449707, 0.775983156574718, -74.9486083984375, -1.30809998634061, 218, 40, 'PPL', 'P'),
(162078, 'Gleasonton', 41.3541717529297, 0.721766456523858, -77.7033309936523, -1.35617896560619, 218, 45, 'PPL', 'P'),
(102260, 'Gleatons Mobile Home Park', 38.6619415283203, 0.674778174882718, -77.2911071777344, -1.34898430276329, 218, 53, 'PPL', 'P'),
(109380, 'Glebe (historical)', 39.2000007629395, 0.684169080097583, -78.8594436645508, -1.37635693823739, 218, 58, 'PPL', 'P'),
(47438, 'Glebe Heights', 38.9272193908691, 0.679408147016848, -76.5427780151367, -1.33592349498727, 218, 25, 'PPL', 'P'),
(102261, 'Glebe Mills', 37.4252815246582, 0.653194386091089, -79.932502746582, -1.39508535228727, 218, 53, 'PPL', 'P'),
(102262, 'Glebe Point', 37.3158302307129, 0.651284100641175, -77.4791717529297, -1.35226664880681, 218, 53, 'PPL', 'P'),
(47439, 'Glebe Villa', 38.7972183227539, 0.677139200347128, -76.105827331543, -1.32829726688971, 218, 25, 'PPL', 'P'),
(94488, 'Gleckler', 29.6061897277832, 0.516725489719941, -96.9121017456055, -1.69143526048856, 218, 51, 'PPL', 'P'),
(21406, 'Gledstone Hills', 33.5294418334961, 0.585199156350431, -84.5625, -1.47589404871771, 218, 13, 'PPL', 'P'),
(207504, 'Gleed', 46.6583290100098, 0.814341464703457, -120.61222076416, -2.10508037047687, 218, 56, 'PPL', 'P'),
(102289, 'Gleedsville', 39.0491714477539, 0.681536611939067, -77.6050033569336, -1.35446282459974, 218, 53, 'PPL', 'P'),
(178250, 'Gleeson', 31.7338905334473, 0.553860874276115, -109.829170227051, -1.91688063519536, 218, 5, 'PPL', 'P'),
(47440, 'Glemont Forest', 39.0558280944824, 0.681652792341621, -77.0588912963867, -1.34493137105835, 218, 25, 'PPL', 'P'),
(47441, 'Glen', 39.0461082458496, 0.681483148980183, -77.2163925170898, -1.34768028593553, 218, 25, 'PPL', 'P'),
(87273, 'Glen', 35.3597183227539, 0.617143507309823, -85.9169387817383, -1.49953346497574, 218, 50, 'PPL', 'P'),
(109381, 'Glen', 38.3941688537598, 0.670104660064765, -81.2427825927734, -1.41795404972583, 218, 58, 'PPL', 'P'),
(135572, 'Glen', 46.4186096191406, 0.810157572051915, -93.5149993896484, -1.63214463934985, 218, 28, 'PPL', 'P'),
(143874, 'Glen', 44.1100006103516, 0.769864743707343, -71.1830596923828, -1.24237876327574, 218, 36, 'PPL', 'P'),
(149137, 'Glen', 42.8941688537598, 0.74864447640451, -74.3450012207031, -1.29756505370047, 218, 40, 'PPL', 'P'),
(196599, 'Glen', 45.4766693115234, 0.793717612326747, -112.689720153809, -1.96680664983497, 218, 31, 'PPL', 'P'),
(199346, 'Glen', 42.6074981689453, 0.743641129085551, -103.58332824707, -1.80787012808542, 218, 35, 'PPL', 'P'),
(200886, 'Glen (historical)', 44.5166702270508, 0.776962467486568, -123.816673278809, -2.16100861758129, 218, 43, 'PPL', 'P'),
(207505, 'Glen Acres', 47.475830078125, 0.828609549980638, -122.445281982422, -2.13707332412615, 218, 56, 'PPL', 'P'),
(102263, 'Glen Alden', 38.8472213745117, 0.678011918236347, -77.35888671875, -1.3501672789195, 218, 53, 'PPL', 'P'),
(87274, 'Glen Alice', 35.8058280944824, 0.624929591651806, -84.7405624389648, -1.47900182455177, 218, 50, 'PPL', 'P'),
(60047, 'Glen Allan', 33.0238914489746, 0.576375637605808, -91.0299987792969, -1.58877319678515, 218, 30, 'PPL', 'P'),
(2745, 'Glen Allen', 33.9150009155273, 0.591928431792843, -87.7416687011719, -1.53138101002951, 218, 2, 'PPL', 'P'),
(102264, 'Glen Allen', 37.665828704834, 0.657392726391544, -77.5066680908203, -1.35274655043524, 218, 53, 'PPL', 'P'),
(145296, 'Glen Alpin', 40.7541694641113, 0.711294441064476, -74.5266723632813, -1.30073581329432, 218, 37, 'PPL', 'P'),
(65031, 'Glen Alpine', 35.728889465332, 0.62358675925116, -81.7794418334961, -1.4273205204377, 218, 33, 'PPL', 'P'),
(87275, 'Glen Alpine', 36.4866714477539, 0.636812549856712, -82.5938873291016, -1.44153527591405, 218, 50, 'PPL', 'P'),
(21407, 'Glen Alta', 32.3066711425781, 0.563857781797027, -84.6513900756836, -1.47744547321073, 218, 13, 'PPL', 'P'),
(109382, 'Glen Alum', 37.5847206115723, 0.655977123114113, -81.9930572509766, -1.43104881280575, 218, 58, 'PPL', 'P'),
(109383, 'Glen Alum Junction', 37.542781829834, 0.655245153288505, -81.9955596923828, -1.43109248864763, 218, 58, 'PPL', 'P'),
(65032, 'Glen Anna', 35.8413887023926, 0.625550241343849, -80.0922164916992, -1.39787288300025, 218, 33, 'PPL', 'P'),
(131007, 'Glen Arbor', 44.8974990844727, 0.783609184935188, -85.9852828979492, -1.50072629482799, 218, 27, 'PPL', 'P'),
(181783, 'Glen Arbor', 37.0744400024414, 0.647071046375697, -122.081108093262, -2.13071729071051, 218, 6, 'PPL', 'P'),
(21408, 'Glen Arden', 32.4736099243164, 0.566771413187628, -84.9169387817383, -1.4820801724558, 218, 13, 'PPL', 'P'),
(87276, 'Glen Arden', 35.9533309936523, 0.627504002898558, -84.0777816772461, -1.4674341180409, 218, 50, 'PPL', 'P'),
(47442, 'Glen Arm', 39.4533309936523, 0.688590526718359, -76.4947204589844, -1.33508473240195, 218, 25, 'PPL', 'P'),
(162079, 'Glen Ashton Farms', 40.103328704834, 0.699935126908906, -74.916389465332, -1.30753765987644, 218, 45, 'PPL', 'P'),
(60048, 'Glen Aubin', 34.3411102294922, 0.599365442294944, -90.6105575561523, -1.58145256642269, 218, 30, 'PPL', 'P'),
(149138, 'Glen Aubrey', 42.2586097717285, 0.737551877832112, -76.0097198486328, -1.32661987487713, 218, 40, 'PPL', 'P'),
(119789, 'Glen Avon', 40.3461112976074, 0.704172482519331, -88.5924987792969, -1.54623079626779, 218, 18, 'PPL', 'P'),
(181784, 'Glen Avon', 34.0116691589355, 0.593615610922436, -117.48388671875, -2.05048064128223, 218, 6, 'PPL', 'P'),
(200887, 'Glen Avon', 45.084171295166, 0.786867229633763, -122.487503051758, -2.13781022079978, 218, 43, 'PPL', 'P'),
(29897, 'Glen Ayre', 39.4736099243164, 0.688944460827231, -87.2958297729492, -1.52359965279846, 218, 19, 'PPL', 'P'),
(65033, 'Glen Ayre', 36.063060760498, 0.629419148617461, -82.1166687011719, -1.43320623960482, 218, 33, 'PPL', 'P'),
(13824, 'Glen Berne Estates', 39.7166709899902, 0.693186676706645, -75.6333312988281, -1.32005065541623, 218, 10, 'PPL', 'P'),
(47443, 'Glen Brook', 39.2763900756836, 0.685502325118304, -76.8488922119141, -1.34126619560813, 218, 25, 'PPL', 'P'),
(102265, 'Glen Burke', 37.148609161377, 0.648365542402557, -81.8291702270508, -1.42818844463695, 218, 53, 'PPL', 'P'),
(47444, 'Glen Burnie', 39.1624984741211, 0.683514541680668, -76.625, -1.33735853934066, 218, 25, 'PPL', 'P'),
(47445, 'Glen Burnie Heights', 39.1583290100098, 0.683441770803882, -76.6336135864258, -1.33750887478419, 218, 25, 'PPL', 'P'),
(47446, 'Glen Burnie Park', 39.1430587768555, 0.683175254957792, -76.6388931274414, -1.33760102015791, 218, 25, 'PPL', 'P'),
(47447, 'Glen Cameron Estates', 39.2538909912109, 0.685109642015571, -77.3433303833008, -1.34989576964637, 218, 25, 'PPL', 'P'),
(162080, 'Glen Campbell', 40.8208312988281, 0.712457909565704, -78.8272171020508, -1.37579447861517, 218, 45, 'PPL', 'P'),
(178251, 'Glen Canyon Trailer Park', 33.538890838623, 0.585364072600934, -112.113327026367, -1.95674669197525, 218, 5, 'PPL', 'P'),
(2728, 'Glen Carbon', 33.2041702270508, 0.579522095854709, -86.9583282470703, -1.51770913994137, 218, 2, 'PPL', 'P'),
(27268, 'Glen Carbon', 38.7483291625977, 0.676285923533866, -89.9830627441406, -1.5705007159139, 218, 18, 'PPL', 'P'),
(162082, 'Glen Carbon', 40.7150001525879, 0.710610807612652, -76.311393737793, -1.33188507751027, 218, 45, 'PPL', 'P'),
(27269, 'Glen Carbon Crossing', 38.7522201538086, 0.676353834141663, -89.9552764892578, -1.57001575427939, 218, 18, 'PPL', 'P'),
(149139, 'Glen Castle', 42.1788902282715, 0.7361605093206, -75.9069366455078, -1.32482596956685, 218, 40, 'PPL', 'P'),
(145297, 'Glen Cedar City', 40.0080604553223, 0.698272382282315, -74.2397232055664, -1.29572760570637, 218, 37, 'PPL', 'P'),
(2729, 'Glen City', 33.5774993896484, 0.586037918935752, -86.2841720581055, -1.50594289477123, 218, 2, 'PPL', 'P'),
(122690, 'Glen Cliff', 40.3163909912109, 0.703653765318011, -87.248893737793, -1.52278046444715, 218, 19, 'PPL', 'P'),
(194202, 'Glen Comfort', 40.3936080932617, 0.705001457987646, -105.439720153809, -1.84027027906538, 218, 7, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(47448, 'Glen Court', 39.1444396972656, 0.683199356565658, -76.8125, -1.34063103168814, 218, 25, 'PPL', 'P'),
(102266, 'Glen Court', 36.6061096191406, 0.638897139199971, -79.8652801513672, -1.39391209666903, 218, 53, 'PPL', 'P'),
(47449, 'Glen Cove', 38.957218170166, 0.679931724487158, -77.0975036621094, -1.34560528397219, 218, 25, 'PPL', 'P'),
(65038, 'Glen Cove', 36.1680603027344, 0.631251736342572, -76.0722198486328, -1.32771070565962, 218, 33, 'PPL', 'P'),
(70868, 'Glen Cove', 39.8833312988281, 0.696095447828257, -74.1430587768555, -1.29404049315581, 218, 37, 'PPL', 'P'),
(94490, 'Glen Cove', 29.5483303070068, 0.515715652324096, -95.0483322143555, -1.6589063456699, 218, 51, 'PPL', 'P'),
(102267, 'Glen Cove', 37.3188896179199, 0.651337497021031, -80.0166702270508, -1.39655435194455, 218, 53, 'PPL', 'P'),
(127568, 'Glen Cove', 44.1336097717285, 0.770276801307006, -69.0947189331055, -1.20593034112275, 218, 26, 'PPL', 'P'),
(149140, 'Glen Cove', 40.8622207641602, 0.713180292011388, -73.6341705322266, -1.28515871776234, 218, 40, 'PPL', 'P'),
(186766, 'Glen Cove', 38.8758316040039, 0.678511260940737, -105.072219848633, -1.83385618873798, 218, 7, 'PPL', 'P'),
(207506, 'Glen Cove', 48.0919418334961, 0.839362728672105, -122.804718017578, -2.14334666638994, 218, 56, 'PPL', 'P'),
(47450, 'Glen Cove (historical)', 39.6711082458496, 0.692391456805148, -76.2055587768555, -1.33003790897819, 218, 25, 'PPL', 'P'),
(47451, 'Glen Cove Estates', 39.2027816772461, 0.684217616208449, -76.7486114501953, -1.33951596613973, 218, 25, 'PPL', 'P'),
(149141, 'Glen Cove Landing', 40.8627815246582, 0.713190079128394, -73.6544418334961, -1.28551251871316, 218, 40, 'PPL', 'P'),
(32552, 'Glen Crouse', 37.4333305358887, 0.653334867838591, -96.6166687011719, -1.686278981144, 218, 20, 'PPL', 'P'),
(109384, 'Glen Daniel', 37.7788887023926, 0.659365995601239, -81.3372192382813, -1.41960228012448, 218, 58, 'PPL', 'P'),
(36102, 'Glen Dean', 37.6533317565918, 0.657174613498267, -86.5411071777344, -1.51042725857276, 218, 21, 'PPL', 'P'),
(109385, 'Glen Easton', 39.8333282470703, 0.695222729939038, -80.6483306884766, -1.4075789067511, 218, 58, 'PPL', 'P'),
(72674, 'Glen Ebon', 39.4041709899902, 0.687732522794163, -82.1908264160156, -1.4345005358946, 218, 41, 'PPL', 'P'),
(47452, 'Glen Echo', 38.9688911437988, 0.680135456310549, -77.1427764892578, -1.34639544386762, 218, 25, 'PPL', 'P'),
(102268, 'Glen Echo', 38.8499984741211, 0.678060387768186, -78.2247161865234, -1.36527885389294, 218, 53, 'PPL', 'P'),
(155453, 'Glen Echo', 40.0044403076172, 0.698209198785453, -83.7969436645508, -1.46253257005461, 218, 41, 'PPL', 'P'),
(194203, 'Glen Echo', 40.6986083984375, 0.710324717532551, -105.584716796875, -1.84280094789123, 218, 7, 'PPL', 'P'),
(200888, 'Glen Echo', 45.3866691589355, 0.792146813336791, -122.60417175293, -2.13984647376925, 218, 43, 'PPL', 'P'),
(47453, 'Glen Echo Heights', 38.9583282470703, 0.679951098984088, -77.126106262207, -1.34610449351853, 218, 25, 'PPL', 'P'),
(54970, 'Glen Echo Park', 38.7011108398438, 0.675461808334541, -90.2977828979492, -1.57599361882024, 218, 29, 'PPL', 'P'),
(102269, 'Glen Echo Place', 37.5161094665527, 0.654779632729959, -77.5341720581055, -1.35322658522173, 218, 53, 'PPL', 'P'),
(113305, 'Glen Eden', 40.7275009155273, 0.710828987084957, -80.1116714477539, -1.39821243603924, 218, 45, 'PPL', 'P'),
(122691, 'Glen Eden', 41.6911087036133, 0.727647115684916, -85.017219543457, -1.4838304019242, 218, 19, 'PPL', 'P'),
(194204, 'Glen Eden', 40.7172203063965, 0.710649556606513, -106.914436340332, -1.86600893205267, 218, 7, 'PPL', 'P'),
(94491, 'Glen Eden (historical)', 33.8894386291504, 0.591482285731228, -96.6413879394531, -1.6867104132406, 218, 51, 'PPL', 'P'),
(149143, 'Glen Edith', 43.2038917541504, 0.754050160785153, -77.5202789306641, -1.35298410440448, 218, 40, 'PPL', 'P'),
(32553, 'Glen Elder', 39.4986114501953, 0.68938081977184, -98.3083267211914, -1.71580398341111, 218, 20, 'PPL', 'P'),
(109386, 'Glen Elk', 39.2849998474121, 0.685652593982811, -80.3388900756836, -1.40217814921848, 218, 58, 'PPL', 'P'),
(47454, 'Glen Ellen', 39.4288902282715, 0.688163954890756, -76.5647201538086, -1.33630645755202, 218, 25, 'PPL', 'P'),
(115747, 'Glen Ellen', 42.4186096191406, 0.740344401972142, -96.3199996948242, -1.68110113019462, 218, 16, 'PPL', 'P'),
(181785, 'Glen Ellen', 38.3641700744629, 0.669581082594456, -122.523063659668, -2.13843087049182, 218, 6, 'PPL', 'P'),
(119790, 'Glen Ellyn', 41.877498626709, 0.730900233535476, -88.0669403076172, -1.53705807052523, 218, 18, 'PPL', 'P'),
(47455, 'Glen Elyn', 39.5430603027344, 0.690156598597381, -76.5088882446289, -1.33533200690916, 218, 25, 'PPL', 'P'),
(21410, 'Glen Errol', 33.9077796936035, 0.591802397694255, -84.399169921875, -1.47304340108688, 218, 13, 'PPL', 'P'),
(72675, 'Glen Este', 39.0988883972168, 0.682404336401242, -84.258056640625, -1.47058050971078, 218, 41, 'PPL', 'P'),
(162083, 'Glen Eyre', 41.4655609130859, 0.723710564119616, -75.0772171020508, -1.31034463166538, 218, 45, 'PPL', 'P'),
(186767, 'Glen Eyrie', 38.8916702270508, 0.678787697061887, -104.883888244629, -1.83056918216255, 218, 7, 'PPL', 'P'),
(47456, 'Glen Falls', 39.4874992370605, 0.689186875065455, -76.8641662597656, -1.34153277803325, 218, 25, 'PPL', 'P'),
(109387, 'Glen Falls', 39.3077812194824, 0.68605020393356, -80.3255615234375, -1.40194552209726, 218, 58, 'PPL', 'P'),
(47457, 'Glen Farms', 39.7069396972656, 0.693016833608126, -75.7955627441406, -1.3228821282872, 218, 25, 'PPL', 'P'),
(109388, 'Glen Ferris', 38.1530609130859, 0.665896532647304, -81.2149963378906, -1.41746908809133, 218, 58, 'PPL', 'P'),
(94492, 'Glen Flora', 29.3472194671631, 0.512205606007372, -96.1930618286133, -1.67888564648378, 218, 51, 'PPL', 'P'),
(174267, 'Glen Flora', 45.4958305358887, 0.794052038780634, -90.8938903808594, -1.5863976570928, 218, 57, 'PPL', 'P'),
(65036, 'Glen Forest', 36.0219383239746, 0.628701426703685, -78.8099975585938, -1.37549394088615, 218, 33, 'PPL', 'P'),
(102272, 'Glen Forest', 36.8394393920898, 0.642969511980866, -76.4741668701172, -1.33472600460311, 218, 53, 'PPL', 'P'),
(21411, 'Glen Forest Mobile Home Park', 33.9094390869141, 0.59183135957111, -83.3513870239258, -1.45475613967158, 218, 13, 'PPL', 'P'),
(109389, 'Glen Fork', 37.6958312988281, 0.657916370440881, -81.529167175293, -1.42295240361775, 218, 58, 'PPL', 'P'),
(78347, 'Glen Forney', 39.7713890075684, 0.694141686273548, -77.5022201538086, -1.35266891928947, 218, 45, 'PPL', 'P'),
(181786, 'Glen Frazer', 37.9983291625977, 0.663195954143909, -122.161666870117, -2.13212330660802, 218, 6, 'PPL', 'P'),
(47458, 'Glen Gardens', 39.1650009155273, 0.683558217522546, -76.6144409179688, -1.33717424859322, 218, 25, 'PPL', 'P'),
(145298, 'Glen Gardner', 40.6966705322266, 0.710290895386707, -74.9411087036133, -1.30796909197303, 218, 37, 'PPL', 'P'),
(124925, 'Glen Grove', 42.1652793884277, 0.735922955351365, -71.9944381713867, -1.25653998921418, 218, 23, 'PPL', 'P'),
(149144, 'Glen Grove', 42.4427795410156, 0.74076624668881, -77.1877822875977, -1.34718094323114, 218, 40, 'PPL', 'P'),
(124926, 'Glen Grove Annex', 42.1583290100098, 0.735801648363712, -71.9875030517578, -1.25641894854264, 218, 23, 'PPL', 'P'),
(190242, 'Glen Hamilton (historical)', 38.9749984741211, 0.680242049333179, -117.505561828613, -2.05085894331507, 218, 39, 'PPL', 'P'),
(21412, 'Glen Haven', 33.7438888549805, 0.588941962946429, -84.2180633544922, -1.46988249518907, 218, 13, 'PPL', 'P'),
(47459, 'Glen Haven', 39.0336112976074, 0.681265036086906, -77.0430603027344, -1.34465506809525, 218, 25, 'PPL', 'P'),
(131009, 'Glen Haven', 44.9019393920898, 0.783686682922909, -86.0274963378906, -1.50146305834356, 218, 27, 'PPL', 'P'),
(149146, 'Glen Haven', 43.1930618286133, 0.753861142926784, -77.5316696166992, -1.35318290937985, 218, 40, 'PPL', 'P'),
(174269, 'Glen Haven', 42.8263893127441, 0.747461500248297, -91.0708312988281, -1.58948585869285, 218, 57, 'PPL', 'P'),
(194205, 'Glen Haven', 40.4538917541504, 0.706053606355309, -105.448608398438, -1.84042540819888, 218, 7, 'PPL', 'P'),
(162084, 'Glen Hazel', 41.5380592346191, 0.72497589853254, -78.6125030517578, -1.37204701148726, 218, 45, 'PPL', 'P'),
(149147, 'Glen Head', 40.8352813720703, 0.712710110920935, -73.6241683959961, -1.28498414755288, 218, 40, 'PPL', 'P'),
(124927, 'Glen Heights', 42.1569404602051, 0.735777413597792, -71.9930572509766, -1.25651588760632, 218, 23, 'PPL', 'P'),
(65039, 'Glen High Estates', 36.0819396972656, 0.629748648223331, -80.1444396972656, -1.39878434988333, 218, 33, 'PPL', 'P'),
(94493, 'Glen Hill', 32.894718170166, 0.574121138585001, -96.4741668701172, -1.68379185500198, 218, 51, 'PPL', 'P'),
(2733, 'Glen Hills', 33.378059387207, 0.582557034232964, -86.9775009155273, -1.51804376613233, 218, 2, 'PPL', 'P'),
(47460, 'Glen Hills', 39.0730590820313, 0.681953529807719, -77.2016677856445, -1.34742329089034, 218, 25, 'PPL', 'P'),
(47461, 'Glen Hollow', 39.1288909912109, 0.682927980450578, -76.6175003051758, -1.33722764497308, 218, 25, 'PPL', 'P'),
(162086, 'Glen Hope', 40.7983283996582, 0.712065159883945, -78.5002822875977, -1.37008838966357, 218, 45, 'PPL', 'P'),
(78348, 'Glen Hope (historical)', 39.728889465332, 0.693399929330934, -75.9027786254883, -1.32475339842715, 218, 45, 'PPL', 'P'),
(143870, 'Glen House', 44.288330078125, 0.772977180073319, -71.225830078125, -1.24312524732929, 218, 36, 'PPL', 'P'),
(178252, 'Glen Ilah', 34.2150001525879, 0.597164406233021, -112.758331298828, -1.96800414021912, 218, 5, 'PPL', 'P'),
(162088, 'Glen Iron', 40.8672218322754, 0.713267577116115, -77.2013931274414, -1.34741849720037, 218, 45, 'PPL', 'P'),
(47462, 'Glen Isle', 38.9577789306641, 0.679941511604164, -76.5905609130859, -1.33675746388262, 218, 25, 'PPL', 'P'),
(72676, 'Glen Jean', 39.1127815246582, 0.682646817218493, -82.9775009155273, -1.44823059605256, 218, 41, 'PPL', 'P'),
(109390, 'Glen Jean', 37.9263916015625, 0.661940406847991, -81.1502838134766, -1.41633964147303, 218, 58, 'PPL', 'P'),
(162089, 'Glen Junction', 40.9561080932617, 0.714818935030114, -76.1800003051758, -1.3295918294956, 218, 45, 'PPL', 'P'),
(155454, 'Glen Karn', 40.0097198486328, 0.69830134415917, -84.7919387817383, -1.4798985108908, 218, 41, 'PPL', 'P'),
(135573, 'Glen Knoll Mobile Home Park', 44.7750015258789, 0.781471199212072, -94.1694412231445, -1.64356680410715, 218, 28, 'PPL', 'P'),
(47463, 'Glen Kyle', 39.702220916748, 0.692934475351415, -75.8024978637695, -1.32300316895875, 218, 25, 'PPL', 'P'),
(135574, 'Glen Lake', 44.9033317565918, 0.783710984267856, -93.4672164916992, -1.63131067045449, 218, 28, 'PPL', 'P'),
(21413, 'Glen Leaf', 33.9463882446289, 0.592476244029073, -84.2472229003906, -1.47039142527338, 218, 13, 'PPL', 'P'),
(65040, 'Glen Lennox', 35.9147186279297, 0.626830089984713, -79.0269393920898, -1.37928029016597, 218, 33, 'PPL', 'P'),
(36103, 'Glen Lily', 37.3077812194824, 0.651143618893674, -85.7944412231445, -1.49739547925262, 218, 21, 'PPL', 'P'),
(131010, 'Glen Lord', 42.0411109924316, 0.733755808014313, -86.5061111450195, -1.50981646257675, 218, 27, 'PPL', 'P'),
(102273, 'Glen Lyn', 37.3680610656738, 0.652195700682309, -80.8644409179688, -1.41135074180298, 218, 53, 'PPL', 'P'),
(162092, 'Glen Lyon', 41.1749992370605, 0.71863930619286, -76.0749969482422, -1.32775917519146, 218, 45, 'PPL', 'P'),
(47464, 'Glen Mar Park', 38.9577789306641, 0.679941511604164, -77.1191711425781, -1.34598345284699, 218, 25, 'PPL', 'P'),
(181787, 'Glen Martin', 34.1458282470703, 0.595957128731861, -116.984718322754, -2.04176850925019, 218, 6, 'PPL', 'P'),
(2735, 'Glen Mary', 34.1241683959961, 0.595579093015124, -87.6236114501953, -1.52932052229411, 218, 2, 'PPL', 'P'),
(162090, 'Glen Mawr', 41.3136100769043, 0.721058521727088, -76.6536102294922, -1.33785788204504, 218, 45, 'PPL', 'P'),
(78349, 'Glen Mills', 39.9191703796387, 0.69672095778929, -75.491943359375, -1.31758297035016, 218, 45, 'PPL', 'P'),
(124928, 'Glen Mills', 42.7374992370605, 0.745910075755271, -70.9016723632813, -1.23746762790953, 218, 23, 'PPL', 'P'),
(162091, 'Glen Moore', 40.061939239502, 0.699212744463222, -76.3119430541992, -1.33189466489019, 218, 45, 'PPL', 'P'),
(109391, 'Glen Morgan', 37.7558288574219, 0.6589635253815, -81.1586074829102, -1.41648491691049, 218, 58, 'PPL', 'P'),
(47466, 'Glen Morris', 39.4861106872559, 0.689162640299536, -76.82861328125, -1.34091226149926, 218, 25, 'PPL', 'P'),
(72677, 'Glen Nell', 39.1474990844727, 0.683252752945514, -82.6213912963867, -1.44201531070053, 218, 41, 'PPL', 'P'),
(47467, 'Glen Oak', 38.5902786254883, 0.673527421276762, -76.9833297729492, -1.34361257368654, 218, 25, 'PPL', 'P'),
(119791, 'Glen Oak', 41.8816719055176, 0.730973070991289, -88.0391693115234, -1.53657337520683, 218, 18, 'PPL', 'P'),
(174271, 'Glen Oak', 43.7441711425781, 0.763479814993878, -89.3613891601563, -1.5596504650007, 218, 57, 'PPL', 'P'),
(2737, 'Glen Oaks', 34.8480606079102, 0.608213395542569, -87.7944412231445, -1.53230206429251, 218, 2, 'PPL', 'P'),
(21414, 'Glen Oaks', 33.9383316040039, 0.592335629123517, -83.445556640625, -1.45639970953833, 218, 13, 'PPL', 'P'),
(47468, 'Glen Oaks', 39.1622200012207, 0.683509681411679, -76.8300018310547, -1.34093649626518, 218, 25, 'PPL', 'P'),
(94494, 'Glen Oaks', 31.2688903808594, 0.54574509059118, -94.0980606079102, -1.64232097734921, 218, 51, 'PPL', 'P'),
(149148, 'Glen Oaks', 40.746940612793, 0.711168273807833, -73.7119369506836, -1.2865159978119, 218, 40, 'PPL', 'P'),
(178253, 'Glen Oaks', 34.4430618286133, 0.601144833377281, -112.547782897949, -1.96432937738898, 218, 5, 'PPL', 'P'),
(181788, 'Glen Oaks', 32.8383293151855, 0.573136967404163, -116.803062438965, -2.03859801597245, 218, 6, 'PPL', 'P'),
(135575, 'Glen Oaks Mobile Home Park', 45.6616706848145, 0.796946495411386, -93.9194412231445, -1.63920348097716, 218, 28, 'PPL', 'P'),
(47469, 'Glen Oban', 39.0361099243164, 0.681308645349756, -76.5219421386719, -1.33555984034042, 218, 25, 'PPL', 'P'),
(122692, 'Glen Park', 41.5416717529297, 0.725038948871347, -87.3361129760742, -1.52430272732624, 218, 19, 'PPL', 'P'),
(149149, 'Glen Park', 44.0011100769043, 0.767964245374435, -75.966667175293, -1.32586846397556, 218, 40, 'PPL', 'P'),
(186768, 'Glen Park', 39.1144409179688, 0.682675779095348, -104.919723510742, -1.83119462554456, 218, 7, 'PPL', 'P'),
(47470, 'Glen Query', 39.0733299255371, 0.681958256918653, -77.2763900756836, -1.34872744087615, 218, 25, 'PPL', 'P'),
(65042, 'Glen Raven', 36.1130599975586, 0.630291799927653, -79.4766693115234, -1.38712955800482, 218, 33, 'PPL', 'P'),
(162093, 'Glen Richey', 40.9488906860352, 0.714692967510553, -78.4780578613281, -1.3697005002508, 218, 45, 'PPL', 'P'),
(78350, 'Glen Riddle', 39.8938903808594, 0.696279738575691, -75.4341735839844, -1.31657469756146, 218, 45, 'PPL', 'P'),
(16217, 'Glen Ridge', 26.6691703796387, 0.465464831900041, -80.0744400024414, -1.39756262473326, 218, 12, 'PPL', 'P'),
(21415, 'Glen Ridge', 33.6791687011719, 0.587812383170071, -84.8119430541992, -1.48024765130971, 218, 13, 'PPL', 'P'),
(47471, 'Glen Ridge', 39.1897201538086, 0.683989649619139, -76.6166687011719, -1.33721313074514, 218, 25, 'PPL', 'P'),
(113474, 'Glen Ridge', 41.5011100769043, 0.724331014074577, -73.0658264160156, -1.27523924165012, 218, 8, 'PPL', 'P'),
(145300, 'Glen Ridge', 40.8052787780762, 0.712186466871598, -74.2041702270508, -1.29510708917238, 218, 37, 'PPL', 'P'),
(72678, 'Glen Ridge Acres', 39.1027793884277, 0.682472247009039, -84.2675018310547, -1.47074535938225, 218, 41, 'PPL', 'P'),
(155455, 'Glen Robbins', 40.1611099243164, 0.700943599434692, -80.7433319091797, -1.40923699084578, 218, 41, 'PPL', 'P'),
(78351, 'Glen Rock', 39.7930603027344, 0.694519921727366, -76.7305603027344, -1.33920091418277, 218, 45, 'PPL', 'P'),
(102274, 'Glen Rock', 36.8502807617188, 0.643158729576316, -76.1988906860352, -1.32992152883855, 218, 53, 'PPL', 'P'),
(145301, 'Glen Rock', 40.9627799987793, 0.714935381748778, -74.1333312988281, -1.29387071663632, 218, 37, 'PPL', 'P'),
(169393, 'Glen Rock', 41.5166702270508, 0.724602589926738, -71.602783203125, -1.24970432048622, 218, 47, 'PPL', 'P'),
(109392, 'Glen Rogers', 37.7152786254883, 0.658255790321812, -81.4180603027344, -1.42101322287001, 218, 58, 'PPL', 'P'),
(9133, 'Glen Rose', 34.4555587768555, 0.601362946270558, -92.7294387817383, -1.61843402026785, 218, 4, 'PPL', 'P'),
(94495, 'Glen Rose', 32.2344398498535, 0.56259710791601, -97.754997253418, -1.70614656235016, 218, 51, 'PPL', 'P'),
(72679, 'Glen Roy', 39.1124992370605, 0.682641890370477, -82.579719543457, -1.44128800140683, 218, 41, 'PPL', 'P'),
(78352, 'Glen Roy', 39.7666702270508, 0.694059328016837, -76.0497207641602, -1.32731802255689, 218, 45, 'PPL', 'P'),
(102275, 'Glen Roy Estates', 37.4044418334961, 0.652830664865211, -76.48388671875, -1.33489564796455, 218, 53, 'PPL', 'P'),
(155456, 'Glen Run', 40.1949996948242, 0.701535087512799, -80.7458267211914, -1.40928053352961, 218, 41, 'PPL', 'P'),
(16218, 'Glen Saint Mary', 30.2755603790283, 0.528408211500387, -82.1608276367188, -1.43397695842429, 218, 12, 'PPL', 'P'),
(78353, 'Glen Savage', 39.9097213745117, 0.696556041538786, -78.7827835083008, -1.37501896610574, 218, 45, 'PPL', 'P'),
(149150, 'Glen Spey', 41.4786109924316, 0.723938330971845, -74.8138885498047, -1.30574868141418, 218, 40, 'PPL', 'P'),
(36104, 'Glen Springs', 38.5108299255371, 0.672140779876185, -83.4852828979492, -1.45709306352813, 218, 21, 'PPL', 'P'),
(162094, 'Glen Summit', 41.146110534668, 0.71813510321948, -75.8605575561523, -1.32401650175352, 218, 45, 'PPL', 'P'),
(72690, 'Glen Summitt', 38.9469413757324, 0.679752360587741, -82.3241729736328, -1.43682787237122, 218, 41, 'PPL', 'P'),
(54971, 'Glen Town', 37.5122184753418, 0.654711722122162, -93.8066711425781, -1.63723527177354, 218, 29, 'PPL', 'P'),
(198336, 'Glen Ullin', 46.814998626709, 0.817075865352696, -101.829437255859, -1.77725895556773, 218, 34, 'PPL', 'P'),
(162095, 'Glen Union', 41.2536087036133, 0.720011300207441, -77.6102828979492, -1.35455496997346, 218, 45, 'PPL', 'P'),
(181789, 'Glen Valley', 33.8619384765625, 0.591002317523768, -117.32527923584, -2.04771241848714, 218, 6, 'PPL', 'P'),
(109393, 'Glen View', 37.7413902282715, 0.658711523763352, -81.2577819824219, -1.41821583846099, 218, 58, 'PPL', 'P'),
(21416, 'Glen Villa', 33.7125015258789, 0.588394150710199, -84.6774978637695, -1.47790114007324, 218, 13, 'PPL', 'P'),
(47472, 'Glen Westover', 39.7136116027832, 0.693133280326789, -75.7972183227539, -1.32291102358503, 218, 25, 'PPL', 'P'),
(109394, 'Glen White', 37.730281829834, 0.658517645635994, -81.2799987792969, -1.4186035947157, 218, 58, 'PPL', 'P'),
(109395, 'Glen White Junction (historical)', 37.7611083984375, 0.659055670755217, -81.2936096191406, -1.41884114868494, 218, 58, 'PPL', 'P'),
(149151, 'Glen Wild', 41.6538887023926, 0.726997504116019, -74.5872192382813, -1.30179255561486, 218, 40, 'PPL', 'P'),
(162096, 'Glen Willow', 40.0347213745117, 0.698737703103779, -75.2261123657227, -1.31294334425708, 218, 45, 'PPL', 'P'),
(102276, 'Glen Wilton', 37.7527809143066, 0.658910328738726, -79.8191680908203, -1.39310728938761, 218, 53, 'PPL', 'P'),
(87279, 'Glen Wright', 35.8844413757324, 0.626301652245414, -84.5416717529297, -1.47553052722891, 218, 50, 'PPL', 'P'),
(200889, 'Glenada', 43.9605598449707, 0.767256510314747, -124.102783203125, -2.16600217778325, 218, 43, 'PPL', 'P'),
(54972, 'Glenaire', 39.2213897705078, 0.684542388703384, -94.4511108398438, -1.64848286632138, 218, 29, 'PPL', 'P'),
(102277, 'Glenaire', 38.0658302307129, 0.664374070031133, -78.6291732788086, -1.37233796183636, 218, 53, 'PPL', 'P'),
(47473, 'Glenallen', 39.059440612793, 0.681715842680429, -77.0427780151367, -1.34465014124724, 218, 25, 'PPL', 'P'),
(54973, 'Glenallen', 37.3177795410156, 0.651318122524101, -90.0277786254883, -1.57128115527135, 218, 29, 'PPL', 'P'),
(124929, 'Glenallen', 42.6816711425781, 0.744935691691438, -72.0255584716797, -1.25708314091851, 218, 23, 'PPL', 'P'),
(47474, 'Glenangus', 39.5180587768555, 0.689720239652771, -76.3030624389648, -1.33173966891475, 218, 25, 'PPL', 'P'),
(47475, 'Glenarden', 38.9291687011719, 0.679442168899774, -76.8619384765625, -1.34149389588133, 218, 25, 'PPL', 'P'),
(27270, 'Glenarm', 39.6236114501953, 0.691562481336833, -89.6488876342773, -1.56466825996857, 218, 18, 'PPL', 'P'),
(36105, 'Glenarm', 38.3536109924316, 0.669396791847022, -85.4630584716797, -1.49161175915524, 218, 21, 'PPL', 'P'),
(47477, 'Glenartney', 39.230281829834, 0.684697584415909, -76.728889465332, -1.33917175256884, 218, 25, 'PPL', 'P'),
(178254, 'Glenbar', 32.9166717529297, 0.574504300886836, -109.857498168945, -1.91737505105174, 218, 5, 'PPL', 'P'),
(47478, 'Glenbauer', 39.461109161377, 0.688726281354926, -76.4044418334961, -1.333509073143, 218, 25, 'PPL', 'P'),
(196600, 'Glenbeg (historical)', 46.3694381713867, 0.809299368390637, -112.147216796875, -1.95733818005336, 218, 31, 'PPL', 'P'),
(174273, 'Glenbeulah', 43.7972183227539, 0.764405662946844, -88.0472183227539, -1.53671385695434, 218, 57, 'PPL', 'P'),
(181790, 'Glenblair', 39.4577789306641, 0.688668157864135, -123.724166870117, -2.15939407617043, 218, 6, 'PPL', 'P'),
(41094, 'Glenbrook', 30.5013904571533, 0.532349689913704, -91.0430603027344, -1.58900116337446, 218, 22, 'PPL', 'P'),
(47480, 'Glenbrook', 38.9952812194824, 0.680596050021078, -77.0924987792969, -1.34551793228844, 218, 25, 'PPL', 'P'),
(113475, 'Glenbrook', 41.0647201538086, 0.716714573094032, -73.5266723632813, -1.28328252077438, 218, 8, 'PPL', 'P'),
(181792, 'Glenbrook', 39.2422218322754, 0.684905976771208, -121.034439086914, -2.11244947037117, 218, 6, 'PPL', 'P'),
(190243, 'Glenbrook', 39.0894393920898, 0.682239420150738, -119.938056945801, -2.09331399214868, 218, 39, 'PPL', 'P'),
(200890, 'Glenbrook', 44.3138885498047, 0.773423259555907, -123.405281066895, -2.15382846896633, 218, 43, 'PPL', 'P'),
(102278, 'Glenbrook Hills', 37.5802803039551, 0.655899625126392, -77.5630569458008, -1.35373072161608, 218, 53, 'PPL', 'P'),
(47481, 'Glenbrook Knoll', 38.9916687011719, 0.68053299968227, -77.1025009155273, -1.34569250249789, 218, 25, 'PPL', 'P'),
(155457, 'Glenburg (historical)', 41.4249992370605, 0.723002629322846, -84.4591674804688, -1.4740905560275, 218, 41, 'PPL', 'P'),
(65044, 'Glenburine (historical)', 35.8899993896484, 0.626398657888121, -81.6233291625977, -1.42459584032644, 218, 33, 'PPL', 'P'),
(119792, 'Glenburn', 40.1427803039551, 0.700623687208746, -87.7683334350586, -1.53184639743, 218, 18, 'PPL', 'P'),
(162097, 'Glenburn', 41.523609161377, 0.724723697177309, -75.7241668701172, -1.32163603521315, 218, 45, 'PPL', 'P'),
(193593, 'Glenburn', 41.0613899230957, 0.716656449603241, -121.489166259766, -2.12038595673571, 218, 6, 'PPL', 'P'),
(198338, 'Glenburn', 48.5130615234375, 0.846712653806561, -101.220283508301, -1.76662721702197, 218, 34, 'PPL', 'P'),
(127569, 'Glenburn Center', 44.9105606079102, 0.783837151524498, -68.8477783203125, -1.20162041437262, 218, 26, 'PPL', 'P'),
(149159, 'Glenburnie', 43.7633285522461, 0.763814174868738, -73.456672668457, -1.2820607956243, 218, 40, 'PPL', 'P'),
(36106, 'Glencairn', 37.7636108398438, 0.659099346597094, -83.6699981689453, -1.46031695318572, 218, 21, 'PPL', 'P'),
(149153, 'Glencairn', 42.0788917541504, 0.734415206700217, -76.4899978637695, -1.33500230756621, 218, 40, 'PPL', 'P'),
(102279, 'Glencarlyn', 38.8616714477539, 0.678264119591577, -77.1294403076172, -1.34616268358835, 218, 53, 'PPL', 'P'),
(21417, 'Glencastle Estates', 33.9011116027832, 0.591686017554619, -84.4005584716797, -1.4730676358528, 218, 13, 'PPL', 'P'),
(21418, 'Glencliff', 32.9075012207031, 0.574344244905323, -84.4250030517578, -1.47349427425943, 218, 13, 'PPL', 'P'),
(87280, 'Glencliff', 36.122501373291, 0.630456583020102, -86.7183303833008, -1.51352038702083, 218, 50, 'PPL', 'P'),
(143871, 'Glencliff', 43.982780456543, 0.76764433314849, -71.8938903808594, -1.25478509921388, 218, 36, 'PPL', 'P'),
(149154, 'Glenclyffe', 41.3680610656738, 0.722008870762083, -73.9488906860352, -1.29065162066868, 218, 40, 'PPL', 'P'),
(149155, 'Glenco Mills', 42.1494407653809, 0.735646519230215, -73.7411117553711, -1.28702519421232, 218, 40, 'PPL', 'P'),
(2740, 'Glencoe', 33.5038909912109, 0.584753210025897, -86.7416687011719, -1.51392771750956, 218, 2, 'PPL', 'P'),
(9134, 'Glencoe', 36.2941703796387, 0.633452772404495, -91.7472229003906, -1.60129111917296, 218, 4, 'PPL', 'P'),
(16219, 'Glencoe', 29.0255603790283, 0.506591595850457, -80.9722213745117, -1.41323186563896, 218, 12, 'PPL', 'P'),
(21419, 'Glencoe', 31.1355590820313, 0.543418020430669, -81.7244415283203, -1.42636058402278, 218, 13, 'PPL', 'P'),
(36107, 'Glencoe', 38.7144393920898, 0.67569443545576, -84.8227767944336, -1.48043673574711, 218, 21, 'PPL', 'P'),
(41095, 'Glencoe', 29.8055591583252, 0.520205142710724, -91.6677780151367, -1.59990454435141, 218, 22, 'PPL', 'P'),
(47483, 'Glencoe', 39.3641700744629, 0.687034375114399, -75.9491729736328, -1.32556313255659, 218, 25, 'PPL', 'P'),
(54974, 'Glencoe', 38.5444412231445, 0.672727407685302, -90.6236114501953, -1.58168039985394, 218, 29, 'PPL', 'P'),
(65046, 'Glencoe', 36.1388893127441, 0.630742606521176, -79.4280624389648, -1.38628120803957, 218, 33, 'PPL', 'P'),
(75929, 'Glencoe', 36.2286109924316, 0.632308545242143, -96.9252777099609, -1.69166522444869, 218, 42, 'PPL', 'P'),
(78354, 'Glencoe', 39.8211097717285, 0.69500947731475, -78.845832824707, -1.37611938426816, 218, 45, 'PPL', 'P'),
(119817, 'Glencoe', 42.1349983215332, 0.735394451033039, -87.758056640625, -1.53166703353058, 218, 18, 'PPL', 'P'),
(131011, 'Glencoe', 43.964168548584, 0.767319494074527, -82.8858337402344, -1.4466307020277, 218, 27, 'PPL', 'P'),
(135577, 'Glencoe', 44.7691688537598, 0.781369399879404, -94.1513900756836, -1.64325175215019, 218, 28, 'PPL', 'P'),
(155458, 'Glencoe', 40.0080604553223, 0.698272382282315, -80.8877792358398, -1.41175807229171, 218, 41, 'PPL', 'P'),
(174275, 'Glencoe', 44.2752799987793, 0.77274941322109, -91.6116714477539, -1.59892530001859, 218, 57, 'PPL', 'P'),
(181793, 'Glencoe', 38.3541717529297, 0.669406578964028, -120.583892822266, -2.10458595462049, 218, 6, 'PPL', 'P'),
(188614, 'Glencoe', 33.4091682434082, 0.583099986200204, -105.448333740234, -1.84042061450892, 218, 38, 'PPL', 'P'),
(194996, 'Glencoe', 42.0111083984375, 0.733232163964976, -111.407501220703, -1.94442770772087, 218, 17, 'PPL', 'P'),
(200891, 'Glencoe', 45.6002807617188, 0.79587503912582, -122.990829467773, -2.14659492397151, 218, 43, 'PPL', 'P'),
(141912, 'Glencoe (historical)', 41.6541709899902, 0.727002430964036, -96.8486099243164, -1.69032711915898, 218, 35, 'PPL', 'P'),
(190244, 'Glencoe (historical)', 39.6627807617188, 0.692246114788657, -114.206108093262, -1.99327261211596, 218, 39, 'PPL', 'P'),
(47484, 'Glencoe Manor', 39.5433311462402, 0.690161325708315, -76.646110534668, -1.33772698767747, 218, 25, 'PPL', 'P'),
(81230, 'Glencove', 34.1997184753418, 0.59689769064985, -79.7083282470703, -1.39117276917178, 218, 48, 'PPL', 'P'),
(181794, 'Glencove', 38.0686111450195, 0.664422606141999, -122.205833435059, -2.13289415858554, 218, 6, 'PPL', 'P'),
(207507, 'Glencove', 47.3461112976074, 0.826345530158934, -122.735832214355, -2.14214438231583, 218, 56, 'PPL', 'P'),
(202156, 'Glencross', 45.4483299255371, 0.793222996733292, -100.920829772949, -1.76140076338269, 218, 49, 'PPL', 'P'),
(200892, 'Glencullen', 45.4872207641602, 0.793901769916126, -122.719169616699, -2.14185356512479, 218, 43, 'PPL', 'P'),
(2741, 'Glendale', 33.6047210693359, 0.586513026874222, -86.8047180175781, -1.51502813567198, 218, 2, 'PPL', 'P'),
(9137, 'Glendale', 35.149169921875, 0.613468744479677, -94.0022201538086, -1.64064824586853, 218, 4, 'PPL', 'P'),
(13825, 'Glendale', 39.6269416809082, 0.691620604827624, -75.6688919067383, -1.32067130510827, 218, 10, 'PPL', 'P'),
(16220, 'Glendale', 30.8627796173096, 0.538657120639447, -86.1144409179688, -1.50298052753268, 218, 12, 'PPL', 'P'),
(27271, 'Glendale', 37.4555587768555, 0.653722823830388, -88.67138671875, -1.54760765055136, 218, 18, 'PPL', 'P'),
(29899, 'Glendale', 39.7880592346191, 0.694432636622639, -86.2027816772461, -1.50452236464578, 218, 19, 'PPL', 'P'),
(32557, 'Glendale', 38.8983306884766, 0.678903944043469, -97.8747177124023, -1.70823607854143, 218, 20, 'PPL', 'P'),
(36108, 'Glendale', 37.6016693115234, 0.656272933732193, -85.9055633544922, -1.49933492631647, 218, 21, 'PPL', 'P'),
(47485, 'Glendale', 39.3797187805176, 0.687305751229478, -76.5858306884766, -1.33667490588883, 218, 25, 'PPL', 'P'),
(60049, 'Glendale', 31.3644409179688, 0.547412762065787, -89.3061065673828, -1.55868560173776, 218, 30, 'PPL', 'P'),
(75931, 'Glendale', 34.9230613708496, 0.60952240579737, -94.7091674804688, -1.65298680435692, 218, 42, 'PPL', 'P'),
(81233, 'Glendale', 34.9447212219238, 0.609900441514107, -81.8377838134766, -1.42833878008049, 218, 48, 'PPL', 'P'),
(87287, 'Glendale', 36.327220916748, 0.634029613096606, -82.6066665649414, -1.44175831565534, 218, 50, 'PPL', 'P'),
(94496, 'Glendale', 31.0155601501465, 0.541323643970403, -95.3008270263672, -1.6633132114837, 218, 51, 'PPL', 'P'),
(102284, 'Glendale', 37.3138885498047, 0.651250211916304, -80.0141677856445, -1.39651067610268, 218, 53, 'PPL', 'P'),
(109409, 'Glendale', 39.9491691589355, 0.697244535259599, -80.7544403076172, -1.40943086897314, 218, 58, 'PPL', 'P'),
(124931, 'Glendale', 42.413890838623, 0.740262043715431, -71.0486068725586, -1.24003211888122, 218, 23, 'PPL', 'P'),
(131012, 'Glendale', 42.3027801513672, 0.738322796388663, -85.9563903808594, -1.50022202527558, 218, 27, 'PPL', 'P'),
(135581, 'Glendale', 48.0325012207031, 0.838325294269465, -92.8308334350586, -1.62020369081221, 218, 28, 'PPL', 'P'),
(139176, 'Glendale', 40.4866714477539, 0.706625719936485, -92.7633285522461, -1.61902550834596, 218, 29, 'PPL', 'P'),
(143872, 'Glendale', 43.5825004577637, 0.760658129239912, -71.3874969482422, -1.24594686650423, 218, 36, 'PPL', 'P'),
(145303, 'Glendale', 40.2463912963867, 0.702432040167937, -74.7827835083008, -1.30520579602596, 218, 37, 'PPL', 'P'),
(149158, 'Glendale', 41.1969413757324, 0.719022268757613, -73.8455581665039, -1.28884812797848, 218, 40, 'PPL', 'P'),
(155460, 'Glendale', 41.3969383239746, 0.72251287399838, -81.5425033569336, -1.42318516389702, 218, 41, 'PPL', 'P'),
(162101, 'Glendale', 41.3388900756836, 0.721499740940687, -75.7058334350586, -1.32131605640818, 218, 45, 'PPL', 'P'),
(169394, 'Glendale', 41.9761085510254, 0.732621301389939, -71.633056640625, -1.25023269164649, 218, 47, 'PPL', 'P'),
(174278, 'Glendale', 43.7822189331055, 0.764143874211689, -90.3455581665039, -1.57682745455754, 218, 57, 'PPL', 'P'),
(178255, 'Glendale', 33.5386085510254, 0.585359145752918, -112.185279846191, -1.95800250558728, 218, 5, 'PPL', 'P'),
(190246, 'Glendale', 39.5205612182617, 0.689763915494648, -119.739440917969, -2.08984748851578, 218, 39, 'PPL', 'P'),
(192586, 'Glendale', 37.3177795410156, 0.651318122524101, -112.596389770508, -1.96517772735422, 218, 52, 'PPL', 'P'),
(193594, 'Glendale', 40.9000015258789, 0.713839690697292, -124.015830993652, -2.16448457543606, 218, 6, 'PPL', 'P'),
(194206, 'Glendale', 40.0819396972656, 0.699561818303104, -105.365829467773, -1.83898064330751, 218, 7, 'PPL', 'P'),
(194998, 'Glendale', 42.1300010681152, 0.735307232507339, -111.704170227051, -1.94960555867026, 218, 17, 'PPL', 'P'),
(196601, 'Glendale', 45.6419410705566, 0.796602148682439, -112.772216796875, -1.96824648787832, 218, 31, 'PPL', 'P'),
(200894, 'Glendale', 45.6444396972656, 0.796645757945289, -118.822219848633, -2.0738389608872, 218, 43, 'PPL', 'P'),
(207509, 'Glendale', 47.5130615234375, 0.829259361286617, -122.314720153809, -2.13479459033943, 218, 56, 'PPL', 'P'),
(60051, 'Glendale (historical)', 34.5166702270508, 0.602429542287135, -90.5758285522461, -1.58084643095858, 218, 30, 'PPL', 'P'),
(102285, 'Glendale (historical)', 38.8188896179199, 0.677517435800946, -77.9013900756836, -1.35963574870111, 218, 53, 'PPL', 'P'),
(119794, 'Glendale (historical)', 41.4855613708496, 0.724059637959498, -90.4155578613281, -1.57804917970762, 218, 18, 'PPL', 'P'),
(162102, 'Glendale (historical)', 41.0330581665039, 0.716161967167841, -78.6241683959961, -1.3722506101526, 218, 45, 'PPL', 'P'),
(2742, 'Glendale Acres', 32.6036109924316, 0.569040359857348, -86.0469436645508, -1.50180247822449, 218, 2, 'PPL', 'P'),
(81236, 'Glendale Acres', 34.2055587768555, 0.596999623140572, -79.6986083984375, -1.39100312581034, 218, 48, 'PPL', 'P'),
(87288, 'Glendale Acres', 36.2566719055176, 0.632798300566608, -83.2119369506836, -1.45232227675136, 218, 50, 'PPL', 'P'),
(170386, 'Glendale Colony', 44.7994384765625, 0.781897704460648, -98.2872161865234, -1.7154355350743, 218, 49, 'PPL', 'P'),
(196602, 'Glendale Colony', 48.8444404602051, 0.852496307324913, -112.544441223145, -1.96427105416111, 218, 31, 'PPL', 'P'),
(87289, 'Glendale Estates', 35.1988906860352, 0.614336535520879, -87.0119400024414, -1.51864484159037, 218, 50, 'PPL', 'P'),
(21420, 'Glendale Gardens', 31.2180595397949, 0.544857925053047, -81.5336074829102, -1.42302990160547, 218, 13, 'PPL', 'P'),
(29900, 'Glendale Heights', 39.8858299255371, 0.696139057091107, -86.1108322143555, -1.5029175437729, 218, 19, 'PPL', 'P'),
(47486, 'Glendale Heights', 38.9747200012207, 0.68023718906419, -76.8169403076172, -1.34070852967587, 218, 25, 'PPL', 'P'),
(109398, 'Glendale Heights', 39.9605598449707, 0.697443340234974, -80.7458267211914, -1.40928053352961, 218, 58, 'PPL', 'P'),
(113034, 'Glendale Heights', 41.9102783203125, 0.731472347116652, -88.0716705322266, -1.53714062851902, 218, 18, 'PPL', 'P'),
(36109, 'Glendale Junction', 37.5913887023926, 0.656093503253749, -85.8636093139648, -1.49860269017476, 218, 21, 'PPL', 'P'),
(181796, 'Glendale Junction', 34.0752792358398, 0.594725816201863, -118.224166870117, -2.06340096731074, 218, 6, 'PPL', 'P'),
(115748, 'Glendale Mobile Home Park', 41.5288887023926, 0.724815842551026, -90.4800033569336, -1.57917396579401, 218, 16, 'PPL', 'P'),
(87290, 'Glendale Park', 36.0972213745117, 0.630015363806503, -86.7861099243164, -1.51470336317705, 218, 50, 'PPL', 'P'),
(204090, 'Glendale Park', 40.7333297729492, 0.710930719838598, -111.933326721191, -1.95360509399534, 218, 52, 'PPL', 'P'),
(65048, 'Glendale Springs', 36.3450012207031, 0.634339937942628, -81.3805618286133, -1.42035875103212, 218, 33, 'PPL', 'P'),
(47487, 'Glendale Terrace', 39.1552810668945, 0.683388574161108, -76.6069412231445, -1.33704335422564, 218, 25, 'PPL', 'P'),
(178256, 'Glendale West Mobile Home Park', 33.5397186279297, 0.585378520249848, -112.230560302734, -1.95879279864076, 218, 5, 'PPL', 'P'),
(194207, 'Glendevey', 40.8102798461914, 0.712273751976325, -105.934440612793, -1.84890477995164, 218, 7, 'PPL', 'P'),
(102286, 'Glendie', 38.3997192382813, 0.670201532549417, -77.5352783203125, -1.35324589313963, 218, 53, 'PPL', 'P'),
(196603, 'Glendive', 47.105281829834, 0.822142263010462, -104.711936950684, -1.82756806593014, 218, 31, 'PPL', 'P'),
(209474, 'Glendo', 42.5027809143066, 0.741813468208457, -105.02555847168, -1.83304179407663, 218, 59, 'PPL', 'P'),
(145304, 'Glendola', 40.1908302307129, 0.701462316636012, -74.0772171020508, -1.29289133914544, 218, 37, 'PPL', 'P'),
(65049, 'Glendon', 35.4822196960449, 0.619281559611966, -79.4172210693359, -1.38609199044412, 218, 33, 'PPL', 'P'),
(72684, 'Glendon', 39.5083312988281, 0.689550463133279, -83.5508270263672, -1.45823702437437, 218, 41, 'PPL', 'P'),
(109399, 'Glendon', 38.5911102294922, 0.673541935504703, -80.8888931274414, -1.41177751336767, 218, 58, 'PPL', 'P'),
(113093, 'Glendon', 44.1011085510254, 0.769709547994819, -69.4511108398438, -1.2121505533228, 218, 26, 'PPL', 'P'),
(115749, 'Glendon', 41.5944404602051, 0.725959936555324, -94.4019393920898, -1.6476246626601, 218, 16, 'PPL', 'P'),
(162114, 'Glendon', 40.6661109924316, 0.709757530799391, -75.2363891601563, -1.3131227081565, 218, 45, 'PPL', 'P'),
(29901, 'Glendora', 39.128059387207, 0.682913466222637, -87.3627777099609, -1.52476811472673, 218, 19, 'PPL', 'P'),
(60053, 'Glendora', 33.8291702270508, 0.590430403679674, -90.2930603027344, -1.5759111939845, 218, 30, 'PPL', 'P'),
(70870, 'Glendora', 39.8394393920898, 0.695329389540696, -75.0738906860352, -1.31028657475362, 218, 37, 'PPL', 'P'),
(131013, 'Glendora', 41.8849983215332, 0.731031127903053, -86.4869384765625, -1.50948183638578, 218, 27, 'PPL', 'P'),
(181797, 'Glendora', 34.1361083984375, 0.595787485370423, -117.864440917969, -2.05712256504088, 218, 6, 'PPL', 'P'),
(135582, 'Glendorado', 45.5780601501465, 0.795487216292077, -93.7694396972656, -1.63658546046756, 218, 28, 'PPL', 'P'),
(102287, 'Glendower', 37.8372192382813, 0.660384055506949, -78.5438919067383, -1.37084952110311, 218, 53, 'PPL', 'P'),
(162104, 'Glendower', 40.7125015258789, 0.710567198349802, -76.3238906860352, -1.33210319040355, 218, 45, 'PPL', 'P'),
(102288, 'Glendoyle (historical)', 37.0519409179688, 0.646678363272965, -77.5625, -1.3537210010781, 218, 53, 'PPL', 'P'),
(186770, 'Gleneagle', 39.045280456543, 0.68146870133127, -104.823890686035, -1.82952202722193, 218, 7, 'PPL', 'P'),
(200895, 'Gleneden Beach', 44.8813896179199, 0.783328021703102, -124.033058166504, -2.16478524632313, 218, 43, 'PPL', 'P'),
(47488, 'Glenelg', 39.2641716003418, 0.685289072494015, -76.9927825927734, -1.34377755651607, 218, 25, 'PPL', 'P'),
(186771, 'Glenelk', 39.4633293151855, 0.688765030348787, -105.35417175293, -1.83877717780023, 218, 7, 'PPL', 'P'),
(21421, 'Glenell', 34.1152801513672, 0.595423963881627, -84.5791702270508, -1.4761849990668, 218, 13, 'PPL', 'P'),
(149180, 'Glenerie', 42.0336112976074, 0.733624913646736, -73.9733276367188, -1.29107812591726, 218, 40, 'PPL', 'P'),
(149160, 'Glenerie Lake Park', 42.0136108398438, 0.733275839806854, -73.9855575561523, -1.29129157827863, 218, 40, 'PPL', 'P'),
(94497, 'Glenfawn', 31.913610458374, 0.556997578697523, -94.8566665649414, -1.65556114902465, 218, 51, 'PPL', 'P'),
(60054, 'Glenfield', 34.5111083984375, 0.602332470065401, -89.0336074829102, -1.55392959550504, 218, 30, 'PPL', 'P'),
(65050, 'Glenfield', 35.3819389343262, 0.617531330143565, -77.6355590820313, -1.35499612260803, 218, 33, 'PPL', 'P'),
(140095, 'Glenfield', 47.4533309936523, 0.828216866877906, -98.5669403076172, -1.72031764198463, 218, 34, 'PPL', 'P'),
(145305, 'Glenfield', 40.7430610656738, 0.711100562937118, -74.4055633544922, -1.29862206233713, 218, 37, 'PPL', 'P'),
(149161, 'Glenfield', 43.7102813720703, 0.762888326915772, -75.4024963378906, -1.31602182531916, 218, 40, 'PPL', 'P'),
(162105, 'Glenfield', 40.5180587768555, 0.707173532172714, -80.1305618286133, -1.39854213538219, 218, 45, 'PPL', 'P'),
(65051, 'Glenfield Crossroads', 35.3930587768555, 0.617725408008005, -77.6163864135742, -1.35466149641706, 218, 33, 'PPL', 'P'),
(72685, 'Glenford', 39.8880615234375, 0.69617800582205, -82.3172225952148, -1.43670656538357, 218, 41, 'PPL', 'P'),
(102314, 'Glenford', 36.7900009155273, 0.64210664778768, -81.9297180175781, -1.42994333463726, 218, 53, 'PPL', 'P'),
(149162, 'Glenford', 42.002498626709, 0.733081895100469, -74.1266708374023, -1.29375446965473, 218, 40, 'PPL', 'P'),
(21422, 'Glenford (historical)', 33.2580604553223, 0.580462657772698, -83.033332824707, -1.44920504669542, 218, 13, 'PPL', 'P'),
(21423, 'Glenforest', 34.0499992370605, 0.594284596988264, -84.4180603027344, -1.47337310042984, 218, 13, 'PPL', 'P'),
(196604, 'Glengarry', 47.0269393920898, 0.820774929527788, -109.547218322754, -1.91195964613312, 218, 31, 'PPL', 'P'),
(109400, 'Glengary', 39.3838882446289, 0.687378522106264, -78.1558303833008, -1.36407656981882, 218, 58, 'PPL', 'P'),
(131015, 'Glengary', 44.4230613708496, 0.775328684736831, -85.7211074829102, -1.49611556403273, 218, 27, 'PPL', 'P'),
(194999, 'Glengary', 48.2219390869141, 0.841631608762798, -116.373611450195, -2.03110268224248, 218, 17, 'PPL', 'P'),
(47489, 'Glengate', 39.5094413757324, 0.689569837630209, -76.3280563354492, -1.33217589470131, 218, 25, 'PPL', 'P'),
(78355, 'Glenhall', 39.9302787780762, 0.696914835916647, -75.7138900756836, -1.32145667131374, 218, 45, 'PPL', 'P'),
(122693, 'Glenhall', 40.3541717529297, 0.704313164003915, -87.0408325195313, -1.51914911114277, 218, 19, 'PPL', 'P'),
(149163, 'Glenham', 41.521671295166, 0.724689875031465, -73.9269409179688, -1.29026852494587, 218, 40, 'PPL', 'P'),
(202158, 'Glenham', 45.5327796936035, 0.794696923238596, -100.271110534668, -1.75006102346113, 218, 49, 'PPL', 'P'),
(81238, 'Glenhaven', 35.0697212219238, 0.6120821030791, -81.6069412231445, -1.42430981682536, 218, 48, 'PPL', 'P'),
(181798, 'Glenhaven', 39.0263900756836, 0.681139001988318, -122.731941223145, -2.14207647170803, 218, 6, 'PPL', 'P'),
(109401, 'Glenhayes', 38.0141716003418, 0.663472456844086, -82.5213928222656, -1.44027000808015, 218, 58, 'PPL', 'P'),
(186772, 'Glenisle', 39.4088897705078, 0.687814881050874, -105.509170532227, -1.84148241683553, 218, 7, 'PPL', 'P'),
(102290, 'Glenita', 36.6952781677246, 0.640453423961986, -82.7505569458008, -1.44426967656329, 218, 53, 'PPL', 'P'),
(9138, 'Glenlake', 34.1933288574219, 0.596786170779202, -91.8891677856445, -1.603768524777, 218, 4, 'PPL', 'P'),
(162108, 'Glenlake', 40.1766700744629, 0.701215175286853, -74.8930587768555, -1.30713046254577, 218, 45, 'PPL', 'P'),
(102291, 'Glenland', 36.999439239502, 0.645762036120896, -79.2183303833008, -1.38262069312126, 218, 53, 'PPL', 'P'),
(65053, 'Glenlaurel', 35.8358306884766, 0.625453235701142, -82.1130599975586, -1.43314325584504, 218, 33, 'PPL', 'P'),
(21425, 'Glenloch', 33.4091682434082, 0.583099986200204, -85.0861129760742, -1.48503281915637, 218, 13, 'PPL', 'P'),
(162109, 'Glenloch', 40.0299987792969, 0.698655278268041, -75.5849990844727, -1.31920709914095, 218, 45, 'PPL', 'P'),
(32559, 'Glenlock', 38.310001373291, 0.668635660407477, -95.341667175293, -1.66402600654946, 218, 20, 'PPL', 'P'),
(47492, 'Glenmar', 39.2238883972168, 0.684585997966235, -76.8027801513672, -1.34046138832671, 218, 25, 'PPL', 'P'),
(177398, 'Glenmar', 40.5544395446777, 0.707808496355616, -81.2113876342773, -1.41740610433155, 218, 41, 'PPL', 'P'),
(162110, 'Glenmar Gardens', 42.0641708374023, 0.734158278234051, -80.0422210693359, -1.39700029826909, 218, 45, 'PPL', 'P'),
(47493, 'Glenmar Manor', 39.3444404602051, 0.686690028385452, -76.4452819824219, -1.33422186820876, 218, 25, 'PPL', 'P'),
(149164, 'Glenmark', 43.1913909912109, 0.753831981312848, -76.9130630493164, -1.34238618800456, 218, 40, 'PPL', 'P'),
(87293, 'Glenmary', 36.3108291625977, 0.633743523016505, -84.6247177124023, -1.47697995265218, 218, 50, 'PPL', 'P'),
(102292, 'Glenmere', 38.9000015258789, 0.678933105657405, -77.2216720581055, -1.34777243130925, 218, 53, 'PPL', 'P'),
(127573, 'Glenmere', 43.9513893127441, 0.767096454333233, -69.2583312988281, -1.20878591560159, 218, 26, 'PPL', 'P'),
(143873, 'Glenmere Village', 43.0994415283203, 0.752227160439966, -71.0063934326172, -1.23929535536565, 218, 36, 'PPL', 'P'),
(47496, 'Glenmont', 39.0577812194824, 0.681686880803574, -77.0500030517578, -1.34477624192485, 218, 25, 'PPL', 'P'),
(102293, 'Glenmont', 37.2236099243164, 0.649674552657359, -79.9958267211914, -1.39619056413965, 218, 53, 'PPL', 'P'),
(113245, 'Glenmont', 40.5200004577637, 0.707207420897586, -82.0975036621094, -1.43287174657191, 218, 41, 'PPL', 'P'),
(149165, 'Glenmont', 42.6047210693359, 0.743592659553711, -73.7699966430664, -1.28752933060667, 218, 40, 'PPL', 'P'),
(47497, 'Glenmont Hills', 39.0647201538086, 0.681807988054146, -77.0608291625977, -1.34496519320419, 218, 25, 'PPL', 'P'),
(47498, 'Glenmont Village', 39.0597190856934, 0.681720702949418, -77.0555572509766, -1.34487318098853, 218, 25, 'PPL', 'P'),
(155462, 'Glenmoor', 40.6661109924316, 0.709757530799391, -80.6233291625977, -1.40714254780649, 218, 41, 'PPL', 'P'),
(145306, 'Glenmoore', 40.3680610656738, 0.704555578242139, -74.7844390869141, -1.30523469132379, 218, 37, 'PPL', 'P'),
(162111, 'Glenmoore', 40.0888900756836, 0.699683125290757, -75.772216796875, -1.32247466464042, 218, 45, 'PPL', 'P'),
(41097, 'Glenmora', 30.976390838623, 0.54064001051858, -92.5849990844727, -1.61591307197998, 218, 22, 'PPL', 'P'),
(21426, 'Glenmore', 31.1236095428467, 0.543209461627802, -82.5299987792969, -1.44042021036563, 218, 13, 'PPL', 'P'),
(36110, 'Glenmore', 37.1683311462402, 0.64870975597345, -86.3988876342773, -1.50794505927875, 218, 21, 'PPL', 'P'),
(41098, 'Glenmore', 30.204439163208, 0.527166912116301, -91.1972198486328, -1.59169175502377, 218, 22, 'PPL', 'P'),
(47499, 'Glenmore', 39.1936111450195, 0.684057560226936, -76.6138916015625, -1.3371646612133, 218, 25, 'PPL', 'P'),
(102295, 'Glenmore', 37.6713905334473, 0.657489798613278, -78.5902786254883, -1.37165912207449, 218, 53, 'PPL', 'P'),
(109402, 'Glenmore', 38.8980598449707, 0.678899216932534, -79.8402786254883, -1.39347573772442, 218, 58, 'PPL', 'P'),
(149166, 'Glenmore', 44.2541694641113, 0.772380964884277, -73.7430572509766, -1.28705914951622, 218, 40, 'PPL', 'P'),
(155463, 'Glenmore', 40.7847213745117, 0.711827672493737, -84.6983337402344, -1.47826479472009, 218, 41, 'PPL', 'P'),
(174281, 'Glenmore', 44.3858299255371, 0.774678873430852, -87.9272232055664, -1.5346195470731, 218, 57, 'PPL', 'P'),
(87294, 'Glenmore Estates', 35.836109161377, 0.625458095970132, -83.9555587768555, -1.46530092600775, 218, 50, 'PPL', 'P'),
(47500, 'Glenmore Park', 39.3474998474121, 0.686743424765308, -76.6849975585938, -1.33840569428127, 218, 25, 'PPL', 'P'),
(21427, 'Glenn', 33.1541709899902, 0.578649444544518, -85.2030563354492, -1.4870738658158, 218, 13, 'PPL', 'P'),
(54977, 'Glenn', 36.5302810668945, 0.637573681296256, -90.6841735839844, -1.58273740849059, 218, 29, 'PPL', 'P'),
(81239, 'Glenn', 34.0750007629395, 0.594720955932873, -78.8755569458008, -1.37663816804851, 218, 48, 'PPL', 'P'),
(112504, 'Glenn', 34.3177795410156, 0.598958244964271, -97.1952819824219, -1.69637768799758, 218, 42, 'PPL', 'P'),
(119796, 'Glenn', 41.8047218322754, 0.729630038853562, -87.7774963378906, -1.53200632025346, 218, 18, 'PPL', 'P'),
(131016, 'Glenn', 42.5202789306641, 0.742118866206462, -86.2275009155273, -1.50495379674238, 218, 27, 'PPL', 'P'),
(181799, 'Glenn', 39.5219383239746, 0.689787950523486, -122.01277923584, -2.12952472717438, 218, 6, 'PPL', 'P'),
(190247, 'Glenn', 39.4863891601563, 0.689167500568525, -114.829437255859, -2.00415175832699, 218, 39, 'PPL', 'P'),
(191533, 'Glenn', 33.7808303833008, 0.589586714246337, -100.846672058105, -1.76010646709291, 218, 51, 'PPL', 'P'),
(162112, 'Glenn Acres', 40.2633285522461, 0.702727651048936, -76.6516723632813, -1.3378240598992, 218, 45, 'PPL', 'P'),
(29902, 'Glenn Ayr', 39.4719390869141, 0.688915299213295, -87.295280456543, -1.52359006541853, 218, 19, 'PPL', 'P'),
(65054, 'Glenn Brook', 35.3177795410156, 0.616411537484214, -82.478889465332, -1.43952818455851, 218, 33, 'PPL', 'P'),
(47501, 'Glenn Dale', 38.9874992370605, 0.680460228805484, -76.8208312988281, -1.34077644028366, 218, 25, 'PPL', 'P'),
(21428, 'Glenn Devon', 33.5430603027344, 0.585436843477721, -84.2922210693359, -1.47117679147885, 218, 13, 'PPL', 'P'),
(65075, 'Glenn Echo', 35.7569389343262, 0.624076314838544, -80.8574981689453, -1.41122956797338, 218, 33, 'PPL', 'P'),
(131020, 'Glenn Haven Shores', 42.4925003051758, 0.741634037730013, -86.2375030517578, -1.50512836695183, 218, 27, 'PPL', 'P'),
(47502, 'Glenn Heights', 39.5319404602051, 0.689962520732941, -76.1416702270508, -1.32892284342977, 218, 25, 'PPL', 'P'),
(94498, 'Glenn Heights', 32.5486106872559, 0.568080423442429, -96.8563919067383, -1.69046294037457, 218, 51, 'PPL', 'P'),
(47503, 'Glenn Hill', 39.5844383239746, 0.690878781305983, -77.154167175293, -1.346594248843, 218, 25, 'PPL', 'P'),
(21429, 'Glenn Hills', 33.4283294677734, 0.58343441265409, -82.0605621337891, -1.432226995272, 218, 13, 'PPL', 'P'),
(174283, 'Glenn Oaks Beach', 42.8813896179199, 0.748421436663216, -88.9986114501953, -1.55331879950903, 218, 57, 'PPL', 'P'),
(131017, 'Glenn Shores', 42.5019416809082, 0.741798820822461, -86.2427825927734, -1.50522051232555, 218, 27, 'PPL', 'P'),
(81240, 'Glenn Springs', 34.8122215270996, 0.607587885581537, -81.8399963378906, -1.42837739591629, 218, 48, 'PPL', 'P'),
(191534, 'Glenn Springs (historical)', 29.1606998443604, 0.508950224469886, -103.147010803223, -1.8002549521064, 218, 51, 'PPL', 'P'),
(131018, 'Glenn Stores', 42.4983291625977, 0.741735770483654, -86.2355575561523, -1.50509441164793, 218, 27, 'PPL', 'P'),
(81241, 'Glenn Village', 33.8805618286133, 0.591327356334812, -81.0944366455078, -1.41536492451406, 218, 48, 'PPL', 'P'),
(211848, 'Glennallen', 62.1091690063477, 1.08400949483838, -145.54638671875, -2.54026366262313, 218, 1, 'PPL', 'P'),
(155464, 'Glenndale (historical)', 40.1333312988281, 0.700458770958243, -80.7125015258789, -1.40869889914753, 218, 41, 'PPL', 'P'),
(131019, 'Glennie', 44.5605583190918, 0.777728459195102, -83.725830078125, -1.46129140382858, 218, 27, 'PPL', 'P'),
(54978, 'Glennon', 37.1888885498047, 0.649068550351311, -89.918327331543, -1.56937086982143, 218, 29, 'PPL', 'P'),
(54979, 'Glennonville', 36.5808296203613, 0.638455919986373, -90.1555633544922, -1.57351141952623, 218, 29, 'PPL', 'P'),
(21430, 'Glenns', 32.5305595397949, 0.567765371485473, -84.9508285522461, -1.4826716605339, 218, 13, 'PPL', 'P'),
(102296, 'Glenns', 37.565559387207, 0.655642696660226, -76.6130599975586, -1.33715014698536, 218, 53, 'PPL', 'P'),
(195000, 'Glenns Ferry', 42.9550018310547, 0.749706212152097, -115.300003051758, -2.01236468081268, 218, 17, 'PPL', 'P'),
(177226, 'Glenns Run (historical)', 40.1230583190918, 0.700279473637853, -80.6997222900391, -1.40847585940624, 218, 58, 'PPL', 'P'),
(29903, 'Glenns Valley', 39.6419410705566, 0.691882393562779, -86.1963882446289, -1.50441077819611, 218, 19, 'PPL', 'P'),
(21431, 'Glennville', 31.9363899230957, 0.557395155358759, -81.9286117553711, -1.42992402671936, 218, 13, 'PPL', 'P'),
(78356, 'Glennville', 39.8783302307129, 0.69600816272353, -75.9527816772461, -1.32562611631637, 218, 45, 'PPL', 'P'),
(181801, 'Glennville', 35.728889465332, 0.62358675925116, -118.702781677246, -2.07175437154394, 218, 6, 'PPL', 'P'),
(21432, 'Glennwood', 33.5191688537598, 0.585019859030042, -82.1469421386719, -1.4337346107651, 218, 13, 'PPL', 'P'),
(75932, 'Glenoak', 36.7280616760254, 0.64102560412219, -95.8086090087891, -1.67217567895927, 218, 42, 'PPL', 'P'),
(181802, 'Glenoak Hills', 33.5374984741211, 0.585339771255987, -116.979721069336, -2.04168129072449, 218, 6, 'PPL', 'P'),
(181803, 'Glenoaks Country', 33.5311088562012, 0.58522825138534, -117.005561828613, -2.0421322970551, 218, 6, 'PPL', 'P'),
(87295, 'Glenobey', 36.3852806091309, 0.635042945891381, -85.0091705322266, -1.48368992017669, 218, 50, 'PPL', 'P'),
(47504, 'Glenoble', 39.3902816772461, 0.687490108555939, -77.5425033569336, -1.35337199381725, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(65058, 'Glenola', 35.8727798461914, 0.626098120159105, -79.9150009155273, -1.39477988771024, 218, 33, 'PPL', 'P'),
(78357, 'Glenolden', 39.9000015258789, 0.696386398177348, -75.289436340332, -1.31404855610946, 218, 45, 'PPL', 'P'),
(207510, 'Glenoma', 46.514720916748, 0.811835030643529, -122.158889770508, -2.13207483707618, 218, 56, 'PPL', 'P'),
(47505, 'Glenora', 39.583610534668, 0.690864333657069, -76.148063659668, -1.32903442987945, 218, 25, 'PPL', 'P'),
(102297, 'Glenora', 38.0886116027832, 0.664771679981881, -77.7944412231445, -1.35776913909308, 218, 53, 'PPL', 'P'),
(149167, 'Glenora', 42.4983291625977, 0.741735770483654, -76.9175033569336, -1.34246368599228, 218, 40, 'PPL', 'P'),
(47506, 'Glenora Hills', 39.089168548584, 0.682234693039804, -77.1902770996094, -1.34722448591496, 218, 25, 'PPL', 'P'),
(102298, 'Glenorchy', 38.0263900756836, 0.663685709468374, -78.4336090087891, -1.36892472142526, 218, 53, 'PPL', 'P'),
(141914, 'Glenover', 40.2811088562012, 0.703037975894958, -96.7566680908203, -1.68872243144415, 218, 35, 'PPL', 'P'),
(75933, 'Glenpool', 35.9552803039551, 0.627538024781484, -96.0086135864258, -1.67566641735809, 218, 42, 'PPL', 'P'),
(87296, 'Glenraven (historical)', 36.5286102294922, 0.63754451968232, -87.0477828979492, -1.51927041813043, 218, 50, 'PPL', 'P'),
(109403, 'Glenray', 37.7294387817383, 0.658502931670971, -80.6697235107422, -1.40795228193593, 218, 58, 'PPL', 'P'),
(124932, 'Glenridge', 42.2458305358887, 0.737328838090818, -71.3219375610352, -1.24480263934188, 218, 23, 'PPL', 'P'),
(149168, 'Glenridge', 42.8669395446777, 0.748169235307985, -73.9100036621094, -1.28997291406488, 218, 40, 'PPL', 'P'),
(47507, 'Glenridge Estates', 39.3802795410156, 0.687315538346484, -77.5166702270508, -1.3529211206447, 218, 25, 'PPL', 'P'),
(181805, 'Glenridge Park', 39.0444412231445, 0.681454053945274, -120.123329162598, -2.09654760234425, 218, 6, 'PPL', 'P'),
(188615, 'Glenrio', 35.1788902282715, 0.613987461680997, -103.04167175293, -1.79841643884786, 218, 38, 'PPL', 'P'),
(141915, 'Glenrock', 40.4436111450195, 0.705874175876865, -95.8908309936523, -1.67361072331266, 218, 35, 'PPL', 'P'),
(209475, 'Glenrock', 42.8613891601563, 0.748072362823334, -105.871673583984, -1.84780928863723, 218, 59, 'PPL', 'P'),
(78359, 'Glenrose', 39.9433288574219, 0.697142602768876, -75.8605575561523, -1.32401650175352, 218, 45, 'PPL', 'P'),
(207511, 'Glenrose', 47.628059387207, 0.831266452642155, -117.333610534668, -2.04785782708266, 218, 56, 'PPL', 'P'),
(87306, 'Glenrose Park', 35.9327812194824, 0.627145341678751, -86.5127792358398, -1.50993284271639, 218, 50, 'PPL', 'P'),
(72686, 'Glenroy', 38.4113883972168, 0.670405197793781, -82.5100021362305, -1.44007120310478, 218, 41, 'PPL', 'P'),
(162113, 'Glenruadh', 42.0972213745117, 0.734735118926162, -80.1730575561523, -1.39928382574578, 218, 45, 'PPL', 'P'),
(60055, 'Glens', 34.8661117553711, 0.608528447499525, -88.4138870239258, -1.5431134330538, 218, 30, 'PPL', 'P'),
(155477, 'Glens Cottage Area', 40.4874992370605, 0.706640167585399, -81.1913909912109, -1.41705709707069, 218, 41, 'PPL', 'P'),
(149169, 'Glens Falls', 43.309440612793, 0.755892335890188, -73.6444396972656, -1.2853379485037, 218, 40, 'PPL', 'P'),
(36112, 'Glens Fork', 37.0138893127441, 0.646014237476126, -85.2505569458008, -1.48790290786314, 218, 21, 'PPL', 'P'),
(36120, 'Glensboro', 38.0047187805176, 0.663307474014556, -85.0599975585938, -1.4845770191358, 218, 21, 'PPL', 'P'),
(162117, 'Glenshaw', 40.5327796936035, 0.70743046063888, -79.9677810668945, -1.39570107513129, 218, 45, 'PPL', 'P'),
(94499, 'Glenshire Estates Colonia', 26.2789993286133, 0.458655062413681, -98.2730026245117, -1.71518746161876, 218, 51, 'PPL', 'P'),
(47508, 'Glenshire Towne', 39.1624984741211, 0.683514541680668, -76.8244400024414, -1.34083942404344, 218, 25, 'PPL', 'P'),
(70871, 'Glenside', 39.666389465332, 0.692309098548437, -75.4886093139648, -1.31752478028034, 218, 37, 'PPL', 'P'),
(162115, 'Glenside', 40.1022186279297, 0.699915752411976, -75.1524963378906, -1.31165850218917, 218, 45, 'PPL', 'P'),
(47509, 'Glenside Park', 39.3869400024414, 0.687431785328066, -76.5205612182617, -1.33553573873255, 218, 25, 'PPL', 'P'),
(54980, 'Glensted', 38.5155601501465, 0.672223337869978, -92.8552780151367, -1.62063032921884, 218, 29, 'PPL', 'P'),
(196605, 'Glentana', 48.8480606079102, 0.852559490821775, -106.248893737793, -1.85439302232607, 218, 31, 'PPL', 'P'),
(186773, 'Glentivar', 39.047779083252, 0.68151231059412, -105.603607177734, -1.84313064723418, 218, 7, 'PPL', 'P'),
(162116, 'Glenvale', 40.3261108398438, 0.703823408679449, -76.9994430541992, -1.34389380349765, 218, 45, 'PPL', 'P'),
(102299, 'Glenvar', 37.2738914489746, 0.650552130815567, -80.1341705322266, -1.39860511914197, 218, 53, 'PPL', 'P'),
(102300, 'Glenvar East', 37.2819404602051, 0.650692612563069, -80.1374969482422, -1.39866317605373, 218, 53, 'PPL', 'P'),
(16221, 'Glenvar Heights', 25.7072200775146, 0.448675631887423, -80.3258285522461, -1.40195018262916, 218, 12, 'PPL', 'P'),
(102301, 'Glenvar Heights', 37.2658309936523, 0.650411449330983, -80.1494369506836, -1.39887156840903, 218, 53, 'PPL', 'P'),
(2747, 'Glenview', 33.4780616760254, 0.584302403432374, -86.894172668457, -1.51658941386104, 218, 2, 'PPL', 'P'),
(36113, 'Glenview', 38.3083305358887, 0.668606498793541, -85.6502838134766, -1.49487945781277, 218, 21, 'PPL', 'P'),
(47510, 'Glenview', 39.0302810668945, 0.681206912596115, -77.043327331543, -1.34465972862716, 218, 25, 'PPL', 'P'),
(65059, 'Glenview', 36.1674995422363, 0.631241949225566, -77.8119430541992, -1.35807460367011, 218, 33, 'PPL', 'P'),
(87299, 'Glenview', 36.128059387207, 0.630553588662808, -86.7002792358398, -1.51320533506388, 218, 50, 'PPL', 'P'),
(119797, 'Glenview', 42.0697212219238, 0.734255150718703, -87.7877807617188, -1.53218581731093, 218, 18, 'PPL', 'P'),
(181808, 'Glenview', 32.832218170166, 0.573030307802505, -116.904998779297, -2.04037714073868, 218, 6, 'PPL', 'P'),
(36114, 'Glenview Acres', 38.2980613708496, 0.668427268052179, -85.6372222900391, -1.49465149122346, 218, 21, 'PPL', 'P'),
(178257, 'Glenview Estates', 33.3041687011719, 0.581267398475093, -111.923332214355, -1.95343065694394, 218, 5, 'PPL', 'P'),
(36115, 'Glenview Heights', 38.3041687011719, 0.668533861074809, -85.6405563354492, -1.49470968129328, 218, 21, 'PPL', 'P'),
(36116, 'Glenview Hills', 38.2947196960449, 0.668368944824306, -85.6386108398438, -1.49467572598938, 218, 21, 'PPL', 'P'),
(36117, 'Glenview Manor', 38.2874984741211, 0.668242910725718, -85.6369400024414, -1.49464656437544, 218, 21, 'PPL', 'P'),
(141916, 'Glenvil', 40.5041694641113, 0.70693111793449, -98.2527770996094, -1.71483445961627, 218, 35, 'PPL', 'P'),
(2748, 'Glenville', 32.1286087036133, 0.560750005962959, -85.1769409179688, -1.48661806579524, 218, 2, 'PPL', 'P'),
(9139, 'Glenville', 33.4913902282715, 0.584535030553593, -93.195556640625, -1.62656931160777, 218, 4, 'PPL', 'P'),
(13827, 'Glenville', 39.7125015258789, 0.693113905829859, -75.6402816772461, -1.32017196240388, 218, 10, 'PPL', 'P'),
(32560, 'Glenville', 37.6124992370605, 0.656461951590562, -97.3472213745117, -1.69902953065303, 218, 20, 'PPL', 'P'),
(36118, 'Glenville', 37.5947189331055, 0.65615162674454, -87.1916732788086, -1.52178177903837, 218, 21, 'PPL', 'P'),
(47511, 'Glenville', 39.6100006103516, 0.691324927367598, -76.2161102294922, -1.33022206656757, 218, 25, 'PPL', 'P'),
(60056, 'Glenville', 34.5283317565918, 0.602633074373444, -89.7399978637695, -1.56625843345546, 218, 30, 'PPL', 'P'),
(65060, 'Glenville', 35.1733283996582, 0.613890389459264, -83.1294403076172, -1.45088243870801, 218, 33, 'PPL', 'P'),
(78360, 'Glenville', 39.7569389343262, 0.693889484918317, -76.815559387207, -1.340684428068, 218, 45, 'PPL', 'P'),
(109404, 'Glenville', 38.9341697692871, 0.679529454004501, -80.8377838134766, -1.41088548756054, 218, 58, 'PPL', 'P'),
(113476, 'Glenville', 41.0352783203125, 0.716200716161701, -73.6602783203125, -1.28561438462485, 218, 8, 'PPL', 'P'),
(135584, 'Glenville', 43.5724983215332, 0.760483559030457, -93.2811126708984, -1.62806254603098, 218, 28, 'PPL', 'P'),
(149173, 'Glenville', 41.065559387207, 0.716729220480028, -73.8411102294922, -1.2887704968327, 218, 40, 'PPL', 'P'),
(155466, 'Glenville', 41.5333290100098, 0.724893340538747, -81.6175003051758, -1.42449410757279, 218, 41, 'PPL', 'P'),
(155467, 'Glenville (historical)', 40.8133316040039, 0.712327015198127, -83.0508270263672, -1.4495103781144, 218, 41, 'PPL', 'P'),
(149174, 'Glenville Center', 42.8925018310547, 0.748615381369601, -73.9791717529297, -1.29118012498701, 218, 40, 'PPL', 'P'),
(47512, 'Glenvue Acres', 39.4888916015625, 0.689211176410402, -77.0791702270508, -1.34528530516722, 218, 25, 'PPL', 'P'),
(41100, 'Glenwild', 29.7141704559326, 0.518610108954849, -91.2541732788086, -1.59268577990064, 218, 22, 'PPL', 'P'),
(60057, 'Glenwild', 33.7208290100098, 0.58853949272669, -89.7819366455078, -1.56699040328106, 218, 30, 'PPL', 'P'),
(149176, 'Glenwild', 43.1341705322266, 0.752833295904068, -74.0652770996094, -1.29268294679014, 218, 40, 'PPL', 'P'),
(162124, 'Glenwillard', 40.5597190856934, 0.707900641729333, -80.2244415283203, -1.40018064524286, 218, 45, 'PPL', 'P'),
(155468, 'Glenwillow', 41.3616714477539, 0.721897350891435, -81.4697189331055, -1.42191483605705, 218, 41, 'PPL', 'P'),
(2750, 'Glenwood', 31.2480602264404, 0.54538153581287, -85.4150009155273, -1.49077299656992, 218, 2, 'PPL', 'P'),
(9140, 'Glenwood', 34.3266716003418, 0.599113440676795, -93.5505599975586, -1.6327652890419, 218, 4, 'PPL', 'P'),
(16224, 'Glenwood', 29.0858306884766, 0.507643511191525, -81.3544387817383, -1.4199028178535, 218, 12, 'PPL', 'P'),
(21434, 'Glenwood', 32.1797218322754, 0.561642098349108, -82.6697235107422, -1.44285886697582, 218, 13, 'PPL', 'P'),
(29904, 'Glenwood', 39.6258316040039, 0.691601230330694, -85.3002777099609, -1.48877069890435, 218, 19, 'PPL', 'P'),
(36119, 'Glenwood', 38.2222213745117, 0.667103610411382, -82.7861099243164, -1.44489019309727, 218, 21, 'PPL', 'P'),
(41101, 'Glenwood', 29.9513893127441, 0.522750359054027, -91.0436096191406, -1.58901075075438, 218, 22, 'PPL', 'P'),
(47516, 'Glenwood', 38.9955596923828, 0.680600910290067, -77.1074981689453, -1.34577972102359, 218, 25, 'PPL', 'P'),
(65064, 'Glenwood', 34.9319381713867, 0.609677335193786, -79.7586135864258, -1.39205041390901, 218, 33, 'PPL', 'P'),
(81242, 'Glenwood', 34.8316688537598, 0.607927305462467, -82.5813903808594, -1.44131716302077, 218, 48, 'PPL', 'P'),
(87302, 'Glenwood', 36.0380592346191, 0.628982789672852, -84.0027770996094, -1.46612504120708, 218, 50, 'PPL', 'P'),
(94500, 'Glenwood', 32.6408309936523, 0.569689971426246, -94.8438873291016, -1.65533810928335, 218, 51, 'PPL', 'P'),
(102304, 'Glenwood', 36.9083290100098, 0.64417186263401, -80.8030624389648, -1.4102794852545, 218, 53, 'PPL', 'P'),
(115750, 'Glenwood', 41.0469398498535, 0.716404248248011, -95.7422180175781, -1.67101693756898, 218, 16, 'PPL', 'P'),
(119798, 'Glenwood', 41.5424995422363, 0.725053396520261, -87.6022186279297, -1.52894714710928, 218, 18, 'PPL', 'P'),
(124933, 'Glenwood', 42.4230613708496, 0.740422099696945, -71.0919418334961, -1.2407884566308, 218, 23, 'PPL', 'P'),
(127571, 'Glenwood', 45.7744407653809, 0.798914704615009, -68.1186065673828, -1.18889396647146, 218, 26, 'PPL', 'P'),
(131021, 'Glenwood', 42.0550003051758, 0.733998222252538, -86.0330581665039, -1.50156013056529, 218, 27, 'PPL', 'P'),
(135586, 'Glenwood', 45.6502799987793, 0.796747690436012, -95.3894424438477, -1.66485984228677, 218, 28, 'PPL', 'P'),
(139177, 'Glenwood', 40.5175018310547, 0.707163811634736, -92.5761108398438, -1.61575794284649, 218, 29, 'PPL', 'P'),
(145307, 'Glenwood', 41.2511100769043, 0.719967690944591, -74.4899978637695, -1.30009572252632, 218, 37, 'PPL', 'P'),
(149179, 'Glenwood', 40.9488906860352, 0.714692967510553, -73.8966674804688, -1.2897401537856, 218, 40, 'PPL', 'P'),
(155470, 'Glenwood', 41.564998626709, 0.725446079622993, -83.567497253418, -1.45852797472346, 218, 41, 'PPL', 'P'),
(162121, 'Glenwood', 41.651668548584, 0.726958755122158, -75.7202835083008, -1.32156825776341, 218, 45, 'PPL', 'P'),
(177225, 'Glenwood', 40.0761108398438, 0.699460085549463, -80.7027816772461, -1.4085292557861, 218, 58, 'PPL', 'P'),
(181809, 'Glenwood', 37.1083297729492, 0.647662534453804, -121.985557556152, -2.12904961923591, 218, 6, 'PPL', 'P'),
(188616, 'Glenwood', 33.3166694641113, 0.581485577947397, -108.882499694824, -1.9003581174764, 218, 38, 'PPL', 'P'),
(192587, 'Glenwood', 38.7633285522461, 0.676547712269021, -111.989440917969, -1.95458447148622, 218, 52, 'PPL', 'P'),
(195001, 'Glenwood', 46.2441711425781, 0.807113046293736, -115.831939697266, -2.02164872668881, 218, 17, 'PPL', 'P'),
(200897, 'Glenwood', 45.6494407653809, 0.796733043050016, -123.269721984863, -2.1514625166539, 218, 43, 'PPL', 'P'),
(207514, 'Glenwood', 46.9277801513672, 0.8190442742934, -117.27889251709, -2.04690281751576, 218, 56, 'PPL', 'P'),
(211336, 'Glenwood', 19.4908294677734, 0.34017914815738, -155.153884887695, -2.70794613855056, 218, 15, 'PPL', 'P'),
(27276, 'Glenwood (historical)', 38.6911087036133, 0.675287238125087, -88.2738876342773, -1.54066998275365, 218, 18, 'PPL', 'P'),
(72688, 'Glenwood (historical)', 39.2166709899902, 0.684460030446674, -84.3311080932617, -1.47185549808265, 218, 41, 'PPL', 'P'),
(81243, 'Glenwood (historical)', 34.9736099243164, 0.610404644487486, -81.959716796875, -1.43046691210757, 218, 48, 'PPL', 'P'),
(170389, 'Glenwood (historical)', 43.0777816772461, 0.75184912472323, -96.834716796875, -1.69008463834173, 218, 49, 'PPL', 'P'),
(193208, 'Glenwood (historical)', 43.5777816772461, 0.760575770983201, -122.655563354492, -2.14074342642439, 218, 43, 'PPL', 'P'),
(81244, 'Glenwood Acres', 34.9891700744629, 0.610676220339647, -81.0294418334961, -1.41423055104774, 218, 48, 'PPL', 'P'),
(94501, 'Glenwood Acres Colonia', 26.1340007781982, 0.45612436029832, -97.5619964599609, -1.70277806304537, 218, 51, 'PPL', 'P'),
(155471, 'Glenwood Addition', 41.565559387207, 0.725455866739999, -83.5880584716797, -1.45888683568035, 218, 41, 'PPL', 'P'),
(131022, 'Glenwood Beach', 44.0569381713867, 0.768938629438268, -83.6055603027344, -1.45919230025738, 218, 27, 'PPL', 'P'),
(174284, 'Glenwood City', 45.0586090087891, 0.786421083572148, -92.1722183227539, -1.6087086885991, 218, 57, 'PPL', 'P'),
(65067, 'Glenwood Crossroads', 35.2675018310547, 0.615534025905033, -78.3955612182617, -1.36826066220744, 218, 33, 'PPL', 'P'),
(21436, 'Glenwood Estates', 31.2119407653809, 0.544751132293335, -81.5119400024414, -1.42265173273068, 218, 13, 'PPL', 'P'),
(47517, 'Glenwood Estates', 39.2791709899902, 0.68555086122917, -77.0152816772461, -1.34417023961881, 218, 25, 'PPL', 'P'),
(102305, 'Glenwood Estates', 37.2333297729492, 0.649844196018797, -79.9247207641602, -1.39494953107167, 218, 53, 'PPL', 'P'),
(102306, 'Glenwood Farms', 37.5763893127441, 0.655831714518594, -77.3855590820313, -1.35063279947805, 218, 53, 'PPL', 'P'),
(21437, 'Glenwood Forest', 32.8972206115723, 0.574164814426879, -83.709716796875, -1.46101017401747, 218, 13, 'PPL', 'P'),
(47518, 'Glenwood Garth', 39.5299987792969, 0.68992863200807, -76.3236083984375, -1.33209826355553, 218, 25, 'PPL', 'P'),
(16225, 'Glenwood Heights', 25.8308296203613, 0.450833025396982, -80.2369384765625, -1.40039875813614, 218, 12, 'PPL', 'P'),
(21438, 'Glenwood Hills', 33.7386093139648, 0.588849817572712, -84.288330078125, -1.47110888087105, 218, 13, 'PPL', 'P'),
(135587, 'Glenwood Junction', 44.9872207641602, 0.785175123656154, -93.3324966430664, -1.62895936552806, 218, 28, 'PPL', 'P'),
(139178, 'Glenwood Junction', 40.5313911437988, 0.70740622587296, -92.5861129760742, -1.61593251305594, 218, 29, 'PPL', 'P'),
(149181, 'Glenwood Landing', 40.8305587768555, 0.712627686085197, -73.6391677856445, -1.28524593628804, 218, 40, 'PPL', 'P'),
(181810, 'Glenwood Mobile Estates', 37.3805618286133, 0.652413880154614, -118.417778015137, -2.06678011925989, 218, 6, 'PPL', 'P'),
(141918, 'Glenwood Mobile Home Park', 40.7444381713867, 0.711124597965956, -99.0819396972656, -1.72930607697976, 218, 35, 'PPL', 'P'),
(102307, 'Glenwood Park', 36.9286117553711, 0.644525863321908, -76.3130569458008, -1.33191410596615, 218, 53, 'PPL', 'P'),
(141919, 'Glenwood Park', 40.7497215270996, 0.7112168099187, -99.0830612182617, -1.72932565121377, 218, 35, 'PPL', 'P'),
(149182, 'Glenwood Park', 41.5133285522461, 0.724544266698865, -74.0502777099609, -1.29242115805498, 218, 40, 'PPL', 'P'),
(186774, 'Glenwood Springs', 39.5505599975586, 0.690287492964958, -107.324172973633, -1.87316018536981, 218, 7, 'PPL', 'P'),
(21439, 'Glenwoods', 33.5269393920898, 0.585155480508554, -84.3988876342773, -1.47303847423887, 218, 13, 'PPL', 'P'),
(21440, 'Glenwoods Spring (historical)', 33.2608299255371, 0.580510994146483, -83.460563659668, -1.45666163143153, 218, 13, 'PPL', 'P'),
(162122, 'Glenworth', 40.6599998474121, 0.709650871197733, -76.2191696166992, -1.33027546294743, 218, 45, 'PPL', 'P'),
(87303, 'Glenwylde', 36.2955589294434, 0.633477007170415, -87.3438873291016, -1.52443841538378, 218, 50, 'PPL', 'P'),
(2752, 'Glenzaida', 34.6958312988281, 0.605556492881051, -85.8041687011719, -1.49756525577212, 218, 2, 'PPL', 'P'),
(113309, 'Glessner', 40.1925010681152, 0.701491478249949, -79.0411071777344, -1.37952756467319, 218, 45, 'PPL', 'P'),
(29905, 'Glezen', 38.416389465332, 0.670492482898508, -87.3011093139648, -1.52369179817217, 218, 19, 'PPL', 'P'),
(29906, 'Glidas', 38.0566711425781, 0.664214213786701, -86.184440612793, -1.50420225268276, 218, 19, 'PPL', 'P'),
(94502, 'Glidden', 29.7005596160889, 0.518372554985614, -96.5861129760742, -1.68574568313571, 218, 51, 'PPL', 'P'),
(115753, 'Glidden', 42.0569381713867, 0.734032044398381, -94.7286071777344, -1.6533260910798, 218, 16, 'PPL', 'P'),
(174287, 'Glidden', 46.1349983215332, 0.805207621112812, -90.5783309936523, -1.58089010680046, 218, 57, 'PPL', 'P'),
(16226, 'Glidden Park', 27.437780380249, 0.478879607074447, -80.3341674804688, -1.40209572438274, 218, 12, 'PPL', 'P'),
(200898, 'Glide', 43.3016700744629, 0.755756714411676, -123.099998474121, -2.14850028257341, 218, 43, 'PPL', 'P'),
(65072, 'Gliden', 36.3202781677246, 0.633908439267008, -76.6144409179688, -1.33717424859322, 218, 33, 'PPL', 'P'),
(54984, 'Glidewell', 37.3044395446777, 0.651085295665801, -93.3269424438477, -1.62886242646438, 218, 29, 'PPL', 'P'),
(87304, 'Glimp', 35.6994400024414, 0.623072769160775, -89.6444396972656, -1.56459062882279, 218, 50, 'PPL', 'P'),
(102308, 'Glimpses Corner', 37.6300010681152, 0.656767416167594, -77.1552810668945, -1.34661368991895, 218, 53, 'PPL', 'P'),
(47520, 'Glisson Place', 39.4566688537598, 0.688648783367205, -77.2191696166992, -1.34772875546737, 218, 25, 'PPL', 'P'),
(36121, 'Glo', 37.4477806091309, 0.653587069193821, -82.809440612793, -1.44529739042795, 218, 21, 'PPL', 'P'),
(32562, 'Globe', 38.7822189331055, 0.676877411611973, -95.3994369506836, -1.66503427933817, 218, 20, 'PPL', 'P'),
(36122, 'Globe', 38.2874984741211, 0.668242910725718, -83.245002746582, -1.45289938375958, 218, 21, 'PPL', 'P'),
(54982, 'Globe', 36.9308280944824, 0.644564545736742, -93.8452835083008, -1.63790918468738, 218, 29, 'PPL', 'P'),
(65074, 'Globe', 36.0461082458496, 0.629123271420353, -81.7083282470703, -1.42607935421166, 218, 33, 'PPL', 'P'),
(87305, 'Globe', 35.435001373291, 0.618457444412641, -86.8724975585938, -1.5162111118282, 218, 50, 'PPL', 'P'),
(94503, 'Globe', 33.7447204589844, 0.58895647717437, -95.7052764892578, -1.67037218626907, 218, 51, 'PPL', 'P'),
(102309, 'Globe', 37.8122215270996, 0.659947763141366, -77.1999969482422, -1.3473941292764, 218, 53, 'PPL', 'P'),
(119799, 'Globe', 41.5974998474121, 0.72601333293518, -87.559440612793, -1.52820052989768, 218, 18, 'PPL', 'P'),
(127574, 'Globe', 44.2269401550293, 0.771905723787753, -69.3888931274414, -1.21106464938832, 218, 26, 'PPL', 'P'),
(169395, 'Globe', 41.9902801513672, 0.73286864247618, -71.524169921875, -1.24833225989261, 218, 47, 'PPL', 'P'),
(174289, 'Globe', 44.6544418334961, 0.7793670356348, -90.6591720581055, -1.58230104954598, 218, 57, 'PPL', 'P'),
(178258, 'Globe', 33.3941688537598, 0.582838197465049, -110.785827636719, -1.93357745680767, 218, 5, 'PPL', 'P'),
(181811, 'Globe', 36.1011085510254, 0.630083207835272, -118.827217102051, -2.0739261794129, 218, 6, 'PPL', 'P'),
(207515, 'Globe', 46.5552787780762, 0.812542898861272, -123.535003662109, -2.15609255536706, 218, 56, 'PPL', 'P'),
(149183, 'Globe Hotel Corners', 42.788330078125, 0.746797241293404, -76.3808288574219, -1.33309694896431, 218, 40, 'PPL', 'P'),
(193595, 'Globe Mill', 40.8844413757324, 0.713568114845131, -123.02278137207, -2.14715258990377, 218, 6, 'PPL', 'P'),
(162123, 'Globe Mills', 40.8061103820801, 0.712200981099539, -76.991943359375, -1.34376290913008, 218, 45, 'PPL', 'P'),
(65076, 'Globe Set (historical)', 35.9402809143066, 0.627276236046329, -81.6436080932617, -1.42494977443531, 218, 33, 'PPL', 'P'),
(124935, 'Globe Village', 42.0833282470703, 0.734492638108911, -72.0477828979492, -1.25747103033128, 218, 23, 'PPL', 'P'),
(36123, 'Glomawr', 37.2266693115234, 0.649727949037215, -83.1572189331055, -1.45136726718446, 218, 21, 'PPL', 'P'),
(41103, 'Gloria', 29.7369403839111, 0.519007519168516, -90.0119400024414, -1.5710047191502, 218, 22, 'PPL', 'P'),
(94504, 'Gloria Colonia', 26.7099990844727, 0.466177427228719, -98.4369964599609, -1.71804969400032, 218, 51, 'PPL', 'P'),
(191535, 'Gloria Elena Colonia', 31.576000213623, 0.551105168338155, -106.267997741699, -1.85472645009455, 218, 51, 'PPL', 'P'),
(155472, 'Gloria Glens Park', 41.0583305358887, 0.716603053223385, -81.898063659668, -1.42939086186912, 218, 41, 'PPL', 'P'),
(87307, 'Gloriana (historical)', 35.975830078125, 0.62789668600129, -86.188606262207, -1.50427495698052, 218, 50, 'PPL', 'P'),
(188617, 'Glorieta', 35.5830612182617, 0.621041576197372, -105.769439697266, -1.84602497070688, 218, 38, 'PPL', 'P'),
(191536, 'Glorieta Addition Colonia', 31.5970001220703, 0.551471685883177, -106.278999328613, -1.85491846400914, 218, 51, 'PPL', 'P'),
(181813, 'Glorietta', 36.8377799987793, 0.642940550104011, -119.708610534668, -2.08930939681753, 218, 6, 'PPL', 'P'),
(21442, 'Glory', 31.3677806854248, 0.547471052004146, -83.1436080932617, -1.45112971321522, 218, 13, 'PPL', 'P'),
(94505, 'Glory', 33.5333290100098, 0.585267000379201, -95.5391693115234, -1.66747306910641, 218, 51, 'PPL', 'P'),
(135590, 'Glory', 46.4174995422363, 0.810138197554985, -93.6002807617188, -1.6336330800831, 218, 28, 'PPL', 'P'),
(196606, 'Gloss Place', 45.3608283996582, 0.791695807006186, -113.273612976074, -1.97699750206227, 218, 31, 'PPL', 'P'),
(162125, 'Glosser View', 41.2319412231445, 0.71963313133265, -77.1197204589844, -1.34599304022691, 218, 45, 'PPL', 'P'),
(21443, 'Gloster', 33.9097213745117, 0.591836286419127, -84.0652770996094, -1.46721587198957, 218, 13, 'PPL', 'P'),
(41104, 'Gloster', 32.1908302307129, 0.561835976476466, -93.8147201538086, -1.63737575352104, 218, 22, 'PPL', 'P'),
(60059, 'Gloster', 31.1972198486328, 0.54449420382717, -91.0216674804688, -1.58862778818963, 218, 30, 'PPL', 'P'),
(135591, 'Gloster', 45.0013885498047, 0.785422398163368, -93.0441665649414, -1.62392705633225, 218, 28, 'PPL', 'P'),
(181814, 'Gloster', 34.9561080932617, 0.610099179910454, -118.14778137207, -2.06206778886905, 218, 6, 'PPL', 'P'),
(196607, 'Gloster', 46.7627792358398, 0.816164465048643, -112.338607788086, -1.96067858300864, 218, 31, 'PPL', 'P'),
(65078, 'Gloucester', 34.7261085510254, 0.60608493062035, -76.541389465332, -1.33589926022135, 218, 33, 'PPL', 'P'),
(102310, 'Gloucester', 37.4136085510254, 0.652990654267698, -76.5258331298828, -1.33562775094821, 218, 53, 'PPL', 'P'),
(124936, 'Gloucester', 42.6158294677734, 0.743786537681069, -70.6624984741211, -1.23329325605888, 218, 23, 'PPL', 'P'),
(70873, 'Gloucester City', 39.8916702270508, 0.69624098958183, -75.1166687011719, -1.31103319196522, 218, 37, 'PPL', 'P'),
(102312, 'Gloucester Courthouse', 37.4097213745117, 0.652922810238928, -76.5269393920898, -1.33564705886612, 218, 53, 'PPL', 'P'),
(70875, 'Gloucester Heights', 39.8977813720703, 0.696347649183488, -75.1047210693359, -1.31082466645187, 218, 37, 'PPL', 'P'),
(102313, 'Gloucester Point', 37.2538909912109, 0.650203056975685, -76.4972229003906, -1.33512840824382, 218, 53, 'PPL', 'P'),
(72689, 'Glouster', 39.503059387207, 0.689458450917616, -82.084716796875, -1.43264857367256, 218, 41, 'PPL', 'P'),
(70877, 'Glouster Landing', 39.5847206115723, 0.690883708153999, -74.5669403076172, -1.30143862150599, 218, 37, 'PPL', 'P'),
(2753, 'Glover', 31.936939239502, 0.557404742738683, -87.8399963378906, -1.53309715103595, 218, 2, 'PPL', 'P'),
(54983, 'Glover', 37.4863891601563, 0.654260915528639, -90.6911087036133, -1.58285844916214, 218, 29, 'PPL', 'P'),
(60060, 'Glover', 34.9324989318848, 0.609687122310792, -90.1800003051758, -1.57393792477481, 218, 30, 'PPL', 'P'),
(75936, 'Glover', 34.0702781677246, 0.594638531097135, -94.8977813720703, -1.65627873778037, 218, 42, 'PPL', 'P'),
(109408, 'Glover', 37.5863914489746, 0.656006284728049, -81.5905609130859, -1.42402392648234, 218, 58, 'PPL', 'P'),
(119800, 'Glover', 40.1136093139648, 0.70011455738735, -88.0188903808594, -1.53621944109796, 218, 18, 'PPL', 'P'),
(140100, 'Glover', 46.2416687011719, 0.807069370451859, -98.1386108398438, -1.71284188248867, 218, 34, 'PPL', 'P'),
(172047, 'Glover', 44.7044410705566, 0.780239686944992, -72.2141723632813, -1.26037507434195, 218, 55, 'PPL', 'P'),
(174288, 'Glover', 44.9130592346191, 0.783880760787348, -92.6802825927734, -1.61757608292268, 218, 57, 'PPL', 'P'),
(94506, 'Glover (historical)', 31.5052795410156, 0.549870859751931, -95.3080596923828, -1.66343944531937, 218, 51, 'PPL', 'P'),
(47521, 'Glover Acres', 39.5422210693359, 0.690141951211385, -76.9855575561523, -1.34365145583846, 218, 25, 'PPL', 'P'),
(87309, 'Glover Crossroad', 36.4491691589355, 0.636158011439798, -86.9466705322266, -1.51750567443408, 218, 50, 'PPL', 'P'),
(87308, 'Glover Hill', 35.063060760498, 0.611965856097518, -85.6516723632813, -1.49490369257869, 218, 50, 'PPL', 'P'),
(13116, 'Glover Park', 38.9208297729492, 0.679296627146201, -77.0774993896484, -1.34525614355329, 218, 9, 'PPL', 'P'),
(188618, 'Glover Place', 34.8008308410645, 0.607389080606162, -106.294998168945, -1.85519769644944, 218, 38, 'PPL', 'P'),
(131023, 'Glovers Corner', 46.8950004577637, 0.818472160712224, -88.1083297729492, -1.53778045297091, 218, 27, 'PPL', 'P'),
(65080, 'Glovers Crossroads', 36.2391700744629, 0.632492835989576, -76.8338928222656, -1.34100440687297, 218, 33, 'PPL', 'P'),
(21444, 'Glovers Millpond', 33.1383285522461, 0.57837294184434, -82.5827789306641, -1.44134139778669, 218, 13, 'PPL', 'P'),
(102315, 'Gloversville', 36.8605613708496, 0.64333816005476, -76.5686111450195, -1.33637436815982, 218, 53, 'PPL', 'P'),
(149184, 'Gloversville', 43.0527801513672, 0.75141276577862, -74.3441696166992, -1.29755053947253, 218, 40, 'PPL', 'P'),
(21445, 'Gloverton', 33.399169921875, 0.582925482569776, -84.829719543457, -1.48055790957671, 218, 13, 'PPL', 'P'),
(81249, 'Gloverville', 32.9000015258789, 0.574213350537745, -80.4936065673828, -1.40487846140576, 218, 48, 'PPL', 'P'),
(207516, 'Gloyd', 47.2649993896484, 0.824929860302476, -119.278610229492, -2.08180447570763, 218, 56, 'PPL', 'P'),
(81250, 'Gluck', 34.4519386291504, 0.601299762773696, -82.6669387817383, -1.44281026428592, 218, 48, 'PPL', 'P'),
(191537, 'Gluck', 35.3658294677734, 0.61725016691148, -101.812217712402, -1.77695841783871, 218, 51, 'PPL', 'P'),
(47522, 'Gluckheim (historical)', 38.579719543457, 0.673343130529329, -75.9688873291016, -1.32590721296942, 218, 25, 'PPL', 'P'),
(60061, 'Gluckstadt', 32.5163917541504, 0.567518096978259, -90.100830078125, -1.57255614364322, 218, 30, 'PPL', 'P'),
(135592, 'Gluek', 44.985279083252, 0.785141234931283, -95.4730606079102, -1.66631925456413, 218, 28, 'PPL', 'P'),
(162126, 'Glyde', 40.125560760498, 0.700323149479731, -80.1369400024414, -1.39865345551576, 218, 45, 'PPL', 'P'),
(47523, 'Glymont', 38.6011085510254, 0.673716439135131, -77.144172668457, -1.3464198117916, 218, 25, 'PPL', 'P'),
(81251, 'Glymphville', 34.3952789306641, 0.600310864481922, -81.42138671875, -1.42107127978177, 218, 48, 'PPL', 'P'),
(122694, 'Glyn Ellen', 40.1111106872559, 0.7000709481245, -85.6477813720703, -1.49483578197089, 218, 19, 'PPL', 'P'),
(21446, 'Glynco', 31.2222194671631, 0.544930529482265, -81.5102767944336, -1.4226227042748, 218, 13, 'PPL', 'P'),
(21447, 'Glynco Annex', 31.2244396209717, 0.544969278476126, -81.4775009155273, -1.42205065727265, 218, 13, 'PPL', 'P'),
(21448, 'Glyndale', 31.2127799987793, 0.54476577967933, -81.5261077880859, -1.42289900723789, 218, 13, 'PPL', 'P'),
(47524, 'Glyndon', 39.476390838623, 0.688992996938098, -76.8161087036133, -1.34069401544792, 218, 25, 'PPL', 'P'),
(135593, 'Glyndon', 46.8752784729004, 0.818127947141331, -96.57861328125, -1.68561478876814, 218, 28, 'PPL', 'P'),
(47525, 'Glyndon Greens', 39.4655609130859, 0.688803979079729, -76.8194427490234, -1.34075220551774, 218, 25, 'PPL', 'P'),
(41106, 'Glynn', 30.6263904571533, 0.534531351478697, -91.3552780151367, -1.59445039043893, 218, 22, 'PPL', 'P'),
(9142, 'Glynn (historical)', 33.6208305358887, 0.586794190106307, -92.2647171020508, -1.61032309685191, 218, 4, 'PPL', 'P'),
(21449, 'Glynn Camp', 31.2099990844727, 0.544717243568464, -81.567497253418, -1.42362138968358, 218, 13, 'PPL', 'P'),
(21451, 'Glynn Haven', 31.1883296966553, 0.544339041404159, -81.3769378662109, -1.42029550095623, 218, 13, 'PPL', 'P'),
(21452, 'Glynn Heights', 31.2219390869141, 0.544925635923762, -81.5274963378906, -1.42292324200381, 218, 13, 'PPL', 'P'),
(21453, 'Glynn Isles', 33.5608291625977, 0.585746968586661, -83.9694366455078, -1.46554314050889, 218, 13, 'PPL', 'P'),
(41105, 'Glynville (historical)', 30.9783306121826, 0.540673865953937, -91.7783279418945, -1.60183400456117, 218, 22, 'PPL', 'P'),
(155473, 'Glynwood', 40.5827789306641, 0.708303111949071, -84.3161087036133, -1.4715937093475, 218, 41, 'PPL', 'P'),
(155474, 'Gnadenhutten', 40.3583297729492, 0.704385735143619, -81.434440612793, -1.42129911321303, 218, 41, 'PPL', 'P'),
(87310, 'Gnat Grove', 35.2991714477539, 0.616086764989279, -86.8130569458008, -1.51517367742556, 218, 50, 'PPL', 'P'),
(87311, 'Gnat Hill', 35.6241683959961, 0.621759031795039, -86.1402816772461, -1.50343153386329, 218, 50, 'PPL', 'P'),
(78361, 'Gnatstown', 39.8675003051758, 0.695819144865162, -76.9291687011719, -1.34266728465762, 218, 45, 'PPL', 'P'),
(2754, 'Gnatville', 33.9952812194824, 0.593329587421361, -85.6761093139648, -1.49533019782727, 218, 2, 'PPL', 'P'),
(29907, 'Gnaw Bone', 39.1908302307129, 0.684009024116069, -86.1555633544922, -1.50369824944646, 218, 19, 'PPL', 'P'),
(65082, 'Gneiss', 35.1333312988281, 0.613192308358527, -83.2813873291016, -1.45353441452151, 218, 33, 'PPL', 'P'),
(87312, 'Goad', 36.4047203063965, 0.635382232614258, -84.7316665649414, -1.47884656226022, 218, 50, 'PPL', 'P'),
(81253, 'Goat Alley', 34.7227783203125, 0.606026807129559, -81.6750030517578, -1.42549771982959, 218, 48, 'PPL', 'P'),
(87313, 'Goat City', 35.8274993896484, 0.625307827105624, -88.7600021362305, -1.54915428135442, 218, 50, 'PPL', 'P'),
(65083, 'Goat Neck', 35.9694404602051, 0.627785166130643, -76.0780563354492, -1.32781257157132, 218, 33, 'PPL', 'P'),
(181815, 'Goat Rock', 38.5816688537598, 0.673377152412254, -123.120277404785, -2.14885421668228, 218, 6, 'PPL', 'P'),
(21455, 'Goat Town', 33.0186080932617, 0.576283425653064, -82.9811096191406, -1.44829357981234, 218, 13, 'PPL', 'P'),
(9145, 'Gobbler', 36.1886100769043, 0.631610397562378, -93.4561080932617, -1.63111679232714, 218, 4, 'PPL', 'P'),
(113310, 'Gobbler Knob', 41.1847190856934, 0.718808949554298, -78.5725021362305, -1.3713488638075, 218, 45, 'PPL', 'P'),
(2755, 'Gobblers Crossing', 33.7508316040039, 0.589063136776027, -87.2180633544922, -1.5222423727489, 218, 2, 'PPL', 'P'),
(21456, 'Gobblers Hill', 32.2816696166992, 0.563421422852417, -84.7191696166992, -1.47862844936694, 218, 13, 'PPL', 'P'),
(9143, 'Gobblers Point', 35.422779083252, 0.618244125209325, -92.7786102294922, -1.61929222392913, 218, 4, 'PPL', 'P'),
(9144, 'Gobell', 34.4674987792969, 0.601571338625857, -90.9250030517578, -1.58694067563907, 218, 4, 'PPL', 'P'),
(21457, 'Gober', 34.3055610656738, 0.598744992339983, -84.4072189331055, -1.47318388283439, 218, 13, 'PPL', 'P'),
(94508, 'Gober', 33.4688911437988, 0.58414234745086, -96.0883331298828, -1.6770577858696, 218, 51, 'PPL', 'P'),
(87314, 'Gobey', 36.1488914489746, 0.630917176730631, -84.5997161865234, -1.47654359370758, 218, 50, 'PPL', 'P'),
(200899, 'Goble', 46.0161094665527, 0.803132619149477, -122.874168395996, -2.14455880416009, 218, 43, 'PPL', 'P'),
(54985, 'Gobler', 36.1561088562012, 0.631043144250191, -89.9591674804688, -1.57008366488719, 218, 29, 'PPL', 'P'),
(131024, 'Gobles', 42.3608283996582, 0.739335929446356, -85.8794403076172, -1.49887899313785, 218, 27, 'PPL', 'P'),
(122695, 'Goblesville', 40.9900016784668, 0.715410489687248, -85.5102767944336, -1.49243587435457, 218, 19, 'PPL', 'P'),
(102316, 'Goby', 38.3136100769043, 0.668698644167258, -77.2744369506836, -1.3486933524142, 218, 53, 'PPL', 'P'),
(135597, 'Godahl', 44.1088905334473, 0.769845369210413, -94.6397171020508, -1.65177466658677, 218, 28, 'PPL', 'P'),
(162127, 'Godard', 42.0391693115234, 0.733721919289442, -80.0105590820313, -1.3964476923429, 218, 45, 'PPL', 'P'),
(109410, 'Godby Heights', 37.936939239502, 0.662124497858343, -82.0091705322266, -1.43133004261686, 218, 58, 'PPL', 'P'),
(41107, 'Godchaux', 29.7322196960449, 0.518925127622292, -90.6102828979492, -1.58144777273272, 218, 22, 'PPL', 'P'),
(2756, 'Goddard', 34.2461090087891, 0.597707358200261, -87.70361328125, -1.53071681765364, 218, 2, 'PPL', 'P'),
(32563, 'Goddard', 37.6597213745117, 0.657286133368914, -97.5749969482422, -1.70300496437025, 218, 20, 'PPL', 'P'),
(36124, 'Goddard', 38.3624992370605, 0.669551920980519, -83.6147232055664, -1.45935222308084, 218, 21, 'PPL', 'P'),
(47526, 'Goddard', 38.9894409179688, 0.680494117530355, -76.8536071777344, -1.34134848728581, 218, 25, 'PPL', 'P'),
(115755, 'Goddard', 41.7174987792969, 0.728107709395446, -93.1927795410156, -1.62652084207593, 218, 16, 'PPL', 'P'),
(209958, 'Goddard', 56.8352813720703, 0.991962791240027, -135.372787475586, -2.36270085905152, 218, 1, 'PPL', 'P'),
(155475, 'Goddard Corners', 40.060001373291, 0.699178922317378, -82.6116714477539, -1.4418456673391, 218, 41, 'PPL', 'P'),
(149186, 'Godeffroy', 41.4466705322266, 0.723380864776664, -74.6127777099609, -1.30223863509745, 218, 40, 'PPL', 'P'),
(21458, 'Godfrey', 33.4533309936523, 0.5838707715987, -83.504997253418, -1.45743714394097, 218, 13, 'PPL', 'P'),
(27277, 'Godfrey', 38.9555587768555, 0.679902762610303, -90.1866683959961, -1.57405430491445, 218, 18, 'PPL', 'P'),
(32564, 'Godfrey', 37.7616691589355, 0.659065457872223, -94.709716796875, -1.65299639173685, 218, 20, 'PPL', 'P'),
(109411, 'Godfrey', 37.3650016784668, 0.652142304302453, -81.2608337402344, -1.41826910168279, 218, 58, 'PPL', 'P'),
(162128, 'Godfrey', 40.6911087036133, 0.710193823164973, -79.6258316040039, -1.38973293112843, 218, 45, 'PPL', 'P'),
(207517, 'Godfrey (historical)', 48.708610534668, 0.850125627901552, -118.115280151367, -2.06150053555686, 218, 56, 'PPL', 'P'),
(113477, 'Godfrey Corner', 41.2355613708496, 0.719696314829512, -73.3847198486328, -1.28080498201228, 218, 8, 'PPL', 'P'),
(9146, 'Godfrey Landing', 33.2422218322754, 0.580186221651548, -92.0883331298828, -1.60724461578983, 218, 4, 'PPL', 'P'),
(149187, 'Godfreys Corner', 44.2938919067383, 0.773074252295052, -75.8880615234375, -1.32449653654001, 218, 40, 'PPL', 'P'),
(81254, 'Godgold Subdivision', 34.1036109924316, 0.595220298637263, -80.5355606079102, -1.40561069754748, 218, 48, 'PPL', 'P'),
(94509, 'Godley', 32.4488906860352, 0.566339981091035, -97.5263900756836, -1.702156614405, 218, 51, 'PPL', 'P'),
(119801, 'Godley', 41.2366714477539, 0.719715689326442, -88.2436065673828, -1.54014147843532, 218, 18, 'PPL', 'P'),
(81255, 'Godsey', 34.1683311462402, 0.59634987841362, -81.9674987792969, -1.43060273332316, 218, 48, 'PPL', 'P'),
(65084, 'Godwin', 35.2174987792969, 0.614661308015814, -78.6816711425781, -1.3732542224094, 218, 33, 'PPL', 'P'),
(87315, 'Godwin', 35.651668548584, 0.622239000002499, -87.0494384765625, -1.51929931342825, 218, 50, 'PPL', 'P'),
(195003, 'Godwin', 42.5127792358398, 0.741987971838884, -114.573890686035, -1.99969162929138, 218, 17, 'PPL', 'P'),
(2757, 'Godwin Estates', 33.6433296203613, 0.587186873209039, -86.6547164916992, -1.51241011516238, 218, 2, 'PPL', 'P'),
(21459, 'Godwinsville', 32.1355590820313, 0.560871312950612, -83.1272201538086, -1.45084368971415, 218, 13, 'PPL', 'P'),
(141922, 'Goehner', 40.832218170166, 0.712656647962051, -97.220832824707, -1.69682363432212, 218, 35, 'PPL', 'P'),
(162129, 'Goehring', 40.814998626709, 0.712356110233036, -80.2133331298828, -1.3999867671155, 218, 45, 'PPL', 'P'),
(36125, 'Goering', 37.8008308410645, 0.659748958165992, -86.7616729736328, -1.51427685792847, 218, 21, 'PPL', 'P'),
(174290, 'Goerkes Corner', 43.0363883972168, 0.751126675698518, -88.1661071777344, -1.53878885891767, 218, 57, 'PPL', 'P'),
(72691, 'Goes', 39.7666702270508, 0.694059328016837, -83.9161071777344, -1.46461236570791, 218, 41, 'PPL', 'P'),
(119802, 'Goeselville', 41.6241683959961, 0.726478786914699, -87.7850036621094, -1.53213734777909, 218, 18, 'PPL', 'P'),
(32565, 'Goessel', 38.2463912963867, 0.667525455128051, -97.3486099243164, -1.69905376541895, 218, 20, 'PPL', 'P'),
(131026, 'Goetzville', 46.0580596923828, 0.803864788712167, -84.0922164916992, -1.46768605308003, 218, 27, 'PPL', 'P'),
(32566, 'Goff', 39.663890838623, 0.692265489285587, -95.9319381713867, -1.67432817891033, 218, 20, 'PPL', 'P'),
(109412, 'Goffs', 39.0900001525879, 0.682249207267745, -81.0347213745117, -1.41432269642145, 218, 58, 'PPL', 'P'),
(181816, 'Goffs', 34.9191703796387, 0.609454495189573, -115.061943054199, -2.008209750038, 218, 6, 'PPL', 'P'),
(36132, 'Goffs Corner', 37.9286117553711, 0.661979155841852, -84.0066680908203, -1.46619295181487, 218, 21, 'PPL', 'P'),
(127575, 'Goffs Corner', 45.2138900756836, 0.789131249455467, -69.2402801513672, -1.20847086364464, 218, 26, 'PPL', 'P'),
(143875, 'Goffs Falls', 42.9319381713867, 0.749303675353332, -71.4530563354492, -1.24709109366658, 218, 36, 'PPL', 'P'),
(21460, 'Goffs Mill', 31.7052803039551, 0.553361531571725, -84.6958312988281, -1.47822111887822, 218, 13, 'PPL', 'P'),
(143876, 'Goffstown', 43.0202789306641, 0.750845512466433, -71.600830078125, -1.24967023202427, 218, 36, 'PPL', 'P'),
(87316, 'Goffton', 36.103889465332, 0.630131743946139, -85.440559387207, -1.49121907605251, 218, 50, 'PPL', 'P'),
(36126, 'Goforth', 38.6647186279297, 0.674826644414557, -84.4488906860352, -1.47391119212809, 218, 21, 'PPL', 'P'),
(94510, 'Goforth', 30.0216693878174, 0.523976977762604, -97.7930603027344, -1.70681088788408, 218, 51, 'PPL', 'P'),
(81256, 'Goforth Cross Road (historical)', 35.1555595397949, 0.613580264350324, -81.6763916015625, -1.42552195459551, 218, 48, 'PPL', 'P'),
(131027, 'Gogebic', 46.3525009155273, 0.809003757509638, -89.5025024414063, -1.5621133563768, 218, 27, 'PPL', 'P'),
(21462, 'Goggins', 33.0758285522461, 0.577282111061844, -84.0919418334961, -1.46768125939006, 218, 13, 'PPL', 'P'),
(181818, 'Goggins', 39.040828704834, 0.681391003606466, -120.506942749023, -2.10324292248277, 218, 6, 'PPL', 'P'),
(181819, 'Goggins (historical)', 39.0422210693359, 0.681415304951413, -120.508331298828, -2.10326715724869, 218, 6, 'PPL', 'P'),
(102317, 'Gogginsville', 37.0402793884277, 0.646474831186656, -79.9261093139648, -1.39497376583759, 218, 53, 'PPL', 'P'),
(162130, 'Goheenville', 40.9066696166992, 0.713956070836928, -79.3722229003906, -1.38530662423866, 218, 45, 'PPL', 'P'),
(202160, 'Goiens (historical)', 44.1958312988281, 0.771362771820513, -103.391670227051, -1.80452506459823, 218, 49, 'PPL', 'P'),
(87317, 'Goin', 36.4233283996582, 0.635707005109193, -83.7222213745117, -1.4612284200688, 218, 50, 'PPL', 'P'),
(75937, 'Going Snake', 35.9916687011719, 0.62817312212244, -94.6500015258789, -1.65195416364424, 218, 42, 'PPL', 'P'),
(36127, 'Goins', 36.7000007629395, 0.640535848797724, -83.9394378662109, -1.46501956303858, 218, 21, 'PPL', 'P'),
(65085, 'Goinstown (historical)', 36.5138893127441, 0.637287591216155, -80.0177764892578, -1.39657365986246, 218, 33, 'PPL', 'P'),
(149188, 'Golah', 42.9702796936035, 0.749972861156242, -77.7163925170898, -1.3564069321955, 218, 40, 'PPL', 'P'),
(102318, 'Golansville', 37.9805603027344, 0.662885829034969, -77.501106262207, -1.35264947821351, 218, 53, 'PPL', 'P'),
(27279, 'Golconda', 37.3672218322754, 0.652181053296314, -88.4863891601563, -1.54437883404575, 218, 18, 'PPL', 'P'),
(186775, 'Golconda', 37.4575004577637, 0.653756712555259, -108.151672363281, -1.88760277427741, 218, 7, 'PPL', 'P'),
(195002, 'Golconda', 47.4747200012207, 0.828590175483708, -115.870002746582, -2.02231305222273, 218, 17, 'PPL', 'P'),
(199965, 'Golconda', 40.9533309936523, 0.714770465498274, -117.488327026367, -2.05055813926995, 218, 39, 'PPL', 'P'),
(65086, 'Gold', 35.7930603027344, 0.624706751647593, -81.7622222900391, -1.42701998270868, 218, 33, 'PPL', 'P'),
(162133, 'Gold', 41.871940612793, 0.730803227892769, -77.8375015258789, -1.3585206831527, 218, 45, 'PPL', 'P'),
(199967, 'Gold Acres', 40.2622184753418, 0.702708276552006, -116.731666564941, -2.03735192289841, 218, 39, 'PPL', 'P'),
(207518, 'Gold Bar', 47.8569412231445, 0.835261194277274, -121.695831298828, -2.12399294211612, 218, 56, 'PPL', 'P'),
(190248, 'Gold Bar (historical)', 36.938060760498, 0.644690779572412, -116.892501831055, -2.0401590278454, 218, 39, 'PPL', 'P'),
(209893, 'Gold Beach', 42.4075012207031, 0.740150523844784, -124.420562744141, -2.17154847706944, 218, 43, 'PPL', 'P'),
(2758, 'Gold Branch', 32.9941711425781, 0.575856920404488, -86.3874969482422, -1.50774625430338, 218, 2, 'PPL', 'P'),
(196608, 'Gold Butte', 48.8736114501953, 0.853005437146309, -111.38500213623, -1.94403502461814, 218, 31, 'PPL', 'P'),
(190250, 'Gold Butte (historical)', 36.2802810668945, 0.633210358166271, -114.199722290039, -1.99316115882434, 218, 39, 'PPL', 'P'),
(178259, 'Gold Camp', 33.2936096191406, 0.581083107727659, -111.303611755371, -1.94261449449269, 218, 5, 'PPL', 'P'),
(190259, 'Gold Center', 36.8683280944824, 0.643473714954245, -116.766387939453, -2.03795792520445, 218, 39, 'PPL', 'P'),
(36128, 'Gold City', 36.7544403076172, 0.641485998095637, -86.4475021362305, -1.50879354240205, 218, 21, 'PPL', 'P'),
(196609, 'Gold Coin (historical)', 46.1736106872559, 0.805881534026657, -113.24388885498, -1.97647871828192, 218, 31, 'PPL', 'P'),
(9147, 'Gold Creek', 35.0119400024414, 0.611073630553314, -92.4138870239258, -1.61292660313357, 218, 4, 'PPL', 'P'),
(21461, 'Gold Creek', 33.9261093139648, 0.592122309920201, -84.7480621337891, -1.47913271891935, 218, 13, 'PPL', 'P'),
(195004, 'Gold Creek', 47.1372184753418, 0.822699662626616, -115.406936645508, -2.01423102410461, 218, 17, 'PPL', 'P'),
(81265, 'Gold Cup Springs', 32.9161109924316, 0.57449451376983, -79.9847183227539, -1.39599668601229, 218, 48, 'PPL', 'P'),
(102319, 'Gold Dale', 38.2669410705566, 0.667884116347857, -77.8061065673828, -1.35797273775841, 218, 53, 'PPL', 'P'),
(41108, 'Gold Dust', 30.8572196960449, 0.538560081707228, -92.1994400024414, -1.60918379653757, 218, 22, 'PPL', 'P'),
(181820, 'Gold Flat', 39.2461090087891, 0.684973820799977, -121.023330688477, -2.11225559224381, 218, 6, 'PPL', 'P'),
(2760, 'Gold Hill', 32.7216682434082, 0.571100847592742, -85.5077819824219, -1.49239233167075, 218, 2, 'PPL', 'P'),
(9149, 'Gold Hill', 35.1958312988281, 0.614283139141023, -92.961669921875, -1.6224872182889, 218, 4, 'PPL', 'P'),
(65091, 'Gold Hill', 34.9211082458496, 0.609488317335417, -79.1733322143555, -1.3818353269158, 218, 33, 'PPL', 'P'),
(102320, 'Gold Hill', 37.6233291625977, 0.65665096944893, -78.3705596923828, -1.36782430326283, 218, 53, 'PPL', 'P'),
(181823, 'Gold Hill', 38.7611083984375, 0.67650896327516, -120.883613586426, -2.10981706879168, 218, 6, 'PPL', 'P'),
(190253, 'Gold Hill', 39.2905616760254, 0.685749666204545, -119.656387329102, -2.08839792993445, 218, 39, 'PPL', 'P'),
(194208, 'Gold Hill', 40.063060760498, 0.699232318697234, -105.403610229492, -1.83964004199341, 218, 7, 'PPL', 'P'),
(200900, 'Gold Hill', 42.4319381713867, 0.74057702909336, -123.049438476563, -2.14761784414621, 218, 43, 'PPL', 'P'),
(204098, 'Gold Hill', 40.166389465332, 0.701035744808409, -113.829719543457, -1.98670339265506, 218, 52, 'PPL', 'P'),
(188619, 'Gold Hill (historical)', 32.4366683959961, 0.56612666188772, -108.531112670898, -1.89422525696011, 218, 38, 'PPL', 'P'),
(190254, 'Gold Hit', 37.9336090087891, 0.662066374367552, -118.279167175293, -2.06436090372566, 218, 39, 'PPL', 'P'),
(16235, 'Gold Key', 25.3452796936035, 0.442358580492241, -80.3330612182617, -1.40207641646483, 218, 12, 'PPL', 'P'),
(162131, 'Gold Key Lake', 41.3058280944824, 0.720922700511494, -74.9388885498047, -1.30793034297917, 218, 45, 'PPL', 'P'),
(181822, 'Gold Lake (historical)', 39.7783317565918, 0.694262860103146, -121.313331604004, -2.11731706305356, 218, 6, 'PPL', 'P'),
(9148, 'Gold Lake Estates', 35.0233306884766, 0.611272435528688, -92.3899993896484, -1.61250968526492, 218, 4, 'PPL', 'P'),
(65090, 'Gold Leaf Estates', 35.5077781677246, 0.619727639094554, -77.3483276367188, -1.34998298817207, 218, 33, 'PPL', 'P'),
(2761, 'Gold Mine', 34.0391693115234, 0.594095579129895, -87.7436065673828, -1.53141483217535, 218, 2, 'PPL', 'P'),
(41109, 'Gold Mine', 29.836109161377, 0.520738340850472, -91.5997161865234, -1.59871664134718, 218, 22, 'PPL', 'P'),
(162132, 'Gold Mine', 40.5261116027832, 0.707314080499243, -76.5374984741211, -1.33583134961355, 218, 45, 'PPL', 'P'),
(204108, 'Gold Mine Acres Condominium', 40.850830078125, 0.712981487036014, -111.903610229492, -1.95308644337305, 218, 52, 'PPL', 'P'),
(202161, 'Gold Mountain Subdivision', 43.9563903808594, 0.76718373943796, -103.59610748291, -1.80809316782672, 218, 49, 'PPL', 'P'),
(65096, 'Gold Point', 35.8702812194824, 0.626054510896255, -77.2416687011719, -1.3481214385701, 218, 33, 'PPL', 'P'),
(190255, 'Gold Point', 37.3547210693359, 0.651962873824009, -117.364166259766, -2.04839112509095, 218, 39, 'PPL', 'P'),
(195005, 'Gold Point', 45.7830581665039, 0.799065106637571, -115.392776489258, -2.01398388275545, 218, 17, 'PPL', 'P'),
(190256, 'Gold Point (historical)', 38.8183288574219, 0.67750764868394, -115.347221374512, -2.01318879601201, 218, 39, 'PPL', 'P'),
(199971, 'Gold Quartz', 40.3108291625977, 0.703556693096278, -116.699440002441, -2.03678946327618, 218, 39, 'PPL', 'P'),
(190257, 'Gold Reef (historical)', 37.9661102294922, 0.662633627679739, -117.215278625488, -2.0457925456573, 218, 39, 'PPL', 'P'),
(2765, 'Gold Ridge', 34.2597198486328, 0.597944912169496, -86.7533264160156, -1.51413118301684, 218, 2, 'PPL', 'P'),
(181825, 'Gold Ridge', 38.7533302307129, 0.676373208638594, -120.567222595215, -2.1042950042714, 218, 6, 'PPL', 'P'),
(181826, 'Gold River', 38.6263885498047, 0.67415765834873, -121.245559692383, -2.1161342200554, 218, 6, 'PPL', 'P'),
(65092, 'Gold Rock', 36.0699996948242, 0.629540255868033, -77.8133316040039, -1.35809883843603, 218, 33, 'PPL', 'P'),
(181827, 'Gold Run', 39.1808280944824, 0.683834453906614, -120.854721069336, -2.10931279923927, 218, 6, 'PPL', 'P'),
(194209, 'Gold Run', 40.0541687011719, 0.69907712298471, -105.410827636719, -1.83976600951298, 218, 7, 'PPL', 'P'),
(199972, 'Gold Run (historical)', 40.8097190856934, 0.712263964859319, -117.500556945801, -2.05077159163132, 218, 39, 'PPL', 'P'),
(65093, 'Gold Sand', 36.1925010681152, 0.631678308170175, -78.1738891601563, -1.36439175493383, 218, 33, 'PPL', 'P'),
(181829, 'Gold Town (historical)', 35.0016708374023, 0.610894399811952, -118.168060302734, -2.06242172297792, 218, 6, 'PPL', 'P'),
(181830, 'Gold Trail Park', 38.7527809143066, 0.676363621258669, -120.848892211914, -2.10921106648563, 218, 6, 'PPL', 'P'),
(65094, 'Gold Valley Crossroads', 35.8994407653809, 0.626563440980569, -78.168327331543, -1.3642946827121, 218, 33, 'PPL', 'P'),
(155478, 'Golda', 40.127498626709, 0.700356971625575, -81.1766662597656, -1.4168001020255, 218, 41, 'PPL', 'P'),
(94511, 'Goldapp Colonia', 27.7159996032715, 0.48373544855853, -98.1449966430664, -1.71295333578029, 218, 51, 'PPL', 'P'),
(178260, 'Goldbadge', 33.6108283996582, 0.586619619896852, -112.338333129883, -1.96067378931868, 218, 5, 'PPL', 'P'),
(102322, 'Goldbond', 37.3800010681152, 0.652404093037608, -80.6666717529297, -1.40789901871413, 218, 53, 'PPL', 'P'),
(199976, 'Goldbud (historical)', 40.7922210693359, 0.711958566861314, -118.670562744141, -2.07119204507977, 218, 39, 'PPL', 'P'),
(36129, 'Goldbug', 36.7924995422363, 0.64215025705053, -84.1680603027344, -1.46900977729985, 218, 21, 'PPL', 'P'),
(195006, 'Goldburg', 44.3855590820313, 0.774674146319917, -113.644996643066, -1.98347936983941, 218, 17, 'PPL', 'P'),
(196610, 'Goldcreek', 46.586669921875, 0.813090777676528, -112.927780151367, -1.97096158060966, 218, 31, 'PPL', 'P'),
(2763, 'Golddust', 32.5636100769043, 0.568342212177584, -85.7811126708984, -1.4971628521314, 218, 2, 'PPL', 'P'),
(87319, 'Golddust', 35.7252807617188, 0.62352377549138, -89.8586120605469, -1.56832864172883, 218, 50, 'PPL', 'P'),
(54988, 'Golden', 36.524169921875, 0.637467021694599, -93.6536102294922, -1.63456385488408, 218, 29, 'PPL', 'P'),
(60062, 'Golden', 34.4883308410645, 0.60193492669368, -88.188606262207, -1.5391815420204, 218, 30, 'PPL', 'P'),
(75938, 'Golden', 34.0344390869141, 0.594013021136103, -94.896110534668, -1.65624957616643, 218, 42, 'PPL', 'P'),
(94512, 'Golden', 32.7294387817383, 0.571236469071255, -95.5627822875977, -1.6678851932851, 218, 51, 'PPL', 'P'),
(109414, 'Golden', 39.9824981689453, 0.6978262362207, -80.5369415283203, -1.40563479915534, 218, 58, 'PPL', 'P'),
(115757, 'Golden', 42.3905601501465, 0.739854846384758, -91.4702835083008, -1.59645761495252, 218, 16, 'PPL', 'P'),
(119805, 'Golden', 40.1091690063477, 0.700037059399629, -91.0175018310547, -1.58855508389187, 218, 18, 'PPL', 'P'),
(131030, 'Golden', 43.6100006103516, 0.761138097447371, -84.168327331543, -1.46901443783176, 218, 27, 'PPL', 'P'),
(186777, 'Golden', 39.7555618286133, 0.693865449889479, -105.220558166504, -1.8364451807917, 218, 7, 'PPL', 'P'),
(188620, 'Golden', 35.2669410705566, 0.615524238788027, -106.213333129883, -1.85377237263403, 218, 38, 'PPL', 'P'),
(195007, 'Golden', 45.8122215270996, 0.799574103300913, -115.678886413574, -2.01897744295741, 218, 17, 'PPL', 'P'),
(200901, 'Golden', 42.6824989318848, 0.744950139340352, -123.330276489258, -2.1525193921325, 218, 43, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(211849, 'Golden', 60.9700012207031, 1.06412726624623, -147.986114501953, -2.58284494529241, 218, 1, 'PPL', 'P'),
(21463, 'Golden (historical)', 30.8697204589844, 0.538778261179533, -83.4430618286133, -1.4563561668545, 218, 13, 'PPL', 'P'),
(65095, 'Golden (historical)', 35.5400009155273, 0.620290032137751, -81.8013916015625, -1.4277036161605, 218, 33, 'PPL', 'P'),
(78364, 'Golden (historical)', 39.9622192382813, 0.697472302111828, -76.6277770996094, -1.33740700887249, 218, 45, 'PPL', 'P'),
(190260, 'Golden (historical)', 38.6458282470703, 0.674496945071606, -117.555000305176, -2.05172180750826, 218, 39, 'PPL', 'P'),
(196611, 'Golden (historical)', 45.2188911437988, 0.789218534560194, -108.965278625488, -1.90180288236777, 218, 31, 'PPL', 'P'),
(81257, 'Golden Acre Mobile Home Park', 33.9249992370605, 0.592102935423271, -80.3066711425781, -1.40161582275431, 218, 48, 'PPL', 'P'),
(94513, 'Golden Acres', 29.670560836792, 0.517848977515304, -95.1527786254883, -1.66072927943605, 218, 51, 'PPL', 'P'),
(119806, 'Golden Acres', 40.7438888549805, 0.711115010586032, -89.6316680908203, -1.56436772223955, 218, 18, 'PPL', 'P'),
(122696, 'Golden Acres', 41.1266708374023, 0.717795816496604, -85.0619430541992, -1.4846109744397, 218, 19, 'PPL', 'P'),
(162134, 'Golden Acres Estates', 40.5641708374023, 0.707978339454136, -75.1183319091797, -1.3110622204211, 218, 45, 'PPL', 'P'),
(196612, 'Golden Age Village Trailer Park', 45.3702812194824, 0.791860789835716, -110.732780456543, -1.9326516088547, 218, 31, 'PPL', 'P'),
(190261, 'Golden Arrow', 37.9977798461914, 0.663186366763985, -116.605278015137, -2.03514602656749, 218, 39, 'PPL', 'P'),
(115758, 'Golden Arrow Mobile Park', 40.9930610656738, 0.715463886067104, -92.4033279418945, -1.61274231238614, 218, 16, 'PPL', 'P'),
(36130, 'Golden Ash', 36.8605613708496, 0.64333816005476, -83.2911071777344, -1.45370405788295, 218, 21, 'PPL', 'P'),
(16227, 'Golden Beach', 25.9647197723389, 0.453169849384986, -80.1224975585938, -1.39840138731858, 218, 12, 'PPL', 'P'),
(47527, 'Golden Beach', 38.4897193908691, 0.671772331539373, -76.682502746582, -1.33836215159745, 218, 25, 'PPL', 'P'),
(94514, 'Golden Beach', 30.8008899688721, 0.537576942501311, -98.4710311889648, -1.71864371208146, 218, 51, 'PPL', 'P'),
(181832, 'Golden Chain Mobile Home Park', 38.938060760498, 0.679597364612298, -121.091667175293, -2.113448288938, 218, 6, 'PPL', 'P'),
(9150, 'Golden City', 35.0591697692871, 0.611897945489721, -93.9258270263672, -1.63931493426878, 218, 4, 'PPL', 'P'),
(54991, 'Golden City', 37.3930587768555, 0.652631993047892, -94.0936126708984, -1.64224334620343, 218, 29, 'PPL', 'P'),
(155479, 'Golden Corners', 40.9150009155273, 0.714101479432447, -81.9819412231445, -1.43085480152034, 218, 41, 'PPL', 'P'),
(145308, 'Golden Crest', 40.2083282470703, 0.701767714634017, -74.6647186279297, -1.30314517513252, 218, 37, 'PPL', 'P'),
(27284, 'Golden Eagle', 38.8933296203613, 0.678816658938741, -90.5788879394531, -1.58089982733844, 218, 18, 'PPL', 'P'),
(47528, 'Golden Fleece Estates', 39.6969413757324, 0.692842329977698, -78.1125030517578, -1.36332036522729, 218, 25, 'PPL', 'P'),
(27285, 'Golden Gardens', 38.5894393920898, 0.673512773890767, -90.1066665649414, -1.57265800955492, 218, 18, 'PPL', 'P'),
(16229, 'Golden Gate', 27.1622200012207, 0.474070171172359, -80.2163925170898, -1.40004016349536, 218, 12, 'PPL', 'P'),
(27286, 'Golden Gate', 38.3594398498535, 0.669498524600663, -88.2041702270508, -1.53945318445159, 218, 18, 'PPL', 'P'),
(16230, 'Golden Gates Estates', 26.1666698455811, 0.456694543087706, -81.5297164916992, -1.42296199099767, 218, 12, 'PPL', 'P'),
(16231, 'Golden Glades', 25.9113903045654, 0.452239074584003, -80.2005615234375, -1.39976386053226, 218, 12, 'PPL', 'P'),
(149189, 'Golden Glow Heights', 42.0858306884766, 0.734536313950788, -76.8716735839844, -1.34166380555888, 218, 40, 'PPL', 'P'),
(60063, 'Golden Grove', 32.6308288574219, 0.569515401216791, -89.0897216796875, -1.55490897299592, 218, 30, 'PPL', 'P'),
(81258, 'Golden Grove', 34.7338905334473, 0.606220751835944, -82.4438934326172, -1.4389173885625, 218, 48, 'PPL', 'P'),
(47529, 'Golden Hill', 38.4027786254883, 0.670254928929273, -76.2302780151367, -1.33046934107478, 218, 25, 'PPL', 'P'),
(122697, 'Golden Hill', 40.7102813720703, 0.710528449355942, -86.7605590820313, -1.51425741685251, 218, 19, 'PPL', 'P'),
(135599, 'Golden Hill', 43.9883308410645, 0.767741205633141, -92.4680633544922, -1.6138721584786, 218, 28, 'PPL', 'P'),
(204102, 'Golden Hill Canyon', 40.5916709899902, 0.708458307661596, -111.788330078125, -1.95107442516949, 218, 52, 'PPL', 'P'),
(113478, 'Golden Hill Paugussett Indian Reservation', 41.5541687011719, 0.725257061764625, -72.2677764892578, -1.2613106428329, 218, 8, 'PPL', 'P'),
(16232, 'Golden Hills', 29.2386093139648, 0.510310001232967, -82.246940612793, -1.43547991338548, 218, 12, 'PPL', 'P'),
(102323, 'Golden Hills', 38.4894409179688, 0.671767471270383, -77.7194366455078, -1.35646006225925, 218, 53, 'PPL', 'P'),
(181834, 'Golden Hills', 35.1425018310547, 0.61335236434004, -118.489440917969, -2.06803087286585, 218, 6, 'PPL', 'P'),
(204103, 'Golden Hills', 40.5916709899902, 0.708458307661596, -111.79167175293, -1.95113274839736, 218, 52, 'PPL', 'P'),
(16233, 'Golden Isles', 25.9794406890869, 0.453426777851151, -80.1288909912109, -1.39851297376825, 218, 12, 'PPL', 'P'),
(21465, 'Golden Isles', 32.0250015258789, 0.558941719582795, -80.9686126708984, -1.41316888187918, 218, 13, 'PPL', 'P'),
(9151, 'Golden Lake', 35.5458297729492, 0.620391764891392, -90.0455627441406, -1.57159154669639, 218, 4, 'PPL', 'P'),
(16234, 'Golden Lakes', 26.7002792358398, 0.466007783867281, -80.1650009155273, -1.39914321084022, 218, 12, 'PPL', 'P'),
(27287, 'Golden Lily', 37.0755615234375, 0.647090620609709, -89.1858291625977, -1.55658636500851, 218, 18, 'PPL', 'P'),
(41110, 'Golden Meadow', 29.3788890838623, 0.512758345091618, -90.2600021362305, -1.57533422013434, 218, 22, 'PPL', 'P'),
(21466, 'Golden Meadows', 33.586669921875, 0.586197974917265, -84.4269409179688, -1.47352809640528, 218, 13, 'PPL', 'P'),
(41111, 'Golden Meadows', 32.4494400024414, 0.566349568470959, -93.6500015258789, -1.6345008711243, 218, 22, 'PPL', 'P'),
(87320, 'Golden Meadows', 35.975830078125, 0.62789668600129, -84.102783203125, -1.46787047698551, 218, 50, 'PPL', 'P'),
(181835, 'Golden Mesa', 34.535831451416, 0.602763968741022, -117.334167480469, -2.04786754762064, 218, 6, 'PPL', 'P'),
(204105, 'Golden Oaks', 40.5894393920898, 0.708419358930653, -111.799171447754, -1.95126364276494, 218, 52, 'PPL', 'P'),
(181836, 'Golden Oaks Mobile Estates', 34.4352798461914, 0.601009012161687, -119.277778625488, -2.08178996147969, 218, 6, 'PPL', 'P'),
(181837, 'Golden Oaks Mobile Home Park', 34.4330596923828, 0.600970263167826, -119.294723510742, -2.08208570551874, 218, 6, 'PPL', 'P'),
(65098, 'Golden Place', 35.5947189331055, 0.621245041704654, -77.3413925170898, -1.34986194750052, 218, 33, 'PPL', 'P'),
(36131, 'Golden Pond', 36.7855606079102, 0.642029149799959, -88.024169921875, -1.53631158647168, 218, 21, 'PPL', 'P'),
(196613, 'Golden Ridge', 47.5677795410156, 0.83021437085352, -112.226112365723, -1.95871516749498, 218, 31, 'PPL', 'P'),
(47530, 'Golden Ring', 39.3344383239746, 0.686515458175997, -76.4947204589844, -1.33508473240195, 218, 25, 'PPL', 'P'),
(124938, 'Golden Ring Camp', 42.0499992370605, 0.73391093714781, -70.8444366455078, -1.23646867618464, 218, 23, 'PPL', 'P'),
(162135, 'Golden Rod Farms', 41.0169410705566, 0.715880670777701, -78.4019393920898, -1.36837198234101, 218, 45, 'PPL', 'P'),
(115759, 'Golden Spike Mobile Home Park', 41.2538909912109, 0.720016227055458, -95.8744430541992, -1.67332469981158, 218, 16, 'PPL', 'P'),
(2766, 'Golden Springs', 33.6436080932617, 0.587191733478028, -85.7858276367188, -1.49724514380909, 218, 2, 'PPL', 'P'),
(113479, 'Golden Spur', 41.3691711425781, 0.722028245259013, -72.1969375610352, -1.26007427029683, 218, 8, 'PPL', 'P'),
(41113, 'Golden Star Plantation', 29.9291706085205, 0.522362569509798, -90.6624984741211, -1.58235910645775, 218, 22, 'PPL', 'P'),
(21467, 'Golden Terrace', 33.4366683959961, 0.583579954407663, -82.0550003051758, -1.43212992305027, 218, 13, 'PPL', 'P'),
(181838, 'Golden Torch Trailer Park', 38.2969398498535, 0.668407693818167, -120.286109924316, -2.09938866259515, 218, 6, 'PPL', 'P'),
(70879, 'Golden Triangle', 39.9277801513672, 0.696871226653797, -75.0391693115234, -1.30968057244757, 218, 37, 'PPL', 'P'),
(135600, 'Golden Valley', 45.0097198486328, 0.785567806758886, -93.3488922119141, -1.62924552218719, 218, 28, 'PPL', 'P'),
(178261, 'Golden Valley', 35.223331451416, 0.614763107348483, -114.222221374512, -1.99355384192707, 218, 5, 'PPL', 'P'),
(190263, 'Golden Valley', 39.6155586242676, 0.691421933010304, -119.825561523438, -2.09135057663502, 218, 39, 'PPL', 'P'),
(198349, 'Golden Valley', 47.290828704834, 0.825380666895999, -102.064170837402, -1.78135582943065, 218, 34, 'PPL', 'P'),
(181839, 'Golden Valley Acres', 34.422779083252, 0.600790832689382, -117.442222595215, -2.04975346514658, 218, 6, 'PPL', 'P'),
(196614, 'Golden Valley Colony', 46.2574996948242, 0.807345673414955, -109.273612976074, -1.90718433198249, 218, 31, 'PPL', 'P'),
(178262, 'Golden West Estates', 33.4222183227539, 0.583327753052432, -111.758331298828, -1.95055084769918, 218, 5, 'PPL', 'P'),
(207519, 'Goldendale', 45.8208312988281, 0.799724372165421, -120.820556640625, -2.10871651747121, 218, 56, 'PPL', 'P'),
(162136, 'Goldenridge', 40.1458282470703, 0.70067688385152, -74.853889465332, -1.30644682909394, 218, 45, 'PPL', 'P'),
(16236, 'Goldenrod', 28.6100006103516, 0.499338709648222, -81.2888870239258, -1.4187587238492, 218, 12, 'PPL', 'P'),
(32568, 'Goldenrod', 39.060001373291, 0.681725629797435, -98.2441711425781, -1.71468425733079, 218, 20, 'PPL', 'P'),
(113127, 'Goldenrod', 47.0944404602051, 0.821953045415012, -95.23388671875, -1.66214488271349, 218, 28, 'PPL', 'P'),
(149190, 'Goldens Bridge', 41.2933311462402, 0.720704587618216, -73.6772232055664, -1.2859101286639, 218, 40, 'PPL', 'P'),
(21468, 'Goldens Mill (historical)', 32.9358291625977, 0.574838660761696, -83.1819381713867, -1.45179869928105, 218, 13, 'PPL', 'P'),
(174293, 'Goldenthal', 43.2361106872559, 0.754612487249323, -88.1619415283203, -1.53871615461991, 218, 57, 'PPL', 'P'),
(47531, 'Goldentree', 39.3333282470703, 0.686496083679067, -76.4677810668945, -1.33461455131149, 218, 25, 'PPL', 'P'),
(78363, 'Goldenville', 39.8925018310547, 0.696255503809771, -77.2422180175781, -1.34813102595003, 218, 45, 'PPL', 'P'),
(115760, 'Goldfield', 42.7358283996582, 0.745880914141335, -93.9205627441406, -1.63922305521117, 218, 16, 'PPL', 'P'),
(178263, 'Goldfield', 33.4588890075684, 0.583967777241406, -111.486671447754, -1.94580948885246, 218, 5, 'PPL', 'P'),
(186778, 'Goldfield', 38.7177810668945, 0.675752758683632, -105.125556945801, -1.83478709669702, 218, 7, 'PPL', 'P'),
(190264, 'Goldfield', 37.708610534668, 0.658139410182175, -117.234718322754, -2.04613183238018, 218, 39, 'PPL', 'P'),
(207520, 'Goldfield Mill', 48.774169921875, 0.851269855063904, -117.666107177734, -2.053660988256, 218, 56, 'PPL', 'P'),
(94515, 'Goldfinch', 28.8586101531982, 0.503677764722774, -98.8730621337891, -1.72566047576355, 218, 51, 'PPL', 'P'),
(181841, 'Goldleaf', 36.7222213745117, 0.640923671631467, -119.716941833496, -2.08945480541304, 218, 6, 'PPL', 'P'),
(9153, 'Goldman', 34.454719543457, 0.601348298884563, -91.6041717529297, -1.59879440565101, 218, 4, 'PPL', 'P'),
(41114, 'Goldman', 31.8283290863037, 0.555509137964278, -91.3805618286133, -1.59489167623155, 218, 22, 'PPL', 'P'),
(54990, 'Goldman', 38.2972183227539, 0.668412554087156, -90.5213928222656, -1.5798963482397, 218, 29, 'PPL', 'P'),
(41115, 'Goldman Landing', 31.8230590820313, 0.55541715903813, -91.3552780151367, -1.59445039043893, 218, 22, 'PPL', 'P'),
(102324, 'Goldmans Corner', 38.1133308410645, 0.665203112078474, -77.2058334350586, -1.3474959951881, 218, 53, 'PPL', 'P'),
(420, 'Goldmine', 34.2905616760254, 0.598483203604828, -83.0461120605469, -1.44942808643672, 218, 13, 'PPL', 'P'),
(47532, 'Goldmine Estates', 39.4111099243164, 0.687853630044735, -77.4805603027344, -1.35229088357273, 218, 25, 'PPL', 'P'),
(181842, 'Goldmont Forest', 38.0233306884766, 0.663632313088518, -120.251388549805, -2.0987826602891, 218, 6, 'PPL', 'P'),
(41116, 'Goldonna', 32.0166702270508, 0.558796310987277, -92.9091720581055, -1.62157095771586, 218, 22, 'PPL', 'P'),
(41117, 'Goldridge', 30.1155605316162, 0.525615687360357, -91.1902770996094, -1.59157058119417, 218, 22, 'PPL', 'P'),
(54999, 'Goldsberry', 39.9622192382813, 0.697472302111828, -92.769172668457, -1.61912750741571, 218, 29, 'PPL', 'P'),
(13828, 'Goldsboro', 39.1566696166992, 0.683412808927027, -75.5199966430664, -1.31807259251657, 218, 10, 'PPL', 'P'),
(21469, 'Goldsboro', 32.4724998474121, 0.566752038690698, -83.227783203125, -1.45259884603056, 218, 13, 'PPL', 'P'),
(47533, 'Goldsboro', 39.0338897705078, 0.681269896355895, -75.7869415283203, -1.32273165968561, 218, 25, 'PPL', 'P'),
(65100, 'Goldsboro', 35.3847198486328, 0.617579866254432, -77.9930572509766, -1.36123564272598, 218, 33, 'PPL', 'P'),
(72692, 'Goldsboro', 39.1169395446777, 0.682719388358198, -82.5680618286133, -1.44108453589955, 218, 41, 'PPL', 'P'),
(94517, 'Goldsboro', 32.060001373291, 0.559552582157832, -99.6808319091797, -1.73975871794221, 218, 51, 'PPL', 'P'),
(113308, 'Goldsboro', 40.1525001525879, 0.700793330570184, -76.7505569458008, -1.33954992144363, 218, 45, 'PPL', 'P'),
(21470, 'Goldsborough (historical)', 31.0352802276611, 0.541667824251782, -81.8686065673828, -1.42887673862068, 218, 13, 'PPL', 'P'),
(47535, 'Goldsborough (historical)', 38.7999992370605, 0.677187736457994, -76.1177825927734, -1.32850592556112, 218, 25, 'PPL', 'P'),
(75942, 'Goldsby', 35.1411094665527, 0.613328062995093, -97.4766693115234, -1.7012888233638, 218, 42, 'PPL', 'P'),
(122700, 'Goldsmith', 40.2894401550293, 0.703183384490476, -86.149169921875, -1.50358666299678, 218, 19, 'PPL', 'P'),
(149191, 'Goldsmith', 44.5686111450195, 0.777869007521631, -73.998893737793, -1.2915243385579, 218, 40, 'PPL', 'P'),
(191538, 'Goldsmith', 31.9805603027344, 0.558166073915309, -102.614723205566, -1.79096478095976, 218, 51, 'PPL', 'P'),
(21471, 'Goldsmith (historical)', 31.7833309173584, 0.554723771758814, -82.6791687011719, -1.44302371664729, 218, 13, 'PPL', 'P'),
(21472, 'Goldson', 32.5608291625977, 0.568293676066717, -84.2588882446289, -1.47059502393872, 218, 13, 'PPL', 'P'),
(200902, 'Goldson', 44.163330078125, 0.770795518508326, -123.34139251709, -2.15271340341791, 218, 43, 'PPL', 'P'),
(207522, 'Goldstake', 48.9205589294434, 0.853824825234699, -118.209999084473, -2.06315369280353, 218, 56, 'PPL', 'P'),
(16237, 'Goldstein', 28.0355606079102, 0.489312840250455, -82.4866714477539, -1.4396640057741, 218, 12, 'PPL', 'P'),
(65105, 'Goldston', 35.5930595397949, 0.621216079827799, -79.32861328125, -1.38454549279912, 218, 33, 'PPL', 'P'),
(181843, 'Goldstone', 35.2972183227539, 0.616052676527326, -116.913063049316, -2.04051788880229, 218, 6, 'PPL', 'P'),
(196616, 'Goldstone', 48.8997192382813, 0.853461104008821, -110.531669616699, -1.92914156253798, 218, 31, 'PPL', 'P'),
(94516, 'Goldthwaite', 31.4497203826904, 0.548901169509519, -98.570556640625, -1.72038075890247, 218, 51, 'PPL', 'P'),
(109415, 'Goldtown', 38.6116714477539, 0.673900796461591, -81.6530609130859, -1.42511475726484, 218, 58, 'PPL', 'P'),
(181844, 'Goldtree', 35.3219413757324, 0.616484175202946, -120.68138885498, -2.106287581399, 218, 6, 'PPL', 'P'),
(102325, 'Goldvein', 38.4488906860352, 0.671059736210695, -77.6555633544922, -1.35534526302694, 218, 53, 'PPL', 'P'),
(2767, 'Goldville', 33.083610534668, 0.577417932277438, -85.7838897705078, -1.49721132166324, 218, 2, 'PPL', 'P'),
(199977, 'Goldville (historical)', 40.9155616760254, 0.714111266549453, -116.308326721191, -2.02996324877009, 218, 39, 'PPL', 'P'),
(140104, 'Goldwin', 47.1488914489746, 0.822903394450007, -99.2008285522461, -1.73138107894309, 218, 34, 'PPL', 'P'),
(190266, 'Goldyke', 38.7369384765625, 0.676087118558492, -117.868606567383, -2.05719526933864, 218, 39, 'PPL', 'P'),
(181845, 'Goler Heights', 35.4269409179688, 0.618316762928057, -117.745002746582, -2.05503797569762, 218, 6, 'PPL', 'P'),
(181846, 'Goleta', 34.4358291625977, 0.601018599541611, -119.826667785645, -2.09136988455292, 218, 6, 'PPL', 'P'),
(16238, 'Golf', 26.4983291625977, 0.462483090164561, -80.10888671875, -1.39816383334934, 218, 12, 'PPL', 'P'),
(119807, 'Golf', 42.0588912963867, 0.734066132860335, -87.7925033569336, -1.53226824214667, 218, 18, 'PPL', 'P'),
(181848, 'Golf (historical)', 38.0061111450195, 0.663331775359503, -122.531387329102, -2.13857614592928, 218, 6, 'PPL', 'P'),
(196617, 'Golf Bench (historical)', 47.8333282470703, 0.834849070098585, -109.499443054199, -1.91112581039581, 218, 31, 'PPL', 'P'),
(112387, 'Golf Club Shores', 38.2511100769043, 0.667607813384761, -75.1688919067383, -1.3119446588483, 218, 25, 'PPL', 'P'),
(16239, 'Golf Estates', 26.1591701507568, 0.456563648720128, -80.1980590820313, -1.39972018469039, 218, 12, 'PPL', 'P'),
(47547, 'Golf Estates', 39.2041702270508, 0.684241850974369, -77.1302795410156, -1.34617733097434, 218, 25, 'PPL', 'P'),
(65102, 'Golf Estates', 35.4647216796875, 0.618976161613961, -82.1999969482422, -1.43466059187612, 218, 33, 'PPL', 'P'),
(27288, 'Golf Lakes', 39.4030609130859, 0.687713148297233, -87.6666717529297, -1.53007206635373, 218, 18, 'PPL', 'P'),
(70880, 'Golf Manor', 39.6966705322266, 0.692837602866763, -75.4711074829102, -1.31721931570331, 218, 37, 'PPL', 'P'),
(72693, 'Golf Manor', 39.1872215270996, 0.683946040356288, -84.4463882446289, -1.47386751628621, 218, 41, 'PPL', 'P'),
(21473, 'Golf Retreat', 31.1388893127441, 0.543476143921459, -81.4005584716797, -1.42070775829297, 218, 13, 'PPL', 'P'),
(70881, 'Golf View', 39.7005615234375, 0.69290551347456, -75.4697189331055, -1.31719508093739, 218, 37, 'PPL', 'P'),
(145309, 'Golf View Manor', 40.2805595397949, 0.703028388515033, -74.591667175293, -1.30187018676064, 218, 37, 'PPL', 'P'),
(115761, 'Golf View Mobile Home Court', 41.7513885498047, 0.728699197473552, -91.6166687011719, -1.59901251854429, 218, 16, 'PPL', 'P'),
(81259, 'Golf View Plantation', 33.8680610656738, 0.591109176862508, -78.6688919067383, -1.3730311826681, 218, 48, 'PPL', 'P'),
(94522, 'Golfcrest', 29.6911106109619, 0.518207638735111, -95.2986068725586, -1.66327446248984, 218, 51, 'PPL', 'P'),
(131032, 'Golfcrest', 41.9427795410156, 0.732039600428839, -83.3702774047852, -1.45508583901453, 218, 27, 'PPL', 'P'),
(16240, 'Golfview', 26.6886100769043, 0.465804118622917, -80.1127777099609, -1.39823174395714, 218, 12, 'PPL', 'P'),
(21474, 'Golfview', 33.4147186279297, 0.583196858684855, -84.5830612182617, -1.47625290967459, 218, 13, 'PPL', 'P'),
(72695, 'Golfway Acres', 39.2075004577637, 0.68429997446516, -84.5661087036133, -1.47595703247749, 218, 41, 'PPL', 'P'),
(94518, 'Goliad', 28.6680603027344, 0.500352042442997, -97.3880615234375, -1.69974232571879, 218, 51, 'PPL', 'P'),
(81260, 'Golightly', 34.8572196960449, 0.608373251787001, -81.8855590820313, -1.42917261581779, 218, 48, 'PPL', 'P'),
(94520, 'Golinda', 31.3775005340576, 0.547640695365585, -97.0824966430664, -1.69440921247785, 218, 51, 'PPL', 'P'),
(162138, 'Golinza', 41.4397201538086, 0.723259557789011, -79.3288879394531, -1.38455028648908, 218, 45, 'PPL', 'P'),
(174294, 'Goll', 45.2802810668945, 0.79028999084576, -87.7508316040039, -1.53154093285297, 218, 57, 'PPL', 'P'),
(36133, 'Gollihue', 38.2458305358887, 0.667515668011045, -82.8858337402344, -1.4466307020277, 218, 21, 'PPL', 'P'),
(94521, 'Golly', 28.9433307647705, 0.505156418339014, -97.2613906860352, -1.69753150253986, 218, 51, 'PPL', 'P'),
(36134, 'Golo', 36.7388916015625, 0.641214621980558, -88.4952774047852, -1.54453396317924, 218, 21, 'PPL', 'P'),
(21475, 'Goloid', 32.6913909912109, 0.570572409853443, -81.6725006103516, -1.42545404398771, 218, 13, 'PPL', 'P'),
(188621, 'Golondrinas', 35.8894386291504, 0.626388870771114, -105.186111450195, -1.83584397217562, 218, 38, 'PPL', 'P'),
(211850, 'Golovin', 64.543327331543, 1.12649357212787, -163.029174804688, -2.84539587715118, 218, 1, 'PPL', 'P'),
(54994, 'Goltra', 37.829719543457, 0.660253161139371, -91.4366683959961, -1.59587092056437, 218, 29, 'PPL', 'P'),
(75940, 'Goltry', 36.5325012207031, 0.637612430290117, -98.1513900756836, -1.71306492222997, 218, 42, 'PPL', 'P'),
(47538, 'Golts', 39.336669921875, 0.686554406906939, -75.7750015258789, -1.32252326733031, 218, 25, 'PPL', 'P'),
(198346, 'Golva', 46.7341690063477, 0.815665122344253, -103.985832214355, -1.81489514756689, 218, 34, 'PPL', 'P'),
(155480, 'Gomer', 40.8450012207031, 0.712879754282373, -84.1872177124023, -1.46934413717471, 218, 41, 'PPL', 'P'),
(204113, 'Gomex', 40.0744400024414, 0.699430923935527, -111.578330993652, -1.94740924971927, 218, 52, 'PPL', 'P'),
(16241, 'Gomez', 27.0844402313232, 0.472712658096205, -80.1436080932617, -1.39876983565539, 218, 12, 'PPL', 'P'),
(191539, 'Gomez', 33.1816711425781, 0.579129412751977, -102.377502441406, -1.78682449757107, 218, 51, 'PPL', 'P'),
(193596, 'Gomez', 41.0361099243164, 0.716215230389642, -121.515281677246, -2.12084175675628, 218, 6, 'PPL', 'P'),
(109416, 'Gomez (historical)', 38.7422218322754, 0.676179330511236, -81.0755615234375, -1.41503549148721, 218, 58, 'PPL', 'P'),
(94523, 'Gomez Colonia', 26.2469997406006, 0.458096564243578, -98.1729965209961, -1.71344202584032, 218, 51, 'PPL', 'P'),
(131033, 'Gomins', 44.8058280944824, 0.782009224331295, -84.0513916015625, -1.46697352433038, 218, 27, 'PPL', 'P'),
(47539, 'Gomoljak', 38.9291687011719, 0.679442168899774, -76.3319396972656, -1.33224367215105, 218, 25, 'PPL', 'P'),
(124939, 'Gomorrah', 42.0513916015625, 0.733935238492757, -73.2869415283203, -1.27909842838575, 218, 23, 'PPL', 'P'),
(2768, 'Gonce', 34.9872207641602, 0.610642198456721, -85.9544372558594, -1.50018793681363, 218, 2, 'PPL', 'P'),
(41118, 'Gondron (historical)', 30.0855598449707, 0.525092076600534, -91.7263870239258, -1.60092746452611, 218, 22, 'PPL', 'P'),
(143878, 'Gonic', 43.2744407653809, 0.755281473315151, -70.9786071777344, -1.23881039373114, 218, 36, 'PPL', 'P'),
(115762, 'Gonoa Bluff', 41.6933288574219, 0.727685864678777, -92.1524963378906, -1.60836447502821, 218, 16, 'PPL', 'P'),
(41119, 'Gonsoulin (historical)', 30.0461101531982, 0.524403549590207, -91.7472229003906, -1.60129111917296, 218, 22, 'PPL', 'P'),
(135603, 'Gonvick', 47.7374992370605, 0.833176538354988, -95.5133285522461, -1.6670220627758, 218, 28, 'PPL', 'P'),
(102326, 'Gonyon', 37.9036102294922, 0.661542796897242, -76.3388900756836, -1.3323649791387, 218, 53, 'PPL', 'P'),
(41120, 'Gonzales', 30.2383308410645, 0.527758433483921, -90.9199981689453, -1.58685332395531, 218, 22, 'PPL', 'P'),
(94524, 'Gonzales', 29.5013904571533, 0.514896397393761, -97.4522171020508, -1.70086205179911, 218, 51, 'PPL', 'P'),
(181849, 'Gonzales', 36.5066719055176, 0.637161623696594, -121.443328857422, -2.11958594314426, 218, 6, 'PPL', 'P'),
(188622, 'Gonzales', 35.4283294677734, 0.618340997693977, -108.320281982422, -1.89054556728195, 218, 38, 'PPL', 'P'),
(94525, 'Gonzales 12 Colonia', 28.0189990997314, 0.489023787403641, -97.5029983520508, -1.70174835180989, 218, 51, 'PPL', 'P'),
(94527, 'Gonzales Colonia', 29.1979999542236, 0.509601234198356, -99.8040008544922, -1.74190842157412, 218, 51, 'PPL', 'P'),
(188623, 'Gonzales Ranch', 35.2458305358887, 0.615155790451215, -105.459999084473, -1.84062421317425, 218, 38, 'PPL', 'P'),
(16243, 'Gonzalez', 30.5813903808594, 0.533745951983719, -87.291389465332, -1.52352215481074, 218, 12, 'PPL', 'P'),
(191540, 'Gonzalez Colonia', 31.5990009307861, 0.551506606582971, -106.267997741699, -1.85472645009455, 218, 51, 'PPL', 'P'),
(94529, 'Gonzalez-Zamora Colonia', 26.242000579834, 0.458009312428364, -98.1569976806641, -1.71316279340003, 218, 51, 'PPL', 'P'),
(94530, 'Goober Hill', 31.6513900756836, 0.552420969653736, -93.9308319091797, -1.63940228595254, 218, 51, 'PPL', 'P'),
(9154, 'Goobertown', 35.9513893127441, 0.627470114173687, -90.5755615234375, -1.58084177042668, 218, 4, 'PPL', 'P'),
(143879, 'Gooch Corner', 42.9688911437988, 0.749948626390322, -70.9858322143555, -1.23893649440876, 218, 36, 'PPL', 'P'),
(124940, 'Gooch Corners', 42.2272186279297, 0.737003999016855, -71.4269409179688, -1.24663529364602, 218, 23, 'PPL', 'P'),
(81261, 'Gooch Crossroad', 34.6930618286133, 0.605508156507266, -80.8038864135742, -1.41029386632438, 218, 48, 'PPL', 'P'),
(102327, 'Goochland', 37.6841697692871, 0.657712838354572, -77.8855590820313, -1.35935944573802, 218, 53, 'PPL', 'P'),
(112335, 'Goochland', 37.4358291625977, 0.653378477101441, -84.1869430541992, -1.46933934348475, 218, 21, 'PPL', 'P'),
(36135, 'Goochtown', 37.3216705322266, 0.651386033131898, -84.5869369506836, -1.47632055396628, 218, 21, 'PPL', 'P'),
(21476, 'Goochville', 34.1597213745117, 0.596199609549112, -83.7750015258789, -1.46214960748986, 218, 13, 'PPL', 'P'),
(109417, 'Good', 39.3574981689453, 0.686917928395735, -78.3613891601563, -1.36766424728132, 218, 58, 'PPL', 'P'),
(65104, 'Good (historical)', 35.2552795410156, 0.615320706701718, -81.7074966430664, -1.42606483998372, 218, 33, 'PPL', 'P'),
(47540, 'Good Acres', 39.6819381713867, 0.692580474663516, -77.6986083984375, -1.35609654077045, 218, 25, 'PPL', 'P'),
(195008, 'Good Grief', 48.9494400024414, 0.854328895050024, -116.176391601563, -2.02766054653355, 218, 17, 'PPL', 'P'),
(131034, 'Good Hart', 45.5672187805176, 0.795297998696627, -85.1130599975586, -1.48550313340487, 218, 27, 'PPL', 'P'),
(47541, 'Good Hill', 39.560001373291, 0.690452276057407, -77.2911071777344, -1.34898430276329, 218, 25, 'PPL', 'P'),
(2771, 'Good Hope', 34.1158294677734, 0.595433551261551, -86.8636093139648, -1.5160559826947, 218, 2, 'PPL', 'P'),
(9155, 'Good Hope', 33.6438903808594, 0.587196660326045, -93.0597229003906, -1.62419856560538, 218, 4, 'PPL', 'P'),
(13117, 'Good Hope', 38.8624992370605, 0.678278567240491, -76.9641723632813, -1.34327821381168, 218, 9, 'PPL', 'P'),
(16244, 'Good Hope', 30.9688892364502, 0.540509082861489, -86.6313934326172, -1.51200305098976, 218, 12, 'PPL', 'P'),
(21477, 'Good Hope', 33.7847213745117, 0.589654624854134, -83.6091690063477, -1.45925528401716, 218, 13, 'PPL', 'P'),
(41121, 'Good Hope', 29.9911098480225, 0.523443613175288, -90.4005584716797, -1.57778739097246, 218, 22, 'PPL', 'P'),
(47542, 'Good Hope', 39.0963897705078, 0.682360727138392, -76.9872207641602, -1.34368048429434, 218, 25, 'PPL', 'P'),
(60068, 'Good Hope', 32.628059387207, 0.569467064843006, -89.6288909912109, -1.56431925270771, 218, 30, 'PPL', 'P'),
(72697, 'Good Hope', 38.6041717529297, 0.673769902094014, -82.3138885498047, -1.43664837531375, 218, 41, 'PPL', 'P'),
(81263, 'Good Hope', 34.0352783203125, 0.594027668522098, -81.8908309936523, -1.42926462803345, 218, 48, 'PPL', 'P'),
(87324, 'Good Hope', 35.2558288574219, 0.615330294081642, -88.4886093139648, -1.54441758303961, 218, 50, 'PPL', 'P'),
(94531, 'Good Hope', 29.451940536499, 0.514033333463493, -96.8994369506836, -1.69121421811808, 218, 51, 'PPL', 'P'),
(119808, 'Good Hope', 40.5577812194824, 0.707866819583489, -90.6733322143555, -1.58254819089514, 218, 18, 'PPL', 'P'),
(162139, 'Good Hope', 40.2691688537598, 0.702829583539659, -76.9852828979492, -1.3436466621485, 218, 45, 'PPL', 'P'),
(181852, 'Good Hope', 33.764720916748, 0.589305551014252, -117.26611328125, -2.04667977777446, 218, 6, 'PPL', 'P'),
(207521, 'Good Hope', 45.7655601501465, 0.798759708639567, -122.619171142578, -2.14010826250441, 218, 56, 'PPL', 'P'),
(21478, 'Good Hope (historical)', 30.7777805328369, 0.537173606754219, -84.2522201538086, -1.47047864379908, 218, 13, 'PPL', 'P'),
(199978, 'Good Hope (historical)', 41.4672203063965, 0.723739525996471, -116.50666809082, -2.03342495871303, 218, 39, 'PPL', 'P'),
(81264, 'Good Hope Landing', 32.1877784729004, 0.561782713254664, -80.9908294677734, -1.41355663813389, 218, 48, 'PPL', 'P'),
(162140, 'Good Hope Mill', 40.2663917541504, 0.702781114007819, -76.9797210693359, -1.34354958992676, 218, 45, 'PPL', 'P'),
(32569, 'Good Intent', 39.5999984741211, 0.691150357158144, -95.216667175293, -1.66184434498447, 218, 20, 'PPL', 'P'),
(70882, 'Good Intent', 39.8041687011719, 0.694713799854724, -75.0780563354492, -1.31035927905138, 218, 37, 'PPL', 'P'),
(162141, 'Good Intent', 40.0369415283203, 0.69877645209764, -80.445556640625, -1.4040398319785, 218, 45, 'PPL', 'P'),
(87325, 'Good Luck', 36.1202812194824, 0.630417834026241, -88.9069366455078, -1.55171877232611, 218, 50, 'PPL', 'P'),
(102329, 'Good Luck', 37.7436103820801, 0.658750272757212, -76.3627777099609, -1.33278189700735, 218, 53, 'PPL', 'P'),
(47543, 'Good Luck (historical)', 38.9933280944824, 0.680561961559125, -76.8327789306641, -1.34098496579702, 218, 25, 'PPL', 'P'),
(181850, 'Good Meadow', 33.7661094665527, 0.589329785780171, -117.283332824707, -2.04698031550348, 218, 6, 'PPL', 'P'),
(94532, 'Good Neighbor', 33.1942901611328, 0.579349656174127, -95.6502380371094, -1.66941158406388, 218, 51, 'PPL', 'P'),
(41122, 'Good Pine', 31.6930599212646, 0.553148245657923, -92.1619415283203, -1.60852932469968, 218, 22, 'PPL', 'P'),
(41123, 'Good Roads', 32.5472183227539, 0.568056122097482, -93.7727813720703, -1.63664378369543, 218, 22, 'PPL', 'P'),
(141924, 'Good Samaritan Village', 40.5788917541504, 0.708235267920302, -98.3675003051758, -1.71683675728184, 218, 35, 'PPL', 'P'),
(162142, 'Good Spring', 40.6247215270996, 0.709035148353707, -76.4852828979492, -1.33492001588852, 218, 45, 'PPL', 'P'),
(2773, 'Good Springs', 34.9472198486328, 0.609944050776957, -87.1941680908203, -1.52182532172219, 218, 2, 'PPL', 'P'),
(94533, 'Good Springs', 32.0561103820801, 0.559484671550035, -94.9105606079102, -1.65650177752166, 218, 51, 'PPL', 'P'),
(2774, 'Good Springs (historical)', 34.6341705322266, 0.60448030948455, -88.1141662597656, -1.53788231888261, 218, 2, 'PPL', 'P'),
(135607, 'Good Thunder', 44.0047187805176, 0.768027229134216, -94.065559387207, -1.64175372403702, 218, 28, 'PPL', 'P'),
(94534, 'Good Valley Ranch Colonia Number 1', 26.2749996185303, 0.458585254303607, -98.3489990234375, -1.71651384899967, 218, 51, 'PPL', 'P'),
(54996, 'Good Water', 37.7133293151855, 0.658221768438886, -91.0461120605469, -1.58905442659626, 218, 29, 'PPL', 'P'),
(47544, 'Goodacre Knolls', 38.9983291625977, 0.680649246663852, -77.0072174072266, -1.34402949155519, 218, 25, 'PPL', 'P'),
(181851, 'Goodale', 36.378059387207, 0.634916911792793, -119.043327331543, -2.07769801446478, 218, 6, 'PPL', 'P'),
(186779, 'Goodale', 38.1180610656738, 0.665285670072267, -102.434722900391, -1.78782318297985, 218, 7, 'PPL', 'P'),
(127576, 'Goodale Corner', 44.7002792358398, 0.78016704922626, -68.7513885498047, -1.19993809551202, 218, 26, 'PPL', 'P'),
(102330, 'Goodall', 37.7825012207031, 0.659429045940046, -77.6372222900391, -1.35502515106391, 218, 53, 'PPL', 'P'),
(21480, 'Goodall Estates', 32.7055587768555, 0.570819684360657, -83.7083282470703, -1.46098593925155, 218, 13, 'PPL', 'P'),
(131035, 'Goodar', 44.5011100769043, 0.776690891634407, -83.8963928222656, -1.46426828529507, 218, 27, 'PPL', 'P'),
(87326, 'Goodbars', 35.7408294677734, 0.623795151606459, -85.6013870239258, -1.49402604784145, 218, 50, 'PPL', 'P'),
(41124, 'Goodbee', 30.4955596923828, 0.532247923870549, -90.1975021362305, -1.57424338935184, 218, 22, 'PPL', 'P'),
(16245, 'Goodbys', 30.2024993896484, 0.527133056680943, -81.616943359375, -1.42448438703482, 218, 12, 'PPL', 'P'),
(60069, 'Goode', 34.5761108398438, 0.603466976689775, -90.1708297729492, -1.57377786879329, 218, 30, 'PPL', 'P'),
(102331, 'Goode', 37.3586082458496, 0.652030717852779, -79.3919372558594, -1.3856507046515, 218, 53, 'PPL', 'P'),
(102332, 'Goode Crossing', 37.4211082458496, 0.653121548635275, -77.8583297729492, -1.35888420464149, 218, 53, 'PPL', 'P'),
(119809, 'Goode Subdivision', 41.3758316040039, 0.722144492240595, -88.3883285522461, -1.54266735357121, 218, 18, 'PPL', 'P'),
(115763, 'Goodell', 42.9230613708496, 0.749148745956917, -93.6161117553711, -1.63390938304619, 218, 16, 'PPL', 'P'),
(127578, 'Goodell Corner', 45.2827796936035, 0.79033360010861, -69.4263916015625, -1.2117191212262, 218, 26, 'PPL', 'P'),
(194211, 'Goodell Corner', 40.735279083252, 0.710964741721524, -105.580558776855, -1.84272837675153, 218, 7, 'PPL', 'P'),
(131037, 'Goodells', 42.9811096191406, 0.75016187901461, -82.6658325195313, -1.44279095636802, 218, 27, 'PPL', 'P'),
(60070, 'Gooden Lake', 33.1380615234375, 0.578368281312432, -90.6069412231445, -1.58138944950485, 218, 30, 'PPL', 'P'),
(119810, 'Goodenow', 41.3913917541504, 0.722416068092756, -87.6366729736328, -1.52954848888342, 218, 18, 'PPL', 'P'),
(21479, 'Goodes', 33.5325012207031, 0.585252552730287, -84.7283325195313, -1.4787883721904, 218, 13, 'PPL', 'P'),
(54997, 'Goodfellow Terrace', 38.6972198486328, 0.675393897726744, -90.2705612182617, -1.57551851088177, 218, 29, 'PPL', 'P'),
(87327, 'Goodfield', 35.4663887023926, 0.61900525664887, -84.8258285522461, -1.48048999896891, 218, 50, 'PPL', 'P'),
(119812, 'Goodfield', 40.6297187805176, 0.709122366879407, -89.2747192382813, -1.55813778950153, 218, 18, 'PPL', 'P'),
(60071, 'Goodford', 34.1086082458496, 0.595307517162963, -88.942497253418, -1.55233942201816, 218, 30, 'PPL', 'P'),
(54998, 'Goodhope', 36.9088897705078, 0.644181649751016, -92.807502746582, -1.61979649348154, 218, 29, 'PPL', 'P'),
(60075, 'Goodhope', 32.457218170166, 0.566485323107526, -89.0166702270508, -1.55363398462404, 218, 30, 'PPL', 'P'),
(109418, 'Goodhope', 39.1813888549805, 0.68384424102362, -80.4394378662109, -1.40393303921878, 218, 58, 'PPL', 'P'),
(81266, 'Goodhope Landing', 32.9655609130859, 0.575357577700098, -80.4186096191406, -1.40356951772999, 218, 48, 'PPL', 'P'),
(135609, 'Goodhue', 44.4005584716797, 0.774935935055072, -92.6236114501953, -1.61658698489383, 218, 28, 'PPL', 'P'),
(194210, 'Gooding', 40.0736083984375, 0.699416409707586, -105.082496643066, -1.8340355526374, 218, 7, 'PPL', 'P'),
(195009, 'Gooding', 42.9388885498047, 0.749424982340985, -114.712219238281, -2.00210591797759, 218, 17, 'PPL', 'P'),
(119813, 'Goodings Grove', 41.6291694641113, 0.726566072019426, -87.9308319091797, -1.53468253083288, 218, 18, 'PPL', 'P'),
(131040, 'Goodison', 42.732780456543, 0.74582771749856, -83.1624984741211, -1.45145941255817, 218, 27, 'PPL', 'P'),
(75943, 'Goodlake', 33.7069396972656, 0.588297078488466, -94.642219543457, -1.65181834242865, 218, 42, 'PPL', 'P'),
(16246, 'Goodland', 25.9244403839111, 0.452466841436232, -81.6458282470703, -1.42498852342917, 218, 12, 'PPL', 'P'),
(55004, 'Goodland', 37.6361083984375, 0.656874009190224, -91.0016708374023, -1.58827878092878, 218, 29, 'PPL', 'P'),
(75944, 'Goodland', 33.9816703796387, 0.593092033452126, -95.5550003051758, -1.6677493720695, 218, 42, 'PPL', 'P'),
(122699, 'Goodland', 40.7633285522461, 0.711454297308908, -87.2936096191406, -1.5235609038046, 218, 19, 'PPL', 'P'),
(131038, 'Goodland', 43.0947189331055, 0.752144735604228, -83.0725021362305, -1.44988868014724, 218, 27, 'PPL', 'P'),
(135613, 'Goodland', 47.1619415283203, 0.823131161302236, -93.1355590820313, -1.62552215666715, 218, 28, 'PPL', 'P'),
(187685, 'Goodland', 39.350830078125, 0.686801548256099, -101.709716796875, -1.77516943937645, 218, 20, 'PPL', 'P'),
(191542, 'Goodland', 33.8723411560059, 0.591183878531084, -102.975318908691, -1.79725836324784, 218, 51, 'PPL', 'P'),
(55001, 'Goodland (historical)', 37.6336097717285, 0.656830399927374, -90.9977798461914, -1.58821087032098, 218, 29, 'PPL', 'P'),
(155481, 'Goodland Acres', 40.6744384765625, 0.709902872815882, -81.2611083984375, -1.41827389537275, 218, 41, 'PPL', 'P'),
(94536, 'Goodlett', 34.3349990844727, 0.599258782693286, -99.8797225952148, -1.74323001526507, 218, 51, 'PPL', 'P'),
(87328, 'Goodlettsville', 36.3230590820313, 0.633956975377874, -86.7133331298828, -1.51343316849513, 218, 50, 'PPL', 'P'),
(36136, 'Goodloe', 37.6036109924316, 0.656306822457065, -82.8627777099609, -1.44622829838699, 218, 21, 'PPL', 'P'),
(102333, 'Goodloe (historical)', 36.8611106872559, 0.643347747434685, -82.8602828979492, -1.44618475570316, 218, 53, 'PPL', 'P'),
(94537, 'Goodlow Park', 32.1152801513672, 0.56051737884174, -96.2180633544922, -1.67932200542839, 218, 51, 'PPL', 'P'),
(36139, 'Goodluck', 36.9252815246582, 0.644467739831117, -85.6416702270508, -1.49472912236924, 218, 21, 'PPL', 'P'),
(60072, 'Goodluck', 31.3266696929932, 0.546753529827452, -89.1563873291016, -1.55607250807618, 218, 30, 'PPL', 'P'),
(65106, 'Goodluck', 35.4402809143066, 0.618549589786357, -82.4400024414063, -1.4388494779547, 218, 33, 'PPL', 'P'),
(2775, 'Goodman', 31.2794399261475, 0.545929214891045, -85.9936065673828, -1.50087157026545, 218, 2, 'PPL', 'P'),
(9156, 'Goodman', 34.5602798461914, 0.603190673726679, -92.4700012207031, -1.61390598062445, 218, 4, 'PPL', 'P'),
(55002, 'Goodman', 36.7416687011719, 0.641263091512398, -94.3988876342773, -1.6475713994383, 218, 29, 'PPL', 'P'),
(60073, 'Goodman', 32.9700012207031, 0.575435075687819, -89.9122161865234, -1.56926421021977, 218, 30, 'PPL', 'P'),
(87329, 'Goodman', 35.0122184753418, 0.611078490822303, -90.0963897705078, -1.5724786456555, 218, 50, 'PPL', 'P'),
(109419, 'Goodman', 37.6897201538086, 0.657809710839224, -82.2980575561523, -1.43637207235066, 218, 58, 'PPL', 'P'),
(174295, 'Goodman', 45.6313896179199, 0.79641799109306, -88.3533325195313, -1.5420565575752, 218, 57, 'PPL', 'P'),
(181853, 'Goodmans Corner', 38.2050018310547, 0.666803072682367, -120.986106872559, -2.11160591409589, 218, 6, 'PPL', 'P'),
(145310, 'Goodmans Crossing', 40.6152801513672, 0.708870365261258, -74.3399963378906, -1.29747770201672, 218, 37, 'PPL', 'P'),
(181854, 'Goodmill', 36.7808303833008, 0.641946591806167, -119.022499084473, -2.07733449297598, 218, 6, 'PPL', 'P'),
(211851, 'Goodnews Bay', 59.1188888549805, 1.03181926063999, -161.587493896484, -2.82023379853989, 218, 1, 'PPL', 'P'),
(211852, 'Goodnews Mining Camp', 58.9261093139648, 1.02845462291878, -161.729995727539, -2.82272092468192, 218, 1, 'PPL', 'P'),
(36137, 'Goodnight', 37.0933303833008, 0.647400745718649, -85.8802795410156, -1.49889364052385, 218, 21, 'PPL', 'P'),
(55003, 'Goodnight', 37.4458312988281, 0.653553047310895, -93.2263870239258, -1.62710740330602, 218, 29, 'PPL', 'P'),
(75946, 'Goodnight', 35.9513893127441, 0.627470114173687, -97.1402816772461, -1.69541775158266, 218, 42, 'PPL', 'P'),
(186780, 'Goodnight', 38.2611083984375, 0.667782317015189, -104.669441223145, -1.82682637556655, 218, 7, 'PPL', 'P'),
(191543, 'Goodnight', 35.0344390869141, 0.611466313656046, -101.185829162598, -1.76602587524783, 218, 51, 'PPL', 'P'),
(16247, 'Goodno', 26.7683296203613, 0.467195487134429, -81.3119430541992, -1.41916112748991, 218, 12, 'PPL', 'P'),
(207523, 'Goodnoe', 45.7161102294922, 0.797896644709299, -120.51277923584, -2.10334478839446, 218, 56, 'PPL', 'P'),
(207524, 'Goodnoe Hills', 45.7513885498047, 0.798512367553325, -120.47917175293, -2.10275822716437, 218, 56, 'PPL', 'P'),
(174297, 'Goodnow', 45.6972198486328, 0.797566945366347, -89.6716690063477, -1.56506586991932, 218, 57, 'PPL', 'P'),
(47545, 'Goodnow Hill', 39.3261108398438, 0.686370116159506, -76.5461120605469, -1.33598168505708, 218, 25, 'PPL', 'P'),
(186781, 'Goodpasture', 38.0833282470703, 0.664679468029137, -104.919441223145, -1.83118969869654, 218, 7, 'PPL', 'P'),
(9157, 'Goodrich', 35.3316688537598, 0.616653951722439, -91.2302780151367, -1.59226872887393, 218, 4, 'PPL', 'P'),
(32570, 'Goodrich', 38.2847213745117, 0.668194441193879, -94.9916687011719, -1.65791738079909, 218, 20, 'PPL', 'P'),
(87330, 'Goodrich', 35.8447189331055, 0.62560836483464, -87.4786071777344, -1.52678972031021, 218, 50, 'PPL', 'P'),
(94539, 'Goodrich', 30.6052799224854, 0.534162903141884, -94.9463882446289, -1.65712708774561, 218, 51, 'PPL', 'P'),
(119814, 'Goodrich', 41.1088905334473, 0.717485491650583, -88.0580596923828, -1.53690307454979, 218, 18, 'PPL', 'P'),
(127577, 'Goodrich', 46.8452796936035, 0.817604369671022, -67.8475036621094, -1.18416232816272, 218, 26, 'PPL', 'P'),
(131042, 'Goodrich', 42.9169387817383, 0.749041886618177, -83.5063934326172, -1.45746151186494, 218, 27, 'PPL', 'P'),
(149193, 'Goodrich', 42.1016693115234, 0.734812750071938, -76.2880630493164, -1.3314778801796, 218, 40, 'PPL', 'P'),
(174298, 'Goodrich', 45.1494407653809, 0.788006396790045, -90.085563659668, -1.57228969437616, 218, 57, 'PPL', 'P'),
(194212, 'Goodrich', 40.3511085510254, 0.704259701045031, -104.061111450195, -1.81620901809068, 218, 7, 'PPL', 'P'),
(195011, 'Goodrich', 44.6536102294922, 0.779352521406859, -116.556938171387, -2.03430233713416, 218, 17, 'PPL', 'P'),
(198352, 'Goodrich', 47.4749984741211, 0.828595035752697, -100.125831604004, -1.74752542778726, 218, 34, 'PPL', 'P'),
(127579, 'Goodrich Corner', 44.7211112976074, 0.780530637294083, -70.057502746582, -1.22273408865283, 218, 26, 'PPL', 'P'),
(172049, 'Goodrich Corner', 44.0963897705078, 0.769627189738108, -73.3794403076172, -1.28071283663856, 218, 55, 'PPL', 'P'),
(149192, 'Goodrich Corners', 43.148609161377, 0.753085297522217, -75.5283279418945, -1.31821800111209, 218, 40, 'PPL', 'P'),
(155482, 'Goodrich Cottage Area', 40.1583290100098, 0.700895063323825, -81.1930618286133, -1.41708625868463, 218, 41, 'PPL', 'P'),
(143880, 'Goodrich Falls', 44.128059387207, 0.770179928822354, -71.1900024414063, -1.24249993710534, 218, 36, 'PPL', 'P'),
(102334, 'Goodrich Fork', 37.0002784729004, 0.645776683506891, -76.9177780151367, -1.34246847968224, 218, 53, 'PPL', 'P'),
(172050, 'Goodrich Four Corners', 43.7550010681152, 0.763668832852247, -72.2797164916992, -1.2615190351882, 218, 55, 'PPL', 'P'),
(113481, 'Goodrich Heights', 41.6263885498047, 0.726517535908559, -72.6527786254883, -1.26803019773733, 218, 8, 'PPL', 'P'),
(113482, 'Goodrichville', 41.9777793884277, 0.732650463003876, -72.8141708374023, -1.27084702322231, 218, 8, 'PPL', 'P'),
(124941, 'Goodrichville', 42.5977783203125, 0.743471485724113, -71.7027816772461, -1.25144962310661, 218, 23, 'PPL', 'P'),
(135615, 'Goodridge', 48.1433296203613, 0.840259614748217, -95.8091735839844, -1.6721855326553, 218, 28, 'PPL', 'P'),
(162143, 'Goods Corner', 40.371940612793, 0.704623289112854, -78.8794403076172, -1.37670594549825, 218, 45, 'PPL', 'P'),
(102336, 'Goods Mill', 38.3416709899902, 0.669188399491723, -78.8119430541992, -1.37552789619005, 218, 53, 'PPL', 'P'),
(2776, 'Goodson', 32.9174995422363, 0.57451874853575, -87.1888885498047, -1.52173317634848, 218, 2, 'PPL', 'P'),
(55005, 'Goodson', 37.7019386291504, 0.658022963463512, -93.2513885498047, -1.62754376225063, 218, 29, 'PPL', 'P'),
(65107, 'Goodsonville', 35.480281829834, 0.619247737466122, -81.2063903808594, -1.41731888580585, 218, 33, 'PPL', 'P'),
(113483, 'Goodspeeds Landing', 41.4502792358398, 0.723443848536444, -72.4583282470703, -1.26463639840219, 218, 8, 'PPL', 'P'),
(87332, 'Goodspring', 35.1433296203613, 0.613366811988954, -87.1013870239258, -1.52020598662137, 218, 50, 'PPL', 'P'),
(2777, 'Goodsprings', 33.6688919067383, 0.587633019270655, -87.2316665649414, -1.52247979356008, 218, 2, 'PPL', 'P'),
(87331, 'Goodsprings', 35.3327789306641, 0.616673326219369, -84.5599975585938, -1.47585037287583, 218, 50, 'PPL', 'P'),
(190268, 'Goodsprings', 35.8325004577637, 0.625395112210351, -115.433326721191, -2.01469161781514, 218, 39, 'PPL', 'P'),
(78365, 'Goodtown', 39.8933296203613, 0.696269951458685, -78.9786071777344, -1.37843673389069, 218, 45, 'PPL', 'P'),
(102337, 'Goodview', 37.214168548584, 0.64950976956491, -79.7252807617188, -1.39146864636889, 218, 53, 'PPL', 'P'),
(135618, 'Goodview', 44.0625, 0.769035701660001, -91.695556640625, -1.60038937282786, 218, 28, 'PPL', 'P'),
(55006, 'Goodville', 37.0313911437988, 0.646319702053158, -92.2949981689453, -1.61085160117023, 218, 29, 'PPL', 'P'),
(162145, 'Goodville', 40.125560760498, 0.700323149479731, -76.0036087036133, -1.32651321527547, 218, 45, 'PPL', 'P'),
(2778, 'Goodwater', 33.065559387207, 0.577102880320481, -86.0533294677734, -1.50191393151611, 218, 2, 'PPL', 'P'),
(36138, 'Goodwater', 37.0752792358398, 0.647085693761693, -84.3733291625977, -1.47259239475628, 218, 21, 'PPL', 'P'),
(60074, 'Goodwater', 31.916109085083, 0.557041187960374, -88.8600006103516, -1.55089958397481, 218, 30, 'PPL', 'P'),
(75945, 'Goodwater', 33.9099998474121, 0.591841146688116, -94.5730590820313, -1.65061126466457, 218, 42, 'PPL', 'P'),
(178264, 'Goodwater', 34.9919395446777, 0.610724556713432, -109.94416809082, -1.9188877265509, 218, 5, 'PPL', 'P'),
(2779, 'Goodway', 31.336669921875, 0.546928066747393, -87.4258270263672, -1.52586853288915, 218, 2, 'PPL', 'P'),
(190978, 'Goodwell', 36.5952796936035, 0.638708121341603, -101.636108398438, -1.7738847304666, 218, 42, 'PPL', 'P'),
(41130, 'Goodwill', 32.5886116027832, 0.568778571122193, -93.432502746582, -1.6307048013065, 218, 22, 'PPL', 'P'),
(47546, 'Goodwill', 38.0705604553223, 0.664456628024925, -75.491943359375, -1.31758297035016, 218, 25, 'PPL', 'P'),
(94543, 'Goodwill', 30.6413898468018, 0.534793140213852, -96.6269378662109, -1.68645821188536, 218, 51, 'PPL', 'P'),
(109420, 'Goodwill', 37.3541717529297, 0.651953286444085, -81.2897186279297, -1.41877323807714, 218, 58, 'PPL', 'P'),
(170395, 'Goodwill', 45.5669403076172, 0.795293138427638, -97.0697174072266, -1.69418617273656, 218, 49, 'PPL', 'P'),
(9160, 'Goodwin', 34.938060760498, 0.609784194532525, -91.0208282470703, -1.58861314080364, 218, 4, 'PPL', 'P'),
(72699, 'Goodwin', 39.6797218322754, 0.692541792248683, -80.9116668701172, -1.41217499016036, 218, 41, 'PPL', 'P'),
(75971, 'Goodwin', 36.1966705322266, 0.631751079046962, -99.9347229003906, -1.74418995167999, 218, 42, 'PPL', 'P'),
(94541, 'Goodwin', 31.4258308410645, 0.548484218351354, -94.2702789306641, -1.64532675411353, 218, 51, 'PPL', 'P'),
(109421, 'Goodwin', 38.9277801513672, 0.679417934133854, -80.1605606079102, -1.3990657128525, 218, 58, 'PPL', 'P'),
(127580, 'Goodwin', 46.8136100769043, 0.817051630586776, -67.8894424438477, -1.18489429798833, 218, 26, 'PPL', 'P'),
(141925, 'Goodwin', 42.4552803039551, 0.740984426161115, -96.6549987792969, -1.68694796720983, 218, 35, 'PPL', 'P'),
(170397, 'Goodwin', 44.8791694641113, 0.783289272709242, -96.8483276367188, -1.69032219231096, 218, 49, 'PPL', 'P'),
(178265, 'Goodwin', 34.3558311462402, 0.59962237076111, -112.379173278809, -1.96138658438444, 218, 5, 'PPL', 'P'),
(155483, 'Goodwin (historical)', 41.0919418334961, 0.717189681032502, -84.4577789306641, -1.47406632126158, 218, 41, 'PPL', 'P'),
(127582, 'Goodwin Corner', 44.8188896179199, 0.782237190920606, -69.3083267211914, -1.20965850033276, 218, 26, 'PPL', 'P'),
(21481, 'Goodwin Crossing (historical)', 33.8574981689453, 0.590924819536047, -84.3405609130859, -1.47202048091218, 218, 13, 'PPL', 'P'),
(94542, 'Goodwin Heights Number 1 Colonia', 26.2590007781982, 0.458306021863313, -98.3860015869141, -1.71715966556402, 218, 51, 'PPL', 'P'),
(65108, 'Goodwin Hills', 35.0022201538086, 0.610903987191876, -76.3122177124023, -1.33189945858016, 218, 33, 'PPL', 'P'),
(102338, 'Goodwin Neck Estates', 37.2083282470703, 0.649407837074187, -76.4233322143555, -1.33383877248595, 218, 53, 'PPL', 'P'),
(127583, 'Goodwin Siding', 44.5433311462402, 0.777427788308032, -68.0669403076172, -1.18799222012636, 218, 26, 'PPL', 'P'),
(21482, 'Goodwindy Estates', 33.7138900756836, 0.588418385476119, -84.7630615234375, -1.47939450765451, 218, 13, 'PPL', 'P'),
(119815, 'Goodwine', 40.5672187805176, 0.708031536096911, -87.7844390869141, -1.53212749408306, 218, 18, 'PPL', 'P'),
(47548, 'Goodwins', 38.4949989318848, 0.671864476913089, -76.600830078125, -1.33693669462399, 218, 25, 'PPL', 'P'),
(29908, 'Goodwins Corner', 39.649169921875, 0.692008560819422, -84.833610534668, -1.4806258201845, 218, 19, 'PPL', 'P'),
(81267, 'Goodwins Crossroads', 34.5374984741211, 0.602793063775931, -81.9191665649414, -1.42975917704788, 218, 48, 'PPL', 'P'),
(102339, 'Goodwins Ferry (historical)', 37.2211112976074, 0.649630943394509, -80.6111068725586, -1.40692922860318, 218, 53, 'PPL', 'P'),
(2781, 'Goodwins Mill', 33.8202781677246, 0.59027520796715, -86.3852767944336, -1.50770750530952, 218, 2, 'PPL', 'P'),
(127584, 'Goodwins Mills', 43.5086097717285, 0.759368493482041, -70.5822219848633, -1.23189216700939, 218, 26, 'PPL', 'P'),
(41127, 'Goodwood', 30.7305603027344, 0.53634945826538, -91.7638931274414, -1.60158206952205, 218, 22, 'PPL', 'P'),
(2782, 'Goodwyn', 32.4377784729004, 0.56614603638465, -85.9338912963867, -1.49982934217285, 218, 2, 'PPL', 'P'),
(36140, 'Goody', 37.6619415283203, 0.657324882362775, -82.2697219848633, -1.43587752333623, 218, 21, 'PPL', 'P'),
(2783, 'Goodyear', 34.0083312988281, 0.59355735427359, -85.9888916015625, -1.50078927858777, 218, 2, 'PPL', 'P'),
(162146, 'Goodyear', 40.0463905334473, 0.698941368348143, -77.2050018310547, -1.34748148096016, 218, 45, 'PPL', 'P'),
(178266, 'Goodyear', 33.4352798461914, 0.583555719641743, -112.357498168945, -1.9610082823516, 218, 5, 'PPL', 'P'),
(149194, 'Goodyear Corners', 42.6363906860352, 0.744145398637957, -76.6152801513672, -1.33718889597922, 218, 40, 'PPL', 'P'),
(155484, 'Goodyear Heights', 41.0780601501465, 0.716947399952332, -81.4677810668945, -1.42188101391121, 218, 41, 'PPL', 'P'),
(177661, 'Goodyears Bar', 39.5400009155273, 0.690103202217524, -120.883331298828, -2.10981214194366, 218, 6, 'PPL', 'P'),
(119816, 'Goofy Ridge', 40.3944396972656, 0.705015972215587, -89.9375, -1.5697054960124, 218, 18, 'PPL', 'P'),
(21483, 'Goolsby', 33.235279083252, 0.580065047821949, -83.623893737793, -1.45951227906235, 218, 13, 'PPL', 'P'),
(149195, 'Goose Bay', 44.3666687011719, 0.774344446976965, -75.8466720581055, -1.32377415409432, 218, 40, 'PPL', 'P'),
(172051, 'Goose City', 42.961109161377, 0.749812805174728, -72.7919387817383, -1.27045900065148, 218, 55, 'PPL', 'P'),
(143881, 'Goose Corner', 43.6005592346191, 0.760973314354923, -71.2444381713867, -1.24345001982423, 218, 36, 'PPL', 'P'),
(36141, 'Goose Creek', 38.3161087036133, 0.668742253430108, -85.6486129760742, -1.49485029619883, 218, 21, 'PPL', 'P'),
(65109, 'Goose Creek', 36.2280616760254, 0.632298957862218, -76.0283279418945, -1.32694464737206, 218, 33, 'PPL', 'P'),
(81268, 'Goose Creek', 32.9808311462402, 0.575624093546188, -80.0327835083008, -1.39683558175567, 218, 48, 'PPL', 'P'),
(209476, 'Goose Egg', 42.7625007629395, 0.746346434699881, -106.486106872559, -1.85853317255671, 218, 59, 'PPL', 'P'),
(127585, 'Goose Falls', 44.353328704834, 0.774111620118665, -68.8099975585938, -1.20096101568672, 218, 26, 'PPL', 'P'),
(47549, 'Goose Hill', 39.2586097717285, 0.685192000272282, -76.0563888549805, -1.32743440269653, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(9162, 'Goose Hollow', 33.4216690063477, 0.583318165672508, -91.8497161865234, -1.60307996447716, 218, 4, 'PPL', 'P'),
(47550, 'Goose Hollow', 39.2388916015625, 0.684847853280417, -76.1944427490234, -1.32984389769278, 218, 25, 'PPL', 'P'),
(65111, 'Goose Hollow', 34.3436088562012, 0.599409051557794, -78.4061126708984, -1.36844481979682, 218, 33, 'PPL', 'P'),
(143882, 'Goose Hollow', 43.8811111450195, 0.76586986891417, -71.5983276367188, -1.24962655618239, 218, 36, 'PPL', 'P'),
(87333, 'Goose Horn', 36.4425010681152, 0.636041631300161, -85.8261108398438, -1.49794821833687, 218, 50, 'PPL', 'P'),
(21486, 'Goose Island', 34.7852783203125, 0.607117637912056, -84.4024963378906, -1.47310145799865, 218, 13, 'PPL', 'P'),
(149196, 'Goose Island', 43.2541694641113, 0.754927672364334, -73.4241714477539, -1.28149354231212, 218, 40, 'PPL', 'P'),
(115765, 'Goose Lake', 41.9674987792969, 0.732471032525432, -90.3827819824219, -1.57747713270547, 218, 16, 'PPL', 'P'),
(21484, 'Goose Neck', 32.2483291625977, 0.562839522154235, -83.4522171020508, -1.45651595651991, 218, 13, 'PPL', 'P'),
(109422, 'Goose Nest', 39.4458312988281, 0.688459632350782, -78.0766677856445, -1.36269492184529, 218, 58, 'PPL', 'P'),
(102340, 'Goose Pimple Junction', 36.5966682434082, 0.638732356107523, -82.1036071777344, -1.43297827301551, 218, 53, 'PPL', 'P'),
(13829, 'Goose Point', 39.5424995422363, 0.690146811480374, -75.774169921875, -1.32250875310237, 218, 10, 'PPL', 'P'),
(47551, 'Goose Point Estates', 38.9208297729492, 0.679296627146201, -76.3208312988281, -1.33204979402369, 218, 25, 'PPL', 'P'),
(65113, 'Goose Pond', 36.1777801513672, 0.63142137970401, -76.7752838134766, -1.33998148669827, 218, 33, 'PPL', 'P'),
(21485, 'Goose Pond (historical)', 33.9833297729492, 0.593120995328981, -82.8666687011719, -1.44629620899478, 218, 13, 'PPL', 'P'),
(60076, 'Goose Pond (historical)', 33.8805618286133, 0.591327356334812, -88.7202835083008, -1.54846106052267, 218, 30, 'PPL', 'P'),
(207525, 'Goose Prairie', 46.8952789306641, 0.818477020981214, -121.265830993652, -2.11648802100622, 218, 56, 'PPL', 'P'),
(36142, 'Goose Rock', 37.0902786254883, 0.647347482496847, -83.6944427490234, -1.46074359159235, 218, 21, 'PPL', 'P'),
(127586, 'Goose Rocks', 44.1352806091309, 0.770305962920942, -68.8322219848633, -1.20134890509949, 218, 26, 'PPL', 'P'),
(127587, 'Goose Rocks Beach', 43.4022216796875, 0.757511670991011, -70.4097213745117, -1.22888146339706, 218, 26, 'PPL', 'P'),
(72700, 'Goose Run (historical)', 39.4938888549805, 0.689298394936102, -82.1516723632813, -1.43381716875889, 218, 41, 'PPL', 'P'),
(200903, 'Gooseberry', 45.2924995422363, 0.790503243470048, -119.890830993652, -2.0924897437913, 218, 43, 'PPL', 'P'),
(21487, 'Gooseberry (historical)', 32.0013885498047, 0.558529595404105, -84.5058288574219, -1.47490495068885, 218, 13, 'PPL', 'P'),
(65114, 'Gooseneck', 34.3430595397949, 0.59939946417787, -78.1777801513672, -1.36445966554163, 218, 33, 'PPL', 'P'),
(87335, 'Gooseneck', 35.7527809143066, 0.624003743698839, -84.1072235107422, -1.46794797497324, 218, 50, 'PPL', 'P'),
(207526, 'Gooseneck', 45.7166709899902, 0.797906431826305, -121.029167175293, -2.11235745815551, 218, 56, 'PPL', 'P'),
(102341, 'Goosepoint', 37.6463890075684, 0.657053439668668, -77.7019424438477, -1.35615473084027, 218, 53, 'PPL', 'P'),
(29909, 'Gooseport', 38.7099990844727, 0.675616937468038, -85.9408264160156, -1.49995038284439, 218, 19, 'PPL', 'P'),
(78366, 'Goosetown', 39.9705581665039, 0.697617843865401, -75.7797164916992, -1.322605559008, 218, 45, 'PPL', 'P'),
(87337, 'Goosetown', 35.3166694641113, 0.616392162987284, -84.5569381713867, -1.47579697649597, 218, 50, 'PPL', 'P'),
(72701, 'Goosetown (historical)', 39.3711090087891, 0.68715548236497, -82.6055603027344, -1.44173900773744, 218, 41, 'PPL', 'P'),
(149197, 'Goosetree', 42.6547203063965, 0.744465310863903, -76.4749984741211, -1.33474051883105, 218, 40, 'PPL', 'P'),
(174300, 'Gooseville', 43.5872192382813, 0.760740487496623, -88.021110534668, -1.53625819009182, 218, 57, 'PPL', 'P'),
(41131, 'Goosport', 30.2566699981689, 0.528078512157435, -93.1802825927734, -1.62630272918266, 218, 22, 'PPL', 'P'),
(196618, 'Gopher (historical)', 45.223331451416, 0.789296032547915, -106.300003051758, -1.85528504813319, 218, 31, 'PPL', 'P'),
(16248, 'Gopher Ridge', 29.6650009155273, 0.517751938583084, -81.414436340332, -1.42094997279412, 218, 12, 'PPL', 'P'),
(78369, 'Goram', 39.8738899230957, 0.695930664735809, -76.4080581665039, -1.33357219006083, 218, 45, 'PPL', 'P'),
(94544, 'Gorbet Estates Colonia', 28.0230007171631, 0.489093628803228, -97.8690032958984, -1.70813634315861, 218, 51, 'PPL', 'P'),
(9163, 'Gorby', 36.1019401550293, 0.630097722063213, -92.0758285522461, -1.6070263697385, 218, 4, 'PPL', 'P'),
(181857, 'Gorda', 35.9324989318848, 0.627140414830735, -121.467781066895, -2.12001271470894, 218, 6, 'PPL', 'P'),
(204118, 'Gorder', 40.1666717529297, 0.701040671656425, -111.91667175293, -1.95331440996236, 218, 52, 'PPL', 'P'),
(2784, 'Gordo', 33.3199996948242, 0.581543701438188, -87.9027786254883, -1.53419290866647, 218, 2, 'PPL', 'P'),
(181855, 'Gordola', 36.9752807617188, 0.645340391141309, -122.133331298828, -2.13162875759359, 218, 6, 'PPL', 'P'),
(2785, 'Gordon', 31.1411094665527, 0.54351489291532, -85.0966720581055, -1.4852171099038, 218, 2, 'PPL', 'P'),
(16249, 'Gordon', 30.889440536499, 0.539122441460912, -86.2799987792969, -1.50587005731542, 218, 12, 'PPL', 'P'),
(21488, 'Gordon', 32.8819389343262, 0.573898098843707, -83.3324966430664, -1.45442644032863, 218, 13, 'PPL', 'P'),
(27290, 'Gordon', 39.0080604553223, 0.680819089762372, -87.6847229003906, -1.53038711831069, 218, 18, 'PPL', 'P'),
(32571, 'Gordon', 37.5886116027832, 0.65604503372191, -96.9902801513672, -1.69279973107306, 218, 20, 'PPL', 'P'),
(36144, 'Gordon', 36.9927787780762, 0.645645789139314, -83.0244369506836, -1.44904978440387, 218, 21, 'PPL', 'P'),
(41135, 'Gordon', 30.4841709136963, 0.532049152184688, -93.3230590820313, -1.62879464901464, 218, 22, 'PPL', 'P'),
(60077, 'Gordon', 31.8966693878174, 0.556701901237497, -90.9722213745117, -1.58776479083839, 218, 30, 'PPL', 'P'),
(72702, 'Gordon', 39.9305610656738, 0.696919762764664, -84.5086135864258, -1.47495355337874, 218, 41, 'PPL', 'P'),
(87336, 'Gordon', 35.2041702270508, 0.614428680894596, -87.0505599975586, -1.51931888766226, 218, 50, 'PPL', 'P'),
(94545, 'Gordon', 32.5483283996582, 0.568075496594412, -98.3688888549805, -1.71686099204776, 218, 51, 'PPL', 'P'),
(109423, 'Gordon', 37.9869384765625, 0.662997149168534, -81.695556640625, -1.42585644762842, 218, 58, 'PPL', 'P'),
(131043, 'Gordon', 46.4844398498535, 0.811306526325202, -87.2272186279297, -1.5224021624143, 218, 27, 'PPL', 'P'),
(162147, 'Gordon', 40.7516708374023, 0.711250831801626, -76.3363876342773, -1.33232130329682, 218, 45, 'PPL', 'P'),
(174301, 'Gordon', 46.246940612793, 0.807161382667521, -91.7983322143555, -1.60218314498008, 218, 57, 'PPL', 'P'),
(181856, 'Gordon', 36.896110534668, 0.643958610009721, -119.728889465332, -2.0896633309264, 218, 6, 'PPL', 'P'),
(196619, 'Gordon', 47.6294403076172, 0.831290554250021, -111.64582824707, -1.94858729902747, 218, 31, 'PPL', 'P'),
(199347, 'Gordon', 42.8047218322754, 0.747083331373506, -102.202781677246, -1.78377504496488, 218, 35, 'PPL', 'P'),
(207527, 'Gordon', 46.7636108398438, 0.816178979276584, -118.021667480469, -2.0598666862281, 218, 56, 'PPL', 'P'),
(211853, 'Gordon', 69.6800003051758, 1.21614542811597, -141.205825805664, -2.46450658330641, 218, 1, 'PPL', 'P'),
(127588, 'Gordon (historical)', 45.5299987792969, 0.79464838712773, -68.2847213745117, -1.19179321679218, 218, 26, 'PPL', 'P'),
(21489, 'Gordon Acres', 33.8088912963867, 0.590076469570802, -84.6061096191406, -1.47665518015725, 218, 13, 'PPL', 'P'),
(131044, 'Gordon Beach', 41.8280601501465, 0.73003736934229, -86.7030563354492, -1.51325380459572, 218, 27, 'PPL', 'P'),
(102342, 'Gordon Corner', 36.7230606079102, 0.640938319017463, -78.2808303833008, -1.36625823138381, 218, 53, 'PPL', 'P'),
(127589, 'Gordon Corner', 45.0330581665039, 0.785975137247614, -69.2016677856445, -1.20779695073079, 218, 26, 'PPL', 'P'),
(102345, 'Gordon Crossing', 37.7400016784668, 0.658687288997432, -78.8172225952148, -1.37562004156377, 218, 53, 'PPL', 'P'),
(21491, 'Gordon Estates', 33.8624992370605, 0.591012104640774, -84.833610534668, -1.4806258201845, 218, 13, 'PPL', 'P'),
(36143, 'Gordon Ford', 37.8833312988281, 0.661188862788371, -83.2380599975586, -1.45277820992998, 218, 21, 'PPL', 'P'),
(2786, 'Gordon Heights', 33.4283294677734, 0.58343441265409, -86.9252777099609, -1.51713229924925, 218, 2, 'PPL', 'P'),
(13832, 'Gordon Heights', 39.7597198486328, 0.693938021029184, -75.5097198486328, -1.31789322861716, 218, 10, 'PPL', 'P'),
(21493, 'Gordon Heights', 31.1988906860352, 0.544523365441106, -81.5044403076172, -1.4225208383631, 218, 13, 'PPL', 'P'),
(149198, 'Gordon Heights', 40.8586082458496, 0.71311724167258, -72.9711074829102, -1.27358608440345, 218, 40, 'PPL', 'P'),
(21495, 'Gordon Hills Estates', 33.7930603027344, 0.589800166607707, -84.5661087036133, -1.47595703247749, 218, 13, 'PPL', 'P'),
(94546, 'Gordon Junction', 32.5344390869141, 0.567833082356188, -98.3177795410156, -1.71596896624064, 218, 51, 'PPL', 'P'),
(2787, 'Gordon Landing', 31.1474990844727, 0.543626412785967, -85.0699996948242, -1.48475158934525, 218, 2, 'PPL', 'P'),
(102343, 'Gordon Landing', 37.5877799987793, 0.656030519493969, -76.9741668701172, -1.34345265086308, 218, 53, 'PPL', 'P'),
(172052, 'Gordon Landing', 44.6886100769043, 0.779963383981896, -73.3472213745117, -1.28015051017439, 218, 55, 'PPL', 'P'),
(21498, 'Gordon Springs (historical)', 34.7555618286133, 0.606598987289763, -85.1372222900391, -1.48592484496349, 218, 13, 'PPL', 'P'),
(21499, 'Gordon Terrace', 33.398609161377, 0.58291569545277, -82.1180572509766, -1.43323047437074, 218, 13, 'PPL', 'P'),
(21500, 'Gordon Woods', 33.7922210693359, 0.589785519221711, -84.5633316040039, -1.47590856294565, 218, 13, 'PPL', 'P'),
(102344, 'Gordondale', 39.3030586242676, 0.685967779097822, -78.1002807617188, -1.36310704602398, 218, 53, 'PPL', 'P'),
(47552, 'Gordons Corner', 38.8325004577637, 0.677754989770181, -76.9402770996094, -1.34286116278498, 218, 25, 'PPL', 'P'),
(145311, 'Gordons Corner', 40.3177795410156, 0.703678000083931, -74.3058319091797, -1.29688142024865, 218, 37, 'PPL', 'P'),
(199349, 'Gordons Mobile Plaza', 41.1369400024414, 0.717975047237967, -102.987503051758, -1.79747101666088, 218, 35, 'PPL', 'P'),
(204119, 'Gordons South Lawn Addition', 40.6819381713867, 0.710033767183459, -111.890281677246, -1.95285381625183, 218, 52, 'PPL', 'P'),
(87338, 'Gordonsburg', 35.5697212219238, 0.620808749339071, -87.4238891601563, -1.52583471074331, 218, 50, 'PPL', 'P'),
(21501, 'Gordonston', 32.0550003051758, 0.559465297053105, -81.0663909912109, -1.4148754355057, 218, 13, 'PPL', 'P'),
(2788, 'Gordonsville', 32.1627807617188, 0.561346420889082, -86.7324981689453, -1.51376766152805, 218, 2, 'PPL', 'P'),
(36145, 'Gordonsville', 36.8400001525879, 0.642979299097872, -87.0188903808594, -1.51876614857802, 218, 21, 'PPL', 'P'),
(87339, 'Gordonsville', 36.1725006103516, 0.631329234330293, -85.9297180175781, -1.49975650471703, 218, 50, 'PPL', 'P'),
(102348, 'Gordonsville', 38.1372184753418, 0.665620029947126, -78.1880569458008, -1.36463902944105, 218, 53, 'PPL', 'P'),
(135622, 'Gordonsville', 43.5127792358398, 0.759441264358828, -93.2533264160156, -1.62757758439648, 218, 28, 'PPL', 'P'),
(65115, 'Gordonton', 36.2808303833008, 0.633219945546195, -79.1272201538086, -1.38103051963437, 218, 33, 'PPL', 'P'),
(65116, 'Gordontown', 35.7555618286133, 0.624052279809706, -80.10888671875, -1.39816383334934, 218, 33, 'PPL', 'P'),
(659, 'Gordonville', 37.3111114501953, 0.651201742384464, -89.6791687011719, -1.5651967642869, 218, 29, 'PPL', 'P'),
(16250, 'Gordonville', 27.9455604553223, 0.487742041260499, -81.8005599975586, -1.42768910193256, 218, 12, 'PPL', 'P'),
(81271, 'Gordonville', 33.6866683959961, 0.587943277537649, -79.445556640625, -1.38658653945855, 218, 48, 'PPL', 'P'),
(94547, 'Gordonville', 33.7955589294434, 0.589843775870557, -96.852783203125, -1.69039995661479, 218, 51, 'PPL', 'P'),
(131045, 'Gordonville', 43.5677795410156, 0.760401200773747, -84.3694381713867, -1.47252448414848, 218, 27, 'PPL', 'P'),
(162149, 'Gordonville', 40.0200004577637, 0.698480774637614, -76.1338882446289, -1.32878702221418, 218, 45, 'PPL', 'P'),
(21502, 'Gordy', 31.4802799224854, 0.549434534096835, -83.879997253418, -1.46398212863594, 218, 13, 'PPL', 'P'),
(41134, 'Gordy', 29.6072196960449, 0.516743466057299, -91.5386123657227, -1.59765017848866, 218, 22, 'PPL', 'P'),
(13831, 'Gordy Estates', 39.7249984741211, 0.693332018723137, -75.6125030517578, -1.31968713392743, 218, 10, 'PPL', 'P'),
(21503, 'Gordydale', 32.6227798461914, 0.569374919469289, -84.8150024414063, -1.48030104768957, 218, 13, 'PPL', 'P'),
(811, 'Gore', 39.5802803039551, 0.690806210166278, -82.2949981689453, -1.4363186759708, 218, 41, 'PPL', 'P'),
(21505, 'Gore', 31.9011096954346, 0.556779399225219, -84.7263870239258, -1.4787544168865, 218, 13, 'PPL', 'P'),
(55007, 'Gore', 38.7144393920898, 0.67569443545576, -91.3222198486328, -1.59387341658876, 218, 29, 'PPL', 'P'),
(75947, 'Gore', 35.5291709899902, 0.620101014279383, -95.116943359375, -1.66010383605405, 218, 42, 'PPL', 'P'),
(102346, 'Gore', 39.2638893127441, 0.685284145645999, -78.3322219848633, -1.36715518403895, 218, 53, 'PPL', 'P'),
(109424, 'Gore', 39.3144416809082, 0.686166450915142, -80.3522186279297, -1.40241077633969, 218, 58, 'PPL', 'P'),
(75948, 'Gore Landing', 35.5230598449707, 0.619994354677725, -95.0955581665039, -1.65973059402728, 218, 42, 'PPL', 'P'),
(94548, 'Gore Landing', 30.4105606079102, 0.530764409985321, -94.1194381713867, -1.64269408621793, 218, 51, 'PPL', 'P'),
(60078, 'Gore Springs', 33.7541694641113, 0.589121393424873, -89.6163864135742, -1.56410100665638, 218, 30, 'PPL', 'P'),
(94549, 'Goree', 33.4672203063965, 0.584113185836924, -99.524169921875, -1.73702445045103, 218, 51, 'PPL', 'P'),
(47555, 'Gores Mill', 39.6811103820801, 0.692566027014602, -76.6994400024414, -1.33865776247845, 218, 25, 'PPL', 'P'),
(102347, 'Goresville', 39.1980590820313, 0.684135191372711, -77.5386123657227, -1.35330408320945, 218, 53, 'PPL', 'P'),
(81272, 'Goretown', 34.026668548584, 0.593877399657591, -78.8213882446289, -1.37569274586153, 218, 48, 'PPL', 'P'),
(27291, 'Goreville', 37.5544395446777, 0.655448618795787, -88.9722213745117, -1.5528582057985, 218, 18, 'PPL', 'P'),
(2790, 'Gorgas', 33.649169921875, 0.587288805699762, -87.2080612182617, -1.52206780253944, 218, 2, 'PPL', 'P'),
(204120, 'Gorgosa', 40.7538909912109, 0.711289580795486, -111.568893432617, -1.94724453320585, 218, 52, 'PPL', 'P'),
(27295, 'Gorham', 37.7183303833008, 0.658309053543613, -89.4858322143555, -1.56182240602771, 218, 18, 'PPL', 'P'),
(32573, 'Gorham', 38.8816719055176, 0.678613193431459, -99.0227813720703, -1.72827356942514, 218, 20, 'PPL', 'P'),
(127590, 'Gorham', 43.6794395446777, 0.762350035480439, -70.4447174072266, -1.22949225939307, 218, 26, 'PPL', 'P'),
(143883, 'Gorham', 44.3877792358398, 0.774712895313778, -71.1736068725586, -1.24221378044621, 218, 36, 'PPL', 'P'),
(149201, 'Gorham', 42.7988891601563, 0.746981532040837, -77.1319427490234, -1.34620635943023, 218, 40, 'PPL', 'P'),
(198354, 'Gorham', 47.148609161377, 0.82289846760199, -103.306938171387, -1.80304621124491, 218, 34, 'PPL', 'P'),
(172053, 'Gorhamtown', 43.5727806091309, 0.760488485878474, -73.1911087036133, -1.27742583006313, 218, 55, 'PPL', 'P'),
(139180, 'Gorin', 40.3600006103516, 0.704414896757556, -92.024169921875, -1.60612475655145, 218, 29, 'PPL', 'P'),
(47553, 'Gorman', 39.295280456543, 0.685832024461255, -79.3466720581055, -1.38486067791413, 218, 25, 'PPL', 'P'),
(65117, 'Gorman', 36.0363883972168, 0.628953628058915, -78.8236083984375, -1.37573149485539, 218, 33, 'PPL', 'P'),
(87340, 'Gorman', 36.1044387817383, 0.630141331326063, -87.7077789306641, -1.5307895219514, 218, 50, 'PPL', 'P'),
(94550, 'Gorman', 32.2136116027832, 0.562233586427215, -98.670280456543, -1.72212126783289, 218, 51, 'PPL', 'P'),
(119820, 'Gorman', 41.2611083984375, 0.720142194575019, -88.341667175293, -1.54185295890986, 218, 18, 'PPL', 'P'),
(181858, 'Gorman', 34.7961082458496, 0.607306655770424, -118.851669311523, -2.07435295097759, 218, 6, 'PPL', 'P'),
(202164, 'Gorman', 44.9269409179688, 0.784123041867518, -100.074440002441, -1.74662847513212, 218, 49, 'PPL', 'P'),
(162150, 'Gorman Summit', 40.7941703796387, 0.71199258874424, -78.8869400024414, -1.37683683986583, 218, 45, 'PPL', 'P'),
(109426, 'Gormania', 39.292781829834, 0.685788415198405, -79.3447189331055, -1.38482658945217, 218, 58, 'PPL', 'P'),
(109427, 'Gormley', 38.9722213745117, 0.68019357980134, -80.0891723632813, -1.39781975293651, 218, 58, 'PPL', 'P'),
(207528, 'Gorst', 47.5255584716797, 0.829477474179895, -122.70361328125, -2.14158205585166, 218, 56, 'PPL', 'P'),
(47554, 'Gorsuch (historical)', 39.3583297729492, 0.686932442623676, -76.9416732788086, -1.34288553070895, 218, 25, 'PPL', 'P'),
(47558, 'Gorsuch Mills', 39.7069396972656, 0.693016833608126, -76.5883331298828, -1.33671858173071, 218, 25, 'PPL', 'P'),
(149200, 'Gorthey Corners', 43.0988883972168, 0.752217506481015, -74.1680603027344, -1.29447685210042, 218, 40, 'PPL', 'P'),
(47556, 'Gortner', 39.3549995422363, 0.686874319132885, -79.4277801513672, -1.38627628119156, 218, 25, 'PPL', 'P'),
(162151, 'Gorton', 40.9941711425781, 0.715483260564034, -78.0408325195313, -1.36206947846328, 218, 45, 'PPL', 'P'),
(169397, 'Gortons Corner', 41.6816711425781, 0.727482399171495, -71.6680603027344, -1.25084362080056, 218, 47, 'PPL', 'P'),
(41136, 'Gorum', 31.4327793121338, 0.548605492049493, -92.9433288574219, -1.62216710632587, 218, 22, 'PPL', 'P'),
(196620, 'Gorus', 46.0627784729004, 0.803947146968877, -114.171112060547, -1.99266181611995, 218, 31, 'PPL', 'P'),
(2791, 'Gosa', 32.8461112976074, 0.573272788619757, -87.8616714477539, -1.5334754530688, 218, 2, 'PPL', 'P'),
(102349, 'Gose Mill', 37.125, 0.647953484802895, -81.3561096191406, -1.41993197946743, 218, 53, 'PPL', 'P'),
(162152, 'Gosford', 40.8497200012207, 0.712962112539083, -79.5102767944336, -1.38771611923491, 218, 45, 'PPL', 'P'),
(181859, 'Gosford', 35.3111114501953, 0.616295157344578, -119.090560913086, -2.07852239598021, 218, 6, 'PPL', 'P'),
(419, 'Goshen', 33.8636093139648, 0.591031479137705, -82.508056640625, -1.44003724780088, 218, 13, 'PPL', 'P'),
(2792, 'Goshen', 31.7227802276611, 0.553666962859243, -86.1183319091797, -1.50304843814048, 218, 2, 'PPL', 'P'),
(9167, 'Goshen', 36.1011085510254, 0.630083207835272, -93.9911117553711, -1.64045436774117, 218, 4, 'PPL', 'P'),
(36146, 'Goshen', 38.4030609130859, 0.67025985577729, -85.5741729736328, -1.49355107306104, 218, 21, 'PPL', 'P'),
(47557, 'Goshen', 39.2033309936523, 0.684227203588374, -77.1877822875977, -1.34718094323114, 218, 25, 'PPL', 'P'),
(60080, 'Goshen', 32.7619400024414, 0.571803722383442, -89.4958267211914, -1.56199684307911, 218, 30, 'PPL', 'P'),
(70883, 'Goshen', 39.1413917541504, 0.683146159922883, -74.8533325195313, -1.30643710855596, 218, 37, 'PPL', 'P'),
(81273, 'Goshen', 32.732780456543, 0.571294792299128, -80.1933288574219, -1.39963762669659, 218, 48, 'PPL', 'P'),
(87341, 'Goshen', 36.4652786254883, 0.636439174671883, -82.7397232055664, -1.44408059212589, 218, 50, 'PPL', 'P'),
(94552, 'Goshen', 30.6219902038574, 0.534454552570762, -95.72119140625, -1.67064995397076, 218, 51, 'PPL', 'P'),
(102350, 'Goshen', 37.9869384765625, 0.662997149168534, -79.4980621337891, -1.38750293318965, 218, 53, 'PPL', 'P'),
(109428, 'Goshen', 38.7122192382813, 0.675655686461899, -80.3066711425781, -1.40161582275431, 218, 58, 'PPL', 'P'),
(113484, 'Goshen', 41.8316688537598, 0.73010035310207, -73.2255630493164, -1.27802717183727, 218, 8, 'PPL', 'P'),
(122701, 'Goshen', 41.582218170166, 0.725746617352009, -85.8344421386719, -1.49809362693239, 218, 19, 'PPL', 'P'),
(124942, 'Goshen', 42.4402809143066, 0.74072263742596, -72.8000030517578, -1.27059974871509, 218, 23, 'PPL', 'P'),
(139181, 'Goshen', 40.3827781677246, 0.704812440129277, -93.679443359375, -1.63501472805663, 218, 29, 'PPL', 'P'),
(143885, 'Goshen', 43.3011093139648, 0.75574692729467, -72.1483306884766, -1.25922592033158, 218, 36, 'PPL', 'P'),
(149203, 'Goshen', 41.4019393920898, 0.722600159103107, -74.3247222900391, -1.2972111195916, 218, 40, 'PPL', 'P'),
(155486, 'Goshen', 40.4436111450195, 0.705874175876865, -81.4100036621094, -1.42087260796445, 218, 41, 'PPL', 'P'),
(162153, 'Goshen', 41.083610534668, 0.717044272436984, -78.4080581665039, -1.36847877510072, 218, 45, 'PPL', 'P'),
(172055, 'Goshen', 44.0491714477539, 0.768803074538783, -72.1486129760742, -1.2592308471796, 218, 55, 'PPL', 'P'),
(181860, 'Goshen', 36.3511085510254, 0.634446530965258, -119.419166564941, -2.08425764654575, 218, 6, 'PPL', 'P'),
(192588, 'Goshen', 39.9530601501465, 0.697312445867396, -111.900001525879, -1.95302345961327, 218, 52, 'PPL', 'P'),
(200904, 'Goshen', 43.9955596923828, 0.767867372889784, -123.010276794434, -2.14693434385244, 218, 43, 'PPL', 'P'),
(207529, 'Goshen', 48.8547210693359, 0.852675737803357, -122.339721679688, -2.13523094928403, 218, 56, 'PPL', 'P'),
(209861, 'Goshen', 43.3097190856934, 0.755897196159177, -112.082496643066, -1.956208600277, 218, 17, 'PPL', 'P'),
(2793, 'Goshen (historical)', 33.9588890075684, 0.592694423501377, -85.6166687011719, -1.49429276342463, 218, 2, 'PPL', 'P'),
(60079, 'Goshen (historical)', 32.1083297729492, 0.560396071854087, -89.0563888549805, -1.55432720545579, 218, 30, 'PPL', 'P'),
(87342, 'Goshen (historical)', 35.0416717529297, 0.611592547491716, -86.5736083984375, -1.51099451188495, 218, 50, 'PPL', 'P'),
(102351, 'Goshen Cross Road', 37.8722190856934, 0.660994918081986, -77.6391677856445, -1.35505910636781, 218, 53, 'PPL', 'P'),
(70885, 'Goshen Crossing', 39.128059387207, 0.682913466222637, -74.8252792358398, -1.30594748638955, 218, 37, 'PPL', 'P'),
(143886, 'Goshen Four Corners', 43.2783317565918, 0.755349383922948, -72.1313934326172, -1.25893030945058, 218, 36, 'PPL', 'P'),
(65118, 'Goshen Grove', 35.2755584716797, 0.615674640810589, -81.0555572509766, -1.4146863510683, 218, 33, 'PPL', 'P'),
(81274, 'Goshen Hill', 34.521110534668, 0.602507040274856, -81.5633316040039, -1.42354868538582, 218, 48, 'PPL', 'P'),
(47559, 'Goshen Hunt Estates', 39.2097206115723, 0.684338723459021, -77.1763916015625, -1.34698213825577, 218, 25, 'PPL', 'P'),
(47560, 'Goshen Hunt Hills', 39.2113914489746, 0.684367885072957, -77.168327331543, -1.34684139019215, 218, 25, 'PPL', 'P'),
(195012, 'Goshen Junction', 43.3083305358887, 0.755872961393258, -112.178611755371, -1.95788612544764, 218, 17, 'PPL', 'P'),
(21506, 'Goshen Plantation', 33.3152809143066, 0.581461343181478, -81.9847183227539, -1.43090327105218, 218, 13, 'PPL', 'P'),
(60081, 'Goshen Springs', 32.4705581665039, 0.566718149965826, -89.9158325195313, -1.56932732713761, 218, 30, 'PPL', 'P'),
(21507, 'Goshen Villa', 32.2611083984375, 0.563062561895529, -81.2061080932617, -1.41731395895783, 218, 13, 'PPL', 'P'),
(78368, 'Goshenville', 39.9949989318848, 0.698044415693004, -75.5447235107422, -1.31850415777122, 218, 45, 'PPL', 'P'),
(192589, 'Goshute', 39.8761100769043, 0.695969413729669, -113.999168395996, -1.98966083304559, 218, 52, 'PPL', 'P'),
(199980, 'Goshute (historical)', 40.1708297729492, 0.70111324279613, -114.708610534668, -2.00204293421781, 218, 39, 'PPL', 'P'),
(172057, 'Goslants Mill', 44.4644393920898, 0.776050867445434, -72.2197189331055, -1.26047188024758, 218, 55, 'PPL', 'P'),
(13833, 'Goslee Mill', 38.7183303833008, 0.675762346063557, -75.1891708374023, -1.31229859295717, 218, 10, 'PPL', 'P'),
(9165, 'Gosnell', 35.9597206115723, 0.627615522769205, -89.9719390869141, -1.57030657147043, 218, 4, 'PPL', 'P'),
(47561, 'Gosnell', 39.4019393920898, 0.687693574063221, -77.0969390869141, -1.34559543027616, 218, 25, 'PPL', 'P'),
(29913, 'Gospel Grove', 39.476390838623, 0.688992996938098, -87.2927780151367, -1.52354638957666, 218, 19, 'PPL', 'P'),
(94553, 'Gospel Hill', 30.8288898468018, 0.538065632561341, -95.3550033569336, -1.66425876682874, 218, 51, 'PPL', 'P'),
(55008, 'Gospel Ridge', 37.8213882446289, 0.660107752543853, -92.1588897705078, -1.60847606147788, 218, 29, 'PPL', 'P'),
(9166, 'Gospoda', 34.8886108398438, 0.608921130602258, -91.495002746582, -1.59688904704911, 218, 4, 'PPL', 'P'),
(2794, 'Gosport', 31.5825004577637, 0.551218619000592, -87.583610534668, -1.52862237461435, 218, 2, 'PPL', 'P'),
(29911, 'Gosport', 39.350830078125, 0.686801548256099, -86.6669387817383, -1.5126234343657, 218, 19, 'PPL', 'P'),
(102352, 'Gosport', 36.8102798461914, 0.642460581896552, -76.3233337402344, -1.33209346986557, 218, 53, 'PPL', 'P'),
(115767, 'Gosport', 41.204719543457, 0.71915802339418, -93.1505584716797, -1.62578394540231, 218, 16, 'PPL', 'P'),
(143888, 'Gosport', 42.9775009155273, 0.75009889525483, -70.6152801513672, -1.23246914085956, 218, 36, 'PPL', 'P'),
(2795, 'Gosport Landing', 31.5466709136963, 0.550593275487128, -87.57861328125, -1.52853515608865, 218, 2, 'PPL', 'P'),
(21508, 'Goss', 34.1505584716797, 0.596039686725653, -82.9219436645508, -1.44726093909966, 218, 13, 'PPL', 'P'),
(41138, 'Goss', 32.0611114501953, 0.559571956654762, -93.5577774047852, -1.63289125656146, 218, 22, 'PPL', 'P'),
(55009, 'Goss', 39.5138893127441, 0.689647468775985, -91.9422225952148, -1.60469450588802, 218, 29, 'PPL', 'P'),
(60082, 'Goss', 31.3552799224854, 0.547252872531842, -89.8886108398438, -1.56885221919914, 218, 30, 'PPL', 'P'),
(75950, 'Goss', 34.5508308410645, 0.603025757476176, -95.6911087036133, -1.67012491176185, 218, 42, 'PPL', 'P'),
(124945, 'Goss Heights', 42.2625007629395, 0.737619788439909, -72.8736114501953, -1.27188445762495, 218, 23, 'PPL', 'P'),
(162156, 'Goss Run Junction', 40.8319396972656, 0.712651787693062, -78.3324966430664, -1.36715997772891, 218, 45, 'PPL', 'P'),
(202165, 'Gossage Memorial', 44.0708312988281, 0.76918111025552, -103.250282287598, -1.80205737953216, 218, 49, 'PPL', 'P'),
(87343, 'Gossburg', 35.6619415283203, 0.622418297322888, -86.2161102294922, -1.504754991767, 218, 50, 'PPL', 'P'),
(162155, 'Gosser Hill', 40.6227798461914, 0.709001259628836, -79.6094436645508, -1.38944690762735, 218, 45, 'PPL', 'P'),
(27296, 'Gossett', 37.9233283996582, 0.661886943889108, -88.3691711425781, -1.54233299369635, 218, 18, 'PPL', 'P'),
(143889, 'Gossville', 43.226390838623, 0.754442843887885, -71.3513870239258, -1.24531662943226, 218, 36, 'PPL', 'P'),
(211854, 'Gost Creek', 62.2105598449707, 1.08577909880371, -159.785827636719, -2.78878879028489, 218, 1, 'PPL', 'P'),
(75951, 'Gotebo', 35.0702781677246, 0.612091823617079, -98.871940612793, -1.72564090152954, 218, 42, 'PPL', 'P'),
(16251, 'Gotha', 28.5275001525879, 0.497898805025843, -81.5233306884766, -1.42285053770605, 218, 12, 'PPL', 'P'),
(135625, 'Gotha', 44.7172203063965, 0.780462726686286, -93.788330078125, -1.63691515981051, 218, 28, 'PPL', 'P'),
(174304, 'Gotham', 43.223331451416, 0.754389447508029, -90.291389465332, -1.57588203237057, 218, 57, 'PPL', 'P'),
(199350, 'Gothenburg', 40.9294395446777, 0.714353481050595, -100.160278320313, -1.74812663640335, 218, 35, 'PPL', 'P'),
(186782, 'Gothic', 38.959171295166, 0.679965812949111, -106.989166259766, -1.86731321519654, 218, 7, 'PPL', 'P'),
(149204, 'Gothicville', 42.6730613708496, 0.744785422826931, -74.6936111450195, -1.30364944468492, 218, 40, 'PPL', 'P'),
(36147, 'Gotts', 36.9727783203125, 0.645296715299432, -86.3138885498047, -1.50646154539353, 218, 21, 'PPL', 'P'),
(47562, 'Gotts', 39.0363883972168, 0.681313505618745, -76.6022186279297, -1.33696092938991, 218, 25, 'PPL', 'P'),
(193597, 'Gottsville', 41.8675003051758, 0.730725729905048, -122.73999786377, -2.14221708661358, 218, 6, 'PPL', 'P'),
(81275, 'Goucher', 34.9813919067383, 0.61054046570308, -81.6972198486328, -1.42588547608431, 218, 48, 'PPL', 'P'),
(47563, 'Goucher Woods', 39.399169921875, 0.687645237689436, -76.5844421386719, -1.33665067112291, 218, 25, 'PPL', 'P'),
(41139, 'Goudeau', 30.8716697692871, 0.538812283062458, -92.0141677856445, -1.605950186342, 218, 22, 'PPL', 'P'),
(119823, 'Gougars', 41.523609161377, 0.724723697177309, -88.0047225952148, -1.53597216659075, 218, 18, 'PPL', 'P'),
(87344, 'Gouge (historical)', 36.3180618286133, 0.633869756852174, -82.0972213745117, -1.43286681972389, 218, 50, 'PPL', 'P'),
(199981, 'Gouge Eye', 41.5713882446289, 0.72555759949364, -117.469718933105, -2.05023336677501, 218, 39, 'PPL', 'P'),
(21509, 'Gough', 33.0916709899902, 0.577558613762021, -82.2266693115234, -1.43512611243466, 218, 13, 'PPL', 'P'),
(94556, 'Gough', 33.3438911437988, 0.581960685885868, -95.8002777099609, -1.67203027036375, 218, 51, 'PPL', 'P'),
(162157, 'Gouglersville', 40.273609161377, 0.70290708152738, -76.0194396972656, -1.32678951823857, 218, 45, 'PPL', 'P'),
(9168, 'Gould', 33.9850006103516, 0.593150156942917, -91.5608291625977, -1.59803793474337, 218, 4, 'PPL', 'P'),
(75952, 'Gould', 34.6708297729492, 0.605120133936442, -99.7708282470703, -1.74132945035314, 218, 42, 'PPL', 'P'),
(94554, 'Gould', 32.0555610656738, 0.559475084170111, -95.1505584716797, -1.66069053044219, 218, 51, 'PPL', 'P'),
(109430, 'Gould', 38.9008293151855, 0.678947553306319, -80.2555618286133, -1.40072379694718, 218, 58, 'PPL', 'P'),
(155495, 'Gould', 41.603328704834, 0.726115065688821, -83.6113891601563, -1.45929403301102, 218, 41, 'PPL', 'P'),
(169398, 'Gould', 41.4583282470703, 0.723584330283946, -71.5208282470703, -1.24827393666474, 218, 47, 'PPL', 'P'),
(194213, 'Gould', 40.5263900756836, 0.707318940768233, -106.026107788086, -1.8505046739765, 218, 7, 'PPL', 'P'),
(81276, 'Gould (historical)', 34.860279083252, 0.608426648166857, -81.4475021362305, -1.42152707980234, 218, 48, 'PPL', 'P'),
(131047, 'Gould City', 46.0952796936035, 0.804514400281064, -85.6966705322266, -1.49568905878415, 218, 27, 'PPL', 'P'),
(207530, 'Gould City', 46.5883293151855, 0.813119739553383, -117.576942443848, -2.05210477007301, 218, 56, 'PPL', 'P'),
(127594, 'Gould Corner', 43.1738891601563, 0.753526516735816, -70.8099975585938, -1.23586760072661, 218, 26, 'PPL', 'P'),
(55010, 'Gould Farm', 39.6561088562012, 0.692129668069993, -93.9016723632813, -1.63889335586822, 218, 29, 'PPL', 'P'),
(127596, 'Gould Landing', 45.1650009155273, 0.788277972642205, -67.7441711425781, -1.18235883547252, 218, 26, 'PPL', 'P'),
(155496, 'Gould Park', 40.0686111450195, 0.699329191181886, -82.8983306884766, -1.44684881492097, 218, 41, 'PPL', 'P'),
(94555, 'Gouldbusk', 31.5547199249268, 0.55073375723463, -99.4763870239258, -1.73619048155567, 218, 51, 'PPL', 'P'),
(102353, 'Gouldin', 37.7722206115723, 0.659249615461602, -77.7013931274414, -1.35614514346035, 218, 53, 'PPL', 'P'),
(16252, 'Goulding', 30.4427795410156, 0.531326736449491, -87.2225036621094, -1.52231987073662, 218, 12, 'PPL', 'P'),
(192590, 'Goulding', 37.0094413757324, 0.645936606330351, -110.202217102051, -1.92339153142839, 218, 52, 'PPL', 'P'),
(124946, 'Goulding Village', 42.5416717529297, 0.742492241391291, -72.1102828979492, -1.25856186111377, 218, 23, 'PPL', 'P'),
(16253, 'Goulds', 25.562219619751, 0.446144896482547, -80.3824996948242, -1.40293928065802, 218, 12, 'PPL', 'P'),
(149205, 'Goulds', 41.9258308410645, 0.731743789810758, -75.083610534668, -1.31045621811506, 218, 40, 'PPL', 'P'),
(65119, 'Goulds (historical)', 36.1027793884277, 0.630112369449209, -81.3388900756836, -1.41963144173842, 218, 33, 'PPL', 'P'),
(149206, 'Goulds Mill', 43.6091690063477, 0.761123583219431, -75.3408279418945, -1.3149455087646, 218, 40, 'PPL', 'P'),
(172058, 'Goulds Mill', 43.271110534668, 0.75522334982436, -72.4497222900391, -1.26448619611671, 218, 55, 'PPL', 'P'),
(127597, 'Gouldsboro', 44.478328704834, 0.776293281683658, -68.0388870239258, -1.18750259795995, 218, 26, 'PPL', 'P'),
(162159, 'Gouldsboro', 41.2444381713867, 0.719851244225928, -75.4563903808594, -1.31696245381617, 218, 45, 'PPL', 'P'),
(70884, 'Gouldtown', 39.4205589294434, 0.688018546295238, -75.1847229003906, -1.3122209618114, 218, 37, 'PPL', 'P'),
(162158, 'Gouldtown', 41.9949989318848, 0.732951000732891, -79.0883331298828, -1.38035181303057, 218, 45, 'PPL', 'P'),
(193598, 'Goumaz (historical)', 40.413890838623, 0.705355458675545, -120.861389160156, -2.10942917937891, 218, 6, 'PPL', 'P'),
(9170, 'Gourd', 33.8436088562012, 0.590682405297823, -91.5966720581055, -1.59866351128343, 218, 4, 'PPL', 'P'),
(9171, 'Gourd Neck', 35.3777809143066, 0.617458759003861, -91.1402816772461, -1.590697996463, 218, 4, 'PPL', 'P'),
(81277, 'Gourdin', 33.4833297729492, 0.584394349069009, -79.896110534668, -1.39445018836728, 218, 48, 'PPL', 'P'),
(2796, 'Gourdsville', 34.9894409179688, 0.610680947450582, -87.0902786254883, -1.52001210849401, 218, 2, 'PPL', 'P'),
(131048, 'Gourley', 45.5950012207031, 0.795782893752103, -87.4238891601563, -1.52583471074331, 218, 27, 'PPL', 'P'),
(149207, 'Gouverneur', 44.336669921875, 0.773820869506656, -75.4633331298828, -1.31708362764577, 218, 40, 'PPL', 'P'),
(81278, 'Govan', 33.2222213745117, 0.579837147811666, -81.1763916015625, -1.41679530833554, 218, 48, 'PPL', 'P'),
(207532, 'Govan', 47.7388916015625, 0.833200839699935, -118.821937561035, -2.07383403403918, 218, 56, 'PPL', 'P'),
(47565, 'Govanstown', 39.3638916015625, 0.68702951484541, -76.6100006103516, -1.3370967506055, 218, 25, 'PPL', 'P'),
(187686, 'Gove', 38.9577789306641, 0.679941511604164, -100.488327026367, -1.75385216643091, 218, 20, 'PPL', 'P'),
(94557, 'Gover', 33.7358283996582, 0.588801281461845, -96.4238891601563, -1.6829143434228, 218, 51, 'PPL', 'P'),
(193599, 'Government Camp', 40.6916694641113, 0.710203610281979, -122.389167785645, -2.13609394663527, 218, 6, 'PPL', 'P'),
(200905, 'Government Camp', 45.3041687011719, 0.790706908714412, -121.753608703613, -2.12500134806288, 218, 43, 'PPL', 'P'),
(178267, 'Government Hill', 33.6744384765625, 0.587729825176279, -111.149436950684, -1.93992363652728, 218, 5, 'PPL', 'P'),
(47564, 'Governor Grayson Manor', 38.9555587768555, 0.679902762610303, -76.165283203125, -1.32933496760846, 218, 25, 'PPL', 'P'),
(47576, 'Governor Run', 38.5, 0.671951762017817, -76.5047225952148, -1.3352593026114, 218, 25, 'PPL', 'P'),
(204121, 'Governors Square Condominium', 40.7788887023926, 0.711725873161069, -111.892776489258, -1.95289735893565, 218, 52, 'PPL', 'P'),
(181861, 'Governors Village', 38.6888885498047, 0.675248489131226, -121.080276489258, -2.11324948396263, 218, 6, 'PPL', 'P'),
(135627, 'Gowan', 46.8641700744629, 0.817934069013974, -92.8469390869141, -1.62048478746527, 218, 28, 'PPL', 'P'),
(149211, 'Gowanda', 42.4630584716797, 0.741120180797682, -78.9361114501953, -1.3776950435271, 218, 40, 'PPL', 'P'),
(194214, 'Gowanda', 40.204719543457, 0.701704730874237, -104.900001525879, -1.83085041197366, 218, 7, 'PPL', 'P'),
(162160, 'Gowango (historical)', 41.9322204589844, 0.731855309681405, -78.929443359375, -1.37757866338747, 218, 45, 'PPL', 'P'),
(27297, 'Gowansville (historical)', 37.4419403076172, 0.653485136703098, -88.477783203125, -1.54422863176027, 218, 18, 'PPL', 'P'),
(124947, 'Gowards Corner', 42.0250015258789, 0.733474644782228, -71.0672225952148, -1.24035702453421, 218, 23, 'PPL', 'P'),
(81279, 'Gowdeysville (historical)', 34.9063911437988, 0.609231455448279, -81.5708312988281, -1.42367957975339, 218, 48, 'PPL', 'P'),
(29912, 'Gowdy', 39.5188903808594, 0.689734753880712, -85.5630569458008, -1.49335706177563, 218, 19, 'PPL', 'P'),
(55011, 'Gowdy', 38.7655601501465, 0.676586660999964, -94.2969436645508, -1.64579214151402, 218, 29, 'PPL', 'P'),
(41140, 'Gowen', 32.6541709899902, 0.569922798284546, -91.4608306884766, -1.59629263212299, 218, 22, 'PPL', 'P'),
(75953, 'Gowen', 34.8813896179199, 0.608795096503669, -95.4766693115234, -1.66638223832391, 218, 42, 'PPL', 'P'),
(131050, 'Gowen', 43.2516708374023, 0.754884063101484, -85.3019409179688, -1.48879972736023, 218, 27, 'PPL', 'P'),
(162161, 'Gowen', 40.9474983215332, 0.714668666165606, -76.1791687011719, -1.32957731526766, 218, 45, 'PPL', 'P'),
(162162, 'Gowen Breaker Station', 40.9458312988281, 0.714639571130697, -76.1816711425781, -1.32962099110954, 218, 45, 'PPL', 'P'),
(162163, 'Gowen City', 40.7555618286133, 0.711318742409423, -76.5338897705078, -1.33576836585377, 218, 45, 'PPL', 'P'),
(81280, 'Gowensville', 35.1147193908691, 0.612867469284564, -82.2252807617188, -1.43510187766874, 218, 48, 'PPL', 'P'),
(55012, 'Gower', 39.6108283996582, 0.691339375016512, -94.5991668701172, -1.65106693152708, 218, 29, 'PPL', 'P'),
(87345, 'Gower (historical)', 35.3208312988281, 0.616464800706016, -87.5805587768555, -1.52856911139255, 218, 50, 'PPL', 'P'),
(21510, 'Gower Springs (historical)', 34.3152809143066, 0.598914635701421, -83.8294372558594, -1.46309969020875, 218, 13, 'PPL', 'P'),
(27299, 'Gowins', 37.4436111450195, 0.653514298317035, -88.4677810668945, -1.54405406155081, 218, 18, 'PPL', 'P'),
(115769, 'Gowrie', 42.2805595397949, 0.73793497355492, -94.2905578613281, -1.6456806882224, 218, 16, 'PPL', 'P'),
(193075, 'Gozar', 31.2133293151855, 0.544775367059255, -103.928062438965, -1.81388687477818, 218, 51, 'PPL', 'P'),
(131051, 'Graafschap', 42.7541694641113, 0.746201026104362, -86.1363906860352, -1.50336362325549, 218, 27, 'PPL', 'P'),
(36148, 'Grab', 37.225830078125, 0.649713301651219, -85.6016693115234, -1.49403097468947, 218, 21, 'PPL', 'P'),
(2801, 'Graball', 31.586389541626, 0.551286496318876, -85.2758331298828, -1.48834406049772, 218, 2, 'PPL', 'P'),
(21511, 'Graball', 33.9297218322754, 0.592185360259009, -82.5647201538086, -1.44102621267168, 218, 13, 'PPL', 'P'),
(87348, 'Graball', 35.872501373291, 0.626093259890116, -88.7447204589844, -1.54888756577125, 218, 50, 'PPL', 'P'),
(94558, 'Graball', 30.2649993896484, 0.52822388746344, -96.1341705322266, -1.67785779946106, 218, 51, 'PPL', 'P'),
(55013, 'Grabeel (historical)', 36.7222213745117, 0.640923671631467, -92.5508270263672, -1.61531665705386, 218, 29, 'PPL', 'P'),
(200906, 'Grabenhorst Corner', 44.8830604553223, 0.783357183317039, -123.035278320313, -2.14737070279705, 218, 43, 'PPL', 'P'),
(122702, 'Grabill', 41.2108306884766, 0.719264682995838, -84.9669418334961, -1.48295289034501, 218, 19, 'PPL', 'P'),
(115771, 'Grable', 41.4708290100098, 0.723802509756251, -95.8994369506836, -1.67376092559814, 218, 16, 'PPL', 'P'),
(41141, 'Grabow', 30.8174991607666, 0.537866827585966, -93.3358306884766, -1.62901755559788, 218, 22, 'PPL', 'P'),
(65120, 'Grabtown', 35.9569396972656, 0.627566986658338, -77.033332824707, -1.34448529157576, 218, 33, 'PPL', 'P'),
(181862, 'Grabtown', 37.4222183227539, 0.653140923132206, -122.342781066895, -2.13528434566389, 218, 6, 'PPL', 'P'),
(2798, 'Grace', 31.6119403839111, 0.55173244264341, -86.8805618286133, -1.51635185989181, 218, 2, 'PPL', 'P'),
(36149, 'Grace', 37.1972198486328, 0.649213958946829, -83.8655624389648, -1.46373019359682, 218, 21, 'PPL', 'P'),
(55015, 'Grace', 37.8574981689453, 0.66073798961582, -92.7444381713867, -1.61869580900301, 218, 29, 'PPL', 'P'),
(60083, 'Grace', 32.999439239502, 0.575948866041123, -90.9563903808594, -1.5874884878753, 218, 30, 'PPL', 'P'),
(65121, 'Grace', 35.628059387207, 0.621826942402836, -82.5524978637695, -1.44081289346836, 218, 33, 'PPL', 'P'),
(81282, 'Grace', 34.7077789306641, 0.605765018394405, -80.8433303833008, -1.41098229346617, 218, 48, 'PPL', 'P'),
(94559, 'Grace', 30.2972202301025, 0.528786247217123, -95.084716796875, -1.65954137643183, 218, 51, 'PPL', 'P'),
(109432, 'Grace', 38.8858299255371, 0.678685764571164, -81.3530578613281, -1.41987871624563, 218, 58, 'PPL', 'P'),
(131052, 'Grace', 45.5513916015625, 0.795021762312559, -84.1294403076172, -1.46833573122795, 218, 27, 'PPL', 'P'),
(195013, 'Grace', 42.5761108398438, 0.743093316849322, -111.729721069336, -1.95005150499479, 218, 17, 'PPL', 'P'),
(196621, 'Grace', 45.8066711425781, 0.799477230816261, -112.329437255859, -1.96051852702713, 218, 31, 'PPL', 'P'),
(207531, 'Grace', 47.7777786254883, 0.833879546303741, -122.149436950684, -2.13190985424665, 218, 56, 'PPL', 'P'),
(21512, 'Grace (historical)', 34.5327796936035, 0.60271070551922, -83.8647232055664, -1.46371554621083, 218, 13, 'PPL', 'P'),
(87349, 'Grace (historical)', 35.975830078125, 0.62789668600129, -85.6050033569336, -1.49408916475929, 218, 50, 'PPL', 'P'),
(65122, 'Grace Chapel', 35.8213882446289, 0.625201167503966, -81.3802795410156, -1.4203538241841, 218, 33, 'PPL', 'P'),
(140107, 'Grace City', 47.5513916015625, 0.829928347352445, -98.8050003051758, -1.72447257275932, 218, 34, 'PPL', 'P'),
(47566, 'Grace Creek', 38.7552795410156, 0.676407230521519, -76.269172668457, -1.33114818083664, 218, 25, 'PPL', 'P'),
(115772, 'Grace Hill', 41.2636108398438, 0.720185870416896, -91.829719543457, -1.60273095721631, 218, 16, 'PPL', 'P'),
(102354, 'Grace Point', 37.6958312988281, 0.657916370440881, -76.3541717529297, -1.33263169472187, 218, 53, 'PPL', 'P'),
(162164, 'Gracedale', 41.1711082458496, 0.718571395585063, -75.8672180175781, -1.3241327487351, 218, 45, 'PPL', 'P'),
(47568, 'Graceham', 39.6141700744629, 0.691397698244385, -77.3819427490234, -1.35056968256021, 218, 25, 'PPL', 'P'),
(47569, 'Graceland', 39.2769393920898, 0.685511912498228, -76.5274963378906, -1.33565677940409, 218, 25, 'PPL', 'P'),
(55016, 'Graceland', 37.7558288574219, 0.6589635253815, -93.7658309936523, -1.63652247670778, 218, 29, 'PPL', 'P'),
(124948, 'Graceland Park', 42.7722206115723, 0.746516078061319, -71.1602783203125, -1.24198115332499, 218, 23, 'PPL', 'P'),
(135629, 'Gracelock', 45.0505599975586, 0.786280601824646, -95.5802764892578, -1.66819052470408, 218, 28, 'PPL', 'P'),
(75955, 'Gracemont', 35.1883316040039, 0.614152244773446, -98.2602767944336, -1.71496535398385, 218, 42, 'PPL', 'P'),
(47570, 'Graceton', 39.7188911437988, 0.693225425700506, -76.3850021362305, -1.33316978642012, 218, 25, 'PPL', 'P'),
(94560, 'Graceton', 32.7144393920898, 0.5709746803361, -94.7888870239258, -1.65437817286843, 218, 51, 'PPL', 'P'),
(135630, 'Graceton', 48.7411117553711, 0.850692881213739, -94.8361129760742, -1.65520242122581, 218, 28, 'PPL', 'P'),
(162165, 'Graceton', 40.5058288574219, 0.706960079811344, -79.166389465332, -1.3817141530862, 218, 45, 'PPL', 'P'),
(16254, 'Graceville', 30.9566707611084, 0.540295830237201, -85.5166702270508, -1.49254746080424, 218, 12, 'PPL', 'P'),
(135631, 'Graceville', 45.5691719055176, 0.79533208715858, -96.4341735839844, -1.68309384048027, 218, 28, 'PPL', 'P'),
(162166, 'Graceville', 40.0513916015625, 0.69902865345287, -78.2438888549805, -1.36561348008391, 218, 45, 'PPL', 'P'),
(21514, 'Gracewood', 33.372501373291, 0.582460028590257, -82.0322189331055, -1.43173231309952, 218, 13, 'PPL', 'P'),
(808, 'Gracey', 39.4386100769043, 0.688333598252194, -81.2944412231445, -1.41885566291288, 218, 41, 'PPL', 'P'),
(36150, 'Gracey', 36.878059387207, 0.643643558052765, -87.6622161865234, -1.5299943020499, 218, 21, 'PPL', 'P'),
(162167, 'Gracey', 40.0816688537598, 0.699557091192169, -78.0611114501953, -1.36242341257215, 218, 45, 'PPL', 'P'),
(149210, 'Gracie', 42.565559387207, 0.742909159259943, -76.2494430541992, -1.3308038341077, 218, 40, 'PPL', 'P'),
(21515, 'Gracys Station (historical)', 31.3322200775146, 0.546850402312104, -83.019172668457, -1.44895790534626, 218, 13, 'PPL', 'P'),
(21516, 'Graddick (historical)', 33.0102806091309, 0.576138083636573, -84.1894378662109, -1.46938288616857, 218, 13, 'PPL', 'P'),
(155497, 'Grade (historical)', 40.5074996948242, 0.706989241425281, -81.8886108398438, -1.42922587903959, 218, 41, 'PPL', 'P'),
(102355, 'Graden', 36.976390838623, 0.645359765638239, -82.648063659668, -1.44248083125908, 218, 53, 'PPL', 'P'),
(2800, 'Grady', 31.9947204589844, 0.558413215264469, -86.2011108398438, -1.50449320303185, 218, 2, 'PPL', 'P'),
(9172, 'Grady', 34.0800018310547, 0.594808241037601, -91.7005615234375, -1.60047672451161, 218, 4, 'PPL', 'P'),
(16255, 'Grady', 29.9538898468018, 0.522794001606391, -82.9322204589844, -1.44744030299908, 218, 12, 'PPL', 'P'),
(55017, 'Grady', 37.1477813720703, 0.648351094753644, -90.9380569458008, -1.58716850907032, 218, 29, 'PPL', 'P'),
(60084, 'Grady', 33.5127792358398, 0.584908339159395, -89.3086090087891, -1.55872927757964, 218, 30, 'PPL', 'P'),
(75957, 'Grady', 34.0202789306641, 0.593765879786944, -97.665283203125, -1.70458075678725, 218, 42, 'PPL', 'P'),
(87350, 'Grady', 35.3461112976074, 0.616906019919615, -84.5163879394531, -1.47508924143628, 218, 50, 'PPL', 'P'),
(102356, 'Grady', 36.7869415283203, 0.642053251407824, -79.6374969482422, -1.38993652979376, 218, 53, 'PPL', 'P'),
(188624, 'Grady', 34.8213882446289, 0.607747874984023, -103.316940307617, -1.80322078145436, 218, 38, 'PPL', 'P'),
(192963, 'Grady', 32.3066711425781, 0.563857781797027, -101.930000305176, -1.77901411188414, 218, 51, 'PPL', 'P'),
(21517, 'Grady (historical)', 34.0036087036133, 0.593474929437852, -85.1675033569336, -1.48645334928181, 218, 13, 'PPL', 'P'),
(65125, 'Gradys', 35.1655616760254, 0.613754834559779, -77.8855590820313, -1.35935944573802, 218, 33, 'PPL', 'P'),
(65126, 'Gradys Crossroads', 35.1538887023926, 0.613551102736387, -77.8119430541992, -1.35807460367011, 218, 33, 'PPL', 'P'),
(36151, 'Gradyville', 37.0633316040039, 0.646877168248339, -85.4225006103516, -1.4909038909375, 218, 21, 'PPL', 'P'),
(78370, 'Gradyville', 39.9430618286133, 0.697137942236969, -75.4697189331055, -1.31719508093739, 218, 45, 'PPL', 'P'),
(181863, 'Graeagle', 39.7663917541504, 0.694054467747848, -120.617500305176, -2.10517251585058, 218, 6, 'PPL', 'P'),
(36152, 'Graefenburg', 38.1558303833008, 0.665944869021089, -85.0136108398438, -1.48376741816442, 218, 21, 'PPL', 'P'),
(78371, 'Graefenburg', 39.901668548584, 0.696415493212257, -77.4622192382813, -1.3519707716097, 218, 45, 'PPL', 'P'),
(47571, 'Graeloch Woods', 39.1538887023926, 0.683364272816161, -76.8858337402344, -1.34191094690804, 218, 25, 'PPL', 'P'),
(115773, 'Graettinger', 43.2377815246582, 0.754641648863259, -94.751106262207, -1.65371877418253, 218, 16, 'PPL', 'P'),
(115774, 'Graf', 42.4930610656738, 0.741643824847019, -90.8711090087891, -1.58600004714205, 218, 16, 'PPL', 'P'),
(141929, 'Graf (historical)', 40.4002799987793, 0.705117904706309, -96.1041717529297, -1.67733422199075, 218, 35, 'PPL', 'P'),
(55018, 'Graff', 37.3175010681152, 0.651313262255112, -92.2825012207031, -1.61063348827696, 218, 29, 'PPL', 'P'),
(135634, 'Graff', 46.5724983215332, 0.812843436590287, -94.5466690063477, -1.65015067095404, 218, 28, 'PPL', 'P'),
(94562, 'Graford', 32.9375, 0.574867822375632, -98.2466735839844, -1.71472793317267, 218, 51, 'PPL', 'P'),
(186783, 'Graft', 37.4477806091309, 0.653587069193821, -102.891937255859, -1.79580307887017, 218, 7, 'PPL', 'P'),
(27298, 'Grafton', 38.9700012207031, 0.680154830807479, -90.4313888549805, -1.57832548267071, 218, 18, 'PPL', 'P'),
(29914, 'Grafton', 38.0013885498047, 0.663249350523765, -87.9541702270508, -1.5350898613216, 218, 19, 'PPL', 'P'),
(32575, 'Grafton', 37.2002792358398, 0.649267355326685, -96.1494369506836, -1.67812424872813, 218, 20, 'PPL', 'P'),
(102358, 'Grafton', 37.1652793884277, 0.648656492751648, -76.4688873291016, -1.33463385922939, 218, 53, 'PPL', 'P'),
(109433, 'Grafton', 39.3408317565918, 0.686627044625671, -80.019172668457, -1.39659802778643, 218, 58, 'PPL', 'P'),
(115775, 'Grafton', 43.3300018310547, 0.756251196847076, -93.0691680908203, -1.62436341527686, 218, 16, 'PPL', 'P'),
(124949, 'Grafton', 42.2069396972656, 0.736650064907984, -71.6861114501953, -1.25115867275752, 218, 23, 'PPL', 'P'),
(131053, 'Grafton', 42.0366706848145, 0.733678310026592, -83.3897171020508, -1.45542512573741, 218, 27, 'PPL', 'P'),
(140111, 'Grafton', 48.4122200012207, 0.844952637221155, -97.4102783203125, -1.7001300819735, 218, 34, 'PPL', 'P'),
(141930, 'Grafton', 40.628059387207, 0.709093405002552, -97.7136077880859, -1.70542417990447, 218, 35, 'PPL', 'P'),
(143890, 'Grafton', 43.5586090087891, 0.760241144792233, -71.9444427490234, -1.25566740448302, 218, 36, 'PPL', 'P'),
(149212, 'Grafton', 42.7688903808594, 0.746457954570528, -73.4513931274414, -1.28196865025059, 218, 40, 'PPL', 'P'),
(155498, 'Grafton', 41.2724990844727, 0.720340999550393, -82.0547180175781, -1.43212499620225, 218, 41, 'PPL', 'P'),
(162168, 'Grafton', 40.473331451416, 0.706392893078185, -79.2091674804688, -1.3824607702978, 218, 45, 'PPL', 'P'),
(172059, 'Grafton', 43.1716690063477, 0.753487767741955, -72.6066665649414, -1.26722539045591, 218, 55, 'PPL', 'P'),
(174305, 'Grafton', 43.3197212219238, 0.756071766368632, -87.9533309936523, -1.53507521393561, 218, 57, 'PPL', 'P'),
(188625, 'Grafton', 33.4305610656738, 0.583473361385033, -107.745559692383, -1.88051477103617, 218, 38, 'PPL', 'P'),
(192591, 'Grafton', 37.1672210693359, 0.64869038147652, -113.079170227051, -1.97360383588518, 218, 52, 'PPL', 'P'),
(47572, 'Grafton (historical)', 38.4402809143066, 0.670909467346187, -77.1991729736328, -1.34737974820651, 218, 25, 'PPL', 'P'),
(143891, 'Grafton Center', 43.5738906860352, 0.760507860375404, -71.9738922119141, -1.2561813945734, 218, 36, 'PPL', 'P'),
(47573, 'Grafton Heights', 39.5449981689453, 0.690190420743225, -76.251106262207, -1.33083286256358, 218, 25, 'PPL', 'P'),
(47574, 'Grafton Manor', 39.5111083984375, 0.689598932665118, -76.9441680908203, -1.34292907339277, 218, 25, 'PPL', 'P'),
(47575, 'Grafton Shops (historical)', 39.5802803039551, 0.690806210166278, -76.4047164916992, -1.33351386683296, 218, 25, 'PPL', 'P'),
(102359, 'Grafton Village', 38.3233299255371, 0.668868287528696, -77.4422225952148, -1.35162176434885, 218, 53, 'PPL', 'P'),
(149214, 'Graftons Square', 43.4425010681152, 0.758214678939764, -76.1511077880859, -1.3290875599432, 218, 40, 'PPL', 'P'),
(65127, 'Gragg', 36.0730590820313, 0.629593652247889, -81.7708282470703, -1.42717018499416, 218, 33, 'PPL', 'P'),
(2802, 'Graham', 33.4575004577637, 0.583943542475486, -85.3208312988281, -1.48912942670318, 218, 2, 'PPL', 'P'),
(16256, 'Graham', 29.8600006103516, 0.521155325298151, -82.2186126708984, -1.43498549752911, 218, 12, 'PPL', 'P'),
(21519, 'Graham', 31.8313903808594, 0.555562567633648, -82.5025024414063, -1.4399403087372, 218, 13, 'PPL', 'P'),
(36153, 'Graham', 37.2516708374023, 0.650164307981824, -87.2797164916992, -1.52331842298735, 218, 21, 'PPL', 'P'),
(60086, 'Graham', 34.5494384765625, 0.603001456131229, -88.793327331543, -1.5497359157365, 218, 30, 'PPL', 'P'),
(65129, 'Graham', 36.0688896179199, 0.629520881371102, -79.4008331298828, -1.38580596694305, 218, 33, 'PPL', 'P'),
(72705, 'Graham', 39.6566696166992, 0.692139455186999, -81.2022171020508, -1.41724604835003, 218, 41, 'PPL', 'P'),
(75959, 'Graham', 34.3405609130859, 0.59935585491502, -97.4341735839844, -1.70054713300021, 218, 42, 'PPL', 'P'),
(87351, 'Graham', 35.8741683959961, 0.626122354925025, -87.4625015258789, -1.52650862365715, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(122703, 'Graham', 40.1569404602051, 0.700870828557906, -87.1949996948242, -1.52183983595013, 218, 19, 'PPL', 'P'),
(139182, 'Graham', 40.2008285522461, 0.70163682026644, -95.0363922119141, -1.6586979533146, 218, 29, 'PPL', 'P'),
(149215, 'Graham', 41.1236114501953, 0.717742420116748, -73.8105621337891, -1.28823733198247, 218, 40, 'PPL', 'P'),
(162169, 'Graham', 40.9136085510254, 0.714077178087499, -78.2474975585938, -1.36567646384369, 218, 45, 'PPL', 'P'),
(178268, 'Graham', 32.875, 0.573776991593136, -109.73999786377, -1.91532428385432, 218, 5, 'PPL', 'P'),
(191544, 'Graham', 33.1505584716797, 0.57858639420571, -101.469169616699, -1.77097109907599, 218, 51, 'PPL', 'P'),
(207533, 'Graham', 47.0530586242676, 0.821230796127383, -122.293060302734, -2.13441655462269, 218, 56, 'PPL', 'P'),
(112371, 'Graham (historical)', 31.3069400787354, 0.546409183098505, -92.5605621337891, -1.61548656673141, 218, 22, 'PPL', 'P'),
(115776, 'Graham (historical)', 41.6752815246582, 0.727370879300848, -91.4558334350586, -1.59620541359729, 218, 16, 'PPL', 'P'),
(193600, 'Graham (historical)', 41.5069389343262, 0.724432746828218, -122.273063659668, -2.13406754736183, 218, 6, 'PPL', 'P'),
(195014, 'Graham (historical)', 43.9688911437988, 0.767401918910265, -115.273612976074, -2.01190408710215, 218, 17, 'PPL', 'P'),
(94564, 'Graham Colonia', 26.1060009002686, 0.45563567023829, -97.609001159668, -1.70359844981917, 218, 51, 'PPL', 'P'),
(155500, 'Graham Corners', 40.186939239502, 0.701394406028215, -82.0883331298828, -1.4327116905904, 218, 41, 'PPL', 'P'),
(174308, 'Graham Corners', 43.7324981689453, 0.763276083170487, -88.1750030517578, -1.53894412120922, 218, 57, 'PPL', 'P'),
(78372, 'Graham Crossing', 39.9883308410645, 0.697928035553368, -79.6616668701172, -1.39035837451043, 218, 45, 'PPL', 'P'),
(109434, 'Graham Heights', 39.4755592346191, 0.688978482710157, -80.1061096191406, -1.3981153638175, 218, 58, 'PPL', 'P'),
(36154, 'Graham Hill', 37.8233299255371, 0.660141641268724, -87.5299987792969, -1.52768667296535, 218, 21, 'PPL', 'P'),
(87353, 'Graham Mill', 36.1772193908691, 0.631411592587004, -82.5444412231445, -1.44067227856281, 218, 50, 'PPL', 'P'),
(102360, 'Graham Park Shores', 38.5513916015625, 0.672848714672956, -77.3111114501953, -1.3493334431822, 218, 53, 'PPL', 'P'),
(193601, 'Graham Place', 40.4266700744629, 0.705578498416839, -123.406936645508, -2.15385736426416, 218, 6, 'PPL', 'P'),
(207534, 'Graham Point', 47.2477798461914, 0.82462932257346, -122.936668395996, -2.14564963494259, 218, 56, 'PPL', 'P'),
(29916, 'Graham Valley', 38.1494407653809, 0.665833349150442, -87.2905578613281, -1.5235076405828, 218, 19, 'PPL', 'P'),
(122704, 'Graham Woods', 41.6175003051758, 0.726362406775062, -87.0272216796875, -1.51891155717354, 218, 19, 'PPL', 'P'),
(207535, 'Grahams', 48.0922203063965, 0.839367588941095, -117.17138671875, -2.04502648736974, 218, 56, 'PPL', 'P'),
(81284, 'Grahams Crossroads', 34.0194396972656, 0.593751232400948, -78.8088912963867, -1.37547463296825, 218, 48, 'PPL', 'P'),
(102361, 'Grahams Forge', 36.9397201538086, 0.644719741449266, -80.8850021362305, -1.41170960275987, 218, 53, 'PPL', 'P'),
(47577, 'Grahams Green Acres', 39.4949989318848, 0.689317769433033, -77.0580596923828, -1.34491685683041, 218, 25, 'PPL', 'P'),
(207536, 'Grahams Landing', 46.2205581665039, 0.806700922115047, -116.958892822266, -2.0413177692357, 218, 56, 'PPL', 'P'),
(196622, 'Grahams Place', 44.8588905334473, 0.78293533860037, -111.58332824707, -1.94749646824497, 218, 31, 'PPL', 'P'),
(16257, 'Grahamsville', 29.2316703796387, 0.510188893982396, -81.9663925170898, -1.43058342540526, 218, 12, 'PPL', 'P'),
(72706, 'Grahamsville', 38.958610534668, 0.679956025832105, -82.7094421386719, -1.44355208780756, 218, 41, 'PPL', 'P'),
(149216, 'Grahamsville', 41.8477783203125, 0.730381516334155, -74.5483322143555, -1.30111384901106, 218, 40, 'PPL', 'P'),
(36155, 'Grahamton', 37.9027786254883, 0.661528282669301, -86.0255584716797, -1.50142923619771, 218, 21, 'PPL', 'P'),
(47578, 'Grahamtown', 39.646110534668, 0.691955164439566, -78.9222183227539, -1.37745256270985, 218, 25, 'PPL', 'P'),
(36156, 'Grahamville', 37.1074981689453, 0.647648020225863, -88.7799987792969, -1.54950328861528, 218, 21, 'PPL', 'P'),
(81286, 'Grahamville', 32.4738883972168, 0.566776273456617, -80.9636077880859, -1.41308153019542, 218, 48, 'PPL', 'P'),
(172061, 'Grahamville', 43.4197196960449, 0.757817068989015, -72.7072219848633, -1.26898041361427, 218, 55, 'PPL', 'P'),
(162170, 'Grahms', 41.0561103820801, 0.716564304229525, -80.3202819824219, -1.40185337672354, 218, 45, 'PPL', 'P'),
(36157, 'Grahn', 38.2836112976074, 0.668175066696948, -83.0752792358398, -1.44993714967908, 218, 21, 'PPL', 'P'),
(55019, 'Grain Valley', 39.0149993896484, 0.680940197012943, -94.1983337402344, -1.64407107365955, 218, 29, 'PPL', 'P'),
(187689, 'Grainfield', 39.1136093139648, 0.682661264867407, -100.464721679688, -1.75344017541027, 218, 20, 'PPL', 'P'),
(65131, 'Graingers', 35.3197212219238, 0.616445426209086, -77.5102767944336, -1.35280953419502, 218, 33, 'PPL', 'P'),
(181865, 'Graino', 39.035831451416, 0.681303785080766, -121.961112976074, -2.12862298082928, 218, 6, 'PPL', 'P'),
(75961, 'Grainola', 36.9372215270996, 0.644676132186416, -96.6502838134766, -1.68686567553215, 218, 42, 'PPL', 'P'),
(72707, 'Grainthorpe (historical)', 39.273609161377, 0.685453789007437, -84.4330596923828, -1.47363488916499, 218, 41, 'PPL', 'P'),
(199354, 'Grainton', 40.8230590820313, 0.712496791717619, -101.28694152832, -1.76779061894417, 218, 35, 'PPL', 'P'),
(75962, 'Grainville', 36.8400001525879, 0.642979299097872, -97.2280578613281, -1.69694973499973, 218, 42, 'PPL', 'P'),
(195015, 'Grainville', 44.0272216796875, 0.768419978815975, -111.367218017578, -1.94372463319309, 218, 17, 'PPL', 'P'),
(135638, 'Grainwood', 44.7222213745117, 0.780550011791014, -93.4391708374023, -1.63082118144614, 218, 28, 'PPL', 'P'),
(188626, 'Grama', 32.7427787780762, 0.571469295929555, -107.031669616699, -1.86805503871818, 218, 38, 'PPL', 'P'),
(41142, 'Grambling', 32.5275001525879, 0.567711975105617, -92.7138900756836, -1.61816264415277, 218, 22, 'PPL', 'P'),
(41143, 'Grambling Corners', 32.5058288574219, 0.567333739651798, -92.7177810668945, -1.61823055476057, 218, 22, 'PPL', 'P'),
(41144, 'Gramercy', 30.0472202301025, 0.524422924087138, -90.6897201538086, -1.58283421439622, 218, 22, 'PPL', 'P'),
(16258, 'Gramercy Park', 26.7616691589355, 0.467079240152847, -80.1205596923828, -1.39836756517274, 218, 12, 'PPL', 'P'),
(162171, 'Gramere', 40.524169921875, 0.707280191774372, -77.2191696166992, -1.34772875546737, 218, 45, 'PPL', 'P'),
(81287, 'Gramling', 35.0766716003418, 0.612203410066753, -82.1327819824219, -1.43348746941594, 218, 48, 'PPL', 'P'),
(209478, 'Gramm', 41.038330078125, 0.716253979383503, -106.128608703613, -1.85229365243876, 218, 59, 'PPL', 'P'),
(29918, 'Grammer', 39.1527786254883, 0.68334489831923, -85.7249984741211, -1.49618347464053, 218, 19, 'PPL', 'P'),
(162172, 'Grampian', 40.9658317565918, 0.714988644970579, -78.6133270263672, -1.37206139255715, 218, 45, 'PPL', 'P'),
(155501, 'Grampian Hills', 40.5063896179199, 0.706969866928351, -81.1361083984375, -1.41609223380776, 218, 41, 'PPL', 'P'),
(162173, 'Grampian Hills', 41.2594413757324, 0.72011309954011, -77.0033264160156, -1.3439615809474, 218, 45, 'PPL', 'P'),
(192592, 'Gramse', 38.7905616760254, 0.677023019944573, -112.042221069336, -1.95550565890727, 218, 52, 'PPL', 'P'),
(188627, 'Gran Quivira', 34.2636108398438, 0.598012822777293, -106.101387023926, -1.85181854450029, 218, 38, 'PPL', 'P'),
(13837, 'Gran-ville', 38.6369400024414, 0.674341815938108, -75.2969436645508, -1.3141795836351, 218, 10, 'PPL', 'P'),
(21520, 'Granada', 33.6441688537598, 0.587201520595035, -84.5313873291016, -1.47535103017144, 218, 13, 'PPL', 'P'),
(32578, 'Granada', 39.7200012207031, 0.693244800197436, -95.793327331543, -1.6719089633761, 218, 20, 'PPL', 'P'),
(55020, 'Granada', 37.0277786254883, 0.646256651714351, -92.7363891601563, -1.61855532725551, 218, 29, 'PPL', 'P'),
(135639, 'Granada', 43.6955604553223, 0.762631398449606, -94.3475036621094, -1.64667457994122, 218, 28, 'PPL', 'P'),
(186784, 'Granada', 38.0638885498047, 0.664340181306261, -102.309997558594, -1.78564631510482, 218, 7, 'PPL', 'P'),
(94565, 'Granada Estates Colonia', 26.3080005645752, 0.459161229468364, -98.2590026855469, -1.71494311658874, 218, 51, 'PPL', 'P'),
(181866, 'Granada Hills', 34.264720916748, 0.598032197274223, -118.522216796875, -2.068602919868, 218, 6, 'PPL', 'P'),
(13834, 'Granada Mobile Home Park', 39.0541687011719, 0.681623830464767, -75.5016708374023, -1.31775274686966, 218, 10, 'PPL', 'P'),
(115793, 'Granada Mobile Home Park', 42.5666694641113, 0.742928533756873, -90.7216720581055, -1.58339188032848, 218, 16, 'PPL', 'P'),
(113486, 'Granbrook Park', 41.9361114501953, 0.731923220289202, -72.771110534668, -1.27009547916269, 218, 8, 'PPL', 'P'),
(94566, 'Granbury', 32.4419403076172, 0.566218674103382, -97.7938919067383, -1.70682540211202, 218, 51, 'PPL', 'P'),
(55021, 'Granby', 36.9191703796387, 0.64436108022946, -94.254997253418, -1.64506003853036, 218, 29, 'PPL', 'P'),
(113487, 'Granby', 41.9538917541504, 0.732233545135224, -72.7891693115234, -1.2704106642777, 218, 8, 'PPL', 'P'),
(124951, 'Granby', 42.2563896179199, 0.737513128838251, -72.5166702270508, -1.26565465804498, 218, 23, 'PPL', 'P'),
(172062, 'Granby', 44.5705604553223, 0.777903029404557, -71.7591705322266, -1.25243379428745, 218, 55, 'PPL', 'P'),
(194215, 'Granby', 40.086109161377, 0.699634589179891, -105.938888549805, -1.84898241109741, 218, 7, 'PPL', 'P'),
(149217, 'Granby Center', 43.3266716003418, 0.756193073356285, -76.4663925170898, -1.33459031654557, 218, 40, 'PPL', 'P'),
(55022, 'Granby City', 36.9416694641113, 0.644753763332192, -94.2694396972656, -1.64531210672753, 218, 29, 'PPL', 'P'),
(47579, 'Granby Woods', 39.1630592346191, 0.683524328797674, -77.1175003051758, -1.34595429123305, 218, 25, 'PPL', 'P'),
(36158, 'Grancer', 37.3088912963867, 0.651162993390604, -86.5461120605469, -1.51051461025652, 218, 21, 'PPL', 'P'),
(2804, 'Grand Acres', 31.2755603790283, 0.54586150402033, -85.4430618286133, -1.49126275189439, 218, 2, 'PPL', 'P'),
(94567, 'Grand Acres', 26.2433300018311, 0.458032515219361, -97.8266677856445, -1.70739744911417, 218, 51, 'PPL', 'P'),
(41145, 'Grand Annse', 30.3427791595459, 0.529581400539594, -91.79638671875, -1.60214918967618, 218, 22, 'PPL', 'P'),
(2805, 'Grand Bay', 30.476110458374, 0.531908470700105, -88.3422164916992, -1.54186254628979, 218, 2, 'PPL', 'P'),
(41148, 'Grand Bayou', 32.086669921875, 0.56001803613735, -93.4730606079102, -1.63141266952424, 218, 22, 'PPL', 'P'),
(41149, 'Grand Bayou Village (historical)', 29.562780380249, 0.515967853679327, -89.8163909912109, -1.5675917450552, 218, 22, 'PPL', 'P'),
(127599, 'Grand Beach', 43.5377807617188, 0.759877623303437, -70.3513870239258, -1.22786333691232, 218, 26, 'PPL', 'P'),
(131054, 'Grand Beach', 41.7733306884766, 0.729082160038306, -86.7975006103516, -1.51490216815242, 218, 27, 'PPL', 'P'),
(131055, 'Grand Blanc', 42.9275016784668, 0.749226243944638, -83.629997253418, -1.45961880550596, 218, 27, 'PPL', 'P'),
(94568, 'Grand Bluff', 32.271671295166, 0.56324691922199, -94.3430633544922, -1.6465970819535, 218, 51, 'PPL', 'P'),
(41150, 'Grand Cane', 32.0838890075684, 0.559969500026484, -93.8099975585938, -1.6372933286853, 218, 22, 'PPL', 'P'),
(94569, 'Grand Cane', 30.3208293914795, 0.529198304816786, -94.7502822875977, -1.65370439311264, 218, 51, 'PPL', 'P'),
(178270, 'Grand Canyon', 36.0544395446777, 0.629268680015872, -112.138610839844, -1.95718797776788, 218, 5, 'PPL', 'P'),
(178271, 'Grand Canyon Caverns', 35.5283317565918, 0.620086366893387, -113.230560302734, -1.9762460911607, 218, 5, 'PPL', 'P'),
(178272, 'Grand Canyon Village', 36.0463905334473, 0.62912819826837, -112.153327941895, -1.95744483965502, 218, 5, 'PPL', 'P'),
(162175, 'Grand Central', 40.8441696166992, 0.712865240054432, -75.2644424438477, -1.31361233032291, 218, 45, 'PPL', 'P'),
(27300, 'Grand Chain', 37.2516708374023, 0.650164307981824, -89.0233306884766, -1.55375023160563, 218, 18, 'PPL', 'P'),
(41151, 'Grand Chenier', 29.7666702270508, 0.519526402817404, -92.9749984741211, -1.62271984541012, 218, 22, 'PPL', 'P'),
(41152, 'Grand Coteau', 30.4197196960449, 0.530924266229753, -92.04638671875, -1.60651251280617, 218, 22, 'PPL', 'P'),
(207537, 'Grand Coulee', 47.9416694641113, 0.836739981051568, -119.002220153809, -2.07698055886711, 218, 56, 'PPL', 'P'),
(16259, 'Grand Crossing', 30.3586101531982, 0.529857703502689, -81.7211074829102, -1.42630239395296, 218, 12, 'PPL', 'P'),
(174310, 'Grand Crossing', 43.8452796936035, 0.765244492111192, -91.2294387817383, -1.59225408148794, 218, 57, 'PPL', 'P'),
(119828, 'Grand Detour', 41.896671295166, 0.731234859726444, -89.4116668701172, -1.56052797657988, 218, 18, 'PPL', 'P'),
(41153, 'Grand Ecore', 31.815559387207, 0.555286264670552, -93.084716796875, -1.62463479139194, 218, 22, 'PPL', 'P'),
(55024, 'Grand Eddy', 37.7550010681152, 0.658949077732587, -89.6861114501953, -1.56531793811649, 218, 29, 'PPL', 'P'),
(135642, 'Grand Falls', 48.1986083984375, 0.841224411432125, -93.7925033569336, -1.63698799726633, 218, 28, 'PPL', 'P'),
(55025, 'Grand Falls Plaza', 37.0361099243164, 0.646402060309869, -94.5347213745117, -1.64994214544069, 218, 29, 'PPL', 'P'),
(140116, 'Grand Forks', 47.9252815246582, 0.836453957550494, -97.0325012207031, -1.69353662774669, 218, 34, 'PPL', 'P'),
(9173, 'Grand Glaise', 35.4749984741211, 0.619155525513377, -91.4097213745117, -1.59540060631587, 218, 4, 'PPL', 'P'),
(149220, 'Grand Gorge', 42.357780456543, 0.739282732803582, -74.5088882446289, -1.30042542186927, 218, 40, 'PPL', 'P'),
(60087, 'Grand Gulf', 32.0330581665039, 0.559082334488351, -91.0524978637695, -1.58916587988788, 218, 30, 'PPL', 'P'),
(140120, 'Grand Harbor', 48.1697196960449, 0.840720208458746, -98.98388671875, -1.72759472966327, 218, 34, 'PPL', 'P'),
(131058, 'Grand Haven', 43.063060760498, 0.751592196257064, -86.2283325195313, -1.50496831097032, 218, 27, 'PPL', 'P'),
(16260, 'Grand Island', 28.8822193145752, 0.504089822322437, -81.7291717529297, -1.42644314201657, 218, 12, 'PPL', 'P'),
(141932, 'Grand Island', 40.9249992370605, 0.714275983062874, -98.341667175293, -1.71638588410929, 218, 35, 'PPL', 'P'),
(181867, 'Grand Island', 39.0661087036133, 0.681832222820065, -121.867218017578, -2.1269842046525, 218, 6, 'PPL', 'P'),
(186785, 'Grand Island (historical)', 39.9708290100098, 0.697622570976336, -105.602783203125, -1.8431162661643, 218, 7, 'PPL', 'P'),
(41155, 'Grand Isle', 29.2363891601563, 0.510271252239106, -89.9872207641602, -1.5705732870536, 218, 22, 'PPL', 'P'),
(127600, 'Grand Isle', 47.3052787780762, 0.825632868251229, -68.1524963378906, -1.18948545454957, 218, 26, 'PPL', 'P'),
(172064, 'Grand Isle', 44.7224998474121, 0.780554872060003, -73.2927780151367, -1.27920029429745, 218, 55, 'PPL', 'P'),
(172066, 'Grand Isle Station', 44.7005615234375, 0.780171976074277, -73.329719543457, -1.27984504559736, 218, 55, 'PPL', 'P'),
(87355, 'Grand Junction', 35.0488891601563, 0.611718515011277, -89.1869430541992, -1.55660580608446, 218, 50, 'PPL', 'P'),
(115778, 'Grand Junction', 42.0316696166992, 0.733591024921864, -94.2405624389648, -1.64480810349123, 218, 16, 'PPL', 'P'),
(131062, 'Grand Junction', 42.4041709899902, 0.740092400353993, -86.0730590820313, -1.50225827824505, 218, 27, 'PPL', 'P'),
(186786, 'Grand Junction', 39.0638885498047, 0.681793473826205, -108.550003051758, -1.89455495630307, 218, 7, 'PPL', 'P'),
(195016, 'Grand Junction', 47.7291717529297, 0.833031196338497, -116.972778320313, -2.0415601168949, 218, 17, 'PPL', 'P'),
(9174, 'Grand Lake', 33.0922203063965, 0.577568201141945, -91.210563659668, -1.59192464846109, 218, 4, 'PPL', 'P'),
(41154, 'Grand Lake', 30.0305595397949, 0.524132140185614, -93.2719421386719, -1.62790249004947, 218, 22, 'PPL', 'P'),
(135644, 'Grand Lake', 46.8666687011719, 0.817977678276824, -92.4677810668945, -1.61386723163058, 218, 28, 'PPL', 'P'),
(194217, 'Grand Lake', 40.2522201538086, 0.702533772921578, -105.82250213623, -1.84695108497595, 218, 7, 'PPL', 'P'),
(155503, 'Grand Lake Mobile Home Park', 40.5033302307129, 0.706916470548494, -84.5361099243164, -1.47543345500718, 218, 41, 'PPL', 'P'),
(127602, 'Grand Lake Stream', 45.1794395446777, 0.788529974260354, -67.7750015258789, -1.18289692717077, 218, 26, 'PPL', 'P'),
(75963, 'Grand Lake Towne', 36.5041694641113, 0.637117947854717, -95.022216796875, -1.65845054564933, 218, 42, 'PPL', 'P'),
(131063, 'Grand Ledge', 42.7533302307129, 0.746186378718367, -84.7463912963867, -1.47910355730541, 218, 27, 'PPL', 'P'),
(131065, 'Grand Marais', 46.6708297729492, 0.814559644175761, -85.9850006103516, -1.50072136797997, 218, 27, 'PPL', 'P'),
(135646, 'Grand Marais', 47.750560760498, 0.833404504944298, -90.3341674804688, -1.57662864958217, 218, 28, 'PPL', 'P'),
(174311, 'Grand Marsh', 43.8869400024414, 0.765971601667811, -89.7061080932617, -1.56566694537735, 218, 57, 'PPL', 'P'),
(135648, 'Grand Meadow', 43.7058296203613, 0.762810629190969, -92.5719375610352, -1.61568510539067, 218, 28, 'PPL', 'P'),
(47580, 'Grand Meadows', 39.7180595397949, 0.693210911472565, -75.8005599975586, -1.3229693468129, 218, 25, 'PPL', 'P'),
(186787, 'Grand Mesa', 39.0402793884277, 0.681381416226542, -107.949172973633, -1.88406849319477, 218, 7, 'PPL', 'P'),
(178274, 'Grand Missouri Adult Mobile Home Park', 33.5183296203613, 0.585005211644046, -112.152778625488, -1.95743525227509, 218, 5, 'PPL', 'P'),
(115781, 'Grand Mound', 41.8241691589355, 0.729969458734493, -90.6477813720703, -1.58210224457061, 218, 16, 'PPL', 'P'),
(207538, 'Grand Mound', 46.7880592346191, 0.816605684262242, -123.01000213623, -2.14692955016248, 218, 56, 'PPL', 'P'),
(16261, 'Grand Park', 30.3527793884277, 0.529755937459535, -81.6994400024414, -1.42592422507817, 218, 12, 'PPL', 'P'),
(27302, 'Grand Pass', 39.4577789306641, 0.688668157864135, -90.5961074829102, -1.58120036506745, 218, 18, 'PPL', 'P'),
(55026, 'Grand Pass', 39.2063903808594, 0.68428059996823, -93.442497253418, -1.6308792383579, 218, 29, 'PPL', 'P'),
(41156, 'Grand Point', 30.0611095428467, 0.524665338325362, -90.7533264160156, -1.58394435309662, 218, 22, 'PPL', 'P'),
(55028, 'Grand Port', 39.3958282470703, 0.687586914461563, -93.1133270263672, -1.62513413409633, 218, 29, 'PPL', 'P'),
(135652, 'Grand Portage', 47.9638900756836, 0.837127803885311, -89.6847229003906, -1.56529370335057, 218, 28, 'PPL', 'P'),
(41157, 'Grand Prairie', 30.6830596923828, 0.535520416218039, -92.1474990844727, -1.60827725650251, 218, 22, 'PPL', 'P'),
(94570, 'Grand Prairie', 32.7458305358887, 0.571522559151357, -96.9974975585938, -1.69292569859262, 218, 51, 'PPL', 'P'),
(41158, 'Grand Prairie (historical)', 29.4850006103516, 0.514610340603172, -89.686393737793, -1.56532286496451, 218, 22, 'PPL', 'P'),
(131067, 'Grand Rapids', 46.7658309936523, 0.816217728270445, -89.2755584716797, -1.55815243688753, 218, 27, 'PPL', 'P'),
(135655, 'Grand Rapids', 47.2372207641602, 0.824445031826027, -93.5299987792969, -1.63240642808501, 218, 28, 'PPL', 'P'),
(140123, 'Grand Rapids', 46.4444389343262, 0.810608378645438, -98.3702774047852, -1.71688522681368, 218, 34, 'PPL', 'P'),
(155505, 'Grand Rapids', 41.4119415283203, 0.722774729312562, -83.8644409179688, -1.46371061936281, 218, 41, 'PPL', 'P'),
(200907, 'Grand Rapids', 45.9013900756836, 0.801130388062928, -123.502777099609, -2.15553009574484, 218, 43, 'PPL', 'P'),
(16262, 'Grand Ridge', 30.7122192382813, 0.536029346302353, -85.0202789306641, -1.48388379830405, 218, 12, 'PPL', 'P'),
(119831, 'Grand Ridge', 41.2369384765625, 0.71972034985835, -88.8313903808594, -1.55040024127042, 218, 18, 'PPL', 'P'),
(41159, 'Grand River', 30.226390838623, 0.527550041128622, -91.418327331543, -1.59555080860135, 218, 22, 'PPL', 'P'),
(115782, 'Grand River', 40.8194389343262, 0.712433608220757, -93.9622192382813, -1.63995009818877, 218, 16, 'PPL', 'P'),
(155507, 'Grand River', 41.7361106872559, 0.728432548469408, -81.2813873291016, -1.41862782948162, 218, 41, 'PPL', 'P'),
(55029, 'Grand River City (historical)', 39.3880615234375, 0.687451359562078, -93.0955581665039, -1.62482400898739, 218, 29, 'PPL', 'P'),
(36159, 'Grand Rivers', 37.003059387207, 0.645825219617758, -88.2344436645508, -1.53998155561186, 218, 21, 'PPL', 'P'),
(200908, 'Grand Ronde', 45.0602798461914, 0.786450245186084, -123.608062744141, -2.15736767689699, 218, 43, 'PPL', 'P'),
(200909, 'Grand Ronde Agency', 45.0800018310547, 0.786794458756977, -123.610557556152, -2.15741121958081, 218, 43, 'PPL', 'P'),
(94571, 'Grand Saline', 32.6733283996582, 0.570257158159405, -95.7091674804688, -1.67044009687687, 218, 51, 'PPL', 'P'),
(70886, 'Grand Sprute', 39.7613906860352, 0.69396718264312, -75.3380584716797, -1.31489717239082, 218, 37, 'PPL', 'P'),
(32581, 'Grand Summit', 37.3680610656738, 0.652195700682309, -96.54638671875, -1.68505232914591, 218, 20, 'PPL', 'P'),
(102362, 'Grand Summit', 37.5311088562012, 0.655041421465113, -77.5580596923828, -1.35364350309038, 218, 53, 'PPL', 'P'),
(181868, 'Grand Terrace', 34.0338897705078, 0.594003433756179, -117.312782287598, -2.04749430559386, 218, 6, 'PPL', 'P'),
(27304, 'Grand Tower', 37.6263885498047, 0.656704365828786, -89.4977798461914, -1.56203093154106, 218, 18, 'PPL', 'P'),
(131071, 'Grand Valley', 42.9744415283203, 0.750045498874973, -85.8697204589844, -1.49870934977641, 218, 27, 'PPL', 'P'),
(162176, 'Grand Valley', 41.7211112976074, 0.728170759734253, -79.5377807617188, -1.3881961540214, 218, 45, 'PPL', 'P'),
(47581, 'Grand Valley Acres', 39.7050018310547, 0.692983011462282, -76.9691696166992, -1.34336543233738, 218, 25, 'PPL', 'P'),
(47582, 'Grand View', 39.3969383239746, 0.687606288958493, -76.9588928222656, -1.34318606843797, 218, 25, 'PPL', 'P'),
(102363, 'Grand View', 37.0777816772461, 0.64712936960357, -76.2758331298828, -1.33126442781823, 218, 53, 'PPL', 'P'),
(131074, 'Grand View', 41.8419418334961, 0.73027965042246, -83.4027786254883, -1.45565309232672, 218, 27, 'PPL', 'P'),
(162177, 'Grand View', 40.0374984741211, 0.698786172635619, -78.7583312988281, -1.37459219454105, 218, 45, 'PPL', 'P'),
(174313, 'Grand View', 46.3675003051758, 0.809265546244793, -91.1080627441406, -1.59013566999883, 218, 57, 'PPL', 'P'),
(178273, 'Grand View', 34.4197196960449, 0.600737436309526, -112.82250213623, -1.96912413261556, 218, 5, 'PPL', 'P'),
(195017, 'Grand View', 42.9897193908691, 0.750312147879118, -116.092498779297, -2.02619634056623, 218, 17, 'PPL', 'P'),
(41160, 'Grand View (historical)', 30.0283298492432, 0.524093224744186, -90.720832824707, -1.58337723294249, 218, 22, 'PPL', 'P'),
(131075, 'Grand View Acres', 42.4261093139648, 0.740475296339719, -83.4466705322266, -1.45641915061428, 218, 27, 'PPL', 'P'),
(131076, 'Grand View Beach', 45.4569396972656, 0.7933732655978, -84.585563659668, -1.47629658551647, 218, 27, 'PPL', 'P'),
(149222, 'Grand View Beach', 43.297779083252, 0.755688803803879, -77.6833267211914, -1.35582982518728, 218, 40, 'PPL', 'P'),
(124953, 'Grand View Estates', 42.0900001525879, 0.734609084827574, -71.8983306884766, -1.2548625972016, 218, 23, 'PPL', 'P'),
(186788, 'Grand View Estates', 39.5436096191406, 0.690166185977305, -104.820556640625, -1.82946383715211, 218, 7, 'PPL', 'P'),
(16263, 'Grand View Grove', 29.521110534668, 0.51524057767514, -81.6786117553711, -1.42556070358937, 218, 12, 'PPL', 'P'),
(135657, 'Grand View Heights', 46.6133308410645, 0.813556098497992, -95.5227813720703, -1.66718704560533, 218, 28, 'PPL', 'P'),
(149223, 'Grand View Heights', 43.295280456543, 0.755645194541029, -77.6936111450195, -1.35600932224475, 218, 40, 'PPL', 'P'),
(162178, 'Grand View Heights', 40.1349983215332, 0.700487865993152, -75.3280563354492, -1.31472260218136, 218, 45, 'PPL', 'P'),
(135658, 'Grand View Mobile Park', 44.5625, 0.777762347919973, -92.6172180175781, -1.61647539844415, 218, 28, 'PPL', 'P'),
(47583, 'Grand View Park', 39.103889465332, 0.682491621505969, -76.6875, -1.33844937012315, 218, 25, 'PPL', 'P'),
(65133, 'Grand View Park', 35.8863906860352, 0.62633567412834, -81.5774993896484, -1.42379595989303, 218, 33, 'PPL', 'P'),
(190272, 'Grand View Terrace', 39.6097183227539, 0.691320000519582, -119.855003356934, -2.09186443356735, 218, 39, 'PPL', 'P'),
(115787, 'Grand View Village', 41.9527816772461, 0.732214170638293, -91.7444381713867, -1.60124251648306, 218, 16, 'PPL', 'P'),
(149224, 'Grand View-on-Hudson', 41.0638885498047, 0.716700058866091, -73.9208297729492, -1.29016186534422, 218, 40, 'PPL', 'P'),
(124954, 'Grand Vue', 41.6372184753418, 0.726706553766928, -70.8052825927734, -1.23578530904892, 218, 23, 'PPL', 'P'),
(2807, 'Grandberry Crossroads', 31.3541698455811, 0.547233498034912, -85.2286071777344, -1.48751981214034, 218, 2, 'PPL', 'P'),
(41161, 'Grandbois', 29.5524997711182, 0.515788423200883, -90.5380630493164, -1.58018729858879, 218, 22, 'PPL', 'P'),
(188628, 'Grande', 36.6705589294434, 0.640021991865394, -103.773887634277, -1.81119601681277, 218, 38, 'PPL', 'P'),
(94572, 'Grande Acres Colonia', 26.2439994812012, 0.458044199838644, -97.8280029296875, -1.70742075177371, 218, 51, 'PPL', 'P'),
(41162, 'Grande Ecaille', 29.3788890838623, 0.512758345091618, -89.7805633544922, -1.56696643483125, 218, 22, 'PPL', 'P'),
(181869, 'Grande Mobile Manor Mobile Home Park', 35.1072196960449, 0.612736574916987, -120.589172363281, -2.10467809999421, 218, 6, 'PPL', 'P'),
(131077, 'Grande Pointe', 42.5994415283203, 0.743500514179995, -82.545280456543, -1.4406869259488, 218, 27, 'PPL', 'P'),
(191545, 'Grandfalls', 31.3391704559326, 0.546971709299757, -102.851387023926, -1.79509534381048, 218, 51, 'PPL', 'P'),
(65134, 'Grandfather', 36.0988883972168, 0.630044458841412, -81.8477783203125, -1.42851321713189, 218, 33, 'PPL', 'P'),
(9175, 'Grandfield', 34.2183303833008, 0.597222529723812, -93.9116668701172, -1.63906779291962, 218, 4, 'PPL', 'P'),
(75966, 'Grandfield', 34.228328704834, 0.597397033354239, -98.6841735839844, -1.72236374865014, 218, 42, 'PPL', 'P'),
(16264, 'Grandin', 29.7275009155273, 0.518842769365581, -81.9186096191406, -1.4297494565099, 218, 12, 'PPL', 'P'),
(55034, 'Grandin', 36.8291702270508, 0.642790281239504, -90.8227767944336, -1.58515649086677, 218, 29, 'PPL', 'P'),
(65135, 'Grandin', 36.0438919067383, 0.62908458900552, -81.4161071777344, -1.42097913440805, 218, 33, 'PPL', 'P'),
(140127, 'Grandin', 47.2369384765625, 0.82444010497801, -97.001106262207, -1.6929886823524, 218, 34, 'PPL', 'P'),
(145312, 'Grandin', 40.6175003051758, 0.708909114255119, -74.9341735839844, -1.30784805130149, 218, 37, 'PPL', 'P'),
(102364, 'Grandin Court', 37.2486114501953, 0.650110911601968, -79.9886093139648, -1.39606459662009, 218, 53, 'PPL', 'P'),
(87356, 'Grandiose Field', 36.1897201538086, 0.631629772059309, -85.5713882446289, -1.49350247037115, 218, 50, 'PPL', 'P'),
(195018, 'Grandjean', 44.1602783203125, 0.770742255286524, -115.16667175293, -2.01003761065217, 218, 17, 'PPL', 'P'),
(41163, 'Grandstaff', 31.7744407653809, 0.554568609335803, -92.3627777099609, -1.61203457732645, 218, 22, 'PPL', 'P'),
(204129, 'Granduer Estates', 40.6194381713867, 0.708942936400963, -111.836387634277, -1.95191318775481, 218, 52, 'PPL', 'P'),
(2806, 'Grandview', 34.127498626709, 0.595637216505915, -86.9061126708984, -1.51679780621634, 218, 2, 'PPL', 'P'),
(9177, 'Grandview', 35.3530616760254, 0.617027326907268, -92.5972213745117, -1.6161263911833, 218, 4, 'PPL', 'P'),
(16265, 'Grandview', 29.6994400024414, 0.518353014041115, -81.5997161865234, -1.42418371614775, 218, 12, 'PPL', 'P'),
(21521, 'Grandview', 34.4955596923828, 0.602061093950322, -84.3938903808594, -1.47295125571317, 218, 13, 'PPL', 'P'),
(32582, 'Grandview', 39.0672187805176, 0.681851597316996, -94.898063659668, -1.65628366462839, 218, 20, 'PPL', 'P'),
(36162, 'Grandview', 36.7194404602051, 0.6408751355206, -85.6872177124023, -1.49552407595462, 218, 21, 'PPL', 'P'),
(55035, 'Grandview', 38.8858299255371, 0.678685764571164, -94.5327835083008, -1.64990832329485, 218, 29, 'PPL', 'P'),
(65136, 'Grandview', 35.1674995422363, 0.613788656705623, -84.045280456543, -1.46686686472872, 218, 33, 'PPL', 'P'),
(72711, 'Grandview', 39.5080604553223, 0.689545736022344, -81.0822219848633, -1.4151517384688, 218, 41, 'PPL', 'P'),
(87361, 'Grandview', 35.7436103820801, 0.623843687717326, -84.8399963378906, -1.48073727347612, 218, 50, 'PPL', 'P'),
(102372, 'Grandview', 37.271671295166, 0.650513381821706, -80.0458297729492, -1.39706328202887, 218, 53, 'PPL', 'P'),
(109436, 'Grandview', 37.8250007629395, 0.660170802882661, -81.0688934326172, -1.41491911134758, 218, 58, 'PPL', 'P'),
(112304, 'Grandview', 39.5411109924316, 0.690122576714455, -87.8461074829102, -1.53320381063761, 218, 18, 'PPL', 'P'),
(115788, 'Grandview', 41.2758293151855, 0.720399123041184, -91.1883316040039, -1.59153662589027, 218, 16, 'PPL', 'P'),
(122707, 'Grandview', 40.1183280944824, 0.700196915644061, -85.7083282470703, -1.49589252429144, 218, 19, 'PPL', 'P'),
(145313, 'Grandview', 40.5830612182617, 0.708308038797088, -74.5838928222656, -1.3017344987031, 218, 37, 'PPL', 'P'),
(162194, 'Grandview', 40.8197212219238, 0.712438535068774, -79.5119400024414, -1.38774514769079, 218, 45, 'PPL', 'P'),
(170405, 'Grandview', 43.6438903808594, 0.761729585525478, -99.2966690063477, -1.73305381042377, 218, 49, 'PPL', 'P'),
(181870, 'Grandview', 34.8899993896484, 0.608945365368177, -117.105827331543, -2.04388226020739, 218, 6, 'PPL', 'P'),
(186789, 'Grandview', 37.2275009155273, 0.649742463265156, -107.826393127441, -1.88192558062364, 218, 7, 'PPL', 'P'),
(191546, 'Grandview', 32.9099998474121, 0.574387854168173, -101.997222900391, -1.78018736750238, 218, 51, 'PPL', 'P'),
(195019, 'Grandview', 43.0530586242676, 0.75141762604761, -112.787498474121, -1.96851320346149, 218, 17, 'PPL', 'P'),
(200910, 'Grandview', 44.5386085510254, 0.777345363472294, -121.340560913086, -2.11779230415009, 218, 43, 'PPL', 'P'),
(207539, 'Grandview', 46.2511100769043, 0.807234153544308, -119.90055847168, -2.09265952031079, 218, 56, 'PPL', 'P'),
(170406, 'Grandview (historical)', 43.3972206115723, 0.757424385886283, -98.3583297729492, -1.71667670130033, 218, 49, 'PPL', 'P'),
(162184, 'Grandview Acres', 40.2816696166992, 0.703047763011964, -76.9499969482422, -1.34303080614641, 218, 45, 'PPL', 'P'),
(172068, 'Grandview Acres', 43.6122207641602, 0.761176846441232, -72.9436111450195, -1.27310618277502, 218, 55, 'PPL', 'P'),
(204130, 'Grandview Acres', 41.1191711425781, 0.717664922129027, -112.027778625488, -1.9552535907101, 218, 52, 'PPL', 'P'),
(72712, 'Grandview Estates', 38.8280601501465, 0.67767749178246, -82.2044372558594, -1.43473808986384, 218, 41, 'PPL', 'P'),
(81288, 'Grandview Estates', 33.9238891601563, 0.592083560926341, -81.086669921875, -1.41522936961457, 218, 48, 'PPL', 'P'),
(102365, 'Grandview Estates', 38.8950004577637, 0.678845820552678, -78.2255630493164, -1.36529363443699, 218, 53, 'PPL', 'P'),
(102366, 'Grandview Gardens', 37.2855606079102, 0.650755796059931, -80.126106262207, -1.39846437107836, 218, 53, 'PPL', 'P'),
(109437, 'Grandview Gardens', 38.3936080932617, 0.670094872947759, -82.5897216796875, -1.44146257161629, 218, 58, 'PPL', 'P'),
(65137, 'Grandview Heights', 36.2188911437988, 0.632138901880705, -81.6838912963867, -1.42565284896309, 218, 33, 'PPL', 'P'),
(75967, 'Grandview Heights', 35.714168548584, 0.623329830784995, -95.3661117553711, -1.66445264495609, 218, 42, 'PPL', 'P'),
(109438, 'Grandview Heights', 38.3950004577637, 0.670119174292706, -82.3805618286133, -1.43781204355206, 218, 58, 'PPL', 'P'),
(155511, 'Grandview Heights', 40.1705589294434, 0.701108515685195, -80.7094421386719, -1.40864550276768, 218, 41, 'PPL', 'P'),
(162185, 'Grandview Heights', 40.0563888549805, 0.699115871978571, -76.2888870239258, -1.33149226124948, 218, 45, 'PPL', 'P'),
(29921, 'Grandview Lake', 39.1522216796875, 0.683335177781252, -86.04638671875, -1.50179275768651, 218, 19, 'PPL', 'P'),
(178275, 'Grandview Mobile Home Park', 33.4761085510254, 0.584268314970421, -112.011108398438, -1.95496264036101, 218, 5, 'PPL', 'P'),
(149225, 'Grandview Park', 44.3194389343262, 0.773520132040559, -76.0555572509766, -1.32741988846859, 218, 40, 'PPL', 'P'),
(32583, 'Grandview Plaza', 39.0291709899902, 0.681187538099184, -96.7888870239258, -1.68928475790832, 218, 20, 'PPL', 'P'),
(87364, 'Grandview Terrace', 36.5305595397949, 0.637578541565246, -82.1708297729492, -1.43415152863375, 218, 50, 'PPL', 'P'),
(115789, 'Grandview Village Mobile Home Park', 41.6286087036133, 0.72655628490242, -93.5486068725586, -1.63273120057994, 218, 16, 'PPL', 'P'),
(131078, 'Grandville', 42.9097213745117, 0.748915919098616, -85.7630615234375, -1.49684780017445, 218, 27, 'PPL', 'P'),
(119832, 'Grandwood Park', 42.3930587768555, 0.739898455647608, -87.9866714477539, -1.53565711463379, 218, 18, 'PPL', 'P'),
(65138, 'Grandy', 36.2419395446777, 0.632541172363361, -75.8794403076172, -1.32434606793842, 218, 33, 'PPL', 'P'),
(102368, 'Grandy', 36.8002815246582, 0.642286078266124, -77.9555587768555, -1.36058117088809, 218, 53, 'PPL', 'P'),
(135660, 'Grandy', 45.6352806091309, 0.796485901700857, -93.1949996948242, -1.62655959106979, 218, 28, 'PPL', 'P'),
(102369, 'Grandy Park', 36.8427810668945, 0.643027835208739, -76.2483291625977, -1.33078439303174, 218, 53, 'PPL', 'P'),
(149226, 'Grandyle Village', 42.9963912963867, 0.750428594597781, -78.9552764892578, -1.37802953656002, 218, 40, 'PPL', 'P'),
(464, 'Graney', 38.833610534668, 0.677774364267112, -89.9136123657227, -1.56928857814375, 218, 18, 'PPL', 'P'),
(47584, 'Grange', 39.2652816772461, 0.685308446990946, -76.4983291625977, -1.33514771616173, 218, 25, 'PPL', 'P'),
(143896, 'Grange', 44.4861106872559, 0.776429102899252, -71.5252838134766, -1.24835170096857, 218, 36, 'PPL', 'P'),
(36160, 'Grange City', 38.2444381713867, 0.667491366666098, -83.665283203125, -1.46023466150804, 218, 21, 'PPL', 'P'),
(207540, 'Grange City (historical)', 46.5499992370605, 0.812450753487555, -118.178886413574, -2.06261067425726, 218, 56, 'PPL', 'P'),
(29923, 'Grange Corner', 39.4458312988281, 0.688459632350782, -87.258056640625, -1.52294038727061, 218, 19, 'PPL', 'P'),
(127604, 'Grange Corner', 44.3383293151855, 0.77384983138351, -69.0561065673828, -1.20525642820891, 218, 26, 'PPL', 'P'),
(131080, 'Grange Corners', 42.5774993896484, 0.743117551615241, -86.190559387207, -1.50430904544247, 218, 27, 'PPL', 'P'),
(72716, 'Grange Hall', 39.6333312988281, 0.691732124698271, -83.1852798461914, -1.45185702250892, 218, 41, 'PPL', 'P'),
(119833, 'Grange Hall', 42.3638916015625, 0.739389392405239, -87.9633331298828, -1.53524978414506, 218, 18, 'PPL', 'P'),
(149227, 'Grange Landing', 42.7663917541504, 0.746414345307678, -77.3213882446289, -1.34951280708161, 218, 40, 'PPL', 'P'),
(2809, 'Grangeburg', 31.0077800750732, 0.541187856044323, -85.211669921875, -1.48722420125934, 218, 2, 'PPL', 'P'),
(94574, 'Granger', 30.7175006866455, 0.536121524965583, -97.442497253418, -1.70069240843767, 218, 51, 'PPL', 'P'),
(115792, 'Granger', 41.7611083984375, 0.72886884083499, -93.8241729736328, -1.63754073635057, 218, 16, 'PPL', 'P'),
(122705, 'Granger', 41.7533302307129, 0.728733086198424, -86.1108322143555, -1.5029175437729, 218, 19, 'PPL', 'P'),
(135662, 'Granger', 43.5022201538086, 0.759256973611394, -92.1386108398438, -1.60812212736901, 218, 28, 'PPL', 'P'),
(139184, 'Granger', 40.4677810668945, 0.706296020593533, -91.9755630493164, -1.60527640658621, 218, 29, 'PPL', 'P'),
(155513, 'Granger', 41.1555595397949, 0.718300019469984, -81.7319412231445, -1.42649147839035, 218, 41, 'PPL', 'P'),
(204135, 'Granger', 40.6966705322266, 0.710290895386707, -111.966667175293, -1.95418699469352, 218, 52, 'PPL', 'P'),
(207541, 'Granger', 46.3422203063965, 0.808824327031194, -120.186111450195, -2.09764335997477, 218, 56, 'PPL', 'P'),
(209479, 'Granger', 41.5936088562012, 0.725945422327383, -109.968063354492, -1.91930477757761, 218, 59, 'PPL', 'P'),
(115794, 'Granger Homesteads', 41.7644386291504, 0.728926964325781, -93.8388900756836, -1.63779759823771, 218, 16, 'PPL', 'P'),
(209480, 'Granger Junction', 41.5463905334473, 0.725121307128058, -109.913330078125, -1.9183495016946, 218, 59, 'PPL', 'P'),
(94575, 'Grangerland', 30.2525005340576, 0.528005741280648, -95.3291702270508, -1.66380789365619, 218, 51, 'PPL', 'P'),
(36161, 'Grangertown', 37.5508308410645, 0.655385635036006, -88.0066680908203, -1.53600612189465, 218, 21, 'PPL', 'P'),
(149229, 'Grangerville', 43.1058311462402, 0.752338680310613, -73.6216735839844, -1.28494060486906, 218, 40, 'PPL', 'P'),
(172069, 'Grangerville', 43.723331451416, 0.763116093768001, -73.0061111450195, -1.27419701355752, 218, 55, 'PPL', 'P'),
(41167, 'Grangeville', 30.7422199249268, 0.536552957062176, -90.833610534668, -1.58534557530416, 218, 22, 'PPL', 'P'),
(109439, 'Grangeville', 39.4561080932617, 0.688638996250199, -80.4063873291016, -1.40335619852667, 218, 58, 'PPL', 'P'),
(181871, 'Grangeville', 36.3436088562012, 0.634315636597681, -119.707778930664, -2.08929488258958, 218, 6, 'PPL', 'P'),
(195023, 'Grangeville', 45.9266700744629, 0.801571607276527, -116.121391296387, -2.02670061011863, 218, 17, 'PPL', 'P'),
(55036, 'Grangeville (historical)', 36.7999992370605, 0.642281151418108, -94.0774993896484, -1.64196211639232, 218, 29, 'PPL', 'P'),
(47585, 'Granite', 39.3427810668945, 0.686661066508597, -76.855827331543, -1.34138723627967, 218, 25, 'PPL', 'P'),
(75969, 'Granite', 34.9622192382813, 0.610205839512112, -99.3802795410156, -1.73451308954308, 218, 42, 'PPL', 'P'),
(87365, 'Granite', 36.1300010681152, 0.630587477387679, -84.1641693115234, -1.46894186669205, 218, 50, 'PPL', 'P'),
(102370, 'Granite', 37.5327796936035, 0.65507058307905, -77.5074996948242, -1.35276106466318, 218, 53, 'PPL', 'P'),
(115795, 'Granite', 43.4688911437988, 0.758675272650293, -96.5561065673828, -1.68522197250735, 218, 16, 'PPL', 'P'),
(143894, 'Granite', 43.6911087036133, 0.762553700724803, -71.0591735839844, -1.24021654278671, 218, 36, 'PPL', 'P'),
(149230, 'Granite', 41.7599983215332, 0.72884946633806, -74.2694396972656, -1.29624625632867, 218, 40, 'PPL', 'P'),
(186790, 'Granite', 39.0436096191406, 0.681439539717333, -106.26277923584, -1.85463536998527, 218, 7, 'PPL', 'P'),
(195022, 'Granite', 48.0877799987793, 0.839290090953373, -116.42472076416, -2.0319947080496, 218, 17, 'PPL', 'P'),
(196623, 'Granite', 46.3175010681152, 0.808392894934601, -113.243606567383, -1.9764737914339, 218, 31, 'PPL', 'P'),
(200911, 'Granite', 44.809440612793, 0.782072274670103, -118.41667175293, -2.06676081134199, 218, 43, 'PPL', 'P'),
(204140, 'Granite', 40.5730590820313, 0.708133468587633, -111.805282592773, -1.9513703023666, 218, 52, 'PPL', 'P'),
(209481, 'Granite', 41.0999984741211, 0.717330295938059, -105.157783508301, -1.83534955631924, 218, 59, 'PPL', 'P'),
(190273, 'Granite (historical)', 38.9711112976074, 0.680174205304409, -118.917503356934, -2.0755019718299, 218, 39, 'PPL', 'P'),
(178276, 'Granite Basin Summer Homes', 34.6133308410645, 0.604116588258673, -112.553329467773, -1.9644261832946, 218, 5, 'PPL', 'P'),
(181872, 'Granite Bay', 38.7633285522461, 0.676547712269021, -121.162780761719, -2.11468945516404, 218, 6, 'PPL', 'P'),
(131081, 'Granite Bluff', 45.9394416809082, 0.801794513859766, -88.0536117553711, -1.53682544340401, 218, 27, 'PPL', 'P'),
(27311, 'Granite City', 38.7013893127441, 0.675466668603531, -90.1486129760742, -1.57339011253858, 218, 18, 'PPL', 'P'),
(174315, 'Granite City (historical)', 44.6338882446289, 0.779008307835967, -88.9911117553711, -1.55318790514146, 218, 57, 'PPL', 'P'),
(178277, 'Granite Dells', 34.6058311462402, 0.603985693891095, -112.411666870117, -1.96195370453857, 218, 5, 'PPL', 'P'),
(65139, 'Granite Falls', 35.7963905334473, 0.624764875138384, -81.4308319091797, -1.42123612945325, 218, 33, 'PPL', 'P'),
(135663, 'Granite Falls', 44.810001373291, 0.782082061787109, -95.545280456543, -1.66757972870807, 218, 28, 'PPL', 'P'),
(207543, 'Granite Falls', 48.084171295166, 0.839227107193593, -121.967498779297, -2.1287344341209, 218, 56, 'PPL', 'P'),
(174316, 'Granite Heights', 45.060001373291, 0.786445384917095, -89.6394424438477, -1.56450341029709, 218, 57, 'PPL', 'P'),
(127605, 'Granite Hill', 44.3111114501953, 0.773374790024068, -69.8319396972656, -1.21879727077142, 218, 26, 'PPL', 'P'),
(181873, 'Granite Hills', 32.8030586242676, 0.572521377718191, -116.90389251709, -2.04035783282078, 218, 6, 'PPL', 'P'),
(47586, 'Granite Knoll Farms', 39.625560760498, 0.691596503219759, -76.1286087036133, -1.32869487684046, 218, 25, 'PPL', 'P'),
(199982, 'Granite Point', 40.0963897705078, 0.699814019658335, -118.579170227051, -2.06959694474487, 218, 39, 'PPL', 'P'),
(65140, 'Granite Quarry', 35.6122207641602, 0.621550506281686, -80.4469375610352, -1.40406393358636, 218, 33, 'PPL', 'P'),
(174317, 'Granite Quarry (historical)', 44.4172210693359, 0.775226752246109, -89.0677795410156, -1.55452601043117, 218, 57, 'PPL', 'P'),
(178278, 'Granite Reef Estates', 33.4391708374023, 0.58362363024954, -111.683609008789, -1.94924669771337, 218, 5, 'PPL', 'P'),
(94576, 'Granite Shoals', 30.5888900756836, 0.533876846351296, -98.3836135864258, -1.71711798709296, 218, 51, 'PPL', 'P'),
(178279, 'Granite Siding', 34.6955604553223, 0.605551765770116, -112.40860748291, -1.96190030815872, 218, 5, 'PPL', 'P'),
(102371, 'Granite Springs', 38.1883316040039, 0.666512122333276, -77.8547210693359, -1.35882122088171, 218, 53, 'PPL', 'P'),
(149231, 'Granite Springs', 41.3102798461914, 0.721000398236297, -73.7577819824219, -1.28731614456141, 218, 40, 'PPL', 'P'),
(181874, 'Granite Springs', 37.7011108398438, 0.658008515814598, -120.294723510742, -2.09953899803868, 218, 6, 'PPL', 'P'),
(55037, 'Graniteville', 37.6502799987793, 0.657121350276465, -90.6797180175781, -1.58265964418676, 218, 29, 'PPL', 'P'),
(81289, 'Graniteville', 33.5636100769043, 0.585795504697527, -81.8080596923828, -1.42781999630014, 218, 48, 'PPL', 'P'),
(113489, 'Graniteville', 41.3349990844727, 0.72143183033289, -72.154167175293, -1.25932778624328, 218, 8, 'PPL', 'P'),
(124955, 'Graniteville', 42.5958290100098, 0.743437463841187, -71.4625015258789, -1.24725594333806, 218, 23, 'PPL', 'P'),
(149232, 'Graniteville', 40.6247215270996, 0.709035148353707, -74.1488876342773, -1.29414222590945, 218, 40, 'PPL', 'P'),
(169399, 'Graniteville', 41.9680595397949, 0.732480819642438, -71.6805572509766, -1.25106173369384, 218, 47, 'PPL', 'P'),
(172070, 'Graniteville', 44.1511116027832, 0.770582265884038, -72.4933319091797, -1.26524732755625, 218, 55, 'PPL', 'P'),
(181875, 'Graniteville', 39.4408302307129, 0.688372347246055, -120.738609313965, -2.10728626680778, 218, 6, 'PPL', 'P'),
(94577, 'Granjeno', 26.1344394683838, 0.456132016886454, -98.304443359375, -1.71573620596137, 218, 51, 'PPL', 'P'),
(143895, 'Granliden', 43.4022216796875, 0.757511670991011, -72.0741729736328, -1.2579316240418, 218, 36, 'PPL', 'P'),
(36163, 'Grannie', 37.6966705322266, 0.657931017826877, -83.5827789306641, -1.45879469030663, 218, 21, 'PPL', 'P'),
(9178, 'Grannis', 34.2405586242676, 0.597610485715609, -94.334716796875, -1.64645140704187, 218, 4, 'PPL', 'P'),
(196625, 'Grannis', 45.7566719055176, 0.798604579506069, -110.495559692383, -1.92851132546601, 218, 31, 'PPL', 'P'),
(81290, 'Grannys Quarter (historical)', 34.3958282470703, 0.600320451861847, -80.6374969482422, -1.40738982231371, 218, 48, 'PPL', 'P'),
(198358, 'Grano', 48.6150016784668, 0.848491845151815, -101.586112976074, -1.77301214573543, 218, 34, 'PPL', 'P'),
(13835, 'Granogue', 39.8316688537598, 0.695193768062184, -75.586669921875, -1.31923626075488, 218, 10, 'PPL', 'P'),
(104, 'Grant', 36.6622200012207, 0.639876450111821, -81.404167175293, -1.42077074205275, 218, 53, 'PPL', 'P'),
(2811, 'Grant', 34.5286102294922, 0.602637934642434, -86.2533264160156, -1.50540453675687, 218, 2, 'PPL', 'P'),
(16266, 'Grant', 27.9286098480225, 0.487446197352905, -80.5266723632813, -1.40545556841398, 218, 12, 'PPL', 'P'),
(32586, 'Grant', 39.1186103820801, 0.682748549972134, -98.3333282470703, -1.71624034235572, 218, 20, 'PPL', 'P'),
(36164, 'Grant', 38.9636116027832, 0.680043310936832, -84.4513931274414, -1.47395486796996, 218, 21, 'PPL', 'P'),
(41164, 'Grant', 30.788330078125, 0.537357731054084, -92.9483337402344, -1.62225445800963, 218, 22, 'PPL', 'P'),
(75972, 'Grant', 33.9430618286133, 0.592418187117309, -95.5133285522461, -1.6670220627758, 218, 42, 'PPL', 'P'),
(112635, 'Grant', 35.2924995422363, 0.615970318270615, -85.2358322143555, -1.48764591281795, 218, 50, 'PPL', 'P'),
(115796, 'Grant', 41.1427803039551, 0.71807697972869, -94.9844436645508, -1.65779128012148, 218, 16, 'PPL', 'P'),
(131082, 'Grant', 43.336109161377, 0.756357789869706, -85.8108291625977, -1.4976815027537, 218, 27, 'PPL', 'P'),
(135670, 'Grant', 45.0844383239746, 0.786871890165671, -92.9102783203125, -1.62159026563376, 218, 28, 'PPL', 'P'),
(149233, 'Grant', 43.3175010681152, 0.756033017374771, -75.0608291625977, -1.31005860816431, 218, 40, 'PPL', 'P'),
(155515, 'Grant', 40.7105598449707, 0.710533309624931, -83.5680618286133, -1.4585378284195, 218, 41, 'PPL', 'P'),
(162186, 'Grant', 41.336669921875, 0.721460991946826, -78.3083267211914, -1.36673813301225, 218, 45, 'PPL', 'P'),
(181877, 'Grant', 38.5902786254883, 0.673527421276762, -122.846672058105, -2.14407890253166, 218, 6, 'PPL', 'P'),
(186791, 'Grant', 39.4597206115723, 0.688702046589006, -105.661109924316, -1.84413425949098, 218, 7, 'PPL', 'P'),
(195024, 'Grant', 43.6408309936523, 0.761676189145622, -112.012496948242, -1.95498687512693, 218, 17, 'PPL', 'P'),
(196626, 'Grant', 45.0086097717285, 0.785548432261956, -113.066108703613, -1.97337586929587, 218, 31, 'PPL', 'P'),
(199355, 'Grant', 40.8419418334961, 0.712826357902517, -101.724716186523, -1.7754312281116, 218, 35, 'PPL', 'P'),
(207544, 'Grant', 47.2555618286133, 0.824765143789054, -122.927780151367, -2.14549450580909, 218, 56, 'PPL', 'P'),
(41165, 'Grant (historical)', 31.7552795410156, 0.554234182881916, -92.3452835083008, -1.61172924590747, 218, 22, 'PPL', 'P'),
(131083, 'Grant Center', 43.7708282470703, 0.763945069236315, -85.4027786254883, -1.49055967736661, 218, 27, 'PPL', 'P'),
(29924, 'Grant City', 39.8663902282715, 0.695799770368231, -85.5425033569336, -1.49299833397679, 218, 19, 'PPL', 'P'),
(115797, 'Grant City', 42.2675018310547, 0.737707073544636, -94.8874969482422, -1.6560992407229, 218, 16, 'PPL', 'P'),
(139185, 'Grant City', 40.4874992370605, 0.706640167585399, -94.4108276367188, -1.6477797917936, 218, 29, 'PPL', 'P'),
(149234, 'Grant City', 40.5819396972656, 0.708288464563076, -74.1052780151367, -1.2933810944699, 218, 40, 'PPL', 'P'),
(162187, 'Grant City', 40.9880599975586, 0.715376600962376, -80.17138671875, -1.39925466413184, 218, 45, 'PPL', 'P'),
(190278, 'Grant City (historical)', 38.4161109924316, 0.670487622629519, -115.523887634277, -2.0162722039221, 218, 39, 'PPL', 'P'),
(149235, 'Grant Corner', 41.3188896179199, 0.721150667100804, -73.5913925170898, -1.28441210055074, 218, 40, 'PPL', 'P'),
(211855, 'Grant Creek', 65.1975021362305, 1.13791107635326, -152.927215576172, -2.66908342771136, 218, 1, 'PPL', 'P'),
(196627, 'Grant Creek (historical)', 46.9583282470703, 0.819577439143634, -114.008331298828, -1.98982075586905, 218, 31, 'PPL', 'P'),
(181878, 'Grant Grove Village', 36.7400016784668, 0.641233996477489, -118.961669921875, -2.07627282380742, 218, 6, 'PPL', 'P'),
(149236, 'Grant Hollow', 42.832218170166, 0.747563233001938, -73.626106262207, -1.28501796969873, 218, 40, 'PPL', 'P'),
(149237, 'Grant Mills', 42.084171295166, 0.734507352073933, -74.6808319091797, -1.30342640494363, 218, 40, 'PPL', 'P'),
(119834, 'Grant Park', 41.2411117553711, 0.719793187314164, -87.646110534668, -1.52971320539684, 218, 18, 'PPL', 'P'),
(2812, 'Grant Town', 33.540828704834, 0.585397894746778, -85.9499969482422, -1.5001104388259, 218, 2, 'PPL', 'P'),
(109444, 'Grant Town', 39.5580596923828, 0.690418387332535, -80.1819381713867, -1.39943882172122, 218, 58, 'PPL', 'P'),
(109445, 'Grant Valley Trailer Court', 39.1847190856934, 0.683902364514411, -80.3783264160156, -1.40286644320221, 218, 58, 'PPL', 'P'),
(102373, 'Grant Village', 37.2144393920898, 0.649514496675845, -77.4636077880859, -1.35199500637562, 218, 53, 'PPL', 'P'),
(119837, 'Grant Village', 41.8183288574219, 0.72986752624377, -87.6041717529297, -1.52898123557124, 218, 18, 'PPL', 'P'),
(27314, 'Grantfork', 38.8300018310547, 0.677711380507331, -89.6655578613281, -1.56495921031766, 218, 18, 'PPL', 'P'),
(16267, 'Grantham', 30.5066699981689, 0.532441835287421, -85.5930633544922, -1.49388077240399, 218, 12, 'PPL', 'P'),
(65142, 'Grantham', 35.2969398498535, 0.616047816258337, -78.1638870239258, -1.36421718472438, 218, 33, 'PPL', 'P'),
(143897, 'Grantham', 43.4894409179688, 0.7590339338701, -72.1380615234375, -1.25904668959022, 218, 36, 'PPL', 'P'),
(162189, 'Grantham', 40.1563911437988, 0.700861241177981, -76.9966735839844, -1.34384546712387, 218, 45, 'PPL', 'P'),
(47587, 'Grantham Hall', 38.6977806091309, 0.67540368484375, -76.6197204589844, -1.33726639396694, 218, 25, 'PPL', 'P'),
(65144, 'Granthams', 35.0699996948242, 0.612086963348089, -77.0213928222656, -1.34427689922046, 218, 33, 'PPL', 'P'),
(81291, 'Granthams Crossroads', 34.4302787780762, 0.600921727056959, -80.1236114501953, -1.39842082839454, 218, 48, 'PPL', 'P'),
(2813, 'Grantley', 33.853889465332, 0.590861835776267, -85.5461120605469, -1.49306131773657, 218, 2, 'PPL', 'P'),
(78375, 'Grantley', 39.9402809143066, 0.697089406126102, -76.7294387817383, -1.33918133994876, 218, 45, 'PPL', 'P'),
(78376, 'Grantly Hills', 39.9425010681152, 0.697128155119963, -76.7300033569336, -1.33919119364479, 218, 45, 'PPL', 'P'),
(174325, 'Granton', 44.5888900756836, 0.778222941630502, -90.4611129760742, -1.57884426645106, 218, 57, 'PPL', 'P'),
(9182, 'Grants', 33.1561088562012, 0.578683266690362, -93.6572189331055, -1.63462683864386, 218, 4, 'PPL', 'P'),
(188630, 'Grants', 35.1472206115723, 0.613434722596751, -107.850830078125, -1.88235208587221, 218, 38, 'PPL', 'P'),
(127606, 'Grants Camps', 45.1030616760254, 0.787196928976715, -70.7494430541992, -1.23481072524801, 218, 26, 'PPL', 'P'),
(87367, 'Grants Chapel', 36.0397186279297, 0.629011751549706, -83.4433288574219, -1.45636082738641, 218, 50, 'PPL', 'P'),
(36166, 'Grants Lick', 38.860279083252, 0.67823981824663, -84.3977813720703, -1.47301916632096, 218, 21, 'PPL', 'P'),
(2814, 'Grants Mill', 33.5077781677246, 0.584821054054667, -86.6497192382813, -1.51232289663668, 218, 2, 'PPL', 'P'),
(169400, 'Grants Mills', 42.0083312988281, 0.733183694433137, -71.4166717529297, -1.24645606290465, 218, 47, 'PPL', 'P'),
(200913, 'Grants Pass', 42.4391708374023, 0.74070326292903, -123.327217102051, -2.15246599575265, 218, 43, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(127607, 'Grants Turn', 44.2611083984375, 0.772502072134849, -69.1336135864258, -1.20660918088462, 218, 26, 'PPL', 'P'),
(65145, 'Grantsboro', 35.1402816772461, 0.61331361534618, -76.8427810668945, -1.34115953600647, 218, 33, 'PPL', 'P'),
(87368, 'Grantsboro', 36.3147201538086, 0.633811433624302, -84.0680618286133, -1.46726447467947, 218, 50, 'PPL', 'P'),
(27315, 'Grantsburg', 37.3908309936523, 0.652593110895976, -88.746940612793, -1.54892631476511, 218, 18, 'PPL', 'P'),
(29926, 'Grantsburg', 38.2880592346191, 0.668252697842724, -86.4694366455078, -1.50917637180875, 218, 19, 'PPL', 'P'),
(174327, 'Grantsburg', 45.7763900756836, 0.798948726497935, -92.682502746582, -1.61761483191654, 218, 57, 'PPL', 'P'),
(196628, 'Grantsdale', 46.2036094665527, 0.806405111496966, -114.140830993652, -1.99213331180162, 218, 31, 'PPL', 'P'),
(47588, 'Grantsville', 39.6949996948242, 0.692808441252827, -79.1513900756836, -1.38145236435104, 218, 25, 'PPL', 'P'),
(55044, 'Grantsville', 39.9430618286133, 0.697137942236969, -93.1133270263672, -1.62513413409633, 218, 29, 'PPL', 'P'),
(109448, 'Grantsville', 38.9233283996582, 0.679340236409051, -81.0961074829102, -1.41539408612799, 218, 58, 'PPL', 'P'),
(190277, 'Grantsville', 38.8455581665039, 0.677982889780465, -117.572219848633, -2.05202234523727, 218, 39, 'PPL', 'P'),
(204146, 'Grantsville', 40.5999984741211, 0.708603649678087, -112.463607788086, -1.96286024457364, 218, 52, 'PPL', 'P'),
(60089, 'Grantsville (historical)', 33.2383308410645, 0.580118311043751, -88.3280563354492, -1.54161540494063, 218, 30, 'PPL', 'P'),
(21522, 'Grantville', 33.2347183227539, 0.580055260704943, -84.8358306884766, -1.48066456917836, 218, 13, 'PPL', 'P'),
(32610, 'Grantville', 39.0833282470703, 0.682132760549081, -95.5611114501953, -1.66785603167116, 218, 20, 'PPL', 'P'),
(113490, 'Grantville', 41.9511108398438, 0.732185009024357, -73.1569366455078, -1.27682941513701, 218, 8, 'PPL', 'P'),
(124956, 'Grantville', 42.3125, 0.738492439750101, -71.2750015258789, -1.24398345099057, 218, 23, 'PPL', 'P'),
(149238, 'Grantville', 44.8594398498535, 0.782944925980295, -74.92138671875, -1.30762487840214, 218, 40, 'PPL', 'P'),
(162190, 'Grantville', 40.3777809143066, 0.704725221603577, -76.6466674804688, -1.33773670821545, 218, 45, 'PPL', 'P'),
(181880, 'Grantville', 32.7874984741211, 0.57224980186603, -117.096389770508, -2.04371754369397, 218, 6, 'PPL', 'P'),
(2815, 'Grantville (historical)', 34.2050018310547, 0.596989902602594, -85.4477767944336, -1.49134504357207, 218, 2, 'PPL', 'P'),
(21523, 'Grantville (historical)', 33.6352806091309, 0.587046391461537, -83.0299987792969, -1.4491468566256, 218, 13, 'PPL', 'P'),
(87369, 'Grantville (historical)', 36.454719543457, 0.636254883924449, -87.2519378662109, -1.5228335945109, 218, 50, 'PPL', 'P'),
(55046, 'Grantwood', 38.5541687011719, 0.672897184204795, -90.3450012207031, -1.57681773401957, 218, 29, 'PPL', 'P'),
(145314, 'Grantwood', 40.8266716003418, 0.712559842056427, -73.9875030517578, -1.29132553358253, 218, 37, 'PPL', 'P'),
(55047, 'Grantwood Village', 38.5502815246582, 0.672829340176025, -90.3544387817383, -1.57698245053299, 218, 29, 'PPL', 'P'),
(55048, 'Granville', 39.5625, 0.690495885320257, -92.0975036621094, -1.60740467177134, 218, 29, 'PPL', 'P'),
(87370, 'Granville', 36.271110534668, 0.633050302184757, -85.795280456543, -1.49741012663862, 218, 50, 'PPL', 'P'),
(94578, 'Granville', 31.2811107635498, 0.545958376504981, -94.8411102294922, -1.65528963975151, 218, 51, 'PPL', 'P'),
(102374, 'Granville', 37.3819389343262, 0.652437915183452, -77.2416687011719, -1.3481214385701, 218, 53, 'PPL', 'P'),
(109446, 'Granville', 39.6458282470703, 0.691950237591549, -79.9875030517578, -1.39604528870219, 218, 58, 'PPL', 'P'),
(115831, 'Granville', 42.9855613708496, 0.750239576739413, -95.8733291625977, -1.67330525873563, 218, 16, 'PPL', 'P'),
(119840, 'Granville', 41.2611083984375, 0.720142194575019, -89.2275009155273, -1.55731367430221, 218, 18, 'PPL', 'P'),
(122711, 'Granville', 40.3172187805176, 0.703668212966925, -85.3186111450195, -1.48909067770932, 218, 19, 'PPL', 'P'),
(124957, 'Granville', 42.0666694641113, 0.734201887496901, -72.8619384765625, -1.27168072580156, 218, 23, 'PPL', 'P'),
(149239, 'Granville', 43.4077796936035, 0.757608676633717, -73.2600021362305, -1.2786282472953, 218, 40, 'PPL', 'P'),
(155516, 'Granville', 40.0680618286133, 0.699319603801962, -82.5197219848633, -1.44024084646621, 218, 41, 'PPL', 'P'),
(162192, 'Granville', 40.0677795410156, 0.699314676953945, -79.9086074829102, -1.39466830126056, 218, 45, 'PPL', 'P'),
(172071, 'Granville', 43.9847183227539, 0.767678155294334, -72.8466720581055, -1.27141427653449, 218, 55, 'PPL', 'P'),
(174330, 'Granville', 43.1775016784668, 0.753589567074624, -88.0438919067383, -1.53665580004257, 218, 57, 'PPL', 'P'),
(178280, 'Granville', 33.1888885498047, 0.579255380271538, -109.381942749023, -1.9090750431984, 218, 5, 'PPL', 'P'),
(198368, 'Granville', 48.2677803039551, 0.842431688933285, -100.842216491699, -1.76002870278908, 218, 34, 'PPL', 'P'),
(115832, 'Granville (historical)', 41.4961090087891, 0.72424372896985, -92.774169921875, -1.61921472594141, 218, 16, 'PPL', 'P'),
(124958, 'Granville Center', 42.0672187805176, 0.734211474876826, -72.8791732788086, -1.27198152984668, 218, 23, 'PPL', 'P'),
(162193, 'Granville Center', 41.7177810668945, 0.728112636243462, -76.7072219848633, -1.33879358369404, 218, 45, 'PPL', 'P'),
(162198, 'Granville Summit', 41.7177810668945, 0.728112636243462, -76.7794418334961, -1.34005405783798, 218, 45, 'PPL', 'P'),
(65147, 'Granville Terrace', 35.8097190856934, 0.624997502259603, -81.4122161865234, -1.42091122380026, 218, 33, 'PPL', 'P'),
(181881, 'Granz (historical)', 36.746940612793, 0.64135510372806, -119.70832824707, -2.08930446996951, 218, 6, 'PPL', 'P'),
(9183, 'Grape', 34.6316719055176, 0.6044367002217, -92.6522216796875, -1.61708632759822, 218, 4, 'PPL', 'P'),
(131096, 'Grape', 41.9636116027832, 0.732403188496662, -83.539436340332, -1.458038219399, 218, 27, 'PPL', 'P'),
(143899, 'Grape Corner', 43.6866683959961, 0.762476202737082, -71.022216796875, -1.23957152517069, 218, 36, 'PPL', 'P'),
(65148, 'Grape Creek', 35.1158294677734, 0.612886843781494, -84.0869369506836, -1.46759390770631, 218, 33, 'PPL', 'P'),
(119843, 'Grape Creek', 40.0677795410156, 0.699314676953945, -87.5986099243164, -1.5288841633495, 218, 18, 'PPL', 'P'),
(191548, 'Grape Creek', 31.5791702270508, 0.551160495509801, -100.547218322754, -1.75488001345363, 218, 51, 'PPL', 'P'),
(72717, 'Grape Grove', 39.7163887023926, 0.693181749858629, -83.6816711425781, -1.46052068500911, 218, 41, 'PPL', 'P'),
(109447, 'Grape Island', 39.4213905334473, 0.688033060523179, -81.1819381713867, -1.41689211424116, 218, 58, 'PPL', 'P'),
(102375, 'Grapefield', 37.1494407653809, 0.648380056630498, -81.2422180175781, -1.4179441960298, 218, 53, 'PPL', 'P'),
(60090, 'Grapeland', 33.6169395446777, 0.58672627949851, -90.9875030517578, -1.58803150642156, 218, 30, 'PPL', 'P'),
(94579, 'Grapeland', 31.4916706085205, 0.549633339072209, -95.4783325195313, -1.66641126677979, 218, 51, 'PPL', 'P'),
(181882, 'Grapeland', 34.125, 0.595593607243065, -117.561668395996, -2.05183818764789, 218, 6, 'PPL', 'P'),
(181883, 'Grapeland (historical)', 34.1588897705078, 0.596185095321172, -117.453330993652, -2.04994734327394, 218, 6, 'PPL', 'P'),
(94580, 'Grapetown', 30.1472206115723, 0.526168259997035, -98.8180618286133, -1.72470053934863, 218, 51, 'PPL', 'P'),
(207546, 'Grapeview', 47.3319396972656, 0.826098189072693, -122.833892822266, -2.14385586279037, 218, 56, 'PPL', 'P'),
(149241, 'Grapeville', 42.4122200012207, 0.740232882101495, -73.9336090087891, -1.29038490508551, 218, 40, 'PPL', 'P'),
(162197, 'Grapeville', 40.3252792358398, 0.703808894451508, -79.605827331543, -1.38938379070952, 218, 45, 'PPL', 'P'),
(9184, 'Grapevine', 34.1455612182617, 0.595952468199953, -92.3152770996094, -1.6112055352791, 218, 4, 'PPL', 'P'),
(36167, 'Grapevine', 37.2999992370605, 0.651007797678079, -87.4858322143555, -1.52691582098782, 218, 21, 'PPL', 'P'),
(94581, 'Grapevine', 32.9341697692871, 0.574809698884841, -97.0777816772461, -1.69432692080017, 218, 51, 'PPL', 'P'),
(178281, 'Grapevine', 33.6511116027832, 0.587322694424633, -111.048332214355, -1.93815902598899, 218, 5, 'PPL', 'P'),
(181884, 'Grapevine', 34.9416694641113, 0.609847178292305, -118.929168701172, -2.07570557049524, 218, 6, 'PPL', 'P'),
(21524, 'Grapevine (historical)', 34.0719413757324, 0.594667559553017, -83.8636093139648, -1.46369610513487, 218, 13, 'PPL', 'P'),
(87371, 'Grapevine (historical)', 35.7563896179199, 0.62406672745862, -85.1305618286133, -1.48580859798191, 218, 50, 'PPL', 'P'),
(65149, 'Grapewood', 36.1197204589844, 0.630408046909235, -80.438606262207, -1.40391852499084, 218, 33, 'PPL', 'P'),
(9185, 'Graphic', 35.5733299255371, 0.620871733098852, -94.1433334350586, -1.64311113724464, 218, 4, 'PPL', 'P'),
(65150, 'Graphite', 35.6605606079102, 0.622394195715023, -82.2519378662109, -1.43556713191118, 218, 33, 'PPL', 'P'),
(149243, 'Graphite', 43.7511100769043, 0.76360092224445, -73.5633316040039, -1.28392234522627, 218, 40, 'PPL', 'P'),
(181885, 'Grapit', 39.6811103820801, 0.692566027014602, -122.193061828613, -2.13267125200231, 218, 6, 'PPL', 'P'),
(113492, 'Grappaville', 41.7208290100098, 0.728165832886237, -73.2286071777344, -1.27808030190102, 218, 8, 'PPL', 'P'),
(41168, 'Grappes Bluff', 31.9155597686768, 0.557031600580449, -93.2041702270508, -1.62671964705131, 218, 22, 'PPL', 'P'),
(2820, 'Grasmere', 33.3969383239746, 0.582886533838834, -86.3327789306641, -1.50679124473648, 218, 2, 'PPL', 'P'),
(143900, 'Grasmere', 43.0222206115723, 0.750879401191304, -71.5436096191406, -1.24867154661549, 218, 36, 'PPL', 'P'),
(149242, 'Grasmere', 40.6041717529297, 0.708676487133901, -74.0875015258789, -1.29307083620291, 218, 40, 'PPL', 'P'),
(195025, 'Grasmere', 42.3766708374023, 0.739612432146533, -115.88166809082, -2.02251665088807, 218, 17, 'PPL', 'P'),
(47589, 'Grasonville', 38.9580612182617, 0.67994643845218, -76.210563659668, -1.33012526066195, 218, 25, 'PPL', 'P'),
(127610, 'Grass Corner', 46.9141693115234, 0.818806720324165, -67.8741683959961, -1.18462771556321, 218, 26, 'PPL', 'P'),
(122712, 'Grass Creek', 40.9474983215332, 0.714668666165606, -86.4044418334961, -1.50804199834243, 218, 19, 'PPL', 'P'),
(209482, 'Grass Creek', 43.9402809143066, 0.766902576205875, -108.64778137207, -1.89626150992959, 218, 59, 'PPL', 'P'),
(181886, 'Grass Flat', 39.6758308410645, 0.692473881640886, -120.934173583984, -2.11069950721888, 218, 6, 'PPL', 'P'),
(60091, 'Grass Lake', 33.1705589294434, 0.578935468045592, -90.3833312988281, -1.57748672008539, 218, 30, 'PPL', 'P'),
(119844, 'Grass Lake', 42.4461097717285, 0.740824370179601, -88.1358337402344, -1.5382604877574, 218, 18, 'PPL', 'P'),
(131097, 'Grass Lake', 42.2508316040039, 0.737416123195545, -84.2130584716797, -1.46979514350531, 218, 27, 'PPL', 'P'),
(135675, 'Grass Lake', 45.7780609130859, 0.798977888111871, -93.1675033569336, -1.62607968944136, 218, 28, 'PPL', 'P'),
(193602, 'Grass Lake', 41.6349983215332, 0.726667804773067, -122.190277099609, -2.13262264931241, 218, 6, 'PPL', 'P'),
(188631, 'Grass Mountain Summer Home Area', 35.7988891601563, 0.624808484401234, -105.653060913086, -1.84399377774348, 218, 38, 'PPL', 'P'),
(94582, 'Grass Pond Colony', 29.2511100769043, 0.510528180705272, -98.1291732788086, -1.71267716597525, 218, 51, 'PPL', 'P'),
(196629, 'Grass Range', 47.0261116027832, 0.820760481878875, -108.803886413574, -1.89898605688279, 218, 31, 'PPL', 'P'),
(181887, 'Grass Valley', 39.2191696166992, 0.684503639709524, -121.059997558594, -2.11289554985376, 218, 6, 'PPL', 'P'),
(190279, 'Grass Valley', 39.6977806091309, 0.692856977363694, -116.797218322754, -2.0384960169027, 218, 39, 'PPL', 'P'),
(196630, 'Grass Valley', 46.9358291625977, 0.819184756040902, -114.139442443848, -1.9921090770357, 218, 31, 'PPL', 'P'),
(200914, 'Grass Valley', 45.360279083252, 0.791686219626262, -120.784439086914, -2.10808614724118, 218, 43, 'PPL', 'P'),
(21525, 'Grassdale', 34.2727813720703, 0.598172878758807, -84.7869415283203, -1.4798112923651, 218, 13, 'PPL', 'P'),
(2816, 'Grasselli', 33.4486083984375, 0.583788346762962, -86.9094390869141, -1.5168558631281, 218, 2, 'PPL', 'P'),
(145315, 'Grasselli', 40.6150016784668, 0.708865504992269, -74.2091674804688, -1.29519430769808, 218, 37, 'PPL', 'P'),
(102377, 'Grassfield', 36.7177810668945, 0.640846173643746, -76.3230590820313, -1.33208867617561, 218, 53, 'PPL', 'P'),
(162199, 'Grassflat', 41.002498626709, 0.715628602580525, -78.1147232055664, -1.36335911422115, 218, 45, 'PPL', 'P'),
(178282, 'Grasshopper', 34.0755615234375, 0.594730743049879, -110.629722595215, -1.93085290985447, 218, 5, 'PPL', 'P'),
(178283, 'Grasshopper Junction', 35.3969383239746, 0.61779311887872, -114.258888244629, -1.99419379953702, 218, 5, 'PPL', 'P'),
(188632, 'Grassie Place', 34.6866683959961, 0.605396570057592, -108.356391906738, -1.89117580435392, 218, 38, 'PPL', 'P'),
(2817, 'Grassland', 34.2983283996582, 0.598618758504313, -85.5883331298828, -1.4937982144102, 218, 2, 'PPL', 'P'),
(78377, 'Grassland', 39.9880599975586, 0.697923308442433, -75.3041687011719, -1.31430568431271, 218, 45, 'PPL', 'P'),
(87372, 'Grassland', 35.9986114501953, 0.628294295952039, -86.8833312988281, -1.51640019626559, 218, 50, 'PPL', 'P'),
(102376, 'Grassland', 38.2636108398438, 0.667825992857066, -77.9863891601563, -1.36111926258634, 218, 53, 'PPL', 'P'),
(191549, 'Grassland', 33.1363792419434, 0.578338919961414, -101.596588134766, -1.77319497174426, 218, 51, 'PPL', 'P'),
(87374, 'Grassland Estates', 36.0041694641113, 0.628391301594745, -86.8813934326172, -1.51636637411975, 218, 50, 'PPL', 'P'),
(81292, 'Grasslawn Beach', 32.2108306884766, 0.562185050316348, -80.6800003051758, -1.40813164583535, 218, 48, 'PPL', 'P'),
(207547, 'Grassmere', 48.5402793884277, 0.847187695166003, -121.77889251709, -2.1254426338555, 218, 56, 'PPL', 'P'),
(47590, 'Grassmere Estates', 39.464168548584, 0.688779677734782, -76.9330596923828, -1.34273519526542, 218, 25, 'PPL', 'P'),
(162200, 'Grassmere Park', 41.2750015258789, 0.72038467539227, -76.378059387207, -1.33304861259053, 218, 45, 'PPL', 'P'),
(198364, 'Grassna', 46.0877799987793, 0.804383505913487, -100.295280456543, -1.7504828681778, 218, 34, 'PPL', 'P'),
(135677, 'Grasston', 45.7947196960449, 0.799268638723881, -93.1488876342773, -1.62575478378837, 218, 28, 'PPL', 'P'),
(2819, 'Grassy', 34.3541717529297, 0.599593408884255, -86.4366683959961, -1.50860445796466, 218, 2, 'PPL', 'P'),
(55050, 'Grassy', 37.2608299255371, 0.650324164226256, -90.1236114501953, -1.57295375359397, 218, 29, 'PPL', 'P'),
(198365, 'Grassy Butte', 47.3925018310547, 0.827155197709346, -103.247497558594, -1.80200877684227, 218, 34, 'PPL', 'P'),
(87376, 'Grassy Cove', 35.8405609130859, 0.625535793694935, -84.9180603027344, -1.48209974668981, 218, 50, 'PPL', 'P'),
(532, 'Grassy Creek', 37.8669395446777, 0.660902772708269, -83.3452835083008, -1.45464961322798, 218, 21, 'PPL', 'P'),
(65152, 'Grassy Creek', 35.8822212219238, 0.626262903251554, -82.0569381713867, -1.43216374519611, 218, 33, 'PPL', 'P'),
(87377, 'Grassy Creek', 35.002498626709, 0.610908847460865, -84.4394378662109, -1.47374620929856, 218, 50, 'PPL', 'P'),
(102379, 'Grassy Creek', 36.7808303833008, 0.641946591806167, -82.3383331298828, -1.43707501372038, 218, 53, 'PPL', 'P'),
(109449, 'Grassy Falls', 38.1725006103516, 0.66623581937018, -80.6877822875977, -1.40826746705094, 218, 58, 'PPL', 'P'),
(87378, 'Grassy Fork', 35.8172187805176, 0.62512839662718, -83.0913925170898, -1.4502183794902, 218, 50, 'PPL', 'P'),
(113491, 'Grassy Hill (historical)', 41.396110534668, 0.722498426349466, -72.288330078125, -1.26166937063173, 218, 8, 'PPL', 'P'),
(162201, 'Grassy Island', 41.4711112976074, 0.723807436604268, -75.5824966430664, -1.31916342329907, 218, 45, 'PPL', 'P'),
(9186, 'Grassy Lake Bottom', 35.2680587768555, 0.615543746443012, -90.3958282470703, -1.57770483297867, 218, 4, 'PPL', 'P'),
(127608, 'Grassy Landing', 46.5669403076172, 0.812746430947581, -68.5858306884766, -1.19704856572929, 218, 26, 'PPL', 'P'),
(36168, 'Grassy Lick', 38.0813903808594, 0.664645645883293, -84.0202789306641, -1.46643050578411, 218, 21, 'PPL', 'P'),
(109450, 'Grassy Meadows', 37.8266716003418, 0.660199964496597, -80.7211074829102, -1.40884910143301, 218, 58, 'PPL', 'P'),
(155520, 'Grassy Point', 40.5591697692871, 0.707891054349409, -83.5869369506836, -1.45886726144634, 218, 41, 'PPL', 'P'),
(81293, 'Grassy Pond', 35.1369400024414, 0.613255292118307, -81.6725006103516, -1.42545404398771, 218, 48, 'PPL', 'P'),
(70887, 'Grassy Sound', 39.0133285522461, 0.680911035399007, -74.8163909912109, -1.30579235725605, 218, 37, 'PPL', 'P'),
(94583, 'Grassyville', 30.1406402587891, 0.526053411175025, -97.0712280273438, -1.69421253803135, 218, 51, 'PPL', 'P'),
(162202, 'Graterford', 40.2255592346191, 0.702068452100114, -75.4550018310547, -1.31693821905025, 218, 45, 'PPL', 'P'),
(87379, 'Gratio', 36.2586097717285, 0.632832122712452, -89.4252777099609, -1.56076553054911, 218, 50, 'PPL', 'P'),
(55051, 'Gratiot', 38.6222190856934, 0.674084887471943, -90.2813873291016, -1.57570746216111, 218, 29, 'PPL', 'P'),
(72718, 'Gratiot', 39.9511108398438, 0.69727842398447, -82.2161102294922, -1.43494182168723, 218, 41, 'PPL', 'P'),
(174331, 'Gratiot', 42.5788917541504, 0.743141852960188, -90.0224990844727, -1.57118900989763, 218, 57, 'PPL', 'P'),
(21526, 'Gratis', 33.8824996948242, 0.591361178480657, -83.663330078125, -1.46020057304609, 218, 13, 'PPL', 'P'),
(72719, 'Gratis', 39.6477813720703, 0.691984326053502, -84.5272216796875, -1.47527832587368, 218, 41, 'PPL', 'P'),
(94584, 'Gratis', 30.148889541626, 0.526197388321457, -93.829719543457, -1.6376375422562, 218, 51, 'PPL', 'P'),
(47591, 'Gratitude', 39.1405601501465, 0.683131645694942, -76.2602767944336, -1.33099291854509, 218, 25, 'PPL', 'P'),
(181888, 'Graton', 38.4363899230957, 0.67084155673839, -122.868606567383, -2.14446173193836, 218, 6, 'PPL', 'P'),
(60092, 'Grattam (historical)', 33.311939239502, 0.581403019953605, -88.4722213745117, -1.54413155953853, 218, 30, 'PPL', 'P'),
(131100, 'Grattan', 43.084171295166, 0.751960644593877, -85.3811111450195, -1.49018150849182, 218, 27, 'PPL', 'P'),
(102380, 'Gratton', 37.1347198486328, 0.648123128164333, -81.4141693115234, -1.42094531226221, 218, 53, 'PPL', 'P'),
(36169, 'Gratz', 38.4736099243164, 0.671491168307288, -84.9527816772461, -1.48270574899586, 218, 21, 'PPL', 'P'),
(162203, 'Gratz', 40.6116714477539, 0.708807381501478, -76.7188873291016, -1.33899718235938, 218, 45, 'PPL', 'P'),
(162205, 'Gratztown', 40.2294387817383, 0.702136162970829, -79.7869415283203, -1.39254482976539, 218, 45, 'PPL', 'P'),
(109451, 'Graux', 38.7547187805176, 0.676397443404513, -81.2880630493164, -1.41874434277931, 218, 58, 'PPL', 'P'),
(109452, 'Grave Creek', 39.8716697692871, 0.695891915741948, -80.7233276367188, -1.40888785042688, 218, 58, 'PPL', 'P'),
(65156, 'Grave Yard (historical)', 36.2405586242676, 0.632517070755496, -81.7352828979492, -1.42654980161823, 218, 33, 'PPL', 'P'),
(41169, 'Gravel', 32.9322204589844, 0.574775677001916, -92.1516723632813, -1.60835009395832, 218, 22, 'PPL', 'P'),
(122715, 'Gravel Beach', 41.5508308410645, 0.725198805115779, -85.2233276367188, -1.48742766676662, 218, 19, 'PPL', 'P'),
(192594, 'Gravel Crossing', 37.707218170166, 0.658115108837228, -110.239166259766, -1.92403641588635, 218, 52, 'PPL', 'P'),
(2822, 'Gravel Hill', 34.485279083252, 0.601881663471878, -87.741943359375, -1.53138580371947, 218, 2, 'PPL', 'P'),
(9189, 'Gravel Hill', 35.2619400024414, 0.6154369536833, -91.9772186279297, -1.60530530188403, 218, 4, 'PPL', 'P'),
(13836, 'Gravel Hill', 38.714168548584, 0.675689708344825, -75.3161087036133, -1.31451407666801, 218, 10, 'PPL', 'P'),
(47592, 'Gravel Hill', 39.663890838623, 0.692265489285587, -79.3933334350586, -1.38567507257547, 218, 25, 'PPL', 'P'),
(55052, 'Gravel Hill', 37.3574981689453, 0.652011343355849, -89.8399963378906, -1.56800373607584, 218, 29, 'PPL', 'P'),
(60093, 'Gravel Hill', 33.4013900756836, 0.582964231563637, -90.0461120605469, -1.57160113407632, 218, 30, 'PPL', 'P'),
(81294, 'Gravel Hill', 33.4805603027344, 0.584346012695224, -80.9730606079102, -1.41324651302495, 218, 48, 'PPL', 'P'),
(87381, 'Gravel Hill', 36.207218170166, 0.631935170057313, -82.5947189331055, -1.44154979014199, 218, 50, 'PPL', 'P'),
(102382, 'Gravel Hill', 37.5363883972168, 0.65513356683883, -77.5149993896484, -1.35289195903076, 218, 53, 'PPL', 'P'),
(122713, 'Gravel Hill', 40.6500015258789, 0.709476367567306, -87.370002746582, -1.52489421540435, 218, 19, 'PPL', 'P'),
(145316, 'Gravel Hill', 40.2997207641602, 0.70336281496892, -74.4197235107422, -1.29886920368628, 218, 37, 'PPL', 'P'),
(162206, 'Gravel Hill', 40.3230590820313, 0.703770145457648, -76.6066665649414, -1.33703856053568, 218, 45, 'PPL', 'P'),
(81296, 'Gravel Hill (historical)', 33.3258285522461, 0.581645434191829, -79.9063873291016, -1.3946295522667, 218, 48, 'PPL', 'P'),
(9191, 'Gravel Junction', 34.045280456543, 0.594202238731553, -92.942497253418, -1.62215259209793, 218, 4, 'PPL', 'P'),
(102383, 'Gravel Lick', 36.9508285522461, 0.644913619576624, -82.230827331543, -1.43519868357437, 218, 53, 'PPL', 'P'),
(162208, 'Gravel Lick', 41.5108299255371, 0.724500657436015, -77.8013916015625, -1.35789044608073, 218, 45, 'PPL', 'P'),
(78378, 'Gravel Pit', 39.8786087036133, 0.696013022992519, -78.6891708374023, -1.37338511677697, 218, 45, 'PPL', 'P'),
(115833, 'Gravel Pit', 42.0702781677246, 0.734264871256682, -94.2911071777344, -1.64569027560232, 218, 16, 'PPL', 'P'),
(162209, 'Gravel Place', 41.0183296203613, 0.715904905543621, -75.1958312988281, -1.31241483993876, 218, 45, 'PPL', 'P'),
(41170, 'Gravel Point', 30.437780380249, 0.531239484634277, -92.9625015258789, -1.62250173251684, 218, 22, 'PPL', 'P'),
(55053, 'Gravel Point (historical)', 37.2247200012207, 0.649693927154289, -92.1677780151367, -1.60863119061138, 218, 29, 'PPL', 'P'),
(9192, 'Gravel Ridge', 34.8683280944824, 0.608567129914359, -92.190559387207, -1.60902880056213, 218, 4, 'PPL', 'P'),
(21527, 'Gravel Springs', 34.0750007629395, 0.594720955932873, -83.9841690063477, -1.46580026871214, 218, 13, 'PPL', 'P'),
(102384, 'Gravel Springs', 39.0750007629395, 0.68198741853259, -78.440559387207, -1.36904602841291, 218, 53, 'PPL', 'P'),
(36170, 'Gravel Switch', 37.5786094665527, 0.655870463512455, -85.0522232055664, -1.48444133107826, 218, 21, 'PPL', 'P'),
(200915, 'Gravelford', 43.105281829834, 0.752329092930689, -124.076942443848, -2.16555117145264, 218, 43, 'PPL', 'P'),
(207548, 'Gravelles', 47.6211090087891, 0.831145145654502, -117.998062133789, -2.05945469520747, 218, 56, 'PPL', 'P'),
(9193, 'Gravelly', 34.8830604553223, 0.608824258117606, -93.6872177124023, -1.63515041611417, 218, 4, 'PPL', 'P'),
(207549, 'Gravelly Beach', 47.1047210693359, 0.822132475893456, -122.963890075684, -2.14612474288106, 218, 56, 'PPL', 'P'),
(87382, 'Gravelly Hill', 36.101390838623, 0.630088134683289, -83.482780456543, -1.45704938768625, 218, 50, 'PPL', 'P'),
(47593, 'Gravelly Hills', 38.3736114501953, 0.669745865686904, -76.8219375610352, -1.34079574820157, 218, 25, 'PPL', 'P'),
(87383, 'Gravelly Hills', 35.8288917541504, 0.625332128450571, -84.1324996948242, -1.46838912760781, 218, 50, 'PPL', 'P'),
(70888, 'Gravelly Run', 39.4258308410645, 0.6881105585109, -74.7016677856445, -1.30379005959048, 218, 37, 'PPL', 'P'),
(2821, 'Gravelly Springs', 34.8858299255371, 0.608872594491391, -87.9080581665039, -1.53428505404018, 218, 2, 'PPL', 'P'),
(87384, 'Gravelotte', 36.2241706848145, 0.632231047254421, -87.0063934326172, -1.51854803568474, 218, 50, 'PPL', 'P'),
(72721, 'Gravelotte (historical)', 39.1519393920898, 0.683330250933235, -84.3236083984375, -1.47172460371508, 218, 41, 'PPL', 'P'),
(9195, 'Gravelridge', 33.4463882446289, 0.583749597769101, -92.2188873291016, -1.6095232164185, 218, 4, 'PPL', 'P'),
(55054, 'Gravelton', 37.2983283996582, 0.650978636064143, -90.2538909912109, -1.57522756053268, 218, 29, 'PPL', 'P'),
(65157, 'Gravelton', 34.9397201538086, 0.60981315640938, -79.9280624389648, -1.39500785429955, 218, 33, 'PPL', 'P'),
(122714, 'Gravelton', 41.4358291625977, 0.723191647181214, -85.9241714477539, -1.49965969881141, 218, 19, 'PPL', 'P'),
(87385, 'Graveltown', 36.3511085510254, 0.634446530965258, -85.9636077880859, -1.50034799279514, 218, 50, 'PPL', 'P'),
(112389, 'Gravely', 38.9561080932617, 0.679912349990227, -76.6350021362305, -1.33753310955011, 218, 25, 'PPL', 'P'),
(181889, 'Gravenstein', 38.4047203063965, 0.670288817654144, -122.806671142578, -2.14338075485189, 218, 6, 'PPL', 'P'),
(162210, 'Gravers', 40.077220916748, 0.699479460046394, -75.2022171020508, -1.31252629323037, 218, 45, 'PPL', 'P'),
(21528, 'Graves', 31.7680606842041, 0.554457255912724, -84.519172668457, -1.47513784412618, 218, 13, 'PPL', 'P'),
(60094, 'Graves', 34.4513893127441, 0.601290175393772, -88.7769393920898, -1.54944989223542, 218, 30, 'PPL', 'P'),
(81299, 'Graves', 33.3933296203613, 0.582823550079053, -79.3691711425781, -1.38525336101686, 218, 48, 'PPL', 'P'),
(102385, 'Graves', 39.0558280944824, 0.681652792341621, -77.5069427490234, -1.3527513441252, 218, 53, 'PPL', 'P'),
(102386, 'Graves Corner', 38.2566719055176, 0.667704885606495, -77.2813873291016, -1.34881465940185, 218, 53, 'PPL', 'P'),
(102387, 'Graves Mill', 38.4225006103516, 0.670599142500166, -78.3677825927734, -1.367775833731, 218, 53, 'PPL', 'P'),
(21529, 'Graves Way', 33.502498626709, 0.58472890868095, -84.4611129760742, -1.4741245113314, 218, 13, 'PPL', 'P'),
(181890, 'Gravesboro', 36.7730598449707, 0.641810970327654, -119.41056060791, -2.08410744426027, 218, 6, 'PPL', 'P'),
(149244, 'Gravesend', 40.5974998474121, 0.708560040415237, -73.9655609130859, -1.29094257101777, 218, 40, 'PPL', 'P'),
(87386, 'Graveston', 36.1594390869141, 0.631101267740982, -83.8255615234375, -1.46303204591706, 218, 50, 'PPL', 'P'),
(60095, 'Gravestown', 34.7486114501953, 0.60647768030211, -89.0833282470703, -1.55479738654625, 218, 30, 'PPL', 'P'),
(9197, 'Gravesville', 35.3891716003418, 0.617657563979235, -92.3477783203125, -1.61177278859129, 218, 4, 'PPL', 'P'),
(149252, 'Gravesville', 43.253059387207, 0.754908297867404, -75.1144409179688, -1.31099430981331, 218, 40, 'PPL', 'P'),
(174334, 'Gravesville', 44.0363883972168, 0.768579968218462, -88.146110534668, -1.53843985165682, 218, 57, 'PPL', 'P'),
(9198, 'Gravette', 36.4219398498535, 0.635682770343273, -94.4533309936523, -1.64852161531524, 218, 4, 'PPL', 'P'),
(115834, 'Gravity', 40.7605590820313, 0.711405960935123, -94.7433319091797, -1.65358308612499, 218, 16, 'PPL', 'P'),
(162211, 'Gravity', 41.4719390869141, 0.723821884253181, -75.3802795410156, -1.31563406906444, 218, 45, 'PPL', 'P'),
(55055, 'Gravois Mills', 38.3083305358887, 0.668606498793541, -92.8252792358398, -1.62010675174853, 218, 29, 'PPL', 'P'),
(131102, 'Grawn', 44.6624984741211, 0.779507650540357, -85.6936111450195, -1.4956356624043, 218, 27, 'PPL', 'P'),
(21530, 'Gray', 33.0094413757324, 0.576123436250577, -83.5338897705078, -1.45794141349337, 218, 13, 'PPL', 'P'),
(32612, 'Gray', 38.1583290100098, 0.665988478283939, -99.6416702270508, -1.73907521764844, 218, 20, 'PPL', 'P'),
(41171, 'Gray', 29.6975002288818, 0.518319158605758, -90.7863922119141, -1.58452146010484, 218, 22, 'PPL', 'P'),
(47594, 'Gray', 39.2572212219238, 0.685167765506362, -76.7858276367188, -1.3401655111296, 218, 25, 'PPL', 'P'),
(60096, 'Gray', 32.9111099243164, 0.574407228665103, -89.4469375610352, -1.56114356626585, 218, 30, 'PPL', 'P'),
(87387, 'Gray', 36.4197196960449, 0.635644021349412, -82.4766693115234, -1.43948943556465, 218, 50, 'PPL', 'P'),
(94585, 'Gray', 32.7874984741211, 0.57224980186603, -94.0733337402344, -1.64188941209456, 218, 51, 'PPL', 'P'),
(102388, 'Gray', 36.7966690063477, 0.642223027927317, -77.3438873291016, -1.34990549018435, 218, 53, 'PPL', 'P'),
(112331, 'Gray', 36.9425010681152, 0.644768277560133, -84.0083312988281, -1.46622198027076, 218, 21, 'PPL', 'P'),
(127609, 'Gray', 43.8855590820313, 0.765947500059946, -70.3322219848633, -1.22752884387941, 218, 26, 'PPL', 'P'),
(149245, 'Gray', 43.264720916748, 0.755111829953713, -74.9475021362305, -1.30808067842271, 218, 40, 'PPL', 'P'),
(162214, 'Gray', 40.6566696166992, 0.709592747706942, -78.2541732788086, -1.36579297714138, 218, 45, 'PPL', 'P'),
(177319, 'Gray', 41.8394393920898, 0.730235974580583, -94.982780456543, -1.6577622516656, 218, 16, 'PPL', 'P'),
(190981, 'Gray', 36.5583305358887, 0.63806323688364, -100.823333740234, -1.75969913660418, 218, 42, 'PPL', 'P'),
(195026, 'Gray', 43.0499992370605, 0.751364229667753, -111.378326416016, -1.94391851132045, 218, 17, 'PPL', 'P'),
(2823, 'Gray (historical)', 34.6597213745117, 0.604926255809084, -85.8986129760742, -1.49921361932882, 218, 2, 'PPL', 'P'),
(72722, 'Gray (historical)', 39.749439239502, 0.69375859055074, -82.960563659668, -1.44793498517156, 218, 41, 'PPL', 'P'),
(87388, 'Gray Acres', 36.5233306884766, 0.637452374308603, -82.1888885498047, -1.43446671374876, 218, 50, 'PPL', 'P'),
(81297, 'Gray Court', 34.6080589294434, 0.604024576043011, -82.1136093139648, -1.43315284322497, 218, 48, 'PPL', 'P'),
(94587, 'Gray Crossing', 29.1700000762939, 0.509112544138327, -97.9947204589844, -1.71033052158073, 218, 51, 'PPL', 'P'),
(94586, 'Gray East and West Colonia', 26.2229995727539, 0.457677682293622, -98.2699966430664, -1.71513499734528, 218, 51, 'PPL', 'P'),
(124960, 'Gray Gables', 41.7333297729492, 0.728384012358541, -70.6208267211914, -1.23256594676518, 218, 23, 'PPL', 'P'),
(207550, 'Gray Gables', 47.0136108398438, 0.82054230240657, -124.008056640625, -2.16434888737852, 218, 56, 'PPL', 'P'),
(202175, 'Gray Goose', 44.5047187805176, 0.776753875394187, -100.350280761719, -1.75144280459272, 218, 49, 'PPL', 'P'),
(47595, 'Gray Haven', 39.2691688537598, 0.685376291019716, -76.4863891601563, -1.33493932380643, 218, 25, 'PPL', 'P'),
(36172, 'Gray Hawk', 37.3950004577637, 0.652665881772763, -83.9402770996094, -1.46503421042458, 218, 21, 'PPL', 'P'),
(2824, 'Gray Hill', 33.2161102294922, 0.579730488210008, -87.0577774047852, -1.51944485518183, 218, 2, 'PPL', 'P'),
(21531, 'Gray Hill', 32.9247207641602, 0.574644782634338, -85.0822219848633, -1.48496490854857, 218, 13, 'PPL', 'P'),
(75978, 'Gray Horse', 36.5497207641602, 0.637912968019133, -96.6474990844727, -1.68681707284225, 218, 42, 'PPL', 'P'),
(29929, 'Gray Junction', 38.3263893127441, 0.668921683908552, -87.3447189331055, -1.52445292961172, 218, 19, 'PPL', 'P'),
(47596, 'Gray Manor', 39.2775001525879, 0.685521699615234, -76.495002746582, -1.33508965924996, 218, 25, 'PPL', 'P'),
(81298, 'Gray Mans Cove', 33.4347190856934, 0.583545932524737, -79.1322174072266, -1.38111773816007, 218, 48, 'PPL', 'P'),
(178284, 'Gray Mountain', 35.7458305358887, 0.623882436711186, -111.472778320313, -1.94556700803521, 218, 5, 'PPL', 'P'),
(191551, 'Gray Mule', 34.288890838623, 0.598454041990892, -101.093887329102, -1.764421187533, 218, 51, 'PPL', 'P'),
(41173, 'Gray Point', 30.7136096954346, 0.536053614357786, -92.4280624389648, -1.61317401079884, 218, 22, 'PPL', 'P'),
(47597, 'Gray Rock', 39.2688903808594, 0.685371430750726, -76.8358306884766, -1.34103822901882, 218, 25, 'PPL', 'P'),
(112229, 'Gray Rock', 35.3400001525879, 0.616799360317957, -93.7444381713867, -1.63614910152295, 218, 4, 'PPL', 'P'),
(47598, 'Gray Rock Farms', 39.2688903808594, 0.685371430750726, -76.8447189331055, -1.34119335815231, 218, 25, 'PPL', 'P'),
(149246, 'Gray Shores', 42.8166694641113, 0.747291856886859, -77.7125015258789, -1.3563390215877, 218, 40, 'PPL', 'P'),
(102389, 'Gray Sulphur Springs (historical)', 37.3944396972656, 0.652656094655757, -80.7855606079102, -1.40997402067746, 218, 53, 'PPL', 'P'),
(55057, 'Gray Summit', 38.4897193908691, 0.671772331539373, -90.8166732788086, -1.58504996442316, 218, 29, 'PPL', 'P'),
(94589, 'Grayback', 33.9905586242676, 0.593247162585623, -99.1738891601563, -1.73091089785264, 218, 51, 'PPL', 'P'),
(65158, 'Graybeal (historical)', 36.4688911437988, 0.63650222501069, -81.6483306884766, -1.42503219927104, 218, 33, 'PPL', 'P'),
(78380, 'Graybill', 39.9236106872559, 0.696798455777011, -76.8011093139648, -1.34043222671277, 218, 45, 'PPL', 'P'),
(94588, 'Grayburg', 30.1208305358887, 0.525707666286505, -94.4111099243164, -1.64778471864162, 218, 51, 'PPL', 'P'),
(109453, 'Grayden', 38.0919418334961, 0.664829803472673, -81.0563888549805, -1.41470086529625, 218, 58, 'PPL', 'P'),
(78381, 'Graydon', 39.8541717529297, 0.695586517743943, -76.6552810668945, -1.33788704365898, 218, 45, 'PPL', 'P'),
(55058, 'Graydon Springs', 37.4566688537598, 0.653742198327318, -93.5097198486328, -1.63205249397614, 218, 29, 'PPL', 'P'),
(29932, 'Grayford', 38.9627799987793, 0.680028796708891, -85.5741729736328, -1.49355107306104, 218, 19, 'PPL', 'P'),
(36173, 'Grayfox', 37.8630599975586, 0.660835061837554, -83.057502746582, -1.44962689141209, 218, 21, 'PPL', 'P'),
(207551, 'Grayland', 46.8102798461914, 0.816993507095985, -124.091941833496, -2.1658129601878, 218, 56, 'PPL', 'P'),
(131103, 'Grayling', 44.6613883972168, 0.779488276043426, -84.7147216796875, -1.47855081822117, 218, 27, 'PPL', 'P'),
(135681, 'Grayling', 46.6291694641113, 0.813832534619143, -93.210563659668, -1.62683123350098, 218, 28, 'PPL', 'P'),
(196632, 'Grayling', 45.0466690063477, 0.786212691216849, -112.819999694824, -1.96908045677368, 218, 31, 'PPL', 'P'),
(211856, 'Grayling', 62.9036102294922, 1.09787510989582, -160.064712524414, -2.79365624980923, 218, 1, 'PPL', 'P'),
(13838, 'Graylyn Crest', 39.7958297729492, 0.694568258101151, -75.5166702270508, -1.31801453560481, 218, 10, 'PPL', 'P'),
(87389, 'Graymere Manor', 35.5930595397949, 0.621216079827799, -87.0788879394531, -1.51981330351864, 218, 50, 'PPL', 'P'),
(2833, 'Graymont', 33.5138893127441, 0.584927713656325, -86.8330612182617, -1.51552281784447, 218, 2, 'PPL', 'P'),
(119846, 'Graymont', 40.8777809143066, 0.713451867863549, -88.7769393920898, -1.54944989223542, 218, 18, 'PPL', 'P'),
(186792, 'Graymont', 39.6944389343262, 0.692798654135821, -105.800003051758, -1.84655840187322, 218, 7, 'PPL', 'P'),
(119847, 'Graymoor', 41.5238914489746, 0.724728624025326, -87.6694412231445, -1.53012040272752, 218, 18, 'PPL', 'P'),
(149247, 'Graymoor', 41.3544387817383, 0.721771117055766, -73.9197235107422, -1.29014255742631, 218, 40, 'PPL', 'P'),
(36175, 'Graymoor-Devondale', 38.2730598449707, 0.667990909107569, -85.6230621337891, -1.4944043498743, 218, 21, 'PPL', 'P'),
(55059, 'Grayridge', 36.8241691589355, 0.642702996134776, -89.7808303833008, -1.56697109536316, 218, 29, 'PPL', 'P'),
(9202, 'Grays', 35.226390838623, 0.614816503728339, -91.23388671875, -1.59233171263371, 218, 4, 'PPL', 'P'),
(41172, 'Grays', 30.8483295440674, 0.538404919284217, -91.0502777099609, -1.58912713089402, 218, 22, 'PPL', 'P'),
(81300, 'Grays', 32.6736106872559, 0.570262085007422, -81.0205612182617, -1.4140755550723, 218, 48, 'PPL', 'P'),
(102390, 'Grays', 36.7999992370605, 0.642281151418108, -82.5025024414063, -1.4399403087372, 218, 53, 'PPL', 'P'),
(162215, 'Grays', 40.3958282470703, 0.705040206981506, -79.2399978637695, -1.38299886199605, 218, 45, 'PPL', 'P'),
(207552, 'Grays', 48.1061096191406, 0.839610003179319, -117.750556945801, -2.0551349147613, 218, 56, 'PPL', 'P'),
(36174, 'Grays Branch', 38.6533317565918, 0.67462790601821, -82.8752822875977, -1.44644654443832, 218, 21, 'PPL', 'P'),
(87390, 'Grays Camp', 36.4575004577637, 0.636303420035316, -89.3594436645508, -1.5596165096968, 218, 50, 'PPL', 'P'),
(65159, 'Grays Chapel', 35.8186111450195, 0.625152697972127, -79.6988906860352, -1.39100805265836, 218, 33, 'PPL', 'P'),
(27320, 'Grays Corner', 38.6433296203613, 0.674453335808756, -87.7219390869141, -1.53103666330056, 218, 18, 'PPL', 'P'),
(47599, 'Grays Corner', 38.3486099243164, 0.669309506742295, -75.1705627441406, -1.31197382046224, 218, 25, 'PPL', 'P'),
(102392, 'Grays Corner', 37.6500015258789, 0.657116490007476, -78.6322174072266, -1.3723910919001, 218, 53, 'PPL', 'P'),
(127613, 'Grays Corner', 44.3802795410156, 0.7745820009462, -68.6602783203125, -1.19834792202514, 218, 26, 'PPL', 'P'),
(149248, 'Grays Corner', 43.5302810668945, 0.75974672893586, -73.3858337402344, -1.28082442308823, 218, 40, 'PPL', 'P'),
(149249, 'Grays Corners', 42.8197212219238, 0.74734512010866, -73.7591705322266, -1.28734037932733, 218, 40, 'PPL', 'P'),
(65160, 'Grays Creek', 34.9599990844727, 0.610167090518251, -78.8444366455078, -1.37609501634418, 218, 33, 'PPL', 'P'),
(87391, 'Grays Crossing', 36.3305587768555, 0.634087869745452, -87.7519378662109, -1.53156024077087, 218, 50, 'PPL', 'P'),
(81301, 'Grays Crossroads', 33.047779083252, 0.57679255547446, -81.3152770996094, -1.41921931755973, 218, 48, 'PPL', 'P'),
(47600, 'Grays Estates', 38.7155609130859, 0.675714009689772, -76.5622177124023, -1.33626278171014, 218, 25, 'PPL', 'P'),
(193603, 'Grays Flat', 40.0177803039551, 0.698442025643753, -121.0625, -2.11293922569564, 218, 6, 'PPL', 'P'),
(102393, 'Grays Ford', 36.8036117553711, 0.642344201756915, -82.5047225952148, -1.43997905773106, 218, 53, 'PPL', 'P'),
(207553, 'Grays Harbor City', 46.985279083252, 0.820047819971169, -123.959999084473, -2.1635101247932, 218, 56, 'PPL', 'P'),
(81303, 'Grays Hill', 32.4933280944824, 0.567115560179493, -80.7425003051758, -1.40922247661784, 218, 48, 'PPL', 'P'),
(21532, 'Grays Landing', 31.9677791595459, 0.557943000884502, -82.434440612793, -1.43875240573297, 218, 13, 'PPL', 'P'),
(78384, 'Grays Landing', 39.832218170166, 0.695203355442108, -79.9188919067383, -1.39484779831803, 218, 45, 'PPL', 'P'),
(81302, 'Grays Landing', 33.2722206115723, 0.580709799121857, -81.8341674804688, -1.42827566316265, 218, 48, 'PPL', 'P'),
(209916, 'Grays Landing', 48.0191688537598, 0.838092600569219, -117.365829467773, -2.04842015354683, 218, 56, 'PPL', 'P'),
(47601, 'Grays Level', 39.2625007629395, 0.685259910880079, -76.7861099243164, -1.34017043797762, 218, 25, 'PPL', 'P'),
(32613, 'Grays Park', 39.0499992370605, 0.68155105958798, -94.6333312988281, -1.65166321329515, 218, 20, 'PPL', 'P'),
(55063, 'Grays Point', 37.2461090087891, 0.650067235760091, -93.9772186279297, -1.64021188692392, 218, 29, 'PPL', 'P'),
(55060, 'Grays Point (historical)', 37.2402801513672, 0.64996550300645, -89.4686126708984, -1.5615218682987, 218, 29, 'PPL', 'P'),
(94592, 'Grays Prairie', 32.4719390869141, 0.566742251573692, -96.3491668701172, -1.68161019343698, 218, 51, 'PPL', 'P'),
(207555, 'Grays River', 46.3563919067383, 0.809071668117435, -123.608062744141, -2.15736767689699, 218, 56, 'PPL', 'P'),
(21533, 'Grays Subdivision', 32.0447196960449, 0.55928586657466, -81.0122222900391, -1.41393001331872, 218, 13, 'PPL', 'P'),
(55061, 'Grays Valley', 37.4524993896484, 0.653669427450532, -93.9802780151367, -1.64026528330378, 218, 29, 'PPL', 'P'),
(87392, 'Graysburg', 36.3144416809082, 0.633806573355312, -82.6805572509766, -1.44304795141321, 218, 50, 'PPL', 'P'),
(119848, 'Grayslake', 42.3444404602051, 0.739049905945282, -88.0416717529297, -1.53661705104871, 218, 18, 'PPL', 'P'),
(2826, 'Grayson', 34.2802810668945, 0.598303773126384, -87.3194427490234, -1.52401177697715, 218, 2, 'PPL', 'P'),
(9203, 'Grayson', 35.0555610656738, 0.61183496172994, -93.8694381713867, -1.63833076308794, 218, 4, 'PPL', 'P'),
(21534, 'Grayson', 33.8941688537598, 0.59156484372502, -83.9558334350586, -1.46530571969771, 218, 13, 'PPL', 'P'),
(36179, 'Grayson', 38.3325004577637, 0.66902834351021, -82.9486083984375, -1.44772632650015, 218, 21, 'PPL', 'P'),
(41174, 'Grayson', 32.0497207641602, 0.559373151679388, -92.1091690063477, -1.60760827043668, 218, 22, 'PPL', 'P'),
(55062, 'Grayson', 39.5333290100098, 0.689986755498861, -94.5641708374023, -1.65045613553107, 218, 29, 'PPL', 'P'),
(65162, 'Grayson', 36.5361099243164, 0.637675414049898, -81.6838912963867, -1.42565284896309, 218, 33, 'PPL', 'P'),
(72725, 'Grayson', 39.9949989318848, 0.698044415693004, -84.1444396972656, -1.46859751996311, 218, 41, 'PPL', 'P'),
(75979, 'Grayson', 35.503059387207, 0.619645280837843, -95.8724975585938, -1.67329074450769, 218, 42, 'PPL', 'P'),
(102394, 'Grayson', 36.7675018310547, 0.641713964684948, -80.9488906860352, -1.41282466830828, 218, 53, 'PPL', 'P'),
(181891, 'Grayson', 37.5638885498047, 0.65561353504629, -121.178329467773, -2.11496083127911, 218, 6, 'PPL', 'P'),
(199364, 'Grayson (historical)', 42.4602813720703, 0.741071711265842, -102.425559997559, -1.78766326015639, 218, 35, 'PPL', 'P'),
(36177, 'Grayson Springs', 37.459171295166, 0.653785874169196, -86.2244415283203, -1.50490040036252, 218, 21, 'PPL', 'P'),
(2827, 'Grayson Valley', 33.6480598449707, 0.587269431202831, -86.6394424438477, -1.51214353273726, 218, 2, 'PPL', 'P'),
(9204, 'Graysonia', 34.1269416809082, 0.595627495967936, -93.4397201538086, -1.63083076882606, 218, 4, 'PPL', 'P'),
(21535, 'Graysons Landing', 33.1763916015625, 0.57903726737826, -85.0555572509766, -1.48449952114808, 218, 13, 'PPL', 'P'),
(102397, 'Graysontown', 37.038330078125, 0.64644080930373, -80.561393737793, -1.40606157072003, 218, 53, 'PPL', 'P'),
(60097, 'Graysport Crossing', 33.8163909912109, 0.59020736393838, -89.6136093139648, -1.56405253712454, 218, 30, 'PPL', 'P'),
(2829, 'Graystone', 33.9261093139648, 0.592122309920201, -86.5083312988281, -1.50985521157061, 218, 2, 'PPL', 'P'),
(21536, 'Graystone', 33.8813896179199, 0.591341803983726, -83.9780578613281, -1.46569360911048, 218, 13, 'PPL', 'P'),
(47604, 'Graystone', 39.6269416809082, 0.691620604827624, -76.6352767944336, -1.33753790324007, 218, 25, 'PPL', 'P'),
(47602, 'Graystone Estates', 38.5194396972656, 0.672291048740693, -77.0774993896484, -1.34525614355329, 218, 25, 'PPL', 'P'),
(21537, 'Graystone North', 33.8833312988281, 0.591375692708597, -83.9902801513672, -1.4659069283138, 218, 13, 'PPL', 'P'),
(2830, 'Graysville', 33.6205596923828, 0.586789462995372, -86.9713897705078, -1.51793710653068, 218, 2, 'PPL', 'P'),
(21538, 'Graysville', 34.976390838623, 0.610453180598353, -85.1413879394531, -1.48599754926125, 218, 13, 'PPL', 'P'),
(29931, 'Graysville', 39.1175003051758, 0.682729175475204, -87.5561065673828, -1.52814233982786, 218, 19, 'PPL', 'P'),
(36178, 'Graysville', 37.7722206115723, 0.659249615461602, -86.2975006103516, -1.50617552189245, 218, 21, 'PPL', 'P'),
(72723, 'Graysville', 39.6655616760254, 0.692294650899523, -81.1738891601563, -1.41675163249366, 218, 41, 'PPL', 'P'),
(87394, 'Graysville', 35.4469413757324, 0.618665836767939, -85.0844421386719, -1.48500365754243, 218, 50, 'PPL', 'P'),
(102398, 'Graysville', 37.7133293151855, 0.658221768438886, -75.6791687011719, -1.32085066900769, 218, 53, 'PPL', 'P'),
(109455, 'Graysville', 39.8166694641113, 0.694931979327029, -80.7947235107422, -1.41013394350092, 218, 58, 'PPL', 'P'),
(139190, 'Graysville', 40.4458312988281, 0.705912924870725, -92.7788925170898, -1.61929715077715, 218, 29, 'PPL', 'P'),
(162216, 'Graysville', 40.6913909912109, 0.71019875001299, -78.0280609130859, -1.36184657188004, 218, 45, 'PPL', 'P'),
(2832, 'Grayton', 33.7999992370605, 0.589921273858278, -85.9672164916992, -1.50041097655492, 218, 2, 'PPL', 'P'),
(47603, 'Grayton', 38.4269409179688, 0.670676640487887, -77.1999969482422, -1.3473941292764, 218, 25, 'PPL', 'P'),
(16268, 'Grayton Beach', 30.3305606842041, 0.529368147915306, -86.1650009155273, -1.50386296595988, 218, 12, 'PPL', 'P'),
(9205, 'Graytown', 34.9952812194824, 0.610782879941305, -92.6361083984375, -1.61680509778711, 218, 4, 'PPL', 'P'),
(87395, 'Graytown', 35.790828704834, 0.624667802916651, -87.3997192382813, -1.52541286602664, 218, 50, 'PPL', 'P'),
(94591, 'Graytown', 29.2079200744629, 0.509774372958725, -98.3188629150391, -1.71598787468438, 218, 51, 'PPL', 'P'),
(155521, 'Graytown', 41.542781829834, 0.725058323368278, -83.2611083984375, -1.45318048041264, 218, 41, 'PPL', 'P'),
(174335, 'Graytown', 45.1994400024414, 0.788879048100236, -92.1269378662109, -1.60791839554562, 218, 57, 'PPL', 'P'),
(16269, 'Grayvik', 25.3166694641113, 0.441859237787851, -80.2869415283203, -1.40127147602536, 218, 12, 'PPL', 'P'),
(27321, 'Grayville', 38.2574996948242, 0.667719333255408, -87.9936065673828, -1.53577815530534, 218, 18, 'PPL', 'P'),
(169401, 'Grayville', 41.5791702270508, 0.725693420709234, -71.1916732788086, -1.24252909871928, 218, 47, 'PPL', 'P'),
(149250, 'Graywood', 42.8122215270996, 0.747214225741083, -77.7149963378906, -1.35638256427153, 218, 40, 'PPL', 'P'),
(162217, 'Grazierville', 40.6536102294922, 0.709539351327086, -78.2649993896484, -1.36598192842072, 218, 45, 'PPL', 'P'),
(135682, 'Greaney', 47.9672203063965, 0.837185927376102, -93.0208282470703, -1.62351972584352, 218, 28, 'PPL', 'P'),
(178285, 'Greasewood', 35.5224990844727, 0.619984567560719, -109.856666564941, -1.9173605368238, 218, 5, 'PPL', 'P'),
(162218, 'Greason', 40.1927795410156, 0.701496338518938, -77.2905578613281, -1.34897471538336, 218, 45, 'PPL', 'P'),
(75981, 'Greasy', 35.6672210693359, 0.622510442696605, -94.7005615234375, -1.65283660207144, 218, 42, 'PPL', 'P'),
(9206, 'Greasy Corner', 35.0072212219238, 0.610991272296603, -90.4483337402344, -1.57862122670977, 218, 4, 'PPL', 'P'),
(36180, 'Greasy Creek', 37.3761100769043, 0.652336182429811, -82.475830078125, -1.43947478817865, 218, 21, 'PPL', 'P'),
(72724, 'Greasy Ridge', 38.6452789306641, 0.674487357691681, -82.4211120605469, -1.43851977861175, 218, 41, 'PPL', 'P'),
(124961, 'Great Barrington', 42.1958312988281, 0.736456186780626, -73.3625030517578, -1.28041722575756, 218, 23, 'PPL', 'P'),
(204149, 'Great Basin Addition', 41.1644401550293, 0.718455015445426, -112.037216186523, -1.95541830722352, 218, 52, 'PPL', 'P'),
(162219, 'Great Belt', 40.8086090087891, 0.712244590362389, -79.8033294677734, -1.39283085326646, 218, 45, 'PPL', 'P'),
(32614, 'Great Bend', 38.3644409179688, 0.669585809705391, -98.7644424438477, -1.72376470454158, 218, 20, 'PPL', 'P'),
(72726, 'Great Bend', 38.9530601501465, 0.679859153347453, -81.815559387207, -1.42795089066772, 218, 41, 'PPL', 'P'),
(140132, 'Great Bend', 46.1538887023926, 0.805537320455764, -96.8016662597656, -1.68950779764961, 218, 34, 'PPL', 'P'),
(149251, 'Great Bend', 44.0341682434082, 0.768541219224601, -75.7191696166992, -1.32154881668745, 218, 40, 'PPL', 'P'),
(162220, 'Great Bend', 41.9716682434082, 0.732543803402218, -75.7436065673828, -1.32197532193603, 218, 45, 'PPL', 'P'),
(143901, 'Great Boars Head', 42.920280456543, 0.74910020984605, -70.7997207641602, -1.23568823682719, 218, 36, 'PPL', 'P'),
(81304, 'Great Branch', 33.5063896179199, 0.584796819288747, -80.9563903808594, -1.41295556267586, 218, 48, 'PPL', 'P'),
(102399, 'Great Bridge', 36.7136116027832, 0.640773402766959, -76.2391662597656, -1.33062447020828, 218, 53, 'PPL', 'P'),
(124963, 'Great Brook Valley', 42.3069381713867, 0.738395367528367, -71.772216796875, -1.25266149456065, 218, 23, 'PPL', 'P'),
(109454, 'Great Cacapon', 39.6199989318848, 0.691499430998026, -78.2927780151367, -1.36646675689717, 218, 58, 'PPL', 'P'),
(36182, 'Great Crossing', 38.2144393920898, 0.666967789195788, -84.6052780151367, -1.47664066592931, 218, 21, 'PPL', 'P'),
(127614, 'Great Diamond Island Landing', 43.6705589294434, 0.762195039504997, -70.2002792358398, -1.22522600848481, 218, 26, 'PPL', 'P'),
(47606, 'Great Falls', 39.0022201538086, 0.680717157271649, -77.2463912963867, -1.34820386340584, 218, 25, 'PPL', 'P'),
(81305, 'Great Falls', 34.5750007629395, 0.603447602192845, -80.9022216796875, -1.41201014048888, 218, 48, 'PPL', 'P'),
(102400, 'Great Falls', 38.9980583190918, 0.680644519552917, -77.2886123657227, -1.34894076007946, 218, 53, 'PPL', 'P'),
(196633, 'Great Falls', 47.5002784729004, 0.829036254966296, -111.300003051758, -1.94255151073291, 218, 31, 'PPL', 'P'),
(127615, 'Great Falls (historical)', 43.8033294677734, 0.764512322548502, -70.4483337402344, -1.2295553763109, 218, 26, 'PPL', 'P'),
(13839, 'Great Good Place', 39.7522201538086, 0.693807126661607, -75.7555618286133, -1.32218398060744, 218, 10, 'PPL', 'P'),
(149253, 'Great Kills', 40.5541687011719, 0.707803769244682, -74.1519393920898, -1.29419548913125, 218, 40, 'PPL', 'P'),
(119849, 'Great Lakes', 42.3091697692871, 0.73843431625931, -87.8499984741211, -1.53327172124541, 218, 18, 'PPL', 'P'),
(131105, 'Great Lakes Beach', 43.2169418334961, 0.754277927637382, -82.522216796875, -1.44028438915004, 218, 27, 'PPL', 'P'),
(47607, 'Great Meadows', 39.0097198486328, 0.680848051639227, -76.476936340332, -1.3347743409769, 218, 25, 'PPL', 'P'),
(145317, 'Great Meadows', 40.8708305358887, 0.713330560875896, -74.9124984741211, -1.30746974926864, 218, 37, 'PPL', 'P'),
(47608, 'Great Mills', 38.2366714477539, 0.667355811766613, -76.4974975585938, -1.33513320193378, 218, 25, 'PPL', 'P'),
(65163, 'Great Neck', 34.9300003051758, 0.609643513047942, -76.6750030517578, -1.33823125722987, 218, 33, 'PPL', 'P'),
(124964, 'Great Neck', 41.5374984741211, 0.724966111415534, -70.9916687011719, -1.23903836032046, 218, 23, 'PPL', 'P'),
(149254, 'Great Neck', 40.8005599975586, 0.712104108614887, -73.728889465332, -1.28681187500901, 218, 40, 'PPL', 'P'),
(102401, 'Great Neck Estates', 36.8816719055176, 0.643706608391573, -76.0502777099609, -1.32732774309487, 218, 53, 'PPL', 'P'),
(149258, 'Great Neck Estates', 40.7869415283203, 0.711866421487597, -73.7372207641602, -1.28695728360452, 218, 40, 'PPL', 'P'),
(149255, 'Great Neck Gardens', 40.8125, 0.712312500970186, -73.626106262207, -1.28501796969873, 218, 40, 'PPL', 'P'),
(102402, 'Great Neck Manor', 36.8822212219238, 0.643716195771497, -76.0422210693359, -1.32718712818932, 218, 53, 'PPL', 'P'),
(149256, 'Great Neck Plaza', 40.7866706848145, 0.711861694376663, -73.726936340332, -1.28677778654705, 218, 40, 'PPL', 'P'),
(145318, 'Great Notch', 40.874439239502, 0.713393544635676, -74.2080612182617, -1.29517499978018, 218, 37, 'PPL', 'P'),
(47609, 'Great Oak Estates', 39.2574996948242, 0.685172625775352, -76.1988906860352, -1.32992152883855, 218, 25, 'PPL', 'P'),
(13840, 'Great Oak Farms', 39.4991683959961, 0.689390540309819, -75.6313934326172, -1.32001683327039, 218, 10, 'PPL', 'P'),
(47610, 'Great Oak Landing', 39.2644386291504, 0.685293733025923, -76.2030563354492, -1.32999423313631, 218, 25, 'PPL', 'P'),
(47611, 'Great Oak Manor', 39.2719383239746, 0.685424627393501, -76.1719436645508, -1.32945121459005, 218, 25, 'PPL', 'P'),
(102403, 'Great Oaks', 37.4625015258789, 0.653843997659987, -79.1216735839844, -1.38093371372875, 218, 53, 'PPL', 'P'),
(115836, 'Great Oaks', 41.5941696166992, 0.725955209444389, -90.42138671875, -1.57815091246126, 218, 16, 'PPL', 'P'),
(127616, 'Great Pond', 44.9402809143066, 0.784355868725819, -68.2825012207031, -1.19175446779832, 218, 26, 'PPL', 'P'),
(149257, 'Great River', 40.7211112976074, 0.71071746721431, -73.1580581665039, -1.27684898937102, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(124966, 'Great Swamp', 42.2444381713867, 0.737304536745871, -72.6138916015625, -1.26735149113352, 218, 23, 'PPL', 'P'),
(149259, 'Great Valley', 42.2144393920898, 0.736780959275561, -78.6366729736328, -1.37246885620393, 218, 40, 'PPL', 'P'),
(155522, 'Great Western', 40.0727806091309, 0.699401962058672, -80.9850006103516, -1.41345490538025, 218, 41, 'PPL', 'P'),
(127619, 'Great Works', 43.2197189331055, 0.754326397169221, -70.7977828979492, -1.23565441468135, 218, 26, 'PPL', 'P'),
(47612, 'Greater Capitol Heights', 38.878059387207, 0.678550143092652, -76.9211120605469, -1.34252666975206, 218, 25, 'PPL', 'P'),
(145319, 'Greater Cross Roads', 40.6688919067383, 0.709806066910258, -74.6802825927734, -1.3034168175637, 218, 37, 'PPL', 'P'),
(78386, 'Greater Point Marion', 39.75, 0.693768377667746, -79.8994369506836, -1.39450824527905, 218, 45, 'PPL', 'P'),
(16270, 'Greater Sun Center', 27.7177791595459, 0.483766507674743, -82.351936340332, -1.43731243453156, 218, 12, 'PPL', 'P'),
(178286, 'Greaterville', 31.7638893127441, 0.554384451746424, -110.749443054199, -1.93294242604574, 218, 5, 'PPL', 'P'),
(94593, 'Greatwood', 29.5538902282715, 0.515812691256316, -95.6755599975586, -1.66985353564678, 218, 51, 'PPL', 'P'),
(162223, 'Greble', 40.4305610656738, 0.705646409024636, -76.3547210693359, -1.3326412821018, 218, 45, 'PPL', 'P'),
(36181, 'Greear', 37.8772201538086, 0.661082203186713, -83.2980575561523, -1.4538253648706, 218, 21, 'PPL', 'P'),
(149261, 'Greece', 43.2097206115723, 0.754151893538794, -77.6933288574219, -1.35600439539674, 218, 40, 'PPL', 'P'),
(162224, 'Greece City', 40.9605598449707, 0.714896632754917, -79.8308334350586, -1.39331088805295, 218, 45, 'PPL', 'P'),
(181892, 'Greekstore', 39.0769386291504, 0.682021240678434, -120.557502746582, -2.10412536090996, 218, 6, 'PPL', 'P'),
(32621, 'Greeley', 38.3666687011719, 0.669624691857306, -95.1266708374023, -1.66027361257354, 218, 20, 'PPL', 'P'),
(36185, 'Greeley', 37.6763916015625, 0.657577083718005, -83.753059387207, -1.46176664492511, 218, 21, 'PPL', 'P'),
(55064, 'Greeley', 37.5149993896484, 0.654760258233028, -91.1869430541992, -1.59151239112435, 218, 29, 'PPL', 'P'),
(115837, 'Greeley', 42.5858306884766, 0.74326296021076, -91.3413925170898, -1.59420804277973, 218, 16, 'PPL', 'P'),
(141953, 'Greeley', 41.5486106872559, 0.725160056121919, -98.5308303833008, -1.71968740491267, 218, 35, 'PPL', 'P'),
(162225, 'Greeley', 41.4211082458496, 0.722934718715049, -74.9955596923828, -1.30891944100803, 218, 45, 'PPL', 'P'),
(194218, 'Greeley', 40.4233283996582, 0.705520175188966, -104.708610534668, -1.82751000901838, 218, 7, 'PPL', 'P'),
(194219, 'Greeley Junction', 40.4555587768555, 0.706082701390218, -104.693893432617, -1.82725314713124, 218, 7, 'PPL', 'P'),
(127620, 'Greeleys Landing', 45.2511100769043, 0.789780861024364, -69.2388916015625, -1.20844662887872, 218, 26, 'PPL', 'P'),
(72727, 'Greeleyville', 39.639720916748, 0.691843644568918, -82.2113876342773, -1.43485939685149, 218, 41, 'PPL', 'P'),
(81306, 'Greeleyville', 33.5808296203613, 0.586096042426543, -79.9891662597656, -1.39607431715807, 218, 48, 'PPL', 'P'),
(21539, 'Greely', 34.3930587768555, 0.600272115488062, -84.6449966430664, -1.47733388676106, 218, 13, 'PPL', 'P'),
(135685, 'Greely', 45.7447204589844, 0.798395987413689, -93.0680618286133, -1.62434410735896, 218, 28, 'PPL', 'P'),
(127621, 'Greely Corner', 44.3763885498047, 0.774514090338403, -69.4491729736328, -1.21211673117695, 218, 26, 'PPL', 'P'),
(21540, 'Green', 34.0883293151855, 0.594953583054092, -85.1486129760742, -1.48612364993886, 218, 13, 'PPL', 'P'),
(32619, 'Green', 39.4277801513672, 0.688144580393826, -97.0016708374023, -1.69299853604844, 218, 20, 'PPL', 'P'),
(36183, 'Green', 38.1405601501465, 0.665678353174999, -83.0752792358398, -1.44993714967908, 218, 21, 'PPL', 'P'),
(41175, 'Green', 32.8300018310547, 0.572991625387671, -91.440559387207, -1.59593883117217, 218, 22, 'PPL', 'P'),
(75983, 'Green', 36.3858299255371, 0.635052533271306, -95.2891693115234, -1.66310974597642, 218, 42, 'PPL', 'P'),
(94594, 'Green', 28.7386093139648, 0.501583354972995, -97.8722229003906, -1.70819253585761, 218, 51, 'PPL', 'P'),
(131106, 'Green', 46.8375015258789, 0.817468615034455, -89.4397201538086, -1.56101759874629, 218, 27, 'PPL', 'P'),
(155523, 'Green', 40.9458312988281, 0.714639571130697, -81.4833297729492, -1.42215239002629, 218, 41, 'PPL', 'P'),
(181893, 'Green', 38.3458290100098, 0.669260970631428, -121.638610839844, -2.12299425670734, 218, 6, 'PPL', 'P'),
(195027, 'Green', 45.452220916748, 0.793290907341089, -115.945831298828, -2.02363651012644, 218, 17, 'PPL', 'P'),
(200918, 'Green', 43.1605606079102, 0.753293889614598, -123.366668701172, -2.15315455605249, 218, 43, 'PPL', 'P'),
(65164, 'Green (historical)', 35.2775001525879, 0.615708529535461, -81.7002792358398, -1.42593887246416, 218, 33, 'PPL', 'P'),
(155524, 'Green (historical)', 40.1808280944824, 0.701287746426557, -82.7425003051758, -1.44412906165773, 218, 41, 'PPL', 'P'),
(21541, 'Green Acre', 34.3383293151855, 0.599316906184078, -85.1488876342773, -1.48612844362882, 218, 13, 'PPL', 'P'),
(127622, 'Green Acre', 43.1119384765625, 0.752445273333244, -70.7958297729492, -1.23562032621939, 218, 26, 'PPL', 'P'),
(2837, 'Green Acres', 33.4719390869141, 0.584195544093635, -86.896110534668, -1.51662323600689, 218, 2, 'PPL', 'P'),
(9207, 'Green Acres', 36.3274993896484, 0.634034473365596, -93.920280456543, -1.63921812836316, 218, 4, 'PPL', 'P'),
(13841, 'Green Acres', 39.7902793884277, 0.6944713856165, -75.4972229003906, -1.31767511572388, 218, 10, 'PPL', 'P'),
(21545, 'Green Acres', 33.584171295166, 0.586154365654415, -84.4269409179688, -1.47352809640528, 218, 13, 'PPL', 'P'),
(27322, 'Green Acres', 39.8933296203613, 0.696269951458685, -89.6733322143555, -1.5650948983752, 218, 18, 'PPL', 'P'),
(36184, 'Green Acres', 37.6541709899902, 0.657189260884262, -84.7605590820313, -1.47935083181263, 218, 21, 'PPL', 'P'),
(41177, 'Green Acres', 29.8091697692871, 0.520268159760019, -90.4252777099609, -1.57821882306906, 218, 22, 'PPL', 'P'),
(47617, 'Green Acres', 38.273609161377, 0.668000496487494, -76.5875015258789, -1.33670406750277, 218, 25, 'PPL', 'P'),
(65166, 'Green Acres', 35.7088890075684, 0.623237685411278, -78.6500015258789, -1.37270148332515, 218, 33, 'PPL', 'P'),
(81309, 'Green Acres', 33.8980598449707, 0.591632754332817, -80.3177795410156, -1.40180970088166, 218, 48, 'PPL', 'P'),
(87402, 'Green Acres', 36.5255584716797, 0.637491256460519, -82.5316696166992, -1.44044937197957, 218, 50, 'PPL', 'P'),
(102407, 'Green Acres', 36.5786094665527, 0.638417170992512, -79.3505630493164, -1.38492858852192, 218, 53, 'PPL', 'P'),
(115840, 'Green Acres', 41.5699996948242, 0.725533364727721, -90.6100006103516, -1.58144284588471, 218, 16, 'PPL', 'P'),
(122716, 'Green Acres', 41.4838905334473, 0.724030476345562, -87.2972183227539, -1.52362388756438, 218, 19, 'PPL', 'P'),
(149263, 'Green Acres', 40.6586112976074, 0.709626636431814, -73.7177810668945, -1.28661799688165, 218, 40, 'PPL', 'P'),
(155525, 'Green Acres', 40.6547203063965, 0.709558725824017, -84.1105575561523, -1.46800616504305, 218, 41, 'PPL', 'P'),
(162226, 'Green Acres', 40.8144416809082, 0.712346389695057, -79.4775009155273, -1.38714407223276, 218, 45, 'PPL', 'P'),
(172073, 'Green Acres', 43.624439239502, 0.76139009906552, -72.9402770996094, -1.2730479927052, 218, 55, 'PPL', 'P'),
(181894, 'Green Acres', 33.7380599975586, 0.588840230192788, -117.075561523438, -2.04335402220517, 218, 6, 'PPL', 'P'),
(196634, 'Green Acres', 48.398609161377, 0.844715083251919, -115.566673278809, -2.01701895429176, 218, 31, 'PPL', 'P'),
(200917, 'Green Acres', 43.6749992370605, 0.762272537492718, -123.797218322754, -2.16066906454231, 218, 43, 'PPL', 'P'),
(211857, 'Green Acres', 61.1861114501953, 1.06789910129811, -149.841674804688, -2.61523058204443, 218, 1, 'PPL', 'P'),
(191552, 'Green Acres Colonia', 31.875560760498, 0.556333486190199, -106.598892211914, -1.86050164807644, 218, 51, 'PPL', 'P'),
(2842, 'Green Acres Estates', 33.6611099243164, 0.587497198055061, -86.4277801513672, -1.50844932883116, 218, 2, 'PPL', 'P'),
(47619, 'Green Acres Estates', 38.5924987792969, 0.673566170270623, -76.9922180175781, -1.34376770282004, 218, 25, 'PPL', 'P'),
(178287, 'Green Acres Mobile and Recreational Vehicle Park', 33.4502792358398, 0.583817508376898, -112.115280151367, -1.9567807804372, 218, 5, 'PPL', 'P'),
(141956, 'Green Acres Mobile Home Community', 41.5344390869141, 0.724912715035678, -96.4700012207031, -1.68371915070422, 218, 35, 'PPL', 'P'),
(13842, 'Green Acres Mobile Home Park', 39.1144409179688, 0.682675779095348, -75.5366668701172, -1.31836354286566, 218, 10, 'PPL', 'P'),
(115841, 'Green Acres Mobile Home Park', 40.8527793884277, 0.713015508918939, -91.107780456543, -1.59013074315082, 218, 16, 'PPL', 'P'),
(141957, 'Green Acres Mobile Home Park', 41.1263885498047, 0.717790889648588, -95.8930587768555, -1.67364960546457, 218, 35, 'PPL', 'P'),
(191553, 'Green Acres Number 1 and 2 Colonia', 28.6730003356934, 0.500438262283288, -100.490997314453, -1.75389877174999, 218, 51, 'PPL', 'P'),
(21547, 'Green Acres Subdivision', 30.9891700744629, 0.540863050259874, -84.879997253418, -1.48143542115589, 218, 13, 'PPL', 'P'),
(178288, 'Green Acres Trailer Court', 33.4152793884277, 0.583206645801861, -111.882217407227, -1.95271306818822, 218, 5, 'PPL', 'P'),
(199365, 'Green Acres Trailer Court', 41.1555595397949, 0.718300019469984, -100.805557250977, -1.75938887833718, 218, 35, 'PPL', 'P'),
(124967, 'Green Acres Trailer Park', 42.6586112976074, 0.7445332214717, -71.5830612182617, -1.24936010691533, 218, 23, 'PPL', 'P'),
(149264, 'Green Acres Valley', 43.0072212219238, 0.75061761245615, -78.831672668457, -1.375872242919, 218, 40, 'PPL', 'P'),
(70889, 'Green Bank', 39.6127815246582, 0.691373463478465, -74.5883331298828, -1.30181199669082, 218, 37, 'PPL', 'P'),
(109456, 'Green Bank', 38.4199981689453, 0.670555466658288, -79.831672668457, -1.39332553543894, 218, 58, 'PPL', 'P'),
(162227, 'Green Bank', 40.0844383239746, 0.699605427565954, -76.0350036621094, -1.32706116066975, 218, 45, 'PPL', 'P'),
(2843, 'Green Bay', 31.1777801513672, 0.544154917104294, -86.289436340332, -1.50603477382884, 218, 2, 'PPL', 'P'),
(16271, 'Green Bay', 27.8358306884766, 0.485826895541596, -81.9230575561523, -1.42982708765568, 218, 12, 'PPL', 'P'),
(81312, 'Green Bay', 33.4441719055176, 0.583710915354268, -79.5194396972656, -1.38787604205837, 218, 48, 'PPL', 'P'),
(102408, 'Green Bay', 37.1336097717285, 0.648103753667403, -78.3150024414063, -1.36685464630994, 218, 53, 'PPL', 'P'),
(172074, 'Green Bay', 44.3047218322754, 0.77326327015342, -72.2027816772461, -1.26017626936658, 218, 55, 'PPL', 'P'),
(174336, 'Green Bay', 44.5191688537598, 0.777006076749418, -88.0197219848633, -1.5362339553259, 218, 57, 'PPL', 'P'),
(81313, 'Green Bay (historical)', 33.2200012207031, 0.579798398817805, -79.6224975585938, -1.38967474105861, 218, 48, 'PPL', 'P'),
(115842, 'Green Bay (historical)', 40.9152793884277, 0.714106339701436, -93.774169921875, -1.63666801846135, 218, 16, 'PPL', 'P'),
(55065, 'Green Bay Terrace', 38.0927810668945, 0.664844450858668, -92.7616729736328, -1.61899661304813, 218, 29, 'PPL', 'P'),
(207556, 'Green Bluff', 47.8274993896484, 0.834747337344944, -117.270561218262, -2.04675740892024, 218, 56, 'PPL', 'P'),
(109457, 'Green Bottom', 38.5522193908691, 0.672863162321869, -82.2838897705078, -1.43612479784344, 218, 58, 'PPL', 'P'),
(181895, 'Green Brae', 37.9486083984375, 0.662328163102707, -122.523612976074, -2.13844045787174, 218, 6, 'PPL', 'P'),
(13843, 'Green Briar', 39.146671295166, 0.6832383052966, -75.6750030517578, -1.32077796470993, 218, 10, 'PPL', 'P'),
(47620, 'Green Briar', 39.4930610656738, 0.689283947287189, -75.8902816772461, -1.32453528553387, 218, 25, 'PPL', 'P'),
(162228, 'Green Briar', 41.3213882446289, 0.721194276363655, -78.9280624389648, -1.3775545617796, 218, 45, 'PPL', 'P'),
(13844, 'Green Briar Court', 38.5486106872559, 0.672800178562089, -75.0922164916992, -1.31060642040054, 218, 10, 'PPL', 'P'),
(27323, 'Green Brier', 38.9086112976074, 0.679083374521913, -87.9072189331055, -1.53427040665419, 218, 18, 'PPL', 'P'),
(87405, 'Green Brier', 36.6127815246582, 0.639013585918635, -85.1313934326172, -1.48582311220985, 218, 50, 'PPL', 'P'),
(115845, 'Green Brier', 41.9219398498535, 0.731675879202961, -94.418327331543, -1.64791068616118, 218, 16, 'PPL', 'P'),
(155529, 'Green Camp', 40.5319404602051, 0.707415813252884, -83.210563659668, -1.45229830830155, 218, 41, 'PPL', 'P'),
(27324, 'Green Castle', 38.8883285522461, 0.678729373834014, -89.745002746582, -1.56634578513921, 218, 18, 'PPL', 'P'),
(115846, 'Green Castle', 41.7461090087891, 0.728607052099836, -93.2613906860352, -1.62771833246009, 218, 16, 'PPL', 'P'),
(139191, 'Green Castle', 40.2625007629395, 0.702713203400022, -92.8777770996094, -1.62102301232157, 218, 29, 'PPL', 'P'),
(115847, 'Green Castle (historical)', 41.7744407653809, 0.729101534535236, -91.6661071777344, -1.59987538273747, 218, 16, 'PPL', 'P'),
(115848, 'Green Center', 41.5402793884277, 0.7250146475264, -91.8863906860352, -1.60372005524516, 218, 16, 'PPL', 'P'),
(122720, 'Green Center', 41.3083305358887, 0.720966376353371, -85.3661117553711, -1.48991971975666, 218, 19, 'PPL', 'P'),
(139192, 'Green City', 40.2686080932617, 0.702819796422653, -92.9530563354492, -1.62233688284536, 218, 29, 'PPL', 'P'),
(149266, 'Green Corners', 42.9391708374023, 0.749429909189002, -74.0813903808594, -1.29296417660125, 218, 40, 'PPL', 'P'),
(75984, 'Green Country Estates', 35.8702812194824, 0.626054510896255, -94.9880599975586, -1.65785439703931, 218, 42, 'PPL', 'P'),
(47621, 'Green Cove', 38.5833282470703, 0.673406114289109, -76.2652816772461, -1.33108027022885, 218, 25, 'PPL', 'P'),
(87406, 'Green Cove', 35.2008285522461, 0.614370357666723, -85.1772232055664, -1.48662299264325, 218, 50, 'PPL', 'P'),
(102409, 'Green Cove', 36.6175003051758, 0.639095944175346, -81.6433334350586, -1.42494498074534, 218, 53, 'PPL', 'P'),
(16272, 'Green Cove Springs', 29.9916706085205, 0.523453400292294, -81.6783294677734, -1.42555577674135, 218, 12, 'PPL', 'P'),
(55066, 'Green Cox', 37.1405601501465, 0.648225060655056, -89.8388900756836, -1.56798442815794, 218, 29, 'PPL', 'P'),
(27325, 'Green Creek', 39.2027816772461, 0.684217616208449, -88.5233306884766, -1.54502358534565, 218, 18, 'PPL', 'P'),
(65171, 'Green Creek', 35.2202796936035, 0.614709844126681, -82.0508270263672, -1.43205708559446, 218, 33, 'PPL', 'P'),
(70890, 'Green Creek', 39.0461082458496, 0.681483148980183, -74.9016723632813, -1.3072807979893, 218, 37, 'PPL', 'P'),
(155528, 'Green Creek', 41.3286094665527, 0.721320310462243, -83.0500030517578, -1.44949599704451, 218, 41, 'PPL', 'P'),
(21548, 'Green Crossing', 34.1452789306641, 0.595947541351937, -83.9775009155273, -1.4656838885725, 218, 13, 'PPL', 'P'),
(60103, 'Green Crossing', 32.4375, 0.566141176115661, -90.2652816772461, -1.57542636550805, 218, 30, 'PPL', 'P'),
(145321, 'Green Curve Heights', 40.2661094665527, 0.702776187159803, -74.7850036621094, -1.30524454501983, 218, 37, 'PPL', 'P'),
(65172, 'Green Farm', 35.6055603027344, 0.621434259300104, -77.4683303833008, -1.35207743121136, 218, 33, 'PPL', 'P'),
(87407, 'Green Field', 35.1419410705566, 0.613342577223034, -87.0583267211914, -1.51945444256175, 218, 50, 'PPL', 'P'),
(196636, 'Green Field Mobile Home Park', 46.8841705322266, 0.818283142853856, -114.08332824707, -1.99112969954483, 218, 31, 'PPL', 'P'),
(81315, 'Green Fields', 34.8722190856934, 0.608635040522156, -82.3172225952148, -1.43670656538357, 218, 48, 'PPL', 'P'),
(36187, 'Green Fields Estates', 37.9927787780762, 0.663099081659257, -84.208610534668, -1.46971751235954, 218, 21, 'PPL', 'P'),
(9209, 'Green Forest', 36.3352813720703, 0.63417029458119, -93.4358291625977, -1.63076285821827, 218, 4, 'PPL', 'P'),
(55067, 'Green Forest', 36.7669410705566, 0.641704177567942, -90.4649963378906, -1.5789120439008, 218, 29, 'PPL', 'P'),
(81332, 'Green Forest', 34.5333290100098, 0.602720292899144, -82.7344436645508, -1.44398844675217, 218, 48, 'PPL', 'P'),
(47622, 'Green Forest Estates', 38.3169403076172, 0.668756767658049, -75.5386123657227, -1.31839749816956, 218, 25, 'PPL', 'P'),
(41181, 'Green Gables', 31.3833293914795, 0.547742428119226, -92.3375015258789, -1.61159342469188, 218, 22, 'PPL', 'P'),
(47623, 'Green Gables', 39.1155586242676, 0.682695286750333, -76.4469375610352, -1.33425076350659, 218, 25, 'PPL', 'P'),
(55074, 'Green Gables (historical)', 37.9497184753418, 0.662347537599637, -92.8744430541992, -1.62096482225175, 218, 29, 'PPL', 'P'),
(131111, 'Green Garden', 46.4386100769043, 0.810506645891797, -87.279167175293, -1.52330883560742, 218, 27, 'PPL', 'P'),
(41180, 'Green Gate', 30.5533294677734, 0.533256196659253, -91.1136093139648, -1.59023247590446, 218, 22, 'PPL', 'P'),
(47624, 'Green Glade', 39.4738883972168, 0.68894932109622, -79.2649993896484, -1.38343522094066, 218, 25, 'PPL', 'P'),
(202176, 'Green Grass', 45.1711082458496, 0.788384565664836, -101.245559692383, -1.76706836965654, 218, 49, 'PPL', 'P'),
(16273, 'Green Grove', 29.6338901519775, 0.517208953326331, -82.2677764892578, -1.43584356803233, 218, 12, 'PPL', 'P'),
(36189, 'Green Grove', 36.7338905334473, 0.641127336875831, -85.2697219848633, -1.48823740089606, 218, 21, 'PPL', 'P'),
(60104, 'Green Grove', 34.1627807617188, 0.596253005928969, -90.7608337402344, -1.58407538062225, 218, 30, 'PPL', 'P'),
(87408, 'Green Grove', 36.4647216796875, 0.636429454133904, -86.1730575561523, -1.50400358086544, 218, 50, 'PPL', 'P'),
(139193, 'Green Grove', 40.3138885498047, 0.703610089476134, -92.7202835083008, -1.61827423060245, 218, 29, 'PPL', 'P'),
(145322, 'Green Grove', 40.2341690063477, 0.702218720964622, -74.0777816772461, -1.29290119284147, 218, 37, 'PPL', 'P'),
(162230, 'Green Grove', 41.5244407653809, 0.72473821140525, -75.6083297729492, -1.31961429647162, 218, 45, 'PPL', 'P'),
(9210, 'Green Hall (historical)', 33.7200012207031, 0.588525045077777, -92.4944381713867, -1.61433248587302, 218, 4, 'PPL', 'P'),
(124968, 'Green Harbor', 42.0777816772461, 0.734395832203286, -70.6500015258789, -1.2330751431656, 218, 23, 'PPL', 'P'),
(47630, 'Green Haven', 39.1394386291504, 0.68311207146093, -76.5480575561523, -1.33601564036098, 218, 25, 'PPL', 'P'),
(131107, 'Green Haven', 46.538890838623, 0.812256875360197, -86.0155563354492, -1.50125466598826, 218, 27, 'PPL', 'P'),
(149267, 'Green Haven', 41.5872192382813, 0.725833902456736, -73.7183303833008, -1.28662758426157, 218, 40, 'PPL', 'P'),
(47626, 'Green Henge', 39.2902793884277, 0.685744739356528, -76.9305572509766, -1.34269151942354, 218, 25, 'PPL', 'P'),
(9212, 'Green High', 36.0088882446289, 0.628473659851456, -90.5322189331055, -1.58008529951904, 218, 4, 'PPL', 'P'),
(2846, 'Green Hill', 34.9730606079102, 0.610395057107562, -87.5122222900391, -1.52737641469835, 218, 2, 'PPL', 'P'),
(9211, 'Green Hill', 33.5647201538086, 0.585814879194458, -91.8977813720703, -1.60391886022054, 218, 4, 'PPL', 'P'),
(13847, 'Green Hill', 38.7911109924316, 0.677032607324497, -75.1675033569336, -1.31192042408238, 218, 10, 'PPL', 'P'),
(21549, 'Green Hill', 32.7094383239746, 0.570887395231373, -81.5930633544922, -1.42406760232422, 218, 13, 'PPL', 'P'),
(36188, 'Green Hill', 37.2963905334473, 0.650944813918299, -83.9655609130859, -1.46547549621721, 218, 21, 'PPL', 'P'),
(47628, 'Green Hill', 38.3113899230957, 0.668659895173397, -75.7788925170898, -1.32259117793811, 218, 25, 'PPL', 'P'),
(65174, 'Green Hill', 36.1233291625977, 0.630471030669015, -81.6580581665039, -1.42520197579054, 218, 33, 'PPL', 'P'),
(78389, 'Green Hill', 39.9605598449707, 0.697443340234974, -76.6991729736328, -1.33865310194654, 218, 45, 'PPL', 'P'),
(81320, 'Green Hill', 34.458610534668, 0.60141620949236, -80.0458297729492, -1.39706328202887, 218, 48, 'PPL', 'P'),
(87410, 'Green Hill', 36.2227783203125, 0.632206745909474, -86.5494384765625, -1.51057266716828, 218, 50, 'PPL', 'P'),
(94595, 'Green Hill', 33.2480583190918, 0.580288087563243, -94.9958267211914, -1.6579899519388, 218, 51, 'PPL', 'P'),
(102411, 'Green Hill', 37.2758293151855, 0.650585952961411, -80.0988922119141, -1.39798939629794, 218, 53, 'PPL', 'P'),
(109459, 'Green Hill', 39.6383285522461, 0.691819343223972, -80.7752838134766, -1.40979465677805, 218, 58, 'PPL', 'P'),
(122717, 'Green Hill', 40.4136085510254, 0.705350531827528, -87.1111068725586, -1.52037562998281, 218, 19, 'PPL', 'P'),
(169406, 'Green Hill', 41.3677787780762, 0.722003943914066, -71.5952835083008, -1.24957342611865, 218, 47, 'PPL', 'P'),
(21550, 'Green Hill (historical)', 32.2297210693359, 0.5625147496593, -84.7655563354492, -1.47943805033833, 218, 13, 'PPL', 'P'),
(65175, 'Green Hill (historical)', 35.8675003051758, 0.626005974785388, -76.7200012207031, -1.33901662343534, 218, 33, 'PPL', 'P'),
(81321, 'Green Hill (historical)', 33.2069396972656, 0.579570432228494, -80.0599975585938, -1.39731055653608, 218, 48, 'PPL', 'P'),
(47629, 'Green Hill Acres', 39.6402816772461, 0.691853431685925, -77.6616668701172, -1.35545178947054, 218, 25, 'PPL', 'P'),
(204155, 'Green Hill Country Estates', 41.2686080932617, 0.720273088942596, -111.716667175293, -1.94982367156354, 218, 52, 'PPL', 'P'),
(47644, 'Green Hill Farm', 39.4736099243164, 0.688944460827231, -76.8666687011719, -1.34157645387512, 218, 25, 'PPL', 'P'),
(102412, 'Green Hill Farms', 36.8952789306641, 0.643944095781781, -76.2525024414063, -1.33085723048755, 218, 53, 'PPL', 'P'),
(102413, 'Green Hill Forest', 38.9147186279297, 0.679189967544543, -78.1466674804688, -1.36391664699536, 218, 53, 'PPL', 'P'),
(47631, 'Green Hill Manor', 39.1866683959961, 0.683936386397337, -76.982780456543, -1.34360298630662, 218, 25, 'PPL', 'P'),
(81322, 'Green Hill Plantation', 34.5694389343262, 0.603350529971111, -82.6730575561523, -1.44291705704564, 218, 48, 'PPL', 'P'),
(102414, 'Green Hill Terrace', 37.2688903808594, 0.65046484571084, -80.1074981689453, -1.39813959858342, 218, 53, 'PPL', 'P'),
(47632, 'Green Hill Village', 38.3025016784668, 0.6685047660399, -75.7638931274414, -1.32232938920296, 218, 25, 'PPL', 'P'),
(21552, 'Green Hills', 34.9172210693359, 0.609420473306647, -85.3333282470703, -1.48934753959646, 218, 13, 'PPL', 'P'),
(47634, 'Green Hills', 39.3138885498047, 0.68615679695619, -77.2752838134766, -1.34870813295825, 218, 25, 'PPL', 'P'),
(81323, 'Green Hills', 34.8791694641113, 0.608756347509809, -82.3555603027344, -1.43737568460745, 218, 48, 'PPL', 'P'),
(87413, 'Green Hills', 36.2161102294922, 0.632090365769838, -85.501106262207, -1.49227581837305, 218, 50, 'PPL', 'P'),
(149268, 'Green Hills', 42.392219543457, 0.739883808261613, -79.4936065673828, -1.38742516888582, 218, 40, 'PPL', 'P'),
(162231, 'Green Hills', 40.1136093139648, 0.70011455738735, -80.3000030517578, -1.40149944261467, 218, 45, 'PPL', 'P'),
(200919, 'Green Hills', 45.5055618286133, 0.794221881879153, -122.727783203125, -2.14200390056832, 218, 43, 'PPL', 'P'),
(21553, 'Green Hills Estates', 34.0138893127441, 0.593654359916297, -84.7416687011719, -1.47902113246968, 218, 13, 'PPL', 'P'),
(113173, 'Green Island', 40.0105590820313, 0.698315991545165, -74.1100006103516, -1.29346351930564, 218, 37, 'PPL', 'P'),
(115849, 'Green Island', 42.1536102294922, 0.735719290107001, -90.3219375610352, -1.5764151972208, 218, 16, 'PPL', 'P'),
(149269, 'Green Island', 42.7441711425781, 0.746026522473935, -73.6919403076172, -1.28616699055104, 218, 40, 'PPL', 'P'),
(21554, 'Green Island Hills', 32.5349998474121, 0.567842869473194, -85.0072174072266, -1.48365583171474, 218, 13, 'PPL', 'P'),
(135686, 'Green Isle', 44.6791687011719, 0.779798600889448, -94.008056640625, -1.64075011178023, 218, 28, 'PPL', 'P'),
(145323, 'Green Knoll', 40.5999984741211, 0.708603649678087, -74.6125030517578, -1.30223384140749, 218, 37, 'PPL', 'P'),
(65178, 'Green Knolls', 36.4730606079102, 0.636574995887477, -79.7988891601563, -1.39275335527874, 218, 33, 'PPL', 'P'),
(94596, 'Green Lake', 28.5291690826416, 0.497927933350266, -96.793327331543, -1.68936225589604, 218, 51, 'PPL', 'P'),
(127623, 'Green Lake', 44.6711082458496, 0.779657919404864, -68.5552825927734, -1.19651540087905, 218, 26, 'PPL', 'P'),
(145324, 'Green Lake', 41.0008316040039, 0.715599507545616, -74.4800033569336, -1.29992128547492, 218, 37, 'PPL', 'P'),
(174341, 'Green Lake', 43.8441696166992, 0.765225117614262, -88.9599990844727, -1.55264488659519, 218, 57, 'PPL', 'P'),
(207557, 'Green Lake', 47.6872215270996, 0.832299026775806, -122.331939697266, -2.13509512806844, 218, 56, 'PPL', 'P'),
(81324, 'Green Lake Estates', 33.9883308410645, 0.593208280433708, -80.8441696166992, -1.41099694085216, 218, 48, 'PPL', 'P'),
(174343, 'Green Lake Terrace', 43.7825012207031, 0.764148801059706, -89.0644378662109, -1.55446768720329, 218, 57, 'PPL', 'P'),
(81325, 'Green Lakes', 33.7788887023926, 0.589552825521465, -78.7808303833008, -1.37498487764379, 218, 48, 'PPL', 'P'),
(47635, 'Green Landing', 38.8058280944824, 0.677289469211635, -76.7088928222656, -1.33882274530798, 218, 25, 'PPL', 'P'),
(162236, 'Green Lane', 40.336669921875, 0.704007699426883, -75.4694366455078, -1.31719015408938, 218, 45, 'PPL', 'P'),
(162234, 'Green Lane Farms', 40.2219390869141, 0.702005268603252, -76.8983306884766, -1.34212905980131, 218, 45, 'PPL', 'P'),
(78391, 'Green Lawn', 39.8877792358398, 0.696173078974033, -75.8419418334961, -1.32369159610053, 218, 45, 'PPL', 'P'),
(135690, 'Green Lea Mobile Home Park', 43.5205612182617, 0.759577085574422, -91.7694396972656, -1.60167887542767, 218, 28, 'PPL', 'P'),
(65180, 'Green Level', 35.7819404602051, 0.624512673783154, -78.904167175293, -1.3771375107529, 218, 33, 'PPL', 'P'),
(47636, 'Green Manor', 38.958610534668, 0.679956025832105, -76.9327774047852, -1.3427302684174, 218, 25, 'PPL', 'P'),
(47637, 'Green Manor Estates', 38.4630584716797, 0.671307010717909, -77.2533264160156, -1.34832490407738, 218, 25, 'PPL', 'P'),
(113493, 'Green Manor Village', 41.9366683959961, 0.731932940827181, -72.6600036621094, -1.26815629841495, 218, 8, 'PPL', 'P'),
(13845, 'Green Meadow', 39.7902793884277, 0.6944713856165, -75.5180587768555, -1.31803877037073, 218, 10, 'PPL', 'P'),
(47638, 'Green Meadow', 39.7188911437988, 0.693225425700506, -76.6688919067383, -1.33812459762822, 218, 25, 'PPL', 'P'),
(87417, 'Green Meadow', 35.1227798461914, 0.613008150769148, -84.8936080932617, -1.48167297512512, 218, 50, 'PPL', 'P'),
(75985, 'Green Meadow Acres', 34.7983283996582, 0.607345404764285, -98.3841705322266, -1.71712770763094, 218, 42, 'PPL', 'P'),
(102416, 'Green Meadow Point', 36.8402786254883, 0.642984159366861, -76.4102783203125, -1.3336109390547, 218, 53, 'PPL', 'P'),
(21558, 'Green Meadows', 33.8424987792969, 0.590663030800892, -84.7975006103516, -1.47999558311254, 218, 13, 'PPL', 'P'),
(47642, 'Green Meadows', 38.9674987792969, 0.680111154965602, -76.978889465332, -1.34353507569882, 218, 25, 'PPL', 'P'),
(72731, 'Green Meadows', 39.8688888549805, 0.695843379631081, -83.9444427490234, -1.46510691472234, 218, 41, 'PPL', 'P'),
(87418, 'Green Meadows', 35.8458290100098, 0.62562773933157, -86.4816665649414, -1.50938982417012, 218, 50, 'PPL', 'P'),
(102418, 'Green Meadows', 37.5297203063965, 0.655017186699194, -77.2474975585938, -1.34822317132374, 218, 53, 'PPL', 'P'),
(122718, 'Green Meadows', 40.4397201538086, 0.705806265269068, -86.9658279418945, -1.51784003430894, 218, 19, 'PPL', 'P'),
(141960, 'Green Meadows', 41.2788887023926, 0.72045251942104, -96.1286087036133, -1.67776072723933, 218, 35, 'PPL', 'P'),
(200920, 'Green Meadows', 45.6166687011719, 0.796161062626895, -118.798606872559, -2.07342683670851, 218, 43, 'PPL', 'P'),
(204158, 'Green Meadows', 40.6666717529297, 0.709767317916397, -111.831390380859, -1.95182596922911, 218, 52, 'PPL', 'P'),
(109460, 'Green Meadows Addition', 39.2641716003418, 0.685289072494015, -81.4633331298828, -1.42180338276543, 218, 58, 'PPL', 'P'),
(21560, 'Green Meadows Estates', 33.4147186279297, 0.583196858684855, -82.0422210693359, -1.43190688330898, 218, 13, 'PPL', 'P'),
(204161, 'Green Meadows Estates', 40.7144393920898, 0.710601020495646, -112.083610534668, -1.95622804135296, 218, 52, 'PPL', 'P'),
(115850, 'Green Meadows Mobile Home Park', 43.1166687011719, 0.752527831327036, -93.3863906860352, -1.62989999402508, 218, 16, 'PPL', 'P'),
(55068, 'Green Mound Ridge', 36.892219543457, 0.643890699401924, -93.2505569458008, -1.62752924802269, 218, 29, 'PPL', 'P'),
(102419, 'Green Mount', 38.5194396972656, 0.672291048740693, -78.89111328125, -1.37690967732164, 218, 53, 'PPL', 'P'),
(55069, 'Green Mountain', 37.3358306884766, 0.651633174481057, -92.3247222900391, -1.61137038495058, 218, 29, 'PPL', 'P'),
(65183, 'Green Mountain', 35.9936103820801, 0.628207010847312, -82.2591705322266, -1.43569336574685, 218, 33, 'PPL', 'P'),
(115851, 'Green Mountain', 42.1016693115234, 0.734812750071938, -92.8202819824219, -1.62001953322283, 218, 16, 'PPL', 'P'),
(186793, 'Green Mountain Falls', 38.935001373291, 0.679543968232442, -105.016387939453, -1.83288173809512, 218, 7, 'PPL', 'P'),
(186794, 'Green Mountain Village', 39.6980590820313, 0.692861837632683, -105.131942749023, -1.83489854998864, 218, 7, 'PPL', 'P'),
(65185, 'Green Needles', 35.7869415283203, 0.624599958887881, -80.3022232055664, -1.40153819160853, 218, 33, 'PPL', 'P'),
(122719, 'Green Oak', 40.9963912963867, 0.715522009557895, -86.1841735839844, -1.50419759215085, 218, 19, 'PPL', 'P'),
(131109, 'Green Oak', 42.4925003051758, 0.741634037730013, -83.6980590820313, -1.46080670851019, 218, 27, 'PPL', 'P'),
(55070, 'Green Oaks', 36.7880592346191, 0.642072759062809, -90.1641693115234, -1.57366162181171, 218, 29, 'PPL', 'P'),
(119852, 'Green Oaks', 42.2900009155273, 0.738099756647368, -87.9033279418945, -1.53420249604639, 218, 18, 'PPL', 'P'),
(162237, 'Green Oaks', 41.4308280944824, 0.723104362076487, -79.5969390869141, -1.38922866157602, 218, 45, 'PPL', 'P'),
(55071, 'Green Park', 38.523609161377, 0.672363819617479, -90.3383331298828, -1.57670135387993, 218, 29, 'PPL', 'P'),
(75986, 'Green Pastures', 35.5222206115723, 0.61997970729173, -97.335563659668, -1.69882606514575, 218, 42, 'PPL', 'P'),
(81326, 'Green Peach Orchard', 34.6661109924316, 0.605037775679731, -80.7938919067383, -1.41011942927298, 218, 48, 'PPL', 'P'),
(87419, 'Green Pine', 36.269718170166, 0.63302600083981, -82.2774963378906, -1.43601321139377, 218, 50, 'PPL', 'P'),
(102420, 'Green Place', 37.0130615234375, 0.645999789827213, -81.7402801513672, -1.42663702014393, 218, 53, 'PPL', 'P'),
(102421, 'Green Plain', 36.6966705322266, 0.640477725306933, -77.4522171020508, -1.35179620140025, 218, 53, 'PPL', 'P'),
(9213, 'Green Plains', 34.1305618286133, 0.595690679464798, -93.9522171020508, -1.63977552797931, 218, 4, 'PPL', 'P'),
(16274, 'Green Point', 29.7574996948242, 0.51936634683589, -84.8319396972656, -1.48059665857057, 218, 12, 'PPL', 'P'),
(162238, 'Green Point', 40.4808311462402, 0.706523787445762, -76.5519409179688, -1.33608341781073, 218, 45, 'PPL', 'P'),
(2850, 'Green Pond', 33.2249984741211, 0.579885617343505, -87.1263885498047, -1.52064234556598, 218, 2, 'PPL', 'P'),
(16275, 'Green Pond', 28.3075008392334, 0.494059092655681, -81.8994369506836, -1.42941483031893, 218, 12, 'PPL', 'P'),
(65187, 'Green Pond', 34.7844390869141, 0.60710299052606, -79.6327819824219, -1.38985423811608, 218, 33, 'PPL', 'P'),
(81330, 'Green Pond', 34.7999992370605, 0.607374566378221, -82.0805587768555, -1.43257600253286, 218, 48, 'PPL', 'P'),
(87420, 'Green Pond', 36.2105598449707, 0.631993493285186, -85.1769409179688, -1.48661806579524, 218, 50, 'PPL', 'P'),
(102422, 'Green Pond', 36.8811111450195, 0.643696821274567, -79.5091705322266, -1.38769681131701, 218, 53, 'PPL', 'P'),
(145325, 'Green Pond', 41.017219543457, 0.715885531046691, -74.4780578613281, -1.29988733017102, 218, 37, 'PPL', 'P'),
(145326, 'Green Pond Junction', 41.0272216796875, 0.716060101256145, -74.4169387817383, -1.29882060099639, 218, 37, 'PPL', 'P'),
(9214, 'Green Ridge', 34.9236106872559, 0.609531993177294, -94.0236129760742, -1.64102162105336, 218, 4, 'PPL', 'P'),
(47647, 'Green Ridge', 39.5449981689453, 0.690190420743225, -76.3055572509766, -1.33178321159857, 218, 25, 'PPL', 'P'),
(55072, 'Green Ridge', 38.6202812194824, 0.674051065326099, -93.4091720581055, -1.63029760397583, 218, 29, 'PPL', 'P'),
(112638, 'Green Ridge', 39.5869407653809, 0.69092245714786, -78.4391708374023, -1.36902179364699, 218, 58, 'PPL', 'P'),
(127624, 'Green Ridge', 46.7938919067383, 0.81670748359491, -67.945556640625, -1.1858736754792, 218, 26, 'PPL', 'P'),
(162240, 'Green Ridge', 40.9588890075684, 0.71486747114098, -76.0083312988281, -1.32659564011121, 218, 45, 'PPL', 'P'),
(47648, 'Green Ridge Mobile Home Park', 38.3363914489746, 0.669096254118007, -75.1247177124023, -1.31117367371272, 218, 25, 'PPL', 'P'),
(124969, 'Green Ridge Park', 42.4516716003418, 0.740921442401335, -73.1883316040039, -1.27737736053129, 218, 23, 'PPL', 'P'),
(60111, 'Green River', 34.7722206115723, 0.606889737901772, -90.2430572509766, -1.57503847609528, 218, 30, 'PPL', 'P'),
(119853, 'Green River', 41.4755592346191, 0.723885067750043, -90.3191680908203, -1.57636686084702, 218, 18, 'PPL', 'P'),
(131112, 'Green River', 44.9891700744629, 0.78520914553908, -85.0552825927734, -1.48449472745812, 218, 27, 'PPL', 'P'),
(149271, 'Green River', 42.2619400024414, 0.737610001322903, -73.4727783203125, -1.28234189227736, 218, 40, 'PPL', 'P'),
(172075, 'Green River', 42.7758293151855, 0.746579061821099, -72.6686096191406, -1.26830650070043, 218, 55, 'PPL', 'P'),
(192595, 'Green River', 38.9952812194824, 0.680596050021078, -110.161109924316, -1.92267407583072, 218, 52, 'PPL', 'P'),
(207558, 'Green River', 47.288890838623, 0.825346844750155, -122.08805847168, -2.13083859769817, 218, 56, 'PPL', 'P'),
(209483, 'Green River', 41.5286102294922, 0.724810982282037, -109.465560913086, -1.91053445547576, 218, 59, 'PPL', 'P'),
(87421, 'Green River (historical)', 35.2708282470703, 0.615592082816797, -87.7577819824219, -1.53166223984062, 218, 50, 'PPL', 'P'),
(47649, 'Green Road Manor', 39.5397186279297, 0.690098275369508, -76.4794387817383, -1.33481801681877, 218, 25, 'PPL', 'P'),
(119854, 'Green Rock', 41.4730606079102, 0.723841458487193, -90.3574981689453, -1.57703584691284, 218, 18, 'PPL', 'P'),
(109461, 'Green Run', 39.3808288574219, 0.687325125726408, -81.2216720581055, -1.41758560138902, 218, 58, 'PPL', 'P'),
(81331, 'Green Sea', 34.1261100769043, 0.595612981739995, -78.975830078125, -1.37838826435885, 218, 48, 'PPL', 'P'),
(149272, 'Green Settlement', 43.8555603027344, 0.765423922589636, -76.0377807617188, -1.32710963020159, 218, 40, 'PPL', 'P'),
(186795, 'Green Settlement', 38.7755584716797, 0.676761164630391, -104.891937255859, -1.83070966391005, 218, 7, 'PPL', 'P'),
(178289, 'Green Spot', 34.1897201538086, 0.596723187019422, -109.403060913086, -1.90944362469326, 218, 5, 'PPL', 'P'),
(13846, 'Green Spring', 39.3175010681152, 0.686219847294998, -75.649169921875, -1.32032709153738, 218, 10, 'PPL', 'P'),
(36192, 'Green Spring', 38.3161087036133, 0.668742253430108, -85.6138916015625, -1.49424429389279, 218, 21, 'PPL', 'P'),
(47650, 'Green Spring', 38.6002807617188, 0.673701991486217, -76.7752838134766, -1.33998148669827, 218, 25, 'PPL', 'P'),
(102424, 'Green Spring', 36.6347198486328, 0.639396481904361, -81.9958267211914, -1.43109714917954, 218, 53, 'PPL', 'P'),
(109462, 'Green Spring', 39.5316696166992, 0.689957793622006, -78.6166687011719, -1.37211971578502, 218, 58, 'PPL', 'P'),
(162241, 'Green Spring', 40.149169921875, 0.700735207079393, -77.4641723632813, -1.35200486007165, 218, 45, 'PPL', 'P'),
(13854, 'Green Spring Farm', 39.3163909912109, 0.686200472798068, -75.6408309936523, -1.32018154978381, 218, 10, 'PPL', 'P'),
(47651, 'Green Spring Furnace', 39.622501373291, 0.691543106839903, -77.9747161865234, -1.36091553076295, 218, 25, 'PPL', 'P'),
(47652, 'Green Spring Junction', 39.4088897705078, 0.687814881050874, -76.7716674804688, -1.33991836978044, 218, 25, 'PPL', 'P'),
(41182, 'Green Springs', 32.5361099243164, 0.567862243970124, -92.209716796875, -1.60936316043699, 218, 22, 'PPL', 'P'),
(65189, 'Green Springs', 35.6083297729492, 0.621482595673889, -77.3486099243164, -1.34998791502008, 218, 33, 'PPL', 'P'),
(78392, 'Green Springs', 39.8488883972168, 0.695494305791199, -77.0036087036133, -1.34396650779541, 218, 45, 'PPL', 'P'),
(81333, 'Green Springs', 34.1286087036133, 0.595656591002845, -80.9044418334961, -1.41204888948274, 218, 48, 'PPL', 'P'),
(102426, 'Green Springs', 38.0858306884766, 0.664723143871015, -78.1119384765625, -1.36331051153126, 218, 53, 'PPL', 'P'),
(155531, 'Green Springs', 41.2561111450195, 0.720054976049319, -83.0516662597656, -1.44952502550039, 218, 41, 'PPL', 'P'),
(190280, 'Green Springs', 39.1172218322754, 0.682724315206215, -115.571670532227, -2.01710617281746, 218, 39, 'PPL', 'P'),
(190281, 'Green Springs (historical)', 38.9022216796875, 0.678971854651266, -117.824440002441, -2.05642441736112, 218, 39, 'PPL', 'P'),
(47653, 'Green Springs Hills', 39.4575004577637, 0.688663297595146, -76.3647232055664, -1.33281585231125, 218, 25, 'PPL', 'P'),
(181897, 'Green Springs Ranch', 38.7016716003418, 0.675471595451547, -121.03360748291, -2.11243495614323, 218, 6, 'PPL', 'P'),
(181898, 'Green Springs Valley', 38.7097206115723, 0.675612077199049, -121.047218322754, -2.11267251011246, 218, 6, 'PPL', 'P'),
(196637, 'Green Star Trailer Court', 46.4091682434082, 0.809992788959466, -105.822776794434, -1.84695587866592, 218, 31, 'PPL', 'P'),
(2852, 'Green Street', 31.576940536499, 0.551121580068373, -87.1308288574219, -1.5207198435537, 218, 2, 'PPL', 'P'),
(149273, 'Green Street', 44.4230613708496, 0.775328684736831, -73.6350021362305, -1.28517323199028, 218, 40, 'PPL', 'P'),
(109463, 'Green Sulphur Springs', 37.8077812194824, 0.659870265153645, -80.8163909912109, -1.41051211237571, 218, 58, 'PPL', 'P'),
(41183, 'Green Terrace', 32.461109161377, 0.566553233715323, -92.0872192382813, -1.60722517471387, 218, 22, 'PPL', 'P'),
(131113, 'Green Timbers', 45.1716690063477, 0.788394352781842, -84.5411071777344, -1.47552067353288, 218, 27, 'PPL', 'P'),
(55075, 'Green Town', 36.5141716003418, 0.637292518064171, -91.5422210693359, -1.59771316224844, 218, 29, 'PPL', 'P'),
(81334, 'Green Town', 33.394718170166, 0.582847784844973, -80.3533325195313, -1.40243021741565, 218, 48, 'PPL', 'P'),
(9215, 'Green Tree', 35.5166702270508, 0.619882834807078, -92.3833312988281, -1.61239330512528, 218, 4, 'PPL', 'P'),
(70891, 'Green Tree', 39.7508316040039, 0.693782891895687, -75.0763931274414, -1.3103302505955, 218, 37, 'PPL', 'P'),
(162244, 'Green Tree', 40.4116706848145, 0.705316709681684, -80.0458297729492, -1.39706328202887, 218, 45, 'PPL', 'P'),
(204165, 'Green Tree', 40.6627807617188, 0.7096994073086, -111.970001220703, -1.95424518476334, 218, 52, 'PPL', 'P'),
(2853, 'Green Tree (historical)', 34.7999992370605, 0.607374566378221, -87.7986068725586, -1.53237476859027, 218, 2, 'PPL', 'P'),
(47654, 'Green Tree Manor', 39.0086097717285, 0.680828677142296, -77.1308288574219, -1.34618691835427, 218, 25, 'PPL', 'P'),
(178290, 'Green Tree Mobile Home Park', 33.3083305358887, 0.581340036193825, -111.829719543457, -1.95179680761518, 218, 5, 'PPL', 'P'),
(170421, 'Green Trees Subdivision', 44.9472198486328, 0.78447697597639, -97.1555633544922, -1.69568446716584, 218, 49, 'PPL', 'P'),
(13848, 'Green Valley', 39.7013893127441, 0.692919961123474, -75.6908264160156, -1.32105413451497, 218, 10, 'PPL', 'P'),
(29934, 'Green Valley', 39.6061096191406, 0.691257016759801, -86.1399993896484, -1.50342660701527, 218, 19, 'PPL', 'P'),
(47656, 'Green Valley', 39.5966682434082, 0.691092233667353, -76.4886093139648, -1.33497807280029, 218, 25, 'PPL', 'P'),
(65192, 'Green Valley', 36.4086112976074, 0.635450143222055, -81.70361328125, -1.42599706253398, 218, 33, 'PPL', 'P'),
(81335, 'Green Valley', 34.1258316040039, 0.595608121471006, -80.7102813720703, -1.40866015015367, 218, 48, 'PPL', 'P'),
(87427, 'Green Valley', 36.3777809143066, 0.634912051523804, -82.3730621337891, -1.43768114918449, 218, 50, 'PPL', 'P'),
(94597, 'Green Valley', 33.3133316040039, 0.581427321298552, -97.0638885498047, -1.69408443998292, 218, 51, 'PPL', 'P'),
(102433, 'Green Valley', 37.2286109924316, 0.649761837762086, -79.991943359375, -1.39612278668991, 218, 53, 'PPL', 'P'),
(109466, 'Green Valley', 37.3111114501953, 0.651201742384464, -81.1394424438477, -1.41615042387758, 218, 58, 'PPL', 'P'),
(119855, 'Green Valley', 40.4075012207031, 0.705243938804897, -89.6427764892578, -1.56456160036691, 218, 18, 'PPL', 'P'),
(135693, 'Green Valley', 44.5269393920898, 0.77714169822793, -95.7569427490234, -1.67127393261417, 218, 28, 'PPL', 'P'),
(155533, 'Green Valley', 40.4249992370605, 0.705549336802902, -82.5783309936523, -1.44126376664091, 218, 41, 'PPL', 'P'),
(162245, 'Green Valley', 41.0613899230957, 0.716656449603241, -79.041389465332, -1.3795324915212, 218, 45, 'PPL', 'P'),
(174346, 'Green Valley', 44.7955589294434, 0.781829993589933, -88.2702789306641, -1.54060699899387, 218, 57, 'PPL', 'P'),
(178291, 'Green Valley', 31.8541698455811, 0.555960144294883, -110.993057250977, -1.93719429588411, 218, 5, 'PPL', 'P'),
(181901, 'Green Valley', 38.253059387207, 0.667641835267687, -122.161109924316, -2.13211358607004, 218, 6, 'PPL', 'P'),
(202177, 'Green Valley', 44.0355606079102, 0.768565520569548, -103.110832214355, -1.79962351661194, 218, 49, 'PPL', 'P'),
(181902, 'Green Valley Acres', 38.7125015258789, 0.675660613309916, -121.070831298828, -2.11308463429115, 218, 6, 'PPL', 'P'),
(186796, 'Green Valley Acres', 39.5022201538086, 0.689443803531621, -105.311393737793, -1.83803056058863, 218, 7, 'PPL', 'P'),
(94598, 'Green Valley Development Subdividion Colonia', 26.2910003662109, 0.458864520033416, -98.0250015258789, -1.71085902589905, 218, 51, 'PPL', 'P'),
(21562, 'Green Valley Estates', 33.5608291625977, 0.585746968586661, -84.3930587768555, -1.47293674148523, 218, 13, 'PPL', 'P'),
(81336, 'Green Valley Estates', 34.127498626709, 0.595637216505915, -81.370002746582, -1.42017446028469, 218, 48, 'PPL', 'P'),
(87429, 'Green Valley Estates', 35.8661117553711, 0.625981740019469, -86.8572235107422, -1.51594452940308, 218, 50, 'PPL', 'P'),
(94599, 'Green Valley Farms', 26.1216697692871, 0.455909143592728, -97.5602798461914, -1.70274810248311, 218, 51, 'PPL', 'P'),
(94600, 'Green Valley Farms Colonia', 26.121000289917, 0.455897458973445, -97.5619964599609, -1.70277806304537, 218, 51, 'PPL', 'P'),
(181903, 'Green Valley Lake', 34.2408294677734, 0.597615212826544, -117.076393127441, -2.04336853643311, 218, 6, 'PPL', 'P'),
(181904, 'Green Valley Mobile Estates', 33.0550003051758, 0.576918589573048, -117.264167785645, -2.04664582247057, 218, 6, 'PPL', 'P'),
(115852, 'Green Valley Mobile Home Court', 40.9438896179199, 0.714605682405826, -91.5650024414063, -1.59811077219919, 218, 16, 'PPL', 'P'),
(135694, 'Green Valley Mobile Home Park', 44.3236083984375, 0.773592902917345, -93.9577789306641, -1.63987260020104, 218, 28, 'PPL', 'P'),
(181905, 'Green Valley Mobile Home Park', 33.1827812194824, 0.579148787248907, -117.279716491699, -2.04691719858564, 218, 6, 'PPL', 'P'),
(47658, 'Green Valley North', 39.452220916748, 0.688571152221429, -76.7211074829102, -1.33903593135324, 218, 25, 'PPL', 'P'),
(178292, 'Green Valley Trailer Park', 33.3936080932617, 0.582828410348043, -112.009170532227, -1.95492881821516, 218, 5, 'PPL', 'P'),
(47659, 'Green Village', 39.497501373291, 0.68936144527491, -77.3702774047852, -1.35036608389487, 218, 25, 'PPL', 'P'),
(78393, 'Green Village', 39.9930610656738, 0.69801059354716, -77.6086120605469, -1.35452580835952, 218, 45, 'PPL', 'P'),
(87430, 'Green Village', 36.5361099243164, 0.637675414049898, -82.6769409179688, -1.44298483449538, 218, 50, 'PPL', 'P'),
(145327, 'Green Village', 40.7391700744629, 0.711032652329321, -74.4538879394531, -1.29946548545435, 218, 37, 'PPL', 'P'),
(47660, 'Green Wood Knolls', 39.0716705322266, 0.681929295041799, -77.070556640625, -1.34513496972369, 218, 25, 'PPL', 'P'),
(70892, 'Green-Fields', 39.8169403076172, 0.694936706437964, -75.1666717529297, -1.31190590985444, 218, 37, 'PPL', 'P'),
(16276, 'Green-Mar Acres', 25.670560836792, 0.448035807435531, -80.3430633544922, -1.40225098667429, 218, 12, 'PPL', 'P'),
(21563, 'Greenacres', 33.8813896179199, 0.591341803983726, -84.841667175293, -1.48076643509006, 218, 13, 'PPL', 'P'),
(36190, 'Greenacres', 37.0247192382813, 0.646203255334495, -88.01611328125, -1.53617097156612, 218, 21, 'PPL', 'P'),
(181906, 'Greenacres', 35.3833312988281, 0.617555631488512, -119.10888671875, -2.07884224162713, 218, 6, 'PPL', 'P'),
(207559, 'Greenacres', 47.6680603027344, 0.83196460032192, -117.163063049316, -2.04488121193228, 218, 56, 'PPL', 'P'),
(16277, 'Greenacres City', 26.6233291625977, 0.464664751729554, -80.1255569458008, -1.39845478369844, 218, 12, 'PPL', 'P'),
(41184, 'Greenacres Place', 32.5694389343262, 0.568443944931225, -93.7158279418945, -1.63564975881856, 218, 22, 'PPL', 'P'),
(162249, 'Greenawald', 40.603328704834, 0.708661773168878, -75.8724975585938, -1.32422489410882, 218, 45, 'PPL', 'P'),
(162250, 'Greenawalds', 40.6272201538086, 0.709078757616557, -75.517219543457, -1.31802412298473, 218, 45, 'PPL', 'P'),
(87432, 'Greenback', 35.6611099243164, 0.622403783094947, -84.1722183227539, -1.46908234843955, 218, 50, 'PPL', 'P'),
(162251, 'Greenback', 40.7811088562012, 0.711764622154929, -76.5224990844727, -1.33556956087839, 218, 45, 'PPL', 'P'),
(200921, 'Greenback (historical)', 42.6527786254883, 0.744431422139032, -123.310829162598, -2.15217997225157, 218, 43, 'PPL', 'P'),
(102429, 'Greenbackville', 38.0113906860352, 0.66342392073322, -75.3905563354492, -1.31581343296386, 218, 53, 'PPL', 'P'),
(13849, 'Greenbank', 39.7388916015625, 0.693574499540388, -75.6361083984375, -1.32009912494807, 218, 10, 'PPL', 'P'),
(207560, 'Greenbank', 48.098331451416, 0.839474248542753, -122.571670532227, -2.13927922045706, 218, 56, 'PPL', 'P'),
(47661, 'Greenbank Farms', 39.5602798461914, 0.690457136326396, -76.0052795410156, -1.32654237688941, 218, 25, 'PPL', 'P'),
(172076, 'Greenbank Hollow', 44.3772201538086, 0.774528604566344, -72.1216735839844, -1.25876066608915, 218, 55, 'PPL', 'P'),
(47662, 'Greenbelt', 39.0044403076172, 0.68075590626551, -76.8758316040039, -1.34173637669858, 218, 25, 'PPL', 'P'),
(21564, 'Greenberry Crossroads', 32.9538917541504, 0.575153912455734, -83.4497222900391, -1.45647241383608, 218, 13, 'PPL', 'P'),
(47663, 'Greenberry Hills', 39.6286087036133, 0.691649699862533, -77.7547225952148, -1.35707591826133, 218, 25, 'PPL', 'P'),
(149274, 'Greenboro', 43.6438903808594, 0.761729585525478, -75.8891677856445, -1.32451584445791, 218, 40, 'PPL', 'P'),
(16278, 'Greenbriar', 28.7758293151855, 0.502232966541893, -81.3180618286133, -1.41926792024962, 218, 12, 'PPL', 'P'),
(29938, 'Greenbriar', 39.901668548584, 0.696415493212257, -86.1797180175781, -1.50411982784702, 218, 19, 'PPL', 'P'),
(36191, 'Greenbriar', 37.4944381713867, 0.65440139727614, -85.2313919067383, -1.48756841483023, 218, 21, 'PPL', 'P'),
(47664, 'Greenbriar', 39.1530609130859, 0.683349825167247, -76.7061080932617, -1.33877414261809, 218, 25, 'PPL', 'P'),
(81339, 'Greenbriar', 34.6402816772461, 0.604586969086208, -82.9102783203125, -1.44705734043433, 218, 48, 'PPL', 'P'),
(102432, 'Greenbriar', 36.8497200012207, 0.64314894245931, -76.3469390869141, -1.3325054608862, 218, 53, 'PPL', 'P'),
(119857, 'Greenbriar', 40.519718170166, 0.707202494049569, -88.9475021362305, -1.55242677370191, 218, 18, 'PPL', 'P'),
(145329, 'Greenbriar', 40.0911102294922, 0.699721874284618, -74.1383285522461, -1.29395793516202, 218, 37, 'PPL', 'P'),
(162252, 'Greenbriar', 40.2983283996582, 0.703338513623973, -76.7011108398438, -1.33868692409239, 218, 45, 'PPL', 'P'),
(178293, 'Greenbriar', 33.584171295166, 0.586154365654415, -112.163887023926, -1.95762913040245, 218, 5, 'PPL', 'P'),
(204169, 'Greenbriar Condominiums', 40.8388900756836, 0.712773094680715, -111.91194152832, -1.95323185196856, 218, 52, 'PPL', 'P'),
(81343, 'Greenbriar Estates', 33.8722190856934, 0.591181748002212, -79.7911071777344, -1.39261753406315, 218, 48, 'PPL', 'P'),
(204170, 'Greenbriar Mobile Home Park', 40.7061080932617, 0.710455611900128, -112.012222290039, -1.95498208143696, 218, 52, 'PPL', 'P'),
(13850, 'Greenbridge', 39.6749992370605, 0.692459367412945, -75.7230606079102, -1.32161672729525, 218, 10, 'PPL', 'P'),
(9216, 'Greenbrier', 35.2338905334473, 0.614947398095916, -92.3874969482422, -1.61246600942304, 218, 4, 'PPL', 'P'),
(21568, 'Greenbrier', 33.4925003051758, 0.584554405050523, -82.0472183227539, -1.43199410183468, 218, 13, 'PPL', 'P'),
(29940, 'Greenbrier', 38.1205596923828, 0.665329279335117, -87.2836074829102, -1.52338633359514, 218, 19, 'PPL', 'P'),
(36193, 'Greenbrier', 37.7294387817383, 0.658502931670971, -85.4591674804688, -1.49154384854745, 218, 21, 'PPL', 'P'),
(47670, 'Greenbrier', 39.5497207641602, 0.690272845578963, -77.6211090087891, -1.3547439212528, 218, 25, 'PPL', 'P'),
(55083, 'Greenbrier', 37.1105613708496, 0.647701483184746, -90.0255584716797, -1.57124240627748, 218, 29, 'PPL', 'P'),
(65200, 'Greenbrier', 35.5888900756836, 0.621143308951013, -77.3925018310547, -1.35075397330764, 218, 33, 'PPL', 'P'),
(72744, 'Greenbrier', 39.6388893127441, 0.691829130340978, -81.1175003051758, -1.41576746131282, 218, 41, 'PPL', 'P'),
(87437, 'Greenbrier', 35.8450012207031, 0.625613291682656, -87.1416702270508, -1.52090906114915, 218, 50, 'PPL', 'P'),
(112204, 'Greenbrier', 34.8325004577637, 0.607941819690408, -87.6474990844727, -1.52973744016276, 218, 2, 'PPL', 'P'),
(162253, 'Greenbrier', 40.7130584716797, 0.710576918887781, -76.6830596923828, -1.33837187213543, 218, 45, 'PPL', 'P'),
(60110, 'Greenbrier (historical)', 33.9124984741211, 0.591884755950966, -88.459716796875, -1.5439133134872, 218, 30, 'PPL', 'P'),
(87438, 'Greenbrier (historical)', 35.7077789306641, 0.623218310914348, -83.379997253418, -1.45525548237597, 218, 50, 'PPL', 'P'),
(109469, 'Greenbrier Addition', 39.3661117553711, 0.68706826383927, -81.4911117553711, -1.42228821124188, 218, 58, 'PPL', 'P'),
(178294, 'Greenbrier East', 33.6152801513672, 0.586697317621655, -111.966667175293, -1.95418699469352, 218, 5, 'PPL', 'P'),
(65203, 'Greenbrier Estates', 35.7174987792969, 0.623387954275786, -78.6458282470703, -1.37262864586934, 218, 33, 'PPL', 'P'),
(47671, 'Greenbrier Hills', 39.5416717529297, 0.690132363831461, -76.3236083984375, -1.33209826355553, 218, 25, 'PPL', 'P'),
(109475, 'Greenbrier Junction', 38.7799987792969, 0.676838662618112, -79.7655563354492, -1.39217158773861, 218, 58, 'PPL', 'P'),
(181907, 'Greenbrier Mobile Home Park', 32.832218170166, 0.573030307802505, -117.013328552246, -2.04226785195458, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(102435, 'Greenbrier Park', 37.2522201538086, 0.650173895361748, -79.9794387817383, -1.39590454063858, 218, 53, 'PPL', 'P'),
(21571, 'Greenbrook', 33.8022193908691, 0.589960022852139, -84.602783203125, -1.47659712324549, 218, 13, 'PPL', 'P'),
(41185, 'Greenbrook', 32.4244384765625, 0.56591320952635, -93.7516708374023, -1.63627533535862, 218, 22, 'PPL', 'P'),
(162254, 'Greenbrook', 40.1469383239746, 0.700696258348451, -74.8349990844727, -1.30611712975099, 218, 45, 'PPL', 'P'),
(113297, 'Greenburr', 41.0058288574219, 0.715686726071316, -77.3547210693359, -1.35009457462174, 218, 45, 'PPL', 'P'),
(32623, 'Greenbush', 37.5144386291504, 0.654750471116022, -94.9877777099609, -1.6578494701913, 218, 20, 'PPL', 'P'),
(72746, 'Greenbush', 39.601390838623, 0.691174658503091, -84.4986114501953, -1.47477898316929, 218, 41, 'PPL', 'P'),
(102436, 'Greenbush', 37.7408294677734, 0.658701736646346, -75.6813888549805, -1.32088941800155, 218, 53, 'PPL', 'P'),
(115857, 'Greenbush', 41.4249992370605, 0.723002629322846, -93.4513931274414, -1.63103450064945, 218, 16, 'PPL', 'P'),
(119858, 'Greenbush', 40.7119407653809, 0.710557411232796, -90.5352783203125, -1.58013869589889, 218, 18, 'PPL', 'P'),
(124970, 'Greenbush', 42.1791687011719, 0.736165369589589, -70.75, -1.23482044578599, 218, 23, 'PPL', 'P'),
(127625, 'Greenbush', 45.0802803039551, 0.786799319025966, -68.6513900756836, -1.19819279289164, 218, 26, 'PPL', 'P'),
(131116, 'Greenbush', 44.5877799987793, 0.778203567133572, -83.3163909912109, -1.45414534367557, 218, 27, 'PPL', 'P'),
(135696, 'Greenbush', 48.7005615234375, 0.84998514615405, -96.1813888549805, -1.67868191466039, 218, 28, 'PPL', 'P'),
(149276, 'Greenbush', 42.6463890075684, 0.744319902268385, -74.4441680908203, -1.29929584209292, 218, 40, 'PPL', 'P'),
(172077, 'Greenbush', 43.4169387817383, 0.757768532878149, -72.5183334350586, -1.26568368650086, 218, 55, 'PPL', 'P'),
(174349, 'Greenbush', 43.776668548584, 0.764047001727038, -88.0838928222656, -1.53735394772234, 218, 57, 'PPL', 'P'),
(21570, 'Greenbush (historical)', 34.6358299255371, 0.604509271361405, -85.1919403076172, -1.48687985453039, 218, 13, 'PPL', 'P'),
(174350, 'Greenbush Addition', 43.061939239502, 0.751572622023052, -89.4027786254883, -1.56037284744638, 218, 57, 'PPL', 'P'),
(29941, 'Greencastle', 39.6444396972656, 0.691926002825629, -86.8647232055664, -1.51607542377066, 218, 19, 'PPL', 'P'),
(36194, 'Greencastle', 37.0916709899902, 0.647371783841794, -86.4955596923828, -1.50963230498737, 218, 21, 'PPL', 'P'),
(72747, 'Greencastle', 39.7738914489746, 0.694185362115425, -82.7608337402344, -1.4444490404627, 218, 41, 'PPL', 'P'),
(78395, 'Greencastle', 39.7902793884277, 0.6944713856165, -77.7280578613281, -1.35661053086084, 218, 45, 'PPL', 'P'),
(109472, 'Greencastle', 39.1311111450195, 0.682966729444439, -81.3794403076172, -1.42033917679811, 218, 58, 'PPL', 'P'),
(47672, 'Greencastle Manor', 39.0747184753418, 0.681982491684573, -76.9241714477539, -1.34258006613192, 218, 25, 'PPL', 'P'),
(195028, 'Greencreek', 46.1072196960449, 0.804722792636363, -116.263328552246, -2.02917788256463, 218, 17, 'PPL', 'P'),
(65205, 'Greencrest', 34.7627792358398, 0.606724954809324, -77.4897232055664, -1.35245080639619, 218, 33, 'PPL', 'P'),
(81344, 'Greencrest', 32.7211112976074, 0.571091127054764, -79.9591674804688, -1.39555073968776, 218, 48, 'PPL', 'P'),
(149277, 'Greencrest', 42.439998626709, 0.740717710577944, -79.4227828979492, -1.38618906266586, 218, 40, 'PPL', 'P'),
(162255, 'Greencrest Park', 41.3458290100098, 0.721620848191258, -80.4052810668945, -1.40333689060877, 218, 45, 'PPL', 'P'),
(47673, 'Greencroft', 39.5130615234375, 0.689633021127071, -76.686393737793, -1.33843006220525, 218, 25, 'PPL', 'P'),
(27326, 'Greendale', 38.6297187805176, 0.67421578183952, -88.6977767944336, -1.54806824426189, 218, 18, 'PPL', 'P'),
(36195, 'Greendale', 38.1058311462402, 0.665072217710897, -84.5255584716797, -1.4752492974178, 218, 21, 'PPL', 'P'),
(41186, 'Greendale', 30.5069408416748, 0.532446562398356, -91.1152801513672, -1.59026163751839, 218, 22, 'PPL', 'P'),
(55080, 'Greendale', 38.6952781677246, 0.675360009001873, -90.3130569458008, -1.57626020124536, 218, 29, 'PPL', 'P'),
(72748, 'Greendale', 39.5419387817383, 0.690137024363368, -82.2755584716797, -1.43597938924792, 218, 41, 'PPL', 'P'),
(102438, 'Greendale', 36.7472190856934, 0.641359963997049, -82.0511093139648, -1.43206201244247, 218, 53, 'PPL', 'P'),
(109473, 'Greendale', 38.2955589294434, 0.668383592210301, -81.1536102294922, -1.41639769838479, 218, 58, 'PPL', 'P'),
(122725, 'Greendale', 41.1133308410645, 0.717562989638304, -85.0888900756836, -1.48508128868821, 218, 19, 'PPL', 'P'),
(124971, 'Greendale', 42.3069381713867, 0.738395367528367, -71.7958297729492, -1.25307361873934, 218, 23, 'PPL', 'P'),
(149278, 'Greendale', 42.207218170166, 0.736654925176973, -73.8475036621094, -1.28888208328238, 218, 40, 'PPL', 'P'),
(162257, 'Greendale', 41.6641693115234, 0.727176934594463, -78.7813873291016, -1.37499459818176, 218, 45, 'PPL', 'P'),
(174352, 'Greendale', 42.940559387207, 0.749454143954921, -87.9958267211914, -1.5358169042992, 218, 57, 'PPL', 'P'),
(181909, 'Greendale', 38.3736114501953, 0.669745865686904, -121.584999084473, -2.12205855505834, 218, 6, 'PPL', 'P'),
(47674, 'Greendale Estates', 39.5327796936035, 0.689977168118936, -76.4930572509766, -1.33505570394606, 218, 25, 'PPL', 'P'),
(145330, 'Greendell', 40.9738883972168, 0.715129259876135, -74.8213882446289, -1.30587957578176, 218, 37, 'PPL', 'P'),
(55081, 'Greendoor', 38.8211097717285, 0.677556184794807, -93.8266677856445, -1.63758427903439, 218, 29, 'PPL', 'P'),
(115859, 'Greene', 42.8958282470703, 0.748673438281365, -92.8022232055664, -1.61970434810782, 218, 16, 'PPL', 'P'),
(122726, 'Greene', 40.4083290100098, 0.705258386453811, -85.0999984741211, -1.48527516681556, 218, 19, 'PPL', 'P'),
(127627, 'Greene', 44.1897201538086, 0.771256112218855, -70.1408309936523, -1.22418844092412, 218, 26, 'PPL', 'P'),
(149279, 'Greene', 42.3291702270508, 0.738783390099192, -75.7702789306641, -1.32244084249458, 218, 40, 'PPL', 'P'),
(155540, 'Greene', 41.4619407653809, 0.723647380622754, -80.7466735839844, -1.40929531407366, 218, 41, 'PPL', 'P'),
(169402, 'Greene', 41.6911087036133, 0.727647115684916, -71.7463912963867, -1.25221075454615, 218, 47, 'PPL', 'P'),
(198370, 'Greene', 48.6563911437988, 0.849214227597499, -101.700828552246, -1.77501431024295, 218, 34, 'PPL', 'P'),
(155541, 'Greene Center', 41.461669921875, 0.723642653511819, -80.7624969482422, -1.4095714838787, 218, 41, 'PPL', 'P'),
(127628, 'Greene Corner', 44.1780586242676, 0.771052580132546, -70.168327331543, -1.22466834255255, 218, 26, 'PPL', 'P'),
(65207, 'Greene Cove', 36.0058288574219, 0.6284202634716, -82.1125030517578, -1.43313353530707, 218, 33, 'PPL', 'P'),
(47684, 'Greene Fields', 39.189998626709, 0.683994509888128, -76.9569396972656, -1.34315197997601, 218, 25, 'PPL', 'P'),
(55087, 'Greene Springs (historical)', 37.8197212219238, 0.660078657508944, -94.1711120605469, -1.64359596572108, 218, 29, 'PPL', 'P'),
(47675, 'Greene Tree', 39.3905601501465, 0.687494968824928, -76.7341690063477, -1.33926389794255, 218, 25, 'PPL', 'P'),
(21574, 'Greene Valley Estates', 33.6094398498535, 0.586595385130932, -85.07861328125, -1.48490192478879, 218, 13, 'PPL', 'P'),
(102440, 'Greenes Corner', 37.975830078125, 0.662803271041177, -77.7202835083008, -1.3564748428033, 218, 53, 'PPL', 'P'),
(162264, 'Greenes Landing', 41.9308280944824, 0.731831008336458, -76.5252838134766, -1.33561816356829, 218, 45, 'PPL', 'P'),
(65209, 'Greenevers', 34.8222198486328, 0.607762389211964, -77.9272232055664, -1.36008662187366, 218, 33, 'PPL', 'P'),
(87441, 'Greeneville', 36.1630592346191, 0.631164451237845, -82.8311080932617, -1.44567555930274, 218, 50, 'PPL', 'P'),
(2861, 'Greenfield', 34.8277816772461, 0.607859461433697, -86.4122161865234, -1.50817768639997, 218, 2, 'PPL', 'P'),
(9219, 'Greenfield', 35.6322212219238, 0.621899580121568, -90.7125015258789, -1.58323182434697, 218, 4, 'PPL', 'P'),
(16281, 'Greenfield', 28.3533306121826, 0.494858973089086, -82.504997253418, -1.43998385142102, 218, 12, 'PPL', 'P'),
(27328, 'Greenfield', 39.3436088562012, 0.686675514157511, -90.2125015258789, -1.574505178087, 218, 18, 'PPL', 'P'),
(29947, 'Greenfield', 39.7849998474121, 0.694379240242783, -85.7694396972656, -1.49695912030801, 218, 19, 'PPL', 'P'),
(41187, 'Greenfield', 32.7580604553223, 0.571736011512726, -91.2283325195313, -1.59223477357003, 218, 22, 'PPL', 'P'),
(47677, 'Greenfield', 39.7122192382813, 0.693108978981842, -77.0027770996094, -1.34395199356747, 218, 25, 'PPL', 'P'),
(55085, 'Greenfield', 36.9650001525879, 0.645160960662865, -89.1716690063477, -1.55633922365935, 218, 29, 'PPL', 'P'),
(60114, 'Greenfield', 32.2491683959961, 0.56285416954023, -90.0527801513672, -1.57171751421596, 218, 30, 'PPL', 'P'),
(65211, 'Greenfield', 36.060001373291, 0.629365752237605, -76.4558334350586, -1.33440602579814, 218, 33, 'PPL', 'P'),
(70893, 'Greenfield', 39.228328704834, 0.684663495953956, -74.7061080932617, -1.3038675575782, 218, 37, 'PPL', 'P'),
(72750, 'Greenfield', 39.3519401550293, 0.686820922753029, -83.3827819824219, -1.45530408506587, 218, 41, 'PPL', 'P'),
(75988, 'Greenfield', 35.7286109924316, 0.623581898982171, -98.3775024414063, -1.7170113274913, 218, 42, 'PPL', 'P'),
(81345, 'Greenfield', 33.5344390869141, 0.585286374876131, -81.9411087036133, -1.43014213961263, 218, 48, 'PPL', 'P'),
(87442, 'Greenfield', 36.1533317565918, 0.630994674718352, -88.8005599975586, -1.54986214957217, 218, 50, 'PPL', 'P'),
(102446, 'Greenfield', 36.7313919067383, 0.641083727612981, -81.8411102294922, -1.42839683699225, 218, 53, 'PPL', 'P'),
(115862, 'Greenfield', 41.3052787780762, 0.720913113131569, -94.4611129760742, -1.64865743653083, 218, 16, 'PPL', 'P'),
(124972, 'Greenfield', 42.5875015258789, 0.743292121824696, -72.5999984741211, -1.26710901031627, 218, 23, 'PPL', 'P'),
(127630, 'Greenfield', 45.0472183227539, 0.786222278596773, -68.4819412231445, -1.1952353525011, 218, 26, 'PPL', 'P'),
(135699, 'Greenfield', 45.103328704834, 0.787201589508623, -93.6911087036133, -1.63521832672197, 218, 28, 'PPL', 'P'),
(140138, 'Greenfield', 47.2744407653809, 0.825094643394924, -97.2172164916992, -1.69676051740428, 218, 34, 'PPL', 'P'),
(143902, 'Greenfield', 42.9505615234375, 0.749628714164376, -71.8727798461914, -1.25441665087706, 218, 36, 'PPL', 'P'),
(149282, 'Greenfield', 43.1036109924316, 0.752299931316753, -73.8644409179688, -1.28917769416338, 218, 40, 'PPL', 'P'),
(162268, 'Greenfield', 41.1988906860352, 0.719056290640539, -80.3630599975586, -1.40259999393514, 218, 45, 'PPL', 'P'),
(170423, 'Greenfield', 42.8805618286133, 0.748406989014302, -96.8452835083008, -1.69026906224721, 218, 49, 'PPL', 'P'),
(174354, 'Greenfield', 42.9613914489746, 0.749817732022744, -88.0124969482422, -1.53610785464829, 218, 57, 'PPL', 'P'),
(181911, 'Greenfield', 36.3208312988281, 0.633918093225959, -121.242782592773, -2.11608575052356, 218, 6, 'PPL', 'P'),
(188633, 'Greenfield', 33.1652793884277, 0.578843322671875, -104.348609924316, -1.82122681305855, 218, 38, 'PPL', 'P'),
(196638, 'Greenfield', 47.6399993896484, 0.831474844997454, -111.858612060547, -1.95230107716758, 218, 31, 'PPL', 'P'),
(60115, 'Greenfield (historical)', 32.521671295166, 0.567610242351976, -89.2991714477539, -1.55856456106622, 218, 30, 'PPL', 'P'),
(47679, 'Greenfield Acres', 39.2599983215332, 0.685216235038202, -77.4513931274414, -1.35178182033036, 218, 25, 'PPL', 'P'),
(87443, 'Greenfield Bend', 35.6827812194824, 0.622782018548766, -87.273063659668, -1.52320230916382, 218, 50, 'PPL', 'P'),
(149283, 'Greenfield Center', 43.1283302307129, 0.752731363413346, -73.8469390869141, -1.28887222958635, 218, 40, 'PPL', 'P'),
(21575, 'Greenfield Chase', 33.8561096191406, 0.590900584770127, -84.7333297729492, -1.4788755907161, 218, 13, 'PPL', 'P'),
(178297, 'Greenfield Estates', 33.4236106872559, 0.583352054397379, -111.735000610352, -1.95014365036851, 218, 5, 'PPL', 'P'),
(102447, 'Greenfield Farms', 36.8597183227539, 0.643323446089738, -76.3816680908203, -1.33311159635031, 218, 53, 'PPL', 'P'),
(70894, 'Greenfield Heights', 39.8097190856934, 0.694810672339376, -75.1686096191406, -1.31193973200028, 218, 37, 'PPL', 'P'),
(113495, 'Greenfield Hill', 41.1763916015625, 0.718663607537807, -73.2922210693359, -1.27919057375947, 218, 8, 'PPL', 'P'),
(47680, 'Greenfield Mills', 39.2638893127441, 0.685284145645999, -77.4391708374023, -1.35156850112705, 218, 25, 'PPL', 'P'),
(122729, 'Greenfield Mills', 41.750560760498, 0.728684749824639, -85.2255630493164, -1.48746668207659, 218, 19, 'PPL', 'P'),
(131120, 'Greenfield Park', 42.3349990844727, 0.738885122852833, -85.1372222900391, -1.48592484496349, 218, 27, 'PPL', 'P'),
(149284, 'Greenfield Park', 41.725830078125, 0.728253117990964, -74.4861068725586, -1.30002781191852, 218, 40, 'PPL', 'P'),
(178295, 'Greenfield Park', 33.4213905334473, 0.583313305403519, -111.729721069336, -1.95005150499479, 218, 5, 'PPL', 'P'),
(115863, 'Greenfield Park Mobile Home Court', 43.0663909912109, 0.751650319747855, -92.6722183227539, -1.61743533485907, 218, 16, 'PPL', 'P'),
(21576, 'Greenfield Summit', 33.8608283996582, 0.590982943026838, -84.8061065673828, -1.48014578539802, 218, 13, 'PPL', 'P'),
(65212, 'Greenfield Terrace', 35.6483306884766, 0.622180743353653, -77.3555603027344, -1.35010922200774, 218, 33, 'PPL', 'P'),
(72751, 'Greenfield Village', 39.2036094665527, 0.684232063857363, -84.5247192382813, -1.4752346500318, 218, 41, 'PPL', 'P'),
(131121, 'Greenfield Village', 42.3052787780762, 0.738366405651513, -83.2247161865234, -1.45254531649265, 218, 27, 'PPL', 'P'),
(47681, 'Greenfields', 39.5750007629395, 0.690714064792561, -76.482780456543, -1.33487634004665, 218, 25, 'PPL', 'P'),
(87445, 'Greenfields', 36.5344390869141, 0.637646252435961, -82.5361099243164, -1.44052686996729, 218, 50, 'PPL', 'P'),
(102448, 'Greenfields', 38.0441703796387, 0.663996034314396, -78.477783203125, -1.36969570656083, 218, 53, 'PPL', 'P'),
(155544, 'Greenford', 40.9438896179199, 0.714605682405826, -80.7916717529297, -1.41008068027912, 218, 41, 'PPL', 'P'),
(47682, 'Greengate', 39.3822212219238, 0.687349427071355, -76.682502746582, -1.33836215159745, 218, 25, 'PPL', 'P'),
(36197, 'Greenhaven', 38.4452781677246, 0.670996685871887, -85.4541702270508, -1.49145663002175, 218, 21, 'PPL', 'P'),
(70895, 'Greenhaven', 39.9166717529297, 0.69667734852644, -74.9958267211914, -1.30892410153993, 218, 37, 'PPL', 'P'),
(149286, 'Greenhaven', 40.9508285522461, 0.714726789656397, -73.7072219848633, -1.28643370613421, 218, 40, 'PPL', 'P'),
(178296, 'Greenhaven Mobile Park', 33.4575004577637, 0.583943542475486, -111.979438781738, -1.95440990127676, 218, 5, 'PPL', 'P'),
(87447, 'Greenhaw', 35.2230606079102, 0.614758380237548, -86.0100021362305, -1.50115772692458, 218, 50, 'PPL', 'P'),
(16282, 'Greenhead', 30.5044403076172, 0.532402919845992, -85.6600036621094, -1.49504910117421, 218, 12, 'PPL', 'P'),
(36196, 'Greenhill', 36.9080581665039, 0.644167135523075, -86.3158264160156, -1.50649536753937, 218, 21, 'PPL', 'P'),
(47683, 'Greenhill', 38.1186103820801, 0.665295257452191, -75.6611099243164, -1.32053548389268, 218, 25, 'PPL', 'P'),
(87448, 'Greenhill', 36.0261116027832, 0.628774264159498, -83.482780456543, -1.45704938768625, 218, 50, 'PPL', 'P'),
(47700, 'Greenhills', 39.2630615234375, 0.685269697997085, -77.2152786254883, -1.34766084485957, 218, 25, 'PPL', 'P'),
(72754, 'Greenhills', 39.2680587768555, 0.685356916522785, -84.523063659668, -1.47520575473397, 218, 41, 'PPL', 'P'),
(87449, 'Greenhills', 36.1327781677246, 0.630635946919518, -88.6172180175781, -1.54666222836438, 218, 50, 'PPL', 'P'),
(47685, 'Greenholly', 39.0455589294434, 0.681473561600259, -76.4580612182617, -1.33444490795005, 218, 25, 'PPL', 'P'),
(181912, 'Greenhorn', 39.9044418334961, 0.69646389616507, -120.749717712402, -2.10748014493514, 218, 6, 'PPL', 'P'),
(186797, 'Greenhorn', 37.9069404602051, 0.661600920388033, -104.852783203125, -1.83002629677434, 218, 7, 'PPL', 'P'),
(200922, 'Greenhorn', 44.7080612182617, 0.780302870441854, -118.490280151367, -2.06804552025184, 218, 43, 'PPL', 'P'),
(209484, 'Greenhough Place', 41.0738906860352, 0.716874629075546, -109.244171142578, -1.90667047505016, 218, 59, 'PPL', 'P'),
(47686, 'Greenhurst', 39.6694412231445, 0.692362361770239, -76.0166702270508, -1.32674118186478, 218, 25, 'PPL', 'P'),
(81348, 'Greenhurst', 32.9916687011719, 0.57581324456261, -80.1619415283203, -1.39908981446036, 218, 48, 'PPL', 'P'),
(149287, 'Greenhurst', 42.1194381713867, 0.735122875180878, -79.3105621337891, -1.38423044084216, 218, 40, 'PPL', 'P'),
(9223, 'Greenland', 35.9941711425781, 0.628216797964318, -94.1750030517578, -1.64366387632888, 218, 4, 'PPL', 'P'),
(16283, 'Greenland', 30.1716709136963, 0.526594998272206, -81.5449981689453, -1.42322870658084, 218, 12, 'PPL', 'P'),
(47687, 'Greenland', 38.4286117553711, 0.670705802101823, -75.4916687011719, -1.3175781766602, 218, 25, 'PPL', 'P'),
(60116, 'Greenland', 32.5511093139648, 0.568124032705279, -89.0527801513672, -1.55426422169601, 218, 30, 'PPL', 'P'),
(70896, 'Greenland', 39.8588905334473, 0.695668876000654, -75.0299987792969, -1.30952051646606, 218, 37, 'PPL', 'P'),
(72756, 'Greenland', 39.4449996948242, 0.688445118122841, -83.1205596923828, -1.45072744273257, 218, 41, 'PPL', 'P'),
(87450, 'Greenland', 36.502498626709, 0.63708878624078, -82.7866668701172, -1.44489991363525, 218, 50, 'PPL', 'P'),
(109474, 'Greenland', 39.1919403076172, 0.684028398612999, -79.1533279418945, -1.38148618649689, 218, 58, 'PPL', 'P'),
(131122, 'Greenland', 46.7794418334961, 0.81645528223968, -89.1016693115234, -1.55511749850927, 218, 27, 'PPL', 'P'),
(135703, 'Greenland', 44.2066688537598, 0.771551922836936, -93.7272186279297, -1.63584856379394, 218, 28, 'PPL', 'P'),
(143904, 'Greenland', 43.0361099243164, 0.751121815429529, -70.8333282470703, -1.23627479805728, 218, 36, 'PPL', 'P'),
(162272, 'Greenland', 40.0302810668945, 0.698660205116058, -76.2344436645508, -1.33054204537254, 218, 45, 'PPL', 'P'),
(186798, 'Greenland', 39.1824989318848, 0.683863615520551, -104.854721069336, -1.83006011892018, 218, 7, 'PPL', 'P'),
(27329, 'Greenland (historical)', 39.1797218322754, 0.683815145988711, -88.8194427490234, -1.55019171575706, 218, 18, 'PPL', 'P'),
(81349, 'Greenland (historical)', 33.2836112976074, 0.580908604097232, -81.6125030517578, -1.42440688904709, 218, 48, 'PPL', 'P'),
(47688, 'Greenland Beach', 39.163890838623, 0.683538843025615, -76.529167175293, -1.33568594101803, 218, 25, 'PPL', 'P'),
(102449, 'Greenland Hills', 37.2438888549805, 0.65002848676623, -79.9944381713867, -1.39616632937373, 218, 53, 'PPL', 'P'),
(47689, 'Greenland Manor', 39.6875, 0.69267754688525, -77.1488876342773, -1.34650210346928, 218, 25, 'PPL', 'P'),
(196639, 'Greenland Park Trailer Court', 46.8833312988281, 0.81826849546786, -113.890281677246, -1.98776040129171, 218, 31, 'PPL', 'P'),
(143905, 'Greenland Station', 43.0438919067383, 0.751257636645123, -70.8241729736328, -1.23611500839188, 218, 36, 'PPL', 'P'),
(581, 'Greenlaw', 30.9841709136963, 0.54077579844466, -90.4847183227539, -1.5792562574717, 218, 22, 'PPL', 'P'),
(127632, 'Greenlaw Chopping Landing', 45.165828704834, 0.788292420291119, -67.7249984741211, -1.18202420928155, 218, 26, 'PPL', 'P'),
(127633, 'Greenlaw Crossing', 46.6616706848145, 0.81439978793133, -68.6286087036133, -1.19779518294089, 218, 26, 'PPL', 'P'),
(47690, 'Greenlawn', 38.3752784729004, 0.669774960721813, -75.5536117553711, -1.31865928690472, 218, 25, 'PPL', 'P'),
(55086, 'Greenlawn', 39.4775009155273, 0.689012371435028, -91.6861114501953, -1.60022452315638, 218, 29, 'PPL', 'P'),
(87454, 'Greenlawn', 36.2433280944824, 0.632565407129281, -86.5619430541992, -1.51079091321961, 218, 50, 'PPL', 'P'),
(149288, 'Greenlawn', 40.8688888549805, 0.713296672151025, -73.3655624389648, -1.28047062213742, 218, 40, 'PPL', 'P'),
(47691, 'Greenlawn Beach', 39.184440612793, 0.683897504245422, -76.5755615234375, -1.33649567514747, 218, 25, 'PPL', 'P'),
(47692, 'Greenlawn Shores', 39.1797218322754, 0.683815145988711, -76.5719375610352, -1.33643242507158, 218, 25, 'PPL', 'P'),
(127634, 'Greenlaws Corner', 44.3747215270996, 0.774484995303494, -69.0308303833008, -1.20481527557434, 218, 26, 'PPL', 'P'),
(13852, 'Greenlea Acres', 38.6977806091309, 0.67540368484375, -75.375, -1.31554192369073, 218, 10, 'PPL', 'P'),
(32626, 'Greenleaf', 39.728328704834, 0.693390142213927, -96.975830078125, -1.69254752971783, 218, 20, 'PPL', 'P'),
(47693, 'Greenleaf', 39.4952812194824, 0.689322696281049, -76.9599990844727, -1.34320537635587, 218, 25, 'PPL', 'P'),
(65215, 'Greenleaf', 35.4102783203125, 0.61802594573702, -77.9833297729492, -1.36106586620649, 218, 33, 'PPL', 'P'),
(135704, 'Greenleaf', 44.9963912963867, 0.785335179637668, -94.4991683959961, -1.6493216289067, 218, 28, 'PPL', 'P'),
(174359, 'Greenleaf', 44.3133316040039, 0.773413539017928, -88.0961074829102, -1.5375671337676, 218, 57, 'PPL', 'P'),
(195029, 'Greenleaf', 43.6713905334473, 0.762209553732938, -116.815277099609, -2.03881120201772, 218, 17, 'PPL', 'P'),
(200923, 'Greenleaf', 44.1138916015625, 0.76993265431514, -123.665832519531, -2.15837594968569, 218, 43, 'PPL', 'P'),
(13853, 'Greenleaf Manor', 39.6811103820801, 0.692566027014602, -75.7041702270508, -1.3212870279523, 218, 10, 'PPL', 'P'),
(122731, 'Greenleaf Manor', 41.6986083984375, 0.727778010052494, -85.9369430541992, -1.49988260539465, 218, 19, 'PPL', 'P'),
(155545, 'Greenleafs Corners (historical)', 41.1919403076172, 0.718934983652886, -81.1097183227539, -1.41563164009723, 218, 41, 'PPL', 'P'),
(135706, 'Greenleafton', 43.5802803039551, 0.760619380246051, -92.2091674804688, -1.60935357305706, 218, 28, 'PPL', 'P'),
(2864, 'Greenleas Heights', 33.5722198486328, 0.585945773562035, -86.8319396972656, -1.51550324361045, 218, 2, 'PPL', 'P'),
(65216, 'Greenlee', 35.6647186279297, 0.622466766854728, -82.1208267211914, -1.43327881074453, 218, 33, 'PPL', 'P'),
(102450, 'Greenlee', 37.6144409179688, 0.656495840315433, -79.4997177124023, -1.38753182848748, 218, 53, 'PPL', 'P'),
(102451, 'Greenleigh Mobile Home Park', 37.3333282470703, 0.65158949863918, -77.4058303833008, -1.35098660042886, 218, 53, 'PPL', 'P'),
(181913, 'Greenley Oaks', 37.985279083252, 0.66296818729168, -120.360282897949, -2.10068322520104, 218, 6, 'PPL', 'P'),
(124974, 'Greenlodge', 42.2222213745117, 0.736916780491155, -71.1597213745117, -1.24197143278701, 218, 23, 'PPL', 'P'),
(21578, 'Greenmont', 33.9894409179688, 0.593227654930639, -83.3666687011719, -1.45502285525475, 218, 13, 'PPL', 'P'),
(47694, 'Greenmont', 38.6500015258789, 0.674569782527419, -76.9511108398438, -1.34305024722237, 218, 25, 'PPL', 'P'),
(47695, 'Greenmount', 39.6311111450195, 0.691693375704411, -76.8627777099609, -1.34150854326733, 218, 25, 'PPL', 'P'),
(78399, 'Greenmount', 39.7641716003418, 0.694015718753987, -77.2738876342773, -1.34868376503427, 218, 45, 'PPL', 'P'),
(112341, 'Greenmount', 37.247501373291, 0.650091537105038, -84.0308303833008, -1.46661466337349, 218, 21, 'PPL', 'P'),
(119864, 'Greenoak', 41.480281829834, 0.723967492585781, -89.408332824707, -1.56046978651006, 218, 18, 'PPL', 'P'),
(47696, 'Greenock', 38.8152809143066, 0.677454452041166, -76.6333312988281, -1.33750394793617, 218, 25, 'PPL', 'P'),
(94601, 'Greenock', 31.7661094665527, 0.554423200740285, -97.3452835083008, -1.69899570850719, 218, 51, 'PPL', 'P'),
(162274, 'Greenock', 40.3122215270996, 0.703580994441225, -79.8069381713867, -1.39289383702624, 218, 45, 'PPL', 'P'),
(21579, 'Greenough', 31.3163890838623, 0.546574099349008, -84.1016693115234, -1.46785103590956, 218, 13, 'PPL', 'P'),
(196640, 'Greenough', 46.9166717529297, 0.818850396166043, -113.435829162598, -1.97982870861713, 218, 31, 'PPL', 'P'),
(81350, 'Greenplains (historical)', 34.4791717529297, 0.601775070449248, -79.982780456543, -1.39596286386645, 218, 48, 'PPL', 'P'),
(27330, 'Greenpond', 39.4952812194824, 0.689322696281049, -90.6427764892578, -1.58201489288686, 218, 18, 'PPL', 'P'),
(94602, 'Greenpond', 33.034740447998, 0.576564988359313, -95.5027465820313, -1.66683737255421, 218, 51, 'PPL', 'P'),
(149290, 'Greenport', 41.103328704834, 0.71738841942885, -72.3597183227539, -1.26291533054772, 218, 40, 'PPL', 'P'),
(149291, 'Greenport Center', 42.2408294677734, 0.737241552986091, -73.7627792358398, -1.28740336308711, 218, 40, 'PPL', 'P'),
(27331, 'Greenridge', 39.4194412231445, 0.687999038640253, -89.7944412231445, -1.5672086493324, 218, 18, 'PPL', 'P'),
(47697, 'Greenridge', 39.6983299255371, 0.692866564743618, -75.8019409179688, -1.32299344842077, 218, 25, 'PPL', 'P'),
(81351, 'Greenridge', 34.8844413757324, 0.608848359725471, -82.0666732788086, -1.43233365487366, 218, 48, 'PPL', 'P'),
(149293, 'Greenridge', 40.5611114501953, 0.70792494307428, -74.170280456543, -1.29451560109428, 218, 40, 'PPL', 'P'),
(162275, 'Greenridge', 40.0105590820313, 0.698315991545165, -76.6999969482422, -1.33866748301643, 218, 45, 'PPL', 'P'),
(47698, 'Greenridge Acres', 39.2172203063965, 0.684469617826598, -77.2525024414063, -1.3483105230075, 218, 25, 'PPL', 'P'),
(199983, 'Greens', 40.0361099243164, 0.698761937869699, -114.746673583984, -2.00270725975173, 218, 39, 'PPL', 'P'),
(94603, 'Greens Bayou', 29.7655601501465, 0.519507028320474, -95.2061080932617, -1.66166005423704, 218, 51, 'PPL', 'P'),
(94604, 'Greens Bluff', 31.8700008392334, 0.556236447257979, -95.9691696166992, -1.67497799021631, 218, 51, 'PPL', 'P'),
(13875, 'Greens Corner', 38.9902801513672, 0.68050876491635, -75.6819381713867, -1.32089900538147, 218, 10, 'PPL', 'P'),
(102452, 'Greens Corner', 38.4705581665039, 0.671437905085486, -77.942497253418, -1.36035320429878, 218, 53, 'PPL', 'P'),
(127635, 'Greens Corner', 44.6586112976074, 0.779439806511587, -69.295280456543, -1.20943080005955, 218, 26, 'PPL', 'P'),
(204177, 'Greens Corner', 41.6469383239746, 0.726876197128366, -111.910827636719, -1.95321241089261, 218, 52, 'PPL', 'P'),
(172078, 'Greens Corners', 44.860279083252, 0.78295957336629, -73.0327835083008, -1.27466253411606, 218, 55, 'PPL', 'P'),
(65218, 'Greens Creek', 35.3283309936523, 0.616595695073593, -83.2622222900391, -1.45319992148859, 218, 33, 'PPL', 'P'),
(21580, 'Greens Crossing', 30.916389465332, 0.539592788998933, -83.0572204589844, -1.44962196456407, 218, 13, 'PPL', 'P'),
(94605, 'Greens Crossing', 30.8355598449707, 0.538182045990491, -97.9013900756836, -1.70870159909998, 218, 51, 'PPL', 'P'),
(149311, 'Greens Crossing', 42.9580612182617, 0.749759608531953, -75.2772216796875, -1.3138353700642, 218, 40, 'PPL', 'P'),
(87455, 'Greens Crossroad', 35.788890838623, 0.624633980770807, -85.7155609130859, -1.49601875812711, 218, 50, 'PPL', 'P'),
(2865, 'Greens Crossroads', 31.8852806091309, 0.556503129551637, -85.600830078125, -1.49401632730348, 218, 2, 'PPL', 'P'),
(41188, 'Greens Ditch', 30.1136093139648, 0.525581632187917, -89.7611083984375, -1.56662688179227, 218, 22, 'PPL', 'P'),
(113494, 'Greens Farms', 41.1238899230957, 0.717747280385738, -73.3197174072266, -1.2796704753879, 218, 8, 'PPL', 'P'),
(29960, 'Greens Fork', 39.8925018310547, 0.696255503809771, -85.0416717529297, -1.48425717348888, 218, 19, 'PPL', 'P'),
(65221, 'Greens Fork', 36.3941688537598, 0.635198075024879, -76.5458297729492, -1.33597675820907, 218, 33, 'PPL', 'P'),
(188634, 'Greens Gap', 34.0947189331055, 0.595065102924739, -108.142219543457, -1.88743779144788, 218, 38, 'PPL', 'P'),
(13856, 'Greens Landing', 38.6552810668945, 0.674661927901136, -75.1627807617188, -1.31183799924664, 218, 10, 'PPL', 'P'),
(149294, 'Greens Landing', 42.8305587768555, 0.747534271125083, -77.2588882446289, -1.34842197629912, 218, 40, 'PPL', 'P'),
(207562, 'Greens Landing', 47.9308280944824, 0.836550763456118, -120.190826416016, -2.09772565165245, 218, 56, 'PPL', 'P'),
(21582, 'Greens Mill', 32.767219543457, 0.571895867757158, -84.5727767944336, -1.47607341261712, 218, 13, 'PPL', 'P'),
(87456, 'Greens Mill', 35.1763916015625, 0.613943852418147, -85.2263870239258, -1.48748106314648, 218, 50, 'PPL', 'P'),
(13857, 'Greens of Dover', 39.163890838623, 0.683538843025615, -75.5583267211914, -1.3187415785824, 218, 10, 'PPL', 'P'),
(47699, 'Greens Rest Manor', 38.2041702270508, 0.666788558454426, -76.4902801513672, -1.33500723441422, 218, 25, 'PPL', 'P'),
(72759, 'Greens Run', 39.4644393920898, 0.688784404845717, -82.1138916015625, -1.43315777007299, 218, 41, 'PPL', 'P'),
(145331, 'Greensand', 40.4916687011719, 0.706712938462185, -74.3874969482422, -1.29830674406406, 218, 37, 'PPL', 'P'),
(2866, 'Greensboro', 32.7044410705566, 0.570800176705673, -87.595832824707, -1.52883569381766, 218, 2, 'PPL', 'P'),
(16284, 'Greensboro', 30.5691699981689, 0.533532666069917, -84.7433319091797, -1.47905016092556, 218, 12, 'PPL', 'P'),
(21583, 'Greensboro', 33.5755615234375, 0.586004096789908, -83.182502746582, -1.45180855297708, 218, 13, 'PPL', 'P'),
(29949, 'Greensboro', 39.875, 0.695950039232739, -85.4661102294922, -1.49166502237705, 218, 19, 'PPL', 'P'),
(47712, 'Greensboro', 38.9736099243164, 0.680217814567259, -75.8052825927734, -1.32305177164864, 218, 25, 'PPL', 'P'),
(65222, 'Greensboro', 36.0724983215332, 0.629583865130882, -79.7922210693359, -1.3926369751391, 218, 33, 'PPL', 'P'),
(78400, 'Greensboro', 39.7911109924316, 0.694485899844441, -79.9130630493164, -1.39474606556439, 218, 45, 'PPL', 'P'),
(172079, 'Greensboro', 44.5763893127441, 0.778004762158198, -72.2961120605469, -1.26180519184733, 218, 55, 'PPL', 'P'),
(9225, 'Greensboro (historical)', 35.954719543457, 0.627528237664478, -90.6222229003906, -1.58165616508802, 218, 4, 'PPL', 'P'),
(41189, 'Greensboro (historical)', 32.6263885498047, 0.56943790322907, -92.7125015258789, -1.61813840938685, 218, 22, 'PPL', 'P'),
(172080, 'Greensboro Bend', 44.5488891601563, 0.777524793950738, -72.2652816772461, -1.26126710014907, 218, 55, 'PPL', 'P'),
(29951, 'Greensburg', 39.3372192382813, 0.686563994286864, -85.4836120605469, -1.49197048695408, 218, 19, 'PPL', 'P'),
(32628, 'Greensburg', 37.6027793884277, 0.656292308229124, -99.2922210693359, -1.732976179278, 218, 20, 'PPL', 'P'),
(36198, 'Greensburg', 37.2608299255371, 0.650324164226256, -85.498893737793, -1.49223720253725, 218, 21, 'PPL', 'P'),
(41190, 'Greensburg', 30.8305606842041, 0.538094794175277, -90.6716690063477, -1.58251916243926, 218, 22, 'PPL', 'P'),
(47701, 'Greensburg', 39.6797218322754, 0.692541792248683, -77.5627822875977, -1.35372592792612, 218, 25, 'PPL', 'P'),
(109476, 'Greensburg', 39.4841690063477, 0.689128751574664, -77.8841705322266, -1.3593352109721, 218, 58, 'PPL', 'P'),
(139196, 'Greensburg', 40.2963905334473, 0.703304691478129, -92.216667175293, -1.60948446742464, 218, 29, 'PPL', 'P'),
(155546, 'Greensburg', 40.9316711425781, 0.714392429781538, -81.4649963378906, -1.42183241122131, 218, 41, 'PPL', 'P'),
(162283, 'Greensburg', 40.3013916015625, 0.703391976582856, -79.5391693115234, -1.38822038878732, 218, 45, 'PPL', 'P'),
(94606, 'Greenshores', 30.3397197723389, 0.529528004159738, -97.8169403076172, -1.70722767259467, 218, 51, 'PPL', 'P'),
(181915, 'Greensport', 34.0675010681152, 0.594590061565296, -117.103332519531, -2.04383871752357, 218, 6, 'PPL', 'P'),
(181916, 'Greenspot (historical)', 34.0858306884766, 0.594909973791242, -117.110000610352, -2.0439550976632, 218, 6, 'PPL', 'P'),
(47702, 'Greenspring', 39.4263916015625, 0.688120345627906, -76.7063903808594, -1.3387790694661, 218, 25, 'PPL', 'P'),
(47703, 'Greenspring Hill', 39.6227798461914, 0.691547967108892, -77.9638900756836, -1.36072657948361, 218, 25, 'PPL', 'P'),
(102453, 'Greensprings', 37.2880592346191, 0.650799405322781, -76.7149963378906, -1.33892927175158, 218, 53, 'PPL', 'P'),
(109477, 'Greenstown', 37.9608306884766, 0.662541482306022, -81.1474990844727, -1.41629103878313, 218, 58, 'PPL', 'P'),
(55093, 'Greenstreet', 38.4063911437988, 0.670317979268081, -91.2030563354492, -1.59179362093546, 218, 29, 'PPL', 'P'),
(21584, 'Greensway', 33.4119415283203, 0.583148389153016, -84.5694427490234, -1.4760152225473, 218, 13, 'PPL', 'P'),
(195030, 'Greentimber (historical)', 44.0852813720703, 0.76943331161075, -111.274436950684, -1.94210529809227, 218, 17, 'PPL', 'P'),
(55088, 'Greenton', 39.0486106872559, 0.681526824822061, -93.9638900756836, -1.6399792598027, 218, 29, 'PPL', 'P'),
(13859, 'Greentop', 38.853328704834, 0.678118511258977, -75.4188919067383, -1.31630798197829, 218, 10, 'PPL', 'P'),
(139198, 'Greentop', 40.3469390869141, 0.704186930168245, -92.5688934326172, -1.61563197532693, 218, 29, 'PPL', 'P'),
(47704, 'Greentop Manor', 39.4719390869141, 0.688915299213295, -76.6327819824219, -1.33749436055625, 218, 25, 'PPL', 'P'),
(65223, 'Greentown', 36.500560760498, 0.637054964094936, -76.0875015258789, -1.3279774212428, 218, 33, 'PPL', 'P'),
(87457, 'Greentown', 35.290828704834, 0.615941156656679, -85.6588897705078, -1.49502966009825, 218, 50, 'PPL', 'P'),
(102455, 'Greentown', 36.6875, 0.64031766932542, -77.7794418334961, -1.35750735035792, 218, 53, 'PPL', 'P'),
(122733, 'Greentown', 40.4780616760254, 0.706475451071977, -85.966667175293, -1.500401389175, 218, 19, 'PPL', 'P'),
(155549, 'Greentown', 40.9275016784668, 0.714319658904751, -81.4027786254883, -1.42074650728683, 218, 41, 'PPL', 'P'),
(162277, 'Greentown', 41.3216705322266, 0.721199203211671, -75.3058319091797, -1.31433471276859, 218, 45, 'PPL', 'P'),
(178299, 'Greentrails', 33.639720916748, 0.587123889449259, -112.062782287598, -1.95586451986416, 218, 5, 'PPL', 'P'),
(21585, 'Greentree', 30.7758293151855, 0.53713955158178, -81.6758270263672, -1.42551210089948, 218, 13, 'PPL', 'P'),
(47705, 'Greentree', 39.1291694641113, 0.682932840719568, -76.6374969482422, -1.33757665223393, 218, 25, 'PPL', 'P'),
(70897, 'Greentree', 39.8969383239746, 0.696332935218465, -74.9561080932617, -1.30823088070819, 218, 37, 'PPL', 'P'),
(72760, 'Greentree Corners', 39.4625015258789, 0.688750582699873, -84.267219543457, -1.47074043253424, 218, 41, 'PPL', 'P'),
(70898, 'Greentree Village', 39.9124984741211, 0.696604511070626, -74.9388885498047, -1.30793034297917, 218, 37, 'PPL', 'P'),
(27332, 'Greenup', 39.2477798461914, 0.685002982413914, -88.163330078125, -1.53874038938583, 218, 18, 'PPL', 'P'),
(36200, 'Greenup', 38.5730590820313, 0.673226883547747, -82.8302764892578, -1.4456610450748, 218, 21, 'PPL', 'P'),
(87459, 'Greenvale', 35.9997215270996, 0.628313670448969, -86.1977767944336, -1.50443501296203, 218, 50, 'PPL', 'P'),
(149295, 'Greenvale', 40.8105583190918, 0.712278612245315, -73.6288909912109, -1.28506657238862, 218, 40, 'PPL', 'P'),
(102456, 'Greenvale (historical)', 37.7213897705078, 0.65836244992347, -76.5524978637695, -1.3360931383487, 218, 53, 'PPL', 'P'),
(47706, 'Greenvale Village', 39.6416702270508, 0.691877666451844, -77.602783203125, -1.35442407560588, 218, 25, 'PPL', 'P'),
(13861, 'Greenview', 39.1180610656738, 0.68273896259221, -75.5250015258789, -1.31815994420033, 218, 10, 'PPL', 'P'),
(55089, 'Greenview', 37.6561088562012, 0.657223083030106, -92.2577819824219, -1.61020205618036, 218, 29, 'PPL', 'P'),
(94607, 'Greenview', 33.0222206115723, 0.576346475991872, -95.716667175293, -1.67057099124444, 218, 51, 'PPL', 'P'),
(109478, 'Greenview', 37.9941711425781, 0.663123383004204, -81.8158264160156, -1.42795555119962, 218, 58, 'PPL', 'P'),
(119866, 'Greenview', 40.0830612182617, 0.699581392537116, -89.7380599975586, -1.56622461130961, 218, 18, 'PPL', 'P'),
(135708, 'Greenview', 47.6258316040039, 0.83122757049024, -96.5602798461914, -1.68529480996316, 218, 28, 'PPL', 'P'),
(193604, 'Greenview', 41.5508308410645, 0.725198805115779, -122.904441833496, -2.14508717532036, 218, 6, 'PPL', 'P'),
(47707, 'Greenview Knolls', 38.2799987792969, 0.668112016358141, -76.4911117553711, -1.33502174864216, 218, 25, 'PPL', 'P'),
(2868, 'Greenville', 31.829439163208, 0.555528512461208, -86.6177825927734, -1.51176549702053, 218, 2, 'PPL', 'P'),
(9226, 'Greenville', 33.476390838623, 0.584273241818438, -92.1319427490234, -1.60800574722937, 218, 4, 'PPL', 'P'),
(13863, 'Greenville', 39.7788887023926, 0.694272580641125, -75.5986099243164, -1.31944465311018, 218, 10, 'PPL', 'P'),
(16285, 'Greenville', 30.4691696166992, 0.53178733016002, -83.6302795410156, -1.45962373235397, 218, 12, 'PPL', 'P'),
(21587, 'Greenville', 33.0286102294922, 0.576457995862519, -84.7130584716797, -1.47852178976529, 218, 13, 'PPL', 'P'),
(27334, 'Greenville', 38.892219543457, 0.678797284441811, -89.4130630493164, -1.56055234450385, 218, 18, 'PPL', 'P'),
(36201, 'Greenville', 37.2011108398438, 0.649281869554626, -87.1788864135742, -1.52155860613902, 218, 21, 'PPL', 'P'),
(41192, 'Greenville', 29.9347190856934, 0.522459408704936, -90.1286087036133, -1.57304097211967, 218, 22, 'PPL', 'P'),
(55091, 'Greenville', 37.1272201538086, 0.647992233796756, -90.4499969482422, -1.57865025516565, 218, 29, 'PPL', 'P'),
(60117, 'Greenville', 33.4099998474121, 0.583114500428144, -91.0616683959961, -1.5893259358694, 218, 30, 'PPL', 'P'),
(65224, 'Greenville', 35.6124992370605, 0.621555366550675, -77.3666687011719, -1.35030310013509, 218, 33, 'PPL', 'P'),
(75989, 'Greenville', 34.0072212219238, 0.59353797977666, -97.1255569458008, -1.69516075653747, 218, 42, 'PPL', 'P'),
(81352, 'Greenville', 34.8525009155273, 0.60829089353029, -82.394172668457, -1.4380495975213, 218, 48, 'PPL', 'P'),
(87460, 'Greenville', 36.2969398498535, 0.63350110877828, -86.8883285522461, -1.51648741479129, 218, 50, 'PPL', 'P'),
(94608, 'Greenville', 33.1383285522461, 0.57837294184434, -96.1105575561523, -1.67744567528237, 218, 51, 'PPL', 'P'),
(102461, 'Greenville', 38.0033302307129, 0.663283239248636, -79.1561126708984, -1.38153478918678, 218, 53, 'PPL', 'P'),
(109480, 'Greenville', 37.5433311462402, 0.655254740668429, -80.6827774047852, -1.40818011536719, 218, 58, 'PPL', 'P'),
(113496, 'Greenville', 41.5336112976074, 0.724898267386764, -72.0577774047852, -1.25764546738268, 218, 8, 'PPL', 'P'),
(115868, 'Greenville', 43.0166702270508, 0.750782528706653, -95.1458282470703, -1.6606079724484, 218, 16, 'PPL', 'P'),
(122734, 'Greenville', 40.6544418334961, 0.709553865555027, -85.2263870239258, -1.48748106314648, 218, 19, 'PPL', 'P'),
(124975, 'Greenville', 42.2041702270508, 0.736601728534199, -71.9166717529297, -1.25518270916463, 218, 23, 'PPL', 'P'),
(127636, 'Greenville', 45.4594383239746, 0.79341687486065, -69.5911102294922, -1.21459400362295, 218, 26, 'PPL', 'P'),
(131128, 'Greenville', 43.1775016784668, 0.753589567074624, -85.2527770996094, -1.48794165685701, 218, 27, 'PPL', 'P'),
(143908, 'Greenville', 42.767219543457, 0.746428792956591, -71.8127822875977, -1.25336949593644, 218, 36, 'PPL', 'P'),
(145333, 'Greenville', 40.1016693115234, 0.699906165032052, -74.1722183227539, -1.29454942324012, 218, 37, 'PPL', 'P'),
(149300, 'Greenville', 40.9930610656738, 0.715463886067104, -73.8202819824219, -1.28840697534391, 218, 40, 'PPL', 'P'),
(155550, 'Greenville', 40.1027793884277, 0.699925539528982, -84.633056640625, -1.47712549440576, 218, 41, 'PPL', 'P'),
(162280, 'Greenville', 41.4044418334961, 0.722643834944985, -80.3913879394531, -1.40309440979152, 218, 45, 'PPL', 'P'),
(169403, 'Greenville', 41.8711090087891, 0.730788713664828, -71.5524978637695, -1.24882667574899, 218, 47, 'PPL', 'P'),
(174360, 'Greenville', 44.3002815246582, 0.773185772165699, -88.5363922119141, -1.54525155193497, 218, 57, 'PPL', 'P'),
(190282, 'Greenville', 39.0374984741211, 0.681332880115676, -119.181671142578, -2.0801125694671, 218, 39, 'PPL', 'P'),
(193605, 'Greenville', 40.139720916748, 0.70057029082889, -120.949996948242, -2.11097567702392, 218, 6, 'PPL', 'P'),
(200924, 'Greenville', 44.3869400024414, 0.774698247927782, -122.778327941895, -2.14288607267941, 218, 43, 'PPL', 'P'),
(204178, 'Greenville', 41.7663917541504, 0.728961052787734, -111.847503662109, -1.95210719904022, 218, 52, 'PPL', 'P'),
(27335, 'Greenville (historical)', 37.8936080932617, 0.661368226687788, -88.8188934326172, -1.55018212837714, 218, 18, 'PPL', 'P'),
(181919, 'Greenville (historical)', 37.7200012207031, 0.65833821515755, -121.698059082031, -2.12403182426803, 218, 6, 'PPL', 'P'),
(190283, 'Greenville (historical)', 39.2394409179688, 0.684857440660341, -115.498329162598, -2.01582612443951, 218, 39, 'PPL', 'P'),
(149301, 'Greenville Center', 42.3872184753418, 0.739796523156885, -74.0005569458008, -1.29155336701378, 218, 40, 'PPL', 'P'),
(13864, 'Greenville Development', 39.7813911437988, 0.694316256483003, -75.6044387817383, -1.31954638586382, 218, 10, 'PPL', 'P'),
(55092, 'Greenville Ford', 36.7455596923828, 0.641331002120195, -90.7355575561523, -1.58363422798768, 218, 29, 'PPL', 'P'),
(65226, 'Greenville Heights', 35.6161117553711, 0.621618416889483, -77.3850021362305, -1.35062307894007, 218, 33, 'PPL', 'P'),
(127637, 'Greenville Junction', 45.4608306884766, 0.793441176205597, -69.6166687011719, -1.21504008310553, 218, 26, 'PPL', 'P'),
(13865, 'Greenville Manor', 39.7813911437988, 0.694316256483003, -75.595832824707, -1.31939618357834, 218, 10, 'PPL', 'P'),
(13866, 'Greenville Place', 39.7727813720703, 0.694165987618495, -75.5963897705078, -1.31940590411632, 218, 10, 'PPL', 'P'),
(94609, 'Greenvine', 30.1147193908691, 0.525601006684848, -96.5580596923828, -1.6852560609693, 218, 51, 'PPL', 'P'),
(135709, 'Greenwald', 45.6016693115234, 0.79589927389174, -94.8597183227539, -1.65561441224645, 218, 28, 'PPL', 'P'),
(162282, 'Greenwald', 40.360279083252, 0.704419757026545, -79.4544372558594, -1.38674153543399, 218, 45, 'PPL', 'P'),
(181920, 'Greenwater', 36.1794395446777, 0.631450341580865, -116.615562438965, -2.03532552362497, 218, 6, 'PPL', 'P'),
(207561, 'Greenwater', 47.1561088562012, 0.823029361969568, -121.649169921875, -2.12317854745477, 218, 56, 'PPL', 'P'),
(9228, 'Greenway', 36.3411102294922, 0.634272027334831, -90.2202835083008, -1.57464099930259, 218, 4, 'PPL', 'P'),
(13119, 'Greenway', 38.8875007629395, 0.6787149261851, -76.9550018310547, -1.34311815783017, 218, 9, 'PPL', 'P'),
(21600, 'Greenway', 34.0591697692871, 0.594444652969778, -84.3833312988281, -1.47276696496573, 218, 13, 'PPL', 'P'),
(87461, 'Greenway', 36.0205612182617, 0.628677391674847, -83.9227828979492, -1.4647288790056, 218, 50, 'PPL', 'P'),
(102460, 'Greenway', 37.584171295166, 0.655967535734189, -78.8338928222656, -1.37591099191286, 218, 53, 'PPL', 'P'),
(149304, 'Greenway', 43.1805610656738, 0.75364296345448, -75.533332824707, -1.31830535279585, 218, 40, 'PPL', 'P'),
(170428, 'Greenway', 45.9097213745117, 0.801275796658446, -99.710563659668, -1.74027763488061, 218, 49, 'PPL', 'P'),
(21589, 'Greenway (historical)', 33.9563903808594, 0.592650814238527, -85.3688888549805, -1.4899681892885, 218, 13, 'PPL', 'P'),
(149305, 'Greenway Corners', 43.170280456543, 0.753463532976036, -75.5261077880859, -1.31817925211823, 218, 40, 'PPL', 'P'),
(102462, 'Greenway Court', 39.0461082458496, 0.681483148980183, -78.1188888549805, -1.36343181851891, 218, 53, 'PPL', 'P'),
(102478, 'Greenway Downs', 38.8769416809082, 0.678530635437667, -77.1836090087891, -1.34710810577533, 218, 53, 'PPL', 'P'),
(102463, 'Greenway Estates', 39.0499992370605, 0.68155105958798, -78.061393737793, -1.36242833942017, 218, 53, 'PPL', 'P'),
(102464, 'Greenway Hills', 38.8547210693359, 0.678142812603924, -77.289436340332, -1.34895514114935, 218, 53, 'PPL', 'P'),
(178300, 'Greenway Park V', 33.6288909912109, 0.58693487159089, -111.964172363281, -1.9541434520097, 218, 5, 'PPL', 'P'),
(41195, 'Greenwell Acres East', 30.5155601501465, 0.532596997710431, -91.0130615234375, -1.58847758590415, 218, 22, 'PPL', 'P'),
(41197, 'Greenwell Springs', 30.579439163208, 0.533711896811279, -90.9941711425781, -1.5881478865612, 218, 22, 'PPL', 'P'),
(32630, 'Greenwich', 37.7827796936035, 0.659433906209036, -97.2033309936523, -1.69651816974508, 218, 20, 'PPL', 'P'),
(70900, 'Greenwich', 39.389720916748, 0.687480321438933, -75.3388900756836, -1.31491168661876, 218, 37, 'PPL', 'P'),
(102466, 'Greenwich', 36.8416709899902, 0.643008460711809, -76.1869430541992, -1.3297130033252, 218, 53, 'PPL', 'P'),
(113497, 'Greenwich', 41.0263900756836, 0.716045587028204, -73.6288909912109, -1.28506657238862, 218, 8, 'PPL', 'P'),
(119869, 'Greenwich', 41.1183280944824, 0.717650208164004, -87.9269409179688, -1.53461462022508, 218, 18, 'PPL', 'P'),
(149306, 'Greenwich', 43.0905609130859, 0.752072164464524, -73.4991683959961, -1.28280248598789, 218, 40, 'PPL', 'P'),
(155552, 'Greenwich', 41.0299987792969, 0.716108570787985, -82.5158309936523, -1.44017293585842, 218, 41, 'PPL', 'P'),
(162284, 'Greenwich', 40.6855583190918, 0.710096950680322, -78.8188934326172, -1.37564920317771, 218, 45, 'PPL', 'P'),
(192597, 'Greenwich', 38.4311103820801, 0.670749411364673, -111.922218322754, -1.95341121586798, 218, 52, 'PPL', 'P'),
(124977, 'Greenwich (historical)', 42.3583297729492, 0.739292320183506, -72.2966690063477, -1.2618149123853, 218, 23, 'PPL', 'P'),
(102467, 'Greenwich Acres', 38.7483291625977, 0.676285923533866, -77.6352767944336, -1.35499119576002, 218, 53, 'PPL', 'P'),
(47708, 'Greenwich Forest', 38.9919395446777, 0.680537726793205, -77.1147232055664, -1.34590582170121, 218, 25, 'PPL', 'P'),
(32631, 'Greenwich Heights', 37.6533317565918, 0.657174613498267, -97.2050018310547, -1.69654733135902, 218, 20, 'PPL', 'P'),
(149307, 'Greenwich Junction', 43.1497192382813, 0.753104672019147, -73.3533325195313, -1.28025716977605, 218, 40, 'PPL', 'P'),
(181924, 'Greenwich Village', 34.1813888549805, 0.596577778423904, -118.863609313965, -2.07456134333288, 218, 6, 'PPL', 'P'),
(124978, 'Greenwich Village (historical)', 42.3833312988281, 0.739728679128115, -72.2750015258789, -1.26143674351051, 218, 23, 'PPL', 'P'),
(2872, 'Greenwood', 33.3258285522461, 0.581645434191829, -86.9361114501953, -1.51732138368665, 218, 2, 'PPL', 'P'),
(9231, 'Greenwood', 35.2155609130859, 0.61462748586997, -94.2555618286133, -1.64506989222639, 218, 4, 'PPL', 'P'),
(13867, 'Greenwood', 38.8069381713867, 0.677308843708566, -75.591667175293, -1.31932347928058, 218, 10, 'PPL', 'P'),
(16286, 'Greenwood', 30.8700008392334, 0.538783154738036, -85.1619415283203, -1.48635627706008, 218, 12, 'PPL', 'P'),
(21594, 'Greenwood', 31.1977806091309, 0.544503990944176, -84.3399963378906, -1.47201062721615, 218, 13, 'PPL', 'P'),
(36205, 'Greenwood', 36.9402809143066, 0.644729528566272, -86.4199981689453, -1.50831350761557, 218, 21, 'PPL', 'P'),
(41202, 'Greenwood', 29.6202793121338, 0.516971399357096, -90.9036102294922, -1.58656730045424, 218, 22, 'PPL', 'P'),
(47710, 'Greenwood', 39.4338912963867, 0.688251239995483, -76.6980590820313, -1.33863366087058, 218, 25, 'PPL', 'P'),
(55094, 'Greenwood', 38.8516693115234, 0.678089549382123, -94.3436126708984, -1.64660666933342, 218, 29, 'PPL', 'P'),
(60119, 'Greenwood', 33.5161094665527, 0.584966462650185, -90.179443359375, -1.57392820423683, 218, 30, 'PPL', 'P'),
(65228, 'Greenwood', 35.0791702270508, 0.612247019329603, -77.0875015258789, -1.34543071376274, 218, 33, 'PPL', 'P'),
(72761, 'Greenwood', 39.9247207641602, 0.696817830273941, -81.4619369506836, -1.42177901484146, 218, 41, 'PPL', 'P'),
(75990, 'Greenwood', 34.1922187805176, 0.596766796282272, -95.5875015258789, -1.66831662538169, 218, 42, 'PPL', 'P'),
(81356, 'Greenwood', 33.9494400024414, 0.592529507250874, -80.3125, -1.40171755550795, 218, 48, 'PPL', 'P'),
(87469, 'Greenwood', 36.1463890075684, 0.630873500888753, -86.2347183227539, -1.50507976426194, 218, 50, 'PPL', 'P'),
(102472, 'Greenwood', 38.4391708374023, 0.670890092849257, -78.6558303833008, -1.37280321607879, 218, 53, 'PPL', 'P'),
(109483, 'Greenwood', 39.4430618286133, 0.688411295976997, -78.2330627441406, -1.36542452880456, 218, 58, 'PPL', 'P'),
(119870, 'Greenwood', 42.3925018310547, 0.739888735109629, -88.3891677856445, -1.5426820009572, 218, 18, 'PPL', 'P'),
(122736, 'Greenwood', 40.8444404602051, 0.712869967165367, -85.1769409179688, -1.48661806579524, 218, 19, 'PPL', 'P'),
(124979, 'Greenwood', 42.4819412231445, 0.741449746982579, -71.0625, -1.24027459969847, 218, 23, 'PPL', 'P'),
(127640, 'Greenwood', 44.3183288574219, 0.773500757543628, -70.6513900756836, -1.23309937793152, 218, 26, 'PPL', 'P'),
(131127, 'Greenwood', 44.1761093139648, 0.77101855824962, -84.1566696166992, -1.46881097232448, 218, 27, 'PPL', 'P'),
(135712, 'Greenwood', 44.9150009155273, 0.78391464951222, -93.5530624389648, -1.63280896488377, 218, 28, 'PPL', 'P'),
(141963, 'Greenwood', 40.9627799987793, 0.714935381748778, -96.4408264160156, -1.6832099543038, 218, 35, 'PPL', 'P'),
(149310, 'Greenwood', 42.1349983215332, 0.735394451033039, -77.6486129760742, -1.35522395603929, 218, 40, 'PPL', 'P'),
(162288, 'Greenwood', 41.3722190856934, 0.722081441901787, -75.7019424438477, -1.32124814580038, 218, 45, 'PPL', 'P'),
(169404, 'Greenwood', 41.7083282470703, 0.727947653413932, -71.4447174072266, -1.24694555191301, 218, 47, 'PPL', 'P'),
(174363, 'Greenwood', 43.5638885498047, 0.76033329016595, -90.418327331543, -1.5780975160814, 218, 57, 'PPL', 'P'),
(178301, 'Greenwood', 34.5077781677246, 0.60227434657461, -113.593887329102, -1.98258734403229, 218, 5, 'PPL', 'P'),
(181922, 'Greenwood', 39.6961097717285, 0.692827815749757, -122.193328857422, -2.13267591253421, 218, 6, 'PPL', 'P'),
(186799, 'Greenwood', 38.2050018310547, 0.666803072682367, -105.096389770508, -1.83427803345465, 218, 7, 'PPL', 'P'),
(191554, 'Greenwood', 32.0275001525879, 0.558985328845645, -101.895278930664, -1.77840810957809, 218, 51, 'PPL', 'P'),
(192598, 'Greenwood', 39.122501373291, 0.682816460579931, -112.351936340332, -1.96091121012986, 218, 52, 'PPL', 'P'),
(195031, 'Greenwood', 42.5766716003418, 0.743103103966328, -114.048606872559, -1.99052369723878, 218, 17, 'PPL', 'P'),
(196641, 'Greenwood', 45.6772193908691, 0.797217871526465, -111.211387634277, -1.94100487992985, 218, 31, 'PPL', 'P'),
(202180, 'Greenwood', 44.2202796936035, 0.771789476806171, -103.561111450195, -1.80748237183071, 218, 49, 'PPL', 'P'),
(207566, 'Greenwood', 48.9141693115234, 0.853713305364052, -122.440559387207, -2.13699089929041, 218, 56, 'PPL', 'P'),
(102473, 'Greenwood (historical)', 37.9541702270508, 0.66242523532444, -79.9658279418945, -1.39566698666934, 218, 53, 'PPL', 'P'),
(109484, 'Greenwood (historical)', 37.8786087036133, 0.661106437952633, -80.9880599975586, -1.41350830176011, 218, 58, 'PPL', 'P'),
(181923, 'Greenwood (historical)', 38.1327781677246, 0.665542531959405, -122.459716796875, -2.13732525916527, 218, 6, 'PPL', 'P'),
(21596, 'Greenwood Acres', 33.6624984741211, 0.58752143282098, -83.8574981689453, -1.46358944553321, 218, 13, 'PPL', 'P'),
(41203, 'Greenwood Acres', 29.8144397735596, 0.520360138686167, -90.8652801513672, -1.58589831438841, 218, 22, 'PPL', 'P'),
(47711, 'Greenwood Acres', 38.9858283996582, 0.680431067191547, -76.5827789306641, -1.33662164266703, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(155554, 'Greenwood Acres', 40.836109161377, 0.712724558569848, -81.5188903808594, -1.42277303971833, 218, 41, 'PPL', 'P'),
(204180, 'Greenwood Circle', 40.6138916015625, 0.708846130495339, -111.883331298828, -1.95273250926417, 218, 52, 'PPL', 'P'),
(170430, 'Greenwood Colony', 43.2133293151855, 0.754214877298574, -98.1508331298828, -1.71305520169199, 218, 49, 'PPL', 'P'),
(21597, 'Greenwood Estates', 33.5644416809082, 0.585810018925468, -85.1216735839844, -1.48565346884841, 218, 13, 'PPL', 'P'),
(41206, 'Greenwood Estates', 30.5461101531982, 0.533130195850179, -91.1186065673828, -1.59031969443016, 218, 22, 'PPL', 'P'),
(81358, 'Greenwood Estates', 34.149169921875, 0.596015451959733, -79.727783203125, -1.39151232221076, 218, 48, 'PPL', 'P'),
(87471, 'Greenwood Estates', 35.0455589294434, 0.611660391520486, -86.5683288574219, -1.51090236651123, 218, 50, 'PPL', 'P'),
(47713, 'Greenwood Farms', 39.163330078125, 0.683529055908609, -76.9472198486328, -1.34298233661458, 218, 25, 'PPL', 'P'),
(102475, 'Greenwood Farms', 37.2083282470703, 0.649407837074187, -77.4322204589844, -1.35144719413939, 218, 53, 'PPL', 'P'),
(81359, 'Greenwood Forest', 32.1277809143066, 0.560735558314045, -80.8000030517578, -1.41022608887464, 218, 48, 'PPL', 'P'),
(87472, 'Greenwood Forest', 36.0552787780762, 0.629283327401867, -83.9375, -1.46498574089274, 218, 50, 'PPL', 'P'),
(102476, 'Greenwood Forest', 37.2383308410645, 0.649931481123524, -79.9938888549805, -1.39615674199381, 218, 53, 'PPL', 'P'),
(13868, 'Greenwood Gardens', 38.7966690063477, 0.677129612967203, -75.5886077880859, -1.31927008290073, 218, 10, 'PPL', 'P'),
(87473, 'Greenwood Heights', 35.9744415283203, 0.62787245123537, -84.0233306884766, -1.46648376900591, 218, 50, 'PPL', 'P'),
(102477, 'Greenwood Heights', 39.1650009155273, 0.683558217522546, -78.1177825927734, -1.36341251060101, 218, 53, 'PPL', 'P'),
(162289, 'Greenwood Heights', 40.0061111450195, 0.698238360399389, -79.601936340332, -1.38931588010172, 218, 45, 'PPL', 'P'),
(21598, 'Greenwood Hills', 33.5041694641113, 0.584758070294887, -84.4097213745117, -1.47322755867626, 218, 13, 'PPL', 'P'),
(41204, 'Greenwood Hills', 32.4291687011719, 0.565995767520142, -93.9472198486328, -1.63968830945361, 218, 22, 'PPL', 'P'),
(162290, 'Greenwood Hills', 40.2180595397949, 0.701937557732537, -76.7719421386719, -1.3399231634704, 218, 45, 'PPL', 'P'),
(9232, 'Greenwood Junction', 35.4480590820313, 0.618685344422924, -94.4397201538086, -1.64828406134601, 218, 4, 'PPL', 'P'),
(135713, 'Greenwood Junction', 47.4408302307129, 0.827998687405601, -91.579719543457, -1.59836763408632, 218, 28, 'PPL', 'P'),
(149312, 'Greenwood Lake', 41.2224998474121, 0.719468348240201, -74.2947235107422, -1.29668754212129, 218, 40, 'PPL', 'P'),
(47716, 'Greenwood Manor', 38.4341697692871, 0.670802807744529, -75.5686111450195, -1.31892107563987, 218, 25, 'PPL', 'P'),
(70903, 'Greenwood Manor', 39.9791717529297, 0.697768179308936, -74.2472229003906, -1.29585850007395, 218, 37, 'PPL', 'P'),
(41205, 'Greenwood Park', 31.7569408416748, 0.554263178048285, -93.1458282470703, -1.62570138740852, 218, 22, 'PPL', 'P'),
(65234, 'Greenwood Park', 35.4061088562012, 0.617953174860234, -80.1911087036133, -1.39959887770273, 218, 33, 'PPL', 'P'),
(81360, 'Greenwood Park', 32.8227806091309, 0.572865591289083, -80.0472183227539, -1.39708751679479, 218, 48, 'PPL', 'P'),
(102479, 'Greenwood Park', 36.7219390869141, 0.640918744783451, -77.5647201538086, -1.35375975007196, 218, 53, 'PPL', 'P'),
(47717, 'Greenwood Place', 38.3430595397949, 0.669212634257643, -75.1186065673828, -1.31106701411107, 218, 25, 'PPL', 'P'),
(81361, 'Greenwood Shores', 34.1822204589844, 0.596592292651845, -81.9322204589844, -1.42998701047914, 218, 48, 'PPL', 'P'),
(60120, 'Greenwood Springs', 33.8869400024414, 0.591438676468378, -88.3088912963867, -1.54128091190771, 218, 30, 'PPL', 'P'),
(81362, 'Greenwood Village', 34.1927795410156, 0.596776583399278, -82.1730575561523, -1.43419041078566, 218, 48, 'PPL', 'P'),
(94614, 'Greenwood Village', 29.8822193145752, 0.52154311484238, -95.3349990844727, -1.66390962640983, 218, 51, 'PPL', 'P'),
(162300, 'Greenwood Village', 40.8805618286133, 0.713500403974416, -79.956672668457, -1.39550719700394, 218, 45, 'PPL', 'P'),
(186800, 'Greenwood Village', 39.6172218322754, 0.691450961466186, -104.95027923584, -1.83172792355284, 218, 7, 'PPL', 'P'),
(174367, 'Greenwyck', 43.7852783203125, 0.764197270591546, -89.0236129760742, -1.55375515845364, 218, 57, 'PPL', 'P'),
(2873, 'Greenwycke Village', 34.7033309936523, 0.605687387248629, -86.5505599975586, -1.51059224140229, 218, 2, 'PPL', 'P'),
(2874, 'Greer', 32.6805610656738, 0.570383391995075, -86.1569366455078, -1.50372221789627, 218, 2, 'PPL', 'P'),
(55096, 'Greer', 36.7694396972656, 0.641747786830792, -91.3533325195313, -1.59441643513503, 218, 29, 'PPL', 'P'),
(81363, 'Greer', 34.9386100769043, 0.609793781912449, -82.2272186279297, -1.43513569981459, 218, 48, 'PPL', 'P'),
(109486, 'Greer', 39.5719413757324, 0.690660668412705, -79.8491668701172, -1.39363086685792, 218, 58, 'PPL', 'P'),
(119873, 'Greer', 40.5330581665039, 0.707435320907869, -87.5947189331055, -1.52881625274171, 218, 18, 'PPL', 'P'),
(155555, 'Greer', 40.5222206115723, 0.707246169891446, -82.2002792358398, -1.43466551872413, 218, 41, 'PPL', 'P'),
(178302, 'Greer', 34.0099983215332, 0.593586449308499, -109.458061218262, -1.91040356110818, 218, 5, 'PPL', 'P'),
(195032, 'Greer', 46.3899993896484, 0.809658229347525, -116.174171447754, -2.02762179753969, 218, 17, 'PPL', 'P'),
(2875, 'Greer (historical)', 34.1388893127441, 0.595836021481289, -86.1833267211914, -1.5041828116068, 218, 2, 'PPL', 'P'),
(9235, 'Greer Place', 34.7527809143066, 0.606550451178896, -90.6725006103516, -1.5825336766672, 218, 4, 'PPL', 'P'),
(178303, 'Greer Place', 34.603328704834, 0.603942018049218, -109.604438781738, -1.9129583315419, 218, 5, 'PPL', 'P'),
(127641, 'Greers Corner', 44.374439239502, 0.774480068455478, -69.1305618286133, -1.20655591766281, 218, 26, 'PPL', 'P'),
(9236, 'Greers Ferry', 35.5769386291504, 0.620934716858632, -92.1772232055664, -1.60879604028286, 218, 4, 'PPL', 'P'),
(21601, 'Greers Mountain', 33.4186096191406, 0.583264769292652, -84.5713882446289, -1.4760491778512, 218, 13, 'PPL', 'P'),
(2876, 'Greerton (historical)', 34.9283294677734, 0.609614351434005, -86.1119384765625, -1.50293685169081, 218, 2, 'PPL', 'P'),
(65235, 'Greesons Crossroads', 36.0347213745117, 0.628924533024006, -79.6388931274414, -1.38996089771774, 218, 33, 'PPL', 'P'),
(41207, 'Greewood Plantation', 29.8138904571533, 0.520350551306243, -90.8688888549805, -1.58596129814819, 218, 22, 'PPL', 'P'),
(55097, 'Gregg', 37.0519409179688, 0.646678363272965, -94.5641708374023, -1.65045613553107, 218, 29, 'PPL', 'P'),
(162296, 'Gregg', 40.4063911437988, 0.705224564307967, -80.1647186279297, -1.3991382839922, 218, 45, 'PPL', 'P'),
(181925, 'Gregg', 36.8816719055176, 0.643706608391573, -119.935829162598, -2.09327510999676, 218, 6, 'PPL', 'P'),
(81364, 'Gregg Camp', 34.1969413757324, 0.59684922111801, -79.6397171020508, -1.38997527878762, 218, 48, 'PPL', 'P'),
(47718, 'Gregg Neck', 39.3624992370605, 0.687005213500463, -75.8666687011719, -1.32412316135518, 218, 25, 'PPL', 'P'),
(81365, 'Gregg Park', 33.5750007629395, 0.585994309672902, -81.7927780151367, -1.42755328071697, 218, 48, 'PPL', 'P'),
(803, 'Greggs', 39.0713882446289, 0.681924368193782, -82.9574966430664, -1.44788145563365, 218, 41, 'PPL', 'P'),
(21607, 'Greggs', 31.0686092376709, 0.542249525212883, -83.4899978637695, -1.45717535520581, 218, 13, 'PPL', 'P'),
(72762, 'Greggs Hill', 39.0944404602051, 0.682326705255466, -82.9730606079102, -1.44815309806484, 218, 41, 'PPL', 'P'),
(81366, 'Greggs Landing', 32.9283294677734, 0.574707766394119, -80.154167175293, -1.39895412640283, 218, 48, 'PPL', 'P'),
(102480, 'Greggsville', 39.0661087036133, 0.681832222820065, -77.7111129760742, -1.35631478682178, 218, 53, 'PPL', 'P'),
(177228, 'Greggsville', 40.089168548584, 0.699687985559747, -80.6880569458008, -1.4082722607409, 218, 58, 'PPL', 'P'),
(94616, 'Greggton', 32.4980583190918, 0.567198118173286, -94.7930603027344, -1.65445101032425, 218, 51, 'PPL', 'P'),
(174368, 'Gregorville', 44.6183280944824, 0.778736731983806, -87.54638671875, -1.52797269646642, 218, 57, 'PPL', 'P'),
(9237, 'Gregory', 35.1552810668945, 0.613575404081334, -91.3430633544922, -1.59423720439367, 218, 4, 'PPL', 'P'),
(21602, 'Gregory', 34.9533309936523, 0.610050710378615, -84.7825012207031, -1.47973379437738, 218, 13, 'PPL', 'P'),
(36206, 'Gregory', 36.8294410705566, 0.642795008350439, -84.7019424438477, -1.47832777847987, 218, 21, 'PPL', 'P'),
(65236, 'Gregory', 36.3838882446289, 0.635018644546435, -76.1233291625977, -1.32860273146675, 218, 33, 'PPL', 'P'),
(75993, 'Gregory', 36.1705589294434, 0.631295345605422, -95.5722198486328, -1.66804990979852, 218, 42, 'PPL', 'P'),
(94617, 'Gregory', 27.9219398498535, 0.487329783923755, -97.2897186279297, -1.69802591839623, 218, 51, 'PPL', 'P'),
(109487, 'Gregory', 38.7436103820801, 0.676203565277156, -80.5277786254883, -1.40547487633188, 218, 58, 'PPL', 'P'),
(131134, 'Gregory', 42.4583282470703, 0.741037622803889, -84.0844421386719, -1.46755036502249, 218, 27, 'PPL', 'P'),
(135717, 'Gregory', 45.9394416809082, 0.801794513859766, -94.3561096191406, -1.6468247822267, 218, 28, 'PPL', 'P'),
(155556, 'Gregory', 40.2402801513672, 0.70232538056628, -83.0130615234375, -1.4488512457446, 218, 41, 'PPL', 'P'),
(162299, 'Gregory', 41.2636108398438, 0.720185870416896, -75.9449996948242, -1.32549029510077, 218, 45, 'PPL', 'P'),
(170431, 'Gregory', 43.2322196960449, 0.754544576641526, -99.4300003051758, -1.73538088058428, 218, 49, 'PPL', 'P'),
(2877, 'Gregory (historical)', 34.2980613708496, 0.598614097972406, -86.2880630493164, -1.50601080537903, 218, 2, 'PPL', 'P'),
(60121, 'Gregory (historical)', 33.1444396972656, 0.578479601445998, -89.4222183227539, -1.56071213416926, 218, 30, 'PPL', 'P'),
(81367, 'Gregory (historical)', 34.6683311462402, 0.605076524673592, -81.5422210693359, -1.423180237049, 218, 48, 'PPL', 'P'),
(190284, 'Gregory (historical)', 39.3805618286133, 0.687320465194501, -118.949996948242, -2.07606909198403, 218, 39, 'PPL', 'P'),
(202179, 'Gregory (historical)', 44.1611099243164, 0.770756769514465, -103.738891601563, -1.81058522081676, 218, 49, 'PPL', 'P'),
(102481, 'Gregory Corner', 36.8002815246582, 0.642286078266124, -78.3647232055664, -1.36772243735114, 218, 53, 'PPL', 'P'),
(65237, 'Gregory Crossroads', 36.0486106872559, 0.629166947262231, -76.7527770996094, -1.33958867043749, 218, 33, 'PPL', 'P'),
(21603, 'Gregory Estates', 33.413330078125, 0.583172623918935, -84.478889465332, -1.4744347695984, 218, 13, 'PPL', 'P'),
(65238, 'Gregory Forks', 34.8816719055176, 0.608800023351686, -77.5774993896484, -1.35398278981326, 218, 33, 'PPL', 'P'),
(21604, 'Gregory Heights', 33.7119407653809, 0.588384363593193, -84.791389465332, -1.47988892351088, 218, 13, 'PPL', 'P'),
(207567, 'Gregory Heights', 47.4561080932617, 0.828265336409745, -122.359718322754, -2.13557995654489, 218, 56, 'PPL', 'P'),
(139199, 'Gregory Landing', 40.2813911437988, 0.703042902742974, -91.4961090087891, -1.59690835496701, 218, 29, 'PPL', 'P'),
(149314, 'Gregory Landing', 42.8102798461914, 0.747180337016212, -76.3127822875977, -1.33190931227619, 218, 40, 'PPL', 'P'),
(127642, 'Gregorys Corner', 44.4927787780762, 0.776545483038889, -69.307502746582, -1.20964411926287, 218, 26, 'PPL', 'P'),
(149315, 'Gregorytown', 42.0311088562012, 0.733581237804858, -75.0366668701172, -1.30963689660569, 218, 40, 'PPL', 'P'),
(36210, 'Gregoryville', 38.3269386291504, 0.668931271288476, -83.0213928222656, -1.44899665434012, 218, 21, 'PPL', 'P'),
(131135, 'Gregoryville', 47.1861114501953, 0.823553006018905, -88.3925018310547, -1.54274019102702, 218, 27, 'PPL', 'P'),
(196642, 'Gregson', 46.0480613708496, 0.803690285081739, -112.808609008789, -1.96888165179831, 218, 31, 'PPL', 'P'),
(41208, 'Greig', 29.9486103057861, 0.522701856232674, -91.829719543457, -1.60273095721631, 218, 22, 'PPL', 'P'),
(149316, 'Greig', 43.6813888549805, 0.762384057363365, -75.3550033569336, -1.31519291642987, 218, 40, 'PPL', 'P'),
(149318, 'Greigsville', 42.8305587768555, 0.747534271125083, -77.897216796875, -1.3595629112453, 218, 40, 'PPL', 'P'),
(131136, 'Greilickville', 44.7830581665039, 0.781611814117628, -85.6386108398438, -1.49467572598938, 218, 27, 'PPL', 'P'),
(41209, 'Greinwich Village', 30.1944408416748, 0.526992408485873, -93.1830596923828, -1.62635119871449, 218, 22, 'PPL', 'P'),
(162301, 'Greisemersville', 40.3544387817383, 0.704317824535822, -75.7566680908203, -1.32220328852534, 218, 45, 'PPL', 'P'),
(87475, 'Greivertown', 35.8352813720703, 0.625443648321218, -84.7927780151367, -1.4799131582768, 218, 50, 'PPL', 'P'),
(174369, 'Grellton', 43.1349983215332, 0.752847743552982, -88.788330078125, -1.5496486972108, 218, 57, 'PPL', 'P'),
(155557, 'Grelton', 41.3416709899902, 0.721548277051553, -83.9997177124023, -1.46607164482722, 218, 41, 'PPL', 'P'),
(60122, 'Grenada', 33.7688903808594, 0.589378321891038, -89.8083267211914, -1.56745099699159, 218, 30, 'PPL', 'P'),
(193606, 'Grenada', 41.6472206115723, 0.726881123976382, -122.518890380859, -2.13835803303601, 218, 6, 'PPL', 'P'),
(60124, 'Grenada Junction', 33.5391693115234, 0.585368932869924, -90.1647186279297, -1.57367120919164, 218, 30, 'PPL', 'P'),
(60125, 'Grenada Landing', 33.8038902282715, 0.589989184466075, -89.767219543457, -1.56673354139393, 218, 30, 'PPL', 'P'),
(47719, 'Grenada Manor', 38.3824996948242, 0.669900994820401, -75.5152816772461, -1.31799030083889, 218, 25, 'PPL', 'P'),
(75994, 'Grenade Crossing', 34.6697196960449, 0.605100759439512, -98.3805618286133, -1.71706472387116, 218, 42, 'PPL', 'P'),
(81369, 'Grenadier', 34.0397186279297, 0.59410516650982, -81.1341705322266, -1.41605841166191, 218, 48, 'PPL', 'P'),
(81370, 'Grendel Village', 34.202220916748, 0.596941366491727, -82.1549987792969, -1.43387522567065, 218, 48, 'PPL', 'P'),
(13869, 'Grendon Farms', 39.7249984741211, 0.693332018723137, -75.6777801513672, -1.32082643424177, 218, 10, 'PPL', 'P'),
(149319, 'Grenell', 44.2833290100098, 0.772889894968591, -76.0444412231445, -1.32722587718318, 218, 40, 'PPL', 'P'),
(70904, 'Grenloch', 39.7855606079102, 0.694389027359789, -75.0561065673828, -1.30997618332857, 218, 37, 'PPL', 'P'),
(70905, 'Grenloch Terrace', 39.7802810668945, 0.694296881986072, -75.0630569458008, -1.31009749031622, 218, 37, 'PPL', 'P'),
(162302, 'Grenoble', 40.2394409179688, 0.702310733180284, -75.038330078125, -1.30966592506158, 218, 45, 'PPL', 'P'),
(32635, 'Grenola', 37.3486099243164, 0.651856214222352, -96.4502792358398, -1.68337493713333, 218, 20, 'PPL', 'P'),
(198371, 'Grenora', 48.6183280944824, 0.848549902063579, -103.9375, -1.81405159129161, 218, 34, 'PPL', 'P'),
(170434, 'Grenville', 45.4669418334961, 0.793547835807254, -97.3933334350586, -1.69983433793445, 218, 49, 'PPL', 'P'),
(188635, 'Grenville', 36.5927810668945, 0.638664512078753, -103.615829467773, -1.80843738139761, 218, 38, 'PPL', 'P'),
(36207, 'Gresham', 37.1966705322266, 0.649204371566905, -85.4502792358398, -1.49138871941395, 218, 21, 'PPL', 'P'),
(81371, 'Gresham', 33.9300003051758, 0.592190220527998, -79.4113922119141, -1.38599025769048, 218, 48, 'PPL', 'P'),
(94618, 'Gresham', 32.2291717529297, 0.562505162279375, -95.3491668701172, -1.66415690091704, 218, 51, 'PPL', 'P'),
(131137, 'Gresham', 42.6413917541504, 0.744232683742685, -84.8952789306641, -1.48170213673906, 218, 27, 'PPL', 'P'),
(141966, 'Gresham', 41.0283317565918, 0.716079475753076, -97.4019393920898, -1.69998454021993, 218, 35, 'PPL', 'P'),
(155558, 'Gresham', 41.4466705322266, 0.723380864776664, -81.7669372558594, -1.42710227438636, 218, 41, 'PPL', 'P'),
(162303, 'Gresham', 41.6236114501953, 0.72646906637672, -79.7200012207031, -1.39137650099517, 218, 45, 'PPL', 'P'),
(174370, 'Gresham', 44.8530616760254, 0.782833605846729, -88.7880630493164, -1.54964403667889, 218, 57, 'PPL', 'P'),
(200925, 'Gresham', 45.4983291625977, 0.794095648043484, -122.430282592773, -2.136811535391, 218, 43, 'PPL', 'P'),
(55098, 'Gresham (historical)', 37.4252815246582, 0.653194386091089, -93.399169921875, -1.63012303376637, 218, 29, 'PPL', 'P'),
(21605, 'Gresham Park', 33.7033309936523, 0.588234094728685, -84.3144378662109, -1.47156454773356, 218, 13, 'PPL', 'P'),
(21606, 'Greshamville', 33.6263885498047, 0.586891195749013, -83.3238906860352, -1.45427623804315, 218, 13, 'PPL', 'P'),
(162304, 'Greshville', 40.3183288574219, 0.703687587463855, -75.6636123657227, -1.32057915973456, 218, 45, 'PPL', 'P'),
(102482, 'Gressitt', 37.4872207641602, 0.654275429756579, -76.7080612182617, -1.33880823108004, 218, 53, 'PPL', 'P'),
(21608, 'Gresston', 32.2861099243164, 0.563498920840139, -83.2525024414063, -1.45303027812716, 218, 13, 'PPL', 'P'),
(102483, 'Greta (historical)', 37.913330078125, 0.66171244025868, -75.5341720581055, -1.31832000018184, 218, 53, 'PPL', 'P'),
(36208, 'Grethel', 37.4911117553711, 0.654343340364376, -82.6477813720703, -1.44247590441106, 218, 21, 'PPL', 'P'),
(36209, 'Grethel PO', 37.482780456543, 0.654197931768858, -82.6572189331055, -1.44264062092449, 218, 21, 'PPL', 'P'),
(16287, 'Gretna', 30.6169395446777, 0.53436640193868, -84.6600036621094, -1.47759580865427, 218, 12, 'PPL', 'P'),
(32636, 'Gretna', 39.7652816772461, 0.694035093250917, -99.2125015258789, -1.73158481076649, 218, 20, 'PPL', 'P'),
(41210, 'Gretna', 29.9144401550293, 0.522105474596064, -90.0538864135742, -1.57173682213386, 218, 22, 'PPL', 'P'),
(55099, 'Gretna', 36.6602783203125, 0.63984256138695, -93.2677764892578, -1.62782978575171, 218, 29, 'PPL', 'P'),
(60126, 'Gretna', 31.7594394683838, 0.554306787311135, -88.5019378662109, -1.54465021016083, 218, 30, 'PPL', 'P'),
(102484, 'Gretna', 36.9536094665527, 0.644962155687491, -79.3591690063477, -1.3850787908074, 218, 53, 'PPL', 'P'),
(119874, 'Gretna', 41.8980598449707, 0.731259094492364, -88.1013870239258, -1.53765927914131, 218, 18, 'PPL', 'P'),
(141967, 'Gretna', 41.1408309936523, 0.718042957845764, -96.2394409179688, -1.67969511429711, 218, 35, 'PPL', 'P'),
(149320, 'Gretna', 41.7805595397949, 0.729208327294948, -73.8463897705078, -1.28886264220642, 218, 40, 'PPL', 'P'),
(155559, 'Gretna', 40.3466682434082, 0.70418220305731, -83.8586120605469, -1.46360888660917, 218, 41, 'PPL', 'P'),
(162305, 'Gretna', 40.2458305358887, 0.702422253050931, -80.3033294677734, -1.40155749952643, 218, 45, 'PPL', 'P'),
(170438, 'Gretna', 45.4505615234375, 0.793261945464234, -99.5144424438477, -1.73685467393153, 218, 49, 'PPL', 'P'),
(41211, 'Gretna Green', 31.8791694641113, 0.556396469949979, -91.4633331298828, -1.59633630796487, 218, 22, 'PPL', 'P'),
(65239, 'Gretna Green', 36.389720916748, 0.635120443879103, -77.8536071777344, -1.35880177980576, 218, 33, 'PPL', 'P'),
(196643, 'Greve (historical)', 48.9702796936035, 0.854692616275901, -107.419441223145, -1.8748229299964, 218, 31, 'PPL', 'P'),
(87478, 'Grey (historical)', 36.4686088562012, 0.636497298162674, -85.3863906860352, -1.49027365386553, 218, 50, 'PPL', 'P'),
(135720, 'Grey Eagle', 45.8252792358398, 0.799802003311196, -94.7463912963867, -1.65363648250485, 218, 28, 'PPL', 'P'),
(47720, 'Grey Estates', 39.0486106872559, 0.681526824822061, -77.0175018310547, -1.34420898861267, 218, 25, 'PPL', 'P'),
(94619, 'Grey Forest', 29.6152801513672, 0.516884147541882, -98.6805572509766, -1.72230063173231, 218, 51, 'PPL', 'P'),
(81373, 'Grey Fox Run', 34.8980598449707, 0.609086046852761, -82.2988891601563, -1.4363865865786, 218, 48, 'PPL', 'P'),
(149321, 'Grey Oaks', 40.9661102294922, 0.714993505239569, -73.870002746582, -1.28927476638511, 218, 40, 'PPL', 'P'),
(47721, 'Grey Rock', 39.394718170166, 0.687567539964633, -76.7375030517578, -1.33932208801237, 218, 25, 'PPL', 'P'),
(81374, 'Grey Rock', 35.0444412231445, 0.611640883865501, -80.991943359375, -1.41357607920985, 218, 48, 'PPL', 'P'),
(181930, 'Grey Rocks (historical)', 36.2677803039551, 0.632992178693966, -119.10417175293, -2.07875994994945, 218, 6, 'PPL', 'P'),
(209485, 'Greybull', 44.4891700744629, 0.776482499279108, -108.055557250977, -1.88592524910677, 218, 59, 'PPL', 'P'),
(196644, 'Greycliff', 45.7633285522461, 0.798720759908624, -109.783889770508, -1.91609034214188, 218, 31, 'PPL', 'P'),
(149322, 'Greycourt', 41.3619384765625, 0.721902011423343, -74.2558288574219, -1.29600870235943, 218, 40, 'PPL', 'P'),
(109488, 'Greyeagle', 37.8494415283203, 0.660597374710264, -82.4169387817383, -1.43844694115594, 218, 58, 'PPL', 'P'),
(21612, 'Greyfield', 30.7780609130859, 0.537178500312722, -81.4663925170898, -1.42185677914529, 218, 13, 'PPL', 'P'),
(21610, 'Greyfield North', 34.0019416809082, 0.593445834402943, -84.6500015258789, -1.47742123844481, 218, 13, 'PPL', 'P'),
(9239, 'Greyhawk Addition', 34.9613914489746, 0.610191391863198, -92.0547180175781, -1.60665792140169, 218, 4, 'PPL', 'P'),
(155560, 'Greyhound', 41.6436080932617, 0.726818073637575, -84.6116714477539, -1.47675225237898, 218, 41, 'PPL', 'P'),
(13870, 'Greylag', 39.4841690063477, 0.689128751574664, -75.6680603027344, -1.32065679088033, 218, 10, 'PPL', 'P'),
(81375, 'Greyland Forest', 33.9902801513672, 0.593242302316634, -81.1500015258789, -1.41633471462501, 218, 48, 'PPL', 'P'),
(102485, 'Greyledge', 37.5722198486328, 0.655758943641808, -79.6666717529297, -1.39044572619419, 218, 53, 'PPL', 'P'),
(65240, 'Greyleigh', 35.5602798461914, 0.620643966246623, -77.3850021362305, -1.35062307894007, 218, 33, 'PPL', 'P'),
(124980, 'Greylock', 42.6963882446289, 0.745192553578577, -73.1519393920898, -1.27674219661131, 218, 23, 'PPL', 'P'),
(124981, 'Greylock Estates', 42.5419387817383, 0.742496901923198, -73.2283325195313, -1.27807550821106, 218, 23, 'PPL', 'P'),
(195033, 'Greys Landing', 42.1327781677246, 0.735355702039178, -114.728332519531, -2.0023871477887, 218, 17, 'PPL', 'P'),
(21611, 'Greystone', 34.3611106872559, 0.599714516134826, -83.8711090087891, -1.46382699950245, 218, 13, 'PPL', 'P'),
(65243, 'Greystone', 36.3605613708496, 0.634611513794789, -78.3494415283203, -1.36745572176797, 218, 33, 'PPL', 'P'),
(87476, 'Greystone', 36.1002807617188, 0.630068760186359, -82.7077789306641, -1.44352305935168, 218, 50, 'PPL', 'P'),
(109489, 'Greystone', 39.6877784729004, 0.692682407154239, -79.8625030517578, -1.39386362713719, 218, 58, 'PPL', 'P'),
(113499, 'Greystone', 41.6188888549805, 0.726386641540982, -73.0416717529297, -1.27481766324956, 218, 8, 'PPL', 'P'),
(149323, 'Greystone', 40.9711112976074, 0.715080790344296, -73.8886108398438, -1.28959953888005, 218, 40, 'PPL', 'P'),
(169405, 'Greystone', 41.8663902282715, 0.730706355408118, -71.4908294677734, -1.24775035919443, 218, 47, 'PPL', 'P'),
(194220, 'Greystone', 40.6094398498535, 0.708768432770536, -108.673332214355, -1.89670745625412, 218, 7, 'PPL', 'P'),
(181926, 'Greystone (historical)', 37.2213897705078, 0.649635803663498, -121.845832824707, -2.12661096262572, 218, 6, 'PPL', 'P'),
(78404, 'Greystone Farms', 39.9819412231445, 0.697816515682721, -76.6211090087891, -1.33729062873286, 218, 45, 'PPL', 'P'),
(65244, 'Greystone Forest', 36.1711082458496, 0.631304932985346, -80.0869369506836, -1.39778073762654, 218, 33, 'PPL', 'P'),
(87477, 'Greystone Heights', 35.7172203063965, 0.623383094006797, -83.5158309936523, -1.45762622837836, 218, 50, 'PPL', 'P'),
(94620, 'Gribble', 32.9002799987793, 0.574218210806735, -96.9102783203125, -1.69140343571353, 218, 51, 'PPL', 'P'),
(188636, 'Gribble Place', 33.9630584716797, 0.592767194378164, -108.875282287598, -1.90023214995684, 218, 38, 'PPL', 'P'),
(94621, 'Grice', 32.8061103820801, 0.572574640939992, -95.1188888549805, -1.66013779135795, 218, 51, 'PPL', 'P'),
(9240, 'Grider', 35.6386108398438, 0.622011099992215, -89.9805603027344, -1.57045704007202, 218, 4, 'PPL', 'P'),
(36211, 'Grider', 36.8041687011719, 0.642353922294894, -85.4255599975586, -1.49095728731736, 218, 21, 'PPL', 'P'),
(36212, 'Griderville', 37.1127815246582, 0.647740232178607, -85.8702774047852, -1.49871907031439, 218, 21, 'PPL', 'P'),
(32637, 'Gridley', 38.0977783203125, 0.664931669384368, -95.8833312988281, -1.67347982894508, 218, 20, 'PPL', 'P'),
(60127, 'Gridley', 32.0597190856934, 0.559547655309815, -89.1125030517578, -1.55530658294667, 218, 30, 'PPL', 'P'),
(115870, 'Gridley', 43.3994407653809, 0.757463134880144, -94.5730590820313, -1.65061126466457, 218, 16, 'PPL', 'P'),
(119875, 'Gridley', 40.7433280944824, 0.711105223469026, -88.8813934326172, -1.55127295915963, 218, 18, 'PPL', 'P'),
(122737, 'Gridley', 40.0886116027832, 0.699678265021768, -85.6527786254883, -1.49492300049659, 218, 19, 'PPL', 'P'),
(181927, 'Gridley', 39.3638916015625, 0.68702951484541, -121.692497253418, -2.1239347520463, 218, 6, 'PPL', 'P'),
(9241, 'Gridley (historical)', 35.5074996948242, 0.619722778825564, -92.6755599975586, -1.61749365808695, 218, 4, 'PPL', 'P'),
(55100, 'Gridley (historical)', 39.8061103820801, 0.694747688579595, -94.2750015258789, -1.64540917894927, 218, 29, 'PPL', 'P'),
(181928, 'Gridley Colony Number One (historical)', 39.3344383239746, 0.686515458175997, -121.661109924316, -2.12338693981007, 218, 6, 'PPL', 'P'),
(181929, 'Gridley Colony Number Two (historical)', 39.350830078125, 0.686801548256099, -121.661109924316, -2.12338693981007, 218, 6, 'PPL', 'P'),
(149324, 'Gridleyville', 42.2449989318848, 0.737314323862877, -76.3724975585938, -1.33295154036879, 218, 40, 'PPL', 'P'),
(162306, 'Grieder', 40.2136116027832, 0.701859926586761, -77.3141708374023, -1.34938683956205, 218, 45, 'PPL', 'P'),
(87480, 'Grief (historical)', 35.2036094665527, 0.61441889377759, -84.6986083984375, -1.47826958841006, 218, 50, 'PPL', 'P'),
(188637, 'Grier', 34.4105606079102, 0.600577580065094, -103.398063659668, -1.8046366510479, 218, 38, 'PPL', 'P'),
(162307, 'Grier City', 40.8286094665527, 0.712593664202271, -76.0561065673828, -1.32742947584851, 218, 45, 'PPL', 'P'),
(162308, 'Griers Corner', 40.3622207641602, 0.704453645751416, -75.1847229003906, -1.3122209618114, 218, 45, 'PPL', 'P'),
(194221, 'Griff', 40.7822189331055, 0.71178399665186, -103.00666809082, -1.7978055096938, 218, 7, 'PPL', 'P'),
(87479, 'Griffen', 35.2761116027832, 0.615684294769541, -89.5002822875977, -1.56207460738294, 218, 50, 'PPL', 'P'),
(115871, 'Griffen', 42.1877784729004, 0.736315638454097, -93.7947235107422, -1.63702674626019, 218, 16, 'PPL', 'P'),
(2878, 'Griffen Mill', 32.5258293151855, 0.56768281349168, -85.2663879394531, -1.48817921082624, 218, 2, 'PPL', 'P'),
(9242, 'Griffin', 33.1366691589355, 0.578343979967485, -92.7713928222656, -1.61916625640957, 218, 4, 'PPL', 'P'),
(16288, 'Griffin', 28.083890914917, 0.490156363236224, -81.9952774047852, -1.43108756179961, 218, 12, 'PPL', 'P'),
(21613, 'Griffin', 33.2466697692871, 0.580263852797324, -84.2641677856445, -1.47068716931244, 218, 13, 'PPL', 'P'),
(29959, 'Griffin', 38.2041702270508, 0.666788558454426, -87.9147186279297, -1.53440130102176, 218, 19, 'PPL', 'P'),
(36213, 'Griffin', 36.7044410705566, 0.640613346785446, -84.728889465332, -1.47879809272838, 218, 21, 'PPL', 'P'),
(41212, 'Griffin', 32.0374984741211, 0.559159832476072, -91.5669403076172, -1.59814459434503, 218, 22, 'PPL', 'P'),
(47723, 'Griffin', 38.8613891601563, 0.678259192743561, -75.9141693115234, -1.32495220340252, 218, 25, 'PPL', 'P'),
(55102, 'Griffin', 37.0805587768555, 0.647177839135409, -93.378059387207, -1.62975458542956, 218, 29, 'PPL', 'P'),
(72763, 'Griffin', 39.9230613708496, 0.696788868397087, -81.9263916015625, -1.4298852777255, 218, 41, 'PPL', 'P'),
(78405, 'Griffin', 39.8400001525879, 0.695339176657702, -79.8916702270508, -1.39437269037956, 218, 45, 'PPL', 'P'),
(94622, 'Griffin', 32.0380592346191, 0.559169619593078, -95.0752792358398, -1.6593766599184, 218, 51, 'PPL', 'P'),
(119877, 'Griffin', 41.2402801513672, 0.719778673086223, -90.4894409179688, -1.57933868230743, 218, 18, 'PPL', 'P'),
(149325, 'Griffin', 43.4722213745117, 0.758733396141084, -74.2233276367188, -1.29544144904724, 218, 40, 'PPL', 'P'),
(198374, 'Griffin', 46.2158317565918, 0.806618430700281, -103.540283203125, -1.80711885034191, 218, 34, 'PPL', 'P'),
(27337, 'Griffin (historical)', 39.4466705322266, 0.688474279736777, -87.6547164916992, -1.52986340768232, 218, 18, 'PPL', 'P'),
(87481, 'Griffin (historical)', 36.2630615234375, 0.632909820437255, -87.9291687011719, -1.534653502377, 218, 50, 'PPL', 'P'),
(2880, 'Griffin Addition', 34.5877799987793, 0.603670641934139, -87.0219421386719, -1.51881941179982, 218, 2, 'PPL', 'P'),
(87482, 'Griffin Corner', 35.3258285522461, 0.616552019231716, -89.9855575561523, -1.57054425859772, 218, 50, 'PPL', 'P'),
(55101, 'Griffin Ford', 36.5666694641113, 0.638208778637213, -94.3047180175781, -1.64592782957156, 218, 29, 'PPL', 'P'),
(2881, 'Griffin Heights', 31.2563896179199, 0.545526911118875, -85.4355621337891, -1.49113185752681, 218, 2, 'PPL', 'P'),
(21614, 'Griffin Heights', 34.3669395446777, 0.599816248888467, -83.8024978637695, -1.46262950911829, 218, 13, 'PPL', 'P'),
(181931, 'Griffin Place', 39.9694404602051, 0.697598336210416, -122.785278320313, -2.14300737966707, 218, 6, 'PPL', 'P'),
(94623, 'Griffing Park', 29.9174995422363, 0.52215887097592, -93.9241714477539, -1.63928603897095, 218, 51, 'PPL', 'P'),
(2883, 'Griffins (historical)', 32.3316688537598, 0.564294074162609, -87.9561080932617, -1.53512368346745, 218, 2, 'PPL', 'P'),
(16289, 'Griffins Corner', 27.5394401550293, 0.480653904861199, -81.7311096191406, -1.42647696416241, 218, 12, 'PPL', 'P'),
(149326, 'Griffins Corners', 42.9333305358887, 0.749327976698279, -76.1972198486328, -1.32989236722462, 218, 40, 'PPL', 'P'),
(65249, 'Griffins Crossroads', 35.7369384765625, 0.623727240998662, -79.083610534668, -1.38026938819483, 218, 33, 'PPL', 'P'),
(102486, 'Griffins Landing', 37.7513885498047, 0.658886027393779, -76.5224990844727, -1.33556956087839, 218, 53, 'PPL', 'P'),
(149327, 'Griffins Mills', 42.7238883972168, 0.745672521786036, -78.6675033569336, -1.37300694790218, 218, 40, 'PPL', 'P'),
(102487, 'Griffinsburg', 38.5219383239746, 0.672334658003543, -78.0986099243164, -1.36307788441004, 218, 53, 'PPL', 'P'),
(87483, 'Griffintown', 36.1824989318848, 0.631503737960721, -87.1374969482422, -1.52083622369334, 218, 50, 'PPL', 'P'),
(21615, 'Griffith', 32.6363906860352, 0.569612473438524, -84.0999984741211, -1.46782187429562, 218, 13, 'PPL', 'P'),
(36214, 'Griffith', 37.8152809143066, 0.660001159521223, -87.2127838134766, -1.52215022737518, 218, 21, 'PPL', 'P'),
(60128, 'Griffith', 33.6349983215332, 0.587041464613521, -88.8280563354492, -1.5503420512006, 218, 30, 'PPL', 'P'),
(72764, 'Griffith', 39.7208290100098, 0.69325924784635, -81.1050033569336, -1.41554934841954, 218, 41, 'PPL', 'P'),
(87484, 'Griffith', 35.5999984741211, 0.62133718707837, -85.2716674804688, -1.48827135619996, 218, 50, 'PPL', 'P'),
(102488, 'Griffith', 37.8658294677734, 0.660883398211339, -79.726936340332, -1.39149754166671, 218, 53, 'PPL', 'P'),
(122738, 'Griffith', 41.5283317565918, 0.724806122013047, -87.4236068725586, -1.52582978389529, 218, 19, 'PPL', 'P'),
(178304, 'Griffith', 35.0666694641113, 0.612028839857298, -114.115829467773, -1.99169695285701, 218, 5, 'PPL', 'P'),
(191555, 'Griffith', 33.7580604553223, 0.58918930403267, -103.019172668457, -1.79802375574513, 218, 51, 'PPL', 'P'),
(72765, 'Griffith (historical)', 39.7236099243164, 0.693307783957217, -82.9572219848633, -1.44787666194369, 218, 41, 'PPL', 'P'),
(87485, 'Griffith Creek', 35.2838897705078, 0.615820049406108, -85.5500030517578, -1.49312922834437, 218, 50, 'PPL', 'P'),
(109491, 'Griffith Creek', 37.7275009155273, 0.658469109525127, -80.6766662597656, -1.40807345576553, 218, 58, 'PPL', 'P'),
(47724, 'Griffith Park', 39.2277793884277, 0.684653908574032, -77.1236114501953, -1.34606095083471, 218, 25, 'PPL', 'P'),
(149328, 'Griffiths', 42.1216697692871, 0.73516182391182, -79.3194427490234, -1.3843854368176, 218, 40, 'PPL', 'P'),
(162310, 'Griffiths', 41.6949996948242, 0.727715026292714, -78.7183303833008, -1.37389404686129, 218, 45, 'PPL', 'P'),
(102489, 'Griffiths Corner', 38.0333290100098, 0.663806816718946, -76.6305618286133, -1.33745561156239, 218, 53, 'PPL', 'P'),
(109490, 'Griffithsville', 38.2386093139648, 0.667389633912457, -81.9894409179688, -1.43098569588792, 218, 58, 'PPL', 'P'),
(9245, 'Griffithtown', 34.0547218322754, 0.594367021824002, -92.9594421386719, -1.62244833613698, 218, 4, 'PPL', 'P'),
(162311, 'Griffithtown', 40.5016708374023, 0.70688750867164, -78.8461074829102, -1.37612417795812, 218, 45, 'PPL', 'P'),
(9246, 'Griffithville', 35.1236114501953, 0.613022664997089, -91.6449966430664, -1.59950693440066, 218, 4, 'PPL', 'P'),
(87486, 'Griffitts (historical)', 35.6819381713867, 0.622767304583743, -84.2305603027344, -1.47010060808235, 218, 50, 'PPL', 'P'),
(2884, 'Griffitts Lake Shore Subdivision', 33.5077781677246, 0.584821054054667, -86.2769393920898, -1.50581666093556, 218, 2, 'PPL', 'P'),
(186801, 'Griffth (historical)', 37.2144393920898, 0.649514496675845, -107.795562744141, -1.88138748892539, 218, 7, 'PPL', 'P'),
(36215, 'Griffytown', 38.2536087036133, 0.667651422647611, -85.545280456543, -1.49304680350863, 218, 21, 'PPL', 'P'),
(65252, 'Grifton', 35.372501373291, 0.617366613630144, -77.4377822875977, -1.35154426636113, 218, 33, 'PPL', 'P'),
(102491, 'Grigbys Store', 36.7855606079102, 0.642029149799959, -82.3863906860352, -1.4379137763057, 218, 53, 'PPL', 'P'),
(27338, 'Grigg', 38.190559387207, 0.666551004485191, -89.9077835083008, -1.56918684539011, 218, 18, 'PPL', 'P'),
(190983, 'Griggs', 36.6027793884277, 0.63883901570918, -102.121940612793, -1.78236410221935, 218, 42, 'PPL', 'P'),
(145335, 'Griggstown', 40.4377784729004, 0.705772376544196, -74.6136093139648, -1.30225314932539, 218, 37, 'PPL', 'P'),
(27339, 'Griggsville', 39.7088890075684, 0.693050855491051, -90.7244415283203, -1.58344021670227, 218, 18, 'PPL', 'P'),
(36216, 'Grigsby', 37.285831451416, 0.650760523170866, -83.1377792358398, -1.45102798046158, 218, 21, 'PPL', 'P'),
(87487, 'Grigsby', 36.3238906860352, 0.633971489605815, -82.9961090087891, -1.4485553685475, 218, 50, 'PPL', 'P'),
(94624, 'Grigsby', 31.6550006866455, 0.55248398670303, -94.3913879394531, -1.64744050507072, 218, 51, 'PPL', 'P'),
(187696, 'Grigston', 38.4847183227539, 0.671685046434645, -100.716667175293, -1.75783745384416, 218, 20, 'PPL', 'P'),
(191556, 'Grijalva Gardens Colonia', 31.6720008850098, 0.552780696137978, -106.272003173828, -1.85479635807316, 218, 51, 'PPL', 'P'),
(162312, 'Grill', 40.2986106872559, 0.70334344047199, -75.9408264160156, -1.32541745764496, 218, 45, 'PPL', 'P'),
(41214, 'Grim', 32.7024993896484, 0.570766287980801, -93.3730621337891, -1.62966736690386, 218, 22, 'PPL', 'P'),
(21617, 'Grimball Park', 31.9930591583252, 0.558384220098101, -81.0638885498047, -1.41483175966382, 218, 13, 'PPL', 'P'),
(81376, 'Grimball Shores', 32.7030601501465, 0.570776075097807, -79.9822235107422, -1.39595314332847, 218, 48, 'PPL', 'P'),
(2886, 'Grimes', 33.1674995422363, 0.578882071665736, -87.39111328125, -1.52526266374116, 218, 2, 'PPL', 'P'),
(41213, 'Grimes', 32.6558303833008, 0.5699517601614, -91.1816711425781, -1.59142037890869, 218, 22, 'PPL', 'P'),
(47725, 'Grimes', 39.521110534668, 0.689773502874573, -77.7713928222656, -1.35736686861042, 218, 25, 'PPL', 'P'),
(75995, 'Grimes', 35.4661102294922, 0.61900039637988, -99.7605590820313, -1.74115021961178, 218, 42, 'PPL', 'P'),
(102490, 'Grimes', 39.2780609130859, 0.68553148673224, -78.1263885498047, -1.36356271288649, 218, 53, 'PPL', 'P'),
(115873, 'Grimes', 41.6883316040039, 0.727598646153077, -93.7908325195313, -1.63695883565239, 218, 16, 'PPL', 'P'),
(181932, 'Grimes', 39.0744400024414, 0.681977631415584, -121.892776489258, -2.12743028413508, 218, 6, 'PPL', 'P'),
(191557, 'Grimes', 32.4588890075684, 0.566514484721462, -100.178329467773, -1.74844168836031, 218, 51, 'PPL', 'P'),
(65258, 'Grimes (historical)', 35.5883293151855, 0.621133521834007, -80.5458297729492, -1.40578992828884, 218, 33, 'PPL', 'P'),
(72766, 'Grimes (historical)', 38.6805610656738, 0.675103147114735, -83.454719543457, -1.45655963236178, 218, 41, 'PPL', 'P'),
(119878, 'Grimes Addition', 41.7980613708496, 0.72951379187198, -89.7486114501953, -1.56640876889899, 218, 18, 'PPL', 'P'),
(55103, 'Grimes Mill', 37.3216705322266, 0.651386033131898, -92.3927764892578, -1.61255815479676, 218, 29, 'PPL', 'P'),
(127643, 'Grimes Mill', 46.8463897705078, 0.817623744167952, -67.9436111450195, -1.18583972017531, 218, 26, 'PPL', 'P'),
(195034, 'Grimes Pass', 44.0447196960449, 0.76872537681398, -115.856391906738, -2.02207549825349, 218, 17, 'PPL', 'P'),
(47726, 'Grimesdale', 39.3250007629395, 0.686350741662576, -76.4672164916992, -1.33460469761546, 218, 25, 'PPL', 'P'),
(65254, 'Grimesdale', 35.3638916015625, 0.617216344765636, -82.4755630493164, -1.43947012764675, 218, 33, 'PPL', 'P'),
(65255, 'Grimesland', 35.5633316040039, 0.620697229468424, -77.192497253418, -1.34726323490882, 218, 33, 'PPL', 'P'),
(47727, 'Grimesville', 39.6930618286133, 0.692774619106983, -76.7088928222656, -1.33882274530798, 218, 25, 'PPL', 'P'),
(162315, 'Grimesville', 41.2483291625977, 0.719919154833725, -77.067497253418, -1.34508157334383, 218, 45, 'PPL', 'P'),
(181933, 'Griminger', 38.7197189331055, 0.675786580829477, -120.409172058105, -2.1015365020143, 218, 6, 'PPL', 'P'),
(55104, 'Grimmet', 36.7813911437988, 0.641956378923173, -92.0063934326172, -1.60581449828446, 218, 29, 'PPL', 'P'),
(174372, 'Grimms', 44.146110534668, 0.77049498077931, -87.9016723632813, -1.53417360074856, 218, 57, 'PPL', 'P'),
(155561, 'Grimms Bridge', 40.6761093139648, 0.709932034429818, -80.541389465332, -1.40571243030112, 218, 41, 'PPL', 'P'),
(78406, 'Grimms Crossroads', 39.9099998474121, 0.696560901807776, -76.5494384765625, -1.33603974196885, 218, 45, 'PPL', 'P'),
(109492, 'Grimms Landing', 38.6775016784668, 0.675049750734879, -81.9488906860352, -1.43027796082823, 218, 58, 'PPL', 'P'),
(155562, 'Grimms Subdivision', 41.6788902282715, 0.727433863060628, -84.6186065673828, -1.47687329305053, 218, 41, 'PPL', 'P'),
(27341, 'Grimsby', 37.7502784729004, 0.658866652896849, -89.4491729736328, -1.56118258157582, 218, 18, 'PPL', 'P'),
(21616, 'Grimshaw', 32.3988914489746, 0.565467329780843, -81.6988906860352, -1.42591463769824, 218, 13, 'PPL', 'P'),
(65257, 'Grimshawes', 35.0758285522461, 0.61218869610173, -83.1105575561523, -1.45055287252311, 218, 33, 'PPL', 'P'),
(87488, 'Grimsley', 36.2669410705566, 0.632977531307971, -84.9844436645508, -1.48325835492205, 218, 50, 'PPL', 'P'),
(102492, 'Grimsleyville', 37.1680603027344, 0.648705028862515, -81.9030609130859, -1.42947808039482, 218, 53, 'PPL', 'P'),
(102493, 'Grimstead', 37.5002784729004, 0.654503329766863, -76.3016662597656, -1.33171530099078, 218, 53, 'PPL', 'P'),
(162313, 'Grimville', 40.5777816772461, 0.708215893423371, -75.7850036621094, -1.32269783753977, 218, 45, 'PPL', 'P'),
(131138, 'Grind Stone City', 44.0502815246582, 0.768822449035713, -82.9008331298828, -1.44689249076285, 218, 27, 'PPL', 'P'),
(81377, 'Grindall (historical)', 34.8911094665527, 0.608964739865108, -81.6374969482422, -1.42484311483365, 218, 48, 'PPL', 'P'),
(127645, 'Grindstone', 45.7361106872559, 0.798245718549181, -68.5872192382813, -1.1970728004952, 218, 26, 'PPL', 'P'),
(149329, 'Grindstone', 44.2833290100098, 0.772889894968591, -76.1430587768555, -1.32894707819569, 218, 40, 'PPL', 'P'),
(162314, 'Grindstone', 40.0161094665527, 0.698412864029817, -79.8308334350586, -1.39331088805295, 218, 45, 'PPL', 'P'),
(202181, 'Grindstone', 44.1391716003418, 0.770373873528739, -101.966941833496, -1.77965886318405, 218, 49, 'PPL', 'P'),
(102494, 'Grinels', 37.5697212219238, 0.655715334378958, -76.3586120605469, -1.33270919270959, 218, 53, 'PPL', 'P'),
(162316, 'Gringo', 40.5638885498047, 0.70797341260612, -80.2716674804688, -1.40100489360024, 218, 45, 'PPL', 'P'),
(27346, 'Grinnell', 37.2791709899902, 0.650644276189284, -88.8722229003906, -1.55111290317812, 218, 18, 'PPL', 'P'),
(115875, 'Grinnell', 41.7430610656738, 0.728553855457061, -92.7222213745117, -1.61830805274829, 218, 16, 'PPL', 'P'),
(187697, 'Grinnell', 39.1272201538086, 0.682898818836642, -100.628608703613, -1.75630054357907, 218, 20, 'PPL', 'P'),
(207568, 'Grinnell', 46.9622192382813, 0.819645349751431, -117.067779541016, -2.04321820098958, 218, 56, 'PPL', 'P'),
(32638, 'Grinter Heights', 39.0738906860352, 0.681968044035659, -94.7638931274414, -1.65394194708188, 218, 20, 'PPL', 'P'),
(178305, 'Gripe', 32.8125, 0.572686160810639, -109.601387023926, -1.91290506832009, 218, 5, 'PPL', 'P'),
(109493, 'Grippe', 38.1988906860352, 0.666696413080709, -81.7363891601563, -1.42656910953613, 218, 58, 'PPL', 'P'),
(207569, 'Grisdale', 47.3572196960449, 0.826539408286292, -123.611106872559, -2.15742080696074, 218, 56, 'PPL', 'P'),
(196645, 'Grisdella (historical)', 46.9911117553711, 0.820149619303838, -106.96305847168, -1.86685754833402, 218, 31, 'PPL', 'P'),
(162317, 'Grisemore', 40.6472206115723, 0.709427831456439, -78.8786087036133, -1.37669143127031, 218, 45, 'PPL', 'P'),
(55105, 'Grisham', 37.3797187805176, 0.652399166189591, -90.100830078125, -1.57255614364322, 218, 29, 'PPL', 'P'),
(191558, 'Grisham Pumping Station', 31.4511108398438, 0.548925437564952, -104.197776794434, -1.81859427832101, 218, 51, 'PPL', 'P'),
(122739, 'Grismore', 41.4955596923828, 0.724234141589926, -85.6347198486328, -1.49460781538158, 218, 19, 'PPL', 'P'),
(27343, 'Grisold (historical)', 38.7152786254883, 0.675709082841755, -87.6875, -1.53043558784253, 218, 18, 'PPL', 'P'),
(81378, 'Grissett', 33.8486099243164, 0.59076969040255, -79.0219421386719, -1.37919307164027, 218, 48, 'PPL', 'P'),
(65261, 'Grissettown', 33.9463882446289, 0.592476244029073, -78.5025024414063, -1.37012713865743, 218, 33, 'PPL', 'P'),
(65259, 'Grissom', 36.0719413757324, 0.629574144592904, -78.5966720581055, -1.37177070852417, 218, 33, 'PPL', 'P'),
(65260, 'Grist', 34.3222198486328, 0.599035742951992, -78.8611068725586, -1.37638596669328, 218, 33, 'PPL', 'P'),
(47729, 'Gristmill Hill', 39.7083282470703, 0.693041068374045, -77.8386077880859, -1.3585399910706, 218, 25, 'PPL', 'P'),
(13871, 'Gristmill Woods', 39.7788887023926, 0.694272580641125, -75.5149993896484, -1.31798537399087, 218, 10, 'PPL', 'P'),
(55106, 'Griswold', 36.5113906860352, 0.637243981953305, -91.1447219848633, -1.59077549445073, 218, 29, 'PPL', 'P'),
(115877, 'Griswold', 41.2350006103516, 0.719686527712506, -95.1372222900391, -1.66045777016292, 218, 16, 'PPL', 'P'),
(119879, 'Griswold', 40.9130592346191, 0.714067590707575, -88.353889465332, -1.54206627811318, 218, 18, 'PPL', 'P'),
(127646, 'Griswold', 46.4097213745117, 0.810002442918418, -68.2986068725586, -1.19203556445137, 218, 26, 'PPL', 'P'),
(149331, 'Griswold', 42.8905601501465, 0.74858149264473, -78.3452835083008, -1.36738315062826, 218, 40, 'PPL', 'P'),
(21618, 'Griswoldville', 32.8705596923828, 0.573699493605415, -83.4888916015625, -1.45715604728791, 218, 13, 'PPL', 'P'),
(113501, 'Griswoldville', 41.6936111450195, 0.727690791526794, -72.6711120605469, -1.2683501765423, 218, 8, 'PPL', 'P'),
(124982, 'Griswoldville', 42.6563911437988, 0.74449447247784, -72.7144393920898, -1.26910638113383, 218, 23, 'PPL', 'P'),
(94627, 'Grit', 30.7830600738525, 0.537265752127936, -99.3197174072266, -1.73345608090643, 218, 51, 'PPL', 'P'),
(102495, 'Grit', 37.0761108398438, 0.647100207989633, -79.2480621337891, -1.38313961005966, 218, 53, 'PPL', 'P'),
(16290, 'Gritney', 30.8380603790283, 0.538225688542855, -85.8302764892578, -1.49802092263463, 218, 12, 'PPL', 'P'),
(87489, 'Grizzard', 36.0283317565918, 0.628813013153359, -88.9855575561523, -1.55309096607778, 218, 50, 'PPL', 'P'),
(102496, 'Grizzard', 36.726390838623, 0.640996442508254, -77.4377822875977, -1.35154426636113, 218, 53, 'PPL', 'P'),
(102497, 'Grizzle (historical)', 36.9916687011719, 0.645626414642384, -82.1655578613281, -1.43405951641809, 218, 53, 'PPL', 'P'),
(178306, 'Grizzles Orchard', 31.7541694641113, 0.554214808384986, -109.748062133789, -1.91546503191793, 218, 5, 'PPL', 'P'),
(193607, 'Grizzlie Place', 41.9011116027832, 0.731312357714165, -120.639442443848, -2.10555547841534, 218, 6, 'PPL', 'P'),
(200926, 'Grizzly', 44.4980583190918, 0.776637628412605, -120.918609619141, -2.11042786478769, 218, 43, 'PPL', 'P'),
(181934, 'Grizzly Flat', 38.6363906860352, 0.674332228558184, -120.526390075684, -2.1035823423637, 218, 6, 'PPL', 'P'),
(181935, 'Grizzly Gulch (historical)', 39.4524993896484, 0.688576012490419, -120.970558166504, -2.11133453798081, 218, 6, 'PPL', 'P'),
(181936, 'Grizzly Peak', 38.6324996948242, 0.674264317950387, -120.543060302734, -2.10387329271279, 218, 6, 'PPL', 'P'),
(181937, 'Grizzly Ridge', 38.2563896179199, 0.667699958758478, -120.337783813477, -2.1002905420983, 218, 6, 'PPL', 'P'),
(27344, 'Groat', 37.9677810668945, 0.662662789293675, -88.8711090087891, -1.55109346210216, 218, 18, 'PPL', 'P'),
(16291, 'Grocery Place', 25.951940536499, 0.452946809643692, -81.6161117553711, -1.42446987280687, 218, 12, 'PPL', 'P'),
(94629, 'Groceville', 30.3408298492432, 0.529547378656668, -95.3338928222656, -1.66389031849192, 218, 51, 'PPL', 'P'),
(155563, 'Grodis Corner', 41.6041717529297, 0.726129779653844, -83.2605590820313, -1.45317089303271, 218, 41, 'PPL', 'P'),
(72767, 'Groesbeck', 39.2230606079102, 0.684571550317321, -84.5869369506836, -1.47632055396628, 218, 41, 'PPL', 'P'),
(94628, 'Groesbeck', 31.524169921875, 0.550200559094882, -96.5336074829102, -1.68482928940462, 218, 51, 'PPL', 'P'),
(162318, 'Groffdale', 40.0913887023926, 0.699726734553608, -76.1297225952148, -1.32871431791642, 218, 45, 'PPL', 'P'),
(21619, 'Grogan', 32.5852813720703, 0.568720447631402, -83.9255599975586, -1.46477734853744, 218, 13, 'PPL', 'P'),
(55107, 'Grogan', 37.1547203063965, 0.648472202004215, -91.8861083984375, -1.60371512839715, 218, 29, 'PPL', 'P'),
(135724, 'Grogan', 44.0163917541504, 0.768230960957607, -94.5363922119141, -1.64997130705463, 218, 28, 'PPL', 'P'),
(207570, 'Gromore', 46.5886116027832, 0.813124666401399, -120.696937561035, -2.10655895751408, 218, 56, 'PPL', 'P'),
(135725, 'Groningen', 46.1508293151855, 0.805483924075908, -92.9238891601563, -1.62182781960299, 218, 28, 'PPL', 'P'),
(191559, 'Groom', 35.2036094665527, 0.61441889377759, -101.106391906738, -1.76463943358433, 218, 51, 'PPL', 'P'),
(190285, 'Groom (historical)', 37.4052810668945, 0.652845312251207, -115.698059082031, -2.01931206914837, 218, 39, 'PPL', 'P'),
(149332, 'Groom Corners', 42.8349990844727, 0.747611769112804, -73.8441696166992, -1.28882389321256, 218, 40, 'PPL', 'P'),
(178307, 'Groom Creek', 34.4755592346191, 0.60171202011044, -112.430557250977, -1.96228340388153, 218, 5, 'PPL', 'P'),
(65262, 'Groometown', 35.9911117553711, 0.628163401584461, -79.8677825927734, -1.39395577251091, 218, 33, 'PPL', 'P'),
(72769, 'Grooms', 39.0202789306641, 0.68103234238666, -83.2752838134766, -1.45342788807791, 218, 41, 'PPL', 'P'),
(122740, 'Groomsville', 40.3458290100098, 0.704167555671315, -86.2027816772461, -1.50452236464578, 218, 19, 'PPL', 'P'),
(81379, 'Groomville', 33.0855598449707, 0.577451954160363, -80.0569381713867, -1.39725716015623, 218, 48, 'PPL', 'P'),
(131139, 'Groos', 45.8116683959961, 0.799564449341961, -87.1030578613281, -1.52023514823531, 218, 27, 'PPL', 'P'),
(81380, 'Groover Landing', 32.485279083252, 0.566975078431992, -81.2186126708984, -1.41753220500916, 218, 48, 'PPL', 'P'),
(21620, 'Grooverville', 30.7208309173584, 0.536179648456374, -83.726936340332, -1.46131071174649, 218, 13, 'PPL', 'P'),
(149333, 'Grooville', 41.9425010681152, 0.732034740159849, -74.7677764892578, -1.30494387413276, 218, 40, 'PPL', 'P'),
(170443, 'Gros (historical)', 45.086109161377, 0.786901051779607, -97.9416732788086, -1.70940467362776, 218, 49, 'PPL', 'P'),
(131140, 'Gros Cap', 45.8702812194824, 0.800587436095688, -84.8277816772461, -1.48052408743086, 218, 27, 'PPL', 'P'),
(47728, 'Grose Close', 39.5130615234375, 0.689633021127071, -76.3497161865234, -1.33255393041804, 218, 25, 'PPL', 'P'),
(102499, 'Groseclose', 36.9080581665039, 0.644167135523075, -81.2088928222656, -1.41736256164773, 218, 53, 'PPL', 'P'),
(102500, 'Groseclose Corner', 36.6680603027344, 0.639978382602544, -81.8027801513672, -1.42772785092642, 218, 53, 'PPL', 'P'),
(102501, 'Groseclose Store', 36.985279083252, 0.645514894771737, -81.3955612182617, -1.42062053976727, 218, 53, 'PPL', 'P'),
(16292, 'Grosh', 30.3950004577637, 0.53049283413316, -86.2827835083008, -1.50591866000531, 218, 12, 'PPL', 'P'),
(16296, 'Gross', 30.7158298492432, 0.536092363351647, -81.6755599975586, -1.42550744036757, 218, 12, 'PPL', 'P'),
(27345, 'Gross', 37.5330581665039, 0.655075443348039, -88.2905578613281, -1.54096093310274, 218, 18, 'PPL', 'P'),
(32639, 'Gross', 37.600830078125, 0.656258286346198, -94.6494369506836, -1.65194430994821, 218, 20, 'PPL', 'P'),
(141968, 'Gross', 42.9458312988281, 0.749546156170584, -98.5719375610352, -1.72040486051033, 218, 35, 'PPL', 'P'),
(195035, 'Gross', 44.3133316040039, 0.773413539017928, -116.306671142578, -2.02993435347226, 218, 17, 'PPL', 'P'),
(87490, 'Gross Crossroad', 36.4558296203613, 0.63627425842138, -82.3494415283203, -1.43726889184774, 218, 50, 'PPL', 'P'),
(47730, 'Gross Mill Estates', 39.6269416809082, 0.691620604827624, -76.8338928222656, -1.34100440687297, 218, 25, 'PPL', 'P'),
(102502, 'Gross Point', 37.063060760498, 0.646872441137404, -79.5908279418945, -1.38912200197436, 218, 53, 'PPL', 'P'),
(119880, 'Gross Point', 42.0788917541504, 0.734415206700217, -87.7225036621094, -1.53104651699659, 218, 18, 'PPL', 'P'),
(21621, 'Gross Still (historical)', 30.7875003814697, 0.537343250115657, -81.6836090087891, -1.42564792211507, 218, 13, 'PPL', 'P'),
(170439, 'Grosse', 43.9272193908691, 0.766674609616564, -99.2861099243164, -1.73286951967634, 218, 49, 'PPL', 'P'),
(131141, 'Grosse Ile', 42.1291694641113, 0.735292718279398, -83.1444396972656, -1.45114422744316, 218, 27, 'PPL', 'P'),
(41215, 'Grosse Isle', 29.9650001525879, 0.522987913023262, -92.0908279418945, -1.60728815847365, 218, 22, 'PPL', 'P'),
(131143, 'Grosse Pointe', 42.3861083984375, 0.739777148659955, -82.9119415283203, -1.44708636889021, 218, 27, 'PPL', 'P'),
(131144, 'Grosse Pointe Farms', 42.4091682434082, 0.740179618879693, -82.8919372558594, -1.4467372284713, 218, 27, 'PPL', 'P'),
(131146, 'Grosse Pointe Park', 42.3758316040039, 0.739597784760538, -82.9375, -1.4475324483728, 218, 27, 'PPL', 'P'),
(131148, 'Grosse Pointe Shores', 42.4366683959961, 0.740659587087153, -82.8769378662109, -1.44647543973614, 218, 27, 'PPL', 'P'),
(131149, 'Grosse Pointe Woods', 42.4436111450195, 0.740780760916751, -82.9069366455078, -1.44699901720645, 218, 27, 'PPL', 'P'),
(41216, 'Grosse Tete', 30.4108295440674, 0.530769103806742, -91.4336090087891, -1.59581752418452, 218, 22, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(200927, 'Grossman (historical)', 45.8055610656738, 0.799457856319331, -117.580558776855, -2.05216788699084, 218, 43, 'PPL', 'P'),
(181938, 'Grossmont', 32.7783317565918, 0.572089812463543, -116.987503051758, -2.04181711194009, 218, 6, 'PPL', 'P'),
(47731, 'Grossnickle', 39.5299987792969, 0.68992863200807, -77.2333297729492, -1.34797589681653, 218, 25, 'PPL', 'P'),
(47732, 'Grosstown', 38.5063896179199, 0.672063281888464, -76.871940612793, -1.34166846609078, 218, 25, 'PPL', 'P'),
(94630, 'Grossville', 30.6838893890381, 0.535534897156466, -99.2011108398438, -1.73138600579111, 218, 51, 'PPL', 'P'),
(72768, 'Grosvenor', 39.3327789306641, 0.686486496299142, -82.1311111450195, -1.433458307802, 218, 41, 'PPL', 'P'),
(94631, 'Grosvenor', 31.8822193145752, 0.556449699882267, -99.1497192382813, -1.73048905313597, 218, 51, 'PPL', 'P'),
(124983, 'Grosvenor Corner', 42.776668548584, 0.746593709207094, -71.1741714477539, -1.24222363414225, 218, 23, 'PPL', 'P'),
(113502, 'Grosvenor Dale', 41.9683303833008, 0.732485546753373, -71.8952789306641, -1.2548093339798, 218, 8, 'PPL', 'P'),
(186802, 'Grote', 38.0872192382813, 0.664747378636935, -102.415283203125, -1.78748389625698, 218, 7, 'PPL', 'P'),
(113503, 'Groton', 41.3499984741211, 0.721693619068044, -72.0788879394531, -1.25801391571949, 218, 8, 'PPL', 'P'),
(143910, 'Groton', 43.7016716003418, 0.762738058051264, -71.8361129760742, -1.25377669326712, 218, 36, 'PPL', 'P'),
(149334, 'Groton', 42.5877799987793, 0.743296982093685, -76.3672180175781, -1.33285939499508, 218, 40, 'PPL', 'P'),
(170440, 'Groton', 45.4474983215332, 0.793208482505351, -98.0983276367188, -1.71213880796089, 218, 49, 'PPL', 'P'),
(172082, 'Groton', 44.2102813720703, 0.771614973175743, -72.1958312988281, -1.26005496237893, 218, 55, 'PPL', 'P'),
(177334, 'Groton', 42.6111106872559, 0.743704179424359, -71.5749969482422, -1.24921935885172, 218, 23, 'PPL', 'P'),
(149335, 'Groton City', 42.6150016784668, 0.743772090032156, -76.2855606079102, -1.33143420433772, 218, 40, 'PPL', 'P'),
(113504, 'Groton Long Point', 41.3144416809082, 0.721073035955029, -72.0083312988281, -1.25678247003144, 218, 8, 'PPL', 'P'),
(102503, 'Groton Town', 37.8663902282715, 0.660893185328345, -75.5872192382813, -1.31924584813481, 218, 53, 'PPL', 'P'),
(102504, 'Grotons', 37.9261093139648, 0.661935479999974, -75.6438903808594, -1.32023494616366, 218, 53, 'PPL', 'P'),
(149337, 'Grotto', 42.559440612793, 0.74280236650023, -76.4100036621094, -1.33360614536473, 218, 40, 'PPL', 'P'),
(207571, 'Grotto', 47.7363891601563, 0.833157163858057, -121.422218322754, -2.11921749480744, 218, 56, 'PPL', 'P'),
(102505, 'Grottoes', 38.267219543457, 0.667888976616847, -78.8261108398438, -1.37577517069727, 218, 53, 'PPL', 'P'),
(124988, 'Grounts Corner', 42.5777816772461, 0.743122478463258, -72.4944381713867, -1.26526663547416, 218, 23, 'PPL', 'P'),
(195036, 'Grouse', 43.6883316040039, 0.762505231192964, -113.611671447754, -1.98289773545734, 218, 17, 'PPL', 'P'),
(200928, 'Grouse', 45.9916687011719, 0.802706047321873, -117.427780151367, -2.0495013969494, 218, 43, 'PPL', 'P'),
(207572, 'Grouse', 46.0125007629395, 0.803069635389696, -117.420562744141, -2.04937542942984, 218, 56, 'PPL', 'P'),
(204184, 'Grouse Creek', 41.7094383239746, 0.727967027910862, -113.882499694824, -1.98762458007612, 218, 52, 'PPL', 'P'),
(204185, 'Grouse Creek Junction', 41.4216690063477, 0.722944505832055, -113.888610839844, -1.98773123967778, 218, 52, 'PPL', 'P'),
(102506, 'Grouse Hollow Estates', 39.2597198486328, 0.685211374769212, -78.1986083984375, -1.36482318703042, 218, 53, 'PPL', 'P'),
(149339, 'Grout Mill', 42.723331451416, 0.745662801248057, -76.2588882446289, -1.33096868377917, 218, 40, 'PPL', 'P'),
(21622, 'Grovania', 32.3658294677734, 0.56489028935165, -83.663330078125, -1.46020057304609, 218, 13, 'PPL', 'P'),
(162319, 'Grovania', 40.9738883972168, 0.715129259876135, -76.5252838134766, -1.33561816356829, 218, 45, 'PPL', 'P'),
(32641, 'Grove', 39.1674995422363, 0.683601826785396, -95.85888671875, -1.67305319053845, 218, 20, 'PPL', 'P'),
(36217, 'Grove', 36.9324989318848, 0.644593707350678, -84.2236099243164, -1.46997930109469, 218, 21, 'PPL', 'P'),
(41217, 'Grove', 32.7374992370605, 0.571377150555838, -93.3311080932617, -1.62893513076214, 218, 22, 'PPL', 'P'),
(47734, 'Grove', 39.4005584716797, 0.687669472455355, -77.3933334350586, -1.35076848753559, 218, 25, 'PPL', 'P'),
(75996, 'Grove', 36.5936088562012, 0.638678959727667, -94.7688903808594, -1.65402916560758, 218, 42, 'PPL', 'P'),
(87492, 'Grove', 36.0522193908691, 0.629229931022011, -84.5319366455078, -1.47536061755136, 218, 50, 'PPL', 'P'),
(102507, 'Grove', 37.2297210693359, 0.649781212259016, -76.6272201538086, -1.33739728833452, 218, 53, 'PPL', 'P'),
(109494, 'Grove', 39.1469383239746, 0.683242965828508, -80.7719421386719, -1.40973633355017, 218, 58, 'PPL', 'P'),
(119881, 'Grove', 40.6199989318848, 0.708952723517969, -89.6266708374023, -1.56428050371385, 218, 18, 'PPL', 'P'),
(127647, 'Grove', 45, 0.785398163397448, -67.4330596923828, -1.17692891632595, 218, 26, 'PPL', 'P'),
(149338, 'Grove', 42.4363899230957, 0.740654726818163, -77.8683319091797, -1.35905877485095, 218, 40, 'PPL', 'P'),
(162320, 'Grove', 40.0047187805176, 0.698214059054443, -75.6350021362305, -1.32007981703017, 218, 45, 'PPL', 'P'),
(172084, 'Grove', 42.7527809143066, 0.746176791338443, -72.710563659668, -1.26903873684214, 218, 55, 'PPL', 'P'),
(181942, 'Grove', 39.436939239502, 0.688304436638258, -123.658332824707, -2.15824505531812, 218, 6, 'PPL', 'P'),
(113506, 'Grove Beach', 41.2747192382813, 0.720379748544254, -72.48388671875, -1.26508247788478, 218, 8, 'PPL', 'P'),
(32642, 'Grove Center', 39.0625, 0.681769239060285, -94.8013916015625, -1.65459641891977, 218, 20, 'PPL', 'P'),
(36218, 'Grove Center', 37.639720916748, 0.656937059529032, -88.0130615234375, -1.53611770834432, 218, 21, 'PPL', 'P'),
(16293, 'Grove City', 26.913890838623, 0.46973600965631, -82.3272171020508, -1.43688100243497, 218, 12, 'PPL', 'P'),
(27347, 'Grove City', 39.7066688537598, 0.693012106497191, -89.2969436645508, -1.5585256789143, 218, 18, 'PPL', 'P'),
(72770, 'Grove City', 39.8813896179199, 0.696061559103386, -83.0930633544922, -1.45024754110413, 218, 41, 'PPL', 'P'),
(135726, 'Grove City', 45.1505584716797, 0.78802590444503, -94.6827774047852, -1.65252621064639, 218, 28, 'PPL', 'P'),
(162321, 'Grove City', 41.1577796936035, 0.718338768463844, -80.0888900756836, -1.39781482608849, 218, 45, 'PPL', 'P'),
(115878, 'Grove City (historical)', 41.3872184753418, 0.722343230636942, -94.9619369506836, -1.65739846386069, 218, 16, 'PPL', 'P'),
(72771, 'Grove City Country Club', 39.8505592346191, 0.695523467405135, -83.0713882446289, -1.44986923907129, 218, 41, 'PPL', 'P'),
(81382, 'Grove Hall', 33.045280456543, 0.57674894621161, -80.0777816772461, -1.39762094796113, 218, 48, 'PPL', 'P'),
(124985, 'Grove Hall', 42.3111114501953, 0.738468204984181, -71.0749969482422, -1.24049271259175, 218, 23, 'PPL', 'P'),
(2887, 'Grove Hill', 31.708610534668, 0.553419655062516, -87.7772216796875, -1.53200152656349, 218, 2, 'PPL', 'P'),
(41218, 'Grove Hill', 31.961669921875, 0.557836374572358, -93.5602798461914, -1.63293493240333, 218, 22, 'PPL', 'P'),
(47735, 'Grove Hill', 39.4194412231445, 0.687999038640253, -77.4613876342773, -1.35195625738176, 218, 25, 'PPL', 'P'),
(65273, 'Grove Hill', 36.3349990844727, 0.634165367733173, -78.0094375610352, -1.361521533069, 218, 33, 'PPL', 'P'),
(102508, 'Grove Hill', 38.5286102294922, 0.672451104722207, -78.6125030517578, -1.37204701148726, 218, 53, 'PPL', 'P'),
(135728, 'Grove Lake', 45.6141700744629, 0.796117453364044, -95.1572189331055, -1.66080677742378, 218, 28, 'PPL', 'P'),
(21623, 'Grove Lakes', 32.4291687011719, 0.565995767520142, -81.7361068725586, -1.42656418268811, 218, 13, 'PPL', 'P'),
(21624, 'Grove Lakes South', 32.4222183227539, 0.565874460532489, -81.7372207641602, -1.42658362376407, 218, 13, 'PPL', 'P'),
(21625, 'Grove Level', 34.2572212219238, 0.597901302906646, -83.4905624389648, -1.45718520890184, 218, 13, 'PPL', 'P'),
(78407, 'Grove Mill', 39.7644386291504, 0.694020379285895, -76.519172668457, -1.33551150396663, 218, 45, 'PPL', 'P'),
(21626, 'Grove Mount', 33.2013893127441, 0.579473559743843, -82.0805587768555, -1.43257600253286, 218, 13, 'PPL', 'P'),
(2889, 'Grove Oak', 34.438060760498, 0.601057548272553, -86.0524978637695, -1.50189941728817, 218, 2, 'PPL', 'P'),
(2891, 'Grove Park', 33.271671295166, 0.580700211741933, -86.3622207641602, -1.50730510166881, 218, 2, 'PPL', 'P'),
(16294, 'Grove Park', 29.6000003814697, 0.516617465248224, -82.1536102294922, -1.43385099090473, 218, 12, 'PPL', 'P'),
(21628, 'Grove Park', 32.3777809143066, 0.565098881444031, -83.725830078125, -1.46129140382858, 218, 13, 'PPL', 'P'),
(65263, 'Grove Park', 35.2388916015625, 0.615034683200643, -80.7347183227539, -1.40908665540225, 218, 33, 'PPL', 'P'),
(81383, 'Grove Park', 34.2055587768555, 0.596999623140572, -79.8249969482422, -1.39320902214125, 218, 48, 'PPL', 'P'),
(102517, 'Grove Park', 36.8255615234375, 0.642727297479723, -76.3561096191406, -1.33266551686772, 218, 53, 'PPL', 'P'),
(102511, 'Grove Place', 37.3549995422363, 0.651967734092999, -77.4263916015625, -1.35134546138575, 218, 53, 'PPL', 'P'),
(21631, 'Grove Point', 31.9513893127441, 0.557656944093913, -81.2041702270508, -1.41728013681199, 218, 13, 'PPL', 'P'),
(47736, 'Grove Ridge', 39.2083282470703, 0.684314422114074, -76.6444396972656, -1.33769782606353, 218, 25, 'PPL', 'P'),
(149340, 'Grove Springs', 42.4711112976074, 0.741260729124211, -77.1563873291016, -1.34663299783686, 218, 40, 'PPL', 'P'),
(16295, 'Groveland', 28.5577793121338, 0.498427276054656, -81.8513870239258, -1.42857620089167, 218, 12, 'PPL', 'P'),
(21634, 'Groveland', 33.4122200012207, 0.583153249422005, -84.5519409179688, -1.47570975797027, 218, 13, 'PPL', 'P'),
(29961, 'Groveland', 39.7605590820313, 0.693952668415179, -86.7200012207031, -1.51354954863477, 218, 19, 'PPL', 'P'),
(32645, 'Groveland', 38.2930603027344, 0.668339982947451, -97.7291717529297, -1.70569582233566, 218, 20, 'PPL', 'P'),
(119882, 'Groveland', 40.5924987792969, 0.708472755310509, -89.5344390869141, -1.56267075599296, 218, 18, 'PPL', 'P'),
(124986, 'Groveland', 42.7602806091309, 0.74630768570602, -71.0319366455078, -1.23974116853213, 218, 23, 'PPL', 'P'),
(135733, 'Groveland', 44.9416694641113, 0.784380103491738, -93.4858322143555, -1.63163557610748, 218, 28, 'PPL', 'P'),
(149342, 'Groveland', 42.6647186279297, 0.744639814494331, -77.7699966430664, -1.35734250068645, 218, 40, 'PPL', 'P'),
(181940, 'Groveland', 37.8383293151855, 0.660403430003879, -120.231666564941, -2.09843844671821, 218, 6, 'PPL', 'P'),
(195037, 'Groveland', 43.2200012207031, 0.754331324017238, -112.371673583984, -1.96125569001686, 218, 17, 'PPL', 'P'),
(196646, 'Groveland', 46.436939239502, 0.810477484277861, -110.396667480469, -1.92678533076353, 218, 31, 'PPL', 'P'),
(115887, 'Groveland (historical)', 40.9844398498535, 0.715313417465514, -93.7980575561523, -1.63708493633, 218, 16, 'PPL', 'P'),
(131154, 'Groveland Corners', 42.8161087036133, 0.747282069769853, -83.5477828979492, -1.45818389431062, 218, 27, 'PPL', 'P'),
(149343, 'Groveland Corners', 42.7016716003418, 0.745284765531321, -77.7519378662109, -1.35702731557144, 218, 40, 'PPL', 'P'),
(81384, 'Groveland Dell', 34.9347190856934, 0.609725871304652, -82.2855606079102, -1.43615395945738, 218, 48, 'PPL', 'P'),
(21637, 'Groveland Estates', 31.4486103057861, 0.548881795012589, -83.9955596923828, -1.46599907368752, 218, 13, 'PPL', 'P'),
(65268, 'Grovemont', 35.6097183227539, 0.621506830439808, -82.3872222900391, -1.43792829053364, 218, 33, 'PPL', 'P'),
(149345, 'Grovenor Corners', 42.728328704834, 0.745750019773757, -74.3841705322266, -1.2982486871523, 218, 40, 'PPL', 'P'),
(72772, 'Groveport', 39.8783302307129, 0.69600816272353, -82.8838882446289, -1.4465967467238, 218, 41, 'PPL', 'P'),
(2894, 'Grover', 34.4122200012207, 0.600606541941948, -85.5116729736328, -1.49246024227854, 218, 2, 'PPL', 'P'),
(32647, 'Grover', 39.0597190856934, 0.681720702949418, -95.4599990844727, -1.66609128797482, 218, 20, 'PPL', 'P'),
(55108, 'Grover', 38.5761108398438, 0.673280146769548, -90.6372222900391, -1.58191795382318, 218, 29, 'PPL', 'P'),
(65269, 'Grover', 35.1744384765625, 0.613909763956194, -81.4499969482422, -1.42157062248616, 218, 33, 'PPL', 'P'),
(81385, 'Grover', 33.1049995422363, 0.57779124088324, -80.5950012207031, -1.40664813195012, 218, 48, 'PPL', 'P'),
(141971, 'Grover', 40.7797203063965, 0.711740387389009, -97.0374984741211, -1.69362384627239, 218, 35, 'PPL', 'P'),
(162324, 'Grover', 41.6144409179688, 0.726309010395206, -76.8675003051758, -1.34159096810306, 218, 45, 'PPL', 'P'),
(170446, 'Grover', 44.8138885498047, 0.782149905815879, -97.2683334350586, -1.69765267636946, 218, 49, 'PPL', 'P'),
(192599, 'Grover', 38.2280616760254, 0.667205542902105, -111.349166870117, -1.94340958123613, 218, 52, 'PPL', 'P'),
(194222, 'Grover', 40.8713912963867, 0.713340347992902, -104.224716186523, -1.81906445941146, 218, 7, 'PPL', 'P'),
(209486, 'Grover', 42.7916717529297, 0.746855564521277, -110.935829162598, -1.93619547731727, 218, 59, 'PPL', 'P'),
(181941, 'Grover Beach', 35.1216697692871, 0.612988776272217, -120.620277404785, -2.10522098538242, 218, 6, 'PPL', 'P'),
(149346, 'Grover Cleveland Terrace', 42.9716682434082, 0.749997095922161, -78.8066711425781, -1.37543588397439, 218, 40, 'PPL', 'P'),
(113509, 'Grover Hill', 41.1463890075684, 0.71813996348847, -73.228889465332, -1.27808522874903, 218, 8, 'PPL', 'P'),
(155566, 'Grover Hill', 41.0191688537598, 0.715919552929616, -84.4766693115234, -1.47439602060454, 218, 41, 'PPL', 'P'),
(149347, 'Grover Hills', 44.0774993896484, 0.769297490395156, -73.5119400024414, -1.28302539257113, 218, 40, 'PPL', 'P'),
(81386, 'Grover Square', 34.6772193908691, 0.605231653807089, -82.9819412231445, -1.44830809404028, 218, 48, 'PPL', 'P'),
(21639, 'Grover View', 30.8786106109619, 0.538933423602543, -81.5722198486328, -1.42370381451931, 218, 13, 'PPL', 'P'),
(145336, 'Grovers Mill', 40.3166694641113, 0.703658625587001, -74.6097183227539, -1.3021852387176, 218, 37, 'PPL', 'P'),
(122741, 'Grovertown', 41.375, 0.722129978012654, -86.5047225952148, -1.50979222781083, 218, 19, 'PPL', 'P'),
(65270, 'Groves', 35.2733306884766, 0.615635758658674, -81.1686096191406, -1.41665948711994, 218, 33, 'PPL', 'P'),
(94632, 'Groves', 29.9480590820313, 0.522692235563236, -93.9169387817383, -1.63915980513529, 218, 51, 'PPL', 'P'),
(109495, 'Groves', 38.5561103820801, 0.672931072929666, -80.9619369506836, -1.41305236858149, 218, 58, 'PPL', 'P'),
(87493, 'Groves (historical)', 35.6708297729492, 0.622573426456385, -85.6605606079102, -1.49505882171219, 218, 50, 'PPL', 'P'),
(21643, 'Groveside Park', 31.2694396972656, 0.545754677971104, -81.5205612182617, -1.42280220133227, 218, 13, 'PPL', 'P'),
(55110, 'Grovespring', 37.3997192382813, 0.652748240029474, -92.6094436645508, -1.61633971038661, 218, 29, 'PPL', 'P'),
(65271, 'Grovestone', 35.6063919067383, 0.621448773528045, -82.3627777099609, -1.43750165212701, 218, 33, 'PPL', 'P'),
(94633, 'Groveton', 31.0547199249268, 0.542007110974658, -95.1255569458008, -1.66025417149758, 218, 51, 'PPL', 'P'),
(102513, 'Groveton', 38.8125, 0.677405915930299, -77.5486068725586, -1.35347852026085, 218, 53, 'PPL', 'P'),
(131157, 'Groveton', 43.2425003051758, 0.75472400711997, -84.1291732788086, -1.46833107069604, 218, 27, 'PPL', 'P'),
(143912, 'Groveton', 44.5986099243164, 0.77839258499194, -71.5116729736328, -1.24811414699934, 218, 36, 'PPL', 'P'),
(162325, 'Groveton', 40.5038909912109, 0.7069262576655, -80.1405563354492, -1.39871657243359, 218, 45, 'PPL', 'P'),
(102514, 'Groveton Heights', 38.7702789306641, 0.676669019256674, -77.0938873291016, -1.34554216705436, 218, 53, 'PPL', 'P'),
(21640, 'Grovetown', 33.4502792358398, 0.583817508376898, -82.1983337402344, -1.43463156342024, 218, 13, 'PPL', 'P'),
(127648, 'Groveville', 43.6636085510254, 0.762073732517344, -70.5205612182617, -1.23081598361289, 218, 26, 'PPL', 'P'),
(145337, 'Groveville', 40.1697196960449, 0.7010938682992, -74.6719436645508, -1.30327127581013, 218, 37, 'PPL', 'P'),
(149348, 'Groveville', 41.5152816772461, 0.724578355160818, -73.9400024414063, -1.29049649153518, 218, 40, 'PPL', 'P'),
(94634, 'Grovewood Estates Colonia', 26.250560760498, 0.458158715765518, -98.2930603027344, -1.71553753414405, 218, 51, 'PPL', 'P'),
(209487, 'Grovont', 43.6450004577637, 0.761748960022408, -110.663330078125, -1.93143947108456, 218, 59, 'PPL', 'P'),
(191560, 'Grow', 33.8097190856934, 0.590090917219716, -100.298332214355, -1.7505361313996, 218, 51, 'PPL', 'P'),
(178308, 'Growler', 32.815559387207, 0.572739557190496, -113.798332214355, -1.98615558041883, 218, 5, 'PPL', 'P'),
(127649, 'Growstown', 43.8997192382813, 0.766194641409105, -70.0008316040039, -1.22174499062397, 218, 26, 'PPL', 'P'),
(181943, 'Grub Gulch (historical)', 37.3247184753418, 0.651439229774672, -119.769721984863, -2.0903759928341, 218, 6, 'PPL', 'P'),
(94635, 'Grub Hill', 32.086109161377, 0.560008249020344, -97.2788925170898, -1.69783696711689, 218, 51, 'PPL', 'P'),
(102515, 'Grubb', 36.9113883972168, 0.644225259013866, -81.1577835083008, -1.4164705358406, 218, 53, 'PPL', 'P'),
(21641, 'Grubb (historical)', 31.6708297729492, 0.552760256376612, -84.773063659668, -1.47956907786396, 218, 13, 'PPL', 'P'),
(127650, 'Grubb Hill (historical)', 43.7097206115723, 0.762878539798766, -70.2988891601563, -1.22694707633928, 218, 26, 'PPL', 'P'),
(9253, 'Grubb Springs', 36.2150001525879, 0.632070991272908, -93.1544418334961, -1.62585172285205, 218, 4, 'PPL', 'P'),
(60130, 'Grubb Springs (historical)', 33.7972183227539, 0.589872737747411, -88.3494415283203, -1.5419886469674, 218, 30, 'PPL', 'P'),
(94636, 'Grubbe', 32.9633293151855, 0.575318628969155, -95.5991668701172, -1.66852022404703, 218, 51, 'PPL', 'P'),
(9254, 'Grubbs', 35.6497192382813, 0.622204978119573, -91.0738906860352, -1.58953925507271, 218, 4, 'PPL', 'P'),
(21642, 'Grubbs', 32.0102806091309, 0.55868479111663, -81.1811065673828, -1.41687760001322, 218, 13, 'PPL', 'P'),
(27350, 'Grubbs', 37.934440612793, 0.662080888595493, -89.3636093139648, -1.55968921399456, 218, 18, 'PPL', 'P'),
(13872, 'Grubbs Corner', 39.8291702270508, 0.695150158799334, -75.4908294677734, -1.3175635292742, 218, 10, 'PPL', 'P'),
(109496, 'Grubbs Corner', 39.413330078125, 0.687892379038595, -77.9736099243164, -1.36089622284505, 218, 58, 'PPL', 'P'),
(13874, 'Grubbs Landing', 39.7861099243164, 0.694398614739713, -75.4694366455078, -1.31719015408938, 218, 10, 'PPL', 'P'),
(188638, 'Grubisich Place', 35.3208312988281, 0.616464800706016, -108.426940917969, -1.89240711688392, 218, 38, 'PPL', 'P'),
(55111, 'Grubville', 38.288330078125, 0.668257424953659, -90.7547225952148, -1.58396872102059, 218, 29, 'PPL', 'P'),
(94637, 'Gruenau', 29.0705604553223, 0.507376995345435, -97.5672225952148, -1.70286927631271, 218, 51, 'PPL', 'P'),
(94638, 'Gruene', 29.7380599975586, 0.519027060113014, -98.1036071777344, -1.71223095333461, 218, 51, 'PPL', 'P'),
(87497, 'Gruetli', 35.3708305358887, 0.617337452016208, -85.6600036621094, -1.49504910117421, 218, 50, 'PPL', 'P'),
(87494, 'Gruetli-Laager', 35.3722190856934, 0.617361686782127, -85.6180572509766, -1.49431699819055, 218, 50, 'PPL', 'P'),
(191561, 'Gruhlkey', 35.2652816772461, 0.615495276911173, -102.743606567383, -1.7932142199745, 218, 51, 'PPL', 'P'),
(119885, 'Grumle Corner', 40.2486114501953, 0.702470789161798, -87.6699981689453, -1.5301301232655, 218, 18, 'PPL', 'P'),
(162333, 'Grunderville (historical)', 41.836669921875, 0.730187638206798, -79.220832824707, -1.38266436896314, 218, 45, 'PPL', 'P'),
(36219, 'Grundy', 37.1261100769043, 0.647972859299825, -84.522216796875, -1.47519097418992, 218, 21, 'PPL', 'P'),
(102516, 'Grundy', 37.2777786254883, 0.650619974844337, -82.0991668701172, -1.43290077502779, 218, 53, 'PPL', 'P'),
(115888, 'Grundy Center', 42.3616714477539, 0.739350643411379, -92.7683334350586, -1.61911286002971, 218, 16, 'PPL', 'P'),
(162327, 'Grundys Corner', 40.1072196960449, 0.700003037516703, -74.9019393920898, -1.30728545852121, 218, 45, 'PPL', 'P'),
(115890, 'Gruver', 43.3933296203613, 0.757356475278486, -94.7050018310547, -1.65291410005916, 218, 16, 'PPL', 'P'),
(192965, 'Gruver', 36.2649993896484, 0.632943642583099, -101.405830383301, -1.7698656209075, 218, 51, 'PPL', 'P'),
(162328, 'Gruversville', 40.5008316040039, 0.706872861285644, -75.3225021362305, -1.31462566311768, 218, 45, 'PPL', 'P'),
(162329, 'Gruvertown', 40.8227806091309, 0.71249193144863, -75.1511077880859, -1.31163426742325, 218, 45, 'PPL', 'P'),
(135734, 'Grygla', 48.3008308410645, 0.843008529625397, -95.6180572509766, -1.66884992338998, 218, 28, 'PPL', 'P'),
(149349, 'Grymes Hill', 40.6186103820801, 0.708928488752049, -74.0938873291016, -1.29318228949453, 218, 40, 'PPL', 'P'),
(178310, 'Gu Chuapo', 31.8944396972656, 0.556662985796069, -111.663887023926, -1.94890248414248, 218, 5, 'PPL', 'P'),
(178309, 'Gu Oidak', 31.9216709136963, 0.557138260182107, -112.042778015137, -1.95551537944525, 218, 5, 'PPL', 'P'),
(178311, 'Gu Vo', 32.065559387207, 0.559649587800538, -112.559997558594, -1.96454256343424, 218, 5, 'PPL', 'P'),
(2896, 'Gu-Win', 33.9608306884766, 0.592728312226249, -87.8805618286133, -1.53380515241175, 218, 2, 'PPL', 'P'),
(188639, 'Guachupangue', 35.982780456543, 0.628017992988943, -106.083610534668, -1.8515082862333, 218, 38, 'PPL', 'P'),
(181944, 'Guadalcanal Village', 38.1186103820801, 0.665295257452191, -122.292778015137, -2.13441162777467, 218, 6, 'PPL', 'P'),
(94639, 'Guadalupe', 28.7516708374023, 0.501811321562306, -96.9225006103516, -1.69161675491685, 218, 51, 'PPL', 'P'),
(178312, 'Guadalupe', 33.3708305358887, 0.582430866976321, -111.962219238281, -1.95410936354775, 218, 5, 'PPL', 'P'),
(181945, 'Guadalupe', 34.9716682434082, 0.610370755762615, -120.570831298828, -2.10435798803118, 218, 6, 'PPL', 'P'),
(186803, 'Guadalupe', 37.0952796936035, 0.647434767601575, -106.025001525879, -1.8504853660586, 218, 7, 'PPL', 'P'),
(188641, 'Guadalupe', 34.5461082458496, 0.602943332640438, -104.42749786377, -1.82260366734212, 218, 38, 'PPL', 'P'),
(181947, 'Guadalupe (historical)', 37.211669921875, 0.64946616030206, -121.905563354492, -2.12765345703443, 218, 6, 'PPL', 'P'),
(94641, 'Guadalupe Guerra Colonia', 26.4109992980957, 0.460958896493681, -99.0820007324219, -1.72930714224419, 218, 51, 'PPL', 'P'),
(94642, 'Guadalupe Heights', 29.9961109161377, 0.523530898280015, -99.0997161865234, -1.72961633524675, 218, 51, 'PPL', 'P'),
(188643, 'Guadalupita', 36.1375007629395, 0.630718371755256, -105.238059997559, -1.83675064536873, 218, 38, 'PPL', 'P'),
(36220, 'Guage', 37.5961112976074, 0.656175928089487, -83.1972198486328, -1.45206541486422, 218, 21, 'PPL', 'P'),
(181950, 'Gualala', 38.7658309936523, 0.676591388110898, -123.52693939209, -2.15595180730345, 218, 6, 'PPL', 'P'),
(55112, 'Guam', 36.9019393920898, 0.644060342763363, -89.8236083984375, -1.56771771257477, 218, 29, 'PPL', 'P'),
(109497, 'Guardian', 38.6361083984375, 0.674327301710168, -80.466667175293, -1.40440828031531, 218, 58, 'PPL', 'P'),
(181952, 'Guasti', 34.064998626709, 0.594546385723419, -117.585563659668, -2.0522552386746, 218, 6, 'PPL', 'P'),
(181953, 'Guatay', 32.8488883972168, 0.573321258151596, -116.55638885498, -2.03429274975423, 218, 6, 'PPL', 'P'),
(36221, 'Gubser Mill', 38.8877792358398, 0.67871978645409, -84.3088912963867, -1.47146774182794, 218, 21, 'PPL', 'P'),
(135736, 'Guckeen', 43.6513900756836, 0.761860479893056, -94.2247161865234, -1.64453153421203, 218, 28, 'PPL', 'P'),
(94643, 'Guda', 31.3586101531982, 0.547310996022633, -97.0325012207031, -1.69353662774669, 218, 51, 'PPL', 'P'),
(29962, 'Gudgel', 38.3047218322754, 0.668543515033761, -87.3644409179688, -1.52479714318261, 218, 19, 'PPL', 'P'),
(87496, 'Gudger', 35.4744415283203, 0.619145804975399, -84.4241714477539, -1.47347976003149, 218, 50, 'PPL', 'P'),
(140148, 'Guelph', 46.0227813720703, 0.80324906586814, -98.2355575561523, -1.71453392188725, 218, 34, 'PPL', 'P'),
(207573, 'Guemes', 48.5302810668945, 0.847013191535576, -122.623611450195, -2.14018576049213, 218, 56, 'PPL', 'P'),
(181956, 'Guenoc (historical)', 38.7891693115234, 0.676998718599626, -122.564720153809, -2.13915791346941, 218, 6, 'PPL', 'P'),
(162330, 'Guenot Settlement', 41.0805587768555, 0.716991009215182, -78.1436080932617, -1.36386325061551, 218, 45, 'PPL', 'P'),
(127651, 'Guerette', 47.1294403076172, 0.822563907990049, -68.3177795410156, -1.19237019064234, 218, 26, 'PPL', 'P'),
(155567, 'Guerne', 40.7633285522461, 0.711454297308908, -81.896110534668, -1.42935677340717, 218, 41, 'PPL', 'P'),
(181957, 'Guerneville', 38.5019416809082, 0.671985650742688, -122.995002746582, -2.14666776142733, 218, 6, 'PPL', 'P'),
(181958, 'Guernewood', 38.4927787780762, 0.671825727919229, -123.013893127441, -2.14699746077028, 218, 6, 'PPL', 'P'),
(192901, 'Guernewood Park', 38.496940612793, 0.671898365637961, -123.011390686035, -2.1469537849284, 218, 6, 'PPL', 'P'),
(9256, 'Guernsey', 33.6427803039551, 0.587177285829115, -93.6780624389648, -1.63499062644877, 218, 4, 'PPL', 'P'),
(78408, 'Guernsey', 39.9472198486328, 0.697210513376673, -77.232780456543, -1.3479663094366, 218, 45, 'PPL', 'P'),
(113000, 'Guernsey', 41.648609161377, 0.726905358742302, -92.3424987792969, -1.61168064321758, 218, 16, 'PPL', 'P'),
(122742, 'Guernsey', 40.8002815246582, 0.712099248345898, -86.8127822875977, -1.51516888373559, 218, 19, 'PPL', 'P'),
(155568, 'Guernsey', 40.1816711425781, 0.70130246039158, -81.5924987792969, -1.42405774862818, 218, 41, 'PPL', 'P'),
(181959, 'Guernsey', 36.2130584716797, 0.632037102548036, -119.639999389648, -2.08811190643337, 218, 6, 'PPL', 'P'),
(209488, 'Guernsey', 42.269718170166, 0.73774575595947, -104.741111755371, -1.82807726233056, 218, 59, 'PPL', 'P'),
(181960, 'Guernsey Mill', 35.834171295166, 0.625424273824288, -118.615562438965, -2.07023210866485, 218, 6, 'PPL', 'P'),
(94644, 'Guerra', 26.8827800750732, 0.469193024399556, -98.8933334350586, -1.72601427671437, 218, 51, 'PPL', 'P'),
(94645, 'Guerra Addition Colonia', 27.7399997711182, 0.484154330508485, -98.0910034179688, -1.71201097622857, 218, 51, 'PPL', 'P'),
(94646, 'Guerra Colonia', 26.3929996490479, 0.460644743353593, -98.8410034179688, -1.72510094561852, 218, 51, 'PPL', 'P'),
(94647, 'Guerra Ellis Colonia Number 1 and 2', 26.253999710083, 0.458218736758585, -98.3050003051758, -1.71574592649935, 218, 51, 'PPL', 'P'),
(94648, 'Guerra Estate Addition Colonia', 27.7409992218018, 0.484171774213625, -98.0899963378906, -1.71199339936537, 218, 51, 'PPL', 'P'),
(36222, 'Guerrant', 37.5066719055176, 0.654614916216537, -83.4972229003906, -1.45730145588343, 218, 21, 'PPL', 'P'),
(65272, 'Guerrant Springs (historical)', 36.4694404602051, 0.636511812390615, -79.5997161865234, -1.38927713110786, 218, 33, 'PPL', 'P'),
(2897, 'Guerryton', 32.2208290100098, 0.562359553946775, -85.5013885498047, -1.49228074522107, 218, 2, 'PPL', 'P'),
(188644, 'Guess Place', 32.1741714477539, 0.561545225864456, -108.263610839844, -1.8895564692531, 218, 38, 'PPL', 'P'),
(2898, 'Guest', 34.4241714477539, 0.600815134034329, -85.8733291625977, -1.49877233353619, 218, 2, 'PPL', 'P'),
(178313, 'Guevavi Mission (historical)', 31.4099998474121, 0.548207915388258, -110.901672363281, -1.93559932870726, 218, 5, 'PPL', 'P'),
(41219, 'Gueydan', 30.0258293151855, 0.524049582191822, -92.5083312988281, -1.61457496669027, 218, 22, 'PPL', 'P'),
(94649, 'Guffey', 30.0186100006104, 0.523923581382748, -94.0819396972656, -1.64203961438004, 218, 51, 'PPL', 'P'),
(162332, 'Guffey', 40.288890838623, 0.703173797110552, -79.7658309936523, -1.39217638142857, 218, 45, 'PPL', 'P'),
(186804, 'Guffey', 38.7511100769043, 0.676334459644733, -105.52082824707, -1.84168588234281, 218, 7, 'PPL', 'P'),
(209862, 'Guffey', 43.2972183227539, 0.755679016686873, -116.54638671875, -2.03411817954478, 218, 17, 'PPL', 'P'),
(36223, 'Guffie', 37.6041717529297, 0.656316609574071, -87.2544403076172, -1.52287727035277, 218, 21, 'PPL', 'P'),
(65274, 'Guide', 34.0783309936523, 0.594779079423664, -78.73388671875, -1.37416555613442, 218, 33, 'PPL', 'P'),
(141972, 'Guide Rock', 40.0747184753418, 0.699435784204516, -98.3302764892578, -1.71618707913392, 218, 35, 'PPL', 'P'),
(149350, 'Guideboard', 42.8091697692871, 0.747160962519281, -75.351936340332, -1.31513938689196, 218, 40, 'PPL', 'P'),
(65275, 'Guideway', 34.0644416809082, 0.59453666518544, -78.6961135864258, -1.37350629060657, 218, 33, 'PPL', 'P'),
(81387, 'Guignard Park', 33.8866691589355, 0.591433949357443, -80.353889465332, -1.40243993795363, 218, 48, 'PPL', 'P'),
(81388, 'Guignard Park East', 33.8899993896484, 0.591492072848234, -80.3483276367188, -1.4023428657319, 218, 48, 'PPL', 'P'),
(41220, 'Guilbeaux (historical)', 30.3575000762939, 0.529838329005759, -92.0538864135742, -1.60664340717374, 218, 22, 'PPL', 'P'),
(55113, 'Guild', 37.0699996948242, 0.646993548387976, -91.8016662597656, -1.6022413350499, 218, 29, 'PPL', 'P'),
(143913, 'Guild', 43.3766708374023, 0.757065724666477, -72.1386108398438, -1.25905627697015, 218, 36, 'PPL', 'P'),
(181961, 'Guild', 38.1452789306641, 0.66576071143171, -121.242500305176, -2.11608082367555, 218, 6, 'PPL', 'P'),
(191562, 'Guild', 30.9558296203613, 0.540281149561691, -102.875, -1.79550746798917, 218, 51, 'PPL', 'P'),
(21644, 'Guild (historical)', 34.6411094665527, 0.604601416735122, -85.3061065673828, -1.48887243165799, 218, 13, 'PPL', 'P'),
(149351, 'Guilderland', 42.7044410705566, 0.745333101905105, -73.9119415283203, -1.29000673621072, 218, 40, 'PPL', 'P'),
(149352, 'Guilderland Center', 42.7019386291504, 0.745289426063228, -73.966667175293, -1.29096187893568, 218, 40, 'PPL', 'P'),
(102518, 'Guildfield Corner', 36.8988914489746, 0.644007146120588, -76.9122161865234, -1.34237140746051, 218, 53, 'PPL', 'P'),
(172085, 'Guildhall', 44.564998626709, 0.777805957182823, -71.5602798461914, -1.24896249696458, 218, 55, 'PPL', 'P'),
(102519, 'Guilds Acres', 37.6930618286133, 0.657868034067096, -77.2861099243164, -1.34889708423759, 218, 53, 'PPL', 'P'),
(16297, 'Guilford', 30.0544395446777, 0.524548924896212, -82.4124984741211, -1.43836944316822, 218, 12, 'PPL', 'P'),
(29963, 'Guilford', 39.1680603027344, 0.683611613902402, -84.9119415283203, -1.4819929539301, 218, 19, 'PPL', 'P'),
(32649, 'Guilford', 37.5991706848145, 0.656229324469343, -95.7194366455078, -1.67061932761823, 218, 20, 'PPL', 'P'),
(47738, 'Guilford', 39.1697196960449, 0.683640575779256, -76.8308334350586, -1.34095101049312, 218, 25, 'PPL', 'P'),
(65280, 'Guilford', 36.0766716003418, 0.629656702586696, -79.8983306884766, -1.39448893736114, 218, 33, 'PPL', 'P'),
(78414, 'Guilford', 39.8652801513672, 0.695780395871301, -77.6127777099609, -1.35459851265728, 218, 45, 'PPL', 'P'),
(102522, 'Guilford', 37.297779083252, 0.650969048684219, -79.9272232055664, -1.39499320691355, 218, 53, 'PPL', 'P'),
(113091, 'Guilford', 45.1688919067383, 0.788345883250003, -69.3850021362305, -1.21099673878052, 218, 26, 'PPL', 'P'),
(113507, 'Guilford', 41.288890838623, 0.720627089630495, -72.6822204589844, -1.26854405466966, 218, 8, 'PPL', 'P'),
(119887, 'Guilford', 42.4174995422363, 0.740325027475211, -90.3002777099609, -1.57603716150406, 218, 18, 'PPL', 'P'),
(139201, 'Guilford', 40.170280456543, 0.701103655416206, -94.7361068725586, -1.65345698544738, 218, 29, 'PPL', 'P'),
(149354, 'Guilford', 42.4041709899902, 0.740092400353993, -75.4899978637695, -1.31754901504626, 218, 40, 'PPL', 'P'),
(155570, 'Guilford', 40.7916717529297, 0.71194897948139, -80.8663864135742, -1.41138469710688, 218, 41, 'PPL', 'P'),
(172087, 'Guilford', 42.8177795410156, 0.747311231383789, -72.5769424438477, -1.26670660667556, 218, 55, 'PPL', 'P'),
(9257, 'Guilford (historical)', 34.6347198486328, 0.604489896864475, -92.3638916015625, -1.6120540184024, 218, 4, 'PPL', 'P'),
(127652, 'Guilford Center', 45.1927795410156, 0.788762801118654, -69.3488922119141, -1.21036650170855, 218, 26, 'PPL', 'P'),
(149355, 'Guilford Center', 42.4052810668945, 0.740111774850923, -75.4625015258789, -1.31706911341783, 218, 40, 'PPL', 'P'),
(172088, 'Guilford Center', 42.7922210693359, 0.746865151901201, -72.6252822875977, -1.2675502961089, 218, 55, 'PPL', 'P'),
(65276, 'Guilford College', 36.0916709899902, 0.629918491321851, -79.8874969482422, -1.39429985292375, 218, 33, 'PPL', 'P'),
(47739, 'Guilford Downs', 39.2291717529297, 0.684678209918979, -76.8402786254883, -1.34111586016459, 218, 25, 'PPL', 'P'),
(47740, 'Guilford Gardens', 39.1708297729492, 0.683659950276187, -76.8291702270508, -1.34092198203724, 218, 25, 'PPL', 'P'),
(102523, 'Guilford Heights', 37.208610534668, 0.649412763922204, -76.9188919067383, -1.3424879207582, 218, 53, 'PPL', 'P'),
(78409, 'Guilford Hills', 39.9208297729492, 0.696749919666144, -77.5930633544922, -1.35425443224444, 218, 45, 'PPL', 'P'),
(47741, 'Guilford Manor', 39.2172203063965, 0.684469617826598, -76.6100006103516, -1.3370967506055, 218, 25, 'PPL', 'P'),
(78410, 'Guilford Springs', 39.8972206115723, 0.696337862066482, -77.6758270263672, -1.3556989308197, 218, 45, 'PPL', 'P'),
(47742, 'Guilford Square', 39.172779083252, 0.683693972159113, -76.8319396972656, -1.34097031841102, 218, 25, 'PPL', 'P'),
(2900, 'Guin', 33.9655609130859, 0.592810870220041, -87.9147186279297, -1.53440130102176, 218, 2, 'PPL', 'P'),
(55114, 'Guin', 37.0872192382813, 0.647294086116991, -93.3452835083008, -1.62918253842741, 218, 29, 'PPL', 'P'),
(181963, 'Guinda', 38.8291702270508, 0.67769686627939, -122.192779541016, -2.13266632515429, 218, 6, 'PPL', 'P'),
(106, 'Guinea', 38.1436080932617, 0.665731549817773, -77.4380569458008, -1.35154906005109, 218, 53, 'PPL', 'P'),
(2901, 'Guinea', 32.9436111450195, 0.57497448197729, -87.6511077880859, -1.52980042392254, 218, 2, 'PPL', 'P'),
(65279, 'Guinea', 36.4791717529297, 0.636681655489134, -76.1291732788086, -1.3287047305365, 218, 33, 'PPL', 'P'),
(127654, 'Guinea Corner', 43.4552803039551, 0.758437718681058, -70.429443359375, -1.22922567696795, 218, 26, 'PPL', 'P'),
(102524, 'Guinea Mills', 37.436939239502, 0.653397851598371, -78.3319396972656, -1.36715025719094, 218, 53, 'PPL', 'P'),
(139202, 'Guinn', 40.5816688537598, 0.708283737452141, -92.6547164916992, -1.61712987028204, 218, 29, 'PPL', 'P'),
(2902, 'Guinn Cross Roads', 34.4866714477539, 0.601905964816825, -87.9241714477539, -1.5345662838513, 218, 2, 'PPL', 'P'),
(9258, 'Guion', 35.9252815246582, 0.627014447311174, -91.940559387207, -1.60466547743214, 218, 4, 'PPL', 'P'),
(29964, 'Guion', 39.8427810668945, 0.695387712768569, -87.1113891601563, -1.52038055683082, 218, 19, 'PPL', 'P'),
(94650, 'Guion', 32.1285705566406, 0.560749340172686, -99.8649520874023, -1.74297222127155, 218, 51, 'PPL', 'P'),
(188645, 'Guique', 36.0877799987793, 0.629850580714054, -106.073608398438, -1.85133371602384, 218, 38, 'PPL', 'P'),
(122743, 'Guise Park', 41.0777816772461, 0.716942539683343, -86.4569396972656, -1.50895825891547, 218, 19, 'PPL', 'P'),
(55115, 'Guiteau', 36.5469398498535, 0.637864431908266, -91.3130569458008, -1.5937134937653, 218, 29, 'PPL', 'P'),
(81389, 'Guiton Crossing', 33.8563919067383, 0.590905511618144, -79.1474990844727, -1.38138445374325, 218, 48, 'PPL', 'P'),
(162334, 'Guitonville', 41.475830078125, 0.723889794860978, -79.2586135864258, -1.38332376764904, 218, 45, 'PPL', 'P'),
(60131, 'Gulde', 32.2986106872559, 0.563717100312443, -89.8633270263672, -1.56841093340651, 218, 30, 'PPL', 'P'),
(78412, 'Guldens', 39.8583297729492, 0.695659088883648, -77.1391677856445, -1.34633246010784, 218, 45, 'PPL', 'P'),
(207574, 'Guler', 45.9997215270996, 0.802846595648402, -121.539436340332, -2.12126333515684, 218, 56, 'PPL', 'P'),
(65281, 'Gulf', 35.5602798461914, 0.620643966246623, -79.2819366455078, -1.38373083182166, 218, 33, 'PPL', 'P'),
(94651, 'Gulf', 28.7211093902588, 0.501277923685477, -95.8916702270508, -1.67362537069865, 218, 51, 'PPL', 'P'),
(192903, 'Gulf', 35.1794395446777, 0.613997049060921, -119.159172058105, -2.07971988636437, 218, 6, 'PPL', 'P'),
(16298, 'Gulf Beach Heights', 30.3144397735596, 0.529086784946139, -87.4394378662109, -1.52610608685839, 218, 12, 'PPL', 'P'),
(16299, 'Gulf Breeze', 30.3569393157959, 0.529828541888753, -87.1638870239258, -1.52129681740387, 218, 12, 'PPL', 'P'),
(149357, 'Gulf Bridge', 43.2902793884277, 0.755557909436301, -76.0650024414063, -1.32758473814006, 218, 40, 'PPL', 'P'),
(16300, 'Gulf City', 27.7055606842041, 0.483553255050454, -82.4619369506836, -1.4392323073614, 218, 12, 'PPL', 'P'),
(41221, 'Gulf Crossing', 32.2058296203613, 0.562097765211621, -92.4730606079102, -1.6139593770043, 218, 22, 'PPL', 'P'),
(16302, 'Gulf Gate Estates', 27.2591705322266, 0.475762277149969, -82.5069427490234, -1.44001780672492, 218, 12, 'PPL', 'P'),
(16303, 'Gulf Hammock', 29.2527809143066, 0.510557342319208, -82.7311096191406, -1.44393025668236, 218, 12, 'PPL', 'P'),
(16304, 'Gulf Harbor', 26.288330078125, 0.458817914714339, -81.8080596923828, -1.42781999630014, 218, 12, 'PPL', 'P'),
(16305, 'Gulf Harbors', 28.2347202301025, 0.49278883139474, -82.7583312988281, -1.44440536462083, 218, 12, 'PPL', 'P'),
(2904, 'Gulf Highlands', 30.2311096191406, 0.527632399385333, -87.8797225952148, -1.53379050502576, 218, 2, 'PPL', 'P'),
(94652, 'Gulf Hill', 28.7569408416748, 0.501903300488455, -95.9297180175781, -1.67428942991647, 218, 51, 'PPL', 'P'),
(60132, 'Gulf Hills', 30.4302806854248, 0.5311085902667, -88.8422164916992, -1.55058919254976, 218, 30, 'PPL', 'P'),
(16306, 'Gulf Lagoon Beach', 30.1644401550293, 0.52646879772605, -85.7869415283203, -1.49726458488505, 218, 12, 'PPL', 'P'),
(87498, 'Gulf Park', 35.9330596923828, 0.627150201947741, -84.1097183227539, -1.46799151765706, 218, 50, 'PPL', 'P'),
(94653, 'Gulf Park', 28.9608306884766, 0.505461849626532, -95.4136123657227, -1.66528168700344, 218, 51, 'PPL', 'P'),
(60133, 'Gulf Park Estates', 30.3916702270508, 0.530434710642369, -88.7611083984375, -1.54917358927233, 218, 30, 'PPL', 'P'),
(16307, 'Gulf Pine', 28.1736106872559, 0.491722268667677, -82.5911102294922, -1.44148680638221, 218, 12, 'PPL', 'P'),
(16308, 'Gulf Pines', 30.3713893890381, 0.530080743243984, -86.3352813720703, -1.50683492057835, 218, 12, 'PPL', 'P'),
(16309, 'Gulf Resort Beach', 30.2233295440674, 0.527496611459252, -85.8916702270508, -1.49909244549922, 218, 12, 'PPL', 'P'),
(2905, 'Gulf Shores', 30.2458305358887, 0.527889327851498, -87.7008285522461, -1.53066821496375, 218, 2, 'PPL', 'P'),
(16310, 'Gulf Stream', 26.4933300018311, 0.462395838349347, -80.0552825927734, -1.3972282648584, 218, 12, 'PPL', 'P'),
(149358, 'Gulf Summit', 42.0188903808594, 0.73336798518057, -75.5308303833008, -1.31826167695397, 218, 40, 'PPL', 'P'),
(2906, 'Gulfcrest', 30.9952793121338, 0.540969676572018, -88.2375030517578, -1.54003495199172, 218, 2, 'PPL', 'P'),
(16311, 'Gulfport', 27.7480602264404, 0.484295011993069, -82.70361328125, -1.44345035505392, 218, 12, 'PPL', 'P'),
(60134, 'Gulfport', 30.3672199249268, 0.530007972367197, -89.0927810668945, -1.55496236937578, 218, 30, 'PPL', 'P'),
(119889, 'Gulfport', 40.8138885498047, 0.712336735736105, -91.0861129760742, -1.58975257427603, 218, 18, 'PPL', 'P'),
(149359, 'Gulfport', 40.6297187805176, 0.709122366879407, -74.1961135864258, -1.29496647426683, 218, 40, 'PPL', 'P'),
(60135, 'Gulfside', 30.2666702270508, 0.528253049077376, -89.3925018310547, -1.56019348354696, 218, 30, 'PPL', 'P'),
(55116, 'Gulfton', 37.1836090087891, 0.648976404977594, -94.5447235107422, -1.65011671565014, 218, 29, 'PPL', 'P'),
(41222, 'Gulftown', 29.3388900756836, 0.512060230701367, -89.4936065673828, -1.56195809408525, 218, 22, 'PPL', 'P'),
(75997, 'Gulftown', 35.4563903808594, 0.618830753018442, -95.9108276367188, -1.67395973057351, 218, 42, 'PPL', 'P'),
(87499, 'Gulfwood', 35.9302787780762, 0.627101665836874, -84.0863876342773, -1.46758432032639, 218, 50, 'PPL', 'P'),
(149360, 'Gulick', 42.6916694641113, 0.745110195321866, -77.4563903808594, -1.35186903885606, 218, 40, 'PPL', 'P'),
(122744, 'Gulivoire Park', 41.6133308410645, 0.726289635898276, -86.2452774047852, -1.50526405500937, 218, 19, 'PPL', 'P'),
(211858, 'Gulkana', 62.2713890075684, 1.08684076797227, -145.382217407227, -2.53739836760632, 218, 1, 'PPL', 'P'),
(131158, 'Gull Lake', 42.3708305358887, 0.739510499655811, -85.3866729736328, -1.49027858071355, 218, 27, 'PPL', 'P'),
(13876, 'Gull Point', 38.5947189331055, 0.673604919264484, -75.209716796875, -1.31265718759795, 218, 10, 'PPL', 'P'),
(9260, 'Gulledge', 33.0708312988281, 0.577194892536144, -91.8711090087891, -1.60345333966199, 218, 4, 'PPL', 'P'),
(36224, 'Gullett', 37.7372207641602, 0.658638752886565, -83.1269378662109, -1.45083876286613, 218, 21, 'PPL', 'P'),
(41223, 'Gullett', 30.7144393920898, 0.536068095296213, -90.5063934326172, -1.57963455950454, 218, 22, 'PPL', 'P'),
(9261, 'Gulley', 36.1377792358398, 0.630723232024246, -94.1591720581055, -1.64338757336579, 218, 4, 'PPL', 'P'),
(131159, 'Gulliver', 45.9930610656738, 0.80273034866682, -86.0119400024414, -1.50119154907042, 218, 27, 'PPL', 'P'),
(65284, 'Gulls Flight', 36.2038917541504, 0.63187711314555, -75.76611328125, -1.32236813819682, 218, 33, 'PPL', 'P'),
(113510, 'Gulls Hollow', 41.6291694641113, 0.726566072019426, -73.2244415283203, -1.27800759760326, 218, 8, 'PPL', 'P'),
(13877, 'Gulls Nest', 38.5758285522461, 0.673275219921532, -75.0608291625977, -1.31005860816431, 218, 10, 'PPL', 'P'),
(47743, 'Gullwing Villas', 38.8058280944824, 0.677289469211635, -76.2202835083008, -1.33029490402338, 218, 25, 'PPL', 'P'),
(135737, 'Gully', 47.7686080932617, 0.833719490322227, -95.6224975585938, -1.6689274213777, 218, 28, 'PPL', 'P'),
(102525, 'Gullysville', 37.8630599975586, 0.660835061837554, -78.8680572509766, -1.37650727368093, 218, 53, 'PPL', 'P'),
(36226, 'Gulnare', 37.6302795410156, 0.656772276436583, -82.5469436645508, -1.44071595440468, 218, 21, 'PPL', 'P'),
(186805, 'Gulnare', 37.3172187805176, 0.651308335407095, -104.751388549805, -1.82825662622998, 218, 7, 'PPL', 'P'),
(149361, 'Gulph', 43.0102806091309, 0.750671008836006, -75.1597213745117, -1.31178460286679, 218, 40, 'PPL', 'P'),
(162336, 'Gulph Mills', 40.0697212219238, 0.699348565678816, -75.3402786254883, -1.31493592138468, 218, 45, 'PPL', 'P'),
(162337, 'Gulph Mills Village', 40.0783309936523, 0.699498834543324, -75.3600006103516, -1.31528013495557, 218, 45, 'PPL', 'P'),
(162338, 'Gulph Terrace', 40.064998626709, 0.699266140843078, -75.3349990844727, -1.31484377601096, 218, 45, 'PPL', 'P'),
(9262, 'Gulpha (historical)', 34.5083312988281, 0.602284000533562, -92.9388885498047, -1.62208960833815, 218, 4, 'PPL', 'P'),
(65285, 'Gulrock', 35.4141693115234, 0.618093856344817, -76.0899963378906, -1.32802096392662, 218, 33, 'PPL', 'P'),
(36225, 'Gulthrie Beach', 38.3300018310547, 0.66898473424736, -85.644172668457, -1.49477279821111, 218, 21, 'PPL', 'P'),
(102526, 'Gulvey', 38.2427787780762, 0.667462404789243, -77.0950012207031, -1.34556160813032, 218, 53, 'PPL', 'P'),
(87500, 'Gum', 35.7447204589844, 0.623863062214256, -86.3258285522461, -1.50666993774882, 218, 50, 'PPL', 'P'),
(102527, 'Gum', 36.6349983215332, 0.639401342173351, -77.0827789306641, -1.345348288927, 218, 53, 'PPL', 'P'),
(181964, 'Gum', 34.9199981689453, 0.609468942838487, -120.520561218262, -2.10348060961006, 218, 6, 'PPL', 'P'),
(41224, 'Gum Bayou Landing', 30.3030605316162, 0.528888179707846, -89.7138900756836, -1.56580276659294, 218, 22, 'PPL', 'P'),
(21645, 'Gum Branch', 31.858060836792, 0.55602805490268, -81.726936340332, -1.4264041267066, 218, 13, 'PPL', 'P'),
(65286, 'Gum Branch', 34.8697204589844, 0.608591431259306, -77.4963912963867, -1.35256718653583, 218, 33, 'PPL', 'P'),
(9263, 'Gum Corner', 33.1694412231445, 0.578915960390607, -91.2869415283203, -1.59325769374473, 218, 4, 'PPL', 'P'),
(65287, 'Gum Corner', 36.4311103820801, 0.635842826324787, -76.0924987792969, -1.3280646397685, 218, 33, 'PPL', 'P'),
(87501, 'Gum Creek', 35.2924995422363, 0.615970318270615, -86.0069427490234, -1.50110433054472, 218, 50, 'PPL', 'P'),
(13878, 'Gum Crossroads', 38.6538887023926, 0.674637626556189, -75.4733276367188, -1.31725806469717, 218, 10, 'PPL', 'P'),
(87502, 'Gum Flat', 35.7150001525879, 0.623344345012936, -88.98388671875, -1.55306180446384, 218, 50, 'PPL', 'P'),
(102528, 'Gum Fork', 37.3666687011719, 0.652171399337362, -76.5708312988281, -1.33641311715368, 218, 53, 'PPL', 'P'),
(65288, 'Gum Forks', 36.5061111450195, 0.637151836579588, -77.6802825927734, -1.35577669512353, 218, 33, 'PPL', 'P'),
(9264, 'Gum Grove', 33.702220916748, 0.588214720231755, -93.1791687011719, -1.6262832881067, 218, 4, 'PPL', 'P'),
(60136, 'Gum Grove', 33.0774993896484, 0.57731127267578, -90.4269409179688, -1.57824785152494, 218, 30, 'PPL', 'P'),
(94654, 'Gum Grove', 30.0750007629395, 0.5249077858531, -94.9916687011719, -1.65791738079909, 218, 51, 'PPL', 'P'),
(21646, 'Gum Hill', 33.4302787780762, 0.583468434537016, -83.033332824707, -1.44920504669542, 218, 13, 'PPL', 'P'),
(47744, 'Gum Landing', 38.1399993896484, 0.665668566057993, -76.4150009155273, -1.33369336389043, 218, 25, 'PPL', 'P'),
(65289, 'Gum Neck', 35.7299995422363, 0.623606133748091, -76.1436080932617, -1.32895666557562, 218, 33, 'PPL', 'P'),
(9266, 'Gum Point', 35.7791709899902, 0.624464337409369, -90.5352783203125, -1.58013869589889, 218, 4, 'PPL', 'P'),
(41225, 'Gum Ridge', 32.6258316040039, 0.569428182691091, -91.811393737793, -1.60241111156939, 218, 22, 'PPL', 'P'),
(41226, 'Gum Ridge (historical)', 30.8686103820801, 0.538758886682602, -92.0250015258789, -1.60613927077939, 218, 22, 'PPL', 'P'),
(60137, 'Gum Ridge (historical)', 31.7833309173584, 0.554723771758814, -91.2444381713867, -1.59251587022309, 218, 30, 'PPL', 'P'),
(87503, 'Gum Road Subdivision', 35.7444381713867, 0.623858135366239, -86.3169403076172, -1.50651480861533, 218, 50, 'PPL', 'P'),
(162339, 'Gum Run', 40.9519386291504, 0.714746164153327, -76.1302795410156, -1.3287240384544, 218, 45, 'PPL', 'P'),
(2907, 'Gum Spring', 34.4361114501953, 0.601023526389628, -86.8186111450195, -1.51527061648924, 218, 2, 'PPL', 'P'),
(60140, 'Gum Spring', 32.4594383239746, 0.566524072101387, -89.4508285522461, -1.56121147687365, 218, 30, 'PPL', 'P'),
(87505, 'Gum Spring', 35.9911117553711, 0.628163401584461, -83.2211074829102, -1.45248233273287, 218, 50, 'PPL', 'P'),
(102529, 'Gum Spring', 37.7755584716797, 0.659307872110448, -77.8969421386719, -1.35955811755534, 218, 53, 'PPL', 'P'),
(109498, 'Gum Spring', 39.5183296203613, 0.689724966763706, -79.9105606079102, -1.39470238972251, 218, 58, 'PPL', 'P'),
(2909, 'Gum Springs', 34.0486106872559, 0.594260362222344, -86.6638870239258, -1.51257017114389, 218, 2, 'PPL', 'P'),
(9271, 'Gum Springs', 34.6991691589355, 0.605614749529897, -92.3255615234375, -1.61138503233658, 218, 4, 'PPL', 'P'),
(21647, 'Gum Springs', 34.360279083252, 0.599700001906885, -84.7866668701172, -1.47980649867514, 218, 13, 'PPL', 'P'),
(60139, 'Gum Springs', 33.2336082458496, 0.580035886208013, -89.0522232055664, -1.55425450115803, 218, 30, 'PPL', 'P'),
(65291, 'Gum Springs', 35.7608299255371, 0.624144225446341, -79.2322235107422, -1.38286317393851, 218, 33, 'PPL', 'P'),
(87508, 'Gum Springs', 36.4444389343262, 0.636075453446005, -85.9452819824219, -1.50002814714822, 218, 50, 'PPL', 'P'),
(94657, 'Gum Springs', 33.1494407653809, 0.578566886550725, -94.3605575561523, -1.64690241337247, 218, 51, 'PPL', 'P'),
(102530, 'Gum Springs', 38.7402801513672, 0.676145441786365, -77.0824966430664, -1.34534336207899, 218, 53, 'PPL', 'P'),
(2908, 'Gum Springs (historical)', 33.9319381713867, 0.592224042673842, -86.0805587768555, -1.50238917261263, 218, 2, 'PPL', 'P'),
(9272, 'Gum Springs (historical)', 35.2050018310547, 0.614443195122537, -91.7375030517578, -1.60112147581152, 218, 4, 'PPL', 'P'),
(162340, 'Gum Stump', 40.980281829834, 0.71524084632581, -77.8497161865234, -1.35873386919796, 218, 45, 'PPL', 'P'),
(112342, 'Gum Sulphur', 37.4269409179688, 0.653223347967944, -84.4594421386719, -1.47409534971747, 218, 21, 'PPL', 'P'),
(47746, 'Gum Swamp', 38.3588905334473, 0.669488937220739, -75.8294372558594, -1.3234733500492, 218, 25, 'PPL', 'P'),
(9273, 'Gum Tree', 35.1866683959961, 0.614123216317564, -93.4527816772461, -1.63105873541537, 218, 4, 'PPL', 'P'),
(36227, 'Gum Tree', 36.7241706848145, 0.640957693514393, -85.8194427490234, -1.49783183819723, 218, 21, 'PPL', 'P'),
(65293, 'Gum Tree', 35.9961090087891, 0.628250620110162, -80.2002792358398, -1.39975893368425, 218, 33, 'PPL', 'P'),
(102531, 'Gum Tree', 37.8191719055176, 0.66006907012902, -77.4744415283203, -1.35218409081302, 218, 53, 'PPL', 'P'),
(70906, 'Gum Tree Corner', 39.4375, 0.688314223755264, -75.3852767944336, -1.31572128759014, 218, 37, 'PPL', 'P'),
(65292, 'Gumberry', 36.4702796936035, 0.63652645977661, -77.4961090087891, -1.35256225968781, 218, 33, 'PPL', 'P'),
(55118, 'Gumbo', 38.6680603027344, 0.67488496764243, -90.6177825927734, -1.5815786671003, 218, 29, 'PPL', 'P'),
(13879, 'Gumboro', 38.4775009155273, 0.671559078915085, -75.3655624389648, -1.3153772071773, 218, 10, 'PPL', 'P'),
(2910, 'Gumbud', 33.6305618286133, 0.586964033204827, -87.8055572509766, -1.53249607557792, 218, 2, 'PPL', 'P'),
(87509, 'Gumdale', 35.5183296203613, 0.619911796683933, -87.9930572509766, -1.53576856792541, 218, 50, 'PPL', 'P'),
(94659, 'Gumesindo Galvan Colonia', 26.2159996032715, 0.457555509778615, -97.4759979248047, -1.701277105455, 218, 51, 'PPL', 'P'),
(127655, 'Gumet (historical)', 43.8622207641602, 0.765540169571218, -69.9138870239258, -1.22022752143484, 218, 26, 'PPL', 'P'),
(21649, 'Gumlog', 34.9658317565918, 0.610268889850919, -83.9355621337891, -1.4649519187469, 218, 13, 'PPL', 'P'),
(78413, 'Gump', 39.8055610656738, 0.694738101199671, -80.195556640625, -1.39967650884851, 218, 45, 'PPL', 'P'),
(60143, 'Gums', 33.9275016784668, 0.592146611265148, -89.6288909912109, -1.56431925270771, 218, 30, 'PPL', 'P'),
(60141, 'Gums Crossing', 33.9105606079102, 0.591850933805122, -89.6291732788086, -1.56432417955573, 218, 30, 'PPL', 'P'),
(13881, 'Gumwood', 39.7886085510254, 0.694442224002563, -75.5208282470703, -1.31808710674451, 218, 10, 'PPL', 'P'),
(94658, 'Gun Barrel City', 32.3344383239746, 0.564342410536394, -96.1511077880859, -1.67815341034206, 218, 51, 'PPL', 'P'),
(102532, 'Gun Barrel Lane Estates', 39.0591697692871, 0.681711115569494, -78.1263885498047, -1.36356271288649, 218, 53, 'PPL', 'P'),
(16312, 'Gun Club Estates', 26.6749992370605, 0.465566564653682, -80.1074981689453, -1.39813959858342, 218, 12, 'PPL', 'P'),
(115892, 'Gunder', 42.9716682434082, 0.749997095922161, -91.5130615234375, -1.59720423216412, 218, 16, 'PPL', 'P'),
(36228, 'Gunlock', 37.5475006103516, 0.655327511545215, -82.9261093139648, -1.44733364339742, 218, 21, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(192600, 'Gunlock', 37.2861099243164, 0.650765383439855, -113.762496948242, -1.98553013703683, 218, 52, 'PPL', 'P'),
(60142, 'Gunn', 32.0833282470703, 0.559959712909478, -89.6999969482422, -1.56556028577569, 218, 30, 'PPL', 'P'),
(102533, 'Gunn', 37.4933280944824, 0.65438202277921, -80.2355575561523, -1.40037465652827, 218, 53, 'PPL', 'P'),
(135740, 'Gunn', 47.2161102294922, 0.824076583489214, -93.4749984741211, -1.63144649167009, 218, 28, 'PPL', 'P'),
(55119, 'Gunn City', 38.6672210693359, 0.674870320256435, -94.1619415283203, -1.64343590973957, 218, 29, 'PPL', 'P'),
(102534, 'Gunn Hall Manor', 36.7769393920898, 0.64187868119837, -76.0047225952148, -1.32653265635143, 218, 53, 'PPL', 'P'),
(16313, 'Gunn Landing', 30.2544403076172, 0.528039596716006, -85.0683288574219, -1.48472242773132, 218, 12, 'PPL', 'P'),
(188646, 'Gunn Place (historical)', 32.8563919067383, 0.573452219098201, -108.837219238281, -1.89956782442292, 218, 38, 'PPL', 'P'),
(21650, 'Gunnell Place', 33.9602813720703, 0.592718724846324, -84.7655563354492, -1.47943805033833, 218, 13, 'PPL', 'P'),
(72773, 'Gunnerville', 39.583610534668, 0.690864333657069, -83.7627792358398, -1.46193628828655, 218, 41, 'PPL', 'P'),
(87510, 'Gunnings', 36.5319404602051, 0.637602643173111, -82.3855590820313, -1.43789926207776, 218, 50, 'PPL', 'P'),
(60144, 'Gunnison', 33.9441719055176, 0.592437561614239, -90.9449996948242, -1.58728968289992, 218, 30, 'PPL', 'P'),
(186807, 'Gunnison', 38.5458297729492, 0.672751642451222, -106.92472076416, -1.86618842911014, 218, 7, 'PPL', 'P'),
(192601, 'Gunnison', 39.1552810668945, 0.683388574161108, -111.817497253418, -1.95158348841186, 218, 52, 'PPL', 'P'),
(131161, 'Gunnisonville', 42.813060760498, 0.747228873127078, -84.523063659668, -1.47520575473397, 218, 27, 'PPL', 'P'),
(47747, 'Gunpowder', 39.4147186279297, 0.687916613804515, -76.3880615234375, -1.33322318279998, 218, 25, 'PPL', 'P'),
(47748, 'Gunpowder Acres', 39.7036094665527, 0.692958710117335, -76.7811126708984, -1.34008321945192, 218, 25, 'PPL', 'P'),
(47749, 'Gunpowder Estates', 39.4194412231445, 0.687999038640253, -76.4458312988281, -1.33423145558868, 218, 25, 'PPL', 'P'),
(47751, 'Gunpowder Farms', 39.5152816772461, 0.689671770120932, -76.4361114501953, -1.33406181222725, 218, 25, 'PPL', 'P'),
(47750, 'Gunpowder Ridge', 39.7172203063965, 0.69319626408657, -76.8222198486328, -1.34080067504958, 218, 25, 'PPL', 'P'),
(47752, 'Gunrich (historical)', 39.4500007629395, 0.688532403227568, -76.7874984741211, -1.34019467274354, 218, 25, 'PPL', 'P'),
(94660, 'Gunsight', 32.541389465332, 0.567954389343841, -98.8708267211914, -1.72562146045358, 218, 51, 'PPL', 'P'),
(196647, 'Gunsight', 48.6372184753418, 0.848879601406531, -112.461112976074, -1.96281670188981, 218, 31, 'PPL', 'P'),
(102535, 'Gunston Heights', 38.6738891601563, 0.674986700396071, -77.2119369506836, -1.3476025216317, 218, 53, 'PPL', 'P'),
(102536, 'Gunston Manor', 38.6477813720703, 0.674531033533559, -77.1438903808594, -1.34641488494358, 218, 53, 'PPL', 'P'),
(94662, 'Gunter', 32.8686103820801, 0.573665471722489, -95.6294403076172, -1.6690485952073, 218, 51, 'PPL', 'P'),
(200929, 'Gunter', 43.7983283996582, 0.764425037443775, -123.508888244629, -2.15563675534649, 218, 43, 'PPL', 'P'),
(21651, 'Gunter Estates', 33.9980583190918, 0.593378056953201, -83.9638900756836, -1.46544633460327, 218, 13, 'PPL', 'P'),
(2912, 'Guntersville', 34.3580589294434, 0.599661252913025, -86.2947235107422, -1.50612705236061, 218, 2, 'PPL', 'P'),
(65296, 'Guntertown', 35.9308280944824, 0.627111253216799, -82.7163925170898, -1.44367339479522, 218, 33, 'PPL', 'P'),
(149362, 'Gunther Park', 40.934440612793, 0.714440766155323, -73.8530578613281, -1.28897902234606, 218, 40, 'PPL', 'P'),
(2914, 'Gunthertown', 33.3738899230957, 0.582484263356177, -85.9524993896484, -1.50015411466778, 218, 2, 'PPL', 'P'),
(196648, 'Guntner Place', 45.1927795410156, 0.788762801118654, -112.465278625488, -1.96288940618757, 218, 31, 'PPL', 'P'),
(60145, 'Guntown', 34.4430618286133, 0.601144833377281, -88.6597213745117, -1.54740405188602, 218, 30, 'PPL', 'P'),
(87511, 'Guntown', 36.3944396972656, 0.635202802135813, -82.9888916015625, -1.44842940102794, 218, 50, 'PPL', 'P'),
(109499, 'Gunville', 38.7747192382813, 0.676746517244396, -81.8727798461914, -1.4289495760765, 218, 58, 'PPL', 'P'),
(140150, 'Guptill', 47.5155601501465, 0.829302970549467, -99.1380615234375, -1.73028558762869, 218, 34, 'PPL', 'P'),
(65294, 'Gupton', 36.1966705322266, 0.631751079046962, -78.1608276367188, -1.36416378834452, 218, 33, 'PPL', 'P'),
(200930, 'Gurdane', 45.2691688537598, 0.790096046139375, -119.103332519531, -2.07874530256345, 218, 43, 'PPL', 'P'),
(177738, 'Gurdev Colonia', 31.6639995574951, 0.552641046628317, -106.276000976563, -1.85486613289372, 218, 51, 'PPL', 'P'),
(9277, 'Gurdon', 33.9208297729492, 0.592030164546484, -93.1538925170898, -1.62584213547213, 218, 4, 'PPL', 'P'),
(65295, 'Gurganus', 34.7558288574219, 0.606603647821671, -77.6555633544922, -1.35534526302694, 218, 33, 'PPL', 'P'),
(2916, 'Gurley', 34.7016716003418, 0.605658425371774, -86.3758316040039, -1.50754265563804, 218, 2, 'PPL', 'P'),
(41228, 'Gurley', 30.8691692352295, 0.538768640510095, -91.1338882446289, -1.59058641001333, 218, 22, 'PPL', 'P'),
(112542, 'Gurley', 34.002498626709, 0.593455554940922, -78.9875030517578, -1.37859199618224, 218, 48, 'PPL', 'P'),
(199367, 'Gurley', 41.3222198486328, 0.721208790591595, -102.970283508301, -1.79717047893187, 218, 35, 'PPL', 'P'),
(155580, 'Gurley (historical)', 40.586109161377, 0.708361235439862, -83.2558288574219, -1.45308833503892, 218, 41, 'PPL', 'P'),
(29966, 'Gurley Corner', 38.8591690063477, 0.6782204437497, -84.8583297729492, -1.4810572522811, 218, 19, 'PPL', 'P'),
(29967, 'Gurley Landing', 37.959171295166, 0.662512520429167, -86.0469436645508, -1.50180247822449, 218, 19, 'PPL', 'P'),
(113511, 'Gurleyville', 41.8141708374023, 0.729794955104065, -72.2216720581055, -1.26050596870953, 218, 8, 'PPL', 'P'),
(178314, 'Gurli Put Vo', 32.2038917541504, 0.562063943065777, -112.018890380859, -1.9550984615766, 218, 5, 'PPL', 'P'),
(149363, 'Gurn Spring', 43.1708297729492, 0.75347312035596, -73.7180633544922, -1.28662292372966, 218, 40, 'PPL', 'P'),
(2917, 'Gurnee', 33.1894416809082, 0.579265034230489, -86.9686126708984, -1.51788863699884, 218, 2, 'PPL', 'P'),
(119890, 'Gurnee', 42.3702812194824, 0.739500912275886, -87.9019393920898, -1.53417826128047, 218, 18, 'PPL', 'P'),
(162341, 'Gurnee', 41.8030586242676, 0.72960101039768, -77.5216674804688, -1.3530083391704, 218, 45, 'PPL', 'P'),
(2918, 'Gurnee Junction', 33.1980590820313, 0.579415436253052, -86.9641723632813, -1.51781113901112, 218, 2, 'PPL', 'P'),
(174378, 'Gurney', 46.4727783203125, 0.811102994238893, -90.508056640625, -1.57966358796042, 218, 57, 'PPL', 'P'),
(195038, 'Gurney', 46.4263916015625, 0.810293393267509, -116.950828552246, -2.04117702117209, 218, 17, 'PPL', 'P'),
(27351, 'Gurney (historical)', 39.899169921875, 0.696371883949407, -90.0500030517578, -1.57166904468412, 218, 18, 'PPL', 'P'),
(162342, 'Gurney Hill', 41.3861083984375, 0.722323856140012, -79.8377838134766, -1.3934321950406, 218, 45, 'PPL', 'P'),
(124989, 'Gurneys Corner', 42.0430603027344, 0.733789829897239, -70.8550033569336, -1.23665310009013, 218, 23, 'PPL', 'P'),
(72774, 'Gurneyville', 39.514720916748, 0.689661983003926, -83.8769378662109, -1.46392873225609, 218, 41, 'PPL', 'P'),
(36229, 'Gus', 37.1175003051758, 0.647822590435317, -86.9088897705078, -1.51684627574818, 218, 21, 'PPL', 'P'),
(94663, 'Gus', 30.4552803039551, 0.531544915921796, -96.8574981689453, -1.69048224829247, 218, 51, 'PPL', 'P'),
(109501, 'Guseman', 39.5163917541504, 0.689691144617862, -79.8091735839844, -1.39293285233621, 218, 58, 'PPL', 'P'),
(109500, 'Guseman (historical)', 39.5713882446289, 0.690651014453754, -79.6097183227539, -1.38945170131731, 218, 58, 'PPL', 'P'),
(127656, 'Gushees Corner', 44.2830581665039, 0.772885167857656, -69.2452774047852, -1.20855808217034, 218, 26, 'PPL', 'P'),
(204188, 'Gusher', 40.3019409179688, 0.703401563962781, -109.817779541016, -1.91668183021999, 218, 52, 'PPL', 'P'),
(115893, 'Guss', 40.8419418334961, 0.712826357902517, -94.857780456543, -1.6555805901006, 218, 16, 'PPL', 'P'),
(202183, 'Gustave', 45.2811088562012, 0.790304438494674, -103.974716186523, -1.81470113628148, 218, 49, 'PPL', 'P'),
(155572, 'Gustavus', 41.4619407653809, 0.723647380622754, -80.6658325195313, -1.40788437132813, 218, 41, 'PPL', 'P'),
(209962, 'Gustavus', 58.413330078125, 1.01950493691752, -135.736938476563, -2.36905649299299, 218, 1, 'PPL', 'P'),
(131162, 'Gustin', 44.6272201538086, 0.77889192769633, -83.414436340332, -1.455856557834, 218, 27, 'PPL', 'P'),
(94664, 'Gustine', 31.8449993133545, 0.555800088313369, -98.4024963378906, -1.71744755327785, 218, 51, 'PPL', 'P'),
(181965, 'Gustine', 37.2577781677246, 0.650270901004455, -120.997779846191, -2.11180964591928, 218, 6, 'PPL', 'P'),
(36230, 'Guston', 37.8927803039551, 0.661353779038874, -86.2219390869141, -1.50485672452064, 218, 21, 'PPL', 'P'),
(186809, 'Guston', 37.916389465332, 0.661765836638536, -107.689720153809, -1.87954018723525, 218, 7, 'PPL', 'P'),
(135741, 'Gutches Grove', 45.9441719055176, 0.801877071853559, -94.9591674804688, -1.65735012748691, 218, 28, 'PPL', 'P'),
(162343, 'Guth', 40.621940612793, 0.70898661224284, -75.5524978637695, -1.31863984582876, 218, 45, 'PPL', 'P'),
(2919, 'Guthery Crossroads', 34.1155586242676, 0.595428824150616, -87.0108337402344, -1.51862553367246, 218, 2, 'PPL', 'P'),
(55121, 'Guthridge', 39.5436096191406, 0.690166185977305, -92.976936340332, -1.62275366755596, 218, 29, 'PPL', 'P'),
(29968, 'Guthrie', 38.9766693115234, 0.680271210947115, -86.5091705322266, -1.50986985895661, 218, 19, 'PPL', 'P'),
(36231, 'Guthrie', 36.6483306884766, 0.639634035873596, -87.166389465332, -1.52134049324574, 218, 21, 'PPL', 'P'),
(41227, 'Guthrie', 32.6811103820801, 0.570392979374999, -92.0199966430664, -1.60605191909564, 218, 22, 'PPL', 'P'),
(55120, 'Guthrie', 38.7569389343262, 0.676436192398374, -92.0963897705078, -1.60738523069539, 218, 29, 'PPL', 'P'),
(65297, 'Guthrie', 36.1213912963867, 0.630437208523171, -80.1513900756836, -1.39890565687099, 218, 33, 'PPL', 'P'),
(72775, 'Guthrie', 38.4438896179199, 0.670972451105967, -82.3383331298828, -1.43707501372038, 218, 41, 'PPL', 'P'),
(75998, 'Guthrie', 35.8788909912109, 0.626204779760763, -97.4250030517578, -1.7003870770187, 218, 42, 'PPL', 'P'),
(109502, 'Guthrie', 38.4061088562012, 0.670313052420064, -81.6616668701172, -1.42526495955032, 218, 58, 'PPL', 'P'),
(119891, 'Guthrie', 40.5083312988281, 0.707003755653222, -88.3249969482422, -1.54156200856077, 218, 18, 'PPL', 'P'),
(131164, 'Guthrie', 42.3025016784668, 0.738317936119673, -84.0691680908203, -1.46728378259737, 218, 27, 'PPL', 'P'),
(135742, 'Guthrie', 47.3002815246582, 0.825545649725529, -94.7908325195313, -1.65441212817233, 218, 28, 'PPL', 'P'),
(174380, 'Guthrie', 42.9249992370605, 0.749182568102761, -88.1999969482422, -1.53938034699578, 218, 57, 'PPL', 'P'),
(178315, 'Guthrie', 32.9461097717285, 0.57501809124014, -109.252502441406, -1.90681588364568, 218, 5, 'PPL', 'P'),
(191563, 'Guthrie', 33.6205596923828, 0.586789462995372, -100.32250213623, -1.75095797611627, 218, 51, 'PPL', 'P'),
(198377, 'Guthrie', 48.0011100769043, 0.837777415454208, -100.376937866211, -1.75190805883515, 218, 34, 'PPL', 'P'),
(115894, 'Guthrie Center', 41.6772193908691, 0.727404701446692, -94.503059387207, -1.6493895395145, 218, 16, 'PPL', 'P'),
(81390, 'Guthries', 34.8980598449707, 0.609086046852761, -81.2080612182617, -1.41734804741978, 218, 48, 'PPL', 'P'),
(162344, 'Guthriesville', 40.0330581665039, 0.698708674647897, -75.7638931274414, -1.32232938920296, 218, 45, 'PPL', 'P'),
(162345, 'Guthsville', 40.6191711425781, 0.708938275869055, -75.586669921875, -1.31923626075488, 218, 45, 'PPL', 'P'),
(188648, 'Gutierrezville', 34.060001373291, 0.594459167197718, -107.923606872559, -1.88362228055413, 218, 38, 'PPL', 'P'),
(155574, 'Gutman', 40.5194396972656, 0.70719763378058, -84.0438919067383, -1.4668426299628, 218, 41, 'PPL', 'P'),
(115896, 'Guttenberg', 42.785831451416, 0.746753632030554, -91.0994415283203, -1.58998520139724, 218, 16, 'PPL', 'P'),
(145338, 'Guttenberg', 40.7919387817383, 0.711953640013298, -74.0041732788086, -1.29161648393162, 218, 37, 'PPL', 'P'),
(322, 'Guy', 35.3252792358398, 0.616542431851792, -92.3341674804688, -1.61153523462206, 218, 4, 'PPL', 'P'),
(36232, 'Guy', 37.1238899230957, 0.647934110305964, -86.6130599975586, -1.51168307218479, 218, 21, 'PPL', 'P'),
(94665, 'Guy', 29.3438892364502, 0.512147482516581, -95.7827835083008, -1.67172493894477, 218, 51, 'PPL', 'P'),
(122745, 'Guy', 40.4352798461914, 0.705728767281346, -85.9755630493164, -1.50055665146655, 218, 19, 'PPL', 'P'),
(188649, 'Guy', 36.8144416809082, 0.642533219615284, -103.431938171387, -1.8052278728099, 218, 38, 'PPL', 'P'),
(109503, 'Guyan', 37.6402816772461, 0.656946846646038, -81.7750015258789, -1.42724302244997, 218, 58, 'PPL', 'P'),
(109506, 'Guyan Estates', 38.401668548584, 0.670235554432343, -82.3177795410156, -1.43671628592155, 218, 58, 'PPL', 'P'),
(109504, 'Guyan Terrace', 37.916389465332, 0.661765836638536, -81.9738922119141, -1.43071431977284, 218, 58, 'PPL', 'P'),
(109505, 'Guyandotte', 38.4269409179688, 0.670676640487887, -82.3852767944336, -1.43789433522975, 218, 58, 'PPL', 'P'),
(149364, 'Guyanoga', 42.6238899230957, 0.743927219165653, -77.1658325195313, -1.34679784750833, 218, 40, 'PPL', 'P'),
(195039, 'Guyaz', 43.4816703796387, 0.758898312391588, -111.64582824707, -1.94858729902747, 218, 17, 'PPL', 'P'),
(13889, 'Guyencourt', 39.8136100769043, 0.694878582947173, -75.586669921875, -1.31923626075488, 218, 10, 'PPL', 'P'),
(149371, 'Guyler Hill', 42.7130584716797, 0.745483503927668, -75.9208297729492, -1.3250684503841, 218, 40, 'PPL', 'P'),
(149365, 'Guymard', 41.4288902282715, 0.723070539930643, -74.5991668701172, -1.30200108112822, 218, 40, 'PPL', 'P'),
(190984, 'Guymon', 36.6827812194824, 0.640235311068709, -101.481109619141, -1.77117949143129, 218, 42, 'PPL', 'P'),
(41229, 'Guynes', 32.2033309936523, 0.562054155948771, -93.1122207641602, -1.62511482617843, 218, 22, 'PPL', 'P'),
(47753, 'Guys', 38.9394416809082, 0.679621466220163, -76.1705627441406, -1.32942711298218, 218, 25, 'PPL', 'P'),
(87512, 'Guys', 35.0347213745117, 0.611471240504063, -88.5586090087891, -1.54563930818968, 218, 50, 'PPL', 'P'),
(162346, 'Guys Mills', 41.6300010681152, 0.726580586247367, -79.977783203125, -1.39587564534075, 218, 45, 'PPL', 'P'),
(94666, 'Guys Store', 31.2199192047119, 0.544890382328832, -95.8242874145508, -1.67244931876128, 218, 51, 'PPL', 'P'),
(21652, 'Guysie', 31.5441703796387, 0.550549632934764, -82.5316696166992, -1.44044937197957, 218, 13, 'PPL', 'P'),
(177362, 'Guyson', 46.2975006103516, 0.808043821094719, -99.2050018310547, -1.73145391639891, 218, 34, 'PPL', 'P'),
(72777, 'Guysville', 39.2900009155273, 0.685739879087539, -81.9236068725586, -1.4298366750356, 218, 41, 'PPL', 'P'),
(21653, 'Guyton', 32.336109161377, 0.56437157215033, -81.3916702270508, -1.42055262915948, 218, 13, 'PPL', 'P'),
(41230, 'Guyton', 32.4130592346191, 0.565714604288057, -92.3772201538086, -1.61228664552362, 218, 22, 'PPL', 'P'),
(55123, 'Guyton', 39.5144386291504, 0.689657056155909, -94.3236083984375, -1.64625752891451, 218, 29, 'PPL', 'P'),
(94667, 'Guzman Colonia', 26.9080009460449, 0.469633211638233, -99.2630004882813, -1.73246618392925, 218, 51, 'PPL', 'P'),
(102540, 'Gwaltney Corner', 37.1116714477539, 0.647720857681676, -77.024169921875, -1.3443253687523, 218, 53, 'PPL', 'P'),
(102537, 'Gwaltney Crossroads', 36.9877815246582, 0.645558570613614, -76.7652816772461, -1.33980691648882, 218, 53, 'PPL', 'P'),
(102538, 'Gwathmey', 37.7338905334473, 0.658580629395774, -77.4897232055664, -1.35245080639619, 218, 53, 'PPL', 'P'),
(190287, 'Gweenah (historical)', 39.5588912963867, 0.690432901560476, -117.189437866211, -2.0453415393267, 218, 39, 'PPL', 'P'),
(813, 'Gwendale', 39.9874992370605, 0.697913521325427, -76.745002746582, -1.33945298237995, 218, 45, 'PPL', 'P'),
(195040, 'Gwenford', 42.1363906860352, 0.735418752377986, -112.329170227051, -1.96051386649522, 218, 17, 'PPL', 'P'),
(47757, 'Gwenlee Estates', 39.2819404602051, 0.685599197602955, -77.0016708374023, -1.34393268564957, 218, 25, 'PPL', 'P'),
(60147, 'Gwin', 33.1736106872559, 0.578988731267394, -90.2233276367188, -1.57469412936634, 218, 30, 'PPL', 'P'),
(13882, 'Gwinhurst', 39.7916717529297, 0.694495686961447, -75.4791717529297, -1.31736006376692, 218, 10, 'PPL', 'P'),
(109508, 'Gwinn', 38.5608291625977, 0.673013431186377, -82.2144393920898, -1.43491266007329, 218, 58, 'PPL', 'P'),
(131165, 'Gwinn', 46.2811088562012, 0.807757731014617, -87.4408264160156, -1.52613032162431, 218, 27, 'PPL', 'P'),
(140152, 'Gwinner', 46.225830078125, 0.806792934330709, -97.6622161865234, -1.70452722724933, 218, 34, 'PPL', 'P'),
(94668, 'Gwinns Crossing (historical)', 29.5397205352783, 0.515565383459588, -96.470832824707, -1.68373366493216, 218, 51, 'PPL', 'P'),
(422, 'Gwinnstone', 33.8383293151855, 0.590590259924106, -84.0327835083008, -1.46664875183544, 218, 13, 'PPL', 'P'),
(60146, 'Gwinville', 31.7513904571533, 0.554166305563633, -89.899169921875, -1.56903650994657, 218, 30, 'PPL', 'P'),
(162347, 'Gwynedd', 40.2016716003418, 0.701651534231462, -75.2555618286133, -1.31345733434747, 218, 45, 'PPL', 'P'),
(162348, 'Gwynedd Heights', 40.2050018310547, 0.701709657722253, -75.2624969482422, -1.31357837501901, 218, 45, 'PPL', 'P'),
(162349, 'Gwynedd Square', 40.2216682434082, 0.702000541492317, -75.3030624389648, -1.31428637639481, 218, 45, 'PPL', 'P'),
(162350, 'Gwynedd Valley', 40.1841697692871, 0.70134606965443, -75.2566680908203, -1.31347664226537, 218, 45, 'PPL', 'P'),
(102539, 'Gwynn', 37.5041694641113, 0.65457124037466, -76.2888870239258, -1.33149226124948, 218, 53, 'PPL', 'P'),
(47754, 'Gwynn Oak', 39.3325004577637, 0.686481636030153, -76.6930618286133, -1.33854644234489, 218, 25, 'PPL', 'P'),
(47755, 'Gwynn Park', 38.7075004577637, 0.675573328205188, -76.8574981689453, -1.34141639789361, 218, 25, 'PPL', 'P'),
(47756, 'Gwynnbrook', 39.4438896179199, 0.688425743625911, -76.7819366455078, -1.3400976005218, 218, 25, 'PPL', 'P'),
(29970, 'Gwynneville', 39.660831451416, 0.692212092905731, -85.648063659668, -1.49484070881891, 218, 19, 'PPL', 'P'),
(181966, 'Gypsite', 35.3311080932617, 0.616644164605433, -117.930282592773, -2.05827171905125, 218, 6, 'PPL', 'P'),
(32652, 'Gypsum', 38.7055587768555, 0.675539439480317, -97.4277801513672, -1.70043554655054, 218, 20, 'PPL', 'P'),
(149366, 'Gypsum', 42.9822196960449, 0.75018125351154, -77.133056640625, -1.34622580050618, 218, 40, 'PPL', 'P'),
(155575, 'Gypsum', 41.4933280944824, 0.724195192858983, -82.8758316040039, -1.44645613181824, 218, 41, 'PPL', 'P'),
(186810, 'Gypsum', 39.6469383239746, 0.691969612088479, -106.951110839844, -1.86664902282067, 218, 7, 'PPL', 'P'),
(181967, 'Gypsum (historical)', 33.8772201538086, 0.59126903310694, -117.691940307617, -2.05411186142855, 218, 6, 'PPL', 'P'),
(102541, 'Gypsum Hill Estates', 38.8702812194824, 0.678414388456085, -77.6191711425781, -1.35471009910696, 218, 53, 'PPL', 'P'),
(192602, 'Gypsum Mill', 39.7127799987793, 0.693118766098848, -111.803329467773, -1.95133621390465, 218, 52, 'PPL', 'P'),
(36233, 'Gypsy', 37.6624984741211, 0.657334602900754, -82.9638900756836, -1.44799304208333, 218, 21, 'PPL', 'P'),
(41231, 'Gypsy', 30.0316696166992, 0.524151514682545, -90.4674987792969, -1.57895571974268, 218, 22, 'PPL', 'P'),
(76000, 'Gypsy', 35.711669921875, 0.623286221522145, -96.4591674804688, -1.68353006626682, 218, 42, 'PPL', 'P'),
(109507, 'Gypsy', 39.3686103820801, 0.68711187310212, -80.3180618286133, -1.40181462772968, 218, 58, 'PPL', 'P'),
(155576, 'Gypsy Lane Estates Mobile Home Park', 41.3527793884277, 0.721742155178911, -83.6594390869141, -1.46013266243829, 218, 41, 'PPL', 'P'),
(21655, 'Gypsy Woods', 33.3441696166992, 0.581965546154857, -84.4044418334961, -1.47313541330255, 218, 13, 'PPL', 'P'),
(94670, 'H and B Colonia', 26.1219997406006, 0.455914902678585, -98.1969985961914, -1.71386094107979, 218, 51, 'PPL', 'P'),
(13883, 'H and H Corner', 39.3797187805176, 0.687305751229478, -75.6655578613281, -1.32061311503845, 218, 10, 'PPL', 'P'),
(196649, 'H and H Trailer Court', 45.6438903808594, 0.796636170565365, -109.260276794434, -1.90695157170322, 218, 31, 'PPL', 'P'),
(94669, 'H Cuellar Estates Colonia', 26.5610008239746, 0.463576917003284, -99.1259994506836, -1.73007506474452, 218, 51, 'PPL', 'P'),
(162351, 'Haafsville', 40.5788917541504, 0.708235267920302, -75.6613922119141, -1.3205404107407, 218, 45, 'PPL', 'P'),
(162352, 'Haags Mill', 41.2891693115234, 0.720631949899484, -75.3311080932617, -1.31477586540316, 218, 45, 'PPL', 'P'),
(60148, 'Haanka Ullah (historical)', 32.6847190856934, 0.57045596313478, -88.7291717529297, -1.54861618965617, 218, 30, 'PPL', 'P'),
(41235, 'Haas', 30.9480590820313, 0.540145528083179, -92.2591705322266, -1.61022629094628, 218, 22, 'PPL', 'P'),
(162353, 'Haas', 40.7005615234375, 0.710358805994504, -76.4947204589844, -1.33508473240195, 218, 45, 'PPL', 'P'),
(41232, 'Haaseville', 30.2250003814697, 0.527525773073189, -91.1319427490234, -1.59055245470943, 218, 22, 'PPL', 'P'),
(21656, 'Haasville (historical)', 33.649169921875, 0.587288805699762, -84.3916702270508, -1.47291250671931, 218, 13, 'PPL', 'P'),
(41233, 'Haaswood', 30.3286094665527, 0.529334092742866, -89.7444381713867, -1.56633593144318, 218, 22, 'PPL', 'P'),
(9280, 'Habberton', 36.1150016784668, 0.630325688652524, -94.0513916015625, -1.64150644952981, 218, 4, 'PPL', 'P'),
(149367, 'Haberman', 40.725830078125, 0.710799825471021, -73.920280456543, -1.29015227796429, 218, 40, 'PPL', 'P'),
(21658, 'Habersham', 34.5897216796875, 0.60370453065901, -83.5605621337891, -1.45840693405192, 218, 13, 'PPL', 'P'),
(87513, 'Habersham', 36.497501373291, 0.63700156771508, -84.0736083984375, -1.46736128058509, 218, 50, 'PPL', 'P'),
(21659, 'Habersham (historical)', 32.9402809143066, 0.574916358486499, -81.8894424438477, -1.42924039326753, 218, 13, 'PPL', 'P'),
(21662, 'Habersham Hills', 34.0438919067383, 0.594178003965633, -83.9888916015625, -1.46588269354788, 218, 13, 'PPL', 'P'),
(21664, 'Habersham Station (historical)', 34.5883293151855, 0.603680229314063, -83.533332824707, -1.45793169295539, 218, 13, 'PPL', 'P'),
(36234, 'Habit', 37.6977806091309, 0.657950392323807, -86.9963912963867, -1.51837346547529, 218, 21, 'PPL', 'P'),
(16316, 'Habor Bluffs', 27.9063892364502, 0.487058374519162, -82.8252792358398, -1.4455738265491, 218, 12, 'PPL', 'P'),
(94672, 'Haby Crossing', 29.3283290863037, 0.51187590666442, -99.9469375610352, -1.74440313772525, 218, 51, 'PPL', 'P'),
(188650, 'Hachita', 31.9180603027344, 0.557075243132813, -108.319717407227, -1.89053571358592, 218, 38, 'PPL', 'P'),
(181968, 'Hacienda', 38.5113906860352, 0.672150566993191, -122.926666259766, -2.14547506473313, 218, 6, 'PPL', 'P'),
(188651, 'Hacienda Acres', 32.0019416809082, 0.558539249363057, -106.576942443848, -1.86011855235363, 218, 38, 'PPL', 'P'),
(181969, 'Hacienda Carmel', 36.5372200012207, 0.637694788546828, -121.878059387207, -2.12717342224795, 218, 6, 'PPL', 'P'),
(94674, 'Hacienda de los Vegas Colonia', 26.3010005950928, 0.459039056953357, -98.0910034179688, -1.71201097622857, 218, 51, 'PPL', 'P'),
(178317, 'Hacienda de Valencia', 33.4099998474121, 0.583114500428144, -111.733612060547, -1.95011941560259, 218, 5, 'PPL', 'P'),
(94675, 'Hacienda del Bronco Number 1 Colonia', 26.3099994659424, 0.459196116878644, -98.2080001831055, -1.71405295499438, 218, 51, 'PPL', 'P'),
(94676, 'Hacienda del Bronco Number 2 Colonia', 26.3099994659424, 0.459196116878644, -98.2089996337891, -1.71407039869952, 218, 51, 'PPL', 'P'),
(181975, 'Hacienda del Florasol', 32.6172218322754, 0.569277913826583, -116.499443054199, -2.03329885803542, 218, 6, 'PPL', 'P'),
(94677, 'Hacienda el Porvenir Colonia', 26.3090000152588, 0.459178673173504, -97.9960021972656, -1.71035289213388, 218, 51, 'PPL', 'P'),
(94673, 'Hacienda Gardens Colonia', 25.9829998016357, 0.453488896083577, -97.5149993896484, -1.70195780942963, 218, 51, 'PPL', 'P'),
(181970, 'Hacienda Heights', 33.9930610656738, 0.593290838427501, -117.967781066895, -2.05892619088914, 218, 6, 'PPL', 'P'),
(191564, 'Hacienda Heights', 31.7427806854248, 0.554016036699125, -106.353057861328, -1.85621102924421, 218, 51, 'PPL', 'P'),
(178319, 'Hacienda Los Encino', 31.6588897705078, 0.552551864021313, -110.646667480469, -1.93114865389352, 218, 5, 'PPL', 'P'),
(191565, 'Hacienda Real Colonia', 31.5869998931885, 0.551297148963236, -106.204002380371, -1.85360952033337, 218, 51, 'PPL', 'P'),
(178316, 'Hacienda Solano Park', 33.3050003051758, 0.581281912703034, -111.790283203125, -1.95110851363144, 218, 5, 'PPL', 'P'),
(196650, 'Hacienda Trailer Court', 48.5555610656738, 0.847454410749175, -109.652778625488, -1.91380202097523, 218, 31, 'PPL', 'P'),
(16317, 'Hacienda Village', 26.0849990844727, 0.455269119403754, -80.2013931274414, -1.3997783747602, 218, 12, 'PPL', 'P'),
(122746, 'Hacienda Village', 41.1172218322754, 0.717630900246101, -85.0299987792969, -1.48405344166549, 218, 19, 'PPL', 'P'),
(178318, 'Haciendas del Lago', 33.5777816772461, 0.586042845783768, -111.871109008789, -1.95251919006086, 218, 5, 'PPL', 'P'),
(191566, 'Haciendas del Valle Number 1 Colonia', 31.6200008392334, 0.551873124127993, -106.248001098633, -1.8543774428337, 218, 51, 'PPL', 'P'),
(191567, 'Haciendas del Valle Number 2 Colonia', 31.6229991912842, 0.551925455243413, -106.250999450684, -1.85442977394912, 218, 51, 'PPL', 'P'),
(191568, 'Haciendito', 29.6149806976318, 0.516878921088243, -104.45467376709, -1.82307797633227, 218, 51, 'PPL', 'P'),
(47758, 'Hack Point', 39.4630584716797, 0.688760303237852, -75.8813934326172, -1.32438015640037, 218, 25, 'PPL', 'P'),
(193608, 'Hackamore', 41.5519409179688, 0.72521817961271, -121.122497558594, -2.11398638063625, 218, 6, 'PPL', 'P'),
(41234, 'Hackberry', 29.9958305358887, 0.523526004721512, -93.3419418334961, -1.62912421519954, 218, 22, 'PPL', 'P'),
(87514, 'Hackberry', 36.4347190856934, 0.635905810084567, -87.434440612793, -1.52601886833269, 218, 50, 'PPL', 'P'),
(178320, 'Hackberry', 35.3691711425781, 0.617308490139353, -113.726387023926, -1.98489989996486, 218, 5, 'PPL', 'P'),
(191571, 'Hackberry', 33.2869415283203, 0.580966727588023, -101.55583190918, -1.7724836414171, 218, 51, 'PPL', 'P'),
(94680, 'Hackberry Colonia', 26.4060001373291, 0.460871644678468, -98.9779968261719, -1.7274919316452, 218, 51, 'PPL', 'P'),
(191572, 'Hackberry Crossing', 30.2186107635498, 0.527414253202542, -101.656936645508, -1.77424825195539, 218, 51, 'PPL', 'P'),
(135744, 'Hackensack', 46.9308280944824, 0.819097470936175, -94.5202789306641, -1.64969007724351, 218, 28, 'PPL', 'P'),
(145340, 'Hackensack', 40.8858299255371, 0.713592349611051, -74.0438919067383, -1.29230970476337, 218, 37, 'PPL', 'P'),
(87515, 'Hacker (historical)', 36.2297210693359, 0.632327919739073, -82.5483322143555, -1.4407401891706, 218, 50, 'PPL', 'P'),
(109509, 'Hacker Valley', 38.6525001525879, 0.674613391790269, -80.3838882446289, -1.40296351542394, 218, 58, 'PPL', 'P'),
(193609, 'Hacketsville', 40.4874992370605, 0.706640167585399, -124.170280456543, -2.16718022709144, 218, 6, 'PPL', 'P'),
(9281, 'Hackett', 35.1902809143066, 0.614186266656371, -94.4108276367188, -1.6477797917936, 218, 4, 'PPL', 'P'),
(135746, 'Hackett', 48.8158302307129, 0.851996964620523, -94.7183303833008, -1.65314672718038, 218, 28, 'PPL', 'P'),
(162354, 'Hackett', 40.2477798461914, 0.702456274933857, -80.0219421386719, -1.39664636416022, 218, 45, 'PPL', 'P'),
(127657, 'Hackett Mills', 44.0858306884766, 0.769442898990675, -70.3361129760742, -1.2275967544872, 218, 26, 'PPL', 'P'),
(41236, 'Hacketts Corner', 30.0091705322266, 0.523758831579813, -93.0880584716797, -1.62469311461981, 218, 22, 'PPL', 'P'),
(145347, 'Hackettstown', 40.853889465332, 0.71303488341587, -74.8294372558594, -1.30602005752926, 218, 37, 'PPL', 'P'),
(145343, 'Hacklebarney', 40.7669410705566, 0.711517347647715, -74.720832824707, -1.30412455262339, 218, 37, 'PPL', 'P'),
(162355, 'Hacklebernie', 40.8574981689453, 0.71309786717565, -75.7716674804688, -1.3224650772605, 218, 45, 'PPL', 'P'),
(2921, 'Hackleburg', 34.2772216796875, 0.598250376746528, -87.82861328125, -1.53289847921863, 218, 2, 'PPL', 'P'),
(122747, 'Hackleman', 40.4216690063477, 0.705491213312111, -85.7480621337891, -1.49658601143929, 218, 19, 'PPL', 'P'),
(55124, 'Hackleman Corner', 37.8511085510254, 0.660626469745173, -93.8747177124023, -1.63842290846166, 218, 29, 'PPL', 'P'),
(55125, 'Hackler Ford (historical)', 37.6927795410156, 0.65786310721908, -92.9744415283203, -1.62271012487214, 218, 29, 'PPL', 'P'),
(36235, 'Hackley', 37.6330604553223, 0.65682081254745, -84.4716720581055, -1.47430880207884, 218, 21, 'PPL', 'P'),
(41237, 'Hackley', 30.975830078125, 0.540630223401574, -90.085563659668, -1.57228969437616, 218, 22, 'PPL', 'P'),
(102542, 'Hackleys Crossroad', 38.7275009155273, 0.67592240204507, -78.0313873291016, -1.36190462879181, 218, 53, 'PPL', 'P'),
(32656, 'Hackney', 37.1661109924316, 0.648671006979589, -97.147216796875, -1.69553879225421, 218, 20, 'PPL', 'P'),
(55126, 'Hackney', 37.3450012207031, 0.651793230462571, -93.3952789306641, -1.63005512315858, 218, 29, 'PPL', 'P'),
(65302, 'Hackney', 35.4697189331055, 0.619063380139661, -77.1194381713867, -1.34598811337889, 218, 33, 'PPL', 'P'),
(72778, 'Hackney', 39.6324996948242, 0.69171761047033, -81.6772232055664, -1.42553646882345, 218, 41, 'PPL', 'P'),
(162356, 'Hackney', 40.0316696166992, 0.698684439881978, -80.2180633544922, -1.4000693251093, 218, 45, 'PPL', 'P'),
(196651, 'Hackney', 46.0313911437988, 0.803399334732648, -112.79167175293, -1.96858604091731, 218, 31, 'PPL', 'P'),
(2922, 'Hackneyville', 33.0602798461914, 0.577010734946765, -85.9330596923828, -1.49981482794491, 218, 2, 'PPL', 'P'),
(47759, 'Hacks Point Acres', 39.4666709899902, 0.68882335357666, -75.8916702270508, -1.32455952029979, 218, 25, 'PPL', 'P'),
(102543, 'Hacksneck', 37.6430587768555, 0.656995316177877, -75.8708267211914, -1.32419573249488, 218, 53, 'PPL', 'P'),
(2923, 'Hacoda', 31.0747203826904, 0.54235618481454, -86.166389465332, -1.5038872007258, 218, 2, 'PPL', 'P'),
(141975, 'Hadar', 42.1049995422363, 0.734870873562729, -97.4488906860352, -1.70080399488735, 218, 35, 'PPL', 'P'),
(32657, 'Haddam', 39.8569412231445, 0.695634854117728, -97.3013916015625, -1.69822965021962, 218, 20, 'PPL', 'P'),
(112982, 'Haddam', 41.4772186279297, 0.723914029626898, -72.5124969482422, -1.26558182058917, 218, 8, 'PPL', 'P'),
(21666, 'Hadden', 33.2605590820313, 0.580506267035548, -82.4786071777344, -1.43952325771049, 218, 13, 'PPL', 'P'),
(81391, 'Hadden Crossroads', 34.935001373291, 0.609730798152669, -82.0033264160156, -1.43122804354711, 218, 48, 'PPL', 'P'),
(81395, 'Hadden Heights', 34.9358291625977, 0.609745245801583, -82.017219543457, -1.43147052436437, 218, 48, 'PPL', 'P'),
(41238, 'Haddens', 31.1861095428467, 0.544300292410298, -93.5330581665039, -1.63245982446486, 218, 22, 'PPL', 'P'),
(78415, 'Haddenville', 39.9294395446777, 0.696900188530652, -79.7713928222656, -1.39227345365031, 218, 45, 'PPL', 'P'),
(78416, 'Haddington', 39.9691696166992, 0.697593609099481, -75.2361068725586, -1.31311778130848, 218, 45, 'PPL', 'P'),
(36236, 'Haddix', 37.4872207641602, 0.654275429756579, -83.3483276367188, -1.45470274329173, 218, 21, 'PPL', 'P'),
(109512, 'Haddleton', 38.0444412231445, 0.664000761425331, -81.8305587768555, -1.42821267940287, 218, 58, 'PPL', 'P'),
(21667, 'Haddock', 33.0325012207031, 0.576525906470316, -83.4291687011719, -1.45611368603725, 218, 13, 'PPL', 'P'),
(81392, 'Haddock', 33.4819412231445, 0.584370114303089, -80.8969421386719, -1.41191799511517, 218, 48, 'PPL', 'P'),
(162357, 'Haddock', 40.8813896179199, 0.713514851623329, -76.0061111450195, -1.32655689111735, 218, 45, 'PPL', 'P'),
(2924, 'Haddock (historical)', 34.9883308410645, 0.610661572953652, -88.1558303833008, -1.53860949501825, 218, 2, 'PPL', 'P'),
(65299, 'Haddocks Crossroads', 35.4913902282715, 0.619441615593479, -77.3544387817383, -1.35008964777372, 218, 33, 'PPL', 'P'),
(70907, 'Haddon', 39.8974990844727, 0.696342722335471, -75.0963897705078, -1.31067925785635, 218, 37, 'PPL', 'P'),
(70908, 'Haddon Heights', 39.8772201538086, 0.6959887882266, -75.0650024414063, -1.31013144562012, 218, 37, 'PPL', 'P'),
(70910, 'Haddon Hills', 39.9000015258789, 0.696386398177348, -75.0527801513672, -1.30991812641681, 218, 37, 'PPL', 'P'),
(47760, 'Haddon Hurst', 39.5449981689453, 0.690190420743225, -76.4833297729492, -1.33488592742657, 218, 25, 'PPL', 'P'),
(70911, 'Haddon Leigh', 39.889720916748, 0.696206967698904, -75.0472183227539, -1.30982105419507, 218, 37, 'PPL', 'P'),
(70912, 'Haddon Towne', 39.8863906860352, 0.696148844208113, -75.0116729736328, -1.30920067081914, 218, 37, 'PPL', 'P'),
(70914, 'Haddonfield', 39.8913917541504, 0.696236129312841, -75.0380630493164, -1.30966126452967, 218, 37, 'PPL', 'P'),
(102544, 'Haddonfield', 37.1527786254883, 0.648438313279344, -82.6041717529297, -1.44171477297152, 218, 53, 'PPL', 'P'),
(21668, 'Haddonville', 32.434440612793, 0.566087779735805, -81.2302780151367, -1.4177358036745, 218, 13, 'PPL', 'P'),
(2925, 'Haden', 34.6891708374023, 0.605440245899469, -86.5047225952148, -1.50979222781083, 218, 2, 'PPL', 'P'),
(102550, 'Haden', 37.7163887023926, 0.658275164818742, -79.8341674804688, -1.39336907812277, 218, 53, 'PPL', 'P'),
(195041, 'Haden (historical)', 43.8250007629395, 0.76489055800232, -111.178886413574, -1.94043762661766, 218, 17, 'PPL', 'P'),
(36237, 'Hadensville', 36.670280456543, 0.640017131596404, -87.1311111450195, -1.52072477040172, 218, 21, 'PPL', 'P'),
(102545, 'Hadensville', 37.8252792358398, 0.66017566315165, -77.9997177124023, -1.36135188970756, 218, 53, 'PPL', 'P'),
(102546, 'Hadensville Estates', 37.8472213745117, 0.660558625716403, -77.9583282470703, -1.36062950726188, 218, 53, 'PPL', 'P'),
(102547, 'Hadensville Farms', 37.8355598449707, 0.660355093630094, -77.9611129760742, -1.36067810995177, 218, 53, 'PPL', 'P'),
(135747, 'Hader', 44.3655586242676, 0.774325072480035, -92.8008270263672, -1.61967998018385, 218, 28, 'PPL', 'P'),
(135748, 'Hadler', 47.3686103820801, 0.826738213261667, -96.5350036621094, -1.68485365732859, 218, 28, 'PPL', 'P'),
(29972, 'Hadley', 39.7313919067383, 0.693443605172811, -86.602783203125, -1.51150370828537, 218, 19, 'PPL', 'P'),
(36238, 'Hadley', 37.0597190856934, 0.646814117909532, -86.6069412231445, -1.51157627942508, 218, 21, 'PPL', 'P'),
(41239, 'Hadley', 32.398609161377, 0.565462402932827, -93.8072204589844, -1.63724485915346, 218, 22, 'PPL', 'P'),
(55127, 'Hadley', 37.0727806091309, 0.647042084498842, -90.7980575561523, -1.58472505877017, 218, 29, 'PPL', 'P'),
(65300, 'Hadley', 34.916389465332, 0.609405959078706, -77.7144393920898, -1.35637284373355, 218, 33, 'PPL', 'P'),
(119901, 'Hadley', 41.5708312988281, 0.725547878955662, -87.9438934326172, -1.53491049742219, 218, 18, 'PPL', 'P'),
(124990, 'Hadley', 42.3416709899902, 0.739001569571497, -72.5888900756836, -1.26691513218891, 218, 23, 'PPL', 'P'),
(131166, 'Hadley', 42.9544410705566, 0.749696425035091, -83.4033279418945, -1.45566267970665, 218, 27, 'PPL', 'P'),
(135749, 'Hadley', 44.0011100769043, 0.767964245374435, -95.8536071777344, -1.67296104516473, 218, 28, 'PPL', 'P'),
(143914, 'Hadley', 42.8347206115723, 0.747606908843815, -71.9883270263672, -1.25643332961253, 218, 36, 'PPL', 'P'),
(149368, 'Hadley', 43.3172187805176, 0.756028090526755, -73.8486099243164, -1.28890139120028, 218, 40, 'PPL', 'P'),
(162358, 'Hadley', 41.413890838623, 0.722808751195488, -80.2333297729492, -1.40033577437636, 218, 45, 'PPL', 'P'),
(186811, 'Hadley', 38.038330078125, 0.663894101823673, -103.402778625488, -1.80471894272559, 218, 7, 'PPL', 'P'),
(190288, 'Hadley', 38.6944389343262, 0.675345361615878, -117.159439086914, -2.04481796185639, 218, 39, 'PPL', 'P'),
(207575, 'Hadley', 46.1769409179688, 0.805939657517447, -118.38166809082, -2.06614988218792, 218, 56, 'PPL', 'P'),
(209965, 'Hadley', 55.5347213745117, 0.9692637371629, -132.286666870117, -2.30883789337245, 218, 1, 'PPL', 'P'),
(149369, 'Hadley Bay', 42.1494407653809, 0.735646519230215, -79.4027786254883, -1.38583992224695, 218, 40, 'PPL', 'P'),
(47761, 'Hadley Farms', 39.1830596923828, 0.683873402637557, -77.1569366455078, -1.34664258521678, 218, 25, 'PPL', 'P'),
(200931, 'Hadleyville', 43.9702796936035, 0.767426153676185, -123.318061828613, -2.15230620608724, 218, 43, 'PPL', 'P'),
(102548, 'Hadlock', 37.5175018310547, 0.654803934074906, -75.8338928222656, -1.32355111435303, 218, 53, 'PPL', 'P'),
(113513, 'Hadlyme', 41.420280456543, 0.722920271066135, -72.4069366455078, -1.26373944574705, 218, 8, 'PPL', 'P'),
(55129, 'Hadsell', 38.6983299255371, 0.675413272223675, -94.1366729736328, -1.64299489026305, 218, 29, 'PPL', 'P'),
(94681, 'Haeckerville', 29.5616703033447, 0.515948479182396, -98.2169418334961, -1.71420901623426, 218, 51, 'PPL', 'P'),
(119892, 'Haegers Bend', 42.1888885498047, 0.736335012951028, -88.2605590820313, -1.54043735563243, 218, 18, 'PPL', 'P'),
(174382, 'Haevers Corners', 44.5127792358398, 0.776894556878771, -87.977783203125, -1.53550198550029, 218, 57, 'PPL', 'P'),
(190289, 'Hafed', 39.514720916748, 0.689661983003926, -119.629440307617, -2.08792761568594, 218, 39, 'PPL', 'P'),
(27355, 'Hagaman', 39.3102798461914, 0.68609381319641, -90.0780563354492, -1.57215866685053, 218, 18, 'PPL', 'P'),
(149375, 'Hagaman', 42.9744415283203, 0.750045498874973, -74.1513900756836, -1.29418590175133, 218, 40, 'PPL', 'P'),
(21669, 'Hagan', 32.1558303833008, 0.561225113901429, -81.9338912963867, -1.43001617209307, 218, 13, 'PPL', 'P'),
(81393, 'Hagan', 33.0572204589844, 0.576957338566908, -79.9091720581055, -1.39467815495659, 218, 48, 'PPL', 'P'),
(102549, 'Hagan', 36.7041702270508, 0.640608619674511, -83.2866668701172, -1.45362655989523, 218, 53, 'PPL', 'P'),
(135752, 'Hagan', 45.148609161377, 0.787991882562104, -95.7758331298828, -1.67160363195712, 218, 28, 'PPL', 'P'),
(188652, 'Hagan (historical)', 35.3172187805176, 0.616401750367208, -106.313331604004, -1.85551767525441, 218, 38, 'PPL', 'P'),
(155577, 'Hagan Addition', 40.2147216796875, 0.701879301083691, -80.8847198486328, -1.41170467591185, 218, 41, 'PPL', 'P'),
(81394, 'Hagan Landing', 33.0608291625977, 0.577020322326689, -79.9161071777344, -1.39479919562814, 218, 48, 'PPL', 'P'),
(109510, 'Hagans', 39.6202812194824, 0.691504357846042, -80.1297225952148, -1.39852748799619, 218, 58, 'PPL', 'P'),
(196652, 'Hagans Crossing', 48.4583282470703, 0.845757377923549, -112.513328552246, -1.96372803561484, 218, 31, 'PPL', 'P'),
(94682, 'Hagansport', 33.3413887023926, 0.58191701004399, -95.2491683959961, -1.66241159829666, 218, 51, 'PPL', 'P'),
(27356, 'Hagarstown', 38.9433288574219, 0.679689310248933, -89.168327331543, -1.55628090043147, 218, 18, 'PPL', 'P'),
(9283, 'Hagarville', 35.5155601501465, 0.619863460310148, -93.3247222900391, -1.62882367747052, 218, 4, 'PPL', 'P'),
(149372, 'Hagedorns Mills', 43.0761108398438, 0.751819963109293, -74.1002807617188, -1.2932938759442, 218, 40, 'PPL', 'P'),
(72779, 'Hageman', 39.3899993896484, 0.687485181707922, -84.2649993896484, -1.47070168354038, 218, 41, 'PPL', 'P'),
(155578, 'Hageman (historical)', 40.2083282470703, 0.701767714634017, -84.0777816772461, -1.4674341180409, 218, 41, 'PPL', 'P'),
(41240, 'Hagen (historical)', 31.8555603027344, 0.555984412350316, -93.0708312988281, -1.62439244373274, 218, 22, 'PPL', 'P'),
(155579, 'Hagenbaugh (historical)', 40.1513900756836, 0.700773956073254, -83.6922225952148, -1.46070484259849, 218, 41, 'PPL', 'P'),
(27359, 'Hagener', 39.9258308410645, 0.696837204770872, -90.397216796875, -1.57772906774459, 218, 18, 'PPL', 'P'),
(131169, 'Hagensville', 45.3333282470703, 0.791215838798726, -83.7819366455078, -1.4622706481614, 218, 27, 'PPL', 'P'),
(36239, 'Hager', 37.7463912963867, 0.658798808868079, -83.1994400024414, -1.45210416385808, 218, 21, 'PPL', 'P'),
(109511, 'Hager', 38.2144393920898, 0.666967789195788, -82.0869369506836, -1.43268732266642, 218, 58, 'PPL', 'P'),
(200932, 'Hager', 42.1913909912109, 0.736378688792905, -121.699172973633, -2.12405126534399, 218, 43, 'PPL', 'P'),
(174389, 'Hager City', 44.6016693115234, 0.778445981371796, -92.5380630493164, -1.61509388362868, 218, 57, 'PPL', 'P'),
(36240, 'Hagerhill', 37.7861099243164, 0.659492029699827, -82.7936096191406, -1.44502108746485, 218, 21, 'PPL', 'P'),
(149373, 'Hagerman', 40.7705612182617, 0.711580531144577, -72.9644393920898, -1.27346970426382, 218, 40, 'PPL', 'P'),
(188653, 'Hagerman', 33.1150016784668, 0.577965811092694, -104.326393127441, -1.82083905680384, 218, 38, 'PPL', 'P'),
(195042, 'Hagerman', 42.8122215270996, 0.747214225741083, -114.89778137207, -2.00534458817924, 218, 17, 'PPL', 'P'),
(188654, 'Hagerman Heights', 32.4161109924316, 0.565767867509859, -104.220832824707, -1.81899668196172, 218, 38, 'PPL', 'P'),
(162359, 'Hagero', 40.1813888549805, 0.701297533543564, -78.8141708374023, -1.37556677834197, 218, 45, 'PPL', 'P'),
(55130, 'Hagers Grove', 39.8311080932617, 0.695183980945178, -92.2230606079102, -1.60959605387432, 218, 29, 'PPL', 'P'),
(29973, 'Hagerstown', 39.9111099243164, 0.696580276304706, -85.1616668701172, -1.48635148337012, 218, 19, 'PPL', 'P'),
(47762, 'Hagerstown', 39.6416702270508, 0.691877666451844, -77.7202835083008, -1.3564748428033, 218, 25, 'PPL', 'P'),
(162360, 'Hagersville', 40.4069404602051, 0.705234151687891, -75.2505569458008, -1.31336998266371, 218, 45, 'PPL', 'P'),
(115898, 'Hagerty', 41.0769386291504, 0.71692782571832, -92.8600006103516, -1.62071275405458, 218, 16, 'PPL', 'P'),
(72780, 'Hagerty (historical)', 39.6688919067383, 0.692352774390314, -82.9572219848633, -1.44787666194369, 218, 41, 'PPL', 'P'),
(70916, 'Hagerville', 39.5333290100098, 0.689986755498861, -75.466667175293, -1.31714181771559, 218, 37, 'PPL', 'P'),
(94683, 'Hagerville', 31.3444404602051, 0.547063688225905, -95.0811080932617, -1.65947839267204, 218, 51, 'PPL', 'P'),
(41241, 'Hagewood', 31.7150001525879, 0.553531174933163, -93.2149963378906, -1.62690859833065, 218, 22, 'PPL', 'P'),
(187699, 'Haggard', 37.6344413757324, 0.656844914155315, -100.319999694824, -1.75091430027439, 218, 20, 'PPL', 'P'),
(124992, 'Haggetts', 42.6433296203613, 0.744266505888529, -71.2077789306641, -1.24281019537233, 218, 23, 'PPL', 'P'),
(181976, 'Hagginwood', 38.627498626709, 0.67417703284566, -121.43138885498, -2.11937755078896, 218, 6, 'PPL', 'P'),
(2926, 'Hagler', 33.0338897705078, 0.576550141236235, -87.3399963378906, -1.52437050477598, 218, 2, 'PPL', 'P'),
(9284, 'Hagler', 34.2541694641113, 0.597848039684844, -91.5280609130859, -1.59746602089928, 218, 4, 'PPL', 'P'),
(72781, 'Hagler', 39.5880584716797, 0.690941964802845, -83.5138931274414, -1.45759240623252, 218, 41, 'PPL', 'P'),
(87516, 'Haglerville (historical)', 36.1672210693359, 0.631237088956576, -88.345832824707, -1.54192566320762, 218, 50, 'PPL', 'P'),
(81396, 'Hagley Estates', 33.4311103820801, 0.583482948764957, -79.1647186279297, -1.38168499147226, 218, 48, 'PPL', 'P'),
(122748, 'Haglund', 41.6124992370605, 0.726275121670335, -87.1158294677734, -1.52045805481855, 218, 19, 'PPL', 'P'),
(81397, 'Hagood', 34.0569381713867, 0.594405704238835, -80.5719375610352, -1.40624559515135, 218, 48, 'PPL', 'P'),
(102551, 'Hagood', 36.6472206115723, 0.639614661376666, -78.1177825927734, -1.36341251060101, 218, 53, 'PPL', 'P'),
(81398, 'Hagoods Mill', 33.2133293151855, 0.579681952099141, -81.3147201538086, -1.41920959702175, 218, 48, 'PPL', 'P'),
(16318, 'Hague', 29.7702808380127, 0.519589419866698, -82.42138671875, -1.43852457230171, 218, 12, 'PPL', 'P'),
(102552, 'Hague', 38.0722198486328, 0.66448558990178, -76.6513900756836, -1.33781913305118, 218, 53, 'PPL', 'P'),
(140157, 'Hague', 46.0286102294922, 0.803350798621781, -99.9952774047852, -1.74524682715859, 218, 34, 'PPL', 'P'),
(149374, 'Hague', 43.7452812194824, 0.763499189490809, -73.498893737793, -1.28279769229793, 218, 40, 'PPL', 'P'),
(149377, 'Hague Crossing', 44.7277793884277, 0.78064701743372, -75.2355575561523, -1.31310819392856, 218, 40, 'PPL', 'P'),
(87517, 'Hagys Corner', 35.4038887023926, 0.617914425866373, -89.7666702270508, -1.566723954014, 218, 50, 'PPL', 'P'),
(55131, 'Hahatonka', 37.9730606079102, 0.662754934667392, -92.7688903808594, -1.61912258056769, 218, 29, 'PPL', 'P'),
(21670, 'Hahira', 30.9911098480225, 0.540896905695231, -83.3727798461914, -1.45512951485641, 218, 13, 'PPL', 'P'),
(55132, 'Hahn', 37.2052803039551, 0.649354640431413, -90.0697174072266, -1.57201312509695, 218, 29, 'PPL', 'P'),
(94684, 'Hahn', 29.2811107635498, 0.511051791465095, -96.3966674804688, -1.68243923548433, 218, 51, 'PPL', 'P'),
(188655, 'Hahn', 35.1305618286133, 0.613143971984742, -106.634170532227, -1.86111737092047, 218, 38, 'PPL', 'P'),
(195043, 'Hahn', 44.3722190856934, 0.774441319461617, -113.216667175293, -1.97600361034345, 218, 17, 'PPL', 'P'),
(119893, 'Hahnaman', 41.6316719055176, 0.726609747861303, -89.6350021362305, -1.56442591230937, 218, 18, 'PPL', 'P'),
(47764, 'Hahns Mill', 39.6794395446777, 0.692536865400666, -77.0899963378906, -1.34547425644656, 218, 25, 'PPL', 'P'),
(55133, 'Hahns Mill', 37.5586090087891, 0.655521389672573, -90.1549987792969, -1.5735015658302, 218, 29, 'PPL', 'P'),
(162361, 'Hahnstown', 40.1711082458496, 0.701118103065119, -76.123893737793, -1.32861258516278, 218, 45, 'PPL', 'P'),
(162362, 'Hahntown', 40.3183288574219, 0.703687587463855, -79.7186126708984, -1.39135226622925, 218, 45, 'PPL', 'P'),
(41243, 'Hahnville', 29.976390838623, 0.523186717998636, -90.4088897705078, -1.57793279956798, 218, 22, 'PPL', 'P'),
(9285, 'Haig', 34.8188896179199, 0.607704265721173, -92.3163909912109, -1.61122497635506, 218, 4, 'PPL', 'P'),
(199368, 'Haig', 41.8794403076172, 0.730934122260347, -103.758613586426, -1.81092943438765, 218, 35, 'PPL', 'P'),
(47763, 'Haight', 39.4097213745117, 0.687829395278815, -76.9022216796875, -1.34219697040911, 218, 25, 'PPL', 'P'),
(181977, 'Haight', 38.0927810668945, 0.664844450858668, -121.241943359375, -2.11607110313757, 218, 6, 'PPL', 'P'),
(199369, 'Haigler', 40.0138893127441, 0.698374115035956, -101.938888549805, -1.77916924101764, 218, 35, 'PPL', 'P'),
(87518, 'Haigler Ridge', 36.2688903808594, 0.633011553190896, -88.1302795410156, -1.53816354869372, 218, 50, 'PPL', 'P'),
(211344, 'Haiku', 20.9174995422363, 0.365079238296431, -156.325836181641, -2.72840054730291, 218, 15, 'PPL', 'P'),
(36241, 'Hail', 36.9941711425781, 0.645670090484261, -84.4636077880859, -1.47416805401522, 218, 21, 'PPL', 'P'),
(94685, 'Hail', 33.5008316040039, 0.584699813646041, -96.0572204589844, -1.67651476732334, 218, 51, 'PPL', 'P'),
(16319, 'Haile', 29.6902809143066, 0.518193157796683, -82.5736083984375, -1.44118134180518, 218, 12, 'PPL', 'P'),
(41242, 'Haile', 32.8308296203613, 0.573006073036585, -92.146110534668, -1.60825302173659, 218, 22, 'PPL', 'P'),
(149378, 'Hailesboro', 44.310001373291, 0.773355415527137, -75.4466705322266, -1.31679281045474, 218, 40, 'PPL', 'P'),
(55134, 'Hailey', 36.7108306884766, 0.640724866656093, -93.7072219848633, -1.63549955653308, 218, 29, 'PPL', 'P'),
(195044, 'Hailey', 43.519718170166, 0.759562371609399, -114.314437866211, -1.99516332333186, 218, 17, 'PPL', 'P'),
(76003, 'Haileyville', 34.8544387817383, 0.608324715676134, -95.5819396972656, -1.66821955315996, 218, 42, 'PPL', 'P'),
(204195, 'Hailstone', 40.6083297729492, 0.708749058273605, -111.409439086914, -1.94446152986672, 218, 52, 'PPL', 'P'),
(36242, 'Hailwell', 36.6763916015625, 0.640123791198062, -89.105827331543, -1.55519006964898, 218, 21, 'PPL', 'P'),
(211349, 'Haina', 20.0961093902588, 0.350743275700966, -155.471939086914, -2.71349723152672, 218, 15, 'PPL', 'P'),
(162364, 'Haines', 40.5705604553223, 0.708089859324783, -75.616943359375, -1.31976463191516, 218, 45, 'PPL', 'P'),
(181979, 'Haines', 34.3247184753418, 0.599079352214842, -119.101936340332, -2.07872093463948, 218, 6, 'PPL', 'P'),
(200933, 'Haines', 44.9116706848145, 0.783856526021429, -117.937782287598, -2.05840261341883, 218, 43, 'PPL', 'P'),
(209971, 'Haines', 59.2358283996582, 1.0338602407204, -135.445007324219, -2.36396133319545, 218, 1, 'PPL', 'P'),
(112513, 'Haines Acres', 39.9644393920898, 0.697511051105689, -76.6727828979492, -1.33819250823601, 218, 45, 'PPL', 'P'),
(16320, 'Haines City', 28.1138896942139, 0.490679940706534, -81.6180572509766, -1.42450382811077, 218, 12, 'PPL', 'P'),
(127658, 'Haines Corner', 44.4222183227539, 0.775313970771809, -70.1447219848633, -1.22425635153192, 218, 26, 'PPL', 'P'),
(145344, 'Haines Corner', 40.2058296203613, 0.701724105371167, -74.6511077880859, -1.30290762116328, 218, 37, 'PPL', 'P'),
(149379, 'Haines Corners', 41.4736099243164, 0.723851045867118, -73.5824966430664, -1.28425683825918, 218, 40, 'PPL', 'P'),
(149380, 'Haines Falls', 42.1958312988281, 0.736456186780626, -74.0975036621094, -1.29324540641236, 218, 40, 'PPL', 'P'),
(145345, 'Hainesburg', 40.9550018310547, 0.714799627112211, -75.0616683959961, -1.3100732555503, 218, 37, 'PPL', 'P'),
(70918, 'Hainesport', 39.9836082458496, 0.69784561071763, -74.8274993896484, -1.30598623538341, 218, 37, 'PPL', 'P'),
(94686, 'Hainesville', 32.7174987792969, 0.571028076715956, -95.3641662597656, -1.6644186896522, 218, 51, 'PPL', 'P'),
(109513, 'Hainesville', 39.5263900756836, 0.689865648248289, -77.9197235107422, -1.35995572750609, 218, 58, 'PPL', 'P'),
(119895, 'Hainesville', 42.3450012207031, 0.739059693062288, -88.0677795410156, -1.53707271791122, 218, 18, 'PPL', 'P'),
(145346, 'Hainesville', 41.2519416809082, 0.719982205172532, -74.8033294677734, -1.30556439066674, 218, 37, 'PPL', 'P'),
(16321, 'Hainesworth', 29.8194408416748, 0.520447423790894, -82.4447174072266, -1.43893176963239, 218, 12, 'PPL', 'P'),
(65303, 'Hairtown', 35.2786102294922, 0.615727904032391, -78.9869384765625, -1.37858214248621, 218, 33, 'PPL', 'P'),
(178321, 'Haivan Vaya', 31.6097202301025, 0.551693693649549, -111.872779846191, -1.9525483516748, 218, 5, 'PPL', 'P'),
(178322, 'Haivana Nakya', 32.0066719055176, 0.558621807356849, -111.71305847168, -1.94976068780376, 218, 5, 'PPL', 'P'),
(181980, 'Haiwee', 36.146671295166, 0.63087842773677, -117.974998474121, -2.0590521584087, 218, 6, 'PPL', 'P'),
(211351, 'Hakalau', 19.8997192382813, 0.347315620930466, -155.129165649414, -2.70751470645396, 218, 15, 'PPL', 'P'),
(155581, 'Hakes Corners', 41.1966705322266, 0.719017541646678, -80.728889465332, -1.40898492264861, 218, 41, 'PPL', 'P'),
(211360, 'Halaula', 20.2374992370605, 0.353210994056547, -155.780563354492, -2.71888374114751, 218, 15, 'PPL', 'P'),
(211685, 'Halawa', 20.2269401550293, 0.353026703309114, -155.768325805664, -2.71867015562809, 218, 15, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(2928, 'Halawaka', 32.6644401550293, 0.570102029025908, -85.17138671875, -1.48652112673156, 218, 2, 'PPL', 'P'),
(70920, 'Halberton', 39.2955589294434, 0.685836884730245, -74.9094390869141, -1.30741635288879, 218, 37, 'PPL', 'P'),
(115899, 'Halbur', 42.0069389343262, 0.73315939308819, -94.9697189331055, -1.65753428507629, 218, 16, 'PPL', 'P'),
(192603, 'Halchita', 37.1258316040039, 0.647967999030836, -109.88777923584, -1.91790355537006, 218, 52, 'PPL', 'P'),
(36243, 'Halcom', 38.0758285522461, 0.66454857366156, -82.966667175293, -1.44804151161517, 218, 21, 'PPL', 'P'),
(181981, 'Halcon', 33.827220916748, 0.590396381796748, -118.027496337891, -2.05996841898174, 218, 6, 'PPL', 'P'),
(149381, 'Halcott Center', 42.1883316040039, 0.736325292413049, -74.4916687011719, -1.30012488414026, 218, 40, 'PPL', 'P'),
(149383, 'Halcottsville', 42.2083282470703, 0.736674299673904, -74.6013870239258, -1.30203983012208, 218, 40, 'PPL', 'P'),
(55135, 'Halcyon', 37.476390838623, 0.654086411898211, -91.3827819824219, -1.59493042522541, 218, 29, 'PPL', 'P'),
(109514, 'Halcyon', 37.9797210693359, 0.662871181648974, -82.0938873291016, -1.43280862965408, 218, 58, 'PPL', 'P'),
(181982, 'Halcyon', 35.103328704834, 0.61266866430919, -120.594718933105, -2.10477490589983, 218, 6, 'PPL', 'P'),
(41244, 'Halcyon (historical)', 31.9400005340576, 0.557458172408053, -93.716667175293, -1.63566440620456, 218, 22, 'PPL', 'P'),
(21671, 'Halcyon Bluff', 31.9797191619873, 0.5581513932398, -81.1094436645508, -1.41562684640727, 218, 13, 'PPL', 'P'),
(47765, 'Halcyon Gate', 39.4008293151855, 0.68767419956629, -76.6969375610352, -1.33861408663657, 218, 25, 'PPL', 'P'),
(21672, 'Halcyondale', 32.538890838623, 0.567910780080991, -81.5983276367188, -1.42415948138183, 218, 13, 'PPL', 'P'),
(119896, 'Haldane', 42.0625, 0.734129116620115, -89.5738906860352, -1.5633593162928, 218, 18, 'PPL', 'P'),
(36244, 'Haldeman', 38.2527809143066, 0.667636974998698, -83.3186111450195, -1.45418409266943, 218, 21, 'PPL', 'P'),
(174383, 'Halder', 44.7991714477539, 0.78189304392874, -89.8705596923828, -1.56853716724218, 218, 57, 'PPL', 'P'),
(32661, 'Hale', 37.2347183227539, 0.649868430784716, -96.0547180175781, -1.67647109148146, 218, 20, 'PPL', 'P'),
(55136, 'Hale', 39.6036109924316, 0.691213407496951, -93.3422164916992, -1.6291290088895, 218, 29, 'PPL', 'P'),
(60149, 'Hale', 31.9636096954346, 0.557870230007715, -88.7755584716797, -1.54942579062756, 218, 30, 'PPL', 'P'),
(81399, 'Hale', 34.8269386291504, 0.607844747468675, -82.5391693115234, -1.44058026634715, 218, 48, 'PPL', 'P'),
(87520, 'Hale', 36.3188896179199, 0.633884204501088, -82.4669418334961, -1.43931965904516, 218, 50, 'PPL', 'P'),
(115900, 'Hale', 42.0125007629395, 0.733256465309923, -91.0591735839844, -1.58928239318557, 218, 16, 'PPL', 'P'),
(127659, 'Hale', 44.5900001525879, 0.778242316127433, -70.5619430541992, -1.23153823290052, 218, 26, 'PPL', 'P'),
(131171, 'Hale', 44.3777809143066, 0.77453839168335, -83.8047180175781, -1.46266825811215, 218, 27, 'PPL', 'P'),
(162365, 'Hale', 40.7886085510254, 0.711895516522507, -78.3447189331055, -1.36737329693223, 218, 45, 'PPL', 'P'),
(174384, 'Hale', 44.4658317565918, 0.776075168790381, -91.2622222900391, -1.59282626164814, 218, 57, 'PPL', 'P'),
(186812, 'Hale', 39.6297187805176, 0.691669074359464, -102.142219543457, -1.78271803632822, 218, 7, 'PPL', 'P'),
(2930, 'Hale (historical)', 34.0927810668945, 0.595031280778895, -85.8272171020508, -1.49796752625477, 218, 2, 'PPL', 'P'),
(9286, 'Hale (historical)', 35.6366691589355, 0.621977211267344, -91.0911102294922, -1.58983979280173, 218, 4, 'PPL', 'P'),
(191573, 'Hale Center', 34.0641708374023, 0.594531938074505, -101.843330383301, -1.77750143638498, 218, 51, 'PPL', 'P'),
(191574, 'Hale City (historical)', 34.092830657959, 0.595032146306249, -101.871658325195, -1.77799585224135, 218, 51, 'PPL', 'P'),
(174385, 'Hale Corner', 44.6616706848145, 0.779493202891443, -91.2763900756836, -1.59307353615536, 218, 57, 'PPL', 'P'),
(113514, 'Hale Court', 41.1213912963867, 0.717703671122888, -73.3513870239258, -1.28022321447215, 218, 8, 'PPL', 'P'),
(102553, 'Hale Creek', 37.2611083984375, 0.650329024495246, -81.9427795410156, -1.43017130122657, 218, 53, 'PPL', 'P'),
(55137, 'Hale Crossing', 36.8822212219238, 0.643716195771497, -92.1872177124023, -1.60897047733426, 218, 29, 'PPL', 'P'),
(149384, 'Hale Eddy', 42.0036087036133, 0.733101269597399, -75.3833312988281, -1.31568733228624, 218, 40, 'PPL', 'P'),
(87527, 'Hale Mill', 35.8408317565918, 0.62554052080587, -85.1372222900391, -1.48592484496349, 218, 50, 'PPL', 'P'),
(149385, 'Hale Mills', 43.0194396972656, 0.750830865080438, -74.3344421386719, -1.29738076295304, 218, 40, 'PPL', 'P'),
(211367, 'Hale Pili', 19.6291694641113, 0.342593636580674, -155.870559692383, -2.72045447355844, 218, 15, 'PPL', 'P'),
(181983, 'Hale Place', 38.5083312988281, 0.672097170613335, -123.03556060791, -2.14737562964507, 218, 6, 'PPL', 'P'),
(196653, 'Hale Place', 45.1091690063477, 0.787303521999346, -112.117500305176, -1.95681952943106, 218, 31, 'PPL', 'P'),
(119897, 'Hale Ridge (historical)', 40.1800003051758, 0.701273298777644, -90.6463928222656, -1.58207800980469, 218, 18, 'PPL', 'P'),
(211372, 'HaleÃ‚â€˜iwa', 21.5902805328369, 0.37682148172724, -158.112503051758, -2.75958376682276, 218, 15, 'PPL', 'P'),
(2932, 'Haleburg', 31.4063892364502, 0.548144898338964, -85.1372222900391, -1.48592484496349, 218, 2, 'PPL', 'P'),
(145362, 'Haledon', 40.9355583190918, 0.714460273810307, -74.1866683959961, -1.29480162459535, 218, 37, 'PPL', 'P'),
(162366, 'Haleeka', 41.3291702270508, 0.721330097579249, -77.0875015258789, -1.34543071376274, 218, 45, 'PPL', 'P'),
(102554, 'Haleford (historical)', 37.1458282470703, 0.648317006291691, -79.6658325195313, -1.39043107880819, 218, 53, 'PPL', 'P'),
(211373, 'Halehomaha', 22.225830078125, 0.38791391385207, -159.549713134766, -2.7846678148141, 218, 15, 'PPL', 'P'),
(204193, 'Halelani', 40.6166687011719, 0.708894600027178, -111.881942749023, -1.95270827449825, 218, 52, 'PPL', 'P'),
(204194, 'Halelea', 40.6136093139648, 0.708841203647322, -111.873062133789, -1.95255327852281, 218, 52, 'PPL', 'P'),
(102555, 'Halemhurst', 38.8413887023926, 0.677910118903678, -77.2969436645508, -1.34908616867498, 218, 53, 'PPL', 'P'),
(211391, 'Halepiula', 19.9311103820801, 0.347863499745722, -155.394439697266, -2.71214461200907, 218, 15, 'PPL', 'P'),
(102556, 'Hales Bottom', 37.2655601501465, 0.650406722220049, -81.2958297729492, -1.4188798976788, 218, 53, 'PPL', 'P'),
(87521, 'Hales Camp', 35.9961090087891, 0.628250620110162, -86.4925003051758, -1.50957890860752, 218, 50, 'PPL', 'P'),
(127660, 'Hales Corner', 44.663330078125, 0.779522164768298, -69.2569427490234, -1.20876168083567, 218, 26, 'PPL', 'P'),
(174387, 'Hales Corners', 42.9375, 0.749400747575065, -88.0486068725586, -1.53673809172025, 218, 57, 'PPL', 'P'),
(72782, 'Hales Creek', 38.8111114501953, 0.677381681164379, -82.6755599975586, -1.44296073288751, 218, 41, 'PPL', 'P'),
(124993, 'Hales Crossing', 42.6541709899902, 0.744455723483979, -72.5644378662109, -1.26648836062423, 218, 23, 'PPL', 'P'),
(937, 'Hales Crossroads', 36.1441688537598, 0.630834751894893, -83.2544403076172, -1.453064100273, 218, 50, 'PPL', 'P'),
(102557, 'Hales Ford (historical)', 37.1266708374023, 0.647982646416831, -79.6997222900391, -1.3910225668863, 218, 53, 'PPL', 'P'),
(181984, 'Hales Grove', 39.8177795410156, 0.694951353823959, -123.781112670898, -2.16038796788925, 218, 6, 'PPL', 'P'),
(87522, 'Hales Point', 35.9099998474121, 0.626747731728003, -89.6269378662109, -1.56428516424576, 218, 50, 'PPL', 'P'),
(94687, 'Halesboro', 33.4619407653809, 0.584021040463207, -95.3030624389648, -1.66335222679367, 218, 51, 'PPL', 'P'),
(9288, 'Haleside', 34.7177810668945, 0.605939588603859, -90.6552810668945, -1.58223313893819, 218, 4, 'PPL', 'P'),
(149386, 'Halesite', 40.8883285522461, 0.713635958873901, -73.4158325195313, -1.28134800055854, 218, 40, 'PPL', 'P'),
(47767, 'Halethorpe', 39.2397193908691, 0.68486230092933, -76.6805572509766, -1.33832819629355, 218, 25, 'PPL', 'P'),
(47768, 'Haletown', 39.5966682434082, 0.691092233667353, -76.7563934326172, -1.33965178735532, 218, 25, 'PPL', 'P'),
(87523, 'Haletown', 35.0283317565918, 0.611359720633416, -85.538330078125, -1.49292549652098, 218, 50, 'PPL', 'P'),
(109515, 'Haleville', 39.0486106872559, 0.681526824822061, -80.4625015258789, -1.40433557601755, 218, 58, 'PPL', 'P'),
(87524, 'Haleville (historical)', 35.9752807617188, 0.627887098621366, -85.9844436645508, -1.50071164744199, 218, 50, 'PPL', 'P'),
(87525, 'Halewood Hills', 35.9366683959961, 0.627213185707521, -86.4727783203125, -1.50923469503662, 218, 50, 'PPL', 'P'),
(87526, 'Haley', 35.4883308410645, 0.619388219213623, -86.3108291625977, -1.50640814901367, 218, 50, 'PPL', 'P'),
(113125, 'Haley', 47.9211082458496, 0.83638112009468, -92.7324981689453, -1.61848741664771, 218, 28, 'PPL', 'P'),
(115902, 'Haley', 41.9061088562012, 0.731399576239865, -95.5561065673828, -1.66776867998741, 218, 16, 'PPL', 'P'),
(195045, 'Haley', 46.4952812194824, 0.811495743920652, -115.924438476563, -2.02326313494162, 218, 17, 'PPL', 'P'),
(198379, 'Haley', 45.9613914489746, 0.802177609582574, -103.11888885498, -1.79976413151749, 218, 34, 'PPL', 'P'),
(196654, 'Haley Subdivision Trailer Court', 45.6111106872559, 0.796064056984188, -111.179168701172, -1.94044255346568, 218, 31, 'PPL', 'P'),
(102558, 'Haleys Corner', 37.8480606079102, 0.660573273102399, -77.3694381713867, -1.35035143650888, 218, 53, 'PPL', 'P'),
(87528, 'Haleys Grove', 35.9097213745117, 0.626742871459013, -84.8916702270508, -1.48163915297928, 218, 50, 'PPL', 'P'),
(36245, 'Haleys Mill', 37.0530586242676, 0.64669787092795, -87.3469390869141, -1.52449167860558, 218, 21, 'PPL', 'P'),
(29974, 'Haleysbury', 38.7419395446777, 0.676174403663219, -86.1508331298828, -1.50361569145267, 218, 19, 'PPL', 'P'),
(2933, 'Haleyville', 34.226390838623, 0.597363211208395, -87.6213912963867, -1.52928177330025, 218, 2, 'PPL', 'P'),
(70921, 'Haleyville', 39.2894401550293, 0.685730091970533, -75.017219543457, -1.30929747672476, 218, 37, 'PPL', 'P'),
(2934, 'Half Acre', 32.1944389343262, 0.561898960236246, -87.9122161865234, -1.53435762517989, 218, 2, 'PPL', 'P'),
(87529, 'Half Acre', 35.8680610656738, 0.626015761902394, -85.9222183227539, -1.49962561034946, 218, 50, 'PPL', 'P'),
(145349, 'Half Acre', 40.3205604553223, 0.703726536194798, -74.4527816772461, -1.29944617753645, 218, 37, 'PPL', 'P'),
(149387, 'Half Acre', 42.9166717529297, 0.749037226086269, -76.625, -1.33735853934066, 218, 40, 'PPL', 'P'),
(76005, 'Half Bank Crossing', 34.3530616760254, 0.599574034387325, -96.0052795410156, -1.67560822728827, 218, 42, 'PPL', 'P'),
(2936, 'Half Chance', 32.2997207641602, 0.563736474809374, -87.727783203125, -1.53113866237031, 218, 2, 'PPL', 'P'),
(119899, 'Half Day', 42.2011108398438, 0.736548332154343, -87.9333267211914, -1.5347260735167, 218, 18, 'PPL', 'P'),
(162367, 'Half Falls', 40.4886093139648, 0.706659542082329, -76.9519424438477, -1.34306476145031, 218, 45, 'PPL', 'P'),
(65304, 'Half Hell', 34.0402793884277, 0.594114953626826, -78.1555633544922, -1.36407190928691, 218, 33, 'PPL', 'P'),
(149388, 'Half Hollow', 40.7763900756836, 0.711682263898219, -73.3436126708984, -1.28008752641461, 218, 40, 'PPL', 'P'),
(9290, 'Half Moon', 35.7597198486328, 0.624124850949411, -92.4261093139648, -1.61313992233688, 218, 4, 'PPL', 'P'),
(16322, 'Half Moon', 29.5988903045654, 0.516598090751294, -82.5716705322266, -1.44114751965933, 218, 12, 'PPL', 'P'),
(65305, 'Half Moon', 34.8258285522461, 0.607825372971744, -77.459716796875, -1.35192709576782, 218, 33, 'PPL', 'P'),
(81400, 'Half Moon (historical)', 33.8499984741211, 0.59079392516847, -79.5458297729492, -1.3883366357689, 218, 48, 'PPL', 'P'),
(181986, 'Half Moon Bay', 37.4636116027832, 0.653863372156917, -122.42749786377, -2.1367629327011, 218, 6, 'PPL', 'P'),
(65306, 'Half Moon Heights', 34.8172187805176, 0.607675104107237, -77.4527816772461, -1.35180605509628, 218, 33, 'PPL', 'P'),
(196655, 'Half Moon Mobile Home Park', 48.3847198486328, 0.844472669013695, -114.245826721191, -1.99396583294771, 218, 31, 'PPL', 'P'),
(87530, 'Half Moon Shores', 35.728889465332, 0.62358675925116, -84.6694412231445, -1.47776052516769, 218, 50, 'PPL', 'P'),
(32660, 'Half Mound', 39.4058303833008, 0.687761484671018, -95.4972229003906, -1.66674096612275, 218, 20, 'PPL', 'P'),
(139203, 'Half Rock', 40.2730598449707, 0.702897494147456, -93.4355621337891, -1.63075819768636, 218, 29, 'PPL', 'P'),
(109516, 'Half Way', 37.7313919067383, 0.658537020132924, -80.5902786254883, -1.40656570711438, 218, 58, 'PPL', 'P'),
(162368, 'Half Way House', 40.2849998474121, 0.703105886502755, -75.64111328125, -1.32018647663182, 218, 45, 'PPL', 'P'),
(115903, 'Halfa', 43.3519401550293, 0.756634092832802, -94.5416717529297, -1.65006345242834, 218, 16, 'PPL', 'P'),
(149389, 'Halfmoon', 42.8274993896484, 0.747480874745227, -73.7183303833008, -1.28662758426157, 218, 40, 'PPL', 'P'),
(196656, 'Halfmoon', 48.3877792358398, 0.844526065393551, -114.238891601563, -1.99384479227616, 218, 31, 'PPL', 'P'),
(149390, 'Halfmoon Beach', 42.8030586242676, 0.747054302917624, -73.7544403076172, -1.28725782133354, 218, 40, 'PPL', 'P'),
(21673, 'Halfmoon Landing', 31.6994400024414, 0.553259599081002, -81.2786102294922, -1.41857935994978, 218, 13, 'PPL', 'P'),
(187700, 'Halford', 39.3730583190918, 0.687189504247896, -100.869438171387, -1.76050381072755, 218, 20, 'PPL', 'P'),
(207576, 'Halford', 47.7886085510254, 0.83406856416211, -121.503059387207, -2.12062843755297, 218, 56, 'PPL', 'P'),
(162369, 'Halfville', 40.1883316040039, 0.701418707373162, -76.3255615234375, -1.33213235201748, 218, 45, 'PPL', 'P'),
(9292, 'Halfway', 34.0847206115723, 0.594890599294311, -93.3216705322266, -1.62877041424872, 218, 4, 'PPL', 'P'),
(36247, 'Halfway', 37.0883293151855, 0.647313460613922, -85.7955627441406, -1.49741505348664, 218, 21, 'PPL', 'P'),
(41245, 'Halfway', 32.1097183227539, 0.560420306620007, -93.3675003051758, -1.62957029468213, 218, 22, 'PPL', 'P'),
(47769, 'Halfway', 39.6205596923828, 0.691509218115032, -77.7591705322266, -1.35715354940711, 218, 25, 'PPL', 'P'),
(55138, 'Halfway', 37.6163902282715, 0.656529862198359, -93.2444381713867, -1.62742245526298, 218, 29, 'PPL', 'P'),
(87531, 'Halfway', 36.0991706848145, 0.630049385689428, -84.8483276367188, -1.48088268207164, 218, 50, 'PPL', 'P'),
(102559, 'Halfway', 38.9161109924316, 0.67921426888949, -77.745002746582, -1.35690627489989, 218, 53, 'PPL', 'P'),
(149392, 'Halfway', 43.0252799987793, 0.750932797571161, -76.392219543457, -1.33329575393968, 218, 40, 'PPL', 'P'),
(188656, 'Halfway', 32.5516700744629, 0.568133819822285, -103.735000610352, -1.81051731020896, 218, 38, 'PPL', 'P'),
(191576, 'Halfway', 34.188060760498, 0.596694225142567, -101.951942443848, -1.7793970744489, 218, 51, 'PPL', 'P'),
(200934, 'Halfway', 44.8808288574219, 0.783318234586096, -117.113609313965, -2.04401808142298, 218, 43, 'PPL', 'P'),
(209489, 'Halfway', 42.8086090087891, 0.747151175402275, -110.33805847168, -1.92576241058883, 218, 59, 'PPL', 'P'),
(21674, 'Halfway (historical)', 34.4791717529297, 0.601775070449248, -83.9100036621094, -1.46450583926431, 218, 13, 'PPL', 'P'),
(81401, 'Halfway Creek', 33.1136093139648, 0.577941509747747, -79.6474990844727, -1.39011110000322, 218, 48, 'PPL', 'P'),
(124999, 'Halfway House', 42.061939239502, 0.734119329503109, -71.6708297729492, -1.25089195717434, 218, 23, 'PPL', 'P'),
(162370, 'Halfway House', 40.2819404602051, 0.703052490122899, -75.6436080932617, -1.32023001931565, 218, 45, 'PPL', 'P'),
(181987, 'Halfway House', 35.5897216796875, 0.621157823178954, -118.959442138672, -2.07623394165551, 218, 6, 'PPL', 'P'),
(47772, 'Halfway Manor', 39.6208305358887, 0.691513945225967, -77.7630615234375, -1.3572214600149, 218, 25, 'PPL', 'P'),
(124994, 'Halfway Pond', 41.8422203063965, 0.730284510691449, -70.5369415283203, -1.23110187395591, 218, 23, 'PPL', 'P'),
(87532, 'Halfway Town (historical)', 35.5366706848145, 0.62023190864696, -84.084716796875, -1.46755515871245, 218, 50, 'PPL', 'P'),
(178323, 'Hali Murk', 32.0011100769043, 0.558524735135116, -112.293609619141, -1.95989321680318, 218, 5, 'PPL', 'P'),
(211861, 'Halibut Cove', 59.5950012207031, 1.04012898903131, -151.225006103516, -2.63937426785487, 218, 1, 'PPL', 'P'),
(21675, 'Halifax', 30.9647197723389, 0.540436311984702, -81.6983337402344, -1.42590491716026, 218, 13, 'PPL', 'P'),
(36248, 'Halifax', 36.8283309936523, 0.642775633853508, -86.2422180175781, -1.50521065862952, 218, 21, 'PPL', 'P'),
(55139, 'Halifax', 38.0119400024414, 0.663433508113144, -90.4897232055664, -1.57934360915545, 218, 29, 'PPL', 'P'),
(65307, 'Halifax', 36.3283309936523, 0.634048987593537, -77.5897216796875, -1.35419610901657, 218, 33, 'PPL', 'P'),
(102560, 'Halifax', 36.7658309936523, 0.641684803071012, -78.9286117553711, -1.37756414915953, 218, 53, 'PPL', 'P'),
(124995, 'Halifax', 41.9911117553711, 0.732883156704121, -70.8625030517578, -1.2367839944577, 218, 23, 'PPL', 'P'),
(162374, 'Halifax', 40.4680595397949, 0.706300880862523, -76.9322204589844, -1.34272054787942, 218, 45, 'PPL', 'P'),
(172091, 'Halifax', 42.769718170166, 0.746472402219441, -72.7458267211914, -1.26965419337006, 218, 55, 'PPL', 'P'),
(124996, 'Halifax Beach', 42, 0.733038285837618, -70.852783203125, -1.23661435109627, 218, 23, 'PPL', 'P'),
(65309, 'Halifax Crossing', 35.9580612182617, 0.62758656089235, -77.8722229003906, -1.35912668545874, 218, 33, 'PPL', 'P'),
(16323, 'Halifax Estates', 29.1472206115723, 0.508714967477091, -80.9669418334961, -1.41313972026524, 218, 12, 'PPL', 'P'),
(47770, 'Halifax Heights', 39.4463882446289, 0.688469352888761, -76.5361099243164, -1.33580711484763, 218, 25, 'PPL', 'P'),
(102562, 'Halifax Hills', 36.8213882446289, 0.64265446002391, -79.3866729736328, -1.38555882559389, 218, 53, 'PPL', 'P'),
(124997, 'Halifax Mobile Home Estates', 41.9925003051758, 0.732907391470041, -70.8294372558594, -1.23620688744948, 218, 23, 'PPL', 'P'),
(149393, 'Halihan Hill', 41.9911117553711, 0.732883156704121, -74.0283279418945, -1.29203806233218, 218, 40, 'PPL', 'P'),
(211394, 'Haliimaile', 20.8711109161377, 0.364269604035533, -156.343887329102, -2.72871559925987, 218, 15, 'PPL', 'P'),
(192604, 'Halivah', 37.7105598449707, 0.658173432065101, -113.174171447754, -1.97526191997986, 218, 52, 'PPL', 'P'),
(29976, 'Hall', 39.5499992370605, 0.690277705847952, -86.5358276367188, -1.51033511319905, 218, 19, 'PPL', 'P'),
(36250, 'Hall', 37.2991714477539, 0.650993350029166, -82.7702789306641, -1.44461389013418, 218, 21, 'PPL', 'P'),
(47771, 'Hall', 38.9022216796875, 0.678971854651266, -76.7358322143555, -1.33929292639843, 218, 25, 'PPL', 'P'),
(60150, 'Hall', 33.8886108398438, 0.591467838082314, -89.0683288574219, -1.55453559781109, 218, 30, 'PPL', 'P'),
(94689, 'Hall', 31.2849998474121, 0.546026253823265, -99.0513916015625, -1.72877291212953, 218, 51, 'PPL', 'P'),
(149394, 'Hall', 42.7938919067383, 0.746894313515137, -77.0666732788086, -1.34506719227394, 218, 40, 'PPL', 'P'),
(196657, 'Hall', 46.5852813720703, 0.813066542910609, -113.195831298828, -1.9756399556966, 218, 31, 'PPL', 'P'),
(207577, 'Hall', 45.9486083984375, 0.801954503262253, -122.538330078125, -2.13869731975888, 218, 56, 'PPL', 'P'),
(9293, 'Hall (historical)', 35.9255599975586, 0.627019307580163, -92.8883285522461, -1.62120716991095, 218, 4, 'PPL', 'P'),
(55140, 'Hall (historical)', 36.1041717529297, 0.630136670794156, -89.8033294677734, -1.56736377846589, 218, 29, 'PPL', 'P'),
(81402, 'Hall (historical)', 33.8319396972656, 0.590478740053459, -81.4811096191406, -1.42211364103243, 218, 48, 'PPL', 'P'),
(16324, 'Hall City', 26.878059387207, 0.469110632853332, -81.3266677856445, -1.4194181225351, 218, 12, 'PPL', 'P'),
(2937, 'Hall Creek', 32.5158309936523, 0.567508309861253, -87.9511108398438, -1.53503646494175, 218, 2, 'PPL', 'P'),
(13884, 'Hall Estates', 38.9397201538086, 0.679626326489153, -75.4625015258789, -1.31706911341783, 218, 10, 'PPL', 'P'),
(2938, 'Hall Grove', 33.5175018310547, 0.584990763995133, -85.982780456543, -1.50068261898611, 218, 2, 'PPL', 'P'),
(21677, 'Hall Mill', 34.7833290100098, 0.60708361602913, -85.355827331543, -1.48974022269919, 218, 13, 'PPL', 'P'),
(76007, 'Hall Park', 35.2369384765625, 0.61500059473869, -97.4061126708984, -1.70005737767575, 218, 42, 'PPL', 'P'),
(127661, 'Hall Quarry', 44.3358306884766, 0.77380622212066, -68.3219375610352, -1.19244276178205, 218, 26, 'PPL', 'P'),
(47773, 'Hall Shop Estates', 39.1708297729492, 0.683659950276187, -76.9544372558594, -1.34310830413414, 218, 25, 'PPL', 'P'),
(47774, 'Hall Spring', 39.3369407653809, 0.686559134017874, -76.5755615234375, -1.33649567514747, 218, 25, 'PPL', 'P'),
(181988, 'Hall Station', 37.586669921875, 0.656011144997039, -122.064170837402, -2.13042167982952, 218, 6, 'PPL', 'P'),
(41246, 'Hall Summit', 32.1772193908691, 0.561598422507231, -93.3022232055664, -1.62843099436779, 218, 22, 'PPL', 'P'),
(65311, 'Hall Swamp', 35.5519409179688, 0.62049842449305, -76.9488906860352, -1.34301149822851, 218, 33, 'PPL', 'P'),
(87533, 'Hall Town', 36.5036087036133, 0.637108160737711, -86.563606262207, -1.51081994167549, 218, 50, 'PPL', 'P'),
(196658, 'Hall Trailer Court', 47.1577796936035, 0.823058523583504, -110.219436645508, -1.92369206915741, 218, 31, 'PPL', 'P'),
(109518, 'Hall Trailer Park', 39.0188903808594, 0.68100810762074, -80.416389465332, -1.40353076873613, 218, 58, 'PPL', 'P'),
(2939, 'Hall Valley', 34.2555618286133, 0.597872341029791, -85.4694366455078, -1.49172307928881, 218, 2, 'PPL', 'P'),
(113515, 'Halladay Corner', 42.0116691589355, 0.733241951081982, -72.6425018310547, -1.26785083383791, 218, 8, 'PPL', 'P'),
(36251, 'Hallam', 38.502498626709, 0.671995371280667, -84.7897186279297, -1.47985976189694, 218, 21, 'PPL', 'P'),
(141977, 'Hallam', 40.5377807617188, 0.707517745743607, -96.7869415283203, -1.68925080260442, 218, 35, 'PPL', 'P'),
(162375, 'Hallam', 40.0047187805176, 0.698214059054443, -76.6044387817383, -1.33699967838377, 218, 45, 'PPL', 'P'),
(16325, 'Hallandale Beach', 25.9808292388916, 0.453451012617071, -80.1486129760742, -1.39885718733915, 218, 12, 'PPL', 'P'),
(87534, 'Hallbrook', 36.082218170166, 0.629753508492321, -83.9194412231445, -1.46467055577773, 218, 50, 'PPL', 'P'),
(109519, 'Hallburg', 38.621940612793, 0.674080027202954, -80.9972229003906, -1.41366822458357, 218, 58, 'PPL', 'P'),
(127662, 'Halldale', 44.5077781677246, 0.776807271774043, -69.2797164916992, -1.20915915762837, 218, 26, 'PPL', 'P'),
(603, 'Halleck', 39.5780601501465, 0.690767461172418, -94.820556640625, -1.65493091195268, 218, 29, 'PPL', 'P'),
(109520, 'Halleck', 39.4791717529297, 0.689041533048964, -79.9394378662109, -1.39520639295881, 218, 58, 'PPL', 'P'),
(199984, 'Halleck', 40.9508285522461, 0.714726789656397, -115.451942443848, -2.01501652346813, 218, 39, 'PPL', 'P'),
(181989, 'Hallelujah Junction', 39.7755584716797, 0.694214457150334, -120.038330078125, -2.09506408845902, 218, 6, 'PPL', 'P'),
(155583, 'Haller (historical)', 41.5613899230957, 0.725383095863213, -84.0569381713867, -1.467070330236, 218, 41, 'PPL', 'P'),
(207578, 'Haller Lake', 47.7236099243164, 0.832934124116763, -122.33805847168, -2.13520192082815, 218, 56, 'PPL', 'P'),
(131172, 'Hallers Corners', 42.6947212219238, 0.745163458543667, -83.70361328125, -1.46090364757387, 218, 27, 'PPL', 'P'),
(211862, 'Hallersville', 59.042781829834, 1.03049094246729, -156.839447021484, -2.73736474753212, 218, 1, 'PPL', 'P'),
(47775, 'Hallet Heights', 38.1847190856934, 0.666449071994468, -75.3838882446289, -1.31569705282422, 218, 25, 'PPL', 'P'),
(76008, 'Hallett', 36.2338905334473, 0.632400690615859, -96.5672225952148, -1.68541598379276, 218, 42, 'PPL', 'P'),
(155584, 'Hallett', 41.7075004577637, 0.727933205765018, -83.5208282470703, -1.45771344690406, 218, 41, 'PPL', 'P'),
(55141, 'Hallett (historical)', 36.9002799987793, 0.644031380886508, -89.3222198486328, -1.55896683154887, 218, 29, 'PPL', 'P'),
(94690, 'Hallettsville', 29.4436092376709, 0.513887924867975, -96.9408264160156, -1.69193660056377, 218, 51, 'PPL', 'P'),
(9294, 'Halley', 33.5355606079102, 0.585305949110143, -91.3247222900391, -1.59391709243064, 218, 4, 'PPL', 'P'),
(76009, 'Halley', 34.8519401550293, 0.608281106413284, -95.8363876342773, -1.67266050743572, 218, 42, 'PPL', 'P'),
(72783, 'Halley (historical)', 38.6530609130859, 0.674623178907275, -82.2297210693359, -1.43517937565646, 218, 41, 'PPL', 'P'),
(181990, 'Halley (historical)', 37.5947189331055, 0.65615162674454, -121.247222900391, -2.11616324851129, 218, 6, 'PPL', 'P'),
(47776, 'Halley Estates', 38.583610534668, 0.673411041137126, -76.9569396972656, -1.34315197997601, 218, 25, 'PPL', 'P'),
(9295, 'Halley Junction', 33.5327796936035, 0.585257412999277, -91.3752822875977, -1.59479953085784, 218, 4, 'PPL', 'P'),
(81403, 'Halleytown', 33.6583290100098, 0.587448661944194, -80.2669372558594, -1.40092233560645, 218, 48, 'PPL', 'P'),
(41249, 'Hallf Moon', 30.6555595397949, 0.535040448010579, -91.7977828979492, -1.60217355760016, 218, 22, 'PPL', 'P'),
(47777, 'Hallfield Manor', 39.3855590820313, 0.687407683720201, -76.4730606079102, -1.33470669668521, 218, 25, 'PPL', 'P'),
(9297, 'Halliday', 36.1213912963867, 0.630437208523171, -90.4341735839844, -1.57837408536061, 218, 4, 'PPL', 'P'),
(198380, 'Halliday', 47.3544387817383, 0.826490872175425, -102.335563659668, -1.78609252774546, 218, 34, 'PPL', 'P'),
(27360, 'Hallidayboro', 37.8888893127441, 0.661285868431077, -89.2369384765625, -1.55747839081563, 218, 18, 'PPL', 'P'),
(36252, 'Hallie', 37.1022186279297, 0.647555874852146, -83.0213928222656, -1.44899665434012, 218, 21, 'PPL', 'P'),
(174390, 'Hallie', 44.8827781677246, 0.783352256469022, -91.432502746582, -1.59579821626661, 218, 57, 'PPL', 'P'),
(21678, 'Hallie Hills', 33.5675010681152, 0.585863415305324, -84.4722213745117, -1.47431838945876, 218, 13, 'PPL', 'P'),
(102564, 'Hallieford', 37.4936103820801, 0.654386949627227, -76.3405609130859, -1.33239414075264, 218, 53, 'PPL', 'P'),
(2940, 'Hallingworth', 33.8363914489746, 0.590556437778262, -85.6930618286133, -1.49562607502437, 218, 2, 'PPL', 'P'),
(162377, 'Hallman', 40.1122207641602, 0.700090322621431, -75.5922164916992, -1.31933306666051, 218, 45, 'PPL', 'P'),
(47778, 'Hallmark', 39.1694412231445, 0.683635715510267, -76.9030609130859, -1.34221161779511, 218, 25, 'PPL', 'P'),
(81404, 'Hallmark', 34.0516700744629, 0.5943137586022, -81.1666717529297, -1.4166256649741, 218, 48, 'PPL', 'P'),
(94691, 'Hallmark Crossing', 31.0855598449707, 0.542545369120477, -98.0511093139648, -1.71131469276157, 218, 51, 'PPL', 'P'),
(625, 'Hallmark Estates', 38.6175003051758, 0.674002529215232, -76.6416702270508, -1.33764948968975, 218, 25, 'PPL', 'P'),
(102565, 'Hallmark Manor', 38.7827796936035, 0.676887198728979, -77.4974975585938, -1.35258649445373, 218, 53, 'PPL', 'P'),
(81406, 'Hallmark Shores', 34.0208282470703, 0.593775467166868, -81.3341674804688, -1.41954901690268, 218, 48, 'PPL', 'P'),
(135756, 'Hallmark Terrace', 44.0805587768555, 0.769350886775012, -92.4569396972656, -1.61367801403513, 218, 28, 'PPL', 'P'),
(47779, 'Hallmark Woods', 38.9861106872559, 0.680435994039564, -76.649169921875, -1.33778038405732, 218, 25, 'PPL', 'P'),
(21680, 'Halloca (historical)', 32.348331451416, 0.564584891353646, -84.783332824707, -1.47974830860532, 218, 13, 'PPL', 'P'),
(119902, 'Hallock', 40.5613899230957, 0.70792980334327, -87.5961074829102, -1.52884048750762, 218, 18, 'PPL', 'P'),
(135757, 'Hallock', 48.7744407653809, 0.851274582174839, -96.9461135864258, -1.69202887909554, 218, 28, 'PPL', 'P'),
(155585, 'Hallock', 41.526668548584, 0.724777093557165, -84.557502746582, -1.475806830192, 218, 41, 'PPL', 'P'),
(125000, 'Hallockville', 42.5525016784668, 0.742681259249659, -72.9422225952148, -1.2730819480091, 218, 23, 'PPL', 'P'),
(55142, 'Halloran', 36.8333282470703, 0.642862852379208, -90.6180572509766, -1.58158346079026, 218, 29, 'PPL', 'P'),
(141978, 'Halloran', 40.5875015258789, 0.708385536784809, -98.29638671875, -1.71559559105581, 218, 35, 'PPL', 'P'),
(181991, 'Halloran Springs', 35.372501373291, 0.617366613630144, -115.889717102051, -2.02265713263557, 218, 6, 'PPL', 'P'),
(65313, 'Halloway (historical)', 36.4866714477539, 0.636812549856712, -78.8013916015625, -1.37534373860067, 218, 33, 'PPL', 'P'),
(32679, 'Hallowell', 37.1747207641602, 0.648821275844097, -94.9952774047852, -1.65798036455888, 218, 20, 'PPL', 'P'),
(47786, 'Hallowell', 39.1430587768555, 0.683175254957792, -77.0611114501953, -1.34497012005221, 218, 25, 'PPL', 'P'),
(127663, 'Hallowell', 44.285831451416, 0.772933570810469, -69.791389465332, -1.21808953571173, 218, 26, 'PPL', 'P'),
(162378, 'Hallowell', 40.1974983215332, 0.701578696775649, -75.1319427490234, -1.31129977439034, 218, 45, 'PPL', 'P'),
(102566, 'Hallowing Point Estates', 38.6375007629395, 0.674351603055115, -77.144172668457, -1.3464198117916, 218, 53, 'PPL', 'P'),
(21681, 'Halls', 34.2983283996582, 0.598618758504313, -84.9400024414063, -1.48248270925456, 218, 13, 'PPL', 'P'),
(55143, 'Halls', 39.6333312988281, 0.691732124698271, -94.9730606079102, -1.65759260830416, 218, 29, 'PPL', 'P'),
(65314, 'Halls', 34.3397216796875, 0.599341207529024, -78.6438903808594, -1.37259482372349, 218, 33, 'PPL', 'P'),
(87539, 'Halls', 35.875560760498, 0.626146656269972, -89.396110534668, -1.56025646730674, 218, 50, 'PPL', 'P'),
(94692, 'Halls Bluff', 31.3544406890869, 0.547238225145846, -95.6572189331055, -1.66953342368375, 218, 51, 'PPL', 'P'),
(94693, 'Halls Bluff Town (historical)', 31.358060836792, 0.547301408642708, -95.6600036621094, -1.66958202637364, 218, 51, 'PPL', 'P'),
(2941, 'Halls Chapel', 33.7508316040039, 0.589063136776027, -85.8472213745117, -1.49831666667368, 218, 2, 'PPL', 'P'),
(127667, 'Halls Corner', 44.377498626709, 0.774533464835334, -69.0780563354492, -1.20563952393172, 218, 26, 'PPL', 'P'),
(131173, 'Halls Corner', 43.5397186279297, 0.759911445449281, -85.2247161865234, -1.48745190153254, 218, 27, 'PPL', 'P'),
(149397, 'Halls Corner', 42.9991683959961, 0.750477064129621, -73.8116683959961, -1.28825663990037, 218, 40, 'PPL', 'P'),
(181992, 'Halls Corner', 36.3424987792969, 0.634296262100751, -119.805557250977, -2.09100143621611, 218, 6, 'PPL', 'P'),
(122749, 'Halls Corners', 41.2408294677734, 0.719788260466147, -84.8522186279297, -1.48095059267944, 218, 19, 'PPL', 'P'),
(155586, 'Halls Corners', 41.1549987792969, 0.718290232352978, -80.6322174072266, -1.40729767693999, 218, 41, 'PPL', 'P'),
(87540, 'Halls Creek', 36.189998626709, 0.631634632328298, -87.8219375610352, -1.53278196592094, 218, 50, 'PPL', 'P'),
(21682, 'Halls Crossing', 33.0238914489746, 0.576375637605808, -82.6474990844727, -1.44247097756305, 218, 13, 'PPL', 'P'),
(192605, 'Halls Crossing', 37.4569396972656, 0.653746925438253, -110.712219238281, -1.93229274789782, 218, 52, 'PPL', 'P'),
(2942, 'Halls Crossroads', 31.4022197723389, 0.548072127462177, -87.3313903808594, -1.5242203024905, 218, 2, 'PPL', 'P'),
(65318, 'Halls Crossroads', 35.9824981689453, 0.628013066140927, -78.2652816772461, -1.36598685526873, 218, 33, 'PPL', 'P'),
(87541, 'Halls Crossroads', 36.0802803039551, 0.629719686346477, -83.942497253418, -1.46507295941844, 218, 50, 'PPL', 'P'),
(65316, 'Halls Ferry Junction', 35.4269409179688, 0.618316762928057, -80.2147216796875, -1.40001100188142, 218, 33, 'PPL', 'P'),
(204198, 'Halls Fifth Avenue Condominium', 40.7755584716797, 0.711667749670278, -111.866943359375, -1.9524464857631, 218, 52, 'PPL', 'P'),
(193610, 'Halls Flat', 40.7561111450195, 0.711328329789347, -121.258056640625, -2.11635233294868, 218, 6, 'PPL', 'P'),
(65317, 'Halls Ford', 35.355281829834, 0.617066075901129, -83.5102767944336, -1.45752928931468, 218, 33, 'PPL', 'P'),
(36255, 'Halls Gap', 37.4619407653809, 0.653834210542981, -84.6333312988281, -1.47713028809572, 218, 21, 'PPL', 'P'),
(47780, 'Halls Hacienda', 38.4638900756836, 0.67132152494585, -76.5247192382813, -1.33560830987225, 218, 25, 'PPL', 'P'),
(87542, 'Halls Hill', 35.8697204589844, 0.626044723779249, -86.2350006103516, -1.50508469110995, 218, 50, 'PPL', 'P'),
(102569, 'Halls Hill', 38.8974990844727, 0.678889429815528, -77.1288909912109, -1.34615309620842, 218, 53, 'PPL', 'P'),
(47781, 'Halls Hills', 38.7097206115723, 0.675612077199049, -76.6611099243164, -1.33798877641262, 218, 25, 'PPL', 'P'),
(36253, 'Halls Landing', 38.4516716003418, 0.671108272321562, -85.5308303833008, -1.4927946021534, 218, 21, 'PPL', 'P'),
(81407, 'Halls Mill', 32.9097213745117, 0.574382993899183, -81.1658325195313, -1.41661101758811, 218, 48, 'PPL', 'P'),
(87543, 'Halls Mill', 35.5533294677734, 0.62052265925897, -86.5819396972656, -1.51113992048047, 218, 50, 'PPL', 'P'),
(65324, 'Halls Mills', 36.2922210693359, 0.633418750521569, -81.210563659668, -1.41739172326166, 218, 33, 'PPL', 'P'),
(109521, 'Halls Mills', 39.6238899230957, 0.691567341605823, -80.720832824707, -1.40884430774305, 218, 58, 'PPL', 'P'),
(127668, 'Halls Mills', 44.7702789306641, 0.781388774376334, -67.2652816772461, -1.17400063754936, 218, 26, 'PPL', 'P'),
(188657, 'Halls Peak (historical)', 36.2322196960449, 0.632371529001923, -105.075561523438, -1.83391451196585, 218, 38, 'PPL', 'P'),
(65319, 'Halls Store', 35.1133308410645, 0.612843234518644, -78.538330078125, -1.37075244888138, 218, 33, 'PPL', 'P'),
(32662, 'Halls Summit', 38.3472213745117, 0.669285271976375, -95.6750030517578, -1.6698438151088, 218, 20, 'PPL', 'P'),
(47782, 'Halls Trailer Villa', 39.6488914489746, 0.692003700550432, -76.2399978637695, -1.33063898443622, 218, 25, 'PPL', 'P'),
(72785, 'Halls Valley (historical)', 39.6647186279297, 0.692279936934501, -81.9416732788086, -1.43015199330867, 218, 41, 'PPL', 'P'),
(65321, 'Hallsboro', 34.3222198486328, 0.599035742951992, -78.5991668701172, -1.37181425120799, 218, 33, 'PPL', 'P'),
(102567, 'Hallsboro', 37.4883308410645, 0.65429480425351, -77.7255630493164, -1.35656698817702, 218, 53, 'PPL', 'P'),
(94694, 'Hallsburg', 31.538610458374, 0.550452594002545, -96.9558334350586, -1.69219852245698, 218, 51, 'PPL', 'P'),
(140160, 'Hallson', 48.7638893127441, 0.85109042458546, -97.817497253418, -1.70723739313265, 218, 34, 'PPL', 'P'),
(149398, 'Hallsport', 42.0752792358398, 0.734352156361409, -77.8525009155273, -1.35878247188785, 218, 40, 'PPL', 'P'),
(162379, 'Hallstead', 41.961109161377, 0.732359512654784, -75.7436065673828, -1.32197532193603, 218, 45, 'PPL', 'P'),
(162381, 'Hallston', 41.0202789306641, 0.715938927426547, -79.9852828979492, -1.39600653970833, 218, 45, 'PPL', 'P'),
(2943, 'Hallsville', 31.7452793121338, 0.554059645961975, -86.103889465332, -1.5027963699433, 218, 2, 'PPL', 'P'),
(9298, 'Hallsville', 34.8166694641113, 0.607665516727312, -91.4952774047852, -1.59689384073907, 218, 4, 'PPL', 'P'),
(55144, 'Hallsville', 39.1169395446777, 0.682719388358198, -92.2205581665039, -1.60955237803244, 218, 29, 'PPL', 'P'),
(65322, 'Hallsville', 34.9072189331055, 0.609245903097193, -77.8391723632813, -1.35854984476663, 218, 33, 'PPL', 'P'),
(72786, 'Hallsville', 39.4438896179199, 0.688425743625911, -82.8272171020508, -1.44560764869494, 218, 41, 'PPL', 'P'),
(94695, 'Hallsville', 32.5041694641113, 0.567304777774943, -94.5738906860352, -1.65062577889251, 218, 51, 'PPL', 'P'),
(119903, 'Hallsville', 40.1508293151855, 0.700764168956248, -89.0927810668945, -1.55496236937578, 218, 18, 'PPL', 'P'),
(149399, 'Hallsville', 42.935001373291, 0.749357138312215, -74.7038879394531, -1.30382880858434, 218, 40, 'PPL', 'P'),
(162382, 'Hallton', 41.4019393920898, 0.722600159103107, -78.932502746582, -1.37763205976732, 218, 45, 'PPL', 'P'),
(2944, 'Halltown', 34.4530601501465, 0.601319337007708, -88.061393737793, -1.5369612646196, 218, 2, 'PPL', 'P'),
(55145, 'Halltown', 37.1933288574219, 0.649146048339032, -93.6252822875977, -1.63406943902771, 218, 29, 'PPL', 'P'),
(60151, 'Halltown', 34.524169921875, 0.602560436654712, -88.8125, -1.55007054192746, 218, 30, 'PPL', 'P'),
(70924, 'Halltown', 39.6380615234375, 0.691814682692064, -75.4130630493164, -1.31620624922465, 218, 37, 'PPL', 'P'),
(87545, 'Halltown', 36.4272193908691, 0.63577491571699, -86.1350021362305, -1.50333938848957, 218, 50, 'PPL', 'P'),
(109522, 'Halltown', 39.3138885498047, 0.68615679695619, -77.7980575561523, -1.35783225601091, 218, 58, 'PPL', 'P'),
(27361, 'Halltown (historical)', 37.8930587768555, 0.661358639307863, -88.6902770996094, -1.54793734989431, 218, 18, 'PPL', 'P'),
(32663, 'Hallville', 38.648609161377, 0.674545481182472, -97.5377807617188, -1.70235541938037, 218, 20, 'PPL', 'P'),
(113516, 'Hallville', 41.4933280944824, 0.724195192858983, -72.0336074829102, -1.25722362266601, 218, 8, 'PPL', 'P'),
(21683, 'Hallwood', 33.246940612793, 0.580268579908259, -83.3633270263672, -1.45496453202688, 218, 13, 'PPL', 'P'),
(102568, 'Hallwood', 37.0633316040039, 0.646877168248339, -76.2980575561523, -1.331652317231, 218, 53, 'PPL', 'P'),
(109523, 'Hallwood', 38.9724998474121, 0.680198440070329, -82.0813903808594, -1.4325905167608, 218, 58, 'PPL', 'P'),
(162383, 'Hallwood', 41.2241706848145, 0.719497509854138, -76.1236114501953, -1.32860765831476, 218, 45, 'PPL', 'P'),
(21684, 'Hallwood Homes', 31.8769397735596, 0.55635755450855, -81.6133270263672, -1.42442127011698, 218, 13, 'PPL', 'P'),
(60152, 'Hally', 34.5088882446289, 0.602293721071541, -90.3619384765625, -1.57711334490056, 218, 30, 'PPL', 'P'),
(135760, 'Halma', 48.6611099243164, 0.84929658585421, -96.5999984741211, -1.68598803079491, 218, 28, 'PPL', 'P'),
(36254, 'Halo', 37.315559387207, 0.65127937353024, -82.7394409179688, -1.44407566527787, 218, 21, 'PPL', 'P'),
(109524, 'Halo', 38.4500007629395, 0.671079110707625, -80.5369415283203, -1.40563479915534, 218, 58, 'PPL', 'P'),
(155587, 'Halo', 41.0438919067383, 0.716351051605236, -81.5547180175781, -1.42339834994228, 218, 41, 'PPL', 'P'),
(16330, 'Halpata (historical)', 30.1833305358887, 0.526798497069002, -82.6333312988281, -1.44222370305583, 218, 12, 'PPL', 'P'),
(47783, 'Halpine Village', 39.0625, 0.681769239060285, -77.1197204589844, -1.34599304022691, 218, 25, 'PPL', 'P'),
(2946, 'Halsell', 32.2838897705078, 0.563460171846278, -88.2772216796875, -1.54072817282347, 218, 2, 'PPL', 'P'),
(94696, 'Halsell', 33.7194404602051, 0.588515257960771, -98.3444366455078, -1.71643422048308, 218, 51, 'PPL', 'P'),
(16326, 'Halsema', 30.312219619751, 0.529048035952278, -81.8652801513672, -1.42881868170892, 218, 12, 'PPL', 'P'),
(27362, 'Halsey', 37.5672187805176, 0.655671658537081, -89.4527816772461, -1.5612455653356, 218, 18, 'PPL', 'P'),
(145350, 'Halsey', 41.0969390869141, 0.717276899558203, -74.748893737793, -1.30461430794786, 218, 37, 'PPL', 'P'),
(162384, 'Halsey', 41.672779083252, 0.727327203458971, -78.6813888549805, -1.37324929556138, 218, 45, 'PPL', 'P'),
(199374, 'Halsey', 41.9033317565918, 0.731351106708026, -100.268608093262, -1.75001734761925, 218, 35, 'PPL', 'P'),
(200935, 'Halsey', 44.3841705322266, 0.774649911553998, -123.108612060547, -2.14865061801694, 218, 43, 'PPL', 'P'),
(149400, 'Halsey Valley', 42.1413917541504, 0.735506037482713, -76.4394378662109, -1.33411986913901, 218, 40, 'PPL', 'P'),
(149401, 'Halseys Corners', 44.7077789306641, 0.780297943593838, -73.4694366455078, -1.28228356904949, 218, 40, 'PPL', 'P'),
(149402, 'Halseyville', 42.5313911437988, 0.742312810912847, -76.6341705322266, -1.33751859532217, 218, 40, 'PPL', 'P'),
(2947, 'Halso Mill', 31.7130603790283, 0.553497319497805, -86.5205612182617, -1.51006866393198, 218, 2, 'PPL', 'P'),
(135762, 'Halstad', 47.3516693115234, 0.826442535801641, -96.8283309936523, -1.68997318505011, 218, 28, 'PPL', 'P'),
(32664, 'Halstead', 38.0013885498047, 0.663249350523765, -97.5083312988281, -1.70184142928999, 218, 20, 'PPL', 'P'),
(60153, 'Halstead', 33.7038917541504, 0.588243881845692, -90.6413879394531, -1.58199065812094, 218, 30, 'PPL', 'P'),
(94697, 'Halsted', 29.9072208404541, 0.52197947378699, -96.7813873291016, -1.68915386354074, 218, 51, 'PPL', 'P'),
(207579, 'Halterman', 48.2694396972656, 0.84246065081014, -121.882499694824, -2.12725092023567, 218, 56, 'PPL', 'P'),
(94698, 'Haltom City', 32.7994384765625, 0.572458194221329, -97.2688903808594, -1.69766239690744, 218, 51, 'PPL', 'P'),
(181993, 'Halvern', 37.6252784729004, 0.656684991331856, -122.051391601563, -2.13019864008822, 218, 6, 'PPL', 'P'),
(135765, 'Ham Lake', 45.2502784729004, 0.789766346796424, -93.2497177124023, -1.6275146006367, 218, 28, 'PPL', 'P'),
(60154, 'Hamage', 31.2255592346191, 0.544988819420624, -89.9441680908203, -1.56982187615204, 218, 30, 'PPL', 'P'),
(211399, 'Hamakuapoko', 20.9219398498535, 0.365156736284152, -156.348052978516, -2.72878830355763, 218, 15, 'PPL', 'P'),
(207580, 'Hamann Corner', 47.8305587768555, 0.8348007337248, -117.424171447754, -2.04943841318962, 218, 56, 'PPL', 'P'),
(140161, 'Hamar', 47.8436088562012, 0.835028500577029, -98.5730590820313, -1.72042443474434, 218, 34, 'PPL', 'P'),
(16327, 'Hamaste (historical)', 30.2666702270508, 0.528253049077376, -83.9916687011719, -1.46593116307972, 218, 12, 'PPL', 'P'),
(155588, 'Hambden', 41.6041717529297, 0.726129779653844, -81.1458282470703, -1.4162618771692, 218, 41, 'PPL', 'P'),
(140162, 'Hamberg', 47.7630615234375, 0.833622684416603, -99.5141677856445, -1.73684988024157, 218, 34, 'PPL', 'P'),
(194223, 'Hambert', 40.314998626709, 0.703629463973064, -104.737503051758, -1.82801427857078, 218, 7, 'PPL', 'P'),
(87546, 'Hamble', 36.3069381713867, 0.633675612408708, -87.283332824707, -1.52338153990518, 218, 50, 'PPL', 'P'),
(164, 'Hambleton', 39.0819396972656, 0.682108525783161, -79.6455612182617, -1.39007727785737, 218, 58, 'PPL', 'P'),
(47785, 'Hambleton', 38.6949996948242, 0.675355148732884, -76.0647201538086, -1.32757981129205, 218, 25, 'PPL', 'P'),
(149403, 'Hambletville', 42.0966682434082, 0.734725464967211, -75.3933334350586, -1.3158619024957, 218, 40, 'PPL', 'P'),
(181994, 'Hamblin', 36.329719543457, 0.634073222359456, -119.60888671875, -2.0875688878871, 218, 6, 'PPL', 'P'),
(196660, 'Hamblin (historical)', 47.6813888549805, 0.832197227443138, -105.65389251709, -1.84400829197142, 218, 31, 'PPL', 'P'),
(196659, 'Hamblin Heights Mobile Village', 46.0011100769043, 0.802870830414322, -112.552780151367, -1.96441659591468, 218, 31, 'PPL', 'P'),
(193611, 'Hambone', 41.3349990844727, 0.72143183033289, -121.696670532227, -2.12400758950211, 218, 6, 'PPL', 'P'),
(87548, 'Hambright', 35.2125015258789, 0.614574089490114, -84.5122222900391, -1.47501653713852, 218, 50, 'PPL', 'P'),
(2949, 'Hamburg', 32.5277786254883, 0.567716835374606, -87.2863922119141, -1.52343493628504, 218, 2, 'PPL', 'P'),
(9299, 'Hamburg', 33.2280616760254, 0.579939080302388, -91.7975006103516, -1.60216863075214, 218, 4, 'PPL', 'P'),
(16328, 'Hamburg', 30.565559387207, 0.533469649020623, -83.5269393920898, -1.45782010650572, 218, 12, 'PPL', 'P'),
(27364, 'Hamburg', 39.2299995422363, 0.684692657567892, -90.7174987792969, -1.58331904287267, 218, 18, 'PPL', 'P'),
(29980, 'Hamburg', 39.3808288574219, 0.687325125726408, -85.2508316040039, -1.48790770155311, 218, 19, 'PPL', 'P'),
(32667, 'Hamburg', 38.125560760498, 0.665416564439844, -99.1699981689453, -1.73084298724484, 218, 20, 'PPL', 'P'),
(41247, 'Hamburg', 31.0305595397949, 0.541585432705558, -91.9313888549805, -1.60450542145063, 218, 22, 'PPL', 'P'),
(55146, 'Hamburg', 38.6697196960449, 0.674913929519285, -90.7316665649414, -1.58356631737988, 218, 29, 'PPL', 'P'),
(60155, 'Hamburg', 31.5786094665527, 0.551150708392795, -91.0666732788086, -1.58941328755315, 218, 30, 'PPL', 'P'),
(72788, 'Hamburg', 39.8872184753418, 0.696163291857027, -84.6763916015625, -1.47788183215534, 218, 41, 'PPL', 'P'),
(81408, 'Hamburg', 33.4797210693359, 0.584331365309229, -81.9580612182617, -1.43043801680974, 218, 48, 'PPL', 'P'),
(87550, 'Hamburg', 35.0066719055176, 0.610981684916679, -85.7024993896484, -1.4957907915378, 218, 50, 'PPL', 'P'),
(102571, 'Hamburg', 38.8050003051758, 0.677275021562722, -78.6377792358398, -1.37248816412184, 218, 53, 'PPL', 'P'),
(113520, 'Hamburg', 41.3844413757324, 0.722294761105102, -72.3505630493164, -1.26275554088232, 218, 8, 'PPL', 'P'),
(115904, 'Hamburg', 40.6044387817383, 0.708681147665808, -95.6575012207031, -1.66953835053176, 218, 16, 'PPL', 'P'),
(131174, 'Hamburg', 42.4486083984375, 0.740867979442451, -83.8016662597656, -1.46261499489035, 218, 27, 'PPL', 'P'),
(135767, 'Hamburg', 44.7333297729492, 0.780743889918371, -93.9669418334961, -1.6400325230245, 218, 28, 'PPL', 'P'),
(145351, 'Hamburg', 41.1533317565918, 0.718261137318069, -74.5766677856445, -1.30160839802549, 218, 37, 'PPL', 'P'),
(149405, 'Hamburg', 42.2341690063477, 0.737125306004509, -73.8505630493164, -1.28893547966223, 218, 40, 'PPL', 'P'),
(162385, 'Hamburg', 40.5555610656738, 0.707828070589629, -75.9822235107422, -1.3261399732487, 218, 45, 'PPL', 'P'),
(174399, 'Hamburg', 45.0905609130859, 0.78697874950441, -89.8850021362305, -1.56878923543936, 218, 57, 'PPL', 'P'),
(193612, 'Hamburg', 41.7830581665039, 0.729251936557798, -123.059173583984, -2.14778775382376, 218, 6, 'PPL', 'P'),
(72789, 'Hamburg (historical)', 39.5833282470703, 0.690859406809052, -82.102783203125, -1.43296389194563, 218, 41, 'PPL', 'P'),
(181995, 'Hamburg Farms', 36.8794403076172, 0.64366765966063, -120.76277923584, -2.10770811152445, 218, 6, 'PPL', 'P'),
(27366, 'Hamburg Landing', 37.4063911437988, 0.652864686748137, -89.4122161865234, -1.5605375639598, 218, 18, 'PPL', 'P'),
(13121, 'Hamburgh (historical)', 38.8902816772461, 0.678763462295967, -77.0527801513672, -1.34482471145669, 218, 9, 'PPL', 'P'),
(36256, 'Hamby', 37.1775016784668, 0.648869811954964, -87.5972213745117, -1.52885992858358, 218, 21, 'PPL', 'P'),
(94699, 'Hamby', 32.5186080932617, 0.567556779393092, -99.6308288574219, -1.73888600005299, 218, 51, 'PPL', 'P'),
(21685, 'Hamby Place', 34.0697212219238, 0.594628810559157, -84.6047210693359, -1.47663094539133, 218, 13, 'PPL', 'P'),
(55147, 'Hamden', 39.577220916748, 0.690752813786422, -92.8230590820313, -1.62006800275467, 218, 29, 'PPL', 'P'),
(72790, 'Hamden', 39.1597213745117, 0.683466072148829, -82.5269393920898, -1.44036681398578, 218, 41, 'PPL', 'P'),
(76010, 'Hamden', 34.142219543457, 0.59589414497208, -95.5663909912109, -1.66794817704488, 218, 42, 'PPL', 'P'),
(113517, 'Hamden', 41.3958282470703, 0.72249349950145, -72.897216796875, -1.27229644864558, 218, 8, 'PPL', 'P'),
(145353, 'Hamden', 40.603328704834, 0.708661773168878, -74.9008331298828, -1.3072661506033, 218, 37, 'PPL', 'P'),
(149407, 'Hamden', 42.1911087036133, 0.736373761944888, -74.995002746582, -1.30890972047005, 218, 40, 'PPL', 'P'),
(27367, 'Hamel', 38.8888893127441, 0.67873916095102, -89.8452835083008, -1.56809601460761, 218, 18, 'PPL', 'P'),
(135770, 'Hamel', 45.0411109924316, 0.786115685574143, -93.5252838134766, -1.63232413640732, 218, 28, 'PPL', 'P'),
(196661, 'Hamen', 46.3097190856934, 0.808257073719007, -110.699996948242, -1.9320794286945, 218, 31, 'PPL', 'P'),
(21686, 'Hamer', 32.0938911437988, 0.560144070235938, -81.2077789306641, -1.41734312057177, 218, 13, 'PPL', 'P'),
(65325, 'Hamer', 36.4563903808594, 0.636284045538386, -79.2750015258789, -1.38360979115012, 218, 33, 'PPL', 'P'),
(81409, 'Hamer', 34.4777793884277, 0.601750769104301, -79.3311080932617, -1.38458903548294, 218, 48, 'PPL', 'P'),
(155590, 'Hamer', 41.628059387207, 0.726546697522496, -84.415283203125, -1.473324630898, 218, 41, 'PPL', 'P'),
(195046, 'Hamer', 43.9272193908691, 0.766674609616564, -112.205276489258, -1.95835151284813, 218, 17, 'PPL', 'P'),
(72792, 'Hamersville', 38.917781829834, 0.679243430503427, -83.9833297729492, -1.46578562132615, 218, 41, 'PPL', 'P'),
(115906, 'Hamerville', 42.3125, 0.738492439750101, -91.8894424438477, -1.60377331846697, 218, 16, 'PPL', 'P'),
(78418, 'Hametown', 39.7983283996582, 0.694611867364001, -76.679443359375, -1.3383087552176, 218, 45, 'PPL', 'P'),
(155591, 'Hametown', 40.9949989318848, 0.715497708212948, -81.6680603027344, -1.42537654599999, 218, 41, 'PPL', 'P'),
(9300, 'Hamil', 36.4030609130859, 0.635353270737403, -91.0652770996094, -1.58938891962918, 218, 4, 'PPL', 'P'),
(170448, 'Hamill', 43.5947189331055, 0.7608713818642, -99.6811065673828, -1.73976351163217, 218, 49, 'PPL', 'P'),
(87551, 'Hamillville', 35.124439239502, 0.613037112646002, -85.232780456543, -1.48759264959615, 218, 50, 'PPL', 'P'),
(2950, 'Hamilton', 34.142219543457, 0.59589414497208, -87.9886093139648, -1.53569093677964, 218, 2, 'PPL', 'P'),
(9302, 'Hamilton', 34.621940612793, 0.604266857123181, -91.7191696166992, -1.60080149700655, 218, 4, 'PPL', 'P'),
(21687, 'Hamilton', 32.7577781677246, 0.57173108466471, -84.875, -1.48134820263019, 218, 13, 'PPL', 'P'),
(32668, 'Hamilton', 37.9794387817383, 0.662866254800957, -96.1638870239258, -1.67837645008336, 218, 20, 'PPL', 'P'),
(36257, 'Hamilton', 38.8833312988281, 0.678642155308314, -84.7816696166992, -1.47971928014944, 218, 21, 'PPL', 'P'),
(41248, 'Hamilton', 30.8024997711182, 0.537605038850812, -91.3116683959961, -1.59368925899938, 218, 22, 'PPL', 'P'),
(47788, 'Hamilton', 39.3563919067383, 0.686898620477832, -76.5572204589844, -1.33617556318444, 218, 25, 'PPL', 'P'),
(55148, 'Hamilton', 39.7436103820801, 0.693656857797099, -93.9980621337891, -1.64057567472883, 218, 29, 'PPL', 'P'),
(60157, 'Hamilton', 33.7402801513672, 0.588878979186648, -88.4111099243164, -1.54306496352196, 218, 30, 'PPL', 'P'),
(65331, 'Hamilton', 35.9444389343262, 0.627348807186034, -77.2099990844727, -1.34756869948586, 218, 33, 'PPL', 'P'),
(72794, 'Hamilton', 39.7649993896484, 0.694030166402901, -81.2413864135742, -1.41792968180186, 218, 41, 'PPL', 'P'),
(87552, 'Hamilton', 36.4986114501953, 0.637020942212011, -82.2616729736328, -1.43573704158873, 218, 50, 'PPL', 'P'),
(94700, 'Hamilton', 31.7036094665527, 0.553332369957788, -98.1236114501953, -1.71258009375352, 218, 51, 'PPL', 'P'),
(102574, 'Hamilton', 39.1341705322266, 0.683020125824295, -77.6627807617188, -1.3554712305465, 218, 53, 'PPL', 'P'),
(109525, 'Hamilton', 38.0213890075684, 0.663598424363647, -81.2633285522461, -1.41831264436661, 218, 58, 'PPL', 'P'),
(115907, 'Hamilton', 41.1691703796387, 0.718537573439219, -92.9030609130859, -1.6214642981142, 218, 16, 'PPL', 'P'),
(119904, 'Hamilton', 40.3963890075684, 0.705049994098512, -91.3388900756836, -1.59416436693785, 218, 18, 'PPL', 'P'),
(122753, 'Hamilton', 41.5336112976074, 0.724898267386764, -84.9127807617188, -1.48200760131609, 218, 19, 'PPL', 'P'),
(125002, 'Hamilton', 42.2561111450195, 0.737508268569262, -71.7680587768555, -1.25258892342094, 218, 23, 'PPL', 'P'),
(131176, 'Hamilton', 42.6772193908691, 0.744857993966635, -86.0061111450195, -1.50108981631678, 218, 27, 'PPL', 'P'),
(135771, 'Hamilton', 43.7616691589355, 0.763785212991883, -92.4483337402344, -1.61352781174965, 218, 28, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(140166, 'Hamilton', 48.8086090087891, 0.851870930521935, -97.4524993896484, -1.70086697864713, 218, 34, 'PPL', 'P'),
(145355, 'Hamilton', 40.5061111450195, 0.706965006659361, -74.6205596923828, -1.30237445631305, 218, 37, 'PPL', 'P'),
(149409, 'Hamilton', 42.8269386291504, 0.747471087628221, -75.5449981689453, -1.31850895146118, 218, 40, 'PPL', 'P'),
(162389, 'Hamilton', 40.9241714477539, 0.71426153541396, -79.0811080932617, -1.38022571235295, 218, 45, 'PPL', 'P'),
(169407, 'Hamilton', 41.5483283996582, 0.725155129273902, -71.4416732788086, -1.24689242184926, 218, 47, 'PPL', 'P'),
(174396, 'Hamilton', 43.2841682434082, 0.755451249834644, -87.9716720581055, -1.53539532589864, 218, 57, 'PPL', 'P'),
(190290, 'Hamilton', 39.253059387207, 0.68509512778763, -115.485557556152, -2.01560321785627, 218, 39, 'PPL', 'P'),
(194224, 'Hamilton', 40.3672218322754, 0.704540930856144, -107.612503051758, -1.87819249456562, 218, 7, 'PPL', 'P'),
(196662, 'Hamilton', 46.246940612793, 0.807161382667521, -114.159439086914, -1.99245808429656, 218, 31, 'PPL', 'P'),
(200936, 'Hamilton', 44.7405586242676, 0.780870057175014, -119.308059692383, -2.08231846579801, 218, 43, 'PPL', 'P'),
(207581, 'Hamilton', 48.521671295166, 0.846862922671068, -121.988059997559, -2.12909329507778, 218, 56, 'PPL', 'P'),
(211863, 'Hamilton', 62.896110534668, 1.09774421552825, -163.894165039063, -2.86049280473862, 218, 1, 'PPL', 'P'),
(109526, 'Hamilton (historical)', 38.0205612182617, 0.663583976714733, -81.2486114501953, -1.41805578247947, 218, 58, 'PPL', 'P'),
(204203, 'Hamilton Acres', 40.5105590820313, 0.707042637805137, -111.944442749023, -1.95379910528075, 218, 52, 'PPL', 'P'),
(211864, 'Hamilton Acres', 64.8469390869141, 1.13179259690686, -147.670562744141, -2.57733752815813, 218, 1, 'PPL', 'P'),
(125003, 'Hamilton Beach', 41.7433280944824, 0.728558515988969, -70.7125015258789, -1.2341659739481, 218, 23, 'PPL', 'P'),
(149410, 'Hamilton Beach', 40.6522216796875, 0.709515116561167, -73.8277816772461, -1.28853786971149, 218, 40, 'PPL', 'P'),
(193613, 'Hamilton Branch', 40.2750015258789, 0.702931382872327, -121.090278625488, -2.11342405417208, 218, 6, 'PPL', 'P'),
(32669, 'Hamilton Camp (historical)', 37.2644386291504, 0.650387147986036, -94.904167175293, -1.65639019107199, 218, 20, 'PPL', 'P'),
(149411, 'Hamilton Center', 42.7897186279297, 0.746821476059323, -75.4961090087891, -1.31765567464792, 218, 40, 'PPL', 'P'),
(181996, 'Hamilton City', 39.7427787780762, 0.693642343569158, -122.012496948242, -2.12951980032636, 218, 6, 'PPL', 'P'),
(178324, 'Hamilton Corner', 33.2477798461914, 0.580283227294254, -111.840560913086, -1.95198602521063, 218, 5, 'PPL', 'P'),
(195047, 'Hamilton Corner', 43.9527816772461, 0.76712075567818, -116.771392822266, -2.03804527688821, 218, 17, 'PPL', 'P'),
(119910, 'Hamilton Corners', 41.7075004577637, 0.727933205765018, -89.9661102294922, -1.57020483871679, 218, 18, 'PPL', 'P'),
(162388, 'Hamilton Court', 40.0066719055176, 0.698248147516396, -75.2949981689453, -1.3141456283312, 218, 45, 'PPL', 'P'),
(102575, 'Hamilton Crossing', 38.2433280944824, 0.667471992169167, -77.434440612793, -1.35148594313325, 218, 53, 'PPL', 'P'),
(2951, 'Hamilton Crossroads', 31.6436100006104, 0.552285181727656, -85.8083267211914, -1.49763782691182, 218, 2, 'PPL', 'P'),
(21688, 'Hamilton Crossroads', 33.5652809143066, 0.585824666311464, -82.4947204589844, -1.43980448752161, 218, 13, 'PPL', 'P'),
(65326, 'Hamilton Crossroads', 35.0494384765625, 0.611728102391201, -80.3447189331055, -1.40227988197212, 218, 33, 'PPL', 'P'),
(209490, 'Hamilton Dome', 43.7733306884766, 0.763988745078192, -108.574996948242, -1.89499118208962, 218, 59, 'PPL', 'P'),
(78419, 'Hamilton Heights', 39.9580612182617, 0.697399730972123, -77.6797180175781, -1.3557668414275, 218, 45, 'PPL', 'P'),
(207582, 'Hamilton Junction', 48.526668548584, 0.846950141196768, -122.005561828613, -2.12939875965482, 218, 56, 'PPL', 'P'),
(65335, 'Hamilton Lakes', 36.0830612182617, 0.629768222457343, -79.8536071777344, -1.39370836484564, 218, 33, 'PPL', 'P'),
(72796, 'Hamilton Meadows', 39.8527793884277, 0.695562216398996, -82.9783325195313, -1.4482451102805, 218, 41, 'PPL', 'P'),
(87554, 'Hamilton Mill', 35.1086082458496, 0.612760809682906, -86.7788925170898, -1.51457739565749, 218, 50, 'PPL', 'P'),
(196663, 'Hamilton Mobile Home Park', 46.2338905334473, 0.806933615815292, -114.152778625488, -1.99234183731498, 218, 31, 'PPL', 'P'),
(13885, 'Hamilton Park', 39.7172203063965, 0.69319626408657, -75.5461120605469, -1.31852839253714, 218, 10, 'PPL', 'P'),
(162390, 'Hamilton Park', 40.0347213745117, 0.698737703103779, -76.3294372558594, -1.33219999630917, 218, 45, 'PPL', 'P'),
(21689, 'Hamilton Plantation Subdivision', 33.4269409179688, 0.583410177888171, -84.8583297729492, -1.4810572522811, 218, 13, 'PPL', 'P'),
(145356, 'Hamilton Square', 40.2272186279297, 0.702097413976969, -74.6536102294922, -1.30295129700516, 218, 37, 'PPL', 'P'),
(162391, 'Hamilton Square', 40.9244384765625, 0.714266195945868, -75.2949981689453, -1.3141456283312, 218, 45, 'PPL', 'P'),
(87555, 'Hamilton Subdivision', 35.8544387817383, 0.625778008196078, -84.4749984741211, -1.4743668589906, 218, 50, 'PPL', 'P'),
(55149, 'Hamilton Town', 37.7413902282715, 0.658711523763352, -90.4836120605469, -1.57923694955379, 218, 29, 'PPL', 'P'),
(102576, 'Hamilton town', 36.9619407653809, 0.645107564283009, -82.5975036621094, -1.44159839283188, 218, 53, 'PPL', 'P'),
(21690, 'Hamilton Trailer Park', 34.038890838623, 0.594090718860906, -83.4847183227539, -1.45708320983209, 218, 13, 'PPL', 'P'),
(169408, 'Hamiltons Corner', 41.6083297729492, 0.726202350793549, -71.5108337402344, -1.24809949961334, 218, 47, 'PPL', 'P'),
(192606, 'Hamiltons Fort', 37.6194381713867, 0.656583058841133, -113.150001525879, -1.97484007526319, 218, 52, 'PPL', 'P'),
(36258, 'Hamim', 38.127498626709, 0.665450386585688, -83.3138885498047, -1.4541016678337, 218, 21, 'PPL', 'P'),
(9304, 'Hamiter', 34.6622200012207, 0.604969865071934, -92.0672225952148, -1.60687616745302, 218, 4, 'PPL', 'P'),
(155592, 'Hamler', 41.2291717529297, 0.719584794958865, -84.0341720581055, -1.46667298660136, 218, 41, 'PPL', 'P'),
(9305, 'Hamlet', 35.0780601501465, 0.612227644832673, -92.3050003051758, -1.61102617137969, 218, 4, 'PPL', 'P'),
(55151, 'Hamlet', 37.7572212219238, 0.658987826726447, -93.6408309936523, -1.63434081514279, 218, 29, 'PPL', 'P'),
(65333, 'Hamlet', 34.8847198486328, 0.608853219994461, -79.6944427490234, -1.39093042151258, 218, 33, 'PPL', 'P'),
(72802, 'Hamlet', 39.0188903808594, 0.68100810762074, -84.1997222900391, -1.46956238322604, 218, 41, 'PPL', 'P'),
(119908, 'Hamlet', 41.3138885498047, 0.721063381996077, -90.7350006103516, -1.5836245074497, 218, 18, 'PPL', 'P'),
(122756, 'Hamlet', 41.5475006103516, 0.725140681624988, -86.5822219848633, -1.51114484732848, 218, 19, 'PPL', 'P'),
(149414, 'Hamlet', 42.3697204589844, 0.73949112515888, -79.1352767944336, -1.38117113453993, 218, 40, 'PPL', 'P'),
(169409, 'Hamlet', 42.0008316040039, 0.733052800065559, -71.5052795410156, -1.24800256054966, 218, 47, 'PPL', 'P'),
(181997, 'Hamlet', 38.2077789306641, 0.666851542214206, -122.924438476563, -2.14543618258122, 218, 6, 'PPL', 'P'),
(186814, 'Hamlet', 38.1547203063965, 0.665925494524158, -104.093330383301, -1.81677134455485, 218, 7, 'PPL', 'P'),
(198384, 'Hamlet', 48.6286087036133, 0.848729332542023, -103.051109313965, -1.79858115536128, 218, 34, 'PPL', 'P'),
(199375, 'Hamlet', 40.3849983215332, 0.704851189123138, -101.234169006348, -1.76686956468116, 218, 35, 'PPL', 'P'),
(200937, 'Hamlet', 45.8463897705078, 0.800170451648009, -123.699440002441, -2.15896251091579, 218, 43, 'PPL', 'P'),
(21691, 'Hamlet (historical)', 34.0686111450195, 0.594609436062226, -85.0861129760742, -1.48503281915637, 218, 13, 'PPL', 'P'),
(60158, 'Hamlet (historical)', 32.0244407653809, 0.558931932465789, -89.2766723632813, -1.55817187796349, 218, 30, 'PPL', 'P'),
(109529, 'Hamlet (historical)', 37.8280601501465, 0.660224199262517, -81.0094375610352, -1.41388141062883, 218, 58, 'PPL', 'P'),
(94702, 'Hamlet Colonia', 26.2670001983643, 0.45844563808346, -98.2880020141602, -1.71544925035391, 218, 51, 'PPL', 'P'),
(47791, 'Hamlet Farms', 39.6277809143066, 0.69163525221362, -76.6855621337891, -1.33841554797731, 218, 25, 'PPL', 'P'),
(65334, 'Hamlet Lakes', 35.7361106872559, 0.623712793349748, -79.7905578613281, -1.39260794668322, 218, 33, 'PPL', 'P'),
(47792, 'Hamlet North', 39.1444396972656, 0.683199356565658, -77.1680603027344, -1.34683672966025, 218, 25, 'PPL', 'P'),
(81410, 'Hamlet South', 33.9461097717285, 0.592471383760083, -81.1636123657227, -1.41657226859424, 218, 48, 'PPL', 'P'),
(81411, 'Hamlet West', 33.9508285522461, 0.592553742016794, -81.1836090087891, -1.4169212758551, 218, 48, 'PPL', 'P'),
(27370, 'Hamletsburg', 37.1386108398438, 0.64819103877213, -88.4316711425781, -1.54342382447884, 218, 18, 'PPL', 'P'),
(72803, 'Hamley Run', 39.3974990844727, 0.687616076075499, -82.1694412231445, -1.43412729386783, 218, 41, 'PPL', 'P'),
(9306, 'Hamlin', 35.2350006103516, 0.614966772592846, -90.9274978637695, -1.58698421832289, 218, 4, 'PPL', 'P'),
(32670, 'Hamlin', 39.9161109924316, 0.696667561409434, -95.6277770996094, -1.66901956675142, 218, 20, 'PPL', 'P'),
(36259, 'Hamlin', 36.598331451416, 0.638761384563405, -88.0763931274414, -1.53722305335476, 218, 21, 'PPL', 'P'),
(60159, 'Hamlin', 34.503059387207, 0.6021919883179, -90.4572219848633, -1.57877635584326, 218, 30, 'PPL', 'P'),
(102577, 'Hamlin', 36.9280586242676, 0.644516209362957, -82.2786102294922, -1.43603265246973, 218, 53, 'PPL', 'P'),
(109528, 'Hamlin', 38.2786102294922, 0.668087781592221, -82.1030578613281, -1.43296868563559, 218, 58, 'PPL', 'P'),
(115912, 'Hamlin', 41.6669387817383, 0.727225270968248, -94.9055633544922, -1.65641455899596, 218, 16, 'PPL', 'P'),
(127669, 'Hamlin', 47.0658302307129, 0.821453702710622, -67.7944412231445, -1.18323621389364, 218, 26, 'PPL', 'P'),
(140170, 'Hamlin', 46.1661109924316, 0.805750639659079, -97.2847213745117, -1.69793869987053, 218, 34, 'PPL', 'P'),
(149415, 'Hamlin', 43.3030586242676, 0.755780949177595, -77.92138671875, -1.35998475596197, 218, 40, 'PPL', 'P'),
(162396, 'Hamlin', 41.4036102294922, 0.722629320717044, -75.3988876342773, -1.31595884155938, 218, 45, 'PPL', 'P'),
(191578, 'Hamlin', 32.8847198486328, 0.573946634954574, -100.126106262207, -1.74753022147723, 218, 51, 'PPL', 'P'),
(41250, 'Hamlin (historical)', 31.7250003814697, 0.553705711853104, -93.5858306884766, -1.63338087872787, 218, 22, 'PPL', 'P'),
(131180, 'Hamlin Lake', 44.0224990844727, 0.768337553980237, -86.4555587768555, -1.50893415730761, 218, 27, 'PPL', 'P'),
(162397, 'Hamlin Station', 41.7108306884766, 0.727991329255809, -78.3947219848633, -1.36824601482145, 218, 45, 'PPL', 'P'),
(87556, 'Hamlin Town', 36.5658302307129, 0.638194131251218, -83.934440612793, -1.46493234451288, 218, 50, 'PPL', 'P'),
(192607, 'Hamlin Valley', 37.9983291625977, 0.663195954143909, -113.968887329102, -1.98913232872727, 218, 52, 'PPL', 'P'),
(102578, 'Hamlins Corner', 37.9413909912109, 0.662202195583146, -76.4611129760742, -1.33449817117186, 218, 53, 'PPL', 'P'),
(207583, 'Hamma Hamma', 47.5269393920898, 0.82950157578776, -123.050003051758, -2.14762769784224, 218, 56, 'PPL', 'P'),
(2952, 'Hammac', 31.1222190856934, 0.543185193572368, -87.2230606079102, -1.5223295912746, 218, 2, 'PPL', 'P'),
(55152, 'Hammack', 39.7172203063965, 0.69319626408657, -92.7252807617188, -1.61836144912815, 218, 29, 'PPL', 'P'),
(155593, 'Hammansburg', 41.226390838623, 0.719536258847998, -83.688606262207, -1.46064172568066, 218, 41, 'PPL', 'P'),
(47793, 'Hammarlee', 39.1755599975586, 0.683742508269979, -76.602783203125, -1.33697078308594, 218, 25, 'PPL', 'P'),
(149417, 'Hammel', 40.5877799987793, 0.708390397053799, -73.8105621337891, -1.28823733198247, 218, 40, 'PPL', 'P'),
(41251, 'Hammell (historical)', 32.0544395446777, 0.559455509936098, -93.3708267211914, -1.62962835159389, 218, 22, 'PPL', 'P'),
(131183, 'Hammell Beach', 44.0938911437988, 0.769583580475258, -83.5802764892578, -1.45875101446476, 218, 27, 'PPL', 'P'),
(21694, 'Hammer', 34.1852798461914, 0.596645689031701, -83.9574966430664, -1.4653347481536, 218, 13, 'PPL', 'P'),
(170453, 'Hammer', 45.855281829834, 0.800325647360533, -97.0208282470703, -1.6933328959233, 218, 49, 'PPL', 'P'),
(78422, 'Hammer Hall', 39.8394393920898, 0.695329389540696, -77.3036117553711, -1.34920254881462, 218, 45, 'PPL', 'P'),
(193614, 'Hammer Place', 40.1197204589844, 0.700221216989008, -122.716110229492, -2.14180016874493, 218, 6, 'PPL', 'P'),
(87557, 'Hammer Store', 36.246940612793, 0.632628457468088, -83.5250015258789, -1.45778628435987, 218, 50, 'PPL', 'P'),
(211865, 'Hammerhead', 51.8486099243164, 0.904928955761529, -176.641662597656, -3.08297860852602, 218, 1, 'PPL', 'P'),
(162399, 'Hammersley', 41.5508308410645, 0.725198805115779, -77.9674987792969, -1.36078956324339, 218, 45, 'PPL', 'P'),
(162400, 'Hammersley Fork', 41.4324989318848, 0.723133523690423, -77.9208297729492, -1.35997503542399, 218, 45, 'PPL', 'P'),
(113519, 'Hammertown', 42.0430603027344, 0.733789829897239, -73.4130630493164, -1.28129966418476, 218, 8, 'PPL', 'P'),
(149419, 'Hammertown', 41.9755592346191, 0.732611714010015, -73.6408309936523, -1.28527496474392, 218, 40, 'PPL', 'P'),
(21692, 'Hammett', 32.6563911437988, 0.569961547278407, -84.0188903808594, -1.46640627101819, 218, 13, 'PPL', 'P'),
(162401, 'Hammett', 42.0666694641113, 0.734201887496901, -79.9688873291016, -1.3957203830492, 218, 45, 'PPL', 'P'),
(195048, 'Hammett', 42.9458312988281, 0.749546156170584, -115.465278625488, -2.0152492837474, 218, 17, 'PPL', 'P'),
(9309, 'Hammett (historical)', 36.3141708374023, 0.633801846244377, -90.2416687011719, -1.57501424132936, 218, 4, 'PPL', 'P'),
(81413, 'Hammett (historical)', 34.3647193908691, 0.599777499894607, -82.3272171020508, -1.43688100243497, 218, 48, 'PPL', 'P'),
(21693, 'Hammett Acres', 33.1744384765625, 0.579003178916307, -84.9875030517578, -1.4833117513019, 218, 13, 'PPL', 'P'),
(94703, 'Hammetts Crossing', 30.3400001525879, 0.529532897718241, -98.1377792358398, -1.71282736826073, 218, 51, 'PPL', 'P'),
(81414, 'Hammetts Crossroads', 34.149169921875, 0.596015451959733, -80.3097229003906, -1.40166908597611, 218, 48, 'PPL', 'P'),
(181998, 'Hammil', 37.6786117553711, 0.657615832711866, -118.402778625488, -2.06651833052474, 218, 6, 'PPL', 'P'),
(41252, 'Hammock', 32.6363906860352, 0.569612473438524, -92.0377807617188, -1.60636231052069, 218, 22, 'PPL', 'P'),
(16331, 'Hammocks', 25.6711101531982, 0.448045394815455, -80.4447174072266, -1.4040251845925, 218, 12, 'PPL', 'P'),
(76012, 'Hammon', 35.6327781677246, 0.621909300659547, -99.3813934326172, -1.73453253061904, 218, 42, 'PPL', 'P'),
(76013, 'Hammon Junction', 35.6561088562012, 0.62231649799022, -99.375, -1.73442094416937, 218, 42, 'PPL', 'P'),
(421, 'Hammond', 33.9252815246582, 0.592107862271288, -84.3675003051758, -1.47249066200264, 218, 13, 'PPL', 'P'),
(16332, 'Hammond', 29.3816699981689, 0.512806881202484, -81.5219421386719, -1.42282630294013, 218, 12, 'PPL', 'P'),
(27371, 'Hammond', 39.7969398498535, 0.694587632598082, -88.591667175293, -1.54621628203985, 218, 18, 'PPL', 'P'),
(32672, 'Hammond', 37.9355583190918, 0.662100396250478, -94.6949996948242, -1.65273952984971, 218, 20, 'PPL', 'P'),
(36260, 'Hammond', 36.9569396972656, 0.645020279178282, -83.7275009155273, -1.46132056544252, 218, 21, 'PPL', 'P'),
(41253, 'Hammond', 30.5041694641113, 0.532398192735057, -90.4611129760742, -1.57884426645106, 218, 22, 'PPL', 'P'),
(55153, 'Hammond', 36.6755599975586, 0.640109276970121, -92.644172668457, -1.61694584585072, 218, 29, 'PPL', 'P'),
(81416, 'Hammond', 34.1394386291504, 0.595845608861214, -80.5844421386719, -1.40646384120269, 218, 48, 'PPL', 'P'),
(94704, 'Hammond', 31.0949993133545, 0.542710118923412, -96.7136077880859, -1.68797088738453, 218, 51, 'PPL', 'P'),
(109530, 'Hammond', 39.4058303833008, 0.687761484671018, -80.1013870239258, -1.39803293898177, 218, 58, 'PPL', 'P'),
(122757, 'Hammond', 41.5833282470703, 0.725765991848939, -87.5, -1.52716309549504, 218, 19, 'PPL', 'P'),
(131184, 'Hammond', 45.4972190856934, 0.794076273546553, -84.0369415283203, -1.46672132297515, 218, 27, 'PPL', 'P'),
(135774, 'Hammond', 44.2222213745117, 0.771823365531042, -92.3733291625977, -1.61221873491583, 218, 28, 'PPL', 'P'),
(149418, 'Hammond', 44.4488906860352, 0.775779491330355, -75.6944427490234, -1.32111725143281, 218, 40, 'PPL', 'P'),
(162402, 'Hammond', 41.8827781677246, 0.730992378909192, -77.1949996948242, -1.3473069107507, 218, 45, 'PPL', 'P'),
(174400, 'Hammond', 44.978889465332, 0.785029715060636, -92.4355621337891, -1.61330490516641, 218, 57, 'PPL', 'P'),
(182000, 'Hammond', 36.4655609130859, 0.636444101519899, -118.860282897949, -2.07450328642112, 218, 6, 'PPL', 'P'),
(196664, 'Hammond', 45.2255592346191, 0.789334914699831, -104.917503356934, -1.83115587655069, 218, 31, 'PPL', 'P'),
(200938, 'Hammond', 46.2002792358398, 0.806346988006175, -123.95027923584, -2.16334048143177, 218, 43, 'PPL', 'P'),
(155594, 'Hammond Crossroad', 40.1841697692871, 0.70134606965443, -80.9561080932617, -1.41295063582785, 218, 41, 'PPL', 'P'),
(65337, 'Hammond Crossroads', 34.4749984741211, 0.601702232993434, -79.2355575561523, -1.38292136400833, 218, 33, 'PPL', 'P'),
(81417, 'Hammond Crossroads', 33.7144393920898, 0.588427972856043, -80.8722229003906, -1.41148656301857, 218, 48, 'PPL', 'P'),
(125005, 'Hammond Heights', 42.2738914489746, 0.737818593415283, -71.8180618286133, -1.25346164131016, 218, 23, 'PPL', 'P'),
(47794, 'Hammond Hills', 39.1433296203613, 0.683179982068727, -76.8888931274414, -1.34196434328789, 218, 25, 'PPL', 'P'),
(47796, 'Hammond Park', 39.1569404602051, 0.683417536037962, -76.8855590820313, -1.34190615321807, 218, 25, 'PPL', 'P'),
(47797, 'Hammond Village', 39.1522216796875, 0.683335177781252, -76.8788909912109, -1.34178977307844, 218, 25, 'PPL', 'P'),
(149421, 'Hammonds Corner', 43.4724998474121, 0.758738256410074, -76.3847198486328, -1.33316485957211, 218, 40, 'PPL', 'P'),
(47798, 'Hammonds Estates', 39.4238891601563, 0.688076669786029, -76.9569396972656, -1.34315197997601, 218, 25, 'PPL', 'P'),
(47799, 'Hammonds Promise', 39.1272201538086, 0.682898818836642, -76.8486099243164, -1.34126126876011, 218, 25, 'PPL', 'P'),
(115914, 'Hammondsburgh (historical)', 41.3069381713867, 0.720942075008424, -93.4727783203125, -1.63140774267623, 218, 16, 'PPL', 'P'),
(149422, 'Hammondsport', 42.4077796936035, 0.740155384113773, -77.2238922119141, -1.34781118030311, 218, 40, 'PPL', 'P'),
(9307, 'Hammondsville', 35.1711082458496, 0.613851640465403, -92.0824966430664, -1.60714274987813, 218, 4, 'PPL', 'P'),
(155595, 'Hammondsville', 40.5574989318848, 0.707861892735473, -80.7072219848633, -1.40860675377382, 218, 41, 'PPL', 'P'),
(172093, 'Hammondsville', 43.4902801513672, 0.759048581256095, -72.5536117553711, -1.26629940934489, 218, 55, 'PPL', 'P'),
(2953, 'Hammondville', 34.5816688537598, 0.603563982332481, -85.6266708374023, -1.49446733363408, 218, 2, 'PPL', 'P'),
(16333, 'Hammondville', 26.2441692352295, 0.458047162605357, -80.2013931274414, -1.3997783747602, 218, 12, 'PPL', 'P'),
(162403, 'Hammondville', 40.1205596923828, 0.700235864375003, -79.5338897705078, -1.3881282434136, 218, 45, 'PPL', 'P'),
(9308, 'Hammons', 33.0955581665039, 0.577626457790791, -94.041389465332, -1.64133187932035, 218, 4, 'PPL', 'P'),
(70923, 'Hammonton', 39.6363906860352, 0.691785521078128, -74.8027801513672, -1.30555480328682, 218, 37, 'PPL', 'P'),
(182001, 'Hammonton', 39.1930618286133, 0.684047972847011, -121.419723510742, -2.11917395212362, 218, 6, 'PPL', 'P'),
(36261, 'Hammonville', 37.4147186279297, 0.653010028764628, -85.7975006103516, -1.49744887563248, 218, 21, 'PPL', 'P'),
(13886, 'Hammville', 39.2272186279297, 0.684644121457025, -75.5783309936523, -1.31909071900131, 218, 10, 'PPL', 'P'),
(2954, 'Hamner', 32.7433280944824, 0.571478883309479, -88.269172668457, -1.54058769107596, 218, 2, 'PPL', 'P'),
(36262, 'Hamner', 37.6477813720703, 0.657077741013615, -87.9469375610352, -1.53496362748593, 218, 21, 'PPL', 'P'),
(2955, 'Hamner Estates', 33.2777786254883, 0.580806804764563, -87.5486068725586, -1.52801144546028, 218, 2, 'PPL', 'P'),
(94706, 'Hamon', 29.4050006866455, 0.513214078533157, -97.3488922119141, -1.69905869226697, 218, 51, 'PPL', 'P'),
(78423, 'Hamorton', 39.8683280944824, 0.695833592514075, -75.6558303833008, -1.32044333851896, 218, 45, 'PPL', 'P'),
(2956, 'Hampden', 32.0813903808594, 0.559925890763634, -87.6288909912109, -1.52941266766783, 218, 2, 'PPL', 'P'),
(47800, 'Hampden', 39.3308296203613, 0.686452474416217, -76.6352767944336, -1.33753790324007, 218, 25, 'PPL', 'P'),
(109531, 'Hampden', 37.6394386291504, 0.656932132681015, -81.9488906860352, -1.43027796082823, 218, 58, 'PPL', 'P'),
(125006, 'Hampden', 42.0638885498047, 0.734153351386035, -72.4138870239258, -1.2638607527347, 218, 23, 'PPL', 'P'),
(127672, 'Hampden', 44.7444381713867, 0.780937768045729, -68.8375015258789, -1.20144105047321, 218, 26, 'PPL', 'P'),
(140173, 'Hampden', 48.5402793884277, 0.847187695166003, -98.6538925170898, -1.72183524433181, 218, 34, 'PPL', 'P'),
(127673, 'Hampden Center', 44.7488899230957, 0.781015465770532, -68.8872222900391, -1.20230884151441, 218, 26, 'PPL', 'P'),
(127674, 'Hampden Highlands', 44.7322196960449, 0.780724515421441, -68.841667175293, -1.20151375477097, 218, 26, 'PPL', 'P'),
(102579, 'Hampden Hills', 37.2386093139648, 0.649936341392513, -79.9186096191406, -1.39484287147002, 218, 53, 'PPL', 'P'),
(127675, 'Hampden Station', 44.7463912963867, 0.780971856507682, -68.8647232055664, -1.20191615841168, 218, 26, 'PPL', 'P'),
(102580, 'Hampden Sydney', 37.2422218322754, 0.649999391731321, -78.4599990844727, -1.36938531513578, 218, 53, 'PPL', 'P'),
(162404, 'Hampden Village Mobile Home Park', 40.2563896179199, 0.702606543798365, -76.9883270263672, -1.34369979221224, 218, 45, 'PPL', 'P'),
(140175, 'Hample', 46.1372184753418, 0.805246370106673, -97.9775009155273, -1.71002998385171, 218, 34, 'PPL', 'P'),
(174404, 'Hamples Corner', 44.3516693115234, 0.774082658241811, -88.4752807617188, -1.54418495591839, 218, 57, 'PPL', 'P'),
(47816, 'Hampshire', 39.5161094665527, 0.689686217769845, -76.5558319091797, -1.33615132841852, 218, 25, 'PPL', 'P'),
(87558, 'Hampshire', 35.5966682434082, 0.621279063587579, -87.2930603027344, -1.52355131642467, 218, 50, 'PPL', 'P'),
(109532, 'Hampshire', 39.4719390869141, 0.688915299213295, -79.0772171020508, -1.38015780174516, 218, 58, 'PPL', 'P'),
(119911, 'Hampshire', 42.0977783203125, 0.734744839464141, -88.5302810668945, -1.54514489233331, 218, 18, 'PPL', 'P'),
(149423, 'Hampshire', 42.163330078125, 0.735888933468439, -77.5244369506836, -1.35305667554418, 218, 40, 'PPL', 'P'),
(13122, 'Hampshire Knolls', 38.961109161377, 0.679999635094955, -77.0041732788086, -1.34397636149145, 218, 9, 'PPL', 'P'),
(47802, 'Hampshire Knolls', 38.9680595397949, 0.680120942082608, -76.9952774047852, -1.3438210991999, 218, 25, 'PPL', 'P'),
(143917, 'Hampshire Road', 42.7430610656738, 0.746007147977005, -71.2016677856445, -1.24270353577068, 218, 36, 'PPL', 'P'),
(47803, 'Hampstead', 39.6047210693359, 0.691232781993882, -76.8502807617188, -1.34129043037405, 218, 25, 'PPL', 'P'),
(65341, 'Hampstead', 34.3675003051758, 0.599826036005473, -77.7108306884766, -1.35630985997377, 218, 33, 'PPL', 'P'),
(72804, 'Hampstead', 39.6808280944824, 0.692561100166586, -84.1350021362305, -1.46843280344968, 218, 41, 'PPL', 'P'),
(102582, 'Hampstead', 37.6058311462402, 0.656345571450925, -77.129997253418, -1.34617240412633, 218, 53, 'PPL', 'P'),
(143918, 'Hampstead', 42.874439239502, 0.748300129675563, -71.1816711425781, -1.24235452850982, 218, 36, 'PPL', 'P'),
(47804, 'Hampstead Heights', 39.6191711425781, 0.691484983349112, -76.8513870239258, -1.34130973829195, 218, 25, 'PPL', 'P'),
(113521, 'Hampsted', 41.9502792358398, 0.732170494796416, -72.8958282470703, -1.27227221387966, 218, 8, 'PPL', 'P'),
(2957, 'Hampton', 32.958610534668, 0.575236270712445, -85.6119384765625, -1.49421020543083, 218, 2, 'PPL', 'P'),
(9310, 'Hampton', 33.5377807617188, 0.585344698104004, -92.4697189331055, -1.61390105377643, 218, 4, 'PPL', 'P'),
(13887, 'Hampton', 39.8252792358398, 0.695082248191537, -75.5227813720703, -1.31812119520647, 218, 10, 'PPL', 'P'),
(16334, 'Hampton', 29.8641700744629, 0.521228096174938, -82.1311111450195, -1.433458307802, 218, 12, 'PPL', 'P'),
(21696, 'Hampton', 33.3869400024414, 0.582712030208406, -84.2830581665039, -1.47101686865539, 218, 13, 'PPL', 'P'),
(36263, 'Hampton', 37.2830581665039, 0.650712120218053, -88.3713912963867, -1.54237174269021, 218, 21, 'PPL', 'P'),
(41254, 'Hampton', 30.5944404602051, 0.533973718835948, -92.6202774047852, -1.61652879482401, 218, 22, 'PPL', 'P'),
(47807, 'Hampton', 38.648609161377, 0.674545481182472, -76.1097183227539, -1.32836517749751, 218, 25, 'PPL', 'P'),
(55154, 'Hampton', 39.2813911437988, 0.685589610223031, -94.7330627441406, -1.65340385538363, 218, 29, 'PPL', 'P'),
(60160, 'Hampton', 33.0308303833008, 0.576496744856379, -91.0019378662109, -1.58828344146068, 218, 30, 'PPL', 'P'),
(65342, 'Hampton', 36.2183303833008, 0.632129114763698, -78.835563659668, -1.3759401535268, 218, 33, 'PPL', 'P'),
(78424, 'Hampton', 39.9294395446777, 0.696900188530652, -77.0586090087891, -1.34492644421033, 218, 45, 'PPL', 'P'),
(81419, 'Hampton', 32.8777809143066, 0.573825527704003, -81.1277770996094, -1.41594682521224, 218, 48, 'PPL', 'P'),
(87559, 'Hampton', 36.2841682434082, 0.633278202195041, -82.1727828979492, -1.4341856170957, 218, 50, 'PPL', 'P'),
(102583, 'Hampton', 37.0297203063965, 0.646290540439222, -76.3455581665039, -1.33248135927834, 218, 53, 'PPL', 'P'),
(109534, 'Hampton', 38.938060760498, 0.679597364612298, -80.2399978637695, -1.40045215451599, 218, 58, 'PPL', 'P'),
(113522, 'Hampton', 41.7838897705078, 0.729266450785739, -72.0552825927734, -1.25760192469885, 218, 8, 'PPL', 'P'),
(115916, 'Hampton', 42.7419395446777, 0.745987573742992, -93.2022171020508, -1.62668555858935, 218, 16, 'PPL', 'P'),
(119913, 'Hampton', 41.5558280944824, 0.72528602364148, -90.4091720581055, -1.577937726416, 218, 18, 'PPL', 'P'),
(135778, 'Hampton', 44.610279083252, 0.778596250236304, -93.0019378662109, -1.62319002650057, 218, 28, 'PPL', 'P'),
(141984, 'Hampton', 40.8788909912109, 0.713471242360479, -97.8855590820313, -1.70842529613688, 218, 35, 'PPL', 'P'),
(143920, 'Hampton', 42.9375, 0.749400747575065, -70.8394393920898, -1.23638145765894, 218, 36, 'PPL', 'P'),
(145358, 'Hampton', 40.7069396972656, 0.710470126128069, -74.9563903808594, -1.3082358075562, 218, 37, 'PPL', 'P'),
(149424, 'Hampton', 43.5247192382813, 0.759649656714126, -73.2522201538086, -1.27849242607971, 218, 40, 'PPL', 'P'),
(195049, 'Hampton', 46.9144401550293, 0.8188114474351, -116.848327636719, -2.03938804270983, 218, 17, 'PPL', 'P'),
(200939, 'Hampton', 43.672779083252, 0.762233788498857, -120.232780456543, -2.09845788779417, 218, 43, 'PPL', 'P'),
(207584, 'Hampton', 48.9422187805176, 0.854202860951436, -122.340827941895, -2.13525025720194, 218, 56, 'PPL', 'P'),
(209491, 'Hampton', 41.5361099243164, 0.724941876649614, -110.308059692383, -1.92523883311852, 218, 59, 'PPL', 'P'),
(81420, 'Hampton Acres', 34.5838890075684, 0.603602731326342, -82.5952835083008, -1.44155964383802, 218, 48, 'PPL', 'P'),
(149425, 'Hampton Bays', 40.8688888549805, 0.713296672151025, -72.5180587768555, -1.2656788928109, 218, 40, 'PPL', 'P'),
(16335, 'Hampton Beach', 29.8713893890381, 0.521354096984012, -82.1669387817383, -1.43408361802595, 218, 12, 'PPL', 'P'),
(143921, 'Hampton Beach', 42.9072189331055, 0.748872243256739, -70.8125, -1.23591127656848, 218, 36, 'PPL', 'P'),
(149426, 'Hampton Beach', 40.8088912963867, 0.712249517210405, -72.5911102294922, -1.26695388118278, 218, 40, 'PPL', 'P'),
(143922, 'Hampton Beach State Recreational Vehicle Park', 42.8969383239746, 0.748692812778295, -70.8147201538086, -1.23595002556235, 218, 36, 'PPL', 'P'),
(143923, 'Hampton Beach Trailer Park', 42.939998626709, 0.749444356837915, -70.7975006103516, -1.23564948783333, 218, 36, 'PPL', 'P'),
(47808, 'Hampton Chase', 39.1444396972656, 0.683199356565658, -76.4738922119141, -1.33472121091315, 218, 25, 'PPL', 'P'),
(47809, 'Hampton Court', 38.4413909912109, 0.670928841843117, -75.4980621337891, -1.31768976310987, 218, 25, 'PPL', 'P'),
(47810, 'Hampton East', 39.4249992370605, 0.688096044282959, -76.5713882446289, -1.33642283769166, 218, 25, 'PPL', 'P'),
(21697, 'Hampton Estates', 33.9986114501953, 0.593387710912152, -84.7616729736328, -1.47937027288859, 218, 13, 'PPL', 'P'),
(143924, 'Hampton Falls', 42.9161109924316, 0.749027438969263, -70.8641662597656, -1.23681302291359, 218, 36, 'PPL', 'P'),
(21698, 'Hampton Farms', 33.9544410705566, 0.592616792355602, -84.408332824707, -1.47320332391034, 218, 13, 'PPL', 'P'),
(70926, 'Hampton Furnace', 39.7694396972656, 0.694107664390622, -74.6808319091797, -1.30342640494363, 218, 37, 'PPL', 'P'),
(47811, 'Hampton Gardens', 39.4194412231445, 0.687999038640253, -76.5558319091797, -1.33615132841852, 218, 25, 'PPL', 'P'),
(70927, 'Hampton Gate', 39.8041687011719, 0.694713799854724, -74.6788864135742, -1.30339244963973, 218, 37, 'PPL', 'P'),
(47812, 'Hampton Heights', 38.6847190856934, 0.67517571825444, -76.6572189331055, -1.33792086580483, 218, 25, 'PPL', 'P'),
(65347, 'Hampton Heights', 35.8455581665039, 0.625623012220635, -81.5213928222656, -1.42281671556021, 218, 33, 'PPL', 'P'),
(81422, 'Hampton Heights', 34.8997192382813, 0.609115008729615, -82.3469390869141, -1.43722521600586, 218, 48, 'PPL', 'P'),
(145359, 'Hampton Junction', 40.711109161377, 0.710542897004855, -74.9530563354492, -1.30817761748638, 218, 37, 'PPL', 'P'),
(47813, 'Hampton Knolls', 39.3863906860352, 0.687422197948142, -77.1291732788086, -1.34615802305644, 218, 25, 'PPL', 'P'),
(21700, 'Hampton Lake', 33.9730606079102, 0.592941764587619, -84.4075012207031, -1.4731888096824, 218, 13, 'PPL', 'P'),
(70928, 'Hampton Lakes', 39.8916702270508, 0.69624098958183, -74.7122192382813, -1.30397421717986, 218, 37, 'PPL', 'P'),
(143926, 'Hampton Landing', 42.9244384765625, 0.749172780985754, -70.8363876342773, -1.23632819443714, 218, 36, 'PPL', 'P'),
(36264, 'Hampton Manor', 37.982780456543, 0.66292457802883, -84.1922225952148, -1.46943148885846, 218, 21, 'PPL', 'P'),
(47814, 'Hampton Manor', 39.1027793884277, 0.682472247009039, -76.5972213745117, -1.33687371086421, 218, 25, 'PPL', 'P'),
(149427, 'Hampton Manor', 42.6208305358887, 0.743873822785797, -73.728889465332, -1.28681187500901, 218, 40, 'PPL', 'P'),
(87561, 'Hampton Mill', 36.1127815246582, 0.630286939658663, -82.6838912963867, -1.44310614148303, 218, 50, 'PPL', 'P'),
(149429, 'Hampton Park', 40.9091682434082, 0.713999680099778, -72.3947219848633, -1.26352625970179, 218, 40, 'PPL', 'P'),
(125010, 'Hampton Ponds', 42.1833305358887, 0.736238007308321, -72.7011108398438, -1.26887375401261, 218, 23, 'PPL', 'P'),
(47815, 'Hampton Ridge', 39.5555610656738, 0.690374778069685, -76.3333282470703, -1.33226790691697, 218, 25, 'PPL', 'P'),
(81424, 'Hampton Shores', 34.7416687011719, 0.606356506472511, -82.954719543457, -1.44783298610181, 218, 48, 'PPL', 'P'),
(16336, 'Hampton Springs', 30.0852794647217, 0.525087183042031, -83.6549987792969, -1.46005516445057, 218, 12, 'PPL', 'P'),
(87562, 'Hampton Station', 36.6136093139648, 0.639028033567549, -87.2255630493164, -1.52237326711648, 218, 50, 'PPL', 'P'),
(162406, 'Hampton Station', 41.3869400024414, 0.722338370367953, -79.5633316040039, -1.38864210034593, 218, 45, 'PPL', 'P'),
(47817, 'Hampton Village', 39.4166717529297, 0.687950702266468, -76.5963897705078, -1.33685919663627, 218, 25, 'PPL', 'P'),
(125011, 'Hampton Village', 42.1680603027344, 0.735971491462232, -72.754997253418, -1.26981424935157, 218, 23, 'PPL', 'P'),
(87563, 'Hampton Woods', 35.1744384765625, 0.613909763956194, -85.2238922119141, -1.48743752046265, 218, 50, 'PPL', 'P'),
(149431, 'Hamptonburgh', 41.435001373291, 0.7231771995323, -74.2605590820313, -1.29609126035322, 218, 40, 'PPL', 'P'),
(16337, 'Hamptons at Boca Raton', 26.3822193145752, 0.460456591022579, -80.1861114501953, -1.39951165917703, 218, 12, 'PPL', 'P'),
(21701, 'Hamptons Corner', 33.3647193908691, 0.582324207374663, -84.5511093139648, -1.47569524374233, 218, 13, 'PPL', 'P'),
(87564, 'Hamptons Crossroads', 36.0541687011719, 0.629263952904937, -85.5166702270508, -1.49254746080424, 218, 50, 'PPL', 'P'),
(65346, 'Hamptonville', 36.098331451416, 0.630034738303433, -80.7605590820313, -1.40953766173285, 218, 33, 'PPL', 'P'),
(113524, 'Hamptonville', 41.7966690063477, 0.729489490527033, -72.0472183227539, -1.25746117663524, 218, 8, 'PPL', 'P'),
(65349, 'Hamrick', 35.8097190856934, 0.624997502259603, -82.1991729736328, -1.43464621080623, 218, 33, 'PPL', 'P'),
(94708, 'Hamrick', 31.8583297729492, 0.556032748724101, -99.4797210693359, -1.73624867162549, 218, 51, 'PPL', 'P'),
(200940, 'Hamricks Corner', 45.1513900756836, 0.78804041867297, -122.680557250977, -2.14117965221094, 218, 43, 'PPL', 'P'),
(182002, 'Hams', 38.3741683959961, 0.669755586224883, -120.461112976074, -2.10244304204936, 218, 6, 'PPL', 'P'),
(65348, 'Hams Crossroads', 35.5283317565918, 0.620086366893387, -77.2219390869141, -1.34777709184115, 218, 33, 'PPL', 'P'),
(102586, 'Hams Ford', 38.1222190856934, 0.665358241211971, -77.5516662597656, -1.35353191664071, 218, 53, 'PPL', 'P'),
(55155, 'Hams Prairie', 38.767219543457, 0.676615622876818, -91.9188919067383, -1.60428730855735, 218, 29, 'PPL', 'P'),
(94707, 'Hamshire', 29.8613891601563, 0.521179560064071, -94.3122177124023, -1.64605872393914, 218, 51, 'PPL', 'P'),
(131186, 'Hamtramck', 42.3927803039551, 0.739893595378619, -83.0497207641602, -1.4494910701965, 218, 27, 'PPL', 'P'),
(81427, 'Hamville (historical)', 34.0183296203613, 0.593731857904018, -79.8550033569336, -1.39373273276962, 218, 48, 'PPL', 'P'),
(27372, 'Hanaford', 37.9558296203613, 0.662454197201295, -88.8402786254883, -1.55055537040391, 218, 18, 'PPL', 'P'),
(81428, 'Hanahan', 32.9183311462402, 0.574533262763691, -80.022216796875, -1.39665115785018, 218, 48, 'PPL', 'P'),
(211405, 'Hanaipoe', 19.9483299255371, 0.348164037474738, -155.461669921875, -2.71331800078535, 218, 15, 'PPL', 'P'),
(211411, 'Hanalei', 22.2052803039551, 0.387555252632263, -159.502777099609, -2.78384862646279, 218, 15, 'PPL', 'P'),
(211415, 'Hanalei Homesteads', 22.1852798461914, 0.387206178792381, -159.466384887695, -2.78321346254281, 218, 15, 'PPL', 'P'),
(211417, 'Hanamaulu', 21.9974994659424, 0.383928792886389, -159.357223510742, -2.78130823709897, 218, 15, 'PPL', 'P'),
(211418, 'HanapÃƒÂ«pÃƒÂ«', 21.9119396209717, 0.382435491884154, -159.595275878906, -2.7854630347156, 218, 15, 'PPL', 'P'),
(211421, 'Hanapepe Heights', 21.920280456543, 0.382581066927241, -159.592224121094, -2.7854097714938, 218, 15, 'PPL', 'P'),
(65352, 'Hanby Beach', 34.0119400024414, 0.593620338033371, -77.9022216796875, -1.35965026292905, 218, 33, 'PPL', 'P'),
(13888, 'Hanbys Corner', 39.8224983215332, 0.69503371208067, -75.4875030517578, -1.31750547236244, 218, 10, 'PPL', 'P'),
(47819, 'Hance Point Estates', 39.5577812194824, 0.690413527063546, -75.9674987792969, -1.3258829782035, 218, 25, 'PPL', 'P'),
(2959, 'Hanceville', 34.0605583190918, 0.594468887735697, -86.7675018310547, -1.51437859068211, 218, 2, 'PPL', 'P'),
(65350, 'Hancheys Store', 34.7833290100098, 0.60708361602913, -77.9113922119141, -1.35981031891057, 218, 33, 'PPL', 'P'),
(102587, 'Hanckel', 36.8494415283203, 0.643144082190321, -81.8058319091797, -1.42778111414822, 218, 53, 'PPL', 'P'),
(9313, 'Hancock', 35.8013916015625, 0.624852160243112, -90.2961120605469, -1.5759644572063, 218, 4, 'PPL', 'P'),
(41255, 'Hancock', 32.5958290100098, 0.568904538641754, -91.9552764892578, -1.60492233931928, 218, 22, 'PPL', 'P'),
(47818, 'Hancock', 39.6988906860352, 0.692876351860624, -78.1800003051758, -1.36449841453549, 218, 25, 'PPL', 'P'),
(55156, 'Hancock', 37.9863891601563, 0.66298756178861, -92.1816711425781, -1.60887367142863, 218, 29, 'PPL', 'P'),
(65351, 'Hancock', 36.0991706848145, 0.630049385689428, -76.6288909912109, -1.33742644994845, 218, 33, 'PPL', 'P'),
(81429, 'Hancock', 34.9080581665039, 0.609260550483188, -80.8108291625977, -1.41041504015398, 218, 48, 'PPL', 'P'),
(87565, 'Hancock', 36.2836112976074, 0.633268481657062, -88.3111114501953, -1.54131966090157, 218, 50, 'PPL', 'P'),
(109535, 'Hancock', 39.6927795410156, 0.692769692258966, -78.1777801513672, -1.36445966554163, 218, 58, 'PPL', 'P'),
(113525, 'Hancock', 41.6363906860352, 0.726692106118014, -73.024169921875, -1.27451219867253, 218, 8, 'PPL', 'P'),
(115918, 'Hancock', 41.3899993896484, 0.722391766747809, -95.3622207641602, -1.6643847343483, 218, 16, 'PPL', 'P'),
(125012, 'Hancock', 42.5430603027344, 0.74251647615721, -73.3241729736328, -1.27974823969173, 218, 23, 'PPL', 'P'),
(127677, 'Hancock', 44.5291709899902, 0.777180646958873, -68.2541732788086, -1.19126005194194, 218, 26, 'PPL', 'P'),
(131188, 'Hancock', 47.1269416809082, 0.822520298727199, -88.5808334350586, -1.54602719760245, 218, 27, 'PPL', 'P'),
(135782, 'Hancock', 45.497501373291, 0.79408120039457, -95.79638671875, -1.67196235975595, 218, 28, 'PPL', 'P'),
(143928, 'Hancock', 42.9727783203125, 0.750016470419092, -71.9802780151367, -1.25629284786502, 218, 36, 'PPL', 'P'),
(149433, 'Hancock', 41.9538917541504, 0.732233545135224, -75.2808303833008, -1.31389835382398, 218, 40, 'PPL', 'P'),
(155596, 'Hancock', 41.1552810668945, 0.718295159200994, -83.851936340332, -1.46349237331148, 218, 41, 'PPL', 'P'),
(162408, 'Hancock', 40.5047187805176, 0.706940705314414, -75.6827774047852, -1.32091365276747, 218, 45, 'PPL', 'P'),
(172094, 'Hancock', 43.9261093139648, 0.766655235119634, -72.841667175293, -1.27132692485074, 218, 55, 'PPL', 'P'),
(174405, 'Hancock', 44.1336097717285, 0.770276801307006, -89.523063659668, -1.56247221733369, 218, 57, 'PPL', 'P'),
(191579, 'Hancock', 32.8188896179199, 0.572797680681286, -101.862777709961, -1.77784085626591, 218, 51, 'PPL', 'P'),
(186815, 'Hancock (historical)', 38.6402816772461, 0.674400139165981, -106.365280151367, -1.85642434844753, 218, 7, 'PPL', 'P'),
(29984, 'Hancock Chapel', 38.3816719055176, 0.669886547171488, -86.179443359375, -1.50411503415706, 218, 19, 'PPL', 'P'),
(29985, 'Hancock Corner', 39.2752799987793, 0.685482950621373, -86.8288879394531, -1.51544998038865, 218, 19, 'PPL', 'P'),
(2960, 'Hancock Crossroads', 34.5347213745117, 0.602744594244091, -85.9936065673828, -1.50087157026545, 218, 2, 'PPL', 'P'),
(9316, 'Hancock Junction', 35.7805595397949, 0.624488572175288, -90.3047180175781, -1.57611465949178, 218, 4, 'PPL', 'P'),
(21704, 'Hancock Landing', 33.1591682434082, 0.578736663070218, -81.7641677856445, -1.42705393801258, 218, 13, 'PPL', 'P'),
(127678, 'Hancock Point', 44.4694404602051, 0.776138152550161, -68.2313919067383, -1.19086244199119, 218, 26, 'PPL', 'P'),
(21705, 'Hancock Subdivision', 32.7905616760254, 0.572303264824913, -83.8916702270508, -1.46418586045934, 218, 13, 'PPL', 'P'),
(70929, 'Hancocks Bridge', 39.5052795410156, 0.689497199911477, -75.4622192382813, -1.31706418656982, 218, 37, 'PPL', 'P'),
(81430, 'Hancockville (historical)', 34.9174995422363, 0.609425333575637, -81.6263885498047, -1.42464923670629, 218, 48, 'PPL', 'P'),
(112540, 'Hand', 33.8558311462402, 0.590895724501138, -78.807502746582, -1.37545039820233, 218, 48, 'PPL', 'P'),
(131190, 'Hand', 42.2536087036133, 0.737464592727385, -83.273063659668, -1.45338913908404, 218, 27, 'PPL', 'P'),
(9314, 'Hand (historical)', 36.276668548584, 0.633147307827463, -92.1947174072266, -1.60910137170183, 218, 4, 'PPL', 'P'),
(195050, 'Hand Place', 42.144718170166, 0.735564094394477, -114.968612670898, -2.00658082755725, 218, 17, 'PPL', 'P'),
(9315, 'Hand Valley', 36.2050018310547, 0.63189648764248, -92.4944381713867, -1.61433248587302, 218, 4, 'PPL', 'P'),
(60163, 'Handle', 32.9608306884766, 0.575275019706305, -88.8744430541992, -1.55115165217198, 218, 30, 'PPL', 'P'),
(55158, 'Handley', 37.8822212219238, 0.66116948829144, -94.1972198486328, -1.6440516325836, 218, 29, 'PPL', 'P'),
(94709, 'Handley', 32.7324981689453, 0.571289865451111, -97.2177810668945, -1.69677037110032, 218, 51, 'PPL', 'P'),
(109536, 'Handley', 38.186939239502, 0.666487820988329, -81.3655624389648, -1.42009696229696, 218, 58, 'PPL', 'P'),
(87567, 'Handleyton', 36.5994415283203, 0.638780759060335, -86.6294403076172, -1.51196896252781, 218, 50, 'PPL', 'P'),
(47820, 'Handly Mobile Home Park', 38.5491714477539, 0.672809965679095, -76.0386123657227, -1.32712414442954, 218, 25, 'PPL', 'P'),
(149435, 'Hands Creek Landing', 41.0188903808594, 0.715914692660627, -72.2030563354492, -1.26018106305654, 218, 40, 'PPL', 'P'),
(60164, 'Handsboro', 30.3983306884766, 0.530550957623951, -89.0269393920898, -1.55381321536541, 218, 30, 'PPL', 'P'),
(36266, 'Handshoe', 37.4700012207031, 0.653974892027564, -82.9066696166992, -1.44699435667455, 218, 21, 'PPL', 'P'),
(102589, 'Handsom', 36.642219543457, 0.639527376271939, -77.0308303833008, -1.34444161573388, 218, 53, 'PPL', 'P'),
(149436, 'Handsome Eddy', 41.4427795410156, 0.723312954168867, -74.89111328125, -1.30709650724187, 218, 40, 'PPL', 'P'),
(21706, 'Handy', 33.3763885498047, 0.582527872619027, -84.9691696166992, -1.48299177249693, 218, 13, 'PPL', 'P'),
(55159, 'Handy', 36.8091697692871, 0.642441207399622, -91.1069412231445, -1.59011609576482, 218, 29, 'PPL', 'P'),
(65355, 'Handy', 35.5886116027832, 0.621138448682023, -80.1011123657227, -1.3980281452918, 218, 33, 'PPL', 'P'),
(94710, 'Handy', 30.6348896026611, 0.534679689551414, -97.0895919799805, -1.69453304946854, 218, 51, 'PPL', 'P'),
(122758, 'Handy', 40.5008316040039, 0.706872861285644, -87.4713897705078, -1.52666375279065, 218, 19, 'PPL', 'P'),
(60165, 'Handy Corner', 34.9622192382813, 0.610205839512112, -89.741943359375, -1.56629238875935, 218, 30, 'PPL', 'P'),
(125014, 'Handy Four Corners', 41.5708312988281, 0.725547878955662, -71.0763931274414, -1.24051708051572, 218, 23, 'PPL', 'P'),
(36267, 'Handyville', 37.6349983215332, 0.656854634693294, -87.170280456543, -1.52140840385354, 218, 21, 'PPL', 'P'),
(72809, 'Hanersville', 38.8355598449707, 0.677808386150037, -82.2152786254883, -1.43492730745929, 218, 41, 'PPL', 'P'),
(174408, 'Hanerville', 42.875560760498, 0.748319703909575, -89.1613922119141, -1.55615985975993, 218, 57, 'PPL', 'P'),
(65356, 'Hanes', 36.082218170166, 0.629753508492321, -80.2972183227539, -1.40145083992477, 218, 33, 'PPL', 'P'),
(47821, 'Hanesville', 39.2758293151855, 0.685492538001298, -76.1358337402344, -1.32882097751808, 218, 25, 'PPL', 'P'),
(72806, 'Hanesville', 39.0372200012207, 0.681328019846686, -82.2186126708984, -1.43498549752911, 218, 41, 'PPL', 'P'),
(21707, 'Haney', 34.0844383239746, 0.594885672446295, -85.4199981689453, -1.49086021509562, 218, 13, 'PPL', 'P'),
(60166, 'Haney', 31.8158302307129, 0.555290991781487, -89.0094375610352, -1.55350775078837, 218, 30, 'PPL', 'P'),
(87568, 'Haney', 35.4961090087891, 0.61952397385019, -88.1399993896484, -1.53833319205516, 218, 50, 'PPL', 'P'),
(155598, 'Haney (historical)', 41.2555618286133, 0.720045388669394, -83.76611328125, -1.46199447835636, 218, 41, 'PPL', 'P'),
(29987, 'Haney Corner', 38.9388885498047, 0.679611812261212, -85.3058319091797, -1.48886763796803, 218, 19, 'PPL', 'P'),
(145363, 'Haneys Mill', 41.1288909912109, 0.717834565490465, -74.9108276367188, -1.3074405876547, 218, 37, 'PPL', 'P'),
(102588, 'Haneytown', 38.2902793884277, 0.668291446836585, -78.5355606079102, -1.37070411250759, 218, 53, 'PPL', 'P'),
(162409, 'Haneyville', 41.3255615234375, 0.721267113819468, -77.4752807617188, -1.35219873819901, 218, 45, 'PPL', 'P'),
(122759, 'Hanfield', 40.6044387817383, 0.708681147665808, -85.5802764892578, -1.49365759950464, 218, 19, 'PPL', 'P'),
(60167, 'Hanford', 31.1124992370605, 0.54301555021093, -89.4277801513672, -1.56080920639099, 218, 30, 'PPL', 'P'),
(72807, 'Hanford', 39.9513893127441, 0.69728328425346, -82.9480590820313, -1.44771673912023, 218, 41, 'PPL', 'P'),
(115921, 'Hanford', 43.0741691589355, 0.751786074384422, -93.1413879394531, -1.62562388942079, 218, 16, 'PPL', 'P'),
(127681, 'Hanford', 46.913330078125, 0.81879207293817, -68.2594375610352, -1.19135193099955, 218, 26, 'PPL', 'P'),
(145364, 'Hanford', 41.295280456543, 0.720738609501142, -74.5633316040039, -1.30137563774621, 218, 37, 'PPL', 'P'),
(182004, 'Hanford', 36.3274993896484, 0.634034473365596, -119.644721984863, -2.08819433126911, 218, 6, 'PPL', 'P'),
(207585, 'Hanford', 46.5838890075684, 0.813042241565662, -119.386672973633, -2.08369052639162, 218, 56, 'PPL', 'P'),
(149437, 'Hanford Bay', 42.5572204589844, 0.74276361750637, -79.1436080932617, -1.38131654313545, 218, 40, 'PPL', 'P'),
(102591, 'Hanford Crossroads', 36.7477798461914, 0.641369751114055, -78.5266723632813, -1.37054898337409, 218, 53, 'PPL', 'P'),
(47822, 'Hanford Estates', 39.3274993896484, 0.686394350925426, -77.2330627441406, -1.34797123628462, 218, 25, 'PPL', 'P'),
(177664, 'Hanford Hill', 38.1744384765625, 0.666269641516024, -120.402496337891, -2.10141998871661, 218, 6, 'PPL', 'P'),
(94711, 'Hanger', 33.711109161377, 0.588369849365252, -96.7574996948242, -1.68873694567209, 218, 51, 'PPL', 'P'),
(102590, 'Hanger', 37.2166709899902, 0.649553445406787, -82.0069427490234, -1.43129116046495, 218, 53, 'PPL', 'P'),
(122760, 'Hanging Grove', 40.9341697692871, 0.714436039044388, -86.9836120605469, -1.51815042573399, 218, 19, 'PPL', 'P'),
(87569, 'Hanging Limb', 36.2369384765625, 0.632453887258634, -85.1619415283203, -1.48635627706008, 218, 50, 'PPL', 'P'),
(36268, 'Hanging Rock', 37.5525016784668, 0.655414796649943, -86.3222198486328, -1.50660695398904, 218, 21, 'PPL', 'P'),
(72808, 'Hanging Rock', 38.560001373291, 0.672998983537463, -82.7211074829102, -1.4437556864729, 218, 41, 'PPL', 'P'),
(102592, 'Hanging Rock', 37.3280601501465, 0.651497553002545, -80.040283203125, -1.39696647612324, 218, 53, 'PPL', 'P'),
(29988, 'Hangman Crossing', 38.9433288574219, 0.679689310248933, -85.9266662597656, -1.49970324149523, 218, 19, 'PPL', 'P'),
(131193, 'Hangore Heights', 45.4394416809082, 0.793067867599795, -84.295280456543, -1.4712301878587, 218, 27, 'PPL', 'P'),
(94712, 'Hankamer', 29.858060836792, 0.521121469862794, -94.6266708374023, -1.65154696631357, 218, 51, 'PPL', 'P'),
(65357, 'Hankins', 35.7324981689453, 0.623649743010941, -82.0066680908203, -1.43128636677499, 218, 33, 'PPL', 'P'),
(149438, 'Hankins', 41.8141708374023, 0.729794955104065, -75.0872192382813, -1.31051920187484, 218, 40, 'PPL', 'P'),
(60168, 'Hankinson', 32.1063919067383, 0.560362249708243, -90.8794403076172, -1.58614545573757, 218, 30, 'PPL', 'P'),
(81431, 'Hankinson', 33.3305587768555, 0.581727992185622, -81.8327789306641, -1.42825142839673, 218, 48, 'PPL', 'P'),
(140176, 'Hankinson', 46.0697212219238, 0.804068320798476, -96.9013900756836, -1.69124830658004, 218, 34, 'PPL', 'P'),
(198386, 'Hanks', 48.603328704834, 0.848288113328424, -103.80249786377, -1.81169535951716, 218, 34, 'PPL', 'P'),
(140178, 'Hanks Corner', 48.7588882446289, 0.851003139480733, -97.9494400024414, -1.70954022852725, 218, 34, 'PPL', 'P'),
(27373, 'Hanks Station', 39.4588890075684, 0.688687532361066, -90.4705581665039, -1.57900911612254, 218, 18, 'PPL', 'P'),
(172096, 'Hanksville', 44.2477798461914, 0.77226944501363, -72.9625015258789, -1.27343588211797, 218, 55, 'PPL', 'P'),
(192608, 'Hanksville', 38.3730583190918, 0.669736211727953, -110.713333129883, -1.93231218897377, 218, 52, 'PPL', 'P'),
(87570, 'Hanlan (historical)', 35.5769386291504, 0.620934716858632, -85.8786087036133, -1.49886447890991, 218, 50, 'PPL', 'P'),
(115922, 'Hanley', 41.2880592346191, 0.720612575402554, -93.8338928222656, -1.63771037971201, 218, 16, 'PPL', 'P'),
(149439, 'Hanley Corner', 42.1344413757324, 0.73538473049506, -74.5438919067383, -1.30103635102334, 218, 40, 'PPL', 'P'),
(135786, 'Hanley Falls', 44.6927795410156, 0.780036154858683, -95.6216735839844, -1.66891304030781, 218, 28, 'PPL', 'P'),
(55160, 'Hanley Hills', 38.6858291625977, 0.67519509275137, -90.3236083984375, -1.57644435883474, 218, 29, 'PPL', 'P'),
(155599, 'Hanley Village', 40.6958312988281, 0.710276248000711, -82.5416717529297, -1.44062394218902, 218, 41, 'PPL', 'P'),
(55161, 'Hanleyville', 36.6886100769043, 0.64033704382235, -90.2900009155273, -1.57585779760465, 218, 29, 'PPL', 'P'),
(21708, 'Hanlin', 33.9449996948242, 0.592452009263153, -84.916389465332, -1.48207058507587, 218, 13, 'PPL', 'P'),
(162410, 'Hanlin Station', 40.3675003051758, 0.704545791125133, -80.4672164916992, -1.40441786769523, 218, 45, 'PPL', 'P'),
(141987, 'Hanlon', 40.6583290100098, 0.709621709583797, -96.6708297729492, -1.68722427017293, 218, 35, 'PPL', 'P'),
(115923, 'Hanlontown', 43.2802810668945, 0.755383405805874, -93.3786087036133, -1.62976417280949, 218, 16, 'PPL', 'P'),
(36270, 'Hanly', 37.8369407653809, 0.660379195237959, -84.5908279418945, -1.47638846457408, 218, 21, 'PPL', 'P'),
(162411, 'Hann Hill', 41.2105598449707, 0.719259955884903, -80.4472198486328, -1.40406886043438, 218, 45, 'PPL', 'P'),
(9318, 'Hanna', 33.0900001525879, 0.577529452148085, -91.2705612182617, -1.59297180340171, 218, 4, 'PPL', 'P'),
(41256, 'Hanna', 31.961109161377, 0.557826587455352, -93.3475036621094, -1.62922128742127, 218, 22, 'PPL', 'P'),
(55162, 'Hanna', 37.7350006103516, 0.658600003892705, -92.2466735839844, -1.61000817805301, 218, 29, 'PPL', 'P'),
(76014, 'Hanna', 35.2050018310547, 0.614443195122537, -95.8899993896484, -1.67359620908472, 218, 42, 'PPL', 'P'),
(109537, 'Hanna', 39.1683311462402, 0.683616341013337, -81.3952789306641, -1.42061561291926, 218, 58, 'PPL', 'P'),
(115924, 'Hanna', 42.9491691589355, 0.749604412819429, -94.0205612182617, -1.64096835783156, 218, 16, 'PPL', 'P'),
(122762, 'Hanna', 41.4119415283203, 0.722774729312562, -86.7799987792969, -1.51459670357539, 218, 19, 'PPL', 'P'),
(186816, 'Hanna', 37.6794395446777, 0.65763028036078, -106.45832824707, -1.85804834408026, 218, 7, 'PPL', 'P'),
(202186, 'Hanna', 44.2616691589355, 0.772511859251855, -103.845283508301, -1.81244210988682, 218, 49, 'PPL', 'P'),
(204204, 'Hanna', 40.4041709899902, 0.705185815314106, -110.764442443848, -1.9332042147809, 218, 52, 'PPL', 'P'),
(209492, 'Hanna', 41.8699989318848, 0.730769339167898, -106.561393737793, -1.85984717623855, 218, 59, 'PPL', 'P'),
(119917, 'Hanna City', 40.6916694641113, 0.710203610281979, -89.7949981689453, -1.56721836987038, 218, 18, 'PPL', 'P'),
(41265, 'Hanna Park', 32.5566711425781, 0.568221104927013, -93.8013916015625, -1.63714312639982, 218, 22, 'PPL', 'P'),
(9317, 'Hannaberry', 34.122501373291, 0.595549997980215, -91.5588912963867, -1.59800411259753, 218, 4, 'PPL', 'P'),
(149444, 'Hannacroix', 42.4288902282715, 0.740523832450586, -73.8097229003906, -1.28822268459648, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(140179, 'Hannaford', 47.3133316040039, 0.825773416577758, -98.1861114501953, -1.71367092453601, 218, 34, 'PPL', 'P'),
(178325, 'Hannagan Meadow', 33.642219543457, 0.587167498712109, -109.323333740234, -1.9080521230237, 218, 5, 'PPL', 'P'),
(2961, 'Hannah', 34.7877807617188, 0.607161313753933, -86.954719543457, -1.51764615618159, 218, 2, 'PPL', 'P'),
(21709, 'Hannah', 33.5869407653809, 0.5862027020282, -84.8636093139648, -1.48114939765481, 218, 13, 'PPL', 'P'),
(36269, 'Hannah', 38.0475006103516, 0.664054157805187, -82.8724975585938, -1.44639794174842, 218, 21, 'PPL', 'P'),
(60169, 'Hannah', 33.6369400024414, 0.587075353338392, -91.0255584716797, -1.58869569879743, 218, 30, 'PPL', 'P'),
(81432, 'Hannah', 33.8830604553223, 0.591370965597663, -79.5805587768555, -1.388942771233, 218, 48, 'PPL', 'P'),
(131194, 'Hannah', 44.5847206115723, 0.778150170753716, -85.6355590820313, -1.49462246276758, 218, 27, 'PPL', 'P'),
(140181, 'Hannah', 48.9716682434082, 0.854716851041821, -98.6913909912109, -1.7224897161697, 218, 34, 'PPL', 'P'),
(162412, 'Hannah', 40.767219543457, 0.711522207916705, -78.0977783203125, -1.3630633701821, 218, 45, 'PPL', 'P'),
(2962, 'Hannah (historical)', 34.5327796936035, 0.60271070551922, -85.9427795410156, -1.49998447130634, 218, 2, 'PPL', 'P'),
(140182, 'Hannah Junction', 47.9252815246582, 0.836453957550494, -97.6666717529297, -1.70460499155316, 218, 34, 'PPL', 'P'),
(109538, 'Hannahdale', 39.2219390869141, 0.684551976083309, -81.0261077880859, -1.41417236097792, 218, 58, 'PPL', 'P'),
(21710, 'Hannahs Mill', 32.9327812194824, 0.574785464118922, -84.3494415283203, -1.47217547688763, 218, 13, 'PPL', 'P'),
(143930, 'Hannahs Mobile Home Park', 43.6430587768555, 0.761715071297537, -72.2680587768555, -1.26131556968091, 218, 36, 'PPL', 'P'),
(162413, 'Hannahstown', 40.7700004577637, 0.711570744027571, -79.7905578613281, -1.39260794668322, 218, 45, 'PPL', 'P'),
(109539, 'Hannahsville', 39.2413902282715, 0.684891462543267, -79.711669921875, -1.39123109239965, 218, 58, 'PPL', 'P'),
(131195, 'Hannahville', 45.6525001525879, 0.796786439429872, -87.3461074829102, -1.52447716437764, 218, 27, 'PPL', 'P'),
(149440, 'Hannans Corner', 43.0791702270508, 0.751873359489149, -77.4419403076172, -1.35161683750083, 218, 40, 'PPL', 'P'),
(190291, 'Hannapah (historical)', 38.1272201538086, 0.665445526316699, -116.916107177734, -2.04057101886604, 218, 39, 'PPL', 'P'),
(162429, 'Hannastown', 40.3536109924316, 0.704303376886909, -79.496940612793, -1.38748335895564, 218, 45, 'PPL', 'P'),
(162414, 'Hannasville', 41.4777793884277, 0.723923816743904, -79.9480590820313, -1.3953568615604, 218, 45, 'PPL', 'P'),
(21711, 'Hannatown', 30.7105598449707, 0.536000384425498, -84.670280456543, -1.47777517255368, 218, 13, 'PPL', 'P'),
(149441, 'Hannawa Falls', 44.6122207641602, 0.778630138961175, -74.9713897705078, -1.30849759629136, 218, 40, 'PPL', 'P'),
(193615, 'Hannchen', 41.8402786254883, 0.730250621966578, -121.403327941895, -2.11888779546449, 218, 6, 'PPL', 'P'),
(55163, 'Hannibal', 39.7083282470703, 0.693041068374045, -91.3583297729492, -1.59450365366073, 218, 29, 'PPL', 'P'),
(72810, 'Hannibal', 39.6672210693359, 0.692323612776378, -80.8722229003906, -1.41148656301857, 218, 41, 'PPL', 'P'),
(94713, 'Hannibal', 32.3736114501953, 0.565026110567245, -98.3352813720703, -1.71627443081767, 218, 51, 'PPL', 'P'),
(149442, 'Hannibal', 43.3211097717285, 0.756096001134552, -76.5791702270508, -1.33655865890725, 218, 40, 'PPL', 'P'),
(174410, 'Hannibal', 45.252498626709, 0.789805095790284, -90.7888870239258, -1.58456500278866, 218, 57, 'PPL', 'P'),
(177382, 'Hannibal Center', 43.2900009155273, 0.755553049167312, -76.5524978637695, -1.3360931383487, 218, 40, 'PPL', 'P'),
(47823, 'Hannleigh Heights', 39.5083312988281, 0.689550463133279, -77.0824966430664, -1.34534336207899, 218, 25, 'PPL', 'P'),
(2965, 'Hannon', 32.2391700744629, 0.562679665909803, -85.5261077880859, -1.49271217731766, 218, 2, 'PPL', 'P'),
(55164, 'Hannon', 37.622501373291, 0.656636521800016, -94.4938888549805, -1.64922948353298, 218, 29, 'PPL', 'P'),
(47824, 'Hannover', 39.3916702270508, 0.687514343321858, -77.440559387207, -1.35159273589297, 218, 25, 'PPL', 'P'),
(198388, 'Hannover', 47.1113891601563, 0.822248856033093, -101.426109313965, -1.77021955501637, 218, 34, 'PPL', 'P'),
(178326, 'Hano', 35.8369407653809, 0.625472610198073, -110.391670227051, -1.92669811223783, 218, 5, 'PPL', 'P'),
(2963, 'Hanover', 33.0047187805176, 0.576041011414839, -86.2024993896484, -1.50451743779777, 218, 2, 'PPL', 'P'),
(9319, 'Hanover', 35.8033294677734, 0.624885982388956, -92.1236114501953, -1.60786033863386, 218, 4, 'PPL', 'P'),
(21713, 'Hanover', 30.9424991607666, 0.540048489150959, -84.6488876342773, -1.47740179736885, 218, 13, 'PPL', 'P'),
(29993, 'Hanover', 38.714168548584, 0.675689708344825, -85.4736099243164, -1.49179591674462, 218, 19, 'PPL', 'P'),
(32676, 'Hanover', 39.8938903808594, 0.696279738575691, -96.8791732788086, -1.69086055032532, 218, 20, 'PPL', 'P'),
(47825, 'Hanover', 39.1927795410156, 0.684043045998995, -76.7244415283203, -1.33909412142306, 218, 25, 'PPL', 'P'),
(94714, 'Hanover', 30.8036098480225, 0.537624413347742, -96.8213882446289, -1.68985201122051, 218, 51, 'PPL', 'P'),
(102593, 'Hanover', 37.7663917541504, 0.659147882707961, -77.3705596923828, -1.35037101074289, 218, 53, 'PPL', 'P'),
(109541, 'Hanover', 37.5727806091309, 0.655768730758814, -81.7997207641602, -1.42767445454657, 218, 58, 'PPL', 'P'),
(113526, 'Hanover', 41.6425018310547, 0.726798765719672, -72.0658264160156, -1.25778594913018, 218, 8, 'PPL', 'P'),
(115926, 'Hanover', 42.6047210693359, 0.743592659553711, -95.3683319091797, -1.66449139394996, 218, 16, 'PPL', 'P'),
(119919, 'Hanover', 42.2563896179199, 0.737513128838251, -90.2794418334961, -1.57567350685721, 218, 18, 'PPL', 'P'),
(125020, 'Hanover', 42.1130599975586, 0.735011555047313, -70.8125, -1.23591127656848, 218, 23, 'PPL', 'P'),
(127682, 'Hanover', 44.4966697692871, 0.776613393646686, -70.6947174072266, -1.23385558252305, 218, 26, 'PPL', 'P'),
(131196, 'Hanover', 42.1011085510254, 0.734802962954932, -84.5519409179688, -1.47570975797027, 218, 27, 'PPL', 'P'),
(135788, 'Hanover', 45.1558303833008, 0.788117916660692, -93.6661071777344, -1.63478196777736, 218, 28, 'PPL', 'P'),
(143931, 'Hanover', 43.702220916748, 0.762747645431188, -72.2900009155273, -1.26169853224567, 218, 36, 'PPL', 'P'),
(145365, 'Hanover', 40.8044395446777, 0.712171819485602, -74.3672180175781, -1.29795280995519, 218, 37, 'PPL', 'P'),
(149447, 'Hanover', 42.9669418334961, 0.749914604507396, -75.378059387207, -1.31559532007058, 218, 40, 'PPL', 'P'),
(155601, 'Hanover', 40.079719543457, 0.699523069309244, -82.2611083984375, -1.43572718789269, 218, 41, 'PPL', 'P'),
(162416, 'Hanover', 40.6616706848145, 0.70968003281167, -75.4127807617188, -1.31620132237663, 218, 45, 'PPL', 'P'),
(174411, 'Hanover', 42.6386108398438, 0.744184147631818, -89.1619415283203, -1.55616944713985, 218, 57, 'PPL', 'P'),
(188658, 'Hanover', 32.8133316040039, 0.57270067503858, -108.090560913086, -1.88653617826084, 218, 38, 'PPL', 'P'),
(196665, 'Hanover', 47.1213912963867, 0.822423426242547, -109.553886413574, -1.91207602627275, 218, 31, 'PPL', 'P'),
(72811, 'Hanover (historical)', 39.4283294677734, 0.68815416777375, -84.6463928222656, -1.47735825468503, 218, 41, 'PPL', 'P'),
(29990, 'Hanover Beach', 38.7066688537598, 0.675558813977247, -85.4533309936523, -1.49144198263575, 218, 19, 'PPL', 'P'),
(125015, 'Hanover Center', 42.1166687011719, 0.735074538807093, -70.841667175293, -1.23642033981085, 218, 23, 'PPL', 'P'),
(143932, 'Hanover Center', 43.7255592346191, 0.763154975919916, -72.1933288574219, -1.26001128653705, 218, 36, 'PPL', 'P'),
(149445, 'Hanover Center', 42.5194396972656, 0.742104218820466, -79.1388931274414, -1.38123425145776, 218, 40, 'PPL', 'P'),
(162418, 'Hanover Court', 40.2508316040039, 0.702509538155659, -75.6433334350586, -1.32022522562568, 218, 45, 'PPL', 'P'),
(102595, 'Hanover Farms', 37.5833282470703, 0.655952821769166, -77.2966690063477, -1.34908137498502, 218, 53, 'PPL', 'P'),
(70930, 'Hanover Furnace', 39.9813919067383, 0.697806928302797, -74.5266723632813, -1.30073581329432, 218, 37, 'PPL', 'P'),
(162419, 'Hanover Green', 41.2180595397949, 0.71939085025248, -75.9516677856445, -1.32560667524041, 218, 45, 'PPL', 'P'),
(102597, 'Hanover Heights', 37.142219543457, 0.64825402253191, -76.5274963378906, -1.33565677940409, 218, 53, 'PPL', 'P'),
(162420, 'Hanover Heights', 40.3333282470703, 0.70394937619901, -76.7508316040039, -1.33955471513359, 218, 45, 'PPL', 'P'),
(102598, 'Hanover Heights South', 37.6472206115723, 0.657067953896609, -77.396110534668, -1.35081695706742, 218, 53, 'PPL', 'P'),
(47826, 'Hanover Hills', 39.1613883972168, 0.683495167183738, -76.7569427490234, -1.33966137473525, 218, 25, 'PPL', 'P'),
(81433, 'Hanover Hills', 34.7130584716797, 0.605857163768121, -82.8888931274414, -1.44668409840755, 218, 48, 'PPL', 'P'),
(102599, 'Hanover Hills', 37.7011108398438, 0.658008515814598, -77.398063659668, -1.35085104552938, 218, 53, 'PPL', 'P'),
(162421, 'Hanover Hills', 40.2924995422363, 0.703236780870332, -76.7305603027344, -1.33920091418277, 218, 45, 'PPL', 'P'),
(78427, 'Hanover Junction', 39.8422203063965, 0.695377925651563, -76.7758331298828, -1.3399910740782, 218, 45, 'PPL', 'P'),
(188659, 'Hanover Junction', 32.7783317565918, 0.572089812463543, -108.114723205566, -1.88695788981945, 218, 38, 'PPL', 'P'),
(145366, 'Hanover Neck', 40.8316688537598, 0.712647060582127, -74.3533325195313, -1.29771046229599, 218, 37, 'PPL', 'P'),
(119920, 'Hanover Park', 41.999439239502, 0.733028498720612, -88.1449966430664, -1.53842041058086, 218, 18, 'PPL', 'P'),
(162427, 'Hanoverdale', 40.3211097717285, 0.703736123574722, -76.7041702270508, -1.33874032047224, 218, 45, 'PPL', 'P'),
(155605, 'Hanoverton', 40.7511100769043, 0.71124104468462, -80.9372177124023, -1.41262093648489, 218, 41, 'PPL', 'P'),
(102600, 'Hanovertown', 37.6972198486328, 0.657940605206801, -77.246940612793, -1.34821345078576, 218, 53, 'PPL', 'P'),
(162428, 'Hanoverville', 40.6827812194824, 0.710048481148482, -75.3752822875977, -1.31554685053874, 218, 45, 'PPL', 'P'),
(65359, 'Hanrahan', 35.4069404602051, 0.617967689088175, -77.4274978637695, -1.35136476930365, 218, 33, 'PPL', 'P'),
(174412, 'Hans Addition', 42.8313903808594, 0.747548785353024, -89.0536117553711, -1.55427873592395, 218, 57, 'PPL', 'P'),
(195051, 'Hansberg', 46.5380592346191, 0.812242361132256, -116.139999389648, -2.02702538261357, 218, 17, 'PPL', 'P'),
(140184, 'Hansboro', 48.9500007629395, 0.85433868216703, -99.3824996948242, -1.73455183853694, 218, 34, 'PPL', 'P'),
(36271, 'Hansbrough', 37.6344413757324, 0.656844914155315, -85.9936065673828, -1.50087157026545, 218, 21, 'PPL', 'P'),
(21714, 'Hansell', 31.0277805328369, 0.541536929884205, -84.0669403076172, -1.46724490044545, 218, 13, 'PPL', 'P'),
(115929, 'Hansell', 42.7577781677246, 0.746264009864143, -93.103889465332, -1.62496941758291, 218, 16, 'PPL', 'P'),
(131199, 'Hansen', 45.2394409179688, 0.789577195780001, -87.6130599975586, -1.52913636470473, 218, 27, 'PPL', 'P'),
(141990, 'Hansen', 40.6963882446289, 0.71028596853869, -98.370002746582, -1.71688043312372, 218, 35, 'PPL', 'P'),
(182005, 'Hansen', 33.8172187805176, 0.590221811587293, -118.009719848633, -2.05965816071475, 218, 6, 'PPL', 'P'),
(195052, 'Hansen', 42.5297203063965, 0.74228364929891, -114.305282592773, -1.99500353366646, 218, 17, 'PPL', 'P'),
(135790, 'Hansen''s Harbor and Trailer Court', 44.499439239502, 0.776661730020471, -92.3152770996094, -1.6112055352791, 218, 28, 'PPL', 'P'),
(36273, 'Hansford', 37.269718170166, 0.650479293359753, -84.370002746582, -1.47253433784452, 218, 21, 'PPL', 'P'),
(109542, 'Hansford', 38.2038917541504, 0.666783698185436, -81.3958282470703, -1.42062520029918, 218, 58, 'PPL', 'P'),
(191580, 'Hansford', 36.2013893127441, 0.631833437303672, -101.301666259766, -1.76804761398936, 218, 51, 'PPL', 'P'),
(135791, 'Hanska', 44.1488914489746, 0.770543516890177, -94.4938888549805, -1.64922948353298, 218, 28, 'PPL', 'P'),
(2964, 'Hanson', 34.0833282470703, 0.594866297949364, -85.4236068725586, -1.4909231988554, 218, 2, 'PPL', 'P'),
(16341, 'Hanson', 30.5513896942139, 0.533222341223896, -83.3672180175781, -1.45503244263468, 218, 12, 'PPL', 'P'),
(27374, 'Hanson', 39.2172203063965, 0.684469617826598, -89.1108322143555, -1.55527742133273, 218, 18, 'PPL', 'P'),
(36272, 'Hanson', 37.4172210693359, 0.653053704606506, -87.480827331543, -1.52682846930407, 218, 21, 'PPL', 'P'),
(76017, 'Hanson', 35.434440612793, 0.618447657295634, -94.6986083984375, -1.65280251360949, 218, 42, 'PPL', 'P'),
(125017, 'Hanson', 42.0750007629395, 0.73434729609242, -70.8805618286133, -1.23709917957271, 218, 23, 'PPL', 'P'),
(209912, 'Hanson', 47.7286109924316, 0.83302140922149, -119.006942749023, -2.07706298370285, 218, 56, 'PPL', 'P'),
(207586, 'Hanson Ferry', 46.0272216796875, 0.803326563855862, -117.334716796875, -2.04787713500056, 218, 56, 'PPL', 'P'),
(47827, 'Hanson Hills', 38.9544410705566, 0.679883254955318, -76.6788864135742, -1.33829903467962, 218, 25, 'PPL', 'P'),
(47828, 'Hansonville', 39.4961090087891, 0.689337143929963, -77.4005584716797, -1.3508945882132, 218, 25, 'PPL', 'P'),
(102602, 'Hansonville', 36.8238906860352, 0.642698135865787, -82.1463928222656, -1.43372502338517, 218, 53, 'PPL', 'P'),
(109543, 'Hansrote', 39.5766716003418, 0.690743226406498, -78.4161071777344, -1.36861925684822, 218, 58, 'PPL', 'P'),
(32680, 'Hanston', 38.121940612793, 0.665353380942982, -99.7125015258789, -1.74031145702646, 218, 20, 'PPL', 'P'),
(207587, 'Hansville', 47.9188919067383, 0.836342437679847, -122.553062438965, -2.13895444796213, 218, 56, 'PPL', 'P'),
(155606, 'Hanville Corners', 41.1191711425781, 0.717664922129027, -82.6125030517578, -1.44186018156704, 218, 41, 'PPL', 'P'),
(21715, 'Hapeville', 33.6599998474121, 0.58747782355813, -84.4102783203125, -1.47323727921424, 218, 13, 'PPL', 'P'),
(65360, 'Happersville (historical)', 35.25, 0.615228561328001, -77.581672668457, -1.35405562726907, 218, 33, 'PPL', 'P'),
(9320, 'Happy', 35.1652793884277, 0.613749907711762, -91.644172668457, -1.59949255333077, 218, 4, 'PPL', 'P'),
(36274, 'Happy', 37.2038917541504, 0.649330405665493, -83.0966720581055, -1.45031052486391, 218, 21, 'PPL', 'P'),
(191582, 'Happy', 34.7436103820801, 0.606390395197382, -101.85417175293, -1.77769065398043, 218, 51, 'PPL', 'P'),
(47830, 'Happy Acres', 39.4441719055176, 0.688430670473927, -76.3472213745117, -1.33251038773422, 218, 25, 'PPL', 'P'),
(65361, 'Happy Acres', 35.1294403076172, 0.61312439775073, -82.7063903808594, -1.44349882458576, 218, 33, 'PPL', 'P'),
(87572, 'Happy Acres', 36.0513916015625, 0.629215483373097, -83.8633270263672, -1.46369117828685, 218, 50, 'PPL', 'P'),
(9321, 'Happy Bend', 35.2638893127441, 0.615470975566226, -92.8672180175781, -1.62083872157414, 218, 4, 'PPL', 'P'),
(81434, 'Happy Bottom', 33.2458305358887, 0.580249205411328, -81.3736114501953, -1.42023744404447, 218, 48, 'PPL', 'P'),
(193616, 'Happy Camp', 41.7933311462402, 0.729431233878188, -123.378326416016, -2.15335802155977, 218, 6, 'PPL', 'P'),
(186817, 'Happy Canyon', 39.435001373291, 0.688270614492414, -104.870002746582, -1.83032683450335, 218, 7, 'PPL', 'P'),
(127684, 'Happy Corner', 45.1688919067383, 0.788345883250003, -69.5744400024414, -1.21430305327385, 218, 26, 'PPL', 'P'),
(143934, 'Happy Corner', 45.0863914489746, 0.786905978627624, -71.3133316040039, -1.2446524370564, 218, 36, 'PPL', 'P'),
(9322, 'Happy Corners', 35.975830078125, 0.62789668600129, -90.2886123657227, -1.57583356283873, 218, 4, 'PPL', 'P'),
(72813, 'Happy Corners', 39.8472213745117, 0.69546521075629, -84.3116683959961, -1.47151621135978, 218, 41, 'PPL', 'P'),
(102603, 'Happy Creek', 38.9297218322754, 0.679451822858725, -78.1488876342773, -1.36395539598922, 218, 53, 'PPL', 'P'),
(199985, 'Happy Creek Station', 41.4674987792969, 0.72374438626546, -118.351936340332, -2.06563096524952, 218, 39, 'PPL', 'P'),
(196666, 'Happy Haven', 48.4155616760254, 0.845010960449027, -114.334167480469, -1.99550767006081, 218, 31, 'PPL', 'P'),
(2967, 'Happy Hill', 31.1813907623291, 0.544217934153587, -88.0516662597656, -1.53679148810011, 218, 2, 'PPL', 'P'),
(87573, 'Happy Hill', 35.3708305358887, 0.617337452016208, -86.9966735839844, -1.5183783923233, 218, 50, 'PPL', 'P'),
(94715, 'Happy Hill', 32.4686088562012, 0.566684128082901, -97.2363891601563, -1.69709514359525, 218, 51, 'PPL', 'P'),
(182006, 'Happy Hill', 35.5711097717285, 0.620832984104991, -121.105560302734, -2.11369076975526, 218, 6, 'PPL', 'P'),
(119924, 'Happy Hills', 41.9155616760254, 0.731564559069396, -88.3811111450195, -1.54254138605165, 218, 18, 'PPL', 'P'),
(125019, 'Happy Hills', 42.1158294677734, 0.735059891421098, -71.4747161865234, -1.24746912938332, 218, 23, 'PPL', 'P'),
(666, 'Happy Hollow', 38.0013885498047, 0.663249350523765, -90.7249984741211, -1.58344993724024, 218, 29, 'PPL', 'P'),
(2969, 'Happy Hollow', 34.0319404602051, 0.593969411873253, -86.091667175293, -1.50258305073999, 218, 2, 'PPL', 'P'),
(21717, 'Happy Hollow', 33.9425010681152, 0.592408400000303, -84.283332824707, -1.47102166234535, 218, 13, 'PPL', 'P'),
(29994, 'Happy Hollow', 38.0533294677734, 0.664155890558828, -85.9377822875977, -1.49989725278064, 218, 19, 'PPL', 'P'),
(94716, 'Happy Hollow', 29.6216697692871, 0.516995667412529, -99.7533264160156, -1.74102398577611, 218, 51, 'PPL', 'P'),
(169410, 'Happy Hollow', 41.9036102294922, 0.731355966977015, -71.3891677856445, -1.24597602811817, 218, 47, 'PPL', 'P'),
(200941, 'Happy Hollow', 45.1425018310547, 0.787885289539473, -123.80249786377, -2.16076120991602, 218, 43, 'PPL', 'P'),
(122772, 'Happy Hollow Heights', 40.4427795410156, 0.705859661648924, -86.9002838134766, -1.5166960734627, 218, 19, 'PPL', 'P'),
(65364, 'Happy Home', 36.4961090087891, 0.636977266370133, -79.6286087036133, -1.38978140066027, 218, 33, 'PPL', 'P'),
(81435, 'Happy Home Subdivision', 34.0502815246582, 0.59428952383628, -80.5261077880859, -1.40544571471795, 218, 48, 'PPL', 'P'),
(72814, 'Happy Homes', 39.9958305358887, 0.698058929920945, -82.6222229003906, -1.44202982492848, 218, 41, 'PPL', 'P'),
(72817, 'Happy Hours Addition', 38.7688903808594, 0.676644784490754, -82.8691711425781, -1.44633988483666, 218, 41, 'PPL', 'P'),
(41257, 'Happy Jack', 29.5216693878174, 0.515250331502632, -89.7336120605469, -1.56614698016384, 218, 22, 'PPL', 'P'),
(178327, 'Happy Jack', 34.7433280944824, 0.606385468349366, -111.406669616699, -1.94441319349293, 218, 5, 'PPL', 'P'),
(47831, 'Happy Knoll', 39.5116691589355, 0.689608719782124, -76.2361068725586, -1.33057107382842, 218, 25, 'PPL', 'P'),
(21728, 'Happy Landing', 31.1630592346191, 0.543897988638128, -81.8566665649414, -1.42866834626538, 218, 13, 'PPL', 'P'),
(36275, 'Happy Landing', 37.6411094665527, 0.656961294294952, -84.3811111450195, -1.47272821597187, 218, 21, 'PPL', 'P'),
(41258, 'Happy Meadows', 32.5786094665527, 0.568604000912739, -93.5730590820313, -1.63315797214463, 218, 22, 'PPL', 'P'),
(191583, 'Happy Union', 34.0208282470703, 0.593775467166868, -101.696113586426, -1.77493201856527, 218, 51, 'PPL', 'P'),
(386, 'Happy Valley', 30.9811096191406, 0.54072236877529, -87.2483291625977, -1.52277061075112, 218, 12, 'PPL', 'P'),
(21720, 'Happy Valley', 34.9352798461914, 0.609735658421658, -85.3222198486328, -1.4891536614691, 218, 13, 'PPL', 'P'),
(47832, 'Happy Valley', 39.6691703796387, 0.692357634659304, -76.8125, -1.34063103168814, 218, 25, 'PPL', 'P'),
(65363, 'Happy Valley', 35.9886093139648, 0.628119725742584, -81.5588912963867, -1.42347118739809, 218, 33, 'PPL', 'P'),
(87574, 'Happy Valley', 35.6088905334473, 0.621492382790895, -83.9574966430664, -1.4653347481536, 218, 50, 'PPL', 'P'),
(102605, 'Happy Valley', 37.2583312988281, 0.650280554963406, -79.1455612182617, -1.3813506315974, 218, 53, 'PPL', 'P'),
(143935, 'Happy Valley', 42.9174995422363, 0.749051673735183, -71.9169387817383, -1.25518736969653, 218, 36, 'PPL', 'P'),
(149450, 'Happy Valley', 43.440559387207, 0.758180790214893, -75.9749984741211, -1.32601387257108, 218, 40, 'PPL', 'P'),
(162430, 'Happy Valley', 41.3274993896484, 0.721300935965312, -75.8349990844727, -1.32357042227093, 218, 45, 'PPL', 'P'),
(182009, 'Happy Valley', 34.083610534668, 0.594871224797381, -118.199440002441, -2.0629694020561, 218, 6, 'PPL', 'P'),
(192962, 'Happy Valley', 32.1324996948242, 0.560817916570756, -100.10888671875, -1.74722968374821, 218, 51, 'PPL', 'P'),
(200942, 'Happy Valley', 45.4469413757324, 0.793198761967372, -122.529167175293, -2.13853739693542, 218, 43, 'PPL', 'P'),
(204210, 'Happy Valley', 40.6361083984375, 0.709233886750054, -111.946388244629, -1.95383306058465, 218, 52, 'PPL', 'P'),
(207589, 'Happy Valley', 48.7147216796875, 0.850232287503209, -122.46639251709, -2.13744177246296, 218, 56, 'PPL', 'P'),
(211426, 'Happy Valley', 20.8950004577637, 0.364686555193698, -156.509719848633, -2.73160992273256, 218, 15, 'PPL', 'P'),
(211867, 'Happy Valley', 59.9472198486328, 1.04627636377554, -151.732223510742, -2.6482268816344, 218, 1, 'PPL', 'P'),
(72815, 'Happy Valley Mobile Home Park', 39.9716682434082, 0.697637218362331, -83.8369369506836, -1.46323058457632, 218, 41, 'PPL', 'P'),
(178328, 'Happy Valley Ranch', 33.7158317565918, 0.58845227420099, -111.899169921875, -1.95300894538532, 218, 5, 'PPL', 'P'),
(135795, 'Happy Wanderer', 47.6922187805176, 0.832386245301507, -91.6922225952148, -1.60033118275804, 218, 28, 'PPL', 'P'),
(41259, 'Happy Woods', 30.4652805328369, 0.531719452841737, -90.4972229003906, -1.57947450352303, 218, 22, 'PPL', 'P'),
(76019, 'Happyland', 34.7966690063477, 0.60731644288743, -96.5491714477539, -1.68510093183581, 218, 42, 'PPL', 'P'),
(113527, 'Happyland', 41.4727783203125, 0.723836531639177, -72.0650024414063, -1.25777156806029, 218, 8, 'PPL', 'P'),
(196667, 'Happys Inn', 48.0833282470703, 0.83921239322857, -115.139442443848, -2.00956236955565, 218, 31, 'PPL', 'P'),
(81436, 'Happytown', 33.9936103820801, 0.593300425807425, -81.0869369506836, -1.41523403014648, 218, 48, 'PPL', 'P'),
(72816, 'Har-Win Acres', 39.9602813720703, 0.697438479965984, -82.5319366455078, -1.44045403251148, 218, 41, 'PPL', 'P'),
(41260, 'Harahan', 29.9402809143066, 0.522556480926669, -90.2030563354492, -1.57434032841552, 218, 22, 'PPL', 'P'),
(41261, 'Harahan Junction', 29.9730606079102, 0.523128594507845, -90.1933288574219, -1.57417055189603, 218, 22, 'PPL', 'P'),
(21721, 'Haralson', 33.226390838623, 0.579909918688452, -84.5713882446289, -1.4760491778512, 218, 13, 'PPL', 'P'),
(94718, 'Haralson Lakes', 30.8729496002197, 0.538834620326101, -94.3801193237305, -1.64724383062422, 218, 51, 'PPL', 'P'),
(36276, 'Harbell', 36.7319412231445, 0.641093314992905, -83.6733322143555, -1.46037514325554, 218, 21, 'PPL', 'P'),
(131200, 'Harbert', 41.871940612793, 0.730803227892769, -86.6288909912109, -1.51195937514789, 218, 27, 'PPL', 'P'),
(207590, 'Harbert', 46.0880584716797, 0.804388366182476, -118.241111755371, -2.0636967113498, 218, 56, 'PPL', 'P'),
(60172, 'Harbert Landing', 34.6536102294922, 0.604819596207426, -90.5572204589844, -1.58052165846365, 218, 30, 'PPL', 'P'),
(13890, 'Harbeson', 38.7247200012207, 0.675873865934204, -75.2852783203125, -1.31397598496976, 218, 10, 'PPL', 'P'),
(21723, 'Harbin', 33.9474983215332, 0.592495618526003, -83.8541717529297, -1.46353138862145, 218, 13, 'PPL', 'P'),
(87575, 'Harbin', 35.8702812194824, 0.626054510896255, -84.6374969482422, -1.47720299239348, 218, 50, 'PPL', 'P'),
(94719, 'Harbin', 32.1166687011719, 0.56054161360766, -98.273063659668, -1.71518852688319, 218, 51, 'PPL', 'P'),
(81437, 'Harbin (historical)', 34.6472206115723, 0.604708076336779, -83.1705627441406, -1.45160016062178, 218, 48, 'PPL', 'P'),
(21724, 'Harbin Acres', 33.5800018310547, 0.586081594777629, -84.2983322143555, -1.47128345108051, 218, 13, 'PPL', 'P'),
(81438, 'Harbin Acres', 34.665828704834, 0.605032848831715, -82.894172668457, -1.44677624378127, 218, 48, 'PPL', 'P'),
(182013, 'Harbin Springs', 38.7877807617188, 0.676974483833706, -122.654441833496, -2.14072385219038, 218, 6, 'PPL', 'P'),
(182010, 'Harbin Springs Annex', 38.7922210693359, 0.677051981821428, -122.660278320313, -2.14082571810207, 218, 6, 'PPL', 'P'),
(32682, 'Harbine', 39.999439239502, 0.698121913680726, -97.7680587768555, -1.70637452893947, 218, 20, 'PPL', 'P'),
(141991, 'Harbine', 40.1922187805176, 0.701486551401932, -96.9722213745117, -1.69248454595805, 218, 35, 'PPL', 'P'),
(182011, 'Harbine (historical)', 38.4647216796875, 0.671336039173791, -122.88500213623, -2.14474788859749, 218, 6, 'PPL', 'P'),
(65365, 'Harbinger', 36.1019401550293, 0.630097722063213, -75.8144378662109, -1.32321156131405, 218, 33, 'PPL', 'P'),
(16342, 'Harbinwood Estates', 30.5141696929932, 0.532572729654998, -84.3352813720703, -1.47192833553847, 218, 12, 'PPL', 'P'),
(9323, 'Harbis (historical)', 34.5072212219238, 0.602264626036632, -90.7738876342773, -1.58430321405351, 218, 4, 'PPL', 'P'),
(162431, 'Harbison', 40.7050018310547, 0.710436303982225, -79.6841735839844, -1.39075119077122, 218, 45, 'PPL', 'P'),
(182012, 'Harbison Canyon', 32.8202781677246, 0.572821915447206, -116.829170227051, -2.03905368283497, 218, 6, 'PPL', 'P'),
(87576, 'Harbison Crossroads', 36.1208305358887, 0.630427421406165, -83.852783203125, -1.46350715385553, 218, 50, 'PPL', 'P'),
(578, 'Harbor', 30.1866703033447, 0.526856787007361, -93.1205596923828, -1.625260367932, 218, 22, 'PPL', 'P'),
(149449, 'Harbor', 43.0819396972656, 0.751921695862934, -75.148063659668, -1.31158113735951, 218, 40, 'PPL', 'P'),
(155614, 'Harbor', 41.8877792358398, 0.73107966401392, -80.815559387207, -1.41049759814777, 218, 41, 'PPL', 'P'),
(162432, 'Harbor', 41.0352783203125, 0.716200716161701, -80.4094390869141, -1.40340946174847, 218, 45, 'PPL', 'P'),
(200943, 'Harbor', 42.0533294677734, 0.733969060638601, -124.266387939453, -2.16885761910403, 218, 43, 'PPL', 'P'),
(47833, 'Harbor Acres', 38.0611114501953, 0.664291711774422, -75.533332824707, -1.31830535279585, 218, 25, 'PPL', 'P'),
(155607, 'Harbor Acres', 41.5480613708496, 0.725150468741995, -82.8319396972656, -1.44569007353068, 218, 41, 'PPL', 'P'),
(16343, 'Harbor Beach', 26.1055603027344, 0.455627980360643, -80.1158294677734, -1.39828500717894, 218, 12, 'PPL', 'P'),
(125021, 'Harbor Beach', 41.6688919067383, 0.727259359430201, -70.7624969482422, -1.23503855867927, 218, 23, 'PPL', 'P'),
(131201, 'Harbor Beach', 43.8447189331055, 0.765234704994186, -82.6513900756836, -1.44253888817084, 218, 27, 'PPL', 'P'),
(16344, 'Harbor Bluffs', 27.9091701507568, 0.487106910630029, -82.8277816772461, -1.44561750239098, 218, 12, 'PPL', 'P'),
(207594, 'Harbor Center', 48.0088882446289, 0.837913170090775, -122.523612976074, -2.13844045787174, 218, 56, 'PPL', 'P'),
(182014, 'Harbor City', 33.7900009155273, 0.58974677022785, -118.296943664551, -2.06467116199266, 218, 6, 'PPL', 'P'),
(94720, 'Harbor City (historical)', 27.8236103057861, 0.485613609627794, -97.1952819824219, -1.69637768799758, 218, 51, 'PPL', 'P'),
(21725, 'Harbor Creek', 32.023609161377, 0.558917418237848, -80.9722213745117, -1.41323186563896, 218, 13, 'PPL', 'P'),
(16345, 'Harbor East', 26.3758296966553, 0.460345071151932, -80.0738906860352, -1.39755303735333, 218, 12, 'PPL', 'P'),
(149456, 'Harbor Green', 40.6497192382813, 0.709471440719289, -73.4630584716797, -1.28217224891592, 218, 40, 'PPL', 'P'),
(94721, 'Harbor Grove', 33.1124992370605, 0.577922135250817, -97.0502777099609, -1.69384688601368, 218, 51, 'PPL', 'P'),
(16346, 'Harbor Heights', 26.0969390869141, 0.455477511759053, -80.1127777099609, -1.39823174395714, 218, 12, 'PPL', 'P'),
(81439, 'Harbor Heights', 34.2358283996582, 0.597527927721817, -82.0027770996094, -1.43121845616719, 218, 48, 'PPL', 'P'),
(87577, 'Harbor Heights', 35.0966682434082, 0.612552417327608, -85.1986083984375, -1.48699623467003, 218, 50, 'PPL', 'P'),
(207592, 'Harbor Heights', 47.3238906860352, 0.825957707325192, -122.587783813477, -2.13956045026818, 218, 56, 'PPL', 'P'),
(47835, 'Harbor Hills', 38.4602813720703, 0.671258541186069, -76.5899963378906, -1.33674761018659, 218, 25, 'PPL', 'P'),
(72818, 'Harbor Hills', 39.9366683959961, 0.697026355787294, -82.4352798461914, -1.43876705311896, 218, 41, 'PPL', 'P'),
(87578, 'Harbor Hills', 35.3472213745117, 0.616925394416545, -84.8652801513672, -1.48117855926875, 218, 50, 'PPL', 'P'),
(149451, 'Harbor Hills', 40.790828704834, 0.711934265516367, -73.746940612793, -1.28712692696596, 218, 40, 'PPL', 'P'),
(182015, 'Harbor Hills', 33.7802810668945, 0.589577126866412, -118.313888549805, -2.06496690603171, 218, 6, 'PPL', 'P'),
(149452, 'Harbor Isle', 40.603328704834, 0.708661773168878, -73.6650009155273, -1.28569680946059, 218, 40, 'PPL', 'P'),
(87579, 'Harbor Isles', 36.0019416809082, 0.62835241944283, -86.4672164916992, -1.50913762281489, 218, 50, 'PPL', 'P'),
(27375, 'Harbor Light Bay', 38.7119407653809, 0.67565082619291, -89.2958297729492, -1.55850623783834, 218, 18, 'PPL', 'P'),
(47836, 'Harbor Light Beach', 38.3300018310547, 0.66898473424736, -76.434440612793, -1.33403265061331, 218, 25, 'PPL', 'P'),
(47837, 'Harbor Mist Estates', 38.3447189331055, 0.669241596134498, -75.0999984741211, -1.31074224161613, 218, 25, 'PPL', 'P'),
(16347, 'Harbor Oaks', 29.107780456543, 0.508026606914333, -80.9691696166992, -1.41317860241716, 218, 12, 'PPL', 'P'),
(47838, 'Harbor Oaks', 39.042781829834, 0.68142509206842, -76.5944366455078, -1.33682510817431, 218, 25, 'PPL', 'P'),
(16348, 'Harbor Palms', 28.0433292388916, 0.489448428439454, -82.6922225952148, -1.44325155007855, 218, 12, 'PPL', 'P'),
(131203, 'Harbor Point', 45.4219398498535, 0.792762403022763, -84.9863891601563, -1.48329231022595, 218, 27, 'PPL', 'P'),
(155608, 'Harbor Point', 40.5400009155273, 0.707556494737468, -84.539436340332, -1.47549151191894, 218, 41, 'PPL', 'P'),
(182017, 'Harbor Point', 37.8819389343262, 0.661164561443424, -122.499717712402, -2.13802340684504, 218, 6, 'PPL', 'P'),
(16349, 'Harbor Shores', 28.8688907623291, 0.503857195201219, -81.7458267211914, -1.42673382604955, 218, 12, 'PPL', 'P'),
(81441, 'Harbor Side', 34.0319404602051, 0.593969411873253, -81.2680587768555, -1.4183952023604, 218, 48, 'PPL', 'P'),
(182018, 'Harbor Side', 32.6100006103516, 0.569151879727995, -117.080558776855, -2.04344124073087, 218, 6, 'PPL', 'P'),
(131204, 'Harbor Springs', 45.4316711425781, 0.792932246121282, -84.991943359375, -1.48338924928962, 218, 27, 'PPL', 'P'),
(174414, 'Harbor Springs', 44.0641708374023, 0.769064863273938, -88.6855621337891, -1.54785505821663, 218, 57, 'PPL', 'P'),
(47839, 'Harbor Valley Estates', 39.2208290100098, 0.684532601586378, -76.6230621337891, -1.33732471719481, 218, 25, 'PPL', 'P'),
(16352, 'Harbor View', 28.0402793884277, 0.489395198507166, -82.7847213745117, -1.44486595833136, 218, 12, 'PPL', 'P'),
(47841, 'Harbor View', 39.5097198486328, 0.689574697899198, -75.8772201538086, -1.32430731894456, 218, 25, 'PPL', 'P'),
(81442, 'Harbor View', 32.7566719055176, 0.571711776746807, -79.9558334350586, -1.39549254961794, 218, 48, 'PPL', 'P'),
(87580, 'Harbor View', 36.2447204589844, 0.632589708474228, -86.579719543457, -1.51110117148661, 218, 50, 'PPL', 'P'),
(102606, 'Harbor View', 38.6708297729492, 0.674933304016215, -77.2252807617188, -1.34783541506903, 218, 53, 'PPL', 'P'),
(113528, 'Harbor View', 41.2633285522461, 0.720180943568879, -72.5158309936523, -1.26564001065898, 218, 8, 'PPL', 'P'),
(125022, 'Harbor View', 41.6291694641113, 0.726566072019426, -70.8930587768555, -1.23731729246599, 218, 23, 'PPL', 'P'),
(131206, 'Harbor View', 45.3427810668945, 0.791380821628257, -83.4869384765625, -1.45712195882595, 218, 27, 'PPL', 'P'),
(155609, 'Harbor View', 41.6933288574219, 0.727685864678777, -83.4444427490234, -1.45638026846237, 218, 41, 'PPL', 'P'),
(16353, 'Harbor Village', 26.2374992370605, 0.457930749176207, -80.095832824707, -1.39793599991809, 218, 12, 'PPL', 'P'),
(81443, 'Harbor Woods', 32.735279083252, 0.571338401561978, -79.9347229003906, -1.39512410128113, 218, 48, 'PPL', 'P'),
(162433, 'Harborcreek', 42.166389465332, 0.735942329848295, -79.9530563354492, -1.3954440800861, 218, 45, 'PPL', 'P'),
(186818, 'Harboro', 37.497501373291, 0.654454860235024, -102.814437866211, -1.79445045935251, 218, 7, 'PPL', 'P'),
(127685, 'Harborside', 44.3488883972168, 0.774034122130944, -68.8152770996094, -1.20105316106044, 218, 26, 'PPL', 'P'),
(102607, 'Harborton', 37.6616706848145, 0.65732015525184, -75.8308334350586, -1.32349771797317, 218, 53, 'PPL', 'P'),
(47843, 'Harborview', 38.9700012207031, 0.680154830807479, -76.2980575561523, -1.331652317231, 218, 25, 'PPL', 'P'),
(113529, 'Harborview', 41.0819396972656, 0.717015110823048, -73.4091720581055, -1.28123175357696, 218, 8, 'PPL', 'P'),
(87581, 'Harbour', 36.4594383239746, 0.63633724218116, -82.6402816772461, -1.44234501004349, 218, 50, 'PPL', 'P'),
(9324, 'Harbour (historical)', 33.6191711425781, 0.586765228229452, -92.6911087036133, -1.61776503420202, 218, 4, 'PPL', 'P'),
(47844, 'Harbour Glen', 39.0311088562012, 0.681221360245028, -76.5152816772461, -1.33544359335883, 218, 25, 'PPL', 'P'),
(16354, 'Harbour Heights', 26.9905605316162, 0.471074148235534, -82.0025024414063, -1.43121366247723, 218, 12, 'PPL', 'P'),
(47845, 'Harbour Oaks', 39.434440612793, 0.688260827375408, -76.2774963378906, -1.33129345627411, 218, 25, 'PPL', 'P'),
(102608, 'Harbour Point', 37.4166717529297, 0.653044117226581, -75.954719543457, -1.32565993846221, 218, 53, 'PPL', 'P'),
(207593, 'Harbour Pointe', 47.8858299255371, 0.835765397250654, -122.303886413574, -2.13460550590203, 218, 56, 'PPL', 'P'),
(81446, 'Harbour Town', 32.1375007629395, 0.560905201675483, -80.8088912963867, -1.41038121800814, 218, 48, 'PPL', 'P'),
(141992, 'Harbour West Mobile Home Park', 40.7938919067383, 0.711987728475251, -96.7411117553711, -1.68845092217102, 218, 35, 'PPL', 'P'),
(87582, 'Harbour Woods', 35.1138916015625, 0.61285302163565, -85.1527786254883, -1.48619635423662, 218, 50, 'PPL', 'P'),
(145369, 'Harbourton', 40.3522186279297, 0.704279075541962, -74.8525009155273, -1.30642259432802, 218, 37, 'PPL', 'P'),
(87583, 'Harbuck', 35.0922203063965, 0.612474786181832, -84.371940612793, -1.47256815999036, 218, 50, 'PPL', 'P'),
(27376, 'Harco', 37.7958297729492, 0.659661673061265, -88.6500015258789, -1.54723440852458, 218, 18, 'PPL', 'P'),
(36277, 'Harcourt', 37.5558280944824, 0.655472853561706, -86.0122222900391, -1.50119647591844, 218, 21, 'PPL', 'P'),
(115930, 'Harcourt', 42.2627792358398, 0.737624648708898, -94.1755599975586, -1.64367359686686, 218, 16, 'PPL', 'P'),
(102609, 'Harcum', 37.5183296203613, 0.654818381723819, -76.5055618286133, -1.3352739499974, 218, 53, 'PPL', 'P'),
(178329, 'Harcuvar', 33.7599983215332, 0.589223126178514, -113.652496337891, -1.98361026420699, 218, 5, 'PPL', 'P'),
(155611, 'Hard', 40.6655616760254, 0.709747943419467, -81.9524993896484, -1.43034094458801, 218, 41, 'PPL', 'P'),
(21727, 'Hard Cash', 34.1847190856934, 0.596635901914695, -82.9711074829102, -1.44811900960289, 218, 13, 'PPL', 'P'),
(47846, 'Hard Corner', 38.3794403076172, 0.669847598440545, -76.9572219848633, -1.34315690682403, 218, 25, 'PPL', 'P'),
(102610, 'Hard Corner', 38.0063896179199, 0.663336635628492, -77.2880630493164, -1.34893117269954, 218, 53, 'PPL', 'P'),
(131207, 'Hard Luck', 44.0716705322266, 0.769195757641515, -84.1930618286133, -1.46944613624446, 218, 27, 'PPL', 'P'),
(188660, 'Hard Luck Crossing', 33.5472183227539, 0.585509414617425, -106.981666564941, -1.86718232082896, 218, 38, 'PPL', 'P'),
(149453, 'Hard Point', 43.089168548584, 0.752047863119577, -76.6630630493164, -1.33802286487458, 218, 40, 'PPL', 'P'),
(178330, 'Hard Rocks', 36.0783309936523, 0.629685664463551, -110.438331604004, -1.92751250689918, 218, 5, 'PPL', 'P'),
(115931, 'Hard Scratch', 41.6133308410645, 0.726289635898276, -95.7138900756836, -1.6705225217126, 218, 16, 'PPL', 'P'),
(2970, 'Hardaway', 32.2863883972168, 0.563503781109128, -85.8488922119141, -1.49834582828762, 218, 2, 'PPL', 'P'),
(16355, 'Hardaway', 30.6302795410156, 0.53459922879698, -84.7355575561523, -1.47891447286802, 218, 12, 'PPL', 'P'),
(65366, 'Hardaway (historical)', 35.7166709899902, 0.623373506626872, -81.841667175293, -1.42840655753023, 218, 33, 'PPL', 'P'),
(36281, 'Hardburly', 37.3016700744629, 0.651036959292016, -83.1241683959961, -1.45079042649235, 218, 21, 'PPL', 'P'),
(36278, 'Hardcastle', 36.9416694641113, 0.644753763332192, -86.3288879394531, -1.50672333412868, 218, 21, 'PPL', 'P'),
(60171, 'Hardee', 32.5930595397949, 0.568856202267969, -90.8550033569336, -1.58571895048899, 218, 30, 'PPL', 'P'),
(65367, 'Hardee Acres', 35.5786094665527, 0.620963878472569, -77.2944412231445, -1.34904249283311, 218, 33, 'PPL', 'P'),
(65368, 'Hardee Cross Roads', 35.473331451416, 0.619126430478468, -78.6080627441406, -1.37196951349954, 218, 33, 'PPL', 'P'),
(81447, 'Hardeeville', 32.2869415283203, 0.563513435068079, -81.0808334350586, -1.41512750370288, 218, 48, 'PPL', 'P'),
(55165, 'Hardeman', 39.0894393920898, 0.682239420150738, -93.0102767944336, -1.62333556825414, 218, 29, 'PPL', 'P'),
(188661, 'Harden Cienega', 33.1733283996582, 0.578983804419377, -109.038330078125, -1.90307787073965, 218, 38, 'PPL', 'P'),
(76020, 'Harden City', 34.6072196960449, 0.604009928657015, -96.5994415283203, -1.68597831025693, 218, 42, 'PPL', 'P'),
(182021, 'Harden Flat', 37.8111114501953, 0.659928388644436, -119.946388244629, -2.0934594007442, 218, 6, 'PPL', 'P'),
(149454, 'Hardenburg', 42.0008316040039, 0.733052800065559, -74.6655578613281, -1.30315982251851, 218, 40, 'PPL', 'P'),
(55166, 'Hardenville', 36.589168548584, 0.638601461739945, -92.3711090087891, -1.61217998592197, 218, 29, 'PPL', 'P'),
(207595, 'Harder', 46.6619415283203, 0.814404515042264, -118.487777709961, -2.06800184440997, 218, 56, 'PPL', 'P'),
(36279, 'Hardesty', 37.8019409179688, 0.659768332662922, -85.2133331298828, -1.48725322971522, 218, 21, 'PPL', 'P'),
(47848, 'Hardesty', 38.898609161377, 0.678908804312458, -76.6786117553711, -1.33829424098965, 218, 25, 'PPL', 'P'),
(109545, 'Hardesty', 39.291389465332, 0.685764113853458, -79.6336135864258, -1.38986875234402, 218, 58, 'PPL', 'P'),
(190986, 'Hardesty', 36.6163902282715, 0.639076569678416, -101.190277099609, -1.7661035063936, 218, 42, 'PPL', 'P'),
(47849, 'Hardesty Estates', 38.9319381713867, 0.679490505273559, -76.6186065673828, -1.33724695289098, 218, 25, 'PPL', 'P'),
(47850, 'Hardesty Fields', 38.6319389343262, 0.674254530833381, -76.5699996948242, -1.33639860292574, 218, 25, 'PPL', 'P'),
(9325, 'Hardin', 34.2811088562012, 0.598318220775298, -92.1500015258789, -1.60832093234439, 218, 4, 'PPL', 'P'),
(21730, 'Hardin', 31.8541698455811, 0.555960144294883, -83.8166732788086, -1.46287691678356, 218, 13, 'PPL', 'P'),
(27377, 'Hardin', 39.1566696166992, 0.683412808927027, -90.6177825927734, -1.5815786671003, 218, 18, 'PPL', 'P'),
(36280, 'Hardin', 36.764720916748, 0.641665428574081, -88.295280456543, -1.54104335793848, 218, 21, 'PPL', 'P'),
(55167, 'Hardin', 39.2708282470703, 0.68540525289657, -93.8341674804688, -1.63771517340197, 218, 29, 'PPL', 'P'),
(65370, 'Hardin', 35.2261085510254, 0.614811576880322, -83.8444366455078, -1.4633614789439, 218, 33, 'PPL', 'P'),
(94723, 'Hardin', 30.1522197723389, 0.526255511812248, -94.7388916015625, -1.65350558813727, 218, 51, 'PPL', 'P'),
(115932, 'Hardin', 43.0802803039551, 0.75189273398608, -91.4841690063477, -1.59669996261172, 218, 16, 'PPL', 'P'),
(155612, 'Hardin', 40.2863883972168, 0.703130121268674, -84.2422180175781, -1.47030407358963, 218, 41, 'PPL', 'P'),
(193141, 'Hardin', 40.3511085510254, 0.704259701045031, -104.425003051758, -1.8225601246583, 218, 7, 'PPL', 'P'),
(196668, 'Hardin', 45.7324981689453, 0.798182668210374, -107.611389160156, -1.87817305348966, 218, 31, 'PPL', 'P'),
(182020, 'Hardin (historical)', 38.8727798461914, 0.678457997718935, -122.893058776855, -2.14488850350304, 218, 6, 'PPL', 'P'),
(87586, 'Hardin Estates', 35.8083305358887, 0.624973267493683, -84.2399978637695, -1.47026532459577, 218, 50, 'PPL', 'P'),
(16358, 'Hardin Heights', 30.6741695404053, 0.535365253795028, -84.8386077880859, -1.4807130387102, 218, 12, 'PPL', 'P'),
(36283, 'Hardin Springs', 37.6094398498535, 0.656408555210706, -86.2563934326172, -1.50545806629478, 218, 21, 'PPL', 'P'),
(32683, 'Harding', 37.9938888549805, 0.663118456156188, -94.8194427490234, -1.65491147087672, 218, 20, 'PPL', 'P'),
(36284, 'Harding', 37.6480598449707, 0.657082601282605, -87.9855575561523, -1.53563767355783, 218, 21, 'PPL', 'P'),
(70931, 'Harding', 39.6433296203613, 0.691906628328699, -75.1222229003906, -1.3111301310289, 218, 37, 'PPL', 'P'),
(109546, 'Harding', 38.9480590820313, 0.679771868242726, -79.9594421386719, -1.39555553337772, 218, 58, 'PPL', 'P'),
(112270, 'Harding', 31.5275001525879, 0.550258682585673, -83.4291687011719, -1.45611368603725, 218, 13, 'PPL', 'P'),
(119926, 'Harding', 41.5149993896484, 0.724573428312802, -88.8494415283203, -1.55071529322737, 218, 18, 'PPL', 'P'),
(125023, 'Harding', 42.2036094665527, 0.736591941417193, -71.3244400024414, -1.24484631518376, 218, 23, 'PPL', 'P'),
(127686, 'Harding', 43.9124984741211, 0.766417681150399, -69.8766708374023, -1.21957797644497, 218, 26, 'PPL', 'P'),
(135796, 'Harding', 46.1161117553711, 0.804877988348887, -94.0405578613281, -1.64131736509241, 218, 28, 'PPL', 'P'),
(162435, 'Harding', 41.3624992370605, 0.721911798540349, -75.8105621337891, -1.32314391702236, 218, 45, 'PPL', 'P'),
(192609, 'Harding', 39.2891693115234, 0.685725364859598, -112.463333129883, -1.96285545088367, 218, 52, 'PPL', 'P'),
(198390, 'Harding', 47.853328704834, 0.835198143938467, -104.014717102051, -1.81539928396124, 218, 34, 'PPL', 'P'),
(202188, 'Harding', 45.3983306884766, 0.7923503454231, -103.832221984863, -1.81221414329751, 218, 49, 'PPL', 'P'),
(149457, 'Harding Crossing', 42.8474998474121, 0.747829948585109, -73.978889465332, -1.29117519813899, 218, 40, 'PPL', 'P'),
(94725, 'Harding Gill Tract Colonia', 26.4419994354248, 0.461499950958645, -98.0380020141602, -1.71108592722393, 218, 51, 'PPL', 'P'),
(41262, 'Harding Heights', 30.5538902282715, 0.533265983776259, -91.1374969482422, -1.59064939377311, 218, 22, 'PPL', 'P'),
(211868, 'Harding Lake', 64.4216690063477, 1.12437023379075, -146.850830078125, -2.56303049415, 218, 1, 'PPL', 'P'),
(112472, 'Harding Lakes', 39.4524993896484, 0.688576012490419, -74.7525024414063, -1.30467729170764, 218, 37, 'PPL', 'P'),
(29996, 'Hardingrove', 37.9269409179688, 0.661949994227915, -86.5713882446289, -1.51095576289109, 218, 19, 'PPL', 'P'),
(102613, 'Hardings', 37.7486114501953, 0.65883755786194, -76.3300018310547, -1.3322098500052, 218, 53, 'PPL', 'P'),
(70932, 'Hardingville', 39.6599998474121, 0.69219757867779, -75.1744384765625, -1.31204146475393, 218, 37, 'PPL', 'P'),
(65371, 'Hardins', 35.3791694641113, 0.61748299376978, -81.190559387207, -1.41704258284275, 218, 33, 'PPL', 'P'),
(102611, 'Hardins Corner', 37.8186111450195, 0.660059283012014, -76.3966674804688, -1.33337338508546, 218, 53, 'PPL', 'P'),
(29998, 'Hardinsburg', 38.4608306884766, 0.671268128565993, -86.2786102294922, -1.5058458225495, 218, 19, 'PPL', 'P'),
(36285, 'Hardinsburg', 37.7799987792969, 0.659385370098169, -86.460563659668, -1.50902150899136, 218, 21, 'PPL', 'P'),
(27381, 'Hardinville', 38.9161109924316, 0.67921426888949, -87.8369369506836, -1.5330437546561, 218, 18, 'PPL', 'P'),
(87588, 'Hardison Mill', 35.610279083252, 0.621516617556815, -86.8230590820313, -1.51534824763501, 218, 50, 'PPL', 'P'),
(145371, 'Hardistonville', 41.1388893127441, 0.718009069120892, -74.5697174072266, -1.30148709103783, 218, 37, 'PPL', 'P'),
(109548, 'Hardman', 39.3902816772461, 0.687490108555939, -79.8949966430664, -1.39443074729133, 218, 58, 'PPL', 'P'),
(194225, 'Hardman', 40.3658294677734, 0.704516629511197, -104.91471862793, -1.8311072738608, 218, 7, 'PPL', 'P'),
(200944, 'Hardman (historical)', 45.1699981689453, 0.788365191167906, -119.68083190918, -2.08882456834108, 218, 43, 'PPL', 'P'),
(21731, 'Hardman Place', 34.1166687011719, 0.595448198647547, -84.404167175293, -1.47313061961258, 218, 13, 'PPL', 'P'),
(36288, 'Hardmoney', 36.9449996948242, 0.644811886822983, -88.5819396972656, -1.54604650552035, 218, 21, 'PPL', 'P'),
(13891, 'Hardscrabble', 38.6147193908691, 0.673953993104366, -75.478889465332, -1.31735513691891, 218, 10, 'PPL', 'P'),
(87587, 'Hardscrabble', 35.8936080932617, 0.626461641647901, -86.101936340332, -1.50276228148135, 218, 50, 'PPL', 'P'),
(102612, 'Hardscrabble', 38.5613899230957, 0.673023218303383, -79.5733337402344, -1.38881667055538, 218, 53, 'PPL', 'P'),
(122765, 'Hardscrabble', 40.019718170166, 0.698475847789597, -85.8433303833008, -1.49824875606588, 218, 19, 'PPL', 'P'),
(143936, 'Hardscrabble', 43.8316688537598, 0.765006938141957, -72.1177825927734, -1.25869275548135, 218, 36, 'PPL', 'P'),
(149459, 'Hardscrabble', 40.9711112976074, 0.715080790344296, -72.2227783203125, -1.26052527662743, 218, 40, 'PPL', 'P'),
(155618, 'Hardscrabble', 41.2591705322266, 0.720108372429175, -80.8683319091797, -1.41141865241078, 218, 41, 'PPL', 'P'),
(60173, 'Hardscrabble (historical)', 31.5608291625977, 0.550840383546774, -90.0522232055664, -1.57170779367798, 218, 30, 'PPL', 'P'),
(155619, 'Hardscrabble (historical)', 40.7455596923828, 0.711144172199968, -81.3161087036133, -1.41923383178767, 218, 41, 'PPL', 'P'),
(172097, 'Hardscrabble Corner', 43.2616691589355, 0.755058566731911, -72.4763870239258, -1.2649515835172, 218, 55, 'PPL', 'P'),
(36286, 'Hardshell', 37.4575004577637, 0.653756712555259, -83.251106262207, -1.45300591020318, 218, 21, 'PPL', 'P'),
(32684, 'Hardtner', 37.0138893127441, 0.646014237476126, -98.649169921875, -1.72175281949608, 218, 20, 'PPL', 'P'),
(204213, 'Hardup', 41.8955612182617, 0.731215485229514, -113.150833129883, -1.97485458949114, 218, 52, 'PPL', 'P'),
(102614, 'Hardware', 37.7427787780762, 0.658735758529271, -78.4058303833008, -1.36843989294881, 218, 53, 'PPL', 'P'),
(2971, 'Hardwick', 33.6883316040039, 0.587972305993531, -86.3525009155273, -1.50713545830737, 218, 2, 'PPL', 'P'),
(21732, 'Hardwick', 33.0680618286133, 0.577146556162359, -83.2236099243164, -1.45252600857475, 218, 13, 'PPL', 'P'),
(36287, 'Hardwick', 36.9288902282715, 0.644530723590898, -84.6908264160156, -1.47813376719446, 218, 21, 'PPL', 'P'),
(125024, 'Hardwick', 42.3499984741211, 0.739146911587988, -72.1999969482422, -1.26012766667668, 218, 23, 'PPL', 'P'),
(135798, 'Hardwick', 43.7750015258789, 0.764017906692129, -96.1991729736328, -1.67899230608544, 218, 28, 'PPL', 'P'),
(145372, 'Hardwick', 41.0544395446777, 0.716535142615588, -74.932502746582, -1.30781888968755, 218, 37, 'PPL', 'P'),
(172098, 'Hardwick', 44.5047187805176, 0.776753875394187, -72.3686065673828, -1.26307045968122, 218, 55, 'PPL', 'P'),
(182023, 'Hardwick', 36.4013900756836, 0.635324109123467, -119.717781066895, -2.08946945279904, 218, 6, 'PPL', 'P'),
(87589, 'Hardwick (historical)', 35.0708312988281, 0.61210147757603, -87.6033325195313, -1.52896658818524, 218, 50, 'PPL', 'P'),
(145373, 'Hardwick Center', 41.0083312988281, 0.715730401913193, -74.9488906860352, -1.30810491318863, 218, 37, 'PPL', 'P'),
(172099, 'Hardwick Center', 44.5297203063965, 0.777190234338797, -72.3375015258789, -1.26252757429301, 218, 55, 'PPL', 'P'),
(172100, 'Hardwick Street', 44.5497207641602, 0.777539308178679, -72.3000030517578, -1.26187310245512, 218, 55, 'PPL', 'P'),
(87590, 'Hardwick Subdivision', 35.1311111450195, 0.613153559364666, -87.5355606079102, -1.52778374518708, 218, 50, 'PPL', 'P'),
(2972, 'Hardwickburg', 31.4986095428467, 0.54975444632278, -85.1508331298828, -1.48616239893272, 218, 2, 'PPL', 'P'),
(41264, 'Hardwood', 30.8061103820801, 0.537668055900106, -91.3838882446289, -1.59494973314332, 218, 22, 'PPL', 'P'),
(131208, 'Hardwood', 45.961669921875, 0.802182469851564, -87.6911087036133, -1.53049857160231, 218, 27, 'PPL', 'P'),
(2973, 'Hardy', 33.2636108398438, 0.58055953025735, -86.8108291625977, -1.51513479527364, 218, 2, 'PPL', 'P'),
(9327, 'Hardy', 36.3158302307129, 0.633830808121232, -91.4824981689453, -1.59667080099778, 218, 4, 'PPL', 'P'),
(36289, 'Hardy', 37.6213912963867, 0.656617147303086, -82.2441711425781, -1.4354315770117, 218, 21, 'PPL', 'P'),
(60174, 'Hardy', 33.8819389343262, 0.59135139136365, -89.8294372558594, -1.56781944532841, 218, 30, 'PPL', 'P'),
(76021, 'Hardy', 36.9708290100098, 0.645262693416506, -96.7980575561523, -1.68944481388983, 218, 42, 'PPL', 'P'),
(87591, 'Hardy', 36.3183288574219, 0.633874417384082, -85.440559387207, -1.49121907605251, 218, 50, 'PPL', 'P'),
(94726, 'Hardy', 33.5763893127441, 0.586018544438821, -97.5202789306641, -1.70204995480334, 218, 51, 'PPL', 'P'),
(102615, 'Hardy', 37.2316703796387, 0.649815234141942, -79.8108291625977, -1.39296174763404, 218, 53, 'PPL', 'P'),
(109549, 'Hardy', 37.3102798461914, 0.651187228156524, -81.0277786254883, -1.41420152259186, 218, 58, 'PPL', 'P'),
(115939, 'Hardy', 42.8105583190918, 0.747185197285201, -94.0511093139648, -1.64150152268179, 218, 16, 'PPL', 'P'),
(127687, 'Hardy', 45.3311080932617, 0.791177089804866, -68.8202819824219, -1.20114051274419, 218, 26, 'PPL', 'P'),
(141993, 'Hardy', 40.0088882446289, 0.698286829931229, -97.9266662597656, -1.70914275173455, 218, 35, 'PPL', 'P'),
(162436, 'Hardy', 40.6088905334473, 0.708758845390611, -79.9680633544922, -1.39570600197931, 218, 45, 'PPL', 'P'),
(182022, 'Hardy', 39.7125015258789, 0.693113905829859, -123.801940917969, -2.16075148937805, 218, 6, 'PPL', 'P'),
(204214, 'Hardy', 40.3386116027832, 0.704041588151754, -111.738059997559, -1.95019704674836, 218, 52, 'PPL', 'P'),
(87592, 'Hardy Acres', 35.6455612182617, 0.622132406979868, -87.0202789306641, -1.51879038334394, 218, 50, 'PPL', 'P'),
(149460, 'Hardy Corners', 42.3591690063477, 0.739306967569501, -78.3091735839844, -1.3667529135563, 218, 40, 'PPL', 'P'),
(102616, 'Hardy Ford', 37.211669921875, 0.64946616030206, -79.7986068725586, -1.39274842843072, 218, 53, 'PPL', 'P'),
(94727, 'Hardy Heights', 29.8833293914795, 0.521562489339311, -95.3672180175781, -1.664471952874, 218, 51, 'PPL', 'P'),
(78429, 'Hardy Hill', 39.964168548584, 0.697506323994754, -79.601936340332, -1.38931588010172, 218, 45, 'PPL', 'P'),
(127688, 'Hardy Hill', 44.7555618286133, 0.781131912489196, -68.8199996948242, -1.20113558589618, 218, 26, 'PPL', 'P'),
(21733, 'Hardy Hills', 33.9288902282715, 0.592170846031068, -84.7472229003906, -1.47911807153336, 218, 13, 'PPL', 'P'),
(182024, 'Hardy Place', 39.8011093139648, 0.694660403474868, -122.949722290039, -2.14587746837384, 218, 6, 'PPL', 'P'),
(149461, 'Hardys', 42.6197204589844, 0.743854448288866, -78.1772232055664, -1.36444994500365, 218, 40, 'PPL', 'P'),
(21735, 'Hardys Crossroads', 33.3808288574219, 0.582605370606749, -83.8161087036133, -1.46286706308753, 218, 13, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(36293, 'Hardyville', 37.2541694641113, 0.650207917244674, -85.7861099243164, -1.4972500706571, 218, 21, 'PPL', 'P'),
(55169, 'Hardyville', 37.8944396972656, 0.661382740915728, -93.7600021362305, -1.63642074395414, 218, 29, 'PPL', 'P'),
(102620, 'Hardyville', 37.5566711425781, 0.655487567526729, -76.3722229003906, -1.33294674667883, 218, 53, 'PPL', 'P'),
(178331, 'Hardyville (historical)', 35.0449981689453, 0.61165060440348, -114.620826721191, -2.00051081764269, 218, 5, 'PPL', 'P'),
(65372, 'Hare', 36.4805603027344, 0.636705890255054, -80.9811096191406, -1.41338699477246, 218, 33, 'PPL', 'P'),
(94729, 'Hare', 30.6708297729492, 0.535306963856669, -97.2727813720703, -1.69773030751523, 218, 51, 'PPL', 'P'),
(102618, 'Hare Valley', 37.4949989318848, 0.654411184393146, -75.8594436645508, -1.32399706067756, 218, 53, 'PPL', 'P'),
(102619, 'Hare Valley Estates', 37.4991683959961, 0.654483955269933, -75.8494415283203, -1.32382249046811, 218, 53, 'PPL', 'P'),
(41266, 'Harelson', 30.4338893890381, 0.53117157402648, -91.0658264160156, -1.5893985070091, 218, 22, 'PPL', 'P'),
(195053, 'Harer', 42.1894416809082, 0.736344666909979, -111.170829772949, -1.9402970117121, 218, 17, 'PPL', 'P'),
(13892, 'Hares Corner', 39.6652793884277, 0.692289724051507, -75.6044387817383, -1.31954638586382, 218, 10, 'PPL', 'P'),
(65373, 'Hares Crossroads', 35.670280456543, 0.622563839076461, -78.2519378662109, -1.36575396183141, 218, 33, 'PPL', 'P'),
(9331, 'Haretown', 34.0208282470703, 0.593775467166868, -93.3741683959961, -1.62968667482176, 218, 4, 'PPL', 'P'),
(47851, 'Harewood', 39.3730583190918, 0.687189504247896, -76.3447189331055, -1.33246671189234, 218, 25, 'PPL', 'P'),
(109552, 'Harewood', 39.3022193908691, 0.685953131711827, -77.916389465332, -1.35989753743627, 218, 58, 'PPL', 'P'),
(72819, 'Harewood Acres', 39.1955604553223, 0.684091582109861, -84.3852767944336, -1.47280092026963, 218, 41, 'PPL', 'P'),
(47852, 'Harewood Park', 39.3752784729004, 0.687228253241757, -76.3680572509766, -1.33287404238107, 218, 25, 'PPL', 'P'),
(149462, 'Harford', 42.4261093139648, 0.740475296339719, -76.226936340332, -1.33041101784691, 218, 40, 'PPL', 'P'),
(162437, 'Harford', 41.7822189331055, 0.729237289171803, -75.7019424438477, -1.32124814580038, 218, 45, 'PPL', 'P'),
(47853, 'Harford Commons', 39.4188919067383, 0.687989451260329, -76.3027801513672, -1.33173474206673, 218, 25, 'PPL', 'P'),
(47855, 'Harford Dale', 39.5505599975586, 0.690287492964958, -76.3652801513672, -1.33282557284923, 218, 25, 'PPL', 'P'),
(47856, 'Harford Downs', 39.6047210693359, 0.691232781993882, -76.4869384765625, -1.33494891118635, 218, 25, 'PPL', 'P'),
(47857, 'Harford Estates', 39.5558280944824, 0.690379438601593, -76.3808288574219, -1.33309694896431, 218, 25, 'PPL', 'P'),
(47858, 'Harford Farms', 39.4086112976074, 0.687810020781884, -76.5177764892578, -1.33548713604266, 218, 25, 'PPL', 'P'),
(47859, 'Harford Furnace', 39.4949989318848, 0.689317769433033, -76.2616729736328, -1.33101728646907, 218, 25, 'PPL', 'P'),
(47860, 'Harford Heights', 39.4858283996582, 0.689157713451519, -76.4180603027344, -1.33374676027029, 218, 25, 'PPL', 'P'),
(47861, 'Harford Heritage', 39.6300010681152, 0.69167400120748, -76.4763870239258, -1.33476475359697, 218, 25, 'PPL', 'P'),
(47863, 'Harford Hills', 39.6127815246582, 0.691373463478465, -76.3311080932617, -1.33222915792311, 218, 25, 'PPL', 'P'),
(47864, 'Harford Hunt Manor', 39.5513916015625, 0.690302007192899, -76.4913864135742, -1.33502654233213, 218, 25, 'PPL', 'P'),
(47865, 'Harford Landing', 39.4330596923828, 0.688236725767542, -76.2583312988281, -1.33095896324119, 218, 25, 'PPL', 'P'),
(47866, 'Harford Manor', 39.4324989318848, 0.688226938650536, -76.2716674804688, -1.33119172352047, 218, 25, 'PPL', 'P'),
(149464, 'Harford Mills', 42.4113883972168, 0.740218367873554, -76.2016677856445, -1.32996999837039, 218, 40, 'PPL', 'P'),
(47867, 'Harford Park', 39.3769416809082, 0.687257281697639, -76.5538864135742, -1.33611737311462, 218, 25, 'PPL', 'P'),
(47868, 'Harford Ranchettes', 39.5402793884277, 0.690108062486514, -76.2750015258789, -1.33124991359029, 218, 25, 'PPL', 'P'),
(47869, 'Harford Square', 39.4213905334473, 0.688033060523179, -76.3199996948242, -1.33203527979575, 218, 25, 'PPL', 'P'),
(47870, 'Harford Village', 39.5574989318848, 0.690408600215529, -76.3752822875977, -1.33300014305869, 218, 25, 'PPL', 'P'),
(47871, 'Harford Woods', 39.5422210693359, 0.690141951211385, -76.3361129760742, -1.33231650960686, 218, 25, 'PPL', 'P'),
(55170, 'Harg', 38.9266700744629, 0.679398559636924, -92.2311096191406, -1.60973653562182, 218, 29, 'PPL', 'P'),
(36290, 'Hargett', 37.7827796936035, 0.659433906209036, -84.0097198486328, -1.46624621503667, 218, 21, 'PPL', 'P'),
(65380, 'Hargetts Crossroads', 35.0027809143066, 0.610913774308882, -77.6369400024414, -1.3550202242159, 218, 33, 'PPL', 'P'),
(94728, 'Hargill', 26.4422206878662, 0.461503812542225, -98.0136108398438, -1.71066022092368, 218, 51, 'PPL', 'P'),
(36292, 'Hargis', 36.9650001525879, 0.645160960662865, -84.4902801513672, -1.47463357457377, 218, 21, 'PPL', 'P'),
(41267, 'Hargis', 31.6841697692871, 0.552993083234912, -92.829719543457, -1.62018424973625, 218, 22, 'PPL', 'P'),
(188663, 'Hargis', 35.146110534668, 0.613415348099821, -103.815826416016, -1.81192798663838, 218, 38, 'PPL', 'P'),
(87593, 'Hargiss', 36.2216682434082, 0.632187371412544, -85.166389465332, -1.48643390820586, 218, 50, 'PPL', 'P'),
(32685, 'Hargrave', 38.5563888549805, 0.672935933198656, -99.4447174072266, -1.73563774247142, 218, 20, 'PPL', 'P'),
(9330, 'Hargrave Corner', 36.2591705322266, 0.632841909829458, -90.2291717529297, -1.57479612843609, 218, 4, 'PPL', 'P'),
(65374, 'Hargraves Bench', 36.1508293151855, 0.630950998876475, -75.7388916015625, -1.32189303025835, 218, 33, 'PPL', 'P'),
(21734, 'Hargrove', 34.3858299255371, 0.600145948231419, -83.8144378662109, -1.46283790147359, 218, 13, 'PPL', 'P'),
(41268, 'Hargrove', 30.4780597686768, 0.531942492583031, -93.4602813720703, -1.63118962978295, 218, 22, 'PPL', 'P'),
(55172, 'Hargrove', 36.0658302307129, 0.629467484991246, -90.3202819824219, -1.57638630192297, 218, 29, 'PPL', 'P'),
(65375, 'Hargrove Crossroads', 35.0941696166992, 0.612508808064758, -78.228889465332, -1.36535169134875, 218, 33, 'PPL', 'P'),
(65376, 'Hargrove Estates', 36.478889465332, 0.636676728641118, -78.4266662597656, -1.36880354759566, 218, 33, 'PPL', 'P'),
(131209, 'Haring', 44.2986106872559, 0.773156610551763, -85.4130630493164, -1.49073917442408, 218, 27, 'PPL', 'P'),
(65377, 'Hariston', 36.2605590820313, 0.632866144595378, -80.1100006103516, -1.3981832744253, 218, 33, 'PPL', 'P'),
(76022, 'Harjo', 35.2133293151855, 0.614588537139028, -96.8274993896484, -1.68995867082217, 218, 42, 'PPL', 'P'),
(16359, 'Harker', 26.3430595397949, 0.459773124018324, -81.3436126708984, -1.41971386657416, 218, 12, 'PPL', 'P'),
(94730, 'Harker Heights', 31.0833301544189, 0.542506453679048, -97.6594390869141, -1.7044787577175, 218, 51, 'PPL', 'P'),
(65378, 'Harkers Island', 34.6949996948242, 0.60554197865311, -76.5597229003906, -1.33621923902632, 218, 33, 'PPL', 'P'),
(55171, 'Harkes', 39.348331451416, 0.686757938993249, -92.4805603027344, -1.61409027137188, 218, 29, 'PPL', 'P'),
(188664, 'Harkey Crossing', 32.2363891601563, 0.562631129798936, -104.196937561035, -1.81857963093501, 218, 38, 'PPL', 'P'),
(94731, 'Harkeyville', 31.2105598449707, 0.54472703068547, -98.7852783203125, -1.72412835918843, 218, 51, 'PPL', 'P'),
(47872, 'Harkins', 39.6969413757324, 0.692842329977698, -76.4511108398438, -1.3343236009624, 218, 25, 'PPL', 'P'),
(2974, 'Harkins Crossroads', 33.2311096191406, 0.579992276945163, -85.8672180175781, -1.49866567393454, 218, 2, 'PPL', 'P'),
(162438, 'Harkness', 41.855281829834, 0.73051247728076, -76.7072219848633, -1.33879358369404, 218, 45, 'PPL', 'P'),
(177381, 'Harkness', 44.523609161377, 0.777083574737139, -73.5699996948242, -1.28403872536591, 218, 40, 'PPL', 'P'),
(47873, 'Harkness Creek Park', 38.9430618286133, 0.679684649717025, -76.5097198486328, -1.3353465211371, 218, 25, 'PPL', 'P'),
(2975, 'Harkness Crossroads', 33.9141693115234, 0.591913917564903, -86.7227783203125, -1.51359801816661, 218, 2, 'PPL', 'P'),
(32686, 'Harlan', 39.6055603027344, 0.691247429379877, -98.7666702270508, -1.72380358669349, 218, 20, 'PPL', 'P'),
(36294, 'Harlan', 36.8430595397949, 0.643032695477728, -83.3219375610352, -1.4542421495812, 218, 21, 'PPL', 'P'),
(115940, 'Harlan', 41.6530609130859, 0.726983056467105, -95.3252792358398, -1.66373998304839, 218, 16, 'PPL', 'P'),
(122766, 'Harlan', 41.1961097717285, 0.719007754529672, -84.9197235107422, -1.48212877514569, 218, 19, 'PPL', 'P'),
(131212, 'Harlan', 44.4569396972656, 0.775919973077856, -85.8194427490234, -1.49783183819723, 218, 27, 'PPL', 'P'),
(162439, 'Harlan', 41.1322212219238, 0.717892688981256, -79.2136077880859, -1.38253826828552, 218, 45, 'PPL', 'P'),
(193209, 'Harlan', 44.5400009155273, 0.777369664817241, -123.691940307617, -2.15883161654821, 218, 43, 'PPL', 'P'),
(60175, 'Harlan (historical)', 33.0927810668945, 0.577577988258951, -88.4166717529297, -1.54316203574369, 218, 30, 'PPL', 'P'),
(36295, 'Harlan Crossroads', 36.6530609130859, 0.639716593867389, -85.7038879394531, -1.49581502630372, 218, 21, 'PPL', 'P'),
(36296, 'Harlan Gas', 36.8505592346191, 0.643163589845306, -83.3050003051758, -1.4539465387002, 218, 21, 'PPL', 'P'),
(115941, 'Harlan Junction (historical)', 41.4980583190918, 0.724277750852775, -95.3633270263672, -1.6644040422662, 218, 16, 'PPL', 'P'),
(72820, 'Harlan Park', 39.5277786254883, 0.689889883014209, -84.3874969482422, -1.47283966926349, 218, 41, 'PPL', 'P'),
(115942, 'Harlan Trailer Court', 41.6652793884277, 0.727196309091393, -95.3199996948242, -1.66364783767467, 218, 16, 'PPL', 'P'),
(122767, 'Harlansburg', 40.8144416809082, 0.712346389695057, -85.5644378662109, -1.49338116338349, 218, 19, 'PPL', 'P'),
(162440, 'Harlansburg', 41.024169921875, 0.716006838034344, -80.1888885498047, -1.39956012870887, 218, 45, 'PPL', 'P'),
(162441, 'Harleigh', 40.9805603027344, 0.715245706594799, -75.9716720581055, -1.32595581565932, 218, 45, 'PPL', 'P'),
(16360, 'Harlem', 26.7372207641602, 0.466652535167189, -80.9511108398438, -1.41286341730215, 218, 12, 'PPL', 'P'),
(21736, 'Harlem', 33.4144401550293, 0.583191998415866, -82.3127822875977, -1.43662906739585, 218, 13, 'PPL', 'P'),
(41272, 'Harlem', 29.6227798461914, 0.517015041909459, -89.9005584716797, -1.56906074471249, 218, 22, 'PPL', 'P'),
(55173, 'Harlem', 39.1177787780762, 0.682734035744193, -94.586669921875, -1.65084881863381, 218, 29, 'PPL', 'P'),
(94732, 'Harlem', 29.5988903045654, 0.516598090751294, -95.7125015258789, -1.67049828694668, 218, 51, 'PPL', 'P'),
(119927, 'Harlem', 42.3402786254883, 0.73897726822655, -89.0177764892578, -1.55365329254195, 218, 18, 'PPL', 'P'),
(131211, 'Harlem', 42.8705596923828, 0.748232418804847, -86.1136093139648, -1.50296601330474, 218, 27, 'PPL', 'P'),
(149465, 'Harlem', 40.8077812194824, 0.712230142713475, -73.9458312988281, -1.29059822428883, 218, 40, 'PPL', 'P'),
(155620, 'Harlem', 40.151668548584, 0.700778816342243, -82.8394393920898, -1.44582096789826, 218, 41, 'PPL', 'P'),
(162442, 'Harlem', 40.4580612182617, 0.706126377232095, -75.5877838134766, -1.31925570183084, 218, 45, 'PPL', 'P'),
(182025, 'Harlem', 36.399169921875, 0.635285360129606, -121.252502441406, -2.116255393885, 218, 6, 'PPL', 'P'),
(195054, 'Harlem', 48.0391693115234, 0.838441674409102, -116.811393737793, -2.03874342456797, 218, 17, 'PPL', 'P'),
(196669, 'Harlem', 48.5333290100098, 0.84706638817835, -108.783332824707, -1.89862732908396, 218, 31, 'PPL', 'P'),
(13123, 'Harlem (historical)', 38.9061088562012, 0.679039698680036, -77.0802764892578, -1.34530461308512, 218, 9, 'PPL', 'P'),
(140188, 'Harlem (historical)', 46.1805610656738, 0.80600284101431, -97.7986068725586, -1.7069076937897, 218, 34, 'PPL', 'P'),
(2976, 'Harlem Heights', 33.4602813720703, 0.583992078586353, -86.9805603027344, -1.51809716251219, 218, 2, 'PPL', 'P'),
(16362, 'Harlem Heights', 28.5100002288818, 0.497593373738325, -81.6208267211914, -1.42455216448456, 218, 12, 'PPL', 'P'),
(109553, 'Harlem Heights', 38.0055618286133, 0.663322187979579, -81.1224975585938, -1.41585467983852, 218, 58, 'PPL', 'P'),
(155621, 'Harlem Springs', 40.5208282470703, 0.707221868546499, -81.0033264160156, -1.41377475102717, 218, 41, 'PPL', 'P'),
(182026, 'Harlem Springs', 34.1213912963867, 0.595530623483285, -117.225280761719, -2.04596711586676, 218, 6, 'PPL', 'P'),
(13893, 'Harlemtown', 38.6902809143066, 0.675272790476173, -75.376106262207, -1.31556123160863, 218, 10, 'PPL', 'P'),
(149466, 'Harlemville', 42.2702789306641, 0.737755543076476, -73.5947189331055, -1.2844701574625, 218, 40, 'PPL', 'P'),
(109554, 'Harless', 38.1519393920898, 0.665876958413292, -81.8480606079102, -1.4285181439799, 218, 58, 'PPL', 'P'),
(60176, 'Harleston', 30.7224998474121, 0.536208776780797, -88.5088882446289, -1.54477151714848, 218, 30, 'PPL', 'P'),
(94733, 'Harleton', 32.6763916015625, 0.570310621118289, -94.5744400024414, -1.65063536627244, 218, 51, 'PPL', 'P'),
(65381, 'Harley', 36.1927795410156, 0.631683168439165, -81.4147186279297, -1.42095489964213, 218, 33, 'PPL', 'P'),
(72823, 'Harley', 39.8530616760254, 0.695567143247013, -82.6880569458008, -1.44317884578079, 218, 41, 'PPL', 'P'),
(109555, 'Harley', 38.6316719055176, 0.674249870301474, -81.3141708374023, -1.41920000964183, 218, 58, 'PPL', 'P'),
(122768, 'Harley', 40.5397186279297, 0.707551567889451, -86.6391677856445, -1.5121387390473, 218, 19, 'PPL', 'P'),
(162443, 'Harley Corners', 40.1580581665039, 0.70089033621289, -75.3741683959961, -1.31552740946278, 218, 45, 'PPL', 'P'),
(122769, 'Harley Siding', 40.5513916015625, 0.707755299712842, -86.6347198486328, -1.51206110790153, 218, 19, 'PPL', 'P'),
(162444, 'Harleysville', 40.2794418334961, 0.703008880860048, -75.3874969482422, -1.315760036584, 218, 45, 'PPL', 'P'),
(81448, 'Harleyville', 33.2144393920898, 0.579701326596072, -80.4480590820313, -1.40408350782037, 218, 48, 'PPL', 'P'),
(109556, 'Harlin', 39.2994384765625, 0.68590459560096, -80.6836090087891, -1.40819462959513, 218, 58, 'PPL', 'P'),
(170461, 'Harlin Addition', 45.4822196960449, 0.793814484811398, -98.5166702270508, -1.71944026356351, 218, 49, 'PPL', 'P'),
(94734, 'Harlingen', 26.1902809143066, 0.457106633976882, -97.6958312988281, -1.70511392163748, 218, 51, 'PPL', 'P'),
(145376, 'Harlingen', 40.4474983215332, 0.705942019905634, -74.6627807617188, -1.30311135298667, 218, 37, 'PPL', 'P'),
(113130, 'Harlis', 46.4122200012207, 0.810046052181268, -92.3125, -1.61115706574727, 218, 28, 'PPL', 'P'),
(135800, 'Harliss', 44.5825004577637, 0.778111421759855, -92.6552810668945, -1.61713972397807, 218, 28, 'PPL', 'P'),
(9332, 'Harlow', 33.7480583190918, 0.589014733823215, -92.5669403076172, -1.61559788686497, 218, 4, 'PPL', 'P'),
(21737, 'Harlow', 32.4938888549805, 0.567125347296499, -82.9763870239258, -1.4482111549766, 218, 13, 'PPL', 'P'),
(47875, 'Harlow', 39.0930595397949, 0.682302603647601, -77.3188934326172, -1.34946926439779, 218, 25, 'PPL', 'P'),
(140190, 'Harlow', 48.1636085510254, 0.840613548857088, -99.5186080932617, -1.73692737822929, 218, 34, 'PPL', 'P'),
(55174, 'Harlow Ford', 37.0722198486328, 0.647032297381836, -91.7050018310547, -1.60055422249933, 218, 29, 'PPL', 'P'),
(193617, 'Harlow Place', 41.1452789306641, 0.71812058899154, -121.675827026367, -2.12364380169721, 218, 6, 'PPL', 'P'),
(65382, 'Harlowe', 34.8458290100098, 0.608174446811627, -76.7594375610352, -1.33970491741907, 218, 33, 'PPL', 'P'),
(125026, 'Harlows Landing', 41.848331451416, 0.730391170293107, -70.5316696166992, -1.23100986174025, 218, 23, 'PPL', 'P'),
(196670, 'Harlowton', 46.4355583190918, 0.810453382669996, -109.833610534668, -1.91695813318309, 218, 31, 'PPL', 'P'),
(102622, 'Harman', 37.1597213745117, 0.648559487108942, -81.7074966430664, -1.42606483998372, 218, 53, 'PPL', 'P'),
(109557, 'Harman', 38.9222183227539, 0.679320861912121, -79.5252838134766, -1.38797804112812, 218, 58, 'PPL', 'P'),
(207596, 'Harman Heights', 47.4761085510254, 0.828614410249627, -121.793327331543, -2.12569456889462, 218, 56, 'PPL', 'P'),
(102623, 'Harman Junction', 37.310001373291, 0.651182367887534, -82.1624984741211, -1.43400612003823, 218, 53, 'PPL', 'P'),
(47876, 'Harmans', 39.1572189331055, 0.683422396306952, -76.6969375610352, -1.33861408663657, 218, 25, 'PPL', 'P'),
(47877, 'Harmans Woods', 39.1444396972656, 0.683199356565658, -76.7069396972656, -1.33878865684603, 218, 25, 'PPL', 'P'),
(72822, 'Harmar', 39.4102783203125, 0.687839115816794, -81.461669921875, -1.42177435430955, 218, 41, 'PPL', 'P'),
(162445, 'Harmar Heights', 40.5563888549805, 0.707842518238542, -79.8191680908203, -1.39310728938761, 218, 45, 'PPL', 'P'),
(162447, 'Harmarville', 40.5311088562012, 0.707401299024943, -79.8486099243164, -1.39362114631994, 218, 45, 'PPL', 'P'),
(94735, 'Harmaston', 29.9775009155273, 0.523206092495567, -95.1588897705078, -1.66083593903771, 218, 51, 'PPL', 'P'),
(94736, 'Harmel Colonia', 26.3159999847412, 0.459300845688512, -98.0169982910156, -1.71071934309988, 218, 51, 'PPL', 'P'),
(70933, 'Harmersville', 39.4988899230957, 0.68938568004083, -75.4347229003906, -1.31658428494138, 218, 37, 'PPL', 'P'),
(122770, 'Harmeson Heights', 40.0586090087891, 0.699154620972431, -85.6922225952148, -1.49561142763838, 218, 19, 'PPL', 'P'),
(2977, 'Harmon', 31.0902805328369, 0.542627760666701, -85.154167175293, -1.48622058900254, 218, 2, 'PPL', 'P'),
(9334, 'Harmon', 36.1536102294922, 0.630999534987341, -94.2769393920898, -1.64544300109511, 218, 4, 'PPL', 'P'),
(13894, 'Harmon', 38.6147193908691, 0.673953993104366, -75.2024993896484, -1.31253122007839, 218, 10, 'PPL', 'P'),
(41269, 'Harmon', 32.0658302307129, 0.559654314911473, -93.4302825927734, -1.63066605231264, 218, 22, 'PPL', 'P'),
(60177, 'Harmon', 31.0930595397949, 0.542676263488054, -89.4147186279297, -1.56058123980168, 218, 30, 'PPL', 'P'),
(76023, 'Harmon', 36.144718170166, 0.630844339274817, -99.5599975585938, -1.73764976067498, 218, 42, 'PPL', 'P'),
(87595, 'Harmon', 36.5286102294922, 0.63754451968232, -81.9086074829102, -1.42957488630045, 218, 50, 'PPL', 'P'),
(94737, 'Harmon', 33.5205612182617, 0.585044160374989, -95.8219375610352, -1.67240830608049, 218, 51, 'PPL', 'P'),
(119930, 'Harmon', 41.7227783203125, 0.728199854769162, -89.5538864135742, -1.56301017587389, 218, 18, 'PPL', 'P'),
(149467, 'Harmon', 41.2011108398438, 0.7190950396344, -73.8838882446289, -1.28951711404431, 218, 40, 'PPL', 'P'),
(155624, 'Harmon', 40.7094383239746, 0.710513735390919, -81.5597229003906, -1.42348570162604, 218, 41, 'PPL', 'P'),
(198393, 'Harmon', 46.9516716003418, 0.81946125874108, -100.952217102051, -1.76194857561891, 218, 34, 'PPL', 'P'),
(65384, 'Harmon (historical)', 35.4030609130859, 0.61789997821746, -81.8797225952148, -1.4290707499061, 218, 33, 'PPL', 'P'),
(174416, 'Harmon (historical)', 46.0677795410156, 0.804034432073605, -91.6680603027344, -1.59990947119942, 218, 57, 'PPL', 'P'),
(127689, 'Harmon Beach', 43.8044395446777, 0.764531697045432, -70.5497207641602, -1.2313249136972, 218, 26, 'PPL', 'P'),
(131213, 'Harmon City Heights', 44.1336097717285, 0.770276801307006, -83.5691680908203, -1.4585571363374, 218, 27, 'PPL', 'P'),
(2979, 'Harmon Crossroads', 33.2024993896484, 0.579492934240773, -85.4802780151367, -1.49191229688426, 218, 2, 'PPL', 'P'),
(81450, 'Harmon Estates', 33.9911117553711, 0.593256816544575, -80.7972183227539, -1.41017748618475, 218, 48, 'PPL', 'P'),
(47878, 'Harmon Haven', 39.5636100769043, 0.690515259817187, -77.1986083984375, -1.34736989451048, 218, 25, 'PPL', 'P'),
(47879, 'Harmon Landing', 38.1966705322266, 0.666657664086848, -75.2608337402344, -1.31354934656313, 218, 25, 'PPL', 'P'),
(47880, 'Harmon Landing Estates', 38.2030601501465, 0.666769183957495, -75.2958297729492, -1.31416014255914, 218, 25, 'PPL', 'P'),
(149468, 'Harmon Park', 42.892219543457, 0.748610454521584, -73.9208297729492, -1.29016186534422, 218, 40, 'PPL', 'P'),
(127692, 'Harmons Corner', 44.0397186279297, 0.768638091709253, -70.2230606079102, -1.22562361843556, 218, 26, 'PPL', 'P'),
(155625, 'Harmons Landing', 40.5116691589355, 0.707062012302067, -84.4427795410156, -1.47380453252643, 218, 41, 'PPL', 'P'),
(162449, 'Harmonsburg', 41.660831451416, 0.727118677945618, -80.3180618286133, -1.40181462772968, 218, 45, 'PPL', 'P'),
(9336, 'Harmontown', 35.7611083984375, 0.624149085715331, -91.8138885498047, -1.60245465425321, 218, 4, 'PPL', 'P'),
(60179, 'Harmontown', 34.5402793884277, 0.602841599886797, -89.6483306884766, -1.56465853943059, 218, 30, 'PPL', 'P'),
(162450, 'Harmontown', 41.9219398498535, 0.731675879202961, -77.8544387817383, -1.3588162940337, 218, 45, 'PPL', 'P'),
(162451, 'Harmonville', 40.0952796936035, 0.699794645161405, -75.2863922119141, -1.31399542604572, 218, 45, 'PPL', 'P'),
(2983, 'Harmony', 31.8908290863037, 0.556599968746775, -86.8788909912109, -1.51632269827787, 218, 2, 'PPL', 'P'),
(9341, 'Harmony', 35.2374992370605, 0.615010381855696, -91.9066696166992, -1.60407398935404, 218, 4, 'PPL', 'P'),
(13895, 'Harmony', 39.6952781677246, 0.692813301521816, -75.6930618286133, -1.32109314982494, 218, 10, 'PPL', 'P'),
(16365, 'Harmony', 28.1891708374023, 0.491993844519838, -81.1452789306641, -1.41625228978927, 218, 12, 'PPL', 'P'),
(21741, 'Harmony', 33.452220916748, 0.583851397101769, -83.3522186279297, -1.45477065389952, 218, 13, 'PPL', 'P'),
(29999, 'Harmony', 39.5366706848145, 0.690045078726733, -87.105827331543, -1.52028348460909, 218, 19, 'PPL', 'P'),
(36298, 'Harmony', 38.3672218322754, 0.669634345816257, -84.7380599975586, -1.4789581487099, 218, 21, 'PPL', 'P'),
(41270, 'Harmony', 30.5958309173584, 0.533997986891381, -92.9136123657227, -1.62164845570358, 218, 22, 'PPL', 'P'),
(47882, 'Harmony', 39.4927787780762, 0.689279020439172, -77.5302810668945, -1.35315867461393, 218, 25, 'PPL', 'P'),
(60183, 'Harmony', 31.2841701507568, 0.546011772884838, -89.8249969482422, -1.56774194734068, 218, 30, 'PPL', 'P'),
(65385, 'Harmony', 35.9555587768555, 0.627542885050473, -80.7719421386719, -1.40973633355017, 218, 33, 'PPL', 'P'),
(72824, 'Harmony', 39.922779083252, 0.69678394154907, -83.6972198486328, -1.46079206112419, 218, 41, 'PPL', 'P'),
(81449, 'Harmony', 33.8002815246582, 0.589926200706295, -81.8408279418945, -1.42839191014423, 218, 48, 'PPL', 'P'),
(87598, 'Harmony', 36.394718170166, 0.635207662404803, -82.5663909912109, -1.44105537428562, 218, 50, 'PPL', 'P'),
(102626, 'Harmony', 36.5588912963867, 0.638073024000646, -78.9655609130859, -1.37820903361749, 218, 53, 'PPL', 'P'),
(109560, 'Harmony', 38.6861114501953, 0.675200019599386, -81.4791717529297, -1.42207981888658, 218, 58, 'PPL', 'P'),
(119932, 'Harmony', 42.1611099243164, 0.735850184474579, -88.5263900756836, -1.54507698172551, 218, 18, 'PPL', 'P'),
(127690, 'Harmony', 44.9738883972168, 0.784942429955908, -69.5466690063477, -1.21381835795546, 218, 26, 'PPL', 'P'),
(135801, 'Harmony', 43.5552787780762, 0.760183021301442, -92.0100021362305, -1.60587748204424, 218, 28, 'PPL', 'P'),
(145379, 'Harmony', 40.7466697692871, 0.711163546696898, -75.1377792358398, -1.31140164030203, 218, 37, 'PPL', 'P'),
(162454, 'Harmony', 40.9683303833008, 0.715032254233429, -78.9705581665039, -1.37829625214319, 218, 45, 'PPL', 'P'),
(169411, 'Harmony', 41.8877792358398, 0.73107966401392, -71.5972213745117, -1.24960724826449, 218, 47, 'PPL', 'P'),
(174417, 'Harmony', 45.0991706848145, 0.787129018368918, -87.8197174072266, -1.53274321692708, 218, 57, 'PPL', 'P'),
(182028, 'Harmony', 36.1236114501953, 0.630475957517032, -119.168891906738, -2.07988952972581, 218, 6, 'PPL', 'P'),
(191585, 'Harmony', 33.9401512145996, 0.592367387319516, -101.533378601074, -1.7720917572627, 218, 51, 'PPL', 'P'),
(194226, 'Harmony', 40.5233306884766, 0.707265544388377, -105.043060302734, -1.83334725865367, 218, 7, 'PPL', 'P'),
(200945, 'Harmony', 45.4361114501953, 0.793009744109004, -122.577217102051, -2.13937602636269, 218, 43, 'PPL', 'P'),
(207597, 'Harmony', 46.5583305358887, 0.812596162083073, -122.482498168945, -2.13772286911602, 218, 56, 'PPL', 'P'),
(209493, 'Harmony', 41.1716690063477, 0.718581182702069, -105.862777709961, -1.84765402634568, 218, 59, 'PPL', 'P'),
(55175, 'Harmony (historical)', 39.9066696166992, 0.696502778316985, -93.3824996948242, -1.62983208341728, 218, 29, 'PPL', 'P'),
(109558, 'Harmony (historical)', 39.2630615234375, 0.685269697997085, -77.8675003051758, -1.35904426062301, 218, 58, 'PPL', 'P'),
(182029, 'Harmony Acres', 34.1436080932617, 0.595918379738, -116.108612060547, -2.02647757037734, 218, 6, 'PPL', 'P'),
(47883, 'Harmony Corner', 39.3199996948242, 0.686263456557848, -75.9772186279297, -1.32605262156494, 218, 25, 'PPL', 'P'),
(149469, 'Harmony Corners', 42.9775009155273, 0.75009889525483, -73.9552764892578, -1.2907630739603, 218, 40, 'PPL', 'P'),
(72825, 'Harmony Estates Mobile Home Park', 39.9275016784668, 0.696866366384808, -83.6699981689453, -1.46031695318572, 218, 41, 'PPL', 'P'),
(207598, 'Harmony Falls Landing', 46.2658309936523, 0.807491082010473, -122.141670227051, -2.13177429934717, 218, 56, 'PPL', 'P'),
(9342, 'Harmony Grove', 33.6519393920898, 0.587337142073547, -92.7808303833008, -1.61933097292299, 218, 4, 'PPL', 'P'),
(47884, 'Harmony Grove', 39.4536094665527, 0.688595386987349, -77.3994369506836, -1.35087501397919, 218, 25, 'PPL', 'P'),
(65386, 'Harmony Grove', 36.0800018310547, 0.629714826077487, -80.3866729736328, -1.40301211811383, 218, 33, 'PPL', 'P'),
(87599, 'Harmony Grove', 35.8894386291504, 0.626388870771114, -82.9977798461914, -1.44858453016143, 218, 50, 'PPL', 'P'),
(109559, 'Harmony Grove', 39.6069412231445, 0.691271530987742, -79.9902801513672, -1.39609375823403, 218, 58, 'PPL', 'P'),
(162455, 'Harmony Grove', 40.0102806091309, 0.698311131276176, -76.9080581665039, -1.34229883632081, 218, 45, 'PPL', 'P'),
(174418, 'Harmony Grove', 43.3716697692871, 0.756978439561749, -89.5508270263672, -1.56295677949403, 218, 57, 'PPL', 'P'),
(182030, 'Harmony Grove', 33.0961112976074, 0.577636111749742, -117.134437561035, -2.04438160291178, 218, 6, 'PPL', 'P'),
(47886, 'Harmony Hall', 38.7455596923828, 0.676237587160081, -77.0022201538086, -1.34394227302949, 218, 25, 'PPL', 'P'),
(16363, 'Harmony Heights', 27.478889465332, 0.479597095961628, -80.3574981689453, -1.40250292171341, 218, 12, 'PPL', 'P'),
(744, 'Harmony Hill', 35.1150016784668, 0.612872396132581, -81.6486129760742, -1.42503712611906, 218, 48, 'PPL', 'P'),
(47887, 'Harmony Hill', 39.5069389343262, 0.689526161788331, -77.4033279418945, -1.35094292458699, 218, 25, 'PPL', 'P'),
(78430, 'Harmony Hill', 39.9816703796387, 0.697811788571786, -75.6725006103516, -1.32073428886805, 218, 45, 'PPL', 'P'),
(174419, 'Harmony Hill', 43.2097206115723, 0.754151893538794, -90.7113876342773, -1.58321238327101, 218, 57, 'PPL', 'P'),
(13896, 'Harmony Hills', 39.6930618286133, 0.692774619106983, -75.6833267211914, -1.32092324014739, 218, 10, 'PPL', 'P'),
(47889, 'Harmony Hills', 39.0741691589355, 0.681972904304649, -77.0766677856445, -1.34524162932534, 218, 25, 'PPL', 'P'),
(87600, 'Harmony Hills', 36.5805587768555, 0.638451192875438, -82.5038909912109, -1.43996454350312, 218, 50, 'PPL', 'P'),
(162456, 'Harmony Hills', 41.3408317565918, 0.721533629665558, -75.5350036621094, -1.31833451440978, 218, 45, 'PPL', 'P'),
(162457, 'Harmony Junction', 40.7961082458496, 0.712026410890084, -80.1033325195313, -1.39806689428567, 218, 45, 'PPL', 'P'),
(47890, 'Harmony Knolls', 39.4986114501953, 0.68938081977184, -77.5361099243164, -1.35326040736757, 218, 25, 'PPL', 'P'),
(36299, 'Harmony Lake Estates', 38.4083290100098, 0.670351801413924, -85.57861328125, -1.49362857104876, 218, 21, 'PPL', 'P'),
(112340, 'Harmony Landing', 38.4113883972168, 0.670405197793781, -85.6175003051758, -1.49430727765257, 218, 21, 'PPL', 'P'),
(135802, 'Harmony Mobile Home Park', 43.5552787780762, 0.760183021301442, -92.0100021362305, -1.60587748204424, 218, 28, 'PPL', 'P'),
(200946, 'Harmony Point', 45.4472198486328, 0.793203622236362, -122.576942443848, -2.13937123267273, 218, 43, 'PPL', 'P'),
(76025, 'Harmony Star', 36.3074989318848, 0.633685399525714, -95.470832824707, -1.66628037241222, 218, 42, 'PPL', 'P'),
(178332, 'Harmony Villa', 33.4605598449707, 0.583996938855342, -111.692222595215, -1.9493970331569, 218, 5, 'PPL', 'P'),
(36300, 'Harmony Village', 38.4044418334961, 0.670283957385155, -85.620002746582, -1.49435095349444, 218, 21, 'PPL', 'P'),
(102627, 'Harmony Village', 37.5813903808594, 0.655918999623322, -76.4877777099609, -1.33496355857235, 218, 53, 'PPL', 'P'),
(145381, 'Harmonyvale', 41.146671295166, 0.718144890336487, -74.6369400024414, -1.30266034665607, 218, 37, 'PPL', 'P'),
(162462, 'Harmonyville', 40.1891708374023, 0.701433354759158, -75.7233276367188, -1.32162138782716, 218, 45, 'PPL', 'P'),
(172102, 'Harmonyville', 43.038330078125, 0.75116056442339, -72.6630630493164, -1.2682096947948, 218, 55, 'PPL', 'P'),
(87601, 'Harms', 35.1547203063965, 0.613565616964328, -86.6508331298828, -1.51234233771264, 218, 50, 'PPL', 'P'),
(36301, 'Harned', 37.7516708374023, 0.658890954241796, -86.4136123657227, -1.50820205432395, 218, 21, 'PPL', 'P'),
(78431, 'Harnedsville', 39.7975006103516, 0.694597419715088, -79.3280563354492, -1.38453577226114, 218, 45, 'PPL', 'P'),
(135805, 'Harnell Park', 46.8875007629395, 0.818341266344647, -92.396110534668, -1.61261634486657, 218, 28, 'PPL', 'P'),
(9343, 'Harness', 35.8430595397949, 0.625579402957785, -92.4052810668945, -1.61277640084809, 218, 4, 'PPL', 'P'),
(119934, 'Harness', 40.247501373291, 0.702451414664868, -89.591667175293, -1.56366957455979, 218, 18, 'PPL', 'P'),
(47891, 'Harness Woods', 38.9436111450195, 0.67969423709695, -76.5041732788086, -1.33524971523148, 218, 25, 'PPL', 'P'),
(65387, 'Harnett', 35.3452796936035, 0.616891505691674, -78.7925033569336, -1.37518860946718, 218, 33, 'PPL', 'P'),
(16364, 'Harney', 28.014720916748, 0.488949119024578, -82.3747177124023, -1.43771004448231, 218, 12, 'PPL', 'P'),
(47892, 'Harney', 39.7138900756836, 0.693138140595779, -77.2069396972656, -1.347515303106, 218, 25, 'PPL', 'P'),
(135806, 'Harney', 46.7216682434082, 0.815446942871949, -92.3333282470703, -1.61152058723606, 218, 28, 'PPL', 'P'),
(194227, 'Harney', 40.1513900756836, 0.700773956073254, -104.940277099609, -1.83155335334339, 218, 7, 'PPL', 'P'),
(199986, 'Harney', 40.5774993896484, 0.708210966575355, -116.323890686035, -2.03023489120128, 218, 39, 'PPL', 'P'),
(200947, 'Harney', 43.6433296203613, 0.761719798408472, -118.821670532227, -2.07382937350728, 218, 43, 'PPL', 'P'),
(202193, 'Harney', 43.8925018310547, 0.766068673889544, -103.387496948242, -1.80445222714242, 218, 49, 'PPL', 'P'),
(47893, 'Harney Venture Estates', 39.7069396972656, 0.693016833608126, -77.2869415283203, -1.34891159846553, 218, 25, 'PPL', 'P'),
(145382, 'Harneys Corner', 40.2491683959961, 0.702480509699777, -74.7430572509766, -1.30451244203616, 218, 37, 'PPL', 'P'),
(273, 'Harold', 38.2724990844727, 0.667981121990563, -99.9330596923828, -1.74416092322411, 218, 20, 'PPL', 'P'),
(16366, 'Harold', 30.6588897705078, 0.53509857150137, -86.8802795410156, -1.51634693304379, 218, 12, 'PPL', 'P'),
(36302, 'Harold', 37.5366706848145, 0.655138493686847, -82.6333312988281, -1.44222370305583, 218, 21, 'PPL', 'P'),
(55177, 'Harold', 37.3777809143066, 0.652365344043747, -93.5152816772461, -1.63214956619787, 218, 29, 'PPL', 'P'),
(135807, 'Harold', 47.702220916748, 0.832560815510961, -96.4972229003906, -1.68419425864269, 218, 28, 'PPL', 'P'),
(182031, 'Harold', 34.5449981689453, 0.602923958143508, -118.108612060547, -2.06138415541723, 218, 6, 'PPL', 'P'),
(47894, 'Harold Heights', 39.5091705322266, 0.689565110519274, -76.2988891601563, -1.33166683145894, 218, 25, 'PPL', 'P'),
(9344, 'Haroldton', 35.3622207641602, 0.6171871831517, -94.2600021362305, -1.64514739021411, 218, 4, 'PPL', 'P'),
(9345, 'Harp', 34.3266716003418, 0.599113440676795, -92.7886123657227, -1.61946679413859, 218, 4, 'PPL', 'P'),
(16367, 'Harp', 30.5602798461914, 0.533377503646906, -87.1080627441406, -1.52032249991906, 218, 12, 'PPL', 'P'),
(21742, 'Harp', 33.4041709899902, 0.583012767674503, -84.4433288574219, -1.47381411990635, 218, 13, 'PPL', 'P'),
(47895, 'Harp', 39.5319404602051, 0.689962520732941, -77.5277786254883, -1.35311499877205, 218, 25, 'PPL', 'P'),
(182032, 'Harp', 37.5805587768555, 0.655904485395381, -120.98388671875, -2.11156716510203, 218, 6, 'PPL', 'P'),
(16368, 'Harper', 30.4452800750732, 0.531370379001854, -86.8791732788086, -1.51632762512589, 218, 12, 'PPL', 'P'),
(21743, 'Harper', 34.1958312988281, 0.59682984662108, -82.9938888549805, -1.44851661955364, 218, 13, 'PPL', 'P'),
(30002, 'Harper', 39.146671295166, 0.6832383052966, -85.5936126708984, -1.49389035978392, 218, 19, 'PPL', 'P'),
(32689, 'Harper', 37.2866706848145, 0.650775170556861, -98.0255584716797, -1.71086874643703, 218, 20, 'PPL', 'P'),
(36303, 'Harper', 37.8016700744629, 0.659763605551987, -83.1958312988281, -1.4520411800983, 218, 21, 'PPL', 'P'),
(55178, 'Harper', 38.0625, 0.664315946540342, -93.5183334350586, -1.63220282941967, 218, 29, 'PPL', 'P'),
(65390, 'Harper', 35.3016700744629, 0.616130374252129, -78.3222198486328, -1.3669806138295, 218, 33, 'PPL', 'P'),
(94747, 'Harper', 30.2997207641602, 0.528829889769487, -99.2438888549805, -1.73213262300271, 218, 51, 'PPL', 'P'),
(102628, 'Harper', 36.878059387207, 0.643643558052765, -82.779167175293, -1.44476901926768, 218, 53, 'PPL', 'P'),
(109562, 'Harper', 37.7986106872559, 0.659710209172131, -81.2616729736328, -1.41828374906878, 218, 58, 'PPL', 'P'),
(115946, 'Harper', 41.3624992370605, 0.721911798540349, -92.0508270263672, -1.60659001079389, 218, 16, 'PPL', 'P'),
(119938, 'Harper', 42.1413917541504, 0.735506037482713, -89.647216796875, -1.56463909835463, 218, 18, 'PPL', 'P'),
(155627, 'Harper', 40.4288902282715, 0.705617247410699, -83.7083282470703, -1.46098593925155, 218, 41, 'PPL', 'P'),
(193618, 'Harper', 41.2150001525879, 0.719337453872624, -120.930557250977, -2.11063639030104, 218, 6, 'PPL', 'P'),
(200949, 'Harper', 43.8633308410645, 0.765559544068148, -117.60888671875, -2.05266230284722, 218, 43, 'PPL', 'P'),
(207601, 'Harper', 47.5208282470703, 0.829394916186102, -122.518333435059, -2.13834831249803, 218, 56, 'PPL', 'P'),
(209494, 'Harper', 41.7094383239746, 0.727967027910862, -105.888061523438, -1.84809531213831, 218, 59, 'PPL', 'P'),
(27383, 'Harper (historical)', 38.1838912963867, 0.666434624345554, -88.0425033569336, -1.53663156527665, 218, 18, 'PPL', 'P'),
(47896, 'Harper (historical)', 38.8125, 0.677405915930299, -76.2497177124023, -1.33080862779766, 218, 25, 'PPL', 'P'),
(36304, 'Harper Crossroads', 37.0902786254883, 0.647347482496847, -86.8852767944336, -1.51643415156949, 218, 21, 'PPL', 'P'),
(81451, 'Harper Crossroads', 33.4672203063965, 0.584113185836924, -79.5661087036133, -1.38869056987777, 218, 48, 'PPL', 'P'),
(47897, 'Harper Estates', 39.5444412231445, 0.690180700205246, -76.8944396972656, -1.34206114919352, 218, 25, 'PPL', 'P'),
(36305, 'Harper Ford', 37.2661094665527, 0.650416309599973, -87.8594436645508, -1.53343657091688, 218, 21, 'PPL', 'P'),
(109563, 'Harper Heights', 37.8030586242676, 0.659787840317907, -81.245002746582, -1.41799279871969, 218, 58, 'PPL', 'P'),
(2984, 'Harper Hill', 32.8566703796387, 0.57345707936719, -87.6125030517578, -1.52912664416675, 218, 2, 'PPL', 'P'),
(162463, 'Harper Tavern', 40.4038887023926, 0.70518088846609, -76.5780563354492, -1.33653921783129, 218, 45, 'PPL', 'P'),
(131214, 'Harper Woods', 42.4330596923828, 0.740596603327372, -82.9241714477539, -1.44729982125158, 218, 27, 'PPL', 'P'),
(102629, 'Harpers', 36.9933280944824, 0.645655376519238, -77.7897186279297, -1.35768671425734, 218, 53, 'PPL', 'P'),
(162464, 'Harpers', 40.7791709899902, 0.711730800009085, -75.5569381713867, -1.31871734381648, 218, 45, 'PPL', 'P'),
(47898, 'Harpers Choice', 39.2191696166992, 0.684503639709524, -76.8833312988281, -1.34186727106616, 218, 25, 'PPL', 'P'),
(94748, 'Harpers Crossing', 33.3108291625977, 0.581383645456675, -95.647216796875, -1.66935885347429, 218, 51, 'PPL', 'P'),
(65391, 'Harpers Crossroads', 35.5677795410156, 0.6207748606142, -79.4633331298828, -1.38689679772555, 218, 33, 'PPL', 'P'),
(109564, 'Harpers Ferry', 39.3252792358398, 0.686355601931565, -77.7391662597656, -1.3568044089882, 218, 58, 'PPL', 'P'),
(115947, 'Harpers Ferry', 43.2005615234375, 0.753992037294362, -91.1530609130859, -1.5909210362043, 218, 16, 'PPL', 'P'),
(21744, 'Harpers Lake', 33.8622207641602, 0.591007244371785, -84.7322235107422, -1.4788562827982, 218, 13, 'PPL', 'P'),
(47899, 'Harpers Mill', 39.1163902282715, 0.682709800978274, -76.6316680908203, -1.33747491948029, 218, 25, 'PPL', 'P'),
(81452, 'Harpers Ridge', 34.5852813720703, 0.603627032671289, -82.6563873291016, -1.44262610669654, 218, 48, 'PPL', 'P'),
(2988, 'Harpers Store', 31.5938892364502, 0.551417390686453, -87.1347198486328, -1.5207877541615, 218, 2, 'PPL', 'P'),
(149471, 'Harpersfield', 42.4383316040039, 0.740688615543035, -74.6877822875977, -1.30354771193128, 218, 40, 'PPL', 'P'),
(155628, 'Harpersfield', 41.7594413757324, 0.728839745800081, -80.9469375610352, -1.41279057984633, 218, 41, 'PPL', 'P'),
(2986, 'Harpersville', 33.3438911437988, 0.581960685885868, -86.4380569458008, -1.50862869273058, 218, 2, 'PPL', 'P'),
(94750, 'Harpersville', 32.5999984741211, 0.568977309518541, -98.9338912963867, -1.72672214493211, 218, 51, 'PPL', 'P'),
(102634, 'Harpersville', 37.0955581665039, 0.647439627870564, -76.454719543457, -1.33438658472218, 218, 53, 'PPL', 'P'),
(109566, 'Harperton', 38.9019393920898, 0.678966927803249, -79.4869384765625, -1.38730878874618, 218, 58, 'PPL', 'P'),
(109567, 'Harpertown', 38.9391708374023, 0.679616739109228, -79.8388900756836, -1.3934515029585, 218, 58, 'PPL', 'P'),
(182033, 'Harpertown', 35.2947196960449, 0.616009067264476, -118.922500610352, -2.0755891903556, 218, 6, 'PPL', 'P'),
(21745, 'Harpertown (historical)', 33.1694412231445, 0.578915960390607, -83.040283203125, -1.44932635368307, 218, 13, 'PPL', 'P'),
(60185, 'Harperville', 32.4941711425781, 0.567130274144516, -89.4894409179688, -1.56188538978749, 218, 30, 'PPL', 'P'),
(60184, 'Harperville (historical)', 32.0444412231445, 0.559281006305671, -90.4847183227539, -1.5792562574717, 218, 30, 'PPL', 'P'),
(87604, 'Harpeth', 35.7988891601563, 0.624808484401234, -86.8441696166992, -1.51571669597182, 218, 50, 'PPL', 'P'),
(87602, 'Harpeth Estates', 36.0261116027832, 0.628774264159498, -86.9394378662109, -1.51737944059841, 218, 50, 'PPL', 'P'),
(87603, 'Harpeth Hills', 35.9986114501953, 0.628294295952039, -86.8944396972656, -1.51659407439295, 218, 50, 'PPL', 'P'),
(87605, 'Harpeth River Estates', 36.0463905334473, 0.62912819826837, -86.9394378662109, -1.51737944059841, 218, 50, 'PPL', 'P'),
(87606, 'Harpeth Valley', 36.1808280944824, 0.631474576346784, -87.1675033569336, -1.5213599343217, 218, 50, 'PPL', 'P'),
(207599, 'Harpole', 46.9283294677734, 0.819053861673325, -117.415557861328, -2.04928807774609, 218, 56, 'PPL', 'P'),
(119936, 'Harpster', 40.4055595397949, 0.705210050080026, -88.4486083984375, -1.54371943535984, 218, 18, 'PPL', 'P'),
(155630, 'Harpster', 40.7391700744629, 0.711032652329321, -83.2538909912109, -1.45305451289308, 218, 41, 'PPL', 'P'),
(195055, 'Harpster', 45.9866714477539, 0.802618828796173, -115.962501525879, -2.02392746047554, 218, 17, 'PPL', 'P'),
(127693, 'Harpswell Center', 43.8016700744629, 0.764483360671647, -69.9847183227539, -1.22146376081286, 218, 26, 'PPL', 'P'),
(149473, 'Harpursville', 42.1783294677734, 0.736150722203594, -75.625, -1.31990524682071, 218, 40, 'PPL', 'P'),
(178333, 'Harqua', 33.2430610656738, 0.580200869037543, -112.998329162598, -1.97219289313966, 218, 5, 'PPL', 'P'),
(87607, 'Harr', 36.5875015258789, 0.638572366705036, -81.9925003051758, -1.43103909226777, 218, 50, 'PPL', 'P'),
(76027, 'Harrah', 35.4894409179688, 0.619407593710554, -97.163330078125, -1.69582002206532, 218, 42, 'PPL', 'P'),
(207600, 'Harrah', 46.4044418334961, 0.809910297544701, -120.543060302734, -2.10387329271279, 218, 56, 'PPL', 'P'),
(36306, 'Harreldsville', 37.0647201538086, 0.646901403014259, -86.8938903808594, -1.51658448701303, 218, 21, 'PPL', 'P'),
(2990, 'Harrell', 32.4430618286133, 0.566238248337394, -87.2155609130859, -1.52219869690702, 218, 2, 'PPL', 'P'),
(9347, 'Harrell', 33.5099983215332, 0.584859803048528, -92.3986129760742, -1.61266002070845, 218, 4, 'PPL', 'P'),
(102630, 'Harrell Corner', 38.877498626709, 0.678540355975646, -78.0644378662109, -1.36248146948392, 218, 53, 'PPL', 'P'),
(65392, 'Harrell Hill', 36.0400009155273, 0.629016678397723, -82.2369384765625, -1.43530534317603, 218, 33, 'PPL', 'P'),
(195056, 'Harrell Place', 42.0774993896484, 0.73439090535527, -114.785278320313, -2.00338103950752, 218, 17, 'PPL', 'P'),
(65393, 'Harrells', 34.7275009155273, 0.606109231965297, -78.2013931274414, -1.36487178972032, 218, 33, 'PPL', 'P'),
(94749, 'Harrells', 30.6652793884277, 0.535210091372017, -93.8305587768555, -1.63765218964219, 218, 51, 'PPL', 'P'),
(65394, 'Harrells Mill', 36.3855590820313, 0.635047806160371, -76.9049987792969, -1.34224543994095, 218, 33, 'PPL', 'P'),
(102631, 'Harrells Mill', 36.7747192382813, 0.641839932204509, -77.3916702270508, -1.3507394590797, 218, 53, 'PPL', 'P'),
(21746, 'Harrells Still', 31.0116691589355, 0.541255733362606, -84.3550033569336, -1.47227254910936, 218, 13, 'PPL', 'P'),
(65395, 'Harrellsville', 36.3025016784668, 0.633598181000014, -76.7927780151367, -1.34028681811725, 218, 33, 'PPL', 'P'),
(55179, 'Harrelson', 38.7688903808594, 0.676644784490754, -94.4911117553711, -1.64918101400114, 218, 29, 'PPL', 'P'),
(65397, 'Harrelsonville Crossroads', 34.2544403076172, 0.597852766795779, -78.7094421386719, -1.37373891772779, 218, 33, 'PPL', 'P'),
(87608, 'Harrican (historical)', 35.5083312988281, 0.619737293053505, -85.7041702270508, -1.49581995315173, 218, 50, 'PPL', 'P'),
(72828, 'Harries', 39.7780609130859, 0.694258132992212, -84.1388931274414, -1.46850071405748, 218, 41, 'PPL', 'P'),
(9348, 'Harriet', 35.9933280944824, 0.628202083999295, -92.5202789306641, -1.61478349220363, 218, 4, 'PPL', 'P'),
(109568, 'Harriet', 38.3416709899902, 0.669188399491723, -80.9958267211914, -1.41364385665959, 218, 58, 'PPL', 'P'),
(191586, 'Harriet', 31.5469398498535, 0.550597969308549, -100.318328857422, -1.75088513866045, 218, 51, 'PPL', 'P'),
(149474, 'Harrietstown', 44.3969383239746, 0.77487275155821, -74.1588897705078, -1.2943167961189, 218, 40, 'PPL', 'P'),
(72829, 'Harriett', 39.1208305358887, 0.682787298965995, -83.4888916015625, -1.45715604728791, 218, 41, 'PPL', 'P'),
(131216, 'Harrietta', 44.310001373291, 0.773355415527137, -85.6977767944336, -1.49570836670206, 218, 27, 'PPL', 'P'),
(21747, 'Harrietts Bluff', 30.8711109161377, 0.538802529234966, -81.5858306884766, -1.42394136848855, 218, 13, 'PPL', 'P'),
(21748, 'Harrietts Bluff Village', 30.8555603027344, 0.538531119830373, -81.6319427490234, -1.42474617576997, 218, 13, 'PPL', 'P'),
(72830, 'Harriettsville', 39.6313896179199, 0.6916982359734, -81.3377838134766, -1.41961213382052, 218, 41, 'PPL', 'P'),
(149476, 'Harrigan', 44.8525009155273, 0.782823818729723, -73.9669418334961, -1.29096667262564, 218, 40, 'PPL', 'P'),
(55180, 'Harrill Ford', 37.7269401550293, 0.658459322408121, -92.4641723632813, -1.6138042478708, 218, 29, 'PPL', 'P'),
(87609, 'Harrill Hills', 36.0430603027344, 0.629070074777579, -83.9191665649414, -1.46466576208777, 218, 50, 'PPL', 'P'),
(87610, 'Harriman', 35.9338912963867, 0.627164716175682, -84.5524978637695, -1.47571947850825, 218, 50, 'PPL', 'P'),
(149477, 'Harriman', 41.3083305358887, 0.720966376353371, -74.1449966430664, -1.29407431530165, 218, 40, 'PPL', 'P'),
(87611, 'Harriman Junction', 35.9411087036133, 0.627290683695243, -84.5663909912109, -1.4759619593255, 218, 50, 'PPL', 'P'),
(2991, 'Harriman Park', 33.5663909912109, 0.585844040808394, -86.793327331543, -1.51482933069661, 218, 2, 'PPL', 'P'),
(13897, 'Harrington', 38.9236106872559, 0.679345163257068, -75.5780563354492, -1.31908592531135, 218, 10, 'PPL', 'P'),
(21749, 'Harrington', 31.2063903808594, 0.544654259808683, -81.3702774047852, -1.42017925397465, 218, 13, 'PPL', 'P'),
(47900, 'Harrington', 39.5400009155273, 0.690103202217524, -76.9783325195313, -1.34352535516084, 218, 25, 'PPL', 'P'),
(102632, 'Harrington', 37.8438911437988, 0.660500502225612, -79.9755630493164, -1.39583689634689, 218, 53, 'PPL', 'P'),
(127695, 'Harrington', 44.6191711425781, 0.778751445948829, -67.8108291625977, -1.18352223739472, 218, 26, 'PPL', 'P'),
(182034, 'Harrington', 38.9588890075684, 0.679960886101094, -122.016387939453, -2.12958771093416, 218, 6, 'PPL', 'P'),
(202194, 'Harrington', 43.1711082458496, 0.753477980624949, -101.254173278809, -1.76721870510007, 218, 49, 'PPL', 'P'),
(207602, 'Harrington', 47.4811096191406, 0.828701695354355, -118.253326416016, -2.06390989739506, 218, 56, 'PPL', 'P'),
(127696, 'Harrington Corner', 44.0733299255371, 0.76922471951837, -69.4952774047852, -1.21292140530032, 218, 26, 'PPL', 'P'),
(47901, 'Harrington Manor', 39.420280456543, 0.688013686026248, -76.5283279418945, -1.33567129363204, 218, 25, 'PPL', 'P'),
(145383, 'Harrington Park', 40.9836082458496, 0.715298903237573, -73.9802780151367, -1.29119943290491, 218, 37, 'PPL', 'P'),
(178334, 'Harrington Place', 32.0424995422363, 0.5592471175808, -110.546112060547, -1.92939363073516, 218, 5, 'PPL', 'P'),
(207603, 'Harrington Place', 46.2313919067383, 0.806890006552442, -122.432777404785, -2.13685507807482, 218, 56, 'PPL', 'P'),
(2992, 'Harris', 34.8872184753418, 0.60889682925731, -85.8594436645508, -1.498529985877, 218, 2, 'PPL', 'P'),
(9350, 'Harris', 36.0311088562012, 0.628861482685199, -94.0475006103516, -1.64143853892201, 218, 4, 'PPL', 'P'),
(16369, 'Harris', 30.413890838623, 0.530822533476112, -86.7363891601563, -1.51383557213585, 218, 12, 'PPL', 'P'),
(32692, 'Harris', 38.3194389343262, 0.668800376920899, -95.4361114501953, -1.66567437010617, 218, 20, 'PPL', 'P'),
(36307, 'Harris', 38.3786087036133, 0.669833084212604, -83.3327789306641, -1.45443136717665, 218, 21, 'PPL', 'P'),
(41273, 'Harris', 31.9122200012207, 0.55697331064209, -93.4147186279297, -1.63039440988145, 218, 22, 'PPL', 'P'),
(65400, 'Harris', 35.2427787780762, 0.615102527229413, -81.8747177124023, -1.42898339822234, 218, 33, 'PPL', 'P'),
(72831, 'Harris', 39.2155609130859, 0.684440655949743, -83.14111328125, -1.4510861705314, 218, 41, 'PPL', 'P'),
(76029, 'Harris', 33.7502784729004, 0.589053482817076, -94.728889465332, -1.65333101792781, 218, 42, 'PPL', 'P'),
(81453, 'Harris', 34.2200012207031, 0.597251691337748, -82.2030563354492, -1.43471398825597, 218, 48, 'PPL', 'P'),
(87612, 'Harris', 36.4466705322266, 0.636114402176948, -88.9497222900391, -1.55246552269577, 218, 50, 'PPL', 'P'),
(94751, 'Harris', 32.8716697692871, 0.573718868102345, -96.1483306884766, -1.67810494081022, 218, 51, 'PPL', 'P'),
(115948, 'Harris', 43.4452781677246, 0.758263148471604, -95.4338912963867, -1.66563562111231, 218, 16, 'PPL', 'P'),
(119937, 'Harris', 40.2324981689453, 0.702189559350686, -88.5924987792969, -1.54623079626779, 218, 18, 'PPL', 'P'),
(122771, 'Harris', 41.4147186279297, 0.722823198844401, -86.3036117553711, -1.50628218149411, 218, 19, 'PPL', 'P'),
(125027, 'Harris', 41.8138885498047, 0.729790028256049, -71.3125, -1.24463792282846, 218, 23, 'PPL', 'P'),
(131217, 'Harris', 45.7036094665527, 0.797678465236994, -87.3452835083008, -1.52446278330775, 218, 27, 'PPL', 'P'),
(135808, 'Harris', 45.5863914489746, 0.795632624887596, -92.9744415283203, -1.62271012487214, 218, 28, 'PPL', 'P'),
(139205, 'Harris', 40.3058280944824, 0.70346940799155, -93.3499984741211, -1.6292648301051, 218, 29, 'PPL', 'P'),
(149478, 'Harris', 41.714168548584, 0.728049585904655, -74.7266693115234, -1.30422641853509, 218, 40, 'PPL', 'P'),
(169412, 'Harris', 41.7244415283203, 0.728228883225044, -71.5330581665039, -1.24848738902611, 218, 47, 'PPL', 'P'),
(178335, 'Harris', 35.1369400024414, 0.613255292118307, -114.083061218262, -1.99112503901292, 218, 5, 'PPL', 'P'),
(193619, 'Harris', 40.084171295166, 0.699600767034047, -123.657501220703, -2.15823054109018, 218, 6, 'PPL', 'P'),
(200950, 'Harris', 44.5783309936523, 0.778038650883069, -123.458892822266, -2.15476417061533, 218, 43, 'PPL', 'P'),
(102633, 'Harris (historical)', 38.0269393920898, 0.663695296848299, -77.7652816772461, -1.35726020900876, 218, 53, 'PPL', 'P'),
(162465, 'Harris Acres', 40.7783317565918, 0.71171615262309, -77.8158264160156, -1.35814238111985, 218, 45, 'PPL', 'P'),
(94752, 'Harris Chapel', 32.3079681396484, 0.563880418666292, -94.4312133789063, -1.64813559011523, 218, 51, 'PPL', 'P'),
(21750, 'Harris City', 32.9680595397949, 0.575401186962948, -84.7127838134766, -1.47851699607532, 218, 13, 'PPL', 'P'),
(30003, 'Harris City', 39.2813911437988, 0.685589610223031, -85.5272216796875, -1.49273161839362, 218, 19, 'PPL', 'P'),
(119939, 'Harris Corners', 42.3402786254883, 0.73897726822655, -87.9783325195313, -1.53551157288022, 218, 18, 'PPL', 'P'),
(149479, 'Harris Corners', 42.769718170166, 0.746472402219441, -78.4422225952148, -1.36907505686879, 218, 40, 'PPL', 'P'),
(65402, 'Harris Crossroads', 36.4002799987793, 0.635304734626536, -78.4191665649414, -1.36867265322808, 218, 33, 'PPL', 'P'),
(102635, 'Harris Crossroads', 36.6680603027344, 0.639978382602544, -77.6877822875977, -1.35590758949111, 218, 53, 'PPL', 'P'),
(36309, 'Harris Grove', 36.5699996948242, 0.638266902128004, -88.4277801513672, -1.54335591387105, 218, 21, 'PPL', 'P'),
(102636, 'Harris Grove', 37.1941719055176, 0.649160762304055, -76.4822235107422, -1.33486661950867, 218, 53, 'PPL', 'P'),
(27385, 'Harris Grove (historical)', 38.2174987792969, 0.667021185575644, -88.7905578613281, -1.54968757936271, 218, 18, 'PPL', 'P'),
(47904, 'Harris Heights', 39.2011108398438, 0.684188454594513, -76.6211090087891, -1.33729062873286, 218, 25, 'PPL', 'P'),
(47903, 'Harris Hill', 39.7188911437988, 0.693225425700506, -76.6438903808594, -1.33768823868361, 218, 25, 'PPL', 'P'),
(149480, 'Harris Hill', 42.9647216796875, 0.749875855513535, -78.6777801513672, -1.3731863118016, 218, 40, 'PPL', 'P'),
(36308, 'Harris Hill Ford', 36.9472198486328, 0.644850635816844, -88.4508285522461, -1.5437581843537, 218, 21, 'PPL', 'P'),
(149481, 'Harris Hill Manor', 42.0955581665039, 0.734706090470281, -76.9036102294922, -1.34222120517503, 218, 40, 'PPL', 'P'),
(87613, 'Harris Hills', 34.9919395446777, 0.610724556713432, -85.1805572509766, -1.48668118271307, 218, 50, 'PPL', 'P'),
(87615, 'Harris Hollow', 36.2374992370605, 0.63246367437564, -87.3249969482422, -1.52410871604083, 218, 50, 'PPL', 'P'),
(41274, 'Harris Landing', 32.1105613708496, 0.56043502058503, -91.5872192382813, -1.5984985284539, 218, 22, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(195057, 'Harris Landing', 47.7849998474121, 0.834005580402329, -116.701667785645, -2.0368283454281, 218, 17, 'PPL', 'P'),
(87616, 'Harris Mill', 36.0086097717285, 0.628468799582466, -82.5397186279297, -1.44058985372707, 218, 50, 'PPL', 'P'),
(186819, 'Harris Park', 39.5116691589355, 0.689608719782124, -105.490562438965, -1.8411576443406, 218, 7, 'PPL', 'P'),
(81454, 'Harris Springs', 34.3316688537598, 0.599200659202496, -82.0266723632813, -1.4316355071939, 218, 48, 'PPL', 'P'),
(2993, 'Harris Station', 34.6586112976074, 0.604906881312154, -86.9702835083008, -1.51791779861277, 218, 2, 'PPL', 'P'),
(81455, 'Harris Town', 33.3794403076172, 0.582581135840829, -79.9033279418945, -1.39457615588684, 218, 48, 'PPL', 'P'),
(94754, 'Harris Tract Colonia', 25.9080009460449, 0.45217991911829, -97.4049987792969, -1.70003793659979, 218, 51, 'PPL', 'P'),
(21752, 'Harris Woods', 34.0299987792969, 0.593935523148382, -84.6833267211914, -1.47800287282688, 218, 13, 'PPL', 'P'),
(2995, 'Harrisburg', 33.5922203063965, 0.586294847401917, -86.289436340332, -1.50603477382884, 218, 2, 'PPL', 'P'),
(9352, 'Harrisburg', 35.5641708374023, 0.62071187685442, -90.716667175293, -1.58330452864473, 218, 4, 'PPL', 'P'),
(16370, 'Harrisburg', 26.9288902282715, 0.469997798391465, -81.3172225952148, -1.41925327286363, 218, 12, 'PPL', 'P'),
(21754, 'Harrisburg', 34.5911102294922, 0.60372876542493, -85.3897171020508, -1.4903317107773, 218, 13, 'PPL', 'P'),
(27386, 'Harrisburg', 37.7383308410645, 0.658658127383496, -88.5405578613281, -1.54532425623272, 218, 18, 'PPL', 'P'),
(30004, 'Harrisburg', 39.6866683959961, 0.692663032657309, -85.1800003051758, -1.48667146217509, 218, 19, 'PPL', 'P'),
(55182, 'Harrisburg', 39.1416702270508, 0.683151020191873, -92.4625015258789, -1.61377508625687, 218, 29, 'PPL', 'P'),
(65404, 'Harrisburg', 35.3236083984375, 0.616513270237855, -80.6561126708984, -1.4077147279667, 218, 33, 'PPL', 'P'),
(76032, 'Harrisburg', 34.4347190856934, 0.600999225044681, -97.789436340332, -1.70674763780819, 218, 42, 'PPL', 'P'),
(81456, 'Harrisburg', 33.9538917541504, 0.592607204975677, -81.2255630493164, -1.41765351199682, 218, 48, 'PPL', 'P'),
(87617, 'Harrisburg', 35.8636093139648, 0.625938064177591, -83.48388671875, -1.45706869560415, 218, 50, 'PPL', 'P'),
(94756, 'Harrisburg', 31.0116691589355, 0.541255733362606, -93.8897171020508, -1.63868469719682, 218, 51, 'PPL', 'P'),
(102637, 'Harrisburg', 37.0263900756836, 0.646232416948431, -78.7480621337891, -1.37441296379969, 218, 53, 'PPL', 'P'),
(115949, 'Harrisburg', 40.7705612182617, 0.711580531144577, -91.7769393920898, -1.60180976979525, 218, 16, 'PPL', 'P'),
(131219, 'Harrisburg', 43.1919403076172, 0.753841568692772, -85.873893737793, -1.49878218723223, 218, 27, 'PPL', 'P'),
(149484, 'Harrisburg', 43.4066696166992, 0.757589302136786, -74.0749969482422, -1.29285259015158, 218, 40, 'PPL', 'P'),
(155632, 'Harrisburg', 40.8933296203613, 0.713723243978628, -81.2275009155273, -1.41768733414266, 218, 41, 'PPL', 'P'),
(162468, 'Harrisburg', 40.0555610656738, 0.699101424329657, -75.0255584716797, -1.30944301847834, 218, 45, 'PPL', 'P'),
(170466, 'Harrisburg', 43.4313888549805, 0.758020734233379, -96.6969375610352, -1.68767993703544, 218, 49, 'PPL', 'P'),
(182035, 'Harrisburg', 36.3638916015625, 0.63466963728558, -117.110557556152, -2.04396481820118, 218, 6, 'PPL', 'P'),
(188665, 'Harrisburg', 35.0480613708496, 0.611704067362363, -107.501937866211, -1.87626276803975, 218, 38, 'PPL', 'P'),
(192610, 'Harrisburg', 37.2058296203613, 0.649364227811337, -113.393608093262, -1.97909181194351, 218, 52, 'PPL', 'P'),
(195058, 'Harrisburg', 46.2969398498535, 0.808034033977713, -116.024719238281, -2.02501336441002, 218, 17, 'PPL', 'P'),
(199377, 'Harrisburg', 41.5563888549805, 0.725295810758486, -103.738059997559, -1.81057070658882, 218, 35, 'PPL', 'P'),
(200951, 'Harrisburg', 44.274169921875, 0.772730038724159, -123.169441223145, -2.1497122871855, 218, 43, 'PPL', 'P'),
(47905, 'Harrisburg (historical)', 39.2155609130859, 0.684440655949743, -76.0924987792969, -1.3280646397685, 218, 25, 'PPL', 'P'),
(140192, 'Harrisburg (historical)', 47.8813896179199, 0.835687899262932, -98.2958297729492, -1.71558587051783, 218, 34, 'PPL', 'P'),
(192611, 'Harrisburg Junction', 37.1619415283203, 0.648598236102803, -113.43083190918, -1.97974149009143, 218, 52, 'PPL', 'P'),
(169413, 'Harrisdale', 41.8494415283203, 0.730410544790037, -71.6025009155273, -1.24969939363821, 218, 47, 'PPL', 'P'),
(9353, 'Harrison', 36.2297210693359, 0.632327919739073, -93.1074981689453, -1.62503240134269, 218, 4, 'PPL', 'P'),
(16371, 'Harrison', 28.975830078125, 0.505723638361687, -82.4069366455078, -1.43827237094648, 218, 12, 'PPL', 'P'),
(21756, 'Harrison', 32.8261108398438, 0.572923714779874, -82.7252807617188, -1.44382852392872, 218, 13, 'PPL', 'P'),
(30005, 'Harrison', 39.5286102294922, 0.68990439724215, -87.4222183227539, -1.52580554912937, 218, 19, 'PPL', 'P'),
(72834, 'Harrison', 39.2619400024414, 0.685250123763073, -84.8199996948242, -1.48038826621527, 218, 41, 'PPL', 'P'),
(76033, 'Harrison', 35.4199981689453, 0.618195589098458, -94.8672180175781, -1.65574530661403, 218, 42, 'PPL', 'P'),
(87618, 'Harrison', 35.1136093139648, 0.612848094787634, -85.1380615234375, -1.48593949234948, 218, 50, 'PPL', 'P'),
(94757, 'Harrison', 31.5224990844727, 0.550171397480946, -96.9986114501953, -1.69294513966858, 218, 51, 'PPL', 'P'),
(109571, 'Harrison', 39.3772201538086, 0.687262141966628, -79.2038879394531, -1.38236862492408, 218, 58, 'PPL', 'P'),
(113311, 'Harrison', 41.9161109924316, 0.73157414644932, -77.7050018310547, -1.35620812722013, 218, 45, 'PPL', 'P'),
(115951, 'Harrison', 41.2872200012207, 0.720597928016559, -94.1849975585938, -1.64383831338028, 218, 16, 'PPL', 'P'),
(119941, 'Harrison', 42.4272193908691, 0.74049467083665, -89.1913909912109, -1.55668343723024, 218, 18, 'PPL', 'P'),
(127698, 'Harrison', 44.110279083252, 0.769869603976333, -70.6797180175781, -1.2335937937879, 218, 26, 'PPL', 'P'),
(131220, 'Harrison', 44.0191688537598, 0.768279430489446, -84.7994384765625, -1.48002940525838, 218, 27, 'PPL', 'P'),
(145386, 'Harrison', 40.7463912963867, 0.711158686427909, -74.1566696166992, -1.29427804712504, 218, 37, 'PPL', 'P'),
(149485, 'Harrison', 40.9688911437988, 0.715042041350435, -73.7130584716797, -1.28653557204591, 218, 40, 'PPL', 'P'),
(170468, 'Harrison', 43.4297218322754, 0.75799163919847, -98.5269393920898, -1.71961949430487, 218, 49, 'PPL', 'P'),
(174425, 'Harrison', 45.4775009155273, 0.793732126554688, -89.5066680908203, -1.56218606067456, 218, 57, 'PPL', 'P'),
(195059, 'Harrison', 47.4544410705566, 0.828236241374836, -116.784439086914, -2.03827297716141, 218, 17, 'PPL', 'P'),
(196671, 'Harrison', 45.7008285522461, 0.797629929126128, -111.78556060791, -1.95102608879571, 218, 31, 'PPL', 'P'),
(199378, 'Harrison', 42.6872215270996, 0.74503256417609, -103.882217407227, -1.81308672802867, 218, 35, 'PPL', 'P'),
(65405, 'Harrison (historical)', 35.0352783203125, 0.611480961042042, -80.8502807617188, -1.41110360045382, 218, 33, 'PPL', 'P'),
(131221, 'Harrison Beach', 45.9805603027344, 0.802512169194516, -86.3013916015625, -1.50624343250025, 218, 27, 'PPL', 'P'),
(87620, 'Harrison Bluff', 35.1477813720703, 0.613444509713757, -85.1580581665039, -1.48628849961034, 218, 50, 'PPL', 'P'),
(162470, 'Harrison City', 40.3541717529297, 0.704313164003915, -79.6486129760742, -1.39013054107917, 218, 45, 'PPL', 'P'),
(72835, 'Harrison Furnace', 38.829719543457, 0.677706453659315, -82.8824996948242, -1.44657251195788, 218, 41, 'PPL', 'P'),
(30007, 'Harrison Grange', 38.2152786254883, 0.666982436581783, -86.1022186279297, -1.50276720832937, 218, 19, 'PPL', 'P'),
(149487, 'Harrison Grove', 43.2805595397949, 0.755388266074863, -78.9663925170898, -1.37822354784543, 218, 40, 'PPL', 'P'),
(87622, 'Harrison Hills', 36.1627807617188, 0.631159590968855, -82.7958297729492, -1.44505983645871, 218, 50, 'PPL', 'P'),
(122774, 'Harrison Lake', 40.1669387817383, 0.701045332188333, -87.2377777099609, -1.52258645316174, 218, 19, 'PPL', 'P'),
(196672, 'Harrison Mill', 45.7188911437988, 0.797945180820166, -111.758056640625, -1.95054605400922, 218, 31, 'PPL', 'P'),
(55183, 'Harrison Mills', 38.0802803039551, 0.664626271386363, -91.1463928222656, -1.59080465606466, 218, 29, 'PPL', 'P'),
(72836, 'Harrison Mills', 38.8319396972656, 0.677745202653175, -82.8080596923828, -1.44527328882008, 218, 41, 'PPL', 'P'),
(182036, 'Harrison Park', 33.0261116027832, 0.576414386599669, -116.568328857422, -2.03450114210953, 218, 6, 'PPL', 'P'),
(30008, 'Harrison Place (historical)', 39.8402786254883, 0.695344036926691, -86.1208267211914, -1.5030919808243, 218, 19, 'PPL', 'P'),
(87623, 'Harrison Point', 35.1233291625977, 0.613017738149072, -85.1405563354492, -1.48598303503331, 218, 50, 'PPL', 'P'),
(94759, 'Harrison Town', 31.4011096954346, 0.548052752965247, -95.2227783203125, -1.66195100458613, 218, 51, 'PPL', 'P'),
(162471, 'Harrison Valley', 41.9419403076172, 0.732024953042843, -77.6497192382813, -1.35524326395719, 218, 45, 'PPL', 'P'),
(41275, 'Harrisonburg', 31.7719402313232, 0.554524966783439, -91.8213882446289, -1.60258554862079, 218, 22, 'PPL', 'P'),
(102640, 'Harrisonburg', 38.4494400024414, 0.671069323590619, -78.8691711425781, -1.37652671475689, 218, 53, 'PPL', 'P'),
(113530, 'Harrisons', 41.3866691589355, 0.722333643257018, -72.100830078125, -1.25839687828424, 218, 8, 'PPL', 'P'),
(65407, 'Harrisons Crossroads', 36.420280456543, 0.635653808466418, -79.6900024414063, -1.39085292352486, 218, 33, 'PPL', 'P'),
(21758, 'Harrisons Mill', 31.548059463501, 0.550617510253048, -84.8858337402344, -1.48153728706758, 218, 13, 'PPL', 'P'),
(21759, 'Harrisonville', 33.1758308410645, 0.579027480261254, -84.9886093139648, -1.48333105921981, 218, 13, 'PPL', 'P'),
(36311, 'Harrisonville', 38.0883293151855, 0.664766753133865, -85.0672225952148, -1.48470311981341, 218, 21, 'PPL', 'P'),
(47906, 'Harrisonville', 39.3858299255371, 0.687412410831136, -76.833610534668, -1.34099948002496, 218, 25, 'PPL', 'P'),
(55187, 'Harrisonville', 38.6533317565918, 0.67462790601821, -94.3486099243164, -1.64669388785912, 218, 29, 'PPL', 'P'),
(70938, 'Harrisonville', 39.6016693115234, 0.69117951877208, -75.4972229003906, -1.31767511572388, 218, 37, 'PPL', 'P'),
(72848, 'Harrisonville', 39.1263885498047, 0.682884304608701, -82.1338882446289, -1.43350677733384, 218, 41, 'PPL', 'P'),
(78433, 'Harrisonville', 39.9874992370605, 0.697913521325427, -78.0597229003906, -1.36239917780623, 218, 45, 'PPL', 'P'),
(119944, 'Harrisonville', 41.2872200012207, 0.720597928016559, -88.3047180175781, -1.5412080744519, 218, 18, 'PPL', 'P'),
(155642, 'Harrisport (historical)', 41.1813888549805, 0.718750826063507, -81.0100021362305, -1.41389126432486, 218, 41, 'PPL', 'P'),
(55188, 'Harriston', 38.8344383239746, 0.677788811916025, -92.9480590820313, -1.62224966431966, 218, 29, 'PPL', 'P'),
(60188, 'Harriston', 31.7250003814697, 0.553705711853104, -91.0322189331055, -1.58881194577901, 218, 30, 'PPL', 'P'),
(102642, 'Harriston', 38.2172203063965, 0.667016325306655, -78.8324966430664, -1.37588662398889, 218, 53, 'PPL', 'P'),
(27390, 'Harristown', 39.853889465332, 0.695581590895926, -89.0838928222656, -1.55480724024228, 218, 18, 'PPL', 'P'),
(30024, 'Harristown', 38.5977783203125, 0.67365831564434, -86.024169921875, -1.50140500143179, 218, 19, 'PPL', 'P'),
(47907, 'Harristown', 39.2877807617188, 0.685701130093678, -76.7430572509766, -1.33941902707605, 218, 25, 'PPL', 'P'),
(81458, 'Harristown', 33.3561096191406, 0.582173938510156, -79.8861083984375, -1.39427561815783, 218, 48, 'PPL', 'P'),
(162474, 'Harristown', 40.0066719055176, 0.698248147516396, -76.0841674804688, -1.32791923117298, 218, 45, 'PPL', 'P'),
(2996, 'Harrisville', 34.0494384765625, 0.594274809871258, -86.2347183227539, -1.50507976426194, 218, 2, 'PPL', 'P'),
(47910, 'Harrisville', 38.4775009155273, 0.671559078915085, -76.1891708374023, -1.32975188547712, 218, 25, 'PPL', 'P'),
(60189, 'Harrisville', 31.9722194671631, 0.558020498872223, -90.0777816772461, -1.57215387316056, 218, 30, 'PPL', 'P'),
(65406, 'Harrisville', 35.2088890075684, 0.614511039151307, -79.8227767944336, -1.39317027314739, 218, 33, 'PPL', 'P'),
(70939, 'Harrisville', 39.6613883972168, 0.69222181344371, -74.522216796875, -1.30065804899049, 218, 37, 'PPL', 'P'),
(102643, 'Harrisville', 38.9508285522461, 0.67982020461651, -78.4619369506836, -1.36941913728163, 218, 53, 'PPL', 'P'),
(109573, 'Harrisville', 39.2094383239746, 0.684333796611004, -81.0519409179688, -1.41462323415047, 218, 58, 'PPL', 'P'),
(113531, 'Harrisville', 41.9261093139648, 0.731748650079748, -71.9372177124023, -1.2555413038054, 218, 8, 'PPL', 'P'),
(119945, 'Harrisville', 42.1569404602051, 0.735777413597792, -89.0325012207031, -1.55391028758714, 218, 18, 'PPL', 'P'),
(122784, 'Harrisville', 40.1847190856934, 0.701355657034355, -84.8816680908203, -1.48146458276982, 218, 19, 'PPL', 'P'),
(125028, 'Harrisville', 42.7102813720703, 0.745435034395828, -72.0852813720703, -1.25812550216916, 218, 23, 'PPL', 'P'),
(131224, 'Harrisville', 44.6563911437988, 0.779401057517726, -83.2947235107422, -1.45376717480078, 218, 27, 'PPL', 'P'),
(143938, 'Harrisville', 42.9449996948242, 0.749531641942643, -72.0969390869141, -1.25832896767644, 218, 36, 'PPL', 'P'),
(149490, 'Harrisville', 44.1519393920898, 0.770596713532951, -75.3213882446289, -1.31460622204173, 218, 40, 'PPL', 'P'),
(155643, 'Harrisville', 40.1813888549805, 0.701297533543564, -80.8877792358398, -1.41175807229171, 218, 41, 'PPL', 'P'),
(162475, 'Harrisville', 41.1366691589355, 0.717970320127032, -80.0094375610352, -1.39642811810889, 218, 45, 'PPL', 'P'),
(169414, 'Harrisville', 41.9655609130859, 0.732437210379588, -71.6750030517578, -1.25096479463016, 218, 47, 'PPL', 'P'),
(172103, 'Harrisville', 42.815559387207, 0.747272482389928, -72.7427825927734, -1.26960106330631, 218, 55, 'PPL', 'P'),
(174431, 'Harrisville', 43.8777809143066, 0.765811745423379, -89.4052810668945, -1.56041652328826, 218, 57, 'PPL', 'P'),
(204219, 'Harrisville', 41.2813911437988, 0.720496195262918, -111.987503051758, -1.95455064934037, 218, 52, 'PPL', 'P'),
(47911, 'Harrisville Farmettes', 39.4358291625977, 0.688285062141327, -77.1930618286133, -1.34727308860486, 218, 25, 'PPL', 'P'),
(47912, 'Harrisville Heights', 39.4361114501953, 0.688289988989344, -77.1750030517578, -1.34695790348985, 218, 25, 'PPL', 'P'),
(204220, 'Harrisville Heights', 41.2861099243164, 0.720578553519628, -112.007217407227, -1.95489472975321, 218, 52, 'PPL', 'P'),
(162477, 'Harrity', 40.8400001525879, 0.712792469177645, -75.6680603027344, -1.32065679088033, 218, 45, 'PPL', 'P'),
(21760, 'Harrock Hall', 31.9947204589844, 0.558413215264469, -81.067497253418, -1.4148947434236, 218, 13, 'PPL', 'P'),
(155645, 'Harrod', 40.7063903808594, 0.710460538748145, -83.92138671875, -1.46470451108163, 218, 41, 'PPL', 'P'),
(36312, 'Harrods Creek', 38.3274993896484, 0.668941058405482, -85.6277770996094, -1.49448664155198, 218, 21, 'PPL', 'P'),
(30025, 'Harrodsburg', 39.0133285522461, 0.680911035399007, -86.5449981689453, -1.51049516918056, 218, 19, 'PPL', 'P'),
(36313, 'Harrodsburg', 37.7622184753418, 0.659075045252148, -84.8433303833008, -1.48079546354594, 218, 21, 'PPL', 'P'),
(87624, 'Harrogate', 36.582218170166, 0.638480154752292, -83.6569366455078, -1.46008898659641, 218, 50, 'PPL', 'P'),
(2997, 'Harrogate Springs', 32.5130615234375, 0.567459973487468, -86.2058334350586, -1.50457562786759, 218, 2, 'PPL', 'P'),
(94760, 'Harrold', 34.0805587768555, 0.594817961575579, -99.0319366455078, -1.72843335909054, 218, 51, 'PPL', 'P'),
(170473, 'Harrold', 44.5244407653809, 0.77709808896508, -99.7388916015625, -1.74077205073699, 218, 49, 'PPL', 'P'),
(188666, 'Harroun Crossing', 32.2405586242676, 0.562703900675723, -104.048057556152, -1.81598118465942, 218, 38, 'PPL', 'P'),
(162478, 'Harrow', 40.4911117553711, 0.706703217924206, -75.1747207641602, -1.31204639160194, 218, 45, 'PPL', 'P'),
(149491, 'Harrower', 42.9652786254883, 0.749885576051514, -74.1716690063477, -1.2945398358602, 218, 40, 'PPL', 'P'),
(60190, 'Harrs Place (historical)', 34.1755599975586, 0.596476045670263, -90.5791702270508, -1.58090475418646, 218, 30, 'PPL', 'P'),
(87625, 'Harrtown', 36.5605583190918, 0.638102119035555, -82.3861083984375, -1.43790884945769, 218, 50, 'PPL', 'P'),
(125029, 'Harrubs Corner', 41.9880599975586, 0.73282989348232, -70.8030624389648, -1.23574656005506, 218, 23, 'PPL', 'P'),
(182037, 'Harry Floyd Terrace', 38.1291694641113, 0.665479548199625, -122.236938476563, -2.13343704397376, 218, 6, 'PPL', 'P'),
(186820, 'Harry Parker Place', 39.0522193908691, 0.681589808581841, -107.468612670898, -1.87568113365767, 218, 7, 'PPL', 'P'),
(21761, 'Harry Pooles Mobile Home Park', 33.6383285522461, 0.587099588104312, -84.251106262207, -1.47045920272313, 218, 13, 'PPL', 'P'),
(102645, 'Harryhogan', 38.0069389343262, 0.663346223008417, -76.5444412231445, -1.33595252344315, 218, 53, 'PPL', 'P'),
(9359, 'Harrys', 34.9480590820313, 0.609958698162952, -91.5105590820313, -1.59716055632225, 218, 4, 'PPL', 'P'),
(9360, 'Harrys (historical)', 34.9550018310547, 0.610079871992551, -91.4927825927734, -1.59685029805525, 218, 4, 'PPL', 'P'),
(199382, 'Harrys Mobile Home Incorporated', 41.809440612793, 0.729712397110273, -103.503326416016, -1.80647383272589, 218, 35, 'PPL', 'P'),
(207604, 'Harsha', 46.288890838623, 0.807893552230211, -118.486106872559, -2.06797268279603, 218, 56, 'PPL', 'P'),
(72849, 'Harshasville', 38.9080581665039, 0.679073720562961, -83.5444412231445, -1.45812557108275, 218, 41, 'PPL', 'P'),
(162479, 'Harshaville', 40.5416717529297, 0.707585656351404, -80.4108276367188, -1.40343369651439, 218, 45, 'PPL', 'P'),
(174432, 'Harshaw', 45.6655616760254, 0.797014406019183, -89.6552810668945, -1.56477984641824, 218, 57, 'PPL', 'P'),
(178336, 'Harshaw', 31.4672203063965, 0.549206600797038, -110.706390380859, -1.93219101514418, 218, 5, 'PPL', 'P'),
(47915, 'Harshman Estates', 39.4980583190918, 0.689371165812889, -77.5494384765625, -1.35349303448879, 218, 25, 'PPL', 'P'),
(9362, 'Hart', 35.2986106872559, 0.616076977872273, -92.0516662597656, -1.60660465817988, 218, 4, 'PPL', 'P'),
(55190, 'Hart', 36.7372207641602, 0.641185460366622, -94.6055603027344, -1.65117851797676, 218, 29, 'PPL', 'P'),
(76045, 'Hart', 34.714168548584, 0.605876538265052, -96.9169387817383, -1.69151968269512, 218, 42, 'PPL', 'P'),
(115961, 'Hart', 42.2638893127441, 0.737644023205829, -94.9941711425781, -1.65796105664097, 218, 16, 'PPL', 'P'),
(131227, 'Hart', 43.6983299255371, 0.762679734823391, -86.3638916015625, -1.50733426328274, 218, 27, 'PPL', 'P'),
(135812, 'Hart', 43.875560760498, 0.765772996429518, -91.7397232055664, -1.60116022480538, 218, 28, 'PPL', 'P'),
(182038, 'Hart', 35.288890838623, 0.615907334510835, -115.102500915527, -2.00891761825574, 218, 6, 'PPL', 'P'),
(191587, 'Hart', 34.3849983215332, 0.600131434003478, -102.115280151367, -1.78224785523777, 218, 51, 'PPL', 'P'),
(195060, 'Hart', 43.8841705322266, 0.765923265294026, -111.738327026367, -1.95020170728027, 218, 17, 'PPL', 'P'),
(9361, 'Hart (historical)', 36.3172187805176, 0.633855042887152, -94.2069396972656, -1.64422127594504, 218, 4, 'PPL', 'P'),
(87626, 'Hart (historical)', 35.711109161377, 0.623276434405139, -85.2194366455078, -1.48735975615882, 218, 50, 'PPL', 'P'),
(193620, 'Hart (historical)', 40.6647186279297, 0.709733229454444, -122.439720153809, -2.13697625190442, 218, 6, 'PPL', 'P'),
(191588, 'Hart Camp', 34.0261993408203, 0.593869210437239, -102.153358459473, -1.7829124470878, 218, 51, 'PPL', 'P'),
(102644, 'Hart Corner', 37.8494415283203, 0.660597374710264, -77.4222183227539, -1.35127262392994, 218, 53, 'PPL', 'P'),
(16372, 'Hart Haven', 30.3252792358398, 0.529275969252075, -81.7647171020508, -1.4270635253925, 218, 12, 'PPL', 'P'),
(21764, 'Hart Town', 33.7408294677734, 0.588888566566573, -84.9611129760742, -1.48285115759137, 218, 13, 'PPL', 'P'),
(94761, 'Hartburg', 30.2574996948242, 0.528092993095862, -93.7644424438477, -1.63649824194186, 218, 51, 'PPL', 'P'),
(109574, 'Harter', 38.2808303833008, 0.668126530586082, -80.0127792358398, -1.39648644133676, 218, 58, 'PPL', 'P'),
(207605, 'Harter', 48.6322212219238, 0.848792382880831, -118.119171142578, -2.06156844616466, 218, 56, 'PPL', 'P'),
(94762, 'Hartex', 33.8205604553223, 0.590280134815166, -98.6769409179688, -1.72223751481447, 218, 51, 'PPL', 'P'),
(102646, 'Hartfield', 37.5511093139648, 0.655390495304996, -76.4463882446289, -1.33424117612666, 218, 53, 'PPL', 'P'),
(149492, 'Hartfield', 42.267219543457, 0.73770214669662, -79.4725036621094, -1.38705685370706, 218, 40, 'PPL', 'P'),
(21765, 'Hartfield Acres', 33.8699989318848, 0.591142999008352, -84.8494415283203, -1.4809021231476, 218, 13, 'PPL', 'P'),
(21766, 'Hartfield Estates', 33.8683280944824, 0.591113837394415, -84.8422164916992, -1.48077602246998, 218, 13, 'PPL', 'P'),
(2998, 'Hartford', 31.1022205352783, 0.542836153022, -85.6969375610352, -1.49569371931606, 218, 2, 'PPL', 'P'),
(9363, 'Hartford', 35.0227813720703, 0.611262848148764, -94.3811111450195, -1.64726114117131, 218, 4, 'PPL', 'P'),
(21767, 'Hartford', 32.2855606079102, 0.563489333460214, -83.4491729736328, -1.45646282645616, 218, 13, 'PPL', 'P'),
(27394, 'Hartford', 37.8047218322754, 0.659816868773789, -88.6655578613281, -1.54750591779772, 218, 18, 'PPL', 'P'),
(30027, 'Hartford', 38.9930610656738, 0.680557301027217, -84.9569396972656, -1.48277832013556, 218, 19, 'PPL', 'P'),
(32700, 'Hartford', 38.3083305358887, 0.668606498793541, -95.9555587768555, -1.67474043624707, 218, 20, 'PPL', 'P'),
(36315, 'Hartford', 37.4511108398438, 0.653645192684612, -86.9091720581055, -1.5168512025962, 218, 21, 'PPL', 'P'),
(70940, 'Hartford', 39.9761085510254, 0.697714716350053, -74.8944396972656, -1.30715456415363, 218, 37, 'PPL', 'P'),
(87627, 'Hartford', 35.8166694641113, 0.625118809247256, -83.1433334350586, -1.45112491952526, 218, 50, 'PPL', 'P'),
(113532, 'Hartford', 41.7636108398438, 0.728912516676868, -72.6855621337891, -1.26860237789753, 218, 8, 'PPL', 'P'),
(115964, 'Hartford', 41.4594383239746, 0.723603704780876, -93.4047164916992, -1.630219839672, 218, 16, 'PPL', 'P'),
(127700, 'Hartford', 44.3727798461914, 0.774451106578623, -70.3472213745117, -1.22779063261456, 218, 26, 'PPL', 'P'),
(131236, 'Hartford', 42.2066688537598, 0.736645337797049, -86.1666717529297, -1.50389212757382, 218, 27, 'PPL', 'P'),
(139210, 'Hartford', 40.4697189331055, 0.706329842739377, -92.835563659668, -1.620286248806, 218, 29, 'PPL', 'P'),
(149493, 'Hartford', 43.3636093139648, 0.756837758077166, -73.394172668457, -1.28096996484181, 218, 40, 'PPL', 'P'),
(155648, 'Hartford', 41.3113899230957, 0.721019772733227, -80.5686111450195, -1.40618753823959, 218, 41, 'PPL', 'P'),
(170477, 'Hartford', 43.6230583190918, 0.761365997457655, -96.9422225952148, -1.69196096848774, 218, 49, 'PPL', 'P'),
(172109, 'Hartford', 43.6605606079102, 0.762020535874569, -72.3388900756836, -1.26255180905893, 218, 55, 'PPL', 'P'),
(174433, 'Hartford', 43.3177795410156, 0.756037877643761, -88.3788909912109, -1.54250263705779, 218, 57, 'PPL', 'P'),
(207606, 'Hartford', 48.0222206115723, 0.838145863791021, -122.054168701172, -2.13024710962006, 218, 56, 'PPL', 'P'),
(155649, 'Hartford (historical)', 40.7361106872559, 0.710979255949465, -84.3147201538086, -1.47156947458158, 218, 41, 'PPL', 'P'),
(170479, 'Hartford Beach', 45.4055595397949, 0.792476512679743, -96.6808319091797, -1.68739884038238, 218, 49, 'PPL', 'P'),
(109575, 'Hartford City', 39.0038909912109, 0.680746318885586, -81.9891662597656, -1.43098090219795, 218, 58, 'PPL', 'P'),
(122785, 'Hartford City', 40.4511108398438, 0.706005070244442, -85.370002746582, -1.48998763036446, 218, 19, 'PPL', 'P'),
(115962, 'Hartford Mobile Home Park', 41.4594383239746, 0.723603704780876, -93.4047164916992, -1.630219839672, 218, 16, 'PPL', 'P'),
(199383, 'Hartgraves Place', 42.3199996948242, 0.738623334117678, -100.267776489258, -1.75000283339131, 218, 35, 'PPL', 'P'),
(125030, 'Harthaven', 41.4430618286133, 0.723317881016884, -70.5569381713867, -1.23145088121677, 218, 23, 'PPL', 'P'),
(47916, 'Harting Estates', 39.0622215270996, 0.681764378791296, -76.5163879394531, -1.33546290127674, 218, 25, 'PPL', 'P'),
(142007, 'Hartington', 42.622501373291, 0.743902984399733, -97.2641677856445, -1.6975799720717, 218, 35, 'PPL', 'P'),
(65408, 'Hartington and Williams', 35.600830078125, 0.621351701306311, -77.3444366455078, -1.34991507756427, 218, 33, 'PPL', 'P'),
(165, 'Hartland', 38.4319381713867, 0.670763859013587, -81.1127777099609, -1.41568503647708, 218, 58, 'PPL', 'P'),
(65409, 'Hartland', 35.8530616760254, 0.62575397316724, -81.6463928222656, -1.4249983771252, 218, 33, 'PPL', 'P'),
(94763, 'Hartland', 26.8244400024414, 0.468174798046278, -98.147216796875, -1.71299208477415, 218, 51, 'PPL', 'P'),
(113535, 'Hartland', 41.9961090087891, 0.732970375229821, -72.9800033569336, -1.27374134669501, 218, 8, 'PPL', 'P'),
(119946, 'Hartland', 42.3636093139648, 0.739384465557223, -88.5072174072266, -1.54474235553454, 218, 18, 'PPL', 'P'),
(127702, 'Hartland', 44.8833312988281, 0.783361910427974, -69.4480590820313, -1.212097290101, 218, 26, 'PPL', 'P'),
(131232, 'Hartland', 42.6566696166992, 0.744499332746829, -83.753059387207, -1.46176664492511, 218, 27, 'PPL', 'P'),
(135816, 'Hartland', 43.8038902282715, 0.764522109665508, -93.4866714477539, -1.63165022349348, 218, 28, 'PPL', 'P'),
(149495, 'Hartland', 43.2400016784668, 0.75468039785712, -78.5763931274414, -1.3714167744153, 218, 40, 'PPL', 'P'),
(155652, 'Hartland', 41.1752815246582, 0.718644233040876, -82.4908294677734, -1.43973657691381, 218, 41, 'PPL', 'P'),
(172105, 'Hartland', 43.5405616760254, 0.759926159414304, -72.3994369506836, -1.26360855137947, 218, 55, 'PPL', 'P'),
(174436, 'Hartland', 43.1049995422363, 0.752324166082673, -88.3419418334961, -1.54185775259982, 218, 57, 'PPL', 'P'),
(182039, 'Hartland', 36.6544418334961, 0.639740695475254, -118.956672668457, -2.07618560528172, 218, 6, 'PPL', 'P'),
(187707, 'Hartland', 37.8872184753418, 0.66125670681714, -101.371673583984, -1.76926947229749, 218, 20, 'PPL', 'P'),
(198400, 'Hartland', 48.3994407653809, 0.84472959747986, -101.819999694824, -1.7770942390543, 218, 34, 'PPL', 'P'),
(87629, 'Hartland Estates', 35.9694404602051, 0.627785166130643, -84.3838882446289, -1.47277668550371, 218, 50, 'PPL', 'P'),
(172106, 'Hartland Four Corners', 43.5463905334473, 0.760027892167945, -72.4250030517578, -1.26405476402012, 218, 55, 'PPL', 'P'),
(47917, 'Hartland Run', 39.2997207641602, 0.685909522448977, -76.4433288574219, -1.33418777974681, 218, 25, 'PPL', 'P'),
(155653, 'Hartland Station', 41.2105598449707, 0.719259955884903, -82.4916687011719, -1.4397512242998, 218, 41, 'PPL', 'P'),
(47918, 'Hartland Village', 39.3030586242676, 0.685967779097822, -76.4480590820313, -1.3342703377406, 218, 25, 'PPL', 'P'),
(55193, 'Hartle Ford', 37.4330596923828, 0.653330140727656, -89.8530578613281, -1.56823170266515, 218, 29, 'PPL', 'P'),
(162480, 'Hartleton', 40.9005584716797, 0.71384941123527, -77.1563873291016, -1.34663299783686, 218, 45, 'PPL', 'P'),
(9365, 'Hartley', 34.3683280944824, 0.599840483654387, -94.1705627441406, -1.64358637834116, 218, 4, 'PPL', 'P'),
(21768, 'Hartley', 32.5794410705566, 0.56861851514068, -83.9147186279297, -1.46458813094199, 218, 13, 'PPL', 'P'),
(36316, 'Hartley', 37.3108291625977, 0.651196815536448, -82.633056640625, -1.44221890936587, 218, 21, 'PPL', 'P'),
(109576, 'Hartley', 39.1394386291504, 0.68311207146093, -81.1183319091797, -1.41578197554076, 218, 58, 'PPL', 'P'),
(115966, 'Hartley', 43.1800003051758, 0.753633176337474, -95.4766693115234, -1.66638223832391, 218, 16, 'PPL', 'P'),
(131234, 'Hartley', 46.3911094665527, 0.809677603844455, -89.8158264160156, -1.56758189135917, 218, 27, 'PPL', 'P'),
(162482, 'Hartley', 40.0213890075684, 0.698505009403534, -78.4527816772461, -1.36925934761622, 218, 45, 'PPL', 'P'),
(182040, 'Hartley', 38.4172210693359, 0.670506997126449, -121.945831298828, -2.1283562652461, 218, 6, 'PPL', 'P'),
(191589, 'Hartley', 35.8855590820313, 0.626321159900399, -102.396392822266, -1.78715419691402, 218, 51, 'PPL', 'P'),
(202196, 'Hartley', 44.4011116027832, 0.774945589014024, -101.809997558594, -1.77691966884485, 218, 49, 'PPL', 'P'),
(47919, 'Hartley (historical)', 39.4486083984375, 0.688508101882621, -76.4730606079102, -1.33470669668521, 218, 25, 'PPL', 'P'),
(47920, 'Hartley Hall Estates', 39.086109161377, 0.682181296659948, -77.2983322143555, -1.3491104034409, 218, 25, 'PPL', 'P'),
(135819, 'Hartley Spur', 46.996940612793, 0.820251352057479, -93.0250015258789, -1.62359256329934, 218, 28, 'PPL', 'P'),
(30028, 'Hartleyville', 38.7961082458496, 0.677119825850197, -86.5350036621094, -1.51032073212916, 218, 19, 'PPL', 'P'),
(72850, 'Hartleyville', 39.5438919067383, 0.690171112825322, -82.1033325195313, -1.43297347932555, 218, 41, 'PPL', 'P'),
(207607, 'Hartline', 47.690559387207, 0.832357283424652, -119.107223510742, -2.07881321317125, 218, 56, 'PPL', 'P'),
(13898, 'Hartly', 39.1686096191406, 0.683621201282326, -75.7136077880859, -1.32145174446572, 218, 10, 'PPL', 'P'),
(9366, 'Hartman', 35.4324989318848, 0.618413768570763, -93.6152801513672, -1.63389486881825, 218, 4, 'PPL', 'P'),
(47921, 'Hartman', 39.392219543457, 0.687523930701783, -77.3138885498047, -1.34938191271404, 218, 25, 'PPL', 'P'),
(60191, 'Hartman', 31.5136108398438, 0.550016268347449, -90.4366683959961, -1.57841762804443, 218, 30, 'PPL', 'P'),
(65410, 'Hartman', 36.4219398498535, 0.635682770343273, -80.1722183227539, -1.39926917835978, 218, 33, 'PPL', 'P'),
(94764, 'Hartman', 33.3783302307129, 0.582561761343898, -94.168327331543, -1.64354736303119, 218, 51, 'PPL', 'P'),
(131235, 'Hartman', 42.0144386291504, 0.733290287455767, -86.3244400024414, -1.5066457029829, 218, 27, 'PPL', 'P'),
(149497, 'Hartman', 43.2636108398438, 0.755092455456783, -73.7502822875977, -1.28718525019383, 218, 40, 'PPL', 'P'),
(186821, 'Hartman', 38.1202812194824, 0.665324419066127, -102.219436645508, -1.78406572899786, 218, 7, 'PPL', 'P'),
(199384, 'Hartman', 41.8766708374023, 0.730885785886562, -103.984718322754, -1.81487570649093, 218, 35, 'PPL', 'P'),
(87630, 'Hartman Subdivision', 36.1805610656738, 0.631469915814877, -82.8708267211914, -1.44636878013449, 218, 50, 'PPL', 'P'),
(149498, 'Hartmans Corners', 42.7077789306641, 0.745391358553951, -73.9227828979492, -1.29019595380617, 218, 40, 'PPL', 'P'),
(109577, 'Hartmansville', 39.3219413757324, 0.686297345282719, -79.1552810668945, -1.38152027495884, 218, 58, 'PPL', 'P'),
(87631, 'Hartmantown', 36.3658294677734, 0.634703459431424, -82.5691680908203, -1.44110384381745, 218, 50, 'PPL', 'P'),
(186822, 'Hartner', 37.3925018310547, 0.652622272509913, -105.909439086914, -1.84846842100703, 218, 7, 'PPL', 'P'),
(209495, 'Hartrandt', 42.8875007629395, 0.748528096264873, -106.346939086914, -1.8561042364845, 218, 59, 'PPL', 'P'),
(21769, 'Harts', 33.3175010681152, 0.581500092175338, -82.5591735839844, -1.44092940676605, 218, 13, 'PPL', 'P'),
(109578, 'Harts', 38.0311088562012, 0.663768067725085, -82.1294403076172, -1.43342914618806, 218, 58, 'PPL', 'P'),
(65411, 'Harts (historical)', 35.5774993896484, 0.620944503975638, -80.6958312988281, -1.40840794879844, 218, 33, 'PPL', 'P'),
(102647, 'Harts (historical)', 38.1341705322266, 0.665566833304352, -76.9250030517578, -1.34259458035986, 218, 53, 'PPL', 'P'),
(94765, 'Harts Bluff', 33.3972206115723, 0.58289146068685, -94.9558334350586, -1.65729193741709, 218, 51, 'PPL', 'P'),
(145387, 'Harts Corner', 40.3088912963867, 0.703522870950434, -74.8130569458008, -1.30573416718624, 218, 37, 'PPL', 'P'),
(182041, 'Harts Place', 35.5008316040039, 0.619606398685928, -117.947776794434, -2.05857705047023, 218, 6, 'PPL', 'P'),
(65412, 'Harts Store', 36.5166702270508, 0.637336127327022, -80.2938919067383, -1.40139278301301, 218, 33, 'PPL', 'P'),
(65414, 'Hartsboro', 35.9152793884277, 0.626839877101719, -77.6466674804688, -1.35519000073539, 218, 33, 'PPL', 'P'),
(55194, 'Hartsburg', 38.6949996948242, 0.675355148732884, -92.3086090087891, -1.61108915513947, 218, 29, 'PPL', 'P'),
(119948, 'Hartsburg', 40.2508316040039, 0.702509538155659, -89.4408264160156, -1.56103690666419, 218, 18, 'PPL', 'P'),
(155655, 'Hartsburg', 41.0924987792969, 0.717199401570481, -84.3244400024414, -1.47173911794302, 218, 41, 'PPL', 'P'),
(122787, 'Hartsdale', 41.5077781677246, 0.724447394214214, -87.4713897705078, -1.52666375279065, 218, 19, 'PPL', 'P'),
(149499, 'Hartsdale', 41.0188903808594, 0.715914692660627, -73.7986068725586, -1.28802867331106, 218, 40, 'PPL', 'P'),
(65413, 'Hartsease', 35.9319381713867, 0.627130627713729, -77.6416702270508, -1.35510278220969, 218, 33, 'PPL', 'P'),
(186823, 'Hartsel', 39.021671295166, 0.681056643731607, -105.795280456543, -1.84647597703748, 218, 7, 'PPL', 'P'),
(2999, 'Hartselle', 34.4433288574219, 0.601149493909188, -86.9352798461914, -1.51730686945871, 218, 2, 'PPL', 'P'),
(21770, 'Hartsfield', 31.2166690826416, 0.544833656997614, -83.9761123657227, -1.46565965380658, 218, 13, 'PPL', 'P'),
(162484, 'Hartsfield', 41.5758285522461, 0.725635097481362, -77.165283203125, -1.34678826012841, 218, 45, 'PPL', 'P'),
(155656, 'Hartsgrove', 41.6049995422363, 0.726144227302758, -80.95361328125, -1.41290709314402, 218, 41, 'PPL', 'P'),
(87632, 'Hartshaw Subdivision', 36.1852798461914, 0.631552274071587, -82.8958282470703, -1.4468051390791, 218, 50, 'PPL', 'P'),
(55195, 'Hartshorn', 37.264720916748, 0.650392074834053, -91.670280456543, -1.59994822019329, 218, 29, 'PPL', 'P'),
(72851, 'Hartshorn', 39.7066688537598, 0.693012106497191, -81.2191696166992, -1.41754192554714, 218, 41, 'PPL', 'P'),
(119949, 'Hartshorn', 40.1297187805176, 0.700395720619435, -87.7052764892578, -1.53074584610952, 218, 18, 'PPL', 'P'),
(76038, 'Hartshorne', 34.8450012207031, 0.608159999162713, -95.5572204589844, -1.66778812106336, 218, 42, 'PPL', 'P'),
(149508, 'Hartson Point', 42.7724990844727, 0.746520938330308, -77.7130584716797, -1.35634874212568, 218, 40, 'PPL', 'P'),
(207608, 'Hartstene', 47.276668548584, 0.825133525546839, -122.885833740234, -2.14476240282543, 218, 56, 'PPL', 'P'),
(162485, 'Hartstown', 41.5525016784668, 0.725227966729716, -80.3794403076172, -1.40288588427816, 218, 45, 'PPL', 'P'),
(27395, 'Hartsville', 37.535831451416, 0.655123846300851, -88.482780456543, -1.54431585028597, 218, 18, 'PPL', 'P'),
(30031, 'Hartsville', 39.2675018310547, 0.685347195984806, -85.6980590820313, -1.49571329355007, 218, 19, 'PPL', 'P'),
(81461, 'Hartsville', 34.3738899230957, 0.59993755587612, -80.0736083984375, -1.39754811050532, 218, 48, 'PPL', 'P'),
(87633, 'Hartsville', 36.3908309936523, 0.635139818376033, -86.1672210693359, -1.50390171495374, 218, 50, 'PPL', 'P'),
(125032, 'Hartsville', 41.4413909912109, 0.723288719402947, -70.5552825927734, -1.23142198591894, 218, 23, 'PPL', 'P'),
(149500, 'Hartsville', 42.246940612793, 0.737348212587748, -77.6941680908203, -1.35601904278273, 218, 40, 'PPL', 'P'),
(162486, 'Hartsville', 40.228328704834, 0.702116788473899, -75.0952835083008, -1.31065994993845, 218, 45, 'PPL', 'P'),
(87634, 'Hartsville Junction', 36.4494400024414, 0.636162738550733, -86.3266677856445, -1.50668458513482, 218, 50, 'PPL', 'P'),
(55196, 'Hartville', 37.2508316040039, 0.650149660595829, -92.5102767944336, -1.61460892199417, 218, 29, 'PPL', 'P'),
(155658, 'Hartville', 40.9636116027832, 0.714949895976718, -81.3313903808594, -1.41950054737084, 218, 41, 'PPL', 'P'),
(209496, 'Hartville', 42.3274993896484, 0.738754228485256, -104.724716186523, -1.82779110567143, 218, 59, 'PPL', 'P'),
(9368, 'Hartwell', 36.1202812194824, 0.630417834026241, -93.8016662597656, -1.63714792008978, 218, 4, 'PPL', 'P'),
(21771, 'Hartwell', 34.3527793884277, 0.599569107539308, -82.9322204589844, -1.44744030299908, 218, 13, 'PPL', 'P'),
(30029, 'Hartwell', 38.3224983215332, 0.668853773300755, -87.1797180175781, -1.52157312036696, 218, 19, 'PPL', 'P'),
(55197, 'Hartwell', 38.4352798461914, 0.67082218224146, -93.934440612793, -1.63946526971232, 218, 29, 'PPL', 'P'),
(72852, 'Hartwell', 39.2133293151855, 0.684401707218801, -84.4686126708984, -1.47425540569898, 218, 41, 'PPL', 'P'),
(30030, 'Hartwell Junction', 38.3605613708496, 0.669518098834675, -87.1408309936523, -1.52089441376316, 218, 19, 'PPL', 'P'),
(172108, 'Hartwellville', 44.646671295166, 0.779231414156288, -71.8936080932617, -1.25478017236586, 218, 55, 'PPL', 'P'),
(115968, 'Hartwick', 41.7847213745117, 0.72928096501368, -92.3433303833008, -1.61169515744552, 218, 16, 'PPL', 'P'),
(149502, 'Hartwick', 42.6597213745117, 0.744552595968631, -75.0491714477539, -1.30985514265703, 218, 40, 'PPL', 'P'),
(149503, 'Hartwick Seminary', 42.6430587768555, 0.744261778777594, -74.9658279418945, -1.30840052406962, 218, 40, 'PPL', 'P'),
(102648, 'Hartwood', 38.4022216796875, 0.670245208391294, -77.565559387207, -1.35377439745796, 218, 53, 'PPL', 'P'),
(149505, 'Hartwood', 41.5352783203125, 0.724927362421673, -74.6980590820313, -1.3037270758307, 218, 40, 'PPL', 'P'),
(155659, 'Hartwood', 40.2786102294922, 0.702994366632107, -81.4841690063477, -1.42216703741228, 218, 41, 'PPL', 'P'),
(149506, 'Hartwood Club', 41.5041694641113, 0.724384410454433, -74.7247161865234, -1.30419233007314, 218, 40, 'PPL', 'P'),
(109580, 'Hartzel', 39.4436111450195, 0.688420883356921, -80.524169921875, -1.4054118925721, 218, 58, 'PPL', 'P'),
(122788, 'Hartzel', 41.5633316040039, 0.725416984588084, -85.2358322143555, -1.48764591281795, 218, 19, 'PPL', 'P'),
(55198, 'Hartzell', 36.485279083252, 0.636788248511765, -89.855827331543, -1.56828003903894, 218, 29, 'PPL', 'P'),
(162487, 'Hartzell (historical)', 40.5708312988281, 0.708094586435718, -75.6444396972656, -1.32024453354359, 218, 45, 'PPL', 'P'),
(162488, 'Hartzells Ferry', 40.8525009155273, 0.71301064864995, -75.0913925170898, -1.31059203933065, 218, 45, 'PPL', 'P'),
(81460, 'Hartzog Acres', 34.1655616760254, 0.596301542039835, -82.1147232055664, -1.43317228430093, 218, 48, 'PPL', 'P'),
(47922, 'Harundale', 39.1527786254883, 0.68334489831923, -76.6149978637695, -1.3371839691312, 218, 25, 'PPL', 'P'),
(9370, 'Harvard', 35.2338905334473, 0.614947398095916, -90.2072219848633, -1.57441303271328, 218, 4, 'PPL', 'P'),
(16373, 'Harvard', 29.7700004577637, 0.519584526308195, -82.8333282470703, -1.4457143082966, 218, 12, 'PPL', 'P'),
(94766, 'Harvard', 33.0597190856934, 0.577000947829759, -94.9680633544922, -1.65750538977846, 218, 51, 'PPL', 'P'),
(115969, 'Harvard', 40.689998626709, 0.710174448668043, -93.269172668457, -1.62785415367568, 218, 16, 'PPL', 'P'),
(119950, 'Harvard', 42.4222183227539, 0.740407385731922, -88.6136093139648, -1.5465992446046, 218, 18, 'PPL', 'P'),
(125033, 'Harvard', 42.5, 0.74176493209759, -71.5833282470703, -1.24936476744724, 218, 23, 'PPL', 'P'),
(131238, 'Harvard', 43.1944389343262, 0.753885177955622, -85.4166717529297, -1.49080215818386, 218, 27, 'PPL', 'P'),
(142008, 'Harvard', 40.6188888549805, 0.708933349021039, -98.0969390869141, -1.71211457319497, 218, 35, 'PPL', 'P'),
(149507, 'Harvard', 42.0238914489746, 0.733455270285298, -75.1130599975586, -1.31097020820544, 218, 40, 'PPL', 'P'),
(182042, 'Harvard', 34.9511108398438, 0.610011961384754, -116.663887023926, -2.03616894674219, 218, 6, 'PPL', 'P'),
(195061, 'Harvard', 46.9174995422363, 0.818864843814956, -116.728607177734, -2.03729852651855, 218, 17, 'PPL', 'P'),
(119951, 'Harvard Hills', 40.7286109924316, 0.710848361581887, -89.4813919067383, -1.56174490803999, 218, 18, 'PPL', 'P'),
(204238, 'Harvard Park', 40.5972213745117, 0.708555180146247, -111.858329772949, -1.95229615031957, 218, 52, 'PPL', 'P'),
(125034, 'Harvard Station', 42.5222206115723, 0.742152754931333, -71.5999984741211, -1.24965571779633, 218, 23, 'PPL', 'P'),
(27396, 'Harvel', 39.3561096191406, 0.686893693629815, -89.5322189331055, -1.5626320069991, 218, 18, 'PPL', 'P'),
(204222, 'Harvel Park Condo', 40.6083297729492, 0.708749058273605, -111.879997253418, -1.95267431919436, 218, 52, 'PPL', 'P'),
(3000, 'Harvest', 34.8555603027344, 0.608344289910146, -86.7508316040039, -1.51408764033302, 218, 2, 'PPL', 'P'),
(21772, 'Harvest', 34.6266708374023, 0.604349415116973, -83.6072235107422, -1.45922132871326, 218, 13, 'PPL', 'P'),
(47923, 'Harvest Acres', 39.4799995422363, 0.689055980697878, -77.7138900756836, -1.35636325635362, 218, 25, 'PPL', 'P'),
(94767, 'Harvest Acres Colonia', 27.7670001983643, 0.484625576863375, -97.9459991455078, -1.70948017424466, 218, 51, 'PPL', 'P'),
(47924, 'Harvest Farms', 39.3844413757324, 0.687388176065216, -76.9250030517578, -1.34259458035986, 218, 25, 'PPL', 'P'),
(47926, 'Harvest Hills', 39.5361099243164, 0.690035291609727, -76.4394378662109, -1.33411986913901, 218, 25, 'PPL', 'P'),
(162489, 'Harvest Hills', 40.1425018310547, 0.700618826939757, -76.779167175293, -1.34004926414802, 218, 45, 'PPL', 'P'),
(47927, 'Harvest Hunt Farm', 39.0922203063965, 0.682287956261605, -77.2777786254883, -1.34875167564207, 218, 25, 'PPL', 'P'),
(204224, 'Harvest Lane Condo', 40.5897216796875, 0.70842428577867, -111.869171142578, -1.95248536791502, 218, 52, 'PPL', 'P'),
(47928, 'Harvest Ridge', 39.3644409179688, 0.687039102225334, -77.1958312988281, -1.34732142497864, 218, 25, 'PPL', 'P'),
(55199, 'Harvester', 38.7458305358887, 0.676242314271016, -90.5805587768555, -1.58092898895238, 218, 29, 'PPL', 'P'),
(204226, 'Harvestland Estates', 40.6744384765625, 0.709902872815882, -111.949440002441, -1.95388632380645, 218, 52, 'PPL', 'P'),
(204227, 'Harvestland Estates Condo', 40.6744384765625, 0.709902872815882, -111.951393127441, -1.9539204122684, 218, 52, 'PPL', 'P'),
(9372, 'Harvey', 34.8458290100098, 0.608174446811627, -93.7850036621094, -1.63685710289875, 218, 4, 'PPL', 'P'),
(36317, 'Harvey', 36.8083305358887, 0.642426560013626, -88.4177780151367, -1.54318134366159, 218, 21, 'PPL', 'P'),
(41276, 'Harvey', 29.9033298492432, 0.521911563179193, -90.0772171020508, -1.57214401946453, 218, 22, 'PPL', 'P'),
(47929, 'Harvey', 39.7030601501465, 0.69294912273741, -78.2780609130859, -1.36620989501003, 218, 25, 'PPL', 'P'),
(55200, 'Harvey', 38.4458312988281, 0.671006339830839, -93.8666687011719, -1.63828242671416, 218, 29, 'PPL', 'P'),
(60192, 'Harvey', 31.3311100006104, 0.546831027815173, -89.2622222900391, -1.55791967660825, 218, 30, 'PPL', 'P'),
(94768, 'Harvey', 30.6547203063965, 0.535025800624584, -96.2750015258789, -1.68031576398915, 218, 51, 'PPL', 'P'),
(102650, 'Harvey', 37.5977783203125, 0.656205023124396, -79.623893737793, -1.38969910898258, 218, 53, 'PPL', 'P'),
(109581, 'Harvey', 37.9324989318848, 0.662046999870621, -81.1391677856445, -1.41614563018761, 218, 58, 'PPL', 'P'),
(115970, 'Harvey', 41.3158302307129, 0.721097270720948, -92.9238891601563, -1.62182781960299, 218, 16, 'PPL', 'P'),
(119952, 'Harvey', 41.6100006103516, 0.726231512407485, -87.6466674804688, -1.52972292593482, 218, 18, 'PPL', 'P'),
(127704, 'Harvey', 46.3466682434082, 0.80890195817697, -67.9080581665039, -1.18521920364132, 218, 26, 'PPL', 'P'),
(131239, 'Harvey', 46.4947204589844, 0.811485956803647, -87.3541717529297, -1.52461791244125, 218, 27, 'PPL', 'P'),
(140194, 'Harvey', 47.769718170166, 0.833738864819158, -99.9349975585938, -1.74419474536996, 218, 34, 'PPL', 'P'),
(207609, 'Harvey', 46.3916702270508, 0.809687390961461, -118.467781066895, -2.06765283714911, 218, 56, 'PPL', 'P'),
(207610, 'Harvey (historical)', 48.457218170166, 0.845738003426619, -118.191673278809, -2.06283384715661, 218, 56, 'PPL', 'P'),
(70942, 'Harvey Cedars', 39.7061080932617, 0.693002319380185, -74.1344375610352, -1.29389002455422, 218, 37, 'PPL', 'P'),
(172110, 'Harvey Hollow', 44.3833312988281, 0.774635264168002, -72.1438903808594, -1.25914842234386, 218, 55, 'PPL', 'P'),
(195062, 'Harvey Place', 42.5127792358398, 0.741987971838884, -116.077499389648, -2.02593455183107, 218, 17, 'PPL', 'P'),
(102651, 'Harveys', 37.7444381713867, 0.658764720406126, -76.3394393920898, -1.33237456651863, 218, 53, 'PPL', 'P'),
(162492, 'Harveys Lake', 41.3833312988281, 0.722275386608172, -76.0250015258789, -1.3268865904603, 218, 45, 'PPL', 'P'),
(196673, 'Harveys Mobile Home Court', 46.8805618286133, 0.818220159094075, -113.884719848633, -1.98766332906998, 218, 31, 'PPL', 'P'),
(162491, 'Harveys Run', 41.1725006103516, 0.71859569693001, -78.7877807617188, -1.37510618463144, 218, 45, 'PPL', 'P'),
(30032, 'Harveysburg', 39.9822196960449, 0.69782137595171, -87.2947235107422, -1.52358034488055, 218, 19, 'PPL', 'P'),
(72853, 'Harveysburg', 39.5036087036133, 0.689468038297541, -84.0105590820313, -1.46626086242267, 218, 41, 'PPL', 'P'),
(36318, 'Harveyton', 37.3122215270996, 0.651221116881395, -83.2016677856445, -1.45214304601, 218, 21, 'PPL', 'P'),
(65415, 'Harveytown', 35.2752799987793, 0.6156697805416, -77.5652770996094, -1.35376947060994, 218, 33, 'PPL', 'P'),
(81462, 'Harveytown', 34.9555587768555, 0.61008959253053, -82.1444396972656, -1.43369093492322, 218, 48, 'PPL', 'P'),
(94770, 'Harveytown', 31.0766696929932, 0.542390206697466, -94.147216796875, -1.64317891469438, 218, 51, 'PPL', 'P'),
(109583, 'Harveytown', 38.398609161377, 0.670182158052486, -82.4688873291016, -1.43935361434905, 218, 58, 'PPL', 'P'),
(32704, 'Harveyville', 38.7900009155273, 0.677013232827567, -95.9613876342773, -1.67484216900071, 218, 20, 'PPL', 'P'),
(162495, 'Harveyville', 41.2138900756836, 0.719318079375694, -76.2463912963867, -1.3307505708859, 218, 45, 'PPL', 'P'),
(36319, 'Harvieland', 38.2541694641113, 0.667661209764618, -84.9127807617188, -1.48200760131609, 218, 21, 'PPL', 'P'),
(55201, 'Harviell', 36.6647186279297, 0.639920059374671, -90.4722213745117, -1.57903814457842, 218, 29, 'PPL', 'P'),
(81463, 'Harvin', 33.7669410705566, 0.589344300008112, -80.2286071777344, -1.40025334954062, 218, 48, 'PPL', 'P'),
(81464, 'Harvins Crossroads', 33.834171295166, 0.590517688784401, -80.4388885498047, -1.40392345183886, 218, 48, 'PPL', 'P'),
(127705, 'Harwards', 44.0341682434082, 0.768541219224601, -69.8272171020508, -1.21871484593568, 218, 26, 'PPL', 'P'),
(87635, 'Harwell', 35.1180610656738, 0.612925792512437, -87.0058288574219, -1.51853818198871, 218, 50, 'PPL', 'P'),
(125036, 'Harwich', 41.6861114501953, 0.727559897159216, -70.0763931274414, -1.22306378799578, 218, 23, 'PPL', 'P'),
(125037, 'Harwich Port', 41.6666717529297, 0.72722061043634, -70.0791702270508, -1.22311225752762, 218, 23, 'PPL', 'P'),
(162493, 'Harwick', 40.5566711425781, 0.707847445086559, -79.8052825927734, -1.39286494172841, 218, 45, 'PPL', 'P'),
(41278, 'Harwick Place', 32.3811111450195, 0.565157004934822, -93.7213897705078, -1.63574683104029, 218, 22, 'PPL', 'P'),
(113537, 'Harwinton', 41.771110534668, 0.729043411044445, -73.0602798461914, -1.2751424357445, 218, 8, 'PPL', 'P'),
(9373, 'Harwood', 33.1627807617188, 0.578799713409025, -91.128059387207, -1.59048467725969, 218, 4, 'PPL', 'P'),
(30033, 'Harwood', 38.0033302307129, 0.663283239248636, -87.5747222900391, -1.52846724548085, 218, 19, 'PPL', 'P'),
(47930, 'Harwood', 38.8652801513672, 0.678327103351358, -76.6202774047852, -1.33727611450492, 218, 25, 'PPL', 'P'),
(55202, 'Harwood', 37.9561080932617, 0.662459057470284, -94.154167175293, -1.64330022168203, 218, 29, 'PPL', 'P'),
(72854, 'Harwood', 39.1311111450195, 0.682966729444439, -83.8461074829102, -1.46339064055784, 218, 41, 'PPL', 'P'),
(94769, 'Harwood', 29.6655597686768, 0.517761692410577, -97.504997253418, -1.70178323922017, 218, 51, 'PPL', 'P'),
(140197, 'Harwood', 46.9794387817383, 0.819945887480447, -96.8802795410156, -1.69087985824322, 218, 34, 'PPL', 'P'),
(162494, 'Harwood', 40.9438896179199, 0.714605682405826, -76.0197219848633, -1.32679444508658, 218, 45, 'PPL', 'P'),
(207611, 'Harwood', 46.5825004577637, 0.813018006799742, -120.654998779297, -2.10582698768847, 218, 56, 'PPL', 'P'),
(47931, 'Harwood Estates', 38.8752784729004, 0.678501606981785, -76.6005630493164, -1.33693203409208, 218, 25, 'PPL', 'P'),
(3002, 'Harwood Heights', 31.211109161377, 0.544736618065394, -85.4158325195313, -1.49078751079786, 218, 2, 'PPL', 'P'),
(119953, 'Harwood Heights', 41.9672203063965, 0.732466172256442, -87.807502746582, -1.53253003088182, 218, 18, 'PPL', 'P'),
(47932, 'Harwood Park', 39.1936111450195, 0.684057560226936, -76.7380599975586, -1.33933180855035, 218, 25, 'PPL', 'P'),
(102652, 'Harwoods Mill', 37.1380615234375, 0.648181451392206, -76.4505615234375, -1.33431401358248, 218, 53, 'PPL', 'P'),
(60193, 'Harworth', 32.6716690063477, 0.570228196282551, -90.6705627441406, -1.58249985452136, 218, 30, 'PPL', 'P'),
(16374, 'Hasan', 29.8586101531982, 0.521131057242718, -82.4380569458008, -1.4388155226508, 218, 12, 'PPL', 'P'),
(149509, 'Hasbrouck', 41.7911109924316, 0.729392484884327, -74.6149978637695, -1.30227738409131, 218, 40, 'PPL', 'P'),
(145388, 'Hasbrouck Heights', 40.8580589294434, 0.713107654292656, -74.0811080932617, -1.29295924975324, 218, 37, 'PPL', 'P'),
(149510, 'Hasbroucks', 43.8713912963867, 0.765700225552732, -74.6347198486328, -1.30262159766221, 218, 40, 'PPL', 'P'),
(182043, 'Haselbusch (historical)', 39.4474983215332, 0.688488727385691, -121.648612976074, -2.12316882691679, 218, 6, 'PPL', 'P'),
(55203, 'Haseltine', 37.2094383239746, 0.649427211571117, -93.3858337402344, -1.6298902734871, 218, 29, 'PPL', 'P'),
(127706, 'Haseltine Corner', 45.0699996948242, 0.786619888547522, -69.2383270263672, -1.20843677518268, 218, 26, 'PPL', 'P'),
(149511, 'Haselton', 44.4116706848145, 0.775129879761457, -73.769172668457, -1.28751494953679, 218, 40, 'PPL', 'P'),
(155660, 'Haselton', 41.083610534668, 0.717044272436984, -80.6180572509766, -1.40705053559083, 218, 41, 'PPL', 'P'),
(139211, 'Haseville', 40.0263900756836, 0.698592294508261, -93.3211135864258, -1.62876069371074, 218, 29, 'PPL', 'P'),
(21774, 'Hasford Estates', 33.9902801513672, 0.593242302316634, -84.7927780151367, -1.4799131582768, 218, 13, 'PPL', 'P'),
(178338, 'Hashan Chuchg', 31.5672206878662, 0.550951936706935, -111.772216796875, -1.95079319535838, 218, 5, 'PPL', 'P'),
(30034, 'Hashtown', 39.0250015258789, 0.681114767222398, -86.9244384765625, -1.51711765186326, 218, 19, 'PPL', 'P'),
(60194, 'Hashuqua (historical)', 32.9944381713867, 0.575861580936395, -88.8061065673828, -1.54995895547779, 218, 30, 'PPL', 'P'),
(94771, 'Hasima', 29.0280609130859, 0.506635238402821, -95.774169921875, -1.67157460350124, 218, 51, 'PPL', 'P'),
(9374, 'Haskell', 34.5013885498047, 0.602162826703963, -92.6363906860352, -1.61681002463512, 218, 4, 'PPL', 'P'),
(76040, 'Haskell', 35.8202781677246, 0.625181793007036, -95.6738891601563, -1.66982437403284, 218, 42, 'PPL', 'P'),
(94772, 'Haskell', 33.1575012207031, 0.578707568035309, -99.7333297729492, -1.74067497851525, 218, 51, 'PPL', 'P'),
(102653, 'Haskell', 36.6477813720703, 0.639624448493672, -82.192497253418, -1.43452969750854, 218, 53, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(122789, 'Haskell', 41.4838905334473, 0.724030476345562, -86.9019393920898, -1.51672496876053, 218, 19, 'PPL', 'P'),
(145390, 'Haskell', 41.0283317565918, 0.716079475753076, -74.29638671875, -1.29671657057717, 218, 37, 'PPL', 'P'),
(196674, 'Haskell (historical)', 46.6130599975586, 0.813551371387057, -113.043327331543, -1.97297825934512, 218, 31, 'PPL', 'P'),
(127707, 'Haskell Corner', 44.0774993896484, 0.769297490395156, -70.2919387817383, -1.22682576935162, 218, 26, 'PPL', 'P'),
(182044, 'Haskell Creek Homesites', 39.6347198486328, 0.691756359464191, -120.551666259766, -2.10402349499827, 218, 6, 'PPL', 'P'),
(149517, 'Haskell Flats', 42.1508293151855, 0.735670753996134, -78.3236083984375, -1.36700484859542, 218, 40, 'PPL', 'P'),
(81465, 'Haskell Heights', 34.086109161377, 0.594914834060231, -81.0483322143555, -1.41456025039069, 218, 48, 'PPL', 'P'),
(36320, 'Haskingsville', 37.186939239502, 0.649034528468385, -85.3952789306641, -1.49042878299903, 218, 21, 'PPL', 'P'),
(115971, 'Haskins', 41.3280601501465, 0.721310723082318, -91.5366668701172, -1.59761622318476, 218, 16, 'PPL', 'P'),
(155661, 'Haskins', 41.4647216796875, 0.72369591673362, -83.7061080932617, -1.46094719025769, 218, 41, 'PPL', 'P'),
(21775, 'Haskins Crossing', 32.5463905334473, 0.568041674448568, -83.1175003051758, -1.45067404635271, 218, 13, 'PPL', 'P'),
(102654, 'Haskinton (historical)', 36.5661087036133, 0.638198991520207, -78.3263931274414, -1.36705345128531, 218, 53, 'PPL', 'P'),
(149512, 'Haskinville', 42.4230613708496, 0.740422099696945, -77.5661087036133, -1.35378398483788, 218, 40, 'PPL', 'P'),
(94774, 'Haslam', 31.9672203063965, 0.557933247057009, -94.0269393920898, -1.64107967796512, 218, 51, 'PPL', 'P'),
(94775, 'Haslet', 32.9747200012207, 0.57551743394453, -97.3475036621094, -1.69903445750105, 218, 51, 'PPL', 'P'),
(162496, 'Haslets Corner', 41.4958305358887, 0.72423886870086, -79.8247222900391, -1.39320422845129, 218, 45, 'PPL', 'P'),
(131240, 'Haslett', 42.746940612793, 0.74607485884772, -84.4011077880859, -1.47307722323273, 218, 27, 'PPL', 'P'),
(65416, 'Haslin Corner', 35.560001373291, 0.620639105977633, -76.5774993896484, -1.33652949729331, 218, 33, 'PPL', 'P'),
(155662, 'Hassan (historical)', 40.8455581665039, 0.712889474820351, -83.76611328125, -1.46199447835636, 218, 41, 'PPL', 'P'),
(55205, 'Hassard', 39.6569404602051, 0.692144182297934, -91.6594390869141, -1.59975900259784, 218, 29, 'PPL', 'P'),
(178337, 'Hassayampa', 33.348331451416, 0.582038183873589, -112.724716186523, -1.96741744583098, 218, 5, 'PPL', 'P'),
(94776, 'Hasse', 31.9363899230957, 0.557395155358759, -98.4883270263672, -1.71894558139102, 218, 51, 'PPL', 'P'),
(196675, 'Hassel', 46.3052787780762, 0.808179575731286, -111.664436340332, -1.9489120715224, 218, 31, 'PPL', 'P'),
(65417, 'Hassell', 35.9077796936035, 0.626708982734142, -77.2788925170898, -1.34877111671803, 218, 33, 'PPL', 'P'),
(188667, 'Hassell', 34.7066688537598, 0.605745643897474, -104.023063659668, -1.81554495887287, 218, 38, 'PPL', 'P'),
(47933, 'Hassengers Corner', 39.2658309936523, 0.68531803437087, -76.0475006103516, -1.32727927356303, 218, 25, 'PPL', 'P'),
(182045, 'Hasset (historical)', 36.4013900756836, 0.635324109123467, -119.731109619141, -2.08970207992026, 218, 6, 'PPL', 'P'),
(162497, 'Hassler Meadows', 40.276668548584, 0.702960477907236, -76.8216705322266, -1.34079108766966, 218, 45, 'PPL', 'P'),
(21776, 'Hassler Mill', 34.8019409179688, 0.607408455103092, -85.0180587768555, -1.48384504931019, 218, 13, 'PPL', 'P'),
(21777, 'Hasslers Mill', 34.8122215270996, 0.607587885581537, -84.6952819824219, -1.47821153149829, 218, 13, 'PPL', 'P'),
(135823, 'Hassman', 46.6019401550293, 0.813357293522618, -93.6127777099609, -1.63385119297638, 218, 28, 'PPL', 'P'),
(162500, 'Hasson Heights', 41.4488906860352, 0.723419613770525, -79.6772232055664, -1.39062988378356, 218, 45, 'PPL', 'P'),
(113539, 'Hassunadchuauck (historical)', 41.7397193908691, 0.728495532229189, -72.5622177124023, -1.26644961163037, 218, 8, 'PPL', 'P'),
(55204, 'Hastain', 38.2019386291504, 0.666749609723483, -93.1761093139648, -1.62622989172684, 218, 29, 'PPL', 'P'),
(115972, 'Hastie', 41.5627784729004, 0.725407330629133, -93.4894409179688, -1.63169855986726, 218, 16, 'PPL', 'P'),
(13899, 'Hasting Estates Mobile Home Park', 38.6313896179199, 0.674244943453457, -75.585563659668, -1.31921695283698, 218, 10, 'PPL', 'P'),
(16375, 'Hastings', 29.7177791595459, 0.518673092714629, -81.5083312988281, -1.4225887489709, 218, 12, 'PPL', 'P'),
(21778, 'Hastings', 33.4486083984375, 0.583788346762962, -84.3252792358398, -1.47175376532901, 218, 13, 'PPL', 'P'),
(76044, 'Hastings', 34.2266693115234, 0.597368071477385, -98.1097183227539, -1.71233761293626, 218, 42, 'PPL', 'P'),
(94777, 'Hastings', 29.5086097717285, 0.515022398202835, -95.2513885498047, -1.66245034729052, 218, 51, 'PPL', 'P'),
(109585, 'Hastings', 39.5511093139648, 0.690297080344882, -80.6736068725586, -1.40802005938567, 218, 58, 'PPL', 'P'),
(115973, 'Hastings', 41.0227813720703, 0.715982603268424, -95.498893737793, -1.66677012773668, 218, 16, 'PPL', 'P'),
(119956, 'Hastings', 41.9688911437988, 0.732495333870378, -88.4022216796875, -1.54290983438846, 218, 18, 'PPL', 'P'),
(122790, 'Hastings', 41.3836097717285, 0.722280246877162, -85.929443359375, -1.49975171102707, 218, 19, 'PPL', 'P'),
(125039, 'Hastings', 42.3875007629395, 0.739801450004902, -71.2897186279297, -1.24424031287771, 218, 23, 'PPL', 'P'),
(127708, 'Hastings', 44.3547210693359, 0.774135921463612, -70.9905624389648, -1.23901905240255, 218, 26, 'PPL', 'P'),
(131241, 'Hastings', 42.6458282470703, 0.744310115151379, -85.2908325195313, -1.48860584923287, 218, 27, 'PPL', 'P'),
(135824, 'Hastings', 44.7433280944824, 0.780918393548799, -92.8522186279297, -1.62057693283898, 218, 28, 'PPL', 'P'),
(140200, 'Hastings', 46.6838912963867, 0.814787610765072, -98.0941696166992, -1.71206623682119, 218, 34, 'PPL', 'P'),
(142010, 'Hastings', 40.586109161377, 0.708361235439862, -98.3880615234375, -1.71719561823873, 218, 35, 'PPL', 'P'),
(143941, 'Hastings', 43.4011116027832, 0.75749229649408, -72.0319366455078, -1.25719446105207, 218, 36, 'PPL', 'P'),
(149513, 'Hastings', 43.3738899230957, 0.75701718855561, -76.1527786254883, -1.32911672155713, 218, 40, 'PPL', 'P'),
(155663, 'Hastings', 40.6552810668945, 0.709568512941023, -82.4444427490234, -1.43892697594242, 218, 41, 'PPL', 'P'),
(162499, 'Hastings', 41.6069412231445, 0.726178116027629, -79.0999984741211, -1.3805554116959, 218, 45, 'PPL', 'P'),
(149514, 'Hastings Center', 43.3169403076172, 0.756023230257765, -76.1547164916992, -1.32915054370298, 218, 40, 'PPL', 'P'),
(65418, 'Hastings Corner', 36.3516693115234, 0.634456318082264, -76.1638870239258, -1.32931059968449, 218, 33, 'PPL', 'P'),
(13900, 'Hastings Park Mobile Home Park', 38.6347198486328, 0.674303066944248, -75.5938873291016, -1.31936222827444, 218, 10, 'PPL', 'P'),
(149516, 'Hastings-on-Hudson', 40.9944381713867, 0.715487921095942, -73.8791732788086, -1.28943482236662, 218, 40, 'PPL', 'P'),
(325, 'Hasty', 36.0149993896484, 0.628580319453113, -93.0475006103516, -1.62398524640207, 218, 4, 'PPL', 'P'),
(21779, 'Hasty', 31.2574996948242, 0.545546285615805, -82.5730590820313, -1.44117175442525, 218, 13, 'PPL', 'P'),
(32705, 'Hasty', 37.9388885498047, 0.662158519741268, -95.6902770996094, -1.67011039753391, 218, 20, 'PPL', 'P'),
(65419, 'Hasty', 34.6902809143066, 0.6054596203964, -79.4783325195313, -1.3871585864607, 218, 33, 'PPL', 'P'),
(135826, 'Hasty', 45.3711090087891, 0.79187523748463, -93.9727783203125, -1.6401343889362, 218, 28, 'PPL', 'P'),
(186824, 'Hasty', 38.1124992370605, 0.665188597850533, -102.956939697266, -1.79693758549454, 218, 7, 'PPL', 'P'),
(127709, 'Hasty Corner', 44.8241691589355, 0.782329336294323, -69.2577819824219, -1.20877632822167, 218, 26, 'PPL', 'P'),
(186825, 'Haswell', 38.452220916748, 0.671117859701486, -103.162498474121, -1.80052526295704, 218, 7, 'PPL', 'P'),
(102655, 'Hat Creek', 37.1186103820801, 0.647841964932248, -78.904167175293, -1.3771375107529, 218, 53, 'PPL', 'P'),
(193621, 'Hat Creek', 40.8305587768555, 0.712627686085197, -121.512496948242, -2.12079315406639, 218, 6, 'PPL', 'P'),
(209497, 'Hat Creek (historical)', 42.9394416809082, 0.749434636299937, -104.369171142578, -1.82158567401544, 218, 59, 'PPL', 'P'),
(162502, 'Hatboro', 40.1741714477539, 0.701171566024003, -75.1072235107422, -1.31086834229375, 218, 45, 'PPL', 'P'),
(55206, 'Hatch', 39.5888900756836, 0.690956479030786, -91.6177825927734, -1.59903195962024, 218, 29, 'PPL', 'P'),
(72855, 'Hatch', 39.0088882446289, 0.680833537411286, -83.1763916015625, -1.45170189337543, 218, 41, 'PPL', 'P'),
(182046, 'Hatch', 37.4897193908691, 0.654319039019429, -120.954437255859, -2.11105317501164, 218, 6, 'PPL', 'P'),
(188668, 'Hatch', 32.6652793884277, 0.570116676411904, -107.152496337891, -1.87016386282736, 218, 38, 'PPL', 'P'),
(192612, 'Hatch', 37.6497192382813, 0.657111563159459, -112.433609008789, -1.96233666710333, 218, 52, 'PPL', 'P'),
(195063, 'Hatch', 42.8194389343262, 0.747340193260644, -111.851387023926, -1.95217497648997, 218, 17, 'PPL', 'P'),
(207612, 'Hatch', 46.2744407653809, 0.807641350874981, -118.669441223145, -2.07117247084576, 218, 56, 'PPL', 'P'),
(16376, 'Hatchbend', 29.8469390869141, 0.52092735870884, -82.918327331543, -1.44719782218183, 218, 12, 'PPL', 'P'),
(16377, 'Hatchcakamocha (historical)', 30.4666690826416, 0.531743687607656, -83.9000015258789, -1.46433126905485, 218, 12, 'PPL', 'P'),
(3003, 'Hatchechubbee', 32.2705612182617, 0.563227544725059, -85.2758331298828, -1.48834406049772, 218, 2, 'PPL', 'P'),
(94778, 'Hatchel', 31.8500003814697, 0.555887373418097, -99.9488906860352, -1.74443722618721, 218, 51, 'PPL', 'P'),
(21780, 'Hatcher', 31.8147201538086, 0.555271617284557, -85.0136108398438, -1.48376741816442, 218, 13, 'PPL', 'P'),
(36321, 'Hatcher', 37.2947196960449, 0.650915652304363, -85.3663864135742, -1.48992451344662, 218, 21, 'PPL', 'P'),
(65420, 'Hatcher', 35.0958290100098, 0.612537769941612, -78.2136077880859, -1.36508497576558, 218, 33, 'PPL', 'P'),
(102656, 'Hatcher', 37.5616683959961, 0.655574786052429, -78.2994384765625, -1.36658300387875, 218, 53, 'PPL', 'P'),
(109587, 'Hatcher', 37.6958312988281, 0.657916370440881, -81.6197204589844, -1.42453285656665, 218, 58, 'PPL', 'P'),
(102657, 'Hatchers', 37.5802803039551, 0.655899625126392, -78.0516662597656, -1.36225856290068, 218, 53, 'PPL', 'P'),
(21781, 'Hatchers Store', 33.038330078125, 0.576627639223957, -82.029167175293, -1.43167904987772, 218, 13, 'PPL', 'P'),
(41279, 'Hatchersville', 30.829439163208, 0.538075219941265, -90.8675003051758, -1.58593706338227, 218, 22, 'PPL', 'P'),
(87636, 'Hatchertown', 35.7316703796387, 0.623635295362027, -83.6322174072266, -1.45965755449982, 218, 50, 'PPL', 'P'),
(3004, 'Hatchet', 33.0166702270508, 0.57624960350722, -86.1050033569336, -1.50281581101926, 218, 2, 'PPL', 'P'),
(3005, 'Hatchet Creek', 33.2425003051758, 0.580191081920537, -86.0416717529297, -1.50171046600882, 218, 2, 'PPL', 'P'),
(60195, 'Hatchette (historical)', 32.8111114501953, 0.57266192604472, -88.4602813720703, -1.54392316718323, 218, 30, 'PPL', 'P'),
(76046, 'Hatchetville', 34.9419403076172, 0.60985190540324, -98.4436111450195, -1.71816514203358, 218, 42, 'PPL', 'P'),
(94779, 'Hatchetville', 33.2594413757324, 0.580486759380563, -95.5294418334961, -1.66730329258692, 218, 51, 'PPL', 'P'),
(939, 'Hatchie', 35.4375, 0.618501053675491, -89.0774993896484, -1.5546956537926, 218, 50, 'PPL', 'P'),
(9377, 'Hatchie Coon', 35.6349983215332, 0.621948049653407, -90.491943359375, -1.57938235814931, 218, 4, 'PPL', 'P'),
(131244, 'Hatchs', 44.8269386291504, 0.782377672668108, -85.6811065673828, -1.49541741635297, 218, 27, 'PPL', 'P'),
(127710, 'Hatchs Corner', 44.047779083252, 0.768778773193836, -69.7619400024414, -1.21757554562134, 218, 26, 'PPL', 'P'),
(149518, 'Hatchs Corners', 43.1780586242676, 0.753599287612602, -75.5077819824219, -1.31785940647131, 218, 40, 'PPL', 'P'),
(162504, 'Hatchtown', 41.7788887023926, 0.729179165681012, -79.6505584716797, -1.39016449638307, 218, 45, 'PPL', 'P'),
(125040, 'Hatchville', 41.6291694641113, 0.726566072019426, -70.5638885498047, -1.23157218820442, 218, 23, 'PPL', 'P'),
(174440, 'Hatchville', 44.8580589294434, 0.782920824372429, -92.1361083984375, -1.60807845152713, 218, 57, 'PPL', 'P'),
(9378, 'Hatfield', 34.4855613708496, 0.601886590319895, -94.3783264160156, -1.64721253848141, 218, 4, 'PPL', 'P'),
(30035, 'Hatfield', 37.9025001525879, 0.661523422400312, -87.2241668701172, -1.5223488991925, 218, 19, 'PPL', 'P'),
(36322, 'Hatfield', 37.7244415283203, 0.658415713145271, -82.3686065673828, -1.43760338488065, 218, 21, 'PPL', 'P'),
(41280, 'Hatfield', 31.9116706848145, 0.556963723262166, -92.6466674804688, -1.61698938853454, 218, 22, 'PPL', 'P'),
(72856, 'Hatfield', 39.5777816772461, 0.690762600903428, -82.067497253418, -1.43234803594355, 218, 41, 'PPL', 'P'),
(109589, 'Hatfield', 37.7275009155273, 0.658469109525127, -82.3161087036133, -1.43668712430761, 218, 58, 'PPL', 'P'),
(125041, 'Hatfield', 42.3708305358887, 0.739510499655811, -72.5986099243164, -1.26708477555035, 218, 23, 'PPL', 'P'),
(135827, 'Hatfield', 43.9575004577637, 0.767203113934891, -96.1949996948242, -1.67891946862962, 218, 28, 'PPL', 'P'),
(139212, 'Hatfield', 40.5288887023926, 0.707362550031083, -94.1547164916992, -1.64330980906196, 218, 29, 'PPL', 'P'),
(162505, 'Hatfield', 40.2797203063965, 0.703013741129038, -75.2997207641602, -1.31422805316694, 218, 45, 'PPL', 'P'),
(174441, 'Hatfield', 44.4147186279297, 0.775183076404231, -90.7305603027344, -1.58354700946198, 218, 57, 'PPL', 'P'),
(193622, 'Hatfield', 41.9980583190918, 0.733004397112747, -121.518333435059, -2.12089501997808, 218, 6, 'PPL', 'P'),
(143942, 'Hatfield Corner', 43.1805610656738, 0.75364296345448, -71.741943359375, -1.25213312340038, 218, 36, 'PPL', 'P'),
(193623, 'Hatfield Place (historical)', 40.204719543457, 0.701704730874237, -122.56916809082, -2.13923554461519, 218, 6, 'PPL', 'P'),
(41281, 'Hathaway', 30.3494396209717, 0.529697647521176, -92.67138671875, -1.61742082063113, 218, 22, 'PPL', 'P'),
(47934, 'Hathaway', 39.4411087036133, 0.688377207515044, -76.8138885498047, -1.34065526645406, 218, 25, 'PPL', 'P'),
(87637, 'Hathaway', 36.2261085510254, 0.632264869400265, -89.6597213745117, -1.56485734440597, 218, 50, 'PPL', 'P'),
(94780, 'Hathaway', 30.1275005340576, 0.525824079715655, -94.4816665649414, -1.64901616432967, 218, 51, 'PPL', 'P'),
(109588, 'Hathaway', 38.857780456543, 0.67819620898378, -81.0833282470703, -1.4151710463867, 218, 58, 'PPL', 'P'),
(196676, 'Hathaway', 46.2761116027832, 0.807670512488917, -106.196113586426, -1.85347183490501, 218, 31, 'PPL', 'P'),
(149519, 'Hathaway Corners', 42.9638900756836, 0.749861341285594, -77.3483276367188, -1.34998298817207, 218, 40, 'PPL', 'P'),
(200952, 'Hathaway Mead', 45.4569396972656, 0.7933732655978, -123.817497253418, -2.16102299865118, 218, 43, 'PPL', 'P'),
(16378, 'Hathaway Mill', 30.8136100769043, 0.537798950267683, -85.8013916015625, -1.49751678624028, 218, 12, 'PPL', 'P'),
(182048, 'Hathaway Pines', 38.1919403076172, 0.666575106093056, -120.364440917969, -2.10075579634074, 218, 6, 'PPL', 'P'),
(182049, 'Hathaway Place', 35.1669387817383, 0.613778869588616, -120.298332214355, -2.09960198179846, 218, 6, 'PPL', 'P'),
(182050, 'Hathaways Mountain Pines', 38.1947212219238, 0.666623642203923, -120.367218017578, -2.10080426587258, 218, 6, 'PPL', 'P'),
(125043, 'Hatherly', 42.1566696166992, 0.735772686486857, -70.9250030517578, -1.2378748252402, 218, 23, 'PPL', 'P'),
(125044, 'Hatherly Beach', 42.2125015258789, 0.736747137129717, -70.7333297729492, -1.2345294954369, 218, 23, 'PPL', 'P'),
(60196, 'Hathorn', 31.3930606842041, 0.547912271217745, -89.9191665649414, -1.56938551720743, 218, 30, 'PPL', 'P'),
(125045, 'Hathorne', 42.586109161377, 0.743267820479749, -70.9749984741211, -1.23874740997136, 218, 23, 'PPL', 'P'),
(21782, 'Hatley', 31.899169921875, 0.556745543789861, -83.6133270263672, -1.45932785515687, 218, 13, 'PPL', 'P'),
(60197, 'Hatley', 33.9766693115234, 0.593004748347399, -88.4205627441406, -1.54322994635149, 218, 30, 'PPL', 'P'),
(174442, 'Hatley', 44.8875007629395, 0.78343468130476, -89.3386077880859, -1.55925285504995, 218, 57, 'PPL', 'P'),
(131245, 'Hatmaker', 41.8474998474121, 0.730376656065166, -85.1213912963867, -1.48564854200039, 218, 27, 'PPL', 'P'),
(87638, 'Hatmaker (historical)', 36.2872200012207, 0.633331465416842, -84.0886077880859, -1.46762306932025, 218, 50, 'PPL', 'P'),
(21783, 'Hatoff (historical)', 32.3116683959961, 0.563945000322727, -82.8080596923828, -1.44527328882008, 218, 13, 'PPL', 'P'),
(112436, 'Hatten', 33.7769393920898, 0.58951880363854, -90.1791687011719, -1.57392341054687, 218, 30, 'PPL', 'P'),
(65424, 'Hatteras', 35.2191696166992, 0.614690469629751, -75.690559387207, -1.32104947398306, 218, 33, 'PPL', 'P'),
(65423, 'Hatterbrond (historical)', 35.6811103820801, 0.622752856934829, -81.4927825927734, -1.42231737285582, 218, 33, 'PPL', 'P'),
(3006, 'Hatters', 30.9033298492432, 0.539364855699136, -88.0508270263672, -1.53677684071412, 218, 2, 'PPL', 'P'),
(113540, 'Hattertown', 41.3411102294922, 0.721538489934547, -73.309440612793, -1.27949111148849, 218, 8, 'PPL', 'P'),
(55208, 'Hattie', 37.079719543457, 0.647163191749414, -91.7733306884766, -1.60174678603547, 218, 29, 'PPL', 'P'),
(109590, 'Hattie', 38.8997192382813, 0.678928178809388, -81.0127792358398, -1.4139397338567, 218, 58, 'PPL', 'P'),
(9379, 'Hattie (historical)', 34.1416702270508, 0.595884557592156, -93.9944381713867, -1.64051242465294, 218, 4, 'PPL', 'P'),
(60198, 'Hattiesburg', 31.326940536499, 0.546758256938387, -89.290283203125, -1.55840943193272, 218, 30, 'PPL', 'P'),
(9380, 'Hattieville', 35.2874984741211, 0.615883033165888, -92.7866668701172, -1.61943283883469, 218, 4, 'PPL', 'P'),
(81466, 'Hattieville', 33.1122207641602, 0.577917274981828, -81.6113891601563, -1.42438744797114, 218, 48, 'PPL', 'P'),
(3008, 'Hatton', 34.5627784729004, 0.60323428298953, -87.415283203125, -1.52568450845783, 218, 2, 'PPL', 'P'),
(9381, 'Hatton', 34.3583297729492, 0.59966598002396, -94.3716735839844, -1.64709642465788, 218, 4, 'PPL', 'P'),
(36323, 'Hatton', 38.225830078125, 0.667166594171163, -85.0066680908203, -1.48364624433482, 218, 21, 'PPL', 'P'),
(55209, 'Hatton', 39.024169921875, 0.681100252994457, -92.0261077880859, -1.6061585786973, 218, 29, 'PPL', 'P'),
(102658, 'Hatton', 37.7591705322266, 0.659021848609373, -78.5130615234375, -1.37031142940486, 218, 53, 'PPL', 'P'),
(131247, 'Hatton', 43.922779083252, 0.766597111628843, -84.8186111450195, -1.48036403144935, 218, 27, 'PPL', 'P'),
(140201, 'Hatton', 47.639720916748, 0.831469984728465, -97.4530563354492, -1.70087669918511, 218, 34, 'PPL', 'P'),
(155664, 'Hatton', 41.2508316040039, 0.719962830675602, -83.4686126708984, -1.45680211317904, 218, 41, 'PPL', 'P'),
(162508, 'Hatton', 40.1383285522461, 0.700545989483943, -77.1580581665039, -1.34666215945079, 218, 45, 'PPL', 'P'),
(192613, 'Hatton', 38.8388900756836, 0.677866509640828, -112.455833435059, -1.9627245565161, 218, 52, 'PPL', 'P'),
(207613, 'Hatton', 46.7761116027832, 0.816397158748889, -118.82527923584, -2.07389235726706, 218, 56, 'PPL', 'P'),
(209498, 'Hatton', 41.3050003051758, 0.72090825286258, -105.982780456543, -1.84974846938497, 218, 59, 'PPL', 'P'),
(174444, 'Hatton (historical)', 44.2594413757324, 0.772472977099939, -88.9888916015625, -1.5531491561476, 218, 57, 'PPL', 'P'),
(155665, 'Hattonia (historical)', 40.2861099243164, 0.703125260999685, -81.1263885498047, -1.41592259044632, 218, 41, 'PPL', 'P'),
(102660, 'Hattontown', 38.9449996948242, 0.679718471862869, -77.3933334350586, -1.35076848753559, 218, 53, 'PPL', 'P'),
(162509, 'Hatville', 40.0325012207031, 0.698698954109919, -76.0808334350586, -1.32786104110316, 218, 45, 'PPL', 'P'),
(195064, 'Hatwai', 46.4363899230957, 0.810467896897936, -116.967216491699, -2.04146304467316, 218, 17, 'PPL', 'P'),
(211435, 'HauÃ‚â€˜ula', 21.610559463501, 0.377175415836111, -157.910827636719, -2.75606386681, 218, 15, 'PPL', 'P'),
(30036, 'Haubstadt', 38.2050018310547, 0.666803072682367, -87.5741729736328, -1.52845765810093, 218, 19, 'PPL', 'P'),
(196677, 'Hauck', 46.9594383239746, 0.819596813640565, -109.830001831055, -1.91689514942331, 218, 31, 'PPL', 'P'),
(162510, 'Haucks', 40.8311080932617, 0.712637273465121, -76.0369415283203, -1.3270949828156, 218, 45, 'PPL', 'P'),
(162511, 'Hauckville', 40.3199996948242, 0.703716749077791, -76.4216690063477, -1.33380974403007, 218, 45, 'PPL', 'P'),
(174445, 'Hauer', 45.8027801513672, 0.799409320208464, -91.4599990844727, -1.59627811789505, 218, 57, 'PPL', 'P'),
(135829, 'Haug', 48.8197212219238, 0.85206487522832, -96.1841735839844, -1.67873051735028, 218, 28, 'PPL', 'P'),
(196678, 'Haugan', 47.3833312988281, 0.826995141727832, -115.398612976074, -2.01408574866715, 218, 31, 'PPL', 'P'),
(174446, 'Haugen', 45.6088905334473, 0.796025307990328, -91.7747192382813, -1.60177102080139, 218, 57, 'PPL', 'P'),
(47935, 'Haughs Hideway', 39.5972213745117, 0.691101887626304, -77.2822189331055, -1.34882917362979, 218, 25, 'PPL', 'P'),
(41282, 'Haughton', 32.5325012207031, 0.567799260210344, -93.5038909912109, -1.6319507612225, 218, 22, 'PPL', 'P'),
(115974, 'Hauntown', 42.0008316040039, 0.733052800065559, -90.1988906860352, -1.57426762411776, 218, 16, 'PPL', 'P'),
(149520, 'Hauppauge', 40.8255615234375, 0.712540467559497, -73.2030563354492, -1.27763435557648, 218, 40, 'PPL', 'P'),
(195065, 'Hauser', 47.7730598449707, 0.833797188047031, -117.02693939209, -2.04250540592382, 218, 17, 'PPL', 'P'),
(200953, 'Hauser', 43.4930610656738, 0.759097117366962, -124.217498779297, -2.16800434229077, 218, 43, 'PPL', 'P'),
(131248, 'Hautala Corner', 46.5208282470703, 0.811941623666159, -90.1555633544922, -1.57351141952623, 218, 27, 'PPL', 'P'),
(162512, 'Hauto', 40.8441696166992, 0.712865240054432, -75.8913879394531, -1.32455459345177, 218, 45, 'PPL', 'P'),
(109591, 'Havaco', 37.4099998474121, 0.652927670507918, -81.5774993896484, -1.42379595989303, 218, 58, 'PPL', 'P'),
(3010, 'Havana', 32.8950004577637, 0.574126065433018, -87.6202774047852, -1.52926233222429, 218, 2, 'PPL', 'P'),
(9382, 'Havana', 35.1111106872559, 0.612804485524784, -93.5294418334961, -1.63239670754703, 218, 4, 'PPL', 'P'),
(16379, 'Havana', 30.6236095428467, 0.53448281536783, -84.4147186279297, -1.47331477720196, 218, 12, 'PPL', 'P'),
(32715, 'Havana', 37.0916709899902, 0.647371783841794, -95.9416732788086, -1.67449808858787, 218, 20, 'PPL', 'P'),
(87639, 'Havana', 35.3669395446777, 0.617269541408411, -88.0988922119141, -1.53761573645749, 218, 50, 'PPL', 'P'),
(94781, 'Havana', 26.2447204589844, 0.458056783274795, -98.5091705322266, -1.71930936919593, 218, 51, 'PPL', 'P'),
(109592, 'Havana', 37.9894409179688, 0.663040825010412, -81.8555603027344, -1.42864903834748, 218, 58, 'PPL', 'P'),
(119957, 'Havana', 40.2999992370605, 0.703367675237909, -90.0608291625977, -1.57185799596346, 218, 18, 'PPL', 'P'),
(135831, 'Havana', 44.0663909912109, 0.769103612267798, -93.146110534668, -1.62570631425653, 218, 28, 'PPL', 'P'),
(140203, 'Havana', 45.9502792358398, 0.801983664876189, -97.6186065673828, -1.70376609580979, 218, 34, 'PPL', 'P'),
(155666, 'Havana', 41.1372184753418, 0.717979907506956, -82.7472229003906, -1.44421148649347, 218, 41, 'PPL', 'P'),
(94782, 'Havana Lomas Number 1 Colonia', 26.2490005493164, 0.458131484943371, -98.5130004882813, -1.71937621453929, 218, 51, 'PPL', 'P'),
(94783, 'Havana Lomas Number 2 Colonia', 26.2479991912842, 0.458114007948718, -98.5110015869141, -1.71934132712901, 218, 51, 'PPL', 'P'),
(94784, 'Havana Lomas Number 3 Colonia', 26.2469997406006, 0.458096564243578, -98.5100021362305, -1.71932388342387, 218, 51, 'PPL', 'P'),
(94785, 'Havana Lomas Number 4 Colonia', 26.2469997406006, 0.458096564243578, -98.5110015869141, -1.71934132712901, 218, 51, 'PPL', 'P'),
(94786, 'Havana Lomas Number 5 Colonia', 26.2450008392334, 0.458061676833298, -98.5110015869141, -1.71934132712901, 218, 51, 'PPL', 'P'),
(192902, 'Havasu Lake', 34.4822196960449, 0.601828267092022, -114.413063049316, -1.99688465750243, 218, 6, 'PPL', 'P'),
(182051, 'Havasu Palms', 34.3988914489746, 0.60037391482073, -114.279716491699, -1.99455732102581, 218, 6, 'PPL', 'P'),
(65428, 'Havelock', 34.8788909912109, 0.608751487240819, -76.9016723632813, -1.34218738302919, 218, 33, 'PPL', 'P'),
(102661, 'Havelock', 38.0205612182617, 0.663583976714733, -76.8388900756836, -1.34109162539867, 218, 53, 'PPL', 'P'),
(115975, 'Havelock', 42.836109161377, 0.747631143609735, -94.7002792358398, -1.65283167522342, 218, 16, 'PPL', 'P'),
(198402, 'Havelock', 46.4747200012207, 0.811136882963764, -102.74333190918, -1.79320942628454, 218, 34, 'PPL', 'P'),
(65427, 'Havelock Station', 34.8824996948242, 0.6088144710006, -76.9225006103516, -1.34255090451798, 218, 33, 'PPL', 'P'),
(32706, 'Haven', 37.8988914489746, 0.661460438640532, -97.7825012207031, -1.70662659713664, 218, 20, 'PPL', 'P'),
(115976, 'Haven', 41.8916702270508, 0.731147574621717, -92.478889465332, -1.61406110975794, 218, 16, 'PPL', 'P'),
(127711, 'Haven', 44.2663917541504, 0.772594284087593, -68.5869369506836, -1.19706787364719, 218, 26, 'PPL', 'P'),
(149521, 'Haven', 41.540828704834, 0.725024234906325, -74.5244369506836, -1.30069679798435, 218, 40, 'PPL', 'P'),
(174448, 'Haven', 43.848331451416, 0.765297755332993, -87.7533264160156, -1.53158447553679, 218, 57, 'PPL', 'P'),
(193624, 'Haven', 40.0094413757324, 0.698296483890181, -121.22917175293, -2.11584819655433, 218, 6, 'PPL', 'P'),
(102662, 'Haven (historical)', 37.438060760498, 0.653417425832383, -76.2847213745117, -1.33141955695172, 218, 53, 'PPL', 'P'),
(70943, 'Haven Beach', 39.5933303833008, 0.691033977018507, -74.2161102294922, -1.29531548152768, 218, 37, 'PPL', 'P'),
(102663, 'Haven Beach', 37.4261093139648, 0.653208833740003, -76.2566680908203, -1.33092993478531, 218, 53, 'PPL', 'P'),
(162513, 'Haven Croft', 40.3183288574219, 0.703687587463855, -76.8399963378906, -1.34111093331658, 218, 45, 'PPL', 'P'),
(204233, 'Haven Grove', 40.6388893127441, 0.709282422860921, -111.841667175293, -1.95200533312853, 218, 52, 'PPL', 'P'),
(102665, 'Haven Heights', 36.8127784729004, 0.642504191159402, -76.1761093139648, -1.32952391888781, 218, 53, 'PPL', 'P'),
(145391, 'Haven Homes', 40.5094413757324, 0.707023130150152, -74.4066696166992, -1.29864137025503, 218, 37, 'PPL', 'P'),
(13901, 'Haven Lake Estates', 38.9116706848145, 0.679136770901769, -75.4638900756836, -1.31709334818375, 218, 10, 'PPL', 'P'),
(16380, 'Haven Park', 30.4111099243164, 0.530773997365245, -87.3727798461914, -1.52494268493618, 218, 12, 'PPL', 'P'),
(21784, 'Haven Park', 33.6044387817383, 0.586508100026205, -84.3163909912109, -1.47159863619552, 218, 13, 'PPL', 'P'),
(155667, 'Haven Park', 41.6408309936523, 0.726769604105735, -83.711669921875, -1.46104426247942, 218, 41, 'PPL', 'P'),
(193625, 'Haven Place', 40.1824989318848, 0.701316908040494, -122.67472076416, -2.14107778629925, 218, 6, 'PPL', 'P'),
(204235, 'Haven Place', 40.6547203063965, 0.709558725824017, -111.817497253418, -1.95158348841186, 218, 52, 'PPL', 'P'),
(155668, 'Haven View', 40.0074996948242, 0.698262595165309, -84.0580596923828, -1.46708990447001, 218, 41, 'PPL', 'P'),
(60199, 'Havendale', 32.6963882446289, 0.570659628379144, -89.8708267211914, -1.56854182777409, 218, 30, 'PPL', 'P'),
(55210, 'Havenhurst', 36.5833282470703, 0.638499529249223, -94.3741683959961, -1.64713996734171, 218, 29, 'PPL', 'P'),
(142012, 'Havens', 41.2652816772461, 0.720215032030832, -97.7494430541992, -1.70604962328648, 218, 35, 'PPL', 'P'),
(155669, 'Havens', 41.3058280944824, 0.720922700511494, -83.1927795410156, -1.4519879168765, 218, 41, 'PPL', 'P'),
(195066, 'Havens', 43.2705612182617, 0.755213762444436, -112.589996337891, -1.96506614090455, 218, 17, 'PPL', 'P'),
(149522, 'Havens Corner', 42.7172203063965, 0.7455561416464, -77.0894393920898, -1.34546453590858, 218, 40, 'PPL', 'P'),
(155670, 'Havens Corners', 40.0188903808594, 0.698461400140684, -82.815559387207, -1.44540418318766, 218, 41, 'PPL', 'P'),
(72858, 'Havensport', 39.810001373291, 0.694815599187392, -82.6730575561523, -1.44291705704564, 218, 41, 'PPL', 'P'),
(32708, 'Havensville', 39.5111083984375, 0.689598932665118, -96.0777816772461, -1.67687362828022, 218, 20, 'PPL', 'P'),
(125046, 'Havenville', 42.5022201538086, 0.741803681091451, -71.2111129760742, -1.24286838544215, 218, 23, 'PPL', 'P'),
(47936, 'Havenwood', 39.4291687011719, 0.688168815159745, -76.6191711425781, -1.33725680658701, 218, 25, 'PPL', 'P'),
(47937, 'Havenwood Hills', 39.6416702270508, 0.691877666451844, -77.5977783203125, -1.35433672392213, 218, 25, 'PPL', 'P'),
(186826, 'Haver', 38.9650001525879, 0.680067545702752, -105.926940917969, -1.84877388558406, 218, 7, 'PPL', 'P'),
(47938, 'Haver Hill', 39.4047203063965, 0.687742110174087, -76.5524978637695, -1.3360931383487, 218, 25, 'PPL', 'P'),
(102666, 'Haver Hills', 38.9638900756836, 0.680048171205821, -77.2808303833008, -1.34880493886387, 218, 53, 'PPL', 'P'),
(13902, 'Haverford', 39.7833290100098, 0.694350078628847, -75.6944427490234, -1.32111725143281, 218, 10, 'PPL', 'P'),
(47939, 'Haverford', 39.4419403076172, 0.688391721742985, -76.6222229003906, -1.33731006980882, 218, 25, 'PPL', 'P'),
(162514, 'Haverford', 40.0130615234375, 0.698359667387043, -75.2947235107422, -1.31414083464124, 218, 45, 'PPL', 'P'),
(16381, 'Haverhill', 26.6908302307129, 0.465842867616778, -80.1202774047852, -1.39836263832472, 218, 12, 'PPL', 'P'),
(32709, 'Haverhill', 37.6855583190918, 0.657737073120492, -96.8827819824219, -1.6909235340851, 218, 20, 'PPL', 'P'),
(72857, 'Haverhill', 38.5847206115723, 0.673430415634056, -82.8322219848633, -1.4456950003787, 218, 41, 'PPL', 'P'),
(115977, 'Haverhill', 41.9449996948242, 0.732078349422699, -92.960563659668, -1.622467910371, 218, 16, 'PPL', 'P'),
(125047, 'Haverhill', 42.7761116027832, 0.746583988669116, -71.0777816772461, -1.24054131528164, 218, 23, 'PPL', 'P'),
(143943, 'Haverhill', 44.0344390869141, 0.768545946335536, -72.0644378662109, -1.25776171436426, 218, 36, 'PPL', 'P'),
(149523, 'Haverling Heights', 42.3494415283203, 0.739137191050009, -77.3158264160156, -1.34941573485988, 218, 40, 'PPL', 'P'),
(169415, 'Haversham', 41.3472213745117, 0.721645149536205, -71.7372207641602, -1.25205069856464, 218, 47, 'PPL', 'P'),
(87640, 'Haversons (historical)', 36.3444404602051, 0.634330150825622, -83.7805633544922, -1.46224667971159, 218, 50, 'PPL', 'P'),
(149524, 'Haverstraw', 41.1974983215332, 0.719031989295592, -73.9649963378906, -1.29093271732174, 218, 40, 'PPL', 'P'),
(78436, 'Havertown', 39.9808311462402, 0.697797141185791, -75.3088912963867, -1.31438810914845, 218, 45, 'PPL', 'P'),
(177665, 'Havilah', 35.5177803039551, 0.619902209304009, -118.517776489258, -2.06852542188027, 218, 6, 'PPL', 'P'),
(32710, 'Haviland', 37.6194381713867, 0.656583058841133, -99.1061096191406, -1.72972792169643, 218, 20, 'PPL', 'P'),
(149526, 'Haviland', 41.7666702270508, 0.728965913056724, -73.9019393920898, -1.28983216600126, 218, 40, 'PPL', 'P'),
(155671, 'Haviland', 41.0188903808594, 0.715914692660627, -84.5808334350586, -1.47621402752268, 218, 41, 'PPL', 'P'),
(178339, 'Haviland', 34.8022193908691, 0.607413315372082, -114.176391601563, -1.99275396149367, 218, 5, 'PPL', 'P'),
(47940, 'Haviland Hills', 39.1961097717285, 0.684101169489786, -76.9952774047852, -1.3438210991999, 218, 25, 'PPL', 'P'),
(149527, 'Haviland Hollow', 41.4844398498535, 0.724040063725486, -73.5711135864258, -1.28405816644186, 218, 40, 'PPL', 'P'),
(207614, 'Havillah', 48.8280601501465, 0.852210416981893, -119.203056335449, -2.08048581149388, 218, 56, 'PPL', 'P'),
(87641, 'Havley Springs', 36.228889465332, 0.632313405511132, -83.3108291625977, -1.45404827145384, 218, 50, 'PPL', 'P'),
(115978, 'Havre', 41.2536087036133, 0.720011300207441, -91.6100006103516, -1.59889613840465, 218, 16, 'PPL', 'P'),
(196679, 'Havre', 48.5499992370605, 0.847357338527442, -109.683326721191, -1.91433518582547, 218, 31, 'PPL', 'P'),
(47941, 'Havre de Grace', 39.5491714477539, 0.690263258199038, -76.0919418334961, -1.32805491923052, 218, 25, 'PPL', 'P'),
(65431, 'Haw Branch', 34.9363899230957, 0.609755032918589, -77.6319427490234, -1.3549330056902, 218, 33, 'PPL', 'P'),
(102667, 'Haw Branch', 37.4102783203125, 0.652932530776907, -78.0208282470703, -1.36172033804437, 218, 53, 'PPL', 'P'),
(65432, 'Haw Creek', 35.5844383239746, 0.62106561122621, -82.5263900756836, -1.44035722660585, 218, 33, 'PPL', 'P'),
(76049, 'Haw Creek', 34.7724990844727, 0.606894598170762, -94.5091705322266, -1.64949619911616, 218, 42, 'PPL', 'P'),
(94787, 'Haw Creek (historical)', 30.0031394958496, 0.523653570137727, -96.6338500976563, -1.68657885308275, 218, 51, 'PPL', 'P'),
(60202, 'Haw Pond (historical)', 31.5833301544189, 0.55123309993902, -89.7597198486328, -1.56660264702635, 218, 30, 'PPL', 'P'),
(65433, 'Haw River', 36.0913887023926, 0.629913564473834, -79.3644409179688, -1.38517080302307, 218, 33, 'PPL', 'P'),
(211438, 'HawaiÃ‚â€˜i Beaches Estates', 19.545560836792, 0.341134390750878, -154.909164428711, -2.70367496079429, 218, 15, 'PPL', 'P'),
(211437, 'HawaiÃ‚â€˜i Kai', 21.2827796936035, 0.371454579629971, -157.705276489258, -2.75247632250555, 218, 15, 'PPL', 'P'),
(211441, 'Hawaii', 20.750280380249, 0.362160713347326, -156.500274658203, -2.73144507306109, 218, 15, 'ADM1', 'A'),
(211443, 'Hawaiian Acres', 19.5380592346191, 0.341003463093787, -155.052215576172, -2.70617167431624, 218, 15, 'PPL', 'P'),
(211442, 'Hawaiian Beaches', 19.5430603027344, 0.341090748198515, -154.915832519531, -2.70379134093392, 218, 15, 'PPL', 'P'),
(182052, 'Hawaiian Gardens', 33.8313903808594, 0.590469152673535, -118.071937561035, -2.06074406464923, 218, 6, 'PPL', 'P'),
(211447, 'Hawaiian Ocean View', 19.0686092376709, 0.332810014973563, -155.764999389648, -2.71861209871632, 218, 15, 'PPL', 'P'),
(211446, 'Hawaiian Ocean View Estates', 19.1124992370605, 0.333576039971611, -155.77082824707, -2.71871383146996, 218, 15, 'PPL', 'P'),
(211448, 'Hawaiian Paradise Park', 19.5013904571533, 0.340363472194328, -154.970565795898, -2.70474661681693, 218, 15, 'PPL', 'P'),
(211450, 'Hawaiian Ranchos', 19.059440612793, 0.332649992281563, -155.779998779297, -2.71887388745148, 218, 15, 'PPL', 'P'),
(211449, 'Hawaiian Village', 20.9058303833008, 0.364875573052067, -156.417221069336, -2.72999551447976, 218, 15, 'PPL', 'P'),
(178340, 'Hawaiian Village Mobile Home Park', 33.4544410705566, 0.58389014609563, -111.839996337891, -1.95197617151459, 218, 5, 'PPL', 'P'),
(211444, 'Hawaiian-Spanish Village', 20.9088897705078, 0.364928969431923, -156.374725341797, -2.72925382411617, 218, 15, 'PPL', 'P'),
(115979, 'Hawarden', 42.9958305358887, 0.750418807480775, -96.4850006103516, -1.68398093943937, 218, 16, 'PPL', 'P'),
(47943, 'Hawbottom', 39.4736099243164, 0.688944460827231, -77.508056640625, -1.35277078520116, 218, 25, 'PPL', 'P'),
(47948, 'Hawbottom Heights', 39.4741706848145, 0.688954247944237, -77.5069427490234, -1.3527513441252, 218, 25, 'PPL', 'P'),
(94788, 'Hawdon', 29.478609085083, 0.514498787443012, -95.4722213745117, -1.66630460717814, 218, 51, 'PPL', 'P'),
(9383, 'Hawes', 34.5499992370605, 0.603011243248235, -93.1547164916992, -1.62585651654201, 218, 4, 'PPL', 'P'),
(182054, 'Hawes', 38.0941696166992, 0.664868685624588, -121.246109008789, -2.11614380743533, 218, 6, 'PPL', 'P'),
(182055, 'Hawes (historical)', 34.9397201538086, 0.60981315640938, -117.362777709961, -2.04836689032503, 218, 6, 'PPL', 'P'),
(36324, 'Hawesville', 37.9000015258789, 0.661479813137462, -86.754997253418, -1.51416034463078, 218, 21, 'PPL', 'P'),
(65435, 'Hawfields', 36.0591697692871, 0.629351238009664, -79.3052825927734, -1.38413829546844, 218, 33, 'PPL', 'P'),
(195067, 'Hawgood', 43.8697204589844, 0.765671063938795, -112.15055847168, -1.95739650328123, 218, 17, 'PPL', 'P'),
(211454, 'Hawi', 20.2413902282715, 0.353278904664344, -155.832778930664, -2.71979507487254, 218, 15, 'PPL', 'P'),
(135836, 'Hawick', 45.3477783203125, 0.791468040153957, -94.8269424438477, -1.6550423652443, 218, 28, 'PPL', 'P'),
(3012, 'Hawk', 33.434440612793, 0.583541072255748, -85.3686065673828, -1.48996326244048, 218, 2, 'PPL', 'P'),
(32712, 'Hawk', 37.1124992370605, 0.64773530533059, -97.9749984741211, -1.70998630800983, 218, 20, 'PPL', 'P'),
(65436, 'Hawk', 36.0188903808594, 0.62864823006091, -82.091667175293, -1.43276988066022, 218, 33, 'PPL', 'P'),
(102668, 'Hawk', 37.4097213745117, 0.652922810238928, -78.3563919067383, -1.36757702875562, 218, 53, 'PPL', 'P'),
(65437, 'Hawk Branch', 35.9638900756836, 0.627688293645991, -82.3716735839844, -1.43765691441857, 218, 33, 'PPL', 'P'),
(94789, 'Hawk Cove', 32.8838882446289, 0.573932120726633, -96.0808334350586, -1.67692689150203, 218, 51, 'PPL', 'P'),
(209973, 'Hawk Inlet', 58.1258316040039, 1.01448714194965, -134.753067016602, -2.35188469660027, 218, 1, 'PPL', 'P'),
(55213, 'Hawk Point', 38.9708290100098, 0.680169278456393, -91.1311111450195, -1.59053794048149, 218, 29, 'PPL', 'P'),
(3013, 'Hawk Pride', 34.6855583190918, 0.605377195560662, -87.8038864135742, -1.53246691396399, 218, 2, 'PPL', 'P'),
(182056, 'Hawk Ravine (historical)', 39.5144386291504, 0.689657056155909, -121.438056945801, -2.11949393092859, 218, 6, 'PPL', 'P'),
(162515, 'Hawk Run', 40.9238891601563, 0.714256608565944, -78.2063903808594, -1.36495900824602, 218, 45, 'PPL', 'P'),
(209499, 'Hawk Springs', 41.7861099243164, 0.7293051997796, -104.264167785645, -1.8197530197113, 218, 59, 'PPL', 'P'),
(72859, 'Hawk Subdivision', 38.8252792358398, 0.677628955671593, -82.245002746582, -1.43544609123964, 218, 41, 'PPL', 'P'),
(60201, 'Hawkes', 31.7547206878662, 0.554224429054424, -89.0761108398438, -1.55467141902668, 218, 30, 'PPL', 'P'),
(47945, 'Hawkeye', 38.559440612793, 0.672989196420457, -75.9191665649414, -1.32503942192822, 218, 25, 'PPL', 'P'),
(55214, 'Hawkeye', 38.0055618286133, 0.663322187979579, -92.3927764892578, -1.61255815479676, 218, 29, 'PPL', 'P'),
(115980, 'Hawkeye', 42.9386100769043, 0.749420122071996, -91.9499969482422, -1.60483019394556, 218, 16, 'PPL', 'P'),
(149528, 'Hawkeye', 44.5194396972656, 0.777010803860353, -73.8594436645508, -1.28909047563768, 218, 40, 'PPL', 'P'),
(162516, 'Hawkeye', 40.121940612793, 0.700259965982869, -79.5927810668945, -1.38915609043631, 218, 45, 'PPL', 'P'),
(209500, 'Hawkeye', 44.1436080932617, 0.770451304937433, -109.623062133789, -1.91328337035294, 218, 59, 'PPL', 'P'),
(209884, 'Hawkeye', 47.997501373291, 0.837714431694428, -102.877502441406, -1.79555114383104, 218, 34, 'PPL', 'P'),
(131250, 'Hawkhead', 42.4694404602051, 0.741231567510274, -86.2072219848633, -1.50459986263351, 218, 27, 'PPL', 'P'),
(9384, 'Hawkins', 35.0602798461914, 0.611917319986651, -90.9219436645508, -1.58688727925921, 218, 4, 'PPL', 'P'),
(21785, 'Hawkins', 34.6041717529297, 0.603956732014241, -85.3744430541992, -1.49006512835218, 218, 13, 'PPL', 'P'),
(36325, 'Hawkins', 37.0291709899902, 0.646280953059298, -87.6505584716797, -1.52979083654262, 218, 21, 'PPL', 'P'),
(94790, 'Hawkins', 32.5883293151855, 0.568773644274177, -95.2038879394531, -1.66162130524318, 218, 51, 'PPL', 'P'),
(127712, 'Hawkins', 46.3783302307129, 0.809454564103161, -68.2822189331055, -1.1917495409503, 218, 26, 'PPL', 'P'),
(131251, 'Hawkins', 43.8005599975586, 0.764463986174717, -85.6030578613281, -1.49405520945539, 218, 27, 'PPL', 'P'),
(174449, 'Hawkins', 45.5149993896484, 0.794386598392575, -90.7197189331055, -1.58335779186653, 218, 57, 'PPL', 'P'),
(178341, 'Hawkins', 34.267219543457, 0.598075806537073, -112.901672363281, -1.97050591374715, 218, 5, 'PPL', 'P'),
(186827, 'Hawkins', 38.4938888549805, 0.671845102416159, -102.931938171387, -1.79650122654993, 218, 7, 'PPL', 'P'),
(195068, 'Hawkins', 42.5436096191406, 0.742526063537135, -112.34139251709, -1.96072718569854, 218, 17, 'PPL', 'P'),
(182057, 'Hawkins (historical)', 36.2205581665039, 0.632167996915614, -119.068328857422, -2.07813437340939, 218, 6, 'PPL', 'P'),
(193626, 'Hawkins Bar', 40.8702812194824, 0.713320973495971, -123.521667480469, -2.15585979508779, 218, 6, 'PPL', 'P'),
(149530, 'Hawkins Corner', 43.2844390869141, 0.755455976945578, -75.4713897705078, -1.31722424255133, 218, 40, 'PPL', 'P'),
(174450, 'Hawkins Corner', 44.5180587768555, 0.776986702252488, -92.165283203125, -1.60858764792756, 218, 57, 'PPL', 'P'),
(21786, 'Hawkins Crossroads', 32.7616691589355, 0.571798995272507, -84.6083297729492, -1.47669392915111, 218, 13, 'PPL', 'P'),
(3014, 'Hawkins Ford', 33.9575004577637, 0.592670188735458, -88.0774993896484, -1.53724236127266, 218, 2, 'PPL', 'P'),
(119960, 'Hawkins Glen', 41.9461097717285, 0.73209772391963, -88.3619384765625, -1.54220675986068, 218, 18, 'PPL', 'P'),
(65438, 'Hawkins Landing', 35.4519386291504, 0.618753055293639, -76.852783203125, -1.34133410621593, 218, 33, 'PPL', 'P'),
(102669, 'Hawkins Mill', 36.8080596923828, 0.642421832902691, -82.1774978637695, -1.43426790877338, 218, 53, 'PPL', 'P'),
(21787, 'Hawkinstown', 31.2630596160889, 0.545643324548025, -84.4499969482422, -1.47393050004599, 218, 13, 'PPL', 'P'),
(102670, 'Hawkinstown', 38.7724990844727, 0.676707768250535, -78.6133270263672, -1.37206139255715, 218, 53, 'PPL', 'P'),
(3015, 'Hawkinsville', 32.0341682434082, 0.559101708985281, -85.227783203125, -1.48750543107045, 218, 2, 'PPL', 'P'),
(21788, 'Hawkinsville', 32.2836112976074, 0.563455311577288, -83.4722213745117, -1.45686509693882, 218, 13, 'PPL', 'P'),
(87643, 'Hawkinsville', 35.9083290100098, 0.626718570114066, -89.2838897705078, -1.55829784548305, 218, 50, 'PPL', 'P'),
(94791, 'Hawkinsville', 28.8875007629395, 0.504182000985667, -95.6694412231445, -1.66974674288706, 218, 51, 'PPL', 'P'),
(149531, 'Hawkinsville', 43.4936103820801, 0.759106704746886, -75.2774963378906, -1.31384016375417, 218, 40, 'PPL', 'P'),
(193627, 'Hawkinsville', 41.7608299255371, 0.728863980566001, -122.620826721191, -2.14013715780223, 218, 6, 'PPL', 'P'),
(3016, 'Hawkinsville (historical)', 33.0744400024414, 0.577257876295924, -87.0352783203125, -1.51905217207909, 218, 2, 'PPL', 'P'),
(72860, 'Hawks', 39.1113891601563, 0.682622515873546, -82.3872222900391, -1.43792829053364, 218, 41, 'PPL', 'P'),
(131252, 'Hawks', 45.3019409179688, 0.790668026562497, -83.8874969482422, -1.46411302300352, 218, 27, 'PPL', 'P'),
(94792, 'Hawks Addition Colonia', 27.7360000610352, 0.484084522398412, -98.0879974365234, -1.71195851195509, 218, 51, 'PPL', 'P'),
(109594, 'Hawks Nest', 38.1158294677734, 0.665246721341324, -81.1172180175781, -1.41576253446481, 218, 58, 'PPL', 'P'),
(113541, 'Hawks Nest', 41.2700004577637, 0.720297390287543, -72.4691696166992, -1.26482561599764, 218, 8, 'PPL', 'P'),
(113542, 'Hawks Nest Beach', 41.2833290100098, 0.720530017408762, -72.2838897705078, -1.26159187264401, 218, 8, 'PPL', 'P'),
(65440, 'Hawkside', 34.7700004577637, 0.606850988907912, -77.4024963378906, -1.35092841035904, 218, 33, 'PPL', 'P'),
(78437, 'Hawksville', 39.9102783203125, 0.696565762076765, -76.1647186279297, -1.32932511391243, 218, 45, 'PPL', 'P'),
(76047, 'Hawley', 36.753059387207, 0.641461896487772, -98.0188903808594, -1.71075236629739, 218, 42, 'PPL', 'P'),
(94796, 'Hawley', 32.6119384765625, 0.569185701873839, -99.8138885498047, -1.74208099441276, 218, 51, 'PPL', 'P'),
(115981, 'Hawley', 43.2127799987793, 0.75420528991865, -93.679443359375, -1.63501472805663, 218, 16, 'PPL', 'P'),
(125049, 'Hawley', 42.5644416809082, 0.742889651604958, -72.8783264160156, -1.27196674930263, 218, 23, 'PPL', 'P'),
(135838, 'Hawley', 46.8808288574219, 0.818224819625983, -96.3163909912109, -1.68103814643484, 218, 28, 'PPL', 'P'),
(162517, 'Hawley', 41.475830078125, 0.723889794860978, -75.182502746582, -1.31218221281754, 218, 45, 'PPL', 'P'),
(182058, 'Hawley', 39.8108291625977, 0.694830046836306, -120.353889465332, -2.10057163875136, 218, 6, 'PPL', 'P'),
(186828, 'Hawley', 37.982780456543, 0.66292457802883, -103.710563659668, -1.81009080496039, 218, 7, 'PPL', 'P'),
(195069, 'Hawley', 42.7341690063477, 0.74585195226448, -113.394996643066, -1.97911604670943, 218, 17, 'PPL', 'P'),
(207615, 'Hawley', 47.627498626709, 0.83125666552515, -122.505279541016, -2.13812047906677, 218, 56, 'PPL', 'P'),
(55215, 'Hawley (historical)', 37.1688919067383, 0.648719543090456, -92.3483276367188, -1.61178237597122, 218, 29, 'PPL', 'P'),
(119961, 'Hawley (historical)', 40.5138893127441, 0.707100761295928, -89.6444396972656, -1.56459062882279, 218, 18, 'PPL', 'P'),
(149532, 'Hawley Corners', 42.5397186279297, 0.742458152929338, -75.5088882446289, -1.31787871438922, 218, 40, 'PPL', 'P'),
(16382, 'Hawley Heights', 25.6608295440674, 0.447865964337011, -80.3447189331055, -1.40227988197212, 218, 12, 'PPL', 'P'),
(178342, 'Hawley Lake', 33.9838905334473, 0.593130782445987, -109.746391296387, -1.915435870304, 218, 5, 'PPL', 'P'),
(149533, 'Hawleys', 42.1819381713867, 0.736213705963374, -75.0130615234375, -1.30922490558506, 218, 40, 'PPL', 'P'),
(195070, 'Hawleys Landing', 47.3558311462402, 0.826515173520372, -116.766670227051, -2.03796285205247, 218, 17, 'PPL', 'P'),
(149534, 'Hawleyton', 42.0186080932617, 0.733363058332554, -75.916389465332, -1.32499095239638, 218, 40, 'PPL', 'P'),
(113548, 'Hawleyville', 41.4275016784668, 0.723046305164723, -73.3555603027344, -1.28029605192796, 218, 8, 'PPL', 'P'),
(115982, 'Hawleyville', 40.776668548584, 0.711687124167208, -94.9361114501953, -1.6569477238462, 218, 16, 'PPL', 'P'),
(102671, 'Hawlin', 38.5955581665039, 0.673619566650479, -78.2083282470703, -1.36499283039186, 218, 53, 'PPL', 'P'),
(47946, 'Hawlings Hills', 39.1791687011719, 0.68380549202976, -77.0274963378906, -1.34438342566407, 218, 25, 'PPL', 'P'),
(47947, 'Hawlings Meadow', 39.2055587768555, 0.684266085740289, -77.0844421386719, -1.34537731738288, 218, 25, 'PPL', 'P'),
(47959, 'Hawlings River Estates', 39.1966705322266, 0.684110956606792, -77.0469436645508, -1.344722845545, 218, 25, 'PPL', 'P'),
(47949, 'Hawlings View', 39.1991691589355, 0.684154565869642, -77.0286102294922, -1.34440286674002, 218, 25, 'PPL', 'P'),
(76048, 'Haworth', 33.8463897705078, 0.590730941408689, -94.6524963378906, -1.65199770632807, 218, 42, 'PPL', 'P'),
(112305, 'Haworth', 39.8250007629395, 0.695077387922547, -97.3874969482422, -1.69973247202276, 218, 20, 'PPL', 'P'),
(145392, 'Haworth', 40.9608306884766, 0.714901359865852, -73.9905624389648, -1.29137892996238, 218, 37, 'PPL', 'P'),
(3017, 'Haworth (historical)', 34.1363906860352, 0.595792412218439, -86.0533294677734, -1.50191393151611, 218, 2, 'PPL', 'P'),
(65441, 'Hawra', 35.6427803039551, 0.622083870869001, -78.0888900756836, -1.3629082410486, 218, 33, 'PPL', 'P'),
(87644, 'Haws Crossroads', 36.3824996948242, 0.634994409780515, -82.6166687011719, -1.4419328858648, 218, 50, 'PPL', 'P'),
(65442, 'Haws Run', 34.6944389343262, 0.605532191536104, -77.5527801513672, -1.35355135771666, 218, 33, 'PPL', 'P'),
(162523, 'Hawstone', 40.5950012207031, 0.708516431152387, -77.498893737793, -1.3526108623777, 218, 45, 'PPL', 'P'),
(9385, 'Hawthicket (historical)', 35.1911087036133, 0.614200714305285, -92.1500015258789, -1.60832093234439, 218, 4, 'PPL', 'P'),
(3018, 'Hawthorn', 31.3330593109131, 0.546865049698099, -88.0883331298828, -1.53743144571006, 218, 2, 'PPL', 'P'),
(47950, 'Hawthorn', 39.2024993896484, 0.684212689360433, -76.8819427490234, -1.34184303630024, 218, 25, 'PPL', 'P'),
(162521, 'Hawthorn', 41.0200004577637, 0.715934067157557, -79.2747192382813, -1.3836048643021, 218, 45, 'PPL', 'P'),
(30038, 'Hawthorn Hills', 39.9444389343262, 0.697161977265807, -85.9802780151367, -1.50063894314423, 218, 19, 'PPL', 'P'),
(47951, 'Hawthorn North', 39.209171295166, 0.684329136079096, -76.8836135864258, -1.34187219791418, 218, 25, 'PPL', 'P'),
(119963, 'Hawthorn Woods', 42.2169418334961, 0.736824635117439, -88.0494384765625, -1.5367526059482, 218, 18, 'PPL', 'P'),
(13124, 'Hawthorne', 38.980281829834, 0.680334261285923, -77.0550003051758, -1.34486346045055, 218, 9, 'PPL', 'P'),
(16384, 'Hawthorne', 28.7611103057861, 0.501976071365241, -81.8711090087891, -1.42892041446256, 218, 12, 'PPL', 'P'),
(32714, 'Hawthorne', 39.476390838623, 0.688992996938098, -95.2138900756836, -1.66179587545263, 218, 20, 'PPL', 'P'),
(36326, 'Hawthorne', 38.9805603027344, 0.680339121554912, -84.420280456543, -1.4734118494237, 218, 21, 'PPL', 'P'),
(41283, 'Hawthorne', 31.1841697692871, 0.544266436974941, -93.288330078125, -1.62818851355054, 218, 22, 'PPL', 'P'),
(47954, 'Hawthorne', 38.5402793884277, 0.672654769966571, -77.0116729736328, -1.34410725585902, 218, 25, 'PPL', 'P'),
(60204, 'Hawthorne', 30.6497192382813, 0.534938515519856, -89.6425018310547, -1.56455680667695, 218, 30, 'PPL', 'P'),
(65443, 'Hawthorne', 35.5933303833008, 0.621220806938734, -82.5116729736328, -1.44010036471871, 218, 33, 'PPL', 'P'),
(87646, 'Hawthorne', 35.3711090087891, 0.617342312285197, -86.4986114501953, -1.50968556820918, 218, 50, 'PPL', 'P'),
(94794, 'Hawthorne', 30.5344390869141, 0.532926497316301, -95.3949966430664, -1.66495678135045, 218, 51, 'PPL', 'P'),
(102672, 'Hawthorne', 36.9413909912109, 0.644748903063203, -82.600830078125, -1.44165644974365, 218, 53, 'PPL', 'P'),
(115983, 'Hawthorne', 41.0016708374023, 0.715614154931612, -95.336669921875, -1.66393878802376, 218, 16, 'PPL', 'P'),
(131253, 'Hawthorne', 42.7733306884766, 0.746535452558249, -82.4727783203125, -1.43942152495685, 218, 27, 'PPL', 'P'),
(145394, 'Hawthorne', 40.9491691589355, 0.714697827779542, -74.154167175293, -1.29423437128317, 218, 37, 'PPL', 'P'),
(149535, 'Hawthorne', 41.1072196960449, 0.717456330036647, -73.79638671875, -1.2879899243172, 218, 40, 'PPL', 'P'),
(174453, 'Hawthorne', 46.503059387207, 0.811631498557219, -91.8605575561523, -1.60326918207261, 218, 57, 'PPL', 'P'),
(182059, 'Hawthorne', 33.916389465332, 0.591952666558763, -118.351669311523, -2.06562630471761, 218, 6, 'PPL', 'P'),
(190292, 'Hawthorne', 38.5247192382813, 0.67238319411441, -118.623611450195, -2.07037259041235, 218, 39, 'PPL', 'P'),
(200954, 'Hawthorne', 43.4563903808594, 0.758457093177989, -123.079719543457, -2.14814634846454, 218, 43, 'PPL', 'P'),
(81467, 'Hawthorne (historical)', 33.3333282470703, 0.581776328559407, -81.6999969482422, -1.42593394561615, 218, 48, 'PPL', 'P'),
(47955, 'Hawthorne Acres', 39.3708305358887, 0.687150622095981, -77.1916732788086, -1.34724885383894, 218, 25, 'PPL', 'P'),
(177230, 'Hawthorne Court', 40.0819396972656, 0.699561818303104, -80.6938934326172, -1.4083741266526, 218, 58, 'PPL', 'P'),
(47956, 'Hawthorne Estates', 39.3913917541504, 0.687509483052869, -77.1847229003906, -1.34712754685128, 218, 25, 'PPL', 'P'),
(149537, 'Hawthorne Hill', 42.797779083252, 0.746962157543907, -73.8805618286133, -1.28945905713254, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(122791, 'Hawthorne Hills', 41.394718170166, 0.722474125004519, -87.3791732788086, -1.52505427138586, 218, 19, 'PPL', 'P'),
(47957, 'Hawthorne Manor', 38.5341682434082, 0.672548110364913, -77.0152816772461, -1.34417023961881, 218, 25, 'PPL', 'P'),
(145395, 'Hawthorne Park', 40.038330078125, 0.69880068686356, -74.8730621337891, -1.30678145528491, 218, 37, 'PPL', 'P'),
(27399, 'Hawthorne Place', 39.7811088562012, 0.694311329634986, -89.6552810668945, -1.56477984641824, 218, 18, 'PPL', 'P'),
(94795, 'Hawthorne Place', 29.8569393157959, 0.521101895628781, -95.3644409179688, -1.66442348334216, 218, 51, 'PPL', 'P'),
(113543, 'Hawthorne Terrace', 41.4588890075684, 0.723594117400952, -73.4305572509766, -1.28160499560374, 218, 8, 'PPL', 'P'),
(47958, 'Hawthorne Woods', 38.8722190856934, 0.678448210601929, -76.665283203125, -1.33806161386844, 218, 25, 'PPL', 'P'),
(30039, 'Hawton', 39.1263885498047, 0.682884304608701, -87.3111114501953, -1.52386636838163, 218, 19, 'PPL', 'P'),
(149536, 'Hawversville', 42.5144386291504, 0.742016933715739, -74.2430572509766, -1.29578579577619, 218, 40, 'PPL', 'P'),
(196680, 'Haxby', 47.7700004577637, 0.833743791667174, -106.426666259766, -1.85749573815407, 218, 31, 'PPL', 'P'),
(194228, 'Haxtun', 40.6411094665527, 0.709321171854782, -102.626388549805, -1.7911683796251, 218, 7, 'PPL', 'P'),
(207617, 'Hay', 46.6788902282715, 0.814700325660345, -117.91471862793, -2.05800007662006, 218, 56, 'PPL', 'P'),
(127713, 'Hay Brook', 45.7655601501465, 0.798759708639567, -68.5741729736328, -1.196845100222, 218, 26, 'PPL', 'P'),
(196681, 'Hay Coulee (historical)', 48.3069381713867, 0.843115122648027, -110.818893432617, -1.93415456381589, 218, 31, 'PPL', 'P'),
(135842, 'Hay Creek', 44.4919395446777, 0.776530835652893, -92.5436096191406, -1.6151906895343, 218, 28, 'PPL', 'P'),
(174455, 'Hay Creek', 44.6222190856934, 0.778804642591603, -91.0747222900391, -1.58955376930065, 218, 57, 'PPL', 'P'),
(65444, 'Hay Meadow (historical)', 36.2683296203613, 0.63300176607389, -81.1627807617188, -1.4165577543663, 218, 33, 'PPL', 'P'),
(13903, 'Hay Point Landing', 39.351390838623, 0.686811335373105, -75.5486068725586, -1.31857193522096, 218, 10, 'PPL', 'P'),
(102675, 'Hay Run', 36.9919395446777, 0.645631141753318, -79.9466705322266, -1.39533262679448, 218, 53, 'PPL', 'P'),
(199385, 'Hay Springs', 42.6838912963867, 0.744974440685299, -102.689437866211, -1.79226879778752, 218, 35, 'PPL', 'P'),
(174457, 'Hay Stack Corner', 45.648609161377, 0.796718528822075, -90.8755569458008, -1.58607767828783, 218, 57, 'PPL', 'P'),
(194229, 'Haybro', 40.332218170166, 0.70393000170208, -106.958892822266, -1.86678484403627, 218, 7, 'PPL', 'P'),
(102673, 'Haycock', 36.8727798461914, 0.643551412679048, -80.2705612182617, -1.40098558568234, 218, 53, 'PPL', 'P'),
(211869, 'Haycock', 65.209716796875, 1.13812426239852, -161.165557861328, -2.81286962549361, 218, 1, 'PPL', 'P'),
(195072, 'Haycrop', 47.7663917541504, 0.833680807907394, -116.892776489258, -2.04016382153537, 218, 17, 'PPL', 'P'),
(41284, 'Haydel (historical)', 30.0227794647217, 0.523996352259534, -90.6166687011719, -1.58155922602434, 218, 22, 'PPL', 'P'),
(3019, 'Hayden', 33.8925018310547, 0.591535748690111, -86.7577819824219, -1.51420894732068, 218, 2, 'PPL', 'P'),
(30040, 'Hayden', 38.9830589294434, 0.680382730817762, -85.7405624389648, -1.49645511707172, 218, 19, 'PPL', 'P'),
(32716, 'Hayden', 37.4277801513672, 0.653237995353939, -95.2608337402344, -1.66261519696199, 218, 20, 'PPL', 'P'),
(47960, 'Hayden', 39.0780601501465, 0.682040814912446, -75.976936340332, -1.32604769471693, 218, 25, 'PPL', 'P'),
(55216, 'Hayden', 38.0750007629395, 0.664534126012646, -91.9766693115234, -1.60529571450411, 218, 29, 'PPL', 'P'),
(113544, 'Hayden', 41.8891716003418, 0.731103965358867, -72.6297225952148, -1.26762779409662, 218, 8, 'PPL', 'P'),
(155672, 'Hayden', 40.0588912963867, 0.699159547820448, -83.1969375610352, -1.4520604880162, 218, 41, 'PPL', 'P'),
(178343, 'Hayden', 33.0047187805176, 0.576041011414839, -110.784721374512, -1.93355814888977, 218, 5, 'PPL', 'P'),
(182060, 'Hayden', 35.0447196960449, 0.61164574413449, -115.610282897949, -2.01778008573131, 218, 6, 'PPL', 'P'),
(188669, 'Hayden', 35.9683303833008, 0.627765791633713, -103.271110534668, -1.80242090102096, 218, 38, 'PPL', 'P'),
(194230, 'Hayden', 40.4919395446777, 0.70671766557312, -107.256942749023, -1.87198679659352, 218, 7, 'PPL', 'P'),
(195071, 'Hayden', 47.7661094665527, 0.833675881059378, -116.78556060791, -2.03829255139542, 218, 17, 'PPL', 'P'),
(204240, 'Hayden', 40.4327812194824, 0.705685158018496, -109.972503662109, -1.91938227556533, 218, 52, 'PPL', 'P'),
(109593, 'Hayden (historical)', 39.5166702270508, 0.689696004886851, -79.626106262207, -1.38973772481839, 218, 58, 'PPL', 'P'),
(47961, 'Hayden Acres', 38.4513893127441, 0.671103345473545, -75.5124969482422, -1.317941698149, 218, 25, 'PPL', 'P'),
(127714, 'Hayden Corner', 44.5247192382813, 0.77710294923407, -69.6194381713867, -1.21508841947932, 218, 26, 'PPL', 'P'),
(193628, 'Hayden Hill', 40.9955596923828, 0.715507495329954, -120.886108398438, -2.1098606114755, 218, 6, 'PPL', 'P'),
(178344, 'Hayden Junction', 33.0097198486328, 0.576128296519567, -110.814720153809, -1.93408172636008, 218, 5, 'PPL', 'P'),
(195073, 'Hayden Lake', 47.7588882446289, 0.833549846960789, -116.755828857422, -2.03777363445702, 218, 17, 'PPL', 'P'),
(127715, 'Hayden Landing', 45.3074989318848, 0.790765032205203, -70.1788864135742, -1.22485263329999, 218, 26, 'PPL', 'P'),
(13904, 'Hayden Park', 39.7061080932617, 0.693002319380185, -75.5950012207031, -1.3193816693504, 218, 10, 'PPL', 'P'),
(125051, 'Hayden Row', 42.2041702270508, 0.736601728534199, -71.5111083984375, -1.2481042933033, 218, 23, 'PPL', 'P'),
(87645, 'Haydenburg', 36.4205589294434, 0.635658668735408, -85.7433319091797, -1.4965034534455, 218, 50, 'PPL', 'P'),
(78439, 'Haydentown', 39.788890838623, 0.69444715085058, -79.7708282470703, -1.39226359995427, 218, 45, 'PPL', 'P'),
(72861, 'Haydenville', 39.4819412231445, 0.689089869422749, -82.3283309936523, -1.43690044351093, 218, 41, 'PPL', 'P'),
(76050, 'Haydenville', 35.5952796936035, 0.62125482882166, -96.2633285522461, -1.68011203216576, 218, 42, 'PPL', 'P'),
(125052, 'Haydenville', 42.375, 0.739583270532597, -72.7013931274414, -1.26887868086063, 218, 23, 'PPL', 'P'),
(135845, 'Haydenville', 45.0094413757324, 0.785562946489897, -96.309440612793, -1.68091683944718, 218, 28, 'PPL', 'P'),
(149538, 'Haydenville', 42.1113891601563, 0.734982393433376, -78.3752822875977, -1.36790672809857, 218, 40, 'PPL', 'P'),
(55217, 'Haydite', 39.497501373291, 0.68936144527491, -94.8016662597656, -1.65460121260973, 218, 29, 'PPL', 'P'),
(202199, 'Haydraw', 44.4449996948242, 0.775711580722558, -102.721389770508, -1.79282646371978, 218, 49, 'PPL', 'P'),
(174458, 'Hayen', 43.8491706848145, 0.765312402718989, -87.7458267211914, -1.53145358116921, 218, 57, 'PPL', 'P'),
(3020, 'Hayes', 31.5027809143066, 0.549827250489081, -85.0727767944336, -1.48480005887709, 218, 2, 'PPL', 'P'),
(21789, 'Hayes', 34.3569412231445, 0.59964174525804, -83.8180618286133, -1.46290115154948, 218, 13, 'PPL', 'P'),
(27401, 'Hayes', 39.8624992370605, 0.695731859760434, -88.2811126708984, -1.54079608343126, 218, 18, 'PPL', 'P'),
(36327, 'Hayes', 38.648609161377, 0.674545481182472, -84.3658294677734, -1.4724615003887, 218, 21, 'PPL', 'P'),
(41285, 'Hayes', 30.1086101531982, 0.525494380372704, -92.9199981689453, -1.6217599089952, 218, 22, 'PPL', 'P'),
(65446, 'Hayes', 35.9724998474121, 0.627838562510499, -78.8644409179688, -1.37644415676309, 218, 33, 'PPL', 'P'),
(102674, 'Hayes', 37.2780609130859, 0.650624901692353, -76.5041732788086, -1.33524971523148, 218, 53, 'PPL', 'P'),
(174459, 'Hayes', 44.9997215270996, 0.785393303128459, -88.4227828979492, -1.54326869534535, 218, 57, 'PPL', 'P'),
(182061, 'Hayes', 34.0741691589355, 0.594706441704932, -118.021942138672, -2.05987147991806, 218, 6, 'PPL', 'P'),
(202200, 'Hayes', 44.3702812194824, 0.774407497315773, -101.021110534668, -1.76315099285109, 218, 49, 'PPL', 'P'),
(207618, 'Hayes', 45.9316711425781, 0.801658892381254, -122.676109313965, -2.14110202106517, 218, 56, 'PPL', 'P'),
(199386, 'Hayes Center', 40.5108299255371, 0.707047364916072, -101.019172668457, -1.76311717070524, 218, 35, 'PPL', 'P'),
(143945, 'Hayes Corner', 43.4083290100098, 0.757618264013641, -71.0250015258789, -1.23962012786058, 218, 36, 'PPL', 'P'),
(155674, 'Hayes Corners', 41.4588890075684, 0.723594117400952, -81.0227813720703, -1.41411430406616, 218, 41, 'PPL', 'P'),
(3022, 'Hayes Crossing', 33.6983299255371, 0.588146809623958, -87.438606262207, -1.52609157263044, 218, 2, 'PPL', 'P'),
(21797, 'Hayes Crossing', 34.5311088562012, 0.602681543905284, -83.293327331543, -1.45374280687681, 218, 13, 'PPL', 'P'),
(60206, 'Hayes Crossing', 34.4494400024414, 0.601256153510846, -89.7613906860352, -1.56663180864029, 218, 30, 'PPL', 'P'),
(81468, 'Hayes Crossroads', 33.0699996948242, 0.577180378308203, -81.2752838134766, -1.41852130303802, 218, 48, 'PPL', 'P'),
(3023, 'Hayes Highland', 33.5777816772461, 0.586042845783768, -86.8311080932617, -1.51548872938251, 218, 2, 'PPL', 'P'),
(47963, 'Hayes Landing', 38.2686080932617, 0.667913211382766, -75.1977767944336, -1.31244879524265, 218, 25, 'PPL', 'P'),
(81469, 'Hayestown', 34.3472213745117, 0.599472101896602, -79.2525024414063, -1.38321710804738, 218, 48, 'PPL', 'P'),
(113545, 'Hayestown', 41.4199981689453, 0.722915344218118, -73.4541702270508, -1.28201711978243, 218, 8, 'PPL', 'P'),
(65448, 'Hayesville', 35.0461082458496, 0.61166997890041, -83.8180618286133, -1.46290115154948, 218, 33, 'PPL', 'P'),
(78441, 'Hayesville', 39.8202781677246, 0.694994963086809, -75.9649963378906, -1.32583930236163, 218, 45, 'PPL', 'P'),
(87648, 'Hayesville', 36.6336097717285, 0.639377107407431, -86.0944366455078, -1.50263138711377, 218, 50, 'PPL', 'P'),
(115987, 'Hayesville', 41.2644386291504, 0.72020031806581, -92.248893737793, -1.61004692704687, 218, 16, 'PPL', 'P'),
(155676, 'Hayesville', 40.7730598449707, 0.711624140407428, -82.2624969482422, -1.43575142265861, 218, 41, 'PPL', 'P'),
(200955, 'Hayesville', 44.9861106872559, 0.785155749159224, -122.981666564941, -2.14643500114805, 218, 43, 'PPL', 'P'),
(102677, 'Hayfield', 39.2341690063477, 0.684765428444679, -78.2900009155273, -1.36641828736533, 218, 53, 'PPL', 'P'),
(115988, 'Hayfield', 43.1766700744629, 0.753575052846683, -93.6949996948242, -1.63528623732977, 218, 16, 'PPL', 'P'),
(135847, 'Hayfield', 43.8905601501465, 0.766034785164673, -92.8475036621094, -1.6204946411613, 218, 28, 'PPL', 'P'),
(182062, 'Hayfield', 33.704719543457, 0.588258329494605, -115.633613586426, -2.01818728306198, 218, 6, 'PPL', 'P'),
(115989, 'Hayfield Junction', 43.1338882446289, 0.752828369056052, -93.5991668701172, -1.63361363900714, 218, 16, 'PPL', 'P'),
(207619, 'Hayford', 47.6063919067383, 0.830888283767364, -117.562782287598, -2.05185762872385, 218, 56, 'PPL', 'P'),
(127718, 'Hayford Corner', 44.4111099243164, 0.775120092644451, -69.0722198486328, -1.20553765802002, 218, 26, 'PPL', 'P'),
(94797, 'Hayford Crossing', 33.0597190856934, 0.577000947829759, -99.3566665649414, -1.73410096536439, 218, 51, 'PPL', 'P'),
(193629, 'Hayfork', 40.5544395446777, 0.707808496355616, -123.181938171387, -2.14993040007878, 218, 6, 'PPL', 'P'),
(149539, 'Hayground', 40.9263916015625, 0.714300284407821, -72.3333282470703, -1.2624547368372, 218, 40, 'PPL', 'P'),
(142015, 'Hayland', 40.6647186279297, 0.709733229454444, -98.5869369506836, -1.72066664924549, 218, 35, 'PPL', 'P'),
(9386, 'Hayley', 34.9958305358887, 0.610792467321229, -91.6547164916992, -1.5996765777621, 218, 4, 'PPL', 'P'),
(21790, 'Haylow', 30.8258304595947, 0.538012236181485, -82.9052810668945, -1.44697012190863, 218, 13, 'PPL', 'P'),
(162525, 'Haymaker', 41.9980583190918, 0.733004397112747, -78.4116668701172, -1.3685417588605, 218, 45, 'PPL', 'P'),
(102680, 'Haymakertown', 37.4661102294922, 0.653906981419767, -79.970832824707, -1.3957543383531, 218, 53, 'PPL', 'P'),
(102678, 'Haymarket', 38.811939239502, 0.677396128813293, -77.6366729736328, -1.35501556368399, 218, 53, 'PPL', 'P'),
(36328, 'Haymond', 37.1805610656738, 0.64892320833482, -82.6875, -1.44316912524281, 218, 21, 'PPL', 'P'),
(191591, 'Haymond', 30.1436100006104, 0.526105242947741, -103.018890380859, -1.79801882889711, 218, 51, 'PPL', 'P'),
(65450, 'Haymount', 35.0566711425781, 0.611854336226871, -78.9005584716797, -1.37707452699312, 218, 33, 'PPL', 'P'),
(102679, 'Haymount', 38.2036094665527, 0.66677877133742, -77.2525024414063, -1.3483105230075, 218, 53, 'PPL', 'P'),
(65451, 'Hayne', 34.9808311462402, 0.610530678586074, -78.5902786254883, -1.37165912207449, 218, 33, 'PPL', 'P'),
(187711, 'Hayne', 37.1005592346191, 0.647526912975291, -100.803611755371, -1.75935492303329, 218, 20, 'PPL', 'P'),
(81470, 'Hayne (historical)', 34.3127784729004, 0.598870959859544, -81.4302825927734, -1.42122654207332, 218, 48, 'PPL', 'P'),
(81471, 'Hayne Station', 34.9630584716797, 0.610220486898107, -81.9611129760742, -1.43049128003154, 218, 48, 'PPL', 'P'),
(21791, 'Hayner', 31.1619396209717, 0.54387844769363, -81.7233276367188, -1.42634114294682, 218, 13, 'PPL', 'P'),
(149540, 'Haynersville', 42.7905616760254, 0.746836190024346, -73.5711135864258, -1.28405816644186, 218, 40, 'PPL', 'P'),
(3024, 'Haynes', 32.625560760498, 0.569423455580156, -86.6730575561523, -1.51273022712541, 218, 2, 'PPL', 'P'),
(9387, 'Haynes', 34.8908309936523, 0.608959879596118, -90.7919387817383, -1.58461826601046, 218, 4, 'PPL', 'P'),
(16385, 'Haynes', 30.8683300018311, 0.538753993124099, -84.9574966430664, -1.48278804067354, 218, 12, 'PPL', 'P'),
(27402, 'Haynes', 39.8494415283203, 0.695503959750151, -89.29638671875, -1.55851595837632, 218, 18, 'PPL', 'P'),
(72863, 'Haynes', 39.4347190856934, 0.688265687644397, -82.6791687011719, -1.44302371664729, 218, 41, 'PPL', 'P'),
(87650, 'Haynes', 35.961109161377, 0.627639757535125, -86.5999984741211, -1.51145510559548, 218, 50, 'PPL', 'P'),
(149541, 'Haynes', 42.4669418334961, 0.741187958247424, -75.5461120605469, -1.31852839253714, 218, 40, 'PPL', 'P'),
(198416, 'Haynes', 45.9741706848145, 0.802400649323868, -102.470558166504, -1.78844862636186, 218, 34, 'PPL', 'P'),
(87651, 'Haynes (historical)', 36.3499984741211, 0.634427156468328, -83.6750030517578, -1.46040430486948, 218, 50, 'PPL', 'P'),
(60205, 'Haynes Bluff', 32.5161094665527, 0.567513170130242, -90.7852783203125, -1.58450201902888, 218, 30, 'PPL', 'P'),
(143946, 'Haynes Corner', 42.9769401550293, 0.750089108137823, -70.9219436645508, -1.23782142886034, 218, 36, 'PPL', 'P'),
(3031, 'Haynes Crossing', 34.8822212219238, 0.60880961073161, -85.8158264160156, -1.4977687212794, 218, 2, 'PPL', 'P'),
(3025, 'Haynes Crossroad', 33.4377784729004, 0.583599328904593, -85.7319412231445, -1.49630464847013, 218, 2, 'PPL', 'P'),
(41286, 'Haynes Landing', 32.9716682434082, 0.575464170722728, -91.6966705322266, -1.60040881390381, 218, 22, 'PPL', 'P'),
(162527, 'Haynes Mill', 40.7841682434082, 0.711818018534785, -75.3608322143555, -1.31529464918351, 218, 45, 'PPL', 'P'),
(87653, 'Haynesfield', 36.5680618286133, 0.63823307998216, -82.1944427490234, -1.43456365281244, 218, 50, 'PPL', 'P'),
(36329, 'Haynesville', 37.685001373291, 0.657727352582513, -86.7566680908203, -1.51418950624472, 218, 21, 'PPL', 'P'),
(41287, 'Haynesville', 32.9619407653809, 0.575294394203236, -93.1399993896484, -1.62559965465487, 218, 22, 'PPL', 'P'),
(55218, 'Haynesville', 39.4613914489746, 0.688731208202943, -94.315559387207, -1.64611704716701, 218, 29, 'PPL', 'P'),
(94798, 'Haynesville', 34.0913887023926, 0.595006979433948, -98.9155578613281, -1.72640216612714, 218, 51, 'PPL', 'P'),
(102681, 'Haynesville', 37.9500007629395, 0.662352464447654, -76.6627807617188, -1.33801793802656, 218, 53, 'PPL', 'P'),
(127716, 'Haynesville', 45.8261108398438, 0.799816517539137, -67.9916687011719, -1.18667848276063, 218, 26, 'PPL', 'P'),
(200956, 'Haynesville', 42.1366691589355, 0.735423612646975, -121.231391906738, -2.11588694554819, 218, 43, 'PPL', 'P'),
(155677, 'Haynesville (historical)', 40.4816703796387, 0.706538434831758, -83.4341735839844, -1.45620103772101, 218, 41, 'PPL', 'P'),
(3026, 'Hayneville', 32.1838912963867, 0.561714869225894, -86.5802764892578, -1.51111089202459, 218, 2, 'PPL', 'P'),
(21792, 'Hayneville', 32.3833312988281, 0.565195753928682, -83.6208267211914, -1.45945874952444, 218, 13, 'PPL', 'P'),
(207620, 'Haynie', 48.9708290100098, 0.854702203655826, -122.658889770508, -2.14080148333615, 218, 56, 'PPL', 'P'),
(135851, 'Haypoint', 46.8997192382813, 0.818554518968935, -93.6136093139648, -1.63386570720432, 218, 28, 'PPL', 'P'),
(27403, 'Haypress', 39.3613891601563, 0.686985839003532, -90.5347213745117, -1.58012897536092, 218, 18, 'PPL', 'P'),
(32724, 'Hays', 38.8791694641113, 0.678569517589582, -99.3263931274414, -1.73357259420412, 218, 20, 'PPL', 'P'),
(36330, 'Hays', 37.0313911437988, 0.646319702053158, -86.1388931274414, -1.50340729909737, 218, 21, 'PPL', 'P'),
(60208, 'Hays', 33.3463897705078, 0.582004295148718, -90.8986129760742, -1.58648008192854, 218, 30, 'PPL', 'P'),
(65452, 'Hays', 36.2497215270996, 0.632676993578955, -81.1158294677734, -1.41573829969889, 218, 33, 'PPL', 'P'),
(87654, 'Hays', 35.0458297729492, 0.611665118631421, -89.4716720581055, -1.56157526467855, 218, 50, 'PPL', 'P'),
(94799, 'Hays', 30.1224994659424, 0.525736794610928, -97.871940612793, -1.70818760900959, 218, 51, 'PPL', 'P'),
(162538, 'Hays', 40.3894386291504, 0.704928687110859, -79.9341735839844, -1.3951145139012, 218, 45, 'PPL', 'P'),
(186829, 'Hays', 38.0730590820313, 0.664500237287775, -103.618606567383, -1.80848585092945, 218, 7, 'PPL', 'P'),
(196682, 'Hays', 47.9891700744629, 0.83756902309891, -108.69361114502, -1.89706139036299, 218, 31, 'PPL', 'P'),
(65453, 'Hays Arbor', 36.184440612793, 0.631537626685592, -81.2558288574219, -1.41818174999903, 218, 33, 'PPL', 'P'),
(47962, 'Hays Beach', 38.0886116027832, 0.664771679981881, -76.3319396972656, -1.33224367215105, 218, 25, 'PPL', 'P'),
(94800, 'Hays City', 30.0472202301025, 0.524422924087138, -97.9880599975586, -1.71021427459914, 218, 51, 'PPL', 'P'),
(72864, 'Hays Corner', 39.7966690063477, 0.694582905487147, -84.366943359375, -1.47248094146466, 218, 41, 'PPL', 'P'),
(162528, 'Hays Corner', 41.3527793884277, 0.721742155178911, -75.9927825927734, -1.32632426399613, 218, 45, 'PPL', 'P'),
(36331, 'Hays Crossing', 38.2441711425781, 0.66748670613419, -83.3444366455078, -1.45463483268393, 218, 21, 'PPL', 'P'),
(87655, 'Hays Crossing', 35.0605583190918, 0.61192218025564, -89.466667175293, -1.5614879129948, 218, 50, 'PPL', 'P'),
(94805, 'Hays Crossing', 31.4699993133545, 0.549255103618391, -99.4333267211914, -1.73543893749605, 218, 51, 'PPL', 'P'),
(3028, 'Hays Ford', 33.9933280944824, 0.593295498959408, -88.0524978637695, -1.53680600232805, 218, 2, 'PPL', 'P'),
(162529, 'Hays Grove', 40.0936088562012, 0.699765483547468, -77.3713912963867, -1.35038552497083, 218, 45, 'PPL', 'P'),
(3029, 'Hays Mill', 34.8800010681152, 0.60877086173775, -86.9697189331055, -1.51790794491674, 218, 2, 'PPL', 'P'),
(65454, 'Hays Mill', 35.1194381713867, 0.612949827541275, -78.6213912963867, -1.37220214062076, 218, 33, 'PPL', 'P'),
(162530, 'Hays Mill', 40.6933288574219, 0.710232572158834, -79.9775009155273, -1.39587071849273, 218, 45, 'PPL', 'P'),
(16386, 'Hays Place', 29.8408298492432, 0.520820732396696, -84.9458312988281, -1.4825844420082, 218, 12, 'PPL', 'P'),
(182063, 'Hays Place', 39.6772193908691, 0.692498116406805, -122.910003662109, -2.1451842475421, 218, 6, 'PPL', 'P'),
(94802, 'Hays Spring', 31.4705600738525, 0.549264890735397, -95.5316696166992, -1.66734217473883, 218, 51, 'PPL', 'P'),
(87656, 'Haysboro', 36.2322196960449, 0.632371529001923, -86.7138900756836, -1.51344288903311, 218, 50, 'PPL', 'P'),
(162531, 'Hayshire', 40.0077781677246, 0.698267455434299, -76.7305603027344, -1.33920091418277, 218, 45, 'PPL', 'P'),
(102682, 'Haysi', 37.2052803039551, 0.649354640431413, -82.2941665649414, -1.43630416174286, 218, 53, 'PPL', 'P'),
(3030, 'Haysland Estates', 34.6536102294922, 0.604819596207426, -86.5777816772461, -1.51106734934076, 218, 2, 'PPL', 'P'),
(182064, 'Haystack', 38.223331451416, 0.667122984908312, -122.60888671875, -2.13992876544693, 218, 6, 'PPL', 'P'),
(21793, 'Hayston', 33.5191688537598, 0.585019859030042, -83.7677764892578, -1.46202350681225, 218, 13, 'PPL', 'P'),
(21794, 'Haysville', 34.8802795410156, 0.608775722006739, -85.3630599975586, -1.48986645653486, 218, 13, 'PPL', 'P'),
(30041, 'Haysville', 38.4855613708496, 0.671699760399668, -86.9150009155273, -1.51695293534984, 218, 19, 'PPL', 'P'),
(32726, 'Haysville', 37.5644416809082, 0.655623189005241, -97.351936340332, -1.69911182233071, 218, 20, 'PPL', 'P'),
(36332, 'Haysville', 37.9033317565918, 0.661537936628253, -86.2425003051758, -1.50521558547753, 218, 21, 'PPL', 'P'),
(87657, 'Haysville', 36.6166687011719, 0.639081429947405, -86.0833282470703, -1.50243750898642, 218, 50, 'PPL', 'P'),
(162533, 'Haysville', 40.9986114501953, 0.715560758551755, -79.7547225952148, -1.39198250330122, 218, 45, 'PPL', 'P'),
(155678, 'Haysville (historical)', 40.6155586242676, 0.708875225530248, -80.8069381713867, -1.41034712954618, 218, 41, 'PPL', 'P'),
(122792, 'Haysville Corner', 40.1805610656738, 0.70128308589465, -84.8258285522461, -1.48048999896891, 218, 19, 'PPL', 'P'),
(149542, 'Hayt Corner', 42.4683303833008, 0.741212193013344, -76.5430603027344, -1.33592842183528, 218, 40, 'PPL', 'P'),
(149543, 'Hayt Corners', 42.6958312988281, 0.745182833040598, -76.7891693115234, -1.34022383435747, 218, 40, 'PPL', 'P'),
(102683, 'Hayter', 36.7355613708496, 0.641156498489767, -81.9199981689453, -1.42977369127582, 218, 53, 'PPL', 'P'),
(41288, 'Hayti', 32.7119407653809, 0.57093107107325, -93.8352813720703, -1.63773461447793, 218, 22, 'PPL', 'P'),
(55219, 'Hayti', 36.2336082458496, 0.632395763767843, -89.7494430541992, -1.56642328312693, 218, 29, 'PPL', 'P'),
(78443, 'Hayti', 39.982780456543, 0.697831163068716, -75.841667175293, -1.32368680241057, 218, 45, 'PPL', 'P'),
(113362, 'Hayti', 44.6572189331055, 0.77941550516664, -97.204719543457, -1.696542404511, 218, 49, 'PPL', 'P'),
(55220, 'Hayti Heights', 36.2338905334473, 0.632400690615859, -89.7694396972656, -1.56677229038779, 218, 29, 'PPL', 'P'),
(174460, 'Hayton', 44.0224990844727, 0.768337553980237, -88.1161117553711, -1.53791627418651, 218, 57, 'PPL', 'P'),
(195074, 'Haytown (historical)', 42.6927795410156, 0.745129569818796, -114.501388549805, -1.99842622829943, 218, 17, 'PPL', 'P'),
(36333, 'Hayward', 38.2561111450195, 0.667695098489489, -83.2858276367188, -1.45361191250923, 218, 21, 'PPL', 'P'),
(55222, 'Hayward', 36.398609161377, 0.6352755730126, -89.6699981689453, -1.56503670830538, 218, 29, 'PPL', 'P'),
(72865, 'Hayward', 39.5724983215332, 0.690670388950684, -81.6727828979492, -1.42545897083573, 218, 41, 'PPL', 'P'),
(76054, 'Hayward', 36.2777786254883, 0.633166682324393, -97.5122222900391, -1.70190933989779, 218, 42, 'PPL', 'P'),
(135852, 'Hayward', 43.6505584716797, 0.761845965665115, -93.2438888549805, -1.62741286788305, 218, 28, 'PPL', 'P'),
(174461, 'Hayward', 46.0130615234375, 0.803079422506702, -91.4844436645508, -1.59670475630168, 218, 57, 'PPL', 'P'),
(182066, 'Hayward', 37.6427803039551, 0.656990455908888, -120.370277404785, -2.10085766225244, 218, 6, 'PPL', 'P'),
(200957, 'Hayward', 45.6444396972656, 0.796645757945289, -123.215560913086, -2.15051722762498, 218, 43, 'PPL', 'P'),
(202202, 'Hayward (historical)', 43.8716697692871, 0.765705085821721, -103.333892822266, -1.80351665865147, 218, 49, 'PPL', 'P'),
(170487, 'Hayward Addition', 43.5380592346191, 0.759882483572426, -96.7930603027344, -1.68935759536413, 218, 49, 'PPL', 'P'),
(125053, 'Hayward Corner', 42.6483306884766, 0.744353790993256, -71.4522171020508, -1.24707644628059, 218, 23, 'PPL', 'P'),
(94803, 'Hayward Junction', 31.5888900756836, 0.551330138871239, -94.6488876342773, -1.65193472256829, 218, 51, 'PPL', 'P'),
(182067, 'Hayward Park', 37.5544395446777, 0.655448618795787, -122.312217712402, -2.13475091449755, 218, 6, 'PPL', 'P'),
(113546, 'Haywardville', 41.5111083984375, 0.724505517705004, -72.3258285522461, -1.26232384246962, 218, 8, 'PPL', 'P'),
(125054, 'Haywardville', 42.464168548584, 0.741139555294612, -71.0919418334961, -1.2407884566308, 218, 23, 'PPL', 'P'),
(3032, 'Haywood', 33.3036117553711, 0.581257677937114, -85.3886108398438, -1.49031240285939, 218, 2, 'PPL', 'P'),
(9389, 'Haywood', 34.3627815246582, 0.599743677748763, -91.9247207641602, -1.60438904131099, 218, 4, 'PPL', 'P'),
(21795, 'Haywood', 31.357780456543, 0.547296515084205, -82.4322204589844, -1.43871365673911, 218, 13, 'PPL', 'P'),
(36334, 'Haywood', 36.9461097717285, 0.644831261319913, -85.9744415283203, -1.50053707723254, 218, 21, 'PPL', 'P'),
(65457, 'Haywood', 35.6199989318848, 0.621686260918253, -79.0641708374023, -1.37993010147195, 218, 33, 'PPL', 'P'),
(76051, 'Haywood', 34.8872184753418, 0.60889682925731, -95.9480590820313, -1.67460954187949, 218, 42, 'PPL', 'P'),
(102684, 'Haywood', 38.4533309936523, 0.671137234198416, -78.2525024414063, -1.36576381552744, 218, 53, 'PPL', 'P'),
(109595, 'Haywood', 39.3811111450195, 0.687330052574425, -80.3361129760742, -1.40212967968664, 218, 58, 'PPL', 'P'),
(21796, 'Haywood (historical)', 34.4911117553711, 0.601983462804547, -85.1841735839844, -1.48674429963091, 218, 13, 'PPL', 'P'),
(55223, 'Haywood City', 37.0125007629395, 0.645990002710207, -89.6013870239258, -1.56383921792123, 218, 29, 'PPL', 'P'),
(65456, 'Haywood Farms', 35.0916709899902, 0.612465198801908, -77.1205596923828, -1.34600768761291, 218, 33, 'PPL', 'P'),
(47964, 'Haywood Heights', 39.3344383239746, 0.686515458175997, -76.716667175293, -1.33895843336552, 218, 25, 'PPL', 'P'),
(72867, 'Hazael', 39.0488891601563, 0.68153168509105, -81.8050003051758, -1.42776659992028, 218, 41, 'PPL', 'P'),
(21798, 'Hazard', 32.8702812194824, 0.573694633336425, -82.8866729736328, -1.44664534941369, 218, 13, 'PPL', 'P'),
(36335, 'Hazard', 37.249439239502, 0.650125359250882, -83.1933288574219, -1.45199750425642, 218, 21, 'PPL', 'P'),
(142020, 'Hazard', 41.0905609130859, 0.717165579424637, -99.0788879394531, -1.72925281375796, 218, 35, 'PPL', 'P'),
(207621, 'Hazard', 47.8777809143066, 0.835624915503152, -117.517776489258, -2.05107212936033, 218, 56, 'PPL', 'P'),
(113547, 'Hazardville', 41.9872207641602, 0.732815246096324, -72.545280456543, -1.26615400074937, 218, 8, 'PPL', 'P'),
(36337, 'Hazel', 37.5122184753418, 0.654711722122162, -87.9894409179688, -1.53570545100758, 218, 21, 'PPL', 'P'),
(60209, 'Hazel', 32.3811111450195, 0.565157004934822, -89.3013916015625, -1.55860331006008, 218, 30, 'PPL', 'P'),
(102685, 'Hazel', 36.9905586242676, 0.645607040145453, -82.2538909912109, -1.43560122037313, 218, 53, 'PPL', 'P'),
(109596, 'Hazel', 39.5475006103516, 0.690234096585102, -80.5119400024414, -1.40519844021073, 218, 58, 'PPL', 'P'),
(131260, 'Hazel', 46.1480598449707, 0.805435587702123, -88.7444381713867, -1.54888263892323, 218, 27, 'PPL', 'P'),
(135855, 'Hazel', 48.0200004577637, 0.83810711479716, -96.1149978637695, -1.67752317327009, 218, 28, 'PPL', 'P'),
(149544, 'Hazel', 41.9244384765625, 0.731719488465811, -74.8705596923828, -1.30673777944303, 218, 40, 'PPL', 'P'),
(170488, 'Hazel', 44.7597198486328, 0.7812044836289, -97.3791732788086, -1.69958719658529, 218, 49, 'PPL', 'P'),
(207622, 'Hazel', 48.2775001525879, 0.842601332294724, -121.807777404785, -2.12594677024985, 218, 56, 'PPL', 'P'),
(41290, 'Hazel (historical)', 30.0961093902588, 0.525276200900399, -91.8888931274414, -1.60376373108704, 218, 22, 'PPL', 'P'),
(195075, 'Hazel (historical)', 42.3911094665527, 0.739864433764682, -113.765281677246, -1.98557873972672, 218, 17, 'PPL', 'P'),
(122793, 'Hazel College', 40.0463905334473, 0.698941368348143, -86.5102767944336, -1.50988916687451, 218, 19, 'PPL', 'P'),
(119965, 'Hazel Crest', 41.5716705322266, 0.725562526341657, -87.6944427490234, -1.53055676167213, 218, 18, 'PPL', 'P'),
(27404, 'Hazel Dell', 39.202220916748, 0.684207829091443, -88.0411071777344, -1.53660719735268, 218, 18, 'PPL', 'P'),
(76052, 'Hazel Dell', 35.4488906860352, 0.618699858650865, -97, -1.6929693744345, 218, 42, 'PPL', 'P'),
(207623, 'Hazel Dell', 45.6716690063477, 0.797120999041814, -122.661666870117, -2.14084995286799, 218, 56, 'PPL', 'P'),
(81472, 'Hazel Farm', 32.4083290100098, 0.565632046294265, -80.6608276367188, -1.40779701964438, 218, 48, 'PPL', 'P'),
(3033, 'Hazel Green', 34.9322204589844, 0.609682262041802, -86.5719375610352, -1.51096535027101, 218, 2, 'PPL', 'P'),
(36338, 'Hazel Green', 37.7975006103516, 0.659690834675201, -83.4166717529297, -1.45589557314397, 218, 21, 'PPL', 'P'),
(65458, 'Hazel Green', 35.5900001525879, 0.621162683447943, -82.5838928222656, -1.44136083886265, 218, 33, 'PPL', 'P'),
(113035, 'Hazel Green', 41.6833305358887, 0.72751136104835, -87.7399978637695, -1.53135184841557, 218, 18, 'PPL', 'P'),
(174464, 'Hazel Green', 42.5327796936035, 0.742337045678766, -90.434440612793, -1.57837874589252, 218, 57, 'PPL', 'P'),
(200958, 'Hazel Green', 45.0105590820313, 0.785582454144882, -122.925277709961, -2.14545082996721, 218, 43, 'PPL', 'P'),
(9392, 'Hazel Grove', 35.8722190856934, 0.626088333042099, -91.3605575561523, -1.59454253581264, 218, 4, 'PPL', 'P'),
(102687, 'Hazel Grove', 38.3027801513672, 0.668509626308889, -77.6536102294922, -1.35531117456499, 218, 53, 'PPL', 'P'),
(102686, 'Hazel Hill', 38.2966690063477, 0.668402966707232, -77.458610534668, -1.35190778784992, 218, 53, 'PPL', 'P'),
(162536, 'Hazel Hurst', 41.7058296203613, 0.727904044151082, -78.5827789306641, -1.37152822770692, 218, 45, 'PPL', 'P'),
(162537, 'Hazel Kirk', 40.1747207641602, 0.701181153403927, -79.959716796875, -1.39556032706768, 218, 45, 'PPL', 'P'),
(131261, 'Hazel Park', 42.4625015258789, 0.741110460259703, -83.1041717529297, -1.45044141923149, 218, 27, 'PPL', 'P'),
(135856, 'Hazel Park', 44.9874992370605, 0.785179983925144, -92.9844436645508, -1.62288469508159, 218, 28, 'PPL', 'P'),
(36339, 'Hazel Patch', 37.2444381713867, 0.650038074146154, -84.1930618286133, -1.46944613624446, 218, 21, 'PPL', 'P'),
(55225, 'Hazel Run', 37.9469413757324, 0.662299068067797, -90.4655609130859, -1.57892189759684, 218, 29, 'PPL', 'P'),
(135857, 'Hazel Run', 44.7519416809082, 0.781068728992334, -95.7147216796875, -1.67053703594054, 218, 28, 'PPL', 'P'),
(9393, 'Hazel Valley', 35.8611106872559, 0.625894454914741, -93.9922180175781, -1.64047367565908, 218, 4, 'PPL', 'P'),
(21799, 'Hazelbrand Acres', 33.6313896179199, 0.58697848085374, -83.7916717529297, -1.46244055783895, 218, 13, 'PPL', 'P'),
(200959, 'Hazeldale', 45.4666709899902, 0.793543108696319, -122.891937255859, -2.14486892926903, 218, 43, 'PPL', 'P'),
(13905, 'Hazeldell', 39.7125015258789, 0.693113905829859, -75.5472183227539, -1.31854770045504, 218, 10, 'PPL', 'P'),
(60210, 'Hazeldell', 34.4805603027344, 0.601799305215168, -88.3930587768555, -1.542749911565, 218, 30, 'PPL', 'P'),
(94804, 'Hazeldell', 31.8813896179199, 0.55643521894384, -98.331672668457, -1.71621144705789, 218, 51, 'PPL', 'P'),
(55226, 'Hazelgreen', 37.7675018310547, 0.659167257204891, -92.4272232055664, -1.61315936341284, 218, 29, 'PPL', 'P'),
(109597, 'Hazelgreen', 39.082218170166, 0.68211338605215, -80.9872207641602, -1.41349365437411, 218, 58, 'PPL', 'P'),
(47965, 'Hazelhurst', 39.4702796936035, 0.68888633733644, -79.2716674804688, -1.3835516010803, 218, 25, 'PPL', 'P'),
(119966, 'Hazelhurst', 41.9633293151855, 0.732398261648645, -89.6861114501953, -1.56531793811649, 218, 18, 'PPL', 'P'),
(131263, 'Hazelhurst', 41.8783302307129, 0.730914747763416, -86.6286087036133, -1.51195444829987, 218, 27, 'PPL', 'P'),
(174467, 'Hazelhurst', 45.8077812194824, 0.799496605313192, -89.7249984741211, -1.5659966447203, 218, 57, 'PPL', 'P'),
(204242, 'Hazelhurst', 40.6427803039551, 0.709350333468718, -111.959167480469, -1.95405610032594, 218, 52, 'PPL', 'P'),
(207624, 'Hazelmere (historical)', 48.0847206115723, 0.839236694573517, -118.260559082031, -2.06403613123073, 218, 56, 'PPL', 'P'),
(47966, 'Hazelmoor', 39.4099998474121, 0.687834255547804, -76.0113906860352, -1.32664903649106, 218, 25, 'PPL', 'P'),
(122794, 'Hazelrigg', 40.082218170166, 0.699566678572094, -86.5630569458008, -1.51081035429557, 218, 19, 'PPL', 'P'),
(47973, 'Hazels Woods', 39.4841690063477, 0.689128751574664, -77.0263900756836, -1.34436411774616, 218, 25, 'PPL', 'P'),
(113129, 'Hazeltine', 44.8369407653809, 0.782552242877562, -93.6011123657227, -1.63364759431104, 218, 28, 'PPL', 'P'),
(186830, 'Hazeltine', 39.896671295166, 0.696328274686557, -104.882499694824, -1.83054494739663, 218, 7, 'PPL', 'P'),
(162543, 'Hazeltine Corners', 41.8633308410645, 0.730652959028262, -79.1494369506836, -1.38141827588909, 218, 45, 'PPL', 'P'),
(186831, 'Hazeltine Heights', 39.8855590820313, 0.696134329980172, -104.889167785645, -1.83066132753627, 218, 7, 'PPL', 'P'),
(32727, 'Hazelton', 37.0902786254883, 0.647347482496847, -98.398063659668, -1.71737018844819, 218, 20, 'PPL', 'P'),
(65459, 'Hazelton', 36.5180587768555, 0.637360362092941, -76.6994400024414, -1.33865776247845, 218, 33, 'PPL', 'P'),
(109598, 'Hazelton', 39.6536102294922, 0.692086058807143, -79.5308303833008, -1.38807484703374, 218, 58, 'PPL', 'P'),
(135860, 'Hazelton', 44.9566688537598, 0.784641892226893, -93.9513931274414, -1.63976114690943, 218, 28, 'PPL', 'P'),
(145397, 'Hazelton', 40.5883293151855, 0.708399984433723, -74.2911071777344, -1.29662442520346, 218, 37, 'PPL', 'P'),
(155679, 'Hazelton', 40.4952812194824, 0.706775988800993, -81.2305603027344, -1.41774073052252, 218, 41, 'PPL', 'P'),
(182068, 'Hazelton', 35.0422210693359, 0.61160213487164, -119.383613586426, -2.08363713001177, 218, 6, 'PPL', 'P'),
(195076, 'Hazelton', 42.5963897705078, 0.743447250958193, -114.135276794434, -1.99203637273795, 218, 17, 'PPL', 'P'),
(198411, 'Hazelton', 46.4847183227539, 0.811311386594192, -100.279167175293, -1.75020163836668, 218, 34, 'PPL', 'P'),
(209501, 'Hazelton', 44.0966682434082, 0.769632050007097, -106.968330383301, -1.86694956054969, 218, 59, 'PPL', 'P'),
(162539, 'Hazelton Mills', 41.898609161377, 0.731268681872288, -78.7191696166992, -1.37390869424728, 218, 45, 'PPL', 'P'),
(139213, 'Hazelville (historical)', 40.2955589294434, 0.703290177250188, -92.320556640625, -1.61129768065282, 218, 29, 'PPL', 'P'),
(13906, 'Hazelwood', 39.2183303833008, 0.684488992323528, -75.5263900756836, -1.31818417896625, 218, 10, 'PPL', 'P'),
(21800, 'Hazelwood', 32.4249992370605, 0.565922996643356, -81.8191680908203, -1.4280138744275, 218, 13, 'PPL', 'P'),
(30042, 'Hazelwood', 39.6155586242676, 0.691421933010304, -86.5219421386719, -1.51009276553985, 218, 19, 'PPL', 'P'),
(36340, 'Hazelwood', 38.1777801513672, 0.666327964743897, -85.7813873291016, -1.49716764582137, 218, 21, 'PPL', 'P'),
(41289, 'Hazelwood', 30.5472202301025, 0.533149570347109, -91.9172210693359, -1.60425814694342, 218, 22, 'PPL', 'P'),
(47968, 'Hazelwood', 39.5597190856934, 0.69044734920939, -76.4997177124023, -1.33517195092765, 218, 25, 'PPL', 'P'),
(55227, 'Hazelwood', 38.7713890075684, 0.676688393753605, -90.3708267211914, -1.57726847403406, 218, 29, 'PPL', 'P'),
(65460, 'Hazelwood', 35.4686088562012, 0.61904400564273, -83.0041732788086, -1.44869611661111, 218, 33, 'PPL', 'P'),
(72866, 'Hazelwood', 39.2661094665527, 0.68532289463986, -84.3630599975586, -1.47241316401492, 218, 41, 'PPL', 'P'),
(102688, 'Hazelwood', 38.1861114501953, 0.666473373339415, -77.2294387817383, -1.34790798620873, 218, 53, 'PPL', 'P'),
(109599, 'Hazelwood', 38.8613891601563, 0.678259192743561, -79.8600006103516, -1.39381995129532, 218, 58, 'PPL', 'P'),
(135863, 'Hazelwood', 44.5224990844727, 0.777064200240209, -93.2858276367188, -1.62814483770866, 218, 28, 'PPL', 'P'),
(162540, 'Hazelwood', 40.413330078125, 0.705345671558538, -79.9394378662109, -1.39520639295881, 218, 45, 'PPL', 'P'),
(200960, 'Hazelwood', 45.5166702270508, 0.794415760006511, -122.52278137207, -2.1384259436438, 218, 43, 'PPL', 'P'),
(207626, 'Hazelwood', 47.6402816772461, 0.831479771845471, -117.553062438965, -2.05168798536241, 218, 56, 'PPL', 'P'),
(109600, 'Hazelwood (historical)', 38.8944396972656, 0.678836033435672, -79.5480575561523, -1.38837551792081, 218, 58, 'PPL', 'P'),
(65462, 'Hazelwood Park', 35.8527793884277, 0.625749046319223, -77.6897201538086, -1.35594141163696, 218, 33, 'PPL', 'P'),
(3035, 'Hazen', 32.3400001525879, 0.564439482758127, -87.2038879394531, -1.52199496508363, 218, 2, 'PPL', 'P'),
(9402, 'Hazen', 34.7808303833008, 0.60704000676628, -91.5808334350586, -1.59838707516228, 218, 4, 'PPL', 'P'),
(47969, 'Hazen', 39.7202796936035, 0.693249660466426, -78.6813888549805, -1.37324929556138, 218, 25, 'PPL', 'P'),
(145398, 'Hazen', 40.8141708374023, 0.712341662584122, -75.043327331543, -1.30975314358728, 218, 37, 'PPL', 'P'),
(162542, 'Hazen', 41.2066688537598, 0.719192045277106, -78.9705581665039, -1.37829625214319, 218, 45, 'PPL', 'P'),
(190295, 'Hazen', 39.5652809143066, 0.690544421431123, -119.045280456543, -2.07773210292673, 218, 39, 'PPL', 'P'),
(198414, 'Hazen', 47.2944412231445, 0.825443717234806, -101.622222900391, -1.7736423828074, 218, 34, 'PPL', 'P'),
(143947, 'Hazens', 44.3688888549805, 0.774383195970826, -71.5619430541992, -1.24899152542046, 218, 36, 'PPL', 'P'),
(162545, 'Hazlebrook', 40.9766693115234, 0.715177795987002, -75.8863906860352, -1.32446737492607, 218, 45, 'PPL', 'P'),
(21802, 'Hazlehurst', 31.8694400787354, 0.556226660140973, -82.5944366455078, -1.44154486329397, 218, 13, 'PPL', 'P'),
(60211, 'Hazlehurst', 31.860279083252, 0.556066770607027, -90.3958282470703, -1.57770483297867, 218, 30, 'PPL', 'P'),
(145399, 'Hazlet', 40.4155616760254, 0.705384620289481, -74.1913909912109, -1.29488404943109, 218, 37, 'PPL', 'P'),
(30043, 'Hazleton', 38.4888916015625, 0.671757883890459, -87.5416717529297, -1.52789040478874, 218, 19, 'PPL', 'P'),
(55229, 'Hazleton', 37.5250015258789, 0.654934828442483, -92.0247192382813, -1.60613434393138, 218, 29, 'PPL', 'P'),
(115992, 'Hazleton', 42.6208305358887, 0.743873822785797, -91.9000015258789, -1.6039576092144, 218, 16, 'PPL', 'P'),
(162546, 'Hazleton', 40.9583282470703, 0.714857684023974, -75.9749984741211, -1.32601387257108, 218, 45, 'PPL', 'P'),
(162547, 'Hazleton Junction', 40.8641700744629, 0.713214313894314, -76.0138931274414, -1.32669271233294, 218, 45, 'PPL', 'P'),
(162548, 'Hazleton Station', 40.9533309936523, 0.714770465498274, -75.9686126708984, -1.32590241927946, 218, 45, 'PPL', 'P'),
(13907, 'Hazlettville', 39.1163902282715, 0.682709800978274, -75.6425018310547, -1.32021071139774, 218, 10, 'PPL', 'P'),
(196683, 'Hazny (historical)', 47.4786109924316, 0.828658086091505, -107.542503356934, -1.87697076941555, 218, 31, 'PPL', 'P'),
(13908, 'Hazzard Landing', 38.8102798461914, 0.677367166936439, -75.2138900756836, -1.31273002505377, 218, 10, 'PPL', 'P'),
(211425, 'HÃƒÂ¤Ã‚â€˜ÃƒÂ¶Ã‚â€˜ÃƒÂ¼', 20.6975002288818, 0.361239525926268, -156.006942749023, -2.72283480694075, 218, 15, 'PPL', 'P'),
(211340, 'HÃƒÂ¤Ã‚â€˜ena', 19.6455593109131, 0.342879693371262, -154.987777709961, -2.7050470213879, 218, 15, 'PPL', 'P'),
(211341, 'HÃƒÂ¤Ã‚â€˜ena', 22.2244396209717, 0.387889645796636, -159.564712524414, -2.78492960354926, 218, 15, 'PPL', 'P'),
(211363, 'HÃƒÂ¤lawa', 21.3794403076172, 0.373141625601509, -157.921676635742, -2.7562532175635, 218, 15, 'PPL', 'P'),
(211366, 'HÃƒÂ¤lawa Heights', 21.3816699981689, 0.373180541042938, -157.918334960938, -2.75619489433563, 218, 15, 'PPL', 'P'),
(211365, 'HÃƒÂ¤lawa Hills', 21.3847198486328, 0.373233770975226, -157.906677246094, -2.75599142882835, 218, 15, 'PPL', 'P'),
(211385, 'HÃƒÂ¤lena', 21.0925006866455, 0.368133584461129, -157.234436035156, -2.7442586063299, 218, 15, 'PPL', 'P'),
(211396, 'HÃƒÂ¤moa', 20.7233295440674, 0.361690332519791, -155.988616943359, -2.72251496129383, 218, 15, 'PPL', 'P'),
(211387, 'HÃƒÂ¤na', 20.7580604553223, 0.362296501273407, -155.990280151367, -2.72254398974972, 218, 15, 'PPL', 'P'),
(211465, 'HÃƒÂ¯lea', 19.1386108398438, 0.334031773413151, -155.536666870117, -2.71462694446113, 218, 15, 'PPL', 'P'),
(211481, 'HÃƒÂ¶kÃƒÂ¼Ã‚â€˜ula', 20.7272205352783, 0.361758243127588, -155.987213134766, -2.72249046021181, 218, 15, 'PPL', 'P'),
(211484, 'HÃƒÂ¶lualoa', 19.6227798461914, 0.342482116710027, -155.952224731445, -2.72187979737385, 218, 15, 'PPL', 'P'),
(211493, 'HÃƒÂ¶naunau', 19.4269409179688, 0.339064082608964, -155.913055419922, -2.72119616392203, 218, 15, 'PPL', 'P'),
(9395, 'Head (historical)', 34.8819389343262, 0.608804683883594, -92.0869369506836, -1.60722024786586, 218, 4, 'PPL', 'P'),
(149545, 'Head Corners', 42.5247192382813, 0.742196364194183, -76.4730606079102, -1.33470669668521, 218, 40, 'PPL', 'P'),
(55230, 'Head Ford (historical)', 37.3061103820801, 0.651114457279737, -90.4658279418945, -1.57892655812875, 218, 29, 'PPL', 'P'),
(87660, 'Head of Barren', 36.4205589294434, 0.635658668735408, -83.6416702270508, -1.45982253732935, 218, 50, 'PPL', 'P'),
(47970, 'Head of Canal (historical)', 39.7102813720703, 0.693075156835998, -76.2200012207031, -1.33028997717537, 218, 25, 'PPL', 'P'),
(47971, 'Head of Creek (historical)', 38.2527809143066, 0.667636974998698, -75.647216796875, -1.32029300307543, 218, 25, 'PPL', 'P'),
(41291, 'Head of Island', 30.2694396972656, 0.528301385451161, -90.7533264160156, -1.58394435309662, 218, 22, 'PPL', 'P'),
(125055, 'Head of Plains (historical)', 41.2666702270508, 0.720239266796752, -70.1833267211914, -1.22493013128771, 218, 23, 'PPL', 'P'),
(149546, 'Head of the Harbor', 40.9033317565918, 0.713897814188083, -73.158332824707, -1.27685378306098, 218, 40, 'PPL', 'P'),
(127720, 'Head of the Tide', 44.4486083984375, 0.775774564482338, -69.054443359375, -1.20522739975303, 218, 26, 'PPL', 'P'),
(125056, 'Head of Westport', 41.6208305358887, 0.726420530265853, -71.0625, -1.24027459969847, 218, 23, 'PPL', 'P'),
(21803, 'Head River', 34.6569404602051, 0.604877719698217, -85.5074996948242, -1.49238740482273, 218, 13, 'PPL', 'P'),
(127719, 'Head Tide', 44.1144409179688, 0.769942241695064, -69.621940612793, -1.2151320953212, 218, 26, 'PPL', 'P'),
(3037, 'Headland', 31.351110458374, 0.547180101655055, -85.3422164916992, -1.48950266872996, 218, 2, 'PPL', 'P'),
(122795, 'Headlee', 40.8977813720703, 0.713800941703431, -86.6586074829102, -1.51247802577018, 218, 19, 'PPL', 'P'),
(78444, 'Headlee Heights', 39.814998626709, 0.694902817713092, -79.9725036621094, -1.39578349996703, 218, 45, 'PPL', 'P'),
(36342, 'Headquarters', 38.3583297729492, 0.669479150103733, -84.1144409179688, -1.4680739424928, 218, 21, 'PPL', 'P'),
(178345, 'Headquarters', 34.8141708374023, 0.607621907464462, -109.864166259766, -1.91749143119137, 218, 5, 'PPL', 'P'),
(195077, 'Headquarters', 46.6300010681152, 0.813847048847083, -115.808326721191, -2.02123660251012, 218, 17, 'PPL', 'P'),
(207627, 'Headquarters', 46.2483291625977, 0.807185617433441, -122.790832519531, -2.14310431873074, 218, 56, 'PPL', 'P'),
(142022, 'Headquarters (historical)', 41.9480590820313, 0.732131745802555, -98.4994430541992, -1.71913959267644, 218, 35, 'PPL', 'P'),
(76058, 'Headrick', 34.627498626709, 0.604363862765887, -99.1377792358398, -1.73028066078067, 218, 42, 'PPL', 'P'),
(60223, 'Heads', 33.4705581665039, 0.58417144248577, -90.8463897705078, -1.58556861504546, 218, 30, 'PPL', 'P'),
(87661, 'Heads (historical)', 35.8624992370605, 0.625918689680661, -85.5941696166992, -1.49390008032189, 218, 50, 'PPL', 'P'),
(127721, 'Heads Corner', 43.9780616760254, 0.767561974891779, -70.7844390869141, -1.23542152124402, 218, 26, 'PPL', 'P'),
(196684, 'Heads Trailer Court', 48.5611114501953, 0.847551283233827, -109.672782897949, -1.91415116139414, 218, 31, 'PPL', 'P'),
(94809, 'Headsville', 31.2611103057861, 0.545609302665099, -96.4955596923828, -1.68416523018681, 218, 51, 'PPL', 'P'),
(109601, 'Headsville', 39.3925018310547, 0.687528857549799, -78.8561096191406, -1.37629874816758, 218, 58, 'PPL', 'P'),
(55231, 'Heady', 37.3852806091309, 0.652496238411325, -93.3680572509766, -1.62958001522011, 218, 29, 'PPL', 'P'),
(9396, 'Heafer', 35.3663902282715, 0.617259954028486, -90.3397216796875, -1.57672558864585, 218, 4, 'PPL', 'P'),
(94806, 'Heafer', 29.3433303833008, 0.512137728689088, -98.5838928222656, -1.72061351918174, 218, 51, 'PPL', 'P'),
(174469, 'Heafford Junction', 45.5472183227539, 0.794948924856745, -89.7152786254883, -1.56582700135886, 218, 57, 'PPL', 'P'),
(55232, 'Heagy', 37.038330078125, 0.64644080930373, -89.8027801513672, -1.56735419108597, 218, 29, 'PPL', 'P'),
(94807, 'Heaker', 29.6424999237061, 0.517359222190839, -95.4691696166992, -1.66625134395633, 218, 51, 'PPL', 'P'),
(94808, 'Heakers', 29.6333293914795, 0.517199166209325, -95.498893737793, -1.66677012773668, 218, 51, 'PPL', 'P'),
(125057, 'Heald Village', 42.4249992370605, 0.740455921842789, -72.095832824707, -1.25830965975854, 218, 23, 'PPL', 'P'),
(182069, 'Healdsburg', 38.6105613708496, 0.673881421964661, -122.868057250977, -2.14445214455843, 218, 6, 'PPL', 'P'),
(76057, 'Healdton', 34.2330589294434, 0.597479591348032, -97.4875030517578, -1.70147790780119, 218, 42, 'PPL', 'P'),
(172111, 'Healdville', 43.4313888549805, 0.758020734233379, -72.76611328125, -1.27000826063699, 218, 55, 'PPL', 'P'),
(3038, 'Healing Springs', 31.6322193145752, 0.552086376752281, -88.336669921875, -1.54176574038416, 218, 2, 'PPL', 'P'),
(9397, 'Healing Springs', 36.2547187805176, 0.632764212104655, -94.2780609130859, -1.64546257532912, 218, 4, 'PPL', 'P'),
(65464, 'Healing Springs', 35.6161117553711, 0.621618416889483, -80.1783294677734, -1.39937583796144, 218, 33, 'PPL', 'P'),
(81474, 'Healing Springs', 33.3938903808594, 0.582833337196059, -81.2736129760742, -1.41849214142408, 218, 48, 'PPL', 'P'),
(102689, 'Healing Springs', 37.9608306884766, 0.662541482306022, -79.8627777099609, -1.39386842082716, 218, 53, 'PPL', 'P'),
(127722, 'Heals Corner', 44.3222198486328, 0.773568668151425, -69.0708312988281, -1.2055134232541, 218, 26, 'PPL', 'P'),
(9399, 'Health', 35.7891693115234, 0.624638841039796, -93.9427795410156, -1.63961081146589, 218, 4, 'PPL', 'P'),
(187712, 'Healy', 38.5999984741211, 0.6736970646382, -100.616668701172, -1.75609215122378, 218, 20, 'PPL', 'P'),
(211870, 'Healy', 63.8569412231445, 1.11451387459637, -148.966110229492, -2.59994909739344, 218, 1, 'PPL', 'P'),
(102690, 'Healys', 37.5727806091309, 0.655768730758814, -76.5119400024414, -1.33538527013096, 218, 53, 'PPL', 'P'),
(178346, 'Heap Place', 34.583610534668, 0.603597871057353, -109.407501220703, -1.90952112268098, 218, 5, 'PPL', 'P'),
(119967, 'Heapsville', 40.7597198486328, 0.711391313549127, -91.0716705322266, -1.58950050607885, 218, 18, 'PPL', 'P'),
(21807, 'Heard', 32.5377807617188, 0.567891405584061, -83.6838912963867, -1.46055943400297, 218, 13, 'PPL', 'P'),
(21805, 'Heard Place', 32.1683311462402, 0.561443293373734, -84.9902801513672, -1.48336022083374, 218, 13, 'PPL', 'P'),
(125058, 'Heard Street', 42.2305603027344, 0.737062322244728, -71.8430633544922, -1.25389800025477, 218, 23, 'PPL', 'P'),
(21806, 'Heardmont', 34.1105613708496, 0.595341605624916, -82.695556640625, -1.44330974014837, 218, 13, 'PPL', 'P'),
(102691, 'Heards', 37.9199981689453, 0.661828820398317, -78.7538909912109, -1.37451469655333, 218, 53, 'PPL', 'P'),
(21808, 'Heardville', 34.2805595397949, 0.598308633395373, -84.2361068725586, -1.47019741398797, 218, 13, 'PPL', 'P'),
(36341, 'Hearin', 37.5330581665039, 0.655075443348039, -87.8486099243164, -1.53324748647949, 218, 21, 'PPL', 'P'),
(9400, 'Hearn (historical)', 34.1386108398438, 0.5958311612123, -93.1627807617188, -1.62599726460562, 218, 4, 'PPL', 'P'),
(87662, 'Hearndale', 36.253059387207, 0.632735250227801, -88.4672164916992, -1.54404420785478, 218, 50, 'PPL', 'P'),
(94810, 'Hearne', 30.8783302307129, 0.53892853004404, -96.5927810668945, -1.68586206327535, 218, 51, 'PPL', 'P'),
(47972, 'Hearns (historical)', 38.434440612793, 0.670807534855464, -75.4277801513672, -1.31646311111178, 218, 25, 'PPL', 'P'),
(13909, 'Hearns Crossroads', 38.5330581665039, 0.672528735867983, -75.5505599975586, -1.31860602368292, 218, 10, 'PPL', 'P'),
(13910, 'Hearns Mill', 38.6783294677734, 0.675064198383793, -75.5944366455078, -1.31937181565437, 218, 10, 'PPL', 'P'),
(21809, 'Hearnville (historical)', 33.420280456543, 0.583293930906589, -83.5055618286133, -1.457446997637, 218, 13, 'PPL', 'P'),
(182071, 'Hearst', 39.4916687011719, 0.689259645942242, -123.213607788086, -2.15048313916303, 218, 6, 'PPL', 'P'),
(9401, 'Heart', 36.3236083984375, 0.633966562757799, -91.7147216796875, -1.60072386586077, 218, 4, 'PPL', 'P'),
(182070, 'Heart Bar Campground', 34.1586112976074, 0.596180235052182, -116.785827636719, -2.03829721192733, 218, 6, 'PPL', 'P'),
(196685, 'Heart Butte', 48.2833290100098, 0.842703065048365, -112.835830688477, -1.96935675973678, 218, 31, 'PPL', 'P'),
(162550, 'Heart Lake', 41.8522186279297, 0.730459014321877, -75.7944412231445, -1.32286255405319, 218, 45, 'PPL', 'P'),
(174470, 'Heart Prairie', 42.7655601501465, 0.746399831079737, -88.6419372558594, -1.54709366046097, 218, 57, 'PPL', 'P'),
(60212, 'Heartease (historical)', 30.3958301544189, 0.530507315071587, -88.9444427490234, -1.55237337732206, 218, 30, 'PPL', 'P'),
(81475, 'Hearthstone', 33.9422187805176, 0.592403473152286, -80.4194412231445, -1.40358403195793, 218, 48, 'PPL', 'P'),
(21811, 'Hearthstone Subdivision', 33.3608283996582, 0.582256296766866, -84.8411102294922, -1.48075671455208, 218, 13, 'PPL', 'P'),
(21812, 'Hearthwood', 33.9116706848145, 0.591870308302052, -84.7486114501953, -1.47914230629927, 218, 13, 'PPL', 'P'),
(21813, 'Heartpine (historical)', 31.1005592346191, 0.542807157855632, -83.4124984741211, -1.45582273568816, 218, 13, 'PPL', 'P'),
(162551, 'Hearts Content', 41.6816711425781, 0.727482399171495, -79.2474975585938, -1.38312975636363, 218, 45, 'PPL', 'P'),
(47974, 'Hearts Ease', 38.0161094665527, 0.66350627898993, -75.8166732788086, -1.32325057662401, 218, 25, 'PPL', 'P'),
(186832, 'Heartstrong', 39.9474983215332, 0.697215373645663, -102.576393127441, -1.79029579489394, 218, 7, 'PPL', 'P'),
(27405, 'Heartville', 39.0505599975586, 0.681560846704986, -88.543327331543, -1.54537259260651, 218, 18, 'PPL', 'P'),
(142023, 'Heartwell', 40.5705604553223, 0.708089859324783, -98.7874984741211, -1.72416710818229, 218, 35, 'PPL', 'P'),
(172112, 'Heartwellville', 42.829719543457, 0.747519623739088, -72.9880599975586, -1.27388196160056, 218, 55, 'PPL', 'P'),
(21814, 'Heartwood', 34.017219543457, 0.593712483407087, -84.4258270263672, -1.47350865532932, 218, 13, 'PPL', 'P'),
(36344, 'Heater', 37.1369400024414, 0.648161877158194, -88.3302764892578, -1.54165415393449, 218, 21, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(60213, 'Heater', 32.0586090087891, 0.559528280812885, -89.6394424438477, -1.56450341029709, 218, 30, 'PPL', 'P'),
(109602, 'Heaters', 38.7616691589355, 0.676518750392166, -80.6416702270508, -1.40746265976952, 218, 58, 'PPL', 'P'),
(3039, 'Heath', 31.360559463501, 0.547345017905559, -86.4697189331055, -1.50918129865677, 218, 2, 'PPL', 'P'),
(36343, 'Heath', 37.086669921875, 0.647284498737067, -88.7900009155273, -1.54967785882473, 218, 21, 'PPL', 'P'),
(65467, 'Heath', 35.2972183227539, 0.616052676527326, -77.538330078125, -1.35329915636143, 218, 33, 'PPL', 'P'),
(87663, 'Heath', 36.4544410705566, 0.63625002365546, -81.754997253418, -1.42689388203106, 218, 50, 'PPL', 'P'),
(94811, 'Heath', 32.8363914489746, 0.573103145258319, -96.4747161865234, -1.6838014423819, 218, 51, 'PPL', 'P'),
(122796, 'Heath', 40.461109161377, 0.70617957387487, -86.7333297729492, -1.51378217575599, 218, 19, 'PPL', 'P'),
(125059, 'Heath', 42.6733283996582, 0.744790083358838, -72.8222198486328, -1.27098750496981, 218, 23, 'PPL', 'P'),
(155685, 'Heath', 40.0227813720703, 0.698529310748481, -82.4447174072266, -1.43893176963239, 218, 41, 'PPL', 'P'),
(162552, 'Heath', 41.0977783203125, 0.717291546944198, -80.0733337402344, -1.39754331681536, 218, 45, 'PPL', 'P'),
(195078, 'Heath', 44.7561111450195, 0.78114149986912, -116.88111114502, -2.03996022287003, 218, 17, 'PPL', 'P'),
(196686, 'Heath', 46.9958305358887, 0.820231977560548, -109.266387939453, -1.90705823130488, 218, 31, 'PPL', 'P'),
(195079, 'Heath (historical)', 44.7519416809082, 0.781068728992334, -116.768608093262, -2.03799667419832, 218, 17, 'PPL', 'P'),
(149547, 'Heath Grove', 42.8849983215332, 0.748484420422996, -76.293327331543, -1.3315697592372, 218, 40, 'PPL', 'P'),
(145401, 'Heath Manor', 40.2588882446289, 0.702650153061215, -74.7630615234375, -1.30486158245507, 218, 37, 'PPL', 'P'),
(174471, 'Heath Mills', 42.9838905334473, 0.750210415125477, -88.5741729736328, -1.54591095062087, 218, 57, 'PPL', 'P'),
(182072, 'Heath Place', 39.8241691589355, 0.695062873694606, -123.379997253418, -2.1533871831737, 218, 6, 'PPL', 'P'),
(149548, 'Heath Ridge', 40.9775009155273, 0.715192310214943, -73.7736129760742, -1.28759244752451, 218, 40, 'PPL', 'P'),
(81476, 'Heath Springs', 34.5930595397949, 0.603762787307856, -80.6755599975586, -1.40805414784763, 218, 48, 'PPL', 'P'),
(145402, 'Heathcote', 40.3886108398438, 0.704914239461946, -74.5761108398438, -1.30159867748751, 218, 37, 'PPL', 'P'),
(149549, 'Heathcote', 40.9844398498535, 0.715313417465514, -73.7750015258789, -1.28761668229043, 218, 40, 'PPL', 'P'),
(112411, 'Heather', 39.8424987792969, 0.695382785920552, -91.8072204589844, -1.60233827411358, 218, 29, 'PPL', 'P'),
(193249, 'Heather', 46.771671295166, 0.816319660761168, -124.079719543457, -2.16559964098448, 218, 56, 'PPL', 'P'),
(204244, 'Heather Circle', 40.6494407653809, 0.7094665804503, -111.810562133789, -1.95146244774032, 218, 52, 'PPL', 'P'),
(182073, 'Heather Glen', 39.0183296203613, 0.680998320503734, -120.980827331543, -2.11151376872217, 218, 6, 'PPL', 'P'),
(204245, 'Heather Glen Condo', 40.6736106872559, 0.709888425166968, -111.949722290039, -1.95389125065447, 218, 52, 'PPL', 'P'),
(21815, 'Heather Heights', 34.3927803039551, 0.600267255219072, -83.8225021362305, -1.4629786495372, 218, 13, 'PPL', 'P'),
(47975, 'Heather Heights', 39.1947212219238, 0.684076934723866, -76.0777816772461, -1.32780777788136, 218, 25, 'PPL', 'P'),
(81477, 'Heather Heights', 34.5349998474121, 0.602749454513081, -82.6211090087891, -1.44201038385252, 218, 48, 'PPL', 'P'),
(87664, 'Heather Heights', 35.9922218322754, 0.628182776081392, -84.0872192382813, -1.46759883455433, 218, 50, 'PPL', 'P'),
(47977, 'Heather Knolls', 38.5900001525879, 0.673522561007773, -76.5486068725586, -1.33602522774091, 218, 25, 'PPL', 'P'),
(21816, 'Heather Lynn', 33.564998626709, 0.585819739463447, -84.2958297729492, -1.47123977523863, 218, 13, 'PPL', 'P'),
(47978, 'Heather Ridge', 39.415828704834, 0.687935988301445, -77.0197219848633, -1.34424773760653, 218, 25, 'PPL', 'P'),
(13911, 'Heather Valley', 39.7611083984375, 0.693962255795104, -75.6800003051758, -1.32086518323563, 218, 10, 'PPL', 'P'),
(13912, 'Heather Woods', 39.6272201538086, 0.691625465096614, -75.7027816772461, -1.32126279318638, 218, 10, 'PPL', 'P'),
(47979, 'Heather Woods', 38.9869384765625, 0.680450441688478, -76.6605606079102, -1.3379791890327, 218, 25, 'PPL', 'P'),
(21817, 'Heatherbrook', 33.0213890075684, 0.576331961763931, -85.1399993896484, -1.48597331449533, 218, 13, 'PPL', 'P'),
(178350, 'Heatherbrook', 33.3477783203125, 0.582028529914637, -111.890830993652, -1.95286340363175, 218, 5, 'PPL', 'P'),
(36345, 'Heatherfield', 38.2030601501465, 0.666769183957495, -85.8266677856445, -1.49795793887485, 218, 21, 'PPL', 'P'),
(109603, 'Heatherfield', 39.4363899230957, 0.688294849258333, -77.831672668457, -1.35841895039906, 218, 58, 'PPL', 'P'),
(119969, 'Heatherfield', 41.3666687011719, 0.721984569417136, -88.4663925170898, -1.54402982678489, 218, 18, 'PPL', 'P'),
(204248, 'Heatherglen', 40.6730613708496, 0.709878837787044, -111.949722290039, -1.95389125065447, 218, 52, 'PPL', 'P'),
(109605, 'Heatherman (historical)', 38.4766693115234, 0.671544564687144, -81.3116683959961, -1.41915633379995, 218, 58, 'PPL', 'P'),
(109604, 'Heathers Run', 39.438060760498, 0.68832401087227, -79.6847229003906, -1.39076077815114, 218, 58, 'PPL', 'P'),
(102692, 'Heatherstone', 37.3547210693359, 0.651962873824009, -79.8424987792969, -1.39351448671828, 218, 53, 'PPL', 'P'),
(13914, 'Heatherton', 39.7833290100098, 0.694350078628847, -75.6999969482422, -1.32121419049649, 218, 10, 'PPL', 'P'),
(47980, 'Heatherview', 39.5083312988281, 0.689550463133279, -77.436393737793, -1.35152003159521, 218, 25, 'PPL', 'P'),
(47981, 'Heatherwick', 38.7158317565918, 0.675718736800707, -76.8638916015625, -1.34152798434328, 218, 25, 'PPL', 'P'),
(3042, 'Heatherwood', 33.704719543457, 0.588258329494605, -86.6455612182617, -1.51225032549698, 218, 2, 'PPL', 'P'),
(21818, 'Heatherwood', 33.5936088562012, 0.586319082167837, -84.4336090087891, -1.47364447654492, 218, 13, 'PPL', 'P'),
(47982, 'Heatherwood', 39.3222198486328, 0.686302205551709, -76.9694366455078, -1.34337009286929, 218, 25, 'PPL', 'P'),
(81478, 'Heatherwood', 33.5819396972656, 0.586115416923473, -81.9433288574219, -1.43018088860649, 218, 48, 'PPL', 'P'),
(102693, 'Heatherwood', 37.6455612182617, 0.657038992019755, -77.3300018310547, -1.34966314252515, 218, 53, 'PPL', 'P'),
(87665, 'Heatherwood Hills', 35.8605613708496, 0.625884867534817, -86.8627777099609, -1.51604146846676, 218, 50, 'PPL', 'P'),
(60215, 'Heathman', 33.439998626709, 0.583638077898454, -90.7202835083008, -1.58336764556256, 218, 30, 'PPL', 'P'),
(16387, 'Heathrow', 28.7572193145752, 0.501908160757444, -81.3394393920898, -1.41964102911834, 218, 12, 'PPL', 'P'),
(204251, 'Heaths Blocks 39 and 40', 40.7638893127441, 0.711464084425914, -111.916107177734, -1.95330455626632, 218, 52, 'PPL', 'P'),
(102694, 'Heaths Store', 37.7355613708496, 0.658609791009711, -77.4513931274414, -1.35178182033036, 218, 53, 'PPL', 'P'),
(27406, 'Heathsville', 38.896671295166, 0.678874982166614, -87.5677795410156, -1.52834607165125, 218, 18, 'PPL', 'P'),
(65473, 'Heathsville', 36.2691688537598, 0.633016413459886, -77.7649993896484, -1.35725528216075, 218, 33, 'PPL', 'P'),
(102695, 'Heathsville', 37.9174995422363, 0.661785211135467, -76.4725036621094, -1.33469697614723, 218, 53, 'PPL', 'P'),
(162553, 'Heathville', 41.0897216796875, 0.717150932038642, -79.1808319091797, -1.38196622128337, 218, 45, 'PPL', 'P'),
(65474, 'Heathwood', 35.3541717529297, 0.617046701404198, -80.1616668701172, -1.3990850207704, 218, 33, 'PPL', 'P'),
(81482, 'Heathwood', 34.8444404602051, 0.608150212045707, -82.5391693115234, -1.44058026634715, 218, 48, 'PPL', 'P'),
(81484, 'Heathwood Park', 33.5244407653809, 0.585111871245704, -81.8883285522461, -1.42922095219158, 218, 48, 'PPL', 'P'),
(65475, 'Heaton', 36.172779083252, 0.631334094599283, -81.9427795410156, -1.43017130122657, 218, 33, 'PPL', 'P'),
(119971, 'Heaton', 40.410831451416, 0.705302062295688, -87.5894393920898, -1.52872410736799, 218, 18, 'PPL', 'P'),
(140209, 'Heaton', 47.478328704834, 0.828653159243488, -99.5475006103516, -1.7374316477817, 218, 34, 'PPL', 'P'),
(162554, 'Heaton', 40.1566696166992, 0.700866101446971, -75.1066665649414, -1.31085862175577, 218, 45, 'PPL', 'P'),
(178347, 'Heaton', 33.0788917541504, 0.577335574020727, -112.133888244629, -1.95710555293214, 218, 5, 'PPL', 'P'),
(191592, 'Heaton', 35.5480613708496, 0.620430713622335, -100.808326721191, -1.75943721471097, 218, 51, 'PPL', 'P'),
(188670, 'Heaton (historical)', 35.5777816772461, 0.620949430823655, -108.717216491699, -1.89747338138363, 218, 38, 'PPL', 'P'),
(87669, 'Heaton Creek', 36.1569404602051, 0.631057658478132, -82.0841674804688, -1.43263898629264, 218, 50, 'PPL', 'P'),
(119974, 'Heaton Park', 41.8325004577637, 0.730114867330011, -88.3583297729492, -1.5421437761009, 218, 18, 'PPL', 'P'),
(55234, 'Heatonville', 37.1883316040039, 0.649058829813332, -93.7991714477539, -1.63710437740596, 218, 29, 'PPL', 'P'),
(135864, 'Heatwole', 44.834171295166, 0.782503906503777, -94.3994369506836, -1.64758098681822, 218, 28, 'PPL', 'P'),
(125061, 'Heaven Heights', 41.7861099243164, 0.7293051997796, -70.9499969482422, -1.23831105102676, 218, 23, 'PPL', 'P'),
(76059, 'Heavener', 34.8891716003418, 0.608930917719264, -94.6005630493164, -1.65109129945106, 218, 42, 'PPL', 'P'),
(109606, 'Heavener Grove', 38.9794387817383, 0.6803195473209, -80.1769409179688, -1.39935160319552, 218, 58, 'PPL', 'P'),
(182074, 'Heavenly Hills', 37.9666709899902, 0.662643414796745, -120.469718933105, -2.10259324433484, 218, 6, 'PPL', 'P'),
(109609, 'Heavner (historical)', 38.9997215270996, 0.680673548008799, -80.2125015258789, -1.39997225288756, 218, 58, 'PPL', 'P'),
(211455, 'HeÃ‚â€˜eia', 21.4308300018311, 0.374038544967134, -157.810562133789, -2.75431390365771, 218, 15, 'PPL', 'P'),
(131266, 'Hebards', 47.2849998474121, 0.825278934142358, -88.2972183227539, -1.54107718008432, 218, 27, 'PPL', 'P'),
(21819, 'Hebardville', 31.2408294677734, 0.545255335266714, -82.3680572509766, -1.43759379750073, 218, 13, 'PPL', 'P'),
(72870, 'Hebardville', 39.2533302307129, 0.685099854898565, -82.1680603027344, -1.43410319225996, 218, 41, 'PPL', 'P'),
(36346, 'Hebbardsville', 37.7761116027832, 0.659317526069399, -87.3752822875977, -1.52498636077806, 218, 21, 'PPL', 'P'),
(87670, 'Hebbertsburg', 36.017219543457, 0.628619068446974, -84.7947235107422, -1.4799471135807, 218, 50, 'PPL', 'P'),
(94814, 'Hebbronville', 27.3063907623291, 0.476586425638807, -98.6780624389648, -1.72225708904848, 218, 51, 'PPL', 'P'),
(47983, 'Hebbville', 39.3413887023926, 0.68663676516365, -76.7630615234375, -1.33976816749496, 218, 25, 'PPL', 'P'),
(162555, 'Hebe', 40.6613883972168, 0.709675105963653, -76.7350006103516, -1.33927841217049, 218, 45, 'PPL', 'P'),
(142024, 'Heber', 41.1111106872559, 0.717524240644444, -97.9747161865234, -1.70998138116182, 218, 35, 'PPL', 'P'),
(178348, 'Heber', 34.4313888549805, 0.60094110155389, -110.593330383301, -1.93021774593448, 218, 5, 'PPL', 'P'),
(182075, 'Heber', 32.7308311462402, 0.571260770416202, -115.52889251709, -2.01635955560586, 218, 6, 'PPL', 'P'),
(204252, 'Heber City', 40.5069389343262, 0.706979454308275, -111.412498474121, -1.94451492624657, 218, 52, 'PPL', 'P'),
(9403, 'Heber Springs', 35.4913902282715, 0.619441615593479, -92.0311126708984, -1.60624593038105, 218, 4, 'PPL', 'P'),
(162556, 'Heberlig', 40.1922187805176, 0.701486551401932, -77.4899978637695, -1.35245560008615, 218, 45, 'PPL', 'P'),
(41292, 'Hebert', 32.1824989318848, 0.561690567880948, -91.9908294677734, -1.60554285585327, 218, 22, 'PPL', 'P'),
(94812, 'Hebert', 29.985279083252, 0.523341847132134, -94.0616683959961, -1.64168581342923, 218, 51, 'PPL', 'P'),
(200961, 'Hebo', 45.2305603027344, 0.789422199804558, -123.86222076416, -2.16180357116668, 218, 43, 'PPL', 'P'),
(940, 'Hebron', 35.1650009155273, 0.613745047442772, -88.8930587768555, -1.55147655782497, 218, 50, 'PPL', 'P'),
(3047, 'Hebron', 34.485279083252, 0.601881663471878, -86.3802795410156, -1.50762028678382, 218, 2, 'PPL', 'P'),
(9405, 'Hebron', 33.8144416809082, 0.590173342055454, -92.2225036621094, -1.60958633333634, 218, 4, 'PPL', 'P'),
(21821, 'Hebron', 32.964168548584, 0.575333276355151, -82.9974975585938, -1.44857960331342, 218, 13, 'PPL', 'P'),
(36347, 'Hebron', 39.0658302307129, 0.681827362551076, -84.7011108398438, -1.47831326425193, 218, 21, 'PPL', 'P'),
(41295, 'Hebron', 32.2869415283203, 0.563513435068079, -92.6194381713867, -1.61651414743801, 218, 22, 'PPL', 'P'),
(47984, 'Hebron', 38.4199981689453, 0.670555466658288, -75.6880569458008, -1.32100579814119, 218, 25, 'PPL', 'P'),
(55236, 'Hebron', 39.892219543457, 0.696250576961754, -92.0297164916992, -1.60622156245708, 218, 29, 'PPL', 'P'),
(60219, 'Hebron', 34.146671295166, 0.595971842696883, -89.1397171020508, -1.55578155772708, 218, 30, 'PPL', 'P'),
(65478, 'Hebron', 35.1297187805176, 0.613129258019719, -80.8791732788086, -1.41160787000623, 218, 33, 'PPL', 'P'),
(72871, 'Hebron', 39.961669921875, 0.697462714731904, -82.4913864135742, -1.43974629745179, 218, 41, 'PPL', 'P'),
(81485, 'Hebron', 34.5755615234375, 0.603457389309851, -79.5930633544922, -1.38916101728433, 218, 48, 'PPL', 'P'),
(94813, 'Hebron', 33.0263900756836, 0.576419246868658, -96.8633270263672, -1.69058398104612, 218, 51, 'PPL', 'P'),
(102698, 'Hebron', 37.1441688537598, 0.648288044414836, -77.8055572509766, -1.35796315037849, 218, 53, 'PPL', 'P'),
(109608, 'Hebron', 39.3600006103516, 0.686961604237612, -81.0183334350586, -1.41403667292038, 218, 58, 'PPL', 'P'),
(113549, 'Hebron', 41.6577796936035, 0.727065414723816, -72.3663864135742, -1.26303171068736, 218, 8, 'PPL', 'P'),
(115994, 'Hebron', 41.2547187805176, 0.720030674704372, -94.2850036621094, -1.64558374915872, 218, 16, 'PPL', 'P'),
(119972, 'Hebron', 42.4716682434082, 0.74127044966219, -88.4322204589844, -1.54343341185877, 218, 18, 'PPL', 'P'),
(122797, 'Hebron', 41.3186111450195, 0.721145806831815, -87.2002792358398, -1.52193198132385, 218, 19, 'PPL', 'P'),
(127723, 'Hebron', 44.1980590820313, 0.771401653972428, -70.4069366455078, -1.22883286070716, 218, 26, 'PPL', 'P'),
(142025, 'Hebron', 40.166389465332, 0.701035744808409, -97.585563659668, -1.70318938827573, 218, 35, 'PPL', 'P'),
(143948, 'Hebron', 43.6938896179199, 0.76260223683567, -71.8061065673828, -1.25325298263875, 218, 36, 'PPL', 'P'),
(162559, 'Hebron', 41.8419418334961, 0.73027965042246, -78.0669403076172, -1.36252514532579, 218, 45, 'PPL', 'P'),
(174472, 'Hebron', 42.9252815246582, 0.749187494950777, -88.692497253418, -1.54797609888817, 218, 57, 'PPL', 'P'),
(188671, 'Hebron', 36.7386093139648, 0.641209695132542, -104.465278625488, -1.82326306602803, 218, 38, 'PPL', 'P'),
(194231, 'Hebron', 40.5961112976074, 0.708535805649317, -106.406387329102, -1.8571418040452, 218, 7, 'PPL', 'P'),
(198417, 'Hebron', 46.9005584716797, 0.81856916635493, -102.044998168945, -1.78102120323968, 218, 34, 'PPL', 'P'),
(3048, 'Hebron (historical)', 33.836109161377, 0.590551510930245, -85.9369430541992, -1.49988260539465, 218, 2, 'PPL', 'P'),
(9406, 'Hebron (historical)', 33.9041709899902, 0.591739413934475, -92.9705581665039, -1.6226423474224, 218, 4, 'PPL', 'P'),
(65479, 'Hebron (historical)', 35.1661109924316, 0.613764421939703, -80.8391723632813, -1.41090972232646, 218, 33, 'PPL', 'P'),
(182076, 'Hebron (historical)', 38.6775016784668, 0.675049750734879, -121.727500915527, -2.12454568120036, 218, 6, 'PPL', 'P'),
(162560, 'Hebron Center', 41.8786087036133, 0.730919608032406, -78.0183334350586, -1.36167679536055, 218, 45, 'PPL', 'P'),
(81486, 'Hebron Crossroads', 33.8163909912109, 0.59020736393838, -79.8872222900391, -1.39429505923379, 218, 48, 'PPL', 'P'),
(36348, 'Hebron Estates', 38.0494384765625, 0.664087979951031, -85.6661071777344, -1.49515562761781, 218, 21, 'PPL', 'P'),
(200962, 'Heceta Beach', 44.0336112976074, 0.768531498686622, -124.129997253418, -2.16647715256366, 218, 43, 'PPL', 'P'),
(155681, 'Hechts Landing', 40.5008316040039, 0.706872861285644, -84.4672164916992, -1.47423103777501, 218, 41, 'PPL', 'P'),
(27407, 'Hecker', 38.3050003051758, 0.66854837530275, -89.9941711425781, -1.57069459404126, 218, 18, 'PPL', 'P'),
(41296, 'Hecker', 30.3549995422363, 0.529794686453395, -93.0880584716797, -1.62469311461981, 218, 22, 'PPL', 'P'),
(102699, 'Heckler Village', 37.5369415283203, 0.655143220797782, -77.3691711425781, -1.35034677597697, 218, 53, 'PPL', 'P'),
(162562, 'Heckscherville', 40.7188911437988, 0.710678718220449, -76.279167175293, -1.33132261788804, 218, 45, 'PPL', 'P'),
(162563, 'Heckton', 40.3522186279297, 0.704279075541962, -76.9161071777344, -1.34243931806831, 218, 45, 'PPL', 'P'),
(162564, 'Hecktown', 40.6930618286133, 0.710227911626926, -75.3352813720703, -1.31484870285898, 218, 45, 'PPL', 'P'),
(191593, 'Heckville', 33.7547187805176, 0.589130980804797, -101.66471862793, -1.77438407317099, 218, 51, 'PPL', 'P'),
(36349, 'Hecla', 37.2849998474121, 0.650746008942925, -87.5269393920898, -1.52763327658549, 218, 21, 'PPL', 'P'),
(55237, 'Hecla', 39.9397201538086, 0.697079619009096, -93.3038864135742, -1.62846002282367, 218, 29, 'PPL', 'P'),
(72872, 'Hecla', 38.5491714477539, 0.672809965679095, -82.6388931274414, -1.44232077527757, 218, 41, 'PPL', 'P'),
(149551, 'Hecla', 43.0994415283203, 0.752227160439966, -75.4541702270508, -1.31692370482231, 218, 40, 'PPL', 'P'),
(162565, 'Hecla', 40.702220916748, 0.710387767871358, -76.0022201538086, -1.32648898050955, 218, 45, 'PPL', 'P'),
(170490, 'Hecla', 45.8830604553223, 0.800810475836982, -98.1516723632813, -1.71306984907798, 218, 49, 'PPL', 'P'),
(178349, 'Hecla', 34.5380592346191, 0.602802850892937, -112.120826721191, -1.95687758634283, 218, 5, 'PPL', 'P'),
(209502, 'Hecla', 41.1575012207031, 0.718333908194855, -105.172782897949, -1.8356113450544, 218, 59, 'PPL', 'P'),
(3049, 'Hector', 32.1122207641602, 0.560463982461884, -85.9088897705078, -1.49939298322824, 218, 2, 'PPL', 'P'),
(9407, 'Hector', 35.4672203063965, 0.619019770876811, -92.9747161865234, -1.6227149185621, 218, 4, 'PPL', 'P'),
(36350, 'Hector', 37.1530609130859, 0.64844324012736, -83.6538925170898, -1.46003585653266, 218, 21, 'PPL', 'P'),
(135865, 'Hector', 44.7438888549805, 0.780928180665805, -94.7152786254883, -1.65309346395858, 218, 28, 'PPL', 'P'),
(149552, 'Hector', 42.500560760498, 0.741774719214596, -76.8727798461914, -1.34168311347678, 218, 40, 'PPL', 'P'),
(155682, 'Hector', 41.1002807617188, 0.717335222786075, -84.227783203125, -1.47005213855051, 218, 41, 'PPL', 'P'),
(162566, 'Hector', 41.8624992370605, 0.730638444800321, -77.6188888549805, -1.35470517225894, 218, 45, 'PPL', 'P'),
(182077, 'Hector', 34.8038902282715, 0.607442476986018, -116.451667785645, -2.03246502229811, 218, 6, 'PPL', 'P'),
(204256, 'Hector Park Condominium', 40.7016716003418, 0.710378180491434, -111.946670532227, -1.95383798743267, 218, 52, 'PPL', 'P'),
(191594, 'Hector Rodriguez Colonia', 28.6830005645752, 0.50061279920323, -100.473999023438, -1.75360209560455, 218, 51, 'PPL', 'P'),
(76061, 'Hectorville', 35.8419418334961, 0.6255598953028, -95.9250030517578, -1.67420713823878, 218, 42, 'PPL', 'P'),
(172113, 'Hectorville', 44.8383293151855, 0.782576477643482, -72.60888671875, -1.26726413944977, 218, 55, 'PPL', 'P'),
(145403, 'Hedding', 40.107780456543, 0.700012824633709, -74.7441711425781, -1.30453188311212, 218, 37, 'PPL', 'P'),
(139214, 'Hedge City', 40.0299987792969, 0.698655278268041, -92.1366729736328, -1.60808830522317, 218, 29, 'PPL', 'P'),
(87672, 'Hedgecoth (historical)', 35.8819389343262, 0.626257976403537, -84.9375, -1.48243903341268, 218, 50, 'PPL', 'P'),
(41297, 'Hedgeland', 31.8150005340576, 0.55527651084306, -91.3666687011719, -1.5946491954143, 218, 22, 'PPL', 'P'),
(41298, 'Hedgeland Landing', 31.8697204589844, 0.556231553699476, -91.5808334350586, -1.59838707516228, 218, 22, 'PPL', 'P'),
(102700, 'Hedgelawn Gardens', 37.3388900756836, 0.651686570860913, -79.9463882446289, -1.39532769994646, 218, 53, 'PPL', 'P'),
(21822, 'Hedgerow', 34.0461082458496, 0.594216686380467, -84.416389465332, -1.4733439388159, 218, 13, 'PPL', 'P'),
(119975, 'Hedgerow', 41.9613914489746, 0.732364439502801, -88.4266662597656, -1.54333647279509, 218, 18, 'PPL', 'P'),
(13915, 'Hedgerow Hollow Mobile Home Park', 39.2708282470703, 0.68540525289657, -75.5908279418945, -1.31930883189459, 218, 10, 'PPL', 'P'),
(388, 'Hedges', 30.5988903045654, 0.534051383271237, -81.5986099243164, -1.42416440822984, 218, 12, 'PPL', 'P'),
(36354, 'Hedges', 37.9936103820801, 0.663113595887198, -84.0461120605469, -1.46688137895666, 218, 21, 'PPL', 'P'),
(155683, 'Hedges', 41.0919418334961, 0.717189681032502, -84.5149993896484, -1.47506500667036, 218, 41, 'PPL', 'P'),
(207628, 'Hedges', 46.1761093139648, 0.805925143289507, -119.032783508301, -2.07751399003346, 218, 56, 'PPL', 'P'),
(9409, 'Hedges (historical)', 35.9736099243164, 0.627857937007429, -92.2213897705078, -1.60956689226038, 218, 4, 'PPL', 'P'),
(109610, 'Hedgesville', 39.5533294677734, 0.690335829338743, -77.9952774047852, -1.36127439171984, 218, 58, 'PPL', 'P'),
(149554, 'Hedgesville', 42.1375007629395, 0.735438126874916, -77.4127807617188, -1.35110790741652, 218, 40, 'PPL', 'P'),
(196687, 'Hedgesville', 46.4566688537598, 0.810821831006808, -109.501937866211, -1.91116935307963, 218, 31, 'PPL', 'P'),
(109611, 'Hedgeview', 37.8480606079102, 0.660573273102399, -82.033332824707, -1.43175175417548, 218, 58, 'PPL', 'P'),
(36351, 'Hedgeville', 37.6333312988281, 0.656825539658385, -84.6836090087891, -1.4780077996749, 218, 21, 'PPL', 'P'),
(119976, 'Hedgewood', 40.5069389343262, 0.706979454308275, -88.936393737793, -1.55223289557455, 218, 18, 'PPL', 'P'),
(155684, 'Hedington Corners', 40.2930603027344, 0.703246567987338, -82.7130584716797, -1.4436152047254, 218, 41, 'PPL', 'P'),
(191595, 'Hedley', 34.8669395446777, 0.608542895148439, -100.660003662109, -1.75684848897336, 218, 51, 'PPL', 'P'),
(55238, 'Hedrick', 37.6319389343262, 0.656801238313438, -91.6661071777344, -1.59987538273747, 218, 29, 'PPL', 'P'),
(115996, 'Hedrick', 41.1725006103516, 0.71859569693001, -92.3086090087891, -1.61108915513947, 218, 16, 'PPL', 'P'),
(122798, 'Hedrick', 40.3016700744629, 0.703396836851846, -87.4908294677734, -1.52700303951352, 218, 19, 'PPL', 'P'),
(9410, 'Hedrick (historical)', 35.1875, 0.614137730545505, -91.7038879394531, -1.60053478142338, 218, 4, 'PPL', 'P'),
(65482, 'Hedrick Grove', 35.7724990844727, 0.624347890690705, -80.1797180175781, -1.39940007272736, 218, 33, 'PPL', 'P'),
(142028, 'Hedrix', 40.204719543457, 0.701704730874237, -97.2411117553711, -1.69717756843099, 218, 35, 'PPL', 'P'),
(32729, 'Hedville', 38.8627815246582, 0.678283494088508, -97.7611083984375, -1.70625322195181, 218, 20, 'PPL', 'P'),
(21824, 'Hedwig (historical)', 34.5050010681152, 0.602225877042771, -84.0500030517578, -1.46694928956446, 218, 13, 'PPL', 'P'),
(94815, 'Hedwig Village', 29.7772197723389, 0.51971052711727, -95.5169372558594, -1.66708504653558, 218, 51, 'PPL', 'P'),
(94816, 'Hedwigs Hill', 30.6655597686768, 0.53521498493052, -99.1116714477539, -1.72982499391816, 218, 51, 'PPL', 'P'),
(162568, 'Heebnerville', 40.2066688537598, 0.701738752757162, -75.3177795410156, -1.31454323828195, 218, 45, 'PPL', 'P'),
(36352, 'Heekin', 38.6002807617188, 0.673701991486217, -84.6144409179688, -1.47680058875277, 218, 21, 'PPL', 'P'),
(9411, 'Heelstring', 36.3536109924316, 0.634490206807136, -90.6944427490234, -1.58291663923196, 218, 4, 'PPL', 'P'),
(186833, 'Heeney', 39.872501373291, 0.695906429969889, -106.300559997559, -1.85529476867117, 218, 7, 'PPL', 'P'),
(536, 'Heenon', 37.6666717529297, 0.657407440356567, -82.4899978637695, -1.43972206268587, 218, 21, 'PPL', 'P'),
(182078, 'Heeser Addition', 39.4152793884277, 0.687926400921521, -123.769721984863, -2.16018916291388, 218, 6, 'PPL', 'P'),
(9412, 'Heffington', 35.4494400024414, 0.618709446030789, -91.5130615234375, -1.59720423216412, 218, 4, 'PPL', 'P'),
(174474, 'Heffron', 44.2436103820801, 0.772196674136844, -89.3061065673828, -1.55868560173776, 218, 57, 'PPL', 'P'),
(3050, 'Heflin', 33.6488914489746, 0.587283945430772, -85.5875015258789, -1.49378370018226, 218, 2, 'PPL', 'P'),
(36353, 'Heflin', 37.5066719055176, 0.654614916216537, -87.0069427490234, -1.51855762306467, 218, 21, 'PPL', 'P'),
(41299, 'Heflin', 32.4561080932617, 0.566465948610596, -93.2638931274414, -1.62776200830196, 218, 22, 'PPL', 'P'),
(65484, 'Heflin', 35.7099990844727, 0.623257059908209, -78.2077789306641, -1.36498324301194, 218, 33, 'PPL', 'P'),
(102701, 'Heflin', 38.4883308410645, 0.671748096773453, -77.5783309936523, -1.3539973040412, 218, 53, 'PPL', 'P'),
(94817, 'Hefner', 33.5330581665039, 0.585262273268266, -99.5330581665039, -1.73717957958452, 218, 51, 'PPL', 'P'),
(94818, 'Hegar', 30.1158294677734, 0.525620381181778, -95.8274993896484, -1.67250537830222, 218, 51, 'PPL', 'P'),
(162571, 'Hegarty Crossroads', 40.7825012207031, 0.711788923499876, -78.4680633544922, -1.3695260631994, 218, 45, 'PPL', 'P'),
(119978, 'Hegeler', 40.0755615234375, 0.699450498169539, -87.6350021362305, -1.52951932726949, 218, 18, 'PPL', 'P'),
(155686, 'Hegemanns Landing', 40.3733291625977, 0.704647523878774, -84.3486099243164, -1.47216096265969, 218, 41, 'PPL', 'P'),
(119979, 'Hegewisch', 41.6536102294922, 0.72699264384703, -87.5469436645508, -1.5279824170044, 218, 18, 'PPL', 'P'),
(174475, 'Hegg', 44.209171295166, 0.771595598678813, -91.1922225952148, -1.59160453649807, 218, 57, 'PPL', 'P'),
(162569, 'Hegins', 40.6513900756836, 0.709500602333226, -76.4980621337891, -1.33514305562982, 218, 45, 'PPL', 'P'),
(36357, 'Hegira', 36.7066688537598, 0.640652228937361, -85.2761077880859, -1.48834885418768, 218, 21, 'PPL', 'P'),
(195080, 'Heglar', 42.4736099243164, 0.741304338387061, -113.146392822266, -1.97477709150341, 218, 17, 'PPL', 'P'),
(72874, 'Heglers (historical)', 39.4569396972656, 0.68865351047814, -83.2513885498047, -1.4530108370512, 218, 41, 'PPL', 'P'),
(135870, 'Heiberg', 47.2830581665039, 0.825245045417486, -96.2755584716797, -1.68032548452713, 218, 28, 'PPL', 'P'),
(3051, 'Heiberger', 32.7580604553223, 0.571736011512726, -87.2866668701172, -1.523439729975, 218, 2, 'PPL', 'P'),
(186834, 'Heiberger', 39.2688903808594, 0.685371430750726, -107.801666259766, -1.88149401536899, 218, 7, 'PPL', 'P'),
(36355, 'Heidelberg', 37.5552787780762, 0.655463266181782, -83.7788925170898, -1.46221751809766, 218, 21, 'PPL', 'P'),
(60221, 'Heidelberg', 31.8866691589355, 0.556527364317556, -88.98388671875, -1.55306180446384, 218, 30, 'PPL', 'P'),
(94819, 'Heidelberg', 26.1966705322266, 0.457218153847529, -97.879997253418, -1.70832822391515, 218, 51, 'PPL', 'P'),
(135871, 'Heidelberg', 44.4913902282715, 0.776521248272969, -93.626106262207, -1.63408382009759, 218, 28, 'PPL', 'P'),
(162580, 'Heidelberg', 40.392219543457, 0.704977223221726, -80.0911102294922, -1.39785357508235, 218, 45, 'PPL', 'P'),
(155687, 'Heidelberg Beach', 41.3877792358398, 0.722353017753948, -82.4544372558594, -1.43910141299382, 218, 41, 'PPL', 'P'),
(102702, 'Heidelberg Estates', 37.3069381713867, 0.651128904928651, -80.0722198486328, -1.3975238757394, 218, 53, 'PPL', 'P'),
(94820, 'Heidenheimer', 31.0180606842041, 0.541367286522767, -97.3024978637695, -1.69824895813753, 218, 51, 'PPL', 'P'),
(65485, 'Heidleberg Settlement', 35.9352798461914, 0.627188950941602, -80.4655609130859, -1.4043889723974, 218, 33, 'PPL', 'P'),
(78446, 'Heidlersburg', 39.9491691589355, 0.697244535259599, -77.1463928222656, -1.34645856078546, 218, 45, 'PPL', 'P'),
(21825, 'Heidrich', 32.976390838623, 0.575546595558466, -82.6511077880859, -1.44253396132283, 218, 13, 'PPL', 'P'),
(36356, 'Heidrick', 36.8824996948242, 0.643721056040486, -83.8786087036133, -1.46395789387002, 218, 21, 'PPL', 'P'),
(102703, 'Height', 37.2805595397949, 0.650668510955203, -81.8141708374023, -1.4279266559018, 218, 53, 'PPL', 'P'),
(94821, 'Heights', 29.3886108398438, 0.512928021742569, -94.9302825927734, -1.65684599109256, 218, 51, 'PPL', 'P'),
(102704, 'Heights', 37.211109161377, 0.649456373185054, -77.4075012207031, -1.3510157620428, 218, 53, 'PPL', 'P'),
(109612, 'Heights', 38.8636093139648, 0.678297941737421, -82.1333312988281, -1.43349705679586, 218, 58, 'PPL', 'P'),
(16388, 'Heijahs Town (historical)', 29.3666706085205, 0.51254509246733, -82.2666702270508, -1.43582426011443, 218, 12, 'PPL', 'P'),
(198420, 'Heil', 46.3875007629395, 0.809614620084675, -101.699440002441, -1.77499007547703, 218, 34, 'PPL', 'P'),
(65486, 'Heil Leah', 34.9530601501465, 0.61004598326768, -80.543327331543, -1.40574625244696, 218, 33, 'PPL', 'P'),
(199392, 'Heil School (historical)', 42.0391693115234, 0.733721919289442, -101.23722076416, -1.76692282790296, 218, 35, 'PPL', 'P'),
(16389, 'Heilbronn', 30.0188903808594, 0.523928474941251, -82.1508331298828, -1.43380252137289, 218, 12, 'PPL', 'P'),
(55239, 'Heilburn (historical)', 38.7208290100098, 0.675805955326407, -91.7211074829102, -1.60083531915239, 218, 29, 'PPL', 'P'),
(112318, 'Heilman', 38.1575012207031, 0.665974030635025, -87.0902786254883, -1.52001210849401, 218, 19, 'PPL', 'P'),
(162576, 'Heilman', 40.7599983215332, 0.711396173818117, -79.4730606079102, -1.38706657424504, 218, 45, 'PPL', 'P'),
(162577, 'Heilmandale', 40.3691711425781, 0.70457495273907, -76.477783203125, -1.33478912152095, 218, 45, 'PPL', 'P'),
(65487, 'Heilmans Mill', 35.482780456543, 0.619291346728972, -80.5838928222656, -1.40645425382276, 218, 33, 'PPL', 'P'),
(113551, 'Heilwield Corner', 41.5127792358398, 0.724534679318941, -72.251106262207, -1.26101969248381, 218, 8, 'PPL', 'P'),
(162578, 'Heilwood', 40.6208305358887, 0.70896723774591, -78.915283203125, -1.37733152203831, 218, 45, 'PPL', 'P'),
(140211, 'Heimdal', 47.792781829834, 0.834141401617923, -99.6447219848633, -1.73912848087024, 218, 34, 'PPL', 'P'),
(131268, 'Heimforth', 44.8574981689453, 0.782911037255423, -85.7088928222656, -1.49590237798747, 218, 27, 'PPL', 'P'),
(9413, 'Heine (historical)', 33.8372192382813, 0.590570885427176, -92.8305587768555, -1.62019889712225, 218, 4, 'PPL', 'P'),
(21828, 'Heineburg Village (historical)', 32.3849983215332, 0.565224848963592, -84.7805633544922, -1.47969997223154, 218, 13, 'PPL', 'P'),
(81488, 'Heineman', 33.5525016784668, 0.585601626570169, -79.9336090087891, -1.39510466020517, 218, 48, 'PPL', 'P'),
(192614, 'Heiner', 39.7080612182617, 0.693036407842138, -110.865562438965, -1.93496909163529, 218, 52, 'PPL', 'P'),
(182079, 'Heinlenville (historical)', 37.3516693115234, 0.651909610602208, -121.893890380859, -2.12744972521104, 218, 6, 'PPL', 'P'),
(135876, 'Heinola', 46.4561080932617, 0.810812043889802, -95.4069366455078, -1.66516517370575, 218, 28, 'PPL', 'P'),
(190296, 'Heinz (historical)', 39.6616706848145, 0.692226740291726, -119.99333190918, -2.09427872225356, 218, 39, 'PPL', 'P'),
(47985, 'Heise', 39.4388885498047, 0.688338458521183, -77.2083282470703, -1.34753953787192, 218, 25, 'PPL', 'P'),
(195081, 'Heise', 43.6419410705566, 0.761695563642552, -111.683609008789, -1.94924669771337, 218, 17, 'PPL', 'P'),
(162579, 'Heise Run', 41.7694396972656, 0.729014249430509, -77.353889465332, -1.3500800603938, 218, 45, 'PPL', 'P'),
(87673, 'Heiskell', 36.0816688537598, 0.629743921112396, -84.0538864135742, -1.4670170670142, 218, 50, 'PPL', 'P'),
(70944, 'Heislerville', 39.2230606079102, 0.684571550317321, -74.9927825927734, -1.30887097147619, 218, 37, 'PPL', 'P'),
(155688, 'Heisley (historical)', 41.6972198486328, 0.727753775286574, -81.307502746582, -1.41908362950219, 218, 41, 'PPL', 'P'),
(193248, 'Heisson', 45.8250007629395, 0.799797143042207, -122.48999786377, -2.1378537634836, 218, 56, 'PPL', 'P'),
(192615, 'Heist', 37.8530616760254, 0.660660558207126, -113.847778320313, -1.98701857777007, 218, 52, 'PPL', 'P'),
(78447, 'Heistersburg', 39.9627799987793, 0.697482089228834, -79.9316711425781, -1.39507083805933, 218, 45, 'PPL', 'P'),
(193631, 'Heitman Place (historical)', 40.1580581665039, 0.70089033621289, -122.70361328125, -2.14158205585166, 218, 6, 'PPL', 'P'),
(55240, 'Heitmans Mill', 37.5963897705078, 0.656180788358477, -90.0283279418945, -1.57129074265127, 218, 29, 'PPL', 'P'),
(32730, 'Heizer', 38.4222183227539, 0.670594215652149, -98.8888931274414, -1.72593677872665, 218, 20, 'PPL', 'P'),
(109613, 'Heizer', 38.535831451416, 0.672577138820795, -81.7686080932617, -1.4271314360003, 218, 58, 'PPL', 'P'),
(94822, 'Helbig', 30.1297206878662, 0.525862828709516, -94.142219543457, -1.64309169616868, 218, 51, 'PPL', 'P'),
(9417, 'Helbig (historical)', 34.1369400024414, 0.595801999598364, -93.7363891601563, -1.63600861977545, 218, 4, 'PPL', 'P'),
(149555, 'Helderberg', 42.5999984741211, 0.743510234717974, -74.0666732788086, -1.29270731471411, 218, 40, 'PPL', 'P'),
(94823, 'Heldnfelt', 28.1330604553223, 0.491014533607989, -97.8583297729492, -1.70795005504036, 218, 51, 'PPL', 'P'),
(199393, 'Heldt', 41.8877792358398, 0.73107966401392, -103.705001831055, -1.80999373273865, 218, 35, 'PPL', 'P'),
(209503, 'Heldt', 42.0008316040039, 0.733052800065559, -104.33943939209, -1.82106675707704, 218, 59, 'PPL', 'P'),
(36359, 'Helechawa', 37.7658309936523, 0.659138095590955, -83.3394393920898, -1.45454761415823, 218, 21, 'PPL', 'P'),
(16401, 'Helen', 30.3072204589844, 0.528960784137064, -84.4000015258789, -1.47305791531483, 218, 12, 'PPL', 'P'),
(21826, 'Helen', 34.7013893127441, 0.605653498523757, -83.7316665649414, -1.46139326974028, 218, 13, 'PPL', 'P'),
(47986, 'Helen', 38.3827781677246, 0.669905855089391, -76.7219390869141, -1.33905044558118, 218, 25, 'PPL', 'P'),
(78448, 'Helen', 39.9711112976074, 0.697627497824353, -79.7811126708984, -1.39244309701175, 218, 45, 'PPL', 'P'),
(109615, 'Helen', 37.6347198486328, 0.656849774424305, -81.3141708374023, -1.41920000964183, 218, 58, 'PPL', 'P'),
(207629, 'Helen', 46.6269416809082, 0.813793652467227, -119.604438781738, -2.08749125674133, 218, 56, 'PPL', 'P'),
(47987, 'Helen Estates', 38.389720916748, 0.670027028918989, -76.7183303833008, -1.3389874618214, 218, 25, 'PPL', 'P'),
(47988, 'Helen Farmettes', 38.3911094665527, 0.670051263684909, -76.727783203125, -1.33915244465093, 218, 25, 'PPL', 'P'),
(162585, 'Helen Furnace', 41.2922210693359, 0.720685213121286, -79.3119430541992, -1.38425454245002, 218, 45, 'PPL', 'P'),
(162581, 'Helen Mills', 41.2769393920898, 0.720418497538114, -78.704719543457, -1.37365649289205, 218, 45, 'PPL', 'P'),
(3052, 'Helena', 33.2961082458496, 0.581126716990509, -86.8436126708984, -1.51570697543384, 218, 2, 'PPL', 'P'),
(9414, 'Helena', 34.5294418334961, 0.602652448870375, -90.591667175293, -1.58112286707973, 218, 4, 'PPL', 'P'),
(21827, 'Helena', 32.0736083984375, 0.55979006954804, -82.9147186279297, -1.44713483842205, 218, 13, 'PPL', 'P'),
(27408, 'Helena', 38.6141700744629, 0.673944405724441, -87.8638916015625, -1.53351420206266, 218, 18, 'PPL', 'P'),
(36358, 'Helena', 38.4933280944824, 0.671835315299153, -83.7752838134766, -1.46215453433788, 218, 21, 'PPL', 'P'),
(41300, 'Helena', 31.8711109161377, 0.556255821754909, -91.3933334350586, -1.59511458281479, 218, 22, 'PPL', 'P'),
(55241, 'Helena', 39.9127807617188, 0.696609437918642, -94.649169921875, -1.6519396494163, 218, 29, 'PPL', 'P'),
(60222, 'Helena', 30.4944400787354, 0.532228382926051, -88.4958267211914, -1.54454355055917, 218, 30, 'PPL', 'P'),
(76063, 'Helena', 36.5461082458496, 0.637849917680325, -98.2697219848633, -1.71513020365532, 218, 42, 'PPL', 'P'),
(81487, 'Helena', 34.2827796936035, 0.598347382389234, -81.64111328125, -1.42490623175148, 218, 48, 'PPL', 'P'),
(87674, 'Helena', 36.4355583190918, 0.635920457470563, -85.0188903808594, -1.48385956353813, 218, 50, 'PPL', 'P'),
(94824, 'Helena', 28.9536094665527, 0.505335815527944, -97.8230590820313, -1.70733446535439, 218, 51, 'PPL', 'P'),
(115997, 'Helena', 41.9208297729492, 0.731656504706031, -92.4741668701172, -1.6139786849222, 218, 16, 'PPL', 'P'),
(131270, 'Helena', 46.2183303833008, 0.806662039963131, -87.272216796875, -1.52318752861977, 218, 27, 'PPL', 'P'),
(149556, 'Helena', 44.9216690063477, 0.784031029651856, -74.7266693115234, -1.30422641853509, 218, 40, 'PPL', 'P'),
(155689, 'Helena', 41.3411102294922, 0.721538489934547, -83.2916717529297, -1.45371391157898, 218, 41, 'PPL', 'P'),
(174476, 'Helena', 43.1713905334473, 0.753482907472966, -90.022216796875, -1.57118408304961, 218, 57, 'PPL', 'P'),
(178351, 'Helena', 33.3561096191406, 0.582173938510156, -111.942779541016, -1.95377007682487, 218, 5, 'PPL', 'P'),
(193630, 'Helena', 40.773609161377, 0.711633727787352, -123.127220153809, -2.14897539051188, 218, 6, 'PPL', 'P'),
(195082, 'Helena', 45.170280456543, 0.788370118015922, -116.651390075684, -2.03595083384892, 218, 17, 'PPL', 'P'),
(196688, 'Helena', 46.5927810668945, 0.813197437278186, -112.035278320313, -1.95538448507768, 218, 31, 'PPL', 'P'),
(142029, 'Helena (historical)', 40.500560760498, 0.70686813417471, -96.2494430541992, -1.67986968450656, 218, 35, 'PPL', 'P'),
(190297, 'Helena (historical)', 38.1377792358398, 0.665629817064132, -116.47721862793, -2.03291096862265, 218, 39, 'PPL', 'P'),
(9415, 'Helena Crossing', 34.5033302307129, 0.602196715428835, -90.620002746582, -1.58161741609416, 218, 4, 'PPL', 'P'),
(182080, 'Helendale', 34.7438888549805, 0.606395255466372, -117.323608398438, -2.04768325687321, 218, 6, 'PPL', 'P'),
(190298, 'Helene', 37.4811096191406, 0.654168770154922, -114.775833129883, -2.00321618983604, 218, 39, 'PPL', 'P'),
(65488, 'Helens Crossroads', 35.4402809143066, 0.618549589786357, -77.3424987792969, -1.34988125541843, 218, 33, 'PPL', 'P'),
(109614, 'Helens Run', 39.4608306884766, 0.688721421085937, -80.2522201538086, -1.40066547371931, 218, 58, 'PPL', 'P'),
(174477, 'Helenville', 43.0119400024414, 0.75069997071286, -88.6994400024414, -1.54809727271777, 218, 57, 'PPL', 'P'),
(87675, 'Helenwood', 36.4297218322754, 0.635818591558867, -84.5441665649414, -1.47557406991273, 218, 50, 'PPL', 'P'),
(162582, 'Helfenstein', 40.7491683959961, 0.711207155959748, -76.45361328125, -1.33436727680428, 218, 45, 'PPL', 'P'),
(9416, 'Helfer Landing', 35.6469383239746, 0.622156442008706, -90.2705612182617, -1.57551851088177, 218, 4, 'PPL', 'P'),
(162583, 'Helfrichsville', 40.565559387207, 0.708002574220056, -75.7055587768555, -1.32131126271822, 218, 45, 'PPL', 'P'),
(3054, 'Helicon', 34.1261100769043, 0.595612981739995, -87.1383285522461, -1.52085073792128, 218, 2, 'PPL', 'P'),
(200963, 'Helix', 45.8497200012207, 0.8002285751388, -118.655830383301, -2.07093491687652, 218, 43, 'PPL', 'P'),
(162584, 'Helixville', 40.0741691589355, 0.699426196824592, -78.704719543457, -1.37365649289205, 218, 45, 'PPL', 'P'),
(131272, 'Hell', 42.4347190856934, 0.740625565204227, -83.9850006103516, -1.46581478294008, 218, 27, 'PPL', 'P'),
(16402, 'Hell Gate', 26.976390838623, 0.470826840438806, -80.086669921875, -1.39777607709463, 218, 12, 'PPL', 'P'),
(196689, 'Hell Gate (historical)', 46.8833312988281, 0.81826849546786, -114.086112976074, -1.99117830223472, 218, 31, 'PPL', 'P'),
(143950, 'Hell Hollow', 43.5230598449707, 0.759620694837272, -72.3252792358398, -1.26231425508969, 218, 36, 'PPL', 'P'),
(47989, 'Hellen', 38.4411087036133, 0.670923914995101, -76.5824966430664, -1.33661671581901, 218, 25, 'PPL', 'P'),
(47991, 'Hellen Creek Estates', 38.3611106872559, 0.669527686214599, -76.4713897705078, -1.33467753507127, 218, 25, 'PPL', 'P'),
(162587, 'Hellertown', 40.5794410705566, 0.708244855300226, -75.3411102294922, -1.31495043561262, 218, 45, 'PPL', 'P'),
(204258, 'Hellgate Villa Condominiums', 40.5927810668945, 0.708477682158526, -111.629997253418, -1.94831099606437, 218, 52, 'PPL', 'P'),
(182081, 'Hellhole Palms', 33.2366714477539, 0.580089349166896, -116.439437866211, -2.03225156993674, 218, 6, 'PPL', 'P'),
(36360, 'Hellier', 37.2874984741211, 0.650789618205775, -82.4713897705078, -1.43939729019093, 218, 21, 'PPL', 'P'),
(47990, 'Helliesen', 39.3933296203613, 0.687543305198713, -77.2022171020508, -1.34743287827026, 218, 25, 'PPL', 'P'),
(162589, 'Hellings Corner', 40.1538887023926, 0.700817565336104, -74.8969421386719, -1.30719823999551, 218, 45, 'PPL', 'P'),
(13126, 'Hells Bottom (historical)', 38.8994407653809, 0.678923318540399, -77.057502746582, -1.34490713629243, 218, 9, 'PPL', 'P'),
(155690, 'Hells Corners', 41.1416702270508, 0.718057605231759, -80.5497207641602, -1.40585783889664, 218, 41, 'PPL', 'P'),
(81489, 'Hells Half Acre', 33.2397193908691, 0.580142545809671, -81.3663864135742, -1.42011134336685, 218, 48, 'PPL', 'P'),
(182082, 'Helltown', 39.8116683959961, 0.694844694222302, -121.65860748291, -2.12334326396819, 218, 6, 'PPL', 'P'),
(27409, 'Helm', 38.5111083984375, 0.672145640145175, -88.708610534668, -1.54825732869928, 218, 18, 'PPL', 'P'),
(36361, 'Helm', 36.8955612182617, 0.643949022629797, -85.1527786254883, -1.48619635423662, 218, 21, 'PPL', 'P'),
(55242, 'Helm', 37.9841690063477, 0.662948812794749, -92.154167175293, -1.60839363664214, 218, 29, 'PPL', 'P'),
(60224, 'Helm', 33.5008316040039, 0.584699813646041, -90.8344421386719, -1.5853600895321, 218, 30, 'PPL', 'P'),
(102705, 'Helm', 37.0794410705566, 0.647158331480424, -79.9477767944336, -1.39535193471238, 218, 53, 'PPL', 'P'),
(182083, 'Helm', 36.5316696166992, 0.637597916062176, -120.097221374512, -2.09609193548174, 218, 6, 'PPL', 'P'),
(182084, 'Helm Corner', 36.0980606079102, 0.630030011192498, -119.642776489258, -2.08816037596521, 218, 6, 'PPL', 'P'),
(113033, 'Helmar', 41.5449981689453, 0.725097005783111, -88.48388671875, -1.54433515820387, 218, 18, 'PPL', 'P'),
(30044, 'Helmcrest', 39.940559387207, 0.697094266395091, -85.8405609130859, -1.4982004196921, 218, 19, 'PPL', 'P'),
(112370, 'Helme', 30.4130592346191, 0.530808019248171, -93.4977798461914, -1.63184410162084, 218, 22, 'PPL', 'P'),
(21829, 'Helmer', 33.5263900756836, 0.58514589312863, -84.4352798461914, -1.47367363815885, 218, 13, 'PPL', 'P'),
(122799, 'Helmer', 41.5311088562012, 0.724854591544887, -85.170280456543, -1.48650181881365, 218, 19, 'PPL', 'P'),
(131273, 'Helmer', 46.2663917541504, 0.807500869127479, -85.7155609130859, -1.49601875812711, 218, 27, 'PPL', 'P'),
(195083, 'Helmer', 46.8008308410645, 0.816828590845482, -116.469169616699, -2.03277048687514, 218, 17, 'PPL', 'P'),
(102706, 'Helmet', 37.916389465332, 0.661765836638536, -77.1052780151367, -1.34574097202973, 218, 53, 'PPL', 'P'),
(145404, 'Helmetta', 40.3766708374023, 0.704705847106647, -74.4250030517578, -1.29896134906, 218, 37, 'PPL', 'P'),
(94825, 'Helmic', 31.1805591583252, 0.544203419925647, -94.9863891601563, -1.65782523542538, 218, 51, 'PPL', 'P'),
(32731, 'Helmick', 38.6277809143066, 0.674181959693676, -96.5999984741211, -1.68598803079491, 218, 20, 'PPL', 'P'),
(155691, 'Helmick', 40.3916702270508, 0.704967635841802, -81.9411087036133, -1.43014213961263, 218, 41, 'PPL', 'P'),
(94826, 'Helms', 29.6502799987793, 0.517495010116919, -96.5027770996094, -1.68429119770637, 218, 51, 'PPL', 'P'),
(13916, 'Helms Landing', 38.5591697692871, 0.672984469309522, -75.2163925170898, -1.31277370089564, 218, 10, 'PPL', 'P'),
(65489, 'Helms Park', 35.0261116027832, 0.611320971639555, -80.5944366455078, -1.40663827825409, 218, 33, 'PPL', 'P'),
(30045, 'Helmsburg', 39.2652816772461, 0.685308446990946, -86.2927780151367, -1.50609309705671, 218, 19, 'PPL', 'P'),
(47992, 'Helmsley Court', 39.3869400024414, 0.687431785328066, -76.7011108398438, -1.33868692409239, 218, 25, 'PPL', 'P'),
(196690, 'Helmville', 46.8666687011719, 0.817977678276824, -112.96028137207, -1.97152883392184, 218, 31, 'PPL', 'P'),
(87676, 'Heloise', 36.0505599975586, 0.629200969145156, -89.6755599975586, -1.56513378052712, 218, 50, 'PPL', 'P'),
(94827, 'Helotes', 29.5777797698975, 0.516229642414481, -98.6894378662109, -1.72245562770775, 218, 51, 'PPL', 'P'),
(192616, 'Helper', 39.6841697692871, 0.692619423394459, -110.853889465332, -1.9347653598119, 218, 52, 'PPL', 'P'),
(131274, 'Helps', 45.9308280944824, 0.801644178416231, -87.5986099243164, -1.5288841633495, 218, 27, 'PPL', 'P'),
(207630, 'Helsing Junction', 46.8061103820801, 0.816920736219198, -123.120826721191, -2.1488638040622, 218, 56, 'PPL', 'P'),
(36362, 'Helton', 36.9538917541504, 0.644967082535507, -83.3908309936523, -1.45544456681337, 218, 21, 'PPL', 'P'),
(55243, 'Helton', 39.7747192382813, 0.694199809764339, -91.4211120605469, -1.59559941129124, 218, 29, 'PPL', 'P'),
(65490, 'Helton', 36.5480613708496, 0.637884006142278, -81.4688873291016, -1.42190032182911, 218, 33, 'PPL', 'P'),
(87678, 'Helton', 36.2919387817383, 0.633413823673553, -83.3997192382813, -1.45559969594687, 218, 50, 'PPL', 'P'),
(30047, 'Heltonville', 38.9277801513672, 0.679417934133854, -86.3755569458008, -1.50753786194808, 218, 19, 'PPL', 'P'),
(41301, 'Helvetia', 30.077220916748, 0.524946534846961, -90.8675003051758, -1.58593706338227, 218, 22, 'PPL', 'P'),
(109619, 'Helvetia', 38.7058296203613, 0.675544166591252, -80.2013931274414, -1.3997783747602, 218, 58, 'PPL', 'P'),
(162591, 'Helvetia', 41.047779083252, 0.716418895634006, -78.774169921875, -1.3748686306622, 218, 45, 'PPL', 'P'),
(178352, 'Helvetia', 31.857780456543, 0.556023161344177, -110.788063049316, -1.93361647211764, 218, 5, 'PPL', 'P'),
(200964, 'Helvetia', 45.5958290100098, 0.795797341401017, -122.916107177734, -2.1452907739857, 218, 43, 'PPL', 'P'),
(142032, 'Helvey', 40.2666702270508, 0.702785974276809, -97.2547225952148, -1.69741512240022, 218, 35, 'PPL', 'P'),
(55244, 'Helvey (historical)', 37.1252784729004, 0.647958345071884, -90.8711090087891, -1.58600004714205, 218, 29, 'PPL', 'P'),
(27411, 'Heman', 39.9469413757324, 0.697205653107684, -89.1055603027344, -1.55518540911707, 218, 18, 'PPL', 'P'),
(112503, 'Heman', 36.5349998474121, 0.637656039552967, -98.9436111450195, -1.72689178829355, 218, 42, 'PPL', 'P'),
(195084, 'Heman', 43.9563903808594, 0.76718373943796, -111.796669006348, -1.95121996692306, 218, 17, 'PPL', 'P'),
(131276, 'Hemans', 43.461669921875, 0.758549238551705, -83.0894393920898, -1.45018429102824, 218, 27, 'PPL', 'P'),
(55245, 'Hematite', 38.2019386291504, 0.666749609723483, -90.480827331543, -1.5791883468639, 218, 29, 'PPL', 'P'),
(87679, 'Hematite', 36.4561080932617, 0.636279118690369, -87.4486083984375, -1.5262661428399, 218, 50, 'PPL', 'P'),
(102707, 'Hematite', 37.7397193908691, 0.658682362149415, -80.1763916015625, -1.3993420158156, 218, 53, 'PPL', 'P'),
(174479, 'Hematite', 45.9091682434082, 0.801266142699495, -88.2094421386719, -1.53954519666725, 218, 57, 'PPL', 'P'),
(188672, 'Hematite (historical)', 36.6536102294922, 0.639726181247313, -105.358329772949, -1.83884974893993, 218, 38, 'PPL', 'P'),
(87680, 'Hembree', 36.2294387817383, 0.632322992891056, -84.4205627441406, -1.47341677627171, 218, 50, 'PPL', 'P'),
(21831, 'Hembree Hills', 33.788330078125, 0.589717608613914, -84.5869369506836, -1.47632055396628, 218, 13, 'PPL', 'P'),
(65492, 'Hemby Bridge', 35.1186103820801, 0.612935379892361, -80.6305618286133, -1.40726878164216, 218, 33, 'PPL', 'P'),
(30048, 'Hemenway', 38.2038917541504, 0.666783698185436, -87.1344375610352, -1.52078282731348, 218, 19, 'PPL', 'P'),
(55246, 'Hemenway', 36.5483283996582, 0.637888666674186, -90.6516723632813, -1.58217015517841, 218, 29, 'PPL', 'P'),
(182085, 'Hemet', 33.747501373291, 0.589005013285236, -116.97110748291, -2.04153095528096, 218, 6, 'PPL', 'P'),
(199394, 'Hemingford', 42.3216705322266, 0.738652495731614, -103.07250213623, -1.79895453054611, 218, 35, 'PPL', 'P'),
(81490, 'Hemingway', 33.7536087036133, 0.589111606307867, -79.4477767944336, -1.38662528845241, 218, 48, 'PPL', 'P'),
(113552, 'Hemingway Town (historical)', 41.3138885498047, 0.721063381996077, -72.8786087036133, -1.27197167615065, 218, 8, 'PPL', 'P'),
(55247, 'Hemker', 38.3072204589844, 0.668587124296611, -90.7774963378906, -1.58436619781329, 218, 29, 'PPL', 'P'),
(72876, 'Hemlock', 39.5886116027832, 0.690951618761796, -82.1555633544922, -1.43388507936669, 218, 41, 'PPL', 'P'),
(87681, 'Hemlock', 36.5022201538086, 0.637083925971791, -82.4916687011719, -1.4397512242998, 218, 50, 'PPL', 'P'),
(102708, 'Hemlock', 37.0691719055176, 0.646979100739062, -80.2158279418945, -1.40003030979933, 218, 53, 'PPL', 'P'),
(109618, 'Hemlock', 38.7838897705078, 0.676906573225909, -80.1405563354492, -1.39871657243359, 218, 58, 'PPL', 'P'),
(122800, 'Hemlock', 40.4199981689453, 0.705462051698175, -86.041389465332, -1.50170553916081, 218, 19, 'PPL', 'P'),
(131278, 'Hemlock', 43.4147186279297, 0.757729783884288, -84.2305603027344, -1.47010060808235, 218, 27, 'PPL', 'P'),
(149558, 'Hemlock', 42.7941703796387, 0.746899173784127, -77.6066665649414, -1.35449185305563, 218, 40, 'PPL', 'P'),
(162590, 'Hemlock', 41.8491706848145, 0.730405817679102, -79.0577774047852, -1.37981851502228, 218, 45, 'PPL', 'P'),
(174480, 'Hemlock', 44.8236083984375, 0.782319549177317, -90.6116714477539, -1.58147200749864, 218, 57, 'PPL', 'P'),
(200965, 'Hemlock', 45.3158302307129, 0.790910440800722, -123.835563659668, -2.16133831692424, 218, 43, 'PPL', 'P'),
(125062, 'Hemlock Brook (historical)', 42.6902809143066, 0.745085960555946, -73.2430572509766, -1.27833250325625, 218, 23, 'PPL', 'P'),
(125065, 'Hemlock Brook Estates', 42.7236099243164, 0.745667661517047, -73.2061080932617, -1.27768761879829, 218, 23, 'PPL', 'P'),
(143954, 'Hemlock Center', 43.2355613708496, 0.754602899869399, -72.3858337402344, -1.26337113056829, 218, 36, 'PPL', 'P'),
(47993, 'Hemlock Estates', 38.3686103820801, 0.669658580582177, -76.456672668457, -1.33442067318413, 218, 25, 'PPL', 'P'),
(162592, 'Hemlock Farms', 41.3266716003418, 0.721286488316399, -75.0369415283203, -1.30964169029566, 218, 45, 'PPL', 'P'),
(145406, 'Hemlock Glen', 40.9805603027344, 0.715245706594799, -75.0408325195313, -1.30970960090345, 218, 37, 'PPL', 'P'),
(72877, 'Hemlock Grove', 39.1208305358887, 0.682787298965995, -81.9858322143555, -1.43092271212814, 218, 41, 'PPL', 'P'),
(162593, 'Hemlock Grove', 41.3108291625977, 0.721009985616221, -75.3041687011719, -1.31430568431271, 218, 45, 'PPL', 'P'),
(47994, 'Hemlock Hill', 39.1772193908691, 0.683771470146834, -76.9622192382813, -1.34324412534973, 218, 25, 'PPL', 'P'),
(102709, 'Hemlock Hills', 37.3038902282715, 0.651075708285876, -80.0002822875977, -1.39626832844348, 218, 53, 'PPL', 'P'),
(87682, 'Hemlock Park', 36.5027809143066, 0.637093713088797, -82.5044403076172, -1.43997413088304, 218, 50, 'PPL', 'P'),
(47995, 'Hemlock Ridge', 39.5219383239746, 0.689787950523486, -76.2569427490234, -1.33093472847527, 218, 25, 'PPL', 'P'),
(65493, 'Hemlock Ridge', 36.1180610656738, 0.63037908503238, -81.7677764892578, -1.42711692177236, 218, 33, 'PPL', 'P'),
(125063, 'Hemlocks', 41.8111114501953, 0.729741558724209, -70.9402770996094, -1.23814140766532, 218, 23, 'PPL', 'P'),
(94828, 'Hemming', 33.4313888549805, 0.583487809033946, -97.085563659668, -1.69446274201576, 218, 51, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(21830, 'Hemp', 34.8833312988281, 0.608828985228541, -84.1719436645508, -1.46907755474959, 218, 13, 'PPL', 'P'),
(47996, 'Hemp Hills', 39.4930610656738, 0.689283947287189, -77.1391677856445, -1.34633246010784, 218, 25, 'PPL', 'P'),
(36363, 'Hemp Ridge', 38.1483306884766, 0.665813974653511, -85.1188888549805, -1.48560486615852, 218, 21, 'PPL', 'P'),
(162595, 'Hempfield', 40.0547218322754, 0.699086776943662, -76.4391708374023, -1.3341152086071, 218, 45, 'PPL', 'P'),
(36364, 'Hemphill', 37.2155609130859, 0.649534070909857, -82.7052764892578, -1.44347938350981, 218, 21, 'PPL', 'P'),
(41302, 'Hemphill', 31.2491703033447, 0.545400910309801, -92.7744369506836, -1.61921938647332, 218, 22, 'PPL', 'P'),
(94829, 'Hemphill', 31.3405609130859, 0.54699597735519, -93.8466720581055, -1.6379334194533, 218, 51, 'PPL', 'P'),
(109620, 'Hemphill', 37.4447212219238, 0.653533672813965, -81.5955581665039, -1.42411114500804, 218, 58, 'PPL', 'P'),
(55248, 'Hemple', 39.7255592346191, 0.693341805840143, -94.561393737793, -1.65040766599923, 218, 29, 'PPL', 'P'),
(94830, 'Hempstead', 30.0972194671631, 0.525295575397329, -96.0780563354492, -1.67687842197019, 218, 51, 'PPL', 'P'),
(149560, 'Hempstead', 41.1497192382813, 0.718198086979261, -74.0341720581055, -1.29214006140193, 218, 40, 'PPL', 'P'),
(149561, 'Hempstead Gardens', 40.6963882446289, 0.71028596853869, -73.6455612182617, -1.28535752273771, 218, 40, 'PPL', 'P'),
(9420, 'Hempwallace', 34.4438896179199, 0.601159281026194, -93.2102813720703, -1.62682630665296, 218, 4, 'PPL', 'P'),
(149563, 'Hemstreet Park', 42.9044418334961, 0.7488237737249, -73.6800003051758, -1.28595859819574, 218, 40, 'PPL', 'P'),
(16403, 'Hen Scratch', 27.312219619751, 0.476688158392448, -81.4686126708984, -1.42189552813915, 218, 12, 'PPL', 'P'),
(3055, 'Henagar', 34.6349983215332, 0.604494757133464, -85.767219543457, -1.49692037131415, 218, 2, 'PPL', 'P'),
(87683, 'Henard (historical)', 36.3444404602051, 0.634330150825622, -85.3194427490234, -1.48910519193726, 218, 50, 'PPL', 'P'),
(87684, 'Henard Mill', 36.482780456543, 0.636744639248915, -82.9877777099609, -1.44840995995198, 218, 50, 'PPL', 'P'),
(87685, 'Henardtown', 36.3841705322266, 0.635023571394451, -83.0127792358398, -1.44884631889659, 218, 50, 'PPL', 'P'),
(23, 'Henderson', 32.1530609130859, 0.561176777527644, -94.7991714477539, -1.65455766992591, 218, 51, 'PPL', 'P'),
(3057, 'Henderson', 31.666389465332, 0.552682758388891, -86.0733337402344, -1.50226307193502, 218, 2, 'PPL', 'P'),
(9421, 'Henderson', 36.3805618286133, 0.634960587634671, -92.2275009155273, -1.60967355186204, 218, 4, 'PPL', 'P'),
(21832, 'Henderson', 32.3411102294922, 0.564458857255058, -83.789436340332, -1.46240154252898, 218, 13, 'PPL', 'P'),
(30049, 'Henderson', 39.6694412231445, 0.692362361770239, -85.5202789306641, -1.49261044456402, 218, 19, 'PPL', 'P'),
(36365, 'Henderson', 37.836109161377, 0.660364681010018, -87.5899963378906, -1.52873382790597, 218, 21, 'PPL', 'P'),
(41304, 'Henderson', 30.313060760498, 0.529062716627787, -91.790283203125, -1.60204266323258, 218, 22, 'PPL', 'P'),
(47997, 'Henderson', 39.0741691589355, 0.681972904304649, -75.7663879394531, -1.32237293188678, 218, 25, 'PPL', 'P'),
(55249, 'Henderson', 37.1411094665527, 0.64823464803498, -93.0597229003906, -1.62419856560538, 218, 29, 'PPL', 'P'),
(60225, 'Henderson', 31.4486103057861, 0.548881795012589, -88.7736129760742, -1.54939183532366, 218, 30, 'PPL', 'P'),
(65494, 'Henderson', 36.3294410705566, 0.634068362090467, -78.3994369506836, -1.36832830649913, 218, 33, 'PPL', 'P'),
(87686, 'Henderson', 35.4391708374023, 0.618530215289427, -88.6413879394531, -1.54708407308105, 218, 50, 'PPL', 'P'),
(102710, 'Henderson', 36.8741683959961, 0.643575647444968, -81.8566665649414, -1.42866834626538, 218, 53, 'PPL', 'P'),
(109621, 'Henderson', 38.833610534668, 0.677774364267112, -82.1383285522461, -1.43358427532156, 218, 58, 'PPL', 'P'),
(115999, 'Henderson', 41.1405601501465, 0.718038230734829, -95.4308319091797, -1.66558222473245, 218, 16, 'PPL', 'P'),
(119980, 'Henderson', 41.0250015258789, 0.716021352262285, -90.3561096191406, -1.57701161214692, 218, 18, 'PPL', 'P'),
(131279, 'Henderson', 43.0863914489746, 0.751999393587737, -84.1952819824219, -1.46948488523832, 218, 27, 'PPL', 'P'),
(135881, 'Henderson', 44.5283317565918, 0.777165999572877, -93.9075012207031, -1.63899508862186, 218, 28, 'PPL', 'P'),
(142033, 'Henderson', 40.7797203063965, 0.711740387389009, -97.8119430541992, -1.70714045406897, 218, 35, 'PPL', 'P'),
(149564, 'Henderson', 43.8469390869141, 0.765273453988046, -76.1822204589844, -1.32963057848946, 218, 40, 'PPL', 'P'),
(162600, 'Henderson', 40.0894393920898, 0.699692712670682, -75.3466720581055, -1.31504750783435, 218, 45, 'PPL', 'P'),
(182086, 'Henderson', 37.4794387817383, 0.654139608540985, -122.164436340332, -2.13217164298181, 218, 6, 'PPL', 'P'),
(186835, 'Henderson', 39.9205589294434, 0.696745192555209, -104.865280151367, -1.83024440966762, 218, 7, 'PPL', 'P'),
(190299, 'Henderson', 36.0397186279297, 0.629011751549706, -114.981109619141, -2.00679894045053, 218, 39, 'PPL', 'P'),
(196691, 'Henderson', 47.3583297729492, 0.826558782783222, -115.308891296387, -2.01251980994618, 218, 31, 'PPL', 'P'),
(41303, 'Henderson (historical)', 32.5758285522461, 0.568555464801872, -91.0844421386719, -1.58972341266209, 218, 22, 'PPL', 'P'),
(65495, 'Henderson (historical)', 36.1686096191406, 0.631261323722496, -81.1344375610352, -1.41606307219382, 218, 33, 'PPL', 'P'),
(191597, 'Henderson Chapel', 31.3690490722656, 0.547493189530708, -100.001861572266, -1.74536174255963, 218, 51, 'PPL', 'P'),
(47998, 'Henderson Corner', 39.2019386291504, 0.684202902243427, -77.2458267211914, -1.34819400970981, 218, 25, 'PPL', 'P'),
(55250, 'Henderson Ford (historical)', 38.1777801513672, 0.666327964743897, -91.8644409179688, -1.60333695952236, 218, 29, 'PPL', 'P'),
(119985, 'Henderson Grove', 41.019718170166, 0.715929140309541, -90.4113922119141, -1.57797647540986, 218, 18, 'PPL', 'P'),
(149565, 'Henderson Harbor', 43.8647193908691, 0.765583778834068, -76.2022171020508, -1.32997958575032, 218, 40, 'PPL', 'P'),
(21833, 'Henderson Heights', 34.1697196960449, 0.59637411317954, -84.2997207641602, -1.47130768584642, 218, 13, 'PPL', 'P'),
(16404, 'Henderson Mill', 30.5677795410156, 0.533508398014484, -85.0697174072266, -1.48474666249724, 218, 12, 'PPL', 'P'),
(162601, 'Henderson Park', 40.0930595397949, 0.699755896167544, -75.3627777099609, -1.31532860448741, 218, 45, 'PPL', 'P'),
(60226, 'Henderson Point', 30.3086109161377, 0.528985052192498, -89.2869415283203, -1.55835110870485, 218, 30, 'PPL', 'P'),
(87688, 'Henderson Springs', 35.8052787780762, 0.624920004271881, -83.5924987792969, -1.45896433366807, 218, 50, 'PPL', 'P'),
(162602, 'Henderson Station', 41.2955589294434, 0.720743469770131, -79.9936065673828, -1.39615181514579, 218, 45, 'PPL', 'P'),
(21834, 'Henderson Still', 31.187219619751, 0.544319666907229, -82.9683303833008, -1.44807054007105, 218, 13, 'PPL', 'P'),
(204262, 'Henderson Subdivisions 1-4', 41.2472190856934, 0.719899780336794, -111.94361114502, -1.95378459105281, 218, 52, 'PPL', 'P'),
(182087, 'Henderson Village', 38.100830078125, 0.66498493260617, -121.304443359375, -2.11716193392006, 218, 6, 'PPL', 'P'),
(102711, 'Hendersons Store', 37.7430610656738, 0.658740685377288, -78.998893737793, -1.37879080115762, 218, 53, 'PPL', 'P'),
(87689, 'Hendersons Subdivision', 35.0872192382813, 0.612387501077105, -86.6016693115234, -1.51148426720941, 218, 50, 'PPL', 'P'),
(65498, 'Hendersonville', 35.3186111450195, 0.616426051712155, -82.4611129760742, -1.43921792629152, 218, 33, 'PPL', 'P'),
(81491, 'Hendersonville', 32.7905616760254, 0.572303264824913, -80.7255630493164, -1.40892686573685, 218, 48, 'PPL', 'P'),
(87690, 'Hendersonville', 36.3047218322754, 0.633636929993874, -86.620002746582, -1.51180424601439, 218, 50, 'PPL', 'P'),
(125064, 'Hendersonville', 42.4041709899902, 0.740092400353993, -71.0666732788086, -1.24034743715428, 218, 23, 'PPL', 'P'),
(162606, 'Hendersonville', 40.2991714477539, 0.703353227588996, -80.1524963378906, -1.39892496478889, 218, 45, 'PPL', 'P'),
(102712, 'Hendersonville (historical)', 37.1455612182617, 0.648312345759783, -78.0877838134766, -1.3628889331307, 218, 53, 'PPL', 'P'),
(142036, 'Hendley', 40.1302795410156, 0.700405507736442, -99.9694366455078, -1.74479582082799, 218, 35, 'PPL', 'P'),
(87691, 'Hendon', 35.4197196960449, 0.618190728829469, -85.2416687011719, -1.48774777872965, 218, 50, 'PPL', 'P'),
(65500, 'Hendrick Estates', 35.6980590820313, 0.62304866755291, -80.5322189331055, -1.40555237431961, 218, 33, 'PPL', 'P'),
(3058, 'Hendrick Mill', 33.8758316040039, 0.59124479834102, -86.5688934326172, -1.51091222020727, 218, 2, 'PPL', 'P'),
(21835, 'Hendricks', 32.9391708374023, 0.574896983989569, -84.466667175293, -1.47422145039508, 218, 13, 'PPL', 'P'),
(30050, 'Hendricks', 39.6080589294434, 0.691291038642727, -86.1483306884766, -1.50357201561079, 218, 19, 'PPL', 'P'),
(36367, 'Hendricks', 37.7080612182617, 0.658129822802251, -83.1186065673828, -1.45069335427061, 218, 21, 'PPL', 'P'),
(81492, 'Hendricks', 34.9288902282715, 0.609624138551011, -82.591667175293, -1.44149652692019, 218, 48, 'PPL', 'P'),
(109622, 'Hendricks', 39.0750007629395, 0.68198741853259, -79.6311111450195, -1.38982507650214, 218, 58, 'PPL', 'P'),
(131282, 'Hendricks', 45.9805603027344, 0.802512169194516, -87.3530578613281, -1.52459847136529, 218, 27, 'PPL', 'P'),
(135884, 'Hendricks', 44.5072212219238, 0.776797551236065, -96.4238891601563, -1.6829143434228, 218, 28, 'PPL', 'P'),
(162607, 'Hendricks', 40.3050003051758, 0.703454960342637, -75.4633331298828, -1.31708362764577, 218, 45, 'PPL', 'P'),
(81493, 'Hendricks Corner', 33.8213882446289, 0.59029458246408, -79.1830596923828, -1.38200510343529, 218, 48, 'PPL', 'P'),
(127725, 'Hendricks Harbor', 43.8197212219238, 0.764798412628604, -69.6786117553711, -1.21612119335005, 218, 26, 'PPL', 'P'),
(188673, 'Hendricks Place', 35.3377799987793, 0.616760611324097, -103.498329162598, -1.80638661420019, 218, 38, 'PPL', 'P'),
(55251, 'Hendrickson', 36.9044418334961, 0.64410401860524, -90.4688873291016, -1.5789799545086, 218, 29, 'PPL', 'P'),
(145407, 'Hendrickson Corners', 40.410831451416, 0.705302062295688, -74.1369400024414, -1.2939337003961, 218, 37, 'PPL', 'P'),
(135887, 'Hendrickson Landing', 48.2999992370605, 0.842994015397456, -93.8199996948242, -1.63746789889476, 218, 28, 'PPL', 'P'),
(30052, 'Hendricksville', 39.1361083984375, 0.683053947970139, -86.7038879394531, -1.51326831882366, 218, 19, 'PPL', 'P'),
(3059, 'Hendrickville (historical)', 34.2633285522461, 0.598007895929276, -85.9241714477539, -1.49965969881141, 218, 2, 'PPL', 'P'),
(3060, 'Hendrix', 34.0380592346191, 0.594076204632965, -86.4533309936523, -1.50889527515569, 218, 2, 'PPL', 'P'),
(60227, 'Hendrix', 33.4663887023926, 0.584098671608983, -89.628059387207, -1.56430473847977, 218, 30, 'PPL', 'P'),
(76064, 'Hendrix', 33.773609161377, 0.589460680147749, -96.4055633544922, -1.68259449777588, 218, 42, 'PPL', 'P'),
(94832, 'Hendrix', 33.021671295166, 0.576336888611947, -96.2347183227539, -1.67961268946137, 218, 51, 'PPL', 'P'),
(119983, 'Hendrix', 40.4194412231445, 0.705452331160196, -88.977783203125, -1.55295527802024, 218, 18, 'PPL', 'P'),
(65501, 'Hendrix (historical)', 36.1377792358398, 0.630723232024246, -81.408332824707, -1.42084344635051, 218, 33, 'PPL', 'P'),
(3061, 'Hendrixville', 34.2183303833008, 0.597222529723812, -85.9494400024414, -1.50010071828793, 218, 2, 'PPL', 'P'),
(36368, 'Hendron', 37.0394401550293, 0.64646018380066, -88.6291732788086, -1.54687088703579, 218, 21, 'PPL', 'P'),
(87692, 'Hendron', 35.9000015258789, 0.626573228097575, -83.8186111450195, -1.46291073892941, 218, 50, 'PPL', 'P'),
(135889, 'Hendrum', 47.2644386291504, 0.824920073185469, -96.8111114501953, -1.68967264732109, 218, 28, 'PPL', 'P'),
(155693, 'Hendrysburg', 40.0608291625977, 0.699193369966292, -81.1733322143555, -1.41674191195568, 218, 41, 'PPL', 'P'),
(182088, 'Hendy Grove', 39.0769386291504, 0.682021240678434, -123.462501525879, -2.15482715437511, 218, 6, 'PPL', 'P'),
(204263, 'Henefer', 41.0166702270508, 0.715875943666766, -111.497497558594, -1.9459984401318, 218, 52, 'PPL', 'P'),
(102713, 'Henegartown', 36.6775016784668, 0.640143165694992, -83.3002777099609, -1.45386411386446, 218, 53, 'PPL', 'P'),
(47999, 'Henekes Corner', 39.0361099243164, 0.681308645349756, -76.4933319091797, -1.33506049763603, 218, 25, 'PPL', 'P'),
(119984, 'Henkel', 41.6002807617188, 0.726061869046047, -89.1736068725586, -1.55637304580519, 218, 18, 'PPL', 'P'),
(186837, 'Henkel', 38.5200004577637, 0.672300835857699, -104.625831604004, -1.82606524412701, 218, 7, 'PPL', 'P'),
(94833, 'Henkhaus', 29.5102806091309, 0.515051559816771, -97.1522216796875, -1.69562614393796, 218, 51, 'PPL', 'P'),
(109623, 'Henlawson', 37.9022216796875, 0.661518562131322, -81.9883270263672, -1.43096625481196, 218, 58, 'PPL', 'P'),
(162609, 'Henlein', 41.3802795410156, 0.722222123386371, -80.357780456543, -1.40250784856143, 218, 45, 'PPL', 'P'),
(55252, 'Henley', 38.3444404602051, 0.669236735865508, -92.3222198486328, -1.6113267091087, 218, 29, 'PPL', 'P'),
(72878, 'Henley', 38.8447189331055, 0.677968242394469, -83.1561126708984, -1.45134795926655, 218, 41, 'PPL', 'P'),
(87693, 'Henley', 35.2097206115723, 0.614525553379248, -86.0950012207031, -1.50264124080981, 218, 50, 'PPL', 'P'),
(102714, 'Henley', 36.8519401550293, 0.643187691453171, -81.1130599975586, -1.4156899633251, 218, 53, 'PPL', 'P'),
(193632, 'Henley', 41.9022216796875, 0.731331732211096, -122.562217712402, -2.13911423762753, 218, 6, 'PPL', 'P'),
(200966, 'Henley', 42.1522216796875, 0.735695055341081, -121.697776794434, -2.12402689742002, 218, 43, 'PPL', 'P'),
(21836, 'Henley (historical)', 33.4372215270996, 0.583589608366615, -85.0202789306641, -1.48388379830405, 218, 13, 'PPL', 'P'),
(102715, 'Henley Fork', 37.8855590820313, 0.661227744940286, -76.8988876342773, -1.34213878033929, 218, 53, 'PPL', 'P'),
(48000, 'Henley Park', 39.4888916015625, 0.689211176410402, -76.2491683959961, -1.33079904041774, 218, 25, 'PPL', 'P'),
(102716, 'Henley Place', 37.1519393920898, 0.648423665893348, -80.4258270263672, -1.40369548524955, 218, 53, 'PPL', 'P'),
(60228, 'Henleyfield', 30.6969394683838, 0.535762664008695, -89.7638931274414, -1.56667548448216, 218, 30, 'PPL', 'P'),
(48001, 'Henleys', 39.4694404602051, 0.688871689950445, -77.2830581665039, -1.34884382101579, 218, 25, 'PPL', 'P'),
(102717, 'Henleys Fork', 37.7555618286133, 0.658958864849593, -76.9908294677734, -1.34374346805412, 218, 53, 'PPL', 'P'),
(182089, 'Henleyville', 39.9619407653809, 0.697467441842839, -122.325561523438, -2.13498380793488, 218, 6, 'PPL', 'P'),
(13918, 'Henlopen Acres', 38.7297210693359, 0.675961151038931, -75.086669921875, -1.31050961449491, 218, 10, 'PPL', 'P'),
(13919, 'Henlopen Keys', 38.726390838623, 0.67590302754814, -75.1011123657227, -1.31076168269209, 218, 10, 'PPL', 'P'),
(94834, 'Henly', 30.1944408416748, 0.526992408485873, -98.210563659668, -1.7140976961007, 218, 51, 'PPL', 'P'),
(76065, 'Hennepin', 34.5088882446289, 0.602293721071541, -97.3466720581055, -1.69901994327311, 218, 42, 'PPL', 'P'),
(119986, 'Hennepin', 41.2541694641113, 0.720021087324447, -89.3422164916992, -1.55931583880973, 218, 18, 'PPL', 'P'),
(72879, 'Hennessee (historical)', 39.8405609130859, 0.695348963774708, -83.9922180175781, -1.46594075045964, 218, 41, 'PPL', 'P'),
(76066, 'Hennessey', 36.1091690063477, 0.630223889319856, -97.8983306884766, -1.70864820272012, 218, 42, 'PPL', 'P'),
(94835, 'Hennessey', 29.7847194671631, 0.519841421484847, -95.5438919067383, -1.66755549394215, 218, 51, 'PPL', 'P'),
(9424, 'Hennessey (historical)', 33.4797210693359, 0.584331365309229, -93.559440612793, -1.63292028501734, 218, 4, 'PPL', 'P'),
(72880, 'Hennessey (historical)', 39.8311080932617, 0.695183980945178, -83.8772201538086, -1.4639336591041, 218, 41, 'PPL', 'P'),
(143951, 'Henniker', 43.1797218322754, 0.753628316068484, -71.8227767944336, -1.25354393298784, 218, 36, 'PPL', 'P'),
(143952, 'Henniker Junction', 43.1744384765625, 0.75353610411574, -71.8041687011719, -1.25321916049291, 218, 36, 'PPL', 'P'),
(87694, 'Henning', 35.672779083252, 0.622607448339311, -89.5733337402344, -1.56334959575482, 218, 50, 'PPL', 'P'),
(109624, 'Henning', 37.896110534668, 0.661411902529665, -80.3600006103516, -1.40254659755529, 218, 58, 'PPL', 'P'),
(119988, 'Henning', 40.3050003051758, 0.703454960342637, -87.7008285522461, -1.53066821496375, 218, 18, 'PPL', 'P'),
(135893, 'Henning', 46.3216705322266, 0.808465665811388, -95.4449996948242, -1.66582949923967, 218, 28, 'PPL', 'P'),
(145408, 'Henningers Mill', 40.3955612182617, 0.705035546449599, -74.2536087036133, -1.29596995336557, 218, 37, 'PPL', 'P'),
(72881, 'Hennings Mill', 39.0141716003418, 0.68092574936403, -84.0305633544922, -1.46661000284158, 218, 41, 'PPL', 'P'),
(162610, 'Henningsville', 40.4666709899902, 0.706276646096603, -75.67138671875, -1.3207148477921, 218, 45, 'PPL', 'P'),
(200967, 'Henrici', 45.3097190856934, 0.790803781199064, -122.545829772949, -2.13882821412646, 218, 43, 'PPL', 'P'),
(21837, 'Henrico', 33.6647186279297, 0.587560181814841, -84.3391723632813, -1.47199624614627, 218, 13, 'PPL', 'P'),
(65502, 'Henrico', 36.5341682434082, 0.637641525325026, -77.8311080932617, -1.35840909670302, 218, 33, 'PPL', 'P'),
(102728, 'Henrico', 36.5924987792969, 0.638659585230736, -78.6163864135742, -1.37211478893701, 218, 53, 'PPL', 'P'),
(9425, 'Henrico (historical)', 34.0138893127441, 0.593654359916297, -91.0111083984375, -1.5884434974422, 218, 4, 'PPL', 'P'),
(102719, 'Henricopolis (historical)', 37.3841705322266, 0.652476863914394, -77.3541717529297, -1.35008498724182, 218, 53, 'PPL', 'P'),
(16406, 'Henrietta', 30.3974990844727, 0.53053644339601, -84.2927780151367, -1.47118651201683, 218, 12, 'PPL', 'P'),
(55255, 'Henrietta', 38.6025009155273, 0.673740740480078, -93.6186065673828, -1.63395292573002, 218, 29, 'PPL', 'P'),
(65504, 'Henrietta', 35.2577781677246, 0.615364315964568, -81.79638671875, -1.42761626447675, 218, 33, 'PPL', 'P'),
(87695, 'Henrietta', 36.4052810668945, 0.635392019731264, -87.20361328125, -1.52199017139367, 218, 50, 'PPL', 'P'),
(94836, 'Henrietta', 33.8172187805176, 0.590221811587293, -98.1949996948242, -1.71382605366951, 218, 51, 'PPL', 'P'),
(109625, 'Henrietta', 38.9080581665039, 0.679073720562961, -81.0449981689453, -1.41450206032087, 218, 58, 'PPL', 'P'),
(149567, 'Henrietta', 43.0591697692871, 0.751524285649267, -77.6125030517578, -1.35459371896732, 218, 40, 'PPL', 'P'),
(155694, 'Henrietta', 41.3416709899902, 0.721548277051553, -82.3008270263672, -1.43642040872444, 218, 41, 'PPL', 'P'),
(162611, 'Henrietta', 40.264720916748, 0.702751952393883, -78.2975006103516, -1.3665491817329, 218, 45, 'PPL', 'P'),
(174482, 'Henrietta (historical)', 43.5083312988281, 0.759363633213052, -90.3952789306641, -1.57769524559875, 218, 57, 'PPL', 'P'),
(135897, 'Henriette', 45.8716697692871, 0.800611670861608, -93.1172180175781, -1.62520204470413, 218, 28, 'PPL', 'P'),
(192617, 'Henrieville', 37.5627784729004, 0.655594160549359, -111.993606567383, -1.95465717578397, 218, 52, 'PPL', 'P'),
(9427, 'Henry', 34.288890838623, 0.598454041990892, -93.9438934326172, -1.63963025254185, 218, 4, 'PPL', 'P'),
(30053, 'Henry', 39.785831451416, 0.694393754470724, -85.5875015258789, -1.49378370018226, 218, 19, 'PPL', 'P'),
(41306, 'Henry', 29.8830604553223, 0.521557795517889, -92.0783309936523, -1.60707004558038, 218, 22, 'PPL', 'P'),
(65505, 'Henry', 35.5583305358887, 0.620609944363697, -81.4258270263672, -1.42114877776949, 218, 33, 'PPL', 'P'),
(81494, 'Henry', 33.6852798461914, 0.587919042771729, -79.4977798461914, -1.38749800634163, 218, 48, 'PPL', 'P'),
(87696, 'Henry', 36.2038917541504, 0.63187711314555, -88.4197235107422, -1.54321529896549, 218, 50, 'PPL', 'P'),
(102722, 'Henry', 36.7966690063477, 0.642223027927317, -77.3930587768555, -1.35076369384562, 218, 53, 'PPL', 'P'),
(109626, 'Henry', 39.2230606079102, 0.684571550317321, -79.42138671875, -1.38616469474188, 218, 58, 'PPL', 'P'),
(119989, 'Henry', 41.1113891601563, 0.717529100913433, -89.3563919067383, -1.559563246475, 218, 18, 'PPL', 'P'),
(155696, 'Henry', 41.4308280944824, 0.723104362076487, -81.5991668701172, -1.42417412876782, 218, 41, 'PPL', 'P'),
(170494, 'Henry', 44.8772201538086, 0.783255250826316, -97.4661102294922, -1.70110453261636, 218, 49, 'PPL', 'P'),
(182090, 'Henry', 35.4897193908691, 0.619412453979543, -120.646942138672, -2.10568637278291, 218, 6, 'PPL', 'P'),
(186838, 'Henry', 37.3983306884766, 0.652724005263554, -105.906387329102, -1.84841515778523, 218, 7, 'PPL', 'P'),
(195085, 'Henry', 42.9069404602051, 0.74886738298775, -111.529998779297, -1.94656569344399, 218, 17, 'PPL', 'P'),
(199395, 'Henry', 41.9986114501953, 0.733014051071699, -104.046943664551, -1.81596174358347, 218, 35, 'PPL', 'P'),
(199989, 'Henry', 41.6969413757324, 0.727748915017585, -114.825561523438, -2.0040841140353, 218, 39, 'PPL', 'P'),
(41307, 'Henry City (historical)', 30.7222194671631, 0.536203883222294, -90.3638916015625, -1.57714743336252, 218, 22, 'PPL', 'P'),
(13920, 'Henry Clay', 39.7702789306641, 0.694122311776618, -75.5805587768555, -1.31912960115323, 218, 10, 'PPL', 'P'),
(36369, 'Henry Clay', 37.3113899230957, 0.651206602653454, -82.4766693115234, -1.43948943556465, 218, 21, 'PPL', 'P'),
(102723, 'Henry Clay Heights', 37.6738891601563, 0.657533407876128, -77.3894424438477, -1.35070057692779, 218, 53, 'PPL', 'P'),
(87698, 'Henry Crossroads', 35.9577789306641, 0.627581634044334, -83.5938873291016, -1.45898856843399, 218, 50, 'PPL', 'P'),
(102725, 'Henry Fork', 36.9661102294922, 0.645180335159795, -79.8705596923828, -1.39400424204275, 218, 53, 'PPL', 'P'),
(65506, 'Henry River', 35.6963882446289, 0.623019505938973, -81.4286117553711, -1.42119738045938, 218, 33, 'PPL', 'P'),
(76069, 'Henryetta', 35.4397201538086, 0.618539802669351, -95.9816665649414, -1.67519610310958, 218, 42, 'PPL', 'P'),
(193633, 'Henryford (historical)', 40.5727806091309, 0.708128608318644, -122.134719848633, -2.13165299235951, 218, 6, 'PPL', 'P'),
(207631, 'Henrys', 47.3444404602051, 0.826316368544998, -122.016387939453, -2.12958771093416, 218, 56, 'PPL', 'P'),
(21839, 'Henrys (historical)', 34.827220916748, 0.607849674316691, -85.3805618286133, -1.49017192111189, 218, 13, 'PPL', 'P'),
(162612, 'Henrys Bend', 41.4627799987793, 0.723662028008749, -79.600830078125, -1.38929657218382, 218, 45, 'PPL', 'P'),
(48002, 'Henrys Bridge', 39.5311088562012, 0.689948006505, -76.5686111450195, -1.33637436815982, 218, 25, 'PPL', 'P'),
(94837, 'Henrys Chapel', 32.1065216064453, 0.56036451339517, -95.0421371459961, -1.65879822132964, 218, 51, 'PPL', 'P'),
(48003, 'Henrys Crossroads', 38.4211082458496, 0.670574841155219, -75.8680572509766, -1.3241473961211, 218, 25, 'PPL', 'P'),
(102731, 'Henrys Mill', 36.7747192382813, 0.641839932204509, -79.1638870239258, -1.38167047724432, 218, 53, 'PPL', 'P'),
(162613, 'Henrys Mills', 41.6372184753418, 0.726706553766928, -79.0436096191406, -1.37957124051507, 218, 45, 'PPL', 'P'),
(174484, 'Henrysville', 44.4438896179199, 0.775692206225627, -87.7858276367188, -1.53215172884897, 218, 57, 'PPL', 'P'),
(36372, 'Henrysville (historical)', 36.9749984741211, 0.645335464293292, -86.9550018310547, -1.5176510830296, 218, 21, 'PPL', 'P'),
(48004, 'Henryton', 39.3511085510254, 0.686806408525088, -76.9136123657227, -1.34239577538449, 218, 25, 'PPL', 'P'),
(48005, 'Henryton Heights', 39.3238906860352, 0.686331367165645, -76.9222183227539, -1.34254597766997, 218, 25, 'PPL', 'P'),
(65508, 'Henrytown', 34.1730613708496, 0.596432436407413, -78.107780456543, -1.36323794039155, 218, 33, 'PPL', 'P'),
(102729, 'Henrytown', 36.8836097717285, 0.643740430537417, -81.7874984741211, -1.42746113534325, 218, 53, 'PPL', 'P'),
(135899, 'Henrytown', 43.5944404602051, 0.760866521595211, -91.9291687011719, -1.60446667245677, 218, 28, 'PPL', 'P'),
(3064, 'Henryville', 34.4244384765625, 0.600819794566236, -86.2622222900391, -1.50555979904842, 218, 2, 'PPL', 'P'),
(30057, 'Henryville', 38.5416717529297, 0.672679071311518, -85.7677764892578, -1.49693009185213, 218, 19, 'PPL', 'P'),
(87700, 'Henryville', 35.3919410705566, 0.61770590035302, -87.394172668457, -1.52531606012101, 218, 50, 'PPL', 'P'),
(162614, 'Henryville', 41.0936088562012, 0.717218776067411, -75.2416687011719, -1.31321485353021, 218, 45, 'PPL', 'P'),
(41314, 'Henryville (historical)', 31.547779083252, 0.550612616694545, -92.9649963378906, -1.62254527520066, 218, 22, 'PPL', 'P'),
(78451, 'Hensel', 39.8216705322266, 0.695019264431756, -76.2011108398438, -1.32996027783241, 218, 45, 'PPL', 'P'),
(140219, 'Hensel', 48.6883316040039, 0.84977169379268, -97.6661071777344, -1.70459513785713, 218, 34, 'PPL', 'P'),
(102730, 'Hensel Stone Woods', 38.9527816772461, 0.679854293078463, -78.216667175293, -1.36513837214544, 218, 53, 'PPL', 'P'),
(145409, 'Hensfoot', 40.6294403076172, 0.709117506610418, -74.9694366455078, -1.3084635078294, 218, 37, 'PPL', 'P'),
(36373, 'Henshaw', 37.6216697692871, 0.656622007572076, -88.0555572509766, -1.53685939870791, 218, 21, 'PPL', 'P'),
(116002, 'Henshaw', 40.8424987792969, 0.712836078440495, -94.8949966430664, -1.65623013509048, 218, 16, 'PPL', 'P'),
(182091, 'Henshaw', 34.0022201538086, 0.593450694671933, -117.462501525879, -2.05010739925545, 218, 6, 'PPL', 'P'),
(87701, 'Henshaw (historical)', 36.1455612182617, 0.63085905323984, -82.7302780151367, -1.44391574245441, 218, 50, 'PPL', 'P'),
(162615, 'Hensingersville', 40.4958305358887, 0.706785576180917, -75.5905609130859, -1.31930417136268, 218, 45, 'PPL', 'P'),
(9429, 'Henslee Heights', 34.2622184753418, 0.597988521432346, -92.0827789306641, -1.60714767672615, 218, 4, 'PPL', 'P'),
(198423, 'Hensler', 47.2602806091309, 0.824847502045765, -101.084442138672, -1.76425633786152, 218, 34, 'PPL', 'P'),
(162616, 'Henslertown', 41.5513916015625, 0.725208592232785, -77.0986099243164, -1.3456245918901, 218, 45, 'PPL', 'P'),
(9428, 'Hensley', 34.5052795410156, 0.60223073731176, -92.2055587768555, -1.60929058929728, 218, 4, 'PPL', 'P'),
(36375, 'Hensley', 37.2377815246582, 0.6499218937436, -83.6741714477539, -1.46038979064154, 218, 21, 'PPL', 'P'),
(55257, 'Hensley', 38.2433280944824, 0.667471992169167, -90.8708267211914, -1.58599512029403, 218, 29, 'PPL', 'P'),
(109627, 'Hensley', 37.4738883972168, 0.654042736056334, -81.6999969482422, -1.42593394561615, 218, 58, 'PPL', 'P'),
(65507, 'Hensley (historical)', 35.9777793884277, 0.627930707884216, -82.4497222900391, -1.43901912131614, 218, 33, 'PPL', 'P'),
(36376, 'Hensley Ford', 38.5763893127441, 0.673285007038538, -84.7077789306641, -1.47842964439157, 218, 21, 'PPL', 'P'),
(109628, 'Hensley Heights', 37.7291717529297, 0.658498271139064, -81.8797225952148, -1.4290707499061, 218, 58, 'PPL', 'P'),
(87702, 'Hensley Ridge (historical)', 35.1166687011719, 0.61290149116749, -87.4875030517578, -1.52694498260176, 218, 50, 'PPL', 'P'),
(36377, 'Hensleytown', 36.6586112976074, 0.63981346635204, -87.4127807617188, -1.52564083261595, 218, 21, 'PPL', 'P'),
(32734, 'Henson', 38.5055618286133, 0.67204883423955, -94.8655624389648, -1.6557164113162, 218, 20, 'PPL', 'P'),
(55258, 'Henson', 36.8561096191406, 0.643260462329957, -89.2525024414063, -1.55775003324682, 218, 29, 'PPL', 'P'),
(186839, 'Henson', 38.0208282470703, 0.663588637246641, -107.376388549805, -1.87407151909483, 218, 7, 'PPL', 'P'),
(3065, 'Henson Springs', 34.0191688537598, 0.593746505290013, -88.0641708374023, -1.53700973415144, 218, 2, 'PPL', 'P'),
(149569, 'Hensonville', 42.2897186279297, 0.738094829799352, -74.2169418334961, -1.29532999575562, 218, 40, 'PPL', 'P'),
(27413, 'Henton', 39.4636116027832, 0.688769957196804, -88.9044418334961, -1.55167522964229, 218, 18, 'PPL', 'P'),
(116003, 'Hentons (historical)', 41.0924987792969, 0.717199401570481, -95.8327789306641, -1.67259752367594, 218, 16, 'PPL', 'P'),
(21840, 'Hentown', 31.2797203063965, 0.545934108449548, -84.8369369506836, -1.48068387709627, 218, 13, 'PPL', 'P'),
(48006, 'Hepbron', 39.3044395446777, 0.685991880705687, -76.0363922119141, -1.32708539543567, 218, 25, 'PPL', 'P'),
(30061, 'Hepburn', 38.0702781677246, 0.664451701176908, -87.8011093139648, -1.53241844443215, 218, 19, 'PPL', 'P'),
(116004, 'Hepburn', 40.8491706848145, 0.712952525159159, -95.0169372558594, -1.65835840027561, 218, 16, 'PPL', 'P'),
(155699, 'Hepburn', 40.6213912963867, 0.708977024862916, -83.4697189331055, -1.45682142109694, 218, 41, 'PPL', 'P'),
(162617, 'Hepburn Heights', 41.3113899230957, 0.721019772733227, -77.0741729736328, -1.34519808664152, 218, 45, 'PPL', 'P'),
(162619, 'Hepburnia', 40.9463882446289, 0.714649291668676, -78.6155624389648, -1.37210040786712, 218, 45, 'PPL', 'P'),
(162620, 'Hepburnville', 41.3047218322754, 0.720903392593591, -77.0672225952148, -1.34507677965387, 218, 45, 'PPL', 'P'),
(65514, 'Hepco (historical)', 35.6652793884277, 0.622476553971734, -82.9899978637695, -1.44844870894584, 218, 33, 'PPL', 'P'),
(3066, 'Hephzibah', 31.7652797698975, 0.554408719801857, -86.0130615234375, -1.50121112330443, 218, 2, 'PPL', 'P'),
(21841, 'Hephzibah', 33.3138885498047, 0.581437041836531, -82.0969390869141, -1.43286189287588, 218, 13, 'PPL', 'P'),
(78452, 'Hephzibah', 39.9505615234375, 0.697268836604546, -75.8083267211914, -1.32310490171239, 218, 45, 'PPL', 'P'),
(125066, 'Hephzibah Heights', 42.1666717529297, 0.735947256696312, -73.1902770996094, -1.27741131583519, 218, 23, 'PPL', 'P'),
(32735, 'Hepler', 37.6611099243164, 0.657310368134834, -94.9680633544922, -1.65750538977846, 218, 20, 'PPL', 'P'),
(162621, 'Hepler', 40.6916694641113, 0.710203610281979, -76.5777816772461, -1.33653442414133, 218, 45, 'PPL', 'P'),
(102732, 'Hepners', 38.7616691589355, 0.676518750392166, -78.8036117553711, -1.37538248759453, 218, 53, 'PPL', 'P'),
(200968, 'Heppner', 45.353328704834, 0.791564912638609, -119.556671142578, -2.08665755416208, 218, 43, 'PPL', 'P'),
(202203, 'Heppner', 43.246940612793, 0.754801505107691, -103.549438476563, -1.80727864000732, 218, 49, 'PPL', 'P'),
(9431, 'Hepsey (historical)', 36.077220916748, 0.62966628996662, -92.4702835083008, -1.61391090747246, 218, 4, 'PPL', 'P'),
(3067, 'Hepsidam', 34.3613891601563, 0.599719376403816, -87.3330612182617, -1.52424946410444, 218, 2, 'PPL', 'P'),
(3068, 'Hepzibah', 33.4469413757324, 0.583759251728053, -86.2316665649414, -1.50502650104014, 218, 2, 'PPL', 'P'),
(109630, 'Hepzibah', 39.3325004577637, 0.686481636030153, -80.335563659668, -1.40212009230671, 218, 58, 'PPL', 'P'),
(27414, 'Herald', 37.9663887023926, 0.662638487948728, -88.1813888549805, -1.53905557450084, 218, 18, 'PPL', 'P'),
(102733, 'Herald', 36.9877815246582, 0.645558570613614, -82.4022216796875, -1.4381900792688, 218, 53, 'PPL', 'P'),
(182092, 'Herald', 38.2958297729492, 0.668388319321236, -121.24333190918, -2.11609533790349, 218, 6, 'PPL', 'P'),
(48007, 'Herald Harbor', 39.0536117553711, 0.681614109926788, -76.5694427490234, -1.33638888238776, 218, 25, 'PPL', 'P'),
(48008, 'Heraldry Square', 39.3236083984375, 0.686326440317629, -76.7624969482422, -1.33975831379893, 218, 25, 'PPL', 'P'),
(30059, 'Herbamount', 39.5077781677246, 0.689540809174327, -86.5588912963867, -1.51073764999781, 218, 19, 'PPL', 'P'),
(3069, 'Herbert', 31.8358306884766, 0.555640065621369, -86.8052825927734, -1.51503798936802, 218, 2, 'PPL', 'P'),
(9432, 'Herbert', 33.5511093139648, 0.585577325225222, -92.8380584716797, -1.62032979148983, 218, 4, 'PPL', 'P'),
(36378, 'Herbert', 37.7186088562012, 0.658313913812603, -86.7994384765625, -1.51493599029827, 218, 21, 'PPL', 'P'),
(78453, 'Herbert', 39.9436111450195, 0.697147529616893, -79.8308334350586, -1.39331088805295, 218, 45, 'PPL', 'P'),
(81495, 'Herbert', 34.503059387207, 0.6021919883179, -81.4241714477539, -1.42111988247166, 218, 48, 'PPL', 'P'),
(94838, 'Herbert', 29.5891704559326, 0.516428447389856, -95.5936126708984, -1.66842328498335, 218, 51, 'PPL', 'P'),
(119993, 'Herbert', 42.1547203063965, 0.735738664603932, -88.7761077880859, -1.54943537800748, 218, 18, 'PPL', 'P'),
(195086, 'Herbert', 43.7063903808594, 0.762820416307974, -111.659172058105, -1.94882019246479, 218, 17, 'PPL', 'P'),
(60229, 'Herbert (historical)', 32.6744384765625, 0.570276532656336, -88.9027786254883, -1.55164620118641, 218, 30, 'PPL', 'P'),
(155700, 'Herbert Corners', 41.0441703796387, 0.716355911874226, -80.7608337402344, -1.40954245542282, 218, 41, 'PPL', 'P'),
(87715, 'Herbert Domain', 35.7591705322266, 0.624115263569487, -85.2441711425781, -1.48779145457153, 218, 50, 'PPL', 'P'),
(21842, 'Herbert Heights', 31.8322200775146, 0.555577048572075, -81.6055603027344, -1.4242857152175, 218, 13, 'PPL', 'P'),
(60230, 'Herbert Springs', 32.603328704834, 0.569035433009331, -88.9286117553711, -1.55209707435896, 218, 30, 'PPL', 'P'),
(145410, 'Herberts', 40.4358291625977, 0.705738354661271, -74.4233322143555, -1.29893218744607, 218, 37, 'PPL', 'P'),
(102734, 'Herberts Corner', 36.7275009155273, 0.641015817005184, -76.3024978637695, -1.33172981521872, 218, 53, 'PPL', 'P'),
(145411, 'Herberts Corner', 40.3308296203613, 0.70390576693616, -74.2611083984375, -1.29610084773315, 218, 37, 'PPL', 'P'),
(145412, 'Herbertsville', 40.1119384765625, 0.700085395773414, -74.1094436645508, -1.29345379876766, 218, 37, 'PPL', 'P'),
(9433, 'Herbine', 33.8211097717285, 0.59028972219509, -92.0338897705078, -1.60629439991289, 218, 4, 'PPL', 'P'),
(125067, 'Herbonville', 41.9027786254883, 0.731341452749074, -71.3208312988281, -1.24478333142397, 218, 23, 'PPL', 'P'),
(27416, 'Herborn', 39.3025016784668, 0.685958058559843, -88.6288909912109, -1.54686596018777, 218, 18, 'PPL', 'P'),
(122802, 'Herbst', 40.514720916748, 0.707115275523869, -85.7872161865234, -1.49726937857501, 218, 19, 'PPL', 'P'),
(174485, 'Herbster', 46.8325004577637, 0.817381329929728, -91.2608337402344, -1.59280202688222, 218, 57, 'PPL', 'P'),
(193634, 'Hercraff Place', 40.2083282470703, 0.701767714634017, -122.544723510742, -2.13880890620856, 218, 6, 'PPL', 'P'),
(55259, 'Herculaneum', 38.2683296203613, 0.667908351113777, -90.379997253418, -1.57742853001558, 218, 29, 'PPL', 'P'),
(55260, 'Hercules', 36.7075004577637, 0.640666743165302, -92.8727798461914, -1.62093579379587, 218, 29, 'PPL', 'P'),
(182093, 'Hercules', 38.017219543457, 0.663525653486861, -122.287498474121, -2.13431948240095, 218, 6, 'PPL', 'P'),
(60231, 'Hercules Station', 31.1805591583252, 0.544203419925647, -88.9388885498047, -1.55227643825838, 218, 30, 'PPL', 'P'),
(36379, 'Herd', 37.3641700744629, 0.652127790074512, -83.8752822875977, -1.46389983695826, 218, 21, 'PPL', 'P'),
(76070, 'Herd', 36.8644409179688, 0.643405870925476, -96.2005615234375, -1.67901654085136, 218, 42, 'PPL', 'P'),
(36380, 'Herdon', 38.1783294677734, 0.666337552123821, -84.5938873291016, -1.47644186095393, 218, 21, 'PPL', 'P'),
(48009, 'Hereford', 39.5888900756836, 0.690956479030786, -76.6636123657227, -1.3380324522545, 218, 25, 'PPL', 'P'),
(55261, 'Hereford', 38.9916687011719, 0.68053299968227, -92.0936126708984, -1.60733676116355, 218, 29, 'PPL', 'P'),
(102746, 'Hereford', 37.2569389343262, 0.650256253618459, -81.3263931274414, -1.41941332884514, 218, 53, 'PPL', 'P'),
(109634, 'Hereford', 38.8197212219238, 0.677531950028887, -81.6175003051758, -1.42449410757279, 218, 58, 'PPL', 'P'),
(162622, 'Hereford', 40.4491691589355, 0.705971181519571, -75.5524978637695, -1.31863984582876, 218, 45, 'PPL', 'P'),
(178353, 'Hereford', 31.4383296966553, 0.548702364534145, -110.097221374512, -1.92155901028231, 218, 5, 'PPL', 'P'),
(191602, 'Hereford', 34.814998626709, 0.607636355113376, -102.397216796875, -1.78716857798391, 218, 51, 'PPL', 'P'),
(194232, 'Hereford', 40.9749984741211, 0.715148634373066, -104.305282592773, -1.82047060846702, 218, 7, 'PPL', 'P'),
(200969, 'Hereford', 44.4986114501953, 0.776647282371557, -118.036109924316, -2.06011875442528, 218, 43, 'PPL', 'P'),
(202204, 'Hereford', 44.3872184753418, 0.774703108196772, -102.894996643066, -1.79585647525002, 218, 49, 'PPL', 'P'),
(204266, 'Herefordshire Condominium', 41.1805610656738, 0.718736378414593, -112.023330688477, -1.95517595956432, 218, 52, 'PPL', 'P'),
(155701, 'Herefork', 41.0605583190918, 0.7166419353753, -82.3947219848633, -1.43805918490122, 218, 41, 'PPL', 'P'),
(211871, 'Herendeen Bay', 55.7680587768555, 0.97333624310185, -160.685836791992, -2.80449691334251, 218, 1, 'PPL', 'P'),
(9435, 'Hergett', 35.7675018310547, 0.624260672165005, -90.5911102294922, -1.58111314654175, 218, 4, 'PPL', 'P'),
(32736, 'Herington', 38.6711082458496, 0.674938164285204, -96.9422225952148, -1.69196096848774, 218, 20, 'PPL', 'P'),
(13921, 'Heritage', 39.7208290100098, 0.69325924784635, -75.6777801513672, -1.32082643424177, 218, 10, 'PPL', 'P'),
(21854, 'Heritage', 33.8891716003418, 0.59147762519932, -84.4775009155273, -1.47441053483248, 218, 13, 'PPL', 'P'),
(48010, 'Heritage', 39.4480590820313, 0.688498514502697, -77.0008316040039, -1.34391803826357, 218, 25, 'PPL', 'P'),
(81496, 'Heritage', 34.1797218322754, 0.596548683388995, -79.8899993896484, -1.39434352876563, 218, 48, 'PPL', 'P'),
(102736, 'Heritage Acres', 37.2938919067383, 0.650901204655449, -79.9622192382813, -1.39560400290956, 218, 53, 'PPL', 'P'),
(94839, 'Heritage Acres Colonia', 27.9349994659424, 0.487557717223552, -97.9059982299805, -1.7087820265649, 218, 51, 'PPL', 'P'),
(94840, 'Heritage Acres Number 2 Colonia', 27.9150009155273, 0.487208676673184, -97.9660034179688, -1.70982931466357, 218, 51, 'PPL', 'P'),
(178354, 'Heritage Court', 33.5816688537598, 0.586110689812538, -111.857223510742, -1.95227684240166, 218, 5, 'PPL', 'P'),
(9436, 'Heritage Estates', 36.2902793884277, 0.633384861796698, -92.3649978637695, -1.61207332632031, 218, 4, 'PPL', 'P'),
(21844, 'Heritage Estates', 33.8813896179199, 0.591341803983726, -84.834716796875, -1.48064512810241, 218, 13, 'PPL', 'P'),
(48013, 'Heritage Estates', 39.5505599975586, 0.690287492964958, -77.7597198486328, -1.35716313678703, 218, 25, 'PPL', 'P'),
(87703, 'Heritage Estates', 35.9097213745117, 0.626742871459013, -85.0430603027344, -1.4842814082548, 218, 50, 'PPL', 'P'),
(135907, 'Heritage Estates', 44.0261116027832, 0.768400604319045, -92.8566665649414, -1.62065456398476, 218, 28, 'PPL', 'P'),
(13922, 'Heritage Farms', 39.7188911437988, 0.693225425700506, -75.6833267211914, -1.32092324014739, 218, 10, 'PPL', 'P'),
(21846, 'Heritage Farms', 33.4436111450195, 0.583701128237262, -84.5208282470703, -1.475166739424, 218, 13, 'PPL', 'P'),
(48014, 'Heritage Farms', 39.336109161377, 0.686544619789933, -76.9513931274414, -1.34305517407039, 218, 25, 'PPL', 'P'),
(21847, 'Heritage Glen', 33.9833297729492, 0.593120995328981, -84.4219436645508, -1.47344087787958, 218, 13, 'PPL', 'P'),
(48015, 'Heritage Harbour', 38.9761085510254, 0.680261423830109, -76.5902786254883, -1.33675253703461, 218, 25, 'PPL', 'P'),
(48016, 'Heritage Heights', 39.2036094665527, 0.684232063857363, -76.9413909912109, -1.34288060386093, 218, 25, 'PPL', 'P'),
(178355, 'Heritage Highlands', 33.6061096191406, 0.586537261640142, -112.078330993652, -1.95613589597924, 218, 5, 'PPL', 'P'),
(48017, 'Heritage Hill', 39.1983299255371, 0.684139918483646, -76.6252822875977, -1.33736346618867, 218, 25, 'PPL', 'P'),
(172114, 'Heritage Hill Development', 43.6233291625977, 0.76137072456859, -72.9447174072266, -1.27312549069292, 218, 55, 'PPL', 'P'),
(21848, 'Heritage Hills', 33.0041694641113, 0.576031424034915, -85.1402816772461, -1.48597824134334, 218, 13, 'PPL', 'P'),
(48019, 'Heritage Hills', 38.8736114501953, 0.678472511946876, -76.7033309936523, -1.33872567308625, 218, 25, 'PPL', 'P'),
(65511, 'Heritage Hills', 35.9319381713867, 0.627130627713729, -81.5036087036133, -1.42250632413516, 218, 33, 'PPL', 'P'),
(81498, 'Heritage Hills', 33.9869384765625, 0.593183979088761, -81.2222213745117, -1.41759518876894, 218, 48, 'PPL', 'P'),
(87708, 'Heritage Hills', 35.1097183227539, 0.612780184179837, -85.129997253418, -1.48579874428587, 218, 50, 'PPL', 'P'),
(102738, 'Heritage Hills', 37.3530616760254, 0.651933911947155, -79.248893737793, -1.3831541242876, 218, 53, 'PPL', 'P'),
(149572, 'Heritage Hills', 41.3394393920898, 0.721509328320611, -73.6977767944336, -1.28626885646274, 218, 40, 'PPL', 'P'),
(186840, 'Heritage Hills', 39.5433311462402, 0.690161325708315, -104.878326416016, -1.83047210994082, 218, 7, 'PPL', 'P'),
(81500, 'Heritage Lakes', 34.8108291625977, 0.60756358423659, -82.2633285522461, -1.43576593688655, 218, 48, 'PPL', 'P'),
(48020, 'Heritage Manor', 38.3219413757324, 0.668844052762776, -75.5347213745117, -1.31832958756177, 218, 25, 'PPL', 'P'),
(48021, 'Heritage Mobile Home Park', 38.5941696166992, 0.673595331884559, -75.9341735839844, -1.32530134382143, 218, 25, 'PPL', 'P'),
(182094, 'Heritage Mobile Home Park', 33.5177803039551, 0.584995624264122, -117.117500305176, -2.04408599203078, 218, 6, 'PPL', 'P'),
(178356, 'Heritage North Ranch', 33.6388893127441, 0.587109375221318, -111.931938171387, -1.95358085922942, 218, 5, 'PPL', 'P'),
(3071, 'Heritage Oaks', 33.3758316040039, 0.582518152081048, -86.7125015258789, -1.51341865426719, 218, 2, 'PPL', 'P'),
(21849, 'Heritage Place', 34.1233291625977, 0.595564445629129, -84.5941696166992, -1.47644678780195, 218, 13, 'PPL', 'P'),
(21850, 'Heritage Square', 33.7874984741211, 0.589703094385973, -84.6483306884766, -1.47739207683087, 218, 13, 'PPL', 'P'),
(94841, 'Heritage Square Number 2 Colonia', 26.1840000152588, 0.456997011608511, -97.9850006103516, -1.71016087821929, 218, 51, 'PPL', 'P'),
(21851, 'Heritage Station', 33.9416694641113, 0.592393885772362, -84.0922164916992, -1.46768605308003, 218, 13, 'PPL', 'P'),
(41308, 'Heritage Subdivision', 30.2902793884277, 0.528665106677038, -89.7558288574219, -1.56653473641855, 218, 22, 'PPL', 'P'),
(81502, 'Heritage Subdivision', 33.4749984741211, 0.584248940473491, -80.8583297729492, -1.41124408220132, 218, 48, 'PPL', 'P'),
(178357, 'Heritage Terrace', 33.5666694641113, 0.585848901077383, -111.901672363281, -1.9530526212272, 218, 5, 'PPL', 'P'),
(13923, 'Heritage Village', 38.6575012207031, 0.674700676894997, -75.6319427490234, -1.32002642065031, 218, 10, 'PPL', 'P'),
(65512, 'Heritage Village', 36.2477798461914, 0.632643104854084, -80.4288864135742, -1.4037488816294, 218, 33, 'PPL', 'P'),
(70945, 'Heritage Village', 39.8908309936523, 0.696226342195835, -74.9052810668945, -1.30734378174908, 218, 37, 'PPL', 'P'),
(113554, 'Heritage Village', 41.4863891601563, 0.724074085608412, -73.2330627441406, -1.27815806620485, 218, 8, 'PPL', 'P'),
(119994, 'Heritage West', 41.8263893127441, 0.730008207728354, -88.3486099243164, -1.54197413273946, 218, 18, 'PPL', 'P'),
(48024, 'Heritage Woods', 39.1583290100098, 0.683441770803882, -76.817497253418, -1.34071825021384, 218, 25, 'PPL', 'P'),
(81505, 'Heritage Woods', 35.1105613708496, 0.61279489814486, -81.0611114501953, -1.41478329013198, 218, 48, 'PPL', 'P'),
(102739, 'Heritage Woods', 38.6925010681152, 0.675311539470034, -77.4208297729492, -1.35124838916402, 218, 53, 'PPL', 'P'),
(32738, 'Herkimer', 39.8911094665527, 0.696231202464824, -96.7108306884766, -1.68792241785269, 218, 20, 'PPL', 'P'),
(149570, 'Herkimer', 43.0255584716797, 0.75093765784015, -74.9863891601563, -1.30875938502651, 218, 40, 'PPL', 'P'),
(149578, 'Herkimer Landing', 43.5094413757324, 0.759383007709982, -74.8150024414063, -1.30576812249014, 218, 40, 'PPL', 'P'),
(72882, 'Herlan', 39.8086090087891, 0.694791297842445, -81.2938919067383, -1.41884607553295, 218, 41, 'PPL', 'P'),
(193635, 'Herlong', 40.1436080932617, 0.70063813485766, -120.133613586426, -2.09672709940172, 218, 6, 'PPL', 'P'),
(193636, 'Herlong Junction', 40.1247215270996, 0.700308502093735, -120.245559692383, -2.09868092753546, 218, 6, 'PPL', 'P'),
(9437, 'Herma', 33.2608299255371, 0.580510994146483, -92.6224975585938, -1.61656754381787, 218, 4, 'PPL', 'P'),
(9438, 'Herman', 35.8536109924316, 0.625763560547164, -90.8013916015625, -1.58478324883999, 218, 4, 'PPL', 'P'),
(70946, 'Herman', 39.6175003051758, 0.691455821735176, -74.5947189331055, -1.30192344998244, 218, 37, 'PPL', 'P'),
(94842, 'Herman', 33.1672210693359, 0.578877211396747, -97.5322189331055, -1.70225834715864, 218, 51, 'PPL', 'P'),
(131284, 'Herman', 46.6669387817383, 0.814491733567964, -88.366943359375, -1.54229411154443, 218, 27, 'PPL', 'P'),
(135902, 'Herman', 45.8086090087891, 0.799511052962105, -96.1430587768555, -1.67801292859456, 218, 28, 'PPL', 'P'),
(142040, 'Herman', 41.6733283996582, 0.727336790838895, -96.2147216796875, -1.67926368220052, 218, 35, 'PPL', 'P'),
(162624, 'Herman', 40.8300018310547, 0.712617965547218, -79.811393737793, -1.39297160133007, 218, 45, 'PPL', 'P'),
(195087, 'Herman', 43.1405601501465, 0.752944815774715, -111.430000305176, -1.9448203908236, 218, 17, 'PPL', 'P'),
(174486, 'Herman Center', 43.413890838623, 0.757715336235374, -88.4599990844727, -1.54391824033522, 218, 57, 'PPL', 'P'),
(78454, 'Herman Heights', 39.9858283996582, 0.697884359711491, -76.7041702270508, -1.33874032047224, 218, 45, 'PPL', 'P'),
(188674, 'Hermanas', 31.850830078125, 0.555901854356524, -107.951393127441, -1.88410724218863, 218, 38, 'PPL', 'P'),
(55262, 'Hermann', 38.7041702270508, 0.675515204714397, -91.4372177124023, -1.5958805079443, 218, 29, 'PPL', 'P'),
(32740, 'Hermansberg', 39.9338912963867, 0.696977886255455, -96.7680587768555, -1.68892123641952, 218, 20, 'PPL', 'P'),
(131285, 'Hermansville', 45.711109161377, 0.797809359604572, -87.601936340332, -1.52894222026127, 218, 27, 'PPL', 'P'),
(135904, 'Hermantown', 46.8069381713867, 0.816935183868112, -92.2380599975586, -1.60985784260947, 218, 28, 'PPL', 'P'),
(48026, 'Hermanville', 38.246940612793, 0.667535042507975, -76.429443359375, -1.33394543208761, 218, 25, 'PPL', 'P'),
(60234, 'Hermanville', 31.9591693878174, 0.557792732019994, -90.8399963378906, -1.58545702859578, 218, 30, 'PPL', 'P'),
(155704, 'Hermanville', 40.915828704834, 0.71411592708136, -81.9108276367188, -1.42961363529431, 218, 41, 'PPL', 'P'),
(162625, 'Herminie', 40.2633285522461, 0.702727651048936, -79.7177810668945, -1.39133775200131, 218, 45, 'PPL', 'P'),
(162626, 'Herminie Number 2', 40.2786102294922, 0.702994366632107, -79.6927795410156, -1.3909013930567, 218, 45, 'PPL', 'P'),
(200970, 'Hermiston', 45.8405609130859, 0.800068718894368, -119.288330078125, -2.08197411906907, 218, 43, 'PPL', 'P'),
(162627, 'Hermit Spring', 41.6780586242676, 0.727419348832687, -79.1841735839844, -1.38202454451125, 218, 45, 'PPL', 'P'),
(9439, 'Hermitage', 33.4463882446289, 0.583749597769101, -92.1738891601563, -1.60873785021304, 218, 4, 'PPL', 'P'),
(41310, 'Hermitage', 30.6450004577637, 0.534856157263146, -91.3383331298828, -1.59415464639987, 218, 22, 'PPL', 'P'),
(55263, 'Hermitage', 37.9413909912109, 0.662202195583146, -93.3161087036133, -1.62867334202699, 218, 29, 'PPL', 'P'),
(87710, 'Hermitage', 36.1961097717285, 0.631741291929956, -86.6224975585938, -1.51184778869821, 218, 50, 'PPL', 'P'),
(102740, 'Hermitage', 38.1413917541504, 0.66569286740294, -78.914436340332, -1.37731674149426, 218, 53, 'PPL', 'P'),
(112271, 'Hermitage', 34.3255615234375, 0.599094066179865, -85.065559387207, -1.48467409135753, 218, 13, 'PPL', 'P'),
(149575, 'Hermitage', 42.6483306884766, 0.744353790993256, -78.1997222900391, -1.36484262810638, 218, 40, 'PPL', 'P'),
(162628, 'Hermitage', 41.2333297729492, 0.71965736609857, -80.4488906860352, -1.40409802204831, 218, 45, 'PPL', 'P'),
(204273, 'Hermitage', 41.2508316040039, 0.719962830675602, -111.88111114502, -1.95269376027031, 218, 52, 'PPL', 'P'),
(102741, 'Hermitage Hamlet', 37.6450004577637, 0.657029204902749, -77.6805572509766, -1.3557814888135, 218, 53, 'PPL', 'P'),
(48027, 'Hermitage Hill', 38.9936103820801, 0.680566888407141, -76.6527786254883, -1.3378433678171, 218, 25, 'PPL', 'P'),
(36381, 'Hermitage Hills', 38.0663909912109, 0.664383857148139, -84.4491729736328, -1.4739161189761, 218, 21, 'PPL', 'P'),
(81507, 'Hermitage Hills', 34.8772201538086, 0.608722325626883, -82.3388900756836, -1.43708473425836, 218, 48, 'PPL', 'P'),
(87712, 'Hermitage Hills', 36.2013893127441, 0.631833437303672, -86.633056640625, -1.51203207944564, 218, 50, 'PPL', 'P'),
(81508, 'Hermitage Mill', 34.2422218322754, 0.597639514171491, -80.5891723632813, -1.40654639919648, 218, 48, 'PPL', 'P'),
(48028, 'Hermitage Park', 39.0794410705566, 0.682064916520311, -77.0641708374023, -1.34502351643207, 218, 25, 'PPL', 'P'),
(87713, 'Hermitage Springs', 36.5808296203613, 0.638455919986373, -85.7813873291016, -1.49716764582137, 218, 50, 'PPL', 'P'),
(87714, 'Hermitage Woods', 36.1777801513672, 0.63142137970401, -86.5999984741211, -1.51145510559548, 218, 50, 'PPL', 'P'),
(94843, 'Hermits Cove', 32.8994407653809, 0.574203563420739, -95.8852767944336, -1.67351378424898, 218, 51, 'PPL', 'P'),
(191598, 'Hermleigh', 32.6349983215332, 0.569588172093577, -100.758888244629, -1.75857435051778, 218, 51, 'PPL', 'P'),
(36382, 'Hermon', 36.7427787780762, 0.641282466009328, -87.1650009155273, -1.52131625847982, 218, 21, 'PPL', 'P'),
(119995, 'Hermon', 40.7569389343262, 0.711342777438261, -90.3197174072266, -1.57637644822694, 218, 18, 'PPL', 'P'),
(127726, 'Hermon', 44.810001373291, 0.782082061787109, -68.9138870239258, -1.2027742289149, 218, 26, 'PPL', 'P'),
(149576, 'Hermon', 44.4672203063965, 0.7760994035563, -75.230827331543, -1.31302563593476, 218, 40, 'PPL', 'P'),
(127727, 'Hermon Center', 44.7963905334473, 0.781844507817874, -68.8883285522461, -1.20232814943231, 218, 26, 'PPL', 'P'),
(127728, 'Hermon Pond', 44.7827796936035, 0.781606953848639, -68.9555587768555, -1.2035015382086, 218, 26, 'PPL', 'P'),
(55264, 'Hermondale', 36.0161094665527, 0.628599693950044, -89.9147186279297, -1.56930788606165, 218, 29, 'PPL', 'P'),
(102742, 'Hermosa', 36.939998626709, 0.644724601718256, -79.1216735839844, -1.38093371372875, 218, 53, 'PPL', 'P'),
(186841, 'Hermosa', 37.4152793884277, 0.653019815881634, -107.834716796875, -1.8820708560611, 218, 7, 'PPL', 'P'),
(188675, 'Hermosa', 33.1575012207031, 0.578707568035309, -107.729438781738, -1.880233408067, 218, 38, 'PPL', 'P'),
(191599, 'Hermosa', 31.3763904571533, 0.547621320868654, -103.64111328125, -1.80887866719024, 218, 51, 'PPL', 'P'),
(202209, 'Hermosa', 43.8397216796875, 0.765147486468486, -103.190559387207, -1.8010150182815, 218, 49, 'PPL', 'P'),
(209504, 'Hermosa', 41.0833282470703, 0.717039345588967, -105.486938476563, -1.84109439426471, 218, 59, 'PPL', 'P'),
(182095, 'Hermosa Beach', 33.8622207641602, 0.591007244371785, -118.398612976074, -2.06644562622698, 218, 6, 'PPL', 'P'),
(191600, 'Hermosa Vista Addition Colonia', 31.9069995880127, 0.556882197243296, -106.593002319336, -1.86039885005836, 218, 51, 'PPL', 'P'),
(94844, 'Hern Colonia', 26.3419990539551, 0.459754615048748, -98.1230010986328, -1.71256944110916, 218, 51, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(188676, 'Hernandez', 36.0627784729004, 0.629414221769445, -106.11888885498, -1.85212400907732, 218, 38, 'PPL', 'P'),
(16410, 'Hernando', 28.8997192382813, 0.504395253609956, -82.3747177124023, -1.43771004448231, 218, 12, 'PPL', 'P'),
(60235, 'Hernando', 34.8238906860352, 0.6077915508259, -89.9936065673828, -1.57068474034522, 218, 30, 'PPL', 'P'),
(16411, 'Hernando Beach', 28.4691696166992, 0.496880745120133, -82.6594390869141, -1.44267936991835, 218, 12, 'PPL', 'P'),
(9440, 'Herndon', 35.952220916748, 0.627484628401628, -90.7136077880859, -1.58325113226487, 218, 4, 'PPL', 'P'),
(21853, 'Herndon', 32.8202781677246, 0.572821915447206, -82.1294403076172, -1.43342914618806, 218, 13, 'PPL', 'P'),
(36383, 'Herndon', 36.7336082458496, 0.641122410027814, -87.5652770996094, -1.52830239580937, 218, 21, 'PPL', 'P'),
(55265, 'Herndon', 39.0041694641113, 0.680751179154575, -93.2699966430664, -1.62786853474557, 218, 29, 'PPL', 'P'),
(102743, 'Herndon', 38.9694404602051, 0.680145043690473, -77.3863906860352, -1.35064731370599, 218, 53, 'PPL', 'P'),
(109631, 'Herndon', 37.5052795410156, 0.65459061487159, -81.3405609130859, -1.41966060335235, 218, 58, 'PPL', 'P'),
(116006, 'Herndon', 41.8455581665039, 0.730342767340295, -94.3491668701172, -1.6467036083971, 218, 16, 'PPL', 'P'),
(162630, 'Herndon', 40.7094383239746, 0.710513735390919, -76.8427810668945, -1.34115953600647, 218, 45, 'PPL', 'P'),
(182097, 'Herndon', 36.836669921875, 0.642921175607081, -119.916389465332, -2.09293582327389, 218, 6, 'PPL', 'P'),
(187713, 'Herndon', 39.9097213745117, 0.696556041538786, -100.784721374512, -1.75902522369033, 218, 20, 'PPL', 'P'),
(191601, 'Herndon', 32.4819412231445, 0.566916821783146, -100.213333129883, -1.74905261751437, 218, 51, 'PPL', 'P'),
(102744, 'Herndon Heights', 38.9797210693359, 0.680324474168917, -77.3988876342773, -1.35086542659926, 218, 53, 'PPL', 'P'),
(109632, 'Herndon Heights', 37.5033302307129, 0.654556592988665, -81.35888671875, -1.41998044899927, 218, 58, 'PPL', 'P'),
(102745, 'Herndon Junction', 39.0141716003418, 0.68092574936403, -77.3711090087891, -1.35038059812282, 218, 53, 'PPL', 'P'),
(21855, 'Herndonville', 33.711109161377, 0.588369849365252, -83.6997222900391, -1.46083573696607, 218, 13, 'PPL', 'P'),
(155705, 'Herner Corners', 41.3708305358887, 0.722057207135867, -80.9902801513672, -1.41354705075397, 218, 41, 'PPL', 'P'),
(109633, 'Hernshaw', 38.2249984741211, 0.667152079943222, -81.6025009155273, -1.42423231883764, 218, 58, 'PPL', 'P'),
(48029, 'Hernwood', 39.3713912963867, 0.687160409212987, -76.8438873291016, -1.34117884392437, 218, 25, 'PPL', 'P'),
(48030, 'Hernwood Heights', 39.3794403076172, 0.687300890960489, -76.8288879394531, -1.34091705518922, 218, 25, 'PPL', 'P'),
(16413, 'Hero', 30.6169395446777, 0.53436640193868, -81.6561126708984, -1.42516802048664, 218, 12, 'PPL', 'P'),
(78455, 'Hero', 39.7241706848145, 0.693317571074223, -80.3483276367188, -1.4023428657319, 218, 45, 'PPL', 'P'),
(21856, 'Herod', 31.6986103057861, 0.553245118142575, -84.4413909912109, -1.47378029776051, 218, 13, 'PPL', 'P'),
(27417, 'Herod', 37.5802803039551, 0.655899625126392, -88.4361114501953, -1.54350132246657, 218, 18, 'PPL', 'P'),
(109636, 'Herold', 38.5672187805176, 0.673124951057024, -80.8099975585938, -1.41040052592604, 218, 58, 'PPL', 'P'),
(174490, 'Herold', 44.3055610656738, 0.773277917539416, -91.8419418334961, -1.60294427641962, 218, 57, 'PPL', 'P'),
(196692, 'Heron', 48.0588912963867, 0.838785887979994, -115.956108093262, -2.02381587402586, 218, 31, 'PPL', 'P'),
(3074, 'Heron Bay', 30.3544406890869, 0.529784932625903, -88.1302795410156, -1.53816354869372, 218, 2, 'PPL', 'P'),
(127730, 'Heron Island', 43.8302803039551, 0.764982703376037, -69.567497253418, -1.21418187944426, 218, 26, 'PPL', 'P'),
(135906, 'Heron Lake', 43.7949981689453, 0.764366913952984, -95.3199996948242, -1.66364783767467, 218, 28, 'PPL', 'P'),
(48032, 'Herons Watch', 39.0930595397949, 0.682302603647601, -76.4611129760742, -1.33449817117186, 218, 25, 'PPL', 'P'),
(13924, 'Heronwood', 38.7602806091309, 0.676494515626247, -75.2233276367188, -1.31289474156719, 218, 10, 'PPL', 'P'),
(9442, 'Herpel', 35.9075012207031, 0.626704122465153, -92.0266723632813, -1.60616843239333, 218, 4, 'PPL', 'P'),
(182098, 'Herpoco', 38.0116691589355, 0.663428781002209, -122.269996643066, -2.13401401782392, 218, 6, 'PPL', 'P'),
(30060, 'Herr', 39.9555587768555, 0.697356055130246, -86.4316711425781, -1.50851723943896, 218, 19, 'PPL', 'P'),
(202206, 'Herreid', 45.8347206115723, 0.799966786403645, -100.068893432617, -1.7465316692265, 218, 49, 'PPL', 'P'),
(65516, 'Herrell (historical)', 36.0569381713867, 0.629312289278722, -82.2158279418945, -1.43493689483921, 218, 33, 'PPL', 'P'),
(188677, 'Herrera', 35.1922187805176, 0.614220088802215, -107.114166259766, -1.86949487676153, 218, 38, 'PPL', 'P'),
(27418, 'Herrick', 39.2202796936035, 0.684523014206454, -88.9844436645508, -1.55307152500182, 218, 18, 'PPL', 'P'),
(131286, 'Herrick', 43.8005599975586, 0.764463986174717, -84.706672668457, -1.47841033647367, 218, 27, 'PPL', 'P'),
(140222, 'Herrick', 48.5138893127441, 0.846727101455474, -97.2280578613281, -1.69694973499973, 218, 34, 'PPL', 'P'),
(155706, 'Herrick', 40.2097206115723, 0.701792015978964, -80.8308334350586, -1.41076418057289, 218, 41, 'PPL', 'P'),
(177413, 'Herrick', 43.1150016784668, 0.752498736292127, -99.1875, -1.73114845182188, 218, 49, 'PPL', 'P'),
(195088, 'Herrick', 47.2727813720703, 0.82506568151807, -116.105560302734, -2.02642430715554, 218, 17, 'PPL', 'P'),
(9443, 'Herrick (historical)', 36.2611083984375, 0.632875731975302, -91.4038925170898, -1.59529887356223, 218, 4, 'PPL', 'P'),
(162632, 'Herrick Center', 41.7419395446777, 0.728534281223049, -75.4897232055664, -1.3175442213563, 218, 45, 'PPL', 'P'),
(162633, 'Herrick Corner', 41.7405586242676, 0.728510179615184, -75.4811096191406, -1.31739388591277, 218, 45, 'PPL', 'P'),
(55266, 'Herrick Ford', 37.8608283996582, 0.660796113106611, -92.9124984741211, -1.62162901462762, 218, 29, 'PPL', 'P'),
(149579, 'Herrick Grove', 44.0580596923828, 0.76895820367228, -76.190559387207, -1.32977612024304, 218, 40, 'PPL', 'P'),
(127731, 'Herricks', 44.3152809143066, 0.773447560900854, -68.706672668457, -1.19915765615457, 218, 26, 'PPL', 'P'),
(149585, 'Herricks', 40.7552795410156, 0.711313815561406, -73.6672210693359, -1.28573555845445, 218, 40, 'PPL', 'P'),
(127732, 'Herricks Corner', 44.355281829834, 0.774145708580618, -69.0133285522461, -1.20450981099731, 218, 26, 'PPL', 'P'),
(162636, 'Herrickville', 41.8063888549805, 0.729659133888471, -76.2566680908203, -1.33092993478531, 218, 45, 'PPL', 'P'),
(204275, 'Herriman', 40.5141716003418, 0.707105688143945, -112.032218933105, -1.95533108869782, 218, 52, 'PPL', 'P'),
(27420, 'Herrin', 37.8030586242676, 0.659787840317907, -89.0274963378906, -1.55382293590339, 218, 18, 'PPL', 'P'),
(199990, 'Herrin', 40.8877792358398, 0.713626371493976, -117.219169616699, -2.0458604562651, 218, 39, 'PPL', 'P'),
(27421, 'Herrin Junction', 37.8241691589355, 0.66015628865472, -89.0111083984375, -1.55353691240231, 218, 18, 'PPL', 'P'),
(21857, 'Herring', 30.6963901519775, 0.535753076628771, -83.158332824707, -1.45138670826041, 218, 13, 'PPL', 'P'),
(76071, 'Herring', 35.6100006103516, 0.621511757287825, -99.5175018310547, -1.73690807031139, 218, 42, 'PPL', 'P'),
(94845, 'Herring', 31.7588901519775, 0.55429719993121, -95.4008331298828, -1.66505864726214, 218, 51, 'PPL', 'P'),
(109635, 'Herring', 39.5424995422363, 0.690146811480374, -79.7383270263672, -1.39169634664209, 218, 58, 'PPL', 'P'),
(209974, 'Herring Cove', 55.3250007629395, 0.965603421981668, -131.522216796875, -2.29549572262726, 218, 1, 'PPL', 'P'),
(48033, 'Herring Creek', 38.1861114501953, 0.666473373339415, -76.5416717529297, -1.33590418706936, 218, 25, 'PPL', 'P'),
(13925, 'Herring Creek Estates', 38.6622200012207, 0.674783035151707, -75.1861114501953, -1.31224519657732, 218, 10, 'PPL', 'P'),
(48034, 'Herring Creek Estates', 38.1777801513672, 0.666327964743897, -76.529167175293, -1.33568594101803, 218, 25, 'PPL', 'P'),
(48035, 'Herring Estates', 39.6377792358398, 0.691809755844047, -77.1577835083008, -1.34665736576083, 218, 25, 'PPL', 'P'),
(13926, 'Herring Landing', 38.6500015258789, 0.674569782527419, -75.1355590820313, -1.31136289130817, 218, 10, 'PPL', 'P'),
(48036, 'Herring Landing', 38.3488883972168, 0.669314367011284, -75.1202774047852, -1.311096175725, 218, 25, 'PPL', 'P'),
(149580, 'Herrings', 44.0238914489746, 0.768361855325184, -75.654167175293, -1.32041431006308, 218, 40, 'PPL', 'P'),
(65519, 'Herrings Crossroads', 35.1744384765625, 0.613909763956194, -78.396110534668, -1.36827024958737, 218, 33, 'PPL', 'P'),
(131287, 'Herrington', 43.0602798461914, 0.751543660146198, -85.8283309936523, -1.49798696733073, 218, 27, 'PPL', 'P'),
(174491, 'Herrington', 43.7783317565918, 0.76407603018292, -91.2191696166992, -1.59207485074658, 218, 57, 'PPL', 'P'),
(48037, 'Herrington Manor', 39.4527816772461, 0.688580939338435, -79.4533309936523, -1.38672222751609, 218, 25, 'PPL', 'P'),
(140223, 'Herriott', 48.3544387817383, 0.843944164695369, -97.3888931274414, -1.69975683994673, 218, 34, 'PPL', 'P'),
(116007, 'Herrold', 41.7205581665039, 0.728161105775302, -93.7366714477539, -1.63601354662347, 218, 16, 'PPL', 'P'),
(9445, 'Herron', 36.1636085510254, 0.631174038617769, -92.2841720581055, -1.61066264989089, 218, 4, 'PPL', 'P'),
(131288, 'Herron', 45.0230598449707, 0.785800633617187, -83.6469421386719, -1.45991454954501, 218, 27, 'PPL', 'P'),
(196693, 'Herron', 48.5250015258789, 0.846921046161859, -109.778327941895, -1.91599326992015, 218, 31, 'PPL', 'P'),
(207633, 'Herron', 47.2744407653809, 0.825094643394924, -122.811111450195, -2.14345825283962, 218, 56, 'PPL', 'P'),
(36384, 'Herron Hill', 38.5897216796875, 0.673517700738783, -83.496940612793, -1.45729652903541, 218, 21, 'PPL', 'P'),
(78456, 'Herrville', 39.9463882446289, 0.697195999148732, -76.2572174072266, -1.33093952216524, 218, 45, 'PPL', 'P'),
(102747, 'Herschberger Hills', 37.3036117553711, 0.651070848016887, -79.9933319091797, -1.39614702145583, 218, 53, 'PPL', 'P'),
(119998, 'Herscher', 41.0491714477539, 0.716443196978953, -88.0977783203125, -1.53759629538153, 218, 18, 'PPL', 'P'),
(127733, 'Hersey', 46.0733299255371, 0.804131304558256, -68.4347229003906, -1.19441123730178, 218, 26, 'PPL', 'P'),
(131289, 'Hersey', 43.8486099243164, 0.765302615601983, -85.4444427490234, -1.49128685350225, 218, 27, 'PPL', 'P'),
(174493, 'Hersey', 44.9627799987793, 0.784748551828551, -92.2113876342773, -1.60939232205092, 218, 57, 'PPL', 'P'),
(188680, 'Hersey Place', 32.5127792358398, 0.567455046639451, -107.078330993652, -1.86886943337952, 218, 38, 'PPL', 'P'),
(162637, 'Hershey', 40.285831451416, 0.703120400730695, -76.6505584716797, -1.33780461882324, 218, 45, 'PPL', 'P'),
(182099, 'Hershey', 38.9255599975586, 0.679379185139993, -121.995559692383, -2.12922418944536, 218, 6, 'PPL', 'P'),
(199396, 'Hershey', 41.1586112976074, 0.718353282691785, -101.002220153809, -1.76282129350813, 218, 35, 'PPL', 'P'),
(162638, 'Hershey Mill', 40.0127792358398, 0.698354740539026, -75.5563888549805, -1.31870775643656, 218, 45, 'PPL', 'P'),
(27422, 'Hersman', 39.9500007629395, 0.69725904948754, -90.7411117553711, -1.58373116705136, 218, 18, 'PPL', 'P'),
(174492, 'Hertel', 45.8086090087891, 0.799511052962105, -92.1750030517578, -1.608757291289, 218, 57, 'PPL', 'P'),
(65521, 'Hertford', 36.189998626709, 0.631634632328298, -76.4663925170898, -1.33459031654557, 218, 33, 'PPL', 'P'),
(65523, 'Hertford Village', 35.7488899230957, 0.623935833091043, -78.6433334350586, -1.37258510318551, 218, 33, 'PPL', 'P'),
(94846, 'Herty', 31.3561096191406, 0.547267353470269, -94.6830596923828, -1.65253113749441, 218, 51, 'PPL', 'P'),
(9446, 'Hervey', 33.4980583190918, 0.584651410693229, -93.7769393920898, -1.63671635483514, 218, 4, 'PPL', 'P'),
(60236, 'Hervey (historical)', 31.8638896942139, 0.556129787656321, -90.7611083984375, -1.58408017431221, 218, 30, 'PPL', 'P'),
(27423, 'Hervey City', 39.7555618286133, 0.693865449889479, -88.850830078125, -1.55073952799329, 218, 18, 'PPL', 'P'),
(149581, 'Hervey Street', 42.3450012207031, 0.739059693062288, -74.1269378662109, -1.29375913018664, 218, 40, 'PPL', 'P'),
(70947, 'Herwood', 39.9377784729004, 0.697045730284225, -75.0055618286133, -1.30909401121748, 218, 37, 'PPL', 'P'),
(186842, 'Herzman Mesa', 39.6105613708496, 0.691334714484604, -105.309722900391, -1.83800139897469, 218, 7, 'PPL', 'P'),
(113312, 'Heshbon', 40.4719390869141, 0.706368591733238, -79.0947189331055, -1.38046326632219, 218, 45, 'PPL', 'P'),
(162639, 'Heshbon Park', 41.2816696166992, 0.720501055531907, -77.0599975585938, -1.34495067897625, 218, 45, 'PPL', 'P'),
(36385, 'Hesler', 38.4636116027832, 0.67131666467686, -84.7772216796875, -1.47964164900366, 218, 21, 'PPL', 'P'),
(72883, 'Heslop', 39.5158309936523, 0.689681357500856, -81.2844390869141, -1.41868109270342, 218, 41, 'PPL', 'P'),
(149582, 'Heslops Corner', 42.4777793884277, 0.741377109263847, -75.304443359375, -1.31431047800267, 218, 40, 'PPL', 'P'),
(198424, 'Hesnault', 48.0502815246582, 0.838635619115487, -101.557220458984, -1.77250787618302, 218, 34, 'PPL', 'P'),
(32742, 'Hesper', 38.898609161377, 0.678908804312458, -95.0744400024414, -1.65936201253241, 218, 20, 'PPL', 'P'),
(116008, 'Hesper', 43.4863891601563, 0.758980670648298, -91.7683334350586, -1.60165956750977, 218, 16, 'PPL', 'P'),
(140224, 'Hesper', 47.9863891601563, 0.837520486988043, -99.6294403076172, -1.73886176528707, 218, 34, 'PPL', 'P'),
(209878, 'Hesper', 45.7419395446777, 0.798347451302822, -108.708892822266, -1.89732810594617, 218, 31, 'PPL', 'P'),
(131291, 'Hesperia', 43.5688896179199, 0.760420575270677, -86.039436340332, -1.50167145069885, 218, 27, 'PPL', 'P'),
(182100, 'Hesperia', 34.4263916015625, 0.600853883028189, -117.300003051758, -2.04727126585257, 218, 6, 'PPL', 'P'),
(16414, 'Hesperides', 27.8838901519775, 0.48666569141643, -81.4591674804688, -1.42173067846767, 218, 12, 'PPL', 'P'),
(41311, 'Hesperides', 29.4458293914795, 0.513926673861835, -89.616943359375, -1.56411072719436, 218, 22, 'PPL', 'P'),
(186843, 'Hesperus', 37.2861099243164, 0.650765383439855, -108.038887023926, -1.88563429875768, 218, 7, 'PPL', 'P'),
(48038, 'Hess', 39.5558280944824, 0.690379438601593, -76.5258331298828, -1.33562775094821, 218, 25, 'PPL', 'P'),
(76072, 'Hess', 34.4647216796875, 0.601522869094017, -99.2719421386719, -1.73262224516913, 218, 42, 'PPL', 'P'),
(162640, 'Hess Island', 41.065559387207, 0.716729220480028, -76.1872177124023, -1.32971779701516, 218, 45, 'PPL', 'P'),
(182101, 'Hess Mill', 38.1025009155273, 0.665014094220106, -120.236671447754, -2.09852579840196, 218, 6, 'PPL', 'P'),
(32743, 'Hessdale', 38.9127807617188, 0.679156145398699, -96.2091674804688, -1.67916674313684, 218, 20, 'PPL', 'P'),
(78457, 'Hessdale', 39.9436111450195, 0.697147529616893, -76.210563659668, -1.33012526066195, 218, 45, 'PPL', 'P'),
(190302, 'Hesse Camp (historical)', 36.0988883972168, 0.630044458841412, -114.746940612793, -2.00271192028364, 218, 39, 'PPL', 'P'),
(131292, 'Hessel', 46.0041694641113, 0.802924226794178, -84.4258270263672, -1.47350865532932, 218, 27, 'PPL', 'P'),
(182102, 'Hessel', 38.348331451416, 0.669304646473305, -122.776107788086, -2.14284732368555, 218, 6, 'PPL', 'P'),
(207634, 'Hesseltine', 47.874439239502, 0.835566592275279, -118.828887939453, -2.07395534102684, 218, 56, 'PPL', 'P'),
(122803, 'Hessen Cassel', 40.9777793884277, 0.715197170483932, -85.0791702270508, -1.48491164532677, 218, 19, 'PPL', 'P'),
(102750, 'Hessian Hills', 38.0633316040039, 0.664330460768283, -78.5027770996094, -1.37013193234739, 218, 53, 'PPL', 'P'),
(186844, 'Hessie (historical)', 39.9550018310547, 0.697346334592267, -105.59944152832, -1.84305794293642, 218, 7, 'PPL', 'P'),
(41312, 'Hessmer', 31.059440612793, 0.542089502520883, -92.1211090087891, -1.60781666279198, 218, 22, 'PPL', 'P'),
(32744, 'Hesston', 38.1383285522461, 0.665639404444057, -97.4311065673828, -1.7004936034623, 218, 20, 'PPL', 'P'),
(122804, 'Hesston', 41.7527809143066, 0.728723498818499, -86.6608276367188, -1.51251677476404, 218, 19, 'PPL', 'P'),
(162642, 'Hesston', 40.4208297729492, 0.705476565926116, -78.1102828979492, -1.36328161623343, 218, 45, 'PPL', 'P'),
(70948, 'Hesstown', 39.3636093139648, 0.687024587997393, -74.9308319091797, -1.30778972807361, 218, 37, 'PPL', 'P'),
(122805, 'Hessville', 41.5955581665039, 0.725979444210309, -87.461669921875, -1.52649410942921, 218, 19, 'PPL', 'P'),
(149583, 'Hessville', 42.8738899230957, 0.748290542295639, -74.6875, -1.30354278508326, 218, 40, 'PPL', 'P'),
(155707, 'Hessville', 41.401668548584, 0.722595431992172, -83.2444381713867, -1.45288953006355, 218, 41, 'PPL', 'P'),
(55267, 'Hest', 36.8958282470703, 0.643953683161705, -92.6811065673828, -1.61759046399257, 218, 29, 'PPL', 'P'),
(36386, 'Hestand', 36.6541709899902, 0.639735968364319, -85.6294403076172, -1.49451567000787, 218, 21, 'PPL', 'P'),
(41313, 'Hester', 31.7388896942139, 0.553948126091328, -92.3291702270508, -1.61144801609636, 218, 22, 'PPL', 'P'),
(55268, 'Hester', 39.910831451416, 0.696575416035717, -91.6266708374023, -1.59918708875374, 218, 29, 'PPL', 'P'),
(65525, 'Hester', 36.1699981689453, 0.631285558488416, -78.6727828979492, -1.3730990932759, 218, 33, 'PPL', 'P'),
(76073, 'Hester', 34.8011093139648, 0.607393940875152, -99.4330596923828, -1.73543427696414, 218, 42, 'PPL', 'P'),
(81509, 'Hester', 34.0702781677246, 0.594638531097135, -82.5872192382813, -1.44141889577441, 218, 48, 'PPL', 'P'),
(3075, 'Hester Heights', 34.5430603027344, 0.602890135997664, -87.7088928222656, -1.53080896302736, 218, 2, 'PPL', 'P'),
(41315, 'Hester Landing', 30.9577808380127, 0.540315204734131, -92.4894409179688, -1.61424526734732, 218, 22, 'PPL', 'P'),
(65526, 'Hestertown', 34.5974998474121, 0.603840285295577, -78.9958267211914, -1.37873727161971, 218, 33, 'PPL', 'P'),
(60237, 'Hesterville', 33.1605606079102, 0.578760964415165, -89.654167175293, -1.56476040534229, 218, 30, 'PPL', 'P'),
(3076, 'Hestle', 31.9294395446777, 0.557273848371106, -87.628059387207, -1.52939815343989, 218, 2, 'PPL', 'P'),
(72884, 'Hestoria', 38.7338905334473, 0.676033921915718, -83.8363876342773, -1.4632209971964, 218, 41, 'PPL', 'P'),
(182103, 'Hetch Hetchy Junction', 37.8011093139648, 0.659753818434981, -120.486671447754, -2.10288912153195, 218, 6, 'PPL', 'P'),
(9447, 'Heth', 35.0774993896484, 0.612217857715667, -90.495002746582, -1.57943575452917, 218, 4, 'PPL', 'P'),
(131293, 'Hetherton', 45.0125007629395, 0.785616342869753, -84.370002746582, -1.47253433784452, 218, 27, 'PPL', 'P'),
(102748, 'Hethwood', 37.2152786254883, 0.64952914406184, -80.4541702270508, -1.40419016742203, 218, 53, 'PPL', 'P'),
(170501, 'Hetland', 44.378059387207, 0.77454325195234, -97.2347183227539, -1.69706598198131, 218, 49, 'PPL', 'P'),
(162641, 'Hetlerville', 41.0144386291504, 0.715836994935824, -76.2613906860352, -1.33101235962105, 218, 45, 'PPL', 'P'),
(162643, 'Hettesheimer Corners', 41.4300003051758, 0.723089914427573, -76.0619430541992, -1.32753134176021, 218, 45, 'PPL', 'P'),
(27425, 'Hettick', 39.3549995422363, 0.686874319132885, -90.0369415283203, -1.5714410780948, 218, 18, 'PPL', 'P'),
(109637, 'Hettie', 38.771671295166, 0.676693320601621, -80.4894409179688, -1.404805757108, 218, 58, 'PPL', 'P'),
(198425, 'Hettinger', 46.0013885498047, 0.802875690683311, -102.636390686035, -1.79134294983456, 218, 34, 'PPL', 'P'),
(109638, 'Hetzel', 37.8608283996582, 0.660796113106611, -81.8777770996094, -1.4290367946022, 218, 58, 'PPL', 'P'),
(155708, 'Hetzlerville (historical)', 40.2052803039551, 0.701714517991243, -84.7280578613281, -1.47878357850044, 218, 41, 'PPL', 'P'),
(9449, 'Heubner', 36.2169418334961, 0.632104879997779, -90.3119430541992, -1.5762407601694, 218, 4, 'PPL', 'P'),
(55269, 'Heuer', 39.7083282470703, 0.693041068374045, -92.807502746582, -1.61979649348154, 218, 29, 'PPL', 'P'),
(204280, 'Heughs Canyon', 40.6399993896484, 0.709301797357851, -111.797500610352, -1.95123448115101, 218, 52, 'PPL', 'P'),
(142043, 'Heun', 41.6300010681152, 0.726580586247367, -97.040283203125, -1.69367244896228, 218, 35, 'PPL', 'P'),
(30063, 'Heusler', 37.9336090087891, 0.662066374367552, -87.7127838134766, -1.53087687363515, 218, 19, 'PPL', 'P'),
(102749, 'Heusley', 36.6988906860352, 0.640516474300794, -79.8958282470703, -1.39444526151927, 218, 53, 'PPL', 'P'),
(9450, 'Heustess', 34.934440612793, 0.609721011035663, -90.7733306884766, -1.58429349351553, 218, 4, 'PPL', 'P'),
(149584, 'Heuvelton', 44.6180610656738, 0.778732071451898, -75.4075012207031, -1.31610917700291, 218, 40, 'PPL', 'P'),
(162644, 'Heverly', 40.7416687011719, 0.711076261592171, -78.5025024414063, -1.37012713865743, 218, 45, 'PPL', 'P'),
(204277, 'Hew-Wood Estates', 40.6511116027832, 0.709495742064236, -111.944442749023, -1.95379910528075, 218, 52, 'PPL', 'P'),
(182104, 'Hewes Park', 33.7805595397949, 0.589581987135402, -117.815277099609, -2.05626449453766, 218, 6, 'PPL', 'P'),
(109639, 'Hewett', 37.9622192382813, 0.662565717071942, -81.8522186279297, -1.42859071511961, 218, 58, 'PPL', 'P'),
(32745, 'Hewins', 37.040828704834, 0.64648441856658, -96.4080581665039, -1.6826380404597, 218, 20, 'PPL', 'P'),
(65527, 'Hewitt', 35.3088912963867, 0.616256408350717, -83.6477813720703, -1.45992919693101, 218, 33, 'PPL', 'P'),
(72885, 'Hewitt', 39.9891700744629, 0.697942682939363, -84.6830596923828, -1.47799821229498, 218, 41, 'PPL', 'P'),
(76074, 'Hewitt', 34.1688919067383, 0.596359665530626, -97.4044418334961, -1.70002821606181, 218, 42, 'PPL', 'P'),
(78458, 'Hewitt', 39.7547187805176, 0.693850735924457, -78.5155563354492, -1.37035497208868, 218, 45, 'PPL', 'P'),
(94847, 'Hewitt', 31.4622192382813, 0.54911931569231, -97.195556640625, -1.69638248168755, 218, 51, 'PPL', 'P'),
(135911, 'Hewitt', 46.3255615234375, 0.808533576419185, -95.0863876342773, -1.65957053804576, 218, 28, 'PPL', 'P'),
(145413, 'Hewitt', 41.1416702270508, 0.718057605231759, -74.3111114501953, -1.29697356562237, 218, 37, 'PPL', 'P'),
(174494, 'Hewitt', 44.6450004577637, 0.779202252542352, -90.0999984741211, -1.57254162941528, 218, 57, 'PPL', 'P'),
(182105, 'Hewitt', 34.1997184753418, 0.59689769064985, -118.389167785645, -2.0662807765555, 218, 6, 'PPL', 'P'),
(48039, 'Hewitt Farms', 39.4258308410645, 0.6881105585109, -76.8013916015625, -1.34043715356079, 218, 25, 'PPL', 'P'),
(188678, 'Hewitt Place', 34.5652809143066, 0.603277958831407, -106.344718933105, -1.85606548749064, 218, 38, 'PPL', 'P'),
(209505, 'Hewitt Place', 44.2449989318848, 0.772220908902764, -108.51611328125, -1.89396346822496, 218, 59, 'PPL', 'P'),
(81510, 'Hewitt Subdivision', 34.1413917541504, 0.595879697323167, -79.7280578613281, -1.39151711590072, 218, 48, 'PPL', 'P'),
(172115, 'Hewitts Corners', 43.723331451416, 0.763116093768001, -72.4991683959961, -1.26534919346795, 218, 55, 'PPL', 'P'),
(27424, 'Hewittville', 39.5361099243164, 0.690035291609727, -89.216667175293, -1.55712458986481, 218, 18, 'PPL', 'P'),
(149586, 'Hewittville', 44.7044410705566, 0.780239686944992, -75.0111083984375, -1.30919081712311, 218, 40, 'PPL', 'P'),
(109640, 'Hewlet', 38.1674995422363, 0.666148534265453, -82.6269378662109, -1.44211211660616, 218, 58, 'PPL', 'P'),
(102751, 'Hewlett', 37.9222183227539, 0.661867569392177, -77.5766677856445, -1.35396827558532, 218, 53, 'PPL', 'P'),
(149587, 'Hewlett', 40.6430587768555, 0.709355193737707, -73.6961135864258, -1.28623982800686, 218, 40, 'PPL', 'P'),
(149588, 'Hewlett Bay Park', 40.6330604553223, 0.70918069010728, -73.6958312988281, -1.28623490115884, 218, 40, 'PPL', 'P'),
(149589, 'Hewlett Harbor', 40.6361083984375, 0.709233886750054, -73.6819381713867, -1.28599242034159, 218, 40, 'PPL', 'P'),
(149590, 'Hewlett Neck', 40.6233291625977, 0.70901084700876, -73.6986083984375, -1.28628337069068, 218, 40, 'PPL', 'P'),
(65528, 'Hexlena', 36.1930618286133, 0.631688095287181, -77.029167175293, -1.344412587278, 218, 33, 'PPL', 'P'),
(76076, 'Hext', 35.247501373291, 0.615184952065151, -99.7525024414063, -1.74100960470622, 218, 42, 'PPL', 'P'),
(94849, 'Hext', 30.8688907623291, 0.538763780241105, -99.5283279418945, -1.73709702159073, 218, 51, 'PPL', 'P'),
(188679, 'Hext Place', 32.8158302307129, 0.57274428430143, -108.928062438965, -1.9011533373779, 218, 38, 'PPL', 'P'),
(76077, 'Heyburn', 35.9122200012207, 0.626786480721863, -96.2836074829102, -1.68046596627463, 218, 42, 'PPL', 'P'),
(195089, 'Heyburn', 42.5586090087891, 0.742787852272289, -113.763061523438, -1.98553999073286, 218, 17, 'PPL', 'P'),
(94848, 'Heyser', 28.5855598449707, 0.498912137820619, -96.8358306884766, -1.69010407941768, 218, 51, 'PPL', 'P'),
(119999, 'Heyworth', 40.3133316040039, 0.703600368938155, -88.9736099243164, -1.55288244056442, 218, 18, 'PPL', 'P'),
(204278, 'Hi Country Estates', 40.5063896179199, 0.706969866928351, -112.070831298828, -1.95600500161166, 218, 52, 'PPL', 'P'),
(36387, 'Hi Hat', 37.3916702270508, 0.652607758281972, -82.7291717529297, -1.44389643453651, 218, 21, 'PPL', 'P'),
(142044, 'Hi Land Mobile Home Park', 41.2833290100098, 0.720530017408762, -96.2416687011719, -1.67973399644902, 218, 35, 'PPL', 'P'),
(21858, 'Hi Roc Shores', 33.711109161377, 0.588369849365252, -83.9749984741211, -1.46564021273063, 218, 13, 'PPL', 'P'),
(178358, 'Hi View Mobile Home Park', 33.5924987792969, 0.586299707670906, -112.096939086914, -1.95646066847418, 218, 5, 'PPL', 'P'),
(182106, 'Hi Vista', 34.7350006103516, 0.606240126332875, -117.776390075684, -2.05558578793385, 218, 6, 'PPL', 'P'),
(36388, 'Hi-Acres', 38.060001373291, 0.664272337277492, -84.4469375610352, -1.47387710366613, 218, 21, 'PPL', 'P'),
(41316, 'Hi-Land', 29.9086093902588, 0.52200370855291, -89.9036102294922, -1.56911400793429, 218, 22, 'PPL', 'P'),
(186845, 'Hi-Land Acres', 39.9883308410645, 0.697928035553368, -104.876937866211, -1.8304478751749, 218, 7, 'PPL', 'P'),
(70949, 'Hi-Nella', 39.8355598449707, 0.695261678669981, -75.0247192382813, -1.30942837109234, 218, 37, 'PPL', 'P'),
(48040, 'Hi-Point', 39.7058296203613, 0.692997459111195, -79.2108306884766, -1.38248979875368, 218, 25, 'PPL', 'P'),
(122806, 'Hi-View Addition', 41.6083297729492, 0.726202350793549, -86.1783294677734, -1.5040955930811, 218, 19, 'PPL', 'P'),
(48041, 'Hi-View Estates', 39.6500015258789, 0.692023075047363, -76.8349990844727, -1.34102371479088, 218, 25, 'PPL', 'P'),
(135913, 'Hi-Vue Park', 45.6138916015625, 0.796112593095055, -94.2050018310547, -1.64418745379919, 218, 28, 'PPL', 'P'),
(16415, 'Hialeah', 25.8572196960449, 0.451293619107511, -80.2783279418945, -1.40112114058182, 218, 12, 'PPL', 'P'),
(16416, 'Hialeah Estates', 25.8575000762939, 0.451298512666014, -80.291389465332, -1.40134910717113, 218, 12, 'PPL', 'P'),
(16417, 'Hialeah Gardens', 25.8647193908691, 0.451424513475089, -80.3247222900391, -1.40193087471126, 218, 12, 'PPL', 'P'),
(16418, 'Hiamonee (historical)', 30.6499996185303, 0.534943409078359, -84.283332824707, -1.47102166234535, 218, 12, 'PPL', 'P'),
(87716, 'Hiara Heights', 36.586669921875, 0.638557852477095, -82.602783203125, -1.4416905382056, 218, 50, 'PPL', 'P'),
(32746, 'Hiatt', 39.2305603027344, 0.684702444684898, -94.8722229003906, -1.65583265829778, 218, 20, 'PPL', 'P'),
(55270, 'Hiatt (historical)', 37.3122215270996, 0.651221116881395, -92.7041702270508, -1.61799300079134, 218, 29, 'PPL', 'P'),
(116010, 'Hiattsville', 40.827220916748, 0.712569429436351, -92.8102798461914, -1.61984496301338, 218, 16, 'PPL', 'P'),
(32747, 'Hiattville', 37.7222213745117, 0.65837696415141, -94.8713912963867, -1.65581814406984, 218, 20, 'PPL', 'P'),
(21859, 'Hiawassee', 34.9491691589355, 0.609978072659883, -83.7574996948242, -1.46184414291283, 218, 13, 'PPL', 'P'),
(87718, 'Hiawassee', 35.6150016784668, 0.621599042392552, -85.8944396972656, -1.49914078187301, 218, 50, 'PPL', 'P'),
(32748, 'Hiawatha', 39.8525009155273, 0.695557356130007, -95.5355606079102, -1.66741008534663, 218, 20, 'PPL', 'P'),
(76078, 'Hiawatha', 34.8925018310547, 0.608989041210054, -94.4669418334961, -1.64875916928448, 218, 42, 'PPL', 'P'),
(109641, 'Hiawatha', 37.439998626709, 0.653451247978227, -81.2441711425781, -1.41797828449175, 218, 58, 'PPL', 'P'),
(116011, 'Hiawatha', 42.035831451416, 0.733663662640596, -91.6819381713867, -1.60015168570057, 218, 16, 'PPL', 'P'),
(131294, 'Hiawatha', 46.1175003051758, 0.804902223114807, -86.2616729736328, -1.5055502116685, 218, 27, 'PPL', 'P'),
(192618, 'Hiawatha', 39.4844398498535, 0.689133478685599, -111.010833740234, -1.9375045541511, 218, 52, 'PPL', 'P'),
(194233, 'Hiawatha', 40.9883308410645, 0.715381328073311, -108.619720458984, -1.89577175460512, 218, 7, 'PPL', 'P'),
(170504, 'Hiawatha Beach', 45.4700012207031, 0.79360123218711, -96.7441711425781, -1.68850431855087, 218, 49, 'PPL', 'P'),
(131295, 'Hiawatha Location', 46.0738906860352, 0.804141091675262, -88.6447219848633, -1.54714226315087, 218, 27, 'PPL', 'P'),
(116012, 'Hiawatha Oak Brook Court', 42.038890838623, 0.733717059020452, -91.6722183227539, -1.59998204233913, 218, 16, 'PPL', 'P'),
(87717, 'Hiawatha Subdivision', 35.8777809143066, 0.626185405263832, -85.0444412231445, -1.48430550986267, 218, 50, 'PPL', 'P'),
(122807, 'Hibbard', 41.2533302307129, 0.720006439938452, -86.3869400024414, -1.5077365337654, 218, 19, 'PPL', 'P'),
(178359, 'Hibbard', 34.9700012207031, 0.610341660727706, -110.517776489258, -1.92889908172073, 218, 5, 'PPL', 'P'),
(195090, 'Hibbard', 43.855281829834, 0.765419062320647, -111.837783813477, -1.95193755567879, 218, 17, 'PPL', 'P'),
(196694, 'Hibbard (historical)', 46.624439239502, 0.81374997662535, -107.650001525879, -1.87884696640351, 218, 31, 'PPL', 'P'),
(149591, 'Hibbards Corner', 42.4311103820801, 0.740562581444447, -76.4283294677734, -1.33392599101165, 218, 40, 'PPL', 'P'),
(127735, 'Hibberts Corner', 44.3041687011719, 0.773253616194469, -69.4077835083008, -1.21139434873127, 218, 26, 'PPL', 'P'),
(155709, 'Hibbetts', 40.6419410705566, 0.709335686082722, -81.1127777099609, -1.41568503647708, 218, 41, 'PPL', 'P'),
(135914, 'Hibbing', 47.4272193908691, 0.827761133436366, -92.9375, -1.62206537357223, 218, 28, 'PPL', 'P'),
(78471, 'Hibbs', 39.9316711425781, 0.696939137261594, -79.8827819824219, -1.39421756124606, 218, 45, 'PPL', 'P'),
(16419, 'Hibernia', 30.0650005340576, 0.524733248933159, -81.6977767944336, -1.42589519662228, 218, 12, 'PPL', 'P'),
(36390, 'Hibernia', 37.4588890075684, 0.653780947321179, -85.5599975585938, -1.49330366539577, 218, 21, 'PPL', 'P'),
(81512, 'Hibernia', 33.8858299255371, 0.591419301971448, -81.585563659668, -1.42393670795664, 218, 48, 'PPL', 'P'),
(122808, 'Hibernia', 40.0041694641113, 0.698204471674518, -87.001106262207, -1.51845575715297, 218, 19, 'PPL', 'P'),
(145414, 'Hibernia', 40.9438896179199, 0.714605682405826, -74.4930572509766, -1.30014911890618, 218, 37, 'PPL', 'P'),
(149592, 'Hibernia', 41.8125, 0.729765793490129, -73.7630615234375, -1.28740828993513, 218, 40, 'PPL', 'P'),
(65529, 'Hibriten (historical)', 35.9294395446777, 0.627087018450879, -81.4972229003906, -1.42239487084354, 218, 33, 'PPL', 'P'),
(76079, 'Hibsaw', 35.7036094665527, 0.623145540037562, -97.1405563354492, -1.69542254527263, 218, 42, 'PPL', 'P'),
(211461, 'Hickam Village', 21.3452796936035, 0.372545410412468, -157.945007324219, -2.75666041489418, 218, 15, 'PPL', 'P'),
(162645, 'Hickernell', 41.7936096191406, 0.729436094147177, -80.2977828979492, -1.40146069362081, 218, 45, 'PPL', 'P'),
(87720, 'Hickey', 36.098331451416, 0.630034738303433, -85.7055587768555, -1.49584418791765, 218, 50, 'PPL', 'P'),
(94850, 'Hickey', 32.0941696166992, 0.560148930504928, -94.8722229003906, -1.65583265829778, 218, 51, 'PPL', 'P'),
(9452, 'Hickeytown', 35.4047203063965, 0.617928940094314, -93.3105621337891, -1.62857653612136, 218, 4, 'PPL', 'P'),
(178360, 'Hickiwan', 32.3688888549805, 0.564943685731507, -112.474716186523, -1.96305412270099, 218, 5, 'PPL', 'P'),
(81514, 'Hicklin Crossing', 34.790828704834, 0.607214510396707, -81.0483322143555, -1.41456025039069, 218, 48, 'PPL', 'P'),
(9453, 'Hickman', 35.9441719055176, 0.627344146654126, -89.7330627441406, -1.56613739278391, 218, 4, 'PPL', 'P'),
(13927, 'Hickman', 38.8330612182617, 0.677764776887187, -75.7230606079102, -1.32161672729525, 218, 10, 'PPL', 'P'),
(36389, 'Hickman', 36.5711097717285, 0.638286276624934, -89.1861114501953, -1.55659129185652, 218, 21, 'PPL', 'P'),
(48042, 'Hickman', 38.8330612182617, 0.677764776887187, -75.7233276367188, -1.32162138782716, 218, 25, 'PPL', 'P'),
(55271, 'Hickman', 36.9905586242676, 0.645607040145453, -90.116943359375, -1.57283737345433, 218, 29, 'PPL', 'P'),
(87721, 'Hickman', 36.1438903808594, 0.630829891625903, -85.940559387207, -1.49994572231248, 218, 50, 'PPL', 'P'),
(102753, 'Hickman', 37.0238914489746, 0.646188807685581, -79.9836120605469, -1.39597737809439, 218, 53, 'PPL', 'P'),
(120000, 'Hickman', 40.5675010681152, 0.708036462944927, -87.7644424438477, -1.5317784868222, 218, 18, 'PPL', 'P'),
(142046, 'Hickman', 40.6199989318848, 0.708952723517969, -96.6288909912109, -1.68649230034732, 218, 35, 'PPL', 'P'),
(155710, 'Hickman', 40.1497192382813, 0.700744794459318, -82.3097229003906, -1.43657567101599, 218, 41, 'PPL', 'P'),
(162646, 'Hickman', 40.3830604553223, 0.704817366977294, -80.1558303833008, -1.39898315485871, 218, 45, 'PPL', 'P'),
(182107, 'Hickman', 37.6236114501953, 0.656655896296947, -120.752777099609, -2.10753354131499, 218, 6, 'PPL', 'P'),
(21860, 'Hickman Forks', 32.9049987792969, 0.574300569063445, -84.4538879394531, -1.47399841065379, 218, 13, 'PPL', 'P'),
(9454, 'Hickman Landing', 35.9427795410156, 0.627319845309179, -89.6872177124023, -1.5653372460344, 218, 4, 'PPL', 'P'),
(60239, 'Hickman Landing', 32.935001373291, 0.574824213112782, -90.7788925170898, -1.58439056573726, 218, 30, 'PPL', 'P'),
(55272, 'Hickman Mills', 38.9194412231445, 0.679272392380281, -94.5183334350586, -1.64965612193961, 218, 29, 'PPL', 'P'),
(87726, 'Hickman Subdivision', 35.961109161377, 0.627639757535125, -84.5111083984375, -1.47499709606257, 218, 50, 'PPL', 'P'),
(13928, 'Hickman Village Estates Mobile Home Park', 38.5438919067383, 0.672717820305378, -75.5441665649414, -1.31849443723324, 218, 10, 'PPL', 'P'),
(65535, 'Hickmans Crossroads', 34.4530601501465, 0.601319337007708, -78.8288879394531, -1.37582364022911, 218, 33, 'PPL', 'P'),
(187715, 'Hickok', 37.5611114501953, 0.65556506551445, -101.228332519531, -1.76676769876947, 218, 20, 'PPL', 'P'),
(182108, 'Hickok Ranch', 38.7172203063965, 0.675742971566626, -121.045562744141, -2.11264361481464, 218, 6, 'PPL', 'P'),
(9457, 'Hickoria', 36.3911094665527, 0.635144678645022, -90.4433288574219, -1.57853387502601, 218, 4, 'PPL', 'P'),
(3077, 'Hickory', 33.1627807617188, 0.578799713409025, -88.0630569458008, -1.53699029307549, 218, 2, 'PPL', 'P'),
(36392, 'Hickory', 36.8224983215332, 0.64267383452084, -88.6474990844727, -1.54719073268271, 218, 21, 'PPL', 'P'),
(41318, 'Hickory', 30.9513893127441, 0.54020365157397, -92.0208282470703, -1.60606643332358, 218, 22, 'PPL', 'P'),
(48044, 'Hickory', 39.5786094665527, 0.690777048552342, -76.3455581665039, -1.33248135927834, 218, 25, 'PPL', 'P'),
(60238, 'Hickory', 32.3175010681152, 0.564046799655395, -89.0255584716797, -1.55378911375754, 218, 30, 'PPL', 'P'),
(65532, 'Hickory', 36.1288909912109, 0.630568102890749, -77.8013916015625, -1.35789044608073, 218, 33, 'PPL', 'P'),
(76080, 'Hickory', 34.5566711425781, 0.603127689966899, -96.8600006103516, -1.69052592413435, 218, 42, 'PPL', 'P'),
(87723, 'Hickory', 36.0424995422363, 0.629060287660573, -83.6558303833008, -1.46006967867851, 218, 50, 'PPL', 'P'),
(102754, 'Hickory', 36.6319389343262, 0.639347945793495, -76.2083282470703, -1.33008624535198, 218, 53, 'PPL', 'P'),
(162647, 'Hickory', 40.2988891601563, 0.703348300740979, -80.3088912963867, -1.40165457174817, 218, 45, 'PPL', 'P'),
(21861, 'Hickory Acres', 33.4841690063477, 0.584408996455005, -84.4713897705078, -1.47430387523082, 218, 13, 'PPL', 'P'),
(48043, 'Hickory Acres', 38.4425010681152, 0.670948216340048, -75.6641693115234, -1.32058888027254, 218, 25, 'PPL', 'P'),
(55273, 'Hickory Barren', 37.3477783203125, 0.651841699994411, -93.2211074829102, -1.62701525793231, 218, 29, 'PPL', 'P'),
(21862, 'Hickory Bluff', 31.0916690826416, 0.542651995432621, -81.5708312988281, -1.42367957975339, 218, 13, 'PPL', 'P'),
(81513, 'Hickory Bluff', 32.2222213745117, 0.562383855291722, -80.7569427490234, -1.40947454481502, 218, 48, 'PPL', 'P'),
(30065, 'Hickory Corner', 39.3050003051758, 0.686001667822693, -87.0444412231445, -1.51921209490255, 218, 19, 'PPL', 'P'),
(36393, 'Hickory Corner', 37.5872192382813, 0.656020732376963, -86.5336074829102, -1.51029636420519, 218, 21, 'PPL', 'P'),
(145415, 'Hickory Corner', 40.2719383239746, 0.702877919913444, -74.5569381713867, -1.30126405129654, 218, 37, 'PPL', 'P'),
(162648, 'Hickory Corner', 40.9324989318848, 0.714406877430451, -80.0025024414063, -1.39630707743734, 218, 45, 'PPL', 'P'),
(87724, 'Hickory Corners', 35.3433303833008, 0.616857483808748, -88.7024993896484, -1.54815066909763, 218, 50, 'PPL', 'P'),
(120001, 'Hickory Corners', 42.4661102294922, 0.741173444019483, -88.0169372558594, -1.53618535263601, 218, 18, 'PPL', 'P'),
(131297, 'Hickory Corners', 42.4413909912109, 0.740742011922891, -85.3755569458008, -1.49008456942814, 218, 27, 'PPL', 'P'),
(149597, 'Hickory Corners', 43.1855583190918, 0.75373018198018, -78.7541732788086, -1.37451962340135, 218, 40, 'PPL', 'P'),
(155711, 'Hickory Corners', 40.9730606079102, 0.715114812227222, -80.8561096191406, -1.41120533320746, 218, 41, 'PPL', 'P'),
(162650, 'Hickory Corners', 40.6558303833008, 0.709578100320947, -76.8644409179688, -1.34153757172321, 218, 45, 'PPL', 'P'),
(174498, 'Hickory Corners', 45.0047187805176, 0.785480521654159, -88.2538909912109, -1.54032097549279, 218, 57, 'PPL', 'P'),
(87725, 'Hickory Cove (historical)', 36.4888916015625, 0.636851298850573, -82.9480590820313, -1.44771673912023, 218, 50, 'PPL', 'P'),
(9458, 'Hickory Creek', 36.2541694641113, 0.632754624724731, -94.0344390869141, -1.6412105723327, 218, 4, 'PPL', 'P'),
(55275, 'Hickory Creek', 39.9980583190918, 0.698097812072861, -93.6691665649414, -1.63483536415721, 218, 29, 'PPL', 'P'),
(102755, 'Hickory Creek', 38.9897193908691, 0.680498977799344, -77.3027801513672, -1.34918803458668, 218, 53, 'PPL', 'P'),
(112590, 'Hickory Creek', 33.1222190856934, 0.578091778612255, -97.0427780151367, -1.6937159916461, 218, 51, 'PPL', 'P'),
(65536, 'Hickory Creek Apartments', 35.2897186279297, 0.615921782159749, -81.5341720581055, -1.4230397553015, 218, 33, 'PPL', 'P'),
(65538, 'Hickory Crossroads', 36.3202781677246, 0.633908439267008, -76.5449981689453, -1.33596224398113, 218, 33, 'PPL', 'P'),
(13929, 'Hickory Dale Acres', 39.211669921875, 0.684372745341946, -75.5625, -1.31881441603822, 218, 10, 'PPL', 'P'),
(21863, 'Hickory Flat', 34.1699981689453, 0.596378973448529, -84.4227828979492, -1.47345552526557, 218, 13, 'PPL', 'P'),
(36394, 'Hickory Flat', 36.7077789306641, 0.640671603434291, -86.4619369506836, -1.50904547744117, 218, 21, 'PPL', 'P'),
(60241, 'Hickory Flat', 34.6158294677734, 0.604160197521523, -89.1883316040039, -1.55663004085038, 218, 30, 'PPL', 'P'),
(87727, 'Hickory Flat', 35.8227806091309, 0.625225468848913, -88.5911102294922, -1.54620656150187, 218, 50, 'PPL', 'P'),
(102756, 'Hickory Flat', 36.6980590820313, 0.640501960072853, -80.9316711425781, -1.41252413057927, 218, 53, 'PPL', 'P'),
(112233, 'Hickory Flat', 35.6480598449707, 0.622176016242718, -93.420280456543, -1.63049148210319, 218, 4, 'PPL', 'P'),
(60240, 'Hickory Flat (historical)', 34.0183296203613, 0.593731857904018, -88.8769378662109, -1.5511951948558, 218, 30, 'PPL', 'P'),
(87729, 'Hickory Flats', 35.2363891601563, 0.614991007358766, -88.4286117553711, -1.54337042809899, 218, 50, 'PPL', 'P'),
(21865, 'Hickory Forest', 33.7852783203125, 0.589664345392113, -84.7155609130859, -1.47856546560716, 218, 13, 'PPL', 'P'),
(81515, 'Hickory Forest', 32.2477798461914, 0.562829934774311, -80.6975021362305, -1.40843711041238, 218, 48, 'PPL', 'P'),
(102764, 'Hickory Fork', 38.0566711425781, 0.664214213786701, -77.227783203125, -1.3478790909109, 218, 53, 'PPL', 'P'),
(87730, 'Hickory Forks', 35.6819381713867, 0.622767304583743, -88.166389465332, -1.53879378576569, 218, 50, 'PPL', 'P'),
(21866, 'Hickory Gap', 33.8777809143066, 0.591278820223946, -84.8625030517578, -1.48113008973691, 218, 13, 'PPL', 'P'),
(21867, 'Hickory Glen', 33.813060760498, 0.590149240447589, -84.7261123657227, -1.47874962319654, 218, 13, 'PPL', 'P'),
(3080, 'Hickory Grove', 34.4302787780762, 0.600921727056959, -87.4444427490234, -1.52619343854214, 218, 2, 'PPL', 'P'),
(9460, 'Hickory Grove', 35.1602783203125, 0.613662622607035, -93.4700012207031, -1.63135927314439, 218, 4, 'PPL', 'P'),
(36396, 'Hickory Grove', 36.6749992370605, 0.640099489853115, -84.4863891601563, -1.47456566396597, 218, 21, 'PPL', 'P'),
(60244, 'Hickory Grove', 30.9974994659424, 0.541008425565878, -89.4075012207031, -1.56045527228212, 218, 30, 'PPL', 'P'),
(65542, 'Hickory Grove', 36.5186080932617, 0.637369949472865, -79.5386123657227, -1.38821066824934, 218, 33, 'PPL', 'P'),
(81519, 'Hickory Grove', 34.9830589294434, 0.610569560737989, -81.4166717529297, -1.42098898810409, 218, 48, 'PPL', 'P'),
(87735, 'Hickory Grove', 36.3863906860352, 0.635062320388312, -86.2927780151367, -1.50609309705671, 218, 50, 'PPL', 'P'),
(102758, 'Hickory Grove', 38.9000015258789, 0.678933105657405, -77.628059387207, -1.35486522824045, 218, 53, 'PPL', 'P'),
(109644, 'Hickory Grove', 37.8338890075684, 0.660325932016158, -80.6761093139648, -1.40806373522755, 218, 58, 'PPL', 'P'),
(116013, 'Hickory Grove', 41.6547203063965, 0.72701201834396, -90.7494430541992, -1.58387657564688, 218, 16, 'PPL', 'P'),
(120003, 'Hickory Grove', 42.0597190856934, 0.734080580509248, -90.067497253418, -1.57197437610309, 218, 18, 'PPL', 'P'),
(149593, 'Hickory Grove', 43.5138893127441, 0.759460638855758, -76.3208312988281, -1.33204979402369, 218, 40, 'PPL', 'P'),
(155713, 'Hickory Grove', 41.4886093139648, 0.724112834602272, -82.9191665649414, -1.44721246956782, 218, 41, 'PPL', 'P'),
(162651, 'Hickory Grove', 41.9683303833008, 0.732485546753373, -75.6716690063477, -1.32071977464011, 218, 45, 'PPL', 'P'),
(174500, 'Hickory Grove', 44.2983283996582, 0.773151683703746, -87.8675003051758, -1.53357718582244, 218, 57, 'PPL', 'P'),
(65543, 'Hickory Grove (historical)', 35.7386093139648, 0.623756402612598, -81.7119369506836, -1.42614233797144, 218, 33, 'PPL', 'P'),
(81520, 'Hickory Grove (historical)', 33.2513885498047, 0.580346211054034, -79.8625030517578, -1.39386362713719, 218, 48, 'PPL', 'P'),
(102759, 'Hickory Grove Acres', 38.9038887023926, 0.679000949686175, -77.6111068725586, -1.35456935104335, 218, 53, 'PPL', 'P'),
(72886, 'Hickory Grove Cottage Area', 39.9422187805176, 0.697123228271946, -81.4136123657227, -1.42093559172423, 218, 41, 'PPL', 'P'),
(65545, 'Hickory Grove Crossroads', 34.7483291625977, 0.606472753454093, -78.4227828979492, -1.36873577014591, 218, 33, 'PPL', 'P'),
(116014, 'Hickory Grove Mobile Home Park', 41.5583305358887, 0.725329699483357, -90.6277770996094, -1.5817531041517, 218, 16, 'PPL', 'P'),
(81521, 'Hickory Hall Plantation', 32.834171295166, 0.573064396264458, -80.0736083984375, -1.39754811050532, 218, 48, 'PPL', 'P'),
(102760, 'Hickory Haven', 37.6650009155273, 0.657378278742631, -77.6755599975586, -1.3556942702878, 218, 53, 'PPL', 'P'),
(113555, 'Hickory Haven', 41.625, 0.72649330114264, -73.3947219848633, -1.28097955222173, 218, 8, 'PPL', 'P'),
(21868, 'Hickory Heights', 33.6141700744629, 0.586677943124725, -85.0366668701172, -1.48416982180513, 218, 13, 'PPL', 'P'),
(87737, 'Hickory Heights', 35.4447212219238, 0.618627087774078, -86.7675018310547, -1.51437859068211, 218, 50, 'PPL', 'P'),
(9462, 'Hickory Hill', 35.2430610656738, 0.61510745407743, -92.7330627441406, -1.61849727034374, 218, 4, 'PPL', 'P'),
(13931, 'Hickory Hill', 38.5386085510254, 0.672625608352634, -75.3069381713867, -1.3143540206865, 218, 10, 'PPL', 'P'),
(16420, 'Hickory Hill', 30.8219394683838, 0.537944325573688, -85.9250030517578, -1.49967421303935, 218, 12, 'PPL', 'P'),
(21869, 'Hickory Hill', 33.8811111450195, 0.591336943714737, -83.3886108398438, -1.45540581781951, 218, 13, 'PPL', 'P'),
(27428, 'Hickory Hill', 38.4963912963867, 0.671888778258037, -88.7502822875977, -1.54898463799298, 218, 18, 'PPL', 'P'),
(36397, 'Hickory Hill', 38.2874984741211, 0.668242910725718, -85.5683288574219, -1.49344907399129, 218, 21, 'PPL', 'P'),
(48053, 'Hickory Hill', 39.357780456543, 0.686922855243752, -77.1569366455078, -1.34664258521678, 218, 25, 'PPL', 'P'),
(55277, 'Hickory Hill', 38.4005584716797, 0.670216179935412, -92.3594436645508, -1.61197638725663, 218, 29, 'PPL', 'P'),
(65546, 'Hickory Hill', 35.8833312988281, 0.626282277748484, -80.4947204589844, -1.40489790248172, 218, 33, 'PPL', 'P'),
(76081, 'Hickory Hill', 36.9458312988281, 0.644826401050924, -96.1100006103516, -1.67743595474439, 218, 42, 'PPL', 'P'),
(81525, 'Hickory Hill', 35.0102806091309, 0.611044668676459, -81.0572204589844, -1.41471537952419, 218, 48, 'PPL', 'P'),
(87738, 'Hickory Hill', 35.2561111450195, 0.615335220929659, -86.3466720581055, -1.50703372555373, 218, 50, 'PPL', 'P'),
(94853, 'Hickory Hill', 32.9363899230957, 0.574848447878702, -95.0122222900391, -1.65827610859793, 218, 51, 'PPL', 'P'),
(102762, 'Hickory Hill', 37.2291717529297, 0.649771624879092, -76.5250015258789, -1.33561323672027, 218, 53, 'PPL', 'P'),
(109642, 'Hickory Hill', 38.4436111450195, 0.670967590836978, -81.9513931274414, -1.43032163667011, 218, 58, 'PPL', 'P'),
(162652, 'Hickory Hill', 40.1949996948242, 0.701535087512799, -78.2205581665039, -1.36520628275323, 218, 45, 'PPL', 'P'),
(81526, 'Hickory Hill (historical)', 32.8263893127441, 0.572928575048864, -81.0988922119141, -1.41544268881789, 218, 48, 'PPL', 'P'),
(48048, 'Hickory Hill Estates', 39.4280586242676, 0.688149440662815, -76.836669921875, -1.34105287640481, 218, 25, 'PPL', 'P'),
(87739, 'Hickory Hill Estates', 35.4025001525879, 0.617890191100454, -86.2191696166992, -1.50480838814686, 218, 50, 'PPL', 'P'),
(102763, 'Hickory Hill Estates', 37.2430610656738, 0.650014039117316, -77.445556640625, -1.35167995441867, 218, 53, 'PPL', 'P'),
(102766, 'Hickory Hill Mobile Home Park', 37.2208290100098, 0.649626016546492, -77.3622207641602, -1.35022546898932, 218, 53, 'PPL', 'P'),
(3082, 'Hickory Hills', 34.5486106872559, 0.602987008482316, -86.9250030517578, -1.51712750555929, 218, 2, 'PPL', 'P'),
(21870, 'Hickory Hills', 33.5888900756836, 0.586236723911126, -84.3702774047852, -1.47253913153448, 218, 13, 'PPL', 'P'),
(48051, 'Hickory Hills', 39.5802803039551, 0.690806210166278, -76.3552780151367, -1.33265100263978, 218, 25, 'PPL', 'P'),
(60246, 'Hickory Hills', 30.4566707611084, 0.531569183977229, -88.6391677856445, -1.54704532408719, 218, 30, 'PPL', 'P'),
(65548, 'Hickory Hills', 35.7708282470703, 0.624318729076769, -80.9508285522461, -1.41285849045413, 218, 33, 'PPL', 'P'),
(81527, 'Hickory Hills', 35.0305595397949, 0.611398602785331, -82.0305633544922, -1.43170341780169, 218, 48, 'PPL', 'P'),
(87745, 'Hickory Hills', 35.8800010681152, 0.626224154257693, -86.7363891601563, -1.51383557213585, 218, 50, 'PPL', 'P'),
(109643, 'Hickory Hills', 39.0638885498047, 0.681793473826205, -80.4266662597656, -1.40371013263554, 218, 58, 'PPL', 'P'),
(120005, 'Hickory Hills', 41.4894409179688, 0.724127348830213, -90.2513885498047, -1.5751838846908, 218, 18, 'PPL', 'P'),
(155714, 'Hickory Hills', 41.4688911437988, 0.723768687610407, -84.3730621337891, -1.47258773422437, 218, 41, 'PPL', 'P'),
(162653, 'Hickory Hills', 41.0374984741211, 0.716239465155562, -75.8208312988281, -1.32332314776372, 218, 45, 'PPL', 'P'),
(174502, 'Hickory Hills', 42.8638916015625, 0.748116038665211, -89.0216674804688, -1.55372120314974, 218, 57, 'PPL', 'P'),
(41320, 'Hickory Hills Estates', 32.0244407653809, 0.558931932465789, -93.684440612793, -1.63510194658233, 218, 22, 'PPL', 'P'),
(65551, 'Hickory Hills West Trailer Park', 34.7550010681152, 0.606589200172757, -77.4594421386719, -1.35192230207786, 218, 33, 'PPL', 'P'),
(30066, 'Hickory Island', 39.3294410705566, 0.686428239650297, -87.2394409179688, -1.52261548161762, 218, 19, 'PPL', 'P'),
(102767, 'Hickory Junction', 37.0288887023926, 0.646276026211281, -81.9677810668945, -1.43060766017118, 218, 53, 'PPL', 'P'),
(81528, 'Hickory Knob Subdivision', 33.8927803039551, 0.591540608959101, -82.4341735839844, -1.43874774520106, 218, 48, 'PPL', 'P'),
(48071, 'Hickory Meadow', 39.4605598449707, 0.688716693975002, -76.6961135864258, -1.33859970556669, 218, 25, 'PPL', 'P'),
(9465, 'Hickory Plains', 34.9900016784668, 0.610690734567588, -91.7366714477539, -1.60110696158358, 218, 4, 'PPL', 'P'),
(21873, 'Hickory Point', 33.8683280944824, 0.591113837394415, -83.3138885498047, -1.4541016678337, 218, 13, 'PPL', 'P'),
(48054, 'Hickory Point', 39.1352806091309, 0.683039500321226, -76.4436111450195, -1.33419270659482, 218, 25, 'PPL', 'P'),
(87749, 'Hickory Point', 36.4338912963867, 0.635891362435653, -87.2480621337891, -1.52276595021921, 218, 50, 'PPL', 'P'),
(120007, 'Hickory Point', 40.7772216796875, 0.711696778126159, -89.4180603027344, -1.56063956302955, 218, 18, 'PPL', 'P'),
(3084, 'Hickory Ridge', 33.3833312988281, 0.582649046448626, -86.720832824707, -1.51356406286271, 218, 2, 'PPL', 'P'),
(9467, 'Hickory Ridge', 35.3972206115723, 0.617798045726737, -90.9963912963867, -1.58818663555506, 218, 4, 'PPL', 'P'),
(13934, 'Hickory Ridge', 38.8133316040039, 0.67742043015824, -75.5852813720703, -1.31921202598896, 218, 10, 'PPL', 'P'),
(30067, 'Hickory Ridge', 38.2583312988281, 0.667733847483349, -87.8266677856445, -1.53286452391473, 218, 19, 'PPL', 'P'),
(48056, 'Hickory Ridge', 38.9722213745117, 0.68019357980134, -76.158332824707, -1.32921366062081, 218, 25, 'PPL', 'P'),
(55278, 'Hickory Ridge', 37.1733283996582, 0.64879697449915, -89.8050003051758, -1.56739294007983, 218, 29, 'PPL', 'P'),
(94854, 'Hickory Ridge', 31.2124996185303, 0.544760886120827, -93.6419372558594, -1.63436012306069, 218, 51, 'PPL', 'P'),
(102768, 'Hickory Ridge', 38.1647186279297, 0.666099998154586, -78.5236129760742, -1.37049558699424, 218, 53, 'PPL', 'P'),
(120008, 'Hickory Ridge', 41.9438896179199, 0.732058974925769, -89.1494369506836, -1.55595120108852, 218, 18, 'PPL', 'P'),
(131298, 'Hickory Ridge', 42.6797218322754, 0.744901669808513, -83.6650009155273, -1.46022973466002, 218, 27, 'PPL', 'P'),
(162654, 'Hickory Ridge', 40.1508293151855, 0.700764168956248, -76.654167175293, -1.33786760258302, 218, 45, 'PPL', 'P'),
(3085, 'Hickory Ridge Estates', 33.422779083252, 0.583337540169439, -86.7558288574219, -1.51417485885872, 218, 2, 'PPL', 'P'),
(48058, 'Hickory Ridge Farms', 39.5930595397949, 0.691029249907572, -76.9477767944336, -1.34299205715255, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(65557, 'Hickory Rock', 36.1241683959961, 0.630485678055011, -78.2102813720703, -1.36502691885382, 218, 33, 'PPL', 'P'),
(102769, 'Hickory Run', 38.9847183227539, 0.680411692694617, -77.2850036621094, -1.34887777631968, 218, 53, 'PPL', 'P'),
(162656, 'Hickory Run', 41.0233306884766, 0.715992190648348, -75.7108306884766, -1.32140327493388, 218, 45, 'PPL', 'P'),
(162655, 'Hickory Run (historical)', 41.0105590820313, 0.715769284065109, -75.732780456543, -1.32178637065669, 218, 45, 'PPL', 'P'),
(41322, 'Hickory Springs (historical)', 32.1758308410645, 0.561574187741311, -92.3177795410156, -1.61124921112098, 218, 22, 'PPL', 'P'),
(9471, 'Hickory Station', 34.4152793884277, 0.600659938321804, -93.491943359375, -1.63174223570914, 218, 4, 'PPL', 'P'),
(9472, 'Hickory Station (historical)', 34.3736114501953, 0.599932695607131, -93.5500030517578, -1.63275556850392, 218, 4, 'PPL', 'P'),
(81530, 'Hickory Tavern', 34.521110534668, 0.602507040274856, -82.1888885498047, -1.43446671374876, 218, 48, 'PPL', 'P'),
(48060, 'Hickory Thicket', 39.0766716003418, 0.682016580146526, -76.2300033569336, -1.33046454738482, 218, 25, 'PPL', 'P'),
(87751, 'Hickory Tree', 36.4911117553711, 0.636890047844433, -82.1519393920898, -1.4338218292908, 218, 50, 'PPL', 'P'),
(145416, 'Hickory Tree', 40.7463912963867, 0.711158686427909, -74.432502746582, -1.29909224342758, 218, 37, 'PPL', 'P'),
(9473, 'Hickory Valley', 35.8958282470703, 0.626500390641762, -91.5563888549805, -1.59796043675565, 218, 4, 'PPL', 'P'),
(41323, 'Hickory Valley', 32.0227813720703, 0.558902970588934, -92.4052810668945, -1.61277640084809, 218, 22, 'PPL', 'P'),
(87753, 'Hickory Valley', 35.0405616760254, 0.611573172994786, -85.1694412231445, -1.48648717142766, 218, 50, 'PPL', 'P'),
(87755, 'Hickory Withe', 35.2438888549805, 0.615121901726344, -89.5886077880859, -1.56361617817993, 218, 50, 'PPL', 'P'),
(13935, 'Hickory Woods', 39.5930595397949, 0.691029249907572, -75.7024993896484, -1.32125786633836, 218, 10, 'PPL', 'P'),
(21874, 'Hickory Woods', 32.5663909912109, 0.568390748288451, -83.6227798461914, -1.4594928379864, 218, 13, 'PPL', 'P'),
(87756, 'Hickory Woods', 35.8847198486328, 0.626306512514404, -84.1986083984375, -1.46954294215008, 218, 50, 'PPL', 'P'),
(102770, 'Hickory Woods', 37.2972183227539, 0.650959261567213, -79.8944396972656, -1.39442102675335, 218, 53, 'PPL', 'P'),
(149594, 'Hickorybush', 41.875560760498, 0.730866411389631, -74.0480575561523, -1.29238240906112, 218, 40, 'PPL', 'P'),
(162661, 'Hickorytown', 40.1133308410645, 0.700109697118361, -75.2847213745117, -1.31396626443178, 218, 45, 'PPL', 'P'),
(72888, 'Hickoryville', 39.4655609130859, 0.688803979079729, -83.9955596923828, -1.46599907368752, 218, 41, 'PPL', 'P'),
(21875, 'Hickox', 31.1502799987793, 0.543674948896834, -81.9966735839844, -1.43111192972359, 218, 13, 'PPL', 'P'),
(162662, 'Hickox', 41.9761085510254, 0.732621301389939, -77.8563919067383, -1.35885038249565, 218, 45, 'PPL', 'P'),
(3087, 'Hicks', 33.5808296203613, 0.586096042426543, -85.7774963378906, -1.49709973521357, 218, 2, 'PPL', 'P'),
(9476, 'Hicks', 35.9388885498047, 0.627251934701382, -94.0480575561523, -1.64144825945999, 218, 4, 'PPL', 'P'),
(21876, 'Hicks', 32.4824981689453, 0.566926542321125, -84.095832824707, -1.46774916999786, 218, 13, 'PPL', 'P'),
(27431, 'Hicks', 37.5430603027344, 0.655250013557494, -88.3755569458008, -1.54244444698797, 218, 18, 'PPL', 'P'),
(41324, 'Hicks', 31.1847190856934, 0.544276024354865, -93.0158309936523, -1.62343250731782, 218, 22, 'PPL', 'P'),
(55279, 'Hicks', 37.9225006103516, 0.661872496240194, -89.9952774047852, -1.57071390195916, 218, 29, 'PPL', 'P'),
(72889, 'Hicks', 39.3583297729492, 0.686932442623676, -84.0561065673828, -1.46705581600806, 218, 41, 'PPL', 'P'),
(94855, 'Hicks', 30.5402793884277, 0.533028429807024, -96.9886093139648, -1.69277056945913, 218, 51, 'PPL', 'P'),
(116017, 'Hicks', 42.3661117553711, 0.7394281413991, -92.5338897705078, -1.61502104617286, 218, 16, 'PPL', 'P'),
(122810, 'Hicks', 41.7063903808594, 0.727913831268088, -86.5691680908203, -1.51091701389723, 218, 19, 'PPL', 'P'),
(149595, 'Hicks', 42.1236114501953, 0.735195712636692, -76.6172180175781, -1.33722271812506, 218, 40, 'PPL', 'P'),
(55280, 'Hicks City', 38.8855590820313, 0.678681037460229, -94.1236114501953, -1.64276692367374, 218, 29, 'PPL', 'P'),
(127737, 'Hicks Corner', 45.0480613708496, 0.786236992561796, -69.0977783203125, -1.20598373750261, 218, 26, 'PPL', 'P'),
(120011, 'Hicks Corners', 41.3277816772461, 0.721305862813329, -89.2177810668945, -1.55714403094077, 218, 18, 'PPL', 'P'),
(41326, 'Hicks Crossing', 31.2275009155273, 0.545022708145496, -92.9402770996094, -1.62211384310407, 218, 22, 'PPL', 'P'),
(87758, 'Hicks Crossing', 35.9000015258789, 0.626573228097575, -83.7291717529297, -1.46134972705646, 218, 50, 'PPL', 'P'),
(94857, 'Hicks Crossing', 31.1669406890869, 0.543965732798357, -98.5052795410156, -1.71924145858813, 218, 51, 'PPL', 'P'),
(65560, 'Hicks Crossroads', 36.4286117553711, 0.635799217061937, -78.4986114501953, -1.37005922804963, 218, 33, 'PPL', 'P'),
(3094, 'Hicks Hill', 32.2391700744629, 0.562679665909803, -86.7486114501953, -1.51404889133916, 218, 2, 'PPL', 'P'),
(102772, 'Hicks Mill', 38.0938911437988, 0.664863825355598, -77.2583312988281, -1.34841225576114, 218, 53, 'PPL', 'P'),
(162663, 'Hicks Run', 41.3630599975586, 0.721921585657355, -78.2383270263672, -1.36551640786217, 218, 45, 'PPL', 'P'),
(9477, 'Hicks Station', 35.0941696166992, 0.612508808064758, -90.6127777099609, -1.58149131541655, 218, 4, 'PPL', 'P'),
(81531, 'Hicks Store', 34.6330604553223, 0.60446093498762, -83.0144424438477, -1.44887534735247, 218, 48, 'PPL', 'P'),
(65568, 'Hicks Village', 36.4049987792969, 0.635387092883247, -79.022216796875, -1.37919786533024, 218, 33, 'PPL', 'P'),
(94856, 'Hicksbaugh', 30.5616703033447, 0.53340177170234, -94.3499984741211, -1.64671812262504, 218, 51, 'PPL', 'P'),
(48061, 'Hicksburg', 38.5530586242676, 0.672877809707865, -75.9577789306641, -1.32571333484207, 218, 25, 'PPL', 'P'),
(140226, 'Hickson', 46.6694412231445, 0.814535409409842, -96.8099975585938, -1.68965320624513, 218, 34, 'PPL', 'P'),
(182109, 'Hickson', 34.2572212219238, 0.597901302906646, -118.466667175293, -2.06763339607315, 218, 6, 'PPL', 'P'),
(81532, 'Hickson (historical)', 34.7138900756836, 0.605871677996062, -79.8319396972656, -1.39333019597085, 218, 48, 'PPL', 'P'),
(94870, 'Hickston', 29.6027793884277, 0.516665968069577, -97.2747192382813, -1.69776412966108, 218, 51, 'PPL', 'P'),
(70951, 'Hickstown', 39.7791709899902, 0.694277507489142, -75.0124969482422, -1.30921505188902, 218, 37, 'PPL', 'P'),
(9478, 'Hicksville', 34.589168548584, 0.603694876700059, -90.9749984741211, -1.58781326037023, 218, 4, 'PPL', 'P'),
(36398, 'Hicksville', 36.7961082458496, 0.642213240810311, -88.5027770996094, -1.54466485754682, 218, 21, 'PPL', 'P'),
(87759, 'Hicksville', 35.6372184753418, 0.621986798647268, -88.8225021362305, -1.55024511213692, 218, 50, 'PPL', 'P'),
(102774, 'Hicksville', 37.1930618286133, 0.649141387807125, -81.1350021362305, -1.41607292588985, 218, 53, 'PPL', 'P'),
(149596, 'Hicksville', 40.7683296203613, 0.711541582413635, -73.5255584716797, -1.28326307969842, 218, 40, 'PPL', 'P'),
(155715, 'Hicksville', 41.2930603027344, 0.720699860507281, -84.7619400024414, -1.47937493342049, 218, 41, 'PPL', 'P'),
(162664, 'Hicksville', 40.5372200012207, 0.707507958626601, -79.4522171020508, -1.38670278644013, 218, 45, 'PPL', 'P'),
(182110, 'Hicksville', 38.327220916748, 0.668936198136493, -121.322219848633, -2.11747219218706, 218, 6, 'PPL', 'P'),
(9479, 'Hicksville (historical)', 35.0972213745117, 0.612562071286559, -91.6180572509766, -1.59903675331021, 218, 4, 'PPL', 'P'),
(162665, 'Hickton', 40.3711090087891, 0.704608774884914, -80.3636093139648, -1.40260958131507, 218, 45, 'PPL', 'P'),
(9481, 'Hico', 36.1902809143066, 0.631639559176315, -94.5408325195313, -1.65004880504235, 218, 4, 'PPL', 'P'),
(36399, 'Hico', 36.7294387817383, 0.641049639151028, -88.1833267211914, -1.53908939664669, 218, 21, 'PPL', 'P'),
(41327, 'Hico', 32.7447204589844, 0.571503184654426, -92.7136077880859, -1.61815771730476, 218, 22, 'PPL', 'P'),
(87760, 'Hico', 36.0911102294922, 0.629908704204845, -88.4894409179688, -1.54443209726755, 218, 50, 'PPL', 'P'),
(94858, 'Hico', 31.982780456543, 0.55820482290917, -98.033332824707, -1.71100443449457, 218, 51, 'PPL', 'P'),
(109645, 'Hico', 38.1172218322754, 0.665271022686271, -81.0058288574219, -1.41381842686905, 218, 58, 'PPL', 'P'),
(55281, 'Hico (historical)', 37.5694389343262, 0.655710407530941, -93.004997253418, -1.62324342288043, 218, 29, 'PPL', 'P'),
(16421, 'Hicoria', 27.1511096954346, 0.473876259755488, -81.3530578613281, -1.41987871624563, 218, 12, 'PPL', 'P'),
(55282, 'Hicoria Spur', 36.6647186279297, 0.639920059374671, -90.1741714477539, -1.57383619202117, 218, 29, 'PPL', 'P'),
(109646, 'Hicumbottom', 38.5638885498047, 0.673066827566233, -81.5608291625977, -1.42350500954394, 218, 58, 'PPL', 'P'),
(27432, 'Hidalgo', 39.1558303833008, 0.683398161541032, -88.1469421386719, -1.53845436588476, 218, 18, 'PPL', 'P'),
(36400, 'Hidalgo', 36.7355613708496, 0.641156498489767, -84.9475021362305, -1.48261360362214, 218, 21, 'PPL', 'P'),
(94859, 'Hidalgo', 26.1000003814697, 0.455530941428423, -98.2627792358398, -1.71500902982572, 218, 51, 'PPL', 'P'),
(94861, 'Hidalgo Park Estates Colonia', 26.1219997406006, 0.455914902678585, -98.1900024414063, -1.71373883514381, 218, 51, 'PPL', 'P'),
(200971, 'Hidaway Springs', 45.1311111450195, 0.787686484564099, -118.736671447754, -2.07234585962205, 218, 43, 'PPL', 'P'),
(13936, 'Hidden Acres', 38.547779083252, 0.672785664334148, -75.1513900756836, -1.31163919427127, 218, 10, 'PPL', 'P'),
(21877, 'Hidden Acres', 34.375560760498, 0.599966717490057, -83.7708282470703, -1.46207677003405, 218, 13, 'PPL', 'P'),
(41328, 'Hidden Acres', 32.5916709899902, 0.568831967502049, -93.9166717529297, -1.63915514460338, 218, 22, 'PPL', 'P'),
(48064, 'Hidden Acres', 39.1283302307129, 0.682918193333572, -76.2333297729492, -1.33052260429659, 218, 25, 'PPL', 'P'),
(94862, 'Hidden Acres', 28.1149997711182, 0.490699315203464, -97.8572235107422, -1.70793074712246, 218, 51, 'PPL', 'P'),
(102777, 'Hidden Acres', 37.2605590820313, 0.650319437115321, -80.0438919067383, -1.39702945988302, 218, 53, 'PPL', 'P'),
(94864, 'Hidden Acres Colonia', 28.1200008392334, 0.490786600308191, -97.8550033569336, -1.7078919981286, 218, 51, 'PPL', 'P'),
(81533, 'Hidden Acres Estates', 35.0363883972168, 0.611500335538972, -81.7077789306641, -1.42606976683174, 218, 48, 'PPL', 'P'),
(178361, 'Hidden Acres Mobile Home Park', 33.4527816772461, 0.583861184218775, -112.20027923584, -1.95826429432243, 218, 5, 'PPL', 'P'),
(21878, 'Hidden Acres of Fayette', 33.5055618286133, 0.584782371639834, -84.4861068725586, -1.47456073711796, 218, 13, 'PPL', 'P'),
(21879, 'Hidden Branches', 33.9483299255371, 0.592510132753944, -84.3455581665039, -1.47210769943788, 218, 13, 'PPL', 'P'),
(48065, 'Hidden Cove', 38.9777793884277, 0.680290585444046, -76.591667175293, -1.33677677180053, 218, 25, 'PPL', 'P'),
(204283, 'Hidden Cove Number 2', 40.663890838623, 0.70971878180553, -111.921669006348, -1.95340162848806, 218, 52, 'PPL', 'P'),
(204284, 'Hidden Cove Number 3', 40.6666717529297, 0.709767317916397, -111.923332214355, -1.95343065694394, 218, 52, 'PPL', 'P'),
(41329, 'Hidden Creek', 30.5933303833008, 0.533954344339017, -91.0072174072266, -1.5883755868344, 218, 22, 'PPL', 'P'),
(48066, 'Hidden Creek', 39.5574989318848, 0.690408600215529, -77.2125015258789, -1.34761237532773, 218, 25, 'PPL', 'P'),
(94865, 'Hidden Echo', 30.0536098480225, 0.524534443957785, -95.1191711425781, -1.66014271820596, 218, 51, 'PPL', 'P'),
(21881, 'Hidden Forest', 32.6650009155273, 0.570111816142914, -83.7744369506836, -1.46213975379383, 218, 13, 'PPL', 'P'),
(21882, 'Hidden Harbor', 34.2402801513672, 0.59760562544662, -83.9194412231445, -1.46467055577773, 218, 13, 'PPL', 'P'),
(48067, 'Hidden Harbor', 38.4483299255371, 0.671049949093689, -75.1222229003906, -1.3111301310289, 218, 25, 'PPL', 'P'),
(41330, 'Hidden Harbor Estates', 32.5416717529297, 0.567959316191858, -93.9166717529297, -1.63915514460338, 218, 22, 'PPL', 'P'),
(81534, 'Hidden Haven', 33.5013885498047, 0.58470953418402, -81.727783203125, -1.42641890725065, 218, 48, 'PPL', 'P'),
(204285, 'Hidden Hideaway Condominium', 41.0927810668945, 0.717204328418498, -111.936668395996, -1.95366341722321, 218, 52, 'PPL', 'P'),
(94866, 'Hidden Hill', 33.1122207641602, 0.577917274981828, -97.0616683959961, -1.69404569098906, 218, 51, 'PPL', 'P'),
(120012, 'Hidden Hill', 42.0416717529297, 0.733765595131319, -88.357780456543, -1.54213418872097, 218, 18, 'PPL', 'P'),
(21885, 'Hidden Hills', 33.3916702270508, 0.582794588202199, -82.0950012207031, -1.43282807073003, 218, 13, 'PPL', 'P'),
(48068, 'Hidden Hills', 39.0208282470703, 0.681041929766584, -76.503059387207, -1.33523027415552, 218, 25, 'PPL', 'P'),
(87763, 'Hidden Hills', 35.9752807617188, 0.627887098621366, -84.0374984741211, -1.46673104351312, 218, 50, 'PPL', 'P'),
(182111, 'Hidden Hills', 34.1602783203125, 0.596209330087091, -118.651390075684, -2.0708574188888, 218, 6, 'PPL', 'P'),
(21888, 'Hidden Hollow', 33.5672187805176, 0.585858488457308, -84.2941665649414, -1.47121074678275, 218, 13, 'PPL', 'P'),
(87771, 'Hidden Hollow Estates', 35.9874992370605, 0.628100351245654, -84.9194412231445, -1.48212384829767, 218, 50, 'PPL', 'P'),
(81536, 'Hidden Lake', 34.5263900756836, 0.602599185648573, -82.7666702270508, -1.4445509063744, 218, 48, 'PPL', 'P'),
(120013, 'Hidden Lake', 42.1438903808594, 0.735549646745563, -88.0119400024414, -1.53609813411031, 218, 18, 'PPL', 'P'),
(194234, 'Hidden Lake', 40.1100006103516, 0.70005157362757, -105.478057861328, -1.84093939828926, 218, 7, 'PPL', 'P'),
(196695, 'Hidden Lake Colony', 48.5908317565918, 0.848070000435147, -112.591667175293, -1.96509530251849, 218, 31, 'PPL', 'P'),
(204288, 'Hidden Lake Condominium', 40.6680603027344, 0.709791552682317, -111.859718322754, -1.95232038508548, 218, 52, 'PPL', 'P'),
(21889, 'Hidden Lakes', 33.6127815246582, 0.586653708358805, -84.1902770996094, -1.46939753355457, 218, 13, 'PPL', 'P'),
(120014, 'Hidden Lakes', 42.0255584716797, 0.733484365320207, -88.4130630493164, -1.54309905198391, 218, 18, 'PPL', 'P'),
(155717, 'Hidden Ledges Cottage Area', 40.1688919067383, 0.701079420650286, -81.1916732788086, -1.41706202391871, 218, 41, 'PPL', 'P'),
(182112, 'Hidden Meadows', 33.2252807617188, 0.579890544191522, -117.111671447754, -2.04398425927714, 218, 6, 'PPL', 'P'),
(204290, 'Hidden Oak Estates', 40.5919418334961, 0.708463034772531, -111.797500610352, -1.95123448115101, 218, 52, 'PPL', 'P'),
(9484, 'Hidden Oaks', 34.901668548584, 0.609149030612541, -91.9697189331055, -1.60517440751646, 218, 4, 'PPL', 'P'),
(21891, 'Hidden Oaks', 33.9416694641113, 0.592393885772362, -84.7613906860352, -1.47936534604057, 218, 13, 'PPL', 'P'),
(41331, 'Hidden Oaks', 32.5680618286133, 0.568419909902387, -91.9783325195313, -1.60532474295999, 218, 22, 'PPL', 'P'),
(48069, 'Hidden Oaks', 39.6591682434082, 0.692183064449849, -77.0894393920898, -1.34546453590858, 218, 25, 'PPL', 'P'),
(182114, 'Hidden Palms', 33.8202781677246, 0.59027520796715, -116.300559997559, -2.02982769387061, 218, 6, 'PPL', 'P'),
(21892, 'Hidden Pines', 33.5566711425781, 0.585674397446956, -83.8680572509766, -1.46377373628065, 218, 13, 'PPL', 'P'),
(48070, 'Hidden Point', 38.9980583190918, 0.680644519552917, -76.4527816772461, -1.33435276257634, 218, 25, 'PPL', 'P'),
(48084, 'Hidden Ridge', 39.0505599975586, 0.681560846704986, -76.4963912963867, -1.33511389401588, 218, 25, 'PPL', 'P'),
(16422, 'Hidden River', 27.2986106872559, 0.476450637712727, -82.2624969482422, -1.43575142265861, 218, 12, 'PPL', 'P'),
(48072, 'Hidden River', 38.4955596923828, 0.671874264030096, -76.7225036621094, -1.33906029927722, 218, 25, 'PPL', 'P'),
(182113, 'Hidden River', 34.1783294677734, 0.596524382044048, -116.307220458984, -2.02994394085219, 218, 6, 'PPL', 'P'),
(21894, 'Hidden Shoals', 33.5722198486328, 0.585945773562035, -83.998893737793, -1.46605726375733, 218, 13, 'PPL', 'P'),
(182115, 'Hidden Springs', 34.3183288574219, 0.598967832344195, -118.130279541016, -2.06176232429202, 218, 6, 'PPL', 'P'),
(178362, 'Hidden Springs Mission', 36.1891708374023, 0.631620184679384, -111.394172668457, -1.94419508059965, 218, 5, 'PPL', 'P'),
(202210, 'Hidden Timber', 43.2294387817383, 0.754496040530659, -100.421112060547, -1.75267904397073, 218, 49, 'PPL', 'P'),
(3090, 'Hidden Valley', 32.9902801513672, 0.575789009796691, -86.4955596923828, -1.50963230498737, 218, 2, 'PPL', 'P'),
(9483, 'Hidden Valley', 36.2752799987793, 0.633123073061543, -91.5127792358398, -1.59719930531611, 218, 4, 'PPL', 'P'),
(21898, 'Hidden Valley', 33.5944404602051, 0.586333596395778, -84.1911087036133, -1.46941204778251, 218, 13, 'PPL', 'P'),
(30068, 'Hidden Valley', 39.1622200012207, 0.683509681411679, -84.8430633544922, -1.48079080301403, 218, 19, 'PPL', 'P'),
(48076, 'Hidden Valley', 39.5144386291504, 0.689657056155909, -76.4058303833008, -1.33353330790892, 218, 25, 'PPL', 'P'),
(87766, 'Hidden Valley', 35.9652786254883, 0.627712528411911, -84.4833297729492, -1.47451226758612, 218, 50, 'PPL', 'P'),
(102778, 'Hidden Valley', 37.2430610656738, 0.650014039117316, -80.0405578613281, -1.39697126981321, 218, 53, 'PPL', 'P'),
(109647, 'Hidden Valley', 38.357780456543, 0.669469562723809, -82.539436340332, -1.44058492687905, 218, 58, 'PPL', 'P'),
(162666, 'Hidden Valley', 40.1066703796387, 0.699993450136779, -75.3783264160156, -1.31559998060249, 218, 45, 'PPL', 'P'),
(172116, 'Hidden Valley', 43.0008316040039, 0.750506092585503, -73.1966705322266, -1.27752290228486, 218, 55, 'PPL', 'P'),
(182118, 'Hidden Valley', 38.7641716003418, 0.676562426234044, -121.162216186523, -2.114679601468, 218, 6, 'PPL', 'P'),
(186847, 'Hidden Valley', 39.6947212219238, 0.692803580983838, -105.338607788086, -1.83850553536904, 218, 7, 'PPL', 'P'),
(204292, 'Hidden Valley Country Club Estates', 40.5333290100098, 0.707440048018804, -111.844436645508, -1.95205366950231, 218, 52, 'PPL', 'P'),
(102779, 'Hidden Valley Court', 37.2463912963867, 0.650072162608107, -80.0430603027344, -1.39701494565508, 218, 53, 'PPL', 'P'),
(87767, 'Hidden Valley Estates', 36.000560760498, 0.628328317834965, -86.8502807617188, -1.51582335557348, 218, 50, 'PPL', 'P'),
(102781, 'Hidden Valley Estates', 37.2491683959961, 0.650120632139947, -80.0319366455078, -1.39682080121162, 218, 53, 'PPL', 'P'),
(109648, 'Hidden Valley Estates', 38.4519386291504, 0.671112932853469, -81.9169387817383, -1.42972029489597, 218, 58, 'PPL', 'P'),
(21896, 'Hidden Valley Farms', 34.1311111450195, 0.595700266844723, -84.29638671875, -1.47124949577661, 218, 13, 'PPL', 'P'),
(102782, 'Hidden Valley Homes', 37.2441711425781, 0.650033413614247, -80.0397186279297, -1.39695662242721, 218, 53, 'PPL', 'P'),
(182119, 'Hidden Valley Lake', 38.8080596923828, 0.677328417942578, -122.557220458984, -2.13902701910183, 218, 6, 'PPL', 'P'),
(196696, 'Hidden Valley Mobile Estates', 45.7194404602051, 0.79795476820009, -111.094436645508, -1.93896370011236, 218, 31, 'PPL', 'P'),
(135917, 'Hidden Valley Mobile Home Village', 44.0708312988281, 0.76918111025552, -91.7569427490234, -1.6014607625344, 218, 28, 'PPL', 'P'),
(48077, 'Hidden Village', 39.0805587768555, 0.682084424175296, -76.6833267211914, -1.33837653266734, 218, 25, 'PPL', 'P'),
(65567, 'Hiddenite', 35.9036102294922, 0.626636211857356, -81.0908279418945, -1.41530194075428, 218, 33, 'PPL', 'P'),
(3091, 'Hide Away Acres', 34.3463897705078, 0.599457587668661, -86.2591705322266, -1.50550653582662, 218, 2, 'PPL', 'P'),
(87769, 'Hide-A-Way Hills', 35.9388885498047, 0.627251934701382, -85.0569381713867, -1.48452362275594, 218, 50, 'PPL', 'P'),
(94867, 'Hide-A-Way Lake', 32.4900894165039, 0.567059034585356, -95.4558486938477, -1.66601884999317, 218, 51, 'PPL', 'P'),
(94868, 'Hideaway', 32.4902801513672, 0.567062363536719, -95.4572219848633, -1.66604281844298, 218, 51, 'PPL', 'P'),
(794, 'Hideaway Acres', 38.8208312988281, 0.677551324525817, -82.3183288574219, -1.43672587330147, 218, 41, 'PPL', 'P'),
(13937, 'Hideaway Acres', 39.086669921875, 0.682191083776953, -75.4966735839844, -1.31766552834396, 218, 10, 'PPL', 'P'),
(48078, 'Hideaway Acres', 38.4099998474121, 0.670380963027861, -75.5141677856445, -1.31797085976293, 218, 25, 'PPL', 'P'),
(102783, 'Hideaway Cove', 37.4844398498535, 0.654226893645713, -75.9430618286133, -1.32545647295493, 218, 53, 'PPL', 'P'),
(48079, 'Hideaway Estates', 39.6836090087891, 0.692609636277453, -76.9680633544922, -1.34334612441948, 218, 25, 'PPL', 'P'),
(94869, 'Hideaway Hill', 28.1866703033447, 0.491950201967474, -97.8933334350586, -1.70856098419442, 218, 51, 'PPL', 'P'),
(3092, 'Hideaway Hills', 34.8558311462402, 0.608349017021081, -87.561393737793, -1.52823461835963, 218, 2, 'PPL', 'P'),
(60247, 'Hideaway Hills', 34.4291687011719, 0.600902352560029, -89.8491668701172, -1.56816379205735, 218, 30, 'PPL', 'P'),
(72890, 'Hideaway Hills', 39.6547203063965, 0.692105433304073, -82.4772186279297, -1.43949902294457, 218, 41, 'PPL', 'P'),
(87770, 'Hideaway Hills', 35.6602783203125, 0.622389268867006, -84.8152770996094, -1.48030584137953, 218, 50, 'PPL', 'P'),
(102784, 'Hideaway Lake', 37.5083312988281, 0.654643878093392, -78.0449981689453, -1.36214218276104, 218, 53, 'PPL', 'P'),
(182120, 'Hideaway Mobile Estates', 33.2341690063477, 0.580045673325019, -117.056938171387, -2.04302898339413, 218, 6, 'PPL', 'P'),
(186846, 'Hideaway Park', 39.9180603027344, 0.696701583292359, -105.785003662109, -1.84629661313807, 218, 7, 'PPL', 'P'),
(102785, 'Hidenwood', 37.064998626709, 0.646906263283248, -76.5052795410156, -1.33526902314938, 218, 53, 'PPL', 'P'),
(65570, 'Hidetown', 35.3713912963867, 0.617347239133214, -83.6802825927734, -1.46049645024319, 218, 33, 'PPL', 'P'),
(60248, 'Hidi', 33.0244407653809, 0.576385224985732, -90.3852767944336, -1.57752067538929, 218, 30, 'PPL', 'P'),
(162667, 'Hiestand', 40.1686096191406, 0.701074493802269, -75.6052780151367, -1.31956103324982, 218, 45, 'PPL', 'P'),
(72891, 'Hiett', 38.7213897705078, 0.675815742443413, -83.7236099243164, -1.46125265483472, 218, 41, 'PPL', 'P'),
(55284, 'Higbee', 39.3047218322754, 0.685996807553704, -92.5124969482422, -1.61464767098803, 218, 29, 'PPL', 'P'),
(78460, 'Higbee', 39.8408317565918, 0.695353690885643, -80.4061126708984, -1.40335140483671, 218, 45, 'PPL', 'P'),
(186848, 'Higbee', 37.7763900756836, 0.659322386338389, -103.458892822266, -1.80569832021646, 218, 7, 'PPL', 'P'),
(131299, 'Higbee Corner', 43.5422210693359, 0.759955121291158, -85.3925018310547, -1.49038031346719, 218, 27, 'PPL', 'P'),
(70952, 'Higbeeville', 39.5152816772461, 0.689671770120932, -74.4569396972656, -1.29951874867616, 218, 37, 'PPL', 'P'),
(72892, 'Higby', 39.1961097717285, 0.684101169489786, -82.8663864135742, -1.44629128214677, 218, 41, 'PPL', 'P'),
(182121, 'Higby', 36.2849998474121, 0.633292716422981, -119.28694152832, -2.08194988430315, 218, 6, 'PPL', 'P'),
(109649, 'Higby (historical)', 38.685001373291, 0.675180645102456, -81.5363922119141, -1.42307850429536, 218, 58, 'PPL', 'P'),
(9485, 'Higden', 35.5733299255371, 0.620871733098852, -92.2030563354492, -1.60924691345541, 218, 4, 'PPL', 'P'),
(3093, 'Higdon', 34.8455581665039, 0.608169719700692, -85.6163864135742, -1.49428783657661, 218, 2, 'PPL', 'P'),
(21897, 'Higdon', 34.8963890075684, 0.609056885238824, -84.4388885498047, -1.47373662191863, 218, 13, 'PPL', 'P'),
(36401, 'Higdon', 37.4294395446777, 0.653266957230794, -86.1744384765625, -1.5040276824733, 218, 21, 'PPL', 'P'),
(55283, 'Higdon', 37.5927810668945, 0.656117804598696, -90.1677780151367, -1.57372460557149, 218, 29, 'PPL', 'P'),
(60249, 'Higdon', 34.7680587768555, 0.60681710018304, -89.3869400024414, -1.56009641132523, 218, 30, 'PPL', 'P'),
(21899, 'Higdon Mill (historical)', 34.8227806091309, 0.60777217632897, -84.4094390869141, -1.47322263182825, 218, 13, 'PPL', 'P'),
(65571, 'Higdonville', 35.1775016784668, 0.613963226915077, -83.3000030517578, -1.4538593201745, 218, 33, 'PPL', 'P'),
(113556, 'Higganum', 41.496940612793, 0.724258243197791, -72.557502746582, -1.26636731995269, 218, 8, 'PPL', 'P'),
(41352, 'Higginbotham', 30.3455600738525, 0.52962993665046, -92.1933288574219, -1.60907713693591, 218, 22, 'PPL', 'P'),
(191603, 'Higginbotham', 32.9011116027832, 0.574232725034676, -102.991668701172, -1.79754372095864, 218, 51, 'PPL', 'P'),
(9486, 'Higgins', 34.6513900756836, 0.604780847213566, -92.23388671875, -1.60978500515366, 218, 4, 'PPL', 'P'),
(48080, 'Higgins', 38.8136100769043, 0.677425290427229, -76.0527801513672, -1.32737141893675, 218, 25, 'PPL', 'P'),
(60250, 'Higgins', 31.423059463501, 0.548435848688055, -89.5975036621094, -1.56377144047149, 218, 30, 'PPL', 'P'),
(65572, 'Higgins', 35.9594383239746, 0.627610595921188, -82.3802795410156, -1.43780711670405, 218, 33, 'PPL', 'P'),
(76086, 'Higgins', 34.8113899230957, 0.607573371353596, -95.4333267211914, -1.66562576741627, 218, 42, 'PPL', 'P'),
(81537, 'Higgins', 34.1272201538086, 0.595632356236926, -81.7480621337891, -1.42677284135952, 218, 48, 'PPL', 'P'),
(149599, 'Higgins', 42.4691696166992, 0.74122684039934, -78.2050018310547, -1.3649347734801, 218, 40, 'PPL', 'P'),
(191604, 'Higgins', 36.1197204589844, 0.630408046909235, -100.023887634277, -1.74574616986298, 218, 51, 'PPL', 'P'),
(196697, 'Higgins', 46.290828704834, 0.807927374376055, -110.741111755371, -1.93279701745022, 218, 31, 'PPL', 'P'),
(149600, 'Higgins Bay', 43.4077796936035, 0.757608676633717, -74.5341720581055, -1.3008667076619, 218, 40, 'PPL', 'P'),
(127738, 'Higgins Beach', 43.560001373291, 0.76026544613718, -70.2802810668945, -1.22662230384434, 218, 26, 'PPL', 'P'),
(127740, 'Higgins Corner', 43.7374992370605, 0.763363368275214, -70.6344375610352, -1.23280350073442, 218, 26, 'PPL', 'P'),
(162668, 'Higgins Corner', 41.1049995422363, 0.717417581042786, -79.8419418334961, -1.39350476618031, 218, 45, 'PPL', 'P'),
(182122, 'Higgins Corner', 39.042781829834, 0.68142509206842, -121.093887329102, -2.11348703793186, 218, 6, 'PPL', 'P'),
(102786, 'Higgins Crossroads', 36.6511116027832, 0.639682571984463, -80.8147201538086, -1.41048295076178, 218, 53, 'PPL', 'P'),
(131300, 'Higgins Lake', 44.4836082458496, 0.776385427057375, -84.7797164916992, -1.47968519168749, 218, 27, 'PPL', 'P'),
(21900, 'Higgins Mill', 33.1283302307129, 0.578198438213913, -84.0044403076172, -1.46615406966296, 218, 13, 'PPL', 'P'),
(188682, 'Higgins Place', 33.1794395446777, 0.579090464021035, -104.524436950684, -1.82429557358265, 218, 38, 'PPL', 'P'),
(9488, 'Higginson', 35.1947212219238, 0.614263764644093, -91.7125015258789, -1.60068511686691, 218, 4, 'PPL', 'P'),
(72893, 'Higginsport', 38.7897186279297, 0.67700830597955, -83.9674987792969, -1.46550931836305, 218, 41, 'PPL', 'P'),
(55285, 'Higginsville', 39.0724983215332, 0.681943742690712, -93.7169418334961, -1.63566919989452, 218, 29, 'PPL', 'P'),
(109650, 'Higginsville', 39.4180603027344, 0.687974937032388, -78.5800018310547, -1.37147975817508, 218, 58, 'PPL', 'P'),
(120016, 'Higginsville', 40.2419395446777, 0.702354342443134, -87.7572174072266, -1.53165238614459, 218, 18, 'PPL', 'P'),
(127751, 'Higginsville', 44.9386100769043, 0.784326707111882, -68.95361328125, -1.2034675829047, 218, 26, 'PPL', 'P'),
(145417, 'Higginsville', 40.5099983215332, 0.707032850688131, -74.7888870239258, -1.30531232246957, 218, 37, 'PPL', 'P'),
(149601, 'Higginsville', 43.1769409179688, 0.753579779957618, -75.647216796875, -1.32029300307543, 218, 40, 'PPL', 'P'),
(65574, 'Higgs', 35.6061096191406, 0.621443846680028, -77.3888931274414, -1.35069098954786, 218, 33, 'PPL', 'P'),
(21901, 'Higgston', 32.2163887023926, 0.562282055959054, -82.4672164916992, -1.43932445273512, 218, 13, 'PPL', 'P'),
(24, 'High', 33.6122207641602, 0.586643921241799, -95.746940612793, -1.67109936240471, 218, 51, 'PPL', 'P'),
(9490, 'High', 36.4694404602051, 0.636511812390615, -93.5555572509766, -1.6328525075676, 218, 4, 'PPL', 'P'),
(182123, 'High Acres Haciendas', 33.5652809143066, 0.585824666311464, -117.027496337891, -2.0425151264618, 218, 6, 'PPL', 'P'),
(116018, 'High Acres Mobile Home Park', 42.5341682434082, 0.742361280444686, -92.4819412231445, -1.61411437297974, 218, 16, 'PPL', 'P'),
(116019, 'High Amana', 41.8033294677734, 0.729605737508615, -91.9380569458008, -1.60462180159027, 218, 16, 'PPL', 'P'),
(149602, 'High Bank', 44.6266708374023, 0.778882340316406, -73.915283203125, -1.29006505943859, 218, 40, 'PPL', 'P'),
(48081, 'High Bank Estates', 38.3441696166992, 0.669232008754573, -75.7019424438477, -1.32124814580038, 218, 25, 'PPL', 'P'),
(70953, 'High Bank Landing', 39.4347190856934, 0.688265687644397, -74.7249984741211, -1.30419725692115, 218, 37, 'PPL', 'P'),
(48082, 'High Banks', 38.7975006103516, 0.677144127195144, -75.9247207641602, -1.3251363609919, 218, 25, 'PPL', 'P'),
(131311, 'High Banks', 45.6436080932617, 0.796631243717348, -84.267219543457, -1.47074043253424, 218, 27, 'PPL', 'P'),
(48083, 'High Barbaree', 39.4119415283203, 0.687868144272675, -77.2652816772461, -1.34853356274879, 218, 25, 'PPL', 'P'),
(3095, 'High Bluff', 31.1563892364502, 0.543781575208978, -85.7313919067383, -1.4962950610902, 218, 2, 'PPL', 'P'),
(16423, 'High Bluff', 29.8191699981689, 0.52044269667996, -84.8252792358398, -1.48048041158898, 218, 12, 'PPL', 'P'),
(87772, 'High Bluff', 35.8916702270508, 0.626427819502057, -83.8433303833008, -1.463342171026, 218, 50, 'PPL', 'P'),
(36402, 'High Bridge', 37.8241691589355, 0.66015628865472, -84.7183303833008, -1.47861380198095, 218, 21, 'PPL', 'P'),
(143955, 'High Bridge', 42.7508316040039, 0.746142769455517, -71.8274993896484, -1.25362635782358, 218, 36, 'PPL', 'P'),
(145418, 'High Bridge', 40.6669387817383, 0.709771978448305, -74.896110534668, -1.30718372576757, 218, 37, 'PPL', 'P'),
(149604, 'High Bridge', 43.0138893127441, 0.750733992595786, -76.0124969482422, -1.32666834440897, 218, 40, 'PPL', 'P'),
(174503, 'High Bridge', 46.3888893127441, 0.809638854850595, -90.7361068725586, -1.5836438153676, 218, 57, 'PPL', 'P'),
(48085, 'High Bridge Estates', 38.980281829834, 0.680334261285923, -76.7772216796875, -1.34001530884412, 218, 25, 'PPL', 'P'),
(135918, 'High Ciara Mobile Home Park', 44.1655616760254, 0.770834467239268, -93.9625015258789, -1.63995502503678, 218, 28, 'PPL', 'P'),
(174504, 'High Cliff (historical)', 44.1661109924316, 0.770844054619192, -88.2925033569336, -1.54099488840664, 218, 57, 'PPL', 'P'),
(182124, 'High Country', 34.4049987792969, 0.60048050784336, -117.380561828613, -2.04867728175008, 218, 6, 'PPL', 'P'),
(116020, 'High Creek', 40.5875015258789, 0.708385536784809, -95.4502792358398, -1.66592164461338, 218, 16, 'PPL', 'P'),
(70954, 'High Crossing', 39.7691688537598, 0.694102937279687, -74.6444396972656, -1.30279124102364, 218, 37, 'PPL', 'P'),
(65575, 'High Crossroads', 35.8069381713867, 0.624948966148736, -78.045280456543, -1.36214710960906, 218, 33, 'PPL', 'P'),
(204299, 'High Danish Condominium', 40.603889465332, 0.708671560285884, -111.804443359375, -1.9513556549806, 218, 52, 'PPL', 'P'),
(21902, 'High Falls', 33.1755599975586, 0.579022753150319, -84.0255584716797, -1.46652265115783, 218, 13, 'PPL', 'P'),
(36403, 'High Falls', 37.7297210693359, 0.658507858518988, -83.5838928222656, -1.45881413138259, 218, 21, 'PPL', 'P'),
(65576, 'High Falls', 35.4836082458496, 0.619305794377885, -79.5219421386719, -1.38791971790025, 218, 33, 'PPL', 'P'),
(149607, 'High Falls', 41.8266716003418, 0.73001313457637, -74.1266708374023, -1.29375446965473, 218, 40, 'PPL', 'P'),
(149608, 'High Flats', 44.5933303833008, 0.778300439618224, -74.8891677856445, -1.30706255193797, 218, 40, 'PPL', 'P'),
(135919, 'High Forest', 43.8450012207031, 0.765239631842203, -92.5497207641602, -1.61529734913596, 218, 28, 'PPL', 'P'),
(55286, 'High Gate', 38.1577796936035, 0.665978890904014, -91.6747207641602, -1.60002571818101, 218, 29, 'PPL', 'P'),
(65577, 'High Hampton', 35.0997200012207, 0.612605680549409, -83.0822219848633, -1.45005832350868, 218, 33, 'PPL', 'P'),
(87774, 'High Health (historical)', 36.3611106872559, 0.634621101174713, -82.0083312988281, -1.43131539523087, 218, 50, 'PPL', 'P'),
(36404, 'High Hickory', 37.4225006103516, 0.653145849980222, -85.8300018310547, -1.49801612894467, 218, 21, 'PPL', 'P'),
(55287, 'High Hill', 38.8783302307129, 0.678554870203587, -91.3833312988281, -1.59494001260534, 218, 29, 'PPL', 'P'),
(60251, 'High Hill', 32.6241683959961, 0.569399154235209, -89.3177795410156, -1.55888933356115, 218, 30, 'PPL', 'P'),
(72894, 'High Hill', 39.8319396972656, 0.695198495173118, -81.7655563354492, -1.4270781727785, 218, 41, 'PPL', 'P'),
(76087, 'High Hill', 34.1349983215332, 0.595768110873492, -95.2966690063477, -1.663240640344, 218, 42, 'PPL', 'P'),
(94872, 'High Hill', 29.7177791595459, 0.518673092714629, -96.9269409179688, -1.69169425290457, 218, 51, 'PPL', 'P'),
(102787, 'High Hill', 36.6358299255371, 0.639415856401292, -78.7494430541992, -1.37443706540756, 218, 53, 'PPL', 'P'),
(81538, 'High Hill Crossroads', 34.3438911437988, 0.599413978405811, -79.2174987792969, -1.38260617889332, 218, 48, 'PPL', 'P'),
(21903, 'High Hill Lake', 31.2350006103516, 0.545153602513073, -81.5319366455078, -1.42300073999153, 218, 13, 'PPL', 'P'),
(41332, 'High Island', 32.269718170166, 0.563212830760037, -93.4349975585938, -1.63074834399032, 218, 22, 'PPL', 'P'),
(94873, 'High Island', 29.5666694641113, 0.51603573099761, -94.3933334350586, -1.64747446037462, 218, 51, 'PPL', 'P'),
(36405, 'High Knob', 37.2861099243164, 0.650765383439855, -83.9072189331055, -1.46445723657441, 218, 21, 'PPL', 'P'),
(162669, 'High Lake', 41.8138885498047, 0.729790028256049, -75.3061065673828, -1.31433950645856, 218, 45, 'PPL', 'P'),
(94874, 'High Land Colonia', 26.1879997253418, 0.457066819718585, -97.9059982299805, -1.7087820265649, 218, 51, 'PPL', 'P'),
(127742, 'High Landing', 45.7891693115234, 0.799171766239229, -68.4538879394531, -1.19474573033469, 218, 26, 'PPL', 'P'),
(135922, 'High Landing', 48.0494384765625, 0.838620905150464, -95.8083267211914, -1.67217075211125, 218, 28, 'PPL', 'P'),
(3098, 'High Level', 33.6655616760254, 0.587574895779864, -87.2127838134766, -1.52215022737518, 218, 2, 'PPL', 'P'),
(188683, 'High Lonesome Wells', 31.4177799224854, 0.548343703314338, -108.557502746582, -1.89468585067064, 218, 38, 'PPL', 'P'),
(102788, 'High Meadows', 36.6100006103516, 0.638965049807768, -82.1055603027344, -1.43301236147747, 218, 53, 'PPL', 'P'),
(65581, 'High Meadows Estates', 36.4008293151855, 0.635314322006461, -80.996940612793, -1.41366329773555, 218, 33, 'PPL', 'P'),
(149609, 'High Mills', 42.8994407653809, 0.748736488620172, -73.9080581665039, -1.28993895876098, 218, 40, 'PPL', 'P'),
(127743, 'High Pasture', 43.230281829834, 0.754510754495682, -70.585563659668, -1.23195049023726, 218, 26, 'PPL', 'P'),
(3100, 'High Pine', 33.2533302307129, 0.580380099778906, -85.9063873291016, -1.49934930738636, 218, 2, 'PPL', 'P'),
(55288, 'High Place Lookout Tower', 36.7150001525879, 0.640797637532879, -92.1669387817383, -1.60861654322538, 218, 29, 'PPL', 'P'),
(36406, 'High Plains', 37.7730598449707, 0.659264262847598, -86.2111129760742, -1.5046677732413, 218, 21, 'PPL', 'P'),
(36407, 'High Plains Corner', 37.7733306884766, 0.659268989958533, -86.1719436645508, -1.50398413978948, 218, 21, 'PPL', 'P'),
(3103, 'High Point', 34.2422218322754, 0.597639514171491, -86.2786102294922, -1.5058458225495, 218, 2, 'PPL', 'P'),
(13938, 'High Point', 39.7708282470703, 0.694131899156542, -75.5083312988281, -1.31786899385124, 218, 10, 'PPL', 'P'),
(16425, 'High Point', 27.9141693115234, 0.487194162445243, -82.7055587768555, -1.44348431035782, 218, 12, 'PPL', 'P'),
(21908, 'High Point', 34.8633308410645, 0.608479911388659, -85.366943359375, -1.4899342339846, 218, 13, 'PPL', 'P'),
(36408, 'High Point', 37.1141700744629, 0.647764466944527, -88.7155609130859, -1.54837863568694, 218, 21, 'PPL', 'P'),
(55289, 'High Point', 38.4844398498535, 0.671680186165656, -92.5905609130859, -1.61601014420172, 218, 29, 'PPL', 'P'),
(60252, 'High Point', 34.9613914489746, 0.610191391863198, -88.2391662597656, -1.5400639804476, 218, 30, 'PPL', 'P'),
(65583, 'High Point', 35.9555587768555, 0.627542885050473, -80.0055618286133, -1.3963604738172, 218, 33, 'PPL', 'P'),
(70955, 'High Point', 39.7097206115723, 0.693065369718992, -74.1327819824219, -1.29386112925639, 218, 37, 'PPL', 'P'),
(81540, 'High Point', 34.7513885498047, 0.606526149833949, -80.4369430541992, -1.40388949653496, 218, 48, 'PPL', 'P'),
(87779, 'High Point', 36.4752807617188, 0.636613744881337, -84.5419387817383, -1.47553518776082, 218, 50, 'PPL', 'P'),
(112390, 'High Point', 39.6947212219238, 0.692803580983838, -79.1044387817383, -1.38063290968363, 218, 25, 'PPL', 'P'),
(116022, 'High Point', 40.7611083984375, 0.711415548315047, -93.5941696166992, -1.63352642048144, 218, 16, 'PPL', 'P'),
(120017, 'High Point', 41.920280456543, 0.731646917326107, -88.4333267211914, -1.54345271977667, 218, 18, 'PPL', 'P'),
(207636, 'High Point', 47.535831451416, 0.829656771500284, -122.375, -2.13584667212806, 218, 56, 'PPL', 'P'),
(9491, 'High Point (historical)', 34.5361099243164, 0.602768829010011, -92.8952789306641, -1.62132847689861, 218, 4, 'PPL', 'P'),
(94875, 'High Point Colonia', 26.1800003051758, 0.456927203498438, -98.015998840332, -1.71070189939474, 218, 51, 'PPL', 'P'),
(48090, 'High Point Estates', 39.5791702270508, 0.690786835669348, -76.4250030517578, -1.33386793409989, 218, 25, 'PPL', 'P'),
(48091, 'High Point Manor', 39.5511093139648, 0.690297080344882, -76.4113922119141, -1.33363038013065, 218, 25, 'PPL', 'P'),
(87780, 'High Point Subdivision', 35.0422210693359, 0.61160213487164, -86.5722198486328, -1.51097027711903, 218, 50, 'PPL', 'P'),
(55290, 'High Prairie', 37.295280456543, 0.650925439421369, -92.7649993896484, -1.6190546699599, 218, 29, 'PPL', 'P'),
(55292, 'High Prarie', 37.2938919067383, 0.650901204655449, -92.7624969482422, -1.61901099411802, 218, 29, 'PPL', 'P'),
(48094, 'High Ridge', 39.1180610656738, 0.68273896259221, -76.85888671875, -1.34144063265953, 218, 25, 'PPL', 'P'),
(55293, 'High Ridge', 38.4588890075684, 0.671234239841122, -90.5363922119141, -1.58015813697485, 218, 29, 'PPL', 'P'),
(112189, 'High Ridge', 32.0625, 0.559596191420682, -85.8949966430664, -1.49915050241099, 218, 2, 'PPL', 'P'),
(113558, 'High Ridge', 41.1641693115234, 0.718450288334491, -73.5638885498047, -1.28393206576425, 218, 8, 'PPL', 'P'),
(162670, 'High Ridge', 40.2733306884766, 0.702902221258391, -76.7366714477539, -1.33930757378443, 218, 45, 'PPL', 'P'),
(16426, 'High Ridge Estates', 26.2119407653809, 0.457484669693619, -80.1158294677734, -1.39828500717894, 218, 12, 'PPL', 'P'),
(3105, 'High Rock', 33.9594383239746, 0.592704010881302, -86.690559387207, -1.51303569170244, 218, 2, 'PPL', 'P'),
(65585, 'High Rock', 35.5966682434082, 0.621279063587579, -80.2213897705078, -1.40012738202106, 218, 33, 'PPL', 'P'),
(102790, 'High Rock', 36.7794418334961, 0.641922357040247, -79.0972213745117, -1.38050694216406, 218, 53, 'PPL', 'P'),
(207637, 'High Rock', 47.813060760498, 0.834495335726795, -121.981391906738, -2.12897691493815, 218, 56, 'PPL', 'P'),
(65586, 'High Rock Mountain Shores', 35.6324996948242, 0.621904440390557, -80.1936111450195, -1.39964255354461, 218, 33, 'PPL', 'P'),
(102791, 'High Rocks Mill', 36.8811111450195, 0.643696821274567, -80.773063659668, -1.40975590778419, 218, 53, 'PPL', 'P'),
(188684, 'High Rolls', 32.9508285522461, 0.575100449496851, -105.834999084473, -1.84716919786923, 218, 38, 'PPL', 'P'),
(162671, 'High Rue', 40.0750007629395, 0.699440711052533, -75.038330078125, -1.30966592506158, 218, 45, 'PPL', 'P'),
(3107, 'High Shoals', 33.2338905334473, 0.58004081305603, -85.3413925170898, -1.48948828766007, 218, 2, 'PPL', 'P'),
(21909, 'High Shoals', 33.8208312988281, 0.590284861926101, -83.5061111450195, -1.45745658501692, 218, 13, 'PPL', 'P'),
(65587, 'High Shoals', 35.4025001525879, 0.617890191100454, -81.2024993896484, -1.41725097519805, 218, 33, 'PPL', 'P'),
(182125, 'High Sierra Park', 38.0819396972656, 0.664655233263218, -120.146392822266, -2.09695013914302, 218, 6, 'PPL', 'P'),
(16427, 'High Springs', 29.8266696929932, 0.520573591047537, -82.5969390869141, -1.44158853913585, 218, 12, 'PPL', 'P'),
(21910, 'High Springs (historical)', 31.6811103820801, 0.552939686855056, -83.7866668701172, -1.4623532061552, 218, 13, 'PPL', 'P'),
(94876, 'High Valley', 31.0825004577637, 0.542491972740621, -98.5358276367188, -1.71977462343837, 218, 51, 'PPL', 'P'),
(195092, 'High Valley', 44.2241706848145, 0.771857387413968, -116.15389251709, -2.02726786343082, 218, 17, 'PPL', 'P'),
(207638, 'High Valley', 47.4925003051758, 0.828900500329729, -122.068893432617, -2.13050410466525, 218, 56, 'PPL', 'P'),
(109651, 'High View', 39.2305603027344, 0.684702444684898, -78.4086074829102, -1.36848836248065, 218, 58, 'PPL', 'P'),
(149610, 'High View', 41.5574989318848, 0.725315185255416, -74.4580612182617, -1.29953832291017, 218, 40, 'PPL', 'P'),
(48097, 'High View Estates', 39.2588882446289, 0.685196860541271, -76.8233337402344, -1.34082011612554, 218, 25, 'PPL', 'P'),
(102792, 'High View Manor', 39.1619415283203, 0.68350482114269, -78.3213882446289, -1.36696609960156, 218, 53, 'PPL', 'P'),
(102793, 'High Woods', 37.7602806091309, 0.659041223106304, -75.6561126708984, -1.32044826536698, 218, 53, 'PPL', 'P'),
(149611, 'High Woods', 42.0455589294434, 0.733833439160089, -74.0288925170898, -1.29204791602821, 218, 40, 'PPL', 'P'),
(94877, 'Highbank', 31.1697196960449, 0.54401423561971, -96.8333282470703, -1.69006040357581, 218, 51, 'PPL', 'P'),
(30069, 'Highbank Town', 38.5144386291504, 0.672203763635966, -87.1502838134766, -1.52105939659269, 218, 19, 'PPL', 'P'),
(122811, 'Highbanks', 41.3233299255371, 0.721228165088526, -85.6711120605469, -1.49524297930157, 218, 19, 'PPL', 'P'),
(195091, 'Highbridge', 44.2833290100098, 0.772889894968591, -112.211669921875, -1.95846309929781, 218, 17, 'PPL', 'P'),
(87781, 'Highcliff', 36.582218170166, 0.638480154752292, -84.0761108398438, -1.46740495642697, 218, 50, 'PPL', 'P'),
(162672, 'Highcliff', 40.526668548584, 0.707323801037222, -80.0505599975586, -1.39714584002266, 218, 45, 'PPL', 'P'),
(182127, 'Highcroft', 38.5019416809082, 0.671985650742688, -122.942497253418, -2.14575136769623, 218, 6, 'PPL', 'P'),
(30070, 'Highets Corner', 39.2819404602051, 0.685599197602955, -86.7041702270508, -1.51327324567168, 218, 19, 'PPL', 'P'),
(3106, 'Highfalls', 31.0983295440674, 0.542768242414203, -85.8000030517578, -1.49749255147436, 218, 2, 'PPL', 'P'),
(48095, 'Highfield', 39.7180595397949, 0.693210911472565, -77.4813919067383, -1.35230539780067, 218, 25, 'PPL', 'P'),
(162694, 'Highfield', 40.8633308410645, 0.713199666508318, -79.9283294677734, -1.39501251483145, 218, 45, 'PPL', 'P'),
(48096, 'Highfield Cascade', 39.7172203063965, 0.69319626408657, -77.4902801513672, -1.35246052693417, 218, 25, 'PPL', 'P'),
(48098, 'Highfield Park', 39.5747184753418, 0.690709137944545, -76.4388885498047, -1.33411028175909, 218, 25, 'PPL', 'P'),
(48099, 'Highfields', 39.503059387207, 0.689458450917616, -77.5480575561523, -1.35346893288093, 218, 25, 'PPL', 'P'),
(102794, 'Highfields', 37.2180595397949, 0.649577680172707, -80.0297164916992, -1.39678205221776, 218, 53, 'PPL', 'P'),
(102795, 'Highfields Farm Estates', 37.2027816772461, 0.649311031168563, -80.0719375610352, -1.39751894889138, 218, 53, 'PPL', 'P'),
(9498, 'Highfill', 36.2613906860352, 0.632880658823319, -94.3574981689453, -1.64684901699262, 218, 4, 'PPL', 'P'),
(21927, 'Highgate', 33.4938888549805, 0.584578639816443, -82.0663909912109, -1.43232872802564, 218, 13, 'PPL', 'P'),
(102796, 'Highgate', 37.1272201538086, 0.647992233796756, -76.7436065673828, -1.33942861445597, 218, 53, 'PPL', 'P'),
(172117, 'Highgate Center', 44.9388885498047, 0.784331567380872, -73.0438919067383, -1.27485641224342, 218, 55, 'PPL', 'P'),
(172118, 'Highgate Falls', 44.9275016784668, 0.784132828984524, -73.0502777099609, -1.27496786553504, 218, 55, 'PPL', 'P'),
(36409, 'Highgate Springs', 38.2152786254883, 0.666982436581783, -85.6402816772461, -1.49470488760332, 218, 21, 'PPL', 'P'),
(172119, 'Highgate Springs', 44.9794387817383, 0.78503930244056, -73.105827331543, -1.27593738932989, 218, 55, 'PPL', 'P'),
(36410, 'Highgrove', 37.9830589294434, 0.662929438297819, -85.4863891601563, -1.49201895648592, 218, 21, 'PPL', 'P'),
(182126, 'Highgrove', 34.0158309936523, 0.593688248641168, -117.332496643066, -2.0478383860067, 218, 6, 'PPL', 'P'),
(78461, 'Highhouse', 39.8661117553711, 0.695794910099242, -79.8099975585938, -1.3929472334061, 218, 45, 'PPL', 'P'),
(178363, 'Highjinks', 32.5711097717285, 0.568473106545161, -110.737777709961, -1.9327388273804, 218, 5, 'PPL', 'P'),
(3123, 'Highland', 33.3555603027344, 0.582164351130231, -85.8255615234375, -1.49793863095694, 218, 2, 'PPL', 'P'),
(9494, 'Highland', 36.2758293151855, 0.633132660441468, -91.5238876342773, -1.59739318344346, 218, 4, 'PPL', 'P'),
(16428, 'Highland', 30.1122207641602, 0.525557397421998, -82.0458297729492, -1.43196986706876, 218, 12, 'PPL', 'P'),
(27433, 'Highland', 38.7394409179688, 0.676130794400369, -89.6711120605469, -1.56505614938134, 218, 18, 'PPL', 'P'),
(32754, 'Highland', 39.2138900756836, 0.684411494335807, -94.8305587768555, -1.65510548216213, 218, 20, 'PPL', 'P'),
(36412, 'Highland', 36.7066688537598, 0.640652228937361, -86.4391708374023, -1.50864813380654, 218, 21, 'PPL', 'P'),
(41335, 'Highland', 31.8377799987793, 0.555674087504295, -91.4855575561523, -1.59672419737764, 218, 22, 'PPL', 'P'),
(48102, 'Highland', 38.9386100769043, 0.679606951992222, -76.9541702270508, -1.34310364360223, 218, 25, 'PPL', 'P'),
(55294, 'Highland', 37.6644401550293, 0.657368491625625, -89.8913879394531, -1.56890068873098, 218, 29, 'PPL', 'P'),
(72895, 'Highland', 39.3444404602051, 0.686690028385452, -83.5975036621094, -1.45905168535183, 218, 41, 'PPL', 'P'),
(81542, 'Highland', 35.0875015258789, 0.612392427925121, -82.3211135864258, -1.43677447599137, 218, 48, 'PPL', 'P'),
(87789, 'Highland', 35.2319412231445, 0.61491337621299, -87.7375030517578, -1.53130830573175, 218, 50, 'PPL', 'P'),
(94881, 'Highland', 31.5344390869141, 0.550379789836245, -97.3513870239258, -1.69910223495079, 218, 51, 'PPL', 'P'),
(102797, 'Highland', 37.1647186279297, 0.648646705634642, -80.6788864135742, -1.40811220475939, 218, 53, 'PPL', 'P'),
(109657, 'Highland', 39.4352798461914, 0.688275474761403, -80.2538909912109, -1.40069463533325, 218, 58, 'PPL', 'P'),
(113559, 'Highland', 41.565559387207, 0.725455866739999, -72.7386093139648, -1.2695282258505, 218, 8, 'PPL', 'P'),
(116024, 'Highland', 42.8938903808594, 0.748639616135521, -91.5969390869141, -1.59866817181534, 218, 16, 'PPL', 'P'),
(122812, 'Highland', 41.5536117553711, 0.725247341226646, -87.4519424438477, -1.52632433290972, 218, 19, 'PPL', 'P'),
(125068, 'Highland', 42.2852783203125, 0.738017331811631, -71.1572189331055, -1.24192775694514, 218, 23, 'PPL', 'P'),
(131303, 'Highland', 44.1455612182617, 0.770485393399386, -85.2663879394531, -1.48817921082624, 218, 27, 'PPL', 'P'),
(135925, 'Highland', 45.1230583190918, 0.78754593623757, -94.0325012207031, -1.64117675018686, 218, 28, 'PPL', 'P'),
(149612, 'Highland', 41.7208290100098, 0.728165832886237, -73.960563659668, -1.29085535249207, 218, 40, 'PPL', 'P'),
(162678, 'Highland', 40.3613891601563, 0.704439131523475, -79.5258331298828, -1.38798762850804, 218, 45, 'PPL', 'P'),
(174505, 'Highland', 43.0466690063477, 0.751306106176962, -90.3797225952148, -1.57742373632561, 218, 57, 'PPL', 'P'),
(182128, 'Highland', 34.1283302307129, 0.595651730733856, -117.207778930664, -2.04566165128973, 218, 6, 'PPL', 'P'),
(194235, 'Highland', 40.2388916015625, 0.70230114580036, -105.082778930664, -1.83404047948541, 218, 7, 'PPL', 'P'),
(200973, 'Highland', 45.2483291625977, 0.789732324913498, -122.408058166504, -2.13642364597823, 218, 43, 'PPL', 'P'),
(204303, 'Highland', 40.4500007629395, 0.705985695747512, -111.769439697266, -1.95074472582654, 218, 52, 'PPL', 'P'),
(207641, 'Highland', 47.6941719055176, 0.83242033376346, -117.529441833496, -2.05127572802567, 218, 56, 'PPL', 'P'),
(48103, 'Highland (historical)', 39.666389465332, 0.692309098548437, -76.3733291625977, -1.33296605459673, 218, 25, 'PPL', 'P'),
(182129, 'Highland (historical)', 37.1063919067383, 0.64762871230796, -121.932777404785, -2.12812843181485, 218, 6, 'PPL', 'P'),
(199991, 'Highland (historical)', 40.5141716003418, 0.707105688143945, -115.996391296387, -2.02451894855364, 218, 39, 'PPL', 'P'),
(13941, 'Highland Acres', 38.7652816772461, 0.676581800730974, -75.1555633544922, -1.31171203172708, 218, 10, 'PPL', 'P'),
(41336, 'Highland Acres', 31.7722206115723, 0.554529860341942, -93.1488876342773, -1.62575478378837, 218, 22, 'PPL', 'P'),
(48104, 'Highland Acres', 39.1591682434082, 0.683456418189877, -76.9458312988281, -1.34295810184866, 218, 25, 'PPL', 'P'),
(81544, 'Highland Acres', 34.5119400024414, 0.602346984293342, -82.6197204589844, -1.4419861490866, 218, 48, 'PPL', 'P'),
(87790, 'Highland Acres', 35.7372207641602, 0.623732167846679, -83.9916687011719, -1.46593116307972, 218, 50, 'PPL', 'P'),
(94882, 'Highland Addition', 32.9366416931152, 0.574852842094501, -97.6304092407227, -1.70397209132011, 218, 51, 'PPL', 'P'),
(94883, 'Highland Addition Colonia', 27.7719993591309, 0.484712828678589, -98.2279968261719, -1.71440196225524, 218, 51, 'PPL', 'P'),
(16429, 'Highland Beach', 26.399169921875, 0.460752434930173, -80.0658264160156, -1.39741228928972, 218, 12, 'PPL', 'P'),
(48105, 'Highland Beach', 38.9302787780762, 0.679461543396704, -76.4661102294922, -1.33458538969756, 218, 25, 'PPL', 'P'),
(149613, 'Highland Beach', 42.877498626709, 0.748353526055419, -76.5155563354492, -1.3354483870488, 218, 40, 'PPL', 'P'),
(169416, 'Highland Beach', 41.6963882446289, 0.727739261058633, -71.366943359375, -1.2455881387054, 218, 47, 'PPL', 'P'),
(174506, 'Highland Beach', 44.1866683959961, 0.771202848997053, -88.3158264160156, -1.54140195257926, 218, 57, 'PPL', 'P'),
(72896, 'Highland Bend', 38.7722206115723, 0.676702907981546, -82.8702774047852, -1.44635919275456, 218, 41, 'PPL', 'P'),
(30073, 'Highland Center', 39.3216705322266, 0.686292618171785, -85.0038909912109, -1.48359777480298, 218, 19, 'PPL', 'P'),
(116025, 'Highland Center', 41.1263885498047, 0.717790889648588, -92.3530578613281, -1.61186493396501, 218, 16, 'PPL', 'P'),
(16430, 'Highland City', 27.9650001525879, 0.488081327983375, -81.878059387207, -1.42904172145021, 218, 12, 'PPL', 'P'),
(155718, 'Highland City', 40.1786117553711, 0.701249064011724, -80.6949996948242, -1.4083934345705, 218, 41, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(196699, 'Highland City (historical)', 45.7969398498535, 0.799307387717741, -112.515281677246, -1.96376212407679, 218, 31, 'PPL', 'P'),
(21912, 'Highland Colony', 34.0663909912109, 0.594570687068366, -84.4169387817383, -1.47335352619582, 218, 13, 'PPL', 'P'),
(41337, 'Highland Community', 30.353609085083, 0.529770418397962, -91.0216674804688, -1.58862778818963, 218, 22, 'PPL', 'P'),
(162679, 'Highland Corners', 41.5602798461914, 0.725363721366283, -78.8511123657227, -1.37621152964188, 218, 45, 'PPL', 'P'),
(3109, 'Highland Crest', 33.3777809143066, 0.582552173963974, -86.8463897705078, -1.51575544496568, 218, 2, 'PPL', 'P'),
(41339, 'Highland Crossing', 30.3388900756836, 0.52951352322131, -91.0330581665039, -1.58882659316501, 218, 22, 'PPL', 'P'),
(21913, 'Highland Estates', 32.5897216796875, 0.568797945619124, -83.6444396972656, -1.45987087370313, 218, 13, 'PPL', 'P'),
(41340, 'Highland Estates', 30.357780456543, 0.529843222564262, -91.1041717529297, -1.59006775939104, 218, 22, 'PPL', 'P'),
(48106, 'Highland Estates', 38.5055618286133, 0.67204883423955, -77.0063934326172, -1.34401511048531, 218, 25, 'PPL', 'P'),
(87793, 'Highland Estates', 35.9277801513672, 0.627058056574024, -85.1786117553711, -1.48664722740917, 218, 50, 'PPL', 'P'),
(113560, 'Highland Estates', 41.5944404602051, 0.725959936555324, -72.7019424438477, -1.26888826824055, 218, 8, 'PPL', 'P'),
(120018, 'Highland Estates', 41.9388885498047, 0.731971689821042, -89.1105575561523, -1.55527262764277, 218, 18, 'PPL', 'P'),
(149614, 'Highland Falls', 41.3691711425781, 0.722028245259013, -73.966667175293, -1.29096187893568, 218, 40, 'PPL', 'P'),
(9495, 'Highland Farm', 34.9666709899902, 0.610283537236915, -90.3847198486328, -1.57751095485131, 218, 4, 'PPL', 'P'),
(48107, 'Highland Farms', 39.6138916015625, 0.691392837975395, -77.540283203125, -1.35333324482339, 218, 25, 'PPL', 'P'),
(162680, 'Highland Fling', 40.5922203063965, 0.70846789504152, -78.4475021362305, -1.36916720224251, 218, 45, 'PPL', 'P'),
(81547, 'Highland Forest', 34.0938911437988, 0.595050655275825, -81.0027770996094, -1.41376516364725, 218, 48, 'PPL', 'P'),
(87794, 'Highland Forest', 35.853328704834, 0.625758633699147, -84.6891708374023, -1.47810487189663, 218, 50, 'PPL', 'P'),
(65590, 'Highland Gate', 35.5997200012207, 0.621332326809381, -82.5338897705078, -1.44048812097343, 218, 33, 'PPL', 'P'),
(125069, 'Highland Glen Estates', 42.2838897705078, 0.737993097045711, -72.4127807617188, -1.2638414448168, 218, 23, 'PPL', 'P'),
(94884, 'Highland Haven', 30.608060836792, 0.534211439252751, -98.3955612182617, -1.71732651260631, 218, 51, 'PPL', 'P'),
(120019, 'Highland Haven', 42.0558280944824, 0.734012669901451, -88.3641662597656, -1.54224564201259, 218, 18, 'PPL', 'P'),
(21914, 'Highland Heights', 30.8788890838623, 0.538938283871533, -83.2747192382813, -1.45341803438187, 218, 13, 'PPL', 'P'),
(36420, 'Highland Heights', 39.0330581665039, 0.681255382127954, -84.4519424438477, -1.47396445534989, 218, 21, 'PPL', 'P'),
(87797, 'Highland Heights', 36.2236099243164, 0.632221260137415, -86.5652770996094, -1.51084910328943, 218, 50, 'PPL', 'P'),
(94885, 'Highland Heights', 29.8633308410645, 0.521213448788942, -95.4277801513672, -1.66552896151065, 218, 51, 'PPL', 'P'),
(102799, 'Highland Heights', 37.5491714477539, 0.655356673159152, -75.8338928222656, -1.32355111435303, 218, 53, 'PPL', 'P'),
(155719, 'Highland Heights', 41.5519409179688, 0.72521817961271, -81.4786071777344, -1.42206996519055, 218, 41, 'PPL', 'P'),
(207642, 'Highland Heights', 47.2172203063965, 0.824095957986144, -124.201667785645, -2.16772803932767, 218, 56, 'PPL', 'P'),
(21915, 'Highland Hills', 33.547779083252, 0.585519201734432, -84.445556640625, -1.47385300205827, 218, 13, 'PPL', 'P'),
(65591, 'Highland Hills', 35.267219543457, 0.615529099057017, -82.4063873291016, -1.43826278356656, 218, 33, 'PPL', 'P'),
(87798, 'Highland Hills', 35.8061103820801, 0.624934518499822, -84.2486114501953, -1.4704156600393, 218, 50, 'PPL', 'P'),
(102801, 'Highland Hills', 36.7380599975586, 0.641200107752617, -78.8833312988281, -1.37677385610605, 218, 53, 'PPL', 'P'),
(120020, 'Highland Hills', 41.8491706848145, 0.730405817679102, -88.0044403076172, -1.53596723974273, 218, 18, 'PPL', 'P'),
(155721, 'Highland Hills', 41.4483299255371, 0.723409826653519, -81.519172668457, -1.42277796656635, 218, 41, 'PPL', 'P'),
(3112, 'Highland Home', 31.9533290863037, 0.557690799529271, -86.3138885498047, -1.50646154539353, 218, 2, 'PPL', 'P'),
(102803, 'Highland Homes', 38.3294410705566, 0.668974947130354, -77.4419403076172, -1.35161683750083, 218, 53, 'PPL', 'P'),
(87800, 'Highland Homesite Addition', 35.9519386291504, 0.627479701553611, -84.9888916015625, -1.48333598606782, 218, 50, 'PPL', 'P'),
(3113, 'Highland Lake', 33.8849983215332, 0.591404787743507, -86.4197235107422, -1.5083087139256, 218, 2, 'PPL', 'P'),
(48108, 'Highland Lake', 39.1897201538086, 0.683989649619139, -76.9694366455078, -1.34337009286929, 218, 25, 'PPL', 'P'),
(125070, 'Highland Lake', 42.1263885498047, 0.735244182168531, -71.3102798461914, -1.2445991738346, 218, 23, 'PPL', 'P'),
(127744, 'Highland Lake', 43.7436103820801, 0.763470027876872, -70.3552780151367, -1.22793124752012, 218, 26, 'PPL', 'P'),
(145420, 'Highland Lake', 41.1766700744629, 0.718668467806796, -74.4569396972656, -1.29951874867616, 218, 37, 'PPL', 'P'),
(149615, 'Highland Lake', 41.5233306884766, 0.72471883690832, -74.8516693115234, -1.30640808010008, 218, 40, 'PPL', 'P'),
(194236, 'Highland Lake', 40.2477798461914, 0.702456274933857, -105.013893127441, -1.8328381954113, 218, 7, 'PPL', 'P'),
(16432, 'Highland Lakes', 25.9680595397949, 0.453228139323345, -80.163330078125, -1.39911404922628, 218, 12, 'PPL', 'P'),
(41344, 'Highland Lakes', 30.3436107635498, 0.529595914767535, -91.0524978637695, -1.58916587988788, 218, 22, 'PPL', 'P'),
(145421, 'Highland Lakes', 41.1772193908691, 0.71867805518672, -74.4691696166992, -1.29973220103753, 218, 37, 'PPL', 'P'),
(102804, 'Highland Landing', 37.749439239502, 0.658852005510853, -76.345832824707, -1.3324861529683, 218, 53, 'PPL', 'P'),
(149616, 'Highland Landing', 41.7177810668945, 0.728112636243462, -73.9486083984375, -1.29064669382067, 218, 40, 'PPL', 'P'),
(87801, 'Highland Manor', 35.125560760498, 0.613056686880014, -85.1172180175781, -1.48557570454458, 218, 50, 'PPL', 'P'),
(13942, 'Highland Meadows', 39.7861099243164, 0.694398614739713, -75.6722183227539, -1.32072936202004, 218, 10, 'PPL', 'P'),
(94886, 'Highland Memorial Park Colonia', 26.2229995727539, 0.457677682293622, -97.9929962158203, -1.71030042786041, 218, 51, 'PPL', 'P'),
(21917, 'Highland Mills', 33.2777786254883, 0.580806804764563, -84.2827835083008, -1.47101207496543, 218, 13, 'PPL', 'P'),
(149617, 'Highland Mills', 41.3469390869141, 0.721640222688188, -74.1266708374023, -1.29375446965473, 218, 40, 'PPL', 'P'),
(196700, 'Highland Mobile Home Park', 47.1136093139648, 0.822287605026953, -104.745277404785, -1.82814996662832, 218, 31, 'PPL', 'P'),
(21919, 'Highland Oaks', 33.9097213745117, 0.591836286419127, -83.4080581665039, -1.45574523770044, 218, 13, 'PPL', 'P'),
(16434, 'Highland Park', 28.7924995422363, 0.502523916890984, -81.271110534668, -1.41844846558221, 218, 12, 'PPL', 'P'),
(21922, 'Highland Park', 32.4877815246582, 0.567018754273869, -84.9369430541992, -1.4824293128747, 218, 13, 'PPL', 'P'),
(32755, 'Highland Park', 39.0244407653809, 0.681104980105392, -95.663330078125, -1.66964008328541, 218, 20, 'PPL', 'P'),
(36414, 'Highland Park', 36.7491683959961, 0.641393985879975, -84.1588897705078, -1.46884972131834, 218, 21, 'PPL', 'P'),
(41345, 'Highland Park', 29.648609161377, 0.517465848502983, -90.7649993896484, -1.58414808492001, 218, 22, 'PPL', 'P'),
(48112, 'Highland Park', 38.3205604553223, 0.668819951154911, -75.1888885498047, -1.31229366610916, 218, 25, 'PPL', 'P'),
(65593, 'Highland Park', 34.9141693115234, 0.609367210084846, -79.6761093139648, -1.39061044270761, 218, 33, 'PPL', 'P'),
(81550, 'Highland Park', 35.063060760498, 0.611965856097518, -82.0891723632813, -1.43272633797639, 218, 48, 'PPL', 'P'),
(87807, 'Highland Park', 36.5366706848145, 0.637685201166904, -82.5216674804688, -1.44027480177011, 218, 50, 'PPL', 'P'),
(94887, 'Highland Park', 32.8333282470703, 0.573049682299435, -96.7916717529297, -1.68933336059821, 218, 51, 'PPL', 'P'),
(102808, 'Highland Park', 38.9099998474121, 0.679107609287833, -78.225830078125, -1.36529829496889, 218, 53, 'PPL', 'P'),
(109653, 'Highland Park', 38.9458312988281, 0.67973298609081, -79.8536071777344, -1.39370836484564, 218, 58, 'PPL', 'P'),
(113561, 'Highland Park', 41.7649993896484, 0.728936751442787, -72.4963912963867, -1.26530072393611, 218, 8, 'PPL', 'P'),
(116026, 'Highland Park', 43.0547218322754, 0.751446654503491, -96.3430633544922, -1.68150366699338, 218, 16, 'PPL', 'P'),
(120021, 'Highland Park', 42.1816711425781, 0.736209045431467, -87.8002777099609, -1.53240393020421, 218, 18, 'PPL', 'P'),
(125071, 'Highland Park', 42.2222213745117, 0.736916780491155, -72.6208267211914, -1.26747253180507, 218, 23, 'PPL', 'P'),
(127745, 'Highland Park', 44.0430603027344, 0.768696414937125, -70.9419403076172, -1.2381704361212, 218, 26, 'PPL', 'P'),
(131305, 'Highland Park', 42.4055595397949, 0.740116635119913, -83.0969390869141, -1.45031518539582, 218, 27, 'PPL', 'P'),
(145422, 'Highland Park', 40.4958305358887, 0.706785576180917, -74.4247207641602, -1.29895642221198, 218, 37, 'PPL', 'P'),
(149618, 'Highland Park', 43.1961097717285, 0.753914339569559, -78.6744384765625, -1.37312798857373, 218, 40, 'PPL', 'P'),
(155723, 'Highland Park', 40.5438919067383, 0.707624405345265, -84.5319366455078, -1.47536061755136, 218, 41, 'PPL', 'P'),
(162685, 'Highland Park', 40.6586112976074, 0.709626636431814, -75.2636108398438, -1.31359781609497, 218, 45, 'PPL', 'P'),
(174507, 'Highland Park', 43.8941688537598, 0.766097768924453, -88.3475036621094, -1.54195482482156, 218, 57, 'PPL', 'P'),
(178365, 'Highland Park', 34.5591697692871, 0.603171299229749, -112.568328857422, -1.96468797202976, 218, 5, 'PPL', 'P'),
(182132, 'Highland Park', 38.5577812194824, 0.672960234543603, -121.487503051758, -2.12035692827983, 218, 6, 'PPL', 'P'),
(186850, 'Highland Park', 39.4988899230957, 0.68938568004083, -105.528610229492, -1.84182170355841, 218, 7, 'PPL', 'P'),
(207643, 'Highland Park', 47.5286102294922, 0.829530737401696, -122.351387023926, -2.13543454794937, 218, 56, 'PPL', 'P'),
(211872, 'Highland Park', 64.7569427490234, 1.13022186449593, -147.360565185547, -2.57192705008752, 218, 1, 'PPL', 'P'),
(81551, 'Highland Park (historical)', 34.1694412231445, 0.596369252910551, -79.7861099243164, -1.39253031553745, 218, 48, 'PPL', 'P'),
(204308, 'Highland Park Addition', 40.7644386291504, 0.711473671805838, -111.92749786377, -1.9535033612417, 218, 52, 'PPL', 'P'),
(135927, 'Highland Park Estates', 43.6347198486328, 0.761569529543964, -91.4966735839844, -1.59691820866305, 218, 28, 'PPL', 'P'),
(204309, 'Highland Park Magna', 40.7069396972656, 0.710470126128069, -112.111106872559, -1.95670794298139, 218, 52, 'PPL', 'P'),
(65597, 'Highland Park West', 36.0688896179199, 0.629520881371102, -79.8572235107422, -1.39377148176348, 218, 33, 'PPL', 'P'),
(21925, 'Highland Pines', 32.5577812194824, 0.568240479423943, -84.9469375610352, -1.48260374992611, 218, 13, 'PPL', 'P'),
(65598, 'Highland Pines', 34.9058303833008, 0.609221668331273, -79.7377777099609, -1.39168675926216, 218, 33, 'PPL', 'P'),
(178366, 'Highland Pines', 34.5605583190918, 0.603195533995669, -112.568893432617, -1.96469782572579, 218, 5, 'PPL', 'P'),
(182134, 'Highland Plams Mobile Home Park', 33.7408294677734, 0.588888566566573, -117.121673583984, -2.04415882948659, 218, 6, 'PPL', 'P'),
(48113, 'Highland Ridge', 39.6494407653809, 0.692013287930357, -76.378059387207, -1.33304861259053, 218, 25, 'PPL', 'P'),
(87808, 'Highland Rim', 35.0838890075684, 0.612329377586314, -86.5977783203125, -1.51141635660162, 218, 50, 'PPL', 'P'),
(87809, 'Highland Rim Falls Subdivision', 35.0819396972656, 0.612295355703388, -86.5805587768555, -1.5111158188726, 218, 50, 'PPL', 'P'),
(174508, 'Highland Shore', 44.0508308410645, 0.768832036415638, -88.6305618286133, -1.54689512180171, 218, 57, 'PPL', 'P'),
(36415, 'Highland Springs', 37.1313896179199, 0.648065004673542, -86.0258331298828, -1.50143402988767, 218, 21, 'PPL', 'P'),
(87811, 'Highland Springs', 36.2294387817383, 0.632322992891056, -83.6427764892578, -1.45984184524725, 218, 50, 'PPL', 'P'),
(102811, 'Highland Springs', 37.5458297729492, 0.655298349931279, -77.3280563354492, -1.34962918722125, 218, 53, 'PPL', 'P'),
(155724, 'Highland Springs', 41.2602806091309, 0.720127746926105, -81.4669418334961, -1.42186636652521, 218, 41, 'PPL', 'P'),
(182136, 'Highland Springs', 33.9694404602051, 0.592878581090756, -116.941390991211, -2.04101230465867, 218, 6, 'PPL', 'P'),
(41350, 'Highland Square', 32.5752792358398, 0.568545877421948, -93.7861099243164, -1.63687641081665, 218, 22, 'PPL', 'P'),
(72901, 'Highland Station', 39.3358306884766, 0.686539759520944, -83.5933303833008, -1.45897884789601, 218, 41, 'PPL', 'P'),
(200972, 'Highland Station (historical)', 44.9577789306641, 0.784661266723823, -123.027221679688, -2.1472300878915, 218, 43, 'PPL', 'P'),
(13943, 'Highland Terrace', 38.6966705322266, 0.67538431034682, -75.394172668457, -1.31587654988169, 218, 10, 'PPL', 'P'),
(155725, 'Highland Terrace', 40.1105613708496, 0.700061360744576, -80.9058303833008, -1.41207312424866, 218, 41, 'PPL', 'P'),
(178367, 'Highland Terrace Mobile Home Park', 33.5938911437988, 0.586324009015853, -112.097221374512, -1.95646559532219, 218, 5, 'PPL', 'P'),
(120022, 'Highland Town (historical)', 41.1941719055176, 0.718973932383828, -88.4916687011719, -1.54447097941946, 218, 18, 'PPL', 'P'),
(16435, 'Highland View', 29.8377799987793, 0.520767502464408, -85.3158264160156, -1.48904207501943, 218, 12, 'PPL', 'P'),
(48115, 'Highland View', 39.002498626709, 0.680722017540639, -77.0097198486328, -1.34407316739707, 218, 25, 'PPL', 'P'),
(87813, 'Highland View', 36.1030616760254, 0.630117296297225, -83.970832824707, -1.46556750843287, 218, 50, 'PPL', 'P'),
(21926, 'Highland Village', 33.5286102294922, 0.58518464212249, -84.1913909912109, -1.46941697463052, 218, 13, 'PPL', 'P'),
(30075, 'Highland Village', 39.160831451416, 0.683485446645759, -86.583610534668, -1.5111690820944, 218, 19, 'PPL', 'P'),
(81553, 'Highland Village', 33.0402793884277, 0.576661661106882, -80.1033325195313, -1.39806689428567, 218, 48, 'PPL', 'P'),
(94888, 'Highland Village', 33.0916709899902, 0.577558613762021, -97.04638671875, -1.69377897540588, 218, 51, 'PPL', 'P'),
(182137, 'Highland Village', 38.7066688537598, 0.675558813977247, -121.070831298828, -2.11308463429115, 218, 6, 'PPL', 'P'),
(94889, 'Highland Waters', 29.7513904571533, 0.519259720523746, -99.1355590820313, -1.73024191178681, 218, 51, 'PPL', 'P'),
(13944, 'Highland West', 39.7569389343262, 0.693889484918317, -75.6624984741211, -1.3205597186586, 218, 10, 'PPL', 'P'),
(13945, 'Highland Woods', 39.8166694641113, 0.694931979327029, -75.4805603027344, -1.31738429853284, 218, 10, 'PPL', 'P'),
(48116, 'Highland Woods', 39.6097183227539, 0.691320000519582, -77.5422210693359, -1.35336706696923, 218, 25, 'PPL', 'P'),
(102812, 'Highland-Biltmore', 36.8111114501953, 0.642475096124493, -76.3369369506836, -1.33233089067675, 218, 53, 'PPL', 'P'),
(149620, 'Highland-on-the-Lake', 42.7080612182617, 0.745396285401968, -78.9783325195313, -1.37843194020073, 218, 40, 'PPL', 'P'),
(60256, 'Highlandale', 33.6805610656738, 0.587836684515018, -90.3438873291016, -1.57679829294361, 218, 30, 'PPL', 'P'),
(116037, 'Highlander Mobile Home Park', 40.7138900756836, 0.710591433115722, -92.8655624389648, -1.62080982627631, 218, 16, 'PPL', 'P'),
(41351, 'Highlandia', 30.3416690826416, 0.529562026042663, -91.0280609130859, -1.58873937463931, 218, 22, 'PPL', 'P'),
(3119, 'Highlands', 33.2983283996582, 0.58116546598437, -86.9194412231445, -1.51703043333756, 218, 2, 'PPL', 'P'),
(16436, 'Highlands', 30.4252796173096, 0.531021305161972, -81.6780624389648, -1.42555111620945, 218, 12, 'PPL', 'P'),
(36417, 'Highlands', 38.2272186279297, 0.667190828937082, -85.7083282470703, -1.49589252429144, 218, 21, 'PPL', 'P'),
(65602, 'Highlands', 35.0525016784668, 0.611781565350084, -83.1969375610352, -1.4520604880162, 218, 33, 'PPL', 'P'),
(94890, 'Highlands', 29.8186092376709, 0.520432909562954, -95.0558319091797, -1.65903724003747, 218, 51, 'PPL', 'P'),
(102813, 'Highlands', 38.8980598449707, 0.678899216932534, -77.0833282470703, -1.34535787630693, 218, 53, 'PPL', 'P'),
(125074, 'Highlands', 42.6305618286133, 0.744043665884316, -71.3375015258789, -1.24507428177307, 218, 23, 'PPL', 'P'),
(127747, 'Highlands', 43.6683311462402, 0.762156157353082, -70.291389465332, -1.2268161819717, 218, 26, 'PPL', 'P'),
(143956, 'Highlands', 44.3727798461914, 0.774451106578623, -71.4388885498047, -1.24684381915937, 218, 36, 'PPL', 'P'),
(145424, 'Highlands', 40.4036102294922, 0.7051760281971, -73.991943359375, -1.29140303157025, 218, 37, 'PPL', 'P'),
(162688, 'Highlands', 41.0133285522461, 0.715817620438894, -75.883056640625, -1.32440918485625, 218, 45, 'PPL', 'P'),
(182138, 'Highlands', 37.5200004577637, 0.654847543337756, -122.342781066895, -2.13528434566389, 218, 6, 'PPL', 'P'),
(195093, 'Highlands', 43.646110534668, 0.761768334519339, -116.192779541016, -2.02794657003463, 218, 17, 'PPL', 'P'),
(204311, 'Highlands', 40.8436088562012, 0.712855452937426, -111.896942138672, -1.95297006323341, 218, 52, 'PPL', 'P'),
(207644, 'Highlands', 47.621940612793, 0.831159659882443, -122.148330688477, -2.13189054632875, 218, 56, 'PPL', 'P'),
(87814, 'Highlands (historical)', 36.2249984741211, 0.632245494903335, -83.6341705322266, -1.45969164296177, 218, 50, 'PPL', 'P'),
(182140, 'Highlands Mobile Home Park', 32.8352813720703, 0.573083770761388, -117.031936645508, -2.04259262444952, 218, 6, 'PPL', 'P'),
(48117, 'Highlands of Darnestown', 39.0991706848145, 0.682409263249258, -77.2844390869141, -1.34886792262365, 218, 25, 'PPL', 'P'),
(48118, 'Highlands of Monroe', 39.5458297729492, 0.690204934971165, -77.5438919067383, -1.35339622858317, 218, 25, 'PPL', 'P'),
(48119, 'Highlands of Olney', 39.146671295166, 0.6832383052966, -77.0652770996094, -1.34504282434997, 218, 25, 'PPL', 'P'),
(122814, 'Highlands Park', 41.2733306884766, 0.720355513778334, -85.7858276367188, -1.49724514380909, 218, 19, 'PPL', 'P'),
(207645, 'Highlands Park', 47.4949989318848, 0.828944109592579, -122.181106567383, -2.1324625933309, 218, 56, 'PPL', 'P'),
(16438, 'Highlands Park Estates', 27.3033294677734, 0.476532995969437, -81.3127822875977, -1.41917577487591, 218, 12, 'PPL', 'P'),
(186851, 'Highlands Ranch', 39.5538902282715, 0.690345616455749, -104.968887329102, -1.83205269604778, 218, 7, 'PPL', 'P'),
(48120, 'Highlandtown', 39.2863883972168, 0.685676828748731, -76.5691680908203, -1.3363840886978, 218, 25, 'PPL', 'P'),
(155728, 'Highlandtown', 40.6341705322266, 0.70920006460421, -80.7569427490234, -1.40947454481502, 218, 41, 'PPL', 'P'),
(55297, 'Highlandville', 36.9327812194824, 0.644598634198695, -93.2802810668945, -1.62804803180304, 218, 29, 'PPL', 'P'),
(116038, 'Highlandville', 43.4422187805176, 0.758209752091748, -91.668327331543, -1.59991413173133, 218, 16, 'PPL', 'P'),
(125075, 'Highlandville', 42.7938919067383, 0.746894313515137, -71.0822219848633, -1.24061881326936, 218, 23, 'PPL', 'P'),
(109654, 'Highlawn', 38.3763885498047, 0.669794335218744, -81.809440612793, -1.427844097908, 218, 58, 'PPL', 'P'),
(55298, 'Highley Heights', 37.8813896179199, 0.661154974063499, -90.517219543457, -1.57982351078388, 218, 29, 'PPL', 'P'),
(207646, 'Highline', 47.4736099243164, 0.828570800986777, -122.323059082031, -2.134940132093, 218, 56, 'PPL', 'P'),
(120024, 'Highmoor', 42.1997184753418, 0.736524030809396, -87.8422164916992, -1.53313590002981, 218, 18, 'PPL', 'P'),
(170516, 'Highmore', 44.5213890075684, 0.777044825743278, -99.4411087036133, -1.73557475871164, 218, 49, 'PPL', 'P'),
(3120, 'Highmound', 34.1438903808594, 0.595923306586017, -86.3788909912109, -1.5075960520179, 218, 2, 'PPL', 'P'),
(149622, 'Highmount', 42.1441688537598, 0.735554507014552, -74.4902801513672, -1.30010064937434, 218, 40, 'PPL', 'P'),
(162689, 'Highmount', 40.0311088562012, 0.698674652764972, -76.5761108398438, -1.33650526252739, 218, 45, 'PPL', 'P'),
(3121, 'Highnote', 30.9958305358887, 0.540979297241456, -85.692497253418, -1.49561622132834, 218, 2, 'PPL', 'P'),
(127748, 'Highpine', 43.3558311462402, 0.756702003440599, -70.6544418334961, -1.23315264115333, 218, 26, 'PPL', 'P'),
(16439, 'Highpoint', 27.9166698455811, 0.487237804997606, -82.7130584716797, -1.4436152047254, 218, 12, 'PPL', 'P'),
(48121, 'Highpoint', 39.6908302307129, 0.692735670376041, -75.8819427490234, -1.3243897437803, 218, 25, 'PPL', 'P'),
(60257, 'Highpoint', 33.188060760498, 0.579240932622624, -89.146110534668, -1.55589314417676, 218, 30, 'PPL', 'P'),
(72902, 'Highpoint', 39.288330078125, 0.685710717473602, -84.3502807617188, -1.47219012427362, 218, 41, 'PPL', 'P'),
(87815, 'Highpoint (historical)', 36.0394401550293, 0.629006891280717, -83.754997253418, -1.46180046707095, 218, 50, 'PPL', 'P'),
(21931, 'Highpoint Forest', 33.8833312988281, 0.591375692708597, -84.3638916015625, -1.47242767824286, 218, 13, 'PPL', 'P'),
(21929, 'Highpoint Mobile Home Park', 33.5263900756836, 0.58514589312863, -83.8536071777344, -1.46352153492541, 218, 13, 'PPL', 'P'),
(78465, 'Highrock', 39.8152809143066, 0.694907744561109, -76.4791717529297, -1.33481335628687, 218, 45, 'PPL', 'P'),
(70957, 'Highs Beach', 39.0791702270508, 0.682060189409376, -74.9088897705078, -1.30740676550886, 218, 37, 'PPL', 'P'),
(65609, 'Highsmith', 34.4749984741211, 0.601702232993434, -77.9822235107422, -1.36104655828858, 218, 33, 'PPL', 'P'),
(65604, 'Highsmiths', 34.9183311462402, 0.609439847803578, -78.496940612793, -1.37003006643569, 218, 33, 'PPL', 'P'),
(162690, 'Highspire', 40.2108306884766, 0.701811390475894, -76.791389465332, -1.34026258335133, 218, 45, 'PPL', 'P'),
(36418, 'Highsplint', 36.894718170166, 0.643934308664775, -83.1172180175781, -1.45066911950469, 218, 21, 'PPL', 'P'),
(60258, 'Hight', 32.9541702270508, 0.575158772724723, -89.0652770996094, -1.55448233458929, 218, 30, 'PPL', 'P'),
(3124, 'Hightogy', 33.6949996948242, 0.588088686133167, -88.0947189331055, -1.53754289900168, 218, 2, 'PPL', 'P'),
(162692, 'Highton', 40.3222198486328, 0.703755498071652, -74.9888916015625, -1.30880306086839, 218, 45, 'PPL', 'P'),
(36419, 'Hightop', 37.0327796936035, 0.646343936819078, -84.1877822875977, -1.46935399087074, 218, 21, 'PPL', 'P'),
(3125, 'Hightower', 33.5316696166992, 0.585238038502346, -85.3955612182617, -1.49043370984705, 218, 2, 'PPL', 'P'),
(9497, 'Hightower', 35.8141708374023, 0.625075199984406, -90.0169372558594, -1.5710919376759, 218, 4, 'PPL', 'P'),
(21930, 'Hightower', 34.3061103820801, 0.598754579719907, -84.2147216796875, -1.4698241719612, 218, 13, 'PPL', 'P'),
(76089, 'Hightower', 34.6305618286133, 0.60441732572477, -99.2533264160156, -1.73229733951614, 218, 42, 'PPL', 'P'),
(94891, 'Hightower', 30.3913898468018, 0.530429817083866, -94.9719390869141, -1.65757303407015, 218, 51, 'PPL', 'P'),
(21932, 'Hightower Forest', 33.7069396972656, 0.588297078488466, -83.9138870239258, -1.46457361671405, 218, 13, 'PPL', 'P'),
(65605, 'Hightowers', 36.3269386291504, 0.63402468624859, -79.2436065673828, -1.38306184575583, 218, 33, 'PPL', 'P'),
(60259, 'Hightown', 34.8216705322266, 0.60775280183204, -88.6727828979492, -1.54763201847533, 218, 30, 'PPL', 'P'),
(102815, 'Hightown', 38.5263900756836, 0.672412355728346, -78.8041687011719, -1.37539220813251, 218, 53, 'PPL', 'P'),
(178368, 'Hightown', 33.3044395446777, 0.581272125586028, -111.90860748291, -1.95317366189875, 218, 5, 'PPL', 'P'),
(182141, 'Hights Corner', 35.4433288574219, 0.618602786429132, -119.201393127441, -2.08045678303799, 218, 6, 'PPL', 'P'),
(145426, 'Hightstown', 40.2694396972656, 0.702834310650594, -74.5236129760742, -1.30068241691447, 218, 37, 'PPL', 'P'),
(65607, 'Hightsville', 34.2694396972656, 0.598114555530934, -77.9319381713867, -1.36016891355135, 218, 33, 'PPL', 'P'),
(3126, 'Highview', 33.2972183227539, 0.58114609148744, -87.6508331298828, -1.52979563023258, 218, 2, 'PPL', 'P'),
(48123, 'Highview', 39.2527809143066, 0.685090267518641, -77.2227783203125, -1.34779173922715, 218, 25, 'PPL', 'P'),
(112344, 'Highview', 37.3058280944824, 0.65110953043172, -86.8444366455078, -1.51572135650373, 218, 21, 'PPL', 'P'),
(116039, 'Highview', 42.4719390869141, 0.741275176773124, -93.9038925170898, -1.63893210486208, 218, 16, 'PPL', 'P'),
(196701, 'Highview', 45.9208297729492, 0.801469674785804, -112.425003051758, -1.96218646481785, 218, 31, 'PPL', 'P'),
(55299, 'Highview (historical)', 38.9555587768555, 0.679902762610303, -90.809440612793, -1.58492373058749, 218, 29, 'PPL', 'P'),
(81557, 'Highview (historical)', 33.6569404602051, 0.587424427178274, -81.9375, -1.43007915585285, 218, 48, 'PPL', 'P'),
(21933, 'Highview Acres', 33.5008316040039, 0.584699813646041, -82.1430587768555, -1.43366683331535, 218, 13, 'PPL', 'P'),
(48125, 'Highview Estates', 39.5752792358398, 0.690718925061551, -76.4955596923828, -1.33509937978794, 218, 25, 'PPL', 'P'),
(116040, 'Highview Mobile Home Park', 41.5449981689453, 0.725097005783111, -93.595832824707, -1.63355544893732, 218, 16, 'PPL', 'P'),
(102816, 'Highview Park', 38.8936080932617, 0.678821519207731, -77.1277770996094, -1.34613365513247, 218, 53, 'PPL', 'P'),
(78466, 'Highville', 39.9466705322266, 0.697200925996749, -76.4169387817383, -1.33372718603628, 218, 45, 'PPL', 'P'),
(155729, 'Highwater', 40.1758308410645, 0.701200527900857, -82.5194396972656, -1.4402359196182, 218, 41, 'PPL', 'P'),
(36421, 'Highway', 36.7383308410645, 0.641204834863552, -85.2088928222656, -1.4871757317275, 218, 21, 'PPL', 'P'),
(155730, 'Highway (historical)', 40.0322189331055, 0.698694027261902, -83.0511093139648, -1.44951530496242, 218, 41, 'PPL', 'P'),
(94892, 'Highway 16 South Colonia', 27.8600006103516, 0.486248740258265, -98.6179962158203, -1.72120873568537, 218, 51, 'PPL', 'P'),
(76090, 'Highway 9 Landing', 35.2400016784668, 0.615054057697574, -95.4922180175781, -1.66665361443899, 218, 42, 'PPL', 'P'),
(182142, 'Highway City', 36.8108291625977, 0.642470169276476, -119.883888244629, -2.0923685699617, 218, 6, 'PPL', 'P'),
(94893, 'Highway Frontage Colonia', 26.4029998779297, 0.460819280273534, -98.1380004882813, -1.71283122984431, 218, 51, 'PPL', 'P'),
(188685, 'Highway Mill', 33.3661117553711, 0.58234850871961, -104.847778320313, -1.82993894509058, 218, 38, 'PPL', 'P'),
(116041, 'Highway Three Mobile Home Park', 42.7174987792969, 0.745561001915389, -92.4347229003906, -1.61329025778042, 218, 16, 'PPL', 'P'),
(120026, 'Highway Village', 40.665828704834, 0.709752603951374, -89.5458297729492, -1.56286956096833, 218, 18, 'PPL', 'P'),
(120027, 'Highwood', 42.1997184753418, 0.736524030809396, -87.8091735839844, -1.53255919249576, 218, 18, 'PPL', 'P'),
(131309, 'Highwood', 43.9272193908691, 0.766674609616564, -84.3063888549805, -1.47142406598606, 218, 27, 'PPL', 'P'),
(135931, 'Highwood', 44.9147186279297, 0.783909722664203, -93.0141677856445, -1.62340347886194, 218, 28, 'PPL', 'P'),
(174512, 'Highwood', 42.8600006103516, 0.748048128057414, -89.0216674804688, -1.55372120314974, 218, 57, 'PPL', 'P'),
(196702, 'Highwood', 47.583610534668, 0.830490673816615, -110.789436340332, -1.93364044056745, 218, 31, 'PPL', 'P'),
(113562, 'Highwood (historical)', 41.3383293151855, 0.721489953823681, -72.934440612793, -1.27294612679351, 218, 8, 'PPL', 'P'),
(30079, 'Highwoods', 39.8441696166992, 0.695411947534488, -86.1833267211914, -1.5041828116068, 218, 19, 'PPL', 'P'),
(196703, 'Highwoods Mobile Home Park', 47.5152816772461, 0.829298110280478, -111.237503051758, -1.94146067995041, 218, 31, 'PPL', 'P'),
(178369, 'Higley', 33.3072204589844, 0.581320661696894, -111.720283508301, -1.94988678848137, 218, 5, 'PPL', 'P'),
(113563, 'Higley Village', 41.936939239502, 0.731937667938116, -72.7263870239258, -1.26931490664718, 218, 8, 'PPL', 'P'),
(131310, 'Higman Park', 42.1305618286133, 0.735317019624345, -86.4688873291016, -1.50916678442883, 218, 27, 'PPL', 'P'),
(211464, 'Hikapoloa', 20.2422199249268, 0.353293385602771, -155.859436035156, -2.72026032911497, 218, 15, 'PPL', 'P'),
(190306, 'Hiko', 37.5969390869141, 0.656190375738401, -115.223327636719, -2.01102644236492, 218, 39, 'PPL', 'P'),
(209506, 'Hiland', 43.1152801513672, 0.752503596561117, -107.348327636719, -1.87358176377037, 218, 59, 'PPL', 'P'),
(16440, 'Hiland Park', 30.2008304595947, 0.52710392835652, -85.6269378662109, -1.49447199416599, 218, 12, 'PPL', 'P'),
(102818, 'Hiland Park', 37.0438919067383, 0.646537881525463, -76.3372192382813, -1.33233581752477, 218, 53, 'PPL', 'P'),
(196704, 'Hiland Trailer Court', 45.6805610656738, 0.797276194754338, -111.018058776855, -1.93763065482872, 218, 31, 'PPL', 'P'),
(102819, 'Hilander Park', 36.6549987792969, 0.639750416013233, -82.0822219848633, -1.43260503098874, 218, 53, 'PPL', 'P'),
(182144, 'Hilarita', 37.8841705322266, 0.661203510174366, -122.470832824707, -2.13751927045069, 218, 6, 'PPL', 'P'),
(109655, 'Hilbert', 38.9222183227539, 0.679320861912121, -81.3672180175781, -1.42012585759479, 218, 58, 'PPL', 'P'),
(174513, 'Hilbert', 44.1402816772461, 0.770393248025669, -88.1638870239258, -1.53875010992381, 218, 57, 'PPL', 'P'),
(174514, 'Hilbert Junction', 44.146110534668, 0.77049498077931, -88.1594390869141, -1.53867247877803, 218, 57, 'PPL', 'P'),
(162693, 'Hilborn', 41.4855613708496, 0.724059637959498, -77.4966735839844, -1.35257211338384, 218, 45, 'PPL', 'P'),
(174516, 'Hilburn', 42.788330078125, 0.746797241293404, -88.3550033569336, -1.54208571918913, 218, 57, 'PPL', 'P'),
(191605, 'Hilburn', 34.3655586242676, 0.599792147280602, -102.089996337891, -1.78180656944514, 218, 51, 'PPL', 'P'),
(196705, 'Hilcrest (historical)', 46.6430587768555, 0.814074948857367, -105.97444152832, -1.8496029276314, 218, 31, 'PPL', 'P'),
(36423, 'Hilda', 38.2380599975586, 0.667380046532532, -83.5077819824219, -1.45748574663086, 218, 21, 'PPL', 'P'),
(55301, 'Hilda', 36.6636085510254, 0.639900684877741, -92.9819412231445, -1.62284101923972, 218, 29, 'PPL', 'P'),
(60260, 'Hilda', 30.3944396972656, 0.530483047016154, -88.6680603027344, -1.54754959363959, 218, 30, 'PPL', 'P'),
(81558, 'Hilda', 33.2733306884766, 0.580729173618788, -81.2472229003906, -1.41803154771355, 218, 48, 'PPL', 'P'),
(94894, 'Hilda', 30.586669921875, 0.533838097357435, -99.1141662597656, -1.72986853660198, 218, 51, 'PPL', 'P'),
(102820, 'Hilda', 36.8202781677246, 0.642635085526979, -77.3294372558594, -1.34965328882911, 218, 53, 'PPL', 'P'),
(207647, 'Hilda', 46.6369400024414, 0.813968156097655, -123.36833190918, -2.15318358450837, 218, 56, 'PPL', 'P'),
(94895, 'Hilda Colonia', 26.2240009307861, 0.457695159288276, -98.3619995117188, -1.71674075032455, 218, 51, 'PPL', 'P'),
(94896, 'Hilda Colonia Number 1', 26.3369998931885, 0.459667363233534, -98.1240005493164, -1.7125868848143, 218, 51, 'PPL', 'P'),
(94897, 'Hilda Colonia Number 2', 26.2509994506836, 0.458166372353652, -98.3539962768555, -1.71660106752537, 218, 51, 'PPL', 'P'),
(94898, 'Hilda Colonia Number 3', 26.2530002593994, 0.458201293053445, -98.3539962768555, -1.71660106752537, 218, 51, 'PPL', 'P'),
(94899, 'Hilda Siding', 29.5880603790283, 0.516409072892926, -98.0702819824219, -1.71164931895253, 218, 51, 'PPL', 'P'),
(192619, 'Hildale', 37.0036087036133, 0.645834806997682, -112.966110229492, -1.97163056667549, 218, 52, 'PPL', 'P'),
(65608, 'Hildebran', 35.7138900756836, 0.623324970516006, -81.4222183227539, -1.42108579400971, 218, 33, 'PPL', 'P'),
(78467, 'Hildebrand', 39.7438888549805, 0.693661718066088, -76.753059387207, -1.3395935972855, 218, 45, 'PPL', 'P'),
(200974, 'Hildebrand', 42.297779083252, 0.738235511283935, -121.478332519531, -2.12019687229832, 218, 43, 'PPL', 'P'),
(30078, 'Hildebrand Village', 39.5466690063477, 0.690219582357161, -85.7861099243164, -1.4972500706571, 218, 19, 'PPL', 'P'),
(16441, 'Hilden', 30.065559387207, 0.524743002760651, -81.4402770996094, -1.42140097912472, 218, 12, 'PPL', 'P'),
(21934, 'Hilderbrand', 33.6888885498047, 0.587982026531509, -84.6608276367188, -1.47761018972415, 218, 13, 'PPL', 'P'),
(55302, 'Hilderbrand', 37.5755615234375, 0.655817266869681, -89.853889465332, -1.56824621689309, 218, 29, 'PPL', 'P'),
(109656, 'Hilderbrand', 39.5905609130859, 0.690985640644722, -79.9977798461914, -1.3962246526016, 218, 58, 'PPL', 'P'),
(16442, 'Hildreth', 29.9524993896484, 0.522769733550957, -82.8055572509766, -1.44522961297821, 218, 12, 'PPL', 'P'),
(27434, 'Hildreth', 39.8655586242676, 0.69578525614029, -87.835563659668, -1.53301978620629, 218, 18, 'PPL', 'P'),
(142060, 'Hildreth', 40.3372192382813, 0.704017286806807, -99.043327331543, -1.72863216406591, 218, 35, 'PPL', 'P'),
(182145, 'Hildreth', 37.1088905334473, 0.64767232157081, -119.631942749023, -2.08797129152782, 218, 6, 'PPL', 'P'),
(196706, 'Hildreth', 44.6808280944824, 0.779827562766302, -113.038887023926, -1.9729007613574, 218, 31, 'PPL', 'P'),
(102821, 'Hildreths House', 36.9069404602051, 0.64414762786809, -81.2872161865234, -1.41872956223526, 218, 53, 'PPL', 'P'),
(127749, 'Hildreths Mill', 44.6738891601563, 0.779706455515731, -70.3694381713867, -1.22817838886928, 218, 26, 'PPL', 'P'),
(162695, 'Hileman Heights', 40.4922218322754, 0.706722592421137, -78.3938903808594, -1.36823150059351, 218, 45, 'PPL', 'P'),
(55303, 'Hiler', 39.0761108398438, 0.68200679302952, -94.1994400024414, -1.64409038157746, 218, 29, 'PPL', 'P'),
(174517, 'Hiles', 45.7038917541504, 0.797683392085011, -88.9772186279297, -1.5529454243242, 218, 57, 'PPL', 'P'),
(32763, 'Hilford', 37.4497184753418, 0.653620891339665, -95.6763916015625, -1.66986804987472, 218, 20, 'PPL', 'P'),
(200975, 'Hilgard', 45.3522186279297, 0.791545538141678, -118.226936340332, -2.06344930368453, 218, 43, 'PPL', 'P'),
(94900, 'Hilger', 33.621940612793, 0.586813564603237, -96.0966720581055, -1.67720332762318, 218, 51, 'PPL', 'P'),
(196707, 'Hilger', 47.2538909912109, 0.824735982175118, -109.359169006348, -1.9086775664057, 218, 31, 'PPL', 'P'),
(87816, 'Hilham', 36.4141693115234, 0.635547148864761, -85.4416732788086, -1.49123851712847, 218, 50, 'PPL', 'P'),
(196708, 'Hiline Trailer Park', 48.3672218322754, 0.84416727101569, -107.843887329102, -1.88223091204262, 218, 31, 'PPL', 'P'),
(858, 'Hill', 35.0944404602051, 0.612513535175693, -94.4691696166992, -1.64879805143639, 218, 42, 'PPL', 'P'),
(941, 'Hill', 35.5480613708496, 0.620430713622335, -86.9486083984375, -1.51753949657993, 218, 50, 'PPL', 'P'),
(27435, 'Hill', 38.9302787780762, 0.679461543396704, -88.521110534668, -1.54498483635179, 218, 18, 'PPL', 'P'),
(41353, 'Hill', 32.0827789306641, 0.559950125529553, -92.4194412231445, -1.61302354219725, 218, 22, 'PPL', 'P'),
(127750, 'Hill', 46.2730598449707, 0.807617249267116, -67.8419418334961, -1.18406525594099, 218, 26, 'PPL', 'P'),
(143957, 'Hill', 43.524169921875, 0.759640069334202, -71.7013931274414, -1.25142538834069, 218, 36, 'PPL', 'P'),
(188686, 'Hill', 32.4272193908691, 0.565961745637217, -106.853057861328, -1.86493767550419, 218, 38, 'PPL', 'P'),
(196709, 'Hill', 48.7849998474121, 0.851458872922273, -111.160003662109, -1.94010806043276, 218, 31, 'PPL', 'P'),
(16443, 'Hill ''n Dale', 28.5194396972656, 0.49775812354126, -82.2994384765625, -1.43639617395852, 218, 12, 'PPL', 'P'),
(190307, 'Hill (historical)', 39.4022216796875, 0.687698500911237, -118.66194152832, -2.07104157647818, 218, 39, 'PPL', 'P'),
(87817, 'Hill Acres', 35.1672210693359, 0.613783796436633, -84.8130569458008, -1.48026709238567, 218, 50, 'PPL', 'P'),
(204325, 'Hill Acres', 41.2455596923828, 0.71987081845994, -112.03556060791, -1.95538941192569, 218, 52, 'PPL', 'P'),
(81560, 'Hill and Dale', 34.1683311462402, 0.59634987841362, -82.1666717529297, -1.43407895749404, 218, 48, 'PPL', 'P'),
(102826, 'Hill and Dale', 38.9688911437988, 0.680135456310549, -78.1897201538086, -1.36466805789693, 218, 53, 'PPL', 'P'),
(21937, 'Hill and Dale Trailer Park', 33.4816703796387, 0.584365387192155, -82.1427764892578, -1.43366190646734, 218, 13, 'PPL', 'P'),
(143960, 'Hill Center', 43.523609161377, 0.759630282217196, -71.7399978637695, -1.25209916809648, 218, 36, 'PPL', 'P'),
(76091, 'Hill Chapel', 33.9861106872559, 0.593169531439848, -94.7480621337891, -1.65366564411878, 218, 42, 'PPL', 'P'),
(162696, 'Hill Church', 40.2447204589844, 0.702402878554001, -80.1744384765625, -1.39930792735364, 218, 45, 'PPL', 'P'),
(21935, 'Hill City', 34.5988883972168, 0.603864520061497, -85.0055618286133, -1.48362693641691, 218, 13, 'PPL', 'P'),
(32764, 'Hill City', 39.3647193908691, 0.687043962494323, -99.841667175293, -1.74256582288921, 218, 20, 'PPL', 'P'),
(55304, 'Hill City', 36.6661109924316, 0.639944360719618, -93.6716690063477, -1.63487903999909, 218, 29, 'PPL', 'P'),
(94901, 'Hill City', 32.3077812194824, 0.563877156293957, -97.8483276367188, -1.7077754848309, 218, 51, 'PPL', 'P'),
(135933, 'Hill City', 46.9933280944824, 0.820188301718671, -93.5983276367188, -1.63359899162115, 218, 28, 'PPL', 'P'),
(162697, 'Hill City', 41.3536109924316, 0.721756669406852, -79.6452789306641, -1.39007235100936, 218, 45, 'PPL', 'P'),
(195094, 'Hill City', 43.3005599975586, 0.755737339914745, -115.050277709961, -2.00800615137266, 218, 17, 'PPL', 'P'),
(202216, 'Hill City', 43.9324989318848, 0.766766754990281, -103.574722290039, -1.80771992579994, 218, 49, 'PPL', 'P'),
(142061, 'Hill City Mobile Home Park', 41.0166702270508, 0.715875943666766, -95.9069366455078, -1.67389181996572, 218, 35, 'PPL', 'P'),
(149623, 'Hill Corners', 43.0238914489746, 0.750908562805241, -74.1736068725586, -1.29457365800604, 218, 40, 'PPL', 'P'),
(94902, 'Hill Country Village', 29.5822200775146, 0.516307140402203, -98.4905624389648, -1.71898459670099, 218, 51, 'PPL', 'P'),
(72903, 'Hill Craft Acres', 39.0805587768555, 0.682084424175296, -84.2850036621094, -1.47105082395929, 218, 41, 'PPL', 'P'),
(9501, 'Hill Creek', 35.2113914489746, 0.614554714993184, -92.6188888549805, -1.61650456005809, 218, 4, 'PPL', 'P'),
(65610, 'Hill Crest', 35.3133316040039, 0.616333906338439, -79.4166717529297, -1.3860824030642, 218, 33, 'PPL', 'P'),
(102822, 'Hill Crest', 39.189998626709, 0.683994509888128, -78.2191696166992, -1.36518204798731, 218, 53, 'PPL', 'P'),
(162698, 'Hill Crest', 40.0944404602051, 0.699779997775409, -75.1811065673828, -1.31215784489356, 218, 45, 'PPL', 'P'),
(162699, 'Hill Distrct', 40.4452781677246, 0.705903270911774, -79.9797210693359, -1.39590946748659, 218, 45, 'PPL', 'P'),
(21936, 'Hill Forest Estates', 34.0416717529297, 0.594139254971773, -84.7083282470703, -1.47843923177149, 218, 13, 'PPL', 'P'),
(204315, 'Hill Gate', 40.7019386291504, 0.710382841023342, -112.103332519531, -1.95657225492385, 218, 52, 'PPL', 'P'),
(102823, 'Hill Grove', 37.0577812194824, 0.646780295763688, -79.2566680908203, -1.38328981234514, 218, 53, 'PPL', 'P'),
(155731, 'Hill Grove', 40.1775016784668, 0.701229689514794, -84.7683334350586, -1.47948651987017, 218, 41, 'PPL', 'P'),
(102824, 'Hill Landing', 36.6563911437988, 0.63977471735818, -75.9813919067383, -1.32612545902076, 218, 53, 'PPL', 'P'),
(13946, 'Hill N Dale', 38.622501373291, 0.67408981431996, -75.6186065673828, -1.31979366037104, 218, 10, 'PPL', 'P'),
(3128, 'Hill Number 1', 33.6855583190918, 0.587923903040719, -86.4688873291016, -1.50916678442883, 218, 2, 'PPL', 'P'),
(3129, 'Hill Number 2', 33.6875, 0.58795779176559, -86.4833297729492, -1.509418852626, 218, 2, 'PPL', 'P'),
(174520, 'Hill Point', 43.4244384765625, 0.757899427245726, -90.1125030517578, -1.57275987546661, 218, 57, 'PPL', 'P'),
(170520, 'Hill Ridge Development', 43.5588912963867, 0.760246071640249, -96.6352767944336, -1.68660375363894, 218, 49, 'PPL', 'P'),
(170521, 'Hill Side', 42.9391708374023, 0.749429909189002, -96.7850036621094, -1.68921698045858, 218, 49, 'PPL', 'P'),
(102825, 'Hill Subdivision', 37.3088912963867, 0.651162993390604, -80.045280456543, -1.39705369464894, 218, 53, 'PPL', 'P'),
(3130, 'Hill Top', 32.2594413757324, 0.56303346686062, -87.9002838134766, -1.53414936598264, 218, 2, 'PPL', 'P'),
(9514, 'Hill Top', 36.1425018310547, 0.630805656859984, -93.2555618286133, -1.62761659970645, 218, 4, 'PPL', 'P'),
(27436, 'Hill Top', 39.9891700744629, 0.697942682939363, -89.883056640625, -1.56875528013546, 218, 18, 'PPL', 'P'),
(36429, 'Hill Top', 38.360279083252, 0.669513171986659, -83.8391723632813, -1.46326959988629, 218, 21, 'PPL', 'P'),
(48128, 'Hill Top', 38.4888916015625, 0.671757883890459, -77.1222229003906, -1.34603671606879, 218, 25, 'PPL', 'P'),
(55305, 'Hill Top', 36.6408309936523, 0.639503141506019, -90.8016662597656, -1.58478804252996, 218, 29, 'PPL', 'P'),
(109658, 'Hill Top', 37.4652786254883, 0.653892467191826, -80.9086074829102, -1.4121215937805, 218, 58, 'PPL', 'P'),
(192620, 'Hill Top', 39.7147216796875, 0.69315265482372, -111.469436645508, -1.94550868480733, 218, 52, 'PPL', 'P'),
(3131, 'Hill Top (historical)', 33.8333282470703, 0.590502974819379, -85.8944396972656, -1.49914078187301, 218, 2, 'PPL', 'P'),
(72904, 'Hill Top Acres', 39.2241706848145, 0.684590924814251, -84.4961090087891, -1.47473530732741, 218, 41, 'PPL', 'P'),
(87820, 'Hill Town', 35.7691688537598, 0.624289767199914, -87.1413879394531, -1.52090413430113, 218, 50, 'PPL', 'P'),
(65611, 'Hill View', 35.4402809143066, 0.618549589786357, -77.6675033569336, -1.35555365538224, 218, 33, 'PPL', 'P'),
(209507, 'Hill View Heights', 43.8258285522461, 0.764905005651234, -104.159439086914, -1.81792515909713, 218, 59, 'PPL', 'P'),
(48129, 'Hill Village', 39.7069396972656, 0.693016833608126, -77.6186065673828, -1.35470024541092, 218, 25, 'PPL', 'P'),
(162708, 'Hill Yard', 40.9166717529297, 0.714130641046383, -75.1050033569336, -1.31082959329989, 218, 45, 'PPL', 'P'),
(48130, 'Hill-N-Dale', 39.584171295166, 0.690874120774075, -76.3483276367188, -1.33252969565212, 218, 25, 'PPL', 'P'),
(78468, 'Hill-n-Dale', 39.9347190856934, 0.696992333904369, -76.6980590820313, -1.33863366087058, 218, 45, 'PPL', 'P'),
(94904, 'Hill-Top Colonia', 26.2910003662109, 0.458864520033416, -98.3379974365234, -1.71632183508508, 218, 51, 'PPL', 'P'),
(202217, 'Hilland', 44.2827796936035, 0.772880307588667, -101.856109619141, -1.77772447612627, 218, 49, 'PPL', 'P'),
(3132, 'Hillandale', 34.7316703796387, 0.606182002842084, -86.6155624389648, -1.51172674802667, 218, 2, 'PPL', 'P'),
(21949, 'Hillandale', 33.5905609130859, 0.586265885525062, -84.4816665649414, -1.47448323913024, 218, 13, 'PPL', 'P'),
(48131, 'Hillandale', 39.0263900756836, 0.681139001988318, -76.9744415283203, -1.34345744455305, 218, 25, 'PPL', 'P'),
(65613, 'Hillandale', 35.274169921875, 0.61565040604467, -82.4272232055664, -1.43862643821341, 218, 33, 'PPL', 'P'),
(48132, 'Hillandale Forest', 39.0238914489746, 0.681095392725468, -76.9649963378906, -1.34329259488157, 218, 25, 'PPL', 'P'),
(48133, 'Hillandale Heights', 39.0208282470703, 0.681041929766584, -76.9886093139648, -1.34370471906026, 218, 25, 'PPL', 'P'),
(48134, 'Hillandale Trailer Park', 39.5086097717285, 0.689555323402268, -76.9077835083008, -1.34229404263084, 218, 25, 'PPL', 'P'),
(87822, 'Hillard', 35.9516716003418, 0.627475041021703, -88.4075012207031, -1.54300197976218, 218, 50, 'PPL', 'P'),
(191606, 'Hillard', 35.6058311462402, 0.621438986411039, -101.411666870117, -1.7699674868192, 218, 51, 'PPL', 'P'),
(41354, 'Hillaryville', 30.1355590820313, 0.525964727910725, -90.9522171020508, -1.58741565041948, 218, 22, 'PPL', 'P'),
(81562, 'Hillavista', 33.4638900756836, 0.584055062346133, -80.8997192382813, -1.41196646464701, 218, 48, 'PPL', 'P'),
(204319, 'Hillborough Heights', 40.577220916748, 0.708206106306365, -111.821388244629, -1.95165139901966, 218, 52, 'PPL', 'P'),
(21938, 'Hillbrook', 33.5050010681152, 0.584772584522828, -82.1358337402344, -1.43354073263774, 218, 13, 'PPL', 'P'),
(48135, 'Hillbrook', 39.3294410705566, 0.686428239650297, -76.5144424438477, -1.33542894597284, 218, 25, 'PPL', 'P'),
(102827, 'Hillbrook', 38.8261108398438, 0.677643469899534, -77.1858291625977, -1.34714685476919, 218, 53, 'PPL', 'P'),
(81563, 'Hillbrook Forest', 34.9738883972168, 0.610409504756475, -81.8766708374023, -1.42901748668429, 218, 48, 'PPL', 'P'),
(149624, 'Hillburn', 41.1238899230957, 0.717747280385738, -74.1697235107422, -1.2945058805563, 218, 40, 'PPL', 'P'),
(188687, 'Hillburn City', 33.0855598449707, 0.577451954160363, -103.315826416016, -1.80320134037841, 218, 38, 'PPL', 'P'),
(16444, 'Hillcoat', 30.4722194671631, 0.531840560092308, -82.9091720581055, -1.44703803251642, 218, 12, 'PPL', 'P'),
(3133, 'Hillcrest', 32.4513893127441, 0.566383590353885, -87.4747161865234, -1.52672180970241, 218, 2, 'PPL', 'P'),
(9506, 'Hillcrest', 35.5424995422363, 0.620333641400601, -93.4319381713867, -1.63069494761047, 218, 4, 'PPL', 'P'),
(13127, 'Hillcrest', 38.8619384765625, 0.678268780123485, -76.9583282470703, -1.34317621474193, 218, 9, 'PPL', 'P'),
(13955, 'Hillcrest', 39.7627792358398, 0.69399141740904, -75.5069427490234, -1.31784475908532, 218, 10, 'PPL', 'P'),
(21941, 'Hillcrest', 33.1291694641113, 0.578213085599908, -85.040283203125, -1.48423293872296, 218, 13, 'PPL', 'P'),
(36425, 'Hillcrest', 37.7686080932617, 0.659186565122795, -84.2916717529297, -1.47116720409892, 218, 21, 'PPL', 'P'),
(48137, 'Hillcrest', 39.6966705322266, 0.692837602866763, -75.7972183227539, -1.32291102358503, 218, 25, 'PPL', 'P'),
(65626, 'Hillcrest', 35.8313903808594, 0.625375737713421, -80.2561111450195, -1.40073338432711, 218, 33, 'PPL', 'P'),
(81566, 'Hillcrest', 34.0349998474121, 0.594022808253109, -80.4647216796875, -1.40437432501141, 218, 48, 'PPL', 'P'),
(87829, 'Hillcrest', 36.5308303833008, 0.637583268676181, -82.495002746582, -1.43980941436962, 218, 50, 'PPL', 'P'),
(94906, 'Hillcrest', 29.7486095428467, 0.51921118441288, -96.600830078125, -1.68600254502285, 218, 51, 'PPL', 'P'),
(102829, 'Hillcrest', 37.6652793884277, 0.65738313901162, -77.8291702270508, -1.35837527455718, 218, 53, 'PPL', 'P'),
(109660, 'Hillcrest', 39.2536087036133, 0.685104715167555, -81.4888916015625, -1.42224946224802, 218, 58, 'PPL', 'P'),
(113564, 'Hillcrest', 41.5441703796387, 0.725082558134197, -73.1025009155273, -1.27587933241812, 218, 8, 'PPL', 'P'),
(120028, 'Hillcrest', 41.9511108398438, 0.732185009024357, -89.0644378662109, -1.55446768720329, 218, 18, 'PPL', 'P'),
(122817, 'Hillcrest', 41.5161094665527, 0.724592802809732, -87.0505599975586, -1.51931888766226, 218, 19, 'PPL', 'P'),
(125076, 'Hillcrest', 41.6541709899902, 0.727002430964036, -71.0749969482422, -1.24049271259175, 218, 23, 'PPL', 'P'),
(131314, 'Hillcrest', 44.4647216796875, 0.77605579429345, -84.773063659668, -1.47956907786396, 218, 27, 'PPL', 'P'),
(145428, 'Hillcrest', 40.2425003051758, 0.70236412956014, -74.7841720581055, -1.30523003079188, 218, 37, 'PPL', 'P'),
(149626, 'Hillcrest', 41.1277809143066, 0.717815190993535, -74.041389465332, -1.29226602892149, 218, 40, 'PPL', 'P'),
(155735, 'Hillcrest', 41.5863914489746, 0.725819454807822, -84.5372161865234, -1.47545276292508, 218, 41, 'PPL', 'P'),
(162700, 'Hillcrest', 40.3486099243164, 0.704216091782181, -80.033332824707, -1.39684516913559, 218, 45, 'PPL', 'P'),
(174522, 'Hillcrest', 46.503059387207, 0.811631498557219, -91.898063659668, -1.60392378706856, 218, 57, 'PPL', 'P'),
(193637, 'Hillcrest', 40.8638916015625, 0.713209453625324, -121.907501220703, -2.12768727918028, 218, 6, 'PPL', 'P'),
(195095, 'Hillcrest', 43.5636100769043, 0.76032842989696, -116.181938171387, -2.02775735243918, 218, 17, 'PPL', 'P'),
(207648, 'Hillcrest', 47.0108299255371, 0.820493766295703, -118.281387329102, -2.06439965271952, 218, 56, 'PPL', 'P'),
(211470, 'Hillcrest', 19.6311092376709, 0.342627492016031, -155.98193359375, -2.72239831483809, 218, 15, 'PPL', 'P'),
(13947, 'Hillcrest Acres Mobile Home Park', 38.6100006103516, 0.673871634847655, -75.2300033569336, -1.31301125486488, 218, 10, 'PPL', 'P'),
(65618, 'Hillcrest Apts', 35.5933303833008, 0.621220806938734, -82.5699996948242, -1.4411183580454, 218, 33, 'PPL', 'P'),
(3139, 'Hillcrest Estates', 33.5944404602051, 0.586333596395778, -86.9277801513672, -1.51717597509113, 218, 2, 'PPL', 'P'),
(87831, 'Hillcrest Estates', 35.186939239502, 0.614127943428499, -85.2266693115234, -1.48748598999449, 218, 50, 'PPL', 'P'),
(102830, 'Hillcrest Estates', 38.723331451416, 0.675849631168284, -77.4400024414063, -1.35158301535499, 218, 53, 'PPL', 'P'),
(143959, 'Hillcrest Estates', 43.0205612182617, 0.75085043931445, -70.7897186279297, -1.23551366661774, 218, 36, 'PPL', 'P'),
(16445, 'Hillcrest Heights', 27.8208293914795, 0.485565073516928, -81.5308303833008, -1.42298143207363, 218, 12, 'PPL', 'P'),
(48139, 'Hillcrest Heights', 38.8327789306641, 0.677759850039171, -76.959716796875, -1.34320044950785, 218, 25, 'PPL', 'P'),
(102831, 'Hillcrest Heights', 37.3002815246582, 0.651012724526096, -80.067497253418, -1.39744145090366, 218, 53, 'PPL', 'P'),
(204322, 'Hillcrest Heights', 40.6111106872559, 0.708797594384472, -111.863059997559, -1.95237870831336, 218, 52, 'PPL', 'P'),
(191607, 'Hillcrest Manor Colonia', 31.6560001373291, 0.55250143040817, -106.25700378418, -1.85453456933801, 218, 51, 'PPL', 'P'),
(116042, 'Hillcrest Mobile Home Park', 42.4688911437988, 0.74122198013035, -93.793327331543, -1.63700237833621, 218, 16, 'PPL', 'P'),
(135937, 'Hillcrest Mobile Home Park', 43.7638893127441, 0.763823961985744, -93.3288879394531, -1.62889638176828, 218, 28, 'PPL', 'P'),
(155736, 'Hillcrest Mobile Home Park', 40.2138900756836, 0.70186478685575, -83.3166732788086, -1.45415027052359, 218, 41, 'PPL', 'P'),
(65621, 'Hillcrest Mobile Home Subdivision', 34.7822189331055, 0.6070642415322, -77.4986114501953, -1.35260593552969, 218, 33, 'PPL', 'P'),
(131315, 'Hillcrest Orchard', 41.8494415283203, 0.730410544790037, -83.4766693115234, -1.45694272808459, 218, 27, 'PPL', 'P'),
(204323, 'Hillcrest Park', 40.6416702270508, 0.709330958971788, -111.883613586426, -1.95273743611219, 218, 52, 'PPL', 'P'),
(135938, 'Hillcrest Park Mobile Home Park', 43.6425018310547, 0.761705350759558, -94.0861129760742, -1.64211245183586, 218, 28, 'PPL', 'P'),
(30081, 'Hillcrest Terrace', 37.9488906860352, 0.662333089950723, -87.3963928222656, -1.52535480911487, 218, 19, 'PPL', 'P'),
(94907, 'Hillcrest Terrace Colonia', 26.382999420166, 0.460470206433652, -98.1129989624023, -1.7123948708997, 218, 51, 'PPL', 'P'),
(21944, 'Hillcrest Valley', 33.7827796936035, 0.589620736129262, -84.5458297729492, -1.47560309836861, 218, 13, 'PPL', 'P'),
(78470, 'Hillcroft', 39.9461097717285, 0.697191138879743, -76.7044372558594, -1.33874498100415, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(21945, 'Hillcroft Heights', 34.1847190856934, 0.596635901914695, -83.8375015258789, -1.46324043827236, 218, 13, 'PPL', 'P'),
(13948, 'Hilldale', 39.1958312988281, 0.684096309220796, -75.4819412231445, -1.31740840014071, 218, 10, 'PPL', 'P'),
(32766, 'Hilldale', 39.1819381713867, 0.683853828403544, -95.475830078125, -1.66636759093792, 218, 20, 'PPL', 'P'),
(55307, 'Hilldale', 39.063060760498, 0.681779026177291, -92.5611114501953, -1.61549615411133, 218, 29, 'PPL', 'P'),
(81569, 'Hilldale', 33.8938903808594, 0.591559983456031, -80.4000015258789, -1.40324474523505, 218, 48, 'PPL', 'P'),
(109661, 'Hilldale', 37.6377792358398, 0.656903170804161, -80.7874984741211, -1.41000784282331, 218, 58, 'PPL', 'P'),
(162703, 'Hilldale', 41.2891693115234, 0.720631949899484, -75.836669921875, -1.32359958388487, 218, 45, 'PPL', 'P'),
(196711, 'Hilldale Colony', 48.7999992370605, 0.851720661657427, -109.779441833496, -1.91601271099611, 218, 31, 'PPL', 'P'),
(87832, 'Hilldale Estates', 35.0380592346191, 0.611529497152908, -86.5677795410156, -1.51089277913131, 218, 50, 'PPL', 'P'),
(32767, 'Hilldale South', 39.1749992370605, 0.683732721152973, -95.4763870239258, -1.66637731147589, 218, 20, 'PPL', 'P'),
(94908, 'Hillebrandt', 29.9330596923828, 0.522430446828081, -94.1130599975586, -1.64258276608436, 218, 51, 'PPL', 'P'),
(190308, 'Hillegas (historical)', 36.1536102294922, 0.630999534987341, -115.020561218262, -2.00748750075037, 218, 39, 'PPL', 'P'),
(162704, 'Hillegass', 40.3716697692871, 0.70461856200192, -75.5205612182617, -1.31808244621261, 218, 45, 'PPL', 'P'),
(9507, 'Hillemann', 35.122501373291, 0.613003290500158, -91.0888900756836, -1.58980104380787, 218, 4, 'PPL', 'P'),
(13949, 'Hillendale', 39.7958297729492, 0.694568258101151, -75.4861068725586, -1.31748110443847, 218, 10, 'PPL', 'P'),
(48143, 'Hillendale', 39.3800010681152, 0.687310678077495, -76.5699996948242, -1.33639860292574, 218, 25, 'PPL', 'P'),
(102833, 'Hillendale', 38.663330078125, 0.674802409648638, -77.3358306884766, -1.34976487527879, 218, 53, 'PPL', 'P'),
(48144, 'Hillendale Farms', 39.3888893127441, 0.687465807210992, -76.5555572509766, -1.33614653472856, 218, 25, 'PPL', 'P'),
(48145, 'Hillendale Heights', 39.5113906860352, 0.689603859513135, -76.5602798461914, -1.3362289595643, 218, 25, 'PPL', 'P'),
(48146, 'Hillendale Park', 39.3836097717285, 0.687373661837275, -76.5619430541992, -1.33625798802018, 218, 25, 'PPL', 'P'),
(162705, 'Hiller', 40.0102806091309, 0.698311131276176, -79.9011077880859, -1.39453740689298, 218, 45, 'PPL', 'P'),
(190309, 'Hiller (historical)', 39.8444404602051, 0.695416674645423, -116.598609924316, -2.03502964642786, 218, 39, 'PPL', 'P'),
(199401, 'Hillerage', 41.8616714477539, 0.730623997151407, -103.603057861328, -1.80821447481437, 218, 35, 'PPL', 'P'),
(27438, 'Hillerman', 37.2366714477539, 0.649902519246669, -88.8897171020508, -1.5514182345971, 218, 18, 'PPL', 'P'),
(120029, 'Hillery', 40.1311111450195, 0.700420021964382, -87.6944427490234, -1.53055676167213, 218, 18, 'PPL', 'P'),
(65623, 'Hillgirt', 35.3652801513672, 0.617240579531556, -82.48388671875, -1.43961540308421, 218, 33, 'PPL', 'P'),
(36426, 'Hillgrove', 37.8791694641113, 0.661116225069639, -86.1638870239258, -1.50384352488392, 218, 21, 'PPL', 'P'),
(182147, 'Hillgrove', 34.0166702270508, 0.593702896027163, -117.97917175293, -2.05912499586451, 218, 6, 'PPL', 'P'),
(207649, 'Hillgrove', 47.0666694641113, 0.821468350096618, -123.266670227051, -2.1514092534321, 218, 56, 'PPL', 'P'),
(30082, 'Hillham', 38.5138893127441, 0.672194176256041, -86.7005615234375, -1.5132102619119, 218, 19, 'PPL', 'P'),
(170522, 'Hillhead', 45.8349990844727, 0.799971646672634, -97.3916702270508, -1.69980530947857, 218, 49, 'PPL', 'P'),
(60266, 'Hillhouse', 34.125560760498, 0.595603394360071, -90.8180618286133, -1.58507419918908, 218, 30, 'PPL', 'P'),
(60267, 'Hillhouse Landing', 34.1336097717285, 0.595743876107573, -90.8411102294922, -1.58547646967174, 218, 30, 'PPL', 'P'),
(207650, 'Hillhurst', 47.0869407653809, 0.821822151047435, -122.505828857422, -2.13813006644669, 218, 56, 'PPL', 'P'),
(3140, 'Hilliard', 33.8144416809082, 0.590173342055454, -87.3763885498047, -1.52500566869597, 218, 2, 'PPL', 'P'),
(16446, 'Hilliard', 30.6908302307129, 0.535656037696551, -81.9175033569336, -1.429730148592, 218, 12, 'PPL', 'P'),
(55315, 'Hilliard', 36.8252792358398, 0.642722370631707, -90.4166717529297, -1.57806862078358, 218, 29, 'PPL', 'P'),
(155739, 'Hilliard', 40.0333290100098, 0.698713401758832, -83.158332824707, -1.45138670826041, 218, 41, 'PPL', 'P'),
(209508, 'Hilliard', 41.1377792358398, 0.717989694623962, -110.811111450195, -1.9340187426003, 218, 59, 'PPL', 'P'),
(131316, 'Hilliards', 42.6747207641602, 0.744814384703785, -85.7283325195313, -1.49624166471035, 218, 27, 'PPL', 'P'),
(162706, 'Hilliards', 41.0858306884766, 0.717083021430845, -79.833610534668, -1.39335935758479, 218, 45, 'PPL', 'P'),
(65624, 'Hilliardston', 36.105281829834, 0.630156045291086, -77.9300003051758, -1.3601350914055, 218, 33, 'PPL', 'P'),
(16447, 'Hilliardville', 30.2875003814697, 0.528616603855685, -84.3994369506836, -1.47304806161879, 218, 12, 'PPL', 'P'),
(113565, 'Hilliardville', 41.7841682434082, 0.729271311054729, -72.5558319091797, -1.26633815833875, 218, 8, 'PPL', 'P'),
(87833, 'Hillis (historical)', 35.7286109924316, 0.623581898982171, -85.6222229003906, -1.49438970248831, 218, 50, 'PPL', 'P'),
(122818, 'Hillisburg', 40.2863883972168, 0.703130121268674, -86.3391723632813, -1.50690283118615, 218, 19, 'PPL', 'P'),
(94909, 'Hillister', 30.6674995422363, 0.535248840365878, -94.3811111450195, -1.64726114117131, 218, 51, 'PPL', 'P'),
(94910, 'Hillje', 29.148609161377, 0.508739202243011, -96.3430633544922, -1.68150366699338, 218, 51, 'PPL', 'P'),
(182148, 'Hillmaid', 36.413890838623, 0.635542288595771, -119.133888244629, -2.07927860057174, 218, 6, 'PPL', 'P'),
(3141, 'Hillman', 33.4449996948242, 0.583725363003181, -86.9080581665039, -1.51683176152024, 218, 2, 'PPL', 'P'),
(21947, 'Hillman', 33.600830078125, 0.586445116266425, -82.7977828979492, -1.44509392492067, 218, 13, 'PPL', 'P'),
(60268, 'Hillman', 31.1333293914795, 0.54337910498924, -88.6327819824219, -1.54693387079557, 218, 30, 'PPL', 'P'),
(131317, 'Hillman', 45.0591697692871, 0.786430870689154, -83.9011077880859, -1.46435057697276, 218, 27, 'PPL', 'P'),
(135939, 'Hillman', 46.0041694641113, 0.802924226794178, -93.8936080932617, -1.63875260780461, 218, 28, 'PPL', 'P'),
(162707, 'Hillman', 40.9047203063965, 0.713922048954002, -78.8502807617188, -1.37619701541393, 218, 45, 'PPL', 'P'),
(177343, 'Hillman', 46.204719543457, 0.806424485993896, -68.1605606079102, -1.18962620261318, 218, 26, 'PPL', 'P'),
(196712, 'Hillman', 45.8891716003418, 0.80091713543864, -111.196670532227, -1.94074801804271, 218, 31, 'PPL', 'P'),
(72906, 'Hillman (historical)', 38.8305587768555, 0.67772110104531, -83.8741683959961, -1.4638803958823, 218, 41, 'PPL', 'P'),
(207651, 'Hillman City (historical)', 47.5561103820801, 0.830010705609156, -122.260559082031, -2.1338493013105, 218, 56, 'PPL', 'P'),
(3142, 'Hillman Gardens', 33.4477806091309, 0.583773899114048, -86.9030609130859, -1.51674454299454, 218, 2, 'PPL', 'P'),
(3143, 'Hillman Park', 33.4447212219238, 0.583720502734192, -86.9005584716797, -1.51670086715266, 218, 2, 'PPL', 'P'),
(48147, 'Hillmark', 39.3944396972656, 0.687562679695643, -77.3841705322266, -1.35060856471213, 218, 25, 'PPL', 'P'),
(48148, 'Hillmead', 38.9977798461914, 0.680639659283928, -77.1275024414063, -1.3461288614425, 218, 25, 'PPL', 'P'),
(48149, 'Hillmeade', 38.9772186279297, 0.68028079832704, -76.795280456543, -1.34033049395913, 218, 25, 'PPL', 'P'),
(48150, 'Hillmeade Manor', 38.9844398498535, 0.680406832425628, -76.7947235107422, -1.34032077342115, 218, 25, 'PPL', 'P'),
(87836, 'Hillrose', 36.0702781677246, 0.629545116137022, -85.5972213745117, -1.4939533435437, 218, 50, 'PPL', 'P'),
(194237, 'Hillrose', 40.3258285522461, 0.703818481831432, -103.521392822266, -1.80678915099896, 218, 7, 'PPL', 'P'),
(21948, 'Hills', 34.5999984741211, 0.603883894558427, -83.5163879394531, -1.45763594891634, 218, 13, 'PPL', 'P'),
(65625, 'Hills', 35.313060760498, 0.616329179227504, -80.2611083984375, -1.40082060285281, 218, 33, 'PPL', 'P'),
(72908, 'Hills', 39.4330596923828, 0.688236725767542, -81.3622207641602, -1.42003863906909, 218, 41, 'PPL', 'P'),
(94911, 'Hills', 30.1873397827148, 0.526868471626644, -97.0511016845703, -1.69386126708357, 218, 51, 'PPL', 'P'),
(116043, 'Hills', 41.5541687011719, 0.725257061764625, -91.5347213745117, -1.59758226788086, 218, 16, 'PPL', 'P'),
(135943, 'Hills', 43.5280609130859, 0.759707979941999, -96.3583297729492, -1.68177011626044, 218, 28, 'PPL', 'P'),
(72909, 'Hills (historical)', 39.1791687011719, 0.68380549202976, -83.0416717529297, -1.44935058844899, 218, 41, 'PPL', 'P'),
(36427, 'Hills and Dales', 38.3011093139648, 0.668480464694953, -85.6247177124023, -1.49443324517213, 218, 21, 'PPL', 'P'),
(87837, 'Hills and Dales', 35.1916694641113, 0.614210501422291, -84.9180603027344, -1.48209974668981, 218, 50, 'PPL', 'P'),
(155740, 'Hills and Dales', 40.829719543457, 0.712613038699201, -81.4449996948242, -1.42148340396046, 218, 41, 'PPL', 'P'),
(127752, 'Hills Beach', 43.4583282470703, 0.758490915323833, -70.3786087036133, -1.22833844485079, 218, 26, 'PPL', 'P'),
(190310, 'Hills Camp (historical)', 35.776668548584, 0.624420661567491, -114.70027923584, -2.00189752562229, 218, 39, 'PPL', 'P'),
(60269, 'Hills Chapel', 34.6291694641113, 0.604393024379823, -88.45361328125, -1.5438067870436, 218, 30, 'PPL', 'P'),
(102834, 'Hills Corner', 36.7516708374023, 0.641437661721852, -76.0105590820313, -1.32663452226312, 218, 53, 'PPL', 'P'),
(143962, 'Hills Corner', 43.3338890075684, 0.756319040875846, -71.1452789306641, -1.24171936458984, 218, 36, 'PPL', 'P'),
(113111, 'Hills Corners', 41.8849983215332, 0.731031127903053, -86.4752807617188, -1.5092783708785, 218, 27, 'PPL', 'P'),
(109662, 'Hills Crossing', 38.9416694641113, 0.679660348372078, -81.8144378662109, -1.4279313164337, 218, 58, 'PPL', 'P'),
(65639, 'Hills Crossroads', 36.1883316040039, 0.631605537293389, -77.4619369506836, -1.35196584476169, 218, 33, 'PPL', 'P'),
(182149, 'Hills Ferry', 37.3488883972168, 0.651861074491341, -120.978607177734, -2.11147501972831, 218, 6, 'PPL', 'P'),
(182150, 'Hills Flat', 39.2241706848145, 0.684590924814251, -121.052223205566, -2.11275986179622, 218, 6, 'PPL', 'P'),
(65628, 'Hills Grove', 36.422779083252, 0.635697417729268, -80.461669921875, -1.40432106178961, 218, 33, 'PPL', 'P'),
(120030, 'Hills Grove (historical)', 40.3891716003418, 0.704924026578952, -90.8705596923828, -1.58599045976213, 218, 18, 'PPL', 'P'),
(135944, 'Hills Mobile Home Park', 43.8280601501465, 0.764943954382176, -91.3038864135742, -1.59355343778379, 218, 28, 'PPL', 'P'),
(204326, 'Hills of Homes', 41.1791687011719, 0.718712077069646, -112.028610229492, -1.95526810493804, 218, 52, 'PPL', 'P'),
(21950, 'Hills Park', 33.8050003051758, 0.590008558963005, -84.434440612793, -1.47365899077286, 218, 13, 'PPL', 'P'),
(48151, 'Hills Point', 38.603328704834, 0.673755188128991, -76.2372207641602, -1.33059051490438, 218, 25, 'PPL', 'P'),
(94912, 'Hills Prairie', 30.0513896942139, 0.524495694963924, -97.2916717529297, -1.69806000685819, 218, 51, 'PPL', 'P'),
(21951, 'Hills Store', 33.0191688537598, 0.57629321277007, -81.6011123657227, -1.42420808407172, 218, 13, 'PPL', 'P'),
(55309, 'Hills Store', 36.7197189331055, 0.64087999578959, -89.8088912963867, -1.56746085068763, 218, 29, 'PPL', 'P'),
(162709, 'Hills Terrace', 40.8161087036133, 0.712375484729966, -76.1500015258789, -1.32906825202529, 218, 45, 'PPL', 'P'),
(48152, 'Hills Trailer Park', 38.2444381713867, 0.667491366666098, -76.4897232055664, -1.33499751387625, 218, 25, 'PPL', 'P'),
(21952, 'Hills-A-Rolling', 34.0930595397949, 0.595036141047884, -84.6458282470703, -1.477348400989, 218, 13, 'PPL', 'P'),
(3146, 'Hillsboro', 34.9388885498047, 0.609798642181439, -86.4233322143555, -1.50837169768538, 218, 2, 'PPL', 'P'),
(9509, 'Hillsboro', 33.1355590820313, 0.578324605470555, -92.4977798461914, -1.61439080910089, 218, 4, 'PPL', 'P'),
(21953, 'Hillsboro', 33.1797218322754, 0.579095390869051, -83.64111328125, -1.45981281679137, 218, 13, 'PPL', 'P'),
(27447, 'Hillsboro', 39.1611099243164, 0.683490306914749, -89.4936065673828, -1.56195809408525, 218, 18, 'PPL', 'P'),
(32768, 'Hillsboro', 38.3519401550293, 0.669367630233086, -97.2041702270508, -1.69653281713108, 218, 20, 'PPL', 'P'),
(36428, 'Hillsboro', 38.2933311462402, 0.668344710058386, -83.6588897705078, -1.46012307505836, 218, 21, 'PPL', 'P'),
(48153, 'Hillsboro', 38.9166717529297, 0.679224056006496, -75.9391708374023, -1.32538856234713, 218, 25, 'PPL', 'P'),
(55310, 'Hillsboro', 38.2322196960449, 0.66727811404181, -90.5627822875977, -1.58061873068538, 218, 29, 'PPL', 'P'),
(60270, 'Hillsboro', 32.459171295166, 0.566519411569479, -89.5113906860352, -1.5622684855103, 218, 30, 'PPL', 'P'),
(87838, 'Hillsboro', 35.4124984741211, 0.618064694730881, -85.9702835083008, -1.50046450609283, 218, 50, 'PPL', 'P'),
(94913, 'Hillsboro', 32.0108299255371, 0.558694378496554, -97.1297225952148, -1.69523346083523, 218, 51, 'PPL', 'P'),
(102836, 'Hillsboro', 39.1980590820313, 0.684135191372711, -77.7230606079102, -1.35652331233514, 218, 53, 'PPL', 'P'),
(109663, 'Hillsboro', 38.1352806091309, 0.665586207801282, -80.2133331298828, -1.3999867671155, 218, 58, 'PPL', 'P'),
(116044, 'Hillsboro', 40.836669921875, 0.712734345686854, -91.7155609130859, -1.60073851324677, 218, 16, 'PPL', 'P'),
(122819, 'Hillsboro', 40.1088905334473, 0.70003219913064, -87.1855621337891, -1.52167511943671, 218, 19, 'PPL', 'P'),
(140231, 'Hillsboro', 47.4038887023926, 0.827353936105693, -97.0616683959961, -1.69404569098906, 218, 34, 'PPL', 'P'),
(143963, 'Hillsboro', 43.1147193908691, 0.75249380944411, -71.8955612182617, -1.25481426082781, 218, 36, 'PPL', 'P'),
(149627, 'Hillsboro', 43.327220916748, 0.756202660736209, -75.829719543457, -1.32347827689722, 218, 40, 'PPL', 'P'),
(155741, 'Hillsboro', 40.3333282470703, 0.70394937619901, -80.6252822875977, -1.40717663626844, 218, 41, 'PPL', 'P'),
(162711, 'Hillsboro', 40.0683288574219, 0.699324264333869, -80.0466690063477, -1.39707792941486, 218, 45, 'PPL', 'P'),
(174523, 'Hillsboro', 43.6522216796875, 0.761874994120996, -90.3438873291016, -1.57679829294361, 218, 57, 'PPL', 'P'),
(188688, 'Hillsboro', 32.9208297729492, 0.574576872026541, -107.566390991211, -1.8773876872842, 218, 38, 'PPL', 'P'),
(194238, 'Hillsboro', 40.3327789306641, 0.703939788819086, -104.863891601563, -1.8302201749017, 218, 7, 'PPL', 'P'),
(196713, 'Hillsboro', 45.0999984741211, 0.787143466017832, -108.232223510742, -1.88900865701687, 218, 31, 'PPL', 'P'),
(200976, 'Hillsboro', 45.5230598449707, 0.794527279877158, -122.988609313965, -2.14655617497765, 218, 43, 'PPL', 'P'),
(116045, 'Hillsboro (historical)', 41.2874984741211, 0.720602788285548, -91.3625030517578, -1.59457649111654, 218, 16, 'PPL', 'P'),
(87839, 'Hillsboro Acres', 35.9749984741211, 0.627882171773349, -86.8808288574219, -1.51635652042371, 218, 50, 'PPL', 'P'),
(16448, 'Hillsboro Beach', 26.2936096191406, 0.458910060088056, -80.0791702270508, -1.39764518272705, 218, 12, 'PPL', 'P'),
(143964, 'Hillsboro Center', 43.1450004577637, 0.753022313762437, -71.9341735839844, -1.25548817374166, 218, 36, 'PPL', 'P'),
(48154, 'Hillsboro Estates', 38.9172210693359, 0.679233643386421, -75.9330596923828, -1.32528190274547, 218, 25, 'PPL', 'P'),
(143965, 'Hillsboro Lower Village', 43.1122207641602, 0.752450200181261, -71.9447174072266, -1.25567219817298, 218, 36, 'PPL', 'P'),
(143966, 'Hillsboro Upper Village', 43.1305618286133, 0.752770312144288, -71.9763870239258, -1.25622493725723, 218, 36, 'PPL', 'P'),
(87841, 'Hillsboro Valley', 36.0355606079102, 0.628939180410002, -86.8791732788086, -1.51632762512589, 218, 50, 'PPL', 'P'),
(48155, 'Hillsborough', 39.1194381713867, 0.682762997621048, -76.8963928222656, -1.34209523765547, 218, 25, 'PPL', 'P'),
(65629, 'Hillsborough', 36.0752792358398, 0.629632401241749, -79.0999984741211, -1.3805554116959, 218, 33, 'PPL', 'P'),
(145429, 'Hillsborough', 40.4775009155273, 0.706465663954971, -74.6272201538086, -1.30249070329463, 218, 37, 'PPL', 'P'),
(182155, 'Hillsborough', 37.5741691589355, 0.655792965524734, -122.378326416016, -2.13590472903982, 218, 6, 'PPL', 'P'),
(204327, 'Hillsborough Estates', 40.6041717529297, 0.708676487133901, -111.800003051758, -1.95127815699288, 218, 52, 'PPL', 'P'),
(182151, 'Hillsborough Park', 37.5550003051758, 0.655458405912793, -122.357780456543, -2.13554613439905, 218, 6, 'PPL', 'P'),
(3148, 'Hillsdale', 33.8683280944824, 0.591113837394415, -87.2663879394531, -1.52308579586613, 218, 2, 'PPL', 'P'),
(21954, 'Hillsdale', 31.4675006866455, 0.549211494355541, -83.5991668701172, -1.45908071380771, 218, 13, 'PPL', 'P'),
(30085, 'Hillsdale', 39.785831451416, 0.694393754470724, -87.3902816772461, -1.52524814951322, 218, 19, 'PPL', 'P'),
(32770, 'Hillsdale', 38.6597213745117, 0.674739425888857, -94.8499984741211, -1.65544476888501, 218, 20, 'PPL', 'P'),
(41356, 'Hillsdale', 30.7444400787354, 0.536591706056037, -90.6208267211914, -1.58163179716405, 218, 22, 'PPL', 'P'),
(48156, 'Hillsdale', 39.5855598449707, 0.690898355539995, -76.9141693115234, -1.34240549592246, 218, 25, 'PPL', 'P'),
(55311, 'Hillsdale', 38.6833305358887, 0.67515148348852, -90.2838897705078, -1.57575113800299, 218, 29, 'PPL', 'P'),
(60271, 'Hillsdale', 30.9277801513672, 0.539791593974308, -89.4972229003906, -1.56202121100309, 218, 30, 'PPL', 'P'),
(65635, 'Hillsdale', 35.0083312988281, 0.611010646793534, -80.5522232055664, -1.40590151473852, 218, 33, 'PPL', 'P'),
(76093, 'Hillsdale', 36.563060760498, 0.638145794877433, -97.9911117553711, -1.71026753782095, 218, 42, 'PPL', 'P'),
(87842, 'Hillsdale', 36.4461097717285, 0.636104615059942, -86.0586090087891, -1.50200607688982, 218, 50, 'PPL', 'P'),
(102837, 'Hillsdale', 36.7261085510254, 0.640991515660237, -76.6333312988281, -1.33750394793617, 218, 53, 'PPL', 'P'),
(109665, 'Hillsdale', 37.6186103820801, 0.656568611192219, -80.4899978637695, -1.40481547764598, 218, 58, 'PPL', 'P'),
(112343, 'Hillsdale', 36.7969398498535, 0.642227755038252, -86.4763870239258, -1.50929767879641, 218, 21, 'PPL', 'P'),
(116046, 'Hillsdale', 41.0074996948242, 0.715715887685253, -95.6705627441406, -1.66976631712108, 218, 16, 'PPL', 'P'),
(120038, 'Hillsdale', 41.6136093139648, 0.726294496167265, -90.1727828979492, -1.57381195725525, 218, 18, 'PPL', 'P'),
(131319, 'Hillsdale', 41.9199981689453, 0.73164199047809, -84.6305618286133, -1.47708195172193, 218, 27, 'PPL', 'P'),
(145431, 'Hillsdale', 40.339168548584, 0.704051308689733, -74.2255630493164, -1.29548046435721, 218, 37, 'PPL', 'P'),
(149629, 'Hillsdale', 43.3766708374023, 0.757065724666477, -73.3172225952148, -1.27962693270408, 218, 40, 'PPL', 'P'),
(162713, 'Hillsdale', 41.6841697692871, 0.727526008434345, -75.8024978637695, -1.32300316895875, 218, 45, 'PPL', 'P'),
(169417, 'Hillsdale', 41.5213890075684, 0.724684948183449, -71.6408309936523, -1.25036837970403, 218, 47, 'PPL', 'P'),
(174526, 'Hillsdale', 45.3158302307129, 0.790910440800722, -91.8594436645508, -1.60324974099666, 218, 57, 'PPL', 'P'),
(182153, 'Hillsdale', 37.5363883972168, 0.65513356683883, -122.304443359375, -2.13461522644001, 218, 6, 'PPL', 'P'),
(192621, 'Hillsdale', 37.7191696166992, 0.658323700929609, -112.381393432617, -1.9614253333783, 218, 52, 'PPL', 'P'),
(200977, 'Hillsdale', 45.4816703796387, 0.793804897431474, -122.69361114502, -2.1414074856422, 218, 43, 'PPL', 'P'),
(207653, 'Hillsdale', 48.9605598449707, 0.854522972914463, -122.734443664551, -2.14212014754991, 218, 56, 'PPL', 'P'),
(209509, 'Hillsdale', 41.2127799987793, 0.719298704878763, -104.476936340332, -1.82346653153531, 218, 59, 'PPL', 'P'),
(195097, 'Hillsdale (historical)', 44.5105590820313, 0.77685580788491, -116.424171447754, -2.03198512066968, 218, 17, 'PPL', 'P'),
(162714, 'Hillsdale Acres', 40.1699981689453, 0.701098728568189, -76.7099990844727, -1.33884205322588, 218, 45, 'PPL', 'P'),
(48157, 'Hillsdale Green', 39.3208312988281, 0.686277970785789, -76.7069396972656, -1.33878865684603, 218, 25, 'PPL', 'P'),
(21955, 'Hillsdale Heights', 33.8419418334961, 0.590653310262913, -84.6527786254883, -1.47746970797665, 218, 13, 'PPL', 'P'),
(145439, 'Hillsdale Manor', 41.0116691589355, 0.715788658562039, -74.0425033569336, -1.29228546999745, 218, 37, 'PPL', 'P'),
(204331, 'Hillsden Addition', 40.6538887023926, 0.709544211596076, -111.815559387207, -1.95154966626602, 218, 52, 'PPL', 'P'),
(162715, 'Hillsgrove', 41.4438896179199, 0.723332328665797, -76.7074966430664, -1.33879837738401, 218, 45, 'PPL', 'P'),
(169418, 'Hillsgrove', 41.7261085510254, 0.728257978259953, -71.4397201538086, -1.24685833338731, 218, 47, 'PPL', 'P'),
(36430, 'Hillside', 37.2483291625977, 0.650105984753951, -87.163330078125, -1.52128709686589, 218, 21, 'PPL', 'P'),
(41357, 'Hillside', 30.3858299255371, 0.530332778151646, -91.1125030517578, -1.59021316798656, 218, 22, 'PPL', 'P'),
(48159, 'Hillside', 38.8727798461914, 0.678457997718935, -76.9244384765625, -1.34258472666383, 218, 25, 'PPL', 'P'),
(81576, 'Hillside', 33.9602813720703, 0.592718724846324, -81.1816711425781, -1.41688745370926, 218, 48, 'PPL', 'P'),
(120031, 'Hillside', 41.8777809143066, 0.730905160383492, -87.9027786254883, -1.53419290866647, 218, 18, 'PPL', 'P'),
(122820, 'Hillside', 41.7102813720703, 0.727981741875885, -86.6175003051758, -1.51176057017251, 218, 19, 'PPL', 'P'),
(127754, 'Hillside', 43.9094390869141, 0.766364284770543, -70.0308303833008, -1.22226856809428, 218, 26, 'PPL', 'P'),
(145434, 'Hillside', 40.7011108398438, 0.710368393374428, -74.2305603027344, -1.29556768288291, 218, 37, 'PPL', 'P'),
(149633, 'Hillside', 41.9180603027344, 0.731608168332246, -74.0355606079102, -1.29216429616785, 218, 40, 'PPL', 'P'),
(162719, 'Hillside', 40.3680610656738, 0.704555578242139, -79.2608337402344, -1.3833625166429, 218, 45, 'PPL', 'P'),
(170524, 'Hillside', 43.4688911437988, 0.758675272650293, -98.2119369506836, -1.71412166455051, 218, 49, 'PPL', 'P'),
(174527, 'Hillside', 42.9347190856934, 0.749352211464199, -89.0427780151367, -1.55408965148656, 218, 57, 'PPL', 'P'),
(178370, 'Hillside', 34.4183311462402, 0.600713201543606, -112.916389465332, -1.97076277563428, 218, 5, 'PPL', 'P'),
(186853, 'Hillside', 38.2652816772461, 0.667855154471003, -105.611106872559, -1.84326154160176, 218, 7, 'PPL', 'P'),
(196714, 'Hillside', 46.9111099243164, 0.818753323944309, -106.399436950684, -1.85702049705754, 218, 31, 'PPL', 'P'),
(200978, 'Hillside', 45.5922203063965, 0.795734357641237, -123.191390991211, -2.15009538290831, 218, 43, 'PPL', 'P'),
(207654, 'Hillside', 47.1044387817383, 0.82212754904544, -122.577499389648, -2.13938095321071, 218, 56, 'PPL', 'P'),
(9511, 'Hillside (historical)', 36.1833305358887, 0.631518252188662, -90.5141677856445, -1.57977024756208, 218, 4, 'PPL', 'P'),
(162720, 'Hillside (historical)', 40.1208305358887, 0.700240591485938, -75.1333312988281, -1.31132400915626, 218, 45, 'PPL', 'P'),
(182154, 'Hillside (historical)', 37.2058296203613, 0.649364227811337, -119.877777099609, -2.09226191036004, 218, 6, 'PPL', 'P'),
(192624, 'Hillside (historical)', 39.978328704834, 0.697753465343913, -112.000282287598, -1.95477368908167, 218, 52, 'PPL', 'P'),
(13950, 'Hillside Acres', 39.0316696166992, 0.681231147362034, -75.5430603027344, -1.31847512931534, 218, 10, 'PPL', 'P'),
(143969, 'Hillside Acres Mobile Home Park', 42.916389465332, 0.749032299238253, -72.3105621337891, -1.26205739320256, 218, 36, 'PPL', 'P'),
(94914, 'Hillside Acres Number 1 Colonia', 27.6770000457764, 0.483054777873419, -99.1780014038086, -1.73098267004402, 218, 51, 'PPL', 'P'),
(94915, 'Hillside Acres Number 2 Colonia', 27.6749992370605, 0.483019857173625, -99.1780014038086, -1.73098267004402, 218, 51, 'PPL', 'P'),
(48165, 'Hillside at Seminary', 39.4280586242676, 0.688149440662815, -76.6555633544922, -1.337891970507, 218, 25, 'PPL', 'P'),
(170526, 'Hillside Colony', 44.7388916015625, 0.780840962140105, -98.0455627441406, -1.71121788685594, 218, 49, 'PPL', 'P'),
(196715, 'Hillside Colony', 48.9791717529297, 0.854847811988426, -112.067497253418, -1.95594681154185, 218, 31, 'PPL', 'P'),
(21957, 'Hillside Cottages', 33.7897186279297, 0.589741843379834, -84.3647232055664, -1.4724421924708, 218, 13, 'PPL', 'P'),
(48161, 'Hillside Estates', 39.3847198486328, 0.687393036334205, -77.4894409179688, -1.35244587954817, 218, 25, 'PPL', 'P'),
(13951, 'Hillside Heights', 39.6805610656738, 0.692556439634678, -75.6875, -1.32099607760321, 218, 10, 'PPL', 'P'),
(48162, 'Hillside Hunt', 39.461109161377, 0.688726281354926, -76.6791687011719, -1.33830396152763, 218, 25, 'PPL', 'P'),
(162721, 'Hillside Junction', 41.348331451416, 0.721664524033135, -75.7180633544922, -1.32152950876955, 218, 45, 'PPL', 'P'),
(149634, 'Hillside Lake', 41.6147193908691, 0.726313870664196, -73.7986068725586, -1.28802867331106, 218, 40, 'PPL', 'P'),
(48163, 'Hillside Manor', 38.4913902282715, 0.671801493153309, -76.5202789306641, -1.33553081188453, 218, 25, 'PPL', 'P'),
(120032, 'Hillside Manor', 41.1155586242676, 0.717601871790219, -87.9477767944336, -1.53497827487193, 218, 18, 'PPL', 'P'),
(149635, 'Hillside Manor', 40.7502784729004, 0.711226530456679, -73.6733322143555, -1.28584221805611, 218, 40, 'PPL', 'P'),
(41358, 'Hillside Park', 32.5347213745117, 0.567838009204205, -92.232780456543, -1.60976569723575, 218, 22, 'PPL', 'P'),
(48164, 'Hillside Park', 39.1472206115723, 0.683247892676524, -76.5294418334961, -1.33569073470799, 218, 25, 'PPL', 'P'),
(207655, 'Hillside Siding', 46.7425003051758, 0.815810530939772, -120.445831298828, -2.10217632646619, 218, 56, 'PPL', 'P'),
(145435, 'Hillside Terrace', 40.2008285522461, 0.70163682026644, -74.6097183227539, -1.3021852387176, 218, 37, 'PPL', 'P'),
(94916, 'Hillside Terrace Colonia', 26.4120006561279, 0.460976373488335, -98.9800033569336, -1.72752695221353, 218, 51, 'PPL', 'P'),
(204342, 'Hillside Townhouse Condominium', 40.7750015258789, 0.711658029132299, -111.888061523438, -1.95281506725797, 218, 52, 'PPL', 'P'),
(196716, 'Hillside Trailer Court', 48.5569381713867, 0.847478445778013, -109.701393127441, -1.91465050409853, 218, 31, 'PPL', 'P'),
(204343, 'Hillside Village', 40.625560760498, 0.709049795739702, -111.819717407227, -1.95162223740572, 218, 52, 'PPL', 'P'),
(142062, 'Hillside Vista Trailer Court', 41.8283309936523, 0.730042096453225, -97.454719543457, -1.70090572764099, 218, 35, 'PPL', 'P'),
(102838, 'Hillsman Corner', 37.3105583190918, 0.651192088425513, -79.2375030517578, -1.38295531931223, 218, 53, 'PPL', 'P'),
(48166, 'Hillsmere Estates', 38.9308280944824, 0.679471130776628, -76.4944381713867, -1.33507980555393, 218, 25, 'PPL', 'P'),
(48167, 'Hillsmere Shores', 38.939998626709, 0.679631186758142, -76.4952774047852, -1.33509445293992, 218, 25, 'PPL', 'P'),
(48168, 'Hillstead', 39.4075012207031, 0.687790646284954, -76.6750030517578, -1.33823125722987, 218, 25, 'PPL', 'P'),
(13952, 'Hillstream', 39.7694396972656, 0.694107664390622, -75.7375030517578, -1.32186879549243, 218, 10, 'PPL', 'P'),
(87845, 'Hillsview', 35.3886108398438, 0.617647776862229, -84.8013916015625, -1.48006349372033, 218, 50, 'PPL', 'P'),
(162723, 'Hillsview', 40.2786102294922, 0.702994366632107, -79.1730575561523, -1.38183053322583, 218, 45, 'PPL', 'P'),
(170528, 'Hillsview', 45.6647186279297, 0.79699969205416, -99.5580596923828, -1.73761593852913, 218, 49, 'PPL', 'P'),
(200979, 'Hillsview', 45.4555587768555, 0.793349163989934, -122.412780761719, -2.13650607081396, 218, 43, 'PPL', 'P'),
(81577, 'Hillsville', 34.6624984741211, 0.604974725340924, -81.966667175293, -1.43058821909522, 218, 48, 'PPL', 'P'),
(102839, 'Hillsville', 36.7625007629395, 0.641626679580221, -80.7350006103516, -1.40909158225027, 218, 53, 'PPL', 'P'),
(125077, 'Hillsville', 42.2611083984375, 0.737595487094962, -72.0111083984375, -1.25683093956328, 218, 23, 'PPL', 'P'),
(162724, 'Hillsville', 41.0077781677246, 0.715720747954242, -80.496940612793, -1.40493665147558, 218, 45, 'PPL', 'P'),
(3152, 'Hilltop', 33.3424987792969, 0.581936384540921, -86.9300003051758, -1.51721472408499, 218, 2, 'PPL', 'P'),
(21960, 'Hilltop', 33.103889465332, 0.577771866386309, -84.4361114501953, -1.47368815238679, 218, 13, 'PPL', 'P'),
(32771, 'Hilltop', 38.0555610656738, 0.66419483928977, -96.039436340332, -1.67620437589829, 218, 20, 'PPL', 'P'),
(36433, 'Hilltop', 36.6641693115234, 0.639910471994746, -86.779167175293, -1.51458218934745, 218, 21, 'PPL', 'P'),
(41359, 'Hilltop', 32.3408317565918, 0.564453996986068, -92.7016677856445, -1.61794932494946, 218, 22, 'PPL', 'P'),
(48181, 'Hilltop', 39.3836097717285, 0.687373661837275, -76.9327774047852, -1.3427302684174, 218, 25, 'PPL', 'P'),
(55313, 'Hilltop', 37.2316703796387, 0.649815234141942, -89.5066680908203, -1.56218606067456, 218, 29, 'PPL', 'P'),
(65640, 'Hilltop', 36.0305595397949, 0.628851895305274, -79.8847198486328, -1.39425138339191, 218, 33, 'PPL', 'P'),
(70958, 'Hilltop', 39.8244400024414, 0.695067600805541, -75.0677795410156, -1.31017991515196, 218, 37, 'PPL', 'P'),
(81578, 'Hilltop', 34.9819412231445, 0.610550053083004, -81.9638900756836, -1.43053974956338, 218, 48, 'PPL', 'P'),
(87849, 'Hilltop', 35.9722213745117, 0.62783370224151, -86.5336074829102, -1.51029636420519, 218, 50, 'PPL', 'P'),
(94919, 'Hilltop', 30.3974990844727, 0.53053644339601, -98.9683303833008, -1.72732322039014, 218, 51, 'PPL', 'P'),
(109666, 'Hilltop', 37.9427795410156, 0.662226430349065, -81.1511077880859, -1.41635402254291, 218, 58, 'PPL', 'P'),
(116047, 'Hilltop', 42.4761085510254, 0.741347947649911, -92.2702789306641, -1.61042016907364, 218, 16, 'PPL', 'P'),
(120033, 'Hilltop', 40.0258293151855, 0.698582507391255, -89.8752822875977, -1.56861959207792, 218, 18, 'PPL', 'P'),
(131323, 'Hilltop', 44.6116714477539, 0.778620551581251, -85.6561126708984, -1.49498119056641, 218, 27, 'PPL', 'P'),
(135947, 'Hilltop', 45.0533294677734, 0.786328938198431, -93.2472229003906, -1.62747105795287, 218, 28, 'PPL', 'P'),
(155742, 'Hilltop', 41.1636085510254, 0.718440501217485, -80.7375030517578, -1.40913525809214, 218, 41, 'PPL', 'P'),
(162725, 'Hilltop', 40.4925003051758, 0.706727452690126, -75.3791732788086, -1.31561476114654, 218, 45, 'PPL', 'P'),
(178372, 'Hilltop', 35.2080612182617, 0.614496591502393, -114.024169921875, -1.9900971919902, 218, 5, 'PPL', 'P'),
(186852, 'Hilltop', 39.4516716003418, 0.688561564841505, -104.68083190918, -1.82702518054193, 218, 7, 'PPL', 'P'),
(199992, 'Hilltop', 40.4147186279297, 0.705369906324458, -116.799438476563, -2.03853476589657, 218, 39, 'PPL', 'P'),
(207656, 'Hilltop', 47.5547218322754, 0.829986470843236, -122.140830993652, -2.13175965196117, 218, 56, 'PPL', 'P'),
(13953, 'Hilltop Acres', 38.848331451416, 0.678031292733277, -75.4297180175781, -1.31649693325763, 218, 10, 'PPL', 'P'),
(81579, 'Hilltop Acres', 34.6836090087891, 0.605343173677736, -81.2061080932617, -1.41731395895783, 218, 48, 'PPL', 'P'),
(87850, 'Hilltop Acres', 35.7686080932617, 0.624279980082908, -85.095832824707, -1.4852024625178, 218, 50, 'PPL', 'P'),
(125078, 'Hilltop Acres', 41.7986106872559, 0.729523379251905, -70.9569396972656, -1.23843222485635, 218, 23, 'PPL', 'P'),
(162726, 'Hilltop Acres', 40.0330581665039, 0.698708674647897, -76.2683334350586, -1.33113353345065, 218, 45, 'PPL', 'P'),
(94920, 'Hilltop Acres Colonia', 27.943000793457, 0.487697366733213, -97.6470031738281, -1.70426171008865, 218, 51, 'PPL', 'P'),
(94922, 'Hilltop Colonia', 26.4039993286133, 0.460836723978674, -98.9219970703125, -1.72651455152514, 218, 51, 'PPL', 'P'),
(155743, 'Hilltop Cottage Area', 40.170280456543, 0.701103655416206, -81.1966705322266, -1.41714924244441, 218, 41, 'PPL', 'P'),
(70959, 'Hilltop Estates', 39.975830078125, 0.697709856081063, -74.2416687011719, -1.29576156101027, 218, 37, 'PPL', 'P'),
(94923, 'Hilltop Estates Colonia', 27.7360000610352, 0.484084522398412, -98.1289978027344, -1.71267410334, 218, 51, 'PPL', 'P'),
(94924, 'Hilltop Estates Number 2 Colonia', 27.7439994812012, 0.484224138618559, -98.1309967041016, -1.71270899075028, 218, 51, 'PPL', 'P'),
(94925, 'Hilltop Lakes', 31.0791702270508, 0.54243384924983, -96.20361328125, -1.67906980407316, 218, 51, 'PPL', 'P'),
(13954, 'Hilltop Manor', 39.7791709899902, 0.694277507489142, -75.4833297729492, -1.31743263490663, 218, 10, 'PPL', 'P'),
(143970, 'Hilltop Manor Extension Mobile Home Park', 44.3086090087891, 0.77333111418219, -71.751106262207, -1.25229304622383, 218, 36, 'PPL', 'P'),
(135949, 'Hilltop Manor Mobile Home Park', 45.2963905334473, 0.790571154077846, -96.4272232055664, -1.68297253349261, 218, 28, 'PPL', 'P'),
(116048, 'Hilltop Mobile Home Park', 41.639720916748, 0.726750229608805, -91.5269393920898, -1.59744644666526, 218, 16, 'PPL', 'P'),
(102841, 'Hilltop Plaza', 37.2088890075684, 0.649417624191193, -80.396110534668, -1.40317683462725, 218, 53, 'PPL', 'P'),
(72912, 'Hilltop Subdivision', 38.8261108398438, 0.677643469899534, -82.2016677856445, -1.43468975349005, 218, 41, 'PPL', 'P'),
(48170, 'Hilltop Woods', 39.4486083984375, 0.688508101882621, -77.4916687011719, -1.35248476170009, 218, 25, 'PPL', 'P'),
(30086, 'Hilltown', 38.8369407653809, 0.677832487757903, -85.6622161865234, -1.49508771701002, 218, 19, 'PPL', 'P'),
(102842, 'Hilltown', 36.730281829834, 0.641064353116051, -80.982780456543, -1.41341615638639, 218, 53, 'PPL', 'P'),
(145437, 'Hilltown', 40.9211082458496, 0.714208072455077, -74.5511093139648, -1.3011623185429, 218, 37, 'PPL', 'P'),
(162727, 'Hilltown', 41.7702789306641, 0.729028896816504, -75.1786117553711, -1.31211430220974, 218, 45, 'PPL', 'P'),
(155744, 'Hilltown (historical)', 41.0736083984375, 0.716869702227529, -81.3288879394531, -1.41945687152896, 218, 41, 'PPL', 'P'),
(87851, 'Hillvale', 36.1752815246582, 0.63137777044116, -84.095832824707, -1.46774916999786, 218, 50, 'PPL', 'P'),
(3153, 'Hillview', 33.5755615234375, 0.586004096789908, -86.8841705322266, -1.51641484365159, 218, 2, 'PPL', 'P'),
(27444, 'Hillview', 39.4505615234375, 0.688542190344575, -90.5411071777344, -1.58024042865254, 218, 18, 'PPL', 'P'),
(36435, 'Hillview', 37.2991714477539, 0.650993350029166, -86.2286071777344, -1.50497310466028, 218, 21, 'PPL', 'P'),
(48171, 'Hillview', 39.5583305358887, 0.69042311444347, -76.3061065673828, -1.3317927989785, 218, 25, 'PPL', 'P'),
(81580, 'Hillview', 33.607780456543, 0.586566423254078, -81.720832824707, -1.426297600263, 218, 48, 'PPL', 'P'),
(109668, 'Hillview', 39.4391708374023, 0.6883433853692, -80.1791687011719, -1.39939048534743, 218, 58, 'PPL', 'P'),
(135951, 'Hillview', 46.6802787780762, 0.814724560426265, -95.2574996948242, -1.66255700689218, 218, 28, 'PPL', 'P'),
(48172, 'Hillview Acres', 39.3144416809082, 0.686166450915142, -77.3291702270508, -1.34964862829721, 218, 25, 'PPL', 'P'),
(48173, 'Hillview Estates', 39.6824989318848, 0.692590261780522, -75.9277801513672, -1.32518975737176, 218, 25, 'PPL', 'P'),
(87853, 'Hillview Estates', 36.0094413757324, 0.628483313810407, -86.8472213745117, -1.51576995919362, 218, 50, 'PPL', 'P'),
(48174, 'Hillview Farms', 39.6361083984375, 0.691780594230111, -76.0577774047852, -1.32745863746245, 218, 25, 'PPL', 'P'),
(102843, 'Hillview Park', 37.2869415283203, 0.650779897667796, -80.0244369506836, -1.39668990684404, 218, 53, 'PPL', 'P'),
(48175, 'Hillville', 38.372501373291, 0.669726491189974, -76.602783203125, -1.33697078308594, 218, 25, 'PPL', 'P'),
(87855, 'Hillville', 35.4552803039551, 0.618811378521512, -89.1694412231445, -1.55630034150743, 218, 50, 'PPL', 'P'),
(162730, 'Hillville', 41.0305595397949, 0.716118357904991, -79.6002807617188, -1.38928698480389, 218, 45, 'PPL', 'P'),
(3156, 'Hillwood', 32.9252815246582, 0.574654569751344, -86.3613891601563, -1.50729058744087, 218, 2, 'PPL', 'P'),
(48176, 'Hillwood', 38.5777816772461, 0.673309308383485, -76.9902801513672, -1.3437338806742, 218, 25, 'PPL', 'P'),
(81582, 'Hillwood', 34.8486099243164, 0.608222982922493, -82.6469421386719, -1.44246125702507, 218, 48, 'PPL', 'P'),
(87856, 'Hillwood', 36.1227798461914, 0.630461443289091, -85.4966735839844, -1.49219845354339, 218, 50, 'PPL', 'P'),
(102844, 'Hillwood', 38.8763885498047, 0.678520981478715, -77.1677780151367, -1.34683180281223, 218, 53, 'PPL', 'P'),
(87859, 'Hillwood Acres', 35.8736114501953, 0.626112634387046, -86.7263870239258, -1.51366100192639, 218, 50, 'PPL', 'P'),
(87861, 'Hillwood Estates', 35.9486083984375, 0.62742157806282, -86.3791732788086, -1.50760097886592, 218, 50, 'PPL', 'P'),
(102845, 'Hillwood Park Mobile Home Park', 38.7961082458496, 0.677119825850197, -77.6227798461914, -1.35477308286674, 218, 53, 'PPL', 'P'),
(41360, 'Hilly', 32.6483306884766, 0.569820865793823, -92.6783294677734, -1.61754199446073, 218, 22, 'PPL', 'P'),
(102849, 'Hilly Farms', 37.6963882446289, 0.65792609097886, -77.3222198486328, -1.34952732130955, 218, 53, 'PPL', 'P'),
(207657, 'Hillyard', 47.7008285522461, 0.832536514166014, -117.365280151367, -2.04841056616691, 218, 56, 'PPL', 'P'),
(162731, 'Hillymeade', 40.3041687011719, 0.703440446114696, -76.7399978637695, -1.33936563069619, 218, 45, 'PPL', 'P'),
(182156, 'Hilmar', 37.4086112976074, 0.652903435741998, -120.849166870117, -2.1092158601756, 218, 6, 'PPL', 'P'),
(9512, 'Hilo', 33.3616714477539, 0.582271010731889, -92.2724990844727, -1.6104589180675, 218, 4, 'PPL', 'P'),
(211469, 'Hilo', 19.7297191619873, 0.344348559870495, -155.089996337891, -2.70683107300214, 218, 15, 'PPL', 'P'),
(55314, 'Hilo (historical)', 36.813060760498, 0.642509118007419, -92.5322189331055, -1.61499188455893, 218, 29, 'PPL', 'P'),
(16450, 'Hilolo', 27.4488906860352, 0.479073518491319, -80.7713928222656, -1.40972674617025, 218, 12, 'PPL', 'P'),
(65644, 'Hilorn (historical)', 36.1402816772461, 0.630766907866123, -81.179443359375, -1.41684857155734, 218, 33, 'PPL', 'P'),
(94926, 'Hilshire Village', 29.7905597686768, 0.51994335397557, -95.4888916015625, -1.66659555752723, 218, 51, 'PPL', 'P'),
(193638, 'Hilt', 41.9949989318848, 0.732951000732891, -122.622222900391, -2.14016152572621, 218, 6, 'PPL', 'P'),
(9513, 'Hilton', 35.6458282470703, 0.622137067511776, -90.0902786254883, -1.57237198605384, 218, 4, 'PPL', 'P'),
(21962, 'Hilton', 31.2880592346191, 0.546079650203121, -85.0652770996094, -1.48466916450952, 218, 13, 'PPL', 'P'),
(32772, 'Hilton', 38.4422187805176, 0.670943289492031, -97.6752777099609, -1.70475519383865, 218, 20, 'PPL', 'P'),
(36436, 'Hilton', 37.271110534668, 0.6505035947047, -83.1763916015625, -1.45170189337543, 218, 21, 'PPL', 'P'),
(76094, 'Hilton', 36.0097198486328, 0.628488174079397, -96.0472183227539, -1.67634019711388, 218, 42, 'PPL', 'P'),
(81583, 'Hilton', 34.1369400024414, 0.595801999598364, -81.3063888549805, -1.41906418842623, 218, 48, 'PPL', 'P'),
(94927, 'Hilton', 33.5705604553223, 0.58591681168518, -96.6205596923828, -1.6863468917518, 218, 51, 'PPL', 'P'),
(145438, 'Hilton', 40.4119415283203, 0.705321436792619, -74.0224990844727, -1.29193632957854, 218, 37, 'PPL', 'P'),
(149638, 'Hilton', 43.2880592346191, 0.755519160442441, -77.7936096191406, -1.35775462486514, 218, 40, 'PPL', 'P'),
(182157, 'Hilton', 38.5047187805176, 0.672034120274528, -122.939170837402, -2.14569331078447, 218, 6, 'PPL', 'P'),
(186854, 'Hilton', 38.0702781677246, 0.664451701176908, -103.060562133789, -1.79874613819081, 218, 7, 'PPL', 'P'),
(48177, 'Hilton (historical)', 39.2555618286133, 0.685138803629508, -76.8202819824219, -1.34076685290374, 218, 25, 'PPL', 'P'),
(60272, 'Hilton (historical)', 32.836109161377, 0.573098218410302, -90.3333282470703, -1.57661400219617, 218, 30, 'PPL', 'P'),
(72913, 'Hilton (historical)', 38.7311096191406, 0.675985385804851, -82.2855606079102, -1.43615395945738, 218, 41, 'PPL', 'P'),
(87862, 'Hilton (historical)', 36.4672203063965, 0.636473063396754, -82.3930587768555, -1.43803015644534, 218, 50, 'PPL', 'P'),
(199402, 'Hilton (historical)', 42.4294395446777, 0.74053341983051, -102.531112670898, -1.78950550184045, 218, 35, 'PPL', 'P'),
(174528, 'Hilton Estates', 43.2230606079102, 0.754384720397094, -89.2236099243164, -1.55724576369441, 218, 57, 'PPL', 'P'),
(81584, 'Hilton Head Island', 32.2161102294922, 0.562277195690065, -80.7527770996094, -1.40940184051726, 218, 48, 'PPL', 'P'),
(81585, 'Hilton Head Plantation', 32.2555618286133, 0.562965755989905, -80.7136077880859, -1.40871820706544, 218, 48, 'PPL', 'P'),
(21963, 'Hilton Heights', 32.4888916015625, 0.567038128770799, -84.9494400024414, -1.48264742576798, 218, 13, 'PPL', 'P'),
(48178, 'Hilton Place', 39.2272186279297, 0.684644121457025, -76.6991729736328, -1.33865310194654, 218, 25, 'PPL', 'P'),
(204348, 'Hilton Villa', 40.639720916748, 0.709296937088862, -111.858612060547, -1.95230107716758, 218, 52, 'PPL', 'P'),
(102847, 'Hilton Village', 37.0847206115723, 0.647250476854141, -80.7866668701172, -1.40999332859537, 218, 53, 'PPL', 'P'),
(109669, 'Hilton Village', 38.0149993896484, 0.663486904493, -80.9016723632813, -1.41200055310896, 218, 58, 'PPL', 'P'),
(21964, 'Hiltonia', 32.8833312988281, 0.573922400188654, -81.658332824707, -1.4252067694805, 218, 13, 'PPL', 'P'),
(102848, 'Hiltons', 36.6544418334961, 0.639740695475254, -82.4672164916992, -1.43932445273512, 218, 53, 'PPL', 'P'),
(149636, 'Hiltonville', 42.3683280944824, 0.739466823813933, -77.8433303833008, -1.35862241590634, 218, 40, 'PPL', 'P'),
(21965, 'Hilyer', 32.9813919067383, 0.575633880663194, -84.9930572509766, -1.48340869036558, 218, 13, 'PPL', 'P'),
(36437, 'Hima', 37.1205596923828, 0.647875986815174, -83.7783279418945, -1.46220766440162, 218, 21, 'PPL', 'P'),
(41361, 'Himalaya', 29.8491706848145, 0.520966307439783, -90.9972229003906, -1.588201149783, 218, 22, 'PPL', 'P'),
(87863, 'Himesville', 35.4311103820801, 0.618389533804844, -86.434440612793, -1.50856557581274, 218, 50, 'PPL', 'P'),
(55316, 'Himmel', 36.9761085510254, 0.645354838790223, -89.7527770996094, -1.56648147319675, 218, 29, 'PPL', 'P'),
(55317, 'Himont (historical)', 37.3097190856934, 0.651177441039517, -91.2447204589844, -1.59252079707111, 218, 29, 'PPL', 'P'),
(120035, 'Himrod', 40.0341682434082, 0.698728049144828, -87.6005630493164, -1.52891825181146, 218, 18, 'PPL', 'P'),
(149637, 'Himrod', 42.5897216796875, 0.743330870818557, -76.9552764892578, -1.34312295152013, 218, 40, 'PPL', 'P'),
(36438, 'Himyar', 36.8327789306641, 0.642853264999284, -83.7997207641602, -1.46258103958645, 218, 21, 'PPL', 'P'),
(55318, 'Hinch', 38.0627784729004, 0.664320806809331, -91.1552810668945, -1.59095978519816, 218, 29, 'PPL', 'P'),
(109671, 'Hinch', 37.6108283996582, 0.656432789976625, -82.0147171020508, -1.43142684852249, 218, 58, 'PPL', 'P'),
(60273, 'Hinchcliff', 34.3097190856934, 0.598817563479688, -90.2736129760742, -1.57557177410357, 218, 30, 'PPL', 'P'),
(131324, 'Hinchman', 41.9722213745117, 0.73255345736117, -86.4272232055664, -1.50843960829318, 218, 27, 'PPL', 'P'),
(102850, 'Hinckle', 39.4199981689453, 0.688008759178232, -78.295280456543, -1.36651043273904, 218, 53, 'PPL', 'P'),
(94928, 'Hinckley', 33.7379913330078, 0.588839031770297, -95.5470962524414, -1.66761142032504, 218, 51, 'PPL', 'P'),
(120036, 'Hinckley', 41.7688903808594, 0.729004662050584, -88.6408309936523, -1.54707435254307, 218, 18, 'PPL', 'P'),
(127755, 'Hinckley', 44.6855583190918, 0.779910120760095, -69.633056640625, -1.21532610660661, 218, 26, 'PPL', 'P'),
(135952, 'Hinckley', 46.0113906860352, 0.803050260892766, -92.9441680908203, -1.62218175371187, 218, 28, 'PPL', 'P'),
(149639, 'Hinckley', 43.3122215270996, 0.755940872001055, -75.1222229003906, -1.3111301310289, 218, 40, 'PPL', 'P'),
(155745, 'Hinckley', 41.2383308410645, 0.719744651203297, -81.7452774047852, -1.42672423866963, 218, 41, 'PPL', 'P'),
(192622, 'Hinckley', 39.3250007629395, 0.686350741662576, -112.670280456543, -1.96646736311209, 218, 52, 'PPL', 'P'),
(195098, 'Hinckley', 43.8650016784668, 0.765588705682085, -111.857498168945, -1.95228163609162, 218, 17, 'PPL', 'P'),
(182158, 'Hinda', 33.9527816772461, 0.592587830478747, -117.057220458984, -2.04303391024215, 218, 6, 'PPL', 'P'),
(36439, 'Hinda Heights', 38.0063896179199, 0.663336635628492, -84.5027770996094, -1.47485168746705, 218, 21, 'PPL', 'P'),
(94929, 'Hindes', 28.7166690826416, 0.501200425697756, -98.7900009155273, -1.72421078402416, 218, 51, 'PPL', 'P'),
(36440, 'Hindman', 37.3358306884766, 0.651633174481057, -82.9805603027344, -1.44828399243242, 218, 21, 'PPL', 'P'),
(191608, 'Hindman', 32.8861083984375, 0.573970869720494, -101.877777099609, -1.77810264500106, 218, 51, 'PPL', 'P'),
(30087, 'Hindostan', 38.6655616760254, 0.67484135837958, -86.6044387817383, -1.5115326035832, 218, 19, 'PPL', 'P'),
(30088, 'Hindostan Falls', 38.624439239502, 0.674123636465804, -86.850830078125, -1.51583294295341, 218, 19, 'PPL', 'P'),
(94930, 'Hinds', 34.1922187805176, 0.596766796282272, -99.2336120605469, -1.7319532591033, 218, 51, 'PPL', 'P'),
(87864, 'Hinds Creek (historical)', 36.1380615234375, 0.630728158872262, -84.0899963378906, -1.46764730408617, 218, 50, 'PPL', 'P'),
(87865, 'Hinds Creek Valley', 36.204719543457, 0.631891560794463, -83.9316711425781, -1.4648840081391, 218, 50, 'PPL', 'P'),
(27446, 'Hindsboro', 39.685001373291, 0.692633937622399, -88.1336135864258, -1.53822173876354, 218, 18, 'PPL', 'P'),
(9516, 'Hindsville', 36.1441688537598, 0.630834751894893, -93.8619384765625, -1.63819986872037, 218, 4, 'PPL', 'P'),
(30089, 'Hindustan', 39.3080596923828, 0.686055064202549, -86.4833297729492, -1.509418852626, 218, 19, 'PPL', 'P'),
(55319, 'Hine', 38.6830596923828, 0.675146756377585, -90.5233306884766, -1.57993017038554, 218, 29, 'PPL', 'P'),
(36441, 'Hiner', 37.3144416809082, 0.651259865875255, -83.1669387817383, -1.45153691054589, 218, 21, 'PPL', 'P'),
(3160, 'Hines', 34.9597206115723, 0.610162230249262, -87.6436080932617, -1.52966952955497, 218, 2, 'PPL', 'P'),
(16451, 'Hines', 29.7391700744629, 0.519046434609945, -83.2366714477539, -1.45275397516406, 218, 12, 'PPL', 'P'),
(109670, 'Hines', 37.9833297729492, 0.662934165408754, -80.7183303833008, -1.40880063190118, 218, 58, 'PPL', 'P'),
(120037, 'Hines', 41.8536109924316, 0.730483315666824, -87.8394393920898, -1.53308743049797, 218, 18, 'PPL', 'P'),
(135955, 'Hines', 47.6861114501953, 0.832279652278876, -94.6324996948242, -1.65164869906721, 218, 28, 'PPL', 'P'),
(174529, 'Hines', 46.5430603027344, 0.812329646236984, -91.9080581665039, -1.60409822411996, 218, 57, 'PPL', 'P'),
(200980, 'Hines', 43.5641708374023, 0.760338217013966, -119.080001831055, -2.07833810523278, 218, 43, 'PPL', 'P'),
(207658, 'Hines', 46.5783309936523, 0.812945235922955, -124.051666259766, -2.16511001881807, 218, 56, 'PPL', 'P'),
(155747, 'Hines (historical)', 40.8722190856934, 0.713354795641815, -82.7200012207031, -1.443736378555, 218, 41, 'PPL', 'P'),
(65645, 'Hines Crossroad', 35.5522193908691, 0.620503284762039, -77.4850006103516, -1.35236838156045, 218, 33, 'PPL', 'P'),
(65646, 'Hines Crossroads', 35.2008285522461, 0.614370357666723, -77.8891677856445, -1.3594224294978, 218, 33, 'PPL', 'P'),
(48179, 'Hines Estates', 39.4013900756836, 0.687683986683296, -76.4925003051758, -1.33504598340808, 218, 25, 'PPL', 'P'),
(65647, 'Hines Junction', 35.2688903808594, 0.615558260670953, -77.6197204589844, -1.35471968648688, 218, 33, 'PPL', 'P'),
(55320, 'Hines Landing', 37.5577812194824, 0.655506942023659, -89.5263900756836, -1.56253027424545, 218, 29, 'PPL', 'P'),
(48180, 'Hines Woods', 39.3811111450195, 0.687330052574425, -77.3566665649414, -1.35012852992564, 218, 25, 'PPL', 'P'),
(172122, 'Hinesburg', 44.3291702270508, 0.773689975139078, -73.1111068725586, -1.2760295347036, 218, 55, 'PPL', 'P'),
(36442, 'Hinesdale', 37.3175010681152, 0.651313262255112, -85.8236083984375, -1.49790454249499, 218, 21, 'PPL', 'P'),
(41362, 'Hineston', 31.1433296203613, 0.543553641909181, -92.7586135864258, -1.61894321666828, 218, 22, 'PPL', 'P'),
(21967, 'Hinesville', 31.8466701507568, 0.555829249927306, -81.5961074829102, -1.42412073238797, 218, 13, 'PPL', 'P'),
(102851, 'Hinesville', 36.7016716003418, 0.640565010411661, -79.5733337402344, -1.38881667055538, 218, 53, 'PPL', 'P'),
(125079, 'Hingham', 42.2416687011719, 0.737256200372086, -70.8902816772461, -1.23726882293415, 218, 23, 'PPL', 'P'),
(174530, 'Hingham', 43.6388893127441, 0.761642300420751, -87.9141693115234, -1.53439171364184, 218, 57, 'PPL', 'P'),
(196717, 'Hingham', 48.5550003051758, 0.847444623632169, -110.42138671875, -1.92721676286013, 218, 31, 'PPL', 'P'),
(125080, 'Hingham Center', 42.2333297729492, 0.737110658618513, -70.8805618286133, -1.23709917957271, 218, 23, 'PPL', 'P'),
(9517, 'Hinkle', 35.4277801513672, 0.618331410314052, -93.5833282470703, -1.63333720288599, 218, 4, 'PPL', 'P'),
(36443, 'Hinkle', 36.9124984741211, 0.644244633510796, -83.8188934326172, -1.46291566577742, 218, 21, 'PPL', 'P'),
(41363, 'Hinkle', 32.5319404602051, 0.567789473093338, -93.7180633544922, -1.63568877412853, 218, 22, 'PPL', 'P'),
(87866, 'Hinkle', 35.4077796936035, 0.61798233647417, -88.3002777099609, -1.54113057646418, 218, 50, 'PPL', 'P'),
(200981, 'Hinkle', 45.7966690063477, 0.799302660606807, -119.311111450195, -2.08237172901981, 218, 43, 'PPL', 'P'),
(87867, 'Hinkledale', 36.0933303833008, 0.629947453198706, -88.5988922119141, -1.54634238271746, 218, 50, 'PPL', 'P'),
(21968, 'Hinkles', 34.9083290100098, 0.609265277594123, -85.3944396972656, -1.49041413561303, 218, 13, 'PPL', 'P'),
(94931, 'Hinkles Ferry', 28.949390411377, 0.505262179123804, -95.5572128295898, -1.66778798790531, 218, 51, 'PPL', 'P'),
(162733, 'Hinkletown', 40.4044418334961, 0.705190542425041, -75.1236114501953, -1.31115436579482, 218, 45, 'PPL', 'P'),
(36444, 'Hinkleville', 37.0436096191406, 0.646532954677447, -88.9336090087891, -1.55218429288466, 218, 21, 'PPL', 'P'),
(109672, 'Hinkleville', 38.9266700744629, 0.679398559636924, -80.2624969482422, -1.40084483761873, 218, 58, 'PPL', 'P'),
(182159, 'Hinkley', 34.9347190856934, 0.609725871304652, -117.198333740234, -2.04549680161825, 218, 6, 'PPL', 'P'),
(149640, 'Hinkleyville', 43.2102813720703, 0.7541616806558, -77.8499984741211, -1.35873879604597, 218, 40, 'PPL', 'P'),
(149646, 'Hinmans Corners', 42.1605606079102, 0.735840597094654, -75.8974990844727, -1.32466125305343, 218, 40, 'PPL', 'P'),
(149641, 'Hinmansville', 43.2477798461914, 0.754816152493687, -76.352783203125, -1.33260745995595, 218, 40, 'PPL', 'P'),
(65648, 'Hinnes Crossroads', 36.4033317565918, 0.635357997848338, -77.7997207641602, -1.35786128446679, 218, 33, 'PPL', 'P'),
(102852, 'Hinnom', 38.110279083252, 0.665149848856673, -76.7372207641602, -1.33931716116435, 218, 53, 'PPL', 'P'),
(149642, 'Hinsburg', 43.2538909912109, 0.754922812095345, -78.1061096191406, -1.36320877877762, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(120039, 'Hinsdale', 41.8008308410645, 0.729562128245765, -87.9369430541992, -1.53478919043453, 218, 18, 'PPL', 'P'),
(125082, 'Hinsdale', 42.4386100769043, 0.740693475812024, -73.1258316040039, -1.27628652974879, 218, 23, 'PPL', 'P'),
(135957, 'Hinsdale', 47.6011085510254, 0.83079607181462, -92.1477813720703, -1.60828218335053, 218, 28, 'PPL', 'P'),
(143971, 'Hinsdale', 42.7861099243164, 0.746758492299543, -72.4869384765625, -1.26513574110658, 218, 36, 'PPL', 'P'),
(149644, 'Hinsdale', 43.1044387817383, 0.752314378965666, -76.1380615234375, -1.32885985966999, 218, 40, 'PPL', 'P'),
(182160, 'Hinsdale', 39.0152816772461, 0.68094512386096, -121.777778625488, -2.12542319277955, 218, 6, 'PPL', 'P'),
(196718, 'Hinsdale', 48.3941688537598, 0.844637585264198, -107.084167480469, -1.86897129929122, 218, 31, 'PPL', 'P'),
(16452, 'Hinson', 30.6472206115723, 0.534894906257006, -84.4166717529297, -1.47334886566392, 218, 12, 'PPL', 'P'),
(65649, 'Hinson', 35.7675018310547, 0.624260672165005, -76.7972183227539, -1.34036431610497, 218, 33, 'PPL', 'P'),
(21969, 'Hinson Crossing', 31.173059463501, 0.544072525558069, -82.6661071777344, -1.44279575005798, 218, 13, 'PPL', 'P'),
(65650, 'Hinson Crossroads', 34.3058280944824, 0.598749652871891, -78.9791717529297, -1.37844658758672, 218, 33, 'PPL', 'P'),
(87869, 'Hinson Springs', 35.6277809143066, 0.621822082133847, -88.4244384765625, -1.54329759064317, 218, 50, 'PPL', 'P'),
(16453, 'Hinsons Crossroads', 30.6686096191406, 0.535268214862808, -85.8424987792969, -1.49823424183794, 218, 12, 'PPL', 'P'),
(21970, 'Hinsonton', 31.1794395446777, 0.544183878981148, -84.0286102294922, -1.46657591437963, 218, 13, 'PPL', 'P'),
(162736, 'Hinterleiter', 40.5138893127441, 0.707100761295928, -75.732780456543, -1.32178637065669, 218, 45, 'PPL', 'P'),
(3161, 'Hinton', 32.0919418334961, 0.560110048353013, -88.4422225952148, -1.54360798206822, 218, 2, 'PPL', 'P'),
(21971, 'Hinton', 34.4808311462402, 0.601804032326102, -84.5827789306641, -1.47624798282658, 218, 13, 'PPL', 'P'),
(36445, 'Hinton', 38.457218170166, 0.671205078227186, -84.5294418334961, -1.47531707486754, 218, 21, 'PPL', 'P'),
(55321, 'Hinton', 39.0536117553711, 0.681614109926788, -92.3402786254883, -1.61164189422371, 218, 29, 'PPL', 'P'),
(76095, 'Hinton', 35.4713897705078, 0.619092541753597, -98.3552780151367, -1.71662343807853, 218, 42, 'PPL', 'P'),
(102853, 'Hinton', 38.4658317565918, 0.671355413670721, -78.9725036621094, -1.37833020744709, 218, 53, 'PPL', 'P'),
(109673, 'Hinton', 37.6738891601563, 0.657533407876128, -80.8894424438477, -1.41178710074759, 218, 58, 'PPL', 'P'),
(116050, 'Hinton', 42.6277809143066, 0.74399512977345, -96.291389465332, -1.68060178749023, 218, 16, 'PPL', 'P'),
(155748, 'Hinton', 40.6113891601563, 0.708802454653461, -84.708610534668, -1.47844415861951, 218, 41, 'PPL', 'P'),
(182161, 'Hinton', 39.3752784729004, 0.687228253241757, -120.072776794434, -2.09566529707511, 218, 6, 'PPL', 'P'),
(87868, 'Hinton Crossing', 36.3666687011719, 0.634718106817419, -87.2474975585938, -1.52275609652318, 218, 50, 'PPL', 'P'),
(36446, 'Hinton Hills', 37.6233291625977, 0.65665096944893, -86.4611129760742, -1.50903109637129, 218, 21, 'PPL', 'P'),
(65652, 'Hintonsville (historical)', 36.3688888549805, 0.63475685581128, -76.2874984741211, -1.33146802648356, 218, 33, 'PPL', 'P'),
(60275, 'Hintonville', 31.2608299255371, 0.545604409106596, -88.9219436645508, -1.55198069421932, 218, 30, 'PPL', 'P'),
(174531, 'Hintz', 44.915828704834, 0.783929097161133, -88.4100036621094, -1.54304565560405, 218, 57, 'PPL', 'P'),
(207659, 'Hintzville', 47.5641708374023, 0.830151387093739, -122.890281677246, -2.1448400339712, 218, 56, 'PPL', 'P'),
(60276, 'Hinze', 33.0327796936035, 0.576530766739305, -89.2702789306641, -1.55806029151381, 218, 30, 'PPL', 'P'),
(109674, 'Hiorra', 39.392219543457, 0.687523930701783, -79.8188934326172, -1.39310249569765, 218, 58, 'PPL', 'P'),
(81586, 'Hiotts', 32.9786109924316, 0.575585344552327, -80.5447235107422, -1.40577062037094, 218, 48, 'PPL', 'P'),
(193639, 'Hiouchi', 41.792781829834, 0.729421646498264, -124.070831298828, -2.16544451185098, 218, 6, 'PPL', 'P'),
(102854, 'Hipes', 37.6538887023926, 0.657184334036246, -79.916389465332, -1.39480412247615, 218, 53, 'PPL', 'P'),
(41364, 'Hipple', 30.2277793884277, 0.527574275894542, -93.1469421386719, -1.62572082848447, 218, 22, 'PPL', 'P'),
(36447, 'Hippo', 37.5325012207031, 0.65506572281006, -82.8688888549805, -1.44633495798864, 218, 21, 'PPL', 'P'),
(48182, 'Hipsleys Mill', 39.2763900756836, 0.685502325118304, -77.1052780151367, -1.34574097202973, 218, 25, 'PPL', 'P'),
(9518, 'Hiram', 35.4691696166992, 0.619053792759736, -91.8677825927734, -1.60339528275023, 218, 4, 'PPL', 'P'),
(21972, 'Hiram', 33.875560760498, 0.591240071230085, -84.7622222900391, -1.47937986026851, 218, 13, 'PPL', 'P'),
(36448, 'Hiram', 36.9663887023926, 0.645185195428785, -83.0472183227539, -1.44944739435462, 218, 21, 'PPL', 'P'),
(55322, 'Hiram', 37.1788902282715, 0.648894046720884, -90.3147201538086, -1.57628922970124, 218, 29, 'PPL', 'P'),
(94932, 'Hiram', 32.6433296203613, 0.569733580689096, -96.1080627441406, -1.67740213259855, 218, 51, 'PPL', 'P'),
(109675, 'Hiram', 39.2930603027344, 0.685793275467395, -79.932502746582, -1.39508535228727, 218, 58, 'PPL', 'P'),
(112435, 'Hiram', 34.0633316040039, 0.594517290688509, -90.2811126708984, -1.57570266847115, 218, 30, 'PPL', 'P'),
(127756, 'Hiram', 43.8786087036133, 0.765826193072292, -70.8038864135742, -1.23576094112495, 218, 26, 'PPL', 'P'),
(155749, 'Hiram', 41.3125, 0.721039147230157, -81.1438903808594, -1.41622805502335, 218, 41, 'PPL', 'P'),
(162734, 'Hiram', 40.0533294677734, 0.699062475598714, -78.085563659668, -1.36285018413684, 218, 45, 'PPL', 'P'),
(155750, 'Hiram Rapids', 41.3400001525879, 0.721519115437617, -81.166389465332, -1.41662073812608, 218, 41, 'PPL', 'P'),
(72914, 'Hiramsburg', 39.8083305358887, 0.694786437573456, -81.595832824707, -1.424115938698, 218, 41, 'PPL', 'P'),
(76096, 'Hird', 34.8105583190918, 0.607558857125655, -96.6516723632813, -1.68688991029807, 218, 42, 'PPL', 'P'),
(199404, 'Hire', 42.1744384765625, 0.736082811595797, -101.417778015137, -1.77007414642086, 218, 35, 'PPL', 'P'),
(3162, 'Hirsch', 32.1716690063477, 0.561501550022579, -85.121940612793, -1.48565812938032, 218, 2, 'PPL', 'P'),
(196719, 'Hirsch', 45.8177795410156, 0.799671108943619, -108.413063049316, -1.89216490238277, 218, 31, 'PPL', 'P'),
(182162, 'Hirschdale', 39.3686103820801, 0.68711187310212, -120.074996948242, -2.09570404606897, 218, 6, 'PPL', 'P'),
(198434, 'Hirschville', 47.0680618286133, 0.821492651441565, -102.563331604004, -1.79006782830463, 218, 34, 'PPL', 'P'),
(209510, 'Hirsig', 41.1913909912109, 0.718925396272961, -105.301109313965, -1.83785106353115, 218, 59, 'PPL', 'P'),
(30090, 'Hirt Corner', 39.4736099243164, 0.688944460827231, -87.0147171020508, -1.51869331112221, 218, 19, 'PPL', 'P'),
(202221, 'Hisega', 44.0533294677734, 0.768875645678488, -103.401390075684, -1.80469470795967, 218, 49, 'PPL', 'P'),
(36449, 'Hisel', 37.5555610656738, 0.655468193029799, -84.0838928222656, -1.46754077764256, 218, 21, 'PPL', 'P'),
(480, 'Hiser', 39.814998626709, 0.694902817713092, -85.0777816772461, -1.48488741056085, 218, 19, 'PPL', 'P'),
(109676, 'Hiser (historical)', 38.9625015258789, 0.680023936439902, -79.1155624389648, -1.38082705412709, 218, 58, 'PPL', 'P'),
(36450, 'Hiseville', 37.100830078125, 0.647531640086226, -85.8125, -1.49771066436763, 218, 21, 'PPL', 'P'),
(94933, 'Hishway', 33.8666687011719, 0.591084875517561, -96.9236068725586, -1.69163606283475, 218, 51, 'PPL', 'P'),
(76097, 'Hisle', 36.4766693115234, 0.636637979647257, -95.4761123657227, -1.66637251778593, 218, 42, 'PPL', 'P'),
(202222, 'Hisle', 43.4058303833008, 0.757574654750791, -101.751388549805, -1.77589674867015, 218, 49, 'PPL', 'P'),
(36451, 'Hislope', 37.021671295166, 0.64615005869172, -84.7333297729492, -1.4788755907161, 218, 21, 'PPL', 'P'),
(3163, 'Hissop', 32.892219543457, 0.574077529322151, -86.1533279418945, -1.50365923413649, 218, 2, 'PPL', 'P'),
(87872, 'Historic Hills', 36.4952812194824, 0.63696281872122, -82.5236129760742, -1.44030875707401, 218, 50, 'PPL', 'P'),
(16454, 'Hitchapukasse (historical)', 28.1666698455811, 0.491601128127592, -82.033332824707, -1.43175175417548, 218, 12, 'PPL', 'P'),
(30091, 'Hitchcock', 38.6380615234375, 0.674361390172121, -86.1697235107422, -1.50394539079562, 218, 19, 'PPL', 'P'),
(72915, 'Hitchcock', 38.8833312988281, 0.678642155308314, -82.5758285522461, -1.44122009079904, 218, 41, 'PPL', 'P'),
(76098, 'Hitchcock', 35.9688911437988, 0.627775578750719, -98.3480606079102, -1.71649747055897, 218, 42, 'PPL', 'P'),
(94934, 'Hitchcock', 29.3480606079102, 0.512220286682881, -95.0158309936523, -1.65833909235771, 218, 51, 'PPL', 'P'),
(102855, 'Hitchcock', 37.1416702270508, 0.648244435151986, -77.2291717529297, -1.34790332567682, 218, 53, 'PPL', 'P'),
(170531, 'Hitchcock', 44.6297187805176, 0.77893553695918, -98.4091720581055, -1.71756406657554, 218, 49, 'PPL', 'P'),
(87870, 'Hitchcox', 35.5686111450195, 0.620789374842141, -85.4141693115234, -1.49075848234198, 218, 50, 'PPL', 'P'),
(13966, 'Hitchens Crossroads', 38.5769386291504, 0.673294594418462, -75.4622192382813, -1.31706418656982, 218, 10, 'PPL', 'P'),
(149647, 'Hitching Corner', 42.8886108398438, 0.748547470761804, -75.165283203125, -1.31188167508852, 218, 40, 'PPL', 'P'),
(36453, 'Hitchins', 38.2808303833008, 0.668126530586082, -82.920280456543, -1.44723191064378, 218, 21, 'PPL', 'P'),
(76099, 'Hitchita', 35.519718170166, 0.619936031449852, -95.751106262207, -1.67117206670247, 218, 42, 'PPL', 'P'),
(191609, 'Hitchland', 36.4988899230957, 0.637025802481, -101.318061828613, -1.76833377064849, 218, 51, 'PPL', 'P'),
(36452, 'Hite', 37.5569381713867, 0.655492228058637, -82.7536087036133, -1.44432293978509, 218, 21, 'PPL', 'P'),
(41365, 'Hite', 30.8225002288818, 0.537954112690694, -93.3236083984375, -1.62880423639457, 218, 22, 'PPL', 'P'),
(207661, 'Hite', 47.6641693115234, 0.831896689714123, -117.777778625488, -2.05561002269977, 218, 56, 'PPL', 'P'),
(87871, 'Hite (historical)', 36.1527786254883, 0.6309850207594, -86.6833267211914, -1.51290945786677, 218, 50, 'PPL', 'P'),
(192623, 'Hite (historical)', 37.8074989318848, 0.659865338305629, -110.438888549805, -1.92752222743716, 218, 52, 'PPL', 'P'),
(207660, 'Hite Center', 47.6019401550293, 0.830810586042561, -122.862777709961, -2.14435999918472, 218, 56, 'PPL', 'P'),
(182163, 'Hite Cove', 37.6408309936523, 0.656956434025962, -119.84806060791, -2.09174325973775, 218, 6, 'PPL', 'P'),
(116051, 'Hiteman', 41.0588912963867, 0.716612840340391, -92.8919372558594, -1.62127015367073, 218, 16, 'PPL', 'P'),
(162735, 'Hites', 40.5825004577637, 0.708298251680082, -79.7799987792969, -1.39242365593579, 218, 45, 'PPL', 'P'),
(36454, 'Hites Falls', 37.5422210693359, 0.655235366171498, -86.5969390869141, -1.51140170921562, 218, 21, 'PPL', 'P'),
(102856, 'Hitesburg', 36.6100006103516, 0.638965049807768, -78.7261123657227, -1.37402986807688, 218, 53, 'PPL', 'P'),
(36455, 'Hitesville', 37.752498626709, 0.658905401890709, -87.8277816772461, -1.53288396499069, 218, 21, 'PPL', 'P'),
(109677, 'Hitop', 38.2841682434082, 0.668184787234927, -81.2938919067383, -1.41884607553295, 218, 58, 'PPL', 'P'),
(32773, 'Hitschmann', 38.6241683959961, 0.674118909354869, -98.5811080932617, -1.72056491649185, 218, 20, 'PPL', 'P'),
(177737, 'Hitson', 32.8944396972656, 0.574116278316012, -100.211387634277, -1.74901866221047, 218, 51, 'PPL', 'P'),
(120042, 'Hitt', 41.3166694641113, 0.721111918106944, -88.8561096191406, -1.55083167336701, 218, 18, 'PPL', 'P'),
(139216, 'Hitt', 40.5636100769043, 0.70796855233713, -92.2555618286133, -1.6101633071865, 218, 29, 'PPL', 'P'),
(191610, 'Hitt', 36.1155586242676, 0.630335409190503, -102.438606262207, -1.78789096042959, 218, 51, 'PPL', 'P'),
(135959, 'Hitterdal', 46.9775009155273, 0.819912065334603, -96.2588882446289, -1.68003453417804, 218, 28, 'PPL', 'P'),
(36456, 'Hittville', 38.5830612182617, 0.673401453757202, -84.0638885498047, -1.46719163722365, 218, 21, 'PPL', 'P'),
(135961, 'Hiview Park', 45.9055595397949, 0.801203158939714, -95.3438873291016, -1.66406475554332, 218, 28, 'PPL', 'P'),
(142045, 'HiVue Mobile Home Park', 41.0166702270508, 0.715875943666766, -95.9069366455078, -1.67389181996572, 218, 35, 'PPL', 'P'),
(186856, 'Hiwan Hills', 39.6402816772461, 0.691853431685925, -105.329437255859, -1.83834547938753, 218, 7, 'PPL', 'P'),
(60278, 'Hiwannee', 31.8099994659424, 0.555189225738332, -88.690559387207, -1.54794227674233, 218, 30, 'PPL', 'P'),
(9519, 'Hiwasse', 36.4316711425781, 0.635852613441793, -94.333610534668, -1.64643209912396, 218, 4, 'PPL', 'P'),
(65656, 'Hiwassee', 35.1641693115234, 0.613730533214832, -84.2541732788086, -1.47051273226104, 218, 33, 'PPL', 'P'),
(102859, 'Hiwassee', 36.9686088562012, 0.645223944422645, -80.7138900756836, -1.40872313391345, 218, 53, 'PPL', 'P'),
(87873, 'Hiwassee College', 35.5577812194824, 0.620600356983773, -84.3625030517578, -1.47240344347694, 218, 50, 'PPL', 'P'),
(65654, 'Hiwassee Village', 35.1488914489746, 0.613463884210687, -84.17138671875, -1.46906783421161, 218, 33, 'PPL', 'P'),
(21973, 'Hix', 34.1824989318848, 0.596597152920834, -83.341667175293, -1.45458649631014, 218, 13, 'PPL', 'P'),
(94935, 'Hix', 30.6977806091309, 0.535777344684204, -96.6619415283203, -1.68706914103943, 218, 51, 'PPL', 'P'),
(109678, 'Hix', 37.7299995422363, 0.658512718787977, -80.8197174072266, -1.41057016928748, 218, 58, 'PPL', 'P'),
(3164, 'Hix (historical)', 34.4619407653809, 0.601474332983151, -85.9719390869141, -1.50049340139066, 218, 2, 'PPL', 'P'),
(87875, 'Hix (historical)', 36.4541702270508, 0.636245296544525, -85.4822235107422, -1.49194625218816, 218, 50, 'PPL', 'P'),
(109679, 'Hix (historical)', 37.2247200012207, 0.649693927154289, -81.6338882446289, -1.42478013107387, 218, 58, 'PPL', 'P'),
(102857, 'Hixburg', 37.3286094665527, 0.651507140382469, -78.647216796875, -1.37265288063526, 218, 53, 'PPL', 'P'),
(3166, 'Hixon', 32.5455589294434, 0.568027160220627, -88.2247161865234, -1.53981177909237, 218, 2, 'PPL', 'P'),
(87876, 'Hixon', 35.4463882446289, 0.618656182808988, -85.809440612793, -1.49765726798778, 218, 50, 'PPL', 'P'),
(135962, 'Hixon', 47.8175010681152, 0.834572833714516, -96.6752777099609, -1.6873019013187, 218, 28, 'PPL', 'P'),
(87877, 'Hixson', 35.1405601501465, 0.613318475615169, -85.232780456543, -1.48759264959615, 218, 50, 'PPL', 'P'),
(174533, 'Hixton', 44.3858299255371, 0.774678873430852, -91.0141677856445, -1.58849689382205, 218, 57, 'PPL', 'P'),
(125084, 'Hixville', 41.6816711425781, 0.727482399171495, -71.0319366455078, -1.23974116853213, 218, 23, 'PPL', 'P'),
(94671, 'HME Colonia', 26.1669998168945, 0.456700302173563, -98.2030029296875, -1.71396573646868, 218, 51, 'PPL', 'P'),
(87878, 'Ho (historical)', 35.4605598449707, 0.618903523895229, -84.379997253418, -1.47270877489592, 218, 50, 'PPL', 'P'),
(145440, 'Ho-Ho-Kus', 40.9963912963867, 0.715522009557895, -74.1016693115234, -1.29331811071012, 218, 37, 'PPL', 'P'),
(178373, 'Hoa Murk', 32.2797203063965, 0.563387400969491, -112.66667175293, -1.96640437935231, 218, 5, 'PPL', 'P'),
(72916, 'Hoadley', 38.7811088562012, 0.676858037115043, -82.5716705322266, -1.44114751965933, 218, 41, 'PPL', 'P'),
(113567, 'Hoadley Neck', 41.2627792358398, 0.720171356188955, -72.7330627441406, -1.26943141994488, 218, 8, 'PPL', 'P'),
(162737, 'Hoadleys', 41.5091705322266, 0.724471695559161, -75.2858276367188, -1.31398557234968, 218, 45, 'PPL', 'P'),
(102858, 'Hoadly', 38.6802787780762, 0.675098220266718, -77.3594436645508, -1.35017699945748, 218, 53, 'PPL', 'P'),
(32774, 'Hoag', 37.1647186279297, 0.648646705634642, -95.0444412231445, -1.6588384350621, 218, 20, 'PPL', 'P'),
(142065, 'Hoag', 40.3175010681152, 0.703673139814941, -96.8324966430664, -1.69004588934787, 218, 35, 'PPL', 'P'),
(149648, 'Hoag Corners', 42.5563888549805, 0.742749103278429, -73.5116729736328, -1.28302073203922, 218, 40, 'PPL', 'P'),
(72917, 'Hoagland', 39.2041702270508, 0.684241850974369, -83.6813888549805, -1.4605157581611, 218, 41, 'PPL', 'P'),
(122821, 'Hoagland', 40.9477806091309, 0.714673593013623, -84.9916687011719, -1.48338445559966, 218, 19, 'PPL', 'P'),
(162738, 'Hoagland', 41.2044410705566, 0.719153163125191, -80.2822189331055, -1.40118905118962, 218, 45, 'PPL', 'P'),
(199406, 'Hoagland', 41.5083312988281, 0.724457048173165, -100.370826721191, -1.75180139923349, 218, 35, 'PPL', 'P'),
(155752, 'Hoagland Corner', 41.2733306884766, 0.720355513778334, -80.7788925170898, -1.40985764053783, 218, 41, 'PPL', 'P'),
(13956, 'Hoagland Subdivision', 38.5669403076172, 0.673120090788035, -75.6563873291016, -1.32045305905694, 218, 10, 'PPL', 'P'),
(162742, 'Hoagland Vista', 41.4855613708496, 0.724059637959498, -76.726936340332, -1.33913766410688, 218, 45, 'PPL', 'P'),
(155753, 'Hoaglin', 40.9461097717285, 0.714644431399686, -84.495002746582, -1.47471599940951, 218, 41, 'PPL', 'P'),
(200982, 'Hoaglin (historical)', 43.3347206115723, 0.756333555103787, -123.006942749023, -2.14687615378262, 218, 43, 'PPL', 'P'),
(3167, 'Hoagtown', 33.5097198486328, 0.584854942779538, -87.0277786254883, -1.51892127771152, 218, 2, 'PPL', 'P'),
(94936, 'Hoard', 32.6413917541504, 0.569699758543252, -95.3872222900391, -1.66482109329291, 218, 51, 'PPL', 'P'),
(109680, 'Hoard', 39.704719543457, 0.692978084614265, -79.932502746582, -1.39508535228727, 218, 58, 'PPL', 'P'),
(13957, 'Hoars Addition', 39.2138900756836, 0.684411494335807, -75.5833282470703, -1.31917793752701, 218, 10, 'PPL', 'P'),
(211556, 'HoÃ‚â€˜okena', 19.3830604553223, 0.338298224058485, -155.900833129883, -2.72098284471871, 218, 15, 'PPL', 'P'),
(211559, 'HoÃ‚â€˜olehua', 21.1711101531982, 0.36950557847571, -157.071395874023, -2.74141301870515, 218, 15, 'PPL', 'P'),
(209511, 'Hoback', 43.2819404602051, 0.755412367682728, -110.783058166504, -1.93352912043389, 218, 59, 'PPL', 'P'),
(209512, 'Hoback Junction', 43.3224983215332, 0.756120235900471, -110.729721069336, -1.93259821247485, 218, 59, 'PPL', 'P'),
(191611, 'Hoban', 31.1941699981689, 0.544440973894882, -103.575561523438, -1.80773457318594, 218, 51, 'PPL', 'P'),
(162739, 'Hoban Heights', 41.4719390869141, 0.723821884253181, -75.8952789306641, -1.32462250405957, 218, 45, 'PPL', 'P'),
(844, 'Hobart', 39.7427787780762, 0.693642343569158, -76.9047164916992, -1.34224051309293, 218, 45, 'PPL', 'P'),
(36457, 'Hobart', 36.6838912963867, 0.640254685565639, -85.2630615234375, -1.48812115391448, 218, 21, 'PPL', 'P'),
(41366, 'Hobart', 30.3222198486328, 0.529222572872219, -90.9388885498047, -1.58718302329826, 218, 22, 'PPL', 'P'),
(55323, 'Hobart', 39.2108306884766, 0.684358097955951, -91.0988922119141, -1.58997561401732, 218, 29, 'PPL', 'P'),
(76100, 'Hobart', 35.0294418334961, 0.611379095130346, -99.0927810668945, -1.72949529457521, 218, 42, 'PPL', 'P'),
(122822, 'Hobart', 41.5322189331055, 0.724873966041817, -87.254997253418, -1.52288699089075, 218, 19, 'PPL', 'P'),
(131327, 'Hobart', 44.1827812194824, 0.771135004968284, -85.4483337402344, -1.49135476411005, 218, 27, 'PPL', 'P'),
(149649, 'Hobart', 42.3713912963867, 0.739520286772817, -74.6708297729492, -1.30325183473417, 218, 40, 'PPL', 'P'),
(155754, 'Hobart', 41.5863914489746, 0.725819454807822, -83.5377807617188, -1.45800932410117, 218, 41, 'PPL', 'P'),
(182164, 'Hobart', 34.0122184753418, 0.59362519830236, -118.203887939453, -2.06304703320187, 218, 6, 'PPL', 'P'),
(187717, 'Hobart', 37.2905616760254, 0.650843081164658, -100.523063659668, -1.75445843505307, 218, 20, 'PPL', 'P'),
(207662, 'Hobart', 47.4219398498535, 0.827668988062649, -121.971672058105, -2.12880727157671, 218, 56, 'PPL', 'P'),
(190311, 'Hobart (historical)', 38.982780456543, 0.680377870548773, -119.939437866211, -2.09333809375654, 218, 39, 'PPL', 'P'),
(209975, 'Hobart Bay', 57.4658317565918, 1.00296797154964, -133.353332519531, -2.32745472097265, 218, 1, 'PPL', 'P'),
(87880, 'Hobart Meadows', 36.5366706848145, 0.637685201166904, -82.4266662597656, -1.43861671767543, 218, 50, 'PPL', 'P'),
(182166, 'Hobart Mills', 39.4005584716797, 0.687669472455355, -120.182777404785, -2.09758516990495, 218, 6, 'PPL', 'P'),
(116052, 'Hobarton', 43.0705604553223, 0.751723090624642, -94.2819366455078, -1.64553021962081, 218, 16, 'PPL', 'P'),
(162740, 'Hobbie', 41.0766716003418, 0.716923165186413, -76.0766677856445, -1.3277883368054, 218, 45, 'PPL', 'P'),
(3168, 'Hobbie Farm', 32.1938896179199, 0.561889372856322, -86.2447204589844, -1.50525433447139, 218, 2, 'PPL', 'P'),
(30092, 'Hobbieville', 38.9991683959961, 0.680663894049848, -86.7063903808594, -1.51331199466554, 218, 19, 'PPL', 'P'),
(48183, 'Hobbits Glen', 39.2236099243164, 0.684581137697245, -76.9011077880859, -1.34217752933315, 218, 25, 'PPL', 'P'),
(36458, 'Hobbs', 37.9272193908691, 0.661954854496905, -85.6252822875977, -1.49444309886816, 218, 21, 'PPL', 'P'),
(48184, 'Hobbs', 38.8613891601563, 0.678259192743561, -75.7847213745117, -1.32269291069175, 218, 25, 'PPL', 'P'),
(122824, 'Hobbs', 40.2836112976074, 0.703081651736835, -85.9475021362305, -1.50006689614208, 218, 19, 'PPL', 'P'),
(188689, 'Hobbs', 32.7024993896484, 0.570766287980801, -103.135559082031, -1.80005508186659, 218, 38, 'PPL', 'P'),
(191613, 'Hobbs', 32.7813911437988, 0.5721432088434, -100.59139251709, -1.7556509985892, 218, 51, 'PPL', 'P'),
(127758, 'Hobbs Crossing', 43.3675003051758, 0.756905668684963, -70.6347198486328, -1.23280842758243, 218, 26, 'PPL', 'P'),
(16455, 'Hobbs Crossroads', 30.9152793884277, 0.539573414502003, -85.9599990844727, -1.50028500903536, 218, 12, 'PPL', 'P'),
(81587, 'Hobbs Crossroads', 34.0097198486328, 0.59358158903951, -79.9530563354492, -1.3954440800861, 218, 48, 'PPL', 'P'),
(87879, 'Hobbs Hill', 35.2755584716797, 0.615674640810589, -85.7275009155273, -1.49622715048241, 218, 50, 'PPL', 'P'),
(3169, 'Hobbs Island', 34.5369415283203, 0.602783343237952, -86.5347213745117, -1.51031580528114, 218, 2, 'PPL', 'P'),
(65657, 'Hobbsville', 36.3469390869141, 0.634373760088472, -76.6050033569336, -1.3370095320798, 218, 33, 'PPL', 'P'),
(65658, 'Hobbton', 35.1719398498535, 0.613866154693344, -78.3227767944336, -1.36699033436748, 218, 33, 'PPL', 'P'),
(9521, 'Hobbtown', 35.5741691589355, 0.620886380484847, -94.3030624389648, -1.64589893427373, 218, 4, 'PPL', 'P'),
(21974, 'Hobby', 31.6625003814697, 0.552614881070607, -83.7408294677734, -1.46155319256374, 218, 13, 'PPL', 'P'),
(94938, 'Hobby', 29.5855598449707, 0.516365430340562, -95.4916687011719, -1.66664402705907, 218, 51, 'PPL', 'P'),
(81588, 'Hobbyville', 34.6966705322266, 0.605571140267047, -81.9316711425781, -1.42997742309921, 218, 48, 'PPL', 'P'),
(81589, 'Hobcaw Point', 32.8199996948242, 0.572817055178217, -79.894172668457, -1.39441636622144, 218, 48, 'PPL', 'P'),
(233, 'Hobdy', 31.8150005340576, 0.55527651084306, -85.5316696166992, -1.4928092495394, 218, 2, 'PPL', 'P'),
(16456, 'Hobe Sound', 27.0591697692871, 0.472271605330174, -80.1366729736328, -1.39864879498385, 218, 12, 'PPL', 'P'),
(149652, 'Hoben', 42.0036087036133, 0.733101269597399, -78.0950012207031, -1.36301490065026, 218, 40, 'PPL', 'P'),
(55325, 'Hoberg', 37.0697212219238, 0.646988688118986, -93.8486099243164, -1.63796724159915, 218, 29, 'PPL', 'P'),
(182165, 'Hobergs', 38.8436088562012, 0.677948867897539, -122.723327636719, -2.14192613626449, 218, 6, 'PPL', 'P'),
(3170, 'Hobgood', 34.714168548584, 0.605876538265052, -87.6347198486328, -1.52951440042147, 218, 2, 'PPL', 'P'),
(65659, 'Hobgood', 36.0297203063965, 0.628837247919279, -77.398063659668, -1.35085104552938, 218, 33, 'PPL', 'P'),
(149650, 'Hobin Corners', 42.8994407653809, 0.748736488620172, -75.3066711425781, -1.31434936015459, 218, 40, 'PPL', 'P'),
(162741, 'Hoblet', 41.8505592346191, 0.730430052445022, -76.6563873291016, -1.33790635157688, 218, 45, 'PPL', 'P'),
(78473, 'Hoblitzell', 39.8347206115723, 0.695247031283985, -78.7508316040039, -1.37446130017348, 218, 45, 'PPL', 'P'),
(60279, 'Hobo Station', 34.5608291625977, 0.603200261106604, -88.4661102294922, -1.54402489993688, 218, 30, 'PPL', 'P'),
(3172, 'Hoboken', 32.0258293151855, 0.558956167231709, -87.8769378662109, -1.53374190233586, 218, 2, 'PPL', 'P'),
(21975, 'Hoboken', 31.1808300018311, 0.544208147036581, -82.1350021362305, -1.4335262184098, 218, 13, 'PPL', 'P'),
(145442, 'Hoboken', 40.7438888549805, 0.711115010586032, -74.0327835083008, -1.29211582663601, 218, 37, 'PPL', 'P'),
(149651, 'Hoboken', 42.6269416809082, 0.743980482387454, -75.3227767944336, -1.31463045680765, 218, 40, 'PPL', 'P'),
(193640, 'Hoboken', 40.8830604553223, 0.713544013237266, -123.433609008789, -2.1543228848227, 218, 6, 'PPL', 'P'),
(72918, 'Hoboken (historical)', 39.5583305358887, 0.69042311444347, -82.1036071777344, -1.43297827301551, 218, 41, 'PPL', 'P'),
(3175, 'Hobson', 31.4722194671631, 0.549293852612251, -88.1533279418945, -1.53856581917638, 218, 2, 'PPL', 'P'),
(36459, 'Hobson', 37.4255599975586, 0.653199246360078, -85.3688888549805, -1.4899681892885, 218, 21, 'PPL', 'P'),
(55326, 'Hobson', 37.7555618286133, 0.658958864849593, -91.6319427490234, -1.5992791009694, 218, 29, 'PPL', 'P'),
(72920, 'Hobson', 38.9916687011719, 0.68053299968227, -82.0758285522461, -1.43249344453907, 218, 41, 'PPL', 'P'),
(94939, 'Hobson', 28.9572200775146, 0.505398832577238, -97.9850006103516, -1.71016087821929, 218, 51, 'PPL', 'P'),
(102861, 'Hobson', 36.894718170166, 0.643934308664775, -76.5122222900391, -1.33539019697898, 218, 53, 'PPL', 'P'),
(186857, 'Hobson', 38.3408317565918, 0.669173752105728, -104.933891296387, -1.83144190005177, 218, 7, 'PPL', 'P'),
(193170, 'Hobson', 47.000560760498, 0.820314535554341, -109.874168395996, -1.91766600140083, 218, 31, 'PPL', 'P'),
(195099, 'Hobson', 42.5319404602051, 0.742322398292771, -113.923057556152, -1.98833244829386, 218, 17, 'PPL', 'P'),
(41367, 'Hobson (historical)', 31.0302791595459, 0.541580539147055, -92.4486083984375, -1.61353260543962, 218, 22, 'PPL', 'P'),
(109681, 'Hobson (historical)', 39.1527786254883, 0.68334489831923, -79.7624969482422, -1.39211819135876, 218, 58, 'PPL', 'P'),
(199994, 'Hobson (historical)', 40.0744400024414, 0.699430923935527, -115.531936645508, -2.0164126856696, 218, 39, 'PPL', 'P'),
(3176, 'Hobson City', 33.6213912963867, 0.586803977223313, -85.8441696166992, -1.49826340345188, 218, 2, 'PPL', 'P'),
(72919, 'Hobson Junction', 38.9836082458496, 0.680392318197687, -82.0791702270508, -1.43255176776694, 218, 41, 'PPL', 'P'),
(200983, 'Hobsonville', 45.5491714477539, 0.794983013318698, -123.900833129883, -2.16247748408053, 218, 43, 'PPL', 'P'),
(65660, 'Hobucken', 35.2455596923828, 0.61515106334028, -76.5694427490234, -1.33638888238776, 218, 33, 'PPL', 'P'),
(76105, 'Hochatown', 34.1522216796875, 0.596068715181535, -94.7525024414063, -1.6537431421065, 218, 42, 'PPL', 'P'),
(94940, 'Hochheim', 29.312219619751, 0.511594743432335, -97.291389465332, -1.69805508001017, 218, 51, 'PPL', 'P'),
(174539, 'Hochheim', 43.4569396972656, 0.758466680557913, -88.4691696166992, -1.54407829631673, 218, 57, 'PPL', 'P'),
(131326, 'Hockaday', 44.0877799987793, 0.7694769208736, -84.4272232055664, -1.4735330232533, 218, 27, 'PPL', 'P'),
(145444, 'Hockamik', 40.0363883972168, 0.698766798138688, -74.5469436645508, -1.30108961424514, 218, 37, 'PPL', 'P'),
(113566, 'Hockanum', 41.7405586242676, 0.728510179615184, -72.6341705322266, -1.2677054252424, 218, 8, 'PPL', 'P'),
(125085, 'Hockanum', 42.2930603027344, 0.738153153027225, -72.6041717529297, -1.26718184777209, 218, 23, 'PPL', 'P'),
(113568, 'Hockanum Park (historical)', 41.1647186279297, 0.718459875714416, -73.3427810668945, -1.28007301218667, 218, 8, 'PPL', 'P'),
(76103, 'Hocker', 35.2900009155273, 0.615926709007765, -99.4736099243164, -1.73614201202383, 218, 42, 'PPL', 'P'),
(116053, 'Hocker Estates Mobile Home Park', 40.4208297729492, 0.705476565926116, -91.4088897705078, -1.59538609208793, 218, 16, 'PPL', 'P'),
(162744, 'Hockersville', 40.2633285522461, 0.702727651048936, -76.6524963378906, -1.33783844096909, 218, 45, 'PPL', 'P'),
(76104, 'Hockerville', 36.9938888549805, 0.645665163636244, -94.7808303833008, -1.65423755796288, 218, 42, 'PPL', 'P'),
(13958, 'Hockessin', 39.7874984741211, 0.694422849505633, -75.6969375610352, -1.32116079411663, 218, 10, 'PPL', 'P'),
(13959, 'Hockessin Hunt', 39.7708282470703, 0.694131899156542, -75.7149963378906, -1.32147597923164, 218, 10, 'PPL', 'P'),
(13960, 'Hockessin Park', 39.7874984741211, 0.694422849505633, -75.6875, -1.32099607760321, 218, 10, 'PPL', 'P'),
(102862, 'Hockett', 36.730281829834, 0.641064353116051, -83.1858291625977, -1.45186660988885, 218, 53, 'PPL', 'P'),
(188690, 'Hockett', 32.6025009155273, 0.569020985360418, -107.284721374512, -1.87247162506997, 218, 38, 'PPL', 'P'),
(72921, 'Hocking', 39.3677787780762, 0.687097358874179, -82.2658309936523, -1.43580961272843, 218, 41, 'PPL', 'P'),
(116055, 'Hocking', 40.9908294677734, 0.715424937336161, -92.8202819824219, -1.62001953322283, 218, 16, 'PPL', 'P'),
(72924, 'Hockingport', 39.188060760498, 0.683960687742284, -81.7519378662109, -1.42684048565121, 218, 41, 'PPL', 'P'),
(207663, 'Hockinson', 45.7380599975586, 0.798279740432107, -122.485832214355, -2.13778105918584, 218, 56, 'PPL', 'P'),
(94941, 'Hockley', 30.0266704559326, 0.524064262867331, -95.8441696166992, -1.67279632865131, 218, 51, 'PPL', 'P'),
(102864, 'Hockley', 37.5091705322266, 0.654658525479387, -76.7316665649414, -1.33922022210067, 218, 53, 'PPL', 'P'),
(102865, 'Hockman', 37.2894401550293, 0.650823506930646, -80.0683288574219, -1.3974559651316, 218, 53, 'PPL', 'P'),
(55327, 'Hocomo', 36.6147193908691, 0.639047408064479, -92.0038909912109, -1.60577082244258, 218, 29, 'PPL', 'P'),
(65661, 'Hocutts Crossroads', 35.7333297729492, 0.623664257238882, -78.2980575561523, -1.36655890227088, 218, 33, 'PPL', 'P'),
(109682, 'Hodam', 38.6202812194824, 0.674051065326099, -80.3827819824219, -1.40294420750604, 218, 58, 'PPL', 'P'),
(36460, 'Hode', 37.8855590820313, 0.661227744940286, -82.4258270263672, -1.43860207028943, 218, 21, 'PPL', 'P'),
(127759, 'Hodgdon', 46.0538902282715, 0.80379201783538, -67.8672180175781, -1.18450640857556, 218, 26, 'PPL', 'P'),
(127760, 'Hodgdon Corners', 46.0422210693359, 0.803588352591016, -67.8597183227539, -1.18437551420798, 218, 26, 'PPL', 'P'),
(3177, 'Hodge', 34.6194381713867, 0.604223181281303, -85.9494400024414, -1.50010071828793, 218, 2, 'PPL', 'P'),
(41368, 'Hodge', 32.276668548584, 0.56333413774769, -92.7233276367188, -1.61832736066619, 218, 22, 'PPL', 'P'),
(55328, 'Hodge', 39.2236099243164, 0.684581137697245, -93.6266708374023, -1.63409367379363, 218, 29, 'PPL', 'P'),
(116054, 'Hodge', 40.6811103820801, 0.710019319534546, -93.4036102294922, -1.6302005317541, 218, 16, 'PPL', 'P'),
(182167, 'Hodge', 34.815559387207, 0.607646142230382, -117.192497253418, -2.04539493570655, 218, 6, 'PPL', 'P'),
(21976, 'Hodge (historical)', 33.5916709899902, 0.586285260021993, -84.9861068725586, -1.48328738337793, 218, 13, 'PPL', 'P'),
(76108, 'Hodgen', 34.8416709899902, 0.608101875671922, -94.6311111450195, -1.65162446430129, 218, 42, 'PPL', 'P'),
(76106, 'Hodgens Station', 34.8408317565918, 0.608087228285926, -94.6283264160156, -1.6515758616114, 218, 42, 'PPL', 'P'),
(36461, 'Hodgenville', 37.5738906860352, 0.655788105255744, -85.7399978637695, -1.49644526337568, 218, 21, 'PPL', 'P'),
(3178, 'Hodges', 34.3269386291504, 0.599118101208703, -87.9263916015625, -1.53460503284516, 218, 2, 'PPL', 'P'),
(32776, 'Hodges', 37.8166694641113, 0.660025394287142, -99.3833312988281, -1.73456635276488, 218, 20, 'PPL', 'P'),
(81590, 'Hodges', 34.2874984741211, 0.598429740645945, -82.2444381713867, -1.4354362375436, 218, 48, 'PPL', 'P'),
(87881, 'Hodges', 36.0769386291504, 0.629661363118604, -83.6413879394531, -1.45981761048133, 218, 50, 'PPL', 'P'),
(94942, 'Hodges', 32.589168548584, 0.568788291660172, -99.8686065673828, -1.74303600397966, 218, 51, 'PPL', 'P'),
(102866, 'Hodges', 37.1216697692871, 0.647895361312104, -79.1594390869141, -1.38159284609854, 218, 53, 'PPL', 'P'),
(109683, 'Hodges', 38.3624992370605, 0.669551920980519, -82.4288864135742, -1.43865546666929, 218, 58, 'PPL', 'P'),
(196720, 'Hodges', 46.9836082458496, 0.820018658357233, -104.387222290039, -1.8219007259724, 218, 31, 'PPL', 'P'),
(94943, 'Hodges Addition Colonia', 28.0160007476807, 0.488971456288221, -97.8759994506836, -1.70825844909459, 218, 51, 'PPL', 'P'),
(81591, 'Hodges Corner', 33.7405586242676, 0.588883839455638, -80.4250030517578, -1.40368110417966, 218, 48, 'PPL', 'P'),
(102867, 'Hodges Ferry', 36.8222198486328, 0.642668974251851, -76.4055633544922, -1.33352864737701, 218, 53, 'PPL', 'P'),
(65662, 'Hodges Gap', 36.2069396972656, 0.631930309788324, -81.7008285522461, -1.42594845984409, 218, 33, 'PPL', 'P'),
(162745, 'Hodges Heights', 40.2805595397949, 0.703028388515033, -76.7633285522461, -1.33977282802687, 218, 45, 'PPL', 'P'),
(102868, 'Hodges Manor', 36.8163909912109, 0.64256724149821, -76.383056640625, -1.33313583111623, 218, 53, 'PPL', 'P'),
(27448, 'Hodges Park', 37.1572189331055, 0.648515811267065, -89.2719421386719, -1.55808931996969, 218, 18, 'PPL', 'P'),
(125086, 'Hodges Village', 42.1180610656738, 0.73509884015204, -71.8813934326172, -1.2545669863206, 218, 23, 'PPL', 'P'),
(3179, 'Hodgesville', 31.0825004577637, 0.542491972740621, -85.3730621337891, -1.49004102674431, 218, 2, 'PPL', 'P'),
(112645, 'Hodgesville', 39.0658302307129, 0.681827362551076, -80.1944427490234, -1.39965706777255, 218, 58, 'PPL', 'P'),
(87882, 'Hodgetown', 35.3658294677734, 0.61725016691148, -85.1263885498047, -1.48573576052609, 218, 50, 'PPL', 'P'),
(27450, 'Hodgeville', 37.3455581665039, 0.65180295100055, -88.5602798461914, -1.54566846980362, 218, 18, 'PPL', 'P'),
(3180, 'Hodgewood', 31.937219619751, 0.557409636297186, -88.3022232055664, -1.54116453176808, 218, 2, 'PPL', 'P'),
(120044, 'Hodgkins', 41.7688903808594, 0.729004662050584, -87.857780456543, -1.533407542461, 218, 18, 'PPL', 'P'),
(16457, 'Hodgson', 29.4036102294922, 0.513189810477724, -82.4561080932617, -1.43913057460776, 218, 12, 'PPL', 'P'),
(94944, 'Hodgson', 33.4719390869141, 0.584195544093635, -94.6858291625977, -1.65257947386819, 218, 51, 'PPL', 'P'),
(65663, 'Hodman', 35.9277801513672, 0.627058056574024, -80.6013870239258, -1.40675958524174, 218, 33, 'PPL', 'P'),
(87883, 'Hodson', 35.9288902282715, 0.627077431070954, -89.1822204589844, -1.55652338124873, 218, 50, 'PPL', 'P'),
(182168, 'Hodson (historical)', 37.9966697692871, 0.663166992267054, -120.684440612793, -2.1063408446208, 218, 6, 'PPL', 'P'),
(131328, 'Hodunk', 42.014720916748, 0.733295214303784, -85.0616683959961, -1.48460618074974, 218, 27, 'PPL', 'P'),
(55329, 'Hoecker', 38.3319396972656, 0.669018556393204, -92.290283203125, -1.61076930949255, 218, 29, 'PPL', 'P'),
(94945, 'Hoefer', 29.6019401550293, 0.516651320683582, -96.2425003051758, -1.67974851067696, 218, 51, 'PPL', 'P'),
(94946, 'Hoehn Drive Colonia', 26.3439998626709, 0.459789535748541, -98.213996887207, -1.71415761722522, 218, 51, 'PPL', 'P'),
(94947, 'Hoehn Estates Colonia', 26.3470001220703, 0.459841900153475, -98.2119979858398, -1.71412272981494, 218, 51, 'PPL', 'P'),
(186858, 'Hoehne', 37.2811088562012, 0.650678098335128, -104.380561828613, -1.82178447899081, 218, 7, 'PPL', 'P'),
(195100, 'Hoelzle Place', 42.2005615234375, 0.736538744774419, -114.952217102051, -2.00629467089812, 218, 17, 'PPL', 'P'),
(94948, 'Hoen', 31.7813892364502, 0.554689883033943, -96.9852828979492, -1.69271251254736, 218, 51, 'PPL', 'P'),
(55330, 'Hoene Spring', 38.4513893127441, 0.671103345473545, -90.6144409179688, -1.58152034387243, 218, 29, 'PPL', 'P'),
(174540, 'Hoepkers Corners', 43.1650009155273, 0.753371387602319, -89.2850036621094, -1.558317286559, 218, 57, 'PPL', 'P'),
(162746, 'Hoernerstown', 40.2872200012207, 0.703144635496615, -76.7247161865234, -1.33909891511302, 218, 45, 'PPL', 'P'),
(48189, 'Hoerr', 39.6252784729004, 0.691591576371743, -76.4816665649414, -1.33485689897069, 218, 25, 'PPL', 'P'),
(149653, 'Hoeseville', 43.0194396972656, 0.750830865080438, -74.1041717529297, -1.293361786552, 218, 40, 'PPL', 'P'),
(174541, 'Hofa Park', 44.6302795410156, 0.778945324076186, -88.3327789306641, -1.54169782977636, 218, 57, 'PPL', 'P'),
(182169, 'Hoff (historical)', 37.3397216796875, 0.651701085088854, -120.538612365723, -2.10379566156701, 218, 6, 'PPL', 'P'),
(87884, 'Hoffasville (historical)', 36.336669921875, 0.63419452934711, -86.9986114501953, -1.51841221446915, 218, 50, 'PPL', 'P'),
(162747, 'Hoffer', 40.6761093139648, 0.709932034429818, -76.9355621337891, -1.34277887110729, 218, 45, 'PPL', 'P'),
(199407, 'Hoffland', 42.0752792358398, 0.734352156361409, -102.657501220703, -1.79171139817137, 218, 35, 'PPL', 'P'),
(55331, 'Hofflins', 38.0958290100098, 0.664897647501442, -91.3605575561523, -1.59454253581264, 218, 29, 'PPL', 'P'),
(27449, 'Hoffman', 38.541389465332, 0.672674144463501, -89.2636108398438, -1.55794391137417, 218, 18, 'PPL', 'P'),
(48186, 'Hoffman', 39.5099983215332, 0.689579558168188, -77.2708282470703, -1.34863036865442, 218, 25, 'PPL', 'P'),
(55333, 'Hoffman', 38.9244384765625, 0.679359610905981, -93.7600021362305, -1.63642074395414, 218, 29, 'PPL', 'P'),
(60280, 'Hoffman', 33.1458282470703, 0.578503836211917, -89.8088912963867, -1.56746085068763, 218, 30, 'PPL', 'P'),
(65664, 'Hoffman', 35.0322189331055, 0.611427564662186, -79.5477828979492, -1.38837072423085, 218, 33, 'PPL', 'P'),
(76107, 'Hoffman', 35.4891700744629, 0.619402866599619, -95.8424987792969, -1.67276716703738, 218, 42, 'PPL', 'P'),
(135965, 'Hoffman', 45.8294410705566, 0.799874641029928, -95.7916717529297, -1.67188006807827, 218, 28, 'PPL', 'P'),
(145445, 'Hoffman', 40.3177795410156, 0.703678000083931, -74.4122161865234, -1.29873817616065, 218, 37, 'PPL', 'P'),
(149654, 'Hoffman', 43.0694389343262, 0.751703516390629, -78.8230590820313, -1.37572190747546, 218, 40, 'PPL', 'P'),
(196721, 'Hoffman', 45.5724983215332, 0.795390144070344, -110.783889770508, -1.93354363466183, 218, 31, 'PPL', 'P'),
(174542, 'Hoffman Corners', 43.021671295166, 0.75086981381138, -89.1500015258789, -1.55596105478456, 218, 57, 'PPL', 'P'),
(30093, 'Hoffman Crossing', 39.3591690063477, 0.686947090009672, -86.9497222900391, -1.51755893765589, 218, 19, 'PPL', 'P'),
(120045, 'Hoffman Estates', 42.042781829834, 0.733784969628249, -88.079719543457, -1.53728111026652, 218, 18, 'PPL', 'P'),
(204354, 'Hoffman Heights', 40.6591682434082, 0.709636356969792, -112.004997253418, -1.95485598075935, 218, 52, 'PPL', 'P'),
(204355, 'Hoffman Heights Numbes 12 and 13', 40.6477813720703, 0.709437618573445, -111.993057250977, -1.95464758840405, 218, 52, 'PPL', 'P'),
(55334, 'Hoffman Junction', 37.9099998474121, 0.661654316767889, -90.5563888549805, -1.58050714423571, 218, 29, 'PPL', 'P'),
(196722, 'Hoffman Place', 45.1749992370605, 0.788452476272633, -112.415832519531, -1.96202640883633, 218, 31, 'PPL', 'P'),
(182170, 'Hoffman Point', 36.6922187805176, 0.64040002758213, -119.197219848633, -2.08038394558218, 218, 6, 'PPL', 'P'),
(145446, 'Hoffmans', 40.7058296203613, 0.710450751631139, -74.8605575561523, -1.30656320923358, 218, 37, 'PPL', 'P'),
(149655, 'Hoffmans', 42.8950004577637, 0.748658990632451, -74.0769424438477, -1.29288654545548, 218, 40, 'PPL', 'P'),
(135967, 'Hoffmans Corner', 45.0502815246582, 0.786275741555657, -93.0316696166992, -1.62370894343897, 218, 28, 'PPL', 'P'),
(48187, 'Hoffmans Mill', 39.5833282470703, 0.690859406809052, -76.8902816772461, -1.34198857805381, 218, 25, 'PPL', 'P'),
(70960, 'Hoffmans Mill', 39.2588882446289, 0.685196860541271, -74.9100036621094, -1.30742620658482, 218, 37, 'PPL', 'P'),
(170534, 'Hoffmans Trailer Court', 42.6069412231445, 0.743631408547572, -96.6444396972656, -1.6867636764624, 218, 49, 'PPL', 'P'),
(162748, 'Hoffmansville', 40.3277816772461, 0.703852570293386, -75.5577774047852, -1.31873199120248, 218, 45, 'PPL', 'P'),
(188691, 'Hoffmantown', 35.1133308410645, 0.612843234518644, -106.537216186523, -1.85942519836383, 218, 38, 'PPL', 'P'),
(48188, 'Hoffmanville', 39.6852798461914, 0.692638797891389, -76.7772216796875, -1.34001530884412, 218, 25, 'PPL', 'P'),
(196723, 'Hoffmanville', 47.5108299255371, 0.829220412555675, -104.301940917969, -1.82041228523915, 218, 31, 'PPL', 'P'),
(149656, 'Hoffmeister', 43.3908309936523, 0.757312866015636, -74.7172164916992, -1.30406143570556, 218, 40, 'PPL', 'P'),
(81592, 'Hoffmeyer Crossroads', 34.2069396972656, 0.597023724748437, -79.8383331298828, -1.39344178242052, 218, 48, 'PPL', 'P'),
(65665, 'Hoflers Fork', 36.396110534668, 0.63523196374975, -76.6072235107422, -1.33704828107366, 218, 33, 'PPL', 'P'),
(32777, 'Hog Back', 38.920280456543, 0.679287039766277, -99.4805603027344, -1.73626331901148, 218, 20, 'PPL', 'P'),
(109684, 'Hog Eye', 39.5691719055176, 0.69061233203892, -79.9124984741211, -1.39473621186836, 218, 58, 'PPL', 'P'),
(196724, 'Hog Heaven (historical)', 47.8166694641113, 0.834558319486575, -114.497222900391, -1.99835352400167, 218, 31, 'PPL', 'P'),
(48190, 'Hog Island', 38.2380599975586, 0.667380046532532, -76.0630569458008, -1.32755078283617, 218, 25, 'PPL', 'P'),
(65666, 'Hog Island', 35.1933288574219, 0.614239463299146, -79.2966690063477, -1.38398796002491, 218, 33, 'PPL', 'P'),
(3181, 'Hog Jaw', 34.332218170166, 0.59921024658242, -86.5602798461914, -1.51076188476373, 218, 2, 'PPL', 'P'),
(9522, 'Hog Jaw', 34.5991706848145, 0.603869446909514, -93.7566680908203, -1.63636255388432, 218, 4, 'PPL', 'P'),
(21977, 'Hog Mountain', 34.0494384765625, 0.594274809871258, -83.9291687011719, -1.46484033229722, 218, 13, 'PPL', 'P'),
(16458, 'Hog Valley', 29.4941692352295, 0.514770363295173, -81.8955612182617, -1.42934718602725, 218, 12, 'PPL', 'P'),
(9524, 'Hogan', 36.1577796936035, 0.631072305864128, -91.1316680908203, -1.59054766101947, 218, 4, 'PPL', 'P'),
(16459, 'Hogan', 30.291109085083, 0.528679587615466, -81.5819396972656, -1.42387345788075, 218, 12, 'PPL', 'P'),
(21979, 'Hogan', 31.1075000762939, 0.542928298395717, -81.5749969482422, -1.42375228405115, 218, 13, 'PPL', 'P'),
(55335, 'Hogan', 37.5111083984375, 0.654692347625231, -90.6958312988281, -1.58294087399788, 218, 29, 'PPL', 'P'),
(199995, 'Hogan', 40.7441711425781, 0.711119937434048, -114.59806060791, -2.00011347400805, 218, 39, 'PPL', 'P'),
(102869, 'Hogans Hill', 37.9936103820801, 0.663113595887198, -76.6588897705078, -1.33795002741876, 218, 53, 'PPL', 'P'),
(149657, 'Hogansburg', 44.9738883972168, 0.784942429955908, -74.6636123657227, -1.30312586721461, 218, 40, 'PPL', 'P'),
(21980, 'Hogansville', 33.1730613708496, 0.578979143887469, -84.9150009155273, -1.48204635030995, 218, 13, 'PPL', 'P'),
(112588, 'Hogansville', 32.875, 0.573776991593136, -95.6691665649414, -1.6697419491971, 218, 51, 'PPL', 'P'),
(21981, 'Hoganville (historical)', 31.5572204589844, 0.550777399786993, -83.4894409179688, -1.45716563466783, 218, 13, 'PPL', 'P'),
(174543, 'Hogarty', 45.0297203063965, 0.785916880598769, -89.3055572509766, -1.55867601435784, 218, 57, 'PPL', 'P'),
(211873, 'Hogatza', 66.1897201538086, 1.15522854765761, -155.717224121094, -2.71777826297902, 218, 1, 'PPL', 'P'),
(32780, 'Hoge', 39.1722183227539, 0.683684185042106, -94.9947204589844, -1.6579706440209, 218, 20, 'PPL', 'P'),
(196725, 'Hogeland', 48.8525009155273, 0.852636988809496, -108.658058166504, -1.89644087382901, 218, 31, 'PPL', 'P'),
(102870, 'Hoges Chapel', 37.3213882446289, 0.651381106283881, -80.5988922119141, -1.40671604255792, 218, 53, 'PPL', 'P'),
(162749, 'Hogestown', 40.2458305358887, 0.702422253050931, -77.0330581665039, -1.3444804978858, 218, 45, 'PPL', 'P'),
(65667, 'Hogetown', 36.1891708374023, 0.631620184679384, -81.5341720581055, -1.4230397553015, 218, 33, 'PPL', 'P'),
(9526, 'Hogeye', 35.920280456543, 0.626927162206447, -94.2675018310547, -1.64527828458169, 218, 4, 'PPL', 'P'),
(94949, 'Hogeye', 33.2969398498535, 0.58114123121845, -96.1630630493164, -1.67836206901347, 218, 51, 'PPL', 'P'),
(81593, 'Hogeye Crossroads', 33.8166694641113, 0.590212224207369, -79.8233337402344, -1.39317999368537, 218, 48, 'PPL', 'P'),
(94951, 'Hogg', 31.1436100006104, 0.543558535467684, -96.6875, -1.68751522052202, 218, 51, 'PPL', 'P'),
(21982, 'Hogg Mountain', 32.958610534668, 0.575236270712445, -85.0791702270508, -1.48491164532677, 218, 13, 'PPL', 'P'),
(188692, 'Hogg Place', 34.6891708374023, 0.605440245899469, -108.251670837402, -1.8893480768978, 218, 38, 'PPL', 'P'),
(21983, 'Hoggard Mill', 31.2169399261475, 0.544838384108549, -84.470832824707, -1.47429415469284, 218, 13, 'PPL', 'P'),
(3182, 'Hogglesville', 32.8541717529297, 0.57341347010434, -87.4916687011719, -1.52701768689952, 218, 2, 'PPL', 'P'),
(21984, 'Hoggs (historical)', 32.1919403076172, 0.561855350973396, -84.5891723632813, -1.47635956927625, 218, 13, 'PPL', 'P'),
(94952, 'Hogpen Crossing', 30.0569400787354, 0.524592567448576, -94.5113906860352, -1.64953494811002, 218, 51, 'PPL', 'P'),
(78474, 'Hogsett', 39.9119415283203, 0.696594790532647, -79.7125015258789, -1.39124560662759, 218, 45, 'PPL', 'P'),
(109685, 'Hogsett', 38.6925010681152, 0.675311539470034, -82.1761093139648, -1.43424367400747, 218, 58, 'PPL', 'P'),
(76110, 'Hogshooter', 36.6986083984375, 0.640511547452777, -95.8541717529297, -1.67297089886077, 218, 42, 'PPL', 'P'),
(30095, 'Hogtown', 38.3583297729492, 0.669479150103733, -86.3177795410156, -1.50652945600132, 218, 19, 'PPL', 'P'),
(149658, 'Hogtown', 43.5202789306641, 0.759572158726405, -73.5569381713867, -1.2838107587766, 218, 40, 'PPL', 'P'),
(193641, 'Hogtown (historical)', 40.6108283996582, 0.708792667536455, -122.473609924316, -2.13756773998252, 218, 6, 'PPL', 'P'),
(36462, 'Hogue', 37.163330078125, 0.648622470868723, -84.709716796875, -1.47846346653741, 218, 21, 'PPL', 'P'),
(102871, 'Hogue Creek Estates', 39.1988906860352, 0.684149705600652, -78.3127822875977, -1.36681589731608, 218, 53, 'PPL', 'P'),
(27451, 'Hogue Town', 39.1902809143066, 0.683999436736145, -87.9280624389648, -1.53463419445909, 218, 18, 'PPL', 'P'),
(162750, 'Hoguetown', 40.4666709899902, 0.706276646096603, -78.6011123657227, -1.37184820651189, 218, 45, 'PPL', 'P'),
(190312, 'Hogum', 39.0563888549805, 0.681662579458627, -114.41056060791, -1.99684098166056, 218, 39, 'PPL', 'P'),
(204358, 'Hogup', 41.2591705322266, 0.720108372429175, -113.123329162598, -1.97437455470465, 218, 52, 'PPL', 'P'),
(207664, 'Hoh', 47.749439239502, 0.833384930710286, -124.405281066895, -2.17128176148627, 218, 56, 'PPL', 'P'),
(41370, 'Hohen Solms', 30.1988906860352, 0.527070072921163, -91.0438919067383, -1.5890156776024, 218, 22, 'PPL', 'P'),
(60281, 'Hohenlinden', 33.728889465332, 0.588680174211274, -89.1636123657227, -1.55619860875379, 218, 30, 'PPL', 'P'),
(87885, 'Hohenwald', 35.547779083252, 0.620425786774318, -87.5519409179688, -1.5280696355301, 218, 50, 'PPL', 'P'),
(162752, 'Hohls Crossing', 40.2722206115723, 0.70288284676146, -75.8380584716797, -1.32362381865079, 218, 45, 'PPL', 'P'),
(72925, 'Hohman', 39.5411109924316, 0.690122576714455, -81.1777801513672, -1.41681954310146, 218, 41, 'PPL', 'P'),
(178374, 'Hohokam Village', 33.440559387207, 0.58364786501546, -111.819442749023, -1.95161744371576, 218, 5, 'PPL', 'P'),
(178375, 'Hoi Oidak', 32.3033294677734, 0.563799458569154, -111.871391296387, -1.95252411690888, 218, 5, 'PPL', 'P'),
(125087, 'Hoicks Hollow', 41.2874984741211, 0.720602788285548, -69.9722213745117, -1.22124564791958, 218, 23, 'PPL', 'P'),
(32778, 'Hoisington', 38.5180587768555, 0.672266947132828, -98.7777786254883, -1.72399746482085, 218, 20, 'PPL', 'P'),
(178376, 'Hoka Tiki Mobile Village', 33.5691719055176, 0.585892576919261, -112.207496643066, -1.95839026184199, 218, 5, 'PPL', 'P'),
(135969, 'Hokah', 43.7594413757324, 0.763746330839968, -91.3463897705078, -1.59429526130543, 218, 28, 'PPL', 'P'),
(65669, 'Hoke', 35.7333297729492, 0.623664257238882, -76.815559387207, -1.340684428068, 218, 33, 'PPL', 'P'),
(162751, 'Hokendauqua', 40.6619415283203, 0.709684759922605, -75.4913864135742, -1.31757324981218, 218, 45, 'PPL', 'P'),
(78475, 'Hokes', 39.7380599975586, 0.693559985312447, -76.8402786254883, -1.34111586016459, 218, 45, 'PPL', 'P'),
(3183, 'Hokes Bluff', 33.9980583190918, 0.593378056953201, -85.8663864135742, -1.4986511597066, 218, 2, 'PPL', 'P'),
(109686, 'Hokes Mill', 37.6997184753418, 0.657984214469651, -80.5263900756836, -1.40545064156596, 218, 58, 'PPL', 'P'),
(170536, 'Holabird', 44.5230598449707, 0.777073987357215, -99.5977783203125, -1.73830915936088, 218, 49, 'PPL', 'P'),
(48206, 'Holabird Homes (historical)', 39.2733306884766, 0.685448928738447, -76.54638671875, -1.33598647874705, 218, 25, 'PPL', 'P'),
(30096, 'Holaday Hills and Dales', 39.9363899230957, 0.697021495518305, -86.1194381713867, -1.50306774605838, 218, 19, 'PPL', 'P'),
(55336, 'Holbert Corner', 36.0233306884766, 0.628725728048632, -89.8677825927734, -1.56848869771034, 218, 29, 'PPL', 'P'),
(199996, 'Holborn', 41.1744384765625, 0.718629519075854, -114.708061218262, -2.00203334683789, 218, 39, 'PPL', 'P'),
(21986, 'Holbrook', 34.2127799987793, 0.59712565723916, -84.271110534668, -1.47080834314204, 218, 13, 'PPL', 'P'),
(36463, 'Holbrook', 38.5905609130859, 0.673532348124779, -84.7141723632813, -1.47854123084124, 218, 21, 'PPL', 'P'),
(48191, 'Holbrook', 39.3944396972656, 0.687562679695643, -76.8530578613281, -1.34133889990589, 218, 25, 'PPL', 'P'),
(65671, 'Holbrook', 35.3777809143066, 0.617458759003861, -80.1741714477539, -1.39930326682173, 218, 33, 'PPL', 'P'),
(78476, 'Holbrook', 39.855281829834, 0.695605892240873, -80.3138885498047, -1.40174179027387, 218, 45, 'PPL', 'P'),
(109687, 'Holbrook', 39.1522216796875, 0.683335177781252, -80.8561096191406, -1.41120533320746, 218, 58, 'PPL', 'P'),
(116056, 'Holbrook', 41.5908317565918, 0.725896952795544, -91.9127807617188, -1.60418064895569, 218, 16, 'PPL', 'P'),
(120046, 'Holbrook', 41.538330078125, 0.724980625643475, -87.6366729736328, -1.52954848888342, 218, 18, 'PPL', 'P'),
(125088, 'Holbrook', 42.1549987792969, 0.735743524872921, -71.0091705322266, -1.23934382489749, 218, 23, 'PPL', 'P'),
(149659, 'Holbrook', 40.8122215270996, 0.712307640701196, -73.0788879394531, -1.27546720823943, 218, 40, 'PPL', 'P'),
(177635, 'Holbrook', 34.9022216796875, 0.609158684571493, -110.157501220703, -1.92261109207094, 218, 5, 'PPL', 'P'),
(195101, 'Holbrook', 42.1619415283203, 0.735864698702519, -112.653060913086, -1.96616682538308, 218, 17, 'PPL', 'P'),
(199408, 'Holbrook', 40.3047218322754, 0.703450100073647, -100.009719848633, -1.74549889535577, 218, 35, 'PPL', 'P'),
(200984, 'Holbrook', 45.6599998474121, 0.79691733379745, -122.86222076416, -2.14435027864674, 218, 43, 'PPL', 'P'),
(149660, 'Holbrook Corners', 42.9738883972168, 0.750035844916022, -73.976936340332, -1.29114110967704, 218, 40, 'PPL', 'P'),
(48192, 'Holbrook Estates', 38.628059387207, 0.674186819962666, -76.5566711425781, -1.33616597580452, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(190313, 'Holbrook Junction', 38.7338905334473, 0.676033921915718, -119.553886413574, -2.08660895147219, 218, 39, 'PPL', 'P'),
(195102, 'Holbrook Summit', 42.1652793884277, 0.735922955351365, -112.452781677246, -1.9626712932943, 218, 17, 'PPL', 'P'),
(21985, 'Holcomb', 34.4127807617188, 0.600616329058954, -84.2805633544922, -1.47097332597157, 218, 13, 'PPL', 'P'),
(55337, 'Holcomb', 36.399169921875, 0.635285360129606, -90.0236129760742, -1.57120845097359, 218, 29, 'PPL', 'P'),
(60282, 'Holcomb', 33.7611083984375, 0.589242500675444, -89.975830078125, -1.57037448207823, 218, 30, 'PPL', 'P'),
(109688, 'Holcomb', 38.2561111450195, 0.667695098489489, -80.6011123657227, -1.40675479155178, 218, 58, 'PPL', 'P'),
(120047, 'Holcomb', 42.0647201538086, 0.734167865613976, -89.0955581665039, -1.55501083890762, 218, 18, 'PPL', 'P'),
(149661, 'Holcomb', 42.9022216796875, 0.748785024731039, -77.4199981689453, -1.35123387493608, 218, 40, 'PPL', 'P'),
(187718, 'Holcomb', 37.9861106872559, 0.662982701519621, -100.988891601563, -1.76258866638692, 218, 20, 'PPL', 'P'),
(200985, 'Holcomb', 45.3708305358887, 0.791870377215641, -122.516670227051, -2.13831928404215, 218, 43, 'PPL', 'P'),
(207666, 'Holcomb', 46.5722198486328, 0.812838576321298, -123.616111755371, -2.15750815864449, 218, 56, 'PPL', 'P'),
(145447, 'Holcomb Mills', 40.5258293151855, 0.707309153651227, -74.8302764892578, -1.30603470491525, 218, 37, 'PPL', 'P'),
(182171, 'Holcomb Village', 33.350830078125, 0.582081793136439, -116.736671447754, -2.03743927458216, 218, 6, 'PPL', 'P'),
(174552, 'Holcombe', 45.2244415283203, 0.789315407044846, -91.1172180175781, -1.59029545966424, 218, 57, 'PPL', 'P'),
(149662, 'Holcombville', 43.6883316040039, 0.762505231192964, -73.9836120605469, -1.29125762297473, 218, 40, 'PPL', 'P'),
(120048, 'Holcombville Corners', 42.2916717529297, 0.738128918261305, -88.3199996948242, -1.54147479003507, 218, 18, 'PPL', 'P'),
(60283, 'Holcut', 34.7297210693359, 0.606147980959158, -88.3058319091797, -1.54122751552786, 218, 30, 'PPL', 'P'),
(102872, 'Holdcroft', 37.3652801513672, 0.652147164571443, -76.9352798461914, -1.34277394425928, 218, 53, 'PPL', 'P'),
(27452, 'Holden', 38.0513916015625, 0.664122068412984, -89.2416687011719, -1.55756094880942, 218, 18, 'PPL', 'P'),
(41369, 'Holden', 30.5041694641113, 0.532398192735057, -90.6691665649414, -1.58247548659738, 218, 22, 'PPL', 'P'),
(55339, 'Holden', 38.714168548584, 0.675689708344825, -93.9911117553711, -1.64045436774117, 218, 29, 'PPL', 'P'),
(94953, 'Holden', 31.6530609130859, 0.552450131267672, -96.4472198486328, -1.68332154075347, 218, 51, 'PPL', 'P'),
(109689, 'Holden', 37.8241691589355, 0.66015628865472, -82.0597229003906, -1.43221234788601, 218, 58, 'PPL', 'P'),
(125090, 'Holden', 42.3516693115234, 0.739176073201924, -71.8638916015625, -1.25426152174357, 218, 23, 'PPL', 'P'),
(127762, 'Holden', 44.7527809143066, 0.781083376378329, -68.679443359375, -1.19868241505805, 218, 26, 'PPL', 'P'),
(155756, 'Holden', 40.6025009155273, 0.708647325519964, -83.8802795410156, -1.46398705548396, 218, 41, 'PPL', 'P'),
(162753, 'Holden', 41.1672210693359, 0.718503551556293, -79.2225036621094, -1.38269353057707, 218, 45, 'PPL', 'P'),
(192625, 'Holden', 39.0988883972168, 0.682404336401242, -112.269996643066, -1.95948109262449, 218, 52, 'PPL', 'P'),
(207665, 'Holden', 48.2008285522461, 0.841263160425986, -120.774436950684, -2.10791157703173, 218, 56, 'PPL', 'P'),
(182172, 'Holden (historical)', 37.9791717529297, 0.662861594269049, -121.105278015137, -2.11368584290724, 218, 6, 'PPL', 'P'),
(65673, 'Holden Beach', 33.913330078125, 0.591899270178907, -78.3041687011719, -1.36666556187254, 218, 33, 'PPL', 'P'),
(125094, 'Holden Center', 42.3499984741211, 0.739146911587988, -71.8583297729492, -1.25416444952183, 218, 23, 'PPL', 'P'),
(16460, 'Holden Heights', 28.4963893890381, 0.49735581976909, -81.3880615234375, -1.4204896453997, 218, 12, 'PPL', 'P'),
(196726, 'Holden Place', 45.2152786254883, 0.789155484221387, -112.415000915527, -1.96201189460839, 218, 31, 'PPL', 'P'),
(65674, 'Holdens Crossroads', 35.7066688537598, 0.623198936417418, -77.783332824707, -1.35757526096572, 218, 33, 'PPL', 'P'),
(76111, 'Holdenville', 35.0802803039551, 0.612266393826533, -96.3988876342773, -1.68247798447819, 218, 42, 'PPL', 'P'),
(16461, 'Holder', 28.9666690826416, 0.505563748827741, -82.4208297729492, -1.43851485176373, 218, 12, 'PPL', 'P'),
(94954, 'Holder', 31.9127807617188, 0.556983097759096, -98.9786071777344, -1.72750258428956, 218, 51, 'PPL', 'P'),
(120049, 'Holder', 40.4511108398438, 0.706005070244442, -88.8041687011719, -1.54992513333195, 218, 18, 'PPL', 'P'),
(143973, 'Holderness', 43.7319412231445, 0.763266362632508, -71.5888900756836, -1.24946183966897, 218, 36, 'PPL', 'P'),
(21987, 'Holders', 34.139720916748, 0.59585053570923, -83.6316680908203, -1.45964796711989, 218, 13, 'PPL', 'P'),
(135974, 'Holdingford', 45.7311096191406, 0.798158433444454, -94.4697189331055, -1.64880763881632, 218, 28, 'PPL', 'P'),
(200986, 'Holdman', 45.8722190856934, 0.800621258241532, -118.93138885498, -2.0757443194891, 218, 43, 'PPL', 'P'),
(142066, 'Holdrege', 40.4402809143066, 0.705816052386074, -99.3694381713867, -1.73432387194763, 218, 35, 'PPL', 'P'),
(9528, 'Holdridge', 34.4316711425781, 0.600946028401906, -91.4427795410156, -1.59597758016603, 218, 4, 'PPL', 'P'),
(127764, 'Holeb', 45.577220916748, 0.795472568906082, -70.4569396972656, -1.22970557859638, 218, 26, 'PPL', 'P'),
(70961, 'Holgate', 39.5400009155273, 0.690103202217524, -74.2572174072266, -1.29603293712535, 218, 37, 'PPL', 'P'),
(155757, 'Holgate', 41.2488899230957, 0.719928941950731, -84.133056640625, -1.46839884814579, 218, 41, 'PPL', 'P'),
(162754, 'Holicong', 40.3355598449707, 0.703988324929952, -75.0477828979492, -1.30983090789111, 218, 45, 'PPL', 'P'),
(30097, 'Holida', 39.8863906860352, 0.696148844208113, -86.1900024414063, -1.50429932490449, 218, 19, 'PPL', 'P'),
(16462, 'Holiday', 28.1875, 0.491964682905902, -82.7397232055664, -1.44408059212589, 218, 12, 'PPL', 'P'),
(13961, 'Holiday Acres', 38.5722198486328, 0.673212236161751, -75.2658309936523, -1.31363656508883, 218, 10, 'PPL', 'P'),
(41371, 'Holiday Acres', 30.5516700744629, 0.533227234782399, -91.1638870239258, -1.59110998748364, 218, 22, 'PPL', 'P'),
(48194, 'Holiday Acres', 39.6444396972656, 0.691926002825629, -77.602783203125, -1.35442407560588, 218, 25, 'PPL', 'P'),
(72929, 'Holiday Acres', 39.2030601501465, 0.684222476477439, -84.383056640625, -1.47276217127577, 218, 41, 'PPL', 'P'),
(81594, 'Holiday Acres', 32.7322196960449, 0.571285005182121, -79.9308319091797, -1.39505619067333, 218, 48, 'PPL', 'P'),
(102873, 'Holiday Acres', 37.4822196960449, 0.654188144651852, -79.1097183227539, -1.38072505505734, 218, 53, 'PPL', 'P'),
(48195, 'Holiday Beach', 38.6474990844727, 0.674526106685542, -76.5263900756836, -1.33563747148619, 218, 25, 'PPL', 'P'),
(70962, 'Holiday Beach', 39.8013916015625, 0.694665330322885, -74.1913909912109, -1.29488404943109, 218, 37, 'PPL', 'P'),
(94955, 'Holiday Beach', 28.1686096191406, 0.49163498356295, -97.0100021362305, -1.69314394464395, 218, 51, 'PPL', 'P'),
(127765, 'Holiday Beach', 44.0750007629395, 0.769253881132306, -69.0561065673828, -1.20525642820891, 218, 26, 'PPL', 'P'),
(200987, 'Holiday Beach', 44.5677795410156, 0.77785449329369, -124.066940307617, -2.16537660124319, 218, 43, 'PPL', 'P'),
(204360, 'Holiday Center Addition', 40.6666717529297, 0.709767317916397, -111.839996337891, -1.95197617151459, 218, 52, 'PPL', 'P'),
(145448, 'Holiday City', 40.0222206115723, 0.698519523631475, -74.1666717529297, -1.2944526173345, 218, 37, 'PPL', 'P'),
(155758, 'Holiday City', 41.6083297729492, 0.726202350793549, -84.5541687011719, -1.47574864012219, 218, 41, 'PPL', 'P'),
(13962, 'Holiday Estates', 38.5311088562012, 0.672494713985057, -75.2655563354492, -1.31363177139887, 218, 10, 'PPL', 'P'),
(21988, 'Holiday Estates', 33.9491691589355, 0.592524780139939, -83.4522171020508, -1.45651595651991, 218, 13, 'PPL', 'P'),
(70963, 'Holiday Estates', 39.9674987792969, 0.697564447485545, -74.1563873291016, -1.29427312027703, 218, 37, 'PPL', 'P'),
(48196, 'Holiday Farms', 39.6441688537598, 0.691921275714694, -77.607780456543, -1.35451129413158, 218, 25, 'PPL', 'P'),
(36464, 'Holiday Ford', 38.5638885498047, 0.673066827566233, -84.7261123657227, -1.47874962319654, 218, 21, 'PPL', 'P'),
(3184, 'Holiday Gardens', 33.5219383239746, 0.585068195403826, -86.710563659668, -1.51338483212135, 218, 2, 'PPL', 'P'),
(16463, 'Holiday Harbor', 30.3047199249268, 0.528917141584701, -81.4438934326172, -1.42146409604256, 218, 12, 'PPL', 'P'),
(48197, 'Holiday Harbor', 38.4166717529297, 0.670497409746525, -75.1688919067383, -1.3119446588483, 218, 25, 'PPL', 'P'),
(193642, 'Holiday Harbor Resort', 40.8025016784668, 0.712137997339758, -122.309173583984, -2.1346977844338, 218, 6, 'PPL', 'P'),
(21989, 'Holiday Heights', 34.2541694641113, 0.597848039684844, -83.8966674804688, -1.46427307898504, 218, 13, 'PPL', 'P'),
(70964, 'Holiday Heights', 39.9458312988281, 0.697186278610754, -74.2544403076172, -1.29598446759351, 218, 37, 'PPL', 'P'),
(174544, 'Holiday Heights', 43.8652801513672, 0.765593565951074, -91.2008285522461, -1.59175473878355, 218, 57, 'PPL', 'P'),
(16464, 'Holiday Hill', 30.3038902282715, 0.528902660646273, -81.5805587768555, -1.42384935627289, 218, 12, 'PPL', 'P'),
(9529, 'Holiday Hills', 36.3369407653809, 0.634199256458044, -92.1855621337891, -1.60894158203643, 218, 4, 'PPL', 'P'),
(13963, 'Holiday Hills', 39.8166694641113, 0.694931979327029, -75.5041732788086, -1.31779642271153, 218, 10, 'PPL', 'P'),
(21991, 'Holiday Hills', 34.3349990844727, 0.599258782693286, -83.896110534668, -1.46426335844706, 218, 13, 'PPL', 'P'),
(36465, 'Holiday Hills', 38.0516700744629, 0.664126928681973, -84.5566711425781, -1.47579231596406, 218, 21, 'PPL', 'P'),
(48200, 'Holiday Hills', 39.1872215270996, 0.683946040356288, -77.0633316040039, -1.34500886904607, 218, 25, 'PPL', 'P'),
(72927, 'Holiday Hills', 38.7188911437988, 0.675772133180563, -82.2125015258789, -1.43487883792745, 218, 41, 'PPL', 'P'),
(81595, 'Holiday Hills', 34.9716682434082, 0.610370755762615, -82.2438888549805, -1.43542665016368, 218, 48, 'PPL', 'P'),
(87890, 'Holiday Hills', 36.5499992370605, 0.637917828288122, -82.4472198486328, -1.43897544547426, 218, 50, 'PPL', 'P'),
(102874, 'Holiday Hills', 37.545280456543, 0.655288762551355, -77.5822219848633, -1.35406521464899, 218, 53, 'PPL', 'P'),
(120050, 'Holiday Hills', 42.2900009155273, 0.738099756647368, -88.2247161865234, -1.53981177909237, 218, 18, 'PPL', 'P'),
(174545, 'Holiday Hills', 42.5480613708496, 0.742603761261938, -89.0302810668945, -1.55387153859328, 218, 57, 'PPL', 'P'),
(182173, 'Holiday Home Mobile Home Park', 33.2552795410156, 0.580414121661831, -116.391387939453, -2.03141294050948, 218, 6, 'PPL', 'P'),
(9530, 'Holiday Island', 36.485279083252, 0.636788248511765, -93.7319412231445, -1.63593098862967, 218, 4, 'PPL', 'P'),
(65675, 'Holiday Island', 36.0875015258789, 0.629845720445065, -76.3833312988281, -1.33314062480619, 218, 33, 'PPL', 'P'),
(94956, 'Holiday Lakes', 29.2094402313232, 0.509800904701085, -95.5166702270508, -1.66708038600368, 218, 51, 'PPL', 'P'),
(16465, 'Holiday Manor', 28.1588897705078, 0.491465340201512, -81.686393737793, -1.42569652480496, 218, 12, 'PPL', 'P'),
(48201, 'Holiday Manor', 38.4208297729492, 0.670569980886229, -75.1666717529297, -1.31190590985444, 218, 25, 'PPL', 'P'),
(21992, 'Holiday Meadows', 34.2161102294922, 0.597183780729951, -83.9066696166992, -1.46444764919449, 218, 13, 'PPL', 'P'),
(65676, 'Holiday Mobile Home City', 34.7425003051758, 0.606371020700452, -77.35888671875, -1.3501672789195, 218, 33, 'PPL', 'P'),
(116057, 'Holiday Mobile Home Court', 41.7377815246582, 0.728461710083344, -91.6050033569336, -1.59880891987895, 218, 16, 'PPL', 'P'),
(48202, 'Holiday Mobile Home Estates', 39.1436080932617, 0.683184842337717, -76.7430572509766, -1.33941902707605, 218, 25, 'PPL', 'P'),
(178379, 'Holiday Palms Mobile Home Park', 33.4088897705078, 0.583095125931214, -111.627502441406, -1.94826745338055, 218, 5, 'PPL', 'P'),
(21993, 'Holiday Park', 33.5166702270508, 0.584976249767192, -82.1202774047852, -1.43326922336461, 218, 13, 'PPL', 'P'),
(48203, 'Holiday Park', 39.0508308410645, 0.681565573815921, -77.0824966430664, -1.34534336207899, 218, 25, 'PPL', 'P'),
(155759, 'Holiday Park', 41.5499992370605, 0.725184290887838, -83.5983276367188, -1.45906606642171, 218, 41, 'PPL', 'P'),
(162756, 'Holiday Park', 40.3658294677734, 0.704516629511197, -76.7516708374023, -1.33956936251958, 218, 45, 'PPL', 'P'),
(3185, 'Holiday Park Estates', 33.6530609130859, 0.587356716307559, -86.6697235107422, -1.51267203705559, 218, 2, 'PPL', 'P'),
(102875, 'Holiday Park Trailer Park', 37.3936080932617, 0.652641580427816, -77.4261093139648, -1.35134053453773, 218, 53, 'PPL', 'P'),
(13964, 'Holiday Pines', 38.6341705322266, 0.674293479564324, -75.209716796875, -1.31265718759795, 218, 10, 'PPL', 'P'),
(13965, 'Holiday Pines Mobile Home Park', 38.6352806091309, 0.674312854061254, -75.2113876342773, -1.31268634921189, 218, 10, 'PPL', 'P'),
(162757, 'Holiday Poconos', 41.0255584716797, 0.716031072800263, -75.6050033569336, -1.31955623955986, 218, 45, 'PPL', 'P'),
(102876, 'Holiday Point Estates', 36.8672218322754, 0.643454407036342, -76.4966735839844, -1.3351188208639, 218, 53, 'PPL', 'P'),
(27454, 'Holiday Shores', 38.9219398498535, 0.679316001643131, -89.940559387207, -1.56975889239226, 218, 18, 'PPL', 'P'),
(55340, 'Holiday Shores', 37.7391700744629, 0.658672774769491, -90.6744384765625, -1.58256749881305, 218, 29, 'PPL', 'P'),
(65679, 'Holiday Shores', 35.3419418334961, 0.616833249042828, -80.0611114501953, -1.39732999761204, 218, 33, 'PPL', 'P'),
(87892, 'Holiday Shores', 35.8963890075684, 0.626510177758768, -84.482780456543, -1.47450268020619, 218, 50, 'PPL', 'P'),
(178377, 'Holiday Spa Mobile Home Park', 33.5800018310547, 0.586081594777629, -112.048606872559, -1.95561711219889, 218, 5, 'PPL', 'P'),
(196727, 'Holiday Trailer Court', 46.7602806091309, 0.816120855785793, -114.081672668457, -1.991100804247, 218, 31, 'PPL', 'P'),
(72928, 'Holiday Valley', 39.8561096191406, 0.695620339889787, -83.9686126708984, -1.46552875943901, 218, 41, 'PPL', 'P'),
(21995, 'Holiday Villa', 34.2427787780762, 0.59764923470947, -83.9024963378906, -1.46437481173868, 218, 13, 'PPL', 'P'),
(3188, 'Holiday Village', 31.3408298492432, 0.547000671176611, -85.7652816772461, -1.49688654916831, 218, 2, 'PPL', 'P'),
(116058, 'Holiday Village', 42.5180587768555, 0.742080117212601, -96.3569412231445, -1.68174588149452, 218, 16, 'PPL', 'P'),
(178378, 'Holiday Village Mobile Home Park', 33.4019393920898, 0.582973818943561, -111.853332519531, -1.95220893179386, 218, 5, 'PPL', 'P'),
(177231, 'Holidays Cove', 40.4005584716797, 0.705122764975299, -80.5899963378906, -1.40656078026636, 218, 58, 'PPL', 'P'),
(36466, 'Holifield', 36.6616706848145, 0.639866862731897, -88.7891693115234, -1.54966334459679, 218, 21, 'PPL', 'P'),
(60284, 'Holihtasha (historical)', 32.7666702270508, 0.571886280377234, -88.6513900756836, -1.5472586432905, 218, 30, 'PPL', 'P'),
(211874, 'Holikachuk', 62.9097213745117, 1.09798176949748, -159.517501831055, -2.78410562150799, 218, 1, 'PPL', 'P'),
(196728, 'Holker', 46.2544403076172, 0.807292277035099, -111.47721862793, -1.94564450602293, 218, 31, 'PPL', 'P'),
(9531, 'Holla Bend', 35.1661109924316, 0.613764421939703, -93.0516662597656, -1.62405795069983, 218, 4, 'PPL', 'P'),
(60285, 'Holladay', 33.9308280944824, 0.592204668176912, -89.0063934326172, -1.55345462072463, 218, 30, 'PPL', 'P'),
(87894, 'Holladay', 36.1427803039551, 0.630810517128973, -85.543327331543, -1.49301271504668, 218, 50, 'PPL', 'P'),
(102877, 'Holladay', 38.1202812194824, 0.665324419066127, -77.8691711425781, -1.35907342223694, 218, 53, 'PPL', 'P'),
(204361, 'Holladay', 40.6688919067383, 0.709806066910258, -111.823890686035, -1.95169507486153, 218, 52, 'PPL', 'P'),
(204366, 'Holladay Edgehill', 40.6563911437988, 0.709587887437953, -111.817222595215, -1.9515786947219, 218, 52, 'PPL', 'P'),
(204368, 'Holladay Gardens', 40.6583290100098, 0.709621709583797, -111.816108703613, -1.95155925364594, 218, 52, 'PPL', 'P'),
(204369, 'Holladay Grove', 40.663890838623, 0.70971878180553, -111.844718933105, -1.95205859635033, 218, 52, 'PPL', 'P'),
(204372, 'Holladay Highlands', 40.6533317565918, 0.709534491058097, -111.811111450195, -1.95147203512024, 218, 52, 'PPL', 'P'),
(204373, 'Holladay Highlands Three', 40.6511116027832, 0.709495742064236, -111.809173583984, -1.9514382129744, 218, 52, 'PPL', 'P'),
(204376, 'Holladay Meadows Condominium', 40.663330078125, 0.709708994688524, -111.819717407227, -1.95162223740572, 218, 52, 'PPL', 'P'),
(204379, 'Holladay Villa Homes Condominium', 40.6666717529297, 0.709767317916397, -111.823608398438, -1.95169014801352, 218, 52, 'PPL', 'P'),
(9534, 'Holland', 35.1713905334473, 0.61385656731342, -92.2736129760742, -1.61047835914346, 218, 4, 'PPL', 'P'),
(16466, 'Holland', 30.4274997711182, 0.531060054155833, -84.5327835083008, -1.47537539809541, 218, 12, 'PPL', 'P'),
(21998, 'Holland', 34.2722206115723, 0.598163091641801, -83.8666687011719, -1.46374950151473, 218, 13, 'PPL', 'P'),
(27455, 'Holland', 39.2158317565918, 0.684445383060678, -88.748893737793, -1.54896040322706, 218, 18, 'PPL', 'P'),
(30098, 'Holland', 38.2455596923828, 0.66751094090011, -87.0361099243164, -1.51906668630703, 218, 19, 'PPL', 'P'),
(32781, 'Holland', 38.7619400024414, 0.676523477503101, -97.279167175293, -1.69784176080685, 218, 20, 'PPL', 'P'),
(36467, 'Holland', 36.6988906860352, 0.640516474300794, -86.0683288574219, -1.50217572025126, 218, 21, 'PPL', 'P'),
(55341, 'Holland', 36.0558280944824, 0.629292914781791, -89.8708267211914, -1.56854182777409, 218, 29, 'PPL', 'P'),
(65680, 'Holland', 35.5727806091309, 0.620862145718928, -78.7705612182617, -1.37480564690242, 218, 33, 'PPL', 'P'),
(94957, 'Holland', 30.878059387207, 0.538923802933105, -97.4013900756836, -1.69997495284001, 218, 51, 'PPL', 'P'),
(102878, 'Holland', 36.6811103820801, 0.640206149454773, -76.7805633544922, -1.34007363207199, 218, 53, 'PPL', 'P'),
(116059, 'Holland', 42.3988914489746, 0.740000254980276, -92.8002777099609, -1.61967039280392, 218, 16, 'PPL', 'P'),
(125092, 'Holland', 42.0638885498047, 0.734153351386035, -72.1577835083008, -1.25939090316111, 218, 23, 'PPL', 'P'),
(131329, 'Holland', 42.7874984741211, 0.746782727065463, -86.10888671875, -1.502883588469, 218, 27, 'PPL', 'P'),
(135976, 'Holland', 44.0916709899902, 0.769544831481397, -96.1883316040039, -1.67880308848999, 218, 28, 'PPL', 'P'),
(142068, 'Holland', 40.5963897705078, 0.708540665918307, -96.5913925170898, -1.68583782850943, 218, 35, 'PPL', 'P'),
(145451, 'Holland', 41.0663909912109, 0.716743734707969, -74.5266723632813, -1.30073581329432, 218, 37, 'PPL', 'P'),
(149664, 'Holland', 40.5863914489746, 0.708366162287879, -73.8183288574219, -1.28837288688196, 218, 40, 'PPL', 'P'),
(155760, 'Holland', 41.6216697692871, 0.726435177651849, -83.711669921875, -1.46104426247942, 218, 41, 'PPL', 'P'),
(162758, 'Holland', 40.172779083252, 0.701147264679056, -74.9930572509766, -1.30887576516615, 218, 45, 'PPL', 'P'),
(172124, 'Holland', 44.9669418334961, 0.784821189547283, -72.0027770996094, -1.25668553096776, 218, 55, 'PPL', 'P'),
(174546, 'Holland', 44.2486114501953, 0.772283959241571, -88.1716690063477, -1.5388859311394, 218, 57, 'PPL', 'P'),
(196729, 'Holland', 45.7441711425781, 0.798386400033765, -111.244438171387, -1.94158172062196, 218, 31, 'PPL', 'P'),
(200988, 'Holland', 42.1277809143066, 0.735268483513478, -123.537780761719, -2.1561410248989, 218, 43, 'PPL', 'P'),
(48204, 'Holland Acres', 39.6436080932617, 0.691911488597688, -76.1222229003906, -1.32858342354884, 218, 25, 'PPL', 'P'),
(48205, 'Holland Cliff Shores', 38.6066703796387, 0.673813511356864, -76.6616668701172, -1.3379984969506, 218, 25, 'PPL', 'P'),
(149665, 'Holland Cove', 43.2869415283203, 0.755499652787456, -77.1438903808594, -1.34641488494358, 218, 40, 'PPL', 'P'),
(16467, 'Holland Crossroads', 30.9652805328369, 0.540446099101708, -85.6466674804688, -1.49481634089494, 218, 12, 'PPL', 'P'),
(87895, 'Holland Ford', 36.1227798461914, 0.630461443289091, -84.8349990844727, -1.48065005495042, 218, 50, 'PPL', 'P'),
(3190, 'Holland Gin', 34.9633293151855, 0.610225214009042, -86.8872222900391, -1.51646810687339, 218, 2, 'PPL', 'P'),
(48207, 'Holland Glenn', 38.6138916015625, 0.673939545455452, -76.658332824707, -1.33794030688078, 218, 25, 'PPL', 'P'),
(48208, 'Holland Heights', 38.4011116027832, 0.670225833894364, -75.5999984741211, -1.3194688878761, 218, 25, 'PPL', 'P'),
(102879, 'Holland Heights', 36.7299995422363, 0.641059426268034, -76.6202774047852, -1.33727611450492, 218, 53, 'PPL', 'P'),
(162759, 'Holland Heights', 40.0744400024414, 0.699430923935527, -76.2552795410156, -1.33090570001939, 218, 45, 'PPL', 'P'),
(48209, 'Holland Hills', 39.336109161377, 0.686544619789933, -76.5258331298828, -1.33562775094821, 218, 25, 'PPL', 'P'),
(60286, 'Holland Landing', 32.9647216796875, 0.575342930314102, -90.7805633544922, -1.5844197273512, 218, 30, 'PPL', 'P'),
(21999, 'Holland Manor', 33.7005615234375, 0.588185758354901, -84.7275009155273, -1.47877385796246, 218, 13, 'PPL', 'P'),
(87896, 'Holland Mill', 36.3074989318848, 0.633685399525714, -82.7822189331055, -1.44482228248948, 218, 50, 'PPL', 'P'),
(149666, 'Holland Patent', 43.2416687011719, 0.754709492892029, -75.2572174072266, -1.31348622964529, 218, 40, 'PPL', 'P'),
(94958, 'Holland Quarters', 32.1688919067383, 0.56145308049074, -94.4258270263672, -1.64804158052875, 218, 51, 'PPL', 'P'),
(81597, 'Holland Store', 34.3916702270508, 0.600247880722142, -82.8080596923828, -1.44527328882008, 218, 48, 'PPL', 'P'),
(182174, 'Holland Summit (historical)', 34.8005599975586, 0.607384353495227, -118.872497558594, -2.07471647246638, 218, 6, 'PPL', 'P'),
(60287, 'Hollandale', 33.1688919067383, 0.578906373010683, -90.853889465332, -1.58569950941303, 218, 30, 'PPL', 'P'),
(135979, 'Hollandale', 43.7608299255371, 0.763770565605888, -93.2038879394531, -1.62671472020329, 218, 28, 'PPL', 'P'),
(174550, 'Hollandale', 42.8758316040039, 0.74832443102051, -89.9361114501953, -1.56968126124648, 218, 57, 'PPL', 'P'),
(135980, 'Hollandale Junction', 43.6636085510254, 0.762073732517344, -93.1891708374023, -1.62645785831615, 218, 28, 'PPL', 'P'),
(72936, 'Hollandia View', 39.9238891601563, 0.696803316046, -83.6416702270508, -1.45982253732935, 218, 41, 'PPL', 'P'),
(65681, 'Hollands', 35.7230606079102, 0.623485026497519, -77.4772186279297, -1.35223256034486, 218, 33, 'PPL', 'P'),
(60288, 'Hollands (historical)', 32.980281829834, 0.575614506166263, -90.6661071777344, -1.58242209021753, 218, 30, 'PPL', 'P'),
(48217, 'Hollands Crossroads', 38.4472198486328, 0.671030574596759, -75.8486099243164, -1.32380797624017, 218, 25, 'PPL', 'P'),
(65683, 'Hollands Crossroads', 35.5230598449707, 0.619994354677725, -78.0888900756836, -1.3629082410486, 218, 33, 'PPL', 'P'),
(22000, 'Hollands Folly', 31.4627799987793, 0.549129102809316, -84.102783203125, -1.46787047698551, 218, 13, 'PPL', 'P'),
(30099, 'Hollandsburg', 39.7602806091309, 0.69394780814619, -87.0722198486328, -1.519696923379, 218, 19, 'PPL', 'P'),
(13967, 'Hollandsville', 38.985279083252, 0.680421479811623, -75.666389465332, -1.3206276292664, 218, 10, 'PPL', 'P'),
(196730, 'Hollandville (historical)', 48.6972198486328, 0.849926822926177, -109.158332824707, -1.90517231377894, 218, 31, 'PPL', 'P'),
(72930, 'Hollansburg', 39.996940612793, 0.698078304417876, -84.7922210693359, -1.47990343773882, 218, 41, 'PPL', 'P'),
(162760, 'Hollars Hill', 40.9488906860352, 0.714692967510553, -76.0077819824219, -1.32658605273128, 218, 45, 'PPL', 'P'),
(48211, 'Hollaway Estates', 38.7552795410156, 0.676407230521519, -76.8247222900391, -1.34084435089146, 218, 25, 'PPL', 'P'),
(65682, 'Hollemans Crossroads', 35.6161117553711, 0.621618416889483, -78.9100036621094, -1.37723937666459, 218, 33, 'PPL', 'P'),
(162761, 'Hollenback', 41.603889465332, 0.726124852805827, -76.2472229003906, -1.33076508511384, 218, 45, 'PPL', 'P'),
(193643, 'Hollenbeck (historical)', 41.4619407653809, 0.723647380622754, -121.282218933105, -2.11677404450729, 218, 6, 'PPL', 'P'),
(32783, 'Hollenberg', 39.9805603027344, 0.697792414074856, -96.991943359375, -1.69282875952894, 218, 20, 'PPL', 'P'),
(188693, 'Hollene', 34.7775001525879, 0.606981883275489, -103.090278625488, -1.7992647888131, 218, 38, 'PPL', 'P'),
(55343, 'Hollensville', 39.313060760498, 0.686142349307277, -91.9852828979492, -1.60544604994765, 218, 29, 'PPL', 'P'),
(162762, 'Hollentown', 40.6897201538086, 0.710169588399054, -78.4649963378906, -1.36947253366148, 218, 45, 'PPL', 'P'),
(48212, 'Holler', 39.4708290100098, 0.688895924716364, -77.1572189331055, -1.3466475120648, 218, 25, 'PPL', 'P'),
(13968, 'Holletts Corners', 39.2894401550293, 0.685730091970533, -75.7330627441406, -1.32179129750471, 218, 10, 'PPL', 'P'),
(16468, 'Holley', 30.4466705322266, 0.531394647057288, -86.9069366455078, -1.51681218728623, 218, 12, 'PPL', 'P'),
(22001, 'Holley', 34.663330078125, 0.604989239568865, -84.8288879394531, -1.48054339534877, 218, 13, 'PPL', 'P'),
(149668, 'Holley', 43.226390838623, 0.754442843887885, -78.0269393920898, -1.36182699764603, 218, 40, 'PPL', 'P'),
(200989, 'Holley', 44.3544387817383, 0.774130994615596, -122.782218933105, -2.14295398328721, 218, 43, 'PPL', 'P'),
(3191, 'Holley Crossroads', 33.8013916015625, 0.589945575203225, -85.6836090087891, -1.49546109219484, 218, 2, 'PPL', 'P'),
(3192, 'Holley Store', 31.2222194671631, 0.544930529482265, -86.0991668701172, -1.50271394510757, 218, 2, 'PPL', 'P'),
(191614, 'Hollicott Crossing', 35.5327796936035, 0.620163998039163, -102.379173278809, -1.78685365918501, 218, 51, 'PPL', 'P'),
(27457, 'Holliday', 39.2163887023926, 0.684455103598657, -88.8247222900391, -1.55028386113078, 218, 18, 'PPL', 'P'),
(32784, 'Holliday', 39.038330078125, 0.681347394343616, -94.8077774047852, -1.65470787221139, 218, 20, 'PPL', 'P'),
(36468, 'Holliday', 37.8108291625977, 0.659923461796419, -83.2230606079102, -1.45251642119483, 218, 21, 'PPL', 'P'),
(55344, 'Holliday', 39.4944381713867, 0.689307982316027, -92.1286087036133, -1.60794755715956, 218, 29, 'PPL', 'P'),
(94959, 'Holliday', 33.8161087036133, 0.590202437090363, -98.6947174072266, -1.72254777308146, 218, 51, 'PPL', 'P'),
(102880, 'Holliday', 37.9341697692871, 0.662076161484558, -77.6080627441406, -1.3545162209796, 218, 53, 'PPL', 'P'),
(162763, 'Holliday', 40.1938896179199, 0.701515713015868, -76.9744415283203, -1.34345744455305, 218, 45, 'PPL', 'P'),
(55345, 'Holliday Landing', 37.0361099243164, 0.646402060309869, -90.4227828979492, -1.57817528038523, 218, 29, 'PPL', 'P'),
(162764, 'Hollidaysburg', 40.4272193908691, 0.705588085796763, -78.3891677856445, -1.36814907575777, 218, 45, 'PPL', 'P'),
(102881, 'Hollin Hills', 38.7572212219238, 0.676441119246391, -77.0663909912109, -1.34506226542593, 218, 53, 'PPL', 'P'),
(102882, 'Hollindale', 38.7508316040039, 0.676329599375744, -77.063606262207, -1.34501366273603, 218, 53, 'PPL', 'P'),
(142069, 'Hollinger', 40.1591682434082, 0.700909710709821, -99.7074966430664, -1.7402241053427, 218, 35, 'PPL', 'P'),
(196731, 'Hollingshead Trailer Court', 48.5583305358887, 0.84750274712296, -109.672218322754, -1.91414130769811, 218, 31, 'PPL', 'P'),
(3193, 'Hollingsworth', 33.8250007629395, 0.590357632802887, -85.6977767944336, -1.49570836670206, 218, 2, 'PPL', 'P'),
(22002, 'Hollingsworth', 34.4386100769043, 0.601067135652478, -83.5083312988281, -1.45749533401078, 218, 13, 'PPL', 'P'),
(41374, 'Hollingsworth', 31.9775009155273, 0.558112677535453, -93.3625030517578, -1.62948307615643, 218, 22, 'PPL', 'P'),
(16469, 'Hollingsworth Bluff', 29.8688907623291, 0.521310487721162, -82.7430572509766, -1.44413878219571, 218, 12, 'PPL', 'P'),
(48213, 'Hollingsworth Circle', 39.0436096191406, 0.681439539717333, -75.8261108398438, -1.32341529313744, 218, 25, 'PPL', 'P'),
(13969, 'Hollingsworth Development', 39.8258285522461, 0.695091835571461, -75.6175003051758, -1.31977435245313, 218, 10, 'PPL', 'P'),
(48215, 'Hollinridge', 39.0547218322754, 0.681633484423718, -77.2113876342773, -1.34759293425178, 218, 25, 'PPL', 'P'),
(3194, 'Hollins', 33.1175003051758, 0.578009420355544, -86.1444396972656, -1.50350410500299, 218, 2, 'PPL', 'P'),
(102883, 'Hollins', 37.3411102294922, 0.651725319854774, -79.9433288574219, -1.39527430356661, 218, 53, 'PPL', 'P'),
(48216, 'Hollins (historical)', 39.3805618286133, 0.687320465194501, -76.644172668457, -1.33769316553162, 218, 25, 'PPL', 'P'),
(102884, 'Hollins Court', 37.3499984741211, 0.651880448988271, -79.938606262207, -1.39519187873087, 218, 53, 'PPL', 'P'),
(48220, 'Hollinsland', 39.6305618286133, 0.691683788324487, -76.7847213745117, -1.3401462032117, 218, 25, 'PPL', 'P'),
(9537, 'Hollis', 34.874439239502, 0.608673789516016, -93.1102828979492, -1.62508100403258, 218, 4, 'PPL', 'P'),
(22003, 'Hollis', 30.9225006103516, 0.539699448600591, -83.7391662597656, -1.46152416410786, 218, 13, 'PPL', 'P'),
(55346, 'Hollis', 36.7044410705566, 0.640613346785446, -91.3050003051758, -1.59357287885974, 218, 29, 'PPL', 'P'),
(60289, 'Hollis', 33.8633308410645, 0.591026618868715, -89.2416687011719, -1.55756094880942, 218, 30, 'PPL', 'P'),
(65684, 'Hollis', 35.4361114501953, 0.618476818909571, -81.730827331543, -1.4264720373144, 218, 33, 'PPL', 'P'),
(76112, 'Hollis', 34.6883316040039, 0.605425598513474, -99.9116668701172, -1.74378754803928, 218, 42, 'PPL', 'P'),
(120051, 'Hollis', 40.5966682434082, 0.708545526187296, -89.6699981689453, -1.56503670830538, 218, 18, 'PPL', 'P'),
(143975, 'Hollis', 42.7430610656738, 0.746007147977005, -71.5922164916992, -1.24951989658074, 218, 36, 'PPL', 'P'),
(149669, 'Hollis', 40.7133293151855, 0.710581645998716, -73.7675018310547, -1.28748578792285, 218, 40, 'PPL', 'P'),
(182176, 'Hollis', 35.6674995422363, 0.622515302965594, -119.190277099609, -2.08026277175258, 218, 6, 'PPL', 'P'),
(209976, 'Hollis', 55.5566711425781, 0.969646832885708, -132.636383056641, -2.3149415922748, 218, 1, 'PPL', 'P'),
(72931, 'Hollis (historical)', 38.7202796936035, 0.675796367946483, -82.3249969482422, -1.43684225344111, 218, 41, 'PPL', 'P'),
(127766, 'Hollis Center', 43.6049995422363, 0.761050812342644, -70.5936126708984, -1.23209097198477, 218, 26, 'PPL', 'P'),
(60290, 'Hollis Creek', 31.5308303833008, 0.550316806076464, -88.833610534668, -1.55043899026428, 218, 30, 'PPL', 'P'),
(3195, 'Hollis Crossroads', 33.523609161377, 0.585097357017763, -85.6372222900391, -1.49465149122346, 218, 2, 'PPL', 'P'),
(143976, 'Hollis Depot', 42.7127799987793, 0.745478643658678, -71.5491714477539, -1.24876861883722, 218, 36, 'PPL', 'P'),
(22004, 'Hollis Heights', 33.6100006103516, 0.586605172247939, -84.8550033569336, -1.48099919536933, 218, 13, 'PPL', 'P'),
(16470, 'Hollister', 29.6224994659424, 0.517010148350956, -81.8138885498047, -1.42792172905378, 218, 12, 'PPL', 'P'),
(32785, 'Hollister', 37.7627792358398, 0.659084832369153, -94.835563659668, -1.65519283384589, 218, 20, 'PPL', 'P'),
(55348, 'Hollister', 36.6211090087891, 0.639158927935126, -93.2152786254883, -1.62691352517866, 218, 29, 'PPL', 'P'),
(65685, 'Hollister', 36.2558288574219, 0.632783586601586, -77.9361114501953, -1.36024175100716, 218, 33, 'PPL', 'P'),
(72932, 'Hollister', 39.5055618286133, 0.689502126759494, -82.1119384765625, -1.43312368161103, 218, 41, 'PPL', 'P'),
(76114, 'Hollister', 34.3422203063965, 0.599384816791875, -98.8705596923828, -1.72561679992167, 218, 42, 'PPL', 'P'),
(174553, 'Hollister', 45.2480583190918, 0.789727597802563, -88.791389465332, -1.54970209359065, 218, 57, 'PPL', 'P'),
(182177, 'Hollister', 36.8525009155273, 0.643197478570177, -121.40055847168, -2.11883945909071, 218, 6, 'PPL', 'P'),
(195103, 'Hollister', 42.353328704834, 0.739205035078779, -114.574172973633, -1.99969655613939, 218, 17, 'PPL', 'P'),
(162767, 'Hollisters', 41.3186111450195, 0.721145806831815, -75.5005569458008, -1.3177333057937, 218, 45, 'PPL', 'P'),
(155761, 'Hollisters (historical)', 40.3833312988281, 0.704822094088229, -82.2486114501953, -1.43550907499942, 218, 41, 'PPL', 'P'),
(162768, 'Hollisterville', 41.3911094665527, 0.722411141244739, -75.4388885498047, -1.31665698923914, 218, 45, 'PPL', 'P'),
(125096, 'Holliston', 42.2000007629395, 0.736528957657413, -71.4250030517578, -1.24660147150017, 218, 23, 'PPL', 'P'),
(81598, 'Hollman Crossroads', 34.0958290100098, 0.595084477421669, -79.8933334350586, -1.39440171883544, 218, 48, 'PPL', 'P'),
(162769, 'Hollo', 40.7227783203125, 0.710746562249219, -75.2958297729492, -1.31416014255914, 218, 45, 'PPL', 'P'),
(48218, 'Hollofield', 39.3152809143066, 0.686181098301137, -76.7938919067383, -1.34030625919321, 218, 25, 'PPL', 'P'),
(22009, 'Hollonville', 33.1655616760254, 0.578848249519892, -84.460563659668, -1.47411492395148, 218, 13, 'PPL', 'P'),
(36469, 'Hollonville', 37.6683311462402, 0.657436402233422, -83.4683303833008, -1.45679718633102, 218, 21, 'PPL', 'P'),
(55347, 'Hollow', 38.5499992370605, 0.672824413328009, -90.7080612182617, -1.58315432635925, 218, 29, 'PPL', 'P'),
(76115, 'Hollow', 36.8875007629395, 0.643808341145214, -95.2697219848633, -1.66277032609549, 218, 42, 'PPL', 'P'),
(36470, 'Hollow Bill', 37.0561103820801, 0.646751134149751, -86.9883270263672, -1.51823271741168, 218, 21, 'PPL', 'P'),
(36471, 'Hollow Creek', 38.1525001525879, 0.665886745530298, -85.6244430541992, -1.49442845148217, 218, 21, 'PPL', 'P'),
(81600, 'Hollow Creek', 34.0052795410156, 0.593504091051789, -81.4105606079102, -1.42088232850243, 218, 48, 'PPL', 'P'),
(48219, 'Hollow Estates', 39.4702796936035, 0.68888633733644, -77.5213928222656, -1.35300354548043, 218, 25, 'PPL', 'P'),
(22005, 'Hollow Hills', 33.5683288574219, 0.585877862954238, -83.7586135864258, -1.46186358398879, 218, 13, 'PPL', 'P'),
(22006, 'Hollow Oaks', 33.4769401550293, 0.584282829198362, -83.9138870239258, -1.46457361671405, 218, 13, 'PPL', 'P'),
(48225, 'Hollow Road Estates', 39.4605598449707, 0.688716693975002, -77.5102767944336, -1.35280953419502, 218, 25, 'PPL', 'P'),
(87897, 'Hollow Rock', 36.0380592346191, 0.628982789672852, -88.2736129760742, -1.54066518906369, 218, 50, 'PPL', 'P'),
(87898, 'Hollow Springs', 35.6730613708496, 0.622612375187328, -86.120002746582, -1.50307759975442, 218, 50, 'PPL', 'P'),
(94960, 'Hollow Tree Estates Colonia', 27.8540000915527, 0.486144011448397, -98.0019989013672, -1.71045755436472, 218, 51, 'PPL', 'P'),
(162772, 'Hollow Woods', 40.0366706848145, 0.698771724986705, -75.2591705322266, -1.31352031810725, 218, 45, 'PPL', 'P'),
(3196, 'Holloway', 34.8902816772461, 0.608950292216194, -87.5386123657227, -1.52783700840888, 218, 2, 'PPL', 'P'),
(41375, 'Holloway', 31.3902797698975, 0.547863735106879, -92.2297210693359, -1.6097123008559, 218, 22, 'PPL', 'P'),
(87899, 'Holloway', 36.1399993896484, 0.630761981018106, -86.3208312988281, -1.50658271922312, 218, 50, 'PPL', 'P'),
(131333, 'Holloway', 41.935001373291, 0.731903845792272, -83.914436340332, -1.46458320409397, 218, 27, 'PPL', 'P'),
(135999, 'Holloway', 45.2486114501953, 0.789737251761514, -95.9077835083008, -1.67390660050977, 218, 28, 'PPL', 'P'),
(155765, 'Holloway', 40.1622200012207, 0.700962973931622, -81.1327819824219, -1.41603417689599, 218, 41, 'PPL', 'P'),
(13970, 'Holloway Terrace', 39.7016716003418, 0.692924887971491, -75.5466690063477, -1.31853811307512, 218, 10, 'PPL', 'P'),
(120053, 'Hollowayville', 41.3650016784668, 0.721955474382226, -89.2969436645508, -1.5585256789143, 218, 18, 'PPL', 'P'),
(72933, 'Hollowtown', 39.1116714477539, 0.682627442721563, -83.7816696166992, -1.4622659876295, 218, 41, 'PPL', 'P'),
(149670, 'Hollowville', 42.2052803039551, 0.736621103031129, -73.6916732788086, -1.28616233001914, 218, 40, 'PPL', 'P'),
(162770, 'Hollsopple', 40.2125015258789, 0.701840552089831, -78.9291687011719, -1.37757386969751, 218, 45, 'PPL', 'P'),
(41376, 'Holly', 32.1372184753418, 0.560900274827467, -93.7013931274414, -1.63539782377944, 218, 22, 'PPL', 'P'),
(94961, 'Holly', 31.1297206878662, 0.543316121229459, -95.3369369506836, -1.66394344855567, 218, 51, 'PPL', 'P'),
(109691, 'Holly', 38.670280456543, 0.674923716636291, -80.5480575561523, -1.40582881044076, 218, 58, 'PPL', 'P'),
(131334, 'Holly', 42.7919387817383, 0.746860225053184, -83.6277770996094, -1.4595800565121, 218, 27, 'PPL', 'P'),
(186859, 'Holly', 38.0522193908691, 0.664136516061898, -102.122222900391, -1.78236902906737, 218, 7, 'PPL', 'P'),
(207670, 'Holly', 47.5577812194824, 0.830039867223092, -122.97721862793, -2.14635737000228, 218, 56, 'PPL', 'P'),
(87900, 'Holly (historical)', 35.6030616760254, 0.621390650037254, -86.1041717529297, -1.50280129679132, 218, 50, 'PPL', 'P'),
(102886, 'Holly (historical)', 37.3125, 0.651225977150384, -77.6263885498047, -1.35483606662652, 218, 53, 'PPL', 'P'),
(155762, 'Holly (historical)', 40.3802795410156, 0.704768830866427, -81.6888885498047, -1.42574006748879, 218, 41, 'PPL', 'P'),
(48221, 'Holly Acres', 38.4777793884277, 0.671563939184074, -76.7361068725586, -1.3392977200884, 218, 25, 'PPL', 'P'),
(65688, 'Holly Acres', 36.0036087036133, 0.628381514477739, -80.1791687011719, -1.39939048534743, 218, 33, 'PPL', 'P'),
(102891, 'Holly Acres', 37.2363891601563, 0.649897592398653, -77.4447174072266, -1.35166530703267, 218, 53, 'PPL', 'P'),
(102889, 'Holly Acres Mobile Home Park', 38.6533317565918, 0.67462790601821, -77.2525024414063, -1.3483105230075, 218, 53, 'PPL', 'P'),
(155763, 'Holly Addition', 41.4333305358887, 0.723148037918364, -84.5361099243164, -1.47543345500718, 218, 41, 'PPL', 'P'),
(48222, 'Holly Anna Acres', 39.0352783203125, 0.681294131121815, -76.5002822875977, -1.33518180462368, 218, 25, 'PPL', 'P'),
(41377, 'Holly Beach', 29.7705593109131, 0.519594280135688, -93.4591674804688, -1.63117018870699, 218, 22, 'PPL', 'P'),
(48223, 'Holly Beach', 39.2861099243164, 0.685671968479742, -76.3883285522461, -1.33322784333189, 218, 25, 'PPL', 'P'),
(94962, 'Holly Beach', 26.1347198486328, 0.456136910444957, -97.2911987304688, -1.69805175105881, 218, 51, 'PPL', 'P'),
(22007, 'Holly Bluff', 32.5730590820313, 0.568507128428087, -83.5813903808594, -1.45877045554071, 218, 13, 'PPL', 'P'),
(60291, 'Holly Bluff', 32.8213882446289, 0.572841289944137, -90.7088928222656, -1.58316884058719, 218, 30, 'PPL', 'P'),
(22008, 'Holly Brook', 33.6338882446289, 0.58702209011659, -84.579719543457, -1.47619458644672, 218, 13, 'PPL', 'P'),
(102890, 'Holly Brook', 37.1883316040039, 0.649058829813332, -80.9508285522461, -1.41285849045413, 218, 53, 'PPL', 'P'),
(48224, 'Holly Corner', 38.9524993896484, 0.679849366230447, -75.8411102294922, -1.32367708187259, 218, 25, 'PPL', 'P'),
(102892, 'Holly Corner', 38.3633308410645, 0.66956643520846, -77.5663909912109, -1.3537889116859, 218, 53, 'PPL', 'P'),
(102893, 'Holly Cove', 36.7986106872559, 0.642256916652188, -76.3994369506836, -1.33342172145925, 218, 53, 'PPL', 'P'),
(76116, 'Holly Creek', 33.9780616760254, 0.593029049692346, -94.8163909912109, -1.65485820765492, 218, 42, 'PPL', 'P'),
(87901, 'Holly Creek', 35.0863914489746, 0.612373053428191, -87.6025009155273, -1.5289520739573, 218, 50, 'PPL', 'P'),
(16476, 'Holly Ford', 30.4111099243164, 0.530773997365245, -81.6536102294922, -1.42512434464476, 218, 12, 'PPL', 'P'),
(13971, 'Holly Forest', 38.538890838623, 0.672630535200651, -75.1350021362305, -1.31135317077019, 218, 10, 'PPL', 'P'),
(102894, 'Holly Forks', 37.4680595397949, 0.653941003302693, -76.7838897705078, -1.34013168898375, 218, 53, 'PPL', 'P'),
(48259, 'Holly Gaf Acres', 38.3441696166992, 0.669232008754573, -76.595832824707, -1.33684947609829, 218, 25, 'PPL', 'P'),
(102911, 'Holly Glen Estates', 37.6699981689453, 0.657465497268331, -77.4591674804688, -1.3519175083879, 218, 53, 'PPL', 'P'),
(3197, 'Holly Grove', 33.8386116027832, 0.590595186772123, -87.4225006103516, -1.52581047597739, 218, 2, 'PPL', 'P'),
(9539, 'Holly Grove', 34.228328704834, 0.597397033354239, -94.2694396972656, -1.64531210672753, 218, 4, 'PPL', 'P'),
(41378, 'Holly Grove', 31.9277801513672, 0.557244886494251, -91.7033309936523, -1.6005250608854, 218, 22, 'PPL', 'P'),
(48226, 'Holly Grove', 38.332218170166, 0.669023416662193, -75.1558303833008, -1.31171669225899, 218, 25, 'PPL', 'P'),
(60292, 'Holly Grove', 33.410831451416, 0.583129014656085, -90.1699981689453, -1.57376335456535, 218, 30, 'PPL', 'P'),
(65690, 'Holly Grove', 36.5052795410156, 0.637137322351647, -76.5691680908203, -1.3363840886978, 218, 33, 'PPL', 'P'),
(87908, 'Holly Grove', 35.6563911437988, 0.622321424838236, -89.1288909912109, -1.55559260644774, 218, 50, 'PPL', 'P'),
(94963, 'Holly Grove', 30.5183296203613, 0.532645334084216, -94.7074966430664, -1.65295764274299, 218, 51, 'PPL', 'P'),
(102895, 'Holly Grove', 37.7955589294434, 0.65965694595033, -77.8147201538086, -1.35812307320195, 218, 53, 'PPL', 'P'),
(109692, 'Holly Grove', 38.8019409179688, 0.677221625182866, -80.2897186279297, -1.4013199455572, 218, 58, 'PPL', 'P'),
(48228, 'Holly Harbor', 38.6722183227539, 0.674957538782135, -76.1416702270508, -1.32892284342977, 218, 25, 'PPL', 'P'),
(48231, 'Holly Haven', 38.3138885498047, 0.668703504436247, -76.5041732788086, -1.33524971523148, 218, 25, 'PPL', 'P'),
(78477, 'Holly Heights', 39.9613914489746, 0.697457854462915, -76.7683334350586, -1.33986017971062, 218, 45, 'PPL', 'P'),
(87904, 'Holly Heights', 35.2863883972168, 0.615863658668958, -85.1458282470703, -1.48607504724897, 218, 50, 'PPL', 'P'),
(13972, 'Holly Hill', 38.8400001525879, 0.677885884137759, -75.4297180175781, -1.31649693325763, 218, 10, 'PPL', 'P'),
(16471, 'Holly Hill', 29.2433300018311, 0.510392392779191, -81.0377807617188, -1.41437609280131, 218, 12, 'PPL', 'P'),
(22011, 'Holly Hill', 33.0852813720703, 0.577447093891374, -85.0513916015625, -1.48442681685032, 218, 13, 'PPL', 'P'),
(48235, 'Holly Hill', 38.6661109924316, 0.674850945759504, -76.9875030517578, -1.34368541114236, 218, 25, 'PPL', 'P'),
(65692, 'Holly Hill', 35.3441696166992, 0.616872131194744, -82.4966735839844, -1.43983857598356, 218, 33, 'PPL', 'P'),
(81603, 'Holly Hill', 33.3224983215332, 0.581587310701038, -80.4138870239258, -1.40348709289425, 218, 48, 'PPL', 'P'),
(162771, 'Holly Hill', 40.1624984741211, 0.700967834200612, -74.8391723632813, -1.3061899672068, 218, 45, 'PPL', 'P'),
(48236, 'Holly Hill Estates', 38.9272193908691, 0.679408147016848, -75.8555603027344, -1.32392928322782, 218, 25, 'PPL', 'P'),
(48237, 'Holly Hill Harbor', 38.9008293151855, 0.678947553306319, -76.5244369506836, -1.33560338302424, 218, 25, 'PPL', 'P'),
(81605, 'Holly Hill Heights', 34.9652786254883, 0.610259235891968, -82.1458282470703, -1.43371516968914, 218, 48, 'PPL', 'P'),
(3198, 'Holly Hills', 30.7827796936035, 0.537260858569433, -87.7797164916992, -1.53204506924732, 218, 2, 'PPL', 'P'),
(22013, 'Holly Hills', 32.5777816772461, 0.568589553263825, -82.9466705322266, -1.44769250435431, 218, 13, 'PPL', 'P'),
(60293, 'Holly Hills', 34.9674987792969, 0.610297984885828, -90.091667175293, -1.57239622081976, 218, 30, 'PPL', 'P'),
(65693, 'Holly Hills', 35.0800018310547, 0.612261533557544, -77.1122207641602, -1.34586214585933, 218, 33, 'PPL', 'P'),
(87907, 'Holly Hills', 36.1805610656738, 0.631469915814877, -83.2813873291016, -1.45353441452151, 218, 50, 'PPL', 'P'),
(102897, 'Holly Hills', 37.1752815246582, 0.648831062961103, -76.4552764892578, -1.33439630526016, 218, 53, 'PPL', 'P'),
(109693, 'Holly Hills Estates', 38.2986106872559, 0.668436855432103, -80.829719543457, -1.41074473949693, 218, 58, 'PPL', 'P'),
(102899, 'Holly Homes', 37.0494384765625, 0.646634687431088, -76.3163909912109, -1.33197229603597, 218, 53, 'PPL', 'P'),
(48238, 'Holly House', 39.1513900756836, 0.683320663553311, -76.9452819824219, -1.34294851446873, 218, 25, 'PPL', 'P'),
(9540, 'Holly Island Community', 36.2591705322266, 0.632841909829458, -90.1580581665039, -1.57355496221006, 218, 4, 'PPL', 'P'),
(13974, 'Holly Knoll', 39.788330078125, 0.694437363733574, -75.7041702270508, -1.3212870279523, 218, 10, 'PPL', 'P'),
(48239, 'Holly Knoll Estates', 39.4858283996582, 0.689157713451519, -76.5316696166992, -1.33572961685991, 218, 25, 'PPL', 'P'),
(13975, 'Holly Lake Mobile Home Park', 38.7777786254883, 0.676799913624252, -75.3194427490234, -1.31457226673783, 218, 10, 'PPL', 'P'),
(48240, 'Holly Landing', 38.8305587768555, 0.67772110104531, -76.5477828979492, -1.33601084667102, 218, 25, 'PPL', 'P'),
(60295, 'Holly Landing', 30.7147197723389, 0.536072988854716, -88.7111129760742, -1.54830100454116, 218, 30, 'PPL', 'P'),
(87911, 'Holly Leaf', 36.0483283996582, 0.629162020414214, -88.6966705322266, -1.54804893634398, 218, 50, 'PPL', 'P'),
(13976, 'Holly Leaf Estates Mobile Home Park', 38.6538887023926, 0.674637626556189, -75.2600021362305, -1.31353483233519, 218, 10, 'PPL', 'P'),
(109694, 'Holly Meadows', 39.1341705322266, 0.683020125824295, -79.6813888549805, -1.39070258808132, 218, 58, 'PPL', 'P'),
(13977, 'Holly Oak', 39.788330078125, 0.694437363733574, -75.4791717529297, -1.31736006376692, 218, 10, 'PPL', 'P'),
(13978, 'Holly Oak Mobile Home Park', 38.4655609130859, 0.671350686559786, -75.5744400024414, -1.31902280839351, 218, 10, 'PPL', 'P'),
(13979, 'Holly Oak Terrace', 39.7833290100098, 0.694350078628847, -75.4888916015625, -1.31752970712836, 218, 10, 'PPL', 'P'),
(22015, 'Holly Oaks', 34.0283317565918, 0.593906428113473, -84.4691696166992, -1.47426512623696, 218, 13, 'PPL', 'P'),
(48243, 'Holly Oaks', 38.7194404602051, 0.675781720560487, -76.057502746582, -1.32745384377249, 218, 25, 'PPL', 'P'),
(65699, 'Holly Park', 35.6972198486328, 0.623034020166914, -80.5202789306641, -1.40534398196431, 218, 33, 'PPL', 'P'),
(70965, 'Holly Park', 39.8952789306641, 0.69630397334161, -74.1433334350586, -1.29404528684577, 218, 37, 'PPL', 'P'),
(102900, 'Holly Park', 38.836109161377, 0.677817973529962, -77.2850036621094, -1.34887777631968, 218, 53, 'PPL', 'P'),
(207667, 'Holly Park', 47.5419387817383, 0.829763364522915, -122.290557861328, -2.13437287878081, 218, 56, 'PPL', 'P'),
(102901, 'Holly Park Estates', 38.8394393920898, 0.677876097020753, -77.2847213745117, -1.34887284947167, 218, 53, 'PPL', 'P'),
(13980, 'Holly Pines Mobile Home Park', 38.7247200012207, 0.675873865934204, -75.1816711425781, -1.3121676985896, 218, 10, 'PPL', 'P'),
(16472, 'Holly Point', 30.1552791595459, 0.526308908192104, -81.6961135864258, -1.4258661681664, 218, 12, 'PPL', 'P'),
(48244, 'Holly Point', 39.0736083984375, 0.681963117187643, -76.5791702270508, -1.33655865890725, 218, 25, 'PPL', 'P'),
(102902, 'Holly Point', 37.0752792358398, 0.647085693761693, -76.6680603027344, -1.33811008340028, 218, 53, 'PPL', 'P'),
(3199, 'Holly Pond', 34.1741714477539, 0.596451810904343, -86.6163864135742, -1.51174112909655, 218, 2, 'PPL', 'P'),
(13981, 'Holly Ridge', 38.5699996948242, 0.673173487167891, -75.0852813720703, -1.31048537972899, 218, 10, 'PPL', 'P'),
(41382, 'Holly Ridge', 31.8955593109131, 0.556682526740567, -91.4716720581055, -1.59648184971844, 218, 22, 'PPL', 'P'),
(60296, 'Holly Ridge', 33.4455604553223, 0.583735150120187, -90.7533264160156, -1.58394435309662, 218, 30, 'PPL', 'P'),
(65700, 'Holly Ridge', 34.4952812194824, 0.602056233681333, -77.5552825927734, -1.35359503355854, 218, 33, 'PPL', 'P'),
(81606, 'Holly Ridge', 33.0469398498535, 0.576777908088464, -80.4397201538086, -1.4039379660668, 218, 48, 'PPL', 'P'),
(102904, 'Holly Ridge', 37.1963882446289, 0.649199444718888, -80.0633316040039, -1.3973687466059, 218, 53, 'PPL', 'P'),
(22016, 'Holly Spring', 34.2347183227539, 0.597508553224886, -84.7383270263672, -1.4789628092418, 218, 13, 'PPL', 'P'),
(65701, 'Holly Spring', 36.2511100769043, 0.632701228344875, -80.5805587768555, -1.40639606375294, 218, 33, 'PPL', 'P'),
(3201, 'Holly Springs', 33.6522216796875, 0.587342068921563, -85.7513885498047, -1.49664406835106, 218, 2, 'PPL', 'P'),
(9545, 'Holly Springs', 35.3536109924316, 0.617036914287192, -91.7438888549805, -1.60123292910314, 218, 4, 'PPL', 'P'),
(22018, 'Holly Springs', 34.2350006103516, 0.597513480072903, -83.6383285522461, -1.45976421410148, 218, 13, 'PPL', 'P'),
(41383, 'Holly Springs', 32.7077789306641, 0.570858433354518, -93.168327331543, -1.62609407051125, 218, 22, 'PPL', 'P'),
(60299, 'Holly Springs', 34.7675018310547, 0.606807379645062, -89.4486083984375, -1.56117272787979, 218, 30, 'PPL', 'P'),
(65705, 'Holly Springs', 35.6511116027832, 0.62222927946452, -78.8338928222656, -1.37591099191286, 218, 33, 'PPL', 'P'),
(81610, 'Holly Springs', 35.0041694641113, 0.610938009074802, -82.1763916015625, -1.43424860085548, 218, 48, 'PPL', 'P'),
(87910, 'Holly Springs', 36.4188919067383, 0.635629573700499, -85.3997192382813, -1.49050628098675, 218, 50, 'PPL', 'P'),
(94967, 'Holly Springs', 32.434440612793, 0.566087779735805, -95.7761077880859, -1.67160842564708, 218, 51, 'PPL', 'P'),
(116061, 'Holly Springs', 42.2705612182617, 0.737760469924492, -96.0774993896484, -1.67686870143221, 218, 16, 'PPL', 'P'),
(48245, 'Holly Station', 38.6441688537598, 0.674467983194751, -76.8994369506836, -1.34214836771922, 218, 25, 'PPL', 'P'),
(81611, 'Holly Tree', 34.9097213745117, 0.60928957893907, -82.0961074829102, -1.43284737864794, 218, 48, 'PPL', 'P'),
(48246, 'Holly Tree Estates', 39.0566711425781, 0.681667506306644, -76.9141693115234, -1.34240549592246, 218, 25, 'PPL', 'P'),
(48247, 'Holly Tree Park', 38.6463890075684, 0.674506732188612, -76.8983306884766, -1.34212905980131, 218, 25, 'PPL', 'P'),
(65708, 'Holly View Forest-Highland Park', 36.4644393920898, 0.636424527285887, -80.6466674804688, -1.40754987829522, 218, 33, 'PPL', 'P'),
(125097, 'Holly Woods', 41.6588897705078, 0.727084789220746, -70.7588882446289, -1.23497557491949, 218, 23, 'PPL', 'P'),
(22020, 'Hollyberry', 33.8427810668945, 0.590667957648909, -84.8680572509766, -1.48122702880059, 218, 13, 'PPL', 'P'),
(48248, 'Hollyberry Woods', 39.047779083252, 0.68151231059412, -76.477783203125, -1.33478912152095, 218, 25, 'PPL', 'P'),
(81612, 'Hollyberry Woods', 35.107780456543, 0.612746362033993, -81.0597229003906, -1.41475905536606, 218, 48, 'PPL', 'P'),
(41384, 'Hollybrook', 32.7350006103516, 0.571333541292988, -91.1797180175781, -1.59138629044674, 218, 22, 'PPL', 'P'),
(102905, 'Hollybrook', 37.2438888549805, 0.65002848676623, -76.7455596923828, -1.33946270291793, 218, 53, 'PPL', 'P'),
(13982, 'Hollybrook Apartments', 38.5688896179199, 0.67315411267096, -75.570556640625, -1.31895503094377, 218, 10, 'PPL', 'P'),
(36472, 'Hollybush', 37.3375015258789, 0.651662336094994, -82.851936340332, -1.44603908079154, 218, 21, 'PPL', 'P'),
(22021, 'Hollydale', 33.5825004577637, 0.586125204040479, -84.4574966430664, -1.47406139441357, 218, 13, 'PPL', 'P'),
(182179, 'Hollydale', 38.5052795410156, 0.672043907391534, -122.918891906738, -2.14533937667559, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(109695, 'Hollygrove', 38.1902809143066, 0.666546144216201, -81.396110534668, -1.4206301271472, 218, 58, 'PPL', 'P'),
(36473, 'Hollyhill', 36.6630592346191, 0.639891097497816, -84.3302764892578, -1.47184098385471, 218, 21, 'PPL', 'P'),
(196732, 'Hollyhock Trailer Court', 46.7511100769043, 0.815960799804279, -114.097221374512, -1.99137218036208, 218, 31, 'PPL', 'P'),
(109697, 'Hollyhurst', 38.2347183227539, 0.66732172330466, -81.7752838134766, -1.42724794929799, 218, 58, 'PPL', 'P'),
(60304, 'Hollyknowe', 33.4013900756836, 0.582964231563637, -90.8302764892578, -1.58528738523434, 218, 30, 'PPL', 'P'),
(48249, 'Hollylake Estates', 38.4277801513672, 0.670691287873882, -75.5616683959961, -1.31879990181027, 218, 25, 'PPL', 'P'),
(102906, 'Hollymead', 38.1169395446777, 0.665266095838255, -78.4419403076172, -1.36907013002077, 218, 53, 'PPL', 'P'),
(13983, 'Hollymount', 38.6752815246582, 0.675011001741018, -75.2219390869141, -1.31287050680127, 218, 10, 'PPL', 'P'),
(65710, 'Hollyoak Apartments', 35.2666702270508, 0.615519511677092, -81.5313873291016, -1.42299115261161, 218, 33, 'PPL', 'P'),
(102907, 'Hollys Mill', 36.7825012207031, 0.641975753420103, -79.5955581665039, -1.38920455996815, 218, 53, 'PPL', 'P'),
(3202, 'Hollytree', 34.7988891601563, 0.607355191881291, -86.2533264160156, -1.50540453675687, 218, 2, 'PPL', 'P'),
(36474, 'Hollyvilla', 38.0936088562012, 0.664858898507582, -85.7455596923828, -1.49654233559742, 218, 21, 'PPL', 'P'),
(13984, 'Hollyville', 38.6716690063477, 0.674947951402211, -75.2425003051758, -1.31322936775816, 218, 10, 'PPL', 'P'),
(65711, 'Hollyville', 35.1911087036133, 0.614200714305285, -76.6855621337891, -1.33841554797731, 218, 33, 'PPL', 'P'),
(13985, 'Hollyville Acres', 38.6883316040039, 0.675238768593247, -75.2302780151367, -1.31301604855484, 218, 10, 'PPL', 'P'),
(3204, 'Hollywood', 33.4727783203125, 0.58421019147963, -86.7830581665039, -1.51465009995525, 218, 2, 'PPL', 'P'),
(9548, 'Hollywood', 34.103889465332, 0.595225158906252, -93.2466735839844, -1.62746147057295, 218, 4, 'PPL', 'P'),
(16473, 'Hollywood', 26.0108299255371, 0.453974623376894, -80.1497192382813, -1.39887649525705, 218, 12, 'PPL', 'P'),
(22022, 'Hollywood', 34.6494407653809, 0.60474682533064, -83.4475021362305, -1.45643366484222, 218, 13, 'PPL', 'P'),
(36476, 'Hollywood', 38.0277786254883, 0.663709944234294, -84.4936065673828, -1.47469163148553, 218, 21, 'PPL', 'P'),
(41388, 'Hollywood', 30.9497203826904, 0.540174523249547, -91.4088897705078, -1.59538609208793, 218, 22, 'PPL', 'P'),
(48253, 'Hollywood', 38.3241691589355, 0.668882934914691, -75.5516662597656, -1.31862533160082, 218, 25, 'PPL', 'P'),
(55349, 'Hollywood', 36.0541687011719, 0.629263952904937, -90.1861114501953, -1.57404458437647, 218, 29, 'PPL', 'P'),
(60300, 'Hollywood', 34.7452812194824, 0.606419556811319, -90.3580627441406, -1.57704570060888, 218, 30, 'PPL', 'P'),
(65712, 'Hollywood', 34.7350006103516, 0.606240126332875, -76.8030624389648, -1.34046631517472, 218, 33, 'PPL', 'P'),
(81613, 'Hollywood', 32.7341690063477, 0.571319027065047, -80.241943359375, -1.40048610981989, 218, 48, 'PPL', 'P'),
(87913, 'Hollywood', 35.1744384765625, 0.613909763956194, -89.9752807617188, -1.5703648946983, 218, 50, 'PPL', 'P'),
(102910, 'Hollywood', 36.8605613708496, 0.64333816005476, -76.1805572509766, -1.32960155003358, 218, 53, 'PPL', 'P'),
(109696, 'Hollywood', 37.6122207641602, 0.656457091321572, -80.4441680908203, -1.40401559721258, 218, 58, 'PPL', 'P'),
(131337, 'Hollywood', 42.0144386291504, 0.733290287455767, -86.4558334350586, -1.50893895099757, 218, 27, 'PPL', 'P'),
(135984, 'Hollywood', 44.9058303833008, 0.783754593530706, -93.9711074829102, -1.64010522732226, 218, 28, 'PPL', 'P'),
(162775, 'Hollywood', 40.0897216796875, 0.699697639518698, -75.0938873291016, -1.31063558201447, 218, 45, 'PPL', 'P'),
(178380, 'Hollywood', 32.8294410705566, 0.572981838270665, -109.682777404785, -1.91432559844554, 218, 5, 'PPL', 'P'),
(186860, 'Hollywood', 38.7094383239746, 0.675607150351032, -105.132781982422, -1.83491319737463, 218, 7, 'PPL', 'P'),
(188694, 'Hollywood', 33.3233299255371, 0.581601824928979, -105.634437561035, -1.84366873893243, 218, 38, 'PPL', 'P'),
(195104, 'Hollywood', 46.5552787780762, 0.812542898861272, -115.835563659668, -2.0217119767647, 218, 17, 'PPL', 'P'),
(200990, 'Hollywood', 45.5355606079102, 0.794745459349463, -122.621109008789, -2.14014208465025, 218, 43, 'PPL', 'P'),
(207668, 'Hollywood', 47.7311096191406, 0.833065018484341, -122.128059387207, -2.13153674537793, 218, 56, 'PPL', 'P'),
(16474, 'Hollywood Beach', 30.2538890838623, 0.528029976046568, -85.9569396972656, -1.5002316126555, 218, 12, 'PPL', 'P'),
(48254, 'Hollywood Beach', 39.5022201538086, 0.689443803531621, -75.908332824707, -1.32485033749083, 218, 25, 'PPL', 'P'),
(182181, 'Hollywood Beach', 34.1672210693359, 0.59633050391669, -119.229721069336, -2.08095119889437, 218, 6, 'PPL', 'P'),
(207669, 'Hollywood Beach', 47.9277801513672, 0.836497566813344, -120.211387634277, -2.09808451260934, 218, 56, 'PPL', 'P'),
(385, 'Hollywood Beach Gardens', 26.0136108398438, 0.454023159487761, -80.2038879394531, -1.39982191744403, 218, 12, 'PPL', 'P'),
(72935, 'Hollywood by the Lake', 39.9277801513672, 0.696871226653797, -82.5111083984375, -1.44009051102268, 218, 41, 'PPL', 'P'),
(182183, 'Hollywood by the Sea', 34.1605606079102, 0.596214256935108, -119.224998474121, -2.08086877405863, 218, 6, 'PPL', 'P'),
(65714, 'Hollywood Crossroads', 35.5313911437988, 0.620139763273243, -77.3208312988281, -1.34950308654363, 218, 33, 'PPL', 'P'),
(72934, 'Hollywood Estates', 39.211669921875, 0.684372745341946, -84.5355606079102, -1.47542386762725, 218, 41, 'PPL', 'P'),
(27458, 'Hollywood Heights', 38.6324996948242, 0.674264317950387, -89.9963912963867, -1.57073334303512, 218, 18, 'PPL', 'P'),
(78478, 'Hollywood Heights', 39.9491691589355, 0.697244535259599, -76.6888885498047, -1.33847360488907, 218, 45, 'PPL', 'P'),
(207671, 'Hollywood Hill', 47.7374992370605, 0.833176538354988, -122.126106262207, -2.13150265691598, 218, 56, 'PPL', 'P'),
(81616, 'Hollywood Hills', 34.0794410705566, 0.594798453920594, -81.0188903808594, -1.41404639345836, 218, 48, 'PPL', 'P'),
(48255, 'Hollywood Park', 39.0661087036133, 0.681832222820065, -76.9958267211914, -1.34383068657982, 218, 25, 'PPL', 'P'),
(94968, 'Hollywood Park', 29.6002807617188, 0.516622358806727, -98.4869384765625, -1.7189213466251, 218, 51, 'PPL', 'P'),
(81617, 'Hollywood Point', 34.061939239502, 0.594492989343562, -81.2358322143555, -1.41783274273818, 218, 48, 'PPL', 'P'),
(16475, 'Hollywood Ridge Farms', 25.9750003814697, 0.45334927986343, -80.1944427490234, -1.39965706777255, 218, 12, 'PPL', 'P'),
(182182, 'Hollywood Riviera', 33.8141708374023, 0.590168614944519, -118.382217407227, -2.06615946956785, 218, 6, 'PPL', 'P'),
(48256, 'Hollywood Shores', 38.3913917541504, 0.670056190532926, -76.5800018310547, -1.33657317313519, 218, 25, 'PPL', 'P'),
(196733, 'Hollywood Trailer Court', 46.8847198486328, 0.81829273023378, -114.017219543457, -1.98997588500255, 218, 31, 'PPL', 'P'),
(13986, 'Hollywoods Park', 38.5436096191406, 0.672712893457362, -75.584716796875, -1.31920217229293, 218, 10, 'PPL', 'P'),
(113569, 'Hollywyle Park', 41.4638900756836, 0.723681402505679, -73.459716796875, -1.28211392568805, 218, 8, 'PPL', 'P'),
(328, 'Holman', 35.4844398498535, 0.619320308605826, -93.3108291625977, -1.62858119665327, 218, 4, 'PPL', 'P'),
(3206, 'Holman', 33.2797203063965, 0.580840693489435, -87.8233337402344, -1.53280633384492, 218, 2, 'PPL', 'P'),
(55350, 'Holman', 37.2730598449707, 0.650537616587626, -93.0530624389648, -1.6240823186238, 218, 29, 'PPL', 'P'),
(94969, 'Holman', 29.7961101531982, 0.520040226460221, -96.7961120605469, -1.68941085858594, 218, 51, 'PPL', 'P'),
(109698, 'Holman', 39.7158317565918, 0.69317202932065, -80.1025009155273, -1.39805238005772, 218, 58, 'PPL', 'P'),
(135986, 'Holman', 47.310001373291, 0.825715293086967, -93.3713912963867, -1.62963820528992, 218, 28, 'PPL', 'P'),
(188695, 'Holman', 36.038330078125, 0.628987516783787, -105.383056640625, -1.83928131419458, 218, 38, 'PPL', 'P'),
(207672, 'Holman', 46.3266716003418, 0.808552950916115, -124.053611755371, -2.16514397412197, 218, 56, 'PPL', 'P'),
(3207, 'Holman Crossroads', 33.1041717529297, 0.577776793234326, -86.192497253418, -1.50434286758831, 218, 2, 'PPL', 'P'),
(48257, 'Holman Manor', 39.4494400024414, 0.688522616110562, -76.3013916015625, -1.33171050730081, 218, 25, 'PPL', 'P'),
(145453, 'Holmansville', 40.100830078125, 0.699891517646056, -74.3183288574219, -1.29709953314193, 218, 37, 'PPL', 'P'),
(87915, 'Holmansville (historical)', 36.5186080932617, 0.637369949472865, -87.079719543457, -1.51982781774658, 218, 50, 'PPL', 'P'),
(145454, 'Holmdel', 40.3450012207031, 0.704153108022401, -74.184440612793, -1.29476274244344, 218, 37, 'PPL', 'P'),
(162776, 'Holme Circle', 40.0561103820801, 0.699111011709581, -75.0286102294922, -1.30949628170014, 218, 45, 'PPL', 'P'),
(48258, 'Holmehurst', 38.9558296203613, 0.679907489721238, -76.79638671875, -1.34034980187703, 218, 25, 'PPL', 'P'),
(174555, 'Holmen', 43.9633293151855, 0.767304846688532, -91.2561111450195, -1.59271960204648, 218, 57, 'PPL', 'P'),
(36475, 'Holmes', 37.2075004577637, 0.649393389425273, -85.2697219848633, -1.48823740089606, 218, 21, 'PPL', 'P'),
(78479, 'Holmes', 39.9041709899902, 0.696459169054135, -75.3088912963867, -1.31438810914845, 218, 45, 'PPL', 'P'),
(87914, 'Holmes', 36.3022193908691, 0.633593254151997, -82.4463882446289, -1.43896093124632, 218, 50, 'PPL', 'P'),
(116062, 'Holmes', 42.7391700744629, 0.745939237369208, -93.833610534668, -1.63770545286399, 218, 16, 'PPL', 'P'),
(120054, 'Holmes', 40.3836097717285, 0.704826954357218, -89.5852813720703, -1.56355812126817, 218, 18, 'PPL', 'P'),
(140238, 'Holmes', 47.7158317565918, 0.832798369480196, -97.29638671875, -1.69814229853587, 218, 34, 'PPL', 'P'),
(149671, 'Holmes', 41.5233306884766, 0.72471883690832, -73.647216796875, -1.28538641803554, 218, 40, 'PPL', 'P'),
(193644, 'Holmes', 40.4186096191406, 0.705437816932255, -123.939437866211, -2.16315126383632, 218, 6, 'PPL', 'P'),
(207673, 'Holmes', 46.9583282470703, 0.819577439143634, -120.52889251709, -2.10362601820557, 218, 56, 'PPL', 'P'),
(16478, 'Holmes Beach', 27.4950008392334, 0.479878292483227, -82.7111129760742, -1.4435812494215, 218, 12, 'PPL', 'P'),
(135987, 'Holmes City', 45.833610534668, 0.799947411906715, -95.5408325195313, -1.66750209756229, 218, 28, 'PPL', 'P'),
(27459, 'Holmes Corner', 37.3252792358398, 0.651449016891678, -88.6336135864258, -1.54694838502351, 218, 18, 'PPL', 'P'),
(36477, 'Holmes Mill', 36.8683280944824, 0.643473714954245, -83.0025024414063, -1.44866695499717, 218, 21, 'PPL', 'P'),
(127768, 'Holmes Mill', 44.4447212219238, 0.775706720453568, -69.0616683959961, -1.20535350043064, 218, 26, 'PPL', 'P'),
(55351, 'Holmes Park', 38.9524993896484, 0.679849366230447, -94.5355606079102, -1.64995679282668, 218, 29, 'PPL', 'P'),
(55352, 'Holmes Place', 36.5386085510254, 0.637719023312748, -90.1933288574219, -1.57417055189603, 218, 29, 'PPL', 'P'),
(102914, 'Holmes Run Acres', 38.8527793884277, 0.678108923879053, -77.2091674804688, -1.34755418525791, 218, 53, 'PPL', 'P'),
(102912, 'Holmes Run Heights', 38.8480606079102, 0.678026565622342, -77.2125015258789, -1.34761237532773, 218, 53, 'PPL', 'P'),
(102913, 'Holmes Run Park', 38.8488883972168, 0.678041013271256, -77.1744384765625, -1.34694804979381, 218, 53, 'PPL', 'P'),
(16479, 'Holmes Valley', 30.5766696929932, 0.533663560437494, -85.7430572509766, -1.49649865975554, 218, 12, 'PPL', 'P'),
(162777, 'Holmesburg', 40.041389465332, 0.698854083243416, -75.0283279418945, -1.30949135485212, 218, 45, 'PPL', 'P'),
(145456, 'Holmeson', 40.1655616760254, 0.701021297159495, -74.4172210693359, -1.29882552784441, 218, 37, 'PPL', 'P'),
(22024, 'Holmesville', 31.7036094665527, 0.553332369957788, -82.3208312988281, -1.43676954914335, 218, 13, 'PPL', 'P'),
(41391, 'Holmesville', 32.6930618286133, 0.57060157146738, -92.3963928222656, -1.61262127171459, 218, 22, 'PPL', 'P'),
(60302, 'Holmesville', 31.2033290863037, 0.544600830139314, -90.3086090087891, -1.57618257009958, 218, 30, 'PPL', 'P'),
(65716, 'Holmesville', 34.3600006103516, 0.599695141637896, -79.1430587768555, -1.38130695575552, 218, 33, 'PPL', 'P'),
(122825, 'Holmesville', 41.5997200012207, 0.726052081929041, -86.8811111450195, -1.51636144727173, 218, 19, 'PPL', 'P'),
(142071, 'Holmesville', 40.2008285522461, 0.70163682026644, -96.6575012207031, -1.68699164305171, 218, 35, 'PPL', 'P'),
(149672, 'Holmesville', 42.5127792358398, 0.741987971838884, -75.4016723632813, -1.31600744424927, 218, 40, 'PPL', 'P'),
(155768, 'Holmesville', 40.6294403076172, 0.709117506610418, -81.9244384765625, -1.42985118926354, 218, 41, 'PPL', 'P'),
(155769, 'Holmesville (historical)', 40.542781829834, 0.707605030848334, -83.3597183227539, -1.4549015482671, 218, 41, 'PPL', 'P'),
(102917, 'Holmhead', 37.7733306884766, 0.659268989958533, -78.2091674804688, -1.36500747777786, 218, 53, 'PPL', 'P'),
(170540, 'Holmquist', 45.3394393920898, 0.791322498400384, -97.6527786254883, -1.70436251073591, 218, 49, 'PPL', 'P'),
(162778, 'Holmstead Manor', 40.3116683959961, 0.703571340482273, -76.8222198486328, -1.34080067504958, 218, 45, 'PPL', 'P'),
(41392, 'Holmwood', 30.1258296966553, 0.525794918101719, -93.079719543457, -1.62454757286624, 218, 22, 'PPL', 'P'),
(16480, 'Holopaw', 28.1355590820313, 0.491058142870839, -81.0763931274414, -1.41505000571516, 218, 12, 'PPL', 'P'),
(94970, 'Holshouser Number 1 Colonia', 27.7390003204346, 0.484136886803345, -98.0920028686523, -1.71202841993371, 218, 51, 'PPL', 'P'),
(94971, 'Holshouser Number 2 Colonia', 27.7390003204346, 0.484136886803345, -98.0899963378906, -1.71199339936537, 218, 51, 'PPL', 'P'),
(94972, 'Holshouser Number 3 Colonia', 27.738000869751, 0.484119443098205, -98.0920028686523, -1.71202841993371, 218, 51, 'PPL', 'P'),
(109699, 'Holstead (historical)', 38.5694389343262, 0.673163700050885, -80.6277770996094, -1.40722017895227, 218, 58, 'PPL', 'P'),
(55353, 'Holstein', 38.6552810668945, 0.674661927901136, -91.1711120605469, -1.59123608816125, 218, 29, 'PPL', 'P'),
(116063, 'Holstein', 42.4891700744629, 0.741575914239222, -95.5447235107422, -1.66757000817009, 218, 16, 'PPL', 'P'),
(142072, 'Holstein', 40.4652786254883, 0.706252344751656, -98.6516723632813, -1.72179649533795, 218, 35, 'PPL', 'P'),
(87916, 'Holston', 36.4858283996582, 0.636797835891689, -82.399169921875, -1.438136816047, 218, 50, 'PPL', 'P'),
(102915, 'Holston', 36.7772216796875, 0.641883608046386, -82.0830612182617, -1.43261967837473, 218, 53, 'PPL', 'P'),
(87917, 'Holston (historical)', 36.2686080932617, 0.63300662634288, -83.2847213745117, -1.45359260459133, 218, 50, 'PPL', 'P'),
(81618, 'Holston Crossroads', 33.9261093139648, 0.592122309920201, -81.5888900756836, -1.4239947648684, 218, 48, 'PPL', 'P'),
(87918, 'Holston Heights', 36.5424995422363, 0.637786933920545, -82.5644378662109, -1.44102128582366, 218, 50, 'PPL', 'P'),
(87922, 'Holston Hills', 36.5791702270508, 0.638426958109518, -82.1938934326172, -1.43455406543251, 218, 50, 'PPL', 'P'),
(102916, 'Holston Mill', 36.7691688537598, 0.641743059719857, -81.5933303833008, -1.42407226285613, 218, 53, 'PPL', 'P'),
(87923, 'Holston Valley', 36.565559387207, 0.638189404140283, -82.0697174072266, -1.43238678493741, 218, 50, 'PPL', 'P'),
(87924, 'Holston View', 36.5263900756836, 0.637505770688459, -82.1719436645508, -1.43417096970971, 218, 50, 'PPL', 'P'),
(3208, 'Holt', 33.2338905334473, 0.58004081305603, -87.4844436645508, -1.5268915862219, 218, 2, 'PPL', 'P'),
(16481, 'Holt', 30.7155609130859, 0.536087669530225, -86.7458267211914, -1.51400028864927, 218, 12, 'PPL', 'P'),
(22038, 'Holt', 31.5038890838623, 0.549846591696497, -84.45361328125, -1.47399361696382, 218, 13, 'PPL', 'P'),
(36480, 'Holt', 37.910831451416, 0.66166883099583, -86.5811080932617, -1.51112540625253, 218, 21, 'PPL', 'P'),
(55354, 'Holt', 39.4527816772461, 0.688580939338435, -94.3419418334961, -1.64657750771948, 218, 29, 'PPL', 'P'),
(87925, 'Holt', 35.0486106872559, 0.611713654742287, -87.8180618286133, -1.53271432162925, 218, 50, 'PPL', 'P'),
(116064, 'Holt', 40.8944396972656, 0.713742618475558, -94.7380599975586, -1.65349107390933, 218, 16, 'PPL', 'P'),
(131339, 'Holt', 42.6405601501465, 0.744218169514744, -84.5152816772461, -1.47506993351838, 218, 27, 'PPL', 'P'),
(135991, 'Holt', 48.2919387817383, 0.842853333912872, -96.1922225952148, -1.67887099909778, 218, 28, 'PPL', 'P'),
(155770, 'Holt', 40.5122184753418, 0.707071599681992, -80.7519378662109, -1.40938719313127, 218, 41, 'PPL', 'P'),
(162779, 'Holt', 40.6227798461914, 0.709001259628836, -80.3697204589844, -1.40271624091673, 218, 45, 'PPL', 'P'),
(174556, 'Holt', 44.7174987792969, 0.780467586955276, -89.3252792358398, -1.55902022792873, 218, 57, 'PPL', 'P'),
(182187, 'Holt', 37.934440612793, 0.662080888595493, -121.426109313965, -2.11928540541524, 218, 6, 'PPL', 'P'),
(191615, 'Holt', 36.0222206115723, 0.628706353551701, -101.229721069336, -1.76679193353539, 218, 51, 'PPL', 'P'),
(196734, 'Holt', 48.082218170166, 0.83919301873164, -114.10888671875, -1.99157577902742, 218, 31, 'PPL', 'P'),
(209903, 'Holt', 41.6761093139648, 0.727385326949762, -111.847221374512, -1.95210227219221, 218, 52, 'PPL', 'P'),
(9550, 'Holt (historical)', 35.6186103820801, 0.621662026152333, -90.0005569458008, -1.57080604733288, 218, 4, 'PPL', 'P'),
(60303, 'Holt (historical)', 32.0272216796875, 0.558980468576656, -89.1288909912109, -1.55559260644774, 218, 30, 'PPL', 'P'),
(48260, 'Holt Manor', 38.6991691589355, 0.67542791960967, -76.8488922119141, -1.34126619560813, 218, 25, 'PPL', 'P'),
(48261, 'Holter', 39.398609161377, 0.68763545057243, -77.5138931274414, -1.35287265111286, 218, 25, 'PPL', 'P'),
(196735, 'Holtet Court', 46.0222206115723, 0.803239278751134, -114.173057556152, -1.99269577142385, 218, 31, 'PPL', 'P'),
(87926, 'Holtland', 35.6922187805176, 0.622946735062187, -86.6947174072266, -1.51310826284215, 218, 50, 'PPL', 'P'),
(30100, 'Holton', 39.0750007629395, 0.68198741853259, -85.3872222900391, -1.49028816809347, 218, 19, 'PPL', 'P'),
(32786, 'Holton', 39.4652786254883, 0.688799052231713, -95.7361068725586, -1.67091027796732, 218, 20, 'PPL', 'P'),
(41393, 'Holton', 30.7441692352295, 0.536586978945102, -90.3641662597656, -1.57715222705248, 218, 22, 'PPL', 'P'),
(87927, 'Holton', 36.564998626709, 0.638179617023277, -84.0372161865234, -1.46672611666511, 218, 50, 'PPL', 'P'),
(109701, 'Holton', 39.6022186279297, 0.691189106152004, -78.0699996948242, -1.36257854170565, 218, 58, 'PPL', 'P'),
(131340, 'Holton', 43.413330078125, 0.757705549118368, -86.0794372558594, -1.50236959837862, 218, 27, 'PPL', 'P'),
(143978, 'Holton', 43.0811080932617, 0.751907181634993, -71.908332824707, -1.25503716741105, 218, 36, 'PPL', 'P'),
(182184, 'Holton (historical)', 33.9472198486328, 0.592490758257014, -118.443061828613, -2.06722140505252, 218, 6, 'PPL', 'P'),
(149673, 'Holton Beach', 42.6186103820801, 0.743835073791936, -76.6849975585938, -1.33840569428127, 218, 40, 'PPL', 'P'),
(87928, 'Holts Corner', 35.6925010681152, 0.622951661910204, -86.6933288574219, -1.51308402807623, 218, 50, 'PPL', 'P'),
(102919, 'Holts Corner', 37.560001373291, 0.65554569101752, -77.2497177124023, -1.3482619203176, 218, 53, 'PPL', 'P'),
(102918, 'Holts Crossing', 37.0741691589355, 0.647066319264762, -78.9813919067383, -1.37848533658059, 218, 53, 'PPL', 'P'),
(174558, 'Holts Landing', 46.0099983215332, 0.803025959547819, -90.3713912963867, -1.5772783277301, 218, 57, 'PPL', 'P'),
(55355, 'Holts Summit', 38.6402816772461, 0.674400139165981, -92.1222229003906, -1.60783610386794, 218, 29, 'PPL', 'P'),
(87929, 'Holtsville', 35.3122215270996, 0.616314531841508, -88.2474975585938, -1.54020938904312, 218, 50, 'PPL', 'P'),
(149674, 'Holtsville', 40.8152809143066, 0.712361037081052, -73.0455627441406, -1.27488557385736, 218, 40, 'PPL', 'P'),
(87930, 'Holttown', 36.0777816772461, 0.629676077083627, -83.2055587768555, -1.45221095661779, 218, 50, 'PPL', 'P'),
(3209, 'Holtville', 32.6361083984375, 0.569607546590508, -86.3266677856445, -1.50668458513482, 218, 2, 'PPL', 'P'),
(55356, 'Holtville', 36.9144401550293, 0.644278522235667, -92.2638931274414, -1.61030871578202, 218, 29, 'PPL', 'P'),
(182185, 'Holtville', 32.8111114501953, 0.57266192604472, -115.379440307617, -2.01375112247618, 218, 6, 'PPL', 'P'),
(78480, 'Holtwood', 39.8319396972656, 0.695198495173118, -76.3277816772461, -1.33217110101134, 218, 45, 'PPL', 'P'),
(78481, 'Holtz', 39.9422187805176, 0.697123228271946, -76.6036071777344, -1.33698516415583, 218, 45, 'PPL', 'P'),
(207674, 'Holtzinger', 46.6777801513672, 0.814680951163415, -120.719436645508, -2.10695164061681, 218, 56, 'PPL', 'P'),
(78482, 'Holtzswam', 39.9305610656738, 0.696919762764664, -76.9266662597656, -1.34262360881574, 218, 45, 'PPL', 'P'),
(9551, 'Holub Crossing', 34.8477783203125, 0.608208468694552, -90.9080581665039, -1.58664493160001, 218, 4, 'PPL', 'P'),
(41394, 'Holum', 31.9966697692871, 0.558447237147395, -92.0833282470703, -1.60715726410608, 218, 22, 'PPL', 'P'),
(127769, 'Holway Corner', 44.6338882446289, 0.779008307835967, -69.6802825927734, -1.21615035496399, 218, 26, 'PPL', 'P'),
(182186, 'Holy City', 37.1569404602051, 0.648510950998076, -121.977783203125, -2.12891393117837, 218, 6, 'PPL', 'P'),
(131342, 'Holy Corners', 42.8116683959961, 0.747204571782131, -85.5266723632813, -1.4927220310137, 218, 27, 'PPL', 'P'),
(36481, 'Holy Cross', 37.6738891601563, 0.657533407876128, -85.4469375610352, -1.49133039618608, 218, 21, 'PPL', 'P'),
(116067, 'Holy Cross', 42.6005592346191, 0.74352002183498, -90.9955596923828, -1.58817212132712, 218, 16, 'PPL', 'P'),
(174560, 'Holy Cross', 43.4702796936035, 0.758699507416213, -87.8955612182617, -1.53406694114691, 218, 57, 'PPL', 'P'),
(211875, 'Holy Cross', 62.1994400024414, 1.08558502093927, -159.771392822266, -2.78853685524577, 218, 1, 'PPL', 'P'),
(186861, 'Holy Cross City (historical)', 39.4150009155273, 0.687921540652532, -106.477500915527, -1.85838297027123, 218, 7, 'PPL', 'P'),
(188696, 'Holy Ghost', 35.7599983215332, 0.6241297112184, -105.691940307617, -1.84467235118923, 218, 38, 'PPL', 'P'),
(87931, 'Holy Hill', 36.4797210693359, 0.636691242869059, -81.8225021362305, -1.42807206449732, 218, 50, 'PPL', 'P'),
(3210, 'Holy Trinity', 32.2222213745117, 0.562383855291722, -85.0052795410156, -1.4836220095689, 218, 2, 'PPL', 'P'),
(125098, 'Holyoke', 42.2041702270508, 0.736601728534199, -72.6166687011719, -1.26739996066536, 218, 23, 'PPL', 'P'),
(135996, 'Holyoke', 46.4674987792969, 0.811010848865176, -92.3883285522461, -1.61248052365098, 218, 28, 'PPL', 'P'),
(194239, 'Holyoke', 40.5844383239746, 0.708332073825926, -102.301940917969, -1.78550570019926, 218, 7, 'PPL', 'P'),
(32788, 'Holyrood', 38.5869407653809, 0.673469164627917, -98.4108276367188, -1.71759296187337, 218, 20, 'PPL', 'P'),
(209513, 'Homa Hills', 42.9799995422363, 0.75014250451768, -106.360282897949, -1.85633712992183, 218, 59, 'PPL', 'P'),
(9552, 'Homan', 33.542781829834, 0.585431983208731, -93.8861083984375, -1.63862171343703, 218, 4, 'PPL', 'P'),
(207675, 'Homan', 45.7005615234375, 0.79762526859422, -122.581672668457, -2.13945379066652, 218, 56, 'PPL', 'P'),
(162780, 'Homans Corner', 40.2163887023926, 0.7019083961186, -78.2750015258789, -1.36615649863017, 218, 45, 'PPL', 'P'),
(192626, 'Homansville', 39.9749984741211, 0.697695341853122, -112.08332824707, -1.95622311450494, 218, 52, 'PPL', 'P'),
(87934, 'Homaway Village', 35.3875007629395, 0.617628402365299, -86.2266693115234, -1.50493928251444, 218, 50, 'PPL', 'P'),
(466, 'Homberg', 37.3252792358398, 0.651449016891678, -88.5519409179688, -1.54552292805004, 218, 18, 'PPL', 'P'),
(32789, 'Home', 39.8416709899902, 0.695368338271638, -96.5194396972656, -1.6845820148974, 218, 20, 'PPL', 'P'),
(112647, 'Home', 38.7255592346191, 0.675888513320199, -80.8133316040039, -1.41045871599586, 218, 58, 'PPL', 'P'),
(162781, 'Home', 40.7394409179688, 0.711037379440256, -79.1055603027344, -1.38065248391764, 218, 45, 'PPL', 'P'),
(207676, 'Home', 47.2750015258789, 0.82510443051193, -122.762496948242, -2.14260976971632, 218, 56, 'PPL', 'P'),
(72940, 'Home (historical)', 39.0247192382813, 0.681109840374381, -84.3166732788086, -1.47160356304353, 218, 41, 'PPL', 'P'),
(200991, 'Home (historical)', 44.0625, 0.769035701660001, -117.262496948242, -2.04661666085663, 218, 43, 'PPL', 'P'),
(48262, 'Home Acres', 39.0416717529297, 0.681405717571489, -76.9241714477539, -1.34258006613192, 218, 25, 'PPL', 'P'),
(65717, 'Home Acres', 35.7397193908691, 0.623775777109529, -78.6324996948242, -1.37239601874812, 218, 33, 'PPL', 'P'),
(81619, 'Home Acres', 33.9883308410645, 0.593208280433708, -80.4786071777344, -1.40461667267061, 218, 48, 'PPL', 'P'),
(109702, 'Home Acres', 39.0499992370605, 0.68155105958798, -80.522216796875, -1.40537780411015, 218, 58, 'PPL', 'P'),
(162782, 'Home Camp', 41.1108283996582, 0.717519313796427, -78.6455612182617, -1.37262398533743, 218, 45, 'PPL', 'P'),
(122826, 'Home Corner', 40.523609161377, 0.707270404657366, -85.6405563354492, -1.49470968129328, 218, 19, 'PPL', 'P'),
(102920, 'Home Creek', 37.3502807617188, 0.651885375836288, -82.0708312988281, -1.43240622601337, 218, 53, 'PPL', 'P'),
(48263, 'Home Farm', 39.4911117553711, 0.689249925404263, -76.9358291625977, -1.3427835316392, 218, 25, 'PPL', 'P'),
(182188, 'Home Garden', 36.3033294677734, 0.633612628648927, -119.635276794434, -2.08802948159763, 218, 6, 'PPL', 'P'),
(182189, 'Home Gardens', 33.878059387207, 0.591283680492935, -117.519996643066, -2.05111087835419, 218, 6, 'PPL', 'P'),
(182190, 'Home Junction', 34.035831451416, 0.59403732248105, -118.433891296387, -2.067061349071, 218, 6, 'PPL', 'P'),
(703, 'Home Landing', 33.6641693115234, 0.587550594434917, -91.1133270263672, -1.59022754905644, 218, 30, 'PPL', 'P'),
(72938, 'Home Park', 38.4486083984375, 0.671054809362678, -82.3611068725586, -1.43747249051308, 218, 41, 'PPL', 'P'),
(142076, 'Home Park', 41.3205604553223, 0.721179828714741, -95.9394378662109, -1.6744590732779, 218, 35, 'PPL', 'P'),
(162783, 'Home Park', 40.6822204589844, 0.710038694031476, -75.5163879394531, -1.31800960875679, 218, 45, 'PPL', 'P'),
(30101, 'Home Place', 39.9438896179199, 0.697152389885882, -86.1433334350586, -1.50348479708509, 218, 19, 'PPL', 'P'),
(41397, 'Home Place', 29.8236103057861, 0.520520194667681, -91.664436340332, -1.59984622112354, 218, 22, 'PPL', 'P'),
(48264, 'Home Place', 38.4625015258789, 0.67129729017993, -76.521110534668, -1.33554532611247, 218, 25, 'PPL', 'P'),
(22027, 'Home Place Acres', 33.8541717529297, 0.590866762624283, -84.8436126708984, -1.48080039039396, 218, 13, 'PPL', 'P'),
(188697, 'Home Place Well', 33.7541694641113, 0.589121393424873, -103.709442138672, -1.81007123072637, 218, 38, 'PPL', 'P'),
(207677, 'Home Valley', 45.6983299255371, 0.797586319863278, -121.775283813477, -2.12537965009572, 218, 56, 'PPL', 'P'),
(162784, 'Homeacre', 40.8591690063477, 0.713127028789586, -79.9397201538086, -1.39521131980683, 218, 45, 'PPL', 'P'),
(48265, 'Homecrest', 39.0902786254883, 0.682254067536734, -77.0555572509766, -1.34487318098853, 218, 25, 'PPL', 'P'),
(30102, 'Homecroft', 39.6699981689453, 0.692372082308217, -86.1313934326172, -1.50327640472979, 218, 19, 'PPL', 'P'),
(195105, 'Homedale', 43.6177787780762, 0.761273852083938, -116.932777404785, -2.04086196921513, 218, 17, 'PPL', 'P'),
(131345, 'Homeier', 46.7724990844727, 0.816334108410081, -87.6797180175781, -1.53029976662693, 218, 27, 'PPL', 'P'),
(186862, 'Homelake', 37.5755615234375, 0.655817266869681, -106.096389770508, -1.85173132597459, 218, 7, 'PPL', 'P'),
(16482, 'Homeland', 27.8174991607666, 0.485506950026137, -81.8247222900391, -1.42811081349118, 218, 12, 'PPL', 'P'),
(22028, 'Homeland', 30.8558292388916, 0.538535813651794, -82.021110534668, -1.43153843497216, 218, 13, 'PPL', 'P'),
(48266, 'Homeland', 39.3580589294434, 0.686927715512741, -76.6247177124023, -1.33735361249264, 218, 25, 'PPL', 'P'),
(55357, 'Homeland', 36.6674995422363, 0.639968595485538, -91.9191665649414, -1.60429210224731, 218, 29, 'PPL', 'P'),
(102921, 'Homeland', 38.6097183227539, 0.673866707999638, -78.0325012207031, -1.36192406986776, 218, 53, 'PPL', 'P'),
(109703, 'Homeland', 39.1227798461914, 0.682821320848921, -80.3963928222656, -1.40318176147527, 218, 58, 'PPL', 'P'),
(162785, 'Homeland', 40.0638885498047, 0.699246766346148, -76.2869415283203, -1.33145830594558, 218, 45, 'PPL', 'P'),
(182191, 'Homeland', 33.7430610656738, 0.588927515297515, -117.108329772949, -2.04392593604927, 218, 6, 'PPL', 'P'),
(78483, 'Homeland Gardens', 39.9205589294434, 0.696745192555209, -76.7108306884766, -1.33885656745382, 218, 45, 'PPL', 'P'),
(102922, 'Homeland Hills', 37.2077789306641, 0.649398249694263, -79.9033279418945, -1.39457615588684, 218, 53, 'PPL', 'P'),
(48267, 'Homeland Park', 39.1933288574219, 0.684052633378919, -76.6716690063477, -1.33817306716006, 218, 25, 'PPL', 'P'),
(81626, 'Homeland Park', 34.4705581665039, 0.601624735005713, -82.6708297729492, -1.44287817489372, 218, 48, 'PPL', 'P'),
(182192, 'Homelands', 32.7416687011719, 0.571449921432625, -116.971672058105, -2.04154080897699, 218, 6, 'PPL', 'P'),
(102924, 'Homeplace', 37.2688903808594, 0.65046484571084, -80.0550003051758, -1.39722333801038, 218, 53, 'PPL', 'P'),
(22029, 'Homer', 34.333610534668, 0.599234547927367, -83.4991683959961, -1.45733541118732, 218, 13, 'PPL', 'P'),
(30103, 'Homer', 39.5780601501465, 0.690767461172418, -85.5780563354492, -1.49361885051078, 218, 19, 'PPL', 'P'),
(32791, 'Homer', 38.8694381713867, 0.678399674491062, -98.7972183227539, -1.72433675154373, 218, 20, 'PPL', 'P'),
(36482, 'Homer', 36.9613914489746, 0.645097976903085, -86.8397216796875, -1.51563906482605, 218, 21, 'PPL', 'P'),
(41398, 'Homer', 32.7916717529297, 0.572322639321844, -93.0555572509766, -1.62412586130762, 218, 22, 'PPL', 'P'),
(55358, 'Homer', 36.5208282470703, 0.637408698466726, -93.3958282470703, -1.6300647105385, 218, 29, 'PPL', 'P'),
(76118, 'Homer', 34.7813911437988, 0.607049793883286, -96.6166687011719, -1.686278981144, 218, 42, 'PPL', 'P'),
(94976, 'Homer', 31.288890838623, 0.546094164431062, -94.6380615234375, -1.65174577128895, 218, 51, 'PPL', 'P'),
(116068, 'Homer', 42.3738899230957, 0.739563896035667, -93.9233322143555, -1.63927139158496, 218, 16, 'PPL', 'P'),
(120055, 'Homer', 40.0347213745117, 0.698737703103779, -87.9580612182617, -1.5351577719294, 218, 18, 'PPL', 'P'),
(131346, 'Homer', 42.1458282470703, 0.735583468891407, -84.8088912963867, -1.48019438808791, 218, 27, 'PPL', 'P'),
(136002, 'Homer', 44.0213890075684, 0.768318179483307, -91.5563888549805, -1.59796043675565, 218, 28, 'PPL', 'P'),
(140239, 'Homer', 46.8477783203125, 0.817647978933872, -98.6711120605469, -1.72213578206083, 218, 34, 'PPL', 'P'),
(142077, 'Homer', 42.3216705322266, 0.738652495731614, -96.4891662597656, -1.68405364373713, 218, 35, 'PPL', 'P'),
(149675, 'Homer', 42.6369400024414, 0.744154986017882, -76.1791687011719, -1.32957731526766, 218, 40, 'PPL', 'P'),
(155772, 'Homer', 41.0447196960449, 0.71636549925415, -82.1258316040039, -1.43336616242828, 218, 41, 'PPL', 'P'),
(174561, 'Homer', 43.0852813720703, 0.751980019090807, -90.6166687011719, -1.58155922602434, 218, 57, 'PPL', 'P'),
(182193, 'Homer', 34.9199981689453, 0.609468942838487, -114.936111450195, -2.00601357424506, 218, 6, 'PPL', 'P'),
(211876, 'Homer', 59.6425018310547, 1.04095803107865, -151.548324584961, -2.64501723988864, 218, 1, 'PPL', 'P'),
(3211, 'Homer (historical)', 34.2633285522461, 0.598007895929276, -85.9072189331055, -1.4993638216143, 218, 2, 'PPL', 'P'),
(162786, 'Homer City', 40.5433311462402, 0.707614618228259, -79.1624984741211, -1.3816462424784, 218, 45, 'PPL', 'P'),
(162788, 'Homer Gap', 40.5638885498047, 0.70797341260612, -78.4044418334961, -1.36841565818289, 218, 45, 'PPL', 'P'),
(120056, 'Homer Glen', 41.5999984741211, 0.72605694219803, -87.9380569458008, -1.53480863151049, 218, 18, 'PPL', 'P'),
(149676, 'Homer Hill', 42.0955581665039, 0.734706090470281, -78.4488906860352, -1.36919143700843, 218, 40, 'PPL', 'P'),
(94975, 'Homer Junction', 31.1647205352783, 0.543926983804496, -99.5097198486328, -1.7367722490958, 218, 51, 'PPL', 'P'),
(131347, 'Homer Location', 46.1166687011719, 0.804887708886866, -88.658332824707, -1.5473798171201, 218, 27, 'PPL', 'P'),
(48268, 'Homers Delight', 39.4286117553711, 0.688159094621767, -77.543327331543, -1.35338637488713, 218, 25, 'PPL', 'P'),
(22030, 'Homerville', 31.0363903045654, 0.541687198748712, -82.7472229003906, -1.44421148649347, 218, 13, 'PPL', 'P'),
(155774, 'Homerville', 41.0291709899902, 0.716094123139071, -82.126106262207, -1.43337095611825, 218, 41, 'PPL', 'P'),
(145457, 'Homes Mills', 40.1344413757324, 0.700478145455173, -74.5427780151367, -1.30101690994738, 218, 37, 'PPL', 'P'),
(22031, 'Homes of Mansfield', 33.9347190856934, 0.592272578784709, -83.4355621337891, -1.45622527248692, 218, 13, 'PPL', 'P'),
(155775, 'Homeside', 40.0625, 0.699222531580228, -80.9024963378906, -1.41201493417885, 218, 41, 'PPL', 'P'),
(211877, 'Homesite Park', 61.2191696166992, 1.06847607514828, -149.741104125977, -2.61347529256996, 218, 1, 'PPL', 'P'),
(196736, 'Homestake', 45.9233283996582, 0.801513284048654, -112.410003662109, -1.96192467608269, 218, 31, 'PPL', 'P'),
(3212, 'Homestead', 33.2058296203613, 0.579551057731564, -86.4683303833008, -1.50915706389085, 218, 2, 'PPL', 'P'),
(16483, 'Homestead', 25.4683303833008, 0.444506220174308, -80.477783203125, -1.40460229160072, 218, 12, 'PPL', 'P'),
(22033, 'Homestead', 31.2758293151855, 0.545866197841751, -82.2772216796875, -1.43600841770381, 218, 13, 'PPL', 'P'),
(30104, 'Homestead', 39.1241683959961, 0.682845555614841, -84.8525009155273, -1.48095551952746, 218, 19, 'PPL', 'P'),
(48269, 'Homestead', 39.3216705322266, 0.686292618171785, -76.5972213745117, -1.33687371086421, 218, 25, 'PPL', 'P'),
(55360, 'Homestead', 39.3627815246582, 0.687010140348479, -94.2005615234375, -1.64410995581147, 218, 29, 'PPL', 'P'),
(65718, 'Homestead', 35.2833290100098, 0.615810262289102, -80.913330078125, -1.41220401861624, 218, 33, 'PPL', 'P'),
(76119, 'Homestead', 36.1497192382813, 0.630931624379544, -98.3936080932617, -1.71729242414436, 218, 42, 'PPL', 'P'),
(87936, 'Homestead', 36.0855598449707, 0.629811831720193, -83.9111099243164, -1.46452514718221, 218, 50, 'PPL', 'P'),
(102925, 'Homestead', 36.8105583190918, 0.642465442165541, -76.182502746582, -1.32963550533748, 218, 53, 'PPL', 'P'),
(116071, 'Homestead', 41.7594413757324, 0.728839745800081, -91.866943359375, -1.60338063536423, 218, 16, 'PPL', 'P'),
(131350, 'Homestead', 46.3380584716797, 0.808751689312462, -84.1224975585938, -1.46821455739835, 218, 27, 'PPL', 'P'),
(162790, 'Homestead', 40.4058303833008, 0.705214777190961, -79.9122161865234, -1.39473128502034, 218, 45, 'PPL', 'P'),
(169419, 'Homestead', 41.6230583190918, 0.726459412417768, -71.3077774047852, -1.24455549799272, 218, 47, 'PPL', 'P'),
(192881, 'Homestead', 33.4555587768555, 0.583909653750615, -111.764999389648, -1.95066722783882, 218, 5, 'PPL', 'P'),
(193645, 'Homestead', 41.9136085510254, 0.731530470607443, -121.421943664551, -2.11921270111748, 218, 6, 'PPL', 'P'),
(196737, 'Homestead', 48.4211082458496, 0.845107766354652, -104.538330078125, -1.8245380543999, 218, 31, 'PPL', 'P'),
(200992, 'Homestead', 45.0238914489746, 0.785815147845127, -116.849716186523, -2.03941227747575, 218, 43, 'PPL', 'P'),
(55361, 'Homestead (historical)', 36.8188896179199, 0.64261085076106, -90.7188873291016, -1.58334327763859, 218, 29, 'PPL', 'P'),
(22034, 'Homestead Acres', 34.0827789306641, 0.59485671056944, -84.6805572509766, -1.4779545364531, 218, 13, 'PPL', 'P'),
(65721, 'Homestead Acres', 35.7597198486328, 0.624124850949411, -80.2249984741211, -1.40019036578084, 218, 33, 'PPL', 'P'),
(81620, 'Homestead Acres', 34.8963890075684, 0.609056885238824, -82.3180618286133, -1.43672121276957, 218, 48, 'PPL', 'P'),
(87938, 'Homestead Acres', 35.1741714477539, 0.613905103424286, -84.7991714477539, -1.48002474472647, 218, 50, 'PPL', 'P'),
(116072, 'Homestead Colony', 42.0783309936523, 0.734405419583211, -93.6255569458008, -1.63407423271767, 218, 16, 'PPL', 'P'),
(204394, 'Homestead Condominium', 40.9088897705078, 0.713994819830789, -111.885833740234, -1.95277618510605, 218, 52, 'PPL', 'P'),
(48270, 'Homestead Estates', 39.0530586242676, 0.681604455967836, -76.9869384765625, -1.34367555744632, 218, 25, 'PPL', 'P'),
(81621, 'Homestead Estates', 34.5127792358398, 0.602361631679338, -82.7536087036133, -1.44432293978509, 218, 48, 'PPL', 'P'),
(204397, 'Homestead Estates', 40.5038909912109, 0.7069262576655, -111.948608398438, -1.95387180957851, 218, 52, 'PPL', 'P'),
(102926, 'Homestead Haven', 37.3627815246582, 0.652103555308593, -79.2577819824219, -1.3833092534211, 218, 53, 'PPL', 'P'),
(192966, 'Homestead Homes Colonia', 31.8020000457764, 0.555049609518185, -106.181999206543, -1.85322549250418, 218, 51, 'PPL', 'P'),
(191624, 'Homestead Meadows', 31.8416690826416, 0.555741964822578, -106.175277709961, -1.85310818025816, 218, 51, 'PPL', 'P'),
(191616, 'Homestead Meadows North', 31.851390838623, 0.55591164147353, -106.171112060547, -1.8530354759604, 218, 51, 'PPL', 'P'),
(191617, 'Homestead Meadows South', 31.8091697692871, 0.555174744799905, -106.166938781738, -1.85296263850459, 218, 51, 'PPL', 'P'),
(191618, 'Homestead Meadows South Number 1 Colonia', 31.8010005950928, 0.555032165813045, -106.171997070313, -1.85305092229473, 218, 51, 'PPL', 'P'),
(191619, 'Homestead Meadows South Number 2 Colonia', 31.8080005645752, 0.555154338328052, -106.171997070313, -1.85305092229473, 218, 51, 'PPL', 'P'),
(191620, 'Homestead Meadows South Number 3 Colonia', 31.8159999847412, 0.5552939545482, -106.171997070313, -1.85305092229473, 218, 51, 'PPL', 'P'),
(191621, 'Homestead Meadows South Number 4 Colonia', 31.8150005340576, 0.55527651084306, -106.178001403809, -1.85315571768362, 218, 51, 'PPL', 'P'),
(191622, 'Homestead Meadows South Number 5 Colonia', 31.8090000152588, 0.555171782033192, -106.162002563477, -1.85287648524333, 218, 51, 'PPL', 'P'),
(191623, 'Homestead Meadows South Number 6 Colonia', 31.8150005340576, 0.55527651084306, -106.179000854492, -1.85317316138876, 218, 51, 'PPL', 'P'),
(13987, 'Homestead Mobile Home Park', 38.6063919067383, 0.673808651087875, -75.39111328125, -1.31582315350184, 218, 10, 'PPL', 'P'),
(145458, 'Homestead Park', 40.689998626709, 0.710174448668043, -74.4505615234375, -1.29940742854259, 218, 37, 'PPL', 'P'),
(149678, 'Homestead Park', 40.916389465332, 0.714125714198366, -73.7733306884766, -1.28758752067649, 218, 40, 'PPL', 'P'),
(16484, 'Homestead Ridge', 30.5013904571533, 0.532349689913704, -84.1202774047852, -1.46817580840449, 218, 12, 'PPL', 'P'),
(55362, 'Homestown', 36.3319396972656, 0.634111971353317, -89.8258285522461, -1.56775646156863, 218, 29, 'PPL', 'P'),
(109704, 'Hometown', 38.5327796936035, 0.672523875598993, -81.8613891601563, -1.42875077110112, 218, 58, 'PPL', 'P'),
(120058, 'Hometown', 41.7344398498535, 0.728403386855472, -87.7313919067383, -1.53120164613009, 218, 18, 'PPL', 'P'),
(162793, 'Hometown', 40.8236083984375, 0.712506379097544, -75.9805603027344, -1.32611094479281, 218, 45, 'PPL', 'P'),
(116073, 'Hometown Lakeside Mobile Home Park', 41.5069389343262, 0.724432746828218, -90.6805572509766, -1.58267429157276, 218, 16, 'PPL', 'P'),
(116074, 'Hometown-Cedar Terrace', 41.9597206115723, 0.732335277888865, -91.7491683959961, -1.60132507447686, 218, 16, 'PPL', 'P'),
(162794, 'Homets Ferry', 41.6988906860352, 0.727782936900511, -76.3230590820313, -1.33208867617561, 218, 45, 'PPL', 'P'),
(102927, 'Homeville', 36.9486083984375, 0.644874870582763, -77.1716690063477, -1.34689971342003, 218, 53, 'PPL', 'P'),
(162795, 'Homeville', 40.3849983215332, 0.704851189123138, -79.8786087036133, -1.39414472379025, 218, 45, 'PPL', 'P'),
(120059, 'Homeward Hill', 41.9652786254883, 0.732432283531571, -88.3858337402344, -1.54262381088738, 218, 18, 'PPL', 'P'),
(3215, 'Homewood', 31.3694400787354, 0.547500013881001, -87.5994415283203, -1.52889867757744, 218, 2, 'PPL', 'P'),
(9555, 'Homewood', 35.0299987792969, 0.611388815668325, -92.9763870239258, -1.62274408017604, 218, 4, 'PPL', 'P'),
(32794, 'Homewood', 38.514720916748, 0.672208690483982, -95.3786087036133, -1.66467075784937, 218, 20, 'PPL', 'P'),
(48273, 'Homewood', 39.0252799987793, 0.681119627491387, -77.0630569458008, -1.34500407535611, 218, 25, 'PPL', 'P'),
(60305, 'Homewood', 32.2400016784668, 0.562694180137744, -89.5061111450195, -1.56217634013658, 218, 30, 'PPL', 'P'),
(81622, 'Homewood', 33.8838882446289, 0.591385413246576, -79.0486068725586, -1.37965845904077, 218, 48, 'PPL', 'P'),
(102930, 'Homewood', 37.1916694641113, 0.649117086462178, -76.6822204589844, -1.33835722474943, 218, 53, 'PPL', 'P'),
(109706, 'Homewood', 39.5213890075684, 0.689778363143562, -80.329719543457, -1.40201809323696, 218, 58, 'PPL', 'P'),
(120060, 'Homewood', 41.5572204589844, 0.725310324986426, -87.6655578613281, -1.53005262527777, 218, 18, 'PPL', 'P'),
(155776, 'Homewood', 41.542781829834, 0.725058323368278, -83.7324981689453, -1.46140778396822, 218, 41, 'PPL', 'P'),
(162798, 'Homewood', 40.1097183227539, 0.700046646779553, -77.0444412231445, -1.34467916970312, 218, 45, 'PPL', 'P'),
(182194, 'Homewood', 39.0869407653809, 0.682195810887888, -120.159172058105, -2.09717317888431, 218, 6, 'PPL', 'P'),
(81623, 'Homewood Acres', 34.896671295166, 0.609061812086841, -82.184440612793, -1.43438908260298, 218, 48, 'PPL', 'P'),
(22036, 'Homewood Hills', 33.9772186279297, 0.593014335727323, -83.4297180175781, -1.45612327341717, 218, 13, 'PPL', 'P'),
(102932, 'Homewood Park', 37.6650009155273, 0.657378278742631, -77.7149963378906, -1.35638256427153, 218, 53, 'PPL', 'P'),
(186863, 'Homewood Park', 39.542781829834, 0.690151738328391, -105.197219848633, -1.83603785030297, 218, 7, 'PPL', 'P'),
(81624, 'Homewood Terrace', 34.0647201538086, 0.594541525454429, -81.1230621337891, -1.41586453353456, 218, 48, 'PPL', 'P'),
(155777, 'Homeworth', 40.8352813720703, 0.712710110920935, -81.0661087036133, -1.41487050865768, 218, 41, 'PPL', 'P'),
(65723, 'Hominy', 35.5458297729492, 0.620391764891392, -82.6763916015625, -1.44297524711545, 218, 33, 'PPL', 'P'),
(76121, 'Hominy', 36.4141693115234, 0.635547148864761, -96.3949966430664, -1.68241007387039, 218, 42, 'PPL', 'P'),
(109707, 'Hominy Falls', 38.1452789306641, 0.66576071143171, -80.7188873291016, -1.40881035243915, 218, 58, 'PPL', 'P'),
(162800, 'Hominy Ridge', 41.3083305358887, 0.720966376353371, -79.1833267211914, -1.3820097639672, 218, 45, 'PPL', 'P'),
(60306, 'Homochitto', 31.3197193145752, 0.546632222839799, -90.98388671875, -1.58796838950373, 218, 30, 'PPL', 'P'),
(60307, 'Homochitto (historical)', 32.8675003051758, 0.573646097225558, -91.0599975585938, -1.58929677425546, 218, 30, 'PPL', 'P'),
(16485, 'Homosassa', 28.7811107635498, 0.502325145205123, -82.6152801513672, -1.44190865109888, 218, 12, 'PPL', 'P'),
(16486, 'Homosassa Springs', 28.8033294677734, 0.502712934749352, -82.5761108398438, -1.44122501764705, 218, 12, 'PPL', 'P'),
(9554, 'Hon', 34.9391708374023, 0.609803569029455, -94.1811065673828, -1.64377040277248, 218, 4, 'PPL', 'P'),
(36483, 'Honaker', 37.523609161377, 0.654910527097536, -82.6800003051758, -1.44303823087523, 218, 21, 'PPL', 'P'),
(102931, 'Honaker', 37.0161094665527, 0.646052986469987, -81.9744415283203, -1.43072390715276, 218, 53, 'PPL', 'P'),
(211492, 'Honalo', 19.5463905334473, 0.341148871689306, -155.931945800781, -2.72152586326498, 218, 15, 'PPL', 'P'),
(182195, 'Honby', 34.4211082458496, 0.600761671075445, -118.491386413574, -2.06806482816975, 218, 6, 'PPL', 'P'),
(182196, 'Honcut', 39.3291702270508, 0.686423512539362, -121.532783508301, -2.12114722133331, 218, 6, 'PPL', 'P'),
(182198, 'Honda', 34.6155586242676, 0.604155470410588, -120.632499694824, -2.10543430458574, 218, 6, 'PPL', 'P'),
(55363, 'Hondin (historical)', 36.621940612793, 0.639173442163067, -89.7300033569336, -1.56608399640406, 218, 29, 'PPL', 'P'),
(94977, 'Hondo', 29.3472194671631, 0.512205606007372, -99.14111328125, -1.73033885085049, 218, 51, 'PPL', 'P'),
(188698, 'Hondo', 33.3875007629395, 0.582721817325412, -105.270278930664, -1.8373129718329, 218, 38, 'PPL', 'P'),
(122827, 'Honduras', 40.7580604553223, 0.711362351672273, -85.0330581665039, -1.48410683804535, 218, 19, 'PPL', 'P'),
(94978, 'Honea', 30.3183307647705, 0.529154695553936, -95.5994415283203, -1.66852501773699, 218, 51, 'PPL', 'P'),
(81625, 'Honea Path', 34.4463882446289, 0.601202890289044, -82.3916702270508, -1.43800592167942, 218, 48, 'PPL', 'P'),
(162801, 'Honeoye', 41.9908294677734, 0.732878229856105, -78.1333312988281, -1.36368388671609, 218, 45, 'PPL', 'P'),
(177375, 'Honeoye', 42.7900009155273, 0.74682640290734, -77.517219543457, -1.35293070802462, 218, 40, 'PPL', 'P'),
(149679, 'Honeoye Falls', 42.952220916748, 0.749657676041231, -77.5905609130859, -1.35421075640257, 218, 40, 'PPL', 'P'),
(149680, 'Honeoye Park', 42.7797203063965, 0.746646972428896, -77.5019378662109, -1.35266399244145, 218, 40, 'PPL', 'P'),
(162803, 'Honesdale', 41.5766716003418, 0.725649811446384, -75.2591705322266, -1.31352031810725, 218, 45, 'PPL', 'P'),
(149681, 'Honest Hill', 43.1452789306641, 0.753027174031426, -78.0661087036133, -1.36251063109785, 218, 40, 'PPL', 'P'),
(72941, 'Honesty', 39.5875015258789, 0.690932244264866, -81.4855575561523, -1.4221912721782, 218, 41, 'PPL', 'P'),
(162805, 'Honey', 40.711109161377, 0.710542897004855, -77.5213928222656, -1.35300354548043, 218, 45, 'PPL', 'P'),
(36484, 'Honey Acre', 37.1127815246582, 0.647740232178607, -84.9747161865234, -1.48308857840255, 218, 21, 'PPL', 'P'),
(27460, 'Honey Bend', 39.2552795410156, 0.685133876781491, -89.6227798461914, -1.56421259310606, 218, 18, 'PPL', 'P'),
(162804, 'Honey Brook', 40.0941696166992, 0.699775270664474, -75.9116668701172, -1.32490852756064, 218, 45, 'PPL', 'P'),
(48277, 'Honey Cove Estates', 38.4730606079102, 0.671481580927363, -76.6080627441406, -1.33706292845966, 218, 25, 'PPL', 'P'),
(55364, 'Honey Creek', 38.4627799987793, 0.671302150448919, -92.2416687011719, -1.60992082636925, 218, 29, 'PPL', 'P'),
(94979, 'Honey Creek', 29.8050003051758, 0.520195388883232, -98.5008316040039, -1.71916382744236, 218, 51, 'PPL', 'P'),
(116075, 'Honey Creek', 41.4305610656738, 0.723099701544579, -95.8661117553711, -1.67317929121607, 218, 16, 'PPL', 'P'),
(120061, 'Honey Creek', 41.9902801513672, 0.73286864247618, -89.2797164916992, -1.55822500802723, 218, 18, 'PPL', 'P'),
(122828, 'Honey Creek', 40.0338897705078, 0.698723188875838, -85.4855575561523, -1.49200444225798, 218, 19, 'PPL', 'P'),
(162808, 'Honey Creek', 40.6897201538086, 0.710169588399054, -77.5591735839844, -1.35366294416634, 218, 45, 'PPL', 'P'),
(174563, 'Honey Creek', 42.7483291625977, 0.746099093613639, -88.3077774047852, -1.54126147083175, 218, 57, 'PPL', 'P'),
(22039, 'Honey Creek (historical)', 33.6041717529297, 0.586503439494298, -84.0486068725586, -1.46692492164048, 218, 13, 'PPL', 'P'),
(72942, 'Honey Creek Village Mobile Home Park', 39.9905586242676, 0.697966917705283, -84.0130615234375, -1.46630453826455, 218, 41, 'PPL', 'P'),
(36485, 'Honey Fork', 37.3472213745117, 0.651831979456432, -82.3541717529297, -1.43735144984153, 218, 21, 'PPL', 'P'),
(36486, 'Honey Grove', 36.889720916748, 0.643847090139074, -87.3097229003906, -1.52384213361571, 218, 21, 'PPL', 'P'),
(94980, 'Honey Grove', 33.5833282470703, 0.586139651689393, -95.9097213745117, -1.67394042265561, 218, 51, 'PPL', 'P'),
(162810, 'Honey Grove', 40.4022216796875, 0.705151793431181, -77.5524978637695, -1.35354643086865, 218, 45, 'PPL', 'P'),
(48276, 'Honey Hill', 39.3891716003418, 0.687470734059008, -77.3083267211914, -1.3492848404923, 218, 25, 'PPL', 'P'),
(65726, 'Honey Hill', 34.2752799987793, 0.598216488021657, -78.6333312988281, -1.37241053297606, 218, 33, 'PPL', 'P'),
(81631, 'Honey Hill', 33.1902809143066, 0.579279681616485, -79.5758285522461, -1.38886021323921, 218, 48, 'PPL', 'P'),
(162809, 'Honey Hole', 41.0411109924316, 0.71630251549437, -75.9544372558594, -1.32565501161419, 218, 45, 'PPL', 'P'),
(81628, 'Honey Horn Plantation', 32.2069396972656, 0.562117139708551, -80.7483291625977, -1.40932420937148, 218, 48, 'PPL', 'P'),
(60308, 'Honey Island', 33.1263885498047, 0.578164549489041, -90.3772201538086, -1.57738006048374, 218, 30, 'PPL', 'P'),
(94981, 'Honey Island', 30.3952808380127, 0.530497727691663, -94.440559387207, -1.648298708732, 218, 51, 'PPL', 'P'),
(174565, 'Honey Lake', 42.7158317565918, 0.74553190688048, -88.3058319091797, -1.54122751552786, 218, 57, 'PPL', 'P'),
(65727, 'Honey Pond', 34.0311088562012, 0.593954897645312, -78.4986114501953, -1.37005922804963, 218, 33, 'PPL', 'P'),
(65728, 'Honey Town', 34.9500007629395, 0.609992586887824, -79.7838897705078, -1.39249156654358, 218, 33, 'PPL', 'P'),
(36487, 'Honeybee', 36.8413887023926, 0.643003533863792, -84.3722229003906, -1.47257308683838, 218, 21, 'PPL', 'P'),
(65729, 'Honeycutt', 36.0605583190918, 0.629375472775584, -82.2130584716797, -1.43488855846543, 218, 33, 'PPL', 'P'),
(87940, 'Honeycutt', 36.4288902282715, 0.635804077330926, -82.8777770996094, -1.44649008712214, 218, 50, 'PPL', 'P'),
(87941, 'Honeycutt Estates', 36.1377792358398, 0.630723232024246, -85.2472229003906, -1.48784471779333, 218, 50, 'PPL', 'P'),
(193646, 'Honeydew', 40.2444381713867, 0.702397951705984, -124.121673583984, -2.1663318771262, 218, 6, 'PPL', 'P'),
(109708, 'Honeydew (historical)', 38.0344390869141, 0.663826191215876, -80.8300018310547, -1.41074966634495, 218, 58, 'PPL', 'P'),
(140243, 'Honeyford', 48.0333290100098, 0.838339741918379, -97.4702835083008, -1.70117737007218, 218, 34, 'PPL', 'P'),
(113570, 'Honeypot Glen', 41.5224990844727, 0.724704322680379, -72.8869400024414, -1.27211708474617, 218, 8, 'PPL', 'P'),
(87942, 'Honeys Hill', 36.1575012207031, 0.631067445595138, -82.8327789306641, -1.44570472091668, 218, 50, 'PPL', 'P'),
(102936, 'Honeysuckle Bluff', 37.3044395446777, 0.651085295665801, -80.0597229003906, -1.39730576284612, 218, 53, 'PPL', 'P'),
(48281, 'Honeysuckle Hollow', 39.6305618286133, 0.691683788324487, -76.0999984741211, -1.32819553413607, 218, 25, 'PPL', 'P'),
(48278, 'Honeysuckle Knoll', 39.4619407653809, 0.688740795582867, -75.8819427490234, -1.3243897437803, 218, 25, 'PPL', 'P'),
(22041, 'Honeysuckle Plantation', 33.8672218322754, 0.591094529476512, -84.8444366455078, -1.48081477146384, 218, 13, 'PPL', 'P'),
(48279, 'Honeysuckle Ridge', 39.0138893127441, 0.680920822516013, -76.5791702270508, -1.33655865890725, 218, 25, 'PPL', 'P'),
(81629, 'Honeysuckle Woods', 35.1136093139648, 0.612848094787634, -81.0602798461914, -1.41476877590404, 218, 48, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(155778, 'Honeytown', 40.7969398498535, 0.712040925118025, -81.8797225952148, -1.4290707499061, 218, 41, 'PPL', 'P'),
(162811, 'Honeytown', 41.165828704834, 0.718479250211346, -76.317497253418, -1.33199160395387, 218, 45, 'PPL', 'P'),
(16487, 'Honeyville', 30.0577793121338, 0.524607214834571, -85.1900024414063, -1.48684603238455, 218, 12, 'PPL', 'P'),
(102934, 'Honeyville', 38.6708297729492, 0.674933304016215, -78.8061065673828, -1.37542603027836, 218, 53, 'PPL', 'P'),
(122831, 'Honeyville', 41.5816688537598, 0.725737029972084, -85.6016693115234, -1.49403097468947, 218, 19, 'PPL', 'P'),
(149685, 'Honeyville', 43.8591690063477, 0.765486906349416, -75.9805603027344, -1.32611094479281, 218, 40, 'PPL', 'P'),
(204401, 'Honeyville', 41.6386108398438, 0.726730855111875, -112.07861328125, -1.95614082282726, 218, 52, 'PPL', 'P'),
(149682, 'Honeywell Corners', 43.041389465332, 0.751213960803246, -74.1427764892578, -1.29403556630779, 218, 40, 'PPL', 'P'),
(81630, 'Honeywood', 33.9297218322754, 0.592185360259009, -81.1980590820313, -1.41717347721033, 218, 48, 'PPL', 'P'),
(204399, 'Honeywood Cove', 40.6083297729492, 0.708749058273605, -111.790832519531, -1.95111810101137, 218, 52, 'PPL', 'P'),
(204400, 'Honeywood Hills', 40.6088905334473, 0.708758845390611, -111.793060302734, -1.95115698316328, 218, 52, 'PPL', 'P'),
(55366, 'Hong', 37.8950004577637, 0.661392528032734, -94.4166717529297, -1.64788179086335, 218, 29, 'PPL', 'P'),
(48280, 'Honga', 38.3444404602051, 0.669236735865508, -76.2300033569336, -1.33046454738482, 218, 25, 'PPL', 'P'),
(207678, 'Hongking (historical)', 47.3519401550293, 0.826447262912575, -122.474998474121, -2.13759197474844, 218, 56, 'PPL', 'P'),
(149683, 'Honk Hill', 41.7569389343262, 0.728796069958204, -74.3802795410156, -1.2981807765445, 218, 40, 'PPL', 'P'),
(149684, 'Honnedaga', 43.3811111450195, 0.757143222654198, -75.2011108398438, -1.31250698531247, 218, 40, 'PPL', 'P'),
(76123, 'Honobia', 34.538890838623, 0.602817365120878, -94.9372177124023, -1.6569670317641, 218, 42, 'PPL', 'P'),
(211488, 'Honohina (historical)', 19.9272193908691, 0.347795589137925, -155.156936645508, -2.70799940177236, 218, 15, 'PPL', 'P'),
(211497, 'HonokaÃ‚â€˜a', 20.0827808380127, 0.350510648579748, -155.472503662109, -2.71350708522275, 218, 15, 'PPL', 'P'),
(211502, 'Honokahua', 21.003059387207, 0.366572539298665, -156.657775878906, -2.73419398793827, 218, 15, 'PPL', 'P'),
(211504, 'Honokai Hale', 21.3425006866455, 0.372496907591115, -158.110824584961, -2.75955447205077, 218, 15, 'PPL', 'P'),
(211511, 'HonokÃƒÂ¶hau', 19.6736106872559, 0.343369282248159, -156.029174804688, -2.72322282951158, 218, 15, 'PPL', 'P'),
(211508, 'Honokohau', 21.0188903808594, 0.366848842261761, -156.611389160156, -2.73338438696688, 218, 15, 'PPL', 'P'),
(211495, 'Honokowai', 20.9541702270508, 0.365719262485404, -156.689712524414, -2.73475138755442, 218, 15, 'PPL', 'P'),
(211519, 'Honolua (historical)', 21.0163898468018, 0.366805199709397, -156.640563964844, -2.73389358336731, 218, 15, 'PPL', 'P'),
(65731, 'Honolulu', 35.3627815246582, 0.617196970268706, -77.2819366455078, -1.34882424678177, 218, 33, 'PPL', 'P'),
(211518, 'Honolulu', 21.3069400787354, 0.371876257899072, -157.858337402344, -2.75514773939501, 218, 15, 'PPL', 'P'),
(72943, 'Honolulu (historical)', 39.1674995422363, 0.683601826785396, -83.8372192382813, -1.46323551142434, 218, 41, 'PPL', 'P'),
(211522, 'Honolulu Landing', 19.5583305358887, 0.341357264044604, -154.883605957031, -2.7032288813117, 218, 15, 'PPL', 'P'),
(211528, 'Honomakau', 20.2399997711182, 0.353254636608911, -155.820556640625, -2.71958175566922, 218, 15, 'PPL', 'P'),
(211527, 'HonomÃƒÂ¤Ã‚â€˜ele (historical)', 20.8011093139648, 0.363047845595945, -156.03889465332, -2.72339247287302, 218, 15, 'PPL', 'P'),
(211525, 'Honomu', 19.8733291625977, 0.346855027219937, -155.117492675781, -2.70731097463057, 218, 15, 'PPL', 'P'),
(131352, 'Honor', 44.663890838623, 0.779531951885304, -86.0180587768555, -1.50129834183013, 218, 27, 'PPL', 'P'),
(22042, 'Honora', 33.9072189331055, 0.591792610577249, -82.5100021362305, -1.44007120310478, 218, 13, 'PPL', 'P'),
(3218, 'Honoraville', 31.8505592346191, 0.555897127245589, -86.4061126708984, -1.50807115995637, 218, 2, 'PPL', 'P'),
(16488, 'Honore', 27.2425003051758, 0.475471326800877, -82.2633285522461, -1.43576593688655, 218, 12, 'PPL', 'P'),
(41401, 'Honore', 32.5563888549805, 0.568216178078996, -93.732780456543, -1.63594563601567, 218, 22, 'PPL', 'P'),
(211541, 'Honouliuli', 21.3677806854248, 0.372938126804714, -158.036117553711, -2.75825058838106, 218, 15, 'PPL', 'P'),
(76124, 'Hontubby', 34.8502807617188, 0.60825214453643, -94.5658264160156, -1.6504850308289, 218, 42, 'PPL', 'P'),
(211548, 'HonuÃ‚â€˜apo', 19.0933303833008, 0.33324148035967, -155.551116943359, -2.71487914581636, 218, 15, 'PPL', 'P'),
(3219, 'Hood', 33.8883285522461, 0.591462911234298, -86.1549987792969, -1.50368839575043, 218, 2, 'PPL', 'P'),
(22043, 'Hood', 34.7636108398438, 0.606739469037265, -83.8741683959961, -1.4638803958823, 218, 13, 'PPL', 'P'),
(41399, 'Hood', 31.288330078125, 0.546084377314056, -92.8930587768555, -1.62128972790474, 218, 22, 'PPL', 'P'),
(94982, 'Hood', 33.542781829834, 0.585431983208731, -97.3488922119141, -1.69905869226697, 218, 51, 'PPL', 'P'),
(102935, 'Hood', 38.3547210693359, 0.669416166343952, -78.383056640625, -1.36804241615611, 218, 53, 'PPL', 'P'),
(162812, 'Hood', 40.3608283996582, 0.704429344406469, -74.9633331298828, -1.3083569813858, 218, 45, 'PPL', 'P'),
(182200, 'Hood', 38.3683280944824, 0.66965365373416, -121.516387939453, -2.12086106467418, 218, 6, 'PPL', 'P'),
(207679, 'Hood', 45.7249984741211, 0.798051773842796, -121.556938171387, -2.12156879973387, 218, 56, 'PPL', 'P'),
(22044, 'Hood (historical)', 34.8327789306641, 0.607946679959398, -83.8994369506836, -1.46432141535882, 218, 13, 'PPL', 'P'),
(209978, 'Hood Bay', 57.3824996948242, 1.00151355269932, -134.39860534668, -2.34569817338802, 218, 1, 'PPL', 'P'),
(182201, 'Hood Junction', 38.3636093139648, 0.66957129547745, -121.508613586426, -2.12072537661665, 218, 6, 'PPL', 'P'),
(87943, 'Hood Lake', 35.2130584716797, 0.614583810028093, -87.3338928222656, -1.52426397833238, 218, 50, 'PPL', 'P'),
(200994, 'Hood River', 45.7055587768555, 0.79771248711992, -121.520278930664, -2.12092897528198, 218, 43, 'PPL', 'P'),
(65732, 'Hood Swamp', 35.4063911437988, 0.617958101708251, -77.875, -1.35917515499058, 218, 33, 'PPL', 'P'),
(207680, 'Hood View Tracts', 45.7255592346191, 0.798061560959802, -121.595001220703, -2.12223312526779, 218, 56, 'PPL', 'P'),
(87946, 'Hoodoo', 35.6383285522461, 0.622006173144198, -86.1761093139648, -1.50405684408724, 218, 50, 'PPL', 'P'),
(65733, 'Hoods', 35.1372184753418, 0.613260152387296, -80.6830596923828, -1.4081850422152, 218, 33, 'PPL', 'P'),
(65734, 'Hoods (historical)', 35.1208305358887, 0.612974128886222, -80.6622161865234, -1.4078212544103, 218, 33, 'PPL', 'P'),
(3220, 'Hoods Crossroads', 33.9883308410645, 0.593208280433708, -86.420280456543, -1.50831843446358, 218, 2, 'PPL', 'P'),
(48282, 'Hoods Mill', 39.3547210693359, 0.686869458863896, -77.0119400024414, -1.34411191639093, 218, 25, 'PPL', 'P'),
(207681, 'Hoodsport', 47.4061088562012, 0.827392685099554, -123.138061523438, -2.14916460810733, 218, 56, 'PPL', 'P'),
(109709, 'Hoodsville', 39.5730590820313, 0.69068017606769, -80.1544418334961, -1.39895892009279, 218, 58, 'PPL', 'P'),
(60309, 'Hoodtown', 31.9777793884277, 0.558117537804443, -90.6047210693359, -1.58135070051099, 218, 30, 'PPL', 'P'),
(81632, 'Hoodtown', 34.9002799987793, 0.609124795846621, -81.4022216796875, -1.42073678674886, 218, 48, 'PPL', 'P'),
(200995, 'Hoodview', 45.3247184753418, 0.791065569934219, -122.804443359375, -2.14334187269998, 218, 43, 'PPL', 'P'),
(27463, 'Hoodville', 38.0491714477539, 0.664083319419123, -88.5272216796875, -1.54509149595345, 218, 18, 'PPL', 'P'),
(102937, 'Hooes', 38.3572196960449, 0.669459775606802, -77.0672225952148, -1.34507677965387, 218, 53, 'PPL', 'P'),
(207682, 'Hoogdal', 48.5583305358887, 0.84750274712296, -122.258056640625, -2.13380562546862, 218, 56, 'PPL', 'P'),
(109710, 'Hoohoo', 37.7427787780762, 0.658735758529271, -81.3099975585938, -1.41912717218601, 218, 58, 'PPL', 'P'),
(27464, 'Hookdale', 38.8263893127441, 0.677648330168524, -89.311393737793, -1.55877788026953, 218, 18, 'PPL', 'P'),
(9558, 'Hooker', 34.1197204589844, 0.595501461869348, -91.8808288574219, -1.60362298302343, 218, 4, 'PPL', 'P'),
(22045, 'Hooker', 34.978889465332, 0.610496789861203, -85.4338912963867, -1.49110269591288, 218, 13, 'PPL', 'P'),
(36488, 'Hooker', 37.1361083984375, 0.648147362930253, -83.835563659668, -1.46320661612651, 218, 21, 'PPL', 'P'),
(55367, 'Hooker', 37.8600006103516, 0.660781665457698, -92.0605621337891, -1.60675992047144, 218, 29, 'PPL', 'P'),
(60310, 'Hooker', 31.6341705322266, 0.55212043192472, -90.0491714477539, -1.57165453045617, 218, 30, 'PPL', 'P'),
(65735, 'Hooker', 36.5036087036133, 0.637108160737711, -81.0255584716797, -1.414162773598, 218, 33, 'PPL', 'P'),
(72944, 'Hooker', 39.747501373291, 0.693724768404896, -82.6600036621094, -1.44268922361438, 218, 41, 'PPL', 'P'),
(149686, 'Hooker', 43.6925010681152, 0.76257800206975, -75.7441711425781, -1.32198517563206, 218, 40, 'PPL', 'P'),
(162813, 'Hooker', 40.996940612793, 0.715531596937819, -79.831672668457, -1.39332553543894, 218, 45, 'PPL', 'P'),
(170543, 'Hooker', 43.2000007629395, 0.753982250177356, -97.0244369506836, -1.69339587968308, 218, 49, 'PPL', 'P'),
(190992, 'Hooker', 36.8600006103516, 0.643328372937754, -101.21305847168, -1.76650111634435, 218, 42, 'PPL', 'P'),
(193647, 'Hooker', 40.3008308410645, 0.70338218946585, -122.325828552246, -2.13498846846678, 218, 6, 'PPL', 'P'),
(122832, 'Hooker Corner', 40.454719543457, 0.706068054004222, -87.3163909912109, -1.52395851375535, 218, 19, 'PPL', 'P'),
(87944, 'Hooker Hills', 35.9311103820801, 0.627116180064815, -86.7497177124023, -1.51406819925706, 218, 50, 'PPL', 'P'),
(41400, 'Hooker Hole', 32.8222198486328, 0.572855804172077, -92.0672225952148, -1.60687616745302, 218, 22, 'PPL', 'P'),
(16489, 'Hooker Point', 26.7397193908691, 0.466696144430039, -80.9169387817383, -1.41226700237602, 218, 12, 'PPL', 'P'),
(94985, 'Hooker Ridge', 32.9143409729004, 0.574463621101186, -95.9651565551758, -1.67490794907964, 218, 51, 'PPL', 'P'),
(87945, 'Hookers Bend', 35.3205604553223, 0.616460073595081, -88.2152786254883, -1.53964706257895, 218, 50, 'PPL', 'P'),
(178381, 'Hookers Hot Springs', 32.3386116027832, 0.564415247992208, -110.238891601563, -1.92403162219639, 218, 5, 'PPL', 'P'),
(109712, 'Hookersville', 38.3699989318848, 0.669682815348097, -80.8222198486328, -1.41061384512936, 218, 58, 'PPL', 'P'),
(65736, 'Hookerton', 35.4249992370605, 0.618282874203186, -77.5886077880859, -1.35417666794061, 218, 33, 'PPL', 'P'),
(3234, 'Hooks', 32.1916694641113, 0.561850623862461, -85.2324981689453, -1.48758772274813, 218, 2, 'PPL', 'P'),
(94984, 'Hooks', 33.4661102294922, 0.584093811339994, -94.288330078125, -1.64564180607048, 218, 51, 'PPL', 'P'),
(162814, 'Hooks', 40.9272193908691, 0.714314732056735, -79.4880599975586, -1.38732836298019, 218, 45, 'PPL', 'P'),
(186864, 'Hooks', 39.3741683959961, 0.687208878744826, -107.08805847168, -1.86903920989902, 218, 7, 'PPL', 'P'),
(72945, 'Hooks Corner', 39.8211097717285, 0.69500947731475, -84.1449966430664, -1.46860724050108, 218, 41, 'PPL', 'P'),
(131353, 'Hooks Corner', 41.8277816772461, 0.730032509073301, -86.668327331543, -1.51264766913162, 218, 27, 'PPL', 'P'),
(143979, 'Hooks Crossing', 43.0250015258789, 0.750927937302171, -71.3308334350586, -1.24495790163343, 218, 36, 'PPL', 'P'),
(3221, 'Hooks Crossroads', 32.0513916015625, 0.559402313293324, -85.852783203125, -1.49841373889542, 218, 2, 'PPL', 'P'),
(102938, 'Hooks Mill', 37.7144393920898, 0.658241142935816, -79.9127807617188, -1.39474113871637, 218, 53, 'PPL', 'P'),
(109711, 'Hooks Mills', 39.2419395446777, 0.684901049923191, -78.4638900756836, -1.36945322574358, 218, 58, 'PPL', 'P'),
(72946, 'Hooksburg', 39.583610534668, 0.690864333657069, -81.7838897705078, -1.42739815158347, 218, 41, 'PPL', 'P'),
(143980, 'Hooksett', 43.0966682434082, 0.752178757487154, -71.4655609130859, -1.24730933971791, 218, 36, 'PPL', 'P'),
(60311, 'Hookston', 32.4316711425781, 0.56603944336202, -88.7905578613281, -1.54968757936271, 218, 30, 'PPL', 'P'),
(182203, 'Hookston', 37.9413909912109, 0.662202195583146, -122.051666259766, -2.13020343377818, 218, 6, 'PPL', 'P'),
(162815, 'Hookstown', 40.5991706848145, 0.708589202029173, -80.4730606079102, -1.40451986676498, 218, 45, 'PPL', 'P'),
(193648, 'Hookton', 40.6733283996582, 0.709883498318952, -124.217216491699, -2.16799941544275, 218, 6, 'PPL', 'P'),
(36489, 'Hooktown', 38.3544387817383, 0.669411239495936, -84.1516723632813, -1.46872375379878, 218, 21, 'PPL', 'P'),
(209977, 'Hoonah', 58.1100006103516, 1.01421083898655, -135.443603515625, -2.36393683211342, 218, 1, 'PPL', 'P'),
(94986, 'Hoop and Holler', 30.4680595397949, 0.53176795566309, -94.7430572509766, -1.65357829243503, 218, 51, 'PPL', 'P'),
(87947, 'Hoop Creek', 36.521671295166, 0.637423412431749, -83.4194412231445, -1.45594390951776, 218, 50, 'PPL', 'P'),
(9559, 'Hoop Spur', 34.3438911437988, 0.599413978405811, -90.836669921875, -1.58539897168402, 218, 4, 'PPL', 'P'),
(193649, 'Hoopa', 41.0505599975586, 0.716467431744873, -123.673057556152, -2.15850205036331, 218, 6, 'PPL', 'P'),
(16490, 'Hooper', 28.670560836792, 0.500395684995361, -82.2680587768555, -1.43584849488035, 218, 12, 'PPL', 'P'),
(22046, 'Hooper', 33.7383308410645, 0.588844957303722, -85.3375015258789, -1.48942037705227, 218, 13, 'PPL', 'P'),
(36490, 'Hooper', 38.1747207641602, 0.66627456836404, -85.1569366455078, -1.48626892537633, 218, 21, 'PPL', 'P'),
(76125, 'Hooper', 34.1591682434082, 0.596189955590161, -98.1736068725586, -1.71345267848468, 218, 42, 'PPL', 'P'),
(120064, 'Hooper', 40.9358291625977, 0.714465000921242, -87.6066665649414, -1.52902477825506, 218, 18, 'PPL', 'P'),
(131354, 'Hooper', 42.5102806091309, 0.741944362576034, -85.5627822875977, -1.49335226808566, 218, 27, 'PPL', 'P'),
(142080, 'Hooper', 41.6105613708496, 0.726241299524491, -96.5477828979492, -1.68507669706989, 218, 35, 'PPL', 'P'),
(178382, 'Hooper', 34.2661094665527, 0.598056432040143, -112.382217407227, -1.96143971444819, 218, 5, 'PPL', 'P'),
(186865, 'Hooper', 37.7427787780762, 0.658735758529271, -105.874717712402, -1.84786241870098, 218, 7, 'PPL', 'P'),
(193650, 'Hooper', 41.2680587768555, 0.720263501562672, -122.16056060791, -2.13210399869012, 218, 6, 'PPL', 'P'),
(204402, 'Hooper', 41.163890838623, 0.718445428065502, -112.121673583984, -1.95689236688688, 218, 52, 'PPL', 'P'),
(207685, 'Hooper', 46.7750015258789, 0.816377784251959, -118.147499084473, -2.06206286202103, 218, 56, 'PPL', 'P'),
(182202, 'Hooper (historical)', 38.019718170166, 0.663569262749711, -121.850280761719, -2.1266885937715, 218, 6, 'PPL', 'P'),
(87949, 'Hooper Acres', 35.2402801513672, 0.615058917966563, -84.8450012207031, -1.48082462515988, 218, 50, 'PPL', 'P'),
(211878, 'Hooper Bay', 61.5311088562012, 1.07392044194375, -166.096664428711, -2.89893367086115, 218, 1, 'PPL', 'P'),
(3223, 'Hooper City', 33.5552787780762, 0.585650096102009, -86.8411102294922, -1.51566329959197, 218, 2, 'PPL', 'P'),
(65738, 'Hooper Hill', 34.3300018310547, 0.599171564167586, -78.0758285522461, -1.36268027445929, 218, 33, 'PPL', 'P'),
(48283, 'Hooper Islands', 38.2999992370605, 0.668461090198023, -76.2083282470703, -1.33008624535198, 218, 25, 'PPL', 'P'),
(207684, 'Hooper Junction', 46.7513885498047, 0.815965660073269, -118.163330078125, -2.06233916498413, 218, 56, 'PPL', 'P'),
(65739, 'Hoopers Creek', 35.4388885498047, 0.61852528844141, -82.4669418334961, -1.43931965904516, 218, 33, 'PPL', 'P'),
(174566, 'Hoopers Mill', 43.0966682434082, 0.752178757487154, -88.8813934326172, -1.55127295915963, 218, 57, 'PPL', 'P'),
(48284, 'Hoopers Neck', 38.3549995422363, 0.669421026612942, -76.4655609130859, -1.33457580231763, 218, 25, 'PPL', 'P'),
(149687, 'Hoopers Valley', 42.0263900756836, 0.733498879548148, -76.3933334350586, -1.33331519501564, 218, 40, 'PPL', 'P'),
(48285, 'Hoopersville', 38.2611083984375, 0.667782317015189, -76.1802825927734, -1.32959675634362, 218, 25, 'PPL', 'P'),
(193651, 'Hooperville', 41.6788902282715, 0.727433863060628, -122.847778320313, -2.14409821044956, 218, 6, 'PPL', 'P'),
(102939, 'Hoopes Landing', 37.1230583190918, 0.647919596078024, -76.5680618286133, -1.33636478077989, 218, 53, 'PPL', 'P'),
(120065, 'Hoopeston', 40.4672203063965, 0.706286233476527, -87.668327331543, -1.53010096165156, 218, 18, 'PPL', 'P'),
(65741, 'Hoophole Landing', 35.6130599975586, 0.621565153667681, -76.5769424438477, -1.33651977675533, 218, 33, 'PPL', 'P'),
(140244, 'Hoople', 48.5347213745117, 0.847090689523297, -97.6344375610352, -1.70404239877289, 218, 34, 'PPL', 'P'),
(120066, 'Hooppole', 41.5222206115723, 0.72469946241139, -89.9097213745117, -1.56922066753595, 218, 18, 'PPL', 'P'),
(211563, 'Hoopuloa', 19.2005596160889, 0.335112983526209, -155.906936645508, -2.72108937116231, 218, 15, 'PPL', 'P'),
(196738, 'Hoosac', 47.2758293151855, 0.825118878160844, -109.83943939209, -1.91705986593673, 218, 31, 'PPL', 'P'),
(125100, 'Hoosac Tunnel', 42.6691703796387, 0.744717512219134, -72.9933319091797, -1.27397397381622, 218, 23, 'PPL', 'P'),
(125101, 'Hoosac Tunnel Station', 42.6683311462402, 0.744702864833138, -72.9875030517578, -1.27387224106258, 218, 23, 'PPL', 'P'),
(32796, 'Hooser', 37.1383285522461, 0.648186111924113, -96.6297225952148, -1.68650681457526, 218, 20, 'PPL', 'P'),
(149688, 'Hoosick', 42.8624992370605, 0.748091737320264, -73.32861328125, -1.27982573767946, 218, 40, 'PPL', 'P'),
(149689, 'Hoosick Falls', 42.9011116027832, 0.748765650234109, -73.351936340332, -1.28023280185207, 218, 40, 'PPL', 'P'),
(149690, 'Hoosick Junction', 42.922779083252, 0.7491438191089, -73.3600006103516, -1.28037354991568, 218, 40, 'PPL', 'P'),
(162817, 'Hoosicks Mill', 40.8022193908691, 0.712133070491742, -79.2363891601563, -1.38293587823627, 218, 45, 'PPL', 'P'),
(27465, 'Hoosier', 38.7802810668945, 0.676843589466129, -88.4555587768555, -1.5438407423475, 218, 18, 'PPL', 'P'),
(30106, 'Hoosier', 39.0666694641113, 0.681842009937071, -87.1858291625977, -1.52167977996862, 218, 19, 'PPL', 'P'),
(30107, 'Hoosier Acres', 39.1577796936035, 0.683432183423958, -86.4869384765625, -1.50948183638578, 218, 19, 'PPL', 'P'),
(30108, 'Hoosierville', 39.4749984741211, 0.688968695593151, -87.1083297729492, -1.52032716045097, 218, 19, 'PPL', 'P'),
(94988, 'Hoot', 33.3291702270508, 0.581703757419702, -94.0483322143555, -1.64145305314995, 218, 51, 'PPL', 'P'),
(94987, 'Hoot and Holler Crossing', 33.954719543457, 0.592621652624591, -99.2394409179688, -1.73205499185694, 218, 51, 'PPL', 'P'),
(76126, 'Hoot Owl', 36.3597183227539, 0.634596799829766, -95.1211090087891, -1.66017654035181, 218, 42, 'PPL', 'P'),
(70966, 'Hoot Owl Estates', 39.8827781677246, 0.696085793869306, -74.8475036621094, -1.30633537580232, 218, 37, 'PPL', 'P'),
(48297, 'Hoot''N Hollow', 39.7183303833008, 0.6932156385835, -77.0994415283203, -1.34563910611804, 218, 25, 'PPL', 'P'),
(87950, 'Hooten (historical)', 36.0486106872559, 0.629166947262231, -89.1119384765625, -1.55529672925064, 218, 50, 'PPL', 'P'),
(36491, 'Hootentown', 37.9255599975586, 0.66192589262005, -84.2925033569336, -1.47118171832686, 218, 21, 'PPL', 'P'),
(65742, 'Hootentown', 35.5361099243164, 0.620222121529954, -77.0199966430664, -1.34425253129649, 218, 33, 'PPL', 'P'),
(65743, 'Hootstown', 36.0488891601563, 0.62917180753122, -80.2669372558594, -1.40092233560645, 218, 33, 'PPL', 'P'),
(72948, 'Hooven', 39.1780586242676, 0.683786117532829, -84.7591705322266, -1.47932659704671, 218, 41, 'PPL', 'P'),
(72947, 'Hooven (historical)', 39.5224990844727, 0.689797737640492, -82.9361114501953, -1.44750821360688, 218, 41, 'PPL', 'P'),
(3225, 'Hoover', 34.855281829834, 0.608339429641157, -86.7355575561523, -1.5138210579079, 218, 2, 'PPL', 'P'),
(55369, 'Hoover', 39.3688888549805, 0.68711673337111, -94.6666717529297, -1.65224511399334, 218, 29, 'PPL', 'P'),
(76127, 'Hoover', 34.521110534668, 0.602507040274856, -97.246940612793, -1.69727930118463, 218, 42, 'PPL', 'P'),
(122833, 'Hoover', 40.8088912963867, 0.712249517210405, -86.2005615234375, -1.50448361565192, 218, 19, 'PPL', 'P'),
(162818, 'Hoover', 41.665828704834, 0.727205896471318, -79.0236129760742, -1.37922223325421, 218, 45, 'PPL', 'P'),
(191625, 'Hoover', 35.5938911437988, 0.62123059405574, -100.850280761719, -1.76016945085269, 218, 51, 'PPL', 'P'),
(195107, 'Hoover', 44.752498626709, 0.781078449530312, -116.440559387207, -2.03227114417075, 218, 17, 'PPL', 'P'),
(202225, 'Hoover', 45.1124992370605, 0.787361645490136, -103.266670227051, -1.80234340303324, 218, 49, 'PPL', 'P'),
(9560, 'Hoover (historical)', 36.250560760498, 0.63269164096495, -94.341667175293, -1.64657271402952, 218, 4, 'PPL', 'P'),
(9561, 'Hoover Addition', 34.8958282470703, 0.609047098121818, -92.0280609130859, -1.60619266715925, 218, 4, 'PPL', 'P'),
(190315, 'Hoover City (historical)', 36.1963882446289, 0.631746152198945, -115.132499694824, -2.00944119572605, 218, 39, 'PPL', 'P'),
(30109, 'Hoover Crest', 39.8875007629395, 0.696168218705044, -86.1741714477539, -1.50402302194139, 218, 19, 'PPL', 'P'),
(9562, 'Hoover Landing', 36.188060760498, 0.631600810182454, -90.9894409179688, -1.58806532856741, 218, 4, 'PPL', 'P'),
(16493, 'Hoover Mill', 30.8694400787354, 0.538773367621029, -85.6861114501953, -1.49550476803672, 218, 12, 'PPL', 'P'),
(30110, 'Hoover Mill', 39.8638916015625, 0.695756161105381, -85.0644378662109, -1.48465451712352, 218, 19, 'PPL', 'P'),
(122834, 'Hoover Park', 40.4541702270508, 0.706058466624298, -85.3611068725586, -1.48983236807291, 218, 19, 'PPL', 'P'),
(109713, 'Hoover Town', 38.8805618286133, 0.678593818934529, -80.3077774047852, -1.40163513067221, 218, 58, 'PPL', 'P'),
(162819, 'Hooverhurst', 40.8047218322754, 0.712176746333619, -78.8552780151367, -1.37628423393963, 218, 45, 'PPL', 'P'),
(192627, 'Hoovers', 38.5041694641113, 0.672024532894603, -112.256942749023, -1.95925325919323, 218, 52, 'PPL', 'P'),
(186866, 'Hoovers Corner', 38.6069412231445, 0.673818238467799, -108.058326721191, -1.88597358548056, 218, 7, 'PPL', 'P'),
(131355, 'Hoovers Corners', 43.1002807617188, 0.752241807825962, -84.3055572509766, -1.47140955175812, 218, 27, 'PPL', 'P'),
(177232, 'Hooverson Heights', 40.3247184753418, 0.703799107334502, -80.5777816772461, -1.4063475942211, 218, 58, 'PPL', 'P'),
(162820, 'Hooversville', 40.1469383239746, 0.700696258348451, -78.9122161865234, -1.3772779925004, 218, 45, 'PPL', 'P'),
(162822, 'Hooverton', 40.1477813720703, 0.700710972313474, -75.3308334350586, -1.3147710717132, 218, 45, 'PPL', 'P'),
(162823, 'Hoovertown', 41.2163887023926, 0.719361688638544, -78.584716796875, -1.37156204985276, 218, 45, 'PPL', 'P'),
(162824, 'Hooverville', 40.4127807617188, 0.705336084178614, -79.0272216796875, -1.37928521701399, 218, 45, 'PPL', 'P'),
(188699, 'Hooverville', 35.3761100769043, 0.617429597389924, -104.217216491699, -1.81893356504388, 218, 38, 'PPL', 'P'),
(162825, 'Hop Bottom', 41.7058296203613, 0.727904044151082, -75.7666702270508, -1.3223778587348, 218, 45, 'PPL', 'P'),
(102940, 'Hop Yard Landing', 38.2441711425781, 0.66748670613419, -77.2261123657227, -1.34784992929697, 218, 53, 'PPL', 'P'),
(145459, 'Hopatcong', 40.9327812194824, 0.714411804278468, -74.6597213745117, -1.30305795660682, 218, 37, 'PPL', 'P'),
(145460, 'Hopatcong Heights', 40.9205589294434, 0.714198485075153, -74.6786117553711, -1.30338765594977, 218, 37, 'PPL', 'P'),
(145461, 'Hopatcong Hills', 40.9438896179199, 0.714605682405826, -74.6711120605469, -1.30325676158219, 218, 37, 'PPL', 'P'),
(9564, 'Hope', 33.6669387817383, 0.587598930808702, -93.5913925170898, -1.6334779509496, 218, 4, 'PPL', 'P'),
(30111, 'Hope', 39.3038902282715, 0.685982293325763, -85.7713928222656, -1.49699320876997, 218, 19, 'PPL', 'P'),
(32798, 'Hope', 38.6902809143066, 0.675272790476173, -97.0763931274414, -1.69430268603425, 218, 20, 'PPL', 'P'),
(36492, 'Hope', 38.0158309936523, 0.663501418720941, -83.773063659668, -1.46211578534402, 218, 21, 'PPL', 'P'),
(41404, 'Hope', 30.3425006866455, 0.529576540270604, -91.8300018310547, -1.60273588406433, 218, 22, 'PPL', 'P'),
(48287, 'Hope', 39.0419387817383, 0.681410378103397, -75.9697189331055, -1.32592172719736, 218, 25, 'PPL', 'P'),
(55370, 'Hope', 38.5283317565918, 0.672446244453217, -91.6711120605469, -1.59996273442123, 218, 29, 'PPL', 'P'),
(60312, 'Hope', 32.7472190856934, 0.571546793917276, -89.2452774047852, -1.5576239325692, 218, 30, 'PPL', 'P'),
(72949, 'Hope', 39.3183288574219, 0.686234294943912, -82.3372192382813, -1.43705557264443, 218, 41, 'PPL', 'P'),
(76128, 'Hope', 34.5688896179199, 0.603340942591187, -97.8363876342773, -1.70756709247561, 218, 42, 'PPL', 'P'),
(94990, 'Hope', 29.2163906097412, 0.509922211688738, -96.9974975585938, -1.69292569859262, 218, 51, 'PPL', 'P'),
(113096, 'Hope', 44.2649993896484, 0.772569982742646, -69.1594390869141, -1.20705992089911, 218, 26, 'PPL', 'P'),
(120067, 'Hope', 40.2055587768555, 0.701719378260232, -87.904167175293, -1.53421714343239, 218, 18, 'PPL', 'P'),
(131356, 'Hope', 43.7644386291504, 0.763833549365668, -84.3380584716797, -1.47197680507031, 218, 27, 'PPL', 'P'),
(136006, 'Hope', 43.9619407653809, 0.767280611922612, -93.2758331298828, -1.62797040065726, 218, 28, 'PPL', 'P'),
(140246, 'Hope', 47.3222198486328, 0.825928545711255, -97.7219390869141, -1.70556958849999, 218, 34, 'PPL', 'P'),
(145463, 'Hope', 40.9111099243164, 0.714033568824649, -74.9677810668945, -1.30843461253158, 218, 37, 'PPL', 'P'),
(149692, 'Hope', 43.3036117553711, 0.755790603136547, -74.2436065673828, -1.29579538315612, 218, 40, 'PPL', 'P'),
(169420, 'Hope', 41.7333297729492, 0.728384012358541, -71.5630569458008, -1.24901096649642, 218, 47, 'PPL', 'P'),
(174567, 'Hope', 43.0516700744629, 0.75139339128169, -89.2461090087891, -1.55763844679714, 218, 57, 'PPL', 'P'),
(178383, 'Hope', 33.7230606079102, 0.588578441457633, -113.701667785645, -1.98446846786827, 218, 5, 'PPL', 'P'),
(188700, 'Hope', 32.8102798461914, 0.572647411816779, -104.732223510742, -1.82792213319707, 218, 38, 'PPL', 'P'),
(195106, 'Hope', 48.2477798461914, 0.842082615093403, -116.306106567383, -2.02992449977623, 218, 17, 'PPL', 'P'),
(207686, 'Hope', 47.2380599975586, 0.824459679212022, -122.601112365723, -2.13979307738939, 218, 56, 'PPL', 'P'),
(211879, 'Hope', 60.920280456543, 1.06325947520503, -149.640274047852, -2.61171547572163, 218, 1, 'PPL', 'P'),
(81633, 'Hope (historical)', 33.2236099243164, 0.579861382577585, -80.290283203125, -1.40132979925323, 218, 48, 'PPL', 'P'),
(109714, 'Hope (historical)', 38.7986106872559, 0.677163501692075, -80.8127822875977, -1.41044912861593, 218, 58, 'PPL', 'P'),
(182205, 'Hope (historical)', 36.0222206115723, 0.628706353551701, -119.025001525879, -2.07737816881786, 218, 6, 'PPL', 'P'),
(48288, 'Hope Acres', 38.5927810668945, 0.67357109711864, -76.9725036621094, -1.3434236224072, 218, 25, 'PPL', 'P'),
(87951, 'Hope Acres', 35.2277793884277, 0.614840738494258, -84.8888931274414, -1.48159068344744, 218, 50, 'PPL', 'P'),
(81634, 'Hope Ferry Estates', 34.0119400024414, 0.593620338033371, -81.1994400024414, -1.4171975788182, 218, 48, 'PPL', 'P'),
(48289, 'Hope Hill', 39.3333282470703, 0.686496083679067, -77.3966674804688, -1.3508266776054, 218, 25, 'PPL', 'P'),
(3226, 'Hope Hull', 32.269718170166, 0.563212830760037, -86.3572235107422, -1.50721788314311, 218, 2, 'PPL', 'P'),
(48290, 'Hope Meadows', 39.5872192382813, 0.690927317416849, -76.6661071777344, -1.33807599493832, 218, 25, 'PPL', 'P'),
(65746, 'Hope Mills', 34.9702796936035, 0.610346520996695, -78.945556640625, -1.37785989319858, 218, 33, 'PPL', 'P'),
(162826, 'Hope Mills', 41.1902809143066, 0.718906021776031, -80.2275009155273, -1.40023404162272, 218, 45, 'PPL', 'P'),
(182206, 'Hope Ranch', 34.4219398498535, 0.600776185303386, -119.769996643066, -2.09038078652406, 218, 6, 'PPL', 'P'),
(72950, 'Hope Ridge (historical)', 39.7902793884277, 0.6944713856165, -81.1236114501953, -1.41587412091448, 218, 41, 'PPL', 'P'),
(113571, 'Hope Valley', 41.6336097717285, 0.726643570007147, -72.3755569458008, -1.26319176666887, 218, 8, 'PPL', 'P'),
(169421, 'Hope Valley', 41.5074996948242, 0.724442533945224, -71.716667175293, -1.2516919707658, 218, 47, 'PPL', 'P'),
(48291, 'Hope Valley Hills', 39.3169403076172, 0.686210060177992, -77.3916702270508, -1.3507394590797, 218, 25, 'PPL', 'P'),
(41405, 'Hope Villa', 30.3427791595459, 0.529581400539594, -90.9824981689453, -1.58794415473781, 218, 22, 'PPL', 'P'),
(22047, 'Hopecastle Forest', 33.9683303833008, 0.592859206593826, -84.7819366455078, -1.47972394068135, 218, 13, 'PPL', 'P'),
(41406, 'Hopedale', 29.8202800750732, 0.52046207117689, -89.6566696166992, -1.56480408118416, 218, 22, 'PPL', 'P'),
(60314, 'Hopedale', 32.9569396972656, 0.575207109098508, -91.0124969482422, -1.58846773220812, 218, 30, 'PPL', 'P'),
(65750, 'Hopedale', 36.1238899230957, 0.630480817786021, -79.4024963378906, -1.38583499539893, 218, 33, 'PPL', 'P'),
(120069, 'Hopedale', 40.4208297729492, 0.705476565926116, -89.414436340332, -1.56057631295366, 218, 18, 'PPL', 'P'),
(125102, 'Hopedale', 42.1305618286133, 0.735317019624345, -71.5416717529297, -1.24863772446965, 218, 23, 'PPL', 'P'),
(155779, 'Hopedale', 40.3252792358398, 0.703808894451508, -80.9013900756836, -1.41199562626094, 218, 41, 'PPL', 'P'),
(9565, 'Hopedale (historical)', 33.7916717529297, 0.589775931841787, -91.4661102294922, -1.59638477749671, 218, 4, 'PPL', 'P'),
(191626, 'Hopedale Colonia', 28.7549991607666, 0.501869411763583, -100.502998352051, -1.75410822936972, 218, 51, 'PPL', 'P'),
(9566, 'Hopefield (historical)', 35.1552810668945, 0.613575404081334, -90.0747222900391, -1.57210047678071, 218, 4, 'PPL', 'P'),
(3227, 'Hopeful', 33.4938888549805, 0.584578639816443, -85.9124984741211, -1.49945596698802, 218, 2, 'PPL', 'P'),
(22049, 'Hopeful', 31.1686096191406, 0.54399486112278, -84.3930587768555, -1.47293674148523, 218, 13, 'PPL', 'P'),
(36493, 'Hopeful Heights', 39.0011100769043, 0.680697782774719, -84.6577835083008, -1.4775570596604, 218, 21, 'PPL', 'P'),
(162827, 'Hopeland', 40.2336082458496, 0.702208933847616, -76.2624969482422, -1.33103166753895, 218, 45, 'PPL', 'P'),
(48292, 'Hopeland Acres', 38.7602806091309, 0.676494515626247, -75.9283294677734, -1.32519934475168, 218, 25, 'PPL', 'P'),
(145465, 'Hopelawn', 40.5269393920898, 0.707328528148157, -74.293327331543, -1.29666317419732, 218, 37, 'PPL', 'P'),
(109716, 'Hopemont', 39.4372215270996, 0.688309363486274, -79.5175018310547, -1.38784221991252, 218, 58, 'PPL', 'P'),
(76130, 'Hopeton', 36.688060760498, 0.640327456442426, -98.6655578613281, -1.72203884299715, 218, 42, 'PPL', 'P'),
(102941, 'Hopeton', 37.8072204589844, 0.659860478036639, -75.6377792358398, -1.32012828656201, 218, 53, 'PPL', 'P'),
(182207, 'Hopeton', 37.4916687011719, 0.654353060902355, -120.529998779297, -2.10364532612348, 218, 6, 'PPL', 'P'),
(72951, 'Hopetown', 39.3786087036133, 0.687286376732548, -82.9752807617188, -1.4481918470587, 218, 41, 'PPL', 'P'),
(22050, 'Hopeulikit', 32.5213890075684, 0.567605315503959, -81.8505630493164, -1.42856181982178, 218, 13, 'PPL', 'P'),
(9567, 'Hopeville', 33.7897186279297, 0.589741843379834, -92.5572204589844, -1.61542824350353, 218, 4, 'PPL', 'P'),
(30112, 'Hopeville', 39.7013893127441, 0.692919961123474, -84.9705581665039, -1.48301600726285, 218, 19, 'PPL', 'P'),
(109717, 'Hopeville', 38.9672203063965, 0.680106294696612, -79.2869415283203, -1.38381818350541, 218, 58, 'PPL', 'P'),
(113573, 'Hopeville', 41.6124992370605, 0.726275121670335, -71.9388885498047, -1.25557046541934, 218, 8, 'PPL', 'P'),
(116078, 'Hopeville', 40.9427795410156, 0.714586307908895, -93.9963912963867, -1.64054651311489, 218, 16, 'PPL', 'P'),
(41407, 'Hopeville (historical)', 30.3444404602051, 0.529610395705962, -90.9836120605469, -1.58796359581377, 218, 22, 'PPL', 'P'),
(3233, 'Hopewell', 32.5250015258789, 0.567668365842767, -85.3024978637695, -1.48880944789821, 218, 2, 'PPL', 'P'),
(9572, 'Hopewell', 35.978328704834, 0.62794029526414, -91.0888900756836, -1.58980104380787, 218, 4, 'PPL', 'P'),
(16492, 'Hopewell', 30.3819408416748, 0.530264900833363, -83.4447174072266, -1.45638506215233, 218, 12, 'PPL', 'P'),
(22053, 'Hopewell', 32.8224983215332, 0.572860664441067, -84.9541702270508, -1.48272998376177, 218, 13, 'PPL', 'P'),
(32800, 'Hopewell', 37.8047218322754, 0.659816868773789, -98.9952774047852, -1.72779353463865, 218, 20, 'PPL', 'P'),
(36496, 'Hopewell', 36.9925003051758, 0.645640928870325, -84.0919418334961, -1.46768125939006, 218, 21, 'PPL', 'P'),
(48294, 'Hopewell', 38.0061111450195, 0.663331775359503, -75.8186111450195, -1.32328439876986, 218, 25, 'PPL', 'P'),
(55372, 'Hopewell', 37.8875007629395, 0.661261633665157, -90.7027816772461, -1.58306218098553, 218, 29, 'PPL', 'P'),
(60319, 'Hopewell', 31.336109161377, 0.546918279630387, -89.6611099243164, -1.56488157917189, 218, 30, 'PPL', 'P'),
(65754, 'Hopewell', 35.2261085510254, 0.614811576880322, -77.9880599975586, -1.36114842420028, 218, 33, 'PPL', 'P'),
(76132, 'Hopewell', 34.2333297729492, 0.597484318458967, -96.3727798461914, -1.68202231761567, 218, 42, 'PPL', 'P'),
(81636, 'Hopewell', 34.9266700744629, 0.60958538955715, -81.4413909912109, -1.42142042020068, 218, 48, 'PPL', 'P'),
(87959, 'Hopewell', 35.4919395446777, 0.619451202973404, -89.8402786254883, -1.56800866292386, 218, 50, 'PPL', 'P'),
(94994, 'Hopewell', 31.3441696166992, 0.54705896111497, -95.8211135864258, -1.6723939250106, 218, 51, 'PPL', 'P'),
(102944, 'Hopewell', 36.7466697692871, 0.641350376617125, -79.4641723632813, -1.38691144511154, 218, 53, 'PPL', 'P'),
(109721, 'Hopewell', 39.6636085510254, 0.69226056243757, -79.6750030517578, -1.3905911347897, 218, 58, 'PPL', 'P'),
(113575, 'Hopewell', 41.6644401550293, 0.727181661705398, -72.5838928222656, -1.26682791366321, 218, 8, 'PPL', 'P'),
(120071, 'Hopewell', 40.9847183227539, 0.715318277734504, -89.4572219848633, -1.56132306332332, 218, 18, 'PPL', 'P'),
(122835, 'Hopewell', 41.2811088562012, 0.720491268414901, -85.0205612182617, -1.48388872515207, 218, 19, 'PPL', 'P'),
(145467, 'Hopewell', 41.0491714477539, 0.716443196978953, -74.5500030517578, -1.30114301062499, 218, 37, 'PPL', 'P'),
(155781, 'Hopewell', 40.2224998474121, 0.702015055720258, -80.7099990844727, -1.40865522330566, 218, 41, 'PPL', 'P'),
(162829, 'Hopewell', 40.0711097717285, 0.699372800444736, -79.3444366455078, -1.38482166260416, 218, 45, 'PPL', 'P'),
(200996, 'Hopewell', 45.0972213745117, 0.787094996485992, -123.090827941895, -2.1483402265919, 218, 43, 'PPL', 'P'),
(9573, 'Hopewell (historical)', 34.0636100769043, 0.594522150957499, -93.543327331543, -1.63263905520623, 218, 4, 'PPL', 'P'),
(87960, 'Hopewell (historical)', 35.7138900756836, 0.623324970516006, -86.1722183227539, -1.50398893347944, 218, 50, 'PPL', 'P'),
(78487, 'Hopewell Center', 39.7975006103516, 0.694597419715088, -76.5077819824219, -1.33531269899126, 218, 45, 'PPL', 'P'),
(149694, 'Hopewell Center', 42.9011116027832, 0.748765650234109, -77.184440612793, -1.34712262000327, 218, 40, 'PPL', 'P'),
(87961, 'Hopewell Estates', 35.2383308410645, 0.615024896083637, -84.8925018310547, -1.48165366720722, 218, 50, 'PPL', 'P'),
(155782, 'Hopewell Heights', 41.723331451416, 0.728209508728114, -83.5783309936523, -1.45871705916086, 218, 41, 'PPL', 'P'),
(149695, 'Hopewell Junction', 41.5838890075684, 0.725775778965945, -73.8091735839844, -1.28821309721655, 218, 40, 'PPL', 'P'),
(41408, 'Hopewell Landing', 32.127498626709, 0.560730631466028, -91.3927764892578, -1.59510486227681, 218, 22, 'PPL', 'P'),
(48295, 'Hopewell Manor', 39.642219543457, 0.691887253831769, -76.0652770996094, -1.32758953183003, 218, 25, 'PPL', 'P'),
(87962, 'Hopewell Mill', 35.5208282470703, 0.619955405946783, -84.2594375610352, -1.47060461131864, 218, 50, 'PPL', 'P'),
(87963, 'Hopewell Springs', 35.5294418334961, 0.620105741390318, -84.2694396972656, -1.4707791815281, 218, 50, 'PPL', 'P'),
(48296, 'Hopewell Village', 39.5788917541504, 0.690781975400358, -76.1988906860352, -1.32992152883855, 218, 25, 'PPL', 'P'),
(3235, 'Hopkins', 33.4844398498535, 0.58441372356594, -87.07861328125, -1.51980850982868, 218, 2, 'PPL', 'P'),
(22054, 'Hopkins', 30.9713897705078, 0.540552725413852, -82.4305572509766, -1.43868462828323, 218, 13, 'PPL', 'P'),
(32801, 'Hopkins', 37.8972206115723, 0.661431277026595, -96.9319381713867, -1.69178147143027, 218, 20, 'PPL', 'P'),
(65755, 'Hopkins', 35.8847198486328, 0.626306512514404, -78.3525009155273, -1.36750911814782, 218, 33, 'PPL', 'P'),
(81637, 'Hopkins', 33.9041709899902, 0.591739413934475, -80.8772201538086, -1.41157378154427, 218, 48, 'PPL', 'P'),
(102946, 'Hopkins', 37.7911109924316, 0.659579314804554, -75.704719543457, -1.32129661533222, 218, 53, 'PPL', 'P'),
(109722, 'Hopkins', 38.0902786254883, 0.664800775016791, -81.853889465332, -1.42861987673355, 218, 58, 'PPL', 'P'),
(131359, 'Hopkins', 42.6236114501953, 0.743922358896663, -85.7602767944336, -1.49679919748455, 218, 27, 'PPL', 'P'),
(136008, 'Hopkins', 44.9249992370605, 0.784089153142647, -93.4625015258789, -1.63122837877681, 218, 28, 'PPL', 'P'),
(139218, 'Hopkins', 40.5508308410645, 0.707745512595836, -94.8191680908203, -1.65490667718676, 218, 29, 'PPL', 'P'),
(190989, 'Hopkins', 36.7994384765625, 0.642271364301102, -102.081672668457, -1.78166129400768, 218, 42, 'PPL', 'P'),
(196739, 'Hopkins', 47.2683296203613, 0.824987983793266, -114.868057250977, -2.00482580439889, 218, 31, 'PPL', 'P'),
(149697, 'Hopkins Beach', 43.3013916015625, 0.755751854142686, -78.8883285522461, -1.37686107463175, 218, 40, 'PPL', 'P'),
(48298, 'Hopkins Corner', 39.651668548584, 0.692052170082272, -76.2177810668945, -1.33025122818151, 218, 25, 'PPL', 'P'),
(145470, 'Hopkins Corner', 41.1355590820313, 0.717950945630102, -74.6436080932617, -1.3027767267957, 218, 37, 'PPL', 'P'),
(13988, 'Hopkins Corners', 38.9550018310547, 0.679893042072324, -75.6769409179688, -1.32081178685577, 218, 10, 'PPL', 'P'),
(87964, 'Hopkins Crossing', 36.0844383239746, 0.629792257486181, -87.7736129760742, -1.53193854280371, 218, 50, 'PPL', 'P'),
(109723, 'Hopkins Fork', 38.0830612182617, 0.66467480749723, -81.6413879394531, -1.42491102544145, 218, 58, 'PPL', 'P'),
(169422, 'Hopkins Hollow', 41.6697196960449, 0.727273807079115, -71.7533264160156, -1.2523317952177, 218, 47, 'PPL', 'P'),
(48299, 'Hopkins Landing', 39.3169403076172, 0.686210060177992, -76.4397201538086, -1.33412479598703, 218, 25, 'PPL', 'P'),
(48300, 'Hopkins Mead', 39.166389465332, 0.683582452288465, -76.9147186279297, -1.34241508330239, 218, 25, 'PPL', 'P'),
(22055, 'Hopkins Mill', 33.9486083984375, 0.592514993022933, -84.1611099243164, -1.4688884703122, 218, 13, 'PPL', 'P'),
(102947, 'Hopkins Mill', 36.9397201538086, 0.644719741449266, -79.7675018310547, -1.39220554304251, 218, 53, 'PPL', 'P'),
(169423, 'Hopkins Mills', 41.8222198486328, 0.729935436851567, -71.7033309936523, -1.25145921048653, 218, 47, 'PPL', 'P'),
(120073, 'Hopkins Park', 41.0633316040039, 0.716690338328112, -87.625, -1.52934475706003, 218, 18, 'PPL', 'P'),
(48301, 'Hopkins Ridge', 39.6349983215332, 0.691761219733181, -77.5444412231445, -1.35340581596309, 218, 25, 'PPL', 'P'),
(102948, 'Hopkins Spring', 38.4075012207031, 0.670337353765011, -78.7261123657227, -1.37402986807688, 218, 53, 'PPL', 'P'),
(131361, 'Hopkinsburg', 42.6188888549805, 0.743839934060925, -85.7027816772461, -1.49579571838581, 218, 27, 'PPL', 'P'),
(36498, 'Hopkinsville', 36.8655586242676, 0.64342537858046, -87.4886093139648, -1.52696429051966, 218, 21, 'PPL', 'P'),
(55373, 'Hopkinsville', 39.1741714477539, 0.683718273504059, -91.1055603027344, -1.59009199415696, 218, 29, 'PPL', 'P'),
(72956, 'Hopkinsville', 39.3388900756836, 0.6865931559008, -84.2197189331055, -1.4699113904869, 218, 41, 'PPL', 'P'),
(116079, 'Hopkinton', 42.3438911437988, 0.739040318565357, -91.2483291625977, -1.59258378083089, 218, 16, 'PPL', 'P'),
(125104, 'Hopkinton', 42.2286109924316, 0.737028300361802, -71.523063659668, -1.24831295197471, 218, 23, 'PPL', 'P'),
(143982, 'Hopkinton', 43.1913909912109, 0.753831981312848, -71.6758270263672, -1.25097917570004, 218, 36, 'PPL', 'P'),
(149698, 'Hopkinton', 44.6902809143066, 0.779992545595833, -74.70361328125, -1.30382401489438, 218, 40, 'PPL', 'P'),
(169424, 'Hopkinton', 41.461109161377, 0.723632866394813, -71.7780609130859, -1.2527634936304, 218, 47, 'PPL', 'P'),
(182208, 'Hopland', 38.9730606079102, 0.680208227187335, -123.115280151367, -2.14876699815658, 218, 6, 'PPL', 'P'),
(60320, 'Hopoca', 32.834171295166, 0.573064396264458, -89.5063934326172, -1.5621812669846, 218, 30, 'PPL', 'P'),
(211561, 'Hopoi Village', 20.8822193145752, 0.364463482162891, -156.510833740234, -2.73162936380852, 218, 15, 'PPL', 'P'),
(174568, 'Hopokoekau Beach', 43.8222198486328, 0.764842021891454, -88.3877792358398, -1.54265776619128, 218, 57, 'PPL', 'P'),
(196740, 'Hopp (historical)', 47.9011116027832, 0.836032112833825, -109.886672973633, -1.91788424745216, 218, 31, 'PPL', 'P'),
(193652, 'Hoppaw', 41.5244407653809, 0.72473821140525, -124.02889251709, -2.16471254202538, 218, 6, 'PPL', 'P'),
(136010, 'Hoppe Mobile Home Park', 44.0819396972656, 0.769374988382878, -93.8574981689453, -1.63812237073264, 218, 28, 'PPL', 'P'),
(162837, 'Hoppenville', 40.3783302307129, 0.704734808983501, -75.460563659668, -1.31703529127199, 218, 45, 'PPL', 'P'),
(3236, 'Hopper', 34.0552787780762, 0.59437674236198, -86.2513885498047, -1.50537071461103, 218, 2, 'PPL', 'P'),
(9576, 'Hopper', 34.3586082458496, 0.599670840292949, -93.688606262207, -1.63517465088009, 218, 4, 'PPL', 'P'),
(109724, 'Hopper', 37.8211097717285, 0.660102892274864, -80.3652801513672, -1.402638742929, 218, 58, 'PPL', 'P'),
(120075, 'Hopper', 40.7855606079102, 0.711842319879732, -90.9905624389648, -1.58808490280142, 218, 18, 'PPL', 'P'),
(136011, 'Hopper', 47.5099983215332, 0.829205898327734, -92.5808334350586, -1.61584036768222, 218, 28, 'PPL', 'P'),
(87965, 'Hopper Bluff', 36.2641716003418, 0.632929194934186, -83.3958282470703, -1.45553178533907, 218, 50, 'PPL', 'P'),
(196741, 'Hoppers', 45.6655616760254, 0.797014406019183, -110.717498779297, -1.93238489327153, 218, 31, 'PPL', 'P'),
(162839, 'Hoppers Mill', 40.7825012207031, 0.711788923499876, -75.8638916015625, -1.32407469182334, 218, 45, 'PPL', 'P'),
(162838, 'Hoppestown', 41.4361114501953, 0.723196574029231, -76.7744369506836, -1.33996670615422, 218, 45, 'PPL', 'P'),
(116080, 'Hoprig', 43.2700004577637, 0.75520397532743, -94.6191711425781, -1.65141607194599, 218, 16, 'PPL', 'P'),
(36499, 'Hopson', 36.9900016784668, 0.645597319607474, -87.8469390869141, -1.53321832486555, 218, 21, 'PPL', 'P'),
(60321, 'Hopson', 34.1586112976074, 0.596180235052182, -90.54638671875, -1.58033257402625, 218, 30, 'PPL', 'P'),
(87966, 'Hopson', 36.2252807617188, 0.632250421751352, -82.1377792358398, -1.43357468794164, 218, 50, 'PPL', 'P'),
(196742, 'Hopsonville (historical)', 45.9638900756836, 0.802221218845424, -106.622779846191, -1.86091856594509, 218, 31, 'PPL', 'P'),
(211551, 'Hopuwai', 19.8491706848145, 0.34643338224035, -155.340560913086, -2.71120424982816, 218, 15, 'PPL', 'P'),
(200997, 'Hopville', 44.8033294677734, 0.781965615068445, -123.13166809082, -2.14905302165765, 218, 43, 'PPL', 'P'),
(78489, 'Hopwood', 39.8769416809082, 0.69598392795761, -79.7022171020508, -1.39106610957012, 218, 45, 'PPL', 'P'),
(182209, 'Hopyard (historical)', 38.4300003051758, 0.670730036867743, -122.867500305176, -2.14444242402045, 218, 6, 'PPL', 'P'),
(207687, 'Hoquiam', 46.9811096191406, 0.819975049094383, -123.888061523438, -2.16225457749729, 218, 56, 'PPL', 'P'),
(27467, 'Horace', 39.7202796936035, 0.693249660466426, -87.706672668457, -1.5307702140335, 218, 18, 'PPL', 'P'),
(30114, 'Horace', 39.2625007629395, 0.685259910880079, -85.5641708374023, -1.49337650285158, 218, 19, 'PPL', 'P'),
(65756, 'Horace', 35.3716697692871, 0.617352099402203, -82.2966690063477, -1.43634783758474, 218, 33, 'PPL', 'P'),
(140250, 'Horace', 46.7588882446289, 0.816096554440846, -96.9033279418945, -1.69128212872588, 218, 34, 'PPL', 'P'),
(142082, 'Horace', 41.5430603027344, 0.725063183637267, -98.6730575561523, -1.72216973736473, 218, 35, 'PPL', 'P'),
(187720, 'Horace', 38.476390838623, 0.671539704418154, -101.790283203125, -1.77657558843201, 218, 20, 'PPL', 'P'),
(87967, 'Horace (historical)', 36.5527801513672, 0.637966364398989, -82.5319366455078, -1.44045403251148, 218, 50, 'PPL', 'P'),
(155787, 'Horace (historical)', 40.7344398498535, 0.710950094335528, -82.0772171020508, -1.43251767930498, 218, 41, 'PPL', 'P'),
(9577, 'Horatio', 33.9383316040039, 0.592335629123517, -94.3569412231445, -1.64683929645464, 218, 4, 'PPL', 'P'),
(60322, 'Horatio', 34.4377784729004, 0.601052621424537, -90.0555572509766, -1.57176598374779, 218, 30, 'PPL', 'P'),
(81638, 'Horatio', 34.021110534668, 0.593780394014884, -80.5661087036133, -1.40614386239771, 218, 48, 'PPL', 'P'),
(155785, 'Horatio', 40.1494407653809, 0.700739934190328, -84.5250015258789, -1.47523957687982, 218, 41, 'PPL', 'P'),
(162840, 'Horatio', 40.9291687011719, 0.71434875393966, -79.0158309936523, -1.37908641203862, 218, 45, 'PPL', 'P'),
(120076, 'Horatio Gardens', 42.1644401550293, 0.73590830796537, -87.9422225952148, -1.53488133580825, 218, 18, 'PPL', 'P'),
(27468, 'Hord', 38.8844413757324, 0.678661529805244, -88.521110534668, -1.54498483635179, 218, 18, 'PPL', 'P'),
(142083, 'Hord', 41.1500015258789, 0.718203013827277, -98.0669403076172, -1.71159099572466, 218, 35, 'PPL', 'P'),
(55374, 'Hord (historical)', 38.6527786254883, 0.674618252059259, -91.9611129760742, -1.60502420523098, 218, 29, 'PPL', 'P'),
(155786, 'Hords (historical)', 40.5924987792969, 0.708472755310509, -83.1930618286133, -1.45199284372452, 218, 41, 'PPL', 'P'),
(142084, 'Hordville', 41.0755615234375, 0.716903790689482, -97.8850021362305, -1.7084155755989, 218, 35, 'PPL', 'P'),
(72957, 'Horeb', 38.9033317565918, 0.678991229148196, -82.6122207641602, -1.44185525471902, 218, 41, 'PPL', 'P'),
(174569, 'Horicon', 43.4513893127441, 0.758369808073261, -88.6311111450195, -1.54690470918163, 218, 57, 'PPL', 'P'),
(55375, 'Horine', 38.2666702270508, 0.667879389236922, -90.4244384765625, -1.57820417568306, 218, 29, 'PPL', 'P'),
(204404, 'Horizon', 40.642219543457, 0.709340546351712, -111.98388671875, -1.95448753242254, 218, 52, 'PPL', 'P'),
(204405, 'Horizon Circle', 40.6233291625977, 0.70901084700876, -111.803886413574, -1.95134593444262, 218, 52, 'PPL', 'P'),
(191627, 'Horizon City', 31.6924991607666, 0.553138458540917, -106.206939697266, -1.85366078618435, 218, 51, 'PPL', 'P'),
(142085, 'Horizon Mobile Home Park', 40.853328704834, 0.713025096298864, -99.9841690063477, -1.74505294903123, 218, 35, 'PPL', 'P'),
(207688, 'Horlick', 47.1302795410156, 0.822578555376045, -120.78360748291, -2.10807163301324, 218, 56, 'PPL', 'P'),
(48302, 'Horman', 39.3911094665527, 0.687504556204852, -77.5022201538086, -1.35266891928947, 218, 25, 'PPL', 'P'),
(162841, 'Hormtown', 41.1463890075684, 0.71813996348847, -78.9194412231445, -1.37740409317801, 218, 45, 'PPL', 'P'),
(60323, 'Horn', 31.9316692352295, 0.557312763812534, -88.5397186279297, -1.54530960884673, 218, 30, 'PPL', 'P'),
(102950, 'Horn', 37.1955604553223, 0.649184997069975, -81.8902816772461, -1.42925504065353, 218, 53, 'PPL', 'P'),
(178384, 'Horn', 32.9447212219238, 0.57499385647422, -113.502502441406, -1.98099237685544, 218, 5, 'PPL', 'P'),
(199411, 'Horn', 42.7627792358398, 0.74635129496887, -103.443328857422, -1.80542667778528, 218, 35, 'PPL', 'P'),
(36500, 'Horn Back Mill', 37.5716705322266, 0.655749356261884, -86.3916702270508, -1.50781909175919, 218, 21, 'PPL', 'P'),
(3237, 'Horn Hill', 31.2455596923828, 0.545337893260507, -86.3166732788086, -1.50651014808342, 218, 2, 'PPL', 'P'),
(94997, 'Horn Hill', 31.5688896179199, 0.550981065031357, -96.6333312988281, -1.68656979833504, 218, 51, 'PPL', 'P'),
(60324, 'Horn Lake', 34.9552803039551, 0.61008473226154, -90.0347213745117, -1.57140232910094, 218, 30, 'PPL', 'P'),
(9578, 'Horn Mountain (historical)', 35.9272193908691, 0.627048269457018, -92.9383316040039, -1.62207988780017, 218, 4, 'PPL', 'P'),
(60325, 'Horn Place Landing', 32.749439239502, 0.571585542911137, -90.7002792358398, -1.58301850514365, 218, 30, 'PPL', 'P'),
(162842, 'Horn Siding', 41.8474998474121, 0.730376656065166, -79.480827331543, -1.38720212914452, 218, 45, 'PPL', 'P'),
(3238, 'Hornady', 32.4650001525879, 0.56662114432312, -85.8652801513672, -1.49863185178869, 218, 2, 'PPL', 'P'),
(87968, 'Hornbeak', 36.3311080932617, 0.634097457125376, -89.29638671875, -1.55851595837632, 218, 50, 'PPL', 'P'),
(41409, 'Hornbeck', 31.3255596160889, 0.546734155330522, -93.3983306884766, -1.63010838638038, 218, 22, 'PPL', 'P'),
(162844, 'Hornbrook', 41.8216705322266, 0.729925849471643, -76.4797210693359, -1.33482294366679, 218, 45, 'PPL', 'P'),
(193653, 'Hornbrook', 41.9102783203125, 0.731472347116652, -122.554718017578, -2.13898334325996, 218, 6, 'PPL', 'P'),
(136012, 'Hornby', 47.3433303833008, 0.826296994048068, -91.9019393920898, -1.60399143136024, 218, 28, 'PPL', 'P'),
(149701, 'Hornby', 42.2441711425781, 0.737299876213963, -77.0444412231445, -1.34467916970312, 218, 40, 'PPL', 'P'),
(162843, 'Hornby', 42.1161117553711, 0.735064818269114, -79.8630599975586, -1.39387334767517, 218, 45, 'PPL', 'P'),
(22056, 'Horne', 32.2822189331055, 0.563431010232342, -83.1050033569336, -1.45045593345943, 218, 13, 'PPL', 'P'),
(72958, 'Horne (historical)', 39.7591705322266, 0.69392843364926, -82.0938873291016, -1.43280862965408, 218, 41, 'PPL', 'P'),
(149703, 'Hornell', 42.3277816772461, 0.738759155333272, -77.6613922119141, -1.35544699578058, 218, 40, 'PPL', 'P'),
(65757, 'Horner', 36.332218170166, 0.634116831622306, -78.5694427490234, -1.37129546742764, 218, 33, 'PPL', 'P'),
(87969, 'Horner', 35.5297203063965, 0.620110601659307, -87.8994369506836, -1.53413458543859, 218, 50, 'PPL', 'P'),
(109725, 'Horner', 39.000560760498, 0.680688195394795, -80.3827819824219, -1.40294420750604, 218, 58, 'PPL', 'P'),
(72959, 'Horner Hill', 39.1047210693359, 0.68250613573391, -82.0994415283203, -1.43290556871775, 218, 41, 'PPL', 'P'),
(102951, 'Horners', 38.1119384765625, 0.665178810733527, -76.9472198486328, -1.34298233661458, 218, 53, 'PPL', 'P'),
(162845, 'Horners Mill', 40.1091690063477, 0.700037059399629, -79.3150024414063, -1.38430793882988, 218, 45, 'PPL', 'P'),
(145471, 'Hornerstown', 40.1061096191406, 0.699983663019773, -74.5144424438477, -1.30052236093295, 218, 37, 'PPL', 'P'),
(162846, 'Hornerstown', 40.3141708374023, 0.70361501632415, -78.9124984741211, -1.37728291934841, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(55376, 'Hornersville', 36.0416717529297, 0.629045840011659, -90.1138916015625, -1.57278411023253, 218, 29, 'PPL', 'P'),
(55377, 'Hornersville Junction', 36.0397186279297, 0.629011751549706, -90.083610534668, -1.57225560591421, 218, 29, 'PPL', 'P'),
(87970, 'Hornertown', 35.6586112976074, 0.622360173832097, -87.5875015258789, -1.52869028522214, 218, 50, 'PPL', 'P'),
(55378, 'Hornet', 36.9619407653809, 0.645107564283009, -94.5569381713867, -1.6503299016954, 218, 29, 'PPL', 'P'),
(87971, 'Hornet', 35.7550010681152, 0.6240424926927, -83.7247161865234, -1.46127196275262, 218, 50, 'PPL', 'P'),
(143984, 'Hornetown', 43.3672218322754, 0.756900808415974, -71.1158294677734, -1.24120537449945, 218, 36, 'PPL', 'P'),
(102952, 'Hornets Nest', 37.503059387207, 0.65455186587773, -76.5244369506836, -1.33560338302424, 218, 53, 'PPL', 'P'),
(65758, 'Hornets Nest (historical)', 35.2083282470703, 0.614501252034301, -80.5783309936523, -1.40635718160103, 218, 33, 'PPL', 'P'),
(65759, 'Horneytown', 36.0194396972656, 0.628657817440835, -80.0602798461914, -1.3973154833841, 218, 33, 'PPL', 'P'),
(116081, 'Hornick', 42.2305603027344, 0.737062322244728, -96.0972213745117, -1.6772129150031, 218, 16, 'PPL', 'P'),
(162848, 'Hornig', 40.0805587768555, 0.699537716695239, -76.2444381713867, -1.33071648242394, 218, 45, 'PPL', 'P'),
(162847, 'Horning', 40.3375015258789, 0.704022213654824, -79.9916687011719, -1.39611799299995, 218, 45, 'PPL', 'P'),
(162849, 'Horningford', 40.5099983215332, 0.707032850688131, -77.6880569458008, -1.35591238318107, 218, 45, 'PPL', 'P'),
(182210, 'Hornitos', 37.5022201538086, 0.654537218491734, -120.23722076416, -2.09853538578189, 218, 6, 'PPL', 'P'),
(22057, 'Horns', 32.6752815246582, 0.570291246621358, -84.0036087036133, -1.46613955543502, 218, 13, 'PPL', 'P'),
(174571, 'Horns Corners', 43.3413887023926, 0.756449935243423, -88.0238876342773, -1.53630665962366, 218, 57, 'PPL', 'P'),
(22058, 'Horns Cross Road (historical)', 31.1183300018311, 0.543117316254085, -84.8597183227539, -1.48108148704702, 218, 13, 'PPL', 'P'),
(22059, 'Horns Crossroads', 32.9816703796387, 0.575638740932183, -84.0755615234375, -1.46739536904704, 218, 13, 'PPL', 'P'),
(72960, 'Horns Mill', 39.6508293151855, 0.692037522696276, -82.5502777099609, -1.4407741444745, 218, 41, 'PPL', 'P'),
(13989, 'Horns Mobile Village Mobile Home Park', 38.5883293151855, 0.673493399393836, -75.5755615234375, -1.31904238262753, 218, 10, 'PPL', 'P'),
(81639, 'Hornsboro', 34.797779083252, 0.607335817384361, -80.2888870239258, -1.40130543132926, 218, 48, 'PPL', 'P'),
(3240, 'Hornsboro (historical)', 32.0647201538086, 0.559634940414543, -88.0213928222656, -1.53626311693984, 218, 2, 'PPL', 'P'),
(27469, 'Hornsby', 39.1705589294434, 0.683655223165252, -89.745002746582, -1.56634578513921, 218, 18, 'PPL', 'P'),
(87972, 'Hornsby', 35.2275009155273, 0.614835878225269, -88.8294372558594, -1.55036615280846, 218, 50, 'PPL', 'P'),
(94998, 'Hornsby Bend', 30.2472190856934, 0.527913562617418, -97.5830612182617, -1.70314571243386, 218, 51, 'PPL', 'P'),
(3239, 'Hornsbytown', 32.5505599975586, 0.568114445325355, -85.9169387817383, -1.49953346497574, 218, 2, 'PPL', 'P'),
(102954, 'Hornsbyville', 37.1963882446289, 0.649199444718888, -76.4686126708984, -1.33462906553943, 218, 53, 'PPL', 'P'),
(16494, 'Hornsville', 30.9411106109619, 0.54002425438504, -85.0036087036133, -1.48359284795496, 218, 12, 'PPL', 'P'),
(36502, 'Horntown', 37.0677795410156, 0.646954799394115, -85.0055618286133, -1.48362693641691, 218, 21, 'PPL', 'P'),
(76135, 'Horntown', 35.0869407653809, 0.612382640808115, -96.2474975585938, -1.67983572920266, 218, 42, 'PPL', 'P'),
(102953, 'Horntown', 37.9694404602051, 0.66269175117053, -75.4641723632813, -1.31709827503177, 218, 53, 'PPL', 'P'),
(131362, 'Horr', 43.6836090087891, 0.762422806357226, -85.0475006103516, -1.48435890624252, 218, 27, 'PPL', 'P'),
(81640, 'Horrel Hill', 33.9516716003418, 0.592568455981817, -80.8427810668945, -1.41097270608624, 218, 48, 'PPL', 'P'),
(162850, 'Horrell', 40.4530601501465, 0.706039092127368, -78.289436340332, -1.36640843366929, 218, 45, 'PPL', 'P'),
(109726, 'Horrock', 38.0261116027832, 0.663680849199385, -80.2947235107422, -1.40140729724095, 218, 58, 'PPL', 'P'),
(81641, 'Horry', 33.936939239502, 0.59231132777857, -79.1344375610352, -1.38115648715393, 218, 48, 'PPL', 'P'),
(41410, 'Horse Bluff Landing', 30.3658294677734, 0.529983704311764, -90.6272201538086, -1.58174338361372, 218, 22, 'PPL', 'P'),
(538, 'Horse Branch', 37.4558296203613, 0.653727550941323, -86.6766662597656, -1.51279321088519, 218, 21, 'PPL', 'P'),
(196743, 'Horse Butte Acres Trailer Court', 44.7583312988281, 0.781180248862981, -111.183326721191, -1.94051512460538, 218, 31, 'PPL', 'P'),
(192628, 'Horse Canyon', 39.4583282470703, 0.68867774524406, -110.358329772949, -1.92611621153965, 218, 52, 'PPL', 'P'),
(36503, 'Horse Cave', 37.1794395446777, 0.648903634100808, -85.9069366455078, -1.49935889476628, 218, 21, 'PPL', 'P'),
(143985, 'Horse Corner', 43.2336082458496, 0.754568811407446, -71.4422225952148, -1.24690200922919, 218, 36, 'PPL', 'P'),
(81643, 'Horse Creek', 33.5202789306641, 0.585039233526972, -81.8791732788086, -1.42906116252617, 218, 48, 'PPL', 'P'),
(87974, 'Horse Creek', 36.4375, 0.635954346195434, -82.6258316040039, -1.44209280868826, 218, 50, 'PPL', 'P'),
(174572, 'Horse Creek', 45.2574996948242, 0.789892380895012, -92.5830612182617, -1.61587924983414, 218, 57, 'PPL', 'P'),
(193654, 'Horse Creek', 41.8241691589355, 0.729969458734493, -122.995826721191, -2.14668214249721, 218, 6, 'PPL', 'P'),
(209514, 'Horse Creek', 41.4150009155273, 0.722828125692418, -105.181671142578, -1.83576647418789, 218, 59, 'PPL', 'P'),
(109727, 'Horse Creek Junction', 38.1644401550293, 0.666095137885596, -81.8580627441406, -1.42869271418936, 218, 58, 'PPL', 'P'),
(178385, 'Horse Crossing', 34.5844383239746, 0.603612318706266, -111.129722595215, -1.93957955611444, 218, 5, 'PPL', 'P'),
(102955, 'Horse Head', 37.8919410705566, 0.661339131652878, -76.4191665649414, -1.33376606818819, 218, 53, 'PPL', 'P'),
(113576, 'Horse Heaven', 41.6172218322754, 0.726357546506073, -73.2841720581055, -1.27905009201197, 218, 8, 'PPL', 'P'),
(207689, 'Horse Heaven', 46.0999984741211, 0.804596758537775, -119.535003662109, -2.08627938528729, 218, 56, 'PPL', 'P'),
(193655, 'Horse Lake', 40.6741714477539, 0.709898212283974, -120.403060913086, -2.10142984241264, 218, 6, 'PPL', 'P'),
(22060, 'Horse Lake Estates', 34.6749992370605, 0.605192904813228, -85.2688903808594, -1.48822288666812, 218, 13, 'PPL', 'P'),
(48303, 'Horse Landing', 38.4383316040039, 0.670875445463261, -76.6452789306641, -1.33771247344953, 218, 25, 'PPL', 'P'),
(81644, 'Horse Landing', 32.2383308410645, 0.562665018523807, -80.7822189331055, -1.40991569744959, 218, 48, 'PPL', 'P'),
(102956, 'Horse Landing', 37.7058296203613, 0.658090874071309, -76.9938888549805, -1.34379686443398, 218, 53, 'PPL', 'P'),
(178387, 'Horse Mesa', 33.5830612182617, 0.586134991157485, -111.354721069336, -1.94350652029981, 218, 5, 'PPL', 'P'),
(65761, 'Horse Neck', 34.8186111450195, 0.607699405452184, -78.9111099243164, -1.37725868458249, 218, 33, 'PPL', 'P'),
(102957, 'Horse Pasture', 36.6283302307129, 0.639284962033714, -79.9511108398438, -1.3954101247822, 218, 53, 'PPL', 'P'),
(65762, 'Horse Shoe', 35.3430595397949, 0.616852756697813, -82.5566711425781, -1.44088573092418, 218, 33, 'PPL', 'P'),
(81645, 'Horse Shoe (historical)', 34.663890838623, 0.604999026685871, -83.1602783203125, -1.45142066356431, 218, 48, 'PPL', 'P'),
(48304, 'Horse Shoe Bend', 39.4386100769043, 0.688333598252194, -77.7297210693359, -1.35663955931672, 218, 25, 'PPL', 'P'),
(102958, 'Horse Shoe Curve', 39.1202812194824, 0.682777711586071, -77.8586120605469, -1.35888913148951, 218, 53, 'PPL', 'P'),
(48305, 'Horse Shoe Farms Estates', 39.4477806091309, 0.688493654233708, -77.2836074829102, -1.34885340839571, 218, 25, 'PPL', 'P'),
(109728, 'Horse Shoe Run', 39.2708282470703, 0.68540525289657, -79.5144424438477, -1.38778882353267, 218, 58, 'PPL', 'P'),
(195108, 'Horsecamp', 47.1913909912109, 0.823645151392621, -115.880828857422, -2.02250200350207, 218, 17, 'PPL', 'P'),
(81646, 'Horsegall', 32.7438888549805, 0.571488670426485, -81.0438919067383, -1.41448275240297, 218, 48, 'PPL', 'P'),
(9580, 'Horsehead', 33.1097183227539, 0.57787359913995, -93.2636108398438, -1.62775708145395, 218, 4, 'PPL', 'P'),
(48306, 'Horsehead', 38.6497192382813, 0.674564855679403, -76.7716674804688, -1.33991836978044, 218, 25, 'PPL', 'P'),
(191629, 'Horsehead Crossing', 31.235279083252, 0.545158462782063, -102.483329772949, -1.7886715329451, 218, 51, 'PPL', 'P'),
(191628, 'Horsehead Crossing (historical)', 31.2847805023193, 0.546022425529198, -102.743019104004, -1.7932039668043, 218, 51, 'PPL', 'P'),
(149706, 'Horseheads', 42.1669387817383, 0.73595191722822, -76.8208312988281, -1.34077644028366, 218, 40, 'PPL', 'P'),
(200998, 'Horseheaven', 44.7158317565918, 0.780438491920367, -120.50611114502, -2.10322840825482, 218, 43, 'PPL', 'P'),
(22061, 'Horseleg Estates', 34.2402801513672, 0.59760562544662, -85.2027816772461, -1.48706907212584, 218, 13, 'PPL', 'P'),
(174573, 'Horseman', 45.4944381713867, 0.794027737435687, -91.559440612793, -1.59801369997745, 218, 57, 'PPL', 'P'),
(36504, 'Horsemill', 37.2330589294434, 0.649839468907862, -86.5380630493164, -1.51037412850902, 218, 21, 'PPL', 'P'),
(109729, 'Horseneck', 39.3213882446289, 0.686287691323768, -81.2808303833008, -1.41861810894364, 218, 58, 'PPL', 'P'),
(102959, 'Horsepen', 37.2280616760254, 0.649752250382162, -81.5199966430664, -1.42279234763623, 218, 53, 'PPL', 'P'),
(109730, 'Horsepen (historical)', 37.6199989318848, 0.656592845958139, -81.8919372558594, -1.42928393595136, 218, 58, 'PPL', 'P'),
(102960, 'Horsepen Cove', 37.2136116027832, 0.649500049026931, -81.508056640625, -1.42258395528093, 218, 53, 'PPL', 'P'),
(102961, 'Horsepen Hills', 37.7011108398438, 0.658008515814598, -77.8066711425781, -1.35798259145445, 218, 53, 'PPL', 'P'),
(9582, 'Horseshoe', 35.5127792358398, 0.619814924199281, -91.2744369506836, -1.5930394476934, 218, 4, 'PPL', 'P'),
(16495, 'Horseshoe', 29.5191707611084, 0.515206722239782, -83.2536087036133, -1.45304958604506, 218, 12, 'PPL', 'P'),
(27470, 'Horseshoe', 37.6988906860352, 0.657969766820737, -88.3788909912109, -1.54250263705779, 218, 18, 'PPL', 'P'),
(60327, 'Horseshoe', 32.5530586242676, 0.568158054588205, -89.4119415283203, -1.56053277026984, 218, 30, 'PPL', 'P'),
(65763, 'Horseshoe', 36.4599990844727, 0.636347029298166, -76.3936080932617, -1.3333199887056, 218, 33, 'PPL', 'P'),
(87975, 'Horseshoe', 36.3358306884766, 0.634179881961114, -82.1186065673828, -1.43324006175067, 218, 50, 'PPL', 'P'),
(102962, 'Horseshoe', 37.663330078125, 0.657349117128694, -77.1488876342773, -1.34650210346928, 218, 53, 'PPL', 'P'),
(149708, 'Horseshoe', 44.1347198486328, 0.770296175803936, -74.6322174072266, -1.30257792182033, 218, 40, 'PPL', 'P'),
(186867, 'Horseshoe', 39.2038917541504, 0.68423699070538, -106.084716796875, -1.8515275941512, 218, 7, 'PPL', 'P'),
(94999, 'Horseshoe Bay', 30.548059463501, 0.533164217733105, -98.3375015258789, -1.71631317981153, 218, 51, 'PPL', 'P'),
(16496, 'Horseshoe Beach', 29.4411106109619, 0.513844315605125, -83.2874984741211, -1.45364107412317, 218, 12, 'PPL', 'P'),
(9583, 'Horseshoe Bend', 36.2291717529297, 0.632318332359149, -91.7641677856445, -1.60158686321201, 218, 4, 'PPL', 'P'),
(22064, 'Horseshoe Bend', 33.9930610656738, 0.593290838427501, -84.2880630493164, -1.47110422033914, 218, 13, 'PPL', 'P'),
(102963, 'Horseshoe Bend', 36.7775001525879, 0.641888468315376, -81.5736083984375, -1.42372804928523, 218, 53, 'PPL', 'P'),
(190317, 'Horseshoe Bend', 37.6841697692871, 0.657712838354572, -114.128608703613, -1.99191999259831, 218, 39, 'PPL', 'P'),
(195109, 'Horseshoe Bend', 43.9147186279297, 0.76645643014426, -116.196937561035, -2.02801914117433, 218, 17, 'PPL', 'P'),
(48307, 'Horseshoe Curve', 39.6377792358398, 0.691809755844047, -78.8919372558594, -1.37692405839153, 218, 25, 'PPL', 'P'),
(48308, 'Horseshoe Estates', 38.9427795410156, 0.679679722869009, -75.9630584716797, -1.32580548021578, 218, 25, 'PPL', 'P'),
(87976, 'Horseshoe Falls (historical)', 35.813060760498, 0.625055825487475, -85.6897201538086, -1.4955677517965, 218, 50, 'PPL', 'P'),
(13993, 'Horseshoe Hill', 39.7986106872559, 0.694616794212018, -75.6708297729492, -1.32070512725412, 218, 10, 'PPL', 'P'),
(149709, 'Horseshoe Hill', 41.1961097717285, 0.719007754529672, -73.5725021362305, -1.28408240120778, 218, 40, 'PPL', 'P'),
(9584, 'Horseshoe Lake', 34.913330078125, 0.60935256269885, -90.3072204589844, -1.57615833533366, 218, 4, 'PPL', 'P'),
(178388, 'Horseshoe Mobile Home Park', 33.413330078125, 0.583172623918935, -111.902778625488, -1.95307192914511, 218, 5, 'PPL', 'P'),
(102964, 'Horseshoe Point', 36.9075012207031, 0.644157414985096, -76.5336074829102, -1.33576343900575, 218, 53, 'PPL', 'P'),
(22065, 'Horseshoe Springs', 33.6366691589355, 0.587070626227457, -83.9416732788086, -1.46505857834855, 218, 13, 'PPL', 'P'),
(194240, 'Horsetooth Heights', 40.5044403076172, 0.706935845045425, -105.153610229492, -1.83527671886343, 218, 7, 'PPL', 'P'),
(102965, 'Horsey', 37.9252815246582, 0.661921032351061, -75.5588912963867, -1.31875143227843, 218, 53, 'PPL', 'P'),
(162851, 'Horsham', 40.1783294677734, 0.701244137163707, -75.1288909912109, -1.31124651116854, 218, 45, 'PPL', 'P'),
(87977, 'Horsleys', 36.4694404602051, 0.636511812390615, -86.1180572509766, -1.50304364445052, 218, 50, 'PPL', 'P'),
(182211, 'Horstville', 39.0280609130859, 0.681168163602254, -121.390556335449, -2.11866488888125, 218, 6, 'PPL', 'P'),
(22066, 'Hortense', 31.336389541626, 0.54692317318889, -81.9563903808594, -1.43040885519581, 218, 13, 'PPL', 'P'),
(55379, 'Hortense', 38.3622207641602, 0.66954706071153, -93.595832824707, -1.63355544893732, 218, 29, 'PPL', 'P'),
(87978, 'Hortense', 36.1488914489746, 0.630917176730631, -87.4311065673828, -1.52596067826287, 218, 50, 'PPL', 'P'),
(95003, 'Hortense', 30.8458309173584, 0.538361310021367, -94.7041702270508, -1.65289958583122, 218, 51, 'PPL', 'P'),
(41411, 'Hortman', 32.7286109924316, 0.571222021422341, -93.3772201538086, -1.62973993804357, 218, 22, 'PPL', 'P'),
(468, 'Horton', 39.5719413757324, 0.690660668412705, -91.043327331543, -1.58900582390637, 218, 18, 'PPL', 'P'),
(3242, 'Horton', 34.2008285522461, 0.59691706514678, -86.2969436645508, -1.50616580135447, 218, 2, 'PPL', 'P'),
(32802, 'Horton', 39.6605606079102, 0.692207365794796, -95.5261077880859, -1.6672451025171, 218, 20, 'PPL', 'P'),
(36505, 'Horton', 37.4355583190918, 0.653373749990506, -86.7988891601563, -1.51492640291834, 218, 21, 'PPL', 'P'),
(55380, 'Horton', 37.9747200012207, 0.662783896544246, -94.3649978637695, -1.64697991136019, 218, 29, 'PPL', 'P'),
(95002, 'Horton', 32.3107681274414, 0.563929287672295, -94.2872695922852, -1.64562329710091, 218, 51, 'PPL', 'P'),
(109731, 'Horton', 38.8072204589844, 0.677313770556582, -79.5427780151367, -1.3882833725471, 218, 58, 'PPL', 'P'),
(116082, 'Horton', 42.8474998474121, 0.747829948585109, -92.4752807617188, -1.61399812599816, 218, 16, 'PPL', 'P'),
(131363, 'Horton', 42.1502799987793, 0.73566116661621, -84.517219543457, -1.47510375566422, 218, 27, 'PPL', 'P'),
(136014, 'Horton', 46.8111114501953, 0.817008021323926, -95.0969390869141, -1.65975469563514, 218, 28, 'PPL', 'P'),
(149710, 'Horton', 41.9719390869141, 0.732548530513153, -75.0186080932617, -1.30932171149068, 218, 40, 'PPL', 'P'),
(155789, 'Horton', 40.4530601501465, 0.706039092127368, -83.5550003051758, -1.45830986183018, 218, 41, 'PPL', 'P'),
(193169, 'Horton', 44.2099990844727, 0.771610046327727, -123.492218017578, -2.1553458049974, 218, 43, 'PPL', 'P'),
(196744, 'Horton', 46.3413887023926, 0.808809812803253, -106.061393737793, -1.85112052997858, 218, 31, 'PPL', 'P'),
(209515, 'Horton', 44.1349983215332, 0.770301036072925, -104.206672668457, -1.81874954061256, 218, 59, 'PPL', 'P'),
(131364, 'Horton Bay', 45.2844390869141, 0.790362561985465, -85.0788879394531, -1.48490671847875, 218, 27, 'PPL', 'P'),
(162853, 'Horton City', 41.2983283996582, 0.720791806143916, -78.732780456543, -1.37414624821652, 218, 45, 'PPL', 'P'),
(149711, 'Horton Crossing', 42.0855598449707, 0.734531586839853, -76.3197174072266, -1.33203035294773, 218, 40, 'PPL', 'P'),
(149717, 'Horton Estates', 41.3238906860352, 0.721237952205532, -73.7455596923828, -1.2871028253581, 218, 40, 'PPL', 'P'),
(188701, 'Horton Place', 35.1419410705566, 0.613342577223034, -106.208610534668, -1.85368994779829, 218, 38, 'PPL', 'P'),
(55381, 'Horton Town', 37.7763900756836, 0.659322386338389, -90.9250030517578, -1.58694067563907, 218, 29, 'PPL', 'P'),
(172126, 'Hortonia', 43.7452812194824, 0.763499189490809, -73.2236099243164, -1.27799308337532, 218, 55, 'PPL', 'P'),
(9585, 'Hortons Landing', 34.295280456543, 0.598565561861539, -91.1125030517578, -1.59021316798656, 218, 4, 'PPL', 'P'),
(3243, 'Hortons Mill', 34.0091705322266, 0.593572001659586, -86.4472198486328, -1.50878861555404, 218, 2, 'PPL', 'P'),
(178389, 'Hortons Place', 32.8777809143066, 0.573825527704003, -110.583061218262, -1.93003851519312, 218, 5, 'PPL', 'P'),
(60329, 'Hortontown', 34.3519401550293, 0.599554460153313, -89.0788879394531, -1.55471988855852, 218, 30, 'PPL', 'P'),
(149713, 'Hortontown', 41.4986114501953, 0.724287404811727, -73.7955627441406, -1.28797554324732, 218, 40, 'PPL', 'P'),
(122836, 'Hortonville', 40.086109161377, 0.699634589179891, -86.1608276367188, -1.50379012850407, 218, 19, 'PPL', 'P'),
(125106, 'Hortonville', 41.7750015258789, 0.729111321652242, -71.1999969482422, -1.24267437415674, 218, 23, 'PPL', 'P'),
(149714, 'Hortonville', 41.7641716003418, 0.728922303793874, -75.0305633544922, -1.30953037016209, 218, 40, 'PPL', 'P'),
(172127, 'Hortonville', 43.4697189331055, 0.758689720299207, -72.8052825927734, -1.27069189408881, 218, 55, 'PPL', 'P'),
(174575, 'Hortonville', 44.3347206115723, 0.77378684762373, -88.6380615234375, -1.54702601616929, 218, 57, 'PPL', 'P'),
(188702, 'Hortonville', 32.9113883972168, 0.574412088934092, -105.535278320313, -1.84193808369804, 218, 38, 'PPL', 'P'),
(22067, 'Hoschton', 34.0963897705078, 0.595094264538675, -83.7613906860352, -1.46191205352063, 218, 13, 'PPL', 'P'),
(149715, 'Hoseaville', 42.4738883972168, 0.74130919865605, -74.8152770996094, -1.3057729161801, 218, 40, 'PPL', 'P'),
(162855, 'Hosensack', 40.4536094665527, 0.706048679507292, -75.4972229003906, -1.31767511572388, 218, 45, 'PPL', 'P'),
(162856, 'Hosensock', 40.8188896179199, 0.712424020840833, -76.0769424438477, -1.32779313049536, 218, 45, 'PPL', 'P'),
(149716, 'Hoseville', 43.6813888549805, 0.762384057363365, -75.4449996948242, -1.3167636488408, 218, 40, 'PPL', 'P'),
(196745, 'Hosey (historical)', 47.8597183227539, 0.835309663809114, -109.495826721191, -1.91106269347798, 218, 31, 'PPL', 'P'),
(16497, 'Hosford', 30.3863906860352, 0.530342565268652, -84.7980575561523, -1.48000530365051, 218, 12, 'PPL', 'P'),
(193656, 'Hoskin', 41.7088890075684, 0.727957440530938, -123.36222076416, -2.15307692490671, 218, 6, 'PPL', 'P'),
(65764, 'Hoskins', 35.2625007629395, 0.615446740800306, -80.8861083984375, -1.41172891067777, 218, 33, 'PPL', 'P'),
(95005, 'Hoskins', 29.1338901519775, 0.508482307066359, -95.2341690063477, -1.6621498095615, 218, 51, 'PPL', 'P'),
(113577, 'Hoskins', 41.9002799987793, 0.731297843486224, -72.7863922119141, -1.27036219474586, 218, 8, 'PPL', 'P'),
(142086, 'Hoskins', 42.1122207641602, 0.734996907661317, -97.3058319091797, -1.69830714820735, 218, 35, 'PPL', 'P'),
(200999, 'Hoskins', 44.6769409179688, 0.779759718737533, -123.467498779297, -2.15491437290081, 218, 43, 'PPL', 'P'),
(36506, 'Hoskinston', 37.077220916748, 0.647119582486564, -83.3916702270508, -1.45545921419936, 218, 21, 'PPL', 'P'),
(72961, 'Hoskinsville', 39.771110534668, 0.694136826004559, -81.5922164916992, -1.42405282178017, 218, 41, 'PPL', 'P'),
(170547, 'Hosmer', 45.5788917541504, 0.795501730520018, -99.4744415283203, -1.73615652625177, 218, 49, 'PPL', 'P'),
(125107, 'Hosmer Corner', 42.0644416809082, 0.734163005344986, -72.7249984741211, -1.26929067188127, 218, 23, 'PPL', 'P'),
(188703, 'Hospah', 35.735279083252, 0.623698279121807, -107.745826721191, -1.88051943156808, 218, 38, 'PPL', 'P'),
(116084, 'Hospers', 43.0719413757324, 0.751747192232507, -95.904167175293, -1.67384348359193, 218, 16, 'PPL', 'P'),
(211880, 'Hospital Valley', 51.8477783203125, 0.904914441533588, -176.633056640625, -3.08282840624054, 218, 1, 'PPL', 'P'),
(41412, 'Hosston', 32.8875007629395, 0.573995171065441, -93.8783264160156, -1.63848589222144, 218, 22, 'PPL', 'P'),
(162857, 'Host', 40.4155616760254, 0.705384620289481, -76.2069396972656, -1.33006201058606, 218, 45, 'PPL', 'P'),
(109732, 'Hosterman', 38.4730606079102, 0.671481580927363, -79.8619384765625, -1.39385377344116, 218, 58, 'PPL', 'P'),
(162858, 'Hostetter', 40.2661094665527, 0.702776187159803, -79.3986129760742, -1.38576721794919, 218, 45, 'PPL', 'P'),
(41413, 'Hostetter (historical)', 30.735279083252, 0.536431816522091, -90.5019378662109, -1.57955679520071, 218, 22, 'PPL', 'P'),
(95006, 'Hostyn', 29.8455600738525, 0.520903290390489, -96.9194412231445, -1.69156335853699, 218, 51, 'PPL', 'P'),
(190318, 'Hot Creek', 38.3852806091309, 0.669949530931268, -115.15055847168, -2.00975638084106, 218, 39, 'PPL', 'P'),
(201000, 'Hot Lake', 45.2447204589844, 0.789669341153717, -117.956672668457, -2.05873231276178, 218, 43, 'PPL', 'P'),
(112339, 'Hot Spot', 37.127498626709, 0.647997094065745, -82.9166717529297, -1.447168926884, 218, 21, 'PPL', 'P'),
(9587, 'Hot Springs', 34.5036087036133, 0.602201575697824, -93.0550003051758, -1.62411614076965, 218, 4, 'PPL', 'P'),
(65765, 'Hot Springs', 35.892219543457, 0.626437406881981, -82.8291702270508, -1.4456417371569, 218, 33, 'PPL', 'P'),
(102967, 'Hot Springs', 37.999439239502, 0.663215328640839, -79.8319396972656, -1.39333019597085, 218, 53, 'PPL', 'P'),
(188704, 'Hot Springs', 35.6538887023926, 0.622277748996359, -105.291107177734, -1.8376764933217, 218, 38, 'PPL', 'P'),
(190320, 'Hot Springs', 36.9769401550293, 0.645369353018164, -116.721939086914, -2.03718214637891, 218, 39, 'PPL', 'P'),
(191630, 'Hot Springs', 29.1819400787354, 0.509320936493625, -102.991668701172, -1.79754372095864, 218, 51, 'PPL', 'P'),
(193658, 'Hot Springs', 40.0188903808594, 0.698461400140684, -121.032783508301, -2.11242057507334, 218, 6, 'PPL', 'P'),
(195110, 'Hot Springs', 42.7919387817383, 0.746860225053184, -115.716941833496, -2.01964163533327, 218, 17, 'PPL', 'P'),
(196746, 'Hot Springs', 47.6091690063477, 0.830936753299204, -114.667778015137, -2.0013302723101, 218, 31, 'PPL', 'P'),
(201001, 'Hot Springs', 42.1152801513672, 0.735050304041173, -121.285003662109, -2.11682264719719, 218, 43, 'PPL', 'P'),
(202231, 'Hot Springs', 43.4316711425781, 0.758025661081396, -103.473892211914, -1.80596010895162, 218, 49, 'PPL', 'P'),
(199998, 'Hot Springs (historical)', 40.8605613708496, 0.713151330134533, -119.331939697266, -2.08273525050861, 218, 39, 'PPL', 'P'),
(201002, 'Hot Springs (historical)', 42.1069412231445, 0.7349047622876, -120.318061828613, -2.09994632852741, 218, 43, 'PPL', 'P'),
(9588, 'Hot Springs Junction', 34.7133293151855, 0.605861890879056, -92.2852783203125, -1.6106819578088, 218, 4, 'PPL', 'P'),
(188705, 'Hot Springs Landing', 33.207218170166, 0.579575292497484, -107.209999084473, -1.87116747508415, 218, 38, 'PPL', 'P'),
(9589, 'Hot Springs Village', 34.6719398498535, 0.605139508433372, -92.9986114501953, -1.62313196958881, 218, 4, 'PPL', 'P'),
(194241, 'Hot Sulphur Springs', 40.0730590820313, 0.699406822327662, -106.10221862793, -1.85183305872823, 218, 7, 'PPL', 'P'),
(41414, 'Hot Wells', 31.3391704559326, 0.546971709299757, -92.7133331298828, -1.61815292361479, 218, 22, 'PPL', 'P'),
(95007, 'Hot Wells', 29.9566707611084, 0.522842537717257, -95.6816711425781, -1.66996019524843, 218, 51, 'PPL', 'P'),
(22068, 'Hotalihuyana (historical)', 31.5244407653809, 0.550205286205817, -84.1388931274414, -1.46850071405748, 218, 13, 'PPL', 'P'),
(3245, 'Hotamville', 31.9922199249268, 0.558369572712105, -87.9400024414063, -1.53484258681439, 218, 2, 'PPL', 'P'),
(178390, 'Hotason Vo', 32.2463912963867, 0.562805700008391, -112.60417175293, -1.96531354856982, 218, 5, 'PPL', 'P'),
(102968, 'Hotchkiss', 38.0013885498047, 0.663249350523765, -79.5811080932617, -1.38895235861292, 218, 53, 'PPL', 'P'),
(109734, 'Hotchkiss', 37.6738891601563, 0.657533407876128, -81.3683319091797, -1.42014529867075, 218, 58, 'PPL', 'P'),
(186868, 'Hotchkiss', 38.7997207641602, 0.677182876189005, -107.718887329102, -1.88004925047762, 218, 7, 'PPL', 'P'),
(113578, 'Hotchkissville', 41.5672187805176, 0.725484828616854, -73.2174987792969, -1.27788642377366, 218, 8, 'PPL', 'P'),
(178391, 'Hotevilla', 35.9277801513672, 0.627058056574024, -110.672218322754, -1.93159460021805, 218, 5, 'PPL', 'P'),
(178392, 'Hotevilla-Bacavi', 35.9277801513672, 0.627058056574024, -110.672218322754, -1.93159460021805, 218, 5, 'PPL', 'P'),
(22069, 'Hothouse', 34.934440612793, 0.609721011035663, -84.3038864135742, -1.47138039014418, 218, 13, 'PPL', 'P'),
(65766, 'Hothouse', 35.0208282470703, 0.611228759686811, -84.2324981689453, -1.47013443022819, 218, 33, 'PPL', 'P'),
(193659, 'Hotlum', 41.4741706848145, 0.723860832984124, -122.313331604004, -2.13477035557351, 218, 6, 'PPL', 'P'),
(162859, 'Hottelville', 41.3530616760254, 0.721747082026928, -79.1561126708984, -1.38153478918678, 218, 45, 'PPL', 'P'),
(48311, 'Hotton Acres', 38.3680610656738, 0.669648993202253, -75.5480575561523, -1.31856234784104, 218, 25, 'PPL', 'P'),
(102969, 'Houchins', 37.151668548584, 0.648418938782413, -80.3600006103516, -1.40254659755529, 218, 53, 'PPL', 'P'),
(55382, 'Houck', 37.3008308410645, 0.65102231190602, -89.7486114501953, -1.56640876889899, 218, 29, 'PPL', 'P'),
(178393, 'Houck', 35.2830581665039, 0.615805535178167, -109.206390380859, -1.90601107636426, 218, 5, 'PPL', 'P'),
(162860, 'Houck Manor', 40.3549995422363, 0.704327611652828, -76.7583312988281, -1.33968560950117, 218, 45, 'PPL', 'P'),
(72962, 'Houck Meadows', 39.8450012207031, 0.695426461762429, -83.9322204589844, -1.46489359551902, 218, 41, 'PPL', 'P'),
(149718, 'Houcks Corners', 42.5955581665039, 0.743432736730252, -73.8349990844727, -1.28866383723105, 218, 40, 'PPL', 'P'),
(48309, 'Houcks Mill', 39.586109161377, 0.690907942919919, -76.5483322143555, -1.33602043405094, 218, 25, 'PPL', 'P'),
(48310, 'Houcksville', 39.5711097717285, 0.690646154184764, -76.8802795410156, -1.34181400784436, 218, 25, 'PPL', 'P'),
(155790, 'Houcktown', 40.9352798461914, 0.714455413541318, -83.5941696166992, -1.45899349528201, 218, 41, 'PPL', 'P'),
(36507, 'Houckville', 38.1122207641602, 0.665183737581544, -82.855827331543, -1.44610699139933, 218, 21, 'PPL', 'P'),
(9591, 'Hough', 36.3088912963867, 0.633709700870661, -93.3649978637695, -1.62952661884025, 218, 4, 'PPL', 'P'),
(55385, 'Hough', 36.9455604553223, 0.644821673939989, -89.2669372558594, -1.55800196828594, 218, 29, 'PPL', 'P'),
(155791, 'Hough', 41.5119400024414, 0.724520031932945, -81.6366729736328, -1.42482873376376, 218, 41, 'PPL', 'P'),
(190990, 'Hough', 36.8708305358887, 0.643517390796123, -101.576667785645, -1.77284729606395, 218, 42, 'PPL', 'P'),
(172128, 'Hough Crossing', 43.8263893127441, 0.76491479276824, -73.3180618286133, -1.27964158009008, 218, 55, 'PPL', 'P'),
(182212, 'Hough Springs', 39.1624984741211, 0.683514541680668, -122.611106872559, -2.13996751444079, 218, 6, 'PPL', 'P'),
(125108, 'Houghs Neck', 42.2666702270508, 0.737692559316695, -70.9583282470703, -1.23845645962227, 218, 23, 'PPL', 'P'),
(116085, 'Houghton', 40.7836112976074, 0.711808297996806, -91.602783203125, -1.59877017088509, 218, 16, 'PPL', 'P'),
(127773, 'Houghton', 44.7649993896484, 0.781296629002617, -70.6500015258789, -1.2330751431656, 218, 26, 'PPL', 'P'),
(131366, 'Houghton', 47.121940612793, 0.822433013622472, -88.5688934326172, -1.54581880524715, 218, 27, 'PPL', 'P'),
(149719, 'Houghton', 42.4233283996582, 0.740426760228852, -78.1575012207031, -1.36410573143276, 218, 40, 'PPL', 'P'),
(170550, 'Houghton', 45.7630615234375, 0.798716099376717, -98.2099990844727, -1.71408784240466, 218, 49, 'PPL', 'P'),
(186869, 'Houghton', 37.5894393920898, 0.656059481370823, -104.042778015137, -1.81588903928571, 218, 7, 'PPL', 'P'),
(207690, 'Houghton', 47.6611099243164, 0.831843293334267, -122.204719543457, -2.13287471750959, 218, 56, 'PPL', 'P'),
(131368, 'Houghton Lake', 44.3147201538086, 0.773437773783848, -84.7647171020508, -1.47942340295233, 218, 27, 'PPL', 'P'),
(131369, 'Houghton Lake Heights', 44.3274993896484, 0.773660813525142, -84.7744369506836, -1.47959304631377, 218, 27, 'PPL', 'P'),
(182213, 'Houghton Place', 39.8050003051758, 0.694728314082665, -122.677223205566, -2.14112146214113, 218, 6, 'PPL', 'P'),
(131370, 'Houghton Point', 44.3722190856934, 0.774441319461617, -84.7591705322266, -1.47932659704671, 218, 27, 'PPL', 'P'),
(125109, 'Houghtonville', 42.7125015258789, 0.745473783389689, -73.1080627441406, -1.27597640463985, 218, 23, 'PPL', 'P'),
(127774, 'Houghtonville', 46.8419418334961, 0.817546113022176, -67.8752822875977, -1.18464715663917, 218, 26, 'PPL', 'P'),
(172130, 'Houghtonville', 43.1983299255371, 0.753953088563419, -72.6477813720703, -1.26794297921163, 218, 55, 'PPL', 'P'),
(131373, 'Houle', 45.7055587768555, 0.79771248711992, -87.3966674804688, -1.52535960280484, 218, 27, 'PPL', 'P'),
(60330, 'Houlka', 34.0380592346191, 0.594076204632965, -89.0219421386719, -1.55372599683971, 218, 30, 'PPL', 'P'),
(109733, 'Hoult', 39.5125007629395, 0.689623234010065, -80.1275024414063, -1.39848873900233, 218, 58, 'PPL', 'P'),
(127775, 'Houlton', 46.1261100769043, 0.805052491979315, -67.8408279418945, -1.18404581486503, 218, 26, 'PPL', 'P'),
(174577, 'Houlton', 45.0605583190918, 0.786455105455073, -92.7911071777344, -1.61951033682241, 218, 57, 'PPL', 'P'),
(41415, 'Houltonville', 30.4066696166992, 0.530696499377524, -90.142219543457, -1.5732785260889, 218, 22, 'PPL', 'P'),
(41416, 'Houma', 29.5955600738525, 0.516539967260503, -90.7194366455078, -1.58335286501851, 218, 22, 'PPL', 'P'),
(95008, 'Houmont Park', 29.8422203063965, 0.52084500045213, -95.2061080932617, -1.66166005423704, 218, 51, 'PPL', 'P'),
(65768, 'Hounds Ear', 36.1777801513672, 0.63142137970401, -81.7452774047852, -1.42672423866963, 218, 33, 'PPL', 'P'),
(136016, 'Houpt', 47.8005599975586, 0.83427715625449, -94.39111328125, -1.64743571138076, 218, 28, 'PPL', 'P'),
(13990, 'Hourglass', 39.1269416809082, 0.682893958567653, -75.682502746582, -1.32090885907751, 218, 10, 'PPL', 'P'),
(125110, 'Housatonic', 42.2541694641113, 0.737474379844391, -73.3666687011719, -1.28048993005532, 218, 23, 'PPL', 'P'),
(60331, 'House', 32.6286087036133, 0.56947665222293, -88.9947204589844, -1.55325088890124, 218, 30, 'PPL', 'P'),
(65769, 'House', 35.6544418334961, 0.622287402955311, -77.3652801513672, -1.35027886536917, 218, 33, 'PPL', 'P'),
(193061, 'House', 34.646671295166, 0.604698488956855, -103.90389251709, -1.81346503006152, 218, 38, 'PPL', 'P'),
(3244, 'House (historical)', 33.5902786254883, 0.586260958677046, -85.852783203125, -1.49841373889542, 218, 2, 'PPL', 'P'),
(55384, 'House Creek', 37.0175018310547, 0.646077287814934, -91.0625, -1.58934045009734, 218, 29, 'PPL', 'P'),
(95009, 'House Crossing', 31.1855602264404, 0.544290705030374, -97.8086090087891, -1.70708226399916, 218, 51, 'PPL', 'P'),
(55387, 'House Hollow (historical)', 37.1808280944824, 0.648927868866728, -91.4283294677734, -1.5957253788108, 218, 29, 'PPL', 'P'),
(162861, 'House Landing Strip', 41.5572204589844, 0.725310324986426, -77.1152801513672, -1.34591554223919, 218, 45, 'PPL', 'P'),
(87979, 'House Mountain (historical)', 36.1472206115723, 0.630888015116694, -83.7758331298828, -1.4621641217178, 218, 50, 'PPL', 'P'),
(55386, 'House Springs', 38.4088897705078, 0.670361588530931, -90.5699996948242, -1.58074469820494, 218, 29, 'PPL', 'P'),
(131374, 'Houseman', 44.6130599975586, 0.778644786347171, -85.3083267211914, -1.48891118065185, 218, 27, 'PPL', 'P'),
(207691, 'Houser', 46.5019416809082, 0.811611990902234, -117.775283813477, -2.05556648001595, 218, 56, 'PPL', 'P'),
(162862, 'Houserville', 40.8238906860352, 0.71251130594556, -77.8291702270508, -1.35837527455718, 218, 45, 'PPL', 'P'),
(145472, 'Houses Corner', 41.0708312988281, 0.71682123269569, -74.654167175293, -1.30296101754314, 218, 37, 'PPL', 'P'),
(162863, 'Houseville', 40.7261085510254, 0.71080468574001, -79.8430633544922, -1.39352434041432, 218, 45, 'PPL', 'P'),
(87982, 'Housley', 36.4455604553223, 0.636095027680017, -82.0447235107422, -1.43195055915085, 218, 50, 'PPL', 'P'),
(87980, 'Housley Addition', 35.4288902282715, 0.618350784810983, -84.607780456543, -1.47668434177119, 218, 50, 'PPL', 'P'),
(3246, 'Houston', 34.1413917541504, 0.595879697323167, -87.258056640625, -1.52294038727061, 218, 2, 'PPL', 'P'),
(9592, 'Houston', 35.0333290100098, 0.611446939159116, -92.6944427490234, -1.61782322427184, 218, 4, 'PPL', 'P'),
(13992, 'Houston', 38.7874984741211, 0.67696955698569, -75.2408294677734, -1.31320020614422, 218, 10, 'PPL', 'P'),
(16498, 'Houston', 30.2566699981689, 0.528078512157435, -82.9027786254883, -1.44692644606675, 218, 12, 'PPL', 'P'),
(22070, 'Houston', 33.1594390869141, 0.578741390181153, -85.1377792358398, -1.48593456550147, 218, 13, 'PPL', 'P'),
(27471, 'Houston', 38.1591682434082, 0.666003125669934, -89.7811126708984, -1.56697602221118, 218, 18, 'PPL', 'P'),
(30115, 'Houston', 39.0163917541504, 0.68096449835789, -86.1908264160156, -1.50431370597438, 218, 19, 'PPL', 'P'),
(36508, 'Houston', 37.4455604553223, 0.653548320199961, -83.5163879394531, -1.45763594891634, 218, 21, 'PPL', 'P'),
(55388, 'Houston', 37.3261108398438, 0.651463531119619, -91.9558334350586, -1.60493205985726, 218, 29, 'PPL', 'P'),
(60333, 'Houston', 32.4124984741211, 0.565704817171051, -88.6999969482422, -1.54810699325575, 218, 30, 'PPL', 'P'),
(65772, 'Houston', 34.957218170166, 0.610118554407384, -80.6283264160156, -1.40722976633219, 218, 33, 'PPL', 'P'),
(87981, 'Houston', 35.2413902282715, 0.615078292463493, -87.9177780151367, -1.53445469740162, 218, 50, 'PPL', 'P'),
(95010, 'Houston', 29.7630596160889, 0.51946338576811, -95.3630599975586, -1.66439938173429, 218, 51, 'PPL', 'P'),
(136017, 'Houston', 43.7633285522461, 0.763814174868738, -91.5683288574219, -1.59816882911095, 218, 28, 'PPL', 'P'),
(142089, 'Houston', 40.915828704834, 0.71411592708136, -97.5397186279297, -1.70238924152622, 218, 35, 'PPL', 'P'),
(155792, 'Houston', 40.2544403076172, 0.702572521915439, -84.3369369506836, -1.4719572308363, 218, 41, 'PPL', 'P'),
(162864, 'Houston', 40.2463912963867, 0.702432040167937, -80.211669921875, -1.39995773865962, 218, 45, 'PPL', 'P'),
(194242, 'Houston', 40.2547187805176, 0.702577382184428, -104.80638885498, -1.8292165626449, 218, 7, 'PPL', 'P'),
(195111, 'Houston', 43.8830604553223, 0.765903890797096, -113.575828552246, -1.98227215891728, 218, 17, 'PPL', 'P'),
(211881, 'Houston', 61.6302795410156, 1.07565129691522, -149.818054199219, -2.61481832470768, 218, 1, 'PPL', 'P'),
(41417, 'Houston (historical)', 30.5499992370605, 0.533198073168462, -92.807502746582, -1.61979649348154, 218, 22, 'PPL', 'P'),
(65771, 'Houston (historical)', 35.6755599975586, 0.622655984450178, -80.7230606079102, -1.40888318989497, 218, 33, 'PPL', 'P'),
(193661, 'Houston (historical)', 41.3786087036133, 0.722192961772434, -122.615829467773, -2.14004993927653, 218, 6, 'PPL', 'P'),
(36509, 'Houston Acres', 38.214168548584, 0.666963062084853, -85.6138916015625, -1.49424429389279, 218, 21, 'PPL', 'P'),
(162865, 'Houston City', 41.3372192382813, 0.72147057932675, -75.7333297729492, -1.32179595803661, 218, 45, 'PPL', 'P'),
(3247, 'Houston Corner', 34.7297210693359, 0.606147980959158, -87.6341705322266, -1.52950481304155, 218, 2, 'PPL', 'P'),
(127777, 'Houston Corner', 44.7949981689453, 0.781820206472927, -69.3386077880859, -1.21018700465108, 218, 26, 'PPL', 'P'),
(95012, 'Houston Heights', 29.797779083252, 0.520069354784644, -95.3977813720703, -1.66500538404034, 218, 51, 'PPL', 'P'),
(22072, 'Houston Lake', 32.4955596923828, 0.567154508910436, -83.6761093139648, -1.46042361278738, 218, 13, 'PPL', 'P'),
(55391, 'Houston Lake', 39.1927795410156, 0.684043045998995, -94.620002746582, -1.65143058617393, 218, 29, 'PPL', 'P'),
(22073, 'Houston Lake Woods', 32.5013885498047, 0.567256241664077, -83.6763916015625, -1.4604285396354, 218, 13, 'PPL', 'P'),
(65774, 'Houston Mobile Home Park', 34.7538909912109, 0.606569825675827, -77.4744415283203, -1.35218409081302, 218, 33, 'PPL', 'P'),
(95013, 'Houston Road East Colonia', 25.9249992370605, 0.452476595263724, -97.3840026855469, -1.69967148563379, 218, 51, 'PPL', 'P'),
(87984, 'Houston Valley', 35.9680595397949, 0.627761064522778, -82.9194412231445, -1.44721726325779, 218, 50, 'PPL', 'P'),
(55389, 'Houstonia', 38.8988914489746, 0.678913731160475, -93.3580627441406, -1.62940557816871, 218, 29, 'PPL', 'P'),
(102971, 'Houstons Corner', 37.9425010681152, 0.662221570080076, -77.5319366455078, -1.35318756991176, 218, 53, 'PPL', 'P'),
(3249, 'Houstontown', 34.827220916748, 0.607849674316691, -87.4349975585938, -1.52602858887066, 218, 2, 'PPL', 'P'),
(3250, 'Houstonville', 30.5016708374023, 0.532354583472207, -87.9002838134766, -1.53414936598264, 218, 2, 'PPL', 'P'),
(65775, 'Houstonville', 36.003059387207, 0.628371927097815, -80.7663879394531, -1.4096393944865, 218, 33, 'PPL', 'P'),
(65776, 'Houstonville (historical)', 35.9613914489746, 0.627644684383141, -80.6991729736328, -1.40846627202632, 218, 33, 'PPL', 'P'),
(78490, 'Housum', 39.8702812194824, 0.695867680976028, -77.7324981689453, -1.35668802884856, 218, 45, 'PPL', 'P'),
(162867, 'Houtzdale', 40.8250007629395, 0.71253068044249, -78.3513870239258, -1.36748967707187, 218, 45, 'PPL', 'P'),
(182214, 'Houze Place', 34.7686080932617, 0.606826687562965, -117.625, -2.05294353265833, 218, 6, 'PPL', 'P'),
(109735, 'Hovatter', 39.2350006103516, 0.68477994267262, -79.7552795410156, -1.39199222383919, 218, 58, 'PPL', 'P'),
(140252, 'Hove Mobile Park', 48.5825004577637, 0.847924591839628, -98.2302780151367, -1.71444177651354, 218, 34, 'PPL', 'P'),
(170551, 'Hoven', 45.2436103820801, 0.789649966656787, -99.7766723632813, -1.74143144942289, 218, 49, 'PPL', 'P'),
(30116, 'Hovey', 37.892219543457, 0.661343991921868, -87.9419403076172, -1.53487640896023, 218, 19, 'PPL', 'P'),
(60334, 'Hovey', 30.6144409179688, 0.53432279267583, -89.1333312988281, -1.55567010443546, 218, 30, 'PPL', 'P'),
(190991, 'Hovey', 36.8627815246582, 0.643376909048621, -101.678611755371, -1.77462655398824, 218, 42, 'PPL', 'P'),
(191631, 'Hovey', 30.6108303070068, 0.534259775626536, -103.366943359375, -1.80409349934358, 218, 51, 'PPL', 'P'),
(125111, 'Hovey Corner', 42.6794395446777, 0.744896742960496, -71.6013870239258, -1.24967995256225, 218, 23, 'PPL', 'P'),
(140254, 'Hoving', 46.247501373291, 0.807171169784527, -97.5677795410156, -1.70287899685068, 218, 34, 'PPL', 'P'),
(136021, 'Hovland', 47.8388900756836, 0.834946142320318, -89.9719390869141, -1.57030657147043, 218, 28, 'PPL', 'P'),
(182215, 'Hovley', 33.002498626709, 0.576002262420979, -115.52082824707, -2.01621880754225, 218, 6, 'PPL', 'P'),
(3251, 'Howard', 33.8541717529297, 0.590866762624283, -87.567497253418, -1.52834114480323, 218, 2, 'PPL', 'P'),
(9594, 'Howard', 34.7058296203613, 0.605730996511479, -94.4369430541992, -1.64823559181417, 218, 4, 'PPL', 'P'),
(16499, 'Howard', 25.6469402313232, 0.447623550098787, -80.3344421386719, -1.4021005180727, 218, 12, 'PPL', 'P'),
(22075, 'Howard', 32.5958290100098, 0.568904538641754, -84.3844375610352, -1.47278627288364, 218, 13, 'PPL', 'P'),
(30117, 'Howard', 39.9161109924316, 0.696667561409434, -87.3755569458008, -1.52499115446802, 218, 19, 'PPL', 'P'),
(32805, 'Howard', 37.4702796936035, 0.653979752296553, -96.2633285522461, -1.68011203216576, 218, 20, 'PPL', 'P'),
(36510, 'Howard', 37.9888916015625, 0.663031237630487, -85.9608306884766, -1.5002995232633, 218, 21, 'PPL', 'P'),
(41418, 'Howard', 32.226390838623, 0.562456626168509, -93.4824981689453, -1.63157738603767, 218, 22, 'PPL', 'P'),
(60335, 'Howard', 33.1227798461914, 0.578101565729261, -90.1908264160156, -1.57412687605415, 218, 30, 'PPL', 'P'),
(76138, 'Howard', 36.4952812194824, 0.63696281872122, -95.458610534668, -1.6660670532089, 218, 42, 'PPL', 'P'),
(81648, 'Howard', 34.1122207641602, 0.595370567501771, -78.876106262207, -1.37664775542843, 218, 48, 'PPL', 'P'),
(87987, 'Howard', 35.5508308410645, 0.62047904999612, -84.158332824707, -1.46884000078036, 218, 50, 'PPL', 'P'),
(95014, 'Howard', 32.2905616760254, 0.563576618564942, -96.7708282470703, -1.68896957279331, 218, 51, 'PPL', 'P'),
(102972, 'Howard', 38.9147186279297, 0.679189967544543, -77.2255630493164, -1.34784034191704, 218, 53, 'PPL', 'P'),
(109736, 'Howard', 39.7311096191406, 0.693438678324794, -80.6427764892578, -1.40748196768742, 218, 58, 'PPL', 'P'),
(120078, 'Howard', 40.327220916748, 0.703842783176379, -90.2663879394531, -1.57544567342596, 218, 18, 'PPL', 'P'),
(149721, 'Howard', 42.3641700744629, 0.739394252674229, -77.5091705322266, -1.35279022627712, 218, 40, 'PPL', 'P'),
(155793, 'Howard', 40.4075012207031, 0.705243938804897, -82.3269424438477, -1.43687620874501, 218, 41, 'PPL', 'P'),
(162871, 'Howard', 41.8863906860352, 0.731055429248, -78.6522216796875, -1.37274023231901, 218, 45, 'PPL', 'P'),
(170554, 'Howard', 44.0108299255371, 0.768133888735873, -97.5263900756836, -1.702156614405, 218, 49, 'PPL', 'P'),
(174580, 'Howard', 44.9505615234375, 0.784535299204263, -91.5374984741211, -1.5976307374127, 218, 57, 'PPL', 'P'),
(186870, 'Howard', 38.4486083984375, 0.671054809362678, -105.834716796875, -1.84716427102122, 218, 7, 'PPL', 'P'),
(193662, 'Howard', 41.313060760498, 0.721048934347163, -122.275833129883, -2.13411588373562, 218, 6, 'PPL', 'P'),
(195112, 'Howard', 46.2763900756836, 0.807675372757907, -116.297218322754, -2.02976937064273, 218, 17, 'PPL', 'P'),
(207692, 'Howard', 47.8980598449707, 0.835978849612024, -119.823608398438, -2.09131648817306, 218, 56, 'PPL', 'P'),
(48312, 'Howard (historical)', 37.9888916015625, 0.663031237630487, -75.7808303833008, -1.32262500008396, 218, 25, 'PPL', 'P'),
(87986, 'Howard (historical)', 35.4533309936523, 0.618777356638586, -87.6044387817383, -1.52898589610314, 218, 50, 'PPL', 'P'),
(109737, 'Howard (historical)', 39.7372207641602, 0.693545337926452, -80.6394424438477, -1.4074237776176, 218, 58, 'PPL', 'P'),
(196747, 'Howard (historical)', 46.2544403076172, 0.807292277035099, -106.928329467773, -1.86625141286992, 218, 31, 'PPL', 'P'),
(149722, 'Howard Beach', 40.6577796936035, 0.709612122203873, -73.836669921875, -1.28869299884498, 218, 40, 'PPL', 'P'),
(87988, 'Howard Chapel', 36.4222183227539, 0.635687630612262, -85.2827835083008, -1.48846536748537, 218, 50, 'PPL', 'P'),
(131375, 'Howard City', 43.3955612182617, 0.757395424009429, -85.4677810668945, -1.49169418399098, 218, 27, 'PPL', 'P'),
(127778, 'Howard Corner', 45.1661109924316, 0.788297347139136, -69.3058319091797, -1.20961495764893, 218, 26, 'PPL', 'P'),
(120079, 'Howard District', 42.0208282470703, 0.733401807326414, -87.6691665649414, -1.53011560903755, 218, 18, 'PPL', 'P'),
(155794, 'Howard Farms Beach', 41.6538887023926, 0.726997504116019, -83.2455596923828, -1.45290910429756, 218, 41, 'PPL', 'P'),
(48318, 'Howard Heights', 39.2838897705078, 0.685633219485881, -76.8305587768555, -1.34094621680316, 218, 25, 'PPL', 'P'),
(87989, 'Howard Hill', 36.5561103820801, 0.63802448788978, -82.5838928222656, -1.44136083886265, 218, 50, 'PPL', 'P'),
(48314, 'Howard Hills', 39.1408309936523, 0.683136372805877, -76.8191680908203, -1.34074741182778, 218, 25, 'PPL', 'P'),
(136022, 'Howard Lake', 45.0608291625977, 0.786459832566008, -94.0730590820313, -1.6418846184046, 218, 28, 'PPL', 'P'),
(136023, 'Howard Lake Mobile Home Park', 45.0566711425781, 0.786387261426304, -94.0755615234375, -1.64192829424648, 218, 28, 'PPL', 'P'),
(3252, 'Howard Landing', 31.4558296203613, 0.549007795821663, -87.5658264160156, -1.5283119831893, 218, 2, 'PPL', 'P'),
(182216, 'Howard Landing', 38.228889465332, 0.667219990551019, -121.599998474121, -2.12232034379349, 218, 6, 'PPL', 'P'),
(13994, 'Howard Manor', 38.5522193908691, 0.672863162321869, -75.1399993896484, -1.31144038929589, 218, 10, 'PPL', 'P'),
(48315, 'Howard Manor', 39.1477813720703, 0.68325767979353, -76.5763931274414, -1.33651018937541, 218, 25, 'PPL', 'P'),
(87995, 'Howard Mill', 36.1025009155273, 0.630107509180219, -84.716667175293, -1.47858477352507, 218, 50, 'PPL', 'P'),
(182217, 'Howard Mill (historical)', 39.3050003051758, 0.686001667822693, -122.939720153809, -2.14570289816439, 218, 6, 'PPL', 'P'),
(48316, 'Howard Park', 39.3311080932617, 0.686457334685206, -76.6949996948242, -1.33858026449073, 218, 25, 'PPL', 'P'),
(87990, 'Howard Quarter', 36.4738883972168, 0.63658944353639, -83.4111099243164, -1.45579850092224, 218, 50, 'PPL', 'P'),
(162872, 'Howard Siding', 41.476390838623, 0.723899581977984, -78.3236083984375, -1.36700484859542, 218, 45, 'PPL', 'P'),
(87991, 'Howard Springs', 35.957218170166, 0.627571846927328, -85.0824966430664, -1.48496970223853, 218, 50, 'PPL', 'P'),
(182218, 'Howard Springs', 38.8583297729492, 0.678205796363704, -122.673606872559, -2.14105834522329, 218, 6, 'PPL', 'P'),
(95015, 'Howards', 30.7486095428467, 0.536664476932823, -93.7838897705078, -1.63683766182279, 218, 51, 'PPL', 'P'),
(102973, 'Howards Corner', 38.0941696166992, 0.664868685624588, -77.2911071777344, -1.34898430276329, 218, 53, 'PPL', 'P'),
(207693, 'Howards Corner', 48.454719543457, 0.845694394163769, -122.581672668457, -2.13945379066652, 218, 56, 'PPL', 'P'),
(81649, 'Howards Crossroads', 34.2916717529297, 0.598502578101759, -79.7747192382813, -1.39233151056207, 218, 48, 'PPL', 'P'),
(143986, 'Howards Grove', 42.872501373291, 0.748266307529719, -71.2213897705078, -1.24304774934157, 218, 36, 'PPL', 'P'),
(174584, 'Howards Grove', 43.8338890075684, 0.765045687135817, -87.8199996948242, -1.5327481437751, 218, 57, 'PPL', 'P'),
(87992, 'Howards Landing', 35.5097198486328, 0.619761527819425, -90.0100021362305, -1.57097089700435, 218, 50, 'PPL', 'P'),
(22076, 'Howards Mill', 31.1561107635498, 0.543776714939989, -84.9947204589844, -1.48343771882146, 218, 13, 'PPL', 'P'),
(36511, 'Howards Mill', 38.0638885498047, 0.664340181306261, -83.8475036621094, -1.46341500848181, 218, 21, 'PPL', 'P'),
(27472, 'Howards Point (historical)', 39.0208282470703, 0.681041929766584, -88.8574981689453, -1.55085590813293, 218, 18, 'PPL', 'P'),
(48322, 'Howards Retreat', 39.4513893127441, 0.688556637993488, -77.4611129760742, -1.3519514636918, 218, 25, 'PPL', 'P'),
(55394, 'Howards Ridge', 36.5288887023926, 0.63754937995131, -92.3319396972656, -1.61149635247014, 218, 29, 'PPL', 'P'),
(36512, 'Howardstown', 37.5722198486328, 0.655758943641808, -85.5919418334961, -1.49386119816998, 218, 21, 'PPL', 'P'),
(48319, 'Howardsville', 39.3613891601563, 0.686985839003532, -76.7238922119141, -1.33908453404314, 218, 25, 'PPL', 'P'),
(70968, 'Howardsville', 39.8127784729004, 0.694864068719232, -74.3652801513672, -1.29791898780934, 218, 37, 'PPL', 'P'),
(102975, 'Howardsville', 39.0377807617188, 0.681337806963692, -77.8388900756836, -1.35854491791862, 218, 53, 'PPL', 'P'),
(131377, 'Howardsville', 42.0250015258789, 0.733474644782228, -85.7183303833008, -1.49606709450089, 218, 27, 'PPL', 'P'),
(186871, 'Howardsville', 37.8355598449707, 0.660355093630094, -107.593612670898, -1.87786279522267, 218, 7, 'PPL', 'P'),
(27473, 'Howardton', 37.6291694641113, 0.656752901939653, -89.4644393920898, -1.56144903084288, 218, 18, 'PPL', 'P'),
(55395, 'Howardville', 36.5680618286133, 0.63823307998216, -89.6005630493164, -1.56382483685134, 218, 29, 'PPL', 'P'),
(87993, 'Howardville', 35.0055618286133, 0.610962310419749, -84.9977798461914, -1.48349111520132, 218, 50, 'PPL', 'P'),
(116092, 'Howardville', 43.1908302307129, 0.753822194195842, -92.7122192382813, -1.61813348253884, 218, 16, 'PPL', 'P'),
(149724, 'Howardville', 43.4627799987793, 0.758568613048636, -76.0530624389648, -1.32737634578477, 218, 40, 'PPL', 'P'),
(191633, 'Howardwick', 35.0372200012207, 0.611514849766913, -100.906387329102, -1.76114869518551, 218, 51, 'PPL', 'P'),
(41419, 'Howcott', 31.6561107635498, 0.55250336119996, -92.3888931274414, -1.61249037734701, 218, 22, 'PPL', 'P'),
(3253, 'Howe', 32.0183296203613, 0.558825272864131, -85.1641693115234, -1.486395159212, 218, 2, 'PPL', 'P'),
(76139, 'Howe', 34.9511108398438, 0.610011961384754, -94.6369400024414, -1.65172619705493, 218, 42, 'PPL', 'P'),
(81650, 'Howe', 34.1338882446289, 0.595748736376562, -79.7583312988281, -1.392045487061, 218, 48, 'PPL', 'P'),
(95016, 'Howe', 33.5086097717285, 0.584835568282608, -96.6119384765625, -1.68619642315021, 218, 51, 'PPL', 'P'),
(116093, 'Howe', 41.4030609130859, 0.722619733337119, -94.3758316040039, -1.64716899579759, 218, 16, 'PPL', 'P'),
(122839, 'Howe', 41.7213897705078, 0.728175620003243, -85.4205627441406, -1.49087006879166, 218, 19, 'PPL', 'P'),
(125112, 'Howe', 42.5944404602051, 0.743413229075267, -70.9986114501953, -1.23915953415005, 218, 23, 'PPL', 'P'),
(142091, 'Howe', 40.3219413757324, 0.703750637802663, -95.8188934326172, -1.67235517601674, 218, 35, 'PPL', 'P'),
(162875, 'Howe', 41.2150001525879, 0.719337453872624, -79.1025009155273, -1.38059908753778, 218, 45, 'PPL', 'P'),
(193150, 'Howe', 43.7836112976074, 0.764168175556636, -113.003890991211, -1.97228996536139, 218, 17, 'PPL', 'P'),
(204412, 'Howe', 40.648609161377, 0.709452066222359, -111.864166259766, -1.95239801623126, 218, 52, 'PPL', 'P'),
(127779, 'Howe Brook', 46.3050003051758, 0.808174715462296, -68.1947174072266, -1.19022235122319, 218, 26, 'PPL', 'P'),
(120080, 'Howe Terrace', 42.1502799987793, 0.73566116661621, -88.1083297729492, -1.53778045297091, 218, 18, 'PPL', 'P'),
(36513, 'Howe Valley', 37.6872215270996, 0.657766101576374, -86.0883331298828, -1.50252486067017, 218, 21, 'PPL', 'P'),
(36514, 'Howel', 36.6991691589355, 0.640521334569783, -87.5355606079102, -1.52778374518708, 218, 21, 'PPL', 'P'),
(9597, 'Howell', 35.1136093139648, 0.612848094787634, -91.2452774047852, -1.59253051760909, 218, 4, 'PPL', 'P'),
(22078, 'Howell', 30.8274993896484, 0.538041364505908, -83.0538864135742, -1.44956377449426, 218, 13, 'PPL', 'P'),
(41420, 'Howell', 30.523609161377, 0.532737479457933, -91.144172668457, -1.5907659070708, 218, 22, 'PPL', 'P'),
(55398, 'Howell', 38.7430610656738, 0.676193977897231, -90.6108322143555, -1.58145736011265, 218, 29, 'PPL', 'P'),
(60336, 'Howell', 30.7936096191406, 0.537449876427801, -88.4288864135742, -1.54337522178895, 218, 30, 'PPL', 'P'),
(72963, 'Howell', 38.4458312988281, 0.671006339830839, -82.5041732788086, -1.43996947035114, 218, 41, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(87994, 'Howell', 35.2299995422363, 0.614879487488119, -86.6111068725586, -1.51164898372284, 218, 50, 'PPL', 'P'),
(102976, 'Howell', 37.274169921875, 0.650556991084556, -79.8816680908203, -1.39419812017011, 218, 53, 'PPL', 'P'),
(131378, 'Howell', 42.6072196960449, 0.743636268816562, -83.929443359375, -1.46484512598718, 218, 27, 'PPL', 'P'),
(149725, 'Howell', 41.3816719055176, 0.722246424731318, -74.3436126708984, -1.29754081893455, 218, 40, 'PPL', 'P'),
(162878, 'Howell', 40.2224998474121, 0.702015055720258, -76.9674987792969, -1.34333627072345, 218, 45, 'PPL', 'P'),
(187722, 'Howell', 37.7833290100098, 0.65944349358896, -100.178886413574, -1.74845140889828, 218, 20, 'PPL', 'P'),
(195113, 'Howell', 46.7358283996582, 0.815694084221108, -116.815826416016, -2.03882078939764, 218, 17, 'PPL', 'P'),
(204411, 'Howell', 41.7961082458496, 0.729479703410027, -112.44361114502, -1.96251123731278, 218, 52, 'PPL', 'P'),
(209517, 'Howell', 41.417781829834, 0.722876661803285, -105.614723205566, -1.84332465851959, 218, 59, 'PPL', 'P'),
(55396, 'Howell (historical)', 38.6933288574219, 0.675325987118947, -90.7658309936523, -1.58416259914795, 218, 29, 'PPL', 'P'),
(60337, 'Howell (historical)', 32.2444381713867, 0.562771611546438, -90.1111068725586, -1.57273550754264, 218, 30, 'PPL', 'P'),
(116094, 'Howell (historical)', 41.3791694641113, 0.72220274888944, -92.9680633544922, -1.62259880473857, 218, 16, 'PPL', 'P'),
(195114, 'Howell (historical)', 43.792781829834, 0.76432823153815, -116.258331298828, -2.02909066403893, 218, 17, 'PPL', 'P'),
(95017, 'Howell Addition Colonia', 27.7759990692139, 0.484782636788662, -98.0859985351563, -1.71192362454481, 218, 51, 'PPL', 'P'),
(41421, 'Howell Community Farms', 30.5227794647217, 0.532722998519506, -91.1516723632813, -1.59089680143838, 218, 22, 'PPL', 'P'),
(22081, 'Howell Estates', 33.5486106872559, 0.585533715962372, -84.4199981689453, -1.47340692257568, 218, 13, 'PPL', 'P'),
(22079, 'Howell Grove', 33.3236083984375, 0.581606685197969, -83.0891723632813, -1.45017963049634, 218, 13, 'PPL', 'P'),
(87996, 'Howell Hill', 35.061939239502, 0.611946281863506, -86.5177764892578, -1.51002006124209, 218, 50, 'PPL', 'P'),
(102977, 'Howell Mills', 37.5008316040039, 0.654512983725814, -79.9116668701172, -1.39472169764042, 218, 53, 'PPL', 'P'),
(182219, 'Howell Mountain', 38.5813903808594, 0.673372292143265, -122.449996948242, -2.13715561580383, 218, 6, 'PPL', 'P'),
(16500, 'Howell Place', 29.771390914917, 0.519608794363629, -83.5083312988281, -1.45749533401078, 218, 12, 'PPL', 'P'),
(182220, 'Howell Place', 34.4691696166992, 0.601600500239793, -119.11888885498, -2.07901681183659, 218, 6, 'PPL', 'P'),
(3254, 'Howells', 31.0522193908691, 0.541963468422294, -86.2091674804688, -1.5046338179374, 218, 2, 'PPL', 'P'),
(81651, 'Howells', 33.976390838623, 0.59299988807841, -78.9983291625977, -1.37878094746158, 218, 48, 'PPL', 'P'),
(142092, 'Howells', 41.7249984741211, 0.728238603763023, -97.0025024414063, -1.69301305027638, 218, 35, 'PPL', 'P'),
(149726, 'Howells', 41.4794387817383, 0.723952778620759, -74.4655609130859, -1.29966921727774, 218, 40, 'PPL', 'P'),
(3262, 'Howells Cove', 33.4919395446777, 0.584544617933517, -86.1600036621094, -1.50377574743418, 218, 2, 'PPL', 'P'),
(3255, 'Howells Crossroads', 34.1780586242676, 0.596519654933113, -85.5455627441406, -1.49305173035665, 218, 2, 'PPL', 'P'),
(102978, 'Howells Mill', 36.8888893127441, 0.643832575911134, -77.3305587768555, -1.34967286306313, 218, 53, 'PPL', 'P'),
(109742, 'Howells Mill', 38.4416694641113, 0.670933702112107, -82.2197189331055, -1.43500480544701, 218, 58, 'PPL', 'P'),
(65780, 'Howellsville', 34.6966705322266, 0.605571140267047, -78.9172210693359, -1.37736534418415, 218, 33, 'PPL', 'P'),
(102979, 'Howellsville', 38.9747200012207, 0.68023718906419, -78.0794372558594, -1.36274325821907, 218, 53, 'PPL', 'P'),
(195115, 'Howelltown', 47.785831451416, 0.83402009463027, -116.980003356934, -2.04168621757251, 218, 17, 'PPL', 'P'),
(162879, 'Howellville', 40.059440612793, 0.699169135200372, -75.4700012207031, -1.31720000778541, 218, 45, 'PPL', 'P'),
(3257, 'Howelton', 34.0558280944824, 0.594386329741905, -86.1836090087891, -1.50418773845482, 218, 2, 'PPL', 'P'),
(155796, 'Howenstine', 40.7194404602051, 0.710688305600374, -81.3472213745117, -1.41977685033394, 218, 41, 'PPL', 'P'),
(162880, 'Howersville', 40.7702789306641, 0.711575604296561, -75.5116729736328, -1.31792731707911, 218, 45, 'PPL', 'P'),
(102980, 'Howertons', 37.8311080932617, 0.660277395905291, -76.8902816772461, -1.34198857805381, 218, 53, 'PPL', 'P'),
(162881, 'Howertown', 40.6966705322266, 0.710290895386707, -75.4661102294922, -1.31713209717761, 218, 45, 'PPL', 'P'),
(55400, 'Howes', 37.7094383239746, 0.658153857831089, -91.5144424438477, -1.59722833377199, 218, 29, 'PPL', 'P'),
(149728, 'Howes', 42.5986099243164, 0.743485999952054, -78.2355575561523, -1.36546807148839, 218, 40, 'PPL', 'P'),
(202233, 'Howes', 44.6194381713867, 0.778756106480736, -102.051391601563, -1.78113278968935, 218, 49, 'PPL', 'P'),
(149729, 'Howes Cave', 42.689998626709, 0.745081033707929, -74.3833312988281, -1.2982340397663, 218, 40, 'PPL', 'P'),
(127780, 'Howes Corner', 44.3319396972656, 0.773738311512863, -70.2186126708984, -1.22554598728979, 218, 26, 'PPL', 'P'),
(149730, 'Howes Landing', 43.8152809143066, 0.764720914640882, -73.436393737793, -1.28170686151543, 218, 40, 'PPL', 'P'),
(48320, 'Howes Meadows', 38.7024993896484, 0.675486043100461, -76.6811065673828, -1.33833778367348, 218, 25, 'PPL', 'P'),
(55401, 'Howes Mill', 37.6177787780762, 0.656554096964278, -91.2916717529297, -1.59334025173853, 218, 29, 'PPL', 'P'),
(30120, 'Howesville', 39.1769409179688, 0.683766609877844, -87.1469421386719, -1.52100107336481, 218, 19, 'PPL', 'P'),
(109738, 'Howesville', 39.4391708374023, 0.6883433853692, -79.7561111450195, -1.39200673806714, 218, 58, 'PPL', 'P'),
(16501, 'Howey Height', 28.6658306121826, 0.500313127001568, -81.7311096191406, -1.42647696416241, 218, 12, 'PPL', 'P'),
(16502, 'Howey in the Hills', 28.7166690826416, 0.501200425697756, -81.7736129760742, -1.42721878768405, 218, 12, 'PPL', 'P'),
(60338, 'Howison', 30.6652793884277, 0.535210091372017, -89.1383285522461, -1.55575732296116, 218, 30, 'PPL', 'P'),
(95018, 'Howland', 33.5330581665039, 0.585262273268266, -95.6386108398438, -1.66920865118881, 218, 51, 'PPL', 'P'),
(102981, 'Howland', 37.8708305358887, 0.660970683316066, -76.4555587768555, -1.33440123210818, 218, 53, 'PPL', 'P'),
(127781, 'Howland', 45.2386093139648, 0.78956268155206, -68.6641693115234, -1.19841583263293, 218, 26, 'PPL', 'P'),
(139221, 'Howland', 40.5347213745117, 0.707464349363751, -92.9572219848633, -1.62240958714312, 218, 29, 'PPL', 'P'),
(149732, 'Howland', 41.605281829834, 0.726149154150774, -73.9400024414063, -1.29049649153518, 218, 40, 'PPL', 'P'),
(155797, 'Howland Center', 41.2511100769043, 0.719967690944591, -80.7455596923828, -1.4092758729977, 218, 41, 'PPL', 'P'),
(149733, 'Howland Corners', 42.5397186279297, 0.742458152929338, -76.4541702270508, -1.33437699734226, 218, 40, 'PPL', 'P'),
(155798, 'Howland Corners', 41.2383308410645, 0.719744651203297, -80.7408294677734, -1.40919331500391, 218, 41, 'PPL', 'P'),
(182221, 'Howland Flat', 39.7150001525879, 0.693157515092709, -120.885559082031, -2.10985102409558, 218, 6, 'PPL', 'P'),
(125113, 'Howlands', 41.7972183227539, 0.729499077906958, -70.845832824707, -1.23649304410861, 218, 23, 'PPL', 'P'),
(131381, 'Howlandsburg', 42.3349990844727, 0.738885122852833, -85.4036102294922, -1.49057419159455, 218, 27, 'PPL', 'P'),
(149734, 'Howlett Hill', 43.0158309936523, 0.750767881320657, -76.2861099243164, -1.33144379171764, 218, 40, 'PPL', 'P'),
(102982, 'Howlett Park', 37.389720916748, 0.652573736399046, -77.4444427490234, -1.35166051334271, 218, 53, 'PPL', 'P'),
(87998, 'Howley', 35.8844413757324, 0.626301652245414, -88.5391693115234, -1.5453000214668, 218, 50, 'PPL', 'P'),
(87997, 'Howse', 35.9494400024414, 0.627436092290761, -88.6427764892578, -1.54710830784697, 218, 50, 'PPL', 'P'),
(95019, 'Howth', 30.1686096191406, 0.526541568602836, -96.0650024414063, -1.67665058853893, 218, 51, 'PPL', 'P'),
(3258, 'Howton', 33.2588882446289, 0.580477105421612, -87.3402786254883, -1.524375431624, 218, 2, 'PPL', 'P'),
(41424, 'Howze Beach', 30.2094402313232, 0.527254197221028, -89.7900009155273, -1.56713115134468, 218, 22, 'PPL', 'P'),
(76141, 'Hoxbar', 34.0708312988281, 0.594648185056087, -97.0388870239258, -1.69364808103831, 218, 42, 'PPL', 'P'),
(131382, 'Hoxeyville', 44.1938896179199, 0.771328883095641, -85.7144393920898, -1.49599918389309, 218, 27, 'PPL', 'P'),
(9601, 'Hoxie', 36.0502815246582, 0.629196108876167, -90.9749984741211, -1.58781326037023, 218, 4, 'PPL', 'P'),
(95020, 'Hoxie', 30.6541690826416, 0.535016179955146, -97.345832824707, -1.69900529588711, 218, 51, 'PPL', 'P'),
(187721, 'Hoxie', 39.3574981689453, 0.686917928395735, -100.441390991211, -1.7530329780796, 218, 20, 'PPL', 'P'),
(149735, 'Hoxie Corner', 41.7136116027832, 0.728039865366676, -73.7022171020508, -1.28634635445046, 218, 40, 'PPL', 'P'),
(127783, 'Hoxies', 44.6505584716797, 0.779299258185058, -69.7422180175781, -1.21723133205045, 218, 26, 'PPL', 'P'),
(169426, 'Hoxsie', 41.7330589294434, 0.728379285247607, -71.4113922119141, -1.24636391753094, 218, 47, 'PPL', 'P'),
(60339, 'Hoy', 31.764720916748, 0.554398965974365, -89.1324996948242, -1.55565559020752, 218, 30, 'PPL', 'P'),
(109739, 'Hoy', 39.3177795410156, 0.686224707563988, -78.5522232055664, -1.37099492969863, 218, 58, 'PPL', 'P'),
(41425, 'Hoy (historical)', 30.7958297729492, 0.537488625421662, -93.0716705322266, -1.62440709111874, 218, 22, 'PPL', 'P'),
(190321, 'Hoya', 36.9469413757324, 0.644845775547854, -114.651390075684, -2.00104424880903, 218, 39, 'PPL', 'P'),
(190322, 'Hoye (historical)', 38.7605590820313, 0.676499375895236, -119.382217407227, -2.08361276208779, 218, 39, 'PPL', 'P'),
(48321, 'Hoyes', 39.5902786254883, 0.690980713796706, -79.3697204589844, -1.38526294839678, 218, 25, 'PPL', 'P'),
(48326, 'Hoyes Run', 39.5280609130859, 0.689894809862226, -79.4108276367188, -1.38598040399445, 218, 25, 'PPL', 'P'),
(196748, 'Hoyle (historical)', 47.0119400024414, 0.820513140792634, -108.165000915527, -1.88783540139863, 218, 31, 'PPL', 'P'),
(142093, 'Hoyle North 77 Mobile Homes', 40.3077812194824, 0.703503496453503, -96.745002746582, -1.68851883277881, 218, 35, 'PPL', 'P'),
(65781, 'Hoylesville (historical)', 35.3488883972168, 0.616954489451454, -81.1811065673828, -1.41687760001322, 218, 33, 'PPL', 'P'),
(27474, 'Hoyleton', 38.4416694641113, 0.670933702112107, -89.274169921875, -1.55812820212161, 218, 18, 'PPL', 'P'),
(9600, 'Hoyt', 35.4263916015625, 0.618307175548133, -93.563606262207, -1.6329929893151, 218, 4, 'PPL', 'P'),
(16503, 'Hoyt', 29.1655597686768, 0.509035046150605, -82.3977813720703, -1.43811258128108, 218, 12, 'PPL', 'P'),
(32808, 'Hoyt', 39.2477798461914, 0.685002982413914, -95.7061080932617, -1.67038670049701, 218, 20, 'PPL', 'P'),
(76142, 'Hoyt', 35.271671295166, 0.61560679678182, -95.3019409179688, -1.66333265255966, 218, 42, 'PPL', 'P'),
(109740, 'Hoyt', 39.6127815246582, 0.691373463478465, -80.6369400024414, -1.40738010177573, 218, 58, 'PPL', 'P'),
(174597, 'Hoyt', 46.4105606079102, 0.810017090304413, -90.2994384765625, -1.57602251411807, 218, 57, 'PPL', 'P'),
(194243, 'Hoyt', 40.0155601501465, 0.698403276649893, -104.074440002441, -1.8164416452119, 218, 7, 'PPL', 'P'),
(195116, 'Hoyt', 47.253059387207, 0.824721467947177, -115.917221069336, -2.02313716742205, 218, 17, 'PPL', 'P'),
(196749, 'Hoyt', 46.9297218322754, 0.819078163018272, -104.85417175293, -1.83005053154026, 218, 31, 'PPL', 'P'),
(136025, 'Hoyt Lakes', 47.519718170166, 0.829375541689172, -92.1383285522461, -1.60811720052099, 218, 28, 'PPL', 'P'),
(162882, 'Hoytdale', 40.8491706848145, 0.712952525159159, -80.3294372558594, -1.40201316638894, 218, 45, 'PPL', 'P'),
(95021, 'Hoyte', 30.7847194671631, 0.53729471400479, -96.915283203125, -1.69149078739729, 218, 51, 'PPL', 'P'),
(204413, 'Hoytsville', 40.874439239502, 0.713393544635676, -111.379722595215, -1.94394287924442, 218, 52, 'PPL', 'P'),
(127784, 'Hoyttown', 44.7227783203125, 0.780559732328992, -67.4449996948242, -1.17713730868125, 218, 26, 'PPL', 'P'),
(131383, 'Hoytville', 42.7411117553711, 0.745973126094079, -84.896110534668, -1.481716650967, 218, 27, 'PPL', 'P'),
(155800, 'Hoytville', 41.189998626709, 0.718901094928015, -83.7847213745117, -1.4623192508513, 218, 41, 'PPL', 'P'),
(162883, 'Hoytville', 41.5877799987793, 0.725843689573742, -77.2991714477539, -1.3491250508269, 218, 45, 'PPL', 'P'),
(178395, 'Huachuca City', 31.6277809143066, 0.552008912054073, -110.33332824707, -1.92567985259504, 218, 5, 'PPL', 'P'),
(178394, 'Huachuca Terrace', 31.3966693878174, 0.547975254977526, -109.924438476563, -1.91854337982196, 218, 5, 'PPL', 'P'),
(199999, 'Hualipi (historical)', 40.8830604553223, 0.713544013237266, -119.306106567383, -2.08228437733606, 218, 39, 'PPL', 'P'),
(182222, 'Huasna', 35.1227798461914, 0.613008150769148, -120.392501831055, -2.10124555166521, 218, 6, 'PPL', 'P'),
(60340, 'Hub', 31.1452808380127, 0.54358769708162, -89.75, -1.56643300366491, 218, 30, 'PPL', 'P'),
(182224, 'Hub', 36.4022216796875, 0.635338623351408, -119.808059692383, -2.09104511205798, 218, 6, 'PPL', 'P'),
(191634, 'Hub', 34.5255317687988, 0.602584205367441, -102.727890014648, -1.79293991438222, 218, 51, 'PPL', 'P'),
(3260, 'Hub (historical)', 34.6097183227539, 0.604053537919865, -87.98388671875, -1.5356085119439, 218, 2, 'PPL', 'P'),
(170561, 'Hub City', 42.9536094665527, 0.74968191080715, -96.904167175293, -1.69129677611188, 218, 49, 'PPL', 'P'),
(174585, 'Hub City', 43.4711112976074, 0.758714021644154, -90.3561096191406, -1.57701161214692, 218, 57, 'PPL', 'P'),
(22082, 'Hub Junction', 33.5994415283203, 0.586420881500505, -83.7502822875977, -1.46171817539327, 218, 13, 'PPL', 'P'),
(109741, 'Hubball', 38.1988906860352, 0.666696413080709, -82.1880569458008, -1.43445219952082, 218, 58, 'PPL', 'P'),
(3261, 'Hubbard', 32.8988914489746, 0.574193976040815, -86.8180618286133, -1.51526102910931, 218, 2, 'PPL', 'P'),
(9602, 'Hubbard', 35.9052810668945, 0.626665373471292, -94.3197174072266, -1.64618961830671, 218, 4, 'PPL', 'P'),
(27476, 'Hubbard', 38.3286094665527, 0.668960432902413, -88.3600006103516, -1.54217293771483, 218, 18, 'PPL', 'P'),
(48323, 'Hubbard', 38.6066703796387, 0.673813511356864, -75.9036102294922, -1.32476791265509, 218, 25, 'PPL', 'P'),
(55402, 'Hubbard', 39.5825004577637, 0.690844959160139, -92.6927795410156, -1.61779419581596, 218, 29, 'PPL', 'P'),
(60342, 'Hubbard', 32.5074996948242, 0.567362901265735, -89.0124969482422, -1.55356114716823, 218, 30, 'PPL', 'P'),
(87999, 'Hubbard', 35.7577781677246, 0.62409096222454, -83.8833312988281, -1.46404031870576, 218, 50, 'PPL', 'P'),
(95023, 'Hubbard', 31.8483295440674, 0.55585821180416, -96.7969436645508, -1.68942537281388, 218, 51, 'PPL', 'P'),
(116095, 'Hubbard', 42.3055610656738, 0.738371332499529, -93.3000030517578, -1.62839224537393, 218, 16, 'PPL', 'P'),
(122840, 'Hubbard', 41.6963882446289, 0.727739261058633, -86.4188919067383, -1.50829419969766, 218, 19, 'PPL', 'P'),
(136027, 'Hubbard', 46.836669921875, 0.817454100806514, -95.0100021362305, -1.65823735960407, 218, 28, 'PPL', 'P'),
(142094, 'Hubbard', 42.3866691589355, 0.739786935776961, -96.5891723632813, -1.68579907951557, 218, 35, 'PPL', 'P'),
(143987, 'Hubbard', 42.8822212219238, 0.748435950891157, -71.2455596923828, -1.24346959405824, 218, 36, 'PPL', 'P'),
(155801, 'Hubbard', 41.1563911437988, 0.718314533697925, -80.5694427490234, -1.40620205246753, 218, 41, 'PPL', 'P'),
(201003, 'Hubbard', 45.1824989318848, 0.78858337064021, -122.806671142578, -2.14338075485189, 218, 43, 'PPL', 'P'),
(125115, 'Hubbard Corner', 42.0436096191406, 0.733799417277163, -72.6361083984375, -1.26773924738824, 218, 23, 'PPL', 'P'),
(172131, 'Hubbard Corner', 44.7463912963867, 0.780971856507682, -73.1133270263672, -1.27606828369746, 218, 55, 'PPL', 'P'),
(199415, 'Hubbard Corner', 41.8722190856934, 0.730808088161759, -103.812782287598, -1.81187485657463, 218, 35, 'PPL', 'P'),
(60343, 'Hubbard Creek', 34.1619415283203, 0.596238358542973, -89.8794403076172, -1.56869216321762, 218, 30, 'PPL', 'P'),
(149736, 'Hubbard Crossing', 44.0563888549805, 0.768929042058344, -75.6577835083008, -1.32047742698092, 218, 40, 'PPL', 'P'),
(102984, 'Hubbard Junction', 36.9905586242676, 0.645607040145453, -81.9722213745117, -1.4306851581589, 218, 53, 'PPL', 'P'),
(131385, 'Hubbard Lake', 44.8736114501953, 0.783192267066536, -83.5872192382813, -1.45887218829435, 218, 27, 'PPL', 'P'),
(3263, 'Hubbard Landing', 31.0625, 0.542142898900739, -87.8705596923828, -1.5336305822023, 218, 2, 'PPL', 'P'),
(102986, 'Hubbard Springs', 36.7227783203125, 0.640933392169446, -83.2205581665039, -1.45247274535295, 218, 53, 'PPL', 'P'),
(120081, 'Hubbard Woods', 42.1155586242676, 0.735055164310163, -87.7427825927734, -1.53140045110546, 218, 18, 'PPL', 'P'),
(88001, 'Hubbards Cove', 35.4819412231445, 0.619276699342976, -85.8649978637695, -1.49862692494068, 218, 50, 'PPL', 'P'),
(125114, 'Hubbardston', 42.4736099243164, 0.741304338387061, -72.0066680908203, -1.25675344157555, 218, 23, 'PPL', 'P'),
(131386, 'Hubbardston', 43.0922203063965, 0.752101126341378, -84.8422164916992, -1.48077602246998, 218, 27, 'PPL', 'P'),
(125116, 'Hubbardston Station', 42.4847183227539, 0.741498216514419, -71.9866714477539, -1.2564044343147, 218, 23, 'PPL', 'P'),
(109743, 'Hubbardstown', 38.1938896179199, 0.666609127975982, -82.5986099243164, -1.44161770074979, 218, 58, 'PPL', 'P'),
(22083, 'Hubbardsville', 34.3644409179688, 0.599772639625617, -84.2377777099609, -1.47022657560191, 218, 13, 'PPL', 'P'),
(149737, 'Hubbardsville', 42.8177795410156, 0.747311231383789, -75.4636077880859, -1.31708842133574, 218, 40, 'PPL', 'P'),
(172132, 'Hubbardton', 43.707218170166, 0.762834863956888, -73.1847229003906, -1.27731437677151, 218, 55, 'PPL', 'P'),
(149738, 'Hubbardtown', 42.2013893127441, 0.736553192423332, -76.3186111450195, -1.33201104502983, 218, 40, 'PPL', 'P'),
(30121, 'Hubbell', 39.1830596923828, 0.683873402637557, -87.0122222900391, -1.51864976843838, 218, 19, 'PPL', 'P'),
(131387, 'Hubbell', 47.1733283996582, 0.823329899698583, -88.4291687011719, -1.54338014863697, 218, 27, 'PPL', 'P'),
(142097, 'Hubbell', 40.0091705322266, 0.698291756779246, -97.4972229003906, -1.70164755116263, 218, 35, 'PPL', 'P'),
(149739, 'Hubbell Corners', 42.3005599975586, 0.738284047394802, -74.5550003051758, -1.30123022915069, 218, 40, 'PPL', 'P'),
(55403, 'Hubbells', 36.5675010681152, 0.638223292865154, -90.5572204589844, -1.58052165846365, 218, 29, 'PPL', 'P'),
(30122, 'Hubbells Corner', 39.2344398498535, 0.684770155555613, -85.0400009155273, -1.48422801187494, 218, 19, 'PPL', 'P'),
(3264, 'Hubbertville', 33.8277816772461, 0.590406168913754, -87.7399978637695, -1.53135184841557, 218, 2, 'PPL', 'P'),
(36515, 'Hubble', 37.5969390869141, 0.656190375738401, -84.6547164916992, -1.47750353012249, 218, 21, 'PPL', 'P'),
(174588, 'Hubbleton', 43.1936111450195, 0.753870730306709, -88.8819427490234, -1.55128254653956, 218, 57, 'PPL', 'P'),
(55405, 'Huben (historical)', 37.5872192382813, 0.656020732376963, -92.7513885498047, -1.61881711599066, 218, 29, 'PPL', 'P'),
(22084, 'Huber', 32.7041702270508, 0.570795449594738, -83.5563888549805, -1.4583340965961, 218, 13, 'PPL', 'P'),
(30123, 'Huber', 39.6861114501953, 0.69265331211933, -85.1391677856445, -1.48595880026739, 218, 19, 'PPL', 'P'),
(55406, 'Huber', 38.6883316040039, 0.675238768593247, -94.336669921875, -1.64648549550382, 218, 29, 'PPL', 'P'),
(95024, 'Huber', 31.8261108398438, 0.555470422259931, -94.320556640625, -1.64620426569271, 218, 51, 'PPL', 'P'),
(131388, 'Huber', 43.6119384765625, 0.761171919593216, -85.9991683959961, -1.50096864248718, 218, 27, 'PPL', 'P'),
(201004, 'Huber', 45.4919395446777, 0.793984128172836, -122.850280761719, -2.14414188629144, 218, 43, 'PPL', 'P'),
(72964, 'Huber Heights', 39.8438911437988, 0.695407087265499, -84.1247177124023, -1.46825330639221, 218, 41, 'PPL', 'P'),
(72966, 'Huber Mobile Home Park', 39.8213882446289, 0.69501433758374, -84.0886077880859, -1.46762306932025, 218, 41, 'PPL', 'P'),
(155803, 'Huber Ridge', 40.0886116027832, 0.699678265021768, -82.9166717529297, -1.447168926884, 218, 41, 'PPL', 'P'),
(22085, 'Hubert', 32.3063888549805, 0.56385285494901, -81.491943359375, -1.42230272546982, 218, 13, 'PPL', 'P'),
(65782, 'Hubert', 34.7136116027832, 0.605866817727073, -77.2455596923828, -1.3481893491779, 218, 33, 'PPL', 'P'),
(95025, 'Hubert', 27.9777793884277, 0.48830436772467, -97.7052764892578, -1.70527877130896, 218, 51, 'PPL', 'P'),
(182225, 'Hubert Place', 35.1688919067383, 0.61381295805057, -120.266387939453, -2.09904444902426, 218, 6, 'PPL', 'P'),
(174590, 'Hubertus', 43.2366714477539, 0.754622274366329, -88.2211074829102, -1.53974879533259, 218, 57, 'PPL', 'P'),
(41426, 'Hubertville', 29.9272193908691, 0.522328514337358, -91.679443359375, -1.60010814301674, 218, 22, 'PPL', 'P'),
(88000, 'Hubertville', 36.5555610656738, 0.638014900509855, -86.8002777099609, -1.51495063768426, 218, 50, 'PPL', 'P'),
(162886, 'Hublersburg', 40.9608306884766, 0.714901359865852, -77.6102828979492, -1.35455496997346, 218, 45, 'PPL', 'P'),
(120082, 'Hubly', 40.1355590820313, 0.700497653110158, -89.6588897705078, -1.56484283017802, 218, 18, 'PPL', 'P'),
(95026, 'Huckabay', 32.3447189331055, 0.564521841014838, -98.2980575561523, -1.71562475266975, 218, 51, 'PPL', 'P'),
(55407, 'Huckaby', 37.7894401550293, 0.659550153190618, -93.2497177124023, -1.6275146006367, 218, 29, 'PPL', 'P'),
(3265, 'Huckaville', 31.079439163208, 0.542438543071251, -86.4161071777344, -1.50824559700777, 218, 2, 'PPL', 'P'),
(162885, 'Huckenberry', 40.9658317565918, 0.714988644970579, -78.1255569458008, -1.36354819865855, 218, 45, 'PPL', 'P'),
(48324, 'Huckleberry', 38.4155616760254, 0.670478035249594, -76.9866714477539, -1.34367089691442, 218, 25, 'PPL', 'P'),
(88002, 'Huckleberry', 35.2602806091309, 0.615407991806445, -85.2111129760742, -1.48721448072136, 218, 50, 'PPL', 'P'),
(102985, 'Huckleberry (historical)', 37.2088890075684, 0.649417624191193, -82.440559387207, -1.43885919849268, 218, 53, 'PPL', 'P'),
(48325, 'Huckleberry Bottom', 39.6575012207031, 0.69215396941494, -77.0891723632813, -1.34545987537668, 218, 25, 'PPL', 'P'),
(125120, 'Huckleberry Corner', 41.8333282470703, 0.730129314978925, -70.7708282470703, -1.23518396727478, 218, 23, 'PPL', 'P'),
(113579, 'Huckleberry Hills Trails', 41.7972183227539, 0.729499077906958, -72.9038925170898, -1.27241296194327, 218, 8, 'PPL', 'P'),
(125118, 'Huckleberry Shores', 41.8236083984375, 0.729959671617487, -70.9499969482422, -1.23831105102676, 218, 23, 'PPL', 'P'),
(65783, 'Huckleberry Spring', 36.040828704834, 0.629031126046637, -78.9583282470703, -1.37808279978182, 218, 33, 'PPL', 'P'),
(196750, 'Huckleberry Trailer Court', 46.9550018310547, 0.81951938223187, -112.68083190918, -1.96665152070147, 218, 31, 'PPL', 'P'),
(48327, 'Huckleberry Woods', 38.8352813720703, 0.677803525881048, -76.5972213745117, -1.33687371086421, 218, 25, 'PPL', 'P'),
(76143, 'Hucmac', 36.0574989318848, 0.629322076395728, -98.7958297729492, -1.72431251677781, 218, 42, 'PPL', 'P'),
(16504, 'Hucomer', 28.9366703033447, 0.505040171357432, -80.8886108398438, -1.41177258651965, 218, 12, 'PPL', 'P'),
(191635, 'Hudd', 32.9263916015625, 0.574673944248275, -100.679443359375, -1.75718777569623, 218, 51, 'PPL', 'P'),
(102987, 'Huddle', 36.8486099243164, 0.64312956796238, -81.0363922119141, -1.41435185803539, 218, 53, 'PPL', 'P'),
(149740, 'Huddle', 43.122501373291, 0.752629630659705, -77.272216796875, -1.34865460342034, 218, 40, 'PPL', 'P'),
(88003, 'Huddle Mill', 36.5161094665527, 0.637326340210015, -82.4580612182617, -1.43916466306971, 218, 50, 'PPL', 'P'),
(9603, 'Huddleston', 34.586109161377, 0.603641480320203, -93.8452835083008, -1.63790918468738, 218, 4, 'PPL', 'P'),
(55408, 'Huddleston', 36.7275009155273, 0.641015817005184, -91.4247207641602, -1.59566239505102, 218, 29, 'PPL', 'P'),
(102988, 'Huddleston', 37.1566696166992, 0.648506223887141, -79.4747161865234, -1.38709546954287, 218, 53, 'PPL', 'P'),
(102989, 'Huddleston Court', 37.2822189331055, 0.650697472832058, -80.0430603027344, -1.39701494565508, 218, 53, 'PPL', 'P'),
(36516, 'Huddy', 37.5947189331055, 0.65615162674454, -82.2755584716797, -1.43597938924792, 218, 21, 'PPL', 'P'),
(27478, 'Hudgens', 37.6549987792969, 0.657203708533176, -88.9408264160156, -1.55231026040422, 218, 18, 'PPL', 'P'),
(36517, 'Hudgins', 37.3486099243164, 0.651856214222352, -85.6805572509766, -1.49540782897304, 218, 21, 'PPL', 'P'),
(102990, 'Hudgins', 37.4708290100098, 0.653989339676478, -76.3261108398438, -1.33214193939741, 218, 53, 'PPL', 'P'),
(182226, 'Hudner', 36.9000015258789, 0.644026520617519, -121.45027923584, -2.11970725013191, 218, 6, 'PPL', 'P'),
(30124, 'Hudnut', 39.6594390869141, 0.692187791560784, -87.3769378662109, -1.52501525607589, 218, 19, 'PPL', 'P'),
(16506, 'Hudson', 28.3641700744629, 0.495048157395023, -82.6936111450195, -1.44327578484447, 218, 12, 'PPL', 'P'),
(32809, 'Hudson', 38.1055603027344, 0.665067490599962, -98.6597213745117, -1.72193697708546, 218, 20, 'PPL', 'P'),
(36518, 'Hudson', 37.6511116027832, 0.657135864504406, -86.2766723632813, -1.50581200040366, 218, 21, 'PPL', 'P'),
(41427, 'Hudson', 32.0369415283203, 0.559150111938094, -92.5849990844727, -1.61591307197998, 218, 22, 'PPL', 'P'),
(48328, 'Hudson', 38.5919418334961, 0.673556449732644, -76.2547225952148, -1.33089597948141, 218, 25, 'PPL', 'P'),
(55409, 'Hudson', 38.2036094665527, 0.66677877133742, -94.0899963378906, -1.6421802292856, 218, 29, 'PPL', 'P'),
(65784, 'Hudson', 35.848331451416, 0.625671415173447, -81.4961090087891, -1.42237542976758, 218, 33, 'PPL', 'P'),
(88004, 'Hudson', 35.3311080932617, 0.616644164605433, -87.4008331298828, -1.5254323071026, 218, 50, 'PPL', 'P'),
(95028, 'Hudson', 29.9022197723389, 0.521892188682263, -95.5022201538086, -1.66682818464845, 218, 51, 'PPL', 'P'),
(109744, 'Hudson', 39.5988883972168, 0.691130982661213, -79.7013931274414, -1.39105172850023, 218, 58, 'PPL', 'P'),
(116096, 'Hudson', 42.4066696166992, 0.740136009616843, -92.4552764892578, -1.61364898557925, 218, 16, 'PPL', 'P'),
(120083, 'Hudson', 40.6058311462402, 0.708705449010755, -88.9872207641602, -1.55311999453366, 218, 18, 'PPL', 'P'),
(122841, 'Hudson', 41.5327796936035, 0.724883753158823, -85.0811080932617, -1.48494546747261, 218, 19, 'PPL', 'P'),
(125119, 'Hudson', 42.3916702270508, 0.739874220881688, -71.5666732788086, -1.24907408341426, 218, 23, 'PPL', 'P'),
(127785, 'Hudson', 45.0011100769043, 0.785417537894379, -68.8811111450195, -1.20220218191275, 218, 26, 'PPL', 'P'),
(131389, 'Hudson', 41.8549995422363, 0.730507550432743, -84.353889465332, -1.4722531080334, 218, 27, 'PPL', 'P'),
(143988, 'Hudson', 42.764720916748, 0.746385183693741, -71.4402770996094, -1.24686805392529, 218, 36, 'PPL', 'P'),
(149741, 'Hudson', 42.2527809143066, 0.737450145078471, -73.791389465332, -1.2879027057915, 218, 40, 'PPL', 'P'),
(155804, 'Hudson', 41.2400016784668, 0.719773812817234, -81.4408264160156, -1.42141056650465, 218, 41, 'PPL', 'P'),
(162888, 'Hudson', 41.2747192382813, 0.720379748544254, -75.8363876342773, -1.32359465703685, 218, 45, 'PPL', 'P'),
(170562, 'Hudson', 43.1302795410156, 0.752765385296271, -96.4538879394531, -1.68343792089311, 218, 49, 'PPL', 'P'),
(174591, 'Hudson', 44.9747200012207, 0.784956944183849, -92.7566680908203, -1.61890926136438, 218, 57, 'PPL', 'P'),
(188706, 'Hudson', 35.2641716003418, 0.615475902414242, -103.532501220703, -1.80698302912632, 218, 38, 'PPL', 'P'),
(194244, 'Hudson', 40.0736083984375, 0.699416409707586, -104.642501831055, -1.8263561944761, 218, 7, 'PPL', 'P'),
(209518, 'Hudson', 42.9061088562012, 0.748852868759809, -108.582778930664, -1.89512700330522, 218, 59, 'PPL', 'P'),
(140257, 'Hudson (historical)', 46.0941696166992, 0.804495025784134, -98.2547225952148, -1.71486841492017, 218, 34, 'PPL', 'P'),
(190324, 'Hudson (historical)', 38.8413887023926, 0.677910118903678, -119.272216796875, -2.08169288925795, 218, 39, 'PPL', 'P'),
(201005, 'Hudson (historical)', 46.0916709899902, 0.804451416521284, -123.016670227051, -2.14704593030212, 218, 43, 'PPL', 'P'),
(81654, 'Hudson Acres', 34.8638916015625, 0.608489698505665, -82.3397216796875, -1.4370992484863, 218, 48, 'PPL', 'P'),
(41428, 'Hudson Addition', 30.8430595397949, 0.538312940358068, -93.2874984741211, -1.6281739993226, 218, 22, 'PPL', 'P'),
(95029, 'Hudson Bend', 30.4169406890869, 0.530875763408399, -97.9288864135742, -1.70918150072841, 218, 51, 'PPL', 'P'),
(143989, 'Hudson Center', 42.771671295166, 0.746506490681394, -71.408332824707, -1.24631052115108, 218, 36, 'PPL', 'P'),
(95030, 'Hudson Chapel', 31.7313899993896, 0.553817231723751, -95.1527786254883, -1.66072927943605, 218, 51, 'PPL', 'P'),
(627, 'Hudson Corner', 38.0530586242676, 0.664151163447893, -75.7088928222656, -1.32136945278804, 218, 25, 'PPL', 'P'),
(48334, 'Hudson Creek', 38.5963897705078, 0.67363408087842, -76.2358322143555, -1.33056628013846, 218, 25, 'PPL', 'P'),
(14001, 'Hudson Crossroads', 38.4786109924316, 0.671578453412015, -75.1744384765625, -1.31204146475393, 218, 10, 'PPL', 'P'),
(102992, 'Hudson Crossroads', 38.7955589294434, 0.677110238470273, -78.7252807617188, -1.37401535384894, 218, 53, 'PPL', 'P'),
(149742, 'Hudson Falls', 43.3005599975586, 0.755737339914745, -73.5863876342773, -1.28432474886698, 218, 40, 'PPL', 'P'),
(3266, 'Hudson Gardens', 33.4272193908691, 0.58341503815716, -86.9358291625977, -1.51731645683863, 218, 2, 'PPL', 'P'),
(3267, 'Hudson Grove', 33.4311103820801, 0.583482948764957, -86.9308319091797, -1.51722923831293, 218, 2, 'PPL', 'P'),
(48330, 'Hudson Heights', 38.3916702270508, 0.670061050801915, -75.5702819824219, -1.31895023725381, 218, 25, 'PPL', 'P'),
(145475, 'Hudson Heights', 40.8069381713867, 0.712215428748452, -74.0041732788086, -1.29161648393162, 218, 37, 'PPL', 'P'),
(122842, 'Hudson Lake', 41.7102813720703, 0.727981741875885, -86.5341720581055, -1.51030621790122, 218, 19, 'PPL', 'P'),
(48331, 'Hudson Landing', 38.0833282470703, 0.664679468029137, -75.3513870239258, -1.31512979951204, 218, 25, 'PPL', 'P'),
(95031, 'Hudson Mast', 32.1877784729004, 0.561782713254664, -94.2622222900391, -1.64518613920797, 218, 51, 'PPL', 'P'),
(131390, 'Hudson Mills', 42.3872184753418, 0.739796523156885, -83.9169387817383, -1.46462687993585, 218, 27, 'PPL', 'P'),
(95032, 'Hudson Oaks', 32.7569389343262, 0.571716437278714, -97.7063903808594, -1.70529821238491, 218, 51, 'PPL', 'P'),
(13995, 'Hudson Pond Acres', 38.8416709899902, 0.677915045751695, -75.4402770996094, -1.31668122400506, 218, 10, 'PPL', 'P'),
(3268, 'Hudson Settlement', 33.8852806091309, 0.591409714591523, -87.2991714477539, -1.52365797602633, 218, 2, 'PPL', 'P'),
(88005, 'Hudsonburg (historical)', 36.1333312988281, 0.63064560087847, -85.1152801513672, -1.48554188239874, 218, 50, 'PPL', 'P'),
(162889, 'Hudsondale', 40.9166717529297, 0.714130641046383, -75.8555603027344, -1.32392928322782, 218, 45, 'PPL', 'P'),
(65786, 'Hudsons Crossroads', 35.5291709899902, 0.620101014279383, -77.2602767944336, -1.34844621106504, 218, 33, 'PPL', 'P'),
(81655, 'Hudsons Mill', 32.9238891601563, 0.574630268406397, -80.8052825927734, -1.41031823424836, 218, 48, 'PPL', 'P'),
(81656, 'Hudsontown', 33.2058296203613, 0.579551057731564, -80.5911102294922, -1.40658022134232, 218, 48, 'PPL', 'P'),
(30125, 'Hudsonville', 38.538890838623, 0.672630535200651, -87.0727767944336, -1.51970664391698, 218, 19, 'PPL', 'P'),
(60344, 'Hudsonville', 34.8611106872559, 0.608441162394798, -89.375, -1.55988801896993, 218, 30, 'PPL', 'P'),
(95033, 'Hudsonville', 33.7108306884766, 0.588364989096263, -96.0397186279297, -1.6762093027463, 218, 51, 'PPL', 'P'),
(131395, 'Hudsonville', 42.8708305358887, 0.748237145915782, -85.8649978637695, -1.49862692494068, 218, 27, 'PPL', 'P'),
(9606, 'Hudspeth', 33.436939239502, 0.583584681518598, -91.4524993896484, -1.59614722352747, 218, 4, 'PPL', 'P'),
(72968, 'Hue', 39.3869400024414, 0.687431785328066, -82.5052795410156, -1.43998877826904, 218, 41, 'PPL', 'P'),
(191637, 'Hueco Mountain Estates Number 1 Colonia', 31.9060001373291, 0.556864753538156, -106.091003417969, -1.85163731638811, 218, 51, 'PPL', 'P'),
(191638, 'Hueco Mountain Estates Number 2 Colonia', 31.9209995269775, 0.557126542273311, -106.070999145508, -1.8512881759692, 218, 51, 'PPL', 'P'),
(191639, 'Hueco Mountain Estates Number 3 Colonia', 31.9060001373291, 0.556864753538156, -106.073997497559, -1.85134050708462, 218, 51, 'PPL', 'P'),
(191640, 'Hueco Mountain Estates Number 4 Colonia', 31.9060001373291, 0.556864753538156, -106.057998657227, -1.85106127464433, 218, 51, 'PPL', 'P'),
(191641, 'Hueco Mountain Estates Number 5 Colonia', 31.8920001983643, 0.556620408508141, -106.060997009277, -1.85111360575975, 218, 51, 'PPL', 'P'),
(191642, 'Hueco Mountain Estates Number 6 Colonia', 31.9209995269775, 0.557126542273311, -106.05899810791, -1.85107871834947, 218, 51, 'PPL', 'P'),
(191643, 'Hueco Mountain Estates Number 7 Colonia', 31.9389991760254, 0.557440695413399, -106.018997192383, -1.8503805706697, 218, 51, 'PPL', 'P'),
(191644, 'Hueco Mountain Estates Number 8 Colonia', 31.9190006256104, 0.55709165486303, -106.079002380371, -1.85142785876838, 218, 51, 'PPL', 'P'),
(191645, 'Hueco Mountain Estates Number 9 Colonia', 31.8589992523193, 0.556044433343384, -106.061996459961, -1.85113104946489, 218, 51, 'PPL', 'P'),
(162890, 'Huefner', 41.3138885498047, 0.721063381996077, -79.3880615234375, -1.38558306035981, 218, 45, 'PPL', 'P'),
(27479, 'Huegely', 38.4055595397949, 0.67030346504014, -89.3183288574219, -1.55889892094108, 218, 18, 'PPL', 'P'),
(211568, 'Huehue', 19.7555599212646, 0.3447995662011, -155.975006103516, -2.7222774073246, 218, 15, 'PPL', 'P'),
(211569, 'Huelo', 20.9083309173584, 0.36491921560443, -156.227493286133, -2.72668413998035, 218, 15, 'PPL', 'P'),
(188707, 'Huerfano', 36.5269393920898, 0.637515358068384, -108.030830383301, -1.88549368385213, 218, 38, 'PPL', 'P'),
(81657, 'Huets Crossroads', 33.7727813720703, 0.589446232498835, -81.8872222900391, -1.42920164427367, 218, 48, 'PPL', 'P'),
(195117, 'Huetter', 47.7011108398438, 0.832541441014031, -116.850280761719, -2.03942213117178, 218, 17, 'PPL', 'P'),
(27480, 'Huey', 38.6044387817383, 0.673774562625922, -89.2911071777344, -1.55842381300261, 218, 18, 'PPL', 'P'),
(162891, 'Huey', 41.0808296203613, 0.716995736326117, -79.5083312988281, -1.38768216393101, 218, 45, 'PPL', 'P'),
(36519, 'Hueys Corners', 38.9461097717285, 0.6797378463598, -84.7174987792969, -1.47859928775301, 218, 21, 'PPL', 'P'),
(3269, 'Hueytown', 33.4511108398438, 0.583832022604839, -86.9966735839844, -1.5183783923233, 218, 2, 'PPL', 'P'),
(3270, 'Hueytown Crest', 33.461109161377, 0.584006526235267, -86.996940612793, -1.51838305285521, 218, 2, 'PPL', 'P'),
(36520, 'Huff', 37.2486114501953, 0.650110911601968, -86.3677825927734, -1.50740217389054, 218, 21, 'PPL', 'P'),
(55412, 'Huff', 38.2436103820801, 0.667476919017184, -90.8852767944336, -1.58624732164926, 218, 29, 'PPL', 'P'),
(112234, 'Huff', 35.6236114501953, 0.62174931125706, -91.605827331543, -1.59882330094884, 218, 4, 'PPL', 'P'),
(186873, 'Huff', 38.7569389343262, 0.676436192398374, -108.255561828613, -1.8894159875056, 218, 7, 'PPL', 'P'),
(198442, 'Huff', 46.6238899230957, 0.813740389245426, -100.651390075684, -1.75669815352982, 218, 34, 'PPL', 'P'),
(109745, 'Huff (historical)', 38.771671295166, 0.676693320601621, -80.0008316040039, -1.3962779158234, 218, 58, 'PPL', 'P'),
(204414, 'Huff Acres', 40.6594390869141, 0.709641084080727, -111.859718322754, -1.95232038508548, 218, 52, 'PPL', 'P'),
(127787, 'Huff Corner', 45.0752792358398, 0.786712033921239, -69.607780456543, -1.21488495397204, 218, 26, 'PPL', 'P'),
(95036, 'Huff Creek', 30.936939239502, 0.53995145021874, -93.8874969482422, -1.63864594820295, 218, 51, 'PPL', 'P'),
(109746, 'Huff Junction', 37.7294387817383, 0.658502931670971, -81.8677825927734, -1.4288623575508, 218, 58, 'PPL', 'P'),
(22086, 'Huffaker', 34.2799987792969, 0.598298846278367, -85.2436065673828, -1.48778160087549, 218, 13, 'PPL', 'P'),
(27481, 'Huffaker', 39.6747207641602, 0.692454507143955, -89.9563903808594, -1.57003519535535, 218, 18, 'PPL', 'P'),
(204417, 'Huffaker', 40.663330078125, 0.709708994688524, -111.861938476563, -1.95235913407935, 218, 52, 'PPL', 'P'),
(190323, 'Huffaker (historical)', 39.4597206115723, 0.688702046589006, -119.779998779297, -2.09055535673352, 218, 39, 'PPL', 'P'),
(22087, 'Huffer', 31.562780380249, 0.550874438719213, -82.7941665649414, -1.44503080800283, 218, 13, 'PPL', 'P'),
(72967, 'Huffeysville (historical)', 39.8180618286133, 0.694956280671976, -84.0744400024414, -1.46737579481303, 218, 41, 'PPL', 'P'),
(95034, 'Huffins', 32.9991683959961, 0.575944138930188, -94.1355590820313, -1.6429754491871, 218, 51, 'PPL', 'P'),
(3271, 'Huffman', 33.5991706848145, 0.58641615438957, -86.6930618286133, -1.51307936754432, 218, 2, 'PPL', 'P'),
(9608, 'Huffman', 35.973331451416, 0.62785307673844, -89.73388671875, -1.5661517738538, 218, 4, 'PPL', 'P'),
(30127, 'Huffman', 38.1019401550293, 0.6650043071031, -86.7769393920898, -1.51454330719553, 218, 19, 'PPL', 'P'),
(36521, 'Huffman', 37.3899993896484, 0.652578596668035, -86.2191696166992, -1.50480838814686, 218, 21, 'PPL', 'P'),
(88006, 'Huffman', 36.2791709899902, 0.63319098366934, -84.6533279418945, -1.47747929535657, 218, 50, 'PPL', 'P'),
(95035, 'Huffman', 30.0269393920898, 0.524068956688752, -95.085563659668, -1.65955615697588, 218, 51, 'PPL', 'P'),
(102993, 'Huffman', 37.3477783203125, 0.651841699994411, -80.4019393920898, -1.4032785673809, 218, 53, 'PPL', 'P'),
(109747, 'Huffman (historical)', 39.0680618286133, 0.681866311282018, -79.9175033569336, -1.39482356355211, 218, 58, 'PPL', 'P'),
(3272, 'Huffman Gardens', 33.603889465332, 0.586498512646281, -86.6750030517578, -1.51276418242931, 218, 2, 'PPL', 'P'),
(65787, 'Huffmantown', 34.9541702270508, 0.61006535776461, -77.5608291625977, -1.35369183946417, 218, 33, 'PPL', 'P'),
(27482, 'Huffmanville', 39.6469383239746, 0.691969612088479, -87.5572204589844, -1.52816178090382, 218, 18, 'PPL', 'P'),
(162892, 'Huffnagle', 40.3619384765625, 0.7044487189034, -74.966667175293, -1.30841517145562, 218, 45, 'PPL', 'P'),
(162894, 'Huffs Church', 40.4466705322266, 0.705927572256721, -75.6194381713867, -1.31980817459898, 218, 45, 'PPL', 'P'),
(162893, 'Huffs Corner', 41.8877792358398, 0.73107966401392, -76.6069412231445, -1.33704335422564, 218, 45, 'PPL', 'P'),
(170565, 'Huffton', 45.6163902282715, 0.796156202357905, -98.0927810668945, -1.71204200205527, 218, 49, 'PPL', 'P'),
(102994, 'Huffville', 37.0622215270996, 0.646857793751409, -80.2855606079102, -1.40124737441749, 218, 53, 'PPL', 'P'),
(95038, 'Hufsmith', 30.121940612793, 0.525727040783436, -95.5963897705078, -1.66847175451519, 218, 51, 'PPL', 'P'),
(81658, 'Huger', 33.0963897705078, 0.577640972018732, -79.8036117553711, -1.39283578011448, 218, 48, 'PPL', 'P'),
(81659, 'Hugers Settlement (historical)', 32.1105613708496, 0.56043502058503, -81.0899963378906, -1.41528742652634, 218, 48, 'PPL', 'P'),
(55413, 'Huggins', 37.3199996948242, 0.651356871517962, -92.1983337402344, -1.60916448861967, 218, 29, 'PPL', 'P'),
(95037, 'Huggins', 33.836109161377, 0.590551510930245, -98.0699996948242, -1.71164439210452, 218, 51, 'PPL', 'P'),
(41429, 'Huggins (historical)', 30.711669921875, 0.536019758922428, -90.0297164916992, -1.57131497741719, 218, 22, 'PPL', 'P'),
(81660, 'Huggins Crossroads', 33.6941719055176, 0.588074238484253, -79.3450012207031, -1.38483151630019, 218, 48, 'PPL', 'P'),
(16507, 'Hugh', 30.1655597686768, 0.526488338670548, -82.0330581665039, -1.43174696048552, 218, 12, 'PPL', 'P'),
(102995, 'Hugh', 37.0933303833008, 0.647400745718649, -82.559440612793, -1.44093406729796, 218, 53, 'PPL', 'P'),
(95039, 'Hugh Terry Colonia', 26.3729991912842, 0.460295669513711, -97.7819976806641, -1.70661780870505, 218, 51, 'PPL', 'P'),
(76154, 'Hughart', 35.2024993896484, 0.61439951928066, -95.2961120605469, -1.66323091980602, 218, 42, 'PPL', 'P'),
(109748, 'Hughart', 37.9019393920898, 0.661513635283306, -80.5513916015625, -1.40588700051057, 218, 58, 'PPL', 'P'),
(9609, 'Hughes', 34.9491691589355, 0.609978072659883, -90.4713897705078, -1.57902363035048, 218, 4, 'PPL', 'P'),
(27483, 'Hughes', 39.7744407653809, 0.694194949495349, -87.89111328125, -1.53398931000113, 218, 18, 'PPL', 'P'),
(41430, 'Hughes', 32.7877807617188, 0.572254728714047, -93.709716796875, -1.6355430992169, 218, 22, 'PPL', 'P'),
(65788, 'Hughes', 36.0597190856934, 0.629360825389588, -81.9644393920898, -1.43054933694331, 218, 33, 'PPL', 'P'),
(72969, 'Hughes', 39.3869400024414, 0.687431785328066, -84.4080581665039, -1.47319853022038, 218, 41, 'PPL', 'P'),
(76144, 'Hughes', 34.9491691589355, 0.609978072659883, -94.9716720581055, -1.65756837353824, 218, 42, 'PPL', 'P'),
(81661, 'Hughes', 33.1363906860352, 0.578339119698496, -81.0163879394531, -1.41400271761648, 218, 48, 'PPL', 'P'),
(95040, 'Hughes', 28.7513904571533, 0.501806428003803, -96.9711074829102, -1.69246510488209, 218, 51, 'PPL', 'P'),
(211882, 'Hughes', 66.0488891601563, 1.15277058312952, -154.255554199219, -2.69226731026493, 218, 1, 'PPL', 'P'),
(88007, 'Hughes (historical)', 35.3833312988281, 0.617555631488512, -85.2044372558594, -1.48709796742367, 218, 50, 'PPL', 'P'),
(102996, 'Hughes Corner', 37.6438903808594, 0.657009830405818, -77.288330078125, -1.34893583323145, 218, 53, 'PPL', 'P'),
(13996, 'Hughes Crossing', 39.202220916748, 0.684207829091443, -75.5713882446289, -1.31896954517171, 218, 10, 'PPL', 'P'),
(13997, 'Hughes Crossroads', 38.9711112976074, 0.680174205304409, -75.6972198486328, -1.32116572096465, 218, 10, 'PPL', 'P'),
(81663, 'Hughes Heights', 34.8686103820801, 0.608572056762375, -82.4413909912109, -1.43887371272062, 218, 48, 'PPL', 'P'),
(36522, 'Hughes Landing', 37.9647216796875, 0.662609392913819, -86.0299987792969, -1.50150673418543, 218, 21, 'PPL', 'P'),
(81662, 'Hughes Landing', 33.8894386291504, 0.591482285731228, -79.2622222900391, -1.38338675140882, 218, 48, 'PPL', 'P'),
(88011, 'Hughes Loop', 35.9555587768555, 0.627542885050473, -88.7733306884766, -1.54938690847564, 218, 50, 'PPL', 'P'),
(3273, 'Hughes Mill', 34.4188919067383, 0.600722988660612, -85.7838897705078, -1.49721132166324, 218, 2, 'PPL', 'P'),
(182230, 'Hughes Mill', 39.0911102294922, 0.682268581764675, -120.778610229492, -2.10798441448754, 218, 6, 'PPL', 'P'),
(162895, 'Hughes Park', 40.0858306884766, 0.699629728910901, -75.3480606079102, -1.31507174260027, 218, 45, 'PPL', 'P'),
(182231, 'Hughes Place', 39.7277793884277, 0.693380554834003, -121.401107788086, -2.11884904647063, 218, 6, 'PPL', 'P'),
(188708, 'Hughes Place', 34.6780586242676, 0.605246301193084, -107.780281066895, -1.88112077334222, 218, 38, 'PPL', 'P'),
(95041, 'Hughes Springs', 32.9983291625977, 0.575929491544192, -94.6305618286133, -1.65161487692137, 218, 51, 'PPL', 'P'),
(22088, 'Hughesboro (historical)', 34.4925003051758, 0.602007697570466, -83.6100006103516, -1.4592697982451, 218, 13, 'PPL', 'P'),
(169427, 'Hughesdale', 41.8080596923828, 0.729688295502408, -71.4941711425781, -1.2478086824223, 218, 47, 'PPL', 'P'),
(109749, 'Hugheston', 38.2094383239746, 0.666880504091061, -81.3727798461914, -1.42022292981653, 218, 58, 'PPL', 'P'),
(162896, 'Hughestown', 41.3269386291504, 0.721291148848306, -75.7736129760742, -1.32249903256439, 218, 45, 'PPL', 'P'),
(48332, 'Hughesville', 38.5325012207031, 0.672519015330004, -76.7841720581055, -1.34013661583177, 218, 25, 'PPL', 'P'),
(55414, 'Hughesville', 38.8386116027832, 0.677861649371839, -93.295280456543, -1.62830982053819, 218, 29, 'PPL', 'P'),
(102997, 'Hughesville', 39.0997200012207, 0.682418850629183, -77.6600036621094, -1.35542276101466, 218, 53, 'PPL', 'P'),
(145476, 'Hughesville', 40.621940612793, 0.70898661224284, -75.1561126708984, -1.31172161910701, 218, 37, 'PPL', 'P'),
(162898, 'Hughesville', 41.2411117553711, 0.719793187314164, -76.7241668701172, -1.3390893277331, 218, 45, 'PPL', 'P'),
(196751, 'Hughesville', 47.0833282470703, 0.821759100708627, -110.63166809082, -1.93088686515836, 218, 31, 'PPL', 'P'),
(48333, 'Hughesville Manor', 38.5227813720703, 0.672349371968566, -76.7802810668945, -1.34006870522397, 218, 25, 'PPL', 'P'),
(88008, 'Hughett', 36.3211097717285, 0.633922953494949, -84.5094375610352, -1.47496793444863, 218, 50, 'PPL', 'P'),
(88009, 'Hughey', 35.2080612182617, 0.614496591502393, -86.6927795410156, -1.5130744406963, 218, 50, 'PPL', 'P'),
(174595, 'Hughey', 45.2486114501953, 0.789737251761514, -90.6999969482422, -1.58301357829564, 218, 57, 'PPL', 'P'),
(22089, 'Hughland', 32.0449981689453, 0.55929072684365, -82.0550003051758, -1.43212992305027, 218, 13, 'PPL', 'P'),
(116097, 'Hughs', 42.3974990844727, 0.739975953635329, -93.1575012207031, -1.62590511923191, 218, 16, 'PPL', 'P'),
(162900, 'Hughs', 41.2405586242676, 0.719783533355212, -76.0652770996094, -1.32758953183003, 218, 45, 'PPL', 'P'),
(109750, 'Hughs Subdivision', 39.1561088562012, 0.683403021810021, -81.4569396972656, -1.42169179631576, 218, 58, 'PPL', 'P'),
(182232, 'Hughson', 37.5969390869141, 0.656190375738401, -120.86499786377, -2.10949216313869, 218, 6, 'PPL', 'P'),
(149744, 'Hughsonville', 41.5808296203613, 0.725722382586089, -73.9274978637695, -1.29027824548385, 218, 40, 'PPL', 'P'),
(3274, 'Hugley', 32.4319381713867, 0.566044103893927, -85.2461090087891, -1.48782527671737, 218, 2, 'PPL', 'P'),
(3275, 'Hugo', 32.2666702270508, 0.563159634117262, -87.6888885498047, -1.53045982260845, 218, 2, 'PPL', 'P'),
(27484, 'Hugo', 39.7538909912109, 0.693836288275543, -88.1488876342773, -1.53848832118865, 218, 18, 'PPL', 'P'),
(55416, 'Hugo', 37.9952812194824, 0.663142757501134, -92.6588897705078, -1.61720270773785, 218, 29, 'PPL', 'P'),
(60345, 'Hugo', 33.7869415283203, 0.589693373847994, -90.1500015258789, -1.5734143473045, 218, 30, 'PPL', 'P'),
(65789, 'Hugo', 35.3913917541504, 0.617696312973096, -77.5330581665039, -1.35320714414577, 218, 33, 'PPL', 'P'),
(76146, 'Hugo', 34.0105590820313, 0.593596236425506, -95.5094375610352, -1.66695415216801, 218, 42, 'PPL', 'P'),
(102998, 'Hugo', 36.5491714477539, 0.637903380639208, -77.2955627441406, -1.34906206706712, 218, 53, 'PPL', 'P'),
(109753, 'Hugo', 38.583610534668, 0.673411041137126, -81.8574981689453, -1.42868286049333, 218, 58, 'PPL', 'P'),
(136032, 'Hugo', 45.1599998474121, 0.788190687537478, -92.9930572509766, -1.62303503052513, 218, 28, 'PPL', 'P'),
(186874, 'Hugo', 39.1361083984375, 0.683053947970139, -103.469436645508, -1.80588234464779, 218, 7, 'PPL', 'P'),
(201006, 'Hugo', 42.5847206115723, 0.743243585713829, -123.401390075684, -2.15376055835853, 218, 43, 'PPL', 'P'),
(9612, 'Hugo (historical)', 34.396110534668, 0.600325378709863, -90.8274993896484, -1.58523891570251, 218, 4, 'PPL', 'P'),
(187723, 'Hugoton', 37.1752815246582, 0.648831062961103, -101.349166870117, -1.7688766560367, 218, 20, 'PPL', 'P'),
(102999, 'Huguenot', 37.5680618286133, 0.655686372502103, -77.7119369506836, -1.35632916789167, 218, 53, 'PPL', 'P'),
(149746, 'Huguenot', 40.5372200012207, 0.707507958626601, -74.1949996948242, -1.29494703319087, 218, 40, 'PPL', 'P'),
(22090, 'Huguenot (historical)', 33.9894409179688, 0.593227654930639, -82.6386108398438, -1.44231584842955, 218, 13, 'PPL', 'P'),
(103001, 'Huguenot Hills', 37.601390838623, 0.656268073463204, -77.6494369506836, -1.35523833710917, 218, 53, 'PPL', 'P'),
(177385, 'Huguenot Park', 40.922779083252, 0.714237234069013, -73.7947235107422, -1.28796089586132, 218, 40, 'PPL', 'P'),
(103002, 'Huguenot Springs', 37.5586090087891, 0.655521389672573, -77.7022171020508, -1.35615952453023, 218, 53, 'PPL', 'P'),
(3276, 'Huguley', 32.8344383239746, 0.573069056796366, -85.2297210693359, -1.48753925321629, 218, 2, 'PPL', 'P'),
(174596, 'Huilsburg', 43.3841705322266, 0.757196619034054, -88.460563659668, -1.54392809403125, 218, 57, 'PPL', 'P'),
(55417, 'Huiskamp', 39.8161087036133, 0.694922192210023, -91.440559387207, -1.59593883117217, 218, 29, 'PPL', 'P'),
(178396, 'Huk Ovi', 35.8916702270508, 0.626427819502057, -110.686943054199, -1.93185159526324, 218, 5, 'PPL', 'P'),
(3277, 'Hulaco', 34.3122215270996, 0.598861239321565, -86.5986099243164, -1.51143087082956, 218, 2, 'PPL', 'P'),
(76147, 'Hulah', 36.9286117553711, 0.644525863321908, -96.0350036621094, -1.67612701106862, 218, 42, 'PPL', 'P'),
(88010, 'Hulan Hollow', 36.1430587768555, 0.630815377397962, -82.4063873291016, -1.43826278356656, 218, 50, 'PPL', 'P'),
(16508, 'Hulaw', 30.7791690826416, 0.537197841520139, -85.5583267211914, -1.49327450378183, 218, 12, 'PPL', 'P'),
(9611, 'Hulbert', 35.1308288574219, 0.613148632516649, -90.1930618286133, -1.57416589136412, 218, 4, 'PPL', 'P'),
(76148, 'Hulbert', 35.9324989318848, 0.627140414830735, -95.14111328125, -1.66052568077072, 218, 42, 'PPL', 'P'),
(131398, 'Hulbert', 46.3541717529297, 0.809032919123575, -85.1500015258789, -1.48614788470478, 218, 27, 'PPL', 'P'),
(149747, 'Hulberton', 43.253059387207, 0.754908297867404, -78.0661087036133, -1.36251063109785, 218, 40, 'PPL', 'P'),
(182234, 'Hulburd Grove', 32.8619384765625, 0.573549025003825, -116.622222900391, -2.03544177060655, 218, 6, 'PPL', 'P'),
(3278, 'Huldah (historical)', 34.0750007629395, 0.594720955932873, -86.4686126708984, -1.50916199073887, 218, 2, 'PPL', 'P'),
(36523, 'Huldeville', 37.2669410705566, 0.650430823827914, -86.60888671875, -1.51161023472898, 218, 21, 'PPL', 'P'),
(76150, 'Hulen', 34.5038909912109, 0.602206502545841, -98.2211074829102, -1.71428172053202, 218, 42, 'PPL', 'P'),
(209519, 'Hulett', 44.6827812194824, 0.779861651228255, -104.601112365723, -1.82563381203042, 218, 59, 'PPL', 'P'),
(149748, 'Huletts Landing', 43.6391716003418, 0.761647227268767, -73.5074996948242, -1.28294789458341, 218, 40, 'PPL', 'P'),
(196752, 'Huletts Trailer Court', 45.8566703796387, 0.800349882126453, -111.331672668457, -1.94310424981716, 218, 31, 'PPL', 'P'),
(72970, 'Hulington', 38.9886093139648, 0.680479603302414, -84.1588897705078, -1.46884972131834, 218, 41, 'PPL', 'P'),
(3280, 'Hull', 33.774169921875, 0.589470467264755, -87.0588912963867, -1.51946429625778, 218, 2, 'PPL', 'P'),
(16509, 'Hull', 27.1188907623291, 0.473313933291318, -81.942497253418, -1.43016637437855, 218, 12, 'PPL', 'P'),
(22091, 'Hull', 34.014720916748, 0.593668874144237, -83.2938919067383, -1.45375266057284, 218, 13, 'PPL', 'P'),
(27485, 'Hull', 39.7069396972656, 0.693016833608126, -91.206672668457, -1.5918567378533, 218, 18, 'PPL', 'P'),
(72971, 'Hull', 39.2538909912109, 0.685109642015571, -81.9683303833008, -1.4306172475511, 218, 41, 'PPL', 'P'),
(95042, 'Hull', 30.146110534668, 0.526148885500104, -94.642219543457, -1.65181834242865, 218, 51, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(109751, 'Hull', 37.4866714477539, 0.654265842376655, -81.8438873291016, -1.42844530652409, 218, 58, 'PPL', 'P'),
(116098, 'Hull', 43.1886100769043, 0.753783445201981, -96.1333312988281, -1.67784315207507, 218, 16, 'PPL', 'P'),
(125123, 'Hull', 42.3019409179688, 0.738308149002667, -70.908332824707, -1.23758387489111, 218, 23, 'PPL', 'P'),
(136034, 'Hull', 47.1974983215332, 0.823751744415252, -92.9230575561523, -1.62181330537505, 218, 28, 'PPL', 'P'),
(198444, 'Hull', 46.0286102294922, 0.803350798621781, -100.124443054199, -1.74750119302134, 218, 34, 'PPL', 'P'),
(88012, 'Hull Mill', 36.2158317565918, 0.632085505500849, -82.9333267211914, -1.44745961091698, 218, 50, 'PPL', 'P'),
(155806, 'Hull Prairie', 41.4736099243164, 0.723851045867118, -83.6969375610352, -1.46078713427618, 218, 41, 'PPL', 'P'),
(191646, 'Hulldale', 31.021390914917, 0.541425410013558, -100.543060302734, -1.75480744231392, 218, 51, 'PPL', 'P'),
(127788, 'Hulls Cove', 44.4191703796387, 0.775260774129034, -68.251106262207, -1.19120652240403, 218, 26, 'PPL', 'P'),
(155808, 'Hulls Crossing', 41.5377807617188, 0.72497103826355, -83.6927795410156, -1.46071456313647, 218, 41, 'PPL', 'P'),
(174600, 'Hulls Crossing', 43.8158302307129, 0.764730502020807, -88.1113891601563, -1.53783384935077, 218, 57, 'PPL', 'P'),
(65792, 'Hulls Crossroads', 35.5086097717285, 0.619742153322495, -81.4574966430664, -1.42170151685374, 218, 33, 'PPL', 'P'),
(81666, 'Hulls Island', 34.0263900756836, 0.593872539388601, -78.7891693115234, -1.37513041939736, 218, 48, 'PPL', 'P'),
(149749, 'Hullsville', 42.1563911437988, 0.735767826217868, -76.1691665649414, -1.32940274505821, 218, 40, 'PPL', 'P'),
(201007, 'Hullt (historical)', 44.8972206115723, 0.783604324666198, -122.638893127441, -2.1404524760753, 218, 43, 'PPL', 'P'),
(162901, 'Hulltown', 40.042781829834, 0.698878384588363, -79.6477813720703, -1.39011602685123, 218, 45, 'PPL', 'P'),
(162902, 'Hulmeville', 40.1430587768555, 0.700628547477736, -74.9113922119141, -1.30745044135074, 218, 45, 'PPL', 'P'),
(162903, 'Hulmeville Terrace', 40.1399993896484, 0.700575151097879, -74.9011077880859, -1.30727094429327, 218, 45, 'PPL', 'P'),
(149750, 'Hulse Landing', 40.9672203063965, 0.715012879736499, -72.8116683959961, -1.27080334738043, 218, 40, 'PPL', 'P'),
(55418, 'Hulsey', 38.1802787780762, 0.666371574006747, -91.0366668701172, -1.58888957692479, 218, 29, 'PPL', 'P'),
(55419, 'Hulston', 37.4544410705566, 0.653703316175403, -93.7324981689453, -1.63594070916765, 218, 29, 'PPL', 'P'),
(191647, 'Hulver', 34.5272216796875, 0.602613699876514, -100.515281677246, -1.75432261383747, 218, 51, 'PPL', 'P'),
(9613, 'Huma', 34.5347213745117, 0.602744594244091, -90.6730575561523, -1.58254339720518, 218, 4, 'PPL', 'P'),
(55420, 'Humansville', 37.7944412231445, 0.659637438295345, -93.5777816772461, -1.63324039698037, 218, 29, 'PPL', 'P'),
(125122, 'Humarock', 42.1361083984375, 0.735413825529969, -70.690559387207, -1.23378301138335, 218, 23, 'PPL', 'P'),
(149751, 'Humaston', 43.2611083984375, 0.755048779614905, -75.5961074829102, -1.31940097726831, 218, 40, 'PPL', 'P'),
(60346, 'Humber', 34.2805595397949, 0.598308633395373, -90.7033309936523, -1.58307176836545, 218, 30, 'PPL', 'P'),
(78491, 'Humbert', 39.8561096191406, 0.695620339889787, -79.315559387207, -1.38431765936786, 218, 45, 'PPL', 'P'),
(48335, 'Humbert Schoolhouse Estates', 39.711109161377, 0.693089604484912, -77.029167175293, -1.344412587278, 218, 25, 'PPL', 'P'),
(81664, 'Humbert Woods', 32.7433280944824, 0.571478883309479, -80.116943359375, -1.3983044482549, 218, 48, 'PPL', 'P'),
(95043, 'Humberto Y Saenz Colonia', 26.4069995880127, 0.460889088383608, -98.9960021972656, -1.72780618465383, 218, 51, 'PPL', 'P'),
(174601, 'Humbird', 44.5291709899902, 0.777180646958873, -90.8891677856445, -1.58631523225706, 218, 57, 'PPL', 'P'),
(36524, 'Humble', 37.0886116027832, 0.647318387461938, -85.0666732788086, -1.48469353243349, 218, 21, 'PPL', 'P'),
(95045, 'Humble', 33.0166702270508, 0.57624960350722, -95.3672180175781, -1.664471952874, 218, 51, 'PPL', 'P'),
(95046, 'Humble Camp', 29.5983295440674, 0.516588303634288, -95.1855621337891, -1.66130145959626, 218, 51, 'PPL', 'P'),
(188709, 'Humble City', 32.7949981689453, 0.572380696233607, -103.218612670898, -1.80150464044792, 218, 38, 'PPL', 'P'),
(95047, 'Humble Colorado Camp', 26.9692401885986, 0.470702038052223, -98.9061737060547, -1.7262383817201, 218, 51, 'PPL', 'P'),
(27486, 'Humboldt', 39.6041717529297, 0.691223194613957, -88.3188934326172, -1.54145548211717, 218, 18, 'PPL', 'P'),
(32810, 'Humboldt', 37.8105583190918, 0.659918734685485, -95.4366683959961, -1.66568409064415, 218, 20, 'PPL', 'P'),
(72972, 'Humboldt', 39.2772216796875, 0.685516839346245, -83.3138885498047, -1.4541016678337, 218, 41, 'PPL', 'P'),
(88013, 'Humboldt', 35.8197212219238, 0.625172072469057, -88.9158325195313, -1.55187403461767, 218, 50, 'PPL', 'P'),
(116099, 'Humboldt', 42.7208290100098, 0.74561912540618, -94.2149963378906, -1.64436189085059, 218, 16, 'PPL', 'P'),
(131399, 'Humboldt', 46.4955596923828, 0.811500604189642, -87.8869400024414, -1.53391647254532, 218, 27, 'PPL', 'P'),
(136035, 'Humboldt', 48.9211082458496, 0.853834412614623, -97.0930633544922, -1.69459363638334, 218, 28, 'PPL', 'P'),
(142100, 'Humboldt', 40.163890838623, 0.700992135545559, -95.9447174072266, -1.67455121865162, 218, 35, 'PPL', 'P'),
(162905, 'Humboldt', 40.9372215270996, 0.714489302266189, -76.0430603027344, -1.32720177557531, 218, 45, 'PPL', 'P'),
(170568, 'Humboldt', 43.6452789306641, 0.761753820291398, -97.0736083984375, -1.69425408334435, 218, 49, 'PPL', 'P'),
(174602, 'Humboldt', 44.5019416809082, 0.776705405862348, -87.8258285522461, -1.53284987652874, 218, 57, 'PPL', 'P'),
(178397, 'Humboldt', 34.5008316040039, 0.602153106165985, -112.236671447754, -1.95889945824242, 218, 5, 'PPL', 'P'),
(200000, 'Humboldt', 40.6030616760254, 0.70865711263697, -118.250831604004, -2.06386635471124, 218, 39, 'PPL', 'P'),
(201008, 'Humboldt Basin (historical)', 44.4263916015625, 0.775386808227622, -117.599998474121, -2.05250717371372, 218, 43, 'PPL', 'P'),
(200001, 'Humboldt City', 40.5844383239746, 0.708332073825926, -118.210830688477, -2.06316820703147, 218, 39, 'PPL', 'P'),
(193664, 'Humboldt Hill', 40.7261085510254, 0.71080468574001, -124.188606262207, -2.16750007273836, 218, 6, 'PPL', 'P'),
(200003, 'Humboldt House', 40.5999984741211, 0.708603649678087, -118.254173278809, -2.06392467793911, 218, 39, 'PPL', 'P'),
(131400, 'Humboldt Mine', 46.4838905334473, 0.811296938945278, -87.8977813720703, -1.53410569014077, 218, 27, 'PPL', 'P'),
(178398, 'Humbug', 34.0547218322754, 0.594367021824002, -112.32250213623, -1.96039748635559, 218, 5, 'PPL', 'P'),
(27488, 'Hume', 39.7966690063477, 0.694582905487147, -87.8686065673828, -1.53359649374034, 218, 18, 'PPL', 'P'),
(36525, 'Hume', 38.8438911437988, 0.677953794745556, -84.7236099243164, -1.47870594735467, 218, 21, 'PPL', 'P'),
(55421, 'Hume', 38.0900001525879, 0.664795914747801, -94.583610534668, -1.65079542225395, 218, 29, 'PPL', 'P'),
(95048, 'Hume', 31.9444408416748, 0.557535670395774, -95.3324966430664, -1.66386595056795, 218, 51, 'PPL', 'P'),
(103003, 'Hume', 38.8311080932617, 0.677730688425234, -77.059440612793, -1.34494095843827, 218, 53, 'PPL', 'P'),
(149752, 'Hume', 42.4727783203125, 0.74128982415912, -78.1366729736328, -1.36374220994396, 218, 40, 'PPL', 'P'),
(155807, 'Hume', 40.6630592346191, 0.709704267577589, -84.2008285522461, -1.46958169114394, 218, 41, 'PPL', 'P'),
(182237, 'Hume', 36.7849998474121, 0.642019362682953, -118.912780761719, -2.07541954699416, 218, 6, 'PPL', 'P'),
(182235, 'Hume (historical)', 39.4283294677734, 0.68815416777375, -121.648330688477, -2.12316390006878, 218, 6, 'PPL', 'P'),
(182236, 'Hume Station', 36.7944412231445, 0.642184145775402, -118.904167175293, -2.07526921155063, 218, 6, 'PPL', 'P'),
(116103, 'Humeston', 40.8588905334473, 0.713122168520597, -93.4972229003906, -1.63183438108286, 218, 16, 'PPL', 'P'),
(27489, 'Humm Wye', 37.4605598449707, 0.653810108935115, -88.4061126708984, -1.54297774499626, 218, 18, 'PPL', 'P'),
(36526, 'Hummel', 37.3963890075684, 0.652690116538682, -84.2855606079102, -1.47106054449727, 218, 21, 'PPL', 'P'),
(162906, 'Hummels Wharf', 40.8316688537598, 0.712647060582127, -76.8361129760742, -1.34104315586683, 218, 45, 'PPL', 'P'),
(162907, 'Hummelstown', 40.2652816772461, 0.702761739510889, -76.708610534668, -1.33881781845996, 218, 45, 'PPL', 'P'),
(169428, 'Hummocks, The', 41.6358299255371, 0.726682319001008, -71.2197189331055, -1.24301858772763, 218, 47, 'PPL', 'P'),
(9614, 'Humnoke', 34.541389465332, 0.602860974383728, -91.7569427490234, -1.6014607625344, 218, 4, 'PPL', 'P'),
(207695, 'Humorist', 46.1936111450195, 0.806230607866539, -118.925827026367, -2.07564724726736, 218, 56, 'PPL', 'P'),
(3281, 'Humoro', 33.6175003051758, 0.586736066615516, -86.7677764892578, -1.51438338437208, 218, 2, 'PPL', 'P'),
(9615, 'Humphrey', 34.4219398498535, 0.600776185303386, -91.7061080932617, -1.60057353041724, 218, 4, 'PPL', 'P'),
(65791, 'Humphrey', 34.7755584716797, 0.606947994550618, -77.3666687011719, -1.35030310013509, 218, 33, 'PPL', 'P'),
(109752, 'Humphrey', 39.1425018310547, 0.683165534419814, -81.7316665649414, -1.42648668470039, 218, 58, 'PPL', 'P'),
(131403, 'Humphrey', 44.4719390869141, 0.776181761813011, -86.0602798461914, -1.50203523850376, 218, 27, 'PPL', 'P'),
(142103, 'Humphrey', 41.6916694641113, 0.727656902801923, -97.4841690063477, -1.70141971773138, 218, 35, 'PPL', 'P'),
(149754, 'Humphrey', 42.2055587768555, 0.736625963300119, -78.539436340332, -1.37077175679928, 218, 40, 'PPL', 'P'),
(195118, 'Humphrey', 44.4883308410645, 0.776467851893113, -112.232780456543, -1.95883154763462, 218, 17, 'PPL', 'P'),
(207696, 'Humphrey', 47.2347183227539, 0.824401355984149, -121.712501525879, -2.12428389246521, 218, 56, 'PPL', 'P'),
(149755, 'Humphrey Center', 42.2333297729492, 0.737110658618513, -78.5263900756836, -1.37054405652608, 218, 40, 'PPL', 'P'),
(41432, 'Humphreys', 29.6086101531982, 0.516767734112732, -90.8566665649414, -1.58574797894487, 218, 22, 'PPL', 'P'),
(60347, 'Humphreys', 32.0802803039551, 0.559906516266703, -90.8408279418945, -1.58547154282372, 218, 30, 'PPL', 'P'),
(76153, 'Humphreys', 34.5558280944824, 0.603112976001876, -99.2369384765625, -1.73201131601506, 218, 42, 'PPL', 'P'),
(139224, 'Humphreys', 40.125560760498, 0.700323149479731, -93.3188934326172, -1.62872194471688, 218, 29, 'PPL', 'P'),
(162912, 'Humphreys', 40.246940612793, 0.702441627547862, -79.4780578613281, -1.38715379277074, 218, 45, 'PPL', 'P'),
(182238, 'Humphreys', 34.4102783203125, 0.600572653217077, -118.439720153809, -2.06716308182464, 218, 6, 'PPL', 'P'),
(162909, 'Humphreys Corner', 41.2466697692871, 0.71989019295687, -79.8099975585938, -1.3929472334061, 218, 45, 'PPL', 'P'),
(162910, 'Humphreysville', 41.5183296203613, 0.724631551803593, -75.725830078125, -1.32166506366904, 218, 45, 'PPL', 'P'),
(78492, 'Humphreyville', 39.9594383239746, 0.697423766000961, -75.8777770996094, -1.32431703948254, 218, 45, 'PPL', 'P'),
(22092, 'Humphries (historical)', 33.8791694641113, 0.591303054989866, -84.3208312988281, -1.47167613418324, 218, 13, 'PPL', 'P'),
(41433, 'Humphries (historical)', 30.1924991607666, 0.526958519761002, -90.9983291625977, -1.5882204577009, 218, 22, 'PPL', 'P'),
(81665, 'Humphriesville (historical)', 34.8033294677734, 0.607432689869012, -81.6155624389648, -1.42446028542695, 218, 48, 'PPL', 'P'),
(3282, 'Humpton', 34.5475006103516, 0.602967633985385, -86.3050003051758, -1.50630641626003, 218, 2, 'PPL', 'P'),
(207697, 'Humptulips', 47.2330589294434, 0.824372394107295, -123.958061218262, -2.16347630264736, 218, 56, 'PPL', 'P'),
(27490, 'Humrick', 39.9155616760254, 0.696657974029509, -87.5488891601563, -1.5280163723083, 218, 18, 'PPL', 'P'),
(155809, 'Hunchberger Corners', 40.2222213745117, 0.702010195451269, -84.7466735839844, -1.47910848415343, 218, 41, 'PPL', 'P'),
(41434, 'Hundley', 30.4408302307129, 0.531292714566565, -92.3661117553711, -1.61209276739626, 218, 22, 'PPL', 'P'),
(103004, 'Hundleys Corner', 37.6388893127441, 0.656922545301091, -77.3305587768555, -1.34967286306313, 218, 53, 'PPL', 'P'),
(109754, 'Hundred', 39.6836090087891, 0.692609636277453, -80.4591674804688, -1.40427738594773, 218, 58, 'PPL', 'P'),
(125124, 'Hundred Acre Lot', 42.0972213745117, 0.734735118926162, -71.6694412231445, -1.25086772240842, 218, 23, 'PPL', 'P'),
(3283, 'Hundred Oaks', 33.5944404602051, 0.586333596395778, -86.5069427490234, -1.50983097680469, 218, 2, 'PPL', 'P'),
(41436, 'Hungarian Settlement', 30.4672203063965, 0.531753308277094, -90.5772171020508, -1.5808706657245, 218, 22, 'PPL', 'P'),
(103005, 'Hungars Point', 37.4261093139648, 0.653208833740003, -75.9677810668945, -1.32588790505152, 218, 53, 'PPL', 'P'),
(113580, 'Hungary', 41.9766693115234, 0.732631088506945, -72.7794418334961, -1.27024088775821, 218, 8, 'PPL', 'P'),
(78493, 'Hungerford', 39.7563896179199, 0.693879897538393, -76.6780624389648, -1.33828465360973, 218, 45, 'PPL', 'P'),
(95049, 'Hungerford', 29.398889541626, 0.5131074189315, -96.0766677856445, -1.67685418720427, 218, 51, 'PPL', 'P'),
(149757, 'Hungerford Corners', 43.8505592346191, 0.765336637484909, -76.23388671875, -1.33053232483456, 218, 40, 'PPL', 'P'),
(48337, 'Hungerford Manor', 39.3672218322754, 0.6870876383362, -77.2388916015625, -1.34807296903826, 218, 25, 'PPL', 'P'),
(48336, 'Hungerford Towne', 39.0744400024414, 0.681977631415584, -77.148063659668, -1.34648772239939, 218, 25, 'PPL', 'P'),
(149758, 'Hungry Hill', 42.7891693115234, 0.746811888679399, -73.9527816772461, -1.29071953127648, 218, 40, 'PPL', 'P'),
(162911, 'Hungry Hollow', 40.6413917541504, 0.709326098702798, -79.567497253418, -1.38871480464369, 218, 45, 'PPL', 'P'),
(196754, 'Hungry Hollow (historical)', 48.2066688537598, 0.841365092916709, -109.446670532227, -1.91020475613281, 218, 31, 'PPL', 'P'),
(196753, 'Hungry Horse', 48.3858299255371, 0.844492043510625, -114.059997558594, -1.99072250221415, 218, 31, 'PPL', 'P'),
(162913, 'Hunker', 40.2041702270508, 0.701695143494312, -79.6208267211914, -1.38964557944467, 218, 45, 'PPL', 'P'),
(81667, 'Hunley Park', 32.892219543457, 0.574077529322151, -80.0763931274414, -1.39759671319521, 218, 48, 'PPL', 'P'),
(162915, 'Hunlock', 41.2094383239746, 0.719240381650891, -76.0822219848633, -1.32788527586908, 218, 45, 'PPL', 'P'),
(162921, 'Hunlock Creek', 41.2058296203613, 0.71917739789111, -76.0663909912109, -1.32760897290598, 218, 45, 'PPL', 'P'),
(162916, 'Hunlock Gardens', 41.2119407653809, 0.719284057492768, -76.0477828979492, -1.32728420041105, 218, 45, 'PPL', 'P'),
(32814, 'Hunnewell', 37.0050010681152, 0.645859108342629, -97.4044418334961, -1.70002821606181, 218, 20, 'PPL', 'P'),
(36528, 'Hunnewell', 38.413330078125, 0.670439086518652, -82.8455581665039, -1.44592776065797, 218, 21, 'PPL', 'P'),
(55422, 'Hunnewell', 39.6680603027344, 0.692338260162373, -91.8616714477539, -1.60328862314857, 218, 29, 'PPL', 'P'),
(88016, 'Hunnicutt Mill', 36.0511093139648, 0.629210556525081, -83.4622192382813, -1.45669052672936, 218, 50, 'PPL', 'P'),
(162918, 'Hunsecker', 40.0855598449707, 0.699625001799966, -76.2444381713867, -1.33071648242394, 218, 45, 'PPL', 'P'),
(9617, 'Hunt', 33.1780586242676, 0.579066362413169, -93.3555603027344, -1.62936190232683, 218, 4, 'PPL', 'P'),
(36527, 'Hunt', 37.9105606079102, 0.661664103884895, -84.1605606079102, -1.46887888293227, 218, 21, 'PPL', 'P'),
(41438, 'Hunt', 32.8438911437988, 0.573234039625896, -92.6575012207031, -1.61717847297193, 218, 22, 'PPL', 'P'),
(60349, 'Hunt', 33.4866714477539, 0.584452672296882, -91.041389465332, -1.58897200176052, 218, 30, 'PPL', 'P'),
(112585, 'Hunt', 30.0705604553223, 0.524830287865379, -99.3375015258789, -1.73376647233148, 218, 51, 'PPL', 'P'),
(149759, 'Hunt', 42.5469398498535, 0.742584187027926, -77.9944381713867, -1.36125974433384, 218, 40, 'PPL', 'P'),
(155810, 'Hunt', 40.3205604553223, 0.703726536194798, -82.4705581665039, -1.43938277596299, 218, 41, 'PPL', 'P'),
(178399, 'Hunt', 34.6100006103516, 0.604058464767882, -109.626937866211, -1.91335101464463, 218, 5, 'PPL', 'P'),
(195119, 'Hunt', 42.6783294677734, 0.744877368463566, -114.249168395996, -1.99402415617558, 218, 17, 'PPL', 'P'),
(22093, 'Hunt (historical)', 34.9686088562012, 0.610317359382759, -83.7525024414063, -1.46175692438713, 218, 13, 'PPL', 'P'),
(41437, 'Hunt (historical)', 32.2847213745117, 0.563474686074219, -92.8677825927734, -1.62084857527017, 218, 22, 'PPL', 'P'),
(48353, 'Hunt Chapel', 38.8474998474121, 0.678016778505336, -76.6277770996094, -1.33740700887249, 218, 25, 'PPL', 'P'),
(27491, 'Hunt City', 39.0511093139648, 0.681570434084911, -88.0233306884766, -1.53629693908568, 218, 18, 'PPL', 'P'),
(22094, 'Hunt Club', 34.0074996948242, 0.593542840045649, -84.6647186279297, -1.47767810033195, 218, 13, 'PPL', 'P'),
(48338, 'Hunt Club Acres', 39.5611114501953, 0.690471650554337, -77.3655624389648, -1.35028379221719, 218, 25, 'PPL', 'P'),
(48340, 'Hunt Club Estates', 39.2077789306641, 0.684304834734149, -76.7430572509766, -1.33941902707605, 218, 25, 'PPL', 'P'),
(120088, 'Hunt Corners', 42.2750015258789, 0.737837967912214, -89.4558334350586, -1.5612988285574, 218, 18, 'PPL', 'P'),
(48341, 'Hunt Country Estates', 39.2174987792969, 0.684474478095587, -76.7911071777344, -1.34025765650332, 218, 25, 'PPL', 'P'),
(48342, 'Hunt Crest', 39.6108283996582, 0.691339375016512, -76.5122222900391, -1.33539019697898, 218, 25, 'PPL', 'P'),
(95051, 'Hunt Crossing', 30.6902809143066, 0.535646450316627, -97.8125, -1.70715017460695, 218, 51, 'PPL', 'P'),
(48343, 'Hunt Cup Hill', 39.478328704834, 0.689026819083942, -76.7172164916992, -1.33896802074544, 218, 25, 'PPL', 'P'),
(149762, 'Hunt Hollow', 42.6511116027832, 0.744402327104123, -77.4772186279297, -1.35223256034486, 218, 40, 'PPL', 'P'),
(48346, 'Hunt Ridge', 39.6316719055176, 0.691703162821417, -76.8649978637695, -1.34154729226119, 218, 25, 'PPL', 'P'),
(48347, 'Hunt Valley', 39.4997215270996, 0.689400194268771, -76.6413879394531, -1.33764456284173, 218, 25, 'PPL', 'P'),
(48349, 'Hunt Valley Estates', 38.5913887023926, 0.673546795773693, -76.5427780151367, -1.33592349498727, 218, 25, 'PPL', 'P'),
(81669, 'Huntcliff', 34.105281829834, 0.5952494602512, -80.8902816772461, -1.41180174813359, 218, 48, 'PPL', 'P'),
(72973, 'Huntcrest Acres', 39.0811080932617, 0.68209401155522, -84.3363876342773, -1.47194764345637, 218, 41, 'PPL', 'P'),
(48350, 'Huntcrest Estates', 39.4083290100098, 0.687805093933868, -76.5736083984375, -1.33646158668552, 218, 25, 'PPL', 'P'),
(65794, 'Huntdale', 36.0263900756836, 0.628779124428488, -82.3177795410156, -1.43671628592155, 218, 33, 'PPL', 'P'),
(3284, 'Hunter', 32.3955612182617, 0.565409206290052, -86.3955612182617, -1.50788700236699, 218, 2, 'PPL', 'P'),
(9619, 'Hunter', 35.0527801513672, 0.611786425619074, -91.126106262207, -1.59045058879774, 218, 4, 'PPL', 'P'),
(16510, 'Hunter', 29.6063899993896, 0.516728985118871, -81.7633285522461, -1.42703929062658, 218, 12, 'PPL', 'P'),
(32813, 'Hunter', 39.2341690063477, 0.684765428444679, -98.3969421386719, -1.71735061421418, 218, 20, 'PPL', 'P'),
(36529, 'Hunter', 37.5061111450195, 0.654605129099531, -82.7563934326172, -1.44437154247498, 218, 21, 'PPL', 'P'),
(41439, 'Hunter', 31.8969402313232, 0.556706628348432, -93.8511123657227, -1.63801091744102, 218, 22, 'PPL', 'P'),
(55423, 'Hunter', 36.8905601501465, 0.64386173752507, -90.8488922119141, -1.58561229088733, 218, 29, 'PPL', 'P'),
(72975, 'Hunter', 39.4927787780762, 0.689279020439172, -84.2897186279297, -1.47113311563697, 218, 41, 'PPL', 'P'),
(76157, 'Hunter', 36.5636100769043, 0.638155382257357, -97.6608276367188, -1.70450299248341, 218, 42, 'PPL', 'P'),
(88018, 'Hunter', 36.3716697692871, 0.634805391922146, -82.1588897705078, -1.43394313627845, 218, 50, 'PPL', 'P'),
(95052, 'Hunter', 29.8069400787354, 0.52022924431859, -98.0233306884766, -1.71082986428512, 218, 51, 'PPL', 'P'),
(103007, 'Hunter', 38.7222213745117, 0.675830256671354, -77.0652770996094, -1.34504282434997, 218, 53, 'PPL', 'P'),
(120097, 'Hunter', 42.4288902282715, 0.740523832450586, -88.8708267211914, -1.55108853525415, 218, 18, 'PPL', 'P'),
(140261, 'Hunter', 47.190559387207, 0.82363063716468, -97.216667175293, -1.69675093002436, 218, 34, 'PPL', 'P'),
(149761, 'Hunter', 42.2136116027832, 0.736766511626648, -74.2191696166992, -1.29536887790754, 218, 40, 'PPL', 'P'),
(162920, 'Hunter', 40.7574996948242, 0.711352564555267, -76.7594375610352, -1.33970491741907, 218, 45, 'PPL', 'P'),
(200004, 'Hunter', 40.7527809143066, 0.711270206298556, -115.902496337891, -2.02288017237686, 218, 39, 'PPL', 'P'),
(204418, 'Hunter', 40.6969413757324, 0.710295622497641, -112.020561218262, -1.95512762319054, 218, 52, 'PPL', 'P'),
(3285, 'Hunter (historical)', 34.6411094665527, 0.604601416735122, -87.6125030517578, -1.52912664416675, 218, 2, 'PPL', 'P'),
(72976, 'Hunter (historical)', 39.8277816772461, 0.695125924033414, -81.6352767944336, -1.42480436583979, 218, 41, 'PPL', 'P'),
(190325, 'Hunter (historical)', 39.6436080932617, 0.691911488597688, -114.987777709961, -2.00691532059016, 218, 39, 'PPL', 'P'),
(122844, 'Hunter Corner', 40.1713905334473, 0.701123029913136, -87.2430572509766, -1.52267859853545, 218, 19, 'PPL', 'P'),
(201009, 'Hunter Creek', 42.3875007629395, 0.739801450004902, -124.41667175293, -2.17148056646165, 218, 43, 'PPL', 'P'),
(178400, 'Hunter Creek Ranch', 34.3041687011719, 0.598720690995036, -111.010559082031, -1.93749976046114, 218, 5, 'PPL', 'P'),
(55424, 'Hunter Crossing', 36.6786117553711, 0.640162540191923, -91.6672210693359, -1.59989482381343, 218, 29, 'PPL', 'P'),
(65797, 'Hunter Crossing', 35.3288917541504, 0.616605482190599, -82.5074996948242, -1.4400275272629, 218, 33, 'PPL', 'P'),
(103008, 'Hunter Estates', 38.7330589294434, 0.676019407687777, -77.1750030517578, -1.34695790348985, 218, 53, 'PPL', 'P'),
(81676, 'Hunter Fields', 33.7205581665039, 0.588534765615755, -78.9652786254883, -1.37820410676947, 218, 48, 'PPL', 'P'),
(48351, 'Hunter Green', 39.5969390869141, 0.691096960778288, -76.7652816772461, -1.33980691648882, 218, 25, 'PPL', 'P'),
(48352, 'Hunter Hill', 39.6811103820801, 0.692566027014602, -77.6855621337891, -1.35586884049725, 218, 25, 'PPL', 'P'),
(41440, 'Hunter Landing', 31.753059387207, 0.554195433888056, -91.5830612182617, -1.5984259573142, 218, 22, 'PPL', 'P'),
(65798, 'Hunter Meadows', 36.1883316040039, 0.631605537293389, -80.3569412231445, -1.40249320117543, 218, 33, 'PPL', 'P'),
(162922, 'Hunter Park', 40.871940612793, 0.713349935372826, -77.8525009155273, -1.35878247188785, 218, 45, 'PPL', 'P'),
(188710, 'Hunter Place', 32.8624992370605, 0.573558812120831, -104.738327026367, -1.82802865964067, 218, 38, 'PPL', 'P'),
(193665, 'Hunter Place', 40.1794395446777, 0.701263511660638, -124.014167785645, -2.16445554698018, 218, 6, 'PPL', 'P'),
(30128, 'Hunter Switch', 39.1736106872559, 0.683708486387053, -86.5736083984375, -1.51099451188495, 218, 19, 'PPL', 'P'),
(36530, 'Hunter Town', 38.0349998474121, 0.663835978332882, -84.6997222900391, -1.47828902948601, 218, 21, 'PPL', 'P'),
(60351, 'Hunter Town', 32.2861099243164, 0.563498920840139, -89.5911102294922, -1.56365985402181, 218, 30, 'PPL', 'P'),
(204424, 'Hunter Village Condominium', 40.684440612793, 0.710077443025337, -112.02693939209, -1.9552389433241, 218, 52, 'PPL', 'P'),
(182239, 'Hunter-Liggett', 36.0102806091309, 0.628497961196403, -121.237503051758, -2.11599360514985, 218, 6, 'PPL', 'P'),
(103009, 'Hunterdale', 36.7013893127441, 0.640560083563644, -76.9613876342773, -1.34322961112179, 218, 53, 'PPL', 'P'),
(72977, 'Hunterdon', 39.5102806091309, 0.689584485016204, -82.1216735839844, -1.43329359128858, 218, 41, 'PPL', 'P'),
(22095, 'Hunters', 32.6544418334961, 0.569927525395481, -81.5505599975586, -1.42332577880258, 218, 13, 'PPL', 'P'),
(36531, 'Hunters', 37.860279083252, 0.660786525726687, -85.501106262207, -1.49227581837305, 218, 21, 'PPL', 'P'),
(103010, 'Hunters', 37.940559387207, 0.662187681355205, -78.2458267211914, -1.36564730222975, 218, 53, 'PPL', 'P'),
(207698, 'Hunters', 48.1169395446777, 0.839799021037688, -118.200828552246, -2.06299363682202, 218, 56, 'PPL', 'P'),
(16511, 'Hunters Creek', 28.360279083252, 0.494980246787226, -81.4225006103516, -1.42109072085773, 218, 12, 'PPL', 'P'),
(81671, 'Hunters Creek', 33.0347213745117, 0.576564655464176, -80.2161102294922, -1.40003523664734, 218, 48, 'PPL', 'P'),
(131404, 'Hunters Creek', 42.9855613708496, 0.750239576739413, -83.2938919067383, -1.45375266057284, 218, 27, 'PPL', 'P'),
(95053, 'Hunters Creek Village', 29.7702808380127, 0.519589419866698, -95.4952774047852, -1.66670701081885, 218, 51, 'PPL', 'P'),
(22115, 'Hunters Crossroad', 32.959171295166, 0.575246057829451, -84.7605590820313, -1.47935083181263, 218, 13, 'PPL', 'P'),
(48354, 'Hunters Farms', 38.5611114501953, 0.673018358034394, -76.8375015258789, -1.34106739063275, 218, 25, 'PPL', 'P'),
(22098, 'Hunters Glen', 33.8152809143066, 0.590187989441449, -84.2027816772461, -1.4696157796059, 218, 13, 'PPL', 'P'),
(48355, 'Hunters Glen', 39.4605598449707, 0.688716693975002, -76.7874984741211, -1.34019467274354, 218, 25, 'PPL', 'P'),
(81672, 'Hunters Glen', 33.4919395446777, 0.584544617933517, -81.6944427490234, -1.42583700655247, 218, 48, 'PPL', 'P'),
(3286, 'Hunters Glen (historical)', 33.2938919067383, 0.581088034575676, -86.7847213745117, -1.51467912841113, 218, 2, 'PPL', 'P'),
(48356, 'Hunters Glen South', 39.4541702270508, 0.688605174104355, -76.8013916015625, -1.34043715356079, 218, 25, 'PPL', 'P'),
(103015, 'Hunters Green', 37.2413902282715, 0.64998487750338, -77.5369415283203, -1.35327492159551, 218, 53, 'PPL', 'P'),
(103011, 'Hunters Grove Estates', 38.6847190856934, 0.67517571825444, -77.4055633544922, -1.35098193989696, 218, 53, 'PPL', 'P'),
(103012, 'Hunters Hall', 38.017219543457, 0.663525653486861, -78.4227828979492, -1.36873577014591, 218, 53, 'PPL', 'P'),
(48357, 'Hunters Harbor', 39.0969390869141, 0.682370314518316, -76.4569396972656, -1.33442533371604, 218, 25, 'PPL', 'P'),
(48358, 'Hunters Hill', 39.4336090087891, 0.688246313147467, -76.6072235107422, -1.33704828107366, 218, 25, 'PPL', 'P'),
(88021, 'Hunters Hill', 36.0366706848145, 0.628958554906932, -86.914436340332, -1.5169430816538, 218, 50, 'PPL', 'P'),
(36533, 'Hunters Hollow', 38.077220916748, 0.664572875006507, -85.6922225952148, -1.49561142763838, 218, 21, 'PPL', 'P'),
(196755, 'Hunters Hot Springs', 45.7580604553223, 0.798628814271989, -110.255828857422, -1.92432723307739, 218, 31, 'PPL', 'P'),
(22099, 'Hunters Mill', 34.1180610656738, 0.595472499992494, -84.4372177124023, -1.4737074603047, 218, 13, 'PPL', 'P'),
(48359, 'Hunters Mill', 39.6222190856934, 0.691538179991886, -76.6177825927734, -1.33723257182109, 218, 25, 'PPL', 'P'),
(70969, 'Hunters Mill', 39.3236083984375, 0.686326440317629, -74.8608322143555, -1.30656800292354, 218, 37, 'PPL', 'P'),
(136039, 'Hunters Park', 46.8291702270508, 0.817323206438937, -92.0730590820313, -1.60697803336471, 218, 28, 'PPL', 'P'),
(88022, 'Hunters Point', 36.2972183227539, 0.63350596904727, -86.2633285522461, -1.50557910696633, 218, 50, 'PPL', 'P'),
(178401, 'Hunters Point', 35.547779083252, 0.620425786774318, -109.104438781738, -1.90423168528192, 218, 5, 'PPL', 'P'),
(22100, 'Hunters Ridge', 33.9005584716797, 0.591676363595667, -83.3177795410156, -1.45416957844149, 218, 13, 'PPL', 'P'),
(48362, 'Hunters Ridge', 39.0458297729492, 0.681478288711194, -76.1158294677734, -1.32847183709917, 218, 25, 'PPL', 'P'),
(88024, 'Hunters Ridge', 36.0377807617188, 0.628977929403862, -86.9263916015625, -1.51715174032521, 218, 50, 'PPL', 'P'),
(48364, 'Hunters Run', 39.4986114501953, 0.68938081977184, -76.3194427490234, -1.33202555925777, 218, 25, 'PPL', 'P'),
(162923, 'Hunters Run', 40.0719413757324, 0.699387314672677, -77.195556640625, -1.34731663128868, 218, 45, 'PPL', 'P'),
(103014, 'Hunters Square', 38.7305603027344, 0.675975798424927, -77.4638900756836, -1.35199993322364, 218, 53, 'PPL', 'P'),
(88025, 'Hunters Store', 36.2305603027344, 0.632342567125068, -86.5305633544922, -1.51024323414144, 218, 50, 'PPL', 'P'),
(36532, 'Hunters Trace', 38.172779083252, 0.666240679639169, -85.8258285522461, -1.49794329148885, 218, 21, 'PPL', 'P'),
(65802, 'Hunters Trace', 36.1619415283203, 0.63114494358286, -80.4072189331055, -1.40337071275461, 218, 33, 'PPL', 'P'),
(81674, 'Hunters Trail', 34.5555610656738, 0.603108315469969, -82.7425003051758, -1.44412906165773, 218, 48, 'PPL', 'P'),
(103018, 'Hunters Trail', 37.7163887023926, 0.658275164818742, -78.0597229003906, -1.36239917780623, 218, 53, 'PPL', 'P'),
(196756, 'Hunters Trailer Court', 46.1286087036133, 0.805096101242165, -112.941390991211, -1.97119913457889, 218, 31, 'PPL', 'P'),
(103016, 'Hunters Valley', 39.1824989318848, 0.683863615520551, -78.4230575561523, -1.36874056383588, 218, 53, 'PPL', 'P'),
(81675, 'Hunters Woods', 34.7166709899902, 0.605920214106929, -82.2666702270508, -1.43582426011443, 218, 48, 'PPL', 'P'),
(103017, 'Hunters Woods', 37.6375007629395, 0.656898310535171, -77.8050003051758, -1.35795342984051, 218, 53, 'PPL', 'P'),
(204428, 'Hunters Woods Condo', 40.6650009155273, 0.709738156302461, -111.904998779297, -1.95311067813897, 218, 52, 'PPL', 'P'),
(149764, 'Huntersland', 42.5708312988281, 0.743001171475605, -74.2600021362305, -1.29608153981524, 218, 40, 'PPL', 'P'),
(78503, 'Hunterstown', 39.8822212219238, 0.696076073331327, -77.1605606079102, -1.34670583529267, 218, 45, 'PPL', 'P'),
(30129, 'Huntersville', 39.3036117553711, 0.685977433056774, -85.2330627441406, -1.48759757644417, 218, 19, 'PPL', 'P'),
(36534, 'Huntersville', 36.6247215270996, 0.639221978273934, -85.1355590820313, -1.48589581650761, 218, 21, 'PPL', 'P'),
(48365, 'Huntersville', 38.4691696166992, 0.671413670319566, -76.7305603027344, -1.33920091418277, 218, 25, 'PPL', 'P'),
(65803, 'Huntersville', 35.4105606079102, 0.618030872585037, -80.8430633544922, -1.41097763293426, 218, 33, 'PPL', 'P'),
(88026, 'Huntersville', 35.6152801513672, 0.621603902661542, -88.9822235107422, -1.55303277600796, 218, 50, 'PPL', 'P'),
(103020, 'Huntersville', 36.8741683959961, 0.643575647444968, -76.4316711425781, -1.33398431423952, 218, 53, 'PPL', 'P'),
(109757, 'Huntersville', 38.1886100769043, 0.666516982602265, -80.0163879394531, -1.39654942509654, 218, 58, 'PPL', 'P'),
(136040, 'Huntersville', 46.7758293151855, 0.816392231900872, -94.8925018310547, -1.65618659240665, 218, 28, 'PPL', 'P'),
(155811, 'Huntersville', 40.7177810668945, 0.710659343723519, -83.7675018310547, -1.46201871312228, 218, 41, 'PPL', 'P'),
(162924, 'Huntersville', 41.3133316040039, 0.721053661458098, -76.7624969482422, -1.33975831379893, 218, 45, 'PPL', 'P'),
(149765, 'Huntersville (historical)', 41.2374992370605, 0.719730136975356, -73.8372192382813, -1.28870258622491, 218, 40, 'PPL', 'P'),
(9620, 'Hunterton (historical)', 35.0208282470703, 0.611228759686811, -91.5438919067383, -1.59774232386237, 218, 4, 'PPL', 'P'),
(122845, 'Huntertown', 41.228328704834, 0.719570080993842, -85.1725006103516, -1.48654056780751, 218, 19, 'PPL', 'P'),
(55425, 'Hunterville', 36.8205604553223, 0.642640012374996, -89.807502746582, -1.56743661592171, 218, 29, 'PPL', 'P'),
(48366, 'Huntfield', 39.4674987792969, 0.688837801225573, -77.0305633544922, -1.34443695520198, 218, 25, 'PPL', 'P'),
(170571, 'Huntimer', 43.834171295166, 0.765050613983834, -96.9297180175781, -1.69174272243641, 218, 49, 'PPL', 'P'),
(177421, 'Hunting', 44.6833305358887, 0.77987123860818, -88.9713897705078, -1.55284369157056, 218, 57, 'PPL', 'P'),
(22102, 'Hunting Creek', 33.9938888549805, 0.593305286076414, -84.0416717529297, -1.46680388096894, 218, 13, 'PPL', 'P'),
(65804, 'Hunting Creek (historical)', 36.1063919067383, 0.630175419788016, -81.0730590820313, -1.41499181564534, 218, 33, 'PPL', 'P'),
(48367, 'Hunting Creek Acres', 39.6097183227539, 0.691320000519582, -77.477783203125, -1.35224241404089, 218, 25, 'PPL', 'P'),
(48368, 'Hunting Creek Farms', 38.5802803039551, 0.673352917646335, -76.5944366455078, -1.33682510817431, 218, 25, 'PPL', 'P'),
(88027, 'Hunting Creek Farms', 35.9597206115723, 0.627615522769205, -86.9561080932617, -1.51767039094751, 218, 50, 'PPL', 'P'),
(103021, 'Hunting Creek Hills', 37.3969383239746, 0.652699703918607, -77.4913864135742, -1.35247983485207, 218, 53, 'PPL', 'P'),
(48369, 'Hunting Creek Woods', 38.6163902282715, 0.673983154718302, -76.6247177124023, -1.33735361249264, 218, 25, 'PPL', 'P'),
(48370, 'Hunting Hill', 39.0969390869141, 0.682370314518316, -77.2072219848633, -1.34752022995402, 218, 25, 'PPL', 'P'),
(13998, 'Hunting Hills', 39.6777801513672, 0.692507903523812, -75.7847213745117, -1.32269291069175, 218, 10, 'PPL', 'P'),
(48372, 'Hunting Hills', 39.3752784729004, 0.687228253241757, -77.3163909912109, -1.34942558855591, 218, 25, 'PPL', 'P'),
(103022, 'Hunting Hills', 37.2125015258789, 0.649480674530001, -79.9652786254883, -1.39565739928942, 218, 53, 'PPL', 'P'),
(109756, 'Hunting Hills', 39.686939239502, 0.692667759768243, -80.3261108398438, -1.40195510947718, 218, 58, 'PPL', 'P'),
(88035, 'Hunting Hills West', 35.9594383239746, 0.627610595921188, -84.059440612793, -1.46711400607788, 218, 50, 'PPL', 'P'),
(48373, 'Hunting Lake', 38.5947189331055, 0.673604919264484, -76.6311111450195, -1.33746519894231, 218, 25, 'PPL', 'P'),
(48374, 'Hunting Lodge', 39.4191703796387, 0.687994311529318, -76.5252838134766, -1.33561816356829, 218, 25, 'PPL', 'P'),
(48375, 'Hunting Neck Woods', 38.2366714477539, 0.667355811766613, -76.4555587768555, -1.33440123210818, 218, 25, 'PPL', 'P'),
(162925, 'Hunting Park', 40.0163917541504, 0.698417790877834, -75.144172668457, -1.31151322675171, 218, 45, 'PPL', 'P'),
(48378, 'Hunting Ridge', 39.5374984741211, 0.690059526375647, -76.482780456543, -1.33487634004665, 218, 25, 'PPL', 'P'),
(113581, 'Hunting Ridge', 41.1238899230957, 0.717747280385738, -73.5725021362305, -1.28408240120778, 218, 8, 'PPL', 'P'),
(155812, 'Hunting Valley', 41.4891700744629, 0.724122621719278, -81.4019393920898, -1.42073185990084, 218, 41, 'PPL', 'P'),
(30130, 'Huntingburg', 38.2988891601563, 0.668441715701092, -86.9550018310547, -1.5176510830296, 218, 19, 'PPL', 'P'),
(55426, 'Huntingdale', 38.4766693115234, 0.671544564687144, -93.8169403076172, -1.6374145025149, 218, 29, 'PPL', 'P'),
(88028, 'Huntingdon', 36.000560760498, 0.628328317834965, -88.4280624389648, -1.54336084071906, 218, 50, 'PPL', 'P'),
(162926, 'Huntingdon', 40.4847183227539, 0.706591631474532, -78.0105590820313, -1.36154110730301, 218, 45, 'PPL', 'P'),
(88029, 'Huntingdon Forest', 35.1872215270996, 0.614132870276515, -85.1983337402344, -1.48699144098007, 218, 50, 'PPL', 'P'),
(162928, 'Huntingdon Furnace', 40.6569404602051, 0.709597474817877, -78.1141662597656, -1.36334939368317, 218, 45, 'PPL', 'P'),
(88030, 'Huntingdon Place', 36.1094398498535, 0.630228616430791, -83.8822174072266, -1.4640208776298, 218, 50, 'PPL', 'P'),
(162929, 'Huntingdon Valley', 40.122501373291, 0.700269753099875, -75.0638885498047, -1.31011200454416, 218, 45, 'PPL', 'P'),
(48379, 'Huntingfields Manor', 38.584171295166, 0.673420828254132, -76.6252822875977, -1.33736346618867, 218, 25, 'PPL', 'P'),
(9621, 'Huntington', 35.082218170166, 0.612300215972377, -94.2630615234375, -1.64520078659397, 218, 4, 'PPL', 'P'),
(16513, 'Huntington', 29.4402809143066, 0.513829834666697, -81.5527801513672, -1.42336452779644, 218, 12, 'PPL', 'P'),
(22106, 'Huntington', 33.0222206115723, 0.576346475991872, -85.1288909912109, -1.48577943636797, 218, 13, 'PPL', 'P'),
(48386, 'Huntington', 38.3869400024414, 0.669978492808123, -75.1613922119141, -1.31181376448072, 218, 25, 'PPL', 'P'),
(55427, 'Huntington', 39.6613883972168, 0.69222181344371, -91.5986099243164, -1.59869733342928, 218, 29, 'PPL', 'P'),
(81692, 'Huntington', 33.8994407653809, 0.591656855940683, -80.3680572509766, -1.40268721246084, 218, 48, 'PPL', 'P'),
(95054, 'Huntington', 31.2775001525879, 0.545895359455688, -94.5763931274414, -1.65066945473439, 218, 51, 'PPL', 'P'),
(103025, 'Huntington', 36.8319396972656, 0.642838617613289, -76.1697235107422, -1.32941246559619, 218, 53, 'PPL', 'P'),
(109758, 'Huntington', 38.4191703796387, 0.670541019009375, -82.4452819824219, -1.43894162332842, 218, 58, 'PPL', 'P'),
(112981, 'Huntington', 41.2963905334473, 0.720757983998072, -73.1466674804688, -1.27665018439564, 218, 8, 'PPL', 'P'),
(116105, 'Huntington', 43.4916687011719, 0.759072816022015, -94.7916717529297, -1.65442677555833, 218, 16, 'PPL', 'P'),
(122846, 'Huntington', 40.8830604553223, 0.713544013237266, -85.4974975585938, -1.49221283461327, 218, 19, 'PPL', 'P'),
(125125, 'Huntington', 42.2361106872559, 0.73715919472938, -72.8763885498047, -1.27193292715679, 218, 23, 'PPL', 'P'),
(149766, 'Huntington', 40.8680610656738, 0.713282224502111, -73.4261093139648, -1.28152736445796, 218, 40, 'PPL', 'P'),
(155814, 'Huntington', 41.1030616760254, 0.717383758896942, -82.2211074829102, -1.43502904021293, 218, 41, 'PPL', 'P'),
(172135, 'Huntington', 44.3252792358398, 0.773622064531281, -72.9877777099609, -1.27387703475255, 218, 55, 'PPL', 'P'),
(174610, 'Huntington', 45.1919403076172, 0.788748153732659, -92.5586090087891, -1.61545247826945, 218, 57, 'PPL', 'P'),
(192629, 'Huntington', 39.3266716003418, 0.686379903276512, -110.963890075684, -1.93668523264174, 218, 52, 'PPL', 'P'),
(201010, 'Huntington', 44.351390838623, 0.774077797972821, -117.265556335449, -2.04667005723649, 218, 43, 'PPL', 'P'),
(48387, 'Huntington (historical)', 38.5763893127441, 0.673285007038538, -76.6083297729492, -1.33706758899156, 218, 25, 'PPL', 'P'),
(81677, 'Huntington (historical)', 34.5366706848145, 0.602778616127017, -81.7958297729492, -1.42760654393877, 218, 48, 'PPL', 'P'),
(200005, 'Huntington (historical)', 40.2763900756836, 0.702955617638247, -115.675003051758, -2.01890966550766, 218, 39, 'PPL', 'P'),
(81680, 'Huntington Acres', 34.8416709899902, 0.608101875671922, -82.3008270263672, -1.43642040872444, 218, 48, 'PPL', 'P'),
(149767, 'Huntington Bay', 40.8997192382813, 0.713834763849275, -73.415283203125, -1.28133841317862, 218, 40, 'PPL', 'P'),
(149768, 'Huntington Beach', 40.8977813720703, 0.713800941703431, -73.3838882446289, -1.28079046778434, 218, 40, 'PPL', 'P'),
(182240, 'Huntington Beach', 33.6602783203125, 0.58748268382712, -117.998329162598, -2.05945935573937, 218, 6, 'PPL', 'P'),
(172134, 'Huntington Center', 44.2969398498535, 0.773127448937826, -72.9680633544922, -1.27353295433971, 218, 55, 'PPL', 'P'),
(103026, 'Huntington Court', 37.3091697692871, 0.651167853659593, -79.9361114501953, -1.39514833604705, 218, 53, 'PPL', 'P'),
(22107, 'Huntington Creek', 33.4772186279297, 0.584287689467352, -84.4336090087891, -1.47364447654492, 218, 13, 'PPL', 'P'),
(81681, 'Huntington Downs', 34.8388900756836, 0.608053339561055, -82.2827835083008, -1.43610548992554, 218, 48, 'PPL', 'P'),
(48388, 'Huntington East', 39.1527786254883, 0.68334489831923, -76.8277816772461, -1.34089774727132, 218, 25, 'PPL', 'P'),
(81682, 'Huntington Estates', 33.5788917541504, 0.586062220280699, -81.961669921875, -1.43050100056952, 218, 48, 'PPL', 'P'),
(81683, 'Huntington Farms', 33.024169921875, 0.576380497874797, -80.216667175293, -1.40004495718532, 218, 48, 'PPL', 'P'),
(182242, 'Huntington Harbour', 33.7211112976074, 0.588544419574707, -118.063331604004, -2.06059386236375, 218, 6, 'PPL', 'P'),
(81684, 'Huntington Heights', 34.5097198486328, 0.602308235299482, -82.7863922119141, -1.44489511994529, 218, 48, 'PPL', 'P'),
(103027, 'Huntington Heights', 37.6902809143066, 0.65781949795623, -77.491943359375, -1.35248955539005, 218, 53, 'PPL', 'P'),
(81685, 'Huntington Hills', 34.9075012207031, 0.609250829945209, -81.8702774047852, -1.42890590023462, 218, 48, 'PPL', 'P'),
(182243, 'Huntington Lake', 37.2316703796387, 0.649815234141942, -119.235000610352, -2.08104334426808, 218, 6, 'PPL', 'P'),
(81687, 'Huntington Marsh', 33.523609161377, 0.585097357017763, -79.0652770996094, -1.37994940938986, 218, 48, 'PPL', 'P'),
(127789, 'Huntington Mill', 45.1066703796387, 0.787259912736495, -68.9302825927734, -1.20306038557403, 218, 26, 'PPL', 'P'),
(162934, 'Huntington Mills', 41.190559387207, 0.718910882045021, -76.23388671875, -1.33053232483456, 218, 45, 'PPL', 'P'),
(22108, 'Huntington Park', 33.9527816772461, 0.592587830478747, -83.4683303833008, -1.45679718633102, 218, 13, 'PPL', 'P'),
(41444, 'Huntington Park', 32.4902801513672, 0.567062363536719, -92.0569381713867, -1.60669667039555, 218, 22, 'PPL', 'P'),
(72981, 'Huntington Park', 38.6711082458496, 0.674938164285204, -83.7697219848633, -1.46205746211614, 218, 41, 'PPL', 'P'),
(182245, 'Huntington Park', 33.9816703796387, 0.593092033452126, -118.224166870117, -2.06340096731074, 218, 6, 'PPL', 'P'),
(22109, 'Huntington Place', 33.3680610656738, 0.582382530602536, -84.533332824707, -1.47538498547534, 218, 13, 'PPL', 'P'),
(22110, 'Huntington South', 33.4027786254883, 0.582988466329556, -84.4252777099609, -1.4734990679494, 218, 13, 'PPL', 'P'),
(48389, 'Huntington South', 39.0013885498047, 0.680702643043708, -76.7708282470703, -1.33990372239444, 218, 25, 'PPL', 'P'),
(149769, 'Huntington Station', 40.853328704834, 0.713025096298864, -73.4119415283203, -1.28128008995075, 218, 40, 'PPL', 'P'),
(48390, 'Huntington Terrace', 38.9958305358887, 0.680605637401002, -77.1144409179688, -1.34590089485319, 218, 25, 'PPL', 'P'),
(48391, 'Huntington Townhouses', 38.6061096191406, 0.673803724239858, -76.894172668457, -1.34205648866161, 218, 25, 'PPL', 'P'),
(103028, 'Huntington Village', 38.0491714477539, 0.664083319419123, -78.5194396972656, -1.37042274953842, 218, 53, 'PPL', 'P'),
(48392, 'Huntington Woods', 38.9941711425781, 0.680576675524147, -76.6361083984375, -1.33755241746801, 218, 25, 'PPL', 'P'),
(131405, 'Huntington Woods', 42.4805603027344, 0.741425645374714, -83.1669387817383, -1.45153691054589, 218, 27, 'PPL', 'P'),
(149771, 'Huntingtonville', 43.9761085510254, 0.767527886429826, -75.8622207641602, -1.3240455302094, 218, 40, 'PPL', 'P'),
(48393, 'Huntingtown', 38.6158294677734, 0.673973367601296, -76.6133270263672, -1.33715480751726, 218, 25, 'PPL', 'P'),
(113582, 'Huntingtown', 41.3580589294434, 0.721834300552628, -73.2858276367188, -1.2790789873098, 218, 8, 'PPL', 'P'),
(48394, 'Huntingtown Estates', 38.5872192382813, 0.673474024896906, -76.6011123657227, -1.336941621472, 218, 25, 'PPL', 'P'),
(48395, 'Huntingtown Farms', 38.6425018310547, 0.674438888159842, -76.6333312988281, -1.33750394793617, 218, 25, 'PPL', 'P'),
(48396, 'Huntingtown Meadows', 38.6230583190918, 0.674099534857939, -76.54638671875, -1.33598647874705, 218, 25, 'PPL', 'P'),
(48397, 'Huntingtown Square', 38.6175003051758, 0.674002529215232, -76.6211090087891, -1.33729062873286, 218, 25, 'PPL', 'P'),
(48398, 'Huntingtown Town Center', 38.6208305358887, 0.674060652706023, -76.6163864135742, -1.33720820389712, 218, 25, 'PPL', 'P'),
(88034, 'Huntland', 36.103328704834, 0.630121956829133, -85.5566711425781, -1.49324560848401, 218, 50, 'PPL', 'P'),
(55429, 'Huntleigh', 38.6158294677734, 0.673973367601296, -90.4105606079102, -1.57796196118192, 218, 29, 'PPL', 'P'),
(103029, 'Huntleigh', 37.7075004577637, 0.658120035685245, -77.8455581665039, -1.35866129805825, 218, 53, 'PPL', 'P'),
(13999, 'Huntley', 39.1369400024414, 0.68306846219808, -75.5202789306641, -1.31807751936459, 218, 10, 'PPL', 'P'),
(65808, 'Huntley', 35.0705604553223, 0.612096750465095, -78.5102767944336, -1.37026282671497, 218, 33, 'PPL', 'P'),
(120089, 'Huntley', 42.1680603027344, 0.735971491462232, -88.4280624389648, -1.54336084071906, 218, 18, 'PPL', 'P'),
(136042, 'Huntley', 43.7316703796387, 0.763261635521573, -94.2372207641602, -1.64474978026336, 218, 28, 'PPL', 'P'),
(142107, 'Huntley', 40.2099990844727, 0.701796876247953, -99.2919387817383, -1.73297125242998, 218, 35, 'PPL', 'P'),
(162933, 'Huntley', 41.2202796936035, 0.719429599246341, -78.3925018310547, -1.36820726582759, 218, 45, 'PPL', 'P'),
(182247, 'Huntley', 37.7586097717285, 0.659012061492367, -120.946113586426, -2.11090789957418, 218, 6, 'PPL', 'P'),
(196757, 'Huntley', 45.8994407653809, 0.801096366180002, -108.300827026367, -1.89020601424297, 218, 31, 'PPL', 'P'),
(207699, 'Huntley', 47.1186103820801, 0.822374890131681, -117.53971862793, -2.05145509192508, 218, 56, 'PPL', 'P'),
(209520, 'Huntley', 41.9327812194824, 0.731865096798411, -104.145561218262, -1.81768294459598, 218, 59, 'PPL', 'P'),
(60354, 'Huntley (historical)', 31.7763900756836, 0.554602631218729, -91.1805572509766, -1.59140093783273, 218, 30, 'PPL', 'P'),
(14000, 'Huntley Circle', 39.1366691589355, 0.683063735087145, -75.5219421386719, -1.31810654782047, 218, 10, 'PPL', 'P'),
(48399, 'Huntley Estates', 38.4444389343262, 0.670982038485892, -76.9241714477539, -1.34258006613192, 218, 25, 'PPL', 'P'),
(22111, 'Huntley Hill', 33.9119415283203, 0.591875035412987, -84.3041687011719, -1.4713853169922, 218, 13, 'PPL', 'P'),
(41446, 'Huntley Place', 30.5472202301025, 0.533149570347109, -91.0347213745117, -1.58885562162089, 218, 22, 'PPL', 'P'),
(103030, 'Huntly', 38.8263893127441, 0.677648330168524, -78.1125030517578, -1.36332036522729, 218, 53, 'PPL', 'P'),
(149772, 'Huntly Corners', 42.8294410705566, 0.747514763470098, -75.1405563354492, -1.31145010983387, 218, 40, 'PPL', 'P'),
(103031, 'Hunton', 37.6883316040039, 0.657785476073304, -77.5, -1.35263017029561, 218, 53, 'PPL', 'P'),
(191648, 'Huntoon', 36.4558296203613, 0.63627425842138, -100.630561828613, -1.75633463204103, 218, 51, 'PPL', 'P'),
(103032, 'Huntridge', 37.3216705322266, 0.651386033131898, -79.8775024414063, -1.39412541587235, 218, 53, 'PPL', 'P'),
(48400, 'Huntridge North', 39.6369400024414, 0.691795108458052, -76.6786117553711, -1.33829424098965, 218, 25, 'PPL', 'P'),
(22112, 'Hunts', 33.3402786254883, 0.58189763554706, -83.4058303833008, -1.45570635554852, 218, 13, 'PPL', 'P'),
(65810, 'Hunts', 35.9922218322754, 0.628182776081392, -78.1252822875977, -1.36354340496859, 218, 33, 'PPL', 'P'),
(22113, 'Hunts Corner', 34.5299987792969, 0.602662169408353, -84.8455581665039, -1.48083434569786, 218, 13, 'PPL', 'P'),
(48401, 'Hunts Corner', 38.8016700744629, 0.677216898071931, -76.9991683959961, -1.34388900980769, 218, 25, 'PPL', 'P'),
(127790, 'Hunts Corner', 44.3019409179688, 0.773214734042554, -70.7497177124023, -1.23481551893797, 218, 26, 'PPL', 'P'),
(149773, 'Hunts Corner', 41.6025009155273, 0.726100618039907, -75.0377807617188, -1.30965633768165, 218, 40, 'PPL', 'P'),
(149775, 'Hunts Corners', 43.0311088562012, 0.751034530324802, -78.5872192382813, -1.37160572569464, 218, 40, 'PPL', 'P'),
(155816, 'Hunts Corners', 41.2275009155273, 0.719555633344929, -82.7574996948242, -1.44439085039289, 218, 41, 'PPL', 'P'),
(81693, 'Hunts Crossroads', 34.4319381713867, 0.600950688933814, -80.0475006103516, -1.39709244364281, 218, 48, 'PPL', 'P'),
(182248, 'Hunts Hill (historical)', 39.2383308410645, 0.684838066163411, -120.911666870117, -2.11030669095809, 218, 6, 'PPL', 'P'),
(81694, 'Hunts Mill', 34.660831451416, 0.604945630306014, -80.021110534668, -1.39663184993228, 218, 48, 'PPL', 'P'),
(149776, 'Hunts Point', 40.8125, 0.712312500970186, -73.8844375610352, -1.28952670142423, 218, 40, 'PPL', 'P'),
(207701, 'Hunts Point', 47.6436080932617, 0.831537828757235, -122.228889465332, -2.13329656222626, 218, 56, 'PPL', 'P'),
(81695, 'Hunts Spring (historical)', 34.6599998474121, 0.604931116078073, -80.0116729736328, -1.39646713341885, 218, 48, 'PPL', 'P'),
(103033, 'Hunts Village', 38.8333282470703, 0.677769437419095, -77.2605590820313, -1.34845113791305, 218, 53, 'PPL', 'P'),
(65812, 'Huntsboro', 36.3591690063477, 0.634587212449842, -78.5380630493164, -1.37074778834947, 218, 33, 'PPL', 'P'),
(145478, 'Huntsburg', 40.9972190856934, 0.715536457206808, -74.8380584716797, -1.30617052613085, 218, 37, 'PPL', 'P'),
(155817, 'Huntsburg', 41.5347213745117, 0.724917641883694, -81.0519409179688, -1.41462323415047, 218, 41, 'PPL', 'P'),
(55430, 'Huntsdale', 38.9116706848145, 0.679136770901769, -92.4722213745117, -1.61394472961831, 218, 29, 'PPL', 'P'),
(162935, 'Huntsdale', 40.1022186279297, 0.699915752411976, -77.3077774047852, -1.34927525311238, 218, 45, 'PPL', 'P'),
(199416, 'Huntsman', 41.2208290100098, 0.719439186626265, -102.973327636719, -1.79722360899561, 218, 35, 'PPL', 'P'),
(204435, 'Huntsman Plat A', 40.5574989318848, 0.707861892735473, -111.798332214355, -1.95124899537895, 218, 52, 'PPL', 'P'),
(48402, 'Huntsmoor South', 39.2369384765625, 0.684813764818464, -76.7050018310547, -1.33875483470018, 218, 25, 'PPL', 'P'),
(48403, 'Huntspring', 39.4277801513672, 0.688144580393826, -76.6613922119141, -1.33799370326064, 218, 25, 'PPL', 'P'),
(131407, 'Huntspur', 46.0419387817383, 0.803583425743, -85.8541717529297, -1.49843797366133, 218, 27, 'PPL', 'P'),
(155819, 'Huntstown (historical)', 41.0052795410156, 0.715677138691392, -84.3036117553711, -1.47137559645422, 218, 41, 'PPL', 'P'),
(3297, 'Huntsville', 34.730281829834, 0.606157768076164, -86.5861129760742, -1.51121275793628, 218, 2, 'PPL', 'P'),
(9622, 'Huntsville', 36.086109161377, 0.629821419100118, -93.7411117553711, -1.63609104461119, 218, 4, 'PPL', 'P'),
(32815, 'Huntsville', 38.0572204589844, 0.664223801166625, -98.3255615234375, -1.71610478745624, 218, 20, 'PPL', 'P'),
(36535, 'Huntsville', 37.163330078125, 0.648622470868723, -86.8816680908203, -1.51637116780971, 218, 21, 'PPL', 'P'),
(48404, 'Huntsville', 38.9088897705078, 0.679088234790902, -76.8927764892578, -1.34203212073764, 218, 25, 'PPL', 'P'),
(55431, 'Huntsville', 39.440559387207, 0.68836762013512, -92.5449981689453, -1.61521492430022, 218, 29, 'PPL', 'P'),
(60357, 'Huntsville', 33.3480606079102, 0.582033456762654, -89.4611129760742, -1.56139097393112, 218, 30, 'PPL', 'P'),
(65813, 'Huntsville', 36.082218170166, 0.629753508492321, -80.5297164916992, -1.40550869847773, 218, 33, 'PPL', 'P'),
(88037, 'Huntsville', 35.7769393920898, 0.624425388678426, -84.2825012207031, -1.47100714811741, 218, 50, 'PPL', 'P'),
(95055, 'Huntsville', 30.7233295440674, 0.536223257719224, -95.5505599975586, -1.66767187408178, 218, 51, 'PPL', 'P'),
(113583, 'Huntsville', 41.9447212219238, 0.73207348915371, -73.3130569458008, -1.27955422840632, 218, 8, 'PPL', 'P'),
(120090, 'Huntsville', 40.1911087036133, 0.701467176905002, -90.8644409179688, -1.58588366700241, 218, 18, 'PPL', 'P'),
(122850, 'Huntsville', 40.0711097717285, 0.699372800444736, -85.0722198486328, -1.48479033833911, 218, 19, 'PPL', 'P'),
(145479, 'Huntsville', 40.980281829834, 0.71524084632581, -74.7758331298828, -1.30508448903831, 218, 37, 'PPL', 'P'),
(155820, 'Huntsville', 40.4433288574219, 0.705869249028848, -83.8050003051758, -1.46267318496017, 218, 41, 'PPL', 'P'),
(162936, 'Huntsville', 41.3063888549805, 0.7209324876285, -75.9747161865234, -1.32600894572306, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(169432, 'Huntsville', 41.9638900756836, 0.732408048765651, -71.7130584716797, -1.25162898700602, 218, 47, 'PPL', 'P'),
(172136, 'Huntsville', 44.6997184753418, 0.780157262109254, -72.9844436645508, -1.27381884468273, 218, 55, 'PPL', 'P'),
(204431, 'Huntsville', 41.2608299255371, 0.720137334306029, -111.769172668457, -1.95074006529463, 218, 52, 'PPL', 'P'),
(207700, 'Huntsville', 46.2872200012207, 0.807864390616275, -118.106109619141, -2.06134047957535, 218, 56, 'PPL', 'P'),
(109759, 'Huntsville (historical)', 38.8313903808594, 0.677735615273251, -81.8402786254883, -1.42838232276431, 218, 58, 'PPL', 'P'),
(169429, 'Huntsville (historical)', 41.9644393920898, 0.732417636145575, -71.7144393920898, -1.25165308861389, 218, 47, 'PPL', 'P'),
(204432, 'Huntsville Hollow', 41.2619400024414, 0.72015670880296, -111.69750213623, -1.94948917853062, 218, 52, 'PPL', 'P'),
(3299, 'Huntsville Park', 34.7044410705566, 0.605706761745559, -86.6188888549805, -1.51178480493843, 218, 2, 'PPL', 'P'),
(136045, 'Huot', 47.8652801513672, 0.835406736030847, -96.4230575561523, -1.68289982919486, 218, 28, 'PPL', 'P'),
(190327, 'Hupton (historical)', 36.6577796936035, 0.639798952124099, -114.574172973633, -1.99969655613939, 218, 39, 'PPL', 'P'),
(109760, 'Hur', 38.8733291625977, 0.678467585098859, -81.1697235107422, -1.4166789281959, 218, 58, 'PPL', 'P'),
(127791, 'Hurd', 46.8447189331055, 0.817594582554016, -67.9519424438477, -1.18598512877082, 218, 26, 'PPL', 'P'),
(198447, 'Hurd', 48.646110534668, 0.849034797119055, -101.217498779297, -1.76657861433207, 218, 34, 'PPL', 'P'),
(9623, 'Hurd (historical)', 36.4830589294434, 0.636749499517904, -93.9394378662109, -1.63955248823802, 218, 4, 'PPL', 'P'),
(127792, 'Hurd Corner', 44.8047218322754, 0.781989916413392, -69.313606262207, -1.20975064570647, 218, 26, 'PPL', 'P'),
(149778, 'Hurd Corners', 41.5894393920898, 0.725872651450597, -73.5838928222656, -1.28428120618316, 218, 40, 'PPL', 'P'),
(149777, 'Hurd Settlement', 41.7275009155273, 0.7282822796049, -74.8827819824219, -1.30695109864635, 218, 40, 'PPL', 'P'),
(139225, 'Hurdland', 40.1500015258789, 0.700749721307334, -92.3019409179688, -1.61097277499983, 218, 29, 'PPL', 'P'),
(65815, 'Hurdle Mills', 36.2730598449707, 0.633084324067683, -79.0477828979492, -1.37964407797088, 218, 33, 'PPL', 'P'),
(88038, 'Hurdlow', 35.1738891601563, 0.61390017657627, -86.3375015258789, -1.50687366957222, 218, 50, 'PPL', 'P'),
(9624, 'Hurds', 33.5338897705078, 0.585276787496207, -91.3561096191406, -1.59446490466687, 218, 4, 'PPL', 'P'),
(113584, 'Hurds Corner', 41.621940612793, 0.726439904762784, -73.4225006103516, -1.28146438069818, 218, 8, 'PPL', 'P'),
(127794, 'Hurds Corner', 44.6155586242676, 0.778688395610021, -68.5266723632813, -1.19601605817466, 218, 26, 'PPL', 'P'),
(140264, 'Hurdsfield', 47.4483299255371, 0.828129581773178, -99.9280624389648, -1.74407370469841, 218, 34, 'PPL', 'P'),
(145480, 'Hurdtown', 40.9700012207031, 0.715061415847365, -74.5994415283203, -1.30200587481818, 218, 37, 'PPL', 'P'),
(70970, 'Hurffville', 39.7625007629395, 0.693986557140051, -75.1086120605469, -1.31089257705967, 218, 37, 'PPL', 'P'),
(155821, 'Hurford', 40.2455596923828, 0.702417525939996, -80.897216796875, -1.41192278880513, 218, 41, 'PPL', 'P'),
(122851, 'Hurlburt', 41.3699989318848, 0.722042692907927, -87.1766662597656, -1.52151985714516, 218, 19, 'PPL', 'P'),
(182249, 'Hurlbut', 38.4127807617188, 0.670429499138728, -122.837501525879, -2.14391884655015, 218, 6, 'PPL', 'P'),
(149783, 'Hurlbutville', 43.4025001525879, 0.75751653126, -75.3475036621094, -1.31506202206229, 218, 40, 'PPL', 'P'),
(182250, 'Hurleton', 39.497501373291, 0.68936144527491, -121.386390686035, -2.11859218458349, 218, 6, 'PPL', 'P'),
(3300, 'Hurley', 34.2750015258789, 0.598211627752667, -85.6230621337891, -1.4944043498743, 218, 2, 'PPL', 'P'),
(36536, 'Hurley', 37.4124984741211, 0.652971279770768, -84.0372161865234, -1.46672611666511, 218, 21, 'PPL', 'P'),
(55432, 'Hurley', 36.9313888549805, 0.644574332853748, -93.498893737793, -1.6318635426968, 218, 29, 'PPL', 'P'),
(60355, 'Hurley', 30.6608295440674, 0.535132426936728, -88.4941711425781, -1.54451465526134, 218, 30, 'PPL', 'P'),
(88039, 'Hurley', 35.1380615234375, 0.613274866352319, -88.3658294677734, -1.54227467046847, 218, 50, 'PPL', 'P'),
(112617, 'Hurley', 37.420280456543, 0.653107100986362, -82.0199966430664, -1.43151899389621, 218, 53, 'PPL', 'P'),
(116106, 'Hurley', 43.0091705322266, 0.750651634339075, -93.2311096191406, -1.62718982814176, 218, 16, 'PPL', 'P'),
(149779, 'Hurley', 41.9244384765625, 0.731719488465811, -74.0616683959961, -1.29261996303036, 218, 40, 'PPL', 'P'),
(170573, 'Hurley', 43.2830581665039, 0.755431875337713, -97.0888900756836, -1.69452079892753, 218, 49, 'PPL', 'P'),
(174605, 'Hurley', 46.4497184753418, 0.810700524019155, -90.186393737793, -1.57404951122448, 218, 57, 'PPL', 'P'),
(188711, 'Hurley', 32.6991691589355, 0.57070816449001, -108.131393432617, -1.88724884016854, 218, 38, 'PPL', 'P'),
(194245, 'Hurley', 40.274169921875, 0.702916868644386, -103.761108398438, -1.81097297707147, 218, 7, 'PPL', 'P'),
(88040, 'Hurley Acres', 36.2019386291504, 0.631843024683597, -83.2313919067383, -1.45266182979034, 218, 50, 'PPL', 'P'),
(14002, 'Hurley Heights', 38.6474990844727, 0.674526106685542, -75.6175003051758, -1.31977435245313, 218, 10, 'PPL', 'P'),
(103035, 'Hurleyville', 38.6427803039551, 0.674443748428831, -77.7636108398438, -1.35723104739483, 218, 53, 'PPL', 'P'),
(149781, 'Hurleyville', 41.7355613708496, 0.728422961089484, -74.6747207641602, -1.30331974534197, 218, 40, 'PPL', 'P'),
(48405, 'Hurline Farms', 39.5055618286133, 0.689502126759494, -76.5036087036133, -1.33523986153544, 218, 25, 'PPL', 'P'),
(55434, 'Hurlingen', 39.7983283996582, 0.694611867364001, -94.6363906860352, -1.65171660967501, 218, 29, 'PPL', 'P'),
(48406, 'Hurlock', 38.6241683959961, 0.674118909354869, -75.8547210693359, -1.32391463584183, 218, 25, 'PPL', 'P'),
(191649, 'Hurlwood', 33.5766716003418, 0.586023471286838, -102.037498474121, -1.7808903088721, 218, 51, 'PPL', 'P'),
(95057, 'Hurnville', 33.958610534668, 0.592689563232388, -98.1691665649414, -1.71337518049696, 218, 51, 'PPL', 'P'),
(30131, 'Huron', 38.7222213745117, 0.675830256671354, -86.6705627441406, -1.51268668444159, 218, 19, 'PPL', 'P'),
(32817, 'Huron', 39.6383285522461, 0.691819343223972, -95.3513870239258, -1.6641956499109, 218, 20, 'PPL', 'P'),
(41448, 'Huron', 30.3519401550293, 0.529741290073539, -91.8736114501953, -1.60349701550387, 218, 22, 'PPL', 'P'),
(55435, 'Huron', 37.7158317565918, 0.658265444280763, -93.3530578613281, -1.62931822648495, 218, 29, 'PPL', 'P'),
(60356, 'Huron', 31.1000003814697, 0.542797404028139, -90.6413879394531, -1.58199065812094, 218, 30, 'PPL', 'P'),
(78495, 'Huron', 39.8736114501953, 0.695925804466819, -79.9194412231445, -1.39485738569796, 218, 45, 'PPL', 'P'),
(88041, 'Huron', 35.5880584716797, 0.621128794723072, -88.5322189331055, -1.54517871447915, 218, 50, 'PPL', 'P'),
(95056, 'Huron', 32.0397186279297, 0.559198581469933, -97.3597183227539, -1.69924764354631, 218, 51, 'PPL', 'P'),
(116107, 'Huron', 41.0366706848145, 0.716225017506648, -91.0338897705078, -1.58884110739295, 218, 16, 'PPL', 'P'),
(149782, 'Huron', 43.2333297729492, 0.754563951138456, -76.8802795410156, -1.34181400784436, 218, 40, 'PPL', 'P'),
(155824, 'Huron', 41.3950004577637, 0.722479051852536, -82.5552825927734, -1.44086149615826, 218, 41, 'PPL', 'P'),
(170576, 'Huron', 44.3633308410645, 0.77428619032812, -98.2138900756836, -1.71415575301246, 218, 49, 'PPL', 'P'),
(174607, 'Huron', 45.1194381713867, 0.787482752740708, -90.9824981689453, -1.58794415473781, 218, 57, 'PPL', 'P'),
(182251, 'Huron', 36.2027816772461, 0.631857738648619, -120.101936340332, -2.09617422715942, 218, 6, 'PPL', 'P'),
(9625, 'Huron (historical)', 36.228889465332, 0.632313405511132, -92.0625, -1.60679374261728, 218, 4, 'PPL', 'P'),
(22114, 'Huron (historical)', 33.2619400024414, 0.580530368643413, -83.4977798461914, -1.4573111764214, 218, 13, 'PPL', 'P'),
(131408, 'Huron Beach', 45.4916687011719, 0.793979401061902, -84.0933303833008, -1.46770549415598, 218, 27, 'PPL', 'P'),
(131409, 'Huron City', 44.0291709899902, 0.768454000698901, -82.8327789306641, -1.44570472091668, 218, 27, 'PPL', 'P'),
(140266, 'Huron City (historical)', 48.9972190856934, 0.855162797366355, -97.2333297729492, -1.69704174721539, 218, 34, 'PPL', 'P'),
(170579, 'Huron Colony', 44.7686080932617, 0.781359612762398, -97.9088897705078, -1.70883249346756, 218, 49, 'PPL', 'P'),
(131411, 'Huron Heights', 44.1399993896484, 0.770388321177653, -83.5691680908203, -1.4585571363374, 218, 27, 'PPL', 'P'),
(131412, 'Huron Mountain', 46.8872184753418, 0.81833633949663, -87.8652801513672, -1.53353843682858, 218, 27, 'PPL', 'P'),
(131413, 'Huron Oaks', 44.2269401550293, 0.771905723787753, -83.5500030517578, -1.45822264330448, 218, 27, 'PPL', 'P'),
(131416, 'Huronia Heights', 43.2122192382813, 0.754195502801644, -82.5227813720703, -1.44029424284607, 218, 27, 'PPL', 'P'),
(131417, 'Hurontown', 47.110279083252, 0.822229481536162, -88.5738906860352, -1.54590602377285, 218, 27, 'PPL', 'P'),
(3302, 'Hurricane', 30.8408298492432, 0.53827402491664, -87.9019393920898, -1.53417826128047, 218, 2, 'PPL', 'P'),
(41449, 'Hurricane', 32.6175003051758, 0.569282774095573, -92.9400024414063, -1.62210904941411, 218, 22, 'PPL', 'P'),
(55437, 'Hurricane', 38.1811103820801, 0.666386088234687, -90.8252792358398, -1.58520016670864, 218, 29, 'PPL', 'P'),
(60360, 'Hurricane', 33.0250015258789, 0.576395012102738, -89.6449966430664, -1.56460034936077, 218, 30, 'PPL', 'P'),
(65816, 'Hurricane', 35.9141693115234, 0.626820502604789, -82.7577819824219, -1.4443957772409, 218, 33, 'PPL', 'P'),
(88043, 'Hurricane', 36.0538902282715, 0.629259092635947, -86.311393737793, -1.5064180027097, 218, 50, 'PPL', 'P'),
(103034, 'Hurricane', 37.0038909912109, 0.645839733845699, -82.5358276367188, -1.44052194311927, 218, 53, 'PPL', 'P'),
(109761, 'Hurricane', 38.4324989318848, 0.670773646130593, -82.0202789306641, -1.43152392074422, 218, 58, 'PPL', 'P'),
(149785, 'Hurricane', 43.246940612793, 0.754801505107691, -74.9786071777344, -1.30862356381092, 218, 40, 'PPL', 'P'),
(174608, 'Hurricane', 42.7847213745117, 0.746734257533623, -90.771110534668, -1.58425474452167, 218, 57, 'PPL', 'P'),
(192630, 'Hurricane', 37.1752815246582, 0.648831062961103, -113.289169311523, -1.9772690113354, 218, 52, 'PPL', 'P'),
(3301, 'Hurricane (historical)', 34.8819389343262, 0.608804683883594, -87.2708282470703, -1.52316329385385, 218, 2, 'PPL', 'P'),
(9626, 'Hurricane (historical)', 34.5400009155273, 0.602836739617808, -92.4205627441406, -1.61304311643126, 218, 4, 'PPL', 'P'),
(27494, 'Hurricane (historical)', 39.2916717529297, 0.685769040701475, -90.4899978637695, -1.57934840284541, 218, 18, 'PPL', 'P'),
(60361, 'Hurricane Branch', 33.8083305358887, 0.590066682453796, -89.6944427490234, -1.56546334671201, 218, 30, 'PPL', 'P'),
(88044, 'Hurricane Branch (historical)', 36.2769393920898, 0.633152034938398, -83.8605575561523, -1.46364284191307, 218, 50, 'PPL', 'P'),
(109762, 'Hurricane Bridge (historical)', 38.4075012207031, 0.670337353765011, -82.0133285522461, -1.43140261375657, 218, 58, 'PPL', 'P'),
(60363, 'Hurricane Creek', 31.1019401550293, 0.542831259463497, -89.8722229003906, -1.56856619569806, 218, 30, 'PPL', 'P'),
(55438, 'Hurricane Deck', 38.1316719055176, 0.665523224041502, -92.7936096191406, -1.61955401266429, 218, 29, 'PPL', 'P'),
(9627, 'Hurricane Grove', 34.5355606079102, 0.602759241630087, -93.5774993896484, -1.63323547013235, 218, 4, 'PPL', 'P'),
(88045, 'Hurricane Hill', 35.6955604553223, 0.62300505829006, -89.5188903808594, -1.56239937987788, 218, 50, 'PPL', 'P'),
(88046, 'Hurricane Mills', 35.9711112976074, 0.627814327744579, -87.7819366455078, -1.53208381824118, 218, 50, 'PPL', 'P'),
(55444, 'Hurricane Ridge', 36.6341705322266, 0.639386894524437, -89.6641693115234, -1.56493497555174, 218, 29, 'PPL', 'P'),
(22116, 'Hurricane Shoals (historical)', 34.211669921875, 0.59710628274223, -83.5444412231445, -1.45812557108275, 218, 13, 'PPL', 'P'),
(194246, 'Hurrich', 40.5311088562012, 0.707401299024943, -104.793327331543, -1.82898859605559, 218, 7, 'PPL', 'P'),
(48407, 'Hurry', 38.3369407653809, 0.669105841497931, -76.7758331298828, -1.3399910740782, 218, 25, 'PPL', 'P'),
(55441, 'Hurryville', 37.8400001525879, 0.660432591617815, -90.4580612182617, -1.57879100322926, 218, 29, 'PPL', 'P'),
(122852, 'Hursh', 41.2480583190918, 0.71991442772279, -84.9741668701172, -1.48307899102263, 218, 19, 'PPL', 'P'),
(22117, 'Hurst', 34.8411102294922, 0.608092088554916, -84.1891708374023, -1.46937822563666, 218, 13, 'PPL', 'P'),
(27496, 'Hurst', 37.8330612182617, 0.660311484367244, -89.1427764892578, -1.55583495410694, 218, 18, 'PPL', 'P'),
(36537, 'Hurst', 37.6369400024414, 0.656888523418165, -83.504997253418, -1.45743714394097, 218, 21, 'PPL', 'P'),
(55442, 'Hurst', 37.2366714477539, 0.649902519246669, -92.086669921875, -1.60721558733395, 218, 29, 'PPL', 'P'),
(95058, 'Hurst', 32.8233299255371, 0.572875178669008, -97.170280456543, -1.69594132905297, 218, 51, 'PPL', 'P'),
(109763, 'Hurst', 39.0730590820313, 0.681953529807719, -80.6991729736328, -1.40846627202632, 218, 58, 'PPL', 'P'),
(88047, 'Hurst Mill', 36.4313888549805, 0.635847686593776, -83.5227813720703, -1.45774753536601, 218, 50, 'PPL', 'P'),
(95059, 'Hurst Springs', 31.6656398773193, 0.552669675610036, -97.6939315795898, -1.70508076528191, 218, 51, 'PPL', 'P'),
(36539, 'Hurstbourne', 38.2380599975586, 0.667380046532532, -85.5883331298828, -1.4937982144102, 218, 21, 'PPL', 'P'),
(36538, 'Hurstbourne Acres', 38.2211112976074, 0.667084235914452, -85.5891723632813, -1.49381286179619, 218, 21, 'PPL', 'P'),
(95060, 'Hurstown', 31.6969394683838, 0.553215956528638, -94.0288925170898, -1.64111376642708, 218, 51, 'PPL', 'P'),
(116109, 'Hurstville', 42.0974998474121, 0.734739979195152, -90.6830596923828, -1.58271796741464, 218, 16, 'PPL', 'P'),
(103037, 'Hurt', 37.0924987792969, 0.647386231490708, -79.2966690063477, -1.38398796002491, 218, 53, 'PPL', 'P'),
(3304, 'Hurtsboro', 32.2416687011719, 0.562723275172653, -85.416389465332, -1.49079723133584, 218, 2, 'PPL', 'P'),
(103038, 'Hurtsville', 37.3652801513672, 0.652147164571443, -78.6161117553711, -1.37210999524704, 218, 53, 'PPL', 'P'),
(162937, 'Husband', 40.0416717529297, 0.698859010091432, -79.101936340332, -1.38058923384175, 218, 45, 'PPL', 'P'),
(32818, 'Huscher', 39.524169921875, 0.689826899254429, -97.5888900756836, -1.7032474451875, 218, 20, 'PPL', 'P'),
(174609, 'Husher', 42.8141708374023, 0.747248247624009, -87.8944396972656, -1.53404736691289, 218, 57, 'PPL', 'P'),
(60364, 'Hushpuckena', 34.0047187805176, 0.593494303934783, -90.753059387207, -1.58393969256471, 218, 30, 'PPL', 'P'),
(48408, 'Husick Estates', 38.4738883972168, 0.671496028576277, -76.897216796875, -1.34210961872536, 218, 25, 'PPL', 'P'),
(103042, 'Huske', 36.8974990844727, 0.643982844775641, -77.4188919067383, -1.35121456701817, 218, 53, 'PPL', 'P'),
(142108, 'Huskerville', 40.8597183227539, 0.713136616169511, -96.7936096191406, -1.68936718274406, 218, 35, 'PPL', 'P'),
(9632, 'Huskey', 35.663890838623, 0.622452319205814, -90.605827331543, -1.58137000842889, 218, 4, 'PPL', 'P'),
(55443, 'Huskey', 37.3194389343262, 0.651347084400956, -89.8874969482422, -1.56883277812318, 218, 29, 'PPL', 'P'),
(76158, 'Huskey', 33.9458312988281, 0.592466523491094, -95.2780609130859, -1.66291586784906, 218, 42, 'PPL', 'P'),
(88048, 'Huskey Valley', 35.8727798461914, 0.626098120159105, -83.7925033569336, -1.46245507206689, 218, 50, 'PPL', 'P'),
(81697, 'Huskum Corner Cross Roads', 32.6749992370605, 0.570286319773342, -80.0505599975586, -1.39714584002266, 218, 48, 'PPL', 'P'),
(211883, 'Huslia', 65.6986083984375, 1.14665703053113, -156.399719238281, -2.72969004990273, 218, 1, 'PPL', 'P'),
(196758, 'Huson', 47.0313911437988, 0.820852627252591, -114.326393127441, -1.99537198200327, 218, 31, 'PPL', 'P'),
(127795, 'Huson Landing', 46.5125007629395, 0.811796281649668, -68.1941680908203, -1.19021276384327, 218, 26, 'PPL', 'P'),
(41450, 'Husser', 30.6791706085205, 0.535452538899755, -90.3372192382813, -1.57668191280397, 218, 22, 'PPL', 'P'),
(81698, 'Hussertown', 33.2555618286133, 0.580419048509848, -80.2583312988281, -1.40077213332097, 218, 48, 'PPL', 'P'),
(65818, 'Husseys Crossroads', 35.2125015258789, 0.614574089490114, -77.8233337402344, -1.35827340864548, 218, 33, 'PPL', 'P'),
(136047, 'Hustad Mobile Home Park', 45.8902816772461, 0.80093650993557, -95.3499984741211, -1.66417141514498, 218, 28, 'PPL', 'P'),
(88049, 'Hustburg', 35.982780456543, 0.628017992988943, -87.959716796875, -1.53518666722723, 218, 50, 'PPL', 'P'),
(72984, 'Hustead', 39.8405609130859, 0.695348963774708, -83.8630599975586, -1.46368651775495, 218, 41, 'PPL', 'P'),
(70971, 'Husted', 39.5252799987793, 0.689846273751359, -75.1894378662109, -1.31230325348908, 218, 37, 'PPL', 'P'),
(70972, 'Husted Landing', 39.351390838623, 0.686811335373105, -75.2574996948242, -1.31349115649331, 218, 37, 'PPL', 'P'),
(174611, 'Hustisford', 43.3461112976074, 0.756532360079161, -88.6005630493164, -1.5463715443314, 218, 57, 'PPL', 'P'),
(103039, 'Hustle', 38.0424995422363, 0.66396687270046, -77.0697174072266, -1.34512032233769, 218, 53, 'PPL', 'P'),
(120093, 'Hustle', 40.4666709899902, 0.706276646096603, -87.8319396972656, -1.5329565361304, 218, 18, 'PPL', 'P'),
(60365, 'Hustler', 31.2819404602051, 0.545972857443409, -90.6975021362305, -1.58297003561181, 218, 30, 'PPL', 'P'),
(174614, 'Hustler', 43.8800010681152, 0.765850494417239, -90.2716674804688, -1.57553781879967, 218, 57, 'PPL', 'P'),
(3305, 'Hustleville', 34.3116683959961, 0.598851585362613, -86.1675033569336, -1.50390664180176, 218, 2, 'PPL', 'P'),
(78496, 'Huston', 39.8294410705566, 0.695154885910269, -79.3755569458008, -1.38536481430848, 218, 45, 'PPL', 'P'),
(195120, 'Huston', 43.610279083252, 0.761142957716361, -116.782218933105, -2.03823422816755, 218, 17, 'PPL', 'P'),
(155825, 'Huston (historical)', 40.607780456543, 0.708739470893681, -81.9177780151367, -1.42973494228196, 218, 41, 'PPL', 'P'),
(162938, 'Huston Run', 40.2311096191406, 0.702165324584766, -79.9722213745117, -1.39577857311901, 218, 45, 'PPL', 'P'),
(162941, 'Hustons Mill', 40.2552795410156, 0.702587169301434, -77.0377807617188, -1.34456292272154, 218, 45, 'PPL', 'P'),
(162942, 'Hustontown', 40.0488891601563, 0.698984977610993, -78.0272216796875, -1.36183192449405, 218, 45, 'PPL', 'P'),
(36540, 'Hustonville', 37.4730606079102, 0.65402828840742, -84.8158264160156, -1.48031542875945, 218, 21, 'PPL', 'P'),
(207702, 'Husum', 45.7994384765625, 0.799350996980591, -121.485832214355, -2.1203277666659, 218, 56, 'PPL', 'P'),
(36541, 'Hutch', 36.6505584716797, 0.639672918025512, -83.6213912963867, -1.45946860322048, 218, 21, 'PPL', 'P'),
(22118, 'Hutchins', 33.8416709899902, 0.590648583151979, -83.1680603027344, -1.45155648477991, 218, 13, 'PPL', 'P'),
(95061, 'Hutchins', 32.649169921875, 0.569835513179819, -96.7127838134766, -1.68795650631464, 218, 51, 'PPL', 'P'),
(103040, 'Hutchins', 36.6755599975586, 0.640109276970121, -76.1894378662109, -1.32975654600902, 218, 53, 'PPL', 'P'),
(116110, 'Hutchins', 43.0916709899902, 0.752091538961454, -93.8808288574219, -1.63852956806332, 218, 16, 'PPL', 'P'),
(162943, 'Hutchins', 41.6622200012207, 0.727142912711537, -78.6275024414063, -1.37230880022242, 218, 45, 'PPL', 'P'),
(172138, 'Hutchins', 44.8594398498535, 0.782944925980295, -72.6102828979492, -1.26728850737374, 218, 55, 'PPL', 'P'),
(187724, 'Hutchins', 38.4397201538086, 0.670899680229181, -100.915000915527, -1.76129903062904, 218, 20, 'PPL', 'P'),
(48409, 'Hutchins Choice', 38.7055587768555, 0.675539439480317, -76.6055603027344, -1.33701925261778, 218, 25, 'PPL', 'P'),
(127797, 'Hutchins Corner', 44.4847183227539, 0.776404801554305, -69.3777770996094, -1.21087063810291, 218, 26, 'PPL', 'P'),
(60366, 'Hutchins Landing', 31.3916702270508, 0.547888003162312, -91.4580612182617, -1.5962442957492, 218, 30, 'PPL', 'P'),
(120094, 'Hutchins Park', 42.3794403076172, 0.739660768520318, -89.0658264160156, -1.55449192196921, 218, 18, 'PPL', 'P'),
(9633, 'Hutchinson', 35.644718170166, 0.622117693014845, -91.6741714477539, -1.60001613080108, 218, 4, 'PPL', 'P'),
(32819, 'Hutchinson', 38.0608291625977, 0.664286784926405, -97.929443359375, -1.70919122126639, 218, 20, 'PPL', 'P'),
(65819, 'Hutchinson', 35.2900009155273, 0.615926709007765, -81.0250015258789, -1.41415305306002, 218, 33, 'PPL', 'P'),
(103041, 'Hutchinson', 38.9433288574219, 0.679689310248933, -77.5202789306641, -1.35298410440448, 218, 53, 'PPL', 'P'),
(109765, 'Hutchinson', 39.440559387207, 0.68836762013512, -80.274169921875, -1.40104856944212, 218, 58, 'PPL', 'P'),
(136048, 'Hutchinson', 44.8877792358398, 0.78343954157375, -94.3694381713867, -1.64705740934792, 218, 28, 'PPL', 'P'),
(145486, 'Hutchinson', 40.773609161377, 0.711633727787352, -75.1316680908203, -1.31129498070038, 218, 37, 'PPL', 'P'),
(162944, 'Hutchinson', 40.2261085510254, 0.702078039480038, -79.7319412231445, -1.39158489335047, 218, 45, 'PPL', 'P'),
(201011, 'Hutchinson', 44.9716682434082, 0.784903680962048, -117.976669311523, -2.05908132002264, 218, 43, 'PPL', 'P'),
(81699, 'Hutchinson Acres', 34.9597206115723, 0.610162230249262, -80.9902801513672, -1.41354705075397, 218, 48, 'PPL', 'P'),
(149786, 'Hutchinson Crossing', 42.8530616760254, 0.747927020806843, -73.9977798461914, -1.29150489748194, 218, 40, 'PPL', 'P'),
(145481, 'Hutchinson Mills', 40.2455596923828, 0.702417525939996, -74.7088928222656, -1.30391616026809, 218, 37, 'PPL', 'P'),
(36542, 'Hutchison', 38.1380615234375, 0.665634743912149, -84.3399963378906, -1.47201062721615, 218, 21, 'PPL', 'P'),
(55445, 'Hutchison', 39.3458290100098, 0.686714263151371, -91.6425018310547, -1.59946339171684, 218, 29, 'PPL', 'P'),
(88050, 'Hutsell', 35.4602813720703, 0.618898663626239, -84.6061096191406, -1.47665518015725, 218, 50, 'PPL', 'P'),
(155826, 'Hutson (historical)', 41.0166702270508, 0.715875943666766, -81.022216796875, -1.41410445037012, 218, 41, 'PPL', 'P'),
(65820, 'Hutson Corner', 36.2649993896484, 0.632943642583099, -76.6552810668945, -1.33788704365898, 218, 33, 'PPL', 'P'),
(88051, 'Hutson Grove (historical)', 35.8702812194824, 0.626054510896255, -89.1944427490234, -1.55673670045204, 218, 50, 'PPL', 'P'),
(27497, 'Hutsonville', 39.1094398498535, 0.682588493990621, -87.6563873291016, -1.52989256929626, 218, 18, 'PPL', 'P'),
(182252, 'Hutt', 34.9077796936035, 0.609255690214199, -117.074440002441, -2.04333444797116, 218, 6, 'PPL', 'P'),
(9634, 'Huttig', 33.0394401550293, 0.576647013720887, -92.182502746582, -1.60888818565657, 218, 4, 'PPL', 'P'),
(95062, 'Hutto', 30.5424995422363, 0.533067178800885, -97.54638671875, -1.70250562166586, 218, 51, 'PPL', 'P'),
(27499, 'Hutton', 39.4124984741211, 0.687877864810654, -88.0844421386719, -1.53736353510226, 218, 18, 'PPL', 'P'),
(30134, 'Hutton', 39.3175010681152, 0.686219847294998, -87.5338897705078, -1.52775458357315, 218, 19, 'PPL', 'P'),
(41451, 'Hutton', 31.3302803039551, 0.546816546876746, -93.0322189331055, -1.6237185308189, 218, 22, 'PPL', 'P'),
(48410, 'Hutton', 39.4141693115234, 0.687907026424591, -79.4797210693359, -1.38718282122662, 218, 25, 'PPL', 'P'),
(136051, 'Hutton', 43.6161117553711, 0.761244757049029, -92.0447235107422, -1.60648348435029, 218, 28, 'PPL', 'P'),
(145482, 'Hutton Park', 40.7791709899902, 0.711730800009085, -74.2508316040039, -1.29592148383373, 218, 37, 'PPL', 'P'),
(207703, 'Hutton Settlement', 47.7013893127441, 0.83254630128302, -117.264999389648, -2.04666033669851, 218, 56, 'PPL', 'P'),
(55446, 'Hutton Valley', 36.961669921875, 0.645102837172074, -91.883056640625, -1.60366186517535, 218, 29, 'PPL', 'P'),
(109768, 'Huttonsville', 38.7127799987793, 0.675665473578905, -79.9791717529297, -1.39589988010667, 218, 58, 'PPL', 'P'),
(3306, 'Huxford', 31.2199993133545, 0.544891780488405, -87.4619369506836, -1.52649876996112, 218, 2, 'PPL', 'P'),
(22124, 'Huxford', 31.5591697692871, 0.550811421669919, -81.5102767944336, -1.4226227042748, 218, 13, 'PPL', 'P'),
(55448, 'Huxie', 37.2591705322266, 0.650295202349402, -90.0522232055664, -1.57170779367798, 218, 29, 'PPL', 'P'),
(95063, 'Huxley', 31.7622203826904, 0.554355323422001, -93.8769378662109, -1.63846165745552, 218, 51, 'PPL', 'P'),
(116111, 'Huxley', 41.8952789306641, 0.731210558381497, -93.6005630493164, -1.63363800693111, 218, 16, 'PPL', 'P'),
(190328, 'Huxley', 39.8705596923828, 0.695872541245018, -118.771392822266, -2.0729518619281, 218, 39, 'PPL', 'P'),
(48411, 'Huyett', 39.6513900756836, 0.692047309813282, -77.7994384765625, -1.35785635761878, 218, 25, 'PPL', 'P'),
(55449, 'Huzzah', 37.9041709899902, 0.661552584014248, -91.1572189331055, -1.590993607344, 218, 29, 'PPL', 'P'),
(76159, 'Hy 10 Landing', 35.6152801513672, 0.621603902661542, -95.1766662597656, -1.66114619730471, 218, 42, 'PPL', 'P'),
(48412, 'Hy-Crest', 39.5750007629395, 0.690714064792561, -76.4697189331055, -1.33464837345734, 218, 25, 'PPL', 'P'),
(103045, 'Hyacinth', 37.9905586242676, 0.663060332665397, -76.5905609130859, -1.33675746388262, 218, 53, 'PPL', 'P'),
(207704, 'Hyak', 47.3930587768555, 0.827164918247325, -121.391670227051, -2.11868432995721, 218, 56, 'PPL', 'P'),
(193666, 'Hyampom', 40.6175003051758, 0.708909114255119, -123.451393127441, -2.15463327624775, 218, 6, 'PPL', 'P'),
(41453, 'Hyams', 31.8369407653809, 0.555659440118299, -93.1202774047852, -1.62525544108398, 218, 22, 'PPL', 'P'),
(199417, 'Hyannis', 42.000560760498, 0.733048072954624, -101.761390686035, -1.7760713188796, 218, 35, 'PPL', 'P'),
(125129, 'Hyannis Park', 41.6458282470703, 0.726856822631435, -70.2694396972656, -1.22643308624889, 218, 23, 'PPL', 'P'),
(125130, 'Hyannis Port', 41.6355590820313, 0.726677591890073, -70.3000030517578, -1.22696651741524, 218, 23, 'PPL', 'P'),
(211575, 'Hyashi Village', 20.8408298492432, 0.363741099717207, -156.509170532227, -2.73160033535264, 218, 15, 'PPL', 'P'),
(3307, 'Hyatt', 34.2341690063477, 0.597498965844962, -86.3430633544922, -1.50697074179395, 218, 2, 'PPL', 'P'),
(22119, 'Hyatt', 33.3436088562012, 0.581955759037851, -85.1694412231445, -1.48648717142766, 218, 13, 'PPL', 'P'),
(95064, 'Hyatt', 30.5752792358398, 0.533639292382061, -94.4022216796875, -1.64762958950812, 218, 51, 'PPL', 'P'),
(88052, 'Hyatt Acres', 36.2794418334961, 0.633195710780275, -83.1916732788086, -1.4519686089586, 218, 50, 'PPL', 'P'),
(65821, 'Hyatt Creek', 35.4652786254883, 0.61898588215194, -83.0286102294922, -1.44912262185968, 218, 33, 'PPL', 'P'),
(81700, 'Hyatts', 34.0463905334473, 0.594221613228483, -81.0199966430664, -1.41406570137626, 218, 48, 'PPL', 'P'),
(155827, 'Hyatts', 40.2166709899902, 0.701913322966617, -83.0852813720703, -1.45011171988854, 218, 41, 'PPL', 'P'),
(48413, 'Hyattstown', 39.2827796936035, 0.685613844988951, -77.3150024414063, -1.34940135378999, 218, 25, 'PPL', 'P'),
(36543, 'Hyattsville', 37.6049995422363, 0.656331057222984, -84.5224990844727, -1.47519590103794, 218, 21, 'PPL', 'P'),
(48414, 'Hyattsville', 38.9558296203613, 0.679907489721238, -76.9458312988281, -1.34295810184866, 218, 25, 'PPL', 'P'),
(48415, 'Hyattsville Hills', 38.9605598449707, 0.67999004771503, -76.9513931274414, -1.34305517407039, 218, 25, 'PPL', 'P'),
(209521, 'Hyattville', 44.2458305358887, 0.772235423130704, -107.60221862793, -1.87801299750815, 218, 59, 'PPL', 'P'),
(3308, 'Hybart', 31.8263893127441, 0.555475282528921, -87.3819427490234, -1.52510260775964, 218, 2, 'PPL', 'P'),
(103043, 'Hybla Valley', 38.747501373291, 0.676271475884953, -77.0833282470703, -1.34535787630693, 218, 53, 'PPL', 'P'),
(55450, 'Hybrid (historical)', 39.9222183227539, 0.696774154432064, -92.9733276367188, -1.62269068379618, 218, 29, 'PPL', 'P'),
(81701, 'Hyco', 34.3177795410156, 0.598958244964271, -80.5391693115234, -1.40567368130726, 218, 48, 'PPL', 'P'),
(103044, 'Hyco', 36.6119384765625, 0.638998871953612, -78.8513870239258, -1.37621632333184, 218, 53, 'PPL', 'P'),
(3309, 'Hycutt', 32.7066688537598, 0.570839058857588, -87.9952774047852, -1.53580731691927, 218, 2, 'PPL', 'P'),
(193137, 'Hydaburg', 55.2080612182617, 0.963562441901259, -132.826675415039, -2.31826282047024, 218, 1, 'PPL', 'P'),
(60367, 'Hyde', 33.9291687011719, 0.592175706300057, -89.5597229003906, -1.56311204178558, 218, 30, 'PPL', 'P'),
(131418, 'Hyde', 45.7336082458496, 0.798202042707304, -87.2024993896484, -1.52197073031771, 218, 27, 'PPL', 'P'),
(162946, 'Hyde', 41.002498626709, 0.715628602580525, -78.4627838134766, -1.36943391782568, 218, 45, 'PPL', 'P'),
(174617, 'Hyde', 43.0733299255371, 0.751771426998427, -89.9816665649414, -1.57047634798992, 218, 57, 'PPL', 'P'),
(194247, 'Hyde', 40.1358299255371, 0.700502380221093, -102.832221984863, -1.79476085077756, 218, 7, 'PPL', 'P'),
(16514, 'Hyde Grove', 30.2841701507568, 0.528558480364894, -81.7594375610352, -1.42697138001879, 218, 12, 'PPL', 'P'),
(172139, 'Hyde Manor', 43.7833290100098, 0.76416324870862, -73.2030563354492, -1.27763435557648, 218, 55, 'PPL', 'P'),
(3310, 'Hyde Park', 33.4777793884277, 0.584297476584358, -86.879997253418, -1.51634200619577, 218, 2, 'PPL', 'P'),
(14003, 'Hyde Park', 39.7458305358887, 0.69369560679096, -75.6500015258789, -1.32034160576532, 218, 10, 'PPL', 'P'),
(16517, 'Hyde Park', 30.1697196960449, 0.526560943099767, -84.2619400024414, -1.47064828716052, 218, 12, 'PPL', 'P'),
(22121, 'Hyde Park', 33.896671295166, 0.591608519566898, -84.2149963378906, -1.46982896565116, 218, 13, 'PPL', 'P'),
(48416, 'Hyde Park', 39.2874984741211, 0.685696203245661, -76.4411087036133, -1.33414903075295, 218, 25, 'PPL', 'P'),
(72985, 'Hyde Park', 39.1419410705566, 0.683155747302807, -84.4338912963867, -1.47364940339293, 218, 41, 'PPL', 'P'),
(76165, 'Hyde Park', 35.7894401550293, 0.624643568150731, -95.3038864135742, -1.66336660786356, 218, 42, 'PPL', 'P'),
(81702, 'Hyde Park', 34.2416687011719, 0.59762986021254, -82.2094421386719, -1.43482544154759, 218, 48, 'PPL', 'P'),
(122853, 'Hyde Park', 40.1925010681152, 0.701491478249949, -85.3083267211914, -1.48891118065185, 218, 19, 'PPL', 'P'),
(125131, 'Hyde Park', 42.2555618286133, 0.737498681189338, -71.125, -1.24136543048097, 218, 23, 'PPL', 'P'),
(131419, 'Hyde Park', 44.2169418334961, 0.771731220157325, -83.5527801513672, -1.45827111283632, 218, 27, 'PPL', 'P'),
(149789, 'Hyde Park', 41.7847213745117, 0.72928096501368, -73.9336090087891, -1.29038490508551, 218, 40, 'PPL', 'P'),
(162949, 'Hyde Park', 40.6324996948242, 0.709170902990274, -79.5899963378906, -1.38910748774642, 218, 45, 'PPL', 'P'),
(172140, 'Hyde Park', 44.5938911437988, 0.77831022673523, -72.616943359375, -1.26740475435533, 218, 55, 'PPL', 'P'),
(178402, 'Hyde Park', 33.6205596923828, 0.586789462995372, -111.966667175293, -1.95418699469352, 218, 5, 'PPL', 'P'),
(182253, 'Hyde Park', 33.9805603027344, 0.593072658955196, -118.329719543457, -2.06524320899481, 218, 6, 'PPL', 'P'),
(204434, 'Hyde Park', 41.7988891601563, 0.729528239520894, -111.818328857422, -1.9515980026398, 218, 52, 'PPL', 'P'),
(178403, 'Hyde Park Lodge', 33.464168548584, 0.584059922615123, -111.991111755371, -1.95461363310015, 218, 5, 'PPL', 'P'),
(22123, 'Hyde Park Mobile Home Park', 33.6344413757324, 0.587031744075542, -84.3188934326172, -1.47164231203739, 218, 13, 'PPL', 'P'),
(48419, 'Hyde Park Trailer Park', 38.8161087036133, 0.67746889969008, -76.0558319091797, -1.32742468215855, 218, 25, 'PPL', 'P'),
(188712, 'Hyde Place', 34.7138900756836, 0.605871677996062, -106.370002746582, -1.85650677328327, 218, 38, 'PPL', 'P'),
(65824, 'Hydeland', 35.4263916015625, 0.618307175548133, -76.2200012207031, -1.33028997717537, 218, 33, 'PPL', 'P'),
(41455, 'Hydell', 30.3008308410645, 0.528849264266417, -91.1141662597656, -1.59024219644244, 218, 22, 'PPL', 'P'),
(9636, 'Hyden', 34.1888885498047, 0.596708672791481, -91.3608322143555, -1.5945473295026, 218, 4, 'PPL', 'P'),
(36544, 'Hyden', 37.160831451416, 0.648578861605873, -83.3733291625977, -1.45513910223634, 218, 21, 'PPL', 'P'),
(178404, 'Hyder', 33.0163917541504, 0.57624474323823, -113.34806060791, -1.97829685835812, 218, 5, 'PPL', 'P'),
(193138, 'Hyder', 55.9169387817383, 0.97593468937744, -130.024719238281, -2.26935945968922, 218, 1, 'PPL', 'P'),
(48420, 'Hydes', 39.4838905334473, 0.689123891305675, -76.4936065673828, -1.33506529132599, 218, 25, 'PPL', 'P'),
(136053, 'Hydes Lake', 44.8188896179199, 0.782237190920606, -93.8491668701172, -1.63797696213713, 218, 28, 'PPL', 'P'),
(149793, 'Hydesville', 43.0702781677246, 0.751718163776625, -77.107780456543, -1.34578464787161, 218, 40, 'PPL', 'P'),
(193667, 'Hydesville', 40.547779083252, 0.707692249374035, -124.09610748291, -2.16588566448555, 218, 6, 'PPL', 'P'),
(162951, 'Hydetown', 41.6525001525879, 0.726973269350099, -79.7272186279297, -1.39150246851473, 218, 45, 'PPL', 'P'),
(113585, 'Hydeville', 41.9930610656738, 0.732917178587047, -72.2766723632813, -1.26146590512445, 218, 8, 'PPL', 'P'),
(125132, 'Hydeville', 42.6827812194824, 0.744955066188369, -72.0722198486328, -1.25789753557985, 218, 23, 'PPL', 'P'),
(149791, 'Hydeville', 42.5977783203125, 0.743471485724113, -75.8755569458008, -1.32427829048868, 218, 40, 'PPL', 'P'),
(172142, 'Hydeville', 43.6055603027344, 0.76106059945965, -73.2286071777344, -1.27808030190102, 218, 55, 'PPL', 'P'),
(195121, 'Hydra', 42.6994400024414, 0.745245816800378, -114.518058776855, -1.99871717864852, 218, 17, 'PPL', 'P'),
(103046, 'Hydraulic', 38.0944404602051, 0.664873412735522, -78.4861068725586, -1.3698409819983, 218, 53, 'PPL', 'P'),
(9635, 'Hydrick', 35.4463882446289, 0.618656182808988, -90.7436065673828, -1.58377470973518, 218, 4, 'PPL', 'P'),
(177667, 'Hydril', 36.0127792358398, 0.628541570459253, -120.097503662109, -2.09609686232976, 218, 6, 'PPL', 'P'),
(36545, 'Hydro', 36.9755592346191, 0.645345251410299, -86.1563873291016, -1.50371263051635, 218, 21, 'PPL', 'P'),
(76160, 'Hydro', 35.5494384765625, 0.620454748651173, -98.5777816772461, -1.72050685958008, 218, 42, 'PPL', 'P'),
(88053, 'Hydro', 35.7949981689453, 0.624740573793437, -88.148063659668, -1.53847394011877, 218, 50, 'PPL', 'P'),
(95065, 'Hye', 30.2422199249268, 0.527826310802204, -98.5697174072266, -1.72036611151647, 218, 51, 'PPL', 'P'),
(188713, 'Hyer', 35.2144393920898, 0.614607911635958, -106.118606567383, -1.85211908222931, 218, 38, 'PPL', 'P'),
(109767, 'Hyers', 38.8636093139648, 0.678297941737421, -80.6994400024414, -1.40847093255822, 218, 58, 'PPL', 'P'),
(88054, 'Hygeia Springs', 36.4130592346191, 0.63552777436783, -86.7911071777344, -1.51479058170275, 218, 50, 'PPL', 'P'),
(194248, 'Hygiene', 40.1886100769043, 0.701423567642152, -105.180282592773, -1.83574223942197, 218, 7, 'PPL', 'P'),
(16518, 'Hyhappo (historical)', 30.6166706085205, 0.534361708117259, -84.9916687011719, -1.48338445559966, 218, 12, 'PPL', 'P'),
(72993, 'Hyland', 38.413330078125, 0.670439086518652, -82.5149993896484, -1.44015842163048, 218, 41, 'PPL', 'P'),
(207705, 'Hyland', 48.0272216796875, 0.838233148895748, -122.029441833496, -2.12981554436541, 218, 56, 'PPL', 'P'),
(204436, 'Hyland Lake', 40.6441688537598, 0.709374568234638, -111.859169006348, -1.95231079770556, 218, 52, 'PPL', 'P'),
(103047, 'Hylas', 37.7097206115723, 0.658158784679106, -77.6366729736328, -1.35501556368399, 218, 53, 'PPL', 'P'),
(131420, 'Hylas', 45.957218170166, 0.802104772126761, -87.679443359375, -1.53029497293697, 218, 27, 'PPL', 'P'),
(36546, 'Hylton', 37.2322196960449, 0.649824821521866, -82.5224990844727, -1.44028931599805, 218, 21, 'PPL', 'P'),
(191651, 'Hylton', 32.128059387207, 0.560740418583034, -100.202499389648, -1.74886353307697, 218, 51, 'PPL', 'P'),
(103048, 'Hylton Park', 37.4938888549805, 0.654391809896216, -77.5977783203125, -1.35433672392213, 218, 53, 'PPL', 'P'),
(81704, 'Hyman', 33.9955596923828, 0.593334447690351, -79.5963897705078, -1.3892190741961, 218, 48, 'PPL', 'P'),
(191652, 'Hyman', 32.1380615234375, 0.560914988792489, -101.134719848633, -1.7651338494407, 218, 51, 'PPL', 'P'),
(65825, 'Hymans', 35.1513900756836, 0.613507493473538, -77.1816711425781, -1.34707428362948, 218, 33, 'PPL', 'P'),
(41456, 'Hymel', 30.0447196960449, 0.524379281534774, -90.8466720581055, -1.58557354189347, 218, 22, 'PPL', 'P'),
(32821, 'Hymer', 38.4861106872559, 0.671709347779592, -96.6888885498047, -1.68753945528794, 218, 20, 'PPL', 'P'),
(3311, 'Hymer (historical)', 34.8291702270508, 0.607883696199617, -85.8447189331055, -1.4982729908318, 218, 2, 'PPL', 'P'),
(30132, 'Hymera', 39.1863899230957, 0.683931526128348, -87.3016662597656, -1.52370151871015, 218, 19, 'PPL', 'P'),
(78498, 'Hyndman', 39.8230590820313, 0.695043499197676, -78.7183303833008, -1.37389404686129, 218, 45, 'PPL', 'P'),
(95066, 'Hynds City', 33.9116706848145, 0.591870308302052, -97.7213897705078, -1.70556000112007, 218, 51, 'PPL', 'P'),
(30133, 'Hyndsdale', 39.415828704834, 0.687935988301445, -86.4847183227539, -1.50944308739192, 218, 19, 'PPL', 'P'),
(88055, 'Hyndsver', 36.3702812194824, 0.634781157156227, -88.7675018310547, -1.549285175722, 218, 50, 'PPL', 'P'),
(149792, 'Hyndsville', 42.6855583190918, 0.745003535720208, -74.5619430541992, -1.30135140298029, 218, 40, 'PPL', 'P'),
(162953, 'Hynemansville', 40.5933303833008, 0.70848726953845, -75.7125015258789, -1.32143243654782, 218, 45, 'PPL', 'P'),
(162954, 'Hyner', 41.3316688537598, 0.721373706842099, -77.6444396972656, -1.35515111858347, 218, 45, 'PPL', 'P'),
(162955, 'Hyner View', 41.3263893127441, 0.721281561468382, -77.6241683959961, -1.35479731763266, 218, 45, 'PPL', 'P'),
(195122, 'Hynes', 42.6122207641602, 0.743723553921289, -113.890830993652, -1.98776998867164, 218, 17, 'PPL', 'P'),
(48421, 'Hynesboro', 38.9716682434082, 0.680183925842388, -76.8602828979492, -1.3414650005835, 218, 25, 'PPL', 'P'),
(48422, 'Hynson', 38.7030601501465, 0.675495830217467, -75.8586120605469, -1.32398254644962, 218, 25, 'PPL', 'P'),
(103049, 'Hynson Knolls', 38.7402801513672, 0.676145441786365, -77.4430618286133, -1.35163641173484, 218, 53, 'PPL', 'P'),
(182255, 'Hyperion', 33.9261093139648, 0.592122309920201, -118.431938171387, -2.06702726060905, 218, 6, 'PPL', 'P'),
(16521, 'Hypoluxo', 26.5661106109619, 0.463666099610288, -80.0536117553711, -1.39719910324446, 218, 12, 'PPL', 'P'),
(16519, 'Hypoluxo Village', 26.5758304595947, 0.463835742971726, -80.0938873291016, -1.39790204461419, 218, 12, 'PPL', 'P'),
(3313, 'Hyram', 32.3527793884277, 0.564662522499421, -85.2480621337891, -1.48785936517932, 218, 2, 'PPL', 'P'),
(204437, 'Hyrum', 41.6341705322266, 0.726653357124153, -111.851387023926, -1.95217497648997, 218, 52, 'PPL', 'P'),
(48423, 'Hyser Estates', 39.6961097717285, 0.692827815749757, -77.1972198486328, -1.34734565974456, 218, 25, 'PPL', 'P'),
(196759, 'Hysham', 46.292781829834, 0.807961462838008, -107.233612060547, -1.87157959926284, 218, 31, 'PPL', 'P'),
(145483, 'Hyson', 40.1408309936523, 0.70058966532582, -74.2669372558594, -1.29620258048679, 218, 37, 'PPL', 'P'),
(78500, 'Hyson Hill', 39.795280456543, 0.694558670721227, -76.5688934326172, -1.33637929500783, 218, 45, 'PPL', 'P'),
(3312, 'Hytop', 34.9161109924316, 0.609401098809717, -86.0880584716797, -1.50252006698021, 218, 2, 'PPL', 'P'),
(14004, 'I and I Mobile Home Park', 38.9830589294434, 0.680382730817762, -75.5791702270508, -1.31910536638731, 218, 10, 'PPL', 'P'),
(95067, 'I B Avila Colonia', 26.1480007171631, 0.456368705328334, -98.0559997558594, -1.7114000470745, 218, 51, 'PPL', 'P'),
(196760, 'I-94 Trailer Park', 47.1049995422363, 0.822137336162446, -104.731666564941, -1.82791241265909, 218, 31, 'PPL', 'P'),
(109769, 'Iaeger', 37.4644393920898, 0.653877819805831, -81.8138885498047, -1.42792172905378, 218, 58, 'PPL', 'P'),
(95068, 'Iago', 29.2777805328369, 0.510993667974304, -95.9636077880859, -1.67488091799457, 218, 51, 'PPL', 'P'),
(16520, 'Iamonia', 30.6680603027344, 0.535258627482884, -84.1636123657227, -1.46893214615407, 218, 12, 'PPL', 'P'),
(65826, 'Ian Joy Acres', 35.7866706848145, 0.624595231776946, -80.8488922119141, -1.4110793656879, 218, 33, 'PPL', 'P'),
(55451, 'Iantha', 37.5169410705566, 0.6547941469579, -94.3974990844727, -1.64754716467238, 218, 29, 'PPL', 'P'),
(55452, 'Iatan', 39.4752807617188, 0.688973622441167, -94.9824981689453, -1.65775732481758, 218, 29, 'PPL', 'P'),
(191653, 'Iatan', 32.336669921875, 0.564381359267336, -101.128326416016, -1.76502226299103, 218, 51, 'PPL', 'P'),
(41457, 'Iatt', 31.6861095428467, 0.55302693867027, -92.7063903808594, -1.6180317497852, 218, 22, 'PPL', 'P'),
(204438, 'Ibapah', 40.0366706848145, 0.698771724986705, -113.984443664551, -1.9894038380004, 218, 52, 'PPL', 'P'),
(36547, 'Iberia', 37.3730583190918, 0.652282919208009, -86.1661071777344, -1.50388227387778, 218, 21, 'PPL', 'P'),
(55453, 'Iberia', 38.0902786254883, 0.664800775016791, -92.2925033569336, -1.61080805848641, 218, 29, 'PPL', 'P'),
(136054, 'Iberia', 44.2391700744629, 0.772119176149122, -94.6949996948242, -1.65273952984971, 218, 28, 'PPL', 'P'),
(155828, 'Iberia', 40.670280456543, 0.709830301676177, -82.8436126708984, -1.44589380535407, 218, 41, 'PPL', 'P'),
(103050, 'Iberis', 37.7186088562012, 0.658313913812603, -76.4563903808594, -1.33441574633612, 218, 53, 'PPL', 'P'),
(41459, 'Iberville', 30.2958297729492, 0.52876197916169, -91.1166687011719, -1.59028587228431, 218, 22, 'PPL', 'P'),
(41461, 'Iberville Terrace', 30.3688907623291, 0.530037133981134, -91.0894393920898, -1.58981063118779, 218, 22, 'PPL', 'P'),
(36548, 'Ibex', 38.1761093139648, 0.66629880312996, -83.0736083984375, -1.44990798806515, 218, 21, 'PPL', 'P'),
(192631, 'Ibex', 38.8824996948242, 0.678627641080373, -113.441108703613, -1.97992085399085, 218, 52, 'PPL', 'P'),
(103051, 'Ibex (historical)', 37.0511093139648, 0.646663849045024, -82.4819412231445, -1.43958144778031, 218, 53, 'PPL', 'P'),
(182256, 'Ibis', 34.939998626709, 0.609818016678369, -114.79167175293, -2.00349262595719, 218, 6, 'PPL', 'P'),
(65840, 'Icard', 35.7272186279297, 0.623557597637224, -81.470832824707, -1.42193427713301, 218, 33, 'PPL', 'P'),
(65828, 'Icaria', 36.2558288574219, 0.632783586601586, -76.6275024414063, -1.33740221518253, 218, 33, 'PPL', 'P'),
(116112, 'Icarid (historical)', 40.9952812194824, 0.715502635060964, -94.6872177124023, -1.65260370863411, 218, 16, 'PPL', 'P'),
(36549, 'Ice', 37.1074981689453, 0.647648020225863, -82.8602828979492, -1.44618475570316, 218, 21, 'PPL', 'P'),
(162956, 'Ice Mine', 41.7527809143066, 0.728723498818499, -77.9522171020508, -1.36052284766022, 218, 45, 'PPL', 'P'),
(127798, 'Iceboro', 44.1122207641602, 0.769903492701204, -69.779167175293, -1.21787621650841, 218, 26, 'PPL', 'P'),
(162957, 'Icedale', 40.0669403076172, 0.69930002956795, -75.82861328125, -1.32345896897931, 218, 45, 'PPL', 'P'),
(182257, 'Iceland', 39.375560760498, 0.687233180089773, -120.025001525879, -2.09483146133781, 218, 6, 'PPL', 'P'),
(162958, 'Ickesburg', 40.4558296203613, 0.706087428501153, -77.351936340332, -1.35004597193185, 218, 45, 'PPL', 'P'),
(9637, 'Ico (historical)', 34.4575004577637, 0.601396834995429, -92.3513870239258, -1.61183577235107, 218, 4, 'PPL', 'P'),
(55454, 'Iconium', 38.1058311462402, 0.665072217710897, -93.5444412231445, -1.63265849628218, 218, 29, 'PPL', 'P'),
(76163, 'Iconium', 35.8691711425781, 0.626035136399325, -97.1875, -1.69624186678199, 218, 42, 'PPL', 'P'),
(88056, 'Iconium', 35.7761116027832, 0.624410941029513, -86.0216674804688, -1.50136132558991, 218, 50, 'PPL', 'P'),
(116113, 'Iconium', 40.8913917541504, 0.713689421832784, -92.9550018310547, -1.62237083814926, 218, 16, 'PPL', 'P'),
(9638, 'Ida', 35.5880584716797, 0.621128794723072, -91.9277801513672, -1.60444243769085, 218, 4, 'PPL', 'P'),
(36550, 'Ida', 36.7675018310547, 0.641713964684948, -85.1680603027344, -1.48646306981979, 218, 21, 'PPL', 'P'),
(41462, 'Ida', 33.0041694641113, 0.576031424034915, -93.8947219848633, -1.63877204888057, 218, 22, 'PPL', 'P'),
(95069, 'Ida', 33.5750007629395, 0.585994309672902, -96.4897232055664, -1.68406336427511, 218, 51, 'PPL', 'P'),
(103052, 'Ida', 38.5888900756836, 0.673503186510843, -78.4241714477539, -1.36876000491183, 218, 53, 'PPL', 'P'),
(131421, 'Ida', 41.910831451416, 0.731482001075603, -83.5736083984375, -1.45863463432512, 218, 27, 'PPL', 'P'),
(112483, 'Ida (historical)', 38.5666694641113, 0.6731153636771, -82.4269409179688, -1.43862151136539, 218, 41, 'PPL', 'P'),
(131422, 'Ida Center', 41.8661117553711, 0.730701495139128, -83.5713882446289, -1.45859588533126, 218, 27, 'PPL', 'P'),
(116115, 'Ida Grove', 42.3450012207031, 0.739059693062288, -95.4713897705078, -1.66629009295019, 218, 16, 'PPL', 'P'),
(65829, 'Ida Mill', 34.7997207641602, 0.607369706109232, -79.5308303833008, -1.38807484703374, 218, 33, 'PPL', 'P'),
(22125, 'Ida Vesper', 32.3177795410156, 0.564051659924384, -84.6961135864258, -1.47822604572623, 218, 13, 'PPL', 'P'),
(76164, 'Idabel', 33.8955612182617, 0.591589145069967, -94.8261108398438, -1.65502785101636, 218, 42, 'PPL', 'P'),
(72986, 'Idaho', 39.0880584716797, 0.682215318542873, -83.1419372558594, -1.45110055160129, 218, 41, 'PPL', 'P'),
(88057, 'Idaho', 35.0936088562012, 0.612499020947752, -87.2927780151367, -1.52354638957666, 218, 50, 'PPL', 'P'),
(149794, 'Idaho', 42.8616714477539, 0.74807728967135, -77.5558319091797, -1.35360462093847, 218, 40, 'PPL', 'P'),
(162959, 'Idaho', 40.6536102294922, 0.709539351327086, -79.3472213745117, -1.38487026529405, 218, 45, 'PPL', 'P'),
(195126, 'Idaho', 44.5002784729004, 0.776676377406466, -114.250282287598, -1.99404359725154, 218, 17, 'ADM1', 'A'),
(195123, 'Idaho City', 43.8286094665527, 0.764953541762101, -115.833610534668, -2.02167788830275, 218, 17, 'PPL', 'P'),
(194249, 'Idaho Creek', 40.1222190856934, 0.700264826251858, -105.012496948242, -1.83281382748732, 218, 7, 'PPL', 'P'),
(195125, 'Idaho Falls', 43.4666709899902, 0.758636523656433, -112.033332824707, -1.95535052977378, 218, 17, 'PPL', 'P'),
(186875, 'Idaho Springs', 39.7425003051758, 0.693637483300169, -105.513061523438, -1.84155032744333, 218, 7, 'PPL', 'P'),
(195127, 'Idahome', 42.4155616760254, 0.740291205329367, -113.398887634277, -1.97918395731722, 218, 17, 'PPL', 'P'),
(55455, 'Idalia', 36.8638916015625, 0.643396283545551, -89.8608322143555, -1.56836739072269, 218, 29, 'PPL', 'P'),
(65830, 'Idalia', 35.2799987792969, 0.615752138798311, -76.791389465332, -1.34026258335133, 218, 33, 'PPL', 'P'),
(186876, 'Idalia', 39.7038917541504, 0.692963636965351, -102.293327331543, -1.78535536475573, 218, 7, 'PPL', 'P'),
(191654, 'Idalou', 33.666389465332, 0.587589343428777, -101.682502746582, -1.77469446459603, 218, 51, 'PPL', 'P'),
(162960, 'Idamar', 40.728889465332, 0.710853221850877, -79.003059387207, -1.37886350545538, 218, 45, 'PPL', 'P'),
(36551, 'Idamay', 37.521110534668, 0.654866917834686, -83.7663879394531, -1.46199927204633, 218, 21, 'PPL', 'P'),
(109770, 'Idamay', 39.496940612793, 0.689351658157904, -80.2572174072266, -1.40075269224501, 218, 58, 'PPL', 'P'),
(501, 'Idana', 39.3574981689453, 0.686917928395735, -97.2638931274414, -1.69757517838174, 218, 20, 'PPL', 'P'),
(201012, 'Idanha', 44.7027816772461, 0.780210725068137, -122.077499389648, -2.13065430695073, 218, 43, 'PPL', 'P'),
(88058, 'Idaville', 35.4313888549805, 0.618394394073833, -89.7108306884766, -1.56574937021309, 218, 50, 'PPL', 'P'),
(122854, 'Idaville', 40.7569389343262, 0.711342777438261, -86.6494369506836, -1.51231796978866, 218, 19, 'PPL', 'P'),
(162961, 'Idaville', 40.014720916748, 0.698388629263897, -77.2030563354492, -1.34744752565626, 218, 45, 'PPL', 'P'),
(201013, 'Idaville', 45.5099983215332, 0.794299313287847, -123.864440917969, -2.16184232016054, 218, 43, 'PPL', 'P'),
(16522, 'Iddo', 30.2775001525879, 0.528442066935744, -83.7249984741211, -1.46127688960064, 218, 12, 'PPL', 'P'),
(22126, 'Ideal', 32.3694381713867, 0.564953273111431, -84.1880569458008, -1.46935878456071, 218, 13, 'PPL', 'P'),
(72987, 'Ideal', 39.9799995422363, 0.69778262695785, -81.5327835083008, -1.42301552053558, 218, 41, 'PPL', 'P'),
(120098, 'Ideal', 41.9749984741211, 0.732601926893009, -89.9880599975586, -1.5705879344396, 218, 18, 'PPL', 'P'),
(162962, 'Ideal', 40.6330604553223, 0.70918069010728, -79.0683288574219, -1.38000267261166, 218, 45, 'PPL', 'P'),
(170586, 'Ideal', 43.5433311462402, 0.759974495788089, -99.9211120605469, -1.74395239771076, 218, 49, 'PPL', 'P'),
(88059, 'Ideal Valley', 35.6961097717285, 0.623014645669984, -84.8794403076172, -1.48142570061791, 218, 50, 'PPL', 'P'),
(14005, 'Idela', 39.7249984741211, 0.693332018723137, -75.5902786254883, -1.31929924451466, 218, 10, 'PPL', 'P'),
(145484, 'Idell', 40.4583282470703, 0.706131037764003, -75.0283279418945, -1.30949135485212, 218, 37, 'PPL', 'P'),
(3314, 'Ider', 34.714168548584, 0.605876538265052, -85.6808319091797, -1.495412622663, 218, 2, 'PPL', 'P'),
(162963, 'Idetown', 41.3469390869141, 0.721640222688188, -76.0255584716797, -1.32689631099828, 218, 45, 'PPL', 'P'),
(136057, 'Idington', 47.7333297729492, 0.833103767478201, -92.6516723632813, -1.61707674021829, 218, 28, 'PPL', 'P'),
(211884, 'Iditarod', 62.5444412231445, 1.09160642816394, -158.095275878906, -2.75928309593569, 218, 1, 'PPL', 'P'),
(36553, 'Idle Hour', 38.0224990844727, 0.663617798860577, -84.4594421386719, -1.47409534971747, 218, 21, 'PPL', 'P'),
(88060, 'Idle Oaks', 35.8138885498047, 0.625070273136389, -84.5972213745117, -1.47650005102375, 218, 50, 'PPL', 'P'),
(186877, 'Idledale', 39.6661109924316, 0.692304238279448, -105.243606567383, -1.83684745127436, 218, 7, 'PPL', 'P'),
(162964, 'Idlepark', 40.2605590820313, 0.702679314675151, -79.2797164916992, -1.3836920828278, 218, 45, 'PPL', 'P'),
(125133, 'Idlewell', 42.2305603027344, 0.737062322244728, -70.9555587768555, -1.23840812324849, 218, 23, 'PPL', 'P'),
(36552, 'Idlewild', 39.0774993896484, 0.68203102779544, -84.7949981689453, -1.47995190727066, 218, 21, 'PPL', 'P'),
(41464, 'Idlewild', 29.641939163208, 0.517349435073833, -90.7574996948242, -1.58401719055243, 218, 22, 'PPL', 'P'),
(55457, 'Idlewild', 37.0036087036133, 0.645834806997682, -90.103889465332, -1.57260954002308, 218, 29, 'PPL', 'P'),
(65833, 'Idlewild', 35.1886100769043, 0.614157105042435, -80.7441711425781, -1.40925163823178, 218, 33, 'PPL', 'P'),
(81705, 'Idlewild', 34.7330589294434, 0.606206237608004, -82.3625030517578, -1.43749685843705, 218, 48, 'PPL', 'P'),
(88063, 'Idlewild', 35.4811096191406, 0.619262185115035, -84.7038879394531, -1.47836173378377, 218, 50, 'PPL', 'P'),
(120099, 'Idlewild', 42.3530616760254, 0.739200374546871, -87.9927825927734, -1.53576377423545, 218, 18, 'PPL', 'P'),
(131424, 'Idlewild', 43.8869400024414, 0.765971601667811, -85.8024978637695, -1.49753609415818, 218, 27, 'PPL', 'P'),
(155829, 'Idlewild', 40.5508308410645, 0.707745512595836, -84.4938888549805, -1.47469655833355, 218, 41, 'PPL', 'P'),
(174618, 'Idlewild', 44.8883285522461, 0.783449128953674, -87.4272232055664, -1.52589290081313, 218, 57, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(188714, 'Idlewild', 36.5494384765625, 0.637908041171116, -105.304718017578, -1.83791404729093, 218, 38, 'PPL', 'P'),
(193668, 'Idlewild', 41.898609161377, 0.731268681872288, -123.77082824707, -2.16020847083178, 218, 6, 'PPL', 'P'),
(190329, 'Idlewild (historical)', 39.0108299255371, 0.680867426136157, -117.614440917969, -2.0527592419109, 218, 39, 'PPL', 'P'),
(155830, 'Idlewild Park (historical)', 40.0255584716797, 0.69857778028032, -82.4358291625977, -1.43877664049889, 218, 41, 'PPL', 'P'),
(65835, 'Idlewild Terrace Apartments', 35.2808303833008, 0.615766653026252, -81.5374984741211, -1.42309781221327, 218, 33, 'PPL', 'P'),
(204440, 'Idlewild Townsite', 41.2538909912109, 0.720016227055458, -111.855827331543, -1.95225247447769, 218, 52, 'PPL', 'P'),
(48425, 'Idlewilde', 38.8499984741211, 0.678060387768186, -76.4963912963867, -1.33511389401588, 218, 25, 'PPL', 'P'),
(103053, 'Idlewilde', 37.753059387207, 0.658915189007716, -79.98388671875, -1.39598217178435, 218, 53, 'PPL', 'P'),
(143991, 'Idlewilde', 45.1513900756836, 0.78804041867297, -71.179443359375, -1.24231564635791, 218, 36, 'PPL', 'P'),
(196761, 'Idlewile (historical)', 48.0441703796387, 0.838528959513829, -106.429718017578, -1.85754900137587, 218, 31, 'PPL', 'P'),
(196762, 'Idlewise Court', 48.0227813720703, 0.838155650908027, -114.066673278809, -1.99083901551185, 218, 31, 'PPL', 'P'),
(30135, 'Idlewold', 39.9861106872559, 0.697889286559507, -85.7527770996094, -1.49666830311698, 218, 19, 'PPL', 'P'),
(22130, 'Idlewood', 33.3836097717285, 0.582653906717615, -83.8525009155273, -1.46350222700751, 218, 13, 'PPL', 'P'),
(27501, 'Idlewood', 38.3802795410156, 0.669862245826541, -88.9227828979492, -1.55199534160532, 218, 18, 'PPL', 'P'),
(48426, 'Idlewood', 39.3699989318848, 0.68713610786804, -76.5894393920898, -1.33673788964861, 218, 25, 'PPL', 'P'),
(72989, 'Idlewood', 39.148609161377, 0.683272127442444, -84.4741668701172, -1.47435234476266, 218, 41, 'PPL', 'P'),
(81707, 'Idlewood', 33.9266700744629, 0.592132097037207, -80.3986129760742, -1.40322051046913, 218, 48, 'PPL', 'P'),
(103055, 'Idlewood', 36.7797203063965, 0.641927217309236, -76.6444396972656, -1.33769782606353, 218, 53, 'PPL', 'P'),
(125135, 'Idlewood', 41.6361083984375, 0.726687179269997, -70.9805603027344, -1.2388444821931, 218, 23, 'PPL', 'P'),
(162966, 'Idlewood', 40.1644401550293, 0.701001722925483, -74.9480590820313, -1.30809039896068, 218, 45, 'PPL', 'P'),
(22132, 'Idlewood Acres', 32.5705604553223, 0.568463519165237, -83.6383285522461, -1.45976421410148, 218, 13, 'PPL', 'P'),
(48427, 'Idlewood Acres', 38.3144416809082, 0.668713158395199, -76.8863906860352, -1.34192066744602, 218, 25, 'PPL', 'P'),
(88066, 'Idlewood Acres', 36.0288887023926, 0.628822733691338, -84.0077819824219, -1.46621239289083, 218, 50, 'PPL', 'P'),
(174619, 'Idlewood Beach', 43.601390838623, 0.760987828582864, -87.7652816772461, -1.5317931342082, 218, 57, 'PPL', 'P'),
(155831, 'Idlewood Cottage Area', 40.6436080932617, 0.709364781117632, -82.3261108398438, -1.43686169451707, 218, 41, 'PPL', 'P'),
(48428, 'Idlewood Trailer Park', 38.6344413757324, 0.674298206675258, -76.8786087036133, -1.34178484623042, 218, 25, 'PPL', 'P'),
(22133, 'Idlewood Vally', 33.9049987792969, 0.591753861583389, -84.4049987792969, -1.47314513384053, 218, 13, 'PPL', 'P'),
(48429, 'Idlewylde', 39.3752784729004, 0.687228253241757, -76.5899963378906, -1.33674761018659, 218, 25, 'PPL', 'P'),
(201014, 'Idleyld Park', 43.3238906860352, 0.756144537245418, -123.02278137207, -2.14715258990377, 218, 43, 'PPL', 'P'),
(195128, 'Idmon', 44.3608283996582, 0.774242514486243, -111.910827636719, -1.95321241089261, 218, 17, 'PPL', 'P'),
(88067, 'Idol', 36.3666687011719, 0.634718106817419, -83.4016723632813, -1.45563378440882, 218, 50, 'PPL', 'P'),
(182261, 'Idria', 36.4169387817383, 0.635595485238546, -120.673332214355, -2.10614696649344, 218, 6, 'PPL', 'P'),
(174620, 'Iduna', 44.1986083984375, 0.771411241352352, -91.3125, -1.59370377322732, 218, 57, 'PPL', 'P'),
(95070, 'Idyle Hour Acres', 30.4261093139648, 0.5310357861004, -97.6747207641602, -1.70474547330067, 218, 51, 'PPL', 'P'),
(182260, 'Idyllwild', 33.7400016784668, 0.588874118917659, -116.718063354492, -2.03711450208723, 218, 6, 'PPL', 'P'),
(120100, 'Idylside', 41.5188903808594, 0.724641338920599, -88.121940612793, -1.53801800694015, 218, 18, 'PPL', 'P'),
(125134, 'Idylwide', 42.4330596923828, 0.740596603327372, -71.2525024414063, -1.24359076788784, 218, 23, 'PPL', 'P'),
(16523, 'Idylwild', 29.6175003051758, 0.516922896535743, -82.3486099243164, -1.4372543776198, 218, 12, 'PPL', 'P'),
(22134, 'Idylwilde', 33.5222206115723, 0.585073122251843, -82.1333312988281, -1.43349705679586, 218, 13, 'PPL', 'P'),
(194250, 'Idylwilde', 40.7008285522461, 0.710363466526411, -105.654167175293, -1.84401308566138, 218, 7, 'PPL', 'P'),
(22135, 'Idylwood', 33.874439239502, 0.591220496996073, -83.3144378662109, -1.45411125521362, 218, 13, 'PPL', 'P'),
(103056, 'Idylwood', 38.8950004577637, 0.678845820552678, -77.2119369506836, -1.3476025216317, 218, 53, 'PPL', 'P'),
(78501, 'Idywyld', 39.9905586242676, 0.697966917705283, -76.6866683959961, -1.33843485589521, 218, 45, 'PPL', 'P'),
(149795, 'Igerna', 43.7241706848145, 0.763130741153996, -73.92138671875, -1.29017158588219, 218, 40, 'PPL', 'P'),
(193669, 'Igerna', 41.401668548584, 0.722595431992172, -122.378326416016, -2.13590472903982, 218, 6, 'PPL', 'P'),
(211885, 'Igiak', 61.6175003051758, 1.07542825717393, -165.933609008789, -2.89608781692029, 218, 1, 'PPL', 'P'),
(211886, 'Igiugig', 59.3277816772461, 1.03546512817231, -155.894714355469, -2.720876051959, 218, 1, 'PPL', 'P'),
(48430, 'Iglehart', 39.0116691589355, 0.680882073522152, -76.5677795410156, -1.33635985393188, 218, 25, 'PPL', 'P'),
(95071, 'Iglehart', 30.2586097717285, 0.528112367592792, -97.706672668457, -1.70530313923293, 218, 51, 'PPL', 'P'),
(202237, 'Igloo', 43.2024993896484, 0.754025859440206, -103.856391906738, -1.81263598801417, 218, 49, 'PPL', 'P'),
(211887, 'Igloo', 65.1477813720703, 1.13704328531206, -165.063323974609, -2.88089847764303, 218, 1, 'PPL', 'P'),
(182262, 'Ignacio', 38.0702781677246, 0.664451701176908, -122.537498474121, -2.13868280553094, 218, 6, 'PPL', 'P'),
(186878, 'Ignacio', 37.1150016784668, 0.647778981172467, -107.632499694824, -1.87854150182647, 218, 7, 'PPL', 'P'),
(26, 'Ignacio Perez Colonia', 26.17799949646, 0.456892282798644, -98.109001159668, -1.71232509607914, 218, 51, 'PPL', 'P'),
(193670, 'Igo', 40.5055618286133, 0.706955419279437, -122.540557861328, -2.1387362019108, 218, 6, 'PPL', 'P'),
(22136, 'Igo (historical)', 34.482780456543, 0.601838054209028, -84.706672668457, -1.47841033647367, 218, 13, 'PPL', 'P'),
(201015, 'Igo (historical)', 45.2522201538086, 0.789800235521295, -120.279167175293, -2.09926748876555, 218, 43, 'PPL', 'P'),
(211888, 'Igushik', 58.7102813720703, 1.02468771471492, -158.889999389648, -2.77315363784115, 218, 1, 'PPL', 'P'),
(136059, 'Ihlen', 43.9072189331055, 0.766325535776682, -96.366943359375, -1.68192045170398, 218, 28, 'PPL', 'P'),
(60368, 'Ihrie (historical)', 31.7783298492432, 0.554636486654086, -91.2180633544922, -1.59205554282867, 218, 30, 'PPL', 'P'),
(65839, 'Ijames Crossroads', 35.9352798461914, 0.627188950941602, -80.6427764892578, -1.40748196768742, 218, 33, 'PPL', 'P'),
(48431, 'Ijamsville', 39.360279083252, 0.686966464506602, -77.3230590820313, -1.34954196869555, 218, 25, 'PPL', 'P'),
(122855, 'Ijamsville', 40.9597206115723, 0.714881985368921, -85.8327789306641, -1.49806459847651, 218, 19, 'PPL', 'P'),
(48432, 'Ijamsville Heights', 39.3530616760254, 0.686840496987041, -77.3208312988281, -1.34950308654363, 218, 25, 'PPL', 'P'),
(211889, 'Ikatan', 54.75, 0.955567765466895, -163.308334350586, -2.85026813036548, 218, 1, 'PPL', 'P'),
(112581, 'Ike', 32.4036102294922, 0.565549688037554, -96.7699966430664, -1.68895505856537, 218, 51, 'PPL', 'P'),
(169430, 'Ike Shippee Corner', 41.6430587768555, 0.726808486257651, -71.5152816772461, -1.24817713075912, 218, 47, 'PPL', 'P'),
(41466, 'Ikes', 30.8738899230957, 0.538851032056319, -93.2174987792969, -1.62695227417253, 218, 22, 'PPL', 'P'),
(109771, 'Ikes Fork', 37.5219383239746, 0.6548813654836, -81.804443359375, -1.4277568793823, 218, 58, 'PPL', 'P'),
(22137, 'Ila', 34.1725006103516, 0.596422649290407, -83.2922210693359, -1.4537234989589, 218, 13, 'PPL', 'P'),
(55458, 'Ilasco', 39.6713905334473, 0.692396383653164, -91.3105621337891, -1.59366995108148, 218, 29, 'PPL', 'P'),
(48433, 'Ilchester', 39.2508316040039, 0.685056245635715, -76.7649993896484, -1.3398019896408, 218, 25, 'PPL', 'P'),
(16524, 'Ilcombe (historical)', 30.1333293914795, 0.525925812469296, -83.9000015258789, -1.46433126905485, 218, 12, 'PPL', 'P'),
(103057, 'Ilda', 38.8380584716797, 0.677851995412887, -77.2516708374023, -1.34829600877956, 218, 53, 'PPL', 'P'),
(30136, 'Ilene', 38.9375, 0.679587577495292, -87.1125030517578, -1.52039999790678, 218, 19, 'PPL', 'P'),
(155832, 'Iler', 41.185001373291, 0.718813876402314, -83.3194427490234, -1.45419860689737, 218, 41, 'PPL', 'P'),
(27502, 'Iles', 39.7713890075684, 0.694141686273548, -89.6536102294922, -1.56475068480431, 218, 18, 'PPL', 'P'),
(194251, 'Iles Grove', 40.3352813720703, 0.703983464660963, -107.686668395996, -1.87948692401345, 218, 7, 'PPL', 'P'),
(72991, 'Ilesboro', 39.4347190856934, 0.688265687644397, -82.4533309936523, -1.43908210507592, 218, 41, 'PPL', 'P'),
(16525, 'Ilexhurst', 27.4902801513672, 0.479795900937003, -82.7074966430664, -1.44351813250367, 218, 12, 'PPL', 'P'),
(188716, 'Ilfeld', 35.4211082458496, 0.618214963595389, -105.558326721191, -1.8423403541807, 218, 38, 'PPL', 'P'),
(88068, 'Ilford', 36.4958305358887, 0.636972406101144, -84.0633316040039, -1.46718191668567, 218, 50, 'PPL', 'P'),
(139226, 'Ilia (historical)', 40.5305595397949, 0.707391711645019, -93.4502792358398, -1.6310150595735, 218, 29, 'PPL', 'P'),
(196763, 'Iliad', 47.7986106872559, 0.834243134371564, -109.785278320313, -1.9161145769078, 218, 31, 'PPL', 'P'),
(194252, 'Iliff', 40.7591705322266, 0.711381726169203, -103.066108703613, -1.79884294409644, 218, 7, 'PPL', 'P'),
(149796, 'Ilion', 43.0149993896484, 0.750753367092716, -75.0358276367188, -1.3096222492197, 218, 40, 'PPL', 'P'),
(186879, 'Ilium', 37.9297218322754, 0.661998530338782, -107.897216796875, -1.8831616868436, 218, 7, 'PPL', 'P'),
(201016, 'Illahe', 42.6288909912109, 0.74401450427038, -124.05638885498, -2.16519244365381, 218, 43, 'PPL', 'P'),
(207706, 'Illahee', 47.6130599975586, 0.831004663907001, -122.595558166504, -2.13969613832572, 218, 56, 'PPL', 'P'),
(136061, 'Illgen City', 47.3469390869141, 0.826359977807848, -91.1894378662109, -1.59155593380817, 218, 28, 'PPL', 'P'),
(207707, 'Illia', 46.6761093139648, 0.814651789549478, -117.503326416016, -2.0508199280051, 218, 56, 'PPL', 'P'),
(120101, 'Illiana', 40.1963882446289, 0.701559322278718, -87.5319366455078, -1.52772049511119, 218, 18, 'PPL', 'P'),
(27503, 'Illiana (historical)', 39.8036117553711, 0.694704079316745, -87.533332824707, -1.52774486303517, 218, 18, 'PPL', 'P'),
(120102, 'Illiana Heights', 41.1688919067383, 0.718532713170229, -87.5430603027344, -1.52791463955466, 218, 18, 'PPL', 'P'),
(122856, 'Illinoi', 41.1897201538086, 0.718896234659025, -87.5261077880859, -1.52761876235755, 218, 19, 'PPL', 'P'),
(120105, 'Illinois', 40.0002784729004, 0.698136561066721, -89.2502822875977, -1.55771128425296, 218, 18, 'ADM1', 'A'),
(95073, 'Illinois Bend', 33.8816719055176, 0.591346730831743, -97.4869384765625, -1.70146805410516, 218, 51, 'PPL', 'P'),
(188717, 'Illinois Camp', 32.7094383239746, 0.570887395231373, -104.212501525879, -1.8188512733662, 218, 38, 'PPL', 'P'),
(120103, 'Illinois City', 41.3974990844727, 0.722522661115386, -90.8994369506836, -1.58649446299842, 218, 18, 'PPL', 'P'),
(116116, 'Illinois Grove', 42.1908302307129, 0.736368901675899, -93.2233276367188, -1.62705400692617, 218, 16, 'PPL', 'P'),
(95074, 'Illinois Heights Colonia', 25.9370002746582, 0.452686052883459, -97.4150009155273, -1.70021250680924, 218, 51, 'PPL', 'P'),
(41467, 'Illinois Plant', 30.0391693115234, 0.524282409050122, -92.9113922119141, -1.62160970670972, 218, 22, 'PPL', 'P'),
(182263, 'Illinoistown (historical)', 39.0883293151855, 0.682220045653808, -120.955558776855, -2.11107274924565, 218, 6, 'PPL', 'P'),
(27505, 'Illiopolis', 39.8536109924316, 0.695576730626937, -89.241943359375, -1.55756574249938, 218, 18, 'PPL', 'P'),
(190330, 'Illipah (historical)', 39.3574981689453, 0.686917928395735, -115.331108093262, -2.0129075662009, 218, 39, 'PPL', 'P'),
(55459, 'Illmo', 37.2197189331055, 0.649606642049562, -89.5088882446289, -1.56222480966842, 218, 29, 'PPL', 'P'),
(116117, 'Illyria', 42.898609161377, 0.748721974392231, -91.6350021362305, -1.59933249734926, 218, 16, 'PPL', 'P'),
(182264, 'Ilmon', 35.3125, 0.616319392110498, -118.693061828613, -2.0715847281825, 218, 6, 'PPL', 'P'),
(195129, 'Ilo (historical)', 46.2383308410645, 0.807011113803014, -116.496673583984, -2.03325052166163, 218, 17, 'PPL', 'P'),
(36554, 'Ilsley', 37.1966705322266, 0.649204371566905, -87.6122207641602, -1.52912171731874, 218, 21, 'PPL', 'P'),
(207708, 'Ilwaco', 46.3091697692871, 0.808247486339083, -124.041938781738, -2.16494024229858, 218, 56, 'PPL', 'P'),
(207709, 'Image', 45.6091690063477, 0.796030168259317, -122.580833435059, -2.13943914328052, 218, 56, 'PPL', 'P'),
(174621, 'Imalone', 45.5522193908691, 0.795036209961472, -91.2272186279297, -1.59221533249408, 218, 57, 'PPL', 'P'),
(201017, 'Imbler', 45.4597206115723, 0.793421801708666, -117.961112976074, -2.0588098107495, 218, 43, 'PPL', 'P'),
(9641, 'Imboden', 36.2024993896484, 0.631852811800603, -91.1744384765625, -1.59129414507302, 218, 4, 'PPL', 'P'),
(103058, 'Imboden', 36.8866691589355, 0.643793826917273, -82.8047180175781, -1.44521496559221, 218, 53, 'PPL', 'P'),
(27507, 'Imbs', 38.523609161377, 0.672363819617479, -90.1352767944336, -1.57315735225931, 218, 18, 'PPL', 'P'),
(9642, 'Imelda (historical)', 34.4083290100098, 0.600538631334151, -93.4158325195313, -1.63041385095741, 218, 4, 'PPL', 'P'),
(32825, 'Imes', 38.5736083984375, 0.673236470927671, -95.1580581665039, -1.66082142480977, 218, 20, 'PPL', 'P'),
(182265, 'Imhoff', 36.2144393920898, 0.632061204155902, -119.330001831055, -2.08270142836277, 218, 6, 'PPL', 'P'),
(22143, 'Imlac', 33.0244407653809, 0.576385224985732, -84.5627822875977, -1.47589897556572, 218, 13, 'PPL', 'P'),
(200006, 'Imlay', 40.660831451416, 0.709665385425674, -118.149436950684, -2.06209668416688, 218, 39, 'PPL', 'P'),
(202238, 'Imlay', 43.7194404602051, 0.763048183160204, -102.396942138672, -1.78716378429395, 218, 49, 'PPL', 'P'),
(131425, 'Imlay City', 43.0247192382813, 0.750923010454155, -83.0777816772461, -1.44998082552096, 218, 27, 'PPL', 'P'),
(145485, 'Imlaystown', 40.1674995422363, 0.701055119305339, -74.5155563354492, -1.30054180200891, 218, 37, 'PPL', 'P'),
(162968, 'Imler', 40.2066688537598, 0.701738752757162, -78.523063659668, -1.37048599961431, 218, 45, 'PPL', 'P'),
(162967, 'Imlertown', 40.0922203063965, 0.699741248781548, -78.4697189331055, -1.36955495849722, 218, 45, 'PPL', 'P'),
(41468, 'Immaculata', 30.7247200012207, 0.536247525774658, -91.970832824707, -1.60519384859241, 218, 22, 'PPL', 'P'),
(9643, 'Immanuel', 34.401668548584, 0.600422384352569, -91.3225021362305, -1.59387834343678, 218, 4, 'PPL', 'P'),
(65842, 'Immer', 35.4822196960449, 0.619281559611966, -79.929443359375, -1.39503195590741, 218, 33, 'PPL', 'P'),
(155833, 'Immergrun', 41.6891708374023, 0.727613293539072, -83.4222183227539, -1.4559923790496, 218, 41, 'PPL', 'P'),
(16526, 'Immokalee', 26.4183292388916, 0.461086828094546, -81.4175033569336, -1.42100350233203, 218, 12, 'PPL', 'P'),
(201018, 'Imnaha', 45.559440612793, 0.79516224406006, -116.832221984863, -2.03910694605677, 218, 43, 'PPL', 'P'),
(201020, 'Imnaha River Woods Development', 45.2599983215332, 0.789935990157862, -116.800827026367, -2.03855900066249, 218, 43, 'PPL', 'P'),
(127799, 'Imnarkuan (historical)', 44.9536094665527, 0.784588495847037, -67.1624984741211, -1.17220673223908, 218, 26, 'PPL', 'P'),
(9644, 'Imo', 35.7786102294922, 0.624454550292363, -92.7505569458008, -1.61880260176272, 218, 4, 'PPL', 'P'),
(76166, 'Imo', 36.353889465332, 0.634495067076125, -97.9775009155273, -1.71002998385171, 218, 42, 'PPL', 'P'),
(116119, 'Imogene', 40.8794403076172, 0.713480829740404, -95.4266662597656, -1.66550952043469, 218, 16, 'PPL', 'P'),
(136062, 'Imogene', 43.6602783203125, 0.762015609026553, -94.3452835083008, -1.64663583094736, 218, 28, 'PPL', 'P'),
(202240, 'Imogene', 45.1405601501465, 0.787851400814602, -102.712501525879, -1.79267133458629, 218, 49, 'PPL', 'P'),
(182266, 'Imola', 38.2786102294922, 0.668087781592221, -122.279441833496, -2.1341788674954, 218, 6, 'PPL', 'P'),
(207710, 'Impach', 48.288330078125, 0.842790350153092, -118.235557556152, -2.06359977228612, 218, 56, 'PPL', 'P'),
(95075, 'Impact', 32.4997215270996, 0.567227146629168, -99.7455596923828, -1.74088843087662, 218, 51, 'PPL', 'P'),
(22138, 'Imperial', 33.3438911437988, 0.581960685885868, -83.4049987792969, -1.45569184132058, 218, 13, 'PPL', 'P'),
(55460, 'Imperial', 38.3697204589844, 0.669677955079107, -90.3783264160156, -1.57739936840164, 218, 29, 'PPL', 'P'),
(109772, 'Imperial', 38.8624992370605, 0.678278567240491, -80.2044372558594, -1.39983150482395, 218, 58, 'PPL', 'P'),
(162969, 'Imperial', 40.4494400024414, 0.705975908630506, -80.2447204589844, -1.40053457935173, 218, 45, 'PPL', 'P'),
(182267, 'Imperial', 32.8474998474121, 0.573297023385676, -115.56861114502, -2.0170527764376, 218, 6, 'PPL', 'P'),
(191655, 'Imperial', 31.2727794647217, 0.545812967909463, -102.692222595215, -1.79231740047742, 218, 51, 'PPL', 'P'),
(199419, 'Imperial', 40.5169410705566, 0.707154024517729, -101.642776489258, -1.77400111060623, 218, 35, 'PPL', 'P'),
(103059, 'Imperial (historical)', 36.8416709899902, 0.643008460711809, -83.0208282470703, -1.44898680064409, 218, 53, 'PPL', 'P'),
(201019, 'Imperial (historical)', 43.7472190856934, 0.763533011636652, -120.441673278809, -2.10210375532648, 218, 43, 'PPL', 'P'),
(182268, 'Imperial Beach', 32.5838890075684, 0.568696146286455, -117.11222076416, -2.04399384665706, 218, 6, 'PPL', 'P'),
(199420, 'Imperial Capitol Mobile Court', 40.5233306884766, 0.707265544388377, -101.636672973633, -1.77389458416263, 218, 35, 'PPL', 'P'),
(191656, 'Imperial Colonia', 31.2719993591309, 0.54579935249839, -102.696998596191, -1.79240075741953, 218, 51, 'PPL', 'P'),
(22139, 'Imperial Estates', 33.6699981689453, 0.587652327188558, -84.8122177124023, -1.48025244499967, 218, 13, 'PPL', 'P'),
(88069, 'Imperial Estates', 35.9894409179688, 0.628134239970525, -84.0963897705078, -1.46775889053584, 218, 50, 'PPL', 'P'),
(109773, 'Imperial Estates', 38.4122200012207, 0.670419712021722, -82.045280456543, -1.43196027968883, 218, 58, 'PPL', 'P'),
(48434, 'Imperial Gardens', 39.3758316040039, 0.687237907200708, -76.7777786254883, -1.3400250293821, 218, 25, 'PPL', 'P'),
(88070, 'Imperial Group Subdivision', 35.2055587768555, 0.614452915660516, -84.9875030517578, -1.4833117513019, 218, 50, 'PPL', 'P'),
(131428, 'Imperial Heights', 46.5336112976074, 0.81216472998648, -88.1311111450195, -1.53817806292166, 218, 27, 'PPL', 'P'),
(30137, 'Imperial Hills', 39.6316719055176, 0.691703162821417, -86.1416702270508, -1.50345576862921, 218, 19, 'PPL', 'P'),
(178405, 'Imperial Mobile Home Park', 33.413330078125, 0.583172623918935, -111.775001525879, -1.95084179804827, 218, 5, 'PPL', 'P'),
(16527, 'Imperial Point', 26.1986103057861, 0.457252009282886, -80.1188888549805, -1.3983384035588, 218, 12, 'PPL', 'P'),
(60369, 'Improve', 31.3427791595459, 0.547034693059537, -89.7002792358398, -1.56556521262371, 218, 30, 'PPL', 'P'),
(88071, 'In-A-Vale-Estates', 36.0094413757324, 0.628483313810407, -86.7369384765625, -1.51384515951577, 218, 50, 'PPL', 'P'),
(27508, 'Ina', 38.1511116027832, 0.665862510764378, -88.9038925170898, -1.55166564226237, 218, 18, 'PPL', 'P'),
(131429, 'Ina', 44.1169395446777, 0.769985850957915, -85.2866668701172, -1.48853314493511, 218, 27, 'PPL', 'P'),
(88072, 'Ina (historical)', 35.2958297729492, 0.616028441761406, -89.2180633544922, -1.55714895778879, 218, 50, 'PPL', 'P'),
(81708, 'Inabinetts (historical)', 33.110279083252, 0.577883386256956, -80.3430633544922, -1.40225098667429, 218, 48, 'PPL', 'P'),
(191657, 'Inadale', 32.540828704834, 0.567944602226835, -100.682777404785, -1.75724596576605, 218, 51, 'PPL', 'P'),
(22140, 'Inaha', 31.6186103820801, 0.55184885607256, -83.6061096191406, -1.45920188763731, 218, 13, 'PPL', 'P'),
(95077, 'Inari', 28.5138893127441, 0.497661251056608, -97.0538864135742, -1.69390986977346, 218, 51, 'PPL', 'P'),
(142109, 'Inavale', 40.0913887023926, 0.699726734553608, -98.649169921875, -1.72175281949608, 218, 35, 'PPL', 'P'),
(149797, 'Inavale', 42.1405601501465, 0.735491523254772, -78.0891723632813, -1.36291316789662, 218, 40, 'PPL', 'P'),
(182272, 'Inca', 33.8008308410645, 0.589935788086219, -114.765556335449, -2.00303682593663, 218, 6, 'PPL', 'P'),
(188718, 'Inca', 36.8927803039551, 0.643900486518931, -107.926666259766, -1.88367567693398, 218, 38, 'PPL', 'P'),
(182273, 'Inceville', 34.038330078125, 0.5940809317439, -118.554443359375, -2.06916537949022, 218, 6, 'PPL', 'P'),
(207711, 'Inchelium', 48.2969398498535, 0.8429406190176, -118.195556640625, -2.06290162460635, 218, 56, 'PPL', 'P'),
(3319, 'Incline', 34.5258293151855, 0.602589398531567, -86.540283203125, -1.51041287750288, 218, 2, 'PPL', 'P'),
(182274, 'Incline', 37.6605606079102, 0.65730078075491, -119.851669311523, -2.09180624349753, 218, 6, 'PPL', 'P'),
(190331, 'Incline Village', 39.2513885498047, 0.685065966173694, -119.971939086914, -2.09390534706873, 218, 39, 'PPL', 'P'),
(60370, 'Increase', 32.2569389343262, 0.562989791018743, -88.5588912963867, -1.5456442350377, 218, 30, 'PPL', 'P'),
(182275, 'Indak (historical)', 38.7291717529297, 0.675951563659007, -120.800003051758, -2.10835778967237, 218, 6, 'PPL', 'P'),
(3320, 'Independence', 32.5230598449707, 0.567634477117895, -86.7013931274414, -1.51322477613984, 218, 2, 'PPL', 'P'),
(27509, 'Independence', 39.5313911437988, 0.689952933353017, -90.791389465332, -1.58460867863054, 218, 18, 'PPL', 'P'),
(32826, 'Independence', 37.2241706848145, 0.649684339774365, -95.7080612182617, -1.67042078895896, 218, 20, 'PPL', 'P'),
(36556, 'Independence', 38.9430618286133, 0.679684649717025, -84.5441665649414, -1.47557406991273, 218, 21, 'PPL', 'P'),
(41469, 'Independence', 30.6352806091309, 0.534686513901708, -90.5008316040039, -1.57953748728281, 218, 22, 'PPL', 'P'),
(55461, 'Independence', 39.0911102294922, 0.682268581764675, -94.415283203125, -1.64785755609743, 218, 29, 'PPL', 'P'),
(60372, 'Independence', 34.7050018310547, 0.605716548862565, -89.8088912963867, -1.56746085068763, 218, 30, 'PPL', 'P'),
(76172, 'Independence', 35.7249984741211, 0.623518848643363, -98.9333267211914, -1.72671229123608, 218, 42, 'PPL', 'P'),
(88075, 'Independence', 35.7277793884277, 0.62356738475423, -88.5858306884766, -1.54611441612815, 218, 50, 'PPL', 'P'),
(95078, 'Independence', 30.3191699981689, 0.529169342939931, -96.3463897705078, -1.68156172390515, 218, 51, 'PPL', 'P'),
(109778, 'Independence', 38.3125, 0.668679269670328, -81.1766662597656, -1.4168001020255, 218, 58, 'PPL', 'P'),
(112616, 'Independence', 36.6222190856934, 0.639178302432057, -81.1511077880859, -1.41635402254291, 218, 53, 'PPL', 'P'),
(116120, 'Independence', 42.4686088562012, 0.741217053282334, -91.8891677856445, -1.603768524777, 218, 16, 'PPL', 'P'),
(122857, 'Independence', 40.3375015258789, 0.704022213654824, -87.1688919067383, -1.52138416908762, 218, 19, 'PPL', 'P'),
(136064, 'Independence', 46.9583282470703, 0.819577439143634, -92.4602813720703, -1.61373633726301, 218, 28, 'PPL', 'P'),
(140271, 'Independence', 46.3411102294922, 0.808804952534264, -98.1936111450195, -1.71380181890359, 218, 34, 'PPL', 'P'),
(149798, 'Independence', 42.0880584716797, 0.734575196102703, -77.7816696166992, -1.35754623250984, 218, 40, 'PPL', 'P'),
(155835, 'Independence', 41.297779083252, 0.720782218763992, -84.3000030517578, -1.47131261269444, 218, 41, 'PPL', 'P'),
(162972, 'Independence', 40.2538909912109, 0.702562934535515, -80.5077819824219, -1.40512586907103, 218, 45, 'PPL', 'P'),
(174622, 'Independence', 44.3569412231445, 0.774174670457473, -91.420280456543, -1.5955848970633, 218, 57, 'PPL', 'P'),
(182277, 'Independence', 36.8027801513672, 0.642329687528975, -118.199172973633, -2.06296474152419, 218, 6, 'PPL', 'P'),
(186880, 'Independence', 39.1072196960449, 0.68254974499676, -106.605278015137, -1.86061310136806, 218, 7, 'PPL', 'P'),
(196764, 'Independence', 45.2125015258789, 0.789107014689547, -110.245559692383, -1.92414800233603, 218, 31, 'PPL', 'P'),
(201021, 'Independence', 44.851390838623, 0.782804444232793, -123.185562133789, -2.14999365015467, 218, 43, 'PPL', 'P'),
(204442, 'Independence', 40.2480583190918, 0.702461135202846, -109.934440612793, -1.91871795003141, 218, 52, 'PPL', 'P'),
(207712, 'Independence', 46.7991714477539, 0.816799628968627, -123.15389251709, -2.14944091107042, 218, 56, 'PPL', 'P'),
(9648, 'Independence (historical)', 36.3125, 0.633772684630441, -92.4897232055664, -1.61425019419534, 218, 4, 'PPL', 'P'),
(186881, 'Independence (historical)', 38.7322196960449, 0.676004760301781, -105.136108398438, -1.8349712542864, 218, 7, 'PPL', 'P'),
(195130, 'Independence (historical)', 43.7763900756836, 0.764042141458048, -111.916107177734, -1.95330455626632, 218, 17, 'PPL', 'P'),
(145487, 'Independence Corner', 41.2099990844727, 0.719250168767897, -74.5516662597656, -1.30117203908088, 218, 37, 'PPL', 'P'),
(122858, 'Independence Hill', 41.4761085510254, 0.723894655129968, -87.3672180175781, -1.52484561271445, 218, 19, 'PPL', 'P'),
(48435, 'Independence Village', 38.5036087036133, 0.672014745777597, -76.8033294677734, -1.34047097570663, 218, 25, 'PPL', 'P'),
(22141, 'Independence Walk', 34.0883293151855, 0.594953583054092, -84.5527801513672, -1.47572440535627, 218, 13, 'PPL', 'P'),
(41471, 'Independent', 30.0322208404541, 0.524161135351983, -91.8505630493164, -1.60309474502121, 218, 22, 'PPL', 'P'),
(103060, 'Independent Hill', 38.6358299255371, 0.674322441441178, -77.4380569458008, -1.35154906005109, 218, 53, 'PPL', 'P'),
(81709, 'Independents', 33.9444389343262, 0.592442222146147, -80.9038925170898, -1.41203930210282, 218, 48, 'PPL', 'P'),
(9651, 'Index', 33.5469398498535, 0.585504554348436, -94.0416717529297, -1.64133680616837, 218, 4, 'PPL', 'P'),
(36555, 'Index', 37.8980598449707, 0.661445924412591, -83.2850036621094, -1.45359753143934, 218, 21, 'PPL', 'P'),
(149799, 'Index', 42.6652793884277, 0.744649601611337, -74.9594421386719, -1.308289070778, 218, 40, 'PPL', 'P'),
(207713, 'Index', 47.8208312988281, 0.834630957205307, -121.553886413574, -2.12151553651207, 218, 56, 'PPL', 'P'),
(3321, 'Index (historical)', 34.6333312988281, 0.604465662098555, -85.8775024414063, -1.49884517099201, 218, 2, 'PPL', 'P'),
(9652, 'Index (historical)', 35.1313896179199, 0.613158419633655, -92.8555603027344, -1.62063525606686, 218, 4, 'PPL', 'P'),
(109777, 'Index (historical)', 38.8763885498047, 0.678520981478715, -81.0158309936523, -1.4139929970785, 218, 58, 'PPL', 'P'),
(944, 'India', 36.3325004577637, 0.634121758470323, -88.258056640625, -1.54039367979055, 218, 50, 'PPL', 'P'),
(60373, 'India', 30.8169403076172, 0.537857073758474, -89.1111068725586, -1.55528221502269, 218, 30, 'PPL', 'P'),
(95079, 'India', 32.5250015258789, 0.567668365842767, -96.6158294677734, -1.68626433375801, 218, 51, 'PPL', 'P'),
(162975, 'India', 40.3763885498047, 0.70470092025863, -79.1197204589844, -1.3808996252668, 218, 45, 'PPL', 'P'),
(81710, 'India Hook', 35.0072212219238, 0.610991272296603, -81.0219421386719, -1.41409965668016, 218, 48, 'PPL', 'P'),
(76168, 'Indiahoma', 34.6197204589844, 0.60422810812932, -98.751106262207, -1.7235319442623, 218, 42, 'PPL', 'P'),
(76169, 'Indiahoma Wye', 34.6955604553223, 0.605551765770116, -98.7050018310547, -1.72272727013894, 218, 42, 'PPL', 'P'),
(16528, 'Indialantic', 28.0891704559326, 0.490248508609941, -80.5658264160156, -1.4061389355497, 218, 12, 'PPL', 'P'),
(9653, 'Indian', 33.0525016784668, 0.576874980310198, -91.289436340332, -1.59330123642856, 218, 4, 'PPL', 'P'),
(103061, 'Indian', 37.0875015258789, 0.647299012965008, -81.7583312988281, -1.42695207210088, 218, 53, 'PPL', 'P'),
(103062, 'Indian (historical)', 37.1100006103516, 0.64769169606774, -82.1575012207031, -1.43391890151253, 218, 53, 'PPL', 'P'),
(48436, 'Indian Acres', 39.3872184753418, 0.687436645597055, -75.915283203125, -1.32497164447848, 218, 25, 'PPL', 'P'),
(196765, 'Indian Arrow', 45.7836112976074, 0.799074760596523, -108.174171447754, -1.88799545738015, 218, 31, 'PPL', 'P'),
(9654, 'Indian Bay', 34.3827781677246, 0.600092685009618, -91.0669403076172, -1.58941794808506, 218, 4, 'PPL', 'P'),
(41472, 'Indian Bayou', 30.1258296966553, 0.525794918101719, -92.2425003051758, -1.60993534059719, 218, 22, 'PPL', 'P'),
(14006, 'Indian Beach', 38.6855583190918, 0.675190365640435, -75.0736083984375, -1.3102816479056, 218, 10, 'PPL', 'P'),
(41473, 'Indian Beach', 30.0188903808594, 0.523928474941251, -90.14111328125, -1.573259218171, 218, 22, 'PPL', 'P'),
(65844, 'Indian Beach', 34.6863899230957, 0.605391709788603, -76.8955612182617, -1.34208072342753, 218, 33, 'PPL', 'P'),
(207714, 'Indian Beach', 48.163330078125, 0.840608688588099, -122.519996643066, -2.13837734095391, 218, 56, 'PPL', 'P'),
(22142, 'Indian Bend', 33.1408309936523, 0.578416617686217, -85.1138916015625, -1.48551764763282, 218, 13, 'PPL', 'P'),
(155837, 'Indian Camp', 40.0944404602051, 0.699779997775409, -81.6458282470703, -1.42498852342917, 218, 41, 'PPL', 'P'),
(149801, 'Indian Castle', 43.0080604553223, 0.750632259842145, -74.7897186279297, -1.30532683669751, 218, 40, 'PPL', 'P'),
(65845, 'Indian Cave Park', 35.2994384765625, 0.616091425521187, -82.5199966430664, -1.44024564015618, 218, 33, 'PPL', 'P'),
(76171, 'Indian City', 35.0372200012207, 0.611514849766913, -98.2255630493164, -1.71435948483585, 218, 42, 'PPL', 'P'),
(14012, 'Indian Cove', 38.4905586242676, 0.671786978925368, -75.1108322143555, -1.31093132605353, 218, 10, 'PPL', 'P'),
(149802, 'Indian Cove', 42.771671295166, 0.746506490681394, -76.4680633544922, -1.33461947815951, 218, 40, 'PPL', 'P'),
(190332, 'Indian Cove', 37.6552810668945, 0.657208635381193, -114.494438171387, -1.99830492131177, 218, 39, 'PPL', 'P'),
(22144, 'Indian Cove (historical)', 31.4477806091309, 0.548867314074161, -83.9611129760742, -1.46539786507143, 218, 13, 'PPL', 'P'),
(22145, 'Indian Creek', 31.5697193145752, 0.550995545969785, -84.254997253418, -1.47052711333092, 218, 13, 'PPL', 'P'),
(55465, 'Indian Creek', 39.5944404602051, 0.691053351515437, -91.7766723632813, -1.60180510926334, 218, 29, 'PPL', 'P'),
(88076, 'Indian Creek', 36.2852783203125, 0.633297576691971, -84.1347198486328, -1.46842787660167, 218, 50, 'PPL', 'P'),
(95080, 'Indian Creek', 31.5230598449707, 0.550181184597952, -98.9797210693359, -1.72752202536551, 218, 51, 'PPL', 'P'),
(120107, 'Indian Creek', 42.2269401550293, 0.736999138747866, -87.9797210693359, -1.53553580764614, 218, 18, 'PPL', 'P'),
(155838, 'Indian Creek', 41.5550003051758, 0.725271575992566, -83.5083312988281, -1.45749533401078, 218, 41, 'PPL', 'P'),
(162976, 'Indian Creek', 40.144718170166, 0.70065750935459, -74.8661117553711, -1.30666014829726, 218, 45, 'PPL', 'P'),
(174624, 'Indian Creek', 45.7052803039551, 0.797707626850931, -92.2072219848633, -1.60931961775317, 218, 57, 'PPL', 'P'),
(182278, 'Indian Creek', 38.1816711425781, 0.666395875351694, -120.433326721191, -2.10195808041486, 218, 6, 'PPL', 'P'),
(88077, 'Indian Creek (historical)', 36.1055603027344, 0.630160905560075, -82.4652786254883, -1.43929063058927, 218, 50, 'PPL', 'P'),
(30138, 'Indian Creek Estates', 39.6786117553711, 0.692522417751752, -85.970832824707, -1.50047409347275, 218, 19, 'PPL', 'P'),
(48448, 'Indian Creek Estates', 39.0625, 0.681769239060285, -76.6102828979492, -1.33710167745352, 218, 25, 'PPL', 'P'),
(30139, 'Indian Creek Settlement', 38.7291717529297, 0.675951563659007, -87.3455581665039, -1.52446757699771, 218, 19, 'PPL', 'P'),
(16529, 'Indian Creek Village', 25.8777809143066, 0.451652480064399, -80.1363906860352, -1.39864386813583, 218, 12, 'PPL', 'P'),
(22146, 'Indian Crossing', 33.9347190856934, 0.592272578784709, -84.1780624389648, -1.4691843475093, 218, 13, 'PPL', 'P'),
(162977, 'Indian Crossing', 41.9736099243164, 0.732577692127089, -78.4049987792969, -1.36842537872087, 218, 45, 'PPL', 'P'),
(48439, 'Indian Falls', 39.6155586242676, 0.691421933010304, -75.9319381713867, -1.32526232851146, 218, 25, 'PPL', 'P'),
(149804, 'Indian Falls', 43.0250015258789, 0.750927937302171, -78.398063659668, -1.36830433804932, 218, 40, 'PPL', 'P'),
(193671, 'Indian Falls', 40.0569381713867, 0.699125459358495, -120.962783813477, -2.11119884992327, 218, 6, 'PPL', 'P'),
(14007, 'Indian Field', 39.8125, 0.694859208450242, -75.4763870239258, -1.31731146107703, 218, 10, 'PPL', 'P'),
(103063, 'Indian Field', 37.9483299255371, 0.662323302833717, -76.7169418334961, -1.33896322705548, 218, 53, 'PPL', 'P'),
(16530, 'Indian Ford', 30.7133293151855, 0.536048720799283, -86.9238891601563, -1.51710806448334, 218, 12, 'PPL', 'P'),
(95081, 'Indian Gap', 31.6627807617188, 0.55261977462911, -98.4130630493164, -1.71763197718334, 218, 51, 'PPL', 'P'),
(178406, 'Indian Gardens', 34.913890838623, 0.609362349815856, -111.726387023926, -1.94999331492497, 218, 5, 'PPL', 'P'),
(55467, 'Indian Grove', 39.5105590820313, 0.689589345285194, -93.0347213745117, -1.62376220666077, 218, 29, 'PPL', 'P'),
(65847, 'Indian Grove', 36.4908294677734, 0.636885120996416, -80.5250015258789, -1.40542640680004, 218, 33, 'PPL', 'P'),
(131431, 'Indian Grove', 42.3886108398438, 0.739820824501832, -86.2827835083008, -1.50591866000531, 218, 27, 'PPL', 'P'),
(195131, 'Indian Grove', 42.1127815246582, 0.735006694778323, -113.727500915527, -1.98491934104082, 218, 17, 'PPL', 'P'),
(182279, 'Indian Gulch', 37.4394416809082, 0.653441527440248, -120.195831298828, -2.0978130033362, 218, 6, 'PPL', 'P'),
(48440, 'Indian Hammock', 37.9963912963867, 0.663162131998065, -75.7699966430664, -1.32243591564656, 218, 25, 'PPL', 'P'),
(48441, 'Indian Harbor', 38.7513885498047, 0.676339319913722, -76.2830581665039, -1.33139052849584, 218, 25, 'PPL', 'P'),
(14008, 'Indian Harbor Villa', 38.5894393920898, 0.673512773890767, -75.0619430541992, -1.31007804924026, 218, 10, 'PPL', 'P'),
(16531, 'Indian Harbour Beach', 28.148609161377, 0.491285909723068, -80.5886077880859, -1.40653654550044, 218, 12, 'PPL', 'P'),
(48442, 'Indian Head', 38.5999984741211, 0.6736970646382, -77.1624984741211, -1.34673965743851, 218, 25, 'PPL', 'P'),
(162979, 'Indian Head', 40.0247192382813, 0.698563132894325, -79.3952789306641, -1.38570902787937, 218, 45, 'PPL', 'P'),
(48443, 'Indian Head Manor', 38.6327781677246, 0.674269178219377, -77.0611114501953, -1.34497012005221, 218, 25, 'PPL', 'P'),
(120111, 'Indian Head Park', 41.7702789306641, 0.729028896816504, -87.9022216796875, -1.53418318812849, 218, 18, 'PPL', 'P'),
(195132, 'Indian Head Rock', 43.5552787780762, 0.760183021301442, -114.800559997559, -2.00364775509069, 218, 17, 'PPL', 'P'),
(122860, 'Indian Heights', 40.4272193908691, 0.705588085796763, -86.1255569458008, -1.5031745388181, 218, 19, 'PPL', 'P'),
(125136, 'Indian Heights', 41.7591705322266, 0.728835018689146, -70.6316680908203, -1.23275516436063, 218, 23, 'PPL', 'P'),
(174625, 'Indian Heights', 42.8522186279297, 0.74791230684182, -89.0180587768555, -1.55365821938996, 218, 57, 'PPL', 'P'),
(3323, 'Indian Hill', 33.2975006103516, 0.581151018335456, -86.352783203125, -1.50714038515539, 218, 2, 'PPL', 'P'),
(48444, 'Indian Hill', 39.334171295166, 0.686510797644089, -76.9469375610352, -1.34297740976656, 218, 25, 'PPL', 'P'),
(72995, 'Indian Hill', 39.1808280944824, 0.683834453906614, -84.3452835083008, -1.47210290574792, 218, 41, 'PPL', 'P'),
(120112, 'Indian Hill', 41.5016708374023, 0.724340801191583, -87.6477813720703, -1.52974236701078, 218, 18, 'PPL', 'P'),
(122861, 'Indian Hill', 41.3252792358398, 0.721262186971452, -86.6833267211914, -1.51290945786677, 218, 19, 'PPL', 'P'),
(149803, 'Indian Hill', 41.2599983215332, 0.720122820078088, -74.1741714477539, -1.29458351170207, 218, 40, 'PPL', 'P'),
(182280, 'Indian Hill (historical)', 39.5069389343262, 0.689526161788331, -120.991386413574, -2.1116980594696, 218, 6, 'PPL', 'P'),
(170592, 'Indian Hill Division', 43.5713882446289, 0.760464184533527, -96.6213912963867, -1.68636140597974, 218, 49, 'PPL', 'P'),
(22147, 'Indian Hill Estates', 33.5305595397949, 0.585218664005416, -84.3188934326172, -1.47164231203739, 218, 13, 'PPL', 'P'),
(22150, 'Indian Hills', 33.8805618286133, 0.591327356334812, -83.4361114501953, -1.45623485986685, 218, 13, 'PPL', 'P'),
(36564, 'Indian Hills', 36.9897193908691, 0.645592392759458, -86.4049987792969, -1.50805171888041, 218, 21, 'PPL', 'P'),
(48446, 'Indian Hills', 39.6800003051758, 0.692546652517672, -76.5108337402344, -1.33536596221306, 218, 25, 'PPL', 'P'),
(60374, 'Indian Hills', 34.3175010681152, 0.598953384695282, -88.684440612793, -1.54783548398261, 218, 30, 'PPL', 'P'),
(65850, 'Indian Hills', 35.4599990844727, 0.618893736778223, -83.3152770996094, -1.45412590259962, 218, 33, 'PPL', 'P'),
(81712, 'Indian Hills', 34.7069396972656, 0.605750371008409, -82.9236068725586, -1.44728996755555, 218, 48, 'PPL', 'P'),
(88082, 'Indian Hills', 36.5486106872559, 0.637893593522202, -82.4208297729492, -1.43851485176373, 218, 50, 'PPL', 'P'),
(95083, 'Indian Hills', 31.0327796936035, 0.541624181699418, -93.7591705322266, -1.6364062297262, 218, 51, 'PPL', 'P'),
(122862, 'Indian Hills', 41.6222190856934, 0.726444765031773, -85.1558303833008, -1.48624961745842, 218, 19, 'PPL', 'P'),
(162980, 'Indian Hills', 40.853328704834, 0.713025096298864, -75.6888885498047, -1.32102031236913, 218, 45, 'PPL', 'P'),
(174626, 'Indian Hills', 43.8047218322754, 0.764536623893449, -88.9897232055664, -1.55316367037554, 218, 57, 'PPL', 'P'),
(182281, 'Indian Hills', 38.1736106872559, 0.66625519386711, -120.376388549805, -2.10096432185409, 218, 6, 'PPL', 'P'),
(186882, 'Indian Hills', 39.6166687011719, 0.691441307507235, -105.236671447754, -1.83672641060281, 218, 7, 'PPL', 'P'),
(192952, 'Indian Hills', 39.086109161377, 0.682181296659948, -119.783058166504, -2.09060875311338, 218, 39, 'PPL', 'P'),
(36565, 'Indian Hills Cherokee Section', 38.2794418334961, 0.668102295820162, -85.6500015258789, -1.49487453096475, 218, 21, 'PPL', 'P'),
(41474, 'Indian Hills Estates', 32.6022186279297, 0.569016058512401, -93.8633270263672, -1.63822410348629, 218, 22, 'PPL', 'P'),
(103067, 'Indian Hollow', 39.2411117553711, 0.684886602274277, -78.2633285522461, -1.36595276680678, 218, 53, 'PPL', 'P'),
(178407, 'Indian Hot Springs', 32.9983291625977, 0.575929491544192, -109.900001525879, -1.91811687457338, 218, 5, 'PPL', 'P'),
(191658, 'Indian Hot Springs', 30.8261108398438, 0.538017129739988, -105.316940307617, -1.83812736649425, 218, 51, 'PPL', 'P'),
(195133, 'Indian Jim Place', 42.167781829834, 0.735966631193242, -114.912780761719, -2.00560637691439, 218, 17, 'PPL', 'P'),
(149805, 'Indian Kettles', 43.7733306884766, 0.763988745078192, -73.4888916015625, -1.28262312208847, 218, 40, 'PPL', 'P'),
(112485, 'Indian Knolls', 39.1780586242676, 0.683786117532829, -84.2747192382813, -1.47087132690182, 218, 41, 'PPL', 'P'),
(22151, 'Indian Lake', 33.8958282470703, 0.591593805601875, -84.7544403076172, -1.47924403905292, 218, 13, 'PPL', 'P'),
(30142, 'Indian Lake', 39.8852806091309, 0.696129469711183, -85.9869384765625, -1.50075519012581, 218, 19, 'PPL', 'P'),
(95084, 'Indian Lake', 26.0888900756836, 0.455337030011551, -97.5022201538086, -1.70173476968833, 218, 51, 'PPL', 'P'),
(103064, 'Indian Lake', 39.2391700744629, 0.684852713549406, -78.2819366455078, -1.36627753930172, 218, 53, 'PPL', 'P'),
(131432, 'Indian Lake', 42.0050010681152, 0.733125570942346, -86.209716796875, -1.50464340531733, 218, 27, 'PPL', 'P'),
(149806, 'Indian Lake', 43.7825012207031, 0.764148801059706, -74.272216796875, -1.29629472586051, 218, 40, 'PPL', 'P'),
(162981, 'Indian Lake', 40.0466690063477, 0.698946228617133, -78.8525009155273, -1.3762357644078, 218, 45, 'PPL', 'P'),
(16532, 'Indian Lake Estates', 27.8136100769043, 0.485439072707853, -81.3786087036133, -1.42032466257017, 218, 12, 'PPL', 'P'),
(41475, 'Indian Lake Estates', 32.5516700744629, 0.568133819822285, -92.2391662597656, -1.60987715052737, 218, 22, 'PPL', 'P'),
(65853, 'Indian Lake Estates', 35.1569404602051, 0.613604365958189, -82.9388885498047, -1.44755668313872, 218, 33, 'PPL', 'P'),
(125137, 'Indian Lake Estates', 42.2555618286133, 0.737498681189338, -73.0591735839844, -1.27512312782659, 218, 23, 'PPL', 'P'),
(88083, 'Indian Lake Farms', 36.2416687011719, 0.632536445252426, -86.5625, -1.51080063375759, 218, 50, 'PPL', 'P'),
(169431, 'Indian Lake Shores', 41.4747200012207, 0.723870420364048, -71.4613876342773, -1.2472365022621, 218, 47, 'PPL', 'P'),
(182282, 'Indian Lakes Estates', 37.211109161377, 0.649456373185054, -119.679168701172, -2.0887955398852, 218, 6, 'PPL', 'P'),
(41476, 'Indian Landing', 32.2799987792969, 0.563392261238481, -91.5233306884766, -1.59738346290548, 218, 22, 'PPL', 'P'),
(127800, 'Indian Landing', 45.2080612182617, 0.789029516701826, -67.8683319091797, -1.18452584965151, 218, 26, 'PPL', 'P'),
(48447, 'Indian Landing Estates', 39.0694389343262, 0.681890346310856, -76.6177825927734, -1.33723257182109, 218, 25, 'PPL', 'P'),
(14009, 'Indian Landing Mobile Home Park', 38.6238899230957, 0.674114049085879, -75.1066665649414, -1.31085862175577, 218, 10, 'PPL', 'P'),
(14010, 'Indian Landing North Mobile Home Park', 38.6269416809082, 0.674167312307681, -75.120002746582, -1.31109138203504, 218, 10, 'PPL', 'P'),
(125138, 'Indian Lands', 41.3333282470703, 0.721402668718953, -70.8166732788086, -1.2359841140243, 218, 23, 'PPL', 'P'),
(48452, 'Indian Meadows', 39.6991691589355, 0.692881212129613, -76.5772171020508, -1.3365245704453, 218, 25, 'PPL', 'P'),
(76173, 'Indian Meadows', 35.8730583190918, 0.626102980428094, -94.9655609130859, -1.65746171393658, 218, 42, 'PPL', 'P'),
(109779, 'Indian Meadows', 38.4222183227539, 0.670594215652149, -82.2452774047852, -1.4354508849296, 218, 58, 'PPL', 'P'),
(194253, 'Indian Meadows', 40.7005615234375, 0.710358805994504, -105.551391601563, -1.84221931350916, 218, 7, 'PPL', 'P'),
(70973, 'Indian Mills', 39.7938919067383, 0.694534435955307, -74.7447204589844, -1.30454147049204, 218, 37, 'PPL', 'P'),
(109780, 'Indian Mills', 37.5283317565918, 0.654992951933274, -80.8172225952148, -1.41052662660366, 218, 58, 'PPL', 'P'),
(14011, 'Indian Mission', 38.6733283996582, 0.674976913279065, -75.2355575561523, -1.31310819392856, 218, 10, 'PPL', 'P'),
(178408, 'Indian Moccasin', 36.8972206115723, 0.643977984506652, -112.741668701172, -1.96771332302809, 218, 5, 'PPL', 'P'),
(55468, 'Indian Mound', 36.1511116027832, 0.630955925724491, -89.6988906860352, -1.56554097785779, 218, 29, 'PPL', 'P'),
(88085, 'Indian Mound', 36.5008316040039, 0.637059691205871, -87.6936111450195, -1.53054224744419, 218, 50, 'PPL', 'P'),
(16533, 'Indian Mound Village', 28.8030605316162, 0.502708240927931, -81.2169418334961, -1.41750304339523, 218, 12, 'PPL', 'P'),
(162984, 'Indian Mountain Lake', 41.0047187805176, 0.715667351574386, -75.4997177124023, -1.3177186584077, 218, 45, 'PPL', 'P'),
(103065, 'Indian Neck', 37.9019393920898, 0.661513635283306, -77.0336074829102, -1.34449008526572, 218, 53, 'PPL', 'P'),
(113586, 'Indian Neck', 41.2611083984375, 0.720142194575019, -72.8011093139648, -1.270619056633, 218, 8, 'PPL', 'P'),
(81714, 'Indian Oaks', 34.7119407653809, 0.605837656113137, -82.977783203125, -1.44823552290058, 218, 48, 'PPL', 'P'),
(120113, 'Indian Oaks', 41.1916694641113, 0.718930256541951, -87.8513870239258, -1.53329595601133, 218, 18, 'PPL', 'P'),
(182283, 'Indian Oaks', 33.6055603027344, 0.586527674260217, -117.019996643066, -2.04238423209422, 218, 6, 'PPL', 'P'),
(125139, 'Indian Orchard', 42.1583290100098, 0.735801648363712, -72.5, -1.26536370769589, 218, 23, 'PPL', 'P'),
(162985, 'Indian Orchard', 41.5472183227539, 0.725135754776972, -75.2138900756836, -1.31273002505377, 218, 45, 'PPL', 'P'),
(41477, 'Indian Park', 30.3566703796387, 0.529823848067332, -91.1333312988281, -1.59057668947535, 218, 22, 'PPL', 'P'),
(149808, 'Indian Park', 41.2083282470703, 0.71922100715396, -74.3125, -1.29699780038829, 218, 40, 'PPL', 'P'),
(16534, 'Indian Pass', 29.6902809143066, 0.518193157796683, -85.2644424438477, -1.48814525552234, 218, 12, 'PPL', 'P'),
(178410, 'Indian Pine', 34.0800018310547, 0.594808241037601, -109.904716491699, -1.91819916625106, 218, 5, 'PPL', 'P'),
(81715, 'Indian Pines', 33.964168548584, 0.592786568875094, -81.1708297729492, -1.41669823611381, 218, 48, 'PPL', 'P'),
(65854, 'Indian Place', 35.2463912963867, 0.615165577568221, -83.0950012207031, -1.45028136324998, 218, 33, 'PPL', 'P'),
(55469, 'Indian Point', 36.6283302307129, 0.639284962033714, -93.3436126708984, -1.62915337681348, 218, 29, 'PPL', 'P'),
(127801, 'Indian Point', 44.3827781677246, 0.774625610209051, -68.3608322143555, -1.19312160154391, 218, 26, 'PPL', 'P'),
(162986, 'Indian Point', 41.2855606079102, 0.720568966139704, -74.834716796875, -1.30611220290297, 218, 45, 'PPL', 'P'),
(103066, 'Indian Point Estates', 36.7880592346191, 0.642072759062809, -76.6113891601563, -1.33712098537142, 218, 53, 'PPL', 'P'),
(48449, 'Indian Princess', 39.4797210693359, 0.689051120428889, -76.3819427490234, -1.33311639004027, 218, 25, 'PPL', 'P'),
(48450, 'Indian Queen Estates', 38.7563896179199, 0.67642660501845, -77.024169921875, -1.3443253687523, 218, 25, 'PPL', 'P'),
(32835, 'Indian Ridge', 39.2180595397949, 0.684484265212594, -95.4749984741211, -1.66635307670998, 218, 20, 'PPL', 'P'),
(178409, 'Indian Ridge Estates', 32.2544403076172, 0.562946181755893, -110.842216491699, -1.93456162798851, 218, 5, 'PPL', 'P'),
(116127, 'Indian Ridge Mobile Home Park', 41.3597183227539, 0.721863262429482, -93.5638885498047, -1.63299791616311, 218, 16, 'PPL', 'P'),
(127802, 'Indian River', 44.5719413757324, 0.777927131012422, -67.6433334350586, -1.18059888546614, 218, 26, 'PPL', 'P'),
(131433, 'Indian River', 45.4124984741211, 0.792597619930314, -84.6125030517578, -1.47676676660692, 218, 27, 'PPL', 'P'),
(149809, 'Indian River', 43.976390838623, 0.767532813277843, -75.3691711425781, -1.31544019093709, 218, 40, 'PPL', 'P'),
(14016, 'Indian River Acres', 38.5741691589355, 0.673246258044677, -75.1708297729492, -1.31197848099415, 218, 10, 'PPL', 'P'),
(16535, 'Indian River City', 28.559440612793, 0.498456271221024, -80.7994384765625, -1.41021623517861, 218, 12, 'PPL', 'P'),
(16537, 'Indian River Estates', 27.3641700744629, 0.477594864875079, -80.3099975585938, -1.40167387966607, 218, 12, 'PPL', 'P'),
(48451, 'Indian River Estates', 38.4944381713867, 0.671854689796084, -76.7050018310547, -1.33875483470018, 218, 25, 'PPL', 'P'),
(103068, 'Indian River Park', 36.810001373291, 0.642455721627562, -76.2219390869141, -1.33032379932121, 218, 53, 'PPL', 'P'),
(16538, 'Indian River Shores', 27.7163906097412, 0.483742272908823, -80.3844375610352, -1.40297310280386, 218, 12, 'PPL', 'P'),
(95085, 'Indian Rock', 32.7067489624023, 0.57084045701716, -94.8737869262695, -1.65585995569895, 218, 51, 'PPL', 'P'),
(13129, 'Indian Rock Terrace', 38.9088897705078, 0.679088234790902, -77.0875015258789, -1.34543071376274, 218, 9, 'PPL', 'P'),
(16539, 'Indian Rocks Beach', 27.875, 0.486510528993419, -82.8513870239258, -1.44602949341161, 218, 12, 'PPL', 'P'),
(22153, 'Indian Rose', 33.8466682434082, 0.590735801677679, -84.7324981689453, -1.47886107648816, 218, 13, 'PPL', 'P'),
(162987, 'Indian Run', 41.1511116027832, 0.718222388324208, -80.2644424438477, -1.40087879292263, 218, 45, 'PPL', 'P'),
(103071, 'Indian Run Park', 38.8125, 0.677405915930299, -77.1572189331055, -1.3466475120648, 218, 53, 'PPL', 'P'),
(3333, 'Indian Shoals', 33.2138900756836, 0.579691739216147, -86.4688873291016, -1.50916678442883, 218, 2, 'PPL', 'P'),
(125140, 'Indian Shore', 41.8236083984375, 0.729959671617487, -70.915283203125, -1.23770518187876, 218, 23, 'PPL', 'P'),
(16540, 'Indian Shores', 27.8624992370605, 0.486292349521115, -82.8486099243164, -1.44598102387977, 218, 12, 'PPL', 'P'),
(174627, 'Indian Shores', 44.1391716003418, 0.770373873528739, -88.7016677856445, -1.54813615486968, 218, 57, 'PPL', 'P'),
(120129, 'Indian Spring', 41.1811103820801, 0.718745965794517, -89.3602828979492, -1.55963115708279, 218, 18, 'PPL', 'P'),
(16541, 'Indian Spring Estates', 27.8708305358887, 0.486437758116633, -82.8436126708984, -1.44589380535407, 218, 12, 'PPL', 'P'),
(48453, 'Indian Spring Terrace', 39.0127792358398, 0.680901448019083, -77.0124969482422, -1.34412163692891, 218, 25, 'PPL', 'P'),
(48454, 'Indian Spring Village', 39.0188903808594, 0.68100810762074, -77.0036087036133, -1.34396650779541, 218, 25, 'PPL', 'P'),
(3336, 'Indian Springs', 30.7802791595459, 0.537217216017069, -88.1916732788086, -1.53923507155831, 218, 2, 'PPL', 'P'),
(22156, 'Indian Springs', 33.9305610656738, 0.592200007645004, -84.7872161865234, -1.47981608605506, 218, 13, 'PPL', 'P'),
(30143, 'Indian Springs', 38.7963905334473, 0.677124752698214, -86.7649993896484, -1.51433491484024, 218, 19, 'PPL', 'P'),
(48456, 'Indian Springs', 39.6463890075684, 0.691960024708555, -78.0019378662109, -1.36139063870142, 218, 25, 'PPL', 'P'),
(55470, 'Indian Springs', 38.0449981689453, 0.66401048196331, -94.1699981689453, -1.64357652464513, 218, 29, 'PPL', 'P'),
(60376, 'Indian Springs', 31.2975006103516, 0.54624443329557, -89.1377792358398, -1.55574773558124, 218, 30, 'PPL', 'P'),
(65857, 'Indian Springs', 35.2308311462402, 0.61489400171606, -77.9480590820313, -1.36045027652051, 218, 33, 'PPL', 'P'),
(72996, 'Indian Springs', 39.355281829834, 0.686879245980902, -84.5283279418945, -1.47529763379158, 218, 41, 'PPL', 'P'),
(76174, 'Indian Springs', 35.8963890075684, 0.626510177758768, -97.5716705322266, -1.70294690745848, 218, 42, 'PPL', 'P'),
(81718, 'Indian Springs', 32.9888916015625, 0.575764775030771, -80.228889465332, -1.40025827638864, 218, 48, 'PPL', 'P'),
(103070, 'Indian Springs', 38.8116683959961, 0.677391401702358, -77.1722183227539, -1.34690930079995, 218, 53, 'PPL', 'P'),
(178411, 'Indian Springs', 33.5072212219238, 0.584811333516688, -112.213890075684, -1.95850184829167, 218, 5, 'PPL', 'P'),
(182287, 'Indian Springs', 32.7202796936035, 0.571076612826823, -116.879997253418, -2.03994078179407, 218, 6, 'PPL', 'P'),
(190333, 'Indian Springs', 36.5697212219238, 0.638262041859015, -115.669723510742, -2.01881752013395, 218, 39, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(190334, 'Indian Springs (historical)', 38.5397186279297, 0.672644982849565, -117.258056640625, -2.04653916286891, 218, 39, 'PPL', 'P'),
(162988, 'Indian Springs Estates', 40.6041717529297, 0.708676487133901, -79.1816711425781, -1.38198086866937, 218, 45, 'PPL', 'P'),
(3339, 'Indian Springs Village', 33.355281829834, 0.582159490861242, -86.7544403076172, -1.5141506240928, 218, 2, 'PPL', 'P'),
(186883, 'Indian Springs Village', 39.4319381713867, 0.68821715153353, -105.319999694824, -1.83818076287411, 218, 7, 'PPL', 'P'),
(48457, 'Indian Town', 39.1188888549805, 0.682753410241124, -76.0952835083008, -1.32811324245839, 218, 25, 'PPL', 'P'),
(103072, 'Indian Town', 38.3688888549805, 0.669663440851166, -77.7988891601563, -1.35784677023885, 218, 53, 'PPL', 'P'),
(131434, 'Indian Town', 46.4088897705078, 0.809987928690477, -86.5630569458008, -1.51081035429557, 218, 27, 'PPL', 'P'),
(65858, 'Indian Trail', 35.0766716003418, 0.612203410066753, -80.6694412231445, -1.40794735508791, 218, 33, 'PPL', 'P'),
(81716, 'Indian Trail', 34.4755592346191, 0.60171202011044, -82.7016677856445, -1.44341639975003, 218, 48, 'PPL', 'P'),
(155840, 'Indian Trail Estates', 41.5905609130859, 0.725892225684609, -83.4355621337891, -1.45622527248692, 218, 41, 'PPL', 'P'),
(95086, 'Indian Trails Lane Colonia', 27.8740005493164, 0.486493085288279, -97.1869964599609, -1.69623307835039, 218, 51, 'PPL', 'P'),
(22157, 'Indian Valley', 34.1175003051758, 0.595462712875488, -84.8525009155273, -1.48095551952746, 218, 13, 'PPL', 'P'),
(36566, 'Indian Valley', 37.5747184753418, 0.655802552904658, -86.4402770996094, -1.50866744172444, 218, 21, 'PPL', 'P'),
(103074, 'Indian Valley', 36.9086112976074, 0.644176789482026, -80.5522232055664, -1.40590151473852, 218, 53, 'PPL', 'P'),
(195134, 'Indian Valley', 44.5572204589844, 0.777670202546256, -116.433059692383, -2.03214024980318, 218, 17, 'PPL', 'P'),
(201022, 'Indian Valley (historical)', 45.5180587768555, 0.794439994772431, -117.883331298828, -2.05745226438383, 218, 43, 'PPL', 'P'),
(22158, 'Indian Valley Estates', 34.0847206115723, 0.594890599294311, -84.5283279418945, -1.47529763379158, 218, 13, 'PPL', 'P'),
(22159, 'Indian Village', 34.0994415283203, 0.595147527760477, -84.6872177124023, -1.47807078343468, 218, 13, 'PPL', 'P'),
(41480, 'Indian Village', 30.4488906860352, 0.531433396051148, -92.9716720581055, -1.62266178849835, 218, 22, 'PPL', 'P'),
(48458, 'Indian Village', 39.0963897705078, 0.682360727138392, -76.5266723632813, -1.33564239833421, 218, 25, 'PPL', 'P'),
(55471, 'Indian Village', 38.9650001525879, 0.680067545702752, -94.5880584716797, -1.65087305339973, 218, 29, 'PPL', 'P'),
(76175, 'Indian Village', 36.4105606079102, 0.63548416510498, -96.3847198486328, -1.68223070997097, 218, 42, 'PPL', 'P'),
(122866, 'Indian Village', 40.4663887023926, 0.706271719248586, -86.9008331298828, -1.51670566084262, 218, 19, 'PPL', 'P'),
(149810, 'Indian Village', 42.9438896179199, 0.749512267445712, -76.1627807617188, -1.32929129176659, 218, 40, 'PPL', 'P'),
(182288, 'Indian Village', 36.4491691589355, 0.636158011439798, -116.873329162598, -2.03982440165444, 218, 6, 'PPL', 'P'),
(201023, 'Indian Village', 43.5849990844727, 0.760701738502762, -119.077499389648, -2.0782944293909, 218, 43, 'PPL', 'P'),
(204446, 'Indian Village', 40.6513900756836, 0.709500602333226, -112.010559082031, -1.95495305298108, 218, 52, 'PPL', 'P'),
(207715, 'Indian Village', 48.5730590820313, 0.84775980874718, -122.649436950684, -2.14063650050662, 218, 56, 'PPL', 'P'),
(204448, 'Indian Village South', 40.6555595397949, 0.709573373210012, -111.97110748291, -1.95426449268124, 218, 52, 'PPL', 'P'),
(178412, 'Indian Wells', 35.4055595397949, 0.61794358748031, -110.084167480469, -1.92133117685105, 218, 5, 'PPL', 'P'),
(182290, 'Indian Wells', 33.7186088562012, 0.58850074373283, -116.307502746582, -2.0299488677002, 218, 6, 'PPL', 'P'),
(182291, 'Indian Wells Mobile Home Park', 33.7008285522461, 0.588190418886808, -116.265556335449, -2.02921676471654, 218, 6, 'PPL', 'P'),
(116129, 'Indiana', 41.2044410705566, 0.719153163125191, -93.0250015258789, -1.62359256329934, 218, 16, 'PPL', 'P'),
(122869, 'Indiana', 40.0002784729004, 0.698136561066721, -86.2502822875977, -1.50535140669313, 218, 19, 'ADM1', 'A'),
(162989, 'Indiana', 40.6213912963867, 0.708977024862916, -79.1527786254883, -1.38147659911696, 218, 45, 'PPL', 'P'),
(122867, 'Indiana Beach', 40.791389465332, 0.711944052633373, -86.7680587768555, -1.51438831122009, 218, 19, 'PPL', 'P'),
(122868, 'Indiana Harbor', 41.6405601501465, 0.726764876994801, -87.4452819824219, -1.52620808592814, 218, 19, 'PPL', 'P'),
(30144, 'Indianapolis', 39.7683296203613, 0.694088289893692, -86.1580581665039, -1.50374179213028, 218, 19, 'PPL', 'P'),
(76177, 'Indianapolis', 35.5513916015625, 0.620488837113126, -98.8622207641602, -1.7254712581681, 218, 42, 'PPL', 'P'),
(116131, 'Indianapolis', 41.3969383239746, 0.72251287399838, -92.4333267211914, -1.61326588985644, 218, 16, 'PPL', 'P'),
(48459, 'Indianbone', 38.4900016784668, 0.671777258387389, -76.0127792358398, -1.32667327125698, 218, 25, 'PPL', 'P'),
(174628, 'Indianford', 42.8041687011719, 0.747073677414554, -89.0911102294922, -1.55493320776184, 218, 57, 'PPL', 'P'),
(162996, 'Indianland', 40.7611083984375, 0.711415548315047, -75.5538864135742, -1.31866408059468, 218, 45, 'PPL', 'P'),
(16542, 'Indianola', 28.396110534668, 0.495605623590203, -80.7147216796875, -1.40873764814139, 218, 12, 'PPL', 'P'),
(22160, 'Indianola', 30.8641700744629, 0.538681388694881, -83.1894378662109, -1.45192959364863, 218, 13, 'PPL', 'P'),
(27512, 'Indianola', 39.9272193908691, 0.696861439536791, -87.7399978637695, -1.53135184841557, 218, 18, 'PPL', 'P'),
(60377, 'Indianola', 33.4508285522461, 0.583827095756822, -90.6549987792969, -1.58222821209017, 218, 30, 'PPL', 'P'),
(76178, 'Indianola', 35.1627807617188, 0.613706298448912, -95.7744369506836, -1.67157926403315, 218, 42, 'PPL', 'P'),
(95087, 'Indianola', 28.5116691589355, 0.497622502062748, -96.4872207641602, -1.68401968843323, 218, 51, 'PPL', 'P'),
(116132, 'Indianola', 41.3580589294434, 0.721834300552628, -93.5572204589844, -1.63288153602348, 218, 16, 'PPL', 'P'),
(122870, 'Indianola', 41.5647201538086, 0.725441219354004, -85.246940612793, -1.48783979094531, 218, 19, 'PPL', 'P'),
(162993, 'Indianola', 40.5694389343262, 0.708070285090771, -79.8638916015625, -1.39388786190311, 218, 45, 'PPL', 'P'),
(192633, 'Indianola', 39.8030586242676, 0.694694425357794, -111.488059997559, -1.94583372361838, 218, 52, 'PPL', 'P'),
(193672, 'Indianola', 40.6863899230957, 0.710111464908262, -124.232223510742, -2.16826133733596, 218, 6, 'PPL', 'P'),
(199424, 'Indianola', 40.2344398498535, 0.702223448075557, -100.416938781738, -1.75260620651492, 218, 35, 'PPL', 'P'),
(207716, 'Indianola', 47.7472190856934, 0.833346181716426, -122.524436950684, -2.13845483894163, 218, 56, 'PPL', 'P'),
(116133, 'Indianola Junction', 41.0402793884277, 0.716288001266429, -93.3563919067383, -1.62937641655477, 218, 16, 'PPL', 'P'),
(186884, 'Indians Hills', 39.6327781677246, 0.69172247073932, -105.259170532227, -1.83711909370555, 218, 7, 'PPL', 'P'),
(16543, 'Indiantown', 27.0269393920898, 0.471709079128922, -80.4858322143555, -1.40474277334822, 218, 12, 'PPL', 'P'),
(48461, 'Indiantown', 38.1886100769043, 0.666516982602265, -75.4077835083008, -1.31611410385093, 218, 25, 'PPL', 'P'),
(65861, 'Indiantown', 36.334171295166, 0.634150920084259, -76.0766677856445, -1.3277883368054, 218, 33, 'PPL', 'P'),
(81717, 'Indiantown', 33.7249984741211, 0.588612263603477, -79.5597229003906, -1.38857911658615, 218, 48, 'PPL', 'P'),
(131437, 'Indiantown', 43.4722213745117, 0.758733396141084, -83.836669921875, -1.46322592404442, 218, 27, 'PPL', 'P'),
(162995, 'Indiantown', 40.0063896179199, 0.698243220668379, -79.2180633544922, -1.38261603258935, 218, 45, 'PPL', 'P'),
(116135, 'Indiantown (historical)', 41.3125, 0.721039147230157, -95.107780456543, -1.65994391323059, 218, 16, 'PPL', 'P'),
(14015, 'Indiantown Farms', 38.6208305358887, 0.674060652706023, -75.2133331298828, -1.31272030451579, 218, 10, 'PPL', 'P'),
(778, 'Indianview', 39.2219390869141, 0.684551976083309, -84.3011093139648, -1.47133192061234, 218, 41, 'PPL', 'P'),
(81720, 'Indigo Run', 32.2019386291504, 0.562029854603824, -80.7305603027344, -1.40901408426254, 218, 48, 'PPL', 'P'),
(103075, 'Indigo Terrace', 37.2730598449707, 0.650537616587626, -76.7452774047852, -1.33945777606991, 218, 53, 'PPL', 'P'),
(103076, 'Indika', 36.8202781677246, 0.642635085526979, -76.6838912963867, -1.33838638636337, 218, 53, 'PPL', 'P'),
(182292, 'Indio', 33.7205581665039, 0.588534765615755, -116.214721679688, -2.02832953259938, 218, 6, 'PPL', 'P'),
(191659, 'Indio', 29.7175006866455, 0.51866823244564, -104.537216186523, -1.82451861332394, 218, 51, 'PPL', 'P'),
(182293, 'Indio Hills', 33.8311080932617, 0.590464225825518, -116.230560302734, -2.02860596872053, 218, 6, 'PPL', 'P'),
(95088, 'Indio Number 1 Colonia', 26.5559997558594, 0.463489631898556, -99.0940017700195, -1.72951659986393, 218, 51, 'PPL', 'P'),
(95089, 'Indio Number 2 Colonia', 26.5550003051758, 0.463472188193416, -99.0950012207031, -1.72953404356907, 218, 51, 'PPL', 'P'),
(76179, 'Indogco', 35.1766700744629, 0.613948712687136, -96.5658264160156, -1.68539161586879, 218, 42, 'PPL', 'P'),
(109796, 'Indore', 38.3527793884277, 0.669382277619081, -81.1469421386719, -1.41628131824515, 218, 58, 'PPL', 'P'),
(16544, 'Indrio', 27.5202808380127, 0.480319511696826, -80.3530578613281, -1.40242542372569, 218, 12, 'PPL', 'P'),
(136067, 'Indus', 48.6252784729004, 0.848671209051232, -93.8375015258789, -1.63777336347179, 218, 28, 'PPL', 'P'),
(60378, 'Industrial', 30.5761108398438, 0.533653806610002, -89.7633285522461, -1.56666563078613, 218, 30, 'PPL', 'P'),
(109783, 'Industrial', 39.2700004577637, 0.685390805247657, -80.3202819824219, -1.40185337672354, 218, 58, 'PPL', 'P'),
(3342, 'Industrial City', 33.4438896179199, 0.583705988506251, -86.9819412231445, -1.51812126412006, 218, 2, 'PPL', 'P'),
(3343, 'Industry', 31.6041698455811, 0.551596821164897, -86.6127777099609, -1.51167814533677, 218, 2, 'PPL', 'P'),
(32838, 'Industry', 39.1333312988281, 0.6830054784383, -97.1711120605469, -1.69595584328091, 218, 20, 'PPL', 'P'),
(95090, 'Industry', 29.9722194671631, 0.523113913832336, -96.5019378662109, -1.68427655032037, 218, 51, 'PPL', 'P'),
(120117, 'Industry', 40.3277816772461, 0.703852570293386, -90.6069412231445, -1.58138944950485, 218, 18, 'PPL', 'P'),
(155843, 'Industry', 41.077220916748, 0.716932752566337, -81.1944427490234, -1.41711036029249, 218, 41, 'PPL', 'P'),
(163006, 'Industry', 40.2644386291504, 0.702747025545866, -79.7925033569336, -1.39264190198712, 218, 45, 'PPL', 'P'),
(182294, 'Industry', 34.019718170166, 0.593756092669938, -117.957778930664, -2.05875162067968, 218, 6, 'PPL', 'P'),
(36567, 'Inez', 37.8663902282715, 0.660893185328345, -82.5388870239258, -1.44057533949913, 218, 21, 'PPL', 'P'),
(65862, 'Inez', 36.2719383239746, 0.633064749833671, -78.0919418334961, -1.3629615042704, 218, 33, 'PPL', 'P'),
(95091, 'Inez', 28.9036102294922, 0.504463164217753, -96.7877807617188, -1.68926544999042, 218, 51, 'PPL', 'P'),
(109784, 'Inez', 38.3572196960449, 0.669459775606802, -82.2388916015625, -1.43533943163798, 218, 58, 'PPL', 'P'),
(136069, 'Inez', 47.860279083252, 0.83531945092612, -94.5800018310547, -1.65073243849417, 218, 28, 'PPL', 'P'),
(142113, 'Inez', 42.2911109924316, 0.738119131144299, -99.001106262207, -1.72789526739229, 218, 35, 'PPL', 'P'),
(163000, 'Inez', 41.7200012207031, 0.728151385237323, -78.0219421386719, -1.36173977912033, 218, 45, 'PPL', 'P'),
(188719, 'Inez', 33.9666709899902, 0.592830244716972, -103.143333435059, -1.80019076992413, 218, 38, 'PPL', 'P'),
(155844, 'Infant of Prague Villa', 40.9936103820801, 0.715473473447028, -81.5205612182617, -1.42280220133227, 218, 41, 'PPL', 'P'),
(196766, 'Inga (historical)', 48.1041717529297, 0.839576181033475, -110.330558776855, -1.92563151622126, 218, 31, 'PPL', 'P'),
(9659, 'Ingalls', 33.3833312988281, 0.582649046448626, -92.1508331298828, -1.60833544657233, 218, 4, 'PPL', 'P'),
(30145, 'Ingalls', 39.9569396972656, 0.697380156738111, -85.8052825927734, -1.49758469684807, 218, 19, 'PPL', 'P'),
(65863, 'Ingalls', 35.9713897705078, 0.627819188013569, -82.0119400024414, -1.43137837899065, 218, 33, 'PPL', 'P'),
(76180, 'Ingalls', 36.1016693115234, 0.630092994952278, -96.8811111450195, -1.69089437247116, 218, 42, 'PPL', 'P'),
(127804, 'Ingalls', 43.985279083252, 0.76768794241134, -70.7261123657227, -1.23440352791734, 218, 26, 'PPL', 'P'),
(131438, 'Ingalls', 45.3769416809082, 0.791977036817298, -87.6111068725586, -1.52910227624278, 218, 27, 'PPL', 'P'),
(187725, 'Ingalls', 37.8277816772461, 0.660219338993527, -100.454170227051, -1.7532560178209, 218, 20, 'PPL', 'P'),
(55473, 'Ingalls (historical)', 37.788890838623, 0.659540565810693, -93.2008285522461, -1.62666132382343, 218, 29, 'PPL', 'P'),
(149811, 'Ingalls Crossing', 43.3047218322754, 0.755809977633477, -76.3488922119141, -1.33253954934816, 218, 40, 'PPL', 'P'),
(120119, 'Ingalls Park', 41.5224990844727, 0.724704322680379, -88.0427780151367, -1.53663635896661, 218, 18, 'PPL', 'P'),
(30146, 'Ingallston', 39.7249984741211, 0.693332018723137, -86.084716796875, -1.50246174375234, 218, 19, 'PPL', 'P'),
(131439, 'Ingallston', 45.2113914489746, 0.789087640192617, -87.5274963378906, -1.52764299712347, 218, 27, 'PPL', 'P'),
(120120, 'Ingalton', 41.9061088562012, 0.731399576239865, -88.20361328125, -1.53944346391361, 218, 18, 'PPL', 'P'),
(195135, 'Ingard', 44.0336112976074, 0.768531498686622, -116.922218322754, -2.0406776784677, 218, 17, 'PPL', 'P'),
(3344, 'Ingate', 32.9683303833008, 0.575405914073883, -87.2158279418945, -1.52220335743893, 218, 2, 'PPL', 'P'),
(170593, 'Ingberg Tracts', 43.5588912963867, 0.760246071640249, -96.6458282470703, -1.68678791122832, 218, 49, 'PPL', 'P'),
(136070, 'Inger', 47.5541687011719, 0.829976816884285, -93.9850006103516, -1.64034770813952, 218, 28, 'PPL', 'P'),
(76181, 'Ingersoll', 36.7963905334473, 0.642218167658327, -98.3944396972656, -1.7173069383723, 218, 42, 'PPL', 'P'),
(174629, 'Ingersoll', 44.8519401550293, 0.782814031612717, -89.2597198486328, -1.55787600076638, 218, 57, 'PPL', 'P'),
(103077, 'Ingersoll (historical)', 37.1966705322266, 0.649204371566905, -76.815559387207, -1.340684428068, 218, 53, 'PPL', 'P'),
(116136, 'Ingersoll (historical)', 41.7319412231445, 0.728359777592622, -93.8208312988281, -1.6374824131227, 218, 16, 'PPL', 'P'),
(103078, 'Ingham', 38.5288887023926, 0.672455964991196, -78.5783309936523, -1.37145059656114, 218, 53, 'PPL', 'P'),
(72998, 'Ingham (historical)', 39.3138885498047, 0.68615679695619, -82.2966690063477, -1.43634783758474, 218, 41, 'PPL', 'P'),
(149812, 'Ingham Mills', 43.0574989318848, 0.751495124035331, -74.7641677856445, -1.30488089037298, 218, 40, 'PPL', 'P'),
(149813, 'Ingham Mills Station', 43.0463905334473, 0.751301245907973, -74.7844390869141, -1.30523469132379, 218, 40, 'PPL', 'P'),
(16545, 'Ingle', 30.4188899993896, 0.530909785291325, -81.9277801513672, -1.42990951249142, 218, 12, 'PPL', 'P'),
(36568, 'Ingle', 37.0933303833008, 0.647400745718649, -84.8591690063477, -1.48107189966709, 218, 21, 'PPL', 'P'),
(174630, 'Ingle', 43.624439239502, 0.76139009906552, -89.1277770996094, -1.55557316537179, 218, 57, 'PPL', 'P'),
(182295, 'Ingle', 36.7213897705078, 0.640909157403526, -120.255561828613, -2.09885549774491, 218, 6, 'PPL', 'P'),
(3346, 'Ingle Terrace', 33.5652809143066, 0.585824666311464, -86.7758331298828, -1.51452399927763, 218, 2, 'PPL', 'P'),
(95092, 'Ingle-Doolittle Colonia', 26.3780002593994, 0.460382954618438, -98.1119995117188, -1.71237742719456, 218, 51, 'PPL', 'P'),
(163001, 'Ingleby', 40.8472213745117, 0.712918503276233, -77.4277801513672, -1.35136969615167, 218, 45, 'PPL', 'P'),
(103079, 'Inglecress', 38.0786094665527, 0.664597109772427, -78.5408325195313, -1.37079612472325, 218, 53, 'PPL', 'P'),
(30147, 'Inglefield', 38.1080589294434, 0.665111099862812, -87.5588912963867, -1.52819094251775, 218, 19, 'PPL', 'P'),
(3345, 'Inglenook', 33.565559387207, 0.585829526580453, -86.7786102294922, -1.51457246880947, 218, 2, 'PPL', 'P'),
(22161, 'Inglenook', 33.9183311462402, 0.591986555283634, -84.0266723632813, -1.46654209223378, 218, 13, 'PPL', 'P'),
(163002, 'Inglenook', 40.4130592346191, 0.705340944447604, -76.9813919067383, -1.3435787515407, 218, 45, 'PPL', 'P'),
(182296, 'Inglenook', 39.5297203063965, 0.68992377173908, -123.757781982422, -2.15998077055858, 218, 6, 'PPL', 'P'),
(207717, 'Inglesea', 47.4858283996582, 0.828784053611065, -122.355278015137, -2.13550245855717, 218, 56, 'PPL', 'P'),
(9660, 'Ingleside', 35.4894409179688, 0.619407593710554, -91.3197174072266, -1.59382974074688, 218, 4, 'PPL', 'P'),
(22163, 'Ingleside', 33.7813911437988, 0.589596501363343, -84.2658309936523, -1.47071619776832, 218, 13, 'PPL', 'P'),
(36569, 'Ingleside', 37.1233291625977, 0.647924323188958, -88.9013900756836, -1.55162196642049, 218, 21, 'PPL', 'P'),
(41482, 'Ingleside', 30.6044406890869, 0.534148255755889, -91.4280624389648, -1.59572071827889, 218, 22, 'PPL', 'P'),
(48463, 'Ingleside', 39.0922203063965, 0.682287956261605, -75.8772201538086, -1.32430731894456, 218, 25, 'PPL', 'P'),
(60379, 'Ingleside', 32.0355606079102, 0.559126010330228, -90.982780456543, -1.58794908158582, 218, 30, 'PPL', 'P'),
(65864, 'Ingleside', 36.1761093139648, 0.631392218090074, -78.29638671875, -1.36652974065695, 218, 33, 'PPL', 'P'),
(81721, 'Ingleside', 35.144718170166, 0.613391046754874, -82.168327331543, -1.43410785279187, 218, 48, 'PPL', 'P'),
(95093, 'Ingleside', 27.8775005340576, 0.486554171545783, -97.2113876342773, -1.69665878465064, 218, 51, 'PPL', 'P'),
(103083, 'Ingleside', 37.2125015258789, 0.649480674530001, -80.0124969482422, -1.39648151448874, 218, 53, 'PPL', 'P'),
(109785, 'Ingleside', 37.3147201538086, 0.651264726144245, -81.0524978637695, -1.41463295468845, 218, 58, 'PPL', 'P'),
(120121, 'Ingleside', 42.3811111450195, 0.739689930134255, -88.1397171020508, -1.53832826520714, 218, 18, 'PPL', 'P'),
(125141, 'Ingleside', 42.1749992370605, 0.736092598712803, -72.6333312988281, -1.2676907778564, 218, 23, 'PPL', 'P'),
(142114, 'Ingleside', 40.5800018310547, 0.708254642417232, -98.4438934326172, -1.71817006888159, 218, 35, 'PPL', 'P'),
(149814, 'Ingleside', 42.5608291625977, 0.74282660126615, -77.3938903808594, -1.35077820807356, 218, 40, 'PPL', 'P'),
(163003, 'Ingleside', 40.2591705322266, 0.702655079909231, -78.89111328125, -1.37690967732164, 218, 45, 'PPL', 'P'),
(88089, 'Ingleside Hill', 35.4513893127441, 0.618743467913715, -84.57861328125, -1.47617527852882, 218, 50, 'PPL', 'P'),
(95094, 'Ingleside On-the-Bay', 27.8291702270508, 0.485710648560014, -97.2230606079102, -1.69686251647403, 218, 51, 'PPL', 'P'),
(120122, 'Ingleside Shore', 42.401668548584, 0.740048724512116, -88.144172668457, -1.53840602951097, 218, 18, 'PPL', 'P'),
(78504, 'Inglesmith', 39.7513885498047, 0.693792612433666, -78.3819427490234, -1.36802297508015, 218, 45, 'PPL', 'P'),
(48462, 'Ingleton', 38.7772216796875, 0.676790193086273, -76.1650009155273, -1.32933004076045, 218, 25, 'PPL', 'P'),
(3348, 'Ingleton (historical)', 34.7869415283203, 0.607146666367938, -88.0138931274414, -1.53613222257226, 218, 2, 'PPL', 'P'),
(41483, 'Inglewood', 31.2297191619873, 0.545061423849843, -92.4211120605469, -1.61305270381118, 218, 22, 'PPL', 'P'),
(88090, 'Inglewood', 36.214168548584, 0.632056477044967, -86.7302780151367, -1.51372891253419, 218, 50, 'PPL', 'P'),
(103084, 'Inglewood', 38.3902816772461, 0.670036816035995, -78.6650009155273, -1.37296327206031, 218, 53, 'PPL', 'P'),
(142115, 'Inglewood', 41.416389465332, 0.722852360458338, -96.501106262207, -1.68426203609243, 218, 35, 'PPL', 'P'),
(163004, 'Inglewood', 40.2472190856934, 0.702446487816851, -75.3133316040039, -1.31446560713617, 218, 45, 'PPL', 'P'),
(182298, 'Inglewood', 33.961669921875, 0.592742959612244, -118.35221862793, -2.06563589209754, 218, 6, 'PPL', 'P'),
(207719, 'Inglewood', 47.622501373291, 0.831169446999449, -122.066940307617, -2.1304700162033, 218, 56, 'PPL', 'P'),
(16546, 'Inglis', 29.0300006866455, 0.506669093838179, -82.6688919067383, -1.44284435274788, 218, 12, 'PPL', 'P'),
(201024, 'Inglis', 46.1266708374023, 0.805062279096321, -123.163887023926, -2.14961534812183, 218, 43, 'PPL', 'P'),
(109786, 'Ingo', 38.7691688537598, 0.676649644759744, -80.4102783203125, -1.40342410913447, 218, 58, 'PPL', 'P'),
(65865, 'Ingold', 34.8266716003418, 0.607840086936767, -78.3475036621094, -1.36742189962212, 218, 33, 'PPL', 'P'),
(155845, 'Ingold Heights', 40.7994384765625, 0.712084534380875, -81.4702835083008, -1.42192468975309, 218, 41, 'PPL', 'P'),
(60380, 'Ingomar', 34.4091682434082, 0.600553278720147, -89.0366668701172, -1.5539829918849, 218, 30, 'PPL', 'P'),
(72999, 'Ingomar', 39.7119407653809, 0.693104118712853, -84.5, -1.47480321793521, 218, 41, 'PPL', 'P'),
(177390, 'Ingomar', 40.5808296203613, 0.708269090066146, -80.0611114501953, -1.39732999761204, 218, 45, 'PPL', 'P'),
(182299, 'Ingomar', 37.1802787780762, 0.648918281486803, -120.967216491699, -2.11127621475294, 218, 6, 'PPL', 'P'),
(196767, 'Ingomar', 46.5766716003418, 0.812916274046101, -107.371673583984, -1.87398922741715, 218, 31, 'PPL', 'P'),
(60381, 'Ingomar (historical)', 32.6269416809082, 0.569447557188021, -91.0447235107422, -1.58903019183034, 218, 30, 'PPL', 'P'),
(193673, 'Ingot', 40.7277793884277, 0.710833847353947, -122.078056335449, -2.13066402748871, 218, 6, 'PPL', 'P'),
(27514, 'Ingraham', 38.836109161377, 0.677817973529962, -88.3338928222656, -1.54171727085232, 218, 18, 'PPL', 'P'),
(149815, 'Ingraham', 44.8108291625977, 0.782096509436023, -73.4349975585938, -1.28168249359146, 218, 40, 'PPL', 'P'),
(539, 'Ingram', 36.730281829834, 0.641064353116051, -83.7983322143555, -1.46255680482053, 218, 21, 'PPL', 'P'),
(3349, 'Ingram', 32.8699989318848, 0.573689706488408, -87.5419387817383, -1.52789506532065, 218, 2, 'PPL', 'P'),
(9661, 'Ingram', 36.3988914489746, 0.635280499860617, -91.0074996948242, -1.58838051368242, 218, 4, 'PPL', 'P'),
(65866, 'Ingram', 35.1002807617188, 0.612615467666415, -79.9380569458008, -1.39518229135095, 218, 33, 'PPL', 'P'),
(76182, 'Ingram', 35.7063903808594, 0.623194076148428, -97.084716796875, -1.69444796147171, 218, 42, 'PPL', 'P'),
(95095, 'Ingram', 30.077220916748, 0.524946534846961, -99.2399978637695, -1.73206471239492, 218, 51, 'PPL', 'P'),
(103085, 'Ingram', 36.7441711425781, 0.641306767354275, -79.1586074829102, -1.3815783318706, 218, 53, 'PPL', 'P'),
(163005, 'Ingram', 40.4461097717285, 0.705917785139715, -80.0677795410156, -1.39744637775168, 218, 45, 'PPL', 'P'),
(174631, 'Ingram', 45.5050010681152, 0.794212094762147, -90.8122177124023, -1.58497220011933, 218, 57, 'PPL', 'P'),
(182300, 'Ingram', 38.8902816772461, 0.678763462295967, -123.170829772949, -2.14973652195142, 218, 6, 'PPL', 'P'),
(60382, 'Ingram (historical)', 34.4152793884277, 0.600659938321804, -90.3983306884766, -1.57774850882055, 218, 30, 'PPL', 'P'),
(188720, 'Ingram (historical)', 34.1113891601563, 0.59535605327383, -103.763328552246, -1.81101172606534, 218, 38, 'PPL', 'P'),
(81722, 'Ingram Beach', 33.813060760498, 0.590149240447589, -78.6866683959961, -1.3733414409351, 218, 48, 'PPL', 'P'),
(109787, 'Ingram Branch', 38.0177803039551, 0.663535440603867, -81.2391662597656, -1.417890932808, 218, 58, 'PPL', 'P'),
(55474, 'Ingram Ridge', 36.2916717529297, 0.633409163141645, -89.7908325195313, -1.56714566557262, 218, 29, 'PPL', 'P'),
(3350, 'Ingram Wells', 33.7791709899902, 0.589557752369482, -85.9794387817383, -1.50062429575824, 218, 2, 'PPL', 'P'),
(60383, 'Ingrams', 33.4336090087891, 0.583526558027807, -90.8419418334961, -1.58549098389968, 218, 30, 'PPL', 'P'),
(81723, 'Ingrams', 34.4622192382813, 0.60147919325214, -80.2099990844727, -1.39992857704569, 218, 48, 'PPL', 'P'),
(169433, 'Ingrams Corner', 41.8147201538086, 0.72980454248399, -71.3702774047852, -1.24564632877521, 218, 47, 'PPL', 'P'),
(60384, 'Ingrams Mill', 34.8241691589355, 0.60779641109489, -89.7683334350586, -1.56675298246988, 218, 30, 'PPL', 'P'),
(103086, 'Ingramville', 36.8875007629395, 0.643808341145214, -80.0661087036133, -1.39741721613774, 218, 53, 'PPL', 'P'),
(211890, 'Ingrihak', 61.7561111450195, 1.07784747270816, -162.001388549805, -2.82745762299673, 218, 1, 'PPL', 'P'),
(136071, 'Inguadona', 46.9833297729492, 0.820013798088244, -94.129997253418, -1.64287837696536, 218, 28, 'PPL', 'P'),
(211891, 'Iniskin', 59.746940612793, 1.04278083168676, -153.237503051758, -2.67449896578803, 218, 1, 'PPL', 'P'),
(22165, 'Iniss (historical)', 31.378059387207, 0.547650449193077, -83.5436096191406, -1.45811105685481, 218, 13, 'PPL', 'P'),
(9662, 'Ink', 34.5872192382813, 0.603660854817133, -94.123893737793, -1.64277185052176, 218, 4, 'PPL', 'P'),
(55475, 'Ink', 37.2580604553223, 0.650275827852471, -91.4836120605469, -1.59669024207374, 218, 29, 'PPL', 'P'),
(109788, 'Inkerman', 39.1380615234375, 0.683088036432092, -78.7688903808594, -1.37477648528849, 218, 58, 'PPL', 'P'),
(163007, 'Inkerman', 41.2988891601563, 0.720801593260922, -75.8130569458008, -1.32318745970618, 218, 45, 'PPL', 'P'),
(195136, 'Inkom', 42.7963905334473, 0.746937922777987, -112.253326416016, -1.9591901422754, 218, 17, 'PPL', 'P'),
(113114, 'Inkster', 42.2941703796387, 0.738172527524155, -83.3099975585938, -1.4540337572259, 218, 27, 'PPL', 'P'),
(140272, 'Inkster', 48.1513900756836, 0.8404002962328, -97.6438903808594, -1.70420738160242, 218, 34, 'PPL', 'P'),
(131445, 'Inland', 46.0380592346191, 0.803515714872285, -85.8688888549805, -1.49869483554847, 218, 27, 'PPL', 'P'),
(142116, 'Inland', 40.5969390869141, 0.708550253298231, -98.2222213745117, -1.71430116160798, 218, 35, 'PPL', 'P'),
(3351, 'Inland Junction', 33.8491706848145, 0.590779477519556, -86.5652770996094, -1.51084910328943, 218, 2, 'PPL', 'P'),
(125142, 'Inland Park', 41.7347183227539, 0.728408247124461, -70.9458312988281, -1.238238346729, 218, 23, 'PPL', 'P'),
(120123, 'Inlet', 41.7350006103516, 0.728413173972478, -89.2402801513672, -1.5575367140435, 218, 18, 'PPL', 'P'),
(149816, 'Inlet', 43.7544403076172, 0.76365904573524, -74.793327331543, -1.30538982045729, 218, 40, 'PPL', 'P'),
(155846, 'Inlet', 41.6536102294922, 0.72699264384703, -84.1852798461914, -1.46931031502887, 218, 41, 'PPL', 'P'),
(174633, 'Inlet', 42.6272201538086, 0.743985342656444, -88.5849990844727, -1.54609990190021, 218, 57, 'PPL', 'P'),
(16547, 'Inlet Beach', 30.2766704559326, 0.528427585997317, -86.008056640625, -1.50112377162068, 218, 12, 'PPL', 'P'),
(81724, 'Inlet Harbor', 33.5416717529297, 0.585412608711801, -79.0263900756836, -1.37927070278605, 218, 48, 'PPL', 'P'),
(81725, 'Inlet Oaks Village', 33.5277786254883, 0.585170127894549, -79.0663909912109, -1.37996885046581, 218, 48, 'PPL', 'P'),
(16548, 'Inlikita', 25.6022205352783, 0.446843044162312, -80.482780456543, -1.40468951012642, 218, 12, 'PPL', 'P'),
(22166, 'Inman', 33.3852806091309, 0.582683068331552, -84.4119415283203, -1.47326630767012, 218, 13, 'PPL', 'P'),
(27515, 'Inman', 37.8377799987793, 0.660393842623955, -88.1730575561523, -1.53891016590532, 218, 18, 'PPL', 'P'),
(32839, 'Inman', 38.2319412231445, 0.66727325377282, -97.773063659668, -1.70646188062322, 218, 20, 'PPL', 'P'),
(81726, 'Inman', 35.0469398498535, 0.611684493128351, -82.0902786254883, -1.4327456458943, 218, 48, 'PPL', 'P'),
(88091, 'Inman', 35.110279083252, 0.612789971296843, -85.5261077880859, -1.49271217731766, 218, 50, 'PPL', 'P'),
(103087, 'Inman', 36.9102783203125, 0.644205884516935, -82.8027801513672, -1.44518114344637, 218, 53, 'PPL', 'P'),
(142118, 'Inman', 42.3819389343262, 0.739704377783169, -98.5277786254883, -1.71963414169086, 218, 35, 'PPL', 'P'),
(88092, 'Inman (historical)', 36.1452789306641, 0.630854126391823, -83.2180633544922, -1.45242920266913, 218, 50, 'PPL', 'P'),
(81727, 'Inman Mills', 35.041389465332, 0.611587620643699, -82.1044387817383, -1.43299278724345, 218, 48, 'PPL', 'P'),
(22167, 'Inman Park', 33.7574996948242, 0.589179516915664, -84.3627777099609, -1.4724082371669, 218, 13, 'PPL', 'P'),
(3352, 'Inmanfield', 34.2449989318848, 0.597687983703331, -87.1883316040039, -1.5217234558105, 218, 2, 'PPL', 'P'),
(182301, 'Inmans (historical)', 35.4283294677734, 0.618340997693977, -118.350830078125, -2.06561165733162, 218, 6, 'PPL', 'P'),
(41484, 'Innis', 30.8777809143066, 0.538918942664116, -91.6805572509766, -1.6001275840927, 218, 22, 'PPL', 'P'),
(16549, 'Innisbrook', 28.1113891601563, 0.49063629815417, -82.7563934326172, -1.44437154247498, 218, 12, 'PPL', 'P'),
(41485, 'Inniswold', 30.4047203063965, 0.530662477494598, -91.0833282470703, -1.58970397158613, 218, 22, 'PPL', 'P'),
(22168, 'Innsbrook', 33.7902793884277, 0.58975163049684, -84.0088882446289, -1.46623170080873, 218, 13, 'PPL', 'P'),
(55476, 'Innsbrook', 38.7691688537598, 0.676649644759744, -91.0519409179688, -1.5891561593499, 218, 29, 'PPL', 'P'),
(22170, 'Innsbrook West', 33.785831451416, 0.589673999351064, -84.0186080932617, -1.46640134417017, 218, 13, 'PPL', 'P'),
(3353, 'Innsbrooke', 33.7041702270508, 0.588248742114681, -86.6616668701172, -1.51253142215003, 218, 2, 'PPL', 'P'),
(3354, 'Ino', 31.271110534668, 0.54578383958504, -86.0947189331055, -1.50263631396179, 218, 2, 'PPL', 'P'),
(103088, 'Ino', 37.7622184753418, 0.659075045252148, -76.7980575561523, -1.34037896349097, 218, 53, 'PPL', 'P'),
(177423, 'Ino', 46.5308303833008, 0.812116193875614, -91.1786117553711, -1.59136698252883, 218, 57, 'PPL', 'P'),
(76183, 'Inola', 36.1511116027832, 0.630955925724491, -95.5091705322266, -1.6669494916361, 218, 42, 'PPL', 'P'),
(182302, 'Inperial Gables', 33.127498626709, 0.578183923985972, -114.928329467773, -2.00587775302947, 218, 6, 'PPL', 'P'),
(36572, 'Inroad', 36.9563903808594, 0.645010691798357, -85.2797164916992, -1.48841183794746, 218, 21, 'PPL', 'P'),
(36570, 'Insco', 36.9811096191406, 0.64544212389495, -86.8644409179688, -1.51607049692264, 218, 21, 'PPL', 'P'),
(41487, 'Insco (historical)', 30.639440536499, 0.534759118330926, -93.2458267211914, -1.6274466900289, 218, 22, 'PPL', 'P'),
(88093, 'Inskip', 36.0130615234375, 0.628546497307269, -83.958610534668, -1.46535418922955, 218, 50, 'PPL', 'P'),
(182303, 'Inskip', 39.9900016784668, 0.697957197167304, -121.540000915527, -2.12127318885287, 218, 6, 'PPL', 'P'),
(186885, 'Insmont', 39.3919410705566, 0.687519070432793, -105.452499389648, -1.84049331880668, 218, 7, 'PPL', 'P'),
(60387, 'Insmore', 32.0138893127441, 0.55874777487641, -90.7319412231445, -1.58357111106984, 218, 30, 'PPL', 'P'),
(178413, 'Inspiration', 33.4124984741211, 0.583158109690994, -110.882781982422, -1.93526962936431, 218, 5, 'PPL', 'P'),
(95096, 'Inspiration Colonia', 26.2800006866455, 0.458672539408335, -98.3379974365234, -1.71632183508508, 218, 51, 'PPL', 'P'),
(95097, 'Inspiration Heights Colonia', 26.2910003662109, 0.458864520033416, -98.3359985351563, -1.7162869476748, 218, 51, 'PPL', 'P'),
(95098, 'Inspiration Point Colonia', 26.318000793457, 0.459335766388305, -98.3310012817383, -1.7161997291491, 218, 51, 'PPL', 'P'),
(95099, 'Inspiration Rd Number 1 Colonia', 26.2870006561279, 0.458794711923342, -98.3369979858398, -1.71630439137994, 218, 51, 'PPL', 'P'),
(95100, 'Inspiration Rd Number 2 Colonia', 26.2859992980957, 0.458777234928688, -98.3359985351563, -1.7162869476748, 218, 51, 'PPL', 'P'),
(95101, 'Inspiration Rd Number 3 Colonia', 26.2859992980957, 0.458777234928688, -98.3349990844727, -1.71626950396966, 218, 51, 'PPL', 'P'),
(163009, 'Instanter', 41.6027793884277, 0.726105478308897, -78.557502746582, -1.37108707507235, 218, 45, 'PPL', 'P'),
(60388, 'Institute', 32.3355598449707, 0.564361984770406, -90.6305618286133, -1.58180170684159, 218, 30, 'PPL', 'P'),
(65868, 'Institute', 35.3574981689453, 0.617104758315962, -77.7141723632813, -1.35636818320164, 218, 33, 'PPL', 'P'),
(109789, 'Institute', 38.3836097717285, 0.669920369317332, -81.7655563354492, -1.4270781727785, 218, 58, 'PPL', 'P'),
(174640, 'Institute', 44.8933296203613, 0.783536414058401, -87.2869415283203, -1.52344452366496, 218, 57, 'PPL', 'P'),
(36571, 'Insull', 36.7633285522461, 0.641641127229135, -83.4880599975586, -1.45714153305997, 218, 21, 'PPL', 'P'),
(196768, 'Intake', 47.2938919067383, 0.825434129854882, -104.521392822266, -1.8242424435189, 218, 31, 'PPL', 'P'),
(16550, 'Interama', 25.9177799224854, 0.45235059445465, -80.1361083984375, -1.39863894128781, 218, 12, 'PPL', 'P'),
(207723, 'Interbay', 47.6413917541504, 0.831499146342401, -122.394721984863, -2.13619088569895, 218, 56, 'PPL', 'P'),
(16551, 'Intercession City', 28.2622203826904, 0.4932687996022, -81.508056640625, -1.42258395528093, 218, 12, 'PPL', 'P'),
(207720, 'Intercity', 47.9150009155273, 0.83627452707205, -122.23388671875, -2.13338378075196, 218, 56, 'PPL', 'P'),
(3355, 'Intercourse', 32.4161109924316, 0.565767867509859, -88.2402801513672, -1.54008342152356, 218, 2, 'PPL', 'P'),
(163010, 'Intercourse', 40.0374984741211, 0.698786172635619, -76.1052780151367, -1.32828767950979, 218, 45, 'PPL', 'P'),
(202249, 'Interior', 43.7269401550293, 0.763179077527781, -101.983612060547, -1.77994981353314, 218, 49, 'PPL', 'P'),
(16552, 'Interlachen', 29.6236095428467, 0.517029522847887, -81.8905563354492, -1.42925983434349, 218, 12, 'PPL', 'P'),
(201025, 'Interlachen', 45.5519409179688, 0.795031349692483, -122.445556640625, -2.13707811781611, 218, 43, 'PPL', 'P'),
(125143, 'Interlaken', 42.3144416809082, 0.738526328474972, -73.3311080932617, -1.27986928036328, 218, 23, 'PPL', 'P'),
(145489, 'Interlaken', 40.2333297729492, 0.702204073578626, -74.01611328125, -1.29182487628692, 218, 37, 'PPL', 'P'),
(149818, 'Interlaken', 42.6169395446777, 0.743805912178, -76.7252807617188, -1.33910876880906, 218, 40, 'PPL', 'P'),
(182304, 'Interlaken', 36.9513893127441, 0.64492340669363, -121.732780456543, -2.12463782657408, 218, 6, 'PPL', 'P'),
(207721, 'Interlaken', 47.1558303833008, 0.823024501700578, -122.540557861328, -2.1387362019108, 218, 56, 'PPL', 'P'),
(140275, 'Interlaken (historical)', 47.5800018310547, 0.830427690056835, -97.6333312988281, -1.70402309085498, 218, 34, 'PPL', 'P'),
(149819, 'Interlaken Beach', 42.6263885498047, 0.743970828428503, -76.6875, -1.33844937012315, 218, 40, 'PPL', 'P'),
(113587, 'Interlaken Estates', 41.9486083984375, 0.73214133318248, -73.4402770996094, -1.28177463896518, 218, 8, 'PPL', 'P'),
(143992, 'Interlaken Park', 43.6027793884277, 0.761012063348783, -71.4552764892578, -1.24712984266044, 218, 36, 'PPL', 'P'),
(131448, 'Interlochen', 44.644718170166, 0.779197325694335, -85.767219543457, -1.49692037131415, 218, 27, 'PPL', 'P'),
(109790, 'Intermont', 39.146110534668, 0.683228518179594, -78.5472183227539, -1.37090757801487, 218, 58, 'PPL', 'P'),
(136074, 'International Falls', 48.6011085510254, 0.848249364334564, -93.4108276367188, -1.63032649927366, 218, 28, 'PPL', 'P'),
(204453, 'International Gardens', 40.6483306884766, 0.70944720595337, -111.836112976074, -1.95190839406485, 218, 52, 'PPL', 'P'),
(103089, 'Intersections', 38.6336097717285, 0.674283692447318, -78.5805587768555, -1.37148947871306, 218, 53, 'PPL', 'P'),
(3356, 'Interurban Heights', 33.4813919067383, 0.584360526923165, -86.9141693115234, -1.5169384211219, 218, 2, 'PPL', 'P'),
(103091, 'Intervale', 37.2980613708496, 0.650973975532235, -79.977783203125, -1.39587564534075, 218, 53, 'PPL', 'P'),
(127805, 'Intervale', 43.9519386291504, 0.767106041713157, -70.2633285522461, -1.22632642664723, 218, 26, 'PPL', 'P'),
(143993, 'Intervale', 44.0741691589355, 0.769239366904365, -71.1405563354492, -1.2416369397541, 218, 36, 'PPL', 'P'),
(172143, 'Intervale', 43.1441688537598, 0.753007799534496, -72.8891677856445, -1.27215596689808, 218, 55, 'PPL', 'P'),
(174634, 'Interwald', 45.2238883972168, 0.789305753085894, -90.1163864135742, -1.57282765291635, 218, 57, 'PPL', 'P'),
(204454, 'Interwest Condominium Project Phase A', 41.2125015258789, 0.719293844609774, -112.004173278809, -1.95484159968946, 218, 52, 'PPL', 'P'),
(41488, 'Intracoastal City', 29.7841701507568, 0.519831834104923, -92.1561126708984, -1.60842759194604, 218, 22, 'PPL', 'P'),
(136076, 'Inver Grove Heights', 44.8480606079102, 0.782746320742002, -93.0425033569336, -1.62389802787637, 218, 28, 'PPL', 'P'),
(103092, 'Invermay', 36.6269416809082, 0.639260727267794, -78.1922225952148, -1.3647117337388, 218, 53, 'PPL', 'P'),
(3357, 'Inverness', 32.014720916748, 0.558762289104351, -85.7461090087891, -1.49655192297734, 218, 2, 'PPL', 'P'),
(16553, 'Inverness', 28.8355598449707, 0.503275460950604, -82.3305587768555, -1.43693932566284, 218, 12, 'PPL', 'P'),
(48464, 'Inverness', 39.2625007629395, 0.685259910880079, -76.4925003051758, -1.33504598340808, 218, 25, 'PPL', 'P'),
(60389, 'Inverness', 33.3536109924316, 0.582130329247306, -90.5924987792969, -1.58113738130767, 218, 30, 'PPL', 'P'),
(65870, 'Inverness', 35.1813888549805, 0.614031070943847, -79.2408294677734, -1.38301337622399, 218, 33, 'PPL', 'P'),
(120124, 'Inverness', 42.1180610656738, 0.73509884015204, -88.0961074829102, -1.5375671337676, 218, 18, 'PPL', 'P'),
(122871, 'Inverness', 41.7005615234375, 0.727812098514447, -85.0936126708984, -1.48516371352394, 218, 19, 'PPL', 'P'),
(149820, 'Inverness', 42.8927803039551, 0.74862024163859, -77.8697204589844, -1.35908300961687, 218, 40, 'PPL', 'P'),
(182305, 'Inverness', 38.1011085510254, 0.664989792875159, -122.855827331543, -2.14423869219706, 218, 6, 'PPL', 'P'),
(196769, 'Inverness', 48.5566711425781, 0.847473785246105, -110.683326721191, -1.93178847834541, 218, 31, 'PPL', 'P'),
(3359, 'Inverness Cliffs', 33.4069404602051, 0.583061104048288, -86.7033309936523, -1.51325859828568, 218, 2, 'PPL', 'P'),
(22178, 'Inverness Farms', 33.976390838623, 0.59299988807841, -83.4644393920898, -1.45672927572322, 218, 13, 'PPL', 'P'),
(182306, 'Inverness Park', 38.0638885498047, 0.664340181306261, -122.821670532227, -2.14364254358705, 218, 6, 'PPL', 'P'),
(3360, 'Inverness Point', 33.4183311462402, 0.583259909023663, -86.7200012207031, -1.51354954863477, 218, 2, 'PPL', 'P'),
(41489, 'Invincible', 32.7872200012207, 0.572244941597041, -93.4075012207031, -1.63026844236189, 218, 22, 'PPL', 'P'),
(27, 'Inwood', 32.9305610656738, 0.574746715125061, -96.8213882446289, -1.68985201122051, 218, 51, 'PPL', 'P'),
(16555, 'Inwood', 28.0366706848145, 0.489332214747386, -81.7652816772461, -1.42707337908854, 218, 12, 'PPL', 'P'),
(48465, 'Inwood', 39.3022193908691, 0.685953131711827, -77.0205612182617, -1.34426238499252, 218, 25, 'PPL', 'P'),
(60390, 'Inwood', 33.5058288574219, 0.584787032171741, -90.5247192382813, -1.57995440515146, 218, 30, 'PPL', 'P'),
(109791, 'Inwood', 39.357780456543, 0.686922855243752, -78.040283203125, -1.36205989108336, 218, 58, 'PPL', 'P'),
(116140, 'Inwood', 43.3072204589844, 0.755853586896327, -96.4316711425781, -1.68305016463839, 218, 16, 'PPL', 'P'),
(122872, 'Inwood', 41.3175010681152, 0.721126432334885, -86.2030563354492, -1.50452715833575, 218, 19, 'PPL', 'P'),
(149822, 'Inwood', 40.8655586242676, 0.713238548660234, -73.9272232055664, -1.29027345179389, 218, 40, 'PPL', 'P'),
(163011, 'Inwood', 40.4755592346191, 0.7064317752301, -76.521110534668, -1.33554532611247, 218, 45, 'PPL', 'P'),
(193674, 'Inwood', 40.524169921875, 0.707280191774372, -121.956108093262, -2.12853562914552, 218, 6, 'PPL', 'P'),
(182308, 'Inyokern', 35.6469383239746, 0.622156442008706, -117.811668395996, -2.05620151077788, 218, 6, 'PPL', 'P'),
(204455, 'Ioka', 40.2586097717285, 0.702645292792225, -110.113059997559, -1.92183544640346, 218, 52, 'PPL', 'P'),
(116141, 'Ioka (historical)', 41.1824989318848, 0.718770200560437, -92.1288909912109, -1.60795248400757, 218, 16, 'PPL', 'P'),
(16556, 'Iola', 30.148609161377, 0.526192494762954, -85.165283203125, -1.48641460028795, 218, 12, 'PPL', 'P'),
(27516, 'Iola', 38.8344383239746, 0.677788811916025, -88.628059387207, -1.54685144595983, 218, 18, 'PPL', 'P'),
(32840, 'Iola', 37.9244384765625, 0.661906318386038, -95.3997192382813, -1.66503920618618, 218, 20, 'PPL', 'P'),
(95102, 'Iola', 30.7716693878174, 0.537066947152561, -96.0747222900391, -1.67682023190037, 218, 51, 'PPL', 'P'),
(112346, 'Iola', 36.8997192382813, 0.644021593769502, -88.4147186279297, -1.54312794728174, 218, 21, 'PPL', 'P'),
(163012, 'Iola', 41.1363906860352, 0.717965459858042, -76.5319366455078, -1.33573427739182, 218, 45, 'PPL', 'P'),
(174635, 'Iola', 44.5080604553223, 0.77681219862206, -89.1305618286133, -1.55562176806168, 218, 57, 'PPL', 'P'),
(116142, 'Iola (historical)', 41.3327789306641, 0.721393081339029, -95.3797225952148, -1.66469019892533, 218, 16, 'PPL', 'P'),
(186886, 'Iola (historical)', 38.4749984741211, 0.671515403073207, -107.096672058105, -1.86918954534255, 218, 7, 'PPL', 'P'),
(191660, 'Iolanthe (historical)', 32.0485801696777, 0.559353244550239, -101.022521972656, -1.76317562709117, 218, 51, 'PPL', 'P'),
(16557, 'Iolee (historical)', 30.2666702270508, 0.528253049077376, -85.1333312988281, -1.48585693435569, 218, 12, 'PPL', 'P'),
(116143, 'Ion', 43.1127815246582, 0.752459987298267, -91.2619400024414, -1.59282133480012, 218, 16, 'PPL', 'P'),
(16558, 'Iona', 26.5200004577637, 0.462861325618379, -81.9641723632813, -1.4305446764114, 218, 12, 'PPL', 'P'),
(30149, 'Iona', 38.5486106872559, 0.672800178562089, -87.4716720581055, -1.52666867963867, 218, 19, 'PPL', 'P'),
(70974, 'Iona', 39.601390838623, 0.691174658503091, -75.067497253418, -1.31017498830394, 218, 37, 'PPL', 'P'),
(76185, 'Iona', 34.6169395446777, 0.604179572018453, -97.0294418334961, -1.69348323136683, 218, 42, 'PPL', 'P'),
(95103, 'Iona', 32.6811103820801, 0.570392979374999, -97.5538864135742, -1.70263651603343, 218, 51, 'PPL', 'P'),
(136078, 'Iona', 43.9155616760254, 0.766471144109282, -95.7838897705078, -1.67174424686268, 218, 28, 'PPL', 'P'),
(163013, 'Iona', 40.3211097717285, 0.703736123574722, -76.3713912963867, -1.33293223245089, 218, 45, 'PPL', 'P'),
(170594, 'Iona', 43.5430603027344, 0.759969768677154, -99.4244384765625, -1.73528380836255, 218, 49, 'PPL', 'P'),
(195137, 'Iona', 43.5263900756836, 0.759678818328063, -111.932220458984, -1.95358578607744, 218, 17, 'PPL', 'P'),
(9667, 'Ione', 35.0636100769043, 0.611975443477442, -94.0472183227539, -1.64143361207399, 218, 4, 'PPL', 'P'),
(22172, 'Ione', 31.0122203826904, 0.541265354032044, -83.73388671875, -1.46143201873414, 218, 13, 'PPL', 'P'),
(182309, 'Ione', 38.3527793884277, 0.669382277619081, -120.931671142578, -2.110655831377, 218, 6, 'PPL', 'P'),
(190335, 'Ione', 38.9483299255371, 0.67977659535366, -117.586669921875, -2.0522745465925, 218, 39, 'PPL', 'P'),
(201026, 'Ione', 45.5013885498047, 0.79414904442334, -119.823608398438, -2.09131648817306, 218, 43, 'PPL', 'P'),
(207722, 'Ione', 48.7411117553711, 0.850692881213739, -117.416107177734, -2.04929766512601, 218, 56, 'PPL', 'P'),
(9664, 'Ionia', 36.3325004577637, 0.634121758470323, -94.5144424438477, -1.64958821133182, 218, 4, 'PPL', 'P'),
(32843, 'Ionia', 39.663890838623, 0.692265489285587, -98.3472213745117, -1.71648282317297, 218, 20, 'PPL', 'P'),
(55477, 'Ionia', 38.5041694641113, 0.672024532894603, -93.3238906860352, -1.62880916324258, 218, 29, 'PPL', 'P'),
(116144, 'Ionia', 43.0341682434082, 0.751087926704658, -92.4558334350586, -1.61365870611723, 218, 16, 'PPL', 'P'),
(131451, 'Ionia', 42.9872207641602, 0.750268538616268, -85.0711135864258, -1.48477103042121, 218, 27, 'PPL', 'P'),
(149824, 'Ionia', 42.9313888549805, 0.749294087973408, -77.4922180175781, -1.35249434908001, 218, 40, 'PPL', 'P'),
(142120, 'Ionia (historical)', 42.6683311462402, 0.744702864833138, -96.7805633544922, -1.68913948247086, 218, 35, 'PPL', 'P'),
(204456, 'Iosepa (historical)', 40.5372200012207, 0.707507958626601, -112.743606567383, -1.96774714517393, 218, 52, 'PPL', 'P'),
(41490, 'Iota', 30.3311100006104, 0.52937773529523, -92.4955596923828, -1.61435206010703, 218, 22, 'PPL', 'P'),
(65871, 'Iotla', 35.2361106872559, 0.614986147089777, -83.3952789306641, -1.45552219795914, 218, 33, 'PPL', 'P'),
(65872, 'Iotla (historical)', 35.2344398498535, 0.61495698547584, -83.3994369506836, -1.45559476909885, 218, 33, 'PPL', 'P'),
(41491, 'Iowa', 30.2366695404053, 0.527729438317553, -93.0136108398438, -1.62339375832396, 218, 22, 'PPL', 'P'),
(116152, 'Iowa', 42.0002784729004, 0.733043146106608, -93.5002822875977, -1.63188777746271, 218, 16, 'ADM1', 'A'),
(163014, 'Iowa', 41.1238899230957, 0.717747280385738, -79.0077819824219, -1.37894593029111, 218, 45, 'PPL', 'P'),
(116145, 'Iowa Center', 41.9286117553711, 0.731792325921625, -93.4049987792969, -1.63022476652001, 218, 16, 'PPL', 'P'),
(16559, 'Iowa City', 28.6911106109619, 0.500754346215167, -81.1513900756836, -1.41635894939093, 218, 12, 'PPL', 'P'),
(116146, 'Iowa City', 41.6611099243164, 0.727123538214607, -91.5299987792969, -1.59749984304512, 218, 16, 'PPL', 'P'),
(182311, 'Iowa City', 39.2916717529297, 0.685769040701475, -121.476387023926, -2.12016291699442, 218, 6, 'PPL', 'P'),
(95104, 'Iowa Colony', 29.4822196960449, 0.514561804492306, -95.415283203125, -1.66531084861737, 218, 51, 'PPL', 'P'),
(116148, 'Iowa Falls', 42.5224990844727, 0.742157615200322, -93.251106262207, -1.62753883540262, 218, 16, 'PPL', 'P'),
(116149, 'Iowa Falls Junction', 42.5152816772461, 0.742031647680761, -93.2633285522461, -1.62775215460593, 218, 16, 'PPL', 'P'),
(182310, 'Iowa Hill', 39.1086082458496, 0.68257397976268, -120.858329772949, -2.10937578299905, 218, 6, 'PPL', 'P'),
(120125, 'Iowa Junction', 40.6872215270996, 0.710125979136203, -91.0599975585938, -1.58929677425546, 218, 18, 'PPL', 'P'),
(116150, 'Iowa Junction (historical)', 41.4925003051758, 0.724180745210069, -91.5350036621094, -1.59758719472888, 218, 16, 'PPL', 'P'),
(95105, 'Iowa Park', 33.9513893127441, 0.5925635291338, -98.668327331543, -1.72208717937094, 218, 51, 'PPL', 'P'),
(32846, 'Iowa Point', 39.9283294677734, 0.696880814033722, -95.2383270263672, -1.66222238070121, 218, 20, 'PPL', 'P'),
(120126, 'Ipava', 40.351390838623, 0.704264627893048, -90.3244400024414, -1.57645887306268, 218, 18, 'PPL', 'P'),
(88094, 'Ipe (historical)', 35.5411109924316, 0.620309406634682, -84.0386123657227, -1.46675048458908, 218, 50, 'PPL', 'P'),
(55478, 'Ipley', 36.2947196960449, 0.633462359784419, -90.0286102294922, -1.57129566949929, 218, 29, 'PPL', 'P'),
(125144, 'Ipswich', 42.6791687011719, 0.744892015849561, -70.841667175293, -1.23642033981085, 218, 23, 'PPL', 'P'),
(170599, 'Ipswich', 45.4444389343262, 0.793155086125495, -99.0288925170898, -1.72838022902679, 218, 49, 'PPL', 'P'),
(174639, 'Ipswich', 42.7075004577637, 0.745386498284962, -90.4102783203125, -1.5779570343339, 218, 57, 'PPL', 'P'),
(55479, 'Ira', 37.8727798461914, 0.661004705198992, -92.8494415283203, -1.62052846330715, 218, 29, 'PPL', 'P'),
(103093, 'Ira', 37.4291687011719, 0.653262230119859, -82.0902786254883, -1.4327456458943, 218, 53, 'PPL', 'P'),
(109792, 'Ira', 38.5627784729004, 0.673047453069303, -80.9608306884766, -1.41303306066358, 218, 58, 'PPL', 'P'),
(113001, 'Ira', 41.7777786254883, 0.729159791184081, -93.2055587768555, -1.62674388181723, 218, 16, 'PPL', 'P'),
(149825, 'Ira', 43.2213897705078, 0.754355558783158, -76.5566711425781, -1.33616597580452, 218, 40, 'PPL', 'P'),
(155847, 'Ira', 41.1813888549805, 0.718750826063507, -81.5844421386719, -1.42391713372263, 218, 41, 'PPL', 'P'),
(172144, 'Ira', 43.5344390869141, 0.759819300075564, -73.0625, -1.27518118473836, 218, 55, 'PPL', 'P'),
(191661, 'Ira', 32.5819396972656, 0.56866212440353, -101.001670837402, -1.76281170612821, 218, 51, 'PPL', 'P'),
(191662, 'Iraan', 30.913890838623, 0.539549179736083, -101.897499084473, -1.77844685857196, 218, 51, 'PPL', 'P'),
(36573, 'Irad', 38.0919418334961, 0.664829803472673, -82.7386093139648, -1.44406115104993, 218, 21, 'PPL', 'P'),
(172146, 'Irasburg', 44.8033294677734, 0.781965615068445, -72.2799987792969, -1.26152396203621, 218, 55, 'PPL', 'P'),
(172148, 'Irasville', 44.1813888549805, 0.771110703623337, -72.8408279418945, -1.27131227746474, 218, 55, 'PPL', 'P'),
(103094, 'Iraville', 38.0886116027832, 0.664771679981881, -77.0725021362305, -1.34516892502758, 218, 53, 'PPL', 'P'),
(95106, 'Irby', 33.1797218322754, 0.579095390869051, -99.522216796875, -1.73699036198907, 218, 51, 'PPL', 'P'),
(103095, 'Irby', 37.0313911437988, 0.646319702053158, -78.0427780151367, -1.36210343376718, 218, 53, 'PPL', 'P'),
(112544, 'Irby', 34.4777793884277, 0.601750769104301, -82.0111083984375, -1.43136386476271, 218, 48, 'PPL', 'P'),
(207724, 'Irby', 47.3594398498535, 0.826578157280153, -118.849998474121, -2.07432378936365, 218, 56, 'PPL', 'P'),
(9666, 'Irby (historical)', 34.9944381713867, 0.610768165976282, -90.3166732788086, -1.57632331816319, 218, 4, 'PPL', 'P'),
(81728, 'Irby (historical)', 34.6930618286133, 0.605508156507266, -79.8244400024414, -1.39319930160327, 218, 48, 'PPL', 'P'),
(65873, 'Iredell', 33.9330596923828, 0.592243616907854, -78.5913925170898, -1.37167856315045, 218, 33, 'PPL', 'P'),
(95107, 'Iredell', 31.9850006103516, 0.558243571903031, -97.8716735839844, -1.70818294847769, 218, 51, 'PPL', 'P'),
(65875, 'Iredell Heights', 35.8377799987793, 0.625487257584068, -80.8733291625977, -1.41150587093648, 218, 33, 'PPL', 'P'),
(30148, 'Ireland', 38.4147186279297, 0.670463321284572, -86.9994430541992, -1.51842672869709, 218, 19, 'PPL', 'P'),
(60391, 'Ireland', 31.3469390869141, 0.547107297488755, -91.2225036621094, -1.59213304081639, 218, 30, 'PPL', 'P'),
(73000, 'Ireland', 39.2555618286133, 0.685138803629508, -81.7716674804688, -1.42718483238016, 218, 41, 'PPL', 'P'),
(95108, 'Ireland', 31.5666694641113, 0.550942316037497, -97.9649963378906, -1.70981173780038, 218, 51, 'PPL', 'P'),
(109793, 'Ireland', 38.815559387207, 0.677459312310155, -80.4619369506836, -1.40432572232152, 218, 58, 'PPL', 'P'),
(143994, 'Ireland', 44.1594390869141, 0.770727607900529, -71.8938903808594, -1.25478509921388, 218, 36, 'PPL', 'P'),
(207725, 'Ireland', 45.6594390869141, 0.796907546680444, -122.371109008789, -2.13577876152026, 218, 56, 'PPL', 'P'),
(127806, 'Ireland Corner', 43.8116683959961, 0.764657864302075, -70.3766708374023, -1.22830462270495, 218, 26, 'PPL', 'P'),
(149827, 'Ireland Corners', 41.6747207641602, 0.727361092183842, -74.133056640625, -1.29386592294635, 218, 40, 'PPL', 'P'),
(48466, 'Ireland Estates', 38.6652793884277, 0.674836431531563, -76.584716796875, -1.33665546481287, 218, 25, 'PPL', 'P'),
(195138, 'Ireland Springs', 42.1650009155273, 0.735918095082376, -112.494720458984, -1.9634032631199, 218, 17, 'PPL', 'P'),
(48467, 'Irelands Corner', 39.3274993896484, 0.686394350925426, -75.8769378662109, -1.32430239209654, 218, 25, 'PPL', 'P'),
(149828, 'Irelandville', 42.4025001525879, 0.740063238740057, -76.9091720581055, -1.34231827739676, 218, 40, 'PPL', 'P'),
(182312, 'Iremel', 34.9233283996582, 0.609527066329278, -120.52555847168, -2.10356782813576, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(139229, 'Irena', 40.5497207641602, 0.707726138098906, -94.39111328125, -1.64743571138076, 218, 29, 'PPL', 'P'),
(41492, 'Irene', 30.6122207641602, 0.534284043681969, -91.2300033569336, -1.59226393518397, 218, 22, 'PPL', 'P'),
(60392, 'Irene', 31.1700000762939, 0.544019129178213, -90.5461120605469, -1.58032778033629, 218, 30, 'PPL', 'P'),
(95109, 'Irene', 31.9919395446777, 0.558364679153602, -96.8711090087891, -1.69071980226171, 218, 51, 'PPL', 'P'),
(112648, 'Irene', 38.1925010681152, 0.666584893210062, -81.8475036621094, -1.42850842344193, 218, 58, 'PPL', 'P'),
(120127, 'Irene', 42.170280456543, 0.736010240456092, -88.9002838134766, -1.55160265850259, 218, 18, 'PPL', 'P'),
(170602, 'Irene', 43.0830612182617, 0.751941270096946, -97.1602783203125, -1.69576675884352, 218, 49, 'PPL', 'P'),
(3361, 'Irene (historical)', 33.9388885498047, 0.592345349661495, -85.7958297729492, -1.49741971401854, 218, 2, 'PPL', 'P'),
(88095, 'Irene (historical)', 35.0058288574219, 0.610966970951656, -89.7594375610352, -1.56659772017833, 218, 50, 'PPL', 'P'),
(116163, 'Ireton', 42.9747200012207, 0.750050359143963, -96.3180618286133, -1.68106730804877, 218, 16, 'PPL', 'P'),
(81729, 'Iris', 34.274169921875, 0.598197113524726, -82.4022216796875, -1.4381900792688, 218, 48, 'PPL', 'P'),
(182313, 'Iris', 33.1952781677246, 0.579366900142185, -115.403610229492, -2.01417296719285, 218, 6, 'PPL', 'P'),
(186887, 'Iris', 38.4161109924316, 0.670487622629519, -106.828330993652, -1.86450611024954, 218, 7, 'PPL', 'P'),
(196770, 'Iris', 46.7255592346191, 0.815514853479746, -113.636390686035, -1.98332916755393, 218, 31, 'PPL', 'P'),
(60393, 'Iris (historical)', 34.2819404602051, 0.598332735003239, -90.4166717529297, -1.57806862078358, 218, 30, 'PPL', 'P'),
(109794, 'Iris (historical)', 39.0336112976074, 0.681265036086906, -81.0552825927734, -1.41468155737834, 218, 58, 'PPL', 'P'),
(103096, 'Irisburg', 36.6205596923828, 0.639149340555202, -79.7586135864258, -1.39205041390901, 218, 53, 'PPL', 'P'),
(41493, 'Irish Bend', 29.8186092376709, 0.520432909562954, -91.4530563354492, -1.59615694406545, 218, 22, 'PPL', 'P'),
(103097, 'Irish Creek', 37.8474998474121, 0.660563485985393, -79.1913909912109, -1.38215051203081, 218, 53, 'PPL', 'P'),
(88097, 'Irish Cut', 35.9594383239746, 0.627610595921188, -83.1613922119141, -1.45144010464027, 218, 50, 'PPL', 'P'),
(109795, 'Irish Hill', 39.458610534668, 0.688682672092076, -77.9574966430664, -1.36061499303394, 218, 58, 'PPL', 'P'),
(163015, 'Irish Meeting House', 40.3944396972656, 0.705015972215587, -75.2055587768555, -1.31258461645825, 218, 45, 'PPL', 'P'),
(193675, 'Irish Place (historical)', 40.1311111450195, 0.700420021964382, -122.533889770508, -2.13861982177116, 218, 6, 'PPL', 'P'),
(127807, 'Irish Settlement', 45.6577796936035, 0.796878584803589, -67.9122161865234, -1.18529177478102, 218, 26, 'PPL', 'P'),
(149830, 'Irish Settlement', 44.4824981689453, 0.776366052560445, -74.8724975585938, -1.30677160158888, 218, 40, 'PPL', 'P'),
(182314, 'Irish Town', 39.8125, 0.694859208450242, -121.624717712402, -2.12275177589009, 218, 6, 'PPL', 'P'),
(149831, 'Irishtown', 43.7988891601563, 0.764434824560781, -73.9408264160156, -1.29051087260507, 218, 40, 'PPL', 'P'),
(163019, 'Irishtown', 40.9761085510254, 0.715168008869996, -78.6661071777344, -1.37298257997821, 218, 45, 'PPL', 'P'),
(182315, 'Irishtown (historical)', 38.3888893127441, 0.670012514691048, -120.673606872559, -2.1061517601834, 218, 6, 'PPL', 'P'),
(9668, 'Irma', 33.5552787780762, 0.585650096102009, -93.283332824707, -1.62810129502484, 218, 4, 'PPL', 'P'),
(36574, 'Irma', 37.3880615234375, 0.652544774522192, -88.2477798461914, -1.54021431589114, 218, 21, 'PPL', 'P'),
(41494, 'Irma', 31.7997207641602, 0.555009828549402, -93.0122222900391, -1.62336952355804, 218, 22, 'PPL', 'P'),
(55480, 'Irma', 36.7458305358887, 0.64133572923113, -93.2811126708984, -1.62806254603098, 218, 29, 'PPL', 'P'),
(113383, 'Irma', 45.351390838623, 0.791531090492764, -89.666389465332, -1.5649737245456, 218, 57, 'PPL', 'P'),
(182316, 'Irma', 34.4294395446777, 0.600907079670964, -119.752502441406, -2.09007545510509, 218, 6, 'PPL', 'P'),
(81731, 'Irmo', 34.0858306884766, 0.594909973791242, -81.1833267211914, -1.41691634900708, 218, 48, 'PPL', 'P'),
(182317, 'Irmulco', 39.4222183227539, 0.688047508172092, -123.516387939453, -2.15576764971407, 218, 6, 'PPL', 'P'),
(27518, 'Iron', 37.9738883972168, 0.662769382316305, -88.2413864135742, -1.54010272944146, 218, 18, 'PPL', 'P'),
(196771, 'Iron', 46.6866683959961, 0.814836080296912, -112.059722900391, -1.95581112348431, 218, 31, 'PPL', 'P'),
(192634, 'Iron Basin', 38.9302787780762, 0.679461543396704, -112.954437255859, -1.97142683485209, 218, 52, 'PPL', 'P'),
(174641, 'Iron Belt', 46.4005584716797, 0.809842520094959, -90.3241729736328, -1.57645421253077, 218, 57, 'PPL', 'P'),
(163024, 'Iron Bridge', 40.1163902282715, 0.700163093498217, -79.5513916015625, -1.38843370799063, 218, 45, 'PPL', 'P'),
(155848, 'Iron Bridge (historical)', 41.1522216796875, 0.718241762821138, -81.5088882446289, -1.42259846950888, 218, 41, 'PPL', 'P'),
(163020, 'Iron Bridge Estates', 40.2066688537598, 0.701738752757162, -75.4416732788086, -1.31670559192904, 218, 45, 'PPL', 'P'),
(55481, 'Iron Center', 38.0347213745117, 0.663831118063893, -91.4511108398438, -1.59612298876155, 218, 29, 'PPL', 'P'),
(3362, 'Iron City', 33.667781829834, 0.587613644773724, -85.6641693115234, -1.49512180547197, 218, 2, 'PPL', 'P'),
(22173, 'Iron City', 31.0133304595947, 0.541284728528974, -84.8130569458008, -1.48026709238567, 218, 13, 'PPL', 'P'),
(88098, 'Iron City', 35.0238914489746, 0.611282222645695, -87.5813903808594, -1.52858362562049, 218, 50, 'PPL', 'P'),
(155849, 'Iron City', 40.3436088562012, 0.704128806677454, -83.754997253418, -1.46180046707095, 218, 41, 'PPL', 'P'),
(163022, 'Iron City', 41.5580596923828, 0.725324972372422, -79.0266723632813, -1.37927562963407, 218, 45, 'PPL', 'P'),
(186888, 'Iron City (historical)', 38.708610534668, 0.675592702702119, -106.337501525879, -1.85593951997108, 218, 7, 'PPL', 'P'),
(211892, 'Iron Creek', 64.9644393920898, 1.13384336410427, -164.654998779297, -2.87377185856597, 218, 1, 'PPL', 'P'),
(81732, 'Iron Crossroads', 32.8727798461914, 0.573738242599275, -80.4888916015625, -1.40479616972808, 218, 48, 'PPL', 'P'),
(88099, 'Iron Divide (historical)', 35.8152809143066, 0.625094574481336, -84.5227813720703, -1.47520082788596, 218, 50, 'PPL', 'P'),
(65876, 'Iron Duff', 35.5788917541504, 0.620968805320585, -82.9705581665039, -1.44810942222296, 218, 33, 'PPL', 'P'),
(149832, 'Iron Furnace', 43.4952812194824, 0.759135866360823, -73.5458297729492, -1.28361688064924, 218, 40, 'PPL', 'P'),
(22174, 'Iron Gate', 33.4747200012207, 0.584244080204501, -84.3536071777344, -1.47224818118539, 218, 13, 'PPL', 'P'),
(81733, 'Iron Gate', 32.9769401550293, 0.575556182938391, -80.1755599975586, -1.39932750158765, 218, 48, 'PPL', 'P'),
(103100, 'Iron Gate', 38.7769393920898, 0.676785266238256, -77.5005569458008, -1.35263989083358, 218, 53, 'PPL', 'P'),
(14017, 'Iron Gates', 39.7861099243164, 0.694398614739713, -75.6833267211914, -1.32092324014739, 218, 10, 'PPL', 'P'),
(55483, 'Iron Gates', 37.0669403076172, 0.64694015200812, -94.5541687011719, -1.65028156532162, 218, 29, 'PPL', 'P'),
(14018, 'Iron Hill', 39.6333312988281, 0.691732124698271, -75.7541732788086, -1.32215974584152, 218, 10, 'PPL', 'P'),
(22175, 'Iron Hill', 34.0805587768555, 0.594817961575579, -84.6938934326172, -1.47818729673237, 218, 13, 'PPL', 'P'),
(36575, 'Iron Hill', 38.4061088562012, 0.670313052420064, -83.0380630493164, -1.44928760468921, 218, 21, 'PPL', 'P'),
(48468, 'Iron Hill', 39.6455612182617, 0.691945577059641, -75.7908325195313, -1.32279957029341, 218, 25, 'PPL', 'P'),
(88100, 'Iron Hill', 35.9891700744629, 0.62812951285959, -87.3227767944336, -1.52406996704697, 218, 50, 'PPL', 'P'),
(88101, 'Iron Hill (historical)', 35.7083282470703, 0.623227898294272, -84.7388916015625, -1.47897266293784, 218, 50, 'PPL', 'P'),
(163023, 'Iron Hill (historical)', 40.6083297729492, 0.708749058273605, -75.3433303833008, -1.31498918460648, 218, 45, 'PPL', 'P'),
(103101, 'Iron Hill Springs', 37.6691703796387, 0.657451049619417, -80.2088928222656, -1.39990926912778, 218, 53, 'PPL', 'P'),
(14019, 'Iron Hills Apartments', 39.6349983215332, 0.691761219733181, -75.7186126708984, -1.32153909614948, 218, 10, 'PPL', 'P'),
(182318, 'Iron Horse', 39.788330078125, 0.694437363733574, -120.495826721191, -2.10304891119735, 218, 6, 'PPL', 'P'),
(136083, 'Iron Junction', 47.4188919067383, 0.827615791419875, -92.6033325195313, -1.61623305078496, 218, 28, 'PPL', 'P'),
(202253, 'Iron Lightning', 45.1797218322754, 0.788534901108371, -101.845832824707, -1.77754511222685, 218, 49, 'PPL', 'P'),
(36576, 'Iron Mound', 37.8147201538086, 0.659991372404216, -84.0438919067383, -1.4668426299628, 218, 21, 'PPL', 'P'),
(55484, 'Iron Mountain', 37.6952781677246, 0.65790671648193, -90.6402816772461, -1.58197135020303, 218, 29, 'PPL', 'P'),
(131459, 'Iron Mountain', 45.8202781677246, 0.799714718206469, -88.0658264160156, -1.53703862944927, 218, 27, 'PPL', 'P'),
(192636, 'Iron Mountain', 37.6175003051758, 0.656549236695289, -113.389999389648, -1.97902882818373, 218, 52, 'PPL', 'P'),
(193676, 'Iron Mountain', 40.6708297729492, 0.709839889056102, -122.523063659668, -2.13843087049182, 218, 6, 'PPL', 'P'),
(55485, 'Iron Mountain Lake', 37.6930618286133, 0.657868034067096, -90.6224975585938, -1.58166095877798, 218, 29, 'PPL', 'P'),
(200010, 'Iron Point (historical)', 40.9477806091309, 0.714673593013623, -117.275833129883, -2.0468494211359, 218, 39, 'PPL', 'P'),
(76192, 'Iron Post', 36.1580581665039, 0.631077166133117, -95.14111328125, -1.66052568077072, 218, 42, 'PPL', 'P'),
(48469, 'Iron Pot Landing', 38.7930603027344, 0.677066629207423, -76.720832824707, -1.33903113766328, 218, 25, 'PPL', 'P'),
(78507, 'Iron Ridge', 39.8405609130859, 0.695348963774708, -76.9119415283203, -1.34236661377055, 218, 45, 'PPL', 'P'),
(174643, 'Iron Ridge', 43.3997192382813, 0.757467995149133, -88.5325012207031, -1.54518364132717, 218, 57, 'PPL', 'P'),
(131461, 'Iron River', 46.0927810668945, 0.804470791018214, -88.642219543457, -1.54709858730899, 218, 27, 'PPL', 'P'),
(174645, 'Iron River', 46.5644416809082, 0.812702821684731, -91.4080581665039, -1.59537157785998, 218, 57, 'PPL', 'P'),
(70975, 'Iron Rock', 39.9594383239746, 0.697423766000961, -75.0252838134766, -1.30943822478837, 218, 37, 'PPL', 'P'),
(196772, 'Iron Rod (historical)', 45.6436080932617, 0.796631243717348, -112.308326721191, -1.96015007869032, 218, 31, 'PPL', 'P'),
(9670, 'Iron Springs', 34.5894393920898, 0.603699603810994, -92.3255615234375, -1.61138503233658, 218, 4, 'PPL', 'P'),
(78508, 'Iron Springs', 39.7755584716797, 0.694214457150334, -77.3969421386719, -1.35083147129537, 218, 45, 'PPL', 'P'),
(178414, 'Iron Springs', 34.5847206115723, 0.603617245554283, -112.56916809082, -1.96470261941575, 218, 5, 'PPL', 'P'),
(192637, 'Iron Springs', 37.7497215270996, 0.65885693235887, -113.23388671875, -1.97630414807247, 218, 52, 'PPL', 'P'),
(207726, 'Iron Springs', 47.1597213745117, 0.823092412308375, -124.187217712402, -2.16747583797244, 218, 56, 'PPL', 'P'),
(22176, 'Iron Springs Crossroads', 33.2880592346191, 0.580986235243008, -83.8947219848633, -1.46423912368114, 218, 13, 'PPL', 'P'),
(22177, 'Iron Stab', 34.0352783203125, 0.594027668522098, -84.9436111450195, -1.48254569301434, 218, 13, 'PPL', 'P'),
(65878, 'Iron Station', 35.4413909912109, 0.618568964283288, -81.1563873291016, -1.41644616791663, 218, 33, 'PPL', 'P'),
(76193, 'Iron Stob Corner', 33.8955612182617, 0.591589145069967, -94.9472198486328, -1.65714160197355, 218, 42, 'PPL', 'P'),
(109797, 'Irona', 39.4488906860352, 0.688513028730638, -79.7163925170898, -1.39131351723539, 218, 58, 'PPL', 'P'),
(177386, 'Irona', 44.9047203063965, 0.783735219033776, -73.7061080932617, -1.28641426505826, 218, 40, 'PPL', 'P'),
(3363, 'Ironaton', 33.4266700744629, 0.583405450777236, -85.9711074829102, -1.50047888716272, 218, 2, 'PPL', 'P'),
(76194, 'Ironbridge', 35.2380599975586, 0.615020168972703, -94.9550018310547, -1.65727742318915, 218, 42, 'PPL', 'P'),
(3364, 'Irondale', 33.5380592346191, 0.585349558372993, -86.7072219848633, -1.51332650889348, 218, 2, 'PPL', 'P'),
(22180, 'Irondale', 33.4805603027344, 0.584346012695224, -84.35888671875, -1.4723403265591, 218, 13, 'PPL', 'P'),
(55488, 'Irondale', 37.8319396972656, 0.660291910133232, -90.6780624389648, -1.58263074888894, 218, 29, 'PPL', 'P'),
(103102, 'Irondale', 36.8433303833008, 0.643037422588663, -82.7608337402344, -1.4444490404627, 218, 53, 'PPL', 'P'),
(122873, 'Irondale', 40.0986099243164, 0.699852768652195, -85.6575012207031, -1.49500542533233, 218, 19, 'PPL', 'P'),
(149834, 'Irondale', 43.1624984741211, 0.753327711760442, -74.7788925170898, -1.30513788541817, 218, 40, 'PPL', 'P'),
(155850, 'Irondale', 40.5716705322266, 0.708109233821714, -80.7266693115234, -1.40894617365475, 218, 41, 'PPL', 'P'),
(186889, 'Irondale', 39.8494415283203, 0.695503959750151, -104.896667480469, -1.83079222190384, 218, 7, 'PPL', 'P'),
(207727, 'Irondale', 48.0422210693359, 0.838494937630903, -122.771392822266, -2.14276503200787, 218, 56, 'PPL', 'P'),
(120130, 'Irondale (historical)', 41.6958312988281, 0.727729540520654, -87.540283203125, -1.52786617002282, 218, 18, 'PPL', 'P'),
(149835, 'Irondequoit', 43.2133293151855, 0.754214877298574, -77.5800018310547, -1.35402646565513, 218, 40, 'PPL', 'P'),
(22179, 'Irongate', 32.4180603027344, 0.565801889392785, -81.8375015258789, -1.42833385323247, 218, 13, 'PPL', 'P'),
(48471, 'Irongate', 39.4458312988281, 0.688459632350782, -77.4883270263672, -1.35242643847221, 218, 25, 'PPL', 'P'),
(81737, 'Irongate', 32.4605598449707, 0.566543646335399, -80.7855606079102, -1.40997402067746, 218, 48, 'PPL', 'P'),
(88102, 'Irongate', 35.1855583190918, 0.614103841820633, -85.2033309936523, -1.48707865950577, 218, 50, 'PPL', 'P'),
(65882, 'Ironhill', 34.1383285522461, 0.595826234364283, -78.783332824707, -1.37502855348566, 218, 33, 'PPL', 'P'),
(116164, 'Ironhills', 42.1416702270508, 0.735510897751703, -90.7697219848633, -1.58423050975575, 218, 16, 'PPL', 'P'),
(145491, 'Ironia', 40.8227806091309, 0.71249193144863, -74.626106262207, -1.30247126221867, 218, 37, 'PPL', 'P'),
(95110, 'Ironosa', 31.6130599975586, 0.551751983587908, -94.2416687011719, -1.64482741140914, 218, 51, 'PPL', 'P'),
(131463, 'Irons', 44.1399993896484, 0.770388321177653, -85.9158325195313, -1.49951415705784, 218, 27, 'PPL', 'P'),
(14020, 'Irons Lane Landing', 38.586669921875, 0.673464437516982, -75.1444396972656, -1.31151788728362, 218, 10, 'PPL', 'P'),
(88106, 'Ironsburg', 35.2374992370605, 0.615010381855696, -84.3466720581055, -1.47212714051384, 218, 50, 'PPL', 'P'),
(48472, 'Ironshire', 38.2838897705078, 0.668179926965938, -75.2313919067383, -1.3130354896308, 218, 25, 'PPL', 'P'),
(201027, 'Ironside', 44.3244400024414, 0.773607417145286, -117.94361114502, -2.05850434617247, 218, 43, 'PPL', 'P'),
(48473, 'Ironsides', 38.4916687011719, 0.671806353422299, -77.1600036621094, -1.34669611475469, 218, 25, 'PPL', 'P'),
(149837, 'Ironsides', 42.9208297729492, 0.749109797225974, -76.2136077880859, -1.33017839072569, 218, 40, 'PPL', 'P'),
(163026, 'Ironsides', 40.1338882446289, 0.700468491496222, -75.541389465332, -1.3184459677014, 218, 45, 'PPL', 'P'),
(182319, 'Ironsides', 33.8111114501953, 0.590115218564663, -118.305282592773, -2.06481670374623, 218, 6, 'PPL', 'P'),
(73005, 'Ironspot', 39.8186111450195, 0.6949658680519, -82.061393737793, -1.43224150949994, 218, 41, 'PPL', 'P'),
(125146, 'Ironstone', 42.0283317565918, 0.733532768273019, -71.6111068725586, -1.24984959592369, 218, 23, 'PPL', 'P'),
(163025, 'Ironstone', 40.3011093139648, 0.70338704973484, -75.6736068725586, -1.32075359678596, 218, 45, 'PPL', 'P'),
(103103, 'Ironto', 37.2186088562012, 0.649587267552631, -80.2783279418945, -1.40112114058182, 218, 53, 'PPL', 'P'),
(9671, 'Ironton', 34.6319389343262, 0.604441360753608, -92.2772216796875, -1.61054134290324, 218, 4, 'PPL', 'P'),
(30150, 'Ironton', 38.6622200012207, 0.674783035151707, -86.7752838134766, -1.51451441189771, 218, 19, 'PPL', 'P'),
(41495, 'Ironton', 29.648609161377, 0.517465848502983, -89.9613876342773, -1.57012241388105, 218, 22, 'PPL', 'P'),
(55489, 'Ironton', 37.5972213745117, 0.656195302586418, -90.6272201538086, -1.58174338361372, 218, 29, 'PPL', 'P'),
(73001, 'Ironton', 38.5366706848145, 0.67259178620679, -82.6830596923828, -1.44309162725509, 218, 41, 'PPL', 'P'),
(95111, 'Ironton', 31.9188899993896, 0.55708972407124, -95.3733291625977, -1.66457861247566, 218, 51, 'PPL', 'P'),
(131464, 'Ironton', 45.2561111450195, 0.789868146129092, -85.1866683959961, -1.48678784231473, 218, 27, 'PPL', 'P'),
(136087, 'Ironton', 46.4775009155273, 0.811185419074631, -93.9775009155273, -1.64021681377194, 218, 28, 'PPL', 'P'),
(149838, 'Ironton', 44.8983306884766, 0.783623699163128, -74.6858291625977, -1.30351362346933, 218, 40, 'PPL', 'P'),
(163027, 'Ironton', 40.6699981689453, 0.709825374828161, -75.5680618286133, -1.31891148825995, 218, 45, 'PPL', 'P'),
(174649, 'Ironton', 43.5461082458496, 0.760022965319928, -90.14111328125, -1.573259218171, 218, 57, 'PPL', 'P'),
(186890, 'Ironton', 37.9327812194824, 0.662051926718638, -107.679718017578, -1.8793656170258, 218, 7, 'PPL', 'P'),
(204461, 'Ironton', 40.1986083984375, 0.701598071272579, -111.617500305176, -1.94809288317109, 218, 52, 'PPL', 'P'),
(73002, 'Ironton Junction', 39.0963897705078, 0.682360727138392, -82.5569381713867, -1.44089039145608, 218, 41, 'PPL', 'P'),
(109798, 'Irontown', 39.3791694641113, 0.687296163849554, -79.915283203125, -1.39478481455825, 218, 58, 'PPL', 'P'),
(3365, 'Ironville', 32.8005599975586, 0.572477768455341, -87.3427810668945, -1.52441910746588, 218, 2, 'PPL', 'P'),
(36577, 'Ironville', 38.4563903808594, 0.671190630578272, -82.692497253418, -1.44325634376851, 218, 21, 'PPL', 'P'),
(149839, 'Ironville', 43.9225006103516, 0.766592251359854, -73.5361099243164, -1.2834472372878, 218, 40, 'PPL', 'P'),
(155851, 'Ironville', 41.6758308410645, 0.727380466680772, -83.4755630493164, -1.45692342016669, 218, 41, 'PPL', 'P'),
(163029, 'Ironville', 40.0563888549805, 0.699115871978571, -76.4630584716797, -1.33453212647575, 218, 45, 'PPL', 'P'),
(88103, 'Ironville (historical)', 36.3291702270508, 0.634063634979532, -81.9722213745117, -1.4306851581589, 218, 50, 'PPL', 'P'),
(131465, 'Ironwood', 46.454719543457, 0.810787809123882, -90.1708297729492, -1.57377786879329, 218, 27, 'PPL', 'P'),
(178415, 'Ironwood Terrace', 33.5127792358398, 0.584908339159395, -112.205558776855, -1.95835643969615, 218, 5, 'PPL', 'P'),
(109799, 'Iroquois', 37.5811080932617, 0.655914072775305, -81.3408279418945, -1.41966526388426, 218, 58, 'PPL', 'P'),
(120133, 'Iroquois', 40.8274993896484, 0.712574289705341, -87.5819396972656, -1.52859321300041, 218, 18, 'PPL', 'P'),
(149840, 'Iroquois', 42.5327796936035, 0.742337045678766, -78.9861068725586, -1.37856762825827, 218, 40, 'PPL', 'P'),
(170604, 'Iroquois', 44.3669395446777, 0.7743491740879, -97.8505630493164, -1.70781450014087, 218, 49, 'PPL', 'P'),
(88105, 'Iroquois Meadows', 36.0499992370605, 0.62919118202815, -86.8888931274414, -1.51649726848733, 218, 50, 'PPL', 'P'),
(211588, 'Iroquois Point', 21.3274993896484, 0.372235085566446, -157.980285644531, -2.7572761377382, 218, 15, 'PPL', 'P'),
(201028, 'Irrigon', 45.8958282470703, 0.801033315841195, -119.490280151367, -2.08549881277179, 218, 43, 'PPL', 'P'),
(182320, 'Irrigosa', 36.8911094665527, 0.643871324904994, -119.986389160156, -2.09415754842396, 218, 6, 'PPL', 'P'),
(155852, 'Irville', 40.0491714477539, 0.69898990445901, -82.1272201538086, -1.4333903971942, 218, 41, 'PPL', 'P'),
(36578, 'Irvin Cobb Resort', 36.6455612182617, 0.639585699499811, -88.1324996948242, -1.53820229768758, 218, 21, 'PPL', 'P'),
(16560, 'Irvine', 29.4052791595459, 0.513218938802147, -82.2513885498047, -1.43555754453126, 218, 12, 'PPL', 'P'),
(36579, 'Irvine', 37.7005615234375, 0.657998928434674, -83.9738922119141, -1.46562090481272, 218, 21, 'PPL', 'P'),
(163030, 'Irvine', 41.839168548584, 0.730231247469648, -79.2686080932617, -1.38349820470044, 218, 45, 'PPL', 'P'),
(174650, 'Irvine', 44.9255599975586, 0.784098940259653, -91.4197235107422, -1.59557517652532, 218, 57, 'PPL', 'P'),
(182321, 'Irvine', 33.6694412231445, 0.587642606650579, -117.822219848633, -2.05638566836726, 218, 6, 'PPL', 'P'),
(209522, 'Irvine', 42.6650009155273, 0.744644741342347, -105.305000305176, -1.83791897413895, 218, 59, 'PPL', 'P'),
(209523, 'Irvine Home Trust Retirement Homes', 42.0544395446777, 0.733988435135531, -104.952217102051, -1.83176174569869, 218, 59, 'PPL', 'P'),
(149841, 'Irvine Mills', 42.0647201538086, 0.734167865613976, -78.6372222900391, -1.37247844358386, 218, 40, 'PPL', 'P'),
(81734, 'Irvines Landing', 34.2361106872559, 0.597532854569833, -82.0105590820313, -1.43135427738278, 218, 48, 'PPL', 'P'),
(27519, 'Irving', 39.2058296203613, 0.684270812851224, -89.4044418334961, -1.56040187590226, 218, 18, 'PPL', 'P'),
(76195, 'Irving', 34.0422210693359, 0.594148842351697, -98.0527801513672, -1.7113438543755, 218, 42, 'PPL', 'P'),
(81735, 'Irving', 34.2633285522461, 0.598007895929276, -82.2263870239258, -1.43512118558665, 218, 48, 'PPL', 'P'),
(95112, 'Irving', 32.8138885498047, 0.572710395576559, -96.9486083984375, -1.69207242177936, 218, 51, 'PPL', 'P'),
(103104, 'Irving', 37.3586082458496, 0.652030717852779, -79.6708297729492, -1.39051829733389, 218, 53, 'PPL', 'P'),
(116165, 'Irving', 41.9483299255371, 0.73213647291349, -92.2949981689453, -1.61085160117023, 218, 16, 'PPL', 'P'),
(131468, 'Irving', 42.6883316040039, 0.74505193867302, -85.4180603027344, -1.49082639294978, 218, 27, 'PPL', 'P'),
(149842, 'Irving', 42.5675010681152, 0.742943047984814, -79.1130599975586, -1.38078337828521, 218, 40, 'PPL', 'P'),
(163031, 'Irving', 40.5327796936035, 0.70743046063888, -76.4391708374023, -1.3341152086071, 218, 45, 'PPL', 'P'),
(174651, 'Irving', 44.189998626709, 0.771260972487844, -90.9011077880859, -1.58652362461236, 218, 57, 'PPL', 'P'),
(201029, 'Irving', 44.1136093139648, 0.769927727467123, -123.163887023926, -2.14961534812183, 218, 43, 'PPL', 'P'),
(182322, 'Irving (historical)', 38.0169410705566, 0.663520793217871, -122.723327636719, -2.14192613626449, 218, 6, 'PPL', 'P'),
(88107, 'Irving College', 35.5838890075684, 0.621056023846285, -85.7133331298828, -1.49597987597519, 218, 50, 'PPL', 'P'),
(65885, 'Irving Park', 36.0952796936035, 0.629981475081631, -79.7994384765625, -1.39276294265866, 218, 33, 'PPL', 'P'),
(41496, 'Irvings (historical)', 30.8730602264404, 0.538836551117892, -89.836669921875, -1.56794567916408, 218, 22, 'PPL', 'P'),
(182323, 'Irvings Crest', 32.9797210693359, 0.575604719049257, -116.911392211914, -2.04048872718836, 218, 6, 'PPL', 'P'),
(65886, 'Irvings Crossroads', 35.0713882446289, 0.612111198114009, -77.64111328125, -1.35509306167171, 218, 33, 'PPL', 'P'),
(3367, 'Irvington', 30.5066699981689, 0.532441835287421, -88.23388671875, -1.53997183507388, 218, 2, 'PPL', 'P'),
(27521, 'Irvington', 38.4391708374023, 0.670890092849257, -89.1627807617188, -1.55618409452585, 218, 18, 'PPL', 'P'),
(36580, 'Irvington', 37.8802795410156, 0.661135599566569, -86.2838897705078, -1.50593796792322, 218, 21, 'PPL', 'P'),
(48474, 'Irvington', 39.2827796936035, 0.685613844988951, -76.686393737793, -1.33843006220525, 218, 25, 'PPL', 'P'),
(73003, 'Irvington', 39.8405609130859, 0.695348963774708, -84.2602767944336, -1.47061925870464, 218, 41, 'PPL', 'P'),
(103108, 'Irvington', 37.6613883972168, 0.657315228403823, -76.4194412231445, -1.33377086187815, 218, 53, 'PPL', 'P'),
(116166, 'Irvington', 43.0074996948242, 0.750622472725139, -94.1952819824219, -1.64401781043775, 218, 16, 'PPL', 'P'),
(122875, 'Irvington', 40.1763916015625, 0.701210315017863, -85.3466720581055, -1.48958043303379, 218, 19, 'PPL', 'P'),
(142122, 'Irvington', 41.3211097717285, 0.721189416094665, -96.054443359375, -1.6764662977915, 218, 35, 'PPL', 'P'),
(145492, 'Irvington', 40.7322196960449, 0.710911345341668, -74.2352828979492, -1.29565010771865, 218, 37, 'PPL', 'P'),
(149843, 'Irvington', 41.038890838623, 0.716263766500509, -73.8655624389648, -1.28919726839739, 218, 40, 'PPL', 'P'),
(174653, 'Irvington', 44.836109161377, 0.782537728649621, -91.9544372558594, -1.60490769193329, 218, 57, 'PPL', 'P'),
(201030, 'Irvington', 45.5405616760254, 0.79483274445419, -122.650833129883, -2.1406608684306, 218, 43, 'PPL', 'P'),
(30152, 'Irvington (historical)', 39.7649993896484, 0.694030166402901, -86.0611114501953, -1.5020497527317, 218, 19, 'PPL', 'P'),
(73004, 'Irvington (historical)', 38.9408302307129, 0.679645700986083, -83.5511093139648, -1.45824195122239, 218, 41, 'PPL', 'P'),
(182324, 'Irvington District', 37.5227813720703, 0.654896079448622, -121.970558166504, -2.12878783050075, 218, 6, 'PPL', 'P'),
(163032, 'Irvona', 40.7744407653809, 0.711648242015293, -78.5536117553711, -1.37101916446455, 218, 45, 'PPL', 'P'),
(36581, 'Irwin', 38.6827812194824, 0.675141896108596, -83.5694427490234, -1.45856193002736, 218, 21, 'PPL', 'P'),
(55490, 'Irwin', 37.5886116027832, 0.65604503372191, -94.2852783203125, -1.64558854284868, 218, 29, 'PPL', 'P'),
(81736, 'Irwin', 34.6936111450195, 0.605517743887191, -80.8225021362305, -1.41061877197737, 218, 48, 'PPL', 'P'),
(88108, 'Irwin', 36.3300018310547, 0.634078149207473, -83.829719543457, -1.46310461705676, 218, 50, 'PPL', 'P'),
(103105, 'Irwin', 37.6938896179199, 0.65788248171601, -77.9233322143555, -1.36001871126587, 218, 53, 'PPL', 'P'),
(116168, 'Irwin', 41.7916717529297, 0.729402272001333, -95.2055587768555, -1.66165046685711, 218, 16, 'PPL', 'P'),
(120137, 'Irwin', 41.0522193908691, 0.716496393621727, -87.98388671875, -1.5356085119439, 218, 18, 'PPL', 'P'),
(155853, 'Irwin', 40.122501373291, 0.700269753099875, -83.4894409179688, -1.45716563466783, 218, 41, 'PPL', 'P'),
(163034, 'Irwin', 40.3244400024414, 0.703794247065513, -79.7013931274414, -1.39105172850023, 218, 45, 'PPL', 'P'),
(177668, 'Irwin', 37.3969383239746, 0.652699703918607, -120.848892211914, -2.10921106648563, 218, 6, 'PPL', 'P'),
(186891, 'Irwin', 38.8736114501953, 0.678472511946876, -107.096389770508, -1.86918461849454, 218, 7, 'PPL', 'P'),
(191664, 'Irwin', 36.1916694641113, 0.631663793942234, -102.311393737793, -1.7856706830288, 218, 51, 'PPL', 'P'),
(195139, 'Irwin', 43.4086112976074, 0.757623190861658, -111.298606872559, -1.94252714280894, 218, 17, 'PPL', 'P'),
(199427, 'Irwin', 42.8772201538086, 0.748348665786429, -101.954437255859, -1.77944061713272, 218, 35, 'PPL', 'P'),
(207728, 'Irwin', 47.6927795410156, 0.832396032418513, -117.243606567383, -2.04628696151368, 218, 56, 'PPL', 'P'),
(182325, 'Irwin Estates', 34.9213905334473, 0.609493244183434, -117.027221679688, -2.04251033277184, 218, 6, 'PPL', 'P'),
(103106, 'Irwin Manor', 37.2786102294922, 0.650634489072278, -77.3536071777344, -1.35007513354578, 218, 53, 'PPL', 'P'),
(182326, 'Irwindale', 34.1069412231445, 0.595278422128054, -117.934440612793, -2.05834429019096, 218, 6, 'PPL', 'P'),
(22182, 'Irwins Crossroads', 32.8572196960449, 0.573466666747114, -82.8494415283203, -1.44599553810771, 218, 13, 'PPL', 'P'),
(27523, 'Irwins Park', 39.6261100769043, 0.691606090599683, -89.7261123657227, -1.56601608579626, 218, 18, 'PPL', 'P'),
(22183, 'Irwinton', 32.8111114501953, 0.57266192604472, -83.1727828979492, -1.45163890961564, 218, 13, 'PPL', 'P'),
(88110, 'Irwinton Shores', 35.7544403076172, 0.624032705575694, -84.6624984741211, -1.47763935133809, 218, 50, 'PPL', 'P'),
(22184, 'Irwinville', 31.6480598449707, 0.552362846162945, -83.3827819824219, -1.45530408506587, 218, 13, 'PPL', 'P'),
(103107, 'Isaac', 36.6941719055176, 0.640434116044083, -76.9658279418945, -1.34330710910951, 218, 53, 'PPL', 'P'),
(95113, 'Isaacs Colonia', 26.261999130249, 0.458358352978733, -98.0920028686523, -1.71202841993371, 218, 51, 'PPL', 'P'),
(169434, 'Isaacs Corner', 41.1641693115234, 0.718450288334491, -71.5805587768555, -1.24931643107345, 218, 47, 'PPL', 'P'),
(174654, 'Isaar', 44.5716705322266, 0.777922403901487, -88.2844390869141, -1.54085414034303, 218, 57, 'PPL', 'P'),
(166, 'Isaban', 37.5299987792969, 0.655022046968183, -81.8883285522461, -1.42922095219158, 218, 58, 'PPL', 'P'),
(27524, 'Isabel', 39.6552810668945, 0.692115220421079, -87.9499969482422, -1.53501702386579, 218, 18, 'PPL', 'P'),
(32848, 'Isabel', 37.4666709899902, 0.653916768536773, -98.5500030517578, -1.72002203110363, 218, 20, 'PPL', 'P'),
(41497, 'Isabel', 30.6747207641602, 0.535374874464466, -89.998893737793, -1.57077701887699, 218, 22, 'PPL', 'P'),
(140279, 'Isabel', 48.0647201538086, 0.838887620733635, -99.6530609130859, -1.73927402262382, 218, 34, 'PPL', 'P'),
(202250, 'Isabel', 45.3941688537598, 0.792277707704368, -101.429168701172, -1.77027295139623, 218, 49, 'PPL', 'P'),
(60394, 'Isabell (historical)', 30.9422206878662, 0.54004362888197, -88.6202774047852, -1.54671562474424, 218, 30, 'PPL', 'P'),
(3368, 'Isabella', 32.8283309936523, 0.572962463773735, -86.7866668701172, -1.51471308371503, 218, 2, 'PPL', 'P'),
(22185, 'Isabella', 31.5683307647705, 0.550971311203865, -83.853889465332, -1.46352646177343, 218, 13, 'PPL', 'P'),
(55493, 'Isabella', 36.5808296203613, 0.638455919986373, -92.6125030517578, -1.61639310676647, 218, 29, 'PPL', 'P'),
(76197, 'Isabella', 36.2355613708496, 0.632429852229796, -98.3397216796875, -1.7163519288054, 218, 42, 'PPL', 'P'),
(88111, 'Isabella', 35.0277786254883, 0.611350066674464, -84.3552780151367, -1.47227734279932, 218, 50, 'PPL', 'P'),
(131470, 'Isabella', 45.8974990844727, 0.801062477455131, -86.6055603027344, -1.51155217781721, 218, 27, 'PPL', 'P'),
(136090, 'Isabella', 47.6172218322754, 0.831077301625733, -91.3547210693359, -1.59444066990095, 218, 28, 'PPL', 'P'),
(163036, 'Isabella', 40.1208305358887, 0.700240591485938, -75.8383331298828, -1.32362861234075, 218, 45, 'PPL', 'P'),
(182327, 'Isabella (historical)', 35.6555595397949, 0.622306910610296, -118.46028137207, -2.06752194278153, 218, 6, 'PPL', 'P'),
(195140, 'Isabella Landing', 46.8497200012207, 0.817681867658743, -115.628059387207, -2.0180903439983, 218, 17, 'PPL', 'P'),
(139230, 'Isadora', 40.5258293151855, 0.707309153651227, -94.5175018310547, -1.64964160771167, 218, 29, 'PPL', 'P'),
(131473, 'Isadore', 44.8777809143066, 0.783265037943322, -85.7736129760742, -1.49703195776383, 218, 27, 'PPL', 'P'),
(182328, 'Isaiah (historical)', 39.7177810668945, 0.693206051203576, -121.441108703613, -2.11954719415039, 218, 6, 'PPL', 'P'),
(136091, 'Isanti', 45.4902801513672, 0.793955166295982, -93.2474975585938, -1.62747585164283, 218, 28, 'PPL', 'P'),
(136093, 'Isanti Estates', 45.454719543457, 0.793334516603939, -93.2333297729492, -1.62722857713562, 218, 28, 'PPL', 'P'),
(3369, 'Isbell', 34.4552803039551, 0.601358086001569, -87.7538909912109, -1.53159432923282, 218, 2, 'PPL', 'P'),
(88112, 'Isbell', 35.5338897705078, 0.620183372536094, -87.1477813720703, -1.52101572075081, 218, 50, 'PPL', 'P'),
(55491, 'Isbell (historical)', 38.6169395446777, 0.673992742098226, -91.9102783203125, -1.60413697311382, 218, 29, 'PPL', 'P'),
(149844, 'Ischua', 42.247501373291, 0.737357999704754, -78.4000015258789, -1.36833816019517, 218, 40, 'PPL', 'P'),
(145494, 'Iselin', 40.5752792358398, 0.708172217581494, -74.3227767944336, -1.2971771642877, 218, 37, 'PPL', 'P'),
(163037, 'Iselin', 40.559440612793, 0.707895781460344, -79.3866729736328, -1.38555882559389, 218, 45, 'PPL', 'P'),
(163038, 'Iselin Heights', 41.1272201538086, 0.717805403876529, -78.7852783203125, -1.37506250878956, 218, 45, 'PPL', 'P'),
(81741, 'Iseman Crossroads', 34.2686080932617, 0.598100041302993, -79.9530563354492, -1.3954440800861, 218, 48, 'PPL', 'P'),
(60395, 'Isenberg', 33.3747215270996, 0.582498777584118, -90.9094390869141, -1.58666903320788, 218, 30, 'PPL', 'P'),
(65887, 'Isenhour', 35.4497184753418, 0.618714306299779, -80.1566696166992, -1.3989978022447, 218, 33, 'PPL', 'P'),
(65888, 'Isenhour Park', 35.8683280944824, 0.626020422434302, -81.1877822875977, -1.41699411331091, 218, 33, 'PPL', 'P'),
(191665, 'Iser', 31.3708305358887, 0.547524281936434, -105.922218322754, -1.84869146074832, 218, 51, 'PPL', 'P'),
(81742, 'Isgett Circle', 34.7013893127441, 0.605653498523757, -79.9361114501953, -1.39514833604705, 218, 48, 'PPL', 'P'),
(88113, 'Isham', 36.5974998474121, 0.638746870335464, -84.4388885498047, -1.47373662191863, 218, 50, 'PPL', 'P'),
(131474, 'Ishaward', 44.8133316040039, 0.7821401852779, -84.8394393920898, -1.48072755293814, 218, 27, 'PPL', 'P'),
(13130, 'Isherwood', 38.8944396972656, 0.678836033435672, -76.9791717529297, -1.34354000254684, 218, 9, 'PPL', 'P'),
(3370, 'Ishkooda', 33.4597206115723, 0.583982291469347, -86.8613891601563, -1.51601723370084, 218, 2, 'PPL', 'P'),
(55492, 'Ishmael', 37.8061103820801, 0.659841103539709, -91.0566711425781, -1.5892387173437, 218, 29, 'PPL', 'P'),
(131475, 'Ishpeming', 46.4886093139648, 0.811379297201989, -87.6675033569336, -1.53008658058167, 218, 27, 'PPL', 'P'),
(136096, 'Isinours', 43.7102813720703, 0.762888326915772, -92.0555572509766, -1.60667256878768, 218, 28, 'PPL', 'P'),
(191666, 'Isla', 31.4872207641602, 0.54955567463692, -106.205833435059, -1.85364147826645, 218, 51, 'PPL', 'P'),
(182329, 'Isla Vista', 34.413330078125, 0.600625916438879, -119.860000610352, -2.09195165209305, 218, 6, 'PPL', 'P'),
(16562, 'Islamorada', 24.9238891601563, 0.435003928246851, -80.628059387207, -1.40722510580028, 218, 12, 'PPL', 'P'),
(9673, 'Island', 35.416389465332, 0.618132605338678, -94.1277770996094, -1.6428396279715, 218, 4, 'PPL', 'P'),
(36582, 'Island', 37.4449996948242, 0.653538533082955, -87.1438903808594, -1.52094781014301, 218, 21, 'PPL', 'P'),
(41498, 'Island', 30.6763896942139, 0.535404002788888, -91.3908309936523, -1.59507090697291, 218, 22, 'PPL', 'P'),
(125147, 'Island', 42.2472190856934, 0.737353072856738, -71.8041687011719, -1.25321916049291, 218, 23, 'PPL', 'P'),
(136097, 'Island', 46.9861106872559, 0.82006233419911, -93.0133285522461, -1.62338883147594, 218, 28, 'PPL', 'P'),
(155854, 'Island', 40.9150009155273, 0.714101479432447, -80.7458267211914, -1.40928053352961, 218, 41, 'PPL', 'P'),
(48475, 'Island Acres', 38.6672210693359, 0.674870320256435, -76.1430587768555, -1.32894707819569, 218, 25, 'PPL', 'P'),
(113385, 'Island Beach', 44.0911102294922, 0.769535044364391, -88.5027770996094, -1.54466485754682, 218, 57, 'PPL', 'P'),
(70976, 'Island Beach Heights', 39.9541702270508, 0.697331820364327, -74.1563873291016, -1.29427312027703, 218, 37, 'PPL', 'P'),
(109800, 'Island Branch', 38.5741691589355, 0.673246258044677, -81.5319366455078, -1.42300073999153, 218, 58, 'PPL', 'P'),
(30153, 'Island City', 39.0091705322266, 0.680838464259302, -87.1477813720703, -1.52101572075081, 218, 19, 'PPL', 'P'),
(36583, 'Island City', 37.3663902282715, 0.652166539068373, -83.7680587768555, -1.46202843366026, 218, 21, 'PPL', 'P'),
(139231, 'Island City', 40.1455612182617, 0.700672223319613, -94.5708312988281, -1.65057238251266, 218, 29, 'PPL', 'P'),
(201031, 'Island City', 45.3411102294922, 0.79135166001432, -118.043609619141, -2.06024964879285, 218, 43, 'PPL', 'P'),
(190337, 'Island City (historical)', 39.4022216796875, 0.687698500911237, -118.780563354492, -2.07311191790961, 218, 39, 'PPL', 'P'),
(196773, 'Island City (historical)', 47.3611106872559, 0.826607318894089, -114.788887023926, -2.0034440232673, 218, 31, 'PPL', 'P'),
(149846, 'Island Cottage Beach', 43.2772216796875, 0.755330009426018, -77.647216796875, -1.35519958811531, 218, 40, 'PPL', 'P'),
(48476, 'Island Creek', 38.4488906860352, 0.671059736210695, -76.5608291625977, -1.33623854694422, 218, 25, 'PPL', 'P'),
(125148, 'Island Creek', 42.0125007629395, 0.733256465309923, -70.7249984741211, -1.23438408684138, 218, 23, 'PPL', 'P'),
(155855, 'Island Creek', 40.4527816772461, 0.706034231858378, -80.679443359375, -1.40812192529737, 218, 41, 'PPL', 'P'),
(65889, 'Island Creek Estates', 36.4583282470703, 0.63631786768423, -78.4383316040039, -1.36900714626099, 218, 33, 'PPL', 'P'),
(127808, 'Island Falls', 46.0091705322266, 0.803011511898905, -68.2719421386719, -1.19157017705088, 218, 26, 'PPL', 'P'),
(103109, 'Island Farm', 37.9075012207031, 0.661610707505039, -76.8252792358398, -1.34085407142944, 218, 53, 'PPL', 'P'),
(65891, 'Island Ford', 35.2305603027344, 0.614889274605125, -83.0405578613281, -1.44933114737304, 218, 33, 'PPL', 'P'),
(103110, 'Island Ford', 38.3516693115234, 0.669362903122151, -78.6888885498047, -1.37338018992896, 218, 53, 'PPL', 'P'),
(88114, 'Island Forty', 35.2955589294434, 0.616023714650472, -90.1394424438477, -1.57323005655707, 218, 50, 'PPL', 'P'),
(16563, 'Island Grove', 29.4533290863037, 0.514057568229413, -82.1066665649414, -1.43303166939537, 218, 12, 'PPL', 'P'),
(27526, 'Island Grove', 39.7241706848145, 0.693317571074223, -89.9608306884766, -1.57011269334307, 218, 18, 'PPL', 'P'),
(70977, 'Island Heights', 39.9419403076172, 0.697118368002957, -74.1502838134766, -1.29416659383342, 218, 37, 'PPL', 'P'),
(88115, 'Island Home', 35.9558296203613, 0.627547612161408, -83.8847198486328, -1.46406455347168, 218, 50, 'PPL', 'P'),
(120139, 'Island Lake', 42.2761116027832, 0.737857342409144, -88.1919403076172, -1.53923973209022, 218, 18, 'PPL', 'P'),
(136098, 'Island Lake', 47.788890838623, 0.834073491010126, -95.0177764892578, -1.65837304766161, 218, 28, 'PPL', 'P'),
(174656, 'Island Lake', 45.3188896179199, 0.790963837180578, -91.3688888549805, -1.59468794440816, 218, 57, 'PPL', 'P'),
(3371, 'Island Landing', 31.0522193908691, 0.541963468422294, -87.8649978637695, -1.53353350998056, 218, 2, 'PPL', 'P'),
(193677, 'Island Mountain', 40.0263900756836, 0.698592294508261, -123.489166259766, -2.1552925417756, 218, 6, 'PPL', 'P'),
(200012, 'Island Mountain (historical)', 41.7338905334473, 0.728393799475548, -115.72306060791, -2.01974842809298, 218, 39, 'PPL', 'P'),
(81744, 'Island of Palms', 32.7900009155273, 0.572293477707907, -79.7844390869141, -1.39250115392351, 218, 48, 'PPL', 'P'),
(122877, 'Island Park', 41.540828704834, 0.725024234906325, -84.9211120605469, -1.48215300991161, 218, 19, 'PPL', 'P'),
(127810, 'Island Park', 44.3211097717285, 0.773549293654495, -69.8880615234375, -1.21977678142035, 218, 26, 'PPL', 'P'),
(136101, 'Island Park', 44.9247207641602, 0.784084292873658, -93.6380615234375, -1.634292478769, 218, 28, 'PPL', 'P'),
(149847, 'Island Park', 40.6041717529297, 0.708676487133901, -73.6558303833008, -1.28553675347908, 218, 40, 'PPL', 'P'),
(169435, 'Island Park', 41.6233291625977, 0.726464139528703, -71.227783203125, -1.24315933579124, 218, 47, 'PPL', 'P'),
(174657, 'Island Park', 44.0227813720703, 0.768342480828254, -88.8022232055664, -1.54989117802805, 218, 57, 'PPL', 'P'),
(195141, 'Island Park', 44.4244384765625, 0.775352719765669, -111.370277404785, -1.94377802957295, 218, 17, 'PPL', 'P'),
(163040, 'Island Plain', 41.954719543457, 0.732247992784137, -75.7052764892578, -1.3213063358702, 218, 45, 'PPL', 'P'),
(172149, 'Island Pond', 44.8147201538086, 0.78216442004382, -71.8808288574219, -1.25455713262457, 218, 55, 'PPL', 'P'),
(22187, 'Island Retreat', 31.1591701507568, 0.543830111319845, -81.39111328125, -1.4205429086215, 218, 13, 'PPL', 'P'),
(22188, 'Island Shoals (historical)', 33.4500007629395, 0.583812648107909, -83.9300003051758, -1.46485484652516, 218, 13, 'PPL', 'P'),
(9674, 'Island Town', 35.5786094665527, 0.620963878472569, -91.2647171020508, -1.59286980433196, 218, 4, 'PPL', 'P'),
(22191, 'Island View', 31.1916694641113, 0.544397331342518, -81.466667175293, -1.42186157283525, 218, 13, 'PPL', 'P'),
(27528, 'Island View', 39.2105598449707, 0.684353370845016, -89.6152801513672, -1.56408169873848, 218, 18, 'PPL', 'P'),
(48477, 'Island View', 38.9297218322754, 0.679451822858725, -76.3016662597656, -1.33171530099078, 218, 25, 'PPL', 'P'),
(131478, 'Island View', 45.6394386291504, 0.796558472840562, -87.1975021362305, -1.52188351179201, 218, 27, 'PPL', 'P'),
(136102, 'Island View', 48.5952796936035, 0.848147631580923, -93.1666717529297, -1.62606517521342, 218, 28, 'PPL', 'P'),
(155857, 'Island View', 40.5161094665527, 0.707139510289789, -83.8861083984375, -1.4640887882376, 218, 41, 'PPL', 'P'),
(207730, 'Island View', 46.2394409179688, 0.807030488299944, -119.222221374512, -2.08082030452679, 218, 56, 'PPL', 'P'),
(48478, 'Island View Beach', 39.2666702270508, 0.685332681756865, -76.3969421386719, -1.33337817877542, 218, 25, 'PPL', 'P'),
(81743, 'Island View Landing', 35.0252799987793, 0.611306457411614, -81.043327331543, -1.41447289870693, 218, 48, 'PPL', 'P'),
(207731, 'Islandale', 48.4463882446289, 0.845548985568251, -122.856391906738, -2.1442485458931, 218, 56, 'PPL', 'P'),
(88116, 'Islandford (historical)', 36.1305618286133, 0.630597264504685, -84.7216720581055, -1.47867212520882, 218, 50, 'PPL', 'P'),
(16564, 'Islandia', 25.3777809143066, 0.442925833804428, -80.2527770996094, -1.40067519425729, 218, 12, 'PPL', 'P'),
(149848, 'Islandia', 40.8041687011719, 0.712167092374667, -73.1694412231445, -1.27704766118834, 218, 40, 'PPL', 'P'),
(48479, 'Islands of Balmoral', 39.4233283996582, 0.688066882669023, -77.290283203125, -1.3489699216934, 218, 25, 'PPL', 'P'),
(81745, 'Islandton', 32.9088897705078, 0.574368479671242, -80.9355621337891, -1.41259204118707, 218, 48, 'PPL', 'P'),
(209524, 'Islay', 41.3177795410156, 0.721131292603874, -105.13500213623, -1.83495194636849, 218, 59, 'PPL', 'P'),
(81746, 'Islay (historical)', 34.6238899230957, 0.604300879006106, -79.7275009155273, -1.39150739536275, 218, 48, 'PPL', 'P'),
(136104, 'Isle', 46.1380615234375, 0.805261084071695, -93.4705581665039, -1.63136899368237, 218, 28, 'PPL', 'P'),
(127811, 'Isle Au Haut', 44.0752792358398, 0.769258741401296, -68.6338882446289, -1.19788732831461, 218, 26, 'PPL', 'P'),
(172151, 'Isle la Motte', 44.8769416809082, 0.783250390557327, -73.3391723632813, -1.28001002842689, 218, 55, 'PPL', 'P'),
(41499, 'Isle Labbe', 30.1652793884277, 0.526483445112045, -91.7763900756836, -1.60180018241533, 218, 22, 'PPL', 'P'),
(22189, 'Isle of Armstrong', 32.0374984741211, 0.559159832476072, -81.0397186279297, -1.41440991494715, 218, 13, 'PPL', 'P'),
(41500, 'Isle of Cuba', 29.7219390869141, 0.518745697143847, -90.817497253418, -1.58506434549305, 218, 22, 'PPL', 'P'),
(22190, 'Isle of Hope', 31.9816703796387, 0.55818544841224, -81.0611114501953, -1.41478329013198, 218, 13, 'PPL', 'P'),
(16565, 'Isle of Normandy', 25.8525009155273, 0.451211260850801, -80.1352767944336, -1.39862442705987, 218, 12, 'PPL', 'P'),
(16566, 'Isle of Palms', 30.2838897705078, 0.528553586806391, -81.429443359375, -1.42121189468733, 218, 12, 'PPL', 'P'),
(81747, 'Isle of Palms', 32.7866706848145, 0.572235354217116, -79.7949981689453, -1.39268544467094, 218, 48, 'PPL', 'P'),
(16567, 'Isle of Palms South', 30.2674999237061, 0.528267530015803, -81.4327774047852, -1.42127008475714, 218, 12, 'PPL', 'P'),
(81748, 'Isle of Pines', 34.3333282470703, 0.59922962107935, -82.1025009155273, -1.43295896509761, 218, 48, 'PPL', 'P'),
(103111, 'Isle of Pines', 37.107780456543, 0.647652947073879, -79.6358337402344, -1.38990750133788, 218, 53, 'PPL', 'P'),
(149849, 'Isle of San Souci', 40.9008293151855, 0.713854138346205, -73.7683334350586, -1.28750030215079, 218, 40, 'PPL', 'P'),
(103112, 'Isle of Wight', 36.9075012207031, 0.644157414985096, -76.7080612182617, -1.33880823108004, 218, 53, 'PPL', 'P'),
(155859, 'Isle Saint George', 41.7216682434082, 0.728180480272232, -82.8202819824219, -1.4454866080234, 218, 41, 'PPL', 'P'),
(16568, 'Isleboro', 29.0652809143066, 0.507284849971719, -80.9472198486328, -1.41279550669435, 218, 12, 'PPL', 'P'),
(88117, 'Isleford', 35.6208305358887, 0.621700775146193, -85.6791687011719, -1.49538359420712, 218, 50, 'PPL', 'P'),
(190338, 'Islen', 37.5297203063965, 0.655017186699194, -114.320831298828, -1.99527490978154, 218, 39, 'PPL', 'P'),
(16569, 'Isles of Capri', 25.9825000762939, 0.453480174231007, -81.727783203125, -1.42641890725065, 218, 12, 'PPL', 'P'),
(127813, 'Islesboro', 44.3083305358887, 0.773326253913201, -68.9038925170898, -1.2025997918635, 218, 26, 'PPL', 'P'),
(127815, 'Islesford', 44.2619400024414, 0.77251658636279, -68.2344436645508, -1.190915705213, 218, 26, 'PPL', 'P'),
(155860, 'Isleta', 40.2700004577637, 0.7028440977676, -81.6716690063477, -1.42543952975977, 218, 41, 'PPL', 'P'),
(188721, 'Isleta', 34.9072189331055, 0.609245903097193, -106.688606262207, -1.86206745363935, 218, 38, 'PPL', 'P'),
(188722, 'Isleta Pueblo', 34.9069404602051, 0.609241042828203, -106.680282592773, -1.86192217820189, 218, 38, 'PPL', 'P'),
(188726, 'Isleta Village Proper', 34.9077796936035, 0.609255690214199, -106.692497253418, -1.86213536424715, 218, 38, 'PPL', 'P'),
(182332, 'Isleton', 38.1619415283203, 0.666051528622746, -121.610557556152, -2.12250463454093, 218, 6, 'PPL', 'P'),
(125149, 'Islington', 42.2236099243164, 0.736941015257075, -71.1902770996094, -1.2425047307953, 218, 23, 'PPL', 'P'),
(41501, 'Islington (historical)', 32.3325004577637, 0.56430858839055, -91.1833267211914, -1.59144927420652, 218, 22, 'PPL', 'P'),
(149850, 'Islip', 40.7297210693359, 0.710867736078818, -73.2108306884766, -1.27777004363402, 218, 40, 'PPL', 'P'),
(149851, 'Islip Terrace', 40.7430610656738, 0.711100562937118, -73.1930618286133, -1.27745991852508, 218, 40, 'PPL', 'P'),
(95118, 'Islitas', 27.6669406890869, 0.482879208978555, -99.6527786254883, -1.7392690957758, 218, 51, 'PPL', 'P'),
(95115, 'Ismael Montalvo Colonia Number 1', 26.0240001678467, 0.454204487468482, -97.6259994506836, -1.7038951259646, 218, 51, 'PPL', 'P'),
(95116, 'Ismael Montalvo Colonia Number 2', 26.0269393920898, 0.454255786608979, -97.6255569458008, -1.70388740279744, 218, 51, 'PPL', 'P'),
(196774, 'Ismay', 46.4972190856934, 0.811529566066497, -104.793609619141, -1.82899352290361, 218, 31, 'PPL', 'P'),
(3372, 'Isney', 31.7822208404541, 0.554704397261883, -88.4555587768555, -1.5438407423475, 218, 2, 'PPL', 'P'),
(60396, 'Isola', 33.2619400024414, 0.580530368643413, -90.5922164916992, -1.58113245445966, 218, 30, 'PPL', 'P'),
(36584, 'Isom', 37.1877784729004, 0.649049175854381, -82.8988876342773, -1.44685853545895, 218, 21, 'PPL', 'P'),
(88118, 'Isom', 35.6327781677246, 0.621909300659547, -87.304443359375, -1.52374998824199, 218, 50, 'PPL', 'P'),
(103114, 'Isom', 37.186939239502, 0.649034528468385, -82.4619369506836, -1.4392323073614, 218, 53, 'PPL', 'P'),
(109801, 'Isom', 37.9436111450195, 0.662240944577006, -81.8705596923828, -1.42891082708264, 218, 58, 'PPL', 'P'),
(36588, 'Isonville', 38.064998626709, 0.664359555803192, -83.0527801513672, -1.44954446657635, 218, 21, 'PPL', 'P'),
(95117, 'Israel', 30.7422294616699, 0.536553123509744, -94.8915634155273, -1.65617021396595, 218, 51, 'PPL', 'P'),
(109805, 'Israel', 39.3180618286133, 0.686229634412004, -79.8111114501953, -1.39296667448205, 218, 58, 'PPL', 'P'),
(14021, 'Israel Haul', 38.5780601501465, 0.673314168652474, -75.1872177124023, -1.31226450449522, 218, 10, 'PPL', 'P'),
(207732, 'Issaquah', 47.5302810668945, 0.829559899015633, -122.031387329102, -2.12984949966931, 218, 56, 'PPL', 'P'),
(60397, 'Issaquena', 32.7775001525879, 0.572075298235602, -90.9338912963867, -1.58709580477256, 218, 30, 'PPL', 'P'),
(16571, 'Istachatta', 28.6597194671631, 0.500206467399911, -82.2777786254883, -1.43601813824178, 218, 12, 'PPL', 'P'),
(16572, 'Istokpoga', 27.413330078125, 0.478452868799276, -81.3513870239258, -1.4198495546317, 218, 12, 'PPL', 'P'),
(41502, 'Istrouma', 30.478889465332, 0.531956973521458, -91.1597213745117, -1.59103728318588, 218, 22, 'PPL', 'P'),
(65893, 'Ita', 36.1758308410645, 0.631387357821084, -77.9100036621094, -1.35978608414465, 218, 33, 'PPL', 'P'),
(178416, 'Itak', 31.6947193145752, 0.553177207534778, -112.006393432617, -1.95488034868332, 218, 5, 'PPL', 'P'),
(16573, 'Italia', 30.6163902282715, 0.534356814558756, -81.7172164916992, -1.42623448334516, 218, 12, 'PPL', 'P'),
(182333, 'Italian Swiss Colony', 36.9311103820801, 0.644569472584758, -120.105560302734, -2.09623747723531, 218, 6, 'PPL', 'P'),
(3373, 'Italian Town', 33.1183280944824, 0.578023868004458, -87.0999984741211, -1.52018175185545, 218, 2, 'PPL', 'P'),
(81749, 'Italy', 33.4483299255371, 0.583783486493972, -79.5411071777344, -1.38825421093316, 218, 48, 'PPL', 'P'),
(95119, 'Italy', 32.1838912963867, 0.561714869225894, -96.8844375610352, -1.69095242938293, 218, 51, 'PPL', 'P'),
(149853, 'Italy', 42.6116714477539, 0.743713966541365, -77.2922210693359, -1.34900374383924, 218, 40, 'PPL', 'P'),
(149854, 'Italy Hill', 42.5961112976074, 0.743442390689204, -77.2491683959961, -1.34825233293768, 218, 40, 'PPL', 'P'),
(95120, 'Itasca', 32.1594390869141, 0.561288097661209, -97.1497192382813, -1.69558246809609, 218, 51, 'PPL', 'P'),
(120142, 'Itasca', 41.9749984741211, 0.732601926893009, -88.0072174072266, -1.53601570927457, 218, 18, 'PPL', 'P'),
(174658, 'Itasca', 46.6747207641602, 0.814627554783558, -92.0063934326172, -1.60581449828446, 218, 57, 'PPL', 'P'),
(149856, 'Itaska', 42.2988891601563, 0.738254885780866, -75.908332824707, -1.32485033749083, 218, 40, 'PPL', 'P'),
(103115, 'Itata', 37.0488891601563, 0.646625100051163, -76.7858276367188, -1.3401655111296, 218, 53, 'PPL', 'P'),
(22194, 'Ithaca', 33.6805610656738, 0.587836684515018, -84.9480590820313, -1.48262332416012, 218, 13, 'PPL', 'P'),
(73007, 'Ithaca', 39.9372215270996, 0.697036009746246, -84.5533294677734, -1.47573399273619, 218, 41, 'PPL', 'P'),
(131480, 'Ithaca', 43.2916717529297, 0.755582210781248, -84.6074981689453, -1.47667941492317, 218, 27, 'PPL', 'P'),
(142125, 'Ithaca', 41.1627807617188, 0.718426053568572, -96.539436340332, -1.68493102215826, 218, 35, 'PPL', 'P'),
(149857, 'Ithaca', 42.440559387207, 0.74072749769495, -76.496940612793, -1.33512348139581, 218, 40, 'PPL', 'P'),
(174659, 'Ithaca', 43.3408317565918, 0.756440214705444, -90.2816696166992, -1.57571238900913, 218, 57, 'PPL', 'P'),
(163042, 'Ithan', 40.0299987792969, 0.698655278268041, -75.3666687011719, -1.31539651509521, 218, 45, 'PPL', 'P'),
(172152, 'Ithiel Falls', 44.649169921875, 0.779275023419138, -72.7249984741211, -1.26929067188127, 218, 55, 'PPL', 'P'),
(41503, 'Ithra', 30.461109161377, 0.531646648675437, -91.2747192382813, -1.59304437454142, 218, 22, 'PPL', 'P'),
(109802, 'Itmann', 37.5733299255371, 0.655778318138738, -81.418327331543, -1.42101788340191, 218, 58, 'PPL', 'P'),
(60400, 'Itta Bena', 33.4949989318848, 0.584598014313373, -90.3197174072266, -1.57637644822694, 218, 30, 'PPL', 'P'),
(211893, 'Itulilik', 61.3763885498047, 1.07122006317744, -157.046676635742, -2.74098158660855, 218, 1, 'PPL', 'P'),
(60401, 'Ituma', 33.2305603027344, 0.579982689565238, -90.1050033569336, -1.57262898109903, 218, 30, 'PPL', 'P'),
(76198, 'Ituna', 36.4830589294434, 0.636749499517904, -97.9691696166992, -1.70988457525619, 218, 42, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(9676, 'Iuka', 36.2041702270508, 0.631881973414539, -92.1549987792969, -1.60840815087009, 218, 4, 'PPL', 'P'),
(27529, 'Iuka', 38.6161117553711, 0.673978294449313, -88.790283203125, -1.54968278567275, 218, 18, 'PPL', 'P'),
(32849, 'Iuka', 37.7291717529297, 0.658498271139064, -98.7347183227539, -1.72324592076123, 218, 20, 'PPL', 'P'),
(36585, 'Iuka', 37.0808296203613, 0.647182566246344, -88.2366714477539, -1.54002043776378, 218, 21, 'PPL', 'P'),
(60402, 'Iuka', 34.8116683959961, 0.607578231622585, -88.1900024414063, -1.53920590994438, 218, 30, 'PPL', 'P'),
(95121, 'Iuka', 29.045560836792, 0.50694066969034, -98.7380599975586, -1.7233042439891, 218, 51, 'PPL', 'P'),
(109803, 'Iuka', 39.5149993896484, 0.689666843272915, -80.790283203125, -1.4100564455132, 218, 58, 'PPL', 'P'),
(55494, 'Iuka Springs', 38.0974998474121, 0.664926809115379, -93.9211120605469, -1.6392326425911, 218, 29, 'PPL', 'P'),
(30154, 'Iva', 38.5027809143066, 0.672000298128684, -87.1194381713867, -1.52052103857833, 218, 19, 'PPL', 'P'),
(78510, 'Iva', 39.9630584716797, 0.697486949497824, -76.1358337402344, -1.32882097751808, 218, 45, 'PPL', 'P'),
(81750, 'Iva', 34.3063888549805, 0.598759439988897, -82.6638870239258, -1.44275700106412, 218, 48, 'PPL', 'P'),
(131482, 'Iva', 43.4633293151855, 0.75857820042856, -84.2694396972656, -1.4707791815281, 218, 27, 'PPL', 'P'),
(73008, 'Iva Dale Subdivision', 38.8561096191406, 0.678167047369844, -82.1469421386719, -1.4337346107651, 218, 41, 'PPL', 'P'),
(103116, 'Ivakota', 38.7911109924316, 0.677032607324497, -77.4075012207031, -1.3510157620428, 218, 53, 'PPL', 'P'),
(3374, 'Ivalee', 34.0344390869141, 0.594013021136103, -86.1452789306641, -1.50351875238899, 218, 2, 'PPL', 'P'),
(9677, 'Ivan', 33.9116706848145, 0.591870308302052, -92.4244384765625, -1.61311076072295, 218, 4, 'PPL', 'P'),
(16574, 'Ivan', 30.2233295440674, 0.527496611459252, -84.3622207641602, -1.47239851662892, 218, 12, 'PPL', 'P'),
(41504, 'Ivan', 32.7941703796387, 0.572366248584694, -93.5352783203125, -1.63249857345872, 218, 22, 'PPL', 'P'),
(95122, 'Ivan', 32.874439239502, 0.57376720447613, -98.7330627441406, -1.7232170254634, 218, 51, 'PPL', 'P'),
(109804, 'Ivan', 38.9841690063477, 0.680402105314693, -81.3427810668945, -1.41969935234622, 218, 58, 'PPL', 'P'),
(103117, 'Ivandale', 39.1450004577637, 0.683209143682664, -77.670280456543, -1.35560212491408, 218, 53, 'PPL', 'P'),
(3376, 'Ivanhoe', 33.1480598449707, 0.57854278494286, -86.7758331298828, -1.51452399927763, 218, 2, 'PPL', 'P'),
(22192, 'Ivanhoe', 32.2838897705078, 0.563460171846278, -81.4775009155273, -1.42205065727265, 218, 13, 'PPL', 'P'),
(41505, 'Ivanhoe', 29.7824993133545, 0.519802672490986, -91.7397232055664, -1.60116022480538, 218, 22, 'PPL', 'P'),
(65894, 'Ivanhoe', 34.6105613708496, 0.604068251884888, -78.2422180175781, -1.36558431846997, 218, 33, 'PPL', 'P'),
(95123, 'Ivanhoe', 33.7130584716797, 0.588403871248178, -96.1436080932617, -1.67802251597448, 218, 51, 'PPL', 'P'),
(103118, 'Ivanhoe', 36.8400001525879, 0.642979299097872, -80.9669418334961, -1.41313972026524, 218, 53, 'PPL', 'P'),
(120141, 'Ivanhoe', 42.2788887023926, 0.737905811940983, -88.0419387817383, -1.53662171158062, 218, 18, 'PPL', 'P'),
(122878, 'Ivanhoe', 41.5977783203125, 0.726018193204169, -87.4244384765625, -1.52584429812323, 218, 19, 'PPL', 'P'),
(131483, 'Ivanhoe', 43.7055587768555, 0.762805902080034, -83.0941696166992, -1.45026684902204, 218, 27, 'PPL', 'P'),
(136109, 'Ivanhoe', 44.4633293151855, 0.776031492948503, -96.246940612793, -1.67982600866469, 218, 28, 'PPL', 'P'),
(149860, 'Ivanhoe', 42.2322196960449, 0.737091284121583, -75.3261108398438, -1.31468864687746, 218, 40, 'PPL', 'P'),
(182334, 'Ivanhoe', 36.3872184753418, 0.635076768037225, -119.216941833496, -2.08072815915307, 218, 6, 'PPL', 'P'),
(188727, 'Ivanhoe (historical)', 32.7838897705078, 0.57218681810625, -108.096672058105, -1.8866428378625, 218, 38, 'PPL', 'P'),
(202252, 'Ivanhoe (historical)', 43.4791717529297, 0.758854703128737, -103.694442749023, -1.80980944199122, 218, 49, 'PPL', 'P'),
(103119, 'Ivanhoe Forest', 37.4813919067383, 0.654173697002938, -79.1347198486328, -1.38116141400195, 218, 53, 'PPL', 'P'),
(211894, 'Ivanof Bay', 55.9000015258789, 0.975639078496441, -159.483337402344, -2.78350933973992, 218, 1, 'PPL', 'P'),
(32850, 'Ivanpah', 37.8980598449707, 0.661445924412591, -96.4822235107422, -1.68393246990753, 218, 20, 'PPL', 'P'),
(182335, 'Ivanpah', 35.3405609130859, 0.616809147434963, -115.309722900391, -2.01253432417412, 218, 6, 'PPL', 'P'),
(209525, 'Ivans Grove (historical)', 41.5877799987793, 0.725843689573742, -106.503890991211, -1.85884356398176, 218, 59, 'PPL', 'P'),
(163041, 'Ivarea', 41.9036102294922, 0.731355966977015, -80.26611328125, -1.40090795453656, 218, 45, 'PPL', 'P'),
(36586, 'Ivel', 37.5911102294922, 0.65608864298476, -82.668327331543, -1.44283449905184, 218, 21, 'PPL', 'P'),
(48480, 'Iverness', 38.1349983215332, 0.665581280953266, -75.811393737793, -1.3231584312503, 218, 25, 'PPL', 'P'),
(196775, 'Iverness', 48.5563888549805, 0.847468858398089, -110.688331604004, -1.93187583002916, 218, 31, 'PPL', 'P'),
(136111, 'Iverson', 46.666389465332, 0.81448214618804, -92.529167175293, -1.61493862133712, 218, 28, 'PPL', 'P'),
(182338, 'Iverson Indian Rancheria', 38.9355583190918, 0.679553688770421, -123.682502746582, -2.15866690003479, 218, 6, 'PPL', 'P'),
(195142, 'Iversons', 42.3047218322754, 0.738356685113534, -114.01000213623, -1.98984991748299, 218, 17, 'PPL', 'P'),
(170609, 'Iversons Subdivision', 43.5283317565918, 0.759712707052934, -96.6394424438477, -1.6866764579367, 218, 49, 'PPL', 'P'),
(55497, 'Ives', 36.7852783203125, 0.642024222951942, -90.1641693115234, -1.57366162181171, 218, 29, 'PPL', 'P'),
(174661, 'Ives', 42.7700004577637, 0.746477329067458, -87.8052825927734, -1.53249128188796, 218, 57, 'PPL', 'P'),
(198453, 'Ives', 46.2708282470703, 0.807578300536173, -103.738891601563, -1.81058522081676, 218, 34, 'PPL', 'P'),
(113588, 'Ives Corner', 41.4672203063965, 0.723739525996471, -72.9063873291016, -1.2724565046271, 218, 8, 'PPL', 'P'),
(149861, 'Ives Corner', 42.6855583190918, 0.745003535720208, -73.5261077880859, -1.28327266707834, 218, 40, 'PPL', 'P'),
(16575, 'Ives Estates', 25.9619407653809, 0.453121346563633, -80.1769409179688, -1.39935160319552, 218, 12, 'PPL', 'P'),
(174662, 'Ives Grove', 42.7291717529297, 0.74576473373878, -87.9661102294922, -1.5352982536769, 218, 57, 'PPL', 'P'),
(149862, 'Ives Hollow', 43.142219543457, 0.75297377765157, -74.8258285522461, -1.30595707376948, 218, 40, 'PPL', 'P'),
(149863, 'Ives Settlement', 42.3844413757324, 0.739748053625046, -75.4638900756836, -1.31709334818375, 218, 40, 'PPL', 'P'),
(27531, 'Ivesdale', 39.9433288574219, 0.697142602768876, -88.4552764892578, -1.54383581549948, 218, 18, 'PPL', 'P'),
(182336, 'Ivesta', 36.7219390869141, 0.640918744783451, -119.635559082031, -2.08803440844565, 218, 6, 'PPL', 'P'),
(116169, 'Ivester', 42.3397216796875, 0.738967547688571, -92.9438934326172, -1.6221769600219, 218, 16, 'PPL', 'P'),
(9679, 'Ivesville', 34.8025016784668, 0.607418242220099, -92.432502746582, -1.61325150878656, 218, 4, 'PPL', 'P'),
(22193, 'Ivey', 32.9069404602051, 0.574334457788317, -83.2908325195313, -1.45369926419298, 218, 13, 'PPL', 'P'),
(65895, 'Ivey Crossroads', 34.4222183227539, 0.600781045572376, -79.0952835083008, -1.38047312001822, 218, 33, 'PPL', 'P'),
(22195, 'Ivey Estates', 33.7061080932617, 0.588282564260525, -84.7333297729492, -1.4788755907161, 218, 13, 'PPL', 'P'),
(81751, 'Ivey Hall', 33.8930587768555, 0.59154546922809, -80.3652801513672, -1.402638742929, 218, 48, 'PPL', 'P'),
(22196, 'Ivey Terrace', 33.7975006103516, 0.589877664595428, -84.5388870239258, -1.47548192453902, 218, 13, 'PPL', 'P'),
(22197, 'Iveys Mill', 31.3911094665527, 0.547878216045306, -84.5861129760742, -1.47630617289639, 218, 13, 'PPL', 'P'),
(116170, 'Iveyville', 40.9008293151855, 0.713854138346205, -94.7955627441406, -1.65449468616612, 218, 16, 'PPL', 'P'),
(192638, 'Ivins', 37.1686096191406, 0.64871461624244, -113.678611755371, -1.98406606422756, 218, 52, 'PPL', 'P'),
(103120, 'Ivondale', 37.8516693115234, 0.660636256862179, -76.6686096191406, -1.3381196707802, 218, 53, 'PPL', 'P'),
(36587, 'Ivor', 38.8597183227539, 0.678230031129624, -84.2408294677734, -1.47027983882371, 218, 21, 'PPL', 'P'),
(103121, 'Ivor', 36.9038887023926, 0.644094364646288, -76.9000015258789, -1.34215822141525, 218, 53, 'PPL', 'P'),
(48481, 'Ivory', 39.2825012207031, 0.685608984719961, -76.978889465332, -1.34353507569882, 218, 25, 'PPL', 'P'),
(55495, 'Ivory', 38.526668548584, 0.672417215997336, -90.2769393920898, -1.57562983101534, 218, 29, 'PPL', 'P'),
(88122, 'Ivory', 36.1661109924316, 0.631217714459646, -84.0083312988281, -1.46622198027076, 218, 50, 'PPL', 'P'),
(149864, 'Ivory', 42.0705604553223, 0.734269798104698, -79.0972213745117, -1.38050694216406, 218, 40, 'PPL', 'P'),
(182337, 'Ivory', 36.5686111450195, 0.638242667362084, -119.422500610352, -2.08431583661557, 218, 6, 'PPL', 'P'),
(163049, 'Ivory Avenue', 40.4947204589844, 0.706766201683987, -80.0116729736328, -1.39646713341885, 218, 45, 'PPL', 'P'),
(48482, 'Ivory Mill', 39.6741714477539, 0.692444919764031, -76.5366668701172, -1.33581683538561, 218, 25, 'PPL', 'P'),
(73009, 'Ivorydale', 39.1775016784668, 0.68377639699485, -84.4963912963867, -1.47474023417543, 218, 41, 'PPL', 'P'),
(73010, 'Ivorydale Junction', 39.1699981689453, 0.683645436048246, -84.5041732788086, -1.47487605539102, 218, 41, 'PPL', 'P'),
(113589, 'Ivoryton', 41.348331451416, 0.721664524033135, -72.4397201538086, -1.26431162590725, 218, 8, 'PPL', 'P'),
(9678, 'Ivy', 34.128059387207, 0.595647003622921, -92.5294418334961, -1.61494341502709, 218, 4, 'PPL', 'P'),
(27532, 'Ivy', 38.1513900756836, 0.665867371033367, -90.2341690063477, -1.57488334696179, 218, 18, 'PPL', 'P'),
(55496, 'Ivy', 37.771110534668, 0.659230240964672, -93.8652801513672, -1.63825819194824, 218, 29, 'PPL', 'P'),
(65896, 'Ivy', 35.8144416809082, 0.625079927095341, -82.5149993896484, -1.44015842163048, 218, 33, 'PPL', 'P'),
(88120, 'Ivy', 35.2694396972656, 0.615567848050877, -84.4238891601563, -1.47347483318348, 218, 50, 'PPL', 'P'),
(103122, 'Ivy', 38.0563888549805, 0.664209286938684, -78.5969390869141, -1.37177536905608, 218, 53, 'PPL', 'P'),
(109806, 'Ivy', 38.939998626709, 0.679631186758142, -80.1847229003906, -1.39948742441111, 218, 58, 'PPL', 'P'),
(116171, 'Ivy', 41.6005592346191, 0.726066729315036, -93.4169387817383, -1.63043315887531, 218, 16, 'PPL', 'P'),
(88121, 'Ivy Bluff', 35.660831451416, 0.622398922825958, -86.0313873291016, -1.50153096895135, 218, 50, 'PPL', 'P'),
(13131, 'Ivy City', 38.9111099243164, 0.679126983784763, -76.9850006103516, -1.34364173530048, 218, 9, 'PPL', 'P'),
(3378, 'Ivy Creek', 31.7069396972656, 0.553390493448579, -86.3652801513672, -1.50735849804866, 218, 2, 'PPL', 'P'),
(182339, 'Ivy del Mobile Home Park', 33.1711082458496, 0.578945055425516, -117.105003356934, -2.0438678791375, 218, 6, 'PPL', 'P'),
(103123, 'Ivy Farms', 38.089168548584, 0.66478140051986, -78.524169921875, -1.37050530753222, 218, 53, 'PPL', 'P'),
(88123, 'Ivy Gap (historical)', 36.2444381713867, 0.632584781626211, -85.6719436645508, -1.49525749352951, 218, 50, 'PPL', 'P'),
(36589, 'Ivy Grove', 36.8222198486328, 0.642668974251851, -83.6958312988281, -1.46076782635827, 218, 21, 'PPL', 'P'),
(27533, 'Ivy Heights', 38.8622207641602, 0.678273706971501, -90.0572204589844, -1.57179501220368, 218, 18, 'PPL', 'P'),
(48488, 'Ivy Hill', 39.4847183227539, 0.689138338954589, -76.668327331543, -1.33811474393218, 218, 25, 'PPL', 'P'),
(163043, 'Ivy Hill', 40.0788917541504, 0.69950862166033, -75.1783294677734, -1.31210937536172, 218, 45, 'PPL', 'P'),
(48485, 'Ivy Hill Way', 39.4169387817383, 0.687955362798376, -77.0475006103516, -1.34473256608298, 218, 25, 'PPL', 'P'),
(30156, 'Ivy Hills', 39.8997192382813, 0.696381471329332, -86.0733337402344, -1.50226307193502, 218, 19, 'PPL', 'P'),
(65898, 'Ivy Hills', 35.5275001525879, 0.620071852665447, -82.9947204589844, -1.44853113378158, 218, 33, 'PPL', 'P'),
(48486, 'Ivy Meadows', 39.4361114501953, 0.688289988989344, -76.8694381713867, -1.34162479024891, 218, 25, 'PPL', 'P'),
(103125, 'Ivy Meadows', 38.0552787780762, 0.664189912441754, -78.6277770996094, -1.37231359391238, 218, 53, 'PPL', 'P'),
(78513, 'Ivy Mills', 39.8972206115723, 0.696337862066482, -75.495002746582, -1.31763636673002, 218, 45, 'PPL', 'P'),
(103124, 'Ivy Oaks', 38.0788917541504, 0.664602036620443, -78.5972213745117, -1.37178029590409, 218, 53, 'PPL', 'P'),
(88124, 'Ivy Point', 36.3486099243164, 0.634402921702408, -86.7925033569336, -1.51481494962672, 218, 50, 'PPL', 'P'),
(112273, 'Ivy Point', 33.7838897705078, 0.589640110626193, -84.6025009155273, -1.47659219639747, 218, 13, 'PPL', 'P'),
(14022, 'Ivy Ridge', 39.6749992370605, 0.692459367412945, -75.6333312988281, -1.32005065541623, 218, 10, 'PPL', 'P'),
(65900, 'Ivy Ridge', 35.9116706848145, 0.626776893341939, -82.5886077880859, -1.44144313054033, 218, 33, 'PPL', 'P'),
(103126, 'Ivy Ridge', 38.084171295166, 0.66469418199416, -78.5027770996094, -1.37013193234739, 218, 53, 'PPL', 'P'),
(163044, 'Ivy Rock', 40.0938911437988, 0.699770410395485, -75.3163909912109, -1.31451900351603, 218, 45, 'PPL', 'P'),
(103127, 'Ivy Woods', 38.0555610656738, 0.66419483928977, -78.6380615234375, -1.37249309096985, 218, 53, 'PPL', 'P'),
(109808, 'Ivydale', 38.310001373291, 0.668635660407477, -81.704719543457, -1.42601637045188, 218, 58, 'PPL', 'P'),
(88125, 'Ivydell', 36.3944396972656, 0.635202802135813, -84.1319427490234, -1.46837940706983, 218, 50, 'PPL', 'P'),
(163045, 'Ivyland', 40.2077789306641, 0.701758127254093, -75.0730590820313, -1.31027206052568, 218, 45, 'PPL', 'P'),
(22198, 'Ivylog', 34.9619407653809, 0.610200979243122, -84.0588912963867, -1.46710441869795, 218, 13, 'PPL', 'P'),
(70980, 'Ivystone Farms', 39.767219543457, 0.694068915396761, -74.9055633544922, -1.3073487085971, 218, 37, 'PPL', 'P'),
(36590, 'Ivyton', 37.7088890075684, 0.658144270451165, -82.9786071777344, -1.44824990397046, 218, 21, 'PPL', 'P'),
(88126, 'Ivyton', 36.4036102294922, 0.635362858117327, -85.1519393920898, -1.48618170685063, 218, 50, 'PPL', 'P'),
(48487, 'Ivytown', 38.7191696166992, 0.675776993449552, -76.0422210693359, -1.32718712818932, 218, 25, 'PPL', 'P'),
(186892, 'Ivywild', 38.8105583190918, 0.677372027205428, -104.834716796875, -1.82971097850127, 218, 7, 'PPL', 'P'),
(22199, 'Ivywood', 33.9041709899902, 0.591739413934475, -83.3988876342773, -1.45558518171892, 218, 13, 'PPL', 'P'),
(70979, 'Ivywood', 39.9819412231445, 0.697816515682721, -74.9897232055664, -1.30881757509633, 218, 37, 'PPL', 'P'),
(163047, 'Ivywood', 40.7108306884766, 0.710538036735866, -79.851936340332, -1.39367920323171, 218, 45, 'PPL', 'P'),
(211589, 'Iwilei', 21.3163890838623, 0.372041174149575, -157.878067016602, -2.75549208612396, 218, 15, 'PPL', 'P'),
(76162, 'IXL', 35.5224990844727, 0.619984567560719, -96.3880615234375, -1.68228903319885, 218, 42, 'PPL', 'P'),
(174663, 'Ixonia', 43.1438903808594, 0.753002939265506, -88.5972213745117, -1.54631322110353, 218, 57, 'PPL', 'P'),
(73011, 'Ixworth (historical)', 39.3666687011719, 0.687077984377249, -84.5441665649414, -1.47557406991273, 218, 41, 'PPL', 'P'),
(188728, 'Iyanbito', 35.5222206115723, 0.61997970729173, -108.476936340332, -1.89327970161508, 218, 38, 'PPL', 'P'),
(16576, 'Izagora', 30.9099998474121, 0.539481269128286, -85.841667175293, -1.49821972761, 218, 12, 'PPL', 'P'),
(201032, 'Izee', 44.0672187805176, 0.769118059916712, -119.38500213623, -2.08366136477769, 218, 43, 'PPL', 'P'),
(95124, 'Izoro', 31.2941703796387, 0.546186309804779, -98.0752792358398, -1.71173653747823, 218, 51, 'PPL', 'P'),
(95131, 'J and E Junction', 30.6688899993896, 0.535273108421311, -93.8894424438477, -1.63867990350685, 218, 51, 'PPL', 'P'),
(202254, 'J and E Trailer Court', 44.1027793884277, 0.769738709608755, -103.52555847168, -1.80686185529672, 218, 49, 'PPL', 'P'),
(199428, 'J and L Trailer Court', 42.8294410705566, 0.747514763470098, -103.069442749023, -1.79890113416625, 218, 35, 'PPL', 'P'),
(196776, 'J and M Trailer Court', 47.1472206115723, 0.822874232836071, -110.223609924316, -1.92376490661322, 218, 31, 'PPL', 'P'),
(178417, 'J and M Trailer Park', 33.4516716003418, 0.583841809721845, -112.25611114502, -1.95923874496529, 218, 5, 'PPL', 'P'),
(95132, 'J and O Colonia', 26.2250003814697, 0.457712602993416, -98.3659973144531, -1.71681052514511, 218, 51, 'PPL', 'P'),
(95125, 'J F Villareal Colonia', 26.4200000762939, 0.461115989708482, -98.9789962768555, -1.72750937535034, 218, 51, 'PPL', 'P'),
(95126, 'J G Gonzales Colonia', 28.0189990997314, 0.489023787403641, -97.5059967041016, -1.70180068292531, 218, 51, 'PPL', 'P'),
(95127, 'J L Garcia Colonia', 26.3770008087158, 0.460365510913298, -98.8320007324219, -1.72494381911421, 218, 51, 'PPL', 'P'),
(163048, 'J M Junction', 40.6041717529297, 0.708676487133901, -79.2958297729492, -1.38397331263891, 218, 45, 'PPL', 'P'),
(209526, 'J O Junction', 41.5352783203125, 0.724927362421673, -108.390830993652, -1.89177687981195, 218, 59, 'PPL', 'P'),
(95128, 'J R Colonia Number 1', 26.1000003814697, 0.455530941428423, -97.9509963989258, -1.70956739277036, 218, 51, 'PPL', 'P'),
(95129, 'J R Colonia Number 2', 26.1009998321533, 0.455548385133563, -97.9449996948242, -1.70946273053952, 218, 51, 'PPL', 'P'),
(95130, 'J W Owens Estates Colonia', 27.7469997406006, 0.484276503023493, -98.1719970703125, -1.71342458213518, 218, 51, 'PPL', 'P'),
(65901, 'Jaars', 34.8636093139648, 0.608484771657648, -80.7461090087891, -1.40928546037762, 218, 33, 'PPL', 'P'),
(36591, 'Jabez', 36.9869384765625, 0.645543856648591, -84.8936080932617, -1.48167297512512, 218, 21, 'PPL', 'P'),
(125150, 'Jabez Corner', 41.9458312988281, 0.73209286365064, -70.6466674804688, -1.23301695309579, 218, 23, 'PPL', 'P'),
(9682, 'Jabur (historical)', 36.0588912963867, 0.629346377740675, -94.3111114501953, -1.64603941602123, 218, 4, 'PPL', 'P'),
(88127, 'Jacen Gorbett Subdivision', 35.2463912963867, 0.615165577568221, -84.9375, -1.48243903341268, 218, 50, 'PPL', 'P'),
(3380, 'Jachin', 32.2297210693359, 0.5625147496593, -88.168327331543, -1.53882760791153, 218, 2, 'PPL', 'P'),
(9683, 'Jacinto', 33.9044418334961, 0.59174414104541, -92.6380615234375, -1.61683918624906, 218, 4, 'PPL', 'P'),
(60404, 'Jacinto', 34.7597198486328, 0.606671558429468, -88.4283294677734, -1.54336550125097, 218, 30, 'PPL', 'P'),
(182342, 'Jacinto', 39.5811080932617, 0.690820657815192, -122.005561828613, -2.12939875965482, 218, 6, 'PPL', 'P'),
(199429, 'Jacinto', 41.225830078125, 0.719526471730992, -103.403610229492, -1.80473345695353, 218, 35, 'PPL', 'P'),
(95133, 'Jacinto City', 29.767219543457, 0.519535990197328, -95.2336120605469, -1.66214008902352, 218, 51, 'PPL', 'P'),
(110, 'Jack', 37.1963882446289, 0.649199444718888, -77.5094375610352, -1.35279488680903, 218, 53, 'PPL', 'P'),
(3381, 'Jack', 31.5738906860352, 0.551068350136085, -86.0002822875977, -1.50098808356314, 218, 2, 'PPL', 'P'),
(41506, 'Jack', 30.7380599975586, 0.536480352632958, -90.7122192382813, -1.58322689749895, 218, 22, 'PPL', 'P'),
(55498, 'Jack', 37.5761108398438, 0.655826854249605, -91.6211090087891, -1.59909001653201, 218, 29, 'PPL', 'P'),
(60405, 'Jack', 32.017219543457, 0.558805898367201, -90.5699996948242, -1.58074469820494, 218, 30, 'PPL', 'P'),
(188729, 'Jack Canon Place', 35.288890838623, 0.615907334510835, -105.626937866211, -1.84353784456485, 218, 38, 'PPL', 'P'),
(200016, 'Jack Creek', 41.4947204589844, 0.72421949420393, -116.098892211914, -2.0263079270159, 218, 39, 'PPL', 'P'),
(200017, 'Jack Creek Camp', 41.8994407653809, 0.731283196100229, -115.401390075684, -2.01413421819899, 218, 39, 'PPL', 'P'),
(3382, 'Jack Lane (historical)', 34.9341697692871, 0.609716283924728, -86.1097183227539, -1.50289810269694, 218, 2, 'PPL', 'P'),
(136112, 'Jack Pine', 47.3833312988281, 0.826995141727832, -95.5202789306641, -1.66714336976346, 218, 28, 'PPL', 'P'),
(209527, 'Jack Pine', 43.3261108398438, 0.756183286239279, -110.433326721191, -1.92742515521542, 218, 59, 'PPL', 'P'),
(3383, 'Jack Springs', 31.1611099243164, 0.543863966755202, -87.5524978637695, -1.52807935606808, 218, 2, 'PPL', 'P'),
(194254, 'Jack Springs', 40.3511085510254, 0.704259701045031, -108.702499389648, -1.89721651949649, 218, 7, 'PPL', 'P'),
(211895, 'Jack Wade', 64.154167175293, 1.11970144608373, -141.459716796875, -2.4689378170442, 218, 1, 'PPL', 'P'),
(55499, 'Jacket', 36.5102806091309, 0.637224607456374, -94.107780456543, -1.64249062071065, 218, 29, 'PPL', 'P'),
(127821, 'Jackins Settlement', 46.0163917541504, 0.803137545997493, -67.8211135864258, -1.18370173445219, 218, 26, 'PPL', 'P'),
(127816, 'Jackman', 45.6238899230957, 0.796287096725482, -70.254997253418, -1.22618101805172, 218, 26, 'PPL', 'P'),
(190339, 'Jackman', 36.642219543457, 0.639527376271939, -114.539436340332, -1.99909028751724, 218, 39, 'PPL', 'P'),
(127817, 'Jackman Corner', 45.0947189331055, 0.787051320644115, -69.3363876342773, -1.21014825565722, 218, 26, 'PPL', 'P'),
(127818, 'Jackman Mill (historical)', 45.646110534668, 0.796674919559225, -70.2455596923828, -1.2260163015383, 218, 26, 'PPL', 'P'),
(200018, 'Jackpot', 41.9833297729492, 0.732747335488527, -114.673889160156, -2.00143693191176, 218, 39, 'PPL', 'P'),
(190340, 'Jackrabbit (historical)', 38.0958290100098, 0.664897647501442, -114.594718933105, -2.00005515078017, 218, 39, 'PPL', 'P'),
(178418, 'Jackrabbit House', 32.605281829834, 0.569069521471285, -111.895278930664, -1.95294103477753, 218, 5, 'PPL', 'P'),
(76200, 'Jacks', 36.0444412231445, 0.629094176385444, -97.9091720581055, -1.70883742031557, 218, 42, 'PPL', 'P'),
(9684, 'Jacks Bay Landing', 34.0952796936035, 0.595074890041745, -91.1699981689453, -1.5912166470853, 218, 4, 'PPL', 'P'),
(48489, 'Jacks Corner', 39.6413917541504, 0.691872806182855, -76.1266708374023, -1.32866105469462, 218, 25, 'PPL', 'P'),
(36593, 'Jacks Creek', 37.3658294677734, 0.652156751951367, -82.7330627441406, -1.44396434514431, 218, 21, 'PPL', 'P'),
(88128, 'Jacks Creek', 35.4686088562012, 0.61904400564273, -88.5208282470703, -1.54497990950378, 218, 50, 'PPL', 'P'),
(103130, 'Jacks Fork', 38.047779083252, 0.664059018074176, -77.1363906860352, -1.346283990576, 218, 53, 'PPL', 'P'),
(9685, 'Jacks Isle', 33.7166709899902, 0.588466921586986, -94.0561065673828, -1.64158874120749, 218, 4, 'PPL', 'P'),
(131484, 'Jacks Landing', 44.6725006103516, 0.779682220749811, -85.4541702270508, -1.49145663002175, 218, 27, 'PPL', 'P'),
(78511, 'Jacks Mountain', 39.7544403076172, 0.693845875655467, -77.4024963378906, -1.35092841035904, 218, 45, 'PPL', 'P'),
(149865, 'Jacks Reef', 43.0991706848145, 0.752222433329031, -76.4244384765625, -1.33385808040385, 218, 40, 'PPL', 'P'),
(88129, 'Jacksboro', 36.3300018310547, 0.634078149207473, -84.1838912963867, -1.46928608026295, 218, 50, 'PPL', 'P'),
(95135, 'Jacksboro', 33.2183303833008, 0.579769237203869, -98.158332824707, -1.71318609605956, 218, 51, 'PPL', 'P'),
(182343, 'Jacksnipe', 38.1927795410156, 0.666589753479051, -122.066940307617, -2.1304700162033, 218, 6, 'PPL', 'P'),
(3384, 'Jackson', 31.5088901519775, 0.549933876801225, -87.8944396972656, -1.53404736691289, 218, 2, 'PPL', 'P'),
(22200, 'Jackson', 33.2944412231445, 0.5810976219556, -83.9661102294922, -1.46548508359713, 218, 13, 'PPL', 'P'),
(27535, 'Jackson', 38.7211112976074, 0.675810882174423, -87.6502838134766, -1.52978604285266, 218, 18, 'PPL', 'P'),
(30157, 'Jackson', 39.064998626709, 0.681812848323135, -85.4413909912109, -1.49123359028045, 218, 19, 'PPL', 'P'),
(36595, 'Jackson', 37.8250007629395, 0.660170802882661, -84.8708267211914, -1.48127536517437, 218, 21, 'PPL', 'P'),
(41507, 'Jackson', 30.8372192382813, 0.538211007867346, -91.2174987792969, -1.59204568913264, 218, 22, 'PPL', 'P'),
(48490, 'Jackson', 39.5825004577637, 0.690844959160139, -76.0422210693359, -1.32718712818932, 218, 25, 'PPL', 'P'),
(55500, 'Jackson', 37.3822212219238, 0.652442842031469, -89.6661071777344, -1.56496879769759, 218, 29, 'PPL', 'P'),
(60406, 'Jackson', 32.2986106872559, 0.563717100312443, -90.1847229003906, -1.57402034961055, 218, 30, 'PPL', 'P'),
(65905, 'Jackson', 34.8666687011719, 0.608538168037504, -80.6836090087891, -1.40819462959513, 218, 33, 'PPL', 'P'),
(70981, 'Jackson', 39.7763900756836, 0.694228971378275, -74.8627777099609, -1.30660195822744, 218, 37, 'PPL', 'P'),
(81753, 'Jackson', 33.3252792358398, 0.581635846811905, -81.7880630493164, -1.42747098903928, 218, 48, 'PPL', 'P'),
(88130, 'Jackson', 35.6144409179688, 0.621589255275546, -88.8138885498047, -1.55009477669338, 218, 50, 'PPL', 'P'),
(95138, 'Jackson', 32.4813919067383, 0.566907234403222, -95.929443359375, -1.6742846362265, 218, 51, 'PPL', 'P'),
(103131, 'Jackson', 37.8722190856934, 0.660994918081986, -77.8219375610352, -1.35824904072151, 218, 53, 'PPL', 'P'),
(109810, 'Jackson', 37.9502792358398, 0.662357324716643, -81.7133331298828, -1.42616670589542, 218, 58, 'PPL', 'P'),
(116173, 'Jackson', 42.1541709899902, 0.735729077224007, -91.3525009155273, -1.59440192090709, 218, 16, 'PPL', 'P'),
(127820, 'Jackson', 44.6147193908691, 0.778673748224025, -69.1213912963867, -1.2063958616813, 218, 26, 'PPL', 'P'),
(131485, 'Jackson', 42.2458305358887, 0.737328838090818, -84.4013900756836, -1.47308215008074, 218, 27, 'PPL', 'P'),
(136113, 'Jackson', 43.6208305358887, 0.76132711530574, -94.9883270263672, -1.65785905757122, 218, 28, 'PPL', 'P'),
(142126, 'Jackson', 42.4486083984375, 0.740867979442451, -96.5644378662109, -1.68536738110287, 218, 35, 'PPL', 'P'),
(143995, 'Jackson', 44.1441688537598, 0.770461092054439, -71.1813888549805, -1.24234960166181, 218, 36, 'PPL', 'P'),
(155862, 'Jackson', 40.9602813720703, 0.714891772485928, -81.8994369506836, -1.42941483031893, 218, 41, 'PPL', 'P'),
(163053, 'Jackson', 41.8380584716797, 0.730211872972717, -75.5911102294922, -1.31931375874261, 218, 45, 'PPL', 'P'),
(169436, 'Jackson', 41.7386093139648, 0.728476157732258, -71.5500030517578, -1.24878313306516, 218, 47, 'PPL', 'P'),
(174665, 'Jackson', 43.3238906860352, 0.756144537245418, -88.1666717529297, -1.5387987126137, 218, 57, 'PPL', 'P'),
(182344, 'Jackson', 38.3488883972168, 0.669314367011284, -120.773063659668, -2.10788760858192, 218, 6, 'PPL', 'P'),
(195143, 'Jackson', 42.6338882446289, 0.74410172279608, -113.569717407227, -1.98216549931562, 218, 17, 'PPL', 'P'),
(196777, 'Jackson', 45.3680610656738, 0.791822040841856, -113.408058166504, -1.97934401329874, 218, 31, 'PPL', 'P'),
(207733, 'Jackson', 46.5344390869141, 0.812179177635394, -117.91194152832, -2.05795160708822, 218, 56, 'PPL', 'P'),
(209528, 'Jackson', 43.4799995422363, 0.758869150777651, -110.761672973633, -1.93315587840711, 218, 59, 'PPL', 'P'),
(9687, 'Jackson (historical)', 33.1972198486328, 0.579400788867056, -91.4727783203125, -1.59650115763634, 218, 4, 'PPL', 'P'),
(73013, 'Jackson (historical)', 39.9555587768555, 0.697356055130246, -81.9330596923828, -1.43000165786513, 218, 41, 'PPL', 'P'),
(200020, 'Jackson (historical)', 41.4855613708496, 0.724059637959498, -116.250282287598, -2.02895018229142, 218, 39, 'PPL', 'P'),
(109809, 'Jackson Acres', 39.1194381713867, 0.682762997621048, -80.4091720581055, -1.40340480121657, 218, 58, 'PPL', 'P'),
(16588, 'Jackson Bluff', 30.3888893127441, 0.530386174531502, -84.6419372558594, -1.4772804903812, 218, 12, 'PPL', 'P'),
(155863, 'Jackson Center', 40.4394416809082, 0.705801405000078, -84.040283203125, -1.46677964620302, 218, 41, 'PPL', 'P'),
(163055, 'Jackson Center', 41.9397201538086, 0.731986204048983, -76.9822235107422, -1.34359326576864, 218, 45, 'PPL', 'P'),
(88131, 'Jackson Chapel', 36.2555618286133, 0.632778926069678, -87.2305603027344, -1.52246048564218, 218, 50, 'PPL', 'P'),
(204467, 'Jackson Condominium', 40.7675018310547, 0.711527134764721, -111.896667480469, -1.95296526954345, 218, 52, 'PPL', 'P'),
(65906, 'Jackson Corner', 36.4213905334473, 0.635673182963349, -76.3680572509766, -1.33287404238107, 218, 33, 'PPL', 'P'),
(163057, 'Jackson Corner', 40.5963897705078, 0.708540665918307, -77.8622207641602, -1.35895211524929, 218, 45, 'PPL', 'P'),
(172154, 'Jackson Corner', 44.0872192382813, 0.769467133756594, -72.5175018310547, -1.26566917227292, 218, 55, 'PPL', 'P'),
(149866, 'Jackson Corners', 42.0166702270508, 0.73332923618671, -73.7452774047852, -1.28709789851008, 218, 40, 'PPL', 'P'),
(65908, 'Jackson Creek', 35.6955604553223, 0.62300505829006, -80.0124969482422, -1.39648151448874, 218, 33, 'PPL', 'P'),
(95140, 'Jackson Crossing', 31.2483291625977, 0.545386229634292, -97.8375015258789, -1.70758653355156, 218, 51, 'PPL', 'P'),
(163058, 'Jackson Crossing', 41.8433303833008, 0.73030388518838, -79.2169418334961, -1.38259645835534, 218, 45, 'PPL', 'P'),
(81754, 'Jackson Crossroads', 34.2361106872559, 0.597532854569833, -79.9730606079102, -1.39579322050501, 218, 48, 'PPL', 'P'),
(65917, 'Jackson Dunes', 35.1119384765625, 0.612818933173698, -75.9686126708984, -1.32590241927946, 218, 33, 'PPL', 'P'),
(22203, 'Jackson Estates', 33.5574989318848, 0.585688845095869, -84.4375, -1.47371238715271, 218, 13, 'PPL', 'P'),
(143997, 'Jackson Falls', 44.1480598449707, 0.770529002662236, -71.1816711425781, -1.24235452850982, 218, 36, 'PPL', 'P'),
(194256, 'Jackson Field', 40.4069404602051, 0.705234151687891, -104.685829162598, -1.82711239906763, 218, 7, 'PPL', 'P'),
(109812, 'Jackson Flats', 37.3316688537598, 0.651560536762325, -81.8794403076172, -1.42906582305808, 218, 58, 'PPL', 'P'),
(48491, 'Jackson Grove', 39.103889465332, 0.682491621505969, -76.708610534668, -1.33881781845996, 218, 25, 'PPL', 'P'),
(65909, 'Jackson Hamlet', 35.1666717529297, 0.613774209056709, -79.4719390869141, -1.38704700001103, 218, 33, 'PPL', 'P'),
(3386, 'Jackson Heights', 30.670280456543, 0.535297376476744, -88.1580581665039, -1.53864837717017, 218, 2, 'PPL', 'P'),
(22204, 'Jackson Heights', 33.7519416809082, 0.589082511272958, -82.7797164916992, -1.4447786066476, 218, 13, 'PPL', 'P'),
(88134, 'Jackson Heights', 35.6402816772461, 0.622040261606151, -87.0091705322266, -1.51859650521658, 218, 50, 'PPL', 'P'),
(103132, 'Jackson Heights', 37.3911094665527, 0.652597971164966, -79.1338882446289, -1.38114689977401, 218, 53, 'PPL', 'P'),
(109813, 'Jackson Heights', 39.1199989318848, 0.682772784738054, -80.4080581665039, -1.40338536014061, 218, 58, 'PPL', 'P'),
(149867, 'Jackson Heights', 40.7555618286133, 0.711318742409423, -73.8858337402344, -1.28955106934821, 218, 40, 'PPL', 'P'),
(155864, 'Jackson Heights', 40.1755599975586, 0.701195800789923, -80.7041702270508, -1.40855349055202, 218, 41, 'PPL', 'P'),
(30159, 'Jackson Hill', 39.1683311462402, 0.683616341013337, -87.3619384765625, -1.52475346734073, 218, 19, 'PPL', 'P'),
(65911, 'Jackson Hill', 35.5724983215332, 0.620857218870911, -80.1502838134766, -1.39888634895308, 218, 33, 'PPL', 'P'),
(88135, 'Jackson Hills', 35.7999992370605, 0.624827858898165, -83.9402770996094, -1.46503421042458, 218, 50, 'PPL', 'P'),
(88136, 'Jackson Hollow', 36.1955604553223, 0.631731704550031, -86.5500030517578, -1.51058252086431, 218, 50, 'PPL', 'P'),
(116175, 'Jackson Junction', 43.1150016784668, 0.752498736292127, -92.0322189331055, -1.60626523829895, 218, 16, 'PPL', 'P'),
(163059, 'Jackson Knolls Gardens', 40.9544410705566, 0.714789839995205, -80.4280624389648, -1.40373450055952, 218, 45, 'PPL', 'P'),
(41508, 'Jackson Landing', 32.348331451416, 0.564584891353646, -91.4997177124023, -1.5969713387268, 218, 22, 'PPL', 'P'),
(48492, 'Jackson Landing', 38.7727813720703, 0.676712695098551, -76.7102813720703, -1.3388469800739, 218, 25, 'PPL', 'P'),
(60408, 'Jackson Landing', 30.2061100006104, 0.527196073730237, -89.5733337402344, -1.56334959575482, 218, 30, 'PPL', 'P'),
(65913, 'Jackson Line', 35.3980598449707, 0.617812693112732, -83.4749984741211, -1.45691356647066, 218, 33, 'PPL', 'P'),
(55502, 'Jackson Mill', 36.8972206115723, 0.643977984506652, -92.7733306884766, -1.61920007855541, 218, 29, 'PPL', 'P'),
(81755, 'Jackson Mill', 34.9488906860352, 0.609973212390893, -82.0830612182617, -1.43261967837473, 218, 48, 'PPL', 'P'),
(109814, 'Jackson Mill', 39.0961112976074, 0.682355866869402, -80.4761123657227, -1.40457312998678, 218, 58, 'PPL', 'P'),
(48493, 'Jackson Mill Farms', 39.6338882446289, 0.69174184523625, -76.033332824707, -1.32703199905582, 218, 25, 'PPL', 'P'),
(78512, 'Jackson Mills', 39.9719390869141, 0.697641945473266, -78.2713928222656, -1.36609351487039, 218, 45, 'PPL', 'P'),
(3388, 'Jackson Oak', 30.6224994659424, 0.5344634408709, -87.9119415283203, -1.53435283148993, 218, 2, 'PPL', 'P'),
(41510, 'Jackson Park', 30.5597190856934, 0.5333677165299, -91.0358276367188, -1.58887492953879, 218, 22, 'PPL', 'P'),
(65914, 'Jackson Park', 35.3758316040039, 0.617424737120935, -80.5997161865234, -1.4067304236278, 218, 33, 'PPL', 'P'),
(103135, 'Jackson Park', 37.2861099243164, 0.650765383439855, -79.9124984741211, -1.39473621186836, 218, 53, 'PPL', 'P'),
(41511, 'Jackson Place', 30.5669403076172, 0.533493750628488, -91.040283203125, -1.58895269384262, 218, 22, 'PPL', 'P'),
(3389, 'Jackson Quarters', 32.644718170166, 0.569757815455015, -87.8516693115234, -1.53330088285934, 218, 2, 'PPL', 'P'),
(88137, 'Jackson Range Station', 35.5394401550293, 0.620280245020745, -88.5127792358398, -1.54483942775628, 218, 50, 'PPL', 'P'),
(48494, 'Jackson Ridge', 39.5222206115723, 0.689792877371503, -76.5711135864258, -1.33641804400169, 218, 25, 'PPL', 'P'),
(88138, 'Jackson Ridge', 35.7602806091309, 0.624134638066417, -86.5736083984375, -1.51099451188495, 218, 50, 'PPL', 'P'),
(41512, 'Jackson Road (historical)', 30.7166690826416, 0.536107010737642, -91.2441711425781, -1.59251120969118, 218, 22, 'PPL', 'P'),
(163061, 'Jackson Run', 41.9049987792969, 0.731380201742935, -79.2383270263672, -1.38296970038212, 218, 45, 'PPL', 'P'),
(73016, 'Jackson Special', 39.9933280944824, 0.698015254079068, -81.5736083984375, -1.42372804928523, 218, 41, 'PPL', 'P'),
(65916, 'Jackson Springs', 35.2094383239746, 0.614520626531231, -79.626106262207, -1.38973772481839, 218, 33, 'PPL', 'P'),
(3390, 'Jackson Spur', 31.9566707611084, 0.557749122757144, -88.3150024414063, -1.54138757150937, 218, 2, 'PPL', 'P'),
(22207, 'Jackson Square', 34.0163917541504, 0.593698035758174, -84.0508270263672, -1.46696367063434, 218, 13, 'PPL', 'P'),
(88139, 'Jackson Square', 36.0247192382813, 0.628749962814551, -84.2402801513672, -1.47027025144378, 218, 50, 'PPL', 'P'),
(149872, 'Jackson Summit', 43.1341705322266, 0.752833295904068, -74.2844390869141, -1.29650804506382, 218, 40, 'PPL', 'P'),
(163062, 'Jackson Summit', 41.9433288574219, 0.732049187808763, -77.0169372558594, -1.34419913491663, 218, 45, 'PPL', 'P'),
(22208, 'Jackson Township', 33.9694404602051, 0.592878581090756, -84.0480575561523, -1.46691533426056, 218, 13, 'PPL', 'P'),
(103137, 'Jackson Woods', 39.1405601501465, 0.683131645694942, -78.2161102294922, -1.36512865160746, 218, 53, 'PPL', 'P'),
(95141, 'Jackson''s New World Colonia', 26.30299949646, 0.459073944363637, -98.0970001220703, -1.71211563845941, 218, 51, 'PPL', 'P'),
(95142, 'Jackson''s New World Colonia Number 2', 26.3020000457764, 0.459056500658497, -98.0989990234375, -1.71215052586969, 218, 51, 'PPL', 'P'),
(81756, 'Jacksonboro', 32.7700004577637, 0.571944403868025, -80.454719543457, -1.40419975480195, 218, 48, 'PPL', 'P'),
(22209, 'Jacksonboro (historical)', 32.8222198486328, 0.572855804172077, -81.6230621337891, -1.42459117979453, 218, 13, 'PPL', 'P'),
(3392, 'Jacksonburg', 34.8908309936523, 0.608959879596118, -87.6636123657227, -1.53001866997388, 218, 2, 'PPL', 'P'),
(30184, 'Jacksonburg', 39.8530616760254, 0.695567143247013, -85.105827331543, -1.4853768995692, 218, 19, 'PPL', 'P'),
(73031, 'Jacksonburg', 39.538330078125, 0.690074040603588, -84.5025024414063, -1.47484689377709, 218, 41, 'PPL', 'P'),
(109815, 'Jacksonburg', 39.5322189331055, 0.68996738100193, -80.6419372558594, -1.40746732030143, 218, 58, 'PPL', 'P'),
(145495, 'Jacksonburg', 40.9916687011719, 0.715439584722157, -74.980827331543, -1.30866231280478, 218, 37, 'PPL', 'P'),
(149869, 'Jacksonburg', 43.0141716003418, 0.750738919443803, -74.9155578613281, -1.3075231456485, 218, 40, 'PPL', 'P'),
(9703, 'Jacksonport', 35.6416702270508, 0.622064496372071, -91.309440612793, -1.59365037684747, 218, 4, 'PPL', 'P'),
(174671, 'Jacksonport', 44.9786109924316, 0.785024854791646, -87.1855621337891, -1.52167511943671, 218, 57, 'PPL', 'P'),
(122901, 'Jacksons', 40.3291702270508, 0.703876805059305, -86.0611114501953, -1.5020497527317, 218, 19, 'PPL', 'P'),
(48495, 'Jacksons Corner', 38.9027786254883, 0.678981575189245, -76.5180587768555, -1.33549206289067, 218, 25, 'PPL', 'P'),
(22210, 'Jacksons Crossroads', 33.8902816772461, 0.591496999696251, -82.8450012207031, -1.44591804011999, 218, 13, 'PPL', 'P'),
(65922, 'Jacksons Crossroads', 35.223331451416, 0.614763107348483, -77.646110534668, -1.35518028019741, 218, 33, 'PPL', 'P'),
(3393, 'Jacksons Gap', 32.8861083984375, 0.573970869720494, -85.8116683959961, -1.49769615013969, 218, 2, 'PPL', 'P'),
(3394, 'Jacksons Lake', 32.4452781677246, 0.566276930752227, -86.3411102294922, -1.506936653332, 218, 2, 'PPL', 'P'),
(145504, 'Jacksons Mills', 40.1477813720703, 0.700710972313474, -74.3244400024414, -1.29720619274359, 218, 37, 'PPL', 'P'),
(103138, 'Jacksons Store', 36.9569396972656, 0.645020279178282, -81.9005584716797, -1.42943440455295, 218, 53, 'PPL', 'P'),
(65923, 'Jacksons Trailer Park', 35.5633316040039, 0.620697229468424, -77.357780456543, -1.3501479710016, 218, 33, 'PPL', 'P'),
(65924, 'Jacksontown', 36.4233283996582, 0.635707005109193, -78.329719543457, -1.36711150819707, 218, 33, 'PPL', 'P'),
(73032, 'Jacksontown', 39.9594383239746, 0.697423766000961, -82.4130630493164, -1.43837929686425, 218, 41, 'PPL', 'P'),
(103139, 'Jacksontown', 38.9169387817383, 0.679228716538404, -77.9411087036133, -1.36032896953286, 218, 53, 'PPL', 'P'),
(48496, 'Jacksontown (historical)', 38.478328704834, 0.671573526563998, -77.2233276367188, -1.34780132660707, 218, 25, 'PPL', 'P'),
(3395, 'Jacksonville', 33.8136100769043, 0.590158827827513, -85.7613906860352, -1.49681863856051, 218, 2, 'PPL', 'P'),
(9704, 'Jacksonville', 34.8661117553711, 0.608528447499525, -92.1100006103516, -1.60762278466462, 218, 4, 'PPL', 'P'),
(16590, 'Jacksonville', 30.3319396972656, 0.529392216233657, -81.6558303833008, -1.42516309363862, 218, 12, 'PPL', 'P'),
(22213, 'Jacksonville', 34.917781829834, 0.609430260423653, -83.8574981689453, -1.46358944553321, 218, 13, 'PPL', 'P'),
(27537, 'Jacksonville', 39.7338905334473, 0.693487214435661, -90.228889465332, -1.57479120158807, 218, 18, 'PPL', 'P'),
(30185, 'Jacksonville', 38.8288917541504, 0.677692006010401, -85.0488891601563, -1.48438314100844, 218, 19, 'PPL', 'P'),
(36598, 'Jacksonville', 38.274169921875, 0.6680102836045, -85.0130615234375, -1.48375783078449, 218, 21, 'PPL', 'P'),
(48497, 'Jacksonville', 39.5180587768555, 0.689720239652771, -76.5597229003906, -1.33621923902632, 218, 25, 'PPL', 'P'),
(65925, 'Jacksonville', 34.7538909912109, 0.606569825675827, -77.4305572509766, -1.35141816568351, 218, 33, 'PPL', 'P'),
(81757, 'Jacksonville', 33.5027809143066, 0.584733835528967, -81.8430633544922, -1.4284309254542, 218, 48, 'PPL', 'P'),
(88140, 'Jacksonville', 36.2999992370605, 0.633554505158136, -89.3194427490234, -1.55891836201703, 218, 50, 'PPL', 'P'),
(95143, 'Jacksonville', 31.9636096954346, 0.557870230007715, -95.2702789306641, -1.66278004663347, 218, 51, 'PPL', 'P'),
(109816, 'Jacksonville', 38.8908309936523, 0.678773049675891, -80.4922180175781, -1.40485422663984, 218, 58, 'PPL', 'P'),
(116209, 'Jacksonville', 41.6452789306641, 0.726847235251511, -95.1497192382813, -1.6606758830562, 218, 16, 'PPL', 'P'),
(127823, 'Jacksonville', 44.7605590820313, 0.781219131014896, -67.3958282470703, -1.17627910501998, 218, 26, 'PPL', 'P'),
(139238, 'Jacksonville', 40.2772216796875, 0.702970131866188, -93.1125030517578, -1.62511975302644, 218, 29, 'PPL', 'P'),
(145498, 'Jacksonville', 40.9524993896484, 0.714755951270333, -74.3302764892578, -1.29730805865528, 218, 37, 'PPL', 'P'),
(149871, 'Jacksonville', 42.5083312988281, 0.741910340693108, -76.6152801513672, -1.33718889597922, 218, 40, 'PPL', 'P'),
(155888, 'Jacksonville', 40.3722190856934, 0.704628149381844, -80.6116714477539, -1.40693908229921, 218, 41, 'PPL', 'P'),
(163082, 'Jacksonville', 40.7052803039551, 0.710441164251214, -75.4088897705078, -1.31613341176883, 218, 45, 'PPL', 'P'),
(172153, 'Jacksonville', 42.7969398498535, 0.746947510157912, -72.8222198486328, -1.27098750496981, 218, 55, 'PPL', 'P'),
(174673, 'Jacksonville', 43.9519386291504, 0.767106041713157, -90.557502746582, -1.58052658531166, 218, 57, 'PPL', 'P'),
(201034, 'Jacksonville', 42.3136100769043, 0.738511814247031, -122.965827941895, -2.1461585650269, 218, 43, 'PPL', 'P'),
(41513, 'Jacksonville (historical)', 31.3238906860352, 0.546705027006099, -92.9911117553711, -1.62300107522123, 218, 22, 'PPL', 'P'),
(116210, 'Jacksonville (historical)', 41.1055603027344, 0.717427368159792, -93.5583267211914, -1.63290084394138, 218, 16, 'PPL', 'P'),
(16591, 'Jacksonville Beach', 30.2944393157959, 0.528737711106257, -81.3933334350586, -1.42058165761536, 218, 12, 'PPL', 'P'),
(16592, 'Jacksonville Heights', 30.2519397735596, 0.527995954163642, -81.7861099243164, -1.42743690057733, 218, 12, 'PPL', 'P'),
(163084, 'Jacksonwald', 40.3244400024414, 0.703794247065513, -75.8499984741211, -1.32383221100609, 218, 45, 'PPL', 'P'),
(36599, 'Jackstown', 38.2447204589844, 0.667496293514114, -84.0586090087891, -1.46709949184994, 218, 21, 'PPL', 'P'),
(163085, 'Jacksville', 41.0169410705566, 0.715880670777701, -80.1130599975586, -1.39823667080516, 218, 45, 'PPL', 'P'),
(36600, 'Jacktown', 37.4438896179199, 0.653519158586024, -85.0155563354492, -1.48380137346831, 218, 21, 'PPL', 'P'),
(48498, 'Jacktown', 38.5519409179688, 0.67285830205288, -76.0430603027344, -1.32720177557531, 218, 25, 'PPL', 'P'),
(65927, 'Jacktown', 35.667781829834, 0.622520229813611, -81.9680633544922, -1.4306125870192, 218, 33, 'PPL', 'P'),
(76205, 'Jacktown', 35.5069389343262, 0.619712991708558, -97.0002822875977, -1.69297430128252, 218, 42, 'PPL', 'P'),
(88141, 'Jacktown', 35.3624992370605, 0.617192043420689, -84.2797164916992, -1.47095854542752, 218, 50, 'PPL', 'P'),
(163086, 'Jacktown', 40.3300018310547, 0.703891319287246, -79.727783203125, -1.39151232221076, 218, 45, 'PPL', 'P'),
(109817, 'Jaco', 39.6672210693359, 0.692323612776378, -79.918327331543, -1.394837944622, 218, 58, 'PPL', 'P'),
(27539, 'Jacob', 37.7449989318848, 0.658774507523132, -89.5369415283203, -1.56271443183483, 218, 18, 'PPL', 'P'),
(88142, 'Jacob (historical)', 36.5586090087891, 0.63806809715263, -81.9958267211914, -1.43109714917954, 218, 50, 'PPL', 'P'),
(178419, 'Jacob Lake', 36.7133293151855, 0.640768475918943, -112.215560913086, -1.9585310099056, 218, 5, 'PPL', 'P'),
(95144, 'Jacob Settlement', 30.2583293914795, 0.528107474034289, -94.7750015258789, -1.65413582520924, 218, 51, 'PPL', 'P'),
(95145, 'Jacobia', 33.2200012207031, 0.579798398817805, -96.0541687011719, -1.67646150410153, 218, 51, 'PPL', 'P'),
(16593, 'Jacobs', 30.8947200775146, 0.539214586834628, -85.3977813720703, -1.49047245884091, 218, 12, 'PPL', 'P'),
(32862, 'Jacobs', 38.6119384765625, 0.673905456993499, -97.0305633544922, -1.69350280560084, 218, 20, 'PPL', 'P'),
(36601, 'Jacobs', 38.2308311462402, 0.66725387927589, -83.2413864135742, -1.45283626684174, 218, 21, 'PPL', 'P'),
(55534, 'Jacobs', 38.7063903808594, 0.675553953708258, -90.6025009155273, -1.58131195151713, 218, 29, 'PPL', 'P'),
(95146, 'Jacobs', 32.2694511413574, 0.563208170228129, -94.8618927001953, -1.65565236229198, 218, 51, 'PPL', 'P'),
(116212, 'Jacobs', 41.6650009155273, 0.727191448822404, -92.6686096191406, -1.61737235109929, 218, 16, 'PPL', 'P'),
(191667, 'Jacobs (historical)', 34.0800018310547, 0.594808241037601, -100.213333129883, -1.74905261751437, 218, 51, 'PPL', 'P'),
(36602, 'Jacobs Addition', 38.189998626709, 0.666541217368185, -85.7886123657227, -1.49729374649898, 218, 21, 'PPL', 'P'),
(182345, 'Jacobs Corner', 38.6716690063477, 0.674947951402211, -121.893333435059, -2.12744000467306, 218, 6, 'PPL', 'P'),
(163087, 'Jacobs Creek', 40.1330604553223, 0.700454043847308, -79.741943359375, -1.39175946355992, 218, 45, 'PPL', 'P'),
(32863, 'Jacobs Creek Landing', 38.2652816772461, 0.667855154471003, -95.8694381713867, -1.67323734812783, 218, 20, 'PPL', 'P'),
(14023, 'Jacobs Crossroads', 38.7430610656738, 0.676193977897231, -75.686393737793, -1.32097676968531, 218, 10, 'PPL', 'P'),
(109818, 'Jacobs Fork', 37.2277793884277, 0.649747323534145, -81.5930633544922, -1.42406760232422, 218, 58, 'PPL', 'P'),
(125151, 'Jacobs Lake Shores', 42.1616706848145, 0.735859971591585, -70.8533325195313, -1.23662393847619, 218, 23, 'PPL', 'P'),
(78517, 'Jacobs Mills', 39.8325004577637, 0.695208282290125, -76.9283294677734, -1.34265263727162, 218, 45, 'PPL', 'P'),
(136117, 'Jacobs Prairie', 45.4869384765625, 0.793896843068109, -94.3927764892578, -1.64746473983664, 218, 28, 'PPL', 'P'),
(48499, 'Jacobs Run', 39.3883285522461, 0.687456020093986, -77.188606262207, -1.34719532430103, 218, 25, 'PPL', 'P'),
(73037, 'Jacobsburg', 39.7588882446289, 0.693923506801243, -81.2486114501953, -1.41805578247947, 218, 41, 'PPL', 'P'),
(163088, 'Jacobsburg (historical)', 40.7966690063477, 0.71203619800709, -75.3000030517578, -1.31423298001495, 218, 45, 'PPL', 'P'),
(182346, 'Jacobsen (historical)', 39.0055618286133, 0.680775480499522, -120.384437561035, -2.1011048036016, 218, 6, 'PPL', 'P'),
(136118, 'Jacobson', 47.0008316040039, 0.820319262665276, -93.267219543457, -1.62782006521373, 218, 28, 'PPL', 'P'),
(145499, 'Jacobstown', 40.0758285522461, 0.699455158701447, -74.583610534668, -1.30172957185508, 218, 37, 'PPL', 'P'),
(48500, 'Jacobsville', 39.1213912963867, 0.682797086083001, -76.5177764892578, -1.33548713604266, 218, 25, 'PPL', 'P'),
(131488, 'Jacobsville', 46.9808311462402, 0.819970188825394, -88.4100036621094, -1.54304565560405, 218, 27, 'PPL', 'P'),
(190342, 'Jacobsville (historical)', 39.5011100769043, 0.68942442903469, -117.180282592773, -2.04518174966129, 218, 39, 'PPL', 'P'),
(78519, 'Jacobus', 39.8830604553223, 0.696090720717322, -76.7108306884766, -1.33885656745382, 218, 45, 'PPL', 'P'),
(41514, 'Jacoby', 30.9150009155273, 0.539568554233014, -91.7891693115234, -1.60202322215662, 218, 22, 'PPL', 'P'),
(65928, 'Jacocks', 36.149169921875, 0.63092203699962, -76.2644424438477, -1.33106562284285, 218, 33, 'PPL', 'P'),
(188730, 'Jacona', 35.8905601501465, 0.626408445005127, -106.04167175293, -1.85077631640769, 218, 38, 'PPL', 'P'),
(188732, 'Jaconita', 35.8861083984375, 0.626330747280323, -106.059440612793, -1.85108644151663, 218, 38, 'PPL', 'P'),
(109819, 'Jacox', 38.0888900756836, 0.664776540250871, -80.3077774047852, -1.40163513067221, 218, 58, 'PPL', 'P'),
(195144, 'Jacques', 46.3716697692871, 0.809338317121579, -116.726387023926, -2.03725977752469, 218, 17, 'PPL', 'P'),
(182347, 'Jacumba', 32.6175003051758, 0.569282774095573, -116.188888549805, -2.02787865942683, 218, 6, 'PPL', 'P'),
(122902, 'Jadden', 40.5361099243164, 0.707488584129671, -85.4574966430664, -1.49151468693351, 218, 19, 'PPL', 'P'),
(9706, 'Jade (historical)', 33.5547218322754, 0.58564037556403, -91.6624984741211, -1.59981239897769, 218, 4, 'PPL', 'P'),
(22214, 'Jade Lake Village', 33.3319396972656, 0.581752093793487, -84.6197204589844, -1.47689273412648, 218, 13, 'PPL', 'P'),
(112413, 'Jadwin', 37.4866714477539, 0.654265842376655, -91.5708312988281, -1.59821250495283, 218, 29, 'PPL', 'P'),
(143998, 'Jady Hill', 42.9858283996582, 0.750244237271321, -70.9438934326172, -1.23820452458315, 218, 36, 'PPL', 'P'),
(55535, 'Jaegers Shop', 38.461109161377, 0.671272988834983, -91.2991714477539, -1.5934711461061, 218, 29, 'PPL', 'P'),
(143999, 'Jaffrey', 42.8138885498047, 0.747243320775992, -72.0236129760742, -1.25704918561461, 218, 36, 'PPL', 'P'),
(144000, 'Jaffrey Center', 42.8277816772461, 0.747485801593244, -72.0555572509766, -1.25760671838882, 218, 36, 'PPL', 'P'),
(190343, 'Jaggersville', 38.3716697692871, 0.669711976962033, -118.540557861328, -2.06892303183102, 218, 39, 'PPL', 'P'),
(60409, 'Jago', 34.9361114501953, 0.609750172649599, -89.9766693115234, -1.57038912946422, 218, 30, 'PPL', 'P'),
(95147, 'Jagoe', 33.1736106872559, 0.578988731267394, -97.1488876342773, -1.69556795386814, 218, 51, 'PPL', 'P'),
(103140, 'Jahile', 37.0372200012207, 0.646421434806799, -82.1613922119141, -1.43398681212033, 218, 53, 'PPL', 'P'),
(95148, 'Jaime Lake Colonia', 25.8899993896484, 0.451865732688688, -97.4179992675781, -1.70026483792466, 218, 51, 'PPL', 'P'),
(155889, 'Jaite', 41.288330078125, 0.720617302513489, -81.5738906860352, -1.42373297613325, 218, 41, 'PPL', 'P'),
(9705, 'Jakajones (historical)', 33.8280601501465, 0.590411029182743, -93.6266708374023, -1.63409367379363, 218, 4, 'PPL', 'P'),
(22215, 'Jake', 33.6519393920898, 0.587337142073547, -85.2275009155273, -1.48750050422243, 218, 13, 'PPL', 'P'),
(55536, 'Jake Prairie', 38.163330078125, 0.666075763388666, -91.5111083984375, -1.59717014370217, 218, 29, 'PPL', 'P'),
(95149, 'Jakes Colony', 29.4406890869141, 0.513836958622613, -97.9711837768555, -1.70991972898258, 218, 51, 'PPL', 'P'),
(178420, 'Jakes Corner', 34.0105590820313, 0.593596236425506, -111.31861114502, -1.94287628322785, 218, 5, 'PPL', 'P'),
(109820, 'Jakes Run', 39.6580581665039, 0.692163689952919, -80.17138671875, -1.39925466413184, 218, 58, 'PPL', 'P'),
(65930, 'Jakesville', 35.8536109924316, 0.625763560547164, -80.2799987792969, -1.40115030219576, 218, 33, 'PPL', 'P'),
(60411, 'Jaketown', 33.2502784729004, 0.580326836557104, -90.4794387817383, -1.57916411209798, 218, 30, 'PPL', 'P'),
(136120, 'Jakeville', 45.7502784729004, 0.798492993056395, -93.9863891601563, -1.64037194290543, 218, 28, 'PPL', 'P'),
(22216, 'Jakin', 31.0908298492432, 0.542637348046625, -84.9822235107422, -1.48321960592819, 218, 13, 'PPL', 'P'),
(211896, 'Jakolof Bay', 59.4469413757324, 1.03754485724658, -151.510284423828, -2.64435331382888, 218, 1, 'PPL', 'P'),
(188733, 'Jal', 32.1130599975586, 0.56047862984788, -103.193061828613, -1.80105869412338, 218, 38, 'PPL', 'P'),
(182348, 'Jalama', 34.4980583190918, 0.602104703213172, -120.493606567383, -2.10301016220349, 218, 6, 'PPL', 'P'),
(182349, 'Jalama (historical)', 34.5102806091309, 0.602318022416488, -120.498062133789, -2.10308792650732, 218, 6, 'PPL', 'P'),
(27545, 'Jalapa', 39.2205581665039, 0.684527874475444, -90.3241729736328, -1.57645421253077, 218, 18, 'PPL', 'P'),
(81758, 'Jalapa', 34.3444404602051, 0.599423565785735, -81.6855621337891, -1.42568201057702, 218, 48, 'PPL', 'P'),
(88143, 'Jalapa', 35.3441696166992, 0.616872131194744, -84.3619384765625, -1.4723935897809, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(122907, 'Jalapa', 40.6277809143066, 0.709088544733563, -85.7455596923828, -1.49654233559742, 218, 19, 'PPL', 'P'),
(163089, 'Jalappa', 40.5286102294922, 0.707357689762093, -76.0377807617188, -1.32710963020159, 218, 45, 'PPL', 'P'),
(81759, 'Jaluco', 33.7777786254883, 0.589533451024535, -78.9766693115234, -1.37840291174485, 218, 48, 'PPL', 'P'),
(182351, 'Jamacha', 32.7416687011719, 0.571449921432625, -116.91056060791, -2.04047421296042, 218, 6, 'PPL', 'P'),
(182350, 'Jamacha Junction', 32.7397193908691, 0.571415899549699, -116.942497253418, -2.04103161257657, 218, 6, 'PPL', 'P'),
(22217, 'Jamaica', 31.2516708374023, 0.545444552862164, -81.6524963378906, -1.4251049035688, 218, 13, 'PPL', 'P'),
(27540, 'Jamaica', 39.9911117553711, 0.697976571664235, -87.8066711425781, -1.53251551665388, 218, 18, 'PPL', 'P'),
(103141, 'Jamaica', 37.7150001525879, 0.658250930052822, -76.6944427490234, -1.33857054395275, 218, 53, 'PPL', 'P'),
(116213, 'Jamaica', 41.8461112976074, 0.730352421299246, -94.309440612793, -1.6460102544073, 218, 16, 'PPL', 'P'),
(142128, 'Jamaica', 40.6988906860352, 0.710329644380567, -96.6894378662109, -1.68754904266786, 218, 35, 'PPL', 'P'),
(149873, 'Jamaica', 40.6913909912109, 0.71019875001299, -73.8061065673828, -1.28815956767864, 218, 40, 'PPL', 'P'),
(172155, 'Jamaica', 43.1002807617188, 0.752241807825962, -72.7788925170898, -1.27023130037828, 218, 55, 'PPL', 'P'),
(95150, 'Jamaica Beach', 29.1894397735596, 0.509451830861203, -94.9794387817383, -1.65770392843772, 218, 51, 'PPL', 'P'),
(22218, 'Jamaica Estates', 33.5333290100098, 0.585267000379201, -82.1236114501953, -1.43332741343442, 218, 13, 'PPL', 'P'),
(125152, 'Jamaica Plain', 42.3097190856934, 0.738443903639234, -71.1208267211914, -1.24129259302515, 218, 23, 'PPL', 'P'),
(3398, 'Jamback', 31.9099998474121, 0.55693456164823, -85.665283203125, -1.49514124654793, 218, 2, 'PPL', 'P'),
(36603, 'Jamboree', 37.4983291625977, 0.654469307883937, -82.1369400024414, -1.43356004055564, 218, 21, 'PPL', 'P'),
(22219, 'Jamerson Forest', 34.0638885498047, 0.594527011226488, -84.5097198486328, -1.47497286129665, 218, 13, 'PPL', 'P'),
(3397, 'James', 32.644718170166, 0.569757815455015, -85.5730590820313, -1.49353163198508, 218, 2, 'PPL', 'P'),
(22220, 'James', 32.9663887023926, 0.575372025349012, -83.4738922119141, -1.45689425855275, 218, 13, 'PPL', 'P'),
(48501, 'James', 38.5855598449707, 0.673445063020052, -76.2588882446289, -1.33096868377917, 218, 25, 'PPL', 'P'),
(60410, 'James', 33.2036094665527, 0.579512308737703, -91.0572204589844, -1.58924830472362, 218, 30, 'PPL', 'P'),
(95152, 'James', 32.6933288574219, 0.570606231999288, -94.7427825927734, -1.65357349874507, 218, 51, 'PPL', 'P'),
(116214, 'James', 42.5769386291504, 0.743107764498235, -96.3172225952148, -1.68105266066278, 218, 16, 'PPL', 'P'),
(170614, 'James', 45.4661102294922, 0.793533321579313, -98.2122192382813, -1.71412659139853, 218, 49, 'PPL', 'P'),
(182352, 'James', 39.6533317565918, 0.692081198538154, -121.548606872559, -2.12142339113836, 218, 6, 'PPL', 'P'),
(199430, 'James', 41.9319381713867, 0.731850382833389, -103.578330993652, -1.80778290955972, 218, 35, 'PPL', 'P'),
(22221, 'James Acres', 33.8016700744629, 0.589950435472214, -84.595832824707, -1.47647581625783, 218, 13, 'PPL', 'P'),
(95153, 'James Allen Colonia', 26.2609996795654, 0.458340909273593, -98.3079986572266, -1.71579825761477, 218, 51, 'PPL', 'P'),
(55538, 'James Brothers', 38.1572189331055, 0.665969103787008, -91.8752822875977, -1.60352617711781, 218, 29, 'PPL', 'P'),
(81761, 'James Byrnes Estates', 32.476390838623, 0.566819949298495, -80.6369400024414, -1.40738010177573, 218, 48, 'PPL', 'P'),
(65931, 'James City', 35.0886116027832, 0.612411802422052, -77.0352783203125, -1.34451924687966, 218, 33, 'PPL', 'P'),
(144002, 'James City', 43.1430587768555, 0.752988425037565, -71.2347183227539, -1.24328037646279, 218, 36, 'PPL', 'P'),
(163090, 'James City', 41.6199989318848, 0.726406016037912, -78.8391723632813, -1.37600313728658, 218, 45, 'PPL', 'P'),
(109821, 'James Crest Farms', 37.8255615234375, 0.660180589999667, -81.2191696166992, -1.41754192554714, 218, 58, 'PPL', 'P'),
(81762, 'James Crossroads', 33.6313896179199, 0.58697848085374, -80.2163925170898, -1.40004016349536, 218, 48, 'PPL', 'P'),
(103144, 'James Crossroads', 37.3638916015625, 0.652122929805523, -75.940559387207, -1.32541279711305, 218, 53, 'PPL', 'P'),
(22222, 'James Heights', 33.8422203063965, 0.590658170531903, -84.6588897705078, -1.47757636757831, 218, 13, 'PPL', 'P'),
(9708, 'James Mill', 35.2627792358398, 0.615451601069295, -90.2174987792969, -1.5745923966127, 218, 4, 'PPL', 'P'),
(195145, 'James Place', 42.2769393920898, 0.737871790058058, -115.779167175293, -2.02072767242581, 218, 17, 'PPL', 'P'),
(103145, 'James River Estates', 37.577220916748, 0.655846228746535, -77.6624984741211, -1.35546630369849, 218, 53, 'PPL', 'P'),
(103146, 'James River Junction', 36.7036094665527, 0.640598832557505, -77.4730606079102, -1.35215998920515, 218, 53, 'PPL', 'P'),
(103147, 'James River Landing', 37.6647186279297, 0.657373351894614, -78.01611328125, -1.36163804636669, 218, 53, 'PPL', 'P'),
(22223, 'James Spring (historical)', 34.2369384765625, 0.597547302218747, -83.2074966430664, -1.45224477876364, 218, 13, 'PPL', 'P'),
(103155, 'James Terrace', 37.2619400024414, 0.650343538723187, -76.67138671875, -1.33816814031204, 218, 53, 'PPL', 'P'),
(209529, 'James Town', 41.5552787780762, 0.725276436261555, -109.51611328125, -1.9114167607449, 218, 59, 'PPL', 'P'),
(170615, 'James Valley Junction', 44.3805618286133, 0.774586927794217, -98.295280456543, -1.71557628313791, 218, 49, 'PPL', 'P'),
(182355, 'Jamesan', 36.7200012207031, 0.640884922637607, -120.208892822266, -2.09804096992551, 218, 6, 'PPL', 'P'),
(22224, 'Jamesburg', 34.8919410705566, 0.608979254093048, -85.4119415283203, -1.49071960019007, 218, 13, 'PPL', 'P'),
(120146, 'Jamesburg', 40.2622184753418, 0.702708276552006, -87.748893737793, -1.53150711070712, 218, 18, 'PPL', 'P'),
(145500, 'Jamesburg', 40.3525009155273, 0.704284002389978, -74.440559387207, -1.29923285833314, 218, 37, 'PPL', 'P'),
(182356, 'Jamesburg', 36.3697204589844, 0.634771370039221, -121.589172363281, -2.12213139251415, 218, 6, 'PPL', 'P'),
(145501, 'Jamesburg Gardens', 40.3430595397949, 0.70411921929753, -74.4208297729492, -1.29888851160419, 218, 37, 'PPL', 'P'),
(145502, 'Jamesburg Park', 40.3797187805176, 0.704759043749421, -74.4391708374023, -1.29920862356722, 218, 37, 'PPL', 'P'),
(88145, 'Jameson', 35.753059387207, 0.624008603967829, -87.0088882446289, -1.51859157836856, 218, 50, 'PPL', 'P'),
(136121, 'Jameson', 48.603889465332, 0.84829790044543, -93.3658294677734, -1.62954113306819, 218, 28, 'PPL', 'P'),
(139239, 'Jameson', 40.0052795410156, 0.698223846171449, -93.9791717529297, -1.64024597538587, 218, 29, 'PPL', 'P'),
(9711, 'Jameson (historical)', 35.9152793884277, 0.626839877101719, -92.658332824707, -1.61719298719988, 218, 4, 'PPL', 'P'),
(207735, 'Jameson (historical)', 47.7138900756836, 0.832764480755325, -119.662780761719, -2.08850951638412, 218, 56, 'PPL', 'P'),
(55539, 'Jamesport', 39.9747200012207, 0.697690481584133, -93.8008270263672, -1.63713327270379, 218, 29, 'PPL', 'P'),
(149874, 'Jamesport', 40.9494400024414, 0.714702554890477, -72.5819396972656, -1.26679382520126, 218, 40, 'PPL', 'P'),
(3399, 'Jamestown', 34.3977813720703, 0.6003545403238, -85.5774993896484, -1.4936091299728, 218, 2, 'PPL', 'P'),
(9713, 'Jamestown', 35.4419403076172, 0.618578551663212, -93.4625015258789, -1.63122837877681, 218, 4, 'PPL', 'P'),
(16599, 'Jamestown', 28.6305599212646, 0.499697537315597, -81.2405624389648, -1.41791530073197, 218, 12, 'PPL', 'P'),
(22228, 'Jamestown', 31.2702808380127, 0.545769358646613, -82.3833312988281, -1.43786037992585, 218, 13, 'PPL', 'P'),
(27543, 'Jamestown', 38.0497207641602, 0.664092906799048, -89.529167175293, -1.56257874377729, 218, 18, 'PPL', 'P'),
(32864, 'Jamestown', 39.5994415283203, 0.691140636620165, -97.8608322143555, -1.70799373088224, 218, 20, 'PPL', 'P'),
(36604, 'Jamestown', 36.9847183227539, 0.64550510765473, -85.0630569458008, -1.48463041551566, 218, 21, 'PPL', 'P'),
(41515, 'Jamestown', 32.3438911437988, 0.564507393365924, -93.211669921875, -1.62685054141888, 218, 22, 'PPL', 'P'),
(55541, 'Jamestown', 38.7655601501465, 0.676586660999964, -92.4805603027344, -1.61409027137188, 218, 29, 'PPL', 'P'),
(60415, 'Jamestown', 31.1833305358887, 0.544251789588945, -89.8552780151367, -1.56827045165901, 218, 30, 'PPL', 'P'),
(65932, 'Jamestown', 35.9941711425781, 0.628216797964318, -79.9355621337891, -1.39513874866712, 218, 33, 'PPL', 'P'),
(73038, 'Jamestown', 39.6580581665039, 0.692163689952919, -83.7350006103516, -1.4614514598101, 218, 41, 'PPL', 'P'),
(76206, 'Jamestown', 36.5694389343262, 0.638257115010998, -95.6297225952148, -1.66905352205532, 218, 42, 'PPL', 'P'),
(81766, 'Jamestown', 33.5852813720703, 0.586173740151346, -79.0097198486328, -1.37897975243696, 218, 48, 'PPL', 'P'),
(88149, 'Jamestown', 36.4275016784668, 0.635779842565006, -84.9319381713867, -1.48234196119095, 218, 50, 'PPL', 'P'),
(95155, 'Jamestown', 32.5858306884766, 0.568730035011327, -95.5841674804688, -1.66825843531187, 218, 51, 'PPL', 'P'),
(103149, 'Jamestown', 37.2080612182617, 0.64940317654228, -76.7744369506836, -1.33996670615422, 218, 53, 'PPL', 'P'),
(109822, 'Jamestown', 39.2413902282715, 0.684891462543267, -77.9844436645508, -1.36108530728244, 218, 58, 'PPL', 'P'),
(116217, 'Jamestown', 41.4944381713867, 0.724214567355913, -90.7080612182617, -1.58315432635925, 218, 16, 'PPL', 'P'),
(122904, 'Jamestown', 41.7483291625977, 0.728645801093696, -85.0175018310547, -1.48383532877221, 218, 19, 'PPL', 'P'),
(131490, 'Jamestown', 42.8255615234375, 0.747447052599383, -85.8424987792969, -1.49823424183794, 218, 27, 'PPL', 'P'),
(140285, 'Jamestown', 46.9105606079102, 0.818743736564385, -98.7080612182617, -1.72278066651879, 218, 34, 'PPL', 'P'),
(149875, 'Jamestown', 42.0969390869141, 0.734730192078146, -79.2355575561523, -1.38292136400833, 218, 40, 'PPL', 'P'),
(163093, 'Jamestown', 41.4847183227539, 0.724044923994475, -80.4377822875977, -1.40390414392096, 218, 45, 'PPL', 'P'),
(169437, 'Jamestown', 41.496940612793, 0.724258243197791, -71.3677825927734, -1.24560278609139, 218, 47, 'PPL', 'P'),
(174675, 'Jamestown', 42.5877799987793, 0.743296982093685, -90.5483322143555, -1.58036652933015, 218, 57, 'PPL', 'P'),
(182357, 'Jamestown', 37.9533309936523, 0.662410587938445, -120.421669006348, -2.10175461490757, 218, 6, 'PPL', 'P'),
(194257, 'Jamestown', 40.1155586242676, 0.700148579270276, -105.388061523438, -1.83936866587834, 218, 7, 'PPL', 'P'),
(204471, 'Jamestown', 40.6388893127441, 0.709282422860921, -111.845832824707, -1.95207803742629, 218, 52, 'PPL', 'P'),
(207736, 'Jamestown', 48.1283302307129, 0.839997826013062, -123.085830688477, -2.14825300806619, 218, 56, 'PPL', 'P'),
(27544, 'Jamestown (historical)', 38.038890838623, 0.663903888940679, -88.3741683959961, -1.54242021222205, 218, 18, 'PPL', 'P'),
(103150, 'Jamestown (historical)', 37.3244400024414, 0.651434369505683, -78.2919387817383, -1.36645210951117, 218, 53, 'PPL', 'P'),
(109823, 'Jamestown (historical)', 38.4561080932617, 0.671185703730256, -81.0294418334961, -1.41423055104774, 218, 58, 'PPL', 'P'),
(190344, 'Jamestown (historical)', 37.5411109924316, 0.655215991674568, -116.782783508301, -2.03824408186358, 218, 39, 'PPL', 'P'),
(195146, 'Jamestown (historical)', 46.996940612793, 0.820251352057479, -117.032501220703, -2.04260247814555, 218, 17, 'PPL', 'P'),
(81768, 'Jamestown Estates', 34.9669418334961, 0.61028826434785, -82.2652816772461, -1.43580002534851, 218, 48, 'PPL', 'P'),
(103151, 'Jamestown Farms', 37.2586097717285, 0.650285415232395, -76.7483291625977, -1.33951103929171, 218, 53, 'PPL', 'P'),
(140286, 'Jamestown Junction', 46.8633308410645, 0.817919421627978, -98.6705627441406, -1.72212619468091, 218, 34, 'PPL', 'P'),
(103153, 'Jamestown Place', 37.252498626709, 0.650178755630738, -79.9138870239258, -1.39476044663428, 218, 53, 'PPL', 'P'),
(169438, 'Jamestown Shores', 41.5297203063965, 0.724830356778967, -71.3897171020508, -1.24598561549809, 218, 47, 'PPL', 'P'),
(14024, 'Jamestowne', 39.6522216796875, 0.692061824041223, -75.6438903808594, -1.32023494616366, 218, 10, 'PPL', 'P'),
(3402, 'Jamesville', 32.7127799987793, 0.570945718459245, -85.6211090087891, -1.49437026141235, 218, 2, 'PPL', 'P'),
(55542, 'Jamesville', 36.9599990844727, 0.645073675558138, -93.3708267211914, -1.62962835159389, 218, 29, 'PPL', 'P'),
(65934, 'Jamesville', 35.8111114501953, 0.62502180360455, -76.8969421386719, -1.34210482503539, 218, 33, 'PPL', 'P'),
(76207, 'Jamesville', 35.7550010681152, 0.6240424926927, -95.6402816772461, -1.66923781280275, 218, 42, 'PPL', 'P'),
(103154, 'Jamesville', 37.5149993896484, 0.654760258233028, -75.9308319091797, -1.32524302059356, 218, 53, 'PPL', 'P'),
(125153, 'Jamesville', 42.2361106872559, 0.73715919472938, -71.8541717529297, -1.25409187838213, 218, 23, 'PPL', 'P'),
(149877, 'Jamesville', 42.9919395446777, 0.750350896872978, -76.0719375610352, -1.32770577881161, 218, 40, 'PPL', 'P'),
(163095, 'Jamesville', 40.7350006103516, 0.710959881452535, -75.4199981689453, -1.31632728989619, 218, 45, 'PPL', 'P'),
(170616, 'Jamesville', 43.1027793884277, 0.752285417088812, -97.4833297729492, -1.70140507034538, 218, 49, 'PPL', 'P'),
(125154, 'Jamesville (historical)', 42.2291717529297, 0.737038087478808, -71.8491668701172, -1.25400452669837, 218, 23, 'PPL', 'P'),
(16600, 'Jamieson', 30.6625003814697, 0.535161588550664, -84.4505615234375, -1.47394035374202, 218, 12, 'PPL', 'P'),
(201035, 'Jamieson', 44.1822204589844, 0.771125217851278, -117.436943054199, -2.04966131977286, 218, 43, 'PPL', 'P'),
(81769, 'Jamison', 33.5819396972656, 0.586115416923473, -80.8180618286133, -1.41054127398965, 218, 48, 'PPL', 'P'),
(116219, 'Jamison', 41.1216697692871, 0.717708531391877, -93.7247161865234, -1.63580488795206, 218, 16, 'PPL', 'P'),
(142129, 'Jamison', 42.9977798461914, 0.750452829363701, -99.307502746582, -1.73324289486117, 218, 35, 'PPL', 'P'),
(163098, 'Jamison', 41.586669921875, 0.725824315076812, -77.8949966430664, -1.35952416225144, 218, 45, 'PPL', 'P'),
(182358, 'Jamison (historical)', 39.7761116027832, 0.694224111109286, -120.681106567383, -2.10628265455098, 218, 6, 'PPL', 'P'),
(163099, 'Jamison City', 41.3063888549805, 0.7209324876285, -76.3611068725586, -1.33275273539342, 218, 45, 'PPL', 'P'),
(207737, 'Jamison Corner', 47.9355583190918, 0.83663332144991, -122.010833740234, -2.12949077187048, 218, 56, 'PPL', 'P'),
(149878, 'Jamison Road', 42.8050003051758, 0.747088191642495, -78.6213912963867, -1.37220214062076, 218, 40, 'PPL', 'P'),
(81770, 'Jamison Terrace', 32.9772186279297, 0.57556104320738, -80.1455612182617, -1.39880392411734, 218, 48, 'PPL', 'P'),
(14025, 'Jamisons Corner', 39.5036087036133, 0.689468038297541, -75.6847229003906, -1.32094760807137, 218, 10, 'PPL', 'P'),
(163100, 'Jamisonville', 40.9438896179199, 0.714605682405826, -79.9247207641602, -1.39494953107167, 218, 45, 'PPL', 'P'),
(182359, 'Jamul', 32.7169418334961, 0.571018356177977, -116.875282287598, -2.03985849011639, 218, 6, 'PPL', 'P'),
(182361, 'Jamul Indian Village', 32.7058296203613, 0.570824411471592, -116.870559692383, -2.03977606528065, 218, 6, 'PPL', 'P'),
(88150, 'Jan Mor Acres', 35.9388885498047, 0.627251934701382, -85.0888900756836, -1.48508128868821, 218, 50, 'PPL', 'P'),
(16601, 'Jan-Phyl Village', 28.014440536499, 0.488944225466075, -81.7719421386719, -1.42718962607012, 218, 12, 'PPL', 'P'),
(149881, 'Janacks Landing Shelter', 44.1116714477539, 0.769893905321279, -74.8919372558594, -1.30711088831175, 218, 40, 'PPL', 'P'),
(55543, 'Jane', 36.5472183227539, 0.637869292177255, -94.3050003051758, -1.64593275641957, 218, 29, 'PPL', 'P'),
(199431, 'Jane', 41.9247207641602, 0.731724415313828, -103.773330688477, -1.81118629627479, 218, 35, 'PPL', 'P'),
(109824, 'Jane Lew', 39.1097183227539, 0.68259335425961, -80.4069366455078, -1.4033657859066, 218, 58, 'PPL', 'P'),
(65936, 'Janeiro', 34.9955596923828, 0.610787740210294, -76.7655563354492, -1.33981171017878, 218, 33, 'PPL', 'P'),
(3403, 'Janes Mill', 31.2780609130859, 0.545905146572694, -87.1533279418945, -1.52111252665643, 218, 2, 'PPL', 'P'),
(193678, 'Janes Place', 40.7894401550293, 0.711910030750448, -123.715560913086, -2.15924387388495, 218, 6, 'PPL', 'P'),
(27546, 'Janesville', 39.3741683959961, 0.687208878744826, -88.2436065673828, -1.54014147843532, 218, 18, 'PPL', 'P'),
(116220, 'Janesville', 42.646110534668, 0.744315041999395, -92.4627838134766, -1.61378001310488, 218, 16, 'PPL', 'P'),
(136123, 'Janesville', 44.1161117553711, 0.769971403309001, -93.7077789306641, -1.63550927707106, 218, 28, 'PPL', 'P'),
(149879, 'Janesville', 42.7061080932617, 0.745362196940015, -74.57861328125, -1.30164235332938, 218, 40, 'PPL', 'P'),
(163103, 'Janesville', 40.7599983215332, 0.711396173818117, -78.4216690063477, -1.36871632906996, 218, 45, 'PPL', 'P'),
(174677, 'Janesville', 42.6827812194824, 0.744955066188369, -89.0186080932617, -1.55366780676989, 218, 57, 'PPL', 'P'),
(193679, 'Janesville', 40.2966690063477, 0.703309551747118, -120.523063659668, -2.10352428545193, 218, 6, 'PPL', 'P'),
(103156, 'Janette Land', 37.2594413757324, 0.650299929460336, -79.9513931274414, -1.39541505163022, 218, 53, 'PPL', 'P'),
(103157, 'Janey', 37.2219390869141, 0.649645391043422, -82.0305633544922, -1.43170341780169, 218, 53, 'PPL', 'P'),
(60412, 'Janice', 31.0252799987793, 0.541493287331841, -89.0366668701172, -1.5539829918849, 218, 30, 'PPL', 'P'),
(41516, 'Janie', 31.4624996185303, 0.549124209250813, -92.8863906860352, -1.62117334776511, 218, 22, 'PPL', 'P'),
(109825, 'Janie', 37.9822196960449, 0.662914790911824, -81.5386123657227, -1.42311725328922, 218, 58, 'PPL', 'P'),
(207738, 'Janis', 48.6474990844727, 0.849059031884975, -119.464172363281, -2.08504314590927, 218, 56, 'PPL', 'P'),
(199432, 'Janise', 41.8530616760254, 0.730473728286899, -104.003059387207, -1.81519581845396, 218, 35, 'PPL', 'P'),
(122906, 'Janney', 40.3650016784668, 0.704502181862283, -85.5438919067383, -1.49302256874271, 218, 19, 'PPL', 'P'),
(163101, 'Janney', 40.1477813720703, 0.700710972313474, -74.9375, -1.30790610821325, 218, 45, 'PPL', 'P'),
(196778, 'Janney', 45.9094390869141, 0.80127086981043, -112.494438171387, -1.96339833627189, 218, 31, 'PPL', 'P'),
(142130, 'Jansen', 40.1852798461914, 0.70136544415136, -97.0833282470703, -1.69442372670579, 218, 35, 'PPL', 'P'),
(186893, 'Jansen', 37.1494407653809, 0.648380056630498, -104.538330078125, -1.8245380543999, 218, 7, 'PPL', 'P'),
(209919, 'Jantz', 47.2299995422363, 0.824318997727439, -118.641387939453, -2.07068284867935, 218, 56, 'PPL', 'P'),
(70982, 'Janvier', 39.6269416809082, 0.691620604827624, -75.0177764892578, -1.30930719726274, 218, 37, 'PPL', 'P'),
(48502, 'Janwood', 39.2763900756836, 0.685502325118304, -77.1697235107422, -1.34686575811613, 218, 25, 'PPL', 'P'),
(55544, 'Japan', 38.2391700744629, 0.667399421029463, -91.3058319091797, -1.59358739308769, 218, 29, 'PPL', 'P'),
(163102, 'Japan', 40.9925003051758, 0.715454098950098, -75.9105606079102, -1.32488921964274, 218, 45, 'PPL', 'P'),
(211590, 'Japanese Village One', 20.9052791595459, 0.364865952382629, -156.42138671875, -2.73006821877752, 218, 15, 'PPL', 'P'),
(9715, 'Japton', 35.9619407653809, 0.627654271763066, -93.8041687011719, -1.63719159593166, 218, 4, 'PPL', 'P'),
(27547, 'Jaques', 39.8838882446289, 0.696105168366236, -90.7430572509766, -1.58376512235526, 218, 18, 'PPL', 'P'),
(149880, 'Jaquins', 42.0166702270508, 0.73332923618671, -79.6091690063477, -1.38944211393739, 218, 40, 'PPL', 'P'),
(60413, 'Jaquith', 33.7680587768555, 0.589363807663097, -90.5358276367188, -1.58014828327882, 218, 30, 'PPL', 'P'),
(188734, 'Jarales', 34.6130599975586, 0.604111861147738, -106.763061523438, -1.86336694309326, 218, 38, 'PPL', 'P'),
(32866, 'Jarbalo', 39.2019386291504, 0.684202902243427, -95.0688934326172, -1.65926520662678, 218, 20, 'PPL', 'P'),
(200022, 'Jarbidge', 41.8736114501953, 0.730832389506706, -115.431106567383, -2.01465286882128, 218, 39, 'PPL', 'P'),
(95156, 'Jardin', 33.3294410705566, 0.581708484530637, -95.9180603027344, -1.67408596440918, 218, 51, 'PPL', 'P'),
(95157, 'Jardin de San Julian Colonia', 26.5259990692139, 0.462966021138733, -99.0999984741211, -1.72962126209477, 218, 51, 'PPL', 'P'),
(95158, 'Jardin Terrace Colonia', 26.2910003662109, 0.458864520033416, -98.2779998779297, -1.71527468014446, 218, 51, 'PPL', 'P'),
(196779, 'Jardine', 45.0699996948242, 0.786619888547522, -110.633613586426, -1.93092082046226, 218, 31, 'PPL', 'P'),
(207739, 'Jared', 48.4691696166992, 0.845946595518999, -117.314437866211, -2.04752320089169, 218, 56, 'PPL', 'P'),
(188735, 'Jarett Place', 35.0386085510254, 0.611539084532833, -106.132217407227, -1.85235663619854, 218, 38, 'PPL', 'P'),
(65938, 'Jarmantown', 34.9700012207031, 0.610341660727706, -77.6324996948242, -1.35494272622818, 218, 33, 'PPL', 'P'),
(188736, 'Jarosa', 36.0466690063477, 0.629133058537359, -106.684440612793, -1.86199474934159, 218, 38, 'PPL', 'P'),
(186894, 'Jaroso', 37.0027809143066, 0.645820359348769, -105.623611450195, -1.84347978765309, 218, 7, 'PPL', 'P'),
(22231, 'Jarrard', 33.5261116027832, 0.58514103285964, -84.345832824707, -1.47211249312785, 218, 13, 'PPL', 'P'),
(103158, 'Jarratt', 36.8141708374023, 0.642528492504349, -77.4686126708984, -1.35208235805938, 218, 53, 'PPL', 'P'),
(22238, 'Jarratt Crossing', 34.0438919067383, 0.594178003965633, -84.7319412231445, -1.47885135595018, 218, 13, 'PPL', 'P'),
(41517, 'Jarreau', 30.6205596923828, 0.534429585435542, -91.4508285522461, -1.59611806191353, 218, 22, 'PPL', 'P'),
(22232, 'Jarrell', 32.663330078125, 0.570082654528978, -84.2813873291016, -1.47098770704145, 218, 13, 'PPL', 'P'),
(88151, 'Jarrell', 36.0652809143066, 0.629457897611322, -88.5730590820313, -1.54589150954491, 218, 50, 'PPL', 'P'),
(95159, 'Jarrell', 30.8247203826904, 0.537992861684555, -97.6041717529297, -1.70351416077067, 218, 51, 'PPL', 'P'),
(14026, 'Jarrell Farms', 39.7555618286133, 0.693865449889479, -75.708610534668, -1.32136452594002, 218, 10, 'PPL', 'P'),
(16603, 'Jarrett', 30.6236095428467, 0.53448281536783, -83.9341735839844, -1.46492768398098, 218, 12, 'PPL', 'P'),
(22235, 'Jarrett', 34.6091690063477, 0.604043950539941, -83.2427825927734, -1.45286063476572, 218, 13, 'PPL', 'P'),
(109826, 'Jarrett', 38.4416694641113, 0.670933702112107, -81.4847183227539, -1.42217662479221, 218, 58, 'PPL', 'P'),
(136127, 'Jarrett', 44.2361106872559, 0.772065779769266, -92.3388900756836, -1.61161765945779, 218, 28, 'PPL', 'P'),
(65939, 'Jarrett Cove', 35.8983306884766, 0.626544066483639, -82.6436080932617, -1.44240306695525, 218, 33, 'PPL', 'P'),
(155890, 'Jarrett Wood Subdivision', 41.1777801513672, 0.718687842303726, -84.7602767944336, -1.47934590496461, 218, 41, 'PPL', 'P'),
(163104, 'Jarrettown', 40.1549987792969, 0.700836939833034, -75.1755599975586, -1.31206103898794, 218, 45, 'PPL', 'P'),
(30189, 'Jarretts', 38.1208305358887, 0.665334006446052, -87.3586120605469, -1.52469541042897, 218, 19, 'PPL', 'P'),
(112646, 'Jarretts Ford', 38.4313888549805, 0.670754271633663, -81.4861068725586, -1.42220085955813, 218, 58, 'PPL', 'P'),
(48503, 'Jarrettsville', 39.6044387817383, 0.691227855145865, -76.4780578613281, -1.33479391521091, 218, 25, 'PPL', 'P'),
(48504, 'Jarrettswood', 39.5900001525879, 0.690975853527716, -76.4636077880859, -1.33454171385568, 218, 25, 'PPL', 'P'),
(109827, 'Jarrolds Valley', 37.9749984741211, 0.662788756813236, -81.529167175293, -1.42295240361775, 218, 58, 'PPL', 'P'),
(9717, 'Jarta (historical)', 35.2075004577637, 0.614486804385387, -91.8191680908203, -1.60254679962693, 218, 4, 'PPL', 'P'),
(55545, 'Jarvis', 38.2680587768555, 0.667903624002842, -90.4941711425781, -1.57942124030123, 218, 29, 'PPL', 'P'),
(73039, 'Jarvis', 39.3694381713867, 0.687126320751034, -82.8902816772461, -1.44670833317347, 218, 41, 'PPL', 'P'),
(95160, 'Jarvis', 31.7549991607666, 0.554229289323413, -95.4447174072266, -1.66582457239165, 218, 51, 'PPL', 'P'),
(182362, 'Jarvis Landing', 37.5294418334961, 0.655012326430204, -122.0625, -2.13039251821558, 218, 6, 'PPL', 'P'),
(65940, 'Jarvisburg', 36.2027816772461, 0.631857738648619, -75.866943359375, -1.32412795504514, 218, 33, 'PPL', 'P'),
(109828, 'Jarvisville', 39.2333297729492, 0.684750781058683, -80.4875030517578, -1.40477193496216, 218, 58, 'PPL', 'P'),
(182363, 'Jasmin', 35.7427787780762, 0.623829173489385, -119.143890380859, -2.0794531707812, 218, 6, 'PPL', 'P'),
(9718, 'Jasmine', 35.0641708374023, 0.611985230594448, -91.583610534668, -1.59843554469412, 218, 4, 'PPL', 'P'),
(16604, 'Jasmine Estates', 28.2927799224854, 0.493802164189515, -82.6902770996094, -1.44321759477465, 218, 12, 'PPL', 'P'),
(36606, 'Jason', 37.0486106872559, 0.646620239782174, -87.0905609130859, -1.52001703534203, 218, 21, 'PPL', 'P'),
(65941, 'Jason', 35.3811111450195, 0.617516882494652, -77.7744369506836, -1.35741999867417, 218, 33, 'PPL', 'P'),
(81777, 'Jason', 34.6644401550293, 0.605008614065795, -83.0788879394531, -1.45000013343886, 218, 48, 'PPL', 'P'),
(88152, 'Jason Chapel', 36.0644416809082, 0.629443250225326, -87.5277786254883, -1.52764792397149, 218, 50, 'PPL', 'P'),
(48506, 'Jasontown', 39.5680618286133, 0.69059295754199, -77.0702819824219, -1.34513017603372, 218, 25, 'PPL', 'P'),
(30187, 'Jasonville', 39.1630592346191, 0.683524328797674, -87.1991729736328, -1.52191267340595, 218, 19, 'PPL', 'P'),
(738, 'Jasper', 32.3427810668945, 0.564488018868994, -80.9494400024414, -1.41283425568821, 218, 48, 'PPL', 'P'),
(3405, 'Jasper', 33.8311080932617, 0.590464225825518, -87.2774963378906, -1.52327967399348, 218, 2, 'PPL', 'P'),
(9719, 'Jasper', 36.0080604553223, 0.628459212202542, -93.186393737793, -1.62640938878431, 218, 4, 'PPL', 'P'),
(16605, 'Jasper', 30.5180606842041, 0.532640640262795, -82.9483337402344, -1.44772153281019, 218, 12, 'PPL', 'P'),
(22236, 'Jasper', 34.4677810668945, 0.601576265473873, -84.4291687011719, -1.47356697855719, 218, 13, 'PPL', 'P'),
(30188, 'Jasper', 38.3913917541504, 0.670056190532926, -86.9311065673828, -1.5172340320029, 218, 19, 'PPL', 'P'),
(55546, 'Jasper', 37.336109161377, 0.651638034750047, -94.3011093139648, -1.64586484581178, 218, 29, 'PPL', 'P'),
(73040, 'Jasper', 39.0499992370605, 0.68155105958798, -83.0566711425781, -1.44961237718415, 218, 41, 'PPL', 'P'),
(76210, 'Jasper', 34.0275001525879, 0.593891913885532, -95.7472229003906, -1.67110428925273, 218, 42, 'PPL', 'P'),
(88153, 'Jasper', 35.0741691589355, 0.612159734224876, -85.626106262207, -1.49445747993805, 218, 50, 'PPL', 'P'),
(95162, 'Jasper', 30.9200000762939, 0.539655806048227, -93.9963912963867, -1.64054651311489, 218, 51, 'PPL', 'P'),
(103159, 'Jasper', 36.7680587768555, 0.641723685222927, -82.8230590820313, -1.44553507755524, 218, 53, 'PPL', 'P'),
(112457, 'Jasper', 35.2013893127441, 0.614380144783729, -77.2069396972656, -1.347515303106, 218, 33, 'PPL', 'P'),
(131492, 'Jasper', 41.7933311462402, 0.729431233878188, -84.0405578613281, -1.46678443989298, 218, 27, 'PPL', 'P'),
(136128, 'Jasper', 43.8499984741211, 0.765326850367903, -96.3983306884766, -1.68246826394021, 218, 28, 'PPL', 'P'),
(149887, 'Jasper', 42.122501373291, 0.735176338139761, -77.5033264160156, -1.35268822720737, 218, 40, 'PPL', 'P'),
(186895, 'Jasper', 37.417781829834, 0.653063491723512, -106.461936950684, -1.85811132784004, 218, 7, 'PPL', 'P'),
(201036, 'Jasper', 43.9966697692871, 0.767886747386714, -122.904998779297, -2.14509689585834, 218, 43, 'PPL', 'P'),
(95164, 'Jasper Heights', 32.5455589294434, 0.568027160220627, -94.3238906860352, -1.64626245576253, 218, 51, 'PPL', 'P'),
(73041, 'Jasper Mills', 39.5186080932617, 0.689729827032695, -83.5205612182617, -1.45770878637215, 218, 41, 'PPL', 'P'),
(136129, 'Jasper Sunrise Village', 43.8494415283203, 0.765317129829924, -96.3908309936523, -1.68233736957263, 218, 28, 'PPL', 'P'),
(182364, 'Jastro', 35.3766708374023, 0.61743938450693, -119.071388244629, -2.07818776978925, 218, 6, 'PPL', 'P'),
(55553, 'Jaudon', 38.7594413757324, 0.676479868240251, -94.5891723632813, -1.65089249447568, 218, 29, 'PPL', 'P'),
(3406, 'Java', 31.5577793121338, 0.550787153614486, -85.8438873291016, -1.49825847660386, 218, 2, 'PPL', 'P'),
(81772, 'Java', 34.1202812194824, 0.595511248986354, -79.7583312988281, -1.392045487061, 218, 48, 'PPL', 'P'),
(95163, 'Java', 31.7841701507568, 0.554738419144809, -95.3199996948242, -1.66364783767467, 218, 51, 'PPL', 'P'),
(103160, 'Java', 36.8358306884766, 0.642906528221086, -79.2280578613281, -1.38279046964075, 218, 53, 'PPL', 'P'),
(170619, 'Java', 45.5033302307129, 0.794182933148211, -99.8861083984375, -1.74334146855669, 218, 49, 'PPL', 'P'),
(182365, 'Java', 34.8875007629395, 0.608901756105327, -114.726387023926, -2.0023531924848, 218, 6, 'PPL', 'P'),
(149883, 'Java Center', 42.6500015258789, 0.744382952607192, -78.3861083984375, -1.36809567937791, 218, 40, 'PPL', 'P'),
(149884, 'Java Village', 42.6725006103516, 0.744775635709925, -78.436393737793, -1.36897332411515, 218, 40, 'PPL', 'P'),
(95165, 'Javier Ramirez Colonia', 26.4039993286133, 0.460836723978674, -98.995002746582, -1.72778874094869, 218, 51, 'PPL', 'P'),
(9722, 'Jay', 36.2088890075684, 0.63196433167125, -90.355827331543, -1.57700668529891, 218, 4, 'PPL', 'P'),
(16606, 'Jay', 30.9527797698975, 0.540227919629404, -87.1513900756836, -1.52107870451059, 218, 12, 'PPL', 'P'),
(41518, 'Jay', 29.5949993133545, 0.516530180143497, -90.4683303833008, -1.57897023397062, 218, 22, 'PPL', 'P'),
(76211, 'Jay', 36.4211082458496, 0.635668256115332, -94.7966690063477, -1.65451399408403, 218, 42, 'PPL', 'P'),
(116224, 'Jay', 41.1066703796387, 0.717446742656722, -93.5863876342773, -1.63339059926585, 218, 16, 'PPL', 'P'),
(127824, 'Jay', 44.5038909912109, 0.776739427745274, -70.216667175293, -1.22551203198589, 218, 26, 'PPL', 'P'),
(149886, 'Jay', 44.375, 0.774489855572484, -73.7286071777344, -1.28680694816099, 218, 40, 'PPL', 'P'),
(172157, 'Jay', 44.9474983215332, 0.784481836245379, -72.4375, -1.26427287691339, 218, 55, 'PPL', 'P'),
(22242, 'Jay (historical)', 34.5602798461914, 0.603190673726679, -84.0730590820313, -1.46735169320517, 218, 13, 'PPL', 'P'),
(22239, 'Jay Bird Springs', 32.1311111450195, 0.560793681804836, -83.0055618286133, -1.44872035137703, 218, 13, 'PPL', 'P'),
(122909, 'Jay City', 40.5672187805176, 0.708031536096911, -84.8486099243164, -1.48088760891966, 218, 19, 'PPL', 'P'),
(65943, 'Jay Crest', 36.1511116027832, 0.630955925724491, -75.7463912963867, -1.32202392462592, 218, 33, 'PPL', 'P'),
(209530, 'Jay Em', 42.4613914489746, 0.741091085762773, -104.369171142578, -1.82158567401544, 218, 59, 'PPL', 'P'),
(16607, 'Jay Jay', 28.6455593109131, 0.499959326050751, -80.8199996948242, -1.4105750961355, 218, 12, 'PPL', 'P'),
(136131, 'Jay See Landing', 47.5458297729492, 0.829831275130712, -91.477783203125, -1.5965885093201, 218, 28, 'PPL', 'P'),
(3407, 'Jay Villa', 31.3652801513672, 0.547427409451783, -86.945556640625, -1.51748623335813, 218, 2, 'PPL', 'P'),
(73043, 'Jaybird', 38.9394416809082, 0.679621466220163, -83.2983322143555, -1.45383015856056, 218, 41, 'PPL', 'P'),
(88155, 'Jaybird', 35.9658317565918, 0.627722182370863, -83.2011108398438, -1.45213332547202, 218, 50, 'PPL', 'P'),
(9723, 'Jaybird (historical)', 36.3847198486328, 0.635033158774375, -94.5644378662109, -1.65046079606298, 218, 4, 'PPL', 'P'),
(48505, 'Jaycox', 39.3072204589844, 0.686040416816554, -77.0833282470703, -1.34535787630693, 218, 25, 'PPL', 'P'),
(76212, 'Jaydee', 34.7527809143066, 0.606550451178896, -96.4388885498047, -1.68317613215795, 218, 42, 'PPL', 'P'),
(95166, 'Jayell', 32.3861083984375, 0.565244223460522, -99.3233337402344, -1.73351919782426, 218, 51, 'PPL', 'P'),
(109829, 'Jayenn', 39.4724998474121, 0.688925086330301, -80.182502746582, -1.39944867541725, 218, 58, 'PPL', 'P'),
(60416, 'Jayess', 31.3647193908691, 0.547417622334777, -90.2058334350586, -1.57438879794736, 218, 30, 'PPL', 'P'),
(182366, 'Jayhawk', 38.7313919067383, 0.675990312652868, -120.965278625488, -2.11124239260709, 218, 6, 'PPL', 'P'),
(103162, 'Jayne Mill', 36.6386108398438, 0.639464392512158, -82.5644378662109, -1.44102128582366, 218, 53, 'PPL', 'P'),
(178422, 'Jaynes', 32.2958297729492, 0.563668564201577, -111.028327941895, -1.93780988557008, 218, 5, 'PPL', 'P'),
(60427, 'Jaynesville', 31.7749996185303, 0.554578363163295, -89.7666702270508, -1.566723954014, 218, 30, 'PPL', 'P'),
(195147, 'Jaype', 46.5302810668945, 0.812106606495689, -115.828887939453, -2.02159546346701, 218, 17, 'PPL', 'P'),
(209531, 'Jays Roost', 41.1674995422363, 0.718508411825282, -106.330558776855, -1.85581834614148, 218, 59, 'PPL', 'P'),
(155891, 'Jaysville', 40.0480613708496, 0.69897052996208, -84.5991668701172, -1.47653400632765, 218, 41, 'PPL', 'P'),
(191668, 'Jayton', 33.2480583190918, 0.580288087563243, -100.573333740234, -1.75533581347419, 218, 51, 'PPL', 'P'),
(149889, 'Jayville', 44.1566696166992, 0.770679271526744, -75.188606262207, -1.31228873926114, 218, 40, 'PPL', 'P'),
(55555, 'Jaywye', 36.4824981689453, 0.636739712400898, -89.7011108398438, -1.56557972685165, 218, 29, 'PPL', 'P'),
(95167, 'Jean', 33.2961082458496, 0.581126716990509, -98.6161117553711, -1.72117584564591, 218, 51, 'PPL', 'P'),
(190345, 'Jean', 35.7788887023926, 0.624459410561352, -115.323059082031, -2.01276708445339, 218, 39, 'PPL', 'P'),
(201037, 'Jean', 45.3983306884766, 0.7923503454231, -122.738609313965, -2.14219285184766, 218, 43, 'PPL', 'P'),
(103161, 'Jean Court', 37.3930587768555, 0.652631993047892, -77.418327331543, -1.35120471332214, 218, 53, 'PPL', 'P'),
(41519, 'Jean Lafitte', 29.7358303070068, 0.518988144671586, -90.1266708374023, -1.57300714997383, 218, 22, 'PPL', 'P'),
(41520, 'Jeanerette', 29.9108295440674, 0.52204245754677, -91.663330078125, -1.59982691320563, 218, 22, 'PPL', 'P'),
(95168, 'Jeanetta', 29.7205600738525, 0.518721628825496, -95.5258331298828, -1.66724030882714, 218, 51, 'PPL', 'P'),
(9724, 'Jeanette', 35.1780586242676, 0.613972947453056, -90.4291687011719, -1.57828673367685, 218, 4, 'PPL', 'P'),
(60417, 'Jeannette', 31.4863891601563, 0.549541160408979, -91.2447204589844, -1.59252079707111, 218, 30, 'PPL', 'P'),
(88156, 'Jeannette', 35.7408294677734, 0.623795151606459, -88.0994415283203, -1.53762532383741, 218, 50, 'PPL', 'P'),
(163106, 'Jeannette', 40.3280601501465, 0.703857430562375, -79.6155624389648, -1.38955370038706, 218, 45, 'PPL', 'P'),
(163108, 'Jeansville', 40.9275016784668, 0.714319658904751, -75.970832824707, -1.32594116827332, 218, 45, 'PPL', 'P'),
(88157, 'Jearoldstown', 36.3630599975586, 0.634655123057639, -82.7024993896484, -1.44343091397797, 218, 50, 'PPL', 'P'),
(109830, 'Jed', 37.4041709899902, 0.652825937754277, -81.5747222900391, -1.42374749036119, 218, 58, 'PPL', 'P'),
(81773, 'Jedburg', 33.0555610656738, 0.576928376690054, -80.2386093139648, -1.40042791975008, 218, 48, 'PPL', 'P'),
(55556, 'Jedburgh', 38.5380592346191, 0.67261602097271, -90.5819396972656, -1.58095309056024, 218, 29, 'PPL', 'P'),
(178421, 'Jeddito', 35.7744407653809, 0.624381779415576, -110.136108398438, -1.92223771688611, 218, 5, 'PPL', 'P'),
(3413, 'Jeddo', 31.3322200775146, 0.546850402312104, -87.5141677856445, -1.52741037000225, 218, 2, 'PPL', 'P'),
(95169, 'Jeddo', 29.8086109161377, 0.520258405932526, -97.3144378662109, -1.69845735049283, 218, 51, 'PPL', 'P'),
(131494, 'Jeddo', 43.151668548584, 0.753138693902073, -82.5833282470703, -1.44135098516661, 218, 27, 'PPL', 'P'),
(139240, 'Jeddo', 40.1002807617188, 0.699881930266132, -91.9683303833008, -1.60515017275054, 218, 29, 'PPL', 'P'),
(149890, 'Jeddo', 43.2552795410156, 0.754947046861264, -78.4574966430664, -1.36934163929391, 218, 40, 'PPL', 'P'),
(163109, 'Jeddo', 40.9955596923828, 0.715507495329954, -75.8966674804688, -1.32464673882549, 218, 45, 'PPL', 'P'),
(155895, 'Jeddoe', 41.2769393920898, 0.720418497538114, -81.1449966430664, -1.41624736294125, 218, 41, 'PPL', 'P'),
(163111, 'Jednota', 40.2044410705566, 0.701699870605247, -76.7588882446289, -1.33969533003915, 218, 45, 'PPL', 'P'),
(3408, 'Jeff', 34.8227806091309, 0.60777217632897, -86.7136077880859, -1.5134379621851, 218, 2, 'PPL', 'P'),
(22240, 'Jeff', 31.5561103820801, 0.550758025290063, -84.8099975585938, -1.48021369600581, 218, 13, 'PPL', 'P'),
(36607, 'Jeff', 37.2050018310547, 0.649349780162423, -83.1363906860352, -1.45100374569566, 218, 21, 'PPL', 'P'),
(55557, 'Jeff', 36.5074996948242, 0.637176071345508, -91.3880615234375, -1.59502257059913, 218, 29, 'PPL', 'P'),
(60418, 'Jeff', 32.4211082458496, 0.565855086035559, -89.1277770996094, -1.55557316537179, 218, 30, 'PPL', 'P'),
(122911, 'Jeff', 40.605281829834, 0.708695861630831, -85.3530578613281, -1.48969188632541, 218, 19, 'PPL', 'P'),
(60419, 'Jeff Davis', 32.1927795410156, 0.561869998359392, -90.8791732788086, -1.58614079520566, 218, 30, 'PPL', 'P'),
(60420, 'Jeff Davis (historical)', 33.2269401550293, 0.579919506068376, -88.7477798461914, -1.54894096215111, 218, 30, 'PPL', 'P'),
(109831, 'Jeff Scotts (historical)', 38.9186096191406, 0.67925787815234, -79.9513931274414, -1.39541505163022, 218, 58, 'PPL', 'P'),
(78520, 'Jefferis', 39.9069404602051, 0.69650750542792, -79.807502746582, -1.39290369072227, 218, 45, 'PPL', 'P'),
(88158, 'Jeffers', 36.3716697692871, 0.634805391922146, -84.3916702270508, -1.47291250671931, 218, 50, 'PPL', 'P'),
(136133, 'Jeffers', 44.0558280944824, 0.768919254941338, -95.1963882446289, -1.6614904108756, 218, 28, 'PPL', 'P'),
(196780, 'Jeffers', 45.3488883972168, 0.791487414650887, -111.704719543457, -1.94961514605018, 218, 31, 'PPL', 'P'),
(201038, 'Jeffers Garden', 46.1500015258789, 0.805469476426994, -123.856941223145, -2.16171142579296, 218, 43, 'PPL', 'P'),
(48507, 'Jeffers Hill', 39.2013893127441, 0.684193314863502, -76.8277816772461, -1.34089774727132, 218, 25, 'PPL', 'P'),
(70983, 'Jeffers Landing', 39.3180618286133, 0.686229634412004, -74.6522216796875, -1.30292706223924, 218, 37, 'PPL', 'P'),
(188737, 'Jeffers Place', 34.1955604553223, 0.596825119510145, -107.773887634277, -1.88100918689254, 218, 38, 'PPL', 'P'),
(3409, 'Jefferson', 32.3866691589355, 0.565254010577528, -87.898063659668, -1.53411061698878, 218, 2, 'PPL', 'P'),
(9726, 'Jefferson', 34.3805618286133, 0.600054002594784, -92.1638870239258, -1.60856328000358, 218, 4, 'PPL', 'P'),
(22245, 'Jefferson', 33.4491691589355, 0.583798133879968, -83.3116683959961, -1.45406291883983, 218, 13, 'PPL', 'P'),
(32867, 'Jefferson', 37.1122207641602, 0.647730445061601, -95.7611083984375, -1.67134663691193, 218, 20, 'PPL', 'P'),
(41523, 'Jefferson', 29.9658298492432, 0.523002393961689, -90.1530609130859, -1.57346774368436, 218, 22, 'PPL', 'P'),
(48508, 'Jefferson', 39.3619384765625, 0.686995426383456, -77.5319366455078, -1.35318756991176, 218, 25, 'PPL', 'P'),
(60422, 'Jefferson', 31.6630592346191, 0.5526246348981, -90.9833297729492, -1.58795866896575, 218, 30, 'PPL', 'P'),
(65944, 'Jefferson', 36.420280456543, 0.635653808466418, -81.4736099243164, -1.42198274666485, 218, 33, 'PPL', 'P'),
(70984, 'Jefferson', 39.7536087036133, 0.693831361427526, -75.2122192382813, -1.31270086343983, 218, 37, 'PPL', 'P'),
(76213, 'Jefferson', 36.7205581665039, 0.640894643175585, -97.790283203125, -1.70676241835224, 218, 42, 'PPL', 'P'),
(81775, 'Jefferson', 34.6500015258789, 0.604756612447646, -80.3891677856445, -1.40305566079766, 218, 48, 'PPL', 'P'),
(88159, 'Jefferson', 35.8944396972656, 0.626476155875842, -85.7111129760742, -1.49594112698133, 218, 50, 'PPL', 'P'),
(95170, 'Jefferson', 32.7572212219238, 0.571721364126731, -94.3450012207031, -1.64663090409934, 218, 51, 'PPL', 'P'),
(103165, 'Jefferson', 38.8644409179688, 0.678312455965362, -77.1880569458008, -1.3471857369211, 218, 53, 'PPL', 'P'),
(109832, 'Jefferson', 38.3752784729004, 0.669774960721813, -81.7805633544922, -1.42734009467171, 218, 58, 'PPL', 'P'),
(116225, 'Jefferson', 42.0152816772461, 0.73330500142079, -94.3772201538086, -1.64719323056351, 218, 16, 'PPL', 'P'),
(122912, 'Jefferson', 40.2794418334961, 0.703008880860048, -86.5899963378906, -1.51128053538602, 218, 19, 'PPL', 'P'),
(125155, 'Jefferson', 42.3638916015625, 0.739389392405239, -71.8813934326172, -1.2545669863206, 218, 23, 'PPL', 'P'),
(127826, 'Jefferson', 44.2066688537598, 0.771551922836936, -69.4530563354492, -1.2121845086267, 218, 26, 'PPL', 'P'),
(131495, 'Jefferson', 42.1088905334473, 0.734938784170526, -84.2900009155273, -1.47113804248499, 218, 27, 'PPL', 'P'),
(144003, 'Jefferson', 44.4188919067383, 0.775255913860045, -71.4749984741211, -1.24747405623134, 218, 36, 'PPL', 'P'),
(149891, 'Jefferson', 42.4811096191406, 0.741435232754638, -74.6108322143555, -1.30220467979355, 218, 40, 'PPL', 'P'),
(155893, 'Jefferson', 40.8016700744629, 0.712123483111817, -82.023063659668, -1.43157252343412, 218, 41, 'PPL', 'P'),
(163116, 'Jefferson', 40.285831451416, 0.703120400730695, -80.498893737793, -1.40497073993753, 218, 45, 'PPL', 'P'),
(170621, 'Jefferson', 42.6025009155273, 0.743553910559851, -96.5588912963867, -1.68527057519724, 218, 49, 'PPL', 'P'),
(174680, 'Jefferson', 43.0055618286133, 0.750588650579295, -88.8072204589844, -1.54997839655375, 218, 57, 'PPL', 'P'),
(182367, 'Jefferson', 34.0183296203613, 0.593731857904018, -118.271110534668, -2.06422028882011, 218, 6, 'PPL', 'P'),
(186896, 'Jefferson', 39.3772201538086, 0.687262141966628, -105.800003051758, -1.84655840187322, 218, 7, 'PPL', 'P'),
(201039, 'Jefferson', 44.7197189331055, 0.780506335949136, -123.009170532227, -2.14691503593454, 218, 43, 'PPL', 'P'),
(103164, 'Jefferson (historical)', 37.6294403076172, 0.656757629050588, -77.9483337402344, -1.36045507021048, 218, 53, 'PPL', 'P'),
(190346, 'Jefferson (historical)', 38.7133293151855, 0.675675060958829, -116.981666564941, -2.04171524602839, 218, 39, 'PPL', 'P'),
(196781, 'Jefferson (historical)', 45.9000015258789, 0.801106153297008, -111.54167175293, -1.94676942526738, 218, 31, 'PPL', 'P'),
(55559, 'Jefferson Barracks', 38.5027809143066, 0.672000298128684, -90.2802810668945, -1.57568815424321, 218, 29, 'PPL', 'P'),
(163118, 'Jefferson Center', 40.7755584716797, 0.711667749670278, -79.8349990844727, -1.39338359235071, 218, 45, 'PPL', 'P'),
(27551, 'Jefferson City', 38.3786087036133, 0.669833084212604, -89.043327331543, -1.55409923886648, 218, 18, 'PPL', 'P'),
(55560, 'Jefferson City', 38.5766716003418, 0.673289933886554, -92.1733322143555, -1.60872812967506, 218, 29, 'PPL', 'P'),
(88164, 'Jefferson City', 36.1222190856934, 0.630451656172085, -83.4925003051758, -1.45721903104769, 218, 50, 'PPL', 'P'),
(196782, 'Jefferson City', 46.3883285522461, 0.809629067733589, -112.026672363281, -1.95523428279219, 218, 31, 'PPL', 'P'),
(27552, 'Jefferson City (historical)', 38.1502799987793, 0.665847996536437, -88.461669921875, -1.54394740194915, 218, 18, 'PPL', 'P'),
(120148, 'Jefferson Corners', 41.605281829834, 0.726149154150774, -89.9805603027344, -1.57045704007202, 218, 18, 'PPL', 'P'),
(48509, 'Jefferson Court', 39.3597183227539, 0.686956677389596, -77.540283203125, -1.35333324482339, 218, 25, 'PPL', 'P'),
(103166, 'Jefferson Court', 38.0938911437988, 0.664863825355598, -78.9627838134766, -1.37816056408565, 218, 53, 'PPL', 'P'),
(14027, 'Jefferson Crossroads', 38.834171295166, 0.677784151384118, -75.3455581665039, -1.3150280667584, 218, 10, 'PPL', 'P'),
(155896, 'Jefferson Estates', 41.5849990844727, 0.725795153462875, -84.498893737793, -1.47478391001731, 218, 41, 'PPL', 'P'),
(14028, 'Jefferson Farms', 39.6788902282715, 0.692527278020742, -75.5713882446289, -1.31896954517171, 218, 10, 'PPL', 'P'),
(41522, 'Jefferson Heights', 29.9636096954346, 0.522963644967829, -90.1650009155273, -1.57367613603965, 218, 22, 'PPL', 'P'),
(48511, 'Jefferson Heights', 39.6438903808594, 0.691916415445705, -77.6772232055664, -1.35572329874368, 218, 25, 'PPL', 'P'),
(55562, 'Jefferson Heights', 38.3933296203613, 0.67009001267877, -90.4972229003906, -1.57947450352303, 218, 29, 'PPL', 'P'),
(149893, 'Jefferson Heights', 42.2338905334473, 0.737120445735519, -73.8827819824219, -1.28949780612641, 218, 40, 'PPL', 'P'),
(144004, 'Jefferson Highland', 44.3849983215332, 0.774664359202911, -71.4225006103516, -1.24655779565829, 218, 36, 'PPL', 'P'),
(3411, 'Jefferson Hills', 33.5722198486328, 0.585945773562035, -86.7733306884766, -1.51448032343575, 218, 2, 'PPL', 'P'),
(103167, 'Jefferson Hills', 37.2405586242676, 0.649970363275439, -79.9749984741211, -1.39582704265085, 218, 53, 'PPL', 'P'),
(41529, 'Jefferson Island', 29.9724998474121, 0.523118807390839, -91.9755630493164, -1.60527640658621, 218, 22, 'PPL', 'P'),
(196784, 'Jefferson Island', 45.850830078125, 0.80024794963573, -111.939720153809, -1.95371668044501, 218, 31, 'PPL', 'P'),
(163120, 'Jefferson Junction', 41.9577789306641, 0.732301389163993, -75.5577774047852, -1.31873199120248, 218, 45, 'PPL', 'P'),
(174682, 'Jefferson Junction', 43.0369415283203, 0.75113632965747, -88.7900009155273, -1.54967785882473, 218, 57, 'PPL', 'P'),
(103171, 'Jefferson Manor', 38.7897186279297, 0.67700830597955, -77.0800018310547, -1.34529981939516, 218, 53, 'PPL', 'P'),
(48512, 'Jefferson Oaks', 39.3716697692871, 0.687165269481976, -77.5444412231445, -1.35340581596309, 218, 25, 'PPL', 'P'),
(3412, 'Jefferson Park', 33.5416717529297, 0.585412608711801, -86.6444396972656, -1.51223075126296, 218, 2, 'PPL', 'P'),
(65947, 'Jefferson Park', 34.917781829834, 0.609430260423653, -79.7852783203125, -1.3925158013095, 218, 33, 'PPL', 'P'),
(81776, 'Jefferson Park', 33.9661102294922, 0.592820457599965, -80.3708267211914, -1.40273554883463, 218, 48, 'PPL', 'P'),
(103174, 'Jefferson Park', 37.2388916015625, 0.64994126824053, -79.9780578613281, -1.39588043903071, 218, 53, 'PPL', 'P'),
(149894, 'Jefferson Park', 43.7783317565918, 0.76407603018292, -76.2191696166992, -1.33027546294743, 218, 40, 'PPL', 'P'),
(182368, 'Jefferson Park', 34.0272216796875, 0.593887053616542, -118.316673278809, -2.0650155087216, 218, 6, 'PPL', 'P'),
(88161, 'Jefferson Pike', 36.0027809143066, 0.628367066828825, -86.5374984741211, -1.51036427481298, 218, 50, 'PPL', 'P'),
(204473, 'Jefferson Place Condominium', 40.5844383239746, 0.708332073825926, -111.908332824707, -1.95316886820878, 218, 52, 'PPL', 'P'),
(125156, 'Jefferson Shores', 41.7516708374023, 0.728704124321569, -70.6294403076172, -1.23271628220872, 218, 23, 'PPL', 'P'),
(88162, 'Jefferson Springs', 36.0013885498047, 0.628342765483878, -86.4583282470703, -1.50898249368139, 218, 50, 'PPL', 'P'),
(22248, 'Jefferson Valley', 33.9936103820801, 0.593300425807425, -83.4283294677734, -1.45609903865125, 218, 13, 'PPL', 'P'),
(149895, 'Jefferson Valley', 41.3380584716797, 0.721485226712746, -73.7911071777344, -1.28789777894349, 218, 40, 'PPL', 'P'),
(48513, 'Jefferson View', 39.3450012207031, 0.686699815502458, -77.5683288574219, -1.35382273383174, 218, 25, 'PPL', 'P'),
(65948, 'Jefferson Village', 35.8358306884766, 0.625453235701142, -80.2405624389648, -1.40046200821203, 218, 33, 'PPL', 'P'),
(103176, 'Jefferson Village', 38.8705596923828, 0.678419248725074, -77.1797180175781, -1.34704019516753, 218, 53, 'PPL', 'P'),
(109836, 'Jefferson Village', 39.3261108398438, 0.686370116159506, -77.8869400024414, -1.35938354734588, 218, 58, 'PPL', 'P'),
(149896, 'Jefferson Village', 41.3263893127441, 0.721281561468382, -73.7991714477539, -1.2880385270071, 218, 40, 'PPL', 'P'),
(103177, 'Jeffersonton', 38.6369400024414, 0.674341815938108, -77.915283203125, -1.35987822951837, 218, 53, 'PPL', 'P'),
(36609, 'Jeffersontown', 38.1941719055176, 0.666614054823998, -85.5644378662109, -1.49338116338349, 218, 21, 'PPL', 'P'),
(9742, 'Jeffersonville', 34.7213897705078, 0.60600257236364, -90.6772232055664, -1.58261610150294, 218, 4, 'PPL', 'P'),
(22249, 'Jeffersonville', 32.6875, 0.570504499245647, -83.3466720581055, -1.4546738479939, 218, 13, 'PPL', 'P'),
(30201, 'Jeffersonville', 38.2775001525879, 0.668068407095291, -85.7372207641602, -1.49639679384384, 218, 19, 'PPL', 'P'),
(36610, 'Jeffersonville', 37.9736099243164, 0.662764522047316, -83.8419418334961, -1.46331793626008, 218, 21, 'PPL', 'P'),
(73059, 'Jeffersonville', 39.6536102294922, 0.692086058807143, -83.5638885498047, -1.45846499096368, 218, 41, 'PPL', 'P'),
(149898, 'Jeffersonville', 41.7808303833008, 0.729213054405883, -74.9341735839844, -1.30784805130149, 218, 40, 'PPL', 'P'),
(163129, 'Jeffersonville', 40.1288909912109, 0.700381272970522, -75.3724975585938, -1.31549824784885, 218, 45, 'PPL', 'P'),
(172159, 'Jeffersonville', 44.6438903808594, 0.779182878045421, -72.829719543457, -1.27111839933739, 218, 55, 'PPL', 'P'),
(116251, 'Jeffersonville (historical)', 40.6097183227539, 0.708773293039525, -91.4458312988281, -1.59603084338783, 218, 16, 'PPL', 'P'),
(155910, 'Jeffersonville (historical)', 40.3477783203125, 0.70420157755424, -80.6166687011719, -1.40702630082491, 218, 41, 'PPL', 'P'),
(88163, 'Jeffery Acres', 35.1961097717285, 0.614287999410012, -85.2030563354492, -1.4870738658158, 218, 50, 'PPL', 'P'),
(103178, 'Jeffress', 36.6536102294922, 0.639726181247313, -78.5372161865234, -1.37073300780542, 218, 53, 'PPL', 'P'),
(9743, 'Jeffrey', 34.8219413757324, 0.607757528942975, -92.3213882446289, -1.61131219488076, 218, 4, 'PPL', 'P'),
(36611, 'Jeffrey', 36.7511100769043, 0.641427874604846, -85.8405609130859, -1.4982004196921, 218, 21, 'PPL', 'P'),
(109837, 'Jeffrey', 37.9713897705078, 0.662725773053455, -81.8216705322266, -1.42805755026937, 218, 58, 'PPL', 'P'),
(88165, 'Jeffrey (historical)', 35.4022216796875, 0.617885330831464, -84.0766677856445, -1.46741467696495, 218, 50, 'PPL', 'P'),
(202256, 'Jeffrey (historical)', 45.7236099243164, 0.798027539076877, -100.579170227051, -1.75543767938589, 218, 49, 'PPL', 'P'),
(209532, 'Jeffrey City', 42.4947204589844, 0.741672786723873, -107.826667785645, -1.8819303743136, 218, 59, 'PPL', 'P'),
(55577, 'Jeffreys', 38.9280586242676, 0.679422794402843, -94.5311126708984, -1.64987916168091, 218, 29, 'PPL', 'P'),
(9744, 'Jeffries', 34.730281829834, 0.606157768076164, -91.2813873291016, -1.59316075468106, 218, 4, 'PPL', 'P'),
(60425, 'Jeffries', 34.5047187805176, 0.602220950194754, -90.5386123657227, -1.58019688596871, 218, 30, 'PPL', 'P'),
(163130, 'Jeffries', 40.8977813720703, 0.713800941703431, -78.3833312988281, -1.36804720984607, 218, 45, 'PPL', 'P'),
(125157, 'Jeffries Point', 42.3652801513672, 0.739413627171159, -71.033332824707, -1.2397655364561, 218, 23, 'PPL', 'P'),
(55578, 'Jeffriesburg', 38.4402809143066, 0.670909467346187, -91.0880584716797, -1.58978652957992, 218, 29, 'PPL', 'P'),
(174688, 'Jeffris', 45.5019416809082, 0.794158698382291, -89.4302825927734, -1.56085288223287, 218, 57, 'PPL', 'P'),
(27556, 'Jeisyville', 39.577220916748, 0.690752813786422, -89.4049987792969, -1.56041159644024, 218, 18, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(142138, 'Jelen', 42.628059387207, 0.743999990042439, -98.1455612182617, -1.71296318947632, 218, 35, 'PPL', 'P'),
(136136, 'Jelle', 48.2380599975586, 0.841912971731965, -95.4000015258789, -1.6650441330342, 218, 28, 'PPL', 'P'),
(88166, 'Jellico', 36.5877799987793, 0.638577226974026, -84.1269378662109, -1.46829205538607, 218, 50, 'PPL', 'P'),
(193680, 'Jellico', 40.8450012207031, 0.712879754282373, -121.29167175293, -2.11693902733683, 218, 6, 'PPL', 'P'),
(196785, 'Jellison Place', 46.6733283996582, 0.814603253438612, -110.071388244629, -1.92110813710976, 218, 31, 'PPL', 'P'),
(155911, 'Jelloway', 40.5366706848145, 0.707498371246677, -82.3002777099609, -1.43641082134452, 218, 41, 'PPL', 'P'),
(209533, 'Jelm', 41.0577812194824, 0.716593465843461, -106.01277923584, -1.85027204685528, 218, 59, 'PPL', 'P'),
(188738, 'Jemez Pueblo', 35.6138916015625, 0.621579667895622, -106.725280761719, -1.86270754440735, 218, 38, 'PPL', 'P'),
(188740, 'Jemez Springs', 35.7686080932617, 0.624279980082908, -106.691673278809, -1.86212098317726, 218, 38, 'PPL', 'P'),
(3414, 'Jemison', 32.9597206115723, 0.575255645209375, -86.7466735839844, -1.51401506919332, 218, 2, 'PPL', 'P'),
(127828, 'Jemtland', 47.0072212219238, 0.820430782535923, -68.1444396972656, -1.18934483964401, 218, 26, 'PPL', 'P'),
(3415, 'Jena', 33.1305618286133, 0.578237386944855, -87.8469390869141, -1.53321832486555, 218, 2, 'PPL', 'P'),
(16610, 'Jena', 29.663330078125, 0.517722776969148, -83.3702774047852, -1.45508583901453, 218, 12, 'PPL', 'P'),
(41533, 'Jena', 31.6830596923828, 0.552973708737982, -92.1336135864258, -1.60803490884331, 218, 22, 'PPL', 'P'),
(88167, 'Jena', 35.6547203063965, 0.6222922632243, -84.1558303833008, -1.46879632493848, 218, 50, 'PPL', 'P'),
(41530, 'Jena (historical)', 30.4125003814697, 0.530798265420678, -90.4333267211914, -1.57835930481656, 218, 22, 'PPL', 'P'),
(16611, 'Jenada Isles', 26.1630592346191, 0.456631526038412, -80.1575012207031, -1.39901231647264, 218, 12, 'PPL', 'P'),
(155912, 'Jenera', 40.8997192382813, 0.713834763849275, -83.726936340332, -1.46131071174649, 218, 41, 'PPL', 'P'),
(3416, 'Jenifer', 33.5491714477539, 0.585543503079378, -85.936393737793, -1.49987301801472, 218, 2, 'PPL', 'P'),
(131498, 'Jenison', 42.9072189331055, 0.748872243256739, -85.7919387817383, -1.49735180341075, 218, 27, 'PPL', 'P'),
(109838, 'Jenkinjones', 37.2936096191406, 0.650896277807432, -81.4261093139648, -1.42115370461751, 218, 58, 'PPL', 'P'),
(3417, 'Jenkins', 33.7994384765625, 0.589911486741272, -85.6699981689453, -1.49522353822561, 218, 2, 'PPL', 'P'),
(32876, 'Jenkins', 38.5499992370605, 0.672824413328009, -97.7216720581055, -1.70556492796808, 218, 20, 'PPL', 'P'),
(36612, 'Jenkins', 37.1733283996582, 0.64879697449915, -82.6311111450195, -1.44218495406197, 218, 21, 'PPL', 'P'),
(41531, 'Jenkins', 30.811939239502, 0.537769788653747, -90.1369400024414, -1.57318638071519, 218, 22, 'PPL', 'P'),
(48514, 'Jenkins', 39.4819412231445, 0.689089869422749, -76.4811096191406, -1.33484717843271, 218, 25, 'PPL', 'P'),
(55579, 'Jenkins', 36.7786102294922, 0.641907842812306, -93.6858291625977, -1.63512618134825, 218, 29, 'PPL', 'P'),
(60426, 'Jenkins', 31.5938892364502, 0.551417390686453, -89.1552810668945, -1.55605320015827, 218, 30, 'PPL', 'P'),
(70985, 'Jenkins', 39.6980590820313, 0.692861837632683, -74.5269393920898, -1.30074047382623, 218, 37, 'PPL', 'P'),
(95173, 'Jenkins', 32.9761085510254, 0.57554166871045, -94.7183303833008, -1.65314672718038, 218, 51, 'PPL', 'P'),
(120153, 'Jenkins', 40.1527786254883, 0.700798190839174, -89.0336074829102, -1.55392959550504, 218, 18, 'PPL', 'P'),
(136137, 'Jenkins', 46.646110534668, 0.814128212079169, -94.3344421386719, -1.64644661335191, 218, 28, 'PPL', 'P'),
(200025, 'Jenkins', 40.6841697692871, 0.710072715914402, -116.858612060547, -2.0395675397673, 218, 39, 'PPL', 'P'),
(48515, 'Jenkins Corner', 38.7863883972168, 0.676950182488759, -76.8974990844727, -1.34211454557337, 218, 25, 'PPL', 'P'),
(78526, 'Jenkins Corner', 39.7313919067383, 0.693443605172811, -76.1533279418945, -1.32912630893706, 218, 45, 'PPL', 'P'),
(3418, 'Jenkins Crossroads', 32.0261116027832, 0.558961094079725, -85.7744369506836, -1.49704633883371, 218, 2, 'PPL', 'P'),
(65951, 'Jenkins Heights', 35.2747192382813, 0.615659993424594, -81.2102813720703, -1.41738679641365, 218, 33, 'PPL', 'P'),
(48516, 'Jenkins Landing', 38.4011116027832, 0.670225833894364, -75.7719421386719, -1.32246987095046, 218, 25, 'PPL', 'P'),
(103179, 'Jenkins Landing', 37.980281829834, 0.66288096876598, -76.9263916015625, -1.34261881512578, 218, 53, 'PPL', 'P'),
(65952, 'Jenkins Meadow', 35.3819389343262, 0.617531330143565, -83.9530563354492, -1.46525725016587, 218, 33, 'PPL', 'P'),
(88168, 'Jenkins Mill', 35.7869415283203, 0.624599958887881, -83.2422180175781, -1.45285078106969, 218, 50, 'PPL', 'P'),
(65953, 'Jenkins Place', 35.4850006103516, 0.619330095722832, -83.4241714477539, -1.45602646751155, 218, 33, 'PPL', 'P'),
(88169, 'Jenkins Village', 36.5188903808594, 0.637374876320882, -85.8072204589844, -1.49761851899392, 218, 50, 'PPL', 'P'),
(195149, 'Jenkins Will', 44.0766716003418, 0.769283042746243, -111.959716796875, -1.95406568770587, 218, 17, 'PPL', 'P'),
(22250, 'Jenkinsburg', 33.3244400024414, 0.58162119942591, -84.0358276367188, -1.46670188189919, 218, 13, 'PPL', 'P'),
(149899, 'Jenkinstown', 41.6969413757324, 0.727748915017585, -74.101936340332, -1.29332277124203, 218, 40, 'PPL', 'P'),
(30203, 'Jenkinsville', 39.5327796936035, 0.689977168118936, -86.8752822875977, -1.51625971451809, 218, 19, 'PPL', 'P'),
(36613, 'Jenkinsville', 37.7319412231445, 0.658546607512849, -85.0397186279297, -1.48422308502693, 218, 21, 'PPL', 'P'),
(81778, 'Jenkinsville', 34.267219543457, 0.598075806537073, -81.2886123657227, -1.41875393015924, 218, 48, 'PPL', 'P'),
(88170, 'Jenkinsville', 36.0519409179688, 0.629225070753022, -89.4158325195313, -1.56060068087764, 218, 50, 'PPL', 'P'),
(174689, 'Jenkinsville', 42.6347198486328, 0.744116237024021, -90.3697204589844, -1.57724916611616, 218, 57, 'PPL', 'P'),
(163132, 'Jenkintown', 40.0958290100098, 0.699804232541329, -75.1255569458008, -1.31118832109872, 218, 45, 'PPL', 'P'),
(76222, 'Jenks', 36.0227813720703, 0.628716140668708, -95.9680633544922, -1.6749586822984, 218, 42, 'PPL', 'P'),
(109839, 'Jenks', 38.1986083984375, 0.666691486232692, -82.1030578613281, -1.43296868563559, 218, 58, 'PPL', 'P'),
(163134, 'Jenks', 41.4766693115234, 0.723904442246974, -75.9763870239258, -1.326038107337, 218, 45, 'PPL', 'P'),
(22251, 'Jenks (historical)', 31.3263893127441, 0.546748636268949, -81.6875, -1.42571583272287, 218, 13, 'PPL', 'P'),
(127829, 'Jenks Landing', 43.7172203063965, 0.763009434166343, -70.1158294677734, -1.22375208197951, 218, 26, 'PPL', 'P'),
(182369, 'Jenks Place', 39.708610534668, 0.693045995222062, -122.847221374512, -2.14408848991158, 218, 6, 'PPL', 'P'),
(149900, 'Jenksville', 42.269718170166, 0.73774575595947, -76.2436065673828, -1.330701968196, 218, 40, 'PPL', 'P'),
(109840, 'Jenky', 38.1494407653809, 0.665833349150442, -80.995002746582, -1.41362947558971, 218, 58, 'PPL', 'P'),
(95175, 'Jenna Estates Colonia', 26.2639999389648, 0.458393273678526, -98.3280029296875, -1.71614739803368, 218, 51, 'PPL', 'P'),
(182370, 'Jenner', 38.4497184753418, 0.671074183859608, -123.114440917969, -2.14875235077058, 218, 6, 'PPL', 'P'),
(163137, 'Jenners', 40.1430587768555, 0.700628547477736, -79.0430603027344, -1.37956165313514, 218, 45, 'PPL', 'P'),
(163138, 'Jenners Crossroads', 40.1513900756836, 0.700773956073254, -79.0497207641602, -1.37967790011672, 218, 45, 'PPL', 'P'),
(163139, 'Jennerstown', 40.1597213745117, 0.700919364668772, -79.0666732788086, -1.37997377731383, 218, 45, 'PPL', 'P'),
(78527, 'Jennersville', 39.8230590820313, 0.695043499197676, -75.870002746582, -1.324181351425, 218, 45, 'PPL', 'P'),
(195150, 'Jenness', 43.832218170166, 0.765016525521881, -116.624168395996, -2.03547572591045, 218, 17, 'PPL', 'P'),
(9746, 'Jennette', 35.166389465332, 0.613769282208692, -90.4044418334961, -1.57785516842221, 218, 4, 'PPL', 'P'),
(172160, 'Jenneville', 43.5344390869141, 0.759819300075564, -72.4897232055664, -1.26518434379647, 218, 55, 'PPL', 'P'),
(9747, 'Jennie', 33.2561111450195, 0.580428635889772, -91.2861099243164, -1.59324317951679, 218, 4, 'PPL', 'P'),
(22252, 'Jennie', 32.0505599975586, 0.559387799065383, -81.8891677856445, -1.42923559957757, 218, 13, 'PPL', 'P'),
(136139, 'Jennie', 45.0077781677246, 0.785533918034015, -94.3477783203125, -1.64667937363118, 218, 28, 'PPL', 'P'),
(48517, 'Jennie Run Estates', 38.5658302307129, 0.673100716291104, -76.9880599975586, -1.34369513168033, 218, 25, 'PPL', 'P'),
(16612, 'Jennings', 30.603889465332, 0.534138635086451, -83.0980606079102, -1.45033475962983, 218, 12, 'PPL', 'P'),
(41534, 'Jennings', 30.2222194671631, 0.527477236962322, -92.6569366455078, -1.6171686192759, 218, 22, 'PPL', 'P'),
(48520, 'Jennings', 39.0902786254883, 0.682254067536734, -76.563606262207, -1.33628701647606, 218, 25, 'PPL', 'P'),
(55581, 'Jennings', 38.7191696166992, 0.675776993449552, -90.2602767944336, -1.5753390138243, 218, 29, 'PPL', 'P'),
(60428, 'Jennings', 31.1938896179199, 0.544436080336379, -90.3777770996094, -1.57738978102171, 218, 30, 'PPL', 'P'),
(65954, 'Jennings', 36.0119400024414, 0.628526923073257, -80.8805618286133, -1.41163210477215, 218, 33, 'PPL', 'P'),
(76224, 'Jennings', 36.1811103820801, 0.631479503194801, -96.5694427490234, -1.68545473278662, 218, 42, 'PPL', 'P'),
(81779, 'Jennings', 34.2402801513672, 0.59760562544662, -81.1555633544922, -1.41643178684674, 218, 48, 'PPL', 'P'),
(95174, 'Jennings', 33.579719543457, 0.586076667929612, -95.4661102294922, -1.66619794757648, 218, 51, 'PPL', 'P'),
(131499, 'Jennings', 44.3327789306641, 0.773752958898859, -85.2980575561523, -1.48873194991049, 218, 27, 'PPL', 'P'),
(174690, 'Jennings', 45.5074996948242, 0.794255704024997, -89.0719375610352, -1.55459858157087, 218, 57, 'PPL', 'P'),
(187733, 'Jennings', 39.6794395446777, 0.692536865400666, -100.293060302734, -1.75044411918394, 218, 20, 'PPL', 'P'),
(196786, 'Jennings', 48.3655586242676, 0.844138242559808, -115.343612670898, -2.01312581225223, 218, 31, 'PPL', 'P'),
(88171, 'Jennings (historical)', 36.2036094665527, 0.631872186297533, -86.0950012207031, -1.50264124080981, 218, 50, 'PPL', 'P'),
(199433, 'Jennings (historical)', 42.2166709899902, 0.736819908006504, -102.259719848633, -1.78476880352564, 218, 35, 'PPL', 'P'),
(48519, 'Jennings Chapel Woods', 39.2686080932617, 0.685366503902709, -77.0722198486328, -1.34516399817957, 218, 25, 'PPL', 'P'),
(201041, 'Jennings Lodge', 45.3913917541504, 0.792229238172529, -122.611389160156, -2.13997244128881, 218, 43, 'PPL', 'P'),
(22253, 'Jennings Mill', 33.9186096191406, 0.591991415552624, -83.4749984741211, -1.45691356647066, 218, 13, 'PPL', 'P'),
(103180, 'Jennings Ordinary', 37.2252807617188, 0.649703714271295, -78.1458282470703, -1.36390199960937, 218, 53, 'PPL', 'P'),
(103181, 'Jennings Store', 36.6233291625977, 0.639197676928987, -82.9308319091797, -1.44741606823316, 218, 53, 'PPL', 'P'),
(22254, 'Jennings Yard', 33.3827781677246, 0.582639392489674, -84.5380630493164, -1.47546754346913, 218, 13, 'PPL', 'P'),
(109841, 'Jenningston', 38.9880599975586, 0.68047001592249, -79.5308303833008, -1.38807484703374, 218, 58, 'PPL', 'P'),
(163141, 'Jenningsville', 41.5830612182617, 0.725761331317031, -76.144172668457, -1.32896651927165, 218, 45, 'PPL', 'P'),
(109842, 'Jenny Gap (historical)', 37.7261085510254, 0.65844480818018, -81.3211135864258, -1.41932118347142, 218, 58, 'PPL', 'P'),
(9748, 'Jenny Lind', 35.2502784729004, 0.615233421596991, -94.3183288574219, -1.64616538354079, 218, 4, 'PPL', 'P'),
(65956, 'Jenny Lind', 35.2569389343262, 0.615349668578573, -77.7783279418945, -1.35748790928196, 218, 33, 'PPL', 'P'),
(182371, 'Jenny Lind', 38.0950012207031, 0.664883199852529, -120.86888885498, -2.10956007374649, 218, 6, 'PPL', 'P'),
(81780, 'Jennys', 33.0261116027832, 0.576414386599669, -81.1138916015625, -1.41570447755304, 218, 48, 'PPL', 'P'),
(196787, 'Jens', 46.6041717529297, 0.81339624225356, -113.005279541016, -1.97231420012731, 218, 31, 'PPL', 'P'),
(195151, 'Jensen', 43.7427787780762, 0.763455513648931, -111.746391296387, -1.95034245534388, 218, 17, 'PPL', 'P'),
(204476, 'Jensen', 40.3697204589844, 0.704584540118994, -109.334167480469, -1.90824120746109, 218, 52, 'PPL', 'P'),
(16613, 'Jensen Beach', 27.2541694641113, 0.475674992045241, -80.2300033569336, -1.40027771746459, 218, 12, 'PPL', 'P'),
(16614, 'Jensen Place', 30.2299995422363, 0.527613024888403, -84.9269409179688, -1.48225474266525, 218, 12, 'PPL', 'P'),
(81781, 'Jensens', 33.5883293151855, 0.58622693679412, -79.0252838134766, -1.37925139486815, 218, 48, 'PPL', 'P'),
(9749, 'Jenson', 35.1972198486328, 0.614307373906943, -94.4388885498047, -1.64826954711806, 218, 4, 'PPL', 'P'),
(36614, 'Jenson', 36.7769393920898, 0.64187868119837, -83.629997253418, -1.45961880550596, 218, 21, 'PPL', 'P'),
(95176, 'Jentsch Acres', 29.6930599212646, 0.518241660618036, -98.1575012207031, -1.71317158183162, 218, 51, 'PPL', 'P'),
(22256, 'Jeptha', 34.1383285522461, 0.595826234364283, -83.1011123657227, -1.45038802285163, 218, 13, 'PPL', 'P'),
(36615, 'Jeptha', 37.9422187805176, 0.662216643232059, -83.0999984741211, -1.45036858177568, 218, 21, 'PPL', 'P'),
(149901, 'Jerden Falls', 44.0127792358398, 0.768167910618799, -75.3225021362305, -1.31462566311768, 218, 40, 'PPL', 'P'),
(109843, 'Jere', 39.6669387817383, 0.692318685928361, -80.0355606079102, -1.39688405128751, 218, 58, 'PPL', 'P'),
(36620, 'Jeremiah', 37.1672210693359, 0.64869038147652, -82.9291687011719, -1.44738703977728, 218, 21, 'PPL', 'P'),
(88172, 'Jeremiah', 36.225830078125, 0.632260009131276, -85.404167175293, -1.49058391213253, 218, 50, 'PPL', 'P'),
(204481, 'Jeremy', 40.6383285522461, 0.709272635743915, -111.835830688477, -1.95190346721683, 218, 52, 'PPL', 'P'),
(204480, 'Jeremy Ranch', 40.7541694641113, 0.711294441064476, -111.558609008789, -1.94706503614838, 218, 52, 'PPL', 'P'),
(3421, 'Jericho', 34.9775009155273, 0.610472555095283, -86.0791702270508, -1.50236493784671, 218, 2, 'PPL', 'P'),
(9750, 'Jericho', 35.285831451416, 0.615853938130979, -90.226936340332, -1.57475711312612, 218, 4, 'PPL', 'P'),
(30210, 'Jericho', 38.1991691589355, 0.666701273349698, -86.4244384765625, -1.50839100560329, 218, 19, 'PPL', 'P'),
(36619, 'Jericho', 37.0863914489746, 0.647279638468078, -85.0491714477539, -1.48438806785646, 218, 21, 'PPL', 'P'),
(41535, 'Jericho', 31.267219543457, 0.545715928977243, -92.8663864135742, -1.6208242073462, 218, 22, 'PPL', 'P'),
(60429, 'Jericho', 34.5111083984375, 0.602332470065401, -88.7544403076172, -1.54905720913269, 218, 30, 'PPL', 'P'),
(65957, 'Jericho', 36.2869415283203, 0.633326605147853, -79.3666687011719, -1.38520968517498, 218, 33, 'PPL', 'P'),
(70987, 'Jericho', 39.8055610656738, 0.694738101199671, -75.1402816772461, -1.31144531614391, 218, 37, 'PPL', 'P'),
(73062, 'Jericho', 39.6175003051758, 0.691455821735176, -81.1063919067383, -1.41557358318546, 218, 41, 'PPL', 'P'),
(81782, 'Jericho', 32.7588882446289, 0.57175045916164, -80.3166732788086, -1.40179039296376, 218, 48, 'PPL', 'P'),
(113590, 'Jericho', 41.336669921875, 0.721460991946826, -72.2988891601563, -1.26185366137916, 218, 8, 'PPL', 'P'),
(144007, 'Jericho', 44.1438903808594, 0.77045623178545, -71.8494415283203, -1.25400932038834, 218, 36, 'PPL', 'P'),
(149904, 'Jericho', 40.9541702270508, 0.71478511288427, -72.2041702270508, -1.2602005041325, 218, 40, 'PPL', 'P'),
(163143, 'Jericho', 41.3191719055176, 0.721155593948821, -75.3908309936523, -1.31581822665382, 218, 45, 'PPL', 'P'),
(172162, 'Jericho', 44.5038909912109, 0.776739427745274, -72.9980621337891, -1.27405653181002, 218, 55, 'PPL', 'P'),
(174692, 'Jericho', 42.8783302307129, 0.74836804028336, -88.4227828979492, -1.54326869534535, 218, 57, 'PPL', 'P'),
(191670, 'Jericho', 35.1730613708496, 0.613885728927356, -100.907783508301, -1.76117306310948, 218, 51, 'PPL', 'P'),
(192640, 'Jericho', 39.7502784729004, 0.693773237936735, -112.204719543457, -1.95834179231015, 218, 52, 'PPL', 'P'),
(207741, 'Jericho', 46.8347206115723, 0.817420078923588, -119.790283203125, -2.09073485379099, 218, 56, 'PPL', 'P'),
(109844, 'Jericho (historical)', 39.211669921875, 0.684372745341946, -78.4250030517578, -1.36877451913977, 218, 58, 'PPL', 'P'),
(172166, 'Jericho Center', 44.4688911437988, 0.776128565170237, -72.9727783203125, -1.27361524601739, 218, 55, 'PPL', 'P'),
(163149, 'Jericho Mills', 40.6130599975586, 0.708831616267398, -77.3375015258789, -1.34979403689273, 218, 45, 'PPL', 'P'),
(48521, 'Jericho Park', 39.0177803039551, 0.68098873312381, -76.7652816772461, -1.33980691648882, 218, 25, 'PPL', 'P'),
(36621, 'Jerico', 36.9966697692871, 0.645713699747111, -86.9775009155273, -1.51804376613233, 218, 21, 'PPL', 'P'),
(55582, 'Jerico', 37.1747207641602, 0.648821275844097, -92.6727828979492, -1.61744518855511, 218, 29, 'PPL', 'P'),
(116253, 'Jerico', 43.1847190856934, 0.753715534594184, -92.2583312988281, -1.61021164356029, 218, 16, 'PPL', 'P'),
(131500, 'Jerico', 41.9719390869141, 0.732548530513153, -86.533332824707, -1.51029157051522, 218, 27, 'PPL', 'P'),
(55583, 'Jerico Springs', 37.6222190856934, 0.656631594952, -94.0083312988281, -1.64075490547019, 218, 29, 'PPL', 'P'),
(149905, 'Jericon Corners', 43.089168548584, 0.752047863119577, -77.976936340332, -1.36095427975681, 218, 40, 'PPL', 'P'),
(36622, 'Jeriel', 38.2180595397949, 0.66703097269265, -82.876106262207, -1.4464609255082, 218, 21, 'PPL', 'P'),
(207742, 'Jerita', 46.7430610656738, 0.815820318056778, -117.885833740234, -2.05749594022571, 218, 56, 'PPL', 'P'),
(55584, 'Jerktail', 37.4241714477539, 0.653175011594159, -92.4366683959961, -1.61332421308432, 218, 29, 'PPL', 'P'),
(163144, 'Jerkwater', 40.1222190856934, 0.700264826251858, -78.2427825927734, -1.365594172166, 218, 45, 'PPL', 'P'),
(73063, 'Jerles (historical)', 39.7386093139648, 0.693569572692372, -81.295280456543, -1.41887031029887, 218, 41, 'PPL', 'P'),
(103183, 'Jermantown', 38.8569412231445, 0.678181561597785, -77.3324966430664, -1.34970668520897, 218, 53, 'PPL', 'P'),
(95178, 'Jermyn', 33.2641716003418, 0.580569317374356, -98.3880615234375, -1.71719561823873, 218, 51, 'PPL', 'P'),
(163145, 'Jermyn', 41.5308303833008, 0.724849731275897, -75.5458297729492, -1.31852346568912, 218, 45, 'PPL', 'P'),
(125158, 'Jerneganville', 41.401668548584, 0.722595431992172, -70.5558319091797, -1.23143157329886, 218, 23, 'PPL', 'P'),
(3420, 'Jernigan', 32.1261100769043, 0.560706396700109, -85.0722198486328, -1.48479033833911, 218, 2, 'PPL', 'P'),
(88173, 'Jernigan (historical)', 35.7261085510254, 0.623538223140294, -86.1838912963867, -1.50419266530283, 218, 50, 'PPL', 'P'),
(81783, 'Jernigan Crossroads', 34.2050018310547, 0.596989902602594, -79.9475021362305, -1.39534714102242, 218, 48, 'PPL', 'P'),
(88174, 'Jernigan Subdivision', 35.773609161377, 0.624367265187635, -86.3936080932617, -1.50785291390504, 218, 50, 'PPL', 'P'),
(88175, 'Jernigan Town', 36.5222206115723, 0.637432999811673, -86.6847229003906, -1.51293382579075, 218, 50, 'PPL', 'P'),
(81784, 'Jernigans Crossroads', 34.1133308410645, 0.595389941998701, -78.9022216796875, -1.377103555449, 218, 48, 'PPL', 'P'),
(9752, 'Jerome', 33.3994407653809, 0.582930209680711, -91.4700012207031, -1.5964526881045, 218, 4, 'PPL', 'P'),
(16615, 'Jerome', 25.996940612793, 0.45373220913867, -81.3469390869141, -1.41977192348592, 218, 12, 'PPL', 'P'),
(27558, 'Jerome', 39.7675018310547, 0.694073842244778, -89.6805572509766, -1.56522099905282, 218, 18, 'PPL', 'P'),
(55585, 'Jerome', 37.9261093139648, 0.661935479999974, -91.9775009155273, -1.60531022873205, 218, 29, 'PPL', 'P'),
(65958, 'Jerome', 34.8424987792969, 0.608116323320836, -78.7341690063477, -1.37417048298244, 218, 33, 'PPL', 'P'),
(103182, 'Jerome', 38.8624992370605, 0.678278567240491, -78.728889465332, -1.37407833760872, 218, 53, 'PPL', 'P'),
(109845, 'Jerome', 39.5844383239746, 0.690878781305983, -78.4569396972656, -1.36933191875593, 218, 58, 'PPL', 'P'),
(116254, 'Jerome', 40.7188911437988, 0.710678718220449, -93.0280609130859, -1.62364595967919, 218, 16, 'PPL', 'P'),
(122930, 'Jerome', 40.4552803039551, 0.706077841121229, -85.9308319091797, -1.49977594579299, 218, 19, 'PPL', 'P'),
(131501, 'Jerome', 42.0269393920898, 0.733508466928072, -84.4694366455078, -1.47426978676887, 218, 27, 'PPL', 'P'),
(155915, 'Jerome', 40.166389465332, 0.701035744808409, -83.1758270263672, -1.45169203967939, 218, 41, 'PPL', 'P'),
(163147, 'Jerome', 40.2088890075684, 0.701777501751023, -78.98388671875, -1.37852887926441, 218, 45, 'PPL', 'P'),
(178423, 'Jerome', 34.7488899230957, 0.606482540571099, -112.113059997559, -1.95674203144334, 218, 5, 'PPL', 'P'),
(193681, 'Jerome', 41.7316703796387, 0.728355050481687, -121.999168395996, -2.12928717320514, 218, 6, 'PPL', 'P'),
(195152, 'Jerome', 42.7241706848145, 0.745677448634053, -114.517776489258, -1.9987122518005, 218, 17, 'PPL', 'P'),
(209534, 'Jerome', 44.0483283996582, 0.76878836057376, -104.529441833496, -1.82438292526641, 218, 59, 'PPL', 'P'),
(163148, 'Jerome Junction', 40.2008285522461, 0.70163682026644, -78.9316711425781, -1.37761754553938, 218, 45, 'PPL', 'P'),
(155916, 'Jeromesville', 40.8041687011719, 0.712167092374667, -82.1958312988281, -1.43458788757836, 218, 41, 'PPL', 'P'),
(88176, 'Jerrerson Farms', 35.9388885498047, 0.627251934701382, -86.3372192382813, -1.5068687427242, 218, 50, 'PPL', 'P'),
(9751, 'Jerrett', 36.4027786254883, 0.635348343889386, -90.9574966430664, -1.5875077957932, 218, 4, 'PPL', 'P'),
(758, 'Jerry', 35.8819389343262, 0.626257976403537, -76.2272186279297, -1.33041594469493, 218, 33, 'PPL', 'P'),
(207743, 'Jerry', 46.3244400024414, 0.808514002185173, -117.107498168945, -2.04391142182133, 218, 56, 'PPL', 'P'),
(155917, 'Jerry City', 41.2538909912109, 0.720016227055458, -83.6044387817383, -1.45917272602337, 218, 41, 'PPL', 'P'),
(196788, 'Jerry Mallo Trailer Court', 46.5488891601563, 0.812431378990625, -110.908332824707, -1.93571557568884, 218, 31, 'PPL', 'P'),
(109847, 'Jerrys Run', 39.0669403076172, 0.681846737048006, -81.6580581665039, -1.42520197579054, 218, 58, 'PPL', 'P'),
(109848, 'Jerryville', 38.4255599975586, 0.670652538880022, -80.311393737793, -1.40169824759004, 218, 58, 'PPL', 'P'),
(149906, 'Jersalem', 44.8074989318848, 0.782038385945232, -73.7458267211914, -1.28710748589, 218, 40, 'PPL', 'P'),
(149907, 'Jersalem Hill', 42.9775009155273, 0.75009889525483, -75.1463928222656, -1.31155197574557, 218, 40, 'PPL', 'P'),
(9753, 'Jersey', 33.4283294677734, 0.58343441265409, -92.3141708374023, -1.6111862273612, 218, 4, 'PPL', 'P'),
(22261, 'Jersey', 33.7155609130859, 0.588447547090055, -83.7988891601563, -1.46256652535851, 218, 13, 'PPL', 'P'),
(48529, 'Jersey', 37.9741706848145, 0.662774309164322, -75.8611068725586, -1.32402608913345, 218, 25, 'PPL', 'P'),
(65962, 'Jersey', 35.7308311462402, 0.623620647976032, -80.315559387207, -1.4017709518878, 218, 33, 'PPL', 'P'),
(88178, 'Jersey', 35.0697212219238, 0.6120821030791, -85.1927795410156, -1.48689450191639, 218, 50, 'PPL', 'P'),
(103184, 'Jersey', 38.2113914489746, 0.666914592553014, -77.1397171020508, -1.34634204748776, 218, 53, 'PPL', 'P'),
(155919, 'Jersey', 40.0536117553711, 0.699067402446731, -82.7233276367188, -1.44379443546676, 218, 41, 'PPL', 'P'),
(200026, 'Jersey (historical)', 40.1672210693359, 0.70105025903635, -117.472221374512, -2.05027704261689, 218, 39, 'PPL', 'P'),
(145508, 'Jersey City', 40.7280616760254, 0.710838774201963, -74.0780563354492, -1.29290598653143, 218, 37, 'PPL', 'P'),
(174693, 'Jersey City', 45.485279083252, 0.793867881191255, -89.7444381713867, -1.56633593144318, 218, 57, 'PPL', 'P'),
(48523, 'Jersey Heights', 38.396110534668, 0.670138548789636, -75.5999984741211, -1.3194688878761, 218, 25, 'PPL', 'P'),
(163150, 'Jersey Mills', 41.3572196960449, 0.721819653166632, -77.4069366455078, -1.35100590834677, 218, 45, 'PPL', 'P'),
(9754, 'Jersey Point', 33.6741714477539, 0.587725164644371, -91.1086120605469, -1.59014525737876, 218, 4, 'PPL', 'P'),
(48524, 'Jersey Road Estates', 38.4305610656738, 0.670739823984749, -75.6072235107422, -1.31959498855372, 218, 25, 'PPL', 'P'),
(163151, 'Jersey Shore', 41.2019386291504, 0.719109487283313, -77.2647171020508, -1.34852370905276, 218, 45, 'PPL', 'P'),
(95179, 'Jersey Village', 29.8875007629395, 0.521635293505611, -95.5627822875977, -1.6678851932851, 218, 51, 'PPL', 'P'),
(182374, 'Jerseydale', 37.5636100769043, 0.6556086747773, -119.856391906738, -2.09188866833327, 218, 6, 'PPL', 'P'),
(163153, 'Jerseytown', 41.0886116027832, 0.717131557541711, -76.57861328125, -1.33654893836927, 218, 45, 'PPL', 'P'),
(27561, 'Jerseyville', 39.1199989318848, 0.682772784738054, -90.3283309936523, -1.57652678367047, 218, 18, 'PPL', 'P'),
(145509, 'Jerseyville', 40.2391700744629, 0.702306006069349, -74.2297210693359, -1.29555303549692, 218, 37, 'PPL', 'P'),
(3423, 'Jerusalem', 34.7050018310547, 0.605716548862565, -87.226936340332, -1.52239723556629, 218, 2, 'PPL', 'P'),
(9755, 'Jerusalem', 35.4047203063965, 0.617928940094314, -92.8166732788086, -1.61995654946305, 218, 4, 'PPL', 'P'),
(22259, 'Jerusalem', 34.4416694641113, 0.601120532032334, -84.5822219848633, -1.4762382622886, 218, 13, 'PPL', 'P'),
(48527, 'Jerusalem', 39.1591682434082, 0.683456418189877, -77.4063873291016, -1.35099632096684, 218, 25, 'PPL', 'P'),
(65960, 'Jerusalem', 35.814998626709, 0.625089647633319, -80.5158309936523, -1.40526635081853, 218, 33, 'PPL', 'P'),
(73065, 'Jerusalem', 39.8516693115234, 0.695542841902066, -81.0924987792969, -1.41533110236821, 218, 41, 'PPL', 'P'),
(88177, 'Jerusalem', 35.2433280944824, 0.615112114609337, -86.7844390869141, -1.51467420156311, 218, 50, 'PPL', 'P'),
(131503, 'Jerusalem', 42.2747192382813, 0.737833041064197, -83.9819412231445, -1.46576138656023, 218, 27, 'PPL', 'P'),
(169440, 'Jerusalem', 41.3766708374023, 0.72215913962659, -71.5180587768555, -1.24822560029096, 218, 47, 'PPL', 'P'),
(172165, 'Jerusalem', 43.8383293151855, 0.765123185123539, -72.774169921875, -1.27014887554254, 218, 55, 'PPL', 'P'),
(192641, 'Jerusalem', 39.5638885498047, 0.690520120086176, -111.656936645508, -1.94878117715482, 218, 52, 'PPL', 'P'),
(22260, 'Jerusalem (historical)', 31.0544395446777, 0.542002217416155, -83.4991683959961, -1.45733541118732, 218, 13, 'PPL', 'P'),
(149908, 'Jerusalem Corners', 42.6830596923828, 0.744959926457358, -79.0152816772461, -1.37907682465869, 218, 40, 'PPL', 'P'),
(48528, 'Jerusalem Mills', 39.4583282470703, 0.68867774524406, -76.4019393920898, -1.33346539730112, 218, 25, 'PPL', 'P'),
(182372, 'Jesbel (historical)', 37.1497192382813, 0.648384916899488, -119.952217102051, -2.09356113349784, 218, 6, 'PPL', 'P'),
(182373, 'Jesmond Dene', 33.1802787780762, 0.57910511140703, -117.108329772949, -2.04392593604927, 218, 6, 'PPL', 'P'),
(27562, 'Jess', 39.764720916748, 0.694025306133911, -89.6675033569336, -1.56499316562156, 218, 18, 'PPL', 'P'),
(65963, 'Jessama', 35.5119400024414, 0.619800276813286, -76.9063873291016, -1.34226967470687, 218, 33, 'PPL', 'P'),
(16616, 'Jessamine', 28.413330078125, 0.495906161319219, -82.2702789306641, -1.43588724387421, 218, 12, 'PPL', 'P'),
(36623, 'Jessamine', 37.8758316040039, 0.661057968420793, -84.6213912963867, -1.47692189574042, 218, 21, 'PPL', 'P'),
(95180, 'Jessan Colonia', 26.2530002593994, 0.458201293053445, -98.3280029296875, -1.71614739803368, 218, 51, 'PPL', 'P'),
(76225, 'Jesse', 34.5819396972656, 0.603568709443416, -96.5294418334961, -1.68475658510686, 218, 42, 'PPL', 'P'),
(109849, 'Jesse', 37.6680603027344, 0.657431675122487, -81.5733337402344, -1.42372325559527, 218, 58, 'PPL', 'P'),
(103186, 'Jessees Mill', 36.9141693115234, 0.644273795124732, -82.1675033569336, -1.43409347172198, 218, 53, 'PPL', 'P'),
(136141, 'Jessenland', 44.5719413757324, 0.777927131012422, -93.9230575561523, -1.639266597895, 218, 28, 'PPL', 'P'),
(3425, 'Jesseton', 34.4047203063965, 0.600475647574371, -87.1666717529297, -1.52134542009376, 218, 2, 'PPL', 'P'),
(194259, 'Jessica', 40.7605590820313, 0.711405960935123, -103.17138671875, -1.80068039209054, 218, 7, 'PPL', 'P'),
(88180, 'Jessie', 35.7536087036133, 0.624018191347753, -85.7422180175781, -1.49648401236954, 218, 50, 'PPL', 'P'),
(140289, 'Jessie', 47.5422210693359, 0.829768291370931, -98.2377777099609, -1.71457267088111, 218, 34, 'PPL', 'P'),
(48533, 'Jessie Anne Estates', 39.5777816772461, 0.690762600903428, -77.1194381713867, -1.34598811337889, 218, 25, 'PPL', 'P'),
(136143, 'Jessie Lake', 47.6011085510254, 0.83079607181462, -93.8169403076172, -1.6374145025149, 218, 28, 'PPL', 'P'),
(16617, 'Jessie Willies', 26.0188903808594, 0.454115304861478, -80.7125015258789, -1.40869889914753, 218, 12, 'PPL', 'P'),
(36625, 'Jessietown', 37.4808311462402, 0.654163909885932, -85.3249969482422, -1.48920213100094, 218, 21, 'PPL', 'P'),
(9757, 'Jessieville', 34.7011108398438, 0.605648638254768, -93.061393737793, -1.62422772721932, 218, 4, 'PPL', 'P'),
(131504, 'Jessieville', 46.454719543457, 0.810787809123882, -90.1311111450195, -1.57308464796155, 218, 27, 'PPL', 'P'),
(109850, 'Jessop', 39.4183311462402, 0.687979664143322, -79.7577819824219, -1.39203589968107, 218, 58, 'PPL', 'P'),
(194258, 'Jessum', 40.1388893127441, 0.700555776600949, -105.024436950684, -1.83302221984262, 218, 7, 'PPL', 'P'),
(626, 'Jessup', 39.149169921875, 0.68328191455945, -76.7755584716797, -1.33998628038824, 218, 25, 'PPL', 'P'),
(755, 'Jessup', 39.0250015258789, 0.681114767222398, -83.5330581665039, -1.45792689926543, 218, 41, 'PPL', 'P'),
(30211, 'Jessup', 39.6572189331055, 0.692149042566923, -87.2566680908203, -1.52291615250469, 218, 19, 'PPL', 'P'),
(163154, 'Jessup', 41.4686088562012, 0.72376376076239, -75.5625, -1.31881441603822, 218, 45, 'PPL', 'P'),
(193067, 'Jessup', 39.9486083984375, 0.697234748142593, -118.873893737793, -2.07474084039036, 218, 39, 'PPL', 'P'),
(196789, 'Jessup', 48.211109161377, 0.84144259090443, -114.127220153809, -1.99189575783239, 218, 31, 'PPL', 'P'),
(103187, 'Jessup Farm Acres', 37.4527816772461, 0.653674354298549, -77.5077819824219, -1.3527659915112, 218, 53, 'PPL', 'P'),
(65964, 'Jessup Mill', 36.5255584716797, 0.637491256460519, -80.3708267211914, -1.40273554883463, 218, 33, 'PPL', 'P'),
(95181, 'Jessups Colonia', 26.3719997406006, 0.460278225808571, -97.9670028686523, -1.70984675836871, 218, 51, 'PPL', 'P'),
(70988, 'Jessups Mill', 39.6616706848145, 0.692226740291726, -75.230827331543, -1.31302563593476, 218, 37, 'PPL', 'P'),
(3426, 'Jester', 32.7033309936523, 0.570780802208742, -85.1436080932617, -1.48603629825511, 218, 2, 'PPL', 'P'),
(76229, 'Jester', 35.0091705322266, 0.611025294179529, -99.6947174072266, -1.74000106560141, 218, 42, 'PPL', 'P'),
(88179, 'Jester (historical)', 35.3608283996582, 0.617162881806753, -90.0269393920898, -1.57126650788535, 218, 50, 'PPL', 'P'),
(103188, 'Jester Gardens', 36.8213882446289, 0.64265446002391, -76.4191665649414, -1.33376606818819, 218, 53, 'PPL', 'P'),
(48530, 'Jesterville', 38.2866706848145, 0.668228463076804, -75.896110534668, -1.32463701828751, 218, 25, 'PPL', 'P'),
(41536, 'Jesuit Bend', 29.7480602264404, 0.519201597032955, -90.0258331298828, -1.57124719996745, 218, 22, 'PPL', 'P'),
(9762, 'Jesup', 36.0169410705566, 0.628614208177985, -91.3361129760742, -1.59411589740601, 218, 4, 'PPL', 'P'),
(22262, 'Jesup', 31.6072196960449, 0.551650051097185, -81.8855590820313, -1.42917261581779, 218, 13, 'PPL', 'P'),
(116255, 'Jesup', 42.4755592346191, 0.741338360269987, -92.063606262207, -1.60681305053518, 218, 16, 'PPL', 'P'),
(182375, 'Jesus Maria', 38.2855606079102, 0.668209088579874, -120.646392822266, -2.10567678540299, 218, 6, 'PPL', 'P'),
(95182, 'Jesus Maria Colonia', 26.1140003204346, 0.455775286458438, -97.9530029296875, -1.7096024133387, 218, 51, 'PPL', 'P'),
(3427, 'Jet', 33.667781829834, 0.587613644773724, -86.9319381713867, -1.51724854623084, 218, 2, 'PPL', 'P'),
(76227, 'Jet', 36.6661109924316, 0.639944360719618, -98.1808319091797, -1.7135787791623, 218, 42, 'PPL', 'P'),
(182377, 'Jet', 37.4327812194824, 0.653325280458666, -121.098892211914, -2.11357438961562, 218, 6, 'PPL', 'P'),
(9759, 'Jeter (historical)', 33.5830612182617, 0.586134991157485, -91.7119369506836, -1.60067526317088, 218, 4, 'PPL', 'P'),
(65965, 'Jeter (historical)', 35.5069389343262, 0.619712991708558, -82.1588897705078, -1.43394313627845, 218, 33, 'PPL', 'P'),
(65966, 'Jeter Mountain Terrace', 35.247501373291, 0.615184952065151, -82.5475006103516, -1.44072567494266, 218, 33, 'PPL', 'P'),
(103189, 'Jetersville', 37.2941703796387, 0.650906064924438, -78.0944366455078, -1.36300504695423, 218, 53, 'PPL', 'P'),
(22266, 'Jeterville', 31.2427806854248, 0.545289390439154, -84.7061080932617, -1.47840048277763, 218, 13, 'PPL', 'P'),
(9760, 'Jethro', 35.6074981689453, 0.621468081445948, -93.8872222900391, -1.63864115451299, 218, 4, 'PPL', 'P'),
(155922, 'Jethro', 40.6252784729004, 0.709044868891686, -80.5952835083008, -1.40665305879814, 218, 41, 'PPL', 'P'),
(32879, 'Jetmore', 38.0844383239746, 0.664698842526068, -99.8930587768555, -1.74346277554435, 218, 20, 'PPL', 'P'),
(36626, 'Jetson', 37.2491683959961, 0.650120632139947, -86.5319366455078, -1.51026720259125, 218, 21, 'PPL', 'P'),
(109852, 'Jetsville', 38.1688919067383, 0.666172835610399, -80.6011123657227, -1.40675479155178, 218, 58, 'PPL', 'P'),
(36627, 'Jett', 38.1786117553711, 0.666342478971838, -84.8144378662109, -1.48029119399353, 218, 21, 'PPL', 'P'),
(103190, 'Jett', 36.8950004577637, 0.643939235512791, -80.7841720581055, -1.40994978591154, 218, 53, 'PPL', 'P'),
(9761, 'Jett (historical)', 36.1500015258789, 0.630936551227561, -91.8861083984375, -1.60371512839715, 218, 4, 'PPL', 'P'),
(190349, 'Jett (historical)', 38.7230606079102, 0.675844904057349, -117.205001831055, -2.04561318175789, 218, 39, 'PPL', 'P'),
(201042, 'Jett (historical)', 44.4263916015625, 0.775386808227622, -117.311111450195, -2.04746514397993, 218, 43, 'PPL', 'P'),
(196790, 'Jette', 47.7174987792969, 0.832827464515105, -114.190559387207, -1.99300123600088, 218, 31, 'PPL', 'P'),
(60430, 'Jetts', 32.3077812194824, 0.563877156293957, -90.9013900756836, -1.58652855146038, 218, 30, 'PPL', 'P'),
(36628, 'Jetts Creek', 37.5022201538086, 0.654537218491734, -83.5425033569336, -1.45809174893691, 218, 21, 'PPL', 'P'),
(103191, 'Jetts Store', 37.9166717529297, 0.661770763486553, -76.3227767944336, -1.33208374932759, 218, 53, 'PPL', 'P'),
(36629, 'Jewel City', 37.5263900756836, 0.654959063208403, -87.3552780151367, -1.52463722035915, 218, 21, 'PPL', 'P'),
(9764, 'Jewell', 33.8561096191406, 0.590900584770127, -94.4238891601563, -1.64800775838291, 218, 4, 'PPL', 'P'),
(22263, 'Jewell', 33.2961082458496, 0.581126716990509, -82.7774963378906, -1.44473985765374, 218, 13, 'PPL', 'P'),
(32877, 'Jewell', 39.6713905334473, 0.692396383653164, -98.1533279418945, -1.71309874437581, 218, 20, 'PPL', 'P'),
(48531, 'Jewell', 38.7547187805176, 0.676397443404513, -76.6188888549805, -1.337251879739, 218, 25, 'PPL', 'P'),
(88182, 'Jewell', 36.336109161377, 0.634184742230103, -88.6063919067383, -1.54647327708504, 218, 50, 'PPL', 'P'),
(95183, 'Jewell', 31.5027809143066, 0.549827250489081, -97.1958312988281, -1.69638727537751, 218, 51, 'PPL', 'P'),
(109851, 'Jewell', 38.8630599975586, 0.678288354357497, -80.4013900756836, -1.40326898000097, 218, 58, 'PPL', 'P'),
(116256, 'Jewell', 42.3069381713867, 0.738395367528367, -93.6399993896484, -1.63432630091485, 218, 16, 'PPL', 'P'),
(149913, 'Jewell', 43.2244415283203, 0.754408822004959, -75.8069381713867, -1.32308066694647, 218, 40, 'PPL', 'P'),
(155923, 'Jewell', 41.3258285522461, 0.721271774351376, -84.2855606079102, -1.47106054449727, 218, 41, 'PPL', 'P'),
(163157, 'Jewell', 40.3113899230957, 0.703566480213284, -80.065559387207, -1.39740762875782, 218, 45, 'PPL', 'P'),
(182378, 'Jewell', 38.0366706848145, 0.663865139946819, -122.744720458984, -2.14229951144932, 218, 6, 'PPL', 'P'),
(201043, 'Jewell', 45.9347190856934, 0.801712089024028, -123.502777099609, -2.15553009574484, 218, 43, 'PPL', 'P'),
(149910, 'Jewell Corner', 43.1858291625977, 0.753734909091115, -73.6197204589844, -1.28490651640711, 218, 40, 'PPL', 'P'),
(103192, 'Jewell Ridge', 37.1847190856934, 0.648995779474525, -81.7886123657227, -1.42748057641921, 218, 53, 'PPL', 'P'),
(120154, 'Jewell Road', 41.8766708374023, 0.730885785886562, -88.1358337402344, -1.5382604877574, 218, 18, 'PPL', 'P'),
(103193, 'Jewell Valley', 37.2472190856934, 0.650086610257021, -81.8016662597656, -1.42770840985047, 218, 53, 'PPL', 'P'),
(30212, 'Jewell Village', 39.1986083984375, 0.684144778752636, -85.8497161865234, -1.4983602093575, 218, 19, 'PPL', 'P'),
(41537, 'Jewella (historical)', 32.4686088562012, 0.566684128082901, -93.8061065673828, -1.63722541807751, 218, 22, 'PPL', 'P'),
(127830, 'Jewells Corner', 46.3405609130859, 0.808795365154339, -67.8430633544922, -1.184084830175, 218, 26, 'PPL', 'P'),
(60431, 'Jewells Hill (historical)', 32.1674995422363, 0.561428779145793, -89.1861114501953, -1.55659129185652, 218, 30, 'PPL', 'P'),
(22264, 'Jewelville', 34.371940612793, 0.599903533993195, -83.4038925170898, -1.45567253340268, 218, 13, 'PPL', 'P'),
(27563, 'Jewett', 39.2077789306641, 0.684304834734149, -88.2458267211914, -1.54018022742918, 218, 18, 'PPL', 'P'),
(55586, 'Jewett', 37.3802795410156, 0.652408953306597, -90.5013885498047, -1.57954720782079, 218, 29, 'PPL', 'P'),
(88181, 'Jewett', 35.771671295166, 0.624333443041791, -84.9361114501953, -1.48241479864676, 218, 50, 'PPL', 'P'),
(95184, 'Jewett', 31.3613891601563, 0.547359498843986, -96.1438903808594, -1.6780274428225, 218, 51, 'PPL', 'P'),
(127831, 'Jewett', 43.2122192382813, 0.754195502801644, -70.7900009155273, -1.23551859346575, 218, 26, 'PPL', 'P'),
(149911, 'Jewett', 42.2702789306641, 0.737755543076476, -74.3033294677734, -1.29683774440677, 218, 40, 'PPL', 'P'),
(155924, 'Jewett', 40.3677787780762, 0.704550651394123, -81.0055618286133, -1.41381376633714, 218, 41, 'PPL', 'P'),
(174694, 'Jewett', 45.1175003051758, 0.787448930594864, -92.4361114501953, -1.61331449254634, 218, 57, 'PPL', 'P'),
(149912, 'Jewett Center', 42.2363891601563, 0.737164054998369, -74.3177795410156, -1.297089945762, 218, 40, 'PPL', 'P'),
(113591, 'Jewett City', 41.6066703796387, 0.726173388916694, -71.9813919067383, -1.25631228894098, 218, 8, 'PPL', 'P'),
(149916, 'Jewettville', 43.9538917541504, 0.76714013017511, -76.0905609130859, -1.32803081762265, 218, 40, 'PPL', 'P'),
(16618, 'Jewfish', 25.1833305358887, 0.439532034469285, -80.3883285522461, -1.40304101341166, 218, 12, 'PPL', 'P'),
(113592, 'Jewitt Corner', 41.4355583190918, 0.723186920070279, -72.3408279418945, -1.26258563120477, 218, 8, 'PPL', 'P'),
(188741, 'Jewkes Place', 33.4169387817383, 0.583235607678716, -107.550277709961, -1.87710645747309, 218, 38, 'PPL', 'P'),
(22265, 'Jewtown', 31.1619396209717, 0.54387844769363, -81.3969421386719, -1.42064464137514, 218, 13, 'PPL', 'P'),
(163158, 'Jewtown', 40.6313896179199, 0.709151528493343, -78.9061126708984, -1.37717146605679, 218, 45, 'PPL', 'P'),
(95185, 'Jiba', 32.5152816772461, 0.567498722481328, -96.2758331298828, -1.68033027821709, 218, 51, 'PPL', 'P'),
(188742, 'Jicarilla', 33.8688888549805, 0.591123624511421, -105.662498474121, -1.8441584942569, 218, 38, 'PPL', 'P'),
(41538, 'Jigger', 32.0347213745117, 0.559111362944233, -91.7466735839844, -1.60128153179303, 218, 22, 'PPL', 'P'),
(81785, 'Jiggs', 34.0800018310547, 0.594808241037601, -80.975830078125, -1.41329484939874, 218, 48, 'PPL', 'P'),
(200028, 'Jiggs', 40.4258308410645, 0.705563851030843, -115.664436340332, -2.01872524160217, 218, 39, 'PPL', 'P'),
(174695, 'Jim Falls', 45.045280456543, 0.786188456450929, -91.2727813720703, -1.59301055239557, 218, 57, 'PPL', 'P'),
(182379, 'Jim Leggett Place', 39.8627815246582, 0.695736786608451, -123.419441223145, -2.15407561031549, 218, 6, 'PPL', 'P'),
(195154, 'Jim Moore Place', 45.4863891601563, 0.793887255688185, -115.338333129883, -2.01303366687851, 218, 17, 'PPL', 'P'),
(188743, 'Jim Robinson', 31.7705593109131, 0.554500865175574, -108.80249786377, -1.89896182211688, 218, 38, 'PPL', 'P'),
(163160, 'Jim Thorpe', 40.8758316040039, 0.713417845980623, -75.732780456543, -1.32178637065669, 218, 45, 'PPL', 'P'),
(155925, 'Jim Town', 41.6436080932617, 0.726818073637575, -84.6022186279297, -1.47658726954945, 218, 41, 'PPL', 'P'),
(65968, 'Jimes (historical)', 35.8452796936035, 0.625618151951646, -80.1938934326172, -1.39964748039263, 218, 33, 'PPL', 'P'),
(182381, 'Jimgrey', 34.9769401550293, 0.610462767978277, -117.466667175293, -2.05018010355321, 218, 6, 'PPL', 'P'),
(22267, 'Jimps', 32.3855590820313, 0.565234636080598, -81.835563659668, -1.42830003108663, 218, 13, 'PPL', 'P'),
(193682, 'Jims Camp', 41.8330612182617, 0.730124654447017, -122.584716796875, -2.13950692073027, 218, 6, 'PPL', 'P'),
(207744, 'Jims Corner', 46.9949989318848, 0.820217463332608, -122.293327331543, -2.1344212151546, 218, 56, 'PPL', 'P'),
(946, 'Jimtown', 35.9711112976074, 0.627814327744579, -83.1686096191406, -1.45156607215983, 218, 50, 'PPL', 'P'),
(14029, 'Jimtown', 38.7319412231445, 0.675999900032792, -75.1869430541992, -1.31225971080526, 218, 10, 'PPL', 'P'),
(27565, 'Jimtown', 38.9877815246582, 0.6804651556535, -89.2125015258789, -1.55705188556705, 218, 18, 'PPL', 'P'),
(30213, 'Jimtown', 38.2730598449707, 0.667990909107569, -87.8530578613281, -1.53332511762526, 218, 19, 'PPL', 'P'),
(36635, 'Jimtown', 38.1888885498047, 0.666521842871254, -84.3744430541992, -1.47261183583224, 218, 21, 'PPL', 'P'),
(48532, 'Jimtown', 39.5991706848145, 0.69113590950923, -77.3930587768555, -1.35076369384562, 218, 25, 'PPL', 'P'),
(76231, 'Jimtown', 33.8619384765625, 0.591002317523768, -97.3691711425781, -1.69941262637584, 218, 42, 'PPL', 'P'),
(109857, 'Jimtown', 39.6369400024414, 0.691795108458052, -78.2177810668945, -1.36515781322139, 218, 58, 'PPL', 'P'),
(155927, 'Jimtown', 40.8202781677246, 0.712448255606753, -80.5347213745117, -1.40559605016148, 218, 41, 'PPL', 'P'),
(163161, 'Jimtown', 40.0275001525879, 0.698611669005191, -79.2280578613281, -1.38279046964075, 218, 45, 'PPL', 'P'),
(174696, 'Jimtown', 43.353328704834, 0.756658327598722, -90.6383285522461, -1.58193726174108, 218, 57, 'PPL', 'P'),
(182382, 'Jimtown', 38.6666717529297, 0.67486073287651, -122.81861114502, -2.14358914720719, 218, 6, 'PPL', 'P'),
(196791, 'Jimtown', 45.6788902282715, 0.797247033140402, -106.6875, -1.86204814572145, 218, 31, 'PPL', 'P'),
(201044, 'Jimtown', 44.9055595397949, 0.783749866419771, -117.143890380859, -2.04454658574131, 218, 43, 'PPL', 'P'),
(88184, 'Jimtown (historical)', 36.1444396972656, 0.630839479005828, -86.7438888549805, -1.51396646650342, 218, 50, 'PPL', 'P'),
(155926, 'Jimtown (historical)', 40.1108283996582, 0.700066021276484, -84.2783279418945, -1.4709343106616, 218, 41, 'PPL', 'P'),
(32880, 'Jingo', 38.4038887023926, 0.670274303426203, -94.6958312988281, -1.65275404407765, 218, 20, 'PPL', 'P'),
(36632, 'Jingo', 37.4986114501953, 0.654474234731954, -86.8083267211914, -1.51509111943176, 218, 21, 'PPL', 'P'),
(109855, 'Jingo (historical)', 38.7241706848145, 0.67586427855428, -81.4786071777344, -1.42206996519055, 218, 58, 'PPL', 'P'),
(3428, 'Jink (historical)', 34.3908309936523, 0.600233233336147, -86.1116714477539, -1.5029321911589, 218, 2, 'PPL', 'P'),
(22268, 'Jinks', 30.7163906097412, 0.536102150468653, -84.8238906860352, -1.48045617682307, 218, 13, 'PPL', 'P'),
(36633, 'Jinks', 37.6063919067383, 0.656355358567931, -84.0322189331055, -1.46663889813941, 218, 21, 'PPL', 'P'),
(95190, 'Jinks Branch', 30.6344394683838, 0.534671833226198, -97.89111328125, -1.70852223520056, 218, 51, 'PPL', 'P'),
(65969, 'Jinnys Branch', 33.9130592346191, 0.591894543067972, -78.3994369506836, -1.36832830649913, 218, 33, 'PPL', 'P'),
(196792, 'Jitney (historical)', 47.0208282470703, 0.820668269926131, -108.026107788086, -1.88541125901639, 218, 31, 'PPL', 'P'),
(163165, 'Jo Jo', 41.6358299255371, 0.726682319001008, -78.851936340332, -1.37622591071176, 218, 45, 'PPL', 'P'),
(9766, 'Joan', 34.1144409179688, 0.595409316495631, -92.9402770996094, -1.62211384310407, 218, 4, 'PPL', 'P'),
(55589, 'Joanna', 39.540828704834, 0.690117649866438, -91.6691665649414, -1.59992877911733, 218, 29, 'PPL', 'P'),
(81786, 'Joanna', 34.4147186279297, 0.600650151204798, -81.811393737793, -1.42787818636996, 218, 48, 'PPL', 'P'),
(163162, 'Joanna', 40.1736106872559, 0.701161778906997, -75.8622207641602, -1.3240455302094, 218, 45, 'PPL', 'P'),
(163163, 'Joanna Furnace', 40.1894416809082, 0.701438081870092, -75.8886108398438, -1.32450612391993, 218, 45, 'PPL', 'P'),
(163164, 'Joanna Heights', 40.1852798461914, 0.70136544415136, -75.8550033569336, -1.32391956268984, 218, 45, 'PPL', 'P'),
(95188, 'Joaquin', 31.9655609130859, 0.557904285180155, -94.0536117553711, -1.64154519852367, 218, 51, 'PPL', 'P'),
(36634, 'Job', 37.917781829834, 0.661790137983483, -82.5438919067383, -1.44066269118288, 218, 21, 'PPL', 'P'),
(109856, 'Job', 38.8641700744629, 0.678307728854427, -79.5572204589844, -1.38853544074427, 218, 58, 'PPL', 'P'),
(55590, 'Jobe', 36.583610534668, 0.638504456097239, -91.2513885498047, -1.59263717721075, 218, 29, 'PPL', 'P'),
(55592, 'Jobe (historical)', 36.5849990844727, 0.638528690863159, -91.2702789306641, -1.5929668765537, 218, 29, 'PPL', 'P'),
(88185, 'Jobe (historical)', 36.1872215270996, 0.631586162796459, -83.959716796875, -1.46537349714746, 218, 50, 'PPL', 'P'),
(170630, 'Jobee Acres', 45.4461097717285, 0.793184247739431, -98.3938903808594, -1.71729735099237, 218, 49, 'PPL', 'P'),
(60433, 'Jobes', 34.8613891601563, 0.608446022663787, -88.4997177124023, -1.54461146116697, 218, 30, 'PPL', 'P'),
(76230, 'Jobes', 36.4388885498047, 0.635978580961354, -96.7205581665039, -1.68809219437218, 218, 42, 'PPL', 'P'),
(73067, 'Jobs', 39.5002784729004, 0.68940991480675, -82.1791687011719, -1.43429707038732, 218, 41, 'PPL', 'P'),
(149917, 'Jobs Corner', 42.3988914489746, 0.740000254980276, -77.5572204589844, -1.35362885570439, 218, 40, 'PPL', 'P'),
(163166, 'Jobs Corners', 41.9316711425781, 0.731845722301481, -76.9361114501953, -1.34278845848722, 218, 45, 'PPL', 'P'),
(145510, 'Jobstown', 40.0369415283203, 0.69877645209764, -74.6933288574219, -1.30364451783691, 218, 37, 'PPL', 'P'),
(81788, 'Jocassee', 34.9708290100098, 0.610356108376619, -82.9375, -1.4475324483728, 218, 48, 'PPL', 'P'),
(81787, 'Jocassee (historical)', 34.9708290100098, 0.610356108376619, -82.9355621337891, -1.44749862622695, 218, 48, 'PPL', 'P'),
(48534, 'Jocelyn Acres', 39.1955604553223, 0.684091582109861, -76.977783203125, -1.34351576778092, 218, 25, 'PPL', 'P'),
(30214, 'Jockey', 38.1783294677734, 0.666337552123821, -87.163330078125, -1.52128709686589, 218, 19, 'PPL', 'P'),
(144008, 'Jockey Hill', 44.1863899230957, 0.771197988728064, -71.9061126708984, -1.25499841841719, 218, 36, 'PPL', 'P'),
(149918, 'Jockey Hill', 41.9880599975586, 0.73282989348232, -74.0502777099609, -1.29242115805498, 218, 40, 'PPL', 'P'),
(199434, 'Joder', 42.8583297729492, 0.748018966443478, -103.551109313965, -1.80730780162125, 218, 35, 'PPL', 'P'),
(109858, 'Jodie', 38.230281829834, 0.667244291895966, -81.148063659668, -1.41630089247917, 218, 58, 'PPL', 'P'),
(95189, 'Joe', 33.7994384765625, 0.589911486741272, -96.5302810668945, -1.68477123249285, 218, 51, 'PPL', 'P'),
(60432, 'Joe (historical)', 32.0527801513672, 0.559426548059244, -89.8138885498047, -1.56754806921333, 218, 30, 'PPL', 'P'),
(73068, 'Joe (historical)', 39.6472206115723, 0.691974538936496, -82.4077835083008, -1.43828715149053, 218, 41, 'PPL', 'P'),
(109859, 'Joe Branch', 37.5688896179199, 0.655700820151017, -81.454719543457, -1.4216530473219, 218, 58, 'PPL', 'P'),
(95191, 'Joe Lee', 30.9106407165527, 0.539492454404864, -97.2805709838867, -1.69786626188888, 218, 51, 'PPL', 'P'),
(103195, 'Joe Neets', 37.0825004577637, 0.64721172786028, -81.4786071777344, -1.42206996519055, 218, 53, 'PPL', 'P'),
(22269, 'Joe Shingler (historical)', 31.1972198486328, 0.54449420382717, -84.8308334350586, -1.48057735065266, 218, 13, 'PPL', 'P'),
(103194, 'Joe Whites', 37.0149993896484, 0.646033611973057, -81.6736068725586, -1.42547335190562, 218, 53, 'PPL', 'P'),
(188744, 'Joe Yarbrough', 31.666109085083, 0.552677864830388, -108.831672668457, -1.8994710185173, 218, 38, 'PPL', 'P'),
(22270, 'Joel', 33.4755592346191, 0.584258727590497, -85.2380599975586, -1.48768479496987, 218, 13, 'PPL', 'P'),
(174698, 'Joel', 45.3605613708496, 0.791691146474278, -92.2344436645508, -1.60979472569164, 218, 57, 'PPL', 'P'),
(191671, 'Joel', 34.8605613708496, 0.608431575014874, -102.301109313965, -1.78549118597132, 218, 51, 'PPL', 'P'),
(195155, 'Joel', 46.7105598449707, 0.815253064744591, -116.876937866211, -2.03988738541422, 218, 17, 'PPL', 'P'),
(16621, 'Joels Landing', 30.5516700744629, 0.533227234782399, -81.6688919067383, -1.42539106022793, 218, 12, 'PPL', 'P'),
(88186, 'Joelton', 36.313060760498, 0.633782471747447, -86.8652801513672, -1.51608514430864, 218, 50, 'PPL', 'P'),
(186898, 'Joes', 39.6563911437988, 0.69213459491801, -102.678329467773, -1.79207491966016, 218, 7, 'PPL', 'P'),
(109860, 'Joes Creek', 38.0933303833008, 0.664854038238592, -81.5572204589844, -1.42344202578416, 218, 58, 'PPL', 'P'),
(182383, 'Joes Landing', 38.7799987792969, 0.676838662618112, -121.602500915527, -2.12236401963537, 218, 6, 'PPL', 'P'),
(182384, 'Joesphine', 39.0941696166992, 0.682321978144531, -121.800003051758, -2.12581108219232, 218, 6, 'PPL', 'P'),
(73069, 'Joetown', 39.6655616760254, 0.692294650899523, -81.9261093139648, -1.42988035087748, 218, 41, 'PPL', 'P'),
(109861, 'Joetown', 39.4630584716797, 0.688760303237852, -80.4077835083008, -1.40338056645065, 218, 58, 'PPL', 'P'),
(120156, 'Joetta', 40.4336090087891, 0.70569960566741, -90.9313888549805, -1.58705212893069, 218, 18, 'PPL', 'P'),
(182385, 'Jofegan', 33.314998626709, 0.581456416333461, -117.331390380859, -2.0478190780888, 218, 6, 'PPL', 'P'),
(3430, 'Joffre', 32.5627784729004, 0.568327697949643, -86.6391677856445, -1.5121387390473, 218, 2, 'PPL', 'P'),
(163167, 'Joffre', 40.3791694641113, 0.704749456369497, -80.3605575561523, -1.40255631809327, 218, 45, 'PPL', 'P'),
(188745, 'Joffre', 34.4872207641602, 0.60191555219675, -105.043891906738, -1.83336177288161, 218, 38, 'PPL', 'P'),
(131505, 'Johannesburg', 44.9855613708496, 0.7851461617793, -84.4558334350586, -1.47403236595769, 218, 27, 'PPL', 'P'),
(174697, 'Johannesburg', 45.1652793884277, 0.788282832911195, -92.5938873291016, -1.61606820111348, 218, 57, 'PPL', 'P'),
(182386, 'Johannesburg', 35.3727798461914, 0.617371473899133, -117.633888244629, -2.05309866179183, 218, 6, 'PPL', 'P'),
(27566, 'Johannisburg', 38.3844413757324, 0.669934883545273, -89.6530609130859, -1.56474109742438, 218, 18, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(207745, 'Johansons Corner', 47.6300010681152, 0.831300341367027, -122.651390075684, -2.14067058896858, 218, 56, 'PPL', 'P'),
(103196, 'John', 36.9652786254883, 0.645165820931854, -82.2958297729492, -1.43633319019874, 218, 53, 'PPL', 'P'),
(41539, 'John (historical)', 30.0519409179688, 0.524505315633362, -91.7158279418945, -1.60074317377867, 218, 22, 'PPL', 'P'),
(201045, 'John Day', 44.4161109924316, 0.775207377749178, -118.951942443848, -2.07610304728793, 218, 43, 'PPL', 'P'),
(211897, 'John Fitzgerald Kennedy City', 61.396671295166, 1.07157406386534, -149.824996948242, -2.61493949853728, 218, 1, 'PPL', 'P'),
(186899, 'John Held Corner', 39.1366691589355, 0.683063735087145, -108.135559082031, -1.8873215444663, 218, 7, 'PPL', 'P'),
(95192, 'John L Norris Colonia', 28.0259990692139, 0.489145959918648, -97.8809967041016, -1.70834566762029, 218, 51, 'PPL', 'P'),
(14030, 'John Marsh Landing', 38.6586112976074, 0.674720051391927, -75.1650009155273, -1.3118767482405, 218, 10, 'PPL', 'P'),
(188746, 'John Padilla Settlement', 34.3841705322266, 0.600116986354565, -107.473892211914, -1.87577327903139, 218, 38, 'PPL', 'P'),
(22273, 'John Ross Estates', 34.976390838623, 0.610453180598353, -85.279167175293, -1.48840225056753, 218, 13, 'PPL', 'P'),
(207746, 'John Sam Lake', 48.1094398498535, 0.83966812667011, -122.244720458984, -2.13357286518935, 218, 56, 'PPL', 'P'),
(88187, 'John Sevier', 36.0400009155273, 0.629016678397723, -83.815559387207, -1.4628574757076, 218, 50, 'PPL', 'P'),
(48535, 'John Town', 39.4255599975586, 0.688105831399965, -75.9188919067383, -1.32503462823826, 218, 25, 'PPL', 'P'),
(36636, 'Johnetta', 37.4155616760254, 0.653024742729651, -84.1919403076172, -1.46942656201045, 218, 21, 'PPL', 'P'),
(191672, 'Johnfarris', 34.2200012207031, 0.597251691337748, -101.210830688477, -1.76646223419244, 218, 51, 'PPL', 'P'),
(190351, 'Johnnie', 36.4197196960449, 0.635644021349412, -116.070831298828, -2.02581817169144, 218, 39, 'PPL', 'P'),
(109862, 'Johnnycake', 37.4822196960449, 0.654188144651852, -81.8172225952148, -1.4279799191236, 218, 58, 'PPL', 'P'),
(232, 'Johns', 33.3616714477539, 0.582271010731889, -87.1097183227539, -1.52035139521689, 218, 2, 'PPL', 'P'),
(60435, 'Johns', 32.1308288574219, 0.560788754956819, -89.8380584716797, -1.56796991393, 218, 30, 'PPL', 'P'),
(65971, 'Johns', 34.6997184753418, 0.605624336909821, -79.4430618286133, -1.38654299677473, 218, 33, 'PPL', 'P'),
(109863, 'Johns', 38.148609161377, 0.665818834922501, -81.7016677856445, -1.42596310723008, 218, 58, 'PPL', 'P'),
(73070, 'Johns Creek (historical)', 38.6711082458496, 0.674938164285204, -82.5688934326172, -1.44109905012749, 218, 41, 'PPL', 'P'),
(16647, 'Johns Ferry', 29.4316692352295, 0.513679532512676, -81.6638870239258, -1.42530370854418, 218, 12, 'PPL', 'P'),
(81790, 'Johns Island', 32.7922210693359, 0.572332226701768, -80.1083297729492, -1.39815411281137, 218, 48, 'PPL', 'P'),
(201046, 'Johns Landing', 45.3997192382813, 0.79237458018902, -122.673606872559, -2.14105834522329, 218, 43, 'PPL', 'P'),
(81791, 'Johns Mill', 34.6258316040039, 0.604334767730978, -83.107780456543, -1.45050440299127, 218, 48, 'PPL', 'P'),
(55593, 'Johns Mills (historical)', 37.0361099243164, 0.646402060309869, -92.8905563354492, -1.62124605206287, 218, 29, 'PPL', 'P'),
(188748, 'Johns Place', 35.0127792358398, 0.61108827793931, -106.088333129883, -1.85159071106904, 218, 38, 'PPL', 'P'),
(36637, 'Johns Run', 38.2383308410645, 0.667384773643467, -82.9116668701172, -1.44708157520025, 218, 21, 'PPL', 'P'),
(95193, 'Johns Valley Colonia', 27.9799995422363, 0.48834311671853, -97.963996887207, -1.70979429409524, 218, 51, 'PPL', 'P'),
(482, 'Johnsburg', 38.2177810668945, 0.667026112423661, -86.9555587768555, -1.51766080356758, 218, 19, 'PPL', 'P'),
(78528, 'Johnsburg', 39.8694381713867, 0.695852967011006, -78.8436126708984, -1.3760806352743, 218, 45, 'PPL', 'P'),
(120157, 'Johnsburg', 42.3800010681152, 0.739670555637325, -88.241943359375, -1.54011244997944, 218, 18, 'PPL', 'P'),
(136149, 'Johnsburg', 43.5055618286133, 0.759315296839267, -92.7688903808594, -1.61912258056769, 218, 28, 'PPL', 'P'),
(149920, 'Johnsburg', 43.6183280944824, 0.761283439463863, -73.961669921875, -1.29087466040998, 218, 40, 'PPL', 'P'),
(174699, 'Johnsburg', 43.8772201538086, 0.765801958306373, -88.2897186279297, -1.54094628571674, 218, 57, 'PPL', 'P'),
(136147, 'Johnsdale', 46.0327796936035, 0.803423569498568, -93.788330078125, -1.63691515981051, 218, 28, 'PPL', 'P'),
(364, 'Johnson', 38.4752807617188, 0.671520329921224, -75.1388931274414, -1.31142108137799, 218, 10, 'PPL', 'P'),
(3432, 'Johnson', 34.4908294677734, 0.60197853595653, -86.4172210693359, -1.50826503808373, 218, 2, 'PPL', 'P'),
(9770, 'Johnson', 36.1327781677246, 0.630635946919518, -94.165283203125, -1.64349423296744, 218, 4, 'PPL', 'P'),
(16649, 'Johnson', 29.5844402313232, 0.516345889396063, -81.9733276367188, -1.4307044660768, 218, 12, 'PPL', 'P'),
(22274, 'Johnson', 34.1722183227539, 0.59641772244239, -83.970832824707, -1.46556750843287, 218, 13, 'PPL', 'P'),
(30215, 'Johnson', 38.2777786254883, 0.66807326736428, -87.7458267211914, -1.53145358116921, 218, 19, 'PPL', 'P'),
(41541, 'Johnson', 30.0163898468018, 0.523884832388887, -90.6347198486328, -1.5818742779813, 218, 22, 'PPL', 'P'),
(60436, 'Johnson', 31.538890838623, 0.550457487561048, -89.1433334350586, -1.55584467464492, 218, 30, 'PPL', 'P'),
(73071, 'Johnson', 39.5472183227539, 0.690229169737085, -83.3305587768555, -1.45439261818279, 218, 41, 'PPL', 'P'),
(76232, 'Johnson', 35.4055595397949, 0.61794358748031, -96.8413925170898, -1.69020115163942, 218, 42, 'PPL', 'P'),
(88188, 'Johnson', 35.6722183227539, 0.622597661222305, -84.5625, -1.47589404871771, 218, 50, 'PPL', 'P'),
(109864, 'Johnson', 39.2755584716797, 0.685487810890363, -78.8258285522461, -1.37577024384925, 218, 58, 'PPL', 'P'),
(136148, 'Johnson', 45.5727806091309, 0.79539507091836, -96.2949981689453, -1.68066477125001, 218, 28, 'PPL', 'P'),
(140291, 'Johnson', 46.9797210693359, 0.819950814328463, -98.5061111450195, -1.71925597281607, 218, 34, 'PPL', 'P'),
(142139, 'Johnson', 40.410831451416, 0.705302062295688, -95.9977798461914, -1.6754773329207, 218, 35, 'PPL', 'P'),
(149922, 'Johnson', 41.3661117553711, 0.721974848879157, -74.5069427490234, -1.30039146656537, 218, 40, 'PPL', 'P'),
(172167, 'Johnson', 44.6355590820313, 0.779037469449903, -72.6808319091797, -1.26851981990374, 218, 55, 'PPL', 'P'),
(174700, 'Johnson', 45.0113906860352, 0.785596968372823, -89.355827331543, -1.55955339277896, 218, 57, 'PPL', 'P'),
(178424, 'Johnson', 32.1030616760254, 0.560304126217452, -110.065559387207, -1.92100640435612, 218, 5, 'PPL', 'P'),
(187736, 'Johnson', 37.5705604553223, 0.655729981764953, -101.750556945801, -1.77588223444221, 218, 20, 'PPL', 'P'),
(191673, 'Johnson', 33.2266693115234, 0.579914778957441, -102.46305847168, -1.78831773199428, 218, 51, 'PPL', 'P'),
(194260, 'Johnson', 40.0875015258789, 0.699658890524838, -104.442222595215, -1.82286066238732, 218, 7, 'PPL', 'P'),
(195157, 'Johnson', 46.5727806091309, 0.812848363438304, -116.08528137207, -2.02607037304667, 218, 17, 'PPL', 'P'),
(196793, 'Johnson', 45.7963905334473, 0.799297800337817, -112.685279846191, -1.96672915184725, 218, 31, 'PPL', 'P'),
(207747, 'Johnson', 46.6316719055176, 0.81387621046102, -117.136940002441, -2.04442527875366, 218, 56, 'PPL', 'P'),
(3433, 'Johnson (historical)', 34.4174995422363, 0.600698687315665, -86.3013916015625, -1.50624343250025, 218, 2, 'PPL', 'P'),
(109865, 'Johnson (historical)', 38.2591705322266, 0.667748494869345, -82.2972183227539, -1.43635742496466, 218, 58, 'PPL', 'P'),
(116257, 'Johnson (historical)', 42.149169921875, 0.73564179211928, -91.0327835083008, -1.58882179947504, 218, 16, 'PPL', 'P'),
(41542, 'Johnson Bayou Landing', 29.8019409179688, 0.520141992503376, -93.7527770996094, -1.63629464327652, 218, 22, 'PPL', 'P'),
(55594, 'Johnson City', 38.1169395446777, 0.665266095838255, -93.9277801513672, -1.63934902273074, 218, 29, 'PPL', 'P'),
(81792, 'Johnson City', 34.9652786254883, 0.610259235891968, -81.9891662597656, -1.43098090219795, 218, 48, 'PPL', 'P'),
(88189, 'Johnson City', 36.3133316040039, 0.633787198858382, -82.3536071777344, -1.4373415961455, 218, 50, 'PPL', 'P'),
(95195, 'Johnson City', 30.2766704559326, 0.528427585997317, -98.4116668701172, -1.71760760925937, 218, 51, 'PPL', 'P'),
(149923, 'Johnson City', 42.1155586242676, 0.735055164310163, -75.9591674804688, -1.32573756960799, 218, 40, 'PPL', 'P'),
(201047, 'Johnson City', 45.4047203063965, 0.792461865293747, -122.577781677246, -2.13938588005872, 218, 43, 'PPL', 'P'),
(22275, 'Johnson Corner', 32.064998626709, 0.559639800683532, -82.3013916015625, -1.43643026242047, 218, 13, 'PPL', 'P'),
(81793, 'Johnson Corner', 33.4666709899902, 0.584103598457, -79.3647232055664, -1.38517572987108, 218, 48, 'PPL', 'P'),
(103199, 'Johnson Corner', 36.9752807617188, 0.645340391141309, -76.8602828979492, -1.3414650005835, 218, 53, 'PPL', 'P'),
(125159, 'Johnson Corner', 42.0666694641113, 0.734201887496901, -72.6944427490234, -1.26875737387298, 218, 23, 'PPL', 'P'),
(127833, 'Johnson Corner', 45.0377807617188, 0.786057562083352, -69.8208312988281, -1.21860339264406, 218, 26, 'PPL', 'P'),
(144009, 'Johnson Corner', 42.8886108398438, 0.748547470761804, -71.7347183227539, -1.25200702272276, 218, 36, 'PPL', 'P'),
(182387, 'Johnson Corner', 34.3072204589844, 0.598773954216838, -117.751670837402, -2.05515435583726, 218, 6, 'PPL', 'P'),
(149924, 'Johnson Corners', 43.0716705322266, 0.751742465121572, -75.059440612793, -1.31003437339839, 218, 40, 'PPL', 'P'),
(103201, 'Johnson Cove', 37.5466690063477, 0.655312997317274, -75.9263916015625, -1.32516552260584, 218, 53, 'PPL', 'P'),
(149925, 'Johnson Creek', 43.2455596923828, 0.754777403499826, -78.5155563354492, -1.37035497208868, 218, 40, 'PPL', 'P'),
(174701, 'Johnson Creek', 43.0761108398438, 0.751819963109293, -88.774169921875, -1.54940155586164, 218, 57, 'PPL', 'P'),
(16650, 'Johnson Crossroad', 30.7294406890869, 0.536329917320882, -85.6636123657227, -1.49511208493399, 218, 12, 'PPL', 'P'),
(3434, 'Johnson Crossroads', 34.9608306884766, 0.610181604746192, -87.7516708374023, -1.53155558023896, 218, 2, 'PPL', 'P'),
(22277, 'Johnson Crossroads', 32.9011116027832, 0.574232725034676, -84.5991668701172, -1.47653400632765, 218, 13, 'PPL', 'P'),
(36639, 'Johnson Crossroads', 37.398609161377, 0.652728865532543, -86.2016677856445, -1.50450292356983, 218, 21, 'PPL', 'P'),
(65973, 'Johnson Crossroads', 35.5208282470703, 0.619955405946783, -78.602783203125, -1.37187736812583, 218, 33, 'PPL', 'P'),
(81796, 'Johnson Crossroads', 34.0347213745117, 0.59401794798412, -79.8225021362305, -1.39316547945743, 218, 48, 'PPL', 'P'),
(109866, 'Johnson Crossroads', 37.6175003051758, 0.656549236695289, -80.6341705322266, -1.40733176540194, 218, 58, 'PPL', 'P'),
(14031, 'Johnson Development', 38.6144409179688, 0.673949132835376, -75.6013870239258, -1.31949312264202, 218, 10, 'PPL', 'P'),
(65974, 'Johnson Development', 35.8516693115234, 0.625729671822293, -81.5052795410156, -1.4225354857491, 218, 33, 'PPL', 'P'),
(198458, 'Johnson Ford', 46.5808296203613, 0.812988845185806, -101.753608703613, -1.77593549766401, 218, 34, 'PPL', 'P'),
(55596, 'Johnson Ford (historical)', 38.1322212219238, 0.665532811421426, -91.8894424438477, -1.60377331846697, 218, 29, 'PPL', 'P'),
(163168, 'Johnson Greene', 41.2319412231445, 0.71963313133265, -75.9683303833008, -1.32589749243144, 218, 45, 'PPL', 'P'),
(88191, 'Johnson Heights', 36.5580596923828, 0.638058509772705, -87.3838882446289, -1.52513656306354, 218, 50, 'PPL', 'P'),
(22278, 'Johnson Land', 33.6791687011719, 0.587812383170071, -84.7869415283203, -1.4798112923651, 218, 13, 'PPL', 'P'),
(3435, 'Johnson Landing', 34.5483283996582, 0.602982081634299, -86.6602783203125, -1.51250718738411, 218, 2, 'PPL', 'P'),
(41543, 'Johnson Landing', 30.9672203063965, 0.540479954537066, -92.434440612793, -1.6132853309324, 218, 22, 'PPL', 'P'),
(103203, 'Johnson Landing', 37.5869407653809, 0.656015872107974, -76.9655609130859, -1.3433024485776, 218, 53, 'PPL', 'P'),
(131506, 'Johnson Landing', 45.2733306884766, 0.790168683858107, -87.4655609130859, -1.52656202003701, 218, 27, 'PPL', 'P'),
(207748, 'Johnson Landing', 47.1841697692871, 0.823519117294033, -122.689170837402, -2.14132998765448, 218, 56, 'PPL', 'P'),
(190353, 'Johnson Lane', 39.0480613708496, 0.681517237442136, -119.72110748291, -2.0895275097108, 218, 39, 'PPL', 'P'),
(48536, 'Johnson Manor', 39.4391708374023, 0.6883433853692, -76.3288879394531, -1.33219040892925, 218, 25, 'PPL', 'P'),
(55597, 'Johnson Mill', 36.1855583190918, 0.631557134340577, -90.1313934326172, -1.57308957480956, 218, 29, 'PPL', 'P'),
(193683, 'Johnson Park', 40.917781829834, 0.714150015543313, -121.626106262207, -2.12277601065601, 218, 6, 'PPL', 'P'),
(70989, 'Johnson Place', 39.8627815246582, 0.695736786608451, -74.6183319091797, -1.30233557416113, 218, 37, 'PPL', 'P'),
(41544, 'Johnson Ridge', 29.7655601501465, 0.519507028320474, -90.8161087036133, -1.58504011072713, 218, 22, 'PPL', 'P'),
(88192, 'Johnson Road', 35.9500007629395, 0.627445879407767, -83.8619384765625, -1.46366694352093, 218, 50, 'PPL', 'P'),
(65975, 'Johnson Siding', 35.6580581665039, 0.622350519873146, -76.6677780151367, -1.33810515655226, 218, 33, 'PPL', 'P'),
(202258, 'Johnson Siding', 44.0847206115723, 0.769423524493744, -103.4375, -1.80532494503163, 218, 49, 'PPL', 'P'),
(186900, 'Johnson Village', 38.8108291625977, 0.677376754316363, -106.106109619141, -1.85190096933603, 218, 7, 'PPL', 'P'),
(103204, 'Johnson Woods', 38.7252807617188, 0.67588365305121, -77.4927825927734, -1.35250420277604, 218, 53, 'PPL', 'P'),
(136150, 'Johnson''s Sunset Mobile Home Park', 46.1425018310547, 0.805338582059417, -92.8658294677734, -1.62081448680822, 218, 28, 'PPL', 'P'),
(145512, 'Johnsonburg', 40.9644393920898, 0.714964343625632, -74.8788909912109, -1.30688318803855, 218, 37, 'PPL', 'P'),
(149932, 'Johnsonburg', 42.7374992370605, 0.745910075755271, -78.3097229003906, -1.36676250093622, 218, 40, 'PPL', 'P'),
(163170, 'Johnsonburg', 40.8861083984375, 0.71359720988004, -78.878059387207, -1.37668184389038, 218, 45, 'PPL', 'P'),
(182389, 'Johnsondale', 35.9747200012207, 0.62787731150436, -118.540000915527, -2.06891331129304, 218, 6, 'PPL', 'P'),
(193684, 'Johnsons', 41.3505592346191, 0.72170340618505, -123.870826721191, -2.16195377345216, 218, 6, 'PPL', 'P'),
(204490, 'Johnsons', 40.622501373291, 0.708996399359846, -111.811111450195, -1.95147203512024, 218, 52, 'PPL', 'P'),
(170631, 'Johnsons Addition', 43.6586112976074, 0.761986513991644, -96.8086090087891, -1.68962897147921, 218, 49, 'PPL', 'P'),
(41545, 'Johnsons Bayou', 29.7611103057861, 0.519429363885184, -93.658332824707, -1.63464627971982, 218, 22, 'PPL', 'P'),
(16651, 'Johnsons Beach', 30.3022193908691, 0.528873499032337, -87.4127807617188, -1.52564083261595, 218, 12, 'PPL', 'P'),
(88193, 'Johnsons Chapel', 35.9874992370605, 0.628100351245654, -85.6694412231445, -1.49521381768763, 218, 50, 'PPL', 'P'),
(16652, 'Johnsons Corner', 28.9755592346191, 0.505718911250752, -81.5419387817383, -1.42317531020099, 218, 12, 'PPL', 'P'),
(65976, 'Johnsons Corner', 36.434440612793, 0.635900949815578, -76.2988891601563, -1.33166683145894, 218, 33, 'PPL', 'P'),
(78531, 'Johnsons Corner', 39.8491706848145, 0.695499232639216, -75.538330078125, -1.31839257132155, 218, 45, 'PPL', 'P'),
(103205, 'Johnsons Corner', 38.276668548584, 0.66805389286735, -77.3311080932617, -1.34968245044305, 218, 53, 'PPL', 'P'),
(113594, 'Johnsons Corner', 41.2411117553711, 0.719793187314164, -73.107780456543, -1.27597147779184, 218, 8, 'PPL', 'P'),
(142141, 'Johnsons Corner', 42.2163887023926, 0.736814981158487, -99.7399978637695, -1.74079135865489, 218, 35, 'PPL', 'P'),
(186901, 'Johnsons Corner', 39.0919418334961, 0.682283095992616, -108.496109008789, -1.89361432780605, 218, 7, 'PPL', 'P'),
(198457, 'Johnsons Corner', 47.8041687011719, 0.83434014001427, -102.941108703613, -1.79666128253144, 218, 34, 'PPL', 'P'),
(207749, 'Johnsons Corner', 46.9805603027344, 0.819965461714459, -122.356391906738, -2.13552189963313, 218, 56, 'PPL', 'P'),
(155930, 'Johnsons Corners', 40.9602813720703, 0.714891772485928, -81.841667175293, -1.42840655753023, 218, 41, 'PPL', 'P'),
(3437, 'Johnsons Crossing', 34.0888900756836, 0.594963370171098, -86.7966690063477, -1.51488765392448, 218, 2, 'PPL', 'P'),
(65977, 'Johnsons Crossing', 35.6041717529297, 0.621410024534184, -79.4024963378906, -1.38583499539893, 218, 33, 'PPL', 'P'),
(88198, 'Johnsons Crossroads', 36.4941711425781, 0.636943444224289, -86.5930633544922, -1.51133406492393, 218, 50, 'PPL', 'P'),
(88194, 'Johnsons Grove', 35.767219543457, 0.624255745316988, -89.195556640625, -1.556756141528, 218, 50, 'PPL', 'P'),
(81797, 'Johnsons Landing', 32.9966697692871, 0.575900529667338, -81.4908294677734, -1.42228328439386, 218, 48, 'PPL', 'P'),
(3438, 'Johnsons Mill', 34.2833290100098, 0.598356969769158, -86.4502792358398, -1.50884201193389, 218, 2, 'PPL', 'P'),
(65978, 'Johnsons Mill', 35.0205612182617, 0.611224099154904, -79.1297225952148, -1.38107419547625, 218, 33, 'PPL', 'P'),
(78529, 'Johnsons Mill', 39.7491683959961, 0.693753863439805, -78.1477813720703, -1.36393608807132, 218, 45, 'PPL', 'P'),
(88195, 'Johnsons Mill', 35.776668548584, 0.624420661567491, -87.230827331543, -1.52246514617408, 218, 50, 'PPL', 'P'),
(109867, 'Johnsons Mill', 39.5691719055176, 0.69061233203892, -78.1997222900391, -1.36484262810638, 218, 58, 'PPL', 'P'),
(195158, 'Johnsons Mill', 46.4272193908691, 0.810307840916423, -115.917221069336, -2.02313716742205, 218, 17, 'PPL', 'P'),
(103206, 'Johnsons Mill (historical)', 36.8330612182617, 0.642858191847301, -82.9258270263672, -1.44732871654941, 218, 53, 'PPL', 'P'),
(65987, 'Johnsons Mills (historical)', 35.3861083984375, 0.617604101020352, -77.3525009155273, -1.35005582562788, 218, 33, 'PPL', 'P'),
(103207, 'Johnsons Springs', 37.6980590820313, 0.657955252592796, -77.7113876342773, -1.35631958051175, 218, 53, 'PPL', 'P'),
(95197, 'Johnsons Station', 32.6919403076172, 0.570581997233368, -97.1277770996094, -1.69519950553133, 218, 51, 'PPL', 'P'),
(155931, 'Johnsons Subdivision', 41.524169921875, 0.724733484294315, -83.4908294677734, -1.45718986943375, 218, 41, 'PPL', 'P'),
(36642, 'Johnsontown', 38.1194381713867, 0.665309705101105, -85.8602828979492, -1.49854463326299, 218, 21, 'PPL', 'P'),
(48537, 'Johnsontown', 39.1375007629395, 0.683078249315086, -76.116943359375, -1.32849127817513, 218, 25, 'PPL', 'P'),
(65981, 'Johnsontown', 34.996940612793, 0.610811841818159, -78.3441696166992, -1.36736370955231, 218, 33, 'PPL', 'P'),
(70990, 'Johnsontown', 39.523609161377, 0.689817112137423, -74.4602813720703, -1.29957707190403, 218, 37, 'PPL', 'P'),
(103208, 'Johnsontown', 37.4252815246582, 0.653194386091089, -75.914436340332, -1.32495686393443, 218, 53, 'PPL', 'P'),
(109869, 'Johnsontown', 39.3388900756836, 0.6865931559008, -77.8872222900391, -1.3593884741939, 218, 58, 'PPL', 'P'),
(3439, 'Johnsonville', 31.2944393157959, 0.5461910036262, -86.8722229003906, -1.51620631813823, 218, 2, 'PPL', 'P'),
(36640, 'Johnsonville', 37.935001373291, 0.662090675712499, -85.1069412231445, -1.48539634064516, 218, 21, 'PPL', 'P'),
(60438, 'Johnsonville', 33.4194412231445, 0.583279283520593, -90.5952835083008, -1.58118598399757, 218, 30, 'PPL', 'P'),
(65982, 'Johnsonville', 35.0113906860352, 0.61106404317339, -84.2630615234375, -1.47066786139453, 218, 33, 'PPL', 'P'),
(76235, 'Johnsonville', 34.8955612182617, 0.609042437589911, -97.0533294677734, -1.69390014923548, 218, 42, 'PPL', 'P'),
(81798, 'Johnsonville', 33.8177795410156, 0.590231598704299, -79.4494400024414, -1.38665431690829, 218, 48, 'PPL', 'P'),
(88196, 'Johnsonville', 36.060001373291, 0.629365752237605, -87.9527816772461, -1.53506562655569, 218, 50, 'PPL', 'P'),
(120158, 'Johnsonville', 40.2105598449707, 0.701806663364959, -87.6697235107422, -1.53012532957553, 218, 18, 'PPL', 'P'),
(122934, 'Johnsonville', 40.2275009155273, 0.702102340824985, -87.4863891601563, -1.5269255415258, 218, 19, 'PPL', 'P'),
(149926, 'Johnsonville', 42.9144401550293, 0.748998277355327, -73.5141677856445, -1.28306427472305, 218, 40, 'PPL', 'P'),
(170632, 'Johnsonville', 44.5444412231445, 0.777447162804962, -96.7852783203125, -1.68922177414854, 218, 49, 'PPL', 'P'),
(174704, 'Johnsonville', 43.7983283996582, 0.764425037443775, -87.9094390869141, -1.53430915564805, 218, 57, 'PPL', 'P'),
(204496, 'Johnsonville', 40.6411094665527, 0.709321171854782, -111.82861328125, -1.95177749969727, 218, 52, 'PPL', 'P'),
(22279, 'Johnsonville (historical)', 31.8358306884766, 0.555640065621369, -82.5180587768555, -1.44021181801033, 218, 13, 'PPL', 'P'),
(327, 'Johnston', 33.2658309936523, 0.58059827925121, -93.1669387817383, -1.62606983574533, 218, 4, 'PPL', 'P'),
(60439, 'Johnston', 33.2819404602051, 0.580879442483295, -90.8855590820313, -1.58625224849728, 218, 30, 'PPL', 'P'),
(78530, 'Johnston', 39.7583312988281, 0.693913786263264, -77.7552795410156, -1.35708563879931, 218, 45, 'PPL', 'P'),
(81799, 'Johnston', 33.8319396972656, 0.590478740053459, -81.8011093139648, -1.42769868931249, 218, 48, 'PPL', 'P'),
(116262, 'Johnston', 41.6730613708496, 0.727332130306987, -93.6975021362305, -1.63532991317164, 218, 16, 'PPL', 'P'),
(155933, 'Johnston', 40.545280456543, 0.707648640111184, -81.3697204589844, -1.42016953343667, 218, 41, 'PPL', 'P'),
(88197, 'Johnston Circle', 35.2277793884277, 0.614840738494258, -84.8150024414063, -1.48030104768957, 218, 50, 'PPL', 'P'),
(27572, 'Johnston City', 37.8205604553223, 0.660093304894939, -88.9274978637695, -1.552077633283, 218, 18, 'PPL', 'P'),
(182390, 'Johnston Corner', 36.9286117553711, 0.644525863321908, -121.704170227051, -2.12413848386969, 218, 6, 'PPL', 'P'),
(155934, 'Johnston Corners', 41.6163902282715, 0.726343032278132, -83.665283203125, -1.46023466150804, 218, 41, 'PPL', 'P'),
(55607, 'Johnston Ford', 37.3605613708496, 0.652064806314732, -92.7958297729492, -1.61959276165815, 218, 29, 'PPL', 'P'),
(65985, 'Johnston Heights', 35.6124992370605, 0.621555366550675, -77.357780456543, -1.3501479710016, 218, 33, 'PPL', 'P'),
(109870, 'Johnston Town', 37.357780456543, 0.652016270203865, -81.1416702270508, -1.41618930602949, 218, 58, 'PPL', 'P'),
(191674, 'Johnstone', 29.3811092376709, 0.512797094085478, -100.758613586426, -1.75856955682782, 218, 51, 'PPL', 'P'),
(182391, 'Johnstons Corner', 34.8302803039551, 0.607903070696547, -117.179443359375, -2.0451671022753, 218, 6, 'PPL', 'P'),
(22280, 'Johnstons Crossing', 33.8097190856934, 0.590090917219716, -84.5100021362305, -1.47497778814466, 218, 13, 'PPL', 'P'),
(60440, 'Johnstons Station', 31.3483295440674, 0.547131565544189, -90.4541702270508, -1.57872309262146, 218, 30, 'PPL', 'P'),
(22281, 'Johnstonville', 33.0894393920898, 0.577519665031079, -84.0744400024414, -1.46737579481303, 218, 13, 'PPL', 'P'),
(193685, 'Johnstonville', 40.3844413757324, 0.704841468585159, -120.586387634277, -2.10462949730432, 218, 6, 'PPL', 'P'),
(3440, 'Johnstown', 33.1152801513672, 0.577970671361684, -87.2197189331055, -1.52227126804673, 218, 2, 'PPL', 'P'),
(9779, 'Johnstown', 35.5783309936523, 0.620959018203579, -91.1624984741211, -1.59108575271772, 218, 4, 'PPL', 'P'),
(16653, 'Johnstown', 30.0441703796387, 0.52436969415485, -82.272216796875, -1.43592106602005, 218, 12, 'PPL', 'P'),
(27573, 'Johnstown', 39.3633308410645, 0.687019727728403, -88.2869415283203, -1.5408978161849, 218, 18, 'PPL', 'P'),
(30223, 'Johnstown', 38.7644386291504, 0.676567086765951, -87.3233337402344, -1.52407968758494, 218, 19, 'PPL', 'P'),
(32882, 'Johnstown', 38.4927787780762, 0.671825727919229, -97.6752777099609, -1.70475519383865, 218, 20, 'PPL', 'P'),
(48538, 'Johnstown', 38.3288917541504, 0.668965359750429, -76.4638900756836, -1.33454664070369, 218, 25, 'PPL', 'P'),
(55606, 'Johnstown', 39.9033317565918, 0.696444521668139, -92.9741668701172, -1.62270533118218, 218, 29, 'PPL', 'P'),
(65986, 'Johnstown', 35.4474983215332, 0.618675557305918, -81.3638916015625, -1.42006780068303, 218, 33, 'PPL', 'P'),
(81800, 'Johnstown', 33.4927787780762, 0.584559265319512, -81.8763885498047, -1.42901255983628, 218, 48, 'PPL', 'P'),
(88199, 'Johnstown', 35.3472213745117, 0.616925394416545, -86.2011108398438, -1.50449320303185, 218, 50, 'PPL', 'P'),
(109873, 'Johnstown', 37.7819404602051, 0.65941925882304, -81.1686096191406, -1.41665948711994, 218, 58, 'PPL', 'P'),
(140293, 'Johnstown', 48.1441688537598, 0.840274262134212, -97.4697189331055, -1.70116751637615, 218, 34, 'PPL', 'P'),
(149927, 'Johnstown', 43.0066719055176, 0.750608025076225, -74.3680572509766, -1.29796745734118, 218, 40, 'PPL', 'P'),
(155936, 'Johnstown', 40.1536102294922, 0.700812705067115, -82.6852798461914, -1.44313037624895, 218, 41, 'PPL', 'P'),
(163174, 'Johnstown', 40.939998626709, 0.714537771798029, -77.0530624389648, -1.34482963830471, 218, 45, 'PPL', 'P'),
(174705, 'Johnstown', 42.7000007629395, 0.745255603917384, -88.8061065673828, -1.54995895547779, 218, 57, 'PPL', 'P'),
(182392, 'Johnstown', 32.8380584716797, 0.573132240293228, -116.89582824707, -2.04021708475717, 218, 6, 'PPL', 'P'),
(194261, 'Johnstown', 40.3369407653809, 0.704012426537818, -104.911666870117, -1.831054010639, 218, 7, 'PPL', 'P'),
(199435, 'Johnstown', 42.5716705322266, 0.7430158188616, -100.057777404785, -1.74633765794109, 218, 35, 'PPL', 'P'),
(209536, 'Johnstown', 43.1183280944824, 0.752556793203891, -108.700828552246, -1.89718735788256, 218, 59, 'PPL', 'P'),
(196794, 'Johnstown (historical)', 47.5027809143066, 0.829079930808173, -111.316673278809, -1.942842461082, 218, 31, 'PPL', 'P'),
(174706, 'Johnstown Center', 42.6958312988281, 0.745182833040598, -88.8394393920898, -1.55054072301792, 218, 57, 'PPL', 'P'),
(95198, 'Johnsue', 29.7858295440674, 0.519860795981777, -95.8763885498047, -1.67335865511548, 218, 51, 'PPL', 'P'),
(9780, 'Johnsville', 33.3730583190918, 0.582469749128236, -92.0158309936523, -1.60597921479788, 218, 4, 'PPL', 'P'),
(36641, 'Johnsville', 38.7533302307129, 0.676373208638594, -84.1483306884766, -1.4686654305709, 218, 21, 'PPL', 'P'),
(48540, 'Johnsville', 39.5338897705078, 0.689996542615867, -77.2311096191406, -1.34793714782267, 218, 25, 'PPL', 'P'),
(60441, 'Johnsville', 31.5502796173096, 0.550656259246909, -91.3491668701172, -1.59434373083727, 218, 30, 'PPL', 'P'),
(73072, 'Johnsville', 39.7452812194824, 0.693686019411035, -84.4236068725586, -1.47346990633546, 218, 41, 'PPL', 'P'),
(81801, 'Johnsville', 33.127498626709, 0.578183923985972, -80.779167175293, -1.40986243422779, 218, 48, 'PPL', 'P'),
(95199, 'Johnsville', 32.1458282470703, 0.561050543691974, -98.0258331298828, -1.71087354012699, 218, 51, 'PPL', 'P'),
(136153, 'Johnsville', 45.1972198486328, 0.788840299106376, -93.2341690063477, -1.62724322452162, 218, 28, 'PPL', 'P'),
(163176, 'Johnsville', 40.1908302307129, 0.701462316636012, -75.0688934326172, -1.31019935622792, 218, 45, 'PPL', 'P'),
(182393, 'Johnsville', 39.7608299255371, 0.693957395526114, -120.694442749023, -2.10651541483026, 218, 6, 'PPL', 'P'),
(131508, 'Johnswood', 45.9508285522461, 0.801993252256114, -83.6222229003906, -1.45948311744842, 218, 27, 'PPL', 'P'),
(88200, 'Johntown', 36.3644409179688, 0.634679224665504, -86.0736083984375, -1.50226786562498, 218, 50, 'PPL', 'P'),
(95200, 'Johntown', 33.422779083252, 0.583337540169439, -95.1694412231445, -1.66102009662709, 218, 51, 'PPL', 'P'),
(22282, 'Johntown (historical)', 34.5258293151855, 0.602589398531567, -84.2522201538086, -1.47047864379908, 218, 13, 'PPL', 'P'),
(190354, 'Johntown (historical)', 39.2511100769043, 0.685061105904705, -119.622779846191, -2.08781136870436, 218, 39, 'PPL', 'P'),
(116263, 'Joice', 43.3627815246582, 0.756823310428252, -93.45361328125, -1.63107324964331, 218, 16, 'PPL', 'P'),
(9781, 'Joiner', 35.5077781677246, 0.619727639094554, -90.1469421386719, -1.57336095092464, 218, 4, 'PPL', 'P'),
(95201, 'Joiner', 29.8886108398438, 0.521654668002541, -96.790283203125, -1.68930912583229, 218, 51, 'PPL', 'P'),
(3443, 'Joinertown', 33.2277793884277, 0.579934153454372, -86.6827774047852, -1.51289987048685, 218, 2, 'PPL', 'P'),
(95208, 'Joinerville', 32.1777801513672, 0.561608209624237, -94.9005584716797, -1.65632720731221, 218, 51, 'PPL', 'P'),
(109874, 'Joker', 38.9058303833008, 0.679034838411046, -81.1697235107422, -1.4166789281959, 218, 58, 'PPL', 'P'),
(95202, 'Joliet', 29.7691707611084, 0.519570045369768, -97.6788864135742, -1.70481817759843, 218, 51, 'PPL', 'P'),
(120159, 'Joliet', 41.5250015258789, 0.724747998522256, -88.081672668457, -1.53731519872848, 218, 18, 'PPL', 'P'),
(196795, 'Joliet', 45.485279083252, 0.793867881191255, -108.969718933105, -1.90188038035549, 218, 31, 'PPL', 'P'),
(163177, 'Joliett', 40.6119384765625, 0.708812042033386, -76.4538879394531, -1.33437207049424, 218, 45, 'PPL', 'P'),
(140295, 'Joliette', 48.8180618286133, 0.852035913351465, -97.2272186279297, -1.69693508761374, 218, 34, 'PPL', 'P'),
(122935, 'Jolietville', 40.0419387817383, 0.69886367062334, -86.2311096191406, -1.50501678050216, 218, 19, 'PPL', 'P'),
(103209, 'Jolivue', 38.1097183227539, 0.665140061739667, -79.0733337402344, -1.38009002429541, 218, 53, 'PPL', 'P'),
(163178, 'Joller', 40.2038917541504, 0.701690283225323, -78.0669403076172, -1.36252514532579, 218, 45, 'PPL', 'P'),
(103211, 'Jollett', 38.4638900756836, 0.67132152494585, -78.524169921875, -1.37050530753222, 218, 53, 'PPL', 'P'),
(116264, 'Jolley', 42.478889465332, 0.741396483760778, -94.7186126708984, -1.6531516540284, 218, 16, 'PPL', 'P'),
(195159, 'Jolley', 43.8422203063965, 0.765191095731336, -111.777221679688, -1.95088054704213, 218, 17, 'PPL', 'P'),
(30224, 'Jolleyville', 38.9941711425781, 0.680576675524147, -85.3594436645508, -1.48980333961703, 218, 19, 'PPL', 'P'),
(103210, 'Jolliff', 36.8105583190918, 0.642465442165541, -76.4358291625977, -1.33405688537923, 218, 53, 'PPL', 'P'),
(22283, 'Jolly', 33.1222190856934, 0.578091778612255, -84.3899993896484, -1.47288334510537, 218, 13, 'PPL', 'P'),
(36643, 'Jolly', 37.4705581665039, 0.653984612565543, -87.7052764892578, -1.53074584610952, 218, 21, 'PPL', 'P'),
(55609, 'Jolly', 36.8958282470703, 0.643953683161705, -94.0699996948242, -1.64183122202474, 218, 29, 'PPL', 'P'),
(60442, 'Jolly', 33.9430618286133, 0.592418187117309, -88.790283203125, -1.54968278567275, 218, 30, 'PPL', 'P'),
(95203, 'Jolly', 33.8638916015625, 0.591036405985721, -98.3491668701172, -1.71651677847687, 218, 51, 'PPL', 'P'),
(16654, 'Jolly Corner', 28.0038890838623, 0.488760067876696, -82.290283203125, -1.43623638429312, 218, 12, 'PPL', 'P'),
(202260, 'Jolly Dump', 44.5936088562012, 0.778305299887213, -103.867500305176, -1.81282986614153, 218, 49, 'PPL', 'P'),
(78532, 'Jollytown', 39.728328704834, 0.693390142213927, -80.3219375610352, -1.40188227202137, 218, 45, 'PPL', 'P'),
(76237, 'Jollyville', 34.4605598449707, 0.601450231375285, -97.129997253418, -1.69523825452519, 218, 42, 'PPL', 'P'),
(95204, 'Jollyville', 30.4424991607666, 0.531321842890988, -97.7747192382813, -1.70649077592105, 218, 51, 'PPL', 'P'),
(109875, 'Jolo', 37.3291702270508, 0.651516927499475, -81.8150024414063, -1.42794117012974, 218, 58, 'PPL', 'P'),
(182395, 'Jolon', 35.9708290100098, 0.627809400896563, -121.175003051758, -2.11490277436735, 218, 6, 'PPL', 'P'),
(48541, 'Jomar Acres', 38.7236099243164, 0.675854491437274, -76.9800033569336, -1.34355451677478, 218, 25, 'PPL', 'P'),
(3444, 'Jon', 32.8938903808594, 0.574106690936088, -86.0311126708984, -1.50152617526139, 218, 2, 'PPL', 'P'),
(76238, 'Jonah', 36.4444389343262, 0.636075453446005, -97.9486083984375, -1.7095257142993, 218, 42, 'PPL', 'P'),
(95205, 'Jonah', 30.6377792358398, 0.534730123164558, -97.5405578613281, -1.70240388891221, 218, 51, 'PPL', 'P'),
(36644, 'Jonancy', 37.3163909912109, 0.651293887758181, -82.5830612182617, -1.44134632463471, 218, 21, 'PPL', 'P'),
(163179, 'Jonas', 40.9674987792969, 0.715017740005488, -75.5122222900391, -1.31793690445903, 218, 45, 'PPL', 'P'),
(65990, 'Jonas Ridge', 35.9724998474121, 0.627838562510499, -81.8949966430664, -1.42933733233121, 218, 33, 'PPL', 'P'),
(182396, 'Jonata Park', 34.6511116027832, 0.604775986944576, -120.183326721191, -2.09759475728487, 218, 6, 'PPL', 'P'),
(60443, 'Jonathan', 31.2224998474121, 0.544935423040768, -88.6374969482422, -1.54701616247325, 218, 30, 'PPL', 'P'),
(65989, 'Jonathan', 35.5675010681152, 0.620770000345211, -83.0180587768555, -1.4489384642703, 218, 33, 'PPL', 'P'),
(136154, 'Jonathan', 44.8002815246582, 0.781912418425671, -93.6005630493164, -1.63363800693111, 218, 28, 'PPL', 'P'),
(193149, 'Jonathan', 44.2675018310547, 0.772613658584523, -117.05249786377, -2.04295148540641, 218, 17, 'PPL', 'P'),
(48542, 'Jonathans Delight', 39.4855613708496, 0.689153052919611, -76.7069396972656, -1.33878865684603, 218, 25, 'PPL', 'P'),
(109876, 'Jonben', 37.6561088562012, 0.657223083030106, -81.1922225952148, -1.41707161129863, 218, 58, 'PPL', 'P'),
(55608, 'Jonca', 37.8372192382813, 0.660384055506949, -90.2988891601563, -1.57601292673814, 218, 29, 'PPL', 'P'),
(3445, 'Jones', 32.5838890075684, 0.568696146286455, -86.8974990844727, -1.51664747077281, 218, 2, 'PPL', 'P'),
(22284, 'Jones', 31.6336097717285, 0.552110644807714, -81.4802780151367, -1.42209912680449, 218, 13, 'PPL', 'P'),
(27575, 'Jones', 39.4524993896484, 0.688576012490419, -88.3358306884766, -1.54175109299817, 218, 18, 'PPL', 'P'),
(41546, 'Jones', 32.9674987792969, 0.575391399845942, -91.648063659668, -1.59956046393857, 218, 22, 'PPL', 'P'),
(48544, 'Jones', 39.6597213745117, 0.692192718408801, -77.3536071777344, -1.35007513354578, 218, 25, 'PPL', 'P'),
(65992, 'Jones', 36.4291687011719, 0.635808937599916, -79.4302825927734, -1.38631995703343, 218, 33, 'PPL', 'P'),
(76239, 'Jones', 35.5658302307129, 0.620740838731274, -97.2866668701172, -1.69797265517443, 218, 42, 'PPL', 'P'),
(88201, 'Jones', 35.6722183227539, 0.622597661222305, -89.1413879394531, -1.55581071934102, 218, 50, 'PPL', 'P'),
(95206, 'Jones', 32.6083297729492, 0.569122718114059, -95.6741714477539, -1.66982930088086, 218, 51, 'PPL', 'P'),
(103214, 'Jones', 36.728889465332, 0.641040051771104, -79.0302810668945, -1.37933861339385, 218, 53, 'PPL', 'P'),
(109877, 'Jones', 39.0583305358887, 0.681696468183499, -79.9911117553711, -1.39610827246197, 218, 58, 'PPL', 'P'),
(131509, 'Jones', 41.9025001525879, 0.731336592480085, -85.7994384765625, -1.49748269777832, 218, 27, 'PPL', 'P'),
(155937, 'Jones', 40.2744407653809, 0.702921595755321, -83.0147171020508, -1.44888014104243, 218, 41, 'PPL', 'P'),
(65993, 'Jones (historical)', 36.0152816772461, 0.62858524630113, -81.5111083984375, -1.42263721850274, 218, 33, 'PPL', 'P'),
(73073, 'Jones (historical)', 39.3291702270508, 0.686423512539362, -84.503059387207, -1.47485661431506, 218, 41, 'PPL', 'P'),
(81802, 'Jones (historical)', 34.3791694641113, 0.600029701249837, -82.2261123657227, -1.43511639189668, 218, 48, 'PPL', 'P'),
(95207, 'Jones Addition Colonia', 26.2310009002686, 0.457817331803283, -97.5800018310547, -1.703092316054, 218, 51, 'PPL', 'P'),
(182397, 'Jones Bar (historical)', 39.2938919067383, 0.685807789695336, -121.108612060547, -2.11374403297706, 218, 6, 'PPL', 'P'),
(149931, 'Jones Beach', 43.374439239502, 0.757026775935534, -78.1483306884766, -1.36394567545124, 218, 40, 'PPL', 'P'),
(22286, 'Jones Bridge Landing', 33.9936103820801, 0.593300425807425, -84.2180633544922, -1.46988249518907, 218, 13, 'PPL', 'P'),
(3446, 'Jones Chapel', 34.2102813720703, 0.59708204797631, -87.0519409179688, -1.51934298927013, 218, 2, 'PPL', 'P'),
(60444, 'Jones Chapel', 33.3566703796387, 0.582183725627162, -90.9111099243164, -1.58669819482181, 218, 30, 'PPL', 'P'),
(88202, 'Jones Chapel (historical)', 35.8822212219238, 0.626262903251554, -86.0736083984375, -1.50226786562498, 218, 50, 'PPL', 'P'),
(155938, 'Jones City', 40.8813896179199, 0.713514851623329, -84.1816711425781, -1.46924733126909, 218, 41, 'PPL', 'P'),
(188749, 'Jones City', 32.4705581665039, 0.566718149965826, -103.125282287598, -1.79987571796717, 218, 38, 'PPL', 'P'),
(16657, 'Jones Corner', 28.0330600738525, 0.489269197698092, -81.8144378662109, -1.4279313164337, 218, 12, 'PPL', 'P'),
(65995, 'Jones Corner', 35.0586090087891, 0.611888158372715, -77.2044372558594, -1.34747162726412, 218, 33, 'PPL', 'P'),
(73074, 'Jones Corner', 38.8197212219238, 0.677531950028887, -83.2925033569336, -1.45372842580692, 218, 41, 'PPL', 'P'),
(103216, 'Jones Corner', 37.8650016784668, 0.660868950562425, -77.692497253418, -1.35598988116879, 218, 53, 'PPL', 'P'),
(127835, 'Jones Corner', 44.3644409179688, 0.77430556482505, -69.3986129760742, -1.21123429274976, 218, 26, 'PPL', 'P'),
(144010, 'Jones Corner', 42.7372207641602, 0.745905215486282, -72.0227813720703, -1.25703467138667, 218, 36, 'PPL', 'P'),
(182398, 'Jones Corner', 36.0658302307129, 0.629467484991246, -119.106109619141, -2.07879377209529, 218, 6, 'PPL', 'P'),
(149933, 'Jones Corners', 43.458610534668, 0.758495842171849, -76.3836135864258, -1.3331455516542, 218, 40, 'PPL', 'P'),
(88203, 'Jones Cove', 35.8294410705566, 0.625341715830495, -83.3263931274414, -1.45431991388503, 218, 50, 'PPL', 'P'),
(22288, 'Jones Creek', 34.8447189331055, 0.608155072314696, -84.1069412231445, -1.46794304812522, 218, 13, 'PPL', 'P'),
(41547, 'Jones Creek', 30.4125003814697, 0.530798265420678, -91.0147171020508, -1.58850648120198, 218, 22, 'PPL', 'P'),
(95211, 'Jones Creek', 29.2866706848145, 0.511148830397315, -96.3125, -1.68097023582704, 218, 51, 'PPL', 'P'),
(103217, 'Jones Creek', 36.7058296203613, 0.640637581551365, -79.8769378662109, -1.39411556217631, 218, 53, 'PPL', 'P'),
(65997, 'Jones Creek (historical)', 34.8574981689453, 0.60837811205599, -80.0941696166992, -1.39790697146221, 218, 33, 'PPL', 'P'),
(22289, 'Jones Crossing', 31.6413898468018, 0.552246432733795, -84.9722213745117, -1.48304503571873, 218, 13, 'PPL', 'P'),
(60446, 'Jones Crossing', 33.1194381713867, 0.578043242501388, -90.1361083984375, -1.57317186648725, 218, 30, 'PPL', 'P'),
(109878, 'Jones Crossing', 38.898609161377, 0.678908804312458, -81.6286087036133, -1.42468798570015, 218, 58, 'PPL', 'P'),
(149934, 'Jones Crossing', 42.628059387207, 0.743999990042439, -75.0541687011719, -1.30994236118273, 218, 40, 'PPL', 'P'),
(178425, 'Jones Crossing', 34.5297203063965, 0.602657309139364, -111.283058166504, -1.94225576669386, 218, 5, 'PPL', 'P'),
(195160, 'Jones Crossing', 44.0869407653809, 0.769462273487605, -112.218612670898, -1.95858427312741, 218, 17, 'PPL', 'P'),
(3448, 'Jones Crossroads', 34.7180595397949, 0.605944448872849, -87.0016708374023, -1.518465610849, 218, 2, 'PPL', 'P'),
(14032, 'Jones Crossroads', 38.6044387817383, 0.673774562625922, -75.4472198486328, -1.31680239783466, 218, 10, 'PPL', 'P'),
(22291, 'Jones Crossroads', 32.8694381713867, 0.573679919371403, -85.0347213745117, -1.48413586650123, 218, 13, 'PPL', 'P'),
(81807, 'Jones Crossroads', 33.9680595397949, 0.592854479482891, -81.6536102294922, -1.42512434464476, 218, 48, 'PPL', 'P'),
(73075, 'Jones Farm', 39.2463912963867, 0.684978747647994, -84.3394393920898, -1.47200090667817, 218, 41, 'PPL', 'P'),
(22296, 'Jones Heights', 34.2333297729492, 0.597484318458967, -84.8625030517578, -1.48113008973691, 218, 13, 'PPL', 'P'),
(22292, 'Jones Hill Estates', 33.3638916015625, 0.58230975972575, -84.4833297729492, -1.47451226758612, 218, 13, 'PPL', 'P'),
(16658, 'Jones Landing', 28.7041702270508, 0.500982279514964, -81.2063903808594, -1.41731888580585, 218, 12, 'PPL', 'P'),
(41548, 'Jones Landing', 31.8824996948242, 0.55645459344077, -91.7783279418945, -1.60183400456117, 218, 22, 'PPL', 'P'),
(3449, 'Jones Mill', 32.750560760498, 0.571605117145149, -85.559440612793, -1.49329394485779, 218, 2, 'PPL', 'P'),
(36649, 'Jones Mill', 36.6566696166992, 0.639779577627169, -85.1047210693359, -1.4853575916513, 218, 21, 'PPL', 'P'),
(60447, 'Jones Mill', 30.3977794647217, 0.530541336954513, -89.184440612793, -1.55656213024259, 218, 30, 'PPL', 'P'),
(65998, 'Jones Mill', 35.1097183227539, 0.612780184179837, -83.9055633544922, -1.46442834127659, 218, 33, 'PPL', 'P'),
(70992, 'Jones Mill', 39.3211097717285, 0.686282831054779, -74.9413909912109, -1.30797401882105, 218, 37, 'PPL', 'P'),
(88204, 'Jones Mill', 36.4463882446289, 0.636109475328931, -88.460563659668, -1.54392809403125, 218, 50, 'PPL', 'P'),
(103218, 'Jones Mill', 36.7636108398438, 0.641646054077151, -79.4655609130859, -1.38693567987746, 218, 53, 'PPL', 'P'),
(127836, 'Jones Mill', 47.1005592346191, 0.822059838174724, -68.8477783203125, -1.20162041437262, 218, 26, 'PPL', 'P'),
(22294, 'Jones Mill (historical)', 34.774169921875, 0.606923759784698, -84.4491729736328, -1.4739161189761, 218, 13, 'PPL', 'P'),
(9782, 'Jones Mills', 34.4375, 0.601047761155547, -92.8874969482422, -1.62119265568301, 218, 4, 'PPL', 'P'),
(144011, 'Jones Mills', 43.3944396972656, 0.757375849775417, -71.4147186279297, -1.2464219744427, 218, 36, 'PPL', 'P'),
(163180, 'Jones Mills', 40.0886116027832, 0.699678265021768, -79.3408279418945, -1.38475867884438, 218, 45, 'PPL', 'P'),
(22295, 'Jones Mobile Home Park', 33.9244384765625, 0.592093148306265, -84.1780624389648, -1.4691843475093, 218, 13, 'PPL', 'P'),
(182399, 'Jones Place', 38.8497200012207, 0.678055527499197, -120.369438171387, -2.10084301486644, 218, 6, 'PPL', 'P'),
(149936, 'Jones Point', 41.2861099243164, 0.720578553519628, -73.9563903808594, -1.29078251503626, 218, 40, 'PPL', 'P'),
(95212, 'Jones Prairie', 30.9627799987793, 0.540402456549345, -96.834716796875, -1.69008463834173, 218, 51, 'PPL', 'P'),
(27581, 'Jones Ridge', 37.8002815246582, 0.659739370786068, -89.6252822875977, -1.56425626894793, 218, 18, 'PPL', 'P'),
(22297, 'Jones Road Subdivision', 32.7277793884277, 0.5712075071944, -83.7163925170898, -1.46112668731516, 218, 13, 'PPL', 'P'),
(22298, 'Jones Settlement', 32.9836082458496, 0.575672563078027, -84.4711074829102, -1.4742989483828, 218, 13, 'PPL', 'P'),
(116266, 'Jones Siding', 42.6800003051758, 0.744906530077502, -94.2077789306641, -1.64423592333103, 218, 16, 'PPL', 'P'),
(109879, 'Jones Springs', 39.4913902282715, 0.689254785673252, -78.0955581665039, -1.36302462118824, 218, 58, 'PPL', 'P'),
(22299, 'Jones Spur', 31.4266700744629, 0.548498865737349, -84.6350021362305, -1.47715944970966, 218, 13, 'PPL', 'P'),
(65999, 'Jones Store', 35.309440612793, 0.616265995730642, -76.9544372558594, -1.34310830413414, 218, 33, 'PPL', 'P'),
(3450, 'Jones Valley', 33.4650001525879, 0.584074436843063, -86.8788909912109, -1.51632269827787, 218, 2, 'PPL', 'P'),
(48545, 'Jones Valley', 39.3830604553223, 0.687364074457351, -76.6650009155273, -1.33805668702042, 218, 25, 'PPL', 'P'),
(88205, 'Jones Valley', 35.7597198486328, 0.624124850949411, -87.2536087036133, -1.52286275612483, 218, 50, 'PPL', 'P'),
(3451, 'Jones Valley Estates', 34.6833305358887, 0.605338313408747, -86.5577774047852, -1.51071820892185, 218, 2, 'PPL', 'P'),
(48546, 'Jones View', 38.5627784729004, 0.673047453069303, -77.1263885498047, -1.34610942036655, 218, 25, 'PPL', 'P'),
(127837, 'Jones Wharf', 43.6558303833008, 0.761937977880777, -70.2002792358398, -1.22522600848481, 218, 26, 'PPL', 'P'),
(3453, 'Jonesboro', 33.3819389343262, 0.582624745103679, -86.9619369506836, -1.51777212370115, 218, 2, 'PPL', 'P'),
(9787, 'Jonesboro', 35.8422203063965, 0.625564755571789, -90.7041702270508, -1.58308641575145, 218, 4, 'PPL', 'P'),
(16659, 'Jonesboro', 29.7108306884766, 0.51855181901649, -83.2972183227539, -1.4538107174846, 218, 12, 'PPL', 'P'),
(22300, 'Jonesboro', 33.5213890075684, 0.585058608023902, -84.353889465332, -1.4722531080334, 218, 13, 'PPL', 'P'),
(27576, 'Jonesboro', 37.4516716003418, 0.653654979801618, -89.2680587768555, -1.55802154251995, 218, 18, 'PPL', 'P'),
(41549, 'Jonesboro', 32.2411117553711, 0.562713554634674, -92.7158279418945, -1.61819646629862, 218, 22, 'PPL', 'P'),
(73077, 'Jonesboro', 39.5299987792969, 0.68992863200807, -83.4794387817383, -1.45699106445838, 218, 41, 'PPL', 'P'),
(103224, 'Jonesboro', 37.7833290100098, 0.65944349358896, -78.9786071777344, -1.37843673389069, 218, 53, 'PPL', 'P'),
(112594, 'Jonesboro', 31.6144409179688, 0.551776085195773, -97.8763885498047, -1.70826524015537, 218, 51, 'PPL', 'P'),
(122936, 'Jonesboro', 40.4797210693359, 0.706504412948832, -85.6277770996094, -1.49448664155198, 218, 19, 'PPL', 'P'),
(127838, 'Jonesboro', 44.6624984741211, 0.779507650540357, -67.5730590820313, -1.1793723666261, 218, 26, 'PPL', 'P'),
(88206, 'Jonesboro (historical)', 35.5263900756836, 0.620052478168516, -87.2108306884766, -1.52211613891323, 218, 50, 'PPL', 'P'),
(103219, 'Jonesboro (historical)', 36.9797210693359, 0.64541788912903, -77.960563659668, -1.36066852257185, 218, 53, 'PPL', 'P'),
(66000, 'Jonesboro Crossing', 34.3216705322266, 0.599026155572068, -78.623893737793, -1.37224581646264, 218, 33, 'PPL', 'P'),
(66001, 'Jonesboro Heights', 35.4566688537598, 0.618835613287432, -79.1522216796875, -1.38146687857898, 218, 33, 'PPL', 'P'),
(9788, 'Jonesboro Junction', 35.8786087036133, 0.626199852912746, -90.5988922119141, -1.58124896775735, 218, 4, 'PPL', 'P'),
(88207, 'Jonesborough', 36.2941703796387, 0.633452772404495, -82.4736099243164, -1.43943603918479, 218, 50, 'PPL', 'P'),
(36645, 'Jonesburg', 37.7208290100098, 0.658352662806464, -87.7441711425781, -1.53142468587138, 218, 21, 'PPL', 'P'),
(41550, 'Jonesburg', 32.5250015258789, 0.567668365842767, -91.7566680908203, -1.60145596884443, 218, 22, 'PPL', 'P'),
(55610, 'Jonesburg', 38.853328704834, 0.678118511258977, -91.3058319091797, -1.59358739308769, 218, 29, 'PPL', 'P'),
(32883, 'Jonesburg (historical)', 37.0041694641113, 0.645844594114688, -96.1041717529297, -1.67733422199075, 218, 20, 'PPL', 'P'),
(174709, 'Jonesdale', 42.8988914489746, 0.748726901240248, -90.0133285522461, -1.57102895391612, 218, 57, 'PPL', 'P'),
(9790, 'Jonesdale (historical)', 36.0569381713867, 0.629312289278722, -92.3466720581055, -1.61175348067339, 218, 4, 'PPL', 'P'),
(127840, 'Jonesport', 44.5327796936035, 0.777243630718653, -67.5988922119141, -1.17982323979865, 218, 26, 'PPL', 'P'),
(22301, 'Jonestown', 34.9872207641602, 0.610642198456721, -84.3880615234375, -1.47284952295953, 218, 13, 'PPL', 'P'),
(30229, 'Jonestown', 39.709171295166, 0.693055782339068, -87.5038909912109, -1.52723100610284, 218, 19, 'PPL', 'P'),
(36646, 'Jonestown', 37.9769401550293, 0.662822645538107, -84.4966735839844, -1.47474516102344, 218, 21, 'PPL', 'P'),
(48549, 'Jonestown', 38.2561111450195, 0.667695098489489, -76.4391708374023, -1.3341152086071, 218, 25, 'PPL', 'P'),
(60452, 'Jonestown', 32.8416709899902, 0.573195290632035, -90.4305572509766, -1.57831096844277, 218, 30, 'PPL', 'P'),
(66003, 'Jonestown', 35.0838890075684, 0.612329377586314, -77.6427764892578, -1.35512209012759, 218, 33, 'PPL', 'P'),
(81809, 'Jonestown', 33.9463882446289, 0.592476244029073, -79.2411117553711, -1.38301830307201, 218, 48, 'PPL', 'P'),
(88208, 'Jonestown', 35.394718170166, 0.61775436988486, -87.2127838134766, -1.52215022737518, 218, 50, 'PPL', 'P'),
(95213, 'Jonestown', 30.4952793121338, 0.532243030312046, -97.9230575561523, -1.70907976797477, 218, 51, 'PPL', 'P'),
(103220, 'Jonestown', 37.8891716003418, 0.661290795279093, -79.2675018310547, -1.38347889678254, 218, 53, 'PPL', 'P'),
(155939, 'Jonestown', 40.7713890075684, 0.711594978793491, -84.5141677856445, -1.47505049244242, 218, 41, 'PPL', 'P'),
(163185, 'Jonestown', 40.1294403076172, 0.700390860350446, -79.9738922119141, -1.39580773473295, 218, 45, 'PPL', 'P'),
(88209, 'Jonestown (historical)', 35.8833312988281, 0.626282277748484, -82.970832824707, -1.44811421591292, 218, 50, 'PPL', 'P'),
(3454, 'Jonesview', 33.4422187805176, 0.583676826892315, -86.2238922119141, -1.5048908129826, 218, 2, 'PPL', 'P'),
(3455, 'Jonesville', 31.8930606842041, 0.556638917477717, -85.904167175293, -1.4993105583925, 218, 2, 'PPL', 'P'),
(9791, 'Jonesville', 33.2255592346191, 0.579895404460511, -93.9375, -1.63951866609217, 218, 4, 'PPL', 'P'),
(16660, 'Jonesville', 29.6538906097412, 0.517558027166213, -82.5233306884766, -1.440303830226, 218, 12, 'PPL', 'P'),
(22302, 'Jonesville', 33.560001373291, 0.585732520937747, -85.2316665649414, -1.48757320852019, 218, 13, 'PPL', 'P'),
(30225, 'Jonesville', 39.0605583190918, 0.681735350335414, -85.8897171020508, -1.49905835703727, 218, 19, 'PPL', 'P'),
(36648, 'Jonesville', 37.3877792358398, 0.652539847674175, -85.7683334350586, -1.49693981239011, 218, 21, 'PPL', 'P'),
(41551, 'Jonesville', 31.6263904571533, 0.55198464399864, -91.8180618286133, -1.60252749170903, 218, 22, 'PPL', 'P'),
(48550, 'Jonesville', 39.1575012207031, 0.683427323154968, -77.3974990844727, -1.35084119183334, 218, 25, 'PPL', 'P'),
(66004, 'Jonesville', 36.2391700744629, 0.632492835989576, -80.8447189331055, -1.41100652823209, 218, 33, 'PPL', 'P'),
(81811, 'Jonesville', 34.8358306884766, 0.607999943181199, -81.6811065673828, -1.42560424627319, 218, 48, 'PPL', 'P'),
(88211, 'Jonesville', 35.9830589294434, 0.628022853257933, -84.3913879394531, -1.47290757987129, 218, 50, 'PPL', 'P'),
(95214, 'Jonesville', 32.4977798461914, 0.567193257904296, -94.1108322143555, -1.64254388393245, 218, 51, 'PPL', 'P'),
(103221, 'Jonesville', 36.6888885498047, 0.640341904091339, -83.1111068725586, -1.45056245990303, 218, 53, 'PPL', 'P'),
(120161, 'Jonesville', 42.3250007629395, 0.738710619222405, -89.0774993896484, -1.5546956537926, 218, 18, 'PPL', 'P'),
(131511, 'Jonesville', 41.9841690063477, 0.732761982874523, -84.6619415283203, -1.47762963080011, 218, 27, 'PPL', 'P'),
(149937, 'Jonesville', 42.9099998474121, 0.748920779367606, -73.8241729736328, -1.28847488595171, 218, 40, 'PPL', 'P'),
(163187, 'Jonesville', 40.8519401550293, 0.713000861532944, -75.541389465332, -1.3184459677014, 218, 45, 'PPL', 'P'),
(172169, 'Jonesville', 44.3838882446289, 0.774644984705981, -72.9380569458008, -1.27300924371134, 218, 55, 'PPL', 'P'),
(193686, 'Jonesville', 40.1124992370605, 0.70009518289042, -121.466110229492, -2.119983553095, 218, 6, 'PPL', 'P'),
(211898, 'Jonesville', 61.7305603027344, 1.07740152638362, -148.934722900391, -2.59940128515722, 218, 1, 'PPL', 'P'),
(103222, 'Jonesville Camp Ground', 36.6816711425781, 0.640215936571779, -83.1438903808594, -1.45113464006324, 218, 53, 'PPL', 'P'),
(88212, 'Joneswood', 35.9336090087891, 0.627159789327665, -86.4475021362305, -1.50879354240205, 218, 50, 'PPL', 'P'),
(3457, 'Jonny Smith Subdivision', 33.5166702270508, 0.584976249767192, -86.2502822875977, -1.50535140669313, 218, 2, 'PPL', 'P'),
(9792, 'Jonquil', 35.0819396972656, 0.612295355703388, -90.4541702270508, -1.57872309262146, 218, 4, 'PPL', 'P'),
(9793, 'Joplin', 34.5422210693359, 0.602875488611669, -93.4524993896484, -1.63105380856736, 218, 4, 'PPL', 'P'),
(55611, 'Joplin', 37.084171295166, 0.647240889474217, -94.5130615234375, -1.64956410972395, 218, 29, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(95215, 'Joplin', 33.0936088562012, 0.577592435907865, -97.9944381713867, -1.71032559473271, 218, 51, 'PPL', 'P'),
(103225, 'Joplin', 38.5608291625977, 0.673013431186377, -77.3852767944336, -1.35062787263003, 218, 53, 'PPL', 'P'),
(109880, 'Joplin', 38.3430595397949, 0.669212634257643, -81.6805572509766, -1.42559465889327, 218, 58, 'PPL', 'P'),
(196796, 'Joplin', 48.5608291625977, 0.84754635638581, -110.771667480469, -1.93333031545851, 218, 31, 'PPL', 'P'),
(60453, 'Joplin (historical)', 33.0311088562012, 0.576501605125369, -89.4652786254883, -1.56146367822888, 218, 30, 'PPL', 'P'),
(66005, 'Joplor', 35.3683280944824, 0.61729377617433, -80.8227767944336, -1.41062356566733, 218, 33, 'PPL', 'P'),
(3458, 'Joppa', 34.297779083252, 0.598609171124389, -86.5561065673828, -1.51068904730792, 218, 2, 'PPL', 'P'),
(27579, 'Joppa', 37.2063903808594, 0.649374014928343, -88.8447189331055, -1.55063286839163, 218, 18, 'PPL', 'P'),
(30226, 'Joppa', 39.6322212219238, 0.691712750201341, -86.4322204589844, -1.50852682681888, 218, 19, 'PPL', 'P'),
(36650, 'Joppa', 37.0516700744629, 0.64667363616203, -85.2422180175781, -1.48775736610957, 218, 21, 'PPL', 'P'),
(48551, 'Joppa', 39.4336090087891, 0.688246313147467, -76.3580627441406, -1.33269960532967, 218, 25, 'PPL', 'P'),
(66006, 'Joppa', 36.3549995422363, 0.634514441573055, -76.5602798461914, -1.3362289595643, 218, 33, 'PPL', 'P'),
(88214, 'Joppa', 35.8230590820313, 0.625230329117903, -85.6361083984375, -1.4946320501475, 218, 50, 'PPL', 'P'),
(95216, 'Joppa', 30.8252792358398, 0.538002615512047, -98.0313873291016, -1.71097047919067, 218, 51, 'PPL', 'P'),
(109882, 'Joppa', 38.7786102294922, 0.676814427852193, -80.4883270263672, -1.40478631603204, 218, 58, 'PPL', 'P'),
(125160, 'Joppa', 42.8055610656738, 0.747097978759501, -70.8583297729492, -1.23671115700189, 218, 23, 'PPL', 'P'),
(131512, 'Joppa', 42.188060760498, 0.736320565302114, -85.2174987792969, -1.48732593401298, 218, 27, 'PPL', 'P'),
(155940, 'Joppa', 41.3644409179688, 0.72194568726522, -82.4305572509766, -1.43868462828323, 218, 41, 'PPL', 'P'),
(48552, 'Joppa Acres', 39.4500007629395, 0.688532403227568, -76.3636093139648, -1.33279641123529, 218, 25, 'PPL', 'P'),
(48553, 'Joppa Heights', 39.4019393920898, 0.687693574063221, -76.54638671875, -1.33598647874705, 218, 25, 'PPL', 'P'),
(48554, 'Joppa Hills', 39.5091705322266, 0.689565110519274, -76.3713912963867, -1.33293223245089, 218, 25, 'PPL', 'P'),
(27580, 'Joppa Junction', 37.329719543457, 0.6515265148794, -89.0313873291016, -1.55389084651118, 218, 18, 'PPL', 'P'),
(48555, 'Joppa Landing', 39.4027786254883, 0.687708221449216, -76.3394393920898, -1.33237456651863, 218, 25, 'PPL', 'P'),
(48556, 'Joppa Manor', 39.396671295166, 0.687601628426586, -76.5319366455078, -1.33573427739182, 218, 25, 'PPL', 'P'),
(103226, 'Joppa Mill', 37.2663917541504, 0.65042123644799, -79.5880584716797, -1.38907366560058, 218, 53, 'PPL', 'P'),
(48557, 'Joppa Vale', 39.3938903808594, 0.687553092315719, -76.4688873291016, -1.33463385922939, 218, 25, 'PPL', 'P'),
(48558, 'Joppa View', 39.4027786254883, 0.687708221449216, -76.4711074829102, -1.33467260822326, 218, 25, 'PPL', 'P'),
(48559, 'Joppatowne', 39.4577789306641, 0.688668157864135, -76.3555603027344, -1.33265592948779, 218, 25, 'PPL', 'P'),
(178426, 'Jops Landing', 34.5438919067383, 0.602904650225605, -114.364440917969, -1.99603604122108, 218, 5, 'PPL', 'P'),
(3459, 'Joquin', 31.7863903045654, 0.55477716813867, -86.1641693115234, -1.50384845173194, 218, 2, 'PPL', 'P'),
(3461, 'Jordan', 31.5047206878662, 0.549861105924438, -88.2472229003906, -1.54020459535316, 218, 2, 'PPL', 'P'),
(9794, 'Jordan', 36.232780456543, 0.632381316118929, -92.1841735839844, -1.60891734727051, 218, 4, 'PPL', 'P'),
(22303, 'Jordan', 32.0347213745117, 0.559111362944233, -82.6688919067383, -1.44284435274788, 218, 13, 'PPL', 'P'),
(30228, 'Jordan', 39.3983306884766, 0.68763059030344, -86.9166717529297, -1.51698209696377, 218, 19, 'PPL', 'P'),
(36651, 'Jordan', 36.5033302307129, 0.637103300468721, -89.0369415283203, -1.55398778557486, 218, 21, 'PPL', 'P'),
(55613, 'Jordan', 38.0213890075684, 0.663598424363647, -93.14111328125, -1.62561909573083, 218, 29, 'PPL', 'P'),
(66007, 'Jordan', 35.6688919067383, 0.622539604310541, -78.3072204589844, -1.36671882509434, 218, 33, 'PPL', 'P'),
(81813, 'Jordan', 35.0430603027344, 0.611616782257636, -82.2525024414063, -1.43557698560721, 218, 48, 'PPL', 'P'),
(95217, 'Jordan', 29.940559387207, 0.522561341195658, -97.3544387817383, -1.69915549817259, 218, 51, 'PPL', 'P'),
(103227, 'Jordan', 37.6758308410645, 0.657567296600999, -75.6936111450195, -1.32110273720487, 218, 53, 'PPL', 'P'),
(109881, 'Jordan', 39.5486106872559, 0.690253471082032, -80.0813903808594, -1.39768393172091, 218, 58, 'PPL', 'P'),
(113595, 'Jordan', 41.339168548584, 0.721504601209676, -72.1447219848633, -1.2591629365718, 218, 8, 'PPL', 'P'),
(116268, 'Jordan', 42.0491714477539, 0.733896489498896, -93.7838897705078, -1.63683766182279, 218, 16, 'PPL', 'P'),
(131513, 'Jordan', 43.6552810668945, 0.761928390500852, -84.7280578613281, -1.47878357850044, 218, 27, 'PPL', 'P'),
(136157, 'Jordan', 44.6669387817383, 0.779585148528078, -93.6266708374023, -1.63409367379363, 218, 28, 'PPL', 'P'),
(149938, 'Jordan', 43.0652809143066, 0.751630945250925, -76.4733276367188, -1.33471135721712, 218, 40, 'PPL', 'P'),
(174710, 'Jordan', 44.5747184753418, 0.777975600544261, -89.504997253418, -1.56215689906062, 218, 57, 'PPL', 'P'),
(178427, 'Jordan', 34.6902809143066, 0.6054596203964, -111.904998779297, -1.95311067813897, 218, 5, 'PPL', 'P'),
(188750, 'Jordan', 34.7944412231445, 0.607277560735515, -103.847778320313, -1.81248565257064, 218, 38, 'PPL', 'P'),
(193210, 'Jordan', 44.7272186279297, 0.780637230316714, -122.698608398438, -2.1414947041679, 218, 43, 'PPL', 'P'),
(196797, 'Jordan', 47.3208312988281, 0.825904310945335, -106.909439086914, -1.86592171352697, 218, 31, 'PPL', 'P'),
(204498, 'Jordan', 40.5, 0.706858347057703, -111.949996948242, -1.95389604434443, 218, 52, 'PPL', 'P'),
(207750, 'Jordan', 48.1480598449707, 0.840342172742009, -122.036109924316, -2.12993192450505, 218, 56, 'PPL', 'P'),
(9796, 'Jordan (historical)', 35.8994407653809, 0.626563440980569, -93.6669387817383, -1.6347964820053, 218, 4, 'PPL', 'P'),
(88213, 'Jordan Acres', 35.9319381713867, 0.627130627713729, -86.5638885498047, -1.51082486852351, 218, 50, 'PPL', 'P'),
(204499, 'Jordan Addition', 40.7686080932617, 0.711546442682624, -111.927223205566, -1.95349856755174, 218, 52, 'PPL', 'P'),
(3462, 'Jordan Chapel', 33.4566688537598, 0.583929028247545, -85.4977798461914, -1.49221776146129, 218, 2, 'PPL', 'P'),
(201048, 'Jordan Creek', 45.5486106872559, 0.794973226201692, -123.600563049316, -2.15723678252941, 218, 43, 'PPL', 'P'),
(196798, 'Jordan Crossing', 48.5072212219238, 0.846610721315838, -107.286666870117, -1.87250558037386, 218, 31, 'PPL', 'P'),
(41553, 'Jordan Hill', 31.853889465332, 0.55595525073638, -92.5224990844727, -1.61482224119749, 218, 22, 'PPL', 'P'),
(202261, 'Jordan Junction', 43.3849983215332, 0.757211066682968, -100.02889251709, -1.74583352154674, 218, 49, 'PPL', 'P'),
(178428, 'Jordan Meadows', 34.540828704834, 0.602851187266722, -111.865280151367, -1.95241745730722, 218, 5, 'PPL', 'P'),
(81814, 'Jordan Mill', 34.4069404602051, 0.600514396568232, -80.5077819824219, -1.40512586907103, 218, 48, 'PPL', 'P'),
(48560, 'Jordan Mill Farms', 39.686939239502, 0.692667759768243, -76.60888671875, -1.33707730952954, 218, 25, 'PPL', 'P'),
(127842, 'Jordan Mills', 45.5533294677734, 0.795055584458403, -68.3797225952148, -1.19345130088686, 218, 26, 'PPL', 'P'),
(103228, 'Jordan Mines', 37.6611099243164, 0.657310368134834, -80.1161117553711, -1.39828993402696, 218, 53, 'PPL', 'P'),
(759, 'Jordan Oak', 36.1088905334473, 0.630219029050866, -79.1741714477539, -1.38184997430179, 218, 33, 'PPL', 'P'),
(22304, 'Jordan Place', 31.7558307647705, 0.554243803551354, -84.208610534668, -1.46971751235954, 218, 13, 'PPL', 'P'),
(103229, 'Jordan Point Manor', 37.2894401550293, 0.650823506930646, -77.2216720581055, -1.34777243130925, 218, 53, 'PPL', 'P'),
(109883, 'Jordan Run', 39.0305595397949, 0.681211772865104, -79.2544403076172, -1.38325093019323, 218, 58, 'PPL', 'P'),
(103230, 'Jordan Springs', 39.2152786254883, 0.684435729101727, -78.0841674804688, -1.36282581621286, 218, 53, 'PPL', 'P'),
(88215, 'Jordan Springs (historical)', 36.5944404602051, 0.638693473955608, -87.5611114501953, -1.52822969151162, 218, 50, 'PPL', 'P'),
(163188, 'Jordan Valley', 40.7127799987793, 0.710572058618792, -75.7138900756836, -1.32145667131374, 218, 45, 'PPL', 'P'),
(201049, 'Jordan Valley', 42.9741706848145, 0.750040771764038, -117.053329467773, -2.04296599963435, 218, 43, 'PPL', 'P'),
(193231, 'Jordan Village', 40.5999984741211, 0.708603649678087, -111.878326416016, -1.95264515758042, 218, 52, 'PPL', 'P'),
(204506, 'Jordanelle', 40.5944404602051, 0.708506644035381, -111.426666259766, -1.94476220075379, 218, 52, 'PPL', 'P'),
(116270, 'Jordans Grove', 42.1558303833008, 0.735758039100862, -91.4983291625977, -1.59694710396088, 218, 16, 'PPL', 'P'),
(3463, 'Jordans Mill', 34.4602813720703, 0.601445371106296, -88.0027770996094, -1.53593821128685, 218, 2, 'PPL', 'P'),
(103231, 'Jordans Point (historical)', 37.3069381713867, 0.651128904928651, -77.220832824707, -1.34775778392325, 218, 53, 'PPL', 'P'),
(95218, 'Jordans Store', 31.6882991790771, 0.553065155031912, -93.9721603393555, -1.64012360313378, 218, 51, 'PPL', 'P'),
(70993, 'Jordantown', 39.964168548584, 0.697506323994754, -75.0377807617188, -1.30965633768165, 218, 37, 'PPL', 'P'),
(81815, 'Jordanville', 33.899169921875, 0.591652128829748, -79.2372207641602, -1.38295039246421, 218, 48, 'PPL', 'P'),
(149943, 'Jordanville', 42.9147186279297, 0.749003137624316, -74.9519424438477, -1.30815817641043, 218, 40, 'PPL', 'P'),
(155941, 'Jordanville', 40.769718170166, 0.711565817179555, -80.7563934326172, -1.4094649574351, 218, 41, 'PPL', 'P'),
(27582, 'Jordanville (historical)', 39.8580589294434, 0.695654361772713, -90.0975036621094, -1.57249808673146, 218, 18, 'PPL', 'P'),
(81816, 'Jordonia', 34.6875, 0.605411084285533, -82.9250030517578, -1.44731433547952, 218, 48, 'PPL', 'P'),
(88217, 'Jordonia', 36.209171295166, 0.631969258519267, -86.8652801513672, -1.51608514430864, 218, 50, 'PPL', 'P'),
(177713, 'Jornada', 33.1230583190918, 0.57810642599825, -107.033332824707, -1.86808406717406, 218, 38, 'PPL', 'P'),
(149939, 'Joscelyn', 41.9536094665527, 0.732228618287207, -74.8608322143555, -1.30656800292354, 218, 40, 'PPL', 'P'),
(190355, 'Joseco', 37.5019416809082, 0.654532358222745, -114.228332519531, -1.99366050152873, 218, 39, 'PPL', 'P'),
(95219, 'Josefina L Chapa Colonia', 26.19700050354, 0.457223912933386, -98.4069976806641, -1.71752611653001, 218, 51, 'PPL', 'P'),
(48561, 'Josenhans', 39.3161087036133, 0.686195545950051, -76.4491729736328, -1.33428977881656, 218, 25, 'PPL', 'P'),
(60454, 'Joseph', 32.9755592346191, 0.575532081330525, -89.727783203125, -1.5660452474102, 218, 30, 'PPL', 'P'),
(192642, 'Joseph', 38.6263885498047, 0.67415765834873, -112.21639251709, -1.95854552413355, 218, 52, 'PPL', 'P'),
(195162, 'Joseph', 45.7972183227539, 0.799312247986731, -116.476936340332, -2.03290604177463, 218, 17, 'PPL', 'P'),
(201050, 'Joseph', 45.3544387817383, 0.791584287135539, -117.228607177734, -2.04602517277852, 218, 43, 'PPL', 'P'),
(178429, 'Joseph City', 34.9558296203613, 0.610094319641465, -110.33332824707, -1.92567985259504, 218, 5, 'PPL', 'P'),
(22306, 'Joseph Estates', 33.8672218322754, 0.591094529476512, -84.8344421386719, -1.48064033441244, 218, 13, 'PPL', 'P'),
(95220, 'Joseph Griggs Colonia', 26.3939990997314, 0.460662187058733, -98.8249969482422, -1.72482158002017, 218, 51, 'PPL', 'P'),
(48562, 'Joseph Meadows', 39.6199989318848, 0.691499430998026, -77.1100006103516, -1.34582339686547, 218, 25, 'PPL', 'P'),
(3465, 'Joseph Springs', 33.6952781677246, 0.588093546402157, -85.6736068725586, -1.49528652198539, 218, 2, 'PPL', 'P'),
(155942, 'Josephatowa', 41.5138893127441, 0.724554053815871, -81.6699981689453, -1.42541036814584, 218, 41, 'PPL', 'P'),
(3466, 'Josephine', 30.3263893127441, 0.529295343749006, -87.5311126708984, -1.52770611404131, 218, 2, 'PPL', 'P'),
(36652, 'Josephine', 38.398609161377, 0.670182158052486, -84.6500015258789, -1.47742123844481, 218, 21, 'PPL', 'P'),
(95221, 'Josephine', 33.0611114501953, 0.577025249174705, -96.3069381713867, -1.68087316360531, 218, 51, 'PPL', 'P'),
(103232, 'Josephine', 36.9280586242676, 0.644516209362957, -82.6658325195313, -1.44279095636802, 218, 53, 'PPL', 'P'),
(109884, 'Josephine', 37.6199989318848, 0.656592845958139, -81.2238922119141, -1.41762435038288, 218, 58, 'PPL', 'P'),
(140297, 'Josephine', 47.9397201538086, 0.836705959168642, -99.313606262207, -1.73334942130477, 218, 34, 'PPL', 'P'),
(163192, 'Josephine', 40.4772186279297, 0.706460737106955, -79.1816711425781, -1.38198086866937, 218, 45, 'PPL', 'P'),
(88216, 'Josephine (historical)', 36.0938911437988, 0.629957240315712, -86.2944412231445, -1.50612212551259, 218, 50, 'PPL', 'P'),
(195163, 'Josephson', 43.7488899230957, 0.763562173250589, -116.637496948242, -2.03570835303166, 218, 17, 'PPL', 'P'),
(163193, 'Josephtown', 40.6699981689453, 0.709825374828161, -80.3313903808594, -1.4020472548509, 218, 45, 'PPL', 'P'),
(55616, 'Josephville', 38.8427810668945, 0.677934420248625, -90.79638671875, -1.58469589715624, 218, 29, 'PPL', 'P'),
(16677, 'Joshua', 27.2075004577637, 0.474860464225841, -81.7333297729492, -1.42651571315627, 218, 12, 'PPL', 'P'),
(81817, 'Joshua', 32.853889465332, 0.573408543256323, -80.0144424438477, -1.39651546979264, 218, 48, 'PPL', 'P'),
(95222, 'Joshua', 32.4613914489746, 0.56655816056334, -97.3877792358398, -1.69973739887077, 218, 51, 'PPL', 'P'),
(149940, 'Joshua', 42.915828704834, 0.749022512121247, -76.2433319091797, -1.33069717450604, 218, 40, 'PPL', 'P'),
(182402, 'Joshua', 35.271110534668, 0.615597009664814, -115.448608398438, -2.01495833339831, 218, 6, 'PPL', 'P'),
(103237, 'Joshua Falls', 37.4249992370605, 0.653189459243072, -79.0447235107422, -1.37959068159102, 218, 53, 'PPL', 'P'),
(182403, 'Joshua Tree', 34.1347198486328, 0.595763250604503, -116.312217712402, -2.03003115937789, 218, 6, 'PPL', 'P'),
(3467, 'Josie', 31.8697204589844, 0.556231553699476, -85.7188873291016, -1.49607681503887, 218, 2, 'PPL', 'P'),
(120164, 'Joslin', 41.5572204589844, 0.725310324986426, -90.2219390869141, -1.57466989460042, 218, 18, 'PPL', 'P'),
(144012, 'Joslin', 42.9091682434082, 0.748906265139665, -72.2561111450195, -1.26110704416756, 218, 36, 'PPL', 'P'),
(207751, 'Joso', 46.6116714477539, 0.813527136621138, -118.217498779297, -2.06328458717111, 218, 56, 'PPL', 'P'),
(95223, 'Josselet', 33.2347183227539, 0.580055260704943, -99.7038879394531, -1.74016112158292, 218, 51, 'PPL', 'P'),
(142144, 'Josselyn', 40.7497215270996, 0.7112168099187, -99.623893737793, -1.73876495938145, 218, 35, 'PPL', 'P'),
(95224, 'Josserand', 31.0349998474121, 0.541662930693279, -95.0894393920898, -1.65962380126756, 218, 51, 'PPL', 'P'),
(131517, 'Jossman Acres', 42.764720916748, 0.746385183693741, -83.470832824707, -1.4568408621729, 218, 27, 'PPL', 'P'),
(95225, 'Jot-Em-Down', 33.3829116821289, 0.582641722755628, -95.8580780029297, -1.67303907578467, 218, 51, 'PPL', 'P'),
(170634, 'Joubert', 43.4275016784668, 0.757952890204609, -98.666389465332, -1.72205335722509, 218, 49, 'PPL', 'P'),
(95226, 'Jourdanton', 28.9177799224854, 0.50471047201448, -98.5461120605469, -1.71995412049584, 218, 51, 'PPL', 'P'),
(182404, 'Jovista', 35.7975006103516, 0.624784249635314, -119.181938171387, -2.08011722999901, 218, 6, 'PPL', 'P'),
(207752, 'Jovita', 47.2611083984375, 0.824861949694679, -122.280563354492, -2.13419844172941, 218, 56, 'PPL', 'P'),
(3468, 'Joy', 34.0333290100098, 0.593993646639173, -86.6166687011719, -1.51174605594457, 218, 2, 'PPL', 'P'),
(9802, 'Joy', 35.2874984741211, 0.615883033165888, -91.9502792358398, -1.60483512079358, 218, 4, 'PPL', 'P'),
(32884, 'Joy', 37.5952796936035, 0.656161413861546, -99.3944396972656, -1.73476023089224, 218, 20, 'PPL', 'P'),
(36653, 'Joy', 37.3549995422363, 0.651967734092999, -88.3858337402344, -1.54262381088738, 218, 21, 'PPL', 'P'),
(55617, 'Joy', 37.5144386291504, 0.654750471116022, -91.6741714477539, -1.60001613080108, 218, 29, 'PPL', 'P'),
(73080, 'Joy', 39.4702796936035, 0.68888633733644, -81.9411087036133, -1.43014213961263, 218, 41, 'PPL', 'P'),
(76242, 'Joy', 34.5936088562012, 0.60377237468778, -97.1419372558594, -1.69544664688049, 218, 42, 'PPL', 'P'),
(95227, 'Joy', 33.5761108398438, 0.586013684169832, -98.2155609130859, -1.7141849146264, 218, 51, 'PPL', 'P'),
(109885, 'Joy', 39.232780456543, 0.684741193678759, -80.8788909912109, -1.41160294315821, 218, 58, 'PPL', 'P'),
(120165, 'Joy', 41.1966705322266, 0.719017541646678, -90.8802795410156, -1.58616010312356, 218, 18, 'PPL', 'P'),
(149941, 'Joy', 43.1922187805176, 0.753846428961762, -77.0933303833008, -1.34553244651638, 218, 40, 'PPL', 'P'),
(192643, 'Joy', 39.5727806091309, 0.690675315798701, -113.057777404785, -1.97323046070035, 218, 52, 'PPL', 'P'),
(81818, 'Joy (historical)', 33.936939239502, 0.59231132777857, -79.101936340332, -1.38058923384175, 218, 48, 'PPL', 'P'),
(190356, 'Joy (historical)', 39.9472198486328, 0.697210513376673, -115.54167175293, -2.01658259534715, 218, 39, 'PPL', 'P'),
(48563, 'Joy Haven', 39.5108299255371, 0.689594072396129, -75.9527816772461, -1.32562611631637, 218, 25, 'PPL', 'P'),
(48564, 'Joy Lee Acres', 38.6124992370605, 0.673915244110505, -76.5930633544922, -1.3368011397245, 218, 25, 'PPL', 'P'),
(27583, 'Joy Prairie', 39.7866706848145, 0.694408401856719, -90.2980575561523, -1.5759984125102, 218, 18, 'PPL', 'P'),
(103233, 'Joy Spring', 38.860279083252, 0.67823981824663, -78.1508331298828, -1.36398935129312, 218, 53, 'PPL', 'P'),
(41554, 'Joyce', 31.9391708374023, 0.557443691469625, -92.5986099243164, -1.61615062594922, 218, 22, 'PPL', 'P'),
(48565, 'Joyce', 39.0247192382813, 0.681109840374381, -76.5202789306641, -1.33553081188453, 218, 25, 'PPL', 'P'),
(155943, 'Joyce', 40.4550018310547, 0.706072980852239, -81.503059387207, -1.42249673675523, 218, 41, 'PPL', 'P'),
(163194, 'Joyce', 40.9719390869141, 0.71509523799321, -80.3161087036133, -1.40178053926773, 218, 45, 'PPL', 'P'),
(199437, 'Joyce', 41.9280586242676, 0.731782671962673, -103.968063354492, -1.81458502245795, 218, 35, 'PPL', 'P'),
(207753, 'Joyce', 48.1366691589355, 0.840143367766635, -123.732780456543, -2.15954441161397, 218, 56, 'PPL', 'P'),
(48566, 'Joyce Acres', 39.038330078125, 0.681347394343616, -76.5041732788086, -1.33524971523148, 218, 25, 'PPL', 'P'),
(9798, 'Joyce City', 33.3758316040039, 0.582518152081048, -92.6488876342773, -1.6170281375284, 218, 4, 'PPL', 'P'),
(103234, 'Joyce Heights', 38.8461112976074, 0.677992543739416, -77.3225021362305, -1.34953224815757, 218, 53, 'PPL', 'P'),
(66009, 'Joyce Mill', 36.5366706848145, 0.637685201166904, -80.4002838134766, -1.40324967208307, 218, 33, 'PPL', 'P'),
(88218, 'Joyceland', 35.8180618286133, 0.625143110592203, -86.4233322143555, -1.50837169768538, 218, 50, 'PPL', 'P'),
(113596, 'Joyceland (historical)', 41.5152816772461, 0.724578355160818, -73.4741668701172, -1.28236612704328, 218, 8, 'PPL', 'P'),
(66010, 'Joyceton', 35.8672218322754, 0.626001114516399, -81.508056640625, -1.42258395528093, 218, 33, 'PPL', 'P'),
(103235, 'Joyceville', 36.5694389343262, 0.638257115010998, -78.0366668701172, -1.36199677416552, 218, 53, 'PPL', 'P'),
(113597, 'Joyceville', 42.0486106872559, 0.73388670238189, -73.4261093139648, -1.28152736445796, 218, 8, 'PPL', 'P'),
(36654, 'Joyes', 38.2097206115723, 0.666885430939077, -85.2911071777344, -1.48861064292283, 218, 21, 'PPL', 'P'),
(9799, 'Joyland', 35.4741706848145, 0.619141077864464, -90.4488906860352, -1.57863094724775, 218, 4, 'PPL', 'P'),
(66011, 'Joyland', 35.9911117553711, 0.628163401584461, -78.8547210693359, -1.37627451340166, 218, 33, 'PPL', 'P'),
(103236, 'Joyner', 36.7791709899902, 0.641917629929312, -77.2519378662109, -1.34830066931146, 218, 53, 'PPL', 'P'),
(66012, 'Joyners Crossing', 35.8913917541504, 0.626422959233067, -77.8649978637695, -1.35900058478113, 218, 33, 'PPL', 'P'),
(66013, 'Joynes', 36.3708305358887, 0.634790744536151, -81.0669403076172, -1.41488502288562, 218, 33, 'PPL', 'P'),
(127843, 'Joyville', 44.5555610656738, 0.777641240669402, -68.4752807617188, -1.19511910551952, 218, 26, 'PPL', 'P'),
(88219, 'Joywood', 35.9297218322754, 0.627091945298895, -86.4944381713867, -1.50961273075336, 218, 50, 'PPL', 'P'),
(192644, 'Juab', 39.519718170166, 0.689749201529626, -111.939720153809, -1.95371668044501, 218, 52, 'PPL', 'P'),
(182405, 'Juan', 35.3663902282715, 0.617259954028486, -115.087219238281, -2.00865090267257, 218, 6, 'PPL', 'P'),
(95228, 'Juan Gonzales Colonia', 26.2129993438721, 0.457503145373681, -97.4700012207031, -1.70117244322416, 218, 51, 'PPL', 'P'),
(188755, 'Juan Tomas', 35.0269393920898, 0.611335419288469, -106.297782897949, -1.85524629913933, 218, 38, 'PPL', 'P'),
(41555, 'Juanita', 30.6183300018311, 0.534390669994113, -93.4250030517578, -1.63057390693892, 218, 22, 'PPL', 'P'),
(140298, 'Juanita', 47.5022201538086, 0.829070143691167, -98.6836090087891, -1.72235389495411, 218, 34, 'PPL', 'P'),
(186902, 'Juanita', 37.0272216796875, 0.646246931176372, -107.150001525879, -1.87012032014354, 218, 7, 'PPL', 'P'),
(207754, 'Juanita', 47.7033309936523, 0.832580190007892, -122.205833435059, -2.13289415858554, 218, 56, 'PPL', 'P'),
(55618, 'Juanita (historical)', 36.8202781677246, 0.642635085526979, -89.5911102294922, -1.56365985402181, 218, 29, 'PPL', 'P'),
(186903, 'Juanita Junction', 38.9247207641602, 0.679364537753998, -107.527496337891, -1.87670884752234, 218, 7, 'PPL', 'P'),
(178430, 'Juanita Mobile Home Park', 33.4208297729492, 0.583303518286513, -111.653327941895, -1.94871819339504, 218, 5, 'PPL', 'P'),
(95229, 'Juarez Colonia', 26.2019996643066, 0.4573111647486, -97.7320022583008, -1.70574522397388, 218, 51, 'PPL', 'P'),
(66019, 'Jubilee', 35.7630615234375, 0.624183174177284, -80.4263916015625, -1.40370533894558, 218, 33, 'PPL', 'P'),
(116271, 'Jubilee', 42.3841705322266, 0.739743326514111, -92.1036071777344, -1.60751119821495, 218, 16, 'PPL', 'P'),
(163195, 'Jubilee', 41.3469390869141, 0.721640222688188, -75.4561080932617, -1.31695752696816, 218, 45, 'PPL', 'P'),
(66014, 'Jubilee Acres', 35.7608299255371, 0.624144225446341, -80.4155578613281, -1.40351625450819, 218, 33, 'PPL', 'P'),
(95230, 'Jubilee Springs', 31.1766700744629, 0.544135542607363, -97.498893737793, -1.70167671277657, 218, 51, 'PPL', 'P'),
(76243, 'Jubys', 36.2036094665527, 0.631872186297533, -96.2841720581055, -1.68047581997067, 218, 42, 'PPL', 'P'),
(95232, 'Jud', 33.2822189331055, 0.580884302752285, -99.9580612182617, -1.74459728216872, 218, 51, 'PPL', 'P'),
(140299, 'Jud', 46.5261116027832, 0.812033835618903, -98.8952789306641, -1.72604823201826, 218, 34, 'PPL', 'P'),
(174712, 'Juda', 42.5897216796875, 0.743330870818557, -89.5058288574219, -1.56217141328857, 218, 57, 'PPL', 'P'),
(30230, 'Judah', 38.9608306884766, 0.679994774825965, -86.5372161865234, -1.51035934796497, 218, 19, 'PPL', 'P'),
(41556, 'Judd', 30.3627796173096, 0.529930474379476, -92.4038925170898, -1.61275216608217, 218, 22, 'PPL', 'P'),
(55619, 'Judd', 39.4230613708496, 0.688062222137115, -93.7397232055664, -1.63606680984527, 218, 29, 'PPL', 'P'),
(116272, 'Judd', 42.4722213745117, 0.741280103621141, -94.0494384765625, -1.64147236106786, 218, 16, 'PPL', 'P'),
(9800, 'Judd Hill', 35.6022186279297, 0.621375936072231, -90.519172668457, -1.57985759924584, 218, 4, 'PPL', 'P'),
(131516, 'Juddville', 43.0586090087891, 0.751514498532261, -83.9875030517578, -1.46585845878196, 218, 27, 'PPL', 'P'),
(149942, 'Juddville', 42.8811111450195, 0.748416576394226, -75.8330612182617, -1.32353660012509, 218, 40, 'PPL', 'P'),
(55620, 'Judge', 38.4205589294434, 0.670565253775294, -91.7805633544922, -1.60187301987114, 218, 29, 'PPL', 'P'),
(136160, 'Judge', 43.899169921875, 0.766185054029181, -92.475830078125, -1.61400771337809, 218, 28, 'PPL', 'P'),
(103238, 'Judge (historical)', 37.0680618286133, 0.646959726242132, -82.1833267211914, -1.43436964152703, 218, 53, 'PPL', 'P'),
(81819, 'Judge Town', 33.4319381713867, 0.583497396413871, -80.0194396972656, -1.39660268831834, 218, 48, 'PPL', 'P'),
(195164, 'Judge Town', 46.4755592346191, 0.81115153034976, -115.796112060547, -2.02102341646486, 218, 17, 'PPL', 'P'),
(41557, 'Judice', 30.1811103820801, 0.526759748075141, -92.1416702270508, -1.60817552374887, 218, 22, 'PPL', 'P'),
(13133, 'Judiciary Square', 38.898609161377, 0.678908804312458, -77.0166702270508, -1.34419447438472, 218, 9, 'PPL', 'P'),
(36655, 'Judio', 36.6958312988281, 0.640463077920938, -85.480827331543, -1.49192188426418, 218, 21, 'PPL', 'P'),
(196799, 'Judith (historical)', 47.7180595397949, 0.832837251632112, -109.642219543457, -1.9136177302278, 218, 31, 'PPL', 'P'),
(196801, 'Judith Gap', 46.6772193908691, 0.814671164046408, -109.751106262207, -1.91551816198168, 218, 31, 'PPL', 'P'),
(191675, 'Judkins', 31.7175006866455, 0.553574817485526, -102.632217407227, -1.79127011237874, 218, 51, 'PPL', 'P'),
(195165, 'Judkins', 43.9219398498535, 0.766582464242848, -111.148887634277, -1.93991404914735, 218, 17, 'PPL', 'P'),
(3470, 'Judson', 32.8358306884766, 0.573093358141312, -85.5861129760742, -1.49375946541634, 218, 2, 'PPL', 'P'),
(36657, 'Judson', 37.6863899230957, 0.657751587348433, -84.5691680908203, -1.47601042885734, 218, 21, 'PPL', 'P'),
(66016, 'Judson', 35.0019416809082, 0.610899126922887, -78.8091735839844, -1.37547955981627, 218, 33, 'PPL', 'P'),
(81821, 'Judson', 34.8330612182617, 0.607951606807414, -82.4277801513672, -1.43863615875139, 218, 48, 'PPL', 'P'),
(95233, 'Judson', 32.5825004577637, 0.568671911520536, -94.7533264160156, -1.65375752317639, 218, 51, 'PPL', 'P'),
(109886, 'Judson', 37.7108306884766, 0.658178159176036, -80.7763900756836, -1.40981396469595, 218, 58, 'PPL', 'P'),
(122939, 'Judson', 40.5038909912109, 0.7069262576655, -86.2713928222656, -1.50571985502994, 218, 19, 'PPL', 'P'),
(125161, 'Judson', 41.9166717529297, 0.731583933566326, -71.004997253418, -1.23927098744167, 218, 23, 'PPL', 'P'),
(136161, 'Judson', 44.1963882446289, 0.771372492358491, -94.1949996948242, -1.64401288358974, 218, 28, 'PPL', 'P'),
(139247, 'Judson', 40.311939239502, 0.703576067593208, -93.2302780151367, -1.62717531391382, 218, 29, 'PPL', 'P'),
(198460, 'Judson', 46.8263893127441, 0.81727467032807, -101.278060913086, -1.76763562296872, 218, 34, 'PPL', 'P'),
(120167, 'Judson (historical)', 41.2522201538086, 0.719987065441522, -87.642219543457, -1.52964529478905, 218, 18, 'PPL', 'P'),
(9801, 'Judsonia', 35.2700004577637, 0.615577635167883, -91.6397171020508, -1.59941478902694, 218, 4, 'PPL', 'P'),
(36656, 'Judy', 38.1297187805176, 0.665489135579549, -83.958610534668, -1.46535418922955, 218, 21, 'PPL', 'P'),
(122940, 'Judyville', 40.3583297729492, 0.704385735143619, -87.3949966430664, -1.5253304411909, 218, 19, 'PPL', 'P'),
(60456, 'Jug Fork', 34.4263916015625, 0.600853883028189, -88.7891693115234, -1.54966334459679, 218, 30, 'PPL', 'P'),
(81822, 'Jug Hole', 34.086669921875, 0.594924621177237, -81.4780578613281, -1.42206037781063, 218, 48, 'PPL', 'P'),
(155944, 'Jug Run', 40.2119407653809, 0.701830764972825, -80.7477798461914, -1.40931462199156, 218, 41, 'PPL', 'P'),
(155945, 'Jugs Corners', 40.6808280944824, 0.710014392686529, -82.6455612182617, -1.4424371554172, 218, 41, 'PPL', 'P'),
(48567, 'Jugtown', 39.6124992370605, 0.691368536630448, -77.5941696166992, -1.35427374016235, 218, 25, 'PPL', 'P'),
(66018, 'Jugtown', 35.5080604553223, 0.61973256594257, -79.6502838134766, -1.39015970269311, 218, 33, 'PPL', 'P'),
(163196, 'Jugtown', 40.5372200012207, 0.707507958626601, -75.0758285522461, -1.31032039689946, 218, 45, 'PPL', 'P'),
(36658, 'Jugville', 37.4630584716797, 0.653853718197965, -86.5988922119141, -1.51143579767758, 218, 21, 'PPL', 'P'),
(131519, 'Jugville', 43.5341682434082, 0.759814572964629, -85.8605575561523, -1.49854942695295, 218, 27, 'PPL', 'P'),
(131518, 'Juhl', 43.3597183227539, 0.756769847469369, -82.9463882446289, -1.44768757750629, 218, 27, 'PPL', 'P'),
(191676, 'Juilliard', 35.3186111450195, 0.616426051712155, -101.809173583984, -1.77690528777496, 218, 51, 'PPL', 'P'),
(27589, 'Jules', 39.9680595397949, 0.697574234602551, -90.2602767944336, -1.5753390138243, 218, 18, 'PPL', 'P'),
(139248, 'Julesburg', 40.461669921875, 0.706189360991876, -92.605827331543, -1.61627659346878, 218, 29, 'PPL', 'P'),
(194262, 'Julesburg', 40.9883308410645, 0.715381328073311, -102.263893127441, -1.78484164098145, 218, 7, 'PPL', 'P'),
(22310, 'Julia', 33.5016708374023, 0.584714461032037, -84.0991668701172, -1.46780736006768, 218, 13, 'PPL', 'P'),
(109887, 'Julia', 38.0244407653809, 0.663651687585449, -80.3041687011719, -1.40157214691243, 218, 58, 'PPL', 'P'),
(41558, 'Julia (historical)', 30.7180595397949, 0.536131278793076, -90.0386123657227, -1.57147023970874, 218, 22, 'PPL', 'P'),
(155946, 'Julia (historical)', 41.3474998474121, 0.721650009805194, -81.2627792358398, -1.41830305698669, 218, 41, 'PPL', 'P'),
(195166, 'Juliaetta', 46.5788917541504, 0.812955023039961, -116.705001831055, -2.03688653549792, 218, 17, 'PPL', 'P'),
(95234, 'Julian', 26.7950000762939, 0.467660974403461, -97.9550018310547, -1.70963730074898, 218, 51, 'PPL', 'P'),
(109888, 'Julian', 38.1572189331055, 0.665969103787008, -81.855827331543, -1.42865369887939, 218, 58, 'PPL', 'P'),
(112456, 'Julian', 35.9049987792969, 0.626660446623275, -79.6605606079102, -1.39033906659253, 218, 33, 'PPL', 'P'),
(142145, 'Julian', 40.5227813720703, 0.707255957008452, -95.8675003051758, -1.67320352598199, 218, 35, 'PPL', 'P'),
(163197, 'Julian', 40.8641700744629, 0.713214313894314, -77.9397201538086, -1.36030473476694, 218, 45, 'PPL', 'P'),
(182406, 'Julian', 33.0786094665527, 0.57733064717271, -116.601112365723, -2.03507332226974, 218, 6, 'PPL', 'P'),
(170636, 'Julian (historical)', 44.9972190856934, 0.785349627286582, -97.7680587768555, -1.70637452893947, 218, 49, 'PPL', 'P'),
(196802, 'Julian (historical)', 48.9425010681152, 0.854207787799452, -105.358329772949, -1.83884974893993, 218, 31, 'PPL', 'P'),
(188757, 'Julian Place', 34.6547203063965, 0.604838970704357, -108.242500305176, -1.88918802091628, 218, 38, 'PPL', 'P'),
(48568, 'Julian Woods', 39.375560760498, 0.687233180089773, -76.7583312988281, -1.33968560950117, 218, 25, 'PPL', 'P'),
(36659, 'Julien', 36.836669921875, 0.642921175607081, -87.6397171020508, -1.52960161894717, 218, 21, 'PPL', 'P'),
(41559, 'Julien', 29.8572196960449, 0.521106789187284, -91.6322174072266, -1.59928389465937, 218, 22, 'PPL', 'P'),
(116273, 'Julien', 42.4811096191406, 0.741435232754638, -90.7794418334961, -1.58440015311719, 218, 16, 'PPL', 'P'),
(467, 'Julien Hill', 37.4749984741211, 0.654062110553264, -88.4786071777344, -1.54424301283015, 218, 18, 'PPL', 'P'),
(22309, 'Julienton', 31.5602798461914, 0.55083079616685, -81.3019409179688, -1.41898655728046, 218, 13, 'PPL', 'P'),
(30232, 'Julietta', 39.7374992370605, 0.693550198195441, -85.9572219848633, -1.50023653950352, 218, 19, 'PPL', 'P'),
(22311, 'Juliette', 33.1072196960449, 0.5778299898771, -83.8002777099609, -1.46259076012443, 218, 13, 'PPL', 'P'),
(95235, 'Juliff', 29.4500007629395, 0.513999478028136, -95.4752807617188, -1.66635800355799, 218, 51, 'PPL', 'P'),
(36660, 'Julip', 36.7427787780762, 0.641282466009328, -84.0658264160156, -1.4672254593695, 218, 21, 'PPL', 'P'),
(9803, 'Julius', 35.1891708374023, 0.614166892159441, -90.3072204589844, -1.57615833533366, 218, 4, 'PPL', 'P'),
(145513, 'Juliustown', 40.0133285522461, 0.69836432791895, -74.6691665649414, -1.30322280627829, 218, 37, 'PPL', 'P'),
(109889, 'July (historical)', 38.6458282470703, 0.674496945071606, -81.5374984741211, -1.42309781221327, 218, 58, 'PPL', 'P'),
(3472, 'Jumbo', 32.9672203063965, 0.575386539576953, -86.5905609130859, -1.51129038908206, 218, 2, 'PPL', 'P'),
(9804, 'Jumbo', 36.060001373291, 0.629365752237605, -91.9794387817383, -1.6053440508779, 218, 4, 'PPL', 'P'),
(36663, 'Jumbo', 37.4580612182617, 0.653766499672265, -84.6891708374023, -1.47810487189663, 218, 21, 'PPL', 'P'),
(70994, 'Jumbo', 39.7730598449707, 0.694170847887484, -75.399169921875, -1.31596376840739, 218, 37, 'PPL', 'P'),
(76244, 'Jumbo', 34.4452781677246, 0.601183515792114, -95.7352828979492, -1.67089589689743, 218, 42, 'PPL', 'P'),
(88220, 'Jumbo', 35.8663902282715, 0.625986600288458, -88.4905624389648, -1.54445167150156, 218, 50, 'PPL', 'P'),
(109890, 'Jumbo', 38.5625, 0.673042592800313, -80.3880615234375, -1.40303635287975, 218, 58, 'PPL', 'P'),
(155947, 'Jumbo', 40.5950012207031, 0.708516431152387, -83.758056640625, -1.46185386345081, 218, 41, 'PPL', 'P'),
(191677, 'Jumbo', 34.7038917541504, 0.605697174365635, -102.281669616699, -1.78515189924845, 218, 51, 'PPL', 'P'),
(190358, 'Jumbo (historical)', 39.2922210693359, 0.685778628081399, -119.707778930664, -2.08929488258958, 218, 39, 'PPL', 'P'),
(127844, 'Jumbo Landing', 45.2144393920898, 0.789140836835391, -67.8763885498047, -1.18466646455707, 218, 26, 'PPL', 'P'),
(190361, 'Jumbotown (historical)', 37.7155609130859, 0.658260717169828, -117.220001220703, -2.04587497049304, 218, 39, 'PPL', 'P'),
(16682, 'Jumeau', 28.728889465332, 0.501413711611557, -82.3016662597656, -1.43643505611044, 218, 12, 'PPL', 'P'),
(78534, 'Jumonville', 39.8847198486328, 0.696119682594177, -79.6486129760742, -1.39013054107917, 218, 45, 'PPL', 'P'),
(155948, 'Jump', 40.6158294677734, 0.708879952641183, -83.7944412231445, -1.46248889421274, 218, 41, 'PPL', 'P'),
(174720, 'Jump River', 45.3530616760254, 0.791560252106701, -90.8011093139648, -1.58477832199198, 218, 57, 'PPL', 'P'),
(60457, 'Jumpertown', 34.7108306884766, 0.605818281616206, -88.6638870239258, -1.54747675618378, 218, 30, 'PPL', 'P'),
(109891, 'Jumping Branch', 37.6575012207031, 0.657247384375053, -80.9766693115234, -1.41330949678473, 218, 58, 'PPL', 'P'),
(48569, 'Jumptown', 38.961109161377, 0.679999635094955, -75.9188919067383, -1.32503462823826, 218, 25, 'PPL', 'P'),
(27584, 'Junction', 37.723331451416, 0.658396338648341, -88.2366714477539, -1.54002043776378, 218, 18, 'PPL', 'P'),
(41560, 'Junction', 30.8377799987793, 0.538220794984352, -93.5088882446289, -1.6320379797482, 218, 22, 'PPL', 'P'),
(66020, 'Junction', 35.2649993896484, 0.615490350063156, -83.9377822875977, -1.46499066774076, 218, 33, 'PPL', 'P'),
(95236, 'Junction', 30.4891700744629, 0.532136403999902, -99.7716674804688, -1.74134409773914, 218, 51, 'PPL', 'P'),
(109899, 'Junction', 39.313060760498, 0.686142349307277, -78.8630599975586, -1.37642005515523, 218, 58, 'PPL', 'P'),
(149944, 'Junction', 42.9286117553711, 0.749245618441568, -78.0263900756836, -1.36181741026611, 218, 40, 'PPL', 'P'),
(155949, 'Junction', 41.1930618286133, 0.718954557886898, -84.458610534668, -1.47408083548952, 218, 41, 'PPL', 'P'),
(174714, 'Junction', 45.0097198486328, 0.785567806758886, -90.9022216796875, -1.58654306568832, 218, 57, 'PPL', 'P'),
(192646, 'Junction', 38.2374992370605, 0.667370259415526, -112.219169616699, -1.95859399366538, 218, 52, 'PPL', 'P'),
(195167, 'Junction', 44.7008285522461, 0.780176636606184, -113.369720458984, -1.97867489407485, 218, 17, 'PPL', 'P'),
(196803, 'Junction', 45.3236083984375, 0.791046195437288, -111.996391296387, -1.95470577847387, 218, 31, 'PPL', 'P'),
(207755, 'Junction', 47.6138916015625, 0.831019178134942, -121.801109313965, -2.12583039011022, 218, 56, 'PPL', 'P'),
(9805, 'Junction (historical)', 36.4363899230957, 0.635934971698504, -93.7063903808594, -1.63548504230514, 218, 4, 'PPL', 'P'),
(81823, 'Junction (historical)', 34.560001373291, 0.60318581345769, -80.267219543457, -1.40092726245446, 218, 48, 'PPL', 'P'),
(116274, 'Junction (historical)', 43.0852813720703, 0.751980019090807, -91.6291732788086, -1.59923076459562, 218, 16, 'PPL', 'P'),
(190359, 'Junction (historical)', 39.0897216796875, 0.682244346998755, -117.13111114502, -2.04432354600002, 218, 39, 'PPL', 'P'),
(182407, 'Junction Camp', 34.7316703796387, 0.606182002842084, -119.97917175293, -2.0940315809044, 218, 6, 'PPL', 'P'),
(9806, 'Junction City', 33.0161094665527, 0.576239816390214, -92.7241668701172, -1.61834200805219, 218, 4, 'PPL', 'P'),
(22313, 'Junction City', 32.603328704834, 0.569035433009331, -84.4594421386719, -1.47409534971747, 218, 13, 'PPL', 'P'),
(27585, 'Junction City', 38.5802803039551, 0.673352917646335, -89.1277770996094, -1.55557316537179, 218, 18, 'PPL', 'P'),
(32885, 'Junction City', 39.0286102294922, 0.681177750982178, -96.8311080932617, -1.69002165458195, 218, 20, 'PPL', 'P'),
(36661, 'Junction City', 37.586669921875, 0.656011144997039, -84.7938919067383, -1.47993259935276, 218, 21, 'PPL', 'P'),
(41561, 'Junction City', 33.0136108398438, 0.576196207127364, -92.7249984741211, -1.61835652228013, 218, 22, 'PPL', 'P'),
(55625, 'Junction City', 37.5763893127441, 0.655831714518594, -90.2880630493164, -1.5758239754588, 218, 29, 'PPL', 'P'),
(60458, 'Junction City', 31.9608306884766, 0.557821727186362, -88.5730590820313, -1.54589150954491, 218, 30, 'PPL', 'P'),
(73081, 'Junction City', 39.7211112976074, 0.693264174694367, -82.2988891601563, -1.4363865865786, 218, 41, 'PPL', 'P'),
(170676, 'Junction City', 42.7866706848145, 0.746768279416549, -96.7858276367188, -1.68923136152846, 218, 49, 'PPL', 'P'),
(174715, 'Junction City', 44.5908317565918, 0.778256830355374, -89.767219543457, -1.56673354139393, 218, 57, 'PPL', 'P'),
(193687, 'Junction City', 40.7333297729492, 0.710930719838598, -123.05249786377, -2.14767124052607, 218, 6, 'PPL', 'P'),
(201052, 'Junction City', 44.2194404602051, 0.771774829420175, -123.204437255859, -2.15032308318151, 218, 43, 'PPL', 'P'),
(207756, 'Junction City', 46.9711112976074, 0.819800545463956, -123.772216796875, -2.1602327055977, 218, 56, 'PPL', 'P'),
(190360, 'Junction City (historical)', 36.0433311462402, 0.629074801888514, -114.794441223145, -2.00354096233098, 218, 39, 'PPL', 'P'),
(55621, 'Junction Ferry', 37.189998626709, 0.649087924848241, -91.2677764892578, -1.59292320071182, 218, 29, 'PPL', 'P'),
(182410, 'Junction House', 39.7405586242676, 0.693603594575297, -121.290832519531, -2.11692437995083, 218, 6, 'PPL', 'P'),
(55622, 'Junction Lookout (historical)', 37.6183280944824, 0.656563684344203, -91.357780456543, -1.5944940662808, 218, 29, 'PPL', 'P'),
(178431, 'Junction Overlook', 36.1372184753418, 0.63071344490724, -109.492218017578, -1.9109997097182, 218, 5, 'PPL', 'P'),
(182409, 'Junction Ranch', 36.0738906860352, 0.62960816647583, -117.511940002441, -2.05097026344864, 218, 6, 'PPL', 'P'),
(202263, 'Junction Ranger Station', 43.8461112976074, 0.765259006339133, -103.69416809082, -1.80980464830126, 218, 49, 'PPL', 'P'),
(116275, 'Junction Switch', 42.276668548584, 0.737867062947123, -91.2027816772461, -1.5917888272455, 218, 16, 'PPL', 'P'),
(95237, 'Junction Windmill', 30.2694396972656, 0.528301385451161, -99.6999969482422, -1.74009321097512, 218, 51, 'PPL', 'P'),
(55623, 'June', 36.8011093139648, 0.642300525915038, -94.3600006103516, -1.64689269283449, 218, 29, 'PPL', 'P'),
(48570, 'June Acres', 39.6105613708496, 0.691334714484604, -77.5116729736328, -1.352833902119, 218, 25, 'PPL', 'P'),
(3474, 'June Bug (historical)', 33.7544403076172, 0.589126120535807, -85.7874984741211, -1.49727430542302, 218, 2, 'PPL', 'P'),
(182411, 'June Lake', 37.7797203063965, 0.65938050982918, -119.074440002441, -2.07824103301105, 218, 6, 'PPL', 'P'),
(182412, 'June Lake Junction', 37.8125, 0.659952623410356, -119.053329467773, -2.07787258467424, 218, 6, 'PPL', 'P'),
(16683, 'June Park', 28.0719394683838, 0.489947771143844, -80.6802825927734, -1.40813657268336, 218, 12, 'PPL', 'P'),
(125162, 'June Street', 42.2686080932617, 0.737726381462539, -71.835563659668, -1.25376710588719, 218, 23, 'PPL', 'P'),
(163198, 'Juneau', 40.8883285522461, 0.713635958873901, -78.9627838134766, -1.37816056408565, 218, 45, 'PPL', 'P'),
(174717, 'Juneau', 43.4055595397949, 0.757569927639856, -88.7050018310547, -1.5481943449395, 218, 57, 'PPL', 'P'),
(193162, 'Juneau', 58.3019409179688, 1.01756082932176, -134.419723510742, -2.34606675488288, 218, 1, 'PPL', 'P'),
(163199, 'Junedale', 40.9233283996582, 0.714246821448938, -75.9419403076172, -1.32543689872092, 218, 45, 'PPL', 'P'),
(9807, 'Junet', 34.3138885498047, 0.598890334356474, -92.2638931274414, -1.61030871578202, 218, 4, 'PPL', 'P'),
(131520, 'Junet', 46.5094413757324, 0.811742885269812, -90.1977767944336, -1.5742481830418, 218, 27, 'PPL', 'P'),
(81825, 'Juneville', 33.6538887023926, 0.587371163956473, -80.2311096191406, -1.4002970253825, 218, 48, 'PPL', 'P'),
(190362, 'Jungletown (historical)', 36.2819404602051, 0.633239320043125, -115.058326721191, -2.00814663312016, 218, 39, 'PPL', 'P'),
(200029, 'Jungo (historical)', 40.9172210693359, 0.714140228426307, -118.382781982422, -2.06616932326388, 218, 39, 'PPL', 'P'),
(32887, 'Juniata', 38.9152793884277, 0.679199754661549, -97.9644393920898, -1.7098020172624, 218, 20, 'PPL', 'P'),
(116277, 'Juniata', 42.5802803039551, 0.743166087726108, -95.1477813720703, -1.66064206091035, 218, 16, 'PPL', 'P'),
(131523, 'Juniata', 43.3497200012207, 0.756595343838942, -83.4622192382813, -1.45669052672936, 218, 27, 'PPL', 'P'),
(142146, 'Juniata', 40.5900001525879, 0.70842914604766, -98.5058288574219, -1.71925104596806, 218, 35, 'PPL', 'P'),
(163201, 'Juniata', 40.0083312988281, 0.69827710939325, -75.1091690063477, -1.31090229759764, 218, 45, 'PPL', 'P'),
(78536, 'Juniata Crossing', 39.9944381713867, 0.698034628575998, -78.2688903808594, -1.36604983902851, 218, 45, 'PPL', 'P'),
(163203, 'Juniata Furnace', 40.4552803039551, 0.706077841121229, -77.1686096191406, -1.34684631704017, 218, 45, 'PPL', 'P'),
(163204, 'Juniata Gap', 40.5488891601563, 0.707711623870965, -78.429443359375, -1.3688520171275, 218, 45, 'PPL', 'P'),
(163210, 'Juniata Terrace', 40.5855598449707, 0.708351648059938, -77.57861328125, -1.35400223088921, 218, 45, 'PPL', 'P'),
(109892, 'Junior', 38.9786109924316, 0.680305099671987, -79.9497222900391, -1.39538589001628, 218, 58, 'PPL', 'P'),
(73082, 'Junior Furnace', 38.6230583190918, 0.674099534857939, -82.8091735839844, -1.44529272989604, 218, 41, 'PPL', 'P'),
(16684, 'Juniper', 30.5424995422363, 0.533067178800885, -84.7533264160156, -1.47922459797696, 218, 12, 'PPL', 'P'),
(22312, 'Juniper', 32.5311088562012, 0.567774958865397, -84.6044387817383, -1.47662601854331, 218, 13, 'PPL', 'P'),
(66021, 'Juniper', 35.6316719055176, 0.621889992741644, -78.6416702270508, -1.37255607472963, 218, 33, 'PPL', 'P'),
(131522, 'Juniper', 46.3580589294434, 0.809100763152344, -86.5902786254883, -1.51128546223404, 218, 27, 'PPL', 'P'),
(193136, 'Juniper', 41.4799995422363, 0.723962565737765, -120.571670532227, -2.10437263541718, 218, 6, 'PPL', 'P'),
(195168, 'Juniper', 42.1533317565918, 0.735714429838012, -112.969169616699, -1.97168396305534, 218, 17, 'PPL', 'P'),
(88221, 'Juniper Acres', 35.9613914489746, 0.627644684383141, -86.3805618286133, -1.50762521363184, 218, 50, 'PPL', 'P'),
(81824, 'Juniper Bay', 33.8711090087891, 0.591162373505282, -79.1697235107422, -1.38177234315602, 218, 48, 'PPL', 'P'),
(36662, 'Juniper Beach', 38.3205604553223, 0.668819951154911, -85.647216796875, -1.49482592827486, 218, 21, 'PPL', 'P'),
(207757, 'Juniper Beach', 48.2311096191406, 0.841791664744312, -122.405830383301, -2.13638476382631, 218, 56, 'PPL', 'P'),
(163209, 'Juniper Circle', 40.6399993896484, 0.709301797357851, -75.4925003051758, -1.31759269088814, 218, 45, 'PPL', 'P'),
(60459, 'Juniper Grove', 30.7680606842041, 0.537003963392781, -89.5013885498047, -1.56209391530084, 218, 30, 'PPL', 'P'),
(178432, 'Juniper Heights', 34.521671295166, 0.602516827391862, -112.462219238281, -1.96283600980772, 218, 5, 'PPL', 'P'),
(182413, 'Juniper Hills', 34.4441719055176, 0.601164207874211, -117.934440612793, -2.05834429019096, 218, 6, 'PPL', 'P'),
(194263, 'Juniper Hot Springs', 40.4672203063965, 0.706286233476527, -107.953056335449, -1.88413627064451, 218, 7, 'PPL', 'P'),
(192647, 'Juniper Park Resort', 37.7133293151855, 0.658221768438886, -112.621673583984, -1.96561901314685, 218, 52, 'PPL', 'P'),
(182414, 'Juniper Springs', 33.7661094665527, 0.589329785780171, -117.08332824707, -2.04348957710466, 218, 6, 'PPL', 'P'),
(170637, 'Junius', 44.0063896179199, 0.768056390748152, -97.2438888549805, -1.69722603796283, 218, 49, 'PPL', 'P'),
(66027, 'Junker', 35.2622184753418, 0.615441813952289, -80.7627792358398, -1.40957641072672, 218, 33, 'PPL', 'P'),
(55624, 'Junland', 36.7686080932617, 0.641733272602851, -90.2808303833008, -1.57569774162313, 218, 29, 'PPL', 'P'),
(22314, 'Juno', 34.475830078125, 0.601716747221375, -84.1941680908203, -1.46946544416236, 218, 13, 'PPL', 'P'),
(66022, 'Juno', 35.6399993896484, 0.622035334758135, -82.6469421386719, -1.44246125702507, 218, 33, 'PPL', 'P'),
(88222, 'Juno', 35.6980590820313, 0.62304866755291, -88.5205612182617, -1.54497524897187, 218, 50, 'PPL', 'P'),
(191678, 'Juno', 30.1516704559326, 0.526245924432324, -101.11499786377, -1.76478963586981, 218, 51, 'PPL', 'P'),
(198462, 'Juno', 48.8983306884766, 0.853436869242902, -103.20361328125, -1.80124285171276, 218, 34, 'PPL', 'P'),
(207758, 'Juno', 47.1150016784668, 0.8223119063719, -117.573890686035, -2.05205150685121, 218, 56, 'PPL', 'P'),
(16685, 'Juno Beach', 26.8794403076172, 0.469134734461197, -80.0536117553711, -1.39719910324446, 218, 12, 'PPL', 'P'),
(16686, 'Juno Isles', 26.8633308410645, 0.468853571229112, -80.0611114501953, -1.39732999761204, 218, 12, 'PPL', 'P'),
(16687, 'Juno Ridge', 26.8477802276611, 0.46858216182452, -80.0625, -1.39735423237796, 218, 12, 'PPL', 'P'),
(22315, 'Junta', 34.1736106872559, 0.596442023787337, -84.8008270263672, -1.4800536400243, 218, 13, 'PPL', 'P'),
(103239, 'Junta (historical)', 37.0330581665039, 0.646348797088068, -80.0533294677734, -1.39719417639645, 218, 53, 'PPL', 'P'),
(109893, 'Junta (historical)', 37.5169410705566, 0.6547941469579, -80.8386077880859, -1.41089986863043, 218, 58, 'PPL', 'P'),
(36666, 'Junte', 38.0811080932617, 0.664640719035277, -85.0977783203125, -1.4852364178217, 218, 21, 'PPL', 'P'),
(201053, 'Juntura', 43.7447204589844, 0.763489402373802, -118.07861328125, -2.06086057794692, 218, 43, 'PPL', 'P'),
(16688, 'Jupiter', 26.9338893890381, 0.470085050206679, -80.0944366455078, -1.39791163199411, 218, 12, 'PPL', 'P'),
(66023, 'Jupiter', 35.7608299255371, 0.624144225446341, -82.5936126708984, -1.44153048222409, 218, 33, 'PPL', 'P'),
(182415, 'Jupiter', 38.122501373291, 0.665363168059988, -120.281669616699, -2.09931116460743, 218, 6, 'PPL', 'P'),
(16689, 'Jupiter Inlet Beach Colony', 26.9486103057861, 0.470341978672844, -80.0749969482422, -1.39757234527124, 218, 12, 'PPL', 'P'),
(16690, 'Jupiter Island', 27.0311107635498, 0.471781883295223, -80.1016693115234, -1.39803786582978, 218, 12, 'PPL', 'P'),
(136164, 'Jurgenson', 47.332218170166, 0.826103049341683, -93.2294387817383, -1.62716066652782, 218, 28, 'PPL', 'P'),
(22316, 'Jushua Tree Villas', 33.5291709899902, 0.585194429239496, -82.085563659668, -1.43266335421661, 218, 13, 'PPL', 'P'),
(66024, 'Just Crossroads', 36.1891708374023, 0.631620184679384, -79.2825012207031, -1.38374068551769, 218, 33, 'PPL', 'P'),
(36664, 'Justell', 37.5563888549805, 0.655482640678712, -82.6380615234375, -1.44230626104963, 218, 21, 'PPL', 'P'),
(36665, 'Justice', 36.8811111450195, 0.643696821274567, -87.0561065673828, -1.51941569356789, 218, 21, 'PPL', 'P'),
(66026, 'Justice', 36.0583305358887, 0.629336590623669, -78.1708297729492, -1.36433835855398, 218, 33, 'PPL', 'P'),
(76245, 'Justice', 36.292781829834, 0.633428537638575, -95.5663909912109, -1.66794817704488, 218, 42, 'PPL', 'P'),
(109894, 'Justice', 37.5886116027832, 0.65604503372191, -81.835563659668, -1.42830003108663, 218, 58, 'PPL', 'P'),
(120168, 'Justice', 41.7444381713867, 0.728577890485899, -87.8377838134766, -1.53305853520015, 218, 18, 'PPL', 'P'),
(109895, 'Justice Addition', 37.8925018310547, 0.661348918769884, -81.9930572509766, -1.43104881280575, 218, 58, 'PPL', 'P'),
(48571, 'Justice Heights', 38.3752784729004, 0.669774960721813, -75.5511093139648, -1.31861561106284, 218, 25, 'PPL', 'P'),
(191680, 'Justiceburg', 33.042781829834, 0.57670533694876, -101.202499389648, -1.76631682559692, 218, 51, 'PPL', 'P'),
(36667, 'Justiceville', 37.4130592346191, 0.652981066887774, -82.4519424438477, -1.43905787031, 218, 21, 'PPL', 'P'),
(48572, 'Justifiable', 39.327220916748, 0.686389490656436, -77.0297164916992, -1.34442217465793, 218, 25, 'PPL', 'P'),
(95238, 'Justin', 33.0847206115723, 0.577437306774368, -97.2958297729492, -1.69813257799789, 218, 51, 'PPL', 'P'),
(41562, 'Justina', 31.9772205352783, 0.55810778397695, -91.429443359375, -1.59574481988676, 218, 22, 'PPL', 'P'),
(103240, 'Justisville', 37.7958297729492, 0.659661673061265, -75.686393737793, -1.32097676968531, 218, 53, 'PPL', 'P'),
(163211, 'Justus', 41.5022201538086, 0.724350388571507, -75.6402816772461, -1.32017196240388, 218, 45, 'PPL', 'P'),
(177399, 'Justus', 40.7044410705566, 0.710426516865219, -81.5791702270508, -1.42382512150697, 218, 41, 'PPL', 'P'),
(145514, 'Jutland', 40.6227798461914, 0.709001259628836, -74.9647216796875, -1.30838121615172, 218, 37, 'PPL', 'P'),
(88223, 'K C Subdivision', 35.8511085510254, 0.625719884705287, -86.48388671875, -1.50942857316398, 218, 50, 'PPL', 'P'),
(193688, 'K Flourney', 41.223331451416, 0.719482862468142, -120.530281066895, -2.10365025297149, 218, 6, 'PPL', 'P'),
(163212, 'K O Junction', 41.4741706848145, 0.723860832984124, -80.3647232055664, -1.40262902239103, 218, 45, 'PPL', 'P'),
(22317, 'K''Ville', 31.5563907623291, 0.550762918848566, -82.1258316040039, -1.43336616242828, 218, 13, 'PPL', 'P'),
(95239, 'K-Bar Ranch', 27.9919395446777, 0.488551509073829, -97.9255599975586, -1.70912344381665, 218, 51, 'PPL', 'P'),
(95240, 'K-Bar Ranch Colonia', 27.7320003509521, 0.484014714288338, -98.1190032958984, -1.7124996662886, 218, 51, 'PPL', 'P'),
(95241, 'K-Bar-J Estates Colonia', 27.9759998321533, 0.488273308608456, -97.9250030517578, -1.70911372327867, 218, 51, 'PPL', 'P'),
(211596, 'Kaaawa', 21.5572204589844, 0.376244474587561, -157.853607177734, -2.75506518140122, 218, 15, 'PPL', 'P'),
(211606, 'Kaalawai', 21.2619400024414, 0.371090858404094, -157.800827026367, -2.75414399398016, 218, 15, 'PPL', 'P'),
(211610, 'Kaanapali Landing', 20.9333305358887, 0.365355541259526, -156.699996948242, -2.73493088461189, 218, 15, 'PPL', 'P'),
(211605, 'Kaau', 20.1091709136963, 0.350971242290277, -155.611389160156, -2.71593109444694, 218, 15, 'PPL', 'P'),
(211626, 'Kaawanui Village', 21.9461097717285, 0.383031873520764, -159.63166809082, -2.78609819863558, 218, 15, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(211625, 'KaÃ‚â€˜awaloa', 19.4825000762939, 0.340033772851376, -155.936676025391, -2.72160842125877, 218, 15, 'PPL', 'P'),
(210284, 'KaÃ‚â€˜ÃƒÂ¼pÃƒÂ¼lehu', 19.8347206115723, 0.346181180885119, -155.989166259766, -2.72252454867376, 218, 15, 'PPL', 'P'),
(211629, 'KaÃ‚â€˜elekÃƒÂ¼', 20.7863903045654, 0.362790950419294, -156.026107788086, -2.72316929997367, 218, 15, 'PPL', 'P'),
(210033, 'KaÃ‚â€˜iliÃ‚â€˜ili', 20.8474998474121, 0.363857513146357, -156.272506713867, -2.72746977250193, 218, 15, 'PPL', 'P'),
(136165, 'Kabekona Corner', 47.2347183227539, 0.824401355984149, -94.8763885498047, -1.65590536259554, 218, 28, 'PPL', 'P'),
(136166, 'Kabetogama', 48.4377784729004, 0.845398716703743, -93.0272216796875, -1.6236313122932, 218, 28, 'PPL', 'P'),
(48573, 'Kabik Korner', 39.3613891601563, 0.686985839003532, -77.0180587768555, -1.34421870915064, 218, 25, 'PPL', 'P'),
(109897, 'Kabletown', 39.2163887023926, 0.684455103598657, -77.8572235107422, -1.35886489672359, 218, 58, 'PPL', 'P'),
(149946, 'Kabob', 42.2833290100098, 0.737983309928705, -79.315559387207, -1.38431765936786, 218, 40, 'PPL', 'P'),
(73083, 'Kachelmacher (historical)', 39.5363883972168, 0.690040151878717, -82.2774963378906, -1.43601321139377, 218, 41, 'PPL', 'P'),
(211899, 'Kachemak City', 59.6699981689453, 1.04143793270708, -151.434173583984, -2.64302492907715, 218, 1, 'PPL', 'P'),
(211900, 'Kachemak Silo', 59.7999992370605, 1.0437068793768, -151.058334350586, -2.63646529699618, 218, 1, 'PPL', 'P'),
(207759, 'Kachess Resort', 47.3327789306641, 0.826112836458689, -121.252777099609, -2.11626018757496, 218, 56, 'PPL', 'P'),
(178433, 'Kachina Village', 35.0969390869141, 0.612557144438543, -111.691940307617, -1.94939210630889, 218, 5, 'PPL', 'P'),
(182419, 'Kaci-badon (historical)', 39.0402793884277, 0.681381416226542, -122.912498474121, -2.14522779022592, 218, 6, 'PPL', 'P'),
(32888, 'Kackley', 39.7000007629395, 0.692895726357554, -97.852783203125, -1.70785324913473, 218, 20, 'PPL', 'P'),
(95242, 'Kadane Corner', 33.857780456543, 0.590929746384064, -98.8383331298828, -1.72505434029945, 218, 51, 'PPL', 'P'),
(41563, 'Kadesh', 31.7041702270508, 0.553342157074794, -92.9111099243164, -1.6216047798617, 218, 22, 'PPL', 'P'),
(202264, 'Kadoka', 43.8338890075684, 0.765045687135817, -101.509437561035, -1.77167390728767, 218, 49, 'PPL', 'P'),
(202265, 'Kadoka Junction', 43.8358306884766, 0.765079575860689, -101.521942138672, -1.771892153339, 218, 49, 'PPL', 'P'),
(182420, 'Kadota', 37.2949981689453, 0.650920512573352, -120.411109924316, -2.10157032416014, 218, 6, 'PPL', 'P'),
(48574, 'Kaese Mill', 39.6502799987793, 0.692027935316352, -79.29638671875, -1.38398303317689, 218, 25, 'PPL', 'P'),
(177739, 'Kaffir', 34.6333312988281, 0.604465662098555, -101.820281982422, -1.77709916590232, 218, 51, 'PPL', 'P'),
(55626, 'Kagel', 37.2058296203613, 0.649364227811337, -89.6333312988281, -1.56439675069544, 218, 29, 'PPL', 'P'),
(178434, 'Kahachi Miliuk', 31.8024997711182, 0.555058331370755, -111.695831298828, -1.94946001691669, 218, 5, 'PPL', 'P'),
(211634, 'Kahakuloa', 20.999719619751, 0.366514249360306, -156.553894042969, -2.73238090786814, 218, 15, 'PPL', 'P'),
(211635, 'Kahala', 21.2697200775146, 0.371226646330174, -157.786392211914, -2.75389205894104, 218, 15, 'PPL', 'P'),
(209981, 'KahaluÃ‚â€˜u', 21.4633293151855, 0.374605764989808, -157.836669921875, -2.75476957052022, 218, 15, 'PPL', 'P'),
(209979, 'Kahaluu', 19.5833301544189, 0.3417935896997, -155.969177246094, -2.72217567457096, 218, 15, 'PPL', 'P'),
(209986, 'Kahana', 21.5580596923828, 0.376259121973556, -157.879165649414, -2.75551126088381, 218, 15, 'PPL', 'P'),
(3475, 'Kahatchee', 33.202220916748, 0.579488073971783, -86.408332824707, -1.50810990895023, 218, 2, 'PPL', 'P'),
(210004, 'Kaheka Village', 20.8955593109131, 0.364696309021191, -156.36555480957, -2.72909376813466, 218, 15, 'PPL', 'P'),
(163213, 'Kahkhout Mountain', 41.0811080932617, 0.717000596595107, -75.0591735839844, -1.31002971286648, 218, 45, 'PPL', 'P'),
(196804, 'Kahle (historical)', 48.5800018310547, 0.847880982576778, -105.470001220703, -1.84079878338371, 218, 31, 'PPL', 'P'),
(194264, 'Kahler', 40.3283309936523, 0.70386215767331, -104.998062133789, -1.8325618924482, 218, 7, 'PPL', 'P'),
(163214, 'Kahletown', 41.2724990844727, 0.720340999550393, -79.1575012207031, -1.3815590239527, 218, 45, 'PPL', 'P'),
(207760, 'Kahlotus', 46.6433296203613, 0.814079675968302, -118.55583190918, -2.06918961425614, 218, 56, 'PPL', 'P'),
(27586, 'Kahm', 39.3277816772461, 0.686399277773442, -90.2608337402344, -1.57534873436228, 218, 18, 'PPL', 'P'),
(41564, 'Kahns', 30.4819393157959, 0.532010203453746, -91.2519378662109, -1.59264676459067, 218, 22, 'PPL', 'P'),
(139249, 'Kahoka', 40.420280456543, 0.705466978546192, -91.7194366455078, -1.60080615753845, 218, 29, 'PPL', 'P'),
(9809, 'Kahoka (historical)', 35.7963905334473, 0.624764875138384, -91.9944381713867, -1.60560583961305, 218, 4, 'PPL', 'P'),
(210021, 'Kahuku', 21.6802806854248, 0.378392280717196, -157.951110839844, -2.75676694133778, 218, 15, 'PPL', 'P'),
(210024, 'Kahului', 20.8947200775146, 0.364681661635195, -156.470001220703, -2.73091670190082, 218, 15, 'PPL', 'P'),
(178435, 'Kaibab', 36.896671295166, 0.643968397126727, -112.73999786377, -1.96768416141415, 218, 5, 'PPL', 'P'),
(178436, 'Kaibito', 36.5972213745117, 0.638742010066474, -111.073608398438, -1.93860017862356, 218, 5, 'PPL', 'P'),
(178437, 'Kaihon Kug', 32.0161094665527, 0.558786523870271, -112.078887939453, -1.95614561651722, 218, 5, 'PPL', 'P'),
(210040, 'Kailua', 19.6405601501465, 0.342792441556048, -155.995559692383, -2.72263613512343, 218, 15, 'PPL', 'P'),
(211319, 'Kailua Village', 20.8713893890381, 0.364274464304522, -156.365005493164, -2.72908418075473, 218, 15, 'PPL', 'P'),
(210043, 'Kaimu', 19.3647193908691, 0.337978112095457, -154.972213745117, -2.70477537895671, 218, 15, 'PPL', 'P'),
(210044, 'Kaimuki', 21.2827796936035, 0.371454579629971, -157.801666259766, -2.75415864136616, 218, 15, 'PPL', 'P'),
(210045, 'Kainaliu', 19.5349998474121, 0.340950066713931, -155.928894042969, -2.72147260004318, 218, 15, 'PPL', 'P'),
(55627, 'Kaiser', 38.1336097717285, 0.665557046187346, -92.5897216796875, -1.61599549681572, 218, 29, 'PPL', 'P'),
(182421, 'Kaiser', 34.0938911437988, 0.595050655275825, -117.488059997559, -2.05055347873804, 218, 6, 'PPL', 'P'),
(174721, 'Kaiser (historical)', 45.9097213745117, 0.801275796658446, -90.5513916015625, -1.58041992571001, 218, 57, 'PPL', 'P'),
(149948, 'Kaisertown', 41.5072212219238, 0.724437673676235, -74.2844390869141, -1.29650804506382, 218, 40, 'PPL', 'P'),
(131524, 'Kaiserville', 42.4316711425781, 0.740572368561453, -84.0302810668945, -1.46660507599356, 218, 27, 'PPL', 'P'),
(163217, 'Kaiserville', 41.6116714477539, 0.726260674021421, -75.9824981689453, -1.32614476693866, 218, 45, 'PPL', 'P'),
(196805, 'Kaiver (historical)', 48.2811088562012, 0.842664316054504, -106.386108398438, -1.85678786993633, 218, 31, 'PPL', 'P'),
(178438, 'Kaka', 32.5097198486328, 0.567401650259595, -112.315826416016, -1.9602809730579, 218, 5, 'PPL', 'P'),
(193165, 'Kake', 56.975830078125, 0.994415828920099, -133.947219848633, -2.33782001025134, 218, 1, 'PPL', 'P'),
(211901, 'Kako Landing', 61.853889465332, 1.07955402633468, -161.346389770508, -2.81602573770146, 218, 1, 'PPL', 'P'),
(211902, 'Kaktovik', 70.1319427490234, 1.22403331179062, -143.623886108398, -2.5067096971009, 218, 1, 'PPL', 'P'),
(210062, 'KalaÃ‚â€˜e', 21.1652793884277, 0.369403812432556, -157.008331298828, -2.74031233422662, 218, 15, 'PPL', 'P'),
(210064, 'Kalaheo', 21.9286098480225, 0.382726442233245, -159.5302734375, -2.78432852809123, 218, 15, 'PPL', 'P'),
(211903, 'Kalak', 61.9500007629395, 1.08123148492629, -162.866668701172, -2.84255961059025, 218, 1, 'PPL', 'P'),
(207761, 'Kalaloch', 47.6047210693359, 0.830859122153428, -124.371109008789, -2.17068534656015, 218, 56, 'PPL', 'P'),
(207762, 'Kalama', 46.0086097717285, 0.803001724781899, -122.843330383301, -2.14402057930379, 218, 56, 'PPL', 'P'),
(9808, 'Kalamazoo', 35.3680610656738, 0.617289115642423, -93.6944427490234, -1.63527651679179, 218, 4, 'PPL', 'P'),
(16691, 'Kalamazoo', 28.8458309173584, 0.50345472498148, -81.1102828979492, -1.41564149379326, 218, 12, 'PPL', 'P'),
(109901, 'Kalamazoo', 39.1413917541504, 0.683146159922883, -79.9161071777344, -1.39479919562814, 218, 58, 'PPL', 'P'),
(131525, 'Kalamazoo', 42.2916717529297, 0.738128918261305, -85.5872192382813, -1.49377877333424, 218, 27, 'PPL', 'P'),
(142148, 'Kalamazoo', 41.8291702270508, 0.73005674383922, -97.6399993896484, -1.70413947099462, 218, 35, 'PPL', 'P'),
(131534, 'Kalamo', 42.542781829834, 0.742511615888221, -85.0127792358398, -1.48375290393647, 218, 27, 'PPL', 'P'),
(210083, 'Kalaoa', 19.728609085083, 0.344329185373565, -155.981674194336, -2.72239378746424, 218, 15, 'PPL', 'P'),
(210095, 'Kalapana', 19.3541698455811, 0.337793987795592, -154.978607177734, -2.70488696540638, 218, 15, 'PPL', 'P'),
(210096, 'Kalapana Sea View Estates', 19.4097194671631, 0.338763511590435, -154.925827026367, -2.70396577798532, 218, 15, 'PPL', 'P'),
(145515, 'Kalarama', 40.9658317565918, 0.714988644970579, -74.9925003051758, -1.30886604462817, 218, 37, 'PPL', 'P'),
(210098, 'Kalauao', 21.3847198486328, 0.373233770975226, -157.948059082031, -2.75671367811598, 218, 15, 'PPL', 'P'),
(210099, 'Kalaupapa', 21.1924991607666, 0.369878887081512, -156.986114501953, -2.7399245779719, 218, 15, 'PPL', 'P'),
(210102, 'Kalawao', 21.1802806854248, 0.369665634457224, -156.951110839844, -2.73931364881784, 218, 15, 'PPL', 'P'),
(109900, 'Kale', 37.3841705322266, 0.652476863914394, -81.1855621337891, -1.41695536431705, 218, 58, 'PPL', 'P'),
(3476, 'Kalem', 31.7049999237061, 0.553356638013222, -87.2158279418945, -1.52220335743893, 218, 2, 'PPL', 'P'),
(60461, 'Kalem', 32.3549995422363, 0.564701271493282, -89.5927810668945, -1.56368901563575, 218, 30, 'PPL', 'P'),
(36668, 'Kaler', 36.8855590820313, 0.643774452420342, -88.54638671875, -1.54542598898637, 218, 21, 'PPL', 'P'),
(127845, 'Kalers Corner', 44.0958290100098, 0.769617402621102, -69.3850021362305, -1.21099673878052, 218, 26, 'PPL', 'P'),
(131530, 'Kaleva', 44.3733291625977, 0.774460693958547, -86.0102767944336, -1.50116252061454, 218, 27, 'PPL', 'P'),
(191681, 'Kalgary', 33.4088897705078, 0.583095125931214, -101.148063659668, -1.76536674287803, 218, 51, 'PPL', 'P'),
(88224, 'Kalida', 36.0027809143066, 0.628367066828825, -84.3572235107422, -1.47231129810322, 218, 50, 'PPL', 'P'),
(155954, 'Kalida', 40.982780456543, 0.71528445558866, -84.1994400024414, -1.46955745637802, 218, 41, 'PPL', 'P'),
(211904, 'Kalifornsky', 60.4183311462402, 1.05449880706213, -151.289993286133, -2.64050850816313, 218, 1, 'PPL', 'P'),
(210109, 'Kalihi', 21.336389541626, 0.372390247989457, -157.876388549805, -2.75546279135197, 218, 15, 'PPL', 'P'),
(210113, 'Kalihi Kai', 21.3266696929932, 0.372220604628019, -157.888610839844, -2.75567611055528, 218, 15, 'PPL', 'P'),
(210117, 'Kalihiwai', 22.2175006866455, 0.387768538546065, -159.432495117188, -2.7826219744647, 218, 15, 'PPL', 'P'),
(193689, 'Kalina', 41.9952812194824, 0.732955927580908, -121.419166564941, -2.11916423158564, 218, 6, 'PPL', 'P'),
(174722, 'Kalinke', 45.0305595397949, 0.785931527984764, -89.3969421386719, -1.56027098153469, 218, 57, 'PPL', 'P'),
(36669, 'Kaliopi', 37.2333297729492, 0.649844196018797, -83.4166717529297, -1.45589557314397, 218, 21, 'PPL', 'P'),
(196806, 'Kalispell', 48.1958312988281, 0.841175941900286, -114.311943054199, -1.99511978064804, 218, 31, 'PPL', 'P'),
(131531, 'Kalkaska', 44.7341690063477, 0.780758537304367, -85.1758270263672, -1.48659862471928, 218, 27, 'PPL', 'P'),
(211906, 'Kalla', 66.9002838134766, 1.16763022306383, -156.643890380859, -2.73395164027907, 218, 1, 'PPL', 'P'),
(211905, 'Kallands', 65.1852798461914, 1.13769775714994, -153.05778503418, -2.67136229465614, 218, 1, 'PPL', 'P'),
(149947, 'Kallops Corners', 41.860279083252, 0.73059969580646, -74.070556640625, -1.29277509216386, 218, 40, 'PPL', 'P'),
(48575, 'Kalmia', 39.605281829834, 0.691242569110888, -76.304443359375, -1.33176377052262, 218, 25, 'PPL', 'P'),
(66029, 'Kalmia', 35.9297218322754, 0.627091945298895, -82.023063659668, -1.43157252343412, 218, 33, 'PPL', 'P'),
(81828, 'Kalmia Place', 34.3569412231445, 0.59964174525804, -80.1105575561523, -1.39819299496328, 218, 48, 'PPL', 'P'),
(48576, 'Kalmia Ridge', 39.019718170166, 0.681022555269654, -76.5733337402344, -1.33645679299555, 218, 25, 'PPL', 'P'),
(116278, 'Kalo', 42.4311103820801, 0.740562581444447, -94.1316680908203, -1.6429075385793, 218, 16, 'PPL', 'P'),
(16692, 'Kalon', 28.5077800750732, 0.497554624744464, -82.1566696166992, -1.43390438728459, 218, 12, 'PPL', 'P'),
(3478, 'Kalona', 32.9805603027344, 0.575619366435253, -86.769172668457, -1.51440775229605, 218, 2, 'PPL', 'P'),
(116279, 'Kalona', 41.4830589294434, 0.724015962117621, -91.7058334350586, -1.60056873672727, 218, 16, 'PPL', 'P'),
(13134, 'Kalorama Heights', 38.9166717529297, 0.679224056006496, -77.0527801513672, -1.34482471145669, 218, 9, 'PPL', 'P'),
(122941, 'Kalorama Park', 41.3344383239746, 0.721422043215884, -85.7608337402344, -1.49680891802253, 218, 19, 'PPL', 'P'),
(13135, 'Kalorama Triangle', 38.9166717529297, 0.679224056006496, -77.0416717529297, -1.34463083332933, 218, 9, 'PPL', 'P'),
(78538, 'Kalreda Woods', 39.9949989318848, 0.698044415693004, -76.7044372558594, -1.33874498100415, 218, 45, 'PPL', 'P'),
(211907, 'Kalskag', 61.5372200012207, 1.07402710154541, -160.305282592773, -2.79785498958385, 218, 1, 'PPL', 'P'),
(211908, 'Kaltag', 64.3272171020508, 1.12272173707599, -158.721939086914, -2.77022043221653, 218, 1, 'PPL', 'P'),
(48577, 'Kalten Acres', 39.6191711425781, 0.691484983349112, -76.9997177124023, -1.34389859718762, 218, 25, 'PPL', 'P'),
(210125, 'KaluaÃ‚â€˜aha', 21.0699996948242, 0.367740868068883, -156.821105957031, -2.73704463556909, 218, 15, 'PPL', 'P'),
(113197, 'Kalurah', 44.1599998474121, 0.770737395017535, -75.210563659668, -1.312671968142, 218, 40, 'PPL', 'P'),
(187740, 'Kalvesta', 38.059440612793, 0.664262550160486, -100.285827636719, -1.75031788534827, 218, 20, 'PPL', 'P'),
(210139, 'KamalÃƒÂ¶', 21.0505599975586, 0.367401581346007, -156.876937866211, -2.73801908621195, 218, 15, 'PPL', 'P'),
(210137, 'Kamalino', 21.8374996185303, 0.381136268746359, -160.233612060547, -2.79660410281984, 218, 15, 'PPL', 'P'),
(127846, 'Kamankeag (historical)', 45.0119400024414, 0.785606555752747, -70.7947235107422, -1.23560101830149, 218, 26, 'PPL', 'P'),
(204512, 'Kamas', 40.6430587768555, 0.709355193737707, -111.279998779297, -1.942202370314, 218, 52, 'PPL', 'P'),
(95243, 'Kamay', 33.857780456543, 0.590929746384064, -98.8077774047852, -1.72452104229116, 218, 51, 'PPL', 'P'),
(210154, 'Kamehameha Heights', 21.3349990844727, 0.372365979934024, -157.864715576172, -2.75525905952858, 218, 15, 'PPL', 'P'),
(195169, 'Kameron', 46.7724990844727, 0.816334108410081, -116.253059387207, -2.02899865182326, 218, 17, 'PPL', 'P'),
(95244, 'Kamey', 28.6358299255371, 0.499789516241745, -96.7430572509766, -1.68848487747492, 218, 51, 'PPL', 'P'),
(195170, 'Kamiah', 46.2272186279297, 0.806817169096629, -116.028327941895, -2.0250763481698, 218, 17, 'PPL', 'P'),
(207763, 'Kamilche', 47.1305618286133, 0.822583482224061, -123.096672058105, -2.14844222566165, 218, 56, 'PPL', 'P'),
(210157, 'Kamiloloa', 21.083890914917, 0.367983315596621, -157.002212524414, -2.7402055414669, 218, 15, 'PPL', 'P'),
(163215, 'Kammerer', 40.1836090087891, 0.701336282537424, -80.0480575561523, -1.39710216418078, 218, 45, 'PPL', 'P'),
(116280, 'Kammerer Trailer Court', 41.3727798461914, 0.722091229018793, -91.0888900756836, -1.58980104380787, 218, 16, 'PPL', 'P'),
(155950, 'Kamms Corner', 41.4502792358398, 0.723443848536444, -81.8180618286133, -1.42799456650959, 218, 41, 'PPL', 'P'),
(209537, 'Kamms Corner', 44.7255592346191, 0.780608268439859, -108.931938171387, -1.90122098166959, 218, 59, 'PPL', 'P'),
(210161, 'KamoÃ‚â€˜oloa', 21.5727806091309, 0.376516050439721, -158.114166259766, -2.75961279527864, 218, 15, 'PPL', 'P'),
(145516, 'Kampe', 41.1669387817383, 0.718498624708276, -74.456672668457, -1.29951408814425, 218, 37, 'PPL', 'P'),
(27587, 'Kampenville', 38.0194396972656, 0.663564402480721, -89.602783203125, -1.5638635858452, 218, 18, 'PPL', 'P'),
(170638, 'Kampeska', 44.8800010681152, 0.783303786937183, -97.2683334350586, -1.69765267636946, 218, 49, 'PPL', 'P'),
(200031, 'Kampos', 40.6958312988281, 0.710276248000711, -116.700828552246, -2.0368136980421, 218, 39, 'PPL', 'P'),
(27588, 'Kampsville', 39.297779083252, 0.685875633724105, -90.60888671875, -1.58142340480875, 218, 18, 'PPL', 'P'),
(55628, 'Kampville', 38.8525009155273, 0.678104063610063, -90.5458297729492, -1.58032285348827, 218, 29, 'PPL', 'P'),
(116281, 'Kamrar', 42.392219543457, 0.739883808261613, -93.7291717529297, -1.63588265225589, 218, 16, 'PPL', 'P'),
(192648, 'Kanab', 37.0475006103516, 0.646600865285244, -112.52555847168, -1.96394148797621, 218, 52, 'PPL', 'P'),
(210164, 'Kanahena', 20.6180591583252, 0.359853017683746, -156.436111450195, -2.73032521382271, 218, 15, 'PPL', 'P'),
(16693, 'Kanapaha', 29.5969390869141, 0.516564035578855, -82.4227828979492, -1.43854894022569, 218, 12, 'PPL', 'P'),
(211909, 'Kanapak', 61.8344383239746, 1.07921453987472, -163.202224731445, -2.84841616814344, 218, 1, 'PPL', 'P'),
(136171, 'Kanaranzi', 43.5758285522461, 0.760541682521248, -96.0941696166992, -1.6771596517813, 218, 28, 'PPL', 'P'),
(192649, 'Kanarraville', 37.538890838623, 0.655177242680708, -113.183326721191, -1.97542170964527, 218, 52, 'PPL', 'P'),
(207766, 'Kanaskat', 47.3205604553223, 0.825899583834401, -121.892501831055, -2.12742549044512, 218, 56, 'PPL', 'P'),
(207764, 'Kanaskat Junction', 47.332218170166, 0.826103049341683, -121.890556335449, -2.12739153514122, 218, 56, 'PPL', 'P'),
(122942, 'Kanata Manayunk', 41.4102783203125, 0.72274570085668, -85.6916732788086, -1.49560184025845, 218, 19, 'PPL', 'P'),
(211910, 'Kanatak', 57.5694389343262, 1.00477625792981, -156.037216186523, -2.72336317810102, 218, 1, 'PPL', 'P'),
(73084, 'Kanauga', 38.8422203063965, 0.677924633131619, -82.147216796875, -1.43373940445506, 218, 41, 'PPL', 'P'),
(95245, 'Kanawha', 33.8613891601563, 0.590992730143844, -95.2527770996094, -1.66247458205644, 218, 51, 'PPL', 'P'),
(109902, 'Kanawha', 39.1988906860352, 0.684149705600652, -81.4602813720703, -1.42175011954363, 218, 58, 'PPL', 'P'),
(116282, 'Kanawha', 42.9377784729004, 0.749405607844055, -93.7930603027344, -1.6369977178043, 218, 16, 'PPL', 'P'),
(109903, 'Kanawha City', 38.3213882446289, 0.668834398803825, -81.5822219848633, -1.42387838472877, 218, 58, 'PPL', 'P'),
(109905, 'Kanawha Drive', 38.9536094665527, 0.679868740727377, -80.8997192382813, -1.41196646464701, 218, 58, 'PPL', 'P'),
(109906, 'Kanawha Estates', 38.2999992370605, 0.668461090198023, -81.5652770996094, -1.42358264068971, 218, 58, 'PPL', 'P'),
(109907, 'Kanawha Falls', 38.1425018310547, 0.66571224189987, -81.206672668457, -1.41732381265386, 218, 58, 'PPL', 'P'),
(109908, 'Kanawha Head', 38.7727813720703, 0.676712695098551, -80.3466720581055, -1.40231397043407, 218, 58, 'PPL', 'P'),
(182422, 'Kanawyers', 36.795280456543, 0.642198793161397, -118.583892822266, -2.06967936958061, 218, 6, 'PPL', 'P'),
(32889, 'Kanbrick', 38.4727783203125, 0.671476654079347, -98.7769393920898, -1.72398281743485, 218, 20, 'PPL', 'P'),
(187741, 'Kanco', 38.4722213745117, 0.671466933541368, -102.042221069336, -1.78097273370784, 218, 20, 'PPL', 'P'),
(209538, 'Kanda', 41.542781829834, 0.725058323368278, -109.340827941895, -1.90835745444267, 218, 59, 'PPL', 'P'),
(136173, 'Kandiyohi', 45.1322212219238, 0.787705859061029, -94.9308319091797, -1.65685557847248, 218, 28, 'PPL', 'P'),
(193690, 'Kandra', 41.8261108398438, 0.730003347459364, -121.398887634277, -2.11881029747677, 218, 6, 'PPL', 'P'),
(27590, 'Kane', 39.189998626709, 0.683994509888128, -90.3536071777344, -1.57696793630505, 218, 18, 'PPL', 'P'),
(95246, 'Kane', 26.208890914917, 0.457431439761331, -98.2666702270508, -1.71507694043352, 218, 51, 'PPL', 'P'),
(163216, 'Kane', 41.6627807617188, 0.727152699828543, -78.811393737793, -1.37551830881013, 218, 45, 'PPL', 'P'),
(209539, 'Kane', 44.8436088562012, 0.782668623017199, -108.202217102051, -1.8884849463885, 218, 59, 'PPL', 'P'),
(48578, 'Kane Crossroads', 39.1199989318848, 0.682772784738054, -75.8097229003906, -1.32312926963636, 218, 25, 'PPL', 'P'),
(182423, 'Kane Spring', 33.1094398498535, 0.577868738870961, -115.835830688477, -2.02171663729661, 218, 6, 'PPL', 'P'),
(120170, 'Kaneland Estates', 41.8783302307129, 0.730914747763416, -88.5530624389648, -1.54554250228406, 218, 18, 'PPL', 'P'),
(109909, 'Kanes Creek', 39.5088882446289, 0.689560183671257, -79.7527770996094, -1.39194854799732, 218, 58, 'PPL', 'P'),
(163219, 'Kanesholm', 41.6747207641602, 0.727361092183842, -78.7272186279297, -1.37404917599479, 218, 45, 'PPL', 'P'),
(204514, 'Kanesville', 41.190559387207, 0.718910882045021, -112.083061218262, -1.95621845397303, 218, 52, 'PPL', 'P'),
(109910, 'Kanetown', 39.3663902282715, 0.687073124108259, -79.7644424438477, -1.39215214666265, 218, 58, 'PPL', 'P'),
(120171, 'Kaneville', 41.8352813720703, 0.730163403440878, -88.5219421386719, -1.54499935057974, 218, 18, 'PPL', 'P'),
(163220, 'Kaneville', 41.5041694641113, 0.724384410454433, -79.7027816772461, -1.39107596326615, 218, 45, 'PPL', 'P'),
(48579, 'Kangaroo Beach', 38.9686088562012, 0.680130529462532, -76.3177795410156, -1.33199653080189, 218, 25, 'PPL', 'P'),
(120173, 'Kangley', 41.1458282470703, 0.718130176371464, -88.8736114501953, -1.55113713794404, 218, 18, 'PPL', 'P'),
(207765, 'Kangley', 47.3619384765625, 0.826621766543003, -121.878890991211, -2.12718793647589, 218, 56, 'PPL', 'P'),
(210175, 'Kaniahiku Village', 19.4894409179688, 0.340154913391461, -154.927215576172, -2.70399001275124, 218, 15, 'PPL', 'P'),
(120174, 'Kankakee', 41.1199989318848, 0.717679369777941, -87.8611068725586, -1.53346559937277, 218, 18, 'PPL', 'P'),
(122943, 'Kankakee', 41.5083312988281, 0.724457048173165, -86.539436340332, -1.51039809695883, 218, 19, 'PPL', 'P'),
(186904, 'Kannah', 38.9391708374023, 0.679616739109228, -108.446388244629, -1.89274653676485, 218, 7, 'PPL', 'P'),
(66030, 'Kannapolis', 35.4872207641602, 0.619368844716693, -80.621940612793, -1.40711831304057, 218, 33, 'PPL', 'P'),
(103242, 'Kanodes Mill', 37.2380599975586, 0.649926754012589, -80.4736099243164, -1.40452945414491, 218, 53, 'PPL', 'P'),
(149949, 'Kanona', 42.3722190856934, 0.73953473442173, -77.3661117553711, -1.35029337959712, 218, 40, 'PPL', 'P'),
(187742, 'Kanona', 39.7966690063477, 0.694582905487147, -100.389442443848, -1.75212630488648, 218, 20, 'PPL', 'P'),
(32890, 'Kanopolis', 38.711109161377, 0.675636311964969, -98.1569366455078, -1.71316172813559, 218, 20, 'PPL', 'P'),
(187743, 'Kanorado', 39.3330612182617, 0.686491423147159, -102.037498474121, -1.7808903088721, 218, 20, 'PPL', 'P'),
(192651, 'Kanosh', 38.8013916015625, 0.677212037802941, -112.436668395996, -1.96239006348318, 218, 52, 'PPL', 'P'),
(192652, 'Kanosh Indian Village', 38.8199996948242, 0.677536810297877, -112.403060913086, -1.96180350225309, 218, 52, 'PPL', 'P'),
(142150, 'Kanosha (historical)', 40.8861083984375, 0.71359720988004, -95.8555603027344, -1.67299513362669, 218, 35, 'PPL', 'P'),
(3481, 'Kansas', 33.901668548584, 0.591695738092598, -87.5519409179688, -1.5280696355301, 218, 2, 'PPL', 'P'),
(9810, 'Kansas', 33.8580589294434, 0.590934606653053, -92.9880599975586, -1.62294781199943, 218, 4, 'PPL', 'P'),
(27592, 'Kansas', 39.5527801513672, 0.690326241958819, -87.9394378662109, -1.53483273311836, 218, 18, 'PPL', 'P'),
(30233, 'Kansas', 39.3313903808594, 0.686462261533223, -86.0325012207031, -1.50155041002731, 218, 19, 'PPL', 'P'),
(32895, 'Kansas', 38.5002784729004, 0.671956622286806, -98.5002822875977, -1.71915424006243, 218, 20, 'ADM1', 'A'),
(36670, 'Kansas', 36.901668548584, 0.644055615652428, -88.7283325195313, -1.54860154227018, 218, 21, 'PPL', 'P'),
(76246, 'Kansas', 36.2050018310547, 0.63189648764248, -94.7975006103516, -1.65452850831197, 218, 42, 'PPL', 'P'),
(88225, 'Kansas', 36.4527816772461, 0.636221061778605, -86.3805618286133, -1.50762521363184, 218, 50, 'PPL', 'P'),
(155951, 'Kansas', 41.2449989318848, 0.719861031342934, -83.2847213745117, -1.45359260459133, 218, 41, 'PPL', 'P'),
(172170, 'Kansas', 43.0577812194824, 0.751500050883347, -73.1313934326172, -1.27638360197053, 218, 55, 'PPL', 'P'),
(32892, 'Kansas City', 39.1141700744629, 0.682671051984413, -94.6272201538086, -1.6515565536935, 218, 20, 'PPL', 'P'),
(55629, 'Kansas City', 39.0997200012207, 0.682418850629183, -94.5783309936523, -1.65070327688023, 218, 29, 'PPL', 'P'),
(88226, 'Kansas City', 36.1930618286133, 0.631688095287181, -82.4694366455078, -1.43936320172898, 218, 50, 'PPL', 'P'),
(201054, 'Kansas City', 45.5961112976074, 0.795802268249034, -123.14582824707, -2.14930016300681, 218, 43, 'PPL', 'P'),
(155952, 'Kansas Corners', 41.1500015258789, 0.718203013827277, -80.5483322143555, -1.40583360413072, 218, 41, 'PPL', 'P'),
(32893, 'Kansas Falls', 38.9833297729492, 0.680387457928697, -96.913330078125, -1.69145669893533, 218, 20, 'PPL', 'P'),
(196807, 'Kansas Flat (historical)', 48.7313919067383, 0.8505232378523, -106.611671447754, -1.86072468781774, 218, 31, 'PPL', 'P'),
(60462, 'Kansas Landing', 32.7472190856934, 0.571546793917276, -90.7125015258789, -1.58323182434697, 218, 30, 'PPL', 'P'),
(178439, 'Kansas Settlement', 32.064998626709, 0.559639800683532, -109.762222290039, -1.91571217326709, 218, 5, 'PPL', 'P'),
(174723, 'Kansasville', 42.6824989318848, 0.744950139340352, -88.1102828979492, -1.53781454143286, 218, 57, 'PPL', 'P'),
(211911, 'Kantishna', 63.5252799987793, 1.10872529423, -150.958053588867, -2.63471506752777, 218, 1, 'PPL', 'P'),
(163226, 'Kantner', 40.1016693115234, 0.699906165032052, -78.9372177124023, -1.37771435144501, 218, 45, 'PPL', 'P'),
(163221, 'Kanty', 42.1211090087891, 0.735152036794814, -80.0022201538086, -1.39630215058932, 218, 45, 'PPL', 'P'),
(163222, 'Kantz', 40.7769393920898, 0.711691851278143, -76.9011077880859, -1.34217752933315, 218, 45, 'PPL', 'P'),
(163223, 'Kantz Corners', 41.5180587768555, 0.724626824692658, -80.059440612793, -1.3973008359981, 218, 45, 'PPL', 'P'),
(66032, 'Kanuga Pines', 35.2788887023926, 0.61573276430138, -82.4872207641602, -1.43967359315403, 218, 33, 'PPL', 'P'),
(32896, 'Kanwaka', 38.9730606079102, 0.680208227187335, -95.3724975585938, -1.66456409824771, 218, 20, 'PPL', 'P'),
(3480, 'Kaolin', 32.4441719055176, 0.566257622834324, -85.0102767944336, -1.4837092280946, 218, 2, 'PPL', 'P'),
(22319, 'Kaolin', 33.0261116027832, 0.576414386599669, -82.8808288574219, -1.44654335034394, 218, 13, 'PPL', 'P'),
(27594, 'Kaolin', 37.5116691589355, 0.654702134742237, -89.3000030517578, -1.55857907529416, 218, 18, 'PPL', 'P'),
(78539, 'Kaolin', 39.7986106872559, 0.694616794212018, -75.7275009155273, -1.32169422528297, 218, 45, 'PPL', 'P'),
(190363, 'Kaolin (historical)', 36.5069389343262, 0.637166284228502, -114.413330078125, -1.99688931803434, 218, 39, 'PPL', 'P'),
(210191, 'Kaonoulu', 20.7402801513672, 0.361986176427385, -156.335556030273, -2.72857019066435, 218, 15, 'PPL', 'P'),
(204515, 'Kap', 41.2066688537598, 0.719192045277106, -112.036392211914, -1.95540392615363, 218, 52, 'PPL', 'P'),
(210193, 'Kapaa', 22.0783290863037, 0.385339535894831, -159.32194519043, -2.78069251425494, 218, 15, 'PPL', 'P'),
(210198, 'Kapaahu', 19.3416690826416, 0.337575808323287, -155.013885498047, -2.70550268825041, 218, 15, 'PPL', 'P'),
(210203, 'Kapaau', 20.2338905334473, 0.353148010296767, -155.801940917969, -2.71925685001623, 218, 15, 'PPL', 'P'),
(210200, 'KapaÃ‚â€˜akea Colony', 21.086669921875, 0.368031818417974, -157.013610839844, -2.74040447960033, 218, 15, 'PPL', 'P'),
(210205, 'Kapaeloa', 21.6324996948242, 0.377558345111351, -158.074172973633, -2.75891478075693, 218, 15, 'PPL', 'P'),
(210206, 'Kapahi', 22.1002807617188, 0.385722664907153, -159.360565185547, -2.78136656032684, 218, 15, 'PPL', 'P'),
(210209, 'Kapaia', 21.9933300018311, 0.383856022009602, -159.368896484375, -2.78151196892236, 218, 15, 'PPL', 'P'),
(210211, 'Kapaka', 21.9236106872559, 0.382639190418032, -159.616943359375, -2.78584120359039, 218, 15, 'PPL', 'P'),
(210215, 'Kapalaoa', 19.9125003814697, 0.347538693961274, -155.898895263672, -2.72094902257287, 218, 15, 'PPL', 'P'),
(210214, 'Kapalawai', 21.9488906860352, 0.38308040963163, -159.6572265625, -2.78654427811817, 218, 15, 'PPL', 'P'),
(210216, 'Kapalua', 20.999719619751, 0.366514249360306, -156.658065795898, -2.73419904794434, 218, 15, 'PPL', 'P'),
(41566, 'Kaplan', 29.9977798461914, 0.523560026604438, -92.2847213745117, -1.61067223727082, 218, 22, 'PPL', 'P'),
(9811, 'Kaplin (historical)', 33.4022216796875, 0.582978745791578, -91.3125, -1.59370377322732, 218, 4, 'PPL', 'P'),
(210223, 'Kapoho', 19.5061092376709, 0.340445830451038, -154.848617553711, -2.70261821847374, 218, 15, 'PPL', 'P'),
(207767, 'Kapowsin', 46.9858283996582, 0.820057407351094, -122.22444152832, -2.13321893108048, 218, 56, 'PPL', 'P'),
(163224, 'Kapp', 40.9066696166992, 0.713956070836928, -76.8327789306641, -1.34098496579702, 218, 45, 'PPL', 'P'),
(163225, 'Kapp Heights', 40.8997192382813, 0.713834763849275, -76.8083267211914, -1.34055819423233, 218, 45, 'PPL', 'P'),
(120178, 'Kappa', 40.6758308410645, 0.709927174160829, -89.0077819824219, -1.55347885549055, 218, 18, 'PPL', 'P'),
(122946, 'Kappa Corner', 40.5327796936035, 0.70743046063888, -86.2708282470703, -1.50571000133391, 218, 19, 'PPL', 'P'),
(210226, 'KapuÃ‚â€˜a (historical)', 19.146110534668, 0.334162667780728, -155.913330078125, -2.72120095761199, 218, 15, 'PPL', 'P'),
(210231, 'Kapulena', 20.1058292388916, 0.350912919062404, -155.528884887695, -2.71449112324553, 218, 15, 'PPL', 'P'),
(210233, 'Kapunakea', 20.8908290863037, 0.364613751027398, -156.684173583984, -2.73465471480685, 218, 15, 'PPL', 'P'),
(207768, 'Karamin', 48.7733306884766, 0.851255207677909, -118.648063659668, -2.07079936197704, 218, 56, 'PPL', 'P'),
(27595, 'Karbers Ridge', 37.579719543457, 0.655889838009386, -88.3333282470703, -1.54170741715629, 218, 18, 'PPL', 'P'),
(195171, 'Karcher Junction', 43.586109161377, 0.760721112999692, -116.601936340332, -2.03508770333962, 218, 17, 'PPL', 'P'),
(95247, 'Karen', 30.2561092376709, 0.528068725040429, -95.7013931274414, -1.67030440881933, 218, 51, 'PPL', 'P'),
(103241, 'Karen Hills', 37.2722206115723, 0.650522969201631, -80.0688934326172, -1.39746581882763, 218, 53, 'PPL', 'P'),
(48580, 'Karen Knolls', 38.5102806091309, 0.672131192496261, -76.7769393920898, -1.3400103819961, 218, 25, 'PPL', 'P'),
(73085, 'Karen Woods', 39.8847198486328, 0.696119682594177, -83.8775024414063, -1.46393858595212, 218, 41, 'PPL', 'P'),
(170640, 'Kargas Subdivision', 43.6930618286133, 0.762587789186756, -98.029167175293, -1.71093173019681, 218, 49, 'PPL', 'P'),
(202268, 'Karinen', 45.9005584716797, 0.801115873834987, -103.674438476563, -1.80946030157231, 218, 49, 'PPL', 'P'),
(48581, 'Karinwood', 39.223331451416, 0.684576277428256, -77.0025024414063, -1.34394719987751, 218, 25, 'PPL', 'P'),
(186905, 'Karl', 38.1375007629395, 0.665624956795143, -102.519439697266, -1.78930177001706, 218, 7, 'PPL', 'P'),
(55630, 'Karlin', 37.5541687011719, 0.655443891684852, -93.4138870239258, -1.63037989565351, 218, 29, 'PPL', 'P'),
(131535, 'Karlin', 44.5783309936523, 0.778038650883069, -85.783332824707, -1.49720160112527, 218, 27, 'PPL', 'P'),
(155953, 'Karlin', 41.4561080932617, 0.723545581290086, -81.6513900756836, -1.4250855956509, 218, 41, 'PPL', 'P'),
(193693, 'Karlo', 40.5505599975586, 0.707740785484901, -120.314437866211, -2.09988307845152, 218, 6, 'PPL', 'P'),
(149950, 'Karlsfeld', 42.6488914489746, 0.744363578110262, -73.8422164916992, -1.28878980475061, 218, 40, 'PPL', 'P'),
(198465, 'Karlsruhe', 48.0900001525879, 0.839328839947234, -100.620002746582, -1.75615034129359, 218, 34, 'PPL', 'P'),
(136178, 'Karlstad', 48.5774993896484, 0.847837306734901, -96.5202789306641, -1.6845966622834, 218, 28, 'PPL', 'P'),
(211912, 'Karluk', 57.5719413757324, 1.00481993377168, -154.45556640625, -2.69575818182181, 218, 1, 'PPL', 'P'),
(36671, 'Karlus', 36.9938888549805, 0.645665163636244, -85.0263900756836, -1.48399045790571, 218, 21, 'PPL', 'P'),
(859, 'Karma', 33.7738914489746, 0.589465606995765, -96.2055587768555, -1.67910375937706, 218, 42, 'PPL', 'P'),
(178440, 'Karmella Mobile Home Park', 33.4013900756836, 0.582964231563637, -111.840278625488, -1.95198109836261, 218, 5, 'PPL', 'P'),
(95248, 'Karnack', 32.667781829834, 0.570160352253781, -94.170280456543, -1.64358145149314, 218, 51, 'PPL', 'P'),
(27596, 'Karnak', 37.2936096191406, 0.650896277807432, -88.9752807617188, -1.55291160217836, 218, 18, 'PPL', 'P'),
(140302, 'Karnak', 47.2808303833008, 0.825206163265571, -98.0638885498047, -1.71153773250286, 218, 34, 'PPL', 'P'),
(182424, 'Karnak', 38.7849998474121, 0.67692594772284, -121.654441833496, -2.12327055967043, 218, 6, 'PPL', 'P'),
(149951, 'Karner', 42.723331451416, 0.745662801248057, -73.857780456543, -1.2890614471818, 218, 40, 'PPL', 'P'),
(95249, 'Karnes City', 28.8847198486328, 0.504133464874801, -97.9005584716797, -1.70868708487204, 218, 51, 'PPL', 'P'),
(76247, 'Karns', 35.6238899230957, 0.62175417152605, -98.2244415283203, -1.71433991060184, 218, 42, 'PPL', 'P'),
(88227, 'Karns', 35.9819412231445, 0.628003345602948, -84.1138916015625, -1.46806435511287, 218, 50, 'PPL', 'P'),
(163227, 'Karns', 40.6305618286133, 0.70913708084443, -79.7038879394531, -1.39109527118406, 218, 45, 'PPL', 'P'),
(163229, 'Karns City', 40.9938888549805, 0.715478333716017, -79.7255630493164, -1.3914735732169, 218, 45, 'PPL', 'P'),
(41565, 'Karo', 30.9836101531982, 0.540766011327654, -92.0936126708984, -1.60733676116355, 218, 22, 'PPL', 'P'),
(103243, 'Karo', 38.871940612793, 0.67844335033294, -78.2522201538086, -1.36575888867942, 218, 53, 'PPL', 'P'),
(190364, 'Karo (historical)', 38.2597198486328, 0.667758082249269, -114.374443054199, -1.99621061143054, 218, 39, 'PPL', 'P'),
(95251, 'Karon', 28.478609085083, 0.497045494923068, -98.0019378662109, -1.71045648910029, 218, 51, 'PPL', 'P'),
(103244, 'Karr Heights', 37.2347183227539, 0.649868430784716, -80.4419403076172, -1.40397671506066, 218, 53, 'PPL', 'P'),
(149954, 'Karrdale', 42.3211097717285, 0.738642708614608, -77.8211135864258, -1.35823465965162, 218, 40, 'PPL', 'P'),
(131536, 'Karrs Corner', 43.4513893127441, 0.758369808073261, -83.5813903808594, -1.45877045554071, 218, 27, 'PPL', 'P'),
(145517, 'Karrsville', 40.8091697692871, 0.712254377479395, -74.932502746582, -1.30781888968755, 218, 37, 'PPL', 'P'),
(210235, 'Karston (historical)', 21.5163898468018, 0.375531845969369, -158.04443359375, -2.75839573066047, 218, 15, 'PPL', 'P'),
(22320, 'Kartah', 34.4477806091309, 0.601227191633991, -85.2486114501953, -1.48786895255925, 218, 13, 'PPL', 'P'),
(149952, 'Karter', 44.0227813720703, 0.768342480828254, -75.5091705322266, -1.31788364123723, 218, 40, 'PPL', 'P'),
(163232, 'Karthaus', 41.1208305358887, 0.717693884005882, -78.1141662597656, -1.36334939368317, 218, 45, 'PPL', 'P'),
(186906, 'Karval', 38.7333297729492, 0.676024134798712, -103.536666870117, -1.80705573342408, 218, 7, 'PPL', 'P'),
(193173, 'Kasaan', 55.538890838623, 0.969336508039687, -132.400833129883, -2.31083047050004, 218, 1, 'PPL', 'P'),
(120179, 'Kasbeer', 41.5050010681152, 0.724398924682374, -89.4633331298828, -1.56142972292498, 218, 18, 'PPL', 'P'),
(27598, 'Kaser', 39.2994384765625, 0.68590459560096, -90.4641723632813, -1.57889766283092, 218, 18, 'PPL', 'P'),
(149953, 'Kaser', 41.1211090087891, 0.717698744274871, -74.067497253418, -1.292721695784, 218, 40, 'PPL', 'P'),
(163231, 'Kaseville', 40.9980583190918, 0.715551104592804, -76.5944366455078, -1.33682510817431, 218, 45, 'PPL', 'P'),
(103245, 'Kasey', 37.0777816772461, 0.64712936960357, -79.5827789306641, -1.38898152022686, 218, 53, 'PPL', 'P'),
(55631, 'Kaseyville', 39.624439239502, 0.691576928985747, -92.6630630493164, -1.61727554519367, 218, 29, 'PPL', 'P'),
(211913, 'Kashegelok', 60.8547210693359, 1.06211524804268, -157.833892822266, -2.75472110098838, 218, 1, 'PPL', 'P'),
(211914, 'Kashiagamiut', 59.3694381713867, 1.0361921711499, -160.064712524414, -2.79365624980923, 218, 1, 'PPL', 'P'),
(204516, 'Kashmir', 40.6483306884766, 0.70944720595337, -111.931106567383, -1.95356634500148, 218, 52, 'PPL', 'P'),
(163236, 'Kashner', 41.3808288574219, 0.722231710766295, -80.3047180175781, -1.40158173429235, 218, 45, 'PPL', 'P'),
(78540, 'Kasiesville', 39.7486114501953, 0.693744142901826, -77.8913879394531, -1.35946117849166, 218, 45, 'PPL', 'P'),
(211915, 'Kasigluk', 60.8955612182617, 1.06282804310844, -162.51806640625, -2.83647535276385, 218, 1, 'PPL', 'P'),
(22325, 'Kasihta (historical)', 32.3416709899902, 0.564468644372064, -84.9958267211914, -1.48345702673937, 218, 13, 'PPL', 'P'),
(211916, 'Kasilof', 60.3375015258789, 1.05308806405369, -151.274444580078, -2.64023713204805, 218, 1, 'PPL', 'P'),
(163233, 'Kaska', 40.7400016784668, 0.711047166557262, -76.1074981689453, -1.32832642850365, 218, 45, 'PPL', 'P'),
(211917, 'Kaskanak', 59.2833290100098, 1.03468928276774, -156.183334350586, -2.72591342116088, 218, 1, 'PPL', 'P'),
(27599, 'Kaskaskia', 37.9213905334473, 0.661853121743264, -89.9130630493164, -1.56927899076382, 218, 18, 'PPL', 'P'),
(149955, 'Kasoag', 43.4613914489746, 0.758544378282716, -75.9238891601563, -1.32512184676396, 218, 40, 'PPL', 'P'),
(136180, 'Kasota', 44.2924995422363, 0.773049950950105, -93.9647216796875, -1.63999377403064, 218, 28, 'PPL', 'P'),
(186907, 'Kassler', 39.4905586242676, 0.689240271445312, -105.094169616699, -1.83423928446079, 218, 7, 'PPL', 'P'),
(30234, 'Kasson', 38.0169410705566, 0.663520793217871, -87.6361083984375, -1.52953863518739, 218, 19, 'PPL', 'P'),
(109911, 'Kasson', 39.2247200012207, 0.684600512194176, -79.8755569458008, -1.39409146056845, 218, 58, 'PPL', 'P'),
(136183, 'Kasson', 44.0299987792969, 0.768468448347815, -92.7505569458008, -1.61880260176272, 218, 28, 'PPL', 'P'),
(163234, 'Kasson', 41.7486114501953, 0.728650727941713, -78.5263900756836, -1.37054405652608, 218, 45, 'PPL', 'P'),
(163235, 'Kasson Brook', 41.4716682434082, 0.723817157142246, -76.148063659668, -1.32903442987945, 218, 45, 'PPL', 'P'),
(149956, 'Kast Bridge', 43.0699996948242, 0.751713303507636, -74.9905624389648, -1.30883222248233, 218, 40, 'PPL', 'P'),
(131538, 'Katakitckon Indian Village', 46.1513900756836, 0.805493711192914, -89.0908279418945, -1.55492828091382, 218, 27, 'PPL', 'P'),
(211918, 'Katalla', 60.1972198486328, 1.05063968690553, -144.518325805664, -2.52232061477872, 218, 1, 'PPL', 'P'),
(113070, 'Katama', 41.3583297729492, 0.721839027663563, -70.5074996948242, -1.23058801702358, 218, 23, 'PPL', 'P'),
(9812, 'Kate', 35.0447196960449, 0.61164574413449, -90.3613891601563, -1.57710375752064, 218, 4, 'PPL', 'P'),
(41567, 'Kateland', 31.4561100006104, 0.549012689380166, -92.6755599975586, -1.61749365808695, 218, 22, 'PPL', 'P'),
(163237, 'Katellen', 40.8247184753418, 0.712525753594474, -75.3677825927734, -1.31541595617117, 218, 45, 'PPL', 'P'),
(95252, 'Katemcy', 30.9125003814697, 0.53952491168065, -99.2536087036133, -1.73230226636415, 218, 51, 'PPL', 'P'),
(127847, 'Katen Corner', 44.9850006103516, 0.785136374662293, -69.2802810668945, -1.2091690113244, 218, 26, 'PPL', 'P'),
(66034, 'Katesville', 36.0888900756836, 0.629869955210984, -78.3661117553711, -1.36774667211706, 218, 33, 'PPL', 'P'),
(211919, 'Kathakne', 62.9694404602051, 1.09902406416911, -141.83332824707, -2.47545856697325, 218, 1, 'PPL', 'P'),
(36672, 'Katharyn', 38.0008316040039, 0.663239629985786, -85.9288864135742, -1.49974199048909, 218, 21, 'PPL', 'P'),
(178441, 'Katherine', 35.2222213745117, 0.614743732851552, -114.561111450195, -1.99946858955008, 218, 5, 'PPL', 'P'),
(22321, 'Katherine Valley', 33.5875015258789, 0.586212489145206, -84.2750015258789, -1.47087625374983, 218, 13, 'PPL', 'P'),
(16694, 'Kathleen', 28.1205596923828, 0.490796354135684, -82.0233306884766, -1.43157718396602, 218, 12, 'PPL', 'P'),
(22322, 'Kathleen', 32.4958305358887, 0.567159236021371, -83.607780456543, -1.45923104925124, 218, 13, 'PPL', 'P'),
(48582, 'Kathleens Delight', 38.3861083984375, 0.669963978580182, -75.5536117553711, -1.31865928690472, 218, 25, 'PPL', 'P'),
(103247, 'Kathmoor', 38.7827796936035, 0.676887198728979, -77.142219543457, -1.34638572332964, 218, 53, 'PPL', 'P'),
(109912, 'Kathryn', 37.8758316040039, 0.661057968420793, -80.9744415283203, -1.41327061463282, 218, 58, 'PPL', 'P'),
(140303, 'Kathryn', 46.6780586242676, 0.814685811432404, -97.9683303833008, -1.7098699278702, 218, 34, 'PPL', 'P'),
(182426, 'Kathryn', 33.7041702270508, 0.588248742114681, -117.752502441406, -2.0551688700652, 218, 6, 'PPL', 'P'),
(81830, 'Kathwood', 33.3441696166992, 0.581965546154857, -81.8444366455078, -1.42845489390401, 218, 48, 'PPL', 'P'),
(88228, 'Kathy Hills', 36.1797218322754, 0.631455268428881, -83.4180603027344, -1.45591980790989, 218, 50, 'PPL', 'P'),
(76249, 'Katie', 34.5794410705566, 0.603525100180566, -97.351936340332, -1.69911182233071, 218, 42, 'PPL', 'P'),
(41568, 'Katie (historical)', 30.4313907623291, 0.53112796476363, -90.2827835083008, -1.57573183008509, 218, 22, 'PPL', 'P'),
(174724, 'Katinka Village', 46.2041702270508, 0.806414898613972, -89.8013916015625, -1.56732995632005, 218, 57, 'PPL', 'P'),
(195172, 'Katka', 48.6897201538086, 0.8497959285586, -116.134437561035, -2.02692831039184, 218, 17, 'PPL', 'P'),
(163238, 'Kato', 41.0847206115723, 0.717063646933914, -77.8663864135742, -1.35902481954705, 218, 45, 'PPL', 'P'),
(149957, 'Katonah', 41.2588882446289, 0.720103445581158, -73.6858291625977, -1.28606033094939, 218, 40, 'PPL', 'P'),
(149958, 'Katonah Ridge', 41.2713890075684, 0.720321625053463, -73.6733322143555, -1.28584221805611, 218, 40, 'PPL', 'P'),
(103246, 'Katrine', 37.5847206115723, 0.655977123114113, -78.5783309936523, -1.37145059656114, 218, 53, 'PPL', 'P'),
(149959, 'Katsbaan', 42.1108283996582, 0.73497260631637, -73.9686126708984, -1.29099583423957, 218, 40, 'PPL', 'P'),
(149961, 'Kattellville', 42.2000007629395, 0.736528957657413, -75.8594436645508, -1.32399706067756, 218, 40, 'PPL', 'P'),
(41569, 'Katy', 29.827220916748, 0.520583211716975, -91.5108337402344, -1.59716535001221, 218, 22, 'PPL', 'P'),
(55635, 'Katy', 37.8283309936523, 0.660228926373452, -94.5713882446289, -1.65058210305063, 218, 29, 'PPL', 'P'),
(95254, 'Katy', 29.7855606079102, 0.519856102160356, -95.8241729736328, -1.67244732139046, 218, 51, 'PPL', 'P'),
(109913, 'Katy', 39.5108299255371, 0.689594072396129, -80.2244415283203, -1.40018064524286, 218, 58, 'PPL', 'P'),
(120180, 'Katy Did', 41.0919418334961, 0.717189681032502, -88.6419372558594, -1.54709366046097, 218, 18, 'PPL', 'P'),
(109914, 'Katy Lick', 39.3175010681152, 0.686219847294998, -80.4236068725586, -1.40365673625569, 218, 58, 'PPL', 'P'),
(60463, 'Katzenmeyer', 32.5205612182617, 0.567590867855045, -90.8255615234375, -1.58520509355666, 218, 30, 'PPL', 'P'),
(210242, 'Kaueleau', 19.4444408416748, 0.339369513896483, -154.915283203125, -2.703781753554, 218, 15, 'PPL', 'P'),
(78541, 'Kauffman', 39.8338890075684, 0.695232517056044, -77.7063903808594, -1.35623236198605, 218, 45, 'PPL', 'P'),
(193691, 'Kauffman', 41.2338905334473, 0.719667153215576, -120.46639251709, -2.10253518742308, 218, 6, 'PPL', 'P'),
(27617, 'Kaufman', 38.8624992370605, 0.678278567240491, -89.7772216796875, -1.56690811160338, 218, 18, 'PPL', 'P'),
(95253, 'Kaufman', 32.5888900756836, 0.568783431391183, -96.3086090087891, -1.68090232521924, 218, 51, 'PPL', 'P'),
(195173, 'Kaufman (historical)', 44.1602783203125, 0.770742255286524, -112.91056060791, -1.97066104288064, 218, 17, 'PPL', 'P'),
(78542, 'Kaufmann', 39.901668548584, 0.696415493212257, -79.4661102294922, -1.38694526725739, 218, 45, 'PPL', 'P'),
(95256, 'Kaufold Estates Number 1 Colonia', 26.3689994812012, 0.460225861403637, -98.1259994506836, -1.71262177222458, 218, 51, 'PPL', 'P'),
(210249, 'KaukahÃƒÂ¶kÃƒÂ¼', 19.5758304595947, 0.341662695332123, -155.861938476563, -2.72030400495685, 218, 15, 'PPL', 'P'),
(174727, 'Kaukauna', 44.2780609130859, 0.772797949331956, -88.2719421386719, -1.54063602744975, 218, 57, 'PPL', 'P'),
(155955, 'Kauke', 40.7108306884766, 0.710538036735866, -81.9824981689453, -1.43086452205832, 218, 41, 'PPL', 'P'),
(163239, 'Kaulmont', 41.4280586242676, 0.723056025702702, -78.5277786254883, -1.370568291292, 218, 45, 'PPL', 'P'),
(210254, 'Kaumakani', 21.9188899993896, 0.382556798871807, -159.622222900391, -2.78593334896411, 218, 15, 'PPL', 'P'),
(210256, 'Kaumalapau', 20.7900009155273, 0.362853967468588, -156.990005493164, -2.7399924885797, 218, 15, 'PPL', 'P'),
(210259, 'Kaumana', 19.6886100769043, 0.343631070983314, -155.144165039063, -2.70777649518912, 218, 15, 'PPL', 'P'),
(210263, 'Kaunakakai', 21.0933303833008, 0.368148065399556, -157.023895263672, -2.7405839766578, 218, 15, 'PPL', 'P'),
(210265, 'Kaunalewa (historical)', 22.003059387207, 0.384025831818609, -159.741104125977, -2.78800821776939, 218, 15, 'PPL', 'P'),
(210271, 'KaunÃƒÂ«nÃƒÂ«', 19.4213905334473, 0.338967210124313, -155.779724121094, -2.71886909376152, 218, 15, 'PPL', 'P'),
(149960, 'Kauneonga Lake', 41.6911087036133, 0.727647115684916, -74.8361129760742, -1.30613657082695, 218, 40, 'PPL', 'P'),
(142151, 'Kaup Trailer Court', 42.5991706848145, 0.74349578706906, -99.142219543457, -1.73035815876839, 218, 35, 'PPL', 'P'),
(210277, 'Kaupakulua', 20.8902797698975, 0.364604163647474, -156.297775268555, -2.72791079197844, 218, 15, 'PPL', 'P'),
(210280, 'KaupÃƒÂ¶', 20.639440536499, 0.360226193131493, -156.125274658203, -2.72490008836611, 218, 15, 'PPL', 'P'),
(109915, 'Kausooth', 39.7544403076172, 0.693845875655467, -80.595832824707, -1.40666264617806, 218, 58, 'PPL', 'P'),
(48583, 'Kavadias Estates', 38.646671295166, 0.674511659036628, -76.5788879394531, -1.33655373205923, 218, 25, 'PPL', 'P'),
(36673, 'Kavanaugh', 38.2533302307129, 0.667646562378622, -82.5869369506836, -1.44141396892639, 218, 21, 'PPL', 'P'),
(76250, 'Kaw City', 36.7602806091309, 0.64158793058636, -96.8330612182617, -1.6900557430439, 218, 42, 'PPL', 'P'),
(210286, 'Kawaihae', 20.041109085083, 0.349783339286047, -155.83056640625, -2.71975645903673, 218, 15, 'PPL', 'P'),
(210290, 'Kawaihau', 22.103609085083, 0.38578075510843, -159.34944152832, -2.78117241588337, 218, 15, 'PPL', 'P'),
(178442, 'Kawaika-A', 35.7447204589844, 0.623863062214256, -110.220001220703, -1.92370192285344, 218, 5, 'PPL', 'P'),
(210295, 'Kawailiula', 20.0272197723389, 0.349540925047822, -155.706390380859, -2.71758917854162, 218, 15, 'PPL', 'P'),
(210294, 'Kawailoa Beach', 21.628059387207, 0.37748084712363, -158.080001831055, -2.75901651351057, 218, 15, 'PPL', 'P'),
(210297, 'Kawainui', 19.8280601501465, 0.346064933903537, -155.097778320313, -2.70696689421773, 218, 15, 'PPL', 'P'),
(14040, 'Kawan Acres', 38.6594390869141, 0.674734499040841, -75.2988891601563, -1.31421353893899, 218, 10, 'PPL', 'P'),
(66035, 'Kawana', 35.9805603027344, 0.627979243995083, -81.8233337402344, -1.42808657872526, 218, 33, 'PPL', 'P'),
(182427, 'Kaweah', 36.4697189331055, 0.636516672659604, -118.917503356934, -2.0755019718299, 218, 6, 'PPL', 'P'),
(210309, 'Kawela', 21.0688896179199, 0.367721493571953, -156.952774047852, -2.73934267727372, 218, 15, 'PPL', 'P'),
(210310, 'Kawela Bay', 21.7033290863037, 0.378794551199852, -158.009994506836, -2.75779465520244, 218, 15, 'PPL', 'P'),
(131539, 'Kawkawlin', 43.6519393920898, 0.76187006727298, -83.9430618286133, -1.46508281311447, 218, 27, 'PPL', 'P'),
(9814, 'Kay', 35.7861099243164, 0.62458544465994, -92.6919403076172, -1.61777954842997, 218, 4, 'PPL', 'P'),
(95257, 'Kay Bee Heights', 31.1183300018311, 0.543117316254085, -97.8311080932617, -1.70747494710189, 218, 51, 'PPL', 'P'),
(70995, 'Kay Gardens', 39.7438888549805, 0.693661718066088, -75.4199981689453, -1.31632728989619, 218, 37, 'PPL', 'P'),
(178443, 'Kay-Bee Mobile Villa', 33.4530601501465, 0.583866044487765, -111.826393127441, -1.95173875070341, 218, 5, 'PPL', 'P'),
(103248, 'Kayan', 37.8908309936523, 0.661319757155948, -76.2702789306641, -1.33116748875455, 218, 53, 'PPL', 'P'),
(182428, 'Kayandee', 35.3474998474121, 0.616930254685535, -118.994171142578, -2.07684007711961, 218, 6, 'PPL', 'P'),
(209540, 'Kaycee', 43.7102813720703, 0.762888326915772, -106.638328552246, -1.86118994206017, 218, 59, 'PPL', 'P'),
(178444, 'Kayenta', 36.7277793884277, 0.641020677274173, -110.253890991211, -1.92429341093155, 218, 5, 'PPL', 'P'),
(109918, 'Kayford', 38.0155601501465, 0.663496691610006, -81.4522171020508, -1.42160937148002, 218, 58, 'PPL', 'P'),
(36674, 'Kayjay', 36.7441711425781, 0.641306767354275, -83.8491668701172, -1.46344403693769, 218, 21, 'PPL', 'P'),
(3482, 'Kaylor', 33.4713897705078, 0.584185956713711, -85.3483276367188, -1.48960932833161, 218, 2, 'PPL', 'P'),
(163241, 'Kaylor', 40.9811096191406, 0.715255293974723, -79.6680603027344, -1.39046996096011, 218, 45, 'PPL', 'P'),
(170643, 'Kaylor', 43.188060760498, 0.753773857822057, -97.8383331298828, -1.7076010477795, 218, 49, 'PPL', 'P'),
(109916, 'Kaymoor', 38.0499992370605, 0.664097767068037, -81.0550003051758, -1.41467663053033, 218, 58, 'PPL', 'P'),
(103249, 'Kayoulah', 36.916389465332, 0.644312544118593, -80.774169921875, -1.40977521570209, 218, 53, 'PPL', 'P'),
(204519, 'Kaysville', 41.0352783203125, 0.716200716161701, -111.937782287598, -1.95368285829917, 218, 52, 'PPL', 'P'),
(48584, 'Kaywood', 38.3536109924316, 0.669396791847022, -75.5477828979492, -1.31855755415108, 218, 25, 'PPL', 'P'),
(88229, 'Kaywood', 35.3499984741211, 0.616973863948385, -86.2300033569336, -1.50499747258425, 218, 50, 'PPL', 'P'),
(48585, 'Kaywood Gardens', 38.9430618286133, 0.679684649717025, -76.9694366455078, -1.34337009286929, 218, 25, 'PPL', 'P'),
(211609, 'KÃƒÂ¤Ã‚â€˜anapali', 20.9316692352295, 0.365326546093158, -156.697219848633, -2.73488241508005, 218, 15, 'PPL', 'P'),
(210058, 'KÃƒÂ¤kiÃ‚â€˜o', 20.7133293151855, 0.36151579559985, -155.996673583984, -2.72265557619939, 218, 15, 'PPL', 'P'),
(210173, 'KÃƒÂ¤neÃ‚â€˜ohe', 21.4180603027344, 0.373815671673408, -157.803604125977, -2.754192463512, 218, 15, 'PPL', 'P'),
(210392, 'KÃƒÂ«ÃƒÂ¶kea', 19.4200000762939, 0.338942942068879, -155.882781982422, -2.72066779276176, 218, 15, 'PPL', 'P'),
(210415, 'KÃƒÂ¯hei', 20.7849998474121, 0.36276668236386, -156.465560913086, -2.73083920391309, 218, 15, 'PPL', 'P'),
(210416, 'KÃƒÂ¯holo', 19.8575000762939, 0.346578757546355, -155.924163818359, -2.72139004204938, 218, 15, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(210436, 'KÃƒÂ¯pahulu', 20.6566696166992, 0.360526897308076, -156.058609008789, -2.72373655328585, 218, 15, 'PPL', 'P'),
(210442, 'KÃƒÂ¯pÃƒÂ¼', 21.1658306121826, 0.369413433101994, -157.02278137207, -2.74056453558185, 218, 15, 'PPL', 'P'),
(210454, 'KÃƒÂ¶heo', 21.0872192382813, 0.368041405797899, -157.01611328125, -2.74044815544221, 218, 15, 'PPL', 'P'),
(210491, 'KÃƒÂ¼kaÃ‚â€˜iau', 20.0327796936035, 0.349637963980042, -155.350280761719, -2.7113738931896, 218, 15, 'PPL', 'P'),
(210313, 'KeaÃ‚â€˜alu', 21.4177799224854, 0.373810778114905, -157.768890380859, -2.75358659436401, 218, 15, 'PPL', 'P'),
(210315, 'KeaÃ‚â€˜au', 19.625560760498, 0.342530652820893, -155.04167175293, -2.70598764988491, 218, 15, 'PPL', 'P'),
(149962, 'Keaches Corners', 42.4916687011719, 0.741619523502072, -79.1627807617188, -1.38165116932642, 218, 40, 'PPL', 'P'),
(210321, 'Keahua', 20.860279083252, 0.364080552887651, -156.385284423828, -2.7294381148636, 218, 15, 'PPL', 'P'),
(163242, 'Keal Run', 40.8769416809082, 0.713437220477553, -78.8324966430664, -1.37588662398889, 218, 45, 'PPL', 'P'),
(210335, 'Kealakekua', 19.5208301544189, 0.340702758917204, -155.922500610352, -2.7213610135935, 218, 15, 'PPL', 'P'),
(210337, 'Kealakomo (historical)', 19.274169921875, 0.336397725725577, -155.154998779297, -2.70796557962651, 218, 15, 'PPL', 'P'),
(210338, 'Kealapuali', 19.6266708374023, 0.342550027317824, -155.863067626953, -2.72032371234892, 218, 15, 'PPL', 'P'),
(210343, 'Kealia', 22.1019401550293, 0.385751626784007, -159.308609008789, -2.78045975397567, 218, 15, 'PPL', 'P'),
(178445, 'Keams Canyon', 35.8125, 0.625046038370469, -110.194442749023, -1.92325584337085, 218, 5, 'PPL', 'P'),
(210355, 'Keanakolu', 19.9183292388916, 0.347640426714915, -155.33805847168, -2.71116057398628, 218, 15, 'PPL', 'P'),
(210356, 'KeanapaÃ‚â€˜akai', 19.4449996948242, 0.339379267723975, -155.797775268555, -2.71918414571847, 218, 15, 'PPL', 'P'),
(155956, 'Keans (historical)', 41.0622215270996, 0.716670963831182, -81.0319366455078, -1.41427409373156, 218, 41, 'PPL', 'P'),
(145518, 'Keansburg', 40.4416694641113, 0.705840287151993, -74.1302795410156, -1.29381745341451, 218, 37, 'PPL', 'P'),
(330, 'Kearney', 34.4130592346191, 0.600621189327944, -92.1719436645508, -1.60870389490914, 218, 4, 'PPL', 'P'),
(48586, 'Kearney', 39.3430595397949, 0.686665926777586, -79.3225021362305, -1.38443883319746, 218, 25, 'PPL', 'P'),
(55636, 'Kearney', 39.3677787780762, 0.687097358874179, -94.3619384765625, -1.64692651498034, 218, 29, 'PPL', 'P'),
(60464, 'Kearney', 32.753059387207, 0.571648726407999, -90.728889465332, -1.58351784784804, 218, 30, 'PPL', 'P'),
(66036, 'Kearney', 36.2244415283203, 0.632235774365356, -78.2736129760742, -1.36613226386425, 218, 33, 'PPL', 'P'),
(142152, 'Kearney', 40.6994400024414, 0.710339231760492, -99.0811080932617, -1.72929156275182, 218, 35, 'PPL', 'P'),
(163244, 'Kearney', 40.0716705322266, 0.699382587561742, -74.9700012207031, -1.30847336152544, 218, 45, 'PPL', 'P'),
(188758, 'Kearney', 32.9816703796387, 0.575638740932183, -105.991386413574, -1.84989867167045, 218, 38, 'PPL', 'P'),
(3483, 'Kearney (historical)', 33.8852806091309, 0.591409714591523, -85.7083282470703, -1.49589252429144, 218, 2, 'PPL', 'P'),
(142153, 'Kearney City (historical)', 40.6416702270508, 0.709330958971788, -99.0472183227539, -1.72870007467371, 218, 35, 'PPL', 'P'),
(60465, 'Kearney Park', 32.5888900756836, 0.568783431391183, -90.3152770996094, -1.57629895023922, 218, 30, 'PPL', 'P'),
(109917, 'Kearneysville', 39.3880615234375, 0.687451359562078, -77.8858337402344, -1.35936423942798, 218, 58, 'PPL', 'P'),
(186908, 'Kearns', 37.1311111450195, 0.648060144404553, -107.159721374512, -1.87028996350497, 218, 7, 'PPL', 'P'),
(204521, 'Kearns', 40.6599998474121, 0.709650871197733, -111.995559692383, -1.95469126424593, 218, 52, 'PPL', 'P'),
(22323, 'Kearns (historical)', 33.9836082458496, 0.59312585559797, -84.6074981689453, -1.47667941492317, 218, 13, 'PPL', 'P'),
(95258, 'Kearny', 28.3416690826416, 0.494655441002777, -99.5358276367188, -1.73722791595831, 218, 51, 'PPL', 'P'),
(145520, 'Kearny', 40.7683296203613, 0.711541582413635, -74.1458282470703, -1.29408882952959, 218, 37, 'PPL', 'P'),
(178446, 'Kearny', 33.0569381713867, 0.576952411718892, -110.910003662109, -1.93574473730278, 218, 5, 'PPL', 'P'),
(209541, 'Kearny', 44.5319404602051, 0.777228983332657, -106.815559387207, -1.8642832036663, 218, 59, 'PPL', 'P'),
(66037, 'Kearny Park', 35.5961112976074, 0.621269343049601, -77.3838882446289, -1.35060363786411, 218, 33, 'PPL', 'P'),
(131542, 'Kearsarge', 47.2750015258789, 0.82510443051193, -88.4161071777344, -1.54315218204766, 218, 27, 'PPL', 'P'),
(144013, 'Kearsarge', 44.0752792358398, 0.769258741401296, -71.1180572509766, -1.24124425665137, 218, 36, 'PPL', 'P'),
(163245, 'Kearsarge', 42.0658302307129, 0.734187240110906, -80.0930633544922, -1.3978876635443, 218, 45, 'PPL', 'P'),
(182429, 'Kearsarge', 36.8069381713867, 0.642402258668679, -118.116386413574, -2.06151984347477, 218, 6, 'PPL', 'P'),
(145522, 'Keasbey', 40.5166702270508, 0.707149297406795, -74.3055572509766, -1.29687662655869, 218, 37, 'PPL', 'P'),
(201055, 'Keasey', 45.8616714477539, 0.80043716723118, -123.328330993652, -2.1524854368286, 218, 43, 'PPL', 'P'),
(22324, 'Keasley (historical)', 34.5341682434082, 0.60273494028514, -84.508056640625, -1.47494383284076, 218, 13, 'PPL', 'P'),
(41570, 'Keatchie', 32.1883316040039, 0.561792367213616, -93.9052810668945, -1.638956339628, 218, 22, 'PPL', 'P'),
(163246, 'Keating', 41.2588882446289, 0.720103445581158, -77.9044418334961, -1.35968901192292, 218, 45, 'PPL', 'P'),
(201056, 'Keating', 44.8741683959961, 0.783201987604514, -117.58943939209, -2.05232288296629, 218, 43, 'PPL', 'P'),
(163247, 'Keating Summit', 41.6808280944824, 0.727467685206472, -78.1813888549805, -1.36452264930141, 218, 45, 'PPL', 'P'),
(36675, 'Keaton', 37.9855613708496, 0.662973114139697, -82.9602813720703, -1.44793005832355, 218, 21, 'PPL', 'P'),
(16695, 'Keaton Beach', 29.8241691589355, 0.520529948495173, -83.5950012207031, -1.45900800950995, 218, 12, 'PPL', 'P'),
(32906, 'Keats', 39.2236099243164, 0.684581137697245, -96.7083282470703, -1.68787874201081, 218, 20, 'PPL', 'P'),
(103250, 'Keats', 36.5441703796387, 0.637816095534481, -78.2969436645508, -1.36653946119493, 218, 53, 'PPL', 'P'),
(178447, 'Keats Crossing', 33.3766708374023, 0.582532799467044, -111.861938476563, -1.95235913407935, 218, 5, 'PPL', 'P'),
(210360, 'Keauhou', 19.5652809143066, 0.341478571032257, -155.964996337891, -2.72210270395709, 218, 15, 'PPL', 'P'),
(210363, 'Keaukaha', 19.7302799224854, 0.344358346987501, -155.04638671875, -2.70606994156259, 218, 15, 'PPL', 'P'),
(36676, 'Keavy', 37.0036087036133, 0.645834806997682, -84.1611099243164, -1.4688884703122, 218, 21, 'PPL', 'P'),
(210366, 'Keawaiki', 19.8899993896484, 0.347145977569028, -155.908325195313, -2.72111360592823, 218, 15, 'PPL', 'P'),
(210367, 'Keawakapu', 20.7075004577637, 0.361414062846209, -156.447784423828, -2.7305289456461, 218, 15, 'PPL', 'P'),
(210353, 'KeÃ‚â€˜anae', 20.8613891601563, 0.364099927384581, -156.151672363281, -2.72536081523469, 218, 15, 'PPL', 'P'),
(210350, 'KeÃ‚â€˜ÃƒÂ¤muku', 19.8430595397949, 0.346326722638692, -155.721115112305, -2.71784617358682, 218, 15, 'PPL', 'P'),
(210376, 'KeÃ‚â€˜ei', 19.4644393920898, 0.339718554446851, -155.927215576172, -2.72144330527119, 218, 15, 'PPL', 'P'),
(210339, 'KeÃƒÂ¤lia', 19.4002799987793, 0.3385987617875, -155.881942749023, -2.72065314537576, 218, 15, 'PPL', 'P'),
(116284, 'Keb (historical)', 41.0833282470703, 0.717039345588967, -92.4583282470703, -1.61370224880105, 218, 16, 'PPL', 'P'),
(163250, 'Keborts Corners', 41.5894393920898, 0.725872651450597, -80.1947174072266, -1.39966186146251, 218, 45, 'PPL', 'P'),
(32901, 'Kechi', 37.7958297729492, 0.659661673061265, -97.279167175293, -1.69784176080685, 218, 20, 'PPL', 'P'),
(36677, 'Keck', 37.6044387817383, 0.656321270105978, -83.3591690063477, -1.45489196088718, 218, 21, 'PPL', 'P'),
(149963, 'Kecks Center', 43.0077781677246, 0.750627332994129, -74.4569396972656, -1.29951874867616, 218, 40, 'PPL', 'P'),
(182430, 'Kecks Corner', 35.6708297729492, 0.622573426456385, -120.080833435059, -2.09580591198067, 218, 6, 'PPL', 'P'),
(163252, 'Kecksburg', 40.1847190856934, 0.701355657034355, -79.4608306884766, -1.38685312188367, 218, 45, 'PPL', 'P'),
(103251, 'Kecoughtan', 37.0141716003418, 0.646019164324143, -76.3466720581055, -1.3325008003543, 218, 53, 'PPL', 'P'),
(193692, 'Keddie', 40.0149993896484, 0.698393489532887, -120.959999084473, -2.11115024723337, 218, 6, 'PPL', 'P'),
(9816, 'Kedron', 34.0444412231445, 0.594187591345558, -92.1402816772461, -1.60815128898295, 218, 4, 'PPL', 'P'),
(27602, 'Kedron', 37.6655616760254, 0.657388065859637, -88.3413925170898, -1.5418481652199, 218, 18, 'PPL', 'P'),
(41572, 'Kedron', 30.7563896179199, 0.536800264858903, -90.5772171020508, -1.5808706657245, 218, 22, 'PPL', 'P'),
(88231, 'Kedron', 35.702220916748, 0.623121305271642, -86.8983306884766, -1.51666198500075, 218, 50, 'PPL', 'P'),
(109919, 'Kedron', 38.8958282470703, 0.678860268201591, -80.1277770996094, -1.3984935326923, 218, 58, 'PPL', 'P'),
(120181, 'Kedron (historical)', 41.4683303833008, 0.723758900493401, -89.8763885498047, -1.56863889999582, 218, 18, 'PPL', 'P'),
(88232, 'Keebler Crossroads', 36.3633308410645, 0.634659850168574, -82.4791717529297, -1.43953311140653, 218, 50, 'PPL', 'P'),
(95259, 'Keechi', 31.5166702270508, 0.550069664727305, -95.9530563354492, -1.67469676040519, 218, 51, 'PPL', 'P'),
(48587, 'Keedysville', 39.4861106872559, 0.689162640299536, -77.6999969482422, -1.35612077553637, 218, 25, 'PPL', 'P'),
(88233, 'Keefe', 36.3355598449707, 0.634175154850179, -89.4419403076172, -1.56105634774015, 218, 50, 'PPL', 'P'),
(36678, 'Keefer', 38.5349998474121, 0.672562624592854, -84.6338882446289, -1.4771400086337, 218, 21, 'PPL', 'P'),
(95260, 'Keefer', 30.1797199249268, 0.526735480019708, -95.1983337402344, -1.6615243661795, 218, 51, 'PPL', 'P'),
(163254, 'Keefers', 40.8752784729004, 0.713408192021672, -76.7216720581055, -1.33904578504927, 218, 45, 'PPL', 'P'),
(76254, 'Keefton', 35.5897216796875, 0.621157823178954, -95.3391723632813, -1.66398246386564, 218, 42, 'PPL', 'P'),
(170645, 'Keefton (historical)', 44.7416687011719, 0.780889431671944, -97.8569412231445, -1.70792582027444, 218, 49, 'PPL', 'P'),
(127848, 'Keegan', 47.186939239502, 0.823567453667818, -67.9580612182617, -1.18609192153054, 218, 26, 'PPL', 'P'),
(3485, 'Keego', 31.0605602264404, 0.542109043465381, -87.1275024414063, -1.52066178664194, 218, 2, 'PPL', 'P'),
(131543, 'Keego Harbor', 42.6080589294434, 0.743650916202557, -83.3438873291016, -1.45462524530401, 218, 27, 'PPL', 'P'),
(60466, 'Keel', 34.4127807617188, 0.600616329058954, -89.3677825927734, -1.55976205145037, 218, 30, 'PPL', 'P'),
(3484, 'Keel (historical)', 34.5166702270508, 0.602429542287135, -86.3077774047852, -1.50635488579187, 218, 2, 'PPL', 'P'),
(16696, 'Keela', 26.6897201538086, 0.465823493119847, -80.8786087036133, -1.41159801631019, 218, 12, 'PPL', 'P'),
(131545, 'Keelans Corner', 44.3377799987793, 0.773840244003586, -85.0755615234375, -1.48484866156699, 218, 27, 'PPL', 'P'),
(32903, 'Keeler', 37.6119384765625, 0.656452164473556, -97.2911071777344, -1.69805015316215, 218, 20, 'PPL', 'P'),
(95261, 'Keeler', 32.5377807617188, 0.567891405584061, -97.3675003051758, -1.6993834647619, 218, 51, 'PPL', 'P'),
(131546, 'Keeler', 42.1127815246582, 0.735006694778323, -86.1666717529297, -1.50389212757382, 218, 27, 'PPL', 'P'),
(182434, 'Keeler', 36.4872207641602, 0.636822137236636, -117.873062133789, -2.05727303364247, 218, 6, 'PPL', 'P'),
(195174, 'Keeler', 46.957218170166, 0.819558064646704, -116.306938171387, -2.02993901400417, 218, 17, 'PPL', 'P'),
(120182, 'Keeler (historical)', 40.3972206115723, 0.705064508326453, -90.0647201538086, -1.57192590657125, 218, 18, 'PPL', 'P'),
(172171, 'Keeler Bay', 44.6597213745117, 0.779459181008517, -73.3199996948242, -1.27967540223592, 218, 55, 'PPL', 'P'),
(9817, 'Keeler Corner', 35.3600006103516, 0.617148434157839, -91.4844436645508, -1.59670475630168, 218, 4, 'PPL', 'P'),
(109920, 'Keeler Glade', 39.6297187805176, 0.691669074359464, -79.4780578613281, -1.38715379277074, 218, 58, 'PPL', 'P'),
(163258, 'Keelersburg', 41.4550018310547, 0.723526273372182, -75.8966674804688, -1.32464673882549, 218, 45, 'PPL', 'P'),
(95262, 'Keelersville', 30.7358303070068, 0.536441437191529, -97.5180587768555, -1.70201120580948, 218, 51, 'PPL', 'P'),
(163255, 'Keelersville', 40.4161109924316, 0.705394207669405, -75.2527770996094, -1.31340873165757, 218, 45, 'PPL', 'P'),
(209542, 'Keeline', 42.7569389343262, 0.746249362478147, -104.75611114502, -1.82833905106572, 218, 59, 'PPL', 'P'),
(88234, 'Keeling', 35.4377784729004, 0.61850591394448, -89.4733276367188, -1.56160415997638, 218, 50, 'PPL', 'P'),
(103252, 'Keeling', 36.7200012207031, 0.640884922637607, -79.2886123657227, -1.38384734511935, 218, 53, 'PPL', 'P'),
(32904, 'Keelville', 37.0311088562012, 0.646314775205142, -94.9225006103516, -1.65671016987696, 218, 20, 'PPL', 'P'),
(163256, 'Keen', 41.5927810668945, 0.725930974678469, -75.3741683959961, -1.31552740946278, 218, 45, 'PPL', 'P'),
(103253, 'Keen Mountain', 37.202220916748, 0.649301244051557, -81.9863891601563, -1.43093243266612, 218, 53, 'PPL', 'P'),
(14033, 'Keen-Wik', 38.4605598449707, 0.671263401455059, -75.0905609130859, -1.31057752510271, 218, 10, 'PPL', 'P'),
(76259, 'Keenan', 36.2758293151855, 0.633132660441468, -99.5691680908203, -1.73780981665649, 218, 42, 'PPL', 'P'),
(95263, 'Keenan', 30.3208293914795, 0.529198304816786, -95.6452789306641, -1.66932503132845, 218, 51, 'PPL', 'P'),
(109921, 'Keenan', 37.5852813720703, 0.655986910231119, -80.4855575561523, -1.40473797965826, 218, 58, 'PPL', 'P'),
(136186, 'Keenan', 47.3833312988281, 0.826995141727832, -92.6041717529297, -1.61624769817095, 218, 28, 'PPL', 'P'),
(163257, 'Keenan', 41.1041717529297, 0.717403133393872, -79.8733291625977, -1.39405257841653, 218, 45, 'PPL', 'P'),
(195175, 'Keenan City', 43.1408309936523, 0.75294954288565, -111.33943939209, -1.94323980471664, 218, 17, 'PPL', 'P'),
(182431, 'Keenbrook', 34.249439239502, 0.597765481691052, -117.456672668457, -2.05000566650181, 218, 6, 'PPL', 'P'),
(88235, 'Keenburg', 36.3869400024414, 0.635071907768236, -82.2272186279297, -1.43513569981459, 218, 50, 'PPL', 'P'),
(16697, 'Keene', 30.483060836792, 0.532029777687758, -81.8469390869141, -1.42849856974589, 218, 12, 'PPL', 'P'),
(32905, 'Keene', 38.9575004577637, 0.679936651335174, -96.0388870239258, -1.67619478851836, 218, 20, 'PPL', 'P'),
(36680, 'Keene', 37.9433288574219, 0.66223601772899, -84.6419372558594, -1.4772804903812, 218, 21, 'PPL', 'P'),
(66038, 'Keene', 35.9491691589355, 0.627431365179826, -78.9044418334961, -1.37714230444286, 218, 33, 'PPL', 'P'),
(95264, 'Keene', 32.396671295166, 0.565428580786983, -97.3236083984375, -1.69861740647434, 218, 51, 'PPL', 'P'),
(103254, 'Keene', 37.8650016784668, 0.660868950562425, -78.5555572509766, -1.37105311976845, 218, 53, 'PPL', 'P'),
(142163, 'Keene', 40.4252815246582, 0.705554263650919, -99.065559387207, -1.72902018663674, 218, 35, 'PPL', 'P'),
(144016, 'Keene', 42.9336090087891, 0.749332836967268, -72.2786102294922, -1.26149972727029, 218, 36, 'PPL', 'P'),
(149964, 'Keene', 44.2561111450195, 0.772414853609149, -73.7925033569336, -1.28792214686746, 218, 40, 'PPL', 'P'),
(155957, 'Keene', 40.3450012207031, 0.704153108022401, -81.8683319091797, -1.42887194493072, 218, 41, 'PPL', 'P'),
(174728, 'Keene', 44.3669395446777, 0.7743491740879, -89.4741668701172, -1.56161880736237, 218, 57, 'PPL', 'P'),
(182432, 'Keene', 35.2236099243164, 0.614767967617472, -118.561393737793, -2.06928668647787, 218, 6, 'PPL', 'P'),
(198467, 'Keene', 47.9269409179688, 0.836482919427348, -102.941108703613, -1.79666128253144, 218, 34, 'PPL', 'P'),
(103255, 'Keene Mill Heights', 38.7730598449707, 0.676717555367541, -77.2597198486328, -1.34843649052706, 218, 53, 'PPL', 'P'),
(103256, 'Keene Mill Manor', 38.7838897705078, 0.676906573225909, -77.2225036621094, -1.34778694553719, 218, 53, 'PPL', 'P'),
(149965, 'Keene Valley', 44.1897201538086, 0.771256112218855, -73.7863922119141, -1.2878154872658, 218, 40, 'PPL', 'P'),
(36679, 'Keeneland', 38.2747192382813, 0.668019870984424, -85.567497253418, -1.49343455976335, 218, 21, 'PPL', 'P'),
(103257, 'Keeneland', 39.1527786254883, 0.68334489831923, -78.0611114501953, -1.36242341257215, 218, 53, 'PPL', 'P'),
(3486, 'Keener', 34.1561088562012, 0.596136559210305, -85.9511108398438, -1.50012987990186, 218, 2, 'PPL', 'P'),
(9819, 'Keener', 34.8091697692871, 0.607534622359735, -94.0005569458008, -1.64061921741265, 218, 4, 'PPL', 'P'),
(66039, 'Keener', 35.1069412231445, 0.612731714647997, -78.3188934326172, -1.36692255691773, 218, 33, 'PPL', 'P'),
(48588, 'Keener (historical)', 39.6916694641113, 0.692750317762036, -76.7219390869141, -1.33905044558118, 218, 25, 'PPL', 'P'),
(55638, 'Keener Cave', 36.9291687011719, 0.644535583859887, -90.5250015258789, -1.57995933199948, 218, 29, 'PPL', 'P'),
(22326, 'Keener Estates', 33.9361114501953, 0.592296880129656, -84.7716674804688, -1.47954470993999, 218, 13, 'PPL', 'P'),
(55639, 'Keeners', 36.9230613708496, 0.644428990837257, -90.5055618286133, -1.5796200452766, 218, 29, 'PPL', 'P'),
(27603, 'Keenes', 38.3380584716797, 0.669125349152916, -88.6430587768555, -1.54711323469499, 218, 18, 'PPL', 'P'),
(149967, 'Keenes', 44.2627792358398, 0.772531233748785, -75.5419387817383, -1.31845555508133, 218, 40, 'PPL', 'P'),
(127849, 'Keenes Corner', 44.2200012207031, 0.771784616537181, -70.0924987792969, -1.22334488464884, 218, 26, 'PPL', 'P'),
(22327, 'Keenes Crossing (historical)', 32.586669921875, 0.568744682397322, -82.7347183227539, -1.44399324044214, 218, 13, 'PPL', 'P'),
(194265, 'Keenesburg', 40.1083297729492, 0.700022412013634, -104.519439697266, -1.82420835505695, 218, 7, 'PPL', 'P'),
(27604, 'Keenesville', 38.4022216796875, 0.670245208391294, -88.648063659668, -1.54720058637874, 218, 18, 'PPL', 'P'),
(14034, 'Keeney', 39.6188888549805, 0.691480056501095, -75.70361328125, -1.32127730741432, 218, 10, 'PPL', 'P'),
(78543, 'Keeney', 39.7594413757324, 0.693933160760195, -76.6619415283203, -1.33800329064056, 218, 45, 'PPL', 'P'),
(149968, 'Keeney', 42.7849998474121, 0.746739117802613, -75.9652786254883, -1.32584422920964, 218, 40, 'PPL', 'P'),
(669, 'Keeney Corner', 37.0625, 0.646862654020398, -90.9124984741211, -1.58672242958773, 218, 29, 'PPL', 'P'),
(48589, 'Keeney Mill Farms', 39.6936111450195, 0.692784206486907, -76.7236099243164, -1.33907960719512, 218, 25, 'PPL', 'P'),
(48590, 'Keeney Mill Woods', 39.6813888549805, 0.692570887283592, -76.7336120605469, -1.33925417740457, 218, 25, 'PPL', 'P'),
(109922, 'Keeneys Creek', 38.0372200012207, 0.663874727326743, -81.0297164916992, -1.4142353447377, 218, 58, 'PPL', 'P'),
(120184, 'Keeneyville', 41.9674987792969, 0.732471032525432, -88.1202774047852, -1.53798897848426, 218, 18, 'PPL', 'P'),
(163259, 'Keeneyville', 41.8605613708496, 0.730604622654477, -77.3050003051758, -1.34922678358054, 218, 45, 'PPL', 'P'),
(27605, 'Keensburg', 38.3505592346191, 0.669343528625221, -87.8686065673828, -1.53359649374034, 218, 18, 'PPL', 'P'),
(16698, 'Keentown', 27.5711097717285, 0.481206643945445, -82.1377792358398, -1.43357468794164, 218, 12, 'PPL', 'P'),
(174729, 'Keenville', 44.0613899230957, 0.769016327163071, -88.5252838134766, -1.54505767380761, 218, 57, 'PPL', 'P'),
(14035, 'Keenwik Sound', 38.4702796936035, 0.671433044816497, -75.1066665649414, -1.31085862175577, 218, 10, 'PPL', 'P'),
(14036, 'Keenwik West', 38.4708290100098, 0.671442632196421, -75.1005630493164, -1.31075209531216, 218, 10, 'PPL', 'P'),
(78544, 'Keeny Row', 39.9538917541504, 0.697326960095337, -79.8869400024414, -1.39429013238577, 218, 45, 'PPL', 'P'),
(149969, 'Keepawa', 43.9575004577637, 0.767203113934891, -74.8397216796875, -1.30619955458673, 218, 40, 'PPL', 'P'),
(163260, 'Keepville', 41.8683280944824, 0.730740177553962, -80.3949966430664, -1.4031573935513, 218, 45, 'PPL', 'P'),
(88236, 'Keese', 35.2058296203613, 0.61445764277145, -86.0983276367188, -1.50269929772157, 218, 50, 'PPL', 'P'),
(88237, 'Keese (historical)', 36.2527809143066, 0.632730389958811, -84.9402770996094, -1.48248750294452, 218, 50, 'PPL', 'P'),
(149972, 'Keese Mill', 44.4324989318848, 0.775493401250253, -74.2972183227539, -1.29673108480511, 218, 40, 'PPL', 'P'),
(186909, 'Keesee', 38.1363906860352, 0.665605582298213, -102.778327941895, -1.79382022228055, 218, 7, 'PPL', 'P'),
(149970, 'Keeseville', 44.5050010681152, 0.776758802242204, -73.4805603027344, -1.28247771349296, 218, 40, 'PPL', 'P'),
(149971, 'Keesler Corners', 42.9174995422363, 0.749051673735183, -74.6800003051758, -1.30341189071569, 218, 40, 'PPL', 'P'),
(95265, 'Keeter', 33.0344390869141, 0.57655972861616, -97.6127777099609, -1.70366436305615, 218, 51, 'PPL', 'P'),
(55640, 'Keethtown', 38.0430603027344, 0.663976659817466, -92.4238891601563, -1.61310117334302, 218, 29, 'PPL', 'P'),
(204522, 'Keetley', 40.6355590820313, 0.70922429937013, -111.413887023926, -1.94453916101249, 218, 52, 'PPL', 'P'),
(204523, 'Keetley Junction', 40.6824989318848, 0.710043554300466, -111.456939697266, -1.94529057191406, 218, 52, 'PPL', 'P'),
(76255, 'Keetonville', 36.3063888549805, 0.633666025028783, -95.7080612182617, -1.67042078895896, 218, 42, 'PPL', 'P'),
(9823, 'Keevil', 34.7880592346191, 0.607166174022923, -91.2438888549805, -1.59250628284317, 218, 4, 'PPL', 'P'),
(131549, 'Keewahdin', 43.0397186279297, 0.751184799189309, -82.4444427490234, -1.43892697594242, 218, 27, 'PPL', 'P'),
(136187, 'Keewatin', 47.3997192382813, 0.827281165228906, -93.0722198486328, -1.62441667849866, 218, 28, 'PPL', 'P'),
(144015, 'Keewayden', 43.6016693115234, 0.760992688851853, -71.2516708374023, -1.2435762536599, 218, 36, 'PPL', 'P'),
(163261, 'Keewaydin', 41.1044387817383, 0.71740779392578, -78.1555633544922, -1.36407190928691, 218, 45, 'PPL', 'P'),
(103258, 'Keezletown', 38.4150009155273, 0.670468248132588, -78.8022232055664, -1.37535825282861, 218, 53, 'PPL', 'P'),
(163263, 'Keffers', 40.6124992370605, 0.708821829150392, -76.4647216796875, -1.33456115493164, 218, 45, 'PPL', 'P'),
(78545, 'Kegg', 39.9819412231445, 0.697816515682721, -78.7205581665039, -1.3739329290132, 218, 45, 'PPL', 'P'),
(193694, 'Kegg', 41.6894416809082, 0.727618020650007, -121.985832214355, -2.12905441292587, 218, 6, 'PPL', 'P'),
(27606, 'Kegley', 37.9094390869141, 0.661644529650883, -88.7430572509766, -1.54885853731537, 218, 18, 'PPL', 'P'),
(109925, 'Kegley', 37.3969383239746, 0.652699703918607, -81.1319427490234, -1.41601952951, 218, 58, 'PPL', 'P'),
(103259, 'Kegleys', 36.9816703796387, 0.645451911011956, -81.1419372558594, -1.4161939665614, 218, 53, 'PPL', 'P'),
(174730, 'Kegonsa', 42.9772186279297, 0.750093968406813, -89.2002792358398, -1.55683856636374, 218, 57, 'PPL', 'P'),
(210379, 'Kehena', 19.3955593109131, 0.338516370241276, -154.933059692383, -2.70409201182099, 218, 15, 'PPL', 'P'),
(163262, 'Kehler', 40.6941719055176, 0.710247286123857, -76.5274963378906, -1.33565677940409, 218, 45, 'PPL', 'P'),
(36681, 'Kehoe', 38.4661102294922, 0.67136027393971, -83.0513916015625, -1.44952023181043, 218, 21, 'PPL', 'P'),
(48591, 'Keifers', 39.5308303833008, 0.689943146236011, -78.4661102294922, -1.36949197473744, 218, 25, 'PPL', 'P'),
(163264, 'Keifertown', 40.103328704834, 0.699935126908906, -79.5791702270508, -1.38891853646708, 218, 45, 'PPL', 'P'),
(32909, 'Keighley', 37.6725006103516, 0.657509173110208, -96.6425018310547, -1.68672985431655, 218, 20, 'PPL', 'P'),
(204528, 'Keigley', 40.0055618286133, 0.698228773019465, -111.808609008789, -1.95142835927836, 218, 52, 'PPL', 'P'),
(204525, 'Keil Number 1', 40.639720916748, 0.709296937088862, -111.938888549805, -1.95370216621707, 218, 52, 'PPL', 'P'),
(204526, 'Keil Number 2', 40.6419410705566, 0.709335686082722, -111.940002441406, -1.95372160729303, 218, 52, 'PPL', 'P'),
(196808, 'Keiley', 46.7627792358398, 0.816164465048643, -112.679718017578, -1.96663207962552, 218, 31, 'PPL', 'P'),
(60467, 'Keirn', 33.2744407653809, 0.580748548115718, -90.2241668701172, -1.57470877675233, 218, 30, 'PPL', 'P'),
(9824, 'Keiser', 35.6744384765625, 0.622636410216166, -90.0997161865234, -1.57253670256726, 218, 4, 'PPL', 'P'),
(88238, 'Keister', 36.1363906860352, 0.630698997258326, -83.4638900756836, -1.4567196883433, 218, 50, 'PPL', 'P'),
(103263, 'Keister', 39.2811088562012, 0.685584683375014, -77.6377792358398, -1.35503487160189, 218, 53, 'PPL', 'P'),
(109923, 'Keister', 37.8627815246582, 0.660830201568564, -80.3430633544922, -1.40225098667429, 218, 58, 'PPL', 'P'),
(163265, 'Keisters', 41.035831451416, 0.716210370120653, -80.0119400024414, -1.39647179395076, 218, 45, 'PPL', 'P'),
(78546, 'Keisterville', 39.9613914489746, 0.697457854462915, -79.7827835083008, -1.39247225862568, 218, 45, 'PPL', 'P'),
(163266, 'Keiters Mill', 40.2286109924316, 0.702121715321916, -77.3341674804688, -1.34973584682291, 218, 45, 'PPL', 'P'),
(3489, 'Keith', 31.6772193908691, 0.552871776247259, -87.3613891601563, -1.52474387996081, 218, 2, 'PPL', 'P'),
(22328, 'Keith', 34.9180603027344, 0.609435120692643, -85.0419387817383, -1.48426183402079, 218, 13, 'PPL', 'P'),
(36682, 'Keith', 36.8522186279297, 0.64319255172216, -83.3713912963867, -1.45510528009049, 218, 21, 'PPL', 'P'),
(73086, 'Keith', 39.6566696166992, 0.692139455186999, -81.5630569458008, -1.42354389169585, 218, 41, 'PPL', 'P'),
(76256, 'Keith', 36.0916709899902, 0.629918491321851, -95.4644393920898, -1.66616878596254, 218, 42, 'PPL', 'P'),
(95266, 'Keith', 30.6450004577637, 0.534856157263146, -96.1011123657227, -1.6772808256109, 218, 51, 'PPL', 'P'),
(103261, 'Keith', 37.8411102294922, 0.660451966114746, -77.2566680908203, -1.34838322730526, 218, 53, 'PPL', 'P'),
(109924, 'Keith', 38.042781829834, 0.663971799548476, -81.5738906860352, -1.42373297613325, 218, 58, 'PPL', 'P'),
(140305, 'Keith', 48.0933303833008, 0.839386963438025, -98.7522201538086, -1.72355138533826, 218, 34, 'PPL', 'P'),
(182433, 'Keith', 34.3941688537598, 0.600291489984992, -118.959167480469, -2.07622914796555, 218, 6, 'PPL', 'P'),
(199438, 'Keith', 41.0905609130859, 0.717165579424637, -100.563606262207, -1.7551660369547, 218, 35, 'PPL', 'P'),
(174731, 'Keith (historical)', 45.5083312988281, 0.794270218252938, -88.8827819824219, -1.55129719392555, 218, 57, 'PPL', 'P'),
(88239, 'Keith Springs', 35.0875015258789, 0.612392427925121, -86.1122207641602, -1.50294177853882, 218, 50, 'PPL', 'P'),
(22330, 'Keiths Mill', 34.7430610656738, 0.606380807817458, -84.8811111450195, -1.48145486223184, 218, 13, 'PPL', 'P'),
(22329, 'Keithsburg', 34.2744407653809, 0.598201840635661, -84.4516677856445, -1.47395966165993, 218, 13, 'PPL', 'P'),
(120185, 'Keithsburg', 41.0994415283203, 0.71732057540008, -90.942497253418, -1.58724600705804, 218, 18, 'PPL', 'P'),
(95267, 'Keithton', 30.8661098480225, 0.538715244130239, -93.9233322143555, -1.63927139158496, 218, 51, 'PPL', 'P'),
(41573, 'Keithville', 32.3330612182617, 0.564318375507556, -93.8361129760742, -1.63774912870587, 218, 22, 'PPL', 'P'),
(81831, 'Keitts Crossroads', 34.3436088562012, 0.599409051557794, -81.5105590820313, -1.42262763112281, 218, 48, 'PPL', 'P'),
(201057, 'Keizer', 44.9902801513672, 0.78522852003601, -123.025001525879, -2.14719133889763, 218, 43, 'PPL', 'P'),
(210381, 'Kekaha', 21.9708309173584, 0.38346333890687, -159.714996337891, -2.78755255090688, 218, 15, 'PPL', 'P'),
(193695, 'Kekawaka', 40.0955581665039, 0.699799505430394, -123.518058776855, -2.15579681132801, 218, 6, 'PPL', 'P'),
(174732, 'Kekoskee', 43.5299987792969, 0.759741802087843, -88.5608291625977, -1.54567805718354, 218, 57, 'PPL', 'P'),
(210386, 'Kekupua', 21.9497203826904, 0.383094890570058, -159.645004272461, -2.78633095891486, 218, 15, 'PPL', 'P'),
(36683, 'Kelat', 38.5261116027832, 0.672407495459357, -84.3122177124023, -1.4715257987397, 218, 21, 'PPL', 'P'),
(210387, 'Kelawea', 20.8850002288818, 0.364512018273757, -156.675003051758, -2.73449465882534, 218, 15, 'PPL', 'P'),
(163267, 'Kelayres', 40.9008293151855, 0.713854138346205, -76.0038909912109, -1.32651814212349, 218, 45, 'PPL', 'P'),
(131550, 'Kelden', 46.2158317565918, 0.806618430700281, -84.290283203125, -1.471142969333, 218, 27, 'PPL', 'P'),
(202269, 'Keldron', 45.9319381713867, 0.801663552913162, -101.809173583984, -1.77690528777496, 218, 49, 'PPL', 'P'),
(66041, 'Kelford', 36.1794395446777, 0.631450341580865, -77.2238922119141, -1.34781118030311, 218, 33, 'PPL', 'P'),
(194266, 'Kelim', 40.4066696166992, 0.705229424576956, -104.95027923584, -1.83172792355284, 218, 7, 'PPL', 'P'),
(186910, 'Kelker', 38.7958297729492, 0.677114965581208, -104.780830383301, -1.82877048316231, 218, 7, 'PPL', 'P'),
(27608, 'Kell', 38.4911117553711, 0.67179663288432, -88.9063873291016, -1.55170918494619, 218, 18, 'PPL', 'P'),
(36684, 'Kellacey', 37.9619407653809, 0.662560856802952, -83.3916702270508, -1.45545921419936, 218, 21, 'PPL', 'P'),
(95268, 'Kelland Heights', 29.4036102294922, 0.513189810477724, -98.647216796875, -1.72171873103412, 218, 51, 'PPL', 'P'),
(3490, 'Kellar Quarry Landing', 34.7344398498535, 0.606230339215869, -87.758056640625, -1.53166703353058, 218, 2, 'PPL', 'P'),
(81833, 'Kellehan Crossroads', 33.5905609130859, 0.586265885525062, -79.679443359375, -1.39066863277743, 218, 48, 'PPL', 'P'),
(22331, 'Keller', 31.8430595397949, 0.555766232878012, -81.2538909912109, -1.41814792785319, 218, 13, 'PPL', 'P'),
(30235, 'Keller', 39.360279083252, 0.686966464506602, -87.3241729736328, -1.52409433497094, 218, 19, 'PPL', 'P'),
(41574, 'Keller', 30.9416694641113, 0.540034008212532, -91.7219390869141, -1.60084983338033, 218, 22, 'PPL', 'P'),
(48592, 'Keller', 39.3358306884766, 0.686539759520944, -77.4436111450195, -1.35164599911477, 218, 25, 'PPL', 'P'),
(95269, 'Keller', 32.934440612793, 0.574814425995776, -97.2513885498047, -1.69735693233041, 218, 51, 'PPL', 'P'),
(103262, 'Keller', 37.6191711425781, 0.656578398309225, -75.7641677856445, -1.32233418289292, 218, 53, 'PPL', 'P'),
(120187, 'Keller', 40.7613906860352, 0.711420475163064, -89.5972213745117, -1.56376651362347, 218, 18, 'PPL', 'P'),
(186911, 'Keller', 38.0627784729004, 0.664320806809331, -103.14582824707, -1.80023431260795, 218, 7, 'PPL', 'P'),
(207770, 'Keller', 48.0788917541504, 0.839134961819876, -118.683891296387, -2.07142467220099, 218, 56, 'PPL', 'P'),
(9825, 'Keller (historical)', 36.3102798461914, 0.63373393563658, -90.8611068725586, -1.5858254769326, 218, 4, 'PPL', 'P'),
(182435, 'Keller Place', 39.7155609130859, 0.693167302209715, -122.906669616699, -2.14512605747228, 218, 6, 'PPL', 'P'),
(3491, 'Kellerman', 33.3405609130859, 0.581902562395077, -87.3047180175781, -1.52375478193196, 218, 2, 'PPL', 'P'),
(95270, 'Kellers Corner Colonia', 25.9139995574951, 0.452284614638643, -97.4079971313477, -1.70009026771521, 218, 51, 'PPL', 'P'),
(199440, 'Kellers Trailer Court', 42.8047218322754, 0.747083331373506, -102.202781677246, -1.78377504496488, 218, 35, 'PPL', 'P'),
(163268, 'Kellersburg', 40.9694404602051, 0.71505162873036, -79.4244384765625, -1.38621795796368, 218, 45, 'PPL', 'P'),
(163269, 'Kellersville', 40.9433288574219, 0.71459589528882, -75.2947235107422, -1.31414083464124, 218, 45, 'PPL', 'P'),
(116287, 'Kellerton', 40.7108306884766, 0.710538036735866, -94.0497207641602, -1.64147728791587, 218, 16, 'PPL', 'P'),
(88240, 'Kellertown', 35.5338897705078, 0.620183372536094, -86.2886123657227, -1.50602039275895, 218, 50, 'PPL', 'P'),
(27609, 'Kellerville', 39.9311103820801, 0.696929350144588, -90.934440612793, -1.58710539215249, 218, 18, 'PPL', 'P'),
(30236, 'Kellerville', 38.4816703796387, 0.671631849791871, -86.831672668457, -1.51549858307855, 218, 19, 'PPL', 'P'),
(55641, 'Kellerville', 39.8219413757324, 0.695023991542691, -92.1347198486328, -1.60805421676121, 218, 29, 'PPL', 'P'),
(66043, 'Kellerville', 36.2452812194824, 0.632599495591234, -81.8977813720703, -1.42938593502111, 218, 33, 'PPL', 'P'),
(163270, 'Kellerville', 40.6597213745117, 0.709646010928744, -77.1608276367188, -1.34671049582458, 218, 45, 'PPL', 'P'),
(191682, 'Kellerville', 35.3716697692871, 0.617352099402203, -100.502502441406, -1.75409957409618, 218, 51, 'PPL', 'P'),
(163271, 'Kellettville', 41.5380592346191, 0.72497589853254, -79.2680587768555, -1.38348861732052, 218, 45, 'PPL', 'P'),
(116288, 'Kelley', 41.9505615234375, 0.732175421644433, -93.6650009155273, -1.63476265985946, 218, 16, 'PPL', 'P'),
(196809, 'Kelley', 46.7641716003418, 0.81618876639359, -108.17749786377, -1.88805351429191, 218, 31, 'PPL', 'P'),
(41575, 'Kelley (historical)', 30.8858299255371, 0.539059424411618, -92.2022171020508, -1.60923226606941, 218, 22, 'PPL', 'P'),
(120188, 'Kelley Corners', 42.4944381713867, 0.741667859875857, -87.9716720581055, -1.53539532589864, 218, 18, 'PPL', 'P'),
(204530, 'Kelley Kay Acres', 41.172779083252, 0.718600557198999, -112.089172363281, -1.95632511357469, 218, 52, 'PPL', 'P'),
(55642, 'Kelley Springs', 36.7152786254883, 0.640802497801869, -94.4197235107422, -1.64793505408515, 218, 29, 'PPL', 'P'),
(88241, 'Kelley Town', 36.0374984741211, 0.628973002555846, -84.3611068725586, -1.47237907555296, 218, 50, 'PPL', 'P'),
(127850, 'Kelleyland', 45.2675018310547, 0.790066951104466, -67.4780578613281, -1.17771428253142, 218, 26, 'PPL', 'P'),
(27610, 'Kelleys', 37.6030616760254, 0.65629723507714, -88.960563659668, -1.55265474029122, 218, 18, 'PPL', 'P'),
(41576, 'Kelleys', 32.475830078125, 0.566810162181489, -92.5583267211914, -1.61544755142144, 218, 22, 'PPL', 'P'),
(149973, 'Kelleys', 42.7794418334961, 0.746642112159907, -74.0683288574219, -1.29273621001194, 218, 40, 'PPL', 'P'),
(144018, 'Kelleys Corner', 43.2916717529297, 0.755582210781248, -71.3611068725586, -1.2454862727937, 218, 36, 'PPL', 'P'),
(60468, 'Kelleys Crossing', 34.7277793884277, 0.606114092234287, -90.1050033569336, -1.57262898109903, 218, 30, 'PPL', 'P'),
(155959, 'Kelleys Island', 41.5969390869141, 0.726003545818174, -82.7102813720703, -1.44356673519356, 218, 41, 'PPL', 'P'),
(22332, 'Kelleytown', 33.5372200012207, 0.585334910986998, -84.0891723632813, -1.46763292301628, 218, 13, 'PPL', 'P'),
(144019, 'Kelleyville', 43.3624992370605, 0.756818383580236, -72.2249984741211, -1.26056402562129, 218, 36, 'PPL', 'P'),
(204529, 'Kellgreen Acres', 40.639720916748, 0.709296937088862, -111.848892211914, -1.95213143380614, 218, 52, 'PPL', 'P'),
(136190, 'Kelliher', 47.9416694641113, 0.836739981051568, -94.4480590820313, -1.64842960309958, 218, 28, 'PPL', 'P'),
(155961, 'Kellker (historical)', 40.6116714477539, 0.708807381501478, -82.7474975585938, -1.44421628018343, 218, 41, 'PPL', 'P'),
(174734, 'Kellner', 44.3588905334473, 0.774208692340399, -89.7247161865234, -1.56599171787228, 218, 57, 'PPL', 'P'),
(174735, 'Kellners Corners', 44.1261100769043, 0.770145906939428, -87.7094421386719, -1.53081855040728, 218, 57, 'PPL', 'P'),
(174736, 'Kellnersville', 44.225830078125, 0.771886349290822, -87.8022232055664, -1.5324378855081, 218, 57, 'PPL', 'P'),
(27611, 'Kellogg', 38.0158309936523, 0.663501418720941, -90.054443359375, -1.57174654267184, 218, 18, 'PPL', 'P'),
(32907, 'Kellogg', 37.2591705322266, 0.650295202349402, -97.1091690063477, -1.6948747330364, 218, 20, 'PPL', 'P'),
(41577, 'Kellogg', 29.9105606079102, 0.522037763725349, -90.3566665649414, -1.5770213326849, 218, 22, 'PPL', 'P'),
(55643, 'Kellogg', 39.7961082458496, 0.694573118370141, -92.4422225952148, -1.613421152148, 218, 29, 'PPL', 'P'),
(95271, 'Kellogg', 33.209171295166, 0.579609380959437, -96.1508331298828, -1.6781486166521, 218, 51, 'PPL', 'P'),
(116289, 'Kellogg', 41.7180595397949, 0.728117496512452, -92.9072189331055, -1.6215368692539, 218, 16, 'PPL', 'P'),
(136193, 'Kellogg', 44.3086090087891, 0.77333111418219, -91.9955596923828, -1.60562541384706, 218, 28, 'PPL', 'P'),
(140306, 'Kellogg', 48.3630599975586, 0.844094633296958, -97.4269409179688, -1.70042089916454, 218, 34, 'PPL', 'P'),
(149974, 'Kellogg', 44.7330589294434, 0.780739162807436, -74.7305603027344, -1.30429432914289, 218, 40, 'PPL', 'P'),
(163272, 'Kellogg', 41.6780586242676, 0.727419348832687, -76.4599990844727, -1.3344787300959, 218, 45, 'PPL', 'P'),
(182436, 'Kellogg', 38.6322212219238, 0.674259457681398, -122.672782897949, -2.1410439641534, 218, 6, 'PPL', 'P'),
(195176, 'Kellogg', 47.538330078125, 0.829700380763134, -116.11833190918, -2.02664721373878, 218, 17, 'PPL', 'P'),
(201058, 'Kellogg', 43.5552787780762, 0.760183021301442, -123.553886413574, -2.15642212155196, 218, 43, 'PPL', 'P'),
(22334, 'Kellogg Creek', 34.1136093139648, 0.595394802267691, -84.6080627441406, -1.4766892686192, 218, 13, 'PPL', 'P'),
(22335, 'Kellogg Creek North', 34.1236114501953, 0.595569372477145, -84.607780456543, -1.47668434177119, 218, 13, 'PPL', 'P'),
(201059, 'Kellogg Park', 45.4544410705566, 0.79332965633495, -122.636390686035, -2.14040880023342, 218, 43, 'PPL', 'P'),
(149975, 'Kelloggsville', 42.7869415283203, 0.746773006527484, -76.3658294677734, -1.33283516022916, 218, 40, 'PPL', 'P'),
(155962, 'Kelloggsville', 41.8566703796387, 0.73053671204668, -80.6175003051758, -1.40704081505285, 218, 41, 'PPL', 'P'),
(66044, 'Kellogs Fork', 36.4558296203613, 0.63627425842138, -76.6052780151367, -1.33701432576976, 218, 33, 'PPL', 'P'),
(76258, 'Kellond', 34.2636108398438, 0.598012822777293, -95.6399993896484, -1.66923288595473, 218, 42, 'PPL', 'P'),
(131551, 'Kells', 45.434440612793, 0.792980582495067, -87.7088928222656, -1.53080896302736, 218, 27, 'PPL', 'P'),
(103264, 'Kells Corner', 36.8783302307129, 0.6436482851637, -78.4080581665039, -1.36847877510072, 218, 53, 'PPL', 'P'),
(22337, 'Kelltown', 31.3947200775146, 0.5479412330946, -83.5369415283203, -1.45799467671517, 218, 13, 'PPL', 'P'),
(9826, 'Kellum', 34.1163902282715, 0.595443338378557, -94.4397201538086, -1.64828406134601, 218, 4, 'PPL', 'P'),
(66045, 'Kellum', 34.8044395446777, 0.607452064365943, -77.3563919067383, -1.35012373623568, 218, 33, 'PPL', 'P'),
(3492, 'Kelly', 31.3236103057861, 0.546700133447596, -85.6552810668945, -1.49496667633847, 218, 2, 'PPL', 'P'),
(22336, 'Kelly', 33.4402809143066, 0.583643004746471, -83.6194381713867, -1.45943451475852, 218, 13, 'PPL', 'P'),
(32908, 'Kelly', 39.7377815246582, 0.693555125043458, -96.003059387207, -1.67556947829441, 218, 20, 'PPL', 'P'),
(36685, 'Kelly', 36.9705581665039, 0.645257966305571, -87.476936340332, -1.52676055869627, 218, 21, 'PPL', 'P'),
(41578, 'Kelly', 31.9805603027344, 0.558166073915309, -92.1766662597656, -1.60878631974488, 218, 22, 'PPL', 'P'),
(60469, 'Kelly', 31.5874996185303, 0.551305870815806, -89.4444427490234, -1.56110002358203, 218, 30, 'PPL', 'P'),
(66046, 'Kelly', 34.4661102294922, 0.601547103859937, -78.3247222900391, -1.36702428967137, 218, 33, 'PPL', 'P'),
(81834, 'Kelly', 34.8122215270996, 0.607587885581537, -81.5972213745117, -1.42414017346392, 218, 48, 'PPL', 'P'),
(95272, 'Kelly', 33.3624992370605, 0.582285458380803, -96.6186065673828, -1.68631280328985, 218, 51, 'PPL', 'P'),
(103265, 'Kelly', 37.3858299255371, 0.652505825791249, -79.0630569458008, -1.379910660396, 218, 53, 'PPL', 'P'),
(109926, 'Kelly', 37.8486099243164, 0.660582860482323, -81.8061065673828, -1.42778590783819, 218, 58, 'PPL', 'P'),
(140307, 'Kelly', 47.9799995422363, 0.837408967117396, -97.245002746582, -1.69724547903879, 218, 34, 'PPL', 'P'),
(174739, 'Kelly', 44.913330078125, 0.783885487898283, -89.5625, -1.56316051131742, 218, 57, 'PPL', 'P'),
(188759, 'Kelly', 34.0830612182617, 0.594861637417457, -107.204719543457, -1.87107532971044, 218, 38, 'PPL', 'P'),
(209543, 'Kelly', 43.6230583190918, 0.761365997457655, -110.622779846191, -1.93073173602487, 218, 59, 'PPL', 'P'),
(48593, 'Kelly (historical)', 38.2852783203125, 0.668204161731857, -75.4836120605469, -1.31743756175464, 218, 25, 'PPL', 'P'),
(193696, 'Kelly (historical)', 40.9194412231445, 0.714178977420168, -122.105560302734, -2.1311440622752, 218, 6, 'PPL', 'P'),
(9827, 'Kelly Addition', 34.8977813720703, 0.609081186583771, -91.9588928222656, -1.60498545623712, 218, 4, 'PPL', 'P'),
(174740, 'Kelly Brook', 44.9602813720703, 0.784704942565701, -88.2158279418945, -1.53965664995887, 218, 57, 'PPL', 'P'),
(113598, 'Kelly Corner', 41.8783302307129, 0.730914747763416, -73.2069396972656, -1.27770213302623, 218, 8, 'PPL', 'P'),
(125166, 'Kelly Corner', 42.4749984741211, 0.741328573152981, -71.4541702270508, -1.24711053474254, 218, 23, 'PPL', 'P'),
(149976, 'Kelly Corners', 42.1819381713867, 0.736213705963374, -74.5999984741211, -1.30201559535616, 218, 40, 'PPL', 'P'),
(200033, 'Kelly Creek (historical)', 41.2649993896484, 0.720210105182816, -117.094169616699, -2.04367879470011, 218, 39, 'PPL', 'P'),
(163273, 'Kelly Crossroads', 41.0163917541504, 0.715871083397777, -76.9358291625977, -1.3427835316392, 218, 45, 'PPL', 'P'),
(81836, 'Kelly Farms', 34.1747207641602, 0.596461398284267, -79.908332824707, -1.3946635075706, 218, 48, 'PPL', 'P'),
(41579, 'Kelly Front (historical)', 32.0419387817383, 0.559237330463794, -92.540283203125, -1.61513263262254, 218, 22, 'PPL', 'P'),
(109927, 'Kelly Hill', 38.4830589294434, 0.671656084557791, -81.3636093139648, -1.42006287383501, 218, 58, 'PPL', 'P'),
(136196, 'Kelly Lake', 47.4174995422363, 0.827591490074928, -93.0063934326172, -1.6232677908044, 218, 28, 'PPL', 'P'),
(136197, 'Kelly Landing', 47.6766700744629, 0.832114869186428, -91.3358306884766, -1.594110970558, 218, 28, 'PPL', 'P'),
(163274, 'Kelly Point', 40.9919395446777, 0.715444311833092, -76.9358291625977, -1.3427835316392, 218, 45, 'PPL', 'P'),
(48594, 'Kelly Ridge', 39.3677787780762, 0.687097358874179, -77.2077789306641, -1.34752995049199, 218, 25, 'PPL', 'P'),
(3493, 'Kelly Springs', 31.2758293151855, 0.545866197841751, -85.4555587768555, -1.49148086478767, 218, 2, 'PPL', 'P'),
(55645, 'Kelly Town', 36.750560760498, 0.641418287224922, -90.4024963378906, -1.57782121311831, 218, 29, 'PPL', 'P'),
(163276, 'Kellyburg', 41.4383316040039, 0.723235323023091, -76.878059387207, -1.3417752588505, 218, 45, 'PPL', 'P'),
(149977, 'Kellys Corners', 43.0149993896484, 0.750753367092716, -76.2527770996094, -1.33086202417752, 218, 40, 'PPL', 'P'),
(3495, 'Kellys Crossroads', 31.0694408416748, 0.542264039440824, -85.7516708374023, -1.49664899519907, 218, 2, 'PPL', 'P'),
(66053, 'Kellys Crossroads', 36.3891716003418, 0.635110856499179, -78.4491729736328, -1.36919636385644, 218, 33, 'PPL', 'P'),
(103266, 'Kellys Ford', 38.4772186279297, 0.671554152067068, -77.7802810668945, -1.35752199774392, 218, 53, 'PPL', 'P'),
(207771, 'Kellys Korner', 46.9850006103516, 0.82004295970218, -122.766937255859, -2.14268726770404, 218, 56, 'PPL', 'P'),
(16699, 'Kellys Mill', 30.7377796173096, 0.536475459074455, -86.7761077880859, -1.51452879296759, 218, 12, 'PPL', 'P'),
(109928, 'Kellysville', 37.3447189331055, 0.651788303614554, -80.9280624389648, -1.41246114681949, 218, 58, 'PPL', 'P'),
(3496, 'Kellyton', 32.9797210693359, 0.575604719049257, -86.0336074829102, -1.50156971794521, 218, 2, 'PPL', 'P'),
(81838, 'Kellytown', 34.2477798461914, 0.597736519814197, -80.7341690063477, -1.40907706802233, 218, 48, 'PPL', 'P'),
(163278, 'Kellytown', 41.8308296203613, 0.730085705716075, -77.091667175293, -1.3455034180605, 218, 45, 'PPL', 'P'),
(186912, 'Kellytown', 39.4813919067383, 0.689080282042825, -104.993057250977, -1.83247454076445, 218, 7, 'PPL', 'P'),
(36686, 'Kellyville', 37.1972198486328, 0.649213958946829, -85.3255615234375, -1.48921198469697, 218, 21, 'PPL', 'P'),
(76261, 'Kellyville', 36.7586097717285, 0.641558768972424, -94.6980590820313, -1.65279292622956, 218, 42, 'PPL', 'P'),
(78550, 'Kellyville', 39.9355583190918, 0.697006981290364, -75.2872161865234, -1.3140098071156, 218, 45, 'PPL', 'P'),
(95273, 'Kellyville', 32.7791709899902, 0.572104459849539, -94.4091720581055, -1.64775089649577, 218, 51, 'PPL', 'P'),
(120190, 'Kellyville', 40.0558280944824, 0.699106084861565, -87.6391677856445, -1.52959203156725, 218, 18, 'PPL', 'P'),
(66047, 'Kellyville (historical)', 35.2961082458496, 0.616033302030396, -80.9866714477539, -1.41348406699419, 218, 33, 'PPL', 'P'),
(60470, 'Kelona', 31.9619407653809, 0.557841101683292, -89.0088882446289, -1.55349816340845, 218, 30, 'PPL', 'P'),
(103267, 'Kelsa', 37.440559387207, 0.653461035095233, -82.0688934326172, -1.43237240386752, 218, 53, 'PPL', 'P'),
(95274, 'Kelsay', 26.3413906097412, 0.459743995693901, -98.7397232055664, -1.72333327244498, 218, 51, 'PPL', 'P'),
(41580, 'Kelsey', 30.7105598449707, 0.536000384425498, -91.5177764892578, -1.59728652384181, 218, 22, 'PPL', 'P'),
(66048, 'Kelsey', 36.1222190856934, 0.630451656172085, -81.7249984741211, -1.42637030456076, 218, 33, 'PPL', 'P'),
(95275, 'Kelsey', 32.7316703796387, 0.571275417802197, -95.0494384765625, -1.6589256535878, 218, 51, 'PPL', 'P'),
(120191, 'Kelsey', 40.2436103820801, 0.702383504057071, -90.0436096191406, -1.57155745823444, 218, 18, 'PPL', 'P'),
(136198, 'Kelsey', 47.1538887023926, 0.822990612975707, -92.5991668701172, -1.6161603464872, 218, 28, 'PPL', 'P'),
(149978, 'Kelsey', 42.045280456543, 0.733828578891099, -75.2986068725586, -1.31420861209098, 218, 40, 'PPL', 'P'),
(182437, 'Kelsey', 38.7988891601563, 0.677168361961064, -120.819717407227, -2.10870187008521, 218, 6, 'PPL', 'P'),
(73087, 'Kelsey (historical)', 39.9644393920898, 0.697511051105689, -80.915283203125, -1.41223810707819, 218, 41, 'PPL', 'P'),
(81839, 'Kelsey Cove Landing', 32.9563903808594, 0.575197521718584, -80.4063873291016, -1.40335619852667, 218, 48, 'PPL', 'P'),
(113599, 'Kelseytown', 41.2966690063477, 0.720762844267062, -72.5327835083008, -1.26593588785609, 218, 8, 'PPL', 'P'),
(182438, 'Kelseyville', 38.9780616760254, 0.680295512292062, -122.838333129883, -2.14393336077809, 218, 6, 'PPL', 'P'),
(9828, 'Kelso', 33.7975006103516, 0.589877664595428, -91.2705612182617, -1.59297180340171, 218, 4, 'PPL', 'P'),
(32910, 'Kelso', 38.7347183227539, 0.676048369564631, -96.5702819824219, -1.68546938017262, 218, 20, 'PPL', 'P'),
(55648, 'Kelso', 37.190559387207, 0.649097711965247, -89.5494384765625, -1.56293254472811, 218, 29, 'PPL', 'P'),
(60471, 'Kelso', 32.6691703796387, 0.570184587019701, -90.9036102294922, -1.58656730045424, 218, 30, 'PPL', 'P'),
(76264, 'Kelso', 36.7055587768555, 0.640632854440431, -95.1097183227539, -1.65997773537643, 218, 42, 'PPL', 'P'),
(88242, 'Kelso', 35.1258316040039, 0.613061413990949, -86.4686126708984, -1.50916199073887, 218, 50, 'PPL', 'P'),
(140308, 'Kelso', 47.3230590820313, 0.825943193097251, -97.029167175293, -1.69347843767687, 218, 34, 'PPL', 'P'),
(182439, 'Kelso', 35.0125007629395, 0.61108341767032, -115.652778625488, -2.01852177609489, 218, 6, 'PPL', 'P'),
(195178, 'Kelso', 48.0119400024414, 0.837966433312577, -116.705558776855, -2.03689625603589, 218, 17, 'PPL', 'P'),
(199441, 'Kelso', 42.0436096191406, 0.733799417277163, -100.925827026367, -1.76148798190839, 218, 35, 'PPL', 'P'),
(201060, 'Kelso', 45.4186096191406, 0.792704279531972, -122.306938171387, -2.13465876912383, 218, 43, 'PPL', 'P'),
(207772, 'Kelso', 46.1469383239746, 0.805416013468111, -122.907218933105, -2.1451356448522, 218, 56, 'PPL', 'P'),
(131552, 'Kelso Junction', 46.1472206115723, 0.805420940316127, -88.2536087036133, -1.54031604864478, 218, 27, 'PPL', 'P'),
(103268, 'Kelso Mill', 37.3963890075684, 0.652690116538682, -79.5563888549805, -1.38852092651633, 218, 53, 'PPL', 'P'),
(36687, 'Keltner', 37.0950012207031, 0.647429907332585, -85.5102767944336, -1.49243587435457, 218, 21, 'PPL', 'P'),
(55650, 'Keltner', 36.9688911437988, 0.645228871270662, -92.9480590820313, -1.62224966431966, 218, 29, 'PPL', 'P'),
(78547, 'Kelton', 39.8086090087891, 0.694791297842445, -75.8783264160156, -1.32432662686246, 218, 45, 'PPL', 'P'),
(81842, 'Kelton', 34.8333282470703, 0.607956267339322, -81.579719543457, -1.42383470888689, 218, 48, 'PPL', 'P'),
(191683, 'Kelton', 35.4008293151855, 0.617861029486517, -100.112503051758, -1.74729280066604, 218, 51, 'PPL', 'P'),
(204532, 'Kelton', 41.7461090087891, 0.728607052099836, -113.105560302734, -1.97406442959571, 218, 52, 'PPL', 'P'),
(88245, 'Keltonburg', 35.8761100769043, 0.626156243649896, -85.7472229003906, -1.4965713640533, 218, 50, 'PPL', 'P'),
(95276, 'Keltys', 31.3613891601563, 0.547359498843986, -94.7508316040039, -1.65371398049257, 218, 51, 'PPL', 'P'),
(48595, 'Kelview', 39.4161109924316, 0.687940915149462, -77.5416717529297, -1.35335747958931, 218, 25, 'PPL', 'P'),
(178448, 'Kelvin', 33.1113891601563, 0.577902760753887, -110.972778320313, -1.93684036177524, 218, 5, 'PPL', 'P'),
(198470, 'Kelvin', 48.9372215270996, 0.854115642425736, -100.050559997559, -1.74621169042153, 218, 34, 'PPL', 'P'),
(22338, 'Kelvin Grove', 31.1597194671631, 0.543839698699769, -81.3797225952148, -1.42034410364612, 218, 13, 'PPL', 'P'),
(144020, 'Kelwyn Park', 43.2249984741211, 0.754418542542938, -70.8808288574219, -1.23710384010462, 218, 36, 'PPL', 'P'),
(192653, 'Kema', 38.8038902282715, 0.677255647065791, -112.024169921875, -1.95519060695032, 218, 52, 'PPL', 'P'),
(95277, 'Kemah', 29.5424995422363, 0.515613886280942, -95.0202789306641, -1.65841672350348, 218, 51, 'PPL', 'P'),
(78548, 'Kemblesville', 39.7488899230957, 0.693749003170816, -75.8244400024414, -1.3233861315235, 218, 45, 'PPL', 'P'),
(116291, 'Kemling (historical)', 41.1666717529297, 0.718493964176369, -95.2783279418945, -1.66292052838097, 218, 16, 'PPL', 'P'),
(88243, 'Kemmer Hill', 35.6777801513672, 0.622694733444038, -84.8688888549805, -1.48124154302853, 218, 50, 'PPL', 'P'),
(209544, 'Kemmerer', 41.7924995422363, 0.729416719650247, -110.53694152832, -1.92923357475364, 218, 59, 'PPL', 'P'),
(163279, 'Kemmererville', 40.9333305358887, 0.714421391658392, -75.2438888549805, -1.31325360252408, 218, 45, 'PPL', 'P'),
(22339, 'Kemp', 34.3624992370605, 0.599738750900746, -83.8141708374023, -1.46283324094168, 218, 13, 'PPL', 'P'),
(27612, 'Kemp', 39.6955604553223, 0.692818228369833, -88.1852798461914, -1.53912348510864, 218, 18, 'PPL', 'P'),
(36690, 'Kemp', 37.1363906860352, 0.648152289778269, -85.4580612182617, -1.49152454062954, 218, 21, 'PPL', 'P'),
(76265, 'Kemp', 33.7694396972656, 0.589387909270962, -96.353889465332, -1.68169261827272, 218, 42, 'PPL', 'P'),
(95278, 'Kemp', 32.4425010681152, 0.566228461220388, -96.2297210693359, -1.67952547093567, 218, 51, 'PPL', 'P'),
(155963, 'Kemp', 40.7236099243164, 0.71076107647716, -84.2233276367188, -1.46997437424668, 218, 41, 'PPL', 'P'),
(193191, 'Kemp', 41.7130584716797, 0.728030211407724, -103.107780456543, -1.79957025339014, 218, 35, 'PPL', 'P'),
(9829, 'Kemp (historical)', 33.7374992370605, 0.588830443075781, -92.8208312988281, -1.62002912060276, 218, 4, 'PPL', 'P'),
(188760, 'Kemp (historical)', 35.1074981689453, 0.612741435185976, -106.375, -1.85659399180897, 218, 38, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(9830, 'Kemp Addition', 34.9972190856934, 0.610816702087149, -92.0650024414063, -1.60683741845916, 218, 4, 'PPL', 'P'),
(103269, 'Kemp Corner', 37.9294395446777, 0.661993603490765, -77.3733291625977, -1.35041934711668, 218, 53, 'PPL', 'P'),
(48596, 'Kemp Mill', 39.038890838623, 0.681357181460623, -77.0194396972656, -1.34424281075851, 218, 25, 'PPL', 'P'),
(48597, 'Kemp Mill Estates', 39.0422210693359, 0.681415304951413, -77.022216796875, -1.34429128029035, 218, 25, 'PPL', 'P'),
(103270, 'Kemp Park', 38.9661102294922, 0.680086920199682, -78.1852798461914, -1.36459055990921, 218, 53, 'PPL', 'P'),
(27613, 'Kemper', 39.2161102294922, 0.684450243329668, -90.164436340332, -1.57366628234362, 218, 18, 'PPL', 'P'),
(41581, 'Kemper', 29.809440612793, 0.520272886870953, -91.6675033569336, -1.59989975066145, 218, 22, 'PPL', 'P'),
(81840, 'Kemper', 34.3280601501465, 0.599137675442715, -79.1997222900391, -1.38229592062633, 218, 48, 'PPL', 'P'),
(116292, 'Kemper', 40.7438888549805, 0.711115010586032, -91.1233291625977, -1.5904021192659, 218, 16, 'PPL', 'P'),
(60473, 'Kemper Springs', 32.5902786254883, 0.568807666157102, -88.5800018310547, -1.54601268337451, 218, 30, 'PPL', 'P'),
(48598, 'Kempfield', 39.6202812194824, 0.691504357846042, -76.8455581665039, -1.34120800553831, 218, 25, 'PPL', 'P'),
(103281, 'Kempis (historical)', 37.3050003051758, 0.651095082782807, -77.9155578613281, -1.35988302320833, 218, 53, 'PPL', 'P'),
(95287, 'Kempner', 31.0808296203613, 0.542462811126684, -98.0022201538086, -1.7104614159483, 218, 51, 'PPL', 'P'),
(48599, 'Kemps', 39.6136093139648, 0.691387911127379, -77.813606262207, -1.35810363212599, 218, 25, 'PPL', 'P'),
(27614, 'Kempside', 38.3172187805176, 0.668761627927038, -89.4266662597656, -1.56078976531503, 218, 18, 'PPL', 'P'),
(174742, 'Kempster', 45.2897186279297, 0.790454707359182, -89.1666717529297, -1.55625200513365, 218, 57, 'PPL', 'P'),
(103271, 'Kempsville', 36.8266716003418, 0.642746671976654, -76.1605606079102, -1.32925254277273, 218, 53, 'PPL', 'P'),
(103272, 'Kempsville Colony', 36.8180618286133, 0.642596403112146, -76.1594390869141, -1.32923296853871, 218, 53, 'PPL', 'P'),
(103273, 'Kempsville Gardens', 36.8255615234375, 0.642727297479723, -76.1561126708984, -1.32917491162695, 218, 53, 'PPL', 'P'),
(103274, 'Kempsville Heights', 36.834171295166, 0.642877566344231, -76.1575012207031, -1.32919914639287, 218, 53, 'PPL', 'P'),
(48600, 'Kempton', 39.2066688537598, 0.684285460237219, -79.4855575561523, -1.38728468713832, 218, 25, 'PPL', 'P'),
(113039, 'Kempton', 40.9355583190918, 0.714460273810307, -88.2372207641602, -1.5400300251437, 218, 18, 'PPL', 'P'),
(122948, 'Kempton', 40.288330078125, 0.703164009993546, -86.2297210693359, -1.50499254573624, 218, 19, 'PPL', 'P'),
(140310, 'Kempton', 47.8188896179199, 0.834597068480436, -97.6138916015625, -1.70368380413211, 218, 34, 'PPL', 'P'),
(163280, 'Kempton', 40.6261100769043, 0.709059383119627, -75.852783203125, -1.32388081369598, 218, 45, 'PPL', 'P'),
(125163, 'Kempton Croft', 41.6402816772461, 0.726760016725811, -71.0097198486328, -1.23935341227741, 218, 23, 'PPL', 'P'),
(109929, 'Kempton Junction', 39.2152786254883, 0.684435729101727, -79.4463882446289, -1.38660105368649, 218, 58, 'PPL', 'P'),
(48601, 'Kemptown', 39.3363914489746, 0.68654954663795, -77.2280578613281, -1.34788388460087, 218, 25, 'PPL', 'P'),
(88244, 'Kempville', 36.3466682434082, 0.634369032977537, -85.8633270263672, -1.49859776332674, 218, 50, 'PPL', 'P'),
(163281, 'Kempville', 40.4947204589844, 0.706766201683987, -75.8150024414063, -1.32322141501008, 218, 45, 'PPL', 'P'),
(186913, 'Ken Caryl', 39.5758285522461, 0.690728512441475, -105.111671447754, -1.83454474903782, 218, 7, 'PPL', 'P'),
(48602, 'Ken Gar', 39.0313911437988, 0.681226287093045, -77.0783309936523, -1.34527065778123, 218, 25, 'PPL', 'P'),
(182440, 'Ken Mar Gardens Mobile Home Park', 35.1055603027344, 0.612707613040132, -120.588890075684, -2.10467317314619, 218, 6, 'PPL', 'P'),
(36688, 'Ken Wye', 37.3455581665039, 0.65180295100055, -86.9533309936523, -1.51762192141567, 218, 21, 'PPL', 'P'),
(48603, 'Ken-Mar Manor', 39.396110534668, 0.68759184130958, -76.995002746582, -1.34381630550993, 218, 25, 'PPL', 'P'),
(211920, 'Kenai', 60.5544395446777, 1.05687434675448, -151.258331298828, -2.63995590223694, 218, 1, 'PPL', 'P'),
(16700, 'Kenansville', 27.8761100769043, 0.48652990349035, -80.9880599975586, -1.41350830176011, 218, 12, 'PPL', 'P'),
(66049, 'Kenansville', 34.9622192382813, 0.610205839512112, -77.9625015258789, -1.36070234471769, 218, 33, 'PPL', 'P'),
(198471, 'Kenaston', 48.6186103820801, 0.848554828911596, -102.11222076416, -1.78219445885791, 218, 34, 'PPL', 'P'),
(36689, 'Kenawood', 38.0583305358887, 0.664243175663555, -84.4516677856445, -1.47395966165993, 218, 21, 'PPL', 'P'),
(125164, 'Kenberma', 42.2833290100098, 0.737983309928705, -70.875, -1.23700210735098, 218, 23, 'PPL', 'P'),
(103276, 'Kenbridge', 36.9619407653809, 0.645107564283009, -78.1252822875977, -1.36354340496859, 218, 53, 'PPL', 'P'),
(32911, 'Kenbro', 38.1286087036133, 0.665469761082618, -96.3394393920898, -1.68144041691749, 218, 20, 'PPL', 'P'),
(149979, 'Kendaia', 42.7422218322754, 0.745992500591009, -76.8872222900391, -1.34193518167396, 218, 40, 'PPL', 'P'),
(125165, 'Kendal Green', 42.3797187805176, 0.739665628789308, -71.2822189331055, -1.24410941851013, 218, 23, 'PPL', 'P'),
(103277, 'Kendale', 37.3911094665527, 0.652597971164966, -77.4649963378906, -1.35201924114154, 218, 53, 'PPL', 'P'),
(78549, 'Kendale East', 39.9188919067383, 0.6967160975203, -76.6074981689453, -1.33705307476362, 218, 45, 'PPL', 'P'),
(16701, 'Kendale Lakes', 25.7077808380127, 0.448685419004429, -80.4072189331055, -1.40337071275461, 218, 12, 'PPL', 'P'),
(95279, 'Kendalia', 29.9688892364502, 0.523055790341545, -98.5219421386719, -1.71953227577917, 218, 51, 'PPL', 'P'),
(109930, 'Kendalia', 38.3363914489746, 0.669096254118007, -81.3133316040039, -1.41918536225583, 218, 58, 'PPL', 'P'),
(16702, 'Kendall', 25.6788902282715, 0.448181182741536, -80.317497253418, -1.40180477403365, 218, 12, 'PPL', 'P'),
(48604, 'Kendall', 39.6333312988281, 0.691732124698271, -79.4177780151367, -1.3861017109821, 218, 25, 'PPL', 'P'),
(55651, 'Kendall', 39.7166709899902, 0.693186676706645, -91.9169387817383, -1.6042532200954, 218, 29, 'PPL', 'P'),
(131553, 'Kendall', 42.3616714477539, 0.739350643411379, -85.8133316040039, -1.49772517859558, 218, 27, 'PPL', 'P'),
(149980, 'Kendall', 43.327220916748, 0.756202660736209, -78.0361099243164, -1.36198705362754, 218, 40, 'PPL', 'P'),
(163282, 'Kendall', 40.5341682434082, 0.707454695404799, -80.4880599975586, -1.40478165550014, 218, 45, 'PPL', 'P'),
(174743, 'Kendall', 43.7922210693359, 0.764318444421144, -90.3683319091797, -1.57722493135024, 218, 57, 'PPL', 'P'),
(187745, 'Kendall', 37.9347190856934, 0.662085748864482, -101.545562744141, -1.77230441067574, 218, 20, 'PPL', 'P'),
(207773, 'Kendall', 48.9172210693359, 0.853766568585854, -122.134719848633, -2.13165299235951, 218, 56, 'PPL', 'P'),
(196810, 'Kendall (historical)', 47.2844390869141, 0.825269147025352, -109.461669921875, -1.91046654486796, 218, 31, 'PPL', 'P'),
(66052, 'Kendall Chapel', 34.0897216796875, 0.594977884399039, -77.9630584716797, -1.36071206525567, 218, 33, 'PPL', 'P'),
(3497, 'Kendall Crossroads', 32.836669921875, 0.573108005527308, -85.5072174072266, -1.49238247797471, 218, 2, 'PPL', 'P'),
(16703, 'Kendall Green', 26.2536106109619, 0.458211945697805, -80.1241683959961, -1.39843054893252, 218, 12, 'PPL', 'P'),
(103278, 'Kendall Grove', 37.3677787780762, 0.652190773834293, -75.92138671875, -1.32507817092208, 218, 53, 'PPL', 'P'),
(103279, 'Kendall Grove Estates', 37.3697204589844, 0.652224662559164, -75.9352798461914, -1.32532065173933, 218, 53, 'PPL', 'P'),
(27615, 'Kendall Hill', 38.8497200012207, 0.678055527499197, -90.0436096191406, -1.57155745823444, 218, 18, 'PPL', 'P'),
(16704, 'Kendall Lakes', 25.6908302307129, 0.448389575096834, -80.4225006103516, -1.40363742833778, 218, 12, 'PPL', 'P'),
(149981, 'Kendall Mills', 43.2983283996582, 0.755698391183803, -77.9958267211914, -1.36128397909976, 218, 40, 'PPL', 'P'),
(145523, 'Kendall Park', 40.4208297729492, 0.705476565926116, -74.5611114501953, -1.30133688875235, 218, 37, 'PPL', 'P'),
(127851, 'Kendalls Corner', 44.4516716003418, 0.775828027441221, -69.086669921875, -1.20578985937525, 218, 26, 'PPL', 'P'),
(116293, 'Kendallville', 43.4394416809082, 0.758161282559908, -92.0361099243164, -1.60633314890675, 218, 16, 'PPL', 'P'),
(122949, 'Kendallville', 41.4413909912109, 0.723288719402947, -85.2649993896484, -1.48815497606032, 218, 19, 'PPL', 'P'),
(155965, 'Kendeigh Corner', 41.3786087036133, 0.722192961772434, -82.2527770996094, -1.43558177929718, 218, 41, 'PPL', 'P'),
(3498, 'Kendell (historical)', 34.976390838623, 0.610453180598353, -87.8816680908203, -1.53382446032965, 218, 2, 'PPL', 'P'),
(48605, 'Kendig Mill Station', 39.4458312988281, 0.688459632350782, -76.790283203125, -1.34024327543343, 218, 25, 'PPL', 'P'),
(163283, 'Kendigtown', 40.3474998474121, 0.704196717285251, -75.14111328125, -1.31145983037185, 218, 45, 'PPL', 'P'),
(95281, 'Kendleton', 29.4505596160889, 0.514009231855628, -95.9944381713867, -1.67541900969282, 218, 51, 'PPL', 'P'),
(60474, 'Kendrick', 34.9702796936035, 0.610346520996695, -88.3816680908203, -1.54255110658963, 218, 30, 'PPL', 'P'),
(76267, 'Kendrick', 35.7847213745117, 0.62456120989402, -96.7777786254883, -1.68909087978096, 218, 42, 'PPL', 'P'),
(112260, 'Kendrick', 29.2533302307129, 0.510566929699132, -82.1680603027344, -1.43410319225996, 218, 12, 'PPL', 'P'),
(163284, 'Kendrick', 40.8183288574219, 0.712414233723827, -78.3811111450195, -1.36800846085221, 218, 45, 'PPL', 'P'),
(195179, 'Kendrick', 46.6141700744629, 0.813570745883988, -116.645561218262, -2.03584910109528, 218, 17, 'PPL', 'P'),
(209545, 'Kendrick', 44.7208290100098, 0.780525710446067, -106.201393127441, -1.85356398027873, 218, 59, 'PPL', 'P'),
(22341, 'Kendrick (historical)', 34.8461112976074, 0.608179373659643, -85.3713912963867, -1.49001186513038, 218, 13, 'PPL', 'P'),
(88246, 'Kendrick Creek (historical)', 36.4791717529297, 0.636681655489134, -82.504997253418, -1.43998385142102, 218, 50, 'PPL', 'P'),
(172172, 'Kendricks Corner', 43.3455581665039, 0.75652270612021, -72.5216674804688, -1.26574187657068, 218, 55, 'PPL', 'P'),
(55652, 'Kendricktown', 37.1947212219238, 0.649170349683979, -94.3097229003906, -1.64601518125531, 218, 29, 'PPL', 'P'),
(127852, 'Kenduskeag', 44.9194412231445, 0.783992147499941, -68.9322204589844, -1.20309420771987, 218, 26, 'PPL', 'P'),
(95282, 'Kenedy', 28.8188896179199, 0.502984510601513, -97.8483276367188, -1.7077754848309, 218, 51, 'PPL', 'P'),
(76268, 'Kenefic', 34.1480598449707, 0.595996077462803, -96.3619384765625, -1.68183310002022, 218, 42, 'PPL', 'P'),
(95284, 'Kenefick', 30.1088905334473, 0.525499273931207, -94.8580627441406, -1.65558551694862, 218, 51, 'PPL', 'P'),
(202270, 'Kenel', 45.8583297729492, 0.800378844003308, -100.459442138672, -1.75334803003656, 218, 49, 'PPL', 'P'),
(142158, 'Kenesaw', 40.6211090087891, 0.708972098014899, -98.6572189331055, -1.72189330124358, 218, 35, 'PPL', 'P'),
(116295, 'Kenfield', 41.5763893127441, 0.725644884598368, -94.7194366455078, -1.65316603509828, 218, 16, 'PPL', 'P'),
(76269, 'Kengle', 36.1363906860352, 0.630698997258326, -96.0511093139648, -1.67640810772168, 218, 42, 'PPL', 'P'),
(163285, 'Kenhorst', 40.3105583190918, 0.703551965985343, -75.9397201538086, -1.32539814972705, 218, 45, 'PPL', 'P'),
(13136, 'Kenilworth', 38.9058303833008, 0.679034838411046, -76.940559387207, -1.34286608963299, 218, 9, 'PPL', 'P'),
(41582, 'Kenilworth', 29.8666706085205, 0.521271738727301, -89.8186111450195, -1.56763049404906, 218, 22, 'PPL', 'P'),
(48606, 'Kenilworth', 38.3805618286133, 0.669867172674557, -75.5124969482422, -1.317941698149, 218, 25, 'PPL', 'P'),
(66060, 'Kenilworth', 35.5758285522461, 0.620915342361702, -82.5388870239258, -1.44057533949913, 218, 33, 'PPL', 'P'),
(120195, 'Kenilworth', 42.0858306884766, 0.734536313950788, -87.7174987792969, -1.53095916531284, 218, 18, 'PPL', 'P'),
(145528, 'Kenilworth', 40.6763916015625, 0.709936961277835, -74.2911071777344, -1.29662442520346, 218, 37, 'PPL', 'P'),
(149983, 'Kenilworth', 42.9613914489746, 0.749817732022744, -78.8383331298828, -1.37598848990058, 218, 40, 'PPL', 'P'),
(155966, 'Kenilworth', 41.4622192382813, 0.723652240891743, -80.7375030517578, -1.40913525809214, 218, 41, 'PPL', 'P'),
(163287, 'Kenilworth', 40.2313919067383, 0.702170251432782, -75.6344375610352, -1.32006996333413, 218, 45, 'PPL', 'P'),
(192654, 'Kenilworth', 39.6883316040039, 0.69269206111319, -110.805000305176, -1.93391208299864, 218, 52, 'PPL', 'P'),
(196811, 'Kenilworth', 48.1755599975586, 0.840822140949469, -110.439720153809, -1.9275367416651, 218, 31, 'PPL', 'P'),
(207774, 'Kenilworth', 47.6324996948242, 0.831343950629877, -122.105560302734, -2.1311440622752, 218, 56, 'PPL', 'P'),
(48607, 'Kenilworth Park', 39.3541717529297, 0.686859871483971, -76.5983276367188, -1.33689301878211, 218, 25, 'PPL', 'P'),
(149984, 'Kenka Mills', 42.6605606079102, 0.744567243354626, -77.0372161865234, -1.3445530690255, 218, 40, 'PPL', 'P'),
(66054, 'Kenly', 35.5961112976074, 0.621269343049601, -78.1244430541992, -1.36352875758259, 218, 33, 'PPL', 'P'),
(163288, 'Kenmar', 41.2533302307129, 0.720006439938452, -76.959716796875, -1.34320044950785, 218, 45, 'PPL', 'P'),
(109931, 'Kenmar Trailer Park', 38.4397201538086, 0.670899680229181, -81.9444427490234, -1.43020032968245, 218, 58, 'PPL', 'P'),
(198472, 'Kenmare', 48.6747207641602, 0.849534139823445, -102.082221984863, -1.78167088138761, 218, 34, 'PPL', 'P'),
(88247, 'Kenmark Hills', 35.7077789306641, 0.623218310914348, -84.0177764892578, -1.46638682994223, 218, 50, 'PPL', 'P'),
(163289, 'Kenmawr', 40.4822196960449, 0.706548022211682, -80.1144409179688, -1.39826077241302, 218, 45, 'PPL', 'P'),
(66055, 'Kenmon Acres', 35.3088912963867, 0.616256408350717, -81.5013885498047, -1.4224675751413, 218, 33, 'PPL', 'P'),
(66056, 'Kenmon Apartments', 35.2897186279297, 0.615921782159749, -81.5605621337891, -1.42350034901203, 218, 33, 'PPL', 'P'),
(55653, 'Kenmoor', 39.6508293151855, 0.692037522696276, -94.9394378662109, -1.65700578075796, 218, 29, 'PPL', 'P'),
(41584, 'Kenmore', 30.5094394683838, 0.532490171661205, -91.540283203125, -1.59767934010259, 218, 22, 'PPL', 'P'),
(48608, 'Kenmore', 39.6925010681152, 0.692764831989977, -75.8675003051758, -1.32413767558312, 218, 25, 'PPL', 'P'),
(103280, 'Kenmore', 38.9544410705566, 0.679883254955318, -77.2694396972656, -1.3486061338885, 218, 53, 'PPL', 'P'),
(149985, 'Kenmore', 42.9658317565918, 0.749895230010466, -78.8702774047852, -1.37654602267479, 218, 40, 'PPL', 'P'),
(155967, 'Kenmore', 41.0447196960449, 0.71636549925415, -81.5608291625977, -1.42350500954394, 218, 41, 'PPL', 'P'),
(207775, 'Kenmore', 47.7574996948242, 0.83352561219487, -122.242782592773, -2.13353904304351, 218, 56, 'PPL', 'P'),
(14037, 'Kenmore Park', 38.6583290100098, 0.67471512454391, -75.5777816772461, -1.31908113162139, 218, 10, 'PPL', 'P'),
(109932, 'Kenna', 38.6763916015625, 0.675030376237948, -81.6602783203125, -1.4252407247844, 218, 58, 'PPL', 'P'),
(188761, 'Kenna', 33.8422203063965, 0.590658170531903, -103.771392822266, -1.81115247412895, 218, 38, 'PPL', 'P'),
(109933, 'Kenna Homes', 38.3563919067383, 0.669445327957889, -81.7188873291016, -1.4262636449591, 218, 58, 'PPL', 'P'),
(76270, 'Kennady', 35.0144386291504, 0.611117239816164, -94.7608337402344, -1.65388855070202, 218, 42, 'PPL', 'P'),
(174746, 'Kennan', 45.5313911437988, 0.794672688472676, -90.5869369506836, -1.58104030908594, 218, 57, 'PPL', 'P'),
(30237, 'Kennard', 39.9038887023926, 0.696454242206118, -85.5194396972656, -1.49259579717803, 218, 19, 'PPL', 'P'),
(95285, 'Kennard', 31.3594398498535, 0.54732547696106, -95.1830596923828, -1.66125778375438, 218, 51, 'PPL', 'P'),
(103283, 'Kennard', 37.9155616760254, 0.661751388989623, -76.7480621337891, -1.3395063787598, 218, 53, 'PPL', 'P'),
(142160, 'Kennard', 41.4730606079102, 0.723841458487193, -96.2030563354492, -1.67906008353518, 218, 35, 'PPL', 'P'),
(155968, 'Kennard', 40.1930618286133, 0.701501265366955, -83.6797180175781, -1.46048659654716, 218, 41, 'PPL', 'P'),
(163290, 'Kennard', 41.4650001525879, 0.72370077700261, -80.336669921875, -1.40213940022461, 218, 45, 'PPL', 'P'),
(127855, 'Kennard Corner', 43.1266708374023, 0.752702401536491, -70.7969436645508, -1.23563976729535, 218, 26, 'PPL', 'P'),
(207776, 'Kennard Corner', 47.8202781677246, 0.834621303246356, -122.206390380859, -2.13290387912352, 218, 56, 'PPL', 'P'),
(103282, 'Kennard Ridge', 38.8044395446777, 0.677265234445716, -77.6474990844727, -1.35520451496333, 218, 53, 'PPL', 'P'),
(127854, 'Kennebago', 45.1074981689453, 0.787274360385409, -70.7719421386719, -1.23520340835074, 218, 26, 'PPL', 'P'),
(127856, 'Kennebago Settlement', 45.1002807617188, 0.787148392865848, -70.5627822875977, -1.23155288028652, 218, 26, 'PPL', 'P'),
(36691, 'Kennebec', 38.2069396972656, 0.666836894828211, -84.9130630493164, -1.48201252816411, 218, 21, 'PPL', 'P'),
(66059, 'Kennebec', 35.5400009155273, 0.620290032137751, -78.7474975585938, -1.37440311010366, 218, 33, 'PPL', 'P'),
(116296, 'Kennebec', 42.0974998474121, 0.734739979195152, -96.0124969482422, -1.67573419480783, 218, 16, 'PPL', 'P'),
(127857, 'Kennebec', 44.6683311462402, 0.779609449873025, -67.4644393920898, -1.17747659540413, 218, 26, 'PPL', 'P'),
(170647, 'Kennebec', 43.9036102294922, 0.766262552016902, -99.8613891601563, -1.7429100364601, 218, 49, 'PPL', 'P'),
(127859, 'Kennebunk', 43.3838882446289, 0.757191692186038, -70.545280456543, -1.23124741570948, 218, 26, 'PPL', 'P'),
(127860, 'Kennebunk Beach', 43.3450012207031, 0.756512985582231, -70.5027770996094, -1.23050559218784, 218, 26, 'PPL', 'P'),
(127861, 'Kennebunk Landing', 43.3777809143066, 0.757085099163407, -70.5091705322266, -1.23061717863752, 218, 26, 'PPL', 'P'),
(127863, 'Kennebunkport', 43.3616714477539, 0.756803935931322, -70.4772186279297, -1.23005951270525, 218, 26, 'PPL', 'P'),
(95286, 'Kennedale', 32.646671295166, 0.569791903916969, -97.2255630493164, -1.69690619231591, 218, 51, 'PPL', 'P'),
(3499, 'Kennedy', 33.5869407653809, 0.5862027020282, -87.9844436645508, -1.53561823248188, 218, 2, 'PPL', 'P'),
(22343, 'Kennedy', 33.7997207641602, 0.589916413589289, -84.600830078125, -1.47656303478353, 218, 13, 'PPL', 'P'),
(30238, 'Kennedy', 38.0813903808594, 0.664645645883293, -86.9225006103516, -1.51708382971742, 218, 19, 'PPL', 'P'),
(36692, 'Kennedy', 36.6483306884766, 0.639634035873596, -87.4150009155273, -1.52567958160981, 218, 21, 'PPL', 'P'),
(55654, 'Kennedy', 36.2644386291504, 0.632933855466093, -89.5899963378906, -1.56364041294585, 218, 29, 'PPL', 'P'),
(113384, 'Kennedy', 45.9102783203125, 0.801285517196425, -90.6572189331055, -1.58226696108403, 218, 57, 'PPL', 'P'),
(116298, 'Kennedy', 41.6066703796387, 0.726173388916694, -94.1247177124023, -1.64278623159165, 218, 16, 'PPL', 'P'),
(120196, 'Kennedy', 42.2425003051758, 0.737270714600027, -87.8713912963867, -1.53364509643024, 218, 18, 'PPL', 'P'),
(136200, 'Kennedy', 48.6419410705566, 0.848962026242269, -96.9086074829102, -1.6913742740996, 218, 28, 'PPL', 'P'),
(149986, 'Kennedy', 42.1572189331055, 0.735782273866782, -79.1022186279297, -1.38059416068976, 218, 40, 'PPL', 'P'),
(163291, 'Kennedy', 41.6800003051758, 0.727453237557559, -77.4286117553711, -1.35138421037961, 218, 45, 'PPL', 'P'),
(182441, 'Kennedy', 37.9300003051758, 0.662003390607771, -121.251670837402, -2.11624087965706, 218, 6, 'PPL', 'P'),
(188762, 'Kennedy', 35.4041709899902, 0.61791935271439, -105.985557556152, -1.84979693891681, 218, 38, 'PPL', 'P'),
(199442, 'Kennedy', 42.5472183227539, 0.742589047296915, -100.816390991211, -1.75957796277458, 218, 35, 'PPL', 'P'),
(22344, 'Kennedy (historical)', 30.9174995422363, 0.539612163495864, -83.5199966430664, -1.45769893267612, 218, 13, 'PPL', 'P'),
(200032, 'Kennedy (historical)', 40.2758293151855, 0.702945830521241, -117.737503051758, -2.05490708133005, 218, 39, 'PPL', 'P'),
(127868, 'Kennedy Corner', 44.1938896179199, 0.771328883095641, -69.4252777099609, -1.21169968015025, 218, 26, 'PPL', 'P'),
(149987, 'Kennedy Corner', 42.4474983215332, 0.740848604945521, -76.5716705322266, -1.33642776453967, 218, 40, 'PPL', 'P'),
(172173, 'Kennedy Corners', 44.0152816772461, 0.768211586460676, -72.4305572509766, -1.26415170308379, 218, 55, 'PPL', 'P'),
(81844, 'Kennedy Crossroads', 34.0791702270508, 0.59479372680966, -79.5858306884766, -1.38903478344866, 218, 48, 'PPL', 'P'),
(66061, 'Kennedy Estates', 35.4577789306641, 0.618854987784362, -77.4208297729492, -1.35124838916402, 218, 33, 'PPL', 'P'),
(41586, 'Kennedy Heights', 29.9152793884277, 0.52212012198206, -90.2213897705078, -1.57466030722049, 218, 22, 'PPL', 'P'),
(73088, 'Kennedy Heights', 39.1855583190918, 0.683917011900407, -84.408332824707, -1.47320332391034, 218, 41, 'PPL', 'P'),
(16705, 'Kennedy Hill', 28.0016708374023, 0.488721352172349, -82.3024978637695, -1.43644957033838, 218, 12, 'PPL', 'P'),
(136202, 'Kennedy Landing', 47.3794403076172, 0.826927231120035, -91.1505584716797, -1.59087736036242, 218, 28, 'PPL', 'P'),
(182442, 'Kennedy Meadow', 38.3116683959961, 0.668664755442387, -119.744720458984, -2.08993963388949, 218, 6, 'PPL', 'P'),
(81845, 'Kennedy Mill', 34.8536109924316, 0.608310268027221, -81.7680587768555, -1.42712184862038, 218, 48, 'PPL', 'P'),
(163292, 'Kennedy Mill', 40.9927787780762, 0.715458959219087, -80.184440612793, -1.3994824975631, 218, 45, 'PPL', 'P'),
(145525, 'Kennedy Mills', 40.660831451416, 0.709665385425674, -75.1136093139648, -1.31097979558537, 218, 37, 'PPL', 'P'),
(16711, 'Kennedy Still', 30.5444393157959, 0.533101034236242, -82.8874969482422, -1.44665973048358, 218, 12, 'PPL', 'P'),
(127865, 'Kennedy Terrace', 47.1877784729004, 0.823582101053814, -67.9611129760742, -1.18614518475234, 218, 26, 'PPL', 'P'),
(145526, 'Kennedys', 40.6480598449707, 0.709442478842435, -75.1277770996094, -1.31122707009258, 218, 37, 'PPL', 'P'),
(48643, 'Kennedyville', 39.3052787780762, 0.686006528091683, -75.9952774047852, -1.32636780667995, 218, 25, 'PPL', 'P'),
(202272, 'Kennedyville', 43.9230613708496, 0.76660203847686, -103.523612976074, -1.80682789999282, 218, 49, 'PPL', 'P'),
(32912, 'Kennekuk', 39.6444396972656, 0.691926002825629, -95.4986114501953, -1.66676520088867, 218, 20, 'PPL', 'P'),
(66063, 'Kennel Beach', 35.024169921875, 0.611287082914684, -76.9002838134766, -1.34216314826327, 218, 33, 'PPL', 'P'),
(78551, 'Kennells Mill', 39.7713890075684, 0.694141686273548, -78.7988891601563, -1.3753000627588, 218, 45, 'PPL', 'P'),
(22357, 'Kennelworth', 33.5008316040039, 0.584699813646041, -82.0411071777344, -1.43188744223302, 218, 13, 'PPL', 'P'),
(103284, 'Kennelworth', 37.2155609130859, 0.649534070909857, -77.4366683959961, -1.35152482528517, 218, 53, 'PPL', 'P'),
(95288, 'Kennemer Crossing', 33.4541702270508, 0.583885418984695, -95.5313873291016, -1.66733724789081, 218, 51, 'PPL', 'P'),
(27616, 'Kenner', 38.6458282470703, 0.674496945071606, -88.5680618286133, -1.54580429101921, 218, 18, 'PPL', 'P'),
(41585, 'Kenner', 29.9938907623291, 0.523492149286155, -90.2416687011719, -1.57501424132936, 218, 22, 'PPL', 'P'),
(163294, 'Kennerdell', 41.2663917541504, 0.720234406527763, -79.8408279418945, -1.39348532510435, 218, 45, 'PPL', 'P'),
(48609, 'Kennersley', 39.146671295166, 0.6832383052966, -76.0347213745117, -1.32705623382174, 218, 25, 'PPL', 'P'),
(22345, 'Kennesaw', 34.0233306884766, 0.593819143008745, -84.6155624389648, -1.47682016298678, 218, 13, 'PPL', 'P'),
(22346, 'Kennesaw Acres', 34.0261116027832, 0.593867679119612, -84.6569366455078, -1.47754227911636, 218, 13, 'PPL', 'P'),
(32913, 'Kenneth', 38.8549995422363, 0.678147672872913, -94.6116714477539, -1.65128517757842, 218, 20, 'PPL', 'P'),
(122950, 'Kenneth', 40.7611083984375, 0.711415548315047, -86.4730606079102, -1.50923962188464, 218, 19, 'PPL', 'P'),
(131562, 'Kenneth', 46.0986099243164, 0.804572523771855, -84.9311065673828, -1.48232744696301, 218, 27, 'PPL', 'P'),
(136204, 'Kenneth', 43.7536087036133, 0.7636445315073, -96.0722198486328, -1.67677655605849, 218, 28, 'PPL', 'P'),
(163295, 'Kenneth', 40.0652809143066, 0.699271067691095, -79.8525009155273, -1.39368905692774, 218, 45, 'PPL', 'P'),
(16706, 'Kenneth City', 27.8152809143066, 0.48546823432179, -82.7202835083008, -1.44374130540301, 218, 12, 'PPL', 'P'),
(55655, 'Kennett', 36.2361106872559, 0.63243943960972, -90.0555572509766, -1.57176598374779, 218, 29, 'PPL', 'P'),
(193698, 'Kennett (historical)', 40.7416687011719, 0.711076261592171, -122.406387329102, -2.13639448436429, 218, 6, 'PPL', 'P'),
(78552, 'Kennett Square', 39.8466682434082, 0.695455556797338, -75.7119369506836, -1.32142258285178, 218, 45, 'PPL', 'P'),
(207777, 'Kennewick', 46.2113914489746, 0.80654093271256, -119.136108398438, -2.0793173495656, 218, 56, 'PPL', 'P'),
(95289, 'Kenney', 30.0475006103516, 0.524427817645641, -96.3266677856445, -1.68121751033425, 218, 51, 'PPL', 'P'),
(120197, 'Kenney', 40.0966682434082, 0.699818879927324, -89.0858306884766, -1.55484106238812, 218, 18, 'PPL', 'P'),
(9831, 'Kenney (historical)', 34.9775009155273, 0.610472555095283, -92.6138916015625, -1.61641734153239, 218, 4, 'PPL', 'P'),
(95290, 'Kenney Lane East Colonia', 27.878999710083, 0.486580337103493, -97.181999206543, -1.69614585982469, 218, 51, 'PPL', 'P'),
(95291, 'Kenney Lane West Colonia', 27.8899993896484, 0.486772317728574, -97.1989974975586, -1.69644253597013, 218, 51, 'PPL', 'P'),
(163296, 'Kenneys', 40.1652793884277, 0.701016370311478, -75.8513870239258, -1.32385644577201, 218, 45, 'PPL', 'P'),
(88249, 'Kenneytown', 36.2730598449707, 0.633084324067683, -82.85888671875, -1.44616038777919, 218, 50, 'PPL', 'P'),
(211922, 'Kennicott', 61.4863891601563, 1.07313993600728, -142.886383056641, -2.49383784060422, 218, 1, 'PPL', 'P'),
(109934, 'Kennison', 38.1074981689453, 0.665101312745806, -80.1861114501953, -1.39951165917703, 218, 58, 'PPL', 'P'),
(60477, 'Kennolia', 31.5944404602051, 0.551427011355891, -90.6750030517578, -1.58257735250908, 218, 30, 'PPL', 'P'),
(103285, 'Kennon', 37.3105583190918, 0.651192088425513, -76.9941711425781, -1.34380179128199, 218, 53, 'PPL', 'P'),
(155969, 'Kennon (historical)', 40.1513900756836, 0.700773956073254, -81.1061096191406, -1.41556865633745, 218, 41, 'PPL', 'P'),
(81847, 'Kennon Heights', 34.6780586242676, 0.605246301193084, -80.741943359375, -1.40921275607986, 218, 48, 'PPL', 'P'),
(103286, 'Kennons (historical)', 36.5605583190918, 0.638102119035555, -77.8530578613281, -1.35879219242583, 218, 53, 'PPL', 'P'),
(73089, 'Kennonsburg', 39.9150009155273, 0.696648186912503, -81.3758316040039, -1.42027619303833, 218, 41, 'PPL', 'P'),
(73090, 'Kennvale', 38.648609161377, 0.674545481182472, -83.1366729736328, -1.45100867254368, 218, 41, 'PPL', 'P'),
(16707, 'Kenny', 30.3558292388916, 0.529809167391823, -82.2427825927734, -1.43540734224578, 218, 12, 'PPL', 'P'),
(182443, 'Kenny', 39.9219398498535, 0.696769294163075, -123.897499084473, -2.16241929401071, 218, 6, 'PPL', 'P'),
(211923, 'Kenny Lake', 61.7191696166992, 1.07720272140825, -144.948333740234, -2.52982566904668, 218, 1, 'PPL', 'P'),
(207780, 'Kennydale', 47.5208282470703, 0.829394916186102, -122.205558776855, -2.13288936489558, 218, 56, 'PPL', 'P'),
(163297, 'Kennywood Park', 40.3877792358398, 0.704899725234005, -79.8649978637695, -1.39390716982102, 218, 45, 'PPL', 'P'),
(36693, 'Keno', 36.8938903808594, 0.643919861015861, -84.5747222900391, -1.47610736792102, 218, 21, 'PPL', 'P'),
(73091, 'Keno', 39.0980606079102, 0.682389888752328, -81.8633270263672, -1.42878459324697, 218, 41, 'PPL', 'P'),
(95292, 'Keno', 30.3902797698975, 0.530410442586935, -95.0605621337891, -1.65911979803127, 218, 51, 'PPL', 'P'),
(131554, 'Keno', 44.4722213745117, 0.776186688661028, -84.4105606079102, -1.47324220606226, 218, 27, 'PPL', 'P'),
(209894, 'Keno', 42.1266708374023, 0.735249109016548, -121.928886413574, -2.12806052120705, 218, 43, 'PPL', 'P'),
(60475, 'Keno (historical)', 31.2000007629395, 0.544542739938036, -89.7786102294922, -1.5669323463693, 218, 30, 'PPL', 'P'),
(193697, 'Keno (historical)', 40.7583312988281, 0.711367078783208, -122.714721679688, -2.14177593397901, 218, 6, 'PPL', 'P'),
(55656, 'Kenoma', 37.4394416809082, 0.653441527440248, -94.1972198486328, -1.6440516325836, 218, 29, 'PPL', 'P'),
(174749, 'Kenosha', 42.5847206115723, 0.743243585713829, -87.8211135864258, -1.53276758485106, 218, 57, 'PPL', 'P'),
(9845, 'Kenova', 33.3572196960449, 0.582193313007086, -92.6972198486328, -1.61787169380368, 218, 4, 'PPL', 'P'),
(109935, 'Kenova', 38.3988914489746, 0.670187084900503, -82.5783309936523, -1.44126376664091, 218, 58, 'PPL', 'P'),
(207778, 'Kenova', 47.2069396972656, 0.8239165275077, -117.551940917969, -2.0516684111284, 218, 56, 'PPL', 'P'),
(149988, 'Kenoza Lake', 41.7333297729492, 0.728384012358541, -74.9499969482422, -1.30812422110653, 218, 40, 'PPL', 'P'),
(73092, 'Kenricksville', 39.5511093139648, 0.690297080344882, -84.1655578613281, -1.46896610145797, 218, 41, 'PPL', 'P'),
(73093, 'Kenridge', 39.2502784729004, 0.685046591676764, -84.375, -1.47262155637022, 218, 41, 'PPL', 'P'),
(163298, 'Kenrock', 40.2330589294434, 0.702199346467692, -78.1708297729492, -1.36433835855398, 218, 45, 'PPL', 'P'),
(196812, 'Kens Trailer Court', 48.3466682434082, 0.843808543216857, -115.508888244629, -2.01601041518695, 218, 31, 'PPL', 'P'),
(140312, 'Kensal', 47.3008308410645, 0.825555237105453, -98.7330627441406, -1.7232170254634, 218, 34, 'PPL', 'P'),
(9833, 'Kensett', 35.2316703796387, 0.614908649102055, -91.6675033569336, -1.59989975066145, 218, 4, 'PPL', 'P'),
(116299, 'Kensett', 43.3536109924316, 0.756663254446739, -93.2102813720703, -1.62682630665296, 218, 16, 'PPL', 'P'),
(95293, 'Kensing', 33.4058303833008, 0.583041729551358, -95.4313888549805, -1.66559194527043, 218, 51, 'PPL', 'P'),
(22348, 'Kensington', 34.774169921875, 0.606923759784698, -85.3727798461914, -1.4900360998963, 218, 13, 'PPL', 'P'),
(32914, 'Kensington', 39.7669410705566, 0.694064055127772, -99.0313873291016, -1.72842377171062, 218, 20, 'PPL', 'P'),
(36700, 'Kensington', 38.9036102294922, 0.678996089417185, -84.6133270263672, -1.47678114767681, 218, 21, 'PPL', 'P'),
(48611, 'Kensington', 39.0255584716797, 0.681124487760377, -77.0766677856445, -1.34524162932534, 218, 25, 'PPL', 'P'),
(78555, 'Kensington', 39.9858283996582, 0.697884359711491, -75.1322174072266, -1.3113045680803, 218, 45, 'PPL', 'P'),
(81849, 'Kensington', 33.4038887023926, 0.583007840826487, -79.283332824707, -1.38375519974563, 218, 48, 'PPL', 'P'),
(88251, 'Kensington', 35.8847198486328, 0.626306512514404, -84.0561065673828, -1.46705581600806, 218, 50, 'PPL', 'P'),
(113600, 'Kensington', 41.6352806091309, 0.726672731621084, -72.769172668457, -1.27006165701684, 218, 8, 'PPL', 'P'),
(120199, 'Kensington', 41.6780586242676, 0.727419348832687, -87.6072235107422, -1.52903449879304, 218, 18, 'PPL', 'P'),
(136206, 'Kensington', 45.7780609130859, 0.798977888111871, -95.6958312988281, -1.67020733659759, 218, 28, 'PPL', 'P'),
(144023, 'Kensington', 42.9269409179688, 0.749216456827632, -70.9444427490234, -1.23821411196308, 218, 36, 'PPL', 'P'),
(149990, 'Kensington', 40.7933311462402, 0.711977941358245, -73.7225036621094, -1.28670042171739, 218, 40, 'PPL', 'P'),
(155970, 'Kensington', 40.735279083252, 0.710964741721524, -80.956672668457, -1.41296048952388, 218, 41, 'PPL', 'P'),
(178449, 'Kensington', 33.6166687011719, 0.586721552387575, -111.973609924316, -1.95430816852312, 218, 5, 'PPL', 'P'),
(182444, 'Kensington', 37.9105606079102, 0.661664103884895, -122.279167175293, -2.13417407380544, 218, 6, 'PPL', 'P'),
(48612, 'Kensington Estates', 39.0272216796875, 0.681153516216259, -77.0844421386719, -1.34537731738288, 218, 25, 'PPL', 'P'),
(48613, 'Kensington Heights', 39.0327796936035, 0.681250521858965, -77.0641708374023, -1.34502351643207, 218, 25, 'PPL', 'P'),
(78556, 'Kensington Heights', 39.9674987792969, 0.697564447485545, -77.6891708374023, -1.35593182425703, 218, 45, 'PPL', 'P'),
(48614, 'Kensington Knolls', 39.0433311462402, 0.681434679448344, -77.0736083984375, -1.34518823294549, 218, 25, 'PPL', 'P'),
(16708, 'Kensington Park', 27.3591709136963, 0.477507613059866, -82.4966735839844, -1.43983857598356, 218, 12, 'PPL', 'P'),
(22350, 'Kensington Park', 31.2208309173584, 0.544906294716346, -81.4749984741211, -1.42200698143077, 218, 13, 'PPL', 'P'),
(48615, 'Kensington View', 39.0397186279297, 0.681371629109536, -77.0599975585938, -1.34495067897625, 218, 25, 'PPL', 'P'),
(196813, 'Kenspur', 46.5936088562012, 0.8132118849271, -114.091110229492, -1.99126552076042, 218, 31, 'PPL', 'P'),
(3502, 'Kent', 31.9524993896484, 0.557676318590844, -86.1747207641602, -1.50403260932132, 218, 2, 'PPL', 'P'),
(9836, 'Kent', 33.625560760498, 0.586876748100099, -92.8130569458008, -1.61989343254522, 218, 4, 'PPL', 'P'),
(13137, 'Kent', 38.9336090087891, 0.679519666887495, -77.103889465332, -1.34571673726381, 218, 9, 'PPL', 'P'),
(16709, 'Kent', 30.521390914917, 0.532698763753586, -81.966667175293, -1.43058821909522, 218, 12, 'PPL', 'P'),
(30239, 'Kent', 38.7377815246582, 0.676101832523515, -85.5400009155273, -1.49295465813492, 218, 19, 'PPL', 'P'),
(41587, 'Kent', 31.2855606079102, 0.546036040940271, -92.4749984741211, -1.61399319915015, 218, 22, 'PPL', 'P'),
(76273, 'Kent', 34.1130599975586, 0.595385214887766, -95.6227798461914, -1.66893234822572, 218, 42, 'PPL', 'P'),
(81851, 'Kent', 33.4288902282715, 0.583444199771096, -79.4824981689453, -1.38723129075846, 218, 48, 'PPL', 'P'),
(103287, 'Kent', 36.9519386291504, 0.644932994073554, -81.0188903808594, -1.41404639345836, 218, 53, 'PPL', 'P'),
(109937, 'Kent', 39.7663917541504, 0.694054467747848, -80.8613891601563, -1.41129747858118, 218, 58, 'PPL', 'P'),
(113601, 'Kent', 41.7247200012207, 0.728233743494034, -73.4775009155273, -1.2824243171131, 218, 8, 'PPL', 'P'),
(116301, 'Kent', 40.9524993896484, 0.714755951270333, -94.4541702270508, -1.64853626270124, 218, 16, 'PPL', 'P'),
(120200, 'Kent', 42.3086090087891, 0.738424529142304, -89.9019393920898, -1.56908484632036, 218, 18, 'PPL', 'P'),
(136208, 'Kent', 46.4363899230957, 0.810467896897936, -96.684440612793, -1.68746182414216, 218, 28, 'PPL', 'P'),
(149991, 'Kent', 43.3277816772461, 0.756212447853215, -78.1355590820313, -1.363722768868, 218, 40, 'PPL', 'P'),
(155971, 'Kent', 41.1536102294922, 0.718265997587058, -81.3580627441406, -1.41996606792939, 218, 41, 'PPL', 'P'),
(191684, 'Kent', 31.0691699981689, 0.542259312329889, -104.216667175293, -1.81892397766396, 218, 51, 'PPL', 'P'),
(201061, 'Kent', 45.1952781677246, 0.788806410381504, -120.693061828613, -2.10649131322239, 218, 43, 'PPL', 'P'),
(207779, 'Kent', 47.3811111450195, 0.826956392733971, -122.233612060547, -2.13337898706199, 218, 56, 'PPL', 'P'),
(22351, 'Kent (historical)', 31.9513893127441, 0.557656944093913, -81.8561096191406, -1.42865862572741, 218, 13, 'PPL', 'P'),
(88252, 'Kent (historical)', 36.6430587768555, 0.639542023657934, -87.0088882446289, -1.51859157836856, 218, 50, 'PPL', 'P'),
(142164, 'Kent (historical)', 41.7555618286133, 0.728772034929366, -99.3083267211914, -1.73325727593105, 218, 35, 'PPL', 'P'),
(169442, 'Kent (historical)', 41.7561111450195, 0.72878162230929, -71.5833282470703, -1.24936476744724, 218, 47, 'PPL', 'P'),
(190366, 'Kent (historical)', 39.4833297729492, 0.689114104188669, -114.741668701172, -2.00261990806797, 218, 39, 'PPL', 'P'),
(14038, 'Kent Acres', 39.1316719055176, 0.682976516561445, -75.5252838134766, -1.31816487104834, 218, 10, 'PPL', 'P'),
(48616, 'Kent Acres', 39.2163887023926, 0.684455103598657, -76.1363906860352, -1.32883069805606, 218, 25, 'PPL', 'P'),
(131556, 'Kent City', 43.2200012207031, 0.754331324017238, -85.751106262207, -1.49663914150304, 218, 27, 'PPL', 'P'),
(149992, 'Kent Cliffs', 41.4550018310547, 0.723526273372182, -73.7544403076172, -1.28725782133354, 218, 40, 'PPL', 'P'),
(125167, 'Kent Corner', 42.7055587768555, 0.74535260956009, -70.9097213745117, -1.23760810965703, 218, 23, 'PPL', 'P'),
(169447, 'Kent Corner', 41.7719383239746, 0.729057858693359, -71.3516693115234, -1.24532155628028, 218, 47, 'PPL', 'P'),
(149993, 'Kent Corners', 41.4683303833008, 0.723758900493401, -73.6605606079102, -1.28561931147287, 218, 40, 'PPL', 'P'),
(48618, 'Kent Cove', 38.9736099243164, 0.680217814567259, -76.3138885498047, -1.33192862019409, 218, 25, 'PPL', 'P'),
(48619, 'Kent Estates', 39.7083282470703, 0.693041068374045, -77.769172668457, -1.35732811961656, 218, 25, 'PPL', 'P'),
(48620, 'Kent Fort Manor', 38.8569412231445, 0.678181561597785, -76.3580627441406, -1.33269960532967, 218, 25, 'PPL', 'P'),
(113602, 'Kent Furnace', 41.7374992370605, 0.728456783235328, -73.4697189331055, -1.28228849589751, 218, 8, 'PPL', 'P'),
(103288, 'Kent Gardens', 38.9116706848145, 0.679136770901769, -77.1730575561523, -1.34692394818595, 218, 53, 'PPL', 'P'),
(163299, 'Kent Gardens', 40.2916717529297, 0.703222333221418, -76.789436340332, -1.34022849488938, 218, 45, 'PPL', 'P'),
(169444, 'Kent Heights', 41.8027801513672, 0.729596150128691, -71.3641662597656, -1.24553966917356, 218, 47, 'PPL', 'P'),
(149994, 'Kent Hills', 41.4944381713867, 0.724214567355913, -73.6836090087891, -1.28602158195552, 218, 40, 'PPL', 'P'),
(48621, 'Kent Island Estates', 38.8916702270508, 0.678787697061887, -76.3505630493164, -1.33256871096209, 218, 25, 'PPL', 'P'),
(103289, 'Kent Junction', 36.9205589294434, 0.644385314995379, -82.7283325195313, -1.44388178715052, 218, 53, 'PPL', 'P'),
(16710, 'Kent Mill', 30.6694393157959, 0.535282695801235, -85.4274978637695, -1.4909911094632, 218, 12, 'PPL', 'P'),
(48622, 'Kent Narrows', 38.9686088562012, 0.680130529462532, -76.2388916015625, -1.33061967651832, 218, 25, 'PPL', 'P'),
(125168, 'Kent Park', 42.1083297729492, 0.73492899705352, -70.6902770996094, -1.23377808453533, 218, 23, 'PPL', 'P'),
(48623, 'Kent Point Farm', 38.8416709899902, 0.677915045751695, -76.3736114501953, -1.33297098144475, 218, 25, 'PPL', 'P'),
(48624, 'Kent Point Manor', 38.850830078125, 0.678074901996127, -76.3747177124023, -1.33299028936265, 218, 25, 'PPL', 'P'),
(48626, 'Kent Timbers', 38.8958282470703, 0.678860268201591, -76.3483276367188, -1.33252969565212, 218, 25, 'PPL', 'P'),
(48627, 'Kent Village', 38.9249992370605, 0.679369398022987, -76.8844375610352, -1.34188657898406, 218, 25, 'PPL', 'P'),
(182446, 'Kent Woodlands', 37.9494400024414, 0.662342677330647, -122.562217712402, -2.13911423762753, 218, 6, 'PPL', 'P'),
(36694, 'Kentenia', 36.7961082458496, 0.642213240810311, -83.4011077880859, -1.45562393071278, 218, 21, 'PPL', 'P'),
(48628, 'Kentfield', 39.3138885498047, 0.68615679695619, -76.1005630493164, -1.32820538783211, 218, 25, 'PPL', 'P'),
(182447, 'Kentfield', 37.952220916748, 0.662391213441514, -122.556106567383, -2.13900757802588, 218, 6, 'PPL', 'P'),
(48629, 'Kentland', 38.9236106872559, 0.679345163257068, -76.8802795410156, -1.34181400784436, 218, 25, 'PPL', 'P'),
(120202, 'Kentland', 41.5463905334473, 0.725121307128058, -88.4338912963867, -1.5434625734727, 218, 18, 'PPL', 'P'),
(122952, 'Kentland', 40.7702789306641, 0.711575604296561, -87.4452819824219, -1.52620808592814, 218, 19, 'PPL', 'P'),
(14051, 'Kentmere', 39.7666702270508, 0.694059328016837, -75.5616683959961, -1.31879990181027, 218, 10, 'PPL', 'P'),
(48631, 'Kentmore Park', 39.3663902282715, 0.687073124108259, -75.9677810668945, -1.32588790505152, 218, 25, 'PPL', 'P'),
(116302, 'Kentner', 42.1666717529297, 0.735947256696312, -94.8227767944336, -1.65496966094654, 218, 16, 'PPL', 'P'),
(14041, 'Kenton', 39.2275009155273, 0.684649048305042, -75.663330078125, -1.32057423288654, 218, 10, 'PPL', 'P'),
(36695, 'Kenton', 38.8683280944824, 0.678380299994132, -84.4561080932617, -1.47403715964765, 218, 21, 'PPL', 'P'),
(88256, 'Kenton', 36.202220916748, 0.631847951531613, -89.0122222900391, -1.55355635347827, 218, 50, 'PPL', 'P'),
(131558, 'Kenton', 46.4855613708496, 0.811326100559215, -88.8938903808594, -1.55149107205291, 218, 27, 'PPL', 'P'),
(155972, 'Kenton', 40.6469383239746, 0.709422904608423, -83.6097183227539, -1.45926487139709, 218, 41, 'PPL', 'P'),
(190993, 'Kenton', 36.9030609130859, 0.644079916997375, -102.962783813477, -1.79703958456429, 218, 42, 'PPL', 'P'),
(201062, 'Kenton', 45.5819396972656, 0.795554927162793, -122.680282592773, -2.14117485852098, 218, 43, 'PPL', 'P'),
(36697, 'Kenton Hills', 39.0838890075684, 0.682142547666087, -84.5316696166992, -1.47535595701945, 218, 21, 'PPL', 'P'),
(182448, 'Kenton Mill', 34.639720916748, 0.604577181969202, -116.354438781738, -2.03076805605151, 218, 6, 'PPL', 'P'),
(22352, 'Kenton Place', 33.3541717529297, 0.582140116364312, -84.5386123657227, -1.47547713084905, 218, 13, 'PPL', 'P'),
(36698, 'Kenton Vale', 39.0508308410645, 0.681565573815921, -84.519172668457, -1.47513784412618, 218, 21, 'PPL', 'P'),
(36699, 'Kentontown', 38.4927787780762, 0.671825727919229, -84.1194381713867, -1.4681611610185, 218, 21, 'PPL', 'P'),
(149996, 'Kents Corners', 44.4327812194824, 0.775498328098269, -75.2975006103516, -1.31418930417307, 218, 40, 'PPL', 'P'),
(172174, 'Kents Corners', 44.3686103820801, 0.774378335701837, -72.4855575561523, -1.26511163949871, 218, 55, 'PPL', 'P'),
(127866, 'Kents Hill', 44.4049987792969, 0.775013433042793, -70.0013885498047, -1.22175471116195, 218, 26, 'PPL', 'P'),
(103290, 'Kents Store', 37.8791694641113, 0.661116225069639, -78.1291732788086, -1.36361131557638, 218, 53, 'PPL', 'P'),
(41588, 'Kents Store (historical)', 30.8791694641113, 0.538943177430036, -90.9258270263672, -1.58695505670895, 218, 22, 'PPL', 'P'),
(3503, 'Kentuck', 33.5308303833008, 0.585223391116351, -85.8305587768555, -1.49802584948264, 218, 2, 'PPL', 'P'),
(103291, 'Kentuck', 36.6597213745117, 0.639832840848971, -79.2986068725586, -1.38402178217075, 218, 53, 'PPL', 'P'),
(109936, 'Kentuck', 38.6555595397949, 0.674666788170125, -81.5905609130859, -1.42402392648234, 218, 58, 'PPL', 'P'),
(9837, 'Kentucky', 34.6083297729492, 0.604029303153945, -92.6611099243164, -1.61724145673172, 218, 4, 'PPL', 'P'),
(27618, 'Kentucky', 39.5933303833008, 0.691033977018507, -87.6111068725586, -1.52910227624278, 218, 18, 'PPL', 'P'),
(131559, 'Kentucky', 46.2652816772461, 0.807481494630549, -86.6308288574219, -1.51199319729373, 218, 27, 'PPL', 'P'),
(103292, 'Kentucky Farms', 37.1455612182617, 0.648312345759783, -76.4936065673828, -1.33506529132599, 218, 53, 'PPL', 'P'),
(88253, 'Kentucky Heights', 36.2558288574219, 0.632783586601586, -83.2494430541992, -1.4529768817473, 218, 50, 'PPL', 'P'),
(95294, 'Kentucky Town', 33.521671295166, 0.585063534871919, -96.438606262207, -1.68317120530993, 218, 51, 'PPL', 'P'),
(41589, 'Kentwood', 30.938060760498, 0.539971024452752, -90.5088882446289, -1.57967810218837, 218, 22, 'PPL', 'P'),
(48632, 'Kentwood', 38.9252815246582, 0.679374324871004, -76.3402786254883, -1.33238921390462, 218, 25, 'PPL', 'P'),
(66070, 'Kentwood', 35.8672218322754, 0.626001114516399, -80.3047180175781, -1.40158173429235, 218, 33, 'PPL', 'P'),
(81852, 'Kentwood', 35.0449981689453, 0.61165060440348, -81.8794403076172, -1.42906582305808, 218, 48, 'PPL', 'P'),
(122957, 'Kentwood', 40.2769393920898, 0.702965205018171, -86.4897232055664, -1.50953043907568, 218, 19, 'PPL', 'P'),
(131560, 'Kentwood', 42.8694381713867, 0.748212844570835, -85.6447219848633, -1.49478238559104, 218, 27, 'PPL', 'P'),
(204534, 'Kentwood Condominium', 41.163330078125, 0.718435640948496, -112.046669006348, -1.95558329005305, 218, 52, 'PPL', 'P'),
(95299, 'Kentwood Manor', 29.5988903045654, 0.516598090751294, -98.461669921875, -1.71848032714859, 218, 51, 'PPL', 'P'),
(66066, 'Kentwood Park', 35.7780609130859, 0.624444962912438, -80.9583282470703, -1.41298938482171, 218, 33, 'PPL', 'P'),
(182449, 'Kentwood-In-The-Pines', 33.0716705322266, 0.577209539922139, -116.574722290039, -2.03461272855921, 218, 6, 'PPL', 'P'),
(81853, 'Kentyre', 34.4552803039551, 0.601358086001569, -79.3091735839844, -1.38420620607624, 218, 48, 'PPL', 'P'),
(145527, 'Kenvil', 40.8797187805176, 0.713485690009393, -74.6188888549805, -1.30234529469911, 218, 37, 'PPL', 'P'),
(36707, 'Kenvir', 36.8536109924316, 0.643216853067107, -83.1572189331055, -1.45136726718446, 218, 21, 'PPL', 'P'),
(149997, 'Kenwells (historical)', 43.6549987792969, 0.761923463652836, -74.6594390869141, -1.3030530297588, 218, 40, 'PPL', 'P'),
(103300, 'Kenwick Place', 37.2174987792969, 0.649567893055701, -80.0061111450195, -1.39637006119712, 218, 53, 'PPL', 'P'),
(163302, 'Kenwick Village', 40.0924987792969, 0.699746109050538, -76.3119430541992, -1.33189466489019, 218, 45, 'PPL', 'P'),
(9842, 'Kenwood', 35.1997184753418, 0.614350983169793, -92.8125, -1.61988371200724, 218, 4, 'PPL', 'P'),
(22353, 'Kenwood', 33.5113906860352, 0.584884104393475, -84.4361114501953, -1.47368815238679, 218, 13, 'PPL', 'P'),
(36702, 'Kenwood', 38.1644401550293, 0.666095137885596, -85.769172668457, -1.49695445977611, 218, 21, 'PPL', 'P'),
(48635, 'Kenwood', 38.9708290100098, 0.680169278456393, -77.1055603027344, -1.34574589887775, 218, 25, 'PPL', 'P'),
(76274, 'Kenwood', 36.3144416809082, 0.633806573355312, -94.9855575561523, -1.65781072119744, 218, 42, 'PPL', 'P'),
(88254, 'Kenwood', 36.5780601501465, 0.638407583612588, -87.3905563354492, -1.52525294320318, 218, 50, 'PPL', 'P'),
(95295, 'Kenwood', 32.7119407653809, 0.57093107107325, -96.9036102294922, -1.6912870555739, 218, 51, 'PPL', 'P'),
(103296, 'Kenwood', 37.2855606079102, 0.650755796059931, -79.9036102294922, -1.39458108273486, 218, 53, 'PPL', 'P'),
(116303, 'Kenwood', 42.0086097717285, 0.733188554702126, -95.5097198486328, -1.66695907901602, 218, 16, 'PPL', 'P'),
(120203, 'Kenwood', 40.1061096191406, 0.699983663019773, -88.2944412231445, -1.54102871055248, 218, 18, 'PPL', 'P'),
(125169, 'Kenwood', 42.6611099243164, 0.74457683073455, -71.2638931274414, -1.24378957286321, 218, 23, 'PPL', 'P'),
(139250, 'Kenwood', 40.1955604553223, 0.701544874629805, -92.2869415283203, -1.61071098626468, 218, 29, 'PPL', 'P'),
(149999, 'Kenwood', 43.0580596923828, 0.751504911152337, -75.6125030517578, -1.31968713392743, 218, 40, 'PPL', 'P'),
(155973, 'Kenwood', 40.250560760498, 0.702504811044724, -80.9108276367188, -1.41216034277436, 218, 41, 'PPL', 'P'),
(163301, 'Kenwood', 40.646671295166, 0.709418244076515, -78.945556640625, -1.37785989319858, 218, 45, 'PPL', 'P'),
(182450, 'Kenwood', 38.413890838623, 0.670448873635658, -122.544998168945, -2.13881369989852, 218, 6, 'PPL', 'P'),
(196814, 'Kenwood (historical)', 46.6069412231445, 0.813444578627345, -112.069442749023, -1.95598076684574, 218, 31, 'PPL', 'P'),
(81855, 'Kenwood Acres', 34.1763916015625, 0.596490559898204, -79.6833267211914, -1.39073641022717, 218, 48, 'PPL', 'P'),
(48636, 'Kenwood Beach', 38.4977798461914, 0.671913013023956, -76.5036087036133, -1.33523986153544, 218, 25, 'PPL', 'P'),
(66068, 'Kenwood Estates', 36.1480598449707, 0.63090266250269, -79.1361083984375, -1.38118564876787, 218, 33, 'PPL', 'P'),
(182451, 'Kenwood Estates', 39.1544418334961, 0.683373926775112, -121.067497253418, -2.11302644422134, 218, 6, 'PPL', 'P'),
(48637, 'Kenwood Farm Estates', 39.4541702270508, 0.688605174104355, -76.3694381713867, -1.33289814398894, 218, 25, 'PPL', 'P'),
(22356, 'Kenwood Forest', 33.5069389343262, 0.584806406668672, -84.4236068725586, -1.47346990633546, 218, 13, 'PPL', 'P'),
(73096, 'Kenwood Hills', 39.1672210693359, 0.683596966516406, -84.3822174072266, -1.47274752388978, 218, 41, 'PPL', 'P'),
(103297, 'Kenwood Hills', 37.3644409179688, 0.652132517185447, -79.2358322143555, -1.38292615769829, 218, 53, 'PPL', 'P'),
(73097, 'Kenwood Knolls', 39.2166709899902, 0.684460030446674, -84.3752822875977, -1.47262648321823, 218, 41, 'PPL', 'P'),
(48639, 'Kenwood Park', 38.9775009155273, 0.680285725175056, -77.1183319091797, -1.34596880546099, 218, 25, 'PPL', 'P'),
(9843, 'Kenyon', 35.7922210693359, 0.624692104261598, -91.2233276367188, -1.59214742188628, 218, 4, 'PPL', 'P'),
(103298, 'Kenyon', 36.7333297729492, 0.641117549758825, -76.6552810668945, -1.33788704365898, 218, 53, 'PPL', 'P'),
(136210, 'Kenyon', 44.2722206115723, 0.772696016841234, -92.9852828979492, -1.62289934246759, 218, 28, 'PPL', 'P'),
(169445, 'Kenyon', 41.4469413757324, 0.723385591887599, -71.626106262207, -1.25011138465884, 218, 47, 'PPL', 'P'),
(195180, 'Kenyon', 42.4155616760254, 0.740291205329367, -113.869438171387, -1.98739661348681, 218, 17, 'PPL', 'P'),
(95296, 'Kenyon Colonia Number 1', 26.3080005645752, 0.459161229468364, -98.1220016479492, -1.71255199740402, 218, 51, 'PPL', 'P'),
(95297, 'Kenyon Colonia Number 2', 26.3090000152588, 0.459178673173504, -98.1230010986328, -1.71256944110916, 218, 51, 'PPL', 'P'),
(194267, 'Kenyon Corner', 40.6394386291504, 0.709292010240845, -105.072219848633, -1.83385618873798, 218, 7, 'PPL', 'P'),
(113604, 'Kenyonville', 41.9294395446777, 0.731806773570538, -72.0830612182617, -1.2580867531753, 218, 8, 'PPL', 'P'),
(150002, 'Kenyonville', 43.3111114501953, 0.755921497504124, -78.2808303833008, -1.36625823138381, 218, 40, 'PPL', 'P'),
(188763, 'Kenzin', 32.1063919067383, 0.560362249708243, -107.015830993652, -1.86777860259703, 218, 38, 'PPL', 'P'),
(9844, 'Keo', 34.6027793884277, 0.603932430669294, -92.0088882446289, -1.60585804096828, 218, 4, 'PPL', 'P'),
(195181, 'Keogh', 42.223331451416, 0.736936154988086, -113.332778930664, -1.97803014277495, 218, 17, 'PPL', 'P'),
(210393, 'Keokea', 20.708610534668, 0.361433437343139, -156.358337402344, -2.7289678006151, 218, 15, 'PPL', 'P'),
(103299, 'Keokee', 36.8588905334473, 0.643308998440824, -82.904167175293, -1.44695068083267, 218, 53, 'PPL', 'P'),
(116304, 'Keokuk', 40.3972206115723, 0.705064508326453, -91.3847198486328, -1.59496424737126, 218, 16, 'PPL', 'P'),
(55661, 'Keokuk (historical)', 36.3424987792969, 0.634296262100751, -89.8219375610352, -1.56768855096083, 218, 29, 'PPL', 'P'),
(76275, 'Keokuk Falls', 35.4049987792969, 0.617933800363304, -96.6361083984375, -1.68661826786688, 218, 42, 'PPL', 'P'),
(210396, 'Keolu Hills', 21.3794403076172, 0.373141625601509, -157.731674194336, -2.75293704937414, 218, 15, 'PPL', 'P'),
(116308, 'Keomah Village', 41.288330078125, 0.720617302513489, -92.5363922119141, -1.61506472201474, 218, 16, 'PPL', 'P'),
(210397, 'Keomuku', 20.8386096954346, 0.363702350723346, -156.920837402344, -2.73878527765756, 218, 15, 'PPL', 'P'),
(210399, 'Keoneoio', 20.6030597686768, 0.359591228948591, -156.423324584961, -2.73010204092336, 218, 15, 'PPL', 'P'),
(116309, 'Keosauqua', 40.730281829834, 0.710877523195824, -91.9622192382813, -1.60504351314888, 218, 16, 'PPL', 'P'),
(55657, 'Keota', 39.7075004577637, 0.693026620725132, -92.5763931274414, -1.6157628696945, 218, 29, 'PPL', 'P'),
(76276, 'Keota', 35.2555618286133, 0.615325633549735, -94.92138671875, -1.656690728801, 218, 42, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(116310, 'Keota', 41.3638916015625, 0.721936099885296, -91.95361328125, -1.6048933108634, 218, 16, 'PPL', 'P'),
(188764, 'Keota', 36.9544410705566, 0.644976669915432, -104.475830078125, -1.82344722361741, 218, 38, 'PPL', 'P'),
(194268, 'Keota', 40.7027816772461, 0.710397554988364, -104.074722290039, -1.81644657205991, 218, 7, 'PPL', 'P'),
(127867, 'Keough', 45.5561103820801, 0.795104120569269, -70.5619430541992, -1.23153823290052, 218, 26, 'PPL', 'P'),
(182452, 'Keough Hot Springs', 37.2547187805176, 0.650217504624598, -118.376106262207, -2.06605280996619, 218, 6, 'PPL', 'P'),
(81857, 'Keowee', 34.6952781677246, 0.6055468389221, -82.8786087036133, -1.44650460135008, 218, 48, 'PPL', 'P'),
(81858, 'Keowee Haven', 34.7366714477539, 0.606269287946811, -82.9380569458008, -1.44754216891078, 218, 48, 'PPL', 'P'),
(81859, 'Keowee Plantation', 34.7061080932617, 0.605735856780468, -82.9780578613281, -1.44824031659054, 218, 48, 'PPL', 'P'),
(163303, 'Keown', 40.5858306884766, 0.708356375170873, -80.045280456543, -1.39705369464894, 218, 45, 'PPL', 'P'),
(163304, 'Keown Station', 40.5444412231445, 0.707633992725189, -80.0297164916992, -1.39678205221776, 218, 45, 'PPL', 'P'),
(174752, 'Keowns', 43.3686103820801, 0.756925043181893, -88.1361083984375, -1.53826528144736, 218, 57, 'PPL', 'P'),
(60478, 'Keownville', 34.541389465332, 0.602860974383728, -88.9119415283203, -1.55180612400987, 218, 30, 'PPL', 'P'),
(211924, 'Kepangalook', 60.8499984741211, 1.06203282320694, -161.616668701172, -2.82074299494032, 218, 1, 'PPL', 'P'),
(193699, 'Kephart', 41.589168548584, 0.725867924339662, -121.313056945801, -2.1173122693636, 218, 6, 'PPL', 'P'),
(36703, 'Kepler', 36.9747200012207, 0.645330604024303, -86.2005615234375, -1.50448361565192, 218, 21, 'PPL', 'P'),
(88255, 'Kepler', 36.4019393920898, 0.635333696503391, -82.8852767944336, -1.44662098148972, 218, 50, 'PPL', 'P'),
(196815, 'Keplerville (historical)', 47.3458290100098, 0.826340603310918, -106.599998474121, -1.86052095599434, 218, 31, 'PPL', 'P'),
(163305, 'Kepner', 40.6969413757324, 0.710295622497641, -75.920280456543, -1.32505886300418, 218, 45, 'PPL', 'P'),
(163308, 'Kepple Hill', 40.6113891601563, 0.708802454653461, -79.5686111450195, -1.38873424571965, 218, 45, 'PPL', 'P'),
(163306, 'Kepples', 40.7166709899902, 0.710639969226589, -79.6999969482422, -1.39102736057626, 218, 45, 'PPL', 'P'),
(163307, 'Kepples Corners', 40.9650001525879, 0.714974130742638, -79.7072219848633, -1.39115346125387, 218, 45, 'PPL', 'P'),
(27619, 'Keptown', 39.0788917541504, 0.682055329140387, -88.6697235107422, -1.54757862209548, 218, 18, 'PPL', 'P'),
(210408, 'Kepuhi', 21.1911106109619, 0.369854652315593, -157.250274658203, -2.74453504245105, 218, 15, 'PPL', 'P'),
(131563, 'Kerby', 42.999439239502, 0.750481791240556, -84.0691680908203, -1.46728378259737, 218, 27, 'PPL', 'P'),
(201063, 'Kerby', 42.1944389343262, 0.736431885435679, -123.65055847168, -2.15810936726058, 218, 43, 'PPL', 'P'),
(182453, 'Kerby (historical)', 39.8244400024414, 0.695067600805541, -120.420829772949, -2.10173996752158, 218, 6, 'PPL', 'P'),
(48640, 'Kerby Hill', 38.7802810668945, 0.676843589466129, -77.0025024414063, -1.34394719987751, 218, 25, 'PPL', 'P'),
(36704, 'Kerby Knob', 37.521671295166, 0.654876704951692, -84.1133270263672, -1.46805450141684, 218, 21, 'PPL', 'P'),
(30240, 'Kercheval', 38.0894393920898, 0.664786127630795, -87.0138931274414, -1.51867893005232, 218, 19, 'PPL', 'P'),
(95298, 'Kerens', 32.1330604553223, 0.560827703687762, -96.2275009155273, -1.67948672194181, 218, 51, 'PPL', 'P'),
(109939, 'Kerens', 39.0125007629395, 0.680896587750093, -79.8138885498047, -1.39301514401389, 218, 58, 'PPL', 'P'),
(182454, 'Kerens', 34.9663887023926, 0.610278610388898, -115.80583190918, -2.0211930598263, 218, 6, 'PPL', 'P'),
(103305, 'Kerfoot', 38.9602813720703, 0.679985187446041, -77.9024963378906, -1.35965505661902, 218, 53, 'PPL', 'P'),
(150000, 'Kerhonkson', 41.7747192382813, 0.729106394804225, -74.2986068725586, -1.29675531957103, 218, 40, 'PPL', 'P'),
(16712, 'Keri', 26.5972194671631, 0.464209051577528, -81.379997253418, -1.42034889733609, 218, 12, 'PPL', 'P'),
(136213, 'Kerkhoven', 45.1930618286133, 0.788767727966671, -95.3202819824219, -1.66365276452269, 218, 28, 'PPL', 'P'),
(150001, 'Kerleys Corners', 42.042781829834, 0.733784969628249, -73.8483276367188, -1.28889646435227, 218, 40, 'PPL', 'P'),
(9846, 'Kerlin', 33.1836090087891, 0.579163234897821, -93.2252807617188, -1.62708809538812, 218, 4, 'PPL', 'P'),
(182455, 'Kerman', 36.7236099243164, 0.640947906397387, -120.058891296387, -2.09542294941591, 218, 6, 'PPL', 'P'),
(103301, 'Kermit', 36.6252784729004, 0.639231698811913, -82.7205581665039, -1.44374609909298, 218, 53, 'PPL', 'P'),
(109940, 'Kermit', 37.8436088562012, 0.660495575377596, -82.4094390869141, -1.43831604678836, 218, 58, 'PPL', 'P'),
(188765, 'Kermit', 34.0011100769043, 0.593431320175002, -103.592216491699, -1.80802525721892, 218, 38, 'PPL', 'P'),
(191686, 'Kermit', 31.8575000762939, 0.556018267785674, -103.092216491699, -1.79929861095895, 218, 51, 'PPL', 'P'),
(198475, 'Kermit', 48.9033317565918, 0.853524154347629, -103.045829772949, -1.79848900998756, 218, 34, 'PPL', 'P'),
(16713, 'Kern', 30.1297206878662, 0.525862828709516, -84.9888916015625, -1.48333598606782, 218, 12, 'PPL', 'P'),
(112414, 'Kern', 39.7755584716797, 0.694214457150334, -92.7008285522461, -1.61793467756346, 218, 29, 'PPL', 'P'),
(182457, 'Kern City', 35.353889465332, 0.617041774556182, -119.07250213623, -2.0782072108652, 218, 6, 'PPL', 'P'),
(182459, 'Kern Lake', 35.1399993896484, 0.613308688498163, -119.073890686035, -2.07823144563112, 218, 6, 'PPL', 'P'),
(103302, 'Kern Springs', 38.9272193908691, 0.679408147016848, -78.5950012207031, -1.37174154691023, 218, 53, 'PPL', 'P'),
(41590, 'Kernan', 30.5069408416748, 0.532446562398356, -93.2622222900391, -1.62773284668803, 218, 22, 'PPL', 'P'),
(120205, 'Kernan', 41.1427803039551, 0.71807697972869, -88.7397232055664, -1.54880034724555, 218, 18, 'PPL', 'P'),
(70996, 'Kernan Corner', 39.4533309936523, 0.688590526718359, -75.3333282470703, -1.31481461439703, 218, 37, 'PPL', 'P'),
(41591, 'Kerne (historical)', 30.561939239502, 0.533406465523761, -91.9722213745117, -1.60521808335833, 218, 22, 'PPL', 'P'),
(182462, 'Kernell', 35.7569389343262, 0.624076314838544, -119.343063354492, -2.08292939495208, 218, 6, 'PPL', 'P'),
(103303, 'Kerner', 37.2872200012207, 0.650784757936785, -80.045280456543, -1.39705369464894, 218, 53, 'PPL', 'P'),
(66073, 'Kernersville', 36.1197204589844, 0.630408046909235, -80.0738906860352, -1.39755303735333, 218, 33, 'PPL', 'P'),
(36705, 'Kernie', 37.7566719055176, 0.658978239346523, -83.1680603027344, -1.45155648477991, 218, 21, 'PPL', 'P'),
(103304, 'Kerns', 36.7572212219238, 0.641534534206504, -82.6180572509766, -1.44195712063072, 218, 53, 'PPL', 'P'),
(136216, 'Kerns', 44.211109161377, 0.771629420824657, -94.1097183227539, -1.64252444285649, 218, 28, 'PPL', 'P'),
(194269, 'Kerns', 40.5074996948242, 0.706989241425281, -104.943893432617, -1.83161647026122, 218, 7, 'PPL', 'P'),
(196816, 'Kerns', 45.711669921875, 0.797819146721578, -111.143890380859, -1.93982683062165, 218, 31, 'PPL', 'P'),
(103306, 'Kernstown', 39.1450004577637, 0.683209143682664, -78.1894378662109, -1.36466313104891, 218, 53, 'PPL', 'P'),
(163318, 'Kernsville', 40.6327781677246, 0.709175763259263, -75.5988922119141, -1.3194495799582, 218, 45, 'PPL', 'P'),
(163309, 'Kernville', 40.3194389343262, 0.703706961960785, -78.9191665649414, -1.37739929948805, 218, 45, 'PPL', 'P'),
(182460, 'Kernville', 35.7547187805176, 0.624037565844684, -118.424438476563, -2.06689636624147, 218, 6, 'PPL', 'P'),
(201064, 'Kernville', 44.8994407653809, 0.783643073660059, -124.003326416016, -2.16426632938473, 218, 43, 'PPL', 'P'),
(182461, 'Kernville (historical)', 35.714168548584, 0.623329830784995, -118.435829162598, -2.06709517121685, 218, 6, 'PPL', 'P'),
(186914, 'Kerper City', 38.2827796936035, 0.668160552469007, -106.141670227051, -1.85252161902807, 218, 7, 'PPL', 'P'),
(9847, 'Kerr', 34.7866706848145, 0.607141939257003, -92.0583267211914, -1.60672090516147, 218, 4, 'PPL', 'P'),
(55658, 'Kerr', 39.6783294677734, 0.692517490903736, -94.1311111450195, -1.64289781804132, 218, 29, 'PPL', 'P'),
(60479, 'Kerr', 33.1272201538086, 0.578179063716982, -89.2697219848633, -1.55805057097583, 218, 30, 'PPL', 'P'),
(66072, 'Kerr', 34.6561088562012, 0.604863205470277, -78.2822189331055, -1.36628246614973, 218, 33, 'PPL', 'P'),
(73099, 'Kerr', 39.7761116027832, 0.694224111109286, -81.1350021362305, -1.41607292588985, 218, 41, 'PPL', 'P'),
(136217, 'Kerr', 47.4236106872559, 0.827698149676586, -92.9797210693359, -1.62280227024585, 218, 28, 'PPL', 'P'),
(163311, 'Kerr', 41.0336112976074, 0.716171621126792, -78.4233322143555, -1.36874535752584, 218, 45, 'PPL', 'P'),
(196817, 'Kerr', 47.6797218322754, 0.832168132408229, -114.190559387207, -1.99300123600088, 218, 31, 'PPL', 'P'),
(16714, 'Kerr City', 29.3700008392334, 0.512603215958121, -81.783332824707, -1.42738843104549, 218, 12, 'PPL', 'P'),
(155974, 'Kerr Corner', 40.4191703796387, 0.705447604049261, -83.248893737793, -1.45296729436738, 218, 41, 'PPL', 'P'),
(131564, 'Kerr Hill', 42.896110534668, 0.748678365129381, -83.396110534668, -1.45553671218708, 218, 27, 'PPL', 'P'),
(120207, 'Kerrick', 40.5530586242676, 0.707784394747751, -88.9875030517578, -1.55312492138168, 218, 18, 'PPL', 'P'),
(136218, 'Kerrick', 46.3388900756836, 0.808766203540403, -92.585563659668, -1.61592292567602, 218, 28, 'PPL', 'P'),
(191687, 'Kerrick', 36.4955596923828, 0.636967678990209, -102.242218017578, -1.78446333894861, 218, 51, 'PPL', 'P'),
(48641, 'Kerrick Manor', 38.5411109924316, 0.672669284194511, -76.9194412231445, -1.34249750813813, 218, 25, 'PPL', 'P'),
(55659, 'Kerrigan (historical)', 37.0055618286133, 0.645868895459635, -90.6086120605469, -1.58141861111879, 218, 29, 'PPL', 'P'),
(103307, 'Kerrington', 38.5099983215332, 0.672126265648244, -78.008056640625, -1.36149743146113, 218, 53, 'PPL', 'P'),
(207782, 'Kerriston', 47.4550018310547, 0.828246028491842, -121.856391906738, -2.12679525337315, 218, 56, 'PPL', 'P'),
(163312, 'Kerrmoor', 40.8925018310547, 0.713708796329714, -78.5822219848633, -1.37151850716894, 218, 45, 'PPL', 'P'),
(163314, 'Kerrs Corners', 41.1716690063477, 0.718581182702069, -80.0524978637695, -1.39717966216851, 218, 45, 'PPL', 'P'),
(103308, 'Kerrs Creek', 37.853889465332, 0.66067500585604, -79.4955596923828, -1.38745925734777, 218, 53, 'PPL', 'P'),
(73100, 'Kerrs Run', 39.0299987792969, 0.681201985748098, -82.0044403076172, -1.43124748462307, 218, 41, 'PPL', 'P'),
(163315, 'Kerrsville', 40.1855583190918, 0.70137030442035, -77.320556640625, -1.34949829285367, 218, 45, 'PPL', 'P'),
(163316, 'Kerrtown', 41.6291694641113, 0.726566072019426, -80.1613922119141, -1.39908022708044, 218, 45, 'PPL', 'P'),
(55660, 'Kerrville', 39.3783302307129, 0.687281516463558, -94.6949996948242, -1.65273952984971, 218, 29, 'PPL', 'P'),
(88257, 'Kerrville', 35.3813896179199, 0.617521742763641, -89.85888671875, -1.56833343541879, 218, 50, 'PPL', 'P'),
(95301, 'Kerrville', 30.0472202301025, 0.524422924087138, -99.1399993896484, -1.73031940977453, 218, 51, 'PPL', 'P'),
(140318, 'Kerry', 48.4563903808594, 0.845723555777705, -97.8038864135742, -1.70699983916342, 218, 34, 'PPL', 'P'),
(201065, 'Kerry', 46.1211090087891, 0.804965206874588, -123.350563049316, -2.15287345939943, 218, 43, 'PPL', 'P'),
(150003, 'Kerry Siding', 42.0247192382813, 0.733469717934211, -75.2536087036133, -1.31342324588551, 218, 40, 'PPL', 'P'),
(103310, 'Kerrydale', 38.6650009155273, 0.674831571262574, -77.345832824707, -1.34993944548824, 218, 53, 'PPL', 'P'),
(150004, 'Kerryville', 42.0277786254883, 0.733523114314067, -75.2388916015625, -1.31316638399838, 218, 40, 'PPL', 'P'),
(122953, 'Kersey', 41.1941719055176, 0.718973932383828, -87.1563873291016, -1.52116592303629, 218, 19, 'PPL', 'P'),
(163317, 'Kersey', 41.3622207641602, 0.72190693827136, -78.5963897705078, -1.37176578167615, 218, 45, 'PPL', 'P'),
(194270, 'Kersey', 40.3875007629395, 0.704894864965015, -104.561111450195, -1.82493566435065, 218, 7, 'PPL', 'P'),
(14043, 'Kerseys Evergreen Acres', 38.5641708374023, 0.67307175441425, -75.2774963378906, -1.31384016375417, 218, 10, 'PPL', 'P'),
(3505, 'Kershaw', 33.7597198486328, 0.589218265909524, -87.1091690063477, -1.52034180783696, 218, 2, 'PPL', 'P'),
(66074, 'Kershaw', 35.047779083252, 0.611699140514346, -76.7369384765625, -1.33931223431634, 218, 33, 'PPL', 'P'),
(81863, 'Kershaw', 34.5516700744629, 0.603040404862172, -80.5838928222656, -1.40645425382276, 218, 48, 'PPL', 'P'),
(196818, 'Kershaw', 47.8133316040039, 0.83450006283773, -110.738609313965, -1.93275334160835, 218, 31, 'PPL', 'P'),
(190367, 'Kershaw (historical)', 37.5897216796875, 0.65606440821884, -114.519721984863, -1.9987462071044, 218, 39, 'PPL', 'P'),
(14044, 'Kershaw Acres', 39.8172187805176, 0.694941566706953, -75.5138931274414, -1.31796606607297, 218, 10, 'PPL', 'P'),
(190368, 'Kerwin Camp (historical)', 35.1805610656738, 0.614016623294933, -114.831390380859, -2.00418584678894, 218, 39, 'PPL', 'P'),
(36706, 'Kerz', 37.9166717529297, 0.661770763486553, -82.8397216796875, -1.44582589474627, 218, 21, 'PPL', 'P'),
(174753, 'Keshena', 44.8838882446289, 0.783371630965953, -88.6336135864258, -1.54694838502351, 218, 57, 'PPL', 'P'),
(174754, 'Keshena Falls', 44.8933296203613, 0.783536414058401, -88.6538925170898, -1.54730231913238, 218, 57, 'PPL', 'P'),
(88258, 'Kesler Hills', 34.9944381713867, 0.610768165976282, -85.10888671875, -1.48543029594906, 218, 50, 'PPL', 'P'),
(109942, 'Keslers Cross Lanes', 38.235279083252, 0.667331510421666, -80.9358291625977, -1.41259670171897, 218, 58, 'PPL', 'P'),
(103311, 'Keslers Mill', 37.3127784729004, 0.651230837419374, -80.0336074829102, -1.39684996282555, 218, 53, 'PPL', 'P'),
(116311, 'Kesley', 42.6624984741211, 0.74460106550047, -92.9100036621094, -1.6215854719438, 218, 16, 'PPL', 'P'),
(109943, 'Kesling Mill', 39.0052795410156, 0.680770553651505, -80.1425018310547, -1.39875052773749, 218, 58, 'PPL', 'P'),
(109944, 'Kessel', 39.0747184753418, 0.681982491684573, -79.0366668701172, -1.37945006668547, 218, 58, 'PPL', 'P'),
(48642, 'Kesselring', 39.586109161377, 0.690907942919919, -77.408332824707, -1.35103027627074, 218, 25, 'PPL', 'P'),
(36710, 'Kessinger', 37.3058280944824, 0.65110953043172, -85.9594421386719, -1.50027528849738, 218, 21, 'PPL', 'P'),
(131565, 'Kessington', 41.776668548584, 0.729140416687151, -85.8969421386719, -1.49918445771488, 218, 27, 'PPL', 'P'),
(41592, 'Kessler', 30.0358295440674, 0.524224119111763, -91.059440612793, -1.58928705371748, 218, 22, 'PPL', 'P'),
(73101, 'Kessler', 39.9777793884277, 0.697743877963989, -84.290283203125, -1.471142969333, 218, 41, 'PPL', 'P'),
(109945, 'Kessler', 37.9850006103516, 0.66296332702269, -80.6691665649414, -1.40794256139795, 218, 58, 'PPL', 'P'),
(163319, 'Kesslersville', 40.7869415283203, 0.711866421487597, -75.2433319091797, -1.3132438819861, 218, 45, 'PPL', 'P'),
(136222, 'Kesteloot''s Trailer Court', 44.5561103820801, 0.777650828049326, -95.9833297729492, -1.67522513156547, 218, 28, 'PPL', 'P'),
(182463, 'Kester', 34.1741714477539, 0.596451810904343, -118.423332214355, -2.06687705832357, 218, 6, 'PPL', 'P'),
(109947, 'Kester (historical)', 38.6161117553711, 0.673978294449313, -81.2980575561523, -1.41891877983071, 218, 58, 'PPL', 'P'),
(103313, 'Kesterson Mill', 36.6272201538086, 0.639265587536784, -83.4944381713867, -1.45725285319353, 218, 53, 'PPL', 'P'),
(103314, 'Keswick', 38.0224990844727, 0.663617798860577, -78.3594436645508, -1.36763029197742, 218, 53, 'PPL', 'P'),
(116312, 'Keswick', 41.4524993896484, 0.723482597530305, -92.2391662597656, -1.60987715052737, 218, 16, 'PPL', 'P'),
(131566, 'Keswick', 44.9288902282715, 0.784157063750444, -85.6536102294922, -1.49493751472453, 218, 27, 'PPL', 'P'),
(193700, 'Keswick', 40.622501373291, 0.708996399359846, -122.464721679688, -2.13741261084903, 218, 6, 'PPL', 'P'),
(70997, 'Keswick Grove', 39.9505615234375, 0.697268836604546, -74.3444366455078, -1.29755520000444, 218, 37, 'PPL', 'P'),
(88259, 'Ketchall (historical)', 35.0547218322754, 0.611820314343945, -85.7125015258789, -1.49596536174725, 218, 50, 'PPL', 'P'),
(163320, 'Ketcham', 41.3600006103516, 0.721868189277499, -75.9138870239258, -1.3249472765545, 218, 45, 'PPL', 'P'),
(88260, 'Ketchen', 36.5705604553223, 0.63827668924501, -84.3172225952148, -1.47161315042346, 218, 50, 'PPL', 'P'),
(193181, 'Ketchikan', 55.3422203063965, 0.965903959710684, -131.646102905273, -2.29765794311629, 218, 1, 'PPL', 'P'),
(76278, 'Ketchum', 36.5244407653809, 0.637471748805534, -95.0236129760742, -1.6584749135733, 218, 42, 'PPL', 'P'),
(127869, 'Ketchum', 44.5027809143066, 0.776720053248343, -70.9155578613281, -1.23770997556872, 218, 26, 'PPL', 'P'),
(195182, 'Ketchum', 43.6808280944824, 0.762374270246359, -114.362777709961, -1.9960070127652, 218, 17, 'PPL', 'P'),
(150005, 'Ketchums Corners', 43.0099983215332, 0.750666081987989, -73.6949996948242, -1.2862203869309, 218, 40, 'PPL', 'P'),
(150006, 'Ketchumville', 42.271110534668, 0.737770057304417, -76.0988922119141, -1.32817622621817, 218, 40, 'PPL', 'P'),
(81862, 'Ketchuptown', 34.1019401550293, 0.595191137023327, -79.1555633544922, -1.38152520180686, 218, 48, 'PPL', 'P'),
(116313, 'Keteban Switch (historical)', 40.6463890075684, 0.709413317228498, -91.6988906860352, -1.60044756289768, 218, 16, 'PPL', 'P'),
(163321, 'Ketner', 41.5391693115234, 0.72499527302947, -78.6305618286133, -1.37236219660228, 218, 45, 'PPL', 'P'),
(88261, 'Ketner Mill', 35.1380615234375, 0.613274866352319, -85.517219543457, -1.49255704818417, 218, 50, 'PPL', 'P'),
(3506, 'Ketona', 33.605281829834, 0.586522813991228, -86.7652816772461, -1.51433984168825, 218, 2, 'PPL', 'P'),
(103315, 'Ketron', 36.6427803039551, 0.639537163388945, -82.289436340332, -1.43622160374907, 218, 53, 'PPL', 'P'),
(207783, 'Ketron', 47.1544418334961, 0.823000266934659, -122.616943359375, -2.14006938035249, 218, 56, 'PPL', 'P'),
(103316, 'Ketron Corner', 36.6469383239746, 0.639609734528649, -81.7841720581055, -1.42740307843149, 218, 53, 'PPL', 'P'),
(103317, 'Ketrontown', 36.6019401550293, 0.638824368323185, -82.4866714477539, -1.4396640057741, 218, 53, 'PPL', 'P'),
(193702, 'Kett', 40.6072196960449, 0.708729683776675, -122.462783813477, -2.13737878870318, 218, 6, 'PPL', 'P'),
(193701, 'Kettenpom', 40.1575012207031, 0.700880615674912, -123.459716796875, -2.15477855168522, 218, 6, 'PPL', 'P'),
(48649, 'Kettering', 38.8844413757324, 0.678661529805244, -76.8150024414063, -1.34067470753002, 218, 25, 'PPL', 'P'),
(73102, 'Kettering', 39.6894416809082, 0.692711435610121, -84.1688919067383, -1.46902429152779, 218, 41, 'PPL', 'P'),
(55662, 'Ketterman', 37.9583282470703, 0.662497806464145, -94.2850036621094, -1.64558374915872, 218, 29, 'PPL', 'P'),
(109946, 'Ketterman', 38.878059387207, 0.678550143092652, -79.2544403076172, -1.38325093019323, 218, 58, 'PPL', 'P'),
(167, 'Kettle', 38.5747184753418, 0.673255845424601, -81.4899978637695, -1.42226877016592, 218, 58, 'PPL', 'P'),
(36708, 'Kettle', 36.702220916748, 0.640574597791585, -85.3611068725586, -1.48983236807291, 218, 21, 'PPL', 'P'),
(169446, 'Kettle Corner', 41.7075004577637, 0.727933205765018, -71.3988876342773, -1.2461456714796, 218, 47, 'PPL', 'P'),
(125170, 'Kettle Cove Village', 42.5800018310547, 0.743161227457119, -70.7300033569336, -1.23447143852513, 218, 23, 'PPL', 'P'),
(22358, 'Kettle Creek', 33.4697189331055, 0.584156795099774, -82.170280456543, -1.43414194125382, 218, 13, 'PPL', 'P'),
(136223, 'Kettle Falls', 48.5027809143066, 0.846533223328117, -92.6394424438477, -1.61686328785692, 218, 28, 'PPL', 'P'),
(207784, 'Kettle Falls', 48.6108283996582, 0.848419007696002, -118.054718017578, -2.06044352692021, 218, 56, 'PPL', 'P'),
(36709, 'Kettle Island', 36.7905616760254, 0.642116434904686, -83.6052780151367, -1.45918737340937, 218, 21, 'PPL', 'P'),
(88262, 'Kettle Mills', 35.6761093139648, 0.622665571830102, -87.2897186279297, -1.5234929931968, 218, 50, 'PPL', 'P'),
(136224, 'Kettle River', 46.4916687011719, 0.811432693581845, -92.8777770996094, -1.62102301232157, 218, 28, 'PPL', 'P'),
(182464, 'Kettleman', 38.1161117553711, 0.665251648189341, -121.242218017578, -2.11607589682753, 218, 6, 'PPL', 'P'),
(182465, 'Kettleman City', 36.0083312988281, 0.628463939313477, -119.960830688477, -2.09371146894137, 218, 6, 'PPL', 'P'),
(182466, 'Kettleman Station', 35.9988899230957, 0.628299156221028, -119.962783813477, -2.09374555740333, 218, 6, 'PPL', 'P'),
(155975, 'Kettlersville', 40.4388885498047, 0.705791751041127, -84.2613906860352, -1.4706386997806, 218, 41, 'PPL', 'P'),
(113605, 'Kettletown', 41.4647216796875, 0.72369591673362, -73.195556640625, -1.27750346120891, 218, 8, 'PPL', 'P'),
(16715, 'Keuka', 29.6044406890869, 0.516694963235946, -81.9127807617188, -1.42964772375626, 218, 12, 'PPL', 'P'),
(150007, 'Keuka', 42.4919395446777, 0.741624250613007, -77.1222229003906, -1.34603671606879, 218, 40, 'PPL', 'P'),
(150009, 'Keuka Park', 42.6152801513672, 0.743776950301145, -77.0924987792969, -1.34551793228844, 218, 40, 'PPL', 'P'),
(195183, 'Keuterville', 46.0341682434082, 0.803447804264488, -116.440559387207, -2.03227114417075, 218, 17, 'PPL', 'P'),
(182467, 'Kevet', 34.3622207641602, 0.599733890631757, -119.039436340332, -2.07763010385698, 218, 6, 'PPL', 'P'),
(36711, 'Kevil', 37.0849990844727, 0.647255337123131, -88.8866729736328, -1.55136510453335, 218, 21, 'PPL', 'P'),
(136227, 'Kevin', 47.3486099243164, 0.826389139421784, -93.1936111450195, -1.62653535630387, 218, 28, 'PPL', 'P'),
(196819, 'Kevin', 48.7452812194824, 0.850765652090525, -111.96443939209, -1.95414811254161, 218, 31, 'PPL', 'P'),
(131567, 'Kew', 45.1586112976074, 0.788166452771558, -87.6158294677734, -1.52918470107852, 218, 27, 'PPL', 'P'),
(150008, 'Kew Gardens', 40.714168548584, 0.710596293384711, -73.8313903808594, -1.28860085347127, 218, 40, 'PPL', 'P'),
(207785, 'Kewa', 48.2011108398438, 0.841268087274003, -118.277496337891, -2.06433174211173, 218, 56, 'PPL', 'P'),
(131568, 'Kewadin', 44.9286117553711, 0.784152203481455, -85.3730621337891, -1.49004102674431, 218, 27, 'PPL', 'P'),
(3507, 'Kewahatchie', 33.1199989318848, 0.578053029618394, -86.5436096191406, -1.51047093441464, 218, 2, 'PPL', 'P'),
(22359, 'Kewanee', 32.4933280944824, 0.567115560179493, -83.0902786254883, -1.45019893841424, 218, 13, 'PPL', 'P'),
(36712, 'Kewanee', 37.4436111450195, 0.653514298317035, -82.51611328125, -1.44017786270643, 218, 21, 'PPL', 'P'),
(55663, 'Kewanee', 36.6711082458496, 0.640031579245318, -89.5738906860352, -1.5633593162928, 218, 29, 'PPL', 'P'),
(60482, 'Kewanee', 32.4238891601563, 0.565903622146426, -88.4383316040039, -1.54354007146043, 218, 30, 'PPL', 'P'),
(120209, 'Kewanee', 41.2455596923828, 0.71987081845994, -89.9247207641602, -1.56948245627111, 218, 18, 'PPL', 'P'),
(22360, 'Kewanee Farms', 32.6733283996582, 0.570257158159405, -83.7350006103516, -1.4614514598101, 218, 13, 'PPL', 'P'),
(122954, 'Kewanna', 41.0186080932617, 0.71590976581261, -86.413330078125, -1.50819712747593, 218, 19, 'PPL', 'P'),
(174755, 'Kewaskum', 43.5208282470703, 0.759581746106329, -88.228889465332, -1.53988461654818, 218, 57, 'PPL', 'P'),
(174758, 'Kewaunee', 44.4583282470703, 0.775944207843776, -87.503059387207, -1.52721649187489, 218, 57, 'PPL', 'P'),
(131569, 'Keweenaw Bay', 46.860279083252, 0.817866158406177, -88.4816665649414, -1.54429640921001, 218, 27, 'PPL', 'P'),
(242, 'Key', 34.1025009155273, 0.595200924140333, -85.5344390869141, -1.49285758591318, 218, 2, 'PPL', 'P'),
(73104, 'Key', 39.9749984741211, 0.697695341853122, -80.8702774047852, -1.41145260771468, 218, 41, 'PPL', 'P'),
(191688, 'Key', 32.7280616760254, 0.571212434042417, -101.799171447754, -1.77673071756551, 218, 51, 'PPL', 'P'),
(9848, 'Key (historical)', 36.3027801513672, 0.633603041269003, -94.0180587768555, -1.64092468198968, 218, 4, 'PPL', 'P'),
(109948, 'Key (historical)', 38.7713890075684, 0.676688393753605, -79.3958282470703, -1.38571861525929, 218, 58, 'PPL', 'P'),
(16716, 'Key Biscayne', 25.6933307647705, 0.448433217649198, -80.1630630493164, -1.39910938869438, 218, 12, 'PPL', 'P'),
(16717, 'Key Colony Beach', 24.7205600738525, 0.431455166225779, -81.0188903808594, -1.41404639345836, 218, 12, 'PPL', 'P'),
(88263, 'Key Corner', 35.9313888549805, 0.627121040333805, -89.4905624389648, -1.5619049640215, 218, 50, 'PPL', 'P'),
(88264, 'Key Estates', 35.9347190856934, 0.627179163824595, -86.4875030517578, -1.50949169008182, 218, 50, 'PPL', 'P'),
(199444, 'Key Estates', 41.1258316040039, 0.717781169110609, -100.790557861328, -1.75912708960203, 218, 35, 'PPL', 'P'),
(48644, 'Key Heights', 39.589168548584, 0.690961339299775, -77.1433334350586, -1.3464051644056, 218, 25, 'PPL', 'P'),
(3508, 'Key Hill', 33.7166709899902, 0.588466921586986, -87.4208297729492, -1.52578131436345, 218, 2, 'PPL', 'P'),
(16718, 'Key Largo', 25.086109161377, 0.437835201380741, -80.4475021362305, -1.40407378728239, 218, 12, 'PPL', 'P'),
(16719, 'Key Largo Park', 25.1041698455811, 0.438150419785266, -80.4333267211914, -1.40382637961713, 218, 12, 'PPL', 'P'),
(16720, 'Key West', 24.5552806854248, 0.428570496712033, -81.7827835083008, -1.42737884366557, 218, 12, 'PPL', 'P'),
(103318, 'Key West', 38.0572204589844, 0.664223801166625, -78.4411087036133, -1.36905561579283, 218, 53, 'PPL', 'P'),
(116314, 'Key West', 42.4488906860352, 0.740872906290468, -90.6838912963867, -1.58273248164258, 218, 16, 'PPL', 'P'),
(136228, 'Key West', 47.9347190856934, 0.836618674063915, -96.7830581665039, -1.68918302515468, 218, 28, 'PPL', 'P'),
(202273, 'Keyapaha', 43.1094398498535, 0.752401664070394, -100.137496948242, -1.7477290264526, 218, 49, 'PPL', 'P'),
(182468, 'Keyes', 37.5566711425781, 0.655487567526729, -120.914436340332, -2.11035502733188, 218, 6, 'PPL', 'P'),
(190995, 'Keyes', 36.8097190856934, 0.642450794779546, -102.254997253418, -1.7846863786899, 218, 42, 'PPL', 'P'),
(127870, 'Keyes Corner', 44.2491683959961, 0.77229367977955, -69.6355590820313, -1.21536978244849, 218, 26, 'PPL', 'P'),
(109949, 'Keyes Ferry Acres', 39.2797203063965, 0.685560448609094, -77.7750015258789, -1.3574298523702, 218, 58, 'PPL', 'P'),
(144022, 'Keyes Hollow', 43.2502784729004, 0.754859761756537, -72.2280578613281, -1.26061742200115, 218, 36, 'PPL', 'P'),
(88265, 'Keyes Point', 35.7213897705078, 0.623455864883583, -89.9102783203125, -1.56923038807393, 218, 50, 'PPL', 'P'),
(55664, 'Keyes Summit', 38.5672187805176, 0.673124951057024, -90.4627838134766, -1.578873428065, 218, 29, 'PPL', 'P'),
(174761, 'Keyeser', 43.2966690063477, 0.755669429306948, -89.2558288574219, -1.55780809015858, 218, 57, 'PPL', 'P'),
(27620, 'Keyesport', 38.7419395446777, 0.676174403663219, -89.2736129760742, -1.55811848158363, 218, 18, 'PPL', 'P'),
(27621, 'Keyesport Landing', 38.7566719055176, 0.676431531866466, -89.2727813720703, -1.55810396735569, 218, 18, 'PPL', 'P'),
(174762, 'Keyesville', 43.3397216796875, 0.756420840208514, -90.2186126708984, -1.57461183768865, 218, 57, 'PPL', 'P'),
(182469, 'Keyesville', 35.6258316040039, 0.621788060250921, -118.51000213623, -2.06838973382274, 218, 6, 'PPL', 'P'),
(186915, 'Keyhole', 38.6930618286133, 0.67532132658704, -108.308326721191, -1.89033690861054, 218, 7, 'PPL', 'P'),
(22361, 'Keyland Woods', 33.4027786254883, 0.582988466329556, -84.438606262207, -1.47373169507062, 218, 13, 'PPL', 'P'),
(48645, 'Keymar', 39.5994415283203, 0.691140636620165, -77.2372207641602, -1.34804380742433, 218, 25, 'PPL', 'P'),
(3509, 'Keyno', 32.936939239502, 0.574858035258626, -86.1091690063477, -1.50288851531702, 218, 2, 'PPL', 'P'),
(145529, 'Keyport', 40.4330596923828, 0.705690018287486, -74.1999969482422, -1.29503425171657, 218, 37, 'PPL', 'P'),
(207786, 'Keyport', 47.702220916748, 0.832560815510961, -122.619720458984, -2.14011784988433, 218, 56, 'PPL', 'P'),
(109950, 'Keyrock', 37.6302795410156, 0.656772276436583, -81.5177764892578, -1.42275359864237, 218, 58, 'PPL', 'P'),
(27622, 'Keys', 39.7799987792969, 0.694291955138056, -89.5730590820313, -1.56334480206485, 218, 18, 'PPL', 'P'),
(76279, 'Keys', 35.7980613708496, 0.62479403675232, -94.9674987792969, -1.65749553608243, 218, 42, 'PPL', 'P'),
(78557, 'Keys', 39.8813896179199, 0.696061559103386, -76.5363922119141, -1.33581204169565, 218, 45, 'PPL', 'P'),
(3510, 'Keys Chapel (historical)', 34.9411087036133, 0.609837391175299, -87.670280456543, -1.53013505011351, 218, 2, 'PPL', 'P'),
(95302, 'Keys Crossing', 31.478889465332, 0.549410266041401, -99.0252838134766, -1.72831724526701, 218, 51, 'PPL', 'P'),
(66077, 'Keys Crossroads', 36.3688888549805, 0.63475685581128, -76.5808334350586, -1.33658768736313, 218, 33, 'PPL', 'P'),
(48646, 'Keys Farm', 38.9411087036133, 0.679650561255072, -76.4805603027344, -1.33483759105279, 218, 25, 'PPL', 'P'),
(81864, 'Keys Field', 33.7433280944824, 0.588932175829422, -79.0680618286133, -1.37999801207975, 218, 48, 'PPL', 'P'),
(103319, 'Keys Gap', 39.2588882446289, 0.685196860541271, -77.7613906860352, -1.35719229840097, 218, 53, 'PPL', 'P'),
(3511, 'Keys Mill', 34.9366683959961, 0.609759893187578, -86.5238876342773, -1.51012672084375, 218, 2, 'PPL', 'P'),
(88266, 'Keys Mill', 36.348331451416, 0.634398061433419, -82.5177764892578, -1.44020689116232, 218, 50, 'PPL', 'P'),
(3512, 'Keysburg', 33.9449996948242, 0.592452009263153, -85.9180603027344, -1.49955303920975, 218, 2, 'PPL', 'P'),
(36713, 'Keysburg', 36.6511116027832, 0.639682571984463, -87.008056640625, -1.51857706414062, 218, 21, 'PPL', 'P'),
(48647, 'Keyser', 39.436939239502, 0.688304436638258, -77.3102798461914, -1.34931892895426, 218, 25, 'PPL', 'P'),
(109951, 'Keyser', 39.4408302307129, 0.688372347246055, -78.9741668701172, -1.37835923590297, 218, 58, 'PPL', 'P'),
(163322, 'Keyser Valley', 41.4255599975586, 0.723012416439852, -75.6963882446289, -1.32115120673671, 218, 45, 'PPL', 'P'),
(48648, 'Keyser Woods', 39.4061088562012, 0.687766344940007, -76.6999969482422, -1.33866748301643, 218, 25, 'PPL', 'P'),
(3513, 'Keystone', 33.2677803039551, 0.580632301134136, -86.8097229003906, -1.51511548735574, 218, 2, 'PPL', 'P'),
(14045, 'Keystone', 39.726390838623, 0.693356320068083, -75.6055603027344, -1.31956596009784, 218, 10, 'PPL', 'P'),
(16721, 'Keystone', 28.1555595397949, 0.491407216710721, -82.6213912963867, -1.44201531070053, 218, 12, 'PPL', 'P'),
(41594, 'Keystone', 30.0802803039551, 0.524999931226817, -91.8375015258789, -1.6028667784319, 218, 22, 'PPL', 'P'),
(73106, 'Keystone', 38.9880599975586, 0.68047001592249, -82.6091690063477, -1.44180199149722, 218, 41, 'PPL', 'P'),
(88267, 'Keystone', 36.3230590820313, 0.633956975377874, -82.3322219848633, -1.43696835411873, 218, 50, 'PPL', 'P'),
(109953, 'Keystone', 37.4147186279297, 0.653010028764628, -81.4511108398438, -1.42159006356212, 218, 58, 'PPL', 'P'),
(116315, 'Keystone', 41.9983291625977, 0.733009124223682, -92.1972198486328, -1.60914504754371, 218, 16, 'PPL', 'P'),
(122956, 'Keystone', 40.5955581665039, 0.708526151690366, -85.2594375610352, -1.48805790383859, 218, 19, 'PPL', 'P'),
(163325, 'Keystone', 40.2675018310547, 0.70280048850475, -79.7080612182617, -1.39116810863987, 218, 45, 'PPL', 'P'),
(182471, 'Keystone', 37.8352813720703, 0.660350233361105, -120.50666809082, -2.1032381287928, 218, 6, 'PPL', 'P'),
(190369, 'Keystone', 39.2819404602051, 0.685599197602955, -114.967498779297, -2.00656138648129, 218, 39, 'PPL', 'P'),
(194271, 'Keystone', 40.3011093139648, 0.70338704973484, -106.962501525879, -1.86684782779605, 218, 7, 'PPL', 'P'),
(196820, 'Keystone', 47.2683296203613, 0.824987983793266, -114.934722900391, -2.00598933947914, 218, 31, 'PPL', 'P'),
(199446, 'Keystone', 41.2161102294922, 0.719356828369554, -101.583061218262, -1.77295888251363, 218, 35, 'PPL', 'P'),
(202274, 'Keystone', 43.8955612182617, 0.7661220702694, -103.417778015137, -1.80498073146074, 218, 49, 'PPL', 'P'),
(207789, 'Keystone', 48.561939239502, 0.84756573088274, -119.481941223145, -2.08535327101821, 218, 56, 'PPL', 'P'),
(209546, 'Keystone', 41.1680603027344, 0.718518198942288, -106.258056640625, -1.85455294514953, 218, 59, 'PPL', 'P'),
(9849, 'Keystone (historical)', 36.1222190856934, 0.630451656172085, -92.5347213745117, -1.6150355604008, 218, 4, 'PPL', 'P'),
(55665, 'Keystone (historical)', 39.6916694641113, 0.692750317762036, -94.3158264160156, -1.64612170769892, 218, 29, 'PPL', 'P'),
(140319, 'Keystone (historical)', 46.1813888549805, 0.806017288663223, -98.5500030517578, -1.72002203110363, 218, 34, 'PPL', 'P'),
(190371, 'Keystone (historical)', 38.4449996948242, 0.670991825602898, -116.382499694824, -2.03125781137598, 218, 39, 'PPL', 'P'),
(81865, 'Keystone Acres', 34.5233306884766, 0.602545789268717, -82.6122207641602, -1.44185525471902, 218, 48, 'PPL', 'P'),
(103320, 'Keystone Estates', 39.1794395446777, 0.683810219140695, -78.0686111450195, -1.36255430693973, 218, 53, 'PPL', 'P'),
(207790, 'Keystone Ferry Landing', 48.1594390869141, 0.840540777980302, -122.669998168945, -2.14099536146351, 218, 56, 'PPL', 'P'),
(103321, 'Keystone Forest', 37.3933296203613, 0.652636720158826, -79.209716796875, -1.38247035767773, 218, 53, 'PPL', 'P'),
(16722, 'Keystone Heights', 29.7858295440674, 0.519860795981777, -82.0316696166992, -1.4317227257196, 218, 12, 'PPL', 'P'),
(16723, 'Keystone Islands', 25.8941707611084, 0.451938536854988, -80.154167175293, -1.39895412640283, 218, 12, 'PPL', 'P'),
(190372, 'Keystone Junction', 39.2830581665039, 0.68561870525794, -114.96305847168, -2.00648388849357, 218, 39, 'PPL', 'P'),
(30242, 'Keystone Manor', 39.7633285522461, 0.694001004788964, -86.2763900756836, -1.50580707355564, 218, 19, 'PPL', 'P'),
(16724, 'Keysville', 27.8688907623291, 0.486403902681275, -82.095832824707, -1.43284258495797, 218, 12, 'PPL', 'P'),
(22362, 'Keysville', 33.2336082458496, 0.580035886208013, -82.2324981689453, -1.4352278451883, 218, 13, 'PPL', 'P'),
(48655, 'Keysville', 39.6338882446289, 0.69174184523625, -77.2588882446289, -1.34842197629912, 218, 25, 'PPL', 'P'),
(55666, 'Keysville', 37.8752784729004, 0.661048314461842, -91.3888931274414, -1.59503708482707, 218, 29, 'PPL', 'P'),
(103323, 'Keysville', 38.7569389343262, 0.676436192398374, -78.0350036621094, -1.36196774570964, 218, 53, 'PPL', 'P'),
(55667, 'Keytesville', 39.434440612793, 0.688260827375408, -92.9380569458008, -1.62207509411021, 218, 29, 'PPL', 'P'),
(3514, 'Keyton', 31.2824993133545, 0.545982611270901, -85.8255615234375, -1.49793863095694, 218, 2, 'PPL', 'P'),
(9850, 'Keyton (historical)', 33.9705581665039, 0.592898088745741, -93.2197189331055, -1.62699102316639, 218, 4, 'PPL', 'P'),
(3515, 'Keytons', 31.1088905334473, 0.54295256645115, -85.3705596923828, -1.48999735090244, 218, 2, 'PPL', 'P'),
(30243, 'Keytsville', 39.6513900756836, 0.692047309813282, -87.0122222900391, -1.51864976843838, 218, 19, 'PPL', 'P'),
(48650, 'Keyview', 39.5986099243164, 0.691126122392224, -77.1438903808594, -1.34641488494358, 218, 25, 'PPL', 'P'),
(48651, 'Keywaydin', 39.2602806091309, 0.685221161886218, -76.8166732788086, -1.34070386914396, 218, 25, 'PPL', 'P'),
(103324, 'Keywood', 36.8247184753418, 0.642712583514701, -81.7908325195313, -1.42751932541307, 218, 53, 'PPL', 'P'),
(127871, 'Kezar Falls', 43.8077812194824, 0.764590020273305, -70.8894424438477, -1.23725417554816, 218, 26, 'PPL', 'P'),
(144024, 'Kezer Seminary', 43.3447189331055, 0.756508058734214, -71.5111083984375, -1.2481042933033, 218, 36, 'PPL', 'P'),
(78559, 'Khedive', 39.8838882446289, 0.696105168366236, -80.0363922119141, -1.39689856551545, 218, 45, 'PPL', 'P'),
(193703, 'Khoonkhwuttunne (historical)', 41.9486083984375, 0.73214133318248, -124.201942443848, -2.16773283301763, 218, 6, 'PPL', 'P'),
(88268, 'Khotan', 36.0766716003418, 0.629656702586696, -84.3333282470703, -1.47189424707651, 218, 50, 'PPL', 'P'),
(193704, 'Khwunrghunme (historical)', 41.5347213745117, 0.724917641883694, -124.076393127441, -2.16554158407272, 218, 6, 'PPL', 'P'),
(48652, 'Kiah Estates', 39.6474990844727, 0.691979399205485, -76.3352813720703, -1.33230199537892, 218, 25, 'PPL', 'P'),
(109957, 'Kiahsville', 38.0913887023926, 0.664820149513721, -82.3274993896484, -1.43688592928299, 218, 58, 'PPL', 'P'),
(95303, 'Kiam', 30.7570400238037, 0.53681161658305, -94.6752090454102, -1.65239411785632, 218, 51, 'PPL', 'P'),
(14046, 'Kiamensi', 39.7236099243164, 0.693307783957217, -75.6402816772461, -1.32017196240388, 218, 10, 'PPL', 'P'),
(14047, 'Kiamensi Gardens', 39.7236099243164, 0.693307783957217, -75.6374969482422, -1.32012335971399, 218, 10, 'PPL', 'P'),
(14048, 'Kiamensi Heights', 39.7194404602051, 0.69323501308043, -75.6333312988281, -1.32005065541623, 218, 10, 'PPL', 'P'),
(150010, 'Kiamesha Lake', 41.6830596923828, 0.727506633937415, -74.6611099243164, -1.30308219137274, 218, 40, 'PPL', 'P'),
(76280, 'Kiamichi', 34.6352806091309, 0.604499683981481, -95.1786117553711, -1.66118015260861, 218, 42, 'PPL', 'P'),
(211925, 'Kiana', 66.9749984741211, 1.16893423989159, -160.422775268555, -2.79990562362321, 218, 1, 'PPL', 'P'),
(150011, 'Kiantone', 42.0219383239746, 0.733421181823345, -79.1983337402344, -1.38227168586041, 218, 40, 'PPL', 'P'),
(81866, 'Kiawah Island', 32.6080589294434, 0.569117991003124, -80.0849990844727, -1.39774691548069, 218, 48, 'PPL', 'P'),
(210411, 'KiÃ‚â€˜ekiÃ‚â€˜e', 21.8863906860352, 0.381989578849134, -160.212783813477, -2.79624058133104, 218, 15, 'PPL', 'P'),
(210417, 'KiÃ‚â€˜i', 21.9772205352783, 0.383574858777517, -160.060287475586, -2.79357901813762, 218, 15, 'PPL', 'P'),
(22363, 'Kibbee', 32.2874984741211, 0.563523155606058, -82.5252838134766, -1.44033791868795, 218, 13, 'PPL', 'P'),
(163326, 'Kibbeville', 41.9772186279297, 0.73264067588687, -78.0666732788086, -1.36252048479389, 218, 45, 'PPL', 'P'),
(196821, 'Kibbey (historical)', 47.1780586242676, 0.823412457692376, -110.730278015137, -1.93260793301283, 218, 31, 'PPL', 'P'),
(27623, 'Kibbie', 39.0697212219238, 0.681895273158873, -87.9380569458008, -1.53480863151049, 218, 18, 'PPL', 'P'),
(131571, 'Kibbie', 42.4188919067383, 0.740349328820158, -86.1875, -1.50425564906261, 218, 27, 'PPL', 'P'),
(140322, 'Kibby (historical)', 46.7358283996582, 0.815694084221108, -97.6833267211914, -1.70489567558615, 218, 34, 'PPL', 'P'),
(182472, 'Kibesillah', 39.5902786254883, 0.690980713796706, -123.776672363281, -2.16031046990153, 218, 6, 'PPL', 'P'),
(9852, 'Kiblah', 33.0513916015625, 0.576855605813267, -93.8958282470703, -1.63879135679847, 218, 4, 'PPL', 'P'),
(9851, 'Kibler', 35.4302787780762, 0.618375019576903, -94.2313919067383, -1.64464804750972, 218, 4, 'PPL', 'P'),
(81876, 'Kibler', 34.2316703796387, 0.597455356582112, -81.4494400024414, -1.42156090194818, 218, 48, 'PPL', 'P'),
(103325, 'Kibler', 36.6308288574219, 0.639328571296564, -80.4530563354492, -1.40417072634607, 218, 53, 'PPL', 'P'),
(207791, 'Kibler', 46.0880584716797, 0.804388366182476, -118.219436645508, -2.06331840931695, 218, 56, 'PPL', 'P'),
(95304, 'Kicaster', 29.3099994659424, 0.511555994438474, -98.2082366943359, -1.71405708289407, 218, 51, 'PPL', 'P'),
(32920, 'Kickapoo', 39.3988914489746, 0.687640377420446, -94.970832824707, -1.65755372615224, 218, 20, 'PPL', 'P'),
(41595, 'Kickapoo', 32.1933288574219, 0.561879585739316, -93.8369369506836, -1.63776350977576, 218, 22, 'PPL', 'P'),
(120212, 'Kickapoo', 40.7900009155273, 0.711919817867454, -89.751106262207, -1.56645231158281, 218, 18, 'PPL', 'P'),
(207792, 'Kickerville', 48.8852806091309, 0.853209102390673, -122.702781677246, -2.14156754162371, 218, 56, 'PPL', 'P'),
(196822, 'Kicking Horse', 47.4605598449707, 0.828343034134548, -114.074172973633, -1.99096990987942, 218, 31, 'PPL', 'P'),
(22364, 'Kicklighter (historical)', 31.9513893127441, 0.557656944093913, -81.9452819824219, -1.43021497706845, 218, 13, 'PPL', 'P'),
(3517, 'Kid', 32.7222213745117, 0.571110501551694, -86.0769424438477, -1.5023260556948, 218, 2, 'PPL', 'P'),
(207793, 'Kid Valley', 46.3730583190918, 0.809362551887499, -122.618057250977, -2.14008882142845, 218, 56, 'PPL', 'P'),
(27629, 'Kidd', 38.1172218322754, 0.665271022686271, -90.1727828979492, -1.57381195725525, 218, 18, 'PPL', 'P'),
(196823, 'Kidd', 44.8011093139648, 0.781926866074585, -112.751937866211, -1.96789255376945, 218, 31, 'PPL', 'P'),
(36714, 'Kidder', 36.9150009155273, 0.644288309352673, -84.6516723632813, -1.47745040005875, 218, 21, 'PPL', 'P'),
(55670, 'Kidder', 39.7802810668945, 0.694296881986072, -94.1022186279297, -1.64239354848891, 218, 29, 'PPL', 'P'),
(116316, 'Kidder', 42.464168548584, 0.741139555294612, -90.9277801513672, -1.58698914517091, 218, 16, 'PPL', 'P'),
(170653, 'Kidder', 45.8830604553223, 0.800810475836982, -97.7130584716797, -1.70541459252455, 218, 49, 'PPL', 'P'),
(150013, 'Kidders', 42.6402816772461, 0.744213309245754, -76.6930618286133, -1.33854644234489, 218, 40, 'PPL', 'P'),
(163328, 'Kidders Corner', 41.910831451416, 0.731482001075603, -80.4013900756836, -1.40326898000097, 218, 45, 'PPL', 'P'),
(144025, 'Kidderville', 44.8763885498047, 0.783240736598375, -71.3769378662109, -1.2457625757568, 218, 36, 'PPL', 'P'),
(36715, 'Kidds Crossing', 36.7563896179199, 0.641520019978563, -84.6800003051758, -1.47794481591512, 218, 21, 'PPL', 'P'),
(103326, 'Kidds Fork', 37.9425010681152, 0.662221570080076, -77.3008270263672, -1.34915394612473, 218, 53, 'PPL', 'P'),
(103332, 'Kidds Store', 37.8033294677734, 0.659792567428842, -78.3619384765625, -1.36767383466124, 218, 53, 'PPL', 'P'),
(36716, 'Kiddville', 37.9597206115723, 0.662522107809092, -83.9930572509766, -1.46595539784564, 218, 21, 'PPL', 'P'),
(27624, 'Kidley', 39.7449989318848, 0.693681092563019, -87.541389465332, -1.52788547794072, 218, 18, 'PPL', 'P'),
(155982, 'Kidron', 40.7408294677734, 0.711061614206176, -81.745002746582, -1.42671944497966, 218, 41, 'PPL', 'P'),
(109954, 'Kidtown', 38.5416717529297, 0.672679071311518, -81.0266723632813, -1.41418221467395, 218, 58, 'PPL', 'P'),
(103327, 'Kidville', 38.1108283996582, 0.665159436236597, -78.9438934326172, -1.3778308647427, 218, 53, 'PPL', 'P'),
(88269, 'Kidwell', 36.5808296203613, 0.638455919986373, -83.9072189331055, -1.46445723657441, 218, 50, 'PPL', 'P'),
(109955, 'Kidwell', 39.5341682434082, 0.690001402884856, -80.8913879394531, -1.41182105605149, 218, 58, 'PPL', 'P'),
(48653, 'Kidwells Corner', 38.8958282470703, 0.678860268201591, -76.7188873291016, -1.33899718235938, 218, 25, 'PPL', 'P'),
(48654, 'Kidwiler Park', 39.353889465332, 0.686854944635955, -77.3816680908203, -1.35056488887025, 218, 25, 'PPL', 'P'),
(198483, 'Kief', 47.8574981689453, 0.835270914815253, -100.511108398438, -1.75424977638166, 218, 34, 'PPL', 'P'),
(76287, 'Kiefer', 35.9447212219238, 0.62735373403405, -96.0650024414063, -1.67665058853893, 218, 42, 'PPL', 'P'),
(169448, 'Kiefer Park', 41.5894393920898, 0.725872651450597, -71.4347229003906, -1.24677111486161, 218, 47, 'PPL', 'P'),
(155977, 'Kieferville', 41.1002807617188, 0.717335222786075, -84.206672668457, -1.46968369021369, 218, 41, 'PPL', 'P'),
(109956, 'Kieffer', 37.939998626709, 0.662177894238199, -80.6097183227539, -1.40690499383726, 218, 58, 'PPL', 'P'),
(55672, 'Kiel', 38.521671295166, 0.672329997471635, -91.2436065673828, -1.59250135599515, 218, 29, 'PPL', 'P'),
(174765, 'Kiel', 43.9124984741211, 0.766417681150399, -88.0355606079102, -1.53651039144705, 218, 57, 'PPL', 'P'),
(174767, 'Kieler', 42.5813903808594, 0.743185462223038, -90.6025009155273, -1.58131195151713, 218, 57, 'PPL', 'P'),
(103328, 'Kiels Gardens', 38.8488883972168, 0.678041013271256, -77.3433303833008, -1.34989576964637, 218, 53, 'PPL', 'P'),
(60483, 'Kienstra', 31.225830078125, 0.544993546531559, -91.605827331543, -1.59882330094884, 218, 30, 'PPL', 'P'),
(163329, 'Kier', 40.0858306884766, 0.699629728910901, -79.7125015258789, -1.39124560662759, 218, 45, 'PPL', 'P'),
(131572, 'Kiernan', 46.1455612182617, 0.805391978439273, -88.1797180175781, -1.53902641288691, 218, 27, 'PPL', 'P'),
(190373, 'Kiernan (historical)', 37.2874984741211, 0.650789618205775, -114.466667175293, -1.99782022599338, 218, 39, 'PPL', 'P'),
(76283, 'Kiersey', 34.0055618286133, 0.593509017899805, -96.4652786254883, -1.68363672586848, 218, 42, 'PPL', 'P'),
(182473, 'Kiesel', 38.6630592346191, 0.674797682537703, -121.615562438965, -2.12259198622468, 218, 6, 'PPL', 'P'),
(55673, 'Kieseweltter Resort', 37.8269386291504, 0.660204625028505, -92.3438873291016, -1.61170487798349, 218, 29, 'PPL', 'P'),
(191689, 'Kiesling', 31.6099700927734, 0.551698054575834, -100.259452819824, -1.74985755795385, 218, 51, 'PPL', 'P'),
(95305, 'Kiesling''s Colonia', 27.7719993591309, 0.484712828678589, -98.0820007324219, -1.71185384972425, 218, 51, 'PPL', 'P'),
(136230, 'Kiester', 43.5363883972168, 0.75985332195849, -93.7119369506836, -1.63558184821076, 218, 28, 'PPL', 'P'),
(81867, 'Kiffs Crossroads', 34.1786117553711, 0.596529308892064, -80.1436080932617, -1.39876983565539, 218, 48, 'PPL', 'P'),
(186918, 'Kiggin', 39.4263916015625, 0.688120345627906, -107.238891601563, -1.87167174463656, 218, 7, 'PPL', 'P'),
(76284, 'Kiheki', 36.6730613708496, 0.640065667707271, -96.2155609130859, -1.67927832958651, 218, 42, 'PPL', 'P'),
(22365, 'Kiker', 34.6666717529297, 0.605047562796737, -84.5008316040039, -1.47481773216315, 218, 13, 'PPL', 'P'),
(66079, 'Kikers', 35.0755615234375, 0.612184035569823, -80.2113876342773, -1.3999528118116, 218, 33, 'PPL', 'P'),
(196824, 'Kila', 48.1202812194824, 0.83985734426556, -114.455833435059, -1.99763114155598, 218, 31, 'PPL', 'P'),
(182474, 'Kilaga Springs', 38.9711112976074, 0.680174205304409, -121.246940612793, -2.11615832166327, 218, 6, 'PPL', 'P'),
(210425, 'Kilauea', 22.2119407653809, 0.387671499613845, -159.412216186523, -2.78226804035583, 218, 15, 'PPL', 'P'),
(48657, 'Kilbirnie Estates', 38.353889465332, 0.669401652116012, -75.5047225952148, -1.31780601009146, 218, 25, 'PPL', 'P'),
(116317, 'Kilbourn', 40.8061103820801, 0.712200981099539, -91.9697189331055, -1.60517440751646, 218, 16, 'PPL', 'P'),
(41600, 'Kilbourne', 32.999439239502, 0.575948866041123, -91.3150024414063, -1.5937474490692, 218, 22, 'PPL', 'P'),
(120214, 'Kilbourne', 40.1519393920898, 0.700783543453178, -90.0100021362305, -1.57097089700435, 218, 18, 'PPL', 'P'),
(155978, 'Kilbourne', 40.3300018310547, 0.703891319287246, -82.9574966430664, -1.44788145563365, 218, 41, 'PPL', 'P'),
(32919, 'Kilbourns Corner', 38.1591682434082, 0.666003125669934, -98.3258285522461, -1.71610944798814, 218, 20, 'PPL', 'P'),
(174768, 'Kilbournville', 42.8077812194824, 0.747136727753362, -87.9522171020508, -1.53505577285965, 218, 57, 'PPL', 'P'),
(3521, 'Kilburn (historical)', 34.8938903808594, 0.609013275975974, -87.6074981689453, -1.529039292483, 218, 2, 'PPL', 'P'),
(3518, 'Kilby', 32.4094390869141, 0.565651420791195, -86.2655563354492, -1.50561798911824, 218, 2, 'PPL', 'P'),
(103329, 'Kilby', 36.7319412231445, 0.641093314992905, -76.6294403076172, -1.33743603732838, 218, 53, 'PPL', 'P'),
(196825, 'Kilby Butte Colony', 46.5458297729492, 0.812377982610769, -108.348609924316, -1.89103998313833, 218, 31, 'PPL', 'P'),
(48656, 'Kilby Corner', 39.6775016784668, 0.692503043254822, -76.1594390869141, -1.32923296853871, 218, 25, 'PPL', 'P'),
(22367, 'Kilby Mill', 34.9502792358398, 0.609997447156813, -83.4927825927734, -1.4572239578957, 218, 13, 'PPL', 'P'),
(103330, 'Kilby Shores', 36.7222213745117, 0.640923671631467, -76.6222229003906, -1.33731006980882, 218, 53, 'PPL', 'P'),
(103331, 'Kilby Shores West', 36.7241706848145, 0.640957693514393, -76.6247177124023, -1.33735361249264, 218, 53, 'PPL', 'P'),
(22366, 'Kildare', 32.5341682434082, 0.567828355245253, -81.4555587768555, -1.42166769470789, 218, 13, 'PPL', 'P'),
(76285, 'Kildare', 36.8097190856934, 0.642450794779546, -97.0488891601563, -1.69382265124776, 218, 42, 'PPL', 'P'),
(95306, 'Kildare', 32.9430618286133, 0.574964894597366, -94.2480621337891, -1.64493899785881, 218, 51, 'PPL', 'P'),
(150014, 'Kildare', 44.3261108398438, 0.773636578759222, -74.5305633544922, -1.30080372390212, 218, 40, 'PPL', 'P'),
(95307, 'Kildare Junction', 32.9083290100098, 0.574358692554236, -94.1883316040039, -1.6438965034501, 218, 51, 'PPL', 'P'),
(36717, 'Kildav', 36.8583297729492, 0.643299211323818, -83.2058334350586, -1.45221575030776, 218, 21, 'PPL', 'P'),
(120216, 'Kildeer', 42.1705589294434, 0.736015100725082, -88.0477828979492, -1.53672371065037, 218, 18, 'PPL', 'P'),
(41597, 'Kile', 31.4055595397949, 0.548130417400536, -93.147216796875, -1.62572562217443, 218, 22, 'PPL', 'P'),
(155979, 'Kileville', 40.1044387817383, 0.699954501405837, -83.2108306884766, -1.45230296883346, 218, 41, 'PPL', 'P'),
(122958, 'Kiley', 40.5275001525879, 0.707338315265163, -85.6802825927734, -1.49540303528308, 218, 19, 'PPL', 'P'),
(3520, 'Kilgore', 33.6794395446777, 0.587817110281006, -87.0305633544922, -1.51896988040141, 218, 2, 'PPL', 'P'),
(81870, 'Kilgore', 34.6927795410156, 0.60550322965925, -81.9955596923828, -1.43109248864763, 218, 48, 'PPL', 'P'),
(95309, 'Kilgore', 28.7694396972656, 0.502121446671246, -97.29638671875, -1.69814229853587, 218, 51, 'PPL', 'P'),
(155980, 'Kilgore', 40.464168548584, 0.706232970254726, -81.0019378662109, -1.41375051626125, 218, 41, 'PPL', 'P'),
(163331, 'Kilgore', 41.2622184753418, 0.720161569071949, -80.0013885498047, -1.39628763636138, 218, 45, 'PPL', 'P'),
(195184, 'Kilgore', 44.4022216796875, 0.774964963510954, -111.893058776855, -1.95290228578367, 218, 17, 'PPL', 'P'),
(199447, 'Kilgore', 42.9383316040039, 0.749415261803006, -100.955276489258, -1.76200197199877, 218, 35, 'PPL', 'P'),
(9853, 'Kilgore (historical)', 33.9011116027832, 0.591686017554619, -93.5888900756836, -1.63343427510772, 218, 4, 'PPL', 'P'),
(41598, 'Kilgore Plantation', 29.8544406890869, 0.521058286365931, -91.6711120605469, -1.59996273442123, 218, 22, 'PPL', 'P'),
(182475, 'Kilkare Woods', 37.6283302307129, 0.656738254553657, -121.911109924316, -2.12775026294006, 218, 6, 'PPL', 'P'),
(66081, 'Kilkenny', 35.6361083984375, 0.621967424150338, -76.2161102294922, -1.33022206656757, 218, 33, 'PPL', 'P'),
(136234, 'Kilkenny', 44.3133316040039, 0.773413539017928, -93.5738906860352, -1.63317248637257, 218, 28, 'PPL', 'P'),
(150015, 'Kill Buck', 42.1583290100098, 0.735801648363712, -78.6811065673828, -1.37324436871336, 218, 40, 'PPL', 'P'),
(66082, 'Kill Devil Hills', 36.0305595397949, 0.628851895305274, -75.6763916015625, -1.32080219947585, 218, 33, 'PPL', 'P'),
(109958, 'Killarm', 39.4225006103516, 0.688052435020109, -80.2416687011719, -1.40048131612993, 218, 58, 'PPL', 'P'),
(16725, 'Killarney', 28.5469398498535, 0.49823809174872, -81.6505584716797, -1.42507108142296, 218, 12, 'PPL', 'P'),
(22370, 'Killarney', 31.1372203826904, 0.543447015597037, -84.9413909912109, -1.48250694402048, 218, 13, 'PPL', 'P'),
(109959, 'Killarney', 37.628059387207, 0.656733527442723, -81.2772216796875, -1.41855512518386, 218, 58, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(131573, 'Killarney Beach', 43.6922187805176, 0.762573075221733, -83.9225006103516, -1.46472395215759, 218, 27, 'PPL', 'P'),
(22368, 'Killarney Hills', 33.7855606079102, 0.589669272240129, -84.6861114501953, -1.47805147551678, 218, 13, 'PPL', 'P'),
(16726, 'Killarney Shores', 30.2844390869141, 0.528563174186316, -81.5652770996094, -1.42358264068971, 218, 12, 'PPL', 'P'),
(55675, 'Killarney Shores', 37.5950012207031, 0.656156553592557, -90.5652770996094, -1.5806622733692, 218, 29, 'PPL', 'P'),
(22369, 'Killarney West', 33.8697204589844, 0.591138138739362, -83.436393737793, -1.45623978671487, 218, 13, 'PPL', 'P'),
(150016, 'Killawog', 42.4005584716797, 0.740029350015185, -76.021110534668, -1.3268186798525, 218, 40, 'PPL', 'P'),
(155981, 'Killbuck', 40.4949989318848, 0.706771061952976, -81.9847183227539, -1.43090327105218, 218, 41, 'PPL', 'P'),
(198480, 'Killdeer', 47.371940612793, 0.826796336752458, -102.753608703613, -1.79338879018395, 218, 34, 'PPL', 'P'),
(116318, 'Killduff', 41.6080589294434, 0.726197623682614, -92.9044418334961, -1.62148839972206, 218, 16, 'PPL', 'P'),
(95310, 'Killeen', 31.1169395446777, 0.543093048198652, -97.7275009155273, -1.70566666072173, 218, 51, 'PPL', 'P'),
(3523, 'Killen', 34.8627815246582, 0.608470324008734, -87.5374984741211, -1.52781756733293, 218, 2, 'PPL', 'P'),
(41599, 'Killian', 30.3586101531982, 0.529857703502689, -90.5861129760742, -1.58102592801605, 218, 22, 'PPL', 'P'),
(81871, 'Killian', 34.1380615234375, 0.595821573832376, -80.9463882446289, -1.41278099246641, 218, 48, 'PPL', 'P'),
(66083, 'Killian Crossroads', 35.5586090087891, 0.620614804632686, -81.0641708374023, -1.41483668651184, 218, 33, 'PPL', 'P'),
(3522, 'Killian Mill', 34.3872184753418, 0.600170182997339, -85.8019409179688, -1.4975263736202, 218, 2, 'PPL', 'P'),
(9855, 'Killin', 33.6122207641602, 0.586643921241799, -91.7411117553711, -1.6011844595713, 218, 4, 'PPL', 'P'),
(163332, 'Killinger', 40.5622215270996, 0.707944317571211, -76.9230575561523, -1.34256062505596, 218, 45, 'PPL', 'P'),
(113606, 'Killingly Center', 41.8386116027832, 0.730221526931669, -71.8697204589844, -1.25436325449721, 218, 8, 'PPL', 'P'),
(16727, 'Killingsworth Crossroads', 30.750560760498, 0.536698532105262, -86.458610534668, -1.50898742052941, 218, 12, 'PPL', 'P'),
(172178, 'Killington', 43.6775016784668, 0.762316213334595, -72.7802810668945, -1.2702555351442, 218, 55, 'PPL', 'P'),
(172175, 'Killington Heights', 43.6047210693359, 0.761045952073655, -72.9436111450195, -1.27310618277502, 218, 55, 'PPL', 'P'),
(172176, 'Killington Village', 43.6399993896484, 0.761661674917681, -72.7938919067383, -1.27049308911344, 218, 55, 'PPL', 'P'),
(113608, 'Killingworth', 41.3580589294434, 0.721834300552628, -72.5641708374023, -1.26648370009232, 218, 8, 'PPL', 'P'),
(131574, 'Killmaster', 44.6316719055176, 0.778969625421133, -83.4513931274414, -1.45650157545002, 218, 27, 'PPL', 'P'),
(41601, 'Killona', 30.0058307647705, 0.523700541641454, -90.482780456543, -1.57922243532585, 218, 22, 'PPL', 'P'),
(3524, 'Killough Springs', 33.6130599975586, 0.586658568627795, -86.7063903808594, -1.51331199466554, 218, 2, 'PPL', 'P'),
(204543, 'Killyons', 40.7930603027344, 0.71197321424731, -111.711936950684, -1.94974111356974, 218, 52, 'PPL', 'P'),
(131575, 'Kilmanagh', 43.7561111450195, 0.763688207349177, -83.3569412231445, -1.45485307873526, 218, 27, 'PPL', 'P'),
(48660, 'Kilmarnock', 39.1016693115234, 0.682452872512108, -76.5955581665039, -1.33684468240832, 218, 25, 'PPL', 'P'),
(103333, 'Kilmarnock', 37.7102813720703, 0.658168571796112, -76.379997253418, -1.33308243473637, 218, 53, 'PPL', 'P'),
(48658, 'Kilmarock', 38.9883308410645, 0.680474743033425, -76.9986114501953, -1.34387928926971, 218, 25, 'PPL', 'P'),
(48659, 'Kilmaurie', 38.6086082458496, 0.673847333502708, -76.2174987792969, -1.33024630133349, 218, 25, 'PPL', 'P'),
(73110, 'Kilmer', 39.603328704834, 0.691208480648935, -81.3786087036133, -1.42032466257017, 218, 41, 'PPL', 'P'),
(60484, 'Kilmichael', 33.4433288574219, 0.583696201389245, -89.5716705322266, -1.56332056729894, 218, 30, 'PPL', 'P'),
(122959, 'Kilmore', 40.3486099243164, 0.704216091782181, -86.5055618286133, -1.50980687519683, 218, 19, 'PPL', 'P'),
(60485, 'Kiln', 30.4088897705078, 0.530735248371384, -89.4349975585938, -1.56093517391055, 218, 30, 'PPL', 'P'),
(182476, 'Kilowatt', 35.3988914489746, 0.617827207340673, -119.446388244629, -2.08473275448422, 218, 6, 'PPL', 'P'),
(3525, 'Kilpatrick', 34.2680587768555, 0.598090453923069, -86.0763931274414, -1.50231646831487, 218, 2, 'PPL', 'P'),
(88271, 'Kilsyth', 36.4286117553711, 0.635799217061937, -84.0830612182617, -1.46752626341462, 218, 50, 'PPL', 'P'),
(109963, 'Kilsyth', 37.8902816772461, 0.661310169776024, -81.182502746582, -1.4169019679372, 218, 58, 'PPL', 'P'),
(201066, 'Kilts', 44.7388916015625, 0.780840962140105, -120.594436645508, -2.10476997905182, 218, 43, 'PPL', 'P'),
(73108, 'Kilvert', 39.3452796936035, 0.686704675771447, -81.8824996948242, -1.42911921943793, 218, 41, 'PPL', 'P'),
(139251, 'Kilwinning', 40.5269393920898, 0.707328528148157, -92.3369369506836, -1.61158357099584, 218, 29, 'PPL', 'P'),
(178450, 'Kim', 32.7347183227539, 0.571328614444972, -113.701667785645, -1.98446846786827, 218, 5, 'PPL', 'P'),
(186919, 'Kim', 37.2466697692871, 0.650077022877097, -103.351669311523, -1.80382691691847, 218, 7, 'PPL', 'P'),
(103334, 'Kimages', 37.3525009155273, 0.651924124830149, -77.1947174072266, -1.34730198390268, 218, 53, 'PPL', 'P'),
(195185, 'Kimama', 42.8380584716797, 0.747665165492661, -113.794723510742, -1.98609259665905, 218, 17, 'PPL', 'P'),
(9856, 'Kimball', 33.0261116027832, 0.576414386599669, -91.6094436645508, -1.59888641786667, 218, 4, 'PPL', 'P'),
(32921, 'Kimball', 37.6611099243164, 0.657310368134834, -95.163330078125, -1.66091343702543, 218, 20, 'PPL', 'P'),
(88272, 'Kimball', 35.047779083252, 0.611699140514346, -85.6719436645508, -1.49525749352951, 218, 50, 'PPL', 'P'),
(103337, 'Kimball', 38.686939239502, 0.6752144672483, -78.4027786254883, -1.368386629727, 218, 53, 'PPL', 'P'),
(109960, 'Kimball', 37.4255599975586, 0.653199246360078, -81.5069427490234, -1.42256451420498, 218, 58, 'PPL', 'P'),
(131576, 'Kimball', 42.9480590820313, 0.749585038322499, -82.5625, -1.44098746367782, 218, 27, 'PPL', 'P'),
(136237, 'Kimball', 45.3125, 0.790852317309931, -94.3000030517578, -1.64584553789387, 218, 28, 'PPL', 'P'),
(155984, 'Kimball', 41.309440612793, 0.720985750850301, -82.7019424438477, -1.44342119343999, 218, 41, 'PPL', 'P'),
(170656, 'Kimball', 43.7466697692871, 0.763523424256728, -98.9580612182617, -1.72714398964878, 218, 49, 'PPL', 'P'),
(174770, 'Kimball', 46.4819412231445, 0.811262917062352, -90.3058319091797, -1.57613410056774, 218, 57, 'PPL', 'P'),
(178451, 'Kimball', 32.896110534668, 0.574145439929948, -109.774719238281, -1.91593028616037, 218, 5, 'PPL', 'P'),
(182477, 'Kimball', 34.2566719055176, 0.597891715526722, -119.188331604004, -2.08022881644868, 218, 6, 'PPL', 'P'),
(191690, 'Kimball', 36.3280601501465, 0.634044260482602, -101.273330688477, -1.76755306497493, 218, 51, 'PPL', 'P'),
(195186, 'Kimball', 43.273609161377, 0.75526695908721, -112.218612670898, -1.95858427312741, 218, 17, 'PPL', 'P'),
(199449, 'Kimball', 41.2358283996582, 0.71970097536142, -103.662498474121, -1.80925190921701, 218, 35, 'PPL', 'P'),
(95311, 'Kimball (historical)', 32.1088600158691, 0.560405326338875, -97.4856872558594, -1.70144621618422, 218, 51, 'PPL', 'P'),
(196826, 'Kimball (historical)', 46.0800018310547, 0.80424775127692, -105.11499786377, -1.83460280594958, 218, 31, 'PPL', 'P'),
(103335, 'Kimball Acres', 37.2763900756836, 0.650595740078417, -80.0633316040039, -1.3973687466059, 218, 53, 'PPL', 'P'),
(204544, 'Kimball Condominium', 40.7722206115723, 0.711609493021432, -111.889717102051, -1.95284396255579, 218, 52, 'PPL', 'P'),
(150017, 'Kimball Corners', 43.0555610656738, 0.751461301889487, -74.0488891601563, -1.29239692328907, 218, 40, 'PPL', 'P'),
(204545, 'Kimball Junction', 40.7272186279297, 0.71082406023694, -111.543327331543, -1.94679832056521, 218, 52, 'PPL', 'P'),
(60486, 'Kimball Lake', 33.7652816772461, 0.589315338131258, -90.8000030517578, -1.58475901407407, 218, 30, 'PPL', 'P'),
(131577, 'Kimball Location', 46.0880584716797, 0.804388366182476, -88.3294372558594, -1.54163950654849, 218, 27, 'PPL', 'P'),
(150018, 'Kimball Mill', 44.0855598449707, 0.76943817187974, -75.3483276367188, -1.31507640313218, 218, 40, 'PPL', 'P'),
(188766, 'Kimball Place', 32.514720916748, 0.567488935364323, -107.044441223145, -1.86827794530142, 218, 38, 'PPL', 'P'),
(150019, 'Kimball Stand', 42.1747207641602, 0.736087738443814, -79.2552795410156, -1.38326557757922, 218, 40, 'PPL', 'P'),
(127872, 'Kimballs Corner', 43.9366683959961, 0.766839525867068, -70.6527786254883, -1.23312361269744, 218, 26, 'PPL', 'P'),
(103336, 'Kimballton', 37.3661117553711, 0.652161678799384, -80.6774978637695, -1.40808796999347, 218, 53, 'PPL', 'P'),
(116319, 'Kimballton', 41.6286087036133, 0.72655628490242, -95.0727767944336, -1.65933298407653, 218, 16, 'PPL', 'P'),
(182478, 'Kimballville (historical)', 34.2750015258789, 0.598211627752667, -119.302780151367, -2.0822263204243, 218, 6, 'PPL', 'P'),
(204547, 'Kimber Estates', 40.6116714477539, 0.708807381501478, -111.842216491699, -1.95201492050845, 218, 52, 'PPL', 'P'),
(9857, 'Kimberley', 34.0436096191406, 0.594173077117617, -93.6888885498047, -1.63517957772811, 218, 4, 'PPL', 'P'),
(48665, 'Kimberley', 38.9805603027344, 0.680339121554912, -77.1502838134766, -1.34652647139325, 218, 25, 'PPL', 'P'),
(88273, 'Kimberlin Heights', 35.9305610656738, 0.627106592684891, -83.7513885498047, -1.46173748331117, 218, 50, 'PPL', 'P'),
(103338, 'Kimberling', 37.1616706848145, 0.648593508991868, -81.0361099243164, -1.41434693118737, 218, 53, 'PPL', 'P'),
(55676, 'Kimberling City', 36.6333312988281, 0.639372247138442, -93.4166717529297, -1.63042849834341, 218, 29, 'PPL', 'P'),
(3526, 'Kimberly', 33.7733306884766, 0.589455819878759, -86.8138885498047, -1.5151881916535, 218, 2, 'PPL', 'P'),
(22371, 'Kimberly', 33.5680618286133, 0.58587320242233, -84.4877777099609, -1.47458989873189, 218, 13, 'PPL', 'P'),
(55677, 'Kimberly', 39.4316711425781, 0.688212491001623, -92.4888916015625, -1.6142356799674, 218, 29, 'PPL', 'P'),
(60487, 'Kimberly', 32.1580581665039, 0.561263996053344, -90.9433288574219, -1.58726052128598, 218, 30, 'PPL', 'P'),
(73109, 'Kimberly', 39.4272193908691, 0.68813479327682, -82.2152786254883, -1.43492730745929, 218, 41, 'PPL', 'P'),
(81872, 'Kimberly', 34.6624984741211, 0.604974725340924, -79.9588928222656, -1.3955459459978, 218, 48, 'PPL', 'P'),
(109962, 'Kimberly', 39.6936111450195, 0.692784206486907, -80.2897186279297, -1.4013199455572, 218, 58, 'PPL', 'P'),
(136240, 'Kimberly', 46.5608291625977, 0.812639771345923, -93.4661102294922, -1.63129136253659, 218, 28, 'PPL', 'P'),
(174772, 'Kimberly', 44.2722206115723, 0.772696016841234, -88.3388900756836, -1.54180448937802, 218, 57, 'PPL', 'P'),
(190374, 'Kimberly', 39.2633285522461, 0.685274358528993, -115.021667480469, -2.00750680866827, 218, 39, 'PPL', 'P'),
(195187, 'Kimberly', 42.5338897705078, 0.742356420175697, -114.363891601563, -1.99602645384116, 218, 17, 'PPL', 'P'),
(201067, 'Kimberly', 44.7594413757324, 0.781199623359911, -119.643333435059, -2.08817009650319, 218, 43, 'PPL', 'P'),
(66084, 'Kimberly Acres', 36.1519393920898, 0.630970373373405, -80.0877838134766, -1.39779551817059, 218, 33, 'PPL', 'P'),
(103339, 'Kimberly Acres', 37.4180603027344, 0.653068351992501, -77.4719390869141, -1.35214041497114, 218, 53, 'PPL', 'P'),
(66085, 'Kimberly Courts', 35.0141716003418, 0.611112579284256, -80.5561065673828, -1.40596929218826, 218, 33, 'PPL', 'P'),
(182479, 'Kimberly Gardens Mobile Home Park', 33.6186103820801, 0.586755441112446, -117.695281982422, -2.05417018465642, 218, 6, 'PPL', 'P'),
(48661, 'Kimberly Heights', 39.3972206115723, 0.68761121580651, -77.1002807617188, -1.34565375350403, 218, 25, 'PPL', 'P'),
(103340, 'Kimberly Hills', 37.3266716003418, 0.651473318236625, -78.3888931274414, -1.36814428206781, 218, 53, 'PPL', 'P'),
(103341, 'Kimberly Knolls', 38.6749992370605, 0.675006074893001, -77.4036102294922, -1.350947851435, 218, 53, 'PPL', 'P'),
(163343, 'Kimberly Meadows', 40.1883316040039, 0.701418707373162, -76.9749984741211, -1.34346716509102, 218, 45, 'PPL', 'P'),
(48662, 'Kimberly Park', 39.0602798461914, 0.681730490066424, -76.0583267211914, -1.32746822484237, 218, 25, 'PPL', 'P'),
(204550, 'Kimberly Park', 40.6430587768555, 0.709355193737707, -111.854721069336, -1.95223316655978, 218, 52, 'PPL', 'P'),
(48663, 'Kimberly Woods', 38.7361106872559, 0.676072670909578, -77.0058288574219, -1.34400525678927, 218, 25, 'PPL', 'P'),
(81873, 'Kimberly Woods', 34.9833297729492, 0.610574287848924, -81.0466690063477, -1.41453122193481, 218, 48, 'PPL', 'P'),
(48664, 'Kimberly Woods Village', 39.0455589294434, 0.681473561600259, -76.4944381713867, -1.33507980555393, 218, 25, 'PPL', 'P'),
(163333, 'Kimberton', 40.1305618286133, 0.700410434584458, -75.5725021362305, -1.31898898624767, 218, 45, 'PPL', 'P'),
(188767, 'Kimbeto', 36.1836090087891, 0.631523112457651, -107.840827941895, -1.88217751566276, 218, 38, 'PPL', 'P'),
(55678, 'Kimble', 37.5769386291504, 0.655841301898519, -91.8411102294922, -1.60292976219168, 218, 29, 'PPL', 'P'),
(163334, 'Kimble', 41.4683303833008, 0.723758900493401, -75.121940612793, -1.31112520418088, 218, 45, 'PPL', 'P'),
(182480, 'Kimble (historical)', 36.3672218322754, 0.634727760776371, -119.716667175293, -2.08945001172308, 218, 6, 'PPL', 'P'),
(163335, 'Kimble Corners', 41.9172210693359, 0.73159352094625, -79.8663864135742, -1.39393140458694, 218, 45, 'PPL', 'P'),
(70998, 'Kimbles Beach', 39.1044387817383, 0.682501208885893, -74.894172668457, -1.30714990362172, 218, 37, 'PPL', 'P'),
(127873, 'Kimbles Corner', 43.6847190856934, 0.762442180854156, -70.5658264160156, -1.23160601035026, 218, 26, 'PPL', 'P'),
(155985, 'Kimbolton', 40.1527786254883, 0.700798190839174, -81.5722198486328, -1.42370381451931, 218, 41, 'PPL', 'P'),
(3527, 'Kimbrell', 33.2761116027832, 0.580777709729654, -87.0672225952148, -1.5196097048533, 218, 2, 'PPL', 'P'),
(36718, 'Kimbrell', 37.8041687011719, 0.659807214814838, -83.9911117553711, -1.46592144254174, 218, 21, 'PPL', 'P'),
(88278, 'Kimbro', 36.0291709899902, 0.628827660539355, -86.6133270263672, -1.5116877327167, 218, 50, 'PPL', 'P'),
(88274, 'Kimbro Heights', 35.7863883972168, 0.624590304928929, -86.4316711425781, -1.50851723943896, 218, 50, 'PPL', 'P'),
(81874, 'Kimbrook', 34.1972198486328, 0.596854081386999, -82.1880569458008, -1.43445219952082, 218, 48, 'PPL', 'P'),
(88275, 'Kimbros (historical)', 35.8555603027344, 0.62579758243009, -84.6999969482422, -1.47829382317598, 218, 50, 'PPL', 'P'),
(3528, 'Kimbrough', 32.0333290100098, 0.559087061599286, -87.5652770996094, -1.52830239580937, 218, 2, 'PPL', 'P'),
(22373, 'Kimbrough', 32.0061111450195, 0.558612020239843, -84.6500015258789, -1.47742123844481, 218, 13, 'PPL', 'P'),
(112228, 'Kimbrough (historical)', 34.1272201538086, 0.595632356236926, -91.6327819824219, -1.5992937483554, 218, 4, 'PPL', 'P'),
(88276, 'Kimbrough Crossroad', 36.1124992370605, 0.630282012810647, -83.3430633544922, -1.45461086423412, 218, 50, 'PPL', 'P'),
(3529, 'Kimbrough Crossroads', 34.8266716003418, 0.607840086936767, -87.7633285522461, -1.53175904574624, 218, 2, 'PPL', 'P'),
(55679, 'Kime', 37.0511093139648, 0.646663849045024, -90.3997192382813, -1.57777274358647, 218, 29, 'PPL', 'P'),
(32922, 'Kimeo', 39.5958290100098, 0.691077586281357, -96.9944381713867, -1.69287230221277, 218, 20, 'PPL', 'P'),
(88277, 'Kimery', 36.1802787780762, 0.63146498896686, -88.8647232055664, -1.55098200881054, 218, 50, 'PPL', 'P'),
(66086, 'Kimesville', 35.952220916748, 0.627484628401628, -79.5397186279297, -1.38822997616724, 218, 33, 'PPL', 'P'),
(163337, 'Kimmel', 40.7138900756836, 0.710591433115722, -79.1405563354492, -1.38126327991365, 218, 45, 'PPL', 'P'),
(122960, 'Kimmell', 41.3952789306641, 0.722483912121525, -85.5483322143555, -1.49310006673043, 218, 19, 'PPL', 'P'),
(163339, 'Kimmelton', 40.0672187805176, 0.699304889836939, -78.95361328125, -1.37800050810414, 218, 45, 'PPL', 'P'),
(55680, 'Kimmelton (historical)', 37.5783309936523, 0.655865603243466, -89.7566680908203, -1.56654938380455, 218, 29, 'PPL', 'P'),
(22372, 'Kimmeridge', 33.3647193908691, 0.582324207374663, -84.5294418334961, -1.47531707486754, 218, 13, 'PPL', 'P'),
(88279, 'Kimmins', 35.6202812194824, 0.621691187766269, -87.5377807617188, -1.52782249418094, 218, 50, 'PPL', 'P'),
(188768, 'Kimmons', 33.4908294677734, 0.584525243436587, -106.018890380859, -1.85037870645694, 218, 38, 'PPL', 'P'),
(55681, 'Kimmswick', 38.3652801513672, 0.669600457091386, -90.3627777099609, -1.57712799228656, 218, 29, 'PPL', 'P'),
(540, 'Kimper', 37.496940612793, 0.654445073118017, -82.3505630493164, -1.43728846608175, 218, 21, 'PPL', 'P'),
(88280, 'Kimsey', 35.0827789306641, 0.612310003089383, -84.3358306884766, -1.47193792291839, 218, 50, 'PPL', 'P'),
(70999, 'Kimseytown', 39.0011100769043, 0.680697782774719, -74.9349975585938, -1.30786243237137, 218, 37, 'PPL', 'P'),
(116320, 'Kimze', 41.9941711425781, 0.732936553083977, -95.3894424438477, -1.66485984228677, 218, 16, 'PPL', 'P'),
(41604, 'Kin Tally', 30.523609161377, 0.532737479457933, -90.5180587768555, -1.57983815816988, 218, 22, 'PPL', 'P'),
(9859, 'Kinard', 33.1936111450195, 0.579337805107276, -92.5158309936523, -1.61470586105785, 218, 4, 'PPL', 'P'),
(16728, 'Kinard', 30.2805595397949, 0.5284954633156, -85.2638931274414, -1.48813566814242, 218, 12, 'PPL', 'P'),
(95313, 'Kinard Estates', 30.1741695404053, 0.526638607535056, -93.790283203125, -1.63694924827246, 218, 51, 'PPL', 'P'),
(81875, 'Kinards', 34.3802795410156, 0.600049075746767, -81.7774963378906, -1.4272865651338, 218, 48, 'PPL', 'P'),
(136242, 'Kinbrae', 43.8258285522461, 0.764905005651234, -95.4869384765625, -1.66656146906527, 218, 28, 'PPL', 'P'),
(9860, 'Kincade Bayou (historical)', 34.7516708374023, 0.606531076681966, -90.5633316040039, -1.58062831806531, 218, 4, 'PPL', 'P'),
(27625, 'Kincaid', 39.5886116027832, 0.690951618761796, -89.414436340332, -1.56057631295366, 218, 18, 'PPL', 'P'),
(32924, 'Kincaid', 38.084171295166, 0.66469418199416, -95.1533279418945, -1.66073886681598, 218, 20, 'PPL', 'P'),
(60488, 'Kincaid', 33.750560760498, 0.589058409665092, -89.6552810668945, -1.56477984641824, 218, 30, 'PPL', 'P'),
(88281, 'Kincaid', 35.5716705322266, 0.620842771221997, -84.2827835083008, -1.47101207496543, 218, 50, 'PPL', 'P'),
(103342, 'Kincaid', 37.9505615234375, 0.66236225156466, -79.9391708374023, -1.3952017324269, 218, 53, 'PPL', 'P'),
(109964, 'Kincaid', 38.0405616760254, 0.663933050554615, -81.2702789306641, -1.41843395135426, 218, 58, 'PPL', 'P'),
(182481, 'Kincaid', 34.1286087036133, 0.595656591002845, -117.934722900391, -2.05834921703897, 218, 6, 'PPL', 'P'),
(198484, 'Kincaid', 48.8872184753418, 0.853242924536517, -102.786392211914, -1.79396097034416, 218, 34, 'PPL', 'P'),
(41605, 'Kincaid (historical)', 31.288330078125, 0.546084377314056, -92.6108322143555, -1.61636394515253, 218, 22, 'PPL', 'P'),
(16729, 'Kincaid Hills', 29.6336097717285, 0.517204059767828, -82.2836074829102, -1.43611987099543, 218, 12, 'PPL', 'P'),
(73111, 'Kincaid Springs', 39.1022186279297, 0.682462459892033, -83.2644424438477, -1.45323867048246, 218, 41, 'PPL', 'P'),
(103343, 'Kincer Mill', 36.6344413757324, 0.639391621635372, -83.1061096191406, -1.45047524137733, 218, 53, 'PPL', 'P'),
(109965, 'Kincheloe', 39.1497192382813, 0.683291501939374, -80.503059387207, -1.40504344423529, 218, 58, 'PPL', 'P'),
(88282, 'Kincheloe (historical)', 36.4480590820313, 0.636138636942867, -82.8161087036133, -1.44541377056758, 218, 50, 'PPL', 'P'),
(88283, 'Kincheloe Mill', 36.4172210693359, 0.635600412086562, -82.5583267211914, -1.440914626222, 218, 50, 'PPL', 'P'),
(3530, 'Kincheon', 32.7569389343262, 0.571716437278714, -86.7019424438477, -1.51323436351976, 218, 2, 'PPL', 'P'),
(95315, 'Kincheonville', 30.2033290863037, 0.52714753761937, -97.834716796875, -1.70753793086167, 218, 51, 'PPL', 'P'),
(9861, 'Kindall', 34.5552787780762, 0.603103388621952, -90.8211135864258, -1.58512746241089, 218, 4, 'PPL', 'P'),
(131579, 'Kinde', 43.9394416809082, 0.76688792881988, -82.996940612793, -1.44856988277544, 218, 27, 'PPL', 'P'),
(30244, 'Kinder', 39.5438919067383, 0.690171112825322, -86.1972198486328, -1.50442529242405, 218, 19, 'PPL', 'P'),
(41606, 'Kinder', 30.485279083252, 0.532068493392105, -92.8505630493164, -1.62054803754116, 218, 22, 'PPL', 'P'),
(55682, 'Kinder', 37.0158309936523, 0.646048126200998, -90.0780563354492, -1.57215866685053, 218, 29, 'PPL', 'P'),
(109968, 'Kinder (historical)', 38.1680603027344, 0.666158321382458, -82.1447219848633, -1.43369586177124, 218, 58, 'PPL', 'P'),
(178452, 'Kinder Crossing', 34.5663909912109, 0.603297333328337, -111.142219543457, -1.93979766900771, 218, 5, 'PPL', 'P'),
(27626, 'Kinderhook', 39.702220916748, 0.692934475351415, -91.1530609130859, -1.5909210362043, 218, 18, 'PPL', 'P'),
(73112, 'Kinderhook', 39.5747184753418, 0.690709137944545, -83.0683288574219, -1.44981584269143, 218, 41, 'PPL', 'P'),
(88284, 'Kinderhook', 35.7949981689453, 0.624740573793437, -87.1891708374023, -1.52173810319649, 218, 50, 'PPL', 'P'),
(103344, 'Kinderhook', 38.3697204589844, 0.669677955079107, -78.4283294677734, -1.36883257605154, 218, 53, 'PPL', 'P'),
(131581, 'Kinderhook', 41.7966690063477, 0.729489490527033, -85.0052795410156, -1.4836220095689, 218, 27, 'PPL', 'P'),
(150020, 'Kinderhook', 42.3952789306641, 0.739937204641469, -73.6983337402344, -1.28627857700072, 218, 40, 'PPL', 'P'),
(163340, 'Kinderhook', 40.0522193908691, 0.699043101101784, -76.4991683959961, -1.33516236354772, 218, 45, 'PPL', 'P'),
(9862, 'Kinderhook (historical)', 35.6833305358887, 0.62279160592869, -92.2447204589844, -1.60997408959105, 218, 4, 'PPL', 'P'),
(22374, 'Kinderlou', 30.8008308410645, 0.537575910526389, -83.3675003051758, -1.45503736948269, 218, 13, 'PPL', 'P'),
(55684, 'Kinderpost', 37.5730590820313, 0.655773591027804, -91.9447174072266, -1.60473804857185, 218, 29, 'PPL', 'P'),
(48666, 'Kindler Estates', 39.1591682434082, 0.683456418189877, -76.8805618286133, -1.34181893469237, 218, 25, 'PPL', 'P'),
(140324, 'Kindred', 46.648609161377, 0.814171821342019, -97.0166702270508, -1.69326032478359, 218, 34, 'PPL', 'P'),
(103345, 'Kindrick', 36.975830078125, 0.645349978521233, -81.040283203125, -1.41441976864319, 218, 53, 'PPL', 'P'),
(163341, 'Kindts Corner', 40.461669921875, 0.706189360991876, -75.932502746582, -1.32527218220749, 218, 45, 'PPL', 'P'),
(66087, 'Kindy Forest', 35.3216705322266, 0.616479448092011, -82.5169372558594, -1.44019224377632, 218, 33, 'PPL', 'P'),
(48667, 'Kindy Hook', 38.5291709899902, 0.672460891839213, -76.8419418334961, -1.34114488862048, 218, 25, 'PPL', 'P'),
(211926, 'Kinegnak', 58.8311080932617, 1.0267965388241, -161.662216186523, -2.82153794852571, 218, 1, 'PPL', 'P'),
(103346, 'Kinfield Estates', 39.2008285522461, 0.684183527746496, -77.9488906860352, -1.36046479074846, 218, 53, 'PPL', 'P'),
(55685, 'Kinfolks Ridge', 36.1241683959961, 0.630485678055011, -89.6449966430664, -1.56460034936077, 218, 29, 'PPL', 'P'),
(9864, 'King', 34.1438903808594, 0.595923306586017, -94.3000030517578, -1.64584553789387, 218, 4, 'PPL', 'P'),
(27628, 'King', 39.2308311462402, 0.684707171795833, -90.5788879394531, -1.58089982733844, 218, 18, 'PPL', 'P'),
(30245, 'King', 38.3041687011719, 0.668533861074809, -87.5761108398438, -1.52849148024677, 218, 19, 'PPL', 'P'),
(41607, 'King', 32.2405586242676, 0.562703900675723, -91.1213912963867, -1.59036829712005, 218, 22, 'PPL', 'P'),
(60489, 'King', 32.0872192382813, 0.560027623517275, -90.1302795410156, -1.57307013373361, 218, 30, 'PPL', 'P'),
(66089, 'King', 36.2805595397949, 0.63321521843526, -80.3594436645508, -1.40253687701731, 218, 33, 'PPL', 'P'),
(103347, 'King', 37.271671295166, 0.650513381821706, -80.0772171020508, -1.3976110942651, 218, 53, 'PPL', 'P'),
(109967, 'King', 39.5011100769043, 0.68942442903469, -80.6816711425781, -1.40816080744928, 218, 58, 'PPL', 'P'),
(116321, 'King', 42.4052810668945, 0.740111774850923, -90.591667175293, -1.58112286707973, 218, 16, 'PPL', 'P'),
(163342, 'King', 40.2438888549805, 0.70238836432606, -78.4644393920898, -1.36946281312351, 218, 45, 'PPL', 'P'),
(174774, 'King', 44.3375015258789, 0.773835383734597, -89.1416702270508, -1.55581564618904, 218, 57, 'PPL', 'P'),
(191691, 'King', 35.9044418334961, 0.626650726085296, -102.718612670898, -1.79277799418794, 218, 51, 'PPL', 'P'),
(182482, 'King (historical)', 35.045280456543, 0.611655531251496, -116.204719543457, -2.02815496238993, 218, 6, 'PPL', 'P'),
(60490, 'King And Anderson', 34.2949981689453, 0.598560635013522, -90.6050033569336, -1.58135562735901, 218, 30, 'PPL', 'P'),
(103353, 'King and Queen Court House', 37.6697196960449, 0.657460636999341, -76.8777770996094, -1.34177033200248, 218, 53, 'PPL', 'P'),
(88285, 'King Arthur Court', 35.9991683959961, 0.628304016490018, -84.1147232055664, -1.46807886934081, 218, 50, 'PPL', 'P'),
(196827, 'King Arthur Park', 45.6666717529297, 0.797033780516114, -111.122222900391, -1.93944866174686, 218, 31, 'PPL', 'P'),
(186920, 'King Center', 38.1769409179688, 0.666313317357901, -103.906936645508, -1.81351816012526, 218, 7, 'PPL', 'P'),
(22375, 'King City', 31.1361103057861, 0.543427641100106, -81.4008331298828, -1.42071255198294, 218, 13, 'PPL', 'P'),
(139252, 'King City', 40.0513916015625, 0.69902865345287, -94.5238876342773, -1.64975306100329, 218, 29, 'PPL', 'P'),
(182483, 'King City', 36.2127799987793, 0.632032242279047, -121.125, -2.11403005647813, 218, 6, 'PPL', 'P'),
(201068, 'King City', 45.4027786254883, 0.792427976568876, -122.802780151367, -2.1433128442441, 218, 43, 'PPL', 'P'),
(196828, 'King Colony Ranch', 47.0558280944824, 0.821279132501168, -109.636390686035, -1.91351599747416, 218, 31, 'PPL', 'P'),
(125171, 'King Corner', 42.5647201538086, 0.742894511873947, -72.9505615234375, -1.27322748976268, 218, 23, 'PPL', 'P'),
(207794, 'King Corner', 45.7947196960449, 0.799268638723881, -122.598609924316, -2.13974940154752, 218, 56, 'PPL', 'P'),
(155986, 'King Corners', 41.2608299255371, 0.720137334306029, -80.7408294677734, -1.40919331500391, 218, 41, 'PPL', 'P'),
(211927, 'King Cove', 55.0616683959961, 0.961007405151437, -162.310287475586, -2.83284892630749, 218, 1, 'PPL', 'P'),
(71000, 'King Crab Landing', 39.0769386291504, 0.682021240678434, -74.9105606079102, -1.3074359271228, 218, 37, 'PPL', 'P'),
(88286, 'King Creek (historical)', 35.8180618286133, 0.625143110592203, -84.6736068725586, -1.47783322946545, 218, 50, 'PPL', 'P'),
(81878, 'King Creek Landing', 32.9208297729492, 0.574576872026541, -81.482780456543, -1.42214280264636, 218, 48, 'PPL', 'P'),
(182484, 'King Farms', 38.7266693115234, 0.67590788781713, -121.690277099609, -2.12389600305244, 218, 6, 'PPL', 'P'),
(150022, 'King Ferry', 42.6652793884277, 0.744649601611337, -76.616943359375, -1.3372179244351, 218, 40, 'PPL', 'P'),
(150023, 'King Ferry Station', 42.6580581665039, 0.744523567512749, -76.6630630493164, -1.33802286487458, 218, 40, 'PPL', 'P'),
(103348, 'King George', 38.2680587768555, 0.667903624002842, -77.1847229003906, -1.34712754685128, 218, 53, 'PPL', 'P'),
(48668, 'King George Estates', 38.5916709899902, 0.673551722621709, -77.0102767944336, -1.34408288793505, 218, 25, 'PPL', 'P'),
(41609, 'King Hill', 31.8777809143066, 0.556372235184059, -93.3263931274414, -1.62885283908446, 218, 22, 'PPL', 'P'),
(195188, 'King Hill', 43.0041694641113, 0.750564349234348, -115.203056335449, -2.0106726414141, 218, 17, 'PPL', 'P'),
(207796, 'King Hill', 48.038330078125, 0.838427027023106, -123.273612976074, -2.1515304272617, 218, 56, 'PPL', 'P'),
(142168, 'King Lake', 41.3136100769043, 0.721058521727088, -96.3008270263672, -1.68076650400365, 218, 35, 'PPL', 'P'),
(48669, 'King Manor', 38.9066696166992, 0.679049485797042, -76.6513900756836, -1.33781913305118, 218, 25, 'PPL', 'P'),
(36719, 'King Mills', 37.7366714477539, 0.658629165506641, -87.7522201538086, -1.53156516761888, 218, 21, 'PPL', 'P'),
(163345, 'King of Prussia', 40.089168548584, 0.699687985559747, -75.3963928222656, -1.31591529887555, 218, 45, 'PPL', 'P'),
(188769, 'King Place', 34.7808303833008, 0.60704000676628, -106.313056945801, -1.85551288156445, 218, 38, 'PPL', 'P'),
(95316, 'King Ranch Colonia Number 1', 26.2439994812012, 0.458044199838644, -98.4560012817383, -1.71838139071409, 218, 51, 'PPL', 'P'),
(95317, 'King Ranch Colonia Number 2', 26.2430000305176, 0.458026756133504, -98.4540023803711, -1.71834650330381, 218, 51, 'PPL', 'P'),
(103354, 'King Richard Estates', 38.7063903808594, 0.675553953708258, -77.6022186279297, -1.35441422190985, 218, 53, 'PPL', 'P'),
(193705, 'King Salmon', 40.7394409179688, 0.711037379440256, -124.217498779297, -2.16800434229077, 218, 6, 'PPL', 'P'),
(211928, 'King Salmon', 58.6883316040039, 1.02430461899211, -156.661392211914, -2.7342571048561, 218, 1, 'PPL', 'P'),
(103350, 'King William', 37.6872215270996, 0.657766101576374, -77.0138931274414, -1.34414600485289, 218, 53, 'PPL', 'P'),
(48670, 'King-Kennedy Estates', 38.3869400024414, 0.669978492808123, -76.6688919067383, -1.33812459762822, 218, 25, 'PPL', 'P'),
(36720, 'Kingbee', 37.1547203063965, 0.648472202004215, -84.7380599975586, -1.4789581487099, 218, 21, 'PPL', 'P'),
(55687, 'Kingbee (historical)', 36.709171295166, 0.640695904779238, -90.6658325195313, -1.58241729652757, 218, 29, 'PPL', 'P'),
(109969, 'Kingbury (historical)', 39.1183280944824, 0.682743623124118, -81.4655609130859, -1.42184226491735, 218, 58, 'PPL', 'P'),
(66091, 'Kingdale', 34.5444412231445, 0.602914237605529, -79.0147171020508, -1.37906697096266, 218, 33, 'PPL', 'P'),
(120218, 'Kingdom', 41.8936080932617, 0.731181396767561, -89.3936080932617, -1.56021279146487, 218, 18, 'PPL', 'P'),
(150024, 'Kingdom', 42.9288902282715, 0.749250478710558, -74.9761123657227, -1.3085800211271, 218, 40, 'PPL', 'P'),
(55688, 'Kingdom City', 38.9527816772461, 0.679854293078463, -91.9388885498047, -1.60463631581821, 218, 29, 'PPL', 'P'),
(3532, 'Kingdom Crossroads', 33.160831451416, 0.578765691526099, -86.5550003051758, -1.51066973939001, 218, 2, 'PPL', 'P'),
(125172, 'Kingdom Hall', 41.5777816772461, 0.725669185943315, -70.5461120605469, -1.23126192993742, 218, 23, 'PPL', 'P'),
(9866, 'Kingdom Springs (historical)', 36.3319396972656, 0.634111971353317, -92.658332824707, -1.61719298719988, 218, 4, 'PPL', 'P'),
(88287, 'Kingfield', 35.9266700744629, 0.627038682077094, -87.0391693115234, -1.51912008268689, 218, 50, 'PPL', 'P'),
(127874, 'Kingfield', 44.959171295166, 0.78468556806877, -70.1544418334961, -1.22442599489335, 218, 26, 'PPL', 'P'),
(76289, 'Kingfisher', 35.8613891601563, 0.625899315183731, -97.9313888549805, -1.70922517657029, 218, 42, 'PPL', 'P'),
(73113, 'Kingfred (historical)', 39.5447196960449, 0.690185560474235, -83.3461074829102, -1.45466399429787, 218, 41, 'PPL', 'P'),
(196829, 'Kingley', 45.898609161377, 0.801081851952061, -107.601112365723, -1.87799368959025, 218, 31, 'PPL', 'P'),
(27631, 'Kingman', 39.3002815246582, 0.685919309565983, -88.5597229003906, -1.54565874926564, 218, 18, 'PPL', 'P'),
(30248, 'Kingman', 39.9674987792969, 0.697564447485545, -87.2774963378906, -1.52327967399348, 218, 19, 'PPL', 'P'),
(32926, 'Kingman', 37.6458282470703, 0.657043652551662, -98.1133270263672, -1.71240059669604, 218, 20, 'PPL', 'P'),
(73114, 'Kingman', 39.5008316040039, 0.689419568765701, -83.9400024414063, -1.46502941673462, 218, 41, 'PPL', 'P'),
(103355, 'Kingman', 36.8705596923828, 0.643512663685188, -76.3702774047852, -1.33291279137493, 218, 53, 'PPL', 'P'),
(127876, 'Kingman', 45.5494384765625, 0.794987673850606, -68.1999969482422, -1.19031449659691, 218, 26, 'PPL', 'P'),
(178453, 'Kingman', 35.1894416809082, 0.614171619270376, -114.052223205566, -1.99058681415662, 218, 5, 'PPL', 'P'),
(3533, 'Kingman (historical)', 34.8416709899902, 0.608101875671922, -87.5483322143555, -1.52800665177032, 218, 2, 'PPL', 'P'),
(13138, 'Kingman Park', 38.9000015258789, 0.678933105657405, -76.9749984741211, -1.34346716509102, 218, 9, 'PPL', 'P'),
(109970, 'Kingmont', 39.4469413757324, 0.688479006847712, -80.1761093139648, -1.39933708896758, 218, 58, 'PPL', 'P'),
(196830, 'Kingrey Place', 45.2266693115234, 0.789354289196761, -112.144996643066, -1.9572994310595, 218, 31, 'PPL', 'P'),
(22376, 'Kingridge Estates', 34.0888900756836, 0.594963370171098, -84.5386123657227, -1.47547713084905, 218, 13, 'PPL', 'P'),
(22377, 'Kingridge North', 34.0961112976074, 0.595089404269686, -84.541389465332, -1.47552560038089, 218, 13, 'PPL', 'P'),
(22378, 'Kingridge West', 34.0919418334961, 0.595016633392899, -84.5508270263672, -1.47569031689431, 218, 13, 'PPL', 'P'),
(3534, 'Kings', 32.2024993896484, 0.56203964172083, -86.9972229003906, -1.51838797970323, 218, 2, 'PPL', 'P'),
(60491, 'Kings', 32.3969383239746, 0.56543324131889, -90.8563919067383, -1.58574318525491, 218, 30, 'PPL', 'P'),
(120219, 'Kings', 42.0041694641113, 0.733111056714405, -89.105827331543, -1.55519006964898, 218, 18, 'PPL', 'P'),
(150025, 'Kings', 43.1508293151855, 0.753124046516078, -73.8547210693359, -1.28900805080194, 218, 40, 'PPL', 'P'),
(3535, 'Kings (historical)', 32.2636108398438, 0.563106237737406, -87.5569381713867, -1.5281568540558, 218, 2, 'PPL', 'P'),
(81880, 'Kings (historical)', 34.9388885498047, 0.609798642181439, -82.2566680908203, -1.43564968990497, 218, 48, 'PPL', 'P'),
(48671, 'Kings Acres', 38.6525001525879, 0.674613391790269, -76.5411071777344, -1.33589433337333, 218, 25, 'PPL', 'P'),
(81881, 'Kings Acres', 32.7122192382813, 0.570935931342239, -79.956672668457, -1.39550719700394, 218, 48, 'PPL', 'P'),
(16730, 'Kings Bay', 25.6369400024414, 0.447449013178846, -80.3013916015625, -1.40152367738059, 218, 12, 'PPL', 'P'),
(182485, 'Kings Beach', 39.2377815246582, 0.684828478783486, -120.02555847168, -2.09484118187578, 218, 6, 'PPL', 'P'),
(150026, 'Kings Bridge', 40.8786087036133, 0.713466315512463, -73.9055633544922, -1.28989541607715, 218, 40, 'PPL', 'P'),
(150027, 'Kings Bridge Heights', 40.8722190856934, 0.713354795641815, -73.9011077880859, -1.28981765177332, 218, 40, 'PPL', 'P'),
(194274, 'Kings Canyon', 40.9269409179688, 0.714309871787745, -106.226387023926, -1.85400020606529, 218, 7, 'PPL', 'P'),
(3537, 'Kings Chapel', 33.3927803039551, 0.582813962699129, -86.3144378662109, -1.50647113277345, 218, 2, 'PPL', 'P'),
(48672, 'Kings Charter', 39.5055618286133, 0.689502126759494, -76.3152770996094, -1.33195285496001, 218, 25, 'PPL', 'P'),
(103356, 'Kings Charter', 37.6875, 0.657770961845363, -77.4258270263672, -1.35133560768972, 218, 53, 'PPL', 'P'),
(14052, 'Kings Cliff Mobile Home Park', 39.1388893127441, 0.683102484081006, -75.4966735839844, -1.31766552834396, 218, 10, 'PPL', 'P'),
(60492, 'Kings Corner', 34.4963912963867, 0.602075608178263, -90.0572204589844, -1.57179501220368, 218, 30, 'PPL', 'P'),
(103357, 'Kings Corner', 37.4005584716797, 0.652762887415469, -76.873893737793, -1.34170255455274, 218, 53, 'PPL', 'P'),
(113610, 'Kings Corner', 41.9444389343262, 0.732068562305693, -72.602783203125, -1.26715761300617, 218, 8, 'PPL', 'P'),
(131582, 'Kings Corner', 43.2491683959961, 0.754840387259607, -85.0733337402344, -1.48480977941507, 218, 27, 'PPL', 'P'),
(194272, 'Kings Corner', 40.3783302307129, 0.704734808983501, -105.072776794434, -1.83386590927596, 218, 7, 'PPL', 'P'),
(195189, 'Kings Corner', 43.5180587768555, 0.759533409732544, -116.53360748291, -2.03389513980348, 218, 17, 'PPL', 'P'),
(155987, 'Kings Corners', 40.6500015258789, 0.709476367567306, -82.6216735839844, -1.44202023754855, 218, 41, 'PPL', 'P'),
(48673, 'Kings Country', 39.4305610656738, 0.688193116504692, -76.4330596923828, -1.33400854900544, 218, 25, 'PPL', 'P'),
(48675, 'Kings Court', 39.1930618286133, 0.684047972847011, -76.0627822875977, -1.3275459891462, 218, 25, 'PPL', 'P'),
(81882, 'Kings Court', 34.559440612793, 0.603176026340684, -82.6650009155273, -1.44277644214008, 218, 48, 'PPL', 'P'),
(22380, 'Kings Cove', 32.8544387817383, 0.573418130636248, -83.7830581665039, -1.46229022239542, 218, 13, 'PPL', 'P'),
(36721, 'Kings Creek', 37.0516700744629, 0.64667363616203, -82.9147186279297, -1.44713483842205, 218, 21, 'PPL', 'P'),
(66094, 'Kings Creek', 35.9922218322754, 0.628182776081392, -81.4019393920898, -1.42073185990084, 218, 33, 'PPL', 'P'),
(81883, 'Kings Creek', 35.0738906860352, 0.612154873955886, -81.4369430541992, -1.4213427890549, 218, 48, 'PPL', 'P'),
(177233, 'Kings Creek', 40.4480590820313, 0.70595180702264, -80.5963897705078, -1.40667236671604, 218, 58, 'PPL', 'P'),
(9867, 'Kings Creek (historical)', 35.0186080932617, 0.611190010692951, -94.1916732788086, -1.64395482667797, 218, 4, 'PPL', 'P'),
(22381, 'Kings Crest Subdivision', 32.4833297729492, 0.566941056549066, -83.7858276367188, -1.4623385587692, 218, 13, 'PPL', 'P'),
(14053, 'Kings Croft', 39.6199989318848, 0.691499430998026, -75.666389465332, -1.3206276292664, 218, 10, 'PPL', 'P'),
(22383, 'Kings Crossing', 32.5652809143066, 0.56837137379152, -83.6097183227539, -1.45926487139709, 218, 13, 'PPL', 'P'),
(103365, 'Kings Crossing', 38.7691688537598, 0.676649644759744, -78.498893737793, -1.37006415489765, 218, 53, 'PPL', 'P'),
(14054, 'Kings Crossroads', 38.7461090087891, 0.676247174540006, -75.4533309936523, -1.31690905743632, 218, 10, 'PPL', 'P'),
(66097, 'Kings Crossroads', 35.6647186279297, 0.622466766854728, -77.5475006103516, -1.35345921234295, 218, 33, 'PPL', 'P'),
(103360, 'Kings Crossroads', 38.666389465332, 0.674855806028494, -77.5838928222656, -1.35409437626293, 218, 53, 'PPL', 'P'),
(41610, 'Kings Estates', 30.5572204589844, 0.53332410726705, -91.1705627441406, -1.59122650078133, 218, 22, 'PPL', 'P'),
(88288, 'Kings Estates', 35.8836097717285, 0.626287138017473, -86.4583282470703, -1.50898249368139, 218, 50, 'PPL', 'P'),
(16736, 'Kings Ferry', 30.7849998474121, 0.537299607563293, -81.8391723632813, -1.42836301484641, 218, 12, 'PPL', 'P'),
(22384, 'Kings Forest', 33.5827789306641, 0.586130064309468, -84.4452819824219, -1.47384820836831, 218, 13, 'PPL', 'P'),
(103362, 'Kings Forest', 37.1991691589355, 0.649247980829755, -80.0800018310547, -1.39765969695499, 218, 53, 'PPL', 'P'),
(125173, 'Kings Forest', 42.6888885498047, 0.745061659210999, -70.9805603027344, -1.2388444821931, 218, 23, 'PPL', 'P'),
(103363, 'Kings Fork', 36.7799987792969, 0.641932077578226, -76.625, -1.33735853934066, 218, 53, 'PPL', 'P'),
(14055, 'Kings Grant', 38.4863891601563, 0.671714208048582, -75.0533294677734, -1.30992771379673, 218, 10, 'PPL', 'P'),
(66098, 'Kings Grant', 34.2627792358398, 0.597998308549352, -77.8638916015625, -1.35898127686323, 218, 33, 'PPL', 'P'),
(81886, 'Kings Grant', 33.9791717529297, 0.593048424189276, -81.1402816772461, -1.41616507126357, 218, 48, 'PPL', 'P'),
(103364, 'Kings Grant', 36.8555603027344, 0.643250874950033, -76.0838928222656, -1.32791443748302, 218, 53, 'PPL', 'P'),
(127877, 'Kings Grove', 46.5313911437988, 0.81212598099262, -67.8605575561523, -1.18439016159398, 218, 26, 'PPL', 'P'),
(139253, 'Kings Grove (historical)', 40.2461090087891, 0.702427113319921, -95.1241683959961, -1.66022993673167, 218, 29, 'PPL', 'P'),
(48677, 'Kings Heights', 39.0777816772461, 0.682035954643456, -76.6941680908203, -1.33856575026279, 218, 25, 'PPL', 'P'),
(201069, 'Kings Heights', 45.5294418334961, 0.794638666589751, -122.706672668457, -2.14163545223151, 218, 43, 'PPL', 'P'),
(95318, 'Kings Highway', 30.9613208770752, 0.540376990071421, -96.2658233642578, -1.68015557484958, 218, 51, 'PPL', 'P'),
(3538, 'Kings Hill (historical)', 34.1338882446289, 0.595748736376562, -85.8188934326172, -1.49782225081731, 218, 2, 'PPL', 'P'),
(113038, 'Kings Island', 42.3841705322266, 0.739743326514111, -88.1808319091797, -1.53904585396286, 218, 18, 'PPL', 'P'),
(48678, 'Kings Kingdom', 39.3811111450195, 0.687330052574425, -77.4819412231445, -1.35231498518059, 218, 25, 'PPL', 'P'),
(55689, 'Kings Lake', 39.0683288574219, 0.681870971813926, -90.7436065673828, -1.58377470973518, 218, 29, 'PPL', 'P'),
(3539, 'Kings Landing', 32.2558288574219, 0.562970416521812, -87.0819396972656, -1.51986656674044, 218, 2, 'PPL', 'P'),
(48679, 'Kings Landing', 38.628059387207, 0.674186819962666, -76.6469421386719, -1.33774150190541, 218, 25, 'PPL', 'P'),
(66100, 'Kings Landing', 34.3741683959961, 0.59994241614511, -77.6524963378906, -1.35529173348903, 218, 33, 'PPL', 'P'),
(125174, 'Kings Landing', 42.1583290100098, 0.735801648363712, -70.767219543457, -1.235120983515, 218, 23, 'PPL', 'P'),
(131584, 'Kings Landing', 42.0436096191406, 0.733799417277163, -86.3974990844727, -1.50792082451283, 218, 27, 'PPL', 'P'),
(201070, 'Kings Landing (historical)', 43.2597198486328, 0.755024544848986, -124.224998474121, -2.16813523665834, 218, 43, 'PPL', 'P'),
(3540, 'Kings Log Landing', 31.8077793121338, 0.555150476744472, -87.461669921875, -1.52649410942921, 218, 2, 'PPL', 'P'),
(48680, 'Kings Manor', 39.1588897705078, 0.683451557920888, -76.9288864135742, -1.3426623578096, 218, 25, 'PPL', 'P'),
(163346, 'Kings Manor', 40.098331451416, 0.699847908383206, -75.3452835083008, -1.31502327306843, 218, 45, 'PPL', 'P'),
(48681, 'Kings Manor South', 38.5852813720703, 0.673440202751062, -76.9613876342773, -1.34322961112179, 218, 25, 'PPL', 'P'),
(48682, 'Kings Meade', 39.1708297729492, 0.683659950276187, -76.8713912963867, -1.34165887871086, 218, 25, 'PPL', 'P'),
(3541, 'Kings Mill', 33.7344398498535, 0.588777046695925, -87.3591690063477, -1.52470513096695, 218, 2, 'PPL', 'P'),
(120220, 'Kings Mill', 41.9536094665527, 0.732228618287207, -88.4138870239258, -1.5431134330538, 218, 18, 'PPL', 'P'),
(131583, 'Kings Mill', 43.142219543457, 0.75297377765157, -83.1727828979492, -1.45163890961564, 218, 27, 'PPL', 'P'),
(73115, 'Kings Mills', 39.3555603027344, 0.686884106249891, -84.2486114501953, -1.4704156600393, 218, 41, 'PPL', 'P'),
(9868, 'Kings Mills (historical)', 36.1944389343262, 0.631712130316019, -91.5461120605469, -1.59778107285623, 218, 4, 'PPL', 'P'),
(73116, 'Kings Mine', 39.9900016784668, 0.697957197167304, -81.4847183227539, -1.42217662479221, 218, 41, 'PPL', 'P'),
(22385, 'Kings Mountain', 33.8347206115723, 0.590527276164325, -84.1388931274414, -1.46850071405748, 218, 13, 'PPL', 'P'),
(36726, 'Kings Mountain', 37.372501373291, 0.652273198670031, -84.6880569458008, -1.47808543082068, 218, 21, 'PPL', 'P'),
(66101, 'Kings Mountain', 35.2449989318848, 0.615141276223274, -81.3413925170898, -1.4196751175803, 218, 33, 'PPL', 'P'),
(41612, 'Kings Oaks', 32.4416694641113, 0.566213946992447, -92.0930633544922, -1.60732717378362, 218, 22, 'PPL', 'P'),
(731, 'Kings Park', 35.041389465332, 0.611587620643699, -81.6897201538086, -1.42575458171673, 218, 48, 'PPL', 'P'),
(22386, 'Kings Park', 32.8452796936035, 0.573258274391816, -83.5527801513672, -1.45827111283632, 218, 13, 'PPL', 'P'),
(48683, 'Kings Park', 39.3722190856934, 0.687174856861901, -76.8291702270508, -1.34092198203724, 218, 25, 'PPL', 'P'),
(103366, 'Kings Park', 38.8061103820801, 0.677294396059652, -77.2436065673828, -1.34815526071595, 218, 53, 'PPL', 'P'),
(150029, 'Kings Park', 40.8861083984375, 0.71359720988004, -73.2577819824219, -1.27858949830144, 218, 40, 'PPL', 'P'),
(16731, 'Kings Point', 26.4449996948242, 0.461552315363578, -80.1399993896484, -1.39870685189561, 218, 12, 'PPL', 'P'),
(22387, 'Kings Point', 33.6661109924316, 0.587584483159788, -84.7799987792969, -1.4796901185355, 218, 13, 'PPL', 'P'),
(55690, 'Kings Point', 37.3211097717285, 0.651376246014892, -93.934440612793, -1.63946526971232, 218, 29, 'PPL', 'P'),
(88289, 'Kings Point', 35.0902786254883, 0.612440897456961, -85.23388671875, -1.48761195751405, 218, 50, 'PPL', 'P'),
(103367, 'Kings Point', 36.7747192382813, 0.641839932204509, -76.6166687011719, -1.33721313074514, 218, 53, 'PPL', 'P'),
(150030, 'Kings Point', 40.8197212219238, 0.712438535068774, -73.7355575561523, -1.28692825514864, 218, 40, 'PPL', 'P'),
(196831, 'Kings Point', 47.7683296203613, 0.833714630053238, -114.15055847168, -1.99230308832112, 218, 31, 'PPL', 'P'),
(48684, 'Kings Ransom', 39.0786094665527, 0.68205040229237, -76.7016677856445, -1.33869664463037, 218, 25, 'PPL', 'P'),
(48685, 'Kings Retreat', 38.9238891601563, 0.679350023526057, -76.6366729736328, -1.33756227116405, 218, 25, 'PPL', 'P'),
(22388, 'Kings Ridge', 33.7294387817383, 0.588689761591198, -84.2044372558594, -1.46964467490373, 218, 13, 'PPL', 'P'),
(48686, 'Kings Ridge', 39.3849983215332, 0.687397896603195, -76.5441665649414, -1.33594772975319, 218, 25, 'PPL', 'P'),
(88290, 'Kings Ridge', 35.1588897705078, 0.613638387841115, -85.2427825927734, -1.48776721980561, 218, 50, 'PPL', 'P'),
(22389, 'Kings Row', 33.6833305358887, 0.587885020888803, -84.2180633544922, -1.46988249518907, 218, 13, 'PPL', 'P'),
(204558, 'Kings Row Manor Condominium', 40.6841697692871, 0.710072715914402, -111.935562133789, -1.95364410930531, 218, 52, 'PPL', 'P'),
(14057, 'Kings Second Addition', 38.6913909912109, 0.675292164973103, -75.3966674804688, -1.31592009256552, 218, 10, 'PPL', 'P'),
(48687, 'Kings Square', 39.1813888549805, 0.68384424102362, -77.2294387817383, -1.34790798620873, 218, 25, 'PPL', 'P'),
(150031, 'Kings Station', 43.149169921875, 0.753095084639223, -73.7633285522461, -1.28741295046704, 218, 40, 'PPL', 'P'),
(30246, 'Kings Store', 38.2036094665527, 0.66677877133742, -86.0611114501953, -1.5020497527317, 218, 19, 'PPL', 'P'),
(22390, 'Kings Terrace', 31.1444396972656, 0.543573016406111, -81.3963928222656, -1.42063505399521, 218, 13, 'PPL', 'P'),
(48688, 'Kings Town Manor', 39.2061080932617, 0.684275673120213, -76.0483322143555, -1.32729378779097, 218, 25, 'PPL', 'P'),
(48689, 'Kings Valley', 39.2686080932617, 0.685366503902709, -77.2352828979492, -1.34800998527848, 218, 25, 'PPL', 'P'),
(88291, 'Kings Valley', 36.0419387817383, 0.629050500543567, -83.8472213745117, -1.46341008163379, 218, 50, 'PPL', 'P'),
(201071, 'Kings Valley', 44.7069396972656, 0.780283296207842, -123.433326721191, -2.15431795797469, 218, 43, 'PPL', 'P'),
(48690, 'Kings Valley Manor', 39.2638893127441, 0.685284145645999, -77.2333297729492, -1.34797589681653, 218, 25, 'PPL', 'P'),
(95319, 'Kings Village', 30.4355602264404, 0.531200735640416, -97.6891708374023, -1.7049976746559, 218, 51, 'PPL', 'P'),
(22392, 'Kings West', 33.6755599975586, 0.587749399410291, -84.7777786254883, -1.47965136954164, 218, 13, 'PPL', 'P'),
(22393, 'Kings Wood', 31.9777793884277, 0.558117537804443, -81.0999984741211, -1.41546199673579, 218, 13, 'PPL', 'P'),
(145531, 'Kings Woods', 40.9516716003418, 0.71474150362142, -73.9258270263672, -1.29024908386992, 218, 37, 'PPL', 'P'),
(103368, 'Kingsberry', 36.709171295166, 0.640695904779238, -77.567497253418, -1.3538082196038, 218, 53, 'PPL', 'P'),
(22394, 'Kingsboro', 32.7083282470703, 0.570868020734442, -84.8694381713867, -1.48125113040845, 218, 13, 'PPL', 'P'),
(150032, 'Kingsboro', 43.0672187805176, 0.751664767396769, -74.341667175293, -1.29750686363065, 218, 40, 'PPL', 'P'),
(174776, 'Kingsbridge', 44.2113914489746, 0.771634347672673, -87.6811065673828, -1.53032400139285, 218, 57, 'PPL', 'P'),
(48691, 'Kingsbrook', 39.3797187805176, 0.687305751229478, -77.4288864135742, -1.35138900406957, 218, 25, 'PPL', 'P'),
(81888, 'Kingsburg', 33.8802795410156, 0.591322429486796, -79.4522171020508, -1.38670278644013, 218, 48, 'PPL', 'P'),
(170660, 'Kingsburg', 42.9144401550293, 0.748998277355327, -97.9308319091797, -1.70921545603231, 218, 49, 'PPL', 'P'),
(182487, 'Kingsburg', 36.5138893127441, 0.637287591216155, -119.553062438965, -2.0865945704023, 218, 6, 'PPL', 'P'),
(73117, 'Kingsbury', 39.1113891601563, 0.682622515873546, -82.0058288574219, -1.43127171938899, 218, 41, 'PPL', 'P'),
(95320, 'Kingsbury', 29.6477794647217, 0.517451367564555, -97.8277816772461, -1.70741689019013, 218, 51, 'PPL', 'P'),
(122961, 'Kingsbury', 41.5275001525879, 0.724791607785106, -86.6999969482422, -1.51320040821586, 218, 19, 'PPL', 'P'),
(127878, 'Kingsbury', 45.1194381713867, 0.787482752740708, -69.6497192382813, -1.21561692379764, 218, 26, 'PPL', 'P'),
(150033, 'Kingsbury', 43.3636093139648, 0.756837758077166, -73.5319366455078, -1.28337439983199, 218, 40, 'PPL', 'P'),
(190375, 'Kingsbury', 38.9772186279297, 0.68028079832704, -119.905830383301, -2.09275153252645, 218, 39, 'PPL', 'P'),
(81889, 'Kingsbury (historical)', 34.5377807617188, 0.602797990623947, -80.8730621337891, -1.41150121040457, 218, 48, 'PPL', 'P'),
(125175, 'Kingsbury Beach', 41.8375015258789, 0.730202152434739, -70.0041732788086, -1.22180331385184, 218, 23, 'PPL', 'P'),
(196832, 'Kingsbury Colony', 48.3027801513672, 0.843042551508322, -112.486671447754, -1.9632627813724, 218, 31, 'PPL', 'P'),
(103369, 'Kingsbury Manor', 38.0875015258789, 0.664752305484951, -78.9427795410156, -1.37781142366674, 218, 53, 'PPL', 'P'),
(190376, 'Kingsbury Meadows', 38.9736099243164, 0.680217814567259, -119.918060302734, -2.09296498488782, 218, 39, 'PPL', 'P'),
(190377, 'Kingsbury Village', 38.9855613708496, 0.68042640665964, -119.891670227051, -2.09250439117729, 218, 39, 'PPL', 'P'),
(156007, 'Kingscreek', 40.1611099243164, 0.700943599434692, -83.7249984741211, -1.46127688960064, 218, 41, 'PPL', 'P'),
(78568, 'Kingsdale', 39.7244415283203, 0.693322298185158, -77.1191711425781, -1.34598345284699, 218, 45, 'PPL', 'P'),
(103372, 'Kingsdale', 36.6330604553223, 0.639367520027507, -76.9011077880859, -1.34217752933315, 218, 53, 'PPL', 'P'),
(136252, 'Kingsdale', 46.2383308410645, 0.807011113803014, -92.311393737793, -1.61113775782936, 218, 28, 'PPL', 'P'),
(32937, 'Kingsdown', 37.5250015258789, 0.654934828442483, -99.7583312988281, -1.74111133745986, 218, 20, 'PPL', 'P'),
(16732, 'Kingsford', 27.8797206878662, 0.486592920539644, -81.9733276367188, -1.4307044660768, 218, 12, 'PPL', 'P'),
(131585, 'Kingsford', 45.7949981689453, 0.79927349899287, -88.0719375610352, -1.53714528905093, 218, 27, 'PPL', 'P'),
(122962, 'Kingsford Heights', 41.4805603027344, 0.723972352854771, -86.6916732788086, -1.5130551327784, 218, 19, 'PPL', 'P'),
(81890, 'Kingsgate', 34.8819389343262, 0.608804683883594, -82.320556640625, -1.43676475545339, 218, 48, 'PPL', 'P'),
(178454, 'Kingsgate', 33.3805618286133, 0.582600710074841, -111.794441223145, -1.95118108477115, 218, 5, 'PPL', 'P'),
(204559, 'Kingsgate', 40.6563911437988, 0.709587887437953, -111.983329772949, -1.95447781188456, 218, 52, 'PPL', 'P'),
(207798, 'Kingsgate', 47.7272186279297, 0.832997107876544, -122.178329467773, -2.13241412379906, 218, 56, 'PPL', 'P'),
(9871, 'Kingsland', 33.8583297729492, 0.590939333763988, -92.2938919067383, -1.61083229325233, 218, 4, 'PPL', 'P'),
(16733, 'Kingsland', 26.4633293151855, 0.461872227589524, -80.1030578613281, -1.3980621005957, 218, 12, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(22395, 'Kingsland', 30.7997207641602, 0.537556536029459, -81.6900024414063, -1.42575950856475, 218, 13, 'PPL', 'P'),
(95321, 'Kingsland', 30.6580600738525, 0.535084090562943, -98.4402770996094, -1.71810695196376, 218, 51, 'PPL', 'P'),
(122963, 'Kingsland', 40.8300018310547, 0.712617965547218, -85.1772232055664, -1.48662299264325, 218, 19, 'PPL', 'P'),
(131587, 'Kingsland', 42.5888900756836, 0.743316356590616, -84.6516723632813, -1.47745040005875, 218, 27, 'PPL', 'P'),
(145532, 'Kingsland', 40.8063888549805, 0.712205841368528, -74.1113891601563, -1.29348775407156, 218, 37, 'PPL', 'P'),
(103371, 'Kingsland Acres', 37.4052810668945, 0.652845312251207, -77.4527816772461, -1.35180605509628, 218, 53, 'PPL', 'P'),
(16734, 'Kingsley', 29.9816703796387, 0.523278863372353, -81.9961090087891, -1.43110207602755, 218, 12, 'PPL', 'P'),
(36722, 'Kingsley', 38.2208290100098, 0.667079309066435, -85.6719436645508, -1.49525749352951, 218, 21, 'PPL', 'P'),
(48692, 'Kingsley', 39.264720916748, 0.68529865987394, -77.2788925170898, -1.34877111671803, 218, 25, 'PPL', 'P'),
(116323, 'Kingsley', 42.5883293151855, 0.74330656947361, -95.9672164916992, -1.67494390175435, 218, 16, 'PPL', 'P'),
(131589, 'Kingsley', 44.5847206115723, 0.778150170753716, -85.5358276367188, -1.4928818206791, 218, 27, 'PPL', 'P'),
(163347, 'Kingsley', 41.7597198486328, 0.728844606069071, -75.7525024414063, -1.32213058422758, 218, 45, 'PPL', 'P'),
(201072, 'Kingsley', 45.3413887023926, 0.79135652028331, -121.199440002441, -2.11532927961593, 218, 43, 'PPL', 'P'),
(16735, 'Kingsley Beach', 29.978889465332, 0.523230327261486, -81.9958267211914, -1.43109714917954, 218, 12, 'PPL', 'P'),
(136247, 'Kingsley Corner', 44.0783309936523, 0.769312004623097, -92.1141662597656, -1.60769548896238, 218, 28, 'PPL', 'P'),
(174777, 'Kingsley Corners', 43.1772193908691, 0.753584640226607, -89.4963912963867, -1.56200669677514, 218, 57, 'PPL', 'P'),
(9873, 'Kingsley Crossing', 34.976390838623, 0.610453180598353, -90.6152801513672, -1.58153499125842, 218, 4, 'PPL', 'P'),
(88294, 'Kingsley Hills', 36.5808296203613, 0.638455919986373, -82.4908294677734, -1.43973657691381, 218, 50, 'PPL', 'P'),
(88295, 'Kingsley Station', 35.9183311462402, 0.626893140323521, -83.9297180175781, -1.46484991967715, 218, 50, 'PPL', 'P'),
(16737, 'Kingsley Village', 29.9716701507568, 0.523104326452412, -82.0163879394531, -1.43145601013642, 218, 12, 'PPL', 'P'),
(155988, 'Kingsleys Corners', 41.2602806091309, 0.720127746926105, -82.0224990844727, -1.43156266973808, 218, 41, 'PPL', 'P'),
(191693, 'Kingsmill', 35.4883308410645, 0.619388219213623, -101.059173583984, -1.76381531838501, 218, 51, 'PPL', 'P'),
(191694, 'Kingsmill Camp', 35.4986114501953, 0.619567649692067, -101.042221069336, -1.7635194411879, 218, 51, 'PPL', 'P'),
(103373, 'Kingsmill On The James', 37.2405586242676, 0.649970363275439, -76.6758270263672, -1.33824563829976, 218, 53, 'PPL', 'P'),
(103374, 'Kingspoint', 37.2413902282715, 0.64998487750338, -76.7038879394531, -1.33873539362423, 218, 53, 'PPL', 'P'),
(88296, 'Kingsport', 36.5483283996582, 0.637888666674186, -82.5619430541992, -1.44097774313984, 218, 50, 'PPL', 'P'),
(48693, 'Kingstead Knolls', 39.2675018310547, 0.685347195984806, -77.2272186279297, -1.34786923721487, 218, 25, 'PPL', 'P'),
(3543, 'Kingston', 33.3666687011719, 0.582358229257589, -86.2319412231445, -1.5050312947301, 218, 2, 'PPL', 'P'),
(9875, 'Kingston', 35.0166702270508, 0.611156188547107, -93.3150024414063, -1.62865403410909, 218, 4, 'PPL', 'P'),
(22398, 'Kingston', 33.4799995422363, 0.584336225578218, -82.0791702270508, -1.43255176776694, 218, 13, 'PPL', 'P'),
(30247, 'Kingston', 39.3788909912109, 0.687291303580564, -85.3883285522461, -1.49030747601138, 218, 19, 'PPL', 'P'),
(36724, 'Kingston', 37.6502799987793, 0.657121350276465, -84.2416687011719, -1.4702944862097, 218, 21, 'PPL', 'P'),
(41615, 'Kingston', 32.1841697692871, 0.561719729494884, -93.7108306884766, -1.63556254029286, 218, 22, 'PPL', 'P'),
(48695, 'Kingston', 38.0744400024414, 0.66452433889564, -75.7283325195313, -1.32170873951091, 218, 25, 'PPL', 'P'),
(55692, 'Kingston', 39.6441688537598, 0.691921275714694, -94.038330078125, -1.6412784829405, 218, 29, 'PPL', 'P'),
(73119, 'Kingston', 39.4738883972168, 0.68894932109622, -82.9108276367188, -1.44706692781425, 218, 41, 'PPL', 'P'),
(76292, 'Kingston', 33.9986114501953, 0.593387710912152, -96.7194366455078, -1.68807262013817, 218, 42, 'PPL', 'P'),
(88297, 'Kingston', 35.8808288574219, 0.626238601906607, -84.5086135864258, -1.47495355337874, 218, 50, 'PPL', 'P'),
(95322, 'Kingston', 33.2527809143066, 0.580370512398981, -96.1763916015625, -1.67859469613469, 218, 51, 'PPL', 'P'),
(103376, 'Kingston', 37.3327789306641, 0.651579911259256, -79.9983291625977, -1.39623423998153, 218, 53, 'PPL', 'P'),
(109975, 'Kingston', 37.9736099243164, 0.662764522047316, -81.3047180175781, -1.4190350268123, 218, 58, 'PPL', 'P'),
(112437, 'Kingston', 31.4052791595459, 0.548125523842034, -91.2774963378906, -1.59309284407326, 218, 30, 'PPL', 'P'),
(116325, 'Kingston', 40.9775009155273, 0.715192310214943, -91.040283203125, -1.58895269384262, 218, 16, 'PPL', 'P'),
(120221, 'Kingston', 42.0997200012207, 0.734778728189012, -88.7588882446289, -1.54913484027846, 218, 18, 'PPL', 'P'),
(125177, 'Kingston', 41.9944381713867, 0.732941213615885, -70.7249984741211, -1.23438408684138, 218, 23, 'PPL', 'P'),
(131590, 'Kingston', 43.4144401550293, 0.757724923615299, -83.1858291625977, -1.45186660988885, 218, 27, 'PPL', 'P'),
(136248, 'Kingston', 45.1969413757324, 0.788835438837386, -94.3130569458008, -1.64607337132513, 218, 28, 'PPL', 'P'),
(144027, 'Kingston', 42.9363899230957, 0.749381373078135, -71.0538864135742, -1.24012426425494, 218, 36, 'PPL', 'P'),
(145533, 'Kingston', 40.3752784729004, 0.7046815457617, -74.6138916015625, -1.30225807617341, 218, 37, 'PPL', 'P'),
(150035, 'Kingston', 41.9269409179688, 0.731763164307689, -73.9977798461914, -1.29150489748194, 218, 40, 'PPL', 'P'),
(163349, 'Kingston', 40.2919387817383, 0.703226993753326, -79.3413925170898, -1.38476853254041, 218, 45, 'PPL', 'P'),
(169449, 'Kingston', 41.480281829834, 0.723967492585781, -71.523063659668, -1.24831295197471, 218, 47, 'PPL', 'P'),
(174778, 'Kingston', 43.6955604553223, 0.762631398449606, -89.1275024414063, -1.55556837168182, 218, 57, 'PPL', 'P'),
(188770, 'Kingston', 32.9169387817383, 0.574508961418744, -107.705558776855, -1.8798166233564, 218, 38, 'PPL', 'P'),
(190378, 'Kingston', 39.2099990844727, 0.68434358372801, -117.068893432617, -2.04323764206554, 218, 39, 'PPL', 'P'),
(192655, 'Kingston', 38.2083282470703, 0.66686112959413, -112.186943054199, -1.95803153404316, 218, 52, 'PPL', 'P'),
(193151, 'Kingston', 47.5491714477539, 0.829889598358585, -116.269721984863, -2.0292894690143, 218, 17, 'PPL', 'P'),
(196833, 'Kingston', 47.1297187805176, 0.822568768259038, -109.596672058105, -1.91282277664241, 218, 31, 'PPL', 'P'),
(201073, 'Kingston', 44.7838897705078, 0.781626328345569, -122.773063659668, -2.14279419362181, 218, 43, 'PPL', 'P'),
(207797, 'Kingston', 47.7988891601563, 0.834247994640554, -122.496940612793, -2.1379749373132, 218, 56, 'PPL', 'P'),
(190379, 'Kingston (historical)', 39.4900016784668, 0.689230550907333, -118.100563049316, -2.06124367366973, 218, 39, 'PPL', 'P'),
(155989, 'Kingston Center', 40.3247184753418, 0.703799107334502, -82.8805618286133, -1.44653868981203, 218, 41, 'PPL', 'P'),
(103377, 'Kingston Court', 37.2208290100098, 0.649626016546492, -80.0175018310547, -1.3965688661725, 218, 53, 'PPL', 'P'),
(41616, 'Kingston Estates', 30.5522193908691, 0.533236822162323, -91.1619415283203, -1.59107603217974, 218, 22, 'PPL', 'P'),
(48713, 'Kingston Estates', 39.1022186279297, 0.682462459892033, -76.4594421386719, -1.33446900955792, 218, 25, 'PPL', 'P'),
(71001, 'Kingston Estates', 39.9236106872559, 0.696798455777011, -74.9883270263672, -1.30879320717236, 218, 37, 'PPL', 'P'),
(48696, 'Kingston Heights', 39.207218170166, 0.684295047617143, -76.6616668701172, -1.3379984969506, 218, 25, 'PPL', 'P'),
(88298, 'Kingston Heights', 35.8886108398438, 0.626374423122201, -84.5355606079102, -1.47542386762725, 218, 50, 'PPL', 'P'),
(88299, 'Kingston Hills', 35.9144401550293, 0.626825229715724, -84.0408325195313, -1.46678923358294, 218, 50, 'PPL', 'P'),
(178455, 'Kingston Knolls Terrace', 32.228328704834, 0.562490448314353, -110.845001220703, -1.9346102306784, 218, 5, 'PPL', 'P'),
(48697, 'Kingston Landing', 38.7816696166992, 0.676867824232049, -75.9655609130859, -1.32584915605766, 218, 25, 'PPL', 'P'),
(112388, 'Kingston Manor', 38.3172187805176, 0.668761627927038, -76.4963912963867, -1.33511389401588, 218, 25, 'PPL', 'P'),
(120222, 'Kingston Mines', 40.5580596923828, 0.707871679852479, -89.7705612182617, -1.5667918646218, 218, 18, 'PPL', 'P'),
(48698, 'Kingston Riding', 39.5483283996582, 0.690248544234015, -76.8638916015625, -1.34152798434328, 218, 25, 'PPL', 'P'),
(125178, 'Kingston Shores', 41.9980583190918, 0.733004397112747, -70.7041702270508, -1.23402056535258, 218, 23, 'PPL', 'P'),
(88300, 'Kingston Springs', 36.1019401550293, 0.630097722063213, -87.1149978637695, -1.5204435405906, 218, 50, 'PPL', 'P'),
(169450, 'Kingston Station', 41.4838905334473, 0.724030476345562, -71.5625, -1.24900124595844, 218, 47, 'PPL', 'P'),
(88301, 'Kingston Woods', 35.9069404602051, 0.626694335348147, -84.0436096191406, -1.46683770311478, 218, 50, 'PPL', 'P'),
(48699, 'Kingstown', 39.204719543457, 0.684251438354293, -76.0516662597656, -1.32735197786079, 218, 25, 'PPL', 'P'),
(66104, 'Kingstown', 35.3511085510254, 0.616993238445315, -81.6125030517578, -1.42440688904709, 218, 33, 'PPL', 'P'),
(109971, 'Kingstown', 39.5794410705566, 0.690791562780283, -80.5922164916992, -1.40659952926022, 218, 58, 'PPL', 'P'),
(150038, 'Kingstown', 41.0094413757324, 0.715749776410124, -72.163330078125, -1.25948770906674, 218, 40, 'PPL', 'P'),
(81892, 'Kingstree', 33.6674995422363, 0.587608717925708, -79.8308334350586, -1.39331088805295, 218, 48, 'PPL', 'P'),
(48700, 'Kingsview Knolls', 39.1588897705078, 0.683451557920888, -77.289436340332, -1.34895514114935, 218, 25, 'PPL', 'P'),
(41617, 'Kingsville', 31.3622207641602, 0.547374013071927, -92.4113922119141, -1.61288306044975, 218, 22, 'PPL', 'P'),
(48701, 'Kingsville', 39.4486083984375, 0.688508101882621, -76.4180603027344, -1.33374676027029, 218, 25, 'PPL', 'P'),
(55695, 'Kingsville', 38.7430610656738, 0.676193977897231, -94.0697174072266, -1.64182629517673, 218, 29, 'PPL', 'P'),
(95323, 'Kingsville', 27.5155601501465, 0.480237120150601, -97.855827331543, -1.70790637919848, 218, 51, 'PPL', 'P'),
(103379, 'Kingsville', 37.2458305358887, 0.650062375491101, -78.4441680908203, -1.36910901217269, 218, 53, 'PPL', 'P'),
(109972, 'Kingsville', 38.9336090087891, 0.679519666887495, -80.0344390869141, -1.39686447705349, 218, 58, 'PPL', 'P'),
(155991, 'Kingsville', 41.8908309936523, 0.731132927235721, -80.6763916015625, -1.40806866207557, 218, 41, 'PPL', 'P'),
(163352, 'Kingsville', 41.1316719055176, 0.717883101601332, -79.2641677856445, -1.38342070671272, 218, 45, 'PPL', 'P'),
(182488, 'Kingsville', 38.6766700744629, 0.675035236506938, -120.874717712402, -2.10966180650013, 218, 6, 'PPL', 'P'),
(9876, 'Kingsville (historical)', 36.2841682434082, 0.633278202195041, -91.2205581665039, -1.5920990855125, 218, 4, 'PPL', 'P'),
(73120, 'Kingsville (historical)', 39.7466697692871, 0.693710254176955, -84.2816696166992, -1.47099263388947, 218, 41, 'PPL', 'P'),
(81893, 'Kingsville Heights', 34.3402786254883, 0.599350928067003, -80.0766677856445, -1.39760150688517, 218, 48, 'PPL', 'P'),
(204562, 'Kingsville Junction', 41.1605606079102, 0.718387304574711, -112.082778930664, -1.95621352712502, 218, 52, 'PPL', 'P'),
(155992, 'Kingsville On-the-Lake', 41.9233283996582, 0.731700113968881, -80.7030563354492, -1.40853404947606, 218, 41, 'PPL', 'P'),
(155994, 'Kingsway', 41.4174995422363, 0.722871734955268, -83.1355590820313, -1.45098923146772, 218, 41, 'PPL', 'P'),
(136251, 'Kingsway Estates', 44.4730606079102, 0.776201336047023, -93.8966674804688, -1.63880600418447, 218, 28, 'PPL', 'P'),
(3544, 'Kingsway Terrace', 33.5625, 0.585776130200597, -86.7441711425781, -1.51397139335144, 218, 2, 'PPL', 'P'),
(22401, 'Kingswood', 33.4180603027344, 0.583255181912728, -84.4480590820313, -1.47389667790015, 218, 13, 'PPL', 'P'),
(36725, 'Kingswood', 37.7188911437988, 0.65831884066062, -86.4086074829102, -1.50811470264019, 218, 21, 'PPL', 'P'),
(48702, 'Kingswood', 39.4786109924316, 0.689031745931958, -76.3872222900391, -1.33320853541398, 218, 25, 'PPL', 'P'),
(66105, 'Kingswood', 35.8447189331055, 0.62560836483464, -80.8802795410156, -1.41162717792413, 218, 33, 'PPL', 'P'),
(81894, 'Kingswood', 34.0541687011719, 0.59435736786505, -81.0922164916992, -1.4153261755202, 218, 48, 'PPL', 'P'),
(88302, 'Kingswood', 36.1977806091309, 0.631770453543892, -83.2383270263672, -1.45278287046189, 218, 50, 'PPL', 'P'),
(95324, 'Kingswood', 32.5713882446289, 0.568477966814151, -96.9744415283203, -1.69252329495191, 218, 51, 'PPL', 'P'),
(103381, 'Kingswood', 37.6866683959961, 0.657756447617422, -78.9466705322266, -1.37787933427454, 218, 53, 'PPL', 'P'),
(66109, 'Kingswood Apartments', 35.2994384765625, 0.616091425521187, -81.539436340332, -1.42313163435911, 218, 33, 'PPL', 'P'),
(48703, 'Kingswood Common', 39.3308296203613, 0.686452474416217, -76.7655563354492, -1.33981171017878, 218, 25, 'PPL', 'P'),
(103382, 'Kingswood Court', 37.6838912963867, 0.657707978085583, -77.4297180175781, -1.35140351829751, 218, 53, 'PPL', 'P'),
(9877, 'Kingswood Estates', 36.3916702270508, 0.635154465762029, -92.3269424438477, -1.61140913394444, 218, 4, 'PPL', 'P'),
(48704, 'Kingswood Estates', 38.560001373291, 0.672998983537463, -76.5638885498047, -1.33629194332408, 218, 25, 'PPL', 'P'),
(163353, 'Kingswood Estates', 40.8638916015625, 0.713209453625324, -75.4716720581055, -1.31722916939935, 218, 45, 'PPL', 'P'),
(182489, 'Kingswood Estates', 39.2552795410156, 0.685133876781491, -120.0625, -2.09548593317569, 218, 6, 'PPL', 'P'),
(142171, 'Kingswood Plaza', 40.5875015258789, 0.708385536784809, -98.3605575561523, -1.71671558345225, 218, 35, 'PPL', 'P'),
(81896, 'Kingswood Terrace', 34.5563888549805, 0.603122763118882, -82.6488876342773, -1.44249521232897, 218, 48, 'PPL', 'P'),
(3546, 'Kingtown', 34.9052810668945, 0.609212080951349, -87.383056640625, -1.5251220488356, 218, 2, 'PPL', 'P'),
(9878, 'Kingtown', 34.4966697692871, 0.602080468447253, -90.8913879394531, -1.58635398125092, 218, 4, 'PPL', 'P'),
(22403, 'Kingtown', 34.975830078125, 0.610443393481347, -84.378059387207, -1.47267495275007, 218, 13, 'PPL', 'P'),
(103383, 'Kingtown', 36.6022186279297, 0.638829228592174, -82.1675033569336, -1.43409347172198, 218, 53, 'PPL', 'P'),
(145534, 'Kingtown', 40.5936088562012, 0.70849212980744, -74.9466705322266, -1.30806616419476, 218, 37, 'PPL', 'P'),
(163354, 'Kingtown', 40.2402801513672, 0.70232538056628, -77.0755615234375, -1.34522232140744, 218, 45, 'PPL', 'P'),
(182490, 'Kingvale', 39.3211097717285, 0.686282831054779, -120.427780151367, -2.10186127450923, 218, 6, 'PPL', 'P'),
(163355, 'Kingview', 40.0986099243164, 0.699852768652195, -79.5763931274414, -1.38887006693524, 218, 45, 'PPL', 'P'),
(3547, 'Kingville', 33.6674995422363, 0.587608717925708, -88.0405578613281, -1.53659760997275, 218, 2, 'PPL', 'P'),
(81897, 'Kingville', 33.8055610656738, 0.590018346080011, -80.6977767944336, -1.40844190410234, 218, 48, 'PPL', 'P'),
(103384, 'Kingwood', 37.1333312988281, 0.648098893398413, -77.3586120605469, -1.35016248522954, 218, 53, 'PPL', 'P'),
(109973, 'Kingwood', 39.4716682434082, 0.68891057210236, -79.6836090087891, -1.39074133707518, 218, 58, 'PPL', 'P'),
(145535, 'Kingwood', 40.4697189331055, 0.706329842739377, -75.0194396972656, -1.30933622571862, 218, 37, 'PPL', 'P'),
(163356, 'Kingwood', 40.2625007629395, 0.702713203400022, -76.9555587768555, -1.34312787836815, 218, 45, 'PPL', 'P'),
(66110, 'Kingwood (historical)', 35.1719398498535, 0.613866154693344, -80.7144393920898, -1.40873272129338, 218, 33, 'PPL', 'P'),
(9879, 'Kingwood Addition', 34.9322204589844, 0.609682262041802, -92.0019378662109, -1.60573673398063, 218, 4, 'PPL', 'P'),
(88303, 'Kingwood Estates', 35.2125015258789, 0.614574089490114, -84.8375015258789, -1.4806937307923, 218, 50, 'PPL', 'P'),
(142172, 'Kingwood Estates', 40.898609161377, 0.713815389352345, -98.3333282470703, -1.71624034235572, 218, 35, 'PPL', 'P'),
(201074, 'Kingwood Park (historical)', 44.936939239502, 0.784297545497946, -123.065559387207, -2.14789920711538, 218, 43, 'PPL', 'P'),
(48705, 'Kinhart Manor', 39.6022186279297, 0.691189106152004, -76.5152816772461, -1.33544359335883, 218, 25, 'PPL', 'P'),
(194273, 'Kinikinik', 40.7125015258789, 0.710567198349802, -105.737503051758, -1.84546757109073, 218, 7, 'PPL', 'P'),
(190381, 'Kinkaid', 38.5449981689453, 0.672737128223281, -118.393890380859, -2.06636320139124, 218, 39, 'PPL', 'P'),
(88304, 'Kinkaid (historical)', 35.8838882446289, 0.626291998286463, -84.1055603027344, -1.46791894651735, 218, 50, 'PPL', 'P'),
(88305, 'Kinkaid Estates', 36.5902786254883, 0.638620836236876, -82.64111328125, -1.44235952427143, 218, 50, 'PPL', 'P'),
(95326, 'Kinkler', 29.5338897705078, 0.515463617416434, -96.8988876342773, -1.69120463073816, 218, 51, 'PPL', 'P'),
(145537, 'Kinkora', 40.1175003051758, 0.700182467995147, -74.7555618286133, -1.30473068808749, 218, 37, 'PPL', 'P'),
(163357, 'Kinkora Heights', 40.3730583190918, 0.704642796767839, -77.0247192382813, -1.34433495613223, 218, 45, 'PPL', 'P'),
(22404, 'Kinlaw', 30.8444404602051, 0.538337041965934, -81.6758270263672, -1.42551210089948, 218, 13, 'PPL', 'P'),
(178456, 'Kinlichee', 35.7561111450195, 0.624061867189631, -109.425003051758, -1.90982658725802, 218, 5, 'PPL', 'P'),
(55697, 'Kinloch', 38.7405586242676, 0.676150302055354, -90.3252792358398, -1.57647352044867, 218, 29, 'PPL', 'P'),
(705, 'Kinlock', 33.309440612793, 0.581359410690755, -90.7074966430664, -1.58314447266321, 218, 30, 'PPL', 'P'),
(163358, 'Kinlock', 40.5497207641602, 0.707726138098906, -79.7366714477539, -1.39166745134426, 218, 45, 'PPL', 'P'),
(3549, 'Kinlock (historical)', 34.3133316040039, 0.598880613818495, -87.5083312988281, -1.52730850409056, 218, 2, 'PPL', 'P'),
(27635, 'Kinmundy', 38.7733306884766, 0.676722282478476, -88.8466720581055, -1.55066695685359, 218, 18, 'PPL', 'P'),
(48706, 'Kinna', 39.3574981689453, 0.686917928395735, -77.3694381713867, -1.35035143650888, 218, 25, 'PPL', 'P'),
(60494, 'Kinnaird (historical)', 31.8374996185303, 0.555669193945792, -90.1605606079102, -1.57359863805193, 218, 30, 'PPL', 'P'),
(48707, 'Kinnairds Point', 39.3300018310547, 0.686438026767303, -76.1333312988281, -1.3287773016762, 218, 25, 'PPL', 'P'),
(209547, 'Kinnear', 43.1519393920898, 0.753143421013008, -108.676940917969, -1.8967704400139, 218, 59, 'PPL', 'P'),
(182491, 'Kinneloa Mesa', 34.1758308410645, 0.596480772781198, -118.08332824707, -2.0609428696246, 218, 6, 'PPL', 'P'),
(145538, 'Kinnelon', 41.0016708374023, 0.715614154931612, -74.3675003051758, -1.29795773680321, 218, 37, 'PPL', 'P'),
(131592, 'Kinneville', 42.4663887023926, 0.741178304288473, -84.5711135864258, -1.47604438416124, 218, 27, 'PPL', 'P'),
(131593, 'Kinney', 43.0158309936523, 0.750767881320657, -85.7683334350586, -1.49693981239011, 218, 27, 'PPL', 'P'),
(136256, 'Kinney', 47.5141716003418, 0.829278735783548, -92.7305603027344, -1.61845359450186, 218, 28, 'PPL', 'P'),
(163359, 'Kinney', 41.9900016784668, 0.732863782207191, -77.9447174072266, -1.36039195329264, 218, 45, 'PPL', 'P'),
(188771, 'Kinney', 35.0102806091309, 0.611044668676459, -106.660278320313, -1.86157303778298, 218, 38, 'PPL', 'P'),
(204564, 'Kinney and Gourlays Improved City Plat', 40.7936096191406, 0.711982801627234, -111.915832519531, -1.95329976257636, 218, 52, 'PPL', 'P'),
(204563, 'Kinney Estates', 40.5361099243164, 0.707488584129671, -111.922218322754, -1.95341121586798, 218, 52, 'PPL', 'P'),
(178457, 'Kinney Junction', 33.9172210693359, 0.591967180786704, -109.773330688477, -1.91590605139445, 218, 5, 'PPL', 'P'),
(195190, 'Kinney Point Summer Home Area', 44.6386108398438, 0.779090732671705, -115.673606872559, -2.01888529758369, 218, 17, 'PPL', 'P'),
(127880, 'Kinney Shores', 43.4930610656738, 0.759097117366962, -70.3880615234375, -1.22850342768032, 218, 26, 'PPL', 'P'),
(188772, 'Kinney Wells', 33.8711090087891, 0.591162373505282, -106.749443054199, -1.86312925596597, 218, 38, 'PPL', 'P'),
(88306, 'Kinneys', 36.5283317565918, 0.637539659413331, -86.945556640625, -1.51748623335813, 218, 50, 'PPL', 'P'),
(113611, 'Kinneytown', 41.3666687011719, 0.721984569417136, -73.0924987792969, -1.27570476220867, 218, 8, 'PPL', 'P'),
(207799, 'Kinneyville (historical)', 46.2077789306641, 0.806477882373753, -119.791107177734, -2.09074923486088, 218, 56, 'PPL', 'P'),
(36727, 'Kinniconick', 38.521110534668, 0.672320210354629, -83.3380584716797, -1.45452351255036, 218, 21, 'PPL', 'P'),
(73121, 'Kinnikinnick', 39.4258308410645, 0.6881105585109, -82.9527816772461, -1.44779916395597, 218, 41, 'PPL', 'P'),
(36728, 'Kino', 36.9477806091309, 0.64486042293385, -85.7774963378906, -1.49709973521357, 218, 21, 'PPL', 'P'),
(103385, 'Kino', 37.9044418334961, 0.661557311125183, -76.9416732788086, -1.34288553070895, 218, 53, 'PPL', 'P'),
(178460, 'Kino', 32.3347206115723, 0.564347337384411, -111.061393737793, -1.9383869925783, 218, 5, 'PPL', 'P'),
(204566, 'Kino Heights', 40.6127815246582, 0.708826755998408, -111.811668395996, -1.95148175565822, 218, 52, 'PPL', 'P'),
(178458, 'Kino Springs', 31.3630599975586, 0.547388660457922, -110.809440612793, -1.93398958098636, 218, 5, 'PPL', 'P'),
(195191, 'Kinport', 42.7544403076172, 0.746205753215297, -111.940826416016, -1.95373598836292, 218, 17, 'PPL', 'P'),
(116326, 'Kinross', 41.4608306884766, 0.723628006125823, -91.9866714477539, -1.60547028471356, 218, 16, 'PPL', 'P'),
(131596, 'Kinross', 46.2750015258789, 0.807651137991987, -84.5147171020508, -1.47506007982235, 218, 27, 'PPL', 'P'),
(103386, 'Kinsale', 38.0294418334961, 0.663738972690176, -76.5811080932617, -1.33659248105309, 218, 53, 'PPL', 'P'),
(3550, 'Kinsey', 31.2988891601563, 0.546268668061489, -85.3444366455078, -1.48954141772382, 218, 2, 'PPL', 'P'),
(16738, 'Kinsey', 27.3400001525879, 0.477173020158411, -81.8949966430664, -1.42933733233121, 218, 12, 'PPL', 'P'),
(55698, 'Kinsey', 38.0311088562012, 0.663768067725085, -90.3000030517578, -1.5760323678141, 218, 29, 'PPL', 'P'),
(73122, 'Kinsey', 39.853889465332, 0.695581590895926, -84.2927780151367, -1.47118651201683, 218, 41, 'PPL', 'P'),
(122964, 'Kinsey', 41.0961112976074, 0.717262451909289, -85.7050018310547, -1.49583446737967, 218, 19, 'PPL', 'P'),
(196834, 'Kinsey', 46.5708312988281, 0.812814341555378, -105.656387329102, -1.84405183465524, 218, 31, 'PPL', 'P'),
(22405, 'Kinseytown', 34.5880584716797, 0.603675502203128, -83.6505584716797, -1.45997766646285, 218, 13, 'PPL', 'P'),
(81898, 'Kinsler', 33.9416694641113, 0.592393885772362, -81.0788879394531, -1.41509354839898, 218, 48, 'PPL', 'P'),
(32931, 'Kinsley', 37.9230613708496, 0.6618822833572, -99.4094390869141, -1.7350220196274, 218, 20, 'PPL', 'P'),
(95327, 'Kinsloe', 32.4336090087891, 0.566073265507864, -94.8241729736328, -1.65499402887051, 218, 51, 'PPL', 'P'),
(120225, 'Kinsman', 41.1897201538086, 0.718896234659025, -88.5694427490234, -1.54582839262708, 218, 18, 'PPL', 'P'),
(155996, 'Kinsman', 41.4438896179199, 0.723332328665797, -80.5888900756836, -1.40654147234846, 218, 41, 'PPL', 'P'),
(125181, 'Kinsman Corner', 42.6375007629395, 0.744164773134888, -70.9749984741211, -1.23874740997136, 218, 23, 'PPL', 'P'),
(22406, 'Kinstle', 31.2244396209717, 0.544969278476126, -81.4922180175781, -1.42230751915978, 218, 13, 'PPL', 'P'),
(3551, 'Kinston', 31.2158298492432, 0.544819009611618, -86.1711120605469, -1.50396962556154, 218, 2, 'PPL', 'P'),
(66112, 'Kinston', 35.2625007629395, 0.615446740800306, -77.5819396972656, -1.35406028780098, 218, 33, 'PPL', 'P'),
(14058, 'Kinston Acres', 39.6205596923828, 0.691509218115032, -75.6591720581055, -1.32050166174684, 218, 10, 'PPL', 'P'),
(76293, 'Kinta', 35.1191711425781, 0.612945167009367, -95.2375030517578, -1.66220799963132, 218, 42, 'PPL', 'P'),
(178459, 'Kinter', 32.7572212219238, 0.571721364126731, -114.397216796875, -1.99660808822323, 218, 5, 'PPL', 'P'),
(163361, 'Kinter Crossing', 40.6063919067383, 0.708715236127761, -78.8630599975586, -1.37642005515523, 218, 45, 'PPL', 'P'),
(3552, 'Kinterbish', 32.3325004577637, 0.56430858839055, -88.3127822875977, -1.54134882251551, 218, 2, 'PPL', 'P'),
(163362, 'Kintersburg', 40.7152786254883, 0.710615667881642, -79.0791702270508, -1.38019189020711, 218, 45, 'PPL', 'P'),
(163363, 'Kintnersville', 40.5569381713867, 0.707852105618467, -75.1800003051758, -1.31213853697566, 218, 45, 'PPL', 'P'),
(9880, 'Kinton', 35.142219543457, 0.613347437492024, -90.6336135864258, -1.5818549700634, 218, 4, 'PPL', 'P'),
(201075, 'Kinton', 45.4233283996582, 0.792786637788682, -122.876670837402, -2.14460248000197, 218, 43, 'PPL', 'P'),
(66115, 'Kinton Fork', 36.3536109924316, 0.634490206807136, -78.6311111450195, -1.3723717839822, 218, 33, 'PPL', 'P'),
(140330, 'Kintyre', 46.5497207641602, 0.812445893218566, -99.9491729736328, -1.74444215303522, 218, 34, 'PPL', 'P'),
(95329, 'Kinwood', 29.9116706848145, 0.522057138222279, -95.3022232055664, -1.66333757940768, 218, 51, 'PPL', 'P'),
(193706, 'Kinyon', 41.2713890075684, 0.720321625053463, -121.893058776855, -2.1274352109831, 218, 6, 'PPL', 'P'),
(88309, 'Kinzel Springs', 35.686939239502, 0.62285458968847, -83.79638671875, -1.46252284951664, 218, 50, 'PPL', 'P'),
(55699, 'Kinzer', 36.7602806091309, 0.64158793058636, -90.3338928222656, -1.57662385589221, 218, 29, 'PPL', 'P'),
(78563, 'Kinzers', 39.9983291625977, 0.698102539183796, -76.0619430541992, -1.32753134176021, 218, 45, 'PPL', 'P'),
(163364, 'Kinzua (historical)', 41.8633308410645, 0.730652959028262, -78.961669921875, -1.37814112300969, 218, 45, 'PPL', 'P'),
(201076, 'Kinzua (historical)', 44.9897193908691, 0.785218732919004, -120.057777404785, -2.09540350833995, 218, 43, 'PPL', 'P'),
(163365, 'Kinzua Beach', 41.8530616760254, 0.730473728286899, -78.9550018310547, -1.37802474287006, 218, 45, 'PPL', 'P'),
(163368, 'Kinzua Heights', 41.8686103820801, 0.730745104401978, -78.9355621337891, -1.37768545614718, 218, 45, 'PPL', 'P'),
(22407, 'Kiokee', 33.5944404602051, 0.586333596395778, -82.220832824707, -1.43502424652297, 218, 13, 'PPL', 'P'),
(95328, 'Kiomatia', 33.8891716003418, 0.59147762519932, -95.2227783203125, -1.66195100458613, 218, 51, 'PPL', 'P'),
(207800, 'Kiona', 46.2497215270996, 0.807209918778388, -119.476387023926, -2.08525633195453, 218, 56, 'PPL', 'P'),
(60497, 'Kioto', 31.163890838623, 0.543912502866069, -90.2455596923828, -1.57508215193716, 218, 30, 'PPL', 'P'),
(73123, 'Kiousville', 39.7972183227539, 0.694592492867071, -83.2947235107422, -1.45376717480078, 218, 41, 'PPL', 'P'),
(3553, 'Kiowa', 33.7991714477539, 0.589906826209364, -86.6672210693359, -1.51262836121371, 218, 2, 'PPL', 'P'),
(32935, 'Kiowa', 37.017219543457, 0.646072360966917, -98.4850006103516, -1.71888752447926, 218, 20, 'PPL', 'P'),
(76294, 'Kiowa', 34.7205581665039, 0.605988058135699, -95.8988876342773, -1.67375133821822, 218, 42, 'PPL', 'P'),
(186921, 'Kiowa', 39.3472213745117, 0.686738564496318, -104.463890075684, -1.82323883126211, 218, 7, 'PPL', 'P'),
(188773, 'Kiowa', 36.6538887023926, 0.639731041516302, -104.107223510742, -1.8170138253721, 218, 38, 'PPL', 'P'),
(196835, 'Kiowa', 48.547779083252, 0.847318589533581, -113.269996643066, -1.97693438514443, 218, 31, 'PPL', 'P'),
(88307, 'Kiowa Subdivision', 35.8597183227539, 0.625870153569794, -85.0833282470703, -1.48498421646647, 218, 50, 'PPL', 'P'),
(188774, 'Kiowa Village', 36.5791702270508, 0.638426958109518, -105.596389770508, -1.84300467971462, 218, 38, 'PPL', 'P'),
(41619, 'Kipling', 30.7525005340576, 0.53673238754062, -93.0888900756836, -1.62470762884775, 218, 22, 'PPL', 'P'),
(60495, 'Kipling', 32.6722183227539, 0.570237783662475, -88.6483306884766, -1.54720524691065, 218, 30, 'PPL', 'P'),
(66116, 'Kipling', 35.4797210693359, 0.619237950349115, -78.8213882446289, -1.37569274586153, 218, 33, 'PPL', 'P'),
(73124, 'Kipling', 39.9961090087891, 0.698063790189935, -81.5008316040039, -1.42245785460332, 218, 41, 'PPL', 'P'),
(131595, 'Kipling', 45.8733291625977, 0.800640632738462, -87.0116729736328, -1.51864018105846, 218, 27, 'PPL', 'P'),
(211929, 'Kipnuk', 59.9388885498047, 1.04613095518002, -164.041397094727, -2.86306248887444, 218, 1, 'PPL', 'P'),
(32939, 'Kipp', 38.7838897705078, 0.676906573225909, -97.4541702270508, -1.70089614026107, 218, 20, 'PPL', 'P'),
(195192, 'Kippen', 46.3111114501953, 0.808281375063954, -116.548606872559, -2.03415692853864, 218, 17, 'PPL', 'P'),
(196836, 'Kippen', 48.7461090087891, 0.850780099739439, -111.600280761719, -1.94779234544208, 218, 31, 'PPL', 'P'),
(142179, 'Kipples Trailer Court', 42.4577789306641, 0.741028035423965, -98.647216796875, -1.72171873103412, 218, 35, 'PPL', 'P'),
(150039, 'Kipps', 41.4255599975586, 0.723012416439852, -74.2949981689453, -1.29669233581125, 218, 40, 'PPL', 'P'),
(163367, 'Kipps Run', 40.9458312988281, 0.714639571130697, -76.6594390869141, -1.33795961479869, 218, 45, 'PPL', 'P'),
(155998, 'Kipton', 41.2680587768555, 0.720263501562672, -82.3022232055664, -1.43644477664842, 218, 41, 'PPL', 'P'),
(103387, 'Kiptopeke', 37.1377792358398, 0.648176524544189, -75.9669418334961, -1.32587325766552, 218, 53, 'PPL', 'P'),
(210439, 'Kipu', 21.9541702270508, 0.383172555005347, -159.426666259766, -2.78252024171106, 218, 15, 'PPL', 'P'),
(210444, 'Kipuka Nahuaopala', 19.045280456543, 0.332402850932404, -155.618057250977, -2.71604747458658, 218, 15, 'PPL', 'P'),
(9881, 'Kirby', 34.2502784729004, 0.597780129077047, -93.64111328125, -1.6343457419908, 218, 4, 'PPL', 'P'),
(22408, 'Kirby', 32.5111083984375, 0.567425885025515, -82.334716796875, -1.43701189680255, 218, 13, 'PPL', 'P'),
(30249, 'Kirby', 39.1366691589355, 0.683063735087145, -86.6100006103516, -1.51162967580493, 218, 19, 'PPL', 'P'),
(55707, 'Kirby', 39.8455581665039, 0.695436182300408, -92.1144409179688, -1.60770028265234, 218, 29, 'PPL', 'P'),
(60496, 'Kirby', 31.5113906860352, 0.549977519353588, -90.980827331543, -1.58791499312387, 218, 30, 'PPL', 'P'),
(78564, 'Kirby', 39.8027801513672, 0.694689565088804, -80.1172180175781, -1.39830924194486, 218, 45, 'PPL', 'P'),
(88308, 'Kirby', 36.478889465332, 0.636676728641118, -85.908332824707, -1.49938326269026, 218, 50, 'PPL', 'P'),
(95330, 'Kirby', 29.4630603790283, 0.514227411327933, -98.3852767944336, -1.71714701554884, 218, 51, 'PPL', 'P'),
(109976, 'Kirby', 39.1827812194824, 0.683868542368567, -78.7263870239258, -1.37403466176684, 218, 58, 'PPL', 'P'),
(155999, 'Kirby', 40.813060760498, 0.712322288087192, -83.4186096191406, -1.45592939528982, 218, 41, 'PPL', 'P'),
(174784, 'Kirby', 44.0905609130859, 0.769525456984467, -90.5391693115234, -1.58020660650669, 218, 57, 'PPL', 'P'),
(196837, 'Kirby', 45.3325004577637, 0.791201391149813, -106.981109619141, -1.86717260029098, 218, 31, 'PPL', 'P'),
(207801, 'Kirby', 46.5133285522461, 0.811810729298582, -117.389717102051, -2.04883707141548, 218, 56, 'PPL', 'P'),
(209548, 'Kirby', 43.8044395446777, 0.764531697045432, -108.18083190918, -1.88811170436173, 218, 59, 'PPL', 'P'),
(125180, 'Kirby Corner', 41.6027793884277, 0.726105478308897, -71.0861129760742, -1.24068672387716, 218, 23, 'PPL', 'P'),
(172179, 'Kirby Corner', 44.4550018310547, 0.775886150932012, -73.1236114501953, -1.27624778075493, 218, 55, 'PPL', 'P'),
(3557, 'Kirby Creek (historical)', 34.899169921875, 0.609105421349691, -85.9533309936523, -1.50016862889572, 218, 2, 'PPL', 'P'),
(48709, 'Kirby Landing', 39.2491683959961, 0.685027217179833, -75.8758316040039, -1.32428308417864, 218, 25, 'PPL', 'P'),
(66118, 'Kirbys Crossing', 35.6133308410645, 0.621569880778616, -78.0905609130859, -1.36293740266254, 218, 33, 'PPL', 'P'),
(71002, 'Kirbys Mill', 39.9166717529297, 0.69667734852644, -74.8047180175781, -1.30558862543266, 218, 37, 'PPL', 'P'),
(145540, 'Kirbys Mills', 40.1286087036133, 0.700376346122505, -74.539436340332, -1.30095858671951, 218, 37, 'PPL', 'P'),
(36729, 'Kirbyton', 36.8405609130859, 0.642989086214878, -88.8638916015625, -1.5509674945826, 218, 21, 'PPL', 'P'),
(109977, 'Kirbyton', 38.0986099243164, 0.664946183612309, -81.6133270263672, -1.42442127011698, 218, 58, 'PPL', 'P'),
(3554, 'Kirbytown', 34.5047187805176, 0.602220950194754, -86.1286087036133, -1.5032278020399, 218, 2, 'PPL', 'P'),
(103388, 'Kirbytown', 37.6144409179688, 0.656495840315433, -77.2677764892578, -1.34857710543261, 218, 53, 'PPL', 'P'),
(55700, 'Kirbyville', 36.6230583190918, 0.639192949818052, -93.1638870239258, -1.62601657252353, 218, 29, 'PPL', 'P'),
(73125, 'Kirbyville', 39.1263885498047, 0.682884304608701, -83.9772186279297, -1.46567896172449, 218, 41, 'PPL', 'P'),
(95331, 'Kirbyville', 30.6602802276611, 0.535122839556803, -93.8925018310547, -1.63873329988671, 218, 51, 'PPL', 'P'),
(163369, 'Kirbyville', 40.4741706848145, 0.70640754046418, -75.85888671875, -1.32398734013959, 218, 45, 'PPL', 'P'),
(163370, 'Kirchberg', 40.5897216796875, 0.70842428577867, -75.3152770996094, -1.31449956244007, 218, 45, 'PPL', 'P'),
(174783, 'Kirchhayn', 43.2941703796387, 0.755625820044098, -88.0950012207031, -1.53754782584969, 218, 57, 'PPL', 'P'),
(103389, 'Kire', 37.439998626709, 0.653451247978227, -80.519172668457, -1.4053246740464, 218, 53, 'PPL', 'P'),
(3555, 'Kirewakra', 30.4333305358887, 0.531161820198988, -88.1763916015625, -1.53896835597514, 218, 2, 'PPL', 'P'),
(3556, 'Kirk', 33.2413902282715, 0.580171707423607, -87.8874969482422, -1.53392619308329, 218, 2, 'PPL', 'P'),
(22409, 'Kirk', 33.1977806091309, 0.579410575984062, -85.1505584716797, -1.48615760524276, 218, 13, 'PPL', 'P'),
(36730, 'Kirk', 37.7238883972168, 0.65840605918632, -86.4786071777344, -1.50933642779027, 218, 21, 'PPL', 'P'),
(55701, 'Kirk', 36.2541694641113, 0.632754624724731, -89.970832824707, -1.57028726355253, 218, 29, 'PPL', 'P'),
(88310, 'Kirk', 35.1019401550293, 0.61264442954327, -89.6252822875977, -1.56425626894793, 218, 50, 'PPL', 'P'),
(95332, 'Kirk', 31.5869407653809, 0.551296116988314, -96.727783203125, -1.6882182950498, 218, 51, 'PPL', 'P'),
(109978, 'Kirk', 37.8941688537598, 0.661378013804794, -82.2433319091797, -1.4354169296257, 218, 58, 'PPL', 'P'),
(136254, 'Kirk', 47.4152793884277, 0.827552741081067, -92.6624984741211, -1.61726569149763, 218, 28, 'PPL', 'P'),
(150041, 'Kirk', 42.6047210693359, 0.743592659553711, -75.6416702270508, -1.3201961971698, 218, 40, 'PPL', 'P'),
(186923, 'Kirk', 39.6133308410645, 0.691383050858389, -102.591110229492, -1.79055265678107, 218, 7, 'PPL', 'P'),
(201077, 'Kirk', 42.747501373291, 0.746084645964726, -121.828330993652, -2.12630549804869, 218, 43, 'PPL', 'P'),
(202276, 'Kirk', 44.3430595397949, 0.773932389377303, -103.793060302734, -1.81153064300374, 218, 49, 'PPL', 'P'),
(103390, 'Kirk O''Cliff', 38.1261100769043, 0.665426151819769, -77.904167175293, -1.35968421823295, 218, 53, 'PPL', 'P'),
(48710, 'Kirk Woods', 39.7083282470703, 0.693041068374045, -78.1997222900391, -1.36484262810638, 218, 25, 'PPL', 'P'),
(73126, 'Kirkersville', 39.9594383239746, 0.697423766000961, -82.595832824707, -1.44156923121795, 218, 41, 'PPL', 'P'),
(48711, 'Kirkham', 38.7625007629395, 0.676533264620107, -76.1444396972656, -1.32897117980356, 218, 25, 'PPL', 'P'),
(3559, 'Kirkland', 33.8025016784668, 0.589964949700155, -87.896110534668, -1.53407652852683, 218, 2, 'PPL', 'P'),
(9882, 'Kirkland', 33.4152793884277, 0.583206645801861, -92.813606262207, -1.61990301992514, 218, 4, 'PPL', 'P'),
(22412, 'Kirkland', 31.3080596923828, 0.546428724043003, -82.908332824707, -1.44702338513043, 218, 13, 'PPL', 'P'),
(66119, 'Kirkland', 34.2999992370605, 0.59864792011825, -77.788330078125, -1.35766247949142, 218, 33, 'PPL', 'P'),
(81899, 'Kirkland', 34.2961082458496, 0.598580009510453, -80.6113891601563, -1.40693415545119, 218, 48, 'PPL', 'P'),
(88312, 'Kirkland', 35.8072204589844, 0.624953892996753, -86.6627807617188, -1.51255086322599, 218, 50, 'PPL', 'P'),
(120227, 'Kirkland', 42.0924987792969, 0.734652694090424, -88.8511123657227, -1.55074445484131, 218, 18, 'PPL', 'P'),
(150042, 'Kirkland', 43.0777816772461, 0.75184912472323, -75.3836135864258, -1.31569225913426, 218, 40, 'PPL', 'P'),
(163371, 'Kirkland', 40.0099983215332, 0.698306204428159, -75.600830078125, -1.31948340210404, 218, 45, 'PPL', 'P'),
(178461, 'Kirkland', 34.4174995422363, 0.600698687315665, -112.711387634277, -1.96718481870976, 218, 5, 'PPL', 'P'),
(191696, 'Kirkland', 34.3791694641113, 0.600029701249837, -100.061111450195, -1.74639584801091, 218, 51, 'PPL', 'P'),
(194275, 'Kirkland', 40.1877784729004, 0.701409053414211, -105.015281677246, -1.83286243017722, 218, 7, 'PPL', 'P'),
(207802, 'Kirkland', 47.6816711425781, 0.832202154291155, -122.207496643066, -2.13292318704143, 218, 56, 'PPL', 'P'),
(66120, 'Kirkland (historical)', 35.3402786254883, 0.616804220586947, -80.5977783203125, -1.40669660148196, 218, 33, 'PPL', 'P'),
(22411, 'Kirkland Acres', 33.5972213745117, 0.586382132506644, -83.9527816772461, -1.46525245647591, 218, 13, 'PPL', 'P'),
(178462, 'Kirkland Junction', 34.3691711425781, 0.59985519761941, -112.664436340332, -1.96636536404234, 218, 5, 'PPL', 'P'),
(3560, 'Kirklands Crossroads', 31.4025001525879, 0.54807702102068, -85.414436340332, -1.49076314287389, 218, 2, 'PPL', 'P'),
(81900, 'Kirkley Mill', 34.4977798461914, 0.602099842944183, -80.5124969482422, -1.40520816074871, 218, 48, 'PPL', 'P'),
(60498, 'Kirklin', 31.047779083252, 0.541885970434573, -90.1158294677734, -1.57281793237838, 218, 30, 'PPL', 'P'),
(122966, 'Kirklin', 40.1933288574219, 0.701505925898862, -86.3605575561523, -1.50727607321293, 218, 19, 'PPL', 'P'),
(78565, 'Kirklyn', 39.9691696166992, 0.697593609099481, -75.2911071777344, -1.3140777177234, 218, 45, 'PPL', 'P'),
(116327, 'Kirkman', 41.7286109924316, 0.728301654101831, -95.2649993896484, -1.66268790125975, 218, 16, 'PPL', 'P'),
(66121, 'Kirkman Crossroad', 35.9683303833008, 0.627765791633713, -79.8794403076172, -1.39415923801819, 218, 33, 'PPL', 'P'),
(60499, 'Kirkman Landing', 33.8505592346191, 0.590803712285476, -89.7613906860352, -1.56663180864029, 218, 30, 'PPL', 'P'),
(36731, 'Kirkmansville', 37.0099983215332, 0.645946326868329, -87.2425003051758, -1.52266887799748, 218, 21, 'PPL', 'P'),
(48712, 'Kirkner Estates', 39.4963912963867, 0.68934207077798, -76.9394378662109, -1.34284651539898, 218, 25, 'PPL', 'P'),
(81901, 'Kirkover Hills', 34.2666702270508, 0.598066219157149, -80.6305618286133, -1.40726878164216, 218, 48, 'PPL', 'P'),
(122968, 'Kirkpatrick', 40.2063903808594, 0.701733892488173, -86.8191680908203, -1.51528033702721, 218, 19, 'PPL', 'P'),
(156000, 'Kirkpatrick', 40.6886100769043, 0.710150213902123, -83.0086135864258, -1.44877361459883, 218, 41, 'PPL', 'P'),
(3562, 'Kirkpatrick Landing', 32.6188888549805, 0.569307008861492, -87.8544387817383, -1.53334921923313, 218, 2, 'PPL', 'P'),
(3561, 'Kirks Grove', 34.1902809143066, 0.596732974136428, -85.4569396972656, -1.49150496639553, 218, 2, 'PPL', 'P'),
(41620, 'Kirks Landing', 31.8644409179688, 0.556139408325759, -91.5736083984375, -1.59826097448467, 218, 22, 'PPL', 'P'),
(78566, 'Kirks Mills', 39.7552795410156, 0.693860523041463, -76.1063919067383, -1.32830712058575, 218, 45, 'PPL', 'P'),
(36732, 'Kirksey', 36.6986083984375, 0.640511547452777, -88.3952789306641, -1.54278866055886, 218, 21, 'PPL', 'P'),
(81902, 'Kirksey', 34.0311088562012, 0.593954897645312, -82.0416717529297, -1.43189729592905, 218, 48, 'PPL', 'P'),
(88313, 'Kirkstall', 36.0400009155273, 0.629016678397723, -84.1908264160156, -1.46940712093449, 218, 50, 'PPL', 'P'),
(27637, 'Kirksville', 39.5705604553223, 0.69063656680484, -88.668327331543, -1.5475542541715, 218, 18, 'PPL', 'P'),
(30250, 'Kirksville', 39.0458297729492, 0.681478288711194, -86.6130599975586, -1.51168307218479, 218, 19, 'PPL', 'P'),
(36733, 'Kirksville', 37.6652793884277, 0.65738313901162, -84.4091720581055, -1.47321797129634, 218, 21, 'PPL', 'P'),
(139254, 'Kirksville', 40.1947212219238, 0.701530227243809, -92.5830612182617, -1.61587924983414, 218, 29, 'PPL', 'P'),
(36734, 'Kirkville', 38.6974983215332, 0.675398757995734, -83.041389465332, -1.44934566160098, 218, 21, 'PPL', 'P'),
(60503, 'Kirkville', 34.4513893127441, 0.601290175393772, -88.4897232055664, -1.54443702411556, 218, 30, 'PPL', 'P'),
(116328, 'Kirkville', 41.1455612182617, 0.718125515839556, -92.5038909912109, -1.61449746870255, 218, 16, 'PPL', 'P'),
(150044, 'Kirkville', 43.0750007629395, 0.751800588612363, -75.9522171020508, -1.32561626262033, 218, 40, 'PPL', 'P'),
(182494, 'Kirkville', 38.9088897705078, 0.679088234790902, -121.79167175293, -2.1256656735968, 218, 6, 'PPL', 'P'),
(41621, 'Kirkville (historical)', 30.9952793121338, 0.540969676572018, -90.4783325195313, -1.57914480418008, 218, 22, 'PPL', 'P'),
(186924, 'Kirkwell', 37.148609161377, 0.648365542402557, -102.940559387207, -1.79665169515152, 218, 7, 'PPL', 'P'),
(14059, 'Kirkwood', 39.5716705322266, 0.69065594130177, -75.6966705322266, -1.32115613358472, 218, 10, 'PPL', 'P'),
(16739, 'Kirkwood', 29.5361099243164, 0.515502366410294, -82.3302764892578, -1.43693439881483, 218, 12, 'PPL', 'P'),
(22414, 'Kirkwood', 33.7561111450195, 0.589155282149744, -84.3233337402344, -1.47171981002511, 218, 13, 'PPL', 'P'),
(32941, 'Kirkwood', 37.3708305358887, 0.652244037056094, -94.7222213745117, -1.65321463778818, 218, 20, 'PPL', 'P'),
(36735, 'Kirkwood', 37.916389465332, 0.661765836638536, -84.9233322143555, -1.48219175890547, 218, 21, 'PPL', 'P'),
(48717, 'Kirkwood', 38.9594383239746, 0.679970473481018, -76.9686126708984, -1.3433557117994, 218, 25, 'PPL', 'P'),
(55702, 'Kirkwood', 38.5833282470703, 0.673406114289109, -90.4066696166992, -1.57789405057412, 218, 29, 'PPL', 'P'),
(66124, 'Kirkwood', 36.4488906860352, 0.636153151170808, -79.7750015258789, -1.39233643741009, 218, 33, 'PPL', 'P'),
(71003, 'Kirkwood', 39.8311080932617, 0.695183980945178, -74.9916687011719, -1.30885153040023, 218, 37, 'PPL', 'P'),
(78567, 'Kirkwood', 39.8561096191406, 0.695620339889787, -76.0772171020508, -1.32779792418533, 218, 45, 'PPL', 'P'),
(81903, 'Kirkwood', 34.2691688537598, 0.598109828419999, -80.6094436645508, -1.40690020014729, 218, 48, 'PPL', 'P'),
(88314, 'Kirkwood', 36.5933303833008, 0.638674099458677, -87.2152786254883, -1.522193770059, 218, 50, 'PPL', 'P'),
(109979, 'Kirkwood', 38.3505592346191, 0.669343528625221, -80.8019409179688, -1.41025991102048, 218, 58, 'PPL', 'P'),
(120228, 'Kirkwood', 40.8658294677734, 0.713243275771168, -90.7483291625977, -1.58385713457092, 218, 18, 'PPL', 'P'),
(150046, 'Kirkwood', 42.5333290100098, 0.742346633058691, -77.4655609130859, -1.35202909483757, 218, 40, 'PPL', 'P'),
(156001, 'Kirkwood', 40.2161102294922, 0.701903535849611, -84.1972198486328, -1.46951870738416, 218, 41, 'PPL', 'P'),
(182493, 'Kirkwood', 39.855281829834, 0.695605892240873, -122.160827636719, -2.13210865922203, 218, 6, 'PPL', 'P'),
(48715, 'Kirkwood Acres', 38.1944389343262, 0.666618715355906, -75.418327331543, -1.31629812828225, 218, 25, 'PPL', 'P'),
(150047, 'Kirkwood Center', 42.0816688537598, 0.734463676232056, -75.8066711425781, -1.32307600641456, 218, 40, 'PPL', 'P'),
(116329, 'Kirkwood Estates', 41.9244384765625, 0.731719488465811, -91.6494369506836, -1.59958443238838, 218, 16, 'PPL', 'P'),
(14060, 'Kirkwood Gardens', 39.7486114501953, 0.693744142901826, -75.654167175293, -1.32041431006308, 218, 10, 'PPL', 'P'),
(48716, 'Kirkwood Manor', 39.5819396972656, 0.690835172043133, -76.2005615234375, -1.32995069045249, 218, 25, 'PPL', 'P'),
(36736, 'Kirkwood Springs', 37.2511100769043, 0.650154520864818, -87.7647171020508, -1.53178328051216, 218, 21, 'PPL', 'P'),
(202277, 'Kirley', 44.523609161377, 0.777083574737139, -101.311393737793, -1.76821739050885, 218, 49, 'PPL', 'P'),
(32942, 'Kiro', 39.0969390869141, 0.682370314518316, -95.7975006103516, -1.67198180083191, 218, 20, 'PPL', 'P'),
(41622, 'Kiroli Woods', 32.5366706848145, 0.56787203108713, -92.1597213745117, -1.60849057570582, 218, 22, 'PPL', 'P'),
(116330, 'Kiron', 42.1955604553223, 0.736451459669691, -95.3274993896484, -1.66377873204225, 218, 16, 'PPL', 'P'),
(55703, 'Kirschner', 39.714168548584, 0.693143000864768, -94.8833312988281, -1.65602653642514, 218, 29, 'PPL', 'P'),
(150048, 'Kirschnerville', 43.8830604553223, 0.765903890797096, -75.3372192382813, -1.31488252500482, 218, 40, 'PPL', 'P'),
(30251, 'Kirschs Corner', 39.121940612793, 0.682806673462925, -84.9366683959961, -1.48242451918474, 218, 19, 'PPL', 'P'),
(109980, 'Kirt', 39.1161117553711, 0.682704940709284, -79.8744430541992, -1.39407201949249, 218, 58, 'PPL', 'P'),
(156003, 'Kirtland', 41.6288909912109, 0.726561211750437, -81.3616714477539, -1.42002905168917, 218, 41, 'PPL', 'P'),
(188775, 'Kirtland', 36.7341690063477, 0.64113219714482, -108.359169006348, -1.89122427388576, 218, 38, 'PPL', 'P'),
(188776, 'Kirtland Addition', 35.0552787780762, 0.611830034881924, -106.630279541016, -1.86104946031267, 218, 38, 'PPL', 'P'),
(156004, 'Kirtland Hills', 41.6238899230957, 0.726473926645709, -81.3072204589844, -1.41907870265417, 218, 41, 'PPL', 'P'),
(36737, 'Kirtley', 37.436939239502, 0.653397851598371, -87.1011123657227, -1.52020119293141, 218, 21, 'PPL', 'P'),
(95334, 'Kirtley', 29.9669399261475, 0.52302176845862, -97.0975036621094, -1.69467113437106, 218, 51, 'PPL', 'P'),
(209550, 'Kirtley', 42.8308296203613, 0.747538998236018, -104.122222900391, -1.81727561410726, 218, 59, 'PPL', 'P'),
(95333, 'Kirvin', 31.7663898468018, 0.554428094298788, -96.3300018310547, -1.68127570040407, 218, 51, 'PPL', 'P'),
(163375, 'Kirwan Heights', 40.3686103820801, 0.704565165622064, -80.101936340332, -1.39804252636169, 218, 45, 'PPL', 'P'),
(32943, 'Kirwin', 39.6730613708496, 0.692425545267101, -99.121940612793, -1.73000422465952, 218, 20, 'PPL', 'P'),
(209549, 'Kirwin', 43.8763885498047, 0.765787444078432, -109.297218322754, -1.90759632300313, 218, 59, 'PPL', 'P'),
(150049, 'Kiryas Joel', 41.3419418334961, 0.721553004162488, -74.168327331543, -1.29448151263232, 218, 40, 'PPL', 'P'),
(163372, 'Kis-Lyn', 41.0055618286133, 0.715682065539409, -75.9872207641602, -1.3262271917744, 218, 45, 'PPL', 'P'),
(41623, 'Kisatchie', 31.4155597686768, 0.548304954320478, -93.1741714477539, -1.626196069581, 218, 22, 'PPL', 'P'),
(27638, 'Kisch', 39.915828704834, 0.696662634561417, -90.2008285522461, -1.5743014462636, 218, 18, 'PPL', 'P'),
(36738, 'Kise (historical)', 37.9880599975586, 0.663016723402547, -82.6594390869141, -1.44267936991835, 218, 21, 'PPL', 'P'),
(27639, 'Kise Crossing', 38.420280456543, 0.670560393506305, -90.2577819824219, -1.57529547114048, 218, 18, 'PPL', 'P'),
(88316, 'Kiser', 35.7411117553711, 0.623800078454476, -84.1666717529297, -1.46898554253393, 218, 50, 'PPL', 'P'),
(103391, 'Kiser (historical)', 36.9249992370605, 0.644462812983101, -82.1777801513672, -1.4342728356214, 218, 53, 'PPL', 'P'),
(163373, 'Kiser Corners', 41.5044403076172, 0.724389137565368, -79.3847198486328, -1.38552473713194, 218, 45, 'PPL', 'P'),
(36739, 'Kiserton', 38.2769393920898, 0.668058619978285, -84.2761077880859, -1.47089556166774, 218, 21, 'PPL', 'P'),
(163374, 'Kishacoquillas', 40.6375007629395, 0.709258188095001, -77.6627807617188, -1.3554712305465, 218, 45, 'PPL', 'P'),
(120229, 'Kishwaukee', 42.1650009155273, 0.735918095082376, -89.1500015258789, -1.55596105478456, 218, 18, 'PPL', 'P'),
(120230, 'Kishwaukee Glen', 42.1861114501953, 0.736286543419188, -89.0199966430664, -1.55369204153581, 218, 18, 'PPL', 'P'),
(193707, 'Kiska', 40.0683288574219, 0.699324264333869, -122.159439086914, -2.13208442445611, 218, 6, 'PPL', 'P'),
(150051, 'Kiskatom', 42.1994400024414, 0.736519170540407, -73.9613876342773, -1.29086973356196, 218, 40, 'PPL', 'P'),
(163376, 'Kiskimere', 40.6197204589844, 0.70894786324898, -79.5838928222656, -1.38900096130282, 218, 45, 'PPL', 'P'),
(163377, 'Kiskiminetas Junction', 40.6772193908691, 0.709951408926749, -79.6666717529297, -1.39044572619419, 218, 45, 'PPL', 'P'),
(150052, 'Kismet', 40.6341705322266, 0.70920006460421, -73.2038879394531, -1.27764886980442, 218, 40, 'PPL', 'P'),
(182495, 'Kismet', 37.0472183227539, 0.646595938437227, -120.092498779297, -2.096009510646, 218, 6, 'PPL', 'P'),
(187751, 'Kismet', 37.2055587768555, 0.649359500700402, -100.701667785645, -1.757575665109, 218, 20, 'PPL', 'P'),
(55704, 'Kissee Mills', 36.6836090087891, 0.640249758717623, -93.0497207641602, -1.62402399539593, 218, 29, 'PPL', 'P'),
(163379, 'Kissell Hill', 40.1391716003418, 0.700560703448966, -76.2977828979492, -1.33164752354103, 218, 45, 'PPL', 'P'),
(55705, 'Kissenger', 39.3050003051758, 0.686001667822693, -90.8583297729492, -1.58577700740076, 218, 29, 'PPL', 'P'),
(55706, 'Kissick', 37.107780456543, 0.647652947073879, -93.2572174072266, -1.62764549500427, 218, 29, 'PPL', 'P'),
(16740, 'Kissimmee', 28.2916698455811, 0.493782789692585, -81.4077835083008, -1.42083385897059, 218, 12, 'PPL', 'P'),
(163383, 'Kissimmee', 40.795280456543, 0.71201196324117, -77.085563659668, -1.3453968916169, 218, 45, 'PPL', 'P'),
(163380, 'Kissingers Mill', 41.0283317565918, 0.716079475753076, -79.5647201538086, -1.38866633511185, 218, 45, 'PPL', 'P'),
(88315, 'Kissling Crossing', 35.1674995422363, 0.613788656705623, -86.1316680908203, -1.50328119841975, 218, 50, 'PPL', 'P'),
(182496, 'Kister', 39.8222198486328, 0.695028851811681, -121.36222076416, -2.11817033986682, 218, 6, 'PPL', 'P'),
(109981, 'Kistler', 37.7561111450195, 0.658968452229517, -81.8602828979492, -1.42873146318322, 218, 58, 'PPL', 'P'),
(163382, 'Kistler', 40.3894386291504, 0.704928687110859, -77.4341735839844, -1.35148128260135, 218, 45, 'PPL', 'P'),
(136255, 'Kistler Mobile Home Park', 43.8280601501465, 0.764943954382176, -91.3038864135742, -1.59355343778379, 218, 28, 'PPL', 'P'),
(182497, 'Kit Carson', 38.6708297729492, 0.674933304016215, -120.112503051758, -2.09635865106491, 218, 6, 'PPL', 'P'),
(186925, 'Kit Carson', 38.7611083984375, 0.67650896327516, -102.788887023926, -1.79400451302798, 218, 7, 'PPL', 'P'),
(191697, 'Kitalou', 33.6547203063965, 0.587385678184413, -101.726669311523, -1.77546531657356, 218, 51, 'PPL', 'P'),
(150053, 'Kitchawan', 41.2188911437988, 0.719405364480421, -73.7863922119141, -1.2878154872658, 218, 40, 'PPL', 'P'),
(30252, 'Kitchel', 39.6830596923828, 0.692600048897528, -84.8613891601563, -1.48111064866095, 218, 19, 'PPL', 'P'),
(145541, 'Kitchell', 41.0069389343262, 0.715706100568246, -74.4649963378906, -1.29965936358171, 218, 37, 'PPL', 'P'),
(73127, 'Kitchen', 38.8697204589844, 0.678404601339079, -82.5427780151367, -1.44064325010693, 218, 41, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(109982, 'Kitchen', 37.9813919067383, 0.66290034326291, -82.0344390869141, -1.43177106209338, 218, 58, 'PPL', 'P'),
(60502, 'Kitchener', 32.5819396972656, 0.56866212440353, -89.2850036621094, -1.558317286559, 218, 30, 'PPL', 'P'),
(73128, 'Kitchener (historical)', 39.5077781677246, 0.689540809174327, -84.1597213745117, -1.46886423554628, 218, 41, 'PPL', 'P'),
(88317, 'Kitchens', 35.4808311462402, 0.619257324846046, -87.5697174072266, -1.5283798937971, 218, 50, 'PPL', 'P'),
(3563, 'Kitchens Mill', 34.482780456543, 0.601838054209028, -87.1269378662109, -1.5206519329459, 218, 2, 'PPL', 'P'),
(22416, 'Kitchens Store (historical)', 33.4352798461914, 0.583555719641743, -83.79638671875, -1.46252284951664, 218, 13, 'PPL', 'P'),
(81905, 'Kitchings Mill', 33.5783309936523, 0.586052433163693, -81.4775009155273, -1.42205065727265, 218, 48, 'PPL', 'P'),
(22417, 'Kite', 32.6922187805176, 0.570586857502357, -82.5147171020508, -1.44015349478246, 218, 13, 'PPL', 'P'),
(36740, 'Kite', 37.3211097717285, 0.651376246014892, -82.8030624389648, -1.44518607029438, 218, 21, 'PPL', 'P'),
(113612, 'Kitemaug', 41.4455604553223, 0.723361490279734, -72.0888900756836, -1.25818848592894, 218, 8, 'PPL', 'P'),
(22418, 'Kites Spur (historical)', 32.5499992370605, 0.568104658208349, -81.9513931274414, -1.43032163667011, 218, 13, 'PPL', 'P'),
(81906, 'Kitfield (historical)', 33.2269401550293, 0.579919506068376, -79.9980621337891, -1.39622957944962, 218, 48, 'PPL', 'P'),
(207804, 'Kitsap Lake', 47.5830612182617, 0.830481086436691, -122.707221984863, -2.14164503961144, 218, 56, 'PPL', 'P'),
(109983, 'Kitsonville', 39.0325012207031, 0.681245661589975, -80.4738922119141, -1.40453438099292, 218, 58, 'PPL', 'P'),
(122969, 'Kitt', 40.4961090087891, 0.706790436449906, -85.0475006103516, -1.48435890624252, 218, 19, 'PPL', 'P'),
(163385, 'Kittanning', 40.8163909912109, 0.712380411577983, -79.522216796875, -1.38792451159021, 218, 45, 'PPL', 'P'),
(163388, 'Kittatinny', 40.7897186279297, 0.711914891019437, -75.6627807617188, -1.32056464550662, 218, 45, 'PPL', 'P'),
(30253, 'Kitterman Corners', 38.2224998474121, 0.667108470680371, -86.6975021362305, -1.51315686553204, 218, 19, 'PPL', 'P'),
(127885, 'Kittery', 43.0880584716797, 0.752028488622646, -70.7366714477539, -1.23458781866477, 218, 26, 'PPL', 'P'),
(127882, 'Kittery Foreside', 43.086109161377, 0.751994466739721, -70.7438888549805, -1.23471378618433, 218, 26, 'PPL', 'P'),
(127883, 'Kittery Point', 43.0833282470703, 0.751945930628854, -70.7083282470703, -1.23409313649229, 218, 26, 'PPL', 'P'),
(207805, 'Kittitas', 46.9833297729492, 0.820013798088244, -120.415832519531, -2.10165274899588, 218, 56, 'PPL', 'P'),
(9883, 'Kittle', 36.2666702270508, 0.632972804197036, -91.628059387207, -1.59921132351966, 218, 4, 'PPL', 'P'),
(9884, 'Kittlers', 34.3727798461914, 0.59991818137919, -91.4097213745117, -1.59540060631587, 218, 4, 'PPL', 'P'),
(142182, 'Kittles Trailer Court', 41.603328704834, 0.726115065688821, -98.9258270263672, -1.7265813968685, 218, 35, 'PPL', 'P'),
(81907, 'Kittredge', 33.0694389343262, 0.577170591191197, -79.9763870239258, -1.39585127741677, 218, 48, 'PPL', 'P'),
(120233, 'Kittredge', 42.1330604553223, 0.735360628887195, -89.7788925170898, -1.56693727321732, 218, 18, 'PPL', 'P'),
(186927, 'Kittredge', 39.6547203063965, 0.692105433304073, -105.299171447754, -1.83781724138531, 218, 7, 'PPL', 'P'),
(31, 'Kittrell', 30.965389251709, 0.540447996603985, -95.4962310791016, -1.66672365557566, 218, 51, 'PPL', 'P'),
(60505, 'Kittrell', 31.2069396972656, 0.544663847188608, -88.913330078125, -1.55183035877579, 218, 30, 'PPL', 'P'),
(66125, 'Kittrell', 36.2219390869141, 0.632192098523479, -78.4380569458008, -1.36900235257103, 218, 33, 'PPL', 'P'),
(88318, 'Kittrell', 35.8236083984375, 0.625239916497827, -86.2447204589844, -1.50525433447139, 218, 50, 'PPL', 'P'),
(88319, 'Kittrell Heights', 35.8263893127441, 0.625288452608694, -86.2624969482422, -1.50556459273839, 218, 50, 'PPL', 'P'),
(66126, 'Kittrell Hill', 35.6091690063477, 0.621497243059884, -77.5438919067383, -1.35339622858317, 218, 33, 'PPL', 'P'),
(36741, 'Kitts', 36.8558311462402, 0.643255602060968, -83.295280456543, -1.45377689533876, 218, 21, 'PPL', 'P'),
(169451, 'Kitts Corner', 41.6430587768555, 0.726808486257651, -71.6244430541992, -1.25008235620296, 218, 47, 'PPL', 'P'),
(207806, 'Kitts Corner', 47.2972183227539, 0.825492186766646, -122.311943054199, -2.13474612080759, 218, 56, 'PPL', 'P'),
(48755, 'Kitts Hill', 38.332218170166, 0.669023416662193, -75.1872177124023, -1.31226450449522, 218, 25, 'PPL', 'P'),
(73129, 'Kitts Hill', 38.5613899230957, 0.673023218303383, -82.5774993896484, -1.44124925241297, 218, 41, 'PPL', 'P'),
(14061, 'Kitts Hummock', 39.1025009155273, 0.682467386740049, -75.4024963378906, -1.31602182531916, 218, 10, 'PPL', 'P'),
(125182, 'Kittville', 42.1897201538086, 0.736349527178968, -71.6563873291016, -1.25063988897717, 218, 23, 'PPL', 'P'),
(48718, 'Kitty Acres', 38.1119384765625, 0.665178810733527, -76.3944396972656, -1.33333450293355, 218, 25, 'PPL', 'P'),
(48719, 'Kitty Corner Park', 38.8263893127441, 0.677648330168524, -75.9638900756836, -1.32581999444372, 218, 25, 'PPL', 'P'),
(48720, 'Kitty Creek', 38.9375, 0.679587577495292, -76.4847183227539, -1.33491016219249, 218, 25, 'PPL', 'P'),
(66130, 'Kitty Fork', 35.0574989318848, 0.611868783875784, -78.3872222900391, -1.36811512045387, 218, 33, 'PPL', 'P'),
(66128, 'Kitty Hawk', 36.0644416809082, 0.629443250225326, -75.7061080932617, -1.32132085009814, 218, 33, 'PPL', 'P'),
(66129, 'Kitty Hawk Beach', 36.0938911437988, 0.629957240315712, -75.7069396972656, -1.32133536432608, 218, 33, 'PPL', 'P'),
(48721, 'Kittyhawk Estates', 39.332218170166, 0.686476709182136, -77.2294387817383, -1.34790798620873, 218, 25, 'PPL', 'P'),
(48722, 'Kittys Corner', 38.8461112976074, 0.677992543739416, -75.9841690063477, -1.32617392855259, 218, 25, 'PPL', 'P'),
(88320, 'Kittyton (historical)', 36.0436096191406, 0.629079662157503, -82.4980621337891, -1.43986281074948, 218, 50, 'PPL', 'P'),
(48723, 'Kitzmiller', 39.3877792358398, 0.687446432714061, -79.182502746582, -1.38199538289731, 218, 25, 'PPL', 'P'),
(207807, 'Kitzmiller', 46.7583312988281, 0.816086833902867, -117.16667175293, -2.04494419569206, 218, 56, 'PPL', 'P'),
(88321, 'Kitzmiller (historical)', 36.4300003051758, 0.635823451827856, -82.4877777099609, -1.43968331369201, 218, 50, 'PPL', 'P'),
(136258, 'Kitzville', 47.452220916748, 0.828197492380976, -92.8974990844727, -1.62136722589247, 218, 28, 'PPL', 'P'),
(131597, 'Kiva', 46.2538909912109, 0.807282689655174, -87.0844421386719, -1.51991024258232, 218, 27, 'PPL', 'P'),
(182498, 'Kiva Beach', 38.940559387207, 0.679640973875148, -120.050003051758, -2.09526782028241, 218, 6, 'PPL', 'P'),
(211930, 'Kivalina', 67.726936340332, 1.18205803142739, -164.533325195313, -2.87164825391275, 218, 1, 'PPL', 'P'),
(211931, 'Kiwalik', 66.0227813720703, 1.15231491626701, -161.841934204102, -2.8246746196576, 218, 1, 'PPL', 'P'),
(9885, 'Kizer', 33.064998626709, 0.577093093203475, -93.6624984741211, -1.63471898401758, 218, 4, 'PPL', 'P'),
(136259, 'Kjellbergs Mobile Home Park', 45.2827796936035, 0.79033360010861, -93.8097229003906, -1.63728853499534, 218, 28, 'PPL', 'P'),
(60460, 'KJirksey', 34.5122184753418, 0.602351844562332, -90.1752777099609, -1.57385549993907, 218, 30, 'PPL', 'P'),
(122972, 'Klaasville', 41.3558311462402, 0.721795418400713, -87.5175018310547, -1.52746856007207, 218, 19, 'PPL', 'P'),
(207808, 'Klaber', 46.561939239502, 0.812659145842854, -123.126670837402, -2.14896580313195, 218, 56, 'PPL', 'P'),
(178463, 'Klagetoh', 35.5019416809082, 0.619625773182858, -109.527496337891, -1.91161543256222, 218, 5, 'PPL', 'P'),
(207809, 'Klahanie', 47.4313888549805, 0.827833904313152, -122.435279846191, -2.1368987539167, 218, 56, 'PPL', 'P'),
(163389, 'Klahr', 40.2991714477539, 0.703353227588996, -78.5130615234375, -1.37031142940486, 218, 45, 'PPL', 'P'),
(14062, 'Klair Estate', 39.7208290100098, 0.69325924784635, -75.654167175293, -1.32041431006308, 218, 10, 'PPL', 'P'),
(193708, 'Klamath', 41.526668548584, 0.724777093557165, -124.037216186523, -2.16485781746284, 218, 6, 'PPL', 'P'),
(201078, 'Klamath Agency', 42.6183280944824, 0.743830146943919, -121.932777404785, -2.12812843181485, 218, 43, 'PPL', 'P'),
(201080, 'Klamath Falls', 42.2249984741211, 0.736965250022995, -121.780563354492, -2.12547179546944, 218, 43, 'PPL', 'P'),
(193709, 'Klamath Glen', 41.5127792358398, 0.724534679318941, -123.992782592773, -2.16408230495341, 218, 6, 'PPL', 'P'),
(193710, 'Klamath River', 41.8613891601563, 0.73061907030339, -122.824440002441, -2.14369087996083, 218, 6, 'PPL', 'P'),
(163390, 'Klapperthall Junction', 40.3152809143066, 0.703634390821081, -75.9086074829102, -1.32485513118079, 218, 45, 'PPL', 'P'),
(48724, 'Klasmeier Point', 39.1563911437988, 0.683407948658038, -76.5358276367188, -1.33580218799961, 218, 25, 'PPL', 'P'),
(182499, 'Klau', 35.6252784729004, 0.621778406291969, -120.890556335449, -2.10993824262128, 218, 6, 'PPL', 'P'),
(207811, 'Klaus', 46.5763893127441, 0.812911347198084, -122.837501525879, -2.14391884655015, 218, 56, 'PPL', 'P'),
(193197, 'Klawock', 55.5522193908691, 0.969569135160905, -133.095825195313, -2.32296037031703, 218, 1, 'PPL', 'P'),
(95335, 'Kleberg', 32.6713905334473, 0.570223336013561, -96.6155624389648, -1.6862596732261, 218, 51, 'PPL', 'P'),
(88322, 'Kleburne', 35.7391700744629, 0.623766189729604, -86.9727783203125, -1.5179613412966, 218, 50, 'PPL', 'P'),
(163391, 'Klecknersville', 40.7755584716797, 0.711667749670278, -75.4233322143555, -1.31638547996601, 218, 45, 'PPL', 'P'),
(48725, 'Klee Mill', 39.4661102294922, 0.688813566459654, -76.9700012207031, -1.34337994656532, 218, 25, 'PPL', 'P'),
(209551, 'Kleenburn', 44.9036102294922, 0.783715844536845, -107.011940002441, -1.86771069198923, 218, 59, 'PPL', 'P'),
(48726, 'Klees Mill Terrace', 39.4550018310547, 0.688619688332296, -76.9794387817383, -1.34354466307875, 218, 25, 'PPL', 'P'),
(3565, 'Klein', 33.2836112976074, 0.580908604097232, -86.4497222900391, -1.50883229139591, 218, 2, 'PPL', 'P'),
(48727, 'Klein', 39.5722198486328, 0.690665528681695, -76.3794403076172, -1.33307271419839, 218, 25, 'PPL', 'P'),
(60506, 'Klein', 32.1763916015625, 0.561583974858317, -89.4611129760742, -1.56139097393112, 218, 30, 'PPL', 'P'),
(95337, 'Klein', 30.0475006103516, 0.524427817645641, -95.5322189331055, -1.66735176211876, 218, 51, 'PPL', 'P'),
(196838, 'Klein', 46.4041709899902, 0.809905570433766, -108.548606872559, -1.89453058837909, 218, 31, 'PPL', 'P'),
(48728, 'Klein Estates', 39.6855583190918, 0.692643658160378, -76.8433303833008, -1.34116912338639, 218, 25, 'PPL', 'P'),
(55709, 'Klein Ford', 37.8913917541504, 0.661329544272954, -91.4538879394531, -1.59617145829339, 218, 29, 'PPL', 'P'),
(170662, 'Klein Subdivision', 43.5183296203613, 0.759538136843479, -96.8263931274414, -1.68993936290426, 218, 49, 'PPL', 'P'),
(163392, 'Kleinfeltersville', 40.3008308410645, 0.70338218946585, -76.2494430541992, -1.3308038341077, 218, 45, 'PPL', 'P'),
(41624, 'Kleinpeter', 30.3497200012207, 0.529702541079679, -91.0258331298828, -1.58870049248739, 218, 22, 'PPL', 'P'),
(163393, 'Kleinville', 40.3930587768555, 0.704991870607721, -75.4694366455078, -1.31719015408938, 218, 45, 'PPL', 'P'),
(116331, 'Klemme', 43.0069389343262, 0.750612685608133, -93.602783203125, -1.63367675592498, 218, 16, 'PPL', 'P'),
(30254, 'Klemmes Corner', 39.353889465332, 0.686854944635955, -85.0036087036133, -1.48359284795496, 218, 19, 'PPL', 'P'),
(32945, 'Klendike', 37.3677787780762, 0.652190773834293, -94.7594375610352, -1.65386418277805, 218, 20, 'PPL', 'P'),
(55708, 'Klendike', 37.440559387207, 0.653461035095233, -90.2247161865234, -1.57471836413226, 218, 29, 'PPL', 'P'),
(211932, 'Klery Creek', 67.179443359375, 1.17250247627813, -160.403060913086, -2.79956154321037, 218, 1, 'PPL', 'P'),
(174785, 'Klevenville', 43.0244407653809, 0.750918150185165, -89.6677780151367, -1.56499795931152, 218, 57, 'PPL', 'P'),
(207812, 'Klickitat', 45.8172187805176, 0.799661321826613, -121.151390075684, -2.11449065018866, 218, 56, 'PPL', 'P'),
(207814, 'Klickitat Heights', 45.7827796936035, 0.799060246368582, -121.322219848633, -2.11747219218706, 218, 56, 'PPL', 'P'),
(207815, 'Klickitat Springs', 45.8211097717285, 0.79972923243441, -121.116111755371, -2.11387492734463, 218, 56, 'PPL', 'P'),
(41625, 'Klienpeter Terrace', 30.5505599975586, 0.533207860285468, -91.1194381713867, -1.5903342086581, 218, 22, 'PPL', 'P'),
(55710, 'Kliever', 38.6972198486328, 0.675393897726744, -92.5033264160156, -1.61448761500652, 218, 29, 'PPL', 'P'),
(211933, 'Klikitarik', 63.4694404602051, 1.10775071042908, -161.471115112305, -2.81820260557649, 218, 1, 'PPL', 'P'),
(41626, 'Kline', 32.6694412231445, 0.570189314130636, -92.0880584716797, -1.60723982209987, 218, 22, 'PPL', 'P'),
(81908, 'Kline', 33.1258316040039, 0.578154828951063, -81.3427810668945, -1.41969935234622, 218, 48, 'PPL', 'P'),
(109985, 'Kline', 38.7788887023926, 0.676819288121182, -79.2255630493164, -1.38274692695693, 218, 58, 'PPL', 'P'),
(116332, 'Kline', 40.9222183227539, 0.714227446952007, -91.2088928222656, -1.59189548684716, 218, 16, 'PPL', 'P'),
(163394, 'Kline', 41.2983283996582, 0.720791806143916, -79.5849990844727, -1.38902026922072, 218, 45, 'PPL', 'P'),
(186928, 'Kline', 37.1441688537598, 0.648288044414836, -108.11888885498, -1.88703059411721, 218, 7, 'PPL', 'P'),
(109984, 'Kline Gap', 39.0722198486328, 0.681938882421723, -79.1927795410156, -1.38217474679673, 218, 58, 'PPL', 'P'),
(48729, 'Kline Mill', 39.5505599975586, 0.690287492964958, -77.6788864135742, -1.35575232719956, 218, 25, 'PPL', 'P'),
(188777, 'Kline Place', 33.4491691589355, 0.583798133879968, -107.857223510742, -1.88246367232189, 218, 38, 'PPL', 'P'),
(182500, 'Klinefelter', 34.9005584716797, 0.609129656115611, -114.76611328125, -2.00304654647461, 218, 6, 'PPL', 'P'),
(27640, 'Klines Corner', 38.3716697692871, 0.669711976962033, -88.2588882446289, -1.54040819401849, 218, 18, 'PPL', 'P'),
(156008, 'Klines Corner', 41.1833305358887, 0.718784714788378, -80.6647186279297, -1.40786493025218, 218, 41, 'PPL', 'P'),
(163396, 'Klines Corner', 40.5238914489746, 0.707275331505383, -75.6866683959961, -1.32098156337527, 218, 45, 'PPL', 'P'),
(163397, 'Klines Grove', 40.9052810668945, 0.713931836071008, -76.6894378662109, -1.338483192269, 218, 45, 'PPL', 'P'),
(103393, 'Klines Mill', 39.0469398498535, 0.681497663208124, -78.2408294677734, -1.36556008370405, 218, 53, 'PPL', 'P'),
(163398, 'Klines Mill', 40.1761093139648, 0.701205388169847, -79.0961074829102, -1.38048750108811, 218, 45, 'PPL', 'P'),
(145542, 'Klinesville', 40.541389465332, 0.707580729503387, -74.8813934326172, -1.30692686388043, 218, 37, 'PPL', 'P'),
(163400, 'Klinesville', 40.047779083252, 0.698965603114063, -76.5094375610352, -1.33534159428908, 218, 45, 'PPL', 'P'),
(116333, 'Klinger', 42.6566696166992, 0.744499332746829, -92.2191696166992, -1.60952814326652, 218, 16, 'PPL', 'P'),
(131599, 'Klingers', 41.7930603027344, 0.729426506767253, -85.5261077880859, -1.49271217731766, 218, 27, 'PPL', 'P'),
(163401, 'Klingerstown', 40.6602783203125, 0.709655731466723, -76.6897201538086, -1.33848811911701, 218, 45, 'PPL', 'P'),
(131600, 'Klingville', 46.9677810668945, 0.819742421973165, -88.477783203125, -1.54422863176027, 218, 27, 'PPL', 'P'),
(207816, 'Klipsan Beach', 46.4666709899902, 0.810996401216263, -124.051666259766, -2.16511001881807, 218, 56, 'PPL', 'P'),
(73130, 'Klocks Crossing', 39.2566719055176, 0.685158178126438, -83.8375015258789, -1.46324043827236, 218, 41, 'PPL', 'P'),
(3564, 'Klondike', 33.2644386291504, 0.580573977906263, -87.3022232055664, -1.52371123924813, 218, 2, 'PPL', 'P'),
(22421, 'Klondike', 32.3480606079102, 0.564580164242711, -83.5761108398438, -1.458678310167, 218, 13, 'PPL', 'P'),
(36742, 'Klondike', 38.0205612182617, 0.663583976714733, -83.996940612793, -1.46602317529538, 218, 21, 'PPL', 'P'),
(48730, 'Klondike', 39.6091690063477, 0.691310413139657, -78.9627838134766, -1.37816056408565, 218, 25, 'PPL', 'P'),
(55712, 'Klondike', 38.5783309936523, 0.673318895763409, -90.8424987792969, -1.58550070443766, 218, 29, 'PPL', 'P'),
(60507, 'Klondike', 32.6222190856934, 0.569365132352283, -88.7561111450195, -1.54908637074663, 218, 30, 'PPL', 'P'),
(81909, 'Klondike', 33.6908302307129, 0.588015915256381, -79.1180572509766, -1.38087059681091, 218, 48, 'PPL', 'P'),
(88323, 'Klondike', 36.4388885498047, 0.635978580961354, -83.1316680908203, -1.45092132085992, 218, 50, 'PPL', 'P'),
(109987, 'Klondike', 39.6344413757324, 0.691751499195202, -80.2874984741211, -1.40128119656334, 218, 58, 'PPL', 'P'),
(116334, 'Klondike', 43.3877792358398, 0.757259602793835, -96.5205612182617, -1.68460158913142, 218, 16, 'PPL', 'P'),
(120234, 'Klondike', 42.4241714477539, 0.740441474193875, -88.149169921875, -1.53849324803667, 218, 18, 'PPL', 'P'),
(122970, 'Klondike', 40.4674987792969, 0.706291093745517, -86.9622192382813, -1.51777705054916, 218, 19, 'PPL', 'P'),
(156010, 'Klondike', 41.3300018310547, 0.721344611807189, -80.7797164916992, -1.40987202160771, 218, 41, 'PPL', 'P'),
(163402, 'Klondike', 41.860279083252, 0.73059969580646, -78.8005599975586, -1.37532922437273, 218, 45, 'PPL', 'P'),
(174787, 'Klondike', 45.0680618286133, 0.786586066401678, -88.1597213745117, -1.53867740562605, 218, 57, 'PPL', 'P'),
(182501, 'Klondike', 34.6683311462402, 0.605076524673592, -116.002220153809, -2.02462068130728, 218, 6, 'PPL', 'P'),
(191698, 'Klondike', 32.5588912963867, 0.568259853920873, -101.956672668457, -1.77947963244269, 218, 51, 'PPL', 'P'),
(201081, 'Klondike', 45.5827789306641, 0.795569574548788, -120.612503051758, -2.10508529732488, 218, 43, 'PPL', 'P'),
(9886, 'Klondike (historical)', 34.538890838623, 0.602817365120878, -92.70361328125, -1.61798328025336, 218, 4, 'PPL', 'P'),
(163403, 'Klondike (historical)', 41.660831451416, 0.727118677945618, -77.1736068725586, -1.34693353556587, 218, 45, 'PPL', 'P'),
(190382, 'Klondike (historical)', 37.8950004577637, 0.661392528032734, -117.262496948242, -2.04661666085663, 218, 39, 'PPL', 'P'),
(144029, 'Klondike Corner', 42.9555587768555, 0.749715932690076, -71.6213912963867, -1.25002909298116, 218, 36, 'PPL', 'P'),
(30256, 'Klondyke', 39.6694412231445, 0.692362361770239, -87.4366683959961, -1.5260577504846, 218, 19, 'PPL', 'P'),
(36743, 'Klondyke', 37.9463882446289, 0.662289414108846, -85.0902786254883, -1.48510552345413, 218, 21, 'PPL', 'P'),
(41628, 'Klondyke', 29.5463905334473, 0.515681796888739, -90.5863876342773, -1.58103072170602, 218, 22, 'PPL', 'P'),
(136260, 'Klondyke', 46.4416694641113, 0.810560042271653, -93.9658279418945, -1.64001308194855, 218, 28, 'PPL', 'P'),
(163404, 'Klondyke', 40.6022186279297, 0.708642398671948, -77.5805587768555, -1.35403618619311, 218, 45, 'PPL', 'P'),
(178464, 'Klondyke', 32.8352813720703, 0.573083770761388, -110.331672668457, -1.92565095729721, 218, 5, 'PPL', 'P'),
(136261, 'Klossner', 44.3658294677734, 0.77432979959097, -94.4255599975586, -1.64803691999685, 218, 28, 'PPL', 'P'),
(140333, 'Kloten', 47.7161102294922, 0.832803229749186, -98.0749969482422, -1.71173161063022, 218, 34, 'PPL', 'P'),
(174788, 'Kloten', 44.0352783203125, 0.768560593721531, -88.2658309936523, -1.54052936784809, 218, 57, 'PPL', 'P'),
(103392, 'Klotz', 37.3422203063965, 0.651744694351704, -80.6758270263672, -1.40805880837953, 218, 53, 'PPL', 'P'),
(41629, 'Klotzville', 30.0152797698975, 0.523865457891957, -91.0466690063477, -1.58906414713424, 218, 22, 'PPL', 'P'),
(140334, 'Kloze', 46.8005599975586, 0.816823863734547, -98.7394409179688, -1.72332834559697, 218, 34, 'PPL', 'P'),
(211934, 'Kluchevaya', 59.8216705322266, 1.04408511483062, -151.595825195313, -2.64584628193598, 218, 1, 'PPL', 'P'),
(193201, 'Klukwan', 59.4038887023926, 1.03679344634501, -135.88444519043, -2.37163097081877, 218, 1, 'PPL', 'P'),
(95339, 'Klump', 30.1202793121338, 0.525698045617067, -96.4905624389648, -1.68407801166111, 218, 51, 'PPL', 'P'),
(211935, 'Klutchevya', 59.8111114501953, 1.04390082408319, -151.611114501953, -2.6461131306772, 218, 1, 'PPL', 'P'),
(109896, 'KM Junction', 38.1622200012207, 0.666056388891736, -81.1941680908203, -1.41710556660253, 218, 58, 'PPL', 'P'),
(66131, 'Knap of Reeds', 36.1527786254883, 0.6309850207594, -78.779167175293, -1.3749558491879, 218, 33, 'PPL', 'P'),
(27642, 'Knapp', 39.7147216796875, 0.69315265482372, -89.8166732788086, -1.56759667190322, 218, 18, 'PPL', 'P'),
(41630, 'Knapp', 30.5988903045654, 0.534051383271237, -91.4250030517578, -1.59566732189904, 218, 22, 'PPL', 'P'),
(109986, 'Knapp', 38.2338905334473, 0.667307275655746, -80.0511093139648, -1.39715542740259, 218, 58, 'PPL', 'P'),
(136262, 'Knapp', 45.1522216796875, 0.788054932900911, -94.2261123657227, -1.644555902136, 218, 28, 'PPL', 'P'),
(174789, 'Knapp', 44.9552803039551, 0.784617657460973, -92.0752792358398, -1.60701678235857, 218, 57, 'PPL', 'P'),
(191699, 'Knapp', 32.6483306884766, 0.569820865793823, -101.117218017578, -1.76482838486367, 218, 51, 'PPL', 'P'),
(207817, 'Knapp', 45.7380599975586, 0.798279740432107, -122.731391906738, -2.1420668843281, 218, 56, 'PPL', 'P'),
(88324, 'Knapp (historical)', 36.1883316040039, 0.631605537293389, -84.1452789306641, -1.4686121673491, 218, 50, 'PPL', 'P'),
(150054, 'Knapp Creek', 42.0069389343262, 0.73315939308819, -78.5061111450195, -1.37019012241721, 218, 40, 'PPL', 'P'),
(207819, 'Knapp Landing', 45.7394409179688, 0.798303842039972, -122.754173278809, -2.14246449427885, 218, 56, 'PPL', 'P'),
(116335, 'Knapp Mobile Home Park', 42.538330078125, 0.742433918163418, -90.6791687011719, -1.58265005680684, 218, 16, 'PPL', 'P'),
(201082, 'Knappa', 46.1852798461914, 0.80608519927102, -123.584716796875, -2.15696021325021, 218, 43, 'PPL', 'P'),
(150055, 'Knapps Corner', 41.628059387207, 0.726546697522496, -73.9166717529297, -1.29008929420451, 218, 40, 'PPL', 'P'),
(207818, 'Knappton', 46.276668548584, 0.807680233026896, -123.813606262207, -2.16095508804338, 218, 56, 'PPL', 'P'),
(150056, 'Knappville', 43.2299995422363, 0.754505827647665, -74.6616668701172, -1.30309191191071, 218, 40, 'PPL', 'P'),
(30257, 'Knarr Corner', 39.3041687011719, 0.685987153594752, -85.4286117553711, -1.49101055053916, 218, 19, 'PPL', 'P'),
(163405, 'Knauers', 40.2466697692871, 0.702436900436927, -75.9977798461914, -1.32641148252183, 218, 45, 'PPL', 'P'),
(163406, 'Knauertown', 40.1713905334473, 0.701123029913136, -75.7272186279297, -1.32168929843496, 218, 45, 'PPL', 'P'),
(156011, 'Knaufville', 40.9944381713867, 0.715487921095942, -80.8166732788086, -1.41051703922373, 218, 41, 'PPL', 'P'),
(109988, 'Knawl', 38.8266716003418, 0.67765325701654, -80.5294418334961, -1.40550390478777, 218, 58, 'PPL', 'P'),
(163407, 'Kneass', 40.7280616760254, 0.710838774201963, -76.809440612793, -1.34057763530829, 218, 45, 'PPL', 'P'),
(163408, 'Knechts', 40.8108291625977, 0.712283339356249, -75.335563659668, -1.31485362970699, 218, 45, 'PPL', 'P'),
(81910, 'Kneece', 33.8716697692871, 0.591172160622288, -81.5113906860352, -1.42264214535075, 218, 48, 'PPL', 'P'),
(131601, 'Kneeland', 44.7105598449707, 0.780346479704704, -84.0913925170898, -1.46767167201014, 218, 27, 'PPL', 'P'),
(174793, 'Kneeland', 42.8266716003418, 0.747466427096314, -88.0083312988281, -1.53603515035053, 218, 57, 'PPL', 'P'),
(193711, 'Kneeland', 40.7613906860352, 0.711420475163064, -123.993606567383, -2.16409668602329, 218, 6, 'PPL', 'P'),
(174792, 'Knellsville', 43.4141693115234, 0.757720196504364, -87.8708267211914, -1.5336352427342, 218, 57, 'PPL', 'P'),
(78569, 'Knepper', 39.8325004577637, 0.695208282290125, -77.5708312988281, -1.35386640967362, 218, 45, 'PPL', 'P'),
(48731, 'Knettishall', 39.3927803039551, 0.687533717818789, -76.5699996948242, -1.33639860292574, 218, 25, 'PPL', 'P'),
(163409, 'Knickerbocker', 40.0424995422363, 0.698873457740346, -75.5041732788086, -1.31779642271153, 218, 45, 'PPL', 'P'),
(191700, 'Knickerbocker', 31.2663898468018, 0.545701448038816, -100.622779846191, -1.75619881082543, 218, 51, 'PPL', 'P'),
(190384, 'Knickerbocker (historical)', 38.9152793884277, 0.679199754661549, -117.589721679688, -2.0523278098143, 218, 39, 'PPL', 'P'),
(113196, 'Knickerbocker Corner', 42.9619407653809, 0.749827319402669, -77.0963897705078, -1.34558584289624, 218, 40, 'PPL', 'P'),
(116336, 'Knierim', 42.4555587768555, 0.740989286430105, -94.456672668457, -1.64857993854311, 218, 16, 'PPL', 'P'),
(142183, 'Knievels Corner', 42.1180610656738, 0.73509884015204, -98.3391723632813, -1.71634234142547, 218, 35, 'PPL', 'P'),
(136264, 'Knife River', 46.9494400024414, 0.819422310010137, -91.7788925170898, -1.6018438582572, 218, 28, 'PPL', 'P'),
(196839, 'Knife River', 47.4527816772461, 0.828207279497982, -104.342781066895, -1.82112508030491, 218, 31, 'PPL', 'P'),
(36744, 'Knifley', 37.2427787780762, 0.6500091122693, -85.1894378662109, -1.48683617868851, 218, 21, 'PPL', 'P'),
(41631, 'Knight', 30.9152793884277, 0.539573414502003, -93.4483337402344, -1.6309811042696, 218, 22, 'PPL', 'P'),
(192657, 'Knight', 39.9433288574219, 0.697142602768876, -112.195281982422, -1.95817707579673, 218, 52, 'PPL', 'P'),
(200036, 'Knight', 40.9055595397949, 0.713936696339998, -117.15389251709, -2.04472115595077, 218, 39, 'PPL', 'P'),
(127886, 'Knight Corner', 45.0363883972168, 0.786033260738405, -69.1733322143555, -1.20730240171636, 218, 26, 'PPL', 'P'),
(150058, 'Knight Creek', 42.1291694641113, 0.735292718279398, -78.0177764892578, -1.36166707482257, 218, 40, 'PPL', 'P'),
(95340, 'Knight Crossing', 31.4319400787354, 0.548590844663498, -99.3405609130859, -1.73381986871133, 218, 51, 'PPL', 'P'),
(30263, 'Knight Ridge', 39.1252784729004, 0.682864930111771, -86.4330596923828, -1.50854147420488, 218, 19, 'PPL', 'P'),
(66132, 'Knightdale', 35.7874984741211, 0.62460967942586, -78.480827331543, -1.36974883662458, 218, 33, 'PPL', 'P'),
(3566, 'Knightens Crossroads', 33.9563903808594, 0.592650814238527, -85.7144393920898, -1.49599918389309, 218, 2, 'PPL', 'P'),
(30259, 'Knighthood Grove', 39.5536117553711, 0.69034075618676, -85.7566680908203, -1.49673621372477, 218, 19, 'PPL', 'P'),
(30260, 'Knighthood Village', 39.5783309936523, 0.690772188283352, -85.7422180175781, -1.49648401236954, 218, 19, 'PPL', 'P'),
(103394, 'Knightly', 38.2333297729492, 0.66729748853874, -78.9280624389648, -1.3775545617796, 218, 53, 'PPL', 'P'),
(16741, 'Knights', 28.0761108398438, 0.490020575310144, -82.1377792358398, -1.43357468794164, 218, 12, 'PPL', 'P'),
(55713, 'Knights', 37.1402816772461, 0.648220200386066, -94.251106262207, -1.64499212792256, 218, 29, 'PPL', 'P'),
(95341, 'Knights Bluff Landing', 33.2388916015625, 0.580128098160757, -94.2552795410156, -1.64506496537837, 218, 51, 'PPL', 'P'),
(125183, 'Knights Corner', 42.3519401550293, 0.739180800312859, -72.4036102294922, -1.26368138883529, 218, 23, 'PPL', 'P'),
(127887, 'Knights Corner', 44.3355598449707, 0.773801495009726, -69.1786117553711, -1.20739454709008, 218, 26, 'PPL', 'P'),
(125184, 'Knights Crossing', 42.7750015258789, 0.746564614172185, -70.8888931274414, -1.23724458816823, 218, 23, 'PPL', 'P'),
(150059, 'Knights Eddy', 41.4249992370605, 0.723002629322846, -74.7858276367188, -1.30525892608971, 218, 40, 'PPL', 'P'),
(182502, 'Knights Ferry', 37.8197212219238, 0.660078657508944, -120.671112060547, -2.10610821749958, 218, 6, 'PPL', 'P'),
(81911, 'Knights Hill', 34.2930603027344, 0.598526812867678, -80.6538925170898, -1.40767597897283, 218, 48, 'PPL', 'P'),
(22422, 'Knights Landing', 33.5633316040039, 0.585790644428538, -83.9288864135742, -1.46483540544921, 218, 13, 'PPL', 'P'),
(127888, 'Knights Landing', 45.3608283996582, 0.791695807006186, -68.9513931274414, -1.20342883391084, 218, 26, 'PPL', 'P'),
(182503, 'Knights Landing', 38.7997207641602, 0.677182876189005, -121.717216491699, -2.12436618414289, 218, 6, 'PPL', 'P'),
(131602, 'Knights Mill', 44.1199989318848, 0.770039247337771, -83.9511108398438, -1.46522329486198, 218, 27, 'PPL', 'P'),
(36745, 'Knightsburg', 37.2127799987793, 0.64948553479899, -86.9194412231445, -1.51703043333756, 218, 21, 'PPL', 'P'),
(182504, 'Knightsen', 37.9688911437988, 0.662682163790605, -121.666938781738, -2.12348867256371, 218, 6, 'PPL', 'P'),
(30261, 'Knightstown', 39.7955589294434, 0.694563530990216, -85.5263900756836, -1.49271710416568, 218, 19, 'PPL', 'P'),
(30262, 'Knightsville', 39.5258293151855, 0.689855861131283, -87.1125030517578, -1.52039999790678, 218, 19, 'PPL', 'P'),
(81912, 'Knightsville', 33.0113906860352, 0.576157458133503, -80.2380599975586, -1.40041833237015, 218, 48, 'PPL', 'P'),
(163417, 'Knightsville', 40.2419395446777, 0.702354342443134, -78.0119400024414, -1.36156520891088, 218, 45, 'PPL', 'P'),
(169452, 'Knightsville', 41.7813911437988, 0.729222841522889, -71.4627838134766, -1.24726087018608, 218, 47, 'PPL', 'P'),
(125185, 'Knightville', 42.2833290100098, 0.737983309928705, -72.8666687011719, -1.27176328379535, 218, 23, 'PPL', 'P'),
(127889, 'Knightville', 43.6305618286133, 0.76149695840426, -70.2566680908203, -1.22621017966565, 218, 26, 'PPL', 'P'),
(192656, 'Knightville', 39.9538917541504, 0.697326960095337, -112.099998474121, -1.95651406485403, 218, 52, 'PPL', 'P'),
(41634, 'Knightville (historical)', 31.6847190856934, 0.553002670614836, -93.1361083984375, -1.62553174404708, 218, 22, 'PPL', 'P'),
(211936, 'Knik', 61.4577789306641, 1.07264059330289, -149.728897094727, -2.61326223968275, 218, 1, 'PPL', 'P'),
(211937, 'Knik Heights', 61.1049995422363, 1.06648343144165, -149.79167175293, -2.61435786415521, 218, 1, 'PPL', 'P'),
(122971, 'Kniman', 41.1441688537598, 0.718101214494609, -87.1374969482422, -1.52083622369334, 218, 19, 'PPL', 'P'),
(95342, 'Knippa', 29.2950000762939, 0.511294205703319, -99.6369400024414, -1.73899265965465, 218, 51, 'PPL', 'P'),
(116338, 'Knittel', 42.7152786254883, 0.745522252921528, -92.2583312988281, -1.61021164356029, 218, 16, 'PPL', 'P'),
(32946, 'Kniveton', 37.3383293151855, 0.651676783743907, -94.6430587768555, -1.65183298981465, 218, 20, 'PPL', 'P'),
(9887, 'Knob', 36.2813911437988, 0.633229732663201, -90.4480590820313, -1.57861643301981, 218, 4, 'PPL', 'P'),
(163410, 'Knob', 40.6974983215332, 0.71030534303562, -80.1880569458008, -1.39954561448093, 218, 45, 'PPL', 'P'),
(193712, 'Knob', 40.3888893127441, 0.704919099730935, -122.986938476563, -2.14652701336371, 218, 6, 'PPL', 'P'),
(22423, 'Knob (historical)', 33.6091690063477, 0.586590658019998, -84.1738891601563, -1.46911151005349, 218, 13, 'PPL', 'P'),
(81913, 'Knob (historical)', 35.0038909912109, 0.610933148805812, -82.6813888549805, -1.44306246564115, 218, 48, 'PPL', 'P'),
(9888, 'Knob Creek', 36.084171295166, 0.629787596954274, -91.9880599975586, -1.60549451947948, 218, 4, 'PPL', 'P'),
(66133, 'Knob Creek', 35.5125007629395, 0.619810063930292, -81.545280456543, -1.42323363342886, 218, 33, 'PPL', 'P'),
(88326, 'Knob Creek', 35.8363914489746, 0.625463022818148, -83.7380599975586, -1.46150485618995, 218, 50, 'PPL', 'P'),
(88327, 'Knob Creek Mill', 36.3488883972168, 0.634407781971398, -82.4044418334961, -1.43822882826266, 218, 50, 'PPL', 'P'),
(109991, 'Knob Fork', 39.648609161377, 0.691998773702416, -80.5469436645508, -1.4058093693648, 218, 58, 'PPL', 'P'),
(760, 'Knob Hill', 34.9536094665527, 0.610055570647604, -79.7458267211914, -1.39182724100966, 218, 33, 'PPL', 'P'),
(22424, 'Knob Hill', 33.5805587768555, 0.586091315315608, -85.0263900756836, -1.48399045790571, 218, 13, 'PPL', 'P'),
(30264, 'Knob Hill', 38.0322189331055, 0.663787442222015, -87.5186080932617, -1.52748786798997, 218, 19, 'PPL', 'P'),
(95343, 'Knob Hill', 32.2588882446289, 0.563023812901668, -98.1427764892578, -1.71291458678643, 218, 51, 'PPL', 'P'),
(103395, 'Knob Hill', 36.8144416809082, 0.642533219615284, -76.2108306884766, -1.33012992119385, 218, 53, 'PPL', 'P'),
(120235, 'Knob Hill', 41.600830078125, 0.726071456425971, -88.4972229003906, -1.54456791848314, 218, 18, 'PPL', 'P'),
(186929, 'Knob Hill', 38.8400001525879, 0.677885884137759, -104.782218933105, -1.82879471792823, 218, 7, 'PPL', 'P'),
(36746, 'Knob Lick', 37.0783309936523, 0.647138956983494, -85.6944427490234, -1.49565017663224, 218, 21, 'PPL', 'P'),
(55714, 'Knob Lick', 37.6752815246582, 0.657557709221075, -90.3672180175781, -1.57720549027428, 218, 29, 'PPL', 'P'),
(55715, 'Knob Noster', 38.7666702270508, 0.676606035496894, -93.5583267211914, -1.63290084394138, 218, 29, 'PPL', 'P'),
(163411, 'Knob Point', 40.2583312988281, 0.702640432523236, -76.9375, -1.34281269325314, 218, 45, 'PPL', 'P'),
(95344, 'Knobbs Springs', 30.3603496551514, 0.529888063539116, -97.1974411010742, -1.69641537172701, 218, 51, 'PPL', 'P'),
(55716, 'Knobby', 38.1525001525879, 0.665886745530298, -93.0952835083008, -1.62481921529743, 218, 29, 'PPL', 'P'),
(9890, 'Knobel', 36.3199996948242, 0.633903578998018, -90.601936340332, -1.5813020978211, 218, 4, 'PPL', 'P'),
(191701, 'Knoblaw', 35.5497207641602, 0.620459675499189, -102.894721984863, -1.79585168156006, 218, 51, 'PPL', 'P'),
(109989, 'Knobmount', 39.6286087036133, 0.691649699862533, -78.790283203125, -1.37514986047332, 218, 58, 'PPL', 'P'),
(109990, 'Knobs', 37.6113891601563, 0.656442577093631, -80.5883331298828, -1.40653175181048, 218, 58, 'PPL', 'P'),
(196840, 'Knobs (historical)', 45.9841690063477, 0.802575152954296, -104.087219238281, -1.81666468495319, 218, 31, 'PPL', 'P'),
(163412, 'Knobsville', 40.0074996948242, 0.698262595165309, -77.9630584716797, -1.36071206525567, 218, 45, 'PPL', 'P'),
(55717, 'Knobtown', 38.9655609130859, 0.680077332819758, -94.4288864135742, -1.64809497690861, 218, 29, 'PPL', 'P'),
(60509, 'Knobtown', 31.378059387207, 0.547650449193077, -88.5233306884766, -1.54502358534565, 218, 30, 'PPL', 'P'),
(163413, 'Knobville', 40.7194404602051, 0.710688305600374, -77.5272216796875, -1.35310527823408, 218, 45, 'PPL', 'P'),
(73131, 'Knockemstiff', 39.2677803039551, 0.685352056253796, -83.1191711425781, -1.45070320796665, 218, 41, 'PPL', 'P'),
(48733, 'Knocks Folly', 39.353889465332, 0.686854944635955, -75.9847183227539, -1.32618351593252, 218, 25, 'PPL', 'P'),
(48734, 'Knoebel', 39.4897193908691, 0.689225624059316, -76.523063659668, -1.33557941457443, 218, 25, 'PPL', 'P'),
(163414, 'Knoebels Grove', 40.8783302307129, 0.713461455243473, -76.5061111450195, -1.33528353737732, 218, 45, 'PPL', 'P'),
(178465, 'Knoell East', 33.3772201538086, 0.582542386846968, -111.886390686035, -1.95278590564403, 218, 5, 'PPL', 'P'),
(178466, 'Knoell Mesa', 33.3908309936523, 0.582779940816203, -111.783058166504, -1.95098241295383, 218, 5, 'PPL', 'P'),
(116339, 'Knoke', 42.5169410705566, 0.742060609557616, -94.7627792358398, -1.65392250600592, 218, 16, 'PPL', 'P'),
(48735, 'Knoll Acres', 39.4124984741211, 0.687877864810654, -76.5138931274414, -1.33541935859291, 218, 25, 'PPL', 'P'),
(120236, 'Knoll Creek West', 41.9302787780762, 0.731821420956534, -88.3563919067383, -1.54210995395505, 218, 18, 'PPL', 'P'),
(48736, 'Knoll View Acres', 39.4844398498535, 0.689133478685599, -76.9236068725586, -1.34257021243589, 218, 25, 'PPL', 'P'),
(81914, 'Knoll Wood Manor', 34.7299995422363, 0.606152841228147, -82.9797210693359, -1.44826934504642, 218, 48, 'PPL', 'P'),
(48737, 'Knolland', 38.5050010681152, 0.672039047122544, -76.7525024414063, -1.33958387674753, 218, 25, 'PPL', 'P'),
(48738, 'Knollcrest', 38.452220916748, 0.671117859701486, -76.9011077880859, -1.34217752933315, 218, 25, 'PPL', 'P'),
(113613, 'Knollcrest', 41.4986114501953, 0.724287404811727, -73.4669418334961, -1.28224002636567, 218, 8, 'PPL', 'P'),
(48739, 'Knollcrest Farms', 39.4069404602051, 0.687780859167948, -76.6833267211914, -1.33837653266734, 218, 25, 'PPL', 'P'),
(48740, 'Knollcrest Manor', 39.4674987792969, 0.688837801225573, -76.7291717529297, -1.33917667941685, 218, 25, 'PPL', 'P'),
(95345, 'Knolle', 27.9738903045654, 0.488236490406386, -97.8241729736328, -1.70735390643034, 218, 51, 'PPL', 'P'),
(48741, 'Knollers Woods', 39.4236106872559, 0.688071809517039, -76.980827331543, -1.34356889784467, 218, 25, 'PPL', 'P'),
(125186, 'Knollmere', 41.6352806091309, 0.726672731621084, -70.8600006103516, -1.23674031861583, 218, 23, 'PPL', 'P'),
(204571, 'Knolls', 40.7230606079102, 0.710751489097236, -113.288887023926, -1.97726408448739, 218, 52, 'PPL', 'P'),
(30265, 'Knollton Heights', 39.8411102294922, 0.695358551154632, -86.2019424438477, -1.50450771725979, 218, 19, 'PPL', 'P'),
(48743, 'Knollview', 39.2330589294434, 0.684746053947748, -76.8011093139648, -1.34043222671277, 218, 25, 'PPL', 'P'),
(22426, 'Knollwood', 33.5666694641113, 0.585848901077383, -84.3047180175781, -1.47139490437213, 218, 13, 'PPL', 'P'),
(48748, 'Knollwood', 39.0258293151855, 0.681129214871312, -76.9583282470703, -1.34317621474193, 218, 25, 'PPL', 'P'),
(66139, 'Knollwood', 35.2008285522461, 0.614370357666723, -79.3994369506836, -1.38578159901908, 218, 33, 'PPL', 'P'),
(73132, 'Knollwood', 39.7333297729492, 0.693477427318655, -84.0672225952148, -1.46724982729347, 218, 41, 'PPL', 'P'),
(88328, 'Knollwood', 35.1161117553711, 0.612891770629511, -85.2858276367188, -1.48851849754912, 218, 50, 'PPL', 'P'),
(95346, 'Knollwood', 33.6894416809082, 0.587991680490461, -96.6188888549805, -1.68631773013786, 218, 51, 'PPL', 'P'),
(103400, 'Knollwood', 37.2569389343262, 0.650256253618459, -80.0069427490234, -1.39638457542506, 218, 53, 'PPL', 'P'),
(109992, 'Knollwood', 38.3869400024414, 0.669978492808123, -81.6066665649414, -1.4243050231354, 218, 58, 'PPL', 'P'),
(113614, 'Knollwood', 41.2666702270508, 0.720239266796752, -72.3838882446289, -1.26333717526439, 218, 8, 'PPL', 'P'),
(120237, 'Knollwood', 42.2861099243164, 0.738031846039572, -87.8855590820313, -1.53389237093745, 218, 18, 'PPL', 'P'),
(145543, 'Knollwood', 40.7602806091309, 0.711401100666133, -74.4044418334961, -1.29860248810311, 218, 37, 'PPL', 'P'),
(204573, 'Knollwood Condominium', 41.1733283996582, 0.718610144578923, -111.926391601563, -1.95348405332379, 218, 52, 'PPL', 'P'),
(103401, 'Knollwood Estates', 38.8611106872559, 0.678254332474571, -77.6783294677734, -1.35574260666158, 218, 53, 'PPL', 'P'),
(73133, 'Knollwood Village', 39.6216697692871, 0.691528592611962, -82.8997192382813, -1.44687304968689, 218, 41, 'PPL', 'P'),
(36747, 'Knopp', 38.1477813720703, 0.665804387273587, -85.730827331543, -1.49628520739417, 218, 21, 'PPL', 'P'),
(55719, 'Knorpp', 38.0883293151855, 0.664766753133865, -90.4627838134766, -1.578873428065, 218, 29, 'PPL', 'P'),
(41632, 'Knot Point', 32.3183288574219, 0.564061247304309, -93.5327835083008, -1.6324550307749, 218, 22, 'PPL', 'P'),
(22431, 'Knott', 33.0116691589355, 0.576162318402493, -84.9380569458008, -1.48244875395066, 218, 13, 'PPL', 'P'),
(193076, 'Knott', 32.4025001525879, 0.565530313540624, -101.640830993652, -1.77396715530233, 218, 51, 'PPL', 'P'),
(22427, 'Knott (historical)', 33.6933288574219, 0.588059524519231, -84.4313888549805, -1.47360572755105, 218, 13, 'PPL', 'P'),
(48749, 'Knotts Crossing', 38.5941696166992, 0.673595331884559, -77.121940612793, -1.34603178922077, 218, 25, 'PPL', 'P'),
(66145, 'Knotts Crossroads', 36.4063911437988, 0.635411394228194, -78.4927825927734, -1.36995749529599, 218, 33, 'PPL', 'P'),
(66146, 'Knotts Island', 36.5133285522461, 0.637277804099149, -75.9194412231445, -1.32504421561818, 218, 33, 'PPL', 'P'),
(22429, 'Knotts Landing', 34.0783309936523, 0.594779079423664, -84.4508285522461, -1.47394501427393, 218, 13, 'PPL', 'P'),
(22430, 'Knotts Pointe', 34.0747184753418, 0.594716029084857, -84.4333267211914, -1.4736395496969, 218, 13, 'PPL', 'P'),
(36749, 'Knottsville', 37.771671295166, 0.659240028081678, -86.904167175293, -1.51676385091244, 218, 21, 'PPL', 'P'),
(109994, 'Knottsville', 39.3111114501953, 0.686108327424351, -79.9652786254883, -1.39565739928942, 218, 58, 'PPL', 'P'),
(66147, 'Knottville', 36.2044410705566, 0.631886700525474, -81.0833282470703, -1.4151710463867, 218, 33, 'PPL', 'P'),
(81920, 'Knotty Branch', 33.9208297729492, 0.592030164546484, -79.158332824707, -1.38157353818064, 218, 48, 'PPL', 'P'),
(163415, 'Knousetown', 40.6566696166992, 0.709592747706942, -77.0783309936523, -1.34527065778123, 218, 45, 'PPL', 'P'),
(150060, 'Knowelhurst', 43.4438896179199, 0.758238913705684, -74.0205612182617, -1.29190250743269, 218, 40, 'PPL', 'P'),
(48750, 'Knowles', 39.5952796936035, 0.691067998901433, -77.4227828979492, -1.35128247762597, 218, 25, 'PPL', 'P'),
(81918, 'Knowles', 32.5094413757324, 0.567396789990606, -80.8583297729492, -1.41124408220132, 218, 48, 'PPL', 'P'),
(174795, 'Knowles', 43.5727806091309, 0.760488485878474, -88.5041732788086, -1.5446892254708, 218, 57, 'PPL', 'P'),
(177714, 'Knowles', 32.8402786254883, 0.573170989287088, -103.127220153809, -1.79990954011301, 218, 38, 'PPL', 'P'),
(182505, 'Knowles', 37.2200012207031, 0.649611568897578, -119.873062133789, -2.09217961868236, 218, 6, 'PPL', 'P'),
(190996, 'Knowles', 36.8733291625977, 0.643561000058973, -100.193061828613, -1.74869881656355, 218, 42, 'PPL', 'P'),
(196841, 'Knowles', 47.3472213745117, 0.826364904655865, -114.712219238281, -2.00210591797759, 218, 31, 'PPL', 'P'),
(41633, 'Knowles (historical)', 32.6388893127441, 0.569656082701374, -92.7811126708984, -1.61933589977101, 218, 22, 'PPL', 'P'),
(127898, 'Knowles Corner', 46.2061080932617, 0.806448720759816, -68.3341674804688, -1.19265621414342, 218, 26, 'PPL', 'P'),
(182506, 'Knowles Corner', 38.3525009155273, 0.669377417350092, -122.814170837402, -2.14351164921947, 218, 6, 'PPL', 'P'),
(14063, 'Knowles Crossroads', 38.6536102294922, 0.6746327662872, -75.4522171020508, -1.31688961636036, 218, 10, 'PPL', 'P'),
(182507, 'Knowles Junction', 37.2027816772461, 0.649311031168563, -119.908058166504, -2.09279041467837, 218, 6, 'PPL', 'P'),
(188778, 'Knowles Place', 32.5588912963867, 0.568259853920873, -104.579170227051, -1.82525084946566, 218, 38, 'PPL', 'P'),
(150067, 'Knowlesville', 43.2419395446777, 0.754714220002964, -78.3108291625977, -1.36678180885412, 218, 40, 'PPL', 'P'),
(177384, 'Knowlesville Station', 43.2280616760254, 0.754472005501821, -78.3072204589844, -1.36671882509434, 218, 40, 'PPL', 'P'),
(9891, 'Knowlton', 34.1072196960449, 0.595283282397043, -90.9636077880859, -1.58761445539486, 218, 4, 'PPL', 'P'),
(36750, 'Knowlton', 37.7861099243164, 0.659492029699827, -83.8375015258789, -1.46324043827236, 218, 21, 'PPL', 'P'),
(116344, 'Knowlton', 40.8263893127441, 0.71255491520841, -94.3319396972656, -1.64640293751003, 218, 16, 'PPL', 'P'),
(145544, 'Knowlton', 40.9302787780762, 0.714368128436591, -75.0283279418945, -1.30949135485212, 218, 37, 'PPL', 'P'),
(163416, 'Knowlton', 41.7713890075684, 0.729048271313434, -78.1275024414063, -1.36358215396245, 218, 45, 'PPL', 'P'),
(174797, 'Knowlton', 44.7163887023926, 0.780448212458345, -89.682502746582, -1.56525495435671, 218, 57, 'PPL', 'P'),
(193171, 'Knowlton', 46.3436088562012, 0.808848561797114, -105.087501525879, -1.83412290432115, 218, 31, 'PPL', 'P'),
(3569, 'Knowlton (historical)', 31.9105606079102, 0.556944348765235, -85.2644424438477, -1.48814525552234, 218, 2, 'PPL', 'P'),
(127890, 'Knowlton Corner', 44.0480613708496, 0.768783700041853, -69.4863891601563, -1.21276627616682, 218, 26, 'PPL', 'P'),
(195193, 'Knowlton Heights', 43.545280456543, 0.760008517671014, -116.771942138672, -2.03805486426813, 218, 17, 'PPL', 'P'),
(73134, 'Knowltons Corner', 39.1583290100098, 0.683441770803882, -84.5391693115234, -1.47548685138703, 218, 41, 'PPL', 'P'),
(177344, 'Knowltons Corner', 44.6100006103516, 0.778591389967315, -70.126106262207, -1.22393144587893, 218, 26, 'PPL', 'P'),
(55720, 'Knox', 37.4744415283203, 0.654052390015285, -93.6102828979492, -1.63380765029255, 218, 29, 'PPL', 'P'),
(60510, 'Knox', 32.9597206115723, 0.575255645209375, -89.5625, -1.56316051131742, 218, 30, 'PPL', 'P'),
(81919, 'Knox', 34.7216682434082, 0.606007432632629, -81.0811080932617, -1.41513229739284, 218, 48, 'PPL', 'P'),
(120239, 'Knox', 40.9341697692871, 0.714436039044388, -90.2547225952148, -1.57524207476062, 218, 18, 'PPL', 'P'),
(122979, 'Knox', 41.2958297729492, 0.720748196881066, -86.625, -1.51189146454009, 218, 19, 'PPL', 'P'),
(140335, 'Knox', 48.3402786254883, 0.843697023346209, -99.6900024414063, -1.73991877392372, 218, 34, 'PPL', 'P'),
(142184, 'Knox', 40.8138885498047, 0.712336735736105, -97.5894393920898, -1.70325703256742, 218, 35, 'PPL', 'P'),
(150061, 'Knox', 42.6711082458496, 0.744751334364978, -74.1161117553711, -1.2935701789073, 218, 40, 'PPL', 'P'),
(156012, 'Knox', 40.4575004577637, 0.706116590115089, -82.5294418334961, -1.44041048982765, 218, 41, 'PPL', 'P'),
(163419, 'Knox', 41.2344398498535, 0.7196767405955, -79.5374984741211, -1.38819122717338, 218, 45, 'PPL', 'P'),
(196842, 'Knox', 45.9438896179199, 0.801872145005542, -108.19750213623, -1.88840265471082, 218, 31, 'PPL', 'P'),
(127891, 'Knox Center', 44.5230598449707, 0.777073987357215, -69.2430572509766, -1.20851933317647, 218, 26, 'PPL', 'P'),
(95347, 'Knox City', 33.4180603027344, 0.583255181912728, -99.8186111450195, -1.7421634192485, 218, 51, 'PPL', 'P'),
(139255, 'Knox City', 40.1436080932617, 0.70063813485766, -92.0091705322266, -1.6058629678163, 218, 29, 'PPL', 'P'),
(127892, 'Knox Corner', 44.5325012207031, 0.777238770449664, -69.271110534668, -1.20900895534289, 218, 26, 'PPL', 'P'),
(163418, 'Knox Dale', 41.086109161377, 0.717087881699834, -79.0266723632813, -1.37927562963407, 218, 45, 'PPL', 'P'),
(16742, 'Knox Hill', 30.6413898468018, 0.534793140213852, -85.9577789306641, -1.5002462600415, 218, 12, 'PPL', 'P'),
(127894, 'Knox Hill Corner', 44.9886093139648, 0.785199358422074, -69.2583312988281, -1.20878591560159, 218, 26, 'PPL', 'P'),
(13140, 'Knox Hill Dwellings', 38.853328704834, 0.678118511258977, -76.9672164916992, -1.34333134387543, 218, 9, 'PPL', 'P'),
(22432, 'Knox Landing', 34.1383285522461, 0.595826234364283, -84.341667175293, -1.47203978883009, 218, 13, 'PPL', 'P'),
(127895, 'Knox Ledge Corner', 44.5572204589844, 0.777670202546256, -69.2186126708984, -1.20809269476984, 218, 26, 'PPL', 'P'),
(88331, 'Knox Park', 35.4502792358398, 0.618724093416785, -84.5772171020508, -1.47615091060484, 218, 50, 'PPL', 'P'),
(22433, 'Knox Springs Estates', 33.7833290100098, 0.589630323509187, -84.5769424438477, -1.47614611691488, 218, 13, 'PPL', 'P'),
(150063, 'Knoxboro', 42.9863891601563, 0.750254024388327, -75.5175018310547, -1.31802904983275, 218, 40, 'PPL', 'P'),
(156018, 'Knoxdale', 41.1980590820313, 0.719041776412598, -84.6752777099609, -1.47786239107938, 218, 41, 'PPL', 'P'),
(78570, 'Knoxlyn', 39.8308296203613, 0.695179120676188, -77.3172225952148, -1.34944010278385, 218, 45, 'PPL', 'P'),
(60511, 'Knoxo', 31.1352806091309, 0.543413160161679, -90.0461120605469, -1.57160113407632, 218, 30, 'PPL', 'P'),
(3571, 'Knoxville', 32.9922218322754, 0.575822898521562, -87.7905578613281, -1.53223428684277, 218, 2, 'PPL', 'P'),
(9893, 'Knoxville', 35.3819389343262, 0.617531330143565, -93.3641662597656, -1.62951210461231, 218, 4, 'PPL', 'P'),
(22434, 'Knoxville', 32.7241706848145, 0.57114452343462, -83.9977798461914, -1.46603782268138, 218, 13, 'PPL', 'P'),
(36752, 'Knoxville', 38.7011108398438, 0.675461808334541, -84.5058288574219, -1.47490495068885, 218, 21, 'PPL', 'P'),
(48751, 'Knoxville', 39.3269386291504, 0.68638456380842, -77.664436340332, -1.35550012584433, 218, 25, 'PPL', 'P'),
(55721, 'Knoxville', 39.4461097717285, 0.688464492619771, -94.0166702270508, -1.64090044722376, 218, 29, 'PPL', 'P'),
(60512, 'Knoxville', 31.3786106109619, 0.547660069862515, -91.1208267211914, -1.59035844342402, 218, 30, 'PPL', 'P'),
(88332, 'Knoxville', 35.9605598449707, 0.6276301701552, -83.9208297729492, -1.46469479054365, 218, 50, 'PPL', 'P'),
(109995, 'Knoxville', 39.8875007629395, 0.696168218705044, -80.6336135864258, -1.40732204486396, 218, 58, 'PPL', 'P'),
(116342, 'Knoxville', 41.3208312988281, 0.721184555825676, -93.1091690063477, -1.62506156295662, 218, 16, 'PPL', 'P'),
(120242, 'Knoxville', 40.9083290100098, 0.713985032713783, -90.2847213745117, -1.57576565223093, 218, 18, 'PPL', 'P'),
(142186, 'Knoxville', 42.6686096191406, 0.744707725102128, -98.2961120605469, -1.71559079736585, 218, 35, 'PPL', 'P'),
(156019, 'Knoxville', 40.4922218322754, 0.706722592421137, -80.6808319091797, -1.40814616006329, 218, 41, 'PPL', 'P'),
(163426, 'Knoxville', 41.957218170166, 0.732291602046987, -77.4391708374023, -1.35156850112705, 218, 45, 'PPL', 'P'),
(182508, 'Knoxville', 38.8277816772461, 0.677672631513471, -122.33943939209, -2.13522602243602, 218, 6, 'PPL', 'P'),
(201083, 'Knoxville (historical)', 42.4319381713867, 0.74057702909336, -124.427780151367, -2.17167444458901, 218, 43, 'PPL', 'P'),
(9894, 'Knoxville Junction', 35.4088897705078, 0.618001710971101, -93.3844375610352, -1.62986590556313, 218, 4, 'PPL', 'P'),
(3572, 'Knoxwood', 32.5125007629395, 0.567450186370462, -87.7938919067383, -1.53229247691259, 218, 2, 'PPL', 'P'),
(81921, 'Knoxwood', 34.5697212219238, 0.603355456819128, -82.6658325195313, -1.44279095636802, 218, 48, 'PPL', 'P'),
(204577, 'Knudsens Corner', 40.6380615234375, 0.709267975212007, -111.811393737793, -1.95147696196826, 218, 52, 'PPL', 'P'),
(195194, 'Knull', 42.5263900756836, 0.742225525808119, -114.554443359375, -1.99935220941045, 218, 17, 'PPL', 'P'),
(88333, 'Ko Ko', 35.478889465332, 0.619223436121174, -89.2716674804688, -1.55808452627973, 218, 50, 'PPL', 'P'),
(178467, 'Ko Vaya', 32.0769386291504, 0.559848193038831, -111.894721984863, -1.95293131423955, 218, 5, 'PPL', 'P'),
(210445, 'Koae (historical)', 19.5266704559326, 0.340804691407926, -154.846664428711, -2.70258413001179, 218, 15, 'PPL', 'P'),
(210449, 'Koali', 20.6888904571533, 0.36108925706176, -156.023895263672, -2.72313068413786, 218, 15, 'PPL', 'P'),
(186930, 'Kobe', 39.1294403076172, 0.682937567830503, -106.314170837402, -1.85553232264041, 218, 7, 'PPL', 'P'),
(182509, 'Kobe (historical)', 38.5769386291504, 0.673294594418462, -121.590278625488, -2.12215070043206, 218, 6, 'PPL', 'P'),
(48752, 'Koblan', 39.5641708374023, 0.690525046934193, -77.3611068725586, -1.35020602791336, 218, 25, 'PPL', 'P'),
(211938, 'Kobuk', 66.9072189331055, 1.16775126373538, -156.881103515625, -2.73809179050971, 218, 1, 'PPL', 'P'),
(60513, 'Koch', 32.4955596923828, 0.567154508910436, -89.8863906860352, -1.56881347020528, 218, 30, 'PPL', 'P'),
(55723, 'Koch (historical)', 38.4816703796387, 0.671631849791871, -90.2855606079102, -1.57578029961693, 218, 29, 'PPL', 'P'),
(131603, 'Kochville', 43.5011100769043, 0.759237599114464, -83.945556640625, -1.4651263557983, 218, 27, 'PPL', 'P'),
(36753, 'Kodak', 37.2052803039551, 0.649354640431413, -83.0313873291016, -1.44917109139152, 218, 21, 'PPL', 'P'),
(88334, 'Kodak', 35.9744415283203, 0.62787245123537, -83.6269378662109, -1.4595654091261, 218, 50, 'PPL', 'P'),
(193193, 'Kodak', 40.2275009155273, 0.702102340824985, -118.419441223145, -2.06680914771577, 218, 39, 'PPL', 'P'),
(174799, 'Kodan', 44.6611099243164, 0.779483415774437, -87.4977798461914, -1.52712434650118, 218, 57, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(55724, 'Kodiak', 39.9519386291504, 0.697292871633384, -94.7569427490234, -1.65382064009423, 218, 29, 'PPL', 'P'),
(211940, 'Kodiak', 57.7900009155273, 1.00862579070649, -152.4072265625, -2.66000790734858, 218, 1, 'PPL', 'P'),
(109996, 'Kodol', 39.6227798461914, 0.691547967108892, -80.5408325195313, -1.40570270976314, 218, 58, 'PPL', 'P'),
(103403, 'Koehler', 36.6897201538086, 0.64035641831928, -79.9091720581055, -1.39467815495659, 218, 53, 'PPL', 'P'),
(188779, 'Koehler', 36.7408294677734, 0.641248444126402, -104.617782592773, -1.82592476237951, 218, 38, 'PPL', 'P'),
(95349, 'Koehn Estates Colonia', 27.951000213623, 0.487836982953361, -97.9580001831055, -1.7096896318644, 218, 51, 'PPL', 'P'),
(210451, 'Koele', 20.8397197723389, 0.363721725220276, -156.920272827148, -2.73877542396153, 218, 15, 'PPL', 'P'),
(55725, 'Koeltztown', 38.3247184753418, 0.668892522294616, -92.0419387817383, -1.60643488166039, 218, 29, 'PPL', 'P'),
(177699, 'Koen', 38.0713882446289, 0.664471075673839, -102.346389770508, -1.7862814790248, 218, 7, 'PPL', 'P'),
(55727, 'Koenig', 38.3561096191406, 0.669440401109872, -91.7680587768555, -1.60165477381981, 218, 29, 'PPL', 'P'),
(95350, 'Koenig Winter Resort Colonia', 26.1720008850098, 0.45678758727829, -98.0859985351563, -1.71192362454481, 218, 51, 'PPL', 'P'),
(3573, 'Koenton', 31.6399993896484, 0.552222164678361, -88.2594375610352, -1.54041778139842, 218, 2, 'PPL', 'P'),
(174800, 'Koepenick', 45.336669921875, 0.791274162026599, -89.1666717529297, -1.55625200513365, 218, 57, 'PPL', 'P'),
(16743, 'Koerber', 30.7272205352783, 0.536291168327021, -86.0713882446289, -1.50222911663112, 218, 12, 'PPL', 'P'),
(95351, 'Koerth', 29.3088893890381, 0.511536619941544, -96.9963912963867, -1.69290639067472, 218, 51, 'PPL', 'P'),
(55726, 'Koester', 38.0222206115723, 0.663612938591588, -90.4094390869141, -1.57794238694791, 218, 29, 'PPL', 'P'),
(178468, 'Kofa', 32.8819389343262, 0.573898098843707, -113.64582824707, -1.98349388406735, 218, 5, 'PPL', 'P'),
(103404, 'Koger (historical)', 36.6324996948242, 0.639357732910501, -80.0986099243164, -1.39798446944993, 218, 53, 'PPL', 'P'),
(211941, 'Koggiung', 58.8669395446777, 1.02742191562708, -157.007507324219, -2.74029795315673, 218, 1, 'PPL', 'P'),
(178469, 'Kohatk', 32.5783309936523, 0.568599140643749, -112.004997253418, -1.95485598075935, 218, 5, 'PPL', 'P'),
(55728, 'Kohl City', 38.598331451416, 0.673667969603291, -91.3644409179688, -1.59461031326239, 218, 29, 'PPL', 'P'),
(36754, 'Kohler', 38.8702812194824, 0.678414388456085, -84.3294372558594, -1.47182633646872, 218, 21, 'PPL', 'P'),
(177424, 'Kohler', 43.7391700744629, 0.763392529889151, -87.7816696166992, -1.53207915770927, 218, 57, 'PPL', 'P'),
(150064, 'Kohlertown', 41.7713890075684, 0.729048271313434, -74.9422225952148, -1.30798853304899, 218, 40, 'PPL', 'P'),
(163428, 'Kohlmeyer Corner', 41.1436080932617, 0.718091427377603, -79.8461074829102, -1.39357747047806, 218, 45, 'PPL', 'P'),
(178470, 'Kohls Ranch', 34.3252792358398, 0.599089139331848, -111.093612670898, -1.93894931904247, 218, 5, 'PPL', 'P'),
(109997, 'Kohlsaat', 37.9416694641113, 0.662207055852135, -81.704719543457, -1.42601637045188, 218, 58, 'PPL', 'P'),
(174803, 'Kohlsville', 43.4711112976074, 0.758714021644154, -88.3219375610352, -1.54150861218091, 218, 57, 'PPL', 'P'),
(95352, 'Kohrville', 30.0119400024414, 0.523807167953598, -95.5852813720703, -1.66827787638783, 218, 51, 'PPL', 'P'),
(142187, 'Koinzan Ranch', 41.9722213745117, 0.73255345736117, -98.4094390869141, -1.71756872710745, 218, 35, 'PPL', 'P'),
(127897, 'Kokadjo', 45.6711082458496, 0.797111211924807, -69.4475021362305, -1.21208756956302, 218, 26, 'PPL', 'P'),
(95353, 'Kokernot', 29.4427795410156, 0.513873443929547, -97.2663879394531, -1.69761872106556, 218, 51, 'PPL', 'P'),
(211942, 'Kokhanok', 59.4394416809082, 1.037413962879, -154.776107788086, -2.70135268432374, 218, 1, 'PPL', 'P'),
(210459, 'Kokokahi', 21.4141693115234, 0.373747761065611, -157.778884887695, -2.75376103141541, 218, 15, 'PPL', 'P'),
(9895, 'Kokomo', 34.8819389343262, 0.608804683883594, -90.5494384765625, -1.58038583724805, 218, 4, 'PPL', 'P'),
(60514, 'Kokomo', 31.1972198486328, 0.54449420382717, -90.0027770996094, -1.57084479632674, 218, 30, 'PPL', 'P'),
(95354, 'Kokomo', 32.2827796936035, 0.563440797349348, -98.704719543457, -1.72272234329092, 218, 51, 'PPL', 'P'),
(122974, 'Kokomo', 40.4863891601563, 0.706620793088468, -86.1336135864258, -1.50331515372365, 218, 19, 'PPL', 'P'),
(186931, 'Kokomo', 39.4241714477539, 0.688081596634045, -106.189170837402, -1.85335066107542, 218, 7, 'PPL', 'P'),
(210460, 'Kokomo', 20.8700008392334, 0.364250229538603, -156.308883666992, -2.7281046701058, 218, 15, 'PPL', 'P'),
(178471, 'Kokopnyama', 35.7802810668945, 0.624483711906299, -110.124717712402, -1.92203891191074, 218, 5, 'PPL', 'P'),
(211943, 'Kokrines', 64.9377822875977, 1.13337810986183, -154.691940307617, -2.69988368466645, 218, 1, 'PPL', 'P'),
(211944, 'Kokruagarok', 70.9150009155273, 1.23770025503075, -153.072494506836, -2.67161902338522, 218, 1, 'PPL', 'P'),
(60515, 'Kola', 31.625, 0.551960375943207, -89.5272216796875, -1.5625447884734, 218, 30, 'PPL', 'P'),
(174805, 'Kolb', 44.422779083252, 0.775323757888815, -87.9630584716797, -1.5352449904551, 218, 57, 'PPL', 'P'),
(174804, 'Kolberg', 44.7191696166992, 0.780496748569212, -87.5488891601563, -1.5280163723083, 218, 57, 'PPL', 'P'),
(48753, 'Kolbes Corner', 38.9002799987793, 0.678937965926394, -76.7927780151367, -1.34028681811725, 218, 25, 'PPL', 'P'),
(140337, 'Koldok', 46.9286117553711, 0.819058788521341, -97.7233276367188, -1.70559382326591, 218, 34, 'PPL', 'P'),
(30268, 'Koleen', 38.9713897705078, 0.680179065573399, -86.8288879394531, -1.51544998038865, 218, 19, 'PPL', 'P'),
(211945, 'Koliganek', 59.7286109924316, 1.04246091946081, -157.284439086914, -2.74513132421911, 218, 1, 'PPL', 'P'),
(41635, 'Kolin', 31.2830600738525, 0.545992398387907, -92.3225021362305, -1.61133163595672, 218, 22, 'PPL', 'P'),
(196843, 'Kolin', 47.1066703796387, 0.822166497776382, -109.772216796875, -1.91588661031849, 218, 31, 'PPL', 'P'),
(142188, 'Koller', 40.5380592346191, 0.707522606012597, -98.8602828979492, -1.72543743602226, 218, 35, 'PPL', 'P'),
(156020, 'Kolmont', 40.3122215270996, 0.703580994441225, -80.6611099243164, -1.4078019464924, 218, 41, 'PPL', 'P'),
(210464, 'Koloa', 21.9066696166992, 0.382343512958006, -159.469177246094, -2.78326219839076, 218, 15, 'PPL', 'P'),
(210466, 'Koloa Mill', 21.9033298492432, 0.382285223019646, -159.447494506836, -2.78288376319986, 218, 15, 'PPL', 'P'),
(16744, 'Kolokee', 28.6961097717285, 0.500841598030381, -81.1383285522461, -1.41613098280162, 218, 12, 'PPL', 'P'),
(60516, 'Kolola Springs', 33.6538887023926, 0.587371163956473, -88.4088897705078, -1.5430262145281, 218, 30, 'PPL', 'P'),
(182512, 'Koloma (historical)', 38.7999992370605, 0.677187736457994, -120.888893127441, -2.1099092141654, 218, 6, 'PPL', 'P'),
(41636, 'Kolter', 32.1527786254883, 0.561171850679627, -93.9241714477539, -1.63928603897095, 218, 22, 'PPL', 'P'),
(178472, 'Kom Kug', 31.610559463501, 0.551708341035544, -111.670280456543, -1.94901407059215, 218, 5, 'PPL', 'P'),
(178473, 'Kom Vo', 31.9597206115723, 0.557802352689432, -112.348327636719, -1.96084822637008, 218, 5, 'PPL', 'P'),
(178477, 'Komak Wuacho', 32.2236099243164, 0.562408090057642, -112.329437255859, -1.96051852702713, 218, 5, 'PPL', 'P'),
(210468, 'Komakawai', 19.3977794647217, 0.338555119235137, -155.776107788086, -2.71880597684368, 218, 15, 'PPL', 'P'),
(76300, 'Komalty', 35.0475006103516, 0.611694280245357, -98.9899978637695, -1.72770138926493, 218, 42, 'PPL', 'P'),
(182510, 'Komandorski Village', 37.7161102294922, 0.658270304549753, -121.907783508301, -2.12769220602829, 218, 6, 'PPL', 'P'),
(150065, 'Komar Park', 42.9113883972168, 0.748945014133525, -73.945556640625, -1.29059343059886, 218, 40, 'PPL', 'P'),
(178474, 'Komatke', 33.2933311462402, 0.58107824745867, -112.17472076416, -1.95781821483984, 218, 5, 'PPL', 'P'),
(95355, 'Komensky', 29.5719394683838, 0.516127709923759, -97.0458297729492, -1.6937692548679, 218, 51, 'PPL', 'P'),
(136266, 'Komensky', 44.9072189331055, 0.783778828296626, -94.2766723632813, -1.6454383405632, 218, 28, 'PPL', 'P'),
(210469, 'Komohana Kai', 19.6138896942139, 0.342326954287016, -155.971664428711, -2.72221908409673, 218, 15, 'PPL', 'P'),
(170663, 'Komstad (historical)', 43.038890838623, 0.751170351540396, -96.9027786254883, -1.69127254134596, 218, 49, 'PPL', 'P'),
(178475, 'Kon Tiki Mobile Home Park', 33.334171295166, 0.581791042524429, -111.850830078125, -1.95216525595199, 218, 5, 'PPL', 'P'),
(36755, 'Kona', 37.1575012207031, 0.648520738115082, -82.7388916015625, -1.44406607789795, 218, 21, 'PPL', 'P'),
(112449, 'Kona', 35.9500007629395, 0.627445879407767, -82.1919403076172, -1.43451997697056, 218, 33, 'PPL', 'P'),
(210470, 'Kona South Estates', 19.0722198486328, 0.332873032022857, -155.80778503418, -2.71935884908598, 218, 15, 'PPL', 'P'),
(76301, 'Konawa', 34.9594383239746, 0.610157303401245, -96.7525024414063, -1.68864972714639, 218, 42, 'PPL', 'P'),
(170664, 'Kones Corner', 44.7313919067383, 0.780710067772527, -97.1072235107422, -1.6948407777325, 218, 49, 'PPL', 'P'),
(60517, 'Kongo', 33.1177787780762, 0.578014280624534, -90.7383270263672, -1.58368256436146, 218, 30, 'PPL', 'P'),
(198488, 'Kongsberg', 47.851390838623, 0.835164321792623, -100.800827026367, -1.75930632034339, 218, 34, 'PPL', 'P'),
(81922, 'Konig', 33.711669921875, 0.588379636482258, -78.9219436645508, -1.37744776901989, 218, 48, 'PPL', 'P'),
(116345, 'Konigsmark', 41.8899993896484, 0.73111841300778, -91.6922225952148, -1.60033118275804, 218, 16, 'PPL', 'P'),
(136268, 'Koniska', 44.8450012207031, 0.782692924362146, -94.2174987792969, -1.64440556669247, 218, 28, 'PPL', 'P'),
(125187, 'Konkapot', 42.077220916748, 0.73438604508628, -73.1624984741211, -1.27692648735874, 218, 23, 'PPL', 'P'),
(195195, 'Konkolville', 46.4955596923828, 0.811500604189642, -116.196937561035, -2.02801914117433, 218, 17, 'PPL', 'P'),
(103405, 'Konnarock', 36.665828704834, 0.639939433871601, -81.6383285522461, -1.42485762906159, 218, 53, 'PPL', 'P'),
(95356, 'Koockville', 30.7569408416748, 0.536809885528341, -99.2497177124023, -1.73223435575636, 218, 51, 'PPL', 'P'),
(178476, 'Kool Corner', 32.8005599975586, 0.572477768455341, -114.498611450195, -1.99837775876759, 218, 5, 'PPL', 'P'),
(81924, 'Koonce', 34.1366691589355, 0.595797272487429, -79.2922210693359, -1.38391032887913, 218, 48, 'PPL', 'P'),
(9896, 'Koones Gulf (historical)', 35.5675010681152, 0.620770000345211, -92.7555618286133, -1.61888995344647, 218, 4, 'PPL', 'P'),
(163429, 'Koonsville', 41.1691703796387, 0.718537573439219, -76.1611099243164, -1.32926213015265, 218, 45, 'PPL', 'P'),
(48754, 'Koontz', 39.5805587768555, 0.690811070435267, -78.9891662597656, -1.37862102463812, 218, 25, 'PPL', 'P'),
(122975, 'Koontz Lake', 41.4180603027344, 0.722881522072274, -86.4858322143555, -1.50946252846788, 218, 19, 'PPL', 'P'),
(66157, 'Koontzville', 36.1433296203613, 0.630820104508897, -79.7688903808594, -1.39222977780843, 218, 33, 'PPL', 'P'),
(78571, 'Koontzville', 39.9377784729004, 0.697045730284225, -78.4691696166992, -1.3695453711173, 218, 45, 'PPL', 'P'),
(207820, 'Koontzville', 48.0158309936523, 0.838034343920374, -118.946113586426, -2.07600131453429, 218, 56, 'PPL', 'P'),
(192658, 'Koosharem', 38.5102806091309, 0.672131192496261, -111.880561828613, -1.95268417289039, 218, 52, 'PPL', 'P'),
(195198, 'Kooskia', 46.1450004577637, 0.805382191322267, -115.976936340332, -2.02417939551466, 218, 17, 'PPL', 'P'),
(207821, 'Kooskooskie', 46.0102806091309, 0.803030886395836, -118.119171142578, -2.06156844616466, 218, 56, 'PPL', 'P'),
(195196, 'Kootenai', 48.3102798461914, 0.8431734458759, -116.512496948242, -2.03352669146667, 218, 17, 'PPL', 'P'),
(196844, 'Kootenai Falls', 48.4480590820313, 0.845578147182187, -115.781669616699, -2.02077134826768, 218, 31, 'PPL', 'P'),
(95357, 'Kopernik Shores', 25.9916706085205, 0.453640230212521, -97.1819381713867, -1.69614479456026, 218, 51, 'PPL', 'P'),
(207822, 'Kopiah', 46.7061080932617, 0.815175367019788, -122.806671142578, -2.14338075485189, 218, 56, 'PPL', 'P'),
(103411, 'Kopp', 38.5900001525879, 0.673522561007773, -77.4461135864258, -1.35168967495664, 218, 53, 'PPL', 'P'),
(32, 'Koppe', 30.5722198486328, 0.533585896002205, -96.3261108398438, -1.68120778979627, 218, 51, 'PPL', 'P'),
(163430, 'Koppel', 40.834171295166, 0.712690736424004, -80.3225021362305, -1.4018921257174, 218, 45, 'PPL', 'P'),
(204576, 'Kopper View Mobile Home Park', 40.711669921875, 0.710552684121861, -112.057777404785, -1.95577716818041, 218, 52, 'PPL', 'P'),
(95358, 'Kopperl', 32.0697212219238, 0.55972222551927, -97.5036087036133, -1.70175900445425, 218, 51, 'PPL', 'P'),
(109998, 'Kopperston', 37.7483291625977, 0.658832631013923, -81.5697174072266, -1.42366013867744, 218, 58, 'PPL', 'P'),
(41637, 'Koran', 32.4249992370605, 0.565922996643356, -93.4627838134766, -1.63123330562483, 218, 22, 'PPL', 'P'),
(193713, 'Korbel', 40.8705596923828, 0.713325833764961, -123.957221984863, -2.16346165526137, 218, 6, 'PPL', 'P'),
(193714, 'Korblex', 40.9036102294922, 0.713902674457072, -124.070281982422, -2.16543492447106, 218, 6, 'PPL', 'P'),
(36756, 'Korea', 37.9419403076172, 0.66221178296307, -83.4786071777344, -1.45697655023044, 218, 21, 'PPL', 'P'),
(103406, 'Korea', 38.6313896179199, 0.674244943453457, -78.0130615234375, -1.36158478314489, 218, 53, 'PPL', 'P'),
(207823, 'Koren', 46.795280456543, 0.81673171836083, -119.015281677246, -2.07720852545642, 218, 56, 'PPL', 'P'),
(163432, 'Korn Krest', 41.2180595397949, 0.71939085025248, -75.9441680908203, -1.32547578087283, 218, 45, 'PPL', 'P'),
(66152, 'Kornegay', 35.0577812194824, 0.611873710723801, -77.8258285522461, -1.35831695132931, 218, 33, 'PPL', 'P'),
(196845, 'Korner (historical)', 48.9111099243164, 0.853659908984196, -112.319442749023, -1.96034408997573, 218, 31, 'PPL', 'P'),
(196846, 'Korner Kourt', 45.672779083252, 0.797140373538744, -111.185562133789, -1.94055413991535, 218, 31, 'PPL', 'P'),
(186932, 'Kornman', 38.1502799987793, 0.665847996536437, -102.611671447754, -1.79091151773796, 218, 7, 'PPL', 'P'),
(174807, 'Koro', 43.9680595397949, 0.767387404682324, -88.8444366455078, -1.55062794154362, 218, 57, 'PPL', 'P'),
(16745, 'Korona', 29.4066696166992, 0.51324320685758, -81.1966705322266, -1.41714924244441, 218, 12, 'PPL', 'P'),
(150066, 'Kortright Center', 42.4174995422363, 0.740325027475211, -74.7758331298828, -1.30508448903831, 218, 40, 'PPL', 'P'),
(150072, 'Kortright Station', 42.4061088562012, 0.740126222499837, -74.7961120605469, -1.30543842314718, 218, 40, 'PPL', 'P'),
(60518, 'Kosciusko', 33.0574989318848, 0.576962198835898, -89.5875015258789, -1.56359687026203, 218, 30, 'PPL', 'P'),
(95359, 'Kosciusko', 29.1052799224854, 0.507982964361969, -97.9502792358398, -1.70955487591324, 218, 51, 'PPL', 'P'),
(55729, 'Koshkonong', 36.5958290100098, 0.638717708721527, -91.6455612182617, -1.59951678809669, 218, 29, 'PPL', 'P'),
(174808, 'Koshkonong', 42.8461112976074, 0.74780571381919, -88.9191665649414, -1.55193222468748, 218, 57, 'PPL', 'P'),
(174813, 'Koshkonong Manor', 42.9013900756836, 0.748770510503098, -88.9599990844727, -1.55264488659519, 218, 57, 'PPL', 'P'),
(174809, 'Koshkonong Mounds', 42.8741683959961, 0.748295402564628, -88.9119415283203, -1.55180612400987, 218, 57, 'PPL', 'P'),
(199458, 'Koshopah', 42.1011085510254, 0.734802962954932, -100.103889465332, -1.74714246522251, 218, 35, 'PPL', 'P'),
(103407, 'Kosmo Village Mobile Home Park', 37.7080612182617, 0.658129822802251, -77.4691696166992, -1.35209207859735, 218, 53, 'PPL', 'P'),
(207824, 'Kosmos (historical)', 46.4980583190918, 0.811544213452492, -122.186668395996, -2.13255966555263, 218, 56, 'PPL', 'P'),
(36757, 'Kosmosdale', 38.0327796936035, 0.663797229339022, -85.9091720581055, -1.49939791007625, 218, 21, 'PPL', 'P'),
(76303, 'Kosoma', 34.348331451416, 0.599491476393532, -95.6127777099609, -1.66875777801626, 218, 42, 'PPL', 'P'),
(131606, 'Koss', 45.3905601501465, 0.792214723944588, -87.7063903808594, -1.53076528718548, 218, 27, 'PPL', 'P'),
(95360, 'Kosse', 31.3075008392334, 0.546418970215511, -96.6316680908203, -1.68654076987916, 218, 51, 'PPL', 'P'),
(30269, 'Kossuth', 38.7044410705566, 0.675519931825332, -86.102783203125, -1.5027770620254, 218, 19, 'PPL', 'P'),
(60519, 'Kossuth', 34.871940612793, 0.608630180253166, -88.6458282470703, -1.54716157106877, 218, 30, 'PPL', 'P'),
(95361, 'Kossuth', 31.7422199249268, 0.554006249582119, -95.4986114501953, -1.66676520088867, 218, 51, 'PPL', 'P'),
(116348, 'Kossuth', 41.0105590820313, 0.715769284065109, -91.1344375610352, -1.59059599739325, 218, 16, 'PPL', 'P'),
(150069, 'Kossuth', 42.0641708374023, 0.734158278234051, -78.1425018310547, -1.3638439426976, 218, 40, 'PPL', 'P'),
(156021, 'Kossuth', 40.6594390869141, 0.709641084080727, -84.3480606079102, -1.47215137527976, 218, 41, 'PPL', 'P'),
(163433, 'Kossuth', 41.2847213745117, 0.720554318753708, -79.5741729736328, -1.38883131794138, 218, 45, 'PPL', 'P'),
(16746, 'Kossuthville', 28.0441703796387, 0.489463109114963, -81.8461074829102, -1.42848405551795, 218, 12, 'PPL', 'P'),
(136270, 'Kost', 45.4919395446777, 0.793984128172836, -92.8677825927734, -1.62084857527017, 218, 28, 'PPL', 'P'),
(120243, 'Koster', 41.0916709899902, 0.717184953921567, -87.6849975585938, -1.53039191200065, 218, 18, 'PPL', 'P'),
(150070, 'Kosterville', 43.6158294677734, 0.761239830201012, -75.3349990844727, -1.31484377601096, 218, 40, 'PPL', 'P'),
(116347, 'Koszta', 41.827220916748, 0.730022721956294, -92.2052764892578, -1.60928566244927, 218, 16, 'PPL', 'P'),
(209552, 'Kotey Place', 42.7247200012207, 0.745687036013977, -108.603332519531, -1.89548573110405, 218, 59, 'PPL', 'P'),
(196847, 'Kotke', 45.3386116027832, 0.79130805075147, -110.896942138672, -1.93551677071347, 218, 31, 'PPL', 'P'),
(211946, 'Kotlik', 63.0341682434082, 1.10015377710352, -163.553329467773, -2.85454410181171, 218, 1, 'PPL', 'P'),
(211947, 'Kotzebue', 66.8983306884766, 1.16759613460188, -162.596664428711, -2.83784714704135, 218, 1, 'PPL', 'P'),
(95362, 'Kountry Hill Estates Colonia', 26.2560005187988, 0.458253657458379, -98.3870010375977, -1.71717710926916, 218, 51, 'PPL', 'P'),
(196848, 'Kountz Trailer Park', 45.6694412231445, 0.797082116889898, -111.094436645508, -1.93896370011236, 218, 31, 'PPL', 'P'),
(95364, 'Kountze', 30.3713893890381, 0.530080743243984, -94.3122177124023, -1.64605872393914, 218, 51, 'PPL', 'P'),
(122977, 'Kouts', 41.3166694641113, 0.721111918106944, -87.0258331298828, -1.51888732240762, 218, 19, 'PPL', 'P'),
(109999, 'Kovan', 38.5394401550293, 0.672640122580575, -80.3777770996094, -1.40285685582228, 218, 58, 'PPL', 'P'),
(95363, 'Kovar', 29.9016704559326, 0.521882601302338, -97.2136077880859, -1.6966975336445, 218, 51, 'PPL', 'P'),
(3575, 'Kowaliga', 32.7400016784668, 0.571420826397716, -85.9691696166992, -1.50044506501687, 218, 2, 'PPL', 'P'),
(196849, 'Koyl', 47.9002799987793, 0.836017598605884, -112.261940002441, -1.95934047771893, 218, 31, 'PPL', 'P'),
(211948, 'Koyuk', 64.9319381713867, 1.13327611079208, -161.156936645508, -2.81271915689202, 218, 1, 'PPL', 'P'),
(211949, 'Koyukuk', 64.8802795410156, 1.13237449760504, -157.700836181641, -2.75239882451783, 218, 1, 'PPL', 'P'),
(73137, 'Kozy Corners', 39.5686111450195, 0.690602544921914, -83.2016677856445, -1.45214304601, 218, 41, 'PPL', 'P'),
(60520, 'Kracker Station', 32.2772216796875, 0.563343791706641, -89.6852798461914, -1.56530342388855, 218, 30, 'PPL', 'P'),
(41638, 'Kraemer', 29.8666706085205, 0.521271738727301, -90.6969375610352, -1.58296018191578, 218, 22, 'PPL', 'P'),
(36758, 'Kraft', 37.7169418334961, 0.658284818777694, -85.970832824707, -1.50047409347275, 218, 21, 'PPL', 'P'),
(41639, 'Kraft', 31.9055595397949, 0.556857063660508, -93.1711120605469, -1.62614267320114, 218, 22, 'PPL', 'P'),
(48756, 'Kraft Corner', 39.3330612182617, 0.686491423147159, -76.8222198486328, -1.34080067504958, 218, 25, 'PPL', 'P'),
(78572, 'Kraft Mill', 39.8202781677246, 0.694994963086809, -76.8772201538086, -1.3417606114645, 218, 45, 'PPL', 'P'),
(136272, 'Kragnes', 46.9883308410645, 0.820101083192971, -96.7513885498047, -1.68863028607043, 218, 28, 'PPL', 'P'),
(36761, 'Kragon', 37.5066719055176, 0.654614916216537, -83.3444366455078, -1.45463483268393, 218, 21, 'PPL', 'P'),
(209920, 'Krain', 47.2430610656738, 0.824546964316749, -121.988059997559, -2.12909329507778, 218, 56, 'PPL', 'P'),
(55730, 'Krakow', 38.497501373291, 0.671908152754967, -91.0455627441406, -1.58904483921634, 218, 29, 'PPL', 'P'),
(142189, 'Krakow', 41.394718170166, 0.722474125004519, -97.7522201538086, -1.70609809281832, 218, 35, 'PPL', 'P'),
(174812, 'Krakow', 44.7616691589355, 0.781238505511826, -88.2513885498047, -1.54027729965092, 218, 57, 'PPL', 'P'),
(163434, 'Kralltown', 40.019718170166, 0.698475847789597, -76.9830627441406, -1.34360791315464, 218, 45, 'PPL', 'P'),
(22435, 'Kramer', 31.9558296203613, 0.557734442081635, -83.3899993896484, -1.45543005258543, 218, 13, 'PPL', 'P'),
(32947, 'Kramer', 37.360279083252, 0.652059879466715, -94.7297210693359, -1.65334553215576, 218, 20, 'PPL', 'P'),
(122978, 'Kramer', 40.3386116027832, 0.704041588151754, -87.2874984741211, -1.52345424420294, 218, 19, 'PPL', 'P'),
(142190, 'Kramer', 40.5883293151855, 0.708399984433723, -96.875, -1.69078771286951, 218, 35, 'PPL', 'P'),
(182515, 'Kramer', 34.9944381713867, 0.610768165976282, -117.584999084473, -2.05224538497857, 218, 6, 'PPL', 'P'),
(198490, 'Kramer', 48.690559387207, 0.849810575944595, -100.706390380859, -1.75765808994474, 218, 34, 'PPL', 'P'),
(9897, 'Kramer (historical)', 35.0966682434082, 0.612552417327608, -91.397216796875, -1.59518236026453, 218, 4, 'PPL', 'P'),
(182516, 'Kramer Hills', 34.9208297729492, 0.609483457066428, -117.467781066895, -2.05019954462917, 218, 6, 'PPL', 'P'),
(182517, 'Kramer Junction', 34.9925003051758, 0.610734343830438, -117.540832519531, -2.05147453300104, 218, 6, 'PPL', 'P'),
(192904, 'Kramm', 39.5530586242676, 0.690331102227808, -121.583610534668, -2.12203432029242, 218, 6, 'PPL', 'P'),
(22436, 'Krannert', 34.2572212219238, 0.597901302906646, -85.3274993896484, -1.48924580684282, 218, 13, 'PPL', 'P'),
(170667, 'Kranzburg', 44.8925018310547, 0.783521966409487, -96.9186096191406, -1.69154884430905, 218, 49, 'PPL', 'P'),
(88335, 'Krapp Spring', 35.2550010681152, 0.615315846432729, -86.9444427490234, -1.51746679228217, 218, 50, 'PPL', 'P'),
(163435, 'Krassdale', 40.4313888549805, 0.705660856673549, -75.4850006103516, -1.31746179652056, 218, 45, 'PPL', 'P'),
(9898, 'Kratnek (historical)', 34.4161109924316, 0.600674452549745, -91.7333297729492, -1.60104863835571, 218, 4, 'PPL', 'P'),
(163436, 'Kratz', 40.3158302307129, 0.703643978201005, -75.4716720581055, -1.31722916939935, 218, 45, 'PPL', 'P'),
(163437, 'Kratzerville', 40.8600006103516, 0.713141543017527, -76.896110534668, -1.34209031080745, 218, 45, 'PPL', 'P'),
(30270, 'Kratzville', 38.0224990844727, 0.663617798860577, -87.585563659668, -1.5286564630763, 218, 19, 'PPL', 'P'),
(88336, 'Kraus (historical)', 35.665828704834, 0.622486141351658, -87.0311126708984, -1.51897946778133, 218, 50, 'PPL', 'P'),
(150071, 'Kraus Landing', 43.1894416809082, 0.753797959429922, -76.0238876342773, -1.32686714938434, 218, 40, 'PPL', 'P'),
(163438, 'Krause', 40.3847198486328, 0.704846328854149, -77.7255630493164, -1.35656698817702, 218, 45, 'PPL', 'P'),
(194276, 'Krauss', 40.1069412231445, 0.699998177247714, -104.442222595215, -1.82286066238732, 218, 7, 'PPL', 'P'),
(211950, 'Kravaksarak', 62.8136100769043, 1.09630431090587, -164.076934814453, -2.86368273909232, 218, 1, 'PPL', 'P'),
(163439, 'Krayn', 40.2691688537598, 0.702829583539659, -78.726936340332, -1.37404424914677, 218, 45, 'PPL', 'P'),
(163440, 'Kreamer', 40.8030586242676, 0.712147717877737, -76.9641723632813, -1.34327821381168, 218, 45, 'PPL', 'P'),
(36759, 'Krebs', 36.9944381713867, 0.645674751016169, -88.605827331543, -1.54646342338901, 218, 21, 'PPL', 'P'),
(76305, 'Krebs', 34.9277801513672, 0.609604764054081, -95.7155609130859, -1.67055168332654, 218, 42, 'PPL', 'P'),
(163442, 'Krebs', 40.8497200012207, 0.712962112539083, -76.2002792358398, -1.32994576360447, 218, 45, 'PPL', 'P'),
(95365, 'Krebsville', 29.9902801513672, 0.523429132236861, -96.5844421386719, -1.68571652152178, 218, 51, 'PPL', 'P'),
(16747, 'Kreftwood Estates', 29.6319408416748, 0.517174931443405, -82.2702789306641, -1.43588724387421, 218, 12, 'PPL', 'P'),
(163444, 'Kregar', 40.1213912963867, 0.700250378602944, -79.3069381713867, -1.38416719076627, 218, 45, 'PPL', 'P'),
(163443, 'Kreidersville', 40.7191696166992, 0.710683578489439, -75.495002746582, -1.31763636673002, 218, 45, 'PPL', 'P'),
(48757, 'Kreigbaum', 39.6922187805176, 0.69275990514196, -78.7861099243164, -1.3750770230175, 218, 25, 'PPL', 'P'),
(122980, 'Kreitzburg', 41.4358291625977, 0.723191647181214, -87.521110534668, -1.52753154383185, 218, 19, 'PPL', 'P'),
(73139, 'Kreitzer Corner', 39.7597198486328, 0.693938021029184, -84.4430618286133, -1.47380945937445, 218, 41, 'PPL', 'P'),
(163447, 'Kremis', 41.3472213745117, 0.721645149536205, -80.3116683959961, -1.40170304128, 218, 45, 'PPL', 'P'),
(76306, 'Kremlin', 36.5472183227539, 0.637869292177255, -97.8311080932617, -1.70747494710189, 218, 42, 'PPL', 'P'),
(103409, 'Kremlin', 38.0294418334961, 0.663738972690176, -76.6916732788086, -1.33852220757897, 218, 53, 'PPL', 'P'),
(174814, 'Kremlin', 45.6508293151855, 0.796757277815936, -87.8447189331055, -1.53317957587169, 218, 57, 'PPL', 'P'),
(196850, 'Kremlin', 48.5697212219238, 0.847701552098334, -110.085830688477, -1.92136020530693, 218, 31, 'PPL', 'P'),
(55731, 'Kremlin Mill', 36.6313896179199, 0.63933835841357, -90.5708312988281, -1.58075921243288, 218, 29, 'PPL', 'P'),
(194277, 'Kremmling', 40.0588912963867, 0.699159547820448, -106.388328552246, -1.85682661893019, 218, 7, 'PPL', 'P'),
(60521, 'Kreole', 30.4058303833008, 0.530681851991528, -88.4947204589844, -1.54452424264126, 218, 30, 'PPL', 'P'),
(55732, 'Krepin (historical)', 36.6186103820801, 0.639115318672276, -89.7202835083008, -1.56591435304262, 218, 29, 'PPL', 'P'),
(182518, 'Kres', 39.1986083984375, 0.684144778752636, -121.01000213623, -2.11202296512259, 218, 6, 'PPL', 'P'),
(163445, 'Kresgeville', 40.8969383239746, 0.713786227738408, -75.5033264160156, -1.31778164216748, 218, 45, 'PPL', 'P'),
(81923, 'Kress', 32.6433296203613, 0.569733580689096, -80.8844375610352, -1.41169974906384, 218, 48, 'PPL', 'P'),
(103410, 'Kress', 36.9302787780762, 0.644554958356818, -77.8105621337891, -1.35805050206224, 218, 53, 'PPL', 'P'),
(191702, 'Kress', 34.3663902282715, 0.599806661508543, -101.748062133789, -1.77583869175839, 218, 51, 'PPL', 'P'),
(9899, 'Kress City', 33.2941703796387, 0.581092894844665, -93.6047210693359, -1.63371057807082, 218, 4, 'PPL', 'P'),
(71004, 'Kresson', 39.8574981689453, 0.695644574655707, -74.9216690063477, -1.30762980525015, 218, 37, 'PPL', 'P'),
(163446, 'Kreutz Creek', 40.0038909912109, 0.698199611405529, -76.6186065673828, -1.33724695289098, 218, 45, 'PPL', 'P'),
(95366, 'Kreutzberg', 29.8633308410645, 0.521213448788942, -98.6750030517578, -1.72220369266863, 218, 51, 'PPL', 'P'),
(186933, 'Kreybill', 38.1138916015625, 0.66521289919548, -103.099998474121, -1.79943443217454, 218, 7, 'PPL', 'P'),
(163448, 'Kricks Mill', 40.4130592346191, 0.705340944447604, -76.1697235107422, -1.32941246559619, 218, 45, 'PPL', 'P'),
(142191, 'Krider', 40.0708312988281, 0.699367940175747, -96.7458267211914, -1.6885332138487, 218, 35, 'PPL', 'P'),
(188780, 'Krider', 34.4338912963867, 0.600984777395767, -103.843612670898, -1.81241294827288, 218, 38, 'PPL', 'P'),
(191703, 'Kriebaum Place', 30.208890914917, 0.527244609841104, -103.086936950684, -1.79920646558523, 218, 51, 'PPL', 'P'),
(88337, 'Kries', 35.9291687011719, 0.627082291339944, -84.4408264160156, -1.47377044406448, 218, 50, 'PPL', 'P'),
(30271, 'Kriete Corner', 38.9174995422363, 0.67923850365541, -85.8327789306641, -1.49806459847651, 218, 19, 'PPL', 'P'),
(163449, 'Krings', 40.2744407653809, 0.702921595755321, -78.9044418334961, -1.37714230444286, 218, 45, 'PPL', 'P'),
(150073, 'Kringsbush', 43.0144386291504, 0.750743579975711, -74.6363906860352, -1.30265075927614, 218, 40, 'PPL', 'P'),
(150074, 'Kripplebush', 41.8402786254883, 0.730250621966578, -74.1944427490234, -1.29493731265289, 218, 40, 'PPL', 'P'),
(95367, 'Kristi Estates Number 1 Colonia', 26.2730007171631, 0.458550366893327, -98.3560028076172, -1.71663608809371, 218, 51, 'PPL', 'P'),
(27645, 'Kritesville', 39.0991706848145, 0.682409263249258, -90.6641693115234, -1.58238826807168, 218, 18, 'PPL', 'P'),
(163450, 'Krocksville', 40.5730590820313, 0.708133468587633, -75.5691680908203, -1.31893079617785, 218, 45, 'PPL', 'P'),
(188781, 'Kroenigs', 35.735279083252, 0.623698279121807, -105.037780761719, -1.83325511327995, 218, 38, 'PPL', 'P'),
(174819, 'Kroghville', 43.0616683959961, 0.751567894912117, -89.008056640625, -1.55348364918051, 218, 57, 'PPL', 'P'),
(174815, 'Krok', 44.4288902282715, 0.775430417490472, -87.633056640625, -1.52948537196559, 218, 57, 'PPL', 'P'),
(110000, 'Krollitz', 37.4716682434082, 0.654003987062473, -81.8605575561523, -1.42873625687318, 218, 58, 'PPL', 'P'),
(142192, 'Kronborg', 41.0027809143066, 0.715633529428542, -97.9397201538086, -1.70937058516581, 218, 35, 'PPL', 'P'),
(174816, 'Kronenwetter', 44.8222198486328, 0.782295314411397, -89.5902786254883, -1.56364533979387, 218, 57, 'PPL', 'P'),
(136275, 'Kroschel', 46.0716705322266, 0.804102342681402, -93.0758285522461, -1.62447966225844, 218, 28, 'PPL', 'P'),
(66153, 'Kross Keys', 35.2322196960449, 0.61491823648198, -82.0783309936523, -1.43253712038094, 218, 33, 'PPL', 'P'),
(41640, 'Krotz Springs', 30.5366706848145, 0.532965446047244, -91.7527770996094, -1.60138805823664, 218, 22, 'PPL', 'P'),
(55734, 'Krueger Ford', 38.5047187805176, 0.672034120274528, -91.6086120605469, -1.59887190363873, 218, 29, 'PPL', 'P'),
(55733, 'Kruegerville (historical)', 38.6302795410156, 0.674225568956527, -91.2205581665039, -1.5920990855125, 218, 29, 'PPL', 'P'),
(182519, 'Krug', 38.5180587768555, 0.672266947132828, -122.480560302734, -2.13768904697018, 218, 6, 'PPL', 'P'),
(95368, 'Krugerville', 33.2813911437988, 0.580869855103371, -96.9902801513672, -1.69279973107306, 218, 51, 'PPL', 'P'),
(103412, 'Krukrak (historical)', 38.5272216796875, 0.672426869956287, -77.4908294677734, -1.35247011431409, 218, 53, 'PPL', 'P'),
(95369, 'Krum', 33.2613906860352, 0.580520781263489, -97.2377777099609, -1.69711937836117, 218, 51, 'PPL', 'P'),
(150075, 'Krum Corner', 42.4861106872559, 0.741522517859366, -76.5741729736328, -1.33647144038155, 218, 40, 'PPL', 'P'),
(163451, 'Krumrine', 40.8016700744629, 0.712123483111817, -77.8811111450195, -1.35928181459224, 218, 45, 'PPL', 'P'),
(156023, 'Krumroy', 41.0149993896484, 0.71584678205283, -81.4733276367188, -1.42197781981683, 218, 41, 'PPL', 'P'),
(163452, 'Krumsville', 40.5786094665527, 0.708230341072285, -75.7975006103516, -1.32291595043305, 218, 45, 'PPL', 'P'),
(150078, 'Krumville', 41.8847198486328, 0.731026267634064, -74.2427825927734, -1.29578100208623, 218, 40, 'PPL', 'P'),
(207826, 'Kruse', 48.0999984741211, 0.839503343577662, -122.173889160156, -2.13233662581134, 218, 56, 'PPL', 'P'),
(207825, 'Kruse Junction', 48.1041717529297, 0.839576181033475, -122.178611755371, -2.13241905064707, 218, 56, 'PPL', 'P'),
(36760, 'Krypton', 37.3111114501953, 0.651201742384464, -83.3394393920898, -1.45454761415823, 218, 21, 'PPL', 'P'),
(178478, 'Kuakatch', 32.1375007629395, 0.560905201675483, -112.662216186523, -1.96632661504848, 218, 5, 'PPL', 'P'),
(210480, 'Kuakini Heights', 19.5977802276611, 0.342045791054931, -155.959167480469, -2.72200097120345, 218, 15, 'PPL', 'P'),
(210476, 'KualapuÃ‚â€˜u', 21.1552791595459, 0.369229275512615, -157.03971862793, -2.74086014646285, 218, 15, 'PPL', 'P'),
(210481, 'Kuau', 20.9294395446777, 0.365287630651729, -156.371109008789, -2.72919070719834, 218, 15, 'PPL', 'P'),
(95370, 'Kubala Store', 29.0691699981689, 0.507352727290002, -97.4908294677734, -1.70153596471296, 218, 51, 'PPL', 'P'),
(150076, 'Kuckville', 43.3605613708496, 0.756784561434392, -78.2658309936523, -1.36599644264866, 218, 40, 'PPL', 'P'),
(142193, 'Kuesters Lake', 40.9222183227539, 0.714227446952007, -98.2949981689453, -1.71557135628989, 218, 35, 'PPL', 'P'),
(210482, 'Kuhio Village', 20.0244407653809, 0.349492422226469, -155.662506103516, -2.71682325341212, 218, 15, 'PPL', 'P'),
(163463, 'Kuhl', 42.0919418334961, 0.734642973552446, -79.9641723632813, -1.39563809137151, 218, 45, 'PPL', 'P'),
(16748, 'Kuhlman', 27.3955593109131, 0.478142710400822, -81.416389465332, -1.42098406125607, 218, 12, 'PPL', 'P'),
(27646, 'Kuhn Station', 38.7819404602051, 0.676872551342984, -89.8763885498047, -1.56863889999582, 218, 18, 'PPL', 'P'),
(66154, 'Kuhns', 34.7902793884277, 0.607204923016783, -77.1319427490234, -1.34620635943023, 218, 33, 'PPL', 'P'),
(163453, 'Kuhnsville', 40.5922203063965, 0.70846789504152, -75.5891723632813, -1.31927993659676, 218, 45, 'PPL', 'P'),
(78574, 'Kuhntown', 39.7727813720703, 0.694165987618495, -80.2727813720703, -1.4010243346762, 218, 45, 'PPL', 'P'),
(178479, 'Kui Tatk', 32.038330078125, 0.559174346704013, -112.080558776855, -1.95617477813116, 218, 5, 'PPL', 'P'),
(178480, 'Kuit Vaya', 31.6783294677734, 0.552891150744189, -111.680282592773, -1.94918864080161, 218, 5, 'PPL', 'P'),
(196851, 'Kuka Crossing', 48.3138885498047, 0.84323642963568, -112.392219543457, -1.96161428465764, 218, 31, 'PPL', 'P'),
(210493, 'Kukio', 19.8213901519775, 0.345948520474387, -156.001937866211, -2.722747455257, 218, 15, 'PPL', 'P'),
(210498, 'Kukui', 19.576940536499, 0.341682069829053, -155.091110229492, -2.7068505140781, 218, 15, 'PPL', 'P'),
(210499, 'Kukui Village', 20.0166702270508, 0.349356800747957, -155.280563354492, -2.71015709488754, 218, 15, 'PPL', 'P'),
(210501, 'Kukuihaele', 20.1213893890381, 0.351184494914565, -155.570831298828, -2.7152232262292, 218, 15, 'PPL', 'P'),
(210508, 'Kukuiula', 21.8886108398438, 0.382028327842995, -159.488891601563, -2.7836062788036, 218, 15, 'PPL', 'P'),
(210518, 'KuliÃ‚â€˜ouÃ‚â€˜ou', 21.288330078125, 0.371551452114623, -157.72917175293, -2.75289337353226, 218, 15, 'PPL', 'P'),
(76308, 'Kullituklo', 33.8519401550293, 0.590827813893341, -94.7219390869141, -1.65320971094016, 218, 42, 'PPL', 'P'),
(140339, 'Kulm', 46.3019409179688, 0.80812131908244, -98.9477767944336, -1.72696449259131, 218, 34, 'PPL', 'P'),
(163454, 'Kulp', 40.8980598449707, 0.71380580197242, -76.350830078125, -1.332573371494, 218, 45, 'PPL', 'P'),
(163455, 'Kulpmont', 40.7933311462402, 0.711977941358245, -76.4727783203125, -1.33470176983719, 218, 45, 'PPL', 'P'),
(163457, 'Kulps', 40.792781829834, 0.71196835397832, -76.6091690063477, -1.33708223637756, 218, 45, 'PPL', 'P'),
(163458, 'Kulps Corner', 40.3819389343262, 0.704797792743282, -75.2200012207031, -1.31283668465542, 218, 45, 'PPL', 'P'),
(163459, 'Kulpsville', 40.2427787780762, 0.70236898982913, -75.3369369506836, -1.31487759815681, 218, 45, 'PPL', 'P'),
(163460, 'Kulptown', 40.2444381713867, 0.702397951705984, -75.7961120605469, -1.32289171566713, 218, 45, 'PPL', 'P'),
(207827, 'Kulshan', 48.8375015258789, 0.852375200074342, -122.136672973633, -2.13168708082147, 218, 56, 'PPL', 'P'),
(3577, 'Kulumi (historical)', 32.4361114501953, 0.566116941349741, -86.1305618286133, -1.50326189050185, 218, 2, 'PPL', 'P'),
(207828, 'Kulzer', 48.1505584716797, 0.840385782004859, -117.723609924316, -2.05466460051279, 218, 56, 'PPL', 'P'),
(120244, 'Kumler', 40.2997207641602, 0.70336281496892, -88.5780563354492, -1.54597872807061, 218, 18, 'PPL', 'P'),
(207829, 'Kummer', 47.2869415283203, 0.825312822867229, -122.019996643066, -2.12965069469394, 218, 56, 'PPL', 'P'),
(207830, 'Kumtux', 45.7894401550293, 0.799176493350164, -122.519721984863, -2.13837254726395, 218, 56, 'PPL', 'P'),
(210523, 'Kumukumu', 22.1108303070068, 0.385906789207018, -159.309997558594, -2.78048398874159, 218, 15, 'PPL', 'P'),
(195199, 'Kuna', 43.4919395446777, 0.75907754313295, -116.419166564941, -2.03189776898592, 218, 17, 'PPL', 'P'),
(194278, 'Kuner', 40.3761100769043, 0.704696059989641, -104.48999786377, -1.82369449812462, 218, 7, 'PPL', 'P'),
(174820, 'Kunesh', 44.6155586242676, 0.778688395610021, -88.1902770996094, -1.53921070363434, 218, 57, 'PPL', 'P'),
(150077, 'Kuneytown', 42.8358306884766, 0.747626283340745, -76.7813873291016, -1.34008801314188, 218, 40, 'PPL', 'P'),
(66155, 'Kungsboro', 35.917781829834, 0.626883552943597, -77.6711120605469, -1.35561663914202, 218, 33, 'PPL', 'P'),
(210524, 'Kunia Camp', 21.4633293151855, 0.374605764989808, -158.065277099609, -2.75875951846538, 218, 15, 'PPL', 'P'),
(156024, 'Kunkle', 41.6366691589355, 0.726696966387003, -84.4952774047852, -1.47472079309947, 218, 41, 'PPL', 'P'),
(163461, 'Kunkle', 41.3783302307129, 0.722188101503445, -75.982780456543, -1.32614969378668, 218, 45, 'PPL', 'P'),
(163462, 'Kunkletown', 40.8477783203125, 0.712928223814212, -75.4486083984375, -1.31682663260058, 218, 45, 'PPL', 'P'),
(22437, 'Kunsford (historical)', 33.1822204589844, 0.579139000131901, -83.7377777099609, -1.46149992934194, 218, 13, 'PPL', 'P'),
(110001, 'Kuntzville (historical)', 38.980281829834, 0.680334261285923, -79.5908279418945, -1.38912200197436, 218, 58, 'PPL', 'P'),
(22438, 'Kunuga Hills', 33.5152816772461, 0.584952015001272, -84.3241729736328, -1.47173445741111, 218, 13, 'PPL', 'P'),
(182520, 'Kunuqug (historical)', 34.4500007629395, 0.601265940627852, -120.470832824707, -2.1026126854108, 218, 6, 'PPL', 'P'),
(178481, 'Kupk', 31.9236106872559, 0.557172115617464, -112.21305847168, -1.95848733406373, 218, 5, 'PPL', 'P'),
(210528, 'Kupolo', 21.9675006866455, 0.383405215416079, -159.363327026367, -2.78141476354257, 218, 15, 'PPL', 'P'),
(193212, 'Kupreanof', 56.8144416809082, 0.99159907001415, -132.980560302734, -2.32094861842958, 218, 1, 'PPL', 'P'),
(182521, 'Kurand (historical)', 39.5297203063965, 0.68992377173908, -122.288612365723, -2.13433892347691, 218, 6, 'PPL', 'P'),
(9900, 'Kurdo (historical)', 33.8283309936523, 0.590415756293678, -91.2597198486328, -1.59278258580626, 218, 4, 'PPL', 'P'),
(66156, 'Kure Beach', 33.9966697692871, 0.593353822187281, -77.9075012207031, -1.35974240830277, 218, 33, 'PPL', 'P'),
(198494, 'Kuroki', 48.9311103820801, 0.854008982824078, -101.146110534668, -1.76533265441608, 218, 34, 'PPL', 'P'),
(55735, 'Kurreville', 37.4752807617188, 0.654067037401281, -89.8213882446289, -1.5676789635809, 218, 29, 'PPL', 'P'),
(95371, 'Kurten', 30.7869396209717, 0.537333462998651, -96.2638931274414, -1.68012188586179, 218, 51, 'PPL', 'P'),
(174821, 'Kurth (historical)', 44.5741691589355, 0.777966013164337, -90.4966735839844, -1.5794649161431, 218, 57, 'PPL', 'P'),
(41641, 'Kurthwood', 31.3372192382813, 0.546937654127317, -93.1655578613281, -1.62604573413746, 218, 22, 'PPL', 'P'),
(210529, 'Kurtistown', 19.603609085083, 0.342147523808572, -155.057220458984, -2.70625902599999, 218, 15, 'PPL', 'P'),
(30272, 'Kurtz', 38.9605598449707, 0.67999004771503, -86.2033309936523, -1.50453195202571, 218, 19, 'PPL', 'P'),
(131609, 'Kurtz', 44.5611114501953, 0.777738113154053, -83.6455612182617, -1.45989044793715, 218, 27, 'PPL', 'P'),
(48759, 'Kurtz Beach', 39.148609161377, 0.683272127442444, -76.4625015258789, -1.33452240593778, 218, 25, 'PPL', 'P'),
(196852, 'Kurtzville (historical)', 46.1616706848145, 0.805673141671358, -107.448059082031, -1.87532240585884, 218, 31, 'PPL', 'P'),
(76310, 'Kusa', 35.4491691589355, 0.618704718919854, -95.9238891601563, -1.67418769716282, 218, 42, 'PPL', 'P'),
(163464, 'Kushequa', 41.7483291625977, 0.728645801093696, -78.621940612793, -1.37221172800069, 218, 45, 'PPL', 'P'),
(3578, 'Kushla', 30.8152809143066, 0.53782811188162, -88.1580581665039, -1.53864837717017, 218, 2, 'PPL', 'P'),
(211951, 'Kuskovak', 60.1150016784668, 1.04920470913116, -162.506393432617, -2.83627162094046, 218, 1, 'PPL', 'P'),
(211952, 'Kustatan', 60.7158317565918, 1.05969117223946, -151.747497558594, -2.64849346405952, 218, 1, 'PPL', 'P'),
(186934, 'Kutch', 38.9105606079102, 0.679117396404839, -103.86888885498, -1.81285410090745, 218, 7, 'PPL', 'P'),
(36771, 'Kuttawa', 37.0588912963867, 0.646799670260618, -88.1324996948242, -1.53820229768758, 218, 21, 'PPL', 'P'),
(163466, 'Kutztown', 40.398609161377, 0.705088743092373, -76.3222198486328, -1.33207402878961, 218, 45, 'PPL', 'P'),
(212248, 'Kvichak', 58.9694404602051, 1.02921089408934, -156.930557250977, -2.738954921019, 218, 1, 'PPL', 'P'),
(48760, 'Kwanson Acres', 38.6602783203125, 0.674749146426836, -76.591667175293, -1.33677677180053, 218, 25, 'PPL', 'P'),
(211953, 'Kwethluk', 60.8122215270996, 1.06137349110006, -161.435836791992, -2.81758688273246, 218, 1, 'PPL', 'P'),
(211954, 'Kwigillingok', 59.8644409179688, 1.04483159888417, -163.134170532227, -2.84722839829726, 218, 1, 'PPL', 'P'),
(211955, 'Kwigorlak', 61.8069381713867, 1.07873457166726, -163.43278503418, -2.85244020455055, 218, 1, 'PPL', 'P'),
(211956, 'Kwikpak', 63.0708312988281, 1.10079366813444, -164.411117553711, -2.8695153281957, 218, 1, 'PPL', 'P'),
(193715, 'Kworatem (historical)', 41.3766708374023, 0.72215913962659, -123.490280151367, -2.15531198285156, 218, 6, 'PPL', 'P'),
(182522, 'Kyan (historical)', 35.1252784729004, 0.613051760031998, -119.261672973633, -2.08150886482663, 218, 6, 'PPL', 'P'),
(30273, 'Kyana', 38.3050003051758, 0.66854837530275, -86.7822189331055, -1.51463545256925, 218, 19, 'PPL', 'P'),
(182523, 'Kyburz', 38.7747192382813, 0.676746517244396, -120.295829772949, -2.09955830595659, 218, 6, 'PPL', 'P'),
(73140, 'Kyger', 38.9813919067383, 0.680353635782853, -82.1549987792969, -1.43387522567065, 218, 41, 'PPL', 'P'),
(178482, 'Kykotsmovi', 35.8752784729004, 0.626141729421955, -110.619720458984, -1.93067833964501, 218, 5, 'PPL', 'P'),
(178483, 'Kykotsmovi Village', 35.8741683959961, 0.626122354925025, -110.622779846191, -1.93073173602487, 218, 5, 'PPL', 'P'),
(22439, 'Kyle', 34.9569396972656, 0.610113694138395, -84.3569412231445, -1.4723063712552, 218, 13, 'PPL', 'P'),
(30274, 'Kyle', 39.1383285522461, 0.683092696964, -84.9883270263672, -1.48332613237179, 218, 19, 'PPL', 'P'),
(55736, 'Kyle', 39.6863899230957, 0.692658172388319, -94.8322219848633, -1.65513451061802, 218, 29, 'PPL', 'P'),
(66158, 'Kyle', 35.2211112976074, 0.614724358354622, -83.6155624389648, -1.45936687046684, 218, 33, 'PPL', 'P'),
(95372, 'Kyle', 29.9888896942139, 0.523404864181428, -97.8769378662109, -1.70827482753529, 218, 51, 'PPL', 'P'),
(110002, 'Kyle', 37.4080581665039, 0.652893781783046, -81.4258270263672, -1.42114877776949, 218, 58, 'PPL', 'P'),
(190385, 'Kyle', 37.3144416809082, 0.651259865875255, -114.489723205566, -1.99822262963409, 218, 39, 'PPL', 'P'),
(193172, 'Kyle', 46.2750015258789, 0.807651137991987, -112.076393127441, -1.9561020738334, 218, 31, 'PPL', 'P'),
(202280, 'Kyle', 43.4249992370605, 0.757909214362732, -102.176109313965, -1.78330952440633, 218, 49, 'PPL', 'P'),
(195200, 'Kyle (historical)', 47.3280601501465, 0.826030478201978, -115.75666809082, -2.02033498932307, 218, 17, 'PPL', 'P'),
(190386, 'Kyle Canyon Summer Home Area', 36.2516708374023, 0.632711015461881, -115.627220153809, -2.0180756966123, 218, 39, 'PPL', 'P'),
(200037, 'Kyle Hot Springs', 40.4063911437988, 0.705224564307967, -117.882499694824, -2.05743775015589, 218, 39, 'PPL', 'P'),
(88338, 'Kyle Subdivision', 35.4908294677734, 0.619431828476473, -84.8583297729492, -1.4810572522811, 218, 50, 'PPL', 'P'),
(163468, 'Kylers Corners', 41.3208312988281, 0.721184555825676, -78.6391677856445, -1.37251239888776, 218, 45, 'PPL', 'P'),
(163469, 'Kylertown', 40.9933280944824, 0.715468546599011, -78.1675033569336, -1.36428030164221, 218, 45, 'PPL', 'P'),
(3579, 'Kyles', 34.7947196960449, 0.607282421004504, -86.0086135864258, -1.50113349215866, 218, 2, 'PPL', 'P'),
(73141, 'Kyles', 39.4161109924316, 0.687940915149462, -84.4077835083008, -1.47319373653042, 218, 41, 'PPL', 'P'),
(156025, 'Kyles Corners', 41.0724983215332, 0.716850327730599, -80.6580581665039, -1.40774868327059, 218, 41, 'PPL', 'P'),
(66160, 'Kyles Crossroads', 35.7350006103516, 0.623693418852818, -80.9444427490234, -1.41274703716251, 218, 33, 'PPL', 'P'),
(948, 'Kyles Ford', 36.5708312988281, 0.638281416355945, -83.043327331543, -1.44937948374682, 218, 50, 'PPL', 'P'),
(103418, 'Kyles Mills', 37.5491714477539, 0.655356673159152, -79.8330612182617, -1.39334977020486, 218, 53, 'PPL', 'P'),
(78575, 'Kyleville', 39.8186111450195, 0.6949658680519, -76.3874969482422, -1.33321332910395, 218, 45, 'PPL', 'P'),
(3581, 'Kymulga', 33.3338890075684, 0.581786115676413, -86.2988891601563, -1.50619975665837, 218, 2, 'PPL', 'P'),
(16749, 'Kynesville', 30.7311096191406, 0.536359045645305, -85.3547210693359, -1.48972091478129, 218, 12, 'PPL', 'P'),
(95373, 'Kyote', 29.0263900756836, 0.506606076788885, -98.7897186279297, -1.72420585717615, 218, 51, 'PPL', 'P'),
(178484, 'Kyrene', 33.3347206115723, 0.581800629904354, -111.944999694824, -1.95380882581873, 218, 5, 'PPL', 'P'),
(36762, 'Kyrock', 37.2633285522461, 0.650367773489106, -86.2566680908203, -1.50546285998475, 218, 21, 'PPL', 'P'),
(201084, 'Kyser (historical)', 46.0666694641113, 0.804015057576674, -123.076393127441, -2.14808829155277, 218, 43, 'PPL', 'P'),
(150079, 'Kyserike', 41.7975006103516, 0.729504004754974, -74.1733322143555, -1.29456886431608, 218, 40, 'PPL', 'P'),
(150080, 'Kysorville', 42.648609161377, 0.744358651262245, -77.7930603027344, -1.35774503748521, 218, 40, 'PPL', 'P'),
(120245, 'Kyte Side Estates', 41.9338912963867, 0.731884471295342, -89.1524963378906, -1.55600459746838, 218, 18, 'PPL', 'P'),
(163470, 'Kyttle', 41.3111114501953, 0.721014912464238, -76.1883316040039, -1.32973723809112, 218, 45, 'PPL', 'P'),
(3583, 'Kyuka', 34.1680603027344, 0.596345151302685, -86.021110534668, -1.50135160505194, 218, 2, 'PPL', 'P'),
(192659, 'Kyune', 39.8261108398438, 0.695096762419477, -110.94416809082, -1.93634101907085, 218, 52, 'PPL', 'P'),
(36764, 'L and E Junction', 38.002498626709, 0.663268725020695, -84.0666732788086, -1.46724023991355, 218, 21, 'PPL', 'P'),
(142194, 'L and J Mobile Home Court', 40.7422218322754, 0.711085915551123, -98.8477783203125, -1.72521918997092, 218, 35, 'PPL', 'P'),
(199459, 'L and L Mobile Home Park', 41.128059387207, 0.717820051262524, -101.719169616699, -1.77533442220598, 218, 35, 'PPL', 'P'),
(95377, 'L and P Colonia', 26.2700004577637, 0.458498002488394, -98.0005569458008, -1.71043238749242, 218, 51, 'PPL', 'P'),
(95378, 'L and R Garza Colonia', 26.3050003051758, 0.459108865063431, -98.2460021972656, -1.71471621526387, 218, 51, 'PPL', 'P'),
(95374, 'L D Morgan''s Colonia', 26.2919998168945, 0.458881963738556, -97.9580001831055, -1.7096896318644, 218, 51, 'PPL', 'P'),
(95375, 'L J Number 1 Colonia', 26.2350006103516, 0.457887139913357, -98.0999984741211, -1.71216796957483, 218, 51, 'PPL', 'P'),
(95376, 'L R Bell Colonia', 26.2029991149902, 0.45732860845374, -98.1699981689453, -1.7133896947249, 218, 51, 'PPL', 'P'),
(36763, 'L S Park', 38.1955604553223, 0.666638289589918, -85.3997192382813, -1.49050628098675, 218, 21, 'PPL', 'P'),
(41642, 'L T Plantation', 29.8347206115723, 0.520714106084552, -90.8874969482422, -1.58628607064312, 218, 22, 'PPL', 'P'),
(9901, 'L''Anguille', 35.2366714477539, 0.614995934206783, -90.894172668457, -1.58640258394082, 218, 4, 'PPL', 'P'),
(131610, 'L''Anse', 46.7566719055176, 0.816057872026013, -88.4527816772461, -1.54379227281566, 218, 27, 'PPL', 'P'),
(120246, 'L''Erable', 40.9033317565918, 0.713897814188083, -87.8469390869141, -1.53321832486555, 218, 18, 'PPL', 'P'),
(163471, 'La Anna', 41.247501373291, 0.719904707184811, -75.334716796875, -1.31483884916295, 218, 45, 'PPL', 'P'),
(95379, 'La Aura Crossing', 26.0255603790283, 0.454231718290628, -97.3227767944336, -1.6986028922464, 218, 51, 'PPL', 'P'),
(95380, 'La Aurora Colonia', 26.2700004577637, 0.458498002488394, -98.5550003051758, -1.72010924962933, 218, 51, 'PPL', 'P'),
(95381, 'La Bahia', 30.1441707611084, 0.526115030064747, -96.6366729736328, -1.68662812156291, 218, 51, 'PPL', 'P'),
(188782, 'La Bajada', 35.5561103820801, 0.620571195369836, -106.240280151367, -1.85424268688254, 218, 38, 'PPL', 'P'),
(423, 'La Bama', 33.8061103820801, 0.590027933459936, -84.5886077880859, -1.47634971558022, 218, 13, 'PPL', 'P'),
(209553, 'La Barge', 42.2619400024414, 0.737610001322903, -110.193893432617, -1.92324625599093, 218, 59, 'PPL', 'P'),
(182524, 'La Barr Meadows', 39.1747207641602, 0.683727860883984, -121.044166564941, -2.11261924689066, 218, 6, 'PPL', 'P'),
(16750, 'La Belle', 26.7613906860352, 0.467074379883858, -81.438606262207, -1.42137181751079, 218, 12, 'PPL', 'P'),
(95382, 'La Belle', 29.8794403076172, 0.521494612021027, -94.1608276367188, -1.64341646866361, 218, 51, 'PPL', 'P'),
(139257, 'La Belle', 40.1169395446777, 0.700172680878141, -91.9124984741211, -1.60417572210768, 218, 29, 'PPL', 'P'),
(163472, 'La Belle', 40.0077781677246, 0.698267455434299, -79.9791717529297, -1.39589988010667, 218, 45, 'PPL', 'P'),
(188783, 'La Belle (historical)', 36.7627792358398, 0.64163153984921, -105.300003051758, -1.83783175561325, 218, 38, 'PPL', 'P'),
(156026, 'La Belle View', 40.3713912963867, 0.70461370173293, -80.6244430541992, -1.40716198888245, 218, 41, 'PPL', 'P'),
(103413, 'La Bellevue', 37.3236083984375, 0.651419855277742, -79.8997192382813, -1.39451317212706, 218, 53, 'PPL', 'P'),
(95383, 'La Blanca', 26.2924995422363, 0.458890685591126, -98.0374984741211, -1.71107713879233, 218, 51, 'PPL', 'P'),
(95384, 'La Blanca Heights Colonia', 26.19700050354, 0.457223912933386, -98.0449981689453, -1.71120803315991, 218, 51, 'PPL', 'P'),
(186935, 'La Boca', 37.0111083984375, 0.64596570136526, -107.601387023926, -1.87799848328021, 218, 7, 'PPL', 'P'),
(182527, 'La Bolsa', 33.6866683959961, 0.587943277537649, -117.996673583984, -2.05943046044155, 218, 6, 'PPL', 'P'),
(188784, 'La Bolsa', 36.2155609130859, 0.632080778389914, -105.904167175293, -1.84837640879137, 218, 38, 'PPL', 'P'),
(78576, 'La Bott', 39.9208297729492, 0.696749919666144, -76.8963928222656, -1.34209523765547, 218, 45, 'PPL', 'P'),
(41644, 'La Branche', 30.0513896942139, 0.524495694963924, -90.3686065673828, -1.5772297250402, 218, 22, 'PPL', 'P'),
(182529, 'La Branza (historical)', 37.1747207641602, 0.648821275844097, -120.316673278809, -2.09992209376149, 218, 6, 'PPL', 'P'),
(196853, 'La Bree Mobile Homes Incorporated', 47.1049995422363, 0.822137336162446, -104.722221374512, -1.82774756298761, 218, 31, 'PPL', 'P'),
(95385, 'La Camellia Colonia', 26.2220001220703, 0.457660238588482, -98.3610000610352, -1.71672330661941, 218, 51, 'PPL', 'P'),
(95386, 'La Camellia Colonia A', 26.2220001220703, 0.457660238588482, -98.3629989624023, -1.71675819402969, 218, 51, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(182532, 'La Canada Flintridge', 34.1991691589355, 0.596888103269925, -118.186943054199, -2.06275128916282, 218, 6, 'PPL', 'P'),
(188785, 'La Careda', 36.2016716003418, 0.631838364151689, -106.321113586426, -1.85565349647001, 218, 38, 'PPL', 'P'),
(95387, 'La Carla Colonia', 26.4360008239746, 0.461395255438291, -98.7399978637695, -1.72333806613495, 218, 51, 'PPL', 'P'),
(95388, 'La Carmelita Ranch Number 1 Colonia', 27.9300003051758, 0.487470465408338, -98.0260009765625, -1.71087646960419, 218, 51, 'PPL', 'P'),
(95389, 'La Casa', 32.600830078125, 0.568991823746482, -98.6891708374023, -1.72245096717584, 218, 51, 'PPL', 'P'),
(178485, 'La Casa Trail Mobile Villa', 33.4161109924316, 0.583221160029802, -111.588890075684, -1.9475935404667, 218, 5, 'PPL', 'P'),
(196854, 'La Casa Trailer Park', 45.8708305358887, 0.800597023475612, -112.096672058105, -1.95645600794227, 218, 31, 'PPL', 'P'),
(95390, 'La Casita', 26.3233299255371, 0.459428777289376, -98.7149963378906, -1.72290170719034, 218, 51, 'PPL', 'P'),
(178486, 'La Casita Mobile Park', 33.4497184753418, 0.583807721259892, -111.820281982422, -1.95163209110175, 218, 5, 'PPL', 'P'),
(36765, 'La Center', 37.0766716003418, 0.647109995106639, -88.9736099243164, -1.55288244056442, 218, 21, 'PPL', 'P'),
(207831, 'La Center', 45.8624992370605, 0.800451614880094, -122.669166564941, -2.14098084723557, 218, 56, 'PPL', 'P'),
(95391, 'La Cerda', 31.437780380249, 0.54869277715422, -94.397216796875, -1.64754223782436, 218, 51, 'PPL', 'P'),
(95392, 'La Chaparosa Colonia', 26.4039993286133, 0.460836723978674, -98.927001953125, -1.72660190320889, 218, 51, 'PPL', 'P'),
(196855, 'La Chapelle Place', 47.3405609130859, 0.826248657674283, -112.290000915527, -1.9598302330434, 218, 31, 'PPL', 'P'),
(55738, 'La Charbonniere (historical)', 38.8333282470703, 0.677769437419095, -90.3499984741211, -1.57690495254527, 218, 29, 'PPL', 'P'),
(188786, 'La Chuachia', 36.0950012207031, 0.629976614812642, -106.137496948242, -1.85244878157226, 218, 38, 'PPL', 'P'),
(188787, 'La Cienaga', 36.2136116027832, 0.632046756506988, -105.923057556152, -1.84870610813432, 218, 38, 'PPL', 'P'),
(178487, 'La Cienega', 34.3733291625977, 0.599927768759114, -111.175003051758, -1.94036984916792, 218, 5, 'PPL', 'P'),
(188788, 'La Cienega', 35.5627784729004, 0.620687575509473, -106.130279541016, -1.8523228140527, 218, 38, 'PPL', 'P'),
(188789, 'La Cinta (historical)', 35.410831451416, 0.618035599695972, -104.13111114502, -1.81743074324075, 218, 38, 'PPL', 'P'),
(27647, 'La Clede', 38.8797187805176, 0.678579104969506, -88.7152786254883, -1.54837370883892, 218, 18, 'PPL', 'P'),
(95394, 'La Coma Colonia', 27.5030002593994, 0.480017908703374, -99.302001953125, -1.73314688790387, 218, 51, 'PPL', 'P'),
(95395, 'La Coma Heights Colonia', 26.4419994354248, 0.461499950958645, -98.068000793457, -1.71160950469424, 218, 51, 'PPL', 'P'),
(207832, 'La Conner', 48.3888893127441, 0.844545439890481, -122.495002746582, -2.13794111516735, 218, 56, 'PPL', 'P'),
(188790, 'La Constancia', 34.6783294677734, 0.605251028304019, -106.734443664551, -1.86286746723081, 218, 38, 'PPL', 'P'),
(182534, 'La Costa', 33.0911102294922, 0.577548826645015, -117.265281677246, -2.04666526354652, 218, 6, 'PPL', 'P'),
(95396, 'La Coste', 29.3105602264404, 0.51156578155548, -98.8097229003906, -1.72455499759506, 218, 51, 'PPL', 'P'),
(136280, 'La Crescent', 43.8280601501465, 0.764943954382176, -91.3038864135742, -1.59355343778379, 218, 28, 'PPL', 'P'),
(182535, 'La Crescenta', 34.2241706848145, 0.597324462214535, -118.239166259766, -2.0636627560459, 218, 6, 'PPL', 'P'),
(182537, 'La Cresta', 32.8111114501953, 0.57266192604472, -116.862503051758, -2.0396354503751, 218, 6, 'PPL', 'P'),
(182538, 'La Cresta Highlands', 33.5227813720703, 0.585082909368849, -117.345283508301, -2.04806155890605, 218, 6, 'PPL', 'P'),
(204586, 'La Cresta Park', 40.6286087036133, 0.709102992382477, -111.831672668457, -1.95183089607713, 218, 52, 'PPL', 'P'),
(182539, 'La Cresta Village', 38.6622200012207, 0.674783035151707, -121.081939697266, -2.11327851241851, 218, 6, 'PPL', 'P'),
(116349, 'La Crew', 40.7333297729492, 0.710930719838598, -91.583610534668, -1.59843554469412, 218, 16, 'PPL', 'P'),
(156027, 'La Croft', 40.6458282470703, 0.709403530111492, -80.5980606079102, -1.40670152832997, 218, 41, 'PPL', 'P'),
(127899, 'La Croix Depot', 46.084171295166, 0.804320522153707, -70.2677764892578, -1.22640405779301, 218, 26, 'PPL', 'P'),
(16751, 'La Crosse', 29.8430595397949, 0.520859647838125, -82.4049987792969, -1.43823854880064, 218, 12, 'PPL', 'P'),
(22440, 'La Crosse', 32.1866683959961, 0.561763338757734, -84.2402801513672, -1.47027025144378, 218, 13, 'PPL', 'P'),
(32948, 'La Crosse', 38.5313911437988, 0.672499640833073, -99.3083267211914, -1.73325727593105, 218, 20, 'PPL', 'P'),
(103414, 'La Crosse', 36.7000007629395, 0.640535848797724, -78.0999984741211, -1.36310211917596, 218, 53, 'PPL', 'P'),
(120247, 'La Crosse', 40.5288887023926, 0.707362550031083, -91.0227813720703, -1.58864722926559, 218, 18, 'PPL', 'P'),
(122981, 'La Crosse', 41.3175010681152, 0.721126432334885, -86.8913879394531, -1.51654081117115, 218, 19, 'PPL', 'P'),
(174822, 'La Crosse', 43.8013916015625, 0.764478500402658, -91.2394409179688, -1.59242865169739, 218, 57, 'PPL', 'P'),
(207833, 'La Crosse', 46.8141708374023, 0.817061417703782, -117.880828857422, -2.05740858854196, 218, 56, 'PPL', 'P'),
(188791, 'La Cuesta', 35.0783309936523, 0.612232371943607, -106.506393432617, -1.85888723982364, 218, 38, 'PPL', 'P'),
(182540, 'La Cuesta Fontana', 34.1416702270508, 0.595884557592156, -117.449440002441, -2.04987943266614, 218, 6, 'PPL', 'P'),
(188792, 'La Cuestecita', 36.1641693115234, 0.631183825734775, -105.803329467773, -1.84661645878499, 218, 38, 'PPL', 'P'),
(188794, 'La Cueva', 35.5911102294922, 0.621182057944873, -105.732498168945, -1.84538021940697, 218, 38, 'PPL', 'P'),
(188795, 'La Cueva (historical)', 36.3675003051758, 0.63473262104536, -106.049171447754, -1.85090721077527, 218, 38, 'PPL', 'P'),
(32950, 'La Cygne', 38.3499984741211, 0.669333741508214, -94.7611083984375, -1.65389334439199, 218, 20, 'PPL', 'P'),
(32951, 'La Cygne Corner', 38.3455581665039, 0.669256243520493, -94.6777801513672, -1.65243899212069, 218, 20, 'PPL', 'P'),
(182541, 'La Delta', 34.642219543457, 0.604620791232052, -117.343612670898, -2.04803239729211, 218, 6, 'PPL', 'P'),
(55739, 'La Due', 38.3125, 0.668679269670328, -93.8766708374023, -1.63845699692361, 218, 29, 'PPL', 'P'),
(95397, 'La Escondida Colonia', 26.378999710083, 0.460400398323578, -98.8740005493164, -1.72567685420425, 218, 51, 'PPL', 'P'),
(95398, 'La Esperanza Colonia', 26.4309997558594, 0.461307970333564, -98.8919982910156, -1.72599097405483, 218, 51, 'PPL', 'P'),
(95399, 'La Estancia Colonia', 26.2889995574951, 0.458829599333622, -98.1940002441406, -1.71380860996437, 218, 51, 'PPL', 'P'),
(174825, 'La Farge', 43.5747184753418, 0.760522308024318, -90.6402816772461, -1.58197135020303, 218, 57, 'PPL', 'P'),
(150085, 'La Fargeville', 44.1947212219238, 0.771343397323582, -75.9663925170898, -1.3258636702856, 218, 40, 'PPL', 'P'),
(36766, 'La Fayette', 36.6583290100098, 0.639808539504024, -87.658332824707, -1.52992652460016, 218, 21, 'PPL', 'P'),
(95400, 'La Feria', 26.1586093902588, 0.456553861603122, -97.8236083984375, -1.70734405273431, 218, 51, 'PPL', 'P'),
(95401, 'La Feria Gardens Colonia', 26.1630001068115, 0.456630494063489, -97.8420028686523, -1.70766509680372, 218, 51, 'PPL', 'P'),
(95402, 'La Feria North', 26.1716709136963, 0.456781828192433, -97.8219375610352, -1.70731489112038, 218, 51, 'PPL', 'P'),
(182542, 'La Fetra', 34.1388893127441, 0.595836021481289, -117.880561828613, -2.05740392801005, 218, 6, 'PPL', 'P'),
(122982, 'La Fontaine', 40.6738891601563, 0.709893285435958, -85.7213897705078, -1.49612049088075, 218, 19, 'PPL', 'P'),
(178488, 'La Fontana Heights', 33.5130615234375, 0.584913266007411, -112.211112976074, -1.95845337875983, 218, 5, 'PPL', 'P'),
(186936, 'La Foret', 39.0094413757324, 0.680843191370237, -104.713890075684, -1.82760215439209, 218, 7, 'PPL', 'P'),
(55741, 'La Forge', 36.6713905334473, 0.640036506093335, -89.5255584716797, -1.56251576001751, 218, 29, 'PPL', 'P'),
(120248, 'La Fox', 41.8863906860352, 0.731055429248, -88.4088897705078, -1.5430262145281, 218, 18, 'PPL', 'P'),
(188796, 'La Fragua', 35.3147201538086, 0.616358141104358, -105.406112670898, -1.83968371783529, 218, 38, 'PPL', 'P'),
(81925, 'La France', 34.6119384765625, 0.604092286913726, -82.7652816772461, -1.44452667160848, 218, 48, 'PPL', 'P'),
(182543, 'La Fresa', 33.8727798461914, 0.591191535119219, -118.334999084473, -2.06533535436852, 218, 6, 'PPL', 'P'),
(95403, 'La Frontera Colonia', 26.0919990539551, 0.455391291918762, -97.9489974975586, -1.70953250536008, 218, 51, 'PPL', 'P'),
(95404, 'La Fruta', 28.0405597686768, 0.489400092065669, -97.8591690063477, -1.70796470242635, 218, 51, 'PPL', 'P'),
(186937, 'La Fruto', 37.4147186279297, 0.653010028764628, -105.898063659668, -1.84826988234776, 218, 7, 'PPL', 'P'),
(191704, 'La Fuente Colonia', 31.6569995880127, 0.55251887411331, -106.276000976563, -1.85486613289372, 218, 51, 'PPL', 'P'),
(186938, 'La Garita', 37.8408317565918, 0.660447105845756, -106.246109008789, -1.85434441963618, 218, 7, 'PPL', 'P'),
(95406, 'La Gloria', 26.7197208404541, 0.466347103879671, -98.521110534668, -1.71951776155123, 218, 51, 'PPL', 'P'),
(188797, 'La Gotera', 35.309440612793, 0.616265995730642, -107.190277099609, -1.87082326151326, 218, 38, 'PPL', 'P'),
(201085, 'La Grande', 45.3247184753418, 0.791065569934219, -118.086669921875, -2.06100119285247, 218, 43, 'PPL', 'P'),
(207834, 'La Grande', 46.8344383239746, 0.817415152075572, -122.317497253418, -2.13484305987126, 218, 56, 'PPL', 'P'),
(3584, 'La Grange', 34.5819396972656, 0.603568709443416, -87.5472183227539, -1.52798721069436, 218, 2, 'PPL', 'P'),
(9905, 'La Grange', 34.6563911437988, 0.604868132318293, -90.732780456543, -1.58358575845584, 218, 4, 'PPL', 'P'),
(16752, 'La Grange', 28.6361103057861, 0.499794409800248, -80.8305587768555, -1.41075938688293, 218, 12, 'PPL', 'P'),
(22441, 'La Grange', 33.0391693115234, 0.576642286609952, -85.0313873291016, -1.48407767643141, 218, 13, 'PPL', 'P'),
(36767, 'La Grange', 38.4075012207031, 0.670337353765011, -85.3788909912109, -1.49014275949796, 218, 21, 'PPL', 'P'),
(66162, 'La Grange', 35.3066711425781, 0.616217659356857, -77.788330078125, -1.35766247949142, 218, 33, 'PPL', 'P'),
(88339, 'La Grange', 35.045280456543, 0.611655531251496, -89.2436065673828, -1.55759477095526, 218, 50, 'PPL', 'P'),
(95407, 'La Grange', 29.9052791595459, 0.521945585062119, -96.8763885498047, -1.69081194763543, 218, 51, 'PPL', 'P'),
(120249, 'La Grange', 41.8050003051758, 0.729634899122552, -87.8691711425781, -1.53360634743638, 218, 18, 'PPL', 'P'),
(131612, 'La Grange', 41.9541702270508, 0.732238405404213, -86.0416717529297, -1.50171046600882, 218, 27, 'PPL', 'P'),
(139259, 'La Grange', 40.042781829834, 0.698878384588363, -91.4974975585938, -1.59693258973293, 218, 29, 'PPL', 'P'),
(174828, 'La Grange', 42.7997207641602, 0.746996046268778, -88.6022186279297, -1.54640043962923, 218, 57, 'PPL', 'P'),
(182545, 'La Grange', 37.6636085510254, 0.657353977397684, -120.462501525879, -2.10246727681528, 218, 6, 'PPL', 'P'),
(209554, 'La Grange', 41.6402816772461, 0.726760016725811, -104.163330078125, -1.81799306970492, 218, 59, 'PPL', 'P'),
(3585, 'La Grange (historical)', 34.6611099243164, 0.604950490575004, -87.5602798461914, -1.52821517728367, 218, 2, 'PPL', 'P'),
(120250, 'La Grange Park', 41.8347206115723, 0.730153616323872, -87.8616714477539, -1.5334754530688, 218, 18, 'PPL', 'P'),
(16753, 'La Grange Point', 30.4313907623291, 0.53112796476363, -86.1549987792969, -1.50368839575043, 218, 12, 'PPL', 'P'),
(9907, 'La Grue (historical)', 34.6852798461914, 0.605372335291672, -91.5827789306641, -1.59842103046618, 218, 4, 'PPL', 'P'),
(9908, 'La Grue Springs', 34.2077789306641, 0.597038372134433, -91.211669921875, -1.591943956379, 218, 4, 'PPL', 'P'),
(95408, 'La Grulla', 26.2691707611084, 0.458483521549966, -98.6469421386719, -1.72171393734416, 218, 51, 'PPL', 'P'),
(191705, 'La Guna', 31.7891693115234, 0.554825670960023, -106.522216796875, -1.85916340962868, 218, 51, 'PPL', 'P'),
(182547, 'La Habra', 33.9319381713867, 0.592224042673842, -117.945281982422, -2.05853350778641, 218, 6, 'PPL', 'P'),
(182548, 'La Habra Heights', 33.9608306884766, 0.592728312226249, -117.949722290039, -2.05861100577413, 218, 6, 'PPL', 'P'),
(95410, 'La Hacienda Colonia', 26.4050006866455, 0.460854200973328, -98.9810028076172, -1.72754439591867, 218, 51, 'PPL', 'P'),
(95411, 'La Hacienda Estates Number 2 Colonia', 28.6840000152588, 0.50063024290837, -99.8099975585938, -1.74201308380496, 218, 51, 'PPL', 'P'),
(32952, 'La Harpe', 37.9169387817383, 0.661775424018461, -95.2988891601563, -1.66327938933786, 218, 20, 'PPL', 'P'),
(120251, 'La Harpe', 40.5833282470703, 0.708312699328996, -90.9691696166992, -1.58771152761659, 218, 18, 'PPL', 'P'),
(95412, 'La Hermosa Colonia', 26.2709999084473, 0.458515446193534, -98.5599975585938, -1.72019646815503, 218, 51, 'PPL', 'P'),
(191706, 'La Herradura Colonia', 28.6660003662109, 0.500316089768281, -100.483001708984, -1.75375922210887, 218, 51, 'PPL', 'P'),
(120253, 'La Hogue', 40.7633285522461, 0.711454297308908, -88.0880584716797, -1.53742665202009, 218, 18, 'PPL', 'P'),
(95413, 'La Homa', 26.249719619751, 0.458144035090009, -98.3633270263672, -1.71676391982603, 218, 51, 'PPL', 'P'),
(95414, 'La Homa Acres Colonia', 26.2789993286133, 0.458655062413681, -98.3479995727539, -1.71649640529453, 218, 51, 'PPL', 'P'),
(95415, 'La Homa Acres Number 2 Colonia', 26.2819995880127, 0.458707426818615, -98.3479995727539, -1.71649640529453, 218, 51, 'PPL', 'P'),
(95416, 'La Homa Acres Number 4 Colonia', 26.2779998779297, 0.458637618708541, -98.3509979248047, -1.71654873640995, 218, 51, 'PPL', 'P'),
(95417, 'La Homa Five Colonia', 26.2919998168945, 0.458881963738556, -98.3539962768555, -1.71660106752537, 218, 51, 'PPL', 'P'),
(95418, 'La Homa Grove Estates Colonia', 26.2759990692139, 0.458602698008747, -98.3570022583008, -1.71665353179885, 218, 51, 'PPL', 'P'),
(95419, 'La Homa Grove Estates Number 2 Colonia', 26.2800006866455, 0.458672539408335, -98.3519973754883, -1.71656618011509, 218, 51, 'PPL', 'P'),
(95420, 'La Homa Groves Colonia Number 1 and 2', 26.2950000762939, 0.45893432814349, -98.3479995727539, -1.71649640529453, 218, 51, 'PPL', 'P'),
(95421, 'La Homa Groves Estates Number 3 Colonia', 26.2870006561279, 0.458794711923342, -98.3509979248047, -1.71654873640995, 218, 51, 'PPL', 'P'),
(95422, 'La Homa Road Colonia', 26.246000289917, 0.458079120538438, -98.3619995117188, -1.71674075032455, 218, 51, 'PPL', 'P'),
(95423, 'La Homa Road North Colonia', 26.250560760498, 0.458158715765518, -98.3580627441406, -1.71667204076842, 218, 51, 'PPL', 'P'),
(182549, 'La Honda', 37.3191719055176, 0.651342423869048, -122.273063659668, -2.13406754736183, 218, 6, 'PPL', 'P'),
(182550, 'La Honda Park', 38.1205596923828, 0.665329279335117, -120.495277404785, -2.10303932381743, 218, 6, 'PPL', 'P'),
(196856, 'La Hood Park', 45.8530616760254, 0.800286898366673, -111.92138671875, -1.95339670164004, 218, 31, 'PPL', 'P'),
(188798, 'La Huerta', 32.4427795410156, 0.566233321489377, -104.220558166504, -1.81899188827176, 218, 38, 'PPL', 'P'),
(95424, 'La India', 27.1716709136963, 0.474235120712376, -98.1275024414063, -1.71264800436131, 218, 51, 'PPL', 'P'),
(48761, 'La Isla', 39.1908302307129, 0.684009024116069, -76.8902816772461, -1.34198857805381, 218, 25, 'PPL', 'P'),
(186939, 'La Jara', 37.2750015258789, 0.650571505312497, -105.959716796875, -1.84934593258621, 218, 7, 'PPL', 'P'),
(188800, 'La Jara', 36.0877799987793, 0.629850580714054, -106.974166870117, -1.86705142646138, 218, 38, 'PPL', 'P'),
(182552, 'La Jolla', 32.8472213745117, 0.573292163116687, -117.273330688477, -2.04680574529402, 218, 6, 'PPL', 'P'),
(95425, 'La Jolla Addition Colonia', 27.742000579834, 0.484189251208279, -98.0930023193359, -1.71204586363885, 218, 51, 'PPL', 'P'),
(182553, 'La Jolla Amago', 33.2827796936035, 0.580894089869291, -116.862503051758, -2.0396354503751, 218, 6, 'PPL', 'P'),
(191707, 'La Jolla Colonia', 31.6469993591309, 0.552344337193369, -106.287002563477, -1.85505814680832, 218, 51, 'PPL', 'P'),
(182554, 'La Jolla Hermosa', 32.8180618286133, 0.572783233032373, -117.269439697266, -2.04673783468623, 218, 6, 'PPL', 'P'),
(182555, 'La Jolla Ranch', 36.728328704834, 0.641030264654098, -120.601936340332, -2.10490087341939, 218, 6, 'PPL', 'P'),
(182556, 'La Jolla Shores', 32.8555603027344, 0.57343770487026, -117.252777099609, -2.04644701749519, 218, 6, 'PPL', 'P'),
(95426, 'La Joya', 26.2466697692871, 0.458090805157721, -98.4811096191406, -1.71881961387146, 218, 51, 'PPL', 'P'),
(188801, 'La Joya', 34.3461112976074, 0.599452727399671, -106.845001220703, -1.86479706059863, 218, 38, 'PPL', 'P'),
(188802, 'La Joyita (historical)', 34.2616691589355, 0.597978934052422, -106.859718322754, -1.86505392248577, 218, 38, 'PPL', 'P'),
(186940, 'La Junta', 37.9850006103516, 0.66296332702269, -103.543327331543, -1.80717198040566, 218, 7, 'PPL', 'P'),
(188803, 'La Junta', 36.2113914489746, 0.632008007513127, -105.916389465332, -1.84858972799468, 218, 38, 'PPL', 'P'),
(191708, 'La Junta', 29.5936107635498, 0.516505945377577, -104.41056060791, -1.82230805646112, 218, 51, 'PPL', 'P'),
(191709, 'La Junta Addition Colonia', 31.6539993286133, 0.552466509708376, -106.300003051758, -1.85528504813319, 218, 51, 'PPL', 'P'),
(186941, 'La Junta Gardens', 37.999439239502, 0.663215328640839, -103.553062438965, -1.80734189008321, 218, 7, 'PPL', 'P'),
(186942, 'La Junta Village', 38.0374984741211, 0.663879587595732, -103.530563354492, -1.80694920698047, 218, 7, 'PPL', 'P'),
(95428, 'La Kinina Colonia', 26.2509994506836, 0.458166372353652, -97.806999206543, -1.70705416764966, 218, 51, 'PPL', 'P'),
(188805, 'La Ladera', 34.709171295166, 0.605789319739352, -106.71443939209, -1.8625183268119, 218, 38, 'PPL', 'P'),
(188806, 'La Lande', 34.4480590820313, 0.601232051902981, -104.133613586426, -1.81747441908263, 218, 38, 'PPL', 'P'),
(95429, 'La Leona', 26.2674999237061, 0.45845435993603, -97.458610534668, -1.70097363824879, 218, 51, 'PPL', 'P'),
(188807, 'La Liendre', 35.4222183227539, 0.618234338092319, -105.050003051758, -1.83346843248327, 218, 38, 'PPL', 'P'),
(188808, 'La Loma', 35.6194381713867, 0.621676473801246, -105.930000305176, -1.84882728196392, 218, 38, 'PPL', 'P'),
(95430, 'La Loma Alta Colonia', 26.1439990997314, 0.456298863928747, -98.0199966430664, -1.7107716742153, 218, 51, 'PPL', 'P'),
(95431, 'La Lomita (historical)', 26.1534996032715, 0.456464678996118, -98.3303604125977, -1.71618854387252, 218, 51, 'PPL', 'P'),
(95432, 'La Lomita Colonia', 26.4080009460449, 0.460906565378261, -98.7669982910156, -1.72380931248984, 218, 51, 'PPL', 'P'),
(188809, 'La Luz', 32.9777793884277, 0.575570830324386, -105.941390991211, -1.84902608693929, 218, 38, 'PPL', 'P'),
(188810, 'La Madera', 35.2227783203125, 0.614753453389531, -106.370002746582, -1.85650677328327, 218, 38, 'PPL', 'P'),
(22442, 'La Mancha', 33.9388885498047, 0.592345349661495, -84.041389465332, -1.46679895412092, 218, 13, 'PPL', 'P'),
(188812, 'La Manga', 35.5094413757324, 0.619756667550436, -105.263328552246, -1.83719166484525, 218, 38, 'PPL', 'P'),
(95433, 'La Marque', 29.3683300018311, 0.512574054344184, -94.9711074829102, -1.65755851984221, 218, 51, 'PPL', 'P'),
(140341, 'La Mars', 45.9647216796875, 0.802235733073365, -96.6900024414063, -1.68755889636389, 218, 34, 'PPL', 'P'),
(95434, 'La Masa Road Colonia', 27.738000869751, 0.484119443098205, -98.2350006103516, -1.71452420134927, 218, 51, 'PPL', 'P'),
(182564, 'La Mesa', 32.7677803039551, 0.571905654874164, -117.022216796875, -2.04242298108808, 218, 6, 'PPL', 'P'),
(188813, 'La Mesa', 32.121940612793, 0.560633625823322, -106.707221984863, -1.86239235929234, 218, 38, 'PPL', 'P'),
(95435, 'La Mesa Colonia', 26.2129993438721, 0.457503145373681, -97.9329986572266, -1.70925327291979, 218, 51, 'PPL', 'P'),
(188814, 'La Mesilla', 35.9483299255371, 0.627416717793831, -106.069999694824, -1.85127073226406, 218, 38, 'PPL', 'P'),
(95436, 'La Milpa Colonia', 26.1439990997314, 0.456298863928747, -97.8720016479492, -1.70818867427403, 218, 51, 'PPL', 'P'),
(182565, 'La Mirada', 33.9172210693359, 0.591967180786704, -118.011108398438, -2.05968239548067, 218, 6, 'PPL', 'P'),
(95437, 'La Moca Ranch Colonia', 27.9050006866455, 0.487034139753243, -99.5080032348633, -1.73674228853353, 218, 51, 'PPL', 'P'),
(120254, 'La Moille', 41.5316696166992, 0.724864378661893, -89.2797164916992, -1.55822500802723, 218, 18, 'PPL', 'P'),
(178489, 'La Montana del Sur', 33.3722190856934, 0.582455101742241, -112.067497253418, -1.95594681154185, 218, 5, 'PPL', 'P'),
(55742, 'La Monte', 38.774169921875, 0.676736929864471, -93.4250030517578, -1.63057390693892, 218, 29, 'PPL', 'P'),
(116351, 'La Motte', 42.2958297729492, 0.738201489401009, -90.6208267211914, -1.58163179716405, 218, 16, 'PPL', 'P'),
(182569, 'La Paco', 34.1686096191406, 0.59635473868261, -118.357498168945, -2.06572803747126, 218, 6, 'PPL', 'P'),
(178490, 'La Palma', 32.8791694641113, 0.573849762469922, -111.514442443848, -1.94629418417085, 218, 5, 'PPL', 'P'),
(182570, 'La Palma', 33.8463897705078, 0.590730941408689, -118.045829772949, -2.06028839778671, 218, 6, 'PPL', 'P'),
(95438, 'La Palma Colonia', 26.2530002593994, 0.458201293053445, -98.3580017089844, -1.71667097550399, 218, 51, 'PPL', 'P'),
(95439, 'La Palma Number 1 Colonia', 26.1529998779297, 0.456455957143548, -98.0199966430664, -1.7107716742153, 218, 51, 'PPL', 'P'),
(95440, 'La Palma Number 2 Colonia', 26.1529998779297, 0.456455957143548, -98.0169982910156, -1.71071934309988, 218, 51, 'PPL', 'P'),
(95441, 'La Paloma', 26.045560836792, 0.45458079213051, -97.6672210693359, -1.70461457893309, 218, 51, 'PPL', 'P'),
(182571, 'La Paloma', 33.7808303833008, 0.589586714246337, -117.803611755371, -2.05606089587232, 218, 6, 'PPL', 'P'),
(95442, 'La Paloma Addition Colonia', 28.0179996490479, 0.489006343698501, -97.5029983520508, -1.70174835180989, 218, 51, 'PPL', 'P'),
(95443, 'La Paloma Junction', 26.0461502075195, 0.45459107859022, -97.6661605834961, -1.70459606996351, 218, 51, 'PPL', 'P'),
(95444, 'La Paloma Number 1 Colonia', 26.2229995727539, 0.457677682293622, -97.9560012817383, -1.70965474445412, 218, 51, 'PPL', 'P'),
(95445, 'La Paloma Site Colonia', 26.2700004577637, 0.458498002488394, -98.3860015869141, -1.71715966556402, 218, 51, 'PPL', 'P'),
(95446, 'La Pampa Colonia', 26.2660007476807, 0.45842819437832, -97.9789962768555, -1.71005608283039, 218, 51, 'PPL', 'P'),
(182572, 'La Panza', 35.3611106872559, 0.61716780865477, -120.21443939209, -2.09813777583114, 218, 6, 'PPL', 'P'),
(95447, 'La Para', 28.3666706085205, 0.495091799947386, -97.9538879394531, -1.70961785967302, 218, 51, 'PPL', 'P'),
(95448, 'La Parita', 28.8469390869141, 0.503474066188897, -98.5930633544922, -1.72077357516325, 218, 51, 'PPL', 'P'),
(95449, 'La Parra Landing', 27.2549991607666, 0.475689472983669, -97.6402816772461, -1.70414439784264, 218, 51, 'PPL', 'P'),
(95450, 'La Parrita Valley Colonia', 28.0139999389648, 0.488936535588427, -98.2229995727539, -1.71431474372954, 218, 51, 'PPL', 'P'),
(182573, 'La Patera', 34.4375, 0.601047761155547, -119.841110229492, -2.0916219527501, 218, 6, 'PPL', 'P'),
(122983, 'La Paz', 41.4597206115723, 0.723608631628893, -86.3083267211914, -1.50636447317179, 218, 19, 'PPL', 'P'),
(178491, 'La Paz (historical)', 33.6791687011719, 0.587812383170071, -114.425559997559, -1.99710277039571, 218, 5, 'PPL', 'P'),
(122984, 'La Paz Junction', 41.4594383239746, 0.723603704780876, -86.2949981689453, -1.50613184605057, 218, 19, 'PPL', 'P'),
(95451, 'La Penusca', 26.0774993896484, 0.455138225036177, -97.4941711425781, -1.70159428794083, 218, 51, 'PPL', 'P'),
(188815, 'La Petra', 33.4330596923828, 0.583516970647883, -107.420562744141, -1.87484250423041, 218, 38, 'PPL', 'P'),
(201086, 'La Pine', 43.6705589294434, 0.762195039504997, -121.502502441406, -2.12061871701499, 218, 43, 'PPL', 'P'),
(3586, 'La Place', 32.3783302307129, 0.565108468823955, -85.8627777099609, -1.49858817594682, 218, 2, 'PPL', 'P'),
(177712, 'La Placita', 36.0352783203125, 0.628934253561985, -106.958061218262, -1.86677032980832, 218, 38, 'PPL', 'P'),
(48762, 'La Plaine Estates', 39.5769386291504, 0.690747886938405, -75.918327331543, -1.32502477454223, 218, 25, 'PPL', 'P'),
(202281, 'La Plant', 45.144718170166, 0.787923971954307, -100.651107788086, -1.75669322668181, 218, 49, 'PPL', 'P'),
(48763, 'La Plata', 38.5291709899902, 0.672460891839213, -76.9755630493164, -1.34347701878706, 218, 25, 'PPL', 'P'),
(139260, 'La Plata', 40.0233306884766, 0.698538898128405, -92.4913864135742, -1.61427922265122, 218, 29, 'PPL', 'P'),
(186943, 'La Plata', 37.3972206115723, 0.652704630766623, -108.0625, -1.88604642293637, 218, 7, 'PPL', 'P'),
(188816, 'La Plata', 36.9286117553711, 0.644525863321908, -108.189720153809, -1.88826683349523, 218, 38, 'PPL', 'P'),
(103415, 'La Plateau', 37.1605606079102, 0.648574134494938, -80.4347229003906, -1.4038507475411, 218, 53, 'PPL', 'P'),
(142195, 'La Platte', 41.0747184753418, 0.71688907672446, -95.9233322143555, -1.67417797662485, 218, 35, 'PPL', 'P'),
(182574, 'La Playa', 32.7122192382813, 0.570935931342239, -117.244438171387, -2.04630147574162, 218, 6, 'PPL', 'P'),
(163473, 'La Plume', 41.5566711425781, 0.725300737606502, -75.7541732788086, -1.32215974584152, 218, 45, 'PPL', 'P'),
(174831, 'La Pointe', 46.7791709899902, 0.816450555128745, -90.7863922119141, -1.58452146010484, 218, 57, 'PPL', 'P'),
(95452, 'La Ponderosa Colonia', 28.1229991912842, 0.490838931423612, -97.8619995117188, -1.70801410406458, 218, 51, 'PPL', 'P'),
(95453, 'La Porte', 29.6655597686768, 0.517761692410577, -95.019172668457, -1.65839741558558, 218, 51, 'PPL', 'P'),
(182576, 'La Porte', 39.6822204589844, 0.692585401511533, -120.983062744141, -2.11155278403214, 218, 6, 'PPL', 'P'),
(116352, 'La Porte City', 42.314998626709, 0.738536049012951, -92.1919403076172, -1.60905290216999, 218, 16, 'PPL', 'P'),
(186945, 'La Posta', 37.1252784729004, 0.647958345071884, -107.894439697266, -1.88311321731176, 218, 7, 'PPL', 'P'),
(120256, 'La Prairie', 40.1477813720703, 0.700710972313474, -91.0027770996094, -1.58829808884668, 218, 18, 'PPL', 'P'),
(136286, 'La Prairie', 47.228328704834, 0.824289836113502, -93.4888916015625, -1.63168897248734, 218, 28, 'PPL', 'P'),
(95454, 'La Presa', 27.3997192382813, 0.478215314830041, -99.4369430541992, -1.73550205441388, 218, 51, 'PPL', 'P'),
(182577, 'La Presa', 32.7080612182617, 0.570863360202535, -116.996391296387, -2.04197224107359, 218, 6, 'PPL', 'P'),
(95455, 'La Presa Colonia', 27.3990001678467, 0.478202764683404, -99.4369964599609, -1.73550298652026, 218, 51, 'PPL', 'P'),
(95456, 'La Pryor', 28.9408302307129, 0.50511277578665, -99.8494415283203, -1.74270151094675, 218, 51, 'PPL', 'P'),
(188817, 'La Puebla', 35.9891700744629, 0.62812951285959, -105.995826721191, -1.84997616965818, 218, 38, 'PPL', 'P'),
(182579, 'La Puente', 34.0200004577637, 0.593761019517954, -117.948608398438, -2.05859156469817, 218, 6, 'PPL', 'P'),
(188818, 'La Puente', 36.7000007629395, 0.640535848797724, -106.600280761719, -1.86052588284236, 218, 38, 'PPL', 'P'),
(95457, 'La Puerta', 26.3441696166992, 0.459792498515254, -98.7447204589844, -1.72342049097068, 218, 51, 'PPL', 'P'),
(95458, 'La Puerta Number 2 Colonia', 26.3500003814697, 0.459894264558409, -98.754997253418, -1.7235998548701, 218, 51, 'PPL', 'P'),
(207835, 'La Push', 47.9088897705078, 0.836167867470392, -124.635276794434, -2.17529594419735, 218, 56, 'PPL', 'P'),
(182582, 'La Quinta', 33.663330078125, 0.587535947048921, -116.309173583984, -2.02997802931414, 218, 6, 'PPL', 'P'),
(95459, 'La Quinta Colonia', 26.1350002288818, 0.45614180400346, -98.1959991455078, -1.71384349737465, 218, 51, 'PPL', 'P'),
(95460, 'La Reforma', 26.6852798461914, 0.465745995132126, -98.3741683959961, -1.71695313742148, 218, 51, 'PPL', 'P'),
(41646, 'La Reussite', 29.7005596160889, 0.518372554985614, -89.9875030517578, -1.57057821390162, 218, 22, 'PPL', 'P'),
(95461, 'La Reyna Colonia', 26.0990009307861, 0.455513497723283, -97.9629974365234, -1.7097768503901, 218, 51, 'PPL', 'P'),
(182583, 'La Riviera', 38.5669403076172, 0.673120090788035, -121.355827331543, -2.11805875341715, 218, 6, 'PPL', 'P'),
(120258, 'La Rose', 40.9822196960449, 0.715274668471654, -89.2352828979492, -1.5574494955178, 218, 18, 'PPL', 'P'),
(182584, 'La Rose (historical)', 35.1041717529297, 0.612683378274212, -118.27082824707, -2.06421536197209, 218, 6, 'PPL', 'P'),
(41647, 'La Rosen', 32.4033317565918, 0.565544827768565, -93.7891693115234, -1.63692980719651, 218, 22, 'PPL', 'P'),
(95462, 'La Rosita', 26.4005603790283, 0.460776702985606, -98.920280456543, -1.72648459096287, 218, 51, 'PPL', 'P'),
(27650, 'La Rue', 37.5455589294434, 0.655293622820344, -89.45361328125, -1.56126007956354, 218, 18, 'PPL', 'P'),
(156028, 'La Rue', 40.5763893127441, 0.708191592078424, -83.3847198486328, -1.45533790721171, 218, 41, 'PPL', 'P'),
(55744, 'La Russell', 37.1413917541504, 0.648239574882997, -94.061393737793, -1.64168101973926, 218, 29, 'PPL', 'P'),
(192660, 'La Sal', 38.3122215270996, 0.668674409401338, -109.247497558594, -1.90672853196193, 218, 52, 'PPL', 'P'),
(192661, 'La Sal Junction', 38.3105583190918, 0.668645380945456, -109.404441833496, -1.90946772630113, 218, 52, 'PPL', 'P'),
(95463, 'La Salle', 28.791389465332, 0.502504542394054, -96.6688919067383, -1.68719044802708, 218, 51, 'PPL', 'P'),
(120259, 'La Salle', 41.3333282470703, 0.721402668718953, -89.091667175293, -1.55494292829982, 218, 18, 'PPL', 'P'),
(131614, 'La Salle', 41.8677787780762, 0.730730590174038, -83.4522171020508, -1.45651595651991, 218, 27, 'PPL', 'P'),
(136288, 'La Salle', 44.0708312988281, 0.76918111025552, -94.5694427490234, -1.65054814774674, 218, 28, 'PPL', 'P'),
(150082, 'La Salle', 43.0825004577637, 0.75193148297994, -78.9683303833008, -1.37825736999127, 218, 40, 'PPL', 'P'),
(182589, 'La Salle', 34.6477813720703, 0.604717863453785, -120.525283813477, -2.10356303444579, 218, 6, 'PPL', 'P'),
(194279, 'La Salle', 40.3488883972168, 0.704220952051171, -104.701393127441, -1.82738404149882, 218, 7, 'PPL', 'P'),
(196857, 'La Salle', 48.313060760498, 0.843221981986766, -114.243057250977, -1.99391749657392, 218, 31, 'PPL', 'P'),
(182585, 'La Selva Beach', 36.9366683959961, 0.644666478227465, -121.863609313965, -2.12692122089271, 218, 6, 'PPL', 'P'),
(182588, 'La Sierra', 33.9208297729492, 0.592030164546484, -117.495559692383, -2.05068437310562, 218, 6, 'PPL', 'P'),
(182590, 'La Sierra Heights', 33.9441719055176, 0.592437561614239, -117.485557556152, -2.05050980289616, 218, 6, 'PPL', 'P'),
(95465, 'La Suena Colonia', 26.2779998779297, 0.458637618708541, -98.3440017700195, -1.71642663047397, 218, 51, 'PPL', 'P'),
(178494, 'La Terraza', 33.4638900756836, 0.584055062346133, -112.188056945801, -1.95805097511912, 218, 5, 'PPL', 'P'),
(41649, 'La Tierra', 32.461109161377, 0.566553233715323, -93.8708267211914, -1.63835499785386, 218, 22, 'PPL', 'P'),
(103416, 'La Tierra', 37.166389465332, 0.648675867248579, -76.3902816772461, -1.33326193179384, 218, 53, 'PPL', 'P'),
(95466, 'La Tina', 26.2190704345703, 0.457609105895552, -97.4717788696289, -1.70120346905086, 218, 51, 'PPL', 'P'),
(163475, 'La Trappe', 40.1302795410156, 0.700405507736442, -74.9794387817383, -1.30863807803886, 218, 45, 'PPL', 'P'),
(191710, 'La Tuna', 31.9808292388916, 0.558170767736731, -106.589996337891, -1.86034638578489, 218, 51, 'PPL', 'P'),
(188821, 'La Union', 31.9505596160889, 0.557642463155486, -106.661109924316, -1.86158755201092, 218, 38, 'PPL', 'P'),
(191711, 'La Union Estates Colonia', 31.9169998168945, 0.557056734163237, -106.603996276855, -1.8605907308149, 218, 51, 'PPL', 'P'),
(188822, 'La Union Vieja', 31.9408302307129, 0.55747265334648, -106.668891906738, -1.86172337322652, 218, 38, 'PPL', 'P'),
(48765, 'La Vale', 39.6555595397949, 0.692120080690069, -78.8108291625977, -1.37550845511409, 218, 25, 'PPL', 'P'),
(174834, 'La Valle', 43.582218170166, 0.760653202391895, -90.128059387207, -1.57303138473975, 218, 57, 'PPL', 'P'),
(186946, 'La Valley', 37.1019401550293, 0.647551014583157, -105.347221374512, -1.83865587081258, 218, 7, 'PPL', 'P'),
(88340, 'La Vergne', 36.0155601501465, 0.628590106570119, -86.5819396972656, -1.51113992048047, 218, 50, 'PPL', 'P'),
(192662, 'La Verkin', 37.2011108398438, 0.649281869554626, -113.268890380859, -1.97691507722653, 218, 52, 'PPL', 'P'),
(182591, 'La Verne', 34.100830078125, 0.595171762526396, -117.766937255859, -2.05542080510432, 218, 6, 'PPL', 'P'),
(95467, 'La Vernia', 29.3561096191406, 0.512360768430382, -98.1152801513672, -1.712434685158, 218, 51, 'PPL', 'P'),
(186947, 'La Veta', 37.5050010681152, 0.654585754602601, -105.007217407227, -1.83272168211361, 218, 7, 'PPL', 'P'),
(186948, 'La Veta Pass', 37.5930595397949, 0.656122664867686, -105.202781677246, -1.83613492252471, 218, 7, 'PPL', 'P'),
(95468, 'La Victoria', 26.3405609130859, 0.459729514755474, -98.6397171020508, -1.72158783666655, 218, 51, 'PPL', 'P'),
(95469, 'La Villa', 26.2983303070068, 0.45899245163428, -97.9283294677734, -1.70917178019043, 218, 51, 'PPL', 'P'),
(188823, 'La Villita', 36.103328704834, 0.630121956829133, -106.047500610352, -1.85087804916133, 218, 38, 'PPL', 'P'),
(182592, 'La Vina', 36.8805618286133, 0.643687233894642, -120.109443664551, -2.09630525468505, 218, 6, 'PPL', 'P'),
(22443, 'La Vista', 33.814998626709, 0.590183062593433, -84.3349990844727, -1.47192340869045, 218, 13, 'PPL', 'P'),
(142197, 'La Vista', 41.1838912963867, 0.718794501905384, -96.0308303833008, -1.67605417361281, 218, 35, 'PPL', 'P'),
(95470, 'La Ward', 28.8436107635498, 0.50341597598762, -96.4638900756836, -1.68361249110256, 218, 51, 'PPL', 'P'),
(88342, 'Laager', 35.372501373291, 0.617366613630144, -85.5988922119141, -1.49398250515763, 218, 50, 'PPL', 'P'),
(112375, 'Laark', 32.9919395446777, 0.575817971673545, -91.5100021362305, -1.59715083578427, 218, 22, 'PPL', 'P'),
(55747, 'Labadie', 38.5288887023926, 0.672455964991196, -90.8499984741211, -1.58563159880524, 218, 29, 'PPL', 'P'),
(41651, 'Labadieville', 29.8372192382813, 0.520757715347402, -90.9561080932617, -1.58748356102728, 218, 22, 'PPL', 'P'),
(95474, 'Laban', 29.6847190856934, 0.51809608557495, -96.4691696166992, -1.68370463647628, 218, 51, 'PPL', 'P'),
(103417, 'Laban', 37.4002799987793, 0.65275802714648, -76.2838897705078, -1.33140504272378, 218, 53, 'PPL', 'P'),
(88343, 'Laban (historical)', 36.2008285522461, 0.631823650186666, -82.0097198486328, -1.43133962999679, 218, 50, 'PPL', 'P'),
(131618, 'Labarge', 42.811939239502, 0.747209298893066, -85.4875030517578, -1.49203839756187, 218, 27, 'PPL', 'P'),
(41652, 'Labarre', 30.7144393920898, 0.536068095296213, -91.5455627441406, -1.59777148547631, 218, 22, 'PPL', 'P'),
(36769, 'Labascus', 37.226390838623, 0.649723088768225, -84.9191665649414, -1.48211905460771, 218, 21, 'PPL', 'P'),
(190388, 'Labbe Camp', 36.4508285522461, 0.636186973316652, -116.055557250977, -2.02555158926632, 218, 39, 'PPL', 'P'),
(136290, 'LaBelle', 46.8827781677246, 0.818258841508909, -96.0622177124023, -1.67660198584904, 218, 28, 'PPL', 'P'),
(195201, 'Labelle', 43.7033309936523, 0.762767019928118, -111.860000610352, -1.9523253119335, 218, 17, 'PPL', 'P'),
(32955, 'Labette', 37.2305603027344, 0.649795859645012, -95.1833267211914, -1.66126244428629, 218, 20, 'PPL', 'P'),
(201087, 'Labish Center', 45.0319404602051, 0.785955629592629, -122.912498474121, -2.14522779022592, 218, 43, 'PPL', 'P'),
(201088, 'Labish Village', 45.0194396972656, 0.785737450120324, -122.97110748291, -2.14625071040062, 218, 43, 'PPL', 'P'),
(170677, 'LaBolt', 45.0508308410645, 0.786285328935581, -96.6763916015625, -1.68732134239466, 218, 49, 'PPL', 'P'),
(66161, 'Laboratory', 35.4341697692871, 0.6184429301847, -81.2602767944336, -1.41825938114481, 218, 33, 'PPL', 'P'),
(163476, 'Laboratory', 40.1549987792969, 0.700836939833034, -80.2136077880859, -1.39999156080547, 218, 45, 'PPL', 'P'),
(188826, 'Laborcita', 33.9458312988281, 0.592466523491094, -106.868057250977, -1.86519946423934, 218, 38, 'PPL', 'P'),
(163477, 'Laborde', 41.0252799987793, 0.716026212531274, -78.6522216796875, -1.37274023231901, 218, 45, 'PPL', 'P'),
(193215, 'Labouchere Bay', 56.2963905334473, 0.982557371797222, -133.632217407227, -2.33232218049698, 218, 1, 'PPL', 'P'),
(131616, 'LaBranche', 45.877498626709, 0.800713403615249, -87.4688873291016, -1.52662007694877, 218, 27, 'PPL', 'P'),
(3588, 'Labuco', 33.6094398498535, 0.586595385130932, -87.0891723632813, -1.51999280057611, 218, 2, 'PPL', 'P'),
(16754, 'LaBuena', 30.2422199249268, 0.527826310802204, -82.0994415283203, -1.43290556871775, 218, 12, 'PPL', 'P'),
(174840, 'Lac du Flambeau', 45.9697189331055, 0.802322951599065, -89.8919372558594, -1.5689102761109, 218, 57, 'PPL', 'P'),
(127900, 'Lac Frontiere', 46.6952781677246, 0.814986349161419, -69.9938888549805, -1.22162381679437, 218, 26, 'PPL', 'P'),
(131619, 'Lac La Belle', 47.3844413757324, 0.827014516224762, -88.0186080932617, -1.53621451424995, 218, 27, 'PPL', 'P'),
(174838, 'Lac La Belle', 43.1441688537598, 0.753007799534496, -88.5305633544922, -1.54514981918132, 218, 57, 'PPL', 'P'),
(136291, 'Lac qui Parle', 45.000560760498, 0.785407950514454, -95.9058303833008, -1.67387251204781, 218, 28, 'PPL', 'P'),
(207836, 'Lacamas', 46.5611114501953, 0.81264469819394, -122.65055847168, -2.14065607474063, 218, 56, 'PPL', 'P'),
(41653, 'Lacamp', 31.163610458374, 0.543907609307566, -92.914436340332, -1.62166283677346, 218, 22, 'PPL', 'P'),
(156030, 'Lacarne', 41.5158309936523, 0.724587942540742, -83.0422210693359, -1.44936017582892, 218, 41, 'PPL', 'P'),
(41654, 'Lacassine', 30.235279083252, 0.527705170262119, -92.92138671875, -1.62178414376112, 218, 22, 'PPL', 'P'),
(120262, 'Lace', 41.7519416809082, 0.728708851432504, -87.9674987792969, -1.53532248844282, 218, 18, 'PPL', 'P'),
(116354, 'Lacelle', 40.9513893127441, 0.714736576773403, -93.8661117553711, -1.63827270617618, 218, 16, 'PPL', 'P'),
(95475, 'Laceola', 30.9716701507568, 0.540557618972355, -95.9866714477539, -1.67528345479334, 218, 51, 'PPL', 'P'),
(9912, 'Lacey', 33.4550018310547, 0.583899933212636, -91.8466720581055, -1.60302683441342, 218, 4, 'PPL', 'P'),
(36770, 'Lacey', 37.8597183227539, 0.660776738609681, -83.0316696166992, -1.44917601823954, 218, 21, 'PPL', 'P'),
(71005, 'Lacey', 39.872501373291, 0.695906429969889, -74.2955627441406, -1.29670218950729, 218, 37, 'PPL', 'P'),
(76311, 'Lacey', 36.1161117553711, 0.630345063149454, -98.0858306884766, -1.71192069506761, 218, 42, 'PPL', 'P'),
(116355, 'Lacey', 41.4008293151855, 0.722580784606177, -92.6399993896484, -1.6168730083949, 218, 16, 'PPL', 'P'),
(131620, 'Lacey', 42.4930610656738, 0.741643824847019, -85.1911087036133, -1.48686534030245, 218, 27, 'PPL', 'P'),
(207837, 'Lacey', 47.0344390869141, 0.820905823895366, -122.821937561035, -2.14364720411896, 218, 56, 'PPL', 'P'),
(103422, 'Lacey Forest', 38.8827781677246, 0.678632501349362, -77.1294403076172, -1.34616268358835, 218, 53, 'PPL', 'P'),
(163478, 'Lacey Park', 40.1861114501953, 0.701379958379301, -75.0888900756836, -1.31054836348877, 218, 45, 'PPL', 'P'),
(103419, 'Lacey Spring', 38.5411109924316, 0.672669284194511, -78.7666702270508, -1.37473773629463, 218, 53, 'PPL', 'P'),
(3589, 'Laceys Chapel', 33.3727798461914, 0.582464888859247, -86.9208297729492, -1.51705466810348, 218, 2, 'PPL', 'P'),
(3590, 'Laceys Spring', 34.5341682434082, 0.60273494028514, -86.6041717529297, -1.51152794305129, 218, 2, 'PPL', 'P'),
(48766, 'Laceys Venture', 38.2825012207031, 0.668155692200018, -76.5650024414063, -1.33631138440004, 218, 25, 'PPL', 'P'),
(163479, 'Laceyville', 41.6458282470703, 0.726856822631435, -76.1616668701172, -1.32927185069063, 218, 45, 'PPL', 'P'),
(156043, 'Laceyville (historical)', 40.3222198486328, 0.703755498071652, -81.1319427490234, -1.41601952951, 218, 41, 'PPL', 'P'),
(131621, 'Lachine', 45.0774993896484, 0.7867507829151, -83.7161102294922, -1.46112176046714, 218, 27, 'PPL', 'P'),
(201089, 'Lachmund (historical)', 44.9361114501953, 0.784283097849032, -122.947219848633, -2.14583379253197, 218, 43, 'PPL', 'P'),
(41656, 'Lachute', 32.2636108398438, 0.563106237737406, -93.5263900756836, -1.63234344432523, 218, 22, 'PPL', 'P'),
(36772, 'Lacie', 38.5269393920898, 0.67242194310827, -85.1294403076172, -1.48578902374789, 218, 21, 'PPL', 'P'),
(182596, 'Lacjac', 36.6116714477539, 0.638994211421705, -119.483062744141, -2.08537284525223, 218, 6, 'PPL', 'P'),
(150086, 'Lackawack', 41.7830581665039, 0.729251936557798, -74.4177780151367, -1.29883524838239, 218, 40, 'PPL', 'P'),
(16755, 'Lackawanna', 30.2947196960449, 0.52874260466476, -81.7613906860352, -1.42700546848074, 218, 12, 'PPL', 'P'),
(150087, 'Lackawanna', 42.8255615234375, 0.747447052599383, -78.8236083984375, -1.37573149485539, 218, 40, 'PPL', 'P'),
(207838, 'Lackawanna Beach', 47.6497192382813, 0.831644488358892, -122.90389251709, -2.14507758794044, 218, 56, 'PPL', 'P'),
(163483, 'Lackawaxen', 41.4819412231445, 0.723996454462636, -74.9863891601563, -1.30875938502651, 218, 45, 'PPL', 'P'),
(36773, 'Lackey', 37.4683303833008, 0.653945730413628, -82.8288879394531, -1.44563681030888, 218, 21, 'PPL', 'P'),
(60524, 'Lackey', 33.8030586242676, 0.589974670238134, -88.4622192382813, -1.54395698932908, 218, 30, 'PPL', 'P'),
(103420, 'Lackey', 37.2308311462402, 0.649800586755947, -76.5530624389648, -1.33610299204474, 218, 53, 'PPL', 'P'),
(66165, 'Lackey Hill', 35.436939239502, 0.618491266558485, -83.438606262207, -1.45627840255067, 218, 33, 'PPL', 'P'),
(182597, 'Lackey Place', 35.6322212219238, 0.621899580121568, -118.64582824707, -2.07076034666707, 218, 6, 'PPL', 'P'),
(66163, 'Lackey Store', 36.5313911437988, 0.637593055793187, -80.1822204589844, -1.39944374856924, 218, 33, 'PPL', 'P'),
(66164, 'Lackey Town', 35.6116714477539, 0.621540918901761, -82.1650009155273, -1.43404979588011, 218, 33, 'PPL', 'P'),
(9913, 'Lackland (historical)', 33.7458305358887, 0.5889758516713, -93.216667175293, -1.62693775994458, 218, 4, 'PPL', 'P'),
(95479, 'Lackland City', 29.3888893127441, 0.512932882011559, -98.6458282470703, -1.7216944962682, 218, 51, 'PPL', 'P'),
(95476, 'Lackland Heights', 29.4050006866455, 0.513214078533157, -98.6547164916992, -1.7218496254017, 218, 51, 'PPL', 'P'),
(95477, 'Lackland Terrace', 29.4113903045654, 0.513325598403805, -98.6425018310547, -1.72163643935644, 218, 51, 'PPL', 'P'),
(32956, 'Lackmans', 38.9244384765625, 0.679359610905981, -94.7638931274414, -1.65394194708188, 218, 20, 'PPL', 'P'),
(32957, 'Laclede', 39.3472213745117, 0.686738564496318, -96.220832824707, -1.67937034180217, 218, 20, 'PPL', 'P'),
(55748, 'Laclede', 39.7855606079102, 0.694389027359789, -93.166389465332, -1.6260602483654, 218, 29, 'PPL', 'P'),
(195202, 'Laclede', 48.170280456543, 0.840729995575752, -116.754997253418, -2.03775912022908, 218, 17, 'PPL', 'P'),
(81926, 'Laco (historical)', 34.110279083252, 0.5953366787769, -82.147216796875, -1.43373940445506, 218, 48, 'PPL', 'P'),
(110004, 'Lacoma', 37.7433280944824, 0.658745345909196, -81.6797180175781, -1.42558001150727, 218, 58, 'PPL', 'P'),
(201090, 'Lacomb', 44.5852813720703, 0.778159957870722, -122.742218017578, -2.14225583560745, 218, 43, 'PPL', 'P'),
(41655, 'Lacombe', 30.3133296966553, 0.529067410449208, -89.9430618286133, -1.56980256823413, 218, 22, 'PPL', 'P'),
(3591, 'Lacon', 34.3347206115723, 0.599253922424297, -86.9033279418945, -1.51674920352645, 218, 2, 'PPL', 'P'),
(36774, 'Lacon', 37.4922218322754, 0.654362714861307, -86.0841674804688, -1.50245215637241, 218, 21, 'PPL', 'P'),
(120263, 'Lacon', 41.0247192382813, 0.716016425414268, -89.4111099243164, -1.5605182560419, 218, 18, 'PPL', 'P'),
(195203, 'Lacon', 47.4391708374023, 0.827969725528746, -116.744171142578, -2.03757016894974, 218, 17, 'PPL', 'P'),
(116356, 'Lacona', 41.1897201538086, 0.718896234659025, -93.3827819824219, -1.6298370102653, 218, 16, 'PPL', 'P'),
(150089, 'Lacona', 43.6433296203613, 0.761719798408472, -76.0688934326172, -1.32765264874786, 218, 40, 'PPL', 'P'),
(9914, 'Laconia', 34.0530586242676, 0.59433799336812, -90.9541702270508, -1.58744973888143, 218, 4, 'PPL', 'P'),
(30275, 'Laconia', 38.0316696166992, 0.663777854842091, -86.085563659668, -1.50247652429639, 218, 19, 'PPL', 'P'),
(88344, 'Laconia', 35.2822189331055, 0.615790887792171, -89.2519378662109, -1.55774017955078, 218, 50, 'PPL', 'P'),
(103421, 'Laconia', 36.7372207641602, 0.641185460366622, -78.6366729736328, -1.37246885620393, 218, 53, 'PPL', 'P'),
(144030, 'Laconia', 43.5277786254883, 0.759703053093982, -71.470832824707, -1.24740135193358, 218, 36, 'PPL', 'P'),
(22445, 'Laconte', 31.2130603790283, 0.544770673237833, -83.4491729736328, -1.45646282645616, 218, 13, 'PPL', 'P'),
(16756, 'Lacoochee', 28.4655609130859, 0.496817761360353, -82.1722183227539, -1.43417576339967, 218, 12, 'PPL', 'P'),
(16757, 'Lacota', 29.233060836792, 0.510213162037829, -81.9261093139648, -1.42988035087748, 218, 12, 'PPL', 'P'),
(131622, 'Lacota', 42.4136085510254, 0.740257116867414, -86.1297225952148, -1.50324724311585, 218, 27, 'PPL', 'P'),
(41657, 'Lacour', 30.8280601501465, 0.538051151622914, -91.6138916015625, -1.59896404901245, 218, 22, 'PPL', 'P'),
(182598, 'Lacresta (historical)', 38.4558296203613, 0.671180843461266, -122.883056640625, -2.14471393329359, 218, 6, 'PPL', 'P'),
(9910, 'LaCrosse', 36.0905609130859, 0.629899116824921, -91.8413925170898, -1.6029346890397, 218, 4, 'PPL', 'P'),
(182602, 'Lacto (historical)', 37.938060760498, 0.662144072092355, -121.478332519531, -2.12019687229832, 218, 6, 'PPL', 'P'),
(30276, 'Lacy', 38.6336097717285, 0.674283692447318, -86.7763900756836, -1.51453371981561, 218, 19, 'PPL', 'P'),
(88345, 'Lacy', 35.1111106872559, 0.612804485524784, -88.857780456543, -1.55086083498095, 218, 50, 'PPL', 'P'),
(95478, 'Lacy', 31.1043605804443, 0.542873503856288, -95.0882034301758, -1.65960222966273, 218, 51, 'PPL', 'P'),
(202283, 'Lacy', 44.4955596923828, 0.776594019149755, -100.700828552246, -1.75756101772301, 218, 49, 'PPL', 'P'),
(9917, 'Lacy (historical)', 33.920280456543, 0.59202057716656, -91.2358322143555, -1.59236566793761, 218, 4, 'PPL', 'P'),
(150090, 'Lacy Corners', 42.5047187805176, 0.741847290354301, -76.2988891601563, -1.33166683145894, 218, 40, 'PPL', 'P'),
(188827, 'Lacy Place', 35.0813903808594, 0.612285768323464, -106.139167785645, -1.8524779431862, 218, 38, 'PPL', 'P'),
(95480, 'Lacy-Lakeview', 31.6291694641113, 0.552033146819993, -97.1025009155273, -1.69475835289676, 218, 51, 'PPL', 'P'),
(16758, 'Lacymark', 30.2119407653809, 0.527297839773392, -82.6486129760742, -1.442490418639, 218, 12, 'PPL', 'P'),
(55750, 'Lacyville', 38.3972206115723, 0.670157923286567, -94.4822235107422, -1.64902588486765, 218, 29, 'PPL', 'P'),
(95481, 'Lacyville', 31.5049991607666, 0.549865966193428, -94.6069412231445, -1.65120261958462, 218, 51, 'PPL', 'P'),
(9918, 'Ladd', 34.1408309936523, 0.595869910206161, -91.9088897705078, -1.6041127383479, 218, 4, 'PPL', 'P'),
(55751, 'Ladd', 37.5863914489746, 0.656006284728049, -92.1119384765625, -1.60765660681047, 218, 29, 'PPL', 'P'),
(73144, 'Ladd', 38.9872207641602, 0.680455368536494, -83.1808319091797, -1.45177939136315, 218, 41, 'PPL', 'P'),
(95482, 'Ladd', 30.0458297729492, 0.524398656031704, -94.9208297729492, -1.65668100826303, 218, 51, 'PPL', 'P'),
(103423, 'Ladd', 38.0558280944824, 0.664199499821678, -78.95361328125, -1.37800050810414, 218, 53, 'PPL', 'P'),
(120265, 'Ladd', 41.3824996948242, 0.722260872380231, -89.2188873291016, -1.55716333885867, 218, 18, 'PPL', 'P'),
(88346, 'Ladd Estates', 35.9500007629395, 0.627445879407767, -84.4875030517578, -1.47458510504193, 218, 50, 'PPL', 'P'),
(201091, 'Ladd Hill', 45.2744407653809, 0.790188058355038, -122.855003356934, -2.14422431112718, 218, 43, 'PPL', 'P'),
(88347, 'Laddie Village', 35.8794403076172, 0.626214367140687, -84.5044403076172, -1.47488071592293, 218, 50, 'PPL', 'P'),
(55753, 'Laddonia', 39.2425003051758, 0.684910837040197, -91.6452789306641, -1.59951186124868, 218, 29, 'PPL', 'P'),
(22446, 'Ladds', 34.148609161377, 0.596005664842727, -84.8294372558594, -1.48055298272869, 218, 13, 'PPL', 'P'),
(88348, 'Ladds', 35.0105590820313, 0.611049528945449, -85.5469436645508, -1.49307583196451, 218, 50, 'PPL', 'P'),
(163491, 'Laddsburg', 41.5747184753418, 0.725615722984431, -76.4175033569336, -1.33373703973231, 218, 45, 'PPL', 'P'),
(9925, 'Ladelle', 33.4644393920898, 0.584064649726057, -91.7936096191406, -1.60210072014434, 218, 4, 'PPL', 'P'),
(170678, 'LaDelle', 44.6752815246582, 0.779730756860678, -98.1186065673828, -1.71249274206976, 218, 49, 'PPL', 'P'),
(36775, 'Laden', 36.916389465332, 0.644312544118593, -83.1933288574219, -1.45199750425642, 218, 21, 'PPL', 'P'),
(76313, 'Laden', 35.7174987792969, 0.623387954275786, -96.0472183227539, -1.67634019711388, 218, 42, 'PPL', 'P'),
(150091, 'Ladentown', 41.1858291625977, 0.718828324051228, -74.0677795410156, -1.29272662263202, 218, 40, 'PPL', 'P'),
(182599, 'Ladera', 37.4000015258789, 0.65275316687749, -122.197219848633, -2.13274382314201, 218, 6, 'PPL', 'P'),
(182600, 'Ladera Heights', 33.9941711425781, 0.593310212924431, -118.374443054199, -2.06602378151031, 218, 6, 'PPL', 'P'),
(182601, 'Ladera Ranch', 33.5708312988281, 0.585921538796115, -117.634719848633, -2.05311317601977, 218, 6, 'PPL', 'P'),
(55752, 'Ladero', 36.9958305358887, 0.645699052361115, -90.4700012207031, -1.57899939558456, 218, 29, 'PPL', 'P'),
(48767, 'Ladiesburg', 39.5763893127441, 0.690738299558481, -77.2652816772461, -1.34853356274879, 218, 25, 'PPL', 'P'),
(3592, 'Ladiga', 33.9488906860352, 0.59251991987095, -85.5811080932617, -1.49367211373258, 218, 2, 'PPL', 'P'),
(150092, 'Ladleton', 41.9408302307129, 0.732005578545913, -74.5186080932617, -1.30059506523071, 218, 40, 'PPL', 'P'),
(202284, 'Ladner', 45.827220916748, 0.799835892036068, -103.727500915527, -1.81038641584138, 218, 49, 'PPL', 'P'),
(30279, 'Ladoga', 39.9136085510254, 0.696623885567556, -86.8011093139648, -1.5149651519122, 218, 19, 'PPL', 'P'),
(116357, 'Ladoga', 40.7416687011719, 0.711076261592171, -94.7949981689453, -1.65448483247009, 218, 16, 'PPL', 'P'),
(131625, 'Ladoga', 46.2819404602051, 0.807772245242558, -87.0547180175781, -1.51939145880197, 218, 27, 'PPL', 'P'),
(140347, 'Ladoga', 46.8761100769043, 0.818142461369272, -99.5625, -1.73769343651685, 218, 34, 'PPL', 'P'),
(174842, 'Ladoga', 43.7200012207031, 0.76305797027721, -88.6741714477539, -1.54765625324125, 218, 57, 'PPL', 'P'),
(3593, 'Ladonia', 32.4680595397949, 0.566674540702976, -85.0791702270508, -1.48491164532677, 218, 2, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(66168, 'Ladonia', 36.4822196960449, 0.636734852131909, -80.8380584716797, -1.41089028125051, 218, 33, 'PPL', 'P'),
(95485, 'Ladonia', 33.4247207641602, 0.58337142889431, -95.9461135864258, -1.67457558657559, 218, 51, 'PPL', 'P'),
(116358, 'Ladora', 41.7547187805176, 0.728757320964343, -92.1833267211914, -1.60890256672646, 218, 16, 'PPL', 'P'),
(207839, 'Ladow', 46.9858283996582, 0.820057407351094, -117.084442138672, -2.04350901818062, 218, 56, 'PPL', 'P'),
(182603, 'Ladrillo (historical)', 32.8194389343262, 0.572807268061211, -117.222221374512, -2.0459137194869, 218, 6, 'PPL', 'P'),
(81927, 'Ladson', 32.9855613708496, 0.57570665153998, -80.1100006103516, -1.3981832744253, 218, 48, 'PPL', 'P'),
(81928, 'Ladson Village', 32.9958305358887, 0.575885882281342, -80.1186065673828, -1.39833347671078, 218, 48, 'PPL', 'P'),
(55759, 'Ladue', 38.6497192382813, 0.674564855679403, -90.3805618286133, -1.57743838371161, 218, 29, 'PPL', 'P'),
(16759, 'Lady Lake', 28.9172191619873, 0.504700684897474, -81.9230575561523, -1.42982708765568, 218, 12, 'PPL', 'P'),
(204598, 'Lady of the Lake', 40.6058311462402, 0.708705449010755, -111.587219238281, -1.94756437885277, 218, 52, 'PPL', 'P'),
(32959, 'Ladysmith', 39.2713890075684, 0.685415040013576, -97.1841735839844, -1.69618380987023, 218, 20, 'PPL', 'P'),
(103424, 'Ladysmith', 38.0175018310547, 0.663530580334877, -77.5155563354492, -1.35290167956874, 218, 53, 'PPL', 'P'),
(174843, 'Ladysmith', 45.4630584716797, 0.793480058357512, -91.103889465332, -1.59006283254302, 218, 57, 'PPL', 'P'),
(210532, 'Lae Ã‚â€˜Apuki (historical)', 19.3172206878662, 0.337149103337629, -155.068603515625, -2.70645769781731, 218, 15, 'PPL', 'P'),
(150093, 'Lafarges Landing', 41.0327796936035, 0.716157106898851, -72.2080612182617, -1.26026841474029, 218, 40, 'PPL', 'P'),
(3594, 'Lafayette', 32.8997192382813, 0.574208423689729, -85.4011077880859, -1.49053051575267, 218, 2, 'PPL', 'P'),
(16760, 'Lafayette', 30.4277801513672, 0.531064947714336, -84.2163925170898, -1.46985333357513, 218, 12, 'PPL', 'P'),
(22444, 'LaFayette', 34.704719543457, 0.605711622014549, -85.2819366455078, -1.48845058694132, 218, 13, 'PPL', 'P'),
(36768, 'LaFayette', 36.6811103820801, 0.640206149454773, -87.6202774047852, -1.52926233222429, 218, 21, 'PPL', 'P'),
(41658, 'Lafayette', 30.2238903045654, 0.527506398576258, -92.0197219848633, -1.60604712540568, 218, 22, 'PPL', 'P'),
(76314, 'Lafayette', 35.1738891601563, 0.61390017657627, -95.1033325195313, -1.65986628208481, 218, 42, 'PPL', 'P'),
(88350, 'Lafayette', 36.1858291625977, 0.631561861451512, -85.7161102294922, -1.49602834550703, 218, 50, 'PPL', 'P'),
(95471, 'LaFayette', 32.8983306884766, 0.574184188923809, -94.855827331543, -1.65554650163865, 218, 51, 'PPL', 'P'),
(103425, 'Lafayette', 37.2361106872559, 0.649892732129663, -80.211669921875, -1.39995773865962, 218, 53, 'PPL', 'P'),
(116359, 'Lafayette', 42.1469383239746, 0.735602843388337, -91.6800003051758, -1.60011786355472, 218, 16, 'PPL', 'P'),
(120267, 'Lafayette', 41.1080589294434, 0.717470977422642, -89.9713897705078, -1.57029698409051, 218, 18, 'PPL', 'P'),
(122988, 'Lafayette', 40.4166717529297, 0.705403994786411, -86.8752822875977, -1.51625971451809, 218, 19, 'PPL', 'P'),
(136294, 'Lafayette', 44.4466705322266, 0.775740742336494, -94.3949966430664, -1.6475034888305, 218, 28, 'PPL', 'P'),
(145546, 'Lafayette', 41.098331451416, 0.717301200903149, -74.6888885498047, -1.30356701984918, 218, 37, 'PPL', 'P'),
(150083, 'LaFayette', 42.892219543457, 0.748610454521584, -76.1055603027344, -1.32829260635781, 218, 40, 'PPL', 'P'),
(156032, 'Lafayette', 41.0991706848145, 0.717315848289145, -81.9352798461914, -1.43004040685899, 218, 41, 'PPL', 'P'),
(163487, 'Lafayette', 40.0527801513672, 0.69905288821879, -75.269172668457, -1.3136948883167, 218, 45, 'PPL', 'P'),
(169453, 'Lafayette', 41.5705604553223, 0.725543151844727, -71.477783203125, -1.24752265892123, 218, 47, 'PPL', 'P'),
(182604, 'Lafayette', 37.8858299255371, 0.661232472051221, -122.116943359375, -2.13134273409252, 218, 6, 'PPL', 'P'),
(186949, 'Lafayette', 39.9936103820801, 0.698020180927085, -105.089172363281, -1.83415206593509, 218, 7, 'PPL', 'P'),
(201092, 'Lafayette', 45.2444381713867, 0.789664414305701, -123.113609313965, -2.14873783654264, 218, 43, 'PPL', 'P'),
(41659, 'Lafayette (historical)', 29.9236106872559, 0.522265530577578, -90.0805587768555, -1.5722023426924, 218, 22, 'PPL', 'P'),
(116360, 'Lafayette (historical)', 41.2874984741211, 0.720602788285548, -91.3625030517578, -1.59457649111654, 218, 16, 'PPL', 'P'),
(103426, 'Lafayette Annex', 36.877498626709, 0.643633770935759, -76.2638931274414, -1.33105603546293, 218, 53, 'PPL', 'P'),
(150094, 'Lafayette Corners', 42.5933303833008, 0.743393854578337, -76.2874984741211, -1.33146802648356, 218, 40, 'PPL', 'P'),
(22447, 'Lafayette Estates', 33.538330078125, 0.585354285483928, -84.4561080932617, -1.47403715964765, 218, 13, 'PPL', 'P'),
(81929, 'Lafayette Heights', 33.9491691589355, 0.592524780139939, -80.3383331298828, -1.4021684286805, 218, 48, 'PPL', 'P'),
(131617, 'LaFayette Landing', 46.7991714477539, 0.816799628968627, -89.8405609130859, -1.56801358977187, 218, 27, 'PPL', 'P'),
(145547, 'Lafayette Mills', 40.3074989318848, 0.703498569605487, -74.304443359375, -1.29685718548273, 218, 37, 'PPL', 'P'),
(66166, 'Lafayette Park', 35.3138885498047, 0.616343626876417, -78.0416717529297, -1.36208412584928, 218, 33, 'PPL', 'P'),
(163488, 'Lafayette Park', 40.0916709899902, 0.699731661401624, -75.3966674804688, -1.31592009256552, 218, 45, 'PPL', 'P'),
(103427, 'Lafayette Shores', 36.8844413757324, 0.643754944765358, -76.2658309936523, -1.33108985760877, 218, 53, 'PPL', 'P'),
(60527, 'Lafayette Springs', 34.3172187805176, 0.598948457847265, -89.2611083984375, -1.5579002355323, 218, 30, 'PPL', 'P'),
(81930, 'Lafayette Village', 34.2986106872559, 0.59862368535233, -80.6074981689453, -1.4068662448434, 218, 48, 'PPL', 'P'),
(48768, 'Lafayettes Crossing', 39.6794395446777, 0.692536865400666, -76.2305603027344, -1.3304742679228, 218, 25, 'PPL', 'P'),
(150095, 'Lafayetteville', 41.9580612182617, 0.73230631601201, -73.7466735839844, -1.28712226643405, 218, 40, 'PPL', 'P'),
(163490, 'Lafayetteville', 40.2016716003418, 0.701651534231462, -78.4538879394531, -1.36927865553413, 218, 45, 'PPL', 'P'),
(9924, 'Lafe', 36.2041702270508, 0.631881973414539, -90.5138931274414, -1.57976545387212, 218, 4, 'PPL', 'P'),
(73143, 'LaFeuille Terrace', 39.1355590820313, 0.683044360590215, -84.5905609130859, -1.47638380404217, 218, 41, 'PPL', 'P'),
(9926, 'Lafferty', 35.9141693115234, 0.626820502604789, -91.8249969482422, -1.60264853238057, 218, 4, 'PPL', 'P'),
(156035, 'Lafferty', 40.1116714477539, 0.700080735241506, -81.0194396972656, -1.41405598083828, 218, 41, 'PPL', 'P'),
(14065, 'Laffertys Corner', 39.1505584716797, 0.68330614932537, -75.4861068725586, -1.31748110443847, 218, 10, 'PPL', 'P'),
(156036, 'Laffertys Trailer Court', 41.4988899230957, 0.724292265080716, -83.478889465332, -1.45698147707845, 218, 41, 'PPL', 'P'),
(22448, 'Laffingal', 34.1913909912109, 0.596752348633358, -84.6486129760742, -1.47739700367889, 218, 13, 'PPL', 'P'),
(41661, 'Lafitte', 29.6666698455811, 0.517781066907507, -90.1083297729492, -1.5726870380108, 218, 22, 'PPL', 'P'),
(95483, 'Lafitte', 29.6619396209717, 0.517698508913715, -96.2624969482422, -1.68009751793782, 218, 51, 'PPL', 'P'),
(41662, 'Lafitte Hill', 30.3449993133545, 0.529620149533454, -91.0602798461914, -1.58930170110348, 218, 22, 'PPL', 'P'),
(55756, 'Laflin', 37.2769393920898, 0.650605327458341, -89.8883285522461, -1.56884729235112, 218, 29, 'PPL', 'P'),
(163492, 'Laflin', 41.288890838623, 0.720627089630495, -75.8058319091797, -1.32306135902856, 218, 45, 'PPL', 'P'),
(88341, 'LaFollette', 36.3827781677246, 0.634999270049504, -84.120002746582, -1.46817101471453, 218, 50, 'PPL', 'P'),
(32961, 'Lafontaine', 37.399169921875, 0.652738652649549, -95.8450012207031, -1.67281084287925, 218, 20, 'PPL', 'P'),
(41663, 'Lafourche', 29.766939163208, 0.519531096638825, -90.7658309936523, -1.58416259914795, 218, 22, 'PPL', 'P'),
(110003, 'LaFrank', 38.2186088562012, 0.667040560072575, -80.5591735839844, -1.40602282172617, 218, 58, 'PPL', 'P'),
(41665, 'Lagan', 29.9752807617188, 0.523167343501706, -90.8144378662109, -1.58501094911319, 218, 22, 'PPL', 'P'),
(95484, 'Lagarto', 28.1191692352295, 0.490772086080251, -97.9552764892578, -1.70964209443894, 218, 51, 'PPL', 'P'),
(41666, 'Lagas', 32.3586082458496, 0.564764255253062, -93.5625, -1.63297368139719, 218, 22, 'PPL', 'P'),
(95486, 'Lago', 26.0883293151855, 0.455327242894545, -97.6133270263672, -1.70367395043607, 218, 51, 'PPL', 'P'),
(195204, 'Lago', 42.4513893127441, 0.740916515553318, -111.695831298828, -1.94946001691669, 218, 17, 'PPL', 'P'),
(204596, 'Lago', 40.704719543457, 0.710431377134208, -112.258888244629, -1.95928721449713, 218, 52, 'PPL', 'P'),
(95487, 'Lago Colonia', 26.0890007019043, 0.455338960803342, -97.6129989624023, -1.70366822463973, 218, 51, 'PPL', 'P'),
(95488, 'Lago Halcon A Colonia', 26.8700008392334, 0.468969984658262, -99.2559967041016, -1.73234394483521, 218, 51, 'PPL', 'P'),
(95489, 'Lago Halcon B Colonia', 26.8719997406006, 0.469004872068542, -99.2539978027344, -1.73230905742493, 218, 51, 'PPL', 'P'),
(95490, 'Lago Vista', 30.4599990844727, 0.531627274178506, -97.9880599975586, -1.71021427459914, 218, 51, 'PPL', 'P'),
(191712, 'Lago Vista Colonia', 28.6830005645752, 0.50061279920323, -100.487998962402, -1.75384644063457, 218, 51, 'PPL', 'P'),
(182605, 'Lagol', 34.2694396972656, 0.598114555530934, -118.949722290039, -2.07606429829407, 218, 6, 'PPL', 'P'),
(41667, 'Lagonda', 29.6783294677734, 0.517984565704303, -91.2799987792969, -1.59313651991514, 218, 22, 'PPL', 'P'),
(55757, 'Lagonda', 39.6569404602051, 0.692144182297934, -92.732780456543, -1.61849234349573, 218, 29, 'PPL', 'P'),
(73154, 'Lagonda', 39.935001373291, 0.696997260752385, -83.7763900756836, -1.46217384225578, 218, 41, 'PPL', 'P'),
(163494, 'Lagonda', 40.1213912963867, 0.700250378602944, -80.289436340332, -1.40131501870918, 218, 45, 'PPL', 'P'),
(66167, 'Lagoon', 34.5611114501953, 0.60320518795462, -78.4349975585938, -1.36894895619118, 218, 33, 'PPL', 'P'),
(211957, 'Lagoon', 63.6833305358887, 1.1114837964871, -149.85693359375, -2.61549689815344, 218, 1, 'PPL', 'P'),
(131624, 'Lagoon Beach', 43.6611099243164, 0.762030123254493, -83.8899993896484, -1.4641566988454, 218, 27, 'PPL', 'P'),
(125188, 'Lagoon Heights', 41.4500007629395, 0.723438988267455, -70.579719543457, -1.23184849116751, 218, 23, 'PPL', 'P'),
(136297, 'Lagoona Beach', 45.3663902282715, 0.791792879227919, -96.4852828979492, -1.68398586628739, 218, 28, 'PPL', 'P'),
(103428, 'Lagrange', 38.4413909912109, 0.670928841843117, -77.8533325195313, -1.35879698611579, 218, 53, 'PPL', 'P'),
(122991, 'Lagrange', 41.6416702270508, 0.726784251491731, -85.4166717529297, -1.49080215818386, 218, 19, 'PPL', 'P'),
(127901, 'Lagrange', 45.1666717529297, 0.788307134256142, -68.8450012207031, -1.20157194484078, 218, 26, 'PPL', 'P'),
(150097, 'Lagrange', 42.8016700744629, 0.747030068151704, -78.0138931274414, -1.36159929737283, 218, 40, 'PPL', 'P'),
(156037, 'Lagrange', 41.2372207641602, 0.719725276706367, -82.120002746582, -1.43326442967464, 218, 41, 'PPL', 'P'),
(163495, 'Lagrange', 40.0766716003418, 0.699469872666469, -75.0400009155273, -1.30969508667551, 218, 45, 'PPL', 'P'),
(150098, 'Lagrangeville', 41.6508293151855, 0.726944107736163, -73.7633285522461, -1.28741295046704, 218, 40, 'PPL', 'P'),
(122992, 'Lagro', 40.8380584716797, 0.712758580452774, -85.7302780151367, -1.49627562001424, 218, 19, 'PPL', 'P'),
(9911, 'LaGrue', 34.452220916748, 0.601304689621713, -91.3216705322266, -1.59386382920884, 218, 4, 'PPL', 'P'),
(88355, 'Laguardo', 36.2963905334473, 0.633491521398356, -86.4436111450195, -1.50872563179426, 218, 50, 'PPL', 'P'),
(178497, 'Laguna', 32.8188896179199, 0.572797680681286, -114.484718322754, -1.99813527795034, 218, 5, 'PPL', 'P'),
(182607, 'Laguna', 38.4211082458496, 0.670574841155219, -121.422782897949, -2.11922734850348, 218, 6, 'PPL', 'P'),
(188828, 'Laguna', 35.0366706848145, 0.611505262386989, -107.382217407227, -1.87417325184847, 218, 38, 'PPL', 'P'),
(191713, 'Laguna', 29.4188899993896, 0.513456492771382, -100.005279541016, -1.74542139736805, 218, 51, 'PPL', 'P'),
(16762, 'Laguna Beach', 30.2394409179688, 0.527777807980851, -85.9241714477539, -1.49965969881141, 218, 12, 'PPL', 'P'),
(55758, 'Laguna Beach', 38.1302795410156, 0.665498922696555, -92.6513900756836, -1.61707181337028, 218, 29, 'PPL', 'P'),
(182608, 'Laguna Beach', 33.5422210693359, 0.585422196091725, -117.782218933105, -2.05568752068749, 218, 6, 'PPL', 'P'),
(95492, 'Laguna Escondida Colonia', 26.253999710083, 0.458218736758585, -97.6210021972656, -1.7038079074389, 218, 51, 'PPL', 'P'),
(95493, 'Laguna Escondida Heights Number 2 Colonia', 26.2530002593994, 0.458201293053445, -97.5960006713867, -1.70337154849429, 218, 51, 'PPL', 'P'),
(95494, 'Laguna Heights', 26.079719543457, 0.455176974030038, -97.2536087036133, -1.69739568132427, 218, 51, 'PPL', 'P'),
(182614, 'Laguna Hills', 33.6124992370605, 0.586648781510789, -117.711936950684, -2.0544608686894, 218, 6, 'PPL', 'P'),
(182616, 'Laguna Junction', 32.809440612793, 0.572632764430783, -116.511672973633, -2.03351231039679, 218, 6, 'PPL', 'P'),
(182617, 'Laguna Niguel', 33.5224990844727, 0.585077982520833, -117.706672668457, -2.05436898963179, 218, 6, 'PPL', 'P'),
(95495, 'Laguna Park', 31.8591709136963, 0.55604742939961, -97.3794403076172, -1.6995918571172, 218, 51, 'PPL', 'P'),
(95496, 'Laguna Park Colonia', 26.19700050354, 0.457223912933386, -98.1169967651367, -1.71246464572026, 218, 51, 'PPL', 'P'),
(95497, 'Laguna Seca', 26.4952793121338, 0.462429860232273, -98.1941680908203, -1.71381153944157, 218, 51, 'PPL', 'P'),
(95498, 'Laguna Vista', 26.1005592346191, 0.455540695255915, -97.2900009155273, -1.69803084524425, 218, 51, 'PPL', 'P'),
(182620, 'Laguna Vista Trailer Park', 33.2297210693359, 0.579968042179243, -117.330558776855, -2.04780456386086, 218, 6, 'PPL', 'P'),
(182621, 'Laguna West', 38.4249992370605, 0.670642751763016, -121.472221374512, -2.12009021269666, 218, 6, 'PPL', 'P'),
(182622, 'Laguna Woods', 33.610279083252, 0.586610032516928, -117.72444152832, -2.05467911474073, 218, 6, 'PPL', 'P'),
(188830, 'Lagunas', 35.5291709899902, 0.620101014279383, -105.337501525879, -1.83848622745114, 218, 38, 'PPL', 'P'),
(188831, 'Lagunita', 35.3672218322754, 0.617274468256427, -105.244171142578, -1.83685730497039, 218, 38, 'PPL', 'P'),
(182625, 'Lagunitas', 38.0113906860352, 0.66342392073322, -122.701110839844, -2.14153838000978, 218, 6, 'PPL', 'P'),
(188832, 'Lagunitas', 35.9925003051758, 0.628187636350381, -106.986389160156, -1.8672647456647, 218, 38, 'PPL', 'P'),
(48769, 'Lahaina', 38.7666702270508, 0.676606035496894, -76.7430572509766, -1.33941902707605, 218, 25, 'PPL', 'P'),
(210534, 'Lahaina', 20.8783302307129, 0.364395604844607, -156.682495117188, -2.73462542003486, 218, 15, 'PPL', 'P'),
(210536, 'Lahainaluna', 20.8936100006104, 0.364662287138265, -156.662216186523, -2.73427148592599, 218, 15, 'PPL', 'P'),
(163496, 'Lahaska', 40.3463897705078, 0.704177342788321, -75.0319366455078, -1.3095543386119, 218, 45, 'PPL', 'P'),
(191714, 'Lahey', 33.1227798461914, 0.578101565729261, -102.333892822266, -1.78606336613153, 218, 51, 'PPL', 'P'),
(145549, 'Lahiere', 40.5188903808594, 0.707188046400655, -74.4027786254883, -1.29857345964723, 218, 37, 'PPL', 'P'),
(110005, 'Lahmansville', 39.128059387207, 0.682913466222637, -79.081672668457, -1.38023556604899, 218, 58, 'PPL', 'P'),
(192663, 'Laho', 38.2652816772461, 0.667855154471003, -113.11499786377, -1.97422914610913, 218, 52, 'PPL', 'P'),
(76318, 'Lahoma', 36.3875007629395, 0.635081694885242, -98.0894393920898, -1.71198367882739, 218, 42, 'PPL', 'P'),
(103429, 'Lahore', 38.1986083984375, 0.666691486232692, -77.9697189331055, -1.36082831223725, 218, 53, 'PPL', 'P'),
(210539, 'Lahuipuaa (historical)', 19.9458293914795, 0.348120394922374, -155.870834350586, -2.7204592672484, 218, 15, 'PPL', 'P'),
(163497, 'Laidig', 40.0283317565918, 0.698626183233132, -78.0833282470703, -1.36281116882687, 218, 45, 'PPL', 'P'),
(150099, 'Laidlaw', 42.3974990844727, 0.739975953635329, -78.4086074829102, -1.36848836248065, 218, 40, 'PPL', 'P'),
(207840, 'Laidlow', 46.8616714477539, 0.817890459751124, -124.07250213623, -2.16547367346492, 218, 56, 'PPL', 'P'),
(110006, 'Laing', 38.0363883972168, 0.663860213098802, -81.4283294677734, -1.42119245361137, 218, 58, 'PPL', 'P'),
(131626, 'Laing', 43.5205612182617, 0.759577085574422, -82.9338912963867, -1.44746946461302, 218, 27, 'PPL', 'P'),
(207841, 'Laing', 47.1155586242676, 0.822321626909879, -119.039169311523, -2.07762544332508, 218, 56, 'PPL', 'P'),
(22449, 'Laingkat', 30.7191696166992, 0.536150653290006, -84.4883270263672, -1.47459948611182, 218, 13, 'PPL', 'P'),
(73146, 'Laings', 39.7169418334961, 0.69319140381758, -81.0124969482422, -1.41393480700868, 218, 41, 'PPL', 'P'),
(131627, 'Laingsburg', 42.8902816772461, 0.74857663237574, -84.3513870239258, -1.47220943219153, 218, 27, 'PPL', 'P'),
(116365, 'Lainsville', 42.1297187805176, 0.735302305659322, -90.2044372558594, -1.57436443002338, 218, 16, 'PPL', 'P'),
(112345, 'Lair', 38.3419418334961, 0.669193126602658, -84.3077774047852, -1.47144830075198, 218, 21, 'PPL', 'P'),
(16763, 'Laird', 30.3138904571533, 0.529077197566215, -85.9186096191406, -1.49956262658968, 218, 12, 'PPL', 'P'),
(177706, 'Laird', 38.4474983215332, 0.671035434865748, -100.054168701172, -1.74627467418131, 218, 20, 'PPL', 'P'),
(194280, 'Laird', 40.0825004577637, 0.69957160542011, -102.103057861328, -1.78203453603446, 218, 7, 'PPL', 'P'),
(103430, 'Laird (historical)', 37.0038909912109, 0.645839733845699, -77.5772171020508, -1.35397786296524, 218, 53, 'PPL', 'P'),
(163498, 'Laird Crossing', 40.8702812194824, 0.713320973495971, -79.633056640625, -1.38985903180604, 218, 45, 'PPL', 'P'),
(95499, 'Laird Hill', 32.3530616760254, 0.564667449347438, -94.9052810668945, -1.65640963214795, 218, 51, 'PPL', 'P'),
(193717, 'Laird Landing', 41.8730583190918, 0.730822735547754, -121.72306060791, -2.12446818321264, 218, 6, 'PPL', 'P'),
(207848, 'Lairds', 46.913890838623, 0.818801860055176, -117.086387634277, -2.04354297348451, 218, 56, 'PPL', 'P'),
(182626, 'Lairds Corner', 36.0513916015625, 0.629215483373097, -119.231109619141, -2.08097543366029, 218, 6, 'PPL', 'P'),
(182627, 'Lairds Landing', 38.1594390869141, 0.666007852780869, -122.911392211914, -2.14520848230802, 218, 6, 'PPL', 'P'),
(150100, 'Lairdsville', 43.079719543457, 0.751882946869074, -75.4319381713867, -1.31653568225149, 218, 40, 'PPL', 'P'),
(163499, 'Lairdsville', 41.2291717529297, 0.719584794958865, -76.6133270263672, -1.33715480751726, 218, 45, 'PPL', 'P'),
(182628, 'Lairport', 33.9222183227539, 0.592054399312404, -118.377777099609, -2.06608197158013, 218, 6, 'PPL', 'P'),
(191715, 'Lajitas', 29.2613906860352, 0.510707611183716, -103.776107788086, -1.81123476580663, 218, 51, 'PPL', 'P'),
(36776, 'Lake', 37.0894393920898, 0.647332835110852, -83.8855590820313, -1.46407920085768, 218, 21, 'PPL', 'P'),
(41668, 'Lake', 30.2997207641602, 0.528829889769487, -90.852783203125, -1.58568020149513, 218, 22, 'PPL', 'P'),
(48770, 'Lake', 39.3913917541504, 0.687509483052869, -76.64111328125, -1.33763976915177, 218, 25, 'PPL', 'P'),
(55760, 'Lake', 38.6794395446777, 0.675083572880723, -90.5199966430664, -1.57987198031572, 218, 29, 'PPL', 'P'),
(60528, 'Lake', 32.3430595397949, 0.564492879137983, -89.32861328125, -1.55907841799855, 218, 30, 'PPL', 'P'),
(76316, 'Lake', 36.1399993896484, 0.630761981018106, -96.081672668457, -1.67694153888802, 218, 42, 'PPL', 'P'),
(103490, 'Lake', 37.9741706848145, 0.662774309164322, -76.4700012207031, -1.33465330030535, 218, 53, 'PPL', 'P'),
(110007, 'Lake', 37.9297218322754, 0.661998530338782, -81.9005584716797, -1.42943440455295, 218, 58, 'PPL', 'P'),
(120269, 'Lake', 41.1688919067383, 0.718532713170229, -87.5508270263672, -1.52805019445414, 218, 18, 'PPL', 'P'),
(131630, 'Lake', 43.8519401550293, 0.765360739092774, -85.0052795410156, -1.4836220095689, 218, 27, 'PPL', 'P'),
(163500, 'Lake', 41.3525009155273, 0.721737294909922, -76.0327835083008, -1.32702241167589, 218, 45, 'PPL', 'P'),
(195205, 'Lake', 44.6669387817383, 0.779585148528078, -111.392776489258, -1.94417071267568, 218, 17, 'PPL', 'P'),
(209555, 'Lake', 44.5583305358887, 0.777689577043187, -110.39582824707, -1.92677068337754, 218, 59, 'PPL', 'P'),
(103431, 'Lake Acres', 38.1555595397949, 0.665940141910154, -78.4397201538086, -1.36903138102691, 218, 53, 'PPL', 'P'),
(16764, 'Lake Alfred', 28.0916690826416, 0.490292117872791, -81.7236099243164, -1.42634606979484, 218, 12, 'PPL', 'P'),
(182629, 'Lake Alpine', 38.4786109924316, 0.671578453412015, -120.002777099609, -2.09444357192503, 218, 6, 'PPL', 'P'),
(16765, 'Lake Alto Estates', 29.7822208404541, 0.519797812221997, -82.1311111450195, -1.433458307802, 218, 12, 'PPL', 'P'),
(76317, 'Lake Aluma', 35.5369415283203, 0.620236635757895, -97.4408264160156, -1.70066324682374, 218, 42, 'PPL', 'P'),
(170685, 'Lake Andes', 43.1563911437988, 0.753221118737811, -98.5411071777344, -1.71986676881208, 218, 49, 'PPL', 'P'),
(131631, 'Lake Angeline', 46.478328704834, 0.811199866723545, -87.6758270263672, -1.53023185601914, 218, 27, 'PPL', 'P'),
(131632, 'Lake Angelus', 42.6986083984375, 0.745231302572437, -83.3166732788086, -1.45415027052359, 218, 27, 'PPL', 'P'),
(48771, 'Lake Anita Louise', 39.4155616760254, 0.687931327769538, -77.2916717529297, -1.34899415645932, 218, 25, 'PPL', 'P'),
(131634, 'Lake Ann', 44.7238883972168, 0.780579106825923, -85.8430633544922, -1.49824409553398, 218, 27, 'PPL', 'P'),
(55761, 'Lake Annette', 38.6541709899902, 0.674642553404206, -94.508056640625, -1.6494767580402, 218, 29, 'PPL', 'P'),
(16766, 'Lake Apopka', 28.624439239502, 0.499590711266371, -81.5436096191406, -1.42320447181492, 218, 12, 'PPL', 'P'),
(60529, 'Lake Appaloosa Estates', 34.3125, 0.598866099590554, -88.591667175293, -1.54621628203985, 218, 30, 'PPL', 'P'),
(48772, 'Lake Arbor', 38.9077796936035, 0.679068860293972, -76.8300018310547, -1.34093649626518, 218, 25, 'PPL', 'P'),
(163501, 'Lake Ariel', 41.4538917541504, 0.723506898875252, -75.383056640625, -1.31568253859628, 218, 45, 'PPL', 'P'),
(127902, 'Lake Arrowhead', 43.6636085510254, 0.762073732517344, -70.7352828979492, -1.23456358389885, 218, 26, 'PPL', 'P'),
(145550, 'Lake Arrowhead', 40.8944396972656, 0.713742618475558, -74.470832824707, -1.29976122949341, 218, 37, 'PPL', 'P'),
(182630, 'Lake Arrowhead', 34.2483291625977, 0.597746107194121, -117.188331604004, -2.0453222314088, 218, 6, 'PPL', 'P'),
(127903, 'Lake Arrowhead Estates', 43.6527786254883, 0.761884714658975, -70.7194366455078, -1.23428701461965, 218, 26, 'PPL', 'P'),
(41669, 'Lake Arthur', 30.0805606842041, 0.52500482478532, -92.67138671875, -1.61742082063113, 218, 22, 'PPL', 'P'),
(188833, 'Lake Arthur', 32.9980583190918, 0.575924764433257, -104.366111755371, -1.82153227763558, 218, 38, 'PPL', 'P'),
(16768, 'Lake Ashby Shores', 28.9391708374023, 0.505083813909796, -81.0944366455078, -1.41536492451406, 218, 12, 'PPL', 'P'),
(95500, 'Lake Barbara', 29.0249996185303, 0.506581808733451, -95.3891677856445, -1.66485504859681, 218, 51, 'PPL', 'P'),
(103432, 'Lake Barcroft', 38.8477783203125, 0.678021638774326, -77.1561126708984, -1.34662820414689, 218, 53, 'PPL', 'P'),
(120270, 'Lake Barrington', 42.2125015258789, 0.736747137129717, -88.1524963378906, -1.53855130494844, 218, 18, 'PPL', 'P'),
(207842, 'Lake Bay', 47.2519416809082, 0.824701960292192, -122.73722076416, -2.14216861708175, 218, 56, 'PPL', 'P'),
(16767, 'Lake Belvedere Estates', 26.6888904571533, 0.46580901218142, -80.1336135864258, -1.39859539860399, 218, 12, 'PPL', 'P'),
(136301, 'Lake Benton', 44.2611083984375, 0.772502072134849, -96.2872161865234, -1.68052895003441, 218, 28, 'PPL', 'P'),
(174849, 'Lake Beulah', 42.8213882446289, 0.74737421514357, -88.3208312988281, -1.54148930426301, 218, 57, 'PPL', 'P'),
(178498, 'Lake Biltmore Estates', 33.586669921875, 0.586197974917265, -112.123611450195, -1.95692618903272, 218, 5, 'PPL', 'P'),
(120271, 'Lake Bluff', 42.2788887023926, 0.737905811940983, -87.8341674804688, -1.53299541828231, 218, 18, 'PPL', 'P'),
(131635, 'Lake Bluff', 45.8125, 0.799578963569902, -87.0572204589844, -1.51943513464385, 218, 27, 'PPL', 'P'),
(150101, 'Lake Bluff', 43.2724990844727, 0.75524758459028, -76.9416732788086, -1.34288553070895, 218, 40, 'PPL', 'P'),
(150102, 'Lake Bonaparte', 44.1380615234375, 0.770354499031809, -75.3797225952148, -1.31562434852646, 218, 40, 'PPL', 'P'),
(207843, 'Lake Bosworth', 48.045280456543, 0.838548334010759, -121.967216491699, -2.12872950727288, 218, 56, 'PPL', 'P'),
(156039, 'Lake Breeze', 41.4894409179688, 0.724127348830213, -82.1133270263672, -1.43314791637695, 218, 41, 'PPL', 'P'),
(95501, 'Lake Bridgeport', 33.2069396972656, 0.579570432228494, -97.8283309936523, -1.70742647757005, 218, 51, 'PPL', 'P'),
(136304, 'Lake Bronson', 48.7355613708496, 0.850596008729087, -96.6624984741211, -1.68707886157741, 218, 28, 'PPL', 'P'),
(95502, 'Lake Brownwood', 31.8355598449707, 0.555635338510434, -99.0074996948242, -1.72800685384196, 218, 51, 'PPL', 'P'),
(122994, 'Lake Bruce', 41.0702781677246, 0.716811578736738, -86.4644393920898, -1.50908915328305, 218, 19, 'PPL', 'P'),
(41670, 'Lake Bruin', 31.9877796173096, 0.558292074724384, -91.2561111450195, -1.59271960204648, 218, 22, 'PPL', 'P'),
(16769, 'Lake Buena Vista', 28.3933296203613, 0.495557087479337, -81.5388870239258, -1.42312204697919, 218, 12, 'PPL', 'P'),
(16770, 'Lake Butler', 30.0224990844727, 0.523991458701031, -82.3397216796875, -1.4370992484863, 218, 12, 'PPL', 'P'),
(16771, 'Lake Butter', 28.5013904571533, 0.497443104873817, -81.5411071777344, -1.42316079597305, 218, 12, 'PPL', 'P'),
(156040, 'Lake Cable', 40.8600006103516, 0.713141543017527, -81.4486083984375, -1.42154638772024, 218, 41, 'PPL', 'P'),
(16772, 'Lake Cain Hills', 28.4836101531982, 0.497132780027796, -81.4775009155273, -1.42205065727265, 218, 12, 'PPL', 'P'),
(182632, 'Lake Camanche Ranches', 38.1944389343262, 0.666618715355906, -120.934722900391, -2.1107090945988, 218, 6, 'PPL', 'P'),
(116366, 'Lake Canyada Mobile Home Park', 41.5125007629395, 0.724529819049952, -90.6833267211914, -1.58272262794654, 218, 16, 'PPL', 'P'),
(22451, 'Lake Capri', 33.7152786254883, 0.588442620242039, -84.0522232055664, -1.46698803855832, 218, 13, 'PPL', 'P'),
(163503, 'Lake Carey', 41.5958290100098, 0.725984171321244, -75.9341735839844, -1.32530134382143, 218, 45, 'PPL', 'P'),
(22452, 'Lake Carlton', 33.850830078125, 0.590808439396411, -83.9397201538086, -1.4650244898866, 218, 13, 'PPL', 'P'),
(150104, 'Lake Carmel', 41.4613914489746, 0.72363779324283, -73.67138671875, -1.28580826275221, 218, 40, 'PPL', 'P'),
(9929, 'Lake Catherine', 34.464168548584, 0.601513215135066, -92.9722213745117, -1.62267137587828, 218, 4, 'PPL', 'P'),
(41672, 'Lake Catherine', 30.1141700744629, 0.525591419304923, -89.7091674804688, -1.56572034175721, 218, 22, 'PPL', 'P'),
(120272, 'Lake Catherine', 42.4791717529297, 0.741401410608794, -88.1333312988281, -1.53821681191552, 218, 18, 'PPL', 'P'),
(207844, 'Lake Cavanaugh', 48.3263893127441, 0.843454609107985, -122.019721984863, -2.12964590100398, 218, 56, 'PPL', 'P'),
(60530, 'Lake Center', 34.6888885498047, 0.605435319051453, -89.3583297729492, -1.55959706862084, 218, 30, 'PPL', 'P'),
(41673, 'Lake Charles', 30.226390838623, 0.527550041128622, -93.2172164916992, -1.62694734732451, 218, 22, 'PPL', 'P'),
(60531, 'Lake Charles Landing', 34.1427803039551, 0.595903932089086, -90.8724975585938, -1.58602428190797, 218, 30, 'PPL', 'P'),
(120273, 'Lake Charlotte', 41.915828704834, 0.731569219601304, -88.3680572509766, -1.54231355262039, 218, 18, 'PPL', 'P'),
(16773, 'Lake Charm', 28.6733303070068, 0.500444021369146, -81.1983337402344, -1.41717827090029, 218, 12, 'PPL', 'P'),
(22453, 'Lake Chase', 33.4886093139648, 0.584486494442726, -84.3294372558594, -1.47182633646872, 218, 13, 'PPL', 'P'),
(66170, 'Lake Christopher Apartments', 35.3044395446777, 0.616178710625914, -81.5361099243164, -1.42307357744735, 218, 33, 'PPL', 'P'),
(174851, 'Lake Church', 43.4997215270996, 0.759213364348544, -87.820556640625, -1.53275786431308, 218, 57, 'PPL', 'P'),
(122995, 'Lake Cicott', 40.7641716003418, 0.71146901127393, -86.524169921875, -1.51013164769176, 218, 19, 'PPL', 'P'),
(22454, 'Lake Cindy Estates', 33.413890838623, 0.583182411035941, -84.2977828979492, -1.47127386370058, 218, 13, 'PPL', 'P'),
(95503, 'Lake Citrus Estates Colonia', 26.3840007781982, 0.460487683428305, -98.1480026245117, -1.71300580005377, 218, 51, 'PPL', 'P'),
(9930, 'Lake City', 35.8161087036133, 0.62510902213025, -90.4341735839844, -1.57837408536061, 218, 4, 'PPL', 'P'),
(16774, 'Lake City', 30.1894397735596, 0.526905123381146, -82.6394424438477, -1.44233036265749, 218, 12, 'PPL', 'P'),
(22455, 'Lake City', 33.6063919067383, 0.586542188488158, -84.3352813720703, -1.47192833553847, 218, 13, 'PPL', 'P'),
(27653, 'Lake City', 39.7544403076172, 0.693845875655467, -88.7200012207031, -1.54845613367466, 218, 18, 'PPL', 'P'),
(32963, 'Lake City', 37.353328704834, 0.651938572479062, -98.820556640625, -1.72474408203245, 218, 20, 'PPL', 'P'),
(36777, 'Lake City', 37.0275001525879, 0.646251791445361, -88.2483291625977, -1.54022390327106, 218, 21, 'PPL', 'P'),
(55762, 'Lake City', 39.110279083252, 0.682603141376616, -94.254997253418, -1.64506003853036, 218, 29, 'PPL', 'P'),
(60533, 'Lake City', 34.6419410705566, 0.604615930963063, -88.5497207641602, -1.54548417905618, 218, 30, 'PPL', 'P'),
(81932, 'Lake City', 33.8708305358887, 0.591157513236293, -79.7555618286133, -1.39199715068721, 218, 48, 'PPL', 'P'),
(88351, 'Lake City', 36.2177810668945, 0.632119527383774, -84.1547164916992, -1.46877688386252, 218, 50, 'PPL', 'P'),
(95504, 'Lake City', 28.0791702270508, 0.49007397169, -97.8855590820313, -1.70842529613688, 218, 51, 'PPL', 'P'),
(116367, 'Lake City', 42.2675018310547, 0.737707073544636, -94.7336120605469, -1.65341344276355, 218, 16, 'PPL', 'P'),
(127905, 'Lake City', 44.2449989318848, 0.772220908902764, -69.0963897705078, -1.20595950273669, 218, 26, 'PPL', 'P'),
(131637, 'Lake City', 44.3352813720703, 0.773796634740736, -85.2149963378906, -1.4872822581711, 218, 27, 'PPL', 'P'),
(136306, 'Lake City', 44.4494400024414, 0.775789078710279, -92.2666702270508, -1.61035718531386, 218, 28, 'PPL', 'P'),
(163505, 'Lake City', 42.0141716003418, 0.73328562692386, -80.3455581665039, -1.40229452935811, 218, 45, 'PPL', 'P'),
(170689, 'Lake City', 45.7252807617188, 0.798056700690813, -97.4141693115234, -1.7001979925813, 218, 49, 'PPL', 'P'),
(186950, 'Lake City', 38.0299987792969, 0.663748693228155, -107.314720153809, -1.87299520254028, 218, 7, 'PPL', 'P'),
(193718, 'Lake City', 41.6427803039551, 0.726803625988661, -120.215827941895, -2.09816201059706, 218, 6, 'PPL', 'P'),
(207847, 'Lake City', 47.1488914489746, 0.822903394450007, -122.550003051758, -2.13890105158227, 218, 56, 'PPL', 'P'),
(16775, 'Lake Clarke Shores', 26.6450004577637, 0.465042987183372, -80.0761108398438, -1.3975917863472, 218, 12, 'PPL', 'P'),
(150103, 'Lake Clear', 44.3675003051758, 0.774358961204906, -74.2330627441406, -1.29561135872479, 218, 40, 'PPL', 'P'),
(145551, 'Lake Club', 40.146110534668, 0.700681810699537, -74.2486114501953, -1.29588273483987, 218, 37, 'PPL', 'P'),
(150105, 'Lake Colby', 44.3527793884277, 0.774102032738741, -74.1438903808594, -1.29405500738375, 218, 40, 'PPL', 'P'),
(88353, 'Lake Colonial Estates', 35.8830604553223, 0.626277550637549, -86.7033309936523, -1.51325859828568, 218, 50, 'PPL', 'P'),
(22456, 'Lake Colony', 33.9777793884277, 0.593024122844329, -84.4049987792969, -1.47314513384053, 218, 13, 'PPL', 'P'),
(16776, 'Lake Como', 29.4836101531982, 0.514586072547739, -81.5730590820313, -1.42371846190531, 218, 12, 'PPL', 'P'),
(60534, 'Lake Como', 31.9622192382813, 0.557845961952282, -89.2125015258789, -1.55705188556705, 218, 30, 'PPL', 'P'),
(145552, 'Lake Como', 40.1597213745117, 0.700919364668772, -74.0286102294922, -1.29204298918019, 218, 37, 'PPL', 'P'),
(163507, 'Lake Como', 41.8497200012207, 0.730415405059027, -75.3372192382813, -1.31488252500482, 218, 45, 'PPL', 'P'),
(174852, 'Lake Como', 42.5902786254883, 0.743340591356535, -88.5019378662109, -1.54465021016083, 218, 57, 'PPL', 'P'),
(60535, 'Lake Cormorant', 34.9041709899902, 0.609192706454418, -90.2144393920898, -1.57453900023284, 218, 30, 'PPL', 'P'),
(120274, 'Lake Corner', 42.2386093139648, 0.73720280399223, -88.1116714477539, -1.53783877619878, 218, 18, 'PPL', 'P'),
(41674, 'Lake Cove', 30.9174995422363, 0.539612163495864, -92.4513931274414, -1.61358120812951, 218, 22, 'PPL', 'P'),
(3597, 'Lake Coves', 34.8458290100098, 0.608174446811627, -87.5691680908203, -1.52837030641717, 218, 2, 'PPL', 'P'),
(22457, 'Lake Creek', 34.0702781677246, 0.594638531097135, -85.2172164916992, -1.48732100716496, 218, 13, 'PPL', 'P'),
(27654, 'Lake Creek', 37.8761100769043, 0.661062828689783, -89.0269393920898, -1.55381321536541, 218, 18, 'PPL', 'P'),
(55763, 'Lake Creek', 38.5113906860352, 0.672150566993191, -93.1333312988281, -1.62548327451524, 218, 29, 'PPL', 'P'),
(76319, 'Lake Creek', 35.0294418334961, 0.611379095130346, -99.4130630493164, -1.73508526970329, 218, 42, 'PPL', 'P'),
(95506, 'Lake Creek', 31.5091705322266, 0.549938770359728, -96.9502792358398, -1.6921015833933, 218, 51, 'PPL', 'P'),
(27655, 'Lake Crest', 37.6061096191406, 0.656350431719915, -88.9175033569336, -1.5519031962316, 218, 18, 'PPL', 'P'),
(88366, 'Lake Crest', 35.1597213745117, 0.613652902069056, -85.1052780151367, -1.48536731218928, 218, 50, 'PPL', 'P'),
(95507, 'Lake Crest Estates', 32.8613891601563, 0.573539437623901, -97.413330078125, -1.70018334519531, 218, 51, 'PPL', 'P'),
(182636, 'Lake Crest Estates', 33.7205581665039, 0.588534765615755, -116.916938781738, -2.04058553309398, 218, 6, 'PPL', 'P'),
(136309, 'Lake Crystal', 44.1058311462402, 0.769791972830557, -94.2186126708984, -1.64442500776843, 218, 28, 'PPL', 'P'),
(103433, 'Lake Crystal Farms', 37.4741706848145, 0.65404766290435, -77.5863876342773, -1.35413791894675, 218, 53, 'PPL', 'P'),
(22458, 'Lake Cumberland West', 33.5805587768555, 0.586091315315608, -82.1972198486328, -1.43461212234428, 218, 13, 'PPL', 'P'),
(122997, 'Lake Dalecarlia', 41.3308296203613, 0.721359059456103, -87.3947219848633, -1.52532564750094, 218, 19, 'PPL', 'P'),
(95508, 'Lake Dallas', 33.1191711425781, 0.578038581969481, -97.0252838134766, -1.69341066022713, 218, 51, 'PPL', 'P'),
(66172, 'Lake Daniel', 36.0825004577637, 0.629758435340337, -79.8119430541992, -1.39298118871, 218, 33, 'PPL', 'P'),
(73147, 'Lake Darby', 39.957218170166, 0.697385017007101, -83.228889465332, -1.45261815394847, 218, 41, 'PPL', 'P'),
(182635, 'Lake Davis', 39.8727798461914, 0.695911290238878, -120.477783203125, -2.10273399239845, 218, 6, 'PPL', 'P'),
(150106, 'Lake Delaware', 42.247501373291, 0.737357999704754, -74.8305587768555, -1.30603963176327, 218, 40, 'PPL', 'P'),
(150107, 'Lake Delta', 43.2930603027344, 0.755606445547168, -75.4725036621094, -1.31724368362729, 218, 40, 'PPL', 'P'),
(174853, 'Lake Delton', 43.6011085510254, 0.760982901734847, -89.7936096191406, -1.56719413510446, 218, 57, 'PPL', 'P'),
(163508, 'Lake Denise', 40.2361106872559, 0.702252609689493, -79.6999969482422, -1.39102736057626, 218, 45, 'PPL', 'P'),
(150108, 'Lake Desolation', 43.1316719055176, 0.752789686641218, -73.9697189331055, -1.29101514215748, 218, 40, 'PPL', 'P'),
(9932, 'Lake Dick', 34.2519416809082, 0.597809157532929, -91.8386077880859, -1.60288608634981, 218, 4, 'PPL', 'P'),
(88357, 'Lake Drive', 36.3630599975586, 0.634655123057639, -89.4336090087891, -1.56091093914463, 218, 50, 'PPL', 'P'),
(3598, 'Lake Drive Estates', 33.4488906860352, 0.583793273610978, -86.807502746582, -1.51507673836188, 218, 2, 'PPL', 'P'),
(95518, 'Lake Dunlap', 29.6755599975586, 0.517936229330518, -98.0719375610352, -1.71167821425036, 218, 51, 'PPL', 'P'),
(172181, 'Lake Dunmore', 43.9088897705078, 0.766354697390619, -73.0875015258789, -1.27561754368297, 218, 55, 'PPL', 'P'),
(88358, 'Lake Dweller', 35.1733283996582, 0.613890389459264, -85.1458282470703, -1.48607504724897, 218, 50, 'PPL', 'P'),
(122998, 'Lake Eliza', 41.4288902282715, 0.723070539930643, -87.1719436645508, -1.52143743230942, 218, 19, 'PPL', 'P'),
(81933, 'Lake Elizabeth Estates', 34.1083297729492, 0.595302656893974, -80.9830627441406, -1.41342108323441, 218, 48, 'PPL', 'P'),
(66173, 'Lake Ellen', 35.9463882446289, 0.627382829068959, -79.0527801513672, -1.37973129649658, 218, 33, 'PPL', 'P'),
(66174, 'Lake Ellsworth', 35.5902786254883, 0.621167543716932, -77.4166717529297, -1.35117581802431, 218, 33, 'PPL', 'P'),
(76320, 'Lake Ellsworth Addition', 34.8369407653809, 0.608019317678129, -98.3213882446289, -1.71603195000042, 218, 42, 'PPL', 'P'),
(136313, 'Lake Elmo', 44.9958305358887, 0.785325392520662, -92.8791732788086, -1.62104738024555, 218, 28, 'PPL', 'P'),
(172182, 'Lake Elmore', 44.5424995422363, 0.777413274080091, -72.5258331298828, -1.26581458086844, 218, 55, 'PPL', 'P'),
(182637, 'Lake Elsinore', 33.6680603027344, 0.587618505042714, -117.326393127441, -2.0477318595631, 218, 6, 'PPL', 'P'),
(136315, 'Lake Elysian', 44.148609161377, 0.77053859004216, -93.7133331298828, -1.63560621613474, 218, 28, 'PPL', 'P'),
(174855, 'Lake Emily (historical)', 44.4777793884277, 0.776283694303734, -89.334716796875, -1.55918494444215, 218, 57, 'PPL', 'P'),
(41675, 'Lake End', 31.9213905334473, 0.557133366623604, -93.3047180175781, -1.62847453705161, 218, 22, 'PPL', 'P'),
(150109, 'Lake Erie Beach', 42.6241683959961, 0.743932079434642, -79.0672225952148, -1.37998336469375, 218, 40, 'PPL', 'P'),
(22459, 'Lake Estates', 33.7563896179199, 0.589160142418733, -84.6447219848633, -1.47732909307109, 218, 13, 'PPL', 'P'),
(27656, 'Lake Estates', 37.6138916015625, 0.656486252935509, -88.9300003051758, -1.55212130912488, 218, 18, 'PPL', 'P'),
(136317, 'Lake Eunice', 46.7461090087891, 0.815873514699552, -95.9688873291016, -1.67497306336829, 218, 28, 'PPL', 'P'),
(48773, 'Lake Fairplay Estates', 39.5369415283203, 0.690049805837668, -77.7713928222656, -1.35736686861042, 218, 25, 'PPL', 'P'),
(9933, 'Lake Farm', 34.2244415283203, 0.59732918932547, -91.70361328125, -1.60052998773341, 218, 4, 'PPL', 'P'),
(22460, 'Lake Farm', 34.3438911437988, 0.599413978405811, -83.8763885498047, -1.46391914487616, 218, 13, 'PPL', 'P'),
(88359, 'Lake Farm Estates', 35.9791717529297, 0.627955009229163, -86.4800033569336, -1.50936079571424, 218, 50, 'PPL', 'P'),
(131639, 'Lake Fenton', 42.8461112976074, 0.74780571381919, -83.7077789306641, -1.46097635187163, 218, 27, 'PPL', 'P'),
(16778, 'Lake Fern', 28.1494407653809, 0.491300423951009, -82.579719543457, -1.44128800140683, 218, 12, 'PPL', 'P'),
(174856, 'Lake Five', 43.1925010681152, 0.753851355809778, -88.2708282470703, -1.54061658637379, 218, 57, 'PPL', 'P'),
(110008, 'Lake Floyd', 39.2861099243164, 0.685671968479742, -80.5074996948242, -1.40512094222301, 218, 58, 'PPL', 'P'),
(48774, 'Lake Ford', 39.526668548584, 0.689870508517279, -79.4802780151367, -1.3871925417646, 218, 25, 'PPL', 'P'),
(55765, 'Lake Ford (historical)', 38.4088897705078, 0.670361588530931, -91.7391662597656, -1.6011505042674, 218, 29, 'PPL', 'P'),
(16780, 'Lake Forest', 30.3977794647217, 0.530541336954513, -81.6738891601563, -1.42547827875363, 218, 12, 'PPL', 'P'),
(22464, 'Lake Forest', 33.878059387207, 0.591283680492935, -83.4394378662109, -1.45629291677861, 218, 13, 'PPL', 'P'),
(48775, 'Lake Forest', 39.0774993896484, 0.68203102779544, -76.5955581665039, -1.33684468240832, 218, 25, 'PPL', 'P'),
(81935, 'Lake Forest', 34.9674987792969, 0.610297984885828, -81.8611068725586, -1.42874584425311, 218, 48, 'PPL', 'P'),
(88360, 'Lake Forest', 35.9266700744629, 0.627038682077094, -83.8677825927734, -1.46376894259068, 218, 50, 'PPL', 'P'),
(95509, 'Lake Forest', 32.9508285522461, 0.575100449496851, -97.5186080932617, -1.70202079318941, 218, 51, 'PPL', 'P'),
(103434, 'Lake Forest', 36.771671295166, 0.641786735561735, -76.5299987792969, -1.33570045524597, 218, 53, 'PPL', 'P'),
(120276, 'Lake Forest', 42.2586097717285, 0.737551877832112, -87.8405609130859, -1.53310700473199, 218, 18, 'PPL', 'P'),
(182639, 'Lake Forest', 39.184440612793, 0.683897504245422, -120.113609313965, -2.09637795898281, 218, 6, 'PPL', 'P'),
(22465, 'Lake Forest Cove', 33.389720916748, 0.582760566319273, -84.5697174072266, -1.47602001623727, 218, 13, 'PPL', 'P'),
(81936, 'Lake Forest Estates', 33.5547218322754, 0.58564037556403, -81.9875030517578, -1.43095187374207, 218, 48, 'PPL', 'P'),
(88361, 'Lake Forest Estates', 36.2561111450195, 0.632788513449602, -83.4180603027344, -1.45591980790989, 218, 50, 'PPL', 'P'),
(22466, 'Lake Forest Glen', 33.3858299255371, 0.582692655711476, -84.561393737793, -1.4758747407998, 218, 13, 'PPL', 'P'),
(16782, 'Lake Forest Hills', 30.3911094665527, 0.530424923525363, -81.6902770996094, -1.42576430225471, 218, 12, 'PPL', 'P'),
(22467, 'Lake Forest Hills', 33.0424995422363, 0.576700410100743, -85.0980606079102, -1.48524134466972, 218, 13, 'PPL', 'P'),
(16783, 'Lake Forest Manor', 30.3930606842041, 0.530458978697802, -81.6661071777344, -1.42534245753804, 218, 12, 'PPL', 'P'),
(14066, 'Lake Forest Mobile Home Est', 38.9847183227539, 0.680411692694617, -75.5663909912109, -1.31888232664601, 218, 10, 'PPL', 'P'),
(125189, 'Lake Forest Park', 42.3083305358887, 0.738419668873314, -71.3541717529297, -1.24536523212216, 218, 23, 'PPL', 'P'),
(207849, 'Lake Forest Park', 47.7569389343262, 0.833515825077864, -122.279716491699, -2.13418366118536, 218, 56, 'PPL', 'P'),
(27657, 'Lake Fork', 39.9705581665039, 0.697617843865401, -89.3499984741211, -1.55945166002532, 218, 18, 'PPL', 'P'),
(156042, 'Lake Fork', 40.7491683959961, 0.711207155959748, -82.1416702270508, -1.43364259854943, 218, 41, 'PPL', 'P'),
(195206, 'Lake Fork', 44.8327789306641, 0.78247960515883, -116.083892822266, -2.02604613828075, 218, 17, 'PPL', 'P'),
(9934, 'Lake Frances', 36.1263885498047, 0.630524427048871, -94.5461120605469, -1.65014095041606, 218, 4, 'PPL', 'P'),
(136319, 'Lake Fremont', 45.4433288574219, 0.793135711628565, -93.5897216796875, -1.63344878933566, 218, 28, 'PPL', 'P'),
(103435, 'Lake Front Royal', 38.8691711425781, 0.678395013959155, -78.149169921875, -1.36396032283724, 218, 53, 'PPL', 'P'),
(16784, 'Lake Garfield', 27.8902797698975, 0.486777211287077, -81.7613906860352, -1.42700546848074, 218, 12, 'PPL', 'P'),
(103436, 'Lake Gaston Estates', 36.5577812194824, 0.638053649503716, -77.8480606079102, -1.35870497390013, 218, 53, 'PPL', 'P'),
(16785, 'Lake Geneva', 29.7719402313232, 0.519618381743553, -82.0102767944336, -1.43134935053477, 218, 12, 'PPL', 'P'),
(174858, 'Lake Geneva', 42.5916709899902, 0.743364892701482, -88.4333267211914, -1.54345271977667, 218, 57, 'PPL', 'P'),
(131640, 'Lake George', 43.9633293151855, 0.767304846688532, -84.9469375610352, -1.48260374992611, 218, 27, 'PPL', 'P'),
(136321, 'Lake George', 47.2005615234375, 0.823805207374135, -94.9933319091797, -1.65794640925498, 218, 28, 'PPL', 'P'),
(150110, 'Lake George', 43.4261093139648, 0.757928588859663, -73.7127838134766, -1.28653077835595, 218, 40, 'PPL', 'P'),
(186952, 'Lake George', 38.9797210693359, 0.680324474168917, -105.356941223145, -1.83882551417401, 218, 7, 'PPL', 'P'),
(66178, 'Lake Glenwood', 35.5750007629395, 0.620900894712788, -77.3097229003906, -1.34930920841628, 218, 33, 'PPL', 'P'),
(131641, 'Lake Gogebic', 46.5766716003418, 0.812916274046101, -89.6111068725586, -1.56400886128267, 218, 27, 'PPL', 'P'),
(207850, 'Lake Goodwin', 48.1391716003418, 0.840187043608512, -122.278327941895, -2.13415942641944, 218, 56, 'PPL', 'P'),
(122999, 'Lake Grange', 41.6902809143066, 0.727632668036003, -85.769172668457, -1.49695445977611, 218, 19, 'PPL', 'P'),
(16786, 'Lake Grove', 30.1200008392334, 0.525693185348078, -85.1769409179688, -1.48661806579524, 218, 12, 'PPL', 'P'),
(150112, 'Lake Grove', 40.8527793884277, 0.713015508918939, -73.1155624389648, -1.27610729900743, 218, 40, 'PPL', 'P'),
(201094, 'Lake Grove (historical)', 45.4047203063965, 0.792461865293747, -122.715278625488, -2.14178565451699, 218, 43, 'PPL', 'P'),
(174860, 'Lake Hallie', 44.8758316040039, 0.783231016060396, -91.440559387207, -1.59593883117217, 218, 57, 'PPL', 'P'),
(9935, 'Lake Hamilton', 34.4244384765625, 0.600819794566236, -93.0950012207031, -1.62481428844941, 218, 4, 'PPL', 'P'),
(16787, 'Lake Hamilton', 28.0441703796387, 0.489463109114963, -81.628059387207, -1.42467839832023, 218, 12, 'PPL', 'P'),
(16788, 'Lake Harbor', 26.6927795410156, 0.465876889499703, -80.8147201538086, -1.41048295076178, 218, 12, 'PPL', 'P'),
(88363, 'Lake Harbor Estates', 35.1308288574219, 0.613148632516649, -85.1477813720703, -1.48610913571092, 218, 50, 'PPL', 'P'),
(163509, 'Lake Harmony', 41.0605583190918, 0.7166419353753, -75.5913925170898, -1.31931868559062, 218, 45, 'PPL', 'P'),
(16789, 'Lake Hart', 28.3924999237061, 0.495542606540909, -81.2408294677734, -1.41791996126388, 218, 12, 'PPL', 'P'),
(30280, 'Lake Hart', 39.5675010681152, 0.690583170424984, -86.4319381713867, -1.50852189997087, 218, 19, 'PPL', 'P'),
(178499, 'Lake Havasu City', 34.4838905334473, 0.601857428705959, -114.321670532227, -1.99528955716753, 218, 5, 'PPL', 'P'),
(22468, 'Lake Haven', 34.3899993896484, 0.600218719108206, -83.8163909912109, -1.46287198993554, 218, 13, 'PPL', 'P'),
(103437, 'Lake Haven', 37.0591697692871, 0.646804530529607, -79.5777816772461, -1.38889430170116, 218, 53, 'PPL', 'P'),
(48776, 'Lake Haven Mobile Home Park', 38.3499984741211, 0.669333741508214, -75.1788864135742, -1.3121190958997, 218, 25, 'PPL', 'P'),
(41679, 'Lake Hayes', 32.4313888549805, 0.566034516514003, -93.9077835083008, -1.63900001546988, 218, 22, 'PPL', 'P'),
(207853, 'Lake Heights', 47.5591697692871, 0.830064101989012, -122.182777404785, -2.13249175494483, 218, 56, 'PPL', 'P'),
(16790, 'Lake Helen', 28.9805603027344, 0.50580619635548, -81.2336120605469, -1.41779399374432, 218, 12, 'PPL', 'P'),
(136327, 'Lake Henry', 45.4605598449707, 0.793436449094662, -94.7961120605469, -1.65450427354605, 218, 28, 'PPL', 'P'),
(78577, 'Lake Heritage', 39.809440612793, 0.694805812070386, -77.1841735839844, -1.34711795947136, 218, 45, 'PPL', 'P'),
(145553, 'Lake Hiawatha', 40.8824996948242, 0.71353422612026, -74.3819427490234, -1.29820980500038, 218, 37, 'PPL', 'P'),
(3602, 'Lake Highlands', 33.5727806091309, 0.585955560679041, -86.730827331543, -1.51373849991411, 218, 2, 'PPL', 'P'),
(150113, 'Lake Hill', 42.0672187805176, 0.734211474876826, -74.1875, -1.29481613882329, 218, 40, 'PPL', 'P'),
(48777, 'Lake Hills', 39.378059387207, 0.687276789352623, -76.9069366455078, -1.34227926208679, 218, 25, 'PPL', 'P'),
(88365, 'Lake Hills', 35.0811080932617, 0.612280841475447, -85.1927795410156, -1.48689450191639, 218, 50, 'PPL', 'P'),
(95510, 'Lake Hills', 29.5841693878174, 0.516341162285129, -98.9486083984375, -1.72697900681925, 218, 51, 'PPL', 'P'),
(103438, 'Lake Hills', 38.0986099243164, 0.664946183612309, -78.4794387817383, -1.36972460185866, 218, 53, 'PPL', 'P'),
(123000, 'Lake Hills', 41.464168548584, 0.723686262774669, -87.4461135864258, -1.52622260015608, 218, 19, 'PPL', 'P'),
(207851, 'Lake Hills', 47.6136093139648, 0.831014251286925, -122.120277404785, -2.13140092416234, 218, 56, 'PPL', 'P'),
(182640, 'Lake Hills Estates', 38.7319412231445, 0.675999900032792, -121.084442138672, -2.11332218826039, 218, 6, 'PPL', 'P'),
(76321, 'Lake Hiwassee', 35.651668548584, 0.622239000002499, -97.3058319091797, -1.69830714820735, 218, 42, 'PPL', 'P'),
(145554, 'Lake Hopatcong', 40.9483299255371, 0.714683180393547, -74.6175003051758, -1.30232105993319, 218, 37, 'PPL', 'P'),
(3605, 'Lake Howard', 34.5069389343262, 0.602259699188615, -85.6116714477539, -1.49420554489893, 218, 2, 'PPL', 'P'),
(136330, 'Lake Hubert', 46.5022201538086, 0.811616851171224, -94.2572174072266, -1.64509878752422, 218, 28, 'PPL', 'P'),
(182641, 'Lake Hughes', 34.6769409179688, 0.6052267935381, -118.444442749023, -2.06724550666038, 218, 6, 'PPL', 'P'),
(150114, 'Lake Huntington', 41.6841697692871, 0.727526008434345, -74.9930572509766, -1.30887576516615, 218, 40, 'PPL', 'P'),
(131642, 'Lake Huron Beach', 44.2330589294434, 0.772012516547465, -83.5475006103516, -1.45817896746261, 218, 27, 'PPL', 'P'),
(163514, 'Lake in the Clouds', 41.2533302307129, 0.720006439938452, -75.2630615234375, -1.31358822871504, 218, 45, 'PPL', 'P'),
(120289, 'Lake in the Hills', 42.1816711425781, 0.736209045431467, -88.3302764892578, -1.54165415393449, 218, 18, 'PPL', 'P'),
(66199, 'Lake in the Pine', 35.3627815246582, 0.617196970268706, -80.0363922119141, -1.39689856551545, 218, 33, 'PPL', 'P'),
(182642, 'Lake Isabella', 35.6180610656738, 0.621652438772409, -118.472221374512, -2.06773033513683, 218, 6, 'PPL', 'P'),
(22469, 'Lake Island Estates', 33.9097213745117, 0.591836286419127, -84.3958282470703, -1.47298507785901, 218, 13, 'PPL', 'P'),
(136332, 'Lake Itasca', 47.2538909912109, 0.824735982175118, -95.2122192382813, -1.6617667138387, 218, 28, 'PPL', 'P'),
(16791, 'Lake Jackson', 30.5322208404541, 0.532887781611954, -84.3616714477539, -1.472388929249, 218, 12, 'PPL', 'P'),
(95511, 'Lake Jackson', 29.0336093902588, 0.506732077597959, -95.4341735839844, -1.66564054796032, 218, 51, 'PPL', 'P'),
(103439, 'Lake Jackson', 38.7024993896484, 0.675486043100461, -77.4550018310547, -1.35184480409014, 218, 53, 'PPL', 'P'),
(95512, 'Lake Jackson Farms', 29.0575008392334, 0.507149062045638, -95.4713897705078, -1.66629009295019, 218, 51, 'PPL', 'P'),
(123001, 'Lake James', 41.7050018310547, 0.727889596502168, -85.0483322143555, -1.48437342047046, 218, 19, 'PPL', 'P'),
(16792, 'Lake Jem', 28.7461109161377, 0.501714282630086, -81.6672210693359, -1.425361898614, 218, 12, 'PPL', 'P'),
(198497, 'Lake Jessie', 48.0605583190918, 0.838814983014903, -103.376388549805, -1.80425834901506, 218, 34, 'PPL', 'P'),
(22470, 'Lake Jodeco', 33.5055618286133, 0.584782371639834, -84.2911071777344, -1.47115735040289, 218, 13, 'PPL', 'P'),
(3607, 'Lake Joy', 33.1180610656738, 0.57801920747255, -86.2091674804688, -1.5046338179374, 218, 2, 'PPL', 'P'),
(41680, 'Lake Judge Perez', 29.5583305358887, 0.515890189244037, -89.8861083984375, -1.56880854335726, 218, 22, 'PPL', 'P'),
(66180, 'Lake Junaluska', 35.5277786254883, 0.620076712934436, -82.959716796875, -1.44792020462751, 218, 33, 'PPL', 'P'),
(55766, 'Lake Junction', 38.6055603027344, 0.673794136859934, -90.3327789306641, -1.57660441481625, 218, 29, 'PPL', 'P'),
(145555, 'Lake Junction', 40.9052810668945, 0.713931836071008, -74.6011123657227, -1.30203503643212, 218, 37, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(27659, 'Lake Ka-ho', 39.0997200012207, 0.682418850629183, -89.746940612793, -1.56637960728505, 218, 18, 'PPL', 'P'),
(48778, 'Lake Karylbrook', 38.6561088562012, 0.67467637555005, -76.5558319091797, -1.33615132841852, 218, 25, 'PPL', 'P'),
(16793, 'Lake Kathryn', 29.0149993896484, 0.50640727181351, -81.4916687011719, -1.42229793177986, 218, 12, 'PPL', 'P'),
(16794, 'Lake Kathryn Heights', 29.0136108398438, 0.506383037047591, -81.4891662597656, -1.42225425593798, 218, 12, 'PPL', 'P'),
(150115, 'Lake Katonah', 41.2841682434082, 0.720544664794757, -73.6519393920898, -1.28546884287128, 218, 40, 'PPL', 'P'),
(150116, 'Lake Katrine', 41.9855613708496, 0.73278628421947, -73.9886093139648, -1.29134484150043, 218, 40, 'PPL', 'P'),
(103440, 'Lake Kennedy Estates', 36.7280616760254, 0.64102560412219, -76.5505599975586, -1.33605931620286, 218, 53, 'PPL', 'P'),
(207852, 'Lake Ketchum', 48.2847213745117, 0.842727366393312, -122.342781066895, -2.13528434566389, 218, 56, 'PPL', 'P'),
(103441, 'Lake Killarney', 37.8319396972656, 0.660291910133232, -77.9797210693359, -1.36100288244671, 218, 53, 'PPL', 'P'),
(95513, 'Lake Kiowa', 33.5769386291504, 0.586028131818746, -97.0127792358398, -1.69319241417579, 218, 51, 'PPL', 'P'),
(174862, 'Lake Koshkonong', 42.9097213745117, 0.748915919098616, -88.9194412231445, -1.55193701837745, 218, 57, 'PPL', 'P'),
(174863, 'Lake Lac La Belle', 43.1308288574219, 0.752774972676196, -88.5444412231445, -1.54539203368247, 218, 57, 'PPL', 'P'),
(55767, 'Lake Lafayette', 38.9458312988281, 0.67973298609081, -93.9711074829102, -1.64010522732226, 218, 29, 'PPL', 'P'),
(66181, 'Lake Landing', 35.4797210693359, 0.619237950349115, -76.0766677856445, -1.3277883368054, 218, 33, 'PPL', 'P'),
(81938, 'Lake Lanier', 35.1902809143066, 0.614186266656371, -82.2319412231445, -1.43521812465033, 218, 48, 'PPL', 'P'),
(22471, 'Lake Lanier Vista', 34.1472206115723, 0.595981430076808, -84.0202789306641, -1.46643050578411, 218, 13, 'PPL', 'P'),
(22472, 'Lake Latimer', 34.0669403076172, 0.59458027444829, -84.5477828979492, -1.47563718683057, 218, 13, 'PPL', 'P'),
(174864, 'Lake Lawn', 42.6258316040039, 0.743961107890524, -88.5941696166992, -1.54625995788172, 218, 57, 'PPL', 'P'),
(131643, 'Lake Leelanau', 44.9808311462402, 0.785063603785507, -85.7149963378906, -1.49600890443107, 218, 27, 'PPL', 'P'),
(136335, 'Lake Lillian', 44.9436111450195, 0.78441399221661, -94.8797225952148, -1.65596355266536, 218, 28, 'PPL', 'P'),
(150117, 'Lake Lincolndale', 41.3416709899902, 0.721548277051553, -73.7222213745117, -1.28669549486937, 218, 40, 'PPL', 'P'),
(131644, 'Lake Linden', 47.1941719055176, 0.823693687503488, -88.4072189331055, -1.54299705291416, 218, 27, 'PPL', 'P'),
(16795, 'Lake Lindsey', 28.6341705322266, 0.499760554364891, -82.3619384765625, -1.43748700474102, 218, 12, 'PPL', 'P'),
(156044, 'Lake Lodge', 40.4205589294434, 0.705471838815181, -80.7477798461914, -1.40931462199156, 218, 41, 'PPL', 'P'),
(16796, 'Lake Lorraine', 30.4413890838623, 0.531302468394057, -86.5652770996094, -1.51084910328943, 218, 12, 'PPL', 'P'),
(182643, 'Lake Los Angeles', 34.6124992370605, 0.604102074030732, -117.827217102051, -2.05647288689296, 218, 6, 'PPL', 'P'),
(55768, 'Lake Lotawana', 38.9230613708496, 0.679335575877143, -94.2438888549805, -1.644866160403, 218, 29, 'PPL', 'P'),
(211958, 'Lake Louise', 62.2813911437988, 1.08701533818173, -146.551116943359, -2.55779951313687, 218, 1, 'PPL', 'P'),
(36778, 'Lake Louisvilla', 38.3136100769043, 0.668698644167258, -85.5141677856445, -1.49250378496237, 218, 21, 'PPL', 'P'),
(16797, 'Lake Lucerne', 25.9647197723389, 0.453169849384986, -80.2416687011719, -1.40048131612993, 218, 12, 'PPL', 'P'),
(156045, 'Lake Lucerne', 41.4049987792969, 0.722653555482963, -81.3383331298828, -1.41962172120044, 218, 41, 'PPL', 'P'),
(22473, 'Lake Lucerne Estates', 33.833610534668, 0.590507901667395, -84.0983276367188, -1.46779271268168, 218, 13, 'PPL', 'P'),
(150118, 'Lake Lucille', 41.1861114501953, 0.718833250899245, -73.995002746582, -1.2914564279501, 218, 40, 'PPL', 'P'),
(66183, 'Lake Lure', 35.4277801513672, 0.618331410314052, -82.2050018310547, -1.43474794355987, 218, 33, 'PPL', 'P'),
(66184, 'Lake Lure Mountain Estates', 35.5047187805176, 0.619674242714698, -82.1708297729492, -1.43415152863375, 218, 33, 'PPL', 'P'),
(150119, 'Lake Luzerne', 43.3127784729004, 0.755950592539033, -73.8352813720703, -1.28866876407906, 218, 40, 'PPL', 'P'),
(78578, 'Lake Lynn', 39.7280616760254, 0.69338548168202, -79.8608322143555, -1.39383446552326, 218, 45, 'PPL', 'P'),
(16798, 'Lake Mack Park', 28.9894409179688, 0.505961192330922, -81.436393737793, -1.42133320167498, 218, 12, 'PPL', 'P'),
(182644, 'Lake Madera Country Estates', 37.0430603027344, 0.646523367297522, -119.991668701172, -2.09424969379768, 218, 6, 'PPL', 'P'),
(16800, 'Lake Magdalene', 28.0738906860352, 0.489981826316283, -82.4719390869141, -1.43940687757086, 218, 12, 'PPL', 'P'),
(131645, 'Lake Margrethe', 44.6416702270508, 0.779144129051561, -84.7702789306641, -1.47952047517407, 218, 27, 'PPL', 'P'),
(16799, 'Lake Marian Highlands', 27.8761100769043, 0.48652990349035, -81.0430603027344, -1.41446823817503, 218, 12, 'PPL', 'P'),
(16812, 'Lake Mary', 28.7586097717285, 0.501932428812877, -81.3180618286133, -1.41926792024962, 218, 12, 'PPL', 'P'),
(182645, 'Lake Mary', 37.5999984741211, 0.656243772118257, -119.000282287598, -2.07694673672127, 218, 6, 'PPL', 'P'),
(196859, 'Lake Mary Ronan', 47.9430618286133, 0.836764282396515, -114.393608093262, -1.99654510446345, 218, 31, 'PPL', 'P'),
(95514, 'Lake Mathis Point Colonia', 28.1310005187988, 0.490978580933273, -97.8779983520508, -1.70829333650487, 218, 51, 'PPL', 'P'),
(196860, 'Lake McDonald', 48.6208305358887, 0.848593577905456, -113.870826721191, -1.98742084825273, 218, 31, 'PPL', 'P'),
(78579, 'Lake Meade', 39.9850006103516, 0.697869912062577, -77.0374984741211, -1.34455799587352, 218, 45, 'PPL', 'P'),
(103442, 'Lake Meade Point', 36.750560760498, 0.641418287224922, -76.6166687011719, -1.33721313074514, 218, 53, 'PPL', 'P'),
(95515, 'Lake Medina Highlands', 29.5677795410156, 0.51605510549454, -98.9569396972656, -1.72712441541477, 218, 51, 'PPL', 'P'),
(131646, 'Lake Michigan Beach', 42.2208290100098, 0.736892479146208, -86.3694381713867, -1.50743106918837, 218, 27, 'PPL', 'P'),
(30281, 'Lake Mill', 37.9377784729004, 0.662139145244338, -87.1097183227539, -1.52035139521689, 218, 19, 'PPL', 'P'),
(116370, 'Lake Mills', 43.4194412231445, 0.757812208720026, -93.5330581665039, -1.63245982446486, 218, 16, 'PPL', 'P'),
(174865, 'Lake Mills', 43.0813903808594, 0.75191210848301, -88.9116668701172, -1.55180133031991, 218, 57, 'PPL', 'P'),
(156046, 'Lake Milton', 41.0994415283203, 0.71732057540008, -80.9705581665039, -1.41320283718308, 218, 41, 'PPL', 'P'),
(211959, 'Lake Minchumina', 63.8827781677246, 1.11496481434794, -152.312225341797, -2.6583498232539, 218, 1, 'PPL', 'P'),
(131647, 'Lake Mine', 46.7752799987793, 0.816382644520948, -89.0458297729492, -1.55414291470836, 218, 27, 'PPL', 'P'),
(150121, 'Lake Minnewaska', 41.735279083252, 0.728418034241467, -74.216667175293, -1.29532520206566, 218, 40, 'PPL', 'P'),
(145556, 'Lake Mohawk', 41.0183296203613, 0.715904905543621, -74.6605606079102, -1.30307260399281, 218, 37, 'PPL', 'P'),
(156047, 'Lake Mohawk', 40.6666717529297, 0.709767317916397, -81.1994400024414, -1.4171975788182, 218, 41, 'PPL', 'P'),
(150122, 'Lake Mohegan', 41.3177795410156, 0.721131292603874, -73.8466720581055, -1.28886756905444, 218, 40, 'PPL', 'P'),
(390, 'Lake Monroe', 28.8244400024414, 0.503081383086165, -81.3272171020508, -1.41942770991503, 218, 12, 'PPL', 'P'),
(60537, 'Lake Monroe East Subdivision', 33.9430618286133, 0.592418187117309, -88.5638885498047, -1.5457314535634, 218, 30, 'PPL', 'P'),
(60538, 'Lake Monroe West Subdivision', 33.9458312988281, 0.592466523491094, -88.5702819824219, -1.54584304001307, 218, 30, 'PPL', 'P'),
(178500, 'Lake Montezuma', 34.6322212219238, 0.604446287601625, -111.777221679688, -1.95088054704213, 218, 5, 'PPL', 'P'),
(103443, 'Lake Monticello', 37.9230613708496, 0.6618822833572, -78.3349990844727, -1.36720365357079, 218, 53, 'PPL', 'P'),
(127906, 'Lake Moxie', 45.3511085510254, 0.791526163644748, -69.8847198486328, -1.21971845819248, 218, 26, 'PPL', 'P'),
(81939, 'Lake Murray Shores', 34.0747184753418, 0.594716029084857, -81.4844436645508, -1.42217183110225, 218, 48, 'PPL', 'P'),
(55769, 'Lake Mykee Town', 38.6761093139648, 0.675025449389932, -92.1041717529297, -1.60752105191098, 218, 29, 'PPL', 'P'),
(182646, 'Lake Nacimiento', 35.728328704834, 0.623576972134154, -120.878608703613, -2.10972971710793, 218, 6, 'PPL', 'P'),
(163510, 'Lake Naomi Estates', 41.1150016784668, 0.717592151252241, -75.4594421386719, -1.31701571703798, 218, 45, 'PPL', 'P'),
(174868, 'Lake Nebagamon', 46.5149993896484, 0.811839890912518, -91.6997222900391, -1.60046207712562, 218, 57, 'PPL', 'P'),
(66185, 'Lake Neighborhood', 35.8911094665527, 0.626418032385051, -75.9205627441406, -1.3250637898522, 218, 33, 'PPL', 'P'),
(136340, 'Lake Netta', 45.2799987792969, 0.790285063997744, -93.1916732788086, -1.62650153415803, 218, 28, 'PPL', 'P'),
(170695, 'Lake Norden', 44.5805587768555, 0.778077533034984, -97.2088928222656, -1.69661524196682, 218, 49, 'PPL', 'P'),
(66186, 'Lake Norman of Catawba', 35.586669921875, 0.621104559957152, -80.959716796875, -1.41301361958763, 218, 33, 'PPL', 'P'),
(48779, 'Lake Normandy Estates', 39.0433311462402, 0.681434679448344, -77.188606262207, -1.34719532430103, 218, 25, 'PPL', 'P'),
(41681, 'Lake Oaks', 30.0272197723389, 0.524073850247255, -90.0577774047852, -1.57180473274166, 218, 22, 'PPL', 'P'),
(103444, 'Lake Occoquan Shores', 38.7438888549805, 0.676208425546145, -77.3963928222656, -1.35082188391544, 218, 53, 'PPL', 'P'),
(131648, 'Lake Odessa', 42.7847213745117, 0.746734257533623, -85.1383285522461, -1.48594415288139, 218, 27, 'PPL', 'P'),
(32970, 'Lake of the Forest', 39.0658302307129, 0.681827362551076, -94.8397216796875, -1.65526540498559, 218, 20, 'PPL', 'P'),
(16821, 'Lake of the Hills', 27.9549999237061, 0.487906791063434, -81.5947189331055, -1.42409649762205, 218, 12, 'PPL', 'P'),
(48785, 'Lake of the Pines', 38.9680595397949, 0.680120942082608, -76.6416702270508, -1.33764948968975, 218, 25, 'PPL', 'P'),
(182653, 'Lake of the Pines', 39.0397186279297, 0.681371629109536, -121.055557250977, -2.11281805186604, 218, 6, 'PPL', 'P'),
(120290, 'Lake of the Woods', 40.2063903808594, 0.701733892488173, -88.3686065673828, -1.54232314000031, 218, 18, 'PPL', 'P'),
(178501, 'Lake of the Woods', 34.163890838623, 0.596272380425899, -109.988891601563, -1.9196682990664, 218, 5, 'PPL', 'P'),
(182654, 'Lake of the Woods', 34.8175010681152, 0.607680030955253, -118.995559692383, -2.07686431188553, 218, 6, 'PPL', 'P'),
(201096, 'Lake of the Woods', 42.3788909912109, 0.739651181140394, -122.211112976074, -2.13298630395926, 218, 43, 'PPL', 'P'),
(30283, 'Lake on the Green', 39.1375007629395, 0.683078249315086, -86.1166687011719, -1.5030194096846, 218, 19, 'PPL', 'P'),
(131649, 'Lake Orion', 42.7844390869141, 0.746729330685607, -83.2397232055664, -1.45280723838586, 218, 27, 'PPL', 'P'),
(131650, 'Lake Orion Heights', 42.7702789306641, 0.746482189336447, -83.2641677856445, -1.45323387679249, 218, 27, 'PPL', 'P'),
(136343, 'Lake Orono Estates', 45.3083305358887, 0.790779546433144, -93.602783203125, -1.63367675592498, 218, 28, 'PPL', 'P'),
(150123, 'Lake Osiris Colony', 41.5794410705566, 0.725698147820169, -74.1686096191406, -1.29448643948034, 218, 40, 'PPL', 'P'),
(201095, 'Lake Oswego', 45.4208297729492, 0.792743028525832, -122.669441223145, -2.14098564092553, 218, 43, 'PPL', 'P'),
(174885, 'Lake Owen', 46.2680587768555, 0.807529964162388, -91.2583312988281, -1.59275835104034, 218, 57, 'PPL', 'P'),
(174870, 'Lake Owen (historical)', 46.2700004577637, 0.80756385288726, -91.2538909912109, -1.59268085305262, 218, 57, 'PPL', 'P'),
(55770, 'Lake Ozark', 38.1986083984375, 0.666691486232692, -92.6386108398438, -1.61684877362898, 218, 29, 'PPL', 'P'),
(16801, 'Lake Panasoffkee', 28.7555599212646, 0.50187919888059, -82.0950012207031, -1.43282807073003, 218, 12, 'PPL', 'P'),
(16802, 'Lake Park', 26.7999992370605, 0.467748226218675, -80.0666732788086, -1.39742706983377, 218, 12, 'PPL', 'P'),
(22476, 'Lake Park', 30.6819400787354, 0.53550087527354, -83.1797180175781, -1.45175995028719, 218, 13, 'PPL', 'P'),
(66187, 'Lake Park', 35.086109161377, 0.612368126580174, -80.6352767944336, -1.40735107331985, 218, 33, 'PPL', 'P'),
(88369, 'Lake Park', 36.5230598449707, 0.637447647197669, -82.4594421386719, -1.43918876467758, 218, 50, 'PPL', 'P'),
(116371, 'Lake Park', 43.4555587768555, 0.758442578950048, -95.320556640625, -1.66365755821265, 218, 16, 'PPL', 'P'),
(123002, 'Lake Park', 41.704719543457, 0.727884669654152, -86.5497207641602, -1.5105775940163, 218, 19, 'PPL', 'P'),
(136344, 'Lake Park', 46.8863906860352, 0.818321891847716, -96.0941696166992, -1.6771596517813, 218, 28, 'PPL', 'P'),
(172183, 'Lake Park', 44.9944381713867, 0.785301091175715, -72.1947174072266, -1.26003552130297, 218, 55, 'PPL', 'P'),
(193252, 'Lake Park', 47.7211112976074, 0.832890514853913, -122.246109008789, -2.13359709995527, 218, 56, 'PPL', 'P'),
(16803, 'Lake Park Estates', 30.3872203826904, 0.530357046207079, -81.6933288574219, -1.42581756547651, 218, 12, 'PPL', 'P'),
(120278, 'Lake Park Estates', 42.1291694641113, 0.735292718279398, -88.0605621337891, -1.53694675039166, 218, 18, 'PPL', 'P'),
(127907, 'Lake Parlin (historical)', 45.5186080932617, 0.794449582152355, -70.0941696166992, -1.22337404626277, 218, 26, 'PPL', 'P'),
(145557, 'Lake Parsippany', 40.8499984741211, 0.712966972808073, -74.4291687011719, -1.29903405335776, 218, 37, 'PPL', 'P'),
(16804, 'Lake Pasadena Heights', 28.3277797698975, 0.494413026764552, -82.2225036621094, -1.4350534081369, 218, 12, 'PPL', 'P'),
(150132, 'Lake Peekskill', 41.3347206115723, 0.7214269700639, -73.8813934326172, -1.28947357136049, 218, 40, 'PPL', 'P'),
(27662, 'Lake Piasa', 39.0227813720703, 0.681076018228537, -90.190559387207, -1.57412221552224, 218, 18, 'PPL', 'P'),
(16805, 'Lake Pickett', 28.5908298492432, 0.499004116746767, -81.1191711425781, -1.41579662292676, 218, 12, 'PPL', 'P'),
(71007, 'Lake Pine', 39.8658294677734, 0.695789983251225, -74.8497161865234, -1.30637399163813, 218, 37, 'PPL', 'P'),
(14067, 'Lake Pines', 38.5555610656738, 0.672921485549742, -75.5488891601563, -1.31857686206898, 218, 10, 'PPL', 'P'),
(204602, 'Lake Pines Apartment Condominium', 40.6647186279297, 0.709733229454444, -111.865280151367, -1.95241745730722, 218, 52, 'PPL', 'P'),
(16806, 'Lake Placid', 27.2927799224854, 0.476348871669572, -81.3630599975586, -1.42005328645509, 218, 12, 'PPL', 'P'),
(150124, 'Lake Placid', 44.2794418334961, 0.772822050939822, -73.9802780151367, -1.29119943290491, 218, 40, 'PPL', 'P'),
(142202, 'Lake Platte View', 41.2444381713867, 0.719851244225928, -96.351936340332, -1.68165852981077, 218, 35, 'PPL', 'P'),
(125190, 'Lake Pleasant', 42.5563888549805, 0.742749103278429, -72.5186080932617, -1.26568848019082, 218, 23, 'PPL', 'P'),
(150125, 'Lake Pleasant', 43.4708290100098, 0.758709094796137, -74.4130630493164, -1.2987529567047, 218, 40, 'PPL', 'P'),
(113615, 'Lake Pocotopaug', 41.598331451416, 0.726027847163121, -72.5108337402344, -1.26555279213328, 218, 8, 'PPL', 'P'),
(81940, 'Lake Point', 34.0819396972656, 0.594842063183445, -81.3241729736328, -1.41937457985128, 218, 48, 'PPL', 'P'),
(204603, 'Lake Point', 40.6808280944824, 0.710014392686529, -112.262222290039, -1.95934540456695, 218, 52, 'PPL', 'P'),
(204604, 'Lake Point Junction', 40.7230606079102, 0.710751489097236, -112.225280761719, -1.95870065326704, 218, 52, 'PPL', 'P'),
(22478, 'Lake Pointe', 34.1119384765625, 0.595365640653754, -84.6125030517578, -1.47676676660692, 218, 13, 'PPL', 'P'),
(88370, 'Lake Pomeroy', 35.9930610656738, 0.628197423467387, -84.8513870239258, -1.4809360784515, 218, 50, 'PPL', 'P'),
(48780, 'Lake Potomac', 39.0486106872559, 0.681526824822061, -77.2541732788086, -1.34833968462143, 218, 25, 'PPL', 'P'),
(170698, 'Lake Preston', 44.3636093139648, 0.774291050597109, -97.3769378662109, -1.69954818127532, 218, 49, 'PPL', 'P'),
(103446, 'Lake Prince Farms', 36.8008308410645, 0.642295665646049, -76.6399993896484, -1.33762032807581, 218, 53, 'PPL', 'P'),
(103447, 'Lake Prince Meadows', 36.8158302307129, 0.642557454381204, -76.6455612182617, -1.33771740029754, 218, 53, 'PPL', 'P'),
(41682, 'Lake Providence', 32.8041687011719, 0.572540752215121, -91.1699981689453, -1.5912166470853, 218, 22, 'PPL', 'P'),
(3608, 'Lake Purdy', 33.4300003051758, 0.583463574268027, -86.6805572509766, -1.51286112149299, 218, 2, 'PPL', 'P'),
(150127, 'Lake Purdy', 41.3250007629395, 0.721257326702462, -73.6725006103516, -1.28582770382817, 218, 40, 'PPL', 'P'),
(32965, 'Lake Quivira', 39.0402793884277, 0.681381416226542, -94.7763900756836, -1.65416005997516, 218, 20, 'PPL', 'P'),
(22479, 'Lake Ranch', 34.3383293151855, 0.599316906184078, -83.9188919067383, -1.46466096839781, 218, 13, 'PPL', 'P'),
(9938, 'Lake Ridge', 34.5522193908691, 0.603049992242096, -90.8030624389648, -1.58481241045393, 218, 4, 'PPL', 'P'),
(32968, 'Lake Ridge', 39.1652793884277, 0.683563077791535, -95.4722213745117, -1.66630460717814, 218, 20, 'PPL', 'P'),
(81941, 'Lake Ridge', 34.9044418334961, 0.609197433565353, -82.0250015258789, -1.43160634557996, 218, 48, 'PPL', 'P'),
(103448, 'Lake Ridge', 38.6877784729004, 0.675229114634296, -77.2980575561523, -1.34910560975094, 218, 53, 'PPL', 'P'),
(110009, 'Lake Ridge', 39.2797203063965, 0.685560448609094, -80.2144393920898, -1.40000607503341, 218, 58, 'PPL', 'P'),
(150128, 'Lake Ridge', 42.6097183227539, 0.743679878079411, -76.6138916015625, -1.3371646612133, 218, 40, 'PPL', 'P'),
(204605, 'Lake Ridge', 40.6988906860352, 0.710329644380567, -112.071670532227, -1.95601964899766, 218, 52, 'PPL', 'P'),
(116373, 'Lake Ridge Mobile Home Park', 41.6072196960449, 0.726182976296618, -91.5430603027344, -1.59772780963443, 218, 16, 'PPL', 'P'),
(60541, 'Lake Ridgelea Subdivision', 32.1763916015625, 0.561583974858317, -90.2972183227539, -1.57598376512421, 218, 30, 'PPL', 'P'),
(174871, 'Lake Ripley', 43.0058288574219, 0.750593311111203, -88.9861068725586, -1.5531005534577, 218, 57, 'PPL', 'P'),
(48781, 'Lake Riviera', 39.1686096191406, 0.683621201282326, -76.5108337402344, -1.33536596221306, 218, 25, 'PPL', 'P'),
(145558, 'Lake Riviera', 40.0449981689453, 0.698917067003196, -74.1538925170898, -1.2942295775932, 218, 37, 'PPL', 'P'),
(3609, 'Lake Robinwood Subdivision', 33.2333297729492, 0.580031025939023, -87.6780624389648, -1.53027087132911, 218, 2, 'PPL', 'P'),
(207854, 'Lake Roesiger', 47.9836082458496, 0.837471950877176, -121.928062438965, -2.12804614013716, 218, 56, 'PPL', 'P'),
(16807, 'Lake Rogers Isle', 26.3811092376709, 0.460437216525648, -80.0741729736328, -1.39755796420135, 218, 12, 'PPL', 'P'),
(131651, 'Lake Roland', 46.8844413757324, 0.818287869964791, -88.8638916015625, -1.5509674945826, 218, 27, 'PPL', 'P'),
(150129, 'Lake Ronkonkoma', 40.8349990844727, 0.712705184072918, -73.1316680908203, -1.27638839566049, 218, 40, 'PPL', 'P'),
(22480, 'Lake Royal', 33.4936103820801, 0.584573779547453, -82.1694412231445, -1.43412729386783, 218, 13, 'PPL', 'P'),
(66188, 'Lake Rugby', 35.3569412231445, 0.617095037777983, -82.5336074829102, -1.44048319412541, 218, 33, 'PPL', 'P'),
(136349, 'Lake Saint Croix Beach', 44.9208297729492, 0.784016382265861, -92.7666702270508, -1.61908383157383, 218, 28, 'PPL', 'P'),
(55771, 'Lake Saint Louis', 38.7975006103516, 0.677144127195144, -90.7855606079102, -1.5845069458769, 218, 29, 'PPL', 'P'),
(182648, 'Lake San Marcos', 33.1261100769043, 0.578159689220052, -117.207496643066, -2.04565672444171, 218, 6, 'PPL', 'P'),
(136350, 'Lake Sarah', 45.0719413757324, 0.786653777272393, -93.6900024414063, -1.63519901880406, 218, 28, 'PPL', 'P'),
(16808, 'Lake Sarasota', 27.2922191619873, 0.476339084552566, -82.4377822875977, -1.43881072896084, 218, 12, 'PPL', 'P'),
(22482, 'Lake Sardis Estates', 32.7122192382813, 0.570935931342239, -83.7427825927734, -1.46158728102569, 218, 13, 'PPL', 'P'),
(81942, 'Lake Secession', 34.2844390869141, 0.598376344266089, -82.5947189331055, -1.44154979014199, 218, 48, 'PPL', 'P'),
(88372, 'Lake Shadow', 35.8202781677246, 0.625181793007036, -84.5861129760742, -1.47630617289639, 218, 50, 'PPL', 'P'),
(174872, 'Lake Shangrila', 42.5052795410156, 0.741857077471307, -88.070556640625, -1.53712118744306, 218, 57, 'PPL', 'P'),
(110010, 'Lake Shawnee', 37.4077796936035, 0.652888921514057, -81.1408309936523, -1.4161746586435, 218, 58, 'PPL', 'P'),
(16809, 'Lake Shipp Heights', 27.9963893890381, 0.488629173509118, -81.7461090087891, -1.42673875289757, 218, 12, 'PPL', 'P'),
(16810, 'Lake Shore', 30.2808303833008, 0.528500190426535, -81.7261123657227, -1.42638974563671, 218, 12, 'PPL', 'P'),
(22483, 'Lake Shore', 34.415828704834, 0.600669525701729, -83.970832824707, -1.46556750843287, 218, 13, 'PPL', 'P'),
(32969, 'Lake Shore', 39.2430610656738, 0.684920624157203, -95.4236068725586, -1.66545612405484, 218, 20, 'PPL', 'P'),
(48782, 'Lake Shore', 39.1069412231445, 0.682544884727771, -76.4852828979492, -1.33492001588852, 218, 25, 'PPL', 'P'),
(88373, 'Lake Shore', 35.9186096191406, 0.62689800059251, -84.5119400024414, -1.47501161029051, 218, 50, 'PPL', 'P'),
(95516, 'Lake Shore', 31.829719543457, 0.555533406019712, -99.0905609130859, -1.72945654558135, 218, 51, 'PPL', 'P'),
(136352, 'Lake Shore', 46.4855613708496, 0.811326100559215, -94.3602828979492, -1.64689761968251, 218, 28, 'PPL', 'P'),
(204606, 'Lake Shore', 40.121940612793, 0.700259965982869, -111.729721069336, -1.95005150499479, 218, 52, 'PPL', 'P'),
(207855, 'Lake Shore', 45.6908302307129, 0.7974554254957, -122.689720153809, -2.1413395750344, 218, 56, 'PPL', 'P'),
(3612, 'Lake Shore Estates', 33.4588890075684, 0.583967777241406, -86.8061065673828, -1.5150523704379, 218, 2, 'PPL', 'P'),
(16811, 'Lake Shore Estates', 28.103889465332, 0.490505403786593, -82.7341690063477, -1.44398365306221, 218, 12, 'PPL', 'P'),
(95517, 'Lake Shore Estates', 32.6308288574219, 0.569515401216791, -97.4844436645508, -1.70142451142134, 218, 51, 'PPL', 'P'),
(136353, 'Lake Shore Park', 45.0716705322266, 0.786649050161458, -93.0111083984375, -1.62335008248208, 218, 28, 'PPL', 'P'),
(144032, 'Lake Shore Park', 43.5750007629395, 0.760527234872335, -71.3483276367188, -1.24526323305241, 218, 36, 'PPL', 'P'),
(186953, 'Lake Shore Park', 39.9588890075684, 0.697414178621037, -105.366386413574, -1.83899036384549, 218, 7, 'PPL', 'P'),
(3613, 'Lake Shore Subdivision', 33.9952812194824, 0.593329587421361, -87.1911087036133, -1.52177192534234, 218, 2, 'PPL', 'P'),
(136354, 'Lake Shore Terrace Mobile Home Park', 45.4088897705078, 0.792534636170534, -92.8391723632813, -1.62034923256578, 218, 28, 'PPL', 'P'),
(14068, 'Lake Shores', 38.6833305358887, 0.67515148348852, -75.595832824707, -1.31939618357834, 218, 10, 'PPL', 'P'),
(81944, 'Lake Shores', 34.2758293151855, 0.598226075401581, -82.0616683959961, -1.43224630318991, 218, 48, 'PPL', 'P'),
(103449, 'Lake Shores', 36.9027786254883, 0.644074990149358, -76.1513900756836, -1.32909248679121, 218, 53, 'PPL', 'P'),
(123003, 'Lake Shores', 41.0222206115723, 0.715972816151418, -85.1538925170898, -1.48621579531258, 218, 19, 'PPL', 'P'),
(9939, 'Lake Side', 36.0522193908691, 0.629229931022011, -90.413330078125, -1.5780102975557, 218, 4, 'PPL', 'P'),
(27663, 'Lake Siding', 38.5697212219238, 0.673168626898901, -90.1044387817383, -1.572619127403, 218, 18, 'PPL', 'P'),
(156049, 'Lake Slagle', 40.878059387207, 0.713456728132538, -81.4563903808594, -1.42168220893583, 218, 41, 'PPL', 'P'),
(103450, 'Lake Smith', 36.8908309936523, 0.643866464636005, -76.1680603027344, -1.3293834371403, 218, 53, 'PPL', 'P'),
(103451, 'Lake Speight Colony', 36.7077789306641, 0.640671603434291, -76.6319427490234, -1.33747971317025, 218, 53, 'PPL', 'P'),
(22484, 'Lake Spivey Estates', 33.5113906860352, 0.584884104393475, -84.3016662597656, -1.47134164115032, 218, 13, 'PPL', 'P'),
(55795, 'Lake Spring', 37.7825012207031, 0.659429045940046, -91.6786117553711, -1.6000936287888, 218, 29, 'PPL', 'P'),
(103452, 'Lake Spring', 37.2930603027344, 0.650886690427508, -80.0730590820313, -1.39753852312539, 218, 53, 'PPL', 'P'),
(103453, 'Lake Spring Land', 37.288890838623, 0.650813919550722, -80.0752792358398, -1.39757727211925, 218, 53, 'PPL', 'P'),
(55772, 'Lake Springs', 37.4536094665527, 0.653688801947462, -90.7947235107422, -1.58466686870036, 218, 29, 'PPL', 'P'),
(55773, 'Lake Station', 39.7013893127441, 0.692919961123474, -94.8891677856445, -1.65612840233683, 218, 29, 'PPL', 'P'),
(123004, 'Lake Station', 41.5750007629395, 0.725620649832448, -87.2388916015625, -1.52260589423769, 218, 19, 'PPL', 'P'),
(207856, 'Lake Stevens', 48.0152816772461, 0.83802475654045, -122.0625, -2.13039251821558, 218, 56, 'PPL', 'P'),
(66190, 'Lake Street Apartments', 35.3052787780762, 0.61619335801191, -81.5374984741211, -1.42309781221327, 218, 33, 'PPL', 'P'),
(150130, 'Lake Success', 40.7705612182617, 0.711580531144577, -73.7180633544922, -1.28662292372966, 218, 40, 'PPL', 'P'),
(120279, 'Lake Summerset', 42.4544410705566, 0.74096977877512, -89.3894424438477, -1.56014008716711, 218, 18, 'PPL', 'P'),
(188834, 'Lake Sumner', 34.6227798461914, 0.604281504509176, -104.376106262207, -1.82170671468698, 218, 38, 'PPL', 'P'),
(150131, 'Lake Sunnyside', 43.3727798461914, 0.75699781405868, -73.6377792358398, -1.28522170152212, 218, 40, 'PPL', 'P'),
(16813, 'Lake Suzy (not official)', 27.0377807617188, 0.471898296724373, -82.0372161865234, -1.43181953162522, 218, 12, 'PPL', 'P'),
(22485, 'Lake Swan', 33.853328704834, 0.590852048659261, -84.8230590820313, -1.48044166259512, 218, 13, 'PPL', 'P'),
(22486, 'Lake Talmadge', 33.4183311462402, 0.583259909023663, -84.3244400024414, -1.47173911794302, 218, 13, 'PPL', 'P'),
(182649, 'Lake Tamarisk', 33.7388916015625, 0.588854744420728, -115.388893127441, -2.01391610530571, 218, 6, 'PPL', 'P'),
(191716, 'Lake Tanglewood', 35.0675010681152, 0.612043354085239, -101.786666870117, -1.77651247151418, 218, 51, 'PPL', 'P'),
(88374, 'Lake Tansi', 35.8727798461914, 0.626098120159105, -85.054443359375, -1.48448008007212, 218, 50, 'PPL', 'P'),
(88375, 'Lake Tansi Village', 35.8833312988281, 0.626282277748484, -85.0472183227539, -1.48435397939451, 218, 50, 'PPL', 'P'),
(55774, 'Lake Tapawingo', 39.0213890075684, 0.68105171688359, -94.311393737793, -1.64604434286925, 218, 29, 'PPL', 'P'),
(22487, 'Lake Tara', 33.5416717529297, 0.585412608711801, -84.3499984741211, -1.47218519742561, 218, 13, 'PPL', 'P'),
(81945, 'Lake Taro', 34.767219543457, 0.606802452797045, -82.2841720581055, -1.43612972469146, 218, 48, 'PPL', 'P'),
(95519, 'Lake Tejas', 30.4577407836914, 0.531587859394373, -94.9371795654297, -1.65696636597383, 218, 51, 'PPL', 'P'),
(145559, 'Lake Telemark', 40.9566688537598, 0.71482872214712, -74.4983291625977, -1.30024113112184, 218, 37, 'PPL', 'P'),
(41685, 'Lake Terrace', 30.0277805328369, 0.524083637364261, -90.0763931274414, -1.57212963839464, 218, 22, 'PPL', 'P'),
(103454, 'Lake Terrace', 36.8613891601563, 0.643352607703674, -76.1991729736328, -1.32992645568657, 218, 53, 'PPL', 'P'),
(174873, 'Lake Tomahawk', 45.8141708374023, 0.799608125183839, -89.5936126708984, -1.56370352986369, 218, 57, 'PPL', 'P'),
(66191, 'Lake Toxaway', 35.1322212219238, 0.613172933861596, -82.9341735839844, -1.44747439146103, 218, 33, 'PPL', 'P'),
(88376, 'Lake Tullahoma Estates', 35.3958282470703, 0.61777374438179, -86.20361328125, -1.50453687887373, 218, 50, 'PPL', 'P'),
(76322, 'Lake Valley', 35.1680603027344, 0.613798443822629, -98.8627777099609, -1.72548097870608, 218, 42, 'PPL', 'P'),
(88377, 'Lake Valley', 36.1297187805176, 0.630582550539662, -85.4458312988281, -1.49131108826817, 218, 50, 'PPL', 'P'),
(188836, 'Lake Valley', 32.7177810668945, 0.571033003563973, -107.567222595215, -1.87740220151214, 218, 38, 'PPL', 'P'),
(188837, 'Lake Van', 33.1933288574219, 0.579332878259259, -104.356666564941, -1.82136742796411, 218, 38, 'PPL', 'P'),
(150140, 'Lake Vanare', 43.3699989318848, 0.756949277947813, -73.7872161865234, -1.28782986833569, 218, 40, 'PPL', 'P'),
(95520, 'Lake Victor', 30.9088897705078, 0.539461894631356, -98.1930618286133, -1.71379223152367, 218, 51, 'PPL', 'P'),
(3614, 'Lake View', 33.2805595397949, 0.58085534087543, -87.1374969482422, -1.52083622369334, 218, 2, 'PPL', 'P'),
(9940, 'Lake View', 35.892219543457, 0.626437406881981, -90.4524993896484, -1.57869393100753, 218, 4, 'PPL', 'P'),
(16814, 'Lake View', 28.7486095428467, 0.501757891892936, -81.3249969482422, -1.41938896092117, 218, 12, 'PPL', 'P'),
(41686, 'Lake View', 30.7924995422363, 0.537430501930871, -89.8305587768555, -1.56783901956242, 218, 22, 'PPL', 'P'),
(48783, 'Lake View', 39.166389465332, 0.683582452288465, -76.5091705322266, -1.33533693375718, 218, 25, 'PPL', 'P'),
(60544, 'Lake View', 34.9888916015625, 0.610671360070658, -90.1397171020508, -1.57323485024703, 218, 30, 'PPL', 'P'),
(66193, 'Lake View', 36.2230606079102, 0.632211672757491, -78.2838897705078, -1.36631162776367, 218, 33, 'PPL', 'P'),
(81948, 'Lake View', 34.3455581665039, 0.59944307344072, -79.1658325195313, -1.38170443254822, 218, 48, 'PPL', 'P'),
(103456, 'Lake View', 36.8330612182617, 0.642858191847301, -75.978889465332, -1.32608178317888, 218, 53, 'PPL', 'P'),
(113616, 'Lake View', 41.3561096191406, 0.721800278669702, -72.5119400024414, -1.26557210005119, 218, 8, 'PPL', 'P'),
(116374, 'Lake View', 42.3116683959961, 0.73847792552216, -95.0530624389648, -1.65898890366369, 218, 16, 'PPL', 'P'),
(123005, 'Lake View', 41.5247192382813, 0.72474307167424, -87.0516662597656, -1.51933819558017, 218, 19, 'PPL', 'P'),
(127908, 'Lake View', 45.3233299255371, 0.791041335168299, -68.9263916015625, -1.20299247496623, 218, 26, 'PPL', 'P'),
(145560, 'Lake View', 40.8919410705566, 0.713699009212708, -74.1469421386719, -1.29410827060555, 218, 37, 'PPL', 'P'),
(150134, 'Lake View', 43.2861099243164, 0.755485138559515, -74.0111083984375, -1.29173752460316, 218, 40, 'PPL', 'P'),
(156050, 'Lake View', 40.4988899230957, 0.706838972560773, -82.5261077880859, -1.44035229975783, 218, 41, 'PPL', 'P'),
(191717, 'Lake View', 29.4549999237061, 0.514086729843349, -100.94416809082, -1.76180809387141, 218, 51, 'PPL', 'P'),
(191718, 'Lake View Addition Colonia', 29.4570007324219, 0.514121650543143, -100.946998596191, -1.76185749550963, 218, 51, 'PPL', 'P'),
(73148, 'Lake View Heights', 39.1072196960449, 0.68254974499676, -83.0305633544922, -1.44915671032164, 218, 41, 'PPL', 'P'),
(120281, 'Lake View Highlands', 42.228328704834, 0.737023373513786, -88.0449981689453, -1.53667510796047, 218, 18, 'PPL', 'P'),
(88378, 'Lake View Park', 36.0244407653809, 0.628745102545562, -83.398063659668, -1.45557080064904, 218, 50, 'PPL', 'P'),
(16815, 'Lake View Point', 30.4238891601563, 0.530997037106539, -84.5977783203125, -1.47650977156173, 218, 12, 'PPL', 'P'),
(192665, 'Lake View Resort', 37.7161102294922, 0.658270304549753, -112.621391296387, -1.96561408629883, 218, 52, 'PPL', 'P'),
(113617, 'Lake View Terrace', 41.9469413757324, 0.732112238147571, -72.3672180175781, -1.2630462249153, 218, 8, 'PPL', 'P'),
(150135, 'Lake View Terrace', 42.0991706848145, 0.734769140809088, -78.3480606079102, -1.3674316201601, 218, 40, 'PPL', 'P'),
(182650, 'Lake View Terrace', 34.2763900756836, 0.598235862518587, -118.360282897949, -2.06577664016115, 218, 6, 'PPL', 'P'),
(120282, 'Lake Villa', 42.4169387817383, 0.740315240358205, -88.0738906860352, -1.53717937751288, 218, 18, 'PPL', 'P'),
(9941, 'Lake Village', 33.3286094665527, 0.581693970302696, -91.2816696166992, -1.59316568152907, 218, 4, 'PPL', 'P'),
(48784, 'Lake Village', 39.1375007629395, 0.683078249315086, -76.7138900756836, -1.33890996383368, 218, 25, 'PPL', 'P'),
(81949, 'Lake Village', 34.0275001525879, 0.593891913885532, -81.4441680908203, -1.42146888973252, 218, 48, 'PPL', 'P'),
(88379, 'Lake Village', 35.0513916015625, 0.611762190853154, -85.3525009155273, -1.48968216578743, 218, 50, 'PPL', 'P'),
(123006, 'Lake Village', 41.1375007629395, 0.717984834354973, -87.4486083984375, -1.5262661428399, 218, 19, 'PPL', 'P'),
(182651, 'Lake Village', 33.499439239502, 0.584675512301094, -117.132499694824, -2.04434778076594, 218, 6, 'PPL', 'P'),
(142203, 'Lake Village Trailer Court', 42.4458312988281, 0.740819509910612, -96.4263916015625, -1.68295801926467, 218, 35, 'PPL', 'P'),
(22489, 'Lake Villas', 33.9869384765625, 0.593183979088761, -84.290283203125, -1.471142969333, 218, 13, 'PPL', 'P'),
(60545, 'Lake Vista', 33.6088905334473, 0.586585797751008, -91.0627822875977, -1.58934537694535, 218, 30, 'PPL', 'P'),
(88380, 'Lake Vista', 35.0783309936523, 0.612232371943607, -85.1769409179688, -1.48661806579524, 218, 50, 'PPL', 'P'),
(66195, 'Lake Waccamaw', 34.3188896179199, 0.598977619461201, -78.5002822875977, -1.37008838966357, 218, 33, 'PPL', 'P'),
(16816, 'Lake Wales', 27.9011096954346, 0.486966229145446, -81.5861129760742, -1.42394629533656, 218, 12, 'PPL', 'P'),
(163511, 'Lake Wallenpaupack Estate', 41.3647193908691, 0.72195054753421, -75.3344421386719, -1.31483405547298, 218, 45, 'PPL', 'P'),
(110011, 'Lake Washington', 38.4111099243164, 0.670400337524791, -82.0033264160156, -1.43122804354711, 218, 58, 'PPL', 'P'),
(60546, 'Lake Washington (historical)', 33.1861114501953, 0.579206910739698, -91.0713882446289, -1.58949557923083, 218, 30, 'PPL', 'P'),
(22490, 'Lake Watch', 34.3786087036133, 0.600019914132831, -83.8122177124023, -1.46279915247973, 218, 13, 'PPL', 'P'),
(95523, 'Lake Water Wheel', 30.471830368042, 0.531833769031528, -94.9102478027344, -1.65649631804143, 218, 51, 'PPL', 'P'),
(174875, 'Lake Waubesa', 43.0255584716797, 0.75093765784015, -89.3052825927734, -1.55867122066787, 218, 57, 'PPL', 'P'),
(55775, 'Lake Waukomis', 39.2322196960449, 0.684731406561753, -94.6377792358398, -1.65174084444093, 218, 29, 'PPL', 'P'),
(174876, 'Lake Wazeecha', 44.3711090087891, 0.774421944964687, -89.7563934326172, -1.56654459011459, 218, 57, 'PPL', 'P'),
(16817, 'Lake Weir', 29.0188903808594, 0.506475182421307, -81.9886093139648, -1.43097118165998, 218, 12, 'PPL', 'P'),
(16818, 'Lake Weir (historical)', 29.0505599975586, 0.507027921505553, -81.9375, -1.43007915585285, 218, 12, 'PPL', 'P'),
(76323, 'Lake West', 33.8958282470703, 0.591593805601875, -95.8852767944336, -1.67351378424898, 218, 42, 'PPL', 'P'),
(22491, 'Lake West Point Estates', 33.1124992370605, 0.577922135250817, -85.0500030517578, -1.4844025820844, 218, 13, 'PPL', 'P'),
(22492, 'Lake Wildwood', 33.8572196960449, 0.590919959267058, -83.4347229003906, -1.45621062510093, 218, 13, 'PPL', 'P'),
(182652, 'Lake Wildwood', 39.2330589294434, 0.684746053947748, -121.199440002441, -2.11532927961593, 218, 6, 'PPL', 'P'),
(140352, 'Lake Williams', 47.1347198486328, 0.822656053363766, -99.6141662597656, -1.73859518286196, 218, 34, 'PPL', 'P'),
(136362, 'Lake Wilson', 43.9966697692871, 0.767886747386714, -95.9524993896484, -1.67468703986721, 218, 28, 'PPL', 'P'),
(174877, 'Lake Windsor', 43.2041702270508, 0.754055021054142, -89.3477783203125, -1.55941291103146, 218, 57, 'PPL', 'P'),
(55776, 'Lake Winnebago', 38.8313903808594, 0.677735615273251, -94.3583297729492, -1.64686353122056, 218, 29, 'PPL', 'P'),
(163512, 'Lake Winola', 41.5066719055176, 0.724428086296311, -75.8533325195313, -1.32389040107591, 218, 45, 'PPL', 'P'),
(174878, 'Lake Wisconsin', 43.3736114501953, 0.757012328286621, -89.5755615234375, -1.56338847790673, 218, 57, 'PPL', 'P'),
(174879, 'Lake Wissota', 44.9263916015625, 0.784113454487594, -91.3008270263672, -1.59350004140393, 218, 57, 'PPL', 'P'),
(123007, 'Lake Wood', 40.5530586242676, 0.707784394747751, -85.5680618286133, -1.49344441345938, 218, 19, 'PPL', 'P'),
(16819, 'Lake Worth', 26.6155605316162, 0.464529163540555, -80.0572204589844, -1.39726208700424, 218, 12, 'PPL', 'P'),
(66197, 'Lake Worth', 35.6966705322266, 0.62302443278699, -75.774169921875, -1.32250875310237, 218, 33, 'PPL', 'P'),
(95524, 'Lake Worth', 32.8047218322754, 0.572550406174073, -97.4447174072266, -1.70073115743154, 218, 51, 'PPL', 'P'),
(16820, 'Lake Worth Corridor', 26.6180591583252, 0.464572772803405, -80.1013870239258, -1.39803293898177, 218, 12, 'PPL', 'P'),
(81950, 'Lake Wylie', 35.1083297729492, 0.612755949413917, -81.0430603027344, -1.41446823817503, 218, 48, 'PPL', 'P'),
(163513, 'Lake Wynonah', 40.5991706848145, 0.708589202029173, -76.1641693115234, -1.32931552653251, 218, 45, 'PPL', 'P'),
(120284, 'Lake Zurich', 42.1969413757324, 0.736475561277556, -88.0933303833008, -1.53751866423576, 218, 18, 'PPL', 'P'),
(88381, 'Lake-A-Wana', 35.7805595397949, 0.624488572175288, -84.3930587768555, -1.47293674148523, 218, 50, 'PPL', 'P'),
(207857, 'Lakebay', 47.2572212219238, 0.824794105665909, -122.757217407227, -2.1425176243426, 218, 56, 'PPL', 'P'),
(201097, 'Lakebrook', 45.0283317565918, 0.785892645832849, -123.049171447754, -2.1476131836143, 218, 43, 'PPL', 'P'),
(193213, 'Lakecreek', 42.4225006103516, 0.740412312579939, -122.625, -2.14020999525805, 218, 43, 'PPL', 'P'),
(14069, 'Lakecroft II', 39.6505584716797, 0.692032795585341, -75.6611099243164, -1.32053548389268, 218, 10, 'PPL', 'P'),
(66201, 'Lakedale', 35.0247192382813, 0.611296670294608, -78.899169921875, -1.3770502922272, 218, 33, 'PPL', 'P'),
(207859, 'Lakedale', 48.5724983215332, 0.847750021630174, -123.082778930664, -2.14819974484439, 218, 56, 'PPL', 'P'),
(41689, 'Lakefield', 32.2794418334961, 0.563382540700502, -92.7547225952148, -1.61887530606048, 218, 22, 'PPL', 'P'),
(131660, 'Lakefield', 43.3463897705078, 0.756537220348151, -84.3305587768555, -1.47184591070273, 218, 27, 'PPL', 'P'),
(136367, 'Lakefield', 43.6775016784668, 0.762316213334595, -95.17138671875, -1.66105405193099, 218, 28, 'PPL', 'P'),
(174882, 'Lakefield', 43.2949981689453, 0.755640267693012, -87.9255599975586, -1.53459051861721, 218, 57, 'PPL', 'P'),
(81951, 'Lakefield Circle', 34.3372192382813, 0.599297531687147, -80.0899963378906, -1.39783413400639, 218, 48, 'PPL', 'P'),
(81952, 'Lakefront', 34.4791717529297, 0.601775070449248, -82.8013916015625, -1.44515690868045, 218, 48, 'PPL', 'P'),
(95525, 'Lakefront Lodge', 26.8827800750732, 0.469193024399556, -99.2727813720703, -1.73263689255512, 218, 51, 'PPL', 'P'),
(9945, 'Lakehall', 33.3283309936523, 0.581689110033707, -91.2705612182617, -1.59297180340171, 218, 4, 'PPL', 'P'),
(88382, 'Lakeharbor', 35.8086090087891, 0.624978127762672, -84.602783203125, -1.47659712324549, 218, 50, 'PPL', 'P'),
(193719, 'Lakehead', 40.9052810668945, 0.713931836071008, -122.378059387207, -2.13590006850792, 218, 6, 'PPL', 'P'),
(22493, 'Lakehills', 33.4088897705078, 0.583095125931214, -84.7716674804688, -1.47954470993999, 218, 13, 'PPL', 'P'),
(95527, 'Lakehills', 29.7231502532959, 0.518766835985, -98.9346771240234, -1.72673586021172, 218, 51, 'PPL', 'P'),
(145561, 'Lakehurst', 40.0144386291504, 0.698383702415881, -74.3116683959961, -1.29698328616035, 218, 37, 'PPL', 'P'),
(16822, 'Lakeland', 28.0391693115234, 0.489375824010236, -81.9499969482422, -1.43029726874613, 218, 12, 'PPL', 'P'),
(22494, 'Lakeland', 31.0408306121826, 0.541764696736434, -83.0752792358398, -1.44993714967908, 218, 13, 'PPL', 'P'),
(36779, 'Lakeland', 38.2702789306641, 0.667942372996703, -85.5541687011719, -1.49320193264213, 218, 21, 'PPL', 'P'),
(41690, 'Lakeland', 30.6005592346191, 0.53408051159566, -91.397216796875, -1.59518236026453, 218, 22, 'PPL', 'P'),
(48788, 'Lakeland', 38.9888916015625, 0.680484530150431, -76.9291687011719, -1.34266728465762, 218, 25, 'PPL', 'P'),
(55780, 'Lakeland', 39.894718170166, 0.696294186224604, -92.2736129760742, -1.61047835914346, 218, 29, 'PPL', 'P'),
(60547, 'Lakeland', 32.2227783203125, 0.562393575829701, -90.1566696166992, -1.57353072744414, 218, 30, 'PPL', 'P'),
(71008, 'Lakeland', 39.7852783203125, 0.694384100511772, -75.0758285522461, -1.31032039689946, 218, 37, 'PPL', 'P'),
(81953, 'Lakeland', 33.9897193908691, 0.593232515199628, -81.2527770996094, -1.41812848677723, 218, 48, 'PPL', 'P'),
(88383, 'Lakeland', 35.2305603027344, 0.614889274605125, -89.7402801513672, -1.56626336030347, 218, 50, 'PPL', 'P'),
(95528, 'Lakeland', 30.1736106872559, 0.526628853707564, -94.7541732788086, -1.65377230372044, 218, 51, 'PPL', 'P'),
(103458, 'Lakeland', 36.8997192382813, 0.644021593769502, -76.2216720581055, -1.3303191387893, 218, 53, 'PPL', 'P'),
(131663, 'Lakeland', 42.4633293151855, 0.741124907908617, -83.8441696166992, -1.46335681841199, 218, 27, 'PPL', 'P'),
(136369, 'Lakeland', 44.9563903808594, 0.784637031957904, -92.7655563354492, -1.61906439049787, 218, 28, 'PPL', 'P'),
(150137, 'Lakeland', 40.8077812194824, 0.712230142713475, -73.1205596923828, -1.27619451753313, 218, 40, 'PPL', 'P'),
(156057, 'Lakeland', 41.6599998474121, 0.727104163717677, -83.2577819824219, -1.45312242350087, 218, 41, 'PPL', 'P'),
(156059, 'Lakeland Beach', 40.5449981689453, 0.707643713263168, -84.5236129760742, -1.4752153421139, 218, 41, 'PPL', 'P'),
(41691, 'Lakeland Gardens', 32.5449981689453, 0.568017373103621, -92.216667175293, -1.60948446742464, 218, 22, 'PPL', 'P'),
(22496, 'Lakeland Heights', 34.3669395446777, 0.599816248888467, -83.8091735839844, -1.46274602241598, 218, 13, 'PPL', 'P'),
(48789, 'Lakeland Heights', 39.4513893127441, 0.688556637993488, -76.9319381713867, -1.3427156210314, 218, 25, 'PPL', 'P'),
(95529, 'Lakeland Heights', 32.7227783203125, 0.571120222089673, -96.9816665649414, -1.69264939562953, 218, 51, 'PPL', 'P'),
(16823, 'Lakeland Highlands', 27.9594402313232, 0.487984289051156, -81.9502792358398, -1.43030219559415, 218, 12, 'PPL', 'P'),
(9946, 'Lakeland Hills', 36.3161087036133, 0.633835668390221, -93.9952774047852, -1.64052707203893, 218, 4, 'PPL', 'P'),
(22497, 'Lakeland Hills', 33.7661094665527, 0.589329785780171, -84.7050018310547, -1.47838117485973, 218, 13, 'PPL', 'P'),
(88384, 'Lakeland Park', 36.0583305358887, 0.629336590623669, -85.5883331298828, -1.4937982144102, 218, 50, 'PPL', 'P'),
(136370, 'Lakeland Shores', 44.9480590820313, 0.784491623362385, -92.7638931274414, -1.61903536204199, 218, 28, 'PPL', 'P'),
(88385, 'Lakeland Subdivision', 35.8883285522461, 0.626369496274184, -84.3397216796875, -1.47200583352619, 218, 50, 'PPL', 'P'),
(41692, 'Lakeland Terrace', 30.3549995422363, 0.529794686453395, -91.081672668457, -1.5896750762883, 218, 22, 'PPL', 'P'),
(182655, 'Lakeland Village', 33.6386108398438, 0.587104514952328, -117.343063354492, -2.04802280991219, 218, 6, 'PPL', 'P'),
(207860, 'Lakeland Village', 47.5511093139648, 0.829923420504429, -117.703887939453, -2.0543203869419, 218, 56, 'PPL', 'P'),
(156060, 'Lakeland Woods Estates', 41.4813919067383, 0.723986867082712, -84.4888916015625, -1.47460933980785, 218, 41, 'PPL', 'P'),
(156061, 'Lakeline', 41.6594390869141, 0.727094376600671, -81.4544372558594, -1.42164812047388, 218, 41, 'PPL', 'P'),
(16824, 'Lakemont', 27.5427799224854, 0.480712194799558, -81.4538879394531, -1.42163853309396, 218, 12, 'PPL', 'P'),
(22498, 'Lakemont', 34.7819404602051, 0.60705938126321, -83.416389465332, -1.45589064629596, 218, 13, 'PPL', 'P'),
(81954, 'Lakemont', 35.0647201538086, 0.611994817974373, -82.6297225952148, -1.44216071929605, 218, 48, 'PPL', 'P'),
(88386, 'Lakemont', 35.853889465332, 0.625768420816153, -83.9608306884766, -1.46539293822341, 218, 50, 'PPL', 'P'),
(103459, 'Lakemont', 37.2374992370605, 0.649916966895583, -77.3675003051758, -1.35031761436304, 218, 53, 'PPL', 'P'),
(150138, 'Lakemont', 42.5161094665527, 0.742046095329675, -76.9283294677734, -1.34265263727162, 218, 40, 'PPL', 'P'),
(156063, 'Lakemont', 41.582218170166, 0.725746617352009, -83.5327835083008, -1.45792210557547, 218, 41, 'PPL', 'P'),
(163518, 'Lakemont', 40.4727783203125, 0.706383239119233, -78.3886108398438, -1.36813935521979, 218, 45, 'PPL', 'P'),
(88387, 'Lakemont Cabin Area', 36.351390838623, 0.634451457813275, -83.1786117553711, -1.45174064236929, 218, 50, 'PPL', 'P'),
(88388, 'Lakemont Heights', 35.8491706848145, 0.625686062559443, -84.6963882446289, -1.47823083941619, 218, 50, 'PPL', 'P'),
(156064, 'Lakemont Landing', 41.6730613708496, 0.727332130306987, -83.2805633544922, -1.45352003345162, 218, 41, 'PPL', 'P'),
(182656, 'Lakemont Pines', 38.235279083252, 0.667331510421666, -120.370277404785, -2.10085766225244, 218, 6, 'PPL', 'P'),
(22499, 'Lakemont Town Homes', 30.767219543457, 0.536989282717272, -81.6180572509766, -1.42450382811077, 218, 13, 'PPL', 'P'),
(120291, 'Lakemoor', 42.3286094665527, 0.738773602982186, -88.1988906860352, -1.53936103907787, 218, 18, 'PPL', 'P'),
(88389, 'Lakemoor Hills', 35.9272193908691, 0.627048269457018, -83.9805603027344, -1.46573728495236, 218, 50, 'PPL', 'P'),
(88390, 'Lakemoore', 36.2527809143066, 0.632730389958811, -83.2827835083008, -1.45355878244548, 218, 50, 'PPL', 'P'),
(22500, 'Lakemoore Heights', 34.2686080932617, 0.598100041302993, -85.1252822875977, -1.48571645260819, 218, 13, 'PPL', 'P'),
(156065, 'Lakemore', 41.0208282470703, 0.715948514806471, -81.4361114501953, -1.42132827482696, 218, 41, 'PPL', 'P'),
(55781, 'Lakenan', 39.6722183227539, 0.692410831302078, -91.9508285522461, -1.60484470817351, 218, 29, 'PPL', 'P'),
(95530, 'Lakenon', 32.0519409179688, 0.559411900673248, -97.024169921875, -1.69339121915117, 218, 51, 'PPL', 'P'),
(60548, 'Lakeover', 32.3958282470703, 0.56541386682196, -90.2069396972656, -1.57440810586526, 218, 30, 'PPL', 'P'),
(9947, 'Lakeport', 33.2249984741211, 0.579885617343505, -91.1266708374023, -1.59046044249377, 218, 4, 'PPL', 'P'),
(16825, 'Lakeport', 26.976110458374, 0.470821946880303, -81.1275024414063, -1.41594203152228, 218, 12, 'PPL', 'P'),
(95531, 'Lakeport', 32.4088897705078, 0.565641833411271, -94.7050018310547, -1.65291410005916, 218, 51, 'PPL', 'P'),
(113169, 'Lakeport', 43.5472183227539, 0.760042339816858, -71.4630584716797, -1.24726566387604, 218, 36, 'PPL', 'P'),
(131664, 'Lakeport', 43.1150016784668, 0.752498736292127, -82.4902801513672, -1.43972698953388, 218, 27, 'PPL', 'P'),
(150139, 'Lakeport', 43.1452789306641, 0.753027174031426, -75.8722229003906, -1.32422010041886, 218, 40, 'PPL', 'P'),
(170709, 'Lakeport', 42.9083290100098, 0.748891617753669, -97.5791702270508, -1.70307780182606, 218, 49, 'PPL', 'P'),
(174884, 'Lakeport', 44.4486083984375, 0.775774564482338, -92.1797180175781, -1.60883958296668, 218, 57, 'PPL', 'P'),
(182657, 'Lakeport', 39.0430603027344, 0.681429952337409, -122.91471862793, -2.14526653921978, 218, 6, 'PPL', 'P'),
(201098, 'Lakeport (historical)', 42.9041709899902, 0.748819046613965, -124.495826721191, -2.17286208127713, 218, 43, 'PPL', 'P'),
(204613, 'Laker Lane Condominium', 41.1730613708496, 0.718605484047016, -111.974716186523, -1.95432747644102, 218, 52, 'PPL', 'P'),
(190390, 'Lakeridge', 39.0363883972168, 0.681313505618745, -119.947219848633, -2.09347391497214, 218, 39, 'PPL', 'P'),
(207861, 'Lakeridge', 47.5066719055176, 0.82914784141597, -122.24333190918, -2.13354863042343, 218, 56, 'PPL', 'P'),
(113618, 'Lakeridge Heights', 41.5219383239746, 0.724694535563373, -72.6355590820313, -1.26772966000832, 218, 8, 'PPL', 'P'),
(182658, 'Lakeridge Oaks', 38.7119407653809, 0.67565082619291, -121.108329772949, -2.11373910612904, 218, 6, 'PPL', 'P'),
(16826, 'Lakes by the Bay', 25.5719394683838, 0.446314539843986, -80.3255615234375, -1.40194552209726, 218, 12, 'PPL', 'P'),
(123011, 'Lakes of the Four Seasons', 41.4102783203125, 0.72274570085668, -87.2130584716797, -1.52215502106514, 218, 19, 'PPL', 'P'),
(55782, 'Lakeshire', 38.5386085510254, 0.672625608352634, -90.3349990844727, -1.57664316381011, 218, 29, 'PPL', 'P'),
(88391, 'Lakeshor Manor', 35.1202812194824, 0.612964541506298, -85.1630630493164, -1.48637585129409, 218, 50, 'PPL', 'P'),
(36786, 'Lakeshore', 37.1341705322266, 0.648113540784409, -87.6994400024414, -1.53064398019783, 218, 21, 'PPL', 'P'),
(41693, 'Lakeshore', 32.5349998474121, 0.567842869473194, -92.0294418334961, -1.60621676876711, 218, 22, 'PPL', 'P'),
(60551, 'Lakeshore', 30.2463893890381, 0.527899081678991, -89.4358291625977, -1.56094968813849, 218, 30, 'PPL', 'P'),
(193720, 'Lakeshore', 40.8800010681152, 0.71349061685741, -122.387496948242, -2.13606478502134, 218, 6, 'PPL', 'P'),
(207862, 'Lakeshore', 45.6902809143066, 0.797445838115776, -122.694442749023, -2.14142199987014, 218, 56, 'PPL', 'P'),
(22503, 'Lakeshore Estates', 33.0400009155273, 0.576656800837893, -85.1386108398438, -1.48594907972941, 218, 13, 'PPL', 'P'),
(88393, 'Lakeshore Estates', 35.1230583190918, 0.613013011038137, -85.1558303833008, -1.48624961745842, 218, 50, 'PPL', 'P'),
(88394, 'Lakeshore Gardens', 36.1733283996582, 0.631343681979207, -83.4263916015625, -1.45606521650541, 218, 50, 'PPL', 'P'),
(95532, 'Lakeshore Gardens', 28.1291694641113, 0.490946623000192, -97.8694381713867, -1.70814393316772, 218, 51, 'PPL', 'P'),
(95533, 'Lakeshore Gardens Number 1 Colonia', 28.1280002593994, 0.490926216528339, -97.8679962158203, -1.70811876629542, 218, 51, 'PPL', 'P'),
(95534, 'Lakeshore Gardens Number 2 Colonia', 28.1299991607666, 0.490961103938619, -97.8649978637695, -1.70806643518, 218, 51, 'PPL', 'P'),
(41695, 'Lakeshore North', 32.5369415283203, 0.567876758198065, -93.9013900756836, -1.63888842902021, 218, 22, 'PPL', 'P'),
(156067, 'Lakeshore Park', 40.464168548584, 0.706232970254726, -81.1691665649414, -1.41666920765792, 218, 41, 'PPL', 'P'),
(195207, 'Lakeshore Summer Home Area', 44.646110534668, 0.779221627039282, -115.660827636719, -2.01866225784239, 218, 17, 'PPL', 'P'),
(196861, 'Lakeshore Summer Home Area', 44.7388916015625, 0.780840962140105, -111.212219238281, -1.94101939415779, 218, 31, 'PPL', 'P'),
(9950, 'Lakeside', 34.9700012207031, 0.610341660727706, -90.6222229003906, -1.58165616508802, 218, 4, 'PPL', 'P'),
(16828, 'Lakeside', 30.3758296966553, 0.530158241231705, -84.3008270263672, -1.47132699376433, 218, 12, 'PPL', 'P'),
(22507, 'Lakeside', 33.5494384765625, 0.585548163611286, -83.9352798461914, -1.46494699189888, 218, 13, 'PPL', 'P'),
(41697, 'Lakeside', 30.3622207641602, 0.529920720551983, -91.1016693115234, -1.59002408354916, 218, 22, 'PPL', 'P'),
(48790, 'Lakeside', 39.4555587768555, 0.688629408870275, -76.5377807617188, -1.33583627646157, 218, 25, 'PPL', 'P'),
(55784, 'Lakeside', 38.2077789306641, 0.666851542214206, -92.6194381713867, -1.61651414743801, 218, 29, 'PPL', 'P'),
(60553, 'Lakeside', 34.1611099243164, 0.596223844315032, -89.8086090087891, -1.56745592383961, 218, 30, 'PPL', 'P'),
(66205, 'Lakeside', 35.3611106872559, 0.61716780865477, -80.258056640625, -1.40076733963101, 218, 33, 'PPL', 'P'),
(76325, 'Lakeside', 33.9550018310547, 0.592626579472608, -96.5516662597656, -1.68514447451963, 218, 42, 'PPL', 'P'),
(81957, 'Lakeside', 34.4883308410645, 0.60193492669368, -81.9613876342773, -1.43049607372151, 218, 48, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(88396, 'Lakeside', 35.7102813720703, 0.623261986756225, -84.7519378662109, -1.47920036321104, 218, 50, 'PPL', 'P'),
(103461, 'Lakeside', 37.6074981689453, 0.656374666485834, -77.4772186279297, -1.35223256034486, 218, 53, 'PPL', 'P'),
(113620, 'Lakeside', 41.4330596923828, 0.723143310807429, -73.2266693115234, -1.27804647975517, 218, 8, 'PPL', 'P'),
(116384, 'Lakeside', 42.6213912963867, 0.743883609902803, -95.1730575561523, -1.66108321354493, 218, 16, 'PPL', 'P'),
(123012, 'Lakeside', 40.9341697692871, 0.714436039044388, -86.7377777099609, -1.51385980690177, 218, 19, 'PPL', 'P'),
(125192, 'Lakeside', 41.851390838623, 0.730444566672963, -70.9097213745117, -1.23760810965703, 218, 23, 'PPL', 'P'),
(131667, 'Lakeside', 42.564998626709, 0.742899372142937, -82.8391723632813, -1.44581630736635, 218, 27, 'PPL', 'P'),
(136374, 'Lakeside', 44.834171295166, 0.782503906503777, -94.5588912963867, -1.65036399015736, 218, 28, 'PPL', 'P'),
(144033, 'Lakeside', 43.4102783203125, 0.757652285896567, -72.0316696166992, -1.25718980052016, 218, 36, 'PPL', 'P'),
(145563, 'Lakeside', 41.1816711425781, 0.718755752911523, -74.3363876342773, -1.29741471825694, 218, 37, 'PPL', 'P'),
(150143, 'Lakeside', 43.2555618286133, 0.754951973709281, -77.3386077880859, -1.34981334481063, 218, 40, 'PPL', 'P'),
(156068, 'Lakeside', 41.5430603027344, 0.725063183637267, -82.7491683959961, -1.44424544179737, 218, 41, 'PPL', 'P'),
(163520, 'Lakeside', 41.8572196960449, 0.730546299426604, -75.658332824707, -1.32048701436084, 218, 45, 'PPL', 'P'),
(172184, 'Lakeside', 44.2516708374023, 0.772337355621427, -72.2627792358398, -1.2612234243072, 218, 55, 'PPL', 'P'),
(182661, 'Lakeside', 32.8572196960449, 0.573466666747114, -116.92138671875, -2.04066316423976, 218, 6, 'PPL', 'P'),
(186955, 'Lakeside', 39.7772216796875, 0.694243485606216, -105.055282592773, -1.83356057785698, 218, 7, 'PPL', 'P'),
(191719, 'Lakeside', 31.746940612793, 0.554088641128344, -106.39778137207, -1.85699160175972, 218, 51, 'PPL', 'P'),
(196864, 'Lakeside', 48.0752792358398, 0.839071911481069, -104.177223205566, -1.81823555052218, 218, 31, 'PPL', 'P'),
(199463, 'Lakeside', 42.0558280944824, 0.734012669901451, -102.424438476563, -1.78764368592238, 218, 35, 'PPL', 'P'),
(201099, 'Lakeside', 43.5758285522461, 0.760541682521248, -124.173889160156, -2.16724321085122, 218, 43, 'PPL', 'P'),
(204614, 'Lakeside', 41.2224998474121, 0.719468348240201, -112.864723205566, -1.96986102928918, 218, 52, 'PPL', 'P'),
(207863, 'Lakeside', 47.8355598449707, 0.834888018829527, -120.049171447754, -2.09525330605447, 218, 56, 'PPL', 'P'),
(55785, 'Lakeside (historical)', 38.4527816772461, 0.671127646818492, -90.3402786254883, -1.57673530918383, 218, 29, 'PPL', 'P'),
(3617, 'Lakeside Acres', 34.8722190856934, 0.608635040522156, -87.559440612793, -1.52820052989768, 218, 2, 'PPL', 'P'),
(32972, 'Lakeside Acres', 37.7188911437988, 0.65831884066062, -97.1902770996094, -1.69629033631383, 218, 20, 'PPL', 'P'),
(81960, 'Lakeside Acres', 33.4708290100098, 0.584176169596704, -80.7980575561523, -1.41019213357074, 218, 48, 'PPL', 'P'),
(204616, 'Lakeside Acres', 41.1855583190918, 0.718823596940293, -112.105560302734, -1.95661113707577, 218, 52, 'PPL', 'P'),
(116385, 'Lakeside Acres Mobile Park', 43.1236114501953, 0.752649005156635, -93.3841705322266, -1.62986124503122, 218, 16, 'PPL', 'P'),
(95538, 'Lakeside City', 33.8286094665527, 0.590420616562668, -98.5449981689453, -1.71993467941988, 218, 51, 'PPL', 'P'),
(95539, 'Lakeside Colonia', 26.2240009307861, 0.457695159288276, -98.359001159668, -1.71668841920913, 218, 51, 'PPL', 'P'),
(81961, 'Lakeside Estates', 34.7527809143066, 0.606550451178896, -82.9513931274414, -1.44777492919005, 218, 48, 'PPL', 'P'),
(88397, 'Lakeside Estates', 35.267219543457, 0.615529099057017, -86.146110534668, -1.50353326661693, 218, 50, 'PPL', 'P'),
(14070, 'Lakeside Estates Mobile Home Park', 38.6288909912109, 0.674201334190607, -75.5919418334961, -1.31932827297055, 218, 10, 'PPL', 'P'),
(182662, 'Lakeside Farms', 32.8669395446777, 0.573636310108552, -116.939170837402, -2.04097355566481, 218, 6, 'PPL', 'P'),
(16829, 'Lakeside Green', 26.7388896942139, 0.466681663491612, -80.1147232055664, -1.39826569926104, 218, 12, 'PPL', 'P'),
(22509, 'Lakeside Grove', 33.3797187805176, 0.582585996109818, -83.8530578613281, -1.46351194754549, 218, 13, 'PPL', 'P'),
(95540, 'Lakeside Heights', 30.6884307861328, 0.535614159488409, -98.4121170043945, -1.71761546558458, 218, 51, 'PPL', 'P'),
(3618, 'Lakeside Highlands', 34.8113899230957, 0.607573371353596, -87.6186065673828, -1.52923317061036, 218, 2, 'PPL', 'P'),
(22512, 'Lakeside Hills', 34.0597190856934, 0.594454240349702, -84.5441665649414, -1.47557406991273, 218, 13, 'PPL', 'P'),
(103462, 'Lakeside Homes', 37.1433296203613, 0.648273397028841, -76.4497222900391, -1.33429936619648, 218, 53, 'PPL', 'P'),
(127910, 'Lakeside Landing', 44.9302787780762, 0.784181298516364, -68.8066711425781, -1.20090295877496, 218, 26, 'PPL', 'P'),
(14071, 'Lakeside Manor', 38.5625, 0.673042592800313, -75.5625, -1.31881441603822, 218, 10, 'PPL', 'P'),
(48792, 'Lakeside Mews', 38.6252784729004, 0.674138283851799, -76.9305572509766, -1.34269151942354, 218, 25, 'PPL', 'P'),
(22513, 'Lakeside Mobile Home Park', 33.7880592346191, 0.589712881502979, -84.6822204589844, -1.47798356490898, 218, 13, 'PPL', 'P'),
(81962, 'Lakeside Mobile Home Park', 34.7527809143066, 0.606550451178896, -82.9322204589844, -1.44744030299908, 218, 48, 'PPL', 'P'),
(103463, 'Lakeside Mobile Home Park', 38.4988899230957, 0.671932387520887, -78.0408325195313, -1.36206947846328, 218, 53, 'PPL', 'P'),
(22514, 'Lakeside Park', 31.9983291625977, 0.558476199024249, -81.0666732788086, -1.41488036235372, 218, 13, 'PPL', 'P'),
(36780, 'Lakeside Park', 39.0355606079102, 0.681299057969831, -84.5691680908203, -1.47601042885734, 218, 21, 'PPL', 'P'),
(88399, 'Lakeside Park', 35.1902809143066, 0.614186266656371, -85.1672210693359, -1.4864484224338, 218, 50, 'PPL', 'P'),
(103464, 'Lakeside Park', 36.728889465332, 0.641040051771104, -76.5988922119141, -1.33690287247814, 218, 53, 'PPL', 'P'),
(123014, 'Lakeside Park', 41.5875015258789, 0.725838829304753, -85.195556640625, -1.48694297144823, 218, 19, 'PPL', 'P'),
(145564, 'Lakeside Park', 40.1927795410156, 0.701496338518938, -74.6875, -1.30354278508326, 218, 37, 'PPL', 'P'),
(150146, 'Lakeside Park', 42.5086097717285, 0.741915200962098, -77.1569366455078, -1.34664258521678, 218, 40, 'PPL', 'P'),
(182663, 'Lakeside Park', 34.2280616760254, 0.597392372822332, -118.64582824707, -2.07076034666707, 218, 6, 'PPL', 'P'),
(48793, 'Lakeside Park South', 39.6144409179688, 0.69140242535532, -75.9558334350586, -1.32567937953817, 218, 25, 'PPL', 'P'),
(196865, 'Lakeside Plaza Mobile Home Park', 48.5341682434082, 0.847081035564346, -109.703330993652, -1.91468432624438, 218, 31, 'PPL', 'P'),
(192664, 'Lakeside Resort', 38.5352783203125, 0.672567484861843, -111.737777709961, -1.95019211990035, 218, 52, 'PPL', 'P'),
(125193, 'Lakeside Shore', 41.7949981689453, 0.729460328913097, -70.9319381713867, -1.23799586591174, 218, 23, 'PPL', 'P'),
(9951, 'Lakeside Terrace', 36.389720916748, 0.635120443879103, -92.3061065673828, -1.61104547929759, 218, 4, 'PPL', 'P'),
(182664, 'Lakeside Terrace', 38.2516708374023, 0.667617600501767, -120.319999694824, -2.09998015067326, 218, 6, 'PPL', 'P'),
(32973, 'Lakeside Village', 39.1752815246582, 0.68373764800099, -95.4211120605469, -1.66541258137101, 218, 20, 'PPL', 'P'),
(66208, 'Lakeside Village', 35.3186111450195, 0.616426051712155, -78.5941696166992, -1.37172703268229, 218, 33, 'PPL', 'P'),
(76326, 'Lakeside Village', 34.7983283996582, 0.607345404764285, -98.3847198486328, -1.71713729501086, 218, 42, 'PPL', 'P'),
(95541, 'Lakeside Village', 32.0208282470703, 0.558868882126981, -97.4936065673828, -1.7015844342448, 218, 51, 'PPL', 'P'),
(103465, 'Lakeside Village', 37.663330078125, 0.657349117128694, -78.1786117553711, -1.36447417976957, 218, 53, 'PPL', 'P'),
(103466, 'Lakeside Village Mobile Home Park', 36.7438888549805, 0.641301840506258, -77.5308303833008, -1.35316826199386, 218, 53, 'PPL', 'P'),
(113621, 'Lakeside Woods', 41.5658302307129, 0.725460593850934, -73.4916687011719, -1.28267159162031, 218, 8, 'PPL', 'P'),
(88401, 'Lakesite', 35.208610534668, 0.614506178882317, -85.1269378662109, -1.48574534790602, 218, 50, 'PPL', 'P'),
(48794, 'Lakesville', 38.3486099243164, 0.669309506742295, -76.1413879394531, -1.32891791658176, 218, 25, 'PPL', 'P'),
(36781, 'Laketon', 36.8633308410645, 0.643386496428545, -89.1016693115234, -1.55511749850927, 218, 21, 'PPL', 'P'),
(123015, 'Laketon', 40.9741706848145, 0.715134186724152, -85.8358306884766, -1.49811786169831, 218, 19, 'PPL', 'P'),
(131668, 'Laketon', 46.3427810668945, 0.8088341141482, -85.7483291625977, -1.4965906719712, 218, 27, 'PPL', 'P'),
(163521, 'Laketon', 41.3655586242676, 0.721965194920205, -76.0580596923828, -1.32746356431047, 218, 45, 'PPL', 'P'),
(191720, 'Laketon', 35.5436096191406, 0.620353015897532, -100.632499694824, -1.75636845418687, 218, 51, 'PPL', 'P'),
(163522, 'Laketon Heights', 40.4638900756836, 0.706228109985736, -79.8552780151367, -1.39373752645958, 218, 45, 'PPL', 'P'),
(204618, 'Laketown', 41.8255615234375, 0.72999376007944, -111.321670532227, -1.9429296796077, 218, 52, 'PPL', 'P'),
(3622, 'Lakeview', 34.3302803039551, 0.599176424436576, -86.3222198486328, -1.50660695398904, 218, 2, 'PPL', 'P'),
(9954, 'Lakeview', 35.1338882446289, 0.613202028896505, -93.023063659668, -1.62355874115349, 218, 4, 'PPL', 'P'),
(16830, 'Lakeview', 26.2991695404053, 0.459007099020276, -80.1602783203125, -1.39906078600448, 218, 12, 'PPL', 'P'),
(22518, 'Lakeview', 32.5777816772461, 0.568589553263825, -83.7497177124023, -1.46170832169723, 218, 13, 'PPL', 'P'),
(27665, 'Lakeview', 38.7988891601563, 0.677168361961064, -90.0827789306641, -1.57224109168626, 218, 18, 'PPL', 'P'),
(36782, 'Lakeview', 39.0386085510254, 0.681352254612606, -84.5286102294922, -1.4753025606396, 218, 21, 'PPL', 'P'),
(41701, 'Lakeview', 30.0044403076172, 0.52367627358602, -90.1080627441406, -1.57268237747889, 218, 22, 'PPL', 'P'),
(48796, 'Lakeview', 39.1305618286133, 0.682957142064515, -76.8736114501953, -1.34169762770472, 218, 25, 'PPL', 'P'),
(55788, 'Lakeview', 36.6966705322266, 0.640477725306933, -93.3686065673828, -1.62958960260003, 218, 29, 'PPL', 'P'),
(66212, 'Lakeview', 35.2436103820801, 0.615117041457354, -79.3088912963867, -1.38420127922822, 218, 33, 'PPL', 'P'),
(76328, 'Lakeview', 35.797779083252, 0.624789109904304, -97.4250030517578, -1.7003870770187, 218, 42, 'PPL', 'P'),
(81963, 'Lakeview', 34.0230598449707, 0.59381441589781, -80.9550018310547, -1.41293132790994, 218, 48, 'PPL', 'P'),
(88406, 'Lakeview', 36.5547218322754, 0.63800025312386, -86.809440612793, -1.51511056050772, 218, 50, 'PPL', 'P'),
(103469, 'Lakeview', 38.788330078125, 0.676984071213631, -77.6147232055664, -1.35463246796118, 218, 53, 'PPL', 'P'),
(123016, 'Lakeview', 41.5458297729492, 0.725111520011052, -85.220832824707, -1.4873841240828, 218, 19, 'PPL', 'P'),
(125195, 'Lakeview', 42.2666702270508, 0.737692559316695, -71.7597198486328, -1.25244338166737, 218, 23, 'PPL', 'P'),
(131673, 'Lakeview', 43.4463882446289, 0.758282522968534, -85.274169921875, -1.48831503204183, 218, 27, 'PPL', 'P'),
(150149, 'Lakeview', 43.5127792358398, 0.759441264358828, -76.4252777099609, -1.33387272778985, 218, 40, 'PPL', 'P'),
(156072, 'Lakeview', 40.9980583190918, 0.715551104592804, -81.5236129760742, -1.42285546455407, 218, 41, 'PPL', 'P'),
(163523, 'Lakeview', 41.8638916015625, 0.730662746145268, -75.6180572509766, -1.31978407299111, 218, 45, 'PPL', 'P'),
(174889, 'Lakeview', 42.9752807617188, 0.750060146260969, -89.371940612793, -1.55983462259008, 218, 57, 'PPL', 'P'),
(177322, 'Lakeview', 42.3069381713867, 0.738395367528367, -95.0513916015625, -1.65895974204975, 218, 16, 'PPL', 'P'),
(178503, 'Lakeview', 34.9091682434082, 0.609279924980118, -111.446388244629, -1.94510641432468, 218, 5, 'PPL', 'P'),
(182669, 'Lakeview', 32.8427810668945, 0.573214665128966, -116.903327941895, -2.04034797912475, 218, 6, 'PPL', 'P'),
(190391, 'Lakeview', 39.2083282470703, 0.684314422114074, -119.804443359375, -2.09098199514015, 218, 39, 'PPL', 'P'),
(191724, 'Lakeview', 34.5294418334961, 0.602652448870375, -101.919723510742, -1.77883474798473, 218, 51, 'PPL', 'P'),
(195208, 'Lakeview', 47.9702796936035, 0.837239323755958, -116.445556640625, -2.03235836269645, 218, 17, 'PPL', 'P'),
(201100, 'Lakeview', 42.1888885498047, 0.736335012951028, -120.344718933105, -2.10041158276985, 218, 43, 'PPL', 'P'),
(202290, 'Lakeview', 43.1036109924316, 0.752299931316753, -100.747779846191, -1.75838047239043, 218, 49, 'PPL', 'P'),
(204619, 'Lakeview', 40.2580604553223, 0.702635705412301, -111.711669921875, -1.94973645303784, 218, 52, 'PPL', 'P'),
(207865, 'Lakeview', 47.1594390869141, 0.823087485460359, -122.496940612793, -2.1379749373132, 218, 56, 'PPL', 'P'),
(209876, 'Lakeview', 44.8047218322754, 0.781989916413392, -111.23999786377, -1.94150422263424, 218, 31, 'PPL', 'P'),
(174890, 'Lakeview (historical)', 43.8972206115723, 0.766151032146255, -91.2627792358398, -1.59283598218612, 218, 57, 'PPL', 'P'),
(190392, 'Lakeview (historical)', 39.2449989318848, 0.684954446303047, -117.530563354492, -2.05129530225968, 218, 39, 'PPL', 'P'),
(196867, 'Lakeview (historical)', 48.0027809143066, 0.837806577068145, -106.497222900391, -1.85872718384212, 218, 31, 'PPL', 'P'),
(9955, 'Lakeview Acres', 35.1277809143066, 0.613095435873875, -92.4283294677734, -1.61317867133074, 218, 4, 'PPL', 'P'),
(27666, 'Lakeview Acres', 38.7125015258789, 0.675660613309916, -89.9527816772461, -1.56997221159557, 218, 18, 'PPL', 'P'),
(36783, 'Lakeview Acres', 38.0080604553223, 0.663365797242429, -84.4824981689453, -1.47449775335818, 218, 21, 'PPL', 'P'),
(73153, 'Lakeview Acres', 39.9483299255371, 0.697229887873604, -83.6627807617188, -1.46019098566616, 218, 41, 'PPL', 'P'),
(81965, 'Lakeview Acres', 34.9741706848145, 0.610414431604492, -81.0500030517578, -1.41458941200463, 218, 48, 'PPL', 'P'),
(95547, 'Lakeview Assembly', 31.6583309173584, 0.552542110193821, -95.6858291625977, -1.67003276638814, 218, 51, 'PPL', 'P'),
(95548, 'Lakeview Colonia', 26.2469997406006, 0.458096564243578, -98.4820022583008, -1.71883519336384, 218, 51, 'PPL', 'P'),
(204621, 'Lakeview Condominium', 41.0886116027832, 0.717131557541711, -112.019721984863, -1.95511297580454, 218, 52, 'PPL', 'P'),
(204622, 'Lakeview Condominiums of Bountiful', 40.8902816772461, 0.713670047335854, -111.888061523438, -1.95281506725797, 218, 52, 'PPL', 'P'),
(3628, 'Lakeview Estates', 33.4524993896484, 0.583856257370759, -86.8030624389648, -1.51499924037416, 218, 2, 'PPL', 'P'),
(14072, 'Lakeview Estates', 38.5763893127441, 0.673285007038538, -75.3433303833008, -1.31498918460648, 218, 10, 'PPL', 'P'),
(16831, 'Lakeview Estates', 29.6283302307129, 0.517111914394111, -82.2886123657227, -1.43620722267918, 218, 12, 'PPL', 'P'),
(22520, 'Lakeview Estates', 33.7066688537598, 0.588292351377531, -84.0316696166992, -1.46662931075948, 218, 13, 'PPL', 'P'),
(66215, 'Lakeview Estates', 35.3333282470703, 0.616682913599293, -82.4274978637695, -1.43863123190337, 218, 33, 'PPL', 'P'),
(88407, 'Lakeview Estates', 35.8630599975586, 0.625928476797667, -83.9622192382813, -1.46541717298933, 218, 50, 'PPL', 'P'),
(95549, 'Lakeview Estates', 30.201940536499, 0.527123302853451, -94.0738906860352, -1.64189913263254, 218, 51, 'PPL', 'P'),
(103470, 'Lakeview Estates', 38.7869415283203, 0.676959836447711, -77.6094436645508, -1.35454032258746, 218, 53, 'PPL', 'P'),
(22523, 'Lakeview Heights', 30.8108291625977, 0.537750414156816, -83.3088912963867, -1.454014449308, 218, 13, 'PPL', 'P'),
(32974, 'Lakeview Heights', 37.6694412231445, 0.657455776730352, -97.1350021362305, -1.69532560620895, 218, 20, 'PPL', 'P'),
(36784, 'Lakeview Heights', 38.1513900756836, 0.665867371033367, -83.5044403076172, -1.45742742340299, 218, 21, 'PPL', 'P'),
(55789, 'Lakeview Heights', 38.2588882446289, 0.667743568021328, -93.1561126708984, -1.62588088446599, 218, 29, 'PPL', 'P'),
(81967, 'Lakeview Heights', 34.9183311462402, 0.609439847803578, -82.2333297729492, -1.43524235941624, 218, 48, 'PPL', 'P'),
(103472, 'Lakeview Heights', 36.726390838623, 0.640996442508254, -76.6002807617188, -1.33692710724406, 218, 53, 'PPL', 'P'),
(125197, 'Lakeview Heights', 42.0433311462402, 0.733794557008174, -71.8249969482422, -1.25358268198171, 218, 23, 'PPL', 'P'),
(163524, 'Lakeview Heights', 40.2808303833008, 0.703033115625968, -76.8108291625977, -1.34060187007421, 218, 45, 'PPL', 'P'),
(3633, 'Lakeview Highlands', 34.7872200012207, 0.607151526636927, -87.6033325195313, -1.52896658818524, 218, 2, 'PPL', 'P'),
(182670, 'Lakeview Hot Springs', 33.8383293151855, 0.590590259924106, -117.144721984863, -2.04456109996925, 218, 6, 'PPL', 'P'),
(193721, 'Lakeview Junction', 41.4761085510254, 0.723894655129968, -120.536666870117, -2.10376170626311, 218, 6, 'PPL', 'P'),
(81969, 'Lakeview Manor', 35.0344390869141, 0.611466313656046, -81.883056640625, -1.42912893997591, 218, 48, 'PPL', 'P'),
(88409, 'Lakeview Manor', 36.2622184753418, 0.632895106472233, -88.1069412231445, -1.53775621820499, 218, 50, 'PPL', 'P'),
(22525, 'Lakeview Meadows', 33.1380615234375, 0.578368281312432, -84.9797210693359, -1.48317593008631, 218, 13, 'PPL', 'P'),
(116386, 'Lakeview Mobile Home Court', 42.6444396972656, 0.744285880385459, -91.9094390869141, -1.60412232572782, 218, 16, 'PPL', 'P'),
(81970, 'Lakeview Mobile Home Park', 34.9908294677734, 0.610705182216502, -81.9966735839844, -1.43111192972359, 218, 48, 'PPL', 'P'),
(136378, 'Lakeview Mobile Home Park', 43.5638885498047, 0.76033329016595, -93.4222183227539, -1.63052530424903, 218, 28, 'PPL', 'P'),
(204628, 'Lakeview Mobile Home Park', 41.101390838623, 0.717354597283006, -111.962219238281, -1.95410936354775, 218, 52, 'PPL', 'P'),
(199464, 'Lakeview Mobile Park', 41.6652793884277, 0.727196309091393, -103.098609924316, -1.79941019740862, 218, 35, 'PPL', 'P'),
(81971, 'Lakeview Of Lawton Bluff', 32.7483291625977, 0.571566168414207, -79.9413909912109, -1.39524048142076, 218, 48, 'PPL', 'P'),
(3635, 'Lakeview Park', 33.4516716003418, 0.583841809721845, -86.8161087036133, -1.51522694064736, 218, 2, 'PPL', 'P'),
(41703, 'Lakeview Park', 32.5586090087891, 0.568254927072857, -92.0144424438477, -1.60595498003196, 218, 22, 'PPL', 'P'),
(103473, 'Lakeview Park', 36.8894386291504, 0.643842163291058, -76.1508331298828, -1.32908276625323, 218, 53, 'PPL', 'P'),
(207866, 'Lakeview Park', 47.3766708374023, 0.82687889474625, -119.50666809082, -2.08578483627286, 218, 56, 'PPL', 'P'),
(188838, 'Lakeview Pines', 36.5086097717285, 0.637195445842438, -105.303062438965, -1.83788515199311, 218, 38, 'PPL', 'P'),
(193722, 'Lakeview Resort', 40.8144416809082, 0.712346389695057, -122.290832519531, -2.13437767247077, 218, 6, 'PPL', 'P'),
(103474, 'Lakeview Shores', 36.8883285522461, 0.643822788794127, -76.1416702270508, -1.32892284342977, 218, 53, 'PPL', 'P'),
(123017, 'Lakeview Spring', 41.2863883972168, 0.720583413788618, -85.6880569458008, -1.49553872334062, 218, 19, 'PPL', 'P'),
(71009, 'Lakeview Terrace', 39.7050018310547, 0.692983011462282, -74.2777786254883, -1.29639179808224, 218, 37, 'PPL', 'P'),
(81972, 'Lakeview Terrace', 33.976390838623, 0.59299988807841, -81.1500015258789, -1.41633471462501, 218, 48, 'PPL', 'P'),
(125198, 'Lakeview Terrace', 42.4916687011719, 0.741619523502072, -73.2405624389648, -1.27828896057243, 218, 23, 'PPL', 'P'),
(204631, 'Lakeview Terrace Condominium', 40.8791694641113, 0.713476102629469, -111.84944152832, -1.95214102118607, 218, 52, 'PPL', 'P'),
(48797, 'Lakeview Trailer Park', 39.4486083984375, 0.688508101882621, -76.9261093139648, -1.34261388827776, 218, 25, 'PPL', 'P'),
(178504, 'Lakeview Trailer Park', 33.6647186279297, 0.587560181814841, -111.133613586426, -1.93964746672223, 218, 5, 'PPL', 'P'),
(16832, 'Lakeville', 26.7605590820313, 0.467059865655917, -81.9236068725586, -1.4298366750356, 218, 12, 'PPL', 'P'),
(36785, 'Lakeville', 37.7188911437988, 0.65831884066062, -83.0711135864258, -1.44986444538133, 218, 21, 'PPL', 'P'),
(113622, 'Lakeville', 41.9644393920898, 0.732417636145575, -73.440559387207, -1.28177956581319, 218, 8, 'PPL', 'P'),
(123018, 'Lakeville', 41.5244407653809, 0.72473821140525, -86.2733306884766, -1.50575367717578, 218, 19, 'PPL', 'P'),
(125199, 'Lakeville', 41.8458290100098, 0.73034749445123, -70.9499969482422, -1.23831105102676, 218, 23, 'PPL', 'P'),
(131674, 'Lakeville', 42.8213882446289, 0.74737421514357, -83.1502838134766, -1.45124622651291, 218, 27, 'PPL', 'P'),
(136380, 'Lakeville', 44.6497192382813, 0.779284610799062, -93.2425003051758, -1.62738863311714, 218, 28, 'PPL', 'P'),
(150152, 'Lakeville', 41.1972198486328, 0.719027129026602, -74.2608337402344, -1.29609605404319, 218, 40, 'PPL', 'P'),
(156077, 'Lakeville', 40.6561088562012, 0.709582960589936, -82.1272201538086, -1.4333903971942, 218, 41, 'PPL', 'P'),
(163526, 'Lakeville', 41.438060760498, 0.723230595912156, -75.2769393920898, -1.31383044321619, 218, 45, 'PPL', 'P'),
(182672, 'Lakeville', 38.1991691589355, 0.666701273349698, -122.546112060547, -2.13883314097448, 218, 6, 'PPL', 'P'),
(103475, 'Lakeville Estates', 36.8186111450195, 0.64260599049207, -76.2033309936523, -1.32999902682628, 218, 53, 'PPL', 'P'),
(9956, 'Lakeway', 36.3386116027832, 0.634228418071981, -92.7683334350586, -1.61911286002971, 218, 4, 'PPL', 'P'),
(95550, 'Lakeway', 30.3677806854248, 0.530017759484203, -97.9913864135742, -1.71027233151091, 218, 51, 'PPL', 'P'),
(14073, 'Lakewind', 39.0319404602051, 0.681235874472969, -75.5124969482422, -1.317941698149, 218, 10, 'PPL', 'P'),
(14074, 'Lakewind III', 39.0341682434082, 0.681274756624885, -75.5111083984375, -1.31791746338308, 218, 10, 'PPL', 'P'),
(3640, 'Lakewood', 34.7794418334961, 0.60701577200036, -86.5877838134766, -1.51124191955022, 218, 2, 'PPL', 'P'),
(9957, 'Lakewood', 34.7944412231445, 0.607277560735515, -92.2438888549805, -1.60995957536311, 218, 4, 'PPL', 'P'),
(14076, 'Lakewood', 38.9077796936035, 0.679068860293972, -75.4555587768555, -1.31694793958823, 218, 10, 'PPL', 'P'),
(16834, 'Lakewood', 30.9883308410645, 0.540848402873878, -86.2819366455078, -1.50590387946126, 218, 12, 'PPL', 'P'),
(22527, 'Lakewood', 34.8888893127441, 0.608925990871247, -84.2613906860352, -1.4706386997806, 218, 13, 'PPL', 'P'),
(48799, 'Lakewood', 38.336669921875, 0.669101114386996, -75.6011123657227, -1.31948832895206, 218, 25, 'PPL', 'P'),
(66218, 'Lakewood', 35.2936096191406, 0.615989692767546, -82.4894409179688, -1.43971234214789, 218, 33, 'PPL', 'P'),
(81980, 'Lakewood', 35.0208282470703, 0.611228759686811, -81.0449981689453, -1.41450206032087, 218, 48, 'PPL', 'P'),
(88414, 'Lakewood', 36.0133285522461, 0.628551157839177, -84.0319366455078, -1.46663397129139, 218, 50, 'PPL', 'P'),
(95551, 'Lakewood', 30.1283302307129, 0.525838560654083, -93.977783203125, -1.64022174061995, 218, 51, 'PPL', 'P'),
(103483, 'Lakewood', 36.7197189331055, 0.64087999578959, -76.6447219848633, -1.33770275291155, 218, 53, 'PPL', 'P'),
(113623, 'Lakewood', 41.579719543457, 0.725703008089159, -73.0302810668945, -1.27461885827419, 218, 8, 'PPL', 'P'),
(116388, 'Lakewood', 41.5016708374023, 0.724340801191583, -93.6738891601563, -1.63491778899295, 218, 16, 'PPL', 'P'),
(120294, 'Lakewood', 42.2291717529297, 0.737038087478808, -88.3550033569336, -1.54208571918913, 218, 18, 'PPL', 'P'),
(123019, 'Lakewood', 40.6863899230957, 0.710111464908262, -86.7597198486328, -1.51424276946652, 218, 19, 'PPL', 'P'),
(125201, 'Lakewood', 42.4494400024414, 0.740882493670392, -73.2263870239258, -1.27804155290716, 218, 23, 'PPL', 'P'),
(127913, 'Lakewood', 44.8313903808594, 0.782455370392911, -69.7786102294922, -1.21786649597043, 218, 26, 'PPL', 'P'),
(131678, 'Lakewood', 43.3766708374023, 0.757065724666477, -86.2363891601563, -1.50510892587587, 218, 27, 'PPL', 'P'),
(136382, 'Lakewood', 46.8638916015625, 0.817929208744984, -91.9625015258789, -1.6050484399969, 218, 28, 'PPL', 'P'),
(145565, 'Lakewood', 40.0977783203125, 0.699838254424255, -74.2180633544922, -1.29534956998964, 218, 37, 'PPL', 'P'),
(150153, 'Lakewood', 42.1041717529297, 0.734856425913816, -79.3333282470703, -1.3846277844768, 218, 40, 'PPL', 'P'),
(156078, 'Lakewood', 41.4819412231445, 0.723996454462636, -81.7983322143555, -1.42765021978065, 218, 41, 'PPL', 'P'),
(163528, 'Lakewood', 41.8519401550293, 0.730454154052887, -75.3816680908203, -1.31565830383036, 218, 45, 'PPL', 'P'),
(169454, 'Lakewood', 41.7591705322266, 0.728835018689146, -71.4088897705078, -1.24632024168906, 218, 47, 'PPL', 'P'),
(174891, 'Lakewood', 45.3008308410645, 0.790648652065567, -88.5233306884766, -1.54502358534565, 218, 57, 'PPL', 'P'),
(182673, 'Lakewood', 33.8536109924316, 0.590856975507277, -118.133056640625, -2.06181079382386, 218, 6, 'PPL', 'P'),
(186956, 'Lakewood', 39.704719543457, 0.692978084614265, -105.080833435059, -1.83400652418152, 218, 7, 'PPL', 'P'),
(201101, 'Lakewood', 45.4130592346191, 0.79260740704732, -122.665000915527, -2.14090814293781, 218, 43, 'PPL', 'P'),
(204632, 'Lakewood', 40.651668548584, 0.709505462602215, -111.845283508301, -1.95206845004636, 218, 52, 'PPL', 'P'),
(207870, 'Lakewood', 48.1522216796875, 0.840414810460741, -122.206108093262, -2.13289895227551, 218, 56, 'PPL', 'P'),
(41704, 'Lakewood (historical)', 30.4955596923828, 0.532247923870549, -90.4958267211914, -1.57945013559905, 218, 22, 'PPL', 'P'),
(116389, 'Lakewood (historical)', 43.3472213745117, 0.756551734576091, -96.1624984741211, -1.67835221531744, 218, 16, 'PPL', 'P'),
(81983, 'Lakewood Acres', 35.0130615234375, 0.611093204787326, -81.0444412231445, -1.41449233978289, 218, 48, 'PPL', 'P'),
(103485, 'Lakewood Acres', 39.3141708374023, 0.686161723804207, -78.3166732788086, -1.36688380792387, 218, 53, 'PPL', 'P'),
(131679, 'Lakewood Club', 43.3711090087891, 0.756968652444743, -86.2602767944336, -1.50552584374453, 218, 27, 'PPL', 'P'),
(116390, 'Lakewood Corner', 43.3461112976074, 0.756532360079161, -96.1758270263672, -1.67858484243865, 218, 16, 'PPL', 'P'),
(145566, 'Lakewood Corner Estates', 40.0311088562012, 0.698674652764972, -74.2297210693359, -1.29555303549692, 218, 37, 'PPL', 'P'),
(41706, 'Lakewood Country Club Estates', 29.9027805328369, 0.521901975799269, -90.0063934326172, -1.57090791324457, 218, 22, 'PPL', 'P'),
(14077, 'Lakewood Development', 38.9072189331055, 0.679059073176966, -75.4519424438477, -1.3168848226704, 218, 10, 'PPL', 'P'),
(3643, 'Lakewood Estate', 33.3813896179199, 0.582615157723755, -86.9763870239258, -1.51802432505638, 218, 2, 'PPL', 'P'),
(3644, 'Lakewood Estates', 31.1827793121338, 0.544242168919507, -85.4241714477539, -1.49093305255144, 218, 2, 'PPL', 'P'),
(9958, 'Lakewood Estates', 33.4244384765625, 0.583366502046293, -93.9561080932617, -1.63984343858711, 218, 4, 'PPL', 'P'),
(16836, 'Lakewood Estates', 27.7275009155273, 0.483936184325694, -82.6675033569336, -1.44282011798196, 218, 12, 'PPL', 'P'),
(48802, 'Lakewood Estates', 39.0805587768555, 0.682084424175296, -77.204719543457, -1.34747655411214, 218, 25, 'PPL', 'P'),
(66221, 'Lakewood Estates', 35.3047218322754, 0.616183637473931, -78.0280609130859, -1.36184657188004, 218, 33, 'PPL', 'P'),
(88415, 'Lakewood Estates', 36.2569389343262, 0.632802961098516, -83.2705612182617, -1.45334546324217, 218, 50, 'PPL', 'P'),
(103487, 'Lakewood Estates', 38.7427787780762, 0.676189051049215, -77.3533325195313, -1.35007033985582, 218, 53, 'PPL', 'P'),
(112374, 'Lakewood Estates', 32.5622215270996, 0.568317977411664, -91.9863891601563, -1.60546535786555, 218, 22, 'PPL', 'P'),
(174892, 'Lakewood Estates', 43.7886085510254, 0.764255394082336, -89.0141677856445, -1.55359030878217, 218, 57, 'PPL', 'P'),
(103488, 'Lakewood Forest', 36.6183280944824, 0.639110391824259, -79.9677810668945, -1.39570107513129, 218, 53, 'PPL', 'P'),
(95552, 'Lakewood Harbor', 31.9036102294922, 0.556823041777582, -97.4194412231445, -1.70029000479696, 218, 51, 'PPL', 'P'),
(22529, 'Lakewood Heights', 33.704719543457, 0.588258329494605, -84.3786087036133, -1.47268454013, 218, 13, 'PPL', 'P'),
(81984, 'Lakewood Heights', 34.214168548584, 0.59714989200508, -82.2155609130859, -1.43493223430731, 218, 48, 'PPL', 'P'),
(95554, 'Lakewood Heights', 28.1025009155273, 0.490481169020673, -97.8630599975586, -1.70803261303415, 218, 51, 'PPL', 'P'),
(182674, 'Lakewood Highlands', 38.0547218322754, 0.664180191903775, -120.217781066895, -2.09819609905901, 218, 6, 'PPL', 'P'),
(3646, 'Lakewood Hills', 33.4441719055176, 0.583710915354268, -86.8108291625977, -1.51513479527364, 218, 2, 'PPL', 'P'),
(30285, 'Lakewood Hills', 38.0022201538086, 0.663263864751706, -87.5136108398438, -1.52740064946427, 218, 19, 'PPL', 'P'),
(81985, 'Lakewood Hills', 34.9663887023926, 0.610278610388898, -82.2055587768555, -1.43475766409785, 218, 48, 'PPL', 'P'),
(16838, 'Lakewood Park', 27.4811096191406, 0.479635844955489, -80.3744430541992, -1.40279866575246, 218, 12, 'PPL', 'P'),
(116391, 'Lakewood Park', 41.5791702270508, 0.725693420709234, -90.6763916015625, -1.582601587275, 218, 16, 'PPL', 'P'),
(125202, 'Lakewood Park', 42.5291709899902, 0.742274061918986, -71.8791732788086, -1.25452823732674, 218, 23, 'PPL', 'P'),
(140356, 'Lakewood Park', 48.0716705322266, 0.839008927721288, -98.9291687011719, -1.72663972009637, 218, 34, 'PPL', 'P'),
(182675, 'Lakewood Park', 38.0516700744629, 0.664126928681973, -120.212501525879, -2.09810395368529, 218, 6, 'PPL', 'P'),
(66222, 'Lakewood Pines', 35.5855598449707, 0.621085185460222, -77.3816680908203, -1.35056488887025, 218, 33, 'PPL', 'P'),
(120296, 'Lakewood Shores', 41.2816696166992, 0.720501055531907, -88.1447219848633, -1.5384156168909, 218, 18, 'PPL', 'P'),
(182676, 'Lakewood Sierra', 38.7402801513672, 0.676145441786365, -120.568061828613, -2.1043096516574, 218, 6, 'PPL', 'P'),
(88416, 'Lakewood Village', 35.6761093139648, 0.622665571830102, -84.7980575561523, -1.48000530365051, 218, 50, 'PPL', 'P'),
(95555, 'Lakewood Village', 33.1425018310547, 0.578445779300154, -96.9691696166992, -1.69243128273625, 218, 51, 'PPL', 'P'),
(41708, 'Lakewood Village Mobile Home Park', 32.4180603027344, 0.565801889392785, -93.7605590820313, -1.63643046449212, 218, 22, 'PPL', 'P'),
(110012, 'Lakin', 38.958610534668, 0.679956025832105, -82.0872192382813, -1.43269224951444, 218, 58, 'PPL', 'P'),
(187754, 'Lakin', 37.940559387207, 0.662187681355205, -101.254440307617, -1.76722336563198, 218, 20, 'PPL', 'P'),
(193723, 'Lakin', 41.3783302307129, 0.722188101503445, -121.561111450195, -2.12164163718969, 218, 6, 'PPL', 'P'),
(116392, 'Lakonta', 41.1933288574219, 0.718959218418806, -92.7302780151367, -1.61844866765385, 218, 16, 'PPL', 'P'),
(103489, 'Lakota', 38.5827789306641, 0.673396526909185, -77.8783264160156, -1.35923321190235, 218, 53, 'PPL', 'P'),
(116393, 'Lakota', 43.3772201538086, 0.757075312046401, -94.0936126708984, -1.64224334620343, 218, 16, 'PPL', 'P'),
(140357, 'Lakota', 48.042781829834, 0.838504724747909, -98.3358306884766, -1.7162840181976, 218, 34, 'PPL', 'P'),
(204634, 'Lakota', 41.9858283996582, 0.732790944751377, -111.407783508301, -1.94443263456889, 218, 52, 'PPL', 'P'),
(207871, 'Lakota', 47.3330612182617, 0.826117763306705, -122.371109008789, -2.13577876152026, 218, 56, 'PPL', 'P'),
(202291, 'Lakota Homes', 44.1083297729492, 0.769835582093407, -103.218063354492, -1.80149505306799, 218, 49, 'PPL', 'P'),
(210545, 'Lalakoa', 20.8255596160889, 0.363474583871117, -156.912216186523, -2.73863480905597, 218, 15, 'PPL', 'P'),
(123020, 'Lalimere', 41.7172203063965, 0.728102849126456, -86.7002792358398, -1.51320533506388, 218, 19, 'PPL', 'P'),
(140360, 'Lallie', 47.978328704834, 0.83737980550346, -99.2155609130859, -1.73163820714634, 218, 34, 'PPL', 'P'),
(178495, 'LaLoma Ranch', 33.5133285522461, 0.584917926539319, -112.358612060547, -1.96102772342755, 218, 5, 'PPL', 'P'),
(188839, 'Lama', 36.6497192382813, 0.639658270639516, -105.617782592773, -1.84337805489945, 218, 38, 'PPL', 'P'),
(188824, 'LaMadera', 36.3869400024414, 0.635071907768236, -106.040832519531, -1.85076166902169, 218, 38, 'PPL', 'P'),
(95562, 'Laman', 32.9850006103516, 0.575696864422974, -94.6544418334961, -1.65203166163197, 218, 51, 'PPL', 'P'),
(182677, 'Lamanda Park', 34.1480598449707, 0.595996077462803, -118.093063354492, -2.06111277930215, 218, 6, 'PPL', 'P'),
(244, 'Lamar', 33.396671295166, 0.582881873306926, -85.3952789306641, -1.49042878299903, 218, 2, 'PPL', 'P'),
(9959, 'Lamar', 35.440559387207, 0.618554450055347, -93.3877792358398, -1.629924228791, 218, 4, 'PPL', 'P'),
(22532, 'Lamar', 32.0161094665527, 0.558786523870271, -84.0719375610352, -1.46733211897115, 218, 13, 'PPL', 'P'),
(30286, 'Lamar', 38.0691719055176, 0.664432393259005, -86.9055633544922, -1.51678821883642, 218, 19, 'PPL', 'P'),
(32977, 'Lamar', 39.2561111450195, 0.685148391009432, -97.5744400024414, -1.70299524383227, 218, 20, 'PPL', 'P'),
(41709, 'Lamar', 32.3105583190918, 0.563925625825797, -91.540283203125, -1.59767934010259, 218, 22, 'PPL', 'P'),
(55790, 'Lamar', 37.4949989318848, 0.654411184393146, -94.2763900756836, -1.64543341371518, 218, 29, 'PPL', 'P'),
(60562, 'Lamar', 34.9172210693359, 0.609420473306647, -89.3177795410156, -1.55888933356115, 218, 30, 'PPL', 'P'),
(76329, 'Lamar', 35.0994415283203, 0.61260082028042, -96.1272201538086, -1.67773649247341, 218, 42, 'PPL', 'P'),
(81986, 'Lamar', 34.1686096191406, 0.59635473868261, -80.0627822875977, -1.39735915922598, 218, 48, 'PPL', 'P'),
(95558, 'Lamar', 31.7986106872559, 0.554990454052472, -94.2441711425781, -1.64487108725101, 218, 51, 'PPL', 'P'),
(110013, 'Lamar', 37.4538917541504, 0.653693728795479, -81.3050003051758, -1.41903995366031, 218, 58, 'PPL', 'P'),
(163529, 'Lamar', 41.0161094665527, 0.71586615654976, -77.5313873291016, -1.35317798253183, 218, 45, 'PPL', 'P'),
(174894, 'Lamar', 45.4258308410645, 0.79283031363056, -92.5699996948242, -1.61565128324483, 218, 57, 'PPL', 'P'),
(186957, 'Lamar', 38.0872192382813, 0.664747378636935, -102.620277404785, -1.79106172002344, 218, 7, 'PPL', 'P'),
(199465, 'Lamar', 40.5719413757324, 0.708113960932649, -101.978057861328, -1.77985287446946, 218, 35, 'PPL', 'P'),
(207872, 'Lamar', 46.2900009155273, 0.807912926727142, -118.507217407227, -2.06834113113284, 218, 56, 'PPL', 'P'),
(55791, 'Lamar Heights', 37.4936103820801, 0.654386949627227, -94.2975006103516, -1.645801862052, 218, 29, 'PPL', 'P'),
(60564, 'Lamar Park', 31.3191699981689, 0.546622635459875, -89.3602828979492, -1.55963115708279, 218, 30, 'PPL', 'P'),
(95560, 'Lamar Terrace', 29.7313899993896, 0.518910646683864, -95.4680633544922, -1.66623203603843, 218, 51, 'PPL', 'P'),
(22534, 'Lamara Heights', 32.0333290100098, 0.559087061599286, -81.1036071777344, -1.41552498049557, 218, 13, 'PPL', 'P'),
(9962, 'Lamartine', 33.3930587768555, 0.582818822968118, -93.2886123657227, -1.62819344039856, 218, 4, 'PPL', 'P'),
(163531, 'Lamartine', 41.2224998474121, 0.719468348240201, -79.6341705322266, -1.389878472882, 218, 45, 'PPL', 'P'),
(174895, 'Lamartine', 43.7333297729492, 0.763290597398428, -88.5686111450195, -1.54581387839914, 218, 57, 'PPL', 'P'),
(186958, 'Lamartine', 39.7294387817383, 0.693409516710858, -105.616111755371, -1.84334889328551, 218, 7, 'PPL', 'P'),
(22535, 'Lamarville', 32.0336112976074, 0.559091988447303, -81.1486129760742, -1.41631047985909, 218, 13, 'PPL', 'P'),
(36787, 'Lamasco', 36.9861106872559, 0.645529408999677, -87.9361114501953, -1.53477467620659, 218, 21, 'PPL', 'P'),
(95561, 'Lamasco', 33.6949996948242, 0.588088686133167, -96.0663909912109, -1.67667482330485, 218, 51, 'PPL', 'P'),
(14078, 'Lamatan I', 39.7611083984375, 0.693962255795104, -75.7444381713867, -1.32198983616397, 218, 10, 'PPL', 'P'),
(14079, 'Lamatan II', 39.7625007629395, 0.693986557140051, -75.7494430541992, -1.32207718784773, 218, 10, 'PPL', 'P'),
(27669, 'Lamb', 37.5316696166992, 0.65505120858212, -88.1247177124023, -1.53806647647199, 218, 18, 'PPL', 'P'),
(30287, 'Lamb', 38.6919403076172, 0.675301752353028, -85.1880569458008, -1.48681207708065, 218, 19, 'PPL', 'P'),
(36789, 'Lamb', 36.7586097717285, 0.641558768972424, -85.899169921875, -1.4992233398668, 218, 21, 'PPL', 'P'),
(55793, 'Lamb', 39.7411117553711, 0.693613248534249, -91.3866729736328, -1.59499833583321, 218, 29, 'PPL', 'P'),
(88417, 'Lamb', 35.9447212219238, 0.62735373403405, -86.4961090087891, -1.5096418923673, 218, 50, 'PPL', 'P'),
(194281, 'Lamb', 40.2449989318848, 0.70240773882299, -103.847221374512, -1.81247593203266, 218, 7, 'PPL', 'P'),
(9964, 'Lamb (historical)', 34.2675018310547, 0.59808073338509, -92.0694427490234, -1.60691491644688, 218, 4, 'PPL', 'P'),
(156080, 'Lamb Corners', 40.1069412231445, 0.699998177247714, -83.192497253418, -1.45198299002848, 218, 41, 'PPL', 'P'),
(195209, 'Lamb Creek', 48.5163917541504, 0.846770777297352, -116.926391601563, -2.04075051592351, 218, 17, 'PPL', 'P'),
(48803, 'Lamb Knolls', 39.4269409179688, 0.68812993300783, -77.6266708374023, -1.35484099347453, 218, 25, 'PPL', 'P'),
(127914, 'Lamb Place', 45.2502784729004, 0.789766346796424, -67.5233306884766, -1.17850444242685, 218, 26, 'PPL', 'P'),
(22536, 'Lamb Town', 32.0286102294922, 0.559004703342575, -83.7155609130859, -1.46111217308722, 218, 13, 'PPL', 'P'),
(76330, 'Lamberson', 34.7947196960449, 0.607282421004504, -95.0133285522461, -1.65829541651583, 218, 42, 'PPL', 'P'),
(3649, 'Lambert', 31.0277805328369, 0.541536929884205, -88.1933288574219, -1.53926396685614, 218, 2, 'PPL', 'P'),
(9966, 'Lambert', 34.3080596923828, 0.598788601602833, -93.2063903808594, -1.62675839604517, 218, 4, 'PPL', 'P'),
(55794, 'Lambert', 37.0927810668945, 0.647391158338725, -89.5538864135742, -1.56301017587389, 218, 29, 'PPL', 'P'),
(60565, 'Lambert', 34.2016716003418, 0.596931779111803, -90.283332824707, -1.57574141746501, 218, 30, 'PPL', 'P'),
(66224, 'Lambert', 35.3133316040039, 0.616333906338439, -80.3597183227539, -1.40254167070727, 218, 33, 'PPL', 'P'),
(76331, 'Lambert', 36.6830596923828, 0.640240171337698, -98.4227828979492, -1.71780162054478, 218, 42, 'PPL', 'P'),
(81987, 'Lambert', 33.3258285522461, 0.581645434191829, -79.5725021362305, -1.38880215632744, 218, 48, 'PPL', 'P'),
(88418, 'Lambert', 35.3127784729004, 0.616324252379487, -89.4844436645508, -1.56179817126179, 218, 50, 'PPL', 'P'),
(112520, 'Lambert', 39.913330078125, 0.696619025298567, -79.8722229003906, -1.39403327049863, 218, 45, 'PPL', 'P'),
(131680, 'Lambert', 45.8397216796875, 0.800054071508372, -87.0950012207031, -1.52009453332975, 218, 27, 'PPL', 'P'),
(196868, 'Lambert', 47.6836090087891, 0.832235976436999, -104.620277404785, -1.82596830506333, 218, 31, 'PPL', 'P'),
(207873, 'Lambert', 45.7797203063965, 0.799006849988726, -122.68083190918, -2.14118444590091, 218, 56, 'PPL', 'P'),
(209556, 'Lambert', 41.6208305358887, 0.726420530265853, -105.121673583984, -1.83471931924728, 218, 59, 'PPL', 'P'),
(182678, 'Lambert (historical)', 38.3205604553223, 0.668819951154911, -121.501388549805, -2.12059927593903, 218, 6, 'PPL', 'P'),
(3650, 'Lambert Grove', 31.0433292388916, 0.541808305999284, -88.1572189331055, -1.53863372978417, 218, 2, 'PPL', 'P'),
(127915, 'Lambert Lake', 45.5458297729492, 0.794924690090825, -67.5274963378906, -1.1785771467246, 218, 26, 'PPL', 'P'),
(182679, 'Lambert Lake Estates', 37.9605598449707, 0.662536755195087, -120.33332824707, -2.10021277779447, 218, 6, 'PPL', 'P'),
(9967, 'Lamberton', 33.1241683959961, 0.578125800495181, -92.6666717529297, -1.61733852895345, 218, 4, 'PPL', 'P'),
(110014, 'Lamberton', 39.2708282470703, 0.68540525289657, -81.0469436645508, -1.41453601562477, 218, 58, 'PPL', 'P'),
(136386, 'Lamberton', 44.2311096191406, 0.771978494664539, -95.2638931274414, -1.66266859334185, 218, 28, 'PPL', 'P'),
(150154, 'Lamberton', 42.4124984741211, 0.740237742370484, -79.3949966430664, -1.38570410103135, 218, 40, 'PPL', 'P'),
(163532, 'Lamberton', 40.6391716003418, 0.709287349708937, -76.4941711425781, -1.33507514502202, 218, 45, 'PPL', 'P'),
(9968, 'Lamberts (historical)', 34.2249984741211, 0.597338909863448, -91.9097213745117, -1.60412725257584, 218, 4, 'PPL', 'P'),
(48804, 'Lamberts Acres', 39.5472183227539, 0.690229169737085, -77.2750015258789, -1.34870320611023, 218, 25, 'PPL', 'P'),
(207874, 'Lamberts Corner', 47.0036087036133, 0.820367732197115, -122.96443939209, -2.14613433026098, 218, 56, 'PPL', 'P'),
(125203, 'Lamberts Cove', 41.438060760498, 0.723230595912156, -70.6677780151367, -1.2333854014326, 218, 23, 'PPL', 'P'),
(103491, 'Lamberts Point', 36.8808288574219, 0.64369189442655, -76.3080596923828, -1.33182688744045, 218, 53, 'PPL', 'P'),
(60566, 'Lamberts Store', 31.4894409179688, 0.54959442363078, -90.2275009155273, -1.57476696682215, 218, 30, 'PPL', 'P'),
(103492, 'Lamberts Store', 37.1311111450195, 0.648060144404553, -81.6958312988281, -1.42586124131839, 218, 53, 'PPL', 'P'),
(163535, 'Lambertsville', 40.0741691589355, 0.699426196824592, -78.913330078125, -1.37729743357636, 218, 45, 'PPL', 'P'),
(131682, 'Lambertville', 41.7658309936523, 0.728951265670728, -83.628059387207, -1.45958498336011, 218, 27, 'PPL', 'P'),
(145568, 'Lambertville', 40.3658294677734, 0.704516629511197, -74.9433288574219, -1.30800784096689, 218, 37, 'PPL', 'P'),
(14080, 'Lambeth Riding', 39.7652816772461, 0.694035093250917, -75.7027816772461, -1.32126279318638, 218, 10, 'PPL', 'P'),
(9969, 'Lambethville', 35.3786087036133, 0.617473206652775, -90.1813888549805, -1.57396215954073, 218, 4, 'PPL', 'P'),
(163533, 'Lambings', 40.5883293151855, 0.708399984433723, -79.5216674804688, -1.38791492421028, 218, 45, 'PPL', 'P'),
(48805, 'Lambourne Downs', 39.5188903808594, 0.689734753880712, -76.6847229003906, -1.33840090059131, 218, 25, 'PPL', 'P'),
(36790, 'Lambric', 37.5686111450195, 0.655695959882028, -83.1305618286133, -1.45090201294202, 218, 21, 'PPL', 'P'),
(81988, 'Lambrick', 33.3061103820801, 0.581301287199964, -80.7347183227539, -1.40908665540225, 218, 48, 'PPL', 'P'),
(22537, 'Lambright', 31.5125007629395, 0.549996893850519, -82.3444366455078, -1.43718154016399, 218, 13, 'PPL', 'P'),
(9970, 'Lambrook', 34.3355598449707, 0.599268569810293, -90.9674987792969, -1.58768236600265, 218, 4, 'PPL', 'P'),
(81989, 'Lambs', 32.8863906860352, 0.57397579656851, -80.0680618286133, -1.39745130459969, 218, 48, 'PPL', 'P'),
(103493, 'Lambs', 36.9913902282715, 0.645621554373394, -77.2566680908203, -1.34838322730526, 218, 53, 'PPL', 'P'),
(131683, 'Lambs', 42.9327812194824, 0.749318389318355, -82.7083282470703, -1.44353264673161, 218, 27, 'PPL', 'P'),
(66229, 'Lambs Corner', 36.3797187805176, 0.634945873669648, -76.2222213745117, -1.33032872616923, 218, 33, 'PPL', 'P'),
(127919, 'Lambs Corner', 44.5027809143066, 0.776720053248343, -69.559440612793, -1.2140412645387, 218, 26, 'PPL', 'P'),
(150156, 'Lambs Corner', 42.8183288574219, 0.747320818763713, -78.0772171020508, -1.36270450922521, 218, 40, 'PPL', 'P'),
(103494, 'Lambs Creek', 38.2636108398438, 0.667825992857066, -77.2694396972656, -1.3486061338885, 218, 53, 'PPL', 'P'),
(163534, 'Lambs Creek', 41.8441696166992, 0.730318532574375, -77.0988922119141, -1.34562951873811, 218, 45, 'PPL', 'P'),
(116394, 'Lambs Grove', 41.7030601501465, 0.727855707777297, -93.0791702270508, -1.62453798548631, 218, 16, 'PPL', 'P'),
(125204, 'Lambs Grove', 42.2750015258789, 0.737837967912214, -71.9683303833008, -1.25608432235167, 218, 23, 'PPL', 'P'),
(71010, 'Lambs Terrace', 39.7705612182617, 0.694127238624634, -75.0430603027344, -1.30974848305537, 218, 37, 'PPL', 'P'),
(103495, 'Lambsburg', 36.5852813720703, 0.638533617711176, -80.7613906860352, -1.4095521759608, 218, 53, 'PPL', 'P'),
(48806, 'Lambson', 39.3108291625977, 0.686103400576334, -75.8899993896484, -1.32453035868585, 218, 25, 'PPL', 'P'),
(22538, 'Lambville (historical)', 30.8150005340576, 0.537823218323116, -83.9036102294922, -1.46439425281463, 218, 13, 'PPL', 'P'),
(196869, 'Lame Deer', 45.6230583190918, 0.796272582497542, -106.666107177734, -1.86167477053662, 218, 31, 'PPL', 'P'),
(36791, 'Lamero', 37.3008308410645, 0.65102231190602, -84.1605606079102, -1.46887888293227, 218, 21, 'PPL', 'P'),
(191726, 'Lamesa', 32.7374992370605, 0.571377150555838, -101.950561523438, -1.77937297284103, 218, 51, 'PPL', 'P'),
(55796, 'Lamine', 38.9466705322266, 0.679747633476806, -92.8744430541992, -1.62096482225175, 218, 29, 'PPL', 'P'),
(145570, 'Lamington', 40.660831451416, 0.709665385425674, -74.7177810668945, -1.30407128940159, 218, 37, 'PPL', 'P'),
(156081, 'Lamira', 40.024169921875, 0.6985535455144, -80.9880599975586, -1.41350830176011, 218, 41, 'PPL', 'P'),
(3651, 'Lamison', 32.1211090087891, 0.560619111595381, -87.5666732788086, -1.52832676373335, 218, 2, 'PPL', 'P'),
(22539, 'Lamkin', 33.5141716003418, 0.584932640504341, -82.0977783203125, -1.43287654026187, 218, 13, 'PPL', 'P'),
(41710, 'Lamkin', 32.5825004577637, 0.568671911520536, -92.0727767944336, -1.6069731065167, 218, 22, 'PPL', 'P'),
(60567, 'Lamkin', 33.0424995422363, 0.576700410100743, -90.4655609130859, -1.57892189759684, 218, 30, 'PPL', 'P'),
(95563, 'Lamkin', 31.8230590820313, 0.55541715903813, -98.2638931274414, -1.71502847090168, 218, 51, 'PPL', 'P'),
(66226, 'Lamm', 35.7636108398438, 0.624192761557208, -78.0097198486328, -1.36152645991702, 218, 33, 'PPL', 'P'),
(66227, 'Lamm Crossroads', 35.9094390869141, 0.626737944610997, -78.0666732788086, -1.36252048479389, 218, 33, 'PPL', 'P'),
(66228, 'Lamms Crossroads', 35.6749992370605, 0.622646197333172, -78.0374984741211, -1.36201128839346, 218, 33, 'PPL', 'P'),
(116353, 'LaMoille', 42.0305595397949, 0.733571650424934, -93.038330078125, -1.62382519042055, 218, 16, 'PPL', 'P'),
(136390, 'Lamoille', 44.0022201538086, 0.767983619871366, -91.4722213745117, -1.59649143709836, 218, 28, 'PPL', 'P'),
(200040, 'Lamoille', 40.7280616760254, 0.710838774201963, -115.477500915527, -2.01546260295072, 218, 39, 'PPL', 'P'),
(193724, 'Lamoine', 40.9780616760254, 0.715202097331949, -122.429718017578, -2.13680168169496, 218, 6, 'PPL', 'P'),
(207875, 'Lamoine', 47.728889465332, 0.83302626949048, -119.897216796875, -2.09260119708292, 218, 56, 'PPL', 'P'),
(127916, 'Lamoine Beach', 44.4505615234375, 0.775808652944291, -68.2927780151367, -1.19193383169773, 218, 26, 'PPL', 'P'),
(127917, 'Lamoine Corner', 44.4777793884277, 0.776283694303734, -68.345832824707, -1.19285981280875, 218, 26, 'PPL', 'P'),
(207876, 'Lamona', 47.3594398498535, 0.826578157280153, -118.481391906738, -2.06789039111835, 218, 56, 'PPL', 'P'),
(163536, 'Lamonaville', 41.4700012207031, 0.723788062107337, -79.0266723632813, -1.37927562963407, 218, 45, 'PPL', 'P'),
(13141, 'Lamond Riggs', 38.9663887023926, 0.680091780468671, -77.0077819824219, -1.34403934525123, 218, 9, 'PPL', 'P'),
(120298, 'Lamone Village', 40.4769401550293, 0.706455876837965, -90.6913909912109, -1.58286337601015, 218, 18, 'PPL', 'P'),
(123021, 'Lamong', 40.0855598449707, 0.699625001799966, -86.2033309936523, -1.50453195202571, 218, 19, 'PPL', 'P'),
(116395, 'Lamoni', 40.6227798461914, 0.709001259628836, -93.9338912963867, -1.63945568233239, 218, 16, 'PPL', 'P'),
(9971, 'Lamont', 34.0999984741211, 0.595157248298456, -92.2750015258789, -1.61050259390938, 218, 4, 'PPL', 'P'),
(16839, 'Lamont', 30.3769397735596, 0.530177615728635, -83.8130569458008, -1.46281379986573, 218, 12, 'PPL', 'P'),
(32978, 'Lamont', 38.1124992370605, 0.665188597850533, -96.0263900756836, -1.67597667562509, 218, 20, 'PPL', 'P'),
(36793, 'Lamont', 37.3497200012207, 0.651875588719282, -83.313606262207, -1.45409674098568, 218, 21, 'PPL', 'P'),
(60568, 'Lamont', 33.5352783203125, 0.585301022262127, -91.0761108398438, -1.58957800406657, 218, 30, 'PPL', 'P'),
(76332, 'Lamont', 36.690559387207, 0.640371065705276, -97.5561065673828, -1.70267526502729, 218, 42, 'PPL', 'P'),
(88425, 'Lamont', 36.6241683959961, 0.639212324314982, -86.7572174072266, -1.51419909362464, 218, 50, 'PPL', 'P'),
(95564, 'Lamont', 30.6572208404541, 0.535069443176947, -94.9516677856445, -1.65721923311933, 218, 51, 'PPL', 'P'),
(116397, 'Lamont', 42.5986099243164, 0.743485999952054, -91.6419372558594, -1.5994535380208, 218, 16, 'PPL', 'P'),
(131684, 'Lamont', 43.0086097717285, 0.750641847222069, -85.9061126708984, -1.4993445136964, 218, 27, 'PPL', 'P'),
(150157, 'Lamont', 42.5913887023926, 0.743359965853466, -78.1063919067383, -1.36321370562563, 218, 40, 'PPL', 'P'),
(163537, 'Lamont', 41.6122207641602, 0.726270261401346, -78.8072204589844, -1.37544547135431, 218, 45, 'PPL', 'P'),
(174906, 'Lamont', 42.704719543457, 0.745337962174095, -89.9852828979492, -1.57053946490776, 218, 57, 'PPL', 'P'),
(182680, 'Lamont', 35.2597198486328, 0.615398204689439, -118.913330078125, -2.07542913437409, 218, 6, 'PPL', 'P'),
(195210, 'Lamont', 43.9697189331055, 0.767416366559179, -111.215278625488, -1.94107279053764, 218, 17, 'PPL', 'P'),
(199466, 'Lamont', 40.3208312988281, 0.703731263305732, -101.872779846191, -1.77801542647536, 218, 35, 'PPL', 'P'),
(207877, 'Lamont', 47.2016716003418, 0.823824581871065, -117.904167175293, -2.05781591903068, 218, 56, 'PPL', 'P'),
(209557, 'Lamont', 42.2205581665039, 0.736887752035273, -107.476387023926, -1.87581682171521, 218, 59, 'PPL', 'P'),
(211961, 'Lamont', 62.7066688537598, 1.09443783445589, -164.396392822266, -2.86925833315051, 218, 1, 'PPL', 'P'),
(3652, 'Lamont (historical)', 34.4716682434082, 0.601644109502643, -86.4305572509766, -1.508497798363, 218, 2, 'PPL', 'P'),
(9972, 'Lamont (historical)', 34.1055603027344, 0.595254320520189, -92.272216796875, -1.61045399121948, 218, 4, 'PPL', 'P'),
(22540, 'Lamont (historical)', 33.0052795410156, 0.576050798531845, -84.1208267211914, -1.46818539578442, 218, 13, 'PPL', 'P'),
(103496, 'Lamont Acres', 37.4797210693359, 0.654144535389002, -79.0894393920898, -1.38037112094847, 218, 53, 'PPL', 'P'),
(3653, 'Lamont Court', 31.2341709136963, 0.545139121574646, -85.4194412231445, -1.49085049455764, 218, 2, 'PPL', 'P'),
(201102, 'Lamonta (historical)', 44.4694404602051, 0.776138152550161, -121.034721374512, -2.11245439721919, 218, 43, 'PPL', 'P'),
(163538, 'Lamonts Corners', 41.2569389343262, 0.720069423698232, -80.4513931274414, -1.40414169789019, 218, 45, 'PPL', 'P'),
(88419, 'Lamontville', 35.3547210693359, 0.617056288784123, -84.8169403076172, -1.48033486983541, 218, 50, 'PPL', 'P'),
(150158, 'Lamoreaux Landing', 42.5752792358398, 0.743078802621381, -76.8763885498047, -1.34174609723656, 218, 40, 'PPL', 'P'),
(163539, 'Lamott', 40.0677795410156, 0.699314676953945, -75.1408309936523, -1.31145490352384, 218, 45, 'PPL', 'P'),
(55745, 'LaMotte', 39.5605583190918, 0.690461996595385, -91.179443359375, -1.59138149675677, 218, 29, 'PPL', 'P'),
(140344, 'LaMoure', 46.3572196960449, 0.809086115766349, -98.2941665649414, -1.71555684206195, 218, 34, 'PPL', 'P'),
(41711, 'Lamourie', 31.1316699981689, 0.543350143112385, -92.4116668701172, -1.61288785413971, 218, 22, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(193211, 'Lampa (historical)', 43.1152801513672, 0.752503596561117, -124.286109924316, -2.16920183267492, 218, 43, 'PPL', 'P'),
(22541, 'Lampadocia (historical)', 31.024169921875, 0.541473912834911, -81.6002807617188, -1.42419356984378, 218, 13, 'PPL', 'P'),
(95565, 'Lampasas', 31.0636100769043, 0.542162273397669, -98.1813888549805, -1.71358849970027, 218, 51, 'PPL', 'P'),
(55798, 'Lampe', 36.5636100769043, 0.638155382257357, -93.4377822875977, -1.63079694668022, 218, 29, 'PPL', 'P'),
(78581, 'Lampeter', 39.9900016784668, 0.697957197167304, -76.2399978637695, -1.33063898443622, 218, 45, 'PPL', 'P'),
(88421, 'Lampkin Bridge Estates', 35.8416709899902, 0.625555168191865, -86.7386093139648, -1.51387432112971, 218, 50, 'PPL', 'P'),
(182682, 'Lamplighter Mobile Home Park', 34.2119407653809, 0.597111009853165, -119.016937255859, -2.07723742075425, 218, 6, 'PPL', 'P'),
(116398, 'Lamplighter Villa', 42.5422210693359, 0.742501828771215, -92.4194412231445, -1.61302354219725, 218, 16, 'PPL', 'P'),
(22543, 'Lamplighter Village Mobile Home Park', 33.9027786254883, 0.591715112589528, -84.5999984741211, -1.47654852055559, 218, 13, 'PPL', 'P'),
(204635, 'Lampo Junction', 41.6363906860352, 0.726692106118014, -112.422782897949, -1.96214771582399, 218, 52, 'PPL', 'P'),
(144034, 'Lamprey Corners', 42.9183311462402, 0.749066187963124, -70.9302825927734, -1.23796697061392, 218, 36, 'PPL', 'P'),
(174898, 'Lampson', 45.9830589294434, 0.802555778457366, -91.8161087036133, -1.60249340324707, 218, 57, 'PPL', 'P'),
(60569, 'Lampton', 31.1930599212646, 0.544421599397951, -89.7980575561523, -1.56727176625023, 218, 30, 'PPL', 'P'),
(204636, 'Lampton', 40.5588912963867, 0.70788619408042, -111.90055847168, -1.95303318015124, 218, 52, 'PPL', 'P'),
(136391, 'Lamson', 44.9902801513672, 0.78522852003601, -94.2744369506836, -1.64539932525323, 218, 28, 'PPL', 'P'),
(150159, 'Lamson', 43.2174987792969, 0.754287648175361, -76.3702774047852, -1.33291279137493, 218, 40, 'PPL', 'P'),
(113624, 'Lamson Corner', 41.7425003051758, 0.728544068340055, -72.9716720581055, -1.27359593809949, 218, 8, 'PPL', 'P'),
(116399, 'Lamson Mobile Home Park', 41.3027801513672, 0.720869503868719, -92.6624984741211, -1.61726569149763, 218, 16, 'PPL', 'P'),
(188840, 'Lamy', 35.4813919067383, 0.619267111963052, -105.879173278809, -1.84794018300481, 218, 38, 'PPL', 'P'),
(55799, 'Lanagan', 36.6080589294434, 0.638931161082897, -94.4475021362305, -1.6484198825616, 218, 29, 'PPL', 'P'),
(182683, 'Lanaki Lane Mobile Home Park', 33.1080589294434, 0.577844637263096, -117.318893432617, -2.04760096519552, 218, 6, 'PPL', 'P'),
(481, 'Lanam', 39.2336082458496, 0.684755641327673, -86.3274993896484, -1.50669909936276, 218, 19, 'PPL', 'P'),
(182684, 'Lanare', 36.4305610656738, 0.635833238944862, -119.930000305176, -2.09317337724312, 218, 6, 'PPL', 'P'),
(9973, 'Lanark', 33.5311088562012, 0.58522825138534, -92.2644424438477, -1.61031830316195, 218, 4, 'PPL', 'P'),
(95567, 'Lanark', 33.1819381713867, 0.579134073283885, -94.149169921875, -1.64321300315633, 218, 51, 'PPL', 'P'),
(110015, 'Lanark', 37.8274993896484, 0.660214412145511, -81.1463928222656, -1.41627173086523, 218, 58, 'PPL', 'P'),
(120299, 'Lanark', 42.1022186279297, 0.734822337451863, -89.8333282470703, -1.5678873559362, 218, 18, 'PPL', 'P'),
(163550, 'Lanark', 40.5516700744629, 0.707760159981832, -75.4330596923828, -1.3165552564855, 218, 45, 'PPL', 'P'),
(188841, 'Lanark', 31.9699993133545, 0.557981749878362, -106.815826416016, -1.86428786419821, 218, 38, 'PPL', 'P'),
(195211, 'Lanark', 42.2816696166992, 0.73795434805185, -111.427780151367, -1.94478164182974, 218, 17, 'PPL', 'P'),
(196870, 'Lanark', 48.1430587768555, 0.840254887637282, -104.356941223145, -1.82137222165407, 218, 31, 'PPL', 'P'),
(16840, 'Lanark Village', 29.8833293914795, 0.521562489339311, -84.595832824707, -1.47647581625783, 218, 12, 'PPL', 'P'),
(88422, 'Lanatana Estates', 35.9055595397949, 0.626670233740281, -85.0666732788086, -1.48469353243349, 218, 50, 'PPL', 'P'),
(14081, 'Lancashire', 39.8188896179199, 0.694970728320889, -75.4905624389648, -1.3175588687423, 218, 10, 'PPL', 'P'),
(16841, 'Lancaster', 30.2488899230957, 0.527942724231354, -83.2030563354492, -1.45216728077592, 218, 12, 'PPL', 'P'),
(32979, 'Lancaster', 39.5727806091309, 0.690675315798701, -95.3024978637695, -1.66334237309764, 218, 20, 'PPL', 'P'),
(36794, 'Lancaster', 37.6194381713867, 0.656583058841133, -84.5780563354492, -1.47616555799084, 218, 21, 'PPL', 'P'),
(48807, 'Lancaster', 38.6272201538086, 0.67417217257667, -76.9361114501953, -1.34278845848722, 218, 25, 'PPL', 'P'),
(66231, 'Lancaster', 35.8580589294434, 0.62584119169294, -77.6933288574219, -1.35600439539674, 218, 33, 'PPL', 'P'),
(73155, 'Lancaster', 39.7136116027832, 0.693133280326789, -82.5994415283203, -1.44163221497773, 218, 41, 'PPL', 'P'),
(81990, 'Lancaster', 34.7202796936035, 0.605983197866709, -80.771110534668, -1.40972181932223, 218, 48, 'PPL', 'P'),
(88423, 'Lancaster', 36.127498626709, 0.630543801545802, -85.8541717529297, -1.49843797366133, 218, 50, 'PPL', 'P'),
(95568, 'Lancaster', 32.5919418334961, 0.568836694612984, -96.7558288574219, -1.68870778405815, 218, 51, 'PPL', 'P'),
(103498, 'Lancaster', 37.769718170166, 0.659205939619725, -76.466667175293, -1.33459511023553, 218, 53, 'PPL', 'P'),
(120300, 'Lancaster', 40.5802803039551, 0.708259502686221, -89.8372192382813, -1.567955266544, 218, 18, 'PPL', 'P'),
(123022, 'Lancaster', 40.7488899230957, 0.711202295690759, -85.5069427490234, -1.49237768428475, 218, 19, 'PPL', 'P'),
(125205, 'Lancaster', 42.4555587768555, 0.740989286430105, -71.6736068725586, -1.25094042670618, 218, 23, 'PPL', 'P'),
(136392, 'Lancaster', 48.8583297729492, 0.852738721563137, -96.8038864135742, -1.68954654664348, 218, 28, 'PPL', 'P'),
(139262, 'Lancaster', 40.5208282470703, 0.707221868546499, -92.5277786254883, -1.6149143865712, 218, 29, 'PPL', 'P'),
(144035, 'Lancaster', 44.4888916015625, 0.776477639010119, -71.5697174072266, -1.249127213478, 218, 36, 'PPL', 'P'),
(150160, 'Lancaster', 42.9005584716797, 0.748755996275157, -78.6705627441406, -1.37306034428204, 218, 40, 'PPL', 'P'),
(163540, 'Lancaster', 40.0377807617188, 0.698791099483635, -76.3058319091797, -1.33178800528854, 218, 45, 'PPL', 'P'),
(174900, 'Lancaster', 42.8474998474121, 0.747829948585109, -90.710563659668, -1.58319800220112, 218, 57, 'PPL', 'P'),
(178505, 'Lancaster', 34.3136100769043, 0.598885474087485, -111.714721679688, -1.94978971625964, 218, 5, 'PPL', 'P'),
(182685, 'Lancaster', 34.6980590820313, 0.605595375032967, -118.135833740234, -2.0618592633557, 218, 6, 'PPL', 'P'),
(201103, 'Lancaster', 44.253059387207, 0.772361590387347, -123.194442749023, -2.15014864613011, 218, 43, 'PPL', 'P'),
(207878, 'Lancaster', 47.0311088562012, 0.820847700404575, -117.663330078125, -2.05361251872416, 218, 56, 'PPL', 'P'),
(9974, 'Lancaster (historical)', 35.5702781677246, 0.62081846987705, -94.2272186279297, -1.64457521005391, 218, 4, 'PPL', 'P'),
(22544, 'Lancaster (historical)', 32.5050010681152, 0.567319292002884, -84.5263900756836, -1.47526381164574, 218, 13, 'PPL', 'P'),
(202293, 'Lancaster City (historical)', 44.3791694641113, 0.77456262644927, -103.773612976074, -1.81119122312281, 218, 49, 'PPL', 'P'),
(48808, 'Lancaster Corner', 39.5319404602051, 0.689962520732941, -76.4466705322266, -1.33424610297468, 218, 25, 'PPL', 'P'),
(14082, 'Lancaster Court', 39.7513885498047, 0.693792612433666, -75.5999984741211, -1.3194688878761, 218, 10, 'PPL', 'P'),
(66230, 'Lancaster Crossroads', 36.0625, 0.629409361500455, -78.0830612182617, -1.36280650829496, 218, 33, 'PPL', 'P'),
(48809, 'Lancaster Hill', 38.4761085510254, 0.671534777570138, -76.5138931274414, -1.33541935859291, 218, 25, 'PPL', 'P'),
(88424, 'Lancaster Hill', 36.1272201538086, 0.630538941276812, -85.8822174072266, -1.49892746266969, 218, 50, 'PPL', 'P'),
(163542, 'Lancaster Junction', 40.1313896179199, 0.700424882233372, -76.4024963378906, -1.3334751178391, 218, 45, 'PPL', 'P'),
(174901, 'Lancaster Junction', 42.9769401550293, 0.750089108137823, -90.6138916015625, -1.5815107564925, 218, 57, 'PPL', 'P'),
(81992, 'Lancaster Mill', 34.709171295166, 0.605789319739352, -80.7949981689453, -1.41013873719089, 218, 48, 'PPL', 'P'),
(30288, 'Lancaster Park', 39.2102813720703, 0.684348510576027, -86.5608291625977, -1.51077147214366, 218, 19, 'PPL', 'P'),
(14083, 'Lancaster Village', 39.7444381713867, 0.693671305446013, -75.5894393920898, -1.31928459712867, 218, 10, 'PPL', 'P'),
(163546, 'Lancasterville', 40.1180610656738, 0.700192255112153, -75.2483291625977, -1.3133311005118, 218, 45, 'PPL', 'P'),
(55800, 'Lance', 37.5858306884766, 0.655996497611043, -90.4530563354492, -1.57870365154551, 218, 29, 'PPL', 'P'),
(209558, 'Lance Creek', 43.0325012207031, 0.751058831669749, -104.641387939453, -1.82633675340014, 218, 59, 'PPL', 'P'),
(22547, 'Lance Mill', 34.9477806091309, 0.609953837893963, -84.1430587768555, -1.46857341835524, 218, 13, 'PPL', 'P'),
(88426, 'Lancelot Acres', 35.1836090087891, 0.614069819937708, -87.0536117553711, -1.51937215088407, 218, 50, 'PPL', 'P'),
(36795, 'Lancelot Estates', 38.1833305358887, 0.666424837228548, -84.6233291625977, -1.47695571788627, 218, 21, 'PPL', 'P'),
(36796, 'Lancer', 37.6669387817383, 0.657412100888475, -82.7369384765625, -1.444031989436, 218, 21, 'PPL', 'P'),
(88427, 'Lanceville', 35.936939239502, 0.627217912818456, -82.9069366455078, -1.44699901720645, 218, 50, 'PPL', 'P'),
(182690, 'Lancha Plana (historical)', 38.2247200012207, 0.667147219674232, -120.900833129883, -2.1101176065207, 218, 6, 'PPL', 'P'),
(88428, 'Lancing', 36.1205596923828, 0.63042269429523, -84.6538925170898, -1.47748914905261, 218, 50, 'PPL', 'P'),
(3654, 'Land', 32.0286102294922, 0.559004703342575, -88.3283309936523, -1.54162019863059, 218, 2, 'PPL', 'P'),
(22546, 'Land (historical)', 34.4430618286133, 0.601144833377281, -83.8069381713867, -1.46270700710601, 218, 13, 'PPL', 'P'),
(182686, 'Land (historical)', 39.5536117553711, 0.69034075618676, -121.466667175293, -2.11999327363298, 218, 6, 'PPL', 'P'),
(88429, 'Land Mark', 36.0374984741211, 0.628973002555846, -86.8194427490234, -1.51528513071718, 218, 50, 'PPL', 'P'),
(16842, 'Land O'' Lakes', 28.2186107635498, 0.492507668162655, -82.4577789306641, -1.4391597362217, 218, 12, 'PPL', 'P'),
(174903, 'Land O'' Lakes', 46.1613883972168, 0.805668214823341, -89.2186126708984, -1.55715854516871, 218, 57, 'PPL', 'P'),
(103500, 'Land O''Pines', 37.4308280944824, 0.653291191996713, -77.529167175293, -1.35313923353797, 218, 53, 'PPL', 'P'),
(22548, 'Land of Lakes', 34.0944404602051, 0.595060242655749, -84.5599975585938, -1.47585037287583, 218, 13, 'PPL', 'P'),
(145571, 'Land of Pines', 40.1580581665039, 0.70089033621289, -74.2291717529297, -1.29554344811699, 218, 37, 'PPL', 'P'),
(14084, 'Land of Pleasant Living', 38.5602798461914, 0.673003843806453, -75.1105575561523, -1.31092653236356, 218, 10, 'PPL', 'P'),
(48811, 'Land of Promise', 39.3388900756836, 0.6865931559008, -77.2977828979492, -1.34910081606098, 218, 25, 'PPL', 'P'),
(81993, 'Land of the Lakes', 33.9422187805176, 0.592403473152286, -81.2197189331055, -1.41755151292707, 218, 48, 'PPL', 'P'),
(48810, 'Land Tree', 38.7427787780762, 0.676189051049215, -76.7766723632813, -1.34000572146419, 218, 25, 'PPL', 'P'),
(48812, 'Land-O-Lakes', 38.3611106872559, 0.669527686214599, -76.6061096191406, -1.3370288399977, 218, 25, 'PPL', 'P'),
(22549, 'Land-O-Plenty Subdivision', 33.6019401550293, 0.586464490763355, -85.0983276367188, -1.48524600520163, 218, 13, 'PPL', 'P'),
(198501, 'Landa', 48.896671295166, 0.853407907366047, -100.911392211914, -1.76123604686926, 218, 34, 'PPL', 'P'),
(95570, 'Landa Park Highlands', 29.7194404602051, 0.518702087880997, -98.1397171020508, -1.71286119040657, 218, 51, 'PPL', 'P'),
(144037, 'Landaff Center', 44.1749992370605, 0.77099918375269, -71.8874969482422, -1.2546735127642, 218, 36, 'PPL', 'P'),
(182687, 'Landco', 35.3794403076172, 0.617487720880715, -119.060279846191, -2.07799389166189, 218, 6, 'PPL', 'P'),
(156082, 'Landeck', 40.8011093139648, 0.712113695994811, -84.3880615234375, -1.47284952295953, 218, 41, 'PPL', 'P'),
(73157, 'Landen', 39.311939239502, 0.686122775073265, -84.2830581665039, -1.47101686865539, 218, 41, 'PPL', 'P'),
(78582, 'Landenberg', 39.7772216796875, 0.694243485606216, -75.7716674804688, -1.3224650772605, 218, 45, 'PPL', 'P'),
(14085, 'Landenberg Junction', 39.730281829834, 0.693424230675881, -75.6191711425781, -1.31980351406707, 218, 10, 'PPL', 'P'),
(48813, 'Lander', 39.3088912963867, 0.68606957843049, -77.559440612793, -1.35366760469825, 218, 25, 'PPL', 'P'),
(163547, 'Lander', 41.9669418334961, 0.732461311987453, -79.2383270263672, -1.38296970038212, 218, 45, 'PPL', 'P'),
(209559, 'Lander', 42.8330612182617, 0.747577946966961, -108.730003356934, -1.89769655428298, 218, 59, 'PPL', 'P'),
(200041, 'Lander (historical)', 40.3330612182617, 0.703944715667102, -116.705558776855, -2.03689625603589, 218, 39, 'PPL', 'P'),
(200042, 'Lander City (historical)', 40.6925010681152, 0.71021812450992, -118.136390686035, -2.06186898389368, 218, 39, 'PPL', 'P'),
(182688, 'Lander Crossing', 39.0691719055176, 0.681885685778949, -120.977500915527, -2.11145571181041, 218, 6, 'PPL', 'P'),
(196871, 'Lander Crossing', 47.6430587768555, 0.83152824137731, -110.932502746582, -1.93613742040551, 218, 31, 'PPL', 'P'),
(191727, 'Landergin', 35.2694396972656, 0.615567848050877, -102.557502746582, -1.78996609555098, 218, 51, 'PPL', 'P'),
(32981, 'Landergin (historical)', 37.788890838623, 0.659540565810693, -96.3388900756836, -1.68143082953757, 218, 20, 'PPL', 'P'),
(9977, 'Landers', 35.5691719055176, 0.620799161959147, -90.6083297729492, -1.58141368427077, 218, 4, 'PPL', 'P'),
(182689, 'Landers', 34.2661094665527, 0.598056432040143, -116.392219543457, -2.03142745473742, 218, 6, 'PPL', 'P'),
(22550, 'Landers (historical)', 34.1483306884766, 0.596000804573738, -85.2858276367188, -1.48851849754912, 218, 13, 'PPL', 'P'),
(14086, 'Landers Park', 39.6944389343262, 0.692798654135821, -75.5680618286133, -1.31891148825995, 218, 10, 'PPL', 'P'),
(30291, 'Landersdale', 39.6194381713867, 0.69148964388102, -86.2630615234375, -1.50557444643442, 218, 19, 'PPL', 'P'),
(3655, 'Landersville', 34.4688911437988, 0.601595639970804, -87.4008331298828, -1.5254323071026, 218, 2, 'PPL', 'P'),
(27673, 'Landes', 38.8647193908691, 0.678317316234352, -87.8891677856445, -1.53395535469723, 218, 18, 'PPL', 'P'),
(110016, 'Landes', 38.896671295166, 0.678874982166614, -79.1980590820313, -1.38226689217044, 218, 58, 'PPL', 'P'),
(123025, 'Landess', 40.6108283996582, 0.708792667536455, -85.5611114501953, -1.49332310647173, 218, 19, 'PPL', 'P'),
(136395, 'Landfall', 44.9508285522461, 0.78453995973617, -92.9763870239258, -1.62274408017604, 218, 28, 'PPL', 'P'),
(110020, 'Landgraff', 37.4116706848145, 0.652956832121854, -81.4738922119141, -1.42198767351287, 218, 58, 'PPL', 'P'),
(172186, 'Landgrove Town Center', 43.2366714477539, 0.754622274366329, -72.8652801513672, -1.27173904902943, 218, 55, 'PPL', 'P'),
(48814, 'Landhaven', 39.0319404602051, 0.681235874472969, -76.4972229003906, -1.33512840824382, 218, 25, 'PPL', 'P'),
(95569, 'LandI Colonia', 26.2479991912842, 0.458114007948718, -97.8059997558594, -1.70703672394452, 218, 51, 'PPL', 'P'),
(156083, 'Landin Park', 40.1355590820313, 0.700497653110158, -84.2705612182617, -1.47079875576211, 218, 41, 'PPL', 'P'),
(145572, 'Landing', 40.9049987792969, 0.713926909222992, -74.6655578613281, -1.30315982251851, 218, 37, 'PPL', 'P'),
(88430, 'Landings', 35.9694404602051, 0.627785166130643, -86.8261108398438, -1.51540151085681, 218, 50, 'PPL', 'P'),
(163548, 'Landingville', 40.6261100769043, 0.709059383119627, -76.123893737793, -1.32861258516278, 218, 45, 'PPL', 'P'),
(9978, 'Landis', 35.9394416809082, 0.627261588660333, -92.4419403076172, -1.61341622529998, 218, 4, 'PPL', 'P'),
(66232, 'Landis', 35.5455589294434, 0.620387037780457, -80.6111068725586, -1.40692922860318, 218, 33, 'PPL', 'P'),
(156084, 'Landis', 40.0541687011719, 0.69907712298471, -84.503059387207, -1.47485661431506, 218, 41, 'PPL', 'P'),
(163563, 'Landis Store', 40.4263916015625, 0.705573638147849, -75.6611099243164, -1.32053548389268, 218, 45, 'PPL', 'P'),
(163551, 'Landis Valley', 40.0936088562012, 0.699765483547468, -76.2808303833008, -1.33135164634393, 218, 45, 'PPL', 'P'),
(110017, 'Landisburg', 37.9769401550293, 0.662822645538107, -80.9402770996094, -1.41267433286475, 218, 58, 'PPL', 'P'),
(163552, 'Landisburg', 40.3424987792969, 0.704109432180524, -77.307502746582, -1.34927045942242, 218, 45, 'PPL', 'P'),
(71011, 'Landisville', 39.5247192382813, 0.689836486634353, -74.938606262207, -1.30792541613115, 218, 37, 'PPL', 'P'),
(163555, 'Landisville', 40.0952796936035, 0.699794645161405, -76.4102783203125, -1.3336109390547, 218, 45, 'PPL', 'P'),
(14087, 'Landlith', 39.7438888549805, 0.693661718066088, -75.5297164916992, -1.31824223587801, 218, 10, 'PPL', 'P'),
(952, 'Landmark', 35.9463882446289, 0.627382829068959, -84.0572204589844, -1.46707525708402, 218, 50, 'PPL', 'P'),
(9979, 'Landmark', 34.6111106872559, 0.604077839264812, -92.3194427490234, -1.61127823957686, 218, 4, 'PPL', 'P'),
(81994, 'Landmark', 34.0519409179688, 0.594318485713135, -81.1324996948242, -1.41602925004798, 218, 48, 'PPL', 'P'),
(103502, 'Landmark', 38.9249992370605, 0.679369398022987, -77.6880569458008, -1.35591238318107, 218, 53, 'PPL', 'P'),
(195212, 'Landmark', 44.6563911437988, 0.779401057517726, -115.544166564941, -2.01662613803097, 218, 17, 'PPL', 'P'),
(55801, 'Landmark (historical)', 39.1130599975586, 0.682651677487483, -92.5169372558594, -1.61472516897575, 218, 29, 'PPL', 'P'),
(81996, 'Lando', 34.7761116027832, 0.606957648509569, -81.0102767944336, -1.41389605801482, 218, 48, 'PPL', 'P'),
(110018, 'Lando Mines', 37.7050018310547, 0.658076426422395, -82.1463928222656, -1.43372502338517, 218, 58, 'PPL', 'P'),
(60571, 'Landon', 30.437780380249, 0.531239484634277, -89.102783203125, -1.55513693958523, 218, 30, 'PPL', 'P'),
(48815, 'Landon Station', 38.1530609130859, 0.665896532647304, -75.6944427490234, -1.32111725143281, 218, 25, 'PPL', 'P'),
(163556, 'Landon Station', 40.0786094665527, 0.699503694812313, -79.8247222900391, -1.39320422845129, 218, 45, 'PPL', 'P'),
(48816, 'Landon Village', 38.9863891601563, 0.680440854308554, -77.1216735839844, -1.34602712868886, 218, 25, 'PPL', 'P'),
(204640, 'Landon Village', 40.6113891601563, 0.708802454653461, -111.869438171387, -1.95249002844692, 218, 52, 'PPL', 'P'),
(48817, 'Landonville', 38.0997200012207, 0.664965558109239, -75.8088912963867, -1.32311475540842, 218, 25, 'PPL', 'P'),
(195213, 'Landore', 45.1233291625977, 0.787550663348505, -116.627502441406, -2.03553391598026, 218, 17, 'PPL', 'P'),
(48818, 'Landover', 38.9338912963867, 0.679524593735512, -76.8969421386719, -1.34210482503539, 218, 25, 'PPL', 'P'),
(48819, 'Landover Hills', 38.9430618286133, 0.679684649717025, -76.8925018310547, -1.34202732704767, 218, 25, 'PPL', 'P'),
(48820, 'Landover Park', 38.9249992370605, 0.679369398022987, -76.9127807617188, -1.34238126115654, 218, 25, 'PPL', 'P'),
(16843, 'Landrum', 28.7547206878662, 0.501864551494594, -82.3850021362305, -1.43788954153978, 218, 12, 'PPL', 'P'),
(22551, 'Landrum', 34.4141693115234, 0.600640563824874, -84.0194396972656, -1.46641585839811, 218, 13, 'PPL', 'P'),
(55802, 'Landrum', 37.0597190856934, 0.646814117909532, -93.9147186279297, -1.63912105614142, 218, 29, 'PPL', 'P'),
(81997, 'Landrum', 35.1749992370605, 0.6139195510732, -82.1894378662109, -1.43447630112868, 218, 48, 'PPL', 'P'),
(95571, 'Landrum', 26.0436096191406, 0.45454673695807, -97.6983337402344, -1.70515759747936, 218, 51, 'PPL', 'P'),
(163557, 'Landrus', 41.642219543457, 0.726793838871655, -77.2063903808594, -1.34750571572608, 218, 45, 'PPL', 'P'),
(41712, 'Landry', 29.8691692352295, 0.521315347990151, -91.665283203125, -1.59986100166759, 218, 22, 'PPL', 'P'),
(41713, 'Landry (historical)', 30.1861095428467, 0.526846999890355, -91.9916687011719, -1.60555750323926, 218, 22, 'PPL', 'P'),
(3657, 'Lands Crossroads', 34.4797210693359, 0.601784657829172, -85.8566665649414, -1.49848151634516, 218, 2, 'PPL', 'P'),
(22552, 'Lands Crossroads', 31.7194404602051, 0.553608672920884, -83.3847198486328, -1.45533790721171, 218, 13, 'PPL', 'P'),
(22553, 'Lands End', 30.7397193908691, 0.536509314509812, -81.5216674804688, -1.42282150925017, 218, 13, 'PPL', 'P'),
(48821, 'Lands End', 38.9483299255371, 0.67977659535366, -76.466667175293, -1.33459511023553, 218, 25, 'PPL', 'P'),
(81999, 'Lands End', 34.0355606079102, 0.594032595370115, -81.2799987792969, -1.4186035947157, 218, 48, 'PPL', 'P'),
(103503, 'Lands End', 37.3283309936523, 0.65150228011348, -76.4255599975586, -1.33387765463787, 218, 53, 'PPL', 'P'),
(125207, 'Lands End', 42.6402816772461, 0.744213309245754, -70.5999984741211, -1.23220242527639, 218, 23, 'PPL', 'P'),
(16844, 'Lands End Ranch', 29.5427799224854, 0.515618779839445, -81.9022216796875, -1.42946343300883, 218, 12, 'PPL', 'P'),
(36797, 'Landsaw', 37.7275009155273, 0.658469109525127, -83.4513931274414, -1.45650157545002, 218, 21, 'PPL', 'P'),
(207879, 'Landsburg', 47.375, 0.826849733132314, -121.970558166504, -2.12878783050075, 218, 56, 'PPL', 'P'),
(66234, 'Landsdown', 35.2936096191406, 0.615989692767546, -81.4655609130859, -1.42184226491735, 218, 33, 'PPL', 'P'),
(82000, 'Landsdowne', 32.723331451416, 0.571129876048624, -79.95361328125, -1.39545380062408, 218, 48, 'PPL', 'P'),
(82001, 'Landsford', 34.7744407653809, 0.606928486895633, -80.92138671875, -1.4123446335218, 218, 48, 'PPL', 'P'),
(174905, 'Landstad', 44.6605606079102, 0.779473828394513, -88.4436111450195, -1.54363221683414, 218, 57, 'PPL', 'P'),
(163558, 'Landstreet', 40.1913909912109, 0.701472103753018, -78.9105606079102, -1.37724909720257, 218, 45, 'PPL', 'P'),
(103504, 'Landtown', 36.7788887023926, 0.641912703081295, -76.085563659668, -1.32794359909695, 218, 53, 'PPL', 'P'),
(196873, 'Landtsheim (historical)', 47.124439239502, 0.822476622885322, -104.79167175293, -1.82895970075776, 218, 31, 'PPL', 'P'),
(196872, 'Landusky', 47.8977813720703, 0.835973989343034, -108.621673583984, -1.89580584306708, 218, 31, 'PPL', 'P'),
(103505, 'Landview Estates', 38.6805610656738, 0.675103147114735, -77.4494400024414, -1.35174773186841, 218, 53, 'PPL', 'P'),
(110019, 'Landville', 37.7122192382813, 0.658202393941956, -81.8675003051758, -1.42885743070278, 218, 58, 'PPL', 'P'),
(3658, 'Lane', 34.3180618286133, 0.598963171812288, -86.2402801513672, -1.50517683648367, 218, 2, 'PPL', 'P'),
(32982, 'Lane', 38.4397201538086, 0.670899680229181, -95.0819396972656, -1.65949290689999, 218, 20, 'PPL', 'P'),
(66236, 'Lane', 35.1974983215332, 0.614312234175932, -78.7777786254883, -1.37493161442198, 218, 33, 'PPL', 'P'),
(76334, 'Lane', 34.2986106872559, 0.59862368535233, -95.9877777099609, -1.67530276271124, 218, 42, 'PPL', 'P'),
(82003, 'Lane', 33.5213890075684, 0.585058608023902, -79.8788909912109, -1.39414965063827, 218, 48, 'PPL', 'P'),
(88432, 'Lane', 36.1941719055176, 0.631707469784112, -89.3622207641602, -1.55966497922864, 218, 50, 'PPL', 'P'),
(95572, 'Lane', 33.3019409179688, 0.581228516323178, -96.2622222900391, -1.68009272424786, 218, 51, 'PPL', 'P'),
(113157, 'Lane', 41.2419395446777, 0.719807634963078, -96.1605606079102, -1.67831839317159, 218, 35, 'PPL', 'P'),
(120302, 'Lane', 40.122501373291, 0.700269753099875, -88.8555603027344, -1.55082208598708, 218, 18, 'PPL', 'P'),
(156085, 'Lane', 41.7508316040039, 0.728689476935574, -81.1813888549805, -1.41688252686124, 218, 41, 'PPL', 'P'),
(170712, 'Lane', 44.0697212219238, 0.769161735758589, -98.4247207641602, -1.71783544269062, 218, 49, 'PPL', 'P'),
(182692, 'Lane', 38.0027809143066, 0.663273651868712, -121.249168395996, -2.11619720381518, 218, 6, 'PPL', 'P'),
(195214, 'Lane', 47.5069389343262, 0.829152501947878, -116.535278320313, -2.03392430141742, 218, 17, 'PPL', 'P'),
(41714, 'Lane (historical)', 32.8077812194824, 0.572603802553929, -93.8447189331055, -1.63789933099135, 218, 22, 'PPL', 'P'),
(48822, 'Lane Beach', 38.1991691589355, 0.666701273349698, -76.565559387207, -1.33632110493801, 218, 25, 'PPL', 'P'),
(95573, 'Lane City', 29.2158298492432, 0.509912424571732, -96.0261077880859, -1.67597174877707, 218, 51, 'PPL', 'P'),
(190394, 'Lane City', 39.2605590820313, 0.685226022155208, -114.930557250977, -2.00591663518138, 218, 39, 'PPL', 'P'),
(16845, 'Lane Landing', 29.8572196960449, 0.521106789187284, -81.5530624389648, -1.42336945464445, 218, 12, 'PPL', 'P'),
(182693, 'Lane Mill (historical)', 36.2819404602051, 0.633239320043125, -117.569999694824, -2.05198359624341, 218, 6, 'PPL', 'P'),
(95574, 'Lane Number 1 Colonia', 26.5030002593994, 0.462564616183431, -98.1380004882813, -1.71283122984431, 218, 51, 'PPL', 'P'),
(95575, 'Lane Number 2 Colonia', 26.5030002593994, 0.462564616183431, -98.1350021362305, -1.71277889872889, 218, 51, 'PPL', 'P'),
(16846, 'Lane Park', 28.7719402313232, 0.502165089223609, -81.7577819824219, -1.42694248472096, 218, 12, 'PPL', 'P'),
(182694, 'Lane Redwood Flat (historical)', 39.896671295166, 0.696328274686557, -123.751106262207, -2.15986425726089, 218, 6, 'PPL', 'P'),
(3659, 'Lane Springs', 34.834171295166, 0.607970981304344, -87.980827331543, -1.53555511556404, 218, 2, 'PPL', 'P'),
(125208, 'Lane Village', 42.6602783203125, 0.744562316506609, -71.9372177124023, -1.2555413038054, 218, 23, 'PPL', 'P'),
(9980, 'Laneburg', 33.685001373291, 0.58791418250274, -93.3466720581055, -1.62920677319333, 218, 4, 'PPL', 'P'),
(48823, 'Lanedon', 38.1938896179199, 0.666609127975982, -76.5583267211914, -1.33619487110234, 218, 25, 'PPL', 'P'),
(60572, 'Laneheart', 31.1933307647705, 0.544426326508886, -91.3683319091797, -1.59467822387018, 218, 30, 'PPL', 'P'),
(95576, 'Lanely', 31.6005592346191, 0.551533804115603, -96.0597229003906, -1.67655844316521, 218, 51, 'PPL', 'P'),
(95577, 'Laneport', 30.690559387207, 0.535651310585616, -97.2786102294922, -1.69783204026888, 218, 51, 'PPL', 'P'),
(103508, 'Lanes Corner', 38.1594390869141, 0.666007852780869, -77.7363891601563, -1.35675593945636, 218, 53, 'PPL', 'P'),
(82002, 'Lanes Creek', 33.499439239502, 0.584675512301094, -79.3633270263672, -1.38515136194711, 218, 48, 'PPL', 'P'),
(103514, 'Lanes Ford', 37.7533302307129, 0.65891991611865, -78.9863891601563, -1.37857255510629, 218, 53, 'PPL', 'P'),
(145573, 'Lanes Mills', 40.0911102294922, 0.699721874284618, -74.1530609130859, -1.29421506336526, 218, 37, 'PPL', 'P'),
(163559, 'Lanes Mills', 41.2200012207031, 0.719424738977351, -78.7761077880859, -1.37490245280805, 218, 45, 'PPL', 'P'),
(55803, 'Lanes Prairie', 38.1861114501953, 0.666473373339415, -91.728889465332, -1.60097114036798, 218, 29, 'PPL', 'P'),
(103509, 'Lanes Store', 37.0688896179199, 0.646974173891046, -82.5263900756836, -1.44035722660585, 218, 53, 'PPL', 'P'),
(103510, 'Lanes Well Fork', 37.3011093139648, 0.65102717217501, -79.1622161865234, -1.38164131563038, 218, 53, 'PPL', 'P'),
(116400, 'Lanesboro', 42.184440612793, 0.736257381805252, -94.6911087036133, -1.65267161924191, 218, 16, 'PPL', 'P'),
(136401, 'Lanesboro', 43.7208290100098, 0.763072417926123, -91.9766693115234, -1.60529571450411, 218, 28, 'PPL', 'P'),
(163560, 'Lanesboro', 41.9569396972656, 0.732286741777998, -75.5852813720703, -1.31921202598896, 218, 45, 'PPL', 'P'),
(172188, 'Lanesboro', 44.3072204589844, 0.773306879416271, -72.3116683959961, -1.26207670112046, 218, 55, 'PPL', 'P'),
(125209, 'Lanesborough', 42.517219543457, 0.742065469826605, -73.2286071777344, -1.27808030190102, 218, 23, 'PPL', 'P'),
(9981, 'Lanesport', 33.649169921875, 0.587288805699762, -94.4727783203125, -1.64886103519617, 218, 4, 'PPL', 'P'),
(27675, 'Lanesville', 39.8525009155273, 0.695557356130007, -89.3488922119141, -1.55943235210742, 218, 18, 'PPL', 'P'),
(30293, 'Lanesville', 38.2369384765625, 0.66736047229852, -85.9858322143555, -1.50073588220791, 218, 19, 'PPL', 'P'),
(103511, 'Lanesville', 37.6144409179688, 0.656495840315433, -76.978889465332, -1.34353507569882, 218, 53, 'PPL', 'P'),
(113625, 'Lanesville', 41.5355606079102, 0.72493228926969, -73.4233322143555, -1.28147889492612, 218, 8, 'PPL', 'P'),
(125211, 'Lanesville', 42.6777801513672, 0.744867781083641, -70.6597213745117, -1.23324478652704, 218, 23, 'PPL', 'P'),
(150162, 'Lanesville', 42.1277809143066, 0.735268483513478, -74.2633285522461, -1.29613959672701, 218, 40, 'PPL', 'P'),
(95578, 'Lanetown', 31.5908298492432, 0.551363994306597, -94.0294418334961, -1.641123353807, 218, 51, 'PPL', 'P'),
(3660, 'Lanett', 32.8686103820801, 0.573665471722489, -85.190559387207, -1.48685575292253, 218, 2, 'PPL', 'P'),
(88433, 'Laneview', 36.023609161377, 0.628730588317621, -88.8986129760742, -1.55157349688865, 218, 50, 'PPL', 'P'),
(103512, 'Laneview', 37.7586097717285, 0.659012061492367, -76.7249984741211, -1.33910384196104, 218, 53, 'PPL', 'P'),
(3661, 'Laneville', 32.5224990844727, 0.567624690000889, -87.5963897705078, -1.52884541435564, 218, 2, 'PPL', 'P'),
(32985, 'Laneville', 37.3327789306641, 0.651579911259256, -95.1263885498047, -1.66026868572553, 218, 20, 'PPL', 'P'),
(95579, 'Laneville', 31.9741706848145, 0.558054554044662, -94.813606262207, -1.65480960496503, 218, 51, 'PPL', 'P'),
(110021, 'Laneville', 38.9738883972168, 0.680222674836249, -79.4175033569336, -1.38609691729214, 218, 58, 'PPL', 'P'),
(163562, 'Laneville', 40.6794395446777, 0.709990157920609, -79.6908264160156, -1.39086730459475, 218, 45, 'PPL', 'P'),
(174907, 'Laneville', 44.6230583190918, 0.778819289977598, -91.956672668457, -1.60494670724326, 218, 57, 'PPL', 'P'),
(131686, 'Lanewood', 42.327220916748, 0.738749368216266, -84.0224990844727, -1.46646925477797, 218, 27, 'PPL', 'P'),
(103513, 'Lanexa', 37.4236106872559, 0.653165224477153, -76.9013900756836, -1.34218245618117, 218, 53, 'PPL', 'P'),
(3663, 'Laney', 33.9011116027832, 0.591686017554619, -85.9016723632813, -1.49926701570868, 218, 2, 'PPL', 'P'),
(22554, 'Laney', 31.2083301544189, 0.544688115244041, -84.0266723632813, -1.46654209223378, 218, 13, 'PPL', 'P'),
(174908, 'Laney', 44.6444396972656, 0.779192465425346, -88.2891693115234, -1.54093669833682, 218, 57, 'PPL', 'P'),
(82005, 'Laneys (historical)', 34.7536087036133, 0.60656489882781, -79.9486083984375, -1.39536644894033, 218, 48, 'PPL', 'P'),
(182695, 'Lanfair', 35.1258316040039, 0.613061413990949, -115.182777404785, -2.01031870730523, 218, 6, 'PPL', 'P'),
(22555, 'Lanford', 33.8477783203125, 0.590755176174609, -84.1291732788086, -1.46833107069604, 218, 13, 'PPL', 'P'),
(82006, 'Lanford', 34.6333312988281, 0.604465662098555, -81.9749984741211, -1.43073362769074, 218, 48, 'PPL', 'P'),
(95580, 'Lanfranco Colonia', 26.3689994812012, 0.460225861403637, -98.1640014648438, -1.71328503249406, 218, 51, 'PPL', 'P'),
(32986, 'Lang', 38.4599990844727, 0.671253614338053, -96.0833282470703, -1.67697043418585, 218, 20, 'PPL', 'P'),
(182696, 'Lang', 34.4316711425781, 0.600946028401906, -118.376670837402, -2.06606266366222, 218, 6, 'PPL', 'P'),
(22556, 'Lang (historical)', 33.6061096191406, 0.586537261640142, -84.9316711425781, -1.48233730065904, 218, 13, 'PPL', 'P'),
(13145, 'Langdon', 38.9230613708496, 0.679335575877143, -76.9741668701172, -1.34345265086308, 218, 9, 'PPL', 'P'),
(22557, 'Langdon', 32.9452781677246, 0.575003577012199, -84.600830078125, -1.47656303478353, 218, 13, 'PPL', 'P'),
(32988, 'Langdon', 37.853889465332, 0.66067500585604, -98.3241729736328, -1.71608055269032, 218, 20, 'PPL', 'P'),
(116401, 'Langdon', 43.2158317565918, 0.754258553140452, -95.0877838134766, -1.65959490596974, 218, 16, 'PPL', 'P'),
(136399, 'Langdon', 44.810001373291, 0.782082061787109, -92.9286117553711, -1.62191024443873, 218, 28, 'PPL', 'P'),
(139263, 'Langdon', 40.3563919067383, 0.704351912997775, -95.5794372558594, -1.66817587731808, 218, 29, 'PPL', 'P'),
(140364, 'Langdon', 48.7599983215332, 0.851022513977663, -98.3677825927734, -1.71684168412986, 218, 34, 'PPL', 'P'),
(144039, 'Langdon', 43.1669387817383, 0.753405209748163, -72.379997253418, -1.2632692646566, 218, 36, 'PPL', 'P'),
(150163, 'Langdon', 42.0675010681152, 0.734216401724842, -75.7949981689453, -1.32287227459117, 218, 40, 'PPL', 'P'),
(163566, 'Langdon', 41.5177803039551, 0.724621964423668, -76.9502792358398, -1.34303573299443, 218, 45, 'PPL', 'P'),
(207880, 'Langdon', 46.0272216796875, 0.803326563855862, -118.33805847168, -2.06538875074838, 218, 56, 'PPL', 'P'),
(3665, 'Langdon (historical)', 33.0091705322266, 0.576118709139642, -85.454719543457, -1.49146621740167, 218, 2, 'PPL', 'P'),
(36798, 'Langdon Place', 38.3055610656738, 0.668558162419756, -85.5819396972656, -1.49368662796052, 218, 21, 'PPL', 'P'),
(48827, 'Langdon Woods', 39.351390838623, 0.686811335373105, -77.1822204589844, -1.34708387100941, 218, 25, 'PPL', 'P'),
(163567, 'Langdondale', 40.1302795410156, 0.700405507736442, -78.2541732788086, -1.36579297714138, 218, 45, 'PPL', 'P'),
(201105, 'Langell Valley', 42.0097198486328, 0.733207929199056, -121.227783203125, -2.11582396178841, 218, 43, 'PPL', 'P'),
(163568, 'Langeloth', 40.3650016784668, 0.704502181862283, -80.4141693115234, -1.40349201974227, 218, 45, 'PPL', 'P'),
(174909, 'Langes Corners', 44.3855590820313, 0.774674146319917, -87.8608322143555, -1.5334608056828, 218, 57, 'PPL', 'P'),
(9982, 'Langford', 34.1674995422363, 0.596335364185679, -91.5955581665039, -1.59864407020747, 218, 4, 'PPL', 'P'),
(48824, 'Langford', 39.1883316040039, 0.683965414853219, -76.14111328125, -1.3289131228918, 218, 25, 'PPL', 'P'),
(60573, 'Langford', 32.3463897705078, 0.564551002628774, -89.9722213745117, -1.57031149831845, 218, 30, 'PPL', 'P'),
(103515, 'Langford', 38.0402793884277, 0.663928123706599, -78.6208267211914, -1.37219228692473, 218, 53, 'PPL', 'P'),
(150164, 'Langford', 42.5875015258789, 0.743292121824696, -78.8422164916992, -1.37605626735032, 218, 40, 'PPL', 'P'),
(170714, 'Langford', 45.6025009155273, 0.795913788119681, -97.8300018310547, -1.70745563918399, 218, 49, 'PPL', 'P'),
(48825, 'Langford Acres', 39.2138900756836, 0.684411494335807, -76.1183319091797, -1.32851551294105, 218, 25, 'PPL', 'P'),
(48826, 'Langford Bay Estates', 39.1338882446289, 0.683015198976279, -76.1680603027344, -1.3293834371403, 218, 25, 'PPL', 'P'),
(196874, 'Langford City (historical)', 46.5483283996582, 0.812421591873619, -111.031387329102, -1.93786328194994, 218, 31, 'PPL', 'P'),
(88434, 'Langford Cove', 36.2400016784668, 0.632507350217517, -86.5711135864258, -1.51095096920113, 218, 50, 'PPL', 'P'),
(82007, 'Langfords Crossroads', 34.2080612182617, 0.59704329898245, -80.9077835083008, -1.41210721271062, 218, 48, 'PPL', 'P'),
(120303, 'Langham', 41.2966690063477, 0.720762844267062, -88.5344390869141, -1.54521746347301, 218, 18, 'PPL', 'P'),
(163569, 'Langhorne', 40.1744384765625, 0.70117622655591, -74.9230575561523, -1.30765404001607, 218, 45, 'PPL', 'P'),
(163570, 'Langhorne Gardens', 40.1802787780762, 0.701278159046633, -74.8874969482422, -1.30703339032403, 218, 45, 'PPL', 'P'),
(163571, 'Langhorne Manor', 40.1669387817383, 0.701045332188333, -74.9180603027344, -1.30756682149037, 218, 45, 'PPL', 'P'),
(103516, 'Langhorne Place', 37.2933311462402, 0.650891417538443, -80.0627822875977, -1.39735915922598, 218, 53, 'PPL', 'P'),
(163573, 'Langhorne Terrace', 40.1716690063477, 0.701127890182126, -74.9497222900391, -1.30811942741657, 218, 45, 'PPL', 'P'),
(174910, 'Langlade', 45.189998626709, 0.788714265007788, -88.7322235107422, -1.54866945287797, 218, 57, 'PPL', 'P'),
(9983, 'Langley', 34.3127784729004, 0.598870959859544, -93.841667175293, -1.63784606776955, 218, 4, 'PPL', 'P'),
(32990, 'Langley', 38.5466690063477, 0.672766289837218, -97.9625015258789, -1.70976819511656, 218, 20, 'PPL', 'P'),
(36799, 'Langley', 37.5316696166992, 0.65505120858212, -82.7908325195313, -1.44497261793301, 218, 21, 'PPL', 'P'),
(66242, 'Langley', 35.6366691589355, 0.621977211267344, -77.3213882446289, -1.34951280708161, 218, 33, 'PPL', 'P'),
(76335, 'Langley', 36.4638900756836, 0.636414939905963, -95.0475006103516, -1.65889183144195, 218, 42, 'PPL', 'P'),
(82008, 'Langley', 33.5177803039551, 0.584995624264122, -81.8441696166992, -1.42845023337211, 218, 48, 'PPL', 'P'),
(103517, 'Langley', 38.9463882446289, 0.679742706628789, -77.1591720581055, -1.34668160052675, 218, 53, 'PPL', 'P'),
(120304, 'Langley', 41.3691711425781, 0.722028245259013, -89.6880569458008, -1.56535189342039, 218, 18, 'PPL', 'P'),
(207881, 'Langley', 48.0402793884277, 0.838461048906032, -122.404998779297, -2.13637024959837, 218, 56, 'PPL', 'P'),
(60574, 'Langley (historical)', 33.2197189331055, 0.579793471969788, -89.5422210693359, -1.56280657720855, 218, 30, 'PPL', 'P'),
(66239, 'Langley Crossroads', 35.9047203063965, 0.626655586354286, -77.9047164916992, -1.35969380561288, 218, 33, 'PPL', 'P'),
(103518, 'Langley Forest', 38.9558296203613, 0.679907489721238, -77.1786117553711, -1.34702088724963, 218, 53, 'PPL', 'P'),
(103519, 'Langley Oaks', 38.9544410705566, 0.679883254955318, -77.1691665649414, -1.34685603757815, 218, 53, 'PPL', 'P'),
(48828, 'Langley Park', 38.9886093139648, 0.680479603302414, -76.9816665649414, -1.34358354523066, 218, 25, 'PPL', 'P'),
(103520, 'Langley View', 37.0763893127441, 0.647105068258623, -76.334716796875, -1.33229214168289, 218, 53, 'PPL', 'P'),
(82009, 'Langley Villa', 33.5116691589355, 0.584888964662464, -81.8288879394531, -1.42818351778894, 218, 48, 'PPL', 'P'),
(27677, 'Langleyville', 39.5622215270996, 0.690491025051267, -89.3552780151367, -1.55954380539904, 218, 18, 'PPL', 'P'),
(201106, 'Langlois', 42.9236106872559, 0.749158333336841, -124.449722290039, -2.17205740715376, 218, 43, 'PPL', 'P'),
(48829, 'Langmaid Landing', 38.2313919067383, 0.667263666392896, -75.2513885498047, -1.31338449689165, 218, 25, 'PPL', 'P'),
(16847, 'Langmar', 30.3463897705078, 0.529644417588888, -81.7724990844727, -1.4271993466081, 218, 12, 'PPL', 'P'),
(36803, 'Langnau', 37.1797218322754, 0.648908560948825, -83.9669418334961, -1.46549959782507, 218, 21, 'PPL', 'P'),
(30294, 'Langoons', 38.8369407653809, 0.677832487757903, -85.8572235107422, -1.49849123688314, 218, 19, 'PPL', 'P'),
(136402, 'Langor', 47.7808303833008, 0.833932809525543, -94.5913925170898, -1.65093124346954, 218, 28, 'PPL', 'P'),
(131687, 'Langport', 43.3650016784668, 0.756862059422113, -84.3897171020508, -1.47287841825735, 218, 27, 'PPL', 'P'),
(182697, 'Langs (historical)', 39.3199996948242, 0.686263456557848, -120.656669616699, -2.10585614930241, 218, 6, 'PPL', 'P'),
(144041, 'Langs Corner', 43.0258293151855, 0.750942384951085, -70.7547225952148, -1.23490287062173, 218, 36, 'PPL', 'P'),
(60575, 'Langsdale', 31.8888893127441, 0.556566113311417, -88.5844421386719, -1.54609018136223, 218, 30, 'PPL', 'P'),
(36800, 'Langstaff', 38.6413917541504, 0.674419513662912, -85.1133270263672, -1.48550779393678, 218, 21, 'PPL', 'P'),
(3666, 'Langston', 34.538890838623, 0.602817365120878, -86.0744400024414, -1.50228237985292, 218, 2, 'PPL', 'P'),
(41715, 'Langston', 32.6761093139648, 0.570305694270272, -93.1522216796875, -1.62581297385819, 218, 22, 'PPL', 'P'),
(55804, 'Langston', 37.1811103820801, 0.648932795714744, -93.2438888549805, -1.62741286788305, 218, 29, 'PPL', 'P'),
(66243, 'Langston', 35.4152793884277, 0.618113230841748, -77.9388885498047, -1.360290220539, 218, 33, 'PPL', 'P'),
(76336, 'Langston', 35.9449996948242, 0.62735859430304, -97.254997253418, -1.69741991609019, 218, 42, 'PPL', 'P'),
(131688, 'Langston', 43.3138885498047, 0.755969967035964, -85.2438888549805, -1.48778652772351, 218, 27, 'PPL', 'P'),
(3667, 'Langston Ford', 33.3294410705566, 0.581708484530637, -86.8422164916992, -1.51568260750987, 218, 2, 'PPL', 'P'),
(73158, 'Langsville', 39.0469398498535, 0.681497663208124, -82.1816711425781, -1.4343407462292, 218, 41, 'PPL', 'P'),
(150165, 'Langton Corners', 43.0994415283203, 0.752227160439966, -78.1849975585938, -1.36458563306119, 218, 40, 'PPL', 'P'),
(127920, 'Langtown Mill', 45.0663909912109, 0.786556904787742, -70.5772171020508, -1.23180481532564, 218, 26, 'PPL', 'P'),
(191728, 'Langtry', 29.8083305358887, 0.520253512374023, -101.558326721191, -1.77252718410093, 218, 51, 'PPL', 'P'),
(163575, 'Langville', 41.0355606079102, 0.716205643009718, -79.1766662597656, -1.38189351698561, 218, 45, 'PPL', 'P'),
(116402, 'Langworthy', 42.1911087036133, 0.736373761944888, -91.2238922119141, -1.59215727558231, 218, 16, 'PPL', 'P'),
(169455, 'Langworthy Corner', 41.3419418334961, 0.721553004162488, -71.769172668457, -1.2526083644969, 218, 47, 'PPL', 'P'),
(48830, 'Lanham', 38.9669418334961, 0.680101434427623, -76.8622207641602, -1.34149882272935, 218, 25, 'PPL', 'P'),
(60576, 'Lanham', 31.5830593109131, 0.551228372828085, -89.0969390869141, -1.55503494051548, 218, 30, 'PPL', 'P'),
(95581, 'Lanham', 31.7525005340576, 0.554185680060563, -97.9522171020508, -1.70958869805908, 218, 51, 'PPL', 'P'),
(110025, 'Lanham', 38.4769401550293, 0.671549291798079, -81.7388916015625, -1.42661278537801, 218, 58, 'PPL', 'P'),
(124072, 'Lanham', 40.0027809143066, 0.698180236908599, -96.8736114501953, -1.69076347810359, 218, 20, 'PPL', 'P'),
(36801, 'Lanhamtown', 37.336109161377, 0.651638034750047, -84.8824996948242, -1.48147909699776, 218, 21, 'PPL', 'P'),
(210548, 'LaniÃƒÂ¤kea', 19.6388893127441, 0.342763279942112, -155.995559692383, -2.72263613512343, 218, 15, 'PPL', 'P'),
(22558, 'Lanier', 32.1297187805176, 0.560769380459889, -81.5369415283203, -1.42308809167529, 218, 13, 'PPL', 'P'),
(88435, 'Lanier', 35.622501373291, 0.62172993676013, -84.0952835083008, -1.46773958261794, 218, 50, 'PPL', 'P'),
(95582, 'Lanier', 32.9352798461914, 0.574829073381772, -94.3736114501953, -1.64713024680373, 218, 51, 'PPL', 'P'),
(13142, 'Lanier Heights', 38.9263916015625, 0.679393699367934, -77.040283203125, -1.34460659856341, 218, 9, 'PPL', 'P'),
(22560, 'Lanier Heights', 32.8163909912109, 0.572754071418436, -83.5686111450195, -1.45854741579942, 218, 13, 'PPL', 'P'),
(82010, 'Lanier Heights', 34.9952812194824, 0.610782879941305, -81.9080581665039, -1.42956529892052, 218, 48, 'PPL', 'P'),
(22561, 'Lanier North Woods', 34.374439239502, 0.599947143256045, -83.8605575561523, -1.46364284191307, 218, 13, 'PPL', 'P'),
(22562, 'Lanier Northwest', 34.332218170166, 0.59921024658242, -83.9266662597656, -1.46479665645534, 218, 13, 'PPL', 'P'),
(22563, 'Lanier Valley', 34.3022193908691, 0.59868666911211, -83.8658294677734, -1.46373485412873, 218, 13, 'PPL', 'P'),
(3668, 'Laniers', 33.3813896179199, 0.582615157723755, -86.3274993896484, -1.50669909936276, 218, 2, 'PPL', 'P'),
(103521, 'Laniers Mill', 36.6650009155273, 0.639924986222687, -79.460563659668, -1.38684846135176, 218, 53, 'PPL', 'P'),
(210551, 'Lanikai', 21.391939163208, 0.3733597717843, -157.715835571289, -2.75266061325299, 218, 15, 'PPL', 'P'),
(182698, 'Lankershim (historical)', 36.9338912963867, 0.644618008695625, -119.981941223145, -2.09407991727818, 218, 6, 'PPL', 'P'),
(103522, 'Lankford Corner', 37.7802810668945, 0.659390296946186, -76.4013900756836, -1.3334558099212, 218, 53, 'PPL', 'P'),
(88436, 'Lankford Farms', 36.2350006103516, 0.63242006511279, -86.5736083984375, -1.51099451188495, 218, 50, 'PPL', 'P'),
(88437, 'Lankford Town', 35.249439239502, 0.615218774210995, -85.7372207641602, -1.49639679384384, 218, 50, 'PPL', 'P'),
(140366, 'Lankin', 48.3111114501953, 0.843187960103841, -97.9247207641602, -1.70910879643065, 218, 34, 'PPL', 'P'),
(207882, 'Lankner', 46.913890838623, 0.818801860055176, -123.320831298828, -2.15235454246103, 218, 56, 'PPL', 'P'),
(95583, 'Lannius', 33.6080589294434, 0.586571283523067, -96.0558319091797, -1.67649053255742, 218, 51, 'PPL', 'P'),
(174913, 'Lannon', 43.146110534668, 0.753041688259367, -88.1661071777344, -1.53878885891767, 218, 57, 'PPL', 'P'),
(103523, 'Lano', 36.7963905334473, 0.642218167658327, -82.5966720581055, -1.44158387860394, 218, 53, 'PPL', 'P'),
(71012, 'Lanoka Harbor', 39.8666687011719, 0.695804630637221, -74.168327331543, -1.29448151263232, 218, 37, 'PPL', 'P'),
(9984, 'Lansbrook', 34.7752799987793, 0.606943134281628, -92.1866683959961, -1.60896088995433, 218, 4, 'PPL', 'P'),
(116403, 'Lanscaster', 41.2755584716797, 0.720394395930249, -92.1647186279297, -1.60857779423152, 218, 16, 'PPL', 'P'),
(103524, 'Lansdale', 36.8769416809082, 0.64362405039778, -76.2130584716797, -1.33016880334577, 218, 53, 'PPL', 'P'),
(163576, 'Lansdale', 40.2413902282715, 0.70234475506321, -75.2841720581055, -1.31395667705186, 218, 45, 'PPL', 'P'),
(88438, 'Lansdell Park', 34.9911117553711, 0.610710109064518, -85.2144393920898, -1.48727253763312, 218, 50, 'PPL', 'P'),
(22564, 'Lansdowne', 34.0108299255371, 0.59360096353644, -84.5044403076172, -1.47488071592293, 218, 13, 'PPL', 'P'),
(32992, 'Lansdowne', 37.6183280944824, 0.656563684344203, -97.8625030517578, -1.70802289249617, 218, 20, 'PPL', 'P'),
(36802, 'Lansdowne', 37.9986114501953, 0.663200880991926, -84.5025024414063, -1.47484689377709, 218, 21, 'PPL', 'P'),
(48831, 'Lansdowne', 39.2449989318848, 0.684954446303047, -76.6608276367188, -1.33798384956461, 218, 25, 'PPL', 'P'),
(78583, 'Lansdowne', 39.938060760498, 0.697050657132241, -75.272216796875, -1.31374801838045, 218, 45, 'PPL', 'P'),
(145574, 'Lansdowne', 40.6083297729492, 0.708749058273605, -74.9066696166992, -1.307368016515, 218, 37, 'PPL', 'P'),
(103525, 'Lansdowne Park', 37.2833290100098, 0.650716847328988, -79.9805603027344, -1.39592411487259, 218, 53, 'PPL', 'P'),
(163578, 'Lanse', 40.9749984741211, 0.715148634373066, -78.1297225952148, -1.36362090295631, 218, 45, 'PPL', 'P'),
(163579, 'Lansford', 40.8316688537598, 0.712647060582127, -75.8827819824219, -1.32440439116629, 218, 45, 'PPL', 'P'),
(198504, 'Lansford', 48.6288909912109, 0.84873425939004, -101.375282287598, -1.76933245605727, 218, 34, 'PPL', 'P'),
(9985, 'Lansing', 35.2502784729004, 0.615233421596991, -90.3866729736328, -1.57754504331327, 218, 4, 'PPL', 'P'),
(16848, 'Lansing', 27.2563896179199, 0.475713741039102, -81.8891677856445, -1.42923559957757, 218, 12, 'PPL', 'P'),
(32993, 'Lansing', 39.2486114501953, 0.685017496641855, -94.9000015258789, -1.65631748677423, 218, 20, 'PPL', 'P'),
(66244, 'Lansing', 36.4991683959961, 0.637030662749989, -81.5111083984375, -1.42263721850274, 218, 33, 'PPL', 'P'),
(95584, 'Lansing', 32.5077781677246, 0.567367761534724, -94.626106262207, -1.65153711261754, 218, 51, 'PPL', 'P'),
(110022, 'Lansing', 38.0733299255371, 0.66450496439871, -81.0658264160156, -1.41486558180967, 218, 58, 'PPL', 'P'),
(116404, 'Lansing', 43.3622207641602, 0.756813523311246, -91.2163925170898, -1.59202638121474, 218, 16, 'PPL', 'P'),
(120305, 'Lansing', 41.5647201538086, 0.725441219354004, -87.5388870239258, -1.52784180209885, 218, 18, 'PPL', 'P'),
(131689, 'Lansing', 42.7324981689453, 0.745822790650544, -84.5555572509766, -1.47577287488811, 218, 27, 'PPL', 'P'),
(136404, 'Lansing', 43.7452812194824, 0.763499189490809, -92.9700012207031, -1.62263262688442, 218, 28, 'PPL', 'P'),
(150167, 'Lansing', 43.4430618286133, 0.75822446605677, -76.4502792358398, -1.33430908673446, 218, 40, 'PPL', 'P'),
(156086, 'Lansing', 40.0755615234375, 0.699450498169539, -80.790283203125, -1.4100564455132, 218, 41, 'PPL', 'P'),
(150168, 'Lansing Station', 42.5769386291504, 0.743107764498235, -76.6097183227539, -1.33709182375748, 218, 40, 'PPL', 'P'),
(116405, 'Lansing Valley Mobile City', 43.3622207641602, 0.756813523311246, -91.2163925170898, -1.59202638121474, 218, 16, 'PPL', 'P'),
(150170, 'Lansingburgh', 42.7844390869141, 0.746729330685607, -73.6699981689453, -1.28578402798629, 218, 40, 'PPL', 'P'),
(150171, 'Lansingville', 42.5977783203125, 0.743471485724113, -76.554443359375, -1.3361270936526, 218, 40, 'PPL', 'P'),
(116407, 'Lansrud', 43.4519386291504, 0.758379395453186, -93.4686126708984, -1.63133503837847, 218, 16, 'PPL', 'P'),
(192666, 'Lant', 39.9625015258789, 0.697477228959845, -111.91471862793, -1.9532803215004, 218, 52, 'PPL', 'P'),
(110023, 'Lanta', 37.9922218322754, 0.663089361121278, -81.7369384765625, -1.42657869691605, 218, 58, 'PPL', 'P'),
(16849, 'Lantana', 26.586389541626, 0.464020033719159, -80.0522232055664, -1.39717486847854, 218, 12, 'PPL', 'P'),
(88439, 'Lantana', 35.8766708374023, 0.626166030766902, -85.1011123657227, -1.48529460789152, 218, 50, 'PPL', 'P'),
(95585, 'Lantana', 26.1927795410156, 0.457150243239732, -97.57861328125, -1.70306808128808, 218, 51, 'PPL', 'P'),
(95586, 'Lantana Colonia', 26.1830005645752, 0.456979567903371, -98.1630020141602, -1.71326758878892, 218, 51, 'PPL', 'P'),
(30295, 'Lantana Estate', 39.5041694641113, 0.689477825414547, -85.7624969482422, -1.49683794647842, 218, 19, 'PPL', 'P'),
(14088, 'Lantern Lane Mobile Villa', 38.4633293151855, 0.671311737828844, -75.1569366455078, -1.31173600017689, 218, 10, 'PPL', 'P'),
(27678, 'Lanton', 39.7686080932617, 0.694093150162681, -88.605827331543, -1.54646342338901, 218, 18, 'PPL', 'P'),
(55805, 'Lanton', 36.517219543457, 0.637345714706946, -91.8013916015625, -1.60223654135994, 218, 29, 'PPL', 'P'),
(88440, 'Lanton', 35.6913909912109, 0.622932287413273, -86.9491729736328, -1.51754935027596, 218, 50, 'PPL', 'P'),
(202295, 'Lantry', 45.0144386291504, 0.785650165015597, -101.431106567383, -1.77030677354207, 218, 49, 'PPL', 'P'),
(9986, 'Lanty', 35.3363914489746, 0.616736376558177, -92.6855621337891, -1.6176682282964, 218, 4, 'PPL', 'P'),
(110024, 'Lantz', 38.9494400024414, 0.679795969850591, -80.0819396972656, -1.39769351910084, 218, 58, 'PPL', 'P'),
(163588, 'Lantz', 40.8369407653809, 0.712739072797789, -76.7699966430664, -1.3398892081665, 218, 45, 'PPL', 'P'),
(163581, 'Lantz Corners', 41.7083282470703, 0.727947653413932, -78.6936111450195, -1.3734626147647, 218, 45, 'PPL', 'P'),
(66245, 'Lanvale', 34.2036094665527, 0.596965601257647, -78.0572204589844, -1.36235550196436, 218, 33, 'PPL', 'P'),
(116408, 'Lanyon', 42.2224998474121, 0.736921640760145, -94.1949996948242, -1.64401288358974, 218, 16, 'PPL', 'P'),
(150172, 'Laona', 42.4216690063477, 0.740397798351998, -79.3058319091797, -1.38414788284837, 218, 40, 'PPL', 'P'),
(174915, 'Laona', 45.5647201538086, 0.795254389433777, -88.6738891601563, -1.54765132639324, 218, 57, 'PPL', 'P'),
(174916, 'Laona Junction', 45.6561088562012, 0.796849423189653, -88.6938934326172, -1.54800046681215, 218, 57, 'PPL', 'P'),
(123026, 'Laotto', 41.2902793884277, 0.720651324396415, -85.1980590820313, -1.4869866472901, 218, 19, 'PPL', 'P'),
(48832, 'Lap', 39.6947212219238, 0.692803580983838, -78.8469390869141, -1.37613869218606, 218, 25, 'PPL', 'P'),
(30297, 'Lap Corner', 39.4308280944824, 0.6881977770366, -87.0716705322266, -1.51968733599908, 218, 19, 'PPL', 'P'),
(88441, 'Lapata', 36.0827789306641, 0.629763295609327, -89.1822204589844, -1.55652338124873, 218, 50, 'PPL', 'P'),
(131692, 'Lapeer', 43.0513916015625, 0.7513885310127, -83.3188934326172, -1.45418901951745, 218, 27, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(150173, 'Lapeer', 42.4419403076172, 0.740751599302815, -76.0991668701172, -1.32818101990813, 218, 40, 'PPL', 'P'),
(131694, 'Lapeer Heights', 43.0086097717285, 0.750641847222069, -83.5950012207031, -1.45900800950995, 218, 27, 'PPL', 'P'),
(123027, 'Lapel', 40.0683288574219, 0.699324264333869, -85.8483276367188, -1.49833597459158, 218, 19, 'PPL', 'P'),
(41717, 'Lapeyrouse', 29.3974990844727, 0.513083150876066, -90.585563659668, -1.58101634063613, 218, 22, 'PPL', 'P'),
(178506, 'Lapham', 34.1805610656738, 0.59656333077499, -112.401390075684, -1.96177434063916, 218, 5, 'PPL', 'P'),
(174918, 'Lapham Junction', 44.2975006103516, 0.773137236054833, -90.4780578613281, -1.57914001049011, 218, 57, 'PPL', 'P'),
(150175, 'Laphams Mills', 44.5961112976074, 0.77834897572909, -73.5027770996094, -1.28286546974767, 218, 40, 'PPL', 'P'),
(78584, 'Lapidea', 39.8772201538086, 0.6959887882266, -75.3675003051758, -1.31541102932315, 218, 45, 'PPL', 'P'),
(48833, 'Lapidum', 39.5977783203125, 0.691111608164283, -76.1291732788086, -1.3287047305365, 218, 25, 'PPL', 'P'),
(48834, 'Lapidum Heights', 39.5916709899902, 0.691005015141653, -76.1294403076172, -1.3287093910684, 218, 25, 'PPL', 'P'),
(9987, 'Lapile', 33.0933303833008, 0.577587575638876, -92.2686080932617, -1.6103910074597, 218, 4, 'PPL', 'P'),
(3670, 'Lapine', 31.9655609130859, 0.557904285180155, -86.2844390869141, -1.50594755530314, 218, 2, 'PPL', 'P'),
(41718, 'Lapine', 32.3894386291504, 0.565302346951313, -92.2525024414063, -1.61010991080665, 218, 22, 'PPL', 'P'),
(150176, 'Lapla', 41.9188919067383, 0.731622682560187, -74.1361083984375, -1.29391918616815, 218, 40, 'PPL', 'P'),
(465, 'LaPlace', 39.7999992370605, 0.694641028977938, -88.7174987792969, -1.54841245783278, 218, 18, 'PPL', 'P'),
(41719, 'Laplace', 30.0663890838623, 0.524757483699079, -90.4800033569336, -1.57917396579401, 218, 22, 'PPL', 'P'),
(30296, 'Lapland', 39.9049987792969, 0.696473616703049, -86.9027786254883, -1.51673961614652, 218, 19, 'PPL', 'P'),
(32995, 'Lapland', 37.9847183227539, 0.662958400174674, -96.3930587768555, -1.68237625172455, 218, 20, 'PPL', 'P'),
(188842, 'Laplata PO', 36.9000015258789, 0.644026520617519, -108.189720153809, -1.88826683349523, 218, 38, 'PPL', 'P'),
(204645, 'Lapoint', 40.4038887023926, 0.70518088846609, -109.792778015137, -1.91624547127538, 218, 52, 'PPL', 'P'),
(122986, 'LaPorte', 41.6105613708496, 0.726241299524491, -86.7225036621094, -1.51359322447665, 218, 19, 'PPL', 'P'),
(131697, 'Laporte', 43.4963912963867, 0.759155240857753, -84.1888885498047, -1.46937329878865, 218, 27, 'PPL', 'P'),
(136407, 'Laporte', 47.2138900756836, 0.824037834495354, -94.7538909912109, -1.65376737687242, 218, 28, 'PPL', 'P'),
(156087, 'Laporte', 41.3305587768555, 0.721354332345168, -82.0777816772461, -1.43252753300102, 218, 41, 'PPL', 'P'),
(163582, 'Laporte', 41.4238891601563, 0.722983254825915, -76.4944381713867, -1.33507980555393, 218, 45, 'PPL', 'P'),
(194282, 'Laporte', 40.6263885498047, 0.709064243388616, -105.137222290039, -1.83499069536235, 218, 7, 'PPL', 'P'),
(48835, 'Lappans', 39.5536117553711, 0.69034075618676, -77.7375030517578, -1.35677538053231, 218, 25, 'PPL', 'P'),
(708, 'Lapperell', 39.1302795410156, 0.682952215216498, -83.2780609130859, -1.45347635760974, 218, 41, 'PPL', 'P'),
(103526, 'Laprades Mill', 36.9136085510254, 0.644264008007726, -79.6352767944336, -1.3898977807999, 218, 53, 'PPL', 'P'),
(195215, 'Lapwai', 46.4049987792969, 0.80992001808268, -116.803886413574, -2.03861239704234, 218, 17, 'PPL', 'P'),
(55806, 'Laquey', 37.7702789306641, 0.659215726736731, -92.3033294677734, -1.61099700976575, 218, 29, 'PPL', 'P'),
(163585, 'Laquin', 41.6322212219238, 0.726619335241228, -76.6511077880859, -1.33781420620317, 218, 45, 'PPL', 'P'),
(103527, 'Lara', 37.8527793884277, 0.66065563135911, -76.5177764892578, -1.33548713604266, 218, 53, 'PPL', 'P'),
(41722, 'Larabee', 30.2461109161377, 0.527894221410001, -91.9886093139648, -1.60550410685941, 218, 22, 'PPL', 'P'),
(163586, 'Larabee', 41.9044418334961, 0.731370481204956, -78.3791732788086, -1.36797463870637, 218, 45, 'PPL', 'P'),
(193725, 'Larabee', 40.4061088562012, 0.70521963745995, -123.928062438965, -2.16295272517705, 218, 6, 'PPL', 'P'),
(209561, 'Laramie', 41.3113899230957, 0.721019772733227, -105.590560913086, -1.84290294696098, 218, 59, 'PPL', 'P'),
(41720, 'Laran', 32.9736099243164, 0.5754980594476, -92.4852828979492, -1.61417269620762, 218, 22, 'PPL', 'P'),
(194284, 'Larand', 40.622501373291, 0.708996399359846, -106.292221069336, -1.8551492269176, 218, 7, 'PPL', 'P'),
(196875, 'Larb (historical)', 48.2147216796875, 0.841505641243238, -107.298889160156, -1.87271889957718, 218, 31, 'PPL', 'P'),
(131698, 'Larch', 45.7897186279297, 0.799181353619153, -87.0644378662109, -1.51956110216341, 218, 27, 'PPL', 'P'),
(120307, 'Larchland', 40.8199996948242, 0.712443395337763, -90.6527786254883, -1.58218946309631, 218, 18, 'PPL', 'P'),
(14089, 'Larchmont', 39.7972183227539, 0.694592492867071, -75.6750030517578, -1.32077796470993, 218, 10, 'PPL', 'P'),
(78585, 'Larchmont', 39.9874992370605, 0.697913521325427, -75.383056640625, -1.31568253859628, 218, 45, 'PPL', 'P'),
(103529, 'Larchmont', 36.8977813720703, 0.643987771623658, -76.3030624389648, -1.33173966891475, 218, 53, 'PPL', 'P'),
(150177, 'Larchmont', 40.9277801513672, 0.714324519173741, -73.7522201538086, -1.28721907233968, 218, 40, 'PPL', 'P'),
(207883, 'Larchmont', 47.1699981689453, 0.823271776207792, -122.432502746582, -2.13685028438486, 218, 56, 'PPL', 'P'),
(48836, 'Larchmont Knolls', 39.0113906860352, 0.680877213253163, -77.0780563354492, -1.34526586409126, 218, 25, 'PPL', 'P'),
(78586, 'Larchmont Square', 39.9769401550293, 0.697729230577994, -75.3897171020508, -1.31579878557786, 218, 45, 'PPL', 'P'),
(116409, 'Larchwood', 43.4536094665527, 0.758408557067122, -96.4338912963867, -1.68308891363225, 218, 16, 'PPL', 'P'),
(196876, 'Larchwood', 47.8502807617188, 0.835144947295692, -115.626937866211, -2.01807076976429, 218, 31, 'PPL', 'P'),
(3673, 'Lardent', 33.6222190856934, 0.586818424872227, -85.8294372558594, -1.49800627524863, 218, 2, 'PPL', 'P'),
(78587, 'Lardin', 39.8616714477539, 0.69571741211152, -79.8966674804688, -1.39445990890526, 218, 45, 'PPL', 'P'),
(163587, 'Lardintown', 40.7050018310547, 0.710436303982225, -79.8127822875977, -1.39299583609599, 218, 45, 'PPL', 'P'),
(95591, 'Laredo', 27.5061092376709, 0.480072170610585, -99.5072174072266, -1.73672857325392, 218, 51, 'PPL', 'P'),
(139264, 'Laredo', 40.0255584716797, 0.69857778028032, -93.4463882446289, -1.6309471489657, 218, 29, 'PPL', 'P'),
(196877, 'Laredo', 48.4313888549805, 0.845287196833096, -109.882499694824, -1.91781140999635, 218, 31, 'PPL', 'P'),
(95587, 'Laredo Ranchettes', 27.4850006103516, 0.479703755563286, -99.3705596923828, -1.73434344618164, 218, 51, 'PPL', 'P'),
(95588, 'Laredo Ranchettes Colonia', 27.4909992218018, 0.47980845108364, -99.3619995117188, -1.73419404284449, 218, 51, 'PPL', 'P'),
(14090, 'Larence Cordrey Subdivision', 38.625, 0.67413342358281, -75.2608337402344, -1.31354934656313, 218, 10, 'PPL', 'P'),
(95589, 'Larga Vista', 27.4986095428467, 0.479941276243007, -99.4297180175781, -1.73537595373627, 218, 51, 'PPL', 'P'),
(95590, 'Larga Vista Colonia', 27.4969997406006, 0.479913179893507, -99.4300003051758, -1.73538088058428, 218, 51, 'PPL', 'P'),
(110026, 'Largent', 39.4777793884277, 0.689017231704017, -78.3824996948242, -1.36803269561813, 218, 58, 'PPL', 'P'),
(16850, 'Largo', 27.9091701507568, 0.487106910630029, -82.7874984741211, -1.44491442786319, 218, 12, 'PPL', 'P'),
(48837, 'Largo', 38.8974990844727, 0.678889429815528, -76.8305587768555, -1.34094621680316, 218, 25, 'PPL', 'P'),
(88442, 'Largo', 35.5499992370605, 0.620464535768179, -88.0963897705078, -1.53757206061561, 218, 50, 'PPL', 'P'),
(136410, 'Largo', 47.480281829834, 0.828687247705441, -92.5702819824219, -1.61565621009285, 218, 28, 'PPL', 'P'),
(182699, 'Largo', 39.021671295166, 0.681056643731607, -123.128890991211, -2.14900455212582, 218, 6, 'PPL', 'P'),
(188844, 'Largo', 33.9019393920898, 0.591700465203533, -105.789169311523, -1.84636931743583, 218, 38, 'PPL', 'P'),
(182700, 'Largo Vista', 34.4269409179688, 0.600863470408114, -117.765281677246, -2.05539190980649, 218, 6, 'PPL', 'P'),
(191729, 'Lariat', 34.3302803039551, 0.599176424436576, -102.907501220703, -1.79607472130135, 218, 51, 'PPL', 'P'),
(178507, 'Lariat Tra-Tel Trailer Court', 33.4666709899902, 0.584103598457, -111.988327026367, -1.95456503041026, 218, 5, 'PPL', 'P'),
(163589, 'Larimer', 40.3452796936035, 0.70415796829139, -79.7266693115234, -1.3914928811348, 218, 45, 'PPL', 'P'),
(30298, 'Larimer Hill', 39.4555587768555, 0.688629408870275, -87.4719390869141, -1.52667334017057, 218, 19, 'PPL', 'P'),
(207884, 'Larimers Corner', 47.8919410705566, 0.835872056852311, -122.143333435059, -2.13180332780305, 218, 56, 'PPL', 'P'),
(55807, 'Larimore', 38.7733306884766, 0.676722282478476, -90.2069396972656, -1.57440810586526, 218, 29, 'PPL', 'P'),
(140369, 'Larimore', 47.9066696166992, 0.836129118476531, -97.6263885498047, -1.70390191702538, 218, 34, 'PPL', 'P'),
(3671, 'Larimore (historical)', 34.3052787780762, 0.598740065491966, -85.8605575561523, -1.49854942695295, 218, 2, 'PPL', 'P'),
(145575, 'Larisons Corners', 40.4413909912109, 0.705835426883004, -74.8566665649414, -1.30649529862578, 218, 37, 'PPL', 'P'),
(55808, 'Larissa', 36.9319381713867, 0.644583920233672, -92.5763931274414, -1.6157628696945, 218, 29, 'PPL', 'P'),
(95592, 'Larissa', 32.0558280944824, 0.559479744702018, -95.3247222900391, -1.66373026251041, 218, 51, 'PPL', 'P'),
(174919, 'Lark', 44.3141708374023, 0.773428186403924, -87.9497222900391, -1.53501223017583, 218, 57, 'PPL', 'P'),
(191730, 'Lark', 35.2075004577637, 0.614486804385387, -101.239723205566, -1.76696650374484, 218, 51, 'PPL', 'P'),
(198506, 'Lark', 46.4530601501465, 0.810758847247028, -101.39582824707, -1.76969105069805, 218, 34, 'PPL', 'P'),
(204646, 'Lark (historical)', 40.5250015258789, 0.707294706002313, -112.095558166504, -1.95643656686631, 218, 52, 'PPL', 'P'),
(48838, 'Lark Hill', 39.0341682434082, 0.681274756624885, -76.5102767944336, -1.33535624167508, 218, 25, 'PPL', 'P'),
(27679, 'Larkdale', 39.8883285522461, 0.696182666353957, -88.9119415283203, -1.55180612400987, 218, 18, 'PPL', 'P'),
(163591, 'Larke', 40.4275016784668, 0.70559301264478, -78.2061080932617, -1.364954081398, 218, 45, 'PPL', 'P'),
(3672, 'Larkin', 34.9094390869141, 0.609284652091053, -86.2152786254883, -1.50474047753906, 218, 2, 'PPL', 'P'),
(9989, 'Larkin', 36.1116714477539, 0.630267565161733, -91.8677825927734, -1.60339528275023, 218, 4, 'PPL', 'P'),
(82011, 'Larkin', 34.920280456543, 0.609473869686503, -82.0697174072266, -1.43238678493741, 218, 48, 'PPL', 'P'),
(131699, 'Larkin', 43.7227783203125, 0.763106439809049, -84.2472229003906, -1.47039142527338, 218, 27, 'PPL', 'P'),
(88443, 'Larkin Hills', 36.5305595397949, 0.637578541565246, -82.1822204589844, -1.43435033360912, 218, 50, 'PPL', 'P'),
(32996, 'Larkinburg', 39.4625015258789, 0.688750582699873, -95.5702819824219, -1.66801608765268, 218, 20, 'PPL', 'P'),
(48839, 'Larkington', 38.9208297729492, 0.679296627146201, -76.529167175293, -1.33568594101803, 218, 25, 'PPL', 'P'),
(3676, 'Larkins Fork (historical)', 34.8722190856934, 0.608635040522156, -86.2055587768555, -1.50457083417762, 218, 2, 'PPL', 'P'),
(3674, 'Larkinsville', 34.6908302307129, 0.605469207776324, -86.1247177124023, -1.5031598914321, 218, 2, 'PPL', 'P'),
(110027, 'Larkmead', 39.2483291625977, 0.685012569793838, -81.5922164916992, -1.42405282178017, 218, 58, 'PPL', 'P'),
(182703, 'Larkmead', 38.5588912963867, 0.672979609040533, -122.521942138672, -2.13841129625781, 218, 6, 'PPL', 'P'),
(36804, 'Larkslane', 37.3847198486328, 0.652486451294319, -82.8813934326172, -1.44655320403997, 218, 21, 'PPL', 'P'),
(103530, 'Larkspur', 36.8199996948242, 0.64263022525799, -76.1377792358398, -1.32885493282198, 218, 53, 'PPL', 'P'),
(182702, 'Larkspur', 37.9341697692871, 0.662076161484558, -122.534172058105, -2.13862474861918, 218, 6, 'PPL', 'P'),
(186959, 'Larkspur', 39.2286109924316, 0.684668422801972, -104.886672973633, -1.83061778485244, 218, 7, 'PPL', 'P'),
(163592, 'Larksville', 41.2449989318848, 0.719861031342934, -75.9311065673828, -1.32524781428352, 218, 45, 'PPL', 'P'),
(3675, 'Larkwood', 33.6536102294922, 0.587366303687483, -86.6963882446289, -1.51313742445608, 218, 2, 'PPL', 'P'),
(116411, 'Larland', 41.7316703796387, 0.728355050481687, -94.7627792358398, -1.65392250600592, 218, 16, 'PPL', 'P'),
(103531, 'Larmond', 38.2666702270508, 0.667879389236922, -78.1208267211914, -1.36346564066476, 218, 53, 'PPL', 'P'),
(32997, 'Larned', 38.1805610656738, 0.666376500854763, -99.0983276367188, -1.72959210048083, 218, 20, 'PPL', 'P'),
(178508, 'Larneds Landing', 34.3083305358887, 0.598793328713768, -114.051391601563, -1.99057229992867, 218, 5, 'PPL', 'P'),
(82012, 'Laroche', 32.7180595397949, 0.571037863832962, -80.2583312988281, -1.40077213332097, 218, 48, 'PPL', 'P'),
(127921, 'Larone', 44.6813888549805, 0.779837349883308, -69.7255630493164, -1.21694064801747, 218, 26, 'PPL', 'P'),
(163594, 'Laros (historical)', 40.5711097717285, 0.708099446704708, -75.6508331298828, -1.32035611999326, 218, 45, 'PPL', 'P'),
(41724, 'Larose', 29.5722198486328, 0.516132603482262, -90.3816680908203, -1.57745769162951, 218, 22, 'PPL', 'P'),
(48840, 'Larox Miracle Land', 39.6291694641113, 0.69165948697954, -77.0930633544922, -1.34552778598447, 218, 25, 'PPL', 'P'),
(55809, 'Larrabee', 39.2444381713867, 0.684944659186041, -92.2333297729492, -1.60977528461568, 218, 29, 'PPL', 'P'),
(116412, 'Larrabee', 42.8608283996582, 0.748062575706328, -95.5449981689453, -1.66757480186005, 218, 16, 'PPL', 'P'),
(127922, 'Larrabee', 44.6680603027344, 0.77960472276209, -67.3933334350586, -1.17623556233615, 218, 26, 'PPL', 'P'),
(174921, 'Larrabee', 44.2680587768555, 0.772623379122502, -87.7149963378906, -1.53091548947096, 218, 57, 'PPL', 'P'),
(145576, 'Larrabees', 40.1144409179688, 0.700129071615291, -74.1966705322266, -1.29497619480481, 218, 37, 'PPL', 'P'),
(103532, 'Larrymore Acres', 36.9261093139648, 0.644482187480031, -76.2155609130859, -1.33021247918765, 218, 53, 'PPL', 'P'),
(103533, 'Larrymore Lawns', 36.9113883972168, 0.644225259013866, -76.2286071777344, -1.33044017946085, 218, 53, 'PPL', 'P'),
(163595, 'Larrys Creek', 41.2194404602051, 0.719414951860345, -77.2138900756836, -1.34763661009365, 218, 45, 'PPL', 'P'),
(163596, 'Larryville', 41.2397193908691, 0.719768885969217, -77.2174987792969, -1.34769959385343, 218, 45, 'PPL', 'P'),
(125213, 'Larrywaug', 42.2999992370605, 0.738274260277796, -73.334716796875, -1.27993226412306, 218, 23, 'PPL', 'P'),
(16851, 'Larsen', 30.2783298492432, 0.528456547874172, -81.6324996948242, -1.42475589630795, 218, 12, 'PPL', 'P'),
(174922, 'Larsen', 44.1916694641113, 0.771290134101781, -88.623893737793, -1.54677874166207, 218, 57, 'PPL', 'P'),
(212250, 'Larsen Bay', 57.5400009155273, 1.0042624675765, -153.978607177734, -2.68743367288644, 218, 1, 'PPL', 'P'),
(196878, 'Larslan', 48.5783309936523, 0.847851820962842, -106.193328857422, -1.85342323221512, 218, 31, 'PPL', 'P'),
(136412, 'Larsmont', 46.9791717529297, 0.819941226948539, -91.7455596923828, -1.60126209071708, 218, 28, 'PPL', 'P'),
(182704, 'Larson', 37.9294395446777, 0.661993603490765, -121.210563659668, -2.11552342405939, 218, 6, 'PPL', 'P'),
(195216, 'Larson', 47.4708290100098, 0.828522264875911, -115.745559692383, -2.02014111119572, 218, 17, 'PPL', 'P'),
(198508, 'Larson', 48.889720916748, 0.853286600378394, -102.858062744141, -1.79521185710817, 218, 34, 'PPL', 'P'),
(131701, 'Larson Beach', 44.8008308410645, 0.781922005805595, -83.5236129760742, -1.45776204959395, 218, 27, 'PPL', 'P'),
(207885, 'Larson Mill', 48.7558288574219, 0.850949743100877, -122.413612365723, -2.13652058504191, 218, 56, 'PPL', 'P'),
(41723, 'Larto', 31.3724994659424, 0.547553410260857, -91.9044418334961, -1.60403510720212, 218, 22, 'PPL', 'P'),
(9990, 'Larue', 36.3416709899902, 0.634281814451837, -93.9458312988281, -1.63966407468769, 218, 4, 'PPL', 'P'),
(36805, 'Larue', 37.2030601501465, 0.649315891437552, -83.9250030517578, -1.46476762799946, 218, 21, 'PPL', 'P'),
(60578, 'Larue', 30.6241703033447, 0.534492602484836, -88.8483276367188, -1.55069585215141, 218, 30, 'PPL', 'P'),
(78589, 'Larue', 39.8202781677246, 0.694994963086809, -76.7605590820313, -1.33972449165308, 218, 45, 'PPL', 'P'),
(95472, 'LaRue', 32.1166687011719, 0.56054161360766, -95.6744384765625, -1.66983396141276, 218, 51, 'PPL', 'P'),
(174837, 'LaRue', 43.4361114501953, 0.758103159069117, -89.8894424438477, -1.56886673342708, 218, 57, 'PPL', 'P'),
(48841, 'Larvadale Estates', 39.5188903808594, 0.689734753880712, -77.4341735839844, -1.35148128260135, 218, 25, 'PPL', 'P'),
(123028, 'Larwill', 41.1805610656738, 0.718736378414593, -85.6255569458008, -1.49444789255812, 218, 19, 'PPL', 'P'),
(103534, 'Larwood', 36.6127815246582, 0.639013585918635, -82.2219390869141, -1.43504355444087, 218, 53, 'PPL', 'P'),
(178509, 'Las Alegres', 33.4602813720703, 0.583992078586353, -111.689437866211, -1.94934843046701, 218, 5, 'PPL', 'P'),
(186960, 'Las Animas', 38.0666694641113, 0.664388717417128, -103.222221374512, -1.8015676242077, 218, 7, 'PPL', 'P'),
(186962, 'Las Animas Junction', 38.0625, 0.664315946540342, -103.173606872559, -1.8007191410844, 218, 7, 'PPL', 'P'),
(191732, 'Las Aves Colonia', 31.5890007019043, 0.55133206966303, -106.263000488281, -1.85463923156885, 218, 51, 'PPL', 'P'),
(95593, 'Las Blancas Colonia', 27.4899997711182, 0.4797910073785, -99.3440017700195, -1.73387992299392, 218, 51, 'PPL', 'P'),
(191731, 'Las Brisas Colonia', 28.6749992370605, 0.500473149693569, -100.474998474121, -1.75361953930969, 218, 51, 'PPL', 'P'),
(95595, 'Las Brisas del Sur Colonia', 26.1159992218018, 0.455810173868718, -98.2020034790039, -1.71394829276354, 218, 51, 'PPL', 'P'),
(95594, 'Las Brisas Estates Colonia', 26.2980003356934, 0.458986692548423, -98.0759963989258, -1.71174905433536, 218, 51, 'PPL', 'P'),
(182715, 'Las Cantilles', 34.5074996948242, 0.602269486305621, -118.451110839844, -2.06736188680002, 218, 6, 'PPL', 'P'),
(191736, 'Las Carretas Colonia', 28.6800003051758, 0.500560434798296, -100.486000061035, -1.75381155322429, 218, 51, 'PPL', 'P'),
(191733, 'Las Casitas Number 1 Colonia', 31.8110008239746, 0.555206702732986, -106.180999755859, -1.85320804879904, 218, 51, 'PPL', 'P'),
(191734, 'Las Casitas Number 2 Colonia', 31.8150005340576, 0.55527651084306, -106.180999755859, -1.85320804879904, 218, 51, 'PPL', 'P'),
(191735, 'Las Casitas Number 3 Colonia', 31.8080005645752, 0.555154338328052, -106.180999755859, -1.85320804879904, 218, 51, 'PPL', 'P'),
(188845, 'Las Cocinitas (historical)', 35.2999992370605, 0.616101212638193, -106.550559997559, -1.85965809180116, 218, 38, 'PPL', 'P'),
(95596, 'Las Colonias', 28.7313899993896, 0.501457354163921, -99.8300018310547, -1.74236222422387, 218, 51, 'PPL', 'P'),
(188846, 'Las Colonias', 35.374439239502, 0.617400435775988, -106.485000610352, -1.85851386463881, 218, 38, 'PPL', 'P'),
(182711, 'Las Cruces', 34.5080604553223, 0.602279273422627, -120.228057861328, -2.09837546295843, 218, 6, 'PPL', 'P'),
(188847, 'Las Cruces', 32.3122215270996, 0.563954654281678, -106.777778625488, -1.8636238049804, 218, 38, 'PPL', 'P'),
(95597, 'Las Cuevas Colonia', 26.2759990692139, 0.458602698008747, -98.5690002441406, -1.72035359465935, 218, 51, 'PPL', 'P'),
(95598, 'Las Cuevas Number 2 Colonia', 26.2779998779297, 0.458637618708541, -98.568000793457, -1.72033615095421, 218, 51, 'PPL', 'P'),
(188850, 'Las Dispensas', 35.7452812194824, 0.623872849331262, -105.359169006348, -1.83886439632593, 218, 38, 'PPL', 'P'),
(188848, 'Las Dos', 35.7616691589355, 0.624158872832337, -106.029998779297, -1.8505725845843, 218, 38, 'PPL', 'P'),
(95599, 'Las Escobas', 26.6632099151611, 0.46536080216996, -98.893180847168, -1.72601161355328, 218, 51, 'PPL', 'P'),
(95601, 'Las Flores', 28.6969394683838, 0.500856078968808, -98.9411087036133, -1.72684811245167, 218, 51, 'PPL', 'P'),
(193726, 'Las Flores', 40.0719413757324, 0.699387314672677, -122.161666870117, -2.13212330660802, 218, 6, 'PPL', 'P'),
(95603, 'Las Flores Colonia', 26.4099998474121, 0.460941452788541, -98.9800033569336, -1.72752695221353, 218, 51, 'PPL', 'P'),
(95604, 'Las Fuentes Colonia', 26.1140003204346, 0.455775286458438, -98.2020034790039, -1.71394829276354, 218, 51, 'PPL', 'P'),
(95605, 'Las Gallinas', 29.1122207641602, 0.508104104902054, -98.4883270263672, -1.71894558139102, 218, 51, 'PPL', 'P'),
(182716, 'Las Gallinas', 38.0205612182617, 0.663583976714733, -122.537498474121, -2.13868280553094, 218, 6, 'PPL', 'P'),
(178510, 'Las Guijas', 31.670280456543, 0.552750668996688, -111.381393432617, -1.94397204085836, 218, 5, 'PPL', 'P'),
(95606, 'Las Haciendas Colonia', 26.1140003204346, 0.455775286458438, -98.1949996948242, -1.71382605366951, 218, 51, 'PPL', 'P'),
(191739, 'Las Hacienditas Colonia', 28.6860008239746, 0.500665163608163, -100.482002258301, -1.75374177840373, 218, 51, 'PPL', 'P'),
(188849, 'Las Huertas', 35.3027801513672, 0.61614974874906, -106.405830383301, -1.85713208350722, 218, 38, 'PPL', 'P'),
(182718, 'Las Juntas', 37.9319381713867, 0.662037212753615, -122.053329467773, -2.13023246223406, 218, 6, 'PPL', 'P'),
(95607, 'Las Lomas', 26.3644409179688, 0.460146299466071, -98.7750015258789, -1.72394899528901, 218, 51, 'PPL', 'P'),
(182721, 'Las Lomas', 38.6772193908691, 0.675044823886862, -123.134170532227, -2.14909669749953, 218, 6, 'PPL', 'P'),
(95608, 'Las Lomitas', 27.3413906097412, 0.477197288213844, -98.6638870239258, -1.72200968138321, 218, 51, 'PPL', 'P'),
(95609, 'Las Lomitas A Colonia', 27.3549995422363, 0.477434808893566, -98.6679992675781, -1.72208145357459, 218, 51, 'PPL', 'P'),
(95610, 'Las Lomitas B Colonia', 27.3339996337891, 0.477068291348543, -98.6719970703125, -1.72215122839515, 218, 51, 'PPL', 'P'),
(95611, 'Las Lomitas C Colonia', 27.3519992828369, 0.477382444488632, -98.6679992675781, -1.72208145357459, 218, 51, 'PPL', 'P'),
(192937, 'Las Lulas', 30.0258293151855, 0.524049582191822, -104.695281982422, -1.82727738189716, 218, 51, 'PPL', 'P'),
(186963, 'Las Mesitas', 37.0644416809082, 0.64689654274527, -106.110000610352, -1.85196887994383, 218, 7, 'PPL', 'P'),
(95612, 'Las Milpas', 26.1180591583252, 0.455846126543434, -98.1991729736328, -1.71389889112532, 218, 51, 'PPL', 'P'),
(191737, 'Las Milpas Addition Colonia', 31.6410007476807, 0.552239641673015, -106.281997680664, -1.85497079512456, 218, 51, 'PPL', 'P'),
(191738, 'Las Milpas Number 2 Colonia', 31.6420001983643, 0.552257085378155, -106.282997131348, -1.8549882388297, 218, 51, 'PPL', 'P'),
(188851, 'Las Mochas', 36.1624984741211, 0.631154664120839, -105.569442749023, -1.84253436546611, 218, 38, 'PPL', 'P'),
(188853, 'Las Nutrias', 34.4766693115234, 0.601731394607371, -106.769996643066, -1.8634879837648, 218, 38, 'PPL', 'P'),
(95613, 'Las Palmas', 26.952220916748, 0.470404995722138, -99.2747192382813, -1.73267071470097, 218, 51, 'PPL', 'P'),
(182723, 'Las Palmas', 36.7574996948242, 0.641539394475493, -119.699440002441, -2.08914934083601, 218, 6, 'PPL', 'P'),
(191740, 'Las Palmas Colonia', 31.8010005950928, 0.555032165813045, -106.28800201416, -1.85507559051346, 218, 51, 'PPL', 'P'),
(95616, 'Las Palmas Estates Colonia', 26.2299995422363, 0.457799854808629, -98.1429977416992, -1.71291844837001, 218, 51, 'PPL', 'P'),
(191741, 'Las Palmas Number 2 Colonia', 31.8010005950928, 0.555032165813045, -106.286003112793, -1.85504070310318, 218, 51, 'PPL', 'P'),
(188854, 'Las Palomas', 33.0625, 0.577049483940625, -107.297782897949, -1.87269959165928, 218, 38, 'PPL', 'P'),
(191742, 'Las Pampas Colonia', 29.681999206543, 0.518048614728519, -104.361000061035, -1.82144306173907, 218, 51, 'PPL', 'P'),
(191743, 'Las Pampas Number 1 Colonia', 31.5669994354248, 0.550948075123354, -106.267997741699, -1.85472645009455, 218, 51, 'PPL', 'P'),
(191744, 'Las Pampas Number 2 Colonia', 31.5650005340576, 0.550913187713074, -106.267997741699, -1.85472645009455, 218, 51, 'PPL', 'P'),
(191745, 'Las Pampas Number 3 Colonia', 31.5639991760254, 0.55089571071842, -106.266998291016, -1.85470900638941, 218, 51, 'PPL', 'P'),
(191746, 'Las Pampas Number 4 Colonia', 31.5620002746582, 0.55086082330814, -106.266998291016, -1.85470900638941, 218, 51, 'PPL', 'P'),
(95617, 'Las Pilas Colonia Number 1', 27.681999206543, 0.483142029688633, -99.177001953125, -1.73096522633888, 218, 51, 'PPL', 'P'),
(95618, 'Las Pilas Colonia Number 2', 27.6809997558594, 0.483124585983493, -99.1900024414063, -1.73119212766375, 218, 51, 'PPL', 'P'),
(188855, 'Las Placitas', 36.3230590820313, 0.633956975377874, -106.16194152832, -1.85287541997889, 218, 38, 'PPL', 'P'),
(182727, 'Las Plumas (historical)', 39.6736106872559, 0.692435132647025, -121.485000610352, -2.12031325243796, 218, 6, 'PPL', 'P'),
(191747, 'Las Quintas Colonia', 31.8059997558594, 0.555119417628259, -106.178001403809, -1.85315571768362, 218, 51, 'PPL', 'P'),
(191748, 'Las Quintas Fronterizas', 28.6902809143066, 0.50073986527674, -100.468330383301, -1.75350315917006, 218, 51, 'PPL', 'P'),
(191749, 'Las Quintas Fronterizas Colonia', 28.6909999847412, 0.500752415423377, -100.46900177002, -1.75351487707885, 218, 51, 'PPL', 'P'),
(191750, 'Las Quintas Number 2 Colonia', 31.8020000457764, 0.555049609518185, -106.180000305176, -1.8531906050939, 218, 51, 'PPL', 'P'),
(95619, 'Las Rusias', 26.0536098480225, 0.454721273878011, -97.7572174072266, -1.70618531134402, 218, 51, 'PPL', 'P'),
(188856, 'Las Tablas', 36.5555610656738, 0.638014900509855, -106.028610229492, -1.85054834981838, 218, 38, 'PPL', 'P'),
(95620, 'Las Tiendas', 27.9025001525879, 0.486990497200879, -99.6391677856445, -1.73903154180656, 218, 51, 'PPL', 'P'),
(188859, 'Las Tusas', 35.7652816772461, 0.624221923171144, -105.282501220703, -1.83752629103622, 218, 38, 'PPL', 'P'),
(182731, 'Las Uvas (historical)', 34.125560760498, 0.595603394360071, -117.570556640625, -2.05199331678139, 218, 6, 'PPL', 'P'),
(95621, 'Las Vegas', 28.547779083252, 0.498252739134715, -99.4894409179688, -1.73641831498692, 218, 51, 'PPL', 'P'),
(188860, 'Las Vegas', 35.5938911437988, 0.62123059405574, -105.223327636719, -1.83649351716549, 218, 38, 'PPL', 'P'),
(190396, 'Las Vegas', 36.1749992370605, 0.631372843593143, -115.136390686035, -2.00950910633385, 218, 39, 'PPL', 'P'),
(188862, 'Las Vegas Town', 35.6005592346191, 0.621346974195376, -105.254440307617, -1.83703653571175, 218, 38, 'PPL', 'P'),
(178511, 'Las Villas', 33.5222206115723, 0.585073122251843, -111.920829772949, -1.95338698110206, 218, 5, 'PPL', 'P'),
(95622, 'Las Yescas', 26.2224998474121, 0.457668960441052, -97.5055618286133, -1.7017930929162, 218, 51, 'PPL', 'P'),
(41726, 'Lasalle', 29.9755592346191, 0.523172203770695, -91.9475021362305, -1.60478665126174, 218, 22, 'PPL', 'P'),
(95473, 'LaSalle', 31.5330600738525, 0.550355721517893, -96.4186096191406, -1.68282219804908, 218, 51, 'PPL', 'P'),
(95623, 'Lasana', 26.250280380249, 0.458153822207015, -97.6969375610352, -1.70513322955538, 218, 51, 'PPL', 'P'),
(95624, 'Lasana Colonia', 26.2520008087158, 0.458183849348305, -97.6940002441406, -1.7050819637044, 218, 51, 'PPL', 'P'),
(95625, 'Lasara', 26.4644393920898, 0.461891602086454, -97.9108276367188, -1.7088663156134, 218, 51, 'PPL', 'P'),
(186966, 'Lasauses', 37.2666702270508, 0.650426096716979, -105.745826721191, -1.84561284652819, 218, 7, 'PPL', 'P'),
(3677, 'Lasca', 32.0163917541504, 0.558791450718287, -87.9583282470703, -1.53516243246131, 218, 2, 'PPL', 'P'),
(186964, 'Lascar', 37.8250007629395, 0.660170802882661, -104.748062133789, -1.82819856931822, 218, 7, 'PPL', 'P'),
(88445, 'Lascassas', 35.9302787780762, 0.627101665836874, -86.2911071777344, -1.50606393544278, 218, 50, 'PPL', 'P'),
(88446, 'Lascassas Colonial Acres', 35.934440612793, 0.627174303555606, -86.2655563354492, -1.50561798911824, 218, 50, 'PPL', 'P'),
(193728, 'Lasco', 40.4225006103516, 0.705505727540052, -120.971672058105, -2.11135397905677, 218, 6, 'PPL', 'P'),
(88448, 'Lasea', 35.6555595397949, 0.622306910610296, -86.9013900756836, -1.5167153813806, 218, 50, 'PPL', 'P'),
(22565, 'Lashley', 32.5458297729492, 0.568031887331562, -83.6113891601563, -1.45929403301102, 218, 13, 'PPL', 'P'),
(73160, 'Lashley', 39.9186096191406, 0.696711170672284, -81.4005584716797, -1.42070775829297, 218, 41, 'PPL', 'P'),
(78590, 'Lashley', 39.7594413757324, 0.693933160760195, -78.2811126708984, -1.36626315823183, 218, 45, 'PPL', 'P'),
(110033, 'Lashmeet', 37.4208297729492, 0.653116688366286, -81.1994400024414, -1.4171975788182, 218, 58, 'PPL', 'P'),
(33000, 'Lasita', 39.4088897705078, 0.687814881050874, -96.9422225952148, -1.69196096848774, 218, 20, 'PPL', 'P'),
(66246, 'Lasker', 36.3499984741211, 0.634427156468328, -77.3058319091797, -1.34924129780848, 218, 33, 'PPL', 'P'),
(144042, 'Laskey Corner', 43.4808311462402, 0.758883665005592, -70.9958267211914, -1.23911093146016, 218, 36, 'PPL', 'P'),
(103535, 'Lasley (historical)', 38.0299987792969, 0.663748693228155, -78.1247177124023, -1.36353355127255, 218, 53, 'PPL', 'P'),
(174923, 'Lasleys Point', 44.1269416809082, 0.770160421167369, -88.7063903808594, -1.54821857970542, 218, 57, 'PPL', 'P'),
(95626, 'Lassater', 32.8338890075684, 0.573059469416441, -94.5025024414063, -1.64937981897652, 218, 51, 'PPL', 'P'),
(150178, 'Lassellsville', 43.0491714477539, 0.75134978201884, -74.6005630493164, -1.30202544905219, 218, 40, 'PPL', 'P'),
(22566, 'Lassiter', 33.5111083984375, 0.584879177545458, -83.8555603027344, -1.46355562338737, 218, 13, 'PPL', 'P'),
(66247, 'Lassiter', 35.9099998474121, 0.626747731728003, -78.4247207641602, -1.36876959229176, 218, 33, 'PPL', 'P'),
(88449, 'Lassiter Corner', 36.3600006103516, 0.634601726677783, -89.366943359375, -1.55974740406438, 218, 50, 'PPL', 'P'),
(66248, 'Lassiter Crossroads', 36.3713912963867, 0.634800531653157, -77.3047180175781, -1.34922185673252, 218, 33, 'PPL', 'P'),
(182733, 'Lasslys (historical)', 39.5202789306641, 0.689758988646632, -121.232780456543, -2.11591118031411, 218, 6, 'PPL', 'P'),
(66249, 'Last Chance', 35.452220916748, 0.618757982141656, -76.0758285522461, -1.32777368941941, 218, 33, 'PPL', 'P'),
(76337, 'Last Chance', 35.5366706848145, 0.62023190864696, -96.2641677856445, -1.68012667955176, 218, 42, 'PPL', 'P'),
(116413, 'Last Chance', 40.9563903808594, 0.714823861878131, -93.5533294677734, -1.63281362541568, 218, 16, 'PPL', 'P'),
(182734, 'Last Chance', 39.1113891601563, 0.682622515873546, -120.623611450195, -2.10527917545224, 218, 6, 'PPL', 'P'),
(186965, 'Last Chance', 39.7408294677734, 0.693608321686232, -103.591110229492, -1.80800594930102, 218, 7, 'PPL', 'P'),
(195217, 'Last Chance', 44.3666687011719, 0.774344446976965, -111.401390075684, -1.94432104811921, 218, 17, 'PPL', 'P'),
(209562, 'Last Crossing Ford Number 9', 42.375560760498, 0.739593057649603, -108.719169616699, -1.89750746984558, 218, 59, 'PPL', 'P'),
(136413, 'Lastrup', 46.0394401550293, 0.80353981648015, -94.0630569458008, -1.64171004819515, 218, 28, 'PPL', 'P'),
(103536, 'Laswell', 36.8941688537598, 0.64392472128485, -80.9091720581055, -1.41213144747654, 218, 53, 'PPL', 'P'),
(207886, 'Latah', 47.2816696166992, 0.825220810651567, -117.154441833496, -2.04473074333069, 218, 56, 'PPL', 'P'),
(103537, 'Latanes', 38.1766700744629, 0.666308590246966, -76.9633331298828, -1.34326356642569, 218, 53, 'PPL', 'P'),
(41727, 'Latanier', 31.201940536499, 0.544576595373394, -92.3561096191406, -1.61191819718681, 218, 22, 'PPL', 'P'),
(95627, 'Latch', 32.6966705322266, 0.57066455522716, -95.0688934326172, -1.65926520662678, 218, 51, 'PPL', 'P'),
(156088, 'Latcha', 41.5441703796387, 0.725082558134197, -83.45361328125, -1.45654032444388, 218, 41, 'PPL', 'P'),
(41728, 'Latex', 32.6044387817383, 0.569054807506262, -94.0427780151367, -1.64135611408627, 218, 22, 'PPL', 'P'),
(95628, 'Latex', 32.604320526123, 0.569052743556417, -94.0427703857422, -1.64135598092822, 218, 51, 'PPL', 'P'),
(95629, 'Latexo', 31.3950004577637, 0.547946126653103, -95.4738922119141, -1.66633376879207, 218, 51, 'PPL', 'P'),
(3678, 'Latham', 31.0847206115723, 0.542530721734481, -87.8341674804688, -1.53299541828231, 218, 2, 'PPL', 'P'),
(27681, 'Latham', 39.9686088562012, 0.697583821982475, -89.1622161865234, -1.55617424082982, 218, 18, 'PPL', 'P'),
(33001, 'Latham', 37.5361099243164, 0.655128706569841, -96.6416702270508, -1.68671534008861, 218, 20, 'PPL', 'P'),
(66250, 'Latham', 35.603328704834, 0.621395310569161, -77.1344375610352, -1.34624990211405, 218, 33, 'PPL', 'P'),
(73161, 'Latham', 39.0988883972168, 0.682404336401242, -83.2466735839844, -1.45292854537352, 218, 41, 'PPL', 'P'),
(76338, 'Latham', 35.1233291625977, 0.613017738149072, -94.8052825927734, -1.65466432952756, 218, 42, 'PPL', 'P'),
(88450, 'Latham', 36.4233283996582, 0.635707005109193, -88.7141723632813, -1.54835440092102, 218, 50, 'PPL', 'P'),
(112415, 'Latham', 38.5608291625977, 0.673013431186377, -92.6822204589844, -1.61760990506853, 218, 29, 'PPL', 'P'),
(150180, 'Latham', 42.746940612793, 0.74607485884772, -73.7594375610352, -1.28734503985924, 218, 40, 'PPL', 'P'),
(201107, 'Latham', 43.7755584716797, 0.764027627230107, -123.061111450195, -2.1478215759696, 218, 43, 'PPL', 'P'),
(9991, 'Latham (historical)', 35.5666694641113, 0.62075548611727, -92.6958312988281, -1.61784745903776, 218, 4, 'PPL', 'P'),
(22567, 'Latham (historical)', 33.8663902282715, 0.591080015248571, -85.1666717529297, -1.48643883505387, 218, 13, 'PPL', 'P'),
(55810, 'Latham Mill', 37.2849998474121, 0.650746008942925, -92.3888931274414, -1.61249037734701, 218, 29, 'PPL', 'P'),
(66252, 'Latham Park', 36.0902786254883, 0.629894189976904, -79.8013916015625, -1.39279703112062, 218, 33, 'PPL', 'P'),
(120308, 'Latham Park', 42.3683280944824, 0.739466823813933, -89.0627822875977, -1.55443879190547, 218, 18, 'PPL', 'P'),
(66253, 'Latham Town', 36.0508308410645, 0.629205696256091, -79.8447189331055, -1.39355323571214, 218, 33, 'PPL', 'P'),
(150179, 'Lathams Corners', 42.4599990844727, 0.741066784417826, -75.399169921875, -1.31596376840739, 218, 40, 'PPL', 'P'),
(3679, 'Lathamville', 34.2733306884766, 0.598182466138731, -86.033332824707, -1.50156492425525, 218, 2, 'PPL', 'P'),
(82013, 'Lathem', 34.8250007629395, 0.607810925322831, -82.5508270263672, -1.44078373185443, 218, 48, 'PPL', 'P'),
(22568, 'Lathemtown', 34.2461090087891, 0.597707358200261, -84.3072204589844, -1.471438580214, 218, 13, 'PPL', 'P'),
(3680, 'Lathrop', 33.3708305358887, 0.582430866976321, -87.9922180175781, -1.53575392053942, 218, 2, 'PPL', 'P'),
(55811, 'Lathrop', 39.5483283996582, 0.690248544234015, -94.329719543457, -1.64636418851617, 218, 29, 'PPL', 'P'),
(73163, 'Lathrop', 39.422779083252, 0.688057295289098, -81.9155578613281, -1.4296961932881, 218, 41, 'PPL', 'P'),
(131702, 'Lathrop', 46.1480598449707, 0.805435587702123, -87.2219390869141, -1.52231001704059, 218, 27, 'PPL', 'P'),
(182735, 'Lathrop', 37.8227806091309, 0.6601320538888, -121.27555847168, -2.11665779752571, 218, 6, 'PPL', 'P'),
(131704, 'Lathrup Village', 42.4963912963867, 0.74170194833781, -83.2227783203125, -1.45251149434681, 218, 27, 'PPL', 'P'),
(48842, 'Latigo Trails', 39.4313888549805, 0.688207564153606, -77.0555572509766, -1.34487318098853, 218, 25, 'PPL', 'P'),
(33002, 'Latimer', 38.7388916015625, 0.676121207020445, -96.8452835083008, -1.69026906224721, 218, 20, 'PPL', 'P'),
(60579, 'Latimer', 30.5344390869141, 0.532926497316301, -88.8666687011719, -1.55101596411444, 218, 30, 'PPL', 'P'),
(82014, 'Latimer', 34.1319389343262, 0.595714714493636, -82.5927810668945, -1.44151596799614, 218, 48, 'PPL', 'P'),
(116414, 'Latimer', 42.7633285522461, 0.746360882348794, -93.3680572509766, -1.62958001522011, 218, 16, 'PPL', 'P'),
(156089, 'Latimer', 41.3566703796387, 0.721810065786708, -80.6180572509766, -1.40705053559083, 218, 41, 'PPL', 'P'),
(192667, 'Latimer', 38.1002807617188, 0.664975345226245, -113.315002441406, -1.97771988450795, 218, 52, 'PPL', 'P'),
(14091, 'Latimer Estates', 39.7319412231445, 0.693453192552735, -75.5749969482422, -1.31903252893149, 218, 10, 'PPL', 'P'),
(163598, 'Latimore', 40.0455589294434, 0.698926854120202, -77.1213912963867, -1.34602220184085, 218, 45, 'PPL', 'P'),
(95630, 'Latium', 30.0802803039551, 0.524999931226817, -96.5602798461914, -1.68529480996316, 218, 51, 'PPL', 'P'),
(3684, 'Lato', 32.3241691589355, 0.564163179795032, -85.1022186279297, -1.48531391580942, 218, 2, 'PPL', 'P'),
(55813, 'Latoh (historical)', 39.5974998474121, 0.691106747895294, -93.6363906860352, -1.63426331715507, 218, 29, 'PPL', 'P'),
(33003, 'Laton', 39.2855606079102, 0.685662381099817, -99.0763931274414, -1.72920927107413, 218, 20, 'PPL', 'P'),
(182736, 'Laton', 36.4333305358887, 0.635881575318647, -119.685829162598, -2.08891178686678, 218, 6, 'PPL', 'P'),
(3681, 'Laton Hill', 31.4888896942139, 0.549584802961342, -88.3680572509766, -1.54231355262039, 218, 2, 'PPL', 'P'),
(27682, 'Latona', 38.9805603027344, 0.680339121554912, -88.3116683959961, -1.54132938143955, 218, 18, 'PPL', 'P'),
(207888, 'Latona', 47.4833297729492, 0.828740444348215, -122.300003051758, -2.13453772845229, 218, 56, 'PPL', 'P'),
(207887, 'Latona (historical)', 47.6549987792969, 0.831736633732609, -122.320281982422, -2.13489166256116, 218, 56, 'PPL', 'P'),
(36809, 'Latonia', 39.0480613708496, 0.681517237442136, -84.5088882446289, -1.47495834706871, 218, 21, 'PPL', 'P'),
(60588, 'Latonia', 30.8608303070068, 0.538623098756522, -88.4277801513672, -1.54335591387105, 218, 30, 'PPL', 'P'),
(110028, 'Latonia', 38.9336090087891, 0.679519666887495, -80.9833297729492, -1.41342574376632, 218, 58, 'PPL', 'P'),
(36807, 'Latonia Lakes', 38.9674987792969, 0.680111154965602, -84.4977798461914, -1.47476446894135, 218, 21, 'PPL', 'P'),
(211962, 'Latouche', 60.0519409179688, 1.04810409123166, -147.898895263672, -2.58132268241332, 218, 1, 'PPL', 'P'),
(9992, 'Latour', 34.5761108398438, 0.603466976689775, -90.7411117553711, -1.58373116705136, 218, 4, 'PPL', 'P'),
(55814, 'Latour', 38.6344413757324, 0.674298206675258, -94.101936340332, -1.6423886216409, 218, 29, 'PPL', 'P'),
(201108, 'Latourell', 45.540828704834, 0.794837404986098, -122.220001220703, -2.13314143309276, 218, 43, 'PPL', 'P'),
(110029, 'Latrobe', 37.7905616760254, 0.65956972742463, -81.7688903808594, -1.42713636284832, 218, 58, 'PPL', 'P'),
(163601, 'Latrobe', 40.3211097717285, 0.703736123574722, -79.3797225952148, -1.38543751860624, 218, 45, 'PPL', 'P'),
(182737, 'Latrobe', 38.5597190856934, 0.672994056689447, -120.982780456543, -2.11154785718412, 218, 6, 'PPL', 'P'),
(73162, 'Latrobe (historical)', 39.0699996948242, 0.681900133427862, -82.5141677856445, -1.44014390740254, 218, 41, 'PPL', 'P'),
(48843, 'Latrobe Homes', 39.2994384765625, 0.68590459560096, -76.6033325195313, -1.33698037046586, 218, 25, 'PPL', 'P'),
(76340, 'Latta', 34.746940612793, 0.606448518688173, -96.7055587768555, -1.68783040563703, 218, 42, 'PPL', 'P'),
(82016, 'Latta', 34.3369407653809, 0.599292671418158, -79.4313888549805, -1.38633926495134, 218, 48, 'PPL', 'P'),
(88451, 'Latta (historical)', 35.7041702270508, 0.623155327154568, -87.1013870239258, -1.52020598662137, 218, 50, 'PPL', 'P'),
(163600, 'Latta Grove', 40.3072204589844, 0.703493709336497, -77.9866714477539, -1.36112418943436, 218, 45, 'PPL', 'P'),
(82017, 'Lattakoo (historical)', 34.2094383239746, 0.597067334011288, -81.3541717529297, -1.41989815732159, 218, 48, 'PPL', 'P'),
(156090, 'Lattasburg', 40.8786087036133, 0.713466315512463, -82.1086120605469, -1.43306562469927, 218, 41, 'PPL', 'P'),
(73164, 'Lattaville', 39.3480606079102, 0.686753211882314, -83.2063903808594, -1.45222547084573, 218, 41, 'PPL', 'P'),
(110030, 'Lattimer', 38.8419418334961, 0.67791977286263, -81.5149993896484, -1.42270512911053, 218, 58, 'PPL', 'P'),
(163604, 'Lattimer', 40.9938888549805, 0.715478333716017, -75.961669921875, -1.32578124544986, 218, 45, 'PPL', 'P'),
(66254, 'Lattimore', 35.3180618286133, 0.616416464332231, -81.6608276367188, -1.42525031216432, 218, 33, 'PPL', 'P'),
(110031, 'Lattin (historical)', 38.0952796936035, 0.664888060121518, -82.1355590820313, -1.43353593894778, 218, 58, 'PPL', 'P'),
(150181, 'Lattingtown', 40.8952789306641, 0.713757265861554, -73.6013870239258, -1.28458653760214, 218, 40, 'PPL', 'P'),
(113626, 'Lattins Landing', 41.4491691589355, 0.723424474039514, -73.429443359375, -1.28158555452778, 218, 8, 'PPL', 'P'),
(150182, 'Lattintown', 41.6441688537598, 0.726827860754581, -74.0038909912109, -1.2916115570836, 218, 40, 'PPL', 'P'),
(3682, 'Lattiwood', 34.2727813720703, 0.598172878758807, -86.2841720581055, -1.50594289477123, 218, 2, 'PPL', 'P'),
(116415, 'Lattnerville', 42.4855613708496, 0.741512930479441, -90.8827819824219, -1.58620377896544, 218, 16, 'PPL', 'P'),
(55815, 'Latty', 37.9877815246582, 0.663011863133557, -90.8505630493164, -1.58564145250127, 218, 29, 'PPL', 'P'),
(116416, 'Latty', 40.9033317565918, 0.713897814188083, -91.1216735839844, -1.59037322396807, 218, 16, 'PPL', 'P'),
(156091, 'Latty', 41.0886116027832, 0.717131557541711, -84.5852813720703, -1.47629165866845, 218, 41, 'PPL', 'P'),
(192668, 'Latuda', 39.7038917541504, 0.692963636965351, -110.945281982422, -1.9363604601468, 218, 52, 'PPL', 'P'),
(66255, 'Lauada', 35.3727798461914, 0.617371473899133, -83.5041732788086, -1.45742276287108, 218, 33, 'PPL', 'P'),
(163602, 'Laubach', 41.2605590820313, 0.720132607195094, -76.3791732788086, -1.33306805366648, 218, 45, 'PPL', 'P'),
(95631, 'Lauback', 29.628059387207, 0.517107187283176, -97.9400024414063, -1.70937551201382, 218, 51, 'PPL', 'P'),
(55816, 'Laubinger Ford', 38.3413887023926, 0.669183472643707, -91.2452774047852, -1.59253051760909, 218, 29, 'PPL', 'P'),
(110032, 'Lauckport', 39.2533302307129, 0.685099854898565, -81.570556640625, -1.42367478606343, 218, 58, 'PPL', 'P'),
(123029, 'Laud', 41.0494384765625, 0.716447857510861, -85.4522171020508, -1.49142254155979, 218, 19, 'PPL', 'P'),
(41730, 'Lauderdale', 30.086109161377, 0.525101663980458, -90.914436340332, -1.58675625173358, 218, 22, 'PPL', 'P'),
(60580, 'Lauderdale', 32.5205612182617, 0.567590867855045, -88.5116729736328, -1.54482011983837, 218, 30, 'PPL', 'P'),
(136415, 'Lauderdale', 44.9986114501953, 0.785373928631529, -93.2055587768555, -1.62674388181723, 218, 28, 'PPL', 'P'),
(174924, 'Lauderdale', 42.7652816772461, 0.746394970810747, -88.5555572509766, -1.54558604496788, 218, 57, 'PPL', 'P'),
(3683, 'Lauderdale Beach', 34.8633308410645, 0.608479911388659, -87.5688934326172, -1.52836551272721, 218, 2, 'PPL', 'P'),
(16852, 'Lauderdale Harbors', 26.1055603027344, 0.455627980360643, -80.1258316040039, -1.3984595773884, 218, 12, 'PPL', 'P'),
(207889, 'Lauderdale Junction', 47.2030601501465, 0.823848816636985, -120.708061218262, -2.10675310195754, 218, 56, 'PPL', 'P'),
(16853, 'Lauderdale Lakes', 26.166109085083, 0.4566847559707, -80.208610534668, -1.39990434227977, 218, 12, 'PPL', 'P'),
(16854, 'Lauderdale-by-the-Sea', 26.1916694641113, 0.457130868742801, -80.0966720581055, -1.39795064730408, 218, 12, 'PPL', 'P'),
(16855, 'Lauderhill', 26.1399993896484, 0.456229055818673, -80.2136077880859, -1.39999156080547, 218, 12, 'PPL', 'P'),
(174925, 'Laudolff Beach', 43.8777809143066, 0.765811745423379, -88.3572235107422, -1.54212446818299, 218, 57, 'PPL', 'P'),
(30299, 'Lauer', 37.8791694641113, 0.661116225069639, -86.6016693115234, -1.51148426720941, 218, 19, 'PPL', 'P'),
(193251, 'Lauer', 47.2255592346191, 0.824241499739717, -118.728057861328, -2.07219552417851, 218, 56, 'PPL', 'P'),
(163603, 'Lauffer', 40.1500015258789, 0.700749721307334, -79.5875015258789, -1.3890639450626, 218, 45, 'PPL', 'P'),
(182738, 'Laugenour (historical)', 38.7397193908691, 0.676135654669359, -121.747222900391, -2.12488989477126, 218, 6, 'PPL', 'P'),
(30303, 'Laughery Switch', 39.1494407653809, 0.683286641670385, -85.2413864135742, -1.48774285188163, 218, 19, 'PPL', 'P'),
(30301, 'Laugheryville', 39.2280616760254, 0.684658835422048, -85.2969436645508, -1.48871250883453, 218, 19, 'PPL', 'P'),
(150183, 'Laughing Waters', 41.0363883972168, 0.716220090658632, -72.4297180175781, -1.2641370556978, 218, 40, 'PPL', 'P'),
(9993, 'Laughlin', 33.336669921875, 0.58183465178728, -93.0972213745117, -1.62485303744327, 218, 4, 'PPL', 'P'),
(60582, 'Laughlin', 33.7183303833008, 0.58849588346384, -90.7977828979492, -1.58472026508021, 218, 30, 'PPL', 'P'),
(82018, 'Laughlin', 34.1958312988281, 0.59682984662108, -79.475830078125, -1.38711491061882, 218, 48, 'PPL', 'P'),
(182739, 'Laughlin', 39.2797203063965, 0.685560448609094, -123.233329772949, -2.15082735273392, 218, 6, 'PPL', 'P'),
(190398, 'Laughlin', 35.167781829834, 0.613793583553639, -114.572219848633, -1.99966246767744, 218, 39, 'PPL', 'P'),
(163605, 'Laughlintown', 40.2119407653809, 0.701830764972825, -79.1980590820313, -1.38226689217044, 218, 45, 'PPL', 'P'),
(210556, 'Launiupoko', 20.8555603027344, 0.36399819463094, -156.649719238281, -2.73405337303271, 218, 15, 'PPL', 'P'),
(210557, 'LaupÃƒÂ¤hoehoe', 19.9869403839111, 0.348837917099069, -155.235000610352, -2.70936187498604, 218, 15, 'PPL', 'P'),
(36808, 'Laura', 37.725830078125, 0.658439947911191, -82.4430618286133, -1.43890287433456, 218, 21, 'PPL', 'P'),
(73165, 'Laura', 39.9947204589844, 0.698039555424015, -84.4080581665039, -1.47319853022038, 218, 41, 'PPL', 'P'),
(120309, 'Laura', 40.9213905334473, 0.714212999303094, -89.9263916015625, -1.56951161788504, 218, 18, 'PPL', 'P'),
(123030, 'Laura', 41.0999984741211, 0.717330295938059, -87.0666732788086, -1.51960011747338, 218, 19, 'PPL', 'P'),
(139265, 'Laura', 40.2213897705078, 0.701995681223328, -91.6013870239258, -1.59874580296111, 218, 29, 'PPL', 'P'),
(22569, 'Laura (historical)', 34.8161087036133, 0.607655729610306, -83.9111099243164, -1.46452514718221, 218, 13, 'PPL', 'P'),
(48849, 'Laura Lee Estates', 39.538330078125, 0.690074040603588, -76.9058303833008, -1.34225995416889, 218, 25, 'PPL', 'P'),
(110034, 'Laura Lee Mine', 39.3627815246582, 0.687010140348479, -80.3625030517578, -1.40259027339716, 218, 58, 'PPL', 'P'),
(66256, 'Lauradale', 34.8019409179688, 0.607408455103092, -77.4550018310547, -1.35184480409014, 218, 33, 'PPL', 'P'),
(9994, 'Lauratown', 36.0200004577637, 0.628667604557841, -91.0883331298828, -1.58979132326989, 218, 4, 'PPL', 'P'),
(111, 'Lauraville', 37.9602813720703, 0.662531894926098, -77.195556640625, -1.34731663128868, 218, 53, 'PPL', 'P'),
(48844, 'Lauraville', 39.3447189331055, 0.686694888654441, -76.5577774047852, -1.33618528372242, 218, 25, 'PPL', 'P'),
(14092, 'Laurel', 38.5563888549805, 0.672935933198656, -75.5716705322266, -1.31897447201973, 218, 10, 'PPL', 'P'),
(16856, 'Laurel', 27.1299991607666, 0.473507811418676, -82.4533309936523, -1.43908210507592, 218, 12, 'PPL', 'P'),
(30302, 'Laurel', 39.5008316040039, 0.689419568765701, -85.186393737793, -1.48678304862477, 218, 19, 'PPL', 'P'),
(48845, 'Laurel', 39.0991706848145, 0.682409263249258, -76.8486099243164, -1.34126126876011, 218, 25, 'PPL', 'P'),
(60583, 'Laurel', 31.6938896179199, 0.55316272659635, -89.1305618286133, -1.55562176806168, 218, 30, 'PPL', 'P'),
(66257, 'Laurel', 36.1797218322754, 0.631455268428881, -78.1888885498047, -1.36465354366899, 218, 33, 'PPL', 'P'),
(73166, 'Laurel', 38.9152793884277, 0.679199754661549, -84.1916732788086, -1.46942190147854, 218, 41, 'PPL', 'P'),
(78593, 'Laurel', 39.8252792358398, 0.695082248191537, -76.5100021362305, -1.33535144798512, 218, 45, 'PPL', 'P'),
(88455, 'Laurel', 35.7769393920898, 0.624425388678426, -83.4058303833008, -1.45570635554852, 218, 50, 'PPL', 'P'),
(103541, 'Laurel', 37.6427803039551, 0.656990455908888, -77.5091705322266, -1.35279022627712, 218, 53, 'PPL', 'P'),
(116417, 'Laurel', 41.8841705322266, 0.731016680254139, -92.9219436645508, -1.6217938642991, 218, 16, 'PPL', 'P'),
(136417, 'Laurel', 48.5149993896484, 0.846746475952405, -93.6744384765625, -1.63492737637288, 218, 28, 'PPL', 'P'),
(142210, 'Laurel', 42.4294395446777, 0.74053341983051, -97.0894393920898, -1.69453038630745, 218, 35, 'PPL', 'P'),
(150184, 'Laurel', 40.9694404602051, 0.71505162873036, -72.5625, -1.26645453847839, 218, 40, 'PPL', 'P'),
(182741, 'Laurel', 37.1166687011719, 0.647808076207377, -121.965278625488, -2.12869568512703, 218, 6, 'PPL', 'P'),
(196879, 'Laurel', 45.6691703796387, 0.797077389778964, -108.77082824707, -1.89840908303263, 218, 31, 'PPL', 'P'),
(201109, 'Laurel', 45.4186096191406, 0.792704279531972, -122.990562438965, -2.1465902634396, 218, 43, 'PPL', 'P'),
(207891, 'Laurel', 48.855281829834, 0.852685524920363, -122.488609313965, -2.13782952871768, 218, 56, 'PPL', 'P'),
(9995, 'Laurel (historical)', 35.5227813720703, 0.619989494408736, -93.0250015258789, -1.62359256329934, 218, 4, 'PPL', 'P'),
(103540, 'Laurel (historical)', 37.0133285522461, 0.64600445035912, -82.1986083984375, -1.4346363571102, 218, 53, 'PPL', 'P'),
(110035, 'Laurel (historical)', 38.9605598449707, 0.67999004771503, -79.9888916015625, -1.39606952346811, 218, 58, 'PPL', 'P'),
(200043, 'Laurel (historical)', 41.0222206115723, 0.715972816151418, -117.879173278809, -2.05737969324413, 218, 39, 'PPL', 'P'),
(48847, 'Laurel Acres', 38.6138916015625, 0.673939545455452, -77.083610534668, -1.34536280315494, 218, 25, 'PPL', 'P'),
(88456, 'Laurel Bank Estates', 35.7438888549805, 0.623848547986315, -84.0286102294922, -1.46657591437963, 218, 50, 'PPL', 'P'),
(82019, 'Laurel Bay', 32.4500007629395, 0.566359355587965, -80.7850036621094, -1.40996430013949, 218, 48, 'PPL', 'P'),
(113627, 'Laurel Beach', 41.1827812194824, 0.718775127408454, -73.0941696166992, -1.2757339238226, 218, 8, 'PPL', 'P'),
(14093, 'Laurel Bend', 39.1363906860352, 0.683058874818156, -75.5111083984375, -1.31791746338308, 218, 10, 'PPL', 'P'),
(88457, 'Laurel Bloomery', 36.5661087036133, 0.638198991520207, -81.7597198486328, -1.4269763068668, 218, 50, 'PPL', 'P'),
(88458, 'Laurel Bluff', 35.797779083252, 0.624789109904304, -84.5227813720703, -1.47520082788596, 218, 50, 'PPL', 'P'),
(48848, 'Laurel Branch', 38.6402816772461, 0.674400139165981, -77.0094375610352, -1.34406824054906, 218, 25, 'PPL', 'P'),
(103542, 'Laurel Branch', 36.9141693115234, 0.644273795124732, -80.3930587768555, -1.40312357140545, 218, 53, 'PPL', 'P'),
(110036, 'Laurel Branch', 37.5305595397949, 0.655031834085189, -80.3499984741211, -1.40237202734583, 218, 58, 'PPL', 'P'),
(22571, 'Laurel Brook', 33.8883285522461, 0.591462911234298, -84.4000015258789, -1.47305791531483, 218, 13, 'PPL', 'P'),
(48854, 'Laurel Brook', 39.5066719055176, 0.689521501256424, -76.4291687011719, -1.33394063839765, 218, 25, 'PPL', 'P'),
(88459, 'Laurel Brook', 35.4944381713867, 0.619494812236254, -85.1122207641602, -1.48548848601888, 218, 50, 'PPL', 'P'),
(22570, 'Laurel Chase', 33.8427810668945, 0.590667957648909, -83.4861068725586, -1.45710744459801, 218, 13, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(48851, 'Laurel Chase Manor', 39.526668548584, 0.689870508517279, -75.9388885498047, -1.32538363549911, 218, 25, 'PPL', 'P'),
(88460, 'Laurel Cove (historical)', 35.7338905334473, 0.623674044355888, -85.5111083984375, -1.49245038858251, 218, 50, 'PPL', 'P'),
(14094, 'Laurel Creek', 38.5555610656738, 0.672921485549742, -75.5602798461914, -1.31877566704435, 218, 10, 'PPL', 'P'),
(22572, 'Laurel Creek', 33.7958297729492, 0.589848502981492, -84.0458297729492, -1.46687645210864, 218, 13, 'PPL', 'P'),
(36811, 'Laurel Creek', 37.2449989318848, 0.65004786126316, -83.748893737793, -1.46169394062735, 218, 21, 'PPL', 'P'),
(88462, 'Laurel Creek', 35.7627792358398, 0.624178247329267, -85.5599975585938, -1.49330366539577, 218, 50, 'PPL', 'P'),
(110037, 'Laurel Creek', 37.8572196960449, 0.660733129346831, -80.9938888549805, -1.41361003451375, 218, 58, 'PPL', 'P'),
(22573, 'Laurel Crest Subdivision', 32.4930610656738, 0.567110899647586, -83.7033309936523, -1.46089872072585, 218, 13, 'PPL', 'P'),
(110038, 'Laurel Dale', 39.3083305358887, 0.686059791313484, -79.0922164916992, -1.38041959048031, 218, 58, 'PPL', 'P'),
(22574, 'Laurel Falls', 34.8591690063477, 0.608407273669927, -83.397216796875, -1.45555602010499, 218, 13, 'PPL', 'P'),
(78594, 'Laurel Falls', 39.8169403076172, 0.694936706437964, -79.1191711425781, -1.38089003788687, 218, 45, 'PPL', 'P'),
(145577, 'Laurel Farms', 40.6930618286133, 0.710227911626926, -74.7811126708984, -1.30517663441203, 218, 37, 'PPL', 'P'),
(36812, 'Laurel Ford', 36.8133316040039, 0.642513845118354, -83.5505599975586, -1.45823236384246, 218, 21, 'PPL', 'P'),
(88463, 'Laurel Fork', 36.2058296203613, 0.631910935291394, -82.0027770996094, -1.43121845616719, 218, 50, 'PPL', 'P'),
(103543, 'Laurel Fork', 36.7174987792969, 0.640841246795729, -80.5188903808594, -1.40531974719839, 218, 53, 'PPL', 'P'),
(110039, 'Laurel Fork', 38.6891708374023, 0.675253415979243, -80.6750030517578, -1.40804442730965, 218, 58, 'PPL', 'P'),
(163611, 'Laurel Gardens', 40.5275001525879, 0.707338315265163, -80.0252838134766, -1.39670468738809, 218, 45, 'PPL', 'P'),
(113628, 'Laurel Glen', 41.4722213745117, 0.723826811101198, -71.8152770996094, -1.25341303862027, 218, 8, 'PPL', 'P'),
(16857, 'Laurel Grove', 30.1552791595459, 0.526308908192104, -81.7013931274414, -1.42595831354012, 218, 12, 'PPL', 'P'),
(22575, 'Laurel Grove', 34.1547203063965, 0.596112324444385, -84.2958297729492, -1.47123977523863, 218, 13, 'PPL', 'P'),
(41740, 'Laurel Grove', 29.8236103057861, 0.520520194667681, -90.8788909912109, -1.58613586835764, 218, 22, 'PPL', 'P'),
(48852, 'Laurel Grove', 38.4116706848145, 0.670410124641797, -76.6780624389648, -1.33828465360973, 218, 25, 'PPL', 'P'),
(88464, 'Laurel Grove', 36.1172218322754, 0.630364437646385, -84.2355575561523, -1.47018782660805, 218, 50, 'PPL', 'P'),
(103547, 'Laurel Grove', 36.9797210693359, 0.64541788912903, -82.6527786254883, -1.44256312293676, 218, 53, 'PPL', 'P'),
(163606, 'Laurel Grove', 40.1525001525879, 0.700793330570184, -77.7108306884766, -1.35630985997377, 218, 45, 'PPL', 'P'),
(201110, 'Laurel Grove', 43.0258293151855, 0.750942384951085, -124.413612365723, -2.17142717008179, 218, 43, 'PPL', 'P'),
(103548, 'Laurel Grove Estates', 37.6588897705078, 0.657271619140973, -77.3905563354492, -1.35072001800375, 218, 53, 'PPL', 'P'),
(41731, 'Laurel Grove Plantation', 29.827220916748, 0.520583211716975, -90.8786087036133, -1.58613094150963, 218, 22, 'PPL', 'P'),
(71014, 'Laurel Harbor', 39.860279083252, 0.695693110766573, -74.1344375610352, -1.29389002455422, 218, 37, 'PPL', 'P'),
(22580, 'Laurel Heights', 33.6841697692871, 0.587899668274799, -84.7983322143555, -1.48001009734048, 218, 13, 'PPL', 'P'),
(16858, 'Laurel Hill', 30.9655609130859, 0.540450992660211, -86.459716796875, -1.50900672844731, 218, 12, 'PPL', 'P'),
(22576, 'Laurel Hill', 33.4327812194824, 0.583512110378893, -82.0569381713867, -1.43216374519611, 218, 13, 'PPL', 'P'),
(41732, 'Laurel Hill', 30.9533290863037, 0.540237507009328, -91.3402786254883, -1.59418860170377, 218, 22, 'PPL', 'P'),
(60584, 'Laurel Hill', 32.7311096191406, 0.571265630685191, -89.3163909912109, -1.55886509879523, 218, 30, 'PPL', 'P'),
(66262, 'Laurel Hill', 34.8088912963867, 0.607529762090746, -79.5480575561523, -1.38837551792081, 218, 33, 'PPL', 'P'),
(82021, 'Laurel Hill', 32.7216682434082, 0.571100847592742, -80.2866668701172, -1.4012666823354, 218, 48, 'PPL', 'P'),
(88465, 'Laurel Hill', 36.1027793884277, 0.630112369449209, -85.8130569458008, -1.49772038490561, 218, 50, 'PPL', 'P'),
(95632, 'Laurel Hill', 30.6027793884277, 0.534119260589521, -95.2130584716797, -1.66178136122469, 218, 51, 'PPL', 'P'),
(103549, 'Laurel Hill', 38.1908302307129, 0.666555731596126, -78.9622192382813, -1.37815071038962, 218, 53, 'PPL', 'P'),
(163608, 'Laurel Hill', 40.3675003051758, 0.704545791125133, -80.230827331543, -1.40029209853448, 218, 45, 'PPL', 'P'),
(169458, 'Laurel Hill', 41.9677810668945, 0.732475959373448, -71.7094421386719, -1.25156587008819, 218, 47, 'PPL', 'P'),
(103550, 'Laurel Hill (historical)', 37.0911102294922, 0.647361996724788, -78.2552795410156, -1.36581228505928, 218, 53, 'PPL', 'P'),
(82023, 'Laurel Hill Plantation', 33.0538902282715, 0.576899215076118, -79.5486068725586, -1.38838510530074, 218, 48, 'PPL', 'P'),
(22579, 'Laurel Hills', 32.5177803039551, 0.567542331744179, -84.9872207641602, -1.48330682445389, 218, 13, 'PPL', 'P'),
(82024, 'Laurel Hills', 34.9383316040039, 0.60978892164346, -82.2763900756836, -1.43599390347587, 218, 48, 'PPL', 'P'),
(103553, 'Laurel Hills', 37.2444381713867, 0.650038074146154, -80.0449981689453, -1.39704876780093, 218, 53, 'PPL', 'P'),
(66264, 'Laurel Hollow', 35.9338912963867, 0.627164716175682, -81.3933334350586, -1.42058165761536, 218, 33, 'PPL', 'P'),
(150185, 'Laurel Hollow', 40.8566703796387, 0.713083419526736, -73.4700012207031, -1.28229342274552, 218, 40, 'PPL', 'P'),
(163609, 'Laurel Junction', 40.8405609130859, 0.712802256294651, -76.0580596923828, -1.32746356431047, 218, 45, 'PPL', 'P'),
(110041, 'Laurel Junction (historical)', 39.1944389343262, 0.684072007875849, -81.2994384765625, -1.41894288143858, 218, 58, 'PPL', 'P'),
(71013, 'Laurel Lake', 39.3394393920898, 0.686602743280724, -75.0302810668945, -1.30952544331407, 218, 37, 'PPL', 'P'),
(163610, 'Laurel Lake', 41.9569396972656, 0.732286741777998, -75.9186096191406, -1.32502970139024, 218, 45, 'PPL', 'P'),
(82025, 'Laurel Lakes', 33.5722198486328, 0.585945773562035, -81.9180603027344, -1.42973986912998, 218, 48, 'PPL', 'P'),
(103554, 'Laurel Lakes', 37.6488914489746, 0.657097115510546, -77.5152816772461, -1.35289688587878, 218, 53, 'PPL', 'P'),
(103555, 'Laurel Manor', 36.8547210693359, 0.643236227564038, -76.019172668457, -1.32678485770666, 218, 53, 'PPL', 'P'),
(82026, 'Laurel Meadows', 34.000560760498, 0.593421732795078, -81.1425018310547, -1.41620382025743, 218, 48, 'PPL', 'P'),
(103556, 'Laurel Mills', 38.6480598449707, 0.674535893802548, -78.0894393920898, -1.36291782842853, 218, 53, 'PPL', 'P'),
(14095, 'Laurel Mobile Home Park', 38.5602798461914, 0.673003843806453, -75.5586090087891, -1.31874650543042, 218, 10, 'PPL', 'P'),
(163615, 'Laurel Mountain Park', 40.211109161377, 0.701816250744884, -79.1852798461914, -1.38204385242915, 218, 45, 'PPL', 'P'),
(163612, 'Laurel Mountain Village', 40.1688919067383, 0.701079420650286, -79.1397171020508, -1.38124863252765, 218, 45, 'PPL', 'P'),
(66267, 'Laurel Park', 36.124439239502, 0.630490405165945, -81.6811065673828, -1.42560424627319, 218, 33, 'PPL', 'P'),
(103558, 'Laurel Park', 36.6886100769043, 0.64033704382235, -79.8008270263672, -1.39278717742458, 218, 53, 'PPL', 'P'),
(125214, 'Laurel Park', 42.3583297729492, 0.739292320183506, -72.6416702270508, -1.26783631960997, 218, 23, 'PPL', 'P'),
(145578, 'Laurel Park', 40.4569396972656, 0.706106802998083, -74.3138885498047, -1.29702203515421, 218, 37, 'PPL', 'P'),
(163614, 'Laurel Park', 40.8705596923828, 0.713325833764961, -77.1833267211914, -1.34710317892731, 218, 45, 'PPL', 'P'),
(169456, 'Laurel Park', 41.7186088562012, 0.728127083892376, -71.2636108398438, -1.24378464601519, 218, 47, 'PPL', 'P'),
(66268, 'Laurel Park Villas', 35.3105583190918, 0.616285503385626, -82.4841690063477, -1.43962032993223, 218, 33, 'PPL', 'P'),
(110042, 'Laurel Point', 39.6191711425781, 0.691484983349112, -80.0083312988281, -1.39640881019098, 218, 58, 'PPL', 'P'),
(41734, 'Laurel Ridge', 30.1622200012207, 0.526430048732189, -91.116943359375, -1.59029066597428, 218, 22, 'PPL', 'P'),
(88467, 'Laurel Ridge', 35.1811103820801, 0.614026210674858, -84.8916702270508, -1.48163915297928, 218, 50, 'PPL', 'P'),
(103559, 'Laurel Ridge', 37.2683296203613, 0.650455058593834, -80.4486083984375, -1.4040930952003, 218, 53, 'PPL', 'P'),
(41735, 'Laurel Ridge Plantation', 29.9894409179688, 0.523414484850865, -90.790283203125, -1.58458937071264, 218, 22, 'PPL', 'P'),
(66269, 'Laurel Rock Acres', 35.2841682434082, 0.615824909675097, -82.4802780151367, -1.43955241932443, 218, 33, 'PPL', 'P'),
(168, 'Laurel Run', 39.6511116027832, 0.692042449544293, -79.7227783203125, -1.39142497052701, 218, 58, 'PPL', 'P'),
(48855, 'Laurel Run', 38.2133293151855, 0.666948414698858, -76.4316711425781, -1.33398431423952, 218, 25, 'PPL', 'P'),
(163616, 'Laurel Run', 41.2222213745117, 0.719463487971212, -75.8633270263672, -1.32406483812731, 218, 45, 'PPL', 'P'),
(3688, 'Laurel Shanty Landing', 31.2297191619873, 0.545061423849843, -87.9891662597656, -1.53570065731761, 218, 2, 'PPL', 'P'),
(66270, 'Laurel Springs', 36.4113883972168, 0.635498612753894, -81.2630615234375, -1.4183079838347, 218, 33, 'PPL', 'P'),
(71023, 'Laurel Springs', 39.8199996948242, 0.69499010281782, -75.0066680908203, -1.30911331913538, 218, 37, 'PPL', 'P'),
(88468, 'Laurel Springs', 35.1866683959961, 0.614123216317564, -84.897216796875, -1.4817359588849, 218, 50, 'PPL', 'P'),
(103567, 'Laurel Springs Crossroads', 37.1222190856934, 0.647904948692028, -77.1324996948242, -1.3462160799682, 218, 53, 'PPL', 'P'),
(163618, 'Laurel Summit', 40.1158294677734, 0.700153306381211, -79.1755599975586, -1.38187420906771, 218, 45, 'PPL', 'P'),
(103560, 'Laurel Terrace', 37.2936096191406, 0.650896277807432, -79.9302825927734, -1.39504660329341, 218, 53, 'PPL', 'P'),
(48856, 'Laurel Valley', 39.4861106872559, 0.689162640299536, -76.3125, -1.33190438542817, 218, 25, 'PPL', 'P'),
(88469, 'Laurel Valley', 35.1805610656738, 0.614016623294933, -84.9000015258789, -1.4817845615748, 218, 50, 'PPL', 'P'),
(41736, 'Laurel Valley Plantation', 29.812219619751, 0.520321389692306, -90.7716674804688, -1.58426446505965, 218, 22, 'PPL', 'P'),
(16859, 'Laurel Villa', 27.1499996185303, 0.473856885258558, -82.4563903808594, -1.43913550145578, 218, 12, 'PPL', 'P'),
(103561, 'Laurel Village', 37.6405601501465, 0.656951706915027, -77.519172668457, -1.35296479648657, 218, 53, 'PPL', 'P'),
(103562, 'Laurel West', 37.6680603027344, 0.657431675122487, -77.4944381713867, -1.35253309807387, 218, 53, 'PPL', 'P'),
(48857, 'Laurel Wood', 39.0463905334473, 0.6814880758282, -76.8397216796875, -1.34110613962661, 218, 25, 'PPL', 'P'),
(66272, 'Laurel Wood Hills', 35.672779083252, 0.622607448339311, -79.795280456543, -1.39269037151896, 218, 33, 'PPL', 'P'),
(163619, 'Laurel Wood Mobile Home Park', 40.1333312988281, 0.700458770958243, -76.8108291625977, -1.34060187007421, 218, 45, 'PPL', 'P'),
(22586, 'Laurel Woods', 33.5877799987793, 0.586217349414196, -84.4836120605469, -1.47451719443413, 218, 13, 'PPL', 'P'),
(48858, 'Laurel Woods', 39.4847183227539, 0.689138338954589, -76.3194427490234, -1.33202555925777, 218, 25, 'PPL', 'P'),
(103563, 'Laurel Woods', 37.3244400024414, 0.651434369505683, -80.0519409179688, -1.39716994163053, 218, 53, 'PPL', 'P'),
(163620, 'Laurel Woods', 40.2400016784668, 0.70232052029729, -76.6549987792969, -1.33788211681096, 218, 45, 'PPL', 'P'),
(88471, 'Laurelburg', 35.7216682434082, 0.623460725152572, -85.5805587768555, -1.49366252635266, 218, 50, 'PPL', 'P'),
(48859, 'Laurelcrest', 39.5213890075684, 0.689778363143562, -77.496940612793, -1.35257677391575, 218, 25, 'PPL', 'P'),
(48860, 'Laureldale', 39.3813896179199, 0.687334912843414, -76.543327331543, -1.33593308236719, 218, 25, 'PPL', 'P'),
(71016, 'Laureldale', 39.4991683959961, 0.689390540309819, -74.6855621337891, -1.30350896293742, 218, 37, 'PPL', 'P'),
(103564, 'Laureldale', 36.6236114501953, 0.639202603777003, -81.7622222900391, -1.42701998270868, 218, 53, 'PPL', 'P'),
(163621, 'Laureldale', 40.3880615234375, 0.704904652082021, -75.918327331543, -1.32502477454223, 218, 45, 'PPL', 'P'),
(95633, 'Laureles', 26.1088905334473, 0.455686103851433, -97.4938888549805, -1.70158936109281, 218, 51, 'PPL', 'P'),
(48861, 'Laurelford', 39.4661102294922, 0.688813566459654, -76.6774978637695, -1.3382747999137, 218, 25, 'PPL', 'P'),
(201111, 'Laurelhurst', 45.5263900756836, 0.794585403367949, -122.621673583984, -2.14015193834628, 218, 43, 'PPL', 'P'),
(207892, 'Laurelhurst', 47.6636085510254, 0.831886902597117, -122.275833129883, -2.13411588373562, 218, 56, 'PPL', 'P'),
(163623, 'Laurella', 41.5936088562012, 0.725945422327383, -75.2094421386719, -1.31265239390799, 218, 45, 'PPL', 'P'),
(145582, 'Laurelton', 40.0686111450195, 0.699329191181886, -74.1308288574219, -1.29382704079444, 218, 37, 'PPL', 'P'),
(150186, 'Laurelton', 40.6666717529297, 0.709767317916397, -73.7519378662109, -1.28721414549166, 218, 40, 'PPL', 'P'),
(163624, 'Laurelton', 40.8830604553223, 0.713544013237266, -77.1988906860352, -1.3473748213585, 218, 45, 'PPL', 'P'),
(145579, 'Laurelton Gardens', 40.0741691589355, 0.699426196824592, -74.1344375610352, -1.29389002455422, 218, 37, 'PPL', 'P'),
(48862, 'Laurelvale', 39.4966697692871, 0.689346931046969, -76.4188919067383, -1.33376127449823, 218, 25, 'PPL', 'P'),
(73168, 'Laurelville', 39.473331451416, 0.688939600558242, -82.7394409179688, -1.44407566527787, 218, 41, 'PPL', 'P'),
(163625, 'Laurelville', 40.1430587768555, 0.700628547477736, -79.4847183227539, -1.38727003975232, 218, 45, 'PPL', 'P'),
(22581, 'Laurelwood', 33.5758285522461, 0.586008757321815, -84.4447174072266, -1.47383835467227, 218, 13, 'PPL', 'P'),
(82030, 'Laurelwood', 35.0541687011719, 0.611810660384993, -81.9569396972656, -1.43041844257573, 218, 48, 'PPL', 'P'),
(201112, 'Laurelwood', 45.4230613708496, 0.792781977256775, -123.079719543457, -2.14814634846454, 218, 43, 'PPL', 'P'),
(22582, 'Laurelwood Estates', 34.9041709899902, 0.609192706454418, -85.3255615234375, -1.48921198469697, 218, 13, 'PPL', 'P'),
(66274, 'Laurelwood Hills', 35.5394401550293, 0.620280245020745, -78.3530578613281, -1.3675188386858, 218, 33, 'PPL', 'P'),
(136418, 'Lauren', 47.1847190856934, 0.823528704673958, -91.6975021362305, -1.60042332813176, 218, 28, 'PPL', 'P'),
(14096, 'Lauren Farms', 39.601390838623, 0.691174658503091, -75.6847229003906, -1.32094760807137, 218, 10, 'PPL', 'P'),
(82031, 'Laurence (historical)', 33.0636100769043, 0.577068858437556, -80.2563934326172, -1.40073831117512, 218, 48, 'PPL', 'P'),
(145580, 'Laurence Harbor', 40.4566688537598, 0.706102075887148, -74.246940612793, -1.29585357322593, 218, 37, 'PPL', 'P'),
(3689, 'Laurendine', 30.4977798461914, 0.53228667286441, -88.1699981689453, -1.53885676952547, 218, 2, 'PPL', 'P'),
(82032, 'Laurens', 34.4988899230957, 0.602119217441113, -82.0144424438477, -1.43142205483253, 218, 48, 'PPL', 'P'),
(116418, 'Laurens', 42.8466682434082, 0.747815434357168, -94.8516693115234, -1.65547393049895, 218, 16, 'PPL', 'P'),
(150187, 'Laurens', 42.5305595397949, 0.742298296684906, -75.0899963378906, -1.31056767140668, 218, 40, 'PPL', 'P'),
(22584, 'Laurens Hill', 32.5205612182617, 0.567590867855045, -83.146110534668, -1.4511733890571, 218, 13, 'PPL', 'P'),
(41737, 'Laurents Point', 30.0616703033447, 0.524675125442368, -92.6708297729492, -1.61741110009315, 218, 22, 'PPL', 'P'),
(120310, 'Laurette', 40.3252792358398, 0.703808894451508, -88.543327331543, -1.54537259260651, 218, 18, 'PPL', 'P'),
(48863, 'Laurian', 38.7136116027832, 0.675679987806846, -76.6588897705078, -1.33795002741876, 218, 25, 'PPL', 'P'),
(55817, 'Laurie', 38.1991691589355, 0.666701273349698, -92.8333282470703, -1.62024723349603, 218, 29, 'PPL', 'P'),
(207893, 'Laurier', 48.9988899230957, 0.855191958980291, -118.22306060791, -2.06338165939284, 218, 56, 'PPL', 'P'),
(196880, 'Laurin', 45.3527793884277, 0.791555325258684, -112.117218017578, -1.95681460258305, 218, 31, 'PPL', 'P'),
(66276, 'Laurinburg', 34.7738914489746, 0.606918899515709, -79.4630584716797, -1.38689200403558, 218, 33, 'PPL', 'P'),
(131706, 'Laurium', 47.2374992370605, 0.824449892095016, -88.4430618286133, -1.54362262945422, 218, 27, 'PPL', 'P'),
(163626, 'Laurys Station', 40.7230606079102, 0.710751489097236, -75.5305633544922, -1.31825701642206, 218, 45, 'PPL', 'P'),
(193077, 'Lautz', 36.1872215270996, 0.631586162796459, -102.031387329102, -1.78078364927045, 218, 51, 'PPL', 'P'),
(190399, 'Lauville (historical)', 38.7955589294434, 0.677110238470273, -116.516387939453, -2.03359460207447, 218, 39, 'PPL', 'P'),
(150189, 'Lava', 41.6166687011719, 0.726347892547121, -75.0194396972656, -1.30933622571862, 218, 40, 'PPL', 'P'),
(188864, 'Lava', 33.4786109924316, 0.584311990812299, -107.015281677246, -1.8677690152171, 218, 38, 'PPL', 'P'),
(182742, 'Lava Beds (historical)', 39.4741706848145, 0.688954247944237, -121.56916809082, -2.12178225209524, 218, 6, 'PPL', 'P'),
(195219, 'Lava Hot Springs', 42.6194381713867, 0.74384952144085, -112.010276794434, -1.95494812613307, 218, 17, 'PPL', 'P'),
(3690, 'Lavaca', 32.1402816772461, 0.56095373778635, -88.0800018310547, -1.53728603711454, 218, 2, 'PPL', 'P'),
(9996, 'Lavaca', 35.336109161377, 0.61673144971016, -94.1730575561523, -1.64362992102498, 218, 4, 'PPL', 'P'),
(41738, 'Lavacco', 31.5588893890381, 0.550806528111416, -91.9888916015625, -1.60550903370743, 218, 22, 'PPL', 'P'),
(201113, 'Lavadoure (historical)', 42.9444389343262, 0.749521854825637, -123.099998474121, -2.14850028257341, 218, 43, 'PPL', 'P'),
(110043, 'Lavalette', 38.3227806091309, 0.668858700148772, -82.4469375610352, -1.43897051862625, 218, 58, 'PPL', 'P'),
(48864, 'Lavall', 38.9786109924316, 0.680305099671987, -76.6255569458008, -1.33736825987863, 218, 25, 'PPL', 'P'),
(48865, 'Lavall Woods', 38.9769401550293, 0.68027593805805, -76.6277770996094, -1.33740700887249, 218, 25, 'PPL', 'P'),
(55746, 'LaValle', 36.6752815246582, 0.640104416701132, -89.7736129760742, -1.5668451278436, 218, 29, 'PPL', 'P'),
(71017, 'Lavallette', 39.9702796936035, 0.697612983596412, -74.0691680908203, -1.29275085739794, 218, 37, 'PPL', 'P'),
(163628, 'Lavansville', 40.0158309936523, 0.698408003760828, -79.1536102294922, -1.3814911133449, 218, 45, 'PPL', 'P'),
(178512, 'Laveen', 33.3627815246582, 0.582290385228819, -112.168609619141, -1.95771155523819, 218, 5, 'PPL', 'P'),
(204657, 'Lavell', 41.1758308410645, 0.718653820420801, -112.061393737793, -1.95584028509824, 218, 52, 'PPL', 'P'),
(163629, 'Lavelle', 40.7633285522461, 0.711454297308908, -76.383056640625, -1.33313583111623, 218, 45, 'PPL', 'P'),
(22585, 'Lavender', 34.2919387817383, 0.598507238633666, -85.3411102294922, -1.48948336081205, 218, 13, 'PPL', 'P'),
(88472, 'Lavender', 36.1894416809082, 0.631624911790319, -84.7677764892578, -1.47947679933219, 218, 50, 'PPL', 'P'),
(95635, 'Lavender', 31.5344390869141, 0.550379789836245, -96.6555633544922, -1.68695782090586, 218, 51, 'PPL', 'P'),
(207894, 'Lavender', 47.204719543457, 0.82387777851384, -121.111106872559, -2.11378757566088, 218, 56, 'PPL', 'P'),
(131705, 'Lavender Corner', 46.5016708374023, 0.8116072637913, -85.9397201538086, -1.49993107492649, 218, 27, 'PPL', 'P'),
(188825, 'LaVentana', 35.827220916748, 0.625302966836635, -106.970832824707, -1.86699323639156, 218, 38, 'PPL', 'P'),
(76341, 'Laverne', 36.7097206115723, 0.640705492159162, -99.8930587768555, -1.74346277554435, 218, 42, 'PPL', 'P'),
(163630, 'Laverock', 40.0950012207031, 0.699789784892415, -75.1813888549805, -1.31216277174158, 218, 45, 'PPL', 'P'),
(127923, 'Lavertue', 47.2486114501953, 0.824643836801401, -68.2019424438477, -1.19034845190081, 218, 26, 'PPL', 'P'),
(76343, 'Laverty', 34.9905586242676, 0.610700455105567, -98.0749969482422, -1.71173161063022, 218, 42, 'PPL', 'P'),
(163631, 'Lavery', 41.8800010681152, 0.730943909377353, -80.225830078125, -1.40020488000878, 218, 45, 'PPL', 'P'),
(150190, 'Laverys Corner', 44.7691688537598, 0.781369399879404, -74.6716690063477, -1.30326648212017, 218, 40, 'PPL', 'P'),
(182743, 'Lavic', 34.7277793884277, 0.606114092234287, -116.3125, -2.0300360862259, 218, 6, 'PPL', 'P'),
(207895, 'Lavilla', 47.6972198486328, 0.832473530406234, -122.273887634277, -2.13408192843172, 218, 56, 'PPL', 'P'),
(196881, 'Lavina', 46.2947196960449, 0.807995284983852, -108.937217712402, -1.90131312704331, 218, 31, 'PPL', 'P'),
(88473, 'Lavinia', 35.8491706848145, 0.625686062559443, -88.6608276367188, -1.54742335980393, 218, 50, 'PPL', 'P'),
(116419, 'Lavinia', 42.4077796936035, 0.740155384113773, -94.7463912963867, -1.65363648250485, 218, 16, 'PPL', 'P'),
(136421, 'Lavinia', 47.4724998474121, 0.828551426489847, -92.9461135864258, -1.62221570901577, 218, 28, 'PPL', 'P'),
(66277, 'Lavinia (historical)', 35.4319381713867, 0.618403981453757, -82.9252777099609, -1.44731912916948, 218, 33, 'PPL', 'P'),
(103565, 'Lavino Village', 37.4513893127441, 0.653650052953602, -79.1833267211914, -1.3820097639672, 218, 53, 'PPL', 'P'),
(193253, 'Lavista', 47.1430587768555, 0.822801595117339, -117.705001831055, -2.05433982801786, 218, 56, 'PPL', 'P'),
(95636, 'Lavon', 33.0275001525879, 0.576438621365588, -96.4338912963867, -1.68308891363225, 218, 51, 'PPL', 'P'),
(190400, 'Lavon', 39.3277816772461, 0.686399277773442, -114.795829772949, -2.0035651970969, 218, 39, 'PPL', 'P'),
(95639, 'Lavon Beach Estates', 33.1138916015625, 0.577946436595764, -96.4497222900391, -1.68336521659535, 218, 51, 'PPL', 'P'),
(95637, 'Lavon Lake Lodges', 33.0377807617188, 0.576618051844032, -96.5022201538086, -1.68428147716839, 218, 51, 'PPL', 'P'),
(95638, 'Lavon Shores Estates', 33.1061096191406, 0.57781061538017, -96.4786071777344, -1.6838693529897, 218, 51, 'PPL', 'P'),
(22587, 'Lavonia', 34.4358291625977, 0.601018599541611, -83.1069412231445, -1.45048975560528, 218, 13, 'PPL', 'P'),
(88474, 'Law', 35.7630615234375, 0.624183174177284, -88.6052780151367, -1.54645383600908, 218, 50, 'PPL', 'P'),
(88475, 'Law Chapel', 35.7213897705078, 0.623455864883583, -83.8777770996094, -1.46394337964208, 218, 50, 'PPL', 'P'),
(210563, 'Lawai', 21.9219398498535, 0.382610028804095, -159.50944519043, -2.78396500660243, 218, 15, 'PPL', 'P'),
(73169, 'Lawco', 38.6394386291504, 0.674385425200959, -82.7022171020508, -1.44342598712995, 218, 41, 'PPL', 'P'),
(201114, 'Lawen', 43.4430618286133, 0.75822446605677, -118.800003051758, -2.07345120463249, 218, 43, 'PPL', 'P'),
(103566, 'Lawford', 37.6163902282715, 0.656529862198359, -78.2772216796875, -1.36619524762403, 218, 53, 'PPL', 'P'),
(110044, 'Lawford', 39.0686111450195, 0.681875898661943, -80.936393737793, -1.41260655541501, 218, 58, 'PPL', 'P'),
(41739, 'Lawhon', 32.3763885498047, 0.565074580099084, -93.2202835083008, -1.62700087686242, 218, 22, 'PPL', 'P'),
(16860, 'Lawhons Mill', 30.166109085083, 0.526497926050473, -84.4022216796875, -1.47309666430869, 218, 12, 'PPL', 'P'),
(36813, 'Lawhorn Hill', 37.2999992370605, 0.651007797678079, -84.853889465332, -1.48097975429337, 218, 21, 'PPL', 'P'),
(211963, 'Lawing', 60.4022216796875, 1.05421764383005, -149.364440917969, -2.6069012794191, 218, 1, 'PPL', 'P'),
(55818, 'Lawing (historical)', 36.9238891601563, 0.64444343848617, -93.1694412231445, -1.62611351158721, 218, 29, 'PPL', 'P'),
(27683, 'Lawler', 37.7280616760254, 0.658478896642133, -88.2858276367188, -1.54087837510895, 218, 18, 'PPL', 'P'),
(116420, 'Lawler', 43.0705604553223, 0.751723090624642, -92.1500015258789, -1.60832093234439, 218, 16, 'PPL', 'P'),
(136422, 'Lawler', 46.5361099243164, 0.81220833924933, -93.170280456543, -1.6261281589732, 218, 28, 'PPL', 'P'),
(3694, 'Lawley', 33.5011100769043, 0.584704673915031, -86.4475021362305, -1.50879354240205, 218, 2, 'PPL', 'P'),
(195220, 'Lawman Ford', 45.1100006103516, 0.787318036227286, -115.60888671875, -2.01775571780733, 218, 17, 'PPL', 'P'),
(95640, 'Lawn', 32.1347198486328, 0.560856665564616, -99.7494430541992, -1.74095620832637, 218, 51, 'PPL', 'P'),
(110045, 'Lawn', 37.8397216796875, 0.660427731348826, -80.753059387207, -1.40940676736528, 218, 58, 'PPL', 'P'),
(163651, 'Lawn', 40.2200012207031, 0.701971446457408, -76.539436340332, -1.33586517175939, 218, 45, 'PPL', 'P'),
(82034, 'Lawn (historical)', 35.0327796936035, 0.611437351779192, -81.5861129760742, -1.42394629533656, 218, 48, 'PPL', 'P'),
(163632, 'Lawn Crest', 40.0466690063477, 0.698946228617133, -75.091667175293, -1.31059683302061, 218, 45, 'PPL', 'P'),
(116421, 'Lawn Hill', 42.297779083252, 0.738235511283935, -93.1716690063477, -1.62615239373912, 218, 16, 'PPL', 'P'),
(120312, 'Lawn Ridge', 40.9738883972168, 0.715129259876135, -89.6291732788086, -1.56432417955573, 218, 18, 'PPL', 'P'),
(163633, 'Lawn View', 41.5366706848145, 0.72495166376662, -78.3016662597656, -1.36662188603066, 218, 45, 'PPL', 'P'),
(14097, 'Lawndale', 39.2763900756836, 0.685502325118304, -75.5908279418945, -1.31930883189459, 218, 10, 'PPL', 'P'),
(48866, 'Lawndale', 39.521671295166, 0.689783289991579, -76.8777770996094, -1.34177033200248, 218, 25, 'PPL', 'P'),
(66279, 'Lawndale', 35.413890838623, 0.618088996075828, -81.5633316040039, -1.42354868538582, 218, 33, 'PPL', 'P'),
(120313, 'Lawndale', 40.2180595397949, 0.701937557732537, -89.2825012207031, -1.55827361071713, 218, 18, 'PPL', 'P'),
(131708, 'Lawndale', 43.4808311462402, 0.758883665005592, -84.0344390869141, -1.46667764713327, 218, 27, 'PPL', 'P'),
(136423, 'Lawndale', 46.5569381713867, 0.812571860738126, -96.3600006103516, -1.68179927787438, 218, 28, 'PPL', 'P'),
(156094, 'Lawndale', 41.042781829834, 0.716331677108306, -81.5822219848633, -1.42387838472877, 218, 41, 'PPL', 'P'),
(163634, 'Lawndale', 40.0502815246582, 0.69900927895594, -75.0919418334961, -1.31060162671057, 218, 45, 'PPL', 'P'),
(182745, 'Lawndale', 38.4213905334473, 0.670579768003235, -122.56916809082, -2.13923554461519, 218, 6, 'PPL', 'P'),
(48879, 'Lawndale Acres', 39.5330581665039, 0.689982028387926, -76.9058303833008, -1.34225995416889, 218, 25, 'PPL', 'P'),
(103568, 'Lawndale Farms', 37.5213890075684, 0.654871778103675, -77.3611068725586, -1.35020602791336, 218, 53, 'PPL', 'P'),
(103569, 'Lawndale Heights', 37.2936096191406, 0.650896277807432, -80.0894393920898, -1.39782441346841, 218, 53, 'PPL', 'P'),
(163635, 'Lawnford Acres', 40.2616691589355, 0.702698689172081, -76.793327331543, -1.34029640549718, 218, 45, 'PPL', 'P'),
(3695, 'Lawngate', 34.725830078125, 0.606080070351361, -87.0930633544922, -1.52006071118391, 218, 2, 'PPL', 'P'),
(71019, 'Lawnside', 39.8663902282715, 0.695799770368231, -75.0286102294922, -1.30949628170014, 218, 37, 'PPL', 'P'),
(163636, 'Lawnton', 40.2583312988281, 0.702640432523236, -76.8041687011719, -1.34048562309263, 218, 45, 'PPL', 'P'),
(103570, 'Lawnvale Estates', 38.8555603027344, 0.67815745998992, -77.6113891601563, -1.35457427789136, 218, 53, 'PPL', 'P'),
(73185, 'Lawnview', 38.8308296203613, 0.677725828156245, -82.2088928222656, -1.43481585416767, 218, 41, 'PPL', 'P'),
(88476, 'Lawnville', 35.8766708374023, 0.626166030766902, -84.4569396972656, -1.47405167387559, 218, 50, 'PPL', 'P'),
(88477, 'Lawnville Meadows', 35.8638916015625, 0.625942991025608, -84.4980621337891, -1.47476939578936, 218, 50, 'PPL', 'P'),
(3696, 'Lawrence', 34.2322196960449, 0.597464943962036, -85.5311126708984, -1.49279952900142, 218, 2, 'PPL', 'P'),
(30305, 'Lawrence', 39.8386116027832, 0.695314941891782, -86.0252838134766, -1.50142444250775, 218, 19, 'PPL', 'P'),
(33004, 'Lawrence', 38.9716682434082, 0.680183925842388, -95.2350006103516, -1.66216432378944, 218, 20, 'PPL', 'P'),
(48867, 'Lawrence', 39.4744415283203, 0.688958975055172, -77.4630584716797, -1.3519854189957, 218, 25, 'PPL', 'P'),
(60585, 'Lawrence', 32.3250007629395, 0.564177694022972, -89.232780456543, -1.55740581967592, 218, 30, 'PPL', 'P'),
(66281, 'Lawrence', 36.0141716003418, 0.6285658718042, -77.4991683959961, -1.35261565606766, 218, 33, 'PPL', 'P'),
(73171, 'Lawrence', 38.6450004577637, 0.674482497422692, -82.6736068725586, -1.44292664442556, 218, 41, 'PPL', 'P'),
(76344, 'Lawrence', 34.6863899230957, 0.605391709788603, -96.732780456543, -1.6883055135755, 218, 42, 'PPL', 'P'),
(88478, 'Lawrence', 35.648609161377, 0.622185603622642, -88.7905578613281, -1.54968757936271, 218, 50, 'PPL', 'P'),
(95641, 'Lawrence', 32.7422218322754, 0.571459575391576, -96.3424987792969, -1.68149381329735, 218, 51, 'PPL', 'P'),
(120315, 'Lawrence', 42.4411087036133, 0.740737085074874, -88.64111328125, -1.54707927939109, 218, 18, 'PPL', 'P'),
(125215, 'Lawrence', 42.7069396972656, 0.745376711167956, -71.1636123657227, -1.24203934339481, 218, 23, 'PPL', 'P'),
(131709, 'Lawrence', 42.2191696166992, 0.736863517269354, -86.0513916015625, -1.50188010937026, 218, 27, 'PPL', 'P'),
(136424, 'Lawrence', 44.6580581665039, 0.779430152552635, -93.684440612793, -1.63510194658233, 218, 28, 'PPL', 'P'),
(142211, 'Lawrence', 40.2919387817383, 0.703226993753326, -98.2597198486328, -1.71495563344587, 218, 35, 'PPL', 'P'),
(145581, 'Lawrence', 40.2738914489746, 0.702912008375397, -74.6800003051758, -1.30341189071569, 218, 37, 'PPL', 'P'),
(150191, 'Lawrence', 40.6155586242676, 0.708875225530248, -73.7300033569336, -1.28683131608496, 218, 40, 'PPL', 'P'),
(163637, 'Lawrence', 40.3061103820801, 0.703474334839567, -80.1208267211914, -1.39837222570464, 218, 45, 'PPL', 'P'),
(174926, 'Lawrence', 43.8836097717285, 0.76591347817702, -89.5444412231445, -1.56284532620241, 218, 57, 'PPL', 'P'),
(182746, 'Lawrence', 37.3699989318848, 0.652229522828153, -121.994720458984, -2.12920954205937, 218, 6, 'PPL', 'P'),
(192669, 'Lawrence', 39.2955589294434, 0.685836884730245, -110.928329467773, -1.9360645829497, 218, 52, 'PPL', 'P'),
(207896, 'Lawrence', 48.857780456543, 0.852729134183213, -122.292221069336, -2.13440190723669, 218, 56, 'PPL', 'P'),
(60586, 'Lawrence (historical)', 33.9716682434082, 0.592917463242672, -88.6208267211914, -1.54672521212416, 218, 30, 'PPL', 'P'),
(145583, 'Lawrence Brook Manor', 40.4722213745117, 0.706373518581255, -74.4161071777344, -1.29880608676845, 218, 37, 'PPL', 'P'),
(71021, 'Lawrence Corner', 39.5494384765625, 0.690267918730946, -75.1355590820313, -1.31136289130817, 218, 37, 'PPL', 'P'),
(144044, 'Lawrence Corner', 42.8472213745117, 0.74782508831612, -71.5238876342773, -1.2483273330446, 218, 36, 'PPL', 'P'),
(163638, 'Lawrence Corners', 41.8611106872559, 0.730614210034401, -77.0086135864258, -1.34405385947917, 218, 45, 'PPL', 'P'),
(76345, 'Lawrence Creek', 36.0849990844727, 0.629802044603187, -96.4250030517578, -1.68293378449875, 218, 42, 'PPL', 'P'),
(178513, 'Lawrence Crossing', 34.6530609130859, 0.604810008827502, -111.731941223145, -1.95009025398865, 218, 5, 'PPL', 'P'),
(22588, 'Lawrence Estates', 33.8019409179688, 0.589955162583149, -84.6311111450195, -1.47709153910186, 218, 13, 'PPL', 'P'),
(73173, 'Lawrence Furnace', 38.6441688537598, 0.674467983194751, -82.6744384765625, -1.4429411586535, 218, 41, 'PPL', 'P'),
(48868, 'Lawrence Hill', 39.3819389343262, 0.687344500223339, -76.4502792358398, -1.33430908673446, 218, 25, 'PPL', 'P'),
(163640, 'Lawrence Junction', 40.9677810668945, 0.715022666853505, -80.378059387207, -1.4028617826703, 218, 45, 'PPL', 'P'),
(150192, 'Lawrence Park', 40.9402809143066, 0.714542698646045, -73.8488922119141, -1.2889063180483, 218, 40, 'PPL', 'P'),
(163642, 'Lawrence Park', 42.1522216796875, 0.735695055341081, -80.0233306884766, -1.39667059892614, 218, 45, 'PPL', 'P'),
(95642, 'Lawrence Springs', 32.6425018310547, 0.569719133040182, -95.7872161865234, -1.67180230377444, 218, 51, 'PPL', 'P'),
(182747, 'Lawrence Welk Resort Village', 33.2316703796387, 0.580002064062169, -117.138893127441, -2.04445936721561, 218, 6, 'PPL', 'P'),
(30308, 'Lawrenceburg', 39.0908317565918, 0.682263721495685, -84.8499984741211, -1.48091184368558, 218, 19, 'PPL', 'P'),
(36815, 'Lawrenceburg', 38.0372200012207, 0.663874727326743, -84.8966674804688, -1.48172637150498, 218, 21, 'PPL', 'P'),
(55820, 'Lawrenceburg', 37.2444381713867, 0.650038074146154, -93.6600036621094, -1.63467544133376, 218, 29, 'PPL', 'P'),
(88480, 'Lawrenceburg', 35.2422218322754, 0.615092806691434, -87.334716796875, -1.52427835940226, 218, 50, 'PPL', 'P'),
(116422, 'Lawrenceburg', 41.2272186279297, 0.719550706496912, -93.5483322143555, -1.63272640688998, 218, 16, 'PPL', 'P'),
(163646, 'Lawrenceburg', 41.0911102294922, 0.717175166804561, -79.6849975585938, -1.3907655718411, 218, 45, 'PPL', 'P'),
(30309, 'Lawrenceburg Junction', 39.1305618286133, 0.682957142064515, -84.8424987792969, -1.480780949318, 218, 19, 'PPL', 'P'),
(30311, 'Lawrenceport', 38.7511100769043, 0.676334459644733, -86.3877792358398, -1.5077511811514, 218, 19, 'PPL', 'P'),
(22589, 'Lawrences Mill', 32.9833297729492, 0.575667702809038, -84.4997177124023, -1.47479829108719, 218, 13, 'PPL', 'P'),
(55821, 'Lawrenceton', 37.9650001525879, 0.662614253182808, -90.3050003051758, -1.5761195863398, 218, 29, 'PPL', 'P'),
(3698, 'Lawrenceville', 31.6574993133545, 0.55252759596588, -85.269172668457, -1.48822781351613, 218, 2, 'PPL', 'P'),
(10000, 'Lawrenceville', 34.5091705322266, 0.602298647919557, -91.1808319091797, -1.59140573152269, 218, 4, 'PPL', 'P'),
(22590, 'Lawrenceville', 33.9561080932617, 0.592645887390511, -83.9880599975586, -1.46586817931994, 218, 13, 'PPL', 'P'),
(27686, 'Lawrenceville', 38.7291717529297, 0.675951563659007, -87.6816711425781, -1.53033385508889, 218, 18, 'PPL', 'P'),
(30312, 'Lawrenceville', 39.2777786254883, 0.685526559884223, -85.039436340332, -1.48421815817891, 218, 19, 'PPL', 'P'),
(36816, 'Lawrenceville', 38.5680618286133, 0.673139665022047, -84.6500015258789, -1.47742123844481, 218, 21, 'PPL', 'P'),
(73176, 'Lawrenceville', 39.9866714477539, 0.697899073676513, -83.8786087036133, -1.46395789387002, 218, 41, 'PPL', 'P'),
(103573, 'Lawrenceville', 36.7574996948242, 0.641539394475493, -77.8472213745117, -1.35869032651414, 218, 53, 'PPL', 'P'),
(145585, 'Lawrenceville', 40.2972183227539, 0.703319139127043, -74.7300033569336, -1.30428460860491, 218, 37, 'PPL', 'P'),
(150196, 'Lawrenceville', 41.8405609130859, 0.730255548814595, -74.1033325195313, -1.29334713916601, 218, 40, 'PPL', 'P'),
(163649, 'Lawrenceville', 41.997501373291, 0.732994676574768, -77.1263885498047, -1.34610942036655, 218, 45, 'PPL', 'P'),
(177234, 'Lawrenceville', 40.6175003051758, 0.708909114255119, -80.5438919067383, -1.405756106143, 218, 58, 'PPL', 'P'),
(156098, 'Lawrenceville (historical)', 40.6500015258789, 0.709476367567306, -81.4444427490234, -1.42147368342248, 218, 41, 'PPL', 'P'),
(103571, 'Lawrenceville Hills', 36.7436103820801, 0.641296980237269, -77.85888671875, -1.35889392517947, 218, 53, 'PPL', 'P'),
(76347, 'Lawrie', 35.9566688537598, 0.627562259547403, -97.4230575561523, -1.7003531217148, 218, 42, 'PPL', 'P'),
(127924, 'Lawry', 44.0055618286133, 0.768041943099238, -69.3436126708984, -1.21027435633484, 218, 26, 'PPL', 'P'),
(66282, 'Laws', 36.2397193908691, 0.6325024233695, -79.1188888549805, -1.38088511103886, 218, 33, 'PPL', 'P'),
(182748, 'Laws', 37.4008293151855, 0.652767614526404, -118.344718933105, -2.06550499772996, 218, 6, 'PPL', 'P'),
(207897, 'Laws Corner', 45.7538909912109, 0.798556043395203, -121.424438476563, -2.1192562438013, 218, 56, 'PPL', 'P'),
(60589, 'Laws Hill', 34.5794410705566, 0.603525100180566, -89.5738906860352, -1.5633593162928, 218, 30, 'PPL', 'P'),
(88481, 'Laws Hill', 35.5430603027344, 0.620343428517607, -86.7083282470703, -1.51334581681138, 218, 50, 'PPL', 'P'),
(73177, 'Lawshe', 38.940559387207, 0.679640973875148, -83.4697189331055, -1.45682142109694, 218, 41, 'PPL', 'P'),
(3699, 'Lawson', 34.7249984741211, 0.60606555612342, -87.0727767944336, -1.51970664391698, 218, 2, 'PPL', 'P'),
(10001, 'Lawson', 33.1966705322266, 0.579391201487132, -92.482780456543, -1.61412902036574, 218, 4, 'PPL', 'P'),
(36817, 'Lawson', 37.6019401550293, 0.656277660843128, -83.458610534668, -1.45662754296958, 218, 21, 'PPL', 'P'),
(48869, 'Lawson', 37.9738883972168, 0.662769382316305, -75.8397216796875, -1.32365284710667, 218, 25, 'PPL', 'P'),
(55822, 'Lawson', 39.4383316040039, 0.688328737983205, -94.2038879394531, -1.64416801272323, 218, 29, 'PPL', 'P'),
(82035, 'Lawson', 34.9775009155273, 0.610472555095283, -81.9113922119141, -1.42962348899034, 218, 48, 'PPL', 'P'),
(95643, 'Lawson', 32.702220916748, 0.570761427711812, -96.5647201538086, -1.68537230795089, 218, 51, 'PPL', 'P'),
(103572, 'Lawson', 37.0111083984375, 0.64596570136526, -76.6308288574219, -1.3374602720943, 218, 53, 'PPL', 'P'),
(131711, 'Lawson', 46.329719543457, 0.808606147558889, -87.1363906860352, -1.52081691577543, 218, 27, 'PPL', 'P'),
(186967, 'Lawson', 39.7658309936523, 0.694044680630842, -105.626937866211, -1.84353784456485, 218, 7, 'PPL', 'P'),
(88482, 'Lawson (historical)', 36.5055618286133, 0.637142249199664, -82.3947219848633, -1.43805918490122, 218, 50, 'PPL', 'P'),
(95644, 'Lawson Crossing', 30.1308307647705, 0.525882203206446, -94.0880584716797, -1.64214640713975, 218, 51, 'PPL', 'P'),
(88483, 'Lawson Crossroad', 35.6541709899902, 0.622282675844376, -83.7975006103516, -1.46254229059259, 218, 50, 'PPL', 'P'),
(103574, 'Lawson Forest', 36.874439239502, 0.643580374555903, -76.1774978637695, -1.32954815365373, 218, 53, 'PPL', 'P'),
(163652, 'Lawson Heights', 40.2916717529297, 0.703222333221418, -79.3894424438477, -1.38560716196768, 218, 45, 'PPL', 'P'),
(22596, 'Lawson Highlands', 34.3913917541504, 0.600243020453153, -83.8311080932617, -1.46312885182268, 218, 13, 'PPL', 'P'),
(88485, 'Lawson Mill', 35.6283302307129, 0.621831669513771, -85.8208312988281, -1.49785607296315, 218, 50, 'PPL', 'P'),
(163657, 'Lawsonham', 40.9961090087891, 0.715517082709878, -79.4850006103516, -1.38727496660034, 218, 45, 'PPL', 'P'),
(48870, 'Lawsonia', 37.9747200012207, 0.662783896544246, -75.8341674804688, -1.32355590804299, 218, 25, 'PPL', 'P'),
(66283, 'Lawsons Mill', 35.1086082458496, 0.612760809682906, -77.6919403076172, -1.35598016063082, 218, 33, 'PPL', 'P'),
(3700, 'Lawsontown', 33.3338890075684, 0.581786115676413, -87.0986099243164, -1.52015751708953, 218, 2, 'PPL', 'P'),
(66285, 'Lawsonville', 36.4888916015625, 0.636851298850573, -80.232780456543, -1.40032618699643, 218, 33, 'PPL', 'P'),
(95645, 'Lawsonville', 31.9352798461914, 0.557375780861828, -94.6005630493164, -1.65109129945106, 218, 51, 'PPL', 'P'),
(163653, 'Lawsville Center', 41.9388885498047, 0.731971689821042, -75.8427810668945, -1.32370624348653, 218, 45, 'PPL', 'P'),
(41741, 'Lawtell', 30.5183296203613, 0.532645334084216, -92.1847229003906, -1.60892693465043, 218, 22, 'PPL', 'P'),
(207898, 'Lawters Beach', 47.6591682434082, 0.831809404609395, -122.77693939209, -2.14286183791349, 218, 56, 'PPL', 'P'),
(16861, 'Lawtey', 30.0438899993896, 0.524364800596346, -82.0719375610352, -1.43242553393127, 218, 12, 'PPL', 'P'),
(103575, 'Lawthorne Mill', 37.8274993896484, 0.660214412145511, -78.7877807617188, -1.37510618463144, 218, 53, 'PPL', 'P'),
(22592, 'Lawton', 30.8158302307129, 0.537837699261544, -83.3269424438477, -1.45432950126495, 218, 13, 'PPL', 'P'),
(33008, 'Lawton', 37.2219390869141, 0.649645391043422, -94.6358337402344, -1.65170688913703, 218, 20, 'PPL', 'P'),
(36818, 'Lawton', 38.2666702270508, 0.667879389236922, -83.220832824707, -1.45247753904291, 218, 21, 'PPL', 'P'),
(76348, 'Lawton', 34.6086082458496, 0.604034163422935, -98.3899993896484, -1.71722944038458, 218, 42, 'PPL', 'P'),
(82038, 'Lawton', 32.1433296203613, 0.561006934429124, -80.7886123657227, -1.41002728389927, 218, 48, 'PPL', 'P'),
(110046, 'Lawton', 37.8711090087891, 0.660975543585055, -80.9772186279297, -1.41331908416466, 218, 58, 'PPL', 'P'),
(116423, 'Lawton', 42.4786109924316, 0.741391623491788, -96.1836090087891, -1.67872066365425, 218, 16, 'PPL', 'P'),
(123032, 'Lawton', 41.0997200012207, 0.717325435669069, -86.5250015258789, -1.5101461619197, 218, 19, 'PPL', 'P'),
(131712, 'Lawton', 42.1672210693359, 0.735956844076236, -85.8469390869141, -1.49831173982566, 218, 27, 'PPL', 'P'),
(140375, 'Lawton', 48.3027801513672, 0.843042551508322, -98.3688888549805, -1.71686099204776, 218, 34, 'PPL', 'P'),
(163654, 'Lawton', 41.785831451416, 0.72930033951061, -76.0711135864258, -1.32769139774172, 218, 45, 'PPL', 'P'),
(174929, 'Lawton', 44.7758293151855, 0.781485646860986, -92.4155578613281, -1.61295576474751, 218, 57, 'PPL', 'P'),
(190401, 'Lawton', 39.5122184753418, 0.689618307162048, -119.905563354492, -2.09274687199455, 218, 39, 'PPL', 'P'),
(73178, 'Lawton (historical)', 39.8919410705566, 0.696245716692765, -81.8713912963867, -1.42892534131058, 218, 41, 'PPL', 'P'),
(82037, 'Lawton Bluff', 32.7419395446777, 0.57145464854356, -79.9416732788086, -1.39524540826878, 218, 48, 'PPL', 'P'),
(163655, 'Lawton Gardens', 40.2683296203613, 0.702814936153663, -76.8050003051758, -1.34050013732057, 218, 45, 'PPL', 'P'),
(76351, 'Lawtonka Acres', 34.7783317565918, 0.60699639750343, -98.5313873291016, -1.71969712545064, 218, 42, 'PPL', 'P'),
(150197, 'Lawtons', 42.5380592346191, 0.742429191052483, -78.9311065673828, -1.37760769184335, 218, 40, 'PPL', 'P'),
(169457, 'Lawtons', 41.5566711425781, 0.725300737606502, -71.3027801513672, -1.24446827946702, 218, 47, 'PPL', 'P'),
(156100, 'Lawtonville (historical)', 41.3680610656738, 0.722008870762083, -84.7863922119141, -1.47980170498518, 218, 41, 'PPL', 'P'),
(82039, 'Lawtonville Crossroads', 32.7544403076172, 0.571672828015864, -81.2708282470703, -1.41844353873419, 218, 48, 'PPL', 'P'),
(73179, 'Lawyerdale Estates', 39.1047210693359, 0.68250613573391, -84.3516693115234, -1.47221435903954, 218, 41, 'PPL', 'P'),
(103576, 'Lawyers', 37.2997207641602, 0.65100293740909, -79.2119369506836, -1.38250910667159, 218, 53, 'PPL', 'P'),
(193730, 'Lawyers Bar (historical)', 41.8697204589844, 0.730764478898909, -123.830276489258, -2.16124603839247, 218, 6, 'PPL', 'P'),
(48871, 'Lawyers Hill', 39.2186088562012, 0.684493852592518, -76.7216720581055, -1.33904578504927, 218, 25, 'PPL', 'P'),
(150198, 'Lawyersville', 42.7024993896484, 0.745299213180234, -74.5069427490234, -1.30039146656537, 218, 40, 'PPL', 'P'),
(22593, 'Lax', 31.4730606079102, 0.54930853328776, -83.1216735839844, -1.45074688380852, 218, 13, 'PPL', 'P'),
(136427, 'Lax Lake', 47.3441696166992, 0.826311641434063, -91.3086090087891, -1.59363586261953, 218, 28, 'PPL', 'P'),
(66287, 'Laxon', 36.235279083252, 0.632424925381779, -81.54638671875, -1.42325294134676, 218, 33, 'PPL', 'P'),
(194285, 'Lay', 40.526668548584, 0.707323801037222, -107.881393432617, -1.88288551703856, 218, 7, 'PPL', 'P'),
(196882, 'Lay Settlement (historical)', 45.6083297729492, 0.796015520873322, -111.150001525879, -1.93993349022331, 218, 31, 'PPL', 'P'),
(3701, 'Lay Springs', 34.1683311462402, 0.59634987841362, -85.8566665649414, -1.49848151634516, 218, 2, 'PPL', 'P'),
(27687, 'Layfield', 38.1063919067383, 0.665082004827903, -89.4352798461914, -1.56094010075857, 218, 18, 'PPL', 'P'),
(163656, 'Layfield', 40.3177795410156, 0.703678000083931, -75.5697174072266, -1.31894038355778, 218, 45, 'PPL', 'P'),
(73180, 'Layhigh', 39.3616714477539, 0.686990765851549, -84.6961135864258, -1.47822604572623, 218, 41, 'PPL', 'P'),
(48872, 'Layhill', 39.0922203063965, 0.682287956261605, -77.0447235107422, -1.34468409655114, 218, 25, 'PPL', 'P'),
(48873, 'Layhill South', 39.0688896179199, 0.681880758930932, -77.0430603027344, -1.34465506809525, 218, 25, 'PPL', 'P'),
(48874, 'Layhill Village', 39.084171295166, 0.682147474514104, -77.0516662597656, -1.34480527038073, 218, 25, 'PPL', 'P'),
(110049, 'Layland', 37.8891716003418, 0.661290795279093, -80.9713897705078, -1.41321735141102, 218, 58, 'PPL', 'P'),
(156099, 'Layland', 40.4361114501953, 0.705743281509287, -81.9669418334961, -1.43059301278518, 218, 41, 'PPL', 'P'),
(110047, 'Layland Heights', 37.9072189331055, 0.661605780657023, -80.9599990844727, -1.41301854643564, 218, 58, 'PPL', 'P'),
(36819, 'Layman', 36.8286094665527, 0.642780494122498, -83.4633331298828, -1.45670996780532, 218, 21, 'PPL', 'P'),
(73181, 'Layman', 39.4033317565918, 0.687717875408168, -81.7244415283203, -1.42636058402278, 218, 41, 'PPL', 'P'),
(103577, 'Laymantown', 37.3655586242676, 0.652152024840432, -79.857780456543, -1.39378120230146, 218, 53, 'PPL', 'P'),
(55823, 'Layneville', 37.4947204589844, 0.654406324124157, -94.0952835083008, -1.64227250781737, 218, 29, 'PPL', 'P'),
(204660, 'Layrelwood Estates', 40.648609161377, 0.709452066222359, -111.838890075684, -1.95195686359669, 218, 52, 'PPL', 'P'),
(103578, 'Layside Estates', 39.1938896179199, 0.684062420495925, -78.2525024414063, -1.36576381552744, 218, 53, 'PPL', 'P'),
(113629, 'Laysville', 41.3486099243164, 0.721669384302125, -72.2988891601563, -1.26185366137916, 218, 8, 'PPL', 'P'),
(16862, 'Layton', 24.8236103057861, 0.433253732067964, -80.8138885498047, -1.41046843653384, 218, 12, 'PPL', 'P'),
(33009, 'Layton', 37.082218170166, 0.647206801012264, -96.4077835083008, -1.68263324676974, 218, 20, 'PPL', 'P'),
(103579, 'Layton', 38.0875015258789, 0.664752305484951, -76.9911117553711, -1.34374839490214, 218, 53, 'PPL', 'P'),
(123033, 'Layton', 40.128059387207, 0.700366758742581, -87.3333282470703, -1.52425412463634, 218, 19, 'PPL', 'P'),
(145586, 'Layton', 41.2161102294922, 0.719356828369554, -74.8233337402344, -1.30591353108565, 218, 37, 'PPL', 'P'),
(163658, 'Layton', 40.0902786254883, 0.699707360056677, -79.7236099243164, -1.39143948475495, 218, 45, 'PPL', 'P'),
(204661, 'Layton', 41.0602798461914, 0.716637075106311, -111.970283508301, -1.95425011161136, 218, 52, 'PPL', 'P'),
(14098, 'Layton Corners', 38.8988914489746, 0.678913731160475, -75.6933288574219, -1.32109781035685, 218, 10, 'PPL', 'P'),
(131713, 'Layton Corners', 43.1758308410645, 0.753560405460687, -83.9883270263672, -1.46587283985185, 218, 27, 'PPL', 'P'),
(204663, 'Layton Meadows Condominium', 41.0816688537598, 0.717010383712113, -111.974998474121, -1.95433240328904, 218, 52, 'PPL', 'P'),
(204665, 'Layton Park Plaza Condominium', 41.0608291625977, 0.716646662486235, -111.961387634277, -1.9540948493198, 218, 52, 'PPL', 'P'),
(48875, 'Layton Ridge', 39.2011108398438, 0.684188454594513, -77.1552810668945, -1.34661368991895, 218, 25, 'PPL', 'P'),
(204666, 'Laytona', 41.089168548584, 0.71714127807969, -111.97306060791, -1.9542985811432, 218, 52, 'PPL', 'P'),
(48876, 'Laytonsville', 39.2119407653809, 0.684377472452881, -77.1430587768555, -1.34640037071564, 218, 25, 'PPL', 'P'),
(48877, 'Laytonsville Knolls', 39.1941719055176, 0.684067347343942, -77.1366729736328, -1.34628891742402, 218, 25, 'PPL', 'P'),
(182749, 'Laytonville', 39.6883316040039, 0.69269206111319, -123.481666564941, -2.15516164740802, 218, 6, 'PPL', 'P'),
(10003, 'Laytonville (historical)', 36.2102813720703, 0.631988633016197, -92.4416732788086, -1.61341156476807, 218, 4, 'PPL', 'P'),
(110048, 'Layville', 38.1266708374023, 0.665435938936775, -81.9341735839844, -1.43002109894109, 218, 58, 'PPL', 'P'),
(95646, 'Lazare', 34.2830581665039, 0.598352242658224, -99.9972229003906, -1.74528078246249, 218, 51, 'PPL', 'P'),
(22595, 'Lazaretto (historical)', 32.0152816772461, 0.558772076221357, -80.8702774047852, -1.41145260771468, 218, 13, 'PPL', 'P'),
(191751, 'Lazbuddie', 34.3930587768555, 0.600272115488062, -102.610832214355, -1.79089687035197, 218, 51, 'PPL', 'P'),
(186968, 'Lazear', 38.7799987792969, 0.676838662618112, -107.781112670898, -1.88113528757016, 218, 7, 'PPL', 'P'),
(177235, 'Lazearville', 40.2861099243164, 0.703125260999685, -80.6108322143555, -1.40692443491321, 218, 58, 'PPL', 'P'),
(178514, 'Lazona Trailer Court', 33.413890838623, 0.583182411035941, -111.800003051758, -1.95127815699288, 218, 5, 'PPL', 'P'),
(41742, 'Lazy Acres', 29.6674995422363, 0.517795547845934, -90.7772216796875, -1.58436140412332, 218, 22, 'PPL', 'P'),
(88486, 'Lazy Acres', 36.0074996948242, 0.628449425085536, -84.0572204589844, -1.46707525708402, 218, 50, 'PPL', 'P'),
(194286, 'Lazy Acres', 40.0933303833008, 0.699760623278479, -105.332221984863, -1.83839408207742, 218, 7, 'PPL', 'P'),
(82041, 'Lazy Acres Estates', 33.940559387207, 0.592374511275432, -80.2763900756836, -1.40108731843598, 218, 48, 'PPL', 'P'),
(204667, 'Lazy Bar', 40.6288909912109, 0.709107919230493, -111.821113586426, -1.95164660532969, 218, 52, 'PPL', 'P'),
(178515, 'Lazy D Trailer Ranch', 33.3805618286133, 0.582600710074841, -112.064720153809, -1.95589834201001, 218, 5, 'PPL', 'P'),
(196883, 'Lazy Day (historical)', 45.2861099243164, 0.790391723599401, -110.237503051758, -1.92400738743047, 218, 31, 'PPL', 'P'),
(82042, 'Lazy Day Acres', 34.0155601501465, 0.593683521530233, -81.4380569458008, -1.42136223013086, 218, 48, 'PPL', 'P'),
(196884, 'Lazy Day Court', 48.3716697692871, 0.844244902161466, -114.211669921875, -1.99336968433769, 218, 31, 'PPL', 'P'),
(178516, 'Lazy Daze Mobile Home Park', 33.452220916748, 0.583851397101769, -112.149719238281, -1.95738185589523, 218, 5, 'PPL', 'P'),
(178517, 'Lazy J Trailer Lodge', 33.5411109924316, 0.585402821594795, -112.198608398438, -1.9582351327085, 218, 5, 'PPL', 'P'),
(199470, 'Lazy L Mobile Ranch', 40.2144393920898, 0.701874374235675, -100.632217407227, -1.75636352733885, 218, 35, 'PPL', 'P'),
(14100, 'Lazy Lagoon Mobile Home Park', 38.502498626709, 0.671995371280667, -75.23388671875, -1.31307903231462, 218, 10, 'PPL', 'P'),
(14099, 'Lazy Lake', 38.7338905334473, 0.676033921915718, -75.2616729736328, -1.31356399394912, 218, 10, 'PPL', 'P'),
(16863, 'Lazy Lake', 26.1558303833008, 0.456505358781769, -80.1449966430664, -1.39879407042131, 218, 12, 'PPL', 'P'),
(41743, 'Lazy Lake Estates', 30.5499992370605, 0.533198073168462, -91.0400009155273, -1.5889477669946, 218, 22, 'PPL', 'P'),
(3705, 'Lazy Living Acres', 34.7638893127441, 0.606744329306254, -87.1736068725586, -1.5214664607653, 218, 2, 'PPL', 'P'),
(211964, 'Lazy Mountain', 61.6261100769043, 1.07557852603844, -148.945556640625, -2.59959036959461, 218, 1, 'PPL', 'P'),
(103580, 'Lazy Oak Corner', 37.1183280944824, 0.647837038084231, -76.8955612182617, -1.34208072342753, 218, 53, 'PPL', 'P'),
(136428, 'Lazy U Mobile Home Park', 44.1680603027344, 0.770878076502118, -93.2827835083008, -1.62809170764492, 218, 28, 'PPL', 'P'),
(3702, 'Lazy V Lake Acres', 33.6366691589355, 0.587070626227457, -86.4513931274414, -1.50886145300985, 218, 2, 'PPL', 'P'),
(210541, 'LÃƒÂ¤Ã‚â€˜ie', 21.6536102294922, 0.377926793448164, -157.927215576172, -2.75634989031107, 218, 15, 'PPL', 'P'),
(210547, 'LÃƒÂ¤naÃ‚â€˜i City', 20.8305606842041, 0.363561868975844, -156.922225952148, -2.73880951242348, 218, 15, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(41744, 'Le Blanc', 30.5088901519775, 0.532480584281281, -92.9488906860352, -1.6222641785476, 218, 22, 'PPL', 'P'),
(41745, 'Le Bleu', 30.2758293151855, 0.528412905321808, -93.0811080932617, -1.62457180763216, 218, 22, 'PPL', 'P'),
(136429, 'Le Center', 44.3894386291504, 0.774741857190632, -93.7300033569336, -1.63589716648383, 218, 28, 'PPL', 'P'),
(204669, 'Le Cheminant', 40.7119407653809, 0.710557411232796, -112.108612060547, -1.95666440029757, 218, 52, 'PPL', 'P'),
(116425, 'Le Claire', 41.5986099243164, 0.72603270743211, -90.3433303833008, -1.57678857240563, 218, 16, 'PPL', 'P'),
(125217, 'Le Count Hollow (historical)', 41.9236106872559, 0.731705040816897, -69.977783203125, -1.22134272014132, 218, 23, 'PPL', 'P'),
(22597, 'Le Dan', 34.3661117553711, 0.599801801239554, -83.8711090087891, -1.46382699950245, 218, 13, 'PPL', 'P'),
(48878, 'Le Gore', 39.5541687011719, 0.690350476724738, -77.3125, -1.34935767794812, 218, 25, 'PPL', 'P'),
(3703, 'Le Grand', 32.1622200012207, 0.561336633772076, -86.2686080932617, -1.50567125234004, 218, 2, 'PPL', 'P'),
(116427, 'Le Grand', 42.0069389343262, 0.73315939308819, -92.7752838134766, -1.61923416701737, 218, 16, 'PPL', 'P'),
(182750, 'Le Grand', 37.2286109924316, 0.649761837762086, -120.247222900391, -2.09870995599134, 218, 6, 'PPL', 'P'),
(207901, 'Le Grow', 46.1733283996582, 0.80587660717864, -118.830833435059, -2.07398929633074, 218, 56, 'PPL', 'P'),
(163659, 'Le High Park', 40.1780586242676, 0.701239410052773, -77.0466690063477, -1.34471805185503, 218, 45, 'PPL', 'P'),
(33019, 'Le Hunt', 37.2691688537598, 0.650469705979829, -95.7516708374023, -1.67118192039851, 218, 20, 'PPL', 'P'),
(41746, 'Le Jeune', 30.6027793884277, 0.534119260589521, -92.7752838134766, -1.61923416701737, 218, 22, 'PPL', 'P'),
(33010, 'Le Loup', 38.6952781677246, 0.675360009001873, -95.1597213745117, -1.66085045326565, 218, 20, 'PPL', 'P'),
(73183, 'Le Mae', 38.4455604553223, 0.671001612719904, -82.3322219848633, -1.43696835411873, 218, 41, 'PPL', 'P'),
(116429, 'Le Mars', 42.7941703796387, 0.746899173784127, -96.165283203125, -1.67840081800733, 218, 16, 'PPL', 'P'),
(41747, 'Le Moyen', 30.7852802276611, 0.537304501121796, -92.040283203125, -1.60640598636256, 218, 22, 'PPL', 'P'),
(3704, 'Le Moyne', 30.9580593109131, 0.54032006500312, -88.0277786254883, -1.53637457023146, 218, 2, 'PPL', 'P'),
(163660, 'Le Raysville', 41.8386116027832, 0.730221526931669, -76.1805572509766, -1.32960155003358, 218, 45, 'PPL', 'P'),
(33011, 'Le Roy', 38.0838890075684, 0.664689255146144, -95.6341705322266, -1.66913115320109, 218, 20, 'PPL', 'P'),
(116430, 'Le Roy', 40.8777809143066, 0.713451867863549, -93.5924987792969, -1.6334972588675, 218, 16, 'PPL', 'P'),
(120316, 'Le Roy', 40.3519401550293, 0.704274215272972, -88.7641677856445, -1.54922698565218, 218, 18, 'PPL', 'P'),
(131714, 'Le Roy', 44.0380592346191, 0.768609129832398, -85.4538879394531, -1.49145170317373, 218, 27, 'PPL', 'P'),
(136432, 'Le Roy', 43.5097198486328, 0.759387867978971, -92.5036087036133, -1.61449254185454, 218, 28, 'PPL', 'P'),
(150200, 'Le Roy', 42.978328704834, 0.750113342903743, -77.9844436645508, -1.36108530728244, 218, 40, 'PPL', 'P'),
(22598, 'Le Roy (historical)', 33.1341705322266, 0.578300370704635, -82.1538925170898, -1.43385591775275, 218, 13, 'PPL', 'P'),
(136433, 'Le Roy Parkside Mobile Home Park', 43.5083312988281, 0.759363633213052, -92.504997253418, -1.61451677662045, 218, 28, 'PPL', 'P'),
(73184, 'Le Sourdsville', 39.4402809143066, 0.68836275986613, -84.4300003051758, -1.47358149278513, 218, 41, 'PPL', 'P'),
(136437, 'Le Sueur', 44.4613914489746, 0.775997670802659, -93.9150009155273, -1.63912598298944, 218, 28, 'PPL', 'P'),
(60590, 'Le Tourneau', 32.214168548584, 0.562243306965193, -90.9383316040039, -1.58717330276028, 218, 30, 'PPL', 'P'),
(95647, 'Le Verte', 30.5294399261475, 0.532839245501088, -93.9274978637695, -1.63934409588272, 218, 51, 'PPL', 'P'),
(193063, 'Lea', 32.5222206115723, 0.5676198297319, -103.532783508301, -1.80698795597433, 218, 38, 'PPL', 'P'),
(22600, 'Lea Glen', 32.4455604553223, 0.566281857600244, -83.6730575561523, -1.46037034956558, 218, 13, 'PPL', 'P'),
(193254, 'Lea Hill', 47.3263893127441, 0.826001316588042, -122.180282592773, -2.13244821226101, 218, 56, 'PPL', 'P'),
(88487, 'Lea Springs', 36.1777801513672, 0.63142137970401, -83.6833267211914, -1.46054958030694, 218, 50, 'PPL', 'P'),
(201115, 'Leaburg', 44.1074981689453, 0.769821067865466, -122.675827026367, -2.14109709421715, 218, 43, 'PPL', 'P'),
(76354, 'Leach', 36.204719543457, 0.631891560794463, -94.9222183227539, -1.65670524302895, 218, 42, 'PPL', 'P'),
(88488, 'Leach', 35.9327812194824, 0.627145341678751, -88.4872207641602, -1.54439334827369, 218, 50, 'PPL', 'P'),
(48880, 'Leachburg', 38.2102813720703, 0.666895218056083, -76.4013900756836, -1.3334558099212, 218, 25, 'PPL', 'P'),
(110052, 'Leachtown', 39.1419410705566, 0.683155747302807, -81.4433288574219, -1.42145424234652, 218, 58, 'PPL', 'P'),
(10004, 'Leachville', 35.9358291625977, 0.627198538321526, -90.2577819824219, -1.57529547114048, 218, 4, 'PPL', 'P'),
(55827, 'Leachville Junction', 36.0463905334473, 0.62912819826837, -90.1097183227539, -1.57271127277672, 218, 29, 'PPL', 'P'),
(163665, 'Leacock', 40.0855598449707, 0.699625001799966, -76.208610534668, -1.33009117219999, 218, 45, 'PPL', 'P'),
(202298, 'Lead', 44.3522186279297, 0.774092245621735, -103.764717102051, -1.81103596083126, 218, 49, 'PPL', 'P'),
(55825, 'Lead Branch Junction', 37.9036102294922, 0.661542796897242, -91.3755569458008, -1.5948043245478, 218, 29, 'PPL', 'P'),
(10005, 'Lead Hill', 36.4197196960449, 0.635644021349412, -92.9147186279297, -1.62166776362148, 218, 4, 'PPL', 'P'),
(110051, 'Lead Mine', 39.1944389343262, 0.684072007875849, -79.5849990844727, -1.38902026922072, 218, 58, 'PPL', 'P'),
(174935, 'Lead Mine', 42.5708312988281, 0.743001171475605, -90.3452835083008, -1.57682266086758, 218, 57, 'PPL', 'P'),
(95648, 'Leaday', 31.5677795410156, 0.550961690534427, -99.6727828979492, -1.73961823619471, 218, 51, 'PPL', 'P'),
(76356, 'Leader', 34.728889465332, 0.606133466731217, -96.476936340332, -1.68384019137576, 218, 42, 'PPL', 'P'),
(103582, 'Leader', 37.2722206115723, 0.650522969201631, -77.5658264160156, -1.35377905798987, 218, 53, 'PPL', 'P'),
(136441, 'Leader', 46.5286102294922, 0.812077444881753, -94.6547164916992, -1.65203645532193, 218, 28, 'PPL', 'P'),
(186969, 'Leader', 39.8994407653809, 0.696376611060342, -104.05583190918, -1.81611687271696, 218, 7, 'PPL', 'P'),
(78597, 'Leaders Heights', 39.9063911437988, 0.696497918047995, -76.7191696166992, -1.3390021092074, 218, 45, 'PPL', 'P'),
(182752, 'Leadfield', 36.8466682434082, 0.643095679237509, -117.058326721191, -2.04305321816005, 218, 6, 'PPL', 'P'),
(55828, 'Leadington', 37.8402786254883, 0.660437451886805, -90.4916687011719, -1.57937756445935, 218, 29, 'PPL', 'P'),
(55829, 'Leadmine', 37.836669921875, 0.660374468127024, -92.9619369506836, -1.62249187882081, 218, 29, 'PPL', 'P'),
(22605, 'Leadmore', 33.4550018310547, 0.583899933212636, -83.95361328125, -1.46526697070385, 218, 13, 'PPL', 'P'),
(195221, 'Leadore', 44.6802787780762, 0.779817975386378, -113.357223510742, -1.97845678118158, 218, 17, 'PPL', 'P'),
(207902, 'Leadpoint', 48.9094390869141, 0.853630747370259, -117.586387634277, -2.05226961974449, 218, 56, 'PPL', 'P'),
(110054, 'Leadsville', 38.9433288574219, 0.679689310248933, -79.8550033569336, -1.39373273276962, 218, 58, 'PPL', 'P'),
(88490, 'Leadvale', 36.0875015258789, 0.629845720445065, -83.2605590820313, -1.45317089303271, 218, 50, 'PPL', 'P'),
(186970, 'Leadville', 39.2508316040039, 0.685056245635715, -106.291938781738, -1.85514430006958, 218, 7, 'PPL', 'P'),
(195222, 'Leadville', 44.7058296203613, 0.780263921710912, -113.307220458984, -1.97758406329236, 218, 17, 'PPL', 'P'),
(196885, 'Leadville', 46.3144416809082, 0.808339498554745, -112.542221069336, -1.96423230516725, 218, 31, 'PPL', 'P'),
(186971, 'Leadville Junction', 39.2586097717285, 0.685192000272282, -106.339172363281, -1.85596868158502, 218, 7, 'PPL', 'P'),
(55832, 'Leadwood', 37.8672218322754, 0.660907699556285, -90.5930633544922, -1.58114723500371, 218, 29, 'PPL', 'P'),
(60592, 'Leaf', 31.0255603790283, 0.541498180890344, -88.7955627441406, -1.54977493104647, 218, 30, 'PPL', 'P'),
(112272, 'Leaf', 34.5744400024414, 0.603437815075839, -83.6611099243164, -1.46016182405223, 218, 13, 'PPL', 'P'),
(193731, 'Leaf', 41.642219543457, 0.726793838871655, -122.000831604004, -2.12931620166102, 218, 6, 'PPL', 'P'),
(60591, 'Leaf River', 31.6722202301025, 0.552784524432045, -89.4347229003906, -1.56093038022059, 218, 30, 'PPL', 'P'),
(120319, 'Leaf River', 42.125560760498, 0.735229734519617, -89.4036102294922, -1.56038736167432, 218, 18, 'PPL', 'P'),
(136445, 'Leaf Valley', 46.0494384765625, 0.803714320110577, -95.4577789306641, -1.66605253898096, 218, 28, 'PPL', 'P'),
(36821, 'Leafdale', 37.5633316040039, 0.655603814508311, -85.6647186279297, -1.49513139285189, 218, 21, 'PPL', 'P'),
(78598, 'Leafydale Terrace', 39.9455604553223, 0.697181551499819, -76.6869430541992, -1.33843964958517, 218, 45, 'PPL', 'P'),
(110055, 'League', 39.2922210693359, 0.685778628081399, -81.0986099243164, -1.41543776196987, 218, 58, 'PPL', 'P'),
(95649, 'League City', 29.5072193145752, 0.514998130147402, -95.0947189331055, -1.65971594664128, 218, 51, 'PPL', 'P'),
(95650, 'Leagueville', 32.2308311462402, 0.56253412415623, -95.6549987792969, -1.66949467468989, 218, 51, 'PPL', 'P'),
(22601, 'Leah', 33.6630592346191, 0.587531219937986, -82.335563659668, -1.4370266773466, 218, 13, 'PPL', 'P'),
(48881, 'Leahigh', 39.3469390869141, 0.686733637648302, -76.6944427490234, -1.33857054395275, 218, 25, 'PPL', 'P'),
(207903, 'Leahy', 47.9191703796387, 0.836347297948836, -119.38777923584, -2.08370983430952, 218, 56, 'PPL', 'P'),
(209563, 'Leahy Place', 42.5074996948242, 0.741895826465168, -105.943061828613, -1.84905524855323, 218, 59, 'PPL', 'P'),
(163666, 'Leak Run', 40.4438896179199, 0.705879036145854, -79.7966690063477, -1.39271460628488, 218, 45, 'PPL', 'P'),
(22602, 'Leake', 31.5400009155273, 0.550476862057978, -81.9005584716797, -1.42943440455295, 218, 13, 'PPL', 'P'),
(60594, 'Leakesville', 31.1555595397949, 0.543767094270551, -88.5577774047852, -1.54562479396174, 218, 30, 'PPL', 'P'),
(95651, 'Leakey', 29.728609085083, 0.518862110572998, -99.7611083984375, -1.7411598069917, 218, 51, 'PPL', 'P'),
(103583, 'Leaksville', 38.6263885498047, 0.67415765834873, -78.5263900756836, -1.37054405652608, 218, 53, 'PPL', 'P'),
(66289, 'Leaksville (historical)', 36.5019416809082, 0.637079065702802, -79.7727813720703, -1.39229768841623, 218, 33, 'PPL', 'P'),
(103584, 'Leaksville Junction', 36.5419387817383, 0.637777146803539, -79.6597213745117, -1.39032441920653, 218, 53, 'PPL', 'P'),
(95652, 'Leal', 28.913890838623, 0.504642594696197, -98.3600006103516, -1.71670586291427, 218, 51, 'PPL', 'P'),
(140377, 'Leal', 47.105281829834, 0.822142263010462, -98.3169403076172, -1.71595431885465, 218, 34, 'PPL', 'P'),
(186972, 'Leal', 39.8102798461914, 0.694820459456382, -106.043891906738, -1.85081506540155, 218, 7, 'PPL', 'P'),
(95654, 'Leal Colonia', 26.3939990997314, 0.460662187058733, -98.8399963378906, -1.72508336875533, 218, 51, 'PPL', 'P'),
(16864, 'Lealman', 27.8208293914795, 0.485565073516928, -82.679443359375, -1.44302851033726, 218, 12, 'PPL', 'P'),
(163668, 'Leaman Place', 40.0072212219238, 0.69825773489632, -76.1166687011719, -1.32848648448516, 218, 45, 'PPL', 'P'),
(163667, 'Leamersville', 40.3683280944824, 0.704560238774047, -78.4272232055664, -1.36881326813364, 218, 45, 'PPL', 'P'),
(71024, 'Leamings Mill', 39.4027786254883, 0.687708221449216, -74.9797210693359, -1.30864300488688, 218, 37, 'PPL', 'P'),
(27688, 'Leamington', 37.6394386291504, 0.656932132681015, -88.3069381713867, -1.54124682344576, 218, 18, 'PPL', 'P'),
(192670, 'Leamington', 39.5347213745117, 0.690011056843808, -112.282783508301, -1.95970426552384, 218, 52, 'PPL', 'P'),
(36822, 'Leander', 37.753059387207, 0.658915189007716, -82.8716735839844, -1.44638356067854, 218, 21, 'PPL', 'P'),
(41749, 'Leander', 31.1483306884766, 0.543640927013908, -92.8463897705078, -1.62047520008534, 218, 22, 'PPL', 'P'),
(66291, 'Leander', 36.2863883972168, 0.633316951188901, -81.85888671875, -1.42870709525924, 218, 33, 'PPL', 'P'),
(76357, 'Leander', 36.2230606079102, 0.632211672757491, -96.3058319091797, -1.6808538556874, 218, 42, 'PPL', 'P'),
(95655, 'Leander', 30.5786094665527, 0.533697415872852, -97.852783203125, -1.70785324913473, 218, 51, 'PPL', 'P'),
(110056, 'Leander', 38.1911087036133, 0.666560591865115, -81.0083312988281, -1.41386210271093, 218, 58, 'PPL', 'P'),
(136447, 'Leander', 47.8030586242676, 0.83432076551734, -92.6502838134766, -1.61705250545237, 218, 28, 'PPL', 'P'),
(27689, 'Leanderville', 37.916389465332, 0.661765836638536, -89.6761093139648, -1.56514336790704, 218, 18, 'PPL', 'P'),
(116435, 'Leando', 40.833610534668, 0.712680949306998, -92.0886077880859, -1.60724940947979, 218, 16, 'PPL', 'P'),
(110057, 'Leaning Oak', 38.773609161377, 0.676727142747465, -81.3791732788086, -1.4203345162662, 218, 58, 'PPL', 'P'),
(10008, 'Leaning Pines', 34.9777793884277, 0.610477415364273, -91.9722213745117, -1.60521808335833, 218, 4, 'PPL', 'P'),
(55830, 'Leann', 36.8127784729004, 0.642504191159402, -93.6900024414063, -1.63519901880406, 218, 29, 'PPL', 'P'),
(33013, 'Leanna', 37.732780456543, 0.658561254898844, -95.3322219848633, -1.66386115687799, 218, 20, 'PPL', 'P'),
(88491, 'Leanna', 35.9386100769043, 0.627247074432392, -86.4311065673828, -1.50850738574292, 218, 50, 'PPL', 'P'),
(73186, 'Leaper', 38.6822204589844, 0.675132108991589, -82.2702789306641, -1.43588724387421, 218, 41, 'PPL', 'P'),
(131716, 'Leapers', 45.7872200012207, 0.799137744356303, -87.6944427490234, -1.53055676167213, 218, 27, 'PPL', 'P'),
(82043, 'Leaphart', 34.0469398498535, 0.594231200608408, -81.1513900756836, -1.41635894939093, 218, 48, 'PPL', 'P'),
(88492, 'Leapwood', 35.3058280944824, 0.616202945391834, -88.4561080932617, -1.54385032972742, 218, 50, 'PPL', 'P'),
(116432, 'Lear', 42.5275001525879, 0.74224490030505, -92.7386093139648, -1.61859407624937, 218, 16, 'PPL', 'P'),
(163669, 'Learn Settlement', 40.6877784729004, 0.710135699674182, -78.9486083984375, -1.37791315642038, 218, 45, 'PPL', 'P'),
(60595, 'Learned', 32.1966705322266, 0.561937908967189, -90.5472183227539, -1.58034708825419, 218, 30, 'PPL', 'P'),
(190402, 'Learville (historical)', 38.9455604553223, 0.679728258979876, -116.84944152832, -2.03940748378578, 218, 39, 'PPL', 'P'),
(22603, 'Leary', 31.485559463501, 0.549526679470551, -84.5138931274414, -1.47504569875246, 218, 13, 'PPL', 'P'),
(95656, 'Leary', 33.4599990844727, 0.583987151738336, -94.2074966430664, -1.64423099648301, 218, 51, 'PPL', 'P'),
(207904, 'Leary', 48.5119400024414, 0.846693079572549, -122.484443664551, -2.13775682441992, 218, 56, 'PPL', 'P'),
(196886, 'Leary Place', 45.0230598449707, 0.785800633617187, -112.063606262207, -1.95587890093405, 218, 31, 'PPL', 'P'),
(55831, 'Leasburg', 38.0919418334961, 0.664829803472673, -91.29638671875, -1.59342254341621, 218, 29, 'PPL', 'P'),
(66292, 'Leasburg', 36.3944396972656, 0.635202802135813, -79.1547164916992, -1.38151042126281, 218, 33, 'PPL', 'P'),
(188866, 'Leasburg', 32.4538917541504, 0.566427266195762, -106.882499694824, -1.86545153243652, 218, 38, 'PPL', 'P'),
(123034, 'Leases Corner', 40.8663902282715, 0.713253062888174, -86.3741683959961, -1.50751362718216, 218, 19, 'PPL', 'P'),
(163672, 'Leasureville', 40.746940612793, 0.711168273807833, -79.7038879394531, -1.39109527118406, 218, 45, 'PPL', 'P'),
(199479, 'Leat', 42.8958282470703, 0.748673438281365, -101.824172973633, -1.77716707651012, 218, 35, 'PPL', 'P'),
(3706, 'Leath Gap (historical)', 34.1372184753418, 0.595806859867353, -86.0536117553711, -1.50191885836412, 218, 2, 'PPL', 'P'),
(36823, 'Leatha', 37.8180618286133, 0.660049695632089, -83.0166702270508, -1.44891422950438, 218, 21, 'PPL', 'P'),
(163670, 'Leather Corner Post', 40.6208305358887, 0.70896723774591, -75.6386108398438, -1.32014280078995, 218, 45, 'PPL', 'P'),
(110058, 'Leatherbark', 38.788330078125, 0.676984071213631, -81.1969375610352, -1.41715390297632, 218, 58, 'PPL', 'P'),
(66294, 'Leatherman', 35.2852783203125, 0.615844284172028, -83.3783264160156, -1.45522632076204, 218, 33, 'PPL', 'P'),
(127925, 'Leathers Corner', 44.829719543457, 0.782426208778974, -68.9313888549805, -1.20307969349193, 218, 26, 'PPL', 'P'),
(22604, 'Leathersville', 33.7166709899902, 0.588466921586986, -82.4400024414063, -1.4388494779547, 218, 13, 'PPL', 'P'),
(3707, 'Leatherwood', 33.7172203063965, 0.58847650896691, -85.8766708374023, -1.49883065676407, 218, 2, 'PPL', 'P'),
(30313, 'Leatherwood', 39.7516708374023, 0.693797539281682, -87.2852783203125, -1.52341549520908, 218, 19, 'PPL', 'P'),
(36824, 'Leatherwood', 37.0327796936035, 0.646343936819078, -83.1725006103516, -1.45163398276763, 218, 21, 'PPL', 'P'),
(48882, 'Leatherwood', 39.7097206115723, 0.693065369718992, -76.8533325195313, -1.34134369359585, 218, 25, 'PPL', 'P'),
(88494, 'Leatherwood', 35.3941688537598, 0.617744782504935, -87.8477783203125, -1.53323297225155, 218, 50, 'PPL', 'P'),
(103586, 'Leatherwood', 36.7408294677734, 0.641248444126402, -79.7466735839844, -1.39184202155371, 218, 53, 'PPL', 'P'),
(163671, 'Leatherwood', 41.0299987792969, 0.716108570787985, -79.3913879394531, -1.38564111727157, 218, 45, 'PPL', 'P'),
(177236, 'Leatherwood', 40.0733299255371, 0.699411549438597, -80.6963882446289, -1.40841766933642, 218, 58, 'PPL', 'P'),
(88493, 'Leatherwood (historical)', 35.7536087036133, 0.624018191347753, -87.225830078125, -1.52237792764838, 218, 50, 'PPL', 'P'),
(131717, 'Leaton', 43.6699981689453, 0.762185252387991, -84.7083282470703, -1.47843923177149, 218, 27, 'PPL', 'P'),
(41750, 'Leavel', 30.7055606842041, 0.535913132610284, -91.4886093139648, -1.59677746059944, 218, 22, 'PPL', 'P'),
(103587, 'Leavells', 38.2447204589844, 0.667496293514114, -77.5255584716797, -1.35307624977819, 218, 53, 'PPL', 'P'),
(82044, 'Leavensworth (historical)', 34.4094390869141, 0.600558005831082, -79.940559387207, -1.39522596719282, 218, 48, 'PPL', 'P'),
(30314, 'Leavenworth', 38.1997184753418, 0.666710860729623, -86.3441696166992, -1.50699004971185, 218, 19, 'PPL', 'P'),
(33014, 'Leavenworth', 39.3111114501953, 0.686108327424351, -94.9222183227539, -1.65670524302895, 218, 20, 'PPL', 'P'),
(136448, 'Leavenworth', 44.2224998474121, 0.771828225800031, -94.8016662597656, -1.65460121260973, 218, 28, 'PPL', 'P'),
(207905, 'Leavenworth', 47.5963897705078, 0.83071371355791, -120.660278320313, -2.10591913306219, 218, 56, 'PPL', 'P'),
(186973, 'Leavick', 39.1949996948242, 0.684081794992855, -106.136940002441, -1.85243906103428, 218, 7, 'PPL', 'P'),
(10009, 'Leavits (historical)', 33.5261116027832, 0.58514103285964, -91.4599990844727, -1.59627811789505, 218, 4, 'PPL', 'P'),
(193732, 'Leavitt', 40.396110534668, 0.705045133829523, -120.525001525879, -2.10355810759778, 218, 6, 'PPL', 'P'),
(144045, 'Leavitt Park', 43.6777801513672, 0.762321073603585, -71.4541702270508, -1.24711053474254, 218, 36, 'PPL', 'P'),
(144048, 'Leavitts Hill', 43.1197204589844, 0.752581094548838, -71.2908325195313, -1.24425975395367, 218, 36, 'PPL', 'P'),
(156101, 'Leavittsburg', 41.2477798461914, 0.7199095674538, -80.8772201538086, -1.41157378154427, 218, 41, 'PPL', 'P'),
(113254, 'Leavittsville', 40.5136108398438, 0.707095901026939, -81.1963882446289, -1.41714431559639, 218, 41, 'PPL', 'P'),
(33017, 'Leawood', 38.9666709899902, 0.680096707316688, -94.6166687011719, -1.65137239610412, 218, 20, 'PPL', 'P'),
(55833, 'Leawood', 37.0369415283203, 0.64641657453781, -94.4966735839844, -1.64927808622288, 218, 29, 'PPL', 'P'),
(82050, 'Leawood', 34.8916702270508, 0.608974526982114, -82.4033279418945, -1.4382093871867, 218, 48, 'PPL', 'P'),
(207906, 'Lebam', 46.5591697692871, 0.812610809469069, -123.547782897949, -2.15631559510836, 218, 56, 'PPL', 'P'),
(3710, 'Lebanon', 34.3702812194824, 0.59987457211634, -86.9700012207031, -1.51791287176476, 218, 2, 'PPL', 'P'),
(10010, 'Lebanon', 34.1063919067383, 0.59526883474813, -94.0977783203125, -1.64231605050119, 218, 4, 'PPL', 'P'),
(14101, 'Lebanon', 39.1113891601563, 0.682622515873546, -75.5008316040039, -1.31773809948366, 218, 10, 'PPL', 'P'),
(22606, 'Lebanon', 34.1427803039551, 0.595903932089086, -84.5094375610352, -1.47496793444863, 218, 13, 'PPL', 'P'),
(27690, 'Lebanon', 38.603889465332, 0.673764975245997, -89.8072204589844, -1.56743168907369, 218, 18, 'PPL', 'P'),
(33033, 'Lebanon', 39.8097190856934, 0.694810672339376, -98.5552825927734, -1.72011417647735, 218, 20, 'PPL', 'P'),
(36825, 'Lebanon', 37.5697212219238, 0.655715334378958, -85.2527770996094, -1.48794165685701, 218, 21, 'PPL', 'P'),
(55834, 'Lebanon', 37.6805610656738, 0.657649854594792, -92.6636123657227, -1.61728513257359, 218, 29, 'PPL', 'P'),
(60600, 'Lebanon', 34.5563888549805, 0.603122763118882, -88.7333297729492, -1.54868876079588, 218, 30, 'PPL', 'P'),
(73188, 'Lebanon', 39.4352798461914, 0.688275474761403, -84.2030563354492, -1.46962057329586, 218, 41, 'PPL', 'P'),
(76358, 'Lebanon', 33.9822196960449, 0.593101620832051, -96.9075012207031, -1.69135496618169, 218, 42, 'PPL', 'P'),
(82048, 'Lebanon', 34.4113883972168, 0.600592027714007, -81.2050018310547, -1.41729465103993, 218, 48, 'PPL', 'P'),
(88498, 'Lebanon', 36.2080612182617, 0.631949884022336, -86.2911071777344, -1.50606393544278, 218, 50, 'PPL', 'P'),
(95659, 'Lebanon', 32.3686103820801, 0.564938825462517, -97.4466705322266, -1.70076524589349, 218, 51, 'PPL', 'P'),
(103588, 'Lebanon', 36.9008293151855, 0.644040968266432, -82.0802764892578, -1.43257107568484, 218, 53, 'PPL', 'P'),
(113630, 'Lebanon', 41.6361083984375, 0.726687179269997, -72.2130584716797, -1.26035563326599, 218, 8, 'PPL', 'P'),
(116434, 'Lebanon', 40.725830078125, 0.710799825471021, -92.0822219848633, -1.60713795618817, 218, 16, 'PPL', 'P'),
(123035, 'Lebanon', 40.0483283996582, 0.698975190493987, -86.4691696166992, -1.50917171127684, 218, 19, 'PPL', 'P'),
(127926, 'Lebanon', 43.3944396972656, 0.757375849775417, -70.8513870239258, -1.23658998317229, 218, 26, 'PPL', 'P'),
(144046, 'Lebanon', 43.642219543457, 0.761700423911542, -72.2522201538086, -1.26103913355976, 218, 36, 'PPL', 'P'),
(145587, 'Lebanon', 40.6416702270508, 0.709330958971788, -74.8363876342773, -1.30614136451691, 218, 37, 'PPL', 'P'),
(150203, 'Lebanon', 41.3600006103516, 0.721868189277499, -74.1586074829102, -1.29431186927089, 218, 40, 'PPL', 'P'),
(163673, 'Lebanon', 40.3408317565918, 0.704080337145615, -76.4116668701172, -1.33363517382062, 218, 45, 'PPL', 'P'),
(170722, 'Lebanon', 45.0697212219238, 0.786615028278533, -99.7694396972656, -1.74130521558722, 218, 49, 'PPL', 'P'),
(174932, 'Lebanon', 43.2552795410156, 0.754947046861264, -88.6266708374023, -1.54682721119391, 218, 57, 'PPL', 'P'),
(178519, 'Lebanon', 32.7452812194824, 0.571512971771432, -109.715560913086, -1.91489777860575, 218, 5, 'PPL', 'P'),
(186974, 'Lebanon', 37.457218170166, 0.653751785707243, -108.590827941895, -1.89526748505272, 218, 7, 'PPL', 'P'),
(199471, 'Lebanon', 40.0505599975586, 0.69901413922493, -100.275833129883, -1.75014344829687, 218, 35, 'PPL', 'P'),
(201116, 'Lebanon', 44.5366706848145, 0.77731154132645, -122.905830383301, -2.14511141008628, 218, 43, 'PPL', 'P'),
(10011, 'Lebanon (historical)', 35.9161109924316, 0.62685439132966, -92.7152786254883, -1.61818687891869, 218, 4, 'PPL', 'P'),
(22607, 'Lebanon (historical)', 32.0269393920898, 0.558975541728639, -84.4241714477539, -1.47347976003149, 218, 13, 'PPL', 'P'),
(41751, 'Lebanon (historical)', 32.9319381713867, 0.574770750153899, -91.2261123657227, -1.59219602457617, 218, 22, 'PPL', 'P'),
(55835, 'Lebanon (historical)', 39.0694389343262, 0.681890346310856, -92.220832824707, -1.6095571717224, 218, 29, 'PPL', 'P'),
(150204, 'Lebanon Center', 42.7849998474121, 0.746739117802613, -75.620002746582, -1.31981802829501, 218, 40, 'PPL', 'P'),
(103589, 'Lebanon Church', 39.0550003051758, 0.681638344692708, -78.3683319091797, -1.36778542111092, 218, 53, 'PPL', 'P'),
(88499, 'Lebanon Heights', 35.5750007629395, 0.620900894712788, -87.0236129760742, -1.51884857341376, 218, 50, 'PPL', 'P'),
(163675, 'Lebanon Independent', 40.3541717529297, 0.704313164003915, -76.4291687011719, -1.33394063839765, 218, 45, 'PPL', 'P'),
(36826, 'Lebanon Junction', 37.8344383239746, 0.660335519396082, -85.7319412231445, -1.49630464847013, 218, 21, 'PPL', 'P'),
(71025, 'Lebanon Lake Estates', 39.9069404602051, 0.69650750542792, -74.5650024414063, -1.30140479936015, 218, 37, 'PPL', 'P'),
(150205, 'Lebanon Springs', 42.4752807617188, 0.741333500000997, -73.3797225952148, -1.28071776348658, 218, 40, 'PPL', 'P'),
(41752, 'Lebeau', 30.7311096191406, 0.536359045645305, -91.976936340332, -1.60530037503602, 218, 22, 'PPL', 'P'),
(182753, 'Lebec', 34.8416709899902, 0.608101875671922, -118.863891601563, -2.0745662701809, 218, 6, 'PPL', 'P'),
(55838, 'Lebeck', 37.889720916748, 0.661300382659018, -93.9130630493164, -1.6390921608436, 218, 29, 'PPL', 'P'),
(207907, 'Leber', 46.9483299255371, 0.819402935513207, -122.330001831055, -2.1350613059226, 218, 56, 'PPL', 'P'),
(41748, 'LeBlanc', 30.2386093139648, 0.52776329375291, -91.085563659668, -1.5897429868961, 218, 22, 'PPL', 'P'),
(33020, 'Lebo', 38.4166717529297, 0.670497409746525, -95.852783203125, -1.67294666409485, 218, 20, 'PPL', 'P'),
(55839, 'Lebo', 36.5202789306641, 0.637399111086802, -91.9086074829102, -1.60410781149988, 218, 29, 'PPL', 'P'),
(196887, 'Lebo', 46.3444404602051, 0.808863076025055, -110.393333435059, -1.92672714069371, 218, 31, 'PPL', 'P'),
(163678, 'Lebo Vista', 41.3891716003418, 0.722377319098895, -77.4686126708984, -1.35208235805938, 218, 45, 'PPL', 'P'),
(163663, 'LeBoeuf Garden', 41.9297218322754, 0.731811700418555, -79.9822235107422, -1.39595314332847, 218, 45, 'PPL', 'P'),
(144043, 'LeBruns Mobile Home Park', 43.6522216796875, 0.761874994120996, -72.1722183227539, -1.25964283820024, 218, 36, 'PPL', 'P'),
(36827, 'Leburn', 37.3480606079102, 0.651846626842427, -82.9552764892578, -1.44784270663979, 218, 21, 'PPL', 'P'),
(16865, 'Lecanto', 28.851390838623, 0.5035517639137, -82.4877777099609, -1.43968331369201, 218, 12, 'PPL', 'P'),
(103591, 'Lecato', 37.9388885498047, 0.662158519741268, -75.5502777099609, -1.3186010968349, 218, 53, 'PPL', 'P'),
(41753, 'Leche', 29.8616695404053, 0.521184453622574, -90.9655609130859, -1.58764854385681, 218, 22, 'PPL', 'P'),
(178520, 'Lechee', 35.0322189331055, 0.611427564662186, -110.752220153809, -1.93299089557758, 218, 5, 'PPL', 'P'),
(178518, 'LeChee Chapter', 36.8600006103516, 0.643328372937754, -111.443328857422, -1.94505301794482, 218, 5, 'PPL', 'P'),
(103592, 'Leck', 37.0380592346191, 0.646436082192795, -82.4008331298828, -1.43816584450288, 218, 53, 'PPL', 'P'),
(163679, 'Leck Kill', 40.7166709899902, 0.710639969226589, -76.6302795410156, -1.33745068471437, 218, 45, 'PPL', 'P'),
(169, 'Leckie', 37.3450012207031, 0.651793230462571, -81.4180603027344, -1.42101322287001, 218, 58, 'PPL', 'P'),
(209564, 'Leckie', 42.5708312988281, 0.743001171475605, -109.278327941895, -1.90726662366018, 218, 59, 'PPL', 'P'),
(36828, 'Leckieville', 37.6588897705078, 0.657271619140973, -82.2724990844727, -1.43592599286807, 218, 21, 'PPL', 'P'),
(78599, 'Leckrone', 39.8613891601563, 0.695712485263504, -79.8702774047852, -1.39399931519473, 218, 45, 'PPL', 'P'),
(27692, 'Leclaire', 38.7955589294434, 0.677110238470273, -89.9569396972656, -1.57004478273528, 218, 18, 'PPL', 'P'),
(55840, 'Lecoma', 37.7761116027832, 0.659317526069399, -91.730827331543, -1.60100496251383, 218, 29, 'PPL', 'P'),
(41754, 'Lecompte', 31.0944404602051, 0.542700365095919, -92.4002838134766, -1.61268918232239, 218, 22, 'PPL', 'P'),
(33021, 'Lecompton', 39.0444412231445, 0.681454053945274, -95.3944396972656, -1.66494706081247, 218, 20, 'PPL', 'P'),
(163683, 'Lecontes Mills', 41.0830612182617, 0.71703468505706, -78.2836074829102, -1.36630670091565, 218, 45, 'PPL', 'P'),
(22608, 'Lecount', 31.6797199249268, 0.552915418799623, -81.4588928222656, -1.42172588477771, 218, 13, 'PPL', 'P'),
(3712, 'Lecta', 33.5883293151855, 0.58622693679412, -85.4327774047852, -1.49108325483692, 218, 2, 'PPL', 'P'),
(36830, 'Lecta', 37.0111083984375, 0.64596570136526, -85.8561096191406, -1.49847179580718, 218, 21, 'PPL', 'P'),
(73191, 'Lecta', 38.6691703796387, 0.67490434213936, -82.3772201538086, -1.43775372032419, 218, 41, 'PPL', 'P'),
(103593, 'Leda', 36.9041709899902, 0.644099291494305, -79.0863876342773, -1.38031785772667, 218, 53, 'PPL', 'P'),
(761, 'Ledbetter', 34.9880599975586, 0.610656845842717, -79.7180633544922, -1.39134267884932, 218, 33, 'PPL', 'P'),
(3713, 'Ledbetter', 33.3847198486328, 0.582673281214546, -86.2408294677734, -1.5051864238636, 218, 2, 'PPL', 'P'),
(36829, 'Ledbetter', 37.0475006103516, 0.646600865285244, -88.476936340332, -1.54421385121622, 218, 21, 'PPL', 'P'),
(88500, 'Ledbetter', 35.934440612793, 0.627174303555606, -88.7291717529297, -1.54861618965617, 218, 50, 'PPL', 'P'),
(95660, 'Ledbetter', 30.1505603790283, 0.526226549935394, -96.7911071777344, -1.68932350690218, 218, 51, 'PPL', 'P'),
(95661, 'Ledbetter Hills', 32.6922187805176, 0.570586857502357, -96.9258270263672, -1.69167481182861, 218, 51, 'PPL', 'P'),
(3714, 'Ledbetters', 33.290828704834, 0.581034571616793, -86.1880569458008, -1.50426536960059, 218, 2, 'PPL', 'P'),
(55841, 'Lede', 36.6166687011719, 0.639081429947405, -90.8166732788086, -1.58504996442316, 218, 29, 'PPL', 'P'),
(163680, 'Lederach', 40.2616691589355, 0.702698689172081, -75.4063873291016, -1.31608973592696, 218, 45, 'PPL', 'P'),
(27693, 'Ledford', 37.7000007629395, 0.657989141317668, -88.5899963378906, -1.54618712042591, 218, 18, 'PPL', 'P'),
(36831, 'Ledford', 36.5299987792969, 0.63756875444824, -89.3024978637695, -1.55862261797798, 218, 21, 'PPL', 'P'),
(88501, 'Ledfords Mill', 35.4030609130859, 0.61789997821746, -86.2761077880859, -1.50580214670762, 218, 50, 'PPL', 'P'),
(163681, 'Ledgedale', 41.3705596923828, 0.722052480024933, -75.3291702270508, -1.31474204325732, 218, 45, 'PPL', 'P'),
(66298, 'Ledger', 35.964168548584, 0.627693153914981, -82.1297225952148, -1.43343407303608, 218, 33, 'PPL', 'P'),
(196889, 'Ledger', 48.2602806091309, 0.842300794565708, -111.822219848633, -1.9516659132476, 218, 31, 'PPL', 'P'),
(22609, 'Ledgewood', 33.4477806091309, 0.583773899114048, -84.5016708374023, -1.47483237954914, 218, 13, 'PPL', 'P'),
(145590, 'Ledgewood', 40.8811111450195, 0.71350999135434, -74.6563873291016, -1.302999766537, 218, 37, 'PPL', 'P'),
(150207, 'Ledgewood Park', 42.202220916748, 0.736567706651273, -74.0141677856445, -1.29179092098302, 218, 40, 'PPL', 'P'),
(48883, 'Lednums Corner', 38.8444404602051, 0.67796338212548, -76.0430603027344, -1.32720177557531, 218, 25, 'PPL', 'P'),
(36833, 'Ledocio', 38.0288887023926, 0.663729318731224, -82.7141723632813, -1.44363464580136, 218, 21, 'PPL', 'P'),
(41755, 'Ledoux', 30.6188907623291, 0.534400457111119, -92.1900024414063, -1.60901908002415, 218, 22, 'PPL', 'P'),
(188867, 'Ledoux', 35.9236106872559, 0.626985285697238, -105.360832214355, -1.83889342478181, 218, 38, 'PPL', 'P'),
(13143, 'LeDroit Park', 38.915828704834, 0.679209342041474, -77.01611328125, -1.34418475384675, 218, 9, 'PPL', 'P'),
(55842, 'Leduc (historical)', 38.1991691589355, 0.666701273349698, -91.5933303833008, -1.59860518805556, 218, 29, 'PPL', 'P'),
(195223, 'Leduc (historical)', 43.3291702270508, 0.756236682619135, -114.065002441406, -1.99080985389791, 218, 17, 'PPL', 'P'),
(182754, 'Leduc Acres', 39.1925010681152, 0.684038185730005, -121.017219543457, -2.11214893264215, 218, 6, 'PPL', 'P'),
(10013, 'Ledwidge', 34.957218170166, 0.610118554407384, -92.5661087036133, -1.61558337263703, 218, 4, 'PPL', 'P'),
(78600, 'Ledy', 39.857780456543, 0.695649501503724, -77.5430603027344, -1.35338171435523, 218, 45, 'PPL', 'P'),
(116447, 'Ledyard', 43.4216690063477, 0.757851090871941, -94.1619415283203, -1.64343590973957, 218, 16, 'PPL', 'P'),
(150208, 'Ledyard', 42.6952781677246, 0.745173179081646, -76.621940612793, -1.3373051429608, 218, 40, 'PPL', 'P'),
(113632, 'Ledyard Center', 41.4397201538086, 0.723259557789011, -72.0147171020508, -1.25689392332306, 218, 8, 'PPL', 'P'),
(3715, 'Lee', 31.4877796173096, 0.549565428464412, -86.0747222900391, -1.50228730670094, 218, 2, 'PPL', 'P'),
(16866, 'Lee', 30.4194393157959, 0.53091937267125, -83.3005599975586, -1.45386904071248, 218, 12, 'PPL', 'P'),
(36832, 'Lee', 37.2958297729492, 0.650935026801293, -86.4994430541992, -1.50970008243712, 218, 21, 'PPL', 'P'),
(103596, 'Lee', 37.6113891601563, 0.656442577093631, -77.8166732788086, -1.3581571616639, 218, 53, 'PPL', 'P'),
(110060, 'Lee', 37.8827781677246, 0.661179208829419, -81.1563873291016, -1.41644616791663, 218, 58, 'PPL', 'P'),
(120321, 'Lee', 41.7949981689453, 0.729460328913097, -88.9413909912109, -1.55232011410025, 218, 18, 'PPL', 'P'),
(123036, 'Lee', 40.8963890075684, 0.713776640358484, -86.9680633544922, -1.51787904961891, 218, 19, 'PPL', 'P'),
(125218, 'Lee', 42.3041687011719, 0.738347031154582, -73.2486114501953, -1.27842944231993, 218, 23, 'PPL', 'P'),
(127928, 'Lee', 45.3600006103516, 0.791681359357272, -68.2869415283203, -1.19183196578604, 218, 26, 'PPL', 'P'),
(131721, 'Lee', 42.4508285522461, 0.740906728436312, -86.0908279418945, -1.50256840335399, 218, 27, 'PPL', 'P'),
(144049, 'Lee', 43.1230583190918, 0.752639351197683, -71.0119400024414, -1.23939216127127, 218, 36, 'PPL', 'P'),
(150211, 'Lee', 42.9561080932617, 0.74972552007, -73.48388671875, -1.28253577040472, 218, 40, 'PPL', 'P'),
(163682, 'Lee', 41.1536102294922, 0.718265997587058, -76.0849990844727, -1.32793374540092, 218, 45, 'PPL', 'P'),
(191752, 'Lee', 35.2999992370605, 0.616101212638193, -101.496673583984, -1.77145113386248, 218, 51, 'PPL', 'P'),
(200045, 'Lee', 40.5683288574219, 0.708050910593841, -115.606666564941, -2.01771696881347, 218, 39, 'PPL', 'P'),
(207908, 'Lee', 46.355281829834, 0.809052293620505, -118.555000305176, -2.0691751000282, 218, 56, 'PPL', 'P'),
(10015, 'Lee (historical)', 36.4780616760254, 0.636662280992204, -94.524169921875, -1.64975798785131, 218, 4, 'PPL', 'P'),
(88502, 'Lee (historical)', 36.3499984741211, 0.634427156468328, -85.3572235107422, -1.48976459062316, 218, 50, 'PPL', 'P'),
(103594, 'Lee (historical)', 36.8255615234375, 0.642727297479723, -83.0722198486328, -1.44988375329923, 218, 53, 'PPL', 'P'),
(116437, 'Lee (historical)', 40.5877799987793, 0.708390397053799, -94.1105575561523, -1.64253909024249, 218, 16, 'PPL', 'P'),
(196888, 'Lee (historical)', 45.8677787780762, 0.800543760253811, -106.389442443848, -1.85684606000614, 218, 31, 'PPL', 'P'),
(201117, 'Lee (historical)', 43.1683311462402, 0.75342951109311, -124.071113586426, -2.165449438699, 218, 43, 'PPL', 'P'),
(82049, 'Lee Acres', 34.1650009155273, 0.596291754922829, -79.8063888549805, -1.39288424964632, 218, 48, 'PPL', 'P'),
(188869, 'Lee Acres', 36.6988906860352, 0.640516474300794, -108.036109924316, -1.88558582922584, 218, 38, 'PPL', 'P'),
(41756, 'Lee Bayou', 31.7630596160889, 0.554369970807997, -91.5602798461914, -1.59802834736345, 218, 22, 'PPL', 'P'),
(110061, 'Lee Bell', 38.6827812194824, 0.675141896108596, -80.0058288574219, -1.3963651343491, 218, 58, 'PPL', 'P'),
(103595, 'Lee Boulevard Heights', 38.8663902282715, 0.678346477848288, -77.1447219848633, -1.34642939917152, 218, 53, 'PPL', 'P'),
(190403, 'Lee Canyon Summer Home Area', 36.3211097717285, 0.633922953494949, -115.663063049316, -2.01870127315236, 218, 39, 'PPL', 'P'),
(120322, 'Lee Center', 41.747501373291, 0.728631353444783, -89.2786102294922, -1.55820570010933, 218, 18, 'PPL', 'P'),
(131720, 'Lee Center', 42.4069404602051, 0.740140736727778, -84.8886108398438, -1.48158575659942, 218, 27, 'PPL', 'P'),
(150212, 'Lee Center', 43.3033294677734, 0.75578567628853, -75.5183334350586, -1.31804356406069, 218, 40, 'PPL', 'P'),
(36834, 'Lee City', 37.7391700744629, 0.658672774769491, -83.3330612182617, -1.45443629402466, 218, 21, 'PPL', 'P'),
(10018, 'Lee Creek', 35.6813888549805, 0.622757717203819, -94.3491668701172, -1.6467036083971, 218, 4, 'PPL', 'P'),
(110067, 'Lee Creek', 39.1530609130859, 0.683349825167247, -81.7397232055664, -1.42662729960595, 218, 58, 'PPL', 'P'),
(3718, 'Lee Crossroads', 33.1997184753418, 0.579444398129906, -85.2736129760742, -1.48830531150386, 218, 2, 'PPL', 'P'),
(82056, 'Lee Crossroads', 33.8713912963867, 0.591167300353299, -79.666389465332, -1.39044079934617, 218, 48, 'PPL', 'P'),
(16868, 'Lee Cypress', 25.9438896179199, 0.452806294606676, -81.3630599975586, -1.42005328645509, 218, 12, 'PPL', 'P'),
(103598, 'Lee Dale Shores', 37.8413887023926, 0.660456826383735, -76.3441696166992, -1.33245712451242, 218, 53, 'PPL', 'P'),
(88503, 'Lee Estates', 35.2230606079102, 0.614758380237548, -84.8861083984375, -1.48154208075755, 218, 50, 'PPL', 'P'),
(144050, 'Lee Five Corners', 43.1505584716797, 0.753119319405143, -70.976936340332, -1.23878123211721, 218, 36, 'PPL', 'P'),
(103599, 'Lee Forest', 38.834171295166, 0.677784151384118, -77.2527770996094, -1.34831531669746, 218, 53, 'PPL', 'P'),
(103600, 'Lee Hall', 37.1916694641113, 0.649117086462178, -76.5719375610352, -1.33643242507158, 218, 53, 'PPL', 'P'),
(41758, 'Lee Heights', 31.3647193908691, 0.547417622334777, -92.4361114501953, -1.61331449254634, 218, 22, 'PPL', 'P'),
(76359, 'Lee Heights', 33.9958305358887, 0.593339174801286, -96.3486099243164, -1.68160047289901, 218, 42, 'PPL', 'P'),
(103601, 'Lee Heights', 38.9019393920898, 0.678966927803249, -77.1175003051758, -1.34595429123305, 218, 53, 'PPL', 'P'),
(82052, 'Lee Hills', 33.9830589294434, 0.593116268218046, -80.8883285522461, -1.41176765967163, 218, 48, 'PPL', 'P'),
(103603, 'Lee Hy Court', 37.2599983215332, 0.650309649998315, -79.9927825927734, -1.3961374340759, 218, 53, 'PPL', 'P'),
(103605, 'Lee Hy Gardens', 37.2636108398438, 0.650372700337123, -79.9941711425781, -1.39616166884182, 218, 53, 'PPL', 'P'),
(103604, 'Lee Hy Park', 37.2591705322266, 0.650295202349402, -80.004997253418, -1.39635062012116, 218, 53, 'PPL', 'P'),
(82053, 'Lee Jackson Estates', 32.7266693115234, 0.57118813269747, -79.9655609130859, -1.39566232613743, 218, 48, 'PPL', 'P'),
(103608, 'Lee Manor', 38.7344398498535, 0.676043509295642, -77.4925003051758, -1.35249927592803, 218, 53, 'PPL', 'P'),
(103609, 'Lee Meadows', 38.836669921875, 0.677827760646968, -77.2655563354492, -1.34853835643875, 218, 53, 'PPL', 'P'),
(103610, 'Lee Mont', 37.7786102294922, 0.659361135332249, -75.6813888549805, -1.32088941800155, 218, 53, 'PPL', 'P'),
(103611, 'Lee Park', 37.5141716003418, 0.654745810584115, -77.3019409179688, -1.34917338720068, 218, 53, 'PPL', 'P'),
(163684, 'Lee Park', 41.2311096191406, 0.719618617104709, -75.9150009155273, -1.32496671763046, 218, 45, 'PPL', 'P'),
(22611, 'Lee Pope', 32.6119384765625, 0.569185701873839, -83.9558334350586, -1.46530571969771, 218, 13, 'PPL', 'P'),
(95663, 'Lee Spring', 32.2125015258789, 0.562214211930284, -95.3716735839844, -1.66454971717783, 218, 51, 'PPL', 'P'),
(88504, 'Lee Valley', 36.4630584716797, 0.636400425678022, -83.1436080932617, -1.45112971321522, 218, 50, 'PPL', 'P'),
(182755, 'Lee Vining', 37.9575004577637, 0.662483358815231, -119.120826721191, -2.07905063398243, 218, 6, 'PPL', 'P'),
(66302, 'Lee Walker Hots', 35.5825004577637, 0.621031789080366, -82.5527801513672, -1.44081782031638, 218, 33, 'PPL', 'P'),
(103613, 'Lee-Hi Village', 38.8424987792969, 0.677929493400609, -77.3516693115234, -1.35004131139994, 218, 53, 'PPL', 'P'),
(103614, 'Lee-Mitchell', 37.2938919067383, 0.650901204655449, -80.1044387817383, -1.39808620220357, 218, 53, 'PPL', 'P'),
(163686, 'Leechburg', 40.6269416809082, 0.709073897347568, -79.605827331543, -1.38938379070952, 218, 45, 'PPL', 'P'),
(163688, 'Leechs Corners', 41.4313888549805, 0.723114149193493, -80.3344421386719, -1.4021005180727, 218, 45, 'PPL', 'P'),
(66301, 'Leechville', 35.5705604553223, 0.620823396725067, -76.503059387207, -1.33523027415552, 218, 33, 'PPL', 'P'),
(36836, 'Leeco', 37.7108306884766, 0.658178159176036, -83.6949996948242, -1.46075331213033, 218, 21, 'PPL', 'P'),
(95664, 'Leedale', 30.9863891601563, 0.540814514149007, -97.1977767944336, -1.69642123068141, 218, 51, 'PPL', 'P'),
(76360, 'Leedey', 35.8699989318848, 0.626049584048238, -99.3463897705078, -1.73392160146498, 218, 42, 'PPL', 'P'),
(60604, 'Leedo (historical)', 31.6472206115723, 0.55234819877695, -90.8444366455078, -1.5855345265835, 218, 30, 'PPL', 'P'),
(88505, 'Leedom (historical)', 35.952220916748, 0.627484628401628, -84.2744369506836, -1.4708664000538, 218, 50, 'PPL', 'P'),
(78601, 'Leedom Estates', 39.8741683959961, 0.695935525004798, -75.3216705322266, -1.31461114888974, 218, 45, 'PPL', 'P'),
(14103, 'Leedon Estates', 39.6916694641113, 0.692750317762036, -75.584716796875, -1.31920217229293, 218, 10, 'PPL', 'P'),
(3719, 'Leeds', 33.5480613708496, 0.585524128582448, -86.5444412231445, -1.51048544864258, 218, 2, 'PPL', 'P'),
(48885, 'Leeds', 39.6525001525879, 0.692066684310213, -75.8805618286133, -1.32436564217243, 218, 25, 'PPL', 'P'),
(55844, 'Leeds', 39.0558280944824, 0.681652792341621, -94.5083312988281, -1.64948155173016, 218, 29, 'PPL', 'P'),
(82054, 'Leeds', 34.6294403076172, 0.604397751490758, -81.3963928222656, -1.42063505399521, 218, 48, 'PPL', 'P'),
(116444, 'Leeds', 42.5411109924316, 0.742482454274285, -96.3597183227539, -1.68179435102636, 218, 16, 'PPL', 'P'),
(120326, 'Leeds', 41.0208282470703, 0.715948514806471, -88.9880599975586, -1.55313464191965, 218, 18, 'PPL', 'P'),
(125220, 'Leeds', 42.351390838623, 0.739171212932935, -72.6999969482422, -1.26885431293666, 218, 23, 'PPL', 'P'),
(127932, 'Leeds', 44.3033294677734, 0.773238968808474, -70.120002746582, -1.22382491943532, 218, 26, 'PPL', 'P'),
(140380, 'Leeds', 48.288890838623, 0.842800137270098, -99.4372177124023, -1.73550684810384, 218, 34, 'PPL', 'P'),
(150214, 'Leeds', 42.2552795410156, 0.737493754341321, -73.9027786254883, -1.28984681338726, 218, 40, 'PPL', 'P'),
(174938, 'Leeds', 43.3105583190918, 0.755911843545173, -89.3244400024414, -1.55900558054273, 218, 57, 'PPL', 'P'),
(192671, 'Leeds', 37.2386093139648, 0.649936341392513, -113.358329772949, -1.97847608909948, 218, 52, 'PPL', 'P'),
(127930, 'Leeds Junction', 44.2063903808594, 0.771547062567946, -70.0794372558594, -1.22311691805953, 218, 26, 'PPL', 'P'),
(48886, 'Leeds Landing', 38.8152809143066, 0.677454452041166, -76.1691665649414, -1.32940274505821, 218, 25, 'PPL', 'P'),
(71026, 'Leeds Point', 39.4919395446777, 0.689264373053177, -74.429443359375, -1.29903884704772, 218, 37, 'PPL', 'P'),
(103615, 'Leedstown', 38.1113891601563, 0.665169223353603, -76.998893737793, -1.34388421611773, 218, 53, 'PPL', 'P'),
(150215, 'Leedsville', 41.855281829834, 0.73051247728076, -73.5141677856445, -1.28306427472305, 218, 40, 'PPL', 'P'),
(60605, 'Leedy', 34.795280456543, 0.607292208121511, -88.3611068725586, -1.54219224563274, 218, 30, 'PPL', 'P'),
(196890, 'Leedy (historical)', 47.6569404602051, 0.83177052245748, -107.597221374512, -1.87792577898245, 218, 31, 'PPL', 'P'),
(209565, 'Leefe', 41.8116683959961, 0.729751279262188, -111.023612976074, -1.9377275938924, 218, 59, 'PPL', 'P'),
(22613, 'Leefield', 32.4180603027344, 0.565801889392785, -81.6136093139648, -1.424426196965, 218, 13, 'PPL', 'P'),
(71027, 'Leektown', 39.624439239502, 0.691576928985747, -74.4674987792969, -1.29970303942359, 218, 37, 'PPL', 'P'),
(131726, 'Leelanau Schools', 44.9152793884277, 0.783919509781209, -85.970832824707, -1.50047409347275, 218, 27, 'PPL', 'P'),
(131727, 'Leelanau Shores', 44.892219543457, 0.783517039561471, -85.6933288574219, -1.49563073555628, 218, 27, 'PPL', 'P'),
(48887, 'Leeland', 38.8738899230957, 0.678477372215865, -76.748893737793, -1.33952089298774, 218, 25, 'PPL', 'P'),
(103616, 'Leeland', 38.3497200012207, 0.669328881239225, -77.4338912963867, -1.35147635575333, 218, 53, 'PPL', 'P'),
(190405, 'Leeland (historical)', 36.586109161377, 0.638548065360089, -116.58528137207, -2.03479701930664, 218, 39, 'PPL', 'P'),
(174939, 'Leeman', 44.5741691589355, 0.777966013164337, -88.5563888549805, -1.54560055919582, 218, 57, 'PPL', 'P'),
(182758, 'Leeman (historical)', 38.6066703796387, 0.673813511356864, -121.559173583984, -2.12160781504384, 218, 6, 'PPL', 'P'),
(88507, 'Leemans Corner', 36.1319389343262, 0.630621299533523, -86.2491683959961, -1.50533196561717, 218, 50, 'PPL', 'P'),
(103617, 'Leemaster', 37.1866683959961, 0.64902980135745, -82.1308288574219, -1.43345338095398, 218, 53, 'PPL', 'P'),
(55845, 'Leemon', 37.464168548584, 0.653873092694896, -89.5883331298828, -1.56361138448997, 218, 29, 'PPL', 'P'),
(55846, 'Leeper', 37.0750007629395, 0.647080833492703, -90.7077789306641, -1.58314939951123, 218, 29, 'PPL', 'P'),
(163689, 'Leeper', 41.3702812194824, 0.722047619755943, -79.304443359375, -1.38412364808245, 218, 45, 'PPL', 'P'),
(131729, 'Leer', 45.1977806091309, 0.788850086223382, -83.7394409179688, -1.46152895779782, 218, 27, 'PPL', 'P'),
(82055, 'Lees', 33.348331451416, 0.582038183873589, -81.2119369506836, -1.41741569171147, 218, 48, 'PPL', 'P'),
(163690, 'Lees', 40.0522193908691, 0.699043101101784, -75.5041732788086, -1.31779642271153, 218, 45, 'PPL', 'P'),
(191753, 'Lees', 32.0761108398438, 0.559833745389917, -101.486389160156, -1.77127163680501, 218, 51, 'PPL', 'P'),
(211965, 'Lees Camp', 64.6202774047852, 1.1278366042656, -164.391387939453, -2.86917098146675, 218, 1, 'PPL', 'P'),
(48890, 'Lees Corner', 39.1500015258789, 0.683296428787391, -77.3619384765625, -1.3502205421413, 218, 25, 'PPL', 'P'),
(88508, 'Lees Corner', 35.6969413757324, 0.623029159897925, -86.8324966430664, -1.51551296414843, 218, 50, 'PPL', 'P'),
(103618, 'Lees Corner', 38.9041709899902, 0.679005876534192, -77.4172210693359, -1.35118540540424, 218, 53, 'PPL', 'P'),
(170725, 'Lees Corner', 44.0774993896484, 0.769297490395156, -99.3249969482422, -1.73354822628015, 218, 49, 'PPL', 'P'),
(41773, 'Lees Creek', 30.7419395446777, 0.536548063503673, -89.8747177124023, -1.56860973838189, 218, 22, 'PPL', 'P'),
(73193, 'Lees Creek', 39.4199981689453, 0.688008759178232, -83.6494369506836, -1.45995809222883, 218, 41, 'PPL', 'P'),
(163699, 'Lees Cross Roads', 40.0697212219238, 0.699348565678816, -77.4422225952148, -1.35162176434885, 218, 45, 'PPL', 'P'),
(22618, 'Lees Crossing', 33.0308303833008, 0.576496744856379, -85.0611114501953, -1.48459646021176, 218, 13, 'PPL', 'P'),
(82058, 'Lees Crossroads', 34.2999992370605, 0.59864792011825, -80.0858306884766, -1.39776142970863, 218, 48, 'PPL', 'P'),
(41759, 'Lees Landing', 30.4041690826416, 0.53065285682516, -90.3236083984375, -1.57644435883474, 218, 22, 'PPL', 'P'),
(156103, 'Lees Landing', 40.5063896179199, 0.706969866928351, -84.4899978637695, -1.47462864772575, 218, 41, 'PPL', 'P'),
(36839, 'Lees Lick', 38.3358306884766, 0.669086467001001, -84.4186096191406, -1.47338268780976, 218, 21, 'PPL', 'P'),
(22614, 'Lees Mill', 33.5022201538086, 0.584724048411961, -84.5269393920898, -1.47527339902566, 218, 13, 'PPL', 'P'),
(48891, 'Lees Mill', 39.5530586242676, 0.690331102227808, -76.8713912963867, -1.34165887871086, 218, 25, 'PPL', 'P'),
(66303, 'Lees Mill', 35.3244400024414, 0.616527784465796, -78.414436340332, -1.36859009523429, 218, 33, 'PPL', 'P'),
(78602, 'Lees Mill', 39.7380599975586, 0.693559985312447, -76.0800018310547, -1.32784652687522, 218, 45, 'PPL', 'P'),
(103620, 'Lees Mill', 37.1088905334473, 0.64767232157081, -77.3247222900391, -1.34957099715143, 218, 53, 'PPL', 'P'),
(144052, 'Lees Mill', 43.7391700744629, 0.763392529889151, -71.3902816772461, -1.24599546919412, 218, 36, 'PPL', 'P'),
(3720, 'Lees Park', 31.8555603027344, 0.555984412350316, -86.0263900756836, -1.50144375042565, 218, 2, 'PPL', 'P'),
(88510, 'Lees Station', 35.5541687011719, 0.620537306644965, -85.2527770996094, -1.48794165685701, 218, 50, 'PPL', 'P'),
(55847, 'Lees Summit', 38.910831451416, 0.679122123515774, -94.3819427490234, -1.64727565539925, 218, 29, 'PPL', 'P'),
(3721, 'Leesburg', 34.1797218322754, 0.596548683388995, -85.7613906860352, -1.49681863856051, 218, 2, 'PPL', 'P'),
(16869, 'Leesburg', 28.8105602264404, 0.502839135295509, -81.878059387207, -1.42904172145021, 218, 12, 'PPL', 'P'),
(22615, 'Leesburg', 31.7319393157959, 0.553826819103675, -84.1708297729492, -1.46905811367363, 218, 13, 'PPL', 'P'),
(36837, 'Leesburg', 38.2944412231445, 0.668364084555317, -84.418327331543, -1.47337776096174, 218, 21, 'PPL', 'P'),
(41760, 'Leesburg', 30.0027809143066, 0.523647311709166, -91.820556640625, -1.60257103439285, 218, 22, 'PPL', 'P'),
(60606, 'Leesburg', 32.4402809143066, 0.566189712226527, -89.7602767944336, -1.56661236756433, 218, 30, 'PPL', 'P'),
(71028, 'Leesburg', 39.2566719055176, 0.685158178126438, -74.9877777099609, -1.30878361979243, 218, 37, 'PPL', 'P'),
(73195, 'Leesburg', 39.3450012207031, 0.686699815502458, -83.5530624389648, -1.45827603968434, 218, 41, 'PPL', 'P'),
(82059, 'Leesburg', 34.0163917541504, 0.593698035758174, -80.7055587768555, -1.40857772531794, 218, 48, 'PPL', 'P'),
(88509, 'Leesburg', 36.2922210693359, 0.633418750521569, -82.5444412231445, -1.44067227856281, 218, 50, 'PPL', 'P'),
(95665, 'Leesburg', 32.9874992370605, 0.575740473685824, -95.083610534668, -1.65952206851392, 218, 51, 'PPL', 'P'),
(103621, 'Leesburg', 39.1155586242676, 0.682695286750333, -77.5638885498047, -1.35374523584402, 218, 53, 'PPL', 'P'),
(120328, 'Leesburg', 40.2472190856934, 0.702446487816851, -90.3172225952148, -1.57633290554312, 218, 18, 'PPL', 'P'),
(123037, 'Leesburg', 41.3319396972656, 0.721378433953033, -85.8499984741211, -1.49836513620552, 218, 19, 'PPL', 'P'),
(163691, 'Leesburg', 41.1344413757324, 0.717931437975117, -80.2202835083008, -1.40010807410316, 218, 45, 'PPL', 'P'),
(195224, 'Leesburg', 45.2238883972168, 0.789305753085894, -114.113059997559, -1.99164861648323, 218, 17, 'PPL', 'P'),
(163692, 'Leesburg Station', 41.1430587768555, 0.718081839997679, -80.2413864135742, -1.40047638928191, 218, 45, 'PPL', 'P'),
(3722, 'Leesdale', 34.389720916748, 0.600213858839216, -86.9116668701172, -1.51689474528002, 218, 2, 'PPL', 'P'),
(60607, 'Leesdale', 31.5466709136963, 0.550593275487128, -91.1577835083008, -1.59100346104004, 218, 30, 'PPL', 'P'),
(182756, 'Leesdale', 34.1966705322266, 0.596844494007075, -119.098892211914, -2.07866780457573, 218, 6, 'PPL', 'P'),
(163693, 'Leesport', 40.4469413757324, 0.705932299367656, -75.966667175293, -1.32586846397556, 218, 45, 'PPL', 'P'),
(30315, 'Leesville', 38.8455581665039, 0.677982889780465, -86.2844390869141, -1.50594755530314, 218, 19, 'PPL', 'P'),
(41761, 'Leesville', 31.1433296203613, 0.543553641909181, -93.2608337402344, -1.62770861192211, 218, 22, 'PPL', 'P'),
(55848, 'Leesville', 38.3486099243164, 0.669309506742295, -93.5444412231445, -1.63265849628218, 218, 29, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(66306, 'Leesville', 35.9069404602051, 0.626694335348147, -78.7263870239258, -1.37403466176684, 218, 33, 'PPL', 'P'),
(82060, 'Leesville', 33.916389465332, 0.591952666558763, -81.5136108398438, -1.42268089434461, 218, 48, 'PPL', 'P'),
(95666, 'Leesville', 29.4066696166992, 0.51324320685758, -97.7447204589844, -1.70596719845074, 218, 51, 'PPL', 'P'),
(103625, 'Leesville', 38.1416702270508, 0.665697727671929, -77.0472183227539, -1.34472763923496, 218, 53, 'PPL', 'P'),
(113634, 'Leesville', 41.5116691589355, 0.724515304822011, -72.4816665649414, -1.26504372889092, 218, 8, 'PPL', 'P'),
(120329, 'Leesville', 41.0247192382813, 0.716016425414268, -87.625, -1.52934475706003, 218, 18, 'PPL', 'P'),
(145591, 'Leesville', 40.1336097717285, 0.700463631227232, -74.3827819824219, -1.29822445238638, 218, 37, 'PPL', 'P'),
(150216, 'Leesville', 42.7969398498535, 0.746947510157912, -74.647216796875, -1.30283971055548, 218, 40, 'PPL', 'P'),
(156106, 'Leesville', 40.795280456543, 0.71201196324117, -82.788330078125, -1.44492894209114, 218, 41, 'PPL', 'P'),
(182757, 'Leesville', 39.1894416809082, 0.683984789350149, -122.422500610352, -2.1366757141754, 218, 6, 'PPL', 'P'),
(156107, 'Leesville Glens', 40.4877815246582, 0.706645094433415, -81.1916732788086, -1.41706202391871, 218, 41, 'PPL', 'P'),
(156108, 'Leesville Hills', 40.459171295166, 0.706145751729025, -81.1722183227539, -1.41672247087972, 218, 41, 'PPL', 'P'),
(156109, 'Leesville Lake Park', 40.4569396972656, 0.706106802998083, -81.1833267211914, -1.41691634900708, 218, 41, 'PPL', 'P'),
(110063, 'Leet', 38.0686111450195, 0.664422606141999, -82.0761108398438, -1.43249837138708, 218, 58, 'PPL', 'P'),
(190406, 'Leete (historical)', 39.7411117553711, 0.693613248534249, -119.054443359375, -2.07789202575019, 218, 39, 'PPL', 'P'),
(113635, 'Leetes Island', 41.2652816772461, 0.720215032030832, -72.7147216796875, -1.26911130798185, 218, 8, 'PPL', 'P'),
(190408, 'Leeteville (historical)', 39.5099983215332, 0.689579558168188, -118.932220458984, -2.07575883371704, 218, 39, 'PPL', 'P'),
(55850, 'Leeton', 38.5830612182617, 0.673401453757202, -93.6944427490234, -1.63527651679179, 218, 29, 'PPL', 'P'),
(204677, 'Leeton', 40.3891716003418, 0.704924026578952, -109.920280456543, -1.91847080868225, 218, 52, 'PPL', 'P'),
(136455, 'Leetonia', 47.4291687011719, 0.827795155319292, -92.9850006103516, -1.62289441561957, 218, 28, 'PPL', 'P'),
(156110, 'Leetonia', 40.8772201538086, 0.713442080746543, -80.7555618286133, -1.40945044320715, 218, 41, 'PPL', 'P'),
(163696, 'Leetonia', 41.5997200012207, 0.726052081929041, -77.4955596923828, -1.35255267230788, 218, 45, 'PPL', 'P'),
(10024, 'Leetown', 36.4313888549805, 0.635847686593776, -94.0472183227539, -1.64143361207399, 218, 4, 'PPL', 'P'),
(36838, 'Leetown', 37.1394386291504, 0.648205486421044, -86.7427825927734, -1.51394715858552, 218, 21, 'PPL', 'P'),
(60608, 'Leetown', 30.5583305358887, 0.533343481763981, -89.519172668457, -1.56240430672589, 218, 30, 'PPL', 'P'),
(103626, 'Leetown', 39.2269401550293, 0.684639261188036, -78.0777816772461, -1.36271436292125, 218, 53, 'PPL', 'P'),
(110064, 'Leetown', 39.348331451416, 0.686757938993249, -77.9338912963867, -1.3602030020133, 218, 58, 'PPL', 'P'),
(163697, 'Leetsdale', 40.563060760498, 0.707958964957206, -80.208610534668, -1.39990434227977, 218, 45, 'PPL', 'P'),
(131730, 'Leetsville', 44.7933311462402, 0.781791111438018, -85.1447219848633, -1.48605573933107, 218, 27, 'PPL', 'P'),
(110065, 'Leevale', 37.9661102294922, 0.662633627679739, -81.5252838134766, -1.422884626168, 218, 58, 'PPL', 'P'),
(41762, 'Leeville', 29.2477798461914, 0.510470057214481, -90.2074966430664, -1.57441782640324, 218, 22, 'PPL', 'P'),
(60609, 'Leeville', 31.3938903808594, 0.547926752156173, -89.2563934326172, -1.55781794385461, 218, 30, 'PPL', 'P'),
(88511, 'Leeville', 36.1908302307129, 0.631649146556239, -86.4175033569336, -1.50826996493174, 218, 50, 'PPL', 'P'),
(200047, 'Leeville', 40.9174995422363, 0.714145088695296, -116.312782287598, -2.03004101307392, 218, 39, 'PPL', 'P'),
(48892, 'Leew Woods', 39.5588912963867, 0.690432901560476, -76.3411102294922, -1.33240372813256, 218, 25, 'PPL', 'P'),
(82061, 'Leeward Landing', 34.5708312988281, 0.603374831316059, -82.7180633544922, -1.44370255640915, 218, 48, 'PPL', 'P'),
(22617, 'Leeward Park', 33.7569389343262, 0.589169729798658, -84.6536102294922, -1.47748422220459, 218, 13, 'PPL', 'P'),
(103627, 'Leewood', 38.8077812194824, 0.677323557673588, -77.1888885498047, -1.34720025114904, 218, 53, 'PPL', 'P'),
(110066, 'Leewood', 38.0675010681152, 0.664403231645069, -81.4499969482422, -1.42157062248616, 218, 58, 'PPL', 'P'),
(177237, 'Leewood Park', 40.1044387817383, 0.699954501405837, -80.6516723632813, -1.40763722997897, 218, 58, 'PPL', 'P'),
(150217, 'Lefever Falls', 41.8572196960449, 0.730546299426604, -74.0583267211914, -1.29256163980249, 218, 40, 'PPL', 'P'),
(150218, 'Lefferts Mill', 40.9000015258789, 0.713839690697292, -73.4452819824219, -1.28186199064893, 218, 40, 'PPL', 'P'),
(182759, 'Leffingwell', 33.9333305358887, 0.592248344018789, -117.992218017578, -2.05935269613771, 218, 6, 'PPL', 'P'),
(113636, 'Leffingwell (historical)', 41.5058288574219, 0.724413372331288, -72.142219543457, -1.25911926072993, 218, 8, 'PPL', 'P'),
(60610, 'Leflore', 33.6936111450195, 0.588064451367247, -90.0547180175781, -1.5717513363618, 218, 30, 'PPL', 'P'),
(76363, 'Leflore', 34.898609161377, 0.609095634232685, -94.9800033569336, -1.65771378213376, 218, 42, 'PPL', 'P'),
(95667, 'Lefman', 29.2625007629395, 0.510726985680646, -96.0547180175781, -1.67647109148146, 218, 51, 'PPL', 'P'),
(198514, 'Lefor', 46.6816711425781, 0.814748861771212, -102.559173583984, -1.78999525716492, 218, 34, 'PPL', 'P'),
(191754, 'Lefors', 35.4363899230957, 0.61848167917856, -100.805282592773, -1.75938408464722, 218, 51, 'PPL', 'P'),
(150219, 'Lefrak City', 40.7361106872559, 0.710979255949465, -73.8630599975586, -1.28915359255551, 218, 40, 'PPL', 'P'),
(88512, 'Leftwich', 35.5730590820313, 0.620867005987917, -86.8666687011719, -1.51610937907456, 218, 50, 'PPL', 'P'),
(178521, 'Legante Paseo', 33.3713912963867, 0.582440654093327, -111.86499786377, -1.9524125304592, 218, 5, 'PPL', 'P'),
(82062, 'Legare (historical)', 33.2816696166992, 0.580874715372361, -80.2347183227539, -1.40036000914228, 218, 48, 'PPL', 'P'),
(82063, 'Legareville', 32.6547203063965, 0.56993238566447, -80.0530624389648, -1.39718951586454, 218, 48, 'PPL', 'P'),
(112545, 'Legate', 36.5544395446777, 0.637995326275843, -87.6986083984375, -1.53062946596989, 218, 50, 'PPL', 'P'),
(103628, 'Legato', 38.8477783203125, 0.678021638774326, -77.3661117553711, -1.35029337959712, 218, 53, 'PPL', 'P'),
(178522, 'Legend Estates', 33.4672203063965, 0.584113185836924, -112.153060913086, -1.95744017912311, 218, 5, 'PPL', 'P'),
(30316, 'Legendary Hills', 39.8791694641113, 0.696022810109525, -86.2622222900391, -1.50555979904842, 218, 19, 'PPL', 'P'),
(66310, 'Legerwood', 36.0141716003418, 0.6285658718042, -81.5199966430664, -1.42279234763623, 218, 33, 'PPL', 'P'),
(110068, 'Legg', 38.4925003051758, 0.67182086765024, -81.6063919067383, -1.42430022944544, 218, 58, 'PPL', 'P'),
(196891, 'Legg (historical)', 47.5930595397949, 0.830655590067119, -107.898887634277, -1.88319084845753, 218, 31, 'PPL', 'P'),
(88513, 'Legget (historical)', 35.913890838623, 0.6268156423358, -85.1166687011719, -1.48556611716465, 218, 50, 'PPL', 'P'),
(60612, 'Leggett', 31.1352806091309, 0.543413160161679, -90.3038864135742, -1.57610014526384, 218, 30, 'PPL', 'P'),
(66309, 'Leggett', 35.9908294677734, 0.628158474736445, -77.5833282470703, -1.3540845225669, 218, 33, 'PPL', 'P'),
(95668, 'Leggett', 30.8177795410156, 0.53787172114447, -94.8702774047852, -1.65579870299388, 218, 51, 'PPL', 'P'),
(182760, 'Leggett', 39.8658294677734, 0.695789983251225, -123.71305847168, -2.15920019804307, 218, 6, 'PPL', 'P'),
(66311, 'Leggett Crossroads', 34.4413909912109, 0.601115671763344, -79.0875015258789, -1.38033729880263, 218, 33, 'PPL', 'P'),
(3723, 'Leggett Landing', 31.7275009155273, 0.553749354405467, -87.482780456543, -1.52686255776602, 218, 2, 'PPL', 'P'),
(66312, 'Leggetts Crossroads', 35.6811103820801, 0.622752856934829, -77.1605606079102, -1.34670583529267, 218, 33, 'PPL', 'P'),
(3724, 'Leggtown', 34.9558296203613, 0.610094319641465, -87.065559387207, -1.51958067639742, 218, 2, 'PPL', 'P'),
(95669, 'Legion', 30.0227794647217, 0.523996352259534, -99.1161117553711, -1.72990249190588, 218, 51, 'PPL', 'P'),
(48893, 'Legion Heights', 38.8433303833008, 0.67794400762855, -75.793327331543, -1.32284311297723, 218, 25, 'PPL', 'P'),
(66313, 'Legion Park', 35.0102806091309, 0.611044668676459, -78.9069366455078, -1.37718584712668, 218, 33, 'PPL', 'P'),
(136457, 'Legionville', 46.4472198486328, 0.810656914756305, -94.1991729736328, -1.64408572104555, 218, 28, 'PPL', 'P'),
(145592, 'Legler', 40.0505599975586, 0.69901413922493, -74.3352813720703, -1.29739541033904, 218, 37, 'PPL', 'P'),
(110069, 'Lego', 37.6338882446289, 0.656835260196364, -81.2388916015625, -1.41788613911804, 218, 58, 'PPL', 'P'),
(88514, 'Lego (historical)', 35.4872207641602, 0.619368844716693, -87.9811096191406, -1.53556004241206, 218, 50, 'PPL', 'P'),
(41763, 'Legonier', 30.9733295440674, 0.54058658084921, -91.7938919067383, -1.60210564699236, 218, 22, 'PPL', 'P'),
(48894, 'Legos Choice', 39.4622192382813, 0.688745655851857, -77.0391693115234, -1.34458715748746, 218, 25, 'PPL', 'P'),
(131731, 'Legrand', 45.4036102294922, 0.792442490796817, -84.4502792358398, -1.47393542689401, 218, 27, 'PPL', 'P'),
(36820, 'LeGrande', 37.1780586242676, 0.648879532492943, -85.7822189331055, -1.49718216004931, 218, 21, 'PPL', 'P'),
(110070, 'Lehew', 39.1991691589355, 0.684154565869642, -78.4383316040039, -1.36900714626099, 218, 58, 'PPL', 'P'),
(188870, 'Lehew', 34.4575004577637, 0.601396834995429, -108.035827636719, -1.88558090237783, 218, 38, 'PPL', 'P'),
(10026, 'Lehi', 35.1472206115723, 0.613434722596751, -90.2925033569336, -1.57590147344652, 218, 4, 'PPL', 'P'),
(178524, 'Lehi', 33.4588890075684, 0.583967777241406, -111.812782287598, -1.95150119673418, 218, 5, 'PPL', 'P'),
(204682, 'Lehi', 40.3916702270508, 0.704967635841802, -111.849998474121, -1.95215074172405, 218, 52, 'PPL', 'P'),
(3725, 'Lehigh', 33.8541717529297, 0.590866762624283, -86.6838912963867, -1.5129193115628, 218, 2, 'PPL', 'P'),
(22619, 'Lehigh', 31.6652793884277, 0.55266338389196, -82.7155609130859, -1.44365888056728, 218, 13, 'PPL', 'P'),
(33023, 'Lehigh', 38.3727798461914, 0.669731351458963, -97.3027801513672, -1.69825388498554, 218, 20, 'PPL', 'P'),
(48895, 'Lehigh', 39.1463890075684, 0.683233378448583, -76.6269378662109, -1.3373923614865, 218, 25, 'PPL', 'P'),
(76364, 'Lehigh', 34.4691696166992, 0.601600500239793, -96.2161102294922, -1.67928791696644, 218, 42, 'PPL', 'P'),
(116445, 'Lehigh', 42.3600006103516, 0.739321481797442, -94.0519409179688, -1.64151603690973, 218, 16, 'PPL', 'P'),
(120330, 'Lehigh', 41.110279083252, 0.717509726416503, -88.0180587768555, -1.53620492687002, 218, 18, 'PPL', 'P'),
(150220, 'Lehigh', 42.9474983215332, 0.749575251205493, -78.3388900756836, -1.36727156417859, 218, 40, 'PPL', 'P'),
(163703, 'Lehigh', 41.2744407653809, 0.720374888275264, -75.4541702270508, -1.31692370482231, 218, 45, 'PPL', 'P'),
(174941, 'Lehigh', 45.4411087036133, 0.793096962634704, -91.5508270263672, -1.59786336453392, 218, 57, 'PPL', 'P'),
(196892, 'Lehigh', 47.0433311462402, 0.82106101960789, -110.206390380859, -1.9234643688842, 218, 31, 'PPL', 'P'),
(198515, 'Lehigh', 46.8677787780762, 0.817997052773754, -102.69416809082, -1.79235135578131, 218, 34, 'PPL', 'P'),
(10027, 'Lehigh (historical)', 34.0022201538086, 0.593450694671933, -92.091667175293, -1.60730280585965, 218, 4, 'PPL', 'P'),
(110071, 'Lehigh (historical)', 39.0361099243164, 0.681308645349756, -79.9613876342773, -1.39558948868162, 218, 58, 'PPL', 'P'),
(16870, 'Lehigh Acres', 26.625, 0.46469391334349, -81.625, -1.42462500194037, 218, 12, 'PPL', 'P'),
(163701, 'Lehigh Furnace', 40.7425003051758, 0.711090775820112, -75.6802825927734, -1.32087011008365, 218, 45, 'PPL', 'P'),
(163702, 'Lehigh Gap', 40.776668548584, 0.711687124167208, -75.6086120605469, -1.31961922331964, 218, 45, 'PPL', 'P'),
(150221, 'Lehigh Valley Junction', 42.9336090087891, 0.749332836967268, -76.7958297729492, -1.34034008133905, 218, 40, 'PPL', 'P'),
(163707, 'Lehighton', 40.833610534668, 0.712680949306998, -75.7141723632813, -1.32146159816175, 218, 45, 'PPL', 'P'),
(136440, 'LeHillier', 44.1519393920898, 0.770596713532951, -94.0350036621094, -1.64122042602873, 218, 28, 'PPL', 'P'),
(163709, 'Lehman', 41.3169403076172, 0.721116645217879, -76.0227813720703, -1.32684784146644, 218, 45, 'PPL', 'P'),
(191755, 'Lehman', 33.6216697692871, 0.586808837492302, -102.798057556152, -1.79416456900949, 218, 51, 'PPL', 'P'),
(178523, 'Lehman Mill', 34.0958290100098, 0.595084477421669, -112.461669921875, -1.96282642242779, 218, 5, 'PPL', 'P'),
(201118, 'Lehman Springs', 45.1530609130859, 0.788069580286907, -118.660827636719, -2.07102213540222, 218, 43, 'PPL', 'P'),
(156111, 'Lehmkuhl Landing', 40.3880615234375, 0.704904652082021, -84.2958297729492, -1.47123977523863, 218, 41, 'PPL', 'P'),
(60613, 'Lehr', 31.0338897705078, 0.541643556196349, -90.1808319091797, -1.57395243900275, 218, 30, 'PPL', 'P'),
(140383, 'Lehr', 46.2797203063965, 0.807733496248698, -99.351936340332, -1.7340184073706, 218, 34, 'PPL', 'P'),
(60614, 'Lehrton (historical)', 33.7255592346191, 0.588622050720483, -90.5805587768555, -1.58092898895238, 218, 30, 'PPL', 'P'),
(210564, 'Lehua (historical)', 19.5366706848145, 0.340979228327868, -155.143890380859, -2.70777170149916, 218, 15, 'PPL', 'P'),
(163712, 'Leibeyville', 40.7286109924316, 0.710848361581887, -75.8713912963867, -1.32420558619092, 218, 45, 'PPL', 'P'),
(78604, 'Leibharts Corner', 39.9911117553711, 0.697976571664235, -76.4983291625977, -1.33514771616173, 218, 45, 'PPL', 'P'),
(55851, 'Leibig', 36.5486106872559, 0.637893593522202, -90.9513931274414, -1.5874012693496, 218, 29, 'PPL', 'P'),
(196893, 'Leibrands Trailer Court', 48.7900009155273, 0.851546158027, -105.412216186523, -1.8397902442789, 218, 31, 'PPL', 'P'),
(66314, 'Leicester', 35.6549987792969, 0.622297123493289, -82.6963882446289, -1.44332425437631, 218, 33, 'PPL', 'P'),
(125221, 'Leicester', 42.2458305358887, 0.737328838090818, -71.9091720581055, -1.25505181479705, 218, 23, 'PPL', 'P'),
(150222, 'Leicester', 42.7719383239746, 0.746511151213302, -77.8969421386719, -1.35955811755534, 218, 40, 'PPL', 'P'),
(172189, 'Leicester', 43.8666687011719, 0.765617800716994, -73.1083297729492, -1.27598106517176, 218, 55, 'PPL', 'P'),
(172190, 'Leicester Junction', 43.8558311462402, 0.765428649700571, -73.1508331298828, -1.2767228886934, 218, 55, 'PPL', 'P'),
(55852, 'Leich Ford', 39.5091705322266, 0.689565110519274, -91.8338928222656, -1.60280379467212, 218, 29, 'PPL', 'P'),
(22620, 'Leicht (historical)', 31.264720916748, 0.545672319714393, -81.6319427490234, -1.42474617576997, 218, 13, 'PPL', 'P'),
(163713, 'Leidighs', 40.1444396972656, 0.700652649085601, -77.0913925170898, -1.34549862437054, 218, 45, 'PPL', 'P'),
(163714, 'Leidy', 41.4052810668945, 0.72265848233098, -77.9227828979492, -1.36000912388594, 218, 45, 'PPL', 'P'),
(10028, 'Leidygate (historical)', 33.7866706848145, 0.58968864673706, -94.290283203125, -1.64567589453244, 218, 4, 'PPL', 'P'),
(163716, 'Leidytown', 40.3180618286133, 0.703682926931947, -75.2444381713867, -1.313263189904, 218, 45, 'PPL', 'P'),
(95670, 'Leigh', 32.6044387817383, 0.569054807506262, -94.1313934326172, -1.64290274488934, 218, 51, 'PPL', 'P'),
(142215, 'Leigh', 41.7052803039551, 0.727894456771158, -97.2377777099609, -1.69711937836117, 218, 35, 'PPL', 'P'),
(82064, 'Leigh (historical)', 33.1963882446289, 0.579386274639115, -81.7152786254883, -1.42620066119932, 218, 48, 'PPL', 'P'),
(88515, 'Leighs', 35.6097183227539, 0.621506830439808, -89.665283203125, -1.5649544166277, 218, 50, 'PPL', 'P'),
(103629, 'Leighs', 39.0322189331055, 0.681240734741959, -77.3413925170898, -1.34986194750052, 218, 53, 'PPL', 'P'),
(3726, 'Leighton', 34.7008285522461, 0.605643711406751, -87.5288925170898, -1.52766736504744, 218, 2, 'PPL', 'P'),
(36840, 'Leighton', 37.6036109924316, 0.656306822457065, -83.8861083984375, -1.4640887882376, 218, 21, 'PPL', 'P'),
(41764, 'Leighton', 29.7963905334473, 0.520045120018724, -90.857780456543, -1.58576742002083, 218, 22, 'PPL', 'P'),
(88516, 'Leighton', 35.5569381713867, 0.62058564301875, -89.0563888549805, -1.55432720545579, 218, 50, 'PPL', 'P'),
(116446, 'Leighton', 41.3372192382813, 0.72147057932675, -92.7869415283203, -1.61943763252465, 218, 16, 'PPL', 'P'),
(136460, 'Leighton', 45.0652809143066, 0.786537530290811, -93.620002746582, -1.63397729365399, 218, 28, 'PPL', 'P'),
(10029, 'Leighton (historical)', 34.5380592346191, 0.602802850892937, -91.6302795410156, -1.59925007251352, 218, 4, 'PPL', 'P'),
(144056, 'Leighton Corners', 43.3086090087891, 0.755877821662247, -71.1911087036133, -1.24251924502324, 218, 36, 'PPL', 'P'),
(125223, 'Leightons Corner', 42.7236099243164, 0.745667661517047, -70.9361114501953, -1.23806870336756, 218, 23, 'PPL', 'P'),
(10030, 'Leigo (historical)', 35.8416709899902, 0.625555168191865, -92.9402770996094, -1.62211384310407, 218, 4, 'PPL', 'P'),
(210568, 'Leilani Estates', 19.4675006866455, 0.339771984116221, -154.917221069336, -2.70381557569984, 218, 15, 'PPL', 'P'),
(182761, 'Leimert', 35.5741691589355, 0.620886380484847, -121.105827331543, -2.11369543028716, 218, 6, 'PPL', 'P'),
(88517, 'Leinarts', 36.107780456543, 0.630199654553936, -84.1900024414063, -1.4693927398646, 218, 50, 'PPL', 'P'),
(163717, 'Leinbachs', 40.3925018310547, 0.704982150069743, -75.9947204589844, -1.32635808614197, 218, 45, 'PPL', 'P'),
(125224, 'Leino Park', 42.5250015258789, 0.7422012910422, -71.8777770996094, -1.25450386940276, 218, 23, 'PPL', 'P'),
(41765, 'Leinster', 30.9577808380127, 0.540315204734131, -92.1427764892578, -1.60819483166677, 218, 22, 'PPL', 'P'),
(88518, 'Leipers Fork', 35.8955612182617, 0.626495730109854, -86.9977798461914, -1.51839770024121, 218, 50, 'PPL', 'P'),
(78605, 'Leiperville', 39.8669395446777, 0.695809357748155, -75.3408279418945, -1.3149455087646, 218, 45, 'PPL', 'P'),
(78606, 'Leiphart Mill', 39.9869384765625, 0.697903734208421, -76.6030578613281, -1.3369755767759, 218, 45, 'PPL', 'P'),
(14102, 'Leipsic', 39.2408294677734, 0.684881675426261, -75.517219543457, -1.31802412298473, 218, 10, 'PPL', 'P'),
(30317, 'Leipsic', 38.6711082458496, 0.674938164285204, -86.3697204589844, -1.50743599603639, 218, 19, 'PPL', 'P'),
(156122, 'Leipsic', 41.098331451416, 0.717301200903149, -83.9847183227539, -1.46580985609207, 218, 41, 'PPL', 'P'),
(156112, 'Leipsic Junction', 41.1063919067383, 0.717441882387733, -83.9780578613281, -1.46569360911048, 218, 41, 'PPL', 'P'),
(174940, 'Leipsig', 43.4008293151855, 0.757487369646064, -88.8641662597656, -1.55097228827256, 218, 57, 'PPL', 'P'),
(78607, 'Leisenring', 39.9983291625977, 0.698102539183796, -79.6444396972656, -1.39005770362336, 218, 45, 'PPL', 'P'),
(48896, 'Leishear Knolls', 39.1425018310547, 0.683165534419814, -76.8866729736328, -1.34192559429403, 218, 25, 'PPL', 'P'),
(48897, 'Leishear Village', 39.1450004577637, 0.683209143682664, -76.8791732788086, -1.34179469992645, 218, 25, 'PPL', 'P'),
(150224, 'Leisher Mill', 43.485279083252, 0.758961296151368, -75.6386108398438, -1.32014280078995, 218, 40, 'PPL', 'P'),
(73197, 'Leistville', 39.5297203063965, 0.68992377173908, -82.8388900756836, -1.44581138051833, 218, 41, 'PPL', 'P'),
(36841, 'Leisure', 38.0447196960449, 0.66400562169432, -83.3041687011719, -1.45393202447226, 218, 21, 'PPL', 'P'),
(123038, 'Leisure', 40.3641700744629, 0.704487667634342, -85.8430633544922, -1.49824409553398, 218, 19, 'PPL', 'P'),
(131734, 'Leisure', 42.4694404602051, 0.741231567510274, -86.168327331543, -1.50392102287164, 218, 27, 'PPL', 'P'),
(22621, 'Leisure Acres', 33.7519416809082, 0.589082511272958, -84.6536102294922, -1.47748422220459, 218, 13, 'PPL', 'P'),
(16871, 'Leisure City', 25.4950008392334, 0.44497170744334, -80.429443359375, -1.40375860216738, 218, 12, 'PPL', 'P'),
(27698, 'Leisure City', 37.4902801513672, 0.654328826136436, -88.442497253418, -1.54361277575819, 218, 18, 'PPL', 'P'),
(22622, 'Leisure Heights', 33.6127815246582, 0.586653708358805, -85.0561065673828, -1.484509108528, 218, 13, 'PPL', 'P'),
(48898, 'Leisure Hill', 39.401668548584, 0.687688846952286, -76.7322235107422, -1.33922994263865, 218, 25, 'PPL', 'P'),
(145593, 'Leisure Knoll', 40.0188903808594, 0.698461400140684, -74.2925033569336, -1.29664879312743, 218, 37, 'PPL', 'P'),
(22623, 'Leisure Lake', 34.4144401550293, 0.600645290935809, -83.9422225952148, -1.46506816572848, 218, 13, 'PPL', 'P'),
(182763, 'Leisure Lake Mobile Home Park', 38.2730598449707, 0.667990909107569, -122.679168701172, -2.14115541744502, 218, 6, 'PPL', 'P'),
(125225, 'Leisure Lee', 42.2938919067383, 0.738167667255165, -73.2005615234375, -1.27759081289266, 218, 23, 'PPL', 'P'),
(48899, 'Leisure Mountain', 39.605281829834, 0.691242569110888, -77.4897232055664, -1.35245080639619, 218, 25, 'PPL', 'P'),
(14104, 'Leisure Point Mobile Home Park', 38.6311111450195, 0.674240083184467, -75.1616668701172, -1.31181855817069, 218, 10, 'PPL', 'P'),
(95671, 'Leisure Time Mobile Home Park Colonia', 26.3299999237061, 0.459545190718526, -97.5039978027344, -1.70176579551503, 218, 51, 'PPL', 'P'),
(178525, 'Leisure Time Mobile Park', 33.5608291625977, 0.585746968586661, -112.20832824707, -1.95840477606993, 218, 5, 'PPL', 'P'),
(192905, 'Leisure Town', 38.3661117553711, 0.669614971319327, -121.94361114502, -2.12831751625224, 218, 6, 'PPL', 'P'),
(41766, 'Leisure Village', 32.5583305358887, 0.568250066803867, -92.0311126708984, -1.60624593038105, 218, 22, 'PPL', 'P'),
(82065, 'Leisure Village', 34.5541687011719, 0.603084014125022, -82.7980575561523, -1.44509871861063, 218, 48, 'PPL', 'P'),
(145594, 'Leisure Village', 40.0424995422363, 0.698873457740346, -74.1852798461914, -1.29477738982943, 218, 37, 'PPL', 'P'),
(182764, 'Leisure Village', 34.2183303833008, 0.597222529723812, -118.987503051758, -2.07672369697997, 218, 6, 'PPL', 'P'),
(196894, 'Leisure Village', 46.2444381713867, 0.807117706825644, -114.151672363281, -1.99232252939707, 218, 31, 'PPL', 'P'),
(145595, 'Leisure Village East', 40.0299987792969, 0.698655278268041, -74.1647186279297, -1.29441852887254, 218, 37, 'PPL', 'P'),
(196895, 'Leisure Village Mobile Home Park', 46.6375007629395, 0.813977943214661, -111.941673278809, -1.95375076890697, 218, 31, 'PPL', 'P'),
(22624, 'Leisure Woods', 33.7027816772461, 0.588224507348761, -84.2302780151367, -1.47009568123433, 218, 13, 'PPL', 'P'),
(178526, 'Leisure World', 33.4011116027832, 0.582959371294647, -111.689170837402, -1.9493437699351, 218, 5, 'PPL', 'P'),
(182765, 'Leisure World', 33.7680587768555, 0.589363807663097, -118.084716796875, -2.06096710439052, 218, 6, 'PPL', 'P'),
(71029, 'Leisuretowne', 39.892219543457, 0.696250576961754, -74.7024993896484, -1.30380457381842, 218, 37, 'PPL', 'P'),
(48900, 'Leitch', 38.7649993896484, 0.676576873882958, -76.5630569458008, -1.33627742909614, 218, 25, 'PPL', 'P'),
(36845, 'Leitchfield', 37.4799995422363, 0.654149395657991, -86.2938919067383, -1.50611253813267, 218, 21, 'PPL', 'P'),
(36842, 'Leitchfield Crossing', 37.3013916015625, 0.651032099023026, -85.9124984741211, -1.49945596698802, 218, 21, 'PPL', 'P'),
(188871, 'Leitendorf (historical)', 32.2480583190918, 0.5628347950433, -108.756393432617, -1.89815714799351, 218, 38, 'PPL', 'P'),
(209566, 'Leiter', 44.7180595397949, 0.780477374072282, -106.268608093262, -1.85473710273891, 218, 59, 'PPL', 'P'),
(110072, 'Leiter (historical)', 38.9402809143066, 0.679636113606159, -79.9747161865234, -1.39582211580284, 218, 58, 'PPL', 'P'),
(123039, 'Leiters Ford', 41.1216697692871, 0.717708531391877, -86.3858337402344, -1.5077172258475, 218, 19, 'PPL', 'P'),
(48901, 'Leitersburg', 39.6925010681152, 0.692764831989977, -77.6230621337891, -1.35477800971475, 218, 25, 'PPL', 'P'),
(196896, 'Leiterville', 45.5550003051758, 0.795084746072339, -112.121940612793, -1.95689702741879, 218, 31, 'PPL', 'P'),
(73196, 'Leith', 39.4552803039551, 0.688624548601285, -81.1505584716797, -1.41634443516299, 218, 41, 'PPL', 'P'),
(78608, 'Leith', 39.8849983215332, 0.696124542863166, -79.7266693115234, -1.3914928811348, 218, 45, 'PPL', 'P'),
(198518, 'Leith', 46.3583297729492, 0.809105490263279, -101.636108398438, -1.7738847304666, 218, 34, 'PPL', 'P'),
(163718, 'Leithsville', 40.5536117553711, 0.707794048706703, -75.3363876342773, -1.31486801077688, 218, 45, 'PPL', 'P'),
(120331, 'Leithton', 42.2463912963867, 0.737338625207824, -87.9794387817383, -1.53553088079812, 218, 18, 'PPL', 'P'),
(103630, 'Leithtown', 39.0133285522461, 0.680911035399007, -77.7591705322266, -1.35715354940711, 218, 53, 'PPL', 'P'),
(10031, 'Leitner', 34.25, 0.597775268808058, -92.0666732788086, -1.60686658007309, 218, 4, 'PPL', 'P'),
(110073, 'Leivasy', 38.1611099243164, 0.666037014394805, -80.6911087036133, -1.40832552396271, 218, 58, 'PPL', 'P'),
(41767, 'Lejeune', 30.482780456543, 0.532024884129255, -91.2816696166992, -1.59316568152907, 218, 22, 'PPL', 'P'),
(22627, 'Lela', 30.983060836792, 0.54075642394773, -84.8630599975586, -1.48113981027489, 218, 13, 'PPL', 'P'),
(41768, 'Lela', 32.9741706848145, 0.575507846564606, -93.6816711425781, -1.63505361020855, 218, 22, 'PPL', 'P'),
(76365, 'Lela', 36.3188896179199, 0.633884204501088, -96.9241714477539, -1.69164591653078, 218, 42, 'PPL', 'P'),
(191757, 'Lela', 35.2275009155273, 0.614835878225269, -100.342498779297, -1.75130698337712, 218, 51, 'PPL', 'P'),
(73198, 'Lelan (historical)', 39.454719543457, 0.688614761484279, -84.1786117553711, -1.46919393488923, 218, 41, 'PPL', 'P'),
(10032, 'Leland', 33.3722190856934, 0.582455101742241, -91.1563873291016, -1.59097909311606, 218, 4, 'PPL', 'P'),
(16874, 'Leland', 30.610279083252, 0.534250154957098, -83.3255615234375, -1.45430539965709, 218, 12, 'PPL', 'P'),
(22625, 'Leland', 33.8122215270996, 0.590134593061593, -84.5588912963867, -1.47583106495792, 218, 13, 'PPL', 'P'),
(41769, 'Leland', 31.8230590820313, 0.55541715903813, -91.7213897705078, -1.60084024600041, 218, 22, 'PPL', 'P'),
(60616, 'Leland', 33.4052810668945, 0.583032142171434, -90.8974990844727, -1.58646064085258, 218, 30, 'PPL', 'P'),
(66316, 'Leland', 34.2561111450195, 0.597881928409716, -78.0449981689453, -1.36214218276104, 218, 33, 'PPL', 'P'),
(82066, 'Leland', 34.4361114501953, 0.601023526389628, -80.1730575561523, -1.39928382574578, 218, 48, 'PPL', 'P'),
(116448, 'Leland', 43.3372192382813, 0.756377164366637, -93.6350021362305, -1.63423908238915, 218, 16, 'PPL', 'P'),
(120332, 'Leland', 41.6124992370605, 0.726275121670335, -88.7994384765625, -1.54984257533815, 218, 18, 'PPL', 'P'),
(131733, 'Leland', 45.0230598449707, 0.785800633617187, -85.7597198486328, -1.49678947694658, 218, 27, 'PPL', 'P'),
(174942, 'Leland', 43.3355598449707, 0.756348202489782, -89.9475021362305, -1.56988006622185, 218, 57, 'PPL', 'P'),
(195225, 'Leland', 46.5780601501465, 0.812940508812021, -116.605827331543, -2.03515561394742, 218, 17, 'PPL', 'P'),
(201119, 'Leland', 42.6386108398438, 0.744184147631818, -123.439720153809, -2.15442954442436, 218, 43, 'PPL', 'P'),
(204679, 'Leland', 40.0988883972168, 0.699857628921185, -111.689437866211, -1.94934843046701, 218, 52, 'PPL', 'P'),
(207909, 'Leland', 47.8919410705566, 0.835872056852311, -122.885276794434, -2.14475268228745, 218, 56, 'PPL', 'P'),
(27697, 'Leland Grove', 39.7769393920898, 0.6942385587582, -89.6791687011719, -1.5651967642869, 218, 18, 'PPL', 'P'),
(48902, 'Lelands Corner', 39.0119400024414, 0.680886800633087, -77.1602783203125, -1.34670090844465, 218, 25, 'PPL', 'P'),
(95672, 'Lelavale', 30.4033298492432, 0.530638209439164, -94.48388671875, -1.64905491332353, 218, 51, 'PPL', 'P'),
(41771, 'Leleux', 30.0683307647705, 0.52479137242395, -92.3608322143555, -1.61200062202255, 218, 22, 'PPL', 'P'),
(191756, 'Lelia Lake', 34.9011116027832, 0.609139310074562, -100.770278930664, -1.75877315549316, 218, 51, 'PPL', 'P'),
(76366, 'Leliaetta', 36.017219543457, 0.628619068446974, -95.3677825927734, -1.66448180657003, 218, 42, 'PPL', 'P'),
(22626, 'Leliaton', 31.3247203826904, 0.546719507944526, -82.9933319091797, -1.44850689901566, 218, 13, 'PPL', 'P'),
(182766, 'Leliter (historical)', 35.7105598449707, 0.623266847025215, -117.829437255859, -2.05651163588682, 218, 6, 'PPL', 'P'),
(88519, 'Lella (historical)', 36.4897193908691, 0.636865746499486, -82.3208312988281, -1.43676954914335, 218, 50, 'PPL', 'P'),
(16872, 'Lely', 26.1002807617188, 0.455535834986926, -81.7286071777344, -1.42643328832054, 218, 12, 'PPL', 'P'),
(16873, 'Lely Resort', 26.0805606842041, 0.455191654705547, -81.6980590820313, -1.4259001234703, 218, 12, 'PPL', 'P'),
(41772, 'Lemannville', 30.1091709136963, 0.52550416748971, -90.920280456543, -1.58685825080333, 218, 22, 'PPL', 'P'),
(66288, 'LeMar Park', 35.9341697692871, 0.627169576444671, -81.4933319091797, -1.42232696023574, 218, 33, 'PPL', 'P'),
(78609, 'Lemasters', 39.8611106872559, 0.695707624994514, -77.8597183227539, -1.35890843940741, 218, 45, 'PPL', 'P'),
(55853, 'Lemay', 38.5333290100098, 0.672533462978917, -90.279167175293, -1.57566871316725, 218, 29, 'PPL', 'P'),
(142216, 'Lembke Landing', 42.6672210693359, 0.744683490336208, -96.8013916015625, -1.68950300395965, 218, 35, 'PPL', 'P'),
(36843, 'Lemen Landing', 37.1947212219238, 0.649170349683979, -88.3477783203125, -1.54195961851152, 218, 21, 'PPL', 'P'),
(27699, 'Lemens', 38.2825012207031, 0.668155692200018, -90.1419372558594, -1.57327359924089, 218, 18, 'PPL', 'P'),
(27700, 'Lementon', 38.3747215270996, 0.669765240183835, -89.9033279418945, -1.56910908108628, 218, 18, 'PPL', 'P'),
(140385, 'Lemert', 47.5097198486328, 0.829201038058745, -99.2636108398438, -1.73247683657361, 218, 34, 'PPL', 'P'),
(156113, 'Lemert', 40.8941688537598, 0.713737891364623, -83.0936126708984, -1.45025712848406, 218, 41, 'PPL', 'P'),
(211966, 'Lemeta', 64.8597183227539, 1.13201563664815, -147.732223510742, -2.57841371155463, 218, 1, 'PPL', 'P'),
(195226, 'Lemhi', 44.8516693115234, 0.782809304501782, -113.61888885498, -1.9830237029769, 218, 17, 'PPL', 'P'),
(48903, 'Leming', 38.4911117553711, 0.67179663288432, -76.647216796875, -1.33774629559537, 218, 25, 'PPL', 'P'),
(95673, 'Leming', 29.0727806091309, 0.507415744339296, -98.48388671875, -1.7188680834033, 218, 51, 'PPL', 'P'),
(88520, 'Leming Subdivision', 36.1480598449707, 0.63090266250269, -82.8202819824219, -1.4454866080234, 218, 50, 'PPL', 'P'),
(174943, 'Lemington', 45.7591705322266, 0.79864818876892, -91.352783203125, -1.5944068477551, 218, 57, 'PPL', 'P'),
(188872, 'Lemitar', 34.1597213745117, 0.596199609549112, -106.909721374512, -1.86592664037499, 218, 38, 'PPL', 'P'),
(95674, 'Lemley', 32.8175010681152, 0.572773445915367, -97.8794403076172, -1.70831850337717, 218, 51, 'PPL', 'P'),
(202300, 'Lemmon', 45.9408302307129, 0.801818748625686, -102.158889770508, -1.78300898667732, 218, 49, 'PPL', 'P'),
(27701, 'Lemmon (historical)', 39.5313911437988, 0.689952933353017, -89.7941665649414, -1.56720385564243, 218, 18, 'PPL', 'P'),
(190409, 'Lemmon Valley', 39.6361083984375, 0.691780594230111, -119.842216491699, -2.091641260668, 218, 39, 'PPL', 'P'),
(207911, 'Lemolo', 47.7119407653809, 0.832730458872399, -122.621109008789, -2.14014208465025, 218, 56, 'PPL', 'P'),
(704, 'Lemon', 32.1358299255371, 0.560876040061547, -89.5013885498047, -1.56209391530084, 218, 30, 'PPL', 'P'),
(36844, 'Lemon', 37.5811080932617, 0.655914072775305, -87.3783264160156, -1.52503949084181, 218, 21, 'PPL', 'P'),
(112486, 'Lemon', 39.4883308410645, 0.689201389293396, -84.3377838134766, -1.47197201138035, 218, 41, 'PPL', 'P'),
(163719, 'Lemon', 41.6161117553711, 0.726338172009143, -75.9427795410156, -1.32545154610691, 218, 45, 'PPL', 'P'),
(16875, 'Lemon Bluff', 28.8061103820801, 0.502761470860219, -81.1322174072266, -1.41602432319996, 218, 12, 'PPL', 'P'),
(16876, 'Lemon City', 25.8299999237061, 0.450818544458555, -80.1930618286133, -1.39963296616469, 218, 12, 'PPL', 'P'),
(193222, 'Lemon Creek', 58.3583297729492, 1.0185450005026, -134.498611450195, -2.34744360916645, 218, 1, 'PPL', 'P'),
(103631, 'Lemon Dell', 37.2536087036133, 0.650198130127668, -79.9786071777344, -1.39589002641063, 218, 53, 'PPL', 'P'),
(16884, 'Lemon Grove', 27.5580596923828, 0.480978877093216, -81.6783294677734, -1.42555577674135, 218, 12, 'PPL', 'P'),
(182767, 'Lemon Grove', 32.7425003051758, 0.571464435660565, -117.030563354492, -2.04256865599971, 218, 6, 'PPL', 'P'),
(182768, 'Lemon Heights', 33.7588882446289, 0.589203751681583, -117.781112670898, -2.05566821276959, 218, 6, 'PPL', 'P'),
(131736, 'Lemon Park', 42.1522216796875, 0.735695055341081, -85.4986114501953, -1.49223227568923, 218, 27, 'PPL', 'P'),
(66322, 'Lemon Springs', 35.3894386291504, 0.617662224511143, -79.1947174072266, -1.38220856894257, 218, 33, 'PPL', 'P'),
(182769, 'Lemona', 33.980281829834, 0.593067798686207, -117.324996948242, -2.04770749163913, 218, 6, 'PPL', 'P'),
(182770, 'Lemoncove', 36.3827781677246, 0.634999270049504, -119.023612976074, -2.07735393405194, 218, 6, 'PPL', 'P'),
(136461, 'Lemond', 43.9824981689453, 0.767639406300473, -93.379997253418, -1.62978840757541, 218, 28, 'PPL', 'P'),
(139266, 'Lemons', 40.4041709899902, 0.705185815314106, -93.0472183227539, -1.62398031955405, 218, 29, 'PPL', 'P'),
(120333, 'Lemont', 41.6736106872559, 0.727341717686912, -88.0016708374023, -1.53591890336895, 218, 18, 'PPL', 'P'),
(163721, 'Lemont', 40.8105583190918, 0.712278612245315, -77.8186111450195, -1.35819098380975, 218, 45, 'PPL', 'P'),
(116449, 'Lemont (historical)', 41.3327789306641, 0.721393081339029, -94.4694366455078, -1.6488027119683, 218, 16, 'PPL', 'P'),
(78610, 'Lemont Furnace', 39.9141693115234, 0.696633672684562, -79.6699981689453, -1.39050378310595, 218, 45, 'PPL', 'P'),
(103632, 'Lemonton', 37.3352813720703, 0.651623587101133, -79.978889465332, -1.39589495325865, 218, 53, 'PPL', 'P'),
(178527, 'Lemontree', 33.4097213745117, 0.583109640159155, -111.742782592773, -1.9502794715841, 218, 5, 'PPL', 'P'),
(204681, 'Lemontree Condominium', 40.9013900756836, 0.713863925463211, -111.876388549805, -1.95261133543458, 218, 52, 'PPL', 'P'),
(95675, 'Lemonville', 30.2141704559326, 0.52733675521482, -93.8455581665039, -1.63791397837735, 218, 51, 'PPL', 'P'),
(174944, 'Lemonweir', 43.7844390869141, 0.76418262320555, -90.0169372558594, -1.5710919376759, 218, 57, 'PPL', 'P'),
(182771, 'Lemoore', 36.3008308410645, 0.633569019386077, -119.781936645508, -2.09058917887936, 218, 6, 'PPL', 'P'),
(156114, 'Lemoyne', 41.4958305358887, 0.72423886870086, -83.4741668701172, -1.45689905224271, 218, 41, 'PPL', 'P'),
(163722, 'Lemoyne', 40.2411117553711, 0.702339894794221, -76.8944396972656, -1.34206114919352, 218, 45, 'PPL', 'P'),
(199474, 'Lemoyne', 41.2724990844727, 0.720340999550393, -101.812782287598, -1.77696827153474, 218, 35, 'PPL', 'P'),
(199475, 'Lemoyne Mobile Home Park', 41.2724990844727, 0.720340999550393, -101.812782287598, -1.77696827153474, 218, 35, 'PPL', 'P'),
(182772, 'Lempon (historical)', 35.9988899230957, 0.628299156221028, -118.99388885498, -2.07683515027159, 218, 6, 'PPL', 'P'),
(144053, 'Lempster', 43.2383308410645, 0.754651236243184, -72.2111129760742, -1.2603216779621, 218, 36, 'PPL', 'P'),
(10034, 'Lemsford', 35.8574981689453, 0.625831404575934, -89.9180603027344, -1.56936620928952, 218, 4, 'PPL', 'P'),
(195230, 'Len Landing', 47.5291709899902, 0.829540524518702, -116.838333129883, -2.03921360565843, 218, 17, 'PPL', 'P'),
(10035, 'Lena', 34.5561103820801, 0.603117902849893, -92.5522232055664, -1.61534102497783, 218, 4, 'PPL', 'P'),
(30318, 'Lena', 39.6049995422363, 0.691237642262871, -87.1072235107422, -1.52030785253307, 218, 19, 'PPL', 'P'),
(41774, 'Lena', 31.4605598449707, 0.549090353815456, -92.7705612182617, -1.61915174218163, 218, 22, 'PPL', 'P'),
(60615, 'Lena', 32.5941696166992, 0.5688755767649, -89.6119384765625, -1.56402337551061, 218, 30, 'PPL', 'P'),
(66317, 'Lena', 34.9088897705078, 0.609275064711129, -78.7938919067383, -1.3752128442331, 218, 33, 'PPL', 'P'),
(82067, 'Lena', 32.7533302307129, 0.571653453518934, -81.2152786254883, -1.41747401493935, 218, 48, 'PPL', 'P'),
(95676, 'Lena', 29.8850002288818, 0.521591650953247, -97.0350036621094, -1.69358030358856, 218, 51, 'PPL', 'P'),
(113040, 'Lena', 42.3794403076172, 0.739660768520318, -89.8222198486328, -1.56769347780885, 218, 18, 'PPL', 'P'),
(116450, 'Lena', 42.2205581665039, 0.736887752035273, -94.2874984741211, -1.64562729184254, 218, 16, 'PPL', 'P'),
(150225, 'Lena', 42.6241683959961, 0.743932079434642, -75.0844421386719, -1.310470732343, 218, 40, 'PPL', 'P'),
(156115, 'Lena', 40.1408309936523, 0.70058966532582, -84.0322189331055, -1.46663889813941, 218, 41, 'PPL', 'P'),
(174946, 'Lena', 44.9511108398438, 0.784544886584187, -88.0466690063477, -1.53670426957441, 218, 57, 'PPL', 'P'),
(199476, 'Lena', 41.7011108398438, 0.727821685894371, -101.498062133789, -1.7714753686284, 218, 35, 'PPL', 'P'),
(201120, 'Lena', 45.4000015258789, 0.792379507037037, -119.280830383301, -2.08184322470149, 218, 43, 'PPL', 'P'),
(10036, 'Lena (historical)', 34.7075004577637, 0.605760158125415, -93.1161117553711, -1.62518273678622, 218, 4, 'PPL', 'P'),
(193220, 'Lena Beach', 58.3930587768555, 1.0191511359667, -134.747222900391, -2.35178269753052, 218, 1, 'PPL', 'P'),
(123040, 'Lena Park', 41.1944389343262, 0.718978592915736, -86.7172164916992, -1.51350094594488, 218, 19, 'PPL', 'P'),
(186975, 'Lenado', 39.2425003051758, 0.684910837040197, -106.761940002441, -1.86334736885925, 218, 7, 'PPL', 'P'),
(103633, 'Lenah', 38.9527816772461, 0.679854293078463, -77.5805587768555, -1.35403618619311, 218, 53, 'PPL', 'P'),
(76367, 'Lenapah', 36.8505592346191, 0.643163589845306, -95.6358337402344, -1.66916018165697, 218, 42, 'PPL', 'P'),
(33025, 'Lenape', 38.9972190856934, 0.680629872166922, -94.9505615234375, -1.65719992520143, 218, 20, 'PPL', 'P'),
(78611, 'Lenape', 39.9127807617188, 0.696609437918642, -75.6319427490234, -1.32002642065031, 218, 45, 'PPL', 'P'),
(163724, 'Lenape Heights', 40.7641716003418, 0.71146901127393, -79.5208282470703, -1.38790027682429, 218, 45, 'PPL', 'P'),
(36853, 'Lenarue', 36.8061103820801, 0.642387811019766, -83.2675018310547, -1.45329206686231, 218, 21, 'PPL', 'P'),
(131738, 'Lenawee Junction', 41.8844413757324, 0.731021407365074, -83.9438934326172, -1.46509732734241, 218, 27, 'PPL', 'P'),
(131739, 'Lencel', 46.3502807617188, 0.808965008515777, -85.429443359375, -1.4910250647671, 218, 27, 'PPL', 'P'),
(82068, 'Lendaw', 35.045280456543, 0.611655531251496, -82.3058319091797, -1.4365077604082, 218, 48, 'PPL', 'P'),
(201121, 'Leneve', 43.2063903808594, 0.754093770048003, -124.272499084473, -2.16896427870569, 218, 43, 'PPL', 'P'),
(33026, 'Lenexa', 38.9536094665527, 0.679868740727377, -94.7333297729492, -1.65340851591554, 218, 20, 'PPL', 'P'),
(136463, 'Lengby', 47.5158309936523, 0.829307697660402, -95.6355590820313, -1.66915538796701, 218, 28, 'PPL', 'P'),
(10037, 'Lenham', 34.3002815246582, 0.598652846966266, -92.6388931274414, -1.616853700477, 218, 4, 'PPL', 'P'),
(163729, 'Lenhartsville', 40.5727806091309, 0.708128608318644, -75.8883285522461, -1.32450119707192, 218, 45, 'PPL', 'P'),
(163726, 'Lenkerville', 40.5338897705078, 0.70744983513581, -76.9594421386719, -1.34319565581789, 218, 45, 'PPL', 'P'),
(76369, 'Lenna', 35.3763885498047, 0.617434457658914, -95.769172668457, -1.67148738497554, 218, 42, 'PPL', 'P'),
(196897, 'Lennep', 46.4161109924316, 0.810113962789065, -110.542503356934, -1.92933064697538, 218, 31, 'PPL', 'P'),
(78612, 'Lenni', 39.8938903808594, 0.696279738575691, -75.4480590820313, -1.31681704522066, 218, 45, 'PPL', 'P'),
(10038, 'Lennie', 35.7675018310547, 0.624260672165005, -90.1774978637695, -1.57389424893293, 218, 4, 'PPL', 'P'),
(103640, 'Lennig', 36.9008293151855, 0.644040968266432, -78.9102783203125, -1.37724417035455, 218, 53, 'PPL', 'P'),
(172193, 'Lennington', 44.8580589294434, 0.782920824372429, -71.5513916015625, -1.24880736783108, 218, 55, 'PPL', 'P'),
(131740, 'Lennon', 42.9855613708496, 0.750239576739413, -83.9283294677734, -1.46482568491123, 218, 27, 'PPL', 'P'),
(66318, 'Lennon Crossroads', 33.996940612793, 0.593358549298216, -78.2352828979492, -1.36546327779842, 218, 33, 'PPL', 'P'),
(3728, 'Lennon Hill', 34.7394409179688, 0.606317624320596, -87.4161071777344, -1.52569888952771, 218, 2, 'PPL', 'P'),
(66319, 'Lennons Crossroads', 34.473331451416, 0.601673137958525, -78.8544387817383, -1.37626958655364, 218, 33, 'PPL', 'P'),
(136465, 'Lennox', 46.2436103820801, 0.80710325917673, -94.3427810668945, -1.64659215510548, 218, 28, 'PPL', 'P'),
(170726, 'Lennox', 43.3541717529297, 0.756673041563745, -96.8916702270508, -1.6910786632186, 218, 49, 'PPL', 'P'),
(174949, 'Lennox', 45.5119400024414, 0.794333202012719, -89.0716705322266, -1.55459392103896, 218, 57, 'PPL', 'P'),
(182773, 'Lennox', 33.938060760498, 0.592330902012582, -118.351669311523, -2.06562630471761, 218, 6, 'PPL', 'P'),
(48908, 'Lennox Park', 39.1725006103516, 0.683689111890123, -76.7444381713867, -1.33944312868391, 218, 25, 'PPL', 'P'),
(177238, 'Lennyville', 40.601390838623, 0.708627951023034, -80.6311111450195, -1.40727836902209, 218, 58, 'PPL', 'P'),
(16877, 'Leno', 29.889440536499, 0.521669148940968, -81.6408309936523, -1.42490130490347, 218, 12, 'PPL', 'P'),
(66320, 'Lenoir', 35.913890838623, 0.6268156423358, -81.5391693115234, -1.4231269738272, 218, 33, 'PPL', 'P'),
(10039, 'Lenoir (historical)', 34.7486114501953, 0.60647768030211, -91.2702789306641, -1.5929668765537, 218, 4, 'PPL', 'P'),
(41775, 'Lenoir (historical)', 31.9177799224854, 0.55707034957431, -93.7822189331055, -1.63680850020885, 218, 22, 'PPL', 'P'),
(66321, 'Lenoir (historical)', 36.0352783203125, 0.628934253561985, -81.4783325195313, -1.42206517150059, 218, 33, 'PPL', 'P'),
(82069, 'Lenoir (historical)', 33.6047210693359, 0.586513026874222, -82.0183334350586, -1.43148996544032, 218, 48, 'PPL', 'P'),
(88521, 'Lenoir City', 35.7972183227539, 0.624779322787298, -84.2561111450195, -1.47054655440688, 218, 50, 'PPL', 'P'),
(3729, 'Lenoir Landing', 31.8569393157959, 0.556008480668668, -88.1586074829102, -1.53865796455009, 218, 2, 'PPL', 'P'),
(71030, 'Lenola', 39.9622192382813, 0.697472302111828, -74.982780456543, -1.30869640126673, 218, 37, 'PPL', 'P'),
(22628, 'Lenora', 33.8030586242676, 0.589974670238134, -84.0033264160156, -1.466134628587, 218, 13, 'PPL', 'P'),
(76370, 'Lenora', 36.0411109924316, 0.629036052894653, -99.0616683959961, -1.72895227602894, 218, 42, 'PPL', 'P'),
(136466, 'Lenora', 43.5724983215332, 0.760483559030457, -91.8822174072266, -1.60364721778935, 218, 28, 'PPL', 'P'),
(187759, 'Lenora', 39.6105613708496, 0.691334714484604, -100.002220153809, -1.74536800098819, 218, 20, 'PPL', 'P'),
(191758, 'Lenorah', 32.3044395446777, 0.563818833066084, -101.875831604004, -1.77806868969716, 218, 51, 'PPL', 'P'),
(36846, 'Lenore', 37.9383316040039, 0.66214879920329, -85.5094375610352, -1.49242122696857, 218, 21, 'PPL', 'P'),
(110075, 'Lenore', 37.7988891601563, 0.659715069441121, -82.2869415283203, -1.43617806106524, 218, 58, 'PPL', 'P'),
(195228, 'Lenore', 46.5086097717285, 0.811728371041871, -116.550003051758, -2.03418129646261, 218, 17, 'PPL', 'P'),
(78613, 'Lenover', 39.9552803039551, 0.697351194861257, -75.9469375610352, -1.32552411724662, 218, 45, 'PPL', 'P'),
(88522, 'Lenow', 35.1863899230957, 0.614118356048574, -89.7305603027344, -1.56609371694203, 218, 50, 'PPL', 'P'),
(425, 'Lenox', 31.271390914917, 0.545788733143543, -83.4649963378906, -1.4567389962612, 218, 13, 'PPL', 'P'),
(3730, 'Lenox', 31.336389541626, 0.54692317318889, -87.1855621337891, -1.52167511943671, 218, 2, 'PPL', 'P'),
(10040, 'Lenox', 34.2488899230957, 0.597755894311128, -93.2683334350586, -1.62783950628969, 218, 4, 'PPL', 'P'),
(36847, 'Lenox', 37.957218170166, 0.662478431967214, -83.2013931274414, -1.45213825232003, 218, 21, 'PPL', 'P'),
(55855, 'Lenox', 37.6530609130859, 0.657169886387332, -91.7611083984375, -1.60153346683216, 218, 29, 'PPL', 'P'),
(76371, 'Lenox', 34.6955604553223, 0.605551765770116, -94.8244400024414, -1.65499868940242, 218, 42, 'PPL', 'P'),
(88524, 'Lenox', 35.1258316040039, 0.613061413990949, -89.9899978637695, -1.57062175658544, 218, 50, 'PPL', 'P'),
(103635, 'Lenox', 36.7130584716797, 0.640763748808008, -76.5808334350586, -1.33658768736313, 218, 53, 'PPL', 'P'),
(110074, 'Lenox', 39.5666694641113, 0.690568656197043, -79.5905609130859, -1.38911734144245, 218, 58, 'PPL', 'P'),
(113188, 'Lenox', 43.0583305358887, 0.751509638263272, -75.704719543457, -1.32129661533222, 218, 40, 'PPL', 'P'),
(116451, 'Lenox', 40.8816719055176, 0.713519778471346, -94.5616683959961, -1.6504124596892, 218, 16, 'PPL', 'P'),
(125226, 'Lenox', 42.3563919067383, 0.739258498037662, -73.2852783203125, -1.27906939992987, 218, 23, 'PPL', 'P'),
(163727, 'Lenox', 41.711669921875, 0.728005976641805, -75.6733322143555, -1.32074880309599, 218, 45, 'PPL', 'P'),
(191759, 'Lenox', 30.2363891601563, 0.52772454475905, -103.378326416016, -1.8042921711609, 218, 51, 'PPL', 'P'),
(150226, 'Lenox Basin', 43.0902786254883, 0.752067237616507, -75.711669921875, -1.32141792231988, 218, 40, 'PPL', 'P'),
(66326, 'Lenox Castle', 36.3008308410645, 0.633569019386077, -79.5547180175781, -1.38849176490239, 218, 33, 'PPL', 'P'),
(156116, 'Lenox Center', 41.6800003051758, 0.727453237557559, -80.7619400024414, -1.40956176334072, 218, 41, 'PPL', 'P'),
(125227, 'Lenox Dale', 42.336109161377, 0.738904497349763, -73.2458267211914, -1.27838083963003, 218, 23, 'PPL', 'P'),
(150227, 'Lenox Park', 42.857780456543, 0.748009379063553, -77.0147171020508, -1.34416038592277, 218, 40, 'PPL', 'P'),
(125228, 'Lenox Station', 42.3499984741211, 0.739146911587988, -73.245002746582, -1.27836645856015, 218, 23, 'PPL', 'P'),
(36848, 'Lenoxburg', 38.7425003051758, 0.676184190780225, -84.2249984741211, -1.47000353586061, 218, 21, 'PPL', 'P'),
(66327, 'Lenoxville', 34.7105598449707, 0.605813554505271, -76.6275024414063, -1.33740221518253, 218, 33, 'PPL', 'P'),
(113313, 'Lenoxville', 41.6622200012207, 0.727142912711537, -75.6374969482422, -1.32012335971399, 218, 45, 'PPL', 'P'),
(48905, 'Lens Rambles', 39.5130615234375, 0.689633021127071, -77.6013870239258, -1.35439970768191, 218, 25, 'PPL', 'P'),
(103636, 'Lent', 38.1511116027832, 0.665862510764378, -77.2430572509766, -1.34814567333602, 218, 53, 'PPL', 'P'),
(150229, 'Lent Hill', 42.5230598449707, 0.742167402317328, -77.4191665649414, -1.35121936070814, 218, 40, 'PPL', 'P'),
(55856, 'Lentner', 39.7186088562012, 0.693220498852489, -92.1477813720703, -1.60828218335053, 218, 29, 'PPL', 'P'),
(33028, 'Lento', 38.6166687011719, 0.673988014987291, -94.845832824707, -1.65537206458725, 218, 20, 'PPL', 'P'),
(182774, 'Lento', 34.4727783203125, 0.601663483999574, -120.159439086914, -2.09717783941622, 218, 6, 'PPL', 'P'),
(201123, 'Lents', 45.4799995422363, 0.793775735817538, -122.566108703613, -2.13918214823533, 218, 43, 'PPL', 'P'),
(150230, 'Lentsville', 42.7502784729004, 0.746133115496565, -74.8597183227539, -1.30654856184758, 218, 40, 'PPL', 'P'),
(3731, 'Lentzville', 34.8441696166992, 0.608145484934772, -87.1408309936523, -1.52089441376316, 218, 2, 'PPL', 'P'),
(195229, 'Lenville', 46.6383285522461, 0.813992390863575, -116.83943939209, -2.03923291357633, 218, 17, 'PPL', 'P'),
(41776, 'Lenwil', 32.4372215270996, 0.566136315846671, -92.2244415283203, -1.60962015548218, 218, 22, 'PPL', 'P'),
(182775, 'Lenwood', 34.8766708374023, 0.608712738246959, -117.103057861328, -2.04383392383361, 218, 6, 'PPL', 'P'),
(78614, 'Lenwood Heights', 39.8319396972656, 0.695198495173118, -77.8883285522461, -1.3594077821118, 218, 45, 'PPL', 'P'),
(95677, 'Lenz', 28.7902793884277, 0.502485167897123, -97.9766693115234, -1.71001546962377, 218, 51, 'PPL', 'P'),
(201122, 'Lenz', 45.6297187805176, 0.796388829479124, -121.523063659668, -2.12097757797188, 218, 43, 'PPL', 'P'),
(27702, 'Lenzburg', 38.2872200012207, 0.668238050456729, -89.8172225952148, -1.56760625928315, 218, 18, 'PPL', 'P'),
(22630, 'Leo', 34.5411109924316, 0.602856114114738, -83.7405624389648, -1.46154853203183, 218, 13, 'PPL', 'P'),
(73200, 'Leo', 39.1480598449707, 0.68326254006252, -82.6691665649414, -1.44284914643784, 218, 41, 'PPL', 'P'),
(82070, 'Leo', 33.8333282470703, 0.590502974819379, -79.6152801513672, -1.38954877353905, 218, 48, 'PPL', 'P'),
(95679, 'Leo', 30.3658294677734, 0.529983704311764, -96.9847183227539, -1.69270265885133, 218, 51, 'PPL', 'P'),
(136468, 'Leo', 48.7608299255371, 0.851037028205604, -96.2502822875977, -1.67988433189256, 218, 28, 'PPL', 'P'),
(209930, 'Leo', 42.2502784729004, 0.737406469236594, -106.802780151367, -1.86406016392501, 218, 59, 'PPL', 'P'),
(110076, 'Leo (historical)', 38.7441711425781, 0.676213352394162, -81.4172210693359, -1.42099857548401, 218, 58, 'PPL', 'P'),
(123041, 'Leo (historical)', 41.223331451416, 0.719482862468142, -85.0111083984375, -1.48372374232254, 218, 19, 'PPL', 'P'),
(123042, 'Leo-Cedarville', 41.2125015258789, 0.719293844609774, -85.0166702270508, -1.48382081454427, 218, 19, 'PPL', 'P'),
(10041, 'Leola', 34.1694412231445, 0.596369252910551, -92.5908279418945, -1.61601480473362, 218, 4, 'PPL', 'P'),
(163730, 'Leola', 40.0877799987793, 0.699663750793827, -76.1852798461914, -1.32968397486932, 218, 45, 'PPL', 'P'),
(170728, 'Leola', 45.7227783203125, 0.798013024848936, -98.940559387207, -1.72683852507175, 218, 49, 'PPL', 'P'),
(163731, 'Leolyn', 41.586669921875, 0.725824315076812, -76.8869400024414, -1.34193025482594, 218, 45, 'PPL', 'P'),
(88525, 'Leoma', 35.1613883972168, 0.613681997103965, -87.3480606079102, -1.52451125283959, 218, 50, 'PPL', 'P'),
(125230, 'Leominster', 42.5250015258789, 0.7422012910422, -71.7602767944336, -1.25245310220535, 218, 23, 'PPL', 'P'),
(144055, 'Leominster Corner', 43.0691719055176, 0.751698855858722, -72.1900024414063, -1.25995322962528, 218, 36, 'PPL', 'P'),
(3732, 'Leon', 31.5575008392334, 0.550782293345497, -86.3927764892578, -1.5078383996771, 218, 2, 'PPL', 'P'),
(33029, 'Leon', 37.6902809143066, 0.65781949795623, -96.7819366455078, -1.68916345092067, 218, 20, 'PPL', 'P'),
(36849, 'Leon', 38.2877807617188, 0.668247837573735, -82.976936340332, -1.44822074235653, 218, 21, 'PPL', 'P'),
(48906, 'Leon', 38.792781829834, 0.677061768938434, -76.7016677856445, -1.33869664463037, 218, 25, 'PPL', 'P'),
(66328, 'Leon', 35.0288887023926, 0.611369441171395, -77.8202819824219, -1.35822014542368, 218, 33, 'PPL', 'P'),
(76372, 'Leon', 33.8791694641113, 0.591303054989866, -97.4288864135742, -1.70045485446844, 218, 42, 'PPL', 'P'),
(103637, 'Leon', 38.4375, 0.67086093123532, -78.1386108398438, -1.36377603208981, 218, 53, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(110077, 'Leon', 38.750560760498, 0.676324872264809, -81.9608306884766, -1.43048635318353, 218, 58, 'PPL', 'P'),
(116453, 'Leon', 40.7397193908691, 0.711042239709245, -93.7474975585938, -1.63620249790281, 218, 16, 'PPL', 'P'),
(150231, 'Leon', 42.2930603027344, 0.738153153027225, -79.0166702270508, -1.37910105942461, 218, 40, 'PPL', 'P'),
(156118, 'Leon', 41.6536102294922, 0.72699264384703, -80.6161117553711, -1.40701658028693, 218, 41, 'PPL', 'P'),
(174951, 'Leon', 43.877498626709, 0.765806818575362, -90.8300018310547, -1.58528259154438, 218, 57, 'PPL', 'P'),
(182776, 'Leon', 34.5580596923828, 0.603151924732819, -117.305557250977, -2.04736820491625, 218, 6, 'PPL', 'P'),
(186976, 'Leon', 39.3847198486328, 0.687393036334205, -107.098609924316, -1.8692233674884, 218, 7, 'PPL', 'P'),
(188873, 'Leon', 35.5711097717285, 0.620832984104991, -107.59944152832, -1.87796452797631, 218, 38, 'PPL', 'P'),
(195231, 'Leon', 46.5319404602051, 0.812135568372544, -117.039169311523, -2.04271885828519, 218, 17, 'PPL', 'P'),
(207912, 'Leon', 46.5319404602051, 0.812135568372544, -117.038330078125, -2.04270421089919, 218, 56, 'PPL', 'P'),
(10042, 'Leon (historical)', 35.2388916015625, 0.615034683200643, -94.0055618286133, -1.6407065690964, 218, 4, 'PPL', 'P'),
(120336, 'Leon Corners', 41.5941696166992, 0.725955209444389, -89.920280456543, -1.56940495828338, 218, 18, 'PPL', 'P'),
(16879, 'Leon Hamilton Place', 25.521110534668, 0.445427407595366, -81.2061080932617, -1.41731395895783, 218, 12, 'PPL', 'P'),
(95681, 'Leon Junction', 31.3408298492432, 0.547000671176611, -97.5938873291016, -1.7033346637132, 218, 51, 'PPL', 'P'),
(95682, 'Leon Springs', 29.6647205352783, 0.517747045024581, -98.6288909912109, -1.7213988853872, 218, 51, 'PPL', 'P'),
(95683, 'Leon Valley', 29.4950008392334, 0.514784877523114, -98.6183319091797, -1.72121459463977, 218, 51, 'PPL', 'P'),
(33030, 'Leona', 39.7872200012207, 0.694417989236644, -95.3213882446289, -1.66367207244059, 218, 20, 'PPL', 'P'),
(95687, 'Leona', 31.1544399261475, 0.543747553326052, -95.9688873291016, -1.67497306336829, 218, 51, 'PPL', 'P'),
(163732, 'Leona', 41.8216705322266, 0.729925849471643, -76.7455596923828, -1.33946270291793, 218, 45, 'PPL', 'P'),
(201124, 'Leona', 43.6952781677246, 0.762626471601589, -123.288063049316, -2.15178262861693, 218, 43, 'PPL', 'P'),
(95684, 'Leona Colonia', 26.2169990539551, 0.457572953483755, -98.3099975585938, -1.71583314502505, 218, 51, 'PPL', 'P'),
(103638, 'Leona Mines (historical)', 36.8383293151855, 0.642950137483936, -83.024169921875, -1.44904512387196, 218, 53, 'PPL', 'P'),
(182777, 'Leona Valley', 34.6183280944824, 0.604203806784373, -118.287216186523, -2.06450138547316, 218, 6, 'PPL', 'P'),
(95685, 'Leonar B De Villarreal Colonia', 26.2099990844727, 0.457450780968747, -97.4779968261719, -1.70131199286528, 218, 51, 'PPL', 'P'),
(3733, 'Leonard', 34.2075004577637, 0.597033511865444, -85.8302764892578, -1.49802092263463, 218, 2, 'PPL', 'P'),
(10043, 'Leonard', 36.2197189331055, 0.632153349529618, -90.2494430541992, -1.5751499293869, 218, 4, 'PPL', 'P'),
(55858, 'Leonard', 39.8963890075684, 0.696323347838541, -92.1783294677734, -1.60881534820076, 218, 29, 'PPL', 'P'),
(76373, 'Leonard', 35.920280456543, 0.626927162206447, -95.7991714477539, -1.67201096244585, 218, 42, 'PPL', 'P'),
(88526, 'Leonard', 36.5344390869141, 0.637646252435961, -85.7836074829102, -1.49720639481523, 218, 50, 'PPL', 'P'),
(95686, 'Leonard', 33.3794403076172, 0.582581135840829, -96.2472229003906, -1.6798309355127, 218, 51, 'PPL', 'P'),
(103639, 'Leonard', 36.6980590820313, 0.640501960072853, -82.2452774047852, -1.4354508849296, 218, 53, 'PPL', 'P'),
(110078, 'Leonard', 38.0827789306641, 0.664669880649213, -80.4036102294922, -1.40330772899483, 218, 58, 'PPL', 'P'),
(120337, 'Leonard', 40.7686080932617, 0.711546442682624, -87.9219436645508, -1.53452740169938, 218, 18, 'PPL', 'P'),
(131742, 'Leonard', 42.8652801513672, 0.748140273431131, -83.1427764892578, -1.45111519898728, 218, 27, 'PPL', 'P'),
(136471, 'Leonard', 47.6519393920898, 0.831683237352753, -95.2719421386719, -1.66280907508935, 218, 28, 'PPL', 'P'),
(140388, 'Leonard', 46.6519393920898, 0.81422994483281, -97.2452774047852, -1.69725027272875, 218, 34, 'PPL', 'P'),
(163733, 'Leonard', 41.021671295166, 0.715963228771494, -78.4150009155273, -1.36859994893032, 218, 45, 'PPL', 'P'),
(193733, 'Leonard', 41.1347198486328, 0.717936298244106, -121.029716491699, -2.11236704553543, 218, 6, 'PPL', 'P'),
(182782, 'Leonard (historical)', 36.9449996948242, 0.644811886822983, -121.869720458984, -2.12702788049437, 218, 6, 'PPL', 'P'),
(186977, 'Leonard (historical)', 38.0638885498047, 0.664340181306261, -108.026390075684, -1.88541618586441, 218, 7, 'PPL', 'P'),
(169459, 'Leonard Corner', 41.8108291625977, 0.729736631876193, -71.3597183227539, -1.24546203802778, 218, 47, 'PPL', 'P'),
(48907, 'Leonard Farm', 38.399169921875, 0.670191945169493, -75.5749969482422, -1.31903252893149, 218, 25, 'PPL', 'P'),
(196898, 'Leonard Place', 45.0244407653809, 0.785824735225052, -112.051940917969, -1.95567530226871, 218, 31, 'PPL', 'P'),
(193734, 'Leonard Place (historical)', 40.0755615234375, 0.699450498169539, -122.504722595215, -2.13811075852879, 218, 6, 'PPL', 'P'),
(30319, 'Leonard Springs', 39.1405601501465, 0.683131645694942, -86.5772171020508, -1.51105749564473, 218, 19, 'PPL', 'P'),
(182778, 'Leonardi', 38.8819389343262, 0.678617853963367, -120.535278320313, -2.10373747149719, 218, 6, 'PPL', 'P'),
(145596, 'Leonardo', 40.4172210693359, 0.705413582166335, -74.0625, -1.2926344772583, 218, 37, 'PPL', 'P'),
(71031, 'Leonards', 39.8422203063965, 0.695377925651563, -75.2063903808594, -1.31259913068619, 218, 37, 'PPL', 'P'),
(174954, 'Leonards', 46.1697196960449, 0.805813623418859, -91.3211135864258, -1.59385410867086, 218, 57, 'PPL', 'P'),
(16880, 'Leonards (historical)', 30.4799995422363, 0.531976348018388, -85.1047210693359, -1.4853575916513, 218, 12, 'PPL', 'P'),
(182779, 'Leonards (historical)', 35.5505599975586, 0.620474322885185, -119.402221679688, -2.0839619025067, 218, 6, 'PPL', 'P'),
(174955, 'Leonards Point', 44.0466690063477, 0.768759398696906, -88.6224975585938, -1.5467543737381, 218, 57, 'PPL', 'P'),
(156119, 'Leonardsburg', 40.3574981689453, 0.704371220915679, -82.9897232055664, -1.44844391525588, 218, 41, 'PPL', 'P'),
(150236, 'Leonardsville', 42.8086090087891, 0.747151175402275, -75.253059387207, -1.31341365850559, 218, 40, 'PPL', 'P'),
(163739, 'Leonardsville', 41.0752792358398, 0.716898863841466, -75.692497253418, -1.32108329612891, 218, 45, 'PPL', 'P'),
(951, 'Leonardtown', 36.5919418334961, 0.638649864692758, -82.2750015258789, -1.43596966870995, 218, 50, 'PPL', 'P'),
(48909, 'Leonardtown', 38.2911109924316, 0.668305961064526, -76.6361083984375, -1.33755241746801, 218, 25, 'PPL', 'P'),
(33031, 'Leonardville', 39.3644409179688, 0.687039102225334, -96.8586120605469, -1.69050168936843, 218, 20, 'PPL', 'P'),
(145597, 'Leonardville', 40.4061088562012, 0.70521963745995, -74.0422210693359, -1.29228054314943, 218, 37, 'PPL', 'P'),
(188874, 'Leoncito', 34.6716690063477, 0.605134781322437, -105.138061523438, -1.83500534274835, 218, 38, 'PPL', 'P'),
(195232, 'Leone', 43.4077796936035, 0.757608676633717, -116.092781066895, -2.02620126741424, 218, 17, 'PPL', 'P'),
(76374, 'Leonel', 35.9911117553711, 0.628163401584461, -98.6527786254883, -1.72181580325586, 218, 42, 'PPL', 'P'),
(88527, 'Leoni', 35.7744407653809, 0.624381779415576, -85.9830627441406, -1.50068754583412, 218, 50, 'PPL', 'P'),
(131743, 'Leoni', 42.2438888549805, 0.737294949365947, -84.269172668457, -1.47077452099619, 218, 27, 'PPL', 'P'),
(16881, 'Leonia', 30.9083309173584, 0.539452140803863, -86.0250015258789, -1.50141951565973, 218, 12, 'PPL', 'P'),
(145598, 'Leonia', 40.8613891601563, 0.713165777783447, -73.9886093139648, -1.29134484150043, 218, 37, 'PPL', 'P'),
(195233, 'Leonia', 48.6166687011719, 0.848520940186724, -116.048606872559, -2.02543028227867, 218, 17, 'PPL', 'P'),
(95688, 'Leonidas', 30.315559387207, 0.529106325890637, -95.5336074829102, -1.66737599688467, 218, 51, 'PPL', 'P'),
(131745, 'Leonidas', 42.0227813720703, 0.733435895788367, -85.351936340332, -1.48967231209139, 218, 27, 'PPL', 'P'),
(136474, 'Leonidas', 47.461669921875, 0.828362408631479, -92.5716705322266, -1.61568044485876, 218, 28, 'PPL', 'P'),
(120338, 'Leonore', 41.1894416809082, 0.718891374390036, -88.9805603027344, -1.55300374755208, 218, 18, 'PPL', 'P'),
(150233, 'Leonta', 42.3597183227539, 0.739316554949426, -75.1277770996094, -1.31122707009258, 218, 40, 'PPL', 'P'),
(41777, 'Leonville', 30.4702796936035, 0.53180670465695, -91.9783325195313, -1.60532474295999, 218, 22, 'PPL', 'P'),
(163734, 'Leopard', 40.0205612182617, 0.69849056175462, -75.4524993896484, -1.31689454320838, 218, 45, 'PPL', 'P'),
(30320, 'Leopold', 38.103889465332, 0.665038328986026, -86.5833282470703, -1.51116415524639, 218, 19, 'PPL', 'P'),
(55859, 'Leopold', 37.2577781677246, 0.650270901004455, -89.9263916015625, -1.56951161788504, 218, 29, 'PPL', 'P'),
(110079, 'Leopold', 39.1252784729004, 0.682864930111771, -80.7408294677734, -1.40919331500391, 218, 58, 'PPL', 'P'),
(174956, 'Leopolis', 44.7680587768555, 0.781350025382473, -88.8447189331055, -1.55063286839163, 218, 57, 'PPL', 'P'),
(55860, 'Leopolis (historical)', 39.871940612793, 0.695896642852883, -93.4211120605469, -1.63050599633113, 218, 29, 'PPL', 'P'),
(55861, 'Leora', 37.0002784729004, 0.645776683506891, -90.0180587768555, -1.57111151190991, 218, 29, 'PPL', 'P'),
(30322, 'Leota', 38.6483306884766, 0.674540620913483, -85.8502807617188, -1.49837006305354, 218, 19, 'PPL', 'P'),
(55862, 'Leota', 36.5313911437988, 0.637593055793187, -92.0374984741211, -1.60635738367267, 218, 29, 'PPL', 'P'),
(60617, 'Leota', 33.1044387817383, 0.577781453766233, -91.0761108398438, -1.58957800406657, 218, 30, 'PPL', 'P'),
(131747, 'Leota', 44.1394386291504, 0.770378534060647, -84.8894424438477, -1.48160027082736, 218, 27, 'PPL', 'P'),
(136476, 'Leota', 43.8338890075684, 0.765045687135817, -96.0133285522461, -1.67574870903577, 218, 28, 'PPL', 'P'),
(204685, 'Leota', 40.1888885498047, 0.701428427911141, -109.65193939209, -1.91378737358924, 218, 52, 'PPL', 'P'),
(187760, 'Leoti', 38.4797210693359, 0.671597827908945, -101.358329772949, -1.76903657886016, 218, 20, 'PPL', 'P'),
(60618, 'Leotis', 34.0672187805176, 0.594585134717279, -88.7433319091797, -1.54886333100533, 218, 30, 'PPL', 'P'),
(187762, 'Leoville', 39.5816688537598, 0.690830444932198, -100.460563659668, -1.75336760427057, 218, 20, 'PPL', 'P'),
(76375, 'Lep', 36.7905616760254, 0.642116434904686, -96.7247161865234, -1.68816476551189, 218, 42, 'PPL', 'P'),
(22599, 'LePageville', 32.0716705322266, 0.559756247402196, -81.0591735839844, -1.41474946798614, 218, 13, 'PPL', 'P'),
(10044, 'Lepanto', 35.6111106872559, 0.621531131784755, -90.329719543457, -1.57655101843639, 218, 4, 'PPL', 'P'),
(10045, 'Lepanto Junction', 35.7380599975586, 0.623746815232674, -90.3333282470703, -1.57661400219617, 218, 4, 'PPL', 'P'),
(195234, 'Leprouse', 45.7436103820801, 0.798376612916759, -115.389442443848, -2.01392569268563, 218, 17, 'PPL', 'P'),
(150234, 'Leptondale', 41.5744400024414, 0.725610862715442, -74.0955581665039, -1.29321145110847, 218, 40, 'PPL', 'P'),
(76376, 'Lequire', 35.1044387817383, 0.61268803880612, -95.1072235107422, -1.65993419269261, 218, 42, 'PPL', 'P'),
(33032, 'Lerado', 37.7763900756836, 0.659322386338389, -98.2822189331055, -1.7153483165486, 218, 20, 'PPL', 'P'),
(73201, 'Lerado', 39.1747207641602, 0.683727860883984, -84.0083312988281, -1.46622198027076, 218, 41, 'PPL', 'P'),
(10046, 'Lerch', 33.2536087036133, 0.580384960047895, -93.4925003051758, -1.63175195624712, 218, 4, 'PPL', 'P'),
(163735, 'Lerchs', 40.6997184753418, 0.710344092029481, -75.4175033569336, -1.31628374721237, 218, 45, 'PPL', 'P'),
(136478, 'Lerdal', 43.7238883972168, 0.763125814305979, -93.2688903808594, -1.62784922682766, 218, 28, 'PPL', 'P'),
(182780, 'Lerdo', 35.4902801513672, 0.619422241096549, -119.151672363281, -2.07958899199679, 218, 6, 'PPL', 'P'),
(48910, 'Lereley', 39.4055595397949, 0.687756757560083, -76.4027786254883, -1.33348004468712, 218, 25, 'PPL', 'P'),
(27704, 'Lerna', 39.4183311462402, 0.687979664143322, -88.2886123657227, -1.54092697779884, 218, 18, 'PPL', 'P'),
(163736, 'Lernerville', 40.7380599975586, 0.711013277832391, -79.7624969482422, -1.39211819135876, 218, 45, 'PPL', 'P'),
(110082, 'Lerona', 37.499439239502, 0.654488682380868, -80.9791717529297, -1.41335317262661, 218, 58, 'PPL', 'P'),
(182781, 'Lerona', 37.1294403076172, 0.648030982790616, -119.430282592773, -2.08445165783117, 218, 6, 'PPL', 'P'),
(36850, 'Lerose', 37.4822196960449, 0.654188144651852, -83.6155624389648, -1.45936687046684, 218, 21, 'PPL', 'P'),
(3734, 'Leroy', 31.5044403076172, 0.549856212365935, -87.9847183227539, -1.53562302617184, 218, 2, 'PPL', 'P'),
(41778, 'Leroy', 30.0786094665527, 0.52497076961288, -92.1922225952148, -1.60905782901801, 218, 22, 'PPL', 'P'),
(76377, 'Leroy', 36.2102813720703, 0.631988633016197, -96.2566680908203, -1.67999578518418, 218, 42, 'PPL', 'P'),
(95689, 'Leroy', 31.7313899993896, 0.553817231723751, -97.0175018310547, -1.69327483901153, 218, 51, 'PPL', 'P'),
(110050, 'LeRoy', 38.9058303833008, 0.679034838411046, -81.545280456543, -1.42323363342886, 218, 58, 'PPL', 'P'),
(123043, 'Leroy', 41.3600006103516, 0.721868189277499, -87.2719421386719, -1.52318273492981, 218, 19, 'PPL', 'P'),
(131754, 'Leroy', 45.2200012207031, 0.789237909057125, -83.5208282470703, -1.45771344690406, 218, 27, 'PPL', 'P'),
(140391, 'Leroy', 48.9233283996582, 0.853873161608484, -97.7522201538086, -1.70609809281832, 218, 34, 'PPL', 'P'),
(163737, 'Leroy', 41.6758308410645, 0.727380466680772, -76.7074966430664, -1.33879837738401, 218, 45, 'PPL', 'P'),
(174930, 'LeRoy', 43.5736083984375, 0.760502933527388, -88.5605621337891, -1.54567339665163, 218, 57, 'PPL', 'P'),
(194287, 'Leroy', 40.5261116027832, 0.707314080499243, -102.913612365723, -1.79618138090301, 218, 7, 'PPL', 'P'),
(196899, 'Leroy', 47.8741683959961, 0.835561865164344, -109.317779541016, -1.90795518396002, 218, 31, 'PPL', 'P'),
(16882, 'Leroy (historical)', 29.1341705322266, 0.508487200624862, -82.329719543457, -1.43692467827685, 218, 12, 'PPL', 'P'),
(103641, 'Lerty', 38.1419410705566, 0.665702454782864, -76.8677825927734, -1.34159589495108, 218, 53, 'PPL', 'P'),
(110080, 'Lesage', 38.5063896179199, 0.672063281888464, -82.2986068725586, -1.43638165973058, 218, 58, 'PPL', 'P'),
(36851, 'Lesbas', 37.0788917541504, 0.6471487441005, -83.9955596923828, -1.46599907368752, 218, 21, 'PPL', 'P'),
(188875, 'Lesbia', 35.1619415283203, 0.613691651062916, -103.578056335449, -1.80777811586976, 218, 38, 'PPL', 'P'),
(142219, 'Leshara', 41.329719543457, 0.721339684959173, -96.4280624389648, -1.68298718087861, 218, 35, 'PPL', 'P'),
(191760, 'Lesley', 34.6769409179688, 0.6052267935381, -100.815559387207, -1.75956344854664, 218, 51, 'PPL', 'P'),
(10047, 'Leslie', 35.8302803039551, 0.625356363216491, -92.5577774047852, -1.61543796404151, 218, 4, 'PPL', 'P'),
(22631, 'Leslie', 31.9552803039551, 0.557724854701711, -84.086669921875, -1.4675892471744, 218, 13, 'PPL', 'P'),
(36852, 'Leslie', 36.7794418334961, 0.641922357040247, -85.4519424438477, -1.49141774786983, 218, 21, 'PPL', 'P'),
(41780, 'Leslie', 32.5886116027832, 0.568778571122193, -93.4830627441406, -1.6315872397337, 218, 22, 'PPL', 'P'),
(48911, 'Leslie', 39.6194381713867, 0.69148964388102, -75.9513931274414, -1.32560188155045, 218, 25, 'PPL', 'P'),
(55864, 'Leslie', 38.417781829834, 0.670516784243455, -91.2319412231445, -1.59229775732981, 218, 29, 'PPL', 'P'),
(103642, 'Leslie', 37.2208290100098, 0.649626016546492, -79.8933334350586, -1.39440171883544, 218, 53, 'PPL', 'P'),
(110081, 'Leslie', 38.0444412231445, 0.664000761425331, -80.7230606079102, -1.40888318989497, 218, 58, 'PPL', 'P'),
(116457, 'Leslie', 40.9427795410156, 0.714586307908895, -93.7977828979492, -1.63708014264004, 218, 16, 'PPL', 'P'),
(131750, 'Leslie', 42.4513893127441, 0.740916515553318, -84.432502746582, -1.47362516862701, 218, 27, 'PPL', 'P'),
(174957, 'Leslie', 42.7705612182617, 0.746487116184464, -90.3663864135742, -1.57719097604634, 218, 57, 'PPL', 'P'),
(195235, 'Leslie', 43.8658294677734, 0.765603153330998, -113.466667175293, -1.98036693347344, 218, 17, 'PPL', 'P'),
(156121, 'Leslie (historical)', 41.6855583190918, 0.727550243200265, -83.9519424438477, -1.46523780908992, 218, 41, 'PPL', 'P'),
(95690, 'Leslie Colonia', 26.193000793457, 0.457154104823312, -98.2829971313477, -1.71536189867016, 218, 51, 'PPL', 'P'),
(22632, 'Leslie Estates', 33.726390838623, 0.588636564948424, -84.2186126708984, -1.46989208256899, 218, 13, 'PPL', 'P'),
(163740, 'Leslie Run', 40.9961090087891, 0.715517082709878, -75.727783203125, -1.32169915213099, 218, 45, 'PPL', 'P'),
(82071, 'Leslie Woods', 34.8972206115723, 0.609071399466765, -80.9349975585938, -1.41258218749103, 218, 48, 'PPL', 'P'),
(110083, 'Lesmalinston', 39.3388900756836, 0.6865931559008, -79.9700012207031, -1.39573982412515, 218, 58, 'PPL', 'P'),
(73205, 'Lesmil', 39.1583290100098, 0.683441770803882, -82.5708312988281, -1.44113287227334, 218, 41, 'PPL', 'P'),
(60619, 'Lespedeza', 34.4516716003418, 0.601295102241788, -89.7877807617188, -1.56709240235081, 218, 30, 'PPL', 'P'),
(16883, 'Lessie', 30.7250003814697, 0.53625241933316, -81.7772216796875, -1.42728177144383, 218, 12, 'PPL', 'P'),
(60620, 'Lessley', 31.1611099243164, 0.543863966755202, -91.429443359375, -1.59574481988676, 218, 30, 'PPL', 'P'),
(82072, 'Lesslie', 34.8905601501465, 0.608955152485183, -80.956672668457, -1.41296048952388, 218, 48, 'PPL', 'P'),
(3736, 'Lester', 34.9905586242676, 0.610700455105567, -87.1533279418945, -1.52111252665643, 218, 2, 'PPL', 'P'),
(10049, 'Lester', 33.648609161377, 0.587279018582756, -92.9199981689453, -1.6217599089952, 218, 4, 'PPL', 'P'),
(22634, 'Lester', 31.3694400787354, 0.547500013881001, -84.0449981689453, -1.4668619378807, 218, 13, 'PPL', 'P'),
(27705, 'Lester', 38.8025016784668, 0.677231412299872, -88.9763870239258, -1.55293091009626, 218, 18, 'PPL', 'P'),
(78615, 'Lester', 39.8708305358887, 0.695877268355953, -75.2830581665039, -1.3139372359759, 218, 45, 'PPL', 'P'),
(82073, 'Lester', 34.6791687011719, 0.605265675690015, -79.6511077880859, -1.390174083763, 218, 48, 'PPL', 'P'),
(110084, 'Lester', 37.7347183227539, 0.658595077044688, -81.2997207641602, -1.4189478082866, 218, 58, 'PPL', 'P'),
(116458, 'Lester', 43.4447212219238, 0.758253427933625, -96.3327789306641, -1.68132416993591, 218, 16, 'PPL', 'P'),
(150235, 'Lester', 42.0602798461914, 0.734090367626254, -75.7261123657227, -1.32166999051705, 218, 40, 'PPL', 'P'),
(156123, 'Lester', 41.1808280944824, 0.718741038946501, -81.9380569458008, -1.43008887639083, 218, 41, 'PPL', 'P'),
(207913, 'Lester', 47.2094383239746, 0.82396013677055, -121.492782592773, -2.12044907365355, 218, 56, 'PPL', 'P'),
(66329, 'Lester (historical)', 36.3236083984375, 0.633966562757799, -81.2519378662109, -1.41811383939124, 218, 33, 'PPL', 'P'),
(48912, 'Lester Acres', 39.6088905334473, 0.691305552870668, -76.9019393920898, -1.34219204356109, 218, 25, 'PPL', 'P'),
(10051, 'Lester Junction', 33.6277809143066, 0.58691549709396, -92.9369430541992, -1.62205565303425, 218, 4, 'PPL', 'P'),
(142224, 'Lester Junction', 40.0855598449707, 0.699625001799966, -98.4433288574219, -1.71816021518556, 218, 35, 'PPL', 'P'),
(136481, 'Lester Park', 46.8375015258789, 0.817468615034455, -92.0194396972656, -1.60604219855766, 218, 28, 'PPL', 'P'),
(136482, 'Lester Prairie', 44.8838882446289, 0.783371630965953, -94.041389465332, -1.64133187932035, 218, 28, 'PPL', 'P'),
(22635, 'Lester Woods', 33.9036102294922, 0.591729626817469, -84.10888671875, -1.46797700342912, 218, 13, 'PPL', 'P'),
(88528, 'Lesters', 35.0694389343262, 0.612077176231083, -87.004997253418, -1.51852366776077, 218, 50, 'PPL', 'P'),
(10053, 'Lesterville', 36.1508293151855, 0.630950998876475, -90.9563903808594, -1.5874884878753, 218, 4, 'PPL', 'P'),
(55866, 'Lesterville', 37.4538917541504, 0.653693728795479, -90.8433303833008, -1.5855152186656, 218, 29, 'PPL', 'P'),
(131753, 'Lesterville', 42.9577789306641, 0.749754681683937, -82.9055633544922, -1.44697504875664, 218, 27, 'PPL', 'P'),
(170732, 'Lesterville', 43.0394401550293, 0.75117993892032, -97.5952835083008, -1.70335903163717, 218, 49, 'PPL', 'P'),
(103581, 'LeSueur', 37.6827812194824, 0.657688603588652, -78.3544387817383, -1.36754294029367, 218, 53, 'PPL', 'P'),
(110085, 'Let (historical)', 38.892219543457, 0.678797284441811, -80.8277816772461, -1.41071091735109, 218, 58, 'PPL', 'P'),
(55868, 'Leta', 39.3705596923828, 0.687145894985046, -93.3283309936523, -1.6288866612303, 218, 29, 'PPL', 'P'),
(10054, 'Leta (historical)', 35.4536094665527, 0.618782216907576, -92.9347229003906, -1.62201690404039, 218, 4, 'PPL', 'P'),
(199477, 'Letan', 42.014720916748, 0.733295214303784, -102.940277099609, -1.7966467683035, 218, 35, 'PPL', 'P'),
(110086, 'Letart', 38.894718170166, 0.678840893704661, -81.9336090087891, -1.43001124524506, 218, 58, 'PPL', 'P'),
(73202, 'Letart Falls', 38.8927803039551, 0.678807071558817, -81.9241714477539, -1.42984652873164, 218, 41, 'PPL', 'P'),
(110087, 'Letch', 38.8008308410645, 0.677202250685935, -80.4966735839844, -1.40493199094367, 218, 58, 'PPL', 'P'),
(3737, 'Letcher', 34.7519416809082, 0.606535803792901, -86.1622161865234, -1.50381436326999, 218, 2, 'PPL', 'P'),
(36857, 'Letcher', 37.1450004577637, 0.648302558642777, -82.9591674804688, -1.44791061724759, 218, 21, 'PPL', 'P'),
(170735, 'Letcher', 43.8972206115723, 0.766151032146255, -98.1383285522461, -1.71283695564065, 218, 49, 'PPL', 'P'),
(182783, 'Letcher (historical)', 36.9077796936035, 0.644162275254085, -119.517501831055, -2.08597392071026, 218, 6, 'PPL', 'P'),
(3738, 'Letchers', 33.6619415283203, 0.587511712283001, -85.8561096191406, -1.49847179580718, 218, 2, 'PPL', 'P'),
(10055, 'Letchworth', 34.910831451416, 0.609308953436, -91.4941711425781, -1.59687453282117, 218, 4, 'PPL', 'P'),
(22636, 'Letford', 32.0386085510254, 0.559179206973003, -81.6013870239258, -1.42421287776168, 218, 13, 'PPL', 'P'),
(195236, 'Letha', 43.8944396972656, 0.766102496035388, -116.646667480469, -2.03586840901318, 218, 17, 'PPL', 'P'),
(66330, 'Letha (historical)', 36.1916694641113, 0.631663793942234, -78.3525009155273, -1.36750911814782, 218, 33, 'PPL', 'P'),
(182784, 'Lethent (historical)', 36.2866706848145, 0.633321878036918, -119.881942749023, -2.0923346146578, 218, 6, 'PPL', 'P'),
(82074, 'Lethia', 33.9661102294922, 0.592820457599965, -82.4122161865234, -1.4383645163202, 218, 48, 'PPL', 'P'),
(36856, 'Letitia', 38.6366691589355, 0.674337088827174, -83.0047225952148, -1.44870570399103, 218, 21, 'PPL', 'P'),
(66331, 'Letitia', 35.0438919067383, 0.611631296485577, -84.1486129760742, -1.46867035741892, 218, 33, 'PPL', 'P'),
(76379, 'Letitia', 34.5794410705566, 0.603525100180566, -98.2113876342773, -1.71411207717058, 218, 42, 'PPL', 'P'),
(3739, 'Letohatchee', 32.1294403076172, 0.5607645201909, -86.4858322143555, -1.50946252846788, 218, 2, 'PPL', 'P'),
(560, 'Leton', 32.8600006103516, 0.573515202857981, -93.2525024414063, -1.62756320332659, 218, 22, 'PPL', 'P'),
(10056, 'Letona', 35.3616714477539, 0.617177595771776, -91.8291702270508, -1.60272136983638, 218, 4, 'PPL', 'P'),
(78616, 'Letort', 39.9761085510254, 0.697714716350053, -76.4066696166992, -1.33354795529492, 218, 45, 'PPL', 'P'),
(3740, 'Letson Settlement', 34.5766716003418, 0.603476763806781, -87.2916717529297, -1.52352708165875, 218, 2, 'PPL', 'P'),
(30323, 'Letts', 39.2350006103516, 0.68477994267262, -85.5650024414063, -1.49339101707953, 218, 19, 'PPL', 'P'),
(116460, 'Letts', 41.3283309936523, 0.721315450193253, -91.2369384765625, -1.59238497585551, 218, 16, 'PPL', 'P'),
(30324, 'Letts Corner', 39.2347183227539, 0.684775015824603, -85.5749969482422, -1.49356545413093, 218, 19, 'PPL', 'P'),
(30325, 'Lettsville', 38.7186088562012, 0.675767206332546, -87.1744384765625, -1.52148097499325, 218, 19, 'PPL', 'P'),
(41779, 'Lettsworth', 30.9333305358887, 0.539888466458959, -91.704719543457, -1.60054929565132, 218, 22, 'PPL', 'P'),
(182785, 'Leucadia', 33.0680618286133, 0.577146556162359, -117.30249786377, -2.04731480853639, 218, 6, 'PPL', 'P'),
(178528, 'Leupp', 35.2980613708496, 0.616067390492349, -111.005561828613, -1.93741254193544, 218, 5, 'PPL', 'P'),
(178529, 'Leupp Corner', 35.0741691589355, 0.612159734224876, -110.857223510742, -1.93482354988172, 218, 5, 'PPL', 'P'),
(192672, 'Levan', 39.5586090087891, 0.69042797471246, -111.861106872559, -1.9523446198514, 218, 52, 'PPL', 'P'),
(73204, 'Levanna', 38.7663917541504, 0.676601175227904, -83.8838882446289, -1.46405003924374, 218, 41, 'PPL', 'P'),
(150241, 'Levanna', 42.7844390869141, 0.746729330685607, -76.7138900756836, -1.33890996383368, 218, 40, 'PPL', 'P'),
(127933, 'Levant', 44.8691711425781, 0.783114769078814, -68.9352798461914, -1.20314760409973, 218, 26, 'PPL', 'P'),
(150237, 'Levant', 42.1333312988281, 0.73536535599813, -79.1819381713867, -1.38198552920128, 218, 40, 'PPL', 'P'),
(187763, 'Levant', 39.3855590820313, 0.687407683720201, -101.194442749023, -1.76617621069136, 218, 20, 'PPL', 'P'),
(55869, 'Levasy', 39.1355590820313, 0.683044360590215, -94.1327819824219, -1.64292697965526, 218, 29, 'PPL', 'P'),
(36858, 'Levee', 37.9711112976074, 0.662720912784466, -83.9352798461914, -1.46494699189888, 218, 21, 'PPL', 'P'),
(182786, 'Levee (historical)', 35.1749992370605, 0.6139195510732, -119.234169006348, -2.08102883004014, 218, 6, 'PPL', 'P'),
(48913, 'Level', 39.5802803039551, 0.690806210166278, -76.1936111450195, -1.32982938346484, 218, 25, 'PPL', 'P'),
(142223, 'Level', 40.538890838623, 0.707537120240537, -98.3030624389648, -1.7157121043535, 218, 35, 'PPL', 'P'),
(195237, 'Level (historical)', 43.8958282470703, 0.766126730801308, -112.491111755371, -1.96334027936012, 218, 17, 'PPL', 'P'),
(120339, 'Level Acres', 41.4688911437988, 0.723768687610407, -90.3219375610352, -1.5764151972208, 218, 18, 'PPL', 'P'),
(163742, 'Level Corner', 41.2019386291504, 0.719109487283313, -77.1883316040039, -1.34719053061106, 218, 45, 'PPL', 'P'),
(22637, 'Level Creek', 34.084171295166, 0.594881011914387, -84.0730590820313, -1.46735169320517, 218, 13, 'PPL', 'P'),
(66333, 'Level Cross', 36.3444404602051, 0.634330150825622, -80.6288909912109, -1.40723962002823, 218, 33, 'PPL', 'P'),
(36860, 'Level Green', 37.2811088562012, 0.650678098335128, -84.4261093139648, -1.47351358217734, 218, 21, 'PPL', 'P'),
(163743, 'Level Green', 40.3933296203613, 0.704996597718656, -79.7205581665039, -1.39138622153315, 218, 45, 'PPL', 'P'),
(82075, 'Level Land', 34.3274993896484, 0.599127888325709, -82.475830078125, -1.43947478817865, 218, 48, 'PPL', 'P'),
(131755, 'Level Park', 42.360279083252, 0.739326342066432, -85.2724990844727, -1.4882858704279, 218, 27, 'PPL', 'P'),
(3741, 'Level Plains', 31.2994403839111, 0.546278288730927, -85.7780609130859, -1.4971095889096, 218, 2, 'PPL', 'P'),
(103644, 'Level Run', 37.0397186279297, 0.64646504406965, -79.1994400024414, -1.38229099377831, 218, 53, 'PPL', 'P'),
(48914, 'Level Terrace', 39.5758285522461, 0.690728512441475, -76.2050018310547, -1.33002818844021, 218, 25, 'PPL', 'P'),
(191761, 'Levelland', 33.5872192382813, 0.58620756229719, -102.377502441406, -1.78682449757107, 218, 51, 'PPL', 'P'),
(211967, 'Levelock', 59.1141700744629, 1.03173690238328, -156.85888671875, -2.73770403425499, 218, 1, 'PPL', 'P'),
(110088, 'Levels', 39.4844398498535, 0.689133478685599, -78.5538864135742, -1.37102395815451, 218, 58, 'PPL', 'P'),
(82076, 'Lever (historical)', 34.1972198486328, 0.596854081386999, -81.1100006103516, -1.41563656694525, 218, 48, 'PPL', 'P'),
(22638, 'Leverett', 33.8105583190918, 0.590105564605711, -82.39111328125, -1.43799620114144, 218, 13, 'PPL', 'P'),
(60621, 'Leverett', 33.8827781677246, 0.591366038749646, -90.0755615234375, -1.5721151241667, 218, 30, 'PPL', 'P'),
(116461, 'Leverett', 42.9066696166992, 0.748862655876815, -94.9733276367188, -1.65759726883607, 218, 16, 'PPL', 'P'),
(120340, 'Leverett', 40.1891708374023, 0.701433354759158, -88.209716796875, -1.53954999035722, 218, 18, 'PPL', 'P'),
(125232, 'Leverett', 42.4519386291504, 0.740926102933242, -72.5019378662109, -1.26539752984173, 218, 23, 'PPL', 'P'),
(125233, 'Leverett Station', 42.4505615234375, 0.740902067904404, -72.523063659668, -1.26576624449465, 218, 23, 'PPL', 'P'),
(95692, 'Leverett''s Chapel', 32.3122596740723, 0.563955320071951, -94.9224090576172, -1.65670857198031, 218, 51, 'PPL', 'P'),
(22639, 'Leveretts', 31.9427795410156, 0.557506675229406, -84.5699996948242, -1.47602494308528, 218, 13, 'PPL', 'P'),
(198522, 'Leverich', 48.4352798461914, 0.845355107440893, -100.088890075684, -1.74688067648736, 218, 34, 'PPL', 'P'),
(131756, 'Levering', 45.6358299255371, 0.796495489080781, -84.7869415283203, -1.4798112923651, 218, 27, 'PPL', 'P'),
(207914, 'Levering', 46.7802810668945, 0.816469929625675, -119.956672668457, -2.09363889780167, 218, 56, 'PPL', 'P'),
(3742, 'Levert', 32.7591705322266, 0.571755386009657, -87.2413864135742, -1.52264943692152, 218, 2, 'PPL', 'P'),
(41781, 'Levert', 30.1569404602051, 0.526337903358473, -91.8211135864258, -1.60258075493083, 218, 22, 'PPL', 'P'),
(123044, 'Levert', 41.1555595397949, 0.718300019469984, -85.3150024414063, -1.48902769394954, 218, 19, 'PPL', 'P'),
(55870, 'Leverton', 39.9433288574219, 0.697142602768876, -93.0583267211914, -1.62417419768141, 218, 29, 'PPL', 'P'),
(10058, 'Levesque', 35.2491683959961, 0.61521404710006, -90.710563659668, -1.58319800220112, 218, 4, 'PPL', 'P'),
(116462, 'Levey', 41.5463905334473, 0.725121307128058, -93.5216674804688, -1.63226101948949, 218, 16, 'PPL', 'P'),
(207915, 'Levey', 46.2758293151855, 0.807665585640901, -118.843612670898, -2.07421233607203, 218, 56, 'PPL', 'P'),
(22640, 'Levgard Estates', 33.5780601501465, 0.586047706052758, -84.4550018310547, -1.47401785172974, 218, 13, 'PPL', 'P'),
(36859, 'Levi', 37.480281829834, 0.654154322506008, -83.720832824707, -1.46120418530288, 218, 21, 'PPL', 'P'),
(95691, 'Levi', 31.3769397735596, 0.547630908248579, -97.121940612793, -1.69509763961964, 218, 51, 'PPL', 'P'),
(36861, 'Levias', 37.3077812194824, 0.651143618893674, -88.1808319091797, -1.53904585396286, 218, 21, 'PPL', 'P'),
(55872, 'Levick Mill', 39.5761108398438, 0.690733439289492, -92.3463897705078, -1.61174855382537, 218, 29, 'PPL', 'P'),
(27708, 'Levings', 37.2172203063965, 0.649563032786711, -89.0616683959961, -1.55441935082951, 218, 18, 'PPL', 'P'),
(191762, 'Levinson', 31.0988903045654, 0.542778029531209, -104.117500305176, -1.81719318927152, 218, 51, 'PPL', 'P'),
(174959, 'Levis', 44.5386085510254, 0.777345363472294, -91.1044387817383, -1.59007241992294, 218, 57, 'PPL', 'P'),
(182787, 'Levis', 36.6236114501953, 0.639202603777003, -120.405281066895, -2.1014685914065, 218, 6, 'PPL', 'P'),
(36862, 'Levisa Junction', 37.4058303833008, 0.652854899631131, -82.4422225952148, -1.43888822694856, 218, 21, 'PPL', 'P'),
(163744, 'Leviston', 40.9272193908691, 0.714314732056735, -75.9372177124023, -1.32535447388518, 218, 45, 'PPL', 'P'),
(10059, 'Levit (historical)', 33.6838912963867, 0.587894808005809, -92.3547210693359, -1.61189396242089, 218, 4, 'PPL', 'P'),
(95693, 'Levita', 31.514720916748, 0.550035642844379, -97.8877792358398, -1.70846404513074, 218, 51, 'PPL', 'P'),
(150238, 'Levittown', 40.725830078125, 0.710799825471021, -73.5147171020508, -1.28307386210297, 218, 40, 'PPL', 'P'),
(163745, 'Levittown', 40.1549987792969, 0.700836939833034, -74.8291702270508, -1.30601539699735, 218, 45, 'PPL', 'P'),
(66335, 'Leviva', 36.3977813720703, 0.635261125363686, -79.5800018310547, -1.38893305069502, 218, 33, 'PPL', 'P'),
(10060, 'Levy', 34.7886085510254, 0.607175761402847, -92.2763900756836, -1.6105268286753, 218, 4, 'PPL', 'P'),
(55871, 'Levy', 37.913330078125, 0.66171244025868, -90.9449996948242, -1.58728968289992, 218, 29, 'PPL', 'P'),
(82077, 'Levy', 32.2027816772461, 0.562044568568846, -81.029167175293, -1.41422575735778, 218, 48, 'PPL', 'P'),
(103646, 'Levy', 38.0355606079102, 0.663845765449888, -77.7080612182617, -1.35626152359998, 218, 53, 'PPL', 'P'),
(188876, 'Levy', 36.0880584716797, 0.629855440983043, -104.686111450195, -1.82711732591564, 218, 38, 'PPL', 'P'),
(150239, 'Lewbeach', 42.0047187805176, 0.733120644094329, -74.7852783203125, -1.30524933870979, 218, 40, 'PPL', 'P'),
(199478, 'Lewellen', 41.3313903808594, 0.721368846573109, -102.143333435059, -1.78273747740418, 218, 35, 'PPL', 'P'),
(131757, 'Lewer Pewabic', 47.151668548584, 0.822951863981846, -88.5602798461914, -1.54566846980362, 218, 27, 'PPL', 'P'),
(14105, 'Lewes', 38.7744407653809, 0.676741656975406, -75.1397171020508, -1.31143546244788, 218, 10, 'PPL', 'P'),
(14106, 'Lewes Beach', 38.7849998474121, 0.67692594772284, -75.1483306884766, -1.31158579789141, 218, 10, 'PPL', 'P'),
(3743, 'Lewin (historical)', 34.0041694641113, 0.593484716554858, -86.1138916015625, -1.50297094015276, 218, 2, 'PPL', 'P'),
(103647, 'Lewinsville', 38.9288902282715, 0.679437308630784, -77.1980590820313, -1.34736030713056, 218, 53, 'PPL', 'P'),
(103648, 'Lewinsville Heights', 38.9213905334473, 0.679306414263207, -77.1902770996094, -1.34722448591496, 218, 53, 'PPL', 'P'),
(3745, 'Lewis', 31.8858299255371, 0.556512716931561, -85.8844375610352, -1.49896621166355, 218, 2, 'PPL', 'P'),
(10062, 'Lewis', 35.0533294677734, 0.611796012998998, -94.125, -1.64279115843966, 218, 4, 'PPL', 'P'),
(16887, 'Lewis', 30.2136096954346, 0.527326968097814, -85.0591735839844, -1.48456263806591, 218, 12, 'PPL', 'P'),
(22642, 'Lewis', 32.8016700744629, 0.572497142952271, -81.6816711425781, -1.42561409996923, 218, 13, 'PPL', 'P'),
(30326, 'Lewis', 39.2599983215332, 0.685216235038202, -87.2574996948242, -1.52293066673263, 218, 19, 'PPL', 'P'),
(33034, 'Lewis', 37.9361114501953, 0.662110050209429, -99.2522201538086, -1.73227803159823, 218, 20, 'PPL', 'P'),
(55873, 'Lewis', 38.4352798461914, 0.67082218224146, -93.6913909912109, -1.63522325356998, 218, 29, 'PPL', 'P'),
(66336, 'Lewis', 36.3758316040039, 0.634878029640878, -78.5950012207031, -1.37174154691023, 218, 33, 'PPL', 'P'),
(82078, 'Lewis', 34.7786102294922, 0.607001257772419, -81.1336135864258, -1.41604869112393, 218, 48, 'PPL', 'P'),
(116464, 'Lewis', 41.3058280944824, 0.720922700511494, -95.0830612182617, -1.659512481134, 218, 16, 'PPL', 'P'),
(150240, 'Lewis', 44.2750015258789, 0.7727445529521, -73.5661087036133, -1.28397081475811, 218, 40, 'PPL', 'P'),
(174961, 'Lewis', 45.7108306884766, 0.797804499335582, -92.4022216796875, -1.61272300446823, 218, 57, 'PPL', 'P'),
(186978, 'Lewis', 37.4997215270996, 0.654493609228884, -108.668609619141, -1.89662503141839, 218, 7, 'PPL', 'P'),
(201125, 'Lewis', 45.6908302307129, 0.7974554254957, -117.093612670898, -2.04366907416213, 218, 43, 'PPL', 'P'),
(204684, 'Lewis', 40.0855598449707, 0.699625001799966, -111.703056335449, -1.9495861175943, 218, 52, 'PPL', 'P'),
(73207, 'Lewis (historical)', 39.8813896179199, 0.696061559103386, -82.0397186279297, -1.4318632074671, 218, 41, 'PPL', 'P'),
(55875, 'Lewis and Clark Village', 39.5430603027344, 0.690156598597381, -95.0524978637695, -1.65897904996765, 218, 29, 'PPL', 'P'),
(88529, 'Lewis Branch', 36.2833290100098, 0.633263554809045, -87.7694396972656, -1.5318657053479, 218, 50, 'PPL', 'P'),
(156124, 'Lewis Center', 40.1983299255371, 0.70159321100359, -83.0102767944336, -1.44880264305471, 218, 41, 'PPL', 'P'),
(169460, 'Lewis City', 41.5974998474121, 0.72601333293518, -71.7111129760742, -1.25159503170212, 218, 47, 'PPL', 'P'),
(191763, 'Lewis Colonia', 31.613000869751, 0.551750951612986, -106.27799987793, -1.854901020304, 218, 51, 'PPL', 'P'),
(22643, 'Lewis Corner', 34.5149993896484, 0.602400380673198, -84.8102798461914, -1.48021862285383, 218, 13, 'PPL', 'P'),
(27709, 'Lewis Corner', 37.2724990844727, 0.65052782947062, -88.5794372558594, -1.54600282967848, 218, 18, 'PPL', 'P'),
(48915, 'Lewis Corner', 38.2900009155273, 0.668286586567595, -75.1513900756836, -1.31163919427127, 218, 25, 'PPL', 'P'),
(163746, 'Lewis Corner', 41.9008293151855, 0.731307430866149, -77.9288864135742, -1.36011565032955, 218, 45, 'PPL', 'P'),
(150242, 'Lewis Corners', 43.3644409179688, 0.756852272305107, -76.4713897705078, -1.33467753507127, 218, 40, 'PPL', 'P'),
(163747, 'Lewis Corners', 41.8958282470703, 0.731220145761421, -75.663330078125, -1.32057423288654, 218, 45, 'PPL', 'P'),
(30327, 'Lewis Creek', 39.4011116027832, 0.687679126414307, -85.8166732788086, -1.49778350182345, 218, 19, 'PPL', 'P'),
(36864, 'Lewis Creek', 36.9894409179688, 0.645587532490468, -83.3169403076172, -1.4541549310555, 218, 21, 'PPL', 'P'),
(78617, 'Lewis Crossing', 39.8675003051758, 0.695819144865162, -79.8694381713867, -1.39398466780874, 218, 45, 'PPL', 'P'),
(66338, 'Lewis Crossroads', 36.332218170166, 0.634116831622306, -77.7527770996094, -1.35704196295743, 218, 33, 'PPL', 'P'),
(82079, 'Lewis Crossroads', 34.3288917541504, 0.599152189670656, -79.9688873291016, -1.3957203830492, 218, 48, 'PPL', 'P'),
(204686, 'Lewis Estates', 41.1666717529297, 0.718493964176369, -112.110557556152, -1.95669835560147, 218, 52, 'PPL', 'P'),
(103649, 'Lewis Gardens', 37.5133285522461, 0.654731096619092, -77.3388900756836, -1.34981827165865, 218, 53, 'PPL', 'P'),
(103650, 'Lewis Hill East', 38.0666694641113, 0.664388717417128, -78.5897216796875, -1.37164940153652, 218, 53, 'PPL', 'P'),
(103651, 'Lewis Hill West', 38.0686111450195, 0.664422606141999, -78.5927810668945, -1.37170279791637, 218, 53, 'PPL', 'P'),
(136485, 'Lewis Lake', 45.7666702270508, 0.798779083136497, -93.3686065673828, -1.62958960260003, 218, 28, 'PPL', 'P'),
(48916, 'Lewis Landing', 38.413890838623, 0.670448873635658, -75.8513870239258, -1.32385644577201, 218, 25, 'PPL', 'P'),
(88531, 'Lewis Lane', 36.5558280944824, 0.638019561041763, -82.6263885498047, -1.44210252922623, 218, 50, 'PPL', 'P'),
(48917, 'Lewis Mill', 39.372501373291, 0.687179783709917, -77.5597229003906, -1.35367253154626, 218, 25, 'PPL', 'P'),
(55874, 'Lewis Mill', 39.2574996948242, 0.685172625775352, -92.852783203125, -1.62058678653502, 218, 29, 'PPL', 'P'),
(163748, 'Lewis Mills', 40.0991706848145, 0.699862555769202, -75.8288879394531, -1.32346376266928, 218, 45, 'PPL', 'P'),
(103652, 'Lewis Park', 38.8208312988281, 0.677551324525817, -77.3766708374023, -1.35047767034455, 218, 53, 'PPL', 'P'),
(103653, 'Lewis Place', 37.2827796936035, 0.650707259949064, -80.1211090087891, -1.39837715255266, 218, 53, 'PPL', 'P'),
(66340, 'Lewis Point', 35.9880599975586, 0.62811013836266, -76.0711135864258, -1.32769139774172, 218, 33, 'PPL', 'P'),
(163749, 'Lewis Run', 41.8708305358887, 0.730783853395839, -78.6616668701172, -1.37290508199049, 218, 45, 'PPL', 'P'),
(178530, 'Lewis Springs', 31.5811100006104, 0.551194350945159, -110.141387939453, -1.92232986225983, 218, 5, 'PPL', 'P'),
(88532, 'Lewis Store', 35.6227798461914, 0.621734797029119, -86.1458282470703, -1.50352833976891, 218, 50, 'PPL', 'P'),
(13144, 'Lewis Subdivision (historical)', 38.9355583190918, 0.679553688770421, -77.0322189331055, -1.3444658504998, 218, 9, 'PPL', 'P'),
(163754, 'Lewisberry', 40.1349983215332, 0.700487865993152, -76.8600006103516, -1.34146007373549, 218, 45, 'PPL', 'P'),
(150247, 'Lewisboro', 41.2380599975586, 0.719739924092362, -73.523063659668, -1.2832195370146, 218, 40, 'PPL', 'P'),
(3750, 'Lewisburg', 33.5825004577637, 0.586125204040479, -86.8055572509766, -1.51504278305798, 218, 2, 'PPL', 'P'),
(10064, 'Lewisburg', 35.1419410705566, 0.613342577223034, -92.7350006103516, -1.61853109248959, 218, 4, 'PPL', 'P'),
(27710, 'Lewisburg', 39.9700012207031, 0.697608123327422, -89.8324966430664, -1.56787284170826, 218, 18, 'PPL', 'P'),
(36866, 'Lewisburg', 38.5488891601563, 0.672805038831078, -83.7649993896484, -1.46197503728041, 218, 21, 'PPL', 'P'),
(41783, 'Lewisburg', 30.3694400787354, 0.530046721361058, -90.1030578613281, -1.57259502579514, 218, 22, 'PPL', 'P'),
(60622, 'Lewisburg', 34.8619384765625, 0.608455610043712, -89.8333282470703, -1.5678873559362, 218, 30, 'PPL', 'P'),
(66357, 'Lewisburg', 35.9944381713867, 0.628221458496225, -82.3925018310547, -1.43802043590736, 218, 33, 'PPL', 'P'),
(73209, 'Lewisburg', 39.8461112976074, 0.69544583625936, -84.5397186279297, -1.47549643876696, 218, 41, 'PPL', 'P'),
(88533, 'Lewisburg', 35.4491691589355, 0.618704718919854, -86.7888870239258, -1.51475183270889, 218, 50, 'PPL', 'P'),
(110091, 'Lewisburg', 37.8016700744629, 0.659763605551987, -80.4458312988281, -1.40404462566846, 218, 58, 'PPL', 'P'),
(123045, 'Lewisburg', 40.7466697692871, 0.711163546696898, -86.2174987792969, -1.50477922653292, 218, 19, 'PPL', 'P'),
(145600, 'Lewisburg', 41.1966705322266, 0.719017541646678, -74.6125030517578, -1.30223384140749, 218, 37, 'PPL', 'P'),
(163756, 'Lewisburg', 40.9644393920898, 0.714964343625632, -76.8847198486328, -1.34189150583208, 218, 45, 'PPL', 'P'),
(201126, 'Lewisburg', 44.6291694641113, 0.778925949579256, -123.240280151367, -2.15094865972157, 218, 43, 'PPL', 'P'),
(48936, 'Lewisdale', 39.2861099243164, 0.685671968479742, -77.2613906860352, -1.34846565214099, 218, 25, 'PPL', 'P'),
(48919, 'Lewisdale Estates', 39.5250015258789, 0.68984141348237, -77.4177780151367, -1.35119512594222, 218, 25, 'PPL', 'P'),
(103654, 'Lewisetta', 37.9977798461914, 0.663186366763985, -76.4630584716797, -1.33453212647575, 218, 53, 'PPL', 'P'),
(36867, 'Lewisport', 37.936939239502, 0.662124497858343, -86.9022216796875, -1.51672989560854, 218, 21, 'PPL', 'P'),
(3747, 'Lewiston', 33.040828704834, 0.576671248486807, -88.0202789306641, -1.53624367586388, 218, 2, 'PPL', 'P'),
(22645, 'Lewiston', 32.8963890075684, 0.574150300198938, -83.4022216796875, -1.45564337178874, 218, 13, 'PPL', 'P'),
(41785, 'Lewiston', 30.9411106109619, 0.54002425438504, -90.4222183227539, -1.5781654266892, 218, 22, 'PPL', 'P'),
(48920, 'Lewiston', 39.0286102294922, 0.681177750982178, -76.9602813720703, -1.34321030320389, 218, 25, 'PPL', 'P'),
(103655, 'Lewiston', 38.0686111450195, 0.664422606141999, -77.7425003051758, -1.35686259905801, 218, 53, 'PPL', 'P'),
(123046, 'Lewiston', 41.0269393920898, 0.716055174408129, -87.0458297729492, -1.51923632966847, 218, 19, 'PPL', 'P'),
(127935, 'Lewiston', 44.1002807617188, 0.769695100345905, -70.2152786254883, -1.22548779721997, 218, 26, 'PPL', 'P'),
(131758, 'Lewiston', 44.8838882446289, 0.783371630965953, -84.3055572509766, -1.47140955175812, 218, 27, 'PPL', 'P'),
(136487, 'Lewiston', 43.9844398498535, 0.767673295025344, -91.8691711425781, -1.60341951751615, 218, 28, 'PPL', 'P'),
(142226, 'Lewiston', 40.2433280944824, 0.702378577209054, -96.4033279418945, -1.68255548246591, 218, 35, 'PPL', 'P'),
(150249, 'Lewiston', 43.1725006103516, 0.753502281969896, -79.0361099243164, -1.37944034614749, 218, 40, 'PPL', 'P'),
(172195, 'Lewiston', 43.7038917541504, 0.762776807045125, -72.3005599975586, -1.2618828229931, 218, 55, 'PPL', 'P'),
(174962, 'Lewiston', 43.5805587768555, 0.760624240515041, -89.6355590820313, -1.56443563284735, 218, 57, 'PPL', 'P'),
(193735, 'Lewiston', 40.7075004577637, 0.710479913245075, -122.80638885498, -2.14337582800388, 218, 6, 'PPL', 'P'),
(195239, 'Lewiston', 46.4166717529297, 0.810123749906071, -117.016670227051, -2.04232617518246, 218, 17, 'PPL', 'P'),
(204687, 'Lewiston', 41.975830078125, 0.73261644112095, -111.855560302734, -1.95224781394578, 218, 52, 'PPL', 'P'),
(196901, 'Lewiston (historical)', 46.4638900756836, 0.810947865105396, -111.985557556152, -1.95451669403647, 218, 31, 'PPL', 'P'),
(22646, 'Lewiston Downs', 33.4927787780762, 0.584559265319512, -82.2033309936523, -1.43471878194594, 218, 13, 'PPL', 'P'),
(150250, 'Lewiston Heights', 43.165828704834, 0.753385835251233, -79.0283279418945, -1.37930452493189, 218, 40, 'PPL', 'P'),
(127936, 'Lewiston Junction', 44.0461082458496, 0.7687496115799, -70.2988891601563, -1.22694707633928, 218, 26, 'PPL', 'P'),
(195240, 'Lewiston Orchards', 46.3805618286133, 0.809493512834104, -116.97444152832, -2.04158914535078, 218, 17, 'PPL', 'P'),
(66341, 'Lewiston Woodville', 36.1227798461914, 0.630461443289091, -77.1769409179688, -1.34699172563569, 218, 33, 'PPL', 'P'),
(36868, 'Lewistown', 37.1427803039551, 0.648263809648916, -87.8005599975586, -1.53240885705222, 218, 21, 'PPL', 'P'),
(41786, 'Lewistown', 29.7383308410645, 0.519031787223949, -90.616943359375, -1.58156401971431, 218, 22, 'PPL', 'P'),
(48922, 'Lewistown', 38.8450012207031, 0.677973169242486, -75.9480590820313, -1.32554369148063, 218, 25, 'PPL', 'P'),
(103656, 'Lewistown', 37.7177810668945, 0.658299466163689, -77.4544372558594, -1.35183495039411, 218, 53, 'PPL', 'P'),
(120341, 'Lewistown', 40.3930587768555, 0.704991870607721, -90.1547164916992, -1.57349663898218, 218, 18, 'PPL', 'P'),
(139268, 'Lewistown', 40.086109161377, 0.699634589179891, -91.8130569458008, -1.60244014002527, 218, 29, 'PPL', 'P'),
(145601, 'Lewistown', 40.0061111450195, 0.698238360399389, -74.6486129760742, -1.30286407847946, 218, 37, 'PPL', 'P'),
(156125, 'Lewistown', 40.4222183227539, 0.705500800692036, -83.8847198486328, -1.46406455347168, 218, 41, 'PPL', 'P'),
(163759, 'Lewistown', 40.7324981689453, 0.710916205610657, -76.0283279418945, -1.32694464737206, 218, 45, 'PPL', 'P'),
(196902, 'Lewistown', 47.0625, 0.821395579219831, -109.42749786377, -1.90987012994184, 218, 31, 'PPL', 'P'),
(196903, 'Lewistown Heights', 47.0758285522461, 0.82162820634105, -109.452217102051, -1.91030156203843, 218, 31, 'PPL', 'P'),
(163760, 'Lewistown Junction', 40.5902786254883, 0.708434006316649, -77.5777816772461, -1.35398771666127, 218, 45, 'PPL', 'P'),
(196904, 'Lewistown Junction', 47.0536117553711, 0.821240450086334, -109.415832519531, -1.9096665312765, 218, 31, 'PPL', 'P'),
(10065, 'Lewisville', 33.3583297729492, 0.582212687504016, -93.5774993896484, -1.63323547013235, 218, 4, 'PPL', 'P'),
(30330, 'Lewisville', 39.4711112976074, 0.688900851564381, -86.6319427490234, -1.51201263836969, 218, 19, 'PPL', 'P'),
(66342, 'Lewisville', 36.0969390869141, 0.630010436958486, -80.4194412231445, -1.40358403195793, 218, 33, 'PPL', 'P'),
(73210, 'Lewisville', 39.7652816772461, 0.694035093250917, -81.2186126708984, -1.41753220500916, 218, 41, 'PPL', 'P'),
(76381, 'Lewisville', 35.1199989318848, 0.612959614658281, -95.2766723632813, -1.66289163308314, 218, 42, 'PPL', 'P'),
(95695, 'Lewisville', 30.0686092376709, 0.524796232692939, -96.1138916015625, -1.67750386535219, 218, 51, 'PPL', 'P'),
(103657, 'Lewisville', 39.1977806091309, 0.684130331103722, -77.9499969482422, -1.36048409866636, 218, 53, 'PPL', 'P'),
(131759, 'Lewisville', 43.9444389343262, 0.76697514734558, -82.8349990844727, -1.44574346991054, 218, 27, 'PPL', 'P'),
(136489, 'Lewisville', 43.9233283996582, 0.766606699008767, -94.4372177124023, -1.64824038550413, 218, 28, 'PPL', 'P'),
(145602, 'Lewisville', 40.288890838623, 0.703173797110552, -74.7263870239258, -1.30422149168707, 218, 37, 'PPL', 'P'),
(163761, 'Lewisville', 40.5105590820313, 0.707042637805137, -79.3213882446289, -1.3844193921215, 218, 45, 'PPL', 'P'),
(195241, 'Lewisville', 43.6958312988281, 0.762636125560541, -112.009719848633, -1.95493840559509, 218, 17, 'PPL', 'P'),
(201127, 'Lewisville', 44.788330078125, 0.78170382633329, -123.344169616699, -2.15276187294975, 218, 43, 'PPL', 'P'),
(207917, 'Lewisville', 45.810001373291, 0.799535354307052, -122.521942138672, -2.13841129625781, 218, 56, 'PPL', 'P'),
(82081, 'Lewisville (historical)', 34.0263900756836, 0.593872539388601, -79.0777816772461, -1.38016765544119, 218, 48, 'PPL', 'P'),
(156126, 'Lewisville (historical)', 41.0511093139648, 0.716477019124797, -83.7897186279297, -1.462406469377, 218, 41, 'PPL', 'P'),
(22647, 'Lewner', 34.9488906860352, 0.609973212390893, -84.1577835083008, -1.46883041340043, 218, 13, 'PPL', 'P'),
(66345, 'Lewters Crossroad', 36.5038909912109, 0.637113087585727, -77.2566680908203, -1.34838322730526, 218, 33, 'PPL', 'P'),
(110092, 'Lex', 37.3702812194824, 0.65223444967617, -81.8005599975586, -1.42768910193256, 218, 58, 'PPL', 'P'),
(10073, 'Lexa', 34.5977783203125, 0.603845145564566, -90.7522201538086, -1.58392504517871, 218, 4, 'PPL', 'P'),
(10066, 'Lexa Junction', 34.5988883972168, 0.603864520061497, -90.7680587768555, -1.58420148129987, 218, 4, 'PPL', 'P'),
(36869, 'Lexie', 37.728889465332, 0.658493344291047, -83.4038925170898, -1.45567253340268, 218, 21, 'PPL', 'P'),
(60623, 'Lexie', 31.0786094665527, 0.542424062132824, -90.1708297729492, -1.57377786879329, 218, 30, 'PPL', 'P'),
(88534, 'Lexie', 35.1480598449707, 0.613449369982746, -86.3013916015625, -1.50624343250025, 218, 50, 'PPL', 'P'),
(88535, 'Lexie Crossroads', 35.1408309936523, 0.613323202726104, -86.2858276367188, -1.50597179006906, 218, 50, 'PPL', 'P'),
(82082, 'Lexing-Town Estates', 33.9633293151855, 0.592771921489099, -81.2769393920898, -1.41855019833585, 218, 48, 'PPL', 'P'),
(3748, 'Lexington', 34.9691696166992, 0.610327146499765, -87.3711090087891, -1.52491352332225, 218, 2, 'PPL', 'P'),
(22648, 'Lexington', 33.8697204589844, 0.591138138739362, -83.1119384765625, -1.45057697413098, 218, 13, 'PPL', 'P'),
(33035, 'Lexington', 37.2938919067383, 0.650901204655449, -99.5991668701172, -1.7383333941268, 218, 20, 'PPL', 'P'),
(36870, 'Lexington', 37.9886093139648, 0.663026310782471, -84.477783203125, -1.47441546168049, 218, 21, 'PPL', 'P'),
(55879, 'Lexington', 39.1847190856934, 0.683902364514411, -93.8797225952148, -1.63851026014541, 218, 29, 'PPL', 'P'),
(60624, 'Lexington', 33.1130599975586, 0.577931922367823, -90.0530624389648, -1.57172244106397, 218, 30, 'PPL', 'P'),
(66346, 'Lexington', 35.8238906860352, 0.625244843345844, -80.2536087036133, -1.40068970848523, 218, 33, 'PPL', 'P'),
(76382, 'Lexington', 35.014720916748, 0.611122166664181, -97.3352813720703, -1.69882113829773, 218, 42, 'PPL', 'P'),
(82083, 'Lexington', 33.9813919067383, 0.593087173183137, -81.2363891601563, -1.41784246327616, 218, 48, 'PPL', 'P'),
(88536, 'Lexington', 35.6508293151855, 0.622224352616503, -88.3933334350586, -1.54275470525496, 218, 50, 'PPL', 'P'),
(95696, 'Lexington', 30.4188899993896, 0.530909785291325, -97.0113906860352, -1.69316817940987, 218, 51, 'PPL', 'P'),
(103659, 'Lexington', 37.7838897705078, 0.659453280705966, -79.4430618286133, -1.38654299677473, 218, 53, 'PPL', 'P'),
(116467, 'Lexington', 41.3977813720703, 0.722527587963403, -91.8069381713867, -1.60233334726556, 218, 16, 'PPL', 'P'),
(120343, 'Lexington', 40.6413917541504, 0.709326098702798, -88.783332824707, -1.5495614786851, 218, 18, 'PPL', 'P'),
(123047, 'Lexington', 40.4588890075684, 0.706140824881009, -86.4888916015625, -1.50951592484774, 218, 19, 'PPL', 'P'),
(125235, 'Lexington', 42.4472198486328, 0.740843744676532, -71.2249984741211, -1.24311073310135, 218, 23, 'PPL', 'P'),
(127938, 'Lexington', 44.9986114501953, 0.785373928631529, -70.0541687011719, -1.22267589858301, 218, 26, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(131760, 'Lexington', 43.2680587768555, 0.755170086602558, -82.5308303833008, -1.44043472459357, 218, 27, 'PPL', 'P'),
(136492, 'Lexington', 44.4425010681152, 0.775667971459708, -93.7022171020508, -1.63541220484933, 218, 28, 'PPL', 'P'),
(142227, 'Lexington', 40.7808303833008, 0.71175976188594, -99.7411117553711, -1.74081079973085, 218, 35, 'PPL', 'P'),
(150252, 'Lexington', 42.2402801513672, 0.737231965606166, -74.3658294677734, -1.29792857518927, 218, 40, 'PPL', 'P'),
(156128, 'Lexington', 40.9619407653809, 0.714920734362782, -81.1047210693359, -1.41554442157153, 218, 41, 'PPL', 'P'),
(163762, 'Lexington', 40.1883316040039, 0.701418707373162, -76.3000030517578, -1.3316862725349, 218, 45, 'PPL', 'P'),
(201128, 'Lexington', 45.4452781677246, 0.79316973351149, -119.683326721191, -2.0888681110249, 218, 43, 'PPL', 'P'),
(207918, 'Lexington', 46.1875, 0.806123948264881, -122.904167175293, -2.1450823816304, 218, 56, 'PPL', 'P'),
(27711, 'Lexington (historical)', 38.415828704834, 0.670482695781502, -87.9641723632813, -1.53526443153106, 218, 18, 'PPL', 'P'),
(55880, 'Lexington (historical)', 39.0291709899902, 0.681187538099184, -92.496940612793, -1.6143761617149, 218, 29, 'PPL', 'P'),
(163763, 'Lexington (historical)', 41.9294395446777, 0.731806773570538, -80.3808288574219, -1.40291011904408, 218, 45, 'PPL', 'P'),
(182788, 'Lexington (historical)', 37.1963882446289, 0.649199444718888, -121.98722076416, -2.12907864769179, 218, 6, 'PPL', 'P'),
(22649, 'Lexington Creek', 33.5136108398438, 0.584922853387336, -84.3883285522461, -1.47285418349143, 218, 13, 'PPL', 'P'),
(22650, 'Lexington Estates', 33.9069404602051, 0.59178775030826, -83.320556640625, -1.45421804797333, 218, 13, 'PPL', 'P'),
(103660, 'Lexington Estates', 38.9952812194824, 0.680596050021078, -77.3088912963867, -1.34929469418834, 218, 53, 'PPL', 'P'),
(110093, 'Lexington Estates', 38.4111099243164, 0.670400337524791, -81.9833297729492, -1.43087903628626, 218, 58, 'PPL', 'P'),
(22651, 'Lexington Heights', 33.9425010681152, 0.592408400000303, -83.341667175293, -1.45458649631014, 218, 13, 'PPL', 'P'),
(131761, 'Lexington Heights', 43.2249984741211, 0.754418542542938, -82.5247192382813, -1.44032806499191, 218, 27, 'PPL', 'P'),
(182789, 'Lexington Hills', 37.1647186279297, 0.648646705634642, -121.971939086914, -2.12881193210862, 218, 6, 'PPL', 'P'),
(36871, 'Lexington Manor', 38.0430603027344, 0.663976659817466, -84.4697189331055, -1.47427471361688, 218, 21, 'PPL', 'P'),
(14124, 'Lexington Mill', 39.038330078125, 0.681347394343616, -75.5094375610352, -1.31788830176914, 218, 10, 'PPL', 'P'),
(48923, 'Lexington Park', 38.2666702270508, 0.667879389236922, -76.4541702270508, -1.33437699734226, 218, 25, 'PPL', 'P'),
(163764, 'Lexington Park', 40.0533294677734, 0.699062475598714, -75.0466690063477, -1.30981146681515, 218, 45, 'PPL', 'P'),
(41787, 'Lexington Place', 29.937219619751, 0.522503051257299, -89.9180603027344, -1.56936620928952, 218, 22, 'PPL', 'P'),
(82085, 'Lexington Place', 34.5633316040039, 0.603243936948481, -82.6977767944336, -1.44334848914223, 218, 48, 'PPL', 'P'),
(178531, 'Lexington Place', 33.6375007629395, 0.587085140455398, -112.199996948242, -1.95825936747442, 218, 5, 'PPL', 'P'),
(204690, 'Lexington Village Old Farm Condominium', 40.6813888549805, 0.710024179803535, -111.870826721191, -1.95251426321284, 218, 52, 'PPL', 'P'),
(36872, 'Lexington-Fayette', 38.0497207641602, 0.664092906799048, -84.458610534668, -1.47408083548952, 218, 21, 'PPL', 'P'),
(196905, 'Lexley Acres Mobile Home Park', 45.7630615234375, 0.798716099376717, -111.183326721191, -1.94051512460538, 218, 31, 'PPL', 'P'),
(22652, 'Lexsy', 32.4683303833008, 0.566679267813911, -82.2975006103516, -1.43636235181268, 218, 13, 'PPL', 'P'),
(156131, 'Leyda', 40.6711082458496, 0.709844749325091, -81.1344375610352, -1.41606307219382, 218, 41, 'PPL', 'P'),
(125237, 'Leyden', 42.7000007629395, 0.745255603917384, -72.6305618286133, -1.26764244148262, 218, 23, 'PPL', 'P'),
(140394, 'Leyden', 48.8766708374023, 0.853058833526165, -97.8105621337891, -1.70711635246111, 218, 34, 'PPL', 'P'),
(174964, 'Leyden', 42.7308311462402, 0.745793695615635, -89.1288909912109, -1.55559260644774, 218, 57, 'PPL', 'P'),
(186979, 'Leyden', 39.8447189331055, 0.695421534914413, -105.183609008789, -1.83580029633374, 218, 7, 'PPL', 'P'),
(186980, 'Leyden Junction', 39.8461112976074, 0.69544583625936, -105.14778137207, -1.83517498610979, 218, 7, 'PPL', 'P'),
(3749, 'Leydens Mill', 33.8019409179688, 0.589955162583149, -85.8380584716797, -1.49815674385022, 218, 2, 'PPL', 'P'),
(194289, 'Leyner', 40.0497207641602, 0.698999491838934, -105.101936340332, -1.83437483936027, 218, 7, 'PPL', 'P'),
(73211, 'Liars Corner', 39.3997192382813, 0.68765482506936, -82.1044387817383, -1.43299278724345, 218, 41, 'PPL', 'P'),
(190998, 'Libbey', 36.9372215270996, 0.644676132186416, -101.97444152832, -1.77978975755163, 218, 42, 'PPL', 'P'),
(136495, 'Libby', 46.7841682434082, 0.816537773654445, -93.3249969482422, -1.62882847116049, 218, 28, 'PPL', 'P'),
(196906, 'Libby', 48.3883285522461, 0.844535652773475, -115.555000305176, -2.01681522246837, 218, 31, 'PPL', 'P'),
(201129, 'Libby', 43.3377799987793, 0.756386951483643, -124.232780456543, -2.16827105787394, 218, 43, 'PPL', 'P'),
(10067, 'Libby (historical)', 35.4561080932617, 0.618825826170426, -91.9505615234375, -1.6048400476416, 218, 4, 'PPL', 'P'),
(127939, 'Libby Corner', 45.3213882446289, 0.791007446443428, -68.4858322143555, -1.1953032631089, 218, 26, 'PPL', 'P'),
(127940, 'Libby Hill', 44.1824989318848, 0.771130078120267, -69.8261108398438, -1.21869553801778, 218, 26, 'PPL', 'P'),
(127941, 'Libbytown', 43.6558303833008, 0.761937977880777, -70.2861099243164, -1.22672403659798, 218, 26, 'PPL', 'P'),
(211968, 'Libbyville', 58.7777786254883, 1.02586576402312, -157.05305480957, -2.74109290674212, 218, 1, 'PPL', 'P'),
(123048, 'Liber', 40.4080581665039, 0.705253659342876, -84.9694366455078, -1.48299643302884, 218, 19, 'PPL', 'P'),
(30333, 'Liberal', 38.0458297729492, 0.664024996191251, -86.9430618286133, -1.5174426906743, 218, 19, 'PPL', 'P'),
(55884, 'Liberal', 37.5580596923828, 0.655511802292649, -94.5197219848633, -1.64968035670553, 218, 29, 'PPL', 'P'),
(187765, 'Liberal', 37.0430603027344, 0.646523367297522, -100.920562744141, -1.76139610285078, 218, 20, 'PPL', 'P'),
(201130, 'Liberal', 45.1930618286133, 0.788767727966671, -122.584442138672, -2.1395021270403, 218, 43, 'PPL', 'P'),
(66348, 'Liberia', 36.3563919067383, 0.634538742918002, -78.0966720581055, -1.3630440622642, 218, 33, 'PPL', 'P'),
(82087, 'Liberia', 35.0138893127441, 0.61110765243624, -82.6319427490234, -1.44219946828991, 218, 48, 'PPL', 'P'),
(113637, 'Liberia (historical)', 41.3066711425781, 0.720937414476516, -72.9105606079102, -1.27252934208291, 218, 8, 'PPL', 'P'),
(3758, 'Liberty', 34.107780456543, 0.595293069514049, -86.5158309936523, -1.50998610593819, 218, 2, 'PPL', 'P'),
(10071, 'Liberty', 35.0275001525879, 0.611345206405475, -94.230827331543, -1.64463819381369, 218, 4, 'PPL', 'P'),
(14108, 'Liberty', 39.7286109924316, 0.693395069061944, -75.6175003051758, -1.31977435245313, 218, 10, 'PPL', 'P'),
(16890, 'Liberty', 30.8202800750732, 0.537915363696833, -86.2136077880859, -1.50471131592513, 218, 12, 'PPL', 'P'),
(22654, 'Liberty', 33.4213905334473, 0.583313305403519, -83.1372222900391, -1.4510182599236, 218, 13, 'PPL', 'P'),
(27713, 'Liberty', 37.7200012207031, 0.65833821515755, -88.5716705322266, -1.54586727477899, 218, 18, 'PPL', 'P'),
(30334, 'Liberty', 39.6355590820313, 0.691771006850187, -84.9311065673828, -1.48232744696301, 218, 19, 'PPL', 'P'),
(33038, 'Liberty', 37.1555595397949, 0.648486849390211, -95.5944366455078, -1.66843766605323, 218, 20, 'PPL', 'P'),
(36876, 'Liberty', 36.764720916748, 0.641665428574081, -84.2041702270508, -1.46964001437182, 218, 21, 'PPL', 'P'),
(41789, 'Liberty', 32.0724983215332, 0.559770695051109, -93.1972198486328, -1.62659834006365, 218, 22, 'PPL', 'P'),
(55883, 'Liberty', 39.2461090087891, 0.684973820799977, -94.4188919067383, -1.64792053985721, 218, 29, 'PPL', 'P'),
(60629, 'Liberty', 32.9847183227539, 0.575691937574957, -89.1694412231445, -1.55630034150743, 218, 30, 'PPL', 'P'),
(66351, 'Liberty', 35.5811080932617, 0.621007487735419, -80.3358306884766, -1.40212475283862, 218, 33, 'PPL', 'P'),
(73212, 'Liberty', 39.7200012207031, 0.693244800197436, -84.3249969482422, -1.471748838481, 218, 41, 'PPL', 'P'),
(76388, 'Liberty', 35.8586082458496, 0.625850779072864, -95.9772186279297, -1.67511847196381, 218, 42, 'PPL', 'P'),
(82088, 'Liberty', 34.7877807617188, 0.607161313753933, -82.692497253418, -1.44325634376851, 218, 48, 'PPL', 'P'),
(88551, 'Liberty', 36.2133293151855, 0.632041829658971, -88.7083282470703, -1.54825240185127, 218, 50, 'PPL', 'P'),
(103666, 'Liberty', 37.0566711425781, 0.646760921266757, -81.654167175293, -1.42513406518274, 218, 53, 'PPL', 'P'),
(110095, 'Liberty', 38.6049995422363, 0.673784349742928, -81.7300033569336, -1.42645765624451, 218, 58, 'PPL', 'P'),
(116469, 'Liberty', 41.1452789306641, 0.71812058899154, -93.6538925170898, -1.6345687817321, 218, 16, 'PPL', 'P'),
(127942, 'Liberty', 44.3891716003418, 0.774737196658725, -69.3033294677734, -1.20957128180706, 218, 26, 'PPL', 'P'),
(131763, 'Liberty', 42.1022186279297, 0.734822337451863, -84.4005584716797, -1.4730676358528, 218, 27, 'PPL', 'P'),
(142229, 'Liberty', 40.0847206115723, 0.699610354413971, -96.4824981689453, -1.6839372635975, 218, 35, 'PPL', 'P'),
(150254, 'Liberty', 41.8011093139648, 0.729566988514755, -74.746940612793, -1.30458021948591, 218, 40, 'PPL', 'P'),
(163769, 'Liberty', 41.5583305358887, 0.725329699483357, -77.1050033569336, -1.34573617833977, 218, 45, 'PPL', 'P'),
(169461, 'Liberty', 41.5400009155273, 0.725009787257411, -71.5738906860352, -1.24920005093382, 218, 47, 'PPL', 'P'),
(174965, 'Liberty', 43.5163917541504, 0.759504314697635, -90.73388671875, -1.58360506637374, 218, 57, 'PPL', 'P'),
(178534, 'Liberty', 33.377498626709, 0.582547247115958, -112.486106872559, -1.96325292767637, 218, 5, 'PPL', 'P'),
(182790, 'Liberty', 38.2844390869141, 0.668189514345862, -122.700828552246, -2.14153345316176, 218, 6, 'PPL', 'P'),
(191764, 'Liberty', 33.6938896179199, 0.588069311636237, -101.766670227051, -1.77616346425332, 218, 51, 'PPL', 'P'),
(194288, 'Liberty', 40.2061080932617, 0.701728965640156, -105.008613586426, -1.83274605003758, 218, 7, 'PPL', 'P'),
(195243, 'Liberty', 43.1688919067383, 0.753439298210116, -112.554443359375, -1.96444562437056, 218, 17, 'PPL', 'P'),
(201132, 'Liberty', 44.8883285522461, 0.783449128953674, -123.059173583984, -2.14778775382376, 218, 43, 'PPL', 'P'),
(204691, 'Liberty', 41.333610534668, 0.72140759556697, -111.862777709961, -1.95237378146534, 218, 52, 'PPL', 'P'),
(207920, 'Liberty', 46.3558311462402, 0.809061881000429, -120.144996643066, -2.09692577121904, 218, 56, 'PPL', 'P'),
(10072, 'Liberty (historical)', 36.2472190856934, 0.632633317737078, -94.1547164916992, -1.64330980906196, 218, 4, 'PPL', 'P'),
(190411, 'Liberty (historical)', 38.3063888549805, 0.66857261006867, -117.293891906738, -2.04716460625091, 218, 39, 'PPL', 'P'),
(186983, 'Liberty Bell', 37.9352798461914, 0.662095535981488, -107.794998168945, -1.88137763522935, 218, 7, 'PPL', 'P'),
(204694, 'Liberty Bell Ranchettes', 41.3569412231445, 0.721814792897643, -111.869720458984, -1.95249495529494, 218, 52, 'PPL', 'P'),
(116470, 'Liberty Center', 41.204719543457, 0.71915802339418, -93.4986114501953, -1.63185861584878, 218, 16, 'PPL', 'P'),
(123049, 'Liberty Center', 40.6991691589355, 0.710334504649557, -85.2805633544922, -1.48842661849151, 218, 19, 'PPL', 'P'),
(156132, 'Liberty Center', 41.4433288574219, 0.723322541548791, -84.0088882446289, -1.46623170080873, 218, 41, 'PPL', 'P'),
(196907, 'Liberty Center (historical)', 47.9272193908691, 0.836487779696338, -111.984718322754, -1.95450204665048, 218, 31, 'PPL', 'P'),
(60630, 'Liberty Chapel', 33.1936111450195, 0.579337805107276, -89.4847183227539, -1.56180296495175, 218, 30, 'PPL', 'P'),
(3757, 'Liberty City', 32.5811080932617, 0.568647610175589, -85.7491683959961, -1.4966053193572, 218, 2, 'PPL', 'P'),
(22655, 'Liberty City', 32.0475006103516, 0.559334402685527, -81.1377792358398, -1.41612139542169, 218, 13, 'PPL', 'P'),
(95705, 'Liberty City', 32.4452781677246, 0.566276930752227, -94.9483337402344, -1.65716104304951, 218, 51, 'PPL', 'P'),
(127943, 'Liberty Corner', 44.0191688537598, 0.768279430489446, -70.8594436645508, -1.23673059807785, 218, 26, 'PPL', 'P'),
(145603, 'Liberty Corner', 40.6647186279297, 0.709733229454444, -74.5777816772461, -1.30162783910144, 218, 37, 'PPL', 'P'),
(123050, 'Liberty Corners', 40.1933288574219, 0.701505925898862, -85.3300018310547, -1.48928948268469, 218, 19, 'PPL', 'P'),
(131764, 'Liberty Corners', 41.7497215270996, 0.728670102438643, -83.5872192382813, -1.45887218829435, 218, 27, 'PPL', 'P'),
(174966, 'Liberty Corners', 42.5208282470703, 0.742128453586386, -88.0991668701172, -1.53762053014745, 218, 57, 'PPL', 'P'),
(3767, 'Liberty Crossroads', 32.8016700744629, 0.572497142952271, -85.413330078125, -1.49074383495599, 218, 2, 'PPL', 'P'),
(41791, 'Liberty Farms', 30.541109085083, 0.533042910745452, -91.1433334350586, -1.59075125968481, 218, 22, 'PPL', 'P'),
(48925, 'Liberty Forest', 39.5094413757324, 0.689569837630209, -77.2666702270508, -1.34855779751471, 218, 25, 'PPL', 'P'),
(103667, 'Liberty Fork', 38.0466690063477, 0.664039643577246, -77.1761093139648, -1.34697721140775, 218, 53, 'PPL', 'P'),
(150255, 'Liberty Gardens', 43.2222213745117, 0.754370073011099, -75.4749984741211, -1.31728722631111, 218, 40, 'PPL', 'P'),
(3759, 'Liberty Grove', 33.353328704834, 0.582125402399289, -85.429443359375, -1.4910250647671, 218, 2, 'PPL', 'P'),
(48926, 'Liberty Grove', 39.6558303833008, 0.692124807801004, -76.1202774047852, -1.32854946824495, 218, 25, 'PPL', 'P'),
(88552, 'Liberty Grove', 35.041389465332, 0.611587620643699, -87.383056640625, -1.5251220488356, 218, 50, 'PPL', 'P'),
(95708, 'Liberty Grove', 33.3311080932617, 0.581737579565546, -95.6969375610352, -1.6702266445155, 218, 51, 'PPL', 'P'),
(88553, 'Liberty Hall', 35.7680587768555, 0.624270392702984, -89.0361099243164, -1.55397327134692, 218, 50, 'PPL', 'P'),
(36877, 'Liberty Heights', 38.038890838623, 0.663903888940679, -84.4658279418945, -1.47420680300909, 218, 21, 'PPL', 'P'),
(48927, 'Liberty Heights', 39.1713905334473, 0.683669737393193, -77.2752838134766, -1.34870813295825, 218, 25, 'PPL', 'P'),
(125239, 'Liberty Heights', 42.1227798461914, 0.735181198408751, -72.595832824707, -1.26703630601851, 218, 23, 'PPL', 'P'),
(3760, 'Liberty Highlands', 33.5638885498047, 0.585800364966517, -86.6547164916992, -1.51241011516238, 218, 2, 'PPL', 'P'),
(3765, 'Liberty Hill', 33.170280456543, 0.578930607776603, -86.1994400024414, -1.50446404141791, 218, 2, 'PPL', 'P'),
(22658, 'Liberty Hill', 31.4008293151855, 0.548047859406744, -83.9397201538086, -1.4650244898866, 218, 13, 'PPL', 'P'),
(27714, 'Liberty Hill', 39.2011108398438, 0.684188454594513, -88.154167175293, -1.53858046656237, 218, 18, 'PPL', 'P'),
(41793, 'Liberty Hill', 32.6291694641113, 0.569486439339936, -92.8036117553711, -1.61972858287374, 218, 22, 'PPL', 'P'),
(66352, 'Liberty Hill', 35.3363914489746, 0.616736376558177, -79.9961090087891, -1.39619549098767, 218, 33, 'PPL', 'P'),
(82091, 'Liberty Hill', 33.9186096191406, 0.591991415552624, -82.1738891601563, -1.4342049250136, 218, 48, 'PPL', 'P'),
(88564, 'Liberty Hill', 36.0433311462402, 0.629074801888514, -86.0630569458008, -1.5020837080356, 218, 50, 'PPL', 'P'),
(95713, 'Liberty Hill', 30.6647205352783, 0.535200337544525, -97.9222183227539, -1.70906512058878, 218, 51, 'PPL', 'P'),
(103669, 'Liberty Hill', 36.8308296203613, 0.642819243116358, -80.6975021362305, -1.40843711041238, 218, 53, 'PPL', 'P'),
(110096, 'Liberty Hill', 38.7902793884277, 0.677018093096556, -81.168327331543, -1.41665456027193, 218, 58, 'PPL', 'P'),
(113638, 'Liberty Hill', 41.6655616760254, 0.72720123593941, -72.2552795410156, -1.26109252993962, 218, 8, 'PPL', 'P'),
(60631, 'Liberty Hill (historical)', 33.211109161377, 0.579643203105281, -89.3897171020508, -1.56014488085707, 218, 30, 'PPL', 'P'),
(66353, 'Liberty Hill (historical)', 35.8636093139648, 0.625938064177591, -80.9677810668945, -1.41315436765124, 218, 33, 'PPL', 'P'),
(110097, 'Liberty Hills', 39.3325004577637, 0.686481636030153, -81.4372177124023, -1.42134758274487, 218, 58, 'PPL', 'P'),
(123051, 'Liberty Hills', 41.0333290100098, 0.716166694278776, -85.2663879394531, -1.48817921082624, 218, 19, 'PPL', 'P'),
(48928, 'Liberty Knolls', 39.4833297729492, 0.689114104188669, -77.2302780151367, -1.34792263359473, 218, 25, 'PPL', 'P'),
(207921, 'Liberty Lake', 47.6483306884766, 0.831620253592973, -117.09139251709, -2.04363032516827, 218, 56, 'PPL', 'P'),
(48929, 'Liberty Lake Hills', 39.4041709899902, 0.687732522794163, -76.9044418334961, -1.34223571940297, 218, 25, 'PPL', 'P'),
(103670, 'Liberty Land', 37.297779083252, 0.650969048684219, -79.9372177124023, -1.39516764396495, 218, 53, 'PPL', 'P'),
(48931, 'Liberty Manor', 39.4099998474121, 0.687834255547804, -76.9097213745117, -1.34232786477669, 218, 25, 'PPL', 'P'),
(204695, 'Liberty Meadows', 41.3238906860352, 0.721237952205532, -111.866943359375, -1.9524464857631, 218, 52, 'PPL', 'P'),
(103671, 'Liberty Mills', 38.2308311462402, 0.66725387927589, -78.2200012207031, -1.36519656221525, 218, 53, 'PPL', 'P'),
(123052, 'Liberty Mills', 41.0336112976074, 0.716171621126792, -85.7358322143555, -1.49637255907792, 218, 19, 'PPL', 'P'),
(113639, 'Liberty Mobile Home Park', 41.6783294677734, 0.727424075943622, -72.8488922119141, -1.27145302552836, 218, 8, 'PPL', 'P'),
(178532, 'Liberty Mobile Home Park', 33.667781829834, 0.587613644773724, -112.024436950684, -1.95519526748223, 218, 5, 'PPL', 'P'),
(82093, 'Liberty Park', 34.877498626709, 0.608727185895872, -82.3574981689453, -1.4374095067533, 218, 48, 'PPL', 'P'),
(123053, 'Liberty Park', 41.4324989318848, 0.723133523690423, -87.3686065673828, -1.52486984748037, 218, 19, 'PPL', 'P'),
(182792, 'Liberty Park', 33.7063903808594, 0.588287491108542, -117.986938476563, -2.059260550764, 218, 6, 'PPL', 'P'),
(125240, 'Liberty Plain', 42.1888885498047, 0.736335012951028, -70.8833312988281, -1.2371475159465, 218, 23, 'PPL', 'P'),
(16892, 'Liberty Point', 26.8111095428467, 0.467942137635546, -80.9863891601563, -1.41347914014617, 218, 12, 'PPL', 'P'),
(174968, 'Liberty Pole', 43.4900016784668, 0.759043720987106, -90.9086074829102, -1.58665451897994, 218, 57, 'PPL', 'P'),
(36878, 'Liberty Road', 37.9055595397949, 0.661576818780168, -83.2927780151367, -1.45373321949688, 218, 21, 'PPL', 'P'),
(10074, 'Liberty Springs (historical)', 35.4936103820801, 0.61948036458734, -92.7233276367188, -1.61832736066619, 218, 4, 'PPL', 'P'),
(16893, 'Liberty Square', 25.8313903808594, 0.450842812513988, -80.2169418334961, -1.40004975087528, 218, 12, 'PPL', 'P'),
(145604, 'Liberty Square', 40.6500015258789, 0.709476367567306, -74.1941680908203, -1.29493251896293, 218, 37, 'PPL', 'P'),
(48932, 'Liberty Trailer Park', 39.2999992370605, 0.685914382717966, -76.5041732788086, -1.33524971523148, 218, 25, 'PPL', 'P'),
(10075, 'Liberty Valley', 35.2775001525879, 0.615708529535461, -91.5355606079102, -1.59759691526685, 218, 4, 'PPL', 'P'),
(22659, 'Liberty View', 32.7272186279297, 0.571197720077394, -83.6875, -1.46062241776275, 218, 13, 'PPL', 'P'),
(48933, 'Liberty View Farms', 39.4855613708496, 0.689153052919611, -76.8888931274414, -1.34196434328789, 218, 25, 'PPL', 'P'),
(178533, 'Liberty Village', 33.4963912963867, 0.58462231565832, -112.276107788086, -1.95958775222615, 218, 5, 'PPL', 'P'),
(150257, 'Libertypole', 42.6488914489746, 0.744363578110262, -77.6341705322266, -1.35497188784211, 218, 40, 'PPL', 'P'),
(48935, 'Libertytown', 38.3188896179199, 0.668790789540975, -75.2988891601563, -1.31421353893899, 218, 25, 'PPL', 'P'),
(3766, 'Libertyville', 31.2413902282715, 0.54526512238372, -86.4613876342773, -1.50903589006125, 218, 2, 'PPL', 'P'),
(30341, 'Libertyville', 39.6027793884277, 0.69119889326901, -87.5186080932617, -1.52748786798997, 218, 19, 'PPL', 'P'),
(55902, 'Libertyville', 37.7036094665527, 0.658052125077448, -90.2880630493164, -1.5758239754588, 218, 29, 'PPL', 'P'),
(116492, 'Libertyville', 40.9575004577637, 0.714843236375061, -92.0511093139648, -1.60659493764191, 218, 16, 'PPL', 'P'),
(120346, 'Libertyville', 42.2830581665039, 0.73797858281777, -87.9530563354492, -1.53507042024565, 218, 18, 'PPL', 'P'),
(145606, 'Libertyville', 41.2397193908691, 0.719768885969217, -74.6547164916992, -1.30297060492306, 218, 37, 'PPL', 'P'),
(150258, 'Libertyville', 41.7222213745117, 0.728190134231184, -74.1355590820313, -1.29390959878823, 218, 40, 'PPL', 'P'),
(163779, 'Library', 40.2897186279297, 0.703188244759465, -80.0100021362305, -1.39643797180492, 218, 45, 'PPL', 'P'),
(163780, 'Library Junction', 40.2874984741211, 0.703149495765605, -80.054443359375, -1.3972136174724, 218, 45, 'PPL', 'P'),
(112376, 'Libuse', 31.353889465332, 0.547228604476408, -92.3333282470703, -1.61152058723606, 218, 22, 'PPL', 'P'),
(207922, 'Lichty', 46.292781829834, 0.807961462838008, -119.951942443848, -2.09355633980788, 218, 56, 'PPL', 'P'),
(156150, 'Lichtys Parcels', 41.1777801513672, 0.718687842303726, -84.7630615234375, -1.47939450765451, 218, 41, 'PPL', 'P'),
(182793, 'Lick', 37.2872200012207, 0.650784757936785, -121.844718933105, -2.12659152154976, 218, 6, 'PPL', 'P'),
(10087, 'Lick Branch', 36.3300018310547, 0.634078149207473, -93.2286071777344, -1.62714615229988, 218, 4, 'PPL', 'P'),
(36879, 'Lick Creek', 37.3802795410156, 0.652408953306597, -82.2972183227539, -1.43635742496466, 218, 21, 'PPL', 'P'),
(88566, 'Lick Creek', 36.3211097717285, 0.633922953494949, -88.0219421386719, -1.53627270431976, 218, 50, 'PPL', 'P'),
(110098, 'Lick Creek', 37.4844398498535, 0.654226893645713, -80.9116668701172, -1.41217499016036, 218, 58, 'PPL', 'P'),
(112295, 'Lick Creek', 37.5224990844727, 0.654891152600606, -89.0749969482422, -1.55465197795073, 218, 18, 'PPL', 'P'),
(88567, 'Lick Creek (historical)', 35.8452796936035, 0.625618151951646, -87.2463912963867, -1.52273678860527, 218, 50, 'PPL', 'P'),
(36880, 'Lick Fork', 38.0963897705078, 0.664907434618448, -83.4111099243164, -1.45579850092224, 218, 21, 'PPL', 'P'),
(110100, 'Lick Fork', 37.9716682434082, 0.662730633322445, -81.2569427490234, -1.41820119107499, 218, 58, 'PPL', 'P'),
(10090, 'Lick Mountain', 35.3597183227539, 0.617143507309823, -92.6324996948242, -1.61674211402733, 218, 4, 'PPL', 'P'),
(88568, 'Lick Skillet', 35.4905586242676, 0.619427101365538, -88.2058334350586, -1.53948221290747, 218, 50, 'PPL', 'P'),
(103672, 'Lick Skillet', 36.8941688537598, 0.64392472128485, -81.791389465332, -1.42752904595105, 218, 53, 'PPL', 'P'),
(150261, 'Lick Springs', 43.1827812194824, 0.75368171244834, -73.51611328125, -1.28309823002694, 218, 40, 'PPL', 'P'),
(36881, 'Lickburg', 37.792781829834, 0.65960847641849, -83.0852813720703, -1.45011171988854, 218, 21, 'PPL', 'P'),
(163781, 'Lickdale', 40.4500007629395, 0.705985695747512, -76.5122222900391, -1.33539019697898, 218, 45, 'PPL', 'P'),
(55904, 'Licking', 37.499439239502, 0.654488682380868, -91.8569412231445, -1.60320606515478, 218, 29, 'PPL', 'P'),
(36882, 'Licking River', 37.9372215270996, 0.662129424706359, -83.3063888549805, -1.45397077346612, 218, 21, 'PPL', 'P'),
(73223, 'Licking View', 39.9538917541504, 0.697326960095337, -82.033332824707, -1.43175175417548, 218, 41, 'PPL', 'P'),
(163782, 'Lickingville', 41.3777809143066, 0.722178514123521, -79.3686065673828, -1.38524350732082, 218, 45, 'PPL', 'P'),
(88569, 'Licklog', 35.8650016784668, 0.625962365522538, -83.1638870239258, -1.45148364732409, 218, 50, 'PPL', 'P'),
(22660, 'Licklog (historical)', 34.598331451416, 0.603854799523518, -84.3324966430664, -1.47187973284857, 218, 13, 'PPL', 'P'),
(131767, 'Lickly Corners', 41.7963905334473, 0.729484630258044, -84.4583282470703, -1.47407590864151, 218, 27, 'PPL', 'P'),
(3768, 'Lickskillet', 34.3402786254883, 0.599350928067003, -85.6958312988281, -1.49567441139816, 218, 2, 'PPL', 'P'),
(22661, 'Lickskillet', 34.9172210693359, 0.609420473306647, -84.4124984741211, -1.4732760282081, 218, 13, 'PPL', 'P'),
(36884, 'Lickskillet', 37.9338912963867, 0.662071301215568, -86.0572204589844, -1.5019818421239, 218, 21, 'PPL', 'P'),
(66359, 'Lickskillet', 36.2597198486328, 0.632851497209383, -78.1569366455078, -1.36409587773672, 218, 33, 'PPL', 'P'),
(73222, 'Lickskillet', 39.25, 0.685041731407774, -82.8097229003906, -1.44530231727596, 218, 41, 'PPL', 'P'),
(88570, 'Lickskillet', 36.2874984741211, 0.633336325685831, -83.8005599975586, -1.46259568697245, 218, 50, 'PPL', 'P'),
(139276, 'Lickskillet', 40.4444389343262, 0.705888623525778, -92.7108306884766, -1.61810924777292, 218, 29, 'PPL', 'P'),
(88571, 'Lickskillet (historical)', 35.5616683959961, 0.620668201012543, -86.9033279418945, -1.51674920352645, 218, 50, 'PPL', 'P'),
(88572, 'Lickton', 36.3013916015625, 0.633578806503083, -86.8099975585938, -1.5151202810457, 218, 50, 'PPL', 'P'),
(82095, 'Lickville', 34.6177787780762, 0.604194219404449, -82.334716796875, -1.43701189680255, 218, 48, 'PPL', 'P'),
(110102, 'Lico', 38.2413902282715, 0.667438170023323, -81.7391662597656, -1.42661757906797, 218, 58, 'PPL', 'P'),
(36885, 'Lida', 37.082218170166, 0.647206801012264, -83.9347229003906, -1.4649372713609, 218, 21, 'PPL', 'P'),
(190412, 'Lida', 37.4583282470703, 0.653771160204173, -117.497222900391, -2.0507134015615, 218, 39, 'PPL', 'P'),
(22662, 'Lida (historical)', 31.9805603027344, 0.558166073915309, -81.7736129760742, -1.42721878768405, 218, 13, 'PPL', 'P'),
(41795, 'Lida Grove', 30.4930591583252, 0.532204281318186, -91.2536087036133, -1.59267592620461, 218, 22, 'PPL', 'P'),
(66360, 'Liddell', 35.1744384765625, 0.613909763956194, -77.8130569458008, -1.35809404474607, 218, 33, 'PPL', 'P'),
(116494, 'Lidderdale', 42.124439239502, 0.735210160285605, -94.7827835083008, -1.65427164642483, 218, 16, 'PPL', 'P'),
(41796, 'Liddieville', 32.1355590820313, 0.560871312950612, -91.8455581665039, -1.60300739333746, 218, 22, 'PPL', 'P'),
(150260, 'Lidell Corners', 42.7625007629395, 0.746346434699881, -75.0288925170898, -1.30950120854815, 218, 40, 'PPL', 'P'),
(191765, 'Lider', 34.1758308410645, 0.596480772781198, -101.623611450195, -1.77366661757332, 218, 51, 'PPL', 'P'),
(140397, 'Lidgerwood', 46.0755615234375, 0.804170253289199, -97.1513900756836, -1.69561162971002, 218, 34, 'PPL', 'P'),
(120350, 'Lidice', 41.5547218322754, 0.725266715723576, -88.0902786254883, -1.53746540101396, 218, 18, 'PPL', 'P'),
(150262, 'Lido Beach', 40.5888900756836, 0.708409771550729, -73.6258316040039, -1.28501317600877, 218, 40, 'PPL', 'P'),
(182794, 'Lido Isle', 33.603889465332, 0.586498512646281, -117.916389465332, -2.058029238234, 218, 6, 'PPL', 'P'),
(116495, 'Lidtke Mill', 43.4644393920898, 0.75859757492549, -92.2780609130859, -1.61055599028923, 218, 16, 'PPL', 'P'),
(195244, 'Lidy Hot Springs', 44.1263885498047, 0.770150767208418, -112.548889160156, -1.96434868530688, 218, 17, 'PPL', 'P'),
(195245, 'Lidyville (historical)', 46.5955581665039, 0.813245906810025, -116.800277709961, -2.03854941328256, 218, 17, 'PPL', 'P'),
(33056, 'Liebenthal', 38.6549987792969, 0.674657001053119, -99.3188934326172, -1.73344169983654, 218, 20, 'PPL', 'P'),
(150263, 'Liebhardt', 41.8516693115234, 0.730449426941952, -74.2724990844727, -1.29629965270852, 218, 40, 'PPL', 'P'),
(48937, 'Liebno Estates', 39.6402816772461, 0.691853431685925, -77.1119384765625, -1.34585721901132, 218, 25, 'PPL', 'P'),
(163784, 'Liebys Trailer Park', 40.228889465332, 0.702126575590905, -77.1033325195313, -1.34570701672584, 218, 45, 'PPL', 'P'),
(163785, 'Liewellyn Corners', 41.2330589294434, 0.719652638987635, -75.8013916015625, -1.32298386104084, 218, 45, 'PPL', 'P'),
(88573, 'Life', 35.6144409179688, 0.621589255275546, -88.4786071777344, -1.54424301283015, 218, 50, 'PPL', 'P'),
(41797, 'Lifenite', 29.9533290863037, 0.522784214489385, -91.716667175293, -1.60075782116467, 218, 22, 'PPL', 'P'),
(22663, 'Lifsey', 33.0366706848145, 0.576598677347102, -84.3733291625977, -1.47259239475628, 218, 13, 'PPL', 'P'),
(195246, 'Lifton', 42.1233291625977, 0.735190785788675, -111.3125, -1.94276962362619, 218, 17, 'PPL', 'P'),
(14109, 'Liftwood', 39.7777786254883, 0.694253206144195, -75.522216796875, -1.31811134151043, 218, 10, 'PPL', 'P'),
(76396, 'Lige', 34.6583290100098, 0.604901954464137, -99.0183334350586, -1.72819593827936, 218, 42, 'PPL', 'P'),
(103675, 'Liggans Corner', 37.6216697692871, 0.656622007572076, -77.225830078125, -1.34784500244895, 218, 53, 'PPL', 'P'),
(30342, 'Liggett', 39.4791717529297, 0.689041533048964, -87.4836120605469, -1.52687707199396, 218, 19, 'PPL', 'P'),
(36886, 'Liggett', 36.7519416809082, 0.641442388832787, -83.3472213745117, -1.45468343537382, 218, 21, 'PPL', 'P'),
(194290, 'Liggett', 40.0449981689453, 0.698917067003196, -105.133331298828, -1.83492278475456, 218, 7, 'PPL', 'P'),
(156153, 'Liggett Crossing', 40.3627815246582, 0.704463432868423, -80.9208297729492, -1.41233491298382, 218, 41, 'PPL', 'P'),
(10092, 'Light', 36.0699996948242, 0.629540255868033, -90.7477798461914, -1.58384754719099, 218, 4, 'PPL', 'P'),
(66361, 'Light', 35.8197212219238, 0.625172072469057, -80.0977783203125, -1.39796995522199, 218, 33, 'PPL', 'P'),
(88574, 'Light (historical)', 35.0525016784668, 0.611781565350084, -87.6366729736328, -1.52954848888342, 218, 50, 'PPL', 'P'),
(103673, 'Light (historical)', 39.3294410705566, 0.686428239650297, -78.2311096191406, -1.36539044034261, 218, 53, 'PPL', 'P'),
(66362, 'Light Nixon Fork', 36.1324996948242, 0.630631086650529, -76.4938888549805, -1.335070218174, 218, 33, 'PPL', 'P'),
(66363, 'Light Oak', 35.2847213745117, 0.615834563634049, -81.476936340332, -1.42204080357661, 218, 33, 'PPL', 'P'),
(163786, 'Light Street', 41.0361099243164, 0.716215230389642, -76.4238891601563, -1.33384849302393, 218, 45, 'PPL', 'P'),
(110103, 'Lightburn', 39.1258316040039, 0.682874584070722, -80.4513931274414, -1.40414169789019, 218, 58, 'PPL', 'P'),
(110108, 'Lightburn Acres', 39.1216697692871, 0.68280194635199, -80.4458312988281, -1.40404462566846, 218, 58, 'PPL', 'P'),
(88575, 'Lightfoot', 35.7477798461914, 0.623916458594112, -89.6425018310547, -1.56455680667695, 218, 50, 'PPL', 'P'),
(103674, 'Lightfoot', 37.3405609130859, 0.65171573247485, -76.7547225952148, -1.33962262574139, 218, 53, 'PPL', 'P'),
(195247, 'Lightfoot', 45.7186088562012, 0.797940253972149, -115.360000610352, -2.0134118357533, 218, 17, 'PPL', 'P'),
(14110, 'Lightfoots Furnace', 38.6408309936523, 0.674409726545905, -75.57861328125, -1.31909564584933, 218, 10, 'PPL', 'P'),
(150264, 'Lighthouse Beach', 43.3408317565918, 0.756440214705444, -77.7647171020508, -1.35725035531273, 218, 40, 'PPL', 'P'),
(82096, 'Lighthouse Landing', 32.1819381713867, 0.561680780763941, -80.7391662597656, -1.40916428654803, 218, 48, 'PPL', 'P'),
(16895, 'Lighthouse Point', 27.201940536499, 0.474763425293621, -80.2736129760742, -1.40103884890414, 218, 12, 'PPL', 'P'),
(82097, 'Lighthouse Point', 32.7272186279297, 0.571197720077394, -79.9194412231445, -1.39485738569796, 218, 48, 'PPL', 'P'),
(95714, 'Lightner', 31.1261100769043, 0.543253104180165, -99.616943359375, -1.73864365239379, 218, 51, 'PPL', 'P'),
(78621, 'Lightners Tract', 39.9877815246582, 0.697918448173444, -76.7380599975586, -1.33933180855035, 218, 45, 'PPL', 'P'),
(60632, 'Lightsey', 31.735559463501, 0.553890002600537, -88.9358291625977, -1.55222304187852, 218, 30, 'PPL', 'P'),
(120348, 'Lightsville', 42.1469383239746, 0.735602843388337, -89.404167175293, -1.5603970822123, 218, 18, 'PPL', 'P'),
(156154, 'Lightsville', 40.2852783203125, 0.703110746771744, -84.7127838134766, -1.47851699607532, 218, 41, 'PPL', 'P'),
(60633, 'Lightville (historical)', 31.3430595397949, 0.54703958661804, -89.8786087036133, -1.56867764898968, 218, 30, 'PPL', 'P'),
(3769, 'Lightwood', 32.711669921875, 0.570926343962315, -86.3891677856445, -1.50777541591732, 218, 2, 'PPL', 'P'),
(331, 'Lignite', 34.561939239502, 0.603219635603534, -92.4875030517578, -1.61421144520148, 218, 4, 'PPL', 'P'),
(103676, 'Lignite', 37.6272201538086, 0.656718880056727, -79.9986114501953, -1.39623916682954, 218, 53, 'PPL', 'P'),
(195248, 'Lignite', 48.228889465332, 0.841752915750452, -116.540000915527, -2.03400672625316, 218, 17, 'PPL', 'P'),
(198525, 'Lignite', 48.877498626709, 0.853073281175079, -102.5625, -1.79005331407668, 218, 34, 'PPL', 'P'),
(211969, 'Lignite', 63.9094390869141, 1.11543013516941, -149.018325805664, -2.60086043111847, 218, 1, 'PPL', 'P'),
(103677, 'Lignum', 38.415828704834, 0.670482695781502, -77.8269424438477, -1.35833639240526, 218, 53, 'PPL', 'P'),
(36889, 'Ligon', 37.3702812194824, 0.65223444967617, -82.6727828979492, -1.44291226335567, 218, 21, 'PPL', 'P'),
(22666, 'Ligon (historical)', 34.1708297729492, 0.59639348767647, -85.0069427490234, -1.48365103802478, 218, 13, 'PPL', 'P'),
(3770, 'Ligon Springs', 34.5902786254883, 0.603714251196989, -87.7161102294922, -1.53093493054692, 218, 2, 'PPL', 'P'),
(127945, 'Ligonia', 43.6375007629395, 0.761618065654831, -70.2927780151367, -1.22684041673762, 218, 26, 'PPL', 'P'),
(123067, 'Ligonier', 41.4658317565918, 0.723715291230551, -85.5875015258789, -1.49378370018226, 218, 19, 'PPL', 'P'),
(163787, 'Ligonier', 40.2430610656738, 0.702373916677146, -79.2377777099609, -1.38296011300219, 218, 45, 'PPL', 'P'),
(178535, 'Ligurta', 32.6744384765625, 0.570276532656336, -114.294166564941, -1.99480952238104, 218, 5, 'PPL', 'P'),
(210572, 'Lihue', 21.9811096191406, 0.383642736095801, -159.371109008789, -2.78155058475817, 218, 15, 'PPL', 'P'),
(193736, 'Likely', 41.2305603027344, 0.719609029724785, -120.503059387207, -2.10317514503302, 218, 6, 'PPL', 'P'),
(110104, 'Lila', 37.3216705322266, 0.651386033131898, -81.4411087036133, -1.42141549335266, 218, 58, 'PPL', 'P'),
(150265, 'Lila', 42.021110534668, 0.733406734174431, -77.5722198486328, -1.35389064443954, 218, 40, 'PPL', 'P'),
(182795, 'Lila C (historical)', 36.2433280944824, 0.632565407129281, -116.498062133789, -2.03327475642755, 218, 6, 'PPL', 'P'),
(542, 'Lilac', 37.5488891601563, 0.655351746311135, -86.3441696166992, -1.50699004971185, 218, 21, 'PPL', 'P'),
(60634, 'Lilac', 33.6694412231445, 0.587642606650579, -89.5883331298828, -1.56361138448997, 218, 30, 'PPL', 'P'),
(182796, 'Lilac', 33.2877807617188, 0.580981374974018, -117.083061218262, -2.04348491657275, 218, 6, 'PPL', 'P'),
(88576, 'Lilac (historical)', 36.0699996948242, 0.629540255868033, -83.2333297729492, -1.45269565193619, 218, 50, 'PPL', 'P'),
(182797, 'Lilac Park', 38.253059387207, 0.667641835267687, -120.348609924316, -2.10047949337764, 218, 6, 'PPL', 'P'),
(182798, 'Lilac Terrace', 38.0299987792969, 0.663748693228155, -120.233612060547, -2.09847240202211, 218, 6, 'PPL', 'P'),
(95715, 'Lilbert', 31.7361106872559, 0.553899623269975, -94.9008331298828, -1.65633200100217, 218, 51, 'PPL', 'P'),
(55905, 'Lilbourn', 36.5922203063965, 0.638654724961747, -89.6152801513672, -1.56408169873848, 218, 29, 'PPL', 'P'),
(22664, 'Lilburn', 33.8899993896484, 0.591492072848234, -84.1430587768555, -1.46857341835524, 218, 13, 'PPL', 'P'),
(103678, 'Lilburn', 37.521671295166, 0.654876704951692, -77.8397216796875, -1.35855943214656, 218, 53, 'PPL', 'P'),
(110105, 'Lile', 38.1269416809082, 0.665440666047709, -80.620002746582, -1.40708449089473, 218, 58, 'PPL', 'P'),
(66364, 'Liledoun', 35.8983306884766, 0.626544066483639, -81.2183303833008, -1.41752727816115, 218, 33, 'PPL', 'P'),
(66365, 'Lilesville', 34.9674987792969, 0.610297984885828, -79.9847183227539, -1.39599668601229, 218, 33, 'PPL', 'P'),
(36887, 'Liletown', 37.1438903808594, 0.648283184145847, -85.5833282470703, -1.49371086272644, 218, 21, 'PPL', 'P'),
(103679, 'Lilian', 37.8616714477539, 0.660810827071634, -76.3000030517578, -1.3316862725349, 218, 53, 'PPL', 'P'),
(3771, 'Lilita', 32.4836082458496, 0.566945916818055, -88.1283264160156, -1.53812946023177, 218, 2, 'PPL', 'P'),
(88578, 'Lillamay', 36.2319412231445, 0.632366668732934, -87.0494384765625, -1.51929931342825, 218, 50, 'PPL', 'P'),
(95716, 'Lillard', 30.3549995422363, 0.529794686453395, -94.1180572509766, -1.64266998461006, 218, 51, 'PPL', 'P'),
(88580, 'Lillard Mill', 35.586669921875, 0.621104559957152, -86.7847213745117, -1.51467912841113, 218, 50, 'PPL', 'P'),
(76397, 'Lillard Park', 35.4286117553711, 0.618345924541993, -97.5938873291016, -1.7033346637132, 218, 42, 'PPL', 'P'),
(127946, 'Lille', 47.2799987792969, 0.82519164903763, -68.1102828979492, -1.188748691034, 218, 26, 'PPL', 'P'),
(131768, 'Lilley', 43.7708282470703, 0.763945069236315, -85.8505630493164, -1.49837498990155, 218, 27, 'PPL', 'P'),
(10093, 'Lilley (historical)', 33.6688919067383, 0.587633019270655, -92.7422180175781, -1.61865706000915, 218, 4, 'PPL', 'P'),
(3772, 'Lillian', 30.4127807617188, 0.530803158979181, -87.4369430541992, -1.52606254417456, 218, 2, 'PPL', 'P'),
(60635, 'Lillian', 32.5050010681152, 0.567319292002884, -89.545280456543, -1.56285997358841, 218, 30, 'PPL', 'P'),
(95717, 'Lillian', 32.5063896179199, 0.567343526768804, -97.1872177124023, -1.69623693993397, 218, 51, 'PPL', 'P'),
(142240, 'Lillian', 41.5897216796875, 0.725877578298613, -99.6438903808594, -1.7391139666423, 218, 35, 'PPL', 'P'),
(110106, 'Lillian (historical)', 39.1152801513672, 0.682690426481343, -80.065559387207, -1.39740762875782, 218, 58, 'PPL', 'P'),
(16896, 'Lillibridge', 27.7916698455811, 0.485056143432613, -82.1097183227539, -1.43308493261717, 218, 12, 'PPL', 'P'),
(41798, 'Lillie', 32.9319381713867, 0.574770750153899, -92.6566696166992, -1.61716395874399, 218, 22, 'PPL', 'P'),
(193737, 'Lillienthal (historical)', 40.6841697692871, 0.710072715914402, -122.293060302734, -2.13441655462269, 218, 6, 'PPL', 'P'),
(172196, 'Lilliesville', 43.8194389343262, 0.764793485780587, -72.6944427490234, -1.26875737387298, 218, 55, 'PPL', 'P'),
(66367, 'Lillington', 35.399169921875, 0.617832067609663, -78.8161087036133, -1.37560060048781, 218, 33, 'PPL', 'P'),
(66369, 'Lilliput Landing', 35.0605583190918, 0.61192218025564, -77.0650024414063, -1.34503803066001, 218, 33, 'PPL', 'P'),
(33057, 'Lillis', 39.6097183227539, 0.691320000519582, -96.2958297729492, -1.68067928547795, 218, 20, 'PPL', 'P'),
(182799, 'Lillis (historical)', 36.4383316040039, 0.635968860423375, -119.716667175293, -2.08945001172308, 218, 6, 'PPL', 'P'),
(207923, 'Lilliwaup', 47.4636116027832, 0.82839629735635, -123.113059997559, -2.14872824916272, 218, 56, 'PPL', 'P'),
(22665, 'Lilly', 32.1469383239746, 0.561069918188905, -83.8775024414063, -1.46393858595212, 218, 13, 'PPL', 'P'),
(55906, 'Lilly', 39.4700012207031, 0.688881477067451, -94.4444427490234, -1.64836648618174, 218, 29, 'PPL', 'P'),
(66370, 'Lilly', 36.485279083252, 0.636788248511765, -76.3030624389648, -1.33173966891475, 218, 33, 'PPL', 'P'),
(103680, 'Lilly', 38.4663887023926, 0.6713651342087, -79.0141677856445, -1.37905738358273, 218, 53, 'PPL', 'P'),
(120349, 'Lilly', 40.5374984741211, 0.70751281889559, -89.2866668701172, -1.55834631501489, 218, 18, 'PPL', 'P'),
(163790, 'Lilly', 40.4258308410645, 0.705563851030843, -78.6202774047852, -1.3721826995448, 218, 45, 'PPL', 'P'),
(110107, 'Lilly (historical)', 37.5833282470703, 0.655952821769166, -80.9749984741211, -1.4132803351708, 218, 58, 'PPL', 'P'),
(73224, 'Lilly Chapel', 39.8888893127441, 0.696192453470963, -83.2816696166992, -1.45353934136953, 218, 41, 'PPL', 'P'),
(30343, 'Lilly Dale', 38.0116691589355, 0.663428781002209, -86.6513900756836, -1.51235205825062, 218, 19, 'PPL', 'P'),
(110109, 'Lilly Grove', 37.3716697692871, 0.65225868444209, -81.0708312988281, -1.41495293349342, 218, 58, 'PPL', 'P'),
(110110, 'Lilly Park', 37.9502792358398, 0.662357324716643, -80.7986068725586, -1.41020172095067, 218, 58, 'PPL', 'P'),
(103681, 'Lilly View', 37.2838897705078, 0.650726634445994, -79.9180603027344, -1.39483328409009, 218, 53, 'PPL', 'P'),
(110111, 'Lillybrook', 37.644718170166, 0.657024278054732, -81.2205581665039, -1.41756616031306, 218, 58, 'PPL', 'P'),
(88581, 'Lillydale', 36.1277809143066, 0.630548728393818, -82.4052810668945, -1.43824347564866, 218, 50, 'PPL', 'P'),
(110113, 'Lillydale', 37.6761093139648, 0.657572156869988, -81.663330078125, -1.4252939880062, 218, 58, 'PPL', 'P'),
(88582, 'Lillydale (historical)', 36.6158294677734, 0.639066782561409, -85.2944412231445, -1.48866883299265, 218, 50, 'PPL', 'P'),
(110114, 'Lillyhaven', 37.686939239502, 0.657761174728357, -81.6591720581055, -1.42522141686649, 218, 58, 'PPL', 'P'),
(48938, 'Lillys Addition', 39.1327781677246, 0.682995824479348, -76.8747177124023, -1.34171693562262, 218, 25, 'PPL', 'P'),
(27720, 'Lillyville', 39.1897201538086, 0.683989649619139, -88.4519424438477, -1.54377762542966, 218, 18, 'PPL', 'P'),
(163792, 'Lillyville', 40.8441696166992, 0.712865240054432, -80.2366714477539, -1.40039409760423, 218, 45, 'PPL', 'P'),
(16897, 'Lily', 27.3661098480225, 0.477628720310437, -81.9658279418945, -1.43057357170923, 218, 12, 'PPL', 'P'),
(36888, 'Lily', 37.0244407653809, 0.646198395065505, -84.0752792358398, -1.46739044219903, 218, 21, 'PPL', 'P'),
(113389, 'Lily', 45.3069381713867, 0.790755245088197, -88.853889465332, -1.55079292437315, 218, 57, 'PPL', 'P'),
(170744, 'Lily', 45.1813888549805, 0.78856399614328, -97.6830596923828, -1.70489101505424, 218, 49, 'PPL', 'P'),
(170745, 'Lily (historical)', 45.0708312988281, 0.786634402775463, -97.7375030517578, -1.70584123093118, 218, 49, 'PPL', 'P'),
(127947, 'Lily Bay', 45.6016693115234, 0.79589927389174, -69.508056640625, -1.21314444504162, 218, 26, 'PPL', 'P'),
(120351, 'Lily Cache', 41.5902786254883, 0.725887298836592, -88.1813888549805, -1.53905557450084, 218, 18, 'PPL', 'P'),
(150266, 'Lily Dale', 42.3516693115234, 0.739176073201924, -79.3244400024414, -1.3844726553433, 218, 40, 'PPL', 'P'),
(88583, 'Lily Grove', 36.4425010681152, 0.636041631300161, -83.7136077880859, -1.46107808462527, 218, 50, 'PPL', 'P'),
(3774, 'Lily Grove (historical)', 32.452220916748, 0.566398104581826, -86.9044418334961, -1.5167686446024, 218, 2, 'PPL', 'P'),
(95718, 'Lily Island', 30.9038906097412, 0.539374642816142, -94.7094421386719, -1.65299159804688, 218, 51, 'PPL', 'P'),
(120352, 'Lily Lake', 41.9488906860352, 0.732146260030496, -88.477783203125, -1.54422863176027, 218, 18, 'PPL', 'P'),
(22667, 'Lily Pond', 34.4338912963867, 0.600984777395767, -84.9519424438477, -1.48269110160986, 218, 13, 'PPL', 'P'),
(136502, 'Lilydale', 44.9161109924316, 0.78393402400915, -93.1258316040039, -1.62535238014766, 218, 28, 'PPL', 'P'),
(120354, 'Lilymoor', 42.3305587768555, 0.738807624865112, -88.2130584716797, -1.53960831358509, 218, 18, 'PPL', 'P'),
(48939, 'Lilypons', 39.2949981689453, 0.685827097613239, -77.4313888549805, -1.35143267991145, 218, 25, 'PPL', 'P'),
(3775, 'Lim Rock', 34.6722183227539, 0.605144368702362, -86.1883316040039, -1.50427016329055, 218, 2, 'PPL', 'P'),
(66371, 'Lima', 35.1972198486328, 0.614307373906943, -77.1358337402344, -1.34627427003802, 218, 33, 'PPL', 'P'),
(76398, 'Lima', 35.1738891601563, 0.61390017657627, -96.5994415283203, -1.68597831025693, 218, 42, 'PPL', 'P'),
(78623, 'Lima', 39.9172210693359, 0.696686935906364, -75.4408264160156, -1.31669081138499, 218, 45, 'PPL', 'P'),
(82098, 'Lima', 35.089168548584, 0.61242152296003, -82.4475021362305, -1.43898037232228, 218, 48, 'PPL', 'P'),
(116497, 'Lima', 42.8683280944824, 0.748193470073905, -91.7427825927734, -1.60121362118524, 218, 16, 'PPL', 'P'),
(120355, 'Lima', 40.1775016784668, 0.701229689514794, -91.3783264160156, -1.59485266092158, 218, 18, 'PPL', 'P'),
(150267, 'Lima', 42.9047203063965, 0.748828633993889, -77.6116714477539, -1.35457920473938, 218, 40, 'PPL', 'P'),
(156155, 'Lima', 40.7425003051758, 0.711090775820112, -84.1052780151367, -1.46791401966934, 218, 41, 'PPL', 'P'),
(174973, 'Lima', 44.6338882446289, 0.779008307835967, -91.8727798461914, -1.60348250127593, 218, 57, 'PPL', 'P'),
(196909, 'Lima', 44.6369400024414, 0.779061571057768, -112.591110229492, -1.96508558198051, 218, 31, 'PPL', 'P'),
(200050, 'Lima (historical)', 40.3377799987793, 0.704027073923813, -118.230003356934, -2.06350283322244, 218, 39, 'PPL', 'P'),
(131770, 'Lima Center', 42.2958297729492, 0.738201489401009, -83.9574966430664, -1.4653347481536, 218, 27, 'PPL', 'P'),
(174974, 'Lima Center', 42.7894401550293, 0.746816615790334, -88.8272171020508, -1.5503274038146, 218, 57, 'PPL', 'P'),
(36890, 'Limaburg', 39.0200004577637, 0.681027482117671, -84.6872177124023, -1.47807078343468, 218, 21, 'PPL', 'P'),
(156158, 'Limaville', 40.9819412231445, 0.715269808202664, -81.1486129760742, -1.41631047985909, 218, 41, 'PPL', 'P'),
(55907, 'Limberlost', 37.8069381713867, 0.659855551188622, -91.3591690063477, -1.59451830104672, 218, 29, 'PPL', 'P'),
(3776, 'Lime', 33.1586112976074, 0.578726942532239, -85.2600021362305, -1.48806775753462, 218, 2, 'PPL', 'P'),
(186984, 'Lime', 37.9550018310547, 0.662439749552381, -107.930282592773, -1.88373879385182, 218, 7, 'PPL', 'P'),
(201133, 'Lime', 44.4066696166992, 0.77504259465673, -117.310279846191, -2.04745062975199, 218, 43, 'PPL', 'P'),
(163793, 'Lime Bluff', 41.2294387817383, 0.719589455490773, -76.7608337402344, -1.33972928534304, 218, 45, 'PPL', 'P'),
(95719, 'Lime City', 31.3944396972656, 0.547936339536097, -97.5269393920898, -1.70216620178492, 218, 51, 'PPL', 'P'),
(116498, 'Lime City', 41.6477813720703, 0.726890911093389, -91.0772171020508, -1.58959731198447, 218, 16, 'PPL', 'P'),
(156160, 'Lime City', 41.5349998474121, 0.724922502152684, -83.5669403076172, -1.45851825418548, 218, 41, 'PPL', 'P'),
(131772, 'Lime Creek', 41.7655601501465, 0.728946538559793, -84.329719543457, -1.47183126331673, 218, 27, 'PPL', 'P'),
(136505, 'Lime Creek', 43.889720916748, 0.766020137778678, -95.5616683959961, -1.66786575220914, 218, 28, 'PPL', 'P'),
(142241, 'Lime Grove', 42.6636085510254, 0.7446204399974, -96.9991683959961, -1.69295486020656, 218, 35, 'PPL', 'P'),
(103682, 'Lime Hill', 36.6488914489746, 0.639643822990602, -82.2474975585938, -1.43548963392346, 218, 53, 'PPL', 'P'),
(3777, 'Lime Kiln', 34.7649993896484, 0.606763703803184, -88.0391693115234, -1.53657337520683, 218, 2, 'PPL', 'P'),
(48940, 'Lime Kiln', 39.3486099243164, 0.686762799262238, -77.4258270263672, -1.35133560768972, 218, 25, 'PPL', 'P'),
(48941, 'Lime Kiln Valley', 39.1541709899902, 0.683369199664177, -76.9561080932617, -1.34313746574807, 218, 25, 'PPL', 'P'),
(150269, 'Lime Lake', 42.434440612793, 0.740620704935237, -78.4800033569336, -1.36973445555469, 218, 40, 'PPL', 'P'),
(163797, 'Lime Ridge', 41.0277786254883, 0.716069821794124, -76.3397216796875, -1.33237949336664, 218, 45, 'PPL', 'P'),
(174979, 'Lime Ridge', 43.4677810668945, 0.758655898153363, -90.1547164916992, -1.57349663898218, 218, 57, 'PPL', 'P'),
(3778, 'Lime Rock', 34.605281829834, 0.603976106511171, -87.7461090087891, -1.53145850801723, 218, 2, 'PPL', 'P'),
(113640, 'Lime Rock', 41.9336090087891, 0.731879544447325, -73.3897171020508, -1.28089220053798, 218, 8, 'PPL', 'P'),
(169462, 'Lime Rock', 41.9286117553711, 0.731792325921625, -71.4508285522461, -1.24705221151467, 218, 47, 'PPL', 'P'),
(66372, 'Lime Rock (historical)', 36.2722206115723, 0.633069676681687, -80.5969390869141, -1.40668195409596, 218, 33, 'PPL', 'P'),
(110115, 'Lime Rock (historical)', 39.0869407653809, 0.682195810887888, -79.5986099243164, -1.38925782318996, 218, 58, 'PPL', 'P'),
(3779, 'Lime Sink', 31.7827796936035, 0.554714151089376, -85.398063659668, -1.49047738568892, 218, 2, 'PPL', 'P'),
(116501, 'Lime Springs', 43.4488906860352, 0.758326198810411, -92.2805633544922, -1.61059966613111, 218, 16, 'PPL', 'P'),
(82100, 'Lime Stone (historical)', 33.9252815246582, 0.592107862271288, -82.045280456543, -1.43196027968883, 218, 48, 'PPL', 'P'),
(78622, 'Lime Valley', 39.9630584716797, 0.697486949497824, -76.2302780151367, -1.33046934107478, 218, 45, 'PPL', 'P'),
(136507, 'Lime Valley Mobile Home Park', 44.2027816772461, 0.771484078808166, -93.9791717529297, -1.64024597538587, 218, 28, 'PPL', 'P'),
(211970, 'Lime Village', 61.3563919067383, 1.07087105591658, -155.435562133789, -2.71286233392284, 218, 1, 'PPL', 'P'),
(10094, 'Limedale', 35.7938919067383, 0.624721265875534, -91.7191696166992, -1.60080149700655, 218, 4, 'PPL', 'P'),
(30344, 'Limedale', 39.6191711425781, 0.691484983349112, -86.8791732788086, -1.51632762512589, 218, 19, 'PPL', 'P'),
(10095, 'Limedale Junction', 35.8158302307129, 0.62510416186126, -91.7133331298828, -1.60069963109485, 218, 4, 'PPL', 'P'),
(163795, 'Limehill', 41.7247200012207, 0.728233743494034, -76.2855606079102, -1.33143420433772, 218, 45, 'PPL', 'P'),
(82099, 'Limehouse', 32.2125015258789, 0.562214211930284, -81.0708312988281, -1.41495293349342, 218, 48, 'PPL', 'P'),
(82101, 'Limehouse Station', 32.7713890075684, 0.571968638633945, -80.0802764892578, -1.39766449064495, 218, 48, 'PPL', 'P'),
(163796, 'Limekiln Acres', 40.1766700744629, 0.701215175286853, -76.9499969482422, -1.34303080614641, 218, 45, 'PPL', 'P'),
(55908, 'Limekiln Ford (historical)', 37.5011100769043, 0.654517843994804, -92.9683303833008, -1.62260346527048, 218, 29, 'PPL', 'P'),
(163798, 'Limeport', 40.5088882446289, 0.707013476191201, -75.4475021362305, -1.31680732468268, 218, 45, 'PPL', 'P'),
(22668, 'Limerick', 31.836669921875, 0.555654713007365, -81.3861083984375, -1.42045555693774, 218, 13, 'PPL', 'P'),
(60636, 'Limerick', 32.7550010681152, 0.57168261513287, -90.5622177124023, -1.58060887698935, 218, 30, 'PPL', 'P'),
(73227, 'Limerick', 39.125560760498, 0.682869856959788, -82.7502822875977, -1.44426488287332, 218, 41, 'PPL', 'P'),
(82102, 'Limerick', 33.1358299255371, 0.57832933258149, -79.8152770996094, -1.39303937877981, 218, 48, 'PPL', 'P'),
(120376, 'Limerick', 41.4947204589844, 0.72421949420393, -89.4669418334961, -1.56149270668476, 218, 18, 'PPL', 'P'),
(127948, 'Limerick', 43.6883316040039, 0.762505231192964, -70.7941665649414, -1.23559129776351, 218, 26, 'PPL', 'P'),
(150270, 'Limerick', 44.0291709899902, 0.768454000698901, -76.043327331543, -1.32720643610722, 218, 40, 'PPL', 'P'),
(163799, 'Limerick', 40.2308311462402, 0.702160464315776, -75.5224990844727, -1.31811626835845, 218, 45, 'PPL', 'P'),
(163800, 'Limerick Center', 40.2363891601563, 0.702257469958483, -75.5366668701172, -1.31836354286566, 218, 45, 'PPL', 'P'),
(127949, 'Limerick Mills', 43.6958312988281, 0.762636125560541, -70.7886123657227, -1.23549435869983, 218, 26, 'PPL', 'P'),
(150271, 'Limerock', 42.9786109924316, 0.75011826975176, -77.9191665649414, -1.35994600696811, 218, 40, 'PPL', 'P'),
(163802, 'Limerock', 40.1588897705078, 0.700904850440831, -76.3408279418945, -1.33239880128455, 218, 45, 'PPL', 'P'),
(10107, 'Limestone', 35.7838897705078, 0.624546695666079, -93.283332824707, -1.62810129502484, 218, 4, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(16899, 'Limestone', 30.351110458374, 0.529726809135112, -84.0280609130859, -1.4665663269997, 218, 12, 'PPL', 'P'),
(36891, 'Limestone', 38.2661094665527, 0.667869602119916, -83.2072219848633, -1.45223998507368, 218, 21, 'PPL', 'P'),
(76399, 'Limestone', 36.3158302307129, 0.633830808121232, -95.748893737793, -1.67113345086667, 218, 42, 'PPL', 'P'),
(82103, 'Limestone', 33.9033317565918, 0.59172476654848, -82.0338897705078, -1.43176147471346, 218, 48, 'PPL', 'P'),
(88584, 'Limestone', 36.2280616760254, 0.632298957862218, -82.6305618286133, -1.44217536668205, 218, 50, 'PPL', 'P'),
(110117, 'Limestone', 39.9358291625977, 0.697011708401299, -80.6458282470703, -1.40753523090922, 218, 58, 'PPL', 'P'),
(127951, 'Limestone', 46.9086112976074, 0.818709714681459, -67.8263931274414, -1.18379387982591, 218, 26, 'PPL', 'P'),
(131773, 'Limestone', 46.2608299255371, 0.807403796905746, -86.9291687011719, -1.51720020985705, 218, 27, 'PPL', 'P'),
(150272, 'Limestone', 42.0272216796875, 0.733513393776089, -78.6297225952148, -1.37234754921628, 218, 40, 'PPL', 'P'),
(156159, 'Limestone', 41.5525016784668, 0.725227966729716, -83.2125015258789, -1.45233213044739, 218, 41, 'PPL', 'P'),
(163803, 'Limestone', 41.1286087036133, 0.717829638642448, -79.3272171020508, -1.38452112487514, 218, 45, 'PPL', 'P'),
(196910, 'Limestone', 45.4777793884277, 0.793736986823677, -109.901672363281, -1.91814603618732, 218, 31, 'PPL', 'P'),
(73228, 'Limestone (historical)', 38.954719543457, 0.679888115224307, -82.529167175293, -1.44040569613769, 218, 41, 'PPL', 'P'),
(14111, 'Limestone Acres', 39.7249984741211, 0.693332018723137, -75.6666717529297, -1.32063255611441, 218, 10, 'PPL', 'P'),
(73229, 'Limestone City', 39.9119415283203, 0.696594790532647, -83.8766708374023, -1.46392407172418, 218, 41, 'PPL', 'P'),
(88585, 'Limestone Cove', 36.1808280944824, 0.631474576346784, -82.2619400024414, -1.43574170212063, 218, 50, 'PPL', 'P'),
(16900, 'Limestone Creek', 26.9424991607666, 0.470235319071186, -80.1413879394531, -1.39873108666153, 218, 12, 'PPL', 'P'),
(14112, 'Limestone Gap', 39.7277793884277, 0.693380554834003, -75.6597213745117, -1.32051124912676, 218, 10, 'PPL', 'P'),
(76400, 'Limestone Gap', 34.6005592346191, 0.603893681675433, -95.9711074829102, -1.67501181236215, 218, 42, 'PPL', 'P'),
(14113, 'Limestone Gardene', 39.7291717529297, 0.69340485617895, -75.6605606079102, -1.32052589651275, 218, 10, 'PPL', 'P'),
(14114, 'Limestone Hills', 39.7541694641113, 0.693841148544532, -75.6847229003906, -1.32094760807137, 218, 10, 'PPL', 'P'),
(207924, 'Limestone Junction', 48.9566688537598, 0.854455062306666, -122.155830383301, -2.13202144069633, 218, 56, 'PPL', 'P'),
(36892, 'Limestone Springs', 37.9302787780762, 0.662008250876761, -85.668327331543, -1.49519437661167, 218, 21, 'PPL', 'P'),
(88586, 'Limestone Springs', 36.0200004577637, 0.628667604557841, -82.8569412231445, -1.44612643247529, 218, 50, 'PPL', 'P'),
(163808, 'Limestoneville', 41.0391693115234, 0.716268626769498, -76.7480621337891, -1.3395063787598, 218, 45, 'PPL', 'P'),
(150273, 'Limestreet', 42.3083305358887, 0.738419668873314, -73.876106262207, -1.28938129282871, 218, 40, 'PPL', 'P'),
(103683, 'Limeton', 38.8544387817383, 0.678137885755907, -78.2769393920898, -1.36619032077602, 218, 53, 'PPL', 'P'),
(22669, 'Limetree', 33.6175003051758, 0.586736066615516, -84.4649963378906, -1.47419228878114, 218, 13, 'PPL', 'P'),
(36893, 'Limeville', 38.7075004577637, 0.675573328205188, -82.8811111450195, -1.44654827719196, 218, 21, 'PPL', 'P'),
(163809, 'Limeville', 40.0019416809082, 0.698165589522603, -75.9805603027344, -1.32611094479281, 218, 45, 'PPL', 'P'),
(10097, 'Limeville (historical)', 35.7533302307129, 0.624013331078764, -91.7525024414063, -1.60138326454667, 218, 4, 'PPL', 'P'),
(131775, 'Liminga', 47.1561088562012, 0.823029361969568, -88.6980590820313, -1.5480731711099, 218, 27, 'PPL', 'P'),
(127952, 'Limington', 43.7316703796387, 0.763261635521573, -70.7113876342773, -1.23414653287214, 218, 26, 'PPL', 'P'),
(188877, 'Limitar', 34.1555595397949, 0.596126971830381, -106.896392822266, -1.86569401325377, 218, 38, 'PPL', 'P'),
(182800, 'Limon', 34.3205604553223, 0.599006781075138, -119.106941223145, -2.07880828632323, 218, 6, 'PPL', 'P'),
(186985, 'Limon', 39.2638893127441, 0.685284145645999, -103.691673278809, -1.80976110561743, 218, 7, 'PPL', 'P'),
(16910, 'Limona', 27.9452800750732, 0.487737147701996, -82.3041687011719, -1.43647873195231, 218, 12, 'PPL', 'P'),
(182801, 'Limoneira', 34.3302803039551, 0.599176424436576, -119.124717712402, -2.07911854459023, 218, 6, 'PPL', 'P'),
(36894, 'Limp', 37.5922203063965, 0.65610801748169, -86.1975021362305, -1.50443021927207, 218, 21, 'PPL', 'P'),
(82104, 'Limp', 33.9880599975586, 0.593203553322773, -81.8525009155273, -1.42859564196763, 218, 48, 'PPL', 'P'),
(156161, 'Limpytown', 40.500560760498, 0.70686813417471, -81.716667175293, -1.42622489596524, 218, 41, 'PPL', 'P'),
(103684, 'Limstrong', 38.7158317565918, 0.675718736800707, -77.4649963378906, -1.35201924114154, 218, 53, 'PPL', 'P'),
(22670, 'Lina (historical)', 33.7261085510254, 0.588631638100407, -82.8655624389648, -1.44627690107688, 218, 13, 'PPL', 'P'),
(16901, 'Linadale', 28.9705600738525, 0.505631659435538, -81.7669372558594, -1.42710227438636, 218, 12, 'PPL', 'P'),
(88592, 'Linary', 35.8641700744629, 0.625947851294597, -84.9905624389648, -1.48336514768176, 218, 50, 'PPL', 'P'),
(66374, 'Linberry', 35.8502807617188, 0.625705437056373, -79.704719543457, -1.391109785412, 218, 33, 'PPL', 'P'),
(116502, 'Linby', 41.1505584716797, 0.718212734365256, -92.14111328125, -1.60816580321089, 218, 16, 'PPL', 'P'),
(41799, 'Lincecum', 31.687219619751, 0.5530463131672, -92.3925018310547, -1.61255336110679, 218, 22, 'PPL', 'P'),
(209567, 'Linch', 43.6063919067383, 0.761075113687591, -106.195556640625, -1.85346211436703, 218, 59, 'PPL', 'P'),
(22672, 'Linchburg', 33.3141708374023, 0.581441968684547, -83.45361328125, -1.45654032444388, 218, 13, 'PPL', 'P'),
(48942, 'Linchester', 38.7008285522461, 0.675456881486525, -75.8963928222656, -1.32464194513553, 218, 25, 'PPL', 'P'),
(150274, 'Lincklaen', 42.6755599975586, 0.744829032089781, -75.8772201538086, -1.32430731894456, 218, 40, 'PPL', 'P'),
(150275, 'Lincklaen Center', 42.7069396972656, 0.745376711167956, -75.8488922119141, -1.32381290308818, 218, 40, 'PPL', 'P'),
(3785, 'Lincoln', 33.6130599975586, 0.586658568627795, -86.1183319091797, -1.50304843814048, 218, 2, 'PPL', 'P'),
(10098, 'Lincoln', 35.9494400024414, 0.627436092290761, -94.4233322143555, -1.64799803784493, 218, 4, 'PPL', 'P'),
(14115, 'Lincoln', 38.8697204589844, 0.678404601339079, -75.4233322143555, -1.31638547996601, 218, 10, 'PPL', 'P'),
(33059, 'Lincoln', 39.040828704834, 0.681391003606466, -98.1444396972656, -1.71294361524231, 218, 20, 'PPL', 'P'),
(36895, 'Lincoln', 37.0577812194824, 0.646780295763688, -83.7391662597656, -1.46152416410786, 218, 21, 'PPL', 'P'),
(48943, 'Lincoln', 38.9630584716797, 0.68003365697788, -76.8197174072266, -1.34075699920771, 218, 25, 'PPL', 'P'),
(55909, 'Lincoln', 38.3908309936523, 0.67004640341592, -93.3344421386719, -1.62899332083196, 218, 29, 'PPL', 'P'),
(71032, 'Lincoln', 39.6694412231445, 0.692362361770239, -75.2411117553711, -1.31320513299224, 218, 37, 'PPL', 'P'),
(76401, 'Lincoln', 34.4938888549805, 0.602031932336386, -99.7600021362305, -1.7411404990738, 218, 42, 'PPL', 'P'),
(88587, 'Lincoln', 35.0149993896484, 0.61112702693317, -86.5074996948242, -1.50984069734267, 218, 50, 'PPL', 'P'),
(95727, 'Lincoln', 30.2872200012207, 0.528611710297182, -96.9630584716797, -1.69232462313459, 218, 51, 'PPL', 'P'),
(103694, 'Lincoln', 39.1152801513672, 0.682690426481343, -77.6952819824219, -1.35603848385869, 218, 53, 'PPL', 'P'),
(110122, 'Lincoln', 37.586109161377, 0.656001357880033, -81.7458267211914, -1.42673382604955, 218, 58, 'PPL', 'P'),
(116504, 'Lincoln', 42.2627792358398, 0.737624648708898, -92.6916732788086, -1.61777488789806, 218, 16, 'PPL', 'P'),
(120359, 'Lincoln', 40.1483306884766, 0.700720559693398, -89.3647232055664, -1.55970865507052, 218, 18, 'PPL', 'P'),
(123083, 'Lincoln', 40.6155586242676, 0.708875225530248, -86.2099990844727, -1.50464833216535, 218, 19, 'PPL', 'P'),
(125241, 'Lincoln', 42.4258308410645, 0.74047043607073, -71.304443359375, -1.2444973079229, 218, 23, 'PPL', 'P'),
(127954, 'Lincoln', 45.3622207641602, 0.791720108351133, -68.5055618286133, -1.19564760983785, 218, 26, 'PPL', 'P'),
(131778, 'Lincoln', 42.1572189331055, 0.735782273866782, -83.6011123657227, -1.45911466911161, 218, 27, 'PPL', 'P'),
(136510, 'Lincoln', 46.2102813720703, 0.80652155821563, -94.6405563354492, -1.65178931397277, 218, 28, 'PPL', 'P'),
(142242, 'Lincoln', 40.7999992370605, 0.712094321497881, -96.6666717529297, -1.68715169903322, 218, 35, 'PPL', 'P'),
(144057, 'Lincoln', 44.0455589294434, 0.768740024199975, -71.6705627441406, -1.25088729664244, 218, 36, 'PPL', 'P'),
(150278, 'Lincoln', 40.9086112976074, 0.713989959561799, -73.8777770996094, -1.28941045444265, 218, 40, 'PPL', 'P'),
(163811, 'Lincoln', 40.1963882446289, 0.701559322278718, -76.2013931274414, -1.32996520468043, 218, 45, 'PPL', 'P'),
(172197, 'Lincoln', 44.1058311462402, 0.769791972830557, -72.9974975585938, -1.27404667811398, 218, 55, 'PPL', 'P'),
(174982, 'Lincoln', 44.6180610656738, 0.778732071451898, -87.6419372558594, -1.52964036794103, 218, 57, 'PPL', 'P'),
(182802, 'Lincoln', 38.8916702270508, 0.678787697061887, -121.291938781738, -2.11694368786873, 218, 6, 'PPL', 'P'),
(186986, 'Lincoln', 39.4874992370605, 0.689186875065455, -105.985000610352, -1.84978721837883, 218, 7, 'PPL', 'P'),
(192942, 'Lincoln', 33.4919395446777, 0.584544617933517, -105.383331298828, -1.83928610788454, 218, 38, 'PPL', 'P'),
(195249, 'Lincoln', 43.5130615234375, 0.759446191206844, -111.963607788086, -1.95413359831367, 218, 17, 'PPL', 'P'),
(196911, 'Lincoln', 46.9550018310547, 0.81951938223187, -112.68083190918, -1.96665152070147, 218, 31, 'PPL', 'P'),
(198527, 'Lincoln', 46.7625007629395, 0.816159604779654, -100.699996948242, -1.75754650349507, 218, 34, 'PPL', 'P'),
(201135, 'Lincoln', 45.0200004577637, 0.78574723723733, -123.082778930664, -2.14819974484439, 218, 43, 'PPL', 'P'),
(204699, 'Lincoln', 40.2788887023926, 0.702999226901097, -111.694442749023, -1.94943578215077, 218, 52, 'PPL', 'P'),
(207926, 'Lincoln', 47.8291702270508, 0.83477649895888, -118.413887023926, -2.06671220865209, 218, 56, 'PPL', 'P'),
(182803, 'Lincoln (historical)', 37.0186080932617, 0.646096595732837, -120.345001220703, -2.10041650961786, 218, 6, 'PPL', 'P'),
(182804, 'Lincoln Acres', 32.667781829834, 0.570160352253781, -117.071937561035, -2.04329077212928, 218, 6, 'PPL', 'P'),
(204700, 'Lincoln Addition', 40.7119407653809, 0.710557411232796, -112.10417175293, -1.95658690230985, 218, 52, 'PPL', 'P'),
(55910, 'Lincoln Beach', 38.5463905334473, 0.672761429568228, -90.539436340332, -1.5802112670386, 218, 29, 'PPL', 'P'),
(201136, 'Lincoln Beach', 44.8505592346191, 0.782789930004852, -124.045562744141, -2.16500349237447, 218, 43, 'PPL', 'P'),
(116505, 'Lincoln Center', 41.1158294677734, 0.717606598901154, -94.871940612793, -1.65582773144976, 218, 16, 'PPL', 'P'),
(127956, 'Lincoln Center', 45.3869400024414, 0.792151540447726, -68.4702835083008, -1.19503188699382, 218, 26, 'PPL', 'P'),
(30345, 'Lincoln City', 38.1211090087891, 0.665338866715041, -86.9986114501953, -1.51841221446915, 218, 19, 'PPL', 'P'),
(190415, 'Lincoln City', 35.8019409179688, 0.624861747623036, -115.622222900391, -2.0179884780866, 218, 39, 'PPL', 'P'),
(201138, 'Lincoln City', 44.9583282470703, 0.784670854103748, -124.016670227051, -2.16449922282206, 218, 43, 'PPL', 'P'),
(103685, 'Lincoln Court', 37.2861099243164, 0.650765383439855, -79.9413909912109, -1.39524048142076, 218, 53, 'PPL', 'P'),
(204701, 'Lincoln Court Condominium', 41.1258316040039, 0.717781169110609, -112.091667175293, -1.95636865625851, 218, 52, 'PPL', 'P'),
(182806, 'Lincoln Crest', 34.5869407653809, 0.603655994548144, -118.303886413574, -2.06479233582226, 218, 6, 'PPL', 'P'),
(16902, 'Lincoln Estates', 29.639720916748, 0.517310719369485, -82.3011093139648, -1.43642533557246, 218, 12, 'PPL', 'P'),
(103686, 'Lincoln Estates', 39.1972198486328, 0.684120543986716, -78.2866668701172, -1.36636009729551, 218, 53, 'PPL', 'P'),
(120360, 'Lincoln Estates', 41.502498626709, 0.724355248840497, -87.8069381713867, -1.53252017718579, 218, 18, 'PPL', 'P'),
(163812, 'Lincoln Falls', 41.5169410705566, 0.724607317037673, -76.6627807617188, -1.33801793802656, 218, 45, 'PPL', 'P'),
(82106, 'Lincoln Green', 33.148609161377, 0.578552372322784, -80.4288864135742, -1.4037488816294, 218, 48, 'PPL', 'P'),
(13146, 'Lincoln Heights', 38.8944396972656, 0.678836033435672, -76.9291687011719, -1.34266728465762, 218, 9, 'PPL', 'P'),
(16903, 'Lincoln Heights', 28.7991695404053, 0.502640330320134, -81.2947235107422, -1.4188605897609, 218, 12, 'PPL', 'P'),
(41801, 'Lincoln Heights', 31.1499996185303, 0.543670055338331, -93.2763900756836, -1.62798012119524, 218, 22, 'PPL', 'P'),
(48945, 'Lincoln Heights', 38.348331451416, 0.669304646473305, -75.5872192382813, -1.31924584813481, 218, 25, 'PPL', 'P'),
(66377, 'Lincoln Heights', 34.7819404602051, 0.60705938126321, -79.4469375610352, -1.38661064106642, 218, 33, 'PPL', 'P'),
(103687, 'Lincoln Heights', 36.6897201538086, 0.64035641831928, -77.5766677856445, -1.35396827558532, 218, 53, 'PPL', 'P'),
(120361, 'Lincoln Heights', 41.8558311462402, 0.730522064660684, -89.5202789306641, -1.5624236146438, 218, 18, 'PPL', 'P'),
(125242, 'Lincoln Heights', 42.2236099243164, 0.736941015257075, -70.9194412231445, -1.23777775301847, 218, 23, 'PPL', 'P'),
(156162, 'Lincoln Heights', 40.7713890075684, 0.711594978793491, -82.4844436645508, -1.43962512362219, 218, 41, 'PPL', 'P'),
(163813, 'Lincoln Heights', 40.3072204589844, 0.703493709336497, -79.6172180175781, -1.38958259568489, 218, 45, 'PPL', 'P'),
(163814, 'Lincoln Hill', 40.1536102294922, 0.700812705067115, -80.2927780151367, -1.40137334193705, 218, 45, 'PPL', 'P'),
(22676, 'Lincoln Hills', 32.5277786254883, 0.567716835374606, -84.9458312988281, -1.4825844420082, 218, 13, 'PPL', 'P'),
(27722, 'Lincoln Hills', 39.9269409179688, 0.696856579267802, -91.3677825927734, -1.59466863649026, 218, 18, 'PPL', 'P'),
(123069, 'Lincoln Hills', 41.4683303833008, 0.723758900493401, -87.107780456543, -1.52031757307104, 218, 19, 'PPL', 'P'),
(186988, 'Lincoln Hills', 39.9225006103516, 0.696779081280081, -105.457778930664, -1.84058546418039, 218, 7, 'PPL', 'P'),
(131779, 'Lincoln Junction', 44.4925003051758, 0.776540622769899, -83.3533325195313, -1.45479009497548, 218, 27, 'PPL', 'P'),
(48946, 'Lincoln Manor', 39.6288909912109, 0.69165462671055, -76.8236083984375, -1.3408249098155, 218, 25, 'PPL', 'P'),
(127958, 'Lincoln Mills', 44.9550018310547, 0.784612797191984, -69.2766723632813, -1.20910602756462, 218, 26, 'PPL', 'P'),
(13147, 'Lincoln Park', 38.8911094665527, 0.678777909944881, -76.9819412231445, -1.34358833892062, 218, 9, 'PPL', 'P'),
(16904, 'Lincoln Park', 28.6533298492432, 0.500094947529264, -82.1083297729492, -1.43306069785125, 218, 12, 'PPL', 'P'),
(22677, 'Lincoln Park', 32.8677787780762, 0.573650957494548, -84.3305587768555, -1.47184591070273, 218, 13, 'PPL', 'P'),
(41804, 'Lincoln Park', 30.5088901519775, 0.532480584281281, -90.4930572509766, -1.57940179922527, 218, 22, 'PPL', 'P'),
(66385, 'Lincoln Park', 35.9261093139648, 0.627028894960088, -82.2972183227539, -1.43635742496466, 218, 33, 'PPL', 'P'),
(73234, 'Lincoln Park', 38.4263916015625, 0.670667053107963, -82.5283279418945, -1.4403910487517, 218, 41, 'PPL', 'P'),
(88590, 'Lincoln Park', 35.4630584716797, 0.618947133158079, -86.809440612793, -1.51511056050772, 218, 50, 'PPL', 'P'),
(95721, 'Lincoln Park', 33.2219390869141, 0.579832220963649, -96.9725036621094, -1.69248947280607, 218, 51, 'PPL', 'P'),
(103690, 'Lincoln Park', 36.9150009155273, 0.644288309352673, -76.2463912963867, -1.3307505708859, 218, 53, 'PPL', 'P'),
(110119, 'Lincoln Park', 38.3702812194824, 0.669687742196113, -81.7908325195313, -1.42751932541307, 218, 58, 'PPL', 'P'),
(131780, 'Lincoln Park', 42.250560760498, 0.73741139608461, -83.1786117553711, -1.45174064236929, 218, 27, 'PPL', 'P'),
(144058, 'Lincoln Park', 42.7572212219238, 0.746254289326164, -71.5086135864258, -1.24806075061948, 218, 36, 'PPL', 'P'),
(145609, 'Lincoln Park', 40.4850006103516, 0.706596558322549, -74.4672164916992, -1.29969811257557, 218, 37, 'PPL', 'P'),
(150280, 'Lincoln Park', 41.9505615234375, 0.732175421644433, -73.9944381713867, -1.29144657425407, 218, 40, 'PPL', 'P'),
(163816, 'Lincoln Park', 40.3147201538086, 0.703624603704075, -75.9858322143555, -1.32620295700848, 218, 45, 'PPL', 'P'),
(169463, 'Lincoln Park', 41.7374992370605, 0.728456783235328, -71.434440612793, -1.24676618801359, 218, 47, 'PPL', 'P'),
(186989, 'Lincoln Park', 38.4291687011719, 0.670715522639802, -105.219436645508, -1.83642560655769, 218, 7, 'PPL', 'P'),
(190416, 'Lincoln Park', 39.0397186279297, 0.681371629109536, -119.947219848633, -2.09347391497214, 218, 39, 'PPL', 'P'),
(30346, 'Lincoln Pioneer Village', 37.8800010681152, 0.66113073929758, -87.0583267211914, -1.51945444256175, 218, 19, 'PPL', 'P'),
(36897, 'Lincoln Ridge', 38.2183303833008, 0.667035699803585, -85.3752822875977, -1.49007977573818, 218, 21, 'PPL', 'P'),
(120363, 'Lincoln Square (historical)', 41.975830078125, 0.73261644112095, -87.6891708374023, -1.53046474945646, 218, 18, 'PPL', 'P'),
(10101, 'Lincoln Terrace', 34.9263916015625, 0.609580529288161, -91.9533309936523, -1.60488838401538, 218, 4, 'PPL', 'P'),
(163819, 'Lincoln Terrace', 40.6916694641113, 0.710203610281979, -75.2566680908203, -1.31347664226537, 218, 45, 'PPL', 'P'),
(198529, 'Lincoln Valley', 47.6383285522461, 0.831445683383518, -100.303886413574, -1.75063307046328, 218, 34, 'PPL', 'P'),
(14116, 'Lincoln Village', 38.8672218322754, 0.678360992076229, -75.4394378662109, -1.31666657661907, 218, 10, 'PPL', 'P'),
(73235, 'Lincoln Village', 39.954719543457, 0.697341407744251, -83.1308288574219, -1.45090667347393, 218, 41, 'PPL', 'P'),
(123070, 'Lincoln Village', 41.4741706848145, 0.723860832984124, -87.3819427490234, -1.52510260775964, 218, 19, 'PPL', 'P'),
(182811, 'Lincoln Village', 33.8277816772461, 0.590406168913754, -118.221939086914, -2.06336208515883, 218, 6, 'PPL', 'P'),
(22679, 'Lincolndale', 33.6502799987793, 0.587308180196692, -84.2522201538086, -1.47047864379908, 218, 13, 'PPL', 'P'),
(150282, 'Lincolndale', 41.3227806091309, 0.721218577708602, -73.7186126708984, -1.28663251110959, 218, 40, 'PPL', 'P'),
(103691, 'Lincolnia', 38.8183288574219, 0.67750764868394, -77.1436080932617, -1.34640995809556, 218, 53, 'PPL', 'P'),
(103692, 'Lincolnia Heights', 38.8294410705566, 0.677701593390325, -77.149169921875, -1.3465070303173, 218, 53, 'PPL', 'P'),
(103693, 'Lincolnia Park', 38.815559387207, 0.677459312310155, -77.1452789306641, -1.3464391197095, 218, 53, 'PPL', 'P'),
(36898, 'Lincolnshire', 38.2230606079102, 0.667118257797378, -85.6213912963867, -1.49437518826036, 218, 21, 'PPL', 'P'),
(82107, 'Lincolnshire', 34.0924987792969, 0.595026353930878, -81.0330581665039, -1.41429366796557, 218, 48, 'PPL', 'P'),
(110120, 'Lincolnshire', 39.1741714477539, 0.683718273504059, -81.5177764892578, -1.42275359864237, 218, 58, 'PPL', 'P'),
(120365, 'Lincolnshire', 42.189998626709, 0.736354387447958, -87.908332824707, -1.53428984773015, 218, 18, 'PPL', 'P'),
(123075, 'Lincolnshire', 41.0275001525879, 0.716064961525135, -85.1402816772461, -1.48597824134334, 218, 19, 'PPL', 'P'),
(22680, 'Lincolnton', 33.7922210693359, 0.589785519221711, -82.4791717529297, -1.43953311140653, 218, 13, 'PPL', 'P'),
(66386, 'Lincolnton', 35.4736099243164, 0.619131290747458, -81.2547225952148, -1.41816244208113, 218, 33, 'PPL', 'P'),
(33086, 'Lincolnville', 38.4933280944824, 0.671835315299153, -96.959716796875, -1.69226629990672, 218, 20, 'PPL', 'P'),
(73236, 'Lincolnville', 39.0986099243164, 0.682399476132252, -83.4019393920898, -1.45563844494073, 218, 41, 'PPL', 'P'),
(76412, 'Lincolnville', 36.9436111450195, 0.644787652057063, -94.7569427490234, -1.65382064009423, 218, 42, 'PPL', 'P'),
(82108, 'Lincolnville', 33.0066719055176, 0.576075099876793, -80.1555633544922, -1.3989784943268, 218, 48, 'PPL', 'P'),
(123076, 'Lincolnville', 40.7544403076172, 0.711299168175411, -85.6777801513672, -1.4953593594412, 218, 19, 'PPL', 'P'),
(127960, 'Lincolnville', 44.2811088562012, 0.772851145974731, -69.0091705322266, -1.2044372398576, 218, 26, 'PPL', 'P'),
(150283, 'Lincolnville', 42.8325004577637, 0.747568159849955, -73.5744400024414, -1.28411622335363, 218, 40, 'PPL', 'P'),
(163825, 'Lincolnville', 41.7936096191406, 0.729436094147177, -79.8383331298828, -1.39344178242052, 218, 45, 'PPL', 'P'),
(127961, 'Lincolnville Center', 44.297779083252, 0.773142096323822, -69.1080627441406, -1.20616323456008, 218, 26, 'PPL', 'P'),
(116548, 'Lincolnway Village', 41.9213905334473, 0.731666291823037, -91.665283203125, -1.59986100166759, 218, 16, 'PPL', 'P'),
(120366, 'Lincolnwood', 42.0044403076172, 0.73311578382534, -87.7300033569336, -1.53117741136417, 218, 18, 'PPL', 'P'),
(120367, 'Lincolnwood Hills', 41.5113906860352, 0.724510444553021, -87.9124984741211, -1.5343625520279, 218, 18, 'PPL', 'P'),
(163826, 'Linconia', 40.125560760498, 0.700323149479731, -74.982780456543, -1.30869640126673, 218, 45, 'PPL', 'P'),
(88591, 'Lincoya Hills', 36.1797218322754, 0.631455268428881, -86.6766662597656, -1.51279321088519, 218, 50, 'PPL', 'P'),
(48947, 'Lincrest', 39.4647216796875, 0.688789331693734, -76.3777770996094, -1.33304368574251, 218, 25, 'PPL', 'P'),
(145611, 'Lincroft', 40.3305587768555, 0.703901039825225, -74.1213912963867, -1.29366232428102, 218, 37, 'PPL', 'P'),
(174994, 'Lind', 45.7400016784668, 0.798313629156978, -92.795280456543, -1.61958317427822, 218, 57, 'PPL', 'P'),
(207928, 'Lind', 46.9722213745117, 0.819819919960886, -118.614166259766, -2.07020774074088, 218, 56, 'PPL', 'P'),
(55920, 'Linda', 36.410831451416, 0.635488892215915, -89.5469436645508, -1.56288900204429, 218, 29, 'PPL', 'P'),
(182810, 'Linda', 39.1277809143066, 0.682908605953648, -121.54972076416, -2.12144283221431, 218, 6, 'PPL', 'P'),
(182812, 'Linda Mar', 37.5955581665039, 0.656166274130536, -122.493057250977, -2.13790715986346, 218, 6, 'PPL', 'P'),
(182813, 'Linda Rose', 33.5291709899902, 0.585194429239496, -117.174438476563, -2.04507975059154, 218, 6, 'PPL', 'P'),
(95722, 'Linda Vista', 26.8819408416748, 0.469178377013561, -99.2794418334961, -1.7327531395367, 218, 51, 'PPL', 'P'),
(182815, 'Linda Vista', 32.7833290100098, 0.572177030989243, -117.170562744141, -2.04501210629986, 218, 6, 'PPL', 'P'),
(182816, 'Linda Vista (historical)', 32.8777809143066, 0.573825527704003, -117.173606872559, -2.0450652363636, 218, 6, 'PPL', 'P'),
(95723, 'Linda Vista Estates Colonia', 26.2649993896484, 0.458410717383666, -98.322998046875, -1.71606004634992, 218, 51, 'PPL', 'P'),
(22681, 'Lindale', 34.1866683959961, 0.596669923797621, -85.1747207641602, -1.48657931680138, 218, 13, 'PPL', 'P'),
(55921, 'Lindale', 38.1533317565918, 0.665901259758239, -94.0436096191406, -1.64137062831421, 218, 29, 'PPL', 'P'),
(73238, 'Lindale', 38.9900016784668, 0.680503904647361, -84.2099990844727, -1.46974174712546, 218, 41, 'PPL', 'P'),
(95724, 'Lindale', 32.5155601501465, 0.567503582750318, -95.4091720581055, -1.66520418901572, 218, 51, 'PPL', 'P'),
(10104, 'Lindale (historical)', 33.7425003051758, 0.588917728180509, -92.3547210693359, -1.61189396242089, 218, 4, 'PPL', 'P'),
(116549, 'Lindale Manor', 42.0319404602051, 0.733595752032799, -91.6263885498047, -1.59918216190572, 218, 16, 'PPL', 'P'),
(14117, 'Lindamere', 39.7611083984375, 0.693962255795104, -75.4930572509766, -1.31760241142612, 218, 10, 'PPL', 'P'),
(48949, 'Lindamoor on the Severn', 39.0013885498047, 0.680702643043708, -76.5130615234375, -1.33540484436497, 218, 25, 'PPL', 'P'),
(103695, 'Lindau Woods', 38.6500015258789, 0.674569782527419, -77.4058303833008, -1.35098660042886, 218, 53, 'PPL', 'P'),
(88596, 'Lindauer (historical)', 35.4375, 0.618501053675491, -87.4250030517578, -1.52585415181926, 218, 50, 'PPL', 'P'),
(163827, 'Lindaville', 41.7277793884277, 0.72828713987389, -75.8147201538086, -1.32321648816206, 218, 45, 'PPL', 'P'),
(95725, 'Lindberg', 32.6822204589844, 0.57041235387193, -97.2141723632813, -1.69670738734053, 218, 51, 'PPL', 'P'),
(163828, 'Lindberg Heights', 40.228328704834, 0.702116788473899, -75.5316696166992, -1.31827632433996, 218, 45, 'PPL', 'P'),
(55922, 'Lindbergh', 38.9558296203613, 0.679907489721238, -92.128059387207, -1.60793796977963, 218, 29, 'PPL', 'P'),
(163829, 'Lindbergh', 41.1105613708496, 0.717514653264519, -75.9441680908203, -1.32547578087283, 218, 45, 'PPL', 'P'),
(201139, 'Lindbergh', 46.0750007629395, 0.804160466172193, -122.904998779297, -2.14509689585834, 218, 43, 'PPL', 'P'),
(150284, 'Lindbergh Lawns', 43.1147193908691, 0.75249380944411, -76.2566680908203, -1.33092993478531, 218, 40, 'PPL', 'P'),
(33087, 'Lindbloom Park (historical)', 38.9850006103516, 0.680416619542634, -95.621940612793, -1.66891770083972, 218, 20, 'PPL', 'P'),
(182817, 'Lindcove', 36.357780456543, 0.634562977683922, -119.063606262207, -2.07805194857365, 218, 6, 'PPL', 'P'),
(55923, 'Lindell', 38.1708297729492, 0.666206657756243, -91.7916717529297, -1.6020668979985, 218, 29, 'PPL', 'P'),
(66388, 'Lindell', 35.5491714477539, 0.620450088119265, -77.8127822875977, -1.3580892510561, 218, 33, 'PPL', 'P'),
(103696, 'Lindell', 36.8044395446777, 0.642358649405829, -81.9008331298828, -1.42943919824291, 218, 53, 'PPL', 'P'),
(14118, 'Lindell Square', 39.7277793884277, 0.693380554834003, -75.6750030517578, -1.32077796470993, 218, 10, 'PPL', 'P'),
(14119, 'Lindell Village', 39.7208290100098, 0.69325924784635, -75.6680603027344, -1.32065679088033, 218, 10, 'PPL', 'P'),
(3784, 'Linden', 32.3061103820801, 0.563847994680021, -87.7980575561523, -1.53236518121034, 218, 2, 'PPL', 'P'),
(16905, 'Linden', 28.5616703033447, 0.498495186662453, -82.0341720581055, -1.43176640156147, 218, 12, 'PPL', 'P'),
(22682, 'Linden', 32.4613914489746, 0.56655816056334, -84.9238891601563, -1.48220147944345, 218, 13, 'PPL', 'P'),
(48950, 'Linden', 39.0080604553223, 0.680819089762372, -77.0494384765625, -1.34476638822882, 218, 25, 'PPL', 'P'),
(66389, 'Linden', 35.2547187805176, 0.615310919584712, -78.7474975585938, -1.37440311010366, 218, 33, 'PPL', 'P'),
(88593, 'Linden', 35.6172218322754, 0.621637791386413, -87.8394393920898, -1.53308743049797, 218, 50, 'PPL', 'P'),
(95726, 'Linden', 33.0122184753418, 0.576171905782417, -94.3652801513672, -1.64698483820821, 218, 51, 'PPL', 'P'),
(103698, 'Linden', 36.9152793884277, 0.644293169621663, -82.8211135864258, -1.44550112225134, 218, 53, 'PPL', 'P'),
(110121, 'Linden', 38.7197189331055, 0.675786580829477, -81.2111129760742, -1.41740131064159, 218, 58, 'PPL', 'P'),
(113150, 'Linden', 40.4863891601563, 0.706620793088468, -95.5372161865234, -1.66743898064445, 218, 29, 'PPL', 'P'),
(116550, 'Linden', 41.6444396972656, 0.726832587865516, -94.2688903808594, -1.64530251934761, 218, 16, 'PPL', 'P'),
(123077, 'Linden', 40.188060760498, 0.701413980262227, -86.9038925170898, -1.51675905722248, 218, 19, 'PPL', 'P'),
(125244, 'Linden', 42.4333305358887, 0.740601330438307, -71.0319366455078, -1.23974116853213, 218, 23, 'PPL', 'P'),
(131790, 'Linden', 42.8144416809082, 0.747252974734944, -83.7825012207031, -1.46228050185744, 218, 27, 'PPL', 'P'),
(136515, 'Linden', 44.1813888549805, 0.771110703623337, -94.4091720581055, -1.64775089649577, 218, 28, 'PPL', 'P'),
(145612, 'Linden', 40.621940612793, 0.70898661224284, -74.245002746582, -1.29581975108009, 218, 37, 'PPL', 'P'),
(150285, 'Linden', 42.8769416809082, 0.74834380551744, -78.1636123657227, -1.36421239103441, 218, 40, 'PPL', 'P'),
(156168, 'Linden', 40.0200004577637, 0.698480774637614, -82.9733276367188, -1.44815775859675, 218, 41, 'PPL', 'P'),
(163831, 'Linden', 40.2280616760254, 0.702112127941992, -80.14111328125, -1.39872629297157, 218, 45, 'PPL', 'P'),
(174996, 'Linden', 42.917781829834, 0.7490566005832, -90.2733306884766, -1.57556684725556, 218, 57, 'PPL', 'P'),
(178536, 'Linden', 34.2849998474121, 0.598386131383095, -110.156387329102, -1.92259165099498, 218, 5, 'PPL', 'P'),
(182818, 'Linden', 38.0213890075684, 0.663598424363647, -121.082778930664, -2.11329315980451, 218, 6, 'PPL', 'P'),
(195251, 'Linden', 46.6708297729492, 0.814559644175761, -116.497222900391, -2.03326010904155, 218, 17, 'PPL', 'P'),
(209569, 'Linden', 44.3205604553223, 0.773539706274571, -104.595832824707, -1.8255416666567, 218, 59, 'PPL', 'P'),
(60639, 'Linden (historical)', 32.1938896179199, 0.561889372856322, -90.0758285522461, -1.57211978469861, 218, 30, 'PPL', 'P'),
(156169, 'Linden (historical)', 41.2172203063965, 0.719376202866485, -83.2266693115234, -1.45257940495461, 218, 41, 'PPL', 'P'),
(150286, 'Linden Acres', 42.0122184753418, 0.733251538461906, -73.8794403076172, -1.28943948289853, 218, 40, 'PPL', 'P'),
(170763, 'Linden Beach', 45.4047203063965, 0.792461865293747, -96.6483306884766, -1.68683158707019, 218, 49, 'PPL', 'P'),
(174997, 'Linden Beach', 43.8541717529297, 0.765399687823716, -88.3733291625977, -1.54240556483605, 218, 57, 'PPL', 'P'),
(48951, 'Linden Chapel Hills', 39.2311096191406, 0.684712032064823, -76.9922180175781, -1.34376770282004, 218, 25, 'PPL', 'P'),
(48952, 'Linden Chapel Woods', 39.2299995422363, 0.684692657567892, -76.9836120605469, -1.34361750053456, 218, 25, 'PPL', 'P'),
(204709, 'Linden Circle', 40.6411094665527, 0.709321171854782, -111.829437255859, -1.95179188076716, 218, 52, 'PPL', 'P'),
(48953, 'Linden Estates', 39.648609161377, 0.691998773702416, -77.0263900756836, -1.34436411774616, 218, 25, 'PPL', 'P'),
(14120, 'Linden Green Apartment', 39.7319412231445, 0.693453192552735, -75.6916732788086, -1.32106891505902, 218, 10, 'PPL', 'P'),
(136516, 'Linden Grove', 47.8630599975586, 0.835367987036987, -92.8702774047852, -1.620892117954, 218, 28, 'PPL', 'P'),
(163832, 'Linden Grove', 40.3672218322754, 0.704540930856144, -80.0152816772461, -1.39653011717864, 218, 45, 'PPL', 'P'),
(163833, 'Linden Hall', 40.7969398498535, 0.712040925118025, -77.7611083984375, -1.35718737155295, 218, 45, 'PPL', 'P'),
(14121, 'Linden Heath', 39.7374992370605, 0.693550198195441, -75.6958312988281, -1.32114148619873, 218, 10, 'PPL', 'P'),
(103699, 'Linden Heights', 38.9388885498047, 0.679611812261212, -78.0533294677734, -1.36228759135656, 218, 53, 'PPL', 'P'),
(14122, 'Linden Hill', 39.7299995422363, 0.693419303827864, -75.6938934326172, -1.32110766405288, 218, 10, 'PPL', 'P'),
(150287, 'Linden Hill', 40.7155609130859, 0.710620594729658, -73.9238891601563, -1.29021526172407, 218, 40, 'PPL', 'P'),
(131791, 'Linden Hills', 42.3041687011719, 0.738347031154582, -86.3247222900391, -1.50665062983092, 218, 27, 'PPL', 'P'),
(48955, 'Linden Springs', 39.714168548584, 0.693143000864768, -76.7177810668945, -1.33897787444148, 218, 25, 'PPL', 'P'),
(14123, 'Linden Square', 39.7277793884277, 0.693380554834003, -75.6958312988281, -1.32114148619873, 218, 10, 'PPL', 'P'),
(150288, 'Linden-Park', 40.5922203063965, 0.70846789504152, -74.091667175293, -1.29314354050067, 218, 40, 'PPL', 'P'),
(95728, 'Lindenau', 29.1175003051758, 0.508196250275771, -97.3705596923828, -1.69943686114176, 218, 51, 'PPL', 'P'),
(145614, 'Lindenau', 40.5149993896484, 0.707120135792858, -74.4113922119141, -1.29872379509077, 218, 37, 'PPL', 'P'),
(95729, 'Lindendale', 30.1117095947266, 0.525548475832346, -98.631721496582, -1.72144828702543, 218, 51, 'PPL', 'P'),
(103700, 'Lindendale', 38.6549987792969, 0.674657001053119, -77.3602828979492, -1.35019164684347, 218, 53, 'PPL', 'P'),
(73239, 'Lindenhall', 39.7027816772461, 0.692944262468421, -84.1277770996094, -1.46830670277207, 218, 41, 'PPL', 'P'),
(120369, 'Lindenhurst', 42.4105606079102, 0.74020392022464, -88.0261077880859, -1.53634540861752, 218, 18, 'PPL', 'P'),
(150289, 'Lindenhurst', 40.6866683959961, 0.710116325177252, -73.373893737793, -1.28061603073294, 218, 40, 'PPL', 'P'),
(156171, 'Lindentree', 40.6049995422363, 0.708690934782814, -81.3011093139648, -1.41897204305251, 218, 41, 'PPL', 'P'),
(73240, 'Lindenwald', 39.3722190856934, 0.687174856861901, -84.5591735839844, -1.47583599180594, 218, 41, 'PPL', 'P'),
(71034, 'Lindenwold', 39.8241691589355, 0.695062873694606, -74.9980621337891, -1.3089631168499, 218, 37, 'PPL', 'P'),
(30348, 'Lindenwood', 39.6586112976074, 0.69217334391187, -86.154167175293, -1.50367388152249, 218, 19, 'PPL', 'P'),
(103701, 'Lindenwood', 37.2733306884766, 0.650542343698561, -79.8605575561523, -1.39382967183329, 218, 53, 'PPL', 'P'),
(120370, 'Lindenwood', 42.0530586242676, 0.733964333527666, -89.0305633544922, -1.5538764654413, 218, 18, 'PPL', 'P'),
(125245, 'Lindenwood', 42.4833297729492, 0.741473981748499, -71.1083297729492, -1.24107448013188, 218, 23, 'PPL', 'P'),
(10105, 'Linder', 35.1902809143066, 0.614186266656371, -92.3727798461914, -1.6122091475359, 218, 4, 'PPL', 'P'),
(22683, 'Linder', 31.3875007629395, 0.547815232285526, -83.4930572509766, -1.45722875158567, 218, 13, 'PPL', 'P'),
(10106, 'Linders Mill (historical)', 34.9930610656738, 0.610744130947444, -90.5852813720703, -1.58101141378811, 218, 4, 'PPL', 'P'),
(139285, 'Lindersville (historical)', 40.0944404602051, 0.699779997775409, -92.7052764892578, -1.61801230870924, 218, 29, 'PPL', 'P'),
(136519, 'Lindford', 48.410831451416, 0.844928402455235, -93.7816696166992, -1.63679891282893, 218, 28, 'PPL', 'P'),
(16906, 'Lindgren', 25.6002807617188, 0.446809188726954, -80.4297180175781, -1.40376339585734, 218, 12, 'PPL', 'P'),
(16907, 'Lindgren Acres', 25.670280456543, 0.448030913877028, -80.4013900756836, -1.40326898000097, 218, 12, 'PPL', 'P'),
(48956, 'Lindill Estates', 39.5227813720703, 0.689802664488509, -76.352783203125, -1.33260745995595, 218, 25, 'PPL', 'P'),
(175000, 'Lindina', 43.7599983215332, 0.763756051377947, -90.1469421386719, -1.57336095092464, 218, 57, 'PPL', 'P'),
(196913, 'Lindisfarne', 47.8088912963867, 0.834422564850008, -114.227500915527, -1.99364598730079, 218, 31, 'PPL', 'P'),
(76413, 'Lindley', 36.2061080932617, 0.631915795560383, -98.2324981689453, -1.7144805255074, 218, 42, 'PPL', 'P'),
(139286, 'Lindley', 40.0819396972656, 0.699561818303104, -93.3680572509766, -1.62958001522011, 218, 29, 'PPL', 'P'),
(150291, 'Lindley', 42.0283317565918, 0.733532768273019, -77.1399993896484, -1.34634697433578, 218, 40, 'PPL', 'P'),
(66390, 'Lindley Park', 36.0688896179199, 0.629520881371102, -79.8324966430664, -1.39333991650883, 218, 33, 'PPL', 'P'),
(186990, 'Lindon', 39.7394409179688, 0.693584086920312, -103.413330078125, -1.80490310031497, 218, 7, 'PPL', 'P'),
(204710, 'Lindon', 40.3433303833008, 0.704123946408465, -111.720001220703, -1.94988186163335, 218, 52, 'PPL', 'P'),
(188879, 'Lindrith', 36.3044395446777, 0.633632003145857, -107.044441223145, -1.86827794530142, 218, 38, 'PPL', 'P'),
(163834, 'Linds Crossing', 40.4419403076172, 0.705845014262928, -78.3219375610352, -1.36697568698148, 218, 45, 'PPL', 'P'),
(41807, 'Lindsay', 30.7175006866455, 0.536121524965583, -91.2177810668945, -1.59205061598066, 218, 22, 'PPL', 'P'),
(76414, 'Lindsay', 34.8347206115723, 0.607980568684269, -97.6022186279297, -1.70348007230872, 218, 42, 'PPL', 'P'),
(103702, 'Lindsay', 38.0880584716797, 0.66476202602293, -78.2466735839844, -1.3656620827738, 218, 53, 'PPL', 'P'),
(142262, 'Lindsay', 41.7000007629395, 0.727802311397441, -97.6936111450195, -1.70507517264362, 218, 35, 'PPL', 'P'),
(182820, 'Lindsay', 36.2030601501465, 0.631862598917609, -119.087219238281, -2.07846407275234, 218, 6, 'PPL', 'P'),
(191766, 'Lindsay', 31.3691692352295, 0.547495286770066, -103.537498474121, -1.80707024765202, 218, 51, 'PPL', 'P'),
(196914, 'Lindsay', 47.2188911437988, 0.824125119600081, -105.153327941895, -1.83527179201541, 218, 31, 'PPL', 'P'),
(172199, 'Lindsay Beach', 44.9708290100098, 0.784889033576052, -72.1891708374023, -1.25993871539734, 218, 55, 'PPL', 'P'),
(191767, 'Lindsay Division Colonia', 31.3689994812012, 0.547492324003354, -103.537002563477, -1.80706159237848, 218, 51, 'PPL', 'P'),
(88594, 'Lindsay Mill', 36.2599983215332, 0.632856357478372, -84.1458282470703, -1.46862175472903, 218, 50, 'PPL', 'P'),
(136520, 'Lindsay Mobile Home Court', 44.6088905334473, 0.778572015470384, -95.6833267211914, -1.66998909054626, 218, 28, 'PPL', 'P'),
(195252, 'Lindsayville', 42.4300003051758, 0.740543206947516, -111.42138671875, -1.94467005538007, 218, 17, 'PPL', 'P'),
(88595, 'Lindsayville (historical)', 36.1341705322266, 0.630660248264465, -86.415283203125, -1.50823121593788, 218, 50, 'PPL', 'P'),
(33090, 'Lindsborg', 38.5736083984375, 0.673236470927671, -97.6741714477539, -1.70473588592074, 218, 20, 'PPL', 'P'),
(3786, 'Lindsey', 31.7580604553223, 0.554282718992783, -85.4694366455078, -1.49172307928881, 218, 2, 'PPL', 'P'),
(10108, 'Lindsey', 35.9908294677734, 0.628158474736445, -91.0163879394531, -1.58853564281591, 218, 4, 'PPL', 'P'),
(22684, 'Lindsey', 32.6613883972168, 0.570048765804107, -83.1138916015625, -1.45061106259293, 218, 13, 'PPL', 'P'),
(33089, 'Lindsey', 39.0936088562012, 0.682312191027525, -97.6777801513672, -1.70479886968052, 218, 20, 'PPL', 'P'),
(110123, 'Lindsey', 37.5391693115234, 0.655182102949697, -82.0294418334961, -1.43168384356768, 218, 58, 'PPL', 'P'),
(156170, 'Lindsey', 41.4188919067383, 0.722896036300215, -83.2213897705078, -1.45248725958089, 218, 41, 'PPL', 'P'),
(177422, 'Lindsey', 44.5558280944824, 0.777645901201309, -90.3000030517578, -1.5760323678141, 218, 57, 'PPL', 'P'),
(22685, 'Lindsey (historical)', 33.1297187805176, 0.578222672979832, -82.834716796875, -1.44573854306252, 218, 13, 'PPL', 'P'),
(204711, 'Lindsey Circle Condominium', 40.7802810668945, 0.711750174506016, -111.86499786377, -1.9524125304592, 218, 52, 'PPL', 'P'),
(3788, 'Lindseys Crossing', 33.230281829834, 0.579977829296249, -86.9272232055664, -1.51716625455315, 218, 2, 'PPL', 'P'),
(36899, 'Lindseyville', 37.2358283996582, 0.649887805281647, -86.2944412231445, -1.50612212551259, 218, 21, 'PPL', 'P'),
(110124, 'Lindside', 37.4536094665527, 0.653688801947462, -80.6699981689453, -1.40795707562589, 218, 58, 'PPL', 'P'),
(88597, 'Lindsley (historical)', 36.2813911437988, 0.633229732663201, -86.5455627441406, -1.51050502287659, 218, 50, 'PPL', 'P'),
(150292, 'Lindsley Corners', 43.172779083252, 0.753507142238886, -74.3691711425781, -1.29798689841714, 218, 40, 'PPL', 'P'),
(55928, 'Lindstrew Ford', 37.2652816772461, 0.650401861951059, -92.9216690063477, -1.62178907060913, 218, 29, 'PPL', 'P'),
(136521, 'Lindstrom', 45.3894386291504, 0.792195149710576, -92.8477783203125, -1.62049943485126, 218, 28, 'PPL', 'P'),
(10109, 'Lindulake Addition', 34.9986114501953, 0.610841003432096, -92.0566711425781, -1.60669200986364, 218, 4, 'PPL', 'P'),
(142263, 'Lindy', 42.7341690063477, 0.74585195226448, -97.7397232055664, -1.70587997992504, 218, 35, 'PPL', 'P'),
(110125, 'Lindytown', 37.9097213745117, 0.6616494564989, -81.6025009155273, -1.42423231883764, 218, 58, 'PPL', 'P'),
(163836, 'Line Lexington', 40.2891693115234, 0.703178657379541, -75.2613906860352, -1.31355906710111, 218, 45, 'PPL', 'P'),
(163837, 'Line Mountain', 40.7125015258789, 0.710567198349802, -76.557502746582, -1.33618049003246, 218, 45, 'PPL', 'P'),
(48959, 'Line Ridge', 38.6319389343262, 0.674254530833381, -76.5663909912109, -1.33633561916596, 218, 25, 'PPL', 'P'),
(88598, 'Line Spring', 35.6966705322266, 0.62302443278699, -83.6522216796875, -1.46000669491873, 218, 50, 'PPL', 'P'),
(10110, 'Line Store (historical)', 36.4977798461914, 0.63700642798407, -94.024169921875, -1.64103134159134, 218, 4, 'PPL', 'P'),
(88599, 'Lineback (historical)', 36.3088912963867, 0.633709700870661, -82.0041732788086, -1.43124282409116, 218, 50, 'PPL', 'P'),
(66392, 'Lineberger Acres', 35.8258285522461, 0.625278665491688, -80.3147201538086, -1.40175630450181, 218, 33, 'PPL', 'P'),
(48957, 'Lineboro', 39.7186088562012, 0.693220498852489, -76.8441696166992, -1.34118377077239, 218, 25, 'PPL', 'P'),
(125246, 'Linebrook', 42.6800003051758, 0.744906530077502, -70.9291687011719, -1.23794752953796, 218, 23, 'PPL', 'P'),
(110126, 'Lineburg', 39.6380615234375, 0.691814682692064, -78.3469390869141, -1.36741204592609, 218, 58, 'PPL', 'P'),
(36901, 'Linefork', 37.019718170166, 0.646115970229767, -82.959716796875, -1.44792020462751, 218, 21, 'PPL', 'P'),
(127964, 'Linekin', 43.839168548584, 0.765137832509534, -69.591667175293, -1.21460372416092, 218, 26, 'PPL', 'P'),
(88600, 'Liners', 36.3822212219238, 0.634989549511525, -87.5711135864258, -1.52840426172107, 218, 50, 'PPL', 'P'),
(36900, 'Lines Mill', 37.3580589294434, 0.652021130472855, -86.0427780151367, -1.50172977392673, 218, 21, 'PPL', 'P'),
(22688, 'Linesville', 33.8438911437988, 0.590687332145839, -82.8652801513672, -1.44627197422886, 218, 13, 'PPL', 'P'),
(163838, 'Linesville', 41.6561088562012, 0.72703625310988, -80.4241714477539, -1.40366658995172, 218, 45, 'PPL', 'P'),
(3791, 'Lineville', 33.3105583190918, 0.58137891834574, -85.7544403076172, -1.49669733157286, 218, 2, 'PPL', 'P'),
(116552, 'Lineville', 40.5813903808594, 0.708278877183152, -93.5236129760742, -1.63229497479339, 218, 16, 'PPL', 'P'),
(163840, 'Linfield', 40.2099990844727, 0.701796876247953, -75.5702819824219, -1.31895023725381, 218, 45, 'PPL', 'P'),
(195253, 'Linfor', 47.6083297729492, 0.830922105913208, -116.234718322754, -2.02867853986024, 218, 17, 'PPL', 'P'),
(204712, 'Linford Acres', 40.6555595397949, 0.709573373210012, -112.011108398438, -1.95496264036101, 218, 52, 'PPL', 'P'),
(48958, 'Linganore', 39.4402809143066, 0.68836275986613, -77.2083282470703, -1.34753953787192, 218, 25, 'PPL', 'P'),
(48960, 'Linganore View', 39.3694381713867, 0.687126320751034, -77.2333297729492, -1.34797589681653, 218, 25, 'PPL', 'P'),
(48961, 'Linganore Woods', 39.4486083984375, 0.688508101882621, -77.2138900756836, -1.34763661009365, 218, 25, 'PPL', 'P'),
(182821, 'Lingard', 37.2402801513672, 0.64996550300645, -120.396392822266, -2.101313462273, 218, 6, 'PPL', 'P'),
(196915, 'Lingenpolter', 46.5327796936035, 0.81215021575854, -112.966667175293, -1.97164028721346, 218, 31, 'PPL', 'P'),
(88601, 'Linger Lake', 36.0138893127441, 0.628560944956183, -84.9847183227539, -1.48326314861201, 218, 50, 'PPL', 'P'),
(60648, 'Lingle', 32.1955604553223, 0.561918534470258, -89.5772171020508, -1.56341737320456, 218, 30, 'PPL', 'P'),
(209570, 'Lingle', 42.1363906860352, 0.735418752377986, -104.345001220703, -1.82116382929877, 218, 59, 'PPL', 'P'),
(82109, 'Lingles Crossroads', 34.7563896179199, 0.606613434938677, -80.6294403076172, -1.40724920740815, 218, 48, 'PPL', 'P'),
(163841, 'Linglestown', 40.3338890075684, 0.703959163316016, -76.789436340332, -1.34022849488938, 218, 45, 'PPL', 'P'),
(95731, 'Lingleville', 32.2444381713867, 0.562771611546438, -98.3772201538086, -1.71700640064328, 218, 51, 'PPL', 'P'),
(55929, 'Lingo', 39.7680587768555, 0.694083562782757, -92.8202819824219, -1.62001953322283, 218, 29, 'PPL', 'P'),
(188880, 'Lingo', 33.788330078125, 0.589717608613914, -103.114166259766, -1.79968170668176, 218, 38, 'PPL', 'P'),
(14129, 'Lingo Estate Mobile Home Park', 38.6302795410156, 0.674225568956527, -75.1752777099609, -1.31205611213992, 218, 10, 'PPL', 'P'),
(14125, 'Lingo Landing', 38.6336097717285, 0.674283692447318, -75.1244430541992, -1.31116888002276, 218, 10, 'PPL', 'P'),
(196916, 'Lingshire', 46.8411102294922, 0.817531598794235, -111.406669616699, -1.94441319349293, 218, 31, 'PPL', 'P'),
(163842, 'Linhart', 40.4225006103516, 0.705505727540052, -79.8147201538086, -1.39302965824183, 218, 45, 'PPL', 'P'),
(48962, 'Linhigh', 39.3580589294434, 0.686927715512741, -76.5138931274414, -1.33541935859291, 218, 25, 'PPL', 'P'),
(88602, 'Link', 35.7166709899902, 0.623373506626872, -86.5063934326172, -1.50982138942477, 218, 50, 'PPL', 'P'),
(110127, 'Link', 39.4844398498535, 0.689133478685599, -80.7474975585938, -1.40930969514354, 218, 58, 'PPL', 'P'),
(156172, 'Link (historical)', 41.2372207641602, 0.719725276706367, -84.795280456543, -1.47995683411868, 218, 41, 'PPL', 'P'),
(95732, 'Link Five', 29.7041702270508, 0.518435572034908, -95.0947189331055, -1.65971594664128, 218, 51, 'PPL', 'P'),
(103703, 'Linkhorn', 36.8613891601563, 0.643352607703674, -76.0238876342773, -1.32686714938434, 218, 53, 'PPL', 'P'),
(103704, 'Linkhorn Estates', 36.8650016784668, 0.643415658042482, -76.0186080932617, -1.32677500401063, 218, 53, 'PPL', 'P'),
(103705, 'Linkhorn Park', 36.8669395446777, 0.643449480188326, -75.9933319091797, -1.32633385137605, 218, 53, 'PPL', 'P'),
(103706, 'Linkhorn Shores', 36.8769416809082, 0.64362405039778, -76.0166702270508, -1.32674118186478, 218, 53, 'PPL', 'P'),
(22689, 'Links of Leith', 33.5844383239746, 0.586159026186323, -84.8655624389648, -1.48118348611677, 218, 13, 'PPL', 'P'),
(178537, 'Links Point', 33.5933303833008, 0.586314221898847, -111.968063354492, -1.9542113626175, 218, 5, 'PPL', 'P'),
(82110, 'Linkside', 34.4605598449707, 0.601450231375285, -79.3244400024414, -1.3844726553433, 218, 48, 'PPL', 'P'),
(55931, 'Linkville', 39.3111114501953, 0.686108327424351, -94.6488876342773, -1.65193472256829, 218, 29, 'PPL', 'P'),
(123078, 'Linkville', 41.4161109924316, 0.722847500189348, -86.2869415283203, -1.50599123114502, 218, 19, 'PPL', 'P'),
(131793, 'Linkville', 43.7580604553223, 0.763722229232103, -83.267219543457, -1.45328714001429, 218, 27, 'PPL', 'P'),
(48963, 'Linkwood', 38.5397186279297, 0.672644982849565, -75.9463882446289, -1.32551452986669, 218, 25, 'PPL', 'P'),
(196917, 'Linley (historical)', 45.2847213745117, 0.790367488833482, -109.423606872559, -1.90980221933404, 218, 31, 'PPL', 'P'),
(103708, 'Linlier', 36.850830078125, 0.64316831695624, -76.0166702270508, -1.32674118186478, 218, 53, 'PPL', 'P'),
(150293, 'Linlithgo', 42.1713905334473, 0.736029614953023, -73.8475036621094, -1.28888208328238, 218, 40, 'PPL', 'P'),
(150294, 'Linlithgo Mills', 42.1741714477539, 0.736078151063889, -73.7472229003906, -1.28713185381398, 218, 40, 'PPL', 'P'),
(33091, 'Linn', 39.6800003051758, 0.692546652517672, -97.0838928222656, -1.69443358040183, 218, 20, 'PPL', 'P'),
(60640, 'Linn', 33.6597213745117, 0.587472963289141, -90.6163864135742, -1.58155429917633, 218, 30, 'PPL', 'P'),
(73241, 'Linn', 39.1011085510254, 0.682443085395102, -82.8141708374023, -1.44537994842174, 218, 41, 'PPL', 'P'),
(76416, 'Linn', 34.1180610656738, 0.595472499992494, -96.6247177124023, -1.6864194628915, 218, 42, 'PPL', 'P'),
(95733, 'Linn', 26.5597190856934, 0.463554546450127, -98.1216735839844, -1.71254627160767, 218, 51, 'PPL', 'P'),
(110128, 'Linn', 39.0080604553223, 0.680819089762372, -80.7191696166992, -1.40881527928717, 218, 58, 'PPL', 'P'),
(112417, 'Linn', 38.4858283996582, 0.671704420931576, -91.8502807617188, -1.6030898181732, 218, 29, 'PPL', 'P'),
(163843, 'Linn', 40.0261116027832, 0.698587434239272, -79.8572235107422, -1.39377148176348, 218, 45, 'PPL', 'P'),
(10111, 'Linn (historical)', 34.1888885498047, 0.596708672791481, -91.7125015258789, -1.60068511686691, 218, 4, 'PPL', 'P'),
(55933, 'Linn Creek', 38.0380592346191, 0.663889374712738, -92.7113876342773, -1.6181189683109, 218, 29, 'PPL', 'P'),
(3790, 'Linn Crossing', 33.6772193908691, 0.587778361287146, -86.9663925170898, -1.51784988800498, 218, 2, 'PPL', 'P'),
(95734, 'Linn Flat', 31.7897205352783, 0.554835291629461, -94.7316665649414, -1.65337948745965, 218, 51, 'PPL', 'P'),
(116554, 'Linn Grove', 42.8916702270508, 0.74860086714166, -95.2463912963867, -1.66236312876482, 218, 16, 'PPL', 'P'),
(123079, 'Linn Grove', 40.6450004577637, 0.709389082462578, -85.0330581665039, -1.48410683804535, 218, 19, 'PPL', 'P'),
(116555, 'Linn Junction', 42.0188903808594, 0.73336798518057, -91.7205581665039, -1.60082573177247, 218, 16, 'PPL', 'P'),
(33093, 'Linn Valley', 38.377498626709, 0.669813709715674, -94.7091674804688, -1.65298680435692, 218, 20, 'PPL', 'P'),
(113249, 'Linndale', 41.4466705322266, 0.723380864776664, -81.767219543457, -1.42710720123438, 218, 41, 'PPL', 'P'),
(182822, 'Linne', 35.5724983215332, 0.620857218870911, -120.568061828613, -2.1043096516574, 218, 6, 'PPL', 'P'),
(55939, 'Linneus', 39.8786087036133, 0.696013022992519, -93.188606262207, -1.62644800462012, 218, 29, 'PPL', 'P'),
(127965, 'Linneus', 46.0386085510254, 0.803525302252209, -67.960563659668, -1.18613559737241, 218, 26, 'PPL', 'P'),
(182823, 'Linnie', 35.8330612182617, 0.625404899327357, -117.866111755371, -2.05715172665482, 218, 6, 'PPL', 'P'),
(55940, 'Linns Mills (historical)', 38.9447212219238, 0.67971361159388, -91.0558319091797, -1.5892240699577, 218, 29, 'PPL', 'P'),
(123080, 'Linnsburg', 40.0002784729004, 0.698136561066721, -86.8000030517578, -1.5149458439943, 218, 19, 'PPL', 'P'),
(201141, 'Linnton', 45.5988883972168, 0.795850737780873, -122.785827636719, -2.14301696704699, 218, 43, 'PPL', 'P'),
(163844, 'Linntown', 40.9588890075684, 0.71486747114098, -76.8994369506836, -1.34214836771922, 218, 45, 'PPL', 'P'),
(112484, 'Linnville', 38.5563888549805, 0.672935933198656, -82.478889465332, -1.43952818455851, 218, 41, 'PPL', 'P'),
(136523, 'Lino Lakes', 45.1602783203125, 0.788195547806468, -93.0886077880859, -1.62470270199974, 218, 28, 'PPL', 'P'),
(142264, 'Linoma Beach', 41.0638885498047, 0.716700058866091, -96.3186111450195, -1.6810768954287, 218, 35, 'PPL', 'P'),
(182824, 'Linora (historical)', 37.211109161377, 0.649456373185054, -120.979438781738, -2.11148953395625, 218, 6, 'PPL', 'P'),
(41808, 'Linsberry (historical)', 32.1097183227539, 0.560420306620007, -93.4272232055664, -1.63061265593278, 218, 22, 'PPL', 'P'),
(199483, 'Linscott', 41.7427787780762, 0.728548928609045, -100.013328552246, -1.74556187911555, 218, 35, 'PPL', 'P'),
(73243, 'Linscott (historical)', 39.4608306884766, 0.688721421085937, -82.0436096191406, -1.43193111807489, 218, 41, 'PPL', 'P'),
(88603, 'Linsdale', 35.2513885498047, 0.615252796093921, -84.628059387207, -1.47703827588006, 218, 50, 'PPL', 'P'),
(60641, 'Linsey (historical)', 33.0849990844727, 0.577442167043357, -91.0647201538086, -1.5893791990912, 218, 30, 'PPL', 'P'),
(201142, 'Linslaw', 44.000560760498, 0.767954657994511, -123.682777404785, -2.15867169372475, 218, 43, 'PPL', 'P'),
(209571, 'Linstead Place', 43.5825004577637, 0.760658129239912, -106.522216796875, -1.85916340962868, 218, 59, 'PPL', 'P'),
(48964, 'Linstead-on-the-Severn', 39.0647201538086, 0.681807988054146, -76.5608291625977, -1.33623854694422, 218, 25, 'PPL', 'P'),
(48965, 'Linthicum', 39.2050018310547, 0.68425636520231, -76.6530609130859, -1.33784829466512, 218, 25, 'PPL', 'P'),
(48966, 'Linthicum Heights', 39.2033309936523, 0.684227203588374, -76.6624984741211, -1.33801301117854, 218, 25, 'PPL', 'P'),
(48967, 'Linthicum Hills', 39.2177810668945, 0.684479404943604, -76.6524963378906, -1.33783844096909, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(48968, 'Linthicum Oaks', 39.2000007629395, 0.684169080097583, -76.6513900756836, -1.33781913305118, 218, 25, 'PPL', 'P'),
(27724, 'Lintner', 39.7999992370605, 0.694641028977938, -88.6677780151367, -1.54754466679158, 218, 18, 'PPL', 'P'),
(3792, 'Linton', 33.8333282470703, 0.590502974819379, -86.8013916015625, -1.51497007876022, 218, 2, 'PPL', 'P'),
(22690, 'Linton', 33.1163902282715, 0.577990045858614, -82.9927825927734, -1.44849731163573, 218, 13, 'PPL', 'P'),
(30349, 'Linton', 39.0347213745117, 0.681284410583836, -87.1658325195313, -1.52133077270776, 218, 19, 'PPL', 'P'),
(36905, 'Linton', 36.6866683959961, 0.640303155097479, -87.9186096191406, -1.53446921162956, 218, 21, 'PPL', 'P'),
(41809, 'Linton', 32.6877784729004, 0.570509359514636, -93.6363906860352, -1.63426331715507, 218, 22, 'PPL', 'P'),
(60642, 'Linton', 32.0341682434082, 0.559101708985281, -88.5875015258789, -1.54614357774209, 218, 30, 'PPL', 'P'),
(88604, 'Linton', 36.0272216796875, 0.628793638656429, -87.0102767944336, -1.51861581313448, 218, 50, 'PPL', 'P'),
(175003, 'Linton', 42.5344390869141, 0.742366007555621, -88.5016708374023, -1.54464554962892, 218, 57, 'PPL', 'P'),
(198535, 'Linton', 46.2666702270508, 0.807505729396469, -100.232498168945, -1.74938711054728, 218, 34, 'PPL', 'P'),
(103709, 'Linton Hall', 38.7597198486328, 0.676484728509241, -77.5752792358398, -1.3539440408194, 218, 53, 'PPL', 'P'),
(156174, 'Linton Mills', 40.1738891601563, 0.701166639175986, -81.6936111450195, -1.42582249232453, 218, 41, 'PPL', 'P'),
(48969, 'Linton Springs', 39.4213905334473, 0.688033060523179, -76.9822235107422, -1.34359326576864, 218, 25, 'PPL', 'P'),
(110130, 'Lintz Addition', 37.848331451416, 0.660578000213334, -82.0219421386719, -1.4315529492001, 218, 58, 'PPL', 'P'),
(145615, 'Linvale', 40.3930587768555, 0.704991870607721, -74.8361129760742, -1.30613657082695, 218, 37, 'PPL', 'P'),
(41810, 'Linville', 32.8419418334961, 0.57320001774297, -92.1927795410156, -1.60906754955599, 218, 22, 'PPL', 'P'),
(66394, 'Linville', 35.7963905334473, 0.624764875138384, -81.8905563354492, -1.42925983434349, 218, 33, 'PPL', 'P'),
(103710, 'Linville', 38.5202789306641, 0.672305696126688, -78.8377838134766, -1.37597890252066, 218, 53, 'PPL', 'P'),
(10114, 'Linville (historical)', 35.6208305358887, 0.621700775146193, -93.6830596923828, -1.63507784497447, 218, 4, 'PPL', 'P'),
(201143, 'Linville (historical)', 44.4416694641113, 0.775653457231767, -123.975563049316, -2.16378176722439, 218, 43, 'PPL', 'P'),
(163851, 'Linville Circle', 40.0305595397949, 0.698665065385047, -76.2652816772461, -1.33108027022885, 218, 45, 'PPL', 'P'),
(66395, 'Linville Falls', 35.959171295166, 0.627605935389281, -81.9430618286133, -1.43017622807459, 218, 33, 'PPL', 'P'),
(66401, 'Linville River (historical)', 35.7924995422363, 0.624696964530587, -81.5108337402344, -1.42263242481277, 218, 33, 'PPL', 'P'),
(3793, 'Linwood', 31.9266700744629, 0.557225511997321, -85.8641662597656, -1.49861241071273, 218, 2, 'PPL', 'P'),
(10113, 'Linwood', 34.1536102294922, 0.596092949947455, -91.7972183227539, -1.60216370390412, 218, 4, 'PPL', 'P'),
(22691, 'Linwood', 34.7127799987793, 0.605852303499132, -85.2891693115234, -1.48857682077699, 218, 13, 'PPL', 'P'),
(33095, 'Linwood', 39.0013885498047, 0.680702643043708, -95.0388870239258, -1.65874149599842, 218, 20, 'PPL', 'P'),
(36903, 'Linwood', 37.3394393920898, 0.651696158240838, -85.7600021362305, -1.49679440379459, 218, 21, 'PPL', 'P'),
(41812, 'Linwood', 29.8691692352295, 0.521315347990151, -91.5255584716797, -1.5974223450574, 218, 22, 'PPL', 'P'),
(48971, 'Linwood', 39.2772216796875, 0.685516839346245, -76.8055572509766, -1.34050985785855, 218, 25, 'PPL', 'P'),
(60646, 'Linwood', 32.7922210693359, 0.572332226701768, -90.1449966430664, -1.57332699562074, 218, 30, 'PPL', 'P'),
(66398, 'Linwood', 35.750560760498, 0.623964994704979, -80.3180618286133, -1.40181462772968, 218, 33, 'PPL', 'P'),
(73244, 'Linwood', 39.1266708374023, 0.682889231456718, -84.4097213745117, -1.47322755867626, 218, 41, 'PPL', 'P'),
(78624, 'Linwood', 39.8263893127441, 0.695101622688467, -75.4258270263672, -1.31642902264983, 218, 45, 'PPL', 'P'),
(88606, 'Linwood', 36.1577796936035, 0.631072305864128, -86.1852798461914, -1.50421690006875, 218, 50, 'PPL', 'P'),
(95735, 'Linwood', 31.6641693115234, 0.55264400939503, -94.9902801513672, -1.65789314603317, 218, 51, 'PPL', 'P'),
(110129, 'Linwood', 38.4208297729492, 0.670569980886229, -80.0441665649414, -1.39703425357299, 218, 58, 'PPL', 'P'),
(116561, 'Linwood', 41.4655609130859, 0.723710564119616, -90.6788864135742, -1.58264512995882, 218, 16, 'PPL', 'P'),
(123081, 'Linwood', 40.1936111450195, 0.701510852746879, -85.6816711425781, -1.495427270049, 218, 19, 'PPL', 'P'),
(125247, 'Linwood', 42.0972213745117, 0.734735118926162, -71.6452789306641, -1.25044601084981, 218, 23, 'PPL', 'P'),
(131794, 'Linwood', 43.7391700744629, 0.763392529889151, -83.9622192382813, -1.46541717298933, 218, 27, 'PPL', 'P'),
(136526, 'Linwood', 45.3569412231445, 0.791627962977416, -93.1113891601563, -1.62510031195048, 218, 28, 'PPL', 'P'),
(142265, 'Linwood', 41.4122200012207, 0.722779589581551, -96.9311065673828, -1.69176695720233, 218, 35, 'PPL', 'P'),
(145616, 'Linwood', 40.8630599975586, 0.713194939397384, -73.9680633544922, -1.29098624685965, 218, 37, 'PPL', 'P'),
(150295, 'Linwood', 42.894718170166, 0.748654063784434, -77.9494400024414, -1.36047437812838, 218, 40, 'PPL', 'P'),
(33096, 'Linwood Acres', 37.6813888549805, 0.657664302243705, -97.2019424438477, -1.69649393497917, 218, 20, 'PPL', 'P'),
(131795, 'Linwood Beach', 43.7238883972168, 0.763125814305979, -83.9436111450195, -1.4650924004944, 218, 27, 'PPL', 'P'),
(36904, 'Linwood Park', 37.3505592346191, 0.651890236105277, -86.1427764892578, -1.50347507654711, 218, 21, 'PPL', 'P'),
(66399, 'Linwood Park', 35.5602798461914, 0.620643966246623, -82.5186080932617, -1.44022140539026, 218, 33, 'PPL', 'P'),
(156176, 'Linworth', 40.0900001525879, 0.699702499787688, -83.0491714477539, -1.44948148281657, 218, 41, 'PPL', 'P'),
(196918, 'Lion City (historical)', 45.6083297729492, 0.796015520873322, -112.925003051758, -1.97091311107782, 218, 31, 'PPL', 'P'),
(36906, 'Lionilli', 37.2605590820313, 0.650319437115321, -82.6113891601563, -1.44184074049108, 218, 21, 'PPL', 'P'),
(41813, 'Lions', 30.0541706085205, 0.524544231074791, -90.5891723632813, -1.58107932439591, 218, 22, 'PPL', 'P'),
(48972, 'Lions Gate', 39.0833282470703, 0.682132760549081, -76.6872177124023, -1.33844444327513, 218, 25, 'PPL', 'P'),
(163845, 'Lionville', 40.0536117553711, 0.699067402446731, -75.6602783203125, -1.32052096966474, 218, 45, 'PPL', 'P'),
(95736, 'Lipan', 32.5183296203613, 0.567551919124103, -98.0455627441406, -1.71121788685594, 218, 51, 'PPL', 'P'),
(88607, 'Lipe', 36.040828704834, 0.629031126046637, -88.179443359375, -1.53902161919694, 218, 50, 'PPL', 'P'),
(48973, 'Lipins Corner', 39.1324996948242, 0.682990964210359, -76.5819396972656, -1.33660699528103, 218, 25, 'PPL', 'P'),
(196919, 'Lippard', 47.9516716003418, 0.836914551261023, -110.390281677246, -1.92667387747191, 218, 31, 'PPL', 'P'),
(30352, 'Lippe', 38.0152816772461, 0.663491831341017, -87.7538909912109, -1.53159432923282, 218, 19, 'PPL', 'P'),
(78625, 'Lippincott', 39.9388885498047, 0.697065104781155, -80.1191711425781, -1.39834333040682, 218, 45, 'PPL', 'P'),
(156177, 'Lippincott', 40.1936111450195, 0.701510852746879, -83.7755584716797, -1.46215932802784, 218, 41, 'PPL', 'P'),
(71038, 'Lippincotts Corner', 39.9291687011719, 0.696895461419717, -74.7774963378906, -1.30511351749419, 218, 37, 'PPL', 'P'),
(169465, 'Lippitt', 41.7213897705078, 0.728175620003243, -71.5252838134766, -1.24835170096857, 218, 47, 'PPL', 'P'),
(169468, 'Lippitt Estate', 41.9561080932617, 0.732272227550057, -71.4205627441406, -1.24652397351245, 218, 47, 'PPL', 'P'),
(103712, 'Lipps', 37.0041694641113, 0.645844594114688, -82.6513900756836, -1.44253888817084, 218, 53, 'PPL', 'P'),
(55941, 'Lippstadt Community', 38.7580604553223, 0.676455766632386, -91.1438903808594, -1.59076098022278, 218, 29, 'PPL', 'P'),
(10115, 'Lippton (historical)', 33.7916717529297, 0.589775931841787, -94.3000030517578, -1.64584553789387, 218, 4, 'PPL', 'P'),
(3797, 'Lipscomb', 33.4255599975586, 0.583386076280305, -86.9266662597656, -1.51715653401517, 218, 2, 'PPL', 'P'),
(103713, 'Lipscomb', 38.0191688537598, 0.663559675369786, -78.978889465332, -1.37844166073871, 218, 53, 'PPL', 'P'),
(191768, 'Lipscomb', 36.2333297729492, 0.632390903498853, -100.270561218262, -1.7500514360812, 218, 51, 'PPL', 'P'),
(27725, 'Lipsey', 39.4913902282715, 0.689254785673252, -88.4177780151367, -1.54318134366159, 218, 18, 'PPL', 'P'),
(196920, 'Lipske Trailer Court', 46.7574996948242, 0.816072319674926, -114.082778930664, -1.9911201121649, 218, 31, 'PPL', 'P'),
(182825, 'Lira', 39.1452789306641, 0.683214003951653, -121.866668701172, -2.12697461727257, 218, 6, 'PPL', 'P'),
(36907, 'Liro', 38.4011116027832, 0.670225833894364, -85.3386077880859, -1.48943968497018, 218, 21, 'PPL', 'P'),
(27726, 'Lis', 39.0200004577637, 0.681027482117671, -88.2602767944336, -1.54043242878441, 218, 18, 'PPL', 'P'),
(95737, 'Lisa Colonia', 26.5109996795654, 0.462704232403578, -97.7699966430664, -1.70640835108531, 218, 51, 'PPL', 'P'),
(207929, 'Lisabeula', 47.4075012207031, 0.8274169864445, -122.516387939453, -2.13831435719413, 218, 56, 'PPL', 'P'),
(10116, 'Lisbon', 33.2724990844727, 0.580714659390847, -92.8272171020508, -1.62014057389438, 218, 4, 'PPL', 'P'),
(16911, 'Lisbon', 28.8702793121338, 0.503881429967138, -81.7897186279297, -1.42749988433711, 218, 12, 'PPL', 'P'),
(22693, 'Lisbon', 33.9566688537598, 0.592655674507517, -82.5811080932617, -1.44131223617275, 218, 13, 'PPL', 'P'),
(41814, 'Lisbon', 32.7958297729492, 0.572395210461548, -92.8649978637695, -1.62079997258028, 218, 22, 'PPL', 'P'),
(48974, 'Lisbon', 39.336109161377, 0.686544619789933, -77.0713882446289, -1.34514948395163, 218, 25, 'PPL', 'P'),
(55942, 'Lisbon', 39.1063919067383, 0.682535297347846, -92.9061126708984, -1.621517561336, 218, 29, 'PPL', 'P'),
(66402, 'Lisbon', 34.5169410705566, 0.60243426939807, -78.5272216796875, -1.37055857075402, 218, 33, 'PPL', 'P'),
(88608, 'Lisbon', 35.1061096191406, 0.612717200420056, -88.915283203125, -1.55186444723774, 218, 50, 'PPL', 'P'),
(116562, 'Lisbon', 41.9211082458496, 0.73166136497502, -91.3852767944336, -1.59497396790924, 218, 16, 'PPL', 'P'),
(120374, 'Lisbon', 41.4813919067383, 0.723986867082712, -88.4822235107422, -1.54430612974799, 218, 18, 'PPL', 'P'),
(123082, 'Lisbon', 41.4111099243164, 0.722760215084621, -85.2597198486328, -1.4880628306866, 218, 19, 'PPL', 'P'),
(127968, 'Lisbon', 44.0313911437988, 0.768492749692762, -70.1050033569336, -1.22356313070017, 218, 26, 'PPL', 'P'),
(140405, 'Lisbon', 46.4416694641113, 0.810560042271653, -97.6808319091797, -1.70485213290232, 218, 34, 'PPL', 'P'),
(144060, 'Lisbon', 44.2133293151855, 0.771668169818517, -71.9113922119141, -1.25509056379091, 218, 36, 'PPL', 'P'),
(150296, 'Lisbon', 44.7272186279297, 0.780637230316714, -75.3213882446289, -1.31460622204173, 218, 40, 'PPL', 'P'),
(156178, 'Lisbon', 40.7719383239746, 0.711604566173415, -80.7683334350586, -1.40967334979039, 218, 41, 'PPL', 'P'),
(163846, 'Lisbon', 41.1972198486328, 0.719027129026602, -79.7944412231445, -1.39267572413296, 218, 45, 'PPL', 'P'),
(193064, 'Lisbon', 32.2777786254883, 0.56335351224462, -108.546943664551, -1.89450155992321, 218, 38, 'PPL', 'P'),
(82116, 'Lisbon (historical)', 34.4241714477539, 0.600815134034329, -82.0013885498047, -1.43119422140127, 218, 48, 'PPL', 'P'),
(48975, 'Lisbon Acres', 39.3386116027832, 0.686588295631811, -77.0441665649414, -1.34467437601316, 218, 25, 'PPL', 'P'),
(120375, 'Lisbon Center', 41.5244407653809, 0.72473821140525, -88.4338912963867, -1.5434625734727, 218, 18, 'PPL', 'P'),
(127969, 'Lisbon Center', 44.019718170166, 0.768289017869371, -70.0938873291016, -1.22336911941476, 218, 26, 'PPL', 'P'),
(127970, 'Lisbon Falls', 43.9961090087891, 0.767876960269708, -70.0611114501953, -1.22279707241261, 218, 26, 'PPL', 'P'),
(48976, 'Lisbon Manor', 39.3527793884277, 0.686835570139025, -77.0813903808594, -1.34532405416108, 218, 25, 'PPL', 'P'),
(48977, 'Lisbon Meadows', 39.3227806091309, 0.686311992668715, -77.0597229003906, -1.34494588528629, 218, 25, 'PPL', 'P'),
(163847, 'Lisburn', 40.167781829834, 0.701060046153356, -76.9105606079102, -1.34234251216268, 218, 45, 'PPL', 'P'),
(199484, 'Lisco', 41.4972190856934, 0.72426310346678, -102.619720458984, -1.79105199948546, 218, 35, 'PPL', 'P'),
(116563, 'Liscomb', 42.189998626709, 0.736354387447958, -93.0036087036133, -1.62321918811451, 218, 16, 'PPL', 'P'),
(3794, 'Lisenba Subdivision', 33.2122192382813, 0.579662577602211, -87.7158279418945, -1.5309300036989, 218, 2, 'PPL', 'P'),
(150298, 'Lisha Kill', 42.7522201538086, 0.746167004221437, -73.8694381713867, -1.28926491268908, 218, 40, 'PPL', 'P'),
(178538, 'Lisitzky Subdivision', 34.9280586242676, 0.60960962432307, -110.135833740234, -1.92223292319615, 218, 5, 'PPL', 'P'),
(131799, 'Liske', 45.334171295166, 0.791230552763749, -83.7411117553711, -1.46155811941175, 218, 27, 'PPL', 'P'),
(193739, 'Liskey', 41.8488883972168, 0.730400890831086, -121.408889770508, -2.11898486768622, 218, 6, 'PPL', 'P'),
(182826, 'Lisko', 36.0969390869141, 0.630010436958486, -119.036392211914, -2.07757697379324, 218, 6, 'PPL', 'P'),
(55943, 'Lisle', 38.5494384765625, 0.672814626211003, -94.5944366455078, -1.65098437353329, 218, 29, 'PPL', 'P'),
(120379, 'Lisle', 41.8011093139648, 0.729566988514755, -88.0747222900391, -1.53719389174082, 218, 18, 'PPL', 'P'),
(150303, 'Lisle', 42.3511085510254, 0.739166286084918, -76.0036087036133, -1.32651321527547, 218, 40, 'PPL', 'P'),
(36909, 'Lisletown', 37.9191703796387, 0.661814372749403, -84.2736129760742, -1.47085201898391, 218, 21, 'PPL', 'P'),
(55944, 'Lisletown (historical)', 38.4933280944824, 0.671835315299153, -92.0058288574219, -1.60580464458842, 218, 29, 'PPL', 'P'),
(3795, 'Lisman', 32.1686096191406, 0.561448153642723, -88.2825012207031, -1.54082031819718, 218, 2, 'PPL', 'P'),
(36908, 'Lisman', 37.4661102294922, 0.653906981419767, -87.7341690063477, -1.53125011566193, 218, 21, 'PPL', 'P'),
(73246, 'Lisman', 38.6361083984375, 0.674327301710168, -82.6805572509766, -1.44304795141321, 218, 41, 'PPL', 'P'),
(48978, 'Lismarelu Farms', 39.5869407653809, 0.69092245714786, -76.8894424438477, -1.34197393066782, 218, 25, 'PPL', 'P'),
(196921, 'Lismas (historical)', 47.9397201538086, 0.836705959168642, -106.527778625488, -1.85926048185041, 218, 31, 'PPL', 'P'),
(41815, 'Lismore', 31.5155601501465, 0.550050290230375, -91.7719421386719, -1.60172255126955, 218, 22, 'PPL', 'P'),
(136529, 'Lismore', 43.7477798461914, 0.763542798753658, -95.9469375610352, -1.67458996764548, 218, 28, 'PPL', 'P'),
(95738, 'Lissie', 29.5558300018311, 0.515846546691674, -96.2249984741211, -1.67944304609993, 218, 51, 'PPL', 'P'),
(10117, 'Lissie (historical)', 34.1816711425781, 0.59658270527192, -93.6194381713867, -1.63396743995796, 218, 4, 'PPL', 'P'),
(41816, 'Lisso', 31.1372203826904, 0.543447015597037, -92.7024993896484, -1.6179638391774, 218, 22, 'PPL', 'P'),
(182827, 'List', 36.2761116027832, 0.633137587289484, -119.126937866211, -2.07915729358409, 218, 6, 'PPL', 'P'),
(66404, 'Listening Rock', 36.5569381713867, 0.638038935538693, -81.6399993896484, -1.42488679067553, 218, 33, 'PPL', 'P'),
(3796, 'Listerhill', 34.7574996948242, 0.606632809435607, -87.5822219848633, -1.52859813984843, 218, 2, 'PPL', 'P'),
(66405, 'Listers Corner', 36.1413917541504, 0.630786282363053, -76.1716690063477, -1.32944642090008, 218, 33, 'PPL', 'P'),
(113314, 'Listie', 40.0280609130859, 0.698621456122197, -79.0136108398438, -1.37904766304476, 218, 45, 'PPL', 'P'),
(78626, 'Listonburg', 39.7547187805176, 0.693850735924457, -79.3144378662109, -1.38429808513385, 218, 45, 'PPL', 'P'),
(22694, 'Listonia', 31.9641704559326, 0.557880017124721, -83.6594390869141, -1.46013266243829, 218, 13, 'PPL', 'P'),
(33097, 'Litchfield', 37.4408302307129, 0.653465762206168, -94.6494369506836, -1.65194430994821, 218, 20, 'PPL', 'P'),
(103716, 'Litchfield', 38.5691719055176, 0.673159039518977, -77.8324966430664, -1.35843333146894, 218, 53, 'PPL', 'P'),
(113642, 'Litchfield', 41.7472190856934, 0.728626426596766, -73.1891708374023, -1.27739200791729, 218, 8, 'PPL', 'P'),
(120381, 'Litchfield', 41.163330078125, 0.718435640948496, -87.586669921875, -1.5286757709942, 218, 18, 'PPL', 'P'),
(131796, 'Litchfield', 42.0438919067383, 0.73380434412518, -84.7574996948242, -1.47929743543277, 218, 27, 'PPL', 'P'),
(136532, 'Litchfield', 45.1272201538086, 0.787618573956302, -94.5277786254883, -1.64982097161109, 218, 28, 'PPL', 'P'),
(142267, 'Litchfield', 41.1575012207031, 0.718333908194855, -99.1552810668945, -1.73058612535771, 218, 35, 'PPL', 'P'),
(144063, 'Litchfield', 42.8441696166992, 0.747771825094318, -71.4802780151367, -1.24756620160505, 218, 36, 'PPL', 'P'),
(150300, 'Litchfield', 42.0091705322266, 0.733198341819132, -76.459716796875, -1.33447380324788, 218, 40, 'PPL', 'P'),
(156179, 'Litchfield', 41.167781829834, 0.718513338673299, -82.023063659668, -1.43157252343412, 218, 41, 'PPL', 'P'),
(163848, 'Litchfield', 41.9674987792969, 0.732471032525432, -76.4305572509766, -1.33396487316357, 218, 45, 'PPL', 'P'),
(178539, 'Litchfield', 33.4266700744629, 0.583405450777236, -112.354438781738, -1.96095488597174, 218, 5, 'PPL', 'P'),
(193738, 'Litchfield', 40.3827781677246, 0.704812440129277, -120.386108398438, -2.10113396521553, 218, 6, 'PPL', 'P'),
(82112, 'Litchfield Beach', 33.4666709899902, 0.584103598457, -79.0999984741211, -1.3805554116959, 218, 48, 'PPL', 'P'),
(82114, 'Litchfield by the Sea', 33.4755592346191, 0.584258727590497, -79.095832824707, -1.38048270739814, 218, 48, 'PPL', 'P'),
(127972, 'Litchfield Corners', 44.1330604553223, 0.770267213927081, -69.9655609130859, -1.221129400938, 218, 26, 'PPL', 'P'),
(22695, 'Litchfield Hundred', 34.0966682434082, 0.595099124807664, -84.4030609130859, -1.47311131169468, 218, 13, 'PPL', 'P'),
(178540, 'Litchfield Junction', 33.4225006103516, 0.583332679900449, -112.361938476563, -1.96108578033932, 218, 5, 'PPL', 'P'),
(136534, 'Litchfield Mobile Home Park', 45.121940612793, 0.787526428582585, -94.5180587768555, -1.64965132824965, 218, 28, 'PPL', 'P'),
(178541, 'Litchfield Park', 33.4933280944824, 0.584568852699437, -112.357223510742, -1.96100348866163, 218, 5, 'PPL', 'P'),
(127973, 'Litchfield Plains', 44.1505584716797, 0.770572611925086, -69.9305572509766, -1.22051847178394, 218, 26, 'PPL', 'P'),
(82113, 'Litchfield Retreat', 33.4850006103516, 0.584423510682946, -79.0861129760742, -1.38031306403671, 218, 48, 'PPL', 'P'),
(140407, 'Litchville', 46.6536102294922, 0.814259106446746, -98.1938934326172, -1.71380674575161, 218, 34, 'PPL', 'P'),
(27728, 'Literberry', 39.8541717529297, 0.695586517743943, -90.1994400024414, -1.57427721149768, 218, 18, 'PPL', 'P'),
(150302, 'Lithgow', 41.8250007629395, 0.729983972962434, -73.6205596923828, -1.2849211637931, 218, 40, 'PPL', 'P'),
(16912, 'Lithia', 27.8500003814697, 0.486074203338324, -82.1750030517578, -1.43422436608956, 218, 12, 'PPL', 'P'),
(27730, 'Lithia', 39.4275016784668, 0.688139720124836, -88.7177810668945, -1.5484173846808, 218, 18, 'PPL', 'P'),
(103714, 'Lithia', 37.4780616760254, 0.654115573512147, -79.7516708374023, -1.39192924007941, 218, 53, 'PPL', 'P'),
(125248, 'Lithia', 42.4561080932617, 0.740998873810029, -72.835563659668, -1.27122039840714, 218, 23, 'PPL', 'P'),
(140410, 'Lithia', 46.6161117553711, 0.813604634608859, -96.8130569458008, -1.68970660262499, 218, 34, 'PPL', 'P'),
(22696, 'Lithia Mobile Home Estates', 33.7777786254883, 0.589533451024535, -84.67138671875, -1.47779448047159, 218, 13, 'PPL', 'P'),
(22697, 'Lithia Springs', 33.7938919067383, 0.589814680835647, -84.6605606079102, -1.47760552919224, 218, 13, 'PPL', 'P'),
(66408, 'Lithia Springs', 35.4583282470703, 0.618864575164286, -81.226936340332, -1.41767748044663, 218, 33, 'PPL', 'P'),
(103715, 'Lithia Springs', 36.5905609130859, 0.638625763084892, -79.8475036621094, -1.39360183840204, 218, 53, 'PPL', 'P'),
(163850, 'Lithia Springs', 40.9208297729492, 0.714203212186088, -76.7636108398438, -1.33977775487488, 218, 45, 'PPL', 'P'),
(55945, 'Lithium', 37.8333282470703, 0.660316144899152, -89.8858337402344, -1.5688037496673, 218, 29, 'PPL', 'P'),
(22698, 'Lithonia', 33.7122192382813, 0.588389223862183, -84.1052780151367, -1.46791401966934, 218, 13, 'PPL', 'P'),
(73247, 'Lithopolis', 39.8027801513672, 0.694689565088804, -82.8063888549805, -1.44524412720615, 218, 41, 'PPL', 'P'),
(163852, 'Lititz', 40.1572189331055, 0.700875688826895, -76.3072204589844, -1.33181224005446, 218, 45, 'PPL', 'P'),
(136537, 'Litomysl', 43.9472198486328, 0.767023683456447, -93.1858291625977, -1.62639953508828, 218, 28, 'PPL', 'P'),
(41817, 'Litroe', 32.9933280944824, 0.575842206439465, -92.1961135864258, -1.60912573962581, 218, 22, 'PPL', 'P'),
(36911, 'Litsey', 37.7694396972656, 0.659201079350735, -85.1927795410156, -1.48689450191639, 218, 21, 'PPL', 'P'),
(36910, 'Littcarr', 37.2408294677734, 0.649975090386374, -82.9488906860352, -1.44773125334817, 218, 21, 'PPL', 'P'),
(207930, 'Littell', 46.6369400024414, 0.813968156097655, -123.034172058105, -2.14735139487915, 218, 56, 'PPL', 'P'),
(95739, 'Littig', 30.3194408416748, 0.529174070050866, -97.4491729736328, -1.70080892173537, 218, 51, 'PPL', 'P'),
(36912, 'Little', 37.4397201538086, 0.653446387709238, -83.3619384765625, -1.45494029726096, 218, 21, 'PPL', 'P'),
(76417, 'Little', 35.3480606079102, 0.616940041802541, -96.6716690063477, -1.68723891755892, 218, 42, 'PPL', 'P'),
(110131, 'Little', 39.4747200012207, 0.688963835324161, -80.9972229003906, -1.41366822458357, 218, 58, 'PPL', 'P'),
(30351, 'Little Acre', 39.0361099243164, 0.681308645349756, -85.8827819824219, -1.49893731636572, 218, 19, 'PPL', 'P'),
(14126, 'Little Acres', 38.4986114501953, 0.671927527251897, -75.5602798461914, -1.31877566704435, 218, 10, 'PPL', 'P'),
(48979, 'Little Acres', 39.6286087036133, 0.691649699862533, -77.0805587768555, -1.34530953993314, 218, 25, 'PPL', 'P'),
(178542, 'Little Acres', 33.394718170166, 0.582847784844973, -110.820281982422, -1.93417879858181, 218, 5, 'PPL', 'P'),
(82115, 'Little Africa', 35.1672210693359, 0.613783796436633, -82.0269393920898, -1.4316401677258, 218, 48, 'PPL', 'P'),
(201144, 'Little Albany', 44.4033317565918, 0.774984338007884, -123.913063049316, -2.1626909364419, 218, 43, 'PPL', 'P'),
(201145, 'Little Alps', 44.9658317565918, 0.784801815050352, -118.181938171387, -2.06266393747906, 218, 43, 'PPL', 'P'),
(120382, 'Little America', 40.4058303833008, 0.705214777190961, -90.0344390869141, -1.57139740225293, 218, 18, 'PPL', 'P'),
(150304, 'Little America', 43.5616683959961, 0.760294541172089, -75.9005584716797, -1.32471464943329, 218, 40, 'PPL', 'P'),
(209572, 'Little America', 41.5436096191406, 0.725072771017191, -109.858329772949, -1.91738956527968, 218, 59, 'PPL', 'P'),
(112236, 'Little Arkansaw', 36.2891693115234, 0.633365487299768, -93.2363891601563, -1.62728197351548, 218, 4, 'PPL', 'P'),
(76419, 'Little Axe', 35.2324981689453, 0.614923096750969, -97.2122192382813, -1.69667329887858, 218, 42, 'PPL', 'P'),
(14127, 'Little Baltimore', 39.773609161377, 0.694180435267408, -75.7375030517578, -1.32186879549243, 218, 10, 'PPL', 'P'),
(66409, 'Little Baltimore', 35.2861099243164, 0.615858798399968, -77.7561111450195, -1.35710015302725, 218, 33, 'PPL', 'P'),
(103717, 'Little Baltimore', 38.1836090087891, 0.666429697497538, -79.3827819824219, -1.38549091498609, 218, 53, 'PPL', 'P'),
(36913, 'Little Barren', 37.1277809143066, 0.648002020913762, -85.6177825927734, -1.49431220450058, 218, 21, 'PPL', 'P'),
(88610, 'Little Barren', 36.3655586242676, 0.634698732320489, -83.7558288574219, -1.46181498129889, 218, 50, 'PPL', 'P'),
(10120, 'Little Bay', 33.7625007629395, 0.589266802020391, -92.5322189331055, -1.61499188455893, 218, 4, 'PPL', 'P'),
(10119, 'Little Bay (historical)', 33.4313888549805, 0.583487809033946, -92.6258316040039, -1.61662573388769, 218, 4, 'PPL', 'P'),
(196922, 'Little Bear (historical)', 45.5449981689453, 0.794910175862884, -111.168060302734, -1.94024867533832, 218, 31, 'PPL', 'P'),
(36914, 'Little Bear Creek', 36.9555587768555, 0.644996177570416, -88.2416687011719, -1.54010765628948, 218, 21, 'PPL', 'P'),
(82117, 'Little Belvidere', 33.3994407653809, 0.582930209680711, -80.3294372558594, -1.40201316638894, 218, 48, 'PPL', 'P'),
(55946, 'Little Berger', 38.6213912963867, 0.674070439823029, -91.394172668457, -1.59512923020079, 218, 29, 'PPL', 'P'),
(73248, 'Little Bethlehem', 39.1208305358887, 0.682787298965995, -84.5113906860352, -1.47500202291058, 218, 41, 'PPL', 'P'),
(110132, 'Little Birch', 38.5788917541504, 0.673328682880415, -80.7069396972656, -1.4086018269258, 218, 58, 'PPL', 'P'),
(175007, 'Little Black', 45.1061096191406, 0.787250125619489, -90.3294372558594, -1.57654609158838, 218, 57, 'PPL', 'P'),
(112416, 'Little Blue', 38.9908294677734, 0.680518352296275, -94.4122161865234, -1.64780402655952, 218, 29, 'PPL', 'P'),
(144064, 'Little Boars Head', 42.9580612182617, 0.749759608531953, -70.7766723632813, -1.23528596634453, 218, 36, 'PPL', 'P'),
(156182, 'Little Bohemia', 41.4705581665039, 0.723797782645316, -81.6549987792969, -1.42514857941068, 218, 41, 'PPL', 'P'),
(204716, 'Little Bonanza', 40.035831451416, 0.69875707760071, -109.211112976074, -1.9060935012, 218, 52, 'PPL', 'P'),
(207931, 'Little Boston', 47.8525009155273, 0.835183696289553, -122.568893432617, -2.13923075092522, 218, 56, 'PPL', 'P'),
(150306, 'Little Bow', 44.3536109924316, 0.774116546966682, -75.5105590820313, -1.31790787600315, 218, 40, 'PPL', 'P'),
(125249, 'Little Bridge', 42.1599998474121, 0.735830809977648, -70.7436065673828, -1.23470885933631, 218, 23, 'PPL', 'P'),
(78627, 'Little Britain', 39.7788887023926, 0.694272580641125, -76.116943359375, -1.32849127817513, 218, 45, 'PPL', 'P'),
(150305, 'Little Britain', 41.4777793884277, 0.723923816743904, -74.129997253418, -1.2938125265665, 218, 40, 'PPL', 'P'),
(145617, 'Little Brook', 40.7411117553711, 0.711066541054192, -74.8613891601563, -1.30657772346152, 218, 37, 'PPL', 'P'),
(73249, 'Little Buck (historical)', 39.1011085510254, 0.682443085395102, -84.5336074829102, -1.4753897791653, 218, 41, 'PPL', 'P'),
(10122, 'Little Buffalo (historical)', 36.047779083252, 0.62915243303429, -93.126106262207, -1.62535717383762, 218, 4, 'PPL', 'P'),
(110133, 'Little Cacapon', 39.5155601501465, 0.689676630389921, -78.4944381713867, -1.36998639059382, 218, 58, 'PPL', 'P'),
(127975, 'Little Canada', 46.2949981689453, 0.808000145252842, -68.1877822875977, -1.19010131055165, 218, 26, 'PPL', 'P'),
(136538, 'Little Canada', 45.0269393920898, 0.785868344487902, -93.0875015258789, -1.62468339408183, 218, 28, 'PPL', 'P'),
(150307, 'Little Canada', 42.9458312988281, 0.749546156170584, -78.1116714477539, -1.36330585099935, 218, 40, 'PPL', 'P'),
(116566, 'Little Cedar', 43.3802795410156, 0.757128708426257, -92.7255630493164, -1.61836637597616, 218, 16, 'PPL', 'P'),
(73250, 'Little Center', 39.4822196960449, 0.689094729691739, -83.8697204589844, -1.46380276473653, 218, 41, 'PPL', 'P'),
(163855, 'Little Chapel', 41.4188919067383, 0.722896036300215, -75.3694381713867, -1.31544485146899, 218, 45, 'PPL', 'P'),
(123084, 'Little Charlie', 40.8250007629395, 0.71253068044249, -86.2019424438477, -1.50450771725979, 218, 19, 'PPL', 'P'),
(88611, 'Little Cherokee', 36.235279083252, 0.632424925381779, -82.4400024414063, -1.4388494779547, 218, 50, 'PPL', 'P'),
(73251, 'Little Chicago', 39.7222213745117, 0.693283549191297, -82.9527816772461, -1.44779916395597, 218, 41, 'PPL', 'P'),
(78629, 'Little Chicago', 39.8600006103516, 0.695688250497584, -79.9608306884766, -1.39557976814364, 218, 45, 'PPL', 'P'),
(82118, 'Little Chicago', 35.0625, 0.611956068980512, -82.1838912963867, -1.43437949522306, 218, 48, 'PPL', 'P'),
(136540, 'Little Chicago', 44.4791717529297, 0.776307995648681, -93.3219375610352, -1.62877507478063, 218, 28, 'PPL', 'P'),
(175009, 'Little Chicago', 45.0472183227539, 0.786222278596773, -89.8441696166992, -1.56807657353165, 218, 57, 'PPL', 'P'),
(196923, 'Little Chicago (historical)', 47.5272216796875, 0.829506502635777, -111.275001525879, -1.9421151517883, 218, 31, 'PPL', 'P'),
(76420, 'Little Chief', 36.665828704834, 0.639939433871601, -96.6399993896484, -1.68668617847468, 218, 42, 'PPL', 'P'),
(88612, 'Little Chucky (historical)', 36.1116714477539, 0.630267565161733, -82.9913864135742, -1.44847294371176, 218, 50, 'PPL', 'P'),
(175010, 'Little Chute', 44.2799987792969, 0.7728317714778, -88.3183288574219, -1.54144562842113, 218, 57, 'PPL', 'P'),
(76421, 'Little City', 34.086109161377, 0.594914834060231, -96.6158294677734, -1.68626433375801, 218, 42, 'PPL', 'P'),
(113645, 'Little City', 41.4474983215332, 0.723395312425578, -72.6005630493164, -1.26711886401231, 218, 8, 'PPL', 'P'),
(103718, 'Little Clover Hill', 38.1144409179688, 0.665222486575405, -78.4791717529297, -1.36971994132675, 218, 53, 'PPL', 'P'),
(55947, 'Little Compton', 39.5683288574219, 0.690597618073898, -93.2858276367188, -1.62814483770866, 218, 29, 'PPL', 'P'),
(169466, 'Little Compton', 41.5099983215332, 0.724486143208074, -71.1716690063477, -1.24217995830037, 218, 47, 'PPL', 'P'),
(163856, 'Little Cooley', 41.7405586242676, 0.728510179615184, -79.894172668457, -1.39441636622144, 218, 45, 'PPL', 'P'),
(193232, 'Little Cottonwood Creek Valley', 40.6044387817383, 0.708681147665808, -111.82861328125, -1.95177749969727, 218, 52, 'PPL', 'P'),
(204719, 'Little Cottonwood Valley', 40.6138916015625, 0.708846130495339, -111.851112365723, -1.9521701828, 218, 52, 'PPL', 'P'),
(88613, 'Little Cove', 35.7586097717285, 0.62410547645248, -83.605827331543, -1.45919696078929, 218, 50, 'PPL', 'P'),
(88614, 'Little Crab', 36.4569396972656, 0.63629363291831, -85.0563888549805, -1.48451403537602, 218, 50, 'PPL', 'P'),
(762, 'Little Creek', 35.9152793884277, 0.626839877101719, -82.5552825927734, -1.44086149615826, 218, 33, 'PPL', 'P'),
(14128, 'Little Creek', 39.1669387817383, 0.68359203966839, -75.4486083984375, -1.31682663260058, 218, 10, 'PPL', 'P'),
(41818, 'Little Creek', 31.7194404602051, 0.553608672920884, -92.2941665649414, -1.61083708694229, 218, 22, 'PPL', 'P'),
(60649, 'Little Creek', 31.1272201538086, 0.543272478677096, -88.8533325195313, -1.55078320383517, 218, 30, 'PPL', 'P'),
(88616, 'Little Creek', 36.2788887023926, 0.633186056821324, -86.7855606079102, -1.51469377579712, 218, 50, 'PPL', 'P'),
(103720, 'Little Creek', 36.9166717529297, 0.64431747096661, -76.1900024414063, -1.32976639970506, 218, 53, 'PPL', 'P'),
(112275, 'Little Creek', 33.8872184753418, 0.591443536737367, -85.3116683959961, -1.48896950387972, 218, 13, 'PPL', 'P'),
(22699, 'Little Creek Farms', 33.9324989318848, 0.592233829790848, -84.8775024414063, -1.48139187847206, 218, 13, 'PPL', 'P'),
(14132, 'Little Creek Landing', 39.160831451416, 0.683485446645759, -75.4452819824219, -1.31676857568882, 218, 10, 'PPL', 'P'),
(196924, 'Little Crooked (historical)', 47.5091705322266, 0.82919145067882, -108.550003051758, -1.89455495630307, 218, 31, 'PPL', 'P'),
(36915, 'Little Cypress', 37.0166702270508, 0.646062773586993, -88.4461135864258, -1.54367589267602, 218, 21, 'PPL', 'P'),
(95740, 'Little Cypress', 30.1644401550293, 0.52646879772605, -93.7558288574219, -1.63634790649833, 218, 51, 'PPL', 'P'),
(207932, 'Little Dalles (historical)', 48.8541717529297, 0.852666150423433, -117.868606567383, -2.05719526933864, 218, 56, 'PPL', 'P'),
(194291, 'Little Dam', 40.4222183227539, 0.705500800692036, -105.222221374512, -1.83647420924758, 218, 7, 'PPL', 'P'),
(113648, 'Little Danbury', 41.1288909912109, 0.717834565490465, -73.2438888549805, -1.27834701748419, 218, 8, 'PPL', 'P'),
(113646, 'Little Danbury (historical)', 41.127498626709, 0.717810264145518, -73.2477798461914, -1.27841492809199, 218, 8, 'PPL', 'P'),
(127976, 'Little Deer Isle', 44.2863883972168, 0.772943291348448, -68.6963882446289, -1.1989781590971, 218, 26, 'PPL', 'P'),
(127977, 'Little Diamond Island Landing', 43.6627807617188, 0.76205928486843, -70.210563659668, -1.22540550554229, 218, 26, 'PPL', 'P'),
(10123, 'Little Dixie', 35.0072212219238, 0.610991272296603, -91.3647232055664, -1.5946152401104, 218, 4, 'PPL', 'P'),
(36916, 'Little Dixie', 37.4613914489746, 0.653824623163056, -82.559440612793, -1.44093406729796, 218, 21, 'PPL', 'P'),
(182828, 'Little Dixie (historical)', 35.4952812194824, 0.619509526201276, -118.001106262207, -2.05950782527121, 218, 6, 'PPL', 'P'),
(88617, 'Little Doe', 36.4524993896484, 0.636216134930589, -81.8802795410156, -1.42908047044407, 218, 50, 'PPL', 'P'),
(103721, 'Little Duck', 36.7441711425781, 0.641306767354275, -82.3486099243164, -1.4372543776198, 218, 53, 'PPL', 'P'),
(202317, 'Little Eagle', 45.6758308410645, 0.797193636760546, -100.803886413574, -1.75935971672325, 218, 49, 'PPL', 'P'),
(66411, 'Little Easonburg', 35.9658317565918, 0.627722182370863, -77.8713912963867, -1.3591121712308, 218, 33, 'PPL', 'P'),
(175012, 'Little Eau Claire', 44.7863883972168, 0.781669937608419, -89.4475021362305, -1.56115341996188, 218, 57, 'PPL', 'P'),
(82119, 'Little Edisto', 32.5997200012207, 0.568972449249551, -80.3447189331055, -1.40227988197212, 218, 48, 'PPL', 'P'),
(125250, 'Little Egypt', 42.6055603027344, 0.743607306939707, -73.0813903808594, -1.27551088408131, 218, 23, 'PPL', 'P'),
(163857, 'Little Elk', 41.9638900756836, 0.732408048765651, -80.288330078125, -1.40129571079128, 218, 45, 'PPL', 'P'),
(201146, 'Little Elk (historical)', 44.6452789306641, 0.779207112811341, -123.784172058105, -2.16044136426911, 218, 43, 'PPL', 'P'),
(207933, 'Little Elkhorn', 45.7075004577637, 0.797746375844791, -122.415000915527, -2.13654481980783, 218, 56, 'PPL', 'P'),
(48980, 'Little Elkton', 39.6061096191406, 0.691257016759801, -75.8397216796875, -1.32365284710667, 218, 25, 'PPL', 'P'),
(95742, 'Little Elm', 33.1624984741211, 0.578794786561009, -96.9372177124023, -1.69187361680399, 218, 51, 'PPL', 'P'),
(88618, 'Little Emory', 35.9575004577637, 0.627576773775344, -84.4833297729492, -1.47451226758612, 218, 50, 'PPL', 'P'),
(103722, 'Little Falls', 38.2727813720703, 0.66798604883858, -77.4208297729492, -1.35124838916402, 218, 53, 'PPL', 'P'),
(110134, 'Little Falls', 39.5566711425781, 0.690394152566616, -80, -1.39626340159546, 218, 58, 'PPL', 'P'),
(127978, 'Little Falls', 43.7313919067383, 0.763256775252584, -70.4280624389648, -1.22920157536008, 218, 26, 'PPL', 'P'),
(136543, 'Little Falls', 45.976390838623, 0.802439398317729, -94.3622207641602, -1.64693144182835, 218, 28, 'PPL', 'P'),
(145618, 'Little Falls', 40.8688888549805, 0.713296672151025, -74.208610534668, -1.29518458716011, 218, 37, 'PPL', 'P'),
(150308, 'Little Falls', 43.0433311462402, 0.751247849528117, -74.8600006103516, -1.3065534886956, 218, 40, 'PPL', 'P'),
(175013, 'Little Falls', 45.2738914489746, 0.790178470975113, -92.4186096191406, -1.61300902796931, 218, 57, 'PPL', 'P'),
(207934, 'Little Falls', 47.8302803039551, 0.83479587345581, -117.91194152832, -2.05795160708822, 218, 56, 'PPL', 'P'),
(41819, 'Little Farms (historical)', 29.9644393920898, 0.522978125906256, -90.220832824707, -1.57465058668251, 218, 22, 'PPL', 'P'),
(145620, 'Little Ferry', 40.8527793884277, 0.713015508918939, -74.0425033569336, -1.29228546999745, 218, 37, 'PPL', 'P'),
(10124, 'Little Fir Landing', 34.6305618286133, 0.60441732572477, -93.4741668701172, -1.63143197744215, 218, 4, 'PPL', 'P'),
(10125, 'Little Flock', 36.3858299255371, 0.635052533271306, -94.1350021362305, -1.64296572864912, 218, 4, 'PPL', 'P'),
(150311, 'Little France', 43.3477783203125, 0.75656145511407, -76.0969390869141, -1.32814213775622, 218, 40, 'PPL', 'P'),
(178543, 'Little Franks', 32.4324989318848, 0.566053891010933, -109.214721679688, -1.90615648495978, 218, 5, 'PPL', 'P'),
(163858, 'Little Gap', 40.8327789306641, 0.712666435079057, -75.5227813720703, -1.31812119520647, 218, 45, 'PPL', 'P'),
(10126, 'Little Garnett', 33.8630599975586, 0.59102189175778, -91.8036117553711, -1.6022752903538, 218, 4, 'PPL', 'P'),
(150312, 'Little Genesee', 42.0269393920898, 0.733508466928072, -78.2063903808594, -1.36495900824602, 218, 40, 'PPL', 'P'),
(36917, 'Little Georgetown', 38.0263900756836, 0.663685709468374, -84.6158294677734, -1.47682482351869, 218, 21, 'PPL', 'P'),
(48981, 'Little Georgetown', 38.4497184753418, 0.671074183859608, -75.1363906860352, -1.31137740553611, 218, 25, 'PPL', 'P'),
(103723, 'Little Georgetown', 38.8230590820313, 0.677590206677733, -77.732780456543, -1.35669295569658, 218, 53, 'PPL', 'P'),
(110135, 'Little Georgetown', 39.5849990844727, 0.690888568422989, -77.9513931274414, -1.36050846659033, 218, 58, 'PPL', 'P'),
(163859, 'Little Germany', 40.3838882446289, 0.704831814626208, -77.2652816772461, -1.34853356274879, 218, 45, 'PPL', 'P'),
(10127, 'Little Green Store', 35.952220916748, 0.627484628401628, -90.0361099243164, -1.57142656386686, 218, 4, 'PPL', 'P'),
(116567, 'Little Groves', 41.5374984741211, 0.724966111415534, -90.688606262207, -1.58281477332026, 218, 16, 'PPL', 'P'),
(113647, 'Little Haddam', 41.4808311462402, 0.723977079965706, -72.4463882446289, -1.26442800604689, 218, 8, 'PPL', 'P'),
(16913, 'Little Harbor on the Hillsboro', 26.3172206878662, 0.459322150977232, -80.0883331298828, -1.39780510555051, 218, 12, 'PPL', 'P'),
(103724, 'Little Haven', 36.8633308410645, 0.643386496428545, -76.0769424438477, -1.32779313049536, 218, 53, 'PPL', 'P'),
(14133, 'Little Heaven', 39.0416717529297, 0.681405717571489, -75.4569396972656, -1.3169720411961, 218, 10, 'PPL', 'P'),
(103725, 'Little Hell', 37.6655616760254, 0.657388065859637, -75.7769393920898, -1.32255708947616, 218, 53, 'PPL', 'P'),
(82120, 'Little Hell Landing', 33.0611114501953, 0.577025249174705, -81.563606262207, -1.42355347907578, 218, 48, 'PPL', 'P'),
(36918, 'Little Hickman', 37.773609161377, 0.659273850227522, -84.5702819824219, -1.4760298699333, 218, 21, 'PPL', 'P'),
(163860, 'Little Hickory', 41.540828704834, 0.725024234906325, -79.3977813720703, -1.38575270372125, 218, 45, 'PPL', 'P'),
(73252, 'Little Hocking', 39.2605590820313, 0.685226022155208, -81.6999969482422, -1.42593394561615, 218, 41, 'PPL', 'P'),
(150313, 'Little Hollow', 42.666389465332, 0.744668976108267, -76.5688934326172, -1.33637929500783, 218, 40, 'PPL', 'P'),
(163862, 'Little Hollywood Mobile Home Park', 40.2333297729492, 0.702204073578626, -76.7724990844727, -1.33993288400838, 218, 45, 'PPL', 'P'),
(22700, 'Little Hope', 31.0127792358398, 0.541275107859536, -84.9094390869141, -1.48194927808822, 218, 13, 'PPL', 'P'),
(88619, 'Little Hope', 35.9030609130859, 0.626626624477431, -86.5213928222656, -1.51008317815992, 218, 50, 'PPL', 'P'),
(95743, 'Little Hope', 32.7794418334961, 0.572109186960474, -95.2566680908203, -1.66254249266424, 218, 51, 'PPL', 'P'),
(112210, 'Little Hope', 33.0072212219238, 0.576084687256717, -87.2825012207031, -1.52336702567724, 218, 2, 'PPL', 'P'),
(163861, 'Little Hope', 42.0988883972168, 0.734764213961072, -79.8191680908203, -1.39310728938761, 218, 45, 'PPL', 'P'),
(175016, 'Little Hope', 44.3183288574219, 0.773500757543628, -89.10888671875, -1.55524346602883, 218, 57, 'PPL', 'P'),
(207935, 'Little Hoquiam', 47.3219413757324, 0.825923685442266, -122.959167480469, -2.14604231804532, 218, 56, 'PPL', 'P'),
(27731, 'Little Indian', 39.8875007629395, 0.696168218705044, -90.2011108398438, -1.57430637311162, 218, 18, 'PPL', 'P'),
(13148, 'Little Indian Rock Terrace', 38.9077796936035, 0.679068860293972, -77.084716796875, -1.34538211107285, 218, 9, 'PPL', 'P'),
(120384, 'Little Ireland (historical)', 40.4938888549805, 0.706751687456046, -90.7236099243164, -1.58342570247432, 218, 18, 'PPL', 'P'),
(3798, 'Little Italy', 33.5161094665527, 0.584966462650185, -86.8899993896484, -1.51651657640523, 218, 2, 'PPL', 'P'),
(10128, 'Little Italy', 34.9375, 0.609774407415519, -92.5858306884766, -1.61592758620792, 218, 4, 'PPL', 'P'),
(48982, 'Little Italy', 39.2866706848145, 0.685681755596748, -76.6013870239258, -1.33694641516197, 218, 25, 'PPL', 'P'),
(60650, 'Little Italy', 32.3530616760254, 0.564667449347438, -89.3541717529297, -1.55952449748114, 218, 30, 'PPL', 'P'),
(110136, 'Little Italy', 38.7941703796387, 0.677086003704353, -79.5494384765625, -1.38839961952868, 218, 58, 'PPL', 'P'),
(127979, 'Little Italy', 45.6508293151855, 0.796757277815936, -68.6994400024414, -1.1990314223189, 218, 26, 'PPL', 'P'),
(156183, 'Little Italy', 41.5088882446289, 0.724466768711144, -81.5983276367188, -1.42415948138183, 218, 41, 'PPL', 'P'),
(163864, 'Little Italy', 40.2680587768555, 0.702810209042729, -75.024169921875, -1.30941878371242, 218, 45, 'PPL', 'P'),
(163863, 'Little Jack Corners', 40.1577796936035, 0.700885475943901, -78.3563919067383, -1.36757702875562, 218, 45, 'PPL', 'P'),
(182832, 'Little Jamison (historical)', 39.7430610656738, 0.693647270417175, -120.70027923584, -2.10661728074195, 218, 6, 'PPL', 'P'),
(14134, 'Little Jersey', 39.5569381713867, 0.690398813098523, -75.7149963378906, -1.32147597923164, 218, 10, 'PPL', 'P'),
(48983, 'Little John', 39.0258293151855, 0.681129214871312, -76.5366668701172, -1.33581683538561, 218, 25, 'PPL', 'P'),
(88620, 'Little John', 35.3086090087891, 0.616251481502701, -89.991943359375, -1.57065571188934, 218, 50, 'PPL', 'P'),
(103726, 'Little Johnsontown', 37.4333305358887, 0.653334867838591, -75.8561096191406, -1.32393887060775, 218, 53, 'PPL', 'P'),
(163865, 'Little Kansas', 40.4877815246582, 0.706645094433415, -77.8111114501953, -1.35806008944217, 218, 45, 'PPL', 'P'),
(33100, 'Little Kaw', 39.0366706848145, 0.681318432466762, -94.9211120605469, -1.65668593511104, 218, 20, 'PPL', 'P'),
(66412, 'Little Kelly', 34.464168548584, 0.601513215135066, -77.9522171020508, -1.36052284766022, 218, 33, 'PPL', 'P'),
(131800, 'Little Killarney Beach', 43.6841697692871, 0.762432593474232, -83.9177780151367, -1.46464152732185, 218, 27, 'PPL', 'P'),
(66413, 'Little Kinnakeet', 35.4063911437988, 0.617958101708251, -75.491943359375, -1.31758297035016, 218, 33, 'PPL', 'P'),
(131801, 'Little Lake', 46.288890838623, 0.807893552230211, -87.341667175293, -1.52439966638992, 218, 27, 'PPL', 'P'),
(182833, 'Little Lake', 35.9366683959961, 0.627213185707521, -117.905830383301, -2.05784494748657, 218, 6, 'PPL', 'P'),
(95744, 'Little Lake Acres Colonia', 27.9689998626709, 0.488151136093449, -98.0790023803711, -1.71180151860883, 218, 51, 'PPL', 'P'),
(16914, 'Little Lake City', 29.8261108398438, 0.520563837220045, -82.8919372558594, -1.4467372284713, 218, 12, 'PPL', 'P'),
(127980, 'Little Machias', 44.6472206115723, 0.779241001536212, -67.241943359375, -1.17359330706063, 218, 26, 'PPL', 'P'),
(131802, 'Little Manistee', 44.0955581665039, 0.769612675510167, -85.9091720581055, -1.49939791007625, 218, 27, 'PPL', 'P'),
(136546, 'Little Marais', 47.410831451416, 0.827475109935292, -91.1100006103516, -1.59016949214468, 218, 28, 'PPL', 'P'),
(136547, 'Little Marais Postoffice', 47.3955612182617, 0.827208594089202, -91.1347198486328, -1.59060092424127, 218, 28, 'PPL', 'P'),
(36919, 'Little Marina', 36.9463882446289, 0.644836121588903, -84.2958297729492, -1.47123977523863, 218, 21, 'PPL', 'P'),
(163867, 'Little Marsh', 41.8766708374023, 0.730885785886562, -77.4016723632813, -1.35091402928916, 218, 45, 'PPL', 'P'),
(163868, 'Little Meadows', 41.9905586242676, 0.73287350274517, -76.1311111450195, -1.32873855268234, 218, 45, 'PPL', 'P'),
(209573, 'Little Medicine', 42.3844413757324, 0.739748053625046, -105.977500915527, -1.84965632401126, 218, 59, 'PPL', 'P'),
(191770, 'Little Mexico Colonia', 30.9179992675781, 0.539620885348434, -102.877998352051, -1.79555979910459, 218, 51, 'PPL', 'P'),
(22701, 'Little Miami', 30.8141708374023, 0.537808737384689, -83.2605590820313, -1.45317089303271, 218, 13, 'PPL', 'P'),
(103727, 'Little Mill', 36.872501373291, 0.643546552410059, -77.4911117553711, -1.35247504116211, 218, 53, 'PPL', 'P'),
(88621, 'Little Milligan', 36.3147201538086, 0.633811433624302, -82.0183334350586, -1.43148996544032, 218, 50, 'PPL', 'P'),
(103728, 'Little Montgomery', 37.0233306884766, 0.646179020568575, -80.5472183227539, -1.40581416305476, 218, 53, 'PPL', 'P'),
(182834, 'Little Morongo Heights', 34.0955581665039, 0.595079750310734, -116.519172668457, -2.03364320476436, 218, 6, 'PPL', 'P'),
(36920, 'Little Mount', 38.0613899230957, 0.664296572043411, -85.2513885498047, -1.48791742209109, 218, 21, 'PPL', 'P'),
(82121, 'Little Mountain', 34.1961097717285, 0.596834706890069, -81.4124984741211, -1.42091615064827, 218, 48, 'PPL', 'P'),
(156184, 'Little Mountain', 41.6402816772461, 0.726760016725811, -81.2819366455078, -1.41863741686155, 218, 41, 'PPL', 'P'),
(204721, 'Little Mountain', 41.2444381713867, 0.719851244225928, -112.253890991211, -1.95919999597143, 218, 52, 'PPL', 'P'),
(82122, 'Little Mountain (historical)', 34.7958297729492, 0.607301795501435, -79.8613891601563, -1.39384418606124, 218, 48, 'PPL', 'P'),
(204722, 'Little Mountain Canyon Condominium', 40.7841682434082, 0.711818018534785, -111.720001220703, -1.94988186163335, 218, 52, 'PPL', 'P'),
(125251, 'Little Nahant', 42.4361114501953, 0.740649866549174, -70.9333267211914, -1.23802010067766, 218, 23, 'PPL', 'P'),
(3799, 'Little Nashville', 34.7527809143066, 0.606550451178896, -86.2311096191406, -1.50501678050216, 218, 2, 'PPL', 'P'),
(125252, 'Little Neck', 42.6958312988281, 0.745182833040598, -70.7930603027344, -1.23557198984561, 218, 23, 'PPL', 'P'),
(150315, 'Little Neck', 40.7619400024414, 0.711430062542988, -73.7386093139648, -1.28698151837044, 218, 40, 'PPL', 'P'),
(48984, 'Little Neck Farms', 39.1650009155273, 0.683558217522546, -76.2588882446289, -1.33096868377917, 218, 25, 'PPL', 'P'),
(36921, 'Little Needmore', 37.6577796936035, 0.657252244644043, -84.7266693115234, -1.47875934373452, 218, 21, 'PPL', 'P'),
(3800, 'Little New York', 34.3877792358398, 0.600179970114345, -86.1858291625977, -1.50422648744868, 218, 2, 'PPL', 'P'),
(95745, 'Little New York', 29.5508308410645, 0.51575929487646, -97.3063888549805, -1.69831686874532, 218, 51, 'PPL', 'P'),
(175017, 'Little Norway', 43.0269393920898, 0.750961759448015, -89.789436340332, -1.56712129764864, 218, 57, 'PPL', 'P'),
(193054, 'Little Norway', 38.8247184753418, 0.677619168554587, -120.03556060791, -2.09501575208524, 218, 6, 'PPL', 'P'),
(3802, 'Little Oak', 31.7308292388916, 0.553807444606745, -86.0538864135742, -1.50192365205408, 218, 2, 'PPL', 'P'),
(120386, 'Little Oklahoma', 41.857780456543, 0.73055608654361, -90.1508331298828, -1.57342886153244, 218, 18, 'PPL', 'P'),
(207936, 'Little Oklahoma', 48.0438919067383, 0.83852409924484, -123.305282592773, -2.15208316634595, 218, 56, 'PPL', 'P'),
(163870, 'Little Oley', 40.3127784729004, 0.703590714979203, -75.6536102294922, -1.3204045895251, 218, 45, 'PPL', 'P'),
(112378, 'Little Orleans', 39.6258316040039, 0.691601230330694, -78.3866729736328, -1.36810553307395, 218, 25, 'PPL', 'P'),
(110138, 'Little Otter', 38.6861114501953, 0.675200019599386, -80.7638931274414, -1.40959585180267, 218, 58, 'PPL', 'P'),
(131803, 'Little Paw Paw Lake', 42.2194404602051, 0.736868244380289, -86.2838897705078, -1.50593796792322, 218, 27, 'PPL', 'P'),
(182836, 'Little Penny', 38.922779083252, 0.679330649029127, -123.456672668457, -2.15472542162147, 218, 6, 'PPL', 'P'),
(136548, 'Little Pine', 46.7455596923828, 0.815863927319628, -93.8611068725586, -1.63818535449243, 218, 28, 'PPL', 'P'),
(112650, 'Little Pittsburg', 39.3958282470703, 0.687586914461563, -80.7438888549805, -1.40924671138376, 218, 58, 'PPL', 'P'),
(150316, 'Little Plains', 40.8505592346191, 0.712976759925079, -73.3661117553711, -1.28048020951734, 218, 40, 'PPL', 'P'),
(103729, 'Little Plymouth', 37.6272201538086, 0.656718880056727, -76.7930603027344, -1.34029174496527, 218, 53, 'PPL', 'P'),
(30353, 'Little Point', 39.564998626709, 0.690539494583107, -86.6319427490234, -1.51201263836969, 218, 19, 'PPL', 'P'),
(175018, 'Little Point', 43.9188919067383, 0.766529267600073, -88.4686126708984, -1.54406857577875, 218, 57, 'PPL', 'P'),
(131804, 'Little Point Sable', 43.6347198486328, 0.761569529543964, -86.5374984741211, -1.51036427481298, 218, 27, 'PPL', 'P'),
(193071, 'Little Ponderosa', 36.9569396972656, 0.645020279178282, -100.875831604004, -1.76061539717722, 218, 42, 'PPL', 'P'),
(66415, 'Little Port', 34.8819389343262, 0.608804683883594, -76.3358306884766, -1.33231158275885, 218, 33, 'PPL', 'P'),
(41820, 'Little Prairie', 30.3233299255371, 0.52924194736915, -90.9222183227539, -1.58689207294917, 218, 22, 'PPL', 'P'),
(175019, 'Little Prairie', 42.8388900756836, 0.747679679720602, -88.5388870239258, -1.54529509461879, 218, 57, 'PPL', 'P'),
(10129, 'Little Prairie (historical)', 34.8183288574219, 0.607694478604167, -91.0141677856445, -1.58849689382205, 218, 4, 'PPL', 'P'),
(66416, 'Little Prong', 34.103889465332, 0.595225158906252, -78.5086135864258, -1.37023379825908, 218, 33, 'PPL', 'P'),
(150317, 'Little Rapids', 43.9286117553711, 0.766698910961511, -74.8736114501953, -1.30679104266483, 218, 40, 'PPL', 'P'),
(175020, 'Little Rapids', 44.3802795410156, 0.7745820009462, -88.1272201538086, -1.53811015231386, 218, 57, 'PPL', 'P'),
(326, 'Little Red', 35.4466705322266, 0.618661109657004, -91.7361068725586, -1.60109710788755, 218, 4, 'PPL', 'P'),
(125253, 'Little Rest', 42.1405601501465, 0.735491523254772, -72.1875, -1.25990955378341, 218, 23, 'PPL', 'P'),
(816, 'Little Richmond', 39.774169921875, 0.694190222384415, -84.4444427490234, -1.47383356098231, 218, 41, 'PPL', 'P'),
(66418, 'Little Richmond', 36.2947196960449, 0.633462359784419, -80.7577819824219, -1.40948919220102, 218, 33, 'PPL', 'P'),
(95746, 'Little Ridge', 33.0627784729004, 0.577054344209615, -96.4544372558594, -1.68344750827303, 218, 51, 'PPL', 'P'),
(3804, 'Little Ridge Estates', 33.4055595397949, 0.583037002440423, -86.6777801513672, -1.51281265196115, 218, 2, 'PPL', 'P'),
(3806, 'Little River', 34.2813911437988, 0.598323147623314, -85.6733322143555, -1.49528172829543, 218, 2, 'PPL', 'P'),
(10130, 'Little River', 35.8074989318848, 0.624958753265742, -90.1002807617188, -1.5725465562633, 218, 4, 'PPL', 'P'),
(16915, 'Little River', 25.8472194671631, 0.45111908218757, -80.1927795410156, -1.39962803931667, 218, 12, 'PPL', 'P'),
(22702, 'Little River', 33.6552810668945, 0.58739546530142, -82.7669372558594, -1.44455556690631, 218, 13, 'PPL', 'P'),
(33101, 'Little River', 38.3980598449707, 0.670172570672562, -98.0116729736328, -1.71062639877783, 218, 20, 'PPL', 'P'),
(55949, 'Little River', 36.8544387817383, 0.643231300716021, -89.663330078125, -1.56492032816575, 218, 29, 'PPL', 'P'),
(66419, 'Little River', 35.2386093139648, 0.615029756352627, -82.6291732788086, -1.44215113191613, 218, 33, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(82123, 'Little River', 33.8730583190918, 0.591196395388208, -78.6144409179688, -1.37208083363311, 218, 48, 'PPL', 'P'),
(88623, 'Little River', 35.8505592346191, 0.625710297325362, -83.9419403076172, -1.46506323888046, 218, 50, 'PPL', 'P'),
(95747, 'Little River', 30.9886093139648, 0.540853263142868, -97.3658294677734, -1.69935430314796, 218, 51, 'PPL', 'P'),
(125254, 'Little River', 42.0999984741211, 0.734783588458002, -72.7200012207031, -1.26920345335557, 218, 23, 'PPL', 'P'),
(182838, 'Little River', 39.2708282470703, 0.68540525289657, -123.787216186523, -2.16049449433285, 218, 6, 'PPL', 'P'),
(41821, 'Little River (historical)', 30.5955600738525, 0.533993259780446, -90.5755615234375, -1.58084177042668, 218, 22, 'PPL', 'P'),
(88624, 'Little River (historical)', 35.6069412231445, 0.621458360907969, -84.2188873291016, -1.46989687625896, 218, 50, 'PPL', 'P'),
(127981, 'Little River Corner', 44.7152786254883, 0.780428837961415, -67.7736129760742, -1.18287269240485, 218, 26, 'PPL', 'P'),
(22703, 'Little River Crossing', 34.1130599975586, 0.595385214887766, -84.4747161865234, -1.47436193214258, 218, 13, 'PPL', 'P'),
(103730, 'Little River Crossing', 37.8208312988281, 0.660098032005874, -77.4261093139648, -1.35134053453773, 218, 53, 'PPL', 'P'),
(103731, 'Little River Hills', 38.8474998474121, 0.678016778505336, -77.2905578613281, -1.34897471538336, 218, 53, 'PPL', 'P'),
(22704, 'Little River Landing', 34.1647186279297, 0.596286828074813, -84.5811080932617, -1.47621882121264, 218, 13, 'PPL', 'P'),
(22705, 'Little River North', 34.1138916015625, 0.595399729115707, -84.4908294677734, -1.47464316195369, 218, 13, 'PPL', 'P'),
(22706, 'Little River South', 34.1097183227539, 0.595326891659894, -84.4902801513672, -1.47463357457377, 218, 13, 'PPL', 'P'),
(82124, 'Little River Subdivision', 33.8499984741211, 0.59079392516847, -82.3672180175781, -1.43757915011474, 218, 48, 'PPL', 'P'),
(95748, 'Little River-Academy', 30.9861106872559, 0.540809653880018, -97.3583297729492, -1.69922340878039, 218, 51, 'PPL', 'P'),
(3807, 'Little Rock', 31.1144409179688, 0.543049438935802, -87.3888931274414, -1.5252239147473, 218, 2, 'PPL', 'P'),
(10135, 'Little Rock', 34.7463912963867, 0.606438931308249, -92.289436340332, -1.6107545289485, 218, 4, 'PPL', 'P'),
(30354, 'Little Rock', 38.4947204589844, 0.6718596166441, -87.6791687011719, -1.53029017924701, 218, 19, 'PPL', 'P'),
(36922, 'Little Rock', 38.1938896179199, 0.666609127975982, -84.0511093139648, -1.46696859748236, 218, 21, 'PPL', 'P'),
(60651, 'Little Rock', 32.5258293151855, 0.56768281349168, -89.0252838134766, -1.55378432006758, 218, 30, 'PPL', 'P'),
(82125, 'Little Rock', 34.476390838623, 0.601726534338381, -79.4033279418945, -1.38584950962687, 218, 48, 'PPL', 'P'),
(116568, 'Little Rock', 43.4441719055176, 0.758243840553701, -95.883056640625, -1.67347503525512, 218, 16, 'PPL', 'P'),
(120387, 'Little Rock', 41.7174987792969, 0.728107709395446, -88.5761108398438, -1.54594477276671, 218, 18, 'PPL', 'P'),
(136550, 'Little Rock', 45.8325004577637, 0.799928037409784, -94.0924987792969, -1.64222390512748, 218, 28, 'PPL', 'P'),
(195254, 'Little Rock', 43.9169387817383, 0.76649517913812, -116.692779541016, -2.0366732162946, 218, 17, 'PPL', 'P'),
(41822, 'Little Rock (historical)', 29.8869400024414, 0.521625506388605, -89.9561080932617, -1.57003026850734, 218, 22, 'PPL', 'P'),
(60652, 'Little Rock (historical)', 32.3772201538086, 0.565089094327025, -89.0722198486328, -1.55460350841889, 218, 30, 'PPL', 'P'),
(120388, 'Little Rock (historical)', 41.3180618286133, 0.721136219451891, -89.0466690063477, -1.55415756209435, 218, 18, 'PPL', 'P'),
(150318, 'Little Rock City', 42.208610534668, 0.73667922652192, -78.7088928222656, -1.37372933034787, 218, 40, 'PPL', 'P'),
(66427, 'Little Rock Creek (historical)', 36.0538902282715, 0.629259092635947, -82.165283203125, -1.43405472272812, 218, 33, 'PPL', 'P'),
(672, 'Little Rock Landing', 38.0050010681152, 0.663312400862573, -90.0599975585938, -1.57184348173552, 218, 29, 'PPL', 'P'),
(88625, 'Little Rock Mills', 35.8480606079102, 0.625666688062512, -87.2980575561523, -1.52363853495037, 218, 50, 'PPL', 'P'),
(145622, 'Little Rocky Hill', 40.3974990844727, 0.705069368595443, -74.5891723632813, -1.30182664407682, 218, 37, 'PPL', 'P'),
(175023, 'Little Rose', 44.8008308410645, 0.781922005805595, -90.170280456543, -1.57376828141337, 218, 57, 'PPL', 'P'),
(175024, 'Little Round Lake', 45.9650001525879, 0.802240593342355, -91.3677825927734, -1.59466863649026, 218, 57, 'PPL', 'P'),
(163871, 'Little Roundtop', 40.6522216796875, 0.709515116561167, -77.3574981689453, -1.35014304415358, 218, 45, 'PPL', 'P'),
(103733, 'Little Run Estates', 38.8233299255371, 0.677594933788668, -77.2733306884766, -1.34867404449629, 218, 53, 'PPL', 'P'),
(30355, 'Little Saint Louis', 38.3027801513672, 0.668509626308889, -86.2369384765625, -1.5051185132558, 218, 19, 'PPL', 'P'),
(103734, 'Little Salisbury', 37.3205604553223, 0.651366658634968, -75.9352798461914, -1.32532065173933, 218, 53, 'PPL', 'P'),
(156185, 'Little Sandusky', 40.7386093139648, 0.711022865212315, -83.2152786254883, -1.45238059997923, 218, 41, 'PPL', 'P'),
(36923, 'Little Sandy', 38.0611114501953, 0.664291711774422, -83.1819381713867, -1.45179869928105, 218, 21, 'PPL', 'P'),
(110139, 'Little Sandy', 39.6302795410156, 0.69167886147647, -79.6447219848633, -1.39006263047138, 218, 58, 'PPL', 'P'),
(112209, 'Little Sandy', 33.0999984741211, 0.577703955778512, -87.5550003051758, -1.52812303190996, 218, 2, 'PPL', 'P'),
(136553, 'Little Sauk', 45.8638916015625, 0.800475916225041, -94.9180603027344, -1.65663267188924, 218, 28, 'PPL', 'P'),
(193740, 'Little Shasta', 41.7119407653809, 0.72801070375274, -122.390281677246, -2.13611338771123, 218, 6, 'PPL', 'P'),
(3808, 'Little Shawmut', 32.8466682434082, 0.573282509157735, -85.2099990844727, -1.4871950396454, 218, 2, 'PPL', 'P'),
(3809, 'Little Shenandoah', 33.8833312988281, 0.591375692708597, -86.6833267211914, -1.51290945786677, 218, 2, 'PPL', 'P'),
(3810, 'Little Shoal', 33.5008316040039, 0.584699813646041, -87.2486114501953, -1.52277553759913, 218, 2, 'PPL', 'P'),
(145623, 'Little Silver', 40.336669921875, 0.704007699426883, -74.0475006103516, -1.29237268852315, 218, 37, 'PPL', 'P'),
(145624, 'Little Silver Point', 40.3355598449707, 0.703988324929952, -74.029167175293, -1.29205270971817, 218, 37, 'PPL', 'P'),
(116569, 'Little Sioux', 41.809440612793, 0.729712397110273, -96.0208282470703, -1.67587960340335, 218, 16, 'PPL', 'P'),
(178544, 'Little Spring', 34.5986099243164, 0.603859659792507, -111.228332519531, -1.9413006239689, 218, 5, 'PPL', 'P'),
(112432, 'Little Springs', 31.4022197723389, 0.548072127462177, -90.7266693115234, -1.58347909885418, 218, 30, 'PPL', 'P'),
(175025, 'Little Sturgeon', 44.8388900756836, 0.782586264760488, -87.5625, -1.52825392627753, 218, 57, 'PPL', 'P'),
(175026, 'Little Suamico', 44.7174987792969, 0.780467586955276, -88.0091705322266, -1.53604979773652, 218, 57, 'PPL', 'P'),
(195255, 'Little Sugar Loaf', 43.0961112976074, 0.752169036949175, -116.70361328125, -2.036862300732, 218, 17, 'PPL', 'P'),
(163873, 'Little Summit', 41.0991706848145, 0.717315848289145, -75.4130630493164, -1.31620624922465, 218, 45, 'PPL', 'P'),
(60653, 'Little Sunflower', 32.6941719055176, 0.57062094596431, -90.815559387207, -1.58503052334721, 218, 30, 'PPL', 'P'),
(136555, 'Little Swan', 47.2972183227539, 0.825492186766646, -92.8308334350586, -1.62020369081221, 218, 28, 'PPL', 'P'),
(66428, 'Little Switzerland', 35.8491706848145, 0.625686062559443, -82.0905609130859, -1.43275057274231, 218, 33, 'PPL', 'P'),
(201147, 'Little Switzerland', 44.4000015258789, 0.774926214517093, -123.901390075684, -2.1624872046185, 218, 43, 'PPL', 'P'),
(3811, 'Little Texas', 32.4427795410156, 0.566233321489377, -85.5683288574219, -1.49344907399129, 218, 2, 'PPL', 'P'),
(10136, 'Little Texas', 34.8424987792969, 0.608116323320836, -93.7255630493164, -1.63581966849611, 218, 4, 'PPL', 'P'),
(36924, 'Little Texas', 38.0125007629395, 0.66344329523015, -84.6419372558594, -1.4772804903812, 218, 21, 'PPL', 'P'),
(41823, 'Little Texas', 29.8805599212646, 0.521514152965526, -91.019172668457, -1.58858424550581, 218, 22, 'PPL', 'P'),
(60654, 'Little Texas', 34.6272201538086, 0.604359002496897, -90.2819366455078, -1.57571704954104, 218, 30, 'PPL', 'P'),
(82126, 'Little Texas', 34.9677810668945, 0.610302911733845, -82.399169921875, -1.438136816047, 218, 48, 'PPL', 'P'),
(88626, 'Little Texas', 35.8005599975586, 0.624837646015171, -86.7830581665039, -1.51465009995525, 218, 50, 'PPL', 'P'),
(103735, 'Little Texas', 36.6019401550293, 0.638824368323185, -77.3397216796875, -1.34983278588659, 218, 53, 'PPL', 'P'),
(82127, 'Little Town', 33.959171295166, 0.592699350349394, -78.7375030517578, -1.37422867305226, 218, 48, 'PPL', 'P'),
(103736, 'Little Town', 37.1138916015625, 0.647759606675537, -81.3522186279297, -1.41986406885964, 218, 53, 'PPL', 'P'),
(103737, 'Little Tree Acres', 37.3180618286133, 0.651323049372118, -79.8733291625977, -1.39405257841653, 218, 53, 'PPL', 'P'),
(204723, 'Little Trieste', 40.6622200012207, 0.709689620191594, -111.96639251709, -1.95418220100356, 218, 52, 'PPL', 'P'),
(116572, 'Little Turkey', 43.1297187805176, 0.752755598179265, -92.100830078125, -1.60746272868311, 218, 16, 'PPL', 'P'),
(673, 'Little Union', 39.8308296203613, 0.695179120676188, -91.654167175293, -1.59966699038217, 218, 29, 'PPL', 'P'),
(150319, 'Little Utica', 43.2161102294922, 0.754263413409441, -76.4019393920898, -1.33346539730112, 218, 40, 'PPL', 'P'),
(36925, 'Little Valley', 37.2041702270508, 0.649335265934482, -87.4563903808594, -1.52640196405549, 218, 21, 'PPL', 'P'),
(150320, 'Little Valley', 42.252498626709, 0.737445218230454, -78.8058319091797, -1.37542123658839, 218, 40, 'PPL', 'P'),
(193741, 'Little Valley', 40.8944396972656, 0.713742618475558, -121.176391601563, -2.11492700913327, 218, 6, 'PPL', 'P'),
(41824, 'Little Valley Plantation', 29.920280456543, 0.522207407086787, -91.7675018310547, -1.60164505328183, 218, 22, 'PPL', 'P'),
(131806, 'Little Venice', 42.690559387207, 0.745090820824936, -84.9558334350586, -1.48275901221766, 218, 27, 'PPL', 'P'),
(82128, 'Little Vista Heights', 34.939998626709, 0.609818016678369, -81.913330078125, -1.42965731113619, 218, 48, 'PPL', 'P'),
(3812, 'Little Walker', 32.1502799987793, 0.561128241416777, -88.1777801513672, -1.53899259074106, 218, 2, 'PPL', 'P'),
(73253, 'Little Walnut', 39.6841697692871, 0.692619423394459, -82.9711074829102, -1.44811900960289, 218, 41, 'PPL', 'P'),
(188881, 'Little Walnut Village', 32.8352813720703, 0.573083770761388, -108.273887634277, -1.88973583315251, 218, 38, 'PPL', 'P'),
(3813, 'Little Warrior', 33.9075012207031, 0.591797537425266, -86.5983276367188, -1.51142594398154, 218, 2, 'PPL', 'P'),
(48985, 'Little Washington', 38.853889465332, 0.678128298375983, -76.8480606079102, -1.34125168138019, 218, 25, 'PPL', 'P'),
(103738, 'Little Washington', 39.0402793884277, 0.681381416226542, -77.5952835083008, -1.35429318123831, 218, 53, 'PPL', 'P'),
(156186, 'Little Washington', 40.6958312988281, 0.710276248000711, -82.4727783203125, -1.43942152495685, 218, 41, 'PPL', 'P'),
(163874, 'Little Washington', 40.0480613708496, 0.69897052996208, -75.7852783203125, -1.32270263122973, 218, 45, 'PPL', 'P'),
(188882, 'Little Water', 36.4463882446289, 0.636109475328931, -108.724166870117, -1.89759468837128, 218, 38, 'PPL', 'P'),
(192673, 'Little Water', 37.103328704834, 0.647575249349076, -109.551109313965, -1.91202755674091, 218, 52, 'PPL', 'P'),
(175028, 'Little Waupon', 44.5938911437988, 0.77831022673523, -89.3944396972656, -1.56022730569281, 218, 57, 'PPL', 'P'),
(88627, 'Little White Oak', 36.524169921875, 0.637467021694599, -84.0536117553711, -1.46701227332424, 218, 50, 'PPL', 'P'),
(110140, 'Little Wildcat (historical)', 38.752498626709, 0.676358694410653, -80.4402770996094, -1.40394768660478, 218, 58, 'PPL', 'P'),
(204725, 'Little Willow', 40.5605583190918, 0.707915289115329, -111.884437561035, -1.95275181718208, 218, 52, 'PPL', 'P'),
(175029, 'Little Wolf (historical)', 44.4222183227539, 0.775313970771809, -88.9013900756836, -1.55162196642049, 218, 57, 'PPL', 'P'),
(41828, 'Little Woods', 30.0750007629395, 0.5249077858531, -89.9441680908203, -1.56982187615204, 218, 22, 'PPL', 'P'),
(60655, 'Little Yazoo', 32.7077789306641, 0.570858433354518, -90.3724975585938, -1.577297635648, 218, 30, 'PPL', 'P'),
(30356, 'Little York', 38.7027816772461, 0.675490969948478, -85.9049987792969, -1.49932507262044, 218, 19, 'PPL', 'P'),
(120391, 'Little York', 41.0111083984375, 0.715778871445033, -90.7461090087891, -1.58381838557706, 218, 18, 'PPL', 'P'),
(145626, 'Little York', 40.6111106872559, 0.708797594384472, -75.0763931274414, -1.3103302505955, 218, 37, 'PPL', 'P'),
(150324, 'Little York', 42.7569389343262, 0.746249362478147, -74.4972229003906, -1.30022182320394, 218, 40, 'PPL', 'P'),
(156187, 'Little York', 41.2944412231445, 0.720723962115147, -81.5236129760742, -1.42285546455407, 218, 41, 'PPL', 'P'),
(182841, 'Little York (historical)', 39.1952781677246, 0.684086655261845, -120.876106262207, -2.10968604126605, 218, 6, 'PPL', 'P'),
(541, 'Little Zion', 37.5444412231445, 0.655274115165359, -87.7233276367188, -1.53106089806648, 218, 21, 'PPL', 'P'),
(3814, 'Little Zion (historical)', 34.6327781677246, 0.604456008139603, -87.8722229003906, -1.53365961065818, 218, 2, 'PPL', 'P'),
(88628, 'Littlebrook', 35.8394393920898, 0.625516219460923, -83.9441680908203, -1.46510212103238, 218, 50, 'PPL', 'P'),
(22707, 'Littlebrooke Farm', 33.9533309936523, 0.592597417858671, -84.2930603027344, -1.47119143886484, 218, 13, 'PPL', 'P'),
(202319, 'Littleburg', 43.0449981689453, 0.751276944563026, -100.451667785645, -1.75321234197902, 218, 49, 'PPL', 'P'),
(112459, 'Littlefield', 35.4341697692871, 0.6184429301847, -77.4219436645508, -1.35126783023998, 218, 33, 'PPL', 'P'),
(144065, 'Littlefield', 43.0386085510254, 0.751165424692379, -70.9977798461914, -1.23914501992211, 218, 36, 'PPL', 'P'),
(178546, 'Littlefield', 36.8872184753418, 0.643803414297197, -113.928886413574, -1.9884341810475, 218, 5, 'PPL', 'P'),
(191771, 'Littlefield', 33.9172210693359, 0.591967180786704, -102.324440002441, -1.785898383302, 218, 51, 'PPL', 'P'),
(127982, 'Littlefield Corner', 44.0666694641113, 0.769108472536788, -70.271110534668, -1.22646224786283, 218, 26, 'PPL', 'P'),
(136556, 'Littlefork', 48.3988914489746, 0.844720010099936, -93.5555572509766, -1.6328525075676, 218, 28, 'PPL', 'P'),
(127983, 'Littlejohn Island', 43.7550010681152, 0.763668832852247, -70.1350021362305, -1.22408670817048, 218, 26, 'PPL', 'P'),
(88629, 'Littlelot', 35.788890838623, 0.624633980770807, -87.3230590820313, -1.52407489389498, 218, 50, 'PPL', 'P'),
(116573, 'Littleport', 42.7547187805176, 0.746210613484287, -91.3691711425781, -1.59469287125618, 218, 16, 'PPL', 'P'),
(150325, 'Littlerest', 41.7708282470703, 0.729038484196428, -73.6444396972656, -1.2853379485037, 218, 40, 'PPL', 'P'),
(182842, 'Littlerock', 34.521110534668, 0.602507040274856, -117.982780456543, -2.05918797962429, 218, 6, 'PPL', 'P'),
(207937, 'Littlerock', 46.9019393920898, 0.818593267962795, -123.016670227051, -2.14704593030212, 218, 56, 'PPL', 'P'),
(30357, 'Littles', 38.4011116027832, 0.670225833894364, -87.2872161865234, -1.52344931735492, 218, 19, 'PPL', 'P'),
(10139, 'Littles (historical)', 33.8713912963867, 0.591167300353299, -91.2583312988281, -1.59275835104034, 218, 4, 'PPL', 'P'),
(163875, 'Littles Corners', 41.7130584716797, 0.728030211407724, -80.2322235107422, -1.40031646645846, 218, 45, 'PPL', 'P'),
(66429, 'Littles Quarters', 34.8224983215332, 0.607767249480953, -80.1994400024414, -1.39974428629825, 218, 33, 'PPL', 'P'),
(199486, 'Littles Trailer Court', 42.8727798461914, 0.748271167798708, -100.550559997559, -1.7549383366815, 218, 35, 'PPL', 'P'),
(110144, 'Littlesburg', 37.3233299255371, 0.651414995008753, -81.2152786254883, -1.41747401493935, 218, 58, 'PPL', 'P'),
(78631, 'Littlestown', 39.7444381713867, 0.693671305446013, -77.0883331298828, -1.34544522799068, 218, 45, 'PPL', 'P'),
(3816, 'Littleton', 33.6886100769043, 0.58797716626252, -86.9980621337891, -1.51840262708922, 218, 2, 'PPL', 'P'),
(36926, 'Littleton', 37.1624984741211, 0.648607956640782, -83.7547225952148, -1.46179567338099, 218, 21, 'PPL', 'P'),
(66430, 'Littleton', 36.434440612793, 0.635900949815578, -77.9122161865234, -1.35982469998045, 218, 33, 'PPL', 'P'),
(82129, 'Littleton', 34.1788902282715, 0.596534169161054, -81.1758270263672, -1.41678545463951, 218, 48, 'PPL', 'P'),
(103739, 'Littleton', 36.9025001525879, 0.644070129880369, -77.1494369506836, -1.3465116908492, 218, 53, 'PPL', 'P'),
(110141, 'Littleton', 39.6977806091309, 0.692856977363694, -80.517219543457, -1.40529058558445, 218, 58, 'PPL', 'P'),
(116574, 'Littleton', 42.5333290100098, 0.742346633058691, -92.0233306884766, -1.60611010916546, 218, 16, 'PPL', 'P'),
(120392, 'Littleton', 40.2338905334473, 0.702213860695633, -90.6222229003906, -1.58165616508802, 218, 18, 'PPL', 'P'),
(125255, 'Littleton', 42.5374984741211, 0.742419403935477, -71.5124969482422, -1.24812852806922, 218, 23, 'PPL', 'P'),
(127984, 'Littleton', 46.2308311462402, 0.806880219435436, -67.841667175293, -1.18406046225102, 218, 26, 'PPL', 'P'),
(144066, 'Littleton', 44.3061103820801, 0.77328750491934, -71.7705612182617, -1.25263259926282, 218, 36, 'PPL', 'P'),
(145627, 'Littleton', 40.8433303833008, 0.712850592668436, -74.4630584716797, -1.29962554143587, 218, 37, 'PPL', 'P'),
(186991, 'Littleton', 39.6133308410645, 0.691383050858389, -105.01611328125, -1.83287694440516, 218, 7, 'PPL', 'P'),
(204727, 'Littleton', 41.0391693115234, 0.716268626769498, -111.717498779297, -1.94983818579148, 218, 52, 'PPL', 'P'),
(125256, 'Littleton Common', 42.5458297729492, 0.742564812530995, -71.4749984741211, -1.24747405623134, 218, 23, 'PPL', 'P'),
(3817, 'Littletons', 33.6324996948242, 0.586997855350671, -87.2486114501953, -1.52277553759913, 218, 2, 'PPL', 'P'),
(103740, 'Littletown', 39.0611114501953, 0.681745004294365, -77.8427810668945, -1.35861282852641, 218, 53, 'PPL', 'P'),
(145628, 'Littletown', 40.5750007629395, 0.708167357312505, -74.9638900756836, -1.30836670192378, 218, 37, 'PPL', 'P'),
(163876, 'Littletown', 40.5202789306641, 0.707212281166575, -79.0261077880859, -1.37926577593803, 218, 45, 'PPL', 'P'),
(178545, 'Littletown', 32.1302795410156, 0.560779167576895, -110.872222900391, -1.93508533861687, 218, 5, 'PPL', 'P'),
(3819, 'Littleville', 34.2513885498047, 0.597799503573978, -87.5749969482422, -1.52847203917081, 218, 2, 'PPL', 'P'),
(36927, 'Littleville', 37.0611114501953, 0.646838419254479, -88.6033325195313, -1.54641988070518, 218, 21, 'PPL', 'P'),
(125258, 'Littleville', 42.2874984741211, 0.738056080805491, -72.8916702270508, -1.27219964273996, 218, 23, 'PPL', 'P'),
(150327, 'Littleville', 42.9430618286133, 0.749497819796799, -77.2222213745117, -1.34778201868917, 218, 40, 'PPL', 'P'),
(120394, 'Littleville (historical)', 40.3416709899902, 0.70409498453161, -88.9555587768555, -1.55256738860747, 218, 18, 'PPL', 'P'),
(16917, 'Littman', 30.5919399261475, 0.533930076283584, -84.5144424438477, -1.47505528613238, 218, 12, 'PPL', 'P'),
(60656, 'Litton', 33.6458282470703, 0.587230482471889, -90.8372192382813, -1.58540855906394, 218, 30, 'PPL', 'P'),
(88630, 'Litton', 35.7383308410645, 0.623751542343609, -85.0361099243164, -1.48416010126715, 218, 50, 'PPL', 'P'),
(36932, 'Littrell', 36.6858291625977, 0.640288507711483, -85.3963928222656, -1.49044822407499, 218, 21, 'PPL', 'P'),
(103741, 'Litwalton', 37.8008308410645, 0.659748958165992, -76.5699996948242, -1.33639860292574, 218, 53, 'PPL', 'P'),
(110142, 'Litwar', 37.4813919067383, 0.654173697002938, -81.8386077880859, -1.42835316115037, 218, 58, 'PPL', 'P'),
(103742, 'Litz', 36.8116683959961, 0.642484816662472, -81.7922210693359, -1.42754356017899, 218, 53, 'PPL', 'P'),
(88631, 'Litz Manor', 36.5233306884766, 0.637452374308603, -82.5166702270508, -1.44018758324441, 218, 50, 'PPL', 'P'),
(163877, 'Litzenberg', 40.589168548584, 0.708414631819719, -75.5972213745117, -1.31942041834426, 218, 45, 'PPL', 'P'),
(78632, 'Live Easy', 39.8630599975586, 0.69574164687744, -79.9372177124023, -1.39516764396495, 218, 45, 'PPL', 'P'),
(3822, 'Live Oak', 31.8083305358887, 0.55516009741391, -86.2474975585938, -1.50530280400323, 218, 2, 'PPL', 'P'),
(16919, 'Live Oak', 30.579439163208, 0.533711896811279, -85.8647232055664, -1.49862213125071, 218, 12, 'PPL', 'P'),
(22708, 'Live Oak', 31.8125, 0.555232868290696, -81.6244430541992, -1.42461528140239, 218, 13, 'PPL', 'P'),
(41826, 'Live Oak', 29.7547206878662, 0.519317844014537, -90.0286102294922, -1.57129566949929, 218, 22, 'PPL', 'P'),
(82130, 'Live Oak', 34.0555610656738, 0.594381669209997, -78.9388885498047, -1.37774351305894, 218, 48, 'PPL', 'P'),
(95751, 'Live Oak', 29.5650005340576, 0.516006602673187, -98.3361129760742, -1.71628894504561, 218, 51, 'PPL', 'P'),
(182845, 'Live Oak', 39.2758293151855, 0.685492538001298, -121.658889770508, -2.12334819081621, 218, 6, 'PPL', 'P'),
(182846, 'Live Oak Acres', 34.4069404602051, 0.600514396568232, -119.307502746582, -2.08230874526003, 218, 6, 'PPL', 'P'),
(95753, 'Live Oak Estates Colonia', 26.378999710083, 0.460400398323578, -98.8460006713867, -1.72518816414422, 218, 51, 'PPL', 'P'),
(16920, 'Live Oak Island', 30.0616703033447, 0.524675125442368, -84.2769393920898, -1.47091007589568, 218, 12, 'PPL', 'P'),
(3820, 'Live Oak Landing', 30.7124996185303, 0.536034239860856, -87.8791732788086, -1.53378091764583, 218, 2, 'PPL', 'P'),
(41827, 'Live Oak Manor', 29.9500007629395, 0.522726124288107, -90.2386093139648, -1.57496084494951, 218, 22, 'PPL', 'P'),
(95754, 'Live Oak Mobil Home Park Colonia', 26.32200050354, 0.459405574498379, -98.193000793457, -1.71379116625923, 218, 51, 'PPL', 'P'),
(95755, 'Live Oak Resorts', 32.0102806091309, 0.55868479111663, -97.3622207641602, -1.69929131938818, 218, 51, 'PPL', 'P'),
(182847, 'Live Oak Springs', 32.690559387207, 0.570557895625503, -116.333610534668, -2.03040453456272, 218, 6, 'PPL', 'P'),
(82131, 'Live Oaks', 33.5458297729492, 0.585485179851506, -79.0541687011719, -1.3797555312625, 218, 48, 'PPL', 'P'),
(55951, 'Lively', 38.2102813720703, 0.666895218056083, -93.107780456543, -1.6250373281907, 218, 29, 'PPL', 'P'),
(88632, 'Lively', 35.6674995422363, 0.622515302965594, -86.7947235107422, -1.51485369862058, 218, 50, 'PPL', 'P'),
(95757, 'Lively', 32.4097213745117, 0.565656347639212, -96.3230590820313, -1.68115452657447, 218, 51, 'PPL', 'P'),
(103743, 'Lively', 37.7775001525879, 0.659341760835319, -76.5138931274414, -1.33541935859291, 218, 53, 'PPL', 'P'),
(110143, 'Lively', 37.9402809143066, 0.662182821086216, -81.2574996948242, -1.41821091161297, 218, 58, 'PPL', 'P'),
(27732, 'Lively Grove', 38.3063888549805, 0.66857261006867, -89.6113891601563, -1.56401378813068, 218, 18, 'PPL', 'P'),
(211971, 'Livengood', 65.5244369506836, 1.14361716530486, -148.544723510742, -2.59259451172708, 218, 1, 'PPL', 'P'),
(3823, 'Liveoak Landing', 30.8369407653809, 0.538206147598356, -88.0175018310547, -1.53619520633204, 218, 2, 'PPL', 'P'),
(36928, 'Livermore', 37.4930610656738, 0.654377362247302, -87.1319427490234, -1.52073928462966, 218, 21, 'PPL', 'P'),
(116575, 'Livermore', 42.8686103820801, 0.748198396921922, -94.1849975585938, -1.64383831338028, 218, 16, 'PPL', 'P'),
(127986, 'Livermore', 44.3838882446289, 0.774644984705981, -70.2497177124023, -1.226088872678, 218, 26, 'PPL', 'P'),
(144068, 'Livermore', 44.0744400024414, 0.7692440940153, -71.3777770996094, -1.24577722314279, 218, 36, 'PPL', 'P'),
(163878, 'Livermore', 40.461669921875, 0.706189360991876, -79.3333282470703, -1.3846277844768, 218, 45, 'PPL', 'P'),
(182850, 'Livermore', 37.6819381713867, 0.65767388962363, -121.766937255859, -2.1252339751841, 218, 6, 'PPL', 'P'),
(194292, 'Livermore', 40.7944412231445, 0.711997315855175, -105.216667175293, -1.8363772701839, 218, 7, 'PPL', 'P'),
(127990, 'Livermore Center', 44.4088897705078, 0.77508134365059, -70.1802825927734, -1.22487700122396, 218, 26, 'PPL', 'P'),
(127987, 'Livermore Falls', 44.4752807617188, 0.776240085040884, -70.188606262207, -1.22502227666142, 218, 26, 'PPL', 'P'),
(3824, 'Liverpool', 32.3666687011719, 0.564904936737646, -85.7783279418945, -1.49711424944151, 218, 2, 'PPL', 'P'),
(41829, 'Liverpool', 30.9150009155273, 0.539568554233014, -90.6802825927734, -1.5826694978828, 218, 22, 'PPL', 'P'),
(95758, 'Liverpool', 29.2947196960449, 0.511289312144816, -95.2786102294922, -1.66292545522899, 218, 51, 'PPL', 'P'),
(110145, 'Liverpool', 38.894718170166, 0.678840893704661, -81.5308303833008, -1.42298143207363, 218, 58, 'PPL', 'P'),
(120395, 'Liverpool', 40.3916702270508, 0.704967635841802, -90.0008316040039, -1.57081084102284, 218, 18, 'PPL', 'P'),
(123085, 'Liverpool', 41.5525016784668, 0.725227966729716, -87.2947235107422, -1.52358034488055, 218, 19, 'PPL', 'P'),
(150329, 'Liverpool', 43.1063919067383, 0.752348467427619, -76.2180633544922, -1.33025615502952, 218, 40, 'PPL', 'P'),
(163879, 'Liverpool', 40.5747184753418, 0.708162430464488, -76.9894409179688, -1.3437192332882, 218, 45, 'PPL', 'P'),
(60657, 'Liverpool (historical)', 32.7130584716797, 0.570950578728235, -90.5013885498047, -1.57954720782079, 218, 30, 'PPL', 'P'),
(48986, 'Liverpool Wharf', 38.4575004577637, 0.671210005075203, -77.2649993896484, -1.34852863590077, 218, 25, 'PPL', 'P'),
(88633, 'Liverworth', 36.4002799987793, 0.635304734626536, -87.3263931274414, -1.5241330839648, 218, 50, 'PPL', 'P'),
(88634, 'Livesay', 35.9319381713867, 0.627130627713729, -85.0388870239258, -1.48420857079899, 218, 50, 'PPL', 'P'),
(88635, 'Livesay Mill', 36.5580596923828, 0.638058509772705, -83.0386123657227, -1.44929719206914, 218, 50, 'PPL', 'P'),
(36929, 'Livia', 37.5708312988281, 0.655734708875888, -87.1044387817383, -1.52025924984317, 218, 21, 'PPL', 'P'),
(82132, 'Living Inn', 34.1136093139648, 0.595394802267691, -81.4625015258789, -1.42178886853749, 218, 48, 'PPL', 'P'),
(186992, 'Living Springs', 39.8913917541504, 0.696236129312841, -104.300003051758, -1.82037846309331, 218, 7, 'PPL', 'P'),
(196925, 'Living Springs', 46.5922203063965, 0.81318765016118, -109.53556060791, -1.91175618062583, 218, 31, 'PPL', 'P'),
(3825, 'Livingston', 32.584171295166, 0.568701073134472, -88.1872177124023, -1.53915730725448, 218, 2, 'PPL', 'P'),
(22710, 'Livingston', 31.416109085083, 0.548314541700402, -83.9433288574219, -1.46508747364638, 218, 13, 'PPL', 'P'),
(27735, 'Livingston', 38.9674987792969, 0.680111154965602, -89.7638931274414, -1.56667548448216, 218, 18, 'PPL', 'P'),
(36930, 'Livingston', 37.297779083252, 0.650969048684219, -84.2149963378906, -1.46982896565116, 218, 21, 'PPL', 'P'),
(41830, 'Livingston', 30.5019397735596, 0.532359277293628, -90.7477798461914, -1.58384754719099, 218, 22, 'PPL', 'P'),
(55952, 'Livingston', 38.4077796936035, 0.670342214034, -93.8105621337891, -1.63730318238134, 218, 29, 'PPL', 'P'),
(60660, 'Livingston', 32.5527801513672, 0.568153194319216, -90.2161102294922, -1.57456816184678, 218, 30, 'PPL', 'P'),
(82133, 'Livingston', 33.5533294677734, 0.585616074219083, -81.1188888549805, -1.41579169607874, 218, 48, 'PPL', 'P'),
(88636, 'Livingston', 36.3833312988281, 0.635008924008456, -85.3230590820313, -1.4891683088551, 218, 50, 'PPL', 'P'),
(95759, 'Livingston', 30.7108306884766, 0.536005111536433, -94.9327774047852, -1.65688953377638, 218, 51, 'PPL', 'P'),
(110146, 'Livingston', 38.1575012207031, 0.665974030635025, -81.4069366455078, -1.42081907842654, 218, 58, 'PPL', 'P'),
(131808, 'Livingston', 41.9683303833008, 0.732485546753373, -86.5430603027344, -1.51046134703472, 218, 27, 'PPL', 'P'),
(145629, 'Livingston', 40.7958297729492, 0.712021550621095, -74.3152770996094, -1.29704626992013, 218, 37, 'PPL', 'P'),
(150328, 'Livingston', 42.1419410705566, 0.735515624862637, -73.7783279418945, -1.28767473920219, 218, 40, 'PPL', 'P'),
(175031, 'Livingston', 42.9000015258789, 0.748746275737178, -90.4308319091797, -1.57831576213274, 218, 57, 'PPL', 'P'),
(182848, 'Livingston', 37.3869400024414, 0.652525200288179, -120.722503662109, -2.10700517015472, 218, 6, 'PPL', 'P'),
(196926, 'Livingston', 45.6624984741211, 0.7969609430603, -110.560279846191, -1.92964090524237, 218, 31, 'PPL', 'P'),
(207938, 'Livingston', 45.689998626709, 0.797440911267759, -122.443893432617, -2.13704908936023, 218, 56, 'PPL', 'P'),
(48987, 'Livingston Grove', 38.6591682434082, 0.674729771929906, -77.0297164916992, -1.34442217465793, 218, 25, 'PPL', 'P'),
(150331, 'Livingston Manor', 41.9002799987793, 0.731297843486224, -74.82861328125, -1.30600567645937, 218, 40, 'PPL', 'P'),
(66432, 'Livingstons Quarters', 34.7936096191406, 0.607263046507574, -79.561393737793, -1.38860827820009, 218, 33, 'PPL', 'P'),
(150333, 'Livingstonville', 42.4874992370605, 0.741546752625285, -74.2688903808594, -1.29623666894874, 218, 40, 'PPL', 'P'),
(198539, 'Livona', 46.5022201538086, 0.811616851171224, -100.546669006348, -1.7548704260737, 218, 34, 'PPL', 'P'),
(30358, 'Livonia', 38.5569381713867, 0.67294552057858, -86.2774963378906, -1.50582638147354, 218, 19, 'PPL', 'P'),
(41832, 'Livonia', 30.5588893890381, 0.533353235591473, -91.5558319091797, -1.59795071621767, 218, 22, 'PPL', 'P'),
(131811, 'Livonia', 42.3683280944824, 0.739466823813933, -83.352783203125, -1.45478050759556, 218, 27, 'PPL', 'P'),
(139288, 'Livonia', 40.4913902282715, 0.706708078193196, -92.6999969482422, -1.61792016333552, 218, 29, 'PPL', 'P'),
(150334, 'Livonia', 42.8213882446289, 0.74737421514357, -77.6688919067383, -1.35557789014816, 218, 40, 'PPL', 'P'),
(163882, 'Livonia', 40.9805603027344, 0.715245706594799, -77.2919387817383, -1.34899881699123, 218, 45, 'PPL', 'P'),
(150335, 'Livonia Center', 42.8213882446289, 0.74737421514357, -77.6388931274414, -1.35505431267785, 218, 40, 'PPL', 'P'),
(182849, 'Liwaito (historical)', 38.5222206115723, 0.67233958485156, -121.969718933105, -2.12877318311476, 218, 6, 'PPL', 'P'),
(55959, 'Lixville', 37.5769386291504, 0.655841301898519, -89.9116668701172, -1.56925462283985, 218, 29, 'PPL', 'P'),
(60659, 'Lizana', 30.5375003814697, 0.532979926985671, -89.2522201538086, -1.5577451063988, 218, 30, 'PPL', 'P'),
(178547, 'Lizard', 33.6352806091309, 0.587046391461537, -112.344436645508, -1.96078031576229, 218, 5, 'PPL', 'P'),
(188883, 'Lizard', 31.8216705322266, 0.55539292427221, -106.628326416016, -1.86101537185072, 218, 38, 'PPL', 'P'),
(116576, 'Lizard (historical)', 42.6347198486328, 0.744116237024021, -94.5108337402344, -1.64952522757204, 218, 16, 'PPL', 'P'),
(178548, 'Lizard Acres', 33.6474990844727, 0.587259644085826, -112.337783813477, -1.96066420193876, 218, 5, 'PPL', 'P'),
(163883, 'Lizard Creek Junction', 40.792781829834, 0.71196835397832, -75.6605606079102, -1.32052589651275, 218, 45, 'PPL', 'P'),
(66434, 'Lizard Lick', 35.8163909912109, 0.625113948978266, -78.3752822875977, -1.36790672809857, 218, 33, 'PPL', 'P'),
(60661, 'Lizelia', 32.5355606079102, 0.5678526565902, -88.6600036621094, -1.54740897873404, 218, 30, 'PPL', 'P'),
(22711, 'Lizella', 32.8069381713867, 0.572589088588906, -83.8199996948242, -1.46293497369532, 218, 13, 'PPL', 'P'),
(110147, 'Lizemores', 38.3338890075684, 0.669052578276129, -81.1752777099609, -1.41677586725958, 218, 58, 'PPL', 'P'),
(30359, 'Lizton', 39.8866691589355, 0.696153704477103, -86.543327331543, -1.51046600756662, 218, 19, 'PPL', 'P'),
(66433, 'Lizzie', 35.5063896179199, 0.619703404328634, -77.6172180175781, -1.354676010645, 218, 33, 'PPL', 'P'),
(22712, 'Lizzie (historical)', 33.774169921875, 0.589470467264755, -84.5513916015625, -1.47570017059035, 218, 13, 'PPL', 'P'),
(3827, 'Lizzieville', 32.7874984741211, 0.57224980186603, -88.0288925170898, -1.53639401130742, 218, 2, 'PPL', 'P'),
(204582, 'LKC Development', 40.5472183227539, 0.707682462257028, -111.903060913086, -1.95307685599312, 218, 52, 'PPL', 'P'),
(204583, 'LKC Jordan View Estates', 40.5458297729492, 0.707658227491109, -111.910827636719, -1.95321241089261, 218, 52, 'PPL', 'P'),
(182851, 'Llanada', 36.6091690063477, 0.638950535579828, -120.915557861328, -2.11037460156589, 218, 6, 'PPL', 'P'),
(48989, 'Llandaff', 38.7255592346191, 0.675888513320199, -76.0819396972656, -1.32788034902106, 218, 25, 'PPL', 'P'),
(78633, 'Llanerch', 39.9713897705078, 0.697632358093342, -75.2994384765625, -1.31422312631892, 218, 45, 'PPL', 'P'),
(163884, 'Llanfair', 40.2855606079102, 0.703115673619761, -78.7233276367188, -1.37398126538699, 218, 45, 'PPL', 'P'),
(14135, 'Llangollen Estates', 39.6472206115723, 0.691974538936496, -75.6188888549805, -1.31979858721905, 218, 10, 'PPL', 'P'),
(95760, 'Llano', 30.7591705322266, 0.53684880096977, -98.6747207641602, -1.72219876582061, 218, 51, 'PPL', 'P'),
(182856, 'Llano', 34.5058288574219, 0.602240324691685, -117.816940307617, -2.05629352299354, 218, 6, 'PPL', 'P'),
(188884, 'Llano', 36.1399993896484, 0.630761981018106, -105.681106567383, -1.84448326675183, 218, 38, 'PPL', 'P'),
(188885, 'Llano Del Medio', 35.1897201538086, 0.614176479539365, -105.109169006348, -1.83450107319594, 218, 38, 'PPL', 'P'),
(95762, 'Llano Grande', 26.1294403076172, 0.45604476507124, -97.9677810668945, -1.70986034049027, 218, 51, 'PPL', 'P'),
(95763, 'Llano Grande Homesites', 26.125560760498, 0.455977054200525, -97.9680633544922, -1.70986526733829, 218, 51, 'PPL', 'P'),
(188886, 'Llano Largo', 36.1405601501465, 0.630771768135112, -105.65860748291, -1.8440905836491, 218, 38, 'PPL', 'P'),
(188887, 'Llano Quemado', 36.3488883972168, 0.634407781971398, -105.61222076416, -1.84328098267772, 218, 38, 'PPL', 'P'),
(188889, 'Llano Viejo', 35.1877784729004, 0.614142590814494, -105.125831604004, -1.83479189038698, 218, 38, 'PPL', 'P'),
(78634, 'Llanwellyn', 39.9083290100098, 0.696531740193839, -75.2949981689453, -1.3141456283312, 218, 45, 'PPL', 'P'),
(188890, 'Llaves', 36.3727798461914, 0.634824766419077, -106.866111755371, -1.86516550893544, 218, 38, 'PPL', 'P'),
(163885, 'Llewellyn', 40.672779083252, 0.709873910939027, -76.2794418334961, -1.33132741157801, 218, 45, 'PPL', 'P'),
(163886, 'Llewellyn Corners', 41.2324981689453, 0.719642851870629, -75.7958297729492, -1.32288678881911, 218, 45, 'PPL', 'P'),
(145631, 'Llewellyn Park', 40.7874984741211, 0.711876142025576, -74.2416687011719, -1.29576156101027, 218, 37, 'PPL', 'P'),
(48990, 'Llewelyn at Sunderland', 38.6538887023926, 0.674637626556189, -76.6097183227539, -1.33709182375748, 218, 25, 'PPL', 'P'),
(10141, 'Lloyd', 33.2994384765625, 0.5811848404813, -91.5138931274414, -1.59721874639206, 218, 4, 'PPL', 'P'),
(16921, 'Lloyd', 30.4772205352783, 0.531927845197035, -84.0219421386719, -1.46645953423999, 218, 12, 'PPL', 'P'),
(36933, 'Lloyd', 38.6199989318848, 0.674046138478082, -82.8647232055664, -1.44626225369088, 218, 21, 'PPL', 'P'),
(150344, 'Lloyd', 41.7361106872559, 0.728432548469408, -74.0058288574219, -1.29164537922944, 218, 40, 'PPL', 'P'),
(156190, 'Lloyd', 41.0724983215332, 0.716850327730599, -81.0224990844727, -1.41410937721814, 218, 41, 'PPL', 'P'),
(196927, 'Lloyd', 48.2902793884277, 0.842824372036018, -109.361389160156, -1.90871631539956, 218, 31, 'PPL', 'P'),
(156191, 'Lloyd Corners', 40.0138893127441, 0.698374115035956, -82.4033279418945, -1.4382093871867, 218, 41, 'PPL', 'P'),
(66441, 'Lloyd Crossroads', 36.2794418334961, 0.633195710780275, -76.7255630493164, -1.33911369565707, 218, 33, 'PPL', 'P'),
(150337, 'Lloyd Harbor', 40.9033317565918, 0.713897814188083, -73.4602813720703, -1.28212377938408, 218, 40, 'PPL', 'P'),
(48991, 'Lloyd Landing', 38.6983299255371, 0.675413272223675, -75.9991683959961, -1.32643571728775, 218, 25, 'PPL', 'P'),
(103745, 'Lloyd Place', 36.7269401550293, 0.641006029888178, -76.5694427490234, -1.33638888238776, 218, 53, 'PPL', 'P'),
(163887, 'Lloydell', 40.3144416809082, 0.703619743435085, -78.692497253418, -1.37344317368874, 218, 45, 'PPL', 'P'),
(3828, 'Lloyds', 30.6175003051758, 0.534376189055686, -88.128059387207, -1.53812479969986, 218, 2, 'PPL', 'P'),
(48992, 'Lloyds', 38.5897216796875, 0.673517700738783, -76.1833267211914, -1.32964988640737, 218, 25, 'PPL', 'P'),
(103746, 'Lloyds', 38.0008316040039, 0.663239629985786, -77.0152816772461, -1.34417023961881, 218, 53, 'PPL', 'P'),
(16922, 'Lloyds Estates', 26.1772193908691, 0.456878667387571, -80.1483306884766, -1.39885226049113, 218, 12, 'PPL', 'P'),
(116579, 'Lloyds Mobile Home Park', 41.8013916015625, 0.729571915362771, -90.2486114501953, -1.57513541515896, 218, 16, 'PPL', 'P'),
(110148, 'Lloydsville', 38.7394409179688, 0.676130794400369, -80.70361328125, -1.40854377001404, 218, 58, 'PPL', 'P'),
(150339, 'Lloydsville', 42.8263893127441, 0.747461500248297, -75.2347183227539, -1.31309354654256, 218, 40, 'PPL', 'P'),
(156192, 'Lloydsville', 40.0711097717285, 0.699372800444736, -80.9986114501953, -1.41369245934949, 218, 41, 'PPL', 'P'),
(163888, 'Lloydsville', 40.3105583190918, 0.703551965985343, -79.4011077880859, -1.38581076063301, 218, 45, 'PPL', 'P'),
(82144, 'Lloydswoods', 33.9000015258789, 0.591666643057689, -81.0572204589844, -1.41471537952419, 218, 48, 'PPL', 'P'),
(163889, 'Lloydville', 40.6699981689453, 0.709825374828161, -78.4066696166992, -1.3684545403348, 218, 45, 'PPL', 'P'),
(163890, 'Llyswen', 40.478328704834, 0.706480111603885, -78.4033279418945, -1.36839621710693, 218, 45, 'PPL', 'P'),
(103755, 'Lo Roy Acres', 37.3152809143066, 0.651274513261251, -79.23388671875, -1.38289220239439, 218, 53, 'PPL', 'P'),
(192674, 'Loa', 38.4027786254883, 0.670254928929273, -111.642219543457, -1.94852431526769, 218, 52, 'PPL', 'P'),
(3829, 'Loachapoka', 32.6041717529297, 0.569050146974354, -85.5933303833008, -1.4938854329359, 218, 2, 'PPL', 'P'),
(36934, 'Load', 38.5461082458496, 0.672756502720212, -82.970832824707, -1.44811421591292, 218, 21, 'PPL', 'P'),
(10142, 'Loafer', 35.7833290100098, 0.624536908549073, -93.4830627441406, -1.6315872397337, 218, 4, 'PPL', 'P'),
(88637, 'Loafers Corner', 35.9847183227539, 0.628051815134787, -86.5466690063477, -1.5105243307945, 218, 50, 'PPL', 'P'),
(66435, 'Loafers Glory', 36.0130615234375, 0.628546497307269, -82.1875, -1.43444247898284, 218, 33, 'PPL', 'P'),
(30360, 'Loafers Station', 38.125560760498, 0.665416564439844, -87.1180572509766, -1.52049693697046, 218, 19, 'PPL', 'P'),
(163891, 'Loag', 40.1288909912109, 0.700381272970522, -75.8133316040039, -1.32319225339614, 218, 45, 'PPL', 'P'),
(60662, 'Loakfoma', 33.2480583190918, 0.580288087563243, -88.8872222900391, -1.55137469191328, 218, 30, 'PPL', 'P'),
(36935, 'Loam', 37.4075012207031, 0.652884061245068, -84.1297225952148, -1.46834065807597, 218, 21, 'PPL', 'P'),
(27736, 'Loami', 39.6755599975586, 0.692469154529951, -89.8466720581055, -1.56812024937353, 218, 18, 'PPL', 'P'),
(3830, 'Loango', 31.329439163208, 0.546801866201237, -86.6488876342773, -1.51230838240874, 218, 2, 'PPL', 'P'),
(145634, 'Loantaka Estates', 40.7722206115723, 0.711609493021432, -74.440559387207, -1.29923285833314, 218, 37, 'PPL', 'P'),
(48993, 'Loarville', 39.6208305358887, 0.691513945225967, -78.8947219848633, -1.37697266108142, 218, 25, 'PPL', 'P'),
(163892, 'Lobachsville', 40.4094390869141, 0.705277760950741, -75.7352828979492, -1.32183004649857, 218, 45, 'PPL', 'P'),
(110149, 'Lobata', 37.648609161377, 0.657092188662529, -82.1891708374023, -1.43447164059678, 218, 58, 'PPL', 'P'),
(188893, 'Lobato', 36.9541702270508, 0.644971942804497, -106.540832519531, -1.85948831528167, 218, 38, 'PPL', 'P'),
(186993, 'Lobatos', 37.0794410705566, 0.647158331480424, -105.948333740234, -1.84914726076889, 218, 7, 'PPL', 'P'),
(156193, 'Lobaugh', 41.4919395446777, 0.724170958093063, -80.684440612793, -1.40820914382307, 218, 41, 'PPL', 'P'),
(36936, 'Lobb', 37.3458290100098, 0.651807678111485, -85.6449966430664, -1.494787179281, 218, 21, 'PPL', 'P'),
(41833, 'Lobdell', 30.4947204589844, 0.532233276484554, -91.2533264160156, -1.59267099935659, 218, 22, 'PPL', 'P'),
(60663, 'Lobdell', 33.7183303833008, 0.58849588346384, -90.9822235107422, -1.58793936104785, 218, 30, 'PPL', 'P'),
(41834, 'Lobdell Station', 30.4936103820801, 0.532213901987623, -91.2611083984375, -1.59280682057218, 218, 22, 'PPL', 'P'),
(82135, 'Lobeco', 32.5525016784668, 0.568148334050226, -80.7436065673828, -1.40924178453575, 218, 48, 'PPL', 'P'),
(66436, 'Lobelia', 35.2130584716797, 0.614583810028093, -79.2038879394531, -1.38236862492408, 218, 33, 'PPL', 'P'),
(110150, 'Lobelia', 38.1336097717285, 0.665557046187346, -80.2947235107422, -1.40140729724095, 218, 58, 'PPL', 'P'),
(88638, 'Lobelville', 35.7719383239746, 0.624338103573699, -87.7838897705078, -1.53211790670313, 218, 50, 'PPL', 'P'),
(182858, 'Lobitos', 37.3830604553223, 0.652457489417464, -122.399169921875, -2.13626851684473, 218, 6, 'PPL', 'P'),
(82136, 'Loblolly Pines', 34.5111083984375, 0.602332470065401, -82.7041702270508, -1.4434600755919, 218, 48, 'PPL', 'P'),
(191772, 'Lobo', 30.8138904571533, 0.537803843826186, -104.752502441406, -1.82827606730594, 218, 51, 'PPL', 'P'),
(188892, 'Lobo (historical)', 36.5858306884766, 0.6385432050911, -105.598892211914, -1.8430483555565, 218, 38, 'PPL', 'P'),
(204728, 'Lobo Subdivision', 40.5972213745117, 0.708555180146247, -111.865829467773, -1.95242704468714, 218, 52, 'PPL', 'P'),
(125259, 'Lobsterville', 41.3499984741211, 0.721693619068044, -70.7980575561523, -1.23565920837131, 218, 23, 'PPL', 'P'),
(60664, 'Lobutcha (historical)', 33.1055603027344, 0.577801028000246, -89.254997253418, -1.55779357593064, 218, 30, 'PPL', 'P'),
(55954, 'Local', 38.3736114501953, 0.669745865686904, -90.6227798461914, -1.581665885626, 218, 29, 'PPL', 'P'),
(182859, 'Locans', 36.7236099243164, 0.640947906397387, -119.662216186523, -2.08849966268809, 218, 6, 'PPL', 'P'),
(110151, 'Location', 39.2138900756836, 0.684411494335807, -79.6372222900391, -1.3899317361038, 218, 58, 'PPL', 'P'),
(22713, 'Loce', 33.7224998474121, 0.588568654340627, -82.4775009155273, -1.43950394979259, 218, 13, 'PPL', 'P'),
(22714, 'Loch Arbor', 34.1966705322266, 0.596844494007075, -83.9483337402344, -1.46517482533014, 218, 13, 'PPL', 'P'),
(145632, 'Loch Arbour', 40.232780456543, 0.702194486198702, -74.0013885498047, -1.29156788124172, 218, 37, 'PPL', 'P'),
(116580, 'Loch Burns', 41.0255584716797, 0.716031072800263, -92.3499984741211, -1.61181153758515, 218, 16, 'PPL', 'P'),
(48994, 'Loch Haven', 39.3169403076172, 0.686210060177992, -77.274169921875, -1.34868869188229, 218, 25, 'PPL', 'P'),
(103747, 'Loch Haven', 37.3463897705078, 0.651817465228491, -80.0044403076172, -1.39634089958319, 218, 53, 'PPL', 'P'),
(48995, 'Loch Haven Beach', 38.9241714477539, 0.679354950374074, -76.523063659668, -1.33557941457443, 218, 25, 'PPL', 'P'),
(48996, 'Loch Hill', 39.3766708374023, 0.687252554586704, -76.5822219848633, -1.33661192212905, 218, 25, 'PPL', 'P'),
(103748, 'Loch Leigh', 38.0613899230957, 0.664296572043411, -78.5844421386719, -1.3715572561628, 218, 53, 'PPL', 'P'),
(48997, 'Loch Leven', 39.5658302307129, 0.690554008811048, -76.1708297729492, -1.32943177351409, 218, 25, 'PPL', 'P'),
(60665, 'Loch Leven', 31.208610534668, 0.544693008802544, -91.5749969482422, -1.59828520925059, 218, 30, 'PPL', 'P'),
(103749, 'Loch Linden', 38.9391708374023, 0.679616739109228, -78.0811080932617, -1.36277241983301, 218, 53, 'PPL', 'P'),
(16923, 'Loch Lommond', 29.8013896942139, 0.520132371833938, -82.0136108398438, -1.43140754060459, 218, 12, 'PPL', 'P'),
(41835, 'Loch Lomond', 32.6763916015625, 0.570310621118289, -92.1419372558594, -1.60818018428077, 218, 22, 'PPL', 'P'),
(60666, 'Loch Lomond', 32.8691711425781, 0.573675258839495, -90.6961135864258, -1.58294580084589, 218, 30, 'PPL', 'P'),
(103750, 'Loch Lomond', 38.7861099243164, 0.67694532221977, -77.4783325195313, -1.35225200142081, 218, 53, 'PPL', 'P'),
(182860, 'Loch Lomond', 38.8633308410645, 0.678293081468432, -122.718330383301, -2.14183891773879, 218, 6, 'PPL', 'P'),
(163893, 'Loch Lomond Junction', 40.9161109924316, 0.714120853929377, -78.1975021362305, -1.36480387911252, 218, 45, 'PPL', 'P'),
(48998, 'Loch Lynn Heights', 39.3930587768555, 0.687538578087778, -79.3733291625977, -1.38532593215656, 218, 25, 'PPL', 'P'),
(150340, 'Loch Muller', 43.8661117553711, 0.765608080179015, -73.8899993896484, -1.28962377364597, 218, 40, 'PPL', 'P'),
(48999, 'Loch Raven', 39.4188919067383, 0.687989451260329, -76.5355606079102, -1.33579752746771, 218, 25, 'PPL', 'P'),
(49000, 'Loch Raven Heights', 39.3883285522461, 0.687456020093986, -76.5625, -1.33626770855816, 218, 25, 'PPL', 'P'),
(49001, 'Loch Raven Village', 39.3880615234375, 0.687451359562078, -76.5699996948242, -1.33639860292574, 218, 25, 'PPL', 'P'),
(150341, 'Loch Sheldrake', 41.7700004577637, 0.729024036547515, -74.6575012207031, -1.30301920761296, 218, 40, 'PPL', 'P'),
(120399, 'Lochanora', 42.2350006103516, 0.737139820232449, -88.0849990844727, -1.53737325564024, 218, 18, 'PPL', 'P'),
(194293, 'Lochbuie', 40.0072212219238, 0.69825773489632, -104.715560913086, -1.82763131600603, 218, 7, 'PPL', 'P'),
(49002, 'Lochearn', 39.3405609130859, 0.686622317514736, -76.7225036621094, -1.33906029927722, 218, 25, 'PPL', 'P'),
(110152, 'Lochgelly', 38.0105590820313, 0.663409406505279, -81.1452789306641, -1.41625228978927, 218, 58, 'PPL', 'P'),
(103751, 'Lochhaven', 36.9144401550293, 0.644278522235667, -76.3111114501953, -1.33188015066225, 218, 53, 'PPL', 'P'),
(123090, 'Lochiel', 40.6641693115234, 0.70972364207452, -87.2738876342773, -1.5232166902337, 218, 19, 'PPL', 'P'),
(163894, 'Lochiel', 40.9483299255371, 0.714683180393547, -76.954719543457, -1.34311323098215, 218, 45, 'PPL', 'P'),
(178549, 'Lochiel', 31.3355598449707, 0.546908692250463, -110.623329162598, -1.93074132340479, 218, 5, 'PPL', 'P'),
(16924, 'Lochiocha (historical)', 30.3666706085205, 0.529998384987273, -84.6666717529297, -1.4777121887939, 218, 12, 'PPL', 'P'),
(163895, 'Lochland', 40.6974983215332, 0.71030534303562, -75.7352828979492, -1.32183004649857, 218, 45, 'PPL', 'P'),
(103752, 'Lochleven', 36.8702812194824, 0.643507803416198, -78.04638671875, -1.36216641752696, 218, 53, 'PPL', 'P'),
(16925, 'Lochloosa', 29.5113906860352, 0.515070934313702, -82.1005630493164, -1.43292514295177, 218, 12, 'PPL', 'P'),
(144070, 'Lochmere', 43.4711112976074, 0.758714021644154, -71.5305633544922, -1.24844384634229, 218, 36, 'PPL', 'P'),
(16926, 'Lochmoor Waterway Estates', 26.6438903808594, 0.465023612686442, -81.9100036621094, -1.42959925422442, 218, 12, 'PPL', 'P'),
(95764, 'Lochridge', 29.3527793884277, 0.512302644939592, -95.5308303833008, -1.66732752735284, 218, 51, 'PPL', 'P'),
(103753, 'Lochridge', 38.100830078125, 0.66498493260617, -78.478889465332, -1.36971501447874, 218, 53, 'PPL', 'P'),
(207939, 'Lochsloy', 48.0516700744629, 0.838659853881406, -122.030830383301, -2.12983977913133, 218, 56, 'PPL', 'P'),
(163896, 'Lochvale', 40.8650016784668, 0.713228828122255, -78.8491668701172, -1.37617757433798, 218, 45, 'PPL', 'P'),
(22715, 'Lochwolde', 33.8074989318848, 0.590052168225855, -84.0224990844727, -1.46646925477797, 218, 13, 'PPL', 'P'),
(14136, 'Lochwood', 38.6788902282715, 0.675073985500799, -75.1963882446289, -1.31242456047673, 218, 10, 'PPL', 'P'),
(156194, 'Lock', 40.2713890075684, 0.70286833253352, -82.6108322143555, -1.4418310199531, 218, 41, 'PPL', 'P'),
(66440, 'Lock (historical)', 35.6108283996582, 0.621526204936739, -80.5186080932617, -1.40531482035037, 218, 33, 'PPL', 'P'),
(16927, 'Lock Arbor', 28.7863903045654, 0.50241729057884, -81.3163909912109, -1.41923875863569, 218, 12, 'PPL', 'P'),
(150342, 'Lock Berlin', 43.0788917541504, 0.75186849922016, -76.9463882446289, -1.34296782238663, 218, 40, 'PPL', 'P'),
(3833, 'Lock Five', 32.5830612182617, 0.568681698637542, -87.7366714477539, -1.53129379150381, 218, 2, 'PPL', 'P'),
(163897, 'Lock Haven', 41.1369400024414, 0.717975047237967, -77.4472198486328, -1.35170898287455, 218, 45, 'PPL', 'P'),
(156195, 'Lock Port', 41.5497207641602, 0.725179430618849, -84.3899993896484, -1.47288334510537, 218, 41, 'PPL', 'P'),
(156196, 'Lock Seventeen', 40.3561096191406, 0.704346986149759, -81.4558334350586, -1.42167248839786, 218, 41, 'PPL', 'P'),
(3834, 'Lock Six', 34.848331451416, 0.608218122653504, -87.5363922119141, -1.52779825941502, 218, 2, 'PPL', 'P'),
(55955, 'Lock Springs', 39.8488883972168, 0.695494305791199, -93.7772216796875, -1.63672128168315, 218, 29, 'PPL', 'P'),
(3835, 'Lock Three', 34.8116683959961, 0.607578231622585, -87.4105606079102, -1.52560208362209, 218, 2, 'PPL', 'P'),
(156197, 'Lock Two', 40.4516716003418, 0.706014857361448, -84.3691711425781, -1.47251982361657, 218, 41, 'PPL', 'P'),
(73255, 'Lockbourne', 39.8091697692871, 0.694801084959451, -82.9725036621094, -1.44814337752686, 218, 41, 'PPL', 'P'),
(110153, 'Lockbridge', 37.8274993896484, 0.660214412145511, -80.8452835083008, -1.41101638192812, 218, 58, 'PPL', 'P'),
(156198, 'Lockbridge (historical)', 40.7761116027832, 0.711677403629229, -80.8125, -1.41044420176792, 218, 41, 'PPL', 'P'),
(73256, 'Lockdale', 38.4147186279297, 0.670463321284572, -82.5094375610352, -1.44006134940874, 218, 41, 'PPL', 'P'),
(10143, 'Locke', 35.6738891601563, 0.622626822836241, -94.0733337402344, -1.64188941209456, 218, 4, 'PPL', 'P'),
(88639, 'Locke', 35.332218170166, 0.616663539102363, -90.0266723632813, -1.57126184735344, 218, 50, 'PPL', 'P'),
(110154, 'Locke', 39.454719543457, 0.688614761484279, -80.9222183227539, -1.41235914774974, 218, 58, 'PPL', 'P'),
(123086, 'Locke', 41.4716682434082, 0.723817157142246, -86.0122222900391, -1.50119647591844, 218, 19, 'PPL', 'P'),
(150343, 'Locke', 42.6605606079102, 0.744567243354626, -76.4311065673828, -1.33397446054349, 218, 40, 'PPL', 'P'),
(182861, 'Locke', 38.250560760498, 0.667598226004837, -121.508331298828, -2.12072044976863, 218, 6, 'PPL', 'P'),
(207940, 'Locke', 48.4266700744629, 0.845204838576385, -117.316673278809, -2.04756221620166, 218, 56, 'PPL', 'P'),
(3838, 'Locke Crossroads', 34.9355583190918, 0.609740518690648, -86.9516677856445, -1.51759289295978, 218, 2, 'PPL', 'P'),
(49003, 'Locke Hill Estates', 38.4494400024414, 0.671069323590619, -76.7513885498047, -1.33956443567157, 218, 25, 'PPL', 'P'),
(127991, 'Locke Mills', 44.4000015258789, 0.774926214517093, -70.7024993896484, -1.23399140373865, 218, 26, 'PPL', 'P'),
(163899, 'Locke Mills', 40.7105598449707, 0.710533309624931, -77.5236129760742, -1.3530422944743, 218, 45, 'PPL', 'P'),
(60667, 'Locke Station', 34.2786102294922, 0.598274611512448, -90.1555633544922, -1.57351141952623, 218, 30, 'PPL', 'P'),
(182862, 'Lockeford', 38.1636085510254, 0.666080623657655, -121.148887634277, -2.11444697434678, 218, 6, 'PPL', 'P'),
(144071, 'Lockehaven', 43.6105613708496, 0.761147884564378, -72.0883331298828, -1.25817876539096, 218, 36, 'PPL', 'P'),
(191773, 'Locker', 31.3794403076172, 0.547674550800942, -103.52555847168, -1.80686185529672, 218, 51, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(88640, 'Lockertsville', 36.3458290100098, 0.634354385591541, -87.1208267211914, -1.52054527334425, 218, 50, 'PPL', 'P'),
(190419, 'Lockes', 38.5550003051758, 0.672911698432736, -115.774169921875, -2.0206404539001, 218, 39, 'PPL', 'P'),
(144074, 'Lockes Corner', 43.3613891601563, 0.756799009083305, -71.182502746582, -1.24236904273776, 218, 36, 'PPL', 'P'),
(103754, 'Lockes Landing', 39.1022186279297, 0.682462459892033, -77.9647216796875, -1.36074109371155, 218, 53, 'PPL', 'P'),
(88641, 'Lockes Mill', 35.2163887023926, 0.614641933518884, -86.4444427490234, -1.5087401460222, 218, 50, 'PPL', 'P'),
(10144, 'Lockesburg', 33.9672203063965, 0.592839832096896, -94.168327331543, -1.64354736303119, 218, 4, 'PPL', 'P'),
(95766, 'Lockett', 34.0811080932617, 0.594827548955504, -99.3775024414063, -1.73446462001124, 218, 51, 'PPL', 'P'),
(22716, 'Lockett Crossing', 31.5575008392334, 0.550782293345497, -84.2541732788086, -1.47051273226104, 218, 13, 'PPL', 'P'),
(191774, 'Lockettville', 33.3916702270508, 0.582794588202199, -102.317222595215, -1.78577241578244, 218, 51, 'PPL', 'P'),
(3836, 'Lockhart', 31.0102806091309, 0.541231498596686, -86.3497161865234, -1.50708685561748, 218, 2, 'PPL', 'P'),
(16928, 'Lockhart', 28.6191692352295, 0.499498732340222, -81.4427795410156, -1.4214446549666, 218, 12, 'PPL', 'P'),
(41837, 'Lockhart', 33.0080604553223, 0.576099334642712, -92.5830612182617, -1.61587924983414, 218, 22, 'PPL', 'P'),
(82137, 'Lockhart', 34.7863883972168, 0.607137012408986, -81.4622192382813, -1.42178394168947, 218, 48, 'PPL', 'P'),
(95767, 'Lockhart', 29.8847198486328, 0.521586757394744, -97.6697235107422, -1.70465825477497, 218, 51, 'PPL', 'P'),
(110155, 'Lockhart', 38.9650001525879, 0.680067545702752, -81.6152801513672, -1.42445535857893, 218, 58, 'PPL', 'P'),
(112425, 'Lockhart', 32.4894409179688, 0.567047716150724, -88.5858306884766, -1.54611441612815, 218, 30, 'PPL', 'P'),
(136559, 'Lockhart', 47.439998626709, 0.82798417317766, -96.5508270263672, -1.68512982713363, 218, 28, 'PPL', 'P'),
(156199, 'Lockhart', 40.6027793884277, 0.708652185788954, -82.4716720581055, -1.43940221703895, 218, 41, 'PPL', 'P'),
(182863, 'Lockhart', 35.014720916748, 0.611122166664181, -117.330001831055, -2.04779484332288, 218, 6, 'PPL', 'P'),
(3837, 'Lockhart (historical)', 33.7088890075684, 0.588331100371392, -87.4805603027344, -1.52682380877216, 218, 2, 'PPL', 'P'),
(103756, 'Lockhart Flats', 37.149169921875, 0.648375329519563, -82.4305572509766, -1.43868462828323, 218, 53, 'PPL', 'P'),
(82138, 'Lockhart Junction', 34.8188896179199, 0.607704265721173, -81.6522216796875, -1.42510010987884, 218, 48, 'PPL', 'P'),
(82139, 'Lockhart Oil Field', 34.4233283996582, 0.600800420069306, -80.5347213745117, -1.40559605016148, 218, 48, 'PPL', 'P'),
(193742, 'Lockharts (historical)', 41.2119407653809, 0.719284057492768, -123.518890380859, -2.15581132555595, 218, 6, 'PPL', 'P'),
(16929, 'Lockharts Subdivision', 28.7944393157959, 0.502557772326342, -81.295280456543, -1.41887031029887, 218, 12, 'PPL', 'P'),
(27738, 'Lockhaven', 38.940559387207, 0.679640973875148, -90.2880630493164, -1.5758239754588, 218, 18, 'PPL', 'P'),
(10147, 'Lockheart', 35.836669921875, 0.625467883087138, -91.2463912963867, -1.59254995868505, 218, 4, 'PPL', 'P'),
(10145, 'Lockheart (historical)', 35.8763885498047, 0.626161103918885, -91.2958297729492, -1.59341282287823, 218, 4, 'PPL', 'P'),
(156200, 'Lockington', 40.2080612182617, 0.701763054102109, -84.23388671875, -1.47015866499411, 218, 41, 'PPL', 'P'),
(82140, 'Locklair (historical)', 33.1472206115723, 0.578528137556865, -80.039436340332, -1.39695169557919, 218, 48, 'PPL', 'P'),
(73257, 'Lockland', 39.2291717529297, 0.684678209918979, -84.4577789306641, -1.47406632126158, 218, 41, 'PPL', 'P'),
(103757, 'Locklies', 37.5944404602051, 0.656146766475551, -76.4400024414063, -1.33412972283504, 218, 53, 'PPL', 'P'),
(116587, 'Lockman', 41.0833282470703, 0.717039345588967, -92.7391662597656, -1.61860379678735, 218, 16, 'PPL', 'P'),
(88642, 'Lockmiller Addition', 35.4302787780762, 0.618375019576903, -84.600830078125, -1.47656303478353, 218, 50, 'PPL', 'P'),
(41838, 'Lockmoor', 30.2366695404053, 0.527729438317553, -93.2916717529297, -1.62824683677841, 218, 22, 'PPL', 'P'),
(110157, 'Lockney', 38.8561096191406, 0.678167047369844, -80.9672164916992, -1.4131445139552, 218, 58, 'PPL', 'P'),
(191775, 'Lockney', 34.124439239502, 0.595583820126059, -101.441108703613, -1.77048134375153, 218, 51, 'PPL', 'P'),
(150346, 'Lockpit', 43.035831451416, 0.75111695516054, -76.8097229003906, -1.34058256215631, 218, 40, 'PPL', 'P'),
(36937, 'Lockport', 38.4358291625977, 0.670831769621384, -84.9672164916992, -1.48295768403498, 218, 21, 'PPL', 'P'),
(41839, 'Lockport', 29.6458301544189, 0.51741734568163, -90.5391693115234, -1.58020660650669, 218, 22, 'PPL', 'P'),
(120400, 'Lockport', 41.5894393920898, 0.725872651450597, -88.0577774047852, -1.53689814770177, 218, 18, 'PPL', 'P'),
(123088, 'Lockport', 40.6991691589355, 0.710334504649557, -86.5736083984375, -1.51099451188495, 218, 19, 'PPL', 'P'),
(131814, 'Lockport', 43.5247192382813, 0.759649656714126, -84.2494430541992, -1.47043017426724, 218, 27, 'PPL', 'P'),
(150347, 'Lockport', 43.1705589294434, 0.753468393245025, -78.690559387207, -1.37340935154289, 218, 40, 'PPL', 'P'),
(163903, 'Lockport', 40.3916702270508, 0.704967635841802, -79.1222229003906, -1.38094330110867, 218, 45, 'PPL', 'P'),
(41840, 'Lockport Heights', 29.6502799987793, 0.517495010116919, -90.54638671875, -1.58033257402625, 218, 22, 'PPL', 'P'),
(150348, 'Lockport Junction', 43.1575012207031, 0.753240493234742, -78.754997253418, -1.37453400447123, 218, 40, 'PPL', 'P'),
(116581, 'Lockridge', 40.9947204589844, 0.715492847943958, -91.7480621337891, -1.60130576655895, 218, 16, 'PPL', 'P'),
(163904, 'Lockridge', 40.6333312988281, 0.709185417218215, -75.5950012207031, -1.3193816693504, 218, 45, 'PPL', 'P'),
(22717, 'Lockridge Forest', 33.9536094665527, 0.592602278127661, -84.2652816772461, -1.47070661038839, 218, 13, 'PPL', 'P'),
(103758, 'Locks Corner', 38.1636085510254, 0.666080623657655, -77.3944396972656, -1.35078779545349, 218, 53, 'PPL', 'P'),
(127992, 'Locks Corner', 44.4500007629395, 0.775798865827285, -69.9502792358398, -1.22086268535483, 218, 26, 'PPL', 'P'),
(125260, 'Locks Village', 42.5, 0.74176493209759, -72.4347229003906, -1.26422440738155, 218, 23, 'PPL', 'P'),
(49006, 'Locksley', 39.5316696166992, 0.689957793622006, -76.5388870239258, -1.33585558437947, 218, 25, 'PPL', 'P'),
(78637, 'Locksley', 39.9297218322754, 0.696905115378669, -75.5072174072266, -1.31784955277528, 218, 45, 'PPL', 'P'),
(82141, 'Locksley Hall', 34.2319412231445, 0.597460083693047, -82.1961135864258, -1.43459281442637, 218, 48, 'PPL', 'P'),
(49004, 'Locksley Manor', 39.5499992370605, 0.690277705847952, -76.1866683959961, -1.32970820963524, 218, 25, 'PPL', 'P'),
(150351, 'Locksley Park', 42.7622184753418, 0.746341507851864, -78.8794403076172, -1.37670594549825, 218, 40, 'PPL', 'P'),
(103759, 'Locksville', 37.6719398498535, 0.657499385993202, -75.7677764892578, -1.3223971666527, 218, 53, 'PPL', 'P'),
(145635, 'Locktown', 40.4847183227539, 0.706591631474532, -74.9702835083008, -1.30847828837345, 218, 37, 'PPL', 'P'),
(163907, 'Lockview', 40.1572189331055, 0.700875688826895, -79.9100036621094, -1.39469266918453, 218, 45, 'PPL', 'P'),
(73259, 'Lockville', 39.8186111450195, 0.6949658680519, -82.7336120605469, -1.44397393252423, 218, 41, 'PPL', 'P'),
(163905, 'Lockville', 41.4169387817383, 0.722861947838262, -75.878059387207, -1.32432196633055, 218, 45, 'PPL', 'P'),
(73260, 'Lockville Station', 39.833610534668, 0.695227656787055, -82.7441711425781, -1.44415822327167, 218, 41, 'PPL', 'P'),
(16930, 'Lockwood', 28.561939239502, 0.498499880483874, -81.1444396972656, -1.41623764240328, 218, 12, 'PPL', 'P'),
(36938, 'Lockwood', 38.3083305358887, 0.668606498793541, -82.5802764892578, -1.44129772194481, 218, 21, 'PPL', 'P'),
(55956, 'Lockwood', 37.3855590820313, 0.652501098680314, -93.9530563354492, -1.63979017536531, 218, 29, 'PPL', 'P'),
(110158, 'Lockwood', 38.2594413757324, 0.66775322198028, -81.0350036621094, -1.41432762326947, 218, 58, 'PPL', 'P'),
(131816, 'Lockwood', 41.8836097717285, 0.731006893137133, -85.0488891601563, -1.48438314100844, 218, 27, 'PPL', 'P'),
(142274, 'Lockwood', 40.9700012207031, 0.715061415847365, -98.2441711425781, -1.71468425733079, 218, 35, 'PPL', 'P'),
(145636, 'Lockwood', 40.9205589294434, 0.714198485075153, -74.7197189331055, -1.30410511154744, 218, 37, 'PPL', 'P'),
(150352, 'Lockwood', 42.0911102294922, 0.734628459324505, -76.5502777099609, -1.33605438935484, 218, 40, 'PPL', 'P'),
(156201, 'Lockwood', 41.4613914489746, 0.72363779324283, -80.8472213745117, -1.41105020407397, 218, 41, 'PPL', 'P'),
(163906, 'Lockwood', 41.5288887023926, 0.724815842551026, -78.2744369506836, -1.36614664493414, 218, 45, 'PPL', 'P'),
(182864, 'Lockwood', 35.9441719055176, 0.627344146654126, -121.082221984863, -2.11328343926653, 218, 6, 'PPL', 'P'),
(190420, 'Lockwood', 39.5072212219238, 0.689531088636348, -119.645561218262, -2.0882089786551, 218, 39, 'PPL', 'P'),
(196928, 'Lockwood', 45.8191719055176, 0.799695410288566, -108.414169311523, -1.89218421030068, 218, 31, 'PPL', 'P'),
(131817, 'Lockwood Beach', 43.8427810668945, 0.765200882848342, -84.335563659668, -1.47193326238648, 218, 27, 'PPL', 'P'),
(169470, 'Lockwood Corner', 41.7125015258789, 0.728020490869746, -71.3986129760742, -1.24614087778964, 218, 47, 'PPL', 'P'),
(156202, 'Lockwood Corners', 40.9977798461914, 0.715546244323814, -81.5577774047852, -1.42345174632214, 218, 41, 'PPL', 'P'),
(82142, 'Lockwood Hall', 32.7316703796387, 0.571275417802197, -79.9247207641602, -1.39494953107167, 218, 48, 'PPL', 'P'),
(49005, 'Lockwood Heights', 39.4786109924316, 0.689031745931958, -77.5630569458008, -1.35373072161608, 218, 25, 'PPL', 'P'),
(82143, 'Lockwood Heights', 34.8491706848145, 0.608232770039499, -82.4516677856445, -1.43905307662004, 218, 48, 'PPL', 'P'),
(41841, 'Loco', 32.9480590820313, 0.575052113123066, -92.165283203125, -1.60858764792756, 218, 22, 'PPL', 'P'),
(76426, 'Loco', 34.3291702270508, 0.599157049939645, -97.6808319091797, -1.70485213290232, 218, 42, 'PPL', 'P'),
(191776, 'Loco', 34.7174987792969, 0.605934661755843, -100.152221679688, -1.74798602149779, 218, 51, 'PPL', 'P'),
(88644, 'Loco (historical)', 35.767219543457, 0.624255745316988, -87.0069427490234, -1.51855762306467, 218, 50, 'PPL', 'P'),
(188894, 'Loco Hills', 32.8188896179199, 0.572797680681286, -103.97721862793, -1.81474481212335, 218, 38, 'PPL', 'P'),
(60668, 'Locopolis (historical)', 33.9855613708496, 0.593159944059923, -90.1947174072266, -1.57419478666195, 218, 30, 'PPL', 'P'),
(60669, 'Locum', 34.5930595397949, 0.603762787307856, -88.8436126708984, -1.55061356047373, 218, 30, 'PPL', 'P'),
(36941, 'Locust', 38.7030601501465, 0.675495830217467, -85.2608337402344, -1.48808227176256, 218, 21, 'PPL', 'P'),
(55958, 'Locust', 36.5636100769043, 0.638155382257357, -92.5422210693359, -1.61516645476838, 218, 29, 'PPL', 'P'),
(66448, 'Locust', 35.2597198486328, 0.615398204689439, -80.4255599975586, -1.40369082471764, 218, 33, 'PPL', 'P'),
(95768, 'Locust', 33.7972183227539, 0.589872737747411, -96.772216796875, -1.68899380755923, 218, 51, 'PPL', 'P'),
(110159, 'Locust', 38.0675010681152, 0.664403231645069, -80.2388916015625, -1.40043284659809, 218, 58, 'PPL', 'P'),
(116583, 'Locust', 43.4216690063477, 0.757851090871941, -91.7222213745117, -1.60085476022835, 218, 16, 'PPL', 'P'),
(145637, 'Locust', 40.3944396972656, 0.705015972215587, -74.0266723632813, -1.29200916703435, 218, 37, 'PPL', 'P'),
(163908, 'Locust', 40.8563919067383, 0.713078559257747, -78.9727783203125, -1.37833500113705, 218, 45, 'PPL', 'P'),
(10146, 'Locust Bayou', 33.5566711425781, 0.585674397446956, -92.6688919067383, -1.61737727794731, 218, 4, 'PPL', 'P'),
(36940, 'Locust Branch', 37.586109161377, 0.656001357880033, -84.0697174072266, -1.46729336997729, 218, 21, 'PPL', 'P'),
(73261, 'Locust Corner', 39.0247192382813, 0.681109840374381, -84.2755584716797, -1.47088597428781, 218, 41, 'PPL', 'P'),
(145638, 'Locust Corner', 40.2844390869141, 0.703096099385749, -74.5619430541992, -1.30135140298029, 218, 37, 'PPL', 'P'),
(131818, 'Locust Corners', 41.8838882446289, 0.731011753406123, -84.420280456543, -1.4734118494237, 218, 27, 'PPL', 'P'),
(103760, 'Locust Creek', 37.8666687011719, 0.660898045597334, -77.7852783203125, -1.35760921626962, 218, 53, 'PPL', 'P'),
(103761, 'Locust Dale', 38.336109161377, 0.66909132726999, -78.1272201538086, -1.36357722711443, 218, 53, 'PPL', 'P'),
(3840, 'Locust Fork', 33.9075012207031, 0.591797537425266, -86.6152801513672, -1.51172182117865, 218, 2, 'PPL', 'P'),
(73276, 'Locust Fork', 39.436939239502, 0.688304436638258, -81.5169372558594, -1.42273895125638, 218, 41, 'PPL', 'P'),
(163919, 'Locust Gap', 40.771671295166, 0.711599905641508, -76.4416732788086, -1.33415888444898, 218, 45, 'PPL', 'P'),
(103772, 'Locust Gardens Mobile Home Park', 37.3241691589355, 0.651429642394748, -79.2383270263672, -1.38296970038212, 218, 53, 'PPL', 'P'),
(103762, 'Locust Green', 37.6652793884277, 0.65738313901162, -77.2619400024414, -1.34847523952092, 218, 53, 'PPL', 'P'),
(901, 'Locust Grove', 36.1741714477539, 0.63135839594423, -89.2569427490234, -1.55782753123454, 218, 50, 'PPL', 'P'),
(10149, 'Locust Grove', 35.7208290100098, 0.623446077766577, -91.7383270263672, -1.60113585688141, 218, 4, 'PPL', 'P'),
(22718, 'Locust Grove', 33.3458290100098, 0.581994508031712, -84.1091690063477, -1.46798193027713, 218, 13, 'PPL', 'P'),
(30362, 'Locust Grove', 39.7694396972656, 0.694107664390622, -84.851936340332, -1.48094566583142, 218, 19, 'PPL', 'P'),
(36944, 'Locust Grove', 37.934440612793, 0.662080888595493, -84.3186111450195, -1.47163738518938, 218, 21, 'PPL', 'P'),
(49012, 'Locust Grove', 39.4483299255371, 0.688503241613632, -77.6650009155273, -1.35550997954036, 218, 25, 'PPL', 'P'),
(60670, 'Locust Grove', 34.503059387207, 0.6021919883179, -88.9472198486328, -1.55242184685389, 218, 30, 'PPL', 'P'),
(76428, 'Locust Grove', 36.2000007629395, 0.631809202537753, -95.1675033569336, -1.66098627448125, 218, 42, 'PPL', 'P'),
(103765, 'Locust Grove', 38.7088890075684, 0.675597562971108, -78.6486129760742, -1.37267724855923, 218, 53, 'PPL', 'P'),
(112473, 'Locust Grove', 39.8919410705566, 0.696245716692765, -74.9552764892578, -1.30821636648024, 218, 37, 'PPL', 'P'),
(150354, 'Locust Grove', 40.810001373291, 0.712268891707336, -73.5025024414063, -1.28286067605771, 218, 40, 'PPL', 'P'),
(156204, 'Locust Grove', 40.9438896179199, 0.714605682405826, -80.7641677856445, -1.40960064549263, 218, 41, 'PPL', 'P'),
(163911, 'Locust Grove', 40.6744384765625, 0.709902872815882, -76.9475021362305, -1.34298726346259, 218, 45, 'PPL', 'P'),
(191777, 'Locust Grove', 36.1141700744629, 0.630311174424583, -100.366386413574, -1.75172390124577, 218, 51, 'PPL', 'P'),
(201148, 'Locust Grove', 45.5988883972168, 0.795850737780873, -120.787780761719, -2.10814447046906, 218, 43, 'PPL', 'P'),
(27742, 'Locust Grove (historical)', 37.8702812194824, 0.660961095936142, -88.7352828979492, -1.54872284925783, 218, 18, 'PPL', 'P'),
(49013, 'Locust Grove Beach', 38.6525001525879, 0.674613391790269, -76.5283279418945, -1.33567129363204, 218, 25, 'PPL', 'P'),
(103768, 'Locust Grove Park', 37.3008308410645, 0.65102231190602, -80.0519409179688, -1.39716994163053, 218, 53, 'PPL', 'P'),
(36943, 'Locust Hill', 37.7277793884277, 0.658473969794117, -86.3566665649414, -1.50720816260513, 218, 21, 'PPL', 'P'),
(49014, 'Locust Hill', 39.5019416809082, 0.689438943262631, -76.5186080932617, -1.3355016502706, 218, 25, 'PPL', 'P'),
(66449, 'Locust Hill', 36.3624992370605, 0.634645335940633, -79.4463882446289, -1.38660105368649, 218, 33, 'PPL', 'P'),
(78639, 'Locust Hill', 39.7544403076172, 0.693845875655467, -79.8694381713867, -1.39398466780874, 218, 45, 'PPL', 'P'),
(82149, 'Locust Hill', 35.0177803039551, 0.611175563044037, -82.3838882446289, -1.43787010046383, 218, 48, 'PPL', 'P'),
(103771, 'Locust Hill', 36.9583282470703, 0.645044513944201, -80.915283203125, -1.41223810707819, 218, 53, 'PPL', 'P'),
(139289, 'Locust Hill', 40.0258293151855, 0.698582507391255, -92.2755584716797, -1.61051231444736, 218, 29, 'PPL', 'P'),
(49016, 'Locust Hill Estates', 39.0108299255371, 0.680867426136157, -77.095832824707, -1.34557612235826, 218, 25, 'PPL', 'P'),
(49017, 'Locust Knoll', 39.5161094665527, 0.689686217769845, -76.3644409179688, -1.33281092546324, 218, 25, 'PPL', 'P'),
(73263, 'Locust Lake', 39.0263900756836, 0.681139001988318, -84.2333297729492, -1.47014894445613, 218, 41, 'PPL', 'P'),
(163912, 'Locust Lakes Village', 41.1444396972656, 0.718105941605544, -75.545280456543, -1.3185138783092, 218, 45, 'PPL', 'P'),
(110160, 'Locust Lane (historical)', 38.8833312988281, 0.678642155308314, -82.1319427490234, -1.43347282202994, 218, 58, 'PPL', 'P'),
(163913, 'Locust Lane Acres', 40.2933311462402, 0.703251295098273, -76.7949981689453, -1.34032556711111, 218, 45, 'PPL', 'P'),
(163914, 'Locust Lane Gardens', 40.2961082458496, 0.703299764630112, -76.7866668701172, -1.34018015851559, 218, 45, 'PPL', 'P'),
(49018, 'Locust Manor', 39.2011108398438, 0.684188454594513, -76.7936096191406, -1.34030133234519, 218, 25, 'PPL', 'P'),
(145639, 'Locust Manor', 40.0499992370605, 0.699004352107924, -74.232780456543, -1.29560643187677, 218, 37, 'PPL', 'P'),
(150355, 'Locust Manor', 40.6841697692871, 0.710072715914402, -73.7797164916992, -1.28769897396811, 218, 40, 'PPL', 'P'),
(163915, 'Locust Manor Mobile Home Park', 40.1741714477539, 0.701171566024003, -76.8283309936523, -1.34090733465124, 218, 45, 'PPL', 'P'),
(88646, 'Locust Mount', 36.3402786254883, 0.63425751310689, -82.5763931274414, -1.44122994449507, 218, 50, 'PPL', 'P'),
(103773, 'Locust Mount', 37.610279083252, 0.656423202596701, -75.6999969482422, -1.32121419049649, 218, 53, 'PPL', 'P'),
(49019, 'Locust Neck Heights', 39.6288909912109, 0.69165462671055, -77.0480575561523, -1.34474228662095, 218, 25, 'PPL', 'P'),
(49020, 'Locust Park', 39.211109161377, 0.68436295822494, -76.8252792358398, -1.34085407142944, 218, 25, 'PPL', 'P'),
(30363, 'Locust Point', 38.1711082458496, 0.666211518025233, -85.9077835083008, -1.49937367531033, 218, 19, 'PPL', 'P'),
(150356, 'Locust Point', 40.8158302307129, 0.712370624460977, -73.8024978637695, -1.28809658391886, 218, 40, 'PPL', 'P'),
(156205, 'Locust Point', 41.5883293151855, 0.725853276953666, -83.0938873291016, -1.45026192217402, 218, 41, 'PPL', 'P'),
(163916, 'Locust Point', 40.1972198486328, 0.701573836506659, -77.0641708374023, -1.34502351643207, 218, 45, 'PPL', 'P'),
(41842, 'Locust Ridge', 31.8763904571533, 0.556347967128626, -91.341667175293, -1.59421283646969, 218, 22, 'PPL', 'P'),
(49021, 'Locust Ridge', 39.2688903808594, 0.685371430750726, -76.9194412231445, -1.34249750813813, 218, 25, 'PPL', 'P'),
(73264, 'Locust Ridge', 38.9919395446777, 0.680537726793205, -84.0072174072266, -1.4662025391948, 218, 41, 'PPL', 'P'),
(163917, 'Locust Ridge Manor', 40.288890838623, 0.703173797110552, -76.8266677856445, -1.34087830619536, 218, 45, 'PPL', 'P'),
(163918, 'Locust Run', 40.5547218322754, 0.707813423203633, -77.273063659668, -1.34866938396439, 218, 45, 'PPL', 'P'),
(78640, 'Locust Spring', 39.9333305358887, 0.696968099138449, -76.5749969482422, -1.33648582145144, 218, 45, 'PPL', 'P'),
(88645, 'Locust Springs', 36.3052787780762, 0.633646650531853, -82.7983322143555, -1.44510351230059, 218, 50, 'PPL', 'P'),
(163920, 'Locust Summit', 40.7719383239746, 0.711604566173415, -76.404167175293, -1.33350427945304, 218, 45, 'PPL', 'P'),
(82145, 'Locust Tree Landing', 33.9577789306641, 0.592675049004447, -79.3324966430664, -1.38461327024886, 218, 48, 'PPL', 'P'),
(49022, 'Locust Valley', 39.4225006103516, 0.688052435020109, -77.6308288574219, -1.35491356461424, 218, 25, 'PPL', 'P'),
(150357, 'Locust Valley', 40.8758316040039, 0.713417845980623, -73.5975036621094, -1.28451876015239, 218, 40, 'PPL', 'P'),
(163922, 'Locust Valley', 40.8044395446777, 0.712171819485602, -76.0619430541992, -1.32753134176021, 218, 45, 'PPL', 'P'),
(163924, 'Locustdale', 40.7772216796875, 0.711696778126159, -76.3763885498047, -1.33301945097659, 218, 45, 'PPL', 'P'),
(73265, 'Locustgrove', 39.8875007629395, 0.696168218705044, -83.7544403076172, -1.46179074653297, 218, 41, 'PPL', 'P'),
(14137, 'Locustville', 39.0738906860352, 0.681968044035659, -75.4944381713867, -1.31762651303399, 218, 10, 'PPL', 'P'),
(103775, 'Locustville', 37.6536102294922, 0.657179473767256, -75.6786117553711, -1.32084094846971, 218, 53, 'PPL', 'P'),
(169469, 'Locustville', 41.5099983215332, 0.724486143208074, -71.7125015258789, -1.25161926646804, 218, 47, 'PPL', 'P'),
(71040, 'Locustwood', 39.9241714477539, 0.696808242894017, -75.0286102294922, -1.30949628170014, 218, 37, 'PPL', 'P'),
(110161, 'Loda', 38.8011093139648, 0.677207110954925, -80.0822219848633, -1.39769844594885, 218, 58, 'PPL', 'P'),
(120403, 'Loda', 40.5175018310547, 0.707163811634736, -88.0719375610352, -1.53714528905093, 218, 18, 'PPL', 'P'),
(36945, 'Lodale', 38.0430603027344, 0.663976659817466, -86.2808303833008, -1.50588457154336, 218, 21, 'PPL', 'P'),
(175033, 'Loddes Mill', 43.2638893127441, 0.755097315725772, -89.8005599975586, -1.56731544209211, 218, 57, 'PPL', 'P'),
(103776, 'Lodebar', 37.9036102294922, 0.661542796897242, -78.8491668701172, -1.37617757433798, 218, 53, 'PPL', 'P'),
(120405, 'Lodemia', 40.8072204589844, 0.712220355596469, -88.5658264160156, -1.54576527570924, 218, 18, 'PPL', 'P'),
(82146, 'Lodge', 33.0677795410156, 0.577141629314342, -80.9538879394531, -1.41291188683398, 218, 48, 'PPL', 'P'),
(103777, 'Lodge', 37.9919395446777, 0.663084434273262, -76.543327331543, -1.33593308236719, 218, 53, 'PPL', 'P'),
(120406, 'Lodge', 40.1061096191406, 0.699983663019773, -88.5599975585938, -1.5456635429556, 218, 18, 'PPL', 'P'),
(10151, 'Lodge Corner', 34.2999992370605, 0.59864792011825, -91.5250015258789, -1.59741262451942, 218, 4, 'PPL', 'P'),
(49023, 'Lodge Forest', 39.2202796936035, 0.684523014206454, -76.4488906860352, -1.33428485196854, 218, 25, 'PPL', 'P'),
(196929, 'Lodge Grass', 45.3144416809082, 0.790886206034802, -107.362503051758, -1.87382917143563, 218, 31, 'PPL', 'P'),
(82147, 'Lodge Grounds', 34.1911087036133, 0.596747421785342, -82.1847229003906, -1.434394009451, 218, 48, 'PPL', 'P'),
(82148, 'Lodge Hall', 33.3327789306641, 0.581766741179483, -79.4747161865234, -1.38709546954287, 218, 48, 'PPL', 'P'),
(182868, 'Lodge Hill', 35.5511093139648, 0.620483910265109, -121.079719543457, -2.11323976342465, 218, 6, 'PPL', 'P'),
(196930, 'Lodge Pole', 48.0347213745117, 0.838364043263326, -108.532501220703, -1.89424949172603, 218, 31, 'PPL', 'P'),
(22719, 'Lodge West', 33.7722206115723, 0.589436445381829, -84.5619430541992, -1.47588432817973, 218, 13, 'PPL', 'P'),
(199487, 'Lodgepole', 41.1497192382813, 0.718198086979261, -102.635833740234, -1.79133322929658, 218, 35, 'PPL', 'P'),
(202320, 'Lodgepole', 45.8047218322754, 0.799443208933335, -102.660278320313, -1.79175986770321, 218, 49, 'PPL', 'P'),
(110162, 'Lodgeville', 39.2874984741211, 0.685696203245661, -80.2838897705078, -1.40121821280356, 218, 58, 'PPL', 'P'),
(112, 'Lodi', 36.7147216796875, 0.64079277726389, -81.7774963378906, -1.4272865651338, 218, 53, 'PPL', 'P'),
(30364, 'Lodi', 39.9500007629395, 0.69725904948754, -87.4058303833008, -1.5255195256283, 218, 19, 'PPL', 'P'),
(55961, 'Lodi', 37.2563896179199, 0.650246666238535, -90.4527816772461, -1.57869885785554, 218, 29, 'PPL', 'P'),
(60672, 'Lodi', 33.0463905334473, 0.57676832070854, -90.4100036621094, -1.57795224064394, 218, 30, 'PPL', 'P'),
(76430, 'Lodi', 35.0091705322266, 0.611025294179529, -95.0419387817383, -1.65879475922022, 218, 42, 'PPL', 'P'),
(88647, 'Lodi', 35.2224998474121, 0.614748593120542, -87.5524978637695, -1.52807935606808, 218, 50, 'PPL', 'P'),
(95769, 'Lodi', 32.8761100769043, 0.573796366090066, -94.2794418334961, -1.64548667693699, 218, 51, 'PPL', 'P'),
(112237, 'Lodi', 34.3108291625977, 0.598836937976618, -93.7072219848633, -1.63549955653308, 218, 4, 'PPL', 'P'),
(131819, 'Lodi', 44.6405601501465, 0.77912475455463, -85.1752777099609, -1.48658903733935, 218, 27, 'PPL', 'P'),
(142275, 'Lodi', 41.2155609130859, 0.71934724098963, -99.8525009155273, -1.7427549073266, 218, 35, 'PPL', 'P'),
(145640, 'Lodi', 40.8822212219238, 0.71352936585127, -74.083610534668, -1.29300292559511, 218, 37, 'PPL', 'P'),
(150358, 'Lodi', 42.6138916015625, 0.743752715535225, -76.8227767944336, -1.34081039558756, 218, 40, 'PPL', 'P'),
(156206, 'Lodi', 41.0333290100098, 0.716166694278776, -82.0122222900391, -1.43138330583867, 218, 41, 'PPL', 'P'),
(163925, 'Lodi', 40.5513916015625, 0.707755299712842, -75.0844421386719, -1.310470732343, 218, 45, 'PPL', 'P'),
(170767, 'Lodi', 42.9824981689453, 0.75018611378053, -96.9836120605469, -1.69268335093343, 218, 49, 'PPL', 'P'),
(175034, 'Lodi', 43.3138885498047, 0.755969967035964, -89.5263900756836, -1.56253027424545, 218, 57, 'PPL', 'P'),
(182867, 'Lodi', 38.1302795410156, 0.665498922696555, -121.271392822266, -2.11658509322795, 218, 6, 'PPL', 'P'),
(190421, 'Lodi', 38.9938888549805, 0.680571748676131, -117.877502441406, -2.05735053163019, 218, 39, 'PPL', 'P'),
(194294, 'Lodi', 40.2511100769043, 0.702514398424648, -103.703330993652, -1.80996457112472, 218, 7, 'PPL', 'P'),
(41843, 'Lodi (historical)', 30.3638896942139, 0.529949848876406, -92.5680618286133, -1.61561746109898, 218, 22, 'PPL', 'P'),
(195256, 'Lodi (historical)', 44.0897216796875, 0.769510809598472, -111.460563659668, -1.94535382198995, 218, 17, 'PPL', 'P'),
(150359, 'Lodi Center', 42.5711097717285, 0.743006031744594, -76.8208312988281, -1.34077644028366, 218, 40, 'PPL', 'P'),
(182869, 'Lodi Junction', 38.1283302307129, 0.665464900813629, -121.242218017578, -2.11607589682753, 218, 6, 'PPL', 'P'),
(190423, 'Lodi Tanks', 38.9872207641602, 0.680455368536494, -117.833061218262, -2.05657488596271, 218, 39, 'PPL', 'P'),
(36946, 'Lodiburg', 37.9044418334961, 0.661557311125183, -86.4027786254883, -1.50801296988655, 218, 21, 'PPL', 'P'),
(182870, 'Lodoga', 39.3019409179688, 0.685948271442837, -122.488059997559, -2.13781994133776, 218, 6, 'PPL', 'P'),
(66454, 'Lodonberry Estates', 35.9833297729492, 0.628027580368868, -80.0477828979492, -1.39709737049082, 218, 33, 'PPL', 'P'),
(103778, 'Lodore', 37.4391708374023, 0.653436800329314, -78.0227813720703, -1.36175442650633, 218, 53, 'PPL', 'P'),
(41844, 'Loe', 32.2430610656738, 0.5627475765176, -92.8208312988281, -1.62002912060276, 218, 22, 'PPL', 'P'),
(95770, 'Loeb', 30.1944408416748, 0.526992408485873, -94.1927795410156, -1.64397413459588, 218, 51, 'PPL', 'P'),
(95771, 'Loebau', 30.2875003814697, 0.528616603855685, -96.9049987792969, -1.69131129033982, 218, 51, 'PPL', 'P'),
(139290, 'Loeffler', 40.1030616760254, 0.699930466376999, -92.8330612182617, -1.62024257296413, 218, 29, 'PPL', 'P'),
(131821, 'Loehme', 43.6902809143066, 0.762539253075889, -84.0677795410156, -1.46725954783145, 218, 27, 'PPL', 'P'),
(55962, 'Loehr', 38.6150016784668, 0.673958919952382, -90.5411071777344, -1.58024042865254, 218, 29, 'PPL', 'P'),
(136562, 'Loerch', 46.4033317565918, 0.809890923047771, -94.0722198486328, -1.6418699710186, 218, 28, 'PPL', 'P'),
(207941, 'Lofall', 47.8122215270996, 0.834480688340799, -122.656936645508, -2.1407673948742, 218, 56, 'PPL', 'P'),
(204730, 'Lofgreen', 40.024169921875, 0.6985535455144, -112.309722900391, -1.96017444661429, 218, 52, 'PPL', 'P'),
(3841, 'Loflin', 32.1969413757324, 0.561942636078123, -85.0350036621094, -1.48414079334924, 218, 2, 'PPL', 'P'),
(22720, 'Loftin', 32.8849983215332, 0.573951495223563, -84.5980606079102, -1.47651469840975, 218, 13, 'PPL', 'P'),
(66452, 'Loftin Farms', 35.3752784729004, 0.617415083161983, -80.1816711425781, -1.39943416118931, 218, 33, 'PPL', 'P'),
(66453, 'Loftins Crossroads', 35.1997184753418, 0.614350983169793, -77.5616683959961, -1.35370648685016, 218, 33, 'PPL', 'P'),
(103779, 'Loftis', 36.9083290100098, 0.64417186263401, -78.9683303833008, -1.37825736999127, 218, 53, 'PPL', 'P'),
(110163, 'Loftis (historical)', 39.2516708374023, 0.685070893021711, -79.9400024414063, -1.39521624665484, 218, 58, 'PPL', 'P'),
(103780, 'Loftlands Wood', 38.1450004577637, 0.66575585116272, -78.4841690063477, -1.36980715985245, 218, 53, 'PPL', 'P'),
(10152, 'Lofton', 34.4005584716797, 0.600403009855639, -93.2311096191406, -1.62718982814176, 218, 4, 'PPL', 'P'),
(41845, 'Lofton', 31.7266693115234, 0.553734840177527, -92.7572174072266, -1.6189188487443, 218, 22, 'PPL', 'P'),
(88648, 'Lofton', 35.9286117553711, 0.627072570801965, -86.2724990844727, -1.50573916294784, 218, 50, 'PPL', 'P'),
(103781, 'Lofton', 37.9550018310547, 0.662439749552381, -79.1647186279297, -1.38168499147226, 218, 53, 'PPL', 'P'),
(3842, 'Lofty', 33.4627799987793, 0.584035687849203, -85.4000015258789, -1.49051120783477, 218, 2, 'PPL', 'P'),
(163926, 'Lofty', 40.8683280944824, 0.713286885034018, -76.0299987792969, -1.326973808986, 218, 45, 'PPL', 'P'),
(49025, 'Lofty Heights', 38.7763900756836, 0.676775678858332, -76.5749969482422, -1.33648582145144, 218, 25, 'PPL', 'P'),
(41846, 'Log Cabin', 32.8327789306641, 0.573040094919511, -91.8775024414063, -1.60356492611167, 218, 22, 'PPL', 'P'),
(95772, 'Log Cabin', 32.2222213745117, 0.562383855291722, -96.0216674804688, -1.67589425078935, 218, 51, 'PPL', 'P'),
(120407, 'Log Cabin Camp', 41.1616706848145, 0.718406679071641, -87.5822219848633, -1.52859813984843, 218, 18, 'PPL', 'P'),
(123089, 'Log Cabin Crossroads', 40.0252799987793, 0.698572920011331, -86.7002792358398, -1.51320533506388, 218, 19, 'PPL', 'P'),
(14138, 'Log Cabin Mobile Home Park', 38.7366714477539, 0.676082458026584, -75.2355575561523, -1.31310819392856, 218, 10, 'PPL', 'P'),
(82151, 'Log Jam Landing', 33.5202789306641, 0.585039233526972, -80.3024978637695, -1.40154298529849, 218, 48, 'PPL', 'P'),
(103782, 'Log Landing', 37.6758308410645, 0.657567296600999, -76.9049987792969, -1.34224543994095, 218, 53, 'PPL', 'P'),
(194297, 'Log Lane Village', 40.2705612182617, 0.702853884884606, -103.829170227051, -1.8121608800757, 218, 7, 'PPL', 'P'),
(36947, 'Log Lick', 37.8580589294434, 0.660747776732826, -84.0269393920898, -1.46654675276569, 218, 21, 'PPL', 'P'),
(163927, 'Log Pile', 40.1630592346191, 0.700977621317618, -80.2927780151367, -1.40137334193705, 218, 45, 'PPL', 'P'),
(14139, 'Log Run', 39.8102798461914, 0.694820459456382, -75.4905624389648, -1.3175588687423, 218, 10, 'PPL', 'P'),
(49026, 'Log Town (historical)', 39.1366691589355, 0.683063735087145, -77.1949996948242, -1.3473069107507, 218, 25, 'PPL', 'P'),
(82150, 'Log Town (historical)', 34.2569389343262, 0.597896376058629, -80.601936340332, -1.40676917262166, 218, 48, 'PPL', 'P'),
(3844, 'Logan', 31.9858303070068, 0.558258052841458, -86.4905624389648, -1.50954508646167, 218, 2, 'PPL', 'P'),
(10154, 'Logan', 36.2008285522461, 0.631823650186666, -94.3872222900391, -1.64736780077296, 218, 4, 'PPL', 'P'),
(22722, 'Logan', 33.7249984741211, 0.588612263603477, -82.7130584716797, -1.4436152047254, 218, 13, 'PPL', 'P'),
(27740, 'Logan', 39.7372207641602, 0.693545337926452, -87.6050033569336, -1.52899574979918, 218, 18, 'PPL', 'P'),
(30366, 'Logan', 38.9422187805176, 0.679669935752003, -86.508056640625, -1.50985041788065, 218, 19, 'PPL', 'P'),
(33120, 'Logan', 39.6616706848145, 0.692226740291726, -99.5699996948242, -1.73782433088443, 218, 20, 'PPL', 'P'),
(55963, 'Logan', 37.0144386291504, 0.646023824856051, -93.6158294677734, -1.63390445619818, 218, 29, 'PPL', 'P'),
(66455, 'Logan', 35.4272193908691, 0.618321623197046, -81.8994369506836, -1.42941483031893, 218, 33, 'PPL', 'P'),
(95773, 'Logan', 32.0783309936523, 0.559872494383778, -94.0536117553711, -1.64154519852367, 218, 51, 'PPL', 'P'),
(103783, 'Logan', 38.2174987792969, 0.667021185575644, -77.7613906860352, -1.35719229840097, 218, 53, 'PPL', 'P'),
(110165, 'Logan', 37.8486099243164, 0.660582860482323, -81.9936065673828, -1.43105840018568, 218, 58, 'PPL', 'P'),
(116588, 'Logan', 41.6430587768555, 0.726808486257651, -95.7886123657227, -1.67182667169842, 218, 16, 'PPL', 'P'),
(150361, 'Logan', 42.4877815246582, 0.741551679473302, -76.8288879394531, -1.34091705518922, 218, 40, 'PPL', 'P'),
(156217, 'Logan', 41.3536109924316, 0.721756669406852, -84.7480621337891, -1.47913271891935, 218, 41, 'PPL', 'P'),
(163929, 'Logan', 40.0283317565918, 0.698626183233132, -75.1519393920898, -1.31164878165119, 218, 45, 'PPL', 'P'),
(175037, 'Logan', 45.086669921875, 0.786910838896613, -88.3997192382813, -1.54286615854658, 218, 57, 'PPL', 'P'),
(188895, 'Logan', 35.3652801513672, 0.617240579531556, -103.410278320313, -1.80484983709316, 218, 38, 'PPL', 'P'),
(190999, 'Logan', 36.5727806091309, 0.638315438238871, -100.216941833496, -1.74911560127415, 218, 42, 'PPL', 'P'),
(193743, 'Logan', 41.7602806091309, 0.728854393186077, -122.438331604004, -2.1369520171385, 218, 6, 'PPL', 'P'),
(194295, 'Logan', 40.5786094665527, 0.708230341072285, -103.357780456543, -1.80393357652012, 218, 7, 'PPL', 'P'),
(196931, 'Logan', 45.8844413757324, 0.800834577444847, -111.426666259766, -1.94476220075379, 218, 31, 'PPL', 'P'),
(198541, 'Logan', 48.1483306884766, 0.840346899852944, -101.153327941895, -1.76545862193564, 218, 34, 'PPL', 'P'),
(199489, 'Logan', 41.4947204589844, 0.72421949420393, -100.300003051758, -1.75056529301353, 218, 35, 'PPL', 'P'),
(201149, 'Logan', 45.3436088562012, 0.791395269277171, -122.421669006348, -2.13666119994746, 218, 43, 'PPL', 'P'),
(204732, 'Logan', 41.7355613708496, 0.728422961089484, -111.833610534668, -1.95186471822297, 218, 52, 'PPL', 'P'),
(156207, 'Logan (historical)', 40.6049995422363, 0.708690934782814, -83.0736083984375, -1.44990798806515, 218, 41, 'PPL', 'P'),
(190424, 'Logan (historical)', 37.6097183227539, 0.656413415479695, -115.391937255859, -2.01396923536946, 218, 39, 'PPL', 'P'),
(140412, 'Logan Center', 47.8027801513672, 0.834315905248351, -97.8180618286133, -1.70724724682869, 218, 34, 'PPL', 'P'),
(13150, 'Logan Circle', 38.9124984741211, 0.679151218550683, -77.0319366455078, -1.34446092365179, 218, 9, 'PPL', 'P'),
(190425, 'Logan Creek Estates', 39.0658302307129, 0.681827362551076, -119.9375, -2.0933042716107, 218, 39, 'PPL', 'P'),
(73269, 'Logan Elm Village', 39.5697212219238, 0.690621919418845, -82.9519424438477, -1.44778451656997, 218, 41, 'PPL', 'P'),
(110166, 'Logan Heights', 37.8369407653809, 0.660379195237959, -82.0261077880859, -1.43162565349786, 218, 58, 'PPL', 'P'),
(3845, 'Logan Martin Lake Estates', 33.5277786254883, 0.585170127894549, -86.2249984741211, -1.5049101209005, 218, 2, 'PPL', 'P'),
(3846, 'Logan Martin Pines', 33.4944381713867, 0.584588227196367, -86.2930603027344, -1.50609802390473, 218, 2, 'PPL', 'P'),
(163930, 'Logan Mills', 41.0066719055176, 0.715701440036339, -77.383056640625, -1.35058912363617, 218, 45, 'PPL', 'P'),
(66457, 'Logan Street Public Housing', 35.3011093139648, 0.616120587135123, -81.5316696166992, -1.42299607945962, 218, 33, 'PPL', 'P'),
(103784, 'Logan Village', 38.1105613708496, 0.665154775704689, -78.5111083984375, -1.37027734094291, 218, 53, 'PPL', 'P'),
(36949, 'Logana', 37.8647193908691, 0.660864023714408, -84.4869384765625, -1.4745752513459, 218, 21, 'PPL', 'P'),
(182873, 'Logandale', 39.4372215270996, 0.688309363486274, -122.190826416016, -2.13263223669234, 218, 6, 'PPL', 'P'),
(190429, 'Logandale', 36.5966682434082, 0.638732356107523, -114.483329772949, -1.99811104318442, 218, 39, 'PPL', 'P'),
(163934, 'Logans Ferry Heights', 40.545280456543, 0.707648640111184, -79.7547225952148, -1.39198250330122, 218, 45, 'PPL', 'P'),
(27743, 'Logansburgh (historical)', 38.3375015258789, 0.669115628614937, -87.8919372558594, -1.53400369107102, 218, 18, 'PPL', 'P'),
(36951, 'Logansport', 37.2849998474121, 0.650746008942925, -86.7680587768555, -1.51438831122009, 218, 21, 'PPL', 'P'),
(41847, 'Logansport', 31.9752807617188, 0.558073928541593, -93.9977798461914, -1.64057074788081, 218, 22, 'PPL', 'P'),
(110167, 'Logansport', 39.5191688537598, 0.689739614149701, -80.4138870239258, -1.40348709289425, 218, 58, 'PPL', 'P'),
(116596, 'Logansport', 42.0675010681152, 0.734216401724842, -93.9466705322266, -1.63967872207369, 218, 16, 'PPL', 'P'),
(123092, 'Logansport', 40.7544403076172, 0.711299168175411, -86.3566665649414, -1.50720816260513, 218, 19, 'PPL', 'P'),
(27744, 'Logansport (historical)', 38.1058311462402, 0.665072217710897, -88.4233322143555, -1.54327828272527, 218, 18, 'PPL', 'P'),
(145642, 'Logansville', 40.725830078125, 0.710799825471021, -74.522216796875, -1.30065804899049, 218, 37, 'PPL', 'P'),
(156210, 'Logansville', 40.3455581665039, 0.70416282856038, -83.9305572509766, -1.46486456706314, 218, 41, 'PPL', 'P'),
(163935, 'Loganton', 41.0341682434082, 0.716181341664771, -77.3069381713867, -1.34926060572638, 218, 45, 'PPL', 'P'),
(88650, 'Loganton (historical)', 36.0494384765625, 0.629181394911144, -82.5325012207031, -1.44046388620751, 218, 50, 'PPL', 'P'),
(36950, 'Logantown', 37.5605583190918, 0.655555411555499, -84.6297225952148, -1.47706730433594, 218, 21, 'PPL', 'P'),
(22725, 'Loganville', 33.8388900756836, 0.590600047041112, -83.9008331298828, -1.46434578328279, 218, 13, 'PPL', 'P'),
(78641, 'Loganville', 39.8555603027344, 0.695610752509863, -76.7077789306641, -1.33880330423202, 218, 45, 'PPL', 'P'),
(175038, 'Loganville', 43.4402809143066, 0.758175929945904, -90.0358276367188, -1.57142163701885, 218, 57, 'PPL', 'P'),
(182874, 'Loganville', 39.5680618286133, 0.69059295754199, -120.666107177734, -2.10602086581583, 218, 6, 'PPL', 'P'),
(41848, 'Loggy Bayou', 32.1997184753418, 0.561991105609963, -93.4419403076172, -1.63086951781992, 218, 22, 'PPL', 'P'),
(156211, 'Loghaven', 40.1605606079102, 0.700934012054768, -81.1813888549805, -1.41688252686124, 218, 41, 'PPL', 'P'),
(186998, 'Loghill Village', 38.1952781677246, 0.666633362741901, -107.77889251709, -1.8810965385763, 218, 7, 'PPL', 'P'),
(177239, 'Logrow', 40.3772201538086, 0.704715434486571, -80.5583267211914, -1.40600804118212, 218, 58, 'PPL', 'P'),
(66458, 'Logsboro', 35.9663887023926, 0.627731902908841, -77.5733337402344, -1.3539100855155, 218, 33, 'PPL', 'P'),
(201152, 'Logsden', 44.7433280944824, 0.780918393548799, -123.793060302734, -2.1605964934026, 218, 43, 'PPL', 'P'),
(36952, 'Logsdon Valley', 37.2661094665527, 0.650416309599973, -85.9619369506836, -1.5003188311812, 218, 21, 'PPL', 'P'),
(3848, 'Logton', 31.9527797698975, 0.557681212149347, -85.914436340332, -1.49948978913386, 218, 2, 'PPL', 'P'),
(22726, 'Logtown', 32.8502807617188, 0.573345559496543, -84.188606262207, -1.46936837194063, 218, 13, 'PPL', 'P'),
(41849, 'Logtown', 32.3349990844727, 0.5643521976534, -92.0886077880859, -1.60724940947979, 218, 22, 'PPL', 'P'),
(60673, 'Logtown', 30.2827796936035, 0.528534212309461, -89.6211090087891, -1.56418343149212, 218, 30, 'PPL', 'P'),
(150362, 'Logtown', 41.3433303833008, 0.721577238928408, -74.5988922119141, -1.30199628743826, 218, 40, 'PPL', 'P'),
(156214, 'Logtown', 41.0255584716797, 0.716031072800263, -81.3933334350586, -1.42058165761536, 218, 41, 'PPL', 'P'),
(186994, 'Logtown (historical)', 37.5516700744629, 0.655400282422002, -107.590827941895, -1.87781419253277, 218, 7, 'PPL', 'P'),
(177407, 'Logue', 41.5588912963867, 0.725339486600363, -77.9502792358398, -1.36048902551437, 218, 45, 'PPL', 'P'),
(36953, 'Logville', 37.8727798461914, 0.661004705198992, -83.1100006103516, -1.45054315198513, 218, 21, 'PPL', 'P'),
(427, 'Logwall', 33.1100006103516, 0.577878525987967, -83.9449996948242, -1.46511663526032, 218, 13, 'PPL', 'P'),
(55966, 'Lohman', 38.5430603027344, 0.672703306077437, -92.3641662597656, -1.61205881209237, 218, 29, 'PPL', 'P'),
(88651, 'Lohman', 36.374439239502, 0.634853728295931, -86.7083282470703, -1.51334581681138, 218, 50, 'PPL', 'P'),
(196932, 'Lohman', 48.5897216796875, 0.848050625938216, -109.404441833496, -1.90946772630113, 218, 31, 'PPL', 'P'),
(88652, 'Lohmans Store (historical)', 36.1444396972656, 0.630839479005828, -86.4674987792969, -1.50914254966291, 218, 50, 'PPL', 'P'),
(55967, 'Lohmer', 36.666389465332, 0.639949220988607, -93.708610534668, -1.635523791299, 218, 29, 'PPL', 'P'),
(95774, 'Lohn', 31.3236103057861, 0.546700133447596, -99.4097213745117, -1.73502694647541, 218, 51, 'PPL', 'P'),
(116597, 'Lohrville', 42.2702789306641, 0.737755543076476, -94.5483322143555, -1.65017969940992, 218, 16, 'PPL', 'P'),
(175043, 'Lohrville', 44.0372200012207, 0.768594482446403, -89.116943359375, -1.55538408093439, 218, 57, 'PPL', 'P'),
(55968, 'Loimbach Landing', 37.7002792358398, 0.657994001586657, -89.5505599975586, -1.56295211896212, 218, 29, 'PPL', 'P'),
(95775, 'Loire', 29.1097202301025, 0.508060462349691, -98.3952789306641, -1.71732158575829, 218, 51, 'PPL', 'P'),
(16931, 'Lois', 30.5261096954346, 0.532781122010297, -83.9158325195313, -1.46460757201795, 218, 12, 'PPL', 'P'),
(55969, 'Lois', 38.1480598449707, 0.665809247542576, -91.7555618286133, -1.60143666092653, 218, 29, 'PPL', 'P'),
(88653, 'Lois', 35.2324981689453, 0.614923096750969, -86.3655624389648, -1.50736342489668, 218, 50, 'PPL', 'P'),
(95777, 'Lois', 29.8327808380127, 0.520680250649195, -95.5036087036133, -1.66685241941437, 218, 51, 'PPL', 'P'),
(103785, 'Lois', 38.5250015258789, 0.672388120962426, -77.7266693115234, -1.35658629609492, 218, 53, 'PPL', 'P'),
(182875, 'Lois', 36.0186080932617, 0.628643303212894, -119.026672363281, -2.0774073304318, 218, 6, 'PPL', 'P'),
(204733, 'Lois', 40.6138916015625, 0.708846130495339, -111.870559692383, -1.95250960268094, 218, 52, 'PPL', 'P'),
(3849, 'Lois Spring', 33.2305603027344, 0.579982689565238, -88.0938873291016, -1.53752838477374, 218, 2, 'PPL', 'P'),
(103786, 'Loisdale Estates', 38.7616691589355, 0.676518750392166, -77.1808319091797, -1.34705963624349, 218, 53, 'PPL', 'P'),
(41850, 'Loisel', 29.938060760498, 0.522517731932808, -91.6944427490234, -1.6003699317519, 218, 22, 'PPL', 'P'),
(182876, 'Lokern', 35.4000015258789, 0.617846581837604, -119.544998168945, -2.08645382233869, 218, 6, 'PPL', 'P'),
(125261, 'Lokerville', 42.288890838623, 0.738080382150438, -71.397216796875, -1.24611650986567, 218, 23, 'PPL', 'P'),
(16932, 'Lokosee', 27.7552795410156, 0.484421012802143, -80.9122161865234, -1.41218457754028, 218, 12, 'PPL', 'P'),
(182878, 'Lokoya', 38.3733291625977, 0.669740938838888, -122.426666259766, -2.13674841847316, 218, 6, 'PPL', 'P'),
(36954, 'Lola', 37.3186111450195, 0.651332636752042, -88.3077774047852, -1.54126147083175, 218, 21, 'PPL', 'P'),
(66459, 'Lola', 34.9577789306641, 0.61012834152439, -76.2797164916992, -1.33133220526797, 218, 33, 'PPL', 'P'),
(3850, 'Lola City', 33.5727806091309, 0.585955560679041, -86.6011123657227, -1.51147454667144, 218, 2, 'PPL', 'P'),
(95778, 'Lolaville', 33.0972213745117, 0.577655486246673, -96.8050003051758, -1.68956598771943, 218, 51, 'PPL', 'P'),
(163941, 'Loleta', 41.3988914489746, 0.722546962460333, -79.079719543457, -1.38020147758703, 218, 45, 'PPL', 'P'),
(193744, 'Loleta', 40.6411094665527, 0.709321171854782, -124.224166870117, -2.1681207224304, 218, 6, 'PPL', 'P'),
(95779, 'Lolita', 28.8391704559326, 0.503338477999898, -96.5422210693359, -1.68497962484815, 218, 51, 'PPL', 'P'),
(10159, 'Lollie', 34.9880599975586, 0.610656845842717, -92.5841674804688, -1.61589855775204, 218, 4, 'PPL', 'P'),
(22729, 'Lollie (historical)', 32.4813919067383, 0.566907234403222, -82.7561111450195, -1.44436661562697, 218, 13, 'PPL', 'P'),
(196933, 'Lolo', 46.7588882446289, 0.816096554440846, -114.080001831055, -1.99107164263306, 218, 31, 'PPL', 'P'),
(196934, 'Lolo Hot Springs', 46.7277793884277, 0.815553602473606, -114.529716491699, -1.9989206441558, 218, 31, 'PPL', 'P'),
(196935, 'Lolo Peak Trailer Court', 46.7486114501953, 0.815917190541429, -114.093063354492, -1.99129960922237, 218, 31, 'PPL', 'P'),
(95783, 'Loma', 30.6802806854248, 0.535471913396686, -95.8091735839844, -1.6721855326553, 218, 51, 'PPL', 'P'),
(140416, 'Loma', 48.6302795410156, 0.84875849415596, -98.5325012207031, -1.7197165665266, 218, 34, 'PPL', 'P'),
(142296, 'Loma', 41.128059387207, 0.717820051262524, -96.9416732788086, -1.69195138110782, 218, 35, 'PPL', 'P'),
(182877, 'Loma', 36.2577781677246, 0.632817608484511, -119.286392211914, -2.08194029692322, 218, 6, 'PPL', 'P'),
(186995, 'Loma', 39.1958312988281, 0.684096309220796, -108.8125, -1.89913639232633, 218, 7, 'PPL', 'P'),
(196936, 'Loma', 47.936939239502, 0.836657423057776, -110.502777099609, -1.92863729298557, 218, 31, 'PPL', 'P'),
(190427, 'Loma (historical)', 39.063060760498, 0.681779026177291, -118.911392211914, -2.07539531222824, 218, 39, 'PPL', 'P'),
(191778, 'Loma Alta', 29.9177799224854, 0.522163764534423, -100.774169921875, -1.75884106610096, 218, 51, 'PPL', 'P'),
(95781, 'Loma Alta Colonia', 26.3950004577637, 0.460679664053387, -98.8290023803711, -1.72489148799879, 218, 51, 'PPL', 'P'),
(95782, 'Loma Alta Ranch Colonia', 27.9710006713867, 0.488186056793243, -98.0879974365234, -1.71195851195509, 218, 51, 'PPL', 'P'),
(191779, 'Loma Bonita Colonia', 28.6840000152588, 0.50063024290837, -100.49299621582, -1.75393365916027, 218, 51, 'PPL', 'P'),
(95792, 'Loma Chica Colonia', 26.3460006713867, 0.459824456448335, -98.1190032958984, -1.7124996662886, 218, 51, 'PPL', 'P'),
(95784, 'Loma Grande Colonia', 28.7220001220703, 0.50129346988834, -99.8330001831055, -1.74241455533929, 218, 51, 'PPL', 'P'),
(55974, 'Loma Linda', 36.7933311462402, 0.642164771278471, -90.4369430541992, -1.57842242173439, 218, 29, 'PPL', 'P'),
(178550, 'Loma Linda', 32.4480590820313, 0.566325466863094, -110.754440307617, -1.93302964457144, 218, 5, 'PPL', 'P'),
(182879, 'Loma Linda', 34.0483283996582, 0.594255435374327, -117.260276794434, -2.04657791186277, 218, 6, 'PPL', 'P'),
(186996, 'Loma Linda', 37.2241706848145, 0.649684339774365, -107.795280456543, -1.88138256207737, 218, 7, 'PPL', 'P'),
(95785, 'Loma Linda Colonia', 28.0049991607666, 0.488779442373626, -97.5009994506836, -1.70171346439961, 218, 51, 'PPL', 'P'),
(95787, 'Loma Linda East Colonia', 26.3279991149902, 0.459510270018733, -98.6900024414063, -1.72246548140378, 218, 51, 'PPL', 'P'),
(191780, 'Loma Linda Estates Colonia', 31.8169994354248, 0.55531139825334, -105.950996398926, -1.84919373292991, 218, 51, 'PPL', 'P'),
(95788, 'Loma Linda Heights Colonia', 26.2360000610352, 0.457904583618497, -98.4010009765625, -1.71742145429917, 218, 51, 'PPL', 'P'),
(191781, 'Loma Linda Number 1 Colonia', 28.6380004882813, 0.499827399708252, -100.420997619629, -1.75267704659991, 218, 51, 'PPL', 'P'),
(191782, 'Loma Linda Number 2 Colonia', 28.6299991607666, 0.499687750198591, -100.416000366211, -1.75258982807421, 218, 51, 'PPL', 'P'),
(191783, 'Loma Linda Number 3 Colonia', 28.621000289917, 0.499530690273303, -100.422996520996, -1.75271193401019, 218, 51, 'PPL', 'P'),
(191784, 'Loma Linda Number 4 Colonia', 28.6270008087158, 0.499635419083171, -100.420997619629, -1.75267704659991, 218, 51, 'PPL', 'P'),
(191785, 'Loma Linda Number 5 Colonia', 28.6270008087158, 0.499635419083171, -100.424003601074, -1.75272951087339, 218, 51, 'PPL', 'P'),
(191786, 'Loma Linda Ranchettes Colonia', 28.6229991912842, 0.499565577683583, -100.426002502441, -1.75276439828367, 218, 51, 'PPL', 'P'),
(95789, 'Loma Linda West Colonia', 26.4209995269775, 0.461133433413622, -98.931999206543, -1.72668912173459, 218, 51, 'PPL', 'P'),
(182880, 'Loma Mar', 37.271110534668, 0.6505035947047, -122.307502746582, -2.13466862281986, 218, 6, 'PPL', 'P'),
(188896, 'Loma Parda', 35.8466682434082, 0.625642386717565, -105.07527923584, -1.83390958511784, 218, 38, 'PPL', 'P'),
(191787, 'Loma Pelona', 29.5352802276611, 0.515487885471867, -104.303611755371, -1.82044144685309, 218, 51, 'PPL', 'P'),
(182881, 'Loma Portal', 32.7438888549805, 0.571488670426485, -117.218063354492, -2.0458411483472, 218, 6, 'PPL', 'P'),
(182882, 'Loma Rica', 39.311939239502, 0.686122775073265, -121.41667175293, -2.11912068890182, 218, 6, 'PPL', 'P'),
(191788, 'Loma Terrace', 31.7313899993896, 0.553817231723751, -106.331390380859, -1.85583286036942, 218, 51, 'PPL', 'P'),
(33122, 'Loma Vista', 39.163890838623, 0.683538843025615, -94.7891693115234, -1.65438309971645, 218, 20, 'PPL', 'P'),
(95790, 'Loma Vista', 29.021110534668, 0.506513931415168, -98.2461090087891, -1.71471807947663, 218, 51, 'PPL', 'P'),
(95791, 'Loma Vista Colonia', 26.4169998168945, 0.461063625303549, -98.9810028076172, -1.72754439591867, 218, 51, 'PPL', 'P'),
(95793, 'Loma Vista Number 1 Colonia', 26.4169998168945, 0.461063625303549, -98.9800033569336, -1.72752695221353, 218, 51, 'PPL', 'P'),
(150364, 'Lomala', 41.5597190856934, 0.725353934249277, -73.841667175293, -1.28878021737068, 218, 40, 'PPL', 'P'),
(136565, 'Loman', 48.5127792358398, 0.846707726958544, -93.8027801513672, -1.63716736116574, 218, 28, 'PPL', 'P'),
(3851, 'Lomax', 32.8788909912109, 0.573844902200933, -86.6608276367188, -1.51251677476404, 218, 2, 'PPL', 'P'),
(66460, 'Lomax', 36.2933311462402, 0.6334381250185, -81.001106262207, -1.41373600203331, 218, 33, 'PPL', 'P'),
(110168, 'Lomax', 37.3186111450195, 0.651332636752042, -81.7080612182617, -1.42607469367976, 218, 58, 'PPL', 'P'),
(120411, 'Lomax', 40.6788902282715, 0.709980570540685, -91.0727767944336, -1.58951981399675, 218, 18, 'PPL', 'P'),
(123093, 'Lomax', 41.2588882446289, 0.720103445581158, -86.8716735839844, -1.51619673075831, 218, 19, 'PPL', 'P'),
(191789, 'Lomax', 32.1163902282715, 0.560536753338671, -101.639717102051, -1.77394771422638, 218, 51, 'PPL', 'P'),
(88654, 'Lomax Crossroads', 35.5566711425781, 0.620580982486842, -87.5788879394531, -1.52853994977861, 218, 50, 'PPL', 'P'),
(22733, 'Lombard', 32.4255599975586, 0.565932783760362, -82.3252792358398, -1.43684718028913, 218, 13, 'PPL', 'P'),
(49027, 'Lombard', 39.7186088562012, 0.693220498852489, -75.9466705322266, -1.32551945671471, 218, 25, 'PPL', 'P'),
(120413, 'Lombard', 41.8800010681152, 0.730943909377353, -88.0077819824219, -1.5360255629706, 218, 18, 'PPL', 'P'),
(150365, 'Lombard', 42.2502784729004, 0.737406469236594, -79.6369400024414, -1.38992680925578, 218, 40, 'PPL', 'P'),
(175041, 'Lombard', 44.959171295166, 0.78468556806877, -90.7391662597656, -1.58369721174746, 218, 57, 'PPL', 'P'),
(182886, 'Lombard', 38.1908302307129, 0.666555731596126, -122.254997253418, -2.13375222908877, 218, 6, 'PPL', 'P'),
(196937, 'Lombard', 46.1074981689453, 0.804727652905352, -111.398063659668, -1.94426299120745, 218, 31, 'PPL', 'P'),
(49028, 'Lombard Acres', 39.7174987792969, 0.693201124355559, -75.940559387207, -1.32541279711305, 218, 25, 'PPL', 'P'),
(186997, 'Lombard Village', 38.2249984741211, 0.667152079943222, -104.544441223145, -1.82464471400156, 218, 7, 'PPL', 'P'),
(49029, 'Lombardee Beach', 39.1602783203125, 0.683475792686808, -76.5366668701172, -1.33581683538561, 218, 25, 'PPL', 'P'),
(182887, 'Lombardi', 38.4461097717285, 0.671011200099828, -120.065277099609, -2.09553440270753, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(73270, 'Lombardsville', 38.8208312988281, 0.677551324525817, -83.133056640625, -1.45094555562584, 218, 41, 'PPL', 'P'),
(120415, 'Lombardville', 41.2211112976074, 0.719444113474282, -89.658332824707, -1.56483310964005, 218, 18, 'PPL', 'P'),
(60674, 'Lombardy', 33.9055595397949, 0.591763648700395, -90.6069412231445, -1.58138944950485, 218, 30, 'PPL', 'P'),
(103787, 'Lombardy Grove', 36.6841697692871, 0.640259545834629, -78.2063903808594, -1.36495900824602, 218, 53, 'PPL', 'P'),
(95795, 'Lometa', 31.2169399261475, 0.544838384108549, -98.3930587768555, -1.71728283676443, 218, 51, 'PPL', 'P'),
(175042, 'Lomira', 43.5913887023926, 0.760813258373409, -88.4436111450195, -1.54363221683414, 218, 57, 'PPL', 'P'),
(182890, 'Lomita', 32.708610534668, 0.570872947582459, -117.027778625488, -2.04252005330981, 218, 6, 'PPL', 'P'),
(182891, 'Lomita Park', 37.6166687011719, 0.656534722467348, -122.403327941895, -2.13634108798443, 218, 6, 'PPL', 'P'),
(145643, 'Lommasons Glen', 40.7941703796387, 0.71199258874424, -75.0833282470703, -1.31045129126704, 218, 37, 'PPL', 'P'),
(193745, 'Lomo', 40.0386085510254, 0.698805547132549, -121.61499786377, -2.12258213252865, 218, 6, 'PPL', 'P'),
(150366, 'Lomond Shore', 43.372501373291, 0.75699295378969, -78.0805587768555, -1.36276283245308, 218, 40, 'PPL', 'P'),
(150367, 'Lomontville', 41.889720916748, 0.731113552738791, -74.1269378662109, -1.29375913018664, 218, 40, 'PPL', 'P'),
(182893, 'Lompico', 37.1055603027344, 0.647614198080019, -122.051666259766, -2.13020343377818, 218, 6, 'PPL', 'P'),
(182894, 'Lompoc', 34.6391716003418, 0.604567594589278, -120.456939697266, -2.10237020459355, 218, 6, 'PPL', 'P'),
(55971, 'Lon', 37.1836090087891, 0.648976404977594, -93.0591735839844, -1.62418897822546, 218, 29, 'PPL', 'P'),
(188897, 'Lon', 34.1500015258789, 0.596029966187674, -105.123329162598, -1.8347482145451, 218, 38, 'PPL', 'P'),
(207942, 'Lona Beach', 48.2044410705566, 0.841326210764794, -122.445281982422, -2.13707332412615, 218, 56, 'PPL', 'P'),
(49030, 'Lonaconing', 39.5658302307129, 0.690554008811048, -78.9805603027344, -1.37847082235264, 218, 25, 'PPL', 'P'),
(3853, 'London', 32.2730598449707, 0.56327115398791, -86.0502777099609, -1.5018606682943, 218, 2, 'PPL', 'P'),
(10161, 'London', 35.3288917541504, 0.616605482190599, -93.2527770996094, -1.62756799701655, 218, 4, 'PPL', 'P'),
(30369, 'London', 39.625560760498, 0.691596503219759, -85.920280456543, -1.49959178820361, 218, 19, 'PPL', 'P'),
(36955, 'London', 37.1288909912109, 0.648021395410692, -84.0833282470703, -1.46753092394653, 218, 21, 'PPL', 'P'),
(88656, 'London', 35.8697204589844, 0.626044723779249, -83.0022201538086, -1.44866202814915, 218, 50, 'PPL', 'P'),
(95797, 'London', 32.2308311462402, 0.56253412415623, -94.9441223144531, -1.65708753980343, 218, 51, 'PPL', 'P'),
(110175, 'London', 38.1944389343262, 0.666618715355906, -81.3688888549805, -1.42015501920873, 218, 58, 'PPL', 'P'),
(131824, 'London', 42.0200004577637, 0.733387359677501, -83.6133270263672, -1.45932785515687, 218, 27, 'PPL', 'P'),
(136567, 'London', 47.2027816772461, 0.823843956367996, -91.5694427490234, -1.59818827018691, 218, 28, 'PPL', 'P'),
(139291, 'London', 40.4449996948242, 0.705898410642784, -95.2347183227539, -1.66215939694143, 218, 29, 'PPL', 'P'),
(156216, 'London', 40.9102783203125, 0.714019054596709, -82.6294403076172, -1.44215579244804, 218, 41, 'PPL', 'P'),
(163937, 'London', 41.1436080932617, 0.718091427377603, -80.1488876342773, -1.39886198102911, 218, 45, 'PPL', 'P'),
(175046, 'London', 43.047779083252, 0.751325480673893, -89.0127792358398, -1.55356607401625, 218, 57, 'PPL', 'P'),
(182897, 'London', 36.4761085510254, 0.636628192530251, -119.442222595215, -2.08466005018647, 218, 6, 'PPL', 'P'),
(201150, 'London', 43.6347198486328, 0.761569529543964, -123.091667175293, -2.14835487397789, 218, 43, 'PPL', 'P'),
(103788, 'London Bridge', 36.8416709899902, 0.643008460711809, -76.0500030517578, -1.32732294940491, 218, 53, 'PPL', 'P'),
(49031, 'London Bridge Estates', 39.4630584716797, 0.688760303237852, -76.9558334350586, -1.34313267205811, 218, 25, 'PPL', 'P'),
(30371, 'London Heights', 39.6286087036133, 0.691649699862533, -85.914436340332, -1.49948978913386, 218, 19, 'PPL', 'P'),
(22730, 'London Hill', 30.8444404602051, 0.538337041965934, -81.6119384765625, -1.42439703535106, 218, 13, 'PPL', 'P'),
(120416, 'London Mills', 40.7105598449707, 0.710533309624931, -90.26611328125, -1.57544087973599, 218, 18, 'PPL', 'P'),
(201151, 'London Springs', 43.6319389343262, 0.761520993433098, -123.089996337891, -2.14832571236395, 218, 43, 'PPL', 'P'),
(103789, 'London Towne', 38.8388900756836, 0.677866509640828, -77.4569396972656, -1.35187862623599, 218, 53, 'PPL', 'P'),
(14140, 'London Village', 39.0694389343262, 0.681890346310856, -75.5311126708984, -1.31826660380199, 218, 10, 'PPL', 'P'),
(49032, 'Londonderry', 39.1372184753418, 0.68307332246707, -77.2083282470703, -1.34753953787192, 218, 25, 'PPL', 'P'),
(144072, 'Londonderry', 42.8650016784668, 0.748135413162141, -71.3744430541992, -1.24571903307297, 218, 36, 'PPL', 'P'),
(156221, 'Londonderry', 40.1547203063965, 0.700832079564045, -81.3005599975586, -1.41896245567259, 218, 41, 'PPL', 'P'),
(172201, 'Londonderry', 43.226390838623, 0.754442843887885, -72.8069381713867, -1.27072078938664, 218, 55, 'PPL', 'P'),
(49034, 'Londontown Terrace', 38.9375, 0.679587577495292, -76.5388870239258, -1.33585558437947, 218, 25, 'PPL', 'P'),
(49035, 'Londontowne', 38.9333305358887, 0.679514806618506, -76.5497207641602, -1.33604466881686, 218, 25, 'PPL', 'P'),
(49036, 'Londontowne (historical)', 38.9319381713867, 0.679490505273559, -76.5527801513672, -1.33609806519672, 218, 25, 'PPL', 'P'),
(36956, 'Lone', 37.5299987792969, 0.655022046968183, -83.603889465332, -1.45916313864345, 218, 21, 'PPL', 'P'),
(103790, 'Lone Ash', 36.9191703796387, 0.64436108022946, -80.8280563354492, -1.41071571104105, 218, 53, 'PPL', 'P'),
(178551, 'Lone Butte Ranch', 33.2324981689453, 0.580016511711082, -112.04638671875, -1.95557836320503, 218, 5, 'PPL', 'P'),
(95798, 'Lone Camp', 32.6791687011719, 0.570359090650128, -98.2683334350586, -1.7151059688894, 218, 51, 'PPL', 'P'),
(95799, 'Lone Cedar', 32.148609161377, 0.561099079802841, -96.751106262207, -1.68862535922242, 218, 51, 'PPL', 'P'),
(110169, 'Lone Cedar', 39.0847206115723, 0.682157061894028, -81.7527770996094, -1.4268551330372, 218, 58, 'PPL', 'P'),
(76434, 'Lone Chimney (historical)', 36.2347183227539, 0.632415138264773, -96.7911071777344, -1.68932350690218, 218, 42, 'PPL', 'P'),
(139292, 'Lone Corner', 40.1155586242676, 0.700148579270276, -95.0022201538086, -1.65810153838847, 218, 29, 'PPL', 'P'),
(127993, 'Lone Creek Village (historical)', 43.6311111450195, 0.761506545784184, -70.3230590820313, -1.22736892105595, 218, 26, 'PPL', 'P'),
(201153, 'Lone Elder', 45.2305603027344, 0.789422199804558, -122.679718017578, -2.14116500482495, 218, 43, 'PPL', 'P'),
(10163, 'Lone Elm', 34.9416694641113, 0.609847178292305, -94.0269393920898, -1.64107967796512, 218, 4, 'PPL', 'P'),
(33124, 'Lone Elm', 39.9583282470703, 0.697404391504031, -96.6555633544922, -1.68695782090586, 218, 20, 'PPL', 'P'),
(55973, 'Lone Elm', 37.1141700744629, 0.647764466944527, -94.5255584716797, -1.64978222261723, 218, 29, 'PPL', 'P'),
(10164, 'Lone Elm (historical)', 36.2094383239746, 0.631973919051174, -94.4866714477539, -1.64910351601342, 218, 4, 'PPL', 'P'),
(103791, 'Lone Fountain', 38.2466697692871, 0.66753031539704, -79.1836090087891, -1.38201469081521, 218, 53, 'PPL', 'P'),
(10165, 'Lone Grove', 35.314998626709, 0.616363001373348, -92.7016677856445, -1.61794932494946, 218, 4, 'PPL', 'P'),
(76435, 'Lone Grove', 34.1752815246582, 0.596471185401273, -97.2624969482422, -1.69755081045776, 218, 42, 'PPL', 'P'),
(95800, 'Lone Grove', 30.8125, 0.537779575770753, -98.5752792358398, -1.72046318373821, 218, 51, 'PPL', 'P'),
(66461, 'Lone Hickory', 36.0577812194824, 0.629327003243744, -80.7172164916992, -1.40878119082522, 218, 33, 'PPL', 'P'),
(55975, 'Lone Hill', 36.7011108398438, 0.640555223294655, -90.5372161865234, -1.58017251804474, 218, 29, 'PPL', 'P'),
(49038, 'Lone Holly', 38.290828704834, 0.668301034216509, -76.9161071777344, -1.34243931806831, 218, 25, 'PPL', 'P'),
(55976, 'Lone Jack', 38.8708305358887, 0.678423975836009, -94.1736068725586, -1.64363950840491, 218, 29, 'PPL', 'P'),
(88658, 'Lone Mountain', 36.2605590820313, 0.632866144595378, -84.4897232055664, -1.47462385403579, 218, 50, 'PPL', 'P'),
(178552, 'Lone Mountain Ranch', 33.7700004577637, 0.589397696387968, -111.956939697266, -1.95401721817403, 218, 5, 'PPL', 'P'),
(22731, 'Lone Oak', 33.1716690063477, 0.578954842542522, -84.8161087036133, -1.48032035560747, 218, 13, 'PPL', 'P'),
(33126, 'Lone Oak', 37.436939239502, 0.653397851598371, -94.7416687011719, -1.65355405766911, 218, 20, 'PPL', 'P'),
(36958, 'Lone Oak', 37.0361099243164, 0.646402060309869, -88.6647186279297, -1.54749127041172, 218, 21, 'PPL', 'P'),
(49039, 'Lone Oak', 39.019718170166, 0.681022555269654, -77.1183319091797, -1.34596880546099, 218, 25, 'PPL', 'P'),
(76438, 'Lone Oak', 35.3905601501465, 0.617681798745155, -94.5486068725586, -1.65018449309989, 218, 42, 'PPL', 'P'),
(82153, 'Lone Oak', 34.9922218322754, 0.610729483561449, -81.9800033569336, -1.4308209793745, 218, 48, 'PPL', 'P'),
(88659, 'Lone Oak', 35.2005615234375, 0.614365697134815, -85.3641662597656, -1.48988576445276, 218, 50, 'PPL', 'P'),
(95806, 'Lone Oak', 32.1186103820801, 0.560575502332531, -96.7594375610352, -1.68877076781794, 218, 51, 'PPL', 'P'),
(103793, 'Lone Oak', 37.3091697692871, 0.651167853659593, -79.9894409179688, -1.39607911084803, 218, 53, 'PPL', 'P'),
(110170, 'Lone Oak', 39.9002799987793, 0.696391258446338, -80.6011123657227, -1.40675479155178, 218, 58, 'PPL', 'P'),
(82152, 'Lone Oak Estates', 34.4708290100098, 0.601629462116648, -82.6097183227539, -1.44181157887714, 218, 48, 'PPL', 'P'),
(103794, 'Lone Oak Mill', 37.1927795410156, 0.649136460959108, -77.1100006103516, -1.34582339686547, 218, 53, 'PPL', 'P'),
(110171, 'Lone Oak Park', 38.3713912963867, 0.669707116693044, -81.8302764892578, -1.42820775255486, 218, 58, 'PPL', 'P'),
(3854, 'Lone Oak Subdivision', 33.999439239502, 0.593402158561066, -87.1841735839844, -1.52165088467079, 218, 2, 'PPL', 'P'),
(10170, 'Lone Pine', 35.103889465332, 0.612678451426196, -93.3216705322266, -1.62877041424872, 218, 4, 'PPL', 'P'),
(41854, 'Lone Pine', 29.9958305358887, 0.523526004721512, -93.6305618286133, -1.63416158440142, 218, 22, 'PPL', 'P'),
(60675, 'Lone Pine', 34.9711112976074, 0.610361035224636, -88.7425003051758, -1.54884881677739, 218, 30, 'PPL', 'P'),
(76439, 'Lone Pine', 34.1888885498047, 0.596708672791481, -95.8141708374023, -1.672272751181, 218, 42, 'PPL', 'P'),
(95808, 'Lone Pine', 32.8444404602051, 0.57324362700582, -94.9066696166992, -1.65643386691387, 218, 51, 'PPL', 'P'),
(163939, 'Lone Pine', 40.0741691589355, 0.699426196824592, -80.1725006103516, -1.3992741052078, 218, 45, 'PPL', 'P'),
(182899, 'Lone Pine', 36.6061096191406, 0.638897139199971, -118.061943054199, -2.06056962759783, 218, 6, 'PPL', 'P'),
(195257, 'Lone Pine', 44.1861114501953, 0.771193128459075, -112.934173583984, -1.97107316705933, 218, 17, 'PPL', 'P'),
(207944, 'Lone Pine', 47.2227783203125, 0.824192963628851, -117.149169921875, -2.04463873111503, 218, 56, 'PPL', 'P'),
(186999, 'Lone Pine Estates', 39.5950012207031, 0.691063138632444, -105.244720458984, -1.83686689235032, 218, 7, 'PPL', 'P'),
(116598, 'Lone Pine Mobile Home Court', 41.7216682434082, 0.728180480272232, -92.4533309936523, -1.61361503027535, 218, 16, 'PPL', 'P'),
(10172, 'Lone Rock', 36.1805610656738, 0.631469915814877, -92.3444366455078, -1.61171446536342, 218, 4, 'PPL', 'P'),
(116599, 'Lone Rock', 43.2186088562012, 0.754307022672291, -94.3266677856445, -1.64631092529437, 218, 16, 'PPL', 'P'),
(175048, 'Lone Rock', 43.1833305358887, 0.753691299828265, -90.1977767944336, -1.5742481830418, 218, 57, 'PPL', 'P'),
(195258, 'Lone Rock', 42.7675018310547, 0.746433719804608, -112.820281982422, -1.9690853836217, 218, 17, 'PPL', 'P'),
(10174, 'Lone Sasafras (historical)', 33.4997215270996, 0.584680439149111, -91.7936096191406, -1.60210072014434, 218, 4, 'PPL', 'P'),
(10176, 'Lone Star', 36.0036087036133, 0.628381514477739, -91.9897232055664, -1.60552354793537, 218, 4, 'PPL', 'P'),
(33127, 'Lone Star', 38.8666687011719, 0.678351338117277, -95.3550033569336, -1.66425876682874, 218, 20, 'PPL', 'P'),
(36959, 'Lone Star', 37.4047203063965, 0.652835525134201, -85.9466705322266, -1.50005238191414, 218, 21, 'PPL', 'P'),
(41853, 'Lone Star', 29.9274997711182, 0.522333407895861, -90.3405609130859, -1.57674023603184, 218, 22, 'PPL', 'P'),
(60676, 'Lone Star', 31.6386108398438, 0.552197929912442, -89.7377777099609, -1.5662196844616, 218, 30, 'PPL', 'P'),
(82154, 'Lone Star', 33.6252784729004, 0.586871821252083, -80.5897216796875, -1.4065559865764, 218, 48, 'PPL', 'P'),
(88661, 'Lone Star', 36.4724998474121, 0.636565208770471, -82.6227798461914, -1.44203954546645, 218, 50, 'PPL', 'P'),
(103796, 'Lone Star', 36.690559387207, 0.640371065705276, -82.2275009155273, -1.4351406266626, 218, 53, 'PPL', 'P'),
(139293, 'Lone Star', 40.3413887023926, 0.704090057683593, -94.253059387207, -1.64502621638451, 218, 29, 'PPL', 'P'),
(178553, 'Lone Star', 32.8163909912109, 0.572754071418436, -109.680557250977, -1.91428684945168, 218, 5, 'PPL', 'P'),
(182901, 'Lone Star', 39.7094383239746, 0.693060442870976, -122.808059692383, -2.14340498961781, 218, 6, 'PPL', 'P'),
(191790, 'Lone Star', 34.274169921875, 0.598197113524726, -101.415832519531, -1.77004019111696, 218, 51, 'PPL', 'P'),
(194298, 'Lone Star', 40.3519401550293, 0.704274215272972, -102.850830078125, -1.7950856232725, 218, 7, 'PPL', 'P'),
(193746, 'Lone Star Junction', 40.6327781677246, 0.709175763259263, -123.876106262207, -2.16204591882588, 218, 6, 'PPL', 'P'),
(103797, 'Lone Star Lakes', 36.8686103820801, 0.643478641802262, -76.5652770996094, -1.33631617809, 218, 53, 'PPL', 'P'),
(14141, 'Lone Star Mobile Home Park', 39.1147193908691, 0.682680639364337, -75.5374984741211, -1.31837805709361, 218, 10, 'PPL', 'P'),
(30370, 'Lone Tree', 39.1258316040039, 0.682874584070722, -87.1288909912109, -1.52068602140786, 218, 19, 'PPL', 'P'),
(55980, 'Lone Tree', 38.5722198486328, 0.673212236161751, -94.3608322143555, -1.64690720706243, 218, 29, 'PPL', 'P'),
(116600, 'Lone Tree', 41.4880599975586, 0.724103247222348, -91.4258270263672, -1.59568170296892, 218, 16, 'PPL', 'P'),
(120417, 'Lone Tree', 40.8369407653809, 0.712739072797789, -91.0180587768555, -1.58856480442985, 218, 18, 'PPL', 'P'),
(170779, 'Lone Tree', 43.978889465332, 0.767576422540693, -96.728889465332, -1.6882376029677, 218, 49, 'PPL', 'P'),
(187000, 'Lone Tree', 39.5361099243164, 0.690035291609727, -104.89582824707, -1.83077757451785, 218, 7, 'PPL', 'P'),
(196938, 'Lone Tree (historical)', 48.3805618286133, 0.84440009787399, -112.055557250977, -1.95573841918655, 218, 31, 'PPL', 'P'),
(120418, 'Lone Tree Corners', 41.1847190856934, 0.718808949554298, -89.4855575561523, -1.56181761233775, 218, 18, 'PPL', 'P'),
(192675, 'Lone Tree Crossing', 38.764720916748, 0.676572013613968, -111.126106262207, -1.9395164391966, 218, 52, 'PPL', 'P'),
(209574, 'Lone Tree Crossing', 44.4480590820313, 0.775764977102414, -108.703330993652, -1.89723103372443, 218, 59, 'PPL', 'P'),
(10177, 'Lone Valley', 34.4650001525879, 0.601527729363007, -94.3236083984375, -1.64625752891451, 218, 4, 'PPL', 'P'),
(110172, 'Lone Valley', 39.2805595397949, 0.68557509599509, -81.1727828979492, -1.41673232457576, 218, 58, 'PPL', 'P'),
(95816, 'Lone Willow', 32.2686080932617, 0.563193456263106, -97.4744415283203, -1.70124994121188, 218, 51, 'PPL', 'P'),
(76443, 'Lone Wolf', 34.9894409179688, 0.610680947450582, -99.2491683959961, -1.73222476837643, 218, 42, 'PPL', 'P'),
(188898, 'Lone Wolf', 33.6925010681152, 0.588045076870317, -103.839996337891, -1.81234983135505, 218, 38, 'PPL', 'P'),
(182902, 'Lone Wolf Colony', 34.4705581665039, 0.601624735005713, -117.154998779297, -2.04474046386867, 218, 6, 'PPL', 'P'),
(55981, 'Lonedell', 38.3080596923828, 0.668601771682606, -90.8274993896484, -1.58523891570251, 218, 29, 'PPL', 'P'),
(163940, 'Lonely Acres', 40.5508308410645, 0.707745512595836, -78.6930618286133, -1.37345302738477, 218, 45, 'PPL', 'P'),
(150368, 'Lonelyville', 40.6408309936523, 0.709316311585792, -73.1752777099609, -1.27714952710003, 218, 40, 'PPL', 'P'),
(196939, 'Lonepine', 47.7030601501465, 0.832575462896957, -114.635833740234, -2.0007727395359, 218, 31, 'PPL', 'P'),
(201154, 'Lonerock', 45.089168548584, 0.786954448159463, -119.881942749023, -2.0923346146578, 218, 43, 'PPL', 'P'),
(103798, 'Lonesome (historical)', 36.9091682434082, 0.644186510020005, -82.3291702270508, -1.43691509089692, 218, 53, 'PPL', 'P'),
(196940, 'Lonesome Hurst Summer Home Area', 44.7388916015625, 0.780840962140105, -111.236106872559, -1.94143631202644, 218, 31, 'PPL', 'P'),
(196941, 'Lonesome Prairie (historical)', 48.2444381713867, 0.842024291865531, -110.266670227051, -1.92451645067284, 218, 31, 'PPL', 'P'),
(112979, 'Lonetown', 41.3216705322266, 0.721199203211671, -73.3819427490234, -1.28075651248044, 218, 8, 'PPL', 'P'),
(110173, 'Lonetree', 39.5283317565918, 0.689899536973161, -80.8183288574219, -1.41054593452156, 218, 58, 'PPL', 'P'),
(187001, 'Lonetree', 37.1680603027344, 0.648705028862515, -107.172218322754, -1.87050807639825, 218, 7, 'PPL', 'P'),
(198544, 'Lonetree', 48.2825012207031, 0.842688617399451, -101.643333435059, -1.77401083114421, 218, 34, 'PPL', 'P'),
(209575, 'Lonetree', 41.0544395446777, 0.716535142615588, -110.153327941895, -1.92253825461513, 218, 59, 'PPL', 'P'),
(110174, 'Lonetree (historical)', 38.8347206115723, 0.677793738764042, -79.9400024414063, -1.39521624665484, 218, 58, 'PPL', 'P'),
(196942, 'Lonetree (historical)', 47.5416717529297, 0.829758703991007, -110.283332824707, -1.92480726786388, 218, 31, 'PPL', 'P'),
(88662, 'Lonewood', 35.7750015258789, 0.624391566532582, -85.2936096191406, -1.48865431876471, 218, 50, 'PPL', 'P'),
(10178, 'Long', 33.6583290100098, 0.587448661944194, -94.0266723632813, -1.64107501743322, 218, 4, 'PPL', 'P'),
(60677, 'Long', 33.4430618286133, 0.583691540857337, -90.7944412231445, -1.58466194185234, 218, 30, 'PPL', 'P'),
(76442, 'Long', 35.497501373291, 0.619548275195137, -94.5844421386719, -1.65080993648189, 218, 42, 'PPL', 'P'),
(156219, 'Long', 40.0780601501465, 0.699494107432389, -84.7980575561523, -1.48000530365051, 218, 41, 'PPL', 'P'),
(207945, 'Long', 46.2916717529297, 0.807942088341078, -118.02555847168, -2.0599345968359, 218, 56, 'PPL', 'P'),
(211972, 'Long', 64.4036102294922, 1.12405504867574, -155.497222900391, -2.71393851731934, 218, 1, 'PPL', 'P'),
(14142, 'Long Acres', 38.7158317565918, 0.675718736800707, -75.1911087036133, -1.31233241510302, 218, 10, 'PPL', 'P'),
(22732, 'Long Acres', 33.3786087036133, 0.582566621612888, -83.8608322143555, -1.46364763560303, 218, 13, 'PPL', 'P'),
(49040, 'Long Bar Harbor', 39.4541702270508, 0.688605174104355, -76.2522201538086, -1.33085230363954, 218, 25, 'PPL', 'P'),
(182903, 'Long Barn', 38.0930595397949, 0.664849311127657, -120.133331298828, -2.09672217255371, 218, 6, 'PPL', 'P'),
(82156, 'Long Bay Estates', 33.6425018310547, 0.587172425560125, -78.9408264160156, -1.37777733520479, 218, 48, 'PPL', 'P'),
(49041, 'Long Beach', 38.4608306884766, 0.671268128565993, -76.4691696166992, -1.33463878607741, 218, 25, 'PPL', 'P'),
(55982, 'Long Beach', 36.707218170166, 0.640661816317285, -93.1297225952148, -1.62542029075546, 218, 29, 'PPL', 'P'),
(60678, 'Long Beach', 30.3502807617188, 0.529712328196685, -89.1527786254883, -1.5560095243164, 218, 30, 'PPL', 'P'),
(66464, 'Long Beach', 33.9102783203125, 0.591846006957105, -78.1180572509766, -1.36341730429097, 218, 33, 'PPL', 'P'),
(71042, 'Long Beach', 39.6855583190918, 0.692643658160378, -74.1452789306641, -1.29407924214967, 218, 37, 'PPL', 'P'),
(123094, 'Long Beach', 41.7388916015625, 0.728481084580275, -86.8569412231445, -1.51593960255506, 218, 19, 'PPL', 'P'),
(127995, 'Long Beach', 43.1672210693359, 0.75341013659618, -70.6227798461914, -1.23260003522713, 218, 26, 'PPL', 'P'),
(136572, 'Long Beach', 45.6547203063965, 0.796825188423733, -95.4172210693359, -1.66534467076322, 218, 28, 'PPL', 'P'),
(150369, 'Long Beach', 40.5883293151855, 0.708399984433723, -73.658332824707, -1.28558042932095, 218, 40, 'PPL', 'P'),
(156220, 'Long Beach', 41.6141700744629, 0.726304283284271, -83.1122207641602, -1.45058190097899, 218, 41, 'PPL', 'P'),
(182904, 'Long Beach', 33.7669410705566, 0.589344300008112, -118.188331604004, -2.06277552392874, 218, 6, 'PPL', 'P'),
(207946, 'Long Beach', 46.3525009155273, 0.809003757509638, -124.053062438965, -2.16513438674204, 218, 56, 'PPL', 'P'),
(49042, 'Long Beach Estates', 39.311939239502, 0.686122775073265, -76.3955612182617, -1.33335407716756, 218, 25, 'PPL', 'P'),
(16933, 'Long Beach Resort', 30.1791706085205, 0.526725892639784, -85.8083267211914, -1.49763782691182, 218, 12, 'PPL', 'P'),
(66465, 'Long Bluff Landing', 34.4233283996582, 0.600800420069306, -78.1374969482422, -1.36375659101385, 218, 33, 'PPL', 'P'),
(36960, 'Long Bottom', 36.8822212219238, 0.643716195771497, -85.1297225952148, -1.48579395059591, 218, 21, 'PPL', 'P'),
(73275, 'Long Bottom', 39.086109161377, 0.682181296659948, -81.8038864135742, -1.42774715884433, 218, 41, 'PPL', 'P'),
(82157, 'Long Bottom Ford', 34.8994407653809, 0.609110148460626, -83.1858291625977, -1.45186660988885, 218, 48, 'PPL', 'P'),
(113, 'Long Branch', 38.1875, 0.666497608105335, -77.3936080932617, -1.35077328122555, 218, 53, 'PPL', 'P'),
(426, 'Long Branch', 30.8977794647217, 0.539267983214484, -84.2061080932617, -1.46967383651766, 218, 13, 'PPL', 'P'),
(765, 'Long Branch', 34.5533294677734, 0.603069366739026, -78.9694366455078, -1.37827667790918, 218, 33, 'PPL', 'P'),
(16934, 'Long Branch', 30.3724994659424, 0.530100117740914, -82.6933288574219, -1.44327085799645, 218, 12, 'PPL', 'P'),
(60679, 'Long Branch', 34.1347198486328, 0.595763250604503, -89.8466720581055, -1.56812024937353, 218, 30, 'PPL', 'P'),
(82159, 'Long Branch', 34.5136108398438, 0.602376145907279, -81.8955612182617, -1.42934718602725, 218, 48, 'PPL', 'P'),
(88664, 'Long Branch', 35.1561088562012, 0.613589851730248, -87.4247207641602, -1.52584922497125, 218, 50, 'PPL', 'P'),
(95818, 'Long Branch', 32.0727806091309, 0.559775621899126, -94.5677795410156, -1.65051911929085, 218, 51, 'PPL', 'P'),
(110176, 'Long Branch', 37.6177787780762, 0.656554096964278, -81.7644424438477, -1.42705873170254, 218, 58, 'PPL', 'P'),
(120420, 'Long Branch', 40.2172203063965, 0.701922910346541, -90.0377807617188, -1.5714557254808, 218, 18, 'PPL', 'P'),
(145646, 'Long Branch', 40.3041687011719, 0.703440446114696, -73.9927825927734, -1.29141767895624, 218, 37, 'PPL', 'P'),
(150371, 'Long Branch', 43.1180610656738, 0.752552132671983, -76.2436065673828, -1.330701968196, 218, 40, 'PPL', 'P'),
(163942, 'Long Branch', 40.1036109924316, 0.699940053756923, -79.8694381713867, -1.39398466780874, 218, 45, 'PPL', 'P'),
(82160, 'Long Branch Estates', 32.7975006103516, 0.572424372075485, -80.0541687011719, -1.39720882378244, 218, 48, 'PPL', 'P'),
(41856, 'Long Bridge', 30.2397193908691, 0.527782668249841, -91.9658279418945, -1.60510649690866, 218, 22, 'PPL', 'P'),
(145645, 'Long Bridge', 40.9199981689453, 0.714188697958147, -74.8405609130859, -1.30621420197272, 218, 37, 'PPL', 'P'),
(150372, 'Long Bridge', 42.980281829834, 0.750147431365696, -76.4463882446289, -1.33424117612666, 218, 40, 'PPL', 'P'),
(163944, 'Long Brook', 41.3708305358887, 0.722057207135867, -76.4855575561523, -1.33492480957849, 218, 45, 'PPL', 'P'),
(22734, 'Long Cane', 32.9563903808594, 0.575197521718584, -85.1408309936523, -1.48598782872327, 218, 13, 'PPL', 'P'),
(82161, 'Long Cane (historical)', 34.1483306884766, 0.596000804573738, -82.3324966430664, -1.43697314780869, 218, 48, 'PPL', 'P'),
(49043, 'Long Corner', 39.3338890075684, 0.686505870796073, -77.1555633544922, -1.34661861676697, 218, 25, 'PPL', 'P'),
(127996, 'Long Cove', 43.9900016784668, 0.767770367247078, -69.2050018310547, -1.20785514080061, 218, 26, 'PPL', 'P'),
(49044, 'Long Cove Estates', 38.4527816772461, 0.671127646818492, -76.5833282470703, -1.33663123004695, 218, 25, 'PPL', 'P'),
(82162, 'Long Cove Plantation', 32.1722183227539, 0.561511137402503, -80.7452774047852, -1.40927094614968, 218, 48, 'PPL', 'P'),
(27747, 'Long Creek', 39.811939239502, 0.694849421333236, -88.8475036621094, -1.55068147108153, 218, 18, 'PPL', 'P'),
(66466, 'Long Creek', 34.4419403076172, 0.601125259143269, -78.0100021362305, -1.36153138676503, 218, 33, 'PPL', 'P'),
(88666, 'Long Creek', 36.5572204589844, 0.63804386238671, -86.0930633544922, -1.50260741866396, 218, 50, 'PPL', 'P'),
(201155, 'Long Creek', 44.714168548584, 0.780409463464485, -119.103057861328, -2.07874050887349, 218, 43, 'PPL', 'P'),
(82163, 'Long Creek Landing', 32.9352798461914, 0.574829073381772, -80.4030609130859, -1.40329814161491, 218, 48, 'PPL', 'P'),
(195259, 'Long Creek Summit Home', 44.1327781677246, 0.770262287079065, -115.577217102051, -2.01720297872309, 218, 17, 'PPL', 'P'),
(95819, 'Long Crossing', 29.4822196960449, 0.514561804492306, -99.5497207641602, -1.73747039677556, 218, 51, 'PPL', 'P'),
(150373, 'Long Crossing', 43.2241706848145, 0.754404094894024, -75.7766723632813, -1.32255242894425, 218, 40, 'PPL', 'P'),
(150374, 'Long Eddy', 41.850830078125, 0.730434779555957, -75.1338882446289, -1.31133372969424, 218, 40, 'PPL', 'P'),
(150375, 'Long Flat', 42.0119400024414, 0.733246678192917, -75.0772171020508, -1.31034463166538, 218, 40, 'PPL', 'P'),
(49045, 'Long Green', 39.4727783203125, 0.68892994659929, -76.5233306884766, -1.33558407510634, 218, 25, 'PPL', 'P'),
(49047, 'Long Green Manor', 39.503059387207, 0.689458450917616, -76.4858322143555, -1.33492960326845, 218, 25, 'PPL', 'P'),
(49046, 'Long Green Woods', 39.4911117553711, 0.689249925404263, -76.4638900756836, -1.33454664070369, 218, 25, 'PPL', 'P'),
(116604, 'Long Grove', 41.6974983215332, 0.727758635555564, -90.5824966430664, -1.58096281109822, 218, 16, 'PPL', 'P'),
(120421, 'Long Grove', 42.1783294677734, 0.736150722203594, -87.9977798461914, -1.53585099276115, 218, 18, 'PPL', 'P'),
(16935, 'Long Hammock', 28.9269409179688, 0.504870361548426, -82.1033325195313, -1.43297347932555, 218, 12, 'PPL', 'P'),
(49048, 'Long Hill', 39.1263885498047, 0.682884304608701, -76.5749969482422, -1.33648582145144, 218, 25, 'PPL', 'P'),
(66468, 'Long Hill', 36.4166717529297, 0.635590824706638, -80.5208282470703, -1.40535356934423, 218, 33, 'PPL', 'P'),
(113653, 'Long Hill', 41.353889465332, 0.721761529675841, -72.0527801513672, -1.25755824885698, 218, 8, 'PPL', 'P'),
(145647, 'Long Hill', 40.7077789306641, 0.710484773514064, -74.4300003051758, -1.2990485675857, 218, 37, 'PPL', 'P'),
(88667, 'Long Hollow', 36.375560760498, 0.634873302529943, -84.0994415283203, -1.46781215375764, 218, 50, 'PPL', 'P'),
(95820, 'Long Hollow', 31.2933292388916, 0.54617162912927, -96.2652816772461, -1.68014612062771, 218, 51, 'PPL', 'P'),
(88668, 'Long Hollow (historical)', 36.3763885498047, 0.634887750178857, -83.9119415283203, -1.46453966141015, 218, 50, 'PPL', 'P'),
(170782, 'Long Hollow Housing', 45.6872215270996, 0.79739244173592, -97.1530609130859, -1.69564079132396, 218, 49, 'PPL', 'P'),
(3855, 'Long Island', 34.9736099243164, 0.610404644487486, -85.6711120605469, -1.49524297930157, 218, 2, 'PPL', 'P'),
(33131, 'Long Island', 39.9494400024414, 0.697249262370534, -99.5355606079102, -1.7372232554264, 218, 20, 'PPL', 'P'),
(66470, 'Long Island', 35.6777801513672, 0.622694733444038, -80.9936065673828, -1.41360510766573, 218, 33, 'PPL', 'P'),
(88669, 'Long Island', 36.5194396972656, 0.637384463700806, -82.5524978637695, -1.44081289346836, 218, 50, 'PPL', 'P'),
(103799, 'Long Island', 37.0783309936523, 0.647138956983494, -79.0944366455078, -1.38045833947417, 218, 53, 'PPL', 'P'),
(127997, 'Long Island', 43.6841697692871, 0.762432593474232, -70.1716690063477, -1.22472666578042, 218, 26, 'PPL', 'P'),
(193258, 'Long Island', 54.9169387817383, 0.958481396857497, -132.679168701172, -2.31568834264446, 218, 1, 'PPL', 'P'),
(125262, 'Long Josephs Point', 41.2458305358887, 0.719875545570875, -70.0999984741211, -1.22347577901641, 218, 23, 'PPL', 'P'),
(60681, 'Long Lake', 32.4086112976074, 0.565636973142281, -90.8833312988281, -1.58621336634537, 218, 30, 'PPL', 'P'),
(95821, 'Long Lake', 31.6494407653809, 0.55238694777081, -95.7808303833008, -1.67169085048282, 218, 51, 'PPL', 'P'),
(120423, 'Long Lake', 42.3708305358887, 0.739510499655811, -88.1275024414063, -1.53811507916188, 218, 18, 'PPL', 'P'),
(131826, 'Long Lake', 44.4197196960449, 0.775270361508959, -83.871940612793, -1.46384151373039, 218, 27, 'PPL', 'P'),
(136573, 'Long Lake', 44.9866714477539, 0.78516553627623, -93.5713882446289, -1.63312881053069, 218, 28, 'PPL', 'P'),
(150377, 'Long Lake', 43.9727783203125, 0.767469762939035, -74.42138671875, -1.29889823214217, 218, 40, 'PPL', 'P'),
(170784, 'Long Lake', 45.8566703796387, 0.800349882126453, -99.204719543457, -1.73144898955089, 218, 49, 'PPL', 'P'),
(175050, 'Long Lake', 45.8427810668945, 0.800107467888228, -88.6677780151367, -1.54754466679158, 218, 57, 'PPL', 'P'),
(207947, 'Long Lake', 47.836109161377, 0.834897606209451, -117.847778320313, -2.05683174784985, 218, 56, 'PPL', 'P'),
(170785, 'Long Lake Colony', 45.6066703796387, 0.795986558996467, -98.8191680908203, -1.72471984726653, 218, 49, 'PPL', 'P'),
(131827, 'Long Lake Heights', 44.0991706848145, 0.769675725848975, -84.7744369506836, -1.47959304631377, 218, 27, 'PPL', 'P'),
(123095, 'Long Lake Island', 41.521671295166, 0.724689875031465, -87.0483322143555, -1.51928000551035, 218, 19, 'PPL', 'P'),
(55983, 'Long Lane', 37.6113891601563, 0.656442577093631, -92.9091720581055, -1.62157095771586, 218, 29, 'PPL', 'P'),
(163945, 'Long Lane Acres', 40.310001373291, 0.703542245447364, -76.716667175293, -1.33895843336552, 218, 45, 'PPL', 'P'),
(103800, 'Long Level Estates', 38.8327789306641, 0.677759850039171, -77.6230621337891, -1.35477800971475, 218, 53, 'PPL', 'P'),
(49049, 'Long Meadow', 39.6861114501953, 0.69265331211933, -77.7125015258789, -1.3563390215877, 218, 25, 'PPL', 'P'),
(49050, 'Long Meadow West', 39.396110534668, 0.68759184130958, -76.716667175293, -1.33895843336552, 218, 25, 'PPL', 'P'),
(49051, 'Long Meadows', 39.4038887023926, 0.687727595946147, -76.940559387207, -1.34286608963299, 218, 25, 'PPL', 'P'),
(82166, 'Long Meadows', 34.5333290100098, 0.602720292899144, -82.6069412231445, -1.4417631093453, 218, 48, 'PPL', 'P'),
(88670, 'Long Meadows', 36.1824989318848, 0.631503737960721, -85.5833282470703, -1.49371086272644, 218, 50, 'PPL', 'P'),
(103801, 'Long Meadows', 37.3772201538086, 0.652355556926741, -79.2013931274414, -1.38232508224026, 218, 53, 'PPL', 'P'),
(49052, 'Long Meadows Estates', 39.3883285522461, 0.687456020093986, -76.7136077880859, -1.33890503698566, 218, 25, 'PPL', 'P'),
(95822, 'Long Mott', 28.4822196960449, 0.497108511972362, -96.7602767944336, -1.68878541520393, 218, 51, 'PPL', 'P'),
(103803, 'Long Mountain Estates', 37.2924995422363, 0.650876903310502, -79.0511093139648, -1.37970213488264, 218, 53, 'PPL', 'P'),
(14143, 'Long Neck', 38.6199989318848, 0.674046138478082, -75.1511077880859, -1.31163426742325, 218, 10, 'PPL', 'P'),
(14144, 'Long Neck Village Mobile Home Park', 38.6294403076172, 0.674210921570531, -75.1711120605469, -1.31198340784216, 218, 10, 'PPL', 'P'),
(66472, 'Long Pine', 34.8238906860352, 0.6077915508259, -80.225830078125, -1.40020488000878, 218, 33, 'PPL', 'P'),
(113296, 'Long Pine', 40.1100006103516, 0.70005157362757, -80.1750030517578, -1.39931778104968, 218, 45, 'PPL', 'P'),
(142299, 'Long Pine', 42.5363883972168, 0.742400029438547, -99.7002792358398, -1.74009813782314, 218, 35, 'PPL', 'P'),
(125263, 'Long Plain', 41.7374992370605, 0.728456783235328, -70.8958282470703, -1.23736562883978, 218, 23, 'PPL', 'P'),
(16936, 'Long Point', 30.1124992370605, 0.525562257690987, -85.602783203125, -1.49405041576543, 218, 12, 'PPL', 'P'),
(49053, 'Long Point', 39.0966682434082, 0.682365587407381, -76.445556640625, -1.33422666189872, 218, 25, 'PPL', 'P'),
(82164, 'Long Point', 34.0244407653809, 0.593838517505676, -78.8805618286133, -1.37672551973226, 218, 48, 'PPL', 'P'),
(95823, 'Long Point', 29.3905601501465, 0.512962043625495, -95.732780456543, -1.67085222105556, 218, 51, 'PPL', 'P'),
(116603, 'Long Point', 41.9452781677246, 0.732083209691689, -92.4836120605469, -1.61414353459368, 218, 16, 'PPL', 'P'),
(120424, 'Long Point', 41.0047187805176, 0.715667351574386, -88.8916702270508, -1.55145232305905, 218, 18, 'PPL', 'P'),
(131829, 'Long Point', 45.5213890075684, 0.794498118263222, -84.5480575561523, -1.47564198052053, 218, 27, 'PPL', 'P'),
(136577, 'Long Point', 48.9772186279297, 0.854813723526473, -94.959716796875, -1.65735971486683, 218, 28, 'PPL', 'P'),
(150378, 'Long Point Cove', 42.7747192382813, 0.746559687324169, -77.7247161865234, -1.35655220763297, 218, 40, 'PPL', 'P'),
(14145, 'Long Point Landing', 39.3074989318848, 0.686045277085543, -75.6208267211914, -1.3198324093649, 218, 10, 'PPL', 'P'),
(49054, 'Long Point on the Magothy', 39.1036109924316, 0.68248676123698, -76.4558334350586, -1.33440602579814, 218, 25, 'PPL', 'P'),
(22735, 'Long Pond', 32.0811080932617, 0.559920963915617, -82.5455627441406, -1.44069185279682, 218, 13, 'PPL', 'P'),
(127999, 'Long Pond', 45.6213912963867, 0.796243487462633, -70.0869369506836, -1.2232478124271, 218, 26, 'PPL', 'P'),
(163946, 'Long Pond', 41.0533294677734, 0.716515768118658, -75.4633331298828, -1.31708362764577, 218, 45, 'PPL', 'P'),
(125264, 'Long Pond Park', 42.6958312988281, 0.745182833040598, -71.3638916015625, -1.24553487548359, 218, 23, 'PPL', 'P'),
(136578, 'Long Prairie', 45.9747200012207, 0.802410236703793, -94.8652801513672, -1.65571148446818, 218, 28, 'PPL', 'P'),
(131830, 'Long Rapids', 45.1258316040039, 0.787594339190382, -83.7225036621094, -1.46123334691682, 218, 27, 'PPL', 'P'),
(49063, 'Long Reach', 39.214168548584, 0.684416354604796, -76.8158264160156, -1.34068908859991, 218, 25, 'PPL', 'P'),
(110177, 'Long Reach', 39.4841690063477, 0.689128751574664, -81.0927810668945, -1.41533602921623, 218, 58, 'PPL', 'P'),
(36962, 'Long Ridge', 38.5872192382813, 0.673474024896906, -84.8236083984375, -1.48045124997505, 218, 21, 'PPL', 'P'),
(66473, 'Long Ridge', 35.8088912963867, 0.624983054610689, -82.5438919067383, -1.44066269118288, 218, 33, 'PPL', 'P'),
(82165, 'Long Ridge', 33.142219543457, 0.578440852452137, -80.1611099243164, -1.39907530023242, 218, 48, 'PPL', 'P'),
(103804, 'Long Ridge', 36.6302795410156, 0.63931898391664, -76.163330078125, -1.32930087914651, 218, 53, 'PPL', 'P'),
(113654, 'Long Ridge', 41.1555595397949, 0.718300019469984, -73.5966720581055, -1.28450424592445, 218, 8, 'PPL', 'P'),
(88671, 'Long Rock', 36.0505599975586, 0.629200969145156, -88.4008331298828, -1.54288559962254, 218, 50, 'PPL', 'P'),
(30372, 'Long Run', 38.753059387207, 0.676368481527659, -85.1177825927734, -1.48558555824061, 218, 19, 'PPL', 'P'),
(36963, 'Long Run', 38.2316703796387, 0.667268526661885, -85.4241714477539, -1.49093305255144, 218, 21, 'PPL', 'P'),
(110180, 'Long Run', 39.1044387817383, 0.682501208885893, -81.0361099243164, -1.41434693118737, 218, 58, 'PPL', 'P'),
(156222, 'Long Run', 40.1949996948242, 0.701535087512799, -80.8158264160156, -1.41050225867968, 218, 41, 'PPL', 'P'),
(163948, 'Long Run', 40.8555603027344, 0.713064045029806, -75.7002792358398, -1.3212191173445, 218, 45, 'PPL', 'P'),
(156223, 'Long Run (historical)', 40.2063903808594, 0.701733892488173, -82.2855606079102, -1.43615395945738, 218, 41, 'PPL', 'P'),
(144075, 'Long Sands', 43.7827796936035, 0.764153661328695, -71.1133270263672, -1.24116169865758, 218, 36, 'PPL', 'P'),
(66474, 'Long Shoals', 35.4147186279297, 0.618103443724742, -81.2405624389648, -1.41791530073197, 218, 33, 'PPL', 'P'),
(120426, 'Long Shore Park', 40.7561111450195, 0.711328329789347, -89.5608291625977, -1.56313134970349, 218, 18, 'PPL', 'P'),
(41857, 'Long Springs', 32.6738891601563, 0.570266945276411, -93.3363876342773, -1.62902727613586, 218, 22, 'PPL', 'P'),
(145649, 'Long Valley', 40.785831451416, 0.711847046990667, -74.7805633544922, -1.3051670470321, 218, 37, 'PPL', 'P'),
(163949, 'Long Valley', 41.6497192382813, 0.726924733239232, -76.5683288574219, -1.3363694413118, 218, 45, 'PPL', 'P'),
(178554, 'Long Valley', 34.5208282470703, 0.602502113426839, -111.328887939453, -1.94305564712726, 218, 5, 'PPL', 'P'),
(202329, 'Long Valley', 43.461669921875, 0.758549238551705, -101.494438171387, -1.77141211855251, 218, 49, 'PPL', 'P'),
(192676, 'Long Valley Junction', 37.4880599975586, 0.654290077142575, -112.510559082031, -1.96367969924105, 218, 52, 'PPL', 'P'),
(36964, 'Long View', 37.7894401550293, 0.659550153190618, -85.9130630493164, -1.49946582068405, 218, 21, 'PPL', 'P'),
(66475, 'Long View', 34.4749984741211, 0.601702232993434, -78.2024993896484, -1.36489109763822, 218, 33, 'PPL', 'P'),
(150380, 'Long View', 42.124439239502, 0.735210160285605, -79.3925018310547, -1.38566055834753, 218, 40, 'PPL', 'P'),
(41858, 'Longacre', 30.8166694641113, 0.537852346647539, -93.1502838134766, -1.62577915171235, 218, 22, 'PPL', 'P'),
(110181, 'Longacre', 38.1674995422363, 0.666148534265453, -81.3036117553711, -1.41901571889439, 218, 58, 'PPL', 'P'),
(16937, 'Longbeach', 27.436939239502, 0.478864926398938, -82.6833267211914, -1.443096287787, 218, 12, 'PPL', 'P'),
(16938, 'Longboat Key', 27.4122200012207, 0.478433494302345, -82.6591720581055, -1.44267470938644, 218, 12, 'PPL', 'P'),
(103805, 'Longbottom', 37.2816696166992, 0.650687885452134, -82.085563659668, -1.43266335421661, 218, 53, 'PPL', 'P'),
(207948, 'Longbranch', 47.209171295166, 0.823955476238643, -122.755561828613, -2.14248872904477, 218, 56, 'PPL', 'P'),
(163950, 'Longbridge', 40.2691688537598, 0.702829583539659, -79.2958297729492, -1.38397331263891, 218, 45, 'PPL', 'P'),
(82168, 'Longcreek', 34.8413887023926, 0.608096948823905, -82.5480575561523, -1.44073539548064, 218, 48, 'PPL', 'P'),
(103813, 'Longcreek (historical)', 37.9311103820801, 0.662022765104702, -77.817497253418, -1.35817154273379, 218, 53, 'PPL', 'P'),
(16939, 'Longdale', 28.7108306884766, 0.501098526496546, -81.3338928222656, -1.41954422321272, 218, 12, 'PPL', 'P'),
(76446, 'Longdale', 36.1333312988281, 0.63064560087847, -98.5502777099609, -1.7200268247936, 218, 42, 'PPL', 'P'),
(103807, 'Longdale', 37.6580581665039, 0.657257104913032, -77.4700012207031, -1.3521065928253, 218, 53, 'PPL', 'P'),
(110182, 'Longdale', 38.9261093139648, 0.679388772519918, -81.9130630493164, -1.42965265060428, 218, 58, 'PPL', 'P'),
(103808, 'Longdale Furnace', 37.810001373291, 0.659909014147506, -79.6836090087891, -1.39074133707518, 218, 53, 'PPL', 'P'),
(49055, 'Longdraft', 39.1380615234375, 0.683088036432092, -77.2444381713867, -1.34816977494389, 218, 25, 'PPL', 'P'),
(49056, 'Longfellow', 39.2294387817383, 0.684682870450886, -76.8786087036133, -1.34178484623042, 218, 25, 'PPL', 'P'),
(163951, 'Longfellow', 40.5044403076172, 0.706935845045425, -77.6738891601563, -1.35566510867386, 218, 45, 'PPL', 'P'),
(191791, 'Longfellow', 30.1616706848145, 0.526420461352265, -102.638061523438, -1.79137211144849, 218, 51, 'PPL', 'P'),
(49057, 'Longfield', 38.4361114501953, 0.670836696469401, -76.0247192382813, -1.32688166361228, 218, 25, 'PPL', 'P'),
(33133, 'Longford', 39.1699981689453, 0.683645436048246, -97.3311080932617, -1.69874830084192, 218, 20, 'PPL', 'P'),
(103809, 'Longfork', 37.1230583190918, 0.647919596078024, -82.4933319091797, -1.43978025275569, 218, 53, 'PPL', 'P'),
(178555, 'Longhaven West', 33.5072212219238, 0.584811333516688, -112.170829772949, -1.95775030423205, 218, 5, 'PPL', 'P'),
(103810, 'Longhollow (historical)', 36.9055595397949, 0.644123526260225, -81.6177825927734, -1.42449903442081, 218, 53, 'PPL', 'P'),
(95824, 'Longhorn', 29.5308303833008, 0.515410221036578, -98.4019393920898, -1.71743783273988, 218, 51, 'PPL', 'P'),
(178556, 'Longhorn Ranch II', 33.6011085510254, 0.586449976535414, -112.198059082031, -1.95822554532857, 218, 5, 'PPL', 'P'),
(10183, 'Longino', 34.982780456543, 0.610564700469, -90.8705596923828, -1.58599045976213, 218, 4, 'PPL', 'P'),
(60682, 'Longino', 32.8050003051758, 0.572555266443062, -89.103889465332, -1.55515624750313, 218, 30, 'PPL', 'P'),
(103811, 'Longist Forks', 37.8908309936523, 0.661319757155948, -76.9069366455078, -1.34227926208679, 218, 53, 'PPL', 'P'),
(41859, 'Longleaf', 31.0063896179199, 0.541163587988889, -92.5524978637695, -1.6153458186678, 218, 22, 'PPL', 'P'),
(82169, 'Longleaf', 33.6202812194824, 0.586784602726383, -78.9902801513672, -1.37864046571408, 218, 48, 'PPL', 'P'),
(3857, 'Longleaf Estates', 34.5444412231445, 0.602914237605529, -86.9963912963867, -1.51837346547529, 218, 2, 'PPL', 'P'),
(156224, 'Longley', 41.2224998474121, 0.719468348240201, -83.4211120605469, -1.45597307113169, 218, 41, 'PPL', 'P'),
(36965, 'Longlick', 38.3424987792969, 0.669202847140637, -84.658332824707, -1.47756664704033, 218, 21, 'PPL', 'P'),
(103812, 'Longmarsh Acres', 39.1819381713867, 0.683853828403544, -77.9722213745117, -1.36087198807913, 218, 53, 'PPL', 'P'),
(163952, 'Longmead Farms', 40.0863914489746, 0.699639516027907, -74.9722213745117, -1.3085121105193, 218, 45, 'PPL', 'P'),
(49059, 'Longmeadow', 39.5558280944824, 0.690379438601593, -76.3494415283203, -1.33254913672808, 218, 25, 'PPL', 'P'),
(125265, 'Longmeadow', 42.0499992370605, 0.73391093714781, -72.5833282470703, -1.26681805996718, 218, 23, 'PPL', 'P'),
(169471, 'Longmeadow', 41.7041702270508, 0.727875082274227, -71.375, -1.24572875361095, 218, 47, 'PPL', 'P'),
(49060, 'Longmeadow North', 39.0736083984375, 0.681963117187643, -76.5327835083008, -1.33574905793587, 218, 25, 'PPL', 'P'),
(207949, 'Longmire', 46.75, 0.815941425307349, -121.811393737793, -2.12600988716769, 218, 56, 'PPL', 'P'),
(194299, 'Longmont', 40.1672210693359, 0.70105025903635, -105.101387023926, -1.83436525198035, 218, 7, 'PPL', 'P'),
(95825, 'Longoria Colonia', 26.3020000457764, 0.459056500658497, -98.6419982910156, -1.72162765092484, 218, 51, 'PPL', 'P'),
(95826, 'Longoria Townsite Colonia', 26.0790004730225, 0.455164423883401, -97.8519973754883, -1.70783953385512, 218, 51, 'PPL', 'P'),
(95827, 'Longpoint', 30.2363891601563, 0.52772454475905, -96.5277786254883, -1.68472755665098, 218, 51, 'PPL', 'P'),
(110183, 'Longpole', 37.5125007629395, 0.654716648970178, -81.8636093139648, -1.42878952009498, 218, 58, 'PPL', 'P'),
(71045, 'Longport', 39.3141708374023, 0.686161723804207, -74.5252838134766, -1.3007115785284, 218, 37, 'PPL', 'P'),
(49062, 'Longridge', 38.3905601501465, 0.670041676304985, -75.2808303833008, -1.31389835382398, 218, 25, 'PPL', 'P'),
(131832, 'Longrie', 45.4058303833008, 0.792481239790678, -87.7249984741211, -1.53109005968041, 218, 27, 'PPL', 'P'),
(55985, 'Longrun', 36.649169921875, 0.639648683259592, -92.7230606079102, -1.61832270013429, 218, 29, 'PPL', 'P'),
(82171, 'Longs', 33.9383316040039, 0.592335629123517, -78.7333297729492, -1.37415583559644, 218, 48, 'PPL', 'P'),
(49064, 'Longs (historical)', 39.6752815246582, 0.692464294260961, -77.3294372558594, -1.34965328882911, 218, 25, 'PPL', 'P'),
(188899, 'Longs (historical)', 33.9238891601563, 0.592083560926341, -103.211112976074, -1.80137374608034, 218, 38, 'PPL', 'P'),
(88672, 'Longs Bend', 36.4463882446289, 0.636109475328931, -82.8269424438477, -1.44560285500498, 218, 50, 'PPL', 'P'),
(156225, 'Longs Crossing', 40.834171295166, 0.712690736424004, -80.8083267211914, -1.4103713643121, 218, 41, 'PPL', 'P'),
(163953, 'Longs Crossroad', 40.667781829834, 0.709786692413327, -78.5766677856445, -1.37142156810526, 218, 45, 'PPL', 'P'),
(49065, 'Longs Mountain View', 39.6527786254883, 0.692071544579202, -77.1877822875977, -1.34718094323114, 218, 25, 'PPL', 'P'),
(66477, 'Longs Store', 36.413890838623, 0.635542288595771, -79.0783309936523, -1.38017724282111, 218, 33, 'PPL', 'P'),
(163955, 'Longsdale', 40.4872207641602, 0.706635307316409, -75.6711120605469, -1.32071005410213, 218, 45, 'PPL', 'P'),
(163954, 'Longsdorf', 40.1019401550293, 0.699910892142987, -77.3399963378906, -1.34983757957655, 218, 45, 'PPL', 'P'),
(82172, 'Longshore', 34.274169921875, 0.598197113524726, -81.7463912963867, -1.42674367974558, 218, 48, 'PPL', 'P'),
(60683, 'Longshot', 33.6452789306641, 0.587220895091965, -90.9024963378906, -1.58654785937828, 218, 30, 'PPL', 'P'),
(78647, 'Longstown', 39.9602813720703, 0.697438479965984, -76.6591720581055, -1.33795495426678, 218, 45, 'PPL', 'P'),
(41868, 'Longstraw', 32.4958305358887, 0.567159236021371, -92.5488891601563, -1.61528283490802, 218, 22, 'PPL', 'P'),
(22736, 'Longstreet', 33.3836097717285, 0.582653906717615, -84.664436340332, -1.47767317348393, 218, 13, 'PPL', 'P'),
(41860, 'Longstreet', 32.0974998474121, 0.560207053995719, -93.9519424438477, -1.63977073428935, 218, 22, 'PPL', 'P'),
(60684, 'Longstreet', 34.1133308410645, 0.595389941998701, -90.329719543457, -1.57655101843639, 218, 30, 'PPL', 'P'),
(190430, 'Longstreet (historical)', 38.3811111450195, 0.669876760054482, -116.709167480469, -2.03695923979567, 218, 39, 'PPL', 'P'),
(73277, 'Longstreth', 39.4980583190918, 0.689371165812889, -82.2202835083008, -1.43501465914304, 218, 41, 'PPL', 'P'),
(163956, 'Longswamp', 40.4980583190918, 0.706824458332832, -75.6552810668945, -1.32043375113904, 218, 45, 'PPL', 'P'),
(33134, 'Longton', 37.3777809143066, 0.652365344043747, -96.0805587768555, -1.67692209781206, 218, 20, 'PPL', 'P'),
(36967, 'Longton', 36.8355598449707, 0.642901801110151, -83.4102783203125, -1.4557839866943, 218, 21, 'PPL', 'P'),
(954, 'Longtown', 35.3413887023926, 0.616823595083877, -89.5141677856445, -1.56231695504214, 218, 50, 'PPL', 'P'),
(3858, 'Longtown', 34.5563888549805, 0.603122763118882, -87.2766723632813, -1.5232652929236, 218, 2, 'PPL', 'P'),
(55987, 'Longtown', 37.6697196960449, 0.657460636999341, -89.7736129760742, -1.5668451278436, 218, 29, 'PPL', 'P'),
(60685, 'Longtown', 34.5108299255371, 0.602327609796412, -90.1241683959961, -1.57296347413195, 218, 30, 'PPL', 'P'),
(66479, 'Longtown', 36.1474990844727, 0.630892875385684, -80.7705612182617, -1.40971223194231, 218, 33, 'PPL', 'P'),
(76447, 'Longtown', 35.2452812194824, 0.61514620307129, -95.5124969482422, -1.66700754854786, 218, 42, 'PPL', 'P'),
(82173, 'Longtown', 34.3474998474121, 0.599476962165591, -80.8375015258789, -1.41088056071253, 218, 48, 'PPL', 'P'),
(88673, 'Longtown (historical)', 36.3319396972656, 0.634111971353317, -83.0583267211914, -1.44964127248198, 218, 50, 'PPL', 'P'),
(182905, 'Longvale', 39.5552787780762, 0.690369851221669, -123.428611755371, -2.154235666297, 218, 6, 'PPL', 'P'),
(3860, 'Longview', 33.2002792358398, 0.579454185246912, -86.7816696166992, -1.51462586518933, 218, 2, 'PPL', 'P'),
(10185, 'Longview', 33.3808288574219, 0.582605370606749, -91.9702835083008, -1.60518426121249, 218, 4, 'PPL', 'P'),
(22737, 'Longview', 34.4702796936035, 0.601619874736724, -83.5694427490234, -1.45856193002736, 218, 13, 'PPL', 'P'),
(27749, 'Longview', 39.8866691589355, 0.696153704477103, -88.0663909912109, -1.5370484831453, 218, 18, 'PPL', 'P'),
(36966, 'Longview', 38.2991714477539, 0.668446642549109, -85.6588897705078, -1.49502966009825, 218, 21, 'PPL', 'P'),
(41861, 'Longview', 32.2619400024414, 0.56307707612347, -91.5780563354492, -1.59833860563044, 218, 22, 'PPL', 'P'),
(49067, 'Longview', 39.4072189331055, 0.687785719436937, -77.2980575561523, -1.34910560975094, 218, 25, 'PPL', 'P'),
(55989, 'Longview', 36.7230606079102, 0.640938319017463, -94.2027816772461, -1.64414870480533, 218, 29, 'PPL', 'P'),
(60687, 'Longview', 34.2811088562012, 0.598318220775298, -88.8952789306641, -1.55151530681883, 218, 30, 'PPL', 'P'),
(66480, 'Longview', 35.7291717529297, 0.623591686099177, -81.3836135864258, -1.42041201425392, 218, 33, 'PPL', 'P'),
(88674, 'Longview', 35.6411094665527, 0.622054709255065, -86.5294418334961, -1.51022365990743, 218, 50, 'PPL', 'P'),
(95828, 'Longview', 32.500560760498, 0.567241794015163, -94.7402801513672, -1.65352982290319, 218, 51, 'PPL', 'P'),
(103816, 'Longview', 38.725830078125, 0.675893240431134, -77.470832824707, -1.35212110705324, 218, 53, 'PPL', 'P'),
(110186, 'Longview', 39.0838890075684, 0.682142547666087, -80.1391677856445, -1.39869233766767, 218, 58, 'PPL', 'P'),
(125267, 'Longview', 41.4402809143066, 0.723269344906017, -70.658332824707, -1.23322055176112, 218, 23, 'PPL', 'P'),
(150381, 'Longview', 42.1055603027344, 0.734880660679735, -79.2888870239258, -1.38385213880931, 218, 40, 'PPL', 'P'),
(163958, 'Longview', 40.3477783203125, 0.70420157755424, -80.0149993896484, -1.39652519033062, 218, 45, 'PPL', 'P'),
(182906, 'Longview', 34.4936103820801, 0.602027072067397, -117.89582824707, -2.05767037727711, 218, 6, 'PPL', 'P'),
(187002, 'Longview', 39.4174995422363, 0.687965149915382, -105.193328857422, -1.83596993969518, 218, 7, 'PPL', 'P'),
(207953, 'Longview', 45.9291687011719, 0.801615216539377, -119.412216186523, -2.0841363395581, 218, 56, 'PPL', 'P'),
(204740, 'Longview Acres', 40.6358299255371, 0.709229026481065, -111.875556945801, -1.95259682120663, 218, 52, 'PPL', 'P'),
(30373, 'Longview Beach', 38.3655586242676, 0.669605317360375, -85.6394424438477, -1.49469024021732, 218, 19, 'PPL', 'P'),
(49068, 'Longview Beach', 38.2933311462402, 0.668344710058386, -76.8080596923828, -1.34055353370042, 218, 25, 'PPL', 'P'),
(10186, 'Longview Crossing', 33.3469390869141, 0.582013882528642, -91.9175033569336, -1.60426307379143, 218, 4, 'PPL', 'P'),
(22738, 'Longview Estates', 33.7202796936035, 0.588529905346766, -84.7283325195313, -1.4787883721904, 218, 13, 'PPL', 'P'),
(49069, 'Longview Estates', 39.5691719055176, 0.69061233203892, -77.6419372558594, -1.3551074427416, 218, 25, 'PPL', 'P'),
(120427, 'Longview Estates', 41.9505615234375, 0.732175421644433, -88.3361129760742, -1.54175601984618, 218, 18, 'PPL', 'P'),
(14146, 'Longview Farms', 39.8191719055176, 0.694975655168906, -75.4725036621094, -1.31724368362729, 218, 10, 'PPL', 'P'),
(49070, 'Longview Heights', 39.420280456543, 0.688013686026248, -76.9161071777344, -1.34243931806831, 218, 25, 'PPL', 'P'),
(73278, 'Longview Heights', 39.3025016784668, 0.685958058559843, -82.0883331298828, -1.4327116905904, 218, 41, 'PPL', 'P'),
(78648, 'Longview Heights', 39.9608306884766, 0.697448067345908, -76.6558303833008, -1.33789663103891, 218, 45, 'PPL', 'P'),
(95829, 'Longview Heights', 32.5058288574219, 0.567333739651798, -94.679443359375, -1.65246802057657, 218, 51, 'PPL', 'P'),
(177241, 'Longview Heights', 40.3383293151855, 0.704036661303737, -80.5716705322266, -1.40624093461945, 218, 58, 'PPL', 'P'),
(207951, 'Longview Heights', 46.1805610656738, 0.80600284101431, -122.955833435059, -2.1459841279755, 218, 56, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(207952, 'Longview Junction', 46.1047210693359, 0.804679183373513, -122.886940002441, -2.14478171074333, 218, 56, 'PPL', 'P'),
(82174, 'Longview Plant', 34.0186080932617, 0.593736718173007, -81.3902816772461, -1.42052839439356, 218, 48, 'PPL', 'P'),
(49071, 'Longview South', 39.2361106872559, 0.68479931716955, -77.1941680908203, -1.34729239652276, 218, 25, 'PPL', 'P'),
(41862, 'Longville', 30.6049995422363, 0.534158009583381, -93.2316665649414, -1.62719954867974, 218, 22, 'PPL', 'P'),
(49072, 'Longville', 39.689998626709, 0.6927211561481, -77.1875, -1.34717601638312, 218, 25, 'PPL', 'P'),
(136581, 'Longville', 46.9863891601563, 0.8200671944681, -94.2111129760742, -1.64429411340085, 218, 28, 'PPL', 'P'),
(193747, 'Longville', 40.1477813720703, 0.700710972313474, -121.243606567383, -2.11610013159345, 218, 6, 'PPL', 'P'),
(55990, 'Longville (historical)', 39.6919403076172, 0.692755044872971, -92.334716796875, -1.61154482200198, 218, 29, 'PPL', 'P'),
(156226, 'Longville (historical)', 40.5855598449707, 0.708351648059938, -83.2174987792969, -1.45241934897309, 218, 41, 'PPL', 'P'),
(103818, 'Longvue Shores', 36.8827781677246, 0.643725916309476, -76.5111083984375, -1.33537075590302, 218, 53, 'PPL', 'P'),
(10188, 'Longwill', 35.7172203063965, 0.623383094006797, -90.4847183227539, -1.5792562574717, 218, 4, 'PPL', 'P'),
(3863, 'Longwood', 34.7188911437988, 0.60595896310079, -86.5813903808594, -1.51113033310054, 218, 2, 'PPL', 'P'),
(14147, 'Longwood', 39.8097190856934, 0.694810672339376, -75.5388870239258, -1.31840229185953, 218, 10, 'PPL', 'P'),
(16941, 'Longwood', 28.7027797698975, 0.500958011459531, -81.3386077880859, -1.4196265148904, 218, 12, 'PPL', 'P'),
(41864, 'Longwood', 30.3400001525879, 0.529532897718241, -91.1369400024414, -1.59063967323513, 218, 22, 'PPL', 'P'),
(49078, 'Longwood', 39.0102806091309, 0.680857838756233, -77.1452789306641, -1.3464391197095, 218, 25, 'PPL', 'P'),
(55991, 'Longwood', 38.899169921875, 0.678918591429464, -93.1697235107422, -1.62611843843522, 218, 29, 'PPL', 'P'),
(60689, 'Longwood', 33.1469383239746, 0.578523210708848, -91.0661087036133, -1.58940343385712, 218, 30, 'PPL', 'P'),
(66485, 'Longwood', 34.0033302307129, 0.593470069168863, -78.5425033569336, -1.37082528633719, 218, 33, 'PPL', 'P'),
(78649, 'Longwood', 39.8675003051758, 0.695819144865162, -75.6708297729492, -1.32070512725412, 218, 45, 'PPL', 'P'),
(82175, 'Longwood', 32.3224983215332, 0.564134018181095, -80.6100006103516, -1.40690992068527, 218, 48, 'PPL', 'P'),
(88676, 'Longwood', 36.0333290100098, 0.628900231679059, -86.9441680908203, -1.51746199859221, 218, 50, 'PPL', 'P'),
(103819, 'Longwood', 39.1191711425781, 0.68275833708914, -77.8763885498047, -1.3591993897565, 218, 53, 'PPL', 'P'),
(150382, 'Longwood', 42.9530601501465, 0.749672323427226, -78.3697204589844, -1.36780965587684, 218, 40, 'PPL', 'P'),
(175053, 'Longwood', 44.8869400024414, 0.783424894187754, -90.5980606079102, -1.58123445352941, 218, 57, 'PPL', 'P'),
(103820, 'Longwood (historical)', 37.6813888549805, 0.657664302243705, -79.5572204589844, -1.38853544074427, 218, 53, 'PPL', 'P'),
(103821, 'Longwood Acres', 37.4500007629395, 0.653625818187682, -77.5530624389648, -1.35355628456468, 218, 53, 'PPL', 'P'),
(30374, 'Longwood Crossing', 39.6558303833008, 0.692124807801004, -85.2272186279297, -1.48749557737442, 218, 19, 'PPL', 'P'),
(82177, 'Longwood Landing', 33.6058311462402, 0.586532401371152, -79.085563659668, -1.38030347665678, 218, 48, 'PPL', 'P'),
(125268, 'Longwood Station', 42.3419418334961, 0.739006296682431, -71.1111068725586, -1.24112294966372, 218, 23, 'PPL', 'P'),
(22739, 'Longwood Subdivision', 33.4225006103516, 0.583332679900449, -84.8097229003906, -1.48020890231585, 218, 13, 'PPL', 'P'),
(41867, 'Longwood Village', 32.4838905334473, 0.566950843666072, -93.8611068725586, -1.63818535449243, 218, 22, 'PPL', 'P'),
(49073, 'Longwoods', 38.8580589294434, 0.67820106925277, -76.0791702270508, -1.32783201264728, 218, 25, 'PPL', 'P'),
(136583, 'Longworth', 48.9824981689453, 0.854905868900189, -95.3647232055664, -1.66442841019018, 218, 28, 'PPL', 'P'),
(191792, 'Longworth', 32.6502799987793, 0.569854887676749, -100.345283508301, -1.75135558606702, 218, 51, 'PPL', 'P'),
(142302, 'Lonnies Trailer Court', 41.4530601501465, 0.723492384647311, -97.0647201538086, -1.69409895421086, 218, 35, 'PPL', 'P'),
(10189, 'Lono', 34.2080612182617, 0.59704329898245, -92.7099990844727, -1.61809473354498, 218, 4, 'PPL', 'P'),
(182907, 'Lonoak', 36.2775001525879, 0.633161822055404, -120.941940307617, -2.11083506211836, 218, 6, 'PPL', 'P'),
(10190, 'Lonoke', 34.7838897705078, 0.607093403146136, -91.8997192382813, -1.60395268236638, 218, 4, 'PPL', 'P'),
(182908, 'Lonoke', 37.0258293151855, 0.646222629831425, -121.576942443848, -2.12191794015278, 218, 6, 'PPL', 'P'),
(10193, 'Lonsdale', 34.5444412231445, 0.602914237605529, -92.8080596923828, -1.61980621401952, 218, 4, 'PPL', 'P'),
(88677, 'Lonsdale', 35.9855613708496, 0.62806652909981, -83.9572219848633, -1.46532995446363, 218, 50, 'PPL', 'P'),
(136584, 'Lonsdale', 44.480281829834, 0.776327370145611, -93.4283294677734, -1.63063196385069, 218, 28, 'PPL', 'P'),
(169472, 'Lonsdale', 41.9072189331055, 0.731418950736796, -71.404167175293, -1.24623781685332, 218, 47, 'PPL', 'P'),
(182909, 'Lonsmith', 35.3402786254883, 0.616804220586947, -118.922500610352, -2.0755891903556, 218, 6, 'PPL', 'P'),
(88678, 'Loo (historical)', 36.3227806091309, 0.633952115108885, -83.8516693115234, -1.46348771277957, 218, 50, 'PPL', 'P'),
(27751, 'Loogootee', 38.9047203063965, 0.679015463914116, -88.8536071777344, -1.55078799752513, 218, 18, 'PPL', 'P'),
(30375, 'Loogootee', 38.6769409179688, 0.675039963617873, -86.9141693115234, -1.5169384211219, 218, 19, 'PPL', 'P'),
(163959, 'Lookabough Corners', 40.6641693115234, 0.70972364207452, -79.6041717529297, -1.38935489541169, 218, 45, 'PPL', 'P'),
(76449, 'Lookeba', 35.3627815246582, 0.617196970268706, -98.3666687011719, -1.7168222430539, 218, 42, 'PPL', 'P'),
(201156, 'Looking Glass (historical)', 45.7097206115723, 0.797785124838652, -117.838333129883, -2.05666689817837, 218, 43, 'PPL', 'P'),
(201157, 'Lookingglass', 43.1786117553711, 0.753608941571554, -123.485000610352, -2.15521983747784, 218, 43, 'PPL', 'P'),
(10194, 'Lookout', 34.5633316040039, 0.603243936948481, -91.3763885498047, -1.59481883877574, 218, 4, 'PPL', 'P'),
(30376, 'Lookout', 39.1952781677246, 0.684086655261845, -85.2074966430664, -1.48715136380352, 218, 19, 'PPL', 'P'),
(36968, 'Lookout', 37.3133316040039, 0.651240491378325, -82.4669418334961, -1.43931965904516, 218, 21, 'PPL', 'P'),
(110184, 'Lookout', 38.0652809143066, 0.664364482651208, -80.9686126708984, -1.41316888187918, 218, 58, 'PPL', 'P'),
(175055, 'Lookout', 44.4583282470703, 0.775944207843776, -91.5791702270508, -1.5983580467064, 218, 57, 'PPL', 'P'),
(193748, 'Lookout', 41.2080612182617, 0.719216346622053, -121.154167175293, -2.1145391197205, 218, 6, 'PPL', 'P'),
(209576, 'Lookout', 41.665828704834, 0.727205896471318, -105.801666259766, -1.8465874303291, 218, 59, 'PPL', 'P'),
(66486, 'Lookout (historical)', 35.0227813720703, 0.611262848148764, -79.9383316040039, -1.39518708504091, 218, 33, 'PPL', 'P'),
(188900, 'Lookout (historical)', 32.2322196960449, 0.56255835892215, -104.111938476563, -1.81709611704978, 218, 38, 'PPL', 'P'),
(182910, 'Lookout City (historical)', 36.2458305358887, 0.632609082971158, -117.433891296387, -2.04960805655106, 218, 6, 'PPL', 'P'),
(188901, 'Lookout Crossing', 32.2252807617188, 0.562437251671578, -104.118606567383, -1.81721249718942, 218, 38, 'PPL', 'P'),
(36969, 'Lookout Heights', 39.0672187805176, 0.681851597316996, -84.543327331543, -1.47555942252674, 218, 21, 'PPL', 'P'),
(193749, 'Lookout Junction', 41.2586097717285, 0.720098585312169, -121.233612060547, -2.11592569454205, 218, 6, 'PPL', 'P'),
(22740, 'Lookout Mountain', 34.9775009155273, 0.610472555095283, -85.357780456543, -1.48977431116114, 218, 13, 'PPL', 'P'),
(88679, 'Lookout Mountain', 34.9941711425781, 0.610763505444374, -85.3494415283203, -1.48962876940757, 218, 50, 'PPL', 'P'),
(178557, 'Lookout Mountain', 33.6233291625977, 0.586837799369157, -112.027221679688, -1.95524387017212, 218, 5, 'PPL', 'P'),
(110185, 'Loom', 39.2786102294922, 0.685541074112164, -78.5116729736328, -1.37028719463894, 218, 58, 'PPL', 'P'),
(131833, 'Loomis', 43.7936096191406, 0.764342679187064, -84.6661071777344, -1.47770233509787, 218, 27, 'PPL', 'P'),
(142303, 'Loomis', 40.478328704834, 0.706480111603885, -99.5066680908203, -1.73671898587399, 218, 35, 'PPL', 'P'),
(150384, 'Loomis', 41.7972183227539, 0.729499077906958, -74.7861099243164, -1.30526385293773, 218, 40, 'PPL', 'P'),
(156227, 'Loomis', 40.0286102294922, 0.698631043502122, -81.0086135864258, -1.41386702955894, 218, 41, 'PPL', 'P'),
(170788, 'Loomis', 43.7938919067383, 0.76434760603508, -98.1041717529297, -1.71224080703064, 218, 49, 'PPL', 'P'),
(175056, 'Loomis', 45.1925010681152, 0.788757940849665, -87.899169921875, -1.53412992490669, 218, 57, 'PPL', 'P'),
(182911, 'Loomis', 38.8213882446289, 0.677561045063796, -121.191940307617, -2.11519838524835, 218, 6, 'PPL', 'P'),
(207955, 'Loomis', 46.4363899230957, 0.810467896897936, -124.046943664551, -2.16502759398233, 218, 56, 'PPL', 'P'),
(150385, 'Loomis Corner', 43.3511085510254, 0.756619578604861, -76.2822189331055, -1.33137588110985, 218, 40, 'PPL', 'P'),
(193750, 'Loomis Corners', 40.5883293151855, 0.708399984433723, -122.304718017578, -2.13462002012997, 218, 6, 'PPL', 'P'),
(150386, 'Loomis Hill', 43.0108299255371, 0.75068059621593, -76.2336120605469, -1.3305275311446, 218, 40, 'PPL', 'P'),
(163960, 'Loomis Park', 41.2038917541504, 0.719143575745266, -75.9702835083008, -1.3259315808934, 218, 45, 'PPL', 'P'),
(150387, 'Loomises', 42.1088905334473, 0.734938784170526, -79.3652801513672, -1.38518545040906, 218, 40, 'PPL', 'P'),
(144077, 'Loon Cove', 43.496940612793, 0.759164828237677, -71.2597198486328, -1.2437167354074, 218, 36, 'PPL', 'P'),
(120428, 'Loon Lake', 42.4469413757324, 0.740838884407542, -88.0899963378906, -1.53746047416594, 218, 18, 'PPL', 'P'),
(128000, 'Loon Lake', 45.0083312988281, 0.785543571992967, -70.6386108398438, -1.23287633819023, 218, 26, 'PPL', 'P'),
(150388, 'Loon Lake', 44.5516700744629, 0.777573330061605, -74.0572204589844, -1.29254233188458, 218, 40, 'PPL', 'P'),
(207956, 'Loon Lake', 48.0616683959961, 0.838834357511834, -117.63166809082, -2.05305991279797, 218, 56, 'PPL', 'P'),
(103822, 'Looney', 37.4711112976074, 0.653994266524494, -80.1627807617188, -1.39910446184636, 218, 53, 'PPL', 'P'),
(95830, 'Looneyville', 31.7630596160889, 0.554369970807997, -94.8441696166992, -1.65534303613137, 218, 51, 'PPL', 'P'),
(110187, 'Looneyville', 38.6644401550293, 0.674821784145568, -81.3033294677734, -1.41901079204638, 218, 58, 'PPL', 'P'),
(110188, 'Loop', 38.5733299255371, 0.673231610658682, -81.6358337402344, -1.42481408637777, 218, 58, 'PPL', 'P'),
(163962, 'Loop', 40.8997192382813, 0.713834763849275, -79.1658325195313, -1.38170443254822, 218, 45, 'PPL', 'P'),
(177741, 'Loop', 32.9152793884277, 0.57447999954189, -102.415557861328, -1.78748868994694, 218, 51, 'PPL', 'P'),
(207957, 'Loop Loop (historical)', 48.4513893127441, 0.845636270672978, -119.712219238281, -2.08937238057731, 218, 56, 'PPL', 'P'),
(182912, 'Loope', 38.6652793884277, 0.674836431531563, -119.694999694824, -2.08907184284829, 218, 6, 'PPL', 'P'),
(110189, 'Loopemount', 37.8433303833008, 0.660490715108606, -80.3499984741211, -1.40237202734583, 218, 58, 'PPL', 'P'),
(22741, 'Looper Lake', 34.3405609130859, 0.59935585491502, -83.8794403076172, -1.46397240809797, 218, 13, 'PPL', 'P'),
(55993, 'Loose Creek', 38.5080604553223, 0.6720924435024, -91.9572219848633, -1.60495629462318, 218, 29, 'PPL', 'P'),
(120429, 'Loose Pulley Junction', 42.1261100769043, 0.735239321899542, -89.2238922119141, -1.55725069054243, 218, 18, 'PPL', 'P'),
(3866, 'Loosier', 34.5716705322266, 0.603389478702054, -87.3702774047852, -1.52489900909431, 218, 2, 'PPL', 'P'),
(60690, 'Looxahoma', 34.5972213745117, 0.603835425026588, -89.8369369506836, -1.56795033969598, 218, 30, 'PPL', 'P'),
(210575, 'Lopa', 20.8033294677734, 0.363086594589806, -156.8125, -2.73689443328361, 218, 15, 'PPL', 'P'),
(95831, 'Lopeno', 26.711109161377, 0.466196801725649, -99.1097183227539, -1.72979090545621, 218, 51, 'PPL', 'P'),
(3867, 'Loper', 31.5813903808594, 0.551199244503662, -88.3000030517578, -1.54112578277421, 218, 2, 'PPL', 'P'),
(82178, 'Lopers Crossroads', 32.9333305358887, 0.574795051498846, -81.2675018310547, -1.41838548182242, 218, 48, 'PPL', 'P'),
(55996, 'Lopez', 37.6519393920898, 0.65715031215332, -90.6463928222656, -1.58207800980469, 218, 29, 'PPL', 'P'),
(163963, 'Lopez', 41.4577789306641, 0.723574742904022, -76.3338928222656, -1.332277760613, 218, 45, 'PPL', 'P'),
(207958, 'Lopez', 48.5238914489746, 0.846901671664929, -122.913330078125, -2.14524230445386, 218, 56, 'PPL', 'P'),
(95832, 'Lopez Colonia', 26.2310009002686, 0.457817331803283, -97.5810012817383, -1.70310975975914, 218, 51, 'PPL', 'P'),
(95833, 'Lopezville', 26.2377796173096, 0.45793564273471, -98.1594390869141, -1.71320540397747, 218, 51, 'PPL', 'P'),
(41869, 'Loquer (historical)', 29.9569396972656, 0.522847231538679, -90.3227767944336, -1.5764298446068, 218, 22, 'PPL', 'P'),
(49074, 'Lor-J Estates', 38.896110534668, 0.678865195049608, -75.8580627441406, -1.3239729590697, 218, 25, 'PPL', 'P'),
(191793, 'Lora', 35.7408294677734, 0.623795151606459, -100.557220458984, -1.75505458366308, 218, 51, 'PPL', 'P'),
(103823, 'Lora Lynn Heights', 37.3394393920898, 0.651696158240838, -77.4486083984375, -1.35173321764047, 218, 53, 'PPL', 'P'),
(36970, 'Loradale', 38.1949996948242, 0.666628502472912, -84.3974990844727, -1.47301423947295, 218, 21, 'PPL', 'P'),
(10195, 'Lorado', 35.9891700744629, 0.62812951285959, -90.7174987792969, -1.58331904287267, 218, 4, 'PPL', 'P'),
(110190, 'Lorado', 37.7955589294434, 0.65965694595033, -81.7149963378906, -1.4261957343513, 218, 58, 'PPL', 'P'),
(116605, 'Lorah', 41.4702796936035, 0.723792922376327, -94.9550018310547, -1.65727742318915, 218, 16, 'PPL', 'P'),
(156228, 'Lorain', 41.4527816772461, 0.723487524378322, -82.182502746582, -1.43435526045714, 218, 41, 'PPL', 'P'),
(163964, 'Lorain', 40.2988891601563, 0.703348300740979, -78.8925018310547, -1.37693391208756, 218, 45, 'PPL', 'P'),
(60695, 'Loraine', 30.4552803039551, 0.531544915921796, -89.0252838134766, -1.55378432006758, 218, 30, 'PPL', 'P'),
(120430, 'Loraine', 40.1541709899902, 0.700822492184121, -91.2222213745117, -1.59212811396838, 218, 18, 'PPL', 'P'),
(182913, 'Loraine', 35.3047218322754, 0.616183637473931, -118.435829162598, -2.06709517121685, 218, 6, 'PPL', 'P'),
(191794, 'Loraine', 32.4111099243164, 0.565680582405131, -100.711936950684, -1.75775489585037, 218, 51, 'PPL', 'P'),
(198549, 'Loraine', 48.8655586242676, 0.85286488881978, -101.567497253418, -1.77268724008244, 218, 34, 'PPL', 'P'),
(82179, 'Loraine (historical)', 33.3499984741211, 0.582067278908498, -81.084716796875, -1.41519528115262, 218, 48, 'PPL', 'P'),
(120432, 'Loran', 42.2350006103516, 0.737139820232449, -89.9102783203125, -1.56923038807393, 218, 18, 'PPL', 'P'),
(22742, 'Lorane', 32.913890838623, 0.57445576477597, -83.774169921875, -1.46213509326192, 218, 13, 'PPL', 'P'),
(123098, 'Lorane', 41.2069396972656, 0.719196772388041, -85.5586090087891, -1.49327943062985, 218, 19, 'PPL', 'P'),
(163966, 'Lorane', 40.288330078125, 0.703164009993546, -75.8550033569336, -1.32391956268984, 218, 45, 'PPL', 'P'),
(201158, 'Lorane', 43.8377799987793, 0.765113597743615, -123.237777709961, -2.1509049838797, 218, 43, 'PPL', 'P'),
(41870, 'Loranger', 30.6355590820313, 0.534691374170697, -90.398063659668, -1.57774384828864, 218, 22, 'PPL', 'P'),
(66487, 'Loray', 35.8166694641113, 0.625118809247256, -80.9683303833008, -1.41316395503116, 218, 33, 'PPL', 'P'),
(200053, 'Loray', 41.142219543457, 0.718067192611684, -114.317222595215, -1.99521192602176, 218, 39, 'PPL', 'P'),
(66488, 'Loray Mills', 35.2636108398438, 0.615466115297236, -81.2055587768555, -1.41730437157791, 218, 33, 'PPL', 'P'),
(10196, 'Lorays', 34.1105613708496, 0.595341605624916, -90.98388671875, -1.58796838950373, 218, 4, 'PPL', 'P'),
(163967, 'Lorberry', 40.6016693115234, 0.708632811292023, -76.4452819824219, -1.33422186820876, 218, 45, 'PPL', 'P'),
(163974, 'Lorberry Junction', 40.5886116027832, 0.70840491128174, -76.4130630493164, -1.33365954174459, 218, 45, 'PPL', 'P'),
(191795, 'Lord', 36.3616714477539, 0.634630888291719, -100.888328552246, -1.7608335100705, 218, 51, 'PPL', 'P'),
(49075, 'Lord Calvert Estates', 38.685001373291, 0.675180645102456, -76.6686096191406, -1.3381196707802, 218, 25, 'PPL', 'P'),
(49076, 'Lord Calvert Hills', 38.6705589294434, 0.67492857690528, -76.6216735839844, -1.33730048242889, 218, 25, 'PPL', 'P'),
(49077, 'Lord Cecil Woods', 38.5855598449707, 0.673445063020052, -76.5994415283203, -1.33691245985807, 218, 25, 'PPL', 'P'),
(113655, 'Lord Corner (historical)', 41.357780456543, 0.721829440283638, -72.5486068725586, -1.26621205766113, 218, 8, 'PPL', 'P'),
(103824, 'Lord Fairfax Estates', 38.855281829834, 0.67815259972093, -77.3038864135742, -1.34920734250458, 218, 53, 'PPL', 'P'),
(16942, 'Lordland', 28.7716693878174, 0.502160362112675, -81.2605590820313, -1.41826430799283, 218, 12, 'PPL', 'P'),
(14148, 'Lords Corner', 39.0144386291504, 0.680930409895937, -75.7236099243164, -1.32162631467518, 218, 10, 'PPL', 'P'),
(150389, 'Lords Corners', 42.9102783203125, 0.748925639636595, -76.2216720581055, -1.3303191387893, 218, 40, 'PPL', 'P'),
(144078, 'Lords Hill (historical)', 43.8038902282715, 0.764522109665508, -71.0572204589844, -1.24018245432475, 218, 36, 'PPL', 'P'),
(113656, 'Lords Point', 41.3358306884766, 0.72144634456083, -71.9274978637695, -1.25537166044397, 218, 8, 'PPL', 'P'),
(163968, 'Lords Valley', 41.3675003051758, 0.721999083645076, -75.0627822875977, -1.31009269662626, 218, 45, 'PPL', 'P'),
(188902, 'Lordsburg', 32.3502807617188, 0.564618913236571, -108.708061218262, -1.89731359171823, 218, 38, 'PPL', 'P'),
(113657, 'Lordship', 41.1538887023926, 0.718270857856047, -73.1125030517578, -1.27605390262758, 218, 8, 'PPL', 'P'),
(156232, 'Lordstown', 41.1655616760254, 0.718474589679438, -80.857780456543, -1.4112344948214, 218, 41, 'PPL', 'P'),
(191796, 'Lordsville Colonia', 31.6009998321533, 0.551541493993251, -106.247001647949, -1.85435999912856, 218, 51, 'PPL', 'P'),
(150390, 'Lordville', 41.8691711425781, 0.730754891518984, -75.2155609130859, -1.3127591866677, 218, 40, 'PPL', 'P'),
(116606, 'Lore', 42.5180587768555, 0.742080117212601, -90.7997207641602, -1.58475408722606, 218, 16, 'PPL', 'P'),
(73280, 'Lore City', 39.9847183227539, 0.69786498521456, -81.458610534668, -1.42172095792969, 218, 41, 'PPL', 'P'),
(116607, 'Lore Mobile Home Park', 42.521671295166, 0.742143167551409, -90.7972183227539, -1.58471041138418, 218, 16, 'PPL', 'P'),
(41871, 'Loreauville', 30.0563907623291, 0.524582980068651, -91.7369384765625, -1.60111162211549, 218, 22, 'PPL', 'P'),
(204744, 'Loredell', 40.6583290100098, 0.709621709583797, -111.813331604004, -1.9515107841141, 218, 52, 'PPL', 'P'),
(3868, 'Loree', 31.4872207641602, 0.54955567463692, -87.0899963378906, -1.520007181646, 218, 2, 'PPL', 'P'),
(123096, 'Loree', 40.6455612182617, 0.709398869579585, -86.0580596923828, -1.5019964895099, 218, 19, 'PPL', 'P'),
(41872, 'Lorelein', 32.0938911437988, 0.560144070235938, -91.5527801513672, -1.59789745299587, 218, 22, 'PPL', 'P'),
(201159, 'Lorella', 42.1372184753418, 0.735433200026899, -121.271392822266, -2.11658509322795, 218, 43, 'PPL', 'P'),
(33137, 'Lorena', 37.6938896179199, 0.65788248171601, -97.083610534668, -1.69442865355381, 218, 20, 'PPL', 'P'),
(60691, 'Lorena', 32.1827812194824, 0.561695494728964, -89.5094375610352, -1.56223439704835, 218, 30, 'PPL', 'P'),
(95834, 'Lorena', 31.3863906860352, 0.547795857788595, -97.2152786254883, -1.69672669525844, 218, 51, 'PPL', 'P'),
(82181, 'Lorena Park', 34.9144401550293, 0.609371937195781, -82.3083267211914, -1.43655130309202, 218, 48, 'PPL', 'P'),
(163969, 'Lorenton', 41.5444412231445, 0.725087285245132, -77.2858276367188, -1.34889215738957, 218, 45, 'PPL', 'P'),
(110191, 'Lorentz', 39.0108299255371, 0.680867426136157, -80.3024978637695, -1.40154298529849, 218, 58, 'PPL', 'P'),
(150391, 'Lorenz Park', 42.2636108398438, 0.737639162936839, -73.7688903808594, -1.28751002268877, 218, 40, 'PPL', 'P'),
(95835, 'Lorenzana Colonia', 26.1749992370605, 0.45683991839371, -97.9169998168945, -1.70897404047949, 218, 51, 'PPL', 'P'),
(60692, 'Lorenzen', 32.9486083984375, 0.57506170050299, -90.9063873291016, -1.58661576998608, 218, 30, 'PPL', 'P'),
(22743, 'Lorenzo', 32.4375, 0.566141176115661, -81.3769378662109, -1.42029550095623, 218, 13, 'PPL', 'P'),
(120434, 'Lorenzo', 41.3472213745117, 0.721645149536205, -88.2155609130859, -1.53965198942696, 218, 18, 'PPL', 'P'),
(191797, 'Lorenzo', 33.6705589294434, 0.587662114305564, -101.534721374512, -1.77211519308029, 218, 51, 'PPL', 'P'),
(195260, 'Lorenzo', 43.728328704834, 0.763203312293701, -111.870559692383, -1.95250960268094, 218, 17, 'PPL', 'P'),
(199500, 'Lorenzo', 41.0475006103516, 0.716414035365017, -103.067497253418, -1.79886717886236, 218, 35, 'PPL', 'P'),
(82182, 'Lorenzo (historical)', 34.149169921875, 0.596015451959733, -82.2363891601563, -1.4352957557961, 218, 48, 'PPL', 'P'),
(182915, 'Lorenzo Station', 37.6925010681152, 0.65785824695009, -122.128890991211, -2.13155125960587, 218, 6, 'PPL', 'P'),
(71047, 'Lores Mill', 39.2838897705078, 0.685633219485881, -75.0658264160156, -1.31014582669001, 218, 37, 'PPL', 'P'),
(175058, 'Loreta', 43.3455581665039, 0.75652270612021, -90.1072235107422, -1.5726677300929, 218, 57, 'PPL', 'P'),
(33138, 'Loretta', 38.6536102294922, 0.6746327662872, -99.1802825927734, -1.73102248430232, 218, 20, 'PPL', 'P'),
(175059, 'Loretta', 45.8855590820313, 0.800854085099832, -90.852783203125, -1.58568020149513, 218, 57, 'PPL', 'P'),
(22744, 'Loretta Heights', 31.4902801513672, 0.549609071016776, -84.1194381713867, -1.4681611610185, 218, 13, 'PPL', 'P'),
(49082, 'Loretta Heights', 38.9841690063477, 0.680402105314693, -76.5355606079102, -1.33579752746771, 218, 25, 'PPL', 'P'),
(3869, 'Loretto', 34.0686111450195, 0.594609436062226, -86.9161071777344, -1.51697224326774, 218, 2, 'PPL', 'P'),
(16943, 'Loretto', 30.1569404602051, 0.526337903358473, -81.5950012207031, -1.42410142447006, 218, 12, 'PPL', 'P'),
(36971, 'Loretto', 37.6352806091309, 0.656859561541311, -85.4008331298828, -1.49052572206271, 218, 21, 'PPL', 'P'),
(49079, 'Loretto', 38.2602806091309, 0.667767869366275, -75.6819381713867, -1.32089900538147, 218, 25, 'PPL', 'P'),
(88680, 'Loretto', 35.0777816772461, 0.612222784563683, -87.4397201538086, -1.5261110137064, 218, 50, 'PPL', 'P'),
(103825, 'Loretto', 38.0761108398438, 0.664553500509577, -77.0508270263672, -1.34479062299474, 218, 53, 'PPL', 'P'),
(120435, 'Loretto', 40.9777793884277, 0.715197170483932, -88.4347229003906, -1.54347708770065, 218, 18, 'PPL', 'P'),
(131834, 'Loretto', 45.7772216796875, 0.798963240725876, -87.8150024414063, -1.5326609252494, 218, 27, 'PPL', 'P'),
(136588, 'Loretto', 45.0547218322754, 0.786353239543378, -93.6352767944336, -1.63424387607911, 218, 28, 'PPL', 'P'),
(142304, 'Loretto', 41.764720916748, 0.728931891173798, -98.0802764892578, -1.71182375600393, 218, 35, 'PPL', 'P'),
(163970, 'Loretto', 40.503059387207, 0.70691174343756, -78.6305618286133, -1.37236219660228, 218, 45, 'PPL', 'P'),
(163971, 'Loretto Road', 40.5088882446289, 0.707013476191201, -78.6552810668945, -1.37279362869887, 218, 45, 'PPL', 'P'),
(14149, 'Lorewood Grove', 39.5402793884277, 0.690108062486514, -75.6875, -1.32099607760321, 218, 10, 'PPL', 'P'),
(103826, 'Lorfax Heights', 38.7208290100098, 0.675805955326407, -77.2558288574219, -1.34836857991926, 218, 53, 'PPL', 'P'),
(120436, 'Lori-Sue Subdivision', 41.3383293151855, 0.721489953823681, -88.3958282470703, -1.54279824793878, 218, 18, 'PPL', 'P'),
(16944, 'Lorida', 27.4430599212646, 0.478971752448164, -81.2538909912109, -1.41814792785319, 218, 12, 'PPL', 'P'),
(175060, 'Lorimar Estates', 42.7113914489746, 0.745454408892759, -88.1272201538086, -1.53811015231386, 218, 57, 'PPL', 'P'),
(116608, 'Lorimor', 41.1283302307129, 0.717824778373459, -94.0530624389648, -1.64153561114374, 218, 16, 'PPL', 'P'),
(10197, 'Lorine', 36.3069381713867, 0.633675612408708, -91.0325012207031, -1.58881687262703, 218, 4, 'PPL', 'P'),
(33139, 'Loring', 39.0138893127441, 0.680920822516013, -94.908332824707, -1.65646289536975, 218, 20, 'PPL', 'P'),
(41873, 'Loring', 31.6025009155273, 0.551567692840475, -93.6005630493164, -1.63363800693111, 218, 22, 'PPL', 'P'),
(55995, 'Loring', 37.3447189331055, 0.651788303614554, -92.5744400024414, -1.61572878123255, 218, 29, 'PPL', 'P'),
(60693, 'Loring', 32.7802810668945, 0.572123834346469, -89.9377822875977, -1.56971042286042, 218, 30, 'PPL', 'P'),
(116609, 'Loring', 41.8347206115723, 0.730153616323872, -93.4349975585938, -1.63074834399032, 218, 16, 'PPL', 'P'),
(193265, 'Loring', 55.6025009155273, 0.970446713319114, -131.636108398438, -2.29748350606489, 218, 1, 'PPL', 'P'),
(196943, 'Loring', 48.7922210693359, 0.851584907020861, -107.861106872559, -1.88253144977163, 218, 31, 'PPL', 'P'),
(200055, 'Loring (historical)', 40.2330589294434, 0.702199346467692, -118.337501525879, -2.0653790302104, 218, 39, 'PPL', 'P'),
(196944, 'Loring Colony', 48.7866706848145, 0.851488034536209, -107.972778320313, -1.88448048421541, 218, 31, 'PPL', 'P'),
(150392, 'Loring Crossing', 42.6258316040039, 0.743961107890524, -76.1458282470703, -1.32899541456948, 218, 40, 'PPL', 'P'),
(82183, 'Loris', 34.0561103820801, 0.594391256589921, -78.8905563354492, -1.37689995678366, 218, 48, 'PPL', 'P'),
(60694, 'Lorman', 31.8202800750732, 0.555368656216777, -91.0500030517578, -1.58912233720406, 218, 30, 'PPL', 'P'),
(204743, 'Lornadale', 40.6483306884766, 0.70944720595337, -111.840278625488, -1.95198109836261, 218, 52, 'PPL', 'P'),
(103827, 'Lorne', 37.8622207641602, 0.660820414451558, -77.3547210693359, -1.35009457462174, 218, 53, 'PPL', 'P'),
(136590, 'Lorne', 44.7461090087891, 0.780966929659665, -95.5741729736328, -1.66808399826047, 218, 28, 'PPL', 'P'),
(16945, 'Lorraine', 27.4316692352295, 0.47877294747279, -82.3955612182617, -1.43807383228722, 218, 12, 'PPL', 'P'),
(33140, 'Lorraine', 38.5688896179199, 0.67315411267096, -98.3163909912109, -1.71594473147472, 218, 20, 'PPL', 'P'),
(41875, 'Lorraine', 30.5058307647705, 0.532427187901425, -90.2783279418945, -1.57565406578126, 218, 22, 'PPL', 'P'),
(88682, 'Lorraine', 35.7219390869141, 0.623465452263507, -84.8277816772461, -1.48052408743086, 218, 50, 'PPL', 'P'),
(103828, 'Lorraine', 37.5677795410156, 0.655681445654087, -77.6202774047852, -1.35472940702486, 218, 53, 'PPL', 'P'),
(150393, 'Lorraine', 43.7663917541504, 0.763867637827621, -75.959716796875, -1.32574715698791, 218, 40, 'PPL', 'P'),
(163973, 'Lorraine', 40.7138900756836, 0.710591433115722, -76.179443359375, -1.32958210895762, 218, 45, 'PPL', 'P'),
(182916, 'Lorraine (historical)', 39.4691696166992, 0.68886696283951, -121.649169921875, -2.12317854745477, 218, 6, 'PPL', 'P'),
(182917, 'Lort', 36.3427810668945, 0.634301188948767, -119.153327941895, -2.07961788729462, 218, 6, 'PPL', 'P'),
(3870, 'Lorton', 33.7552795410156, 0.589140767921803, -87.0622177124023, -1.51952235316955, 218, 2, 'PPL', 'P'),
(103829, 'Lorton', 38.7041702270508, 0.675515204714397, -77.2280578613281, -1.34788388460087, 218, 53, 'PPL', 'P'),
(142305, 'Lorton', 40.5955581665039, 0.708526151690366, -96.024169921875, -1.67593792663122, 218, 35, 'PPL', 'P'),
(110192, 'Lorton Lick', 37.329719543457, 0.6515265148794, -81.2427825927734, -1.41795404972583, 218, 58, 'PPL', 'P'),
(674, 'Lorwood', 36.6094398498535, 0.638955262690762, -89.855827331543, -1.56828003903894, 218, 29, 'PPL', 'P'),
(110195, 'Lory', 38.1297187805176, 0.665489135579549, -81.8274993896484, -1.42815928302302, 218, 58, 'PPL', 'P'),
(41876, 'Los Adaes (historical)', 31.7080593109131, 0.553410034393078, -93.2930603027344, -1.62827107154433, 218, 22, 'PPL', 'P'),
(182918, 'Los Alamitos', 33.8030586242676, 0.589974670238134, -118.071670532227, -2.06073940411732, 218, 6, 'PPL', 'P'),
(182920, 'Los Alamitos Junction', 33.8058280944824, 0.590023006611919, -117.998329162598, -2.05945935573937, 218, 6, 'PPL', 'P'),
(182922, 'Los Alamos', 34.7444381713867, 0.606404842846296, -120.277221679688, -2.09923353346165, 218, 6, 'PPL', 'P'),
(188904, 'Los Alamos', 35.7319412231445, 0.623640022472962, -105.151107788086, -1.83523304302155, 218, 38, 'PPL', 'P'),
(182926, 'Los Altos', 37.3852806091309, 0.652496238411325, -122.113059997559, -2.13127495664278, 218, 6, 'PPL', 'P'),
(95836, 'Los Altos Colonia', 27.4899997711182, 0.4797910073785, -99.3860015869141, -1.73461295808396, 218, 51, 'PPL', 'P'),
(182927, 'Los Altos Hills', 37.3797187805176, 0.652399166189591, -122.136390686035, -2.13168215397345, 218, 6, 'PPL', 'P'),
(95837, 'Los Alvarez', 26.3891696929932, 0.460577898010232, -98.9008331298828, -1.72614517108194, 218, 51, 'PPL', 'P'),
(95838, 'Los Angeles', 26.5777797698975, 0.463869764854652, -98.1394424438477, -1.71285639671661, 218, 51, 'PPL', 'P'),
(182928, 'Los Angeles', 34.0522193908691, 0.594323345982124, -118.242782592773, -2.06372587296373, 218, 6, 'PPL', 'P'),
(95839, 'Los Angeles Subdivision', 26.4950008392334, 0.462424999963284, -97.7863922119141, -1.70669450774444, 218, 51, 'PPL', 'P'),
(110193, 'Los Anglin', 39.063060760498, 0.681779026177291, -80.4544372558594, -1.40419482795394, 218, 58, 'PPL', 'P'),
(182930, 'Los Banos', 37.0583305358887, 0.646789883143612, -120.848892211914, -2.10921106648563, 218, 6, 'PPL', 'P'),
(95840, 'Los Barreras', 26.3863906860352, 0.460529395188879, -98.920280456543, -1.72648459096287, 218, 51, 'PPL', 'P'),
(182931, 'Los Berros', 35.0788917541504, 0.612242159060614, -120.54167175293, -2.10384905794687, 218, 6, 'PPL', 'P'),
(178558, 'Los Burros', 34.1413917541504, 0.595879697323167, -109.776390075684, -1.91595944777431, 218, 5, 'PPL', 'P'),
(191798, 'Los Campos Number 1,2 and 5 Colonia', 29.4260005950928, 0.51358059607818, -100.921997070313, -1.76142113656502, 218, 51, 'PPL', 'P'),
(191799, 'Los Campos Number 3 and 4 Colonia', 29.4290008544922, 0.513632960483113, -100.942001342773, -1.76177027698393, 218, 51, 'PPL', 'P'),
(188906, 'Los Candelarias', 35.1233291625977, 0.613017738149072, -106.663330078125, -1.86162630100478, 218, 38, 'PPL', 'P'),
(95841, 'Los Castillos Estates Colonia', 26.128999710083, 0.456037075193592, -97.9629974365234, -1.7097768503901, 218, 51, 'PPL', 'P'),
(188908, 'Los Cerrilos', 35.4388885498047, 0.61852528844141, -106.122779846191, -1.85219191968512, 218, 38, 'PPL', 'P'),
(187003, 'Los Cerritos', 37.1483306884766, 0.648360682133568, -105.910278320313, -1.84848306839302, 218, 7, 'PPL', 'P'),
(95842, 'Los Cerritos Colonia', 26.4419994354248, 0.461499950958645, -98.1360015869141, -1.71279634243403, 218, 51, 'PPL', 'P'),
(188909, 'Los Chaves', 34.7269401550293, 0.606099444848291, -106.737777709961, -1.86292565730063, 218, 38, 'PPL', 'P'),
(188910, 'Los Chavez', 34.7266693115234, 0.606094717737356, -106.753059387207, -1.8631923728838, 218, 38, 'PPL', 'P'),
(177710, 'Los Cisneros', 36.0736083984375, 0.629603239627813, -105.22917175293, -1.83659551623524, 218, 38, 'PPL', 'P'),
(188911, 'Los Cocas', 36.1127815246582, 0.630286939658663, -105.213333129883, -1.83631908011409, 218, 38, 'PPL', 'P'),
(188912, 'Los Cordovas', 36.3872184753418, 0.635076768037225, -105.636940002441, -1.84371241477431, 218, 38, 'PPL', 'P'),
(95843, 'Los Corralitos Colonia', 27.6420001983643, 0.482443915298382, -99.5559997558594, -1.73757998585442, 218, 51, 'PPL', 'P'),
(95844, 'Los Coyotes', 26.3871192932129, 0.460542111783084, -97.6729583740234, -1.70471471379008, 218, 51, 'PPL', 'P'),
(95845, 'Los Cuates', 26.0805606842041, 0.455191654705547, -97.4963912963867, -1.70163303693469, 218, 51, 'PPL', 'P'),
(95846, 'Los Cuates South Colonia', 25.882999420166, 0.45174356017368, -97.431999206543, -1.70050918295468, 218, 51, 'PPL', 'P'),
(188913, 'Los Duranes', 35.1086082458496, 0.612760809682906, -106.676940917969, -1.86186385497402, 218, 38, 'PPL', 'P'),
(95847, 'Los Ebanos', 26.2430591583252, 0.458027788108427, -98.561393737793, -1.72022083607901, 218, 51, 'PPL', 'P'),
(95848, 'Los Ebanos Colonia', 26.4109992980957, 0.460958896493681, -98.9179992675781, -1.72644477670458, 218, 51, 'PPL', 'P'),
(95849, 'Los Ebanos Colonia Number 1', 26.3050003051758, 0.459108865063431, -98.3280029296875, -1.71614739803368, 218, 51, 'PPL', 'P'),
(95850, 'Los Ebanos Colonia Number 2', 26.3050003051758, 0.459108865063431, -98.3300018310547, -1.71618228544396, 218, 51, 'PPL', 'P'),
(95851, 'Los Ebanos Estates Colonia', 26.261999130249, 0.458358352978733, -98.3349990844727, -1.71626950396966, 218, 51, 'PPL', 'P'),
(95852, 'Los Ebanos Number 2 Colonia', 26.4109992980957, 0.460958896493681, -98.9199981689453, -1.72647966411486, 218, 51, 'PPL', 'P'),
(95853, 'Los Fresnos', 26.0713901519775, 0.455031598724033, -97.4761123657227, -1.70127910282582, 218, 51, 'PPL', 'P'),
(187004, 'Los Fuertes', 37.1344413757324, 0.648118267895344, -105.379173278809, -1.83921353674484, 218, 7, 'PPL', 'P'),
(95854, 'Los Garzas', 26.3636093139648, 0.46013178523813, -98.8933334350586, -1.72601427671437, 218, 51, 'PPL', 'P'),
(182943, 'Los Gatos', 37.2266693115234, 0.649727949037215, -121.973609924316, -2.12884109372255, 218, 6, 'PPL', 'P'),
(188914, 'Los Griegos', 35.1394386291504, 0.613298901381157, -106.650283813477, -1.86139860073158, 218, 38, 'PPL', 'P'),
(191800, 'Los Guajillos Colonia', 28.6350002288818, 0.499775035303318, -100.43399810791, -1.75290394792479, 218, 51, 'PPL', 'P'),
(177669, 'Los Guilicos', 38.4266700744629, 0.670671913376952, -122.580558776855, -2.13943434959056, 218, 6, 'PPL', 'P'),
(188915, 'Los Huerros', 36.1627807617188, 0.631159590968855, -105.118057250977, -1.83465620232944, 218, 38, 'PPL', 'P'),
(95855, 'Los Huisaches Colonia', 27.9060001373291, 0.487051583458383, -99.4800033569336, -1.7362535984735, 218, 51, 'PPL', 'P'),
(95856, 'Los Huisaches Number 2 Colonia', 27.9080009460449, 0.487086504158176, -99.4720001220703, -1.73611391567433, 218, 51, 'PPL', 'P'),
(95857, 'Los Indios', 26.0488891601563, 0.454638882331787, -97.7447204589844, -1.70596719845074, 218, 51, 'PPL', 'P'),
(191801, 'Los Jardines Verdes Colonia', 28.67799949646, 0.500525514098502, -100.470001220703, -1.75353232078399, 218, 51, 'PPL', 'P'),
(188916, 'Los LeFebres', 36.1994400024414, 0.631799415420747, -105.113891601563, -1.83458349803168, 218, 38, 'PPL', 'P'),
(188917, 'Los Lentes', 34.8233299255371, 0.607781763708894, -106.731666564941, -1.86281899769897, 218, 38, 'PPL', 'P'),
(95858, 'Los Leones Colonia', 26.1089992523193, 0.45568800135371, -97.9570007324219, -1.70967218815926, 218, 51, 'PPL', 'P'),
(95859, 'Los Lomas', 28.1375007629395, 0.49109203159571, -97.8877792358398, -1.70846404513074, 218, 51, 'PPL', 'P'),
(188918, 'Los Luceros', 36.1097183227539, 0.63023347669978, -106.04638671875, -1.85085860808537, 218, 38, 'PPL', 'P'),
(188919, 'Los Lunas', 34.8061103820801, 0.607481225979879, -106.732780456543, -1.86283843877493, 218, 38, 'PPL', 'P'),
(178559, 'Los Maderas', 33.4491691589355, 0.583798133879968, -111.783332824707, -1.95098720664379, 218, 5, 'PPL', 'P'),
(188920, 'Los Marias', 35.4136085510254, 0.618084069227811, -105.942497253418, -1.84904539485719, 218, 38, 'PPL', 'P'),
(182951, 'Los Medanos', 38.0122184753418, 0.663438368382133, -121.850280761719, -2.1266885937715, 218, 6, 'PPL', 'P'),
(188921, 'Los Medinas', 36.0441703796387, 0.629089449274509, -105.222221374512, -1.83647420924758, 218, 38, 'PPL', 'P'),
(95860, 'Los Minerales Colonia', 27.6509990692139, 0.482600975223669, -99.6179962158203, -1.73866202820532, 218, 51, 'PPL', 'P'),
(193751, 'Los Molinos', 40.0213890075684, 0.698505009403534, -122.099166870117, -2.13103247582552, 218, 6, 'PPL', 'P'),
(188922, 'Los Montoyas', 35.4194412231445, 0.61818586856048, -105.207221984863, -1.83621242051243, 218, 38, 'PPL', 'P'),
(182953, 'Los Nietos', 33.9683303833008, 0.592859206593826, -118.069717407227, -2.06070531565537, 218, 6, 'PPL', 'P'),
(182954, 'Los Nietos Junction', 33.9613914489746, 0.592738099343255, -118.069442749023, -2.0607005219654, 218, 6, 'PPL', 'P'),
(95861, 'Los Nogales Estates Colonia', 26.0540008544922, 0.454728098228305, -97.7639999389648, -1.70630368885447, 218, 51, 'PPL', 'P'),
(188923, 'Los Ojitos', 34.6852798461914, 0.605372335291672, -104.460563659668, -1.82318077435034, 218, 38, 'PPL', 'P'),
(188924, 'Los Ojos', 36.7291717529297, 0.64104497861912, -106.569442749023, -1.85998765798606, 218, 38, 'PPL', 'P'),
(95862, 'Los Ojuelos', 27.4027805328369, 0.47826874449941, -98.9961090087891, -1.72780804886659, 218, 51, 'PPL', 'P'),
(182957, 'Los Olivos', 34.667781829834, 0.605066937293668, -120.113891601563, -2.09638288583083, 218, 6, 'PPL', 'P'),
(95863, 'Los Olmos Colonia', 26.375560760498, 0.46034037733051, -98.7980575561523, -1.72435139892972, 218, 51, 'PPL', 'P'),
(182959, 'Los Osos', 35.3111114501953, 0.616295157344578, -120.831390380859, -2.1089056019086, 218, 6, 'PPL', 'P'),
(188925, 'Los Pachecos', 36.0091705322266, 0.628478586699472, -105.933609008789, -1.8488902657237, 218, 38, 'PPL', 'P'),
(188926, 'Los Padillas', 34.9691696166992, 0.610327146499765, -106.695281982422, -1.86218396693704, 218, 38, 'PPL', 'P'),
(95877, 'Los Padres Colonia', 26.2940006256104, 0.458916884438349, -98.2460021972656, -1.71471621526387, 218, 51, 'PPL', 'P'),
(188927, 'Los Pastores', 35.314998626709, 0.616363001373348, -106.42749786377, -1.85751025238201, 218, 38, 'PPL', 'P'),
(188929, 'Los Pinos', 36.9883308410645, 0.645568157993538, -106.063888549805, -1.85116407266241, 218, 38, 'PPL', 'P'),
(182962, 'Los Pitos (historical)', 34.3186111450195, 0.598972759192212, -119.387496948242, -2.08370490746151, 218, 6, 'PPL', 'P'),
(182966, 'Los Ranchitos', 33.4833297729492, 0.584394349069009, -117.133331298828, -2.04436229499388, 218, 6, 'PPL', 'P'),
(95864, 'Los Ranchitos Colonia', 26.2229995727539, 0.457677682293622, -97.7409973144531, -1.70590221732014, 218, 51, 'PPL', 'P'),
(95865, 'Los Ranchitos Number 1-3 Colonia', 26.1229991912842, 0.455932346383725, -98.2060012817383, -1.7140180675841, 218, 51, 'PPL', 'P'),
(188930, 'Los Ranchos de Albuquerque', 35.1619415283203, 0.613691651062916, -106.642219543457, -1.86125785266797, 218, 38, 'PPL', 'P'),
(182968, 'Los Serranos', 33.9727783203125, 0.592936837739602, -117.707221984863, -2.05437857701172, 218, 6, 'PPL', 'P'),
(188931, 'Los Tanos', 34.9952812194824, 0.610782879941305, -104.542221069336, -1.8246059650077, 218, 38, 'PPL', 'P'),
(95866, 'Los Terrazos Colonia', 26.3269996643066, 0.459492826313593, -98.2570037841797, -1.71490822917846, 218, 51, 'PPL', 'P'),
(182969, 'Los Terrentos', 32.8347206115723, 0.573073983644382, -116.621109008789, -2.03542232953059, 218, 6, 'PPL', 'P'),
(178560, 'Los Tesoros', 33.3286094665527, 0.581693970302696, -111.912216186523, -1.95323664565853, 218, 5, 'PPL', 'P'),
(16946, 'Los Trancos Woods', 29.6997203826904, 0.518357907599618, -82.4927825927734, -1.43977066537576, 218, 12, 'PPL', 'P'),
(182970, 'Los Trancos Woods', 37.3494415283203, 0.651870728450292, -122.198333740234, -2.13276326421797, 218, 6, 'PPL', 'P'),
(95867, 'Los Trevinos Colonia', 26.2180004119873, 0.457590430478408, -98.3889999389648, -1.71721199667944, 218, 51, 'PPL', 'P'),
(95868, 'Los Trevinos Colonia Number 2', 26.2189998626709, 0.457607874183548, -98.3889999389648, -1.71721199667944, 218, 51, 'PPL', 'P'),
(95869, 'Los Trevinos Colonia Number 3', 26.2189998626709, 0.457607874183548, -98.3899993896484, -1.71722944038458, 218, 51, 'PPL', 'P'),
(95870, 'Los Trevinos Colonia Number 4', 26.2220001220703, 0.457660238588482, -98.3889999389648, -1.71721199667944, 218, 51, 'PPL', 'P'),
(95871, 'Los Trevinos Colonia Number 5', 26.2180004119873, 0.457590430478408, -98.3899993896484, -1.71722944038458, 218, 51, 'PPL', 'P'),
(188932, 'Los Trujillos', 34.646671295166, 0.604698488956855, -106.760276794434, -1.86331834040336, 218, 38, 'PPL', 'P'),
(182972, 'Los Tules', 33.2833290100098, 0.580903677249215, -116.620277404785, -2.03540781530265, 218, 6, 'PPL', 'P'),
(95872, 'Los Velas', 26.3377799987793, 0.459680978644607, -98.7808303833008, -1.72405072804265, 218, 51, 'PPL', 'P'),
(95873, 'Los Veteranos 59 Colonia', 27.632999420166, 0.482286822083581, -99.2190017700195, -1.73169826142892, 218, 51, 'PPL', 'P'),
(95874, 'Los Veteranos 83 Colonia', 27.7709999084473, 0.484695384973449, -99.443000793457, -1.73560778190916, 218, 51, 'PPL', 'P'),
(188933, 'Los Vigiles', 35.6494407653809, 0.622200117850583, -105.263061523438, -1.83718700431334, 218, 38, 'PPL', 'P'),
(95875, 'Los Villareales', 26.3938903808594, 0.460660289556456, -98.8811111450195, -1.72580095751105, 218, 51, 'PPL', 'P'),
(191802, 'Los Ybanez', 32.7188911437988, 0.571052378060903, -101.916938781738, -1.77878614529483, 218, 51, 'PPL', 'P'),
(123097, 'Losantville', 40.024169921875, 0.6985535455144, -85.1827774047852, -1.48671993170693, 218, 19, 'PPL', 'P'),
(73281, 'Losantville Triangle', 39.1283302307129, 0.682918193333572, -84.5022201538086, -1.47484196692907, 218, 41, 'PPL', 'P'),
(163975, 'Loschs', 40.6444396972656, 0.709379295345572, -77.1458282470703, -1.34644870708942, 218, 45, 'PPL', 'P'),
(163976, 'Losh Run', 40.4550018310547, 0.706072980852239, -77.0319366455078, -1.34446092365179, 218, 45, 'PPL', 'P'),
(110194, 'Losie (historical)', 38.6780586242676, 0.675059471272858, -81.0361099243164, -1.41434693118737, 218, 58, 'PPL', 'P'),
(95876, 'Losoya', 29.2333297729492, 0.51021785585925, -98.4561080932617, -1.71838325492685, 218, 51, 'PPL', 'P'),
(204745, 'Lost Acres', 40.7144393920898, 0.710601020495646, -111.65193939209, -1.94869395862912, 218, 52, 'PPL', 'P'),
(10198, 'Lost Bridge Village', 36.3883285522461, 0.635096142534156, -93.9066696166992, -1.63898057439392, 218, 4, 'PPL', 'P'),
(209577, 'Lost Cabin', 43.2863883972168, 0.755489998828504, -107.631942749023, -1.8785317812885, 218, 59, 'PPL', 'P'),
(10199, 'Lost Cane', 35.7999992370605, 0.624827858898165, -90.1272201538086, -1.57301673735375, 218, 4, 'PPL', 'P'),
(116610, 'Lost Canyon Mobile Home Park', 42.4486083984375, 0.740867979442451, -90.7799987792969, -1.58440987365516, 218, 16, 'PPL', 'P'),
(36972, 'Lost City', 36.9769401550293, 0.645369353018164, -86.9049987792969, -1.51677836514038, 218, 21, 'PPL', 'P'),
(76450, 'Lost City', 35.9877815246582, 0.628105278093671, -95.1361083984375, -1.66043832908696, 218, 42, 'PPL', 'P'),
(110197, 'Lost City', 38.9297218322754, 0.679451822858725, -78.8344421386719, -1.37592057929278, 218, 58, 'PPL', 'P'),
(182976, 'Lost City', 38.086669921875, 0.66473779125701, -120.748611450195, -2.10746083701723, 218, 6, 'PPL', 'P'),
(190432, 'Lost City (historical)', 36.4880599975586, 0.636836784622632, -114.378608703613, -1.99628331572829, 218, 39, 'PPL', 'P'),
(10201, 'Lost Corner', 35.5716705322266, 0.620842771221997, -92.8338928222656, -1.62025708719207, 218, 4, 'PPL', 'P'),
(103830, 'Lost Corner', 39.0927810668945, 0.682297743378611, -78.0997161865234, -1.36309719232794, 218, 53, 'PPL', 'P'),
(66489, 'Lost Cove', 36.0708312988281, 0.629554770095973, -82.4024963378906, -1.43819487295876, 218, 33, 'PPL', 'P'),
(36973, 'Lost Creek', 37.4816703796387, 0.654178557271928, -83.3252792358398, -1.45430047280907, 218, 21, 'PPL', 'P'),
(82184, 'Lost Creek', 34.1105613708496, 0.595341605624916, -81.1369400024414, -1.4161067480357, 218, 48, 'PPL', 'P'),
(88684, 'Lost Creek', 35.8772201538086, 0.626175618146826, -85.3625030517578, -1.48985673599688, 218, 50, 'PPL', 'P'),
(95878, 'Lost Creek', 30.295280456543, 0.528752391781766, -97.8441696166992, -1.7077029136912, 218, 51, 'PPL', 'P'),
(110196, 'Lost Creek', 39.1611099243164, 0.683490306914749, -80.3522186279297, -1.40241077633969, 218, 58, 'PPL', 'P'),
(163977, 'Lost Creek', 40.8063888549805, 0.712205841368528, -76.2472229003906, -1.33076508511384, 218, 45, 'PPL', 'P'),
(196945, 'Lost Creek', 46.1758308410645, 0.805920283020517, -112.948333740234, -1.97132030840849, 218, 31, 'PPL', 'P'),
(207959, 'Lost Creek', 48.6094398498535, 0.848394772930082, -117.362503051758, -2.04836209663507, 218, 56, 'PPL', 'P'),
(88683, 'Lost Creek (historical)', 36.3208312988281, 0.633918093225959, -83.8772201538086, -1.4639336591041, 218, 50, 'PPL', 'P'),
(196946, 'Lost Creek (historical)', 47.5166702270508, 0.829322345046398, -105.58332824707, -1.84277671312531, 218, 31, 'PPL', 'P'),
(55997, 'Lost Creek Landing', 37.0222206115723, 0.646159646071645, -90.3063888549805, -1.57614382110572, 218, 29, 'PPL', 'P'),
(191803, 'Lost Creek Place', 29.6088905334473, 0.516772627671235, -100.179168701172, -1.7484563357463, 218, 51, 'PPL', 'P'),
(178561, 'Lost Dutchman Mobile Home Park', 33.4172210693359, 0.583240534526732, -111.598892211914, -1.94776811067616, 218, 5, 'PPL', 'P'),
(49080, 'Lost Eden', 39.5319404602051, 0.689962520732941, -77.4972229003906, -1.35258170076377, 218, 25, 'PPL', 'P'),
(178562, 'Lost Eden', 34.6316719055176, 0.6044367002217, -111.260276794434, -1.94185815674311, 218, 5, 'PPL', 'P'),
(103831, 'Lost Forest', 37.3841705322266, 0.652476863914394, -77.466667175293, -1.35204840275548, 218, 53, 'PPL', 'P'),
(60696, 'Lost Gap', 32.3416709899902, 0.564468644372064, -88.8069381713867, -1.54997346970573, 218, 30, 'PPL', 'P'),
(182977, 'Lost Hills', 35.6163902282715, 0.621623277158472, -119.693328857422, -2.08904268123435, 218, 6, 'PPL', 'P'),
(60697, 'Lost Lake', 34.7836112976074, 0.607088542877147, -90.2438888549805, -1.57505299032322, 218, 30, 'PPL', 'P'),
(175061, 'Lost Lake', 43.4588890075684, 0.758500702440839, -88.9888916015625, -1.5531491561476, 218, 57, 'PPL', 'P'),
(196947, 'Lost Lake (historical)', 48.6416702270508, 0.848957299131334, -108.277778625488, -1.88980374376031, 218, 31, 'PPL', 'P'),
(201160, 'Lost Lake Resort', 45.4977798461914, 0.794086060663559, -121.817497253418, -2.12611641361129, 218, 43, 'PPL', 'P'),
(131835, 'Lost Lake Woods', 44.7769393920898, 0.781505021357916, -83.4244384765625, -1.45603112804346, 218, 27, 'PPL', 'P'),
(22747, 'Lost Meadows', 33.936939239502, 0.59231132777857, -84.7555618286133, -1.47926361328693, 218, 13, 'PPL', 'P'),
(22745, 'Lost Mountain', 33.940559387207, 0.592374511275432, -84.7024993896484, -1.47833749901785, 218, 13, 'PPL', 'P'),
(22746, 'Lost Mountain Woods', 33.938060760498, 0.592330902012582, -84.7319412231445, -1.47885135595018, 218, 13, 'PPL', 'P'),
(116613, 'Lost Nation', 41.9638900756836, 0.732408048765651, -90.817497253418, -1.58506434549305, 218, 16, 'PPL', 'P'),
(120437, 'Lost Nation', 41.9111099243164, 0.731486861344593, -89.3666687011719, -1.55974261037441, 218, 18, 'PPL', 'P'),
(144079, 'Lost Nation', 44.5094413757324, 0.776836300229925, -71.491943359375, -1.24776980027039, 218, 36, 'PPL', 'P'),
(172202, 'Lost Nation', 44.6969413757324, 0.780108792577415, -71.8441696166992, -1.25391730817267, 218, 55, 'PPL', 'P'),
(95879, 'Lost Prairie', 31.4986305236816, 0.54975481250743, -96.3716888427734, -1.68200327601388, 218, 51, 'PPL', 'P'),
(30378, 'Lost River', 38.6069412231445, 0.673818238467799, -86.4513931274414, -1.50886145300985, 218, 19, 'PPL', 'P'),
(36974, 'Lost River', 36.9527816772461, 0.644947708038577, -86.4752807617188, -1.5092783708785, 218, 21, 'PPL', 'P'),
(144080, 'Lost River', 44.0369415283203, 0.768589622177413, -71.7847213745117, -1.25287974061198, 218, 36, 'PPL', 'P'),
(195261, 'Lost River', 43.6891708374023, 0.762519878578959, -113.370559692383, -1.97868954146085, 218, 17, 'PPL', 'P'),
(73282, 'Lost Run (historical)', 39.5541687011719, 0.690350476724738, -82.2319412231445, -1.43521812465033, 218, 41, 'PPL', 'P'),
(33141, 'Lost Springs', 38.5661087036133, 0.673105576560094, -96.9661102294922, -1.69237788635639, 218, 20, 'PPL', 'P'),
(209578, 'Lost Springs', 42.7655601501465, 0.746399831079737, -104.92472076416, -1.83128184407026, 218, 59, 'PPL', 'P'),
(49081, 'Lost Valley', 39.7155609130859, 0.693167302209715, -77.3936080932617, -1.35077328122555, 218, 25, 'PPL', 'P'),
(150395, 'Lost Valley', 42.8486099243164, 0.74784932308204, -74.2724990844727, -1.29629965270852, 218, 40, 'PPL', 'P'),
(201161, 'Lost Valley (historical)', 45.0563888549805, 0.786382334578287, -119.998611450195, -2.09437086762728, 218, 43, 'PPL', 'P'),
(150396, 'Lost Village', 44.6194381713867, 0.778756106480736, -75.4927825927734, -1.31759761773616, 218, 40, 'PPL', 'P'),
(120438, 'Lostant', 41.1427803039551, 0.71807697972869, -89.0599975585938, -1.55439018921557, 218, 18, 'PPL', 'P'),
(201162, 'Lostine', 45.4874992370605, 0.793906630185115, -117.428611755371, -2.04951591117734, 218, 43, 'PPL', 'P'),
(198552, 'Lostwood', 48.4755592346191, 0.846058115389646, -102.423606872559, -1.78762917169444, 218, 34, 'PPL', 'P'),
(545, 'Lot', 36.600830078125, 0.638804993826255, -84.0877838134766, -1.46760868825036, 218, 21, 'PPL', 'P'),
(3871, 'Lot (historical)', 34.2694396972656, 0.598114555530934, -86.1358337402344, -1.50335390271751, 218, 2, 'PPL', 'P'),
(82185, 'Lota', 34.252498626709, 0.597818878070908, -82.045280456543, -1.43196027968883, 218, 48, 'PPL', 'P'),
(36975, 'Lothair', 37.2419395446777, 0.649994464883304, -83.1808319091797, -1.45177939136315, 218, 21, 'PPL', 'P'),
(112276, 'Lothair', 32.3549995422363, 0.564701271493282, -82.6555633544922, -1.44261172562666, 218, 13, 'PPL', 'P'),
(196948, 'Lothair', 48.4716682434082, 0.845990204781849, -111.231391906738, -1.94135402034876, 218, 31, 'PPL', 'P'),
(49083, 'Lothair Station', 38.4352798461914, 0.67082218224146, -76.9663925170898, -1.34331696280554, 218, 25, 'PPL', 'P'),
(49084, 'Lothian', 38.8316688537598, 0.67774047554224, -76.6116714477539, -1.33712591221944, 218, 25, 'PPL', 'P'),
(49085, 'Lothian Estates', 38.8236083984375, 0.677599794057657, -76.6508331298828, -1.33780941251321, 218, 25, 'PPL', 'P'),
(49086, 'Lothian Woods', 38.8233299255371, 0.677594933788668, -76.6469421386719, -1.33774150190541, 218, 25, 'PPL', 'P'),
(196949, 'Lothrop', 46.9908294677734, 0.820144692455821, -114.446113586426, -1.99746149819455, 218, 31, 'PPL', 'P'),
(76452, 'Lotsee', 36.1333312988281, 0.63064560087847, -96.2091674804688, -1.67916674313684, 218, 42, 'PPL', 'P'),
(3872, 'Lott', 30.8111095428467, 0.537755307715319, -88.2513885498047, -1.54027729965092, 218, 2, 'PPL', 'P'),
(95880, 'Lott', 31.2033290863037, 0.544600830139314, -97.0363922119141, -1.69360453835448, 218, 51, 'PPL', 'P'),
(88685, 'Lott Landing', 35.399169921875, 0.617832067609663, -88.0933303833008, -1.53751866423576, 218, 50, 'PPL', 'P'),
(95881, 'Lotta', 32.5780601501465, 0.568594413532814, -94.103889465332, -1.64242271010285, 218, 51, 'PPL', 'P'),
(123099, 'Lottaville', 41.5033302307129, 0.724369763068438, -87.3647232055664, -1.52480207003063, 218, 19, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(30379, 'Lottick Corner', 38.1711082458496, 0.666211518025233, -85.9402770996094, -1.49994079546447, 218, 19, 'PPL', 'P'),
(3873, 'Lottie', 31.1288890838623, 0.543301607001518, -87.6222229003906, -1.52929628752819, 218, 2, 'PPL', 'P'),
(41877, 'Lottie', 30.5561103820801, 0.53330473277012, -91.6416702270508, -1.5994488774889, 218, 22, 'PPL', 'P'),
(16947, 'Lottieville', 29.6119403839111, 0.516825857603523, -82.898063659668, -1.44684415438907, 218, 12, 'PPL', 'P'),
(131836, 'Lottivue', 42.6594390869141, 0.744547669120614, -82.7619400024414, -1.44446834838061, 218, 27, 'PPL', 'P'),
(73283, 'Lottridge', 39.2272186279297, 0.684644121457025, -81.8974990844727, -1.42938100817309, 218, 41, 'PPL', 'P'),
(22748, 'Lotts', 31.5874996185303, 0.551305870815806, -82.8583297729492, -1.44615066724121, 218, 13, 'PPL', 'P'),
(22749, 'Lotts (historical)', 31.3138904571533, 0.546530490086158, -81.7330627441406, -1.42651105262437, 218, 13, 'PPL', 'P'),
(116620, 'Lotts Creek', 43.1566696166992, 0.753225979006801, -94.3661117553711, -1.64699935243615, 218, 16, 'PPL', 'P'),
(82187, 'Lotts Crossroads', 33.040828704834, 0.576671248486807, -80.2494430541992, -1.40061700418747, 218, 48, 'PPL', 'P'),
(103832, 'Lottsburg', 37.9608306884766, 0.662541482306022, -76.519172668457, -1.33551150396663, 218, 53, 'PPL', 'P'),
(163978, 'Lottsville', 41.9516716003418, 0.732194796141363, -79.4336090087891, -1.3863780139452, 218, 45, 'PPL', 'P'),
(16948, 'Lotus', 28.2472190856934, 0.493006977577531, -80.6569366455078, -1.40772910903658, 218, 12, 'PPL', 'P'),
(30380, 'Lotus', 39.6130599975586, 0.691378323747454, -84.8899993896484, -1.48160999136534, 218, 19, 'PPL', 'P'),
(36976, 'Lotus', 37.9188919067383, 0.661809512480414, -85.5966720581055, -1.49394375616377, 218, 21, 'PPL', 'P'),
(41878, 'Lotus', 31.485279083252, 0.549521785912048, -93.1302795410156, -1.62543001129344, 218, 22, 'PPL', 'P'),
(120439, 'Lotus', 40.3188896179199, 0.703697374580861, -88.4558334350586, -1.54384553603746, 218, 18, 'PPL', 'P'),
(182978, 'Lotus', 38.8016700744629, 0.677216898071931, -120.907501220703, -2.11023398666033, 218, 6, 'PPL', 'P'),
(195262, 'Lotus', 47.2299995422363, 0.824318997727439, -116.616386413574, -2.03533990469485, 218, 17, 'PPL', 'P'),
(120440, 'Lotus Woods', 42.4219398498535, 0.740402525462933, -88.1730575561523, -1.53891016590532, 218, 18, 'PPL', 'P'),
(150397, 'Lotville', 43.1172218322754, 0.752537485285988, -74.6991729736328, -1.30374651690666, 218, 40, 'PPL', 'P'),
(3875, 'Lou', 31.9188899993896, 0.55708972407124, -88.2111129760742, -1.53957435828119, 218, 2, 'PPL', 'P'),
(49091, 'Lou Mar Estates', 39.4727783203125, 0.68892994659929, -76.2891693115234, -1.3314971880975, 218, 25, 'PPL', 'P'),
(10203, 'Louann', 33.3908309936523, 0.582779940816203, -92.7916717529297, -1.61952019051844, 218, 4, 'PPL', 'P'),
(163979, 'Loucks Mills', 41.8450012207031, 0.730333046802316, -77.7013931274414, -1.35614514346035, 218, 45, 'PPL', 'P'),
(36977, 'Louden', 36.7516708374023, 0.641437661721852, -84.0258331298828, -1.46652744484779, 218, 21, 'PPL', 'P'),
(71048, 'Louden', 39.7755584716797, 0.694214457150334, -74.875, -1.30681527743075, 218, 37, 'PPL', 'P'),
(73284, 'Louden', 39.026668548584, 0.681143862257307, -83.4527816772461, -1.45652581021594, 218, 41, 'PPL', 'P'),
(163980, 'Louden Hill', 41.771671295166, 0.729053198161451, -75.8986129760742, -1.32468069412939, 218, 45, 'PPL', 'P'),
(110199, 'Loudendale', 38.3038902282715, 0.66852900080582, -81.6530609130859, -1.42511475726484, 218, 58, 'PPL', 'P'),
(110200, 'Loudenville', 39.8352813720703, 0.695256818400991, -80.5997161865234, -1.4067304236278, 218, 58, 'PPL', 'P'),
(88686, 'Loudon', 35.732780456543, 0.623654669858957, -84.3338928222656, -1.47190410077255, 218, 50, 'PPL', 'P'),
(144081, 'Loudon', 43.2855606079102, 0.755475551179591, -71.4677810668945, -1.24734808871178, 218, 36, 'PPL', 'P'),
(156235, 'Loudon', 40.5694389343262, 0.708070285090771, -81.501106262207, -1.42246264829328, 218, 41, 'PPL', 'P'),
(144082, 'Loudon Center', 43.3358306884766, 0.756352929600717, -71.4022216796875, -1.24620386154942, 218, 36, 'PPL', 'P'),
(88687, 'Loudon City Park', 35.7244415283203, 0.623509128105385, -84.3775024414063, -1.47266523221209, 218, 50, 'PPL', 'P'),
(110201, 'Loudon Heights', 38.3300018310547, 0.66898473424736, -81.6305618286133, -1.4247220741621, 218, 58, 'PPL', 'P'),
(150398, 'Loudonville', 42.704719543457, 0.745337962174095, -73.7552795410156, -1.28727246871953, 218, 40, 'PPL', 'P'),
(156238, 'Loudonville', 40.6352806091309, 0.70921943910114, -82.2333297729492, -1.43524235941624, 218, 41, 'PPL', 'P'),
(103834, 'Loudoun Heights', 39.313060760498, 0.686142349307277, -77.7180633544922, -1.35643609380944, 218, 53, 'PPL', 'P'),
(125269, 'Loudville', 42.2874984741211, 0.738056080805491, -72.7380599975586, -1.26951863847058, 218, 23, 'PPL', 'P'),
(128002, 'Loudville', 43.9286117553711, 0.766698910961511, -69.4313888549805, -1.21180633975191, 218, 26, 'PPL', 'P'),
(36984, 'Louellen', 36.9127807617188, 0.644249560358813, -83.0941696166992, -1.45026684902204, 218, 21, 'PPL', 'P'),
(95882, 'Louetta', 30.0063896179199, 0.523710295468946, -95.5608291625977, -1.66785110482314, 218, 51, 'PPL', 'P'),
(55999, 'Loughboro', 37.7783317565918, 0.65935627506326, -90.5219421386719, -1.57990593561962, 218, 29, 'PPL', 'P'),
(16949, 'Loughman', 28.2416706085205, 0.492910138382393, -81.5669403076172, -1.4236116691456, 218, 12, 'PPL', 'P'),
(60699, 'Louin', 32.0711097717285, 0.55974646028519, -89.2608337402344, -1.55789544184233, 218, 30, 'PPL', 'P'),
(3874, 'Louina', 33.124439239502, 0.578130527606116, -85.5522232055664, -1.49316797733823, 218, 2, 'PPL', 'P'),
(76453, 'Louis', 34.5652809143066, 0.603277958831407, -99.8011093139648, -1.74185795467147, 218, 42, 'PPL', 'P'),
(95883, 'Louis and J Hoyt Subdivision Colonia', 26.2730007171631, 0.458550366893327, -97.9899978637695, -1.71024809674499, 218, 51, 'PPL', 'P'),
(131838, 'Louis Cabin Landing', 44.6650009155273, 0.779551326382234, -84.6366729736328, -1.47718861132359, 218, 27, 'PPL', 'P'),
(175062, 'Louis Corners', 43.9352798461914, 0.766815291101148, -87.9519424438477, -1.53505097916969, 218, 57, 'PPL', 'P'),
(191804, 'Louis Granger Place', 30.148609161377, 0.526192494762954, -103.181106567383, -1.80085003545197, 218, 51, 'PPL', 'P'),
(49087, 'Louis Heights', 38.4269409179688, 0.670676640487887, -75.1661071777344, -1.31189605615841, 218, 25, 'PPL', 'P'),
(36978, 'Louisa', 38.1141700744629, 0.66521775946447, -82.6033325195313, -1.44170012558552, 218, 21, 'PPL', 'P'),
(103835, 'Louisa', 38.0250015258789, 0.663661474702455, -78.0044403076172, -1.3614343145433, 218, 53, 'PPL', 'P'),
(116616, 'Louisa', 42.0313911437988, 0.733586164652875, -91.6672210693359, -1.59989482381343, 218, 16, 'PPL', 'P'),
(33143, 'Louisburg', 38.6194381713867, 0.674036351361076, -94.6805572509766, -1.65248746165253, 218, 20, 'PPL', 'P'),
(56000, 'Louisburg', 37.7577781677246, 0.658997547264426, -93.1391677856445, -1.62558514042693, 218, 29, 'PPL', 'P'),
(66490, 'Louisburg', 36.0988883972168, 0.630044458841412, -78.3013916015625, -1.3666170923407, 218, 33, 'PPL', 'P'),
(136591, 'Louisburg', 45.1661109924316, 0.788297347139136, -96.1708297729492, -1.67849762391295, 218, 28, 'PPL', 'P'),
(175063, 'Louisburg', 42.5791702270508, 0.743146713229178, -90.5555572509766, -1.58049263000777, 218, 57, 'PPL', 'P'),
(10204, 'Louise', 35.0763893127441, 0.612198483218736, -90.2936096191406, -1.57592078136443, 218, 4, 'PPL', 'P'),
(16950, 'Louise', 29.8372192382813, 0.520757715347402, -82.2313919067383, -1.4352085372704, 218, 12, 'PPL', 'P'),
(22750, 'Louise', 33.0838890075684, 0.577422792546427, -84.9358291625977, -1.48240987179875, 218, 13, 'PPL', 'P'),
(60700, 'Louise', 32.9822196960449, 0.575648328312107, -90.5886077880859, -1.58106947069988, 218, 30, 'PPL', 'P'),
(88689, 'Louise', 36.3708305358887, 0.634790744536151, -87.399169921875, -1.52540327864671, 218, 50, 'PPL', 'P'),
(95884, 'Louise', 29.1111106872559, 0.508084730405124, -96.4030609130859, -1.682550821934, 218, 51, 'PPL', 'P'),
(116618, 'Louise', 42.3600006103516, 0.739321481797442, -92.2986068725586, -1.61091458493001, 218, 16, 'PPL', 'P'),
(177240, 'Louise', 40.3038902282715, 0.703435585845706, -80.565559387207, -1.40613427501779, 218, 58, 'PPL', 'P'),
(41880, 'Louisiana', 31.000280380249, 0.541056961676745, -92.0002822875977, -1.6057078386828, 218, 22, 'ADM1', 'A'),
(56001, 'Louisiana', 39.4488906860352, 0.688513028730638, -91.0513916015625, -1.58914657196998, 218, 29, 'PPL', 'P'),
(3876, 'Louisville', 31.7833309173584, 0.554723771758814, -85.5558319091797, -1.49323096109801, 218, 2, 'PPL', 'P'),
(22751, 'Louisville', 33.0013885498047, 0.575982887924049, -82.4113922119141, -1.43835013525031, 218, 13, 'PPL', 'P'),
(27754, 'Louisville', 38.7722206115723, 0.676702907981546, -88.5025024414063, -1.54466006385686, 218, 18, 'PPL', 'P'),
(33146, 'Louisville', 39.2502784729004, 0.685046591676764, -96.3144378662109, -1.68100405797288, 218, 20, 'PPL', 'P'),
(36979, 'Louisville', 38.2541694641113, 0.667661209764618, -85.7594375610352, -1.49678455009856, 218, 21, 'PPL', 'P'),
(49088, 'Louisville', 39.4486083984375, 0.688508101882621, -76.9241714477539, -1.34258006613192, 218, 25, 'PPL', 'P'),
(56003, 'Louisville', 39.1997184753418, 0.684164153249566, -91.1744384765625, -1.59129414507302, 218, 29, 'PPL', 'P'),
(60701, 'Louisville', 33.1236114501953, 0.578116079957202, -89.0550003051758, -1.55430297068987, 218, 30, 'PPL', 'P'),
(88691, 'Louisville', 35.8216705322266, 0.625206094351983, -84.0480575561523, -1.46691533426056, 218, 50, 'PPL', 'P'),
(142307, 'Louisville', 40.9977798461914, 0.715546244323814, -96.1619415283203, -1.67834249477946, 218, 35, 'PPL', 'P'),
(150399, 'Louisville', 44.8974990844727, 0.783609184935188, -75.01611328125, -1.30927816880686, 218, 40, 'PPL', 'P'),
(156239, 'Louisville', 40.8372192382813, 0.712743933066779, -81.2597198486328, -1.41824966060683, 218, 41, 'PPL', 'P'),
(187005, 'Louisville', 39.9777793884277, 0.697743877963989, -105.131393432617, -1.83488896260871, 218, 7, 'PPL', 'P'),
(196950, 'Louisville', 46.5627784729004, 0.812673793228849, -111.794998168945, -1.95119080530913, 218, 31, 'PPL', 'P'),
(41881, 'Louisville (historical)', 30.2247200012207, 0.527520879514686, -91.0008316040039, -1.58826413354278, 218, 22, 'PPL', 'P'),
(150400, 'Louisville Corner', 44.9091682434082, 0.783812850179551, -75.0286102294922, -1.30949628170014, 218, 40, 'PPL', 'P'),
(36980, 'Louisville-Jefferson County', 38.209171295166, 0.666875843559153, -85.7038879394531, -1.49581502630372, 218, 21, 'PPL', 'P'),
(36981, 'Louisville-Jefferson County (Balance)', 38.209171295166, 0.666875843559153, -85.7038879394531, -1.49581502630372, 218, 21, 'PPL', 'P'),
(150402, 'Lounsberry', 42.0580596923828, 0.734051618632394, -76.3361129760742, -1.33231650960686, 218, 40, 'PPL', 'P'),
(142310, 'Loup City', 41.2755584716797, 0.720394395930249, -98.9663925170898, -1.7272893982443, 218, 35, 'PPL', 'P'),
(116619, 'Lourdes', 43.2622184753418, 0.755068154111836, -92.2986068725586, -1.61091458493001, 218, 16, 'PPL', 'P'),
(95885, 'Lourdes Street Colonia', 26.125560760498, 0.455977054200525, -97.4738922119141, -1.70124035383196, 218, 51, 'PPL', 'P'),
(49089, 'Lourds Manor', 39.1091690063477, 0.682583766879686, -76.5438919067383, -1.33594293606322, 218, 25, 'PPL', 'P'),
(136595, 'Louriston', 45.0944404602051, 0.787046460375126, -95.4516677856445, -1.6659458793793, 218, 28, 'PPL', 'P'),
(103838, 'Lousetown', 38.6388893127441, 0.674375837821034, -77.8525009155273, -1.35878247188785, 218, 53, 'PPL', 'P'),
(110202, 'Louther', 38.7966690063477, 0.677129612967203, -81.5497207641602, -1.42331113141658, 218, 58, 'PPL', 'P'),
(22752, 'Louvale', 32.1749992370605, 0.56155967351337, -84.8252792358398, -1.48048041158898, 218, 13, 'PPL', 'P'),
(22753, 'Louvale Station', 32.1513900756836, 0.561147615913708, -84.8363876342773, -1.48067428971634, 218, 13, 'PPL', 'P'),
(187006, 'Louviers', 39.4777793884277, 0.689017231704017, -105.00666809082, -1.83271209473368, 218, 7, 'PPL', 'P'),
(163981, 'Loux Corner', 40.3469390869141, 0.704186930168245, -75.2238922119141, -1.31290459526322, 218, 45, 'PPL', 'P'),
(163982, 'Louxs Corner', 40.4633293151855, 0.70621832286873, -75.3111114501953, -1.31442685814231, 218, 45, 'PPL', 'P'),
(110203, 'Lovada', 38.9630584716797, 0.68003365697788, -81.0733337402344, -1.4149966093353, 218, 58, 'PPL', 'P'),
(188934, 'Lovato', 35.2872200012207, 0.615878172896899, -105.391387939453, -1.8394267227901, 218, 38, 'PPL', 'P'),
(182979, 'Lovdal', 38.6002807617188, 0.673701991486217, -121.551391601563, -2.12147199382825, 218, 6, 'PPL', 'P'),
(36982, 'Love', 37.2830581665039, 0.650712120218053, -86.5272216796875, -1.51018491091357, 218, 21, 'PPL', 'P'),
(60702, 'Love', 34.7533302307129, 0.60656003855882, -89.9700012207031, -1.57027274932459, 218, 30, 'PPL', 'P'),
(95886, 'Love', 32.9705581665039, 0.575444796225798, -94.6086120605469, -1.65123178119856, 218, 51, 'PPL', 'P'),
(103839, 'Love', 37.8852806091309, 0.661222884671296, -79.0102767944336, -1.37898947297494, 218, 53, 'PPL', 'P'),
(120441, 'Love', 41.5691719055176, 0.725518917078807, -89.8058319091797, -1.56740745430777, 218, 18, 'PPL', 'P'),
(178563, 'Love', 33.8522186279297, 0.59083267416233, -113.464996337891, -1.9803377718595, 218, 5, 'PPL', 'P'),
(10206, 'Love (historical)', 36.1480598449707, 0.63090266250269, -91.6933288574219, -1.60035049067594, 218, 4, 'PPL', 'P'),
(10207, 'Love Creek', 34.0252799987793, 0.593853164891671, -93.3147201538086, -1.62864910726107, 218, 4, 'PPL', 'P'),
(41882, 'Love Estates', 32.5302810668945, 0.567760511216483, -91.9891662597656, -1.60551382739739, 218, 22, 'PPL', 'P'),
(66491, 'Love Field', 35.357780456543, 0.617109685163979, -83.2016677856445, -1.45214304601, 218, 33, 'PPL', 'P'),
(3879, 'Love Hill', 31.1158294677734, 0.543073673701721, -85.2738876342773, -1.48831010519382, 218, 2, 'PPL', 'P'),
(22754, 'Love Hill', 34.9186096191406, 0.609444708072567, -85.1463928222656, -1.486084900945, 218, 13, 'PPL', 'P'),
(88692, 'Love Lady', 36.589168548584, 0.638601461739945, -85.1594390869141, -1.4863126012182, 218, 50, 'PPL', 'P'),
(56006, 'Love Lake', 39.9555587768555, 0.697356055130246, -92.4855575561523, -1.61417748989758, 218, 29, 'PPL', 'P'),
(10208, 'Love Place', 35.3163909912109, 0.616387302718295, -90.5736083984375, -1.58080768196472, 218, 4, 'PPL', 'P'),
(49090, 'Love Point', 39.0319404602051, 0.681235874472969, -76.3116683959961, -1.33188987120023, 218, 25, 'PPL', 'P'),
(82186, 'Love Springs', 35.0458297729492, 0.611665118631421, -81.7750015258789, -1.42724302244997, 218, 48, 'PPL', 'P'),
(88693, 'Love Station', 36.1205596923828, 0.63042269429523, -82.4347229003906, -1.43875733258099, 218, 50, 'PPL', 'P'),
(66496, 'Love Valley', 35.9897193908691, 0.628139100239515, -80.9883270263672, -1.41351296229202, 218, 33, 'PPL', 'P'),
(16951, 'Lovedale', 30.8797206878662, 0.538952798099474, -85.0430603027344, -1.4842814082548, 218, 12, 'PPL', 'P'),
(163983, 'Lovedale', 40.2775001525879, 0.702974992135177, -79.8680572509766, -1.39396056620087, 218, 45, 'PPL', 'P'),
(22755, 'Lovejoy', 33.4361114501953, 0.583570233869684, -84.3144378662109, -1.47156454773356, 218, 13, 'PPL', 'P'),
(56007, 'Lovejoy', 37.5333290100098, 0.655080170458974, -89.5280609130859, -1.56255943585939, 218, 29, 'PPL', 'P'),
(66494, 'Lovejoy', 35.4225006103516, 0.618239264940336, -79.9197235107422, -1.39486231254597, 218, 33, 'PPL', 'P'),
(88695, 'Lovejoy', 36.189998626709, 0.631634632328298, -85.1680603027344, -1.48646306981979, 218, 50, 'PPL', 'P'),
(163984, 'Lovejoy', 40.707218170166, 0.710474986397058, -78.9583282470703, -1.37808279978182, 218, 45, 'PPL', 'P'),
(182980, 'Lovejoy (historical)', 39.9452781677246, 0.697176624651802, -120.657218933105, -2.10586573668233, 218, 6, 'PPL', 'P'),
(49092, 'Lovejoy Estates', 39.5188903808594, 0.689734753880712, -77.2022171020508, -1.34743287827026, 218, 25, 'PPL', 'P'),
(144084, 'Lovejoy Sands', 43.6488914489746, 0.761816870630205, -71.4272232055664, -1.24664022049403, 218, 36, 'PPL', 'P'),
(22756, 'Lovelace', 33.7911109924316, 0.589766144724781, -82.5711135864258, -1.44113779912135, 218, 13, 'PPL', 'P'),
(60704, 'Lovelace', 31.2122192382813, 0.544755992562324, -89.8591690063477, -1.56833836226681, 218, 30, 'PPL', 'P'),
(88694, 'Lovelace', 36.4075012207031, 0.635430768725124, -82.6569366455078, -1.44263569407647, 218, 50, 'PPL', 'P'),
(95887, 'Lovelace', 32.0888900756836, 0.560056785131211, -97.1283264160156, -1.69520909291126, 218, 51, 'PPL', 'P'),
(188935, 'Lovelace', 33.7680587768555, 0.589363807663097, -106.040832519531, -1.85076166902169, 218, 38, 'PPL', 'P'),
(66495, 'Lovelace (historical)', 36.0722198486328, 0.629579004861893, -80.9538879394531, -1.41291188683398, 218, 33, 'PPL', 'P'),
(3877, 'Lovelace Crossroads', 34.8608283996582, 0.608436235546781, -87.7566680908203, -1.53164279876466, 218, 2, 'PPL', 'P'),
(36983, 'Lovelaceville', 36.9686088562012, 0.645223944422645, -88.8308334350586, -1.55039052073244, 218, 21, 'PPL', 'P'),
(95888, 'Lovelady', 31.1266708374023, 0.543262891297171, -95.4452819824219, -1.66583442608768, 218, 51, 'PPL', 'P'),
(66498, 'Lovelady (historical)', 35.7944412231445, 0.624730853255458, -81.5686111450195, -1.42364083075953, 218, 33, 'PPL', 'P'),
(73286, 'Loveland', 39.2688903808594, 0.685371430750726, -84.2638931274414, -1.47068237562247, 218, 41, 'PPL', 'P'),
(76455, 'Loveland', 34.3052787780762, 0.598740065491966, -98.7713928222656, -1.72388601152923, 218, 42, 'PPL', 'P'),
(88696, 'Loveland', 36.0180587768555, 0.62863371583297, -83.8691711425781, -1.4637931773566, 218, 50, 'PPL', 'P'),
(116621, 'Loveland', 41.4972190856934, 0.72426310346678, -95.8897171020508, -1.6735912822367, 218, 16, 'PPL', 'P'),
(125270, 'Loveland', 42.0325012207031, 0.733605539149805, -71.8399963378906, -1.25384447071686, 218, 23, 'PPL', 'P'),
(150404, 'Loveland', 42.7333297729492, 0.745837304878485, -78.6991729736328, -1.37355968698643, 218, 40, 'PPL', 'P'),
(194300, 'Loveland', 40.3977813720703, 0.705074295443459, -105.074440002441, -1.83389493773184, 218, 7, 'PPL', 'P'),
(207960, 'Loveland', 47.0641708374023, 0.821424740833768, -122.407783508301, -2.13641885228826, 218, 56, 'PPL', 'P'),
(194301, 'Loveland Heights', 40.389720916748, 0.704933613958876, -105.463607788086, -1.84068719693403, 218, 7, 'PPL', 'P'),
(73287, 'Loveland Park', 39.2997207641602, 0.685909522448977, -84.2633285522461, -1.47067252192644, 218, 41, 'PPL', 'P'),
(3878, 'Loveless', 34.3177795410156, 0.598958244964271, -85.7622222900391, -1.49683315278845, 218, 2, 'PPL', 'P'),
(3880, 'Loveless Park', 33.3244400024414, 0.58162119942591, -86.9822235107422, -1.51812619096807, 218, 2, 'PPL', 'P'),
(76457, 'Lovell', 36.0569381713867, 0.629312289278722, -97.6350021362305, -1.70405225246892, 218, 42, 'PPL', 'P'),
(88697, 'Lovell', 35.8955612182617, 0.626495730109854, -84.1372222900391, -1.46847155244355, 218, 50, 'PPL', 'P'),
(128005, 'Lovell', 44.1266708374023, 0.770155694056434, -70.892219543457, -1.23730264508, 218, 26, 'PPL', 'P'),
(156241, 'Lovell', 40.8905601501465, 0.713674907604843, -83.331672668457, -1.45441205925874, 218, 41, 'PPL', 'P'),
(163985, 'Lovell', 41.9061088562012, 0.731399576239865, -79.7024993896484, -1.39107103641814, 218, 45, 'PPL', 'P'),
(190433, 'Lovell', 36.291389465332, 0.633404236293628, -115.042221069336, -2.0078655364671, 218, 39, 'PPL', 'P'),
(209579, 'Lovell', 44.8375015258789, 0.782562029994568, -108.388893127441, -1.89174305766611, 218, 59, 'PPL', 'P'),
(125271, 'Lovell Corners', 42.1966705322266, 0.736470834166622, -70.9269409179688, -1.23790864738604, 218, 23, 'PPL', 'P'),
(88698, 'Lovell Heights', 35.8969383239746, 0.626519765138692, -84.1291732788086, -1.46833107069604, 218, 50, 'PPL', 'P'),
(95889, 'Lovell Lake', 29.9422206878662, 0.522590336362027, -94.1255569458008, -1.64280087897764, 218, 51, 'PPL', 'P'),
(163986, 'Lovell Park', 40.4799995422363, 0.706509273217821, -78.6672210693359, -1.37300202105417, 218, 45, 'PPL', 'P'),
(131839, 'Lovells', 44.8030586242676, 0.78196088795751, -84.4819412231445, -1.4744880328202, 218, 27, 'PPL', 'P'),
(125272, 'Lovellville', 42.3708305358887, 0.739510499655811, -71.8511123657227, -1.25403848200227, 218, 23, 'PPL', 'P'),
(182981, 'Lovelock', 39.8913917541504, 0.696236129312841, -121.576667785645, -2.12191314646282, 218, 6, 'PPL', 'P'),
(200056, 'Lovelock', 40.1794395446777, 0.701263511660638, -118.472503662109, -2.06773526198485, 218, 39, 'PPL', 'P'),
(163987, 'Lovelton', 41.5391693115234, 0.72499527302947, -76.188606262207, -1.32974203178108, 218, 45, 'PPL', 'P'),
(36985, 'Lovely', 37.8258285522461, 0.660185250531574, -82.4013900756836, -1.43817556504086, 218, 21, 'PPL', 'P'),
(163988, 'Lovely', 40.2094383239746, 0.701787089130947, -78.6052780151367, -1.37192091080965, 218, 45, 'PPL', 'P'),
(113658, 'Lovely Street', 41.7827796936035, 0.729247076288809, -72.8927764892578, -1.27221895065786, 218, 8, 'PPL', 'P'),
(163989, 'Lover', 40.1124992370605, 0.70009518289042, -79.9505615234375, -1.39540053740228, 218, 45, 'PPL', 'P'),
(144085, 'Loverens Mill', 43.0727806091309, 0.751761839618502, -72.0188903808594, -1.25696676077887, 218, 36, 'PPL', 'P'),
(110204, 'Loveridge', 38.0827789306641, 0.664669880649213, -80.373893737793, -1.40278907837254, 218, 58, 'PPL', 'P'),
(110205, 'Lovern', 37.4341697692871, 0.653349515224586, -80.8755569458008, -1.41154475308839, 218, 58, 'PPL', 'P'),
(49094, 'Loves', 38.5244407653809, 0.67237833384542, -76.7283325195313, -1.33916203203086, 218, 25, 'PPL', 'P'),
(27757, 'Loves Corner', 37.4955596923828, 0.654420971510152, -88.1705627441406, -1.5388666232215, 218, 18, 'PPL', 'P'),
(49095, 'Loves Folly', 38.747501373291, 0.676271475884953, -76.164436340332, -1.32932018706441, 218, 25, 'PPL', 'P'),
(103841, 'Loves Mill', 36.7472190856934, 0.641359963997049, -81.6875, -1.42571583272287, 218, 53, 'PPL', 'P'),
(120443, 'Loves Park', 42.3199996948242, 0.738623334117678, -89.0580596923828, -1.55435636706973, 218, 18, 'PPL', 'P'),
(49096, 'Loveton Farms', 39.5186080932617, 0.689729827032695, -76.6402816772461, -1.33762525492383, 218, 25, 'PPL', 'P'),
(88699, 'Lovetown', 35.6436080932617, 0.622098318517915, -87.251106262207, -1.52281908028296, 218, 50, 'PPL', 'P'),
(16952, 'Lovett', 30.628059387207, 0.534560479803119, -83.5733337402344, -1.45862984063516, 218, 12, 'PPL', 'P'),
(22757, 'Lovett', 32.6380615234375, 0.569641635052461, -82.7677764892578, -1.4445702142923, 218, 13, 'PPL', 'P'),
(30381, 'Lovett', 38.9113883972168, 0.679131844053752, -85.633056640625, -1.4945787869257, 218, 19, 'PPL', 'P'),
(188941, 'Lovett', 31.6436100006104, 0.552285181727656, -108.933326721191, -1.90124521643551, 218, 38, 'PPL', 'P'),
(103843, 'Lovettsville', 39.2724990844727, 0.685434414510507, -77.6369400024414, -1.3550202242159, 218, 53, 'PPL', 'P'),
(3881, 'Lovettville', 34.6488914489746, 0.604737237950716, -87.210563659668, -1.52211147838132, 218, 2, 'PPL', 'P'),
(14150, 'Loveville', 39.7708282470703, 0.694131899156542, -75.6647186279297, -1.32059846765246, 218, 10, 'PPL', 'P'),
(49097, 'Loveville', 38.3619384765625, 0.669542133863513, -76.6833267211914, -1.33837653266734, 218, 25, 'PPL', 'P'),
(88701, 'Loveville (historical)', 36.2397193908691, 0.6325024233695, -86.7397232055664, -1.51389376220566, 218, 50, 'PPL', 'P'),
(49098, 'Loveville Acres', 38.389720916748, 0.670027028918989, -76.6616668701172, -1.3379984969506, 218, 25, 'PPL', 'P'),
(33148, 'Lovewell', 39.8652801513672, 0.695780395871301, -97.9813919067383, -1.71009789445951, 218, 20, 'PPL', 'P'),
(163990, 'Lovi', 40.6800003051758, 0.709999945037615, -80.1547164916992, -1.39896371378275, 218, 45, 'PPL', 'P'),
(3882, 'Lovick', 33.5588912963867, 0.585713146440817, -86.6138916015625, -1.51169758641273, 218, 2, 'PPL', 'P'),
(88700, 'Lovie (historical)', 35.4480590820313, 0.618685344422924, -87.7569427490234, -1.53164759245462, 218, 50, 'PPL', 'P'),
(116623, 'Lovilia', 41.1358299255371, 0.717955672741036, -92.9038925170898, -1.62147881234214, 218, 16, 'PPL', 'P'),
(66501, 'Lovill', 36.2347183227539, 0.632415138264773, -81.7336120605469, -1.42652064000429, 218, 33, 'PPL', 'P'),
(27758, 'Lovilla', 38.1566696166992, 0.665959516407084, -88.6666717529297, -1.54752535887368, 218, 18, 'PPL', 'P'),
(22758, 'Loving', 34.9199981689453, 0.609468942838487, -84.2211074829102, -1.46993562525282, 218, 13, 'PPL', 'P'),
(36986, 'Loving', 37.0202789306641, 0.646125757346773, -86.2911071777344, -1.50606393544278, 218, 21, 'PPL', 'P'),
(76458, 'Loving', 34.8669395446777, 0.608542895148439, -94.4797210693359, -1.64898220902577, 218, 42, 'PPL', 'P'),
(95890, 'Loving', 33.2641716003418, 0.580569317374356, -98.5102767944336, -1.71932867711383, 218, 51, 'PPL', 'P'),
(188936, 'Loving', 32.2861099243164, 0.563498920840139, -104.095283508301, -1.8168054330168, 218, 38, 'PPL', 'P'),
(103844, 'Loving Fork', 38.0963897705078, 0.664907434618448, -77.3533325195313, -1.35007033985582, 218, 53, 'PPL', 'P'),
(188937, 'Loving Place', 33.1866683959961, 0.579216631277677, -104.51000213623, -1.82404363854353, 218, 38, 'PPL', 'P'),
(103845, 'Lovingston', 37.7597198486328, 0.659031435989297, -78.8711090087891, -1.37656053690273, 218, 53, 'PPL', 'P'),
(27759, 'Lovington', 39.7155609130859, 0.693167302209715, -88.6324996948242, -1.54692894394755, 218, 18, 'PPL', 'P'),
(116624, 'Lovington', 41.6458282470703, 0.726856822631435, -93.686393737793, -1.63513603504428, 218, 16, 'PPL', 'P'),
(188938, 'Lovington', 32.9438896179199, 0.574979342246279, -103.34806060791, -1.80376393315868, 218, 38, 'PPL', 'P'),
(204748, 'Low', 40.7855606079102, 0.711842319879732, -112.939720153809, -1.97116997296496, 218, 52, 'PPL', 'P'),
(36987, 'Low Gap', 36.6450004577637, 0.639575912382805, -84.9588928222656, -1.48281240859751, 218, 21, 'PPL', 'P'),
(66502, 'Low Gap', 35.871940612793, 0.62608347277311, -82.2980575561523, -1.43637207235066, 218, 33, 'PPL', 'P'),
(103846, 'Low Gap', 36.5669403076172, 0.638213505748148, -80.8988876342773, -1.41195195041907, 218, 53, 'PPL', 'P'),
(110207, 'Low Gap', 39.211109161377, 0.68436295822494, -81.133056640625, -1.41603897058596, 218, 58, 'PPL', 'P'),
(112410, 'Low Gap', 36.8669395446777, 0.643449480188326, -93.1047210693359, -1.62498393181085, 218, 29, 'PPL', 'P'),
(156242, 'Low Gap', 40.2444381713867, 0.702397951705984, -81.6311111450195, -1.42473166154203, 218, 41, 'PPL', 'P'),
(207961, 'Low Gap', 46.9861106872559, 0.82006233419911, -119.790557861328, -2.09073964748095, 218, 56, 'PPL', 'P'),
(150405, 'Low Hampton', 43.5858306884766, 0.760716252730703, -73.2988891601563, -1.27930695389911, 218, 40, 'PPL', 'P'),
(103847, 'Low Moor', 37.7886085510254, 0.659535638962677, -79.8838882446289, -1.39423686916397, 218, 53, 'PPL', 'P'),
(116625, 'Low Moor', 41.8016700744629, 0.729576775631761, -90.3547210693359, -1.576987377381, 218, 16, 'PPL', 'P'),
(145651, 'Low Moor', 40.3497200012207, 0.704235466279112, -73.9738922119141, -1.29108797961329, 218, 37, 'PPL', 'P'),
(178564, 'Low Mountain', 35.9402809143066, 0.627276236046329, -110.112777709961, -1.92183051955544, 218, 5, 'PPL', 'P'),
(201163, 'Low Pass', 44.1888885498047, 0.771241597990914, -123.452781677246, -2.15465751101367, 218, 43, 'PPL', 'P'),
(120444, 'Low Point', 40.872501373291, 0.713359722489832, -89.3133316040039, -1.55881170241538, 218, 18, 'PPL', 'P'),
(56008, 'Low Wassie', 36.9886093139648, 0.645573018262528, -91.258056640625, -1.59275355735038, 218, 29, 'PPL', 'P'),
(191806, 'Lowake', 31.5661106109619, 0.550932562210004, -100.075561523438, -1.74664804936614, 218, 51, 'PPL', 'P'),
(163992, 'Lowber', 40.2458305358887, 0.702422253050931, -79.771110534668, -1.39226852680229, 218, 45, 'PPL', 'P'),
(110208, 'Lowdell', 39.0597190856934, 0.681720702949418, -81.6113891601563, -1.42438744797114, 218, 58, 'PPL', 'P'),
(10213, 'Lowden', 35.8144416809082, 0.625079927095341, -90.0608291625977, -1.57185799596346, 218, 4, 'PPL', 'P'),
(116626, 'Lowden', 41.8574981689453, 0.730551159695593, -90.9280624389648, -1.58699407201892, 218, 16, 'PPL', 'P'),
(207962, 'Lowden', 46.0563888549805, 0.80383562709823, -118.584716796875, -2.06969375065049, 218, 56, 'PPL', 'P'),
(27761, 'Lowder', 39.5508308410645, 0.690292220075893, -89.845832824707, -1.56810560198754, 218, 18, 'PPL', 'P'),
(14151, 'Lowe', 38.5247192382813, 0.67238319411441, -75.5091705322266, -1.31788364123723, 218, 10, 'PPL', 'P'),
(66505, 'Lowe', 34.6488914489746, 0.604737237950716, -79.101936340332, -1.38058923384175, 218, 33, 'PPL', 'P'),
(187783, 'Lowe', 38.0330581665039, 0.663802089608011, -100.992218017578, -1.76264672329868, 218, 20, 'PPL', 'P'),
(191807, 'Lowe', 32.1958312988281, 0.561923261581193, -100.838333129883, -1.75996092533933, 218, 51, 'PPL', 'P'),
(194302, 'Lowe', 40.4925003051758, 0.706727452690126, -104.595001220703, -1.82552715242876, 218, 7, 'PPL', 'P'),
(3883, 'Lowe (historical)', 34.586669921875, 0.603651267437209, -86.4147186279297, -1.50822136224185, 218, 2, 'PPL', 'P'),
(110209, 'Lowe (historical)', 37.4152793884277, 0.653019815881634, -81.2680587768555, -1.4183952023604, 218, 58, 'PPL', 'P'),
(88702, 'Lowe Acres', 36.1961097717285, 0.631741291929956, -83.4361114501953, -1.45623485986685, 218, 50, 'PPL', 'P'),
(10211, 'Lowell', 36.2552795410156, 0.632773999221661, -94.1305618286133, -1.6428882306614, 218, 4, 'PPL', 'P'),
(16953, 'Lowell', 29.3302803039551, 0.511909961836859, -82.1916732788086, -1.43451531643865, 218, 12, 'PPL', 'P'),
(22759, 'Lowell', 33.4663887023926, 0.584098671608983, -85.0449981689453, -1.48431523040064, 218, 13, 'PPL', 'P'),
(33150, 'Lowell', 37.0486106872559, 0.646620239782174, -94.7013931274414, -1.65285111629938, 218, 20, 'PPL', 'P'),
(36988, 'Lowell', 37.6094398498535, 0.656408555210706, -84.4252777099609, -1.4734990679494, 218, 21, 'PPL', 'P'),
(56009, 'Lowell', 39.851390838623, 0.695537981633076, -93.3544387817383, -1.62934232809282, 218, 29, 'PPL', 'P'),
(66503, 'Lowell', 35.2677803039551, 0.615538886174023, -81.1030578613281, -1.41551539311565, 218, 33, 'PPL', 'P'),
(110210, 'Lowell', 37.6544418334961, 0.657193987995197, -80.7291717529297, -1.40898984949663, 218, 58, 'PPL', 'P'),
(116627, 'Lowell', 40.8333282470703, 0.712676022458982, -91.436393737793, -1.59586612687441, 218, 16, 'PPL', 'P'),
(120445, 'Lowell', 41.250560760498, 0.719958103564667, -89.0105590820313, -1.55352732502239, 218, 18, 'PPL', 'P'),
(123100, 'Lowell', 41.291389465332, 0.720670698893345, -87.4205627441406, -1.52577665383154, 218, 19, 'PPL', 'P'),
(125273, 'Lowell', 42.6333312988281, 0.744092002258101, -71.3166732788086, -1.24471076028427, 218, 23, 'PPL', 'P'),
(128006, 'Lowell', 45.1877784729004, 0.788675516013927, -68.4683303833008, -1.19499779853187, 218, 26, 'PPL', 'P'),
(131841, 'Lowell', 42.9336090087891, 0.749332836967268, -85.3419418334961, -1.48949787503999, 218, 27, 'PPL', 'P'),
(140424, 'Lowell', 45.9419403076172, 0.801838123122616, -99.3797225952148, -1.7345033690051, 218, 34, 'PPL', 'P'),
(142320, 'Lowell', 40.6474990844727, 0.709432691725429, -98.8469390869141, -1.72520454258493, 218, 35, 'PPL', 'P'),
(150406, 'Lowell', 43.1386108398438, 0.75291079389179, -75.501106262207, -1.31774289317362, 218, 40, 'PPL', 'P'),
(156243, 'Lowell', 41.2069396972656, 0.719196772388041, -83.0552825927734, -1.44958814241823, 218, 41, 'PPL', 'P'),
(163993, 'Lowell', 40.7299995422363, 0.710872596347807, -77.2961120605469, -1.34907165444704, 218, 45, 'PPL', 'P'),
(172203, 'Lowell', 44.7991714477539, 0.78189304392874, -72.4486083984375, -1.26446675504075, 218, 55, 'PPL', 'P'),
(175064, 'Lowell', 43.3402786254883, 0.756430560746493, -88.8169403076172, -1.55014803991519, 218, 57, 'PPL', 'P'),
(178565, 'Lowell', 31.4277801513672, 0.548518240234279, -109.893058776855, -1.91799570074378, 218, 5, 'PPL', 'P'),
(182982, 'Lowell', 38.1741714477539, 0.666264980984116, -122.252220153809, -2.13370375955693, 218, 6, 'PPL', 'P'),
(195263, 'Lowell', 46.1441688537598, 0.805367677094326, -115.594718933105, -2.01750844330012, 218, 17, 'PPL', 'P'),
(201164, 'Lowell', 43.9186096191406, 0.766524340752057, -122.782501220703, -2.14295891013523, 218, 43, 'PPL', 'P'),
(207963, 'Lowell', 47.9558296203613, 0.836987122400727, -122.195831298828, -2.13271958837609, 218, 56, 'PPL', 'P'),
(125274, 'Lowell Junction', 42.6138916015625, 0.743752715535225, -71.1624984741211, -1.24201990231885, 218, 23, 'PPL', 'P'),
(66504, 'Lowell Mill', 35.5663909912109, 0.62075062584828, -78.1611099243164, -1.36416871519254, 218, 33, 'PPL', 'P'),
(211973, 'Lowell Point', 60.0724983215332, 1.04846288560952, -149.441116333008, -2.60823951786686, 218, 1, 'PPL', 'P'),
(49099, 'Lowell Ridge', 39.4036102294922, 0.687722735677157, -76.5430603027344, -1.33592842183528, 218, 25, 'PPL', 'P'),
(128008, 'Lowells Corner (historical)', 43.8491706848145, 0.765312402718989, -70.4488906860352, -1.22956509684888, 218, 26, 'PPL', 'P'),
(128009, 'Lowelltown', 45.5138893127441, 0.794367223895644, -70.6452789306641, -1.23299271832987, 218, 26, 'PPL', 'P'),
(156244, 'Lowellville', 41.0352783203125, 0.716200716161701, -80.5366668701172, -1.40563000546538, 218, 41, 'PPL', 'P'),
(33152, 'Lowemont', 39.3805618286133, 0.687320465194501, -95.0555572509766, -1.65903244634751, 218, 20, 'PPL', 'P'),
(163994, 'Lower Allen', 40.226390838623, 0.702082966328055, -76.9008331298828, -1.34217273564319, 218, 45, 'PPL', 'P'),
(163997, 'Lower Askam', 41.1941719055176, 0.718973932383828, -75.9711074829102, -1.32594596196328, 218, 45, 'PPL', 'P'),
(71051, 'Lower Bank', 39.603328704834, 0.691208480648935, -74.5483322143555, -1.30111384901106, 218, 37, 'PPL', 'P'),
(144087, 'Lower Bartlett', 44.1022186279297, 0.769728922491749, -71.1505584716797, -1.24181150996356, 218, 36, 'PPL', 'P'),
(128011, 'Lower Beddington', 44.8013916015625, 0.781931792922601, -68.04638671875, -1.18763349232753, 218, 26, 'PPL', 'P'),
(150407, 'Lower Beechwood', 41.7580604553223, 0.728815644192216, -74.9836120605469, -1.30871091549467, 218, 40, 'PPL', 'P'),
(110211, 'Lower Belle', 38.2527809143066, 0.667636974998698, -81.5644378662109, -1.42356799330372, 218, 58, 'PPL', 'P'),
(10212, 'Lower Boydsville', 36.3338890075684, 0.634145993236243, -90.408332824707, -1.57792307903, 218, 4, 'PPL', 'P'),
(49100, 'Lower Brambley (historical)', 38.3008308410645, 0.668475604425964, -76.8111114501953, -1.34060679692222, 218, 25, 'PPL', 'P'),
(103848, 'Lower Brandon', 37.2555618286133, 0.650232218589621, -76.982780456543, -1.34360298630662, 218, 53, 'PPL', 'P'),
(201165, 'Lower Bridge (historical)', 44.3600006103516, 0.774228066837329, -121.292503356934, -2.11695354156477, 218, 43, 'PPL', 'P'),
(196951, 'Lower Bridger (historical)', 45.7027816772461, 0.797664017588081, -110.928062438965, -1.93605992241779, 218, 31, 'PPL', 'P'),
(163999, 'Lower Brownville', 40.8175010681152, 0.712399786074913, -76.2174987792969, -1.33024630133349, 218, 45, 'PPL', 'P'),
(170793, 'Lower Brule', 44.0788917541504, 0.769321791740103, -99.5811080932617, -1.73801820901179, 218, 49, 'PPL', 'P'),
(36989, 'Lower Buffalo', 37.5277786254883, 0.654983297974323, -83.6877822875977, -1.46062734461077, 218, 21, 'PPL', 'P'),
(164000, 'Lower Burrell', 40.5530586242676, 0.707784394747751, -79.7574996948242, -1.39203097283306, 218, 45, 'PPL', 'P'),
(172205, 'Lower Cabot', 44.3902816772461, 0.774756571155655, -72.3330612182617, -1.26245007630529, 218, 55, 'PPL', 'P'),
(188939, 'Lower Canones', 36.1986083984375, 0.631784901192806, -106.449996948242, -1.85790293548474, 218, 38, 'PPL', 'P'),
(131844, 'Lower Chub Landing', 44.8908309936523, 0.783492804795551, -84.5844421386719, -1.47627701128246, 218, 27, 'PPL', 'P'),
(150408, 'Lower Cincinnatus', 42.5325012207031, 0.742332185409777, -75.8986129760742, -1.32468069412939, 218, 40, 'PPL', 'P'),
(113659, 'Lower City', 41.9247207641602, 0.731724415313828, -73.2766723632813, -1.27891919764439, 218, 8, 'PPL', 'P'),
(188940, 'Lower Colonias', 35.5416717529297, 0.620319193751688, -105.583061218262, -1.8427720525934, 218, 38, 'PPL', 'P'),
(150409, 'Lower Corners', 42.9286117553711, 0.749245618441568, -74.0136108398438, -1.29178120044504, 218, 40, 'PPL', 'P'),
(128010, 'Lower Dennysville', 44.9297218322754, 0.784171577978385, -67.2275009155273, -1.17334123886345, 218, 26, 'PPL', 'P'),
(156245, 'Lower Dresden', 40.1133308410645, 0.700109697118361, -82.0083312988281, -1.43131539523087, 218, 41, 'PPL', 'P'),
(164006, 'Lower Dutchtown', 40.4172210693359, 0.705413582166335, -78.6294403076172, -1.37234262236826, 218, 45, 'PPL', 'P'),
(103850, 'Lower Elk Creek', 36.7138900756836, 0.640778263035949, -81.1594390869141, -1.41649943113843, 218, 53, 'PPL', 'P'),
(88703, 'Lower Elkton (historical)', 35.0291709899902, 0.611374368019411, -86.9250030517578, -1.51712750555929, 218, 50, 'PPL', 'P'),
(196952, 'Lower Ellis Place', 47.2833290100098, 0.825249772528421, -112.29167175293, -1.95985939465734, 218, 31, 'PPL', 'P'),
(207964, 'Lower Elwha', 48.1444396972656, 0.840278989245147, -123.551391601563, -2.15637857886814, 218, 56, 'PPL', 'P'),
(103849, 'Lower Exeter', 36.8800010681152, 0.643677446777636, -82.8302764892578, -1.4456610450748, 218, 53, 'PPL', 'P'),
(145652, 'Lower Fairmount', 40.7058296203613, 0.710450751631139, -74.7752838134766, -1.30507490165839, 218, 37, 'PPL', 'P'),
(110212, 'Lower Falls', 38.3777809143066, 0.669818636563691, -81.85888671875, -1.42870709525924, 218, 58, 'PPL', 'P'),
(71053, 'Lower Forge', 39.7247200012207, 0.693327158454147, -74.6733322143555, -1.30329551057605, 218, 37, 'PPL', 'P'),
(88704, 'Lower Forked Deer Landing', 35.7805595397949, 0.624488572175288, -89.7555618286133, -1.56653007588664, 218, 50, 'PPL', 'P'),
(182983, 'Lower Forni', 38.8030586242676, 0.67724113283785, -120.228057861328, -2.09837546295843, 218, 6, 'PPL', 'P'),
(41883, 'Lower Garden District', 29.9236106872559, 0.522265530577578, -90.0805587768555, -1.5722023426924, 218, 22, 'PPL', 'P'),
(150411, 'Lower Genegantslet Corner', 42.3033294677734, 0.738332383768587, -75.8016662597656, -1.32298865473081, 218, 40, 'PPL', 'P'),
(36990, 'Lower Gillmore', 37.7638893127441, 0.659104206866084, -83.3694381713867, -1.45507119162854, 218, 21, 'PPL', 'P'),
(144088, 'Lower Gilmanton', 43.3808288574219, 0.757138295806181, -71.3544387817383, -1.24536989265406, 218, 36, 'PPL', 'P'),
(190434, 'Lower Gold Hill (historical)', 39.2750015258789, 0.685478090352384, -119.652778625488, -2.08833494617467, 218, 39, 'PPL', 'P'),
(16954, 'Lower Grand Lagoon', 30.1438903808594, 0.526110136506244, -85.7508316040039, -1.49663434781308, 218, 12, 'PPL', 'P'),
(172206, 'Lower Granville', 43.9683303833008, 0.767392131793259, -72.8433303833008, -1.27135595330662, 218, 55, 'PPL', 'P'),
(3884, 'Lower Hall Landing', 30.8191699981689, 0.537895989199903, -87.915283203125, -1.5344111547178, 218, 2, 'PPL', 'P'),
(145653, 'Lower Harmony', 40.7363891601563, 0.710984116218454, -75.14111328125, -1.31145983037185, 218, 37, 'PPL', 'P'),
(164005, 'Lower Hillville', 41.0244407653809, 0.716011565145279, -79.5899963378906, -1.38910748774642, 218, 45, 'PPL', 'P'),
(88705, 'Lower Holly Creek', 35.0586090087891, 0.611888158372715, -87.600830078125, -1.52892291234336, 218, 50, 'PPL', 'P'),
(78651, 'Lower Hopewell', 39.7841682434082, 0.694364726014842, -76.022216796875, -1.32683798777041, 218, 45, 'PPL', 'P'),
(211974, 'Lower Kalskag', 61.5122184753418, 1.0735907426008, -160.358062744141, -2.79877617700491, 218, 1, 'PPL', 'P'),
(192677, 'Lower Kimberly', 38.4902801513672, 0.671782118656379, -112.389999389648, -1.96157553566378, 218, 52, 'PPL', 'P'),
(188942, 'Lower La Posada', 35.6380615234375, 0.622001512612291, -105.678611755371, -1.84443972406801, 218, 38, 'PPL', 'P'),
(182985, 'Lower Lake', 38.9105606079102, 0.679117396404839, -122.609169006348, -2.13993369229495, 218, 6, 'PPL', 'P'),
(128012, 'Lower Landing', 43.3194389343262, 0.756066839520615, -70.5702819824219, -1.23168377465409, 218, 26, 'PPL', 'P'),
(164016, 'Lower Longswamp', 40.4908294677734, 0.70669829107619, -75.6449966430664, -1.32025425408157, 218, 45, 'PPL', 'P'),
(145654, 'Lower Longwood', 40.9647216796875, 0.714969270473649, -74.5650024414063, -1.30140479936015, 218, 37, 'PPL', 'P'),
(188943, 'Lower Lovett Place', 31.6563892364502, 0.55250822146895, -108.942222595215, -1.90140047872706, 218, 38, 'PPL', 'P'),
(196953, 'Lower Madison (historical)', 45.8388900756836, 0.800039557280431, -111.477783203125, -1.94565435971896, 218, 31, 'PPL', 'P'),
(49101, 'Lower Marlboro', 38.6558303833008, 0.67467151528106, -76.6822204589844, -1.33835722474943, 218, 25, 'PPL', 'P'),
(49102, 'Lower Marlboro Meadow', 38.6583290100098, 0.67471512454391, -76.6208267211914, -1.33728570188484, 218, 25, 'PPL', 'P'),
(49103, 'Lower Marlboro Towne', 38.6627807617188, 0.674792822268713, -76.6777801513672, -1.33827972676171, 218, 25, 'PPL', 'P'),
(16955, 'Lower Matecumbe Beach', 24.8497200012207, 0.433709432219991, -80.7347183227539, -1.40908665540225, 218, 12, 'PPL', 'P'),
(150412, 'Lower Melville', 40.7663917541504, 0.711507760267791, -73.4238891601563, -1.2814886154641, 218, 40, 'PPL', 'P'),
(113660, 'Lower Merryall', 41.646671295166, 0.726871536596458, -73.4161071777344, -1.28135279424851, 218, 8, 'PPL', 'P'),
(178566, 'Lower Miami', 33.4066696166992, 0.583056376937353, -110.855003356934, -1.93478480088786, 218, 5, 'PPL', 'P'),
(71052, 'Lower Mill', 39.9444389343262, 0.697161977265807, -74.6091690063477, -1.30217565133767, 218, 37, 'PPL', 'P'),
(88706, 'Lower Mill', 35.167781829834, 0.613793583553639, -85.2219390869141, -1.4874034320007, 218, 50, 'PPL', 'P'),
(128013, 'Lower Mill', 44.8527793884277, 0.782828678998713, -69.7405624389648, -1.21720243675262, 218, 26, 'PPL', 'P'),
(125276, 'Lower Mills', 42.2750015258789, 0.737837967912214, -71.0708312988281, -1.24042000829399, 218, 23, 'PPL', 'P'),
(88707, 'Lower Mockeson', 35.0680618286133, 0.612053141202245, -87.2752838134766, -1.52324105815768, 218, 50, 'PPL', 'P'),
(145655, 'Lower Montville', 40.9005584716797, 0.71384941123527, -74.3649978637695, -1.29791406096133, 218, 37, 'PPL', 'P'),
(14152, 'Lower Moores Corner', 39.1813888549805, 0.68384424102362, -75.5861129760742, -1.31922654021691, 218, 10, 'PPL', 'P'),
(73291, 'Lower Newport', 39.3519401550293, 0.686820922753029, -81.3452835083008, -1.41974302818809, 218, 41, 'PPL', 'P'),
(188944, 'Lower Nutria', 35.2566719055176, 0.615345008046665, -108.588890075684, -1.89523366290687, 218, 38, 'PPL', 'P'),
(150413, 'Lower Oswegatchie', 44.1947212219238, 0.771343397323582, -75.0688934326172, -1.31019935622792, 218, 40, 'PPL', 'P'),
(210576, 'Lower Paia', 20.9191703796387, 0.365108399910367, -156.38444519043, -2.72942346747761, 218, 15, 'PPL', 'P'),
(3885, 'Lower Peach Tree', 31.8405609130859, 0.555722623615162, -87.545280456543, -1.52795338854852, 218, 2, 'PPL', 'P'),
(78655, 'Lower Peanut', 39.9744415283203, 0.697685621315144, -79.7627792358398, -1.39212311820677, 218, 45, 'PPL', 'P'),
(188945, 'Lower Pueblo', 35.3263893127441, 0.616561806348722, -105.429443359375, -1.84009091516597, 218, 38, 'PPL', 'P'),
(182986, 'Lower Rancheria (historical)', 38.438060760498, 0.670870718352326, -120.818328857422, -2.10867763531929, 218, 6, 'PPL', 'P'),
(200057, 'Lower Rochester', 40.285831451416, 0.703120400730695, -118.199996948242, -2.06297912259408, 218, 39, 'PPL', 'P'),
(103851, 'Lower Rocketts', 37.5027809143066, 0.65454700560874, -77.3997192382813, -1.35087994082721, 218, 53, 'PPL', 'P'),
(150414, 'Lower Rotterdam Junction', 42.8605613708496, 0.74805791517442, -74.029167175293, -1.29205270971817, 218, 40, 'PPL', 'P'),
(73293, 'Lower Salem', 39.5611114501953, 0.690471650554337, -81.3966674804688, -1.42063984768518, 218, 41, 'PPL', 'P'),
(188946, 'Lower San Francisco Plaza', 33.6627807617188, 0.587526359668997, -108.786666870117, -1.89868551915378, 218, 38, 'PPL', 'P'),
(22760, 'Lower Sansavilla', 31.4952793121338, 0.549696322831989, -81.6488876342773, -1.42504191980902, 218, 13, 'PPL', 'P'),
(164020, 'Lower Saucon', 40.6061096191406, 0.708710309279745, -75.2827835083008, -1.31393244228594, 218, 45, 'PPL', 'P'),
(144089, 'Lower Shaker Village', 43.6199989318848, 0.761312601077799, -72.1466674804688, -1.2591968918757, 218, 36, 'PPL', 'P'),
(128014, 'Lower Shirley Corner', 45.351390838623, 0.791531090492764, -69.5886077880859, -1.21455032778107, 218, 26, 'PPL', 'P'),
(150415, 'Lower South Bay', 43.2000007629395, 0.753982250177356, -76.0633316040039, -1.32755557652613, 218, 40, 'PPL', 'P'),
(36991, 'Lower Spencer', 38.0286102294922, 0.663724458462235, -83.8402786254883, -1.4632889078042, 218, 21, 'PPL', 'P'),
(145656, 'Lower Squankum', 40.1586112976074, 0.700899990171842, -74.1572189331055, -1.29428763450497, 218, 37, 'PPL', 'P'),
(195264, 'Lower Stanley', 44.2269401550293, 0.771905723787753, -114.927780151367, -2.00586816564954, 218, 17, 'PPL', 'P'),
(123101, 'Lower Sunset Park', 40.7069396972656, 0.710470126128069, -86.7544403076172, -1.5141506240928, 218, 19, 'PPL', 'P'),
(164024, 'Lower Tannersville', 41.0316696166992, 0.716137732401921, -75.3002777099609, -1.31423777370491, 218, 45, 'PPL', 'P'),
(41884, 'Lower Texas', 29.833890914917, 0.520699625146125, -91.0391693115234, -1.58893325276666, 218, 22, 'PPL', 'P'),
(178567, 'Lower Tillman', 34.6283302307129, 0.604378376993828, -110.795829772949, -1.93375202701713, 218, 5, 'PPL', 'P'),
(211975, 'Lower Tonsina', 61.6549987792969, 1.07608272901182, -144.658615112305, -2.52476912508494, 218, 1, 'PPL', 'P'),
(82192, 'Lower Topsaw Landing', 33.6080589294434, 0.586571283523067, -79.1516723632813, -1.38145729119906, 218, 48, 'PPL', 'P'),
(110213, 'Lower Town', 39.3230590820313, 0.686316852937704, -77.7305603027344, -1.35665420670272, 218, 58, 'PPL', 'P'),
(182987, 'Lower Town', 38.3675003051758, 0.669639206085247, -119.11888885498, -2.07901681183659, 218, 6, 'PPL', 'P'),
(190435, 'Lower Town (historical)', 38.5144386291504, 0.672203763635966, -116.347503662109, -2.03064701537997, 218, 39, 'PPL', 'P'),
(150416, 'Lower Town Landing', 44.2700004577637, 0.772657267847373, -76.0913925170898, -1.32804533185059, 218, 40, 'PPL', 'P'),
(103852, 'Lower Tuckahoe', 37.5805587768555, 0.655904485395381, -77.644172668457, -1.35514645805157, 218, 53, 'PPL', 'P'),
(41885, 'Lower Vacherie', 29.9361095428467, 0.522483676760369, -90.6786117553711, -1.58264033626886, 218, 22, 'PPL', 'P'),
(145657, 'Lower Valley', 40.7266693115234, 0.710814472857016, -74.8441696166992, -1.3062771857325, 218, 37, 'PPL', 'P'),
(125277, 'Lower Village', 42.4333305358887, 0.740601330438307, -71.4850006103516, -1.24764862644079, 218, 23, 'PPL', 'P'),
(128015, 'Lower Village', 43.357780456543, 0.756736025323525, -70.4802780151367, -1.23011290908511, 218, 26, 'PPL', 'P'),
(144092, 'Lower Village', 43.396671295166, 0.757414798506359, -72.0811080932617, -1.25805266471335, 218, 36, 'PPL', 'P'),
(172207, 'Lower Village', 44.4561080932617, 0.775905458849915, -72.6947174072266, -1.26876216756294, 218, 55, 'PPL', 'P'),
(210577, 'Lower Village', 21.360279083252, 0.372807199147623, -158.028610229492, -2.75811956085543, 218, 15, 'PPL', 'P'),
(128016, 'Lower Village (historical)', 43.792781829834, 0.76432823153815, -70.1777801513672, -1.22483332538208, 218, 26, 'PPL', 'P'),
(210578, 'Lower Village Three', 20.8958301544189, 0.364701036132126, -156.429168701172, -2.73020403999311, 218, 15, 'PPL', 'P'),
(172208, 'Lower Waterford', 44.3544387817383, 0.774130994615596, -71.9075012207031, -1.25502265318311, 218, 55, 'PPL', 'P'),
(172209, 'Lower Websterville', 44.1680603027344, 0.770878076502118, -72.4786071777344, -1.26499033251106, 218, 55, 'PPL', 'P'),
(178568, 'Lower Wheatfields', 36.2041702270508, 0.631881973414539, -109.135276794434, -1.90476991013823, 218, 5, 'PPL', 'P'),
(164026, 'Lower Whyel', 40.2236099243164, 0.702034430217188, -79.6822204589844, -1.39071710230926, 218, 45, 'PPL', 'P'),
(125278, 'Lower Wire Village', 42.2638893127441, 0.737644023205829, -71.9938888549805, -1.25653040183426, 218, 23, 'PPL', 'P'),
(150417, 'Lowerre', 40.915828704834, 0.71411592708136, -73.897216796875, -1.28974974116553, 218, 40, 'PPL', 'P'),
(3887, 'Lowery', 31.1672191619873, 0.543970593067346, -86.1427764892578, -1.50347507654711, 218, 2, 'PPL', 'P'),
(22763, 'Lowery', 32.2055587768555, 0.562093038100686, -83.128059387207, -1.45085833710014, 218, 13, 'PPL', 'P'),
(49104, 'Lowery Oaks', 38.5750007629395, 0.673260772272618, -76.6455612182617, -1.33771740029754, 218, 25, 'PPL', 'P'),
(103853, 'Lowerys Landing', 37.8952789306641, 0.661397388301724, -76.7988891601563, -1.34039347771891, 218, 53, 'PPL', 'P'),
(103854, 'Lowerys Point Landing', 37.9022216796875, 0.661518562131322, -76.8208312988281, -1.34077644028366, 218, 53, 'PPL', 'P'),
(3888, 'Lowerytown', 33.1119384765625, 0.577912348133811, -87.1516723632813, -1.52108363135861, 218, 2, 'PPL', 'P'),
(36993, 'Lowes', 36.8855590820313, 0.643774452420342, -88.7738876342773, -1.54939662901362, 218, 21, 'PPL', 'P'),
(182988, 'Lowes Corner', 36.0944404602051, 0.629966827695636, -119.231109619141, -2.08097543366029, 218, 6, 'PPL', 'P'),
(22762, 'Lowes Crossing', 32.3916702270508, 0.565341295682255, -83.9802780151367, -1.46573235810434, 218, 13, 'PPL', 'P'),
(14153, 'Lowes Crossroads', 38.5233306884766, 0.67235895934849, -75.4066696166992, -1.31609466277497, 218, 10, 'PPL', 'P'),
(66510, 'Lowes Grove', 35.9033317565918, 0.626631351588366, -78.8891677856445, -1.37687572201774, 218, 33, 'PPL', 'P'),
(103855, 'Lowes Island', 39.0597190856934, 0.681720702949418, -77.3525009155273, -1.35005582562788, 218, 53, 'PPL', 'P'),
(66511, 'Lowesville', 35.4169387817383, 0.618142192718602, -81.0113906860352, -1.41391549909078, 218, 33, 'PPL', 'P'),
(103856, 'Lowesville', 37.7188911437988, 0.65831884066062, -79.0650024414063, -1.37994461569989, 218, 53, 'PPL', 'P'),
(196954, 'Loweth', 46.3688888549805, 0.809289781010713, -110.706939697266, -1.9322006025241, 218, 31, 'PPL', 'P'),
(3889, 'Lowetown', 33.3086090087891, 0.581344896462814, -87.0752792358398, -1.51975031975886, 218, 2, 'PPL', 'P'),
(66512, 'Lowgap', 36.5255584716797, 0.637491256460519, -80.8675003051758, -1.41140413818284, 218, 33, 'PPL', 'P'),
(139294, 'Lowground', 40.3738899230957, 0.70465731099578, -92.7352828979492, -1.6185360193376, 218, 29, 'PPL', 'P'),
(164028, 'Lowhill', 40.0099983215332, 0.698306204428159, -79.9511108398438, -1.3954101247822, 218, 45, 'PPL', 'P'),
(66513, 'Lowland', 35.2988891601563, 0.616081838141263, -76.5647201538086, -1.33630645755202, 218, 33, 'PPL', 'P'),
(103857, 'Lowland', 36.7724990844727, 0.641801183210648, -81.9833297729492, -1.43087903628626, 218, 53, 'PPL', 'P'),
(41886, 'Lowlands', 29.7691707611084, 0.519570045369768, -90.8988876342773, -1.5864848756185, 218, 22, 'PPL', 'P'),
(150418, 'Lowman', 42.0297203063965, 0.733557003038939, -76.720832824707, -1.33903113766328, 218, 40, 'PPL', 'P'),
(195265, 'Lowman', 44.083610534668, 0.769404149996814, -115.619720458984, -2.01794480224473, 218, 17, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(207965, 'Lowman Beach Park', 47.540828704834, 0.829743990025985, -122.394721984863, -2.13619088569895, 218, 56, 'PPL', 'P'),
(123102, 'Lowman Corner', 41.0705604553223, 0.716816505584755, -86.0183334350586, -1.5013031355201, 218, 19, 'PPL', 'P'),
(123103, 'Lowmandale', 40.0780601501465, 0.699494107432389, -85.663330078125, -1.49510715808597, 218, 19, 'PPL', 'P'),
(82188, 'Lowmans Crossroads (historical)', 34.1127815246582, 0.595380354618777, -81.4941711425781, -1.42234160762174, 218, 48, 'PPL', 'P'),
(36992, 'Lowmansville', 37.9172210693359, 0.661780350866477, -82.7319412231445, -1.4439447709103, 218, 21, 'PPL', 'P'),
(49105, 'Lowndes', 39.5488891601563, 0.690258331351022, -78.8605575561523, -1.37637637931335, 218, 25, 'PPL', 'P'),
(56010, 'Lowndes', 37.1488914489746, 0.648370469250574, -90.2633285522461, -1.5753922770461, 218, 29, 'PPL', 'P'),
(82189, 'Lowndes Landing', 32.8683280944824, 0.573660544874472, -80.4038925170898, -1.40331265584285, 218, 48, 'PPL', 'P'),
(3891, 'Lowndesboro', 32.2750015258789, 0.563305042712781, -86.6113891601563, -1.51165391057085, 218, 2, 'PPL', 'P'),
(82190, 'Lowndesville', 34.2125015258789, 0.597120796970171, -82.6497192382813, -1.44250972655691, 218, 48, 'PPL', 'P'),
(110214, 'Lowney', 37.936939239502, 0.662124497858343, -82.2752838134766, -1.43597459555796, 218, 58, 'PPL', 'P'),
(196957, 'Lowrane (historical)', 48.9383316040039, 0.854135016922666, -107.821670532227, -1.8818431557879, 218, 31, 'PPL', 'P'),
(60706, 'Lowrey', 34.6791687011719, 0.605265675690015, -89.0274963378906, -1.55382293590339, 218, 30, 'PPL', 'P'),
(76462, 'Lowrey', 36.0980606079102, 0.630030011192498, -94.9219436645508, -1.65670044933898, 218, 42, 'PPL', 'P'),
(193752, 'Lowrey', 40.0138893127441, 0.698374115035956, -122.552223205566, -2.13893980057613, 218, 6, 'PPL', 'P'),
(3892, 'Lowrimores Crossroads', 33.7677803039551, 0.589358947394108, -85.936393737793, -1.49987301801472, 218, 2, 'PPL', 'P'),
(10217, 'Lowry', 36.4716682434082, 0.63655069454253, -93.0541687011719, -1.6241016265417, 218, 4, 'PPL', 'P'),
(16956, 'Lowry', 30.4244403839111, 0.531006657775977, -84.7761077880859, -1.47962220792771, 218, 12, 'PPL', 'P'),
(22765, 'Lowry', 33.3116683959961, 0.58139829284267, -84.3963928222656, -1.47299493155504, 218, 13, 'PPL', 'P'),
(41887, 'Lowry', 30.023889541626, 0.524015726756464, -92.7708282470703, -1.61915640271354, 218, 22, 'PPL', 'P'),
(103858, 'Lowry', 37.3505592346191, 0.651890236105277, -79.4311065673828, -1.38633433810332, 218, 53, 'PPL', 'P'),
(136599, 'Lowry', 45.7050018310547, 0.797702766581941, -95.5177764892578, -1.66709969392158, 218, 28, 'PPL', 'P'),
(170794, 'Lowry', 45.3161087036133, 0.790915301069711, -99.9822235107422, -1.74501899372734, 218, 49, 'PPL', 'P'),
(196955, 'Lowry', 47.5125007629395, 0.829249574169611, -112.008888244629, -1.95492389136715, 218, 31, 'PPL', 'P'),
(56011, 'Lowry City', 38.1399993896484, 0.665668566057993, -93.7266693115234, -1.63583897641401, 218, 29, 'PPL', 'P'),
(95891, 'Lowry Crossing', 33.1547203063965, 0.578659031924442, -96.5469436645508, -1.68506204968389, 218, 51, 'PPL', 'P'),
(3893, 'Lowry Mill', 31.538610458374, 0.550452594002545, -85.9822235107422, -1.50067289844813, 218, 2, 'PPL', 'P'),
(66514, 'Lowrys', 34.8686103820801, 0.608572056762375, -80.1783294677734, -1.39937583796144, 218, 33, 'PPL', 'P'),
(82191, 'Lowrys', 34.8038902282715, 0.607442476986018, -81.2394409179688, -1.41789572649796, 218, 48, 'PPL', 'P'),
(49106, 'Lowrys Resurvey', 38.5958290100098, 0.673624293761414, -76.6291732788086, -1.33743137679647, 218, 25, 'PPL', 'P'),
(88708, 'Lowryville', 35.1041717529297, 0.612683378274212, -88.0988922119141, -1.53761573645749, 218, 50, 'PPL', 'P'),
(145658, 'Lows Hollow', 40.7138900756836, 0.710591433115722, -75.1144409179688, -1.31099430981331, 218, 37, 'PPL', 'P'),
(110223, 'Lowsville', 39.5627784729004, 0.690500745589246, -80.0533294677734, -1.39719417639645, 218, 58, 'PPL', 'P'),
(116628, 'Lowther Station (historical)', 43.3188896179199, 0.756057252140691, -92.5058288574219, -1.6145312908484, 218, 16, 'PPL', 'P'),
(136601, 'Lowville', 44.0666694641113, 0.769108472536788, -95.8666687011719, -1.67318901175405, 218, 28, 'PPL', 'P'),
(150419, 'Lowville', 43.7866706848145, 0.764221571936492, -75.4922180175781, -1.31758776404012, 218, 40, 'PPL', 'P'),
(164032, 'Lowville', 42.0247192382813, 0.733469717934211, -79.8216705322266, -1.39315096522949, 218, 45, 'PPL', 'P'),
(175067, 'Lowville', 43.3824996948242, 0.757167457420118, -89.3269424438477, -1.55904925638461, 218, 57, 'PPL', 'P'),
(27763, 'Loxa', 39.4972190856934, 0.689356518426893, -88.267219543457, -1.54055360261401, 218, 18, 'PPL', 'P'),
(16957, 'Loxahatchee', 26.6833305358887, 0.4657119732492, -80.2799987792969, -1.40115030219576, 218, 12, 'PPL', 'P'),
(3894, 'Loxley', 30.6180591583252, 0.534385942883178, -87.753059387207, -1.53157981500488, 218, 2, 'PPL', 'P'),
(103861, 'Loxley Gardens', 36.7752799987793, 0.641849719321515, -76.3341674804688, -1.33228255430296, 218, 53, 'PPL', 'P'),
(103859, 'Loxley Place', 36.7986106872559, 0.642256916652188, -76.3377838134766, -1.3323456712208, 218, 53, 'PPL', 'P'),
(10218, 'Loy', 36.0144386291504, 0.628570532336107, -93.5522232055664, -1.63279431749778, 218, 4, 'PPL', 'P'),
(191808, 'Loy Place', 29.7930603027344, 0.519986996527933, -103.666389465332, -1.80931981982481, 218, 51, 'PPL', 'P'),
(95892, 'Loya Colonia', 26.2409992218018, 0.45799183543371, -98.3939971923828, -1.71729921520514, 218, 51, 'PPL', 'P'),
(76463, 'Loyal', 35.9711112976074, 0.627814327744579, -98.1205596923828, -1.71252683053171, 218, 42, 'PPL', 'P'),
(175069, 'Loyal', 44.7369384765625, 0.780806873678152, -90.4958267211914, -1.57945013559905, 218, 57, 'PPL', 'P'),
(207966, 'Loyal Heights', 47.6888885498047, 0.832328121810716, -122.391670227051, -2.13613762247715, 218, 56, 'PPL', 'P'),
(95893, 'Loyal Valley', 30.5755596160889, 0.533644185940564, -99.0074996948242, -1.72800685384196, 218, 51, 'PPL', 'P'),
(164031, 'Loyalhanna', 40.3224983215332, 0.703760358340642, -79.3625030517578, -1.38513698087722, 218, 45, 'PPL', 'P'),
(164033, 'Loyalhanna Woodlands Number 1', 40.4511108398438, 0.706005070244442, -79.4413909912109, -1.38651383516079, 218, 45, 'PPL', 'P'),
(164034, 'Loyalhanna Woodlands Number 2', 40.452220916748, 0.706024444741372, -79.4630584716797, -1.38689200403558, 218, 45, 'PPL', 'P'),
(36996, 'Loyall', 36.8519401550293, 0.643187691453171, -83.3541717529297, -1.45480474236148, 218, 21, 'PPL', 'P'),
(3895, 'Loyall (historical)', 34.7522201538086, 0.60654066406189, -87.7055587768555, -1.53075077295754, 218, 2, 'PPL', 'P'),
(164036, 'Loyalsock (historical)', 41.2291717529297, 0.719584794958865, -76.8949966430664, -1.3420708697315, 218, 45, 'PPL', 'P'),
(164038, 'Loyalsockville', 41.3208312988281, 0.721184555825676, -76.9097213745117, -1.34232786477669, 218, 45, 'PPL', 'P'),
(164039, 'Loyalton', 40.5688896179199, 0.708060697710847, -76.7619400024414, -1.33974859326095, 218, 45, 'PPL', 'P'),
(170796, 'Loyalton', 45.2863883972168, 0.790396583868391, -99.279167175293, -1.73274834584674, 218, 49, 'PPL', 'P'),
(182989, 'Loyalton', 39.6763916015625, 0.692483668757892, -120.23999786377, -2.09858385531373, 218, 6, 'PPL', 'P'),
(103860, 'Loyalty', 39.2266693115234, 0.684634534077101, -77.5827789306641, -1.35407493518697, 218, 53, 'PPL', 'P'),
(164040, 'Loyalville', 41.336109161377, 0.72145120482982, -76.0994415283203, -1.3281858135981, 218, 45, 'PPL', 'P'),
(16958, 'Loyce', 28.3802795410156, 0.495329320627108, -82.4866714477539, -1.4396640057741, 218, 12, 'PPL', 'P'),
(27764, 'Loyd', 39.9147186279297, 0.696643260064487, -89.8541717529297, -1.56825114374111, 218, 18, 'PPL', 'P'),
(41888, 'Loyd', 31.0444393157959, 0.541827680496214, -92.3583297729492, -1.61195694618067, 218, 22, 'PPL', 'P'),
(56012, 'Loyd', 37.4341697692871, 0.653349515224586, -90.0725021362305, -1.57206172778685, 218, 29, 'PPL', 'P'),
(60707, 'Loyd', 33.9580612182617, 0.592679975852464, -89.2219390869141, -1.55721660208047, 218, 30, 'PPL', 'P'),
(175072, 'Loyd', 43.4230613708496, 0.757875392216888, -90.2427825927734, -1.57503368240532, 218, 57, 'PPL', 'P'),
(194303, 'Loyd', 40.3036117553711, 0.703430725576717, -107.704170227051, -1.87979238859048, 218, 7, 'PPL', 'P'),
(60708, 'Loyd Star', 31.6263904571533, 0.55198464399864, -90.5500030517578, -1.58039569094409, 218, 30, 'PPL', 'P'),
(71055, 'Loyds Corner', 39.3605613708496, 0.686971391354618, -75.3011093139648, -1.31425228793286, 218, 37, 'PPL', 'P'),
(182990, 'Loyola', 37.351390838623, 0.651904750333218, -122.09944152832, -2.13103726951549, 218, 6, 'PPL', 'P'),
(95894, 'Loyola Beach', 27.3333301544189, 0.477056606729261, -97.6944427490234, -1.70508968687156, 218, 51, 'PPL', 'P'),
(182991, 'Loyola Corners', 37.3522186279297, 0.651919197982132, -122.084999084473, -2.13078520131831, 218, 6, 'PPL', 'P'),
(3896, 'Loyola Villa', 30.500560760498, 0.532335208975277, -87.9244384765625, -1.5345709443832, 218, 2, 'PPL', 'P'),
(49107, 'Loys', 39.6063919067383, 0.691261943607818, -77.352783203125, -1.3500607524759, 218, 25, 'PPL', 'P'),
(156246, 'Loys Corners', 41.1847190856934, 0.718808949554298, -80.6922225952148, -1.40834496503866, 218, 41, 'PPL', 'P'),
(164041, 'Loysburg', 40.160831451416, 0.700938739165703, -78.3752822875977, -1.36790672809857, 218, 45, 'PPL', 'P'),
(164042, 'Loysburg Gap', 40.1597213745117, 0.700919364668772, -78.3661117553711, -1.36774667211706, 218, 45, 'PPL', 'P'),
(88709, 'Loyston (historical)', 36.2652816772461, 0.632948569431116, -83.9499969482422, -1.46520385378602, 218, 50, 'PPL', 'P'),
(164043, 'Loysville', 40.3655586242676, 0.704511902400262, -77.3447189331055, -1.34992000441229, 218, 45, 'PPL', 'P'),
(95895, 'Lozano', 26.1888904571533, 0.457082365921448, -97.5408325195313, -1.70240868260218, 218, 51, 'PPL', 'P'),
(196956, 'Lozeau', 47.1166687011719, 0.822341001406809, -114.779167175293, -2.00327437990586, 218, 31, 'PPL', 'P'),
(41889, 'Lozes', 30.041389465332, 0.524321158043983, -91.9594421386719, -1.60499504361704, 218, 22, 'PPL', 'P'),
(191809, 'Lozier', 29.9349994659424, 0.522464302263439, -101.819999694824, -1.7770942390543, 218, 51, 'PPL', 'P'),
(204584, 'LPT Condominium', 40.8519401550293, 0.713000861532944, -111.911666870117, -1.9532270582786, 218, 52, 'PPL', 'P'),
(116629, 'Lu Verne', 42.9083290100098, 0.748891617753669, -94.0736083984375, -1.64189420578452, 218, 16, 'PPL', 'P'),
(116631, 'Luana', 43.0602798461914, 0.751543660146198, -91.4538879394531, -1.59617145829339, 218, 16, 'PPL', 'P'),
(66515, 'Luart', 35.4150009155273, 0.618108370572758, -78.8874969482422, -1.3768465604038, 218, 33, 'PPL', 'P'),
(191810, 'Lubbock', 33.5777816772461, 0.586042845783768, -101.854721069336, -1.77770024136035, 218, 51, 'PPL', 'P'),
(3897, 'Lubbub', 33.4305610656738, 0.583473361385033, -87.873893737793, -1.53368877227211, 218, 2, 'PPL', 'P'),
(128017, 'Lubec', 44.8605613708496, 0.782964500214307, -66.9847183227539, -1.16910388325303, 218, 26, 'PPL', 'P'),
(110215, 'Lubeck', 39.235279083252, 0.684784802941609, -81.6313934326172, -1.42473658839005, 218, 58, 'PPL', 'P'),
(110216, 'Lubeck Hills', 39.2238883972168, 0.684585997966235, -81.6391677856445, -1.42487227644759, 218, 58, 'PPL', 'P'),
(10219, 'Luber', 35.7655601501465, 0.624226783440134, -92.083610534668, -1.60716219095409, 218, 4, 'PPL', 'P'),
(187007, 'Lubers', 38.1288909912109, 0.665474687930635, -102.923889160156, -1.79636074480243, 218, 7, 'PPL', 'P'),
(175073, 'Lublin', 45.077220916748, 0.78674592264611, -90.7244415283203, -1.58344021670227, 218, 57, 'PPL', 'P'),
(66516, 'Lucama', 35.6452789306641, 0.622127480131851, -78.0100021362305, -1.36153138676503, 218, 33, 'PPL', 'P'),
(136603, 'Lucan', 44.4097213745117, 0.775095857878531, -95.4102783203125, -1.66522349693362, 218, 28, 'PPL', 'P'),
(10220, 'Lucas', 35.0697212219238, 0.6120821030791, -94.1152801513672, -1.64262151507822, 218, 4, 'PPL', 'P'),
(33153, 'Lucas', 39.0561103820801, 0.681657719189638, -98.5361099243164, -1.71977955028638, 218, 20, 'PPL', 'P'),
(36994, 'Lucas', 36.8916702270508, 0.643881112022, -86.0374984741211, -1.50163762855301, 218, 21, 'PPL', 'P'),
(41891, 'Lucas', 30.3738899230957, 0.530124385796347, -93.5622177124023, -1.63296875454918, 218, 22, 'PPL', 'P'),
(56013, 'Lucas', 38.416389465332, 0.670492482898508, -94.0286102294922, -1.64110883957906, 218, 29, 'PPL', 'P'),
(60709, 'Lucas', 31.5877799987793, 0.551310764374309, -89.9583282470703, -1.5700690175012, 218, 30, 'PPL', 'P'),
(95897, 'Lucas', 29.9980602264404, 0.523564920162941, -94.0688934326172, -1.64181191410684, 218, 51, 'PPL', 'P'),
(110218, 'Lucas', 38.1919403076172, 0.666575106093056, -81.039436340332, -1.41440498809914, 218, 58, 'PPL', 'P'),
(116632, 'Lucas', 41.0283317565918, 0.716079475753076, -93.459716796875, -1.63117977608692, 218, 16, 'PPL', 'P'),
(120447, 'Lucas', 40.3066711425781, 0.703484121956573, -89.3675003051758, -1.55975712460235, 218, 18, 'PPL', 'P'),
(131845, 'Lucas', 44.2183303833008, 0.771755454923245, -85.2850036621094, -1.48850411647923, 218, 27, 'PPL', 'P'),
(156247, 'Lucas', 40.7050018310547, 0.710436303982225, -82.418327331543, -1.43847117592186, 218, 41, 'PPL', 'P'),
(170797, 'Lucas', 43.2897186279297, 0.755548122319295, -99.2161102294922, -1.73164779452627, 218, 49, 'PPL', 'P'),
(128019, 'Lucas Corner', 44.2833290100098, 0.772889894968591, -69.3344421386719, -1.21011430035332, 218, 26, 'PPL', 'P'),
(49108, 'Lucas Heights', 39.6630592346191, 0.692250975057646, -78.8161087036133, -1.37560060048781, 218, 25, 'PPL', 'P'),
(182996, 'Lucas Valley', 38.0275001525879, 0.663705083965305, -122.557220458984, -2.13902701910183, 218, 6, 'PPL', 'P'),
(73294, 'Lucasburg', 39.9544410705566, 0.697336547475261, -81.5694427490234, -1.42365534498747, 218, 41, 'PPL', 'P'),
(71056, 'Lucaston', 39.8183288574219, 0.694960941203884, -74.9677810668945, -1.30843461253158, 218, 37, 'PPL', 'P'),
(36995, 'Lucastown', 37.2063903808594, 0.649374014928343, -82.7966690063477, -1.44507448384471, 218, 21, 'PPL', 'P'),
(73295, 'Lucasville', 38.8794403076172, 0.678574244700517, -82.996940612793, -1.44856988277544, 218, 41, 'PPL', 'P'),
(164050, 'Lucasville', 40.8772201538086, 0.713442080746543, -79.7774963378906, -1.39237998009391, 218, 45, 'PPL', 'P'),
(140426, 'Lucca', 46.7069396972656, 0.815189881247729, -97.7194366455078, -1.70552591265811, 218, 34, 'PPL', 'P'),
(182992, 'Lucca', 36.2452812194824, 0.632599495591234, -119.088890075684, -2.07849323436628, 218, 6, 'PPL', 'P'),
(10222, 'Lucca Landing', 33.7152786254883, 0.588442620242039, -91.2149963378906, -1.59200201329076, 218, 4, 'PPL', 'P'),
(131846, 'Luce', 43.2341690063477, 0.754578598524452, -84.0299987792969, -1.46660014914555, 218, 27, 'PPL', 'P'),
(136606, 'Luce', 46.6577796936035, 0.814331877323532, -95.6524963378906, -1.66945099884801, 218, 28, 'PPL', 'P'),
(49109, 'Luce Creek', 39.0013885498047, 0.680702643043708, -76.5202789306641, -1.33553081188453, 218, 25, 'PPL', 'P'),
(150421, 'Luce Landing', 40.9855613708496, 0.715332991699526, -72.6186065673828, -1.26743378281121, 218, 40, 'PPL', 'P'),
(60710, 'Lucedale', 30.9249992370605, 0.539743057863441, -88.5899963378906, -1.54618712042591, 218, 30, 'PPL', 'P'),
(60711, 'Lucern', 32.5166702270508, 0.567522957247248, -89.2291717529297, -1.55734283591614, 218, 30, 'PPL', 'P'),
(41892, 'Lucerna (historical)', 31.5283298492432, 0.550273163524101, -91.5352783203125, -1.59759198841884, 218, 22, 'PPL', 'P'),
(10223, 'Lucerne', 35.0713882446289, 0.612111198114009, -90.5580596923828, -1.58053630584964, 218, 4, 'PPL', 'P'),
(110219, 'Lucerne', 38.9986114501953, 0.680654173511869, -80.8802795410156, -1.41162717792413, 218, 58, 'PPL', 'P'),
(123104, 'Lucerne', 40.8663902282715, 0.713253062888174, -86.4033279418945, -1.50802255726648, 218, 19, 'PPL', 'P'),
(139295, 'Lucerne', 40.4638900756836, 0.706228109985736, -93.2919387817383, -1.62825149731032, 218, 29, 'PPL', 'P'),
(156249, 'Lucerne', 40.4625015258789, 0.706203875219817, -82.6286087036133, -1.4421412782201, 218, 41, 'PPL', 'P'),
(182994, 'Lucerne', 39.0902786254883, 0.682254067536734, -122.795280456543, -2.14318194987652, 218, 6, 'PPL', 'P'),
(187784, 'Lucerne', 39.4966697692871, 0.689346931046969, -100.199996948242, -1.7488198572351, 218, 20, 'PPL', 'P'),
(194304, 'Lucerne', 40.4819412231445, 0.706543161942693, -104.699172973633, -1.82734529250495, 218, 7, 'PPL', 'P'),
(202331, 'Lucerne', 44.2391700744629, 0.772119176149122, -101.525833129883, -1.77196006394679, 218, 49, 'PPL', 'P'),
(207968, 'Lucerne', 47.6416702270508, 0.831504006611391, -122.219436645508, -2.13313157939672, 218, 56, 'PPL', 'P'),
(209580, 'Lucerne', 43.7350006103516, 0.763319759012364, -108.175827026367, -1.88802435267797, 218, 59, 'PPL', 'P'),
(88714, 'Lucerne (historical)', 35.5402793884277, 0.620294892406741, -87.3561096191406, -1.52465173458709, 218, 50, 'PPL', 'P'),
(164044, 'Lucerne Mines', 40.5588912963867, 0.70788619408042, -79.1513900756836, -1.38145236435104, 218, 45, 'PPL', 'P'),
(16960, 'Lucerne Park', 28.0808296203613, 0.490102933566854, -81.6755599975586, -1.42550744036757, 218, 12, 'PPL', 'P'),
(182995, 'Lucerne Valley', 34.4438896179199, 0.601159281026194, -116.966941833496, -2.0414582509832, 218, 6, 'PPL', 'P'),
(128020, 'Lucerne-in-Maine', 44.6997184753418, 0.780157262109254, -68.6011123657227, -1.19731528131246, 218, 26, 'PPL', 'P'),
(188948, 'Lucero', 35.3911094665527, 0.617691386125079, -105.461112976074, -1.84064365425021, 218, 38, 'PPL', 'P'),
(188949, 'Lucero Place', 36.9019393920898, 0.644060342763363, -107.58943939209, -1.87778995776685, 218, 38, 'PPL', 'P'),
(164045, 'Luces Corners', 41.6161117553711, 0.726338172009143, -79.8333282470703, -1.39335443073677, 218, 45, 'PPL', 'P'),
(66517, 'Lucia', 35.3847198486328, 0.617579866254432, -81.0108337402344, -1.4139057785528, 218, 33, 'PPL', 'P'),
(182997, 'Lucia', 36.0208282470703, 0.628682052206754, -121.549438476563, -2.1214379053663, 218, 6, 'PPL', 'P'),
(207969, 'Lucia', 45.8383293151855, 0.800029770163425, -122.433326721191, -2.13686466545474, 218, 56, 'PPL', 'P'),
(10224, 'Lucian (historical)', 34.2150001525879, 0.597164406233021, -92.6680603027344, -1.61736276371937, 218, 4, 'PPL', 'P'),
(60712, 'Lucien', 31.5166702270508, 0.550069664727305, -90.6638870239258, -1.58238334122367, 218, 30, 'PPL', 'P'),
(76464, 'Lucien', 36.2747192382813, 0.633113285944537, -97.4544372558594, -1.70090080079297, 218, 42, 'PPL', 'P'),
(22766, 'Lucile', 31.2433300018311, 0.545298977819078, -84.9172210693359, -1.48208509930381, 218, 13, 'PPL', 'P'),
(110220, 'Lucile', 38.9452781677246, 0.679723332131859, -81.3861083984375, -1.42045555693774, 218, 58, 'PPL', 'P'),
(195266, 'Lucile', 45.5352783203125, 0.794740532501446, -116.309440612793, -2.02998268984605, 218, 17, 'PPL', 'P'),
(88710, 'Lucilla (historical)', 36.0597190856934, 0.629360825389588, -83.5730590820313, -1.4586250469452, 218, 50, 'PPL', 'P'),
(3898, 'Lucille', 33.0883293151855, 0.577500290534148, -87.1474990844727, -1.52101079390279, 218, 2, 'PPL', 'P'),
(204751, 'Lucin', 41.1883316040039, 0.718871999893105, -112.108062744141, -1.95665481291764, 218, 52, 'PPL', 'P'),
(164046, 'Lucinda', 41.3083305358887, 0.720966376353371, -79.370002746582, -1.3852678752448, 218, 45, 'PPL', 'P'),
(22767, 'Lucius', 34.8016700744629, 0.607403727992158, -84.3794403076172, -1.47269905435794, 218, 13, 'PPL', 'P'),
(164047, 'Luciusboro', 40.5105590820313, 0.707042637805137, -79.1224975585938, -1.38094809479864, 218, 45, 'PPL', 'P'),
(66518, 'Luck', 35.7358283996582, 0.623707866501732, -82.8663864135742, -1.44629128214677, 218, 33, 'PPL', 'P'),
(175076, 'Luck', 45.5761108398438, 0.795453194409152, -92.4824981689453, -1.61412409351772, 218, 57, 'PPL', 'P'),
(95898, 'Luckenbach', 30.1788902282715, 0.526720999081281, -98.7574996948242, -1.72364353071198, 218, 51, 'PPL', 'P'),
(164048, 'Lucket', 40.4636116027832, 0.706223249716747, -78.620002746582, -1.37217790585484, 218, 45, 'PPL', 'P'),
(88711, 'Luckett', 35.7280616760254, 0.623572311602247, -89.6744384765625, -1.5651142062931, 218, 50, 'PPL', 'P'),
(41895, 'Luckett (historical)', 31.766939163208, 0.554437681678712, -91.4588928222656, -1.59625880997714, 218, 22, 'PPL', 'P'),
(103863, 'Lucketts', 39.2155609130859, 0.684440655949743, -77.5347213745117, -1.35323617260165, 218, 53, 'PPL', 'P'),
(156250, 'Luckey', 41.4505615234375, 0.723448775384461, -83.4875030517578, -1.45713181252199, 218, 41, 'PPL', 'P'),
(22768, 'Luckie (historical)', 33.6144409179688, 0.58668267023566, -85.2402801513672, -1.48772354396373, 218, 13, 'PPL', 'P'),
(193753, 'Luckie Place', 40.5736083984375, 0.708143055967558, -123.206939697266, -2.15036675902339, 218, 6, 'PPL', 'P'),
(60713, 'Luckney', 32.3413887023926, 0.564463717524047, -90.0755615234375, -1.5721151241667, 218, 30, 'PPL', 'P'),
(82193, 'Lucknow', 34.2924995422363, 0.598517025750672, -80.3377838134766, -1.40215884130057, 218, 48, 'PPL', 'P'),
(136607, 'Lucknow', 47.5011100769043, 0.829050769194237, -92.7361068725586, -1.61855040040749, 218, 28, 'PPL', 'P'),
(164049, 'Lucknow', 40.3274993896484, 0.703847643445369, -76.8861083984375, -1.341915740598, 218, 45, 'PPL', 'P'),
(103862, 'Lucks', 36.813060760498, 0.642509118007419, -79.2191696166992, -1.38263534050726, 218, 53, 'PPL', 'P'),
(36997, 'Lucky', 36.7369384765625, 0.641180533518605, -84.0722198486328, -1.46733704581917, 218, 21, 'PPL', 'P'),
(41893, 'Lucky', 32.2550010681152, 0.562955968872899, -92.9966735839844, -1.62309814744296, 218, 22, 'PPL', 'P'),
(78658, 'Lucky', 39.9036102294922, 0.696449381937129, -76.4458312988281, -1.33423145558868, 218, 45, 'PPL', 'P'),
(88712, 'Lucky', 35.7975006103516, 0.624784249635314, -85.8427810668945, -1.49823916868596, 218, 50, 'PPL', 'P'),
(10225, 'Lucky (historical)', 34.4602813720703, 0.601445371106296, -93.4486083984375, -1.63098589795956, 218, 4, 'PPL', 'P'),
(110221, 'Lucky (historical)', 39.1699981689453, 0.683645436048246, -81.5472183227539, -1.4232674555747, 218, 58, 'PPL', 'P'),
(190436, 'Lucky Boy (historical)', 38.4602813720703, 0.671258541186069, -118.678062438965, -2.07132293944735, 218, 39, 'PPL', 'P'),
(36998, 'Lucky Fork', 37.3675003051758, 0.652185913565303, -83.5699996948242, -1.45857165056534, 218, 21, 'PPL', 'P'),
(190437, 'Lucky Jim Camp', 35.702220916748, 0.623121305271642, -114.80249786377, -2.00368157723653, 218, 39, 'PPL', 'P'),
(128023, 'Lucky Landing', 44.9105606079102, 0.783837151524498, -68.8038864135742, -1.20085435608506, 218, 26, 'PPL', 'P'),
(95899, 'Lucky Ridge', 33.0361099243164, 0.576588890230096, -97.6680603027344, -1.70462922631908, 218, 51, 'PPL', 'P'),
(187008, 'Lucky Seven Summer Homes', 37.5838890075684, 0.655962608886172, -106.739166259766, -1.86294989206655, 218, 7, 'PPL', 'P'),
(211976, 'Lucky Shot Landing', 61.7750015258789, 1.07817717205111, -149.408325195313, -2.6076672045486, 218, 1, 'PPL', 'P'),
(36999, 'Lucky Stop', 37.9647216796875, 0.662609392913819, -83.8147201538086, -1.46284282832161, 218, 21, 'PPL', 'P'),
(116634, 'Lucky Valley (historical)', 42.3849983215332, 0.739757774163025, -95.9380569458008, -1.67443497167004, 218, 16, 'PPL', 'P'),
(175079, 'Luco', 43.8013916015625, 0.764478500402658, -88.4191665649414, -1.54320557842751, 218, 57, 'PPL', 'P'),
(164051, 'Lucon', 40.2350006103516, 0.702233235192563, -75.4161071777344, -1.31625937928839, 218, 45, 'PPL', 'P'),
(110222, 'Lucretia', 39.3294410705566, 0.686428239650297, -80.0013885498047, -1.39628763636138, 218, 58, 'PPL', 'P'),
(164052, 'Lucullus', 41.3688888549805, 0.722023318410996, -77.540283203125, -1.35333324482339, 218, 45, 'PPL', 'P'),
(3899, 'Lucy', 31.0200004577637, 0.541401141958124, -85.0411071777344, -1.48424731979285, 218, 2, 'PPL', 'P'),
(41894, 'Lucy', 30.0466709136963, 0.524413336707213, -90.5074996948242, -1.57965386742245, 218, 22, 'PPL', 'P'),
(88713, 'Lucy', 35.2999992370605, 0.616101212638193, -89.9272232055664, -1.56952613211298, 218, 50, 'PPL', 'P'),
(188950, 'Lucy', 34.6519393920898, 0.60479043459349, -105.836387634277, -1.84719343263515, 218, 38, 'PPL', 'P'),
(82194, 'Lucy Creek', 32.4749984741211, 0.566795647953548, -80.6263885498047, -1.40719594418635, 218, 48, 'PPL', 'P'),
(164053, 'Lucy Furnace', 40.3933296203613, 0.704996597718656, -77.8861083984375, -1.35936903311794, 218, 45, 'PPL', 'P'),
(140427, 'Ludden', 46.0086097717285, 0.803001724781899, -98.125, -1.71260432851944, 218, 34, 'PPL', 'P'),
(16961, 'Luddersville', 29.1588897705078, 0.508918632721455, -82.4408264160156, -1.43886385902459, 218, 12, 'PPL', 'P'),
(187785, 'Ludell', 39.8555603027344, 0.695610752509863, -100.959442138672, -1.76207467629653, 218, 20, 'PPL', 'P'),
(41896, 'Ludevine', 29.5852794647217, 0.516360536782059, -90.4274978637695, -1.57825757206292, 218, 22, 'PPL', 'P'),
(41897, 'Ludger', 29.9486103057861, 0.522701856232674, -91.8644409179688, -1.60333695952236, 218, 22, 'PPL', 'P'),
(41898, 'Ludington', 30.8738899230957, 0.538851032056319, -93.2850036621094, -1.62813045663878, 218, 22, 'PPL', 'P'),
(73296, 'Ludington', 39.5936088562012, 0.691038837287496, -82.1605606079102, -1.43397229789239, 218, 41, 'PPL', 'P'),
(131848, 'Ludington', 43.9552803039551, 0.76716436494103, -86.4524993896484, -1.50888076092775, 218, 27, 'PPL', 'P'),
(175080, 'Ludington', 44.8291702270508, 0.78241662139905, -91.1272201538086, -1.59047002987369, 218, 57, 'PPL', 'P'),
(196959, 'Ludington', 47.8261108398438, 0.834723102579024, -104.061111450195, -1.81620901809068, 218, 31, 'PPL', 'P'),
(150422, 'Ludingtonville', 41.5088882446289, 0.724466768711144, -73.6916732788086, -1.28616233001914, 218, 40, 'PPL', 'P'),
(16962, 'Ludlam', 25.7333297729492, 0.449131332039449, -80.3016662597656, -1.40152847107055, 218, 12, 'PPL', 'P'),
(37000, 'Ludlow', 39.0924987792969, 0.682292816530595, -84.5475006103516, -1.47563225998255, 218, 21, 'PPL', 'P'),
(56017, 'Ludlow', 39.6549987792969, 0.692110293573063, -93.7019424438477, -1.63540741115936, 218, 29, 'PPL', 'P'),
(60714, 'Ludlow', 32.5716705322266, 0.568482893662167, -89.7127838134766, -1.56578345867504, 218, 30, 'PPL', 'P'),
(73297, 'Ludlow', 39.5880584716797, 0.690941964802845, -81.6513900756836, -1.4250855956509, 218, 41, 'PPL', 'P'),
(76467, 'Ludlow', 34.5361099243164, 0.602768829010011, -94.8505630493164, -1.65545462258104, 218, 42, 'PPL', 'P'),
(116635, 'Ludlow', 43.226390838623, 0.754442843887885, -91.5666732788086, -1.59813993381312, 218, 16, 'PPL', 'P'),
(120448, 'Ludlow', 40.3869400024414, 0.704885077848009, -88.1275024414063, -1.53811507916188, 218, 18, 'PPL', 'P'),
(125280, 'Ludlow', 42.2397193908691, 0.73722217848916, -71.8486099243164, -1.2539948061604, 218, 23, 'PPL', 'P'),
(128021, 'Ludlow', 46.1405601501465, 0.805304693334545, -68.0405578613281, -1.18753175957389, 218, 26, 'PPL', 'P'),
(150423, 'Ludlow', 40.9280586242676, 0.71432937944273, -73.9013900756836, -1.28982257862134, 218, 40, 'PPL', 'P'),
(164062, 'Ludlow', 41.728328704834, 0.728296727253814, -78.9436111450195, -1.37782593789468, 218, 45, 'PPL', 'P'),
(172210, 'Ludlow', 43.3958282470703, 0.757400084541336, -72.7011108398438, -1.26887375401261, 218, 55, 'PPL', 'P'),
(182998, 'Ludlow', 34.7211112976074, 0.60599771209465, -116.159172058105, -2.02736000880454, 218, 6, 'PPL', 'P'),
(187009, 'Ludlow', 37.3333282470703, 0.65158949863918, -104.582778930664, -1.82531383322544, 218, 7, 'PPL', 'P'),
(202332, 'Ludlow', 45.8344383239746, 0.799961859555628, -103.376106262207, -1.80425342216704, 218, 49, 'PPL', 'P'),
(125281, 'Ludlow Center', 42.1916694641113, 0.736383549061894, -72.459716796875, -1.26466063316811, 218, 23, 'PPL', 'P'),
(125282, 'Ludlow City', 42.2202796936035, 0.736882891766284, -72.4994430541992, -1.26535398715791, 218, 23, 'PPL', 'P'),
(73298, 'Ludlow Falls', 39.9980583190918, 0.698097812072861, -84.3388900756836, -1.47199131929825, 218, 41, 'PPL', 'P'),
(150426, 'Ludlowville', 42.5536117553711, 0.742700633746589, -76.5388870239258, -1.33585558437947, 218, 40, 'PPL', 'P'),
(22769, 'Ludowici', 31.7077808380127, 0.553405174124088, -81.7425003051758, -1.42667576913779, 218, 13, 'PPL', 'P'),
(22770, 'Ludville', 34.4694404602051, 0.601605227350728, -84.6097183227539, -1.47671816391703, 218, 13, 'PPL', 'P'),
(10226, 'Ludwig', 35.5108299255371, 0.619780902316355, -93.4291687011719, -1.63064661123668, 218, 4, 'PPL', 'P'),
(56014, 'Ludwig', 38.2350006103516, 0.667326650152676, -90.4188919067383, -1.57810736977744, 218, 29, 'PPL', 'P'),
(190438, 'Ludwig (historical)', 38.9555587768555, 0.679902762610303, -119.278060913086, -2.0817948883277, 218, 39, 'PPL', 'P'),
(123105, 'Ludwig Park', 41.1363906860352, 0.717965459858042, -85.154167175293, -1.48622058900254, 218, 19, 'PPL', 'P'),
(164054, 'Ludwigs Corner', 40.1155586242676, 0.700148579270276, -75.6938934326172, -1.32110766405288, 218, 45, 'PPL', 'P'),
(56015, 'Luebbering', 38.2702789306641, 0.667942372996703, -90.8191680908203, -1.58509350710699, 218, 29, 'PPL', 'P'),
(95900, 'Lueders', 32.8013916015625, 0.572492282683282, -99.6186065673828, -1.73867268084968, 218, 51, 'PPL', 'P'),
(10227, 'Luehrmann (historical)', 36.3624992370605, 0.634645335940633, -90.5888900756836, -1.58107439754789, 218, 4, 'PPL', 'P'),
(22771, 'Luella', 33.3519401550293, 0.582101167633369, -84.1786117553711, -1.46919393488923, 218, 13, 'PPL', 'P'),
(41899, 'Luella', 31.7755603790283, 0.554588150280302, -92.995002746582, -1.62306898582903, 218, 22, 'PPL', 'P'),
(95901, 'Luella', 33.5694389343262, 0.585897237451168, -96.5508270263672, -1.68512982713363, 218, 51, 'PPL', 'P'),
(156251, 'Lueneburg', 41.4569396972656, 0.723560095518026, -84.1733322143555, -1.46910178951551, 218, 41, 'PPL', 'P'),
(196958, 'Lufboro (historical)', 47.2833290100098, 0.825249772528421, -104.45832824707, -1.82314175904037, 218, 31, 'PPL', 'P'),
(95902, 'Lufkin', 31.3380603790283, 0.546952334802826, -94.728889465332, -1.65333101792781, 218, 51, 'PPL', 'P'),
(175082, 'Lufkin', 44.7511100769043, 0.781054214764393, -91.6105575561523, -1.59890585894263, 218, 57, 'PPL', 'P'),
(10228, 'Lufra (historical)', 33.5291709899902, 0.585194429239496, -92.9941711425781, -1.62305447160109, 218, 4, 'PPL', 'P'),
(76466, 'Lugert', 34.8958282470703, 0.609047098121818, -99.2750015258789, -1.73267564154898, 218, 42, 'PPL', 'P'),
(175083, 'Lugerville', 45.7755584716797, 0.798934212269994, -90.5061111450195, -1.57962963265653, 218, 57, 'PPL', 'P'),
(3900, 'Lugo', 31.9655609130859, 0.557904285180155, -85.2149963378906, -1.4872822581711, 218, 2, 'PPL', 'P'),
(182999, 'Lugo', 34.3672218322754, 0.599821175736484, -117.34139251709, -2.04799364829825, 218, 6, 'PPL', 'P'),
(888, 'Lugoff', 34.2272186279297, 0.597377658857309, -80.6894378662109, -1.40829636234877, 218, 48, 'PPL', 'P'),
(73300, 'Luhrig', 39.3333282470703, 0.686496083679067, -82.1833267211914, -1.43436964152703, 218, 41, 'PPL', 'P'),
(188952, 'Luis Lopez', 33.9888916015625, 0.593218067550714, -106.884719848633, -1.86549028143038, 218, 38, 'PPL', 'P'),
(187011, 'Lujane', 38.4872207641602, 0.671728722276523, -107.733062744141, -1.88029665814289, 218, 7, 'PPL', 'P'),
(178571, 'Lukachukai', 36.4169387817383, 0.635595485238546, -109.228057861328, -1.90638924523905, 218, 5, 'PPL', 'P'),
(201166, 'Lukarilla', 45.8274993896484, 0.799840752305057, -123.600563049316, -2.15723678252941, 218, 43, 'PPL', 'P'),
(3901, 'Luke', 34.0502815246582, 0.59428952383628, -85.8994369506836, -1.49922800039871, 218, 2, 'PPL', 'P'),
(22772, 'Luke', 31.3377799987793, 0.546947441244323, -85.0002822875977, -1.4835347910432, 218, 13, 'PPL', 'P'),
(49110, 'Luke', 39.4749984741211, 0.688968695593151, -79.0572204589844, -1.3798087944843, 218, 25, 'PPL', 'P'),
(88715, 'Luke (historical)', 36.3597183227539, 0.634596799829766, -82.5666732788086, -1.44106030113363, 218, 50, 'PPL', 'P'),
(73301, 'Luke Chute', 39.5380592346191, 0.690069313492653, -81.7197189331055, -1.42627815918704, 218, 41, 'PPL', 'P'),
(41904, 'Luke Landing', 29.5972194671631, 0.516568929137358, -91.5416717529297, -1.59770357486851, 218, 22, 'PPL', 'P'),
(95903, 'Luke Wilson', 33.7177810668945, 0.588486296083916, -98.5500030517578, -1.72002203110363, 218, 51, 'PPL', 'P'),
(16963, 'Lukens', 29.1861095428467, 0.509393707370412, -83.1352767944336, -1.4509843046197, 218, 12, 'PPL', 'P'),
(66520, 'Lukens', 34.9705581665039, 0.610351381265685, -76.5744400024414, -1.33647610091346, 218, 33, 'PPL', 'P'),
(103864, 'Lukes Island (historical)', 38.0566711425781, 0.664214213786701, -76.9027786254883, -1.34220669094709, 218, 53, 'PPL', 'P'),
(3902, 'Lukes Landing', 32.6711082458496, 0.570218409165545, -88.0591735839844, -1.53692251562574, 218, 2, 'PPL', 'P'),
(41900, 'Lukeville', 30.3794403076172, 0.530221258280999, -91.2436065673828, -1.59250135599515, 218, 22, 'PPL', 'P'),
(178572, 'Lukeville', 31.8824996948242, 0.55645459344077, -112.815002441406, -1.96899323824798, 218, 5, 'PPL', 'P'),
(22773, 'Lula', 34.3875007629395, 0.600175109845355, -83.666389465332, -1.46025396942594, 218, 13, 'PPL', 'P'),
(41902, 'Lula', 31.8805599212646, 0.556420738005412, -93.7805633544922, -1.63677960491103, 218, 22, 'PPL', 'P'),
(60715, 'Lula', 34.4530601501465, 0.601319337007708, -90.4786071777344, -1.57914959787004, 218, 30, 'PPL', 'P'),
(76468, 'Lula', 34.7005615234375, 0.605639050874844, -96.4319381713867, -1.6830548251703, 218, 42, 'PPL', 'P'),
(88716, 'Lula (historical)', 35.4791717529297, 0.619228362969191, -88.4347229003906, -1.54347708770065, 218, 50, 'PPL', 'P'),
(22774, 'Lulaton', 31.2155609130859, 0.544814315790197, -81.9038925170898, -1.42949259462276, 218, 13, 'PPL', 'P'),
(22776, 'Lulaville', 33.5161094665527, 0.584966462650185, -82.0774993896484, -1.432522606153, 218, 13, 'PPL', 'P'),
(88717, 'Lulaville', 36.2577781677246, 0.632817608484511, -83.5755615234375, -1.45866872278707, 218, 50, 'PPL', 'P'),
(41903, 'Luling', 29.9319400787354, 0.522410905883583, -90.3663864135742, -1.57719097604634, 218, 22, 'PPL', 'P'),
(95904, 'Luling', 29.6802806854248, 0.518018620876742, -97.647216796875, -1.70426543851418, 218, 51, 'PPL', 'P'),
(191816, 'Lull', 29.7527809143066, 0.51928398857918, -101.292778015137, -1.76789248485586, 218, 51, 'PPL', 'P'),
(16964, 'Lulu', 30.1072196960449, 0.52547011231727, -82.4913864135742, -1.43974629745179, 218, 12, 'PPL', 'P'),
(56016, 'Lulu', 36.6886100769043, 0.64033704382235, -91.3050003051758, -1.59357287885974, 218, 29, 'PPL', 'P'),
(131851, 'Lulu', 41.8797187805176, 0.730938982529336, -83.6108322143555, -1.45928431247304, 218, 27, 'PPL', 'P'),
(199504, 'Lulu (historical)', 42.3083305358887, 0.738419668873314, -102.561111450195, -1.79002907931076, 218, 35, 'PPL', 'P'),
(3903, 'Lum', 32.0658302307129, 0.559654314911473, -86.6508331298828, -1.51234233771264, 218, 2, 'PPL', 'P'),
(131850, 'Lum', 43.0994415283203, 0.752227160439966, -83.1511077880859, -1.4512606075828, 218, 27, 'PPL', 'P'),
(49111, 'Lum Estates', 39.6300010681152, 0.69167400120748, -75.9380569458008, -1.32536912127117, 218, 25, 'PPL', 'P'),
(27767, 'Lumaghi Heights', 38.670280456543, 0.674923716636291, -89.9477767944336, -1.56988485991182, 218, 18, 'PPL', 'P'),
(10229, 'Lumber', 33.3502807617188, 0.582072205756515, -93.3472213745117, -1.62921636057326, 218, 4, 'PPL', 'P'),
(82195, 'Lumber (historical)', 34.417781829834, 0.600703614163682, -79.8091735839844, -1.39293285233621, 218, 48, 'PPL', 'P'),
(112649, 'Lumber (historical)', 38.9147186279297, 0.679189967544543, -79.774169921875, -1.39232192318215, 218, 58, 'PPL', 'P'),
(66521, 'Lumber Bridge', 34.8883285522461, 0.608916203754241, -79.0725021362305, -1.38007551006747, 218, 33, 'PPL', 'P'),
(22777, 'Lumber City', 31.9291706085205, 0.557269154549684, -82.6797180175781, -1.44303330402722, 218, 13, 'PPL', 'P'),
(164056, 'Lumber City', 40.6602783203125, 0.709655731466723, -77.6011123657227, -1.35439491399195, 218, 45, 'PPL', 'P'),
(66523, 'Lumber Mill', 36.3088912963867, 0.633709700870661, -76.254997253418, -1.33090077317138, 218, 33, 'PPL', 'P'),
(110224, 'Lumberport', 39.3738899230957, 0.687204018475837, -80.3486099243164, -1.40234779257991, 218, 58, 'PPL', 'P'),
(16965, 'Lumberton', 28.2658290863037, 0.49333178336198, -82.1366729736328, -1.43355538002373, 218, 12, 'PPL', 'P'),
(60717, 'Lumberton', 31.0011100769043, 0.541071442615172, -89.4522171020508, -1.56123571163957, 218, 30, 'PPL', 'P'),
(66524, 'Lumberton', 34.6180610656738, 0.604199146252465, -79.0088882446289, -1.37896523820902, 218, 33, 'PPL', 'P'),
(71057, 'Lumberton', 39.9658317565918, 0.697535352450636, -74.8055572509766, -1.30560327281866, 218, 37, 'PPL', 'P'),
(73302, 'Lumberton', 39.5569381713867, 0.690398813098523, -83.8488922119141, -1.46343924324773, 218, 41, 'PPL', 'P'),
(95906, 'Lumberton', 30.2655601501465, 0.528233674580446, -94.1994400024414, -1.64409038157746, 218, 51, 'PPL', 'P'),
(103874, 'Lumberton', 36.8813896179199, 0.643701681543556, -77.2108306884766, -1.3475832137138, 218, 53, 'PPL', 'P'),
(188953, 'Lumberton', 36.9300003051758, 0.644550098087828, -106.936393737793, -1.86639216093353, 218, 38, 'PPL', 'P'),
(164059, 'Lumberville', 40.4066696166992, 0.705229424576956, -75.038330078125, -1.30966592506158, 218, 45, 'PPL', 'P'),
(14154, 'Lumbrook', 39.6852798461914, 0.692638797891389, -75.7330627441406, -1.32179129750471, 218, 10, 'PPL', 'P'),
(247, 'Lumbull', 34.253059387207, 0.597828665187914, -87.7313919067383, -1.53120164613009, 218, 2, 'PPL', 'P'),
(183001, 'Lumer', 36.0374984741211, 0.628973002555846, -118.990280151367, -2.07677216651181, 218, 6, 'PPL', 'P'),
(88718, 'Luminary', 35.6955604553223, 0.62300505829006, -85.0008316040039, -1.48354437842312, 218, 50, 'PPL', 'P'),
(95907, 'Lumkins', 32.2436103820801, 0.562757163897524, -96.8641662597656, -1.69059862843211, 218, 51, 'PPL', 'P'),
(95908, 'Lumm', 30.2777805328369, 0.528446960494247, -94.8916702270508, -1.65617207817871, 218, 51, 'PPL', 'P'),
(207970, 'Lummi', 48.7949981689453, 0.8516333765527, -122.612503051758, -2.13999188236477, 218, 56, 'PPL', 'P'),
(207971, 'Lummi Island', 48.7247200012207, 0.850406791133637, -122.684997558594, -2.14125715019867, 218, 56, 'PPL', 'P'),
(103865, 'Lummis', 36.6949996948242, 0.640448563692997, -76.7013931274414, -1.3386918509404, 218, 53, 'PPL', 'P'),
(71059, 'Lummistown', 39.350830078125, 0.686801548256099, -75.179443359375, -1.31212881643768, 218, 37, 'PPL', 'P'),
(113199, 'Lummisville', 43.2449989318848, 0.75476761638282, -76.9066696166992, -1.34227460155489, 218, 40, 'PPL', 'P'),
(22780, 'Lumpkin', 32.0508308410645, 0.559392526176318, -84.7991714477539, -1.48002474472647, 218, 13, 'PPL', 'P'),
(183002, 'Lumpkin', 39.6100006103516, 0.691324927367598, -121.207778930664, -2.1154748213695, 218, 6, 'PPL', 'P'),
(103866, 'Lumpkin Forest', 36.6577796936035, 0.639798952124099, -79.3786087036133, -1.38541807753028, 218, 53, 'PPL', 'P'),
(66526, 'Lumptown', 35.8925018310547, 0.626442333729998, -82.7255630493164, -1.44383345077673, 218, 33, 'PPL', 'P'),
(41906, 'Lums', 32.3955612182617, 0.565409206290052, -91.1547164916992, -1.59094993150213, 218, 22, 'PPL', 'P'),
(191812, 'Lums Chapel', 33.8325004577637, 0.590488527170465, -102.327217102051, -1.78594685283384, 218, 51, 'PPL', 'P'),
(14155, 'Lums Pond Estates II', 39.5750007629395, 0.690714064792561, -75.7069396972656, -1.32133536432608, 218, 10, 'PPL', 'P'),
(10230, 'Luna', 33.3830604553223, 0.582644319337691, -91.2050018310547, -1.59182757623936, 218, 4, 'PPL', 'P'),
(41905, 'Luna', 32.3250007629395, 0.564177694022972, -92.2219390869141, -1.6095764796403, 218, 22, 'PPL', 'P'),
(56018, 'Luna', 36.6519393920898, 0.639697019633377, -92.3055572509766, -1.61103589191767, 218, 29, 'PPL', 'P'),
(88719, 'Luna', 35.3691711425781, 0.617308490139353, -86.7305603027344, -1.5137338393822, 218, 50, 'PPL', 'P'),
(95909, 'Luna', 31.5522193908691, 0.550690114682266, -96.2172164916992, -1.67930722488434, 218, 51, 'PPL', 'P'),
(136608, 'Luna', 48.2536087036133, 0.842184347847044, -96.793327331543, -1.68936225589604, 218, 28, 'PPL', 'P'),
(188956, 'Luna', 33.8188896179199, 0.59025097320123, -108.953887939453, -1.9016040773924, 218, 38, 'PPL', 'P'),
(3904, 'Luna (historical)', 34.4463882446289, 0.601202890289044, -85.8277816772461, -1.49797737995081, 218, 2, 'PPL', 'P'),
(131852, 'Luna Pier', 41.8069381713867, 0.729668721268396, -83.442497253418, -1.45634631315847, 218, 27, 'PPL', 'P'),
(37001, 'Lunah', 37.5625, 0.65558930028037, -83.1769409179688, -1.45171148075535, 218, 21, 'PPL', 'P'),
(95910, 'Lunar Heights Colonia', 26.1700000762939, 0.456752666578497, -98.0699996948242, -1.71164439210452, 218, 51, 'PPL', 'P'),
(191813, 'Lunas', 29.2152805328369, 0.509902837191808, -103.534439086914, -1.80701685127216, 218, 51, 'PPL', 'P'),
(210583, 'Lunaville', 20.8769397735596, 0.364371336789174, -156.673614501953, -2.73447042405942, 218, 15, 'PPL', 'P'),
(95911, 'Lund', 30.4063892364502, 0.530691605819021, -97.396110534668, -1.69988280746629, 218, 51, 'PPL', 'P'),
(175084, 'Lund', 44.5397186279297, 0.777364737969224, -92.2058334350586, -1.60929538298725, 218, 57, 'PPL', 'P'),
(183003, 'Lund', 38.3305587768555, 0.668994454785338, -121.642776489258, -2.1230669610051, 218, 6, 'PPL', 'P'),
(190441, 'Lund', 38.8566703796387, 0.67817683448685, -115.006942749023, -2.00724981362308, 218, 39, 'PPL', 'P'),
(192678, 'Lund', 38.0074996948242, 0.663356010125423, -113.43083190918, -1.97974149009143, 218, 52, 'PPL', 'P'),
(195267, 'Lund', 42.6427803039551, 0.744256918508604, -111.88777923584, -1.95281014040995, 218, 17, 'PPL', 'P'),
(156252, 'Lunda', 40.3647193908691, 0.704497255014267, -83.5116729736328, -1.45755365723866, 218, 41, 'PPL', 'P'),
(110225, 'Lundale', 37.8011093139648, 0.659753818434981, -81.7444381713867, -1.42670959128363, 218, 58, 'PPL', 'P'),
(66527, 'Lunday', 35.9541702270508, 0.627518650284553, -82.1952819824219, -1.43457830019843, 218, 33, 'PPL', 'P'),
(22783, 'Lundberg', 33.6500015258789, 0.587303319927703, -82.7266693115234, -1.44385275869463, 218, 13, 'PPL', 'P'),
(10231, 'Lundell', 34.1919403076172, 0.596761936013283, -90.9622192382813, -1.58759022062894, 218, 4, 'PPL', 'P'),
(116637, 'Lundgren', 42.3686103820801, 0.73947175066195, -94.1744384765625, -1.64365402263285, 218, 16, 'PPL', 'P'),
(204752, 'Lundon Street Condo', 40.6238899230957, 0.709020634125766, -111.872222900391, -1.95253863113682, 218, 52, 'PPL', 'P'),
(175085, 'Lunds', 44.6994400024414, 0.780152401840265, -88.545280456543, -1.54540668106846, 218, 57, 'PPL', 'P'),
(198558, 'Lunds Landing', 48.165828704834, 0.840652297850949, -103.140281677246, -1.80013750670232, 218, 34, 'PPL', 'P'),
(198559, 'Lunds Valley', 48.5077781677246, 0.846620441853817, -102.542221069336, -1.78969937996781, 218, 34, 'PPL', 'P'),
(10232, 'Lundsford Corner', 34.9072189331055, 0.609245903097193, -92.5494384765625, -1.61529242228794, 218, 4, 'PPL', 'P'),
(16966, 'Lundy', 29.6180591583252, 0.516932650363235, -81.6477813720703, -1.42502261189112, 218, 12, 'PPL', 'P'),
(56019, 'Lundy', 37.2830581665039, 0.650712120218053, -92.059440612793, -1.60674034623742, 218, 29, 'PPL', 'P'),
(183004, 'Lundy', 38.0275001525879, 0.663705083965305, -119.240562438965, -2.08114041648982, 218, 6, 'PPL', 'P'),
(82196, 'Lundy Crossroads', 33.8841705322266, 0.591390340094593, -79.1786117553711, -1.38192747228951, 218, 48, 'PPL', 'P'),
(164060, 'Lundys Lane', 41.8925018310547, 0.731162088849658, -80.3391723632813, -1.40218307606649, 218, 45, 'PPL', 'P'),
(10233, 'Lunenburg', 36.002498626709, 0.628362139980809, -91.9075012207031, -1.60408850358198, 218, 4, 'PPL', 'P'),
(103867, 'Lunenburg', 36.9608306884766, 0.645088189786079, -78.2658309936523, -1.36599644264866, 218, 53, 'PPL', 'P'),
(125284, 'Lunenburg', 42.5944404602051, 0.743413229075267, -71.7249984741211, -1.25183737936132, 218, 23, 'PPL', 'P'),
(172213, 'Lunenburg', 44.4630584716797, 0.776026765837568, -71.682502746582, -1.25109568899773, 218, 55, 'PPL', 'P'),
(125285, 'Lunenburg Station', 42.5361099243164, 0.742395169169557, -71.7041702270508, -1.25147385787253, 218, 23, 'PPL', 'P'),
(37002, 'Luner', 37.2355613708496, 0.649883144749739, -84.2755584716797, -1.47088597428781, 218, 21, 'PPL', 'P'),
(10235, 'Lunet', 33.7633285522461, 0.589281249669305, -92.9086074829102, -1.62156110401982, 218, 4, 'PPL', 'P'),
(164061, 'Lungerville', 41.2775001525879, 0.72042828465512, -76.5122222900391, -1.33539019697898, 218, 45, 'PPL', 'P'),
(190440, 'Luning', 38.5063896179199, 0.672063281888464, -118.180557250977, -2.0626398358712, 218, 39, 'PPL', 'P'),
(41907, 'Lunita', 30.3583297729492, 0.529852809944186, -93.5944366455078, -1.63353108101335, 218, 22, 'PPL', 'P'),
(82197, 'Lunn', 34.3413887023926, 0.599370302563934, -79.9705581665039, -1.39574954466313, 218, 48, 'PPL', 'P'),
(201167, 'Lunnville', 45.3505592346191, 0.791516576264824, -123.173606872559, -2.14978499148326, 218, 43, 'PPL', 'P'),
(10236, 'Lunsford', 35.7572212219238, 0.624081241686561, -90.4802780151367, -1.57917875948398, 218, 4, 'PPL', 'P'),
(116638, 'Lunsford', 40.6027793884277, 0.708652185788954, -92.4352798461914, -1.6132999783184, 218, 16, 'PPL', 'P'),
(103869, 'Lunt', 38.8002815246582, 0.677192663306011, -77.1397171020508, -1.34634204748776, 218, 53, 'PPL', 'P'),
(128024, 'Lunts Corner', 43.6858291625977, 0.762461555351086, -70.2688903808594, -1.22642349886897, 218, 26, 'PPL', 'P'),
(196960, 'Lupfer', 48.4836082458496, 0.846198597137148, -114.510276794434, -1.99858135743292, 218, 31, 'PPL', 'P'),
(204755, 'Lupine Village', 41.0022201538086, 0.715623742311536, -111.904167175293, -1.95309616391102, 218, 52, 'PPL', 'P'),
(3905, 'Lupton', 33.9361114501953, 0.592296880129656, -87.397216796875, -1.52536919018476, 218, 2, 'PPL', 'P'),
(66528, 'Lupton', 34.9613914489746, 0.610191391863198, -76.2825012207031, -1.33138080795786, 218, 33, 'PPL', 'P'),
(131853, 'Lupton', 44.4311103820801, 0.775469166484333, -84.0258331298828, -1.46652744484779, 218, 27, 'PPL', 'P'),
(178573, 'Lupton', 35.353889465332, 0.617041774556182, -109.053062438965, -1.90333499894289, 218, 5, 'PPL', 'P'),
(88720, 'Lupton City', 35.1055603027344, 0.612707613040132, -85.2641677856445, -1.48814046183238, 218, 50, 'PPL', 'P'),
(56020, 'Lupus', 38.8461112976074, 0.677992543739416, -92.4530563354492, -1.61361023658539, 218, 29, 'PPL', 'P'),
(60719, 'Lurand', 34.1358299255371, 0.595782625101433, -90.5277786254883, -1.58000780153132, 218, 30, 'PPL', 'P'),
(16967, 'Luraville', 30.1222190856934, 0.525731901052425, -83.1694412231445, -1.45158058638777, 218, 12, 'PPL', 'P'),
(33155, 'Luray', 39.1105613708496, 0.682608068224633, -98.688606262207, -1.72244111347981, 218, 20, 'PPL', 'P'),
(73304, 'Luray', 39.9577789306641, 0.697394804124107, -82.5316696166992, -1.44044937197957, 218, 41, 'PPL', 'P'),
(82198, 'Luray', 32.8136100769043, 0.57270553530757, -81.2399978637695, -1.41790544703594, 218, 48, 'PPL', 'P'),
(88721, 'Luray', 35.5913887023926, 0.621186918213863, -88.5758285522461, -1.5459398459187, 218, 50, 'PPL', 'P'),
(103870, 'Luray', 38.6652793884277, 0.674836431531563, -78.459716796875, -1.36938038828777, 218, 53, 'PPL', 'P'),
(116639, 'Luray', 41.9905586242676, 0.73287350274517, -92.9997177124023, -1.62315127750671, 218, 16, 'PPL', 'P'),
(123106, 'Luray', 40.0711097717285, 0.699372800444736, -85.366943359375, -1.4899342339846, 218, 19, 'PPL', 'P'),
(139296, 'Luray', 40.4530601501465, 0.706039092127368, -91.8816680908203, -1.60363763040943, 218, 29, 'PPL', 'P'),
(82199, 'Luray Hills', 35.0825004577637, 0.612305142820394, -81.9872207641602, -1.43094694689406, 218, 48, 'PPL', 'P'),
(164065, 'Lurgan', 40.0938911437988, 0.699770410395485, -77.6313934326172, -1.35492341831027, 218, 45, 'PPL', 'P'),
(103871, 'Lurich', 37.3808288574219, 0.652418540686522, -80.8411102294922, -1.41094354447231, 218, 53, 'PPL', 'P'),
(60718, 'Lurline', 34.7430610656738, 0.606380807817458, -89.845832824707, -1.56810560198754, 218, 30, 'PPL', 'P'),
(183005, 'Lurline (historical)', 39.2191696166992, 0.684503639709524, -122.245002746582, -2.13357779203737, 218, 6, 'PPL', 'P'),
(49112, 'Lurose Estates', 39.6958312988281, 0.692822955480768, -77.6883316040039, -1.35591717687104, 218, 25, 'PPL', 'P'),
(10238, 'Lurton', 35.7713890075684, 0.624328516193775, -93.0774993896484, -1.62450882387238, 218, 4, 'PPL', 'P'),
(49113, 'Lusby', 38.4105606079102, 0.670390750144867, -76.4555587768555, -1.33440123210818, 218, 25, 'PPL', 'P'),
(49114, 'Lusby Crossroads', 38.9877815246582, 0.6804651556535, -76.5849990844727, -1.33666039166089, 218, 25, 'PPL', 'P'),
(164064, 'Lushbaugh', 41.4230613708496, 0.722968807177002, -78.0316696166992, -1.36190955563982, 218, 45, 'PPL', 'P'),
(142322, 'Lushton', 40.7247200012207, 0.71078045097409, -97.7247161865234, -1.70561805803183, 218, 35, 'PPL', 'P'),
(3907, 'Lusk', 31.9680595397949, 0.557947894443005, -88.2874984741211, -1.54090753672288, 218, 2, 'PPL', 'P'),
(27768, 'Lusk', 37.482780456543, 0.654197931768858, -88.4741668701172, -1.54416551484243, 218, 18, 'PPL', 'P'),
(56021, 'Lusk', 37.0322189331055, 0.646334149702072, -89.3816680908203, -1.56000439910957, 218, 29, 'PPL', 'P'),
(88722, 'Lusk', 35.5013885498047, 0.619616119223907, -85.2986068725586, -1.48874153729041, 218, 50, 'PPL', 'P'),
(95912, 'Lusk', 32.9708290100098, 0.575449523336733, -99.0316696166992, -1.72842869855863, 218, 51, 'PPL', 'P'),
(209581, 'Lusk', 42.7625007629395, 0.746346434699881, -104.451667785645, -1.82302551205879, 218, 59, 'PPL', 'P'),
(30385, 'Lusks Mills (historical)', 39.8938903808594, 0.696279738575691, -87.1813888549805, -1.5216022819809, 218, 19, 'PPL', 'P'),
(88723, 'Luskville', 35.2750015258789, 0.615664920272611, -84.6611099243164, -1.47761511657217, 218, 50, 'PPL', 'P'),
(76469, 'Lusta', 36.2425003051758, 0.632550959480367, -95.3369369506836, -1.66394344855567, 218, 42, 'PPL', 'P'),
(196961, 'Lustre', 48.3933296203613, 0.844622937878203, -105.88166809082, -1.84798372568863, 218, 31, 'PPL', 'P'),
(193267, 'Lutak', 59.3411102294922, 1.03569775529353, -135.565567016602, -2.36606549677272, 218, 1, 'PPL', 'P'),
(41913, 'Lutcher', 30.0402793884277, 0.524301783547052, -90.6988906860352, -1.58299427037773, 218, 22, 'PPL', 'P'),
(103872, 'Lutersville', 36.7180595397949, 0.640851033912735, -76.664436340332, -1.33804683332439, 218, 53, 'PPL', 'P'),
(41908, 'Lutes', 31.639720916748, 0.552217304409372, -92.5527801513672, -1.61535074551581, 218, 22, 'PPL', 'P'),
(49115, 'Lutes', 39.0699996948242, 0.681900133427862, -77.0502777099609, -1.34478103561481, 218, 25, 'PPL', 'P'),
(56022, 'Lutesville', 37.3002815246582, 0.651012724526096, -89.9811096191406, -1.57046662745194, 218, 29, 'PPL', 'P'),
(60720, 'Luther', 32.8166694641113, 0.572758931687426, -89.480827331543, -1.56173505434396, 218, 30, 'PPL', 'P'),
(66529, 'Luther', 35.535831451416, 0.620217261260965, -82.7369384765625, -1.444031989436, 218, 33, 'PPL', 'P'),
(76470, 'Luther', 35.6616706848145, 0.622413570211953, -97.1952819824219, -1.69637768799758, 218, 42, 'PPL', 'P'),
(88724, 'Luther', 36.4608306884766, 0.636361543526107, -83.2402801513672, -1.45281695892384, 218, 50, 'PPL', 'P'),
(116640, 'Luther', 41.9677810668945, 0.732475959373448, -93.8186111450195, -1.63744366412884, 218, 16, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(120450, 'Luther', 40.1933288574219, 0.701505925898862, -89.6530609130859, -1.56474109742438, 218, 18, 'PPL', 'P'),
(123107, 'Luther', 41.0027809143066, 0.715633529428542, -85.5738906860352, -1.49354614621302, 218, 19, 'PPL', 'P'),
(131854, 'Luther', 44.0402793884277, 0.768647878826259, -85.682502746582, -1.49544178427694, 218, 27, 'PPL', 'P'),
(150425, 'Luther', 42.603889465332, 0.74357814532577, -73.6513900756836, -1.28545925549135, 218, 40, 'PPL', 'P'),
(191814, 'Luther', 32.4436111450195, 0.566247835717318, -101.456390380859, -1.7707480593347, 218, 51, 'PPL', 'P'),
(196962, 'Luther', 45.2844390869141, 0.790362561985465, -109.428062438965, -1.90987998363787, 218, 31, 'PPL', 'P'),
(82203, 'Luther (historical)', 33.2730598449707, 0.580724446507853, -81.1536102294922, -1.41639769838479, 218, 48, 'PPL', 'P'),
(125287, 'Luther Corner', 41.7447204589844, 0.728582817333916, -71.2236099243164, -1.24308649833543, 218, 23, 'PPL', 'P'),
(103873, 'Luther Park', 37.2472190856934, 0.650086610257021, -80.102783203125, -1.39805730690574, 218, 53, 'PPL', 'P'),
(175086, 'Lutheran Hill', 43.2083282470703, 0.754127592193847, -89.6005630493164, -1.56382483685134, 218, 57, 'PPL', 'P'),
(150427, 'Lutheranville', 42.5847206115723, 0.743243585713829, -74.6413879394531, -1.30273797780184, 218, 40, 'PPL', 'P'),
(125288, 'Luthers Corners', 41.8091697692871, 0.729707669999338, -71.3375015258789, -1.24507428177307, 218, 23, 'PPL', 'P'),
(169473, 'Luthers Corners', 41.8083305358887, 0.729693022613343, -71.3397216796875, -1.24511303076693, 218, 47, 'PPL', 'P'),
(164066, 'Luthers Mills', 41.7822189331055, 0.729237289171803, -76.5666732788086, -1.33634054601397, 218, 45, 'PPL', 'P'),
(164067, 'Luthersburg', 41.0533294677734, 0.716515768118658, -78.7194366455078, -1.37391335477919, 218, 45, 'PPL', 'P'),
(22784, 'Luthersville', 33.2099990844727, 0.57962382860835, -84.7444381713867, -1.47906946884346, 218, 13, 'PPL', 'P'),
(10239, 'Lutherville', 35.4838905334473, 0.619310721225902, -93.2777786254883, -1.62800435596116, 218, 4, 'PPL', 'P'),
(49116, 'Lutherville', 39.4211082458496, 0.688028133675162, -76.6263885498047, -1.33738277410657, 218, 25, 'PPL', 'P'),
(56023, 'Lutie', 36.5872192382813, 0.63856743985702, -92.6975021362305, -1.6178766206517, 218, 29, 'PPL', 'P'),
(76472, 'Lutie', 34.9233283996582, 0.609527066329278, -95.2616729736328, -1.66262984434799, 218, 42, 'PPL', 'P'),
(191815, 'Lutie', 35.0230598449707, 0.611267708417754, -100.222221374512, -1.74920774664787, 218, 51, 'PPL', 'P'),
(116641, 'Luton', 42.3397216796875, 0.738967547688571, -96.2261123657227, -1.67946248717589, 218, 16, 'PPL', 'P'),
(136611, 'Lutsen', 47.6472206115723, 0.831600879096042, -90.6747207641602, -1.58257242566106, 218, 28, 'PPL', 'P'),
(16968, 'Lutterloh', 30.3283290863037, 0.529329199184363, -84.253059387207, -1.47049329118508, 218, 12, 'PPL', 'P'),
(73305, 'Luttleton (historical)', 39.1669387817383, 0.68359203966839, -83.7888870239258, -1.46239195514906, 218, 41, 'PPL', 'P'),
(3908, 'Luttrell', 34.4402809143066, 0.601096297266414, -85.9347229003906, -1.49984385640079, 218, 2, 'PPL', 'P'),
(73306, 'Luttrell', 39.5847206115723, 0.690883708153999, -83.6497192382813, -1.45996301907685, 218, 41, 'PPL', 'P'),
(88726, 'Luttrell', 36.1994400024414, 0.631799415420747, -83.741943359375, -1.46157263363969, 218, 50, 'PPL', 'P'),
(103879, 'Luttrellville', 37.9449996948242, 0.662265179342926, -76.5844421386719, -1.33665067112291, 218, 53, 'PPL', 'P'),
(103875, 'Luttrels Corner', 37.9336090087891, 0.662066374367552, -76.4072189331055, -1.33355754267484, 218, 53, 'PPL', 'P'),
(88727, 'Lutts', 35.1511116027832, 0.613502633204548, -87.9380569458008, -1.53480863151049, 218, 50, 'PPL', 'P'),
(16969, 'Lutz', 28.1508293151855, 0.491324658716928, -82.461669921875, -1.43922764682949, 218, 12, 'PPL', 'P'),
(49117, 'Lutz Hill', 39.3325004577637, 0.686481636030153, -76.522216796875, -1.33556463403038, 218, 25, 'PPL', 'P'),
(164068, 'Lutzville', 40.0080604553223, 0.698272382282315, -78.4358291625977, -1.36896347041912, 218, 45, 'PPL', 'P'),
(3909, 'Luverne', 31.7163906097412, 0.553555442988596, -86.2638931274414, -1.50558896066236, 218, 2, 'PPL', 'P'),
(136613, 'Luverne', 43.6541709899902, 0.761909016003922, -96.2125015258789, -1.67922493320666, 218, 28, 'PPL', 'P'),
(140429, 'Luverne', 47.2511100769043, 0.824687446064251, -97.934440612793, -1.70927843979209, 218, 34, 'PPL', 'P'),
(60721, 'Lux', 31.4449996948242, 0.548818777963295, -89.4008331298828, -1.56033889214248, 218, 30, 'PPL', 'P'),
(190442, 'Lux', 39.1272201538086, 0.682898818836642, -119.112777709961, -2.07891015223493, 218, 39, 'PPL', 'P'),
(196963, 'Lux', 45.7344398498535, 0.798216556935245, -111.065826416016, -1.93846435740797, 218, 31, 'PPL', 'P'),
(95913, 'Luxello', 29.601390838623, 0.516641733303658, -98.3138885498047, -1.71590105563284, 218, 51, 'PPL', 'P'),
(116642, 'Luxemburg', 42.6027793884277, 0.74355877082884, -91.0738906860352, -1.58953925507271, 218, 16, 'PPL', 'P'),
(136616, 'Luxemburg', 45.4527816772461, 0.793300694458095, -94.2461090087891, -1.64490490939686, 218, 28, 'PPL', 'P'),
(175087, 'Luxemburg', 44.5386085510254, 0.777345363472294, -87.7038879394531, -1.5307216113436, 218, 57, 'PPL', 'P'),
(30386, 'Luxhaven', 39.9474983215332, 0.697215373645663, -85.8869400024414, -1.49900988750543, 218, 19, 'PPL', 'P'),
(49118, 'Luxmanor', 39.0424995422363, 0.681420165220403, -77.121940612793, -1.34603178922077, 218, 25, 'PPL', 'P'),
(22785, 'Luxomni', 33.896110534668, 0.591598732449892, -84.1163864135742, -1.46810789779669, 218, 13, 'PPL', 'P'),
(164069, 'Luxor', 40.334171295166, 0.703964090164033, -79.4783325195313, -1.3871585864607, 218, 45, 'PPL', 'P'),
(10240, 'Luxora', 35.7561111450195, 0.624061867189631, -89.9280624389648, -1.56954077949898, 218, 4, 'PPL', 'P'),
(56024, 'Luystown', 38.5580596923828, 0.672965094812592, -91.8338928222656, -1.60280379467212, 218, 29, 'PPL', 'P'),
(178574, 'Luzena', 32.3547210693359, 0.564696411224293, -109.626106262207, -1.91333650041669, 218, 5, 'PPL', 'P'),
(37003, 'Luzerne', 37.2183303833008, 0.649582407283642, -87.2108306884766, -1.52211613891323, 218, 21, 'PPL', 'P'),
(116643, 'Luzerne', 41.8980598449707, 0.731259094492364, -92.1797180175781, -1.60883958296668, 218, 16, 'PPL', 'P'),
(131855, 'Luzerne', 44.6158294677734, 0.778693122720956, -84.271110534668, -1.47080834314204, 218, 27, 'PPL', 'P'),
(150428, 'Luzerne', 41.9513893127441, 0.732189869293346, -75.1483306884766, -1.31158579789141, 218, 40, 'PPL', 'P'),
(164070, 'Luzerne', 41.2855606079102, 0.720568966139704, -75.9013900756836, -1.32472916366123, 218, 45, 'PPL', 'P'),
(110226, 'Luzon', 39.5333290100098, 0.689986755498861, -80.9297180175781, -1.41249004211732, 218, 58, 'PPL', 'P'),
(183006, 'Luzon', 38.0144386291504, 0.663477117375994, -122.250282287598, -2.13366993741108, 218, 6, 'PPL', 'P'),
(156254, 'Lybrand', 40.3166694641113, 0.703658625587001, -83.2372207641602, -1.45276356254399, 218, 41, 'PPL', 'P'),
(188958, 'Lybrook', 36.2333297729492, 0.632390903498853, -107.561668395996, -1.87730526244846, 218, 38, 'PPL', 'P'),
(110227, 'Lyburn', 37.8019409179688, 0.659768332662922, -81.9313888549805, -1.4299724962512, 218, 58, 'PPL', 'P'),
(187012, 'Lycan', 37.6152801513672, 0.656510487701428, -102.20027923584, -1.783731369123, 218, 7, 'PPL', 'P'),
(164073, 'Lycippus', 40.228889465332, 0.702126575590905, -79.4291687011719, -1.38630051595748, 218, 45, 'PPL', 'P'),
(150429, 'Lycoming', 43.4986114501953, 0.759193989851614, -76.3861083984375, -1.33318909433803, 218, 40, 'PPL', 'P'),
(116644, 'Lycurgus', 43.3311080932617, 0.756270504764979, -91.4238891601563, -1.59564788082308, 218, 16, 'PPL', 'P'),
(56025, 'Lyda (historical)', 39.833610534668, 0.695227656787055, -92.4591674804688, -1.61371689618705, 218, 29, 'PPL', 'P'),
(10241, 'Lydalisk', 35.7438888549805, 0.623848547986315, -92.3341674804688, -1.61153523462206, 218, 4, 'PPL', 'P'),
(113661, 'Lydallville', 41.795280456543, 0.729465255761114, -72.4908294677734, -1.26520365171438, 218, 8, 'PPL', 'P'),
(95914, 'Lyday Crossing', 33.4633293151855, 0.584045275229127, -95.8775024414063, -1.67337809619144, 218, 51, 'PPL', 'P'),
(103876, 'Lydell Heights', 37.6347198486328, 0.656849774424305, -77.48388671875, -1.35234894048449, 218, 53, 'PPL', 'P'),
(188957, 'Lyden', 36.146110534668, 0.630868640619764, -106.004997253418, -1.85013622563969, 218, 38, 'PPL', 'P'),
(10242, 'Lydesdale', 33.3208312988281, 0.581558215666129, -93.1180572509766, -1.62521669209012, 218, 4, 'PPL', 'P'),
(3910, 'Lydia', 34.4330596923828, 0.600970263167826, -85.850830078125, -1.49837965043346, 218, 2, 'PPL', 'P'),
(41909, 'Lydia', 29.9191703796387, 0.522188032589857, -91.795280456543, -1.60212988175828, 218, 22, 'PPL', 'P'),
(82200, 'Lydia', 34.288890838623, 0.598454041990892, -80.1125030517578, -1.39822695026718, 218, 48, 'PPL', 'P'),
(95915, 'Lydia', 33.4461097717285, 0.583744737500112, -94.7544403076172, -1.65377696425235, 218, 51, 'PPL', 'P'),
(103877, 'Lydia', 38.3302803039551, 0.668989594516349, -78.4911117553711, -1.36992833368205, 218, 53, 'PPL', 'P'),
(110228, 'Lydia', 38.6544418334961, 0.674647280515141, -81.0344390869141, -1.41431776957344, 218, 58, 'PPL', 'P'),
(136618, 'Lydia', 44.6527786254883, 0.779338007178918, -93.5008316040039, -1.63189736484264, 218, 28, 'PPL', 'P'),
(187787, 'Lydia', 38.2783317565918, 0.668082921323232, -101.291107177734, -1.76786332324193, 218, 20, 'PPL', 'P'),
(82201, 'Lydia Mills', 34.458610534668, 0.60141620949236, -81.9019393920898, -1.42945850616081, 218, 48, 'PPL', 'P'),
(123108, 'Lydick', 41.6933288574219, 0.727685864678777, -86.379997253418, -1.5076153599358, 218, 19, 'PPL', 'P'),
(3911, 'Lyeffion', 31.5424995422363, 0.550520471320828, -86.9861068725586, -1.51819396841782, 218, 2, 'PPL', 'P'),
(103878, 'Lyells', 37.996940612793, 0.663171719377989, -76.7291717529297, -1.33917667941685, 218, 53, 'PPL', 'P'),
(22786, 'Lyerly', 34.4038887023926, 0.60046113334643, -85.4033279418945, -1.49056926474653, 218, 13, 'PPL', 'P'),
(30387, 'Lyford', 39.6500015258789, 0.692023075047363, -87.3708267211914, -1.52490859647423, 218, 19, 'PPL', 'P'),
(95916, 'Lyford', 26.4119396209717, 0.460975308223899, -97.789436340332, -1.70674763780819, 218, 51, 'PPL', 'P'),
(128025, 'Lyford Corner', 44.9247207641602, 0.784084292873658, -69.3305587768555, -1.21004652290358, 218, 26, 'PPL', 'P'),
(144093, 'Lyford Crossing', 43.0111083984375, 0.750685456484919, -71.0994415283203, -1.24091935099838, 218, 36, 'PPL', 'P'),
(49119, 'Lyford Landing', 38.8441696166992, 0.677958655014545, -75.8672180175781, -1.3241327487351, 218, 25, 'PPL', 'P'),
(95917, 'Lyford South Colonia', 26.3990001678467, 0.46074947216346, -97.7919998168945, -1.7067923789145, 218, 51, 'PPL', 'P'),
(156275, 'Lykens', 40.9650001525879, 0.714974130742638, -83.0169372558594, -1.44891889003629, 218, 41, 'PPL', 'P'),
(164076, 'Lykens', 40.5666694641113, 0.708021948716986, -76.7008285522461, -1.33868199724437, 218, 45, 'PPL', 'P'),
(175090, 'Lykens', 45.4244384765625, 0.792806012285613, -92.4688873291016, -1.61388653954849, 218, 57, 'PPL', 'P'),
(150430, 'Lykers', 42.8111114501953, 0.747194851244153, -74.4722213745117, -1.29978546425933, 218, 40, 'PPL', 'P'),
(82202, 'Lykes', 33.9386100769043, 0.592340489392506, -80.9030609130859, -1.41202478787488, 218, 48, 'PPL', 'P'),
(37004, 'Lykins', 37.7780609130859, 0.659351547952325, -83.2219390869141, -1.45249684696081, 218, 21, 'PPL', 'P'),
(3912, 'Lyle', 32.8886108398438, 0.574014545562371, -86.3352813720703, -1.50683492057835, 218, 2, 'PPL', 'P'),
(136619, 'Lyle', 43.5052795410156, 0.75931036999125, -92.9438934326172, -1.6221769600219, 218, 28, 'PPL', 'P'),
(164078, 'Lyle', 41.142219543457, 0.718067192611684, -80.3408279418945, -1.40221197136432, 218, 45, 'PPL', 'P'),
(187788, 'Lyle', 39.9577789306641, 0.697394804124107, -100.216110229492, -1.74910108704621, 218, 20, 'PPL', 'P'),
(207972, 'Lyle', 45.6961097717285, 0.797547570869417, -121.285003662109, -2.11682264719719, 218, 56, 'PPL', 'P'),
(16970, 'Lyle Corner', 27.9127807617188, 0.487169927679323, -81.8697204589844, -1.42889617969664, 218, 12, 'PPL', 'P'),
(30388, 'Lyles', 38.3702812194824, 0.669687742196113, -87.6591720581055, -1.52994117198615, 218, 19, 'PPL', 'P'),
(41910, 'Lyles', 30.5230598449707, 0.532727892078009, -92.8247222900391, -1.62009703121055, 218, 22, 'PPL', 'P'),
(88728, 'Lyles', 35.9197196960449, 0.626917375089441, -87.3450012207031, -1.52445785645974, 218, 50, 'PPL', 'P'),
(41911, 'Lyles (historical)', 31.0372200012207, 0.54170167968714, -92.3444366455078, -1.61171446536342, 218, 22, 'PPL', 'P'),
(41912, 'Lyles Addition', 31.1469402313232, 0.543616658958475, -93.2652816772461, -1.62778624306788, 218, 22, 'PPL', 'P'),
(82204, 'Lylesford (historical)', 34.4524993896484, 0.601309549890702, -81.4180603027344, -1.42101322287001, 218, 48, 'PPL', 'P'),
(164079, 'Lyleville', 40.7391700744629, 0.711032652329321, -78.540283203125, -1.37078653734333, 218, 45, 'PPL', 'P'),
(60722, 'Lyman', 30.4972190856934, 0.532276885747404, -89.1108322143555, -1.55527742133273, 218, 30, 'PPL', 'P'),
(66530, 'Lyman', 34.857780456543, 0.608383038904007, -77.7474975585938, -1.35694981758371, 218, 33, 'PPL', 'P'),
(76473, 'Lyman', 36.8402786254883, 0.642984159366861, -96.7430572509766, -1.68848487747492, 218, 42, 'PPL', 'P'),
(82205, 'Lyman', 34.9480590820313, 0.609958698162952, -82.1275024414063, -1.43339532404222, 218, 48, 'PPL', 'P'),
(116645, 'Lyman', 41.2311096191406, 0.719618617104709, -94.9841690063477, -1.65778648643152, 218, 16, 'PPL', 'P'),
(136622, 'Lyman', 46.3400001525879, 0.808785578037333, -95.2483291625977, -1.66239695091066, 218, 28, 'PPL', 'P'),
(170801, 'Lyman', 43.8811111450195, 0.76586986891417, -99.7391662597656, -1.74077684442695, 218, 49, 'PPL', 'P'),
(192679, 'Lyman', 38.3969383239746, 0.67015299643855, -111.588890075684, -1.9475935404667, 218, 52, 'PPL', 'P'),
(195268, 'Lyman', 43.7391700744629, 0.763392529889151, -111.816940307617, -1.95157376787388, 218, 17, 'PPL', 'P'),
(199505, 'Lyman', 41.9172210693359, 0.73159352094625, -104.038612365723, -1.81581633498795, 218, 35, 'PPL', 'P'),
(207973, 'Lyman', 48.5272216796875, 0.84695979515572, -122.060562133789, -2.13035869606973, 218, 56, 'PPL', 'P'),
(209582, 'Lyman', 41.3274993896484, 0.721300935965312, -110.292221069336, -1.92496239699737, 218, 59, 'PPL', 'P'),
(183007, 'Lyman (historical)', 39.5688896179199, 0.690607405190904, -122.192497253418, -2.13266139830627, 218, 6, 'PPL', 'P'),
(103880, 'Lyman Park', 38.5275001525879, 0.672431730225276, -77.3516693115234, -1.35004131139994, 218, 53, 'PPL', 'P'),
(193754, 'Lyman Springs', 40.309440612793, 0.703532458330358, -121.766670227051, -2.12522931465219, 218, 6, 'PPL', 'P'),
(164080, 'Lymansville', 41.7730598449707, 0.729077432927371, -77.9850006103516, -1.36109502782042, 218, 45, 'PPL', 'P'),
(169474, 'Lymansville', 41.8413887023926, 0.730269996463508, -71.4730606079102, -1.24744023408549, 218, 47, 'PPL', 'P'),
(175091, 'Lymantown', 45.9341697692871, 0.801702501644104, -90.4524993896484, -1.57869393100753, 218, 57, 'PPL', 'P'),
(164081, 'Lymanville', 41.648609161377, 0.726905358742302, -75.9533309936523, -1.32563570369629, 218, 45, 'PPL', 'P'),
(144095, 'Lyme', 43.809440612793, 0.76461898215016, -72.1563873291016, -1.25936653523714, 218, 36, 'PPL', 'P'),
(156256, 'Lyme (historical)', 41.2916717529297, 0.720675625741362, -82.7827835083008, -1.44483213618551, 218, 41, 'PPL', 'P'),
(144096, 'Lyme Center', 43.7991714477539, 0.764439751408797, -72.1233291625977, -1.25878956138697, 218, 36, 'PPL', 'P'),
(113662, 'Lyme Station', 41.3016700744629, 0.720850129371789, -72.3272171020508, -1.26234807723554, 218, 8, 'PPL', 'P'),
(164084, 'Lymehurst', 41.246940612793, 0.719894920067805, -76.9524993896484, -1.34307448198829, 218, 45, 'PPL', 'P'),
(172214, 'Lympus', 43.8222198486328, 0.764842021891454, -72.7194366455078, -1.26919359965953, 218, 55, 'PPL', 'P'),
(22788, 'Lyn Hills', 32.538330078125, 0.567900992963985, -84.9302825927734, -1.48231306589312, 218, 13, 'PPL', 'P'),
(49120, 'Lyn Woods', 39.0080604553223, 0.680819089762372, -75.9013900756836, -1.32472916366123, 218, 25, 'PPL', 'P'),
(103881, 'Lynbrook', 38.788330078125, 0.676984071213631, -77.1830596923828, -1.3470985183954, 218, 53, 'PPL', 'P'),
(150432, 'Lynbrook', 40.6547203063965, 0.709558725824017, -73.6722183227539, -1.28582277698015, 218, 40, 'PPL', 'P'),
(164082, 'Lynces Junction', 41.6241683959961, 0.726478786914699, -80.3305587768555, -1.40203274062296, 218, 45, 'PPL', 'P'),
(37005, 'Lynch', 36.9661102294922, 0.645180335159795, -82.9225006103516, -1.44727065963764, 218, 21, 'PPL', 'P'),
(41914, 'Lynch', 30.3977794647217, 0.530541336954513, -91.3563919067383, -1.59446983151488, 218, 22, 'PPL', 'P'),
(49121, 'Lynch', 39.295280456543, 0.685832024461255, -76.0630569458008, -1.32755078283617, 218, 25, 'PPL', 'P'),
(142323, 'Lynch', 42.8302803039551, 0.747529410856094, -98.4658279418945, -1.71855289828829, 218, 35, 'PPL', 'P'),
(164083, 'Lynch', 41.6022186279297, 0.726095691191891, -79.0505599975586, -1.37969254750272, 218, 45, 'PPL', 'P'),
(22789, 'Lynch (historical)', 34.7000007629395, 0.605629263757838, -83.665283203125, -1.46023466150804, 218, 13, 'PPL', 'P'),
(66531, 'Lynch (historical)', 35.8172187805176, 0.62512839662718, -82.8916702270508, -1.44673256793939, 218, 33, 'PPL', 'P'),
(66532, 'Lynch Beach', 35.1599998474121, 0.613657762338045, -76.6866683959961, -1.33843485589521, 218, 33, 'PPL', 'P'),
(49122, 'Lynch Estates', 39.5033302307129, 0.689463178028551, -77.5936126708984, -1.35426401962437, 218, 25, 'PPL', 'P'),
(14156, 'Lynch Heights', 38.952220916748, 0.679844505961458, -75.4258270263672, -1.31642902264983, 218, 10, 'PPL', 'P'),
(49123, 'Lynch Point', 39.2458305358887, 0.684968960530988, -76.4433288574219, -1.33418777974681, 218, 25, 'PPL', 'P'),
(103884, 'Lynch Station', 37.146110534668, 0.648321933139707, -79.3011093139648, -1.38406545801263, 218, 53, 'PPL', 'P'),
(150433, 'Lynch Tract', 43.223331451416, 0.754389447508029, -75.4400024414063, -1.3166764303151, 218, 40, 'PPL', 'P'),
(16971, 'Lynchburg', 28.0877799987793, 0.490224240554508, -81.7552795410156, -1.42689880887908, 218, 12, 'PPL', 'P'),
(56028, 'Lynchburg', 37.4930610656738, 0.654377362247302, -92.2941665649414, -1.61083708694229, 218, 29, 'PPL', 'P'),
(60724, 'Lynchburg', 32.439998626709, 0.566184785378511, -90.5488891601563, -1.58037624986813, 218, 30, 'PPL', 'P'),
(82207, 'Lynchburg', 34.060001373291, 0.594459167197718, -80.0716705322266, -1.39751428835947, 218, 48, 'PPL', 'P'),
(88729, 'Lynchburg', 35.2830581665039, 0.615805535178167, -86.3741683959961, -1.50751362718216, 218, 50, 'PPL', 'P'),
(95918, 'Lynchburg', 29.7869396209717, 0.519880170478708, -95.0552825927734, -1.65902765265755, 218, 51, 'PPL', 'P'),
(103882, 'Lynchburg', 37.4136085510254, 0.652990654267698, -79.1425018310547, -1.38129723521755, 218, 53, 'PPL', 'P'),
(140431, 'Lynchburg', 46.7744407653809, 0.816367997134952, -97.2624969482422, -1.69755081045776, 218, 34, 'PPL', 'P'),
(156258, 'Lynchburg', 40.7411117553711, 0.711066541054192, -80.9994430541992, -1.41370697357743, 218, 41, 'PPL', 'P'),
(27769, 'Lynchburg (historical)', 38.2866706848145, 0.668228463076804, -88.7861099243164, -1.54960994821693, 218, 18, 'PPL', 'P'),
(95919, 'Lynchburg Landing', 29.7655601501465, 0.519507028320474, -95.0777816772461, -1.65942033576028, 218, 51, 'PPL', 'P'),
(103883, 'Lynchburg Mines (historical)', 37.392219543457, 0.652617345661896, -79.82861328125, -1.39327213905909, 218, 53, 'PPL', 'P'),
(82206, 'Lynches Mill', 34.0258293151855, 0.593862752271595, -79.8127822875977, -1.39299583609599, 218, 48, 'PPL', 'P'),
(49124, 'Lynchs Corner', 39.4919395446777, 0.689264373053177, -76.394172668457, -1.33332984240164, 218, 25, 'PPL', 'P'),
(66533, 'Lynchs Corner', 36.422779083252, 0.635697417729268, -76.42138671875, -1.33380481718205, 218, 33, 'PPL', 'P'),
(128028, 'Lynchville', 44.2441711425781, 0.77220646125385, -70.7850036621094, -1.23543137494005, 218, 26, 'PPL', 'P'),
(164096, 'Lynchville', 41.4372215270996, 0.723215948526161, -78.563606262207, -1.37119360151595, 218, 45, 'PPL', 'P'),
(110229, 'Lynco', 37.6980590820313, 0.657955252592796, -81.6772232055664, -1.42553646882345, 218, 58, 'PPL', 'P'),
(150434, 'Lyncourt', 43.0813903808594, 0.75191210848301, -76.126106262207, -1.32865120099859, 218, 40, 'PPL', 'P'),
(136623, 'Lynd', 44.3861083984375, 0.774683733699842, -95.8899993896484, -1.67359620908472, 218, 28, 'PPL', 'P'),
(136624, 'Lynd Mobile Home Park', 44.3861083984375, 0.774683733699842, -95.8899993896484, -1.67359620908472, 218, 28, 'PPL', 'P'),
(37006, 'Lyndale', 37.9691696166992, 0.662687024059595, -84.2052764892578, -1.46965932228972, 218, 21, 'PPL', 'P'),
(49125, 'Lyndale', 39.107780456543, 0.682559532113766, -76.4875030517578, -1.33495876488238, 218, 25, 'PPL', 'P'),
(116646, 'Lyndale', 43.2988891601563, 0.755708178300809, -91.283332824707, -1.59319470998495, 218, 16, 'PPL', 'P'),
(136627, 'Lyndale', 44.9824981689453, 0.785092698820416, -93.7316665649414, -1.63592619493971, 218, 28, 'PPL', 'P'),
(14157, 'Lyndalia', 39.7180595397949, 0.693210911472565, -75.602783203125, -1.319517490566, 218, 10, 'PPL', 'P'),
(144098, 'Lyndeborough', 42.9075012207031, 0.748877170104756, -71.7669372558594, -1.25256934918693, 218, 36, 'PPL', 'P'),
(164085, 'Lyndell', 40.059440612793, 0.699169135200372, -75.745002746582, -1.32199968986, 218, 45, 'PPL', 'P'),
(207974, 'Lynden', 48.9466705322266, 0.854280558676239, -122.450828552246, -2.13717013003178, 218, 56, 'PPL', 'P'),
(103886, 'Lyndhurst', 38.0291709899902, 0.663734245579241, -78.9452819824219, -1.37785509950862, 218, 53, 'PPL', 'P'),
(145659, 'Lyndhurst', 40.811939239502, 0.71230271385318, -74.1247177124023, -1.29372038119278, 218, 37, 'PPL', 'P'),
(156259, 'Lyndhurst', 41.5200004577637, 0.724660713417529, -81.4888916015625, -1.42224946224802, 218, 41, 'PPL', 'P'),
(175092, 'Lyndhurst', 44.8419418334961, 0.78263952798229, -88.8125, -1.55007054192746, 218, 57, 'PPL', 'P'),
(33157, 'Lyndon', 38.6100006103516, 0.673871634847655, -95.6841735839844, -1.67000387109031, 218, 20, 'PPL', 'P'),
(37007, 'Lyndon', 38.2566719055176, 0.667704885606495, -85.6016693115234, -1.49403097468947, 218, 21, 'PPL', 'P'),
(73308, 'Lyndon', 39.3525009155273, 0.686830709870035, -83.3122177124023, -1.45407250621976, 218, 41, 'PPL', 'P'),
(120453, 'Lyndon', 41.7174987792969, 0.728107709395446, -89.9258270263672, -1.56950176418901, 218, 18, 'PPL', 'P'),
(150435, 'Lyndon', 43.0291709899902, 0.751000708178958, -76.054443359375, -1.32740044739263, 218, 40, 'PPL', 'P'),
(164086, 'Lyndon', 40.0061111450195, 0.698238360399389, -76.2966690063477, -1.33162808246508, 218, 45, 'PPL', 'P'),
(172215, 'Lyndon', 44.5141716003418, 0.776918858223718, -72.0113906860352, -1.25683586641129, 218, 55, 'PPL', 'P'),
(131857, 'Lyndon Center', 42.3813896179199, 0.739694790403244, -84.0830612182617, -1.46752626341462, 218, 27, 'PPL', 'P'),
(172217, 'Lyndon Center', 44.5372200012207, 0.777321128706374, -72.0133285522461, -1.25686968855714, 218, 55, 'PPL', 'P'),
(175102, 'Lyndon Dale', 43.577220916748, 0.760565983866195, -88.9305572509766, -1.55213102966286, 218, 57, 'PPL', 'P'),
(33158, 'Lyndon Station', 38.6419410705566, 0.674429101042836, -95.684440612793, -1.67000853162222, 218, 20, 'PPL', 'P'),
(175093, 'Lyndon Station', 43.7122192382813, 0.762922149061616, -89.8994369506836, -1.56904117047848, 218, 57, 'PPL', 'P'),
(150437, 'Lyndonville', 43.3266716003418, 0.756193073356285, -78.3891677856445, -1.36814907575777, 218, 40, 'PPL', 'P'),
(172219, 'Lyndonville', 44.5336112976074, 0.777258144946594, -72.0036087036133, -1.2567000451957, 218, 55, 'PPL', 'P'),
(164087, 'Lyndora', 40.8522186279297, 0.713005721801933, -79.9272232055664, -1.39499320691355, 218, 45, 'PPL', 'P'),
(22790, 'Lyneville', 33.6358299255371, 0.587055978841462, -82.9297180175781, -1.4473966271572, 218, 13, 'PPL', 'P'),
(103887, 'Lynhams', 37.7183303833008, 0.658309053543613, -76.3430633544922, -1.33243781659452, 218, 53, 'PPL', 'P'),
(22791, 'Lynhaven', 33.3838882446289, 0.582658766986605, -84.833610534668, -1.4806258201845, 218, 13, 'PPL', 'P'),
(103888, 'Lynhaven', 38.8355598449707, 0.677808386150037, -77.057502746582, -1.34490713629243, 218, 53, 'PPL', 'P'),
(22792, 'Lynhurst', 31.9922199249268, 0.558369572712105, -81.1116714477539, -1.41566572855918, 218, 13, 'PPL', 'P'),
(30389, 'Lynhurst', 39.7588882446289, 0.693923506801243, -86.2480621337891, -1.50531265769927, 218, 19, 'PPL', 'P'),
(22793, 'Lynley Estates', 33.577220916748, 0.586033058666762, -84.4519424438477, -1.47396445534989, 218, 13, 'PPL', 'P'),
(3914, 'Lynn', 34.0469398498535, 0.594231200608408, -87.5497207641602, -1.52803088653624, 218, 2, 'PPL', 'P'),
(10243, 'Lynn', 36.0072212219238, 0.628444564816547, -91.2522201538086, -1.59265169143869, 218, 4, 'PPL', 'P'),
(16972, 'Lynn', 29.1736106872559, 0.509175561187621, -81.8686065673828, -1.42887673862068, 218, 12, 'PPL', 'P'),
(22795, 'Lynn', 31.9724998474121, 0.558025392430726, -81.9619369506836, -1.43050566110143, 218, 13, 'PPL', 'P'),
(37008, 'Lynn', 38.583610534668, 0.673411041137126, -82.9394378662109, -1.44756627051864, 218, 21, 'PPL', 'P'),
(66534, 'Lynn', 35.228328704834, 0.614850325874183, -82.2347183227539, -1.43526659418216, 218, 33, 'PPL', 'P'),
(88730, 'Lynn', 36.1055603027344, 0.630160905560075, -88.8600006103516, -1.55089958397481, 218, 50, 'PPL', 'P'),
(110230, 'Lynn', 37.6025009155273, 0.656287447960134, -82.1552810668945, -1.43388015251867, 218, 58, 'PPL', 'P'),
(123109, 'Lynn', 40.0497207641602, 0.698999491838934, -84.9397201538086, -1.48247778240654, 218, 19, 'PPL', 'P'),
(125289, 'Lynn', 42.4666709899902, 0.74118323113649, -70.9499969482422, -1.23831105102676, 218, 23, 'PPL', 'P'),
(156261, 'Lynn', 40.4988899230957, 0.706838972560773, -83.1072235107422, -1.45049468245329, 218, 41, 'PPL', 'P'),
(164089, 'Lynn', 41.6644401550293, 0.727181661705398, -75.9380569458008, -1.32536912127117, 218, 45, 'PPL', 'P'),
(175097, 'Lynn', 44.5825004577637, 0.778111421759855, -90.4097213745117, -1.57794731379592, 218, 57, 'PPL', 'P'),
(177369, 'Lynn', 43.2194404602051, 0.754321536900232, -72.2799987792969, -1.26152396203621, 218, 36, 'PPL', 'P'),
(187013, 'Lynn', 37.4272193908691, 0.653228208236933, -104.640556335449, -1.8263222391722, 218, 7, 'PPL', 'P'),
(199507, 'Lynn', 41.8013916015625, 0.729571915362771, -102.975830078125, -1.79726728483749, 218, 35, 'PPL', 'P'),
(204754, 'Lynn', 41.8727798461914, 0.730817875278765, -113.74388885498, -1.98520536454189, 218, 52, 'PPL', 'P'),
(3913, 'Lynn Acres', 33.6197204589844, 0.586774815609377, -86.706672668457, -1.51331692151355, 218, 2, 'PPL', 'P'),
(49126, 'Lynn Acres', 39.3480606079102, 0.686753211882314, -76.7541732788086, -1.33961303836146, 218, 25, 'PPL', 'P'),
(110231, 'Lynn Camp', 39.7700004577637, 0.694117451507628, -80.7074966430664, -1.40861154746378, 218, 58, 'PPL', 'P'),
(120455, 'Lynn Center', 41.2958297729492, 0.720748196881066, -90.357780456543, -1.57704077376086, 218, 18, 'PPL', 'P'),
(88731, 'Lynn Christie', 36.1738891601563, 0.631353469096213, -86.5397186279297, -1.51040302380684, 218, 50, 'PPL', 'P'),
(37009, 'Lynn City', 37.3716697692871, 0.65225868444209, -87.2508316040039, -1.52281428659299, 218, 21, 'PPL', 'P'),
(60725, 'Lynn Creek', 33.2333297729492, 0.580031025939023, -88.7305603027344, -1.54864042442209, 218, 30, 'PPL', 'P'),
(66536, 'Lynn Crossroads', 35.9258308410645, 0.627024034691098, -78.7616729736328, -1.37465051776893, 218, 33, 'PPL', 'P'),
(103891, 'Lynn Dell Estates', 37.211669921875, 0.64946616030206, -80.0155563354492, -1.3965349108686, 218, 53, 'PPL', 'P'),
(88732, 'Lynn Garden', 36.5769386291504, 0.638388009378576, -82.5677795410156, -1.44107960905154, 218, 50, 'PPL', 'P'),
(37010, 'Lynn Grove', 36.589168548584, 0.638601461739945, -88.4380569458008, -1.54353527777046, 218, 21, 'PPL', 'P'),
(95920, 'Lynn Grove', 30.2849998474121, 0.528572961303322, -96.0308303833008, -1.67605417361281, 218, 51, 'PPL', 'P'),
(103889, 'Lynn Grove', 37.5869407653809, 0.656015872107974, -77.4022216796875, -1.35092361666908, 218, 53, 'PPL', 'P'),
(16973, 'Lynn Haven', 30.2452793121338, 0.52787970718206, -85.6483306884766, -1.49484536935082, 218, 12, 'PPL', 'P'),
(103890, 'Lynn Haven', 37.2797203063965, 0.650653863569208, -79.8736114501953, -1.39405750526455, 218, 53, 'PPL', 'P'),
(22796, 'Lynn Haven Estates', 32.4283294677734, 0.565981120134147, -81.7508316040039, -1.42682117773331, 218, 13, 'PPL', 'P'),
(76476, 'Lynn Lane', 36.1477813720703, 0.6308978022337, -95.7794418334961, -1.6716666157169, 218, 42, 'PPL', 'P'),
(49127, 'Lynn Lee', 39.4744415283203, 0.688958975055172, -76.9649963378906, -1.34329259488157, 218, 25, 'PPL', 'P'),
(14159, 'Lynn Lee Village Mobile Home Park', 38.5574989318848, 0.672955307695586, -75.0877838134766, -1.31052905557087, 218, 10, 'PPL', 'P'),
(183008, 'Lynn Park Acres', 38.3894386291504, 0.670022102070973, -120.511672973633, -2.10332548047656, 218, 6, 'PPL', 'P'),
(191818, 'Lynn Park Replat Colonia', 31.6490001678467, 0.552379257893163, -106.276000976563, -1.85486613289372, 218, 51, 'PPL', 'P'),
(103893, 'Lynn Shores', 36.8544387817383, 0.643231300716021, -76.1133270263672, -1.32842816125729, 218, 53, 'PPL', 'P'),
(103892, 'Lynn Spring', 37.1044387817383, 0.647594623846007, -81.9338912963867, -1.43001617209307, 218, 53, 'PPL', 'P'),
(145661, 'Lynn Woodoaks', 40.5888900756836, 0.708409771550729, -74.333610534668, -1.2973662487251, 218, 37, 'PPL', 'P'),
(49128, 'Lynn Woods', 39.0097198486328, 0.680848051639227, -75.8988876342773, -1.32468548781935, 218, 25, 'PPL', 'P'),
(49130, 'Lynnbrook', 38.6450004577637, 0.674482497422692, -76.9055633544922, -1.34225529363698, 218, 25, 'PPL', 'P'),
(3916, 'Lynndale', 32.3236083984375, 0.564153392678026, -86.2658309936523, -1.5056227828082, 218, 2, 'PPL', 'P'),
(66539, 'Lynndale', 35.5736083984375, 0.620876593367841, -77.3805618286133, -1.35054558095235, 218, 33, 'PPL', 'P'),
(88733, 'Lynndale', 36.1327781677246, 0.630635946919518, -83.2669372558594, -1.45328221316628, 218, 50, 'PPL', 'P'),
(192680, 'Lynndyl', 39.5191688537598, 0.689739614149701, -112.375, -1.96131374692863, 218, 52, 'PPL', 'P'),
(16974, 'Lynne', 29.1922206878662, 0.509500366972069, -81.9175033569336, -1.429730148592, 218, 12, 'PPL', 'P'),
(14160, 'Lynnfield', 39.788890838623, 0.69444715085058, -75.5083312988281, -1.31786899385124, 218, 10, 'PPL', 'P'),
(125291, 'Lynnfield', 42.538890838623, 0.742443705280424, -71.0486068725586, -1.24003211888122, 218, 23, 'PPL', 'P'),
(103897, 'Lynnhaven', 37.0480613708496, 0.64661065240225, -76.4097213745117, -1.33360121851672, 218, 53, 'PPL', 'P'),
(103895, 'Lynnhaven Acres', 36.8536109924316, 0.643216853067107, -76.0691680908203, -1.32765744243782, 218, 53, 'PPL', 'P'),
(103896, 'Lynnhaven Colony', 36.9075012207031, 0.644157414985096, -76.0708312988281, -1.32768647089371, 218, 53, 'PPL', 'P'),
(103898, 'Lynnhaven Shores', 36.9105606079102, 0.644210811364952, -76.0819396972656, -1.32788034902106, 218, 53, 'PPL', 'P'),
(49131, 'Lynnhurst', 39.2719383239746, 0.685424627393501, -76.4522171020508, -1.3343429088803, 218, 25, 'PPL', 'P'),
(125293, 'Lynnhurst', 42.4708290100098, 0.741255802276194, -71.0041732788086, -1.23925660637179, 218, 23, 'PPL', 'P'),
(164091, 'Lynnport', 40.6752815246582, 0.709917586780905, -75.8052825927734, -1.32305177164864, 218, 45, 'PPL', 'P'),
(156264, 'Lynns Corners', 41.0424995422363, 0.716326750260289, -80.7372207641602, -1.40913033124413, 218, 41, 'PPL', 'P'),
(3917, 'Lynns Park', 33.8061103820801, 0.590027933459936, -87.1438903808594, -1.52094781014301, 218, 2, 'PPL', 'P'),
(82209, 'Lynns Ranchettes', 33.4638900756836, 0.584055062346133, -81.8936080932617, -1.42931309756529, 218, 48, 'PPL', 'P'),
(3918, 'Lynntown', 34.4305610656738, 0.600926653904976, -86.7052764892578, -1.51329255358958, 218, 2, 'PPL', 'P'),
(37011, 'Lynnview', 38.1783294677734, 0.666337552123821, -85.709716796875, -1.49591675905736, 218, 21, 'PPL', 'P'),
(73309, 'Lynnview', 39.2361106872559, 0.68479931716955, -84.5569381713867, -1.47579697649597, 218, 41, 'PPL', 'P'),
(27770, 'Lynnville', 39.686939239502, 0.692667759768243, -90.345832824707, -1.57683224824751, 218, 18, 'PPL', 'P'),
(30390, 'Lynnville', 38.1961097717285, 0.666647876969842, -87.2966690063477, -1.52361430018445, 218, 19, 'PPL', 'P'),
(37012, 'Lynnville', 36.5602798461914, 0.638097258766566, -88.5691680908203, -1.54582359893711, 218, 21, 'PPL', 'P'),
(88734, 'Lynnville', 35.3766708374023, 0.61743938450693, -87.0061111450195, -1.51854310883672, 218, 50, 'PPL', 'P'),
(116648, 'Lynnville', 41.5774993896484, 0.725664259095298, -92.783332824707, -1.61937464876487, 218, 16, 'PPL', 'P'),
(164092, 'Lynnville', 40.6469383239746, 0.709422904608423, -75.7519378662109, -1.32212073053155, 218, 45, 'PPL', 'P'),
(82210, 'Lynnwood', 32.7277793884277, 0.5712075071944, -79.9594421386719, -1.39555553337772, 218, 48, 'PPL', 'P'),
(103899, 'Lynnwood', 36.8733291625977, 0.643561000058973, -76.0922164916992, -1.32805971292048, 218, 53, 'PPL', 'P'),
(164094, 'Lynnwood', 41.2347183227539, 0.71968160086449, -75.9319381713867, -1.32526232851146, 218, 45, 'PPL', 'P'),
(207975, 'Lynnwood', 47.8211097717285, 0.834635817474296, -122.313888549805, -2.13478007611148, 218, 56, 'PPL', 'P'),
(88735, 'Lynnwood Downs', 35.9708290100098, 0.627809400896563, -86.8572235107422, -1.51594452940308, 218, 50, 'PPL', 'P'),
(183009, 'Lynnwood Estates', 38.0449981689453, 0.66401048196331, -120.231109619141, -2.09842872618023, 218, 6, 'PPL', 'P'),
(164095, 'Lynnwood Gardens', 40.0666694641113, 0.699295302457015, -75.1444396972656, -1.31151788728362, 218, 45, 'PPL', 'P'),
(49132, 'Lyns Rest', 39.5338897705078, 0.689996542615867, -76.2797164916992, -1.33133220526797, 218, 25, 'PPL', 'P'),
(60727, 'Lynville', 32.8549995422363, 0.573427917753254, -88.815559387207, -1.55012393830732, 218, 30, 'PPL', 'P'),
(173, 'Lynwinn', 37.6808280944824, 0.657654515126699, -81.2275009155273, -1.41768733414266, 218, 58, 'PPL', 'P'),
(49133, 'Lynwood', 39.5783309936523, 0.690772188283352, -76.8958282470703, -1.34208538395944, 218, 25, 'PPL', 'P'),
(82212, 'Lynwood', 35.0250015258789, 0.611301597142625, -81.8930587768555, -1.42930351018537, 218, 48, 'PPL', 'P'),
(120460, 'Lynwood', 41.6836090087891, 0.727516221317339, -88.3936080932617, -1.54275949894492, 218, 18, 'PPL', 'P'),
(183010, 'Lynwood', 33.9302787780762, 0.592195080796988, -118.210563659668, -2.06316354649956, 218, 6, 'PPL', 'P'),
(198561, 'Lynwood', 46.6666717529297, 0.814487073036057, -100.906936645508, -1.76115828256543, 218, 34, 'PPL', 'P'),
(60728, 'Lynwood (historical)', 32.211109161377, 0.562189910585337, -89.8083267211914, -1.56745099699159, 218, 30, 'PPL', 'P'),
(207976, 'Lynwood Center', 47.6047210693359, 0.830859122153428, -122.546112060547, -2.13883314097448, 218, 56, 'PPL', 'P'),
(183011, 'Lynwood Gardens', 33.9102783203125, 0.591846006957105, -118.191108703613, -2.06282399346058, 218, 6, 'PPL', 'P'),
(183012, 'Lynwood Hills', 32.6452789306641, 0.569767602572022, -117.050827026367, -2.04292232379247, 218, 6, 'PPL', 'P'),
(49134, 'Lynwood Village', 39.1019401550293, 0.682457599623043, -76.4736099243164, -1.33471628406513, 218, 25, 'PPL', 'P'),
(73310, 'Lynx', 38.7730598449707, 0.676717555367541, -83.4130630493164, -1.45583258938419, 218, 41, 'PPL', 'P'),
(175100, 'Lynxville', 43.2463912963867, 0.754791917727767, -91.0561065673828, -1.58922886364766, 218, 57, 'PPL', 'P'),
(56029, 'Lyon', 38.5116691589355, 0.672155427262181, -91.1738891601563, -1.59128455769309, 218, 29, 'PPL', 'P'),
(60729, 'Lyon', 34.2177810668945, 0.597212942343888, -90.5419387817383, -1.58025494288048, 218, 30, 'PPL', 'P'),
(3922, 'Lyon (historical)', 32.3650016784668, 0.564875841702737, -87.5436096191406, -1.52792422693458, 218, 2, 'PPL', 'P'),
(150438, 'Lyon Corner', 43.8491706848145, 0.765312402718989, -76.0780563354492, -1.32781257157132, 218, 40, 'PPL', 'P'),
(131860, 'Lyon Manor', 44.4613914489746, 0.775997670802659, -84.7438888549805, -1.47905988146354, 218, 27, 'PPL', 'P'),
(150439, 'Lyon Mountain', 44.7247200012207, 0.780593621053864, -73.9119415283203, -1.29000673621072, 218, 40, 'PPL', 'P'),
(103901, 'Lyon Park', 38.8805618286133, 0.678593818934529, -77.0905609130859, -1.3454841101426, 218, 53, 'PPL', 'P'),
(164097, 'Lyon Valley', 40.6288909912109, 0.709107919230493, -75.6705627441406, -1.32070046672221, 218, 45, 'PPL', 'P'),
(103902, 'Lyon Village', 38.894718170166, 0.678840893704661, -77.0952835083008, -1.34556653497833, 218, 53, 'PPL', 'P'),
(33163, 'Lyona', 38.8619384765625, 0.678268780123485, -96.9255599975586, -1.6916701512967, 218, 20, 'PPL', 'P'),
(164098, 'Lyona', 41.6933288574219, 0.727685864678777, -79.9683303833008, -1.39571066251122, 218, 45, 'PPL', 'P'),
(195269, 'Lyondale (historical)', 47.607780456543, 0.830912518533284, -116.849998474121, -2.03941720432376, 218, 17, 'PPL', 'P'),
(764, 'Lyons', 36.1472206115723, 0.630888015116694, -78.7249984741211, -1.37401042700093, 218, 33, 'PPL', 'P'),
(22797, 'Lyons', 32.2041702270508, 0.562068803334766, -82.3219375610352, -1.43678885706125, 218, 13, 'PPL', 'P'),
(30391, 'Lyons', 38.9891700744629, 0.68048939041942, -87.0822219848633, -1.51987149358846, 218, 19, 'PPL', 'P'),
(33164, 'Lyons', 38.3450012207031, 0.669246522982514, -98.2013931274414, -1.71393764011918, 218, 20, 'PPL', 'P'),
(37014, 'Lyons', 37.6777801513672, 0.657601318483925, -85.6125030517578, -1.49422005912687, 218, 21, 'PPL', 'P'),
(41919, 'Lyons', 29.8838901519775, 0.521572276456317, -91.6997222900391, -1.60046207712562, 218, 22, 'PPL', 'P'),
(56031, 'Lyons', 37.5658302307129, 0.655647423771161, -92.4944381713867, -1.61433248587302, 218, 29, 'PPL', 'P'),
(76477, 'Lyons', 35.7511100769043, 0.623974582084903, -94.7108306884766, -1.6530158328128, 218, 42, 'PPL', 'P'),
(95921, 'Lyons', 30.3861103057861, 0.530337671710149, -96.5630569458008, -1.685343279495, 218, 51, 'PPL', 'P'),
(103903, 'Lyons', 37.0136108398438, 0.646009377207137, -82.4677810668945, -1.43933430643115, 218, 53, 'PPL', 'P'),
(116652, 'Lyons', 41.8672218322754, 0.730720869636059, -90.1861114501953, -1.57404458437647, 218, 16, 'PPL', 'P'),
(120461, 'Lyons', 41.8133316040039, 0.72978030771807, -87.8180618286133, -1.53271432162925, 218, 18, 'PPL', 'P'),
(131863, 'Lyons', 42.9819412231445, 0.750176393242551, -84.9469375610352, -1.48260374992611, 218, 27, 'PPL', 'P'),
(142326, 'Lyons', 41.9375, 0.731947455055122, -96.476936340332, -1.68384019137576, 218, 35, 'PPL', 'P'),
(145662, 'Lyons', 40.6852798461914, 0.710092090411332, -74.5475006103516, -1.30109933478312, 218, 37, 'PPL', 'P'),
(150440, 'Lyons', 43.0641708374023, 0.751611570753995, -76.9905624389648, -1.34373880752221, 218, 40, 'PPL', 'P'),
(156265, 'Lyons', 41.6994400024414, 0.727792524280435, -84.0702819824219, -1.46730322367333, 218, 41, 'PPL', 'P'),
(164099, 'Lyons', 40.4819412231445, 0.706543161942693, -75.758056640625, -1.32222752329126, 218, 45, 'PPL', 'P'),
(170808, 'Lyons', 43.7230606079102, 0.763111366657066, -96.8675003051758, -1.69065681850193, 218, 49, 'PPL', 'P'),
(175104, 'Lyons', 42.6511116027832, 0.744402327104123, -88.3583297729492, -1.5421437761009, 218, 57, 'PPL', 'P'),
(194305, 'Lyons', 40.2247200012207, 0.702053804714119, -105.27082824707, -1.83732255921283, 218, 7, 'PPL', 'P'),
(198562, 'Lyons', 46.8111114501953, 0.817008021323926, -101.052780151367, -1.76370373193533, 218, 34, 'PPL', 'P'),
(201168, 'Lyons', 44.7747192382813, 0.781466272364055, -122.613891601563, -2.14001611713069, 218, 43, 'PPL', 'P'),
(207977, 'Lyons', 47.6805610656738, 0.832182779794225, -117.57527923584, -2.05207574161713, 218, 56, 'PPL', 'P'),
(95922, 'Lyons Colonia', 26.0919990539551, 0.455391291918762, -97.963996887207, -1.70979429409524, 218, 51, 'PPL', 'P'),
(49135, 'Lyons Corner', 38.5686111450195, 0.673149252401971, -76.9805603027344, -1.34356423731276, 218, 25, 'PPL', 'P'),
(150441, 'Lyons Corners', 42.267219543457, 0.73770214669662, -78.2536087036133, -1.36578312344534, 218, 40, 'PPL', 'P'),
(49136, 'Lyons Creek Hundred', 38.7608299255371, 0.676504103006171, -76.6366729736328, -1.33756227116405, 218, 25, 'PPL', 'P'),
(49137, 'Lyons Creek Mobile Estates', 38.7622184753418, 0.676528337772091, -76.6675033569336, -1.3381003628623, 218, 25, 'PPL', 'P'),
(150442, 'Lyons Falls', 43.6252784729004, 0.761404746451516, -75.3675003051758, -1.31541102932315, 218, 40, 'PPL', 'P'),
(16975, 'Lyons Park', 26.2141704559326, 0.457523585135047, -80.1272201538086, -1.39848381215432, 218, 12, 'PPL', 'P'),
(199508, 'Lyons Place', 41.5513916015625, 0.725208592232785, -101.607498168945, -1.77338538776221, 218, 35, 'PPL', 'P'),
(113664, 'Lyons Plain', 41.2249984741211, 0.719511957503051, -73.3466720581055, -1.28014092279447, 218, 8, 'PPL', 'P'),
(41918, 'Lyons Point', 30.0944404602051, 0.525247072575976, -92.378059387207, -1.61230129290962, 218, 22, 'PPL', 'P'),
(88737, 'Lyons Store (historical)', 36.4936103820801, 0.636933657107283, -82.8677825927734, -1.44631565007074, 218, 50, 'PPL', 'P'),
(88738, 'Lyons View', 35.9275016784668, 0.627053196305035, -83.9913864135742, -1.4659262362317, 218, 50, 'PPL', 'P'),
(150444, 'Lyonsdale', 43.6186103820801, 0.761288366311879, -75.3066711425781, -1.31434936015459, 218, 40, 'PPL', 'P'),
(73311, 'Lyonsdale (historical)', 39.732780456543, 0.693467839938731, -82.1374969482422, -1.43356976109362, 218, 41, 'PPL', 'P'),
(164101, 'Lyonstown', 40.9375, 0.714494162535179, -77.7427825927734, -1.35686752590603, 218, 45, 'PPL', 'P'),
(30392, 'Lyonsville', 39.6525001525879, 0.692066684310213, -85.0538864135742, -1.48447035953414, 218, 19, 'PPL', 'P'),
(110233, 'Lyonsville', 38.2591705322266, 0.667748494869345, -81.0577774047852, -1.41472510006217, 218, 58, 'PPL', 'P'),
(125294, 'Lyonsville', 42.6722183227539, 0.744770708861908, -72.7158279418945, -1.26913061589975, 218, 23, 'PPL', 'P'),
(145663, 'Lyonsville', 40.9566688537598, 0.71482872214712, -74.4400024414063, -1.29922313779516, 218, 37, 'PPL', 'P'),
(150446, 'Lyonsville', 41.8486099243164, 0.730396030562096, -74.2125015258789, -1.2952524977679, 218, 40, 'PPL', 'P'),
(193755, 'Lyonsville', 40.309440612793, 0.703532458330358, -121.736938476563, -2.12471039771379, 218, 6, 'PPL', 'P'),
(49138, 'Lyonswood', 39.3908309936523, 0.687499695935863, -76.8013916015625, -1.34043715356079, 218, 25, 'PPL', 'P'),
(88739, 'Lyonton', 36.0400009155273, 0.629016678397723, -83.7155609130859, -1.46111217308722, 218, 50, 'PPL', 'P'),
(170810, 'Lyonville', 43.8777809143066, 0.765811745423379, -98.9702835083008, -1.72735730885209, 218, 49, 'PPL', 'P'),
(183013, 'Lyoth', 37.7158317565918, 0.658265444280763, -121.380561828613, -2.11849045182985, 218, 6, 'PPL', 'P'),
(73312, 'Lyra', 38.7383308410645, 0.676111419903439, -82.7377777099609, -1.44404663682199, 218, 41, 'PPL', 'P'),
(95923, 'Lyra', 32.5552787780762, 0.568196803582066, -98.4686126708984, -1.71860150097819, 218, 51, 'PPL', 'P'),
(73313, 'Lysander', 39.2849998474121, 0.685652593982811, -82.0458297729492, -1.43196986706876, 218, 41, 'PPL', 'P'),
(150447, 'Lysander', 43.2063903808594, 0.754093770048003, -76.4594421386719, -1.33446900955792, 218, 40, 'PPL', 'P'),
(150448, 'Lysander New Community', 43.167781829834, 0.753419923713186, -76.3016662597656, -1.33171530099078, 218, 40, 'PPL', 'P'),
(209583, 'Lysite', 43.2680587768555, 0.755170086602558, -107.689720153809, -1.87954018723525, 218, 59, 'PPL', 'P'),
(3923, 'Lytle', 31.0755596160889, 0.542370832200536, -85.9524993896484, -1.50015411466778, 218, 2, 'PPL', 'P'),
(22798, 'Lytle', 34.916389465332, 0.609405959078706, -85.2750015258789, -1.48832954626978, 218, 13, 'PPL', 'P'),
(73314, 'Lytle', 39.5608291625977, 0.69046672370632, -84.1350021362305, -1.46843280344968, 218, 41, 'PPL', 'P'),
(95925, 'Lytle', 32.6411094665527, 0.569694831695235, -97.3324966430664, -1.69877253560784, 218, 51, 'PPL', 'P'),
(183014, 'Lytle Creek', 34.2591705322266, 0.597935324789572, -117.499168395996, -2.0507473568654, 218, 6, 'PPL', 'P'),
(37016, 'Lytten', 38.1044387817383, 0.66504791636595, -83.2211074829102, -1.45248233273287, 218, 21, 'PPL', 'P'),
(116655, 'Lytton', 42.4230613708496, 0.740422099696945, -94.8594436645508, -1.65560961855649, 218, 16, 'PPL', 'P'),
(156266, 'Lytton', 41.6572189331055, 0.72705562760681, -83.9552764892578, -1.46529599915973, 218, 41, 'PPL', 'P'),
(183015, 'Lytton', 38.6594390869141, 0.674734499040841, -122.870559692383, -2.14449582040031, 218, 6, 'PPL', 'P'),
(110234, 'Lytton (historical)', 39.4597206115723, 0.688702046589006, -81.0780563354492, -1.41507903417104, 218, 58, 'PPL', 'P'),
(95926, 'Lytton Springs', 30.0044403076172, 0.52367627358602, -97.6122207641602, -1.70365464251817, 218, 51, 'PPL', 'P'),
(49139, 'Lyttonsville', 39.0013885498047, 0.680702643043708, -77.0541687011719, -1.34484894622261, 218, 25, 'PPL', 'P'),
(95929, 'M and R Colonia', 26.201000213623, 0.45729372104346, -97.9670028686523, -1.70984675836871, 218, 51, 'PPL', 'P'),
(116656, 'M and S Mobile Home Park', 42.0444412231445, 0.733813931505104, -94.0361099243164, -1.64123973394664, 218, 16, 'PPL', 'P'),
(95927, 'M K Crossing', 33.0013885498047, 0.575982887924049, -99.3925018310547, -1.7347264087464, 218, 51, 'PPL', 'P'),
(95928, 'M Munoz Colonia', 26.4050006866455, 0.460854200973328, -98.9739990234375, -1.72742215682464, 218, 51, 'PPL', 'P'),
(95930, 'M-S Colonia', 26.2679996490479, 0.4584630817886, -98.3420028686523, -1.71639174306369, 218, 51, 'PPL', 'P'),
(210585, 'Maalaea', 20.7963905334473, 0.362965487339235, -156.514175415039, -2.73168768703639, 218, 15, 'PPL', 'P'),
(210586, 'MaÃ‚â€˜ÃƒÂ¤lehu', 21.1669406890869, 0.369432807598924, -157.02360534668, -2.74057891665173, 218, 15, 'PPL', 'P'),
(41920, 'Mab', 30.8541698455811, 0.53850685177494, -92.7624969482422, -1.61901099411802, 218, 22, 'PPL', 'P'),
(207978, 'Mabana', 48.0947189331055, 0.839411198203945, -122.413887023926, -2.13652537873187, 218, 56, 'PPL', 'P'),
(95931, 'Mabank', 32.3663902282715, 0.564900076468656, -96.1005630493164, -1.67727123823097, 218, 51, 'PPL', 'P'),
(150450, 'Mabbettsville', 41.7924995422363, 0.729416719650247, -73.6600036621094, -1.28560959093489, 218, 40, 'PPL', 'P'),
(73315, 'Mabee Corner', 38.9027786254883, 0.678981575189245, -82.7211074829102, -1.4437556864729, 218, 41, 'PPL', 'P'),
(16978, 'Mabel', 28.5791702270508, 0.498800617949972, -81.9772186279297, -1.4307723766846, 218, 12, 'PPL', 'P'),
(27772, 'Mabel', 39.8763885498047, 0.695974273998659, -87.6922225952148, -1.53051801267827, 218, 18, 'PPL', 'P'),
(56032, 'Mabel', 39.8216705322266, 0.695019264431756, -94.1997222900391, -1.64409530842547, 218, 29, 'PPL', 'P'),
(66542, 'Mabel', 36.3172187805176, 0.633855042887152, -81.7688903808594, -1.42713636284832, 218, 33, 'PPL', 'P'),
(136634, 'Mabel', 43.5205612182617, 0.759577085574422, -91.7694396972656, -1.60167887542767, 218, 28, 'PPL', 'P'),
(164102, 'Mabel', 40.7099990844727, 0.710523522507925, -76.4247207641602, -1.33386300725187, 218, 45, 'PPL', 'P'),
(201169, 'Mabel', 44.2147216796875, 0.771692471163465, -122.825828552246, -2.14371511472675, 218, 43, 'PPL', 'P'),
(193757, 'Mabel (historical)', 40.8061103820801, 0.712200981099539, -122.383331298828, -2.13599208072358, 218, 6, 'PPL', 'P'),
(95932, 'Mabelle', 33.6699981689453, 0.587652327188558, -99.1388931274414, -1.73030010185663, 218, 51, 'PPL', 'P'),
(49140, 'Mabels Manor', 39.5077781677246, 0.689540809174327, -77.2802810668945, -1.34879535148395, 218, 25, 'PPL', 'P'),
(103904, 'Mabelton', 37.8408317565918, 0.660447105845756, -77.7425003051758, -1.35686259905801, 218, 53, 'PPL', 'P'),
(10244, 'Mabelvale', 34.6549987792969, 0.604843830973346, -92.3863906860352, -1.61244670150514, 218, 4, 'PPL', 'P'),
(60730, 'Maben', 33.5552787780762, 0.585650096102009, -89.084716796875, -1.55482162131217, 218, 30, 'PPL', 'P'),
(110235, 'Maben', 37.6386108398438, 0.656917685032102, -81.394172668457, -1.42059630500135, 218, 58, 'PPL', 'P'),
(10245, 'Maberry', 35.0219383239746, 0.611248134183741, -91.3258285522461, -1.59393640034854, 218, 4, 'PPL', 'P'),
(110236, 'Mabie', 38.8763885498047, 0.678520981478715, -79.9833297729492, -1.39597245124637, 218, 58, 'PPL', 'P'),
(183016, 'Mabie', 39.7936096191406, 0.694529509107291, -120.520278930664, -2.10347568276204, 218, 6, 'PPL', 'P'),
(78662, 'Mable Hill', 39.7747192382813, 0.694199809764339, -79.938606262207, -1.39519187873087, 218, 45, 'PPL', 'P'),
(22799, 'Mableton', 33.8186111450195, 0.59024611293224, -84.5824966430664, -1.47624305597856, 218, 13, 'PPL', 'P'),
(95933, 'Mabry', 33.6133308410645, 0.58666329573873, -95.1180572509766, -1.66012327713001, 218, 51, 'PPL', 'P'),
(22800, 'Mabry (historical)', 33.4744415283203, 0.584239219935512, -85.163330078125, -1.486380511826, 218, 13, 'PPL', 'P'),
(103905, 'Mabry Crossroads', 36.7891693115234, 0.642092133559739, -80.7155609130859, -1.40875229552739, 218, 53, 'PPL', 'P'),
(103906, 'Mabry Mill', 36.75, 0.641408500107916, -80.4049987792969, -1.40333196376075, 218, 53, 'PPL', 'P'),
(110237, 'Mabscott', 37.7708282470703, 0.659225314116655, -81.208610534668, -1.41735763479971, 218, 58, 'PPL', 'P'),
(3924, 'Mabson', 31.4680595397949, 0.549221248183033, -85.5630569458008, -1.49335706177563, 218, 2, 'PPL', 'P'),
(207979, 'Mabton', 46.2150001525879, 0.806603916472341, -119.995559692383, -2.09431760440547, 218, 56, 'PPL', 'P'),
(37015, 'Mac', 37.4000015258789, 0.65275316687749, -85.5105590820313, -1.49244080120259, 218, 21, 'PPL', 'P'),
(164103, 'Mac', 41.8074989318848, 0.729678508385402, -76.5833282470703, -1.33663123004695, 218, 45, 'PPL', 'P'),
(191819, 'Mac Bain', 33.8936080932617, 0.591555056608014, -100.97444152832, -1.76233646503168, 218, 51, 'PPL', 'P'),
(156267, 'MacAdam (historical)', 40.7713890075684, 0.711594978793491, -84.5519409179688, -1.47570975797027, 218, 41, 'PPL', 'P'),
(103907, 'Macanie', 38.7758293151855, 0.676765891741326, -78.7577819824219, -1.37458260716113, 218, 53, 'PPL', 'P'),
(110238, 'MacArthur', 37.7583312988281, 0.659007201223378, -81.2127838134766, -1.41743047225552, 218, 58, 'PPL', 'P'),
(145664, 'MacArthur Manor', 40.4583282470703, 0.706131037764003, -74.3694381713867, -1.29799155894905, 218, 37, 'PPL', 'P'),
(82214, 'MacArthurs Junction', 34.4219398498535, 0.600776185303386, -82.2816696166992, -1.43608604884958, 218, 48, 'PPL', 'P'),
(131865, 'Macatawa', 42.769718170166, 0.746472402219441, -86.2061080932617, -1.50458042155755, 218, 27, 'PPL', 'P'),
(82215, 'Macbeth', 33.2675018310547, 0.580627440865147, -79.9749984741211, -1.39582704265085, 218, 48, 'PPL', 'P'),
(16979, 'Macclenny', 30.2819404602051, 0.528519564923466, -82.1222229003906, -1.4333031786685, 218, 12, 'PPL', 'P'),
(66546, 'Macclesfield', 35.7519416809082, 0.623989096312844, -77.670280456543, -1.35560212491408, 218, 33, 'PPL', 'P'),
(110240, 'Macdale', 39.7191696166992, 0.693230285969495, -80.2333297729492, -1.40033577437636, 218, 58, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(193756, 'Macdoel', 41.8269386291504, 0.730017795108278, -122.004173278809, -2.1293745248889, 218, 6, 'PPL', 'P'),
(95934, 'Macdona', 29.3255596160889, 0.511827570290635, -98.6908264160156, -1.72247986247367, 218, 51, 'PPL', 'P'),
(110241, 'Macdonald', 37.8891716003418, 0.661290795279093, -81.1611099243164, -1.41652859275237, 218, 58, 'PPL', 'P'),
(49141, 'MacDonald Farms', 38.6980590820313, 0.67540854511274, -76.6402816772461, -1.33762525492383, 218, 25, 'PPL', 'P'),
(78663, 'Macdonaldton', 39.9161109924316, 0.696667561409434, -78.9205627441406, -1.37742366741203, 218, 45, 'PPL', 'P'),
(150451, 'MacDonnell Heights', 41.7094383239746, 0.727967027910862, -73.8627777099609, -1.2891486657075, 218, 40, 'PPL', 'P'),
(110239, 'MacDougal', 38.1172218322754, 0.665271022686271, -81.1213912963867, -1.41583537192062, 218, 58, 'PPL', 'P'),
(150452, 'MacDougall', 42.8063888549805, 0.747112426408415, -76.8797225952148, -1.34180428730638, 218, 40, 'PPL', 'P'),
(144100, 'MacDowell Colony', 42.8899993896484, 0.748571705527724, -71.9544372558594, -1.25584184153442, 218, 36, 'PPL', 'P'),
(110242, 'Mace', 38.4561080932617, 0.671185703730256, -80.0308303833008, -1.39680149329371, 218, 58, 'PPL', 'P'),
(123110, 'Mace', 40.0102806091309, 0.698311131276176, -86.79638671875, -1.51488272707646, 218, 19, 'PPL', 'P'),
(188960, 'Mace', 31.6272201538086, 0.551999124937067, -108.911666870117, -1.90086718071877, 218, 38, 'PPL', 'P'),
(195271, 'Mace', 47.5183296203613, 0.829351306923252, -115.821113586426, -2.02145977540947, 218, 17, 'PPL', 'P'),
(183017, 'Mace (historical)', 34.9152793884277, 0.609386584581776, -117.108329772949, -2.04392593604927, 218, 6, 'PPL', 'P'),
(110243, 'Mace Addition', 39.0180587768555, 0.680993593392799, -80.4138870239258, -1.40348709289425, 218, 58, 'PPL', 'P'),
(82216, 'Macedon', 33.8172187805176, 0.590221811587293, -81.2138900756836, -1.41744978017343, 218, 48, 'PPL', 'P'),
(150453, 'Macedon', 43.0691719055176, 0.751698855858722, -77.2991714477539, -1.3491250508269, 218, 40, 'PPL', 'P'),
(156269, 'Macedon', 40.4794387817383, 0.706499486100815, -84.7525024414063, -1.47921021690707, 218, 41, 'PPL', 'P'),
(150454, 'Macedon Center', 43.0941696166992, 0.752135148224304, -77.3208312988281, -1.34950308654363, 218, 40, 'PPL', 'P'),
(3932, 'Macedonia', 33.9372215270996, 0.592316254626586, -87.3666687011719, -1.52483602533453, 218, 2, 'PPL', 'P'),
(10249, 'Macedonia', 33.1763916015625, 0.57903726737826, -93.3000030517578, -1.62839224537393, 218, 4, 'PPL', 'P'),
(22803, 'Macedonia', 34.9180603027344, 0.609435120692643, -83.7249984741211, -1.46127688960064, 218, 13, 'PPL', 'P'),
(27773, 'Macedonia', 38.0519409179688, 0.664131655792908, -88.7052764892578, -1.54819913862947, 218, 18, 'PPL', 'P'),
(30404, 'Macedonia', 38.0538902282715, 0.664165677675834, -85.9599990844727, -1.50028500903536, 218, 19, 'PPL', 'P'),
(37017, 'Macedonia', 37.458610534668, 0.65377608705219, -83.9658279418945, -1.46548015674911, 218, 21, 'PPL', 'P'),
(60735, 'Macedonia', 34.5027809143066, 0.60218712804891, -89.208610534668, -1.55698397495926, 218, 30, 'PPL', 'P'),
(66550, 'Macedonia', 36.1016693115234, 0.630092994952278, -76.6675033569336, -1.3381003628623, 218, 33, 'PPL', 'P'),
(82218, 'Macedonia', 34.1055603027344, 0.595254320520189, -81.4422225952148, -1.42143493442862, 218, 48, 'PPL', 'P'),
(88746, 'Macedonia', 36.0355606079102, 0.628939180410002, -85.5313873291016, -1.49280432269138, 218, 50, 'PPL', 'P'),
(95938, 'Macedonia', 32.7291717529297, 0.571231808539347, -94.5272216796875, -1.64981125107311, 218, 51, 'PPL', 'P'),
(103908, 'Macedonia', 37.8258285522461, 0.660185250531574, -75.6050033569336, -1.31955623955986, 218, 53, 'PPL', 'P'),
(113665, 'Macedonia', 41.7427787780762, 0.728548928609045, -73.4994430541992, -1.28280727967785, 218, 8, 'PPL', 'P'),
(116657, 'Macedonia', 41.1927795410156, 0.718949631038881, -95.4252777099609, -1.66548528566877, 218, 16, 'PPL', 'P'),
(145665, 'Macedonia', 40.2861099243164, 0.703125260999685, -74.0969390869141, -1.29323555271633, 218, 37, 'PPL', 'P'),
(156270, 'Macedonia', 41.3136100769043, 0.721058521727088, -81.5086135864258, -1.42259367581891, 218, 41, 'PPL', 'P'),
(164106, 'Macedonia', 40.6113891601563, 0.708802454653461, -77.4433288574219, -1.35164107226675, 218, 45, 'PPL', 'P'),
(60736, 'Macedonia (historical)', 33.1847190856934, 0.579182609394751, -89.5963897705078, -1.56375199939553, 218, 30, 'PPL', 'P'),
(56033, 'Macedonia Neighborhood', 38.7611083984375, 0.67650896327516, -91.1988906860352, -1.5917209166377, 218, 29, 'PPL', 'P'),
(60737, 'Macel', 33.8222198486328, 0.590309096692021, -90.1630630493164, -1.57364231389381, 218, 30, 'PPL', 'P'),
(37018, 'Maceo', 37.8638916015625, 0.660849576065495, -86.9938888549805, -1.51832978963341, 218, 21, 'PPL', 'P'),
(103909, 'Maces Spring', 36.6722183227539, 0.640050953742248, -82.4027786254883, -1.43819979980678, 218, 53, 'PPL', 'P'),
(10250, 'Macey', 35.9272193908691, 0.627048269457018, -90.3597183227539, -1.5770745959067, 218, 4, 'PPL', 'P'),
(88747, 'Macey', 36.3769416809082, 0.634897404137809, -85.9972229003906, -1.50093468718328, 218, 50, 'PPL', 'P'),
(95939, 'Macey', 30.9488906860352, 0.54016004231112, -96.2636108398438, -1.68011695901378, 218, 51, 'PPL', 'P'),
(116659, 'Macey', 42.5394401550293, 0.742453292660348, -93.1477813720703, -1.62573547587047, 218, 16, 'PPL', 'P'),
(49143, 'Maceys Corner', 39.0802803039551, 0.682079563906306, -76.5449981689453, -1.33596224398113, 218, 25, 'PPL', 'P'),
(110244, 'Macfarlan', 39.0777816772461, 0.682035954643456, -81.1988906860352, -1.41718799143827, 218, 58, 'PPL', 'P'),
(49142, 'MacGills Common', 39.1813888549805, 0.68384424102362, -76.8625030517578, -1.34150374957736, 218, 25, 'PPL', 'P'),
(195270, 'MacGregor (historical)', 44.6919403076172, 0.780021507472687, -116.078887939453, -2.02595878659699, 218, 17, 'PPL', 'P'),
(183018, 'Machado (historical)', 33.9844398498535, 0.593140369825911, -118.446113586426, -2.06727466827432, 218, 6, 'PPL', 'P'),
(22804, 'Machen', 33.3919410705566, 0.582799315313134, -83.5899963378906, -1.45892065782619, 218, 13, 'PPL', 'P'),
(56035, 'Machens', 38.9030609130859, 0.678986502037261, -90.3322219848633, -1.57659469427827, 218, 29, 'PPL', 'P'),
(120463, 'Machesney Park', 42.3472213745117, 0.739098442056148, -89.0388870239258, -1.55402174087876, 218, 18, 'PPL', 'P'),
(128031, 'Machias', 44.7150001525879, 0.780423977692426, -67.4619369506836, -1.17743291956225, 218, 26, 'PPL', 'P'),
(150456, 'Machias', 42.4194412231445, 0.740358916200083, -78.4947204589844, -1.36999131744183, 218, 40, 'PPL', 'P'),
(207980, 'Machias', 47.9816703796387, 0.837438128731332, -122.044723510742, -2.13008225994858, 218, 56, 'PPL', 'P'),
(150457, 'Machias Junction', 42.4086112976074, 0.740169898341714, -78.4761123657227, -1.3696665449469, 218, 40, 'PPL', 'P'),
(128033, 'Machiasport', 44.6986083984375, 0.780137887612324, -67.3952789306641, -1.17626951764005, 218, 26, 'PPL', 'P'),
(103910, 'Machipongo', 37.4058303833008, 0.652854899631131, -75.9019393920898, -1.32473875104115, 218, 53, 'PPL', 'P'),
(115, 'Machodoc', 38.0802803039551, 0.664626271386363, -76.6969375610352, -1.33861408663657, 218, 53, 'PPL', 'P'),
(191820, 'Machovec', 35.9438896179199, 0.627339219806109, -101.986389160156, -1.77999828306498, 218, 51, 'PPL', 'P'),
(66552, 'Machpelah', 35.4472198486328, 0.618670697036929, -81.0725021362305, -1.41498209510736, 218, 33, 'PPL', 'P'),
(172220, 'MacIntyre', 43.0238914489746, 0.750908562805241, -73.0716705322266, -1.27534124071987, 218, 55, 'PPL', 'P'),
(41921, 'Mack', 29.9647197723389, 0.522983019464759, -92.0736083984375, -1.60698762074464, 218, 22, 'PPL', 'P'),
(60738, 'Mack', 34.8383293151855, 0.608043552444049, -89.4800033569336, -1.56172067327407, 218, 30, 'PPL', 'P'),
(73317, 'Mack', 39.1580581665039, 0.683437043692947, -84.6497192382813, -1.47741631159679, 218, 41, 'PPL', 'P'),
(88748, 'Mack', 35.6688919067383, 0.622539604310541, -89.7436065673828, -1.56632141721524, 218, 50, 'PPL', 'P'),
(178575, 'Mack', 34.9602813720703, 0.610172017366268, -112.286392211914, -1.95976724928362, 218, 5, 'PPL', 'P'),
(187014, 'Mack', 39.2238883972168, 0.684585997966235, -108.864440917969, -1.90004293236139, 218, 7, 'PPL', 'P'),
(192681, 'Mack', 39.5336112976074, 0.689991682346877, -112.312782287598, -1.96022784299415, 218, 52, 'PPL', 'P'),
(207981, 'Mack', 46.9052810668945, 0.818651591190668, -118.184440612793, -2.06270761332094, 218, 56, 'PPL', 'P'),
(3933, 'Mack (historical)', 33.8636093139648, 0.591031479137705, -85.8688888549805, -1.49869483554847, 218, 2, 'PPL', 'P'),
(66551, 'Mack (historical)', 35.3663902282715, 0.617259954028486, -82.0100021362305, -1.4313445568448, 218, 33, 'PPL', 'P'),
(103911, 'Mack Creek Village', 36.985279083252, 0.645514894771737, -80.6902770996094, -1.40831100973476, 218, 53, 'PPL', 'P'),
(156272, 'Mackachack (historical)', 40.249439239502, 0.702485236810712, -83.727783203125, -1.46132549229054, 218, 41, 'PPL', 'P'),
(49144, 'Mackall', 38.4049987792969, 0.670293677923134, -76.5027770996094, -1.3352253473075, 218, 25, 'PPL', 'P'),
(49145, 'Mackall Estates', 38.458610534668, 0.671229379572133, -76.5377807617188, -1.33583627646157, 218, 25, 'PPL', 'P'),
(128035, 'Mackamp', 45.6147193908691, 0.796127040743969, -70.0055618286133, -1.22182754861776, 218, 26, 'PPL', 'P'),
(95940, 'Mackay', 29.2697200775146, 0.510852986489721, -96.1494369506836, -1.67812424872813, 218, 51, 'PPL', 'P'),
(195272, 'Mackay', 43.9147186279297, 0.76645643014426, -113.612503051758, -1.98291224968528, 218, 17, 'PPL', 'P'),
(195273, 'Mackay Bar', 45.3761100769043, 0.791962522589357, -115.505279541016, -2.01594743142717, 218, 17, 'PPL', 'P'),
(82219, 'Mackay Subdivision', 33.5180587768555, 0.585000484533111, -80.8222198486328, -1.41061384512936, 218, 48, 'PPL', 'P'),
(142342, 'Mackels Mobile Home Court', 42.0283317565918, 0.733532768273019, -97.4166717529297, -1.70024166842318, 218, 35, 'PPL', 'P'),
(183019, 'Mackenson', 38.1161117553711, 0.665251648189341, -121.680282592773, -2.12372156600104, 218, 6, 'PPL', 'P'),
(56034, 'Mackenzie', 38.5791702270508, 0.673333543149405, -90.3169403076172, -1.5763279786951, 218, 29, 'PPL', 'P'),
(196965, 'MacKenzie (historical)', 46.1572189331055, 0.805595443946555, -104.712783813477, -1.82758284647419, 218, 31, 'PPL', 'P'),
(3934, 'Mackey', 34.1716690063477, 0.596408135062466, -85.7900009155273, -1.4973179812649, 218, 2, 'PPL', 'P'),
(30394, 'Mackey', 38.2522201538086, 0.667627187881692, -87.3916702270508, -1.52527238427914, 218, 19, 'PPL', 'P'),
(116660, 'Mackey', 42.166389465332, 0.735942329848295, -93.7566680908203, -1.63636255388432, 218, 16, 'PPL', 'P'),
(150459, 'Mackey', 42.457218170166, 0.741018248306959, -74.3838882446289, -1.29824376030428, 218, 40, 'PPL', 'P'),
(78664, 'Mackey Ford', 39.9730606079102, 0.697661519707278, -76.9225006103516, -1.34255090451798, 218, 45, 'PPL', 'P'),
(188961, 'Mackey Place', 36.9847183227539, 0.64550510765473, -107.535278320313, -1.87684466873793, 218, 38, 'PPL', 'P'),
(56038, 'Mackeys', 36.2486114501953, 0.632657619082025, -89.9952774047852, -1.57071390195916, 218, 29, 'PPL', 'P'),
(66553, 'Mackeys', 35.9333305358887, 0.627154929058676, -76.6113891601563, -1.33712098537142, 218, 33, 'PPL', 'P'),
(110245, 'Mackeyville', 39.1122207641602, 0.682637030101487, -79.616943359375, -1.38957780199493, 218, 58, 'PPL', 'P'),
(164107, 'Mackeyville', 41.0544395446777, 0.716535142615588, -77.461669921875, -1.35196118422978, 218, 45, 'PPL', 'P'),
(33168, 'Mackie', 38.5958290100098, 0.673624293761414, -97.804443359375, -1.7070095597014, 218, 20, 'PPL', 'P'),
(76479, 'Mackie', 35.6861114501953, 0.622840142039557, -99.7941665649414, -1.74173678084187, 218, 42, 'PPL', 'P'),
(123111, 'Mackie', 40.0602798461914, 0.699183782586368, -87.2852783203125, -1.52341549520908, 218, 19, 'PPL', 'P'),
(3935, 'Mackies', 30.8327808380127, 0.538133543169138, -88.0680618286133, -1.53707764475924, 218, 2, 'PPL', 'P'),
(131867, 'Mackinac Island', 45.8491706848145, 0.800218987758876, -84.6188888549805, -1.47687821989854, 218, 27, 'PPL', 'P'),
(120464, 'Mackinaw', 40.5369415283203, 0.707503098357612, -89.3574981689453, -1.5595825543929, 218, 18, 'PPL', 'P'),
(131869, 'Mackinaw City', 45.7838897705078, 0.799079620865512, -84.727783203125, -1.47877878481048, 218, 27, 'PPL', 'P'),
(120465, 'Mackinaw Dells', 40.6238899230957, 0.709020634125766, -89.230827331543, -1.55737173121397, 218, 18, 'PPL', 'P'),
(10251, 'Macks', 35.6124992370605, 0.621555366550675, -91.3625030517578, -1.59457649111654, 218, 4, 'PPL', 'P'),
(56036, 'Macks Camp', 38.310001373291, 0.668635660407477, -93.4461135864258, -1.63094235527574, 218, 29, 'PPL', 'P'),
(56037, 'Macks Creek', 37.9663887023926, 0.662638487948728, -92.9691696166992, -1.62261811265648, 218, 29, 'PPL', 'P'),
(178576, 'Macks Crossing', 34.6183280944824, 0.604203806784373, -111.091941833496, -1.93892015742853, 218, 5, 'PPL', 'P'),
(195274, 'Macks Inn Post Office', 44.4991683959961, 0.776657002909536, -111.336936950684, -1.94319612887476, 218, 17, 'PPL', 'P'),
(131875, 'Macks Landing', 42.6313896179199, 0.74405811353323, -86.1544418334961, -1.50367867521245, 218, 27, 'PPL', 'P'),
(66554, 'Macks Village', 35.627498626709, 0.62181715528583, -78.7194366455078, -1.37391335477919, 218, 33, 'PPL', 'P'),
(73320, 'Macksburg', 39.6322212219238, 0.691712750201341, -81.456672668457, -1.42168713578385, 218, 41, 'PPL', 'P'),
(116661, 'Macksburg', 41.2147216796875, 0.719332593603635, -94.1849975585938, -1.64383831338028, 218, 16, 'PPL', 'P'),
(201170, 'Macksburg', 45.2138900756836, 0.789131249455467, -122.660003662109, -2.14082092441211, 218, 43, 'PPL', 'P'),
(156273, 'Mackstown', 40.1450004577637, 0.700662436202607, -82.8827819824219, -1.44657743880589, 218, 41, 'PPL', 'P'),
(33169, 'Macksville', 37.959171295166, 0.662512520429167, -98.9683303833008, -1.72732322039014, 218, 20, 'PPL', 'P'),
(110246, 'Macksville', 38.8005599975586, 0.677197523575, -79.3997192382813, -1.38578652586709, 218, 58, 'PPL', 'P'),
(27774, 'Mackville', 39.8063888549805, 0.694752548848585, -88.475830078125, -1.54419454329831, 218, 18, 'PPL', 'P'),
(37019, 'Mackville', 37.7366714477539, 0.658629165506641, -85.067497253418, -1.48470791350338, 218, 21, 'PPL', 'P'),
(56042, 'Mackville', 39.0591697692871, 0.681711115569494, -91.0599975585938, -1.58929677425546, 218, 29, 'PPL', 'P'),
(172221, 'Mackville', 44.4900016784668, 0.776497013507049, -72.3686065673828, -1.26307045968122, 218, 55, 'PPL', 'P'),
(175106, 'Mackville', 44.3436088562012, 0.773941976757227, -88.4150009155273, -1.54313287412975, 218, 57, 'PPL', 'P'),
(22805, 'Macland', 33.9022216796875, 0.591705392051549, -84.6725006103516, -1.47781392154754, 218, 13, 'PPL', 'P'),
(41922, 'Macland', 30.6591701507568, 0.535103465059873, -92.0530624389648, -1.60662902610386, 218, 22, 'PPL', 'P'),
(22806, 'Macland Springs', 33.9099998474121, 0.591841146688116, -84.7563934326172, -1.47927812751487, 218, 13, 'PPL', 'P'),
(116662, 'Maclay (historical)', 42.9691696166992, 0.749953486659311, -95.0727767944336, -1.65933298407653, 218, 16, 'PPL', 'P'),
(201171, 'Macleay', 44.9080581665039, 0.783793475682621, -122.886108398438, -2.14476719651539, 218, 43, 'PPL', 'P'),
(128030, 'MacMahan', 43.8405609130859, 0.765162133854481, -69.7094421386719, -1.2166592850483, 218, 26, 'PPL', 'P'),
(3925, 'MacMillan', 31.9727802276611, 0.558030285989229, -87.5224990844727, -1.52755577859777, 218, 2, 'PPL', 'P'),
(66556, 'Maco', 34.2869415283203, 0.598420020107966, -78.1463928222656, -1.3639118533054, 218, 33, 'PPL', 'P'),
(156274, 'Macochee Castle', 40.2580604553223, 0.702635705412301, -83.7169418334961, -1.46113627469509, 218, 41, 'PPL', 'P'),
(16980, 'Macom', 30.5783290863037, 0.533692522314349, -85.6311111450195, -1.4945448316218, 218, 12, 'PPL', 'P'),
(56039, 'Macomb', 37.0941696166992, 0.647415393104644, -92.4916687011719, -1.61428414949924, 218, 29, 'PPL', 'P'),
(76480, 'Macomb', 35.146671295166, 0.613425135216827, -97.0086135864258, -1.69311970987803, 218, 42, 'PPL', 'P'),
(95942, 'Macomb', 33.5980606079102, 0.58639677989264, -96.855827331543, -1.69045308667854, 218, 51, 'PPL', 'P'),
(120466, 'Macomb', 40.459171295166, 0.706145751729025, -90.6716690063477, -1.58251916243926, 218, 18, 'PPL', 'P'),
(131871, 'Macomb', 42.7008285522461, 0.745270051566298, -82.9591674804688, -1.44791061724759, 218, 27, 'PPL', 'P'),
(76481, 'Macomb-Y', 35.1463890075684, 0.61342020836881, -96.9263916015625, -1.69168466552465, 218, 42, 'PPL', 'P'),
(110247, 'Macomber', 39.3188896179199, 0.686244082060918, -79.6894378662109, -1.39084306982883, 218, 58, 'PPL', 'P'),
(125295, 'Macomber Corner', 41.5977783203125, 0.726018193204169, -70.9805603027344, -1.2388444821931, 218, 23, 'PPL', 'P'),
(183020, 'Macomber Palms', 33.7986106872559, 0.589897039092358, -116.254440307617, -2.02902275343113, 218, 6, 'PPL', 'P'),
(125296, 'Macombers Corner', 41.5694389343262, 0.725523577610715, -71.1069412231445, -1.24105024536596, 218, 23, 'PPL', 'P'),
(3937, 'Macon', 33.7305603027344, 0.58870933582521, -86.0772171020508, -1.50233084938476, 218, 2, 'PPL', 'P'),
(10252, 'Macon', 34.920280456543, 0.609473869686503, -92.168327331543, -1.6086407779913, 218, 4, 'PPL', 'P'),
(16981, 'Macon', 30.4944400787354, 0.532228382926051, -84.279167175293, -1.47094895804759, 218, 12, 'PPL', 'P'),
(22807, 'Macon', 32.8405609130859, 0.573175916135105, -83.6324996948242, -1.45966248134784, 218, 13, 'PPL', 'P'),
(27775, 'Macon', 39.7127799987793, 0.693118766098848, -88.996940612793, -1.5532896378951, 218, 18, 'PPL', 'P'),
(37020, 'Macon', 37.3308296203613, 0.65154588937633, -86.0197219848633, -1.50132737028602, 218, 21, 'PPL', 'P'),
(56040, 'Macon', 39.7422218322754, 0.693632623031179, -92.4725036621094, -1.61394965646632, 218, 29, 'PPL', 'P'),
(60739, 'Macon', 33.105281829834, 0.577796167731256, -88.5608291625977, -1.54567805718354, 218, 30, 'PPL', 'P'),
(66557, 'Macon', 36.4386100769043, 0.635973720692364, -78.0841674804688, -1.36282581621286, 218, 33, 'PPL', 'P'),
(73318, 'Macon', 38.9650001525879, 0.680067545702752, -83.7283325195313, -1.46133507967046, 218, 41, 'PPL', 'P'),
(88749, 'Macon', 35.1530609130859, 0.613536655087474, -89.4897232055664, -1.56189031663551, 218, 50, 'PPL', 'P'),
(95941, 'Macon', 33.0886116027832, 0.577505217382165, -95.1275024414063, -1.66028812680148, 218, 51, 'PPL', 'P'),
(103913, 'Macon', 37.521671295166, 0.654876704951692, -77.9622192382813, -1.36069741786967, 218, 53, 'PPL', 'P'),
(131874, 'Macon', 42.0663909912109, 0.734197027227912, -83.8683319091797, -1.46377852997061, 218, 27, 'PPL', 'P'),
(142327, 'Macon', 40.2050018310547, 0.701709657722253, -98.9522171020508, -1.72704199057903, 218, 35, 'PPL', 'P'),
(195275, 'Macon', 43.3266716003418, 0.756193073356285, -114.544166564941, -1.99917284551103, 218, 17, 'PPL', 'P'),
(196966, 'Macon', 48.1097183227539, 0.8396729869391, -105.518333435059, -1.84164233965899, 218, 31, 'PPL', 'P'),
(10253, 'Macon Lake', 33.4286117553711, 0.583439339502107, -91.3244400024414, -1.59391216558262, 218, 4, 'PPL', 'P'),
(103912, 'Macons Corner', 36.7999992370605, 0.642281151418108, -76.0044403076172, -1.32652772950341, 218, 53, 'PPL', 'P'),
(145666, 'Macopin', 41.0522193908691, 0.716496393621727, -74.3891677856445, -1.298335905678, 218, 37, 'PPL', 'P'),
(27777, 'Macoupin', 39.2133293151855, 0.684401707218801, -89.9572219848633, -1.57004970958329, 218, 18, 'PPL', 'P'),
(128029, 'MacQuillis Corner', 44.6058311462402, 0.778518619090528, -70.164436340332, -1.22460043194475, 218, 26, 'PPL', 'P'),
(128036, 'Macs Corner', 43.875560760498, 0.765772996429518, -70.6805572509766, -1.23360844117389, 218, 26, 'PPL', 'P'),
(170811, 'Macs Corner', 44.2519416809082, 0.772342082732362, -99.4411087036133, -1.73557475871164, 218, 49, 'PPL', 'P'),
(49147, 'Macton', 39.6783294677734, 0.692517490903736, -76.2891693115234, -1.3314971880975, 218, 25, 'PPL', 'P'),
(95943, 'Macune', 31.4158306121826, 0.548309681431412, -94.1600036621094, -1.64340208759373, 218, 51, 'PPL', 'P'),
(164109, 'Macungie', 40.5158309936523, 0.707134650020799, -75.5555572509766, -1.31869324220862, 218, 45, 'PPL', 'P'),
(22809, 'Macville (historical)', 30.791389465332, 0.53741112743394, -83.2838897705078, -1.45357809036339, 218, 13, 'PPL', 'P'),
(128037, 'Macwahoc', 45.6283302307129, 0.796364594713204, -68.2633285522461, -1.19141984160735, 218, 26, 'PPL', 'P'),
(123112, 'Macy', 40.959171295166, 0.714872397988997, -86.1272201538086, -1.50320356727398, 218, 19, 'PPL', 'P'),
(128038, 'Macy', 44.9286117553711, 0.784152203481455, -70.7533264160156, -1.23487850269775, 218, 26, 'PPL', 'P'),
(142329, 'Macy', 42.1130599975586, 0.735011555047313, -96.3561096191406, -1.68173136726658, 218, 35, 'PPL', 'P'),
(33171, 'Macyville', 39.4816703796387, 0.689085142311814, -97.8161087036133, -1.70721315836673, 218, 20, 'PPL', 'P'),
(194306, 'Mad Creek', 40.5661087036133, 0.70801216159998, -106.88777923584, -1.86554367781023, 218, 7, 'PPL', 'P'),
(73319, 'Mad River', 39.8958282470703, 0.696313560721535, -83.9250030517578, -1.46476762799946, 218, 41, 'PPL', 'P'),
(125299, 'Madaket', 41.2727813720703, 0.72034592639841, -70.1986083984375, -1.22519684687088, 218, 23, 'PPL', 'P'),
(30395, 'Madalline', 39.7322196960449, 0.693458052821724, -87.0805587768555, -1.51984246513257, 218, 19, 'PPL', 'P'),
(128041, 'Madawaska', 46.8841705322266, 0.818283142853856, -67.9477767944336, -1.18591242447306, 218, 26, 'PPL', 'P'),
(150461, 'Madawaska', 44.5166702270508, 0.776962467486568, -74.3974990844727, -1.29848131427351, 218, 40, 'PPL', 'P'),
(144101, 'Madbury', 43.1691703796387, 0.753444158479105, -70.9244384765625, -1.23786497154417, 218, 36, 'PPL', 'P'),
(60745, 'Madden', 32.6788902282715, 0.570354230381139, -89.3480606079102, -1.55941783787948, 218, 30, 'PPL', 'P'),
(209584, 'Madden', 43.2055587768555, 0.754079255820062, -107.519439697266, -1.87656823261678, 218, 59, 'PPL', 'P'),
(156277, 'Madden Corners', 41.2105598449707, 0.719259955884903, -80.7405624389648, -1.409188654472, 218, 41, 'PPL', 'P'),
(82220, 'Maddens', 34.4594383239746, 0.601430657141273, -82.0536117553711, -1.43210568828435, 218, 48, 'PPL', 'P'),
(195276, 'Maddens', 43.6619415283203, 0.762044637482434, -116.596939086914, -2.03500048481392, 218, 17, 'PPL', 'P'),
(156278, 'Maddens (historical)', 40.0072212219238, 0.69825773489632, -81.9833297729492, -1.43087903628626, 218, 41, 'PPL', 'P'),
(56043, 'Maddens Richwoods', 38.0666694641113, 0.664388717417128, -90.6586074829102, -1.58229119584995, 218, 29, 'PPL', 'P'),
(41928, 'Maddens Spur (historical)', 32.1988906860352, 0.561976657961049, -93.2936096191406, -1.62828065892426, 218, 22, 'PPL', 'P'),
(164110, 'Maddensville', 40.1266708374023, 0.700342523976661, -77.9583282470703, -1.36062950726188, 218, 45, 'PPL', 'P'),
(125297, 'Maddequet (historical)', 41.288890838623, 0.720627089630495, -70.1694412231445, -1.22468778362851, 218, 23, 'PPL', 'P'),
(10254, 'Madding', 34.2247200012207, 0.597334049594459, -91.833610534668, -1.60279886782411, 218, 4, 'PPL', 'P'),
(140435, 'Maddock', 47.9625015258789, 0.837103569119391, -99.5297164916992, -1.73712125635665, 218, 34, 'PPL', 'P'),
(10255, 'Maddock (historical)', 35.4869384765625, 0.619363917868676, -91.6549987792969, -1.59968150461011, 218, 4, 'PPL', 'P'),
(128043, 'Maddocks Corner', 44.3444404602051, 0.773956490985168, -69.2922210693359, -1.2093774036797, 218, 26, 'PPL', 'P'),
(10256, 'Maddox', 34.4925003051758, 0.602007697570466, -93.3030624389648, -1.62844564175379, 218, 4, 'PPL', 'P'),
(22811, 'Maddox', 31.996940612793, 0.558451964258329, -84.2425003051758, -1.47030900043765, 218, 13, 'PPL', 'P'),
(49146, 'Maddox', 38.3325004577637, 0.66902834351021, -76.8119430541992, -1.34062131115017, 218, 25, 'PPL', 'P'),
(60740, 'Maddox', 31.8886108398438, 0.556561253042428, -89.6694412231445, -1.5650269877674, 218, 30, 'PPL', 'P'),
(88752, 'Maddox', 35.160831451416, 0.613672276565986, -88.2188873291016, -1.53971004633873, 218, 50, 'PPL', 'P'),
(196967, 'Maddux', 48.1405601501465, 0.840211278374432, -109.417221069336, -1.90969076604242, 218, 31, 'PPL', 'P'),
(88753, 'Maddux Farm', 36.0977783203125, 0.630025084344481, -85.4638900756836, -1.49162627338318, 218, 50, 'PPL', 'P'),
(10257, 'Maddux Spring', 35.7083282470703, 0.623227898294272, -94.1313934326172, -1.64290274488934, 218, 4, 'PPL', 'P'),
(73323, 'Madeira', 39.1908302307129, 0.684009024116069, -84.3636093139648, -1.47242275139484, 218, 41, 'PPL', 'P'),
(156301, 'Madeira (historical)', 41.1666717529297, 0.718493964176369, -84.0547180175781, -1.46703158124214, 218, 41, 'PPL', 'P'),
(16982, 'Madeira Beach', 27.797779083252, 0.485162769744758, -82.7975006103516, -1.44508899807265, 218, 12, 'PPL', 'P'),
(139299, 'Madelaine (historical)', 40.1188888549805, 0.700206702761067, -93.9108276367188, -1.63905314553363, 218, 29, 'PPL', 'P'),
(136638, 'Madelia', 44.0508308410645, 0.768832036415638, -94.4180603027344, -1.64790602562927, 218, 28, 'PPL', 'P'),
(136639, 'Madelia Mobile Village', 44.0574989318848, 0.768948416555274, -94.4180603027344, -1.64790602562927, 218, 28, 'PPL', 'P'),
(174, 'Madeline', 37.5802803039551, 0.655899625126392, -81.304443359375, -1.41903023312233, 218, 58, 'PPL', 'P'),
(82221, 'Madeline', 34.6355590820313, 0.60450454425047, -79.7669372558594, -1.39219568934648, 218, 48, 'PPL', 'P'),
(193758, 'Madeline', 41.0511093139648, 0.716477019124797, -120.47444152832, -2.10267566917058, 218, 6, 'PPL', 'P'),
(14161, 'Madelyn Gardens', 39.7894401550293, 0.694456738230504, -75.5258331298828, -1.31817445842827, 218, 10, 'PPL', 'P'),
(164112, 'Madera', 40.8283309936523, 0.712588803933282, -78.4352798461914, -1.36895388303919, 218, 45, 'PPL', 'P'),
(183021, 'Madera', 36.9613914489746, 0.645097976903085, -120.059722900391, -2.09543746364385, 218, 6, 'PPL', 'P'),
(183022, 'Madera Acres', 37.0191688537598, 0.646106382849843, -120.065826416016, -2.09554399008746, 218, 6, 'PPL', 'P'),
(178577, 'Madera Canyon', 31.7250003814697, 0.553705711853104, -110.879440307617, -1.93521130613643, 218, 5, 'PPL', 'P'),
(183023, 'Madera Country Club Estates', 37.0261116027832, 0.646227556679442, -120.063606262207, -2.0955052410936, 218, 6, 'PPL', 'P'),
(183025, 'Madera Highlands', 37.0111083984375, 0.64596570136526, -120.080001831055, -2.09579139775272, 218, 6, 'PPL', 'P'),
(183026, 'Madera Ranchos', 36.9311103820801, 0.644569472584758, -119.880561828613, -2.09231051304994, 218, 6, 'PPL', 'P'),
(95944, 'Madero', 26.170280456543, 0.456757560137, -98.3311080932617, -1.71620159336186, 218, 51, 'PPL', 'P'),
(41924, 'Madewood', 29.9319400787354, 0.522410905883583, -90.9894409179688, -1.58806532856741, 218, 22, 'PPL', 'P'),
(76482, 'Madge', 34.9002799987793, 0.609124795846621, -99.9580612182617, -1.74459728216872, 218, 42, 'PPL', 'P'),
(88754, 'Madge', 35.3811111450195, 0.617516882494652, -89.6666717529297, -1.56497865139362, 218, 50, 'PPL', 'P'),
(175107, 'Madge', 45.7458305358887, 0.798415361910619, -91.7236099243164, -1.60087899499427, 218, 57, 'PPL', 'P'),
(88756, 'Madie', 36.2816696166992, 0.63323459293219, -89.4613876342773, -1.56139576762108, 218, 50, 'PPL', 'P'),
(76483, 'Madill', 34.0902786254883, 0.594987604937017, -96.7713928222656, -1.68897942648934, 218, 42, 'PPL', 'P'),
(3945, 'Madison', 33.4441719055176, 0.583710915354268, -86.9391708374023, -1.51737478006651, 218, 2, 'PPL', 'P'),
(10258, 'Madison', 35.0130615234375, 0.611093204787326, -90.7225036621094, -1.58340639455642, 218, 4, 'PPL', 'P'),
(16983, 'Madison', 30.4691696166992, 0.53178733016002, -83.4130630493164, -1.45583258938419, 218, 12, 'PPL', 'P'),
(22812, 'Madison', 33.5955581665039, 0.586353104050763, -83.4680633544922, -1.45679252579911, 218, 13, 'PPL', 'P'),
(27779, 'Madison', 38.6824989318848, 0.675136969260579, -90.1569366455078, -1.57353538797604, 218, 18, 'PPL', 'P'),
(30396, 'Madison', 38.7358283996582, 0.676067744061562, -85.379997253418, -1.49016206741586, 218, 19, 'PPL', 'P'),
(33172, 'Madison', 38.1355590820313, 0.665591068070272, -96.1355590820313, -1.67788203422698, 218, 20, 'PPL', 'P'),
(49148, 'Madison', 38.5113906860352, 0.672150566993191, -76.2205581665039, -1.33029969771335, 218, 25, 'PPL', 'P'),
(56044, 'Madison', 39.4736099243164, 0.688944460827231, -92.209716796875, -1.60936316043699, 218, 29, 'PPL', 'P'),
(60741, 'Madison', 32.461669921875, 0.566563020832329, -90.1152801513672, -1.57280834499845, 218, 30, 'PPL', 'P'),
(66559, 'Madison', 36.3852806091309, 0.635042945891381, -79.959716796875, -1.39556032706768, 218, 33, 'PPL', 'P'),
(82223, 'Madison', 34.6322212219238, 0.604446287601625, -83.2080612182617, -1.45225463245967, 218, 48, 'PPL', 'P'),
(88755, 'Madison', 36.2561111450195, 0.632788513449602, -86.7138900756836, -1.51344288903311, 218, 50, 'PPL', 'P'),
(103914, 'Madison', 38.3802795410156, 0.669862245826541, -78.2577819824219, -1.36585596090116, 218, 53, 'PPL', 'P'),
(110248, 'Madison', 38.0669403076172, 0.664393444528063, -81.8194427490234, -1.42801866811746, 218, 58, 'PPL', 'P'),
(113666, 'Madison', 41.2794418334961, 0.720462173379992, -72.5988922119141, -1.26708970239837, 218, 8, 'PPL', 'P'),
(128044, 'Madison', 44.7975006103516, 0.781863882314804, -69.8802795410156, -1.21964096020475, 218, 26, 'PPL', 'P'),
(136642, 'Madison', 45.0097198486328, 0.785567806758886, -96.195556640625, -1.6789291891676, 218, 28, 'PPL', 'P'),
(142330, 'Madison', 41.8283309936523, 0.730042096453225, -97.454719543457, -1.70090572764099, 218, 35, 'PPL', 'P'),
(144103, 'Madison', 43.899169921875, 0.766185054029181, -71.1488876342773, -1.24178234834962, 218, 36, 'PPL', 'P'),
(145667, 'Madison', 40.7597198486328, 0.711391313549127, -74.4175033569336, -1.29883045469242, 218, 37, 'PPL', 'P'),
(150462, 'Madison', 42.8988914489746, 0.748726901240248, -75.5124969482422, -1.317941698149, 218, 40, 'PPL', 'P'),
(156280, 'Madison', 41.771110534668, 0.729043411044445, -81.0500030517578, -1.41458941200463, 218, 41, 'PPL', 'P'),
(164111, 'Madison', 40.2472190856934, 0.702446487816851, -79.6774978637695, -1.39063467747353, 218, 45, 'PPL', 'P'),
(170812, 'Madison', 44.0061111450195, 0.768051530479163, -97.1136093139648, -1.69495223102412, 218, 49, 'PPL', 'P'),
(175109, 'Madison', 43.0730590820313, 0.751766699887492, -89.4011077880859, -1.56034368583244, 218, 57, 'PPL', 'P'),
(183027, 'Madison', 38.6794395446777, 0.675083572880723, -121.967216491699, -2.12872950727288, 218, 6, 'PPL', 'P'),
(188962, 'Madison (historical)', 36.8808288574219, 0.64369189442655, -103.873062133789, -1.81292693836327, 218, 38, 'PPL', 'P'),
(156281, 'Madison Addition', 41.190559387207, 0.718910882045021, -83.4280624389648, -1.45609437811935, 218, 41, 'PPL', 'P'),
(156282, 'Madison Beach', 41.8369407653809, 0.730192365317732, -81.0336074829102, -1.4143032553455, 218, 41, 'PPL', 'P'),
(131876, 'Madison Center', 41.8600006103516, 0.730594835537471, -84.0425033569336, -1.46681839519688, 218, 27, 'PPL', 'P'),
(150463, 'Madison Center', 42.8805618286133, 0.748406989014302, -75.4986114501953, -1.3176993504898, 218, 40, 'PPL', 'P'),
(3941, 'Madison Crossroads', 34.9033317565918, 0.609178059068423, -86.7141723632813, -1.51344781588113, 218, 2, 'PPL', 'P'),
(156283, 'Madison Dock (historical)', 41.8499984741211, 0.730420265328016, -81.008056640625, -1.41385730902096, 218, 41, 'PPL', 'P'),
(88758, 'Madison Hall', 35.5633316040039, 0.620697229468424, -88.8697204589844, -1.55106922733624, 218, 50, 'PPL', 'P'),
(103916, 'Madison Heights', 37.4308280944824, 0.653291191996713, -79.1233291625977, -1.38096260902658, 218, 53, 'PPL', 'P'),
(131877, 'Madison Heights', 42.4858283996582, 0.741517591011349, -83.1052780151367, -1.45046072714939, 218, 27, 'PPL', 'P'),
(145668, 'Madison Heights', 40.7536087036133, 0.71128465394747, -74.4322204589844, -1.29908731657956, 218, 37, 'PPL', 'P'),
(145669, 'Madison Hill', 40.6111106872559, 0.708797594384472, -74.3091735839844, -1.29693974347652, 218, 37, 'PPL', 'P'),
(156284, 'Madison Hill', 40.7844390869141, 0.71182274564572, -81.9333267211914, -1.43000631839704, 218, 41, 'PPL', 'P'),
(73326, 'Madison Lake', 39.8708305358887, 0.695877268355953, -83.3797225952148, -1.45525068868601, 218, 41, 'PPL', 'P'),
(136643, 'Madison Lake', 44.2044410705566, 0.77151304068502, -93.8152770996094, -1.63738547405902, 218, 28, 'PPL', 'P'),
(103919, 'Madison Manor', 38.8802795410156, 0.678588892086512, -77.1474990844727, -1.34647786870336, 218, 53, 'PPL', 'P'),
(73327, 'Madison Mills', 39.6536102294922, 0.692086058807143, -83.3397216796875, -1.45455254100625, 218, 41, 'PPL', 'P'),
(103921, 'Madison Mills', 38.2808303833008, 0.668126530586082, -78.14111328125, -1.36381970793168, 218, 53, 'PPL', 'P'),
(145670, 'Madison Park', 40.4513893127441, 0.706009930513432, -74.3083267211914, -1.29692496293247, 218, 37, 'PPL', 'P'),
(207982, 'Madison Park', 47.6349983215332, 0.831387559892727, -122.278327941895, -2.13415942641944, 218, 56, 'PPL', 'P'),
(49149, 'Madison Place', 38.7702789306641, 0.676669019256674, -76.2044372558594, -1.33001833474418, 218, 25, 'PPL', 'P'),
(103922, 'Madison Run', 38.1966705322266, 0.666657664086848, -78.1305618286133, -1.3636355503423, 218, 53, 'PPL', 'P'),
(22814, 'Madison Springs', 34.2097206115723, 0.597072260859304, -83.1747207641602, -1.45167273176149, 218, 13, 'PPL', 'P'),
(27781, 'Madison Station', 38.6752815246582, 0.675011001741018, -90.1458282470703, -1.57334150984869, 218, 18, 'PPL', 'P'),
(156295, 'Madison-on-the-Lake', 41.8363914489746, 0.730182777937808, -81.045280456543, -1.41450698716889, 218, 41, 'PPL', 'P'),
(156296, 'Madisonburg', 40.857780456543, 0.713102794023667, -81.9258270263672, -1.42987542402946, 218, 41, 'PPL', 'P'),
(164118, 'Madisonburg', 40.9261093139648, 0.714295357559804, -77.5175018310547, -1.35293563487264, 218, 45, 'PPL', 'P'),
(37022, 'Madisonville', 37.3280601501465, 0.651497553002545, -87.498893737793, -1.52714378757714, 218, 21, 'PPL', 'P'),
(41926, 'Madisonville', 30.4041690826416, 0.53065285682516, -90.1569366455078, -1.57353538797604, 218, 22, 'PPL', 'P'),
(56049, 'Madisonville', 39.457218170166, 0.688658370747129, -91.4963912963867, -1.59691328181503, 218, 29, 'PPL', 'P'),
(60744, 'Madisonville', 32.526668548584, 0.567697460877676, -89.9775009155273, -1.57040364369216, 218, 30, 'PPL', 'P'),
(73340, 'Madisonville', 39.1575012207031, 0.683427323154968, -84.39111328125, -1.47290278618133, 218, 41, 'PPL', 'P'),
(88759, 'Madisonville', 35.519718170166, 0.619936031449852, -84.3636093139648, -1.47242275139484, 218, 50, 'PPL', 'P'),
(95946, 'Madisonville', 30.9497203826904, 0.540174523249547, -95.9113922119141, -1.67396958426955, 218, 51, 'PPL', 'P'),
(103923, 'Madisonville', 37.188060760498, 0.649054102702397, -78.6902770996094, -1.37340442469488, 218, 53, 'PPL', 'P'),
(145672, 'Madisonville', 40.7194404602051, 0.710688305600374, -74.5408325195313, -1.30098295464348, 218, 37, 'PPL', 'P'),
(164119, 'Madisonville', 41.3586082458496, 0.721843887932552, -75.4755630493164, -1.31729708000714, 218, 45, 'PPL', 'P'),
(73341, 'Madland (historical)', 38.7633285522461, 0.676547712269021, -82.6819381713867, -1.44307205302108, 218, 41, 'PPL', 'P'),
(112524, 'Madley', 39.8980598449707, 0.696352509452477, -78.6733322143555, -1.37310868065582, 218, 45, 'PPL', 'P'),
(196969, 'Madoc', 48.8108291625977, 0.851909679515796, -105.285278320313, -1.83757476056806, 218, 31, 'PPL', 'P'),
(22815, 'Madola', 34.9277801513672, 0.609604764054081, -84.4297180175781, -1.47357656593712, 218, 13, 'PPL', 'P'),
(49150, 'Madonna', 39.6130599975586, 0.691378323747454, -76.5166702270508, -1.33546782812475, 218, 25, 'PPL', 'P'),
(49151, 'Madonna Hills', 39.6619415283203, 0.692231467402661, -76.4902801513672, -1.33500723441422, 218, 25, 'PPL', 'P'),
(49152, 'Madonna Manor', 39.6294403076172, 0.691664214090474, -76.5055618286133, -1.3352739499974, 218, 25, 'PPL', 'P'),
(27783, 'Madonnaville', 38.2649993896484, 0.667850227622986, -90.2466735839844, -1.57510159301312, 218, 18, 'PPL', 'P'),
(170816, 'Madra', 45.9300003051758, 0.801629730767318, -99.7161102294922, -1.74037444078624, 218, 49, 'PPL', 'P'),
(22817, 'Madras', 33.439998626709, 0.583638077898454, -84.7422180175781, -1.4790307198496, 218, 13, 'PPL', 'P'),
(95947, 'Madras', 33.6583290100098, 0.587448661944194, -94.9819412231445, -1.6577476042796, 218, 51, 'PPL', 'P'),
(201172, 'Madras', 44.6336097717285, 0.779003447566977, -121.128326416016, -2.1140881133899, 218, 43, 'PPL', 'P'),
(22816, 'Madray Springs', 31.7338905334473, 0.553860874276115, -81.978889465332, -1.43080153829854, 218, 13, 'PPL', 'P'),
(3944, 'Madrid', 31.0355606079102, 0.541672717810285, -85.3933334350586, -1.49039482769513, 218, 2, 'PPL', 'P'),
(37023, 'Madrid', 37.6122207641602, 0.656457091321572, -86.3422164916992, -1.5069559612499, 218, 21, 'PPL', 'P'),
(103924, 'Madrid', 38.1394386291504, 0.665658778940987, -78.8808288574219, -1.37673018026417, 218, 53, 'PPL', 'P'),
(116677, 'Madrid', 41.8766708374023, 0.730885785886562, -93.8230590820313, -1.63752129527461, 218, 16, 'PPL', 'P'),
(128046, 'Madrid', 44.8644409179688, 0.783032211085022, -70.4625015258789, -1.22980265081812, 218, 26, 'PPL', 'P'),
(150466, 'Madrid', 44.7502784729004, 0.781039700536452, -75.1313934326172, -1.31129018701041, 218, 40, 'PPL', 'P'),
(187015, 'Madrid', 37.1269416809082, 0.647987373527766, -106.641670227051, -1.86124826528805, 218, 7, 'PPL', 'P'),
(188963, 'Madrid', 35.4066696166992, 0.61796296197724, -106.15193939209, -1.85270084976944, 218, 38, 'PPL', 'P'),
(199509, 'Madrid', 40.8499984741211, 0.712966972808073, -101.543060302734, -1.77226073483386, 218, 35, 'PPL', 'P'),
(128047, 'Madrid Junction', 44.8697204589844, 0.783124356458739, -70.4002838134766, -1.22871674688364, 218, 26, 'PPL', 'P'),
(150467, 'Madrid Springs', 44.7400016784668, 0.780860336637035, -75.1438903808594, -1.31150829990369, 218, 40, 'PPL', 'P'),
(191821, 'Madrilena Colonia', 31.5799999237061, 0.551174976448229, -106.268997192383, -1.85474389379969, 218, 51, 'PPL', 'P'),
(103925, 'Madrillon Farms', 38.9080581665039, 0.679073720562961, -77.2302780151367, -1.34792263359473, 218, 53, 'PPL', 'P'),
(207983, 'Madrona', 47.6083297729492, 0.830922105913208, -122.294166564941, -2.13443586254059, 218, 56, 'PPL', 'P'),
(207985, 'Madrona Beach', 47.0722198486328, 0.821565222581269, -123.015830993652, -2.14703128291612, 218, 56, 'PPL', 'P'),
(207986, 'Madrona Heights', 47.6886100769043, 0.832323261541726, -122.561111450195, -2.13909492970963, 218, 56, 'PPL', 'P'),
(183029, 'Madrone', 37.1505584716797, 0.648399564285483, -121.670562744141, -2.1235519226396, 218, 6, 'PPL', 'P'),
(188964, 'Madrone', 34.5938911437988, 0.603777301535797, -106.732498168945, -1.86283351192691, 218, 38, 'PPL', 'P'),
(183030, 'Madrone (historical)', 38.3402786254883, 0.669164098146776, -122.504722595215, -2.13811075852879, 218, 6, 'PPL', 'P'),
(183031, 'Madrone Soda Springs (historical)', 37.165828704834, 0.648666080131573, -121.512222290039, -2.12078836037643, 218, 6, 'PPL', 'P'),
(56050, 'Madry', 36.8694381713867, 0.643493089451176, -93.7200012207031, -1.63572259627437, 218, 29, 'PPL', 'P'),
(175112, 'Madsen', 44.0811080932617, 0.769360474154937, -87.8219375610352, -1.53278196592094, 218, 57, 'PPL', 'P'),
(204761, 'Madsen', 41.666389465332, 0.727215683588324, -112.090827941895, -1.95635400887252, 218, 52, 'PPL', 'P'),
(170817, 'Madsen Beach', 45.4602813720703, 0.793431588825672, -96.7394409179688, -1.68842176055708, 218, 49, 'PPL', 'P'),
(207988, 'Madson', 46.8219413757324, 0.817197039182294, -117.092781066895, -2.04365455993419, 218, 56, 'PPL', 'P'),
(136647, 'Mae', 46.832218170166, 0.817376403081711, -93.8652801513672, -1.63825819194824, 218, 28, 'PPL', 'P'),
(207989, 'Mae', 47.1175003051758, 0.82235551563475, -119.394439697266, -2.08382608129111, 218, 56, 'PPL', 'P'),
(204763, 'Maeser', 40.4772186279297, 0.706460737106955, -109.586112976074, -1.91263848589498, 218, 52, 'PPL', 'P'),
(190444, 'Maestretti (historical)', 39.3836097717285, 0.687373661837275, -117.626937866211, -2.05297735480417, 218, 39, 'PPL', 'P'),
(27784, 'Maeystown', 38.2247200012207, 0.667147219674232, -90.2333297729492, -1.57486869957579, 218, 18, 'PPL', 'P'),
(188965, 'Maez Place', 34.6630592346191, 0.60498451245793, -106.28694152832, -1.85505708154388, 218, 38, 'PPL', 'P'),
(183032, 'Magalia', 39.8122215270996, 0.694854348181253, -121.577217102051, -2.12192273384274, 218, 6, 'PPL', 'P'),
(207990, 'Magallon', 46.5897216796875, 0.81314404089833, -118.474166870117, -2.06776429044073, 218, 56, 'PPL', 'P'),
(37024, 'Magan', 37.6002807617188, 0.656248698966274, -86.7994384765625, -1.51493599029827, 218, 21, 'PPL', 'P'),
(95948, 'Magasco', 31.2805595397949, 0.545948755835544, -93.9749984741211, -1.64017313793006, 218, 51, 'PPL', 'P'),
(3946, 'Magazine', 30.7341709136963, 0.536412475314674, -88.0524978637695, -1.53680600232805, 218, 2, 'PPL', 'P'),
(10263, 'Magazine', 35.1508293151855, 0.613497706356531, -93.8066711425781, -1.63723527177354, 218, 4, 'PPL', 'P'),
(41932, 'Magda (historical)', 31.139440536499, 0.543485764590897, -92.283332824707, -1.6106480025049, 218, 22, 'PPL', 'P'),
(188966, 'Magdalena', 34.1166687011719, 0.595448198647547, -107.24333190918, -1.87174924262428, 218, 38, 'PPL', 'P'),
(60746, 'Magee', 31.8736095428467, 0.556299431017759, -89.7336120605469, -1.56614698016384, 218, 30, 'PPL', 'P'),
(103926, 'Magee', 38.6836090087891, 0.675156343757509, -77.9305572509766, -1.36014481194348, 218, 53, 'PPL', 'P'),
(123121, 'Magee', 41.5308303833008, 0.724849731275897, -86.751106262207, -1.51409243402298, 218, 19, 'PPL', 'P'),
(150469, 'Magee', 42.961109161377, 0.749812805174728, -76.8463897705078, -1.34122251976625, 218, 40, 'PPL', 'P'),
(164124, 'Magee', 41.7016716003418, 0.727831473011377, -79.3563919067383, -1.38503032127556, 218, 45, 'PPL', 'P'),
(37025, 'Magee Springs', 36.9225006103516, 0.644419203720251, -88.9375, -1.55225220349246, 218, 21, 'PPL', 'P'),
(41931, 'Magenta', 32.4991683959961, 0.567217492670216, -92.045280456543, -1.60649320488826, 218, 22, 'PPL', 'P'),
(60747, 'Magenta', 33.4311103820801, 0.583482948764957, -90.9633331298828, -1.58760966170489, 218, 30, 'PPL', 'P'),
(95949, 'Magers Crossing', 29.5763893127441, 0.516205374359048, -99.7247161865234, -1.74052464307172, 218, 51, 'PPL', 'P'),
(37026, 'Maggard', 37.8186111450195, 0.660059283012014, -83.0955581665039, -1.45029108378796, 218, 21, 'PPL', 'P'),
(88760, 'Maggarte (historical)', 36.2580604553223, 0.632822535332528, -85.8441696166992, -1.49826340345188, 218, 50, 'PPL', 'P'),
(103927, 'Maggie', 37.4233283996582, 0.653160297629136, -80.3822174072266, -1.40293435381, 218, 53, 'PPL', 'P'),
(110249, 'Maggie', 38.9455604553223, 0.679728258979876, -82.0886077880859, -1.43271648428036, 218, 58, 'PPL', 'P'),
(190445, 'Maggie Blues (historical)', 38.2455596923828, 0.66751094090011, -117.074440002441, -2.04333444797116, 218, 39, 'PPL', 'P'),
(66565, 'Maggie Valley', 35.5180587768555, 0.619907069572998, -83.0977783203125, -1.45032983278182, 218, 33, 'PPL', 'P'),
(88763, 'Maggies Mill', 35.2341690063477, 0.614952258364905, -84.4713897705078, -1.47430387523082, 218, 50, 'PPL', 'P'),
(195278, 'Magic', 43.2552795410156, 0.754947046861264, -114.385833740234, -1.99640941640591, 218, 17, 'PPL', 'P'),
(191822, 'Magic City', 35.3574981689453, 0.617104758315962, -100.378059387207, -1.75192763306916, 218, 51, 'PPL', 'P'),
(195279, 'Magic City', 43.2905616760254, 0.755562836284318, -114.364723205566, -1.9960409680691, 218, 17, 'PPL', 'P'),
(195280, 'Magic Resort', 43.2825012207031, 0.755422154799734, -114.388893127441, -1.99646281278577, 218, 17, 'PPL', 'P'),
(10265, 'Magic Springs', 35.814998626709, 0.625089647633319, -92.85888671875, -1.62069331297862, 218, 4, 'PPL', 'P'),
(56051, 'Magill', 39.878059387207, 0.696003435612595, -93.8897171020508, -1.63868469719682, 218, 29, 'PPL', 'P'),
(116678, 'Magill', 41.5188903808594, 0.724641338920599, -95.5052795410156, -1.6668815810283, 218, 16, 'PPL', 'P'),
(164120, 'Magill Heights', 40.6208305358887, 0.70896723774591, -79.8605575561523, -1.39382967183329, 218, 45, 'PPL', 'P'),
(123122, 'Magley', 40.8313903808594, 0.712642200313138, -85.0533294677734, -1.48446063899616, 218, 19, 'PPL', 'P'),
(178578, 'Magma', 33.1316719055176, 0.578256761441785, -111.498611450195, -1.94601788120776, 218, 5, 'PPL', 'P'),
(204768, 'Magna', 40.709171295166, 0.710509074859011, -112.100830078125, -1.95652857908197, 218, 52, 'PPL', 'P'),
(204764, 'Magna Addition', 40.7083282470703, 0.710494360893989, -112.104438781738, -1.95659156284175, 218, 52, 'PPL', 'P'),
(204765, 'Magna Manors', 40.7044410705566, 0.710426516865219, -112.107780456543, -1.95664988606963, 218, 52, 'PPL', 'P'),
(204766, 'Magna Mill', 40.7150001525879, 0.710610807612652, -112.121673583984, -1.95689236688688, 218, 52, 'PPL', 'P'),
(60748, 'Magna Vista', 32.6580581665039, 0.569990642313316, -91.0616683959961, -1.5893259358694, 218, 30, 'PPL', 'P'),
(10266, 'Magnesia Springs', 33.3424987792969, 0.581936384540921, -93.1741714477539, -1.626196069581, 218, 4, 'PPL', 'P'),
(10267, 'Magness', 35.702220916748, 0.623121305271642, -91.4802780151367, -1.59663205200392, 218, 4, 'PPL', 'P'),
(49153, 'Magness', 39.5041694641113, 0.689477825414547, -76.3413925170898, -1.33240865498058, 218, 25, 'PPL', 'P'),
(22818, 'Magnet', 33.564998626709, 0.585819739463447, -84.0155563354492, -1.46634808094837, 218, 13, 'PPL', 'P'),
(27785, 'Magnet', 39.4391708374023, 0.6883433853692, -88.3977813720703, -1.54283233640074, 218, 18, 'PPL', 'P'),
(30409, 'Magnet', 38.0966682434082, 0.664912294887438, -86.4633331298828, -1.50906984536515, 218, 19, 'PPL', 'P'),
(95950, 'Magnet', 29.1505603790283, 0.50877325741545, -95.9866714477539, -1.67528345479334, 218, 51, 'PPL', 'P'),
(103934, 'Magnet', 36.9811096191406, 0.64544212389495, -76.7011108398438, -1.33868692409239, 218, 53, 'PPL', 'P'),
(142337, 'Magnet', 42.4550018310547, 0.740979565892126, -97.4697189331055, -1.70116751637615, 218, 35, 'PPL', 'P'),
(183036, 'Magnet (historical)', 37.1522216796875, 0.648428592741365, -119.66056060791, -2.08847076739026, 218, 6, 'PPL', 'P'),
(10270, 'Magnet Cove', 34.4541702270508, 0.601338711504638, -92.8444366455078, -1.62044111162339, 218, 4, 'PPL', 'P'),
(183033, 'Magnetic Spring (historical)', 37.0705604553223, 0.647003335504982, -121.984443664551, -2.12903017815995, 218, 6, 'PPL', 'P'),
(30405, 'Magnetic Springs', 39.708610534668, 0.693045995222062, -86.4727783203125, -1.50923469503662, 218, 19, 'PPL', 'P'),
(156297, 'Magnetic Springs', 40.3527793884277, 0.704288862658968, -83.2613906860352, -1.45318540726065, 218, 41, 'PPL', 'P'),
(3947, 'Magnolia', 32.1355590820313, 0.560871312950612, -87.6680603027344, -1.53009630111965, 218, 2, 'PPL', 'P'),
(10272, 'Magnolia', 33.2669410705566, 0.580617653748141, -93.2391662597656, -1.62733044304732, 218, 4, 'PPL', 'P'),
(14162, 'Magnolia', 39.0711097717285, 0.681919507924793, -75.4763870239258, -1.31731146107703, 218, 10, 'PPL', 'P'),
(22822, 'Magnolia', 33.103328704834, 0.577762079269303, -82.5666732788086, -1.44106030113363, 218, 13, 'PPL', 'P'),
(30406, 'Magnolia', 38.2491683959961, 0.66757392465989, -86.3930587768555, -1.50784332652511, 218, 19, 'PPL', 'P'),
(37027, 'Magnolia', 37.4438896179199, 0.653519158586024, -85.7436065673828, -1.49650824713546, 218, 21, 'PPL', 'P'),
(41941, 'Magnolia', 30.0038890838623, 0.523666652916582, -91.0644378662109, -1.58937427224318, 218, 22, 'PPL', 'P'),
(49154, 'Magnolia', 39.4047203063965, 0.687742110174087, -76.3249969482422, -1.33212249832145, 218, 25, 'PPL', 'P'),
(56052, 'Magnolia', 38.6391716003418, 0.674380764669051, -93.9138870239258, -1.63910654191348, 218, 29, 'PPL', 'P'),
(60749, 'Magnolia', 31.1430606842041, 0.54354894808776, -90.458610534668, -1.57880059060918, 218, 30, 'PPL', 'P'),
(66568, 'Magnolia', 35.7241706848145, 0.62350440099445, -81.6938934326172, -1.42582741917254, 218, 33, 'PPL', 'P'),
(71064, 'Magnolia', 39.5888900756836, 0.690956479030786, -74.7241668701172, -1.30418274269321, 218, 37, 'PPL', 'P'),
(88761, 'Magnolia', 36.2550010681152, 0.632769138952672, -87.8713912963867, -1.53364509643024, 218, 50, 'PPL', 'P'),
(95952, 'Magnolia', 30.483060836792, 0.532029777687758, -95.1933288574219, -1.66143701449574, 218, 51, 'PPL', 'P'),
(103928, 'Magnolia', 36.7458305358887, 0.64133572923113, -76.5408325195313, -1.33588953968337, 218, 53, 'PPL', 'P'),
(110250, 'Magnolia', 39.5616683959961, 0.690481371092316, -78.4272232055664, -1.36881326813364, 218, 58, 'PPL', 'P'),
(116679, 'Magnolia', 41.6958312988281, 0.727729540520654, -95.8763885498047, -1.67335865511548, 218, 16, 'PPL', 'P'),
(120471, 'Magnolia', 41.1136093139648, 0.717567849907294, -89.1944427490234, -1.55673670045204, 218, 18, 'PPL', 'P'),
(125298, 'Magnolia', 42.5736083984375, 0.743049641007444, -70.7111129760742, -1.23414173918218, 218, 23, 'PPL', 'P'),
(136648, 'Magnolia', 43.6452789306641, 0.761753820291398, -96.0788879394531, -1.67689293619813, 218, 28, 'PPL', 'P'),
(140437, 'Magnolia', 46.9124984741211, 0.818777558710229, -97.4291687011719, -1.70045978131646, 218, 34, 'PPL', 'P'),
(150470, 'Magnolia', 42.1749992370605, 0.736092598712803, -79.4402770996094, -1.38649439408483, 218, 40, 'PPL', 'P'),
(156298, 'Magnolia', 40.6511116027832, 0.709495742064236, -81.2991714477539, -1.41893822090667, 218, 41, 'PPL', 'P'),
(175113, 'Magnolia', 42.7158317565918, 0.74553190688048, -89.2886123657227, -1.55838027031878, 218, 57, 'PPL', 'P'),
(183034, 'Magnolia', 36.0227813720703, 0.628716140668708, -118.994171142578, -2.07684007711961, 218, 6, 'PPL', 'P'),
(187016, 'Magnolia', 39.9938888549805, 0.698025041196074, -105.364723205566, -1.83896133538961, 218, 7, 'PPL', 'P'),
(49155, 'Magnolia (historical)', 39.1441688537598, 0.683194629454723, -76.8097229003906, -1.34058256215631, 218, 25, 'PPL', 'P'),
(82224, 'Magnolia Acres', 34.7833290100098, 0.60708361602913, -82.3711090087891, -1.43764706072253, 218, 48, 'PPL', 'P'),
(183035, 'Magnolia Avenue', 33.957218170166, 0.592665261887441, -117.417503356934, -2.04932203304999, 218, 6, 'PPL', 'P'),
(3948, 'Magnolia Beach', 30.5155601501465, 0.532596997710431, -87.9175033569336, -1.53444990371166, 218, 2, 'PPL', 'P'),
(16985, 'Magnolia Beach', 30.1583309173584, 0.526362171413906, -85.7238922119141, -1.49616416672263, 218, 12, 'PPL', 'P'),
(88762, 'Magnolia Beach', 36.351390838623, 0.634451457813275, -89.4402770996094, -1.56102731928427, 218, 50, 'PPL', 'P'),
(95953, 'Magnolia Beach', 28.5599994659424, 0.498466025048517, -96.5425033569336, -1.68498455169617, 218, 51, 'PPL', 'P'),
(207991, 'Magnolia Beach', 47.3822212219238, 0.826975767230902, -122.481941223145, -2.13771314857804, 218, 56, 'PPL', 'P'),
(41940, 'Magnolia Bend', 30.5216693878174, 0.532703624022575, -90.9916687011719, -1.58810421071932, 218, 22, 'PPL', 'P'),
(82225, 'Magnolia Bluff', 32.3819389343262, 0.565171452583736, -80.7272186279297, -1.40895576103467, 218, 48, 'PPL', 'P'),
(207992, 'Magnolia Bluff', 47.6525001525879, 0.831693024469759, -122.400001525879, -2.13628303107267, 218, 56, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(16986, 'Magnolia Bluffs', 29.7347202301025, 0.518968770174655, -84.9000015258789, -1.4817845615748, 218, 12, 'PPL', 'P'),
(27786, 'Magnolia Corner', 39.0944404602051, 0.682326705255466, -88.8525009155273, -1.55076868960723, 218, 18, 'PPL', 'P'),
(3949, 'Magnolia Courts', 33.6036109924316, 0.586493652377291, -86.7024993896484, -1.51324408405774, 218, 2, 'PPL', 'P'),
(16988, 'Magnolia Gardens', 30.3775005340576, 0.530187402845641, -81.7033309936523, -1.42599213568596, 218, 12, 'PPL', 'P'),
(95954, 'Magnolia Gardens', 29.8863906860352, 0.52161591900868, -95.1125030517578, -1.66002633806633, 218, 51, 'PPL', 'P'),
(41943, 'Magnolia Heights', 30.2541694641113, 0.528034869605071, -89.7841720581055, -1.56702941859103, 218, 22, 'PPL', 'P'),
(207993, 'Magnolia Heights', 47.2652816772461, 0.824934787150492, -122.594169616699, -2.1396719035598, 218, 56, 'PPL', 'P'),
(164121, 'Magnolia Hill', 40.163890838623, 0.700992135545559, -74.834716796875, -1.30611220290297, 218, 45, 'PPL', 'P'),
(95955, 'Magnolia Hills', 30.7780609130859, 0.537178500312722, -94.4766693115234, -1.64892894580397, 218, 51, 'PPL', 'P'),
(41945, 'Magnolia Landing', 30.3036098480225, 0.52889776708777, -90.6302795410156, -1.58179677999358, 218, 22, 'PPL', 'P'),
(14163, 'Magnolia Mobile Home Park', 39.065559387207, 0.681822635440141, -75.4822235107422, -1.31741332698872, 218, 10, 'PPL', 'P'),
(95956, 'Magnolia Number 1 Colonia', 26.2240009307861, 0.457695159288276, -97.9410018920898, -1.70939295571896, 218, 51, 'PPL', 'P'),
(22825, 'Magnolia Park', 32.0186080932617, 0.558830133133121, -81.0827789306641, -1.41516145900677, 218, 13, 'PPL', 'P'),
(41946, 'Magnolia Park', 31.4338893890381, 0.548624866546423, -92.5227813720703, -1.6148271680455, 218, 22, 'PPL', 'P'),
(95957, 'Magnolia Park', 29.7322196960449, 0.518925127622292, -95.2919387817383, -1.66315808235021, 218, 51, 'PPL', 'P'),
(183037, 'Magnolia Park', 34.167781829834, 0.596340291033696, -118.346389770508, -2.0655341593439, 218, 6, 'PPL', 'P'),
(82226, 'Magnolia Place', 34.2205581665039, 0.597261411875727, -82.0461120605469, -1.43197479391677, 218, 48, 'PPL', 'P'),
(41947, 'Magnolia Plantation', 29.7141704559326, 0.518610108954849, -90.8172225952148, -1.58505955180309, 218, 22, 'PPL', 'P'),
(82227, 'Magnolia Ranch', 32.8286094665527, 0.572967324042725, -80.0505599975586, -1.39714584002266, 218, 48, 'PPL', 'P'),
(95958, 'Magnolia Road Colonia', 27.8689994812012, 0.486405800183552, -98.6269989013672, -1.72136586218969, 218, 51, 'PPL', 'P'),
(3951, 'Magnolia Shores', 31.9325008392334, 0.557327278040475, -86.2941665649414, -1.50611733182263, 218, 2, 'PPL', 'P'),
(14164, 'Magnolia Shores', 38.478328704834, 0.671573526563998, -75.1149978637695, -1.31100403035129, 218, 10, 'PPL', 'P'),
(3952, 'Magnolia Springs', 30.3994407653809, 0.530570332120881, -87.7761077880859, -1.53198208548754, 218, 2, 'PPL', 'P'),
(16987, 'Magnolia Springs', 30.0116691589355, 0.523802440842663, -81.695556640625, -1.42585644762842, 218, 12, 'PPL', 'P'),
(95959, 'Magnolia Springs', 30.735279083252, 0.536431816522091, -94.0263900756836, -1.6410700905852, 218, 51, 'PPL', 'P'),
(22827, 'Magnolia Springs (historical)', 32.0694389343262, 0.559717298671253, -84.4091720581055, -1.47321797129634, 218, 13, 'PPL', 'P'),
(49156, 'Magnolia Terrace', 38.3291702270508, 0.668970220019419, -75.5875015258789, -1.31925077498282, 218, 25, 'PPL', 'P'),
(88765, 'Magnum (historical)', 35.8369407653809, 0.625472610198073, -85.8583297729492, -1.49851054480104, 218, 50, 'PPL', 'P'),
(103930, 'Magnums Mobile Home Park', 36.8108291625977, 0.642470169276476, -77.4902801513672, -1.35246052693417, 218, 53, 'PPL', 'P'),
(49157, 'Mago Vista Beach', 39.0652809143066, 0.681817775171152, -76.5091705322266, -1.33533693375718, 218, 25, 'PPL', 'P'),
(103931, 'Magotha', 37.1800003051758, 0.648913421217814, -75.9491729736328, -1.32556313255659, 218, 53, 'PPL', 'P'),
(49158, 'Magothy Beach', 39.0908317565918, 0.682263721495685, -76.5325012207031, -1.33574413108785, 218, 25, 'PPL', 'P'),
(49159, 'Magothy Estates', 39.065559387207, 0.681822635440141, -76.5138931274414, -1.33541935859291, 218, 25, 'PPL', 'P'),
(49160, 'Magothy Forest', 39.0936088562012, 0.682312191027525, -76.5447235107422, -1.33595745029116, 218, 25, 'PPL', 'P'),
(49161, 'Magothy Forge', 39.1072196960449, 0.68254974499676, -76.5425033569336, -1.3359187012973, 218, 25, 'PPL', 'P'),
(191823, 'Magoun', 36.3763885498047, 0.634887750178857, -100.033058166504, -1.7459062258445, 218, 51, 'PPL', 'P'),
(183039, 'Magra', 39.149169921875, 0.68328191455945, -120.895561218262, -2.11002559430503, 218, 6, 'PPL', 'P'),
(22828, 'Magruder', 32.9199981689453, 0.5745623577986, -82.2416687011719, -1.43538790116982, 218, 13, 'PPL', 'P'),
(103932, 'Magruder', 37.3230590820313, 0.651410267897818, -76.6750030517578, -1.33823125722987, 218, 53, 'PPL', 'P'),
(103933, 'Magruder Hills', 37.4580612182617, 0.653766499672265, -79.1241683959961, -1.38097725641257, 218, 53, 'PPL', 'P'),
(49162, 'Magruder Landing', 38.6438903808594, 0.674463122925762, -76.6941680908203, -1.33856575026279, 218, 25, 'PPL', 'P'),
(76486, 'Maguire', 35.1311111450195, 0.613153559364666, -97.2997207641602, -1.69820048860569, 218, 42, 'PPL', 'P'),
(183038, 'Magunden', 35.3650016784668, 0.617235719262567, -118.933891296387, -2.07578799533098, 218, 6, 'PPL', 'P'),
(191824, 'Magwalt', 31.9236106872559, 0.557172115617464, -103.114166259766, -1.79968170668176, 218, 51, 'PPL', 'P'),
(95960, 'Maha', 30.0902805328369, 0.525174468146758, -97.6761093139648, -1.70476970806659, 218, 51, 'PPL', 'P'),
(164122, 'Mahaffey', 40.8727798461914, 0.713364582758822, -78.7244415283203, -1.37400070646295, 218, 45, 'PPL', 'P'),
(22829, 'Mahailey Crossroads', 33.3588905334473, 0.582222474621022, -85.2186126708984, -1.48734537508894, 218, 13, 'PPL', 'P'),
(210588, 'Mahaiula', 19.7861099243164, 0.345332764340847, -156.039169311523, -2.72339726656298, 218, 15, 'PPL', 'P'),
(30407, 'Mahalasville', 39.360279083252, 0.686966464506602, -86.3627777099609, -1.50731482220679, 218, 19, 'PPL', 'P'),
(14165, 'Mahan', 39.0658302307129, 0.681827362551076, -75.7177810668945, -1.32152458192153, 218, 10, 'PPL', 'P'),
(41950, 'Mahan', 32.8911094665527, 0.574058154825221, -93.045280456543, -1.62394649740821, 218, 22, 'PPL', 'P'),
(56053, 'Mahan', 37.4036102294922, 0.652816150637271, -91.8269424438477, -1.60268248768447, 218, 29, 'PPL', 'P'),
(110253, 'Mahan', 38.0227813720703, 0.663622725708594, -81.3552780151367, -1.41991746523949, 218, 58, 'PPL', 'P'),
(3953, 'Mahan (historical)', 34.5736083984375, 0.603423300847898, -85.8127822875977, -1.49771559121565, 218, 2, 'PPL', 'P'),
(112277, 'Mahan (historical)', 34.6591682434082, 0.604916601850133, -85.3899993896484, -1.49033663762531, 218, 13, 'PPL', 'P'),
(30408, 'Mahan Crossing', 38.5572204589844, 0.672950447426597, -86.3644409179688, -1.50734385066267, 218, 19, 'PPL', 'P'),
(3954, 'Mahan Crossroads', 34.5733299255371, 0.603418440578908, -85.7752838134766, -1.49706111937776, 218, 2, 'PPL', 'P'),
(88766, 'Mahan Village', 36.1680603027344, 0.631251736342572, -84.4891662597656, -1.47461413349781, 218, 50, 'PPL', 'P'),
(210591, 'Mahana', 21.1538906097412, 0.369205040746695, -157.148330688477, -2.74275578452676, 218, 15, 'PPL', 'P'),
(164125, 'Mahanoy City', 40.8125, 0.712312500970186, -76.1419372558594, -1.32892750396168, 218, 45, 'PPL', 'P'),
(164127, 'Mahanoy Plane', 40.7944412231445, 0.711997315855175, -76.2422180175781, -1.33067773343008, 218, 45, 'PPL', 'P'),
(164129, 'Mahantango', 40.6488914489746, 0.709456993070376, -76.9427795410156, -1.34290483862685, 218, 45, 'PPL', 'P'),
(116682, 'Maharishi Vedic City', 41.0525016784668, 0.716501320469744, -91.9947204589844, -1.60561076646107, 218, 16, 'PPL', 'P'),
(33176, 'Mahaska', 39.9874992370605, 0.697913521325427, -97.353889465332, -1.69914591079267, 218, 20, 'PPL', 'P'),
(110252, 'Maher', 37.7691688537598, 0.659196352239801, -82.3274993896484, -1.43688592928299, 218, 58, 'PPL', 'P'),
(187017, 'Maher', 38.6450004577637, 0.674482497422692, -107.584167480469, -1.87769794555119, 218, 7, 'PPL', 'P'),
(22830, 'Mahers (historical)', 33.5361099243164, 0.585315536490068, -84.225830078125, -1.47001805008855, 218, 13, 'PPL', 'P'),
(210593, 'Mahinahina Camp', 20.9599990844727, 0.365820995239045, -156.658615112305, -2.73420863532426, 218, 15, 'PPL', 'P'),
(210600, 'Mahinui', 21.4144401550293, 0.373752488176546, -157.773895263672, -2.75367394604776, 218, 15, 'PPL', 'P'),
(125302, 'Mahkeenac Heights', 42.3263893127441, 0.738734853988325, -73.3125, -1.27954450786834, 218, 23, 'PPL', 'P'),
(125300, 'Mahkeenac Shores', 42.3308296203613, 0.738812351976046, -73.3147201538086, -1.2795832568622, 218, 23, 'PPL', 'P'),
(125301, 'Mahkeenac Terrace', 42.3330612182617, 0.738851300706989, -73.3147201538086, -1.2795832568622, 218, 23, 'PPL', 'P'),
(136651, 'Mahkonce', 47.3244400024414, 0.825967294705116, -95.6152801513672, -1.66880145385814, 218, 28, 'PPL', 'P'),
(95961, 'Mahl', 31.7336101531982, 0.553855980717611, -94.6761093139648, -1.65240983050676, 218, 51, 'PPL', 'P'),
(3955, 'Mahlep', 33.7447204589844, 0.58895647717437, -85.8811111450195, -1.49890815475179, 218, 2, 'PPL', 'P'),
(60755, 'Mahned', 31.208890914917, 0.544697902361047, -89.0808334350586, -1.55475384386242, 218, 30, 'PPL', 'P'),
(136652, 'Mahnomen', 47.3152809143066, 0.825807438460684, -95.9683303833008, -1.67496334283031, 218, 28, 'PPL', 'P'),
(145673, 'Mahola', 41.0355606079102, 0.716205643009718, -74.5927810668945, -1.3018896278366, 218, 37, 'PPL', 'P'),
(95962, 'Mahomet', 30.8216705322266, 0.537939631752267, -97.9316711425781, -1.70923010341831, 218, 51, 'PPL', 'P'),
(120473, 'Mahomet', 40.1952781677246, 0.701539947781788, -88.404167175293, -1.54294378969236, 218, 18, 'PPL', 'P'),
(33177, 'Mahon', 39.0377807617188, 0.681337806963692, -94.9458312988281, -1.65711736720763, 218, 20, 'PPL', 'P'),
(60753, 'Mahon', 34.8147201538086, 0.607631494844387, -89.5152816772461, -1.5623363961181, 218, 30, 'PPL', 'P'),
(123123, 'Mahon', 40.9386100769043, 0.714513537032109, -85.3805618286133, -1.49017192111189, 218, 19, 'PPL', 'P'),
(110254, 'Mahone', 39.1091690063477, 0.682583766879686, -81.0747222900391, -1.41502084410122, 218, 58, 'PPL', 'P'),
(88767, 'Mahone (historical)', 36.0913887023926, 0.629913564473834, -86.0886077880859, -1.50252965436013, 218, 50, 'PPL', 'P'),
(95963, 'Mahoney', 33.1925010681152, 0.579318430610345, -95.4936065673828, -1.66667784920491, 218, 51, 'PPL', 'P'),
(88768, 'Mahoney Mill', 35.7849998474121, 0.62456607016301, -84.101936340332, -1.46785569644146, 218, 50, 'PPL', 'P'),
(71063, 'Mahoneyville', 39.6322212219238, 0.691712750201341, -75.5100021362305, -1.31789815546517, 218, 37, 'PPL', 'P'),
(136655, 'Mahoning', 47.4491691589355, 0.828144229159174, -92.9719390869141, -1.62266644903026, 218, 28, 'PPL', 'P'),
(156299, 'Mahoning', 41.2588882446289, 0.720103445581158, -81.0488891601563, -1.41456997092867, 218, 41, 'PPL', 'P'),
(164130, 'Mahoning', 40.9324989318848, 0.714406877430451, -79.4594421386719, -1.38682888711775, 218, 45, 'PPL', 'P'),
(164131, 'Mahoning Furnace', 40.9458312988281, 0.714639571130697, -79.3644409179688, -1.38517080302307, 218, 45, 'PPL', 'P'),
(164135, 'Mahoningtown', 40.9744415283203, 0.715138913835087, -80.3724975585938, -1.40276471044857, 218, 45, 'PPL', 'P'),
(150471, 'Mahopac', 41.3722190856934, 0.722081441901787, -73.73388671875, -1.28689909353471, 218, 40, 'PPL', 'P'),
(150472, 'Mahopac Falls', 41.371940612793, 0.722076581632798, -73.7622222900391, -1.28739364254913, 218, 40, 'PPL', 'P'),
(150473, 'Mahopac Mines', 41.3980598449707, 0.722532448232392, -73.7594375610352, -1.28734503985924, 218, 40, 'PPL', 'P'),
(183041, 'Mahou Riviera', 34.0133285522461, 0.593644572799291, -118.805557250977, -2.07354814369616, 218, 6, 'PPL', 'P'),
(202335, 'Mahto', 45.7586097717285, 0.798638401651913, -100.675827026367, -1.7571246587784, 218, 49, 'PPL', 'P'),
(136656, 'Mahtomedi', 45.0697212219238, 0.786615028278533, -92.9513931274414, -1.62230785438948, 218, 28, 'PPL', 'P'),
(136658, 'Mahtowa', 46.5738906860352, 0.812867737935234, -92.6316680908203, -1.61672759979938, 218, 28, 'PPL', 'P'),
(178579, 'Mahtson-pi', 35.9372215270996, 0.627222839666473, -110.670280456543, -1.93156077807221, 218, 5, 'PPL', 'P'),
(145674, 'Mahwah', 41.0886116027832, 0.717131557541711, -74.144172668457, -1.29405993423177, 218, 37, 'PPL', 'P'),
(49163, 'Maid Marion', 39.0252799987793, 0.681119627491387, -76.5425033569336, -1.3359187012973, 218, 25, 'PPL', 'P'),
(140438, 'Maida', 48.9986114501953, 0.855187098711302, -98.3644409179688, -1.71678336090199, 218, 34, 'PPL', 'P'),
(41951, 'Maidco', 32.4011116027832, 0.565506078774704, -92.1108322143555, -1.60763729889256, 218, 22, 'PPL', 'P'),
(66569, 'Maiden', 35.5755615234375, 0.620910681829794, -81.2119369506836, -1.41741569171147, 218, 33, 'PPL', 'P'),
(196970, 'Maiden', 47.1777801513672, 0.823407597423386, -109.229438781738, -1.90641334684692, 218, 31, 'PPL', 'P'),
(164137, 'Maiden Creek', 40.4480590820313, 0.70595180702264, -75.8986129760742, -1.32468069412939, 218, 45, 'PPL', 'P'),
(175115, 'Maiden Rock', 44.5608291625977, 0.777733186306037, -92.309440612793, -1.61110366936741, 218, 57, 'PPL', 'P'),
(196971, 'Maiden Rock', 45.6966705322266, 0.797557357986423, -112.735832214355, -1.96761145711639, 218, 31, 'PPL', 'P'),
(103935, 'Maiden Spring', 37.0280609130859, 0.646261578562368, -81.682502746582, -1.42562861419717, 218, 53, 'PPL', 'P'),
(103937, 'Maidens', 37.6688919067383, 0.657446189350428, -77.8822174072266, -1.35930112251014, 218, 53, 'PPL', 'P'),
(103936, 'Maidens Forest', 37.7130584716797, 0.658217041327951, -77.8602828979492, -1.35891829310345, 218, 53, 'PPL', 'P'),
(172222, 'Maidstone', 44.648609161377, 0.779265236302132, -71.5725021362305, -1.2491758161679, 218, 55, 'PPL', 'P'),
(150474, 'Maidstone Park', 41.035831451416, 0.716210370120653, -72.1791687011719, -1.25976414518789, 218, 40, 'PPL', 'P'),
(110255, 'Maidsville', 39.6883316040039, 0.69269206111319, -79.9802780151367, -1.39591918802457, 218, 58, 'PPL', 'P'),
(95964, 'Maier Colonia', 26.2299995422363, 0.457799854808629, -98.3600006103516, -1.71670586291427, 218, 51, 'PPL', 'P'),
(41955, 'Mail Boxes', 32.8166694641113, 0.572758931687426, -93.908332824707, -1.6390096028498, 218, 22, 'PPL', 'P'),
(183042, 'Mailliard (historical)', 38.0066719055176, 0.663341562476509, -122.633056640625, -2.1403506101636, 218, 6, 'PPL', 'P'),
(56054, 'Main City', 38.4894409179688, 0.671767471270383, -94.491943359375, -1.64919552822909, 218, 29, 'PPL', 'P'),
(204770, 'Main Point Condominium', 41.1566696166992, 0.718319393966914, -111.941940307617, -1.95375542943887, 218, 52, 'PPL', 'P'),
(150475, 'Main Settlement', 42.0133285522461, 0.733270912958837, -78.3144378662109, -1.3668447926139, 218, 40, 'PPL', 'P'),
(49164, 'Mainbrace', 38.9752807617188, 0.680246976181196, -76.1533279418945, -1.32912630893706, 218, 25, 'PPL', 'P'),
(66570, 'Maine', 35.9311103820801, 0.627116180064815, -80.5458297729492, -1.40578992828884, 218, 33, 'PPL', 'P'),
(116684, 'Maine', 40.8561096191406, 0.71307363240973, -92.8613891601563, -1.6207369888205, 218, 16, 'PPL', 'P'),
(128051, 'Maine', 45.5002784729004, 0.794129669926409, -69.2502822875977, -1.20864543385409, 218, 26, 'ADM1', 'A'),
(136660, 'Maine', 46.4122200012207, 0.810046052181268, -95.8169403076172, -1.67232108755479, 218, 28, 'PPL', 'P'),
(150476, 'Maine', 42.1925010681152, 0.736398063289835, -76.061393737793, -1.32752175438028, 218, 40, 'PPL', 'P'),
(178580, 'Maine', 35.253059387207, 0.615281957707857, -111.937782287598, -1.95368285829917, 218, 5, 'PPL', 'P'),
(183043, 'Maine Prairie', 38.3080596923828, 0.668601771682606, -121.757781982422, -2.12507418551869, 218, 6, 'PPL', 'P'),
(56055, 'Maines', 37.3797187805176, 0.652399166189591, -92.3633270263672, -1.61204416470637, 218, 29, 'PPL', 'P'),
(164140, 'Mainesburg', 41.7838897705078, 0.729266450785739, -76.9986114501953, -1.34387928926971, 218, 45, 'PPL', 'P'),
(73342, 'Maineville', 39.314998626709, 0.686176171453121, -84.220832824707, -1.46993083156285, 218, 41, 'PPL', 'P'),
(164141, 'Mainland', 40.2558288574219, 0.702596756681359, -75.3605575561523, -1.31528985549355, 218, 45, 'PPL', 'P'),
(128052, 'Mainstream', 44.9694404602051, 0.784864798810133, -69.5074996948242, -1.21313472450364, 218, 26, 'PPL', 'P'),
(73343, 'Mainsville', 39.7122192382813, 0.693108978981842, -82.2422180175781, -1.43539748854974, 218, 41, 'PPL', 'P'),
(164142, 'Mainsville', 40.0149993896484, 0.698393489532887, -77.5149993896484, -1.35289195903076, 218, 45, 'PPL', 'P'),
(164143, 'Mainville', 40.975830078125, 0.715163148601007, -76.3747177124023, -1.33299028936265, 218, 45, 'PPL', 'P'),
(49165, 'Mairs Mill', 39.7136116027832, 0.693133280326789, -77.2172164916992, -1.34769466700542, 218, 25, 'PPL', 'P'),
(178581, 'Maish Vaya', 32.1669387817383, 0.561418992028787, -112.126670837402, -1.95697958541258, 218, 5, 'PPL', 'P'),
(88769, 'Maison', 36.2902793884277, 0.633384861796698, -82.4225006103516, -1.43854401337767, 218, 50, 'PPL', 'P'),
(16989, 'Maitland', 28.6275005340576, 0.499644140935741, -81.3633270263672, -1.42005794698699, 218, 12, 'PPL', 'P'),
(41952, 'Maitland', 31.7569408416748, 0.554263178048285, -91.6097183227539, -1.59889121155663, 218, 22, 'PPL', 'P'),
(110256, 'Maitland', 37.4286117553711, 0.65325250958188, -81.5516662597656, -1.42334508672048, 218, 58, 'PPL', 'P'),
(139304, 'Maitland', 40.2008285522461, 0.70163682026644, -95.0741729736328, -1.6593573520005, 218, 29, 'PPL', 'P'),
(164144, 'Maitland', 40.6305618286133, 0.70913708084443, -77.503059387207, -1.35268356667546, 218, 45, 'PPL', 'P'),
(187018, 'Maitland', 37.6566696166992, 0.657232870147112, -104.83332824707, -1.82968674373535, 218, 7, 'PPL', 'P'),
(202337, 'Maitland', 44.3974990844727, 0.774882538675216, -103.801109313965, -1.81167112475124, 218, 49, 'PPL', 'P'),
(41953, 'Maitland Landing', 31.7580604553223, 0.554282718992783, -91.6063919067383, -1.59883315464487, 218, 22, 'PPL', 'P'),
(103938, 'Maitland Village', 37.2008285522461, 0.64927694270661, -77.4722213745117, -1.35214534181916, 218, 53, 'PPL', 'P'),
(33178, 'Maize', 37.7791709899902, 0.659370922449255, -97.4669418334961, -1.70111904684431, 218, 20, 'PPL', 'P'),
(27787, 'Maizetown', 39.9541702270508, 0.697331820364327, -87.804443359375, -1.53247663450196, 218, 18, 'PPL', 'P'),
(164145, 'Maizeville', 40.7980613708496, 0.712060499352037, -76.2225036621094, -1.33033365301724, 218, 45, 'PPL', 'P'),
(123124, 'Majenica', 40.7700004577637, 0.711570744027571, -85.4533309936523, -1.49144198263575, 218, 19, 'PPL', 'P'),
(3956, 'Majestic', 33.749439239502, 0.58903883543108, -86.7605590820313, -1.51425741685251, 218, 2, 'PPL', 'P'),
(37029, 'Majestic', 37.5338897705078, 0.65508995757598, -82.0999984741211, -1.43291528925573, 218, 21, 'PPL', 'P'),
(204772, 'Majestic Acres', 40.6894416809082, 0.710164728130064, -112.063056945801, -1.95586931355412, 218, 52, 'PPL', 'P'),
(204773, 'Majestic Canyon Estates', 40.5680618286133, 0.708046250061933, -111.803062438965, -1.95133155337274, 218, 52, 'PPL', 'P'),
(204775, 'Majestic Grove', 40.6944389343262, 0.710251946655764, -112.068061828613, -1.95595666523788, 218, 52, 'PPL', 'P'),
(16990, 'Majette', 30.0802803039551, 0.524999931226817, -85.3211135864258, -1.4891343535512, 218, 12, 'PPL', 'P'),
(22831, 'Major', 33.4533309936523, 0.5838707715987, -84.6563873291016, -1.47753269173643, 218, 13, 'PPL', 'P'),
(37030, 'Major', 37.413890838623, 0.652995581115715, -83.6986083984375, -1.46081629589011, 218, 21, 'PPL', 'P'),
(88770, 'Major', 36.0802803039551, 0.629719686346477, -86.3397216796875, -1.50691241856608, 218, 50, 'PPL', 'P'),
(103940, 'Major', 37.5577812194824, 0.655506942023659, -79.3702774047852, -1.38527266893476, 218, 53, 'PPL', 'P'),
(10275, 'Majors', 34.2216682434082, 0.597280786372657, -93.4730606079102, -1.63141266952424, 218, 4, 'PPL', 'P'),
(41954, 'Majors', 30.6002807617188, 0.534075651326671, -91.4372177124023, -1.5958805079443, 218, 22, 'PPL', 'P'),
(95965, 'Majors', 33.1027793884277, 0.577752491889379, -95.2194366455078, -1.66189268135826, 218, 51, 'PPL', 'P'),
(183044, 'Majors', 36.9824981689453, 0.64546635866087, -122.142219543457, -2.13178388672709, 218, 6, 'PPL', 'P'),
(49166, 'Majors Choice', 39.5458297729492, 0.690204934971165, -76.341667175293, -1.33241344867054, 218, 25, 'PPL', 'P'),
(190446, 'Majors Place', 39.0250015258789, 0.681114767222398, -114.581108093262, -1.99981759681094, 218, 39, 'PPL', 'P'),
(110257, 'Majorsville', 39.9655609130859, 0.697530625339701, -80.5199966430664, -1.40533905511629, 218, 58, 'PPL', 'P'),
(56056, 'Majorville', 38.1819381713867, 0.666400535883601, -93.2697219848633, -1.6278637410556, 218, 29, 'PPL', 'P'),
(210607, 'MakaÃ‚â€˜eo', 19.6452808380127, 0.342874833102272, -156.011383056641, -2.72291230492847, 218, 15, 'PPL', 'P'),
(210609, 'Makahalau', 19.976110458374, 0.3486488992407, -155.551666259766, -2.71488873319628, 218, 15, 'PPL', 'P'),
(183046, 'Makahmo (historical)', 38.8180618286133, 0.677502988152033, -123.008331298828, -2.14690038854854, 218, 6, 'PPL', 'P'),
(210612, 'Makakilo City', 21.3469390869141, 0.372574372289322, -158.085830688477, -2.75911824626421, 218, 15, 'PPL', 'P'),
(210616, 'Makalawena', 19.795280456543, 0.345492820322361, -156.029434204102, -2.72322735688543, 218, 15, 'PPL', 'P'),
(27788, 'Makanda', 37.6175003051758, 0.656549236695289, -89.2088928222656, -1.55698890180727, 218, 18, 'PPL', 'P'),
(210622, 'Makapala', 20.2244396209717, 0.35298306075675, -155.752212524414, -2.71838892581697, 218, 15, 'PPL', 'P'),
(66571, 'Makatoka', 34.1183280944824, 0.595477160524401, -78.4075012207031, -1.36846905456274, 218, 33, 'PPL', 'P'),
(210629, 'Makawao', 20.8569393157959, 0.364022262949292, -156.313064575195, -2.72817764071967, 218, 15, 'PPL', 'P'),
(49167, 'Make Shift Estates', 39.3833312988281, 0.687368801568286, -77.4733276367188, -1.35216464973706, 218, 25, 'PPL', 'P'),
(110258, 'Maken', 39.2849998474121, 0.685652593982811, -80.4844436645508, -1.4047185385823, 218, 58, 'PPL', 'P'),
(210634, 'Makena', 20.6574993133545, 0.360541378246504, -156.445281982422, -2.73048526980422, 218, 15, 'PPL', 'P'),
(178582, 'Makgum Havoka', 32.2747192382813, 0.563300115864764, -111.96028137207, -1.9540755414019, 218, 5, 'PPL', 'P'),
(210636, 'Makiki Heights', 21.3174991607666, 0.372060548646505, -157.838333129883, -2.7547985989761, 218, 15, 'PPL', 'P'),
(123125, 'Makin', 40.9658317565918, 0.714988644970579, -85.585563659668, -1.49374987803641, 218, 19, 'PPL', 'P'),
(136663, 'Makinen', 47.3572196960449, 0.826539408286292, -92.3675003051758, -1.61211700216218, 218, 28, 'PPL', 'P'),
(103941, 'Makleys Corner', 38.7586097717285, 0.67646535401231, -77.3405609130859, -1.34984743327258, 218, 53, 'PPL', 'P'),
(66572, 'Makleyville', 35.4605598449707, 0.618903523895229, -76.5458297729492, -1.33597675820907, 218, 33, 'PPL', 'P'),
(125303, 'Makonikey', 41.4597206115723, 0.723608631628893, -70.6561126708984, -1.23318180276726, 218, 23, 'PPL', 'P'),
(198565, 'Makoti', 47.961109161377, 0.837079267774444, -101.804168701172, -1.77681793609121, 218, 34, 'PPL', 'P'),
(211977, 'Makushin', 53.7750015258789, 0.938550831891562, -166.985824584961, -2.91445244316526, 218, 1, 'PPL', 'P'),
(210643, 'Mala', 20.8905601501465, 0.364609057205977, -156.687774658203, -2.73471756540858, 218, 15, 'PPL', 'P'),
(16991, 'Malabar', 28.0033302307129, 0.488750314049203, -80.5658264160156, -1.4061389355497, 218, 12, 'PPL', 'P'),
(187019, 'Malachite', 37.7544403076172, 0.658939290615581, -105.260276794434, -1.83713840162345, 218, 7, 'PPL', 'P'),
(195281, 'Malad City', 42.1916694641113, 0.736383549061894, -112.25, -1.95913208536363, 218, 17, 'PPL', 'P'),
(37031, 'Malaga', 37.711669921875, 0.658192806562032, -83.4274978637695, -1.45608452442331, 218, 21, 'PPL', 'P'),
(71065, 'Malaga', 39.5697212219238, 0.690621919418845, -75.0480575561523, -1.30983570158107, 218, 37, 'PPL', 'P'),
(73344, 'Malaga', 39.8547210693359, 0.695596105123867, -81.1494369506836, -1.41632486092898, 218, 41, 'PPL', 'P'),
(177715, 'Malaga', 32.2238883972168, 0.562412950326632, -104.071937561035, -1.81639796937002, 218, 38, 'PPL', 'P'),
(183045, 'Malaga', 36.6836090087891, 0.640249758717623, -119.732780456543, -2.08973124153419, 218, 6, 'PPL', 'P'),
(207994, 'Malaga', 47.372501373291, 0.826806123869464, -120.199996948242, -2.09788570763396, 218, 56, 'PPL', 'P'),
(95966, 'Malakoff', 32.1694412231445, 0.561462667870664, -96.0122222900391, -1.67572940111787, 218, 51, 'PPL', 'P'),
(183047, 'Malakoff (historical)', 39.3669395446777, 0.687082711488184, -120.918609619141, -2.11042786478769, 218, 6, 'PPL', 'P'),
(145676, 'Malapardis', 40.8294410705566, 0.712608178430212, -74.4322204589844, -1.29908731657956, 218, 37, 'PPL', 'P'),
(41956, 'Malarcher (historical)', 30.0522193908691, 0.524510175902351, -90.831672668457, -1.58531175315832, 218, 22, 'PPL', 'P'),
(150478, 'Malba', 40.7905616760254, 0.71192960498446, -73.8272171020508, -1.28852801601545, 218, 40, 'PPL', 'P'),
(3957, 'Malbis', 30.6555595397949, 0.535040448010579, -87.851936340332, -1.53330554339125, 218, 2, 'PPL', 'P'),
(22832, 'Malbone (historical)', 34.1430587768555, 0.595908792358076, -84.897216796875, -1.4817359588849, 218, 13, 'PPL', 'P'),
(128053, 'Malbons Mills', 44.7961082458496, 0.781839580969857, -69.6858291625977, -1.21624716086961, 218, 26, 'PPL', 'P'),
(103943, 'Malbrook', 38.8477783203125, 0.678021638774326, -77.1677780151367, -1.34683180281223, 218, 53, 'PPL', 'P'),
(183048, 'Malby Crossing', 38.6133308410645, 0.673929758338446, -121.069999694824, -2.11307012006321, 218, 6, 'PPL', 'P'),
(3958, 'Malcolm', 31.1911106109619, 0.544387577515026, -88.0074996948242, -1.53602063612259, 218, 2, 'PPL', 'P'),
(49172, 'Malcolm', 38.6166687011719, 0.673988014987291, -76.7872161865234, -1.34018974589552, 218, 25, 'PPL', 'P'),
(103942, 'Malcolm', 36.6094398498535, 0.638955262690762, -82.2194366455078, -1.43499987859899, 218, 53, 'PPL', 'P'),
(131881, 'Malcolm', 44.4925003051758, 0.776540622769899, -86.1558303833008, -1.50370290997837, 218, 27, 'PPL', 'P'),
(136664, 'Malcolm', 48.3244400024414, 0.843420587225059, -95.3352813720703, -1.66391455325784, 218, 28, 'PPL', 'P'),
(142338, 'Malcolm', 40.9066696166992, 0.713956070836928, -96.8625030517578, -1.69056959997623, 218, 35, 'PPL', 'P'),
(60754, 'Malcolm (historical)', 31.6152801513672, 0.551790732581769, -90.9625015258789, -1.58759514747695, 218, 30, 'PPL', 'P'),
(110260, 'Malcolm Springs Heights', 38.4377784729004, 0.67086579150431, -82.1791687011719, -1.43429707038732, 218, 58, 'PPL', 'P'),
(22833, 'Malcolm Woods', 33.3972206115723, 0.58289146068685, -83.8727798461914, -1.46385616111638, 218, 13, 'PPL', 'P'),
(22834, 'Malcolms Store', 33.7008285522461, 0.588190418886808, -83.5483322143555, -1.45819348169055, 218, 13, 'PPL', 'P'),
(116688, 'Malcom', 41.7083282470703, 0.727947653413932, -92.5588912963867, -1.61545740511747, 218, 16, 'PPL', 'P'),
(150479, 'Malcon', 43.0072212219238, 0.75061761245615, -76.8563919067383, -1.34139708997571, 218, 40, 'PPL', 'P'),
(56057, 'Malden', 36.5569381713867, 0.638038935538693, -89.9663925170898, -1.57020976556481, 218, 29, 'PPL', 'P'),
(110259, 'Malden', 38.3005599975586, 0.668470877315029, -81.5572204589844, -1.42344202578416, 218, 58, 'PPL', 'P'),
(120477, 'Malden', 41.4244384765625, 0.722992842205839, -89.3691711425781, -1.55978628621629, 218, 18, 'PPL', 'P'),
(123126, 'Malden', 41.3761100769043, 0.722149352509584, -87.0269393920898, -1.51890663032552, 218, 19, 'PPL', 'P'),
(125304, 'Malden', 42.4249992370605, 0.740455921842789, -71.0666732788086, -1.24034743715428, 218, 23, 'PPL', 'P'),
(150480, 'Malden', 42.0950012207031, 0.734696369932302, -73.9355621337891, -1.29041899354746, 218, 40, 'PPL', 'P'),
(191827, 'Malden', 35.0897216796875, 0.612431176918982, -101.307777404785, -1.76815427359102, 218, 51, 'PPL', 'P'),
(207995, 'Malden', 47.228889465332, 0.824299623230508, -117.471672058105, -2.05026745523696, 218, 56, 'PPL', 'P'),
(150481, 'Malden Bridge', 42.4705581665039, 0.741251075165259, -73.5833282470703, -1.28427135248712, 218, 40, 'PPL', 'P'),
(125306, 'Malden Centre', 42.4269409179688, 0.74048981056766, -71.065559387207, -1.24032799607833, 218, 23, 'PPL', 'P'),
(125305, 'Malden Highlands', 42.4319381713867, 0.74057702909336, -71.086669921875, -1.24069644441514, 218, 23, 'PPL', 'P'),
(164146, 'Malden Place', 40.0374984741211, 0.698786172635619, -79.9308319091797, -1.39505619067333, 218, 45, 'PPL', 'P'),
(150482, 'Malden-on-Hudson', 42.0952796936035, 0.734701230201291, -73.934440612793, -1.29039941931345, 218, 40, 'PPL', 'P'),
(88771, 'Malesus', 35.542781829834, 0.620338568248618, -88.8266677856445, -1.55031781643468, 218, 50, 'PPL', 'P'),
(201173, 'Malheur City (historical)', 44.4130592346191, 0.775154114527377, -117.723892211914, -2.05466952736081, 218, 43, 'PPL', 'P'),
(22835, 'Malibu', 33.6127815246582, 0.586653708358805, -84.4766693115234, -1.47439602060454, 218, 13, 'PPL', 'P'),
(82228, 'Malibu', 34.1936111450195, 0.596791097627219, -79.7077789306641, -1.39116318179185, 218, 48, 'PPL', 'P'),
(103944, 'Malibu', 36.8466682434082, 0.643095679237509, -76.0955581665039, -1.32811803614835, 218, 53, 'PPL', 'P'),
(183050, 'Malibu', 34.0050010681152, 0.593499230782799, -118.809173583984, -2.073611260614, 218, 6, 'PPL', 'P'),
(183052, 'Malibu Beach', 34.0327796936035, 0.593984059259248, -118.6875, -2.07148765596077, 218, 6, 'PPL', 'P'),
(183053, 'Malibu Bowl', 34.0611114501953, 0.594478541694649, -118.739440917969, -2.07239419599583, 218, 6, 'PPL', 'P'),
(183054, 'Malibu Hills', 34.0475006103516, 0.594240987725414, -118.74333190918, -2.07246210660363, 218, 6, 'PPL', 'P'),
(183055, 'Malibu Junction', 34.1433296203613, 0.595913519469011, -118.75611114502, -2.07268514634492, 218, 6, 'PPL', 'P'),
(183056, 'Malibu Mar Vista (historical)', 34.0616683959961, 0.594488262232628, -118.764167785645, -2.07282576125048, 218, 6, 'PPL', 'P'),
(183057, 'Malibu Vista', 34.047779083252, 0.594245847994403, -118.773330688477, -2.07298568407394, 218, 6, 'PPL', 'P'),
(183058, 'Malibu West', 34.0372200012207, 0.59406155724697, -118.84139251709, -2.07417358707817, 218, 6, 'PPL', 'P'),
(201175, 'Malin', 42.0127792358398, 0.733261325578913, -121.407501220703, -2.1189606329203, 218, 43, 'PPL', 'P'),
(164147, 'Malins', 40.0505599975586, 0.69901413922493, -75.538330078125, -1.31839257132155, 218, 45, 'PPL', 'P'),
(156302, 'Malinta', 41.3224983215332, 0.721213650860585, -84.0380630493164, -1.46674089720916, 218, 41, 'PPL', 'P'),
(188967, 'Maljamar', 32.8561096191406, 0.573447292250184, -103.762222290039, -1.81099241814743, 218, 38, 'PPL', 'P'),
(95967, 'Mallard', 33.582950592041, 0.586133060365695, -97.6516418457031, -1.70434267018579, 218, 51, 'PPL', 'P'),
(116690, 'Mallard', 42.9363899230957, 0.749381373078135, -94.6819381713867, -1.6525115632604, 218, 16, 'PPL', 'P'),
(136665, 'Mallard (historical)', 47.3111114501953, 0.825734667583897, -95.2666702270508, -1.66271706287369, 218, 28, 'PPL', 'P'),
(183061, 'Mallard (historical)', 37.5463905334473, 0.655308137048285, -121.955833435059, -2.12853083545556, 218, 6, 'PPL', 'P'),
(76488, 'Mallard Bay', 35.8597183227539, 0.625870153569794, -95.2788925170898, -1.66293038207701, 218, 42, 'PPL', 'P'),
(82229, 'Mallard Bay', 34.0347213745117, 0.59401794798412, -81.3824996948242, -1.42039257317796, 218, 48, 'PPL', 'P'),
(144105, 'Mallard Cove', 43.561939239502, 0.760299268283024, -71.48388671875, -1.24762918536483, 218, 36, 'PPL', 'P'),
(41957, 'Mallard Junction', 30.2383308410645, 0.527758433483921, -93.1549987792969, -1.62586144339003, 218, 22, 'PPL', 'P'),
(103945, 'Mallard Lake', 38.1450004577637, 0.66575585116272, -78.5016708374023, -1.37011262442949, 218, 53, 'PPL', 'P'),
(120478, 'Mallard Lake North', 41.9666709899902, 0.732456584876518, -88.3708267211914, -1.54236188899418, 218, 18, 'PPL', 'P'),
(120479, 'Mallard Lake South', 41.9588890075684, 0.732320763660924, -88.3711090087891, -1.54236681584219, 218, 18, 'PPL', 'P'),
(66574, 'Mallard Lakes', 36.1861114501953, 0.631566788299528, -80.3252792358398, -1.40194059524924, 218, 33, 'PPL', 'P'),
(10277, 'Mallard Point', 36.3980598449707, 0.635265985632676, -92.2886123657227, -1.61074014787861, 218, 4, 'PPL', 'P'),
(14166, 'Mallard Point', 38.7486114501953, 0.676290850381883, -75.2125015258789, -1.31270579028785, 218, 10, 'PPL', 'P'),
(37036, 'Mallard Point', 38.3177795410156, 0.668771415044044, -84.5761108398438, -1.47613160268694, 218, 21, 'PPL', 'P'),
(49170, 'Mallard Point', 38.8030586242676, 0.67724113283785, -76.2680587768555, -1.33112873976069, 218, 25, 'PPL', 'P'),
(22836, 'Mallard Pointe', 30.8624992370605, 0.538652227080945, -81.6227798461914, -1.42458625294651, 218, 13, 'PPL', 'P'),
(156303, 'Mallet Creek', 41.1672210693359, 0.718503551556293, -81.9255599975586, -1.42987076349756, 218, 41, 'PPL', 'P'),
(49171, 'Mallet Hill', 39.0580596923828, 0.681691741072564, -76.6430587768555, -1.33767372445567, 218, 25, 'PPL', 'P'),
(172224, 'Malletts Bay', 44.5444412231445, 0.777447162804962, -73.2158279418945, -1.27785726215972, 218, 55, 'PPL', 'P'),
(82230, 'Mallory', 34.3883285522461, 0.600189557494269, -79.5133285522461, -1.38776938245671, 218, 48, 'PPL', 'P'),
(88772, 'Mallory', 35.0974998474121, 0.612566931555549, -90.0625, -1.57188715757739, 218, 50, 'PPL', 'P'),
(110268, 'Mallory', 37.7305603027344, 0.658522505904983, -81.8380584716797, -1.42834357377045, 218, 58, 'PPL', 'P'),
(136666, 'Mallory', 47.8766708374023, 0.835605541006222, -96.9113922119141, -1.69142287678949, 218, 28, 'PPL', 'P'),
(150483, 'Mallory', 43.3236083984375, 0.756139610397402, -76.116943359375, -1.32849127817513, 218, 40, 'PPL', 'P'),
(103946, 'Mallory (historical)', 37.9497184753418, 0.662347537599637, -78.1580581665039, -1.36411545197074, 218, 53, 'PPL', 'P'),
(150484, 'Mallory Corner', 42.4241714477539, 0.740441474193875, -75.2936096191406, -1.31412139356528, 218, 40, 'PPL', 'P'),
(22837, 'Mallory Estates', 33.5941696166992, 0.586328869284843, -84.5274963378906, -1.47528311956364, 218, 13, 'PPL', 'P'),
(16992, 'Mallory Heights', 30.7611103057861, 0.536882656405128, -85.1888885498047, -1.48682659130859, 218, 12, 'PPL', 'P'),
(22838, 'Mallory Park', 31.1452808380127, 0.54358769708162, -81.39111328125, -1.4205429086215, 218, 13, 'PPL', 'P'),
(10278, 'Mallory Spur', 35.0155601501465, 0.611136814050176, -90.3852767944336, -1.57752067538929, 218, 4, 'PPL', 'P'),
(30410, 'Mallot Park (historical)', 39.8527793884277, 0.695562216398996, -86.1180572509766, -1.50304364445052, 218, 19, 'PPL', 'P'),
(103947, 'Mallow', 37.7708282470703, 0.659225314116655, -79.9727783203125, -1.39578829365699, 218, 53, 'PPL', 'P'),
(175120, 'Mallwood', 42.836669921875, 0.747640930726741, -89.0041732788086, -1.55341587173077, 218, 57, 'PPL', 'P'),
(60756, 'Malmaison', 33.5222206115723, 0.585073122251843, -90.0072174072266, -1.57092229431446, 218, 30, 'PPL', 'P'),
(66575, 'Malmo', 34.2658309936523, 0.598051571771154, -78.0991668701172, -1.36308760494802, 218, 33, 'PPL', 'P'),
(136667, 'Malmo', 46.3338890075684, 0.808678918435676, -93.519172668457, -1.63221747680567, 218, 28, 'PPL', 'P'),
(142339, 'Malmo', 41.2661094665527, 0.720229479679746, -96.7219390869141, -1.68811629598005, 218, 35, 'PPL', 'P'),
(207996, 'Malo', 48.8016700744629, 0.851749823271364, -118.605827331543, -2.0700621989873, 218, 56, 'PPL', 'P'),
(3961, 'Malone', 33.1986083984375, 0.579425023632976, -85.5841674804688, -1.49372551011244, 218, 2, 'PPL', 'P'),
(16993, 'Malone', 30.9575004577637, 0.540310311175628, -85.1622161865234, -1.48636107075004, 218, 12, 'PPL', 'P'),
(37032, 'Malone', 37.871940612793, 0.660990057812996, -83.2583312988281, -1.4531320108808, 218, 21, 'PPL', 'P'),
(60757, 'Malone', 34.5761108398438, 0.603466976689775, -89.477783203125, -1.56168192428021, 218, 30, 'PPL', 'P'),
(88773, 'Malone', 35.0627784729004, 0.611960929249501, -87.2038879394531, -1.52199496508363, 218, 50, 'PPL', 'P'),
(95968, 'Malone', 31.9177799224854, 0.55707034957431, -96.8944396972656, -1.69112699959238, 218, 51, 'PPL', 'P'),
(116692, 'Malone', 41.8208312988281, 0.729911202085647, -90.4513931274414, -1.57867462308962, 218, 16, 'PPL', 'P'),
(150485, 'Malone', 44.8486099243164, 0.782755908121926, -74.295280456543, -1.29669726265927, 218, 40, 'PPL', 'P'),
(175121, 'Malone', 43.860279083252, 0.765506280846347, -88.2813873291016, -1.54080087712123, 218, 57, 'PPL', 'P'),
(192682, 'Malone', 38.6527786254883, 0.674618252059259, -112.981109619141, -1.97189235541064, 218, 52, 'PPL', 'P'),
(196972, 'Malone', 47.9416694641113, 0.836739981051568, -112.16667175293, -1.95767773309234, 218, 31, 'PPL', 'P'),
(201176, 'Malone', 42.019718170166, 0.733382432829484, -121.558326721191, -2.12159303449979, 218, 43, 'PPL', 'P'),
(207997, 'Malone', 46.9605598449707, 0.819616387874577, -123.325561523438, -2.15243710045482, 218, 56, 'PPL', 'P'),
(188968, 'Malone (historical)', 32.5436096191406, 0.567993138337702, -108.526672363281, -1.89414775897239, 218, 38, 'PPL', 'P'),
(150486, 'Malone Junction', 44.857780456543, 0.78291596410344, -74.274169921875, -1.29632881432246, 218, 40, 'PPL', 'P'),
(66576, 'Malonee Mill', 35.2277793884277, 0.614840738494258, -83.4091720581055, -1.4557646787764, 218, 33, 'PPL', 'P'),
(37033, 'Maloneton', 38.6841697692871, 0.675166130874515, -82.9180603027344, -1.44719316164992, 218, 21, 'PPL', 'P'),
(37034, 'Maloney', 37.5825004577637, 0.655938374120252, -83.6747207641602, -1.46039937802146, 218, 21, 'PPL', 'P'),
(88774, 'Maloneyville', 36.0863914489746, 0.629826345948134, -83.8352813720703, -1.4632016892785, 218, 50, 'PPL', 'P'),
(16994, 'Malore Gardens', 29.5994396209717, 0.516607678131218, -82.3411102294922, -1.43712348325222, 218, 12, 'PPL', 'P'),
(207998, 'Malott', 48.2827796936035, 0.84269347766844, -119.705558776855, -2.08925613359572, 218, 56, 'PPL', 'P'),
(116696, 'Maloy', 40.6744384765625, 0.709902872815882, -94.4119415283203, -1.64779923286956, 218, 16, 'PPL', 'P'),
(194307, 'Maloy', 40.2444381713867, 0.702397951705984, -104.969436645508, -1.8320622834277, 218, 7, 'PPL', 'P'),
(188969, 'Malpais', 31.7983303070068, 0.554985560493969, -107.252502441406, -1.8719092986058, 218, 38, 'PPL', 'P'),
(66577, 'Malpass Corner', 34.5022201538086, 0.602177340931904, -78.0569381713867, -1.36235057511634, 218, 33, 'PPL', 'P'),
(3962, 'Malta', 31.0247192382813, 0.541483500214835, -87.454719543457, -1.52637280244156, 218, 2, 'PPL', 'P'),
(73346, 'Malta', 39.649169921875, 0.692008560819422, -81.8622207641602, -1.42876528532906, 218, 41, 'PPL', 'P'),
(82231, 'Malta', 33.8769416809082, 0.59126417283795, -80.5841674804688, -1.40645904751272, 218, 48, 'PPL', 'P'),
(95971, 'Malta', 33.4880599975586, 0.584476907062802, -94.5219421386719, -1.64971910569939, 218, 51, 'PPL', 'P'),
(116693, 'Malta', 41.9708290100098, 0.732529156016222, -93.1125030517578, -1.62511975302644, 218, 16, 'PPL', 'P'),
(120481, 'Malta', 41.9297218322754, 0.731811700418555, -88.8608322143555, -1.55091409820275, 218, 18, 'PPL', 'P'),
(150488, 'Malta', 42.9711112976074, 0.749987375384182, -73.7930603027344, -1.28793186740544, 218, 40, 'PPL', 'P'),
(164148, 'Malta', 40.6177787780762, 0.708913974524108, -76.9094390869141, -1.34232293792867, 218, 45, 'PPL', 'P'),
(187020, 'Malta', 39.2294387817383, 0.684682870450886, -106.350280761719, -1.85616255971238, 218, 7, 'PPL', 'P'),
(195282, 'Malta', 42.3063888549805, 0.738385780148443, -113.36833190918, -1.97865065930893, 218, 17, 'PPL', 'P'),
(196973, 'Malta', 48.3597183227539, 0.844036310069086, -107.873611450195, -1.88274969582296, 218, 31, 'PPL', 'P'),
(56060, 'Malta Bend', 39.1933288574219, 0.684052633378919, -93.3627777099609, -1.62948786984639, 218, 29, 'PPL', 'P'),
(150489, 'Malta Ridge', 43.0113906860352, 0.750690383332936, -73.790283203125, -1.2878833978736, 218, 40, 'PPL', 'P'),
(150491, 'Maltaville', 42.9455604553223, 0.749541429059649, -73.7822189331055, -1.28774264980999, 218, 40, 'PPL', 'P'),
(33179, 'Maltby', 39.2194404602051, 0.684508366820459, -94.8361129760742, -1.65520242122581, 218, 20, 'PPL', 'P'),
(66578, 'Maltby', 35.1563911437988, 0.613594778578265, -83.9583282470703, -1.46534926238154, 218, 33, 'PPL', 'P'),
(183062, 'Maltby', 38.0149993896484, 0.663486904493, -122.06916809082, -2.13050889835522, 218, 6, 'PPL', 'P'),
(207999, 'Maltby', 47.8052787780762, 0.834359514511201, -122.111938476563, -2.13125538240876, 218, 56, 'PPL', 'P'),
(30411, 'Maltersville', 38.3463897705078, 0.669270757748434, -86.8897171020508, -1.51651164955721, 218, 19, 'PPL', 'P'),
(183063, 'Maltha', 35.4213905334473, 0.618219890443405, -118.996391296387, -2.07687882611347, 218, 6, 'PPL', 'P'),
(183064, 'Malton (historical)', 39.7955589294434, 0.694563530990216, -122.178611755371, -2.13241905064707, 218, 6, 'PPL', 'P'),
(88775, 'Maltsberger (historical)', 36.3180618286133, 0.633869756852174, -82.7144393920898, -1.44363930633326, 218, 50, 'PPL', 'P'),
(56058, 'Malty', 37.3666687011719, 0.652171399337362, -94.2108306884766, -1.64428918655283, 218, 29, 'PPL', 'P'),
(136670, 'Malung', 48.7724990844727, 0.851240693449968, -95.7238922119141, -1.67069709192206, 218, 28, 'PPL', 'P'),
(191825, 'Malvado', 29.9677791595459, 0.523036415844615, -101.867782592773, -1.77792820794966, 218, 51, 'PPL', 'P'),
(3963, 'Malvern', 31.1391696929932, 0.543481037479963, -85.519172668457, -1.49259113664612, 218, 2, 'PPL', 'P'),
(10279, 'Malvern', 34.3622207641602, 0.599733890631757, -92.8127822875977, -1.61988863885525, 218, 4, 'PPL', 'P'),
(49173, 'Malvern', 39.3936080932617, 0.687548165467702, -76.6391677856445, -1.33760581384787, 218, 25, 'PPL', 'P'),
(95969, 'Malvern', 31.3352794647217, 0.54690379869196, -95.7033309936523, -1.67033823096517, 218, 51, 'PPL', 'P'),
(116694, 'Malvern', 41.0027809143066, 0.715633529428542, -95.5849990844727, -1.66827294953981, 218, 16, 'PPL', 'P'),
(120483, 'Malvern', 41.855281829834, 0.73051247728076, -89.8866729736328, -1.56881839705329, 218, 18, 'PPL', 'P'),
(156304, 'Malvern', 40.6916694641113, 0.710203610281979, -81.1813888549805, -1.41688252686124, 218, 41, 'PPL', 'P'),
(164149, 'Malvern', 40.0361099243164, 0.698761937869699, -75.5141677856445, -1.31797085976293, 218, 45, 'PPL', 'P'),
(175122, 'Malvern', 45.607780456543, 0.796005933493397, -89.2850036621094, -1.558317286559, 218, 57, 'PPL', 'P'),
(66579, 'Malvern Hills', 35.5672187805176, 0.620765073497194, -82.6097183227539, -1.44181157887714, 218, 33, 'PPL', 'P'),
(103948, 'Malvern Hills', 37.3244400024414, 0.651434369505683, -79.9558334350586, -1.39549254961794, 218, 53, 'PPL', 'P'),
(150492, 'Malverne', 40.6788902282715, 0.709980570540685, -73.6744384765625, -1.28586152597401, 218, 40, 'PPL', 'P'),
(150496, 'Malverne Park Oaks', 40.6324996948242, 0.709170902990274, -73.6705627441406, -1.28579388168232, 218, 40, 'PPL', 'P'),
(60758, 'Malvina', 33.8494415283203, 0.590784204630491, -90.9172210693359, -1.58680485442347, 218, 30, 'PPL', 'P'),
(150493, 'Mamakating Park', 41.6119384765625, 0.726265334553329, -74.538330078125, -1.3009392788016, 218, 40, 'PPL', 'P'),
(150495, 'Mamaroneck', 40.9486083984375, 0.714688040662536, -73.7330627441406, -1.28688471246482, 218, 40, 'PPL', 'P'),
(95970, 'Mambrino', 32.3741683959961, 0.565035831105223, -97.7447204589844, -1.70596719845074, 218, 51, 'PPL', 'P'),
(66580, 'Mamers', 35.4166717529297, 0.618137532186695, -78.9336090087891, -1.37765136768523, 218, 33, 'PPL', 'P'),
(3964, 'Mamie', 32.1863899230957, 0.561758478488744, -86.0405578613281, -1.50169102493287, 218, 2, 'PPL', 'P'),
(66581, 'Mamie', 36.1277809143066, 0.630548728393818, -75.8375015258789, -1.32361409811281, 218, 33, 'PPL', 'P'),
(116697, 'Mammen', 42.851390838623, 0.747897859192906, -96.2919387817383, -1.68061137487015, 218, 16, 'PPL', 'P'),
(56059, 'Mammoth', 36.535831451416, 0.637670553780908, -92.4005584716797, -1.61269397601235, 218, 29, 'PPL', 'P'),
(110261, 'Mammoth', 38.2633285522461, 0.667821066009049, -81.3722229003906, -1.42021320927855, 218, 58, 'PPL', 'P'),
(164151, 'Mammoth', 40.2008285522461, 0.70163682026644, -79.4633331298828, -1.38689679772555, 218, 45, 'PPL', 'P'),
(178583, 'Mammoth', 32.7224998474121, 0.571115361820683, -110.639999389648, -1.93103227375388, 218, 5, 'PPL', 'P'),
(192683, 'Mammoth', 39.9263916015625, 0.696846991887878, -112.125556945801, -1.95696014433662, 218, 52, 'PPL', 'P'),
(193759, 'Mammoth', 41.7305603027344, 0.728335675984756, -121.353889465332, -2.11802493127131, 218, 6, 'PPL', 'P'),
(196974, 'Mammoth', 45.6697196960449, 0.797086977158888, -112.015830993652, -1.95504506519674, 218, 31, 'PPL', 'P'),
(209585, 'Mammoth', 44.9766693115234, 0.784990966066775, -110.700828552246, -1.93209394292244, 218, 59, 'PPL', 'P'),
(37035, 'Mammoth Cave', 37.1861114501953, 0.649020080819472, -86.0999984741211, -1.50272845933551, 218, 21, 'PPL', 'P'),
(192684, 'Mammoth Junction', 39.936939239502, 0.697031082898229, -112.14778137207, -1.95734803374939, 218, 52, 'PPL', 'P'),
(183065, 'Mammoth Lakes', 37.648609161377, 0.657092188662529, -118.97110748291, -2.07643754032085, 218, 6, 'PPL', 'P'),
(190447, 'Mammoth Ledge (historical)', 38.8191719055176, 0.677522362648963, -119.616943359375, -2.08770950279266, 218, 39, 'PPL', 'P'),
(103949, 'Mammoth Oak', 37.0833282470703, 0.647226175509194, -76.5044403076172, -1.33525437576338, 218, 53, 'PPL', 'P'),
(10280, 'Mammoth Spring', 36.4955596923828, 0.636967678990209, -91.5405578613281, -1.59768413379255, 218, 4, 'PPL', 'P'),
(120484, 'Mammoth Springs', 41.8544387817383, 0.730497763315737, -87.9488906860352, -1.53499771594789, 218, 18, 'PPL', 'P'),
(164152, 'Mamont', 40.4819412231445, 0.706543161942693, -79.5905609130859, -1.38911734144245, 218, 45, 'PPL', 'P'),
(41958, 'Mamou', 30.6336097717285, 0.534657352287771, -92.4191665649414, -1.61301874850729, 218, 22, 'PPL', 'P'),
(56061, 'Mamre', 39.8733291625977, 0.695920877618803, -92.0244369506836, -1.60612941708336, 218, 29, 'PPL', 'P'),
(110262, 'Man', 37.7397193908691, 0.658682362149415, -81.8777770996094, -1.4290367946022, 218, 58, 'PPL', 'P'),
(3965, 'Manack', 32.3283309936523, 0.564235817513764, -86.5111083984375, -1.50990368110245, 218, 2, 'PPL', 'P'),
(164153, 'Manada Gap', 40.3972206115723, 0.705064508326453, -76.7102813720703, -1.3388469800739, 218, 45, 'PPL', 'P'),
(164154, 'Manadahill', 40.3522186279297, 0.704279075541962, -76.7149963378906, -1.33892927175158, 218, 45, 'PPL', 'P'),
(49174, 'Manadier', 38.7130584716797, 0.675670333847895, -76.0447235107422, -1.32723080403119, 218, 25, 'PPL', 'P'),
(49175, 'Manahan (historical)', 39.4858283996582, 0.689157713451519, -77.0772171020508, -1.34525121670527, 218, 25, 'PPL', 'P'),
(49176, 'Manahan Ranch Estates', 39.6688919067383, 0.692352774390314, -77.466667175293, -1.35204840275548, 218, 25, 'PPL', 'P'),
(71066, 'Manahawkin', 39.6952781677246, 0.692813301521816, -74.2591705322266, -1.2960670255873, 218, 37, 'PPL', 'P'),
(71067, 'Manahawkin Terrace', 39.7019386291504, 0.692929548503398, -74.2477798461914, -1.29586822061193, 218, 37, 'PPL', 'P'),
(103950, 'Manakin', 37.601390838623, 0.656268073463204, -77.7024993896484, -1.35616445137825, 218, 53, 'PPL', 'P'),
(103951, 'Manakin Farms', 37.603889465332, 0.656311682726054, -77.7141723632813, -1.35636818320164, 218, 53, 'PPL', 'P'),
(16995, 'Manalapan', 26.5688896179199, 0.463714602431641, -80.0449981689453, -1.39704876780093, 218, 12, 'PPL', 'P'),
(145677, 'Manalapan', 40.2572212219238, 0.702621058026306, -74.396110534668, -1.2984570795076, 218, 37, 'PPL', 'P'),
(136673, 'Manannah', 45.2536087036133, 0.789824470287214, -94.6172180175781, -1.65138198348404, 218, 28, 'PPL', 'P'),
(73348, 'Manara', 39.6025009155273, 0.691194033000021, -83.3130569458008, -1.45408715360575, 218, 41, 'PPL', 'P'),
(16996, 'Manasota', 27.0149993896484, 0.471500686773624, -82.4027786254883, -1.43819979980678, 218, 12, 'PPL', 'P'),
(16997, 'Manasota Beach', 27.0102806091309, 0.471418328516913, -82.4127807617188, -1.43837437001623, 218, 12, 'PPL', 'P'),
(16998, 'Manasota Key', 26.9249992370605, 0.469929887783668, -82.3522186279297, -1.43731736137958, 218, 12, 'PPL', 'P'),
(145680, 'Manasquan', 40.1261100769043, 0.700332736859655, -74.0497207641602, -1.29241143751701, 218, 37, 'PPL', 'P'),
(145679, 'Manasquan Park', 40.0999984741211, 0.699877003418115, -74.0749969482422, -1.29285259015158, 218, 37, 'PPL', 'P'),
(187021, 'Manassa', 37.1741714477539, 0.648811688464173, -105.936943054199, -1.84894845579351, 218, 7, 'PPL', 'P'),
(22841, 'Manassas', 32.1602783203125, 0.561302745047205, -82.0197219848633, -1.43151420020624, 218, 13, 'PPL', 'P'),
(103952, 'Manassas', 38.7508316040039, 0.676329599375744, -77.4755630493164, -1.35220366504703, 218, 53, 'PPL', 'P'),
(103953, 'Manassas Park', 38.7838897705078, 0.676906573225909, -77.4700012207031, -1.3521065928253, 218, 53, 'PPL', 'P'),
(164155, 'Manatawna', 40.065559387207, 0.699275927960084, -75.2322235107422, -1.31305000385874, 218, 45, 'PPL', 'P'),
(164156, 'Manatawny', 40.3836097717285, 0.704826954357218, -75.7330627441406, -1.32179129750471, 218, 45, 'PPL', 'P'),
(16999, 'Manatee', 27.4961109161377, 0.479897666980157, -82.5397186279297, -1.44058985372707, 218, 12, 'PPL', 'P'),
(116698, 'Manatheka (historical)', 42.2277793884277, 0.737013786133861, -91.8702774047852, -1.60343882543405, 218, 16, 'PPL', 'P'),
(17001, 'Manattee Road', 29.5127792358398, 0.515095169079621, -82.914436340332, -1.44712991157403, 218, 12, 'PPL', 'P'),
(17002, 'Manavista', 27.5152797698975, 0.480232226592098, -82.5355606079102, -1.44051728258736, 218, 12, 'PPL', 'P'),
(175123, 'Manawa', 44.4644393920898, 0.776050867445434, -88.9197235107422, -1.55194194522546, 218, 57, 'PPL', 'P'),
(164157, 'Manayunk', 40.0244407653809, 0.698558272625335, -75.2144393920898, -1.31273961243369, 218, 45, 'PPL', 'P'),
(112620, 'Manbur', 37.5344390869141, 0.655099544955905, -77.3424987792969, -1.34988125541843, 218, 53, 'PPL', 'P'),
(78665, 'Mance', 39.8316688537598, 0.695193768062184, -78.9369430541992, -1.37770955775505, 218, 45, 'PPL', 'P'),
(131889, 'Mancelona', 44.9022216796875, 0.783691609770926, -85.0608291625977, -1.48459153336374, 218, 27, 'PPL', 'P'),
(41959, 'Manchac', 30.291389465332, 0.528684481173969, -90.4019393920898, -1.57781149258033, 218, 22, 'PPL', 'P'),
(95972, 'Manchaca', 30.1405601501465, 0.526052013015453, -97.8327789306641, -1.70750410871583, 218, 51, 'PPL', 'P'),
(125308, 'Manchaug', 42.0944404602051, 0.734686582815296, -71.7480621337891, -1.25223991616009, 218, 23, 'PPL', 'P'),
(585, 'Manchester', 30.1941699981689, 0.526987681374938, -93.0969390869141, -1.62484811059525, 218, 22, 'PPL', 'P'),
(3967, 'Manchester', 34.4111099243164, 0.600587167445018, -86.3483276367188, -1.50706262085156, 218, 2, 'PPL', 'P'),
(22843, 'Manchester', 32.8597183227539, 0.573510276009964, -84.620002746582, -1.4768976609745, 218, 13, 'PPL', 'P'),
(27790, 'Manchester', 39.5422210693359, 0.690141951211385, -90.3322219848633, -1.57659469427827, 218, 18, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(33180, 'Manchester', 39.0947189331055, 0.682331565524455, -97.3244400024414, -1.69863192070228, 218, 20, 'PPL', 'P'),
(37037, 'Manchester', 37.1536102294922, 0.648452827507285, -83.7619400024414, -1.46192164090055, 218, 21, 'PPL', 'P'),
(49177, 'Manchester', 39.6611099243164, 0.69221695317472, -76.8852767944336, -1.34190122637006, 218, 25, 'PPL', 'P'),
(56062, 'Manchester', 38.5969390869141, 0.673643668258344, -90.5091705322266, -1.57968302903638, 218, 29, 'PPL', 'P'),
(66582, 'Manchester', 35.1925010681152, 0.614225015650232, -78.9866714477539, -1.3785774819543, 218, 33, 'PPL', 'P'),
(76490, 'Manchester', 36.9938888549805, 0.645665163636244, -98.0372161865234, -1.71107221194431, 218, 42, 'PPL', 'P'),
(88777, 'Manchester', 35.4816703796387, 0.619271972232041, -86.0886077880859, -1.50252965436013, 218, 50, 'PPL', 'P'),
(95974, 'Manchester', 33.8424987792969, 0.590663030800892, -95.1622161865234, -1.66089399594948, 218, 51, 'PPL', 'P'),
(103956, 'Manchester', 37.5208282470703, 0.654861990986669, -77.4444427490234, -1.35166051334271, 218, 53, 'PPL', 'P'),
(113668, 'Manchester', 41.7758293151855, 0.729125769301156, -72.5219421386719, -1.26574667026064, 218, 8, 'PPL', 'P'),
(116699, 'Manchester', 42.4841690063477, 0.741488629134494, -91.4552764892578, -1.59619569305931, 218, 16, 'PPL', 'P'),
(123127, 'Manchester', 40.0977783203125, 0.699838254424255, -86.904167175293, -1.51676385091244, 218, 19, 'PPL', 'P'),
(125309, 'Manchester', 42.5777816772461, 0.743122478463258, -70.7694396972656, -1.23515973250886, 218, 23, 'PPL', 'P'),
(128054, 'Manchester', 44.3244400024414, 0.773607417145286, -69.8608322143555, -1.21930154032382, 218, 26, 'PPL', 'P'),
(131883, 'Manchester', 42.1502799987793, 0.73566116661621, -84.0377807617188, -1.46673597036114, 218, 27, 'PPL', 'P'),
(136675, 'Manchester', 43.7255592346191, 0.763154975919916, -93.4516677856445, -1.63103929433942, 218, 28, 'PPL', 'P'),
(144106, 'Manchester', 42.9955596923828, 0.75041408036984, -71.4552764892578, -1.24712984266044, 218, 36, 'PPL', 'P'),
(150498, 'Manchester', 42.9697189331055, 0.749963074039235, -77.2305603027344, -1.34792756044274, 218, 40, 'PPL', 'P'),
(156305, 'Manchester', 40.936939239502, 0.714484375418173, -81.5694427490234, -1.42365534498747, 218, 41, 'PPL', 'P'),
(164159, 'Manchester', 40.063060760498, 0.699232318697234, -76.7186126708984, -1.33899238866942, 218, 45, 'PPL', 'P'),
(170818, 'Manchester', 44.3691711425781, 0.774388122818843, -97.7202835083008, -1.70554069320216, 218, 49, 'PPL', 'P'),
(172225, 'Manchester', 43.1636085510254, 0.753347086257372, -73.0727767944336, -1.27536054863777, 218, 55, 'PPL', 'P'),
(175125, 'Manchester', 43.690559387207, 0.762544113344879, -89.0483322143555, -1.55418659055024, 218, 57, 'PPL', 'P'),
(183066, 'Manchester', 38.9702796936035, 0.680159691076468, -123.686943054199, -2.15874439802251, 218, 6, 'PPL', 'P'),
(196975, 'Manchester', 47.540828704834, 0.829743990025985, -111.461387634277, -1.94536820305983, 218, 31, 'PPL', 'P'),
(208000, 'Manchester', 47.5561103820801, 0.830010705609156, -122.543609619141, -2.1387894651326, 218, 56, 'PPL', 'P'),
(188970, 'Manchester (historical)', 33.7113914489746, 0.588374776213269, -105.753059387207, -1.84573908036386, 218, 38, 'PPL', 'P'),
(164160, 'Manchester Beach', 42.077220916748, 0.73438604508628, -80.2372207641602, -1.40040368498416, 218, 45, 'PPL', 'P'),
(150499, 'Manchester Bridge', 41.684440612793, 0.72753073554528, -73.8663864135742, -1.28921164946728, 218, 40, 'PPL', 'P'),
(150500, 'Manchester Center', 42.975830078125, 0.750069733640893, -77.1802825927734, -1.34705004886356, 218, 40, 'PPL', 'P'),
(172229, 'Manchester Center', 43.1769409179688, 0.753579779957618, -73.057502746582, -1.27509396621266, 218, 55, 'PPL', 'P'),
(103957, 'Manchester Court', 37.2733306884766, 0.650542343698561, -80.0455627441406, -1.39705862149696, 218, 53, 'PPL', 'P'),
(172226, 'Manchester Depot', 43.1738891601563, 0.753526516735816, -73.0361099243164, -1.27472059102783, 218, 55, 'PPL', 'P'),
(49178, 'Manchester Estates', 38.8136100769043, 0.677425290427229, -76.9088897705078, -1.34231335054875, 218, 25, 'PPL', 'P'),
(113669, 'Manchester Green', 41.7849998474121, 0.72928582528267, -72.5008316040039, -1.26537822192383, 218, 8, 'PPL', 'P'),
(103958, 'Manchester Mill', 37.2555618286133, 0.650232218589621, -77.2716674804688, -1.34864501604041, 218, 53, 'PPL', 'P'),
(49179, 'Manchester Park', 39.6527786254883, 0.692071544579202, -75.8486099243164, -1.32380797624017, 218, 25, 'PPL', 'P'),
(88778, 'Manchester Park', 35.1141700744629, 0.61285788190464, -85.2769393920898, -1.48836336841562, 218, 50, 'PPL', 'P'),
(183067, 'Manchester Rancheria', 38.9347190856934, 0.679539041384425, -123.680282592773, -2.15862815104093, 218, 6, 'PPL', 'P'),
(56063, 'Manchester School', 39.0930595397949, 0.682302603647601, -94.5013885498047, -1.64936037790056, 218, 29, 'PPL', 'P'),
(142340, 'Manchester Trailer Court', 41.603328704834, 0.726115065688821, -98.9258270263672, -1.7265813968685, 218, 35, 'PPL', 'P'),
(187022, 'Mancos', 37.3450012207031, 0.651793230462571, -108.288612365723, -1.88999282819771, 218, 7, 'PPL', 'P'),
(110263, 'Mand', 39.6194381713867, 0.69148964388102, -80.741943359375, -1.40921275607986, 218, 58, 'PPL', 'P'),
(95975, 'Manda', 30.4025001525879, 0.530623728500737, -97.4680633544922, -1.70113862107832, 218, 51, 'PPL', 'P'),
(17003, 'Mandalay', 30.1236095428467, 0.525756169107858, -83.966667175293, -1.46549480413511, 218, 12, 'PPL', 'P'),
(41962, 'Mandalay', 29.5658302307129, 0.516021083611615, -90.771110534668, -1.58425474452167, 218, 22, 'PPL', 'P'),
(112239, 'Mandalay', 35.7791709899902, 0.624464337409369, -90.2358322143555, -1.57491237541767, 218, 4, 'PPL', 'P'),
(145682, 'Mandalay', 40.0152816772461, 0.698398416380903, -74.0905609130859, -1.29312423258277, 218, 37, 'PPL', 'P'),
(66585, 'Mandale', 35.8530616760254, 0.62575397316724, -79.2733306884766, -1.38358062953618, 218, 33, 'PPL', 'P'),
(156306, 'Mandale', 41.0180587768555, 0.715900178432686, -84.3600006103516, -1.47235976763506, 218, 41, 'PPL', 'P'),
(131885, 'Mandan', 47.4249992370605, 0.827722384442505, -88.0155563354492, -1.53616125102814, 218, 27, 'PPL', 'P'),
(198568, 'Mandan', 46.8266716003418, 0.817279597176087, -100.889167785645, -1.76084815745649, 218, 34, 'PPL', 'P'),
(150502, 'Mandana', 42.8655586242676, 0.74814513370012, -76.4038925170898, -1.33349948576308, 218, 40, 'PPL', 'P'),
(198572, 'Mandaree', 47.7291717529297, 0.833031196338497, -102.675559997559, -1.79202658328638, 218, 34, 'PPL', 'P'),
(17004, 'Mandarin', 30.1602802276611, 0.526396193296832, -81.6594390869141, -1.4252260773984, 218, 12, 'PPL', 'P'),
(164164, 'Mandata', 40.6833305358887, 0.710058068528406, -76.8269424438477, -1.34088309988532, 218, 45, 'PPL', 'P'),
(82232, 'Mandel Hall', 34.065559387207, 0.594556172840425, -81.1111068725586, -1.41565587486315, 218, 48, 'PPL', 'P'),
(82233, 'Mandel Park', 34.0616683959961, 0.594488262232628, -81.1177825927734, -1.41577238816084, 218, 48, 'PPL', 'P'),
(88779, 'Mandels (historical)', 36.4111099243164, 0.635493752484905, -88.3477783203125, -1.54195961851152, 218, 50, 'PPL', 'P'),
(192685, 'Manderfield', 38.3594398498535, 0.669498524600663, -112.638061523438, -1.96590503664792, 218, 52, 'PPL', 'P'),
(202339, 'Manderson', 43.235279083252, 0.754597973021382, -102.470283508301, -1.78844383267189, 218, 49, 'PPL', 'P'),
(209586, 'Manderson', 44.2694396972656, 0.772647480730367, -107.963333129883, -1.88431563454393, 218, 59, 'PPL', 'P'),
(10284, 'Mandeville', 33.4816703796387, 0.584365387192155, -93.9638900756836, -1.6399792598027, 218, 4, 'PPL', 'P'),
(17005, 'Mandeville', 30.3291702270508, 0.529343879859872, -81.894172668457, -1.42932295126133, 218, 12, 'PPL', 'P'),
(22842, 'Mandeville', 33.6544418334961, 0.587380817915424, -85.1369400024414, -1.48591991811547, 218, 13, 'PPL', 'P'),
(41960, 'Mandeville', 30.358060836792, 0.529848116122765, -90.065559387207, -1.57194055395725, 218, 22, 'PPL', 'P'),
(56064, 'Mandeville', 39.4963912963867, 0.68934207077798, -93.6208267211914, -1.63399167472388, 218, 29, 'PPL', 'P'),
(110264, 'Mandeville', 37.4955596923828, 0.654420971510152, -80.8227767944336, -1.41062356566733, 218, 58, 'PPL', 'P'),
(49180, 'Mandleys', 38.6002807617188, 0.673701991486217, -76.8483276367188, -1.3412563419121, 218, 25, 'PPL', 'P'),
(103959, 'Mandleys Corner', 38.5625, 0.673042592800313, -77.8008270263672, -1.3578805923847, 218, 53, 'PPL', 'P'),
(190448, 'Mandolin (historical)', 35.7969398498535, 0.624774462518308, -115.628059387207, -2.0180903439983, 218, 39, 'PPL', 'P'),
(204787, 'Mandolin Condominium', 40.7708282470703, 0.711585191676485, -111.876388549805, -1.95261133543458, 218, 52, 'PPL', 'P'),
(140439, 'Mandt', 48.4197196960449, 0.845083531588732, -97.6005630493164, -1.70345117701089, 218, 34, 'PPL', 'P'),
(56065, 'Manes', 37.3800010681152, 0.652404093037608, -92.3666687011719, -1.61210248793424, 218, 29, 'PPL', 'P'),
(103960, 'Maness', 36.7822189331055, 0.641970826572086, -83.0577774047852, -1.44963168510205, 218, 53, 'PPL', 'P'),
(14167, 'Manette Heights', 39.7152786254883, 0.693162375361698, -75.6569366455078, -1.32046264643687, 218, 10, 'PPL', 'P'),
(136686, 'Maney', 46.9902801513672, 0.820135105075897, -92.607780456543, -1.61631068193073, 218, 28, 'PPL', 'P'),
(10285, 'Manfred', 34.4077796936035, 0.600529043954227, -93.6483306884766, -1.63447170951036, 218, 4, 'PPL', 'P'),
(140440, 'Manfred', 47.6947212219238, 0.832429921143384, -99.7477798461914, -1.74092717987048, 218, 34, 'PPL', 'P'),
(136680, 'Manganese', 46.5275001525879, 0.812058070384823, -94.0094375610352, -1.64077421338809, 218, 28, 'PPL', 'P'),
(110265, 'Manganese (historical)', 39.1236114501953, 0.682835835076862, -81.6597213745117, -1.42523100424642, 218, 58, 'PPL', 'P'),
(188971, 'Mangas', 34.1569404602051, 0.596151073438246, -108.31861114502, -1.89051640566802, 218, 38, 'PPL', 'P'),
(188972, 'Mangas Springs', 32.8424987792969, 0.573209738280949, -108.511108398438, -1.89387611654121, 218, 38, 'PPL', 'P'),
(196976, 'Manger', 46.5166702270508, 0.811869052526454, -111.224998474121, -1.94124243389908, 218, 31, 'PPL', 'P'),
(41961, 'Mangham', 32.3088912963867, 0.563896530790887, -91.7747192382813, -1.60177102080139, 218, 22, 'PPL', 'P'),
(17006, 'Mango', 27.9794406890869, 0.488333362891038, -82.3066711425781, -1.43652240779419, 218, 12, 'PPL', 'P'),
(17007, 'Mango Hills', 27.9922199249268, 0.488556402632332, -82.2947235107422, -1.43631388228084, 218, 12, 'PPL', 'P'),
(103961, 'Mangohick', 37.810001373291, 0.659909014147506, -77.273063659668, -1.34866938396439, 218, 53, 'PPL', 'P'),
(17008, 'Mangonia Park', 26.7600002288818, 0.467050111828424, -80.0738906860352, -1.39755303735333, 218, 12, 'PPL', 'P'),
(10286, 'Mangrum', 35.7877807617188, 0.624614606273876, -90.3574981689453, -1.57703584691284, 218, 4, 'PPL', 'P'),
(37038, 'Mangum', 37.1733283996582, 0.64879697449915, -84.7727813720703, -1.47956415101594, 218, 21, 'PPL', 'P'),
(66590, 'Mangum', 35.1227798461914, 0.613008150769148, -79.9875030517578, -1.39604528870219, 218, 33, 'PPL', 'P'),
(76491, 'Mangum', 34.871940612793, 0.608630180253166, -99.5038909912109, -1.73667051634216, 218, 42, 'PPL', 'P'),
(95976, 'Mangum', 32.3199996948242, 0.564090408918245, -98.8591690063477, -1.7254179949463, 218, 51, 'PPL', 'P'),
(131886, 'Mangum', 46.458610534668, 0.810855719731679, -87.2566680908203, -1.52291615250469, 218, 27, 'PPL', 'P'),
(178585, 'Mangum Springs', 36.6261100769043, 0.639246213039854, -112.348609924316, -1.9608531532181, 218, 5, 'PPL', 'P'),
(66588, 'Mangum Store', 36.1936111450195, 0.631697682667106, -78.82861328125, -1.37581884653914, 218, 33, 'PPL', 'P'),
(82234, 'Mangums (historical)', 34.7633285522461, 0.606734542189248, -80.3411102294922, -1.40221689821234, 218, 48, 'PPL', 'P'),
(150503, 'Manhasset', 40.797779083252, 0.71205557250402, -73.6999969482422, -1.2863076054566, 218, 40, 'PPL', 'P'),
(150504, 'Manhasset Hills', 40.7591705322266, 0.711381726169203, -73.6802825927734, -1.28596352504376, 218, 40, 'PPL', 'P'),
(17009, 'Manhattan', 27.5072193145752, 0.480091545107515, -82.3188934326172, -1.43673572699751, 218, 12, 'PPL', 'P'),
(30415, 'Manhattan', 39.5550003051758, 0.690364990952679, -86.9274978637695, -1.51717104824312, 218, 19, 'PPL', 'P'),
(33181, 'Manhattan', 39.1836090087891, 0.683882990017481, -96.5713882446289, -1.68548868809052, 218, 20, 'PPL', 'P'),
(60759, 'Manhattan', 33.271671295166, 0.580700211741933, -90.8572235107422, -1.58575769948285, 218, 30, 'PPL', 'P'),
(120487, 'Manhattan', 41.4225006103516, 0.722959020059996, -87.9858322143555, -1.5356424672478, 218, 18, 'PPL', 'P'),
(164165, 'Manhattan', 41.746940612793, 0.728621566327777, -77.538330078125, -1.35329915636143, 218, 45, 'PPL', 'P'),
(190449, 'Manhattan', 38.538890838623, 0.672630535200651, -117.07250213623, -2.04330062582532, 218, 39, 'PPL', 'P'),
(196977, 'Manhattan', 45.8566703796387, 0.800349882126453, -111.331672668457, -1.94310424981716, 218, 31, 'PPL', 'P'),
(194308, 'Manhattan (historical)', 40.7322196960449, 0.710911345341668, -105.59944152832, -1.84305794293642, 218, 7, 'PPL', 'P'),
(17010, 'Manhattan Beach', 30.3666706085205, 0.529998384987273, -81.3988876342773, -1.42067859667904, 218, 12, 'PPL', 'P'),
(49181, 'Manhattan Beach', 39.0683288574219, 0.681870971813926, -76.521110534668, -1.33554532611247, 218, 25, 'PPL', 'P'),
(136681, 'Manhattan Beach', 46.728328704834, 0.815563189853531, -94.1344375610352, -1.64295587495308, 218, 28, 'PPL', 'P'),
(156307, 'Manhattan Beach', 41.5750007629395, 0.725620649832448, -81.5769424438477, -1.42378623935505, 218, 41, 'PPL', 'P'),
(183068, 'Manhattan Beach', 33.8847198486328, 0.591399927474517, -118.410003662109, -2.06664443120235, 218, 6, 'PPL', 'P'),
(201177, 'Manhattan Beach', 45.6305618286133, 0.796403543444146, -123.940277099609, -2.16316591122231, 218, 43, 'PPL', 'P'),
(116700, 'Manhattan Beach Resort', 43.3911094665527, 0.757317726284626, -95.1672210693359, -1.66098134763323, 218, 16, 'PPL', 'P'),
(49182, 'Manhattan Manor', 39.0652809143066, 0.681817775171152, -76.5277786254883, -1.33566170625211, 218, 25, 'PPL', 'P'),
(150507, 'Manhattan Park', 41.2380599975586, 0.719739924092362, -73.7777786254883, -1.28766515182227, 218, 40, 'PPL', 'P'),
(17011, 'Manhatten', 29.1383304595947, 0.50855980505408, -81.51611328125, -1.42272457018649, 218, 12, 'PPL', 'P'),
(95977, 'Manheim', 30.2305603027344, 0.527622812005409, -97.0308303833008, -1.69350746613275, 218, 51, 'PPL', 'P'),
(110266, 'Manheim', 39.360279083252, 0.686966464506602, -79.6911087036133, -1.39087223144276, 218, 58, 'PPL', 'P'),
(164166, 'Manheim', 40.163330078125, 0.700982348428553, -76.3952789306641, -1.33334915031954, 218, 45, 'PPL', 'P'),
(150509, 'Manheim Center', 43.047779083252, 0.751325480673893, -74.7922210693359, -1.30537051253939, 218, 40, 'PPL', 'P'),
(196978, 'Manicke (historical)', 48.0416717529297, 0.838485350250979, -115.297218322754, -2.01231607812279, 218, 31, 'PPL', 'P'),
(41963, 'Manifest', 31.7099990844727, 0.553443889828435, -91.9619369506836, -1.60503858630086, 218, 22, 'PPL', 'P'),
(164169, 'Manifold', 40.1949996948242, 0.701535087512799, -80.2188873291016, -1.40008370617918, 218, 45, 'PPL', 'P'),
(78667, 'Manifold Manor', 39.9427795410156, 0.697133015388952, -76.6272201538086, -1.33739728833452, 218, 45, 'PPL', 'P'),
(3969, 'Manila', 32.4483299255371, 0.566330193974029, -86.9211120605469, -1.5170595949515, 218, 2, 'PPL', 'P'),
(10287, 'Manila', 35.8800010681152, 0.626224154257693, -90.1669387817383, -1.5737099581855, 218, 4, 'PPL', 'P'),
(37039, 'Manila', 37.8427810668945, 0.660481127728682, -82.9155578613281, -1.44714948580804, 218, 21, 'PPL', 'P'),
(56066, 'Manila', 38.5511093139648, 0.672843787824939, -93.3361129760742, -1.6290224824459, 218, 29, 'PPL', 'P'),
(88780, 'Manila', 35.4625015258789, 0.6189374126201, -84.4786071777344, -1.47442984275038, 218, 50, 'PPL', 'P'),
(110267, 'Manila', 37.9866714477539, 0.662992488636627, -81.9430618286133, -1.43017622807459, 218, 58, 'PPL', 'P'),
(178584, 'Manila', 34.9650001525879, 0.610254375622978, -110.412780761719, -1.92706656057464, 218, 5, 'PPL', 'P'),
(187023, 'Manila', 39.7563896179199, 0.693879897538393, -104.521942138672, -1.82425203089883, 218, 7, 'PPL', 'P'),
(193760, 'Manila', 40.8519401550293, 0.713000861532944, -124.161109924316, -2.16702017110993, 218, 6, 'PPL', 'P'),
(204789, 'Manila', 40.9880599975586, 0.715376600962376, -109.721939086914, -1.91500909873931, 218, 52, 'PPL', 'P'),
(210659, 'Manila Camp', 21.0980606079102, 0.368230623393349, -157.026382446289, -2.74062738618357, 218, 15, 'PPL', 'P'),
(30414, 'Manilla', 39.5741691589355, 0.69069955056462, -85.6194381713867, -1.49434109979841, 218, 19, 'PPL', 'P'),
(116701, 'Manilla', 41.889720916748, 0.731113552738791, -95.2319412231445, -1.66211092740959, 218, 16, 'PPL', 'P'),
(3970, 'Manistee', 31.4408302307129, 0.548746007086508, -87.4944381713867, -1.5270660232733, 218, 2, 'PPL', 'P'),
(131887, 'Manistee', 44.2444381713867, 0.772211121785757, -86.3241729736328, -1.506641042451, 218, 27, 'PPL', 'P'),
(41964, 'Manistee (historical)', 31.5750007629395, 0.551087724633015, -92.3605575561523, -1.61199582833259, 218, 22, 'PPL', 'P'),
(131892, 'Manistique', 45.9577789306641, 0.802114559243767, -86.2461090087891, -1.50527856923731, 218, 27, 'PPL', 'P'),
(120489, 'Manito', 40.4258308410645, 0.705563851030843, -89.779167175293, -1.56694206690728, 218, 18, 'PPL', 'P'),
(164170, 'Manito', 40.2724990844727, 0.70288770703045, -79.3986129760742, -1.38576721794919, 218, 45, 'PPL', 'P'),
(208002, 'Manito', 47.5077781677246, 0.829167149333873, -117.131393432617, -2.04432847284803, 218, 56, 'PPL', 'P'),
(136683, 'Manitoba Junction', 46.9066696166992, 0.818675825956588, -96.2472229003906, -1.6798309355127, 218, 28, 'PPL', 'P'),
(113671, 'Manitock Spring', 41.3527793884277, 0.721742155178911, -72.1622161865234, -1.25946826799078, 218, 8, 'PPL', 'P'),
(37040, 'Manitou', 37.3711090087891, 0.652248897325084, -87.579719543457, -1.52855446400655, 218, 21, 'PPL', 'P'),
(76493, 'Manitou', 34.5074996948242, 0.602269486305621, -98.9830627441406, -1.72758034859339, 218, 42, 'PPL', 'P'),
(136684, 'Manitou', 48.6283302307129, 0.848724472273034, -93.9927825927734, -1.64048352935511, 218, 28, 'PPL', 'P'),
(150511, 'Manitou', 41.3330612182617, 0.721398008187046, -73.9641723632813, -1.29091833625185, 218, 40, 'PPL', 'P'),
(198573, 'Manitou', 48.3311080932617, 0.843536967364696, -102.636108398438, -1.79133802298654, 218, 34, 'PPL', 'P'),
(208004, 'Manitou', 47.1974983215332, 0.823751744415252, -122.491668701172, -2.13788292509754, 218, 56, 'PPL', 'P'),
(131896, 'Manitou Beach', 45.4908294677734, 0.793964753675906, -83.9327774047852, -1.464903316057, 218, 27, 'PPL', 'P'),
(150512, 'Manitou Beach', 43.3233299255371, 0.756134750128412, -77.7147216796875, -1.35637777058156, 218, 40, 'PPL', 'P'),
(208005, 'Manitou Beach', 47.6558303833008, 0.83175114796055, -122.509437561035, -2.13819305020648, 218, 56, 'PPL', 'P'),
(136685, 'Manitou Junction', 47.5686111450195, 0.830228885081461, -91.2583312988281, -1.59275835104034, 218, 28, 'PPL', 'P'),
(71069, 'Manitou Park', 39.9722213745117, 0.697646872321283, -74.1841735839844, -1.29475808191153, 218, 37, 'PPL', 'P'),
(187024, 'Manitou Springs', 38.8597183227539, 0.678230031129624, -104.91667175293, -1.83114136232275, 218, 7, 'PPL', 'P'),
(175128, 'Manitowish', 46.1330604553223, 0.805173798966968, -90.0133285522461, -1.57102895391612, 218, 57, 'PPL', 'P'),
(175134, 'Manitowish Waters', 46.1349983215332, 0.805207621112812, -89.8874969482422, -1.56883277812318, 218, 57, 'PPL', 'P'),
(175130, 'Manitowoc', 44.0886116027832, 0.769491435101541, -87.6575012207031, -1.52991201037222, 218, 57, 'PPL', 'P'),
(175132, 'Manitowoc Rapids', 44.0991706848145, 0.769675725848975, -87.7008285522461, -1.53066821496375, 218, 57, 'PPL', 'P'),
(164171, 'Manitto Haven', 40.4238891601563, 0.705529962305972, -79.4322204589844, -1.38635377917928, 218, 45, 'PPL', 'P'),
(183069, 'Manix', 34.9819412231445, 0.610550053083004, -116.593330383301, -2.03493750105414, 218, 6, 'PPL', 'P'),
(183070, 'Mankas Corner', 38.2863883972168, 0.668223536228788, -122.105827331543, -2.13114872280711, 218, 6, 'PPL', 'P'),
(33184, 'Mankato', 39.7872200012207, 0.694417989236644, -98.209716796875, -1.71408291555665, 218, 20, 'PPL', 'P'),
(136687, 'Mankato', 44.1636085510254, 0.770800378777315, -93.9991683959961, -1.64059498264673, 218, 28, 'PPL', 'P'),
(73352, 'Manker (historical)', 38.589168548584, 0.673508046779832, -82.5127792358398, -1.44011967263662, 218, 41, 'PPL', 'P'),
(95978, 'Mankins', 33.7825012207031, 0.589615875860273, -98.7966690063477, -1.7243271641638, 218, 51, 'PPL', 'P'),
(95979, 'Mankins Mill', 32.6527786254883, 0.569898496939599, -99.0580596923828, -1.72888929226916, 218, 51, 'PPL', 'P'),
(88781, 'Mankinville', 35.791389465332, 0.624677590033657, -86.3566665649414, -1.50720816260513, 218, 50, 'PPL', 'P'),
(49186, 'Manklin Meadows', 38.3783302307129, 0.669828223943615, -75.158332824707, -1.31176036810087, 218, 25, 'PPL', 'P'),
(49183, 'Manklin Moorings', 38.3800010681152, 0.669857385557551, -75.1294403076172, -1.31125609854846, 218, 25, 'PPL', 'P'),
(128056, 'Manks Corner', 44.1738891601563, 0.770979809255759, -69.3338928222656, -1.2101047129734, 218, 26, 'PPL', 'P'),
(14168, 'Manley', 39.7777786254883, 0.694253206144195, -75.6999969482422, -1.32121419049649, 218, 10, 'PPL', 'P'),
(120491, 'Manley', 40.5838890075684, 0.708322486446002, -90.4255599975586, -1.57822374991707, 218, 18, 'PPL', 'P'),
(136690, 'Manley', 43.5902786254883, 0.760793883876479, -96.4308319091797, -1.6830355172524, 218, 28, 'PPL', 'P'),
(142341, 'Manley', 40.9197196960449, 0.714183837689157, -96.1655578613281, -1.67840561169729, 218, 35, 'PPL', 'P'),
(211978, 'Manley Hot Springs', 65.001106262207, 1.13448332171422, -150.633895874023, -2.62905744810801, 218, 1, 'PPL', 'P'),
(125311, 'Manleys Corner', 42.0416717529297, 0.733765595131319, -71.0583267211914, -1.24020176224266, 218, 23, 'PPL', 'P'),
(156308, 'Manleys Subdivision', 41.6019401550293, 0.726090830922902, -84.5555572509766, -1.47577287488811, 218, 41, 'PPL', 'P'),
(88782, 'Manleyville', 36.2236099243164, 0.632221260137415, -88.17138671875, -1.53888100429139, 218, 50, 'PPL', 'P'),
(120492, 'Manlius', 41.4563903808594, 0.723550508138102, -89.6688919067383, -1.56501740038748, 218, 18, 'PPL', 'P'),
(150513, 'Manlius', 43.0019416809082, 0.750525467082433, -75.9772186279297, -1.32605262156494, 218, 40, 'PPL', 'P'),
(183071, 'Manlove', 38.5541687011719, 0.672897184204795, -121.371109008789, -2.11832546900032, 218, 6, 'PPL', 'P'),
(66591, 'Manly', 35.1855583190918, 0.614103841820633, -79.371940612793, -1.38530169739064, 218, 33, 'PPL', 'P'),
(116702, 'Manly', 43.2872200012207, 0.755504513056445, -93.2019424438477, -1.62668076489939, 218, 16, 'PPL', 'P'),
(3971, 'Mann', 30.5930595397949, 0.533949617228083, -88.1438903808594, -1.53840110266295, 218, 2, 'PPL', 'P'),
(49184, 'Mann', 39.6977806091309, 0.692856977363694, -78.2783279418945, -1.36621455554194, 218, 25, 'PPL', 'P'),
(78668, 'Mann', 39.725830078125, 0.693346532951077, -78.2394409179688, -1.36553584893813, 218, 45, 'PPL', 'P'),
(156309, 'Mann', 41.5916709899902, 0.725911600181539, -80.6391677856445, -1.40741898392764, 218, 41, 'PPL', 'P'),
(175137, 'Mann', 44.7002792358398, 0.78016704922626, -90.2169418334961, -1.57458267607472, 218, 57, 'PPL', 'P'),
(191826, 'Mann', 31.4033298492432, 0.548091501959108, -103.519996643066, -1.80676478307499, 218, 51, 'PPL', 'P'),
(196979, 'Mann', 45.9708290100098, 0.802342326095996, -108.113059997559, -1.88692886136357, 218, 31, 'PPL', 'P'),
(196980, 'Mann (historical)', 47.2636108398438, 0.824905625536556, -110.72444152832, -1.93250606710113, 218, 31, 'PPL', 'P'),
(95980, 'Mann Crossing', 29.3058300018311, 0.511483223561688, -98.6616668701172, -1.72197093238935, 218, 51, 'PPL', 'P'),
(125312, 'Mann Hill Beach', 42.2227783203125, 0.736926501029134, -70.75, -1.23482044578599, 218, 23, 'PPL', 'P'),
(22844, 'Mann Manor', 33.8377799987793, 0.590580672544182, -84.7044372558594, -1.4783713211637, 218, 13, 'PPL', 'P'),
(60760, 'Mannassa', 31.9972190856934, 0.558456824527319, -88.5763931274414, -1.54594969961473, 218, 30, 'PPL', 'P'),
(103963, 'Mannboro', 37.2513885498047, 0.650159381133807, -77.8236083984375, -1.35827820233545, 218, 53, 'PPL', 'P'),
(76494, 'Mannford', 36.1333312988281, 0.63064560087847, -96.3541717529297, -1.68169754512074, 218, 42, 'PPL', 'P'),
(41965, 'Mannheim (historical)', 30.7083301544189, 0.535961468984069, -91.3138885498047, -1.59372800799324, 218, 22, 'PPL', 'P'),
(10288, 'Manning', 34.021110534668, 0.593780394014884, -92.7927780151367, -1.61953949843634, 218, 4, 'PPL', 'P'),
(17012, 'Manning', 30.1749992370605, 0.526653088473483, -82.1747207641602, -1.43421943924155, 218, 12, 'PPL', 'P'),
(82235, 'Manning', 33.6949996948242, 0.588088686133167, -80.2111129760742, -1.39994801812164, 218, 48, 'PPL', 'P'),
(95981, 'Manning', 31.1386108398438, 0.54347128365247, -94.5361099243164, -1.64996638020661, 218, 51, 'PPL', 'P'),
(103964, 'Manning', 36.7050018310547, 0.640623133902452, -76.6486129760742, -1.33777066351934, 218, 53, 'PPL', 'P'),
(116703, 'Manning', 41.9091682434082, 0.731452972619722, -95.0647201538086, -1.65919236917097, 218, 16, 'PPL', 'P'),
(131898, 'Manning', 45.5149993896484, 0.794386598392575, -84.3511123657227, -1.47220463850156, 218, 27, 'PPL', 'P'),
(150515, 'Manning', 43.1988906860352, 0.753962875680426, -78.0963897705078, -1.36303913541618, 218, 40, 'PPL', 'P'),
(187790, 'Manning', 38.5552787780762, 0.672916558701725, -100.72306060791, -1.75794904029383, 218, 20, 'PPL', 'P'),
(198575, 'Manning', 47.2299995422363, 0.824318997727439, -102.769721984863, -1.79367001999507, 218, 34, 'PPL', 'P'),
(201178, 'Manning', 45.6650009155273, 0.797004618902177, -123.162498474121, -2.14959111335591, 218, 43, 'PPL', 'P'),
(208006, 'Manning', 46.9322204589844, 0.819121772281122, -117.406669616699, -2.04913294861259, 218, 56, 'PPL', 'P'),
(22845, 'Manning (historical)', 32.6150016784668, 0.569239164832723, -82.772216796875, -1.44464771228002, 218, 13, 'PPL', 'P'),
(41966, 'Manning (historical)', 32.2625007629395, 0.563086863240476, -93.3525009155273, -1.62930850594697, 218, 22, 'PPL', 'P'),
(82236, 'Manning Acres', 34.9199981689453, 0.609468942838487, -82.1855621337891, -1.434408656837, 218, 48, 'PPL', 'P'),
(37041, 'Manning Crossing', 37.9958305358887, 0.663152344881059, -86.4811096191406, -1.50938010363214, 218, 21, 'PPL', 'P'),
(82237, 'Manning Crossroads', 34.473331451416, 0.601673137958525, -79.460563659668, -1.38684846135176, 218, 48, 'PPL', 'P'),
(103965, 'Manning Estates', 36.8038902282715, 0.642349062025905, -76.4369430541992, -1.33407632645519, 218, 53, 'PPL', 'P'),
(22852, 'Manning Farms', 33.9666709899902, 0.592830244716972, -84.3402786254883, -1.47201555406417, 218, 13, 'PPL', 'P'),
(66592, 'Manning Park', 35.0794410705566, 0.612251746440538, -77.1216735839844, -1.34602712868886, 218, 33, 'PPL', 'P'),
(3972, 'Manningham', 31.8858299255371, 0.556512716931561, -86.7463912963867, -1.5140101423453, 218, 2, 'PPL', 'P'),
(110270, 'Mannings', 39.2452812194824, 0.684959373151064, -77.7811126708984, -1.35753651197186, 218, 58, 'PPL', 'P'),
(150520, 'Mannings Cove', 43.019718170166, 0.750835725349427, -73.758056640625, -1.28732093825137, 218, 40, 'PPL', 'P'),
(37043, 'Mannington', 37.1277809143066, 0.648002020913762, -87.4877777099609, -1.52694977629172, 218, 21, 'PPL', 'P'),
(110269, 'Mannington', 39.5308303833008, 0.689943146236011, -80.3436126708984, -1.40226057405421, 218, 58, 'PPL', 'P'),
(71070, 'Mannington Mills', 39.5869407653809, 0.69092245714786, -75.454719543457, -1.31693329220224, 218, 37, 'PPL', 'P'),
(22846, 'Manningtown', 31.4130592346191, 0.548261311768114, -81.8586120605469, -1.42870230156928, 218, 13, 'PPL', 'P'),
(150516, 'Manningville', 42.3569412231445, 0.739268085417586, -76.0461120605469, -1.32725503879711, 218, 40, 'PPL', 'P'),
(196981, 'Mannix', 46.7747192382813, 0.816372857403942, -112.767219543457, -1.96815926935262, 218, 31, 'PPL', 'P'),
(120495, 'Mannon', 41.2311096191406, 0.719618617104709, -90.956672668457, -1.58749341472331, 218, 18, 'PPL', 'P'),
(164172, 'Manns Choice', 40.002498626709, 0.698175310060582, -78.5913925170898, -1.37167856315045, 218, 45, 'PPL', 'P'),
(125323, 'Manns Corner', 42.1438903808594, 0.735549646745563, -70.8680572509766, -1.23688093352138, 218, 23, 'PPL', 'P'),
(150517, 'Manns Corner', 43.0027809143066, 0.750540114468428, -77.666389465332, -1.35553421430628, 218, 40, 'PPL', 'P'),
(66594, 'Manns Harbor', 35.8855590820313, 0.626321159900399, -75.7630615234375, -1.32231487497502, 218, 33, 'PPL', 'P'),
(17013, 'Manns Spur', 30.2344398498535, 0.527690522876124, -82.3197174072266, -1.43675010806739, 218, 12, 'PPL', 'P'),
(60761, 'Mannsdale', 32.5233306884766, 0.56763920422883, -90.1916732788086, -1.5741416565982, 218, 30, 'PPL', 'P'),
(10289, 'Mannstown', 33.4766693115234, 0.584278102087427, -92.0494384765625, -1.60656577602797, 218, 4, 'PPL', 'P'),
(37044, 'Mannsville', 37.372501373291, 0.652273198670031, -85.1966705322266, -1.48696241252418, 218, 21, 'PPL', 'P'),
(76496, 'Mannsville', 34.1858291625977, 0.596655276411625, -96.8802795410156, -1.69087985824322, 218, 42, 'PPL', 'P'),
(150518, 'Mannsville', 43.7127799987793, 0.762931936178622, -76.0630569458008, -1.32755078283617, 218, 40, 'PPL', 'P'),
(164173, 'Mannsville', 40.4258308410645, 0.705563851030843, -77.267219543457, -1.34856738489464, 218, 45, 'PPL', 'P'),
(37045, 'Manntown', 36.8783302307129, 0.6436482851637, -85.1608276367188, -1.48633683598412, 218, 21, 'PPL', 'P'),
(17014, 'Mannville', 29.6286106109619, 0.517116807952614, -81.8683319091797, -1.42887194493072, 218, 12, 'PPL', 'P'),
(150519, 'Manny Corners', 42.9469413757324, 0.749565530667514, -74.1452789306641, -1.29407924214967, 218, 40, 'PPL', 'P'),
(56067, 'Mano', 36.5769386291504, 0.638388009378576, -93.6975021362305, -1.63532991317164, 218, 29, 'PPL', 'P'),
(78675, 'Manoa', 39.976390838623, 0.697719643198069, -75.3183288574219, -1.31455282566187, 218, 45, 'PPL', 'P'),
(49185, 'Manokin', 38.1152801513672, 0.6652371339614, -75.7561111450195, -1.32219356798736, 218, 25, 'PPL', 'P'),
(211979, 'Manokotak', 58.9813919067383, 1.02941948618172, -159.058334350586, -2.77609163715572, 218, 1, 'PPL', 'P'),
(183072, 'Manolith', 35.1205596923828, 0.612969401775287, -118.371940612793, -2.06598010566843, 218, 6, 'PPL', 'P'),
(125313, 'Manomet', 41.9186096191406, 0.73161775571217, -70.5666732788086, -1.23162079089431, 218, 23, 'PPL', 'P'),
(125314, 'Manomet Beach', 41.892219543457, 0.731157162001641, -70.5347213745117, -1.23106312496205, 218, 23, 'PPL', 'P'),
(125315, 'Manomet Bluffs', 41.9124984741211, 0.731511096110512, -70.5486068725586, -1.23130547262125, 218, 23, 'PPL', 'P'),
(125316, 'Manomet Heights', 41.9249992370605, 0.731729275582817, -70.5541687011719, -1.23140254484298, 218, 23, 'PPL', 'P'),
(22847, 'Manor', 31.103609085083, 0.54286038778792, -82.5733337402344, -1.44117654811521, 218, 13, 'PPL', 'P'),
(49188, 'Manor', 39.5572204589844, 0.69040373994654, -76.5650024414063, -1.33631138440004, 218, 25, 'PPL', 'P'),
(95982, 'Manor', 30.3405609130859, 0.529542684835247, -97.5566711425781, -1.70268511872333, 218, 51, 'PPL', 'P'),
(164176, 'Manor', 40.6324996948242, 0.709170902990274, -78.98388671875, -1.37852887926441, 218, 45, 'PPL', 'P'),
(183073, 'Manor', 37.9908294677734, 0.663065059776331, -122.589721679688, -2.13959427241402, 218, 6, 'PPL', 'P'),
(73353, 'Manor (historical)', 39.5894393920898, 0.69096606641071, -84.1430587768555, -1.46857341835524, 218, 41, 'PPL', 'P'),
(164175, 'Manor Acres', 40.3408317565918, 0.704080337145615, -76.7233276367188, -1.3390746803471, 218, 45, 'PPL', 'P'),
(49187, 'Manor Brook', 39.5741691589355, 0.69069955056462, -76.6044387817383, -1.33699967838377, 218, 25, 'PPL', 'P'),
(37046, 'Manor Creek', 38.297779083252, 0.668422341204162, -85.6213912963867, -1.49437518826036, 218, 21, 'PPL', 'P'),
(49196, 'Manor Fields', 39.5097198486328, 0.689574697899198, -76.5272216796875, -1.33565198571413, 218, 25, 'PPL', 'P'),
(49189, 'Manor Glade', 39.5230598449707, 0.689807524757498, -76.5347213745117, -1.33578288008171, 218, 25, 'PPL', 'P'),
(49190, 'Manor Glen', 39.5277786254883, 0.689889883014209, -76.5425033569336, -1.3359187012973, 218, 25, 'PPL', 'P'),
(49191, 'Manor Heights', 39.6080589294434, 0.691291038642727, -76.0783309936523, -1.32781736526128, 218, 25, 'PPL', 'P'),
(164177, 'Manor Heights', 40.7513885498047, 0.711245904953609, -79.5299987792969, -1.3880603328058, 218, 45, 'PPL', 'P'),
(49192, 'Manor Hill', 39.4663887023926, 0.688818426728643, -76.5341720581055, -1.33577329270179, 218, 25, 'PPL', 'P'),
(164178, 'Manor Hill', 40.6186103820801, 0.708928488752049, -77.9211120605469, -1.35997996227201, 218, 45, 'PPL', 'P'),
(49193, 'Manor Oaks', 39.4997215270996, 0.689400194268771, -76.5338897705078, -1.33576836585377, 218, 25, 'PPL', 'P'),
(13152, 'Manor Park', 38.9638900756836, 0.680048171205821, -77.01611328125, -1.34418475384675, 218, 9, 'PPL', 'P'),
(14169, 'Manor Park', 39.6875, 0.69267754688525, -75.595832824707, -1.31939618357834, 218, 10, 'PPL', 'P'),
(49194, 'Manor Park', 39.0972213745117, 0.682375241366333, -77.0830612182617, -1.34535321577502, 218, 25, 'PPL', 'P'),
(14170, 'Manor Park Apartments', 39.6913909912109, 0.692745457493047, -75.5822219848633, -1.31915862960911, 218, 10, 'PPL', 'P'),
(49195, 'Manor Ridge', 39.5083312988281, 0.689550463133279, -76.5408325195313, -1.33588953968337, 218, 25, 'PPL', 'P'),
(164179, 'Manor Ridge', 40.0380592346191, 0.698795959752625, -76.3663864135742, -1.33284488076713, 218, 45, 'PPL', 'P'),
(49205, 'Manor Springs', 39.4513893127441, 0.688556637993488, -76.5261077880859, -1.33563254463817, 218, 25, 'PPL', 'P'),
(49197, 'Manor View', 39.4599990844727, 0.688706906857996, -76.5266723632813, -1.33564239833421, 218, 25, 'PPL', 'P'),
(49198, 'Manor View Farms', 39.5522193908691, 0.690316454841813, -76.5638885498047, -1.33629194332408, 218, 25, 'PPL', 'P'),
(49199, 'Manor Village', 39.3147201538086, 0.686171311184131, -77.480827331543, -1.35229554410464, 218, 25, 'PPL', 'P'),
(49200, 'Manor Woods', 39.4447212219238, 0.688440257853852, -76.5269393920898, -1.33564705886612, 218, 25, 'PPL', 'P'),
(123128, 'Manor Woods', 41.0252799987793, 0.716026212531274, -85.2622222900391, -1.48810650652848, 218, 19, 'PPL', 'P'),
(150521, 'Manorhaven', 40.8430595397949, 0.712845865557501, -73.7152786254883, -1.28657432103977, 218, 40, 'PPL', 'P'),
(150522, 'Manorkill', 42.3894386291504, 0.739835272150746, -74.3225021362305, -1.29717237059774, 218, 40, 'PPL', 'P'),
(150523, 'Manorton', 42.0924987792969, 0.734652694090424, -73.7986068725586, -1.28802867331106, 218, 40, 'PPL', 'P'),
(150525, 'Manorville', 42.142219543457, 0.735520485131627, -74.0363922119141, -1.29217881039579, 218, 40, 'PPL', 'P'),
(164182, 'Manorville', 40.7872200012207, 0.711871281756587, -79.5199966430664, -1.38788576259635, 218, 45, 'PPL', 'P'),
(110271, 'Manown', 39.4927787780762, 0.689279020439172, -79.7452774047852, -1.39181765362974, 218, 58, 'PPL', 'P'),
(164184, 'Manown', 40.1977806091309, 0.701583623623665, -79.9044418334961, -1.3945955969628, 218, 45, 'PPL', 'P'),
(103967, 'Manquin', 37.7099990844727, 0.658163644948095, -77.1530609130859, -1.34657494092509, 218, 53, 'PPL', 'P'),
(49201, 'Manresa', 39.0063896179199, 0.680789928148436, -76.4905624389648, -1.33501216126224, 218, 25, 'PPL', 'P'),
(88783, 'Manring', 36.5583305358887, 0.63806323688364, -83.8138885498047, -1.46282831409367, 218, 50, 'PPL', 'P'),
(103968, 'Manry', 36.8916702270508, 0.643881112022, -77.0350036621094, -1.3445144531897, 218, 53, 'PPL', 'P'),
(37047, 'Manse', 37.5877799987793, 0.656030519493969, -84.4377822875977, -1.47371731400073, 218, 21, 'PPL', 'P'),
(190451, 'Manse', 36.1547203063965, 0.631018909484272, -115.901390075684, -2.02286086445896, 218, 39, 'PPL', 'P'),
(128057, 'Manset', 44.2680587768555, 0.772623379122502, -68.3133316040039, -1.19229255949657, 218, 26, 'PPL', 'P'),
(3975, 'Mansfield', 33.8541717529297, 0.590866762624283, -87.9741668701172, -1.53543886858246, 218, 2, 'PPL', 'P'),
(10290, 'Mansfield', 35.059440612793, 0.611902672600656, -94.2525024414063, -1.64501649584653, 218, 4, 'PPL', 'P'),
(22849, 'Mansfield', 33.5177803039551, 0.584995624264122, -83.7344436645508, -1.46144173927212, 218, 13, 'PPL', 'P'),
(30416, 'Mansfield', 39.6763916015625, 0.692483668757892, -87.1022186279297, -1.52022050084931, 218, 19, 'PPL', 'P'),
(41967, 'Mansfield', 32.0374984741211, 0.559159832476072, -93.6999969482422, -1.63537345585546, 218, 22, 'PPL', 'P'),
(56068, 'Mansfield', 37.1066703796387, 0.647633572576949, -92.5805587768555, -1.61583557399226, 218, 29, 'PPL', 'P'),
(66599, 'Mansfield', 34.7322196960449, 0.606191590222008, -76.7866668701172, -1.34018015851559, 218, 33, 'PPL', 'P'),
(88784, 'Mansfield', 36.1772193908691, 0.631411592587004, -88.2861099243164, -1.54088330195696, 218, 50, 'PPL', 'P'),
(95983, 'Mansfield', 32.563060760498, 0.56833262479766, -97.1413879394531, -1.69543705950057, 218, 51, 'PPL', 'P'),
(103969, 'Mansfield', 37.2163887023926, 0.649548518558771, -77.4899978637695, -1.35245560008615, 218, 53, 'PPL', 'P'),
(110272, 'Mansfield', 39.1500015258789, 0.683296428787391, -80.0538864135742, -1.39720389693443, 218, 58, 'PPL', 'P'),
(120496, 'Mansfield', 40.2113914489746, 0.7018211775929, -88.5061111450195, -1.54472304761664, 218, 18, 'PPL', 'P'),
(125317, 'Mansfield', 42.0333290100098, 0.733619986798719, -71.2194366455078, -1.24301366087962, 218, 23, 'PPL', 'P'),
(131899, 'Mansfield', 46.0875015258789, 0.804378645644498, -88.1486129760742, -1.53848352749869, 218, 27, 'PPL', 'P'),
(136691, 'Mansfield', 43.5724983215332, 0.760483559030457, -93.6086120605469, -1.63377848867862, 218, 28, 'PPL', 'P'),
(145683, 'Mansfield', 40.0911102294922, 0.699721874284618, -74.7141723632813, -1.30400830564181, 218, 37, 'PPL', 'P'),
(156310, 'Mansfield', 40.7583312988281, 0.711367078783208, -82.5155563354492, -1.44016814216846, 218, 41, 'PPL', 'P'),
(164185, 'Mansfield', 41.8072204589844, 0.729673648116412, -77.0777816772461, -1.3452610704013, 218, 45, 'PPL', 'P'),
(170820, 'Mansfield', 45.2430610656738, 0.789640379276863, -98.5625, -1.72024014399691, 218, 49, 'PPL', 'P'),
(187791, 'Mansfield', 37.922779083252, 0.661877356509183, -100.766670227051, -1.75871017173338, 218, 20, 'PPL', 'P'),
(208009, 'Mansfield', 47.8116683959961, 0.834471034381848, -119.635559082031, -2.08803440844565, 218, 56, 'PPL', 'P'),
(103970, 'Mansfield (historical)', 38.0900001525879, 0.664795914747801, -77.9127807617188, -1.35983455367649, 218, 53, 'PPL', 'P'),
(113672, 'Mansfield Center', 41.7652816772461, 0.728941678290804, -72.1986083984375, -1.26010343191076, 218, 8, 'PPL', 'P'),
(113673, 'Mansfield City', 41.7658309936523, 0.728951265670728, -72.2341690063477, -1.26072408160281, 218, 8, 'PPL', 'P'),
(113674, 'Mansfield Depot', 41.8013916015625, 0.729571915362771, -72.3069381713867, -1.26199414312667, 218, 8, 'PPL', 'P'),
(22850, 'Mansfield Estates', 33.5169410705566, 0.584980976878126, -83.7505569458008, -1.46172296908323, 218, 13, 'PPL', 'P'),
(113675, 'Mansfield Four Corners', 41.827220916748, 0.730022721956294, -72.2666702270508, -1.26129133491499, 218, 8, 'PPL', 'P'),
(88785, 'Mansfield Gap', 36.1069412231445, 0.630185007167941, -83.379997253418, -1.45525548237597, 218, 50, 'PPL', 'P'),
(103971, 'Mansfield Hall', 38.2649993896484, 0.667850227622986, -77.4266662597656, -1.35135025507571, 218, 53, 'PPL', 'P'),
(113676, 'Mansfield Hollow', 41.7574996948242, 0.72880585707521, -72.186393737793, -1.2598902458655, 218, 8, 'PPL', 'P'),
(131900, 'Mansfield Location', 46.1191711425781, 0.804931384728743, -88.2194366455078, -1.53971963371865, 218, 27, 'PPL', 'P'),
(82238, 'Mansfield Park', 34.8525009155273, 0.60829089353029, -82.4466705322266, -1.43896585809434, 218, 48, 'PPL', 'P'),
(145684, 'Mansfield Square', 40.1161117553711, 0.700158233229228, -74.7061080932617, -1.3038675575782, 218, 37, 'PPL', 'P'),
(49202, 'Mansfield Woods', 39.3074989318848, 0.686045277085543, -76.4472198486328, -1.3342556903546, 218, 25, 'PPL', 'P'),
(41968, 'Mansford', 32.4652786254883, 0.56662600459211, -91.144172668457, -1.5907659070708, 218, 22, 'PPL', 'P'),
(208007, 'Mansford', 48.3074989318848, 0.843124909765033, -121.521667480469, -2.1209532100479, 218, 56, 'PPL', 'P'),
(88786, 'Mansford (historical)', 35.1963882446289, 0.614292859679002, -86.2436065673828, -1.50523489339543, 218, 50, 'PPL', 'P'),
(49203, 'Mansion House Manor', 39.1283302307129, 0.682918193333572, -76.5374984741211, -1.33583134961355, 218, 25, 'PPL', 'P'),
(3976, 'Mansion View', 34.8622207641602, 0.608460536891728, -87.7286071777344, -1.5311530434402, 218, 2, 'PPL', 'P'),
(10293, 'Manson', 36.1941719055176, 0.631707469784112, -90.9625015258789, -1.58759514747695, 218, 4, 'PPL', 'P'),
(66596, 'Manson', 36.4216690063477, 0.635678043232338, -78.283332824707, -1.36630190722569, 218, 33, 'PPL', 'P'),
(88787, 'Manson', 36.3972206115723, 0.63525133824668, -85.0833282470703, -1.48498421646647, 218, 50, 'PPL', 'P'),
(112595, 'Manson', 28.9925003051758, 0.506014588710778, -96.6155624389648, -1.6862596732261, 218, 51, 'PPL', 'P'),
(116705, 'Manson', 42.5291709899902, 0.742274061918986, -94.5338897705078, -1.64992763121275, 218, 16, 'PPL', 'P'),
(123129, 'Manson', 40.2400016784668, 0.70232052029729, -86.5902786254883, -1.51128546223404, 218, 19, 'PPL', 'P'),
(195283, 'Manson', 42.5697212219238, 0.742981796978675, -111.498062133789, -1.94600829382783, 218, 17, 'PPL', 'P'),
(196982, 'Manson', 48.2374992370605, 0.841903184614959, -112.005561828613, -1.95486583445538, 218, 31, 'PPL', 'P'),
(208008, 'Manson', 47.8849983215332, 0.835750883022713, -120.157218933105, -2.09713909042236, 218, 56, 'PPL', 'P'),
(22851, 'Manson (historical)', 31.3402805328369, 0.546991083796687, -81.9780578613281, -1.4307870240706, 218, 13, 'PPL', 'P'),
(175138, 'Manson (historical)', 45.5666694641113, 0.795288411316703, -89.6613922119141, -1.5648865060199, 218, 57, 'PPL', 'P'),
(125320, 'Manson Corner', 42.2013893127441, 0.736553192423332, -70.7838897705078, -1.23541193386409, 218, 23, 'PPL', 'P'),
(128058, 'Manson Corner', 44.8622207641602, 0.782993462091161, -69.4747161865234, -1.21256254434343, 218, 26, 'PPL', 'P'),
(88788, 'Manson Manor', 35.8474998474121, 0.625656900945506, -86.4502792358398, -1.50884201193389, 218, 50, 'PPL', 'P'),
(88789, 'Manson Park', 35.8697204589844, 0.626044723779249, -86.4583282470703, -1.50898249368139, 218, 50, 'PPL', 'P'),
(41969, 'Mansura', 31.0577793121338, 0.542060507354514, -92.0488891601563, -1.60655618864804, 218, 22, 'PPL', 'P'),
(164187, 'Mansville', 40.1775016784668, 0.701229689514794, -79.3255615234375, -1.38449222957731, 218, 45, 'PPL', 'P'),
(10291, 'Mansville (historical)', 34.0483283996582, 0.594255435374327, -92.4100036621094, -1.61285882568383, 218, 4, 'PPL', 'P'),
(22853, 'Manta', 32.285831451416, 0.563494060571149, -84.7136077880859, -1.47853137714521, 218, 13, 'PPL', 'P'),
(60762, 'Mantachie', 34.3241691589355, 0.599069764834918, -88.4911117553711, -1.54446125888148, 218, 30, 'PPL', 'P'),
(140446, 'Mantador', 46.1652793884277, 0.805736125431138, -96.976936340332, -1.69256683763573, 218, 34, 'PPL', 'P'),
(103972, 'Mantapike', 37.6963882446289, 0.65792609097886, -76.9211120605469, -1.34252666975206, 218, 53, 'PPL', 'P'),
(10292, 'Mante (historical)', 36.084171295166, 0.629787596954274, -93.8111114501953, -1.63731276976126, 218, 4, 'PPL', 'P'),
(183074, 'Manteca', 37.7975006103516, 0.659690834675201, -121.214996337891, -2.11560078888906, 218, 6, 'PPL', 'P'),
(183075, 'Manteca Junction', 37.8636093139648, 0.660844649217478, -121.227783203125, -2.11582396178841, 218, 6, 'PPL', 'P'),
(60763, 'Mantee', 33.7313919067383, 0.588723850053151, -89.0552825927734, -1.55430789753789, 218, 30, 'PPL', 'P'),
(116706, 'Manteno', 41.8325004577637, 0.730114867330011, -95.5369415283203, -1.66743418695449, 218, 16, 'PPL', 'P'),
(120497, 'Manteno', 41.250560760498, 0.719958103564667, -87.8313903808594, -1.53294694875047, 218, 18, 'PPL', 'P'),
(66597, 'Manteo', 35.9080581665039, 0.626713843003131, -75.6761093139648, -1.32079727262783, 218, 33, 'PPL', 'P'),
(103973, 'Manteo', 37.6766700744629, 0.657581943986995, -78.6636123657227, -1.37293903729439, 218, 53, 'PPL', 'P'),
(187792, 'Manter', 37.5230598449707, 0.654900939717612, -101.884437561035, -1.77821889198264, 218, 20, 'PPL', 'P'),
(33185, 'Mantey', 38.0522193908691, 0.664136516061898, -94.8055572509766, -1.65466912321753, 218, 20, 'PPL', 'P'),
(192686, 'Manti', 39.2683296203613, 0.68536164363372, -111.636108398438, -1.94841765566603, 218, 52, 'PPL', 'P'),
(192687, 'Manti Canyon Summer Homes', 39.2561111450195, 0.685148391009432, -111.520561218262, -1.94640097693057, 218, 52, 'PPL', 'P'),
(145687, 'Mantoloking', 40.0391693115234, 0.698815334249555, -74.0502777099609, -1.29242115805498, 218, 37, 'PPL', 'P'),
(145688, 'Mantoloking Estates', 40.0069389343262, 0.698252808048303, -74.0630569458008, -1.29264419779628, 218, 37, 'PPL', 'P'),
(145689, 'Mantoloking Shores', 40.0180587768555, 0.698446885912743, -74.0583267211914, -1.29256163980249, 218, 37, 'PPL', 'P'),
(37048, 'Manton', 37.7147216796875, 0.658246069783833, -85.3852767944336, -1.49025421278958, 218, 21, 'PPL', 'P'),
(131902, 'Manton', 44.410831451416, 0.775115232375462, -85.3988876342773, -1.49049176675881, 218, 27, 'PPL', 'P'),
(169475, 'Manton', 41.8363914489746, 0.730182777937808, -71.4688873291016, -1.24736739662968, 218, 47, 'PPL', 'P'),
(193761, 'Manton', 40.4352798461914, 0.705728767281346, -121.86888885498, -2.12701336626643, 218, 6, 'PPL', 'P'),
(136694, 'Mantorville', 44.0691719055176, 0.769152148378665, -92.7555618286133, -1.61888995344647, 218, 28, 'PPL', 'P'),
(95984, 'Mantu', 29.7975006103516, 0.520064494515655, -95.0899963378906, -1.65963352180554, 218, 51, 'PPL', 'P'),
(3977, 'Mantua', 33.0536117553711, 0.576894354807128, -87.9288864135742, -1.53464857552898, 218, 2, 'PPL', 'P'),
(49204, 'Mantua', 39.5050010681152, 0.689492339642488, -76.7444381713867, -1.33944312868391, 218, 25, 'PPL', 'P'),
(71072, 'Mantua', 39.7938919067383, 0.694534435955307, -75.1725006103516, -1.31200764260808, 218, 37, 'PPL', 'P'),
(103974, 'Mantua', 38.8536109924316, 0.678123438106994, -77.2597198486328, -1.34843649052706, 218, 53, 'PPL', 'P'),
(156313, 'Mantua', 41.2838897705078, 0.720539804525767, -81.2241668701172, -1.41762914407284, 218, 41, 'PPL', 'P'),
(204797, 'Mantua', 41.4958305358887, 0.72423886870086, -111.943061828613, -1.95377500367289, 218, 52, 'PPL', 'P'),
(156314, 'Mantua Center', 41.3097190856934, 0.720990611119291, -81.245002746582, -1.41799279871969, 218, 41, 'PPL', 'P'),
(156315, 'Mantua Corners', 41.3102798461914, 0.721000398236297, -81.2213897705078, -1.417580674541, 218, 41, 'PPL', 'P'),
(71075, 'Mantua Grove', 39.8175010681152, 0.69494649355497, -75.1941680908203, -1.31238581148287, 218, 37, 'PPL', 'P'),
(103975, 'Mantua Hills', 38.8544387817383, 0.678137885755907, -77.2666702270508, -1.34855779751471, 218, 53, 'PPL', 'P'),
(204794, 'Mantyla', 40.6611099243164, 0.709670245694664, -111.924171447754, -1.95344530432993, 218, 52, 'PPL', 'P'),
(125321, 'Mantyranta', 42.538890838623, 0.742443705280424, -71.8824996948242, -1.2545862942385, 218, 23, 'PPL', 'P'),
(164188, 'Mantz', 40.7322196960449, 0.710911345341668, -75.8300018310547, -1.32348320374523, 218, 45, 'PPL', 'P'),
(164189, 'Mantzville', 40.7677803039551, 0.711531995033711, -75.8702774047852, -1.32418614511496, 218, 45, 'PPL', 'P'),
(544, 'Manuel', 37.3505592346191, 0.651890236105277, -83.3047180175781, -1.45394161185218, 218, 21, 'PPL', 'P'),
(95985, 'Manuel Garcia Colonia', 26.3330001831055, 0.45959755512346, -98.7020034790039, -1.72267493902352, 218, 51, 'PPL', 'P'),
(95986, 'Manuel Garcia Number 2 Colonia', 26.3129997253418, 0.459248481283578, -98.6910018920898, -1.72248292510892, 218, 51, 'PPL', 'P'),
(95987, 'Manuel Medina Addition Colonia', 26.9209995269775, 0.469860079673594, -99.2590026855469, -1.73239640910869, 218, 51, 'PPL', 'P'),
(183077, 'Manuel Mill', 38.2611083984375, 0.667782317015189, -120.360000610352, -2.10067829835302, 218, 6, 'PPL', 'P'),
(95988, 'Manuel Munoz Colonia', 26.4060001373291, 0.460871644678468, -98.9830017089844, -1.72757928332895, 218, 51, 'PPL', 'P'),
(188973, 'Manuelitas', 35.8005599975586, 0.624837646015171, -105.278060913086, -1.8374487930485, 218, 38, 'PPL', 'P'),
(188974, 'Manuelito', 35.4219398498535, 0.61822947782333, -108.99333190918, -1.90229250453418, 218, 38, 'PPL', 'P'),
(188975, 'Manuelito Place', 34.1436080932617, 0.595918379738, -108.776107788086, -1.89850122840635, 218, 38, 'PPL', 'P'),
(210668, 'ManukÃƒÂ¤ (historical)', 19.0811100006104, 0.333028194445868, -155.902786254883, -2.72101693318066, 218, 15, 'PPL', 'P'),
(71074, 'Manumuskin', 39.3349990844727, 0.686525245293003, -74.9613876342773, -1.3083230260819, 218, 37, 'PPL', 'P'),
(145691, 'Manunka Chunk', 40.8613891601563, 0.713165777783447, -75.0486068725586, -1.30984528896099, 218, 37, 'PPL', 'P'),
(88790, 'Manus Town (historical)', 35.7808303833008, 0.624493299286223, -86.0055618286133, -1.50108022893686, 218, 50, 'PPL', 'P'),
(95989, 'Manvel', 29.4624996185303, 0.514217624210927, -95.357780456543, -1.66430723636058, 218, 51, 'PPL', 'P'),
(140448, 'Manvel', 48.0777816772461, 0.839115587322946, -97.1761093139648, -1.69604306180661, 218, 34, 'PPL', 'P'),
(30417, 'Manville', 38.7877807617188, 0.676974483833706, -85.2855606079102, -1.48851383701721, 218, 19, 'PPL', 'P'),
(82239, 'Manville', 34.1538887023926, 0.596097810216444, -80.3036117553711, -1.40156242637445, 218, 48, 'PPL', 'P'),
(103978, 'Manville', 36.672779083252, 0.640060740859254, -82.6416702270508, -1.44236924480941, 218, 53, 'PPL', 'P'),
(120499, 'Manville', 41.0550003051758, 0.716544929732594, -88.76611328125, -1.54926094095608, 218, 18, 'PPL', 'P'),
(145692, 'Manville', 40.540828704834, 0.707570942386381, -74.5880584716797, -1.30180720300086, 218, 37, 'PPL', 'P'),
(169476, 'Manville', 41.9697189331055, 0.732509781519292, -71.4741668701172, -1.2474595420034, 218, 47, 'PPL', 'P'),
(209587, 'Manville', 42.7791709899902, 0.746637385048972, -104.617218017578, -1.82591490868347, 218, 59, 'PPL', 'P'),
(103977, 'Manwaring Manor', 37.2088890075684, 0.649417624191193, -80.0119400024414, -1.39647179395076, 218, 53, 'PPL', 'P'),
(41970, 'Many', 31.5686092376709, 0.550976171472854, -93.48388671875, -1.63160162080359, 218, 22, 'PPL', 'P'),
(178586, 'Many Farms', 36.3527793884277, 0.634475692579195, -109.617218017578, -1.91318137128319, 218, 5, 'PPL', 'P'),
(10296, 'Many Islands', 36.3888893127441, 0.635105929651162, -91.529167175293, -1.59748532881718, 218, 4, 'PPL', 'P'),
(183076, 'Manzana', 38.4449996948242, 0.670991825602898, -122.870826721191, -2.14450048093222, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(183078, 'Manzanar', 36.7400016784668, 0.641233996477489, -118.079719543457, -2.06087988586482, 218, 6, 'PPL', 'P'),
(183080, 'Manzanita', 32.6688919067383, 0.570179726750711, -116.288887023926, -2.02962396204721, 218, 6, 'PPL', 'P'),
(201179, 'Manzanita', 45.7186088562012, 0.797940253972149, -123.933891296387, -2.16305445793069, 218, 43, 'PPL', 'P'),
(208011, 'Manzanita', 47.6763916015625, 0.832110008917438, -122.558326721191, -2.13904632701974, 218, 56, 'PPL', 'P'),
(183081, 'Manzanita Acres', 38.7380599975586, 0.676106692792504, -121.049438476563, -2.11271125910632, 218, 6, 'PPL', 'P'),
(193762, 'Manzanita Lake', 40.5355606079102, 0.707478996749746, -121.559722900391, -2.12161740242377, 218, 6, 'PPL', 'P'),
(192934, 'Manzano', 34.646671295166, 0.604698488956855, -106.344436645508, -1.85606056064263, 218, 38, 'PPL', 'P'),
(187026, 'Manzanola', 38.1094398498535, 0.665135201470677, -103.865562438965, -1.81279604399569, 218, 7, 'PPL', 'P'),
(178587, 'Manzoro', 32.0447196960449, 0.55928586657466, -109.970283508301, -1.91934352657147, 218, 5, 'PPL', 'P'),
(56069, 'Mapaville', 38.2488899230957, 0.667569064390901, -90.4833297729492, -1.57923202270578, 218, 29, 'PPL', 'P'),
(140450, 'Mapes', 48.0311088562012, 0.838300992924518, -98.226936340332, -1.71438345328566, 218, 34, 'PPL', 'P'),
(150527, 'Mapes', 42.0483283996582, 0.733881775533874, -77.9327774047852, -1.36018356093734, 218, 40, 'PPL', 'P'),
(10294, 'Maple', 36.4347190856934, 0.635905810084567, -93.4972229003906, -1.63183438108286, 218, 4, 'PPL', 'P'),
(27792, 'Maple', 38.860279083252, 0.67823981824663, -89.8763885498047, -1.56863889999582, 218, 18, 'PPL', 'P'),
(37049, 'Maple', 37.464168548584, 0.653873092694896, -85.5022201538086, -1.49229525944901, 218, 21, 'PPL', 'P'),
(66600, 'Maple', 36.4147186279297, 0.635556736244685, -76.0044403076172, -1.32652772950341, 218, 33, 'PPL', 'P'),
(73354, 'Maple', 38.9033317565918, 0.678991229148196, -84.0355606079102, -1.46669722136728, 218, 41, 'PPL', 'P'),
(76497, 'Maple', 35.4713897705078, 0.619092541753597, -94.6263885498047, -1.65154203946555, 218, 42, 'PPL', 'P'),
(82240, 'Maple', 34.9294395446777, 0.609633725930935, -82.2369384765625, -1.43530534317603, 218, 48, 'PPL', 'P'),
(110273, 'Maple', 39.709171295166, 0.693055782339068, -80.3586120605469, -1.40252236278937, 218, 58, 'PPL', 'P'),
(136700, 'Maple', 47.4580612182617, 0.828299424871698, -91.1516723632813, -1.59089680143838, 218, 28, 'PPL', 'P'),
(175139, 'Maple', 46.5897216796875, 0.81314404089833, -91.7205581665039, -1.60082573177247, 218, 57, 'PPL', 'P'),
(191828, 'Maple', 33.8486099243164, 0.59076969040255, -102.898063659668, -1.79591000478793, 218, 51, 'PPL', 'P'),
(110274, 'Maple Acre', 37.3241691589355, 0.651429642394748, -81.1386108398438, -1.41613590964963, 218, 58, 'PPL', 'P'),
(136701, 'Maple Bay', 47.6358299255371, 0.831402074120668, -96.2247161865234, -1.67943811925192, 218, 28, 'PPL', 'P'),
(131903, 'Maple Beach', 42.0533294677734, 0.733969060638601, -83.1869430541992, -1.4518860509648, 218, 27, 'PPL', 'P'),
(150528, 'Maple Beach', 42.7350006103516, 0.745866466492421, -77.7241668701172, -1.35654262025304, 218, 40, 'PPL', 'P'),
(164190, 'Maple Beach', 40.086109161377, 0.699634589179891, -74.8691711425781, -1.30671354467711, 218, 45, 'PPL', 'P'),
(175140, 'Maple Beach', 42.8419418334961, 0.747732942942403, -89.0036087036133, -1.55340601803473, 218, 57, 'PPL', 'P'),
(208012, 'Maple Beach', 49.0008316040039, 0.855225847705162, -123.036109924316, -2.14738521702499, 218, 56, 'PPL', 'P'),
(175141, 'Maple Bluff', 43.1183280944824, 0.752556793203891, -89.3794403076172, -1.55996551695765, 218, 57, 'PPL', 'P'),
(33186, 'Maple City', 37.0558280944824, 0.646746207301735, -96.7680587768555, -1.68892123641952, 218, 20, 'PPL', 'P'),
(131904, 'Maple City', 44.8555603027344, 0.782877215109579, -85.855827331543, -1.49846686895916, 218, 27, 'PPL', 'P'),
(204799, 'Maple City', 40.771671295166, 0.711599905641508, -111.735000610352, -1.95014365036851, 218, 52, 'PPL', 'P'),
(10295, 'Maple Corner', 34.5552787780762, 0.603103388621952, -90.8583297729492, -1.58577700740076, 218, 4, 'PPL', 'P'),
(73355, 'Maple Corner', 39.6083297729492, 0.691295765753662, -83.9066696166992, -1.46444764919449, 218, 41, 'PPL', 'P'),
(172228, 'Maple Corner', 44.3758316040039, 0.774504369800425, -72.4952774047852, -1.26528128286015, 218, 55, 'PPL', 'P'),
(22854, 'Maple Creek', 33.4977798461914, 0.58464655042424, -82.1661071777344, -1.43406910379801, 218, 13, 'PPL', 'P'),
(193763, 'Maple Creek', 40.7625007629395, 0.711439849659994, -123.868057250977, -2.16190543707838, 218, 6, 'PPL', 'P'),
(88796, 'Maple Creek (historical)', 35.8769416809082, 0.626170757877837, -88.2463912963867, -1.54019008112522, 218, 50, 'PPL', 'P'),
(49209, 'Maple Crest', 39.5394401550293, 0.690093415100518, -76.9847183227539, -1.34363680845246, 218, 25, 'PPL', 'P'),
(95991, 'Maple Crest Acres', 30.1350002288818, 0.525954974083233, -93.9811096191406, -1.64027979753172, 218, 51, 'PPL', 'P'),
(82242, 'Maple Crossroads', 33.913330078125, 0.591899270178907, -79.0144424438477, -1.3790621772727, 218, 48, 'PPL', 'P'),
(208013, 'Maple Falls', 48.9244384765625, 0.853892536105414, -122.075828552246, -2.1306251453368, 218, 56, 'PPL', 'P'),
(150529, 'Maple Flats', 43.2702789306641, 0.755208835596419, -75.8552780151367, -1.3239243563798, 218, 40, 'PPL', 'P'),
(22858, 'Maple Forge', 34.2619400024414, 0.597983661163357, -83.8772201538086, -1.4639336591041, 218, 13, 'PPL', 'P'),
(110275, 'Maple Fork', 37.8711090087891, 0.660975543585055, -81.230827331543, -1.41774539105442, 218, 58, 'PPL', 'P'),
(3978, 'Maple Forks', 34.2125015258789, 0.597120796970171, -87.0244369506836, -1.51886295448364, 218, 2, 'PPL', 'P'),
(150530, 'Maple Glen', 41.5083312988281, 0.724457048173165, -74.4658279418945, -1.29967387780965, 218, 40, 'PPL', 'P'),
(164202, 'Maple Glen', 40.1791687011719, 0.701258784549703, -75.1808319091797, -1.3121530512036, 218, 45, 'PPL', 'P'),
(3979, 'Maple Grove', 34.1202812194824, 0.595511248986354, -85.7694396972656, -1.49695912030801, 218, 2, 'PPL', 'P'),
(10297, 'Maple Grove', 35.6419410705566, 0.622069223483006, -90.5541687011719, -1.58046839524185, 218, 4, 'PPL', 'P'),
(22856, 'Maple Grove', 34.9102783203125, 0.609299299477049, -84.1711120605469, -1.46906304052165, 218, 13, 'PPL', 'P'),
(27797, 'Maple Grove', 38.5333290100098, 0.672533462978917, -88.0938873291016, -1.53752838477374, 218, 18, 'PPL', 'P'),
(37050, 'Maple Grove', 36.7750015258789, 0.641844859052526, -87.8958282470703, -1.53407160167881, 218, 21, 'PPL', 'P'),
(49207, 'Maple Grove', 39.649169921875, 0.692008560819422, -76.8605575561523, -1.34146979427346, 218, 25, 'PPL', 'P'),
(56071, 'Maple Grove', 37.2536087036133, 0.650198130127668, -94.1255569458008, -1.64280087897764, 218, 29, 'PPL', 'P'),
(66601, 'Maple Grove', 36.0052795410156, 0.628410676091675, -81.7266693115234, -1.42639946617469, 218, 33, 'PPL', 'P'),
(71076, 'Maple Grove', 39.624439239502, 0.691576928985747, -75.2011108398438, -1.31250698531247, 218, 37, 'PPL', 'P'),
(88793, 'Maple Grove', 35.7119407653809, 0.62329094863308, -84.6888885498047, -1.47809994504862, 218, 50, 'PPL', 'P'),
(103985, 'Maple Grove', 37.1061096191406, 0.647623785459943, -76.5244369506836, -1.33560338302424, 218, 53, 'PPL', 'P'),
(125322, 'Maple Grove', 42.6147193908691, 0.743767163184139, -73.1291732788086, -1.27634485297667, 218, 23, 'PPL', 'P'),
(128059, 'Maple Grove', 46.728889465332, 0.815572976970537, -67.8638916015625, -1.18444835166379, 218, 26, 'PPL', 'P'),
(131908, 'Maple Grove', 43.4019393920898, 0.757506744142994, -86.3633270263672, -1.50732440958671, 218, 27, 'PPL', 'P'),
(136702, 'Maple Grove', 45.0724983215332, 0.786663497810372, -93.4555587768555, -1.63110720494721, 218, 28, 'PPL', 'P'),
(150534, 'Maple Grove', 42.6147193908691, 0.743767163184139, -73.5694427490234, -1.28402900482793, 218, 40, 'PPL', 'P'),
(156318, 'Maple Grove', 41.2147216796875, 0.719332593603635, -83.225830078125, -1.45256475756861, 218, 41, 'PPL', 'P'),
(164197, 'Maple Grove', 41.9452781677246, 0.732083209691689, -75.420280456543, -1.31633221674421, 218, 45, 'PPL', 'P'),
(175145, 'Maple Grove', 44.1894416809082, 0.771251251949866, -87.9236068725586, -1.53455643015526, 218, 57, 'PPL', 'P'),
(192688, 'Maple Grove', 39.0149993896484, 0.680940197012943, -112.092216491699, -1.95637824363844, 218, 52, 'PPL', 'P'),
(193764, 'Maple Grove', 40.4691696166992, 0.706320255359453, -123.832496643066, -2.16128478738633, 218, 6, 'PPL', 'P'),
(208014, 'Maple Grove', 48.0813903808594, 0.839178571082726, -123.703887939453, -2.15904014206156, 218, 56, 'PPL', 'P'),
(156319, 'Maple Grove (historical)', 41.589168548584, 0.725867924339662, -83.1980590820313, -1.45208006225022, 218, 41, 'PPL', 'P'),
(208015, 'Maple Grove Beach', 48.2533302307129, 0.842179487578055, -122.514999389648, -2.13829012242821, 218, 56, 'PPL', 'P'),
(131909, 'Maple Grove Corners', 42.375560760498, 0.739593057649603, -86.2438888549805, -1.50523982024345, 218, 27, 'PPL', 'P'),
(103981, 'Maple Grove Estates', 38.7841682434082, 0.676911433494899, -77.1458282470703, -1.34644870708942, 218, 53, 'PPL', 'P'),
(164198, 'Maple Grove Park', 40.2102813720703, 0.70180180309597, -75.9688873291016, -1.32590721296942, 218, 45, 'PPL', 'P'),
(73358, 'Maple Grove Trailer Court', 39.8458290100098, 0.695440909411343, -83.9955596923828, -1.46599907368752, 218, 41, 'PPL', 'P'),
(49208, 'Maple Haven', 39.4569396972656, 0.68865351047814, -76.9797210693359, -1.34354958992676, 218, 25, 'PPL', 'P'),
(156320, 'Maple Heights', 41.4152793884277, 0.722832985961408, -81.5661087036133, -1.42359715491766, 218, 41, 'PPL', 'P'),
(175149, 'Maple Heights', 43.9563903808594, 0.76718373943796, -88.317497253418, -1.54143111419319, 218, 57, 'PPL', 'P'),
(3980, 'Maple Hill', 34.9333305358887, 0.609701636538732, -86.7658309936523, -1.51434942906818, 218, 2, 'PPL', 'P'),
(33187, 'Maple Hill', 39.0847206115723, 0.682157061894028, -96.0277786254883, -1.67600091039101, 218, 20, 'PPL', 'P'),
(56072, 'Maple Hill', 39.7016716003418, 0.692924887971491, -94.4075012207031, -1.64772173488184, 218, 29, 'PPL', 'P'),
(66603, 'Maple Hill', 34.6611099243164, 0.604950490575004, -77.6966705322266, -1.35606271862461, 218, 33, 'PPL', 'P'),
(88795, 'Maple Hill', 36.2244415283203, 0.632235774365356, -86.3530578613281, -1.50714517884535, 218, 50, 'PPL', 'P'),
(103983, 'Maple Hill', 36.711109161377, 0.640729726925082, -76.6591720581055, -1.33795495426678, 218, 53, 'PPL', 'P'),
(116708, 'Maple Hill', 43.392219543457, 0.757337100781556, -94.625, -1.65151780469963, 218, 16, 'PPL', 'P'),
(136706, 'Maple Hill', 47.8077812194824, 0.834403190353078, -90.3047180175781, -1.57611465949178, 218, 28, 'PPL', 'P'),
(150536, 'Maple Hill', 41.8663902282715, 0.730706355408118, -74.0616683959961, -1.29261996303036, 218, 40, 'PPL', 'P'),
(164201, 'Maple Hill', 41.689998626709, 0.727627741187986, -77.1661071777344, -1.34680264119829, 218, 45, 'PPL', 'P'),
(175150, 'Maple Hill', 45.0169410705566, 0.785693840857474, -90.9836120605469, -1.58796359581377, 218, 57, 'PPL', 'P'),
(103984, 'Maple Hills', 38.8383293151855, 0.677856722523822, -77.3002777099609, -1.3491443587448, 218, 53, 'PPL', 'P'),
(208016, 'Maple Hills', 47.4672203063965, 0.82845928111613, -122.066673278809, -2.13046535567139, 218, 56, 'PPL', 'P'),
(131913, 'Maple Island', 42.0633316040039, 0.734143630848056, -86.1772232055664, -1.5040762851632, 218, 27, 'PPL', 'P'),
(136708, 'Maple Island', 45.1741714477539, 0.788438028623719, -92.8550033569336, -1.62062553552888, 218, 28, 'PPL', 'P'),
(110276, 'Maple Lake', 39.295280456543, 0.685832024461255, -80.2072219848633, -1.39988010751385, 218, 58, 'PPL', 'P'),
(136709, 'Maple Lake', 45.2291717529297, 0.789397965038638, -94.0016708374023, -1.64063865848861, 218, 28, 'PPL', 'P'),
(164203, 'Maple Lake', 41.3261108398438, 0.721276701199392, -75.5736083984375, -1.31900829416557, 218, 45, 'PPL', 'P'),
(136710, 'Maple Lake Mobile Home Park', 45.2247200012207, 0.789320267313835, -94.0013885498047, -1.64063373164059, 218, 28, 'PPL', 'P'),
(116709, 'Maple Landing (historical)', 42.0922203063965, 0.734647833821435, -96.2133331298828, -1.6792394474346, 218, 16, 'PPL', 'P'),
(123130, 'Maple Lane', 41.7000007629395, 0.727802311397441, -86.2169418334961, -1.50476950599494, 218, 19, 'PPL', 'P'),
(116710, 'Maple Leaf', 43.3208312988281, 0.756091140865562, -92.3788909912109, -1.61231580713756, 218, 16, 'PPL', 'P'),
(131914, 'Maple Leaf', 42.5780601501465, 0.743127338732247, -82.5697174072266, -1.44111343119738, 218, 27, 'PPL', 'P'),
(202341, 'Maple Leaf', 45.9247207641602, 0.801537585393601, -100.890281677246, -1.76086759853245, 218, 49, 'PPL', 'P'),
(136713, 'Maple Leaf Court', 45.9838905334473, 0.802570292685306, -94.3736114501953, -1.64713024680373, 218, 28, 'PPL', 'P'),
(120500, 'Maple Leaf Estates', 41.648609161377, 0.726905358742302, -87.978889465332, -1.5355212934182, 218, 18, 'PPL', 'P'),
(145694, 'Maple Meade', 40.4436111450195, 0.705874175876865, -74.475830078125, -1.29984844801911, 218, 37, 'PPL', 'P'),
(110278, 'Maple Meadow', 37.7411117553711, 0.658706663494362, -81.3447189331055, -1.41973317449206, 218, 58, 'PPL', 'P'),
(56073, 'Maple Park', 39.1897201538086, 0.683989649619139, -94.508056640625, -1.6494767580402, 218, 29, 'PPL', 'P'),
(120501, 'Maple Park', 41.9075012207031, 0.731423877584812, -88.5991668701172, -1.54634717640742, 218, 18, 'PPL', 'P'),
(125325, 'Maple Park', 42.7683296203613, 0.746448167453522, -71.1624984741211, -1.24201990231885, 218, 23, 'PPL', 'P'),
(136714, 'Maple Plain', 45.0072212219238, 0.785524197496036, -93.6555633544922, -1.63459794334603, 218, 28, 'PPL', 'P'),
(49211, 'Maple Plains', 38.3872184753418, 0.669983353077112, -75.5752792358398, -1.31903745577951, 218, 25, 'PPL', 'P'),
(27793, 'Maple Point', 39.332218170166, 0.686476709182136, -88.1130599975586, -1.5378630109647, 218, 18, 'PPL', 'P'),
(150537, 'Maple Point', 42.1025009155273, 0.734827264299879, -79.3583297729492, -1.38506414342141, 218, 40, 'PPL', 'P'),
(164204, 'Maple Point', 40.2005615234375, 0.701632159734532, -74.9008331298828, -1.3072661506033, 218, 45, 'PPL', 'P'),
(131915, 'Maple Rapids', 43.1047210693359, 0.752319305813683, -84.6919403076172, -1.47815320827042, 218, 27, 'PPL', 'P'),
(22857, 'Maple Ridge', 34.021671295166, 0.593790181131891, -84.0911102294922, -1.46766674516212, 218, 13, 'PPL', 'P'),
(30418, 'Maple Ridge', 39.6780586242676, 0.692512763792801, -86.2861099243164, -1.50597671691708, 218, 19, 'PPL', 'P'),
(49210, 'Maple Ridge', 39.0724983215332, 0.681943742690712, -76.6930618286133, -1.33854644234489, 218, 25, 'PPL', 'P'),
(125324, 'Maple Ridge', 42.0750007629395, 0.73434729609242, -71.4805603027344, -1.24757112845307, 218, 23, 'PPL', 'P'),
(131916, 'Maple Ridge', 44.1419410705566, 0.770422209902524, -83.9274978637695, -1.46481117068329, 218, 27, 'PPL', 'P'),
(156323, 'Maple Ridge', 40.9230613708496, 0.71424216091703, -81.0511093139648, -1.41460871992253, 218, 41, 'PPL', 'P'),
(164205, 'Maple Ridge', 40.2108306884766, 0.701811390475894, -78.9136123657227, -1.37730236042437, 218, 45, 'PPL', 'P'),
(116711, 'Maple River', 42.0980606079102, 0.734749766312158, -94.9349975585938, -1.65692828277024, 218, 16, 'PPL', 'P'),
(49227, 'Maple Run', 38.2722206115723, 0.667976261721574, -76.5397186279297, -1.33587009860741, 218, 25, 'PPL', 'P'),
(110279, 'Maple Run', 39.3352813720703, 0.68653017214102, -79.904167175293, -1.39459080327284, 218, 58, 'PPL', 'P'),
(71079, 'Maple Shade', 39.9524993896484, 0.69730265875039, -74.9927825927734, -1.30887097147619, 218, 37, 'PPL', 'P'),
(150538, 'Maple Shade', 43.0186080932617, 0.750816350852497, -73.7266693115234, -1.28677312601514, 218, 40, 'PPL', 'P'),
(164207, 'Maple Shade', 40.0999984741211, 0.699877003418115, -74.8955612182617, -1.30717413838764, 218, 45, 'PPL', 'P'),
(88800, 'Maple Spring', 35.901668548584, 0.626602323132484, -83.2888870239258, -1.45366530888909, 218, 50, 'PPL', 'P'),
(10298, 'Maple Springs', 35.6352806091309, 0.621952976501424, -91.5105590820313, -1.59716055632225, 218, 4, 'PPL', 'P'),
(66605, 'Maple Springs', 35.3569412231445, 0.617095037777983, -83.5336074829102, -1.45793648664536, 218, 33, 'PPL', 'P'),
(95992, 'Maple Springs', 33.3555603027344, 0.582164351130231, -95.0052795410156, -1.65815493476833, 218, 51, 'PPL', 'P'),
(136718, 'Maple Springs', 44.4097213745117, 0.775095857878531, -92.1616668701172, -1.60852453100972, 218, 28, 'PPL', 'P'),
(150539, 'Maple Springs', 42.1966705322266, 0.736470834166622, -79.4241714477539, -1.38621329743178, 218, 40, 'PPL', 'P'),
(22859, 'Maple Subdivision', 31.8069400787354, 0.555135829358476, -81.6013870239258, -1.42421287776168, 218, 13, 'PPL', 'P'),
(164208, 'Maple Summit', 41.559440612793, 0.725349073980287, -76.7763900756836, -1.34000079461618, 218, 45, 'PPL', 'P'),
(49212, 'Maple Trailer Park', 39.160831451416, 0.683485446645759, -76.793327331543, -1.34029640549718, 218, 25, 'PPL', 'P'),
(30419, 'Maple Valley', 39.8669395446777, 0.695809357748155, -85.5869369506836, -1.49377384648622, 218, 19, 'PPL', 'P'),
(66615, 'Maple Valley', 35.8863906860352, 0.62633567412834, -81.4761123657227, -1.42202642250673, 218, 33, 'PPL', 'P'),
(131920, 'Maple Valley', 44.3052787780762, 0.773272990691399, -84.4911117553711, -1.47464808880171, 218, 27, 'PPL', 'P'),
(150540, 'Maple Valley', 42.6794395446777, 0.744896742960496, -74.7644424438477, -1.30488568406294, 218, 40, 'PPL', 'P'),
(156324, 'Maple Valley', 41.0838890075684, 0.717049132705973, -81.5702819824219, -1.42366999237347, 218, 41, 'PPL', 'P'),
(208017, 'Maple Valley', 47.4066696166992, 0.82740247221656, -122.037498474121, -2.12995615927097, 218, 56, 'PPL', 'P'),
(208018, 'Maple Valley Heights', 47.4550018310547, 0.828246028491842, -122.085563659668, -2.13079505501434, 218, 56, 'PPL', 'P'),
(49213, 'Maple View', 39.5588912963867, 0.690432901560476, -76.9841690063477, -1.34362722107254, 218, 25, 'PPL', 'P'),
(110280, 'Maple View', 37.2983283996582, 0.650978636064143, -81.1622161865234, -1.41654790067027, 218, 58, 'PPL', 'P'),
(150541, 'Maple View', 43.457218170166, 0.758471540826902, -76.1455612182617, -1.32899075403757, 218, 40, 'PPL', 'P'),
(208019, 'Maplecreek', 47.7880592346191, 0.834058976782185, -120.138893127441, -2.09681924477544, 218, 56, 'PPL', 'P'),
(22860, 'Maplecreek Hills', 32.985279083252, 0.575701724691963, -85.1133270263672, -1.48550779393678, 218, 13, 'PPL', 'P'),
(14178, 'Maplecrest', 39.7291717529297, 0.69340485617895, -75.654167175293, -1.32041431006308, 218, 10, 'PPL', 'P'),
(150542, 'Maplecrest', 42.2758293151855, 0.737852415561127, -74.1872177124023, -1.29481121197528, 218, 40, 'PPL', 'P'),
(156325, 'Maplecrest', 41.5580596923828, 0.725324972372422, -84.5708312988281, -1.47603945731322, 218, 41, 'PPL', 'P'),
(66606, 'Maplecypress', 35.3258285522461, 0.616552019231716, -77.2994384765625, -1.34912971135881, 218, 33, 'PPL', 'P'),
(103986, 'Mapledale', 38.6527786254883, 0.674618252059259, -77.3666687011719, -1.35030310013509, 218, 53, 'PPL', 'P'),
(110281, 'Mapledale', 37.8349990844727, 0.660345306513088, -80.258056640625, -1.40076733963101, 218, 58, 'PPL', 'P'),
(150545, 'Mapledale', 42.1108283996582, 0.73497260631637, -74.5633316040039, -1.30137563774621, 218, 40, 'PPL', 'P'),
(164209, 'Mapledale', 41.3841705322266, 0.722290033994168, -79.8611068725586, -1.39383925921322, 218, 45, 'PPL', 'P'),
(144109, 'Maplehaven', 43.0272216796875, 0.750966686296032, -70.7975006103516, -1.23564948783333, 218, 36, 'PPL', 'P'),
(88801, 'Maplehurst', 36.5166702270508, 0.637336127327022, -82.2644424438477, -1.43578537796251, 218, 50, 'PPL', 'P'),
(131923, 'Maplehurst', 42.3477783203125, 0.739108162594127, -85.154167175293, -1.48622058900254, 218, 27, 'PPL', 'P'),
(150546, 'Maplehurst', 42.1800003051758, 0.73617988381753, -78.3819427490234, -1.36802297508015, 218, 40, 'PPL', 'P'),
(175154, 'Maplehurst', 45.0608291625977, 0.786459832566008, -90.6386108398438, -1.5819421885891, 218, 57, 'PPL', 'P'),
(49215, 'Maplehurst Woods', 39.5844383239746, 0.690878781305983, -76.6494369506836, -1.33778504458923, 218, 25, 'PPL', 'P'),
(208020, 'Mapleleaf', 47.6941719055176, 0.83242033376346, -122.321670532227, -2.13491589732708, 218, 56, 'PPL', 'P'),
(56074, 'Maples', 37.584171295166, 0.655967535734189, -91.783332824707, -1.60192135624493, 218, 29, 'PPL', 'P'),
(88802, 'Maples', 36.1547203063965, 0.631018909484272, -84.1236114501953, -1.46823399847431, 218, 50, 'PPL', 'P'),
(123131, 'Maples', 41.0127792358398, 0.715808033058969, -84.9691696166992, -1.48299177249693, 218, 19, 'PPL', 'P'),
(150547, 'Maples', 42.3338890075684, 0.738865748355903, -78.7352828979492, -1.3741899240584, 218, 40, 'PPL', 'P'),
(88803, 'Maples (historical)', 36.1838912963867, 0.631528039305668, -83.6624984741211, -1.46018605881815, 218, 50, 'PPL', 'P'),
(37051, 'Maples Corner', 37.8330612182617, 0.660311484367244, -86.1336135864258, -1.50331515372365, 218, 21, 'PPL', 'P'),
(120502, 'Maples Mill', 40.4283294677734, 0.705607460293693, -90.0305633544922, -1.57132975796124, 218, 18, 'PPL', 'P'),
(73359, 'Mapleshade', 38.8213882446289, 0.677561045063796, -82.1766662597656, -1.43425339454544, 218, 41, 'PPL', 'P'),
(116716, 'Mapleside', 43.002498626709, 0.750535187620412, -95.6236114501953, -1.66894686245366, 218, 16, 'PPL', 'P'),
(3981, 'Maplesville', 32.788330078125, 0.572264316093971, -86.8716735839844, -1.51619673075831, 218, 2, 'PPL', 'P'),
(37052, 'Maplesville', 37.1500015258789, 0.648389843747504, -84.0277786254883, -1.46656140015169, 218, 21, 'PPL', 'P'),
(30422, 'Mapleton', 39.8288917541504, 0.695145298530344, -86.1672210693359, -1.50390171495374, 218, 19, 'PPL', 'P'),
(33190, 'Mapleton', 38.0149993896484, 0.663486904493, -94.8833312988281, -1.65602653642514, 218, 20, 'PPL', 'P'),
(66607, 'Mapleton', 36.4266700744629, 0.635765328337065, -77.0350036621094, -1.3445144531897, 218, 33, 'PPL', 'P'),
(95993, 'Mapleton', 31.1399993896484, 0.54349551841839, -95.6686096191406, -1.66973222865912, 218, 51, 'PPL', 'P'),
(103989, 'Mapleton', 36.7999992370605, 0.642281151418108, -76.0858306884766, -1.32794825962886, 218, 53, 'PPL', 'P'),
(116717, 'Mapleton', 42.165828704834, 0.735932542731289, -95.7927780151367, -1.67189937599617, 218, 16, 'PPL', 'P'),
(120503, 'Mapleton', 40.5663909912109, 0.708017088447997, -89.7316665649414, -1.56611302485994, 218, 18, 'PPL', 'P'),
(128063, 'Mapleton', 46.6819381713867, 0.814753522303119, -68.163330078125, -1.18967453898697, 218, 26, 'PPL', 'P'),
(131926, 'Mapleton', 43.5666694641113, 0.760381826276816, -84.1827774047852, -1.46926663918699, 218, 27, 'PPL', 'P'),
(136720, 'Mapleton', 43.9288902282715, 0.766703771230501, -93.9558334350586, -1.63983864489715, 218, 28, 'PPL', 'P'),
(140454, 'Mapleton', 46.8891716003418, 0.818370427958583, -97.0522232055664, -1.69388084131758, 218, 34, 'PPL', 'P'),
(144110, 'Mapleton', 44.648609161377, 0.779265236302132, -71.5527801513672, -1.248831602597, 218, 36, 'PPL', 'P'),
(150549, 'Mapleton', 43.1230583190918, 0.752639351197683, -78.7994384765625, -1.37530965013872, 218, 40, 'PPL', 'P'),
(156326, 'Mapleton', 40.7458305358887, 0.711148899310903, -81.2463912963867, -1.41801703348561, 218, 41, 'PPL', 'P'),
(164210, 'Mapleton', 40.3936080932617, 0.705001457987646, -77.9413909912109, -1.36033389638088, 218, 45, 'PPL', 'P'),
(175156, 'Mapleton', 43.1788902282715, 0.753613801840543, -88.4599990844727, -1.54391824033522, 218, 57, 'PPL', 'P'),
(195284, 'Mapleton', 42.0838890075684, 0.734502425225917, -111.748062133789, -1.95037161695782, 218, 17, 'PPL', 'P'),
(201180, 'Mapleton', 44.0313911437988, 0.768492749692762, -123.856941223145, -2.16171142579296, 218, 43, 'PPL', 'P'),
(204807, 'Mapleton', 40.1302795410156, 0.700405507736442, -111.577781677246, -1.94739966233935, 218, 52, 'PPL', 'P'),
(110282, 'Mapleton (historical)', 39.1163902282715, 0.682709800978274, -78.9333267211914, -1.37764644083721, 218, 58, 'PPL', 'P'),
(30420, 'Mapleton Corner', 39.1908302307129, 0.684009024116069, -85.5461120605469, -1.49306131773657, 218, 19, 'PPL', 'P'),
(103987, 'Mapleton Heights', 37.3061103820801, 0.651114457279737, -79.934440612793, -1.39511917443311, 218, 53, 'PPL', 'P'),
(88811, 'Mapleton Hills', 35.2341690063477, 0.614952258364905, -84.8472213745117, -1.48086337415374, 218, 50, 'PPL', 'P'),
(78676, 'Mapletown', 39.8044395446777, 0.694718526965659, -79.9438934326172, -1.39528415726264, 218, 45, 'PPL', 'P'),
(150550, 'Mapletown', 42.8386116027832, 0.747674819451612, -74.5597229003906, -1.30131265398643, 218, 40, 'PPL', 'P'),
(88804, 'Mapleview', 36.0880584716797, 0.629855440983043, -83.9861068725586, -1.46583409085799, 218, 50, 'PPL', 'P'),
(136723, 'Mapleview', 43.6888885498047, 0.762514951730942, -92.9791717529297, -1.62279268286593, 218, 28, 'PPL', 'P'),
(88805, 'Mapleview Acres', 36.1655616760254, 0.631208127079722, -83.3627777099609, -1.45495494464696, 218, 50, 'PPL', 'P'),
(49216, 'Mapleville', 39.538890838623, 0.690083827720594, -77.6477813720703, -1.35520944181135, 218, 25, 'PPL', 'P'),
(66608, 'Mapleville', 36.0763893127441, 0.62965177573868, -78.2275009155273, -1.36532745658283, 218, 33, 'PPL', 'P'),
(169477, 'Mapleville', 41.9480590820313, 0.732131745802555, -71.649169921875, -1.25051392145761, 218, 47, 'PPL', 'P'),
(3983, 'Maplewood', 34.6980590820313, 0.605595375032967, -86.7583312988281, -1.5142185347006, 218, 2, 'PPL', 'P'),
(14171, 'Maplewood', 38.730281829834, 0.675970938155937, -75.1363906860352, -1.31137740553611, 218, 10, 'PPL', 'P'),
(30421, 'Maplewood', 39.8344383239746, 0.695242104435969, -86.5052795410156, -1.50980194834881, 218, 19, 'PPL', 'P'),
(41971, 'Maplewood', 30.2311096191406, 0.527632399385333, -93.3161087036133, -1.62867334202699, 218, 22, 'PPL', 'P'),
(49218, 'Maplewood', 39.0074996948242, 0.680809302645366, -77.1036071777344, -1.3457118104158, 218, 25, 'PPL', 'P'),
(56075, 'Maplewood', 38.6124992370605, 0.673915244110505, -90.3244400024414, -1.57645887306268, 218, 29, 'PPL', 'P'),
(66609, 'Maplewood', 34.9244384765625, 0.609546440826208, -79.7541732788086, -1.39197291592129, 218, 33, 'PPL', 'P'),
(88806, 'Maplewood', 36.2297210693359, 0.632327919739073, -86.7305603027344, -1.5137338393822, 218, 50, 'PPL', 'P'),
(103988, 'Maplewood', 37.3161087036133, 0.651288960910165, -78.0488891601563, -1.36221009336884, 218, 53, 'PPL', 'P'),
(110283, 'Maplewood', 37.9263916015625, 0.661940406847991, -80.9333267211914, -1.4125530258771, 218, 58, 'PPL', 'P'),
(125327, 'Maplewood', 42.2272186279297, 0.737003999016855, -71.7249984741211, -1.25183737936132, 218, 23, 'PPL', 'P'),
(128061, 'Maplewood', 43.6741714477539, 0.762258089843804, -70.9113922119141, -1.23763727127096, 218, 26, 'PPL', 'P'),
(131927, 'Maplewood', 45.9688911437988, 0.802308503950152, -86.9722213745117, -1.51795162075862, 218, 27, 'PPL', 'P'),
(136725, 'Maplewood', 44.9530601501465, 0.784578908467113, -92.995002746582, -1.62306898582903, 218, 28, 'PPL', 'P'),
(144111, 'Maplewood', 44.2819404602051, 0.772865660202672, -71.6577835083008, -1.25066425690114, 218, 36, 'PPL', 'P'),
(145696, 'Maplewood', 40.7311096191406, 0.710891970844737, -74.2738876342773, -1.29632388747444, 218, 37, 'PPL', 'P'),
(150553, 'Maplewood', 40.9633293151855, 0.714944969128702, -73.7891693115234, -1.28786395679764, 218, 40, 'PPL', 'P'),
(156328, 'Maplewood', 40.3761100769043, 0.704696059989641, -84.0258331298828, -1.46652744484779, 218, 41, 'PPL', 'P'),
(164212, 'Maplewood', 41.4316711425781, 0.723119076041509, -75.4369430541992, -1.31662303393524, 218, 45, 'PPL', 'P'),
(175157, 'Maplewood', 44.747501373291, 0.780991231004612, -87.4791717529297, -1.52679957400624, 218, 57, 'PPL', 'P'),
(201181, 'Maplewood', 45.4700012207031, 0.79360123218711, -122.728889465332, -2.14202320848623, 218, 43, 'PPL', 'P'),
(208022, 'Maplewood', 47.4019393920898, 0.827319914222767, -122.55583190918, -2.13900278433591, 218, 56, 'PPL', 'P'),
(142351, 'Maplewood Estates', 41.2949981689453, 0.720733682653125, -96.1125030517578, -1.67747963058627, 218, 35, 'PPL', 'P'),
(88810, 'Maplewood Heights', 35.0366706848145, 0.611505262386989, -85.0963897705078, -1.48521218305578, 218, 50, 'PPL', 'P'),
(164213, 'Maplewood Heights', 41.3388900756836, 0.721499740940687, -75.9391708374023, -1.32538856234713, 218, 45, 'PPL', 'P'),
(208023, 'Maplewood Heights', 47.476390838623, 0.828619337097644, -122.146942138672, -2.13186631156283, 218, 56, 'PPL', 'P'),
(27794, 'Maplewood Park', 38.5755615234375, 0.673270559389624, -90.1761093139648, -1.57387001416701, 218, 18, 'PPL', 'P'),
(123132, 'Maplewood Park', 41.1155586242676, 0.717601871790219, -85.0563888549805, -1.48451403537602, 218, 19, 'PPL', 'P'),
(156329, 'Maplewood Park', 41.1355590820313, 0.717950945630102, -80.584716796875, -1.40646863489265, 218, 41, 'PPL', 'P'),
(164214, 'Maplewood Terrace', 40.2827796936035, 0.703067137508894, -79.5311126708984, -1.38807977388176, 218, 45, 'PPL', 'P'),
(136726, 'Maplewood Trailer Park', 44.4494400024414, 0.775789078710279, -92.2666702270508, -1.61035718531386, 218, 28, 'PPL', 'P'),
(142352, 'Mapps', 40.9447212219238, 0.714620196633767, -97.6066665649414, -1.70355770345449, 218, 35, 'PPL', 'P'),
(103990, 'Mappsburg', 37.5774993896484, 0.655851089015525, -75.7638931274414, -1.32232938920296, 218, 53, 'PPL', 'P'),
(103991, 'Mappsville', 37.8458290100098, 0.660534324371456, -75.5669403076172, -1.31889191402594, 218, 53, 'PPL', 'P'),
(113365, 'Maquam', 44.9174995422363, 0.78395825877507, -73.1613922119141, -1.27690717944084, 218, 55, 'PPL', 'P'),
(178588, 'Maques Place', 32.975830078125, 0.57553680844146, -109.365829467773, -1.90879381338728, 218, 5, 'PPL', 'P'),
(116718, 'Maquoketa', 42.0688896179199, 0.734240636490762, -90.6655578613281, -1.5824125028376, 218, 16, 'PPL', 'P'),
(120506, 'Maquon', 40.7988891601563, 0.712074947000951, -90.1655578613281, -1.57368585657763, 218, 18, 'PPL', 'P'),
(183082, 'Mar Vista', 34.0047187805176, 0.593494303934783, -118.430000305176, -2.06699343846321, 218, 6, 'PPL', 'P'),
(136729, 'Mar Wey Mobile Home Park', 44.3105583190918, 0.773365136065116, -93.9727783203125, -1.6401343889362, 218, 28, 'PPL', 'P'),
(196983, 'Mar-Le Villa', 48.1816711425781, 0.840928800551127, -114.291107177734, -1.99475612600119, 218, 31, 'PPL', 'P'),
(49220, 'Mar-Lu-Ridge Vista', 39.3438911437988, 0.686680441005527, -77.5083312988281, -1.35277557889112, 218, 25, 'PPL', 'P'),
(66612, 'Mar-Mac', 35.3347206115723, 0.61670721494424, -78.0561065673828, -1.3623360608884, 218, 33, 'PPL', 'P'),
(125328, 'Mara Vista', 41.5472183227539, 0.725135754776972, -70.5872192382813, -1.23197938553509, 218, 23, 'PPL', 'P'),
(14172, 'Marabou Meadows', 39.5902786254883, 0.690980713796706, -75.7458267211914, -1.32201407092989, 218, 10, 'PPL', 'P'),
(49221, 'Marabrooke', 39.0069389343262, 0.68079951552836, -76.5527801513672, -1.33609806519672, 218, 25, 'PPL', 'P'),
(56076, 'Marais Croche', 38.8477783203125, 0.678021638774326, -90.4013900756836, -1.5778019052004, 218, 29, 'PPL', 'P'),
(95994, 'Marak', 30.9016704559326, 0.539335893822281, -97.0683288574219, -1.69416193797064, 218, 51, 'PPL', 'P'),
(76500, 'Maramec', 36.2419395446777, 0.632541172363361, -96.6800003051758, -1.68738432615444, 218, 42, 'PPL', 'P'),
(178589, 'Marana', 32.4366683959961, 0.56612666188772, -111.224716186523, -1.94123750705107, 218, 5, 'PPL', 'P'),
(128062, 'Maranacook', 44.3469390869141, 0.774000100248018, -69.958610534668, -1.22100809395035, 218, 26, 'PPL', 'P'),
(17017, 'Marathon', 24.7133293151855, 0.431328965679623, -81.0905609130859, -1.41529728022237, 218, 12, 'PPL', 'P'),
(41972, 'Marathon', 30.0591697692871, 0.524631482890004, -90.6013870239258, -1.58129251044117, 218, 22, 'PPL', 'P'),
(60764, 'Marathon', 33.0652809143066, 0.577098020051492, -91.019172668457, -1.58858424550581, 218, 30, 'PPL', 'P'),
(73360, 'Marathon', 39.144718170166, 0.683204216834647, -84.0063934326172, -1.46618815812491, 218, 41, 'PPL', 'P'),
(116720, 'Marathon', 42.8616714477539, 0.74807728967135, -94.9822235107422, -1.65775253112762, 218, 16, 'PPL', 'P'),
(150554, 'Marathon', 42.4416694641113, 0.74074687219188, -76.0325012207031, -1.32701748482788, 218, 40, 'PPL', 'P'),
(175158, 'Marathon', 44.9291687011719, 0.784161924019434, -89.8402786254883, -1.56800866292386, 218, 57, 'PPL', 'P'),
(191829, 'Marathon', 30.2049999237061, 0.527176699233307, -103.244171142578, -1.8019507199305, 218, 51, 'PPL', 'P'),
(17018, 'Marathon Shores', 24.7252807617188, 0.431537557772004, -81.0486068725586, -1.41456504408065, 218, 12, 'PPL', 'P'),
(88812, 'Marathon Trail', 35.9238891601563, 0.626990145966227, -86.5038909912109, -1.50977771358289, 218, 50, 'PPL', 'P'),
(183085, 'Maravilla Housing Project', 34.0422210693359, 0.594148842351697, -118.15860748291, -2.06225674014839, 218, 6, 'PPL', 'P'),
(49222, 'Marbella', 38.6522216796875, 0.67460853152128, -76.8913879394531, -1.34200788597172, 218, 25, 'PPL', 'P'),
(10300, 'Marble', 36.139720916748, 0.630757120749117, -93.5872192382813, -1.63340511349379, 218, 4, 'PPL', 'P'),
(66614, 'Marble', 35.1749992370605, 0.6139195510732, -83.9250030517578, -1.46476762799946, 218, 33, 'PPL', 'P'),
(136730, 'Marble', 47.3205604553223, 0.825899583834401, -93.2983322143555, -1.62836308375999, 218, 28, 'PPL', 'P'),
(164215, 'Marble', 41.3388900756836, 0.721499740940687, -79.4383316040039, -1.38646043878094, 218, 45, 'PPL', 'P'),
(187025, 'Marble', 39.0722198486328, 0.681938882421723, -107.188331604004, -1.87078930620936, 218, 7, 'PPL', 'P'),
(208024, 'Marble', 48.8491706848145, 0.852578865318705, -117.90055847168, -2.0577529352709, 218, 56, 'PPL', 'P'),
(22864, 'Marble (historical)', 31.2219390869141, 0.544925635923762, -83.8241729736328, -1.46300781115114, 218, 13, 'PPL', 'P'),
(175162, 'Marble (historical)', 44.5625, 0.777762347919973, -88.8708267211914, -1.55108853525415, 218, 57, 'PPL', 'P'),
(178590, 'Marble Canyon', 36.815559387207, 0.642552727270269, -111.636940002441, -1.94843216989397, 218, 5, 'PPL', 'P'),
(76501, 'Marble City', 35.5802803039551, 0.620993040086505, -94.8208312988281, -1.65493570564264, 218, 42, 'PPL', 'P'),
(88813, 'Marble City', 35.9524993896484, 0.627489488670617, -83.9647216796875, -1.46546084883121, 218, 50, 'PPL', 'P'),
(164216, 'Marble City', 40.146671295166, 0.700691597816543, -78.3058319091797, -1.36669459032842, 218, 45, 'PPL', 'P'),
(73361, 'Marble Cliff', 39.9866714477539, 0.697899073676513, -83.0616683959961, -1.44969959570985, 218, 41, 'PPL', 'P'),
(195285, 'Marble Creek', 47.2527809143066, 0.824716607678187, -116.030830383301, -2.02512002401167, 218, 17, 'PPL', 'P'),
(113680, 'Marble Dale', 41.6636085510254, 0.727167147477457, -73.3694381713867, -1.28053826642911, 218, 8, 'PPL', 'P'),
(95995, 'Marble Falls', 30.5780601501465, 0.533687828492928, -98.2724990844727, -1.71517867318716, 218, 51, 'PPL', 'P'),
(73362, 'Marble Furnace', 38.9749984741211, 0.680242049333179, -83.4274978637695, -1.45608452442331, 218, 41, 'PPL', 'P'),
(164217, 'Marble Hall', 40.0913887023926, 0.699726734553608, -75.2516708374023, -1.31338942373967, 218, 45, 'PPL', 'P'),
(30423, 'Marble Hill', 38.5924987792969, 0.673566170270623, -85.4505615234375, -1.49139364626197, 218, 19, 'PPL', 'P'),
(49225, 'Marble Hill', 39.1972198486328, 0.684120543986716, -76.7425003051758, -1.33940930653807, 218, 25, 'PPL', 'P'),
(56077, 'Marble Hill', 37.3058280944824, 0.65110953043172, -89.9702835083008, -1.5702776761726, 218, 29, 'PPL', 'P'),
(88815, 'Marble Hill', 35.2033309936523, 0.6144140335086, -86.3233337402344, -1.506626395065, 218, 50, 'PPL', 'P'),
(145698, 'Marble Hill', 40.8858299255371, 0.713592349611051, -74.9352798461914, -1.30786735921939, 218, 37, 'PPL', 'P'),
(183086, 'Marble Mountain', 38.6494407653809, 0.674559995410413, -121.032783508301, -2.11242057507334, 218, 6, 'PPL', 'P'),
(183087, 'Marble Place', 39.4583282470703, 0.68867774524406, -123.571388244629, -2.15672758612899, 218, 6, 'PPL', 'P'),
(103992, 'Marble Quarry', 39.0244407653809, 0.681104980105392, -77.6897201538086, -1.35594141163696, 218, 53, 'PPL', 'P'),
(125329, 'Marble Ridge Station', 42.6791687011719, 0.744892015849561, -71.0983276367188, -1.24089990992242, 218, 23, 'PPL', 'P'),
(116721, 'Marble Rock', 42.9652786254883, 0.749885576051514, -92.8683319091797, -1.6208581626501, 218, 16, 'PPL', 'P'),
(3984, 'Marble Valley', 33.0438919067383, 0.57672471144569, -86.4519424438477, -1.50887104038977, 218, 2, 'PPL', 'P'),
(22865, 'Marble Valley', 33.6238899230957, 0.586847586486163, -83.8969421386719, -1.464277872675, 218, 13, 'PPL', 'P'),
(103993, 'Marble Valley', 38.1352806091309, 0.665586207801282, -79.4255599975586, -1.3862375321977, 218, 53, 'PPL', 'P'),
(88816, 'Marbledale', 35.9577789306641, 0.627581634044334, -83.8186111450195, -1.46291073892941, 218, 50, 'PPL', 'P'),
(27795, 'Marblehead', 39.8397216796875, 0.695334316388713, -91.3683319091797, -1.59467822387018, 218, 18, 'PPL', 'P'),
(125330, 'Marblehead', 42.5, 0.74176493209759, -70.8583297729492, -1.23671115700189, 218, 23, 'PPL', 'P'),
(156330, 'Marblehead', 41.5402793884277, 0.7250146475264, -82.7355575561523, -1.44400788782813, 218, 41, 'PPL', 'P'),
(175163, 'Marblehead', 43.7041702270508, 0.762781667314114, -88.3836135864258, -1.54258506189352, 218, 57, 'PPL', 'P'),
(125331, 'Marblehead Lighthouse', 42.5061111450195, 0.741871591699248, -70.8344421386719, -1.23629423913324, 218, 23, 'PPL', 'P'),
(125332, 'Marblehead Neck', 42.5, 0.74176493209759, -70.8375015258789, -1.23634763551309, 218, 23, 'PPL', 'P'),
(22866, 'Marblehill', 34.4305610656738, 0.600926653904976, -84.3369369506836, -1.4719572308363, 218, 13, 'PPL', 'P'),
(208026, 'Marblemount', 48.5277786254883, 0.846969515693699, -121.448333740234, -2.11967329482801, 218, 56, 'PPL', 'P'),
(88817, 'Marbleton', 36.2402801513672, 0.632512210486506, -82.3277816772461, -1.436890856131, 218, 50, 'PPL', 'P'),
(209588, 'Marbleton', 42.5536117553711, 0.742700633746589, -110.108612060547, -1.92175781525768, 218, 59, 'PPL', 'P'),
(120508, 'Marbletown', 40.2313919067383, 0.702170251432782, -90.1972198486328, -1.57423846250382, 218, 18, 'PPL', 'P'),
(150562, 'Marbletown', 41.8833312988281, 0.731002032868144, -74.1136093139648, -1.29352650306542, 218, 40, 'PPL', 'P'),
(78679, 'Marborough West', 39.9258308410645, 0.696837204770872, -76.7113876342773, -1.3388662879918, 218, 45, 'PPL', 'P'),
(78677, 'Marburg', 39.7847213745117, 0.694374379973793, -76.8861083984375, -1.341915740598, 218, 45, 'PPL', 'P'),
(3985, 'Marbury', 32.7011108398438, 0.570742053214882, -86.4711074829102, -1.50920553342269, 218, 2, 'PPL', 'P'),
(49226, 'Marbury', 38.5752792358398, 0.673265632541607, -77.1558303833008, -1.34662327729888, 218, 25, 'PPL', 'P'),
(41973, 'Marburyville (historical)', 30.6388893127441, 0.534749497661488, -90.4638900756836, -1.5788927359829, 218, 22, 'PPL', 'P'),
(88818, 'Marbuts', 35.0272216796875, 0.611340346136485, -87.1677780151367, -1.52136472801166, 218, 50, 'PPL', 'P'),
(41974, 'Marcarco', 32.7172203063965, 0.571023216446967, -91.9908294677734, -1.60554285585327, 218, 22, 'PPL', 'P'),
(41975, 'Marce', 29.9424991607666, 0.522595196631016, -91.8841705322266, -1.6036813062513, 218, 22, 'PPL', 'P'),
(41976, 'Marceaux', 29.9636096954346, 0.522963644967829, -92.4113922119141, -1.61288306044975, 218, 22, 'PPL', 'P'),
(183092, 'Marcel', 35.1902809143066, 0.614186266656371, -118.516387939453, -2.06850118711436, 218, 6, 'PPL', 'P'),
(56078, 'Marceline', 39.7119407653809, 0.693104118712853, -92.9480590820313, -1.62224966431966, 218, 29, 'PPL', 'P'),
(136732, 'Marcell', 47.5930595397949, 0.830655590067119, -93.690559387207, -1.63520873934204, 218, 28, 'PPL', 'P'),
(10305, 'Marcella', 35.7880592346191, 0.624619466542866, -91.8836135864258, -1.60367158571333, 218, 4, 'PPL', 'P'),
(60765, 'Marcella', 33.1294403076172, 0.578217812710843, -90.2975006103516, -1.57598869197222, 218, 30, 'PPL', 'P'),
(145699, 'Marcella', 40.9869384765625, 0.715357026728364, -74.4747161865234, -1.29982900694315, 218, 37, 'PPL', 'P'),
(88819, 'Marcella (historical)', 35.3638916015625, 0.617216344765636, -87.2152786254883, -1.522193770059, 218, 50, 'PPL', 'P'),
(120509, 'Marcelline', 40.1180610656738, 0.700192255112153, -91.3672180175781, -1.59465878279422, 218, 18, 'PPL', 'P'),
(175164, 'Marcellon', 43.5686111450195, 0.760415715001687, -89.2655563354492, -1.55797786667807, 218, 57, 'PPL', 'P'),
(37053, 'Marcellus', 37.6861114501953, 0.657746727079443, -84.6772232055664, -1.47789634638328, 218, 21, 'PPL', 'P'),
(131929, 'Marcellus', 42.0258293151855, 0.733489092431142, -85.815559387207, -1.49776406074749, 218, 27, 'PPL', 'P'),
(150558, 'Marcellus', 42.982780456543, 0.750191040628546, -76.3408279418945, -1.33239880128455, 218, 40, 'PPL', 'P'),
(208025, 'Marcellus', 47.2336082458496, 0.824381981487219, -118.404167175293, -2.06654256529066, 218, 56, 'PPL', 'P'),
(150559, 'Marcellus Falls', 43.0050010681152, 0.750578863462289, -76.3383331298828, -1.33235525860072, 218, 40, 'PPL', 'P'),
(103994, 'Marcem', 36.6302795410156, 0.63931898391664, -82.6086120605469, -1.44179227095924, 218, 53, 'PPL', 'P'),
(56080, 'March', 37.5224990844727, 0.654891152600606, -93.0891723632813, -1.62471255569577, 218, 29, 'PPL', 'P'),
(136733, 'March', 48.1949996948242, 0.841161427672345, -96.8969421386719, -1.69117067543426, 218, 28, 'PPL', 'P'),
(10306, 'March (historical)', 35.8797187805176, 0.626219227409676, -90.7763900756836, -1.58434688989538, 218, 4, 'PPL', 'P'),
(183088, 'March Field', 33.9000015258789, 0.591666643057689, -117.254173278809, -2.04647138541917, 218, 6, 'PPL', 'P'),
(175166, 'March Rapids', 44.8444404602051, 0.78268313724514, -90.1500015258789, -1.5734143473045, 218, 57, 'PPL', 'P'),
(41980, 'Marchand', 30.149169921875, 0.52620228187996, -90.9941711425781, -1.5881478865612, 218, 22, 'PPL', 'P'),
(164218, 'Marchand', 40.8574981689453, 0.71309786717565, -79.023063659668, -1.37921264587429, 218, 45, 'PPL', 'P'),
(156334, 'Marchand (historical)', 40.8816719055176, 0.713519778471346, -81.4283294677734, -1.42119245361137, 218, 41, 'PPL', 'P'),
(164219, 'Marchandville', 40.0738906860352, 0.699421336555603, -79.8966674804688, -1.39445990890526, 218, 45, 'PPL', 'P'),
(183089, 'Marchant', 38.8230590820313, 0.677590206677733, -121.678886413574, -2.12369719807706, 218, 6, 'PPL', 'P'),
(88820, 'Marchbanks (historical)', 36.211669921875, 0.632012867782117, -85.4166717529297, -1.49080215818386, 218, 50, 'PPL', 'P'),
(10307, 'Marche', 34.8633308410645, 0.608479911388659, -92.3622207641602, -1.61202485678847, 218, 4, 'PPL', 'P'),
(188976, 'Marcia', 32.8286094665527, 0.572967324042725, -105.767219543457, -1.84598622171302, 218, 38, 'PPL', 'P'),
(17019, 'Marco', 25.9722194671631, 0.453300743752563, -81.7291717529297, -1.42644314201657, 218, 12, 'PPL', 'P'),
(30424, 'Marco', 38.9358291625977, 0.679558415881356, -87.142219543457, -1.52091864852908, 218, 19, 'PPL', 'P'),
(41977, 'Marco', 31.5091705322266, 0.549938770359728, -92.7647171020508, -1.61904974311188, 218, 22, 'PPL', 'P'),
(56081, 'Marco', 36.7477798461914, 0.641369751114055, -89.8080596923828, -1.56744633645969, 218, 29, 'PPL', 'P'),
(95996, 'Marco', 31.1399993896484, 0.54349551841839, -99.5800018310547, -1.73799890109389, 218, 51, 'PPL', 'P'),
(27796, 'Marcoe', 38.2669410705566, 0.667884116347857, -88.9663925170898, -1.55275647304486, 218, 18, 'PPL', 'P'),
(201182, 'Marcola', 44.1725006103516, 0.77095557448984, -122.859443664551, -2.1443018091149, 218, 43, 'PPL', 'P'),
(183090, 'Marconi', 38.1438903808594, 0.66573647666579, -122.877220153809, -2.14461206738189, 218, 6, 'PPL', 'P'),
(210679, 'Marconi', 21.7033290863037, 0.378794551199852, -157.97721862793, -2.75722260820029, 218, 15, 'PPL', 'P'),
(3986, 'Marcoot', 32.9577789306641, 0.575221756484504, -85.4891662597656, -1.49206742601776, 218, 2, 'PPL', 'P'),
(56082, 'Marcoot', 37.5544395446777, 0.655448618795787, -91.2583312988281, -1.59275835104034, 218, 29, 'PPL', 'P'),
(194309, 'Marcott', 40.8786087036133, 0.713466315512463, -102.723609924316, -1.79286521271364, 218, 7, 'PPL', 'P'),
(37054, 'Marcum', 37.1105613708496, 0.647701483184746, -83.5597229003906, -1.45839228666592, 218, 21, 'PPL', 'P'),
(37055, 'Marcus', 38.5680618286133, 0.673139665022047, -84.4641723632813, -1.47417790771126, 218, 21, 'PPL', 'P'),
(116722, 'Marcus', 42.8258285522461, 0.747451713131291, -95.8072204589844, -1.67215144419335, 218, 16, 'PPL', 'P'),
(120510, 'Marcus', 42.1583290100098, 0.735801648363712, -90.1958312988281, -1.5742142277379, 218, 18, 'PPL', 'P'),
(202345, 'Marcus', 44.6580581665039, 0.779430152552635, -102.27278137207, -1.78499677011495, 218, 49, 'PPL', 'P'),
(208027, 'Marcus', 48.663330078125, 0.849335334848071, -118.067222595215, -2.06066177297154, 218, 56, 'PPL', 'P'),
(3987, 'Marcus (historical)', 34.2150001525879, 0.597164406233021, -85.9830627441406, -1.50068754583412, 218, 2, 'PPL', 'P'),
(22867, 'Marcus (historical)', 34.0736083984375, 0.594696654587926, -83.6772232055664, -1.46044305386334, 218, 13, 'PPL', 'P'),
(78678, 'Marcus Hook', 39.8191719055176, 0.694975655168906, -75.4188919067383, -1.31630798197829, 218, 45, 'PPL', 'P'),
(183093, 'Marcuse (historical)', 38.952220916748, 0.679844505961458, -121.625282287598, -2.12276162958612, 218, 6, 'PPL', 'P'),
(17020, 'Marcy', 27.141939163208, 0.473716203773974, -80.6522216796875, -1.4076468173589, 218, 12, 'PPL', 'P'),
(73363, 'Marcy', 39.7516708374023, 0.693797539281682, -82.82861328125, -1.44563201661892, 218, 41, 'PPL', 'P'),
(150561, 'Marcy', 43.1705589294434, 0.753468393245025, -75.2919387817383, -1.31409223195134, 218, 40, 'PPL', 'P'),
(164220, 'Marcy', 41.5733299255371, 0.725591488218512, -75.9175033569336, -1.32501039347234, 218, 45, 'PPL', 'P'),
(175167, 'Marcy', 43.1074981689453, 0.752367775345523, -88.1327819824219, -1.5382072245356, 218, 57, 'PPL', 'P'),
(116725, 'Mardan Mobile Home Court', 40.9519386291504, 0.714746164153327, -91.5638885498047, -1.59809133112323, 218, 16, 'PPL', 'P'),
(49228, 'Mardela Springs', 38.4597206115723, 0.671248754069063, -75.7594375610352, -1.32225162489913, 218, 25, 'PPL', 'P'),
(140458, 'Mardell (historical)', 47.4602813720703, 0.828338173865559, -98.0058288574219, -1.71052439970808, 218, 34, 'PPL', 'P'),
(49229, 'Mardella Run', 39.3591690063477, 0.686947090009672, -76.820556640625, -1.3407716465937, 218, 25, 'PPL', 'P'),
(82245, 'Marden Ranchettes', 33.9644393920898, 0.592791295986029, -80.4991683959961, -1.40497553362749, 218, 48, 'PPL', 'P'),
(123133, 'Mardenis', 40.9041709899902, 0.713912461574078, -85.4136123657227, -1.490748761804, 218, 19, 'PPL', 'P'),
(164221, 'Mardin', 41.7986106872559, 0.729523379251905, -77.1655578613281, -1.34679305381837, 218, 45, 'PPL', 'P'),
(3988, 'Mardisville', 33.3844413757324, 0.582668420945556, -86.1591720581055, -1.50376123320624, 218, 2, 'PPL', 'P'),
(66617, 'Maready', 34.8058280944824, 0.607476299131862, -77.7877807617188, -1.35765289211149, 218, 33, 'PPL', 'P'),
(183094, 'Maredith Mill', 39.639720916748, 0.691843644568918, -120.88111114502, -2.1097733929498, 218, 6, 'PPL', 'P'),
(76504, 'Marena', 36.0722198486328, 0.629579004861893, -97.211669921875, -1.69666371149866, 218, 42, 'PPL', 'P'),
(164224, 'Marene Village', 40.2966690063477, 0.703309551747118, -76.789436340332, -1.34022849488938, 218, 45, 'PPL', 'P'),
(3989, 'Marengo', 32.0569381713867, 0.559499119198949, -87.8141708374023, -1.53264641102146, 218, 2, 'PPL', 'P'),
(30425, 'Marengo', 38.3691711425781, 0.669668367699183, -86.3436126708984, -1.50698032917387, 218, 19, 'PPL', 'P'),
(103995, 'Marengo', 36.6383285522461, 0.639459465664142, -78.1197204589844, -1.36344633274685, 218, 53, 'PPL', 'P'),
(116726, 'Marengo', 41.7980613708496, 0.72951379187198, -92.070556640625, -1.60693435752284, 218, 16, 'PPL', 'P'),
(120512, 'Marengo', 42.2486114501953, 0.737377374201684, -88.6083297729492, -1.54650709923088, 218, 18, 'PPL', 'P'),
(131931, 'Marengo', 42.2713890075684, 0.737774917573406, -84.8486099243164, -1.48088760891966, 218, 27, 'PPL', 'P'),
(150564, 'Marengo', 43.0258293151855, 0.750942384951085, -76.9108276367188, -1.34234717269459, 218, 40, 'PPL', 'P'),
(156331, 'Marengo', 40.4008293151855, 0.705127492086234, -82.8108291625977, -1.44532162519387, 218, 41, 'PPL', 'P'),
(164222, 'Marengo', 40.7311096191406, 0.710891970844737, -78.0313873291016, -1.36190462879181, 218, 45, 'PPL', 'P'),
(175168, 'Marengo', 46.4225006103516, 0.810225482659712, -90.8166732788086, -1.58504996442316, 218, 57, 'PPL', 'P'),
(199511, 'Marengo', 40.6386108398438, 0.709277562591931, -100.910003662109, -1.76121181210334, 218, 35, 'PPL', 'P'),
(208029, 'Marengo', 46.4408302307129, 0.810545394885658, -117.747779846191, -2.05508644522946, 218, 56, 'PPL', 'P'),
(131933, 'Marenisco', 46.3763885498047, 0.80942067537829, -89.6961135864258, -1.56549250832595, 218, 27, 'PPL', 'P'),
(37056, 'Maretburg', 37.355281829834, 0.651972660941015, -84.3872222900391, -1.47283487557353, 218, 21, 'PPL', 'P'),
(22868, 'Maretts', 34.4230613708496, 0.600795759537399, -82.9858322143555, -1.44837600464808, 218, 13, 'PPL', 'P'),
(191830, 'Marfa', 30.3077793121338, 0.528970537964557, -104.018608093262, -1.81546719456904, 218, 51, 'PPL', 'P'),
(110287, 'Marfork', 37.9441719055176, 0.662250731694013, -81.5111083984375, -1.42263721850274, 218, 58, 'PPL', 'P'),
(110285, 'Marfrance', 38.0555610656738, 0.66419483928977, -80.6913909912109, -1.40833045081072, 218, 58, 'PPL', 'P'),
(3991, 'Margaret', 33.6861114501953, 0.58793355699967, -86.4749984741211, -1.50927344403049, 218, 2, 'PPL', 'P'),
(66616, 'Margaret', 36.0247192382813, 0.628749962814551, -78.2263870239258, -1.36530801550687, 218, 33, 'PPL', 'P'),
(95997, 'Margaret', 34.0494384765625, 0.594274809871258, -99.6508331298828, -1.7392351404719, 218, 51, 'PPL', 'P'),
(110286, 'Margaret', 39.4583282470703, 0.68867774524406, -80.4436111450195, -1.4040058766746, 218, 58, 'PPL', 'P'),
(164223, 'Margaret', 40.7802810668945, 0.711750174506016, -79.3713912963867, -1.38529211001072, 218, 45, 'PPL', 'P'),
(204814, 'Margarethe', 40.8263893127441, 0.71255491520841, -111.73388671875, -1.95012420929255, 218, 52, 'PPL', 'P'),
(17021, 'Margaretta', 30.2652797698975, 0.528228781021942, -82.220832824707, -1.43502424652297, 218, 12, 'PPL', 'P'),
(78681, 'Margaretta Furnace', 39.9652786254883, 0.697525698491684, -76.5369415283203, -1.33582162907557, 218, 45, 'PPL', 'P'),
(66621, 'Margarettsville', 36.5311088562012, 0.63758812894517, -77.3491668701172, -1.34999763555806, 218, 33, 'PPL', 'P'),
(150565, 'Margaretville', 42.148609161377, 0.735632005002274, -74.6486129760742, -1.30286407847946, 218, 40, 'PPL', 'P'),
(95998, 'Margarita Addition Number 1 Colonia', 26.4099998474121, 0.460941452788541, -98.9769973754883, -1.72747448794006, 218, 51, 'PPL', 'P'),
(95999, 'Margarita Colonia', 26.4109992980957, 0.460958896493681, -98.9769973754883, -1.72747448794006, 218, 51, 'PPL', 'P'),
(17022, 'Margate', 26.2441692352295, 0.458047162605357, -80.206672668457, -1.39987052013392, 218, 12, 'PPL', 'P'),
(49231, 'Margate', 39.4894409179688, 0.689220763790327, -76.4416732788086, -1.33415888444898, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(71081, 'Margate City', 39.3277816772461, 0.686399277773442, -74.5038909912109, -1.30033820334357, 218, 37, 'PPL', 'P'),
(17023, 'Margate Estates', 26.2224998474121, 0.457668960441052, -80.1999969482422, -1.39975400683623, 218, 12, 'PPL', 'P'),
(113678, 'Margerie Manor', 41.452220916748, 0.723477737261316, -73.4677810668945, -1.28225467375166, 218, 8, 'PPL', 'P'),
(3992, 'Margerum', 34.7669410705566, 0.606797592528056, -88.0683288574219, -1.53708230529115, 218, 2, 'PPL', 'P'),
(96000, 'Margie', 31.2291698455811, 0.545051836469919, -96.1308288574219, -1.67779947623319, 218, 51, 'PPL', 'P'),
(136734, 'Margie', 48.0952796936035, 0.839420985320951, -93.9397201538086, -1.63955741508603, 218, 28, 'PPL', 'P'),
(22869, 'Margie (historical)', 34.4011116027832, 0.600412663814591, -85.1113891601563, -1.48547397179094, 218, 13, 'PPL', 'P'),
(128064, 'Margison', 46.9169387817383, 0.81885505669795, -68.1388931274414, -1.18924803373839, 218, 26, 'PPL', 'P'),
(103996, 'Margo', 38.1605606079102, 0.666027427014881, -77.7244415283203, -1.356547413943, 218, 53, 'PPL', 'P'),
(164234, 'Margo Gardens', 40.1202812194824, 0.700231004106014, -74.8691711425781, -1.30671354467711, 218, 45, 'PPL', 'P'),
(22870, 'Margret', 34.7544403076172, 0.606579413055751, -84.146110534668, -1.46862668157704, 218, 13, 'PPL', 'P'),
(41978, 'Marguerite', 29.8761100769043, 0.521436488530236, -91.6777801513672, -1.60007911456086, 218, 22, 'PPL', 'P'),
(88821, 'Marguerite', 36.2558288574219, 0.632783586601586, -83.258056640625, -1.45312721719084, 218, 50, 'PPL', 'P'),
(164225, 'Marguerite', 40.2636108398438, 0.702732577896953, -79.4636077880859, -1.38690159141551, 218, 45, 'PPL', 'P'),
(183095, 'Marguerite (historical)', 37.1708297729492, 0.6487533652363, -120.176391601563, -2.09747371661333, 218, 6, 'PPL', 'P'),
(41979, 'Maria', 29.7316703796387, 0.518915540242367, -91.4241714477539, -1.5956528076711, 218, 22, 'PPL', 'P'),
(164226, 'Maria', 40.2177810668945, 0.701932697463547, -78.4072189331055, -1.36846412771473, 218, 45, 'PPL', 'P'),
(49232, 'Maria Acres', 38.398609161377, 0.670182158052486, -75.519172668457, -1.31805821144669, 218, 25, 'PPL', 'P'),
(78682, 'Maria Furnace', 39.7750015258789, 0.694204736612355, -77.4052810668945, -1.35097701304894, 218, 45, 'PPL', 'P'),
(156333, 'Maria Stein', 40.4077796936035, 0.705248799073887, -84.4933319091797, -1.47468683779557, 218, 41, 'PPL', 'P'),
(30426, 'Mariah Hill', 38.1652793884277, 0.666109785271592, -86.9247207641602, -1.51712257871128, 218, 19, 'PPL', 'P'),
(201183, 'Marial', 42.7125015258789, 0.745473783389689, -123.88777923584, -2.16224965064927, 218, 43, 'PPL', 'P'),
(96001, 'Mariam', 30.2138900756836, 0.527331861656317, -94.7541732788086, -1.65377230372044, 218, 51, 'PPL', 'P'),
(142354, 'Marian Center', 40.8824996948242, 0.71353422612026, -96.5688934326172, -1.6854451454067, 218, 35, 'PPL', 'P'),
(123134, 'Marian Manor', 41.4669418334961, 0.723734665727481, -87.0875015258789, -1.51996363896217, 218, 19, 'PPL', 'P'),
(204816, 'Marian Meadows', 40.6636085510254, 0.709713854957514, -111.941940307617, -1.95375542943887, 218, 52, 'PPL', 'P'),
(193765, 'Marian Place', 40.310001373291, 0.703542245447364, -121.820281982422, -2.12616501630119, 218, 6, 'PPL', 'P'),
(183096, 'Mariana Ranchos', 34.4241714477539, 0.600815134034329, -117.195831298828, -2.04545312577637, 218, 6, 'PPL', 'P'),
(150566, 'Mariandale', 41.1744384765625, 0.718629519075854, -73.8675003051758, -1.28923109054323, 218, 40, 'PPL', 'P'),
(10308, 'Marianna', 34.773609161377, 0.606913972667692, -90.7574996948242, -1.58401719055243, 218, 4, 'PPL', 'P'),
(17025, 'Marianna', 30.774169921875, 0.537110589704925, -85.226936340332, -1.4874906505264, 218, 12, 'PPL', 'P'),
(60766, 'Marianna', 34.7174987792969, 0.605934661755843, -89.5988922119141, -1.56379567523741, 218, 30, 'PPL', 'P'),
(110288, 'Marianna', 37.6002807617188, 0.656248698966274, -81.6113891601563, -1.42438744797114, 218, 58, 'PPL', 'P'),
(164227, 'Marianna', 40.0247192382813, 0.698563132894325, -80.1002807617188, -1.39801363106386, 218, 45, 'PPL', 'P'),
(22871, 'Marianna (historical)', 30.809440612793, 0.537726179390897, -81.5347213745117, -1.42304934268143, 218, 13, 'PPL', 'P'),
(164229, 'Marianne', 41.2463912963867, 0.719885332687881, -79.4291687011719, -1.38630051595748, 218, 45, 'PPL', 'P'),
(145700, 'Mariannes Corner', 40.6530609130859, 0.709529763947162, -74.9124984741211, -1.30746974926864, 218, 37, 'PPL', 'P'),
(187027, 'Mariano', 37.1794395446777, 0.648903634100808, -108.872779846191, -1.90018847411497, 218, 7, 'PPL', 'P'),
(188977, 'Mariano Lake', 35.5780601501465, 0.620954291092644, -108.321388244629, -1.89056487519986, 218, 38, 'PPL', 'P'),
(164230, 'Mariasville', 41.2088890075684, 0.719230794270966, -79.6608276367188, -1.39034372712444, 218, 45, 'PPL', 'P'),
(128065, 'Mariaville', 44.7205581665039, 0.780520983335132, -68.4161071777344, -1.19408633164879, 218, 26, 'PPL', 'P'),
(142355, 'Mariaville', 42.7752799987793, 0.746569474441175, -99.3349990844727, -1.7337227964896, 218, 35, 'PPL', 'P'),
(150567, 'Mariaville', 42.8286094665527, 0.747500249242157, -74.1355590820313, -1.29390959878823, 218, 40, 'PPL', 'P'),
(150568, 'Mariaville Lake', 42.8247184753418, 0.74743233863436, -74.1291732788086, -1.29379814549661, 218, 40, 'PPL', 'P'),
(37057, 'Mariba', 37.9161109924316, 0.661760976369547, -83.57861328125, -1.45872198600887, 218, 21, 'PPL', 'P'),
(66618, 'Maribel', 35.1666717529297, 0.613774209056709, -76.7069396972656, -1.33878865684603, 218, 33, 'PPL', 'P'),
(175170, 'Maribel', 44.2763900756836, 0.77276878771802, -87.8072204589844, -1.5325251040338, 218, 57, 'PPL', 'P'),
(17026, 'Maricamp', 29.1622200012207, 0.508976756212246, -82.0924987792969, -1.43278439488816, 218, 12, 'PPL', 'P'),
(178592, 'Maricopa', 33.0580596923828, 0.576971985952904, -112.046943664551, -1.95558808374301, 218, 5, 'PPL', 'P'),
(183097, 'Maricopa', 35.0588912963867, 0.611893085220731, -119.400001525879, -2.08392315351284, 218, 6, 'PPL', 'P'),
(178594, 'Maricopa Village', 33.3713912963867, 0.582440654093327, -112.236938476563, -1.95890411877432, 218, 5, 'PPL', 'P'),
(178595, 'Maricopa Wells', 33.1619415283203, 0.57878506602303, -112.08332824707, -1.95622311450494, 218, 5, 'PPL', 'P'),
(10309, 'Marie', 35.610279083252, 0.621516617556815, -90.0808334350586, -1.57220713638237, 218, 4, 'PPL', 'P'),
(110289, 'Marie', 37.583610534668, 0.655957748617182, -80.7616729736328, -1.40955710280881, 218, 58, 'PPL', 'P'),
(191831, 'Marie', 31.8992290496826, 0.556746575764783, -100.208648681641, -1.7489708584689, 218, 51, 'PPL', 'P'),
(190453, 'Marie Camp', 35.7083282470703, 0.623227898294272, -114.816673278809, -2.0039289849018, 218, 39, 'PPL', 'P'),
(49233, 'Mariellen Park', 38.5066719055176, 0.672068208736481, -76.9550018310547, -1.34311815783017, 218, 25, 'PPL', 'P'),
(73364, 'Mariemont', 39.1450004577637, 0.683209143682664, -84.3744430541992, -1.47261183583224, 218, 41, 'PPL', 'P'),
(183098, 'Mariemont', 38.7147216796875, 0.675699362303776, -120.938888549805, -2.11078179889656, 218, 6, 'PPL', 'P'),
(60767, 'Marienette', 34.871940612793, 0.608630180253166, -90.2180633544922, -1.57460225030873, 218, 30, 'PPL', 'P'),
(187794, 'Marienthal', 38.4874992370605, 0.671733582545512, -101.212501525879, -1.76649139580637, 218, 20, 'PPL', 'P'),
(164231, 'Marienville', 41.4688911437988, 0.723768687610407, -79.1233291625977, -1.38096260902658, 218, 45, 'PPL', 'P'),
(3994, 'Marietta', 33.7005615234375, 0.588185758354901, -87.3938903808594, -1.525311133273, 218, 2, 'PPL', 'P'),
(17027, 'Marietta', 30.3188896179199, 0.529164449381428, -81.783332824707, -1.42738843104549, 218, 12, 'PPL', 'P'),
(22872, 'Marietta', 33.9524993896484, 0.59258290363073, -84.5500030517578, -1.47567593582443, 218, 13, 'PPL', 'P'),
(30427, 'Marietta', 39.4413909912109, 0.688382134363061, -85.8838882446289, -1.49895662428363, 218, 19, 'PPL', 'P'),
(33192, 'Marietta', 39.9430618286133, 0.697137942236969, -96.6083297729492, -1.68613343939043, 218, 20, 'PPL', 'P'),
(60768, 'Marietta', 34.5019416809082, 0.602172480662915, -88.4688873291016, -1.54407336946871, 218, 30, 'PPL', 'P'),
(66619, 'Marietta', 34.3686103820801, 0.599845410502404, -79.1224975585938, -1.38094809479864, 218, 33, 'PPL', 'P'),
(73366, 'Marietta', 39.4152793884277, 0.687926400921521, -81.4550018310547, -1.42165797416991, 218, 41, 'PPL', 'P'),
(76506, 'Marietta', 33.936939239502, 0.59231132777857, -97.1163864135742, -1.69500070055596, 218, 42, 'PPL', 'P'),
(82246, 'Marietta', 35.0208282470703, 0.611228759686811, -82.5016708374023, -1.43992579450926, 218, 48, 'PPL', 'P'),
(96002, 'Marietta', 33.1733283996582, 0.578983804419377, -94.5422210693359, -1.65007303980827, 218, 51, 'PPL', 'P'),
(116728, 'Marietta', 42.0830612182617, 0.734487977577003, -93.0002822875977, -1.62316113120274, 218, 16, 'PPL', 'P'),
(120514, 'Marietta', 40.5011100769043, 0.706877721554634, -90.3925018310547, -1.57764677606691, 218, 18, 'PPL', 'P'),
(136735, 'Marietta', 45.0083312988281, 0.785543571992967, -96.4172210693359, -1.68279796328316, 218, 28, 'PPL', 'P'),
(150569, 'Marietta', 42.9088897705078, 0.748901404870675, -76.3238906860352, -1.33210319040355, 218, 40, 'PPL', 'P'),
(164232, 'Marietta', 40.0569381713867, 0.699125459358495, -76.5524978637695, -1.3360931383487, 218, 45, 'PPL', 'P'),
(190454, 'Marietta', 38.2433280944824, 0.667471992169167, -118.337783813477, -2.06538395705842, 218, 39, 'PPL', 'P'),
(202342, 'Marietta', 43.3919410705566, 0.757332240512567, -103.918891906738, -1.81372681879667, 218, 49, 'PPL', 'P'),
(208030, 'Marietta', 48.7872200012207, 0.851497621916133, -122.579170227051, -2.13941011482464, 218, 56, 'PPL', 'P'),
(22873, 'Marietta Mobile Home Park', 33.9972190856934, 0.593363409567205, -84.595832824707, -1.47647581625783, 218, 13, 'PPL', 'P'),
(22874, 'Marietta Place Homes (historical)', 33.9422187805176, 0.592403473152286, -84.5338897705078, -1.47539470601332, 218, 13, 'PPL', 'P'),
(169478, 'Marieville', 41.8683280944824, 0.730740177553962, -71.434440612793, -1.24676618801359, 218, 47, 'PPL', 'P'),
(3995, 'Marigold', 33.938060760498, 0.592330902012582, -87.3150024414063, -1.52393427898943, 218, 2, 'PPL', 'P'),
(27798, 'Marigold', 38.079719543457, 0.664616484269357, -90.0063934326172, -1.57090791324457, 218, 18, 'PPL', 'P'),
(183103, 'Marigold', 34.0777816772461, 0.59476949204374, -117.240562438965, -2.04623383144993, 218, 6, 'PPL', 'P'),
(187028, 'Marigold', 38.6611099243164, 0.674763660654777, -105.220832824707, -1.83644997448166, 218, 7, 'PPL', 'P'),
(183099, 'Marigold (historical)', 39.1813888549805, 0.68384424102362, -121.456672668457, -2.11981883658158, 218, 6, 'PPL', 'P'),
(96003, 'Marilee', 33.4036102294922, 0.583002980557497, -96.7611083984375, -1.68879992943187, 218, 51, 'PPL', 'P'),
(131935, 'Marilla', 44.3708305358887, 0.774417084695697, -85.8808288574219, -1.49890322790377, 218, 27, 'PPL', 'P'),
(150570, 'Marilla', 42.8400001525879, 0.747699054217532, -78.5552825927734, -1.37104832607848, 218, 40, 'PPL', 'P'),
(191832, 'Marilla', 34.9797210693359, 0.610511304089144, -100.397216796875, -1.75226199294402, 218, 51, 'PPL', 'P'),
(22875, 'Marilyn Acres', 33.4622192382813, 0.584025900732197, -84.4852828979492, -1.47454635604807, 218, 13, 'PPL', 'P'),
(82248, 'Marilyn Acres', 34.5513916015625, 0.603035544593182, -82.6122207641602, -1.44185525471902, 218, 48, 'PPL', 'P'),
(88823, 'Marimont', 35.0222206115723, 0.611253061031758, -85.1847229003906, -1.48675388701083, 218, 50, 'PPL', 'P'),
(183100, 'Marin City', 37.8686103820801, 0.660931934322205, -122.508056640625, -2.13816894859861, 218, 6, 'PPL', 'P'),
(183102, 'Marina', 36.684440612793, 0.640264272945564, -121.801109313965, -2.12583039011022, 218, 6, 'PPL', 'P'),
(183106, 'Marina del Rey', 33.980281829834, 0.593067798686207, -118.450828552246, -2.067356959952, 218, 6, 'PPL', 'P'),
(88824, 'Marina Hills', 35.3277816772461, 0.616586107693669, -84.8383331298828, -1.48070824502024, 218, 50, 'PPL', 'P'),
(183105, 'Marina Village', 38.7152786254883, 0.675709082841755, -121.088333129883, -2.11339009886819, 218, 6, 'PPL', 'P'),
(27799, 'Marine', 38.7863883972168, 0.676950182488759, -89.7774963378906, -1.56691290529334, 218, 18, 'PPL', 'P'),
(110290, 'Marine', 37.4627799987793, 0.653848857928976, -81.6308288574219, -1.42472673469401, 218, 58, 'PPL', 'P'),
(131937, 'Marine City', 42.7194404602051, 0.74559489064026, -82.4922180175781, -1.43976081167973, 218, 27, 'PPL', 'P'),
(208031, 'Marine Drive', 47.5888900756836, 0.830582819190332, -122.673889160156, -2.14106327207131, 218, 56, 'PPL', 'P'),
(49234, 'Marine Oak Village', 39.3161087036133, 0.686195545950051, -76.4488906860352, -1.33428485196854, 218, 25, 'PPL', 'P'),
(136737, 'Marine on Saint Croix', 45.3666687011719, 0.791797739496909, -92.7708282470703, -1.61915640271354, 218, 28, 'PPL', 'P'),
(183107, 'Marine Terrace', 35.545280456543, 0.620382177511468, -121.092498779297, -2.11346280316594, 218, 6, 'PPL', 'P'),
(17028, 'Marineland', 29.6686096191406, 0.517814922342865, -81.2136077880859, -1.41744485332541, 218, 12, 'PPL', 'P'),
(123135, 'Marineland Gardens', 41.378059387207, 0.72218337439251, -85.684440612793, -1.49547560642279, 218, 19, 'PPL', 'P'),
(128067, 'Mariner', 43.6969413757324, 0.762655500057471, -70.1513900756836, -1.22437273167155, 218, 26, 'PPL', 'P'),
(49235, 'Mariners', 37.9891700744629, 0.663036097899477, -75.8308334350586, -1.32349771797317, 218, 25, 'PPL', 'P'),
(49237, 'Mariners Cove', 39.5605583190918, 0.690461996595385, -75.8713912963867, -1.32420558619092, 218, 25, 'PPL', 'P'),
(150572, 'Mariners Harbor', 40.6366691589355, 0.70924367386706, -74.1591720581055, -1.29432172296692, 218, 40, 'PPL', 'P'),
(22876, 'Mariners Landing', 30.7702808380127, 0.537042712386641, -81.6205596923828, -1.42454750395265, 218, 13, 'PPL', 'P'),
(156335, 'Mariners Point', 40.5461082458496, 0.707663087760098, -84.5491714477539, -1.47566142159649, 218, 41, 'PPL', 'P'),
(82249, 'Mariners Watch', 32.3833312988281, 0.565195753928682, -80.6947174072266, -1.40838850772249, 218, 48, 'PPL', 'P'),
(66623, 'Marines', 34.5786094665527, 0.603510585952625, -77.3636093139648, -1.35024970375524, 218, 33, 'PPL', 'P'),
(175172, 'Marinette', 45.0999984741211, 0.787143466017832, -87.6305618286133, -1.52944182928176, 218, 57, 'PPL', 'P'),
(49239, 'Maring Manor', 39.5966682434082, 0.691092233667353, -77.0666732788086, -1.34506719227394, 218, 25, 'PPL', 'P'),
(41982, 'Maringouin', 30.4911098480225, 0.53217025943526, -91.5194396972656, -1.59731555229769, 218, 22, 'PPL', 'P'),
(183108, 'Marinwood', 38.038330078125, 0.663894101823673, -122.536666870117, -2.138668291303, 218, 6, 'PPL', 'P'),
(96004, 'Mario Olga Colonia', 27.6070003509521, 0.481833052723345, -98.4150009155273, -1.71766579932919, 218, 51, 'PPL', 'P'),
(630, 'Marion', 38.0391693115234, 0.663908749209669, -75.771110534668, -1.32245535672252, 218, 25, 'PPL', 'P'),
(4000, 'Marion', 32.6322212219238, 0.569539702561738, -87.3191680908203, -1.52400698328719, 218, 2, 'PPL', 'P'),
(10310, 'Marion', 35.2144393920898, 0.614607911635958, -90.1963882446289, -1.57422394827588, 218, 4, 'PPL', 'P'),
(17029, 'Marion', 30.4411106109619, 0.531297608125068, -82.9466705322266, -1.44769250435431, 218, 12, 'PPL', 'P'),
(22879, 'Marion', 32.6622200012207, 0.570063280032048, -83.4372177124023, -1.45625416778475, 218, 13, 'PPL', 'P'),
(27802, 'Marion', 37.7305603027344, 0.658522505904983, -88.9330596923828, -1.55217470550474, 218, 18, 'PPL', 'P'),
(33193, 'Marion', 38.348331451416, 0.669304646473305, -97.0169372558594, -1.6932649853155, 218, 20, 'PPL', 'P'),
(37058, 'Marion', 37.3327789306641, 0.651579911259256, -88.0811080932617, -1.53730534503244, 218, 21, 'PPL', 'P'),
(41983, 'Marion', 32.9013900756836, 0.574237585303665, -92.241943359375, -1.60992562005921, 218, 22, 'PPL', 'P'),
(56084, 'Marion', 38.6908302307129, 0.675282377856097, -92.3661117553711, -1.61209276739626, 218, 29, 'PPL', 'P'),
(60769, 'Marion', 32.4172210693359, 0.565787242006789, -88.6477813720703, -1.54719565953072, 218, 30, 'PPL', 'P'),
(66622, 'Marion', 35.6838912963867, 0.622801393045696, -82.0094375610352, -1.43133470314877, 218, 33, 'PPL', 'P'),
(78683, 'Marion', 39.8572196960449, 0.695639714386717, -77.695556640625, -1.35604327754865, 218, 45, 'PPL', 'P'),
(82250, 'Marion', 34.1780586242676, 0.596519654933113, -79.4008331298828, -1.38580596694305, 218, 48, 'PPL', 'P'),
(88826, 'Marion', 36.3286094665527, 0.634053847862526, -87.4338912963867, -1.52600928095276, 218, 50, 'PPL', 'P'),
(96005, 'Marion', 29.5711097717285, 0.516113228985331, -98.1399993896484, -1.71286611725459, 218, 51, 'PPL', 'P'),
(103998, 'Marion', 36.8347206115723, 0.642887153724155, -81.5149993896484, -1.42270512911053, 218, 53, 'PPL', 'P'),
(110291, 'Marion', 39.6755599975586, 0.692469154529951, -80.7716674804688, -1.40973153986021, 218, 58, 'PPL', 'P'),
(113679, 'Marion', 41.5636100769043, 0.725421844857074, -72.9261093139648, -1.27280071819799, 218, 8, 'PPL', 'P'),
(116730, 'Marion', 42.0341682434082, 0.733634634184714, -91.5975036621094, -1.59867802551137, 218, 16, 'PPL', 'P'),
(123136, 'Marion', 40.5583305358887, 0.707876406963413, -85.6591720581055, -1.49503458694627, 218, 19, 'PPL', 'P'),
(125334, 'Marion', 41.7000007629395, 0.727802311397441, -70.7633285522461, -1.23505307290721, 218, 23, 'PPL', 'P'),
(128068, 'Marion', 44.8783302307129, 0.783274625323246, -67.317497253418, -1.17491197127438, 218, 26, 'PPL', 'P'),
(131939, 'Marion', 44.1025009155273, 0.769733849339766, -85.1469421386719, -1.48609448832493, 218, 27, 'PPL', 'P'),
(136739, 'Marion', 43.9436111450195, 0.766960699696666, -92.3480606079102, -1.61177771543931, 218, 28, 'PPL', 'P'),
(140459, 'Marion', 46.6072196960449, 0.813449438896335, -98.3319396972656, -1.7162161075898, 218, 34, 'PPL', 'P'),
(150573, 'Marion', 43.1433296203613, 0.7529931521485, -77.1894378662109, -1.34720983852897, 218, 40, 'PPL', 'P'),
(156336, 'Marion', 40.5886116027832, 0.70840491128174, -83.1286087036133, -1.45086792448007, 218, 41, 'PPL', 'P'),
(170823, 'Marion', 43.4230613708496, 0.757875392216888, -97.2602767944336, -1.6975120614639, 218, 49, 'PPL', 'P'),
(175175, 'Marion', 44.6708297729492, 0.779653059135875, -88.8891677856445, -1.55140864721717, 218, 57, 'PPL', 'P'),
(195286, 'Marion', 42.2866706848145, 0.738041633156578, -113.910278320313, -1.98810940855257, 218, 17, 'PPL', 'P'),
(196984, 'Marion', 48.1055603027344, 0.839600415799395, -114.662216186523, -2.00123320008837, 218, 31, 'PPL', 'P'),
(199512, 'Marion', 40.0158309936523, 0.698408003760828, -100.480003356934, -1.75370689099345, 218, 35, 'PPL', 'P'),
(201184, 'Marion', 44.7491683959961, 0.781020326039522, -122.941108703613, -2.14572713293031, 218, 43, 'PPL', 'P'),
(204819, 'Marion', 40.6775016784668, 0.709956335774765, -111.280281066895, -1.94220729716202, 218, 52, 'PPL', 'P'),
(164235, 'Marion Center', 40.7700004577637, 0.711570744027571, -79.0502777099609, -1.3796876206547, 218, 45, 'PPL', 'P'),
(201186, 'Marion Forks', 44.6155586242676, 0.778688395610021, -121.946937561035, -2.12837557316401, 218, 43, 'PPL', 'P'),
(30430, 'Marion Heights', 39.4947204589844, 0.689312909164043, -87.4458312988281, -1.52621767330806, 218, 19, 'PPL', 'P'),
(164237, 'Marion Heights', 40.8041687011719, 0.712167092374667, -76.4652786254883, -1.33457087546961, 218, 45, 'PPL', 'P'),
(164239, 'Marion Hill', 40.730281829834, 0.710877523195824, -80.2961120605469, -1.40143153200687, 218, 45, 'PPL', 'P'),
(3998, 'Marion Junction', 32.4372215270996, 0.566136315846671, -87.2388916015625, -1.52260589423769, 218, 2, 'PPL', 'P'),
(30431, 'Marion Mills', 39.3063888549805, 0.686025902588613, -86.998893737793, -1.51841714131716, 218, 19, 'PPL', 'P'),
(116732, 'Marion Mobile Home Park', 42.0333290100098, 0.733619986798719, -91.5694427490234, -1.59818827018691, 218, 16, 'PPL', 'P'),
(17031, 'Marion Oaks', 29.0083293914795, 0.50629085838436, -82.1833267211914, -1.43436964152703, 218, 12, 'PPL', 'P'),
(49240, 'Marion Oaks', 38.6977806091309, 0.67540368484375, -76.5708312988281, -1.33641311715368, 218, 25, 'PPL', 'P'),
(131940, 'Marion Springs', 43.2444381713867, 0.754757829265814, -84.3272171020508, -1.47178758747486, 218, 27, 'PPL', 'P'),
(125336, 'Marions Camp', 42.1555595397949, 0.735753311989927, -71.7727813720703, -1.25267134825668, 218, 23, 'PPL', 'P'),
(56093, 'Marionville', 37.003059387207, 0.645825219617758, -93.6372222900391, -1.63427783138301, 218, 29, 'PPL', 'P'),
(103997, 'Marionville', 37.4524993896484, 0.653669427450532, -75.8550033569336, -1.32391956268984, 218, 53, 'PPL', 'P'),
(41984, 'Marionville (historical)', 30.8150005340576, 0.537823218323116, -92.841667175293, -1.62039277524961, 218, 22, 'PPL', 'P'),
(66625, 'Mariposa', 35.4144401550293, 0.618098583455752, -81.0625, -1.4148075248979, 218, 33, 'PPL', 'P'),
(150575, 'Mariposa', 42.7075004577637, 0.745386498284962, -75.8105621337891, -1.32314391702236, 218, 40, 'PPL', 'P'),
(183109, 'Mariposa', 37.4850006103516, 0.654236680762719, -119.965278625488, -2.09378910008715, 218, 6, 'PPL', 'P'),
(60771, 'Maris Town', 32.6236114501953, 0.56938943369723, -90.0188903808594, -1.57112602613785, 218, 30, 'PPL', 'P'),
(27804, 'Marissa', 38.25, 0.667588438887831, -89.75, -1.56643300366491, 218, 18, 'PPL', 'P'),
(96007, 'Marjorie', 30.6311092376709, 0.534613709735407, -97.0838928222656, -1.69443358040183, 218, 51, 'PPL', 'P'),
(37060, 'Mark', 37.1630592346191, 0.648617743757788, -84.5044403076172, -1.47488071592293, 218, 21, 'PPL', 'P'),
(56094, 'Mark', 39.8880615234375, 0.69617800582205, -91.4633331298828, -1.59633630796487, 218, 29, 'PPL', 'P'),
(116744, 'Mark', 40.6602783203125, 0.709655731466723, -92.5113906860352, -1.61462836307013, 218, 16, 'PPL', 'P'),
(120517, 'Mark', 41.2644386291504, 0.72020031806581, -89.25, -1.55770635740494, 218, 18, 'PPL', 'P'),
(195287, 'Mark', 43.7752799987793, 0.764022766961118, -111.831108093262, -1.95182104238109, 218, 17, 'PPL', 'P'),
(41985, 'Mark (historical)', 30.3502807617188, 0.529712328196685, -91.2519378662109, -1.59264676459067, 218, 22, 'PPL', 'P'),
(110293, 'Mark (historical)', 38.7255592346191, 0.675888513320199, -80.8777770996094, -1.41158350208225, 218, 58, 'PPL', 'P'),
(156344, 'Mark Center', 41.288890838623, 0.720627089630495, -84.6311111450195, -1.47709153910186, 218, 41, 'PPL', 'P'),
(82252, 'Mark Island', 32.4741706848145, 0.566781200304634, -80.6686096191406, -1.40793284085997, 218, 48, 'PPL', 'P'),
(142359, 'Mark IV Estates', 40.8561096191406, 0.71307363240973, -96.6922225952148, -1.68759764535776, 218, 35, 'PPL', 'P'),
(66626, 'Mark Pine', 34.2030601501465, 0.596956013877722, -78.6302795410156, -1.37235726975426, 218, 33, 'PPL', 'P'),
(190455, 'Mark Twain Estates', 39.3069381713867, 0.686035489968537, -119.551666259766, -2.08657020247832, 218, 39, 'PPL', 'P'),
(183111, 'Mark West Springs', 38.5491714477539, 0.672809965679095, -122.719169616699, -2.14185356512479, 218, 6, 'PPL', 'P'),
(10319, 'Marked Tree', 35.5327796936035, 0.620163998039163, -90.4205627441406, -1.57813653139137, 218, 4, 'PPL', 'P'),
(41986, 'Markee', 30.9266700744629, 0.539772219477377, -93.1152801513672, -1.62516822255828, 218, 22, 'PPL', 'P'),
(3999, 'Markeeta', 33.5800018310547, 0.586081594777629, -86.5391693115234, -1.51039343642692, 218, 2, 'PPL', 'P'),
(164244, 'Markelsville', 40.4655609130859, 0.706257271599673, -77.2322235107422, -1.34795658889863, 218, 45, 'PPL', 'P'),
(14173, 'Marker Estates', 39.2077789306641, 0.684304834734149, -75.5699996948242, -1.31894531040579, 218, 10, 'PPL', 'P'),
(78684, 'Markes', 39.874439239502, 0.695940252115733, -77.871940612793, -1.35912175861073, 218, 45, 'PPL', 'P'),
(175180, 'Markesan', 43.707218170166, 0.762834863956888, -88.9899978637695, -1.5531684640655, 218, 57, 'PPL', 'P'),
(110294, 'Market', 39.2050018310547, 0.68425636520231, -80.7033309936523, -1.40853884316602, 218, 58, 'PPL', 'P'),
(150576, 'Market', 41.8827781677246, 0.730992378909192, -73.7411117553711, -1.28702519421232, 218, 40, 'PPL', 'P'),
(49242, 'Market Square North', 39.3036117553711, 0.685977433056774, -76.8627777099609, -1.34150854326733, 218, 25, 'PPL', 'P'),
(49243, 'Market Square South', 39.3013916015625, 0.685938684062913, -76.8663864135742, -1.34157152702711, 218, 25, 'PPL', 'P'),
(204821, 'Marketboro Condostor Condominium', 41.0441703796387, 0.716355911874226, -111.949172973633, -1.95388166327454, 218, 52, 'PPL', 'P'),
(208032, 'Marketown', 48.3261108398438, 0.843449748838995, -122.668327331543, -2.14096619984957, 218, 56, 'PPL', 'P'),
(60772, 'Markette', 34.2777786254883, 0.598260097284507, -89.5208282470703, -1.56243320202372, 218, 30, 'PPL', 'P'),
(17032, 'Markham', 28.7927799224854, 0.502528810449487, -81.3938903808594, -1.42059137815334, 218, 12, 'PPL', 'P'),
(60773, 'Markham', 33.4047203063965, 0.583022355054428, -90.5611114501953, -1.58058956907144, 218, 30, 'PPL', 'P'),
(76508, 'Markham', 36.0611114501953, 0.629385126734535, -96.6072235107422, -1.68611413147253, 218, 42, 'PPL', 'P'),
(78685, 'Markham', 39.8908309936523, 0.696226342195835, -75.5061111450195, -1.31783024485738, 218, 45, 'PPL', 'P'),
(96008, 'Markham', 28.9599990844727, 0.505447335398591, -96.0650024414063, -1.67665058853893, 218, 51, 'PPL', 'P'),
(104001, 'Markham', 38.9038887023926, 0.679000949686175, -78.0022201538086, -1.36139556554944, 218, 53, 'PPL', 'P'),
(120518, 'Markham', 41.5936088562012, 0.725945422327383, -87.6947174072266, -1.53056155536209, 218, 18, 'PPL', 'P'),
(136741, 'Markham', 47.2991714477539, 0.825526275228599, -92.2183303833008, -1.60951349588052, 218, 28, 'PPL', 'P'),
(208033, 'Markham', 46.9055595397949, 0.818656451459658, -123.996391296387, -2.16414528871319, 218, 56, 'PPL', 'P'),
(27806, 'Markham City', 38.3302803039551, 0.668989594516349, -88.7222213745117, -1.54849488266852, 218, 18, 'PPL', 'P'),
(150577, 'Markhams', 42.3988914489746, 0.740000254980276, -79.0036087036133, -1.3788730928353, 218, 40, 'PPL', 'P'),
(30441, 'Markland', 38.7819404602051, 0.676872551342984, -84.9866714477539, -1.48329723707396, 218, 19, 'PPL', 'P'),
(113255, 'Markle', 40.4500007629395, 0.705985695747512, -80.6175003051758, -1.40704081505285, 218, 41, 'PPL', 'P'),
(123140, 'Markle', 40.8291702270508, 0.712603451319277, -85.335563659668, -1.48938655490643, 218, 19, 'PPL', 'P'),
(164247, 'Markle', 40.5724983215332, 0.708123681470627, -79.6438903808594, -1.39004811624344, 218, 45, 'PPL', 'P'),
(183112, 'Marklee Village', 38.6897201538086, 0.675263003359167, -119.797218322754, -2.09085589446253, 218, 6, 'PPL', 'P'),
(183113, 'Markleeville', 38.6949996948242, 0.675355148732884, -119.779167175293, -2.09054084250558, 218, 6, 'PPL', 'P'),
(30442, 'Markles', 39.5269393920898, 0.689875235628214, -87.351936340332, -1.52457889713128, 218, 19, 'PPL', 'P'),
(164245, 'Marklesburg', 40.3830604553223, 0.704817366977294, -78.1733322143555, -1.36438203439585, 218, 45, 'PPL', 'P'),
(78686, 'Markleton', 39.8605613708496, 0.69569803761459, -79.2272186279297, -1.38277582225476, 218, 45, 'PPL', 'P'),
(30443, 'Markleville', 39.9777793884277, 0.697743877963989, -85.6147232055664, -1.49425880812073, 218, 19, 'PPL', 'P'),
(96009, 'Markley', 33.3583297729492, 0.582212687504016, -98.4477767944336, -1.71823784633134, 218, 51, 'PPL', 'P'),
(73375, 'Markley (historical)', 39.9324989318848, 0.696953584910508, -83.5152816772461, -1.45761664099844, 218, 41, 'PPL', 'P'),
(78687, 'Markleysburg', 39.7330589294434, 0.69347270020772, -79.4530563354492, -1.38671743382613, 218, 45, 'PPL', 'P'),
(96010, 'Markout', 32.7066688537598, 0.570839058857588, -96.4922180175781, -1.68410690695893, 218, 51, 'PPL', 'P'),
(60774, 'Marks', 34.2563896179199, 0.597886788678705, -90.2719421386719, -1.57554261248964, 218, 30, 'PPL', 'P'),
(131947, 'Marks', 46.2597198486328, 0.807384422408815, -85.6975021362305, -1.4957035730121, 218, 27, 'PPL', 'P'),
(156346, 'Marks (historical)', 40.7533302307129, 0.71127979367848, -81.2797164916992, -1.41859866786769, 218, 41, 'PPL', 'P'),
(128070, 'Marks Corner', 44.4958305358887, 0.77659874626069, -68.6455612182617, -1.198091060138, 218, 26, 'PPL', 'P'),
(125337, 'Marks Garrison', 42.2347183227539, 0.737134893384433, -72.1597213745117, -1.25942472530696, 218, 23, 'PPL', 'P'),
(183114, 'Marks Place', 39.7033309936523, 0.692953849848345, -123.156669616699, -2.14948938060226, 218, 6, 'PPL', 'P'),
(4001, 'Marks Village', 33.5438919067383, 0.585451357705662, -86.7247161865234, -1.51363184031245, 218, 2, 'PPL', 'P'),
(145702, 'Marksboro', 40.9883308410645, 0.715381328073311, -74.9077835083008, -1.30738745759096, 218, 37, 'PPL', 'P'),
(37061, 'Marksbury', 37.6725006103516, 0.657509173110208, -84.6377792358398, -1.4772079192415, 218, 21, 'PPL', 'P'),
(41987, 'Marksville', 31.1277809143066, 0.543282265794102, -92.0661087036133, -1.60685672637706, 218, 22, 'PPL', 'P'),
(60775, 'Marksville', 33.3091697692871, 0.58135468357982, -90.2802810668945, -1.57568815424321, 218, 30, 'PPL', 'P'),
(104000, 'Marksville', 38.5750007629395, 0.673260772272618, -78.4797210693359, -1.36972952870668, 218, 53, 'PPL', 'P'),
(202344, 'Marksville', 45.0694389343262, 0.786610101430516, -100.376937866211, -1.75190805883515, 218, 49, 'PPL', 'P'),
(4002, 'Markton', 33.8800010681152, 0.591317569217806, -86.0100021362305, -1.50115772692458, 218, 2, 'PPL', 'P'),
(164253, 'Markton', 41.0105590820313, 0.715769284065109, -79.0644378662109, -1.37993476200386, 218, 45, 'PPL', 'P'),
(175183, 'Markton', 45.121940612793, 0.787526428582585, -88.6647186279297, -1.54749127041172, 218, 57, 'PPL', 'P'),
(136742, 'Markville', 46.0919418334961, 0.804456143632219, -92.3305587768555, -1.61147225086228, 218, 28, 'PPL', 'P'),
(60776, 'Markwald', 31.8261108398438, 0.555470422259931, -89.0025024414063, -1.55338671011683, 218, 30, 'PPL', 'P'),
(110295, 'Markwood', 39.3352813720703, 0.68653017214102, -78.9641723632813, -1.37818479885157, 218, 58, 'PPL', 'P'),
(4003, 'Marl', 31.0902805328369, 0.542627760666701, -85.9800033569336, -1.50063414945427, 218, 2, 'PPL', 'P'),
(156347, 'Marl City', 40.4324989318848, 0.70568023117048, -83.6866683959961, -1.46060790353481, 218, 41, 'PPL', 'P'),
(96011, 'Marla Colonia', 26.2339992523193, 0.457869662918703, -98.3870010375977, -1.71717710926916, 218, 51, 'PPL', 'P'),
(73376, 'Marlain Acres', 39.2324981689453, 0.684736266830742, -84.5041732788086, -1.47487605539102, 218, 41, 'PPL', 'P'),
(110296, 'Marlaina Addition', 38.4041709899902, 0.67027923027422, -81.8555603027344, -1.42864903834748, 218, 58, 'PPL', 'P'),
(17033, 'Marland', 27.3388900756836, 0.47715364566148, -81.2408294677734, -1.41791996126388, 218, 12, 'PPL', 'P'),
(76509, 'Marland', 36.5608291625977, 0.63810684614649, -97.1508331298828, -1.69560190917204, 218, 42, 'PPL', 'P'),
(177242, 'Marland Heights', 40.3983306884766, 0.705083882823384, -80.6055603027344, -1.40683242269755, 218, 58, 'PPL', 'P'),
(175184, 'Marlands', 45.9561080932617, 0.80208539762983, -89.8161087036133, -1.56758681820719, 218, 57, 'PPL', 'P'),
(22883, 'Marlanta', 34.0277786254883, 0.593896774154521, -84.434440612793, -1.47365899077286, 218, 13, 'PPL', 'P'),
(104004, 'Marlbank', 37.208610534668, 0.649412763922204, -76.4822235107422, -1.33486661950867, 218, 53, 'PPL', 'P'),
(66632, 'Marlboro', 35.5800018310547, 0.620988179817516, -77.5922164916992, -1.35423965170039, 218, 33, 'PPL', 'P'),
(78689, 'Marlboro', 39.8955612182617, 0.696308900189627, -75.7044372558594, -1.32129168848421, 218, 45, 'PPL', 'P'),
(82253, 'Marlboro', 34.5366706848145, 0.602778616127017, -79.732780456543, -1.39159954073646, 218, 48, 'PPL', 'P'),
(104002, 'Marlboro', 39.0813903808594, 0.682098938403237, -78.3225021362305, -1.36698554067751, 218, 53, 'PPL', 'P'),
(125338, 'Marlboro', 42.7166709899902, 0.745546554266475, -70.9736099243164, -1.23872317520544, 218, 23, 'PPL', 'P'),
(128071, 'Marlboro', 44.4755592346191, 0.776244945309873, -68.2705612182617, -1.19154607544302, 218, 26, 'PPL', 'P'),
(145703, 'Marlboro', 40.3152809143066, 0.703634390821081, -74.2466735839844, -1.29584891269403, 218, 37, 'PPL', 'P'),
(150580, 'Marlboro', 41.6055603027344, 0.726154014419764, -73.9719390869141, -1.29105389115134, 218, 40, 'PPL', 'P'),
(156348, 'Marlboro', 40.9511108398438, 0.714731716504414, -81.2141723632813, -1.41745470702144, 218, 41, 'PPL', 'P'),
(172230, 'Marlboro', 42.8594398498535, 0.748038340940408, -72.7263870239258, -1.26931490664718, 218, 55, 'PPL', 'P'),
(183115, 'Marlboro', 33.8125, 0.590139453330583, -117.858062744141, -2.05701124490732, 218, 6, 'PPL', 'P'),
(66633, 'Marlboro Forest', 35.5852813720703, 0.621080325191232, -77.6119384765625, -1.35458386527129, 218, 33, 'PPL', 'P'),
(49244, 'Marlboro Hills', 38.6624984741211, 0.674787895420697, -76.6127777099609, -1.33714522013734, 218, 25, 'PPL', 'P'),
(49245, 'Marlboro Meadows', 38.836109161377, 0.677817973529962, -76.7152786254883, -1.3389341985996, 218, 25, 'PPL', 'P'),
(22884, 'Marlborough', 33.5272216796875, 0.58516040735657, -84.3844375610352, -1.47278627288364, 218, 13, 'PPL', 'P'),
(56096, 'Marlborough', 38.5702781677246, 0.67317834743688, -90.3369369506836, -1.57667698595596, 218, 29, 'PPL', 'P'),
(113681, 'Marlborough', 41.6313896179199, 0.726604821013287, -72.4602813720703, -1.26467048686414, 218, 8, 'PPL', 'P'),
(125339, 'Marlborough', 42.3458290100098, 0.739074140711201, -71.5527801513672, -1.248831602597, 218, 23, 'PPL', 'P'),
(131948, 'Marlborough', 43.8647193908691, 0.765583778834068, -85.841667175293, -1.49821972761, 218, 27, 'PPL', 'P'),
(144112, 'Marlborough', 42.9041709899902, 0.748819046613965, -72.2083282470703, -1.2602730752722, 218, 36, 'PPL', 'P'),
(125340, 'Marlborough Junction', 42.3313903808594, 0.738822139093053, -71.5416717529297, -1.24863772446965, 218, 23, 'PPL', 'P'),
(178596, 'Marlborough Meadows', 33.5944404602051, 0.586333596395778, -112.17472076416, -1.95781821483984, 218, 5, 'PPL', 'P'),
(178597, 'Marlborough Mesa', 33.3613891601563, 0.582266083883872, -111.853057861328, -1.9522041381039, 218, 5, 'PPL', 'P'),
(178598, 'Marlborough Park', 33.4474983215332, 0.583768972266031, -111.928886413574, -1.95352759600762, 218, 5, 'PPL', 'P'),
(164249, 'Marlboroville', 40.3708305358887, 0.704603914615924, -75.4366683959961, -1.31661824024528, 218, 45, 'PPL', 'P'),
(104003, 'Marlbrook', 37.8619384765625, 0.660815487603542, -79.2533264160156, -1.38323148911727, 218, 53, 'PPL', 'P'),
(201187, 'Marlene Village', 45.5169410705566, 0.794420487117446, -122.817779541016, -2.14357463297925, 218, 43, 'PPL', 'P'),
(66634, 'Marler', 36.127498626709, 0.630543801545802, -80.820556640625, -1.41058481667347, 218, 33, 'PPL', 'P'),
(131949, 'Marlette', 43.3269386291504, 0.756197733888193, -83.0802764892578, -1.45002436820478, 218, 27, 'PPL', 'P'),
(22885, 'Marlette Heights', 34.2236099243164, 0.597314675097529, -83.813606262207, -1.46282338724565, 218, 13, 'PPL', 'P'),
(49246, 'Marley', 39.1508293151855, 0.683310876436305, -76.5922164916992, -1.33678635918045, 218, 25, 'PPL', 'P'),
(120519, 'Marley', 41.5486106872559, 0.725160056121919, -87.9255599975586, -1.53459051861721, 218, 18, 'PPL', 'P'),
(195288, 'Marley', 43.0155601501465, 0.750763154209723, -114.230278015137, -1.99369445683263, 218, 17, 'PPL', 'P'),
(198578, 'Marley', 48.0250015258789, 0.838194399901888, -103.904441833496, -1.81347461744144, 218, 34, 'PPL', 'P'),
(49247, 'Marley Heights', 39.1513900756836, 0.683320663553311, -76.5924987792969, -1.33679128602847, 218, 25, 'PPL', 'P'),
(4005, 'Marley Mill', 31.4927806854248, 0.549652713569139, -85.6958312988281, -1.49567441139816, 218, 2, 'PPL', 'P'),
(49248, 'Marley Park Beach', 39.1555595397949, 0.683393434430097, -76.5955581665039, -1.33684468240832, 218, 25, 'PPL', 'P'),
(49249, 'Marley Run', 39.1311111450195, 0.682966729444439, -76.5924987792969, -1.33679128602847, 218, 25, 'PPL', 'P'),
(49250, 'Marley Village', 39.6302795410156, 0.69167886147647, -75.8805618286133, -1.32436564217243, 218, 25, 'PPL', 'P'),
(104008, 'Marlfield', 37.4472198486328, 0.653577282076815, -76.6100006103516, -1.3370967506055, 218, 53, 'PPL', 'P'),
(96012, 'Marlin', 31.3061103820801, 0.546394702160077, -96.8977813720703, -1.69118532282026, 218, 51, 'PPL', 'P'),
(164250, 'Marlin', 40.6783294677734, 0.709970783423679, -76.2455596923828, -1.33073605665795, 218, 45, 'PPL', 'P'),
(193247, 'Marlin', 47.4075012207031, 0.8274169864445, -118.98388671875, -2.07666058006214, 218, 56, 'PPL', 'P'),
(82256, 'Marlin Estates', 32.9916687011719, 0.57581324456261, -80.1952819824219, -1.39967171515855, 218, 48, 'PPL', 'P'),
(104005, 'Marlin Forest', 38.7608299255371, 0.676504103006171, -77.0555572509766, -1.34487318098853, 218, 53, 'PPL', 'P'),
(30444, 'Marlin Hills', 39.2130584716797, 0.684396980107866, -86.5233306884766, -1.51011700030577, 218, 19, 'PPL', 'P'),
(164251, 'Marlin Hills', 40.6025009155273, 0.708647325519964, -75.2958297729492, -1.31416014255914, 218, 45, 'PPL', 'P'),
(56097, 'Marling', 39.1338882446289, 0.683015198976279, -91.3097229003906, -1.59365530369548, 218, 29, 'PPL', 'P'),
(49251, 'Marling Farms', 38.9324989318848, 0.679500292390565, -76.26611328125, -1.33109478445679, 218, 25, 'PPL', 'P'),
(110297, 'Marlinton', 38.223331451416, 0.667122984908312, -80.0947189331055, -1.39791655884213, 218, 58, 'PPL', 'P'),
(187029, 'Marlman', 38.0936088562012, 0.664858898507582, -103.348609924316, -1.80377352053861, 218, 7, 'PPL', 'P'),
(56098, 'Marlo', 37.9497184753418, 0.662347537599637, -90.1136093139648, -1.57277918338452, 218, 29, 'PPL', 'P'),
(104006, 'Marlo Heights', 38.8580589294434, 0.67820106925277, -77.1691665649414, -1.34685603757815, 218, 53, 'PPL', 'P'),
(4004, 'Marlow', 30.4608306884766, 0.531641788406447, -87.7991714477539, -1.5323846222863, 218, 2, 'PPL', 'P'),
(22887, 'Marlow', 34.4152793884277, 0.600659938321804, -83.9055633544922, -1.46442834127659, 218, 13, 'PPL', 'P'),
(27808, 'Marlow', 38.3208312988281, 0.668824678265846, -88.793327331543, -1.5497359157365, 218, 18, 'PPL', 'P'),
(37062, 'Marlow', 36.7772216796875, 0.641883608046386, -85.0924987792969, -1.48514427244799, 218, 21, 'PPL', 'P'),
(56099, 'Marlow', 36.389720916748, 0.635120443879103, -89.978889465332, -1.57042787845808, 218, 29, 'PPL', 'P'),
(76511, 'Marlow', 34.5902786254883, 0.603714251196989, -97.9555587768555, -1.70964702128696, 218, 42, 'PPL', 'P'),
(88828, 'Marlow', 36.0633316040039, 0.629423875728396, -84.2433319091797, -1.47032351466559, 218, 50, 'PPL', 'P'),
(96013, 'Marlow', 30.8487091064453, 0.538411543897429, -96.9213027954102, -1.69159584910229, 218, 51, 'PPL', 'P'),
(144114, 'Marlow', 43.1158294677734, 0.752513183941041, -72.1975021362305, -1.26008412399286, 218, 36, 'PPL', 'P'),
(170828, 'Marlow', 45.9208297729492, 0.801469674785804, -97.3852767944336, -1.6996937230289, 218, 49, 'PPL', 'P'),
(49252, 'Marlow Heights', 38.8333282470703, 0.677769437419095, -76.9519424438477, -1.34306476145031, 218, 25, 'PPL', 'P'),
(144115, 'Marlow Junction', 43.1672210693359, 0.75341013659618, -72.2202835083008, -1.26048173394361, 218, 36, 'PPL', 'P'),
(37065, 'Marlowe', 37.1311111450195, 0.648060144404553, -82.8308334350586, -1.44567076561278, 218, 21, 'PPL', 'P'),
(110298, 'Marlowe', 39.5883293151855, 0.69094669191378, -77.8597183227539, -1.35890843940741, 218, 58, 'PPL', 'P'),
(49253, 'Marlton', 38.773609161377, 0.676727142747465, -76.790283203125, -1.34024327543343, 218, 25, 'PPL', 'P'),
(71084, 'Marlton', 39.8911094665527, 0.696231202464824, -74.9222183227539, -1.30763939263008, 218, 37, 'PPL', 'P'),
(71085, 'Marlton Heights', 39.663890838623, 0.692265489285587, -75.357780456543, -1.31524138596171, 218, 37, 'PPL', 'P'),
(71086, 'Marlton Lakes', 39.8088912963867, 0.694796224690462, -74.8986129760742, -1.30722740160944, 218, 37, 'PPL', 'P'),
(49254, 'Marlton South', 38.7452812194824, 0.676232726891092, -76.7836074829102, -1.34012676213574, 218, 25, 'PPL', 'P'),
(66635, 'Marlwood Acre', 35.2002792358398, 0.614360770286799, -80.7088928222656, -1.40863591538775, 218, 33, 'PPL', 'P'),
(96014, 'Marly', 29.8713893890381, 0.521354096984012, -97.0330581665039, -1.69354634828467, 218, 51, 'PPL', 'P'),
(88829, 'Marlyn Hills', 36.5513916015625, 0.637942129633069, -82.2155609130859, -1.43493223430731, 218, 50, 'PPL', 'P'),
(71087, 'Marlyn Manor', 39.0169410705566, 0.680974085737815, -74.873893737793, -1.30679596951285, 218, 37, 'PPL', 'P'),
(49255, 'Marlywood', 39.4011116027832, 0.687679126414307, -76.6202774047852, -1.33727611450492, 218, 25, 'PPL', 'P'),
(208034, 'Marmac', 47.1116714477539, 0.822253782881109, -123.143608093262, -2.14926141401295, 218, 56, 'PPL', 'P'),
(10321, 'Marmaduke', 36.186939239502, 0.631581235948442, -90.383056640625, -1.57748192639543, 218, 4, 'PPL', 'P'),
(66636, 'Marmaduke', 36.3472213745117, 0.634378686936488, -78.0694427490234, -1.36256882116767, 218, 33, 'PPL', 'P'),
(204827, 'Marmalade Condominium', 40.7772216796875, 0.711696778126159, -111.892219543457, -1.95288763839767, 218, 52, 'PPL', 'P'),
(56100, 'Marmaros', 36.6191711425781, 0.639125105789282, -93.4538879394531, -1.63107804333328, 218, 29, 'PPL', 'P'),
(198579, 'Marmarth', 46.2949981689453, 0.808000145252842, -103.920280456543, -1.81375105356259, 218, 34, 'PPL', 'P'),
(33201, 'Marmaton', 37.8319396972656, 0.660291910133232, -94.8244400024414, -1.65499868940242, 218, 20, 'PPL', 'P'),
(110299, 'Marmet', 38.2452812194824, 0.66750608063112, -81.5672225952148, -1.42361659599361, 218, 58, 'PPL', 'P'),
(4006, 'Marmion (historical)', 34.8522186279297, 0.608285966682274, -87.404167175293, -1.52549049717241, 218, 2, 'PPL', 'P'),
(190456, 'Marmol (historical)', 39.4738883972168, 0.68894932109622, -119.992218017578, -2.0942592811776, 218, 39, 'PPL', 'P'),
(188978, 'Marmon', 35.017219543457, 0.611165775927031, -107.300003051758, -1.87273834065314, 218, 38, 'PPL', 'P'),
(198581, 'Marmon', 48.3872184753418, 0.844516278276545, -103.655563354492, -1.80913086854547, 218, 34, 'PPL', 'P'),
(104007, 'Marmona', 37.2277793884277, 0.649747323534145, -77.6413879394531, -1.35509785536167, 218, 53, 'PPL', 'P'),
(88830, 'Marmor', 35.7880592346191, 0.624619466542866, -84.1172180175781, -1.46812241202464, 218, 50, 'PPL', 'P'),
(71088, 'Marmora', 39.2666702270508, 0.685332681756865, -74.6452789306641, -1.30280588840964, 218, 37, 'PPL', 'P'),
(201188, 'Marmot', 45.396671295166, 0.792321383546245, -122.114440917969, -2.13129905825064, 218, 43, 'PPL', 'P'),
(113135, 'Marna', 43.6058311462402, 0.761065326570585, -94.0074996948242, -1.64074039124225, 218, 28, 'PPL', 'P'),
(112644, 'Marne', 38.4727783203125, 0.671476654079347, -81.1975021362305, -1.41716375667235, 218, 58, 'PPL', 'P'),
(116745, 'Marne', 41.4513893127441, 0.723463223033375, -95.1111068725586, -1.66000197014235, 218, 16, 'PPL', 'P'),
(131952, 'Marne', 43.0361099243164, 0.751121815429529, -85.8277816772461, -1.49797737995081, 218, 27, 'PPL', 'P'),
(156351, 'Marne', 40.0711097717285, 0.699372800444736, -82.309440612793, -1.43657074416798, 218, 41, 'PPL', 'P'),
(183116, 'Marne', 34.0055618286133, 0.593509017899805, -117.905563354492, -2.05784028695466, 218, 6, 'PPL', 'P'),
(22895, 'Marnelle Mobile Home Park', 33.440559387207, 0.58364786501546, -84.5280609130859, -1.47529297325967, 218, 13, 'PPL', 'P'),
(194310, 'Marnett', 40.1683311462402, 0.70106963353328, -105.133331298828, -1.83492278475456, 218, 7, 'PPL', 'P'),
(110300, 'Marnie', 37.9552803039551, 0.66244460982137, -81.6566696166992, -1.42517774102462, 218, 58, 'PPL', 'P'),
(120520, 'Maroa', 40.0363883972168, 0.698766798138688, -88.9569396972656, -1.55259149021533, 218, 18, 'PPL', 'P'),
(172232, 'Marolin Acres', 43.6211090087891, 0.761331975574729, -72.9677810668945, -1.27352802749169, 218, 55, 'PPL', 'P'),
(113683, 'Maromas', 41.5433311462402, 0.725067910748202, -72.5611114501953, -1.26643030371247, 218, 8, 'PPL', 'P'),
(78690, 'Marple', 39.9775009155273, 0.697739017695, -75.3788909912109, -1.31560983429852, 218, 45, 'PPL', 'P'),
(199513, 'Marple (historical)', 42.4005584716797, 0.740029350015185, -102.72917175293, -1.79296228493538, 218, 35, 'PPL', 'P'),
(110301, 'Marpleton', 38.6775016784668, 0.675049750734879, -80.5038909912109, -1.40505795846323, 218, 58, 'PPL', 'P'),
(201189, 'Marquam', 45.0733299255371, 0.786678012038313, -122.685829162598, -2.14127166442661, 218, 43, 'PPL', 'P'),
(201190, 'Marquam Hill', 45.4991683959961, 0.794110295429479, -122.688331604004, -2.14131534026848, 218, 43, 'PPL', 'P'),
(56101, 'Marquand', 37.4291687011719, 0.653262230119859, -90.1680603027344, -1.57372953241951, 218, 29, 'PPL', 'P'),
(156352, 'Marquand Mills', 40.1458282470703, 0.70067688385152, -81.7975006103516, -1.42763570555271, 218, 41, 'PPL', 'P'),
(110302, 'Marquess', 39.2983283996582, 0.68588522110403, -79.8511123657227, -1.39366482216182, 218, 58, 'PPL', 'P'),
(33204, 'Marquette', 38.5555610656738, 0.672921485549742, -97.8333282470703, -1.70751369609575, 218, 20, 'PPL', 'P'),
(116746, 'Marquette', 43.0444412231445, 0.751267224025047, -91.1780624389648, -1.59135739514891, 218, 16, 'PPL', 'P'),
(120522, 'Marquette', 41.3308296203613, 0.721359059456103, -89.2624969482422, -1.55792447029822, 218, 18, 'PPL', 'P'),
(131953, 'Marquette', 46.5436096191406, 0.812339233616908, -87.3952789306641, -1.52533536803892, 218, 27, 'PPL', 'P'),
(142360, 'Marquette', 41.003059387207, 0.715638389697531, -98.0091705322266, -1.71058272293596, 218, 35, 'PPL', 'P'),
(175185, 'Marquette', 43.747501373291, 0.763537938484669, -89.1386108398438, -1.55576224980918, 218, 57, 'PPL', 'P'),
(120523, 'Marquette Heights', 40.6175003051758, 0.708909114255119, -89.6002807617188, -1.56381991000333, 218, 18, 'PPL', 'P'),
(96015, 'Marquez', 31.2391700744629, 0.54522637338986, -96.2533264160156, -1.67993746195631, 218, 51, 'PPL', 'P'),
(188979, 'Marquez', 35.3144416809082, 0.616353280835369, -107.301940917969, -1.87277216279898, 218, 38, 'PPL', 'P'),
(156353, 'Marquis', 40.9880599975586, 0.715376600962376, -80.7641677856445, -1.40960064549263, 218, 41, 'PPL', 'P'),
(116747, 'Marquisville', 41.6566696166992, 0.727046040226886, -93.6005630493164, -1.63363800693111, 218, 16, 'PPL', 'P'),
(73377, 'Marr', 39.6286087036133, 0.691649699862533, -81.225830078125, -1.41765817252872, 218, 41, 'PPL', 'P'),
(41988, 'Marrero', 29.899169921875, 0.521838958749975, -90.1002807617188, -1.5725465562633, 218, 22, 'PPL', 'P'),
(204824, 'Marriott (historical)', 41.2447204589844, 0.719856171073944, -112.008613586426, -1.95491909767718, 218, 52, 'PPL', 'P'),
(49256, 'Marriott Hill', 38.8752784729004, 0.678501606981785, -76.6086120605469, -1.33707251583958, 218, 25, 'PPL', 'P'),
(204825, 'Marriott-Slaterville', 41.2516708374023, 0.719977478061597, -112.024719238281, -1.95520019433024, 218, 52, 'PPL', 'P'),
(49257, 'Marriottsville', 39.3499984741211, 0.686787034028158, -76.8997192382813, -1.34215329456723, 218, 25, 'PPL', 'P'),
(164252, 'Marron', 40.8616714477539, 0.713170704631464, -78.6194381713867, -1.37216805215881, 218, 45, 'PPL', 'P'),
(37064, 'Marrowbone', 37.3658294677734, 0.652156751951367, -82.4138870239258, -1.43839367793414, 218, 21, 'PPL', 'P'),
(88831, 'Marrowbone', 36.2430610656738, 0.632560746597373, -87.0069427490234, -1.51855762306467, 218, 50, 'PPL', 'P'),
(104010, 'Marrowbone Heights', 36.6161117553711, 0.639071709409426, -79.8583297729492, -1.39379078968138, 218, 53, 'PPL', 'P'),
(208035, 'Marrowstone', 48.0533294677734, 0.838688815758261, -122.688056945801, -2.14131054657852, 218, 56, 'PPL', 'P'),
(30445, 'Marrs Center', 37.9455604553223, 0.662274966459932, -87.754997253418, -1.53161363715072, 218, 19, 'PPL', 'P'),
(110303, 'Marrtown', 39.2588882446289, 0.685196860541271, -81.5822219848633, -1.42387838472877, 218, 58, 'PPL', 'P'),
(128072, 'Marrtown', 43.7944412231445, 0.764357193415005, -69.7819366455078, -1.2179245528822, 218, 26, 'PPL', 'P'),
(96016, 'Mars', 32.3592185974121, 0.564774907897423, -95.7255172729492, -1.67072545458767, 218, 51, 'PPL', 'P'),
(164255, 'Mars', 40.6958312988281, 0.710276248000711, -80.0119400024414, -1.39647179395076, 218, 45, 'PPL', 'P'),
(183117, 'Mars', 35.4249992370605, 0.618282874203186, -116.888893127441, -2.04009604408562, 218, 6, 'PPL', 'P'),
(82257, 'Mars Bluff', 34.2052803039551, 0.596994762871583, -79.6555633544922, -1.39025184806683, 218, 48, 'PPL', 'P'),
(49258, 'Mars Estates', 39.3202781677246, 0.686268316826838, -76.4494400024414, -1.33429443934846, 218, 25, 'PPL', 'P'),
(4010, 'Mars Hill', 34.8516693115234, 0.608276379302349, -87.6608276367188, -1.52997006728398, 218, 2, 'PPL', 'P'),
(10323, 'Mars Hill', 35.2761116027832, 0.615684294769541, -92.9991683959961, -1.62314169012679, 218, 4, 'PPL', 'P'),
(22888, 'Mars Hill', 34.0349998474121, 0.594022808253109, -84.6916732788086, -1.47814854773851, 218, 13, 'PPL', 'P'),
(41990, 'Mars Hill', 31.7180595397949, 0.553584571313019, -92.7966690063477, -1.61960740904414, 218, 22, 'PPL', 'P'),
(60778, 'Mars Hill', 31.3030605316162, 0.546341472227789, -90.628059387207, -1.58175803099972, 218, 30, 'PPL', 'P'),
(66639, 'Mars Hill', 35.8263893127441, 0.625288452608694, -82.5494384765625, -1.44075949708851, 218, 33, 'PPL', 'P'),
(88833, 'Mars Hill', 35.2649993896484, 0.615490350063156, -87.2897186279297, -1.5234929931968, 218, 50, 'PPL', 'P'),
(128073, 'Mars Hill', 46.5158309936523, 0.811854405140459, -67.866943359375, -1.18450161488559, 218, 26, 'PPL', 'P'),
(22889, 'Mars Hill Acres', 34.026668548584, 0.593877399657591, -84.6883316040039, -1.47809022451064, 218, 13, 'PPL', 'P'),
(22891, 'Mars Hill Crossroads', 34.1563911437988, 0.596141486058322, -84.1958312988281, -1.46949447261824, 218, 13, 'PPL', 'P'),
(22892, 'Mars Hill Downs', 34.0288887023926, 0.593916148651451, -84.6805572509766, -1.4779545364531, 218, 13, 'PPL', 'P'),
(104009, 'Marsailles (historical)', 36.6827812194824, 0.640235311068709, -78.9833297729492, -1.37851915872643, 218, 53, 'PPL', 'P'),
(183118, 'Marsala (historical)', 36.2202796936035, 0.632163136646624, -119.83332824707, -2.0914861315345, 218, 6, 'PPL', 'P'),
(41989, 'Marsalis', 32.6630592346191, 0.570077927418043, -92.956672668457, -1.6223999997632, 218, 22, 'PPL', 'P'),
(10325, 'Marsden', 33.3277816772461, 0.581679522653782, -92.2225036621094, -1.60958633333634, 218, 4, 'PPL', 'P'),
(76512, 'Marsden', 34.0555610656738, 0.594381669209997, -97.1952819824219, -1.69637768799758, 218, 42, 'PPL', 'P'),
(120525, 'Marseilles', 41.3308296203613, 0.721359059456103, -88.7080612182617, -1.54824774131936, 218, 18, 'PPL', 'P'),
(156354, 'Marseilles', 40.7013893127441, 0.710373253643417, -83.3927764892578, -1.45547852211727, 218, 41, 'PPL', 'P'),
(10326, 'Marsena', 35.8802795410156, 0.626229014526682, -92.7944412231445, -1.61956852689223, 218, 4, 'PPL', 'P'),
(116748, 'Marsh', 41.1016693115234, 0.717359457551995, -91.3522186279297, -1.59439699405907, 218, 16, 'PPL', 'P'),
(191833, 'Marsh', 35.5397186279297, 0.620285105289735, -101.921669006348, -1.77886870328862, 218, 51, 'PPL', 'P'),
(196985, 'Marsh', 46.889720916748, 0.818380015338507, -104.932502746582, -1.83141766528585, 218, 31, 'PPL', 'P'),
(195289, 'Marsh (historical)', 43.9186096191406, 0.766524340752057, -116.338890075684, -2.03049667993643, 218, 17, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(125349, 'Marsh Corner', 42.7277793884277, 0.745740432393833, -71.2319412231445, -1.24323190693095, 218, 23, 'PPL', 'P'),
(128075, 'Marsh Corner', 44.8813896179199, 0.783328021703102, -69.317497253418, -1.20981855631427, 218, 26, 'PPL', 'P'),
(131958, 'Marsh Corner', 45.5794410705566, 0.795511317899942, -84.9349975585938, -1.48239535757081, 218, 27, 'PPL', 'P'),
(150579, 'Marsh Corner', 42.7388916015625, 0.745934377100218, -76.7919387817383, -1.34027217073126, 218, 40, 'PPL', 'P'),
(82258, 'Marsh Cove', 32.8166694641113, 0.572758931687426, -80.0286102294922, -1.39676274429985, 218, 48, 'PPL', 'P'),
(22893, 'Marsh Creek', 33.9972190856934, 0.593363409567205, -84.0286102294922, -1.46657591437963, 218, 13, 'PPL', 'P'),
(56103, 'Marsh Creek', 37.4172210693359, 0.653053704606506, -90.4644393920898, -1.57890232336283, 218, 29, 'PPL', 'P'),
(164256, 'Marsh Creek', 41.7761116027832, 0.729130696149172, -77.3986129760742, -1.3508606329093, 218, 45, 'PPL', 'P'),
(183119, 'Marsh Creek Springs', 37.8927803039551, 0.661353779038874, -121.852783203125, -2.12673226961337, 218, 6, 'PPL', 'P'),
(22894, 'Marsh Crossing', 34.7172203063965, 0.605929801486853, -85.3283309936523, -1.48926032107076, 218, 13, 'PPL', 'P'),
(82261, 'Marsh Harbor', 32.4480590820313, 0.566325466863094, -80.6563873291016, -1.40771952165666, 218, 48, 'PPL', 'P'),
(82259, 'Marsh Hawk', 32.4799995422363, 0.566882933058275, -80.64111328125, -1.40745293923154, 218, 48, 'PPL', 'P'),
(164257, 'Marsh Hill', 41.4769401550293, 0.723909169357909, -76.9744415283203, -1.34345744455305, 218, 45, 'PPL', 'P'),
(183120, 'Marsh Mill', 39.4444389343262, 0.688435331005835, -120.702499389648, -2.10665602973581, 218, 6, 'PPL', 'P'),
(82260, 'Marsh Point', 32.7366714477539, 0.571362702906924, -79.9175033569336, -1.39482356355211, 218, 48, 'PPL', 'P'),
(164258, 'Marsh Run', 40.2000007629395, 0.701622372617526, -76.8138885498047, -1.34065526645406, 218, 45, 'PPL', 'P'),
(104011, 'Marsh Run Mobile Home Park', 38.5616683959961, 0.673028078572372, -77.7566680908203, -1.35710987356523, 218, 53, 'PPL', 'P'),
(195290, 'Marsh Valley', 42.5177803039551, 0.742075256943612, -112.154998779297, -1.95747400126895, 218, 17, 'PPL', 'P'),
(49259, 'Marshalee Estates', 39.2066688537598, 0.684285460237219, -76.7605590820313, -1.33972449165308, 218, 25, 'PPL', 'P'),
(4012, 'Marshall', 34.2427787780762, 0.59764923470947, -86.1447219848633, -1.50350903185101, 218, 2, 'PPL', 'P'),
(10327, 'Marshall', 35.9088897705078, 0.626728357231072, -92.6311111450195, -1.61671787926141, 218, 4, 'PPL', 'P'),
(22896, 'Marshall', 31.8683300018311, 0.556207285644042, -83.8883285522461, -1.46412753723146, 218, 13, 'PPL', 'P'),
(27810, 'Marshall', 39.3913917541504, 0.687509483052869, -87.6936111450195, -1.53054224744419, 218, 18, 'PPL', 'P'),
(30452, 'Marshall', 39.8480606079102, 0.695479858142285, -87.1877822875977, -1.52171386843057, 218, 19, 'PPL', 'P'),
(37067, 'Marshall', 38.5449981689453, 0.672737128223281, -83.7630615234375, -1.46194121513456, 218, 21, 'PPL', 'P'),
(56104, 'Marshall', 39.1230583190918, 0.68282618111791, -93.1966705322266, -1.62658875268373, 218, 29, 'PPL', 'P'),
(66641, 'Marshall', 35.7972183227539, 0.624779322787298, -82.6841735839844, -1.44311106833105, 218, 33, 'PPL', 'P'),
(73378, 'Marshall', 39.1519393920898, 0.683330250933235, -83.4850006103516, -1.45708813668011, 218, 41, 'PPL', 'P'),
(76513, 'Marshall', 36.1538887023926, 0.631004395256331, -97.6252822875977, -1.70388260910748, 218, 42, 'PPL', 'P'),
(78692, 'Marshall', 39.814998626709, 0.694902817713092, -77.376106262207, -1.35046781664852, 218, 45, 'PPL', 'P'),
(88834, 'Marshall', 36.5727806091309, 0.638315438238871, -82.6611099243164, -1.44270853153228, 218, 50, 'PPL', 'P'),
(96017, 'Marshall', 32.5447196960449, 0.568012512834632, -94.3672180175781, -1.64701866035405, 218, 51, 'PPL', 'P'),
(104012, 'Marshall', 38.8647193908691, 0.678317316234352, -77.8580627441406, -1.35887954410959, 218, 53, 'PPL', 'P'),
(110305, 'Marshall', 38.8247184753418, 0.677619168554587, -81.5361099243164, -1.42307357744735, 218, 58, 'PPL', 'P'),
(131959, 'Marshall', 42.2722206115723, 0.737789431801347, -84.9633331298828, -1.48288990658523, 218, 27, 'PPL', 'P'),
(136744, 'Marshall', 44.4469413757324, 0.775745469447429, -95.7880630493164, -1.67181708431849, 218, 28, 'PPL', 'P'),
(150582, 'Marshall', 42.9630584716797, 0.749846827057653, -75.3280563354492, -1.31472260218136, 218, 40, 'PPL', 'P'),
(175189, 'Marshall', 43.1683311462402, 0.75342951109311, -89.0666732788086, -1.55450670251326, 218, 57, 'PPL', 'P'),
(183121, 'Marshall', 38.1605606079102, 0.666027427014881, -122.893058776855, -2.14488850350304, 218, 6, 'PPL', 'P'),
(187030, 'Marshall', 39.9555587768555, 0.697356055130246, -105.22917175293, -1.83659551623524, 218, 7, 'PPL', 'P'),
(198582, 'Marshall', 47.1380615234375, 0.822714376591639, -102.332496643066, -1.78603899820755, 218, 34, 'PPL', 'P'),
(204828, 'Marshall', 40.6025009155273, 0.708647325519964, -112.392776489258, -1.96162400519562, 218, 52, 'PPL', 'P'),
(208036, 'Marshall', 47.564998626709, 0.830165834742653, -117.498329162598, -2.0507327094794, 218, 56, 'PPL', 'P'),
(211980, 'Marshall', 61.8777809143066, 1.07997101078236, -162.081115722656, -2.8288491246663, 218, 1, 'PPL', 'P'),
(116749, 'Marshall (historical)', 40.7249984741211, 0.71078531124308, -94.3277816772461, -1.64633036637032, 218, 16, 'PPL', 'P'),
(125342, 'Marshall Corner', 42.0597190856934, 0.734080580509248, -71.0666732788086, -1.24034743715428, 218, 23, 'PPL', 'P'),
(144117, 'Marshall Corner', 42.9925003051758, 0.750360683989984, -71.0147171020508, -1.23944063080311, 218, 36, 'PPL', 'P'),
(96018, 'Marshall Creek', 33.0166702270508, 0.57624960350722, -97.2083282470703, -1.69660538827078, 218, 51, 'PPL', 'P'),
(88836, 'Marshall Estates', 36.5777816772461, 0.638402723343598, -82.6624984741211, -1.4427327662982, 218, 50, 'PPL', 'P'),
(96019, 'Marshall Ford', 30.3916702270508, 0.530434710642369, -97.8883285522461, -1.70847363251067, 218, 51, 'PPL', 'P'),
(82262, 'Marshall Forest', 34.8111114501953, 0.607568511084606, -82.3733291625977, -1.43768580971639, 218, 48, 'PPL', 'P'),
(13153, 'Marshall Heights', 38.8861083984375, 0.678690624840153, -76.9283294677734, -1.34265263727162, 218, 9, 'PPL', 'P'),
(88838, 'Marshall Heights', 35.4461097717285, 0.618651322539998, -86.8013916015625, -1.51497007876022, 218, 50, 'PPL', 'P'),
(104013, 'Marshall Heights', 37.2683296203613, 0.650455058593834, -76.4972229003906, -1.33512840824382, 218, 53, 'PPL', 'P'),
(164259, 'Marshall Heights', 40.464168548584, 0.706232970254726, -79.1933288574219, -1.38218433417665, 218, 45, 'PPL', 'P'),
(88837, 'Marshall Hill', 35.5280609130859, 0.620081639782453, -84.591667175293, -1.47640311196007, 218, 50, 'PPL', 'P'),
(164260, 'Marshall Hollow', 41.2219390869141, 0.719458561123195, -76.2736129760742, -1.33122567882437, 218, 45, 'PPL', 'P'),
(56105, 'Marshall Junction', 38.9580612182617, 0.67994643845218, -93.2063903808594, -1.62675839604517, 218, 29, 'PPL', 'P'),
(183122, 'Marshall Junction', 37.0138893127441, 0.646014237476126, -119.568061828613, -2.08685635913745, 218, 6, 'PPL', 'P'),
(27811, 'Marshall Landing', 38.9575004577637, 0.679936651335174, -90.5058288574219, -1.57962470580851, 218, 18, 'PPL', 'P'),
(104015, 'Marshall Manor', 37.9605598449707, 0.662536755195087, -78.5177764892578, -1.37039372108254, 218, 53, 'PPL', 'P'),
(17034, 'Marshall Plantation (historical)', 30.1499996185303, 0.526216762818388, -81.6500015258789, -1.42506136088498, 218, 12, 'PPL', 'P'),
(96020, 'Marshall Springs', 33.2219390869141, 0.579832220963649, -95.0805587768555, -1.65946880529212, 218, 51, 'PPL', 'P'),
(177244, 'Marshall Terrace', 40.2572212219238, 0.702621058026306, -80.6036071777344, -1.4067983342356, 218, 58, 'PPL', 'P'),
(4014, 'Marshall Upper Landing', 31.6625003814697, 0.552614881070607, -87.5669403076172, -1.52833142426526, 218, 2, 'PPL', 'P'),
(66642, 'Marshallberg', 34.7277793884277, 0.606114092234287, -76.51611328125, -1.33545810758677, 218, 33, 'PPL', 'P'),
(150584, 'Marshalls', 42.4116706848145, 0.74022329472157, -77.3452835083008, -1.34992985810832, 218, 40, 'PPL', 'P'),
(49260, 'Marshalls Corner', 38.5494384765625, 0.672814626211003, -77.039436340332, -1.34459181801936, 218, 25, 'PPL', 'P'),
(145705, 'Marshalls Corner', 40.3613891601563, 0.704439131523475, -74.79638671875, -1.30544321683715, 218, 37, 'PPL', 'P'),
(164273, 'Marshalls Creek', 41.0430603027344, 0.716336537377296, -75.1277770996094, -1.31122707009258, 218, 45, 'PPL', 'P'),
(14174, 'Marshallton', 39.7255592346191, 0.693341805840143, -75.6544418334961, -1.32041910375304, 218, 10, 'PPL', 'P'),
(164263, 'Marshallton', 40.7866706848145, 0.711861694376663, -76.5397186279297, -1.33587009860741, 218, 45, 'PPL', 'P'),
(14175, 'Marshallton Green', 39.7291717529297, 0.69340485617895, -75.6388931274414, -1.32014772763796, 218, 10, 'PPL', 'P'),
(14176, 'Marshallton Heights II', 39.7244415283203, 0.693322298185158, -75.6388931274414, -1.32014772763796, 218, 10, 'PPL', 'P'),
(71092, 'Marshalltown', 39.6375007629395, 0.691804895575058, -75.45361328125, -1.31691398428433, 218, 37, 'PPL', 'P'),
(104016, 'Marshalltown', 37.5380592346191, 0.655162728452767, -80.0599975585938, -1.39731055653608, 218, 53, 'PPL', 'P'),
(116755, 'Marshalltown', 42.0494384765625, 0.733901150030804, -92.9077835083008, -1.62154672294994, 218, 16, 'PPL', 'P'),
(170830, 'Marshalltown (historical)', 42.9402809143066, 0.749449283685932, -96.904167175293, -1.69129677611188, 218, 49, 'PPL', 'P'),
(22897, 'Marshallville', 32.4561080932617, 0.566465948610596, -83.9402770996094, -1.46503421042458, 218, 13, 'PPL', 'P'),
(37069, 'Marshallville', 37.6780586242676, 0.657606178752914, -82.9894409179688, -1.44843898840786, 218, 21, 'PPL', 'P'),
(71089, 'Marshallville', 39.2963905334473, 0.685851398958186, -74.7688903808594, -1.30496331520871, 218, 37, 'PPL', 'P'),
(156356, 'Marshallville', 40.9022216796875, 0.713878439691152, -81.7341690063477, -1.42653036054227, 218, 41, 'PPL', 'P'),
(164264, 'Marshbrook', 41.6372184753418, 0.726706553766928, -75.6777801513672, -1.32082643424177, 218, 45, 'PPL', 'P'),
(164265, 'Marshburg', 41.8544387817383, 0.730497763315737, -78.7547225952148, -1.37452921078127, 218, 45, 'PPL', 'P'),
(187031, 'Marshdale', 39.5924987792969, 0.691019462790566, -105.311668395996, -1.83803535427859, 218, 7, 'PPL', 'P'),
(37070, 'Marshes Siding', 36.7436103820801, 0.641296980237269, -84.480827331543, -1.47446859174424, 218, 21, 'PPL', 'P'),
(22898, 'Marshes-of-Mackay', 31.2747192382813, 0.545846823344821, -81.4305572509766, -1.42123133576328, 218, 13, 'PPL', 'P'),
(56108, 'Marshfield', 37.3386116027832, 0.651681710591924, -92.9069366455078, -1.62153194240589, 218, 29, 'PPL', 'P'),
(123142, 'Marshfield', 40.2491683959961, 0.702480509699777, -87.4527816772461, -1.52633898029571, 218, 19, 'PPL', 'P'),
(125343, 'Marshfield', 42.0916709899902, 0.734638246441511, -70.7061080932617, -1.23405438749843, 218, 23, 'PPL', 'P'),
(128076, 'Marshfield', 44.7330589294434, 0.780739162807436, -67.4780578613281, -1.17771428253142, 218, 26, 'PPL', 'P'),
(150585, 'Marshfield', 42.542781829834, 0.742511615888221, -78.8419418334961, -1.37605147366036, 218, 40, 'PPL', 'P'),
(172233, 'Marshfield', 44.350830078125, 0.774068010855815, -72.3544387817383, -1.26282318517401, 218, 55, 'PPL', 'P'),
(175193, 'Marshfield', 44.6688919067383, 0.779619236990031, -90.1716690063477, -1.57379251617929, 218, 57, 'PPL', 'P'),
(125344, 'Marshfield Center', 42.1166687011719, 0.735074538807093, -70.716667175293, -1.23423867824586, 218, 23, 'PPL', 'P'),
(125345, 'Marshfield Hills', 42.1458282470703, 0.735583468891407, -70.7402801513672, -1.23465080242455, 218, 23, 'PPL', 'P'),
(144118, 'Marshfield Station', 44.2691688537598, 0.772642753619432, -71.3572235107422, -1.24541849534396, 218, 36, 'PPL', 'P'),
(164266, 'Marshfield Station', 40.9033317565918, 0.713897814188083, -75.0808334350586, -1.31040774858322, 218, 45, 'PPL', 'P'),
(175197, 'Marshland', 44.0736083984375, 0.769229579787359, -91.5547180175781, -1.59793127514171, 218, 57, 'PPL', 'P'),
(201191, 'Marshland', 46.1113891601563, 0.804795563513149, -123.284439086914, -2.15171937854104, 218, 43, 'PPL', 'P'),
(190457, 'Marshland (historical)', 39.3027801513672, 0.685962918828833, -119.247222900391, -2.0812566634714, 218, 39, 'PPL', 'P'),
(164267, 'Marshlands', 41.7133293151855, 0.728034938518659, -77.5788879394531, -1.35400702457918, 218, 45, 'PPL', 'P'),
(49261, 'Marshope', 38.4752807617188, 0.671520329921224, -77.1911087036133, -1.3472390001429, 218, 25, 'PPL', 'P'),
(156357, 'Marshs (historical)', 40.5588912963867, 0.70788619408042, -83.4416732788086, -1.45633193208858, 218, 41, 'PPL', 'P'),
(14177, 'Marshtown', 38.6933288574219, 0.675325987118947, -75.1641693115234, -1.31186223401256, 218, 10, 'PPL', 'P'),
(123143, 'Marshtown', 40.9488906860352, 0.714692967510553, -86.3386077880859, -1.50689297749012, 218, 19, 'PPL', 'P'),
(164268, 'Marshview', 41.6752815246582, 0.727370879300848, -76.3850021362305, -1.33316978642012, 218, 45, 'PPL', 'P'),
(66644, 'Marshville', 34.9883308410645, 0.610661572953652, -80.3672180175781, -1.40267256507485, 218, 33, 'PPL', 'P'),
(110306, 'Marshville', 39.3213882446289, 0.686287691323768, -80.4644393920898, -1.40436939816339, 218, 58, 'PPL', 'P'),
(128078, 'Marshville', 44.6161117553711, 0.778698049568972, -67.7850036621094, -1.18307149738022, 218, 26, 'PPL', 'P'),
(150587, 'Marshville', 44.4511108398438, 0.775818240324215, -75.2322235107422, -1.31305000385874, 218, 40, 'PPL', 'P'),
(208037, 'Marshville (historical)', 47.0522193908691, 0.821216148741387, -122.913330078125, -2.14524230445386, 218, 56, 'PPL', 'P'),
(164269, 'Marshwood', 41.4361114501953, 0.723196574029231, -75.567497253418, -1.31890163456392, 218, 45, 'PPL', 'P'),
(22899, 'Marshwood At The Landings', 31.9397201538086, 0.55745327884955, -81.0316696166992, -1.41426943319965, 218, 13, 'PPL', 'P'),
(96021, 'Marshy Springs', 31.523609161377, 0.550190771977876, -96.1011123657227, -1.6772808256109, 218, 51, 'PPL', 'P'),
(49265, 'Marshyhope Village', 38.622501373291, 0.67408981431996, -75.8241729736328, -1.32338147099159, 218, 25, 'PPL', 'P'),
(195291, 'Marsing', 43.5455589294434, 0.760013377940004, -116.812217712402, -2.03875780563786, 218, 17, 'PPL', 'P'),
(199514, 'Marsland', 42.4438896179199, 0.740785621185741, -103.298057556152, -1.80289121526947, 218, 35, 'PPL', 'P'),
(164270, 'Marsteller', 40.6505584716797, 0.709486088105285, -78.8083267211914, -1.37546477927222, 218, 45, 'PPL', 'P'),
(49262, 'Marston', 39.5077781677246, 0.689540809174327, -77.1005630493164, -1.34565868035205, 218, 25, 'PPL', 'P'),
(56109, 'Marston', 36.5188903808594, 0.637374876320882, -89.6125030517578, -1.56403322920664, 218, 29, 'PPL', 'P'),
(66646, 'Marston', 34.9880599975586, 0.610656845842717, -79.5824966430664, -1.38897659337884, 218, 33, 'PPL', 'P'),
(96025, 'Marston', 30.7580604553223, 0.53682942647284, -94.9086074829102, -1.65646768905971, 218, 51, 'PPL', 'P'),
(120528, 'Marston', 41.3072204589844, 0.720947001856441, -90.8016662597656, -1.58478804252996, 218, 18, 'PPL', 'P'),
(41991, 'Marston (historical)', 30.8344402313232, 0.538162505045993, -89.8480606079102, -1.56814448413945, 218, 22, 'PPL', 'P'),
(128079, 'Marston Corner', 44.0505599975586, 0.768827309304703, -70.2766723632813, -1.22655932008456, 218, 26, 'PPL', 'P'),
(125347, 'Marston Corners', 42.7416687011719, 0.745982846632058, -71.1686096191406, -1.24212656192051, 218, 23, 'PPL', 'P'),
(125348, 'Marstons Mills', 41.6561088562012, 0.72703625310988, -70.4166717529297, -1.22900277038471, 218, 23, 'PPL', 'P'),
(164271, 'Marstown', 40.5397186279297, 0.707551567889451, -76.3783264160156, -1.33305327312243, 218, 45, 'PPL', 'P'),
(96022, 'Mart', 31.5422191619873, 0.550515577762325, -96.8333282470703, -1.69006040357581, 218, 51, 'PPL', 'P'),
(104017, 'Mart', 37.209171295166, 0.64942255103921, -82.2855606079102, -1.43615395945738, 218, 53, 'PPL', 'P'),
(17035, 'Mart Law Seminole Village', 25.9441699981689, 0.452811188165179, -80.8186111450195, -1.41055086136958, 218, 12, 'PPL', 'P'),
(17036, 'Martel', 29.1863899230957, 0.509398600928915, -82.2466735839844, -1.43547525285357, 218, 12, 'PPL', 'P'),
(88839, 'Martel', 35.8216705322266, 0.625206094351983, -84.2197189331055, -1.4699113904869, 218, 50, 'PPL', 'P'),
(156358, 'Martel', 40.6688919067383, 0.709806066910258, -82.9102783203125, -1.44705734043433, 218, 41, 'PPL', 'P'),
(88840, 'Martel Estates', 35.811939239502, 0.625036251253463, -84.2344436645508, -1.47016838553209, 218, 50, 'PPL', 'P'),
(88841, 'Martel Estates East', 35.8180618286133, 0.625143110592203, -84.2319412231445, -1.47012470969021, 218, 50, 'PPL', 'P'),
(142362, 'Martell', 40.6375007629395, 0.709258188095001, -96.7583312988281, -1.68875145990003, 218, 35, 'PPL', 'P'),
(175198, 'Martell', 44.829719543457, 0.782426208778974, -92.3974990844727, -1.61264057963249, 218, 57, 'PPL', 'P'),
(183123, 'Martell', 38.3669395446777, 0.669629418968241, -120.794998168945, -2.10827043798862, 218, 6, 'PPL', 'P'),
(116756, 'Martelle', 42.021671295166, 0.733416521291437, -91.3597183227539, -1.59452788842665, 218, 16, 'PPL', 'P'),
(41992, 'Martello Castle', 29.9449996948242, 0.52263883918338, -89.8349990844727, -1.56791651755014, 218, 22, 'PPL', 'P'),
(128080, 'Martells Mobile Home Court', 44.7969398498535, 0.781854095197798, -68.8291702270508, -1.20129564187769, 218, 26, 'PPL', 'P'),
(116757, 'Martensdale', 41.3730583190918, 0.722096089287783, -93.7355575561523, -1.63599410554751, 218, 16, 'PPL', 'P'),
(37071, 'Martha', 38.0091705322266, 0.663385171739359, -82.913330078125, -1.44711060365613, 218, 21, 'PPL', 'P'),
(66648, 'Martha', 35.6108283996582, 0.621526204936739, -80.0188903808594, -1.39659310093842, 218, 33, 'PPL', 'P'),
(71090, 'Martha', 39.6819381713867, 0.692580474663516, -74.5108337402344, -1.30045937717317, 218, 37, 'PPL', 'P'),
(76518, 'Martha', 34.7252807617188, 0.606070482971437, -99.3866729736328, -1.73462467599276, 218, 42, 'PPL', 'P'),
(88842, 'Martha', 36.2297210693359, 0.632327919739073, -86.4269409179688, -1.50843468144517, 218, 50, 'PPL', 'P'),
(96023, 'Martha', 30.086669921875, 0.525111451097464, -94.9180603027344, -1.65663267188924, 218, 51, 'PPL', 'P'),
(110307, 'Martha', 38.3766708374023, 0.66979926206676, -82.2869415283203, -1.43617806106524, 218, 58, 'PPL', 'P'),
(10330, 'Martha (historical)', 34.0716705322266, 0.594662832442082, -94.0255584716797, -1.64105557635726, 218, 4, 'PPL', 'P'),
(164272, 'Martha Furnace', 40.8347206115723, 0.712700323803929, -78.0074996948242, -1.36148771092315, 218, 45, 'PPL', 'P'),
(208038, 'Martha Lake', 47.8511085510254, 0.835159394944606, -122.238059997559, -2.13345661820777, 218, 56, 'PPL', 'P'),
(88844, 'Marthas Chapel', 36.2466697692871, 0.632623730357153, -87.5319366455078, -1.52772049511119, 218, 50, 'PPL', 'P'),
(49263, 'Marthas Legacy', 39.4583282470703, 0.68867774524406, -76.9291687011719, -1.34266728465762, 218, 25, 'PPL', 'P'),
(56110, 'Marthasville', 38.6283302307129, 0.674191547073601, -91.057502746582, -1.58925323157164, 218, 29, 'PPL', 'P'),
(110309, 'Marthatown', 37.934440612793, 0.662080888595493, -81.6977767944336, -1.42589519662228, 218, 58, 'PPL', 'P'),
(41993, 'Marthaville', 31.7386093139648, 0.553943232532825, -93.3963928222656, -1.63007456423453, 218, 22, 'PPL', 'P'),
(78694, 'Martic Forge', 39.9052810668945, 0.696478543551065, -76.3277816772461, -1.33217110101134, 218, 45, 'PPL', 'P'),
(78696, 'Marticville', 39.9263916015625, 0.696846991887878, -76.3072204589844, -1.33181224005446, 218, 45, 'PPL', 'P'),
(882, 'Martin', 33.0688896179199, 0.577161003811272, -81.4766693115234, -1.42203614304471, 218, 48, 'PPL', 'P'),
(4015, 'Martin', 32.3127784729004, 0.563964374819657, -87.3061065673828, -1.52377901669787, 218, 2, 'PPL', 'P'),
(10331, 'Martin', 36.1833305358887, 0.631518252188662, -94.4469375610352, -1.64841002886557, 218, 4, 'PPL', 'P'),
(17037, 'Martin', 29.2936096191406, 0.511269937647886, -82.190559387207, -1.4344958753627, 218, 12, 'PPL', 'P'),
(22900, 'Martin', 34.4869384765625, 0.601910625348733, -83.1849975585938, -1.45185209566091, 218, 13, 'PPL', 'P'),
(30449, 'Martin', 38.124439239502, 0.665396990205832, -87.6736068725586, -1.53019310702528, 218, 19, 'PPL', 'P'),
(37072, 'Martin', 37.5727806091309, 0.655768730758814, -82.7527770996094, -1.44430842555715, 218, 21, 'PPL', 'P'),
(41995, 'Martin', 32.0852813720703, 0.559993801371431, -93.2200012207031, -1.6269959500144, 218, 22, 'PPL', 'P'),
(49264, 'Martin', 39.3777809143066, 0.687271929083634, -77.3083267211914, -1.3492848404923, 218, 25, 'PPL', 'P'),
(60781, 'Martin', 31.1855602264404, 0.544290705030374, -90.3788909912109, -1.57740922209767, 218, 30, 'PPL', 'P'),
(76520, 'Martin', 35.5663909912109, 0.62075062584828, -95.3105621337891, -1.66348312116125, 218, 42, 'PPL', 'P'),
(78698, 'Martin', 39.8880615234375, 0.69617800582205, -76.8408279418945, -1.34112544754452, 218, 45, 'PPL', 'P'),
(88843, 'Martin', 36.3433303833008, 0.634310776328691, -88.8502807617188, -1.55072994061337, 218, 50, 'PPL', 'P'),
(96024, 'Martin', 31.0463905334473, 0.541861735668653, -94.4002838134766, -1.64759576736227, 218, 51, 'PPL', 'P'),
(110308, 'Martin', 39.2241706848145, 0.684590924814251, -79.0891723632813, -1.38036646041656, 218, 58, 'PPL', 'P'),
(128081, 'Martin', 43.9705581665039, 0.767431013945174, -69.3594436645508, -1.21055065929793, 218, 26, 'PPL', 'P'),
(131962, 'Martin', 42.5369415283203, 0.742409683397498, -85.6416702270508, -1.49472912236924, 218, 27, 'PPL', 'P'),
(144119, 'Martin', 43.0433311462402, 0.751247849528117, -71.454719543457, -1.24712012212246, 218, 36, 'PPL', 'P'),
(150588, 'Martin', 43.0258293151855, 0.750942384951085, -77.7055587768555, -1.35621784775811, 218, 40, 'PPL', 'P'),
(156359, 'Martin', 41.5574989318848, 0.725315185255416, -83.336669921875, -1.45449927778444, 218, 41, 'PPL', 'P'),
(190458, 'Martin', 39.6041717529297, 0.691223194613957, -119.870826721191, -2.09214060337239, 218, 39, 'PPL', 'P'),
(192689, 'Martin', 39.7019386291504, 0.692929548503398, -110.867500305176, -1.93500291378114, 218, 52, 'PPL', 'P'),
(195292, 'Martin', 43.5188903808594, 0.759547923960485, -113.566390991211, -1.98210744240386, 218, 17, 'PPL', 'P'),
(198584, 'Martin', 47.8266716003418, 0.83473288969603, -100.114723205566, -1.74733154965991, 218, 34, 'PPL', 'P'),
(199515, 'Martin', 41.2561111450195, 0.720054976049319, -101.690559387207, -1.77483507950159, 218, 35, 'PPL', 'P'),
(202346, 'Martin', 43.1725006103516, 0.753502281969896, -101.732223510742, -1.77556225563724, 218, 49, 'PPL', 'P'),
(208039, 'Martin', 47.2808303833008, 0.825206163265571, -121.316673278809, -2.11737538628143, 218, 56, 'PPL', 'P'),
(66647, 'Martin (historical)', 36.202220916748, 0.631847951531613, -80.9844436645508, -1.41344518484227, 218, 33, 'PPL', 'P'),
(120529, 'Martin (historical)', 41.1472206115723, 0.718154477716411, -90.6369400024414, -1.58191302697516, 218, 18, 'PPL', 'P'),
(196986, 'Martin (historical)', 46.9077796936035, 0.818695200453518, -107.745002746582, -1.88050505049819, 218, 31, 'PPL', 'P'),
(60782, 'Martin Bluff', 30.4566707611084, 0.531569183977229, -88.6394424438477, -1.54705011777715, 218, 30, 'PPL', 'P'),
(10332, 'Martin Box', 35.9425010681152, 0.62731498504019, -92.6122207641602, -1.61638817991845, 218, 4, 'PPL', 'P'),
(56111, 'Martin City', 38.8861083984375, 0.678690624840153, -94.5899963378906, -1.65090687554557, 218, 29, 'PPL', 'P'),
(196987, 'Martin City', 48.3916702270508, 0.844593976001348, -114.037216186523, -1.99032489226341, 218, 31, 'PPL', 'P'),
(82266, 'Martin Corner', 33.4094390869141, 0.583104713311138, -79.7072219848633, -1.39115346125387, 218, 48, 'PPL', 'P'),
(128082, 'Martin Corner', 44.8069381713867, 0.782028598828226, -69.8072204589844, -1.21836583867482, 218, 26, 'PPL', 'P'),
(88845, 'Martin Creek', 36.5847206115723, 0.63852383059417, -83.3541717529297, -1.45480474236148, 218, 50, 'PPL', 'P'),
(22902, 'Martin Creek Country Estates', 33.6044387817383, 0.586508100026205, -84.1972198486328, -1.46951870738416, 218, 13, 'PPL', 'P'),
(144120, 'Martin Crossing', 43.0208282470703, 0.750855099846358, -71.0863876342773, -1.24069151756712, 218, 36, 'PPL', 'P'),
(82267, 'Martin Crossroads', 34.6291694641113, 0.604393024379823, -82.0305633544922, -1.43170341780169, 218, 48, 'PPL', 'P'),
(22903, 'Martin Glen', 30.7749996185303, 0.537125070643352, -81.726936340332, -1.4264041267066, 218, 13, 'PPL', 'P'),
(30451, 'Martin Heights', 38.6124992370605, 0.673915244110505, -86.1080627441406, -1.50286920739912, 218, 19, 'PPL', 'P'),
(41996, 'Martin Junction', 32.4244384765625, 0.56591320952635, -93.2819366455078, -1.62807692710087, 218, 22, 'PPL', 'P'),
(136751, 'Martin Lake', 45.3811111450195, 0.792049807694085, -93.0947189331055, -1.62480936160139, 218, 28, 'PPL', 'P'),
(136752, 'Martin Landing', 47.7449989318848, 0.833307432722565, -91.3036117553711, -1.59354864409383, 218, 28, 'PPL', 'P'),
(49266, 'Martin Manor', 39.4180603027344, 0.687974937032388, -76.2986068725586, -1.33166190461092, 218, 25, 'PPL', 'P'),
(188981, 'Martin Place', 34.5363883972168, 0.602773689279, -106.330001831055, -1.8558086256035, 218, 38, 'PPL', 'P'),
(10333, 'Martin Spring', 35.5444412231445, 0.620367530125473, -93.4358291625977, -1.63076285821827, 218, 4, 'PPL', 'P'),
(88846, 'Martin Springs', 35.1666717529297, 0.613774209056709, -85.7897186279297, -1.49731305441689, 218, 50, 'PPL', 'P'),
(96026, 'Martin Springs', 33.086669921875, 0.577471328657294, -95.5647201538086, -1.66791901543094, 218, 51, 'PPL', 'P'),
(82269, 'Martin Subdivision', 33.8811111450195, 0.591336943714737, -80.3466720581055, -1.40231397043407, 218, 48, 'PPL', 'P'),
(10336, 'Martindale', 34.8816719055176, 0.608800023351686, -92.6880569458008, -1.61771177098022, 218, 4, 'PPL', 'P'),
(22905, 'Martindale', 34.6227798461914, 0.604281504509176, -85.3022232055664, -1.48880465420825, 218, 13, 'PPL', 'P'),
(49268, 'Martindale', 39.5819396972656, 0.690835172043133, -76.3675003051758, -1.33286432184309, 218, 25, 'PPL', 'P'),
(82268, 'Martindale', 34.6494407653809, 0.60474682533064, -82.897216796875, -1.44682937384502, 218, 48, 'PPL', 'P'),
(96027, 'Martindale', 29.8452796936035, 0.520898396831986, -97.8405609130859, -1.70763992993142, 218, 51, 'PPL', 'P'),
(150589, 'Martindale', 42.2069396972656, 0.736650064907984, -73.6322174072266, -1.28512462930039, 218, 40, 'PPL', 'P'),
(164275, 'Martindale', 40.1530609130859, 0.70080311768719, -76.0888900756836, -1.32800165600872, 218, 45, 'PPL', 'P'),
(208040, 'Martindale', 46.2430610656738, 0.807093671796806, -118.961936950684, -2.07627748433933, 218, 56, 'PPL', 'P'),
(66650, 'Martindale (historical)', 35.3177795410156, 0.616411537484214, -80.9444427490234, -1.41274703716251, 218, 33, 'PPL', 'P'),
(170831, 'Martindale Addition', 43.5886116027832, 0.76076478884157, -96.7652816772461, -1.68887276688769, 218, 49, 'PPL', 'P'),
(131964, 'Martindale Beach', 42.6913909912109, 0.745105335052876, -82.5074996948242, -1.4400275272629, 218, 27, 'PPL', 'P'),
(22906, 'Martinez', 33.517219543457, 0.584985837147116, -82.0758285522461, -1.43249344453907, 218, 13, 'PPL', 'P'),
(96028, 'Martinez', 29.4186096191406, 0.513451599212879, -98.335563659668, -1.71627935766569, 218, 51, 'PPL', 'P'),
(183127, 'Martinez', 38.0233306884766, 0.663632313088518, -120.378608703613, -2.10100307084795, 218, 6, 'PPL', 'P'),
(188982, 'Martinez', 34.9991683959961, 0.610850723970074, -106.190559387207, -1.85337489584133, 218, 38, 'PPL', 'P'),
(96029, 'Martinez Addition Colonia', 27.742000579834, 0.484189251208279, -98.0950012207031, -1.71208075104913, 218, 51, 'PPL', 'P'),
(183128, 'Martinez Place', 35.2880592346191, 0.615892820282894, -120.165000915527, -2.09727491163795, 218, 6, 'PPL', 'P'),
(188983, 'Martinez Town', 35.089168548584, 0.61242152296003, -106.641387939453, -1.86124333844003, 218, 38, 'PPL', 'P'),
(110310, 'Marting', 38.2019386291504, 0.666749609723483, -81.253059387207, -1.41813341362525, 218, 58, 'PPL', 'P'),
(49269, 'Martingham', 38.8055610656738, 0.677284808679728, -76.2311096191406, -1.33048385530272, 218, 25, 'PPL', 'P'),
(4017, 'Martins', 33.4874992370605, 0.584467119945796, -86.892219543457, -1.51655532539909, 218, 2, 'PPL', 'P'),
(145706, 'Martins', 41.1936111450195, 0.718964145266822, -74.5944366455078, -1.30191852313443, 218, 37, 'PPL', 'P'),
(183129, 'Martins', 34.5661087036133, 0.603292406480321, -118.658889770508, -2.07098831325638, 218, 6, 'PPL', 'P'),
(22907, 'Martins (historical)', 31.8422203063965, 0.555751585492016, -81.5583267211914, -1.42346133370206, 218, 13, 'PPL', 'P'),
(49270, 'Martins Addition', 38.9811096191406, 0.680348708934837, -77.0697174072266, -1.34512032233769, 218, 25, 'PPL', 'P'),
(49271, 'Martins Additions', 38.9791717529297, 0.680314886788993, -77.0697174072266, -1.34512032233769, 218, 25, 'PPL', 'P'),
(145707, 'Martins Beach', 40.0083312988281, 0.69827710939325, -74.8877792358398, -1.30703831717205, 218, 37, 'PPL', 'P'),
(183130, 'Martins Beach', 37.375, 0.652316807932881, -122.406936645508, -2.13640407174421, 218, 6, 'PPL', 'P'),
(131965, 'Martins Bluff', 45.6363906860352, 0.796505276197787, -85.4880599975586, -1.49204811809985, 218, 27, 'PPL', 'P'),
(49272, 'Martins Choice', 39.3869400024414, 0.687431785328066, -76.6386108398438, -1.33759609330989, 218, 25, 'PPL', 'P'),
(49273, 'Martins Corner', 38.2969398498535, 0.668407693818167, -75.7969436645508, -1.32290622989507, 218, 25, 'PPL', 'P'),
(104019, 'Martins Corner', 37.1138916015625, 0.647759606675537, -78.1369400024414, -1.36374687047587, 218, 53, 'PPL', 'P'),
(128083, 'Martins Corner', 44.3147201538086, 0.773437773783848, -69.2533264160156, -1.20869856391784, 218, 26, 'PPL', 'P'),
(144121, 'Martins Corner', 43.0480613708496, 0.751330407521909, -71.4327774047852, -1.24673715955771, 218, 36, 'PPL', 'P'),
(164276, 'Martins Corner', 40.0422210693359, 0.698868597471357, -75.8602828979492, -1.32401170806356, 218, 45, 'PPL', 'P'),
(49274, 'Martins Cove Farm', 39.0041694641113, 0.680751179154575, -76.4702835083008, -1.33465822715337, 218, 25, 'PPL', 'P'),
(66652, 'Martins Creek', 35.0250015258789, 0.611301597142625, -84.0308303833008, -1.46661466337349, 218, 33, 'PPL', 'P'),
(164277, 'Martins Creek', 40.7833290100098, 0.71180337114879, -75.1866683959961, -1.3122549171153, 218, 45, 'PPL', 'P'),
(164278, 'Martins Creek Junction', 40.8274993896484, 0.712574289705341, -75.2005615234375, -1.31249739793255, 218, 45, 'PPL', 'P'),
(22909, 'Martins Crossroads', 31.6969394683838, 0.553215956528638, -84.6388931274414, -1.47722736031745, 218, 13, 'PPL', 'P'),
(49275, 'Martins Crossroads', 39.6813888549805, 0.692570887283592, -77.7900009155273, -1.35769164110536, 218, 25, 'PPL', 'P'),
(82270, 'Martins Crossroads', 33.6997184753418, 0.588171044389878, -79.9574966430664, -1.39552157807382, 218, 48, 'PPL', 'P'),
(164279, 'Martins Crossroads', 40.5591697692871, 0.707891054349409, -77.4986114501953, -1.35260593552969, 218, 45, 'PPL', 'P'),
(156360, 'Martins Ferry', 40.0958290100098, 0.699804232541329, -80.7247161865234, -1.4089120851928, 218, 41, 'PPL', 'P'),
(193767, 'Martins Ferry (historical)', 41.2083282470703, 0.71922100715396, -123.754173278809, -2.1599177867988, 218, 6, 'PPL', 'P'),
(37074, 'Martins Fork', 36.7161102294922, 0.64081701202981, -83.3222198486328, -1.45424707642921, 218, 21, 'PPL', 'P'),
(41997, 'Martins Landing', 31.8341693878174, 0.555611070455001, -91.5688934326172, -1.59817868280698, 218, 22, 'PPL', 'P'),
(82272, 'Martins Landing', 32.6505584716797, 0.569859747945738, -81.3930587768555, -1.4205768639254, 218, 48, 'PPL', 'P'),
(131966, 'Martins Landing', 46.5363883972168, 0.81221319951832, -87.9855575561523, -1.53563767355783, 218, 27, 'PPL', 'P'),
(145708, 'Martins Landing', 40.4930610656738, 0.706737239807132, -74.4000015258789, -1.29852499011539, 218, 37, 'PPL', 'P'),
(4018, 'Martins Mill', 33.6347198486328, 0.587036604344531, -86.0683288574219, -1.50217572025126, 218, 2, 'PPL', 'P'),
(96030, 'Martins Mill', 32.4161109924316, 0.565767867509859, -95.7900009155273, -1.67185090646433, 218, 51, 'PPL', 'P'),
(88848, 'Martins Mills', 35.2019386291504, 0.614389732163653, -87.9519424438477, -1.53505097916969, 218, 50, 'PPL', 'P'),
(60783, 'Martins Pine Hill Estates', 30.4963893890381, 0.532262404808976, -88.8569412231445, -1.55084618759495, 218, 30, 'PPL', 'P'),
(82273, 'Martins Point Landing', 32.8958282470703, 0.574140513081932, -79.8388900756836, -1.3934515029585, 218, 48, 'PPL', 'P'),
(104020, 'Martins Shop', 37.4841690063477, 0.654222166534778, -79.0583267211914, -1.3798281024022, 218, 53, 'PPL', 'P'),
(104021, 'Martins Siding', 37.3899993896484, 0.652578596668035, -75.9100036621094, -1.32487949910476, 218, 53, 'PPL', 'P'),
(66653, 'Martins Store', 35.8499984741211, 0.625700510208356, -80.4974975585938, -1.40494637201356, 218, 33, 'PPL', 'P'),
(104024, 'Martins Store', 37.9174995422363, 0.661785211135467, -78.8405609130859, -1.3760273720525, 218, 53, 'PPL', 'P'),
(27815, 'Martinsburg', 39.5158309936523, 0.689681357500856, -90.8424987792969, -1.58550070443766, 218, 18, 'PPL', 'P'),
(30457, 'Martinsburg', 38.4438896179199, 0.670972451105967, -86.0261077880859, -1.50143882357764, 218, 19, 'PPL', 'P'),
(37075, 'Martinsburg', 36.6458282470703, 0.639590360031719, -85.4852828979492, -1.49199964856801, 218, 21, 'PPL', 'P'),
(49276, 'Martinsburg', 39.1641693115234, 0.683543703294605, -77.475830078125, -1.35220832557894, 218, 25, 'PPL', 'P'),
(56112, 'Martinsburg', 39.1022186279297, 0.682462459892033, -91.6474990844727, -1.59955061024254, 218, 29, 'PPL', 'P'),
(110311, 'Martinsburg', 39.4561080932617, 0.688638996250199, -77.9641723632813, -1.36073150633163, 218, 58, 'PPL', 'P'),
(116758, 'Martinsburg', 41.1788902282715, 0.718707216800657, -92.2516708374023, -1.61009539657871, 218, 16, 'PPL', 'P'),
(142364, 'Martinsburg', 42.5083312988281, 0.741910340693108, -96.8305587768555, -1.69001206720202, 218, 35, 'PPL', 'P'),
(150590, 'Martinsburg', 43.7374992370605, 0.763363368275214, -75.4700012207031, -1.31720000778541, 218, 40, 'PPL', 'P'),
(156361, 'Martinsburg', 40.269718170166, 0.702839170919583, -82.3541717529297, -1.43735144984153, 218, 41, 'PPL', 'P'),
(164280, 'Martinsburg', 40.3111114501953, 0.703561619944294, -78.3244400024414, -1.36701936282336, 218, 45, 'PPL', 'P'),
(56113, 'Martinsburg (historical)', 36.5877799987793, 0.638577226974026, -90.690559387207, -1.58284886178221, 218, 29, 'PPL', 'P'),
(73380, 'Martinsburg (historical)', 39.1063919067383, 0.682535297347846, -82.2194366455078, -1.43499987859899, 218, 41, 'PPL', 'P'),
(164281, 'Martinsburg Junction', 40.3088912963867, 0.703522870950434, -78.3394393920898, -1.36728115155851, 218, 45, 'PPL', 'P'),
(196989, 'Martinsdale', 46.4583282470703, 0.810850792883663, -110.3125, -1.92531633110624, 218, 31, 'PPL', 'P'),
(196988, 'Martinsdale Colony', 46.4894409179688, 0.81139381142993, -110.266670227051, -1.92451645067284, 218, 31, 'PPL', 'P'),
(116759, 'Martinstown', 40.6872215270996, 0.710125979136203, -92.9588928222656, -1.62243874875706, 218, 16, 'PPL', 'P'),
(139308, 'Martinstown', 40.4105606079102, 0.705297335184754, -92.7702789306641, -1.61914681533361, 218, 29, 'PPL', 'P'),
(156362, 'Martinstown (historical)', 40.9063911437988, 0.713951210567939, -83.6511077880859, -1.45998725384277, 218, 41, 'PPL', 'P'),
(27817, 'Martinsville', 39.3355598449707, 0.686535032410009, -87.8819427490234, -1.53382925401962, 218, 18, 'PPL', 'P'),
(30453, 'Martinsville', 39.4277801513672, 0.688144580393826, -86.4283294677734, -1.50845891621108, 218, 19, 'PPL', 'P'),
(37076, 'Martinsville', 36.9244384765625, 0.644453025866095, -86.2147216796875, -1.50473075700108, 218, 21, 'PPL', 'P'),
(60784, 'Martinsville', 31.7908306121826, 0.554854666126391, -90.4069366455078, -1.57789871110603, 218, 30, 'PPL', 'P'),
(78699, 'Martinsville', 39.9402809143066, 0.697089406126102, -76.5250015258789, -1.33561323672027, 218, 45, 'PPL', 'P'),
(96031, 'Martinsville', 31.6424999237061, 0.552265807230725, -94.4138870239258, -1.64783318817346, 218, 51, 'PPL', 'P'),
(104025, 'Martinsville', 36.6913909912109, 0.640385579933217, -79.8727798461914, -1.39404299103661, 218, 53, 'PPL', 'P'),
(128084, 'Martinsville', 43.9433288574219, 0.76695577284865, -69.2266693115234, -1.2082333096754, 218, 26, 'PPL', 'P'),
(131967, 'Martinsville', 42.144718170166, 0.735564094394477, -83.460563659668, -1.45666163143153, 218, 27, 'PPL', 'P'),
(139309, 'Martinsville', 40.3386116027832, 0.704041588151754, -94.1613922119141, -1.64342632235965, 218, 29, 'PPL', 'P'),
(145709, 'Martinsville', 40.6011085510254, 0.708623024175017, -74.559440612793, -1.30130772713842, 218, 37, 'PPL', 'P'),
(150593, 'Martinsville', 42.7213897705078, 0.745628912523186, -78.133056640625, -1.36367909302613, 218, 40, 'PPL', 'P'),
(156363, 'Martinsville', 40.6144409179688, 0.708855717875263, -81.8680572509766, -1.42886715124076, 218, 41, 'PPL', 'P'),
(175200, 'Martinsville', 43.1802787780762, 0.753638036606463, -89.5899963378906, -1.56364041294585, 218, 57, 'PPL', 'P'),
(120532, 'Martinton', 40.915828704834, 0.71411592708136, -87.7252807617188, -1.53109498652843, 218, 18, 'PPL', 'P'),
(4023, 'Martintown', 34.7436103820801, 0.606390395197382, -85.9205627441406, -1.49959671505163, 218, 2, 'PPL', 'P'),
(60785, 'Martintown', 34.4583282470703, 0.601411282644343, -89.054443359375, -1.55429325015189, 218, 30, 'PPL', 'P'),
(164283, 'Martintown', 40.642219543457, 0.709340546351712, -78.851936340332, -1.37622591071176, 218, 45, 'PPL', 'P'),
(175201, 'Martintown', 42.5083312988281, 0.741910340693108, -89.8005599975586, -1.56731544209211, 218, 57, 'PPL', 'P'),
(183131, 'Martinus Corner', 35.939998626709, 0.627271309198312, -121.118057250977, -2.11390888264853, 218, 6, 'PPL', 'P'),
(142365, 'Martinview Mobile Home Park', 41.1375007629395, 0.717984834354973, -95.9244384765625, -1.67419728454275, 218, 35, 'PPL', 'P'),
(4020, 'Martinville', 31.0922203063965, 0.542661616102059, -87.4805603027344, -1.52682380877216, 218, 2, 'PPL', 'P'),
(10339, 'Martinville', 35.3250007629395, 0.616537571582802, -92.4822235107422, -1.61411929982776, 218, 4, 'PPL', 'P'),
(41998, 'Martinville', 30.5991706848145, 0.53405627682974, -90.1791687011719, -1.57392341054687, 218, 22, 'PPL', 'P'),
(60786, 'Martinville', 31.9733295440674, 0.558039873369153, -89.7538909912109, -1.56650091427271, 218, 30, 'PPL', 'P'),
(150594, 'Martisco', 43.017219543457, 0.750792116086577, -76.3349990844727, -1.33229706853091, 218, 40, 'PPL', 'P'),
(142366, 'Martland', 40.4519386291504, 0.706019517893356, -97.6711120605469, -1.70468248954089, 218, 35, 'PPL', 'P'),
(4022, 'Martling', 34.3672218322754, 0.599821175736484, -86.1675033569336, -1.50390664180176, 218, 2, 'PPL', 'P'),
(150595, 'Martville', 43.2799987792969, 0.755378478957857, -76.6275024414063, -1.33740221518253, 218, 40, 'PPL', 'P'),
(37077, 'Martwick', 37.3269386291504, 0.651477978768533, -87.0238876342773, -1.51885336710372, 218, 21, 'PPL', 'P'),
(76523, 'Marty', 34.5294418334961, 0.602652448870375, -99.5074996948242, -1.73673350010194, 218, 42, 'PPL', 'P'),
(136755, 'Marty', 45.3997192382813, 0.79237458018902, -94.3324966430664, -1.64641265804801, 218, 28, 'PPL', 'P'),
(170832, 'Marty', 42.9925003051758, 0.750360683989984, -98.4247207641602, -1.71783544269062, 218, 49, 'PPL', 'P'),
(183132, 'Marty (historical)', 38.6297187805176, 0.67421578183952, -121.581390380859, -2.12199557129856, 218, 6, 'PPL', 'P'),
(164284, 'Martzville', 41.0686111450195, 0.716782483701829, -76.267219543457, -1.33111409237469, 218, 45, 'PPL', 'P'),
(112393, 'Marumsco', 38.0077781677246, 0.663360870394412, -75.6849975585938, -1.32095240176133, 218, 25, 'PPL', 'P'),
(104027, 'Marumsco Acres', 38.6430587768555, 0.674448608697821, -77.2597198486328, -1.34843649052706, 218, 53, 'PPL', 'P'),
(104028, 'Marumsco Hills', 38.6436080932617, 0.674458196077745, -77.2752838134766, -1.34870813295825, 218, 53, 'PPL', 'P'),
(104029, 'Marumsco Village', 38.6613883972168, 0.674768520923766, -77.258056640625, -1.34840746207118, 218, 53, 'PPL', 'P'),
(104030, 'Marumsco Woods', 38.621940612793, 0.674080027202954, -77.2608337402344, -1.34845593160302, 218, 53, 'PPL', 'P'),
(49277, 'Marvania Heights', 39.7208290100098, 0.69325924784635, -78.116943359375, -1.36339786321501, 218, 25, 'PPL', 'P'),
(4024, 'Marvel', 33.146671295166, 0.57851855017694, -87.003059387207, -1.51848984561492, 218, 2, 'PPL', 'P'),
(110312, 'Marvel', 38.1738891601563, 0.6662600541361, -81.0758285522461, -1.41504015201912, 218, 58, 'PPL', 'P'),
(187032, 'Marvel', 37.1124992370605, 0.64773530533059, -108.126106262207, -1.88715656163677, 218, 7, 'PPL', 'P'),
(88849, 'Marvel (historical)', 36.2305603027344, 0.632342567125068, -86.6688919067383, -1.51265752282765, 218, 50, 'PPL', 'P'),
(56114, 'Marvel Cave', 36.6997184753418, 0.640530921949708, -93.336669921875, -1.62903220298388, 218, 29, 'PPL', 'P'),
(10340, 'Marvell', 34.5555610656738, 0.603108315469969, -90.9127807617188, -1.58672735643575, 218, 4, 'PPL', 'P'),
(96032, 'Marvels', 30.4347190856934, 0.531186054964907, -94.7666702270508, -1.65399041661372, 218, 51, 'PPL', 'P'),
(14179, 'Marvels Crossroads', 38.9275016784668, 0.679413073864865, -75.5175018310547, -1.31802904983275, 218, 10, 'PPL', 'P'),
(56115, 'Marvin', 38.416389465332, 0.670492482898508, -92.7705612182617, -1.61915174218163, 218, 29, 'PPL', 'P'),
(66654, 'Marvin', 34.9916687011719, 0.610719829602497, -80.8150024414063, -1.41048787760979, 218, 33, 'PPL', 'P'),
(88850, 'Marvin', 36.2480583190918, 0.632647965123073, -82.998893737793, -1.44860397123739, 218, 50, 'PPL', 'P'),
(96034, 'Marvin', 30.9144401550293, 0.539558767116007, -96.7027816772461, -1.68778193610519, 218, 51, 'PPL', 'P'),
(104031, 'Marvin', 37.1822204589844, 0.648952170211675, -81.9463882446289, -1.43023428498635, 218, 53, 'PPL', 'P'),
(150596, 'Marvin', 42.0313911437988, 0.733586164652875, -79.7347183227539, -1.39163336288231, 218, 40, 'PPL', 'P'),
(170833, 'Marvin', 45.2613906860352, 0.789960291502809, -96.9122161865234, -1.69143725785938, 218, 49, 'PPL', 'P'),
(104032, 'Marvin Garden Subdivision', 37.1427803039551, 0.648263809648916, -80.3180618286133, -1.40181462772968, 218, 53, 'PPL', 'P'),
(209589, 'Marvin Place (historical)', 42.2211112976074, 0.736897405994225, -107.191390991211, -1.87084270258922, 218, 59, 'PPL', 'P'),
(17039, 'Marvina', 27.875560760498, 0.486520316110425, -82.2255630493164, -1.43510680451676, 218, 12, 'PPL', 'P'),
(164285, 'Marvindale', 41.7294387817383, 0.728316101750744, -78.541389465332, -1.37080584526123, 218, 45, 'PPL', 'P'),
(60787, 'Marvins Chapel', 33.1083297729492, 0.577849364374031, -89.5444412231445, -1.56284532620241, 218, 30, 'PPL', 'P'),
(10341, 'Marvinville', 35.1180610656738, 0.612925792512437, -93.5500030517578, -1.63275556850392, 218, 4, 'PPL', 'P'),
(4025, 'Marvyn', 32.4388885498047, 0.56616541088158, -85.3641662597656, -1.48988576445276, 218, 2, 'PPL', 'P'),
(49278, 'Marwood', 39.1463890075684, 0.683233378448583, -76.5908279418945, -1.33676212441453, 218, 25, 'PPL', 'P'),
(164286, 'Marwood', 40.7788887023926, 0.711725873161069, -79.7733306884766, -1.39230727579615, 218, 45, 'PPL', 'P'),
(175202, 'Marxville', 43.1911087036133, 0.753827054464831, -89.6597213745117, -1.56485734440597, 218, 57, 'PPL', 'P'),
(4026, 'Mary', 32.7555618286133, 0.571692402249876, -85.688606262207, -1.49554831072054, 218, 2, 'PPL', 'P'),
(82275, 'Mary', 33.8733291625977, 0.591201122499143, -79.1052780151367, -1.38064755706962, 218, 48, 'PPL', 'P'),
(112347, 'Mary', 37.6683311462402, 0.657436402233422, -83.5363922119141, -1.45798508933525, 218, 21, 'PPL', 'P'),
(546, 'Mary Alice', 36.7841682434082, 0.642004848455012, -83.3300018310547, -1.45438289764481, 218, 21, 'PPL', 'P'),
(88851, 'Mary Chapel', 36.3019409179688, 0.633588393883007, -83.357780456543, -1.45486772612126, 218, 50, 'PPL', 'P'),
(49279, 'Mary E White Estate', 38.7563896179199, 0.67642660501845, -76.6569366455078, -1.33791593895681, 218, 25, 'PPL', 'P'),
(73381, 'Mary Ellen', 39.3661117553711, 0.68706826383927, -84.2183303833008, -1.46988715572098, 218, 41, 'PPL', 'P'),
(193766, 'Mary Ellen Place', 40.1199989318848, 0.700226077257997, -122.63111114502, -2.1403166548597, 218, 6, 'PPL', 'P'),
(17042, 'Mary Esther', 30.4097194671631, 0.530749729309811, -86.6630630493164, -1.51255579007401, 218, 12, 'PPL', 'P'),
(37078, 'Mary Helen', 36.8127784729004, 0.642504191159402, -83.254997253418, -1.45307382081098, 218, 21, 'PPL', 'P'),
(177320, 'Mary Hill', 42.7355613708496, 0.745876253609427, -95.6883316040039, -1.67007644223001, 218, 16, 'PPL', 'P'),
(96035, 'Mary K Acres Colonia', 26.2590007781982, 0.458306021863313, -98.3889999389648, -1.71721199667944, 218, 51, 'PPL', 'P'),
(192968, 'Mary Lou Park Colonia', 31.6509990692139, 0.552414145303443, -106.263000488281, -1.85463923156885, 218, 51, 'PPL', 'P'),
(120534, 'Mary Meadows', 41.9383316040039, 0.731961969283063, -88.4466705322266, -1.543685613214, 218, 18, 'PPL', 'P'),
(56116, 'Mary Ridge', 38.7208290100098, 0.675805955326407, -90.3736114501953, -1.57731707672396, 218, 29, 'PPL', 'P'),
(10342, 'Mary Spur', 34.2666702270508, 0.598066219157149, -90.9155578613281, -1.58677582596759, 218, 4, 'PPL', 'P'),
(110313, 'Marybill', 38.2686080932617, 0.667913211382766, -80.682502746582, -1.40817532167722, 218, 58, 'PPL', 'P'),
(113200, 'Marycrest', 41.3363914489746, 0.721456131677837, -74.2094421386719, -1.29519910138805, 218, 40, 'PPL', 'P'),
(164287, 'Maryd', 40.7599983215332, 0.711396173818117, -76.0563888549805, -1.32743440269653, 218, 45, 'PPL', 'P'),
(14182, 'Marydale', 39.6624984741211, 0.69224118794064, -75.6986083984375, -1.32118995573057, 218, 10, 'PPL', 'P'),
(27819, 'Marydale', 38.6974983215332, 0.675398757995734, -89.371940612793, -1.55983462259008, 218, 18, 'PPL', 'P'),
(37081, 'Marydale', 39.0261116027832, 0.681134141719328, -84.6216735839844, -1.47692682258844, 218, 21, 'PPL', 'P'),
(14180, 'Marydel', 39.1122207641602, 0.682637030101487, -75.7447204589844, -1.32199476301199, 218, 10, 'PPL', 'P'),
(33209, 'Marydel', 38.9444389343262, 0.679708684745863, -97.7222213745117, -1.70557451534801, 218, 20, 'PPL', 'P'),
(49280, 'Marydel', 39.1127815246582, 0.682646817218493, -75.7461090087891, -1.32201899777791, 218, 25, 'PPL', 'P'),
(37079, 'Marydell', 37.1091690063477, 0.647677181839799, -83.9088897705078, -1.46448639818835, 218, 21, 'PPL', 'P'),
(49281, 'Marydell', 39.292781829834, 0.685788415198405, -76.8327789306641, -1.34098496579702, 218, 25, 'PPL', 'P'),
(60789, 'Marydell', 32.8852806091309, 0.57395642207158, -89.3836135864258, -1.56003835441347, 218, 30, 'PPL', 'P'),
(82276, 'Marydell (historical)', 35.0536117553711, 0.611800939847015, -82.4274978637695, -1.43863123190337, 218, 48, 'PPL', 'P'),
(104033, 'Marye', 38.0800018310547, 0.664621411117374, -77.5841674804688, -1.35409916995289, 218, 53, 'PPL', 'P'),
(104034, 'Maryes Heights', 38.2988891601563, 0.668441715701092, -77.476936340332, -1.35222763349684, 218, 53, 'PPL', 'P'),
(96036, 'Maryetta', 33.2983283996582, 0.58116546598437, -98.0747222900391, -1.71172681694025, 218, 51, 'PPL', 'P'),
(208041, 'Maryhill', 45.6872215270996, 0.79739244173592, -120.8125, -2.10857590256565, 218, 56, 'PPL', 'P'),
(37080, 'Maryhill Estates', 38.2666702270508, 0.667879389236922, -85.6502838134766, -1.49487945781277, 218, 21, 'PPL', 'P'),
(56117, 'Maryknoll', 38.9352798461914, 0.679548828501431, -90.7780609130859, -1.58437605150932, 218, 29, 'PPL', 'P'),
(42002, 'Maryland', 31.9225006103516, 0.557152741120534, -91.3686065673828, -1.59468301756014, 218, 22, 'PPL', 'P'),
(49291, 'Maryland', 39.0002784729004, 0.680683268546778, -76.7502822875977, -1.33954512775366, 218, 25, 'ADM1', 'A'),
(120535, 'Maryland', 42.065559387207, 0.734182512999971, -89.5472183227539, -1.56289379573425, 218, 18, 'PPL', 'P'),
(145710, 'Maryland', 40.1527786254883, 0.700798190839174, -74.378059387207, -1.29814202755064, 218, 37, 'PPL', 'P'),
(150597, 'Maryland', 42.5363883972168, 0.742400029438547, -74.8869400024414, -1.30702366978605, 218, 40, 'PPL', 'P'),
(49282, 'Maryland Beach', 39.1474990844727, 0.683252752945514, -76.4608306884766, -1.33449324432384, 218, 25, 'PPL', 'P'),
(49283, 'Maryland City', 39.0919418334961, 0.682283095992616, -76.8180618286133, -1.34072810390988, 218, 25, 'PPL', 'P'),
(49284, 'Maryland Gardens', 38.4769401550293, 0.671549291798079, -76.5094375610352, -1.33534159428908, 218, 25, 'PPL', 'P'),
(42003, 'Maryland Heights', 30.5513896942139, 0.533222341223896, -91.1716690063477, -1.59124580869923, 218, 22, 'PPL', 'P'),
(56118, 'Maryland Heights', 38.7130584716797, 0.675670333847895, -90.4297180175781, -1.57829632105678, 218, 29, 'PPL', 'P'),
(110314, 'Maryland Junction', 39.6324996948242, 0.69171761047033, -78.7847213745117, -1.37505278825158, 218, 58, 'PPL', 'P'),
(49285, 'Maryland Line', 39.714168548584, 0.693143000864768, -76.654167175293, -1.33786760258302, 218, 25, 'PPL', 'P'),
(49286, 'Maryland Manor', 38.2933311462402, 0.668344710058386, -76.5027770996094, -1.3352253473075, 218, 25, 'PPL', 'P'),
(49287, 'Maryland Manor Trailer Park', 38.8583297729492, 0.678205796363704, -76.6833267211914, -1.33837653266734, 218, 25, 'PPL', 'P'),
(49288, 'Maryland Park', 38.8883285522461, 0.678729373834014, -76.9072189331055, -1.34228418893481, 218, 25, 'PPL', 'P'),
(27820, 'Maryland Place', 38.7316703796387, 0.675995172921857, -90.1100006103516, -1.57271619962473, 218, 18, 'PPL', 'P'),
(49289, 'Maryland Point', 38.3974990844727, 0.670162783555556, -77.2052764892578, -1.34748627465012, 218, 25, 'PPL', 'P'),
(49290, 'Maryland Ponderosa', 39.5155601501465, 0.689676630389921, -76.3547210693359, -1.3326412821018, 218, 25, 'PPL', 'P'),
(178599, 'Maryland West Mobile Home Park', 33.5294418334961, 0.585199156350431, -112.182777404785, -1.9579588297454, 218, 5, 'PPL', 'P'),
(4027, 'Marylee', 33.9791717529297, 0.593048424189276, -87.1916732788086, -1.52178177903837, 218, 2, 'PPL', 'P'),
(201192, 'Marylhurst', 45.4013900756836, 0.792403741802956, -122.650001525879, -2.14064635420266, 218, 43, 'PPL', 'P'),
(49295, 'Marymount', 39.0219383239746, 0.681061304263515, -77.1277770996094, -1.34613365513247, 218, 25, 'PPL', 'P'),
(191835, 'Maryneal', 32.235279083252, 0.562611755302006, -100.449996948242, -1.75318318036508, 218, 51, 'PPL', 'P'),
(66657, 'Marys Beach', 36.1616706848145, 0.631140216471925, -76.7544403076172, -1.33961769889337, 218, 33, 'PPL', 'P'),
(49292, 'Marys Choice', 39.3352813720703, 0.68653017214102, -76.4438934326172, -1.33419763344284, 218, 25, 'PPL', 'P'),
(208042, 'Marys Corner', 46.5472183227539, 0.812402217376688, -122.821388244629, -2.14363761673903, 218, 56, 'PPL', 'P'),
(66660, 'Marys Grove', 35.3405609130859, 0.616809147434963, -81.3833312988281, -1.4204070874059, 218, 33, 'PPL', 'P'),
(88852, 'Marys Grove', 35.0555610656738, 0.61183496172994, -86.6458282470703, -1.51225498602888, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(56119, 'Marys Home', 38.3055610656738, 0.668558162419756, -92.3550033569336, -1.61189888926891, 218, 29, 'PPL', 'P'),
(211981, 'Marys Igloo', 65.1500015258789, 1.13708203430592, -165.066665649414, -2.8809568008709, 218, 1, 'PPL', 'P'),
(136758, 'Marysburg', 44.2402801513672, 0.772138550646053, -93.8166732788086, -1.63740984198299, 218, 28, 'PPL', 'P'),
(96040, 'Marystown', 32.4597206115723, 0.566528998949403, -97.3197174072266, -1.69854949586654, 218, 51, 'PPL', 'P'),
(136760, 'Marystown', 44.7208290100098, 0.780525710446067, -93.5411071777344, -1.63260030621237, 218, 28, 'PPL', 'P'),
(192690, 'Marysvale', 38.4494400024414, 0.671069323590619, -112.229438781738, -1.95877322440675, 218, 52, 'PPL', 'P'),
(10343, 'Marysville', 33.2272186279297, 0.579924366337366, -92.9572219848633, -1.62240958714312, 218, 4, 'PPL', 'P'),
(17045, 'Marysville', 30.2944393157959, 0.528737711106257, -85.0983276367188, -1.48524600520163, 218, 12, 'PPL', 'P'),
(30455, 'Marysville', 38.3519401550293, 0.669367630233086, -87.2783279418945, -1.52329418822143, 218, 19, 'PPL', 'P'),
(33210, 'Marysville', 39.8411102294922, 0.695358551154632, -96.6469421386719, -1.68680735230427, 218, 20, 'PPL', 'P'),
(82277, 'Marysville', 33.4275016784668, 0.583419965005176, -79.1513900756836, -1.38145236435104, 218, 48, 'PPL', 'P'),
(96037, 'Marysville', 33.7705612182617, 0.589407483504974, -97.3338928222656, -1.69879690353181, 218, 51, 'PPL', 'P'),
(104035, 'Marysville', 37.1088905334473, 0.64767232157081, -79.1224975585938, -1.38094809479864, 218, 53, 'PPL', 'P'),
(116760, 'Marysville', 41.1805610656738, 0.718736378414593, -92.9488906860352, -1.6222641785476, 218, 16, 'PPL', 'P'),
(131969, 'Marysville', 42.9124984741211, 0.748964388630456, -82.4869384765625, -1.43966866630601, 218, 27, 'PPL', 'P'),
(150599, 'Marysville', 42.9838905334473, 0.750210415125477, -76.4494400024414, -1.33429443934846, 218, 40, 'PPL', 'P'),
(156365, 'Marysville', 40.2363891601563, 0.702257469958483, -83.3672180175781, -1.45503244263468, 218, 41, 'PPL', 'P'),
(164291, 'Marysville', 40.3424987792969, 0.704109432180524, -76.9302825927734, -1.34268672573358, 218, 45, 'PPL', 'P'),
(183134, 'Marysville', 39.1458282470703, 0.683223591331577, -121.590278625488, -2.12215070043206, 218, 6, 'PPL', 'P'),
(195293, 'Marysville', 44.0713882446289, 0.769190830793499, -111.419441223145, -1.94463610007617, 218, 17, 'PPL', 'P'),
(196990, 'Marysville', 46.750560760498, 0.815951212424355, -112.299438476563, -1.95999494955682, 218, 31, 'PPL', 'P'),
(208043, 'Marysville', 48.0519409179688, 0.838664580992341, -122.175827026367, -2.13237044795718, 218, 56, 'PPL', 'P'),
(116761, 'Marysville (historical)', 41.2880592346191, 0.720612575402554, -92.2286071777344, -1.60969285977994, 218, 16, 'PPL', 'P'),
(142367, 'Marysville (historical)', 40.9666709899902, 0.715003292356575, -97.2083282470703, -1.69660538827078, 218, 35, 'PPL', 'P'),
(104036, 'Maryton', 38.2377815246582, 0.667375186263543, -77.3377838134766, -1.34979896374074, 218, 53, 'PPL', 'P'),
(110315, 'Marytown', 37.4697189331055, 0.653969965179547, -81.6797180175781, -1.42558001150727, 218, 58, 'PPL', 'P'),
(175203, 'Marytown', 43.9136085510254, 0.766437055647329, -88.2022171020508, -1.53941909598964, 218, 57, 'PPL', 'P'),
(104037, 'Maryus', 37.2794418334961, 0.650649003300219, -76.4030609130859, -1.33348497153513, 218, 53, 'PPL', 'P'),
(49293, 'Maryvale', 38.7975006103516, 0.677144127195144, -76.8083267211914, -1.34055819423233, 218, 25, 'PPL', 'P'),
(178600, 'Maryvale', 33.5019416809082, 0.584719188142972, -112.176940917969, -1.9578569638337, 218, 5, 'PPL', 'P'),
(187033, 'Maryvale', 39.9330596923828, 0.696963372027514, -105.786666870117, -1.84632564159395, 218, 7, 'PPL', 'P'),
(178601, 'Maryvale Terrace', 33.4927787780762, 0.584559265319512, -112.194442749023, -1.95816242841074, 218, 5, 'PPL', 'P'),
(4028, 'Maryville', 34.0961112976074, 0.595089404269686, -86.0905609130859, -1.50256374282209, 218, 2, 'PPL', 'P'),
(27821, 'Maryville', 38.7236099243164, 0.675854491437274, -89.9558334350586, -1.57002547481737, 218, 18, 'PPL', 'P'),
(82280, 'Maryville', 34.916389465332, 0.609405959078706, -81.7569427490234, -1.42692783733496, 218, 48, 'PPL', 'P'),
(88853, 'Maryville', 35.7563896179199, 0.62406672745862, -83.9705581665039, -1.46556271474291, 218, 50, 'PPL', 'P'),
(116762, 'Maryville', 42.6877784729004, 0.745042284714069, -91.6452789306641, -1.59951186124868, 218, 16, 'PPL', 'P'),
(139310, 'Maryville', 40.3461112976074, 0.704172482519331, -94.8722229003906, -1.65583265829778, 218, 29, 'PPL', 'P'),
(49294, 'Marywood', 39.5472183227539, 0.690229169737085, -76.3741683959961, -1.33298070198273, 218, 25, 'PPL', 'P'),
(120537, 'Marywood', 41.7936096191406, 0.729436094147177, -88.290283203125, -1.54095613941278, 218, 18, 'PPL', 'P'),
(82281, 'Mas Old Field Landing', 33.0541687011719, 0.576904075345107, -80.4497222900391, -1.40411253627625, 218, 48, 'PPL', 'P'),
(104038, 'Masada', 36.6911087036133, 0.6403806530852, -81.7180633544922, -1.42624926388921, 218, 53, 'PPL', 'P'),
(128085, 'Masardis', 46.5036087036133, 0.811641085937144, -68.3616714477539, -1.1931362489299, 218, 26, 'PPL', 'P'),
(17046, 'Masaryktown', 28.4413890838623, 0.496395883354171, -82.4572219848633, -1.43915001568372, 218, 12, 'PPL', 'P'),
(144122, 'Mascoma', 43.6511116027832, 0.761855619624066, -72.1827774047852, -1.25982712894767, 218, 36, 'PPL', 'P'),
(183135, 'Mascorini Place', 36.3561096191406, 0.634533816069986, -121.52278137207, -2.12097265112386, 218, 6, 'PPL', 'P'),
(56120, 'Mascot', 37.2627792358398, 0.650358186109182, -93.2966690063477, -1.62833405530411, 218, 29, 'PPL', 'P'),
(82282, 'Mascot', 35.0702781677246, 0.612091823617079, -82.1294403076172, -1.43342914618806, 218, 48, 'PPL', 'P'),
(88854, 'Mascot', 36.0611114501953, 0.629385126734535, -83.7458267211914, -1.46164041108944, 218, 50, 'PPL', 'P'),
(104039, 'Mascot', 37.6269416809082, 0.656714019787738, -76.7074966430664, -1.33879837738401, 218, 53, 'PPL', 'P'),
(142368, 'Mascot', 40.2644386291504, 0.702747025545866, -99.5458297729492, -1.73740248616776, 218, 35, 'PPL', 'P'),
(164293, 'Mascot', 40.0616683959961, 0.699208017352287, -76.1547164916992, -1.32915054370298, 218, 45, 'PPL', 'P'),
(60790, 'Mascot (historical)', 34.4541702270508, 0.601338711504638, -90.4944381713867, -1.57942590083313, 218, 30, 'PPL', 'P'),
(164294, 'Mascot (historical)', 40.8505592346191, 0.712976759925079, -78.4013900756836, -1.36836239496109, 218, 45, 'PPL', 'P'),
(17047, 'Mascotte', 28.5780601501465, 0.498781243453041, -81.8869400024414, -1.42919671742566, 218, 12, 'PPL', 'P'),
(27822, 'Mascoutah', 38.4902801513672, 0.671782118656379, -89.7930603027344, -1.56718454772453, 218, 18, 'PPL', 'P'),
(4029, 'Masena', 33.1616706848145, 0.578780338912095, -87.0436096191406, -1.51919758067461, 218, 2, 'PPL', 'P'),
(66659, 'Masequetuc (historical)', 36.1666717529297, 0.631227501576652, -76.0833282470703, -1.32790458378698, 218, 33, 'PPL', 'P'),
(76524, 'Masham', 36.4491691589355, 0.636158011439798, -96.8533325195313, -1.69040954399472, 218, 42, 'PPL', 'P'),
(113684, 'Mashapaug', 42.0272216796875, 0.733513393776089, -72.1386108398438, -1.25905627697015, 218, 8, 'PPL', 'P'),
(88855, 'Mashburn', 35.4361114501953, 0.618476818909571, -84.5299987792969, -1.47532679540552, 218, 50, 'PPL', 'P'),
(195294, 'Mashburn', 47.1791687011719, 0.823431832189306, -116.495002746582, -2.03322136004769, 218, 17, 'PPL', 'P'),
(22910, 'Mashburn Mill', 34.8905601501465, 0.608955152485183, -84.1355590820313, -1.46844252398766, 218, 13, 'PPL', 'P'),
(131971, 'Mashek', 46.047779083252, 0.803685358233723, -87.4713897705078, -1.52666375279065, 218, 27, 'PPL', 'P'),
(56121, 'Mashek (historical)', 39.0041694641113, 0.680751179154575, -91.0758285522461, -1.58957307721855, 218, 29, 'PPL', 'P'),
(37084, 'Mashfork', 37.7613906860352, 0.659060597603234, -83.0055618286133, -1.44872035137703, 218, 21, 'PPL', 'P'),
(66661, 'Mashoes', 35.9561080932617, 0.627552472430397, -75.8033294677734, -1.32301768318669, 218, 33, 'PPL', 'P'),
(125350, 'Mashpee', 41.6483306884766, 0.726900498473313, -70.4816665649414, -1.23013714385103, 218, 23, 'PPL', 'P'),
(125351, 'Mashpee Neck', 41.6100006103516, 0.726231512407485, -70.4652786254883, -1.22985112034995, 218, 23, 'PPL', 'P'),
(60791, 'Mashulaville', 33.086669921875, 0.577471328657294, -88.7441711425781, -1.54887797839133, 218, 30, 'PPL', 'P'),
(4030, 'Mashville', 31.8030605316162, 0.555068118487761, -86.5411071777344, -1.51042725857276, 218, 2, 'PPL', 'P'),
(4031, 'Masingale (historical)', 33.9666709899902, 0.592830244716972, -85.9722213745117, -1.50049832823867, 218, 2, 'PPL', 'P'),
(142369, 'Maskell', 42.689998626709, 0.745081033707929, -96.9822235107422, -1.69265911616751, 218, 35, 'PPL', 'P'),
(71091, 'Maskells Mill', 39.4863891601563, 0.689167500568525, -75.4013900756836, -1.31600251740126, 218, 37, 'PPL', 'P'),
(17048, 'Mason', 30.0397205352783, 0.52429202971956, -82.5980606079102, -1.44160811336986, 218, 12, 'PPL', 'P'),
(22911, 'Mason', 33.2658309936523, 0.58059827925121, -85.2611083984375, -1.48808706545252, 218, 13, 'PPL', 'P'),
(27825, 'Mason', 38.9530601501465, 0.679859153347453, -88.6236114501953, -1.54677381481405, 218, 18, 'PPL', 'P'),
(37083, 'Mason', 37.7205581665039, 0.658347935695529, -83.0500030517578, -1.44949599704451, 218, 21, 'PPL', 'P'),
(42004, 'Mason', 32.0694389343262, 0.559717298671253, -91.8869400024414, -1.60372964262509, 218, 22, 'PPL', 'P'),
(73384, 'Mason', 39.3600006103516, 0.686961604237612, -84.3099975585938, -1.47148704974584, 218, 41, 'PPL', 'P'),
(76525, 'Mason', 35.5661087036133, 0.620745699000264, -96.351936340332, -1.68165852981077, 218, 42, 'PPL', 'P'),
(88856, 'Mason', 35.4116706848145, 0.618050247081967, -89.5327835083008, -1.56264186069513, 218, 50, 'PPL', 'P'),
(96039, 'Mason', 31.2455596923828, 0.545337893260507, -93.7686080932617, -1.63657094623962, 218, 51, 'PPL', 'P'),
(104040, 'Mason', 36.7594413757324, 0.641573283200365, -77.3855590820313, -1.35063279947805, 218, 53, 'PPL', 'P'),
(110316, 'Mason', 39.021671295166, 0.681056643731607, -82.029167175293, -1.43167904987772, 218, 58, 'PPL', 'P'),
(131974, 'Mason', 47.1411094665527, 0.822767573234413, -88.4655609130859, -1.54401531255695, 218, 27, 'PPL', 'P'),
(140465, 'Mason', 47.0736083984375, 0.821589457347189, -97.32861328125, -1.69870475815809, 218, 34, 'PPL', 'P'),
(144124, 'Mason', 42.7436103820801, 0.746016735356929, -71.7694396972656, -1.25261302502881, 218, 36, 'PPL', 'P'),
(164295, 'Mason', 41.4736099243164, 0.723851045867118, -79.8472213745117, -1.39359691155402, 218, 45, 'PPL', 'P'),
(175204, 'Mason', 46.4352798461914, 0.810448522401006, -91.0597229003906, -1.5892919805655, 218, 57, 'PPL', 'P'),
(190459, 'Mason', 38.9500007629395, 0.679805756967597, -119.189170837402, -2.08024346383468, 218, 39, 'PPL', 'P'),
(10344, 'Mason (historical)', 33.7786102294922, 0.589547965252476, -92.1991729736328, -1.60917913600566, 218, 4, 'PPL', 'P'),
(42005, 'Mason (historical)', 30.5444393157959, 0.533101034236242, -90.4952774047852, -1.57944054821913, 218, 22, 'PPL', 'P'),
(78700, 'Mason and Dixon', 39.7213897705078, 0.693269034963356, -77.7544403076172, -1.35707099141331, 218, 45, 'PPL', 'P'),
(4032, 'Mason City', 33.4680595397949, 0.58412783322292, -86.8497161865234, -1.51581350187745, 218, 2, 'PPL', 'P'),
(116763, 'Mason City', 43.1536102294922, 0.753172582626944, -93.2008285522461, -1.62666132382343, 218, 16, 'PPL', 'P'),
(120538, 'Mason City', 40.202220916748, 0.701661121611387, -89.6980590820313, -1.56552646362985, 218, 18, 'PPL', 'P'),
(142370, 'Mason City', 41.2230606079102, 0.719478135357207, -99.3000030517578, -1.73311200049359, 218, 35, 'PPL', 'P'),
(208044, 'Mason City', 47.9666709899902, 0.837176339996178, -118.966667175293, -2.07636004233312, 218, 56, 'PPL', 'P'),
(208045, 'Mason City (historical)', 47.9513893127441, 0.836909624413006, -118.966667175293, -2.07636004233312, 218, 56, 'PPL', 'P'),
(116765, 'Mason City Junction', 43.1186103820801, 0.752561720051908, -93.1888885498047, -1.62645293146814, 218, 16, 'PPL', 'P'),
(194311, 'Mason Corner', 40.4669418334961, 0.706281373207538, -104.701393127441, -1.82738404149882, 218, 7, 'PPL', 'P'),
(104041, 'Mason Cove', 37.3708305358887, 0.652244037056094, -80.067497253418, -1.39744145090366, 218, 53, 'PPL', 'P'),
(96042, 'Mason Crossing', 31.2052803039551, 0.544634885311753, -97.7152786254883, -1.70545334151841, 218, 51, 'PPL', 'P'),
(49296, 'Mason Dixon Estates', 39.7191696166992, 0.693230285969495, -76.8033294677734, -1.34047097570663, 218, 25, 'PPL', 'P'),
(49297, 'Mason Dixon Village', 39.7200012207031, 0.693244800197436, -76.0666732788086, -1.327613899754, 218, 25, 'PPL', 'P'),
(82290, 'Mason Estates', 35.0533294677734, 0.611796012998998, -81.960563659668, -1.43048169265162, 218, 48, 'PPL', 'P'),
(88857, 'Mason Grove', 35.7644386291504, 0.624207209206122, -88.9580612182617, -1.55261106444934, 218, 50, 'PPL', 'P'),
(88858, 'Mason Hall', 36.2066688537598, 0.631925582677389, -89.0936126708984, -1.55497688360372, 218, 50, 'PPL', 'P'),
(96043, 'Mason Lake Estates', 30.3875007629395, 0.530361939765582, -94.8041687011719, -1.65464488845161, 218, 51, 'PPL', 'P'),
(49298, 'Mason Landing', 38.2372207641602, 0.667365399146537, -75.2577819824219, -1.31349608334133, 218, 25, 'PPL', 'P'),
(60792, 'Mason Landing', 34.0219383239746, 0.593794841663798, -90.8958282470703, -1.58643147923864, 218, 30, 'PPL', 'P'),
(88859, 'Mason Springs', 36.4891700744629, 0.636856159119562, -83.5391693115234, -1.45803355886709, 218, 50, 'PPL', 'P'),
(10345, 'Mason Valley', 36.2991714477539, 0.633540057509222, -94.3405609130859, -1.64655340611162, 218, 4, 'PPL', 'P'),
(22913, 'Mason Woods', 33.8027801513672, 0.589969809969145, -84.0486068725586, -1.46692492164048, 218, 13, 'PPL', 'P'),
(66662, 'Masonboro', 34.1791687011719, 0.596539029430043, -77.8477783203125, -1.35870004705211, 218, 33, 'PPL', 'P'),
(195295, 'Masonia (historical)', 47.4516716003418, 0.828187905001051, -116.179718017578, -2.02771860344532, 218, 17, 'PPL', 'P'),
(145711, 'Masonicus', 41.0827789306641, 0.717029758209043, -74.1266708374023, -1.29375446965473, 218, 37, 'PPL', 'P'),
(14181, 'Masonicville', 39.7208290100098, 0.69325924784635, -75.6138916015625, -1.31971136869335, 218, 10, 'PPL', 'P'),
(49299, 'Masons', 38.5591697692871, 0.672984469309522, -76.8005599975586, -1.34042263933285, 218, 25, 'PPL', 'P'),
(144126, 'Masons', 44.6861114501953, 0.779919774719046, -71.5891723632813, -1.24946676651699, 218, 36, 'PPL', 'P'),
(49300, 'Masons Beach', 38.7722206115723, 0.676702907981546, -76.5491714477539, -1.33603508143694, 218, 25, 'PPL', 'P'),
(104043, 'Masons Corner', 37.4327812194824, 0.653325280458666, -77.8930587768555, -1.3594903401056, 218, 53, 'PPL', 'P'),
(125353, 'Masons Corner', 41.7666702270508, 0.728965913056724, -70.9430618286133, -1.23819001035521, 218, 23, 'PPL', 'P'),
(82283, 'Masons Cross Road', 34.5572204589844, 0.603137277346823, -82.7752838134766, -1.44470124181793, 218, 48, 'PPL', 'P'),
(66664, 'Masons Crossroads', 34.7344398498535, 0.606230339215869, -79.5616683959961, -1.38861307189005, 218, 33, 'PPL', 'P'),
(188984, 'Masons Mill (historical)', 32.9402809143066, 0.574916358486499, -108.190002441406, -1.88827176034324, 218, 38, 'PPL', 'P'),
(104044, 'Masons Store (historical)', 36.8033294677734, 0.642339274908899, -82.2874984741211, -1.43618778160322, 218, 53, 'PPL', 'P'),
(66666, 'Masontown', 34.8694381713867, 0.608586504411289, -76.4158325195313, -1.33370787811837, 218, 33, 'PPL', 'P'),
(78701, 'Masontown', 39.8466682434082, 0.695455556797338, -79.9000015258789, -1.39451809897508, 218, 45, 'PPL', 'P'),
(110318, 'Masontown', 39.5522193908691, 0.690316454841813, -79.7980575561523, -1.3927388410508, 218, 58, 'PPL', 'P'),
(187034, 'Masontown', 39.5663909912109, 0.690563795928054, -106.099716186523, -1.85178938288636, 218, 7, 'PPL', 'P'),
(10349, 'Masonville', 33.5847206115723, 0.58616395303434, -91.4049987792969, -1.59531818148013, 218, 4, 'PPL', 'P'),
(37087, 'Masonville', 37.6749992370605, 0.657552782373058, -87.0347213745117, -1.51904245154111, 218, 21, 'PPL', 'P'),
(49301, 'Masonville', 39.2430610656738, 0.684920624157203, -76.5908279418945, -1.33676212441453, 218, 25, 'PPL', 'P'),
(71093, 'Masonville', 39.978328704834, 0.697753465343913, -74.8705596923828, -1.30673777944303, 218, 37, 'PPL', 'P'),
(104045, 'Masonville', 38.8461112976074, 0.677992543739416, -77.2030563354492, -1.34744752565626, 218, 53, 'PPL', 'P'),
(110319, 'Masonville', 38.9186096191406, 0.67925787815234, -79.0838928222656, -1.38027431504285, 218, 58, 'PPL', 'P'),
(116767, 'Masonville', 42.4794387817383, 0.741406071140702, -91.5911102294922, -1.5985664390617, 218, 16, 'PPL', 'P'),
(131978, 'Masonville', 45.9127807617188, 0.801329193038302, -86.9872207641602, -1.51821340949377, 218, 27, 'PPL', 'P'),
(150600, 'Masonville', 42.2419395446777, 0.737260927483021, -75.3777770996094, -1.31559039322257, 218, 40, 'PPL', 'P'),
(194312, 'Masonville', 40.4874992370605, 0.706640167585399, -105.21028137207, -1.83626581689228, 218, 7, 'PPL', 'P'),
(4033, 'Masonville (historical)', 34.8633308410645, 0.608479911388659, -87.5299987792969, -1.52768667296535, 218, 2, 'PPL', 'P'),
(49302, 'Masonville (historical)', 39.2402801513672, 0.684872088046336, -76.5947189331055, -1.33683003502233, 218, 25, 'PPL', 'P'),
(150601, 'Maspeth', 40.7230606079102, 0.710751489097236, -73.9130630493164, -1.29002631044473, 218, 40, 'PPL', 'P'),
(131980, 'Mass City', 46.7638893127441, 0.816183839545574, -89.0861129760742, -1.55484598923614, 218, 27, 'PPL', 'P'),
(96044, 'Massa', 31.271390914917, 0.545788733143543, -94.1283264160156, -1.64284921535143, 218, 51, 'PPL', 'P'),
(144127, 'Massabesic', 43.0036087036133, 0.750554562117342, -71.3930587768555, -1.24604393872596, 218, 36, 'PPL', 'P'),
(37088, 'Massac', 37.0166702270508, 0.646062773586993, -88.7305603027344, -1.54864042442209, 218, 21, 'PPL', 'P'),
(27827, 'Massac City', 37.1436080932617, 0.64827825729783, -88.7186126708984, -1.54843189890874, 218, 18, 'PPL', 'P'),
(13154, 'Massachusetts Avenue Heights', 38.9263916015625, 0.679393699367934, -77.0652770996094, -1.34504282434997, 218, 9, 'PPL', 'P'),
(183136, 'Massack', 39.9261093139648, 0.696842065039861, -120.836669921875, -2.10899774728232, 218, 6, 'PPL', 'P'),
(30456, 'Massacre', 39.1558303833008, 0.683398161541032, -87.4075012207031, -1.52554868724223, 218, 19, 'PPL', 'P'),
(194313, 'Massadona', 40.2527809143066, 0.702543560038584, -108.639717102051, -1.89612076186598, 218, 7, 'PPL', 'P'),
(104046, 'Massanetta Springs', 38.4002799987793, 0.670211319666423, -78.8344421386719, -1.37592057929278, 218, 53, 'PPL', 'P'),
(104047, 'Massanova', 38.6699981689453, 0.674918789788274, -78.0774993896484, -1.36270943607323, 218, 53, 'PPL', 'P'),
(104048, 'Massanutten', 38.4094390869141, 0.670371175910855, -78.7380599975586, -1.37423839359024, 218, 53, 'PPL', 'P'),
(113685, 'Massapeag', 41.4577789306641, 0.723574742904022, -72.0813903808594, -1.25805759156137, 218, 8, 'PPL', 'P'),
(150602, 'Massapequa', 40.6805610656738, 0.710009732154621, -73.4747161865234, -1.28237571442321, 218, 40, 'PPL', 'P'),
(150604, 'Massapequa Park', 40.6802787780762, 0.710004805306605, -73.4555587768555, -1.28204135454835, 218, 40, 'PPL', 'P'),
(104050, 'Massaponax', 38.2397193908691, 0.667409008409387, -77.436393737793, -1.35152003159521, 218, 53, 'PPL', 'P'),
(10350, 'Massard', 35.348331451416, 0.616944768913475, -94.3405609130859, -1.64655340611162, 218, 4, 'PPL', 'P'),
(125355, 'Massasoit', 42.2394409179688, 0.737217318220171, -71.7827835083008, -1.25284591846613, 218, 23, 'PPL', 'P'),
(120541, 'Massbach', 42.2461090087891, 0.737333698359807, -90.1216735839844, -1.57291993144813, 218, 18, 'PPL', 'P'),
(22914, 'Massee', 31.1900005340576, 0.544368203018095, -83.3572235107422, -1.45485800558328, 218, 13, 'PPL', 'P'),
(116768, 'Massena', 41.2541694641113, 0.720021087324447, -94.7680587768555, -1.65401465137964, 218, 16, 'PPL', 'P'),
(150605, 'Massena', 44.9280586242676, 0.784142549522503, -74.892219543457, -1.30711581515977, 218, 40, 'PPL', 'P'),
(150606, 'Massena Center', 44.9599990844727, 0.784700015717684, -74.831672668457, -1.30605907283923, 218, 40, 'PPL', 'P'),
(150607, 'Massena Springs', 44.9144401550293, 0.783904862395214, -74.8877792358398, -1.30703831717205, 218, 40, 'PPL', 'P'),
(88860, 'Massengill Mill', 36.2055587768555, 0.631906208180459, -83.5561065673828, -1.45832916974809, 218, 50, 'PPL', 'P'),
(4034, 'Massey', 34.3702812194824, 0.59987457211634, -87.022216796875, -1.51882420548978, 218, 2, 'PPL', 'P'),
(49303, 'Massey', 39.3097190856934, 0.686084026079404, -75.8255615234375, -1.32340570575751, 218, 25, 'PPL', 'P'),
(116770, 'Massey', 42.4302787780762, 0.740548067216506, -90.5849990844727, -1.5810064869401, 218, 16, 'PPL', 'P'),
(22915, 'Massey Hill', 32.8600006103516, 0.573515202857981, -83.3466720581055, -1.4546738479939, 218, 13, 'PPL', 'P'),
(96045, 'Massey Lake', 31.811939239502, 0.55522308117369, -95.8680572509766, -1.67321324651996, 218, 51, 'PPL', 'P'),
(14183, 'Massey Landing', 38.6261100769043, 0.67415279807974, -75.1044387817383, -1.31081973960385, 218, 10, 'PPL', 'P'),
(76527, 'Massey Point', 35.0641708374023, 0.611985230594448, -95.6447219848633, -1.66931531079047, 218, 42, 'PPL', 'P'),
(164296, 'Masseyburg', 40.6594390869141, 0.709641084080727, -77.9274978637695, -1.36009141556363, 218, 45, 'PPL', 'P'),
(4035, 'Masseyline', 33.7916717529297, 0.589775931841787, -86.6861114501953, -1.51295806055666, 218, 2, 'PPL', 'P'),
(22916, 'Masseyville', 34.7266693115234, 0.606094717737356, -85.4633331298828, -1.49161655284521, 218, 13, 'PPL', 'P'),
(88861, 'Masseyville', 35.2936096191406, 0.615989692767546, -88.7063903808594, -1.54821857970542, 218, 50, 'PPL', 'P'),
(110320, 'Masseyville', 37.8380584716797, 0.660398702892944, -81.4516677856445, -1.4215997841001, 218, 58, 'PPL', 'P'),
(190461, 'Massie', 39.5969390869141, 0.691096960778288, -118.974998474121, -2.07650545092864, 218, 39, 'PPL', 'P'),
(73387, 'Massie (historical)', 38.913330078125, 0.679165732778623, -82.7941665649414, -1.44503080800283, 218, 41, 'PPL', 'P'),
(104051, 'Massies Corner', 38.7236099243164, 0.675854491437274, -78.1149978637695, -1.36336390791112, 218, 53, 'PPL', 'P'),
(104052, 'Massies Mill', 37.7769393920898, 0.659331973718313, -79.0013885498047, -1.37883434384144, 218, 53, 'PPL', 'P'),
(73389, 'Massieville', 39.2649993896484, 0.685303520142929, -82.9669418334961, -1.44804630530513, 218, 41, 'PPL', 'P'),
(112212, 'Massillon', 32.4377784729004, 0.56614603638465, -87.2958297729492, -1.52359965279846, 218, 2, 'PPL', 'P'),
(116771, 'Massillon', 41.9147186279297, 0.731549845104373, -90.9225006103516, -1.58689699979719, 218, 16, 'PPL', 'P'),
(156366, 'Massillon', 40.7966690063477, 0.71203619800709, -81.5216674804688, -1.42282150925017, 218, 41, 'PPL', 'P'),
(113686, 'Massomuck (historical)', 41.8974990844727, 0.731249307375358, -71.9630584716797, -1.25599231013601, 218, 8, 'PPL', 'P'),
(128087, 'Mast Landing', 43.8574981689453, 0.76545774473548, -70.0841674804688, -1.22319947605332, 218, 26, 'PPL', 'P'),
(164299, 'Masten', 41.5072212219238, 0.724437673676235, -76.8208312988281, -1.34077644028366, 218, 45, 'PPL', 'P'),
(14184, 'Mastens Corner', 38.9686088562012, 0.680130529462532, -75.6177825927734, -1.31977927930115, 218, 10, 'PPL', 'P'),
(14185, 'Mastens Heights Mobile Home Park', 38.7249984741211, 0.675878726203193, -75.1311111450195, -1.3112852601624, 218, 10, 'PPL', 'P'),
(42006, 'Masters', 29.8830604553223, 0.521557795517889, -91.690559387207, -1.60030215430216, 218, 22, 'PPL', 'P'),
(56123, 'Masters', 37.6055603027344, 0.65634084433999, -93.6613922119141, -1.63469967609968, 218, 29, 'PPL', 'P'),
(194314, 'Masters', 40.309440612793, 0.703532458330358, -104.244438171387, -1.81940867298236, 218, 7, 'PPL', 'P'),
(191837, 'Masterson', 35.6358299255371, 0.621962563881348, -101.959716796875, -1.77953276250644, 218, 51, 'PPL', 'P'),
(4037, 'Masterson Mill', 34.5386085510254, 0.602812438272861, -87.283332824707, -1.52338153990518, 218, 2, 'PPL', 'P'),
(164297, 'Mastersonville', 40.1966705322266, 0.701564249126735, -76.4875030517578, -1.33495876488238, 218, 45, 'PPL', 'P'),
(164298, 'Masthope', 41.535831451416, 0.724937016380625, -75.0286102294922, -1.30949628170014, 218, 45, 'PPL', 'P'),
(164303, 'Masthope Rapids', 41.517219543457, 0.724612177306662, -75.0219421386719, -1.3093799015605, 218, 45, 'PPL', 'P'),
(150609, 'Mastic', 40.8019409179688, 0.712128210222752, -72.8413925170898, -1.27132213116078, 218, 40, 'PPL', 'P'),
(150610, 'Mastic Beach', 40.7666702270508, 0.71151262053678, -72.8525009155273, -1.27151600928814, 218, 40, 'PPL', 'P'),
(104054, 'Mastins Corner', 38.1897201538086, 0.666536357099195, -77.7752838134766, -1.35743477921822, 218, 53, 'PPL', 'P'),
(131981, 'Mastodon', 46.0183296203613, 0.803171368143337, -88.3486099243164, -1.54197413273946, 218, 27, 'PPL', 'P'),
(188985, 'Mastodon', 31.8219394683838, 0.555397618093631, -106.695281982422, -1.86218396693704, 218, 38, 'PPL', 'P'),
(156368, 'Masury', 41.211109161377, 0.719269543264827, -80.5380630493164, -1.40565437338936, 218, 41, 'PPL', 'P'),
(96046, 'Mata Colonia', 26.19700050354, 0.457223912933386, -98.2720031738281, -1.71517001791362, 218, 51, 'PPL', 'P'),
(96047, 'Mata Colonia Number 2', 26.2210006713867, 0.457642794883342, -98.4049987792969, -1.71749122911973, 218, 51, 'PPL', 'P'),
(191838, 'Matador', 34.0119400024414, 0.593620338033371, -100.821670532227, -1.7596701081483, 218, 51, 'PPL', 'P'),
(60793, 'Matagorda', 34.3380584716797, 0.599312179073143, -90.4569396972656, -1.57877142899525, 218, 30, 'PPL', 'P'),
(96048, 'Matagorda', 28.690559387207, 0.500744725545729, -95.9672164916992, -1.67494390175435, 218, 51, 'PPL', 'P'),
(123144, 'Matamoras', 40.5541687011719, 0.707803769244682, -85.2630615234375, -1.48812115391448, 218, 19, 'PPL', 'P'),
(164301, 'Matamoras', 41.3686103820801, 0.722018458142007, -74.7005615234375, -1.30377075167258, 218, 45, 'PPL', 'P'),
(211982, 'Matanuska', 61.5419387817383, 1.07410945980212, -149.229721069336, -2.60454997449267, 218, 1, 'PPL', 'P'),
(37090, 'Matanzas', 37.4505615234375, 0.653635605304688, -87.0586090087891, -1.51945936940977, 218, 21, 'PPL', 'P'),
(120542, 'Matanzas', 40.2311096191406, 0.702165324584766, -90.0994415283203, -1.5725319088773, 218, 18, 'PPL', 'P'),
(120543, 'Matanzas Beach', 40.2430610656738, 0.702373916677146, -90.103889465332, -1.57260954002308, 218, 18, 'PPL', 'P'),
(49305, 'Matapeake', 38.9588890075684, 0.679960886101094, -76.345832824707, -1.3324861529683, 218, 25, 'PPL', 'P'),
(49306, 'Matapeake Estates', 38.9500007629395, 0.679805756967597, -76.3541717529297, -1.33263169472187, 218, 25, 'PPL', 'P'),
(82284, 'Matassee (historical)', 33.4008293151855, 0.582954444446631, -79.8658294677734, -1.39392168404896, 218, 48, 'PPL', 'P'),
(136763, 'Matawan', 43.8580589294434, 0.765467531852486, -93.6358337402344, -1.63425359661709, 218, 28, 'PPL', 'P'),
(145712, 'Matawan', 40.4147186279297, 0.705369906324458, -74.2300033569336, -1.29555796234493, 218, 37, 'PPL', 'P'),
(22917, 'Match', 34.1555595397949, 0.596126971830381, -83.0147171020508, -1.44888014104243, 218, 13, 'PPL', 'P'),
(88862, 'Match', 35.6458282470703, 0.622137067511776, -86.934440612793, -1.51729222207271, 218, 50, 'PPL', 'P'),
(145714, 'Matchaponix', 40.3383293151855, 0.704036661303737, -74.3794403076172, -1.2981661291585, 218, 37, 'PPL', 'P'),
(183137, 'Matchin', 36.3252792358398, 0.633995724371735, -119.129173278809, -2.07919630889406, 218, 6, 'PPL', 'P'),
(104056, 'Matchot (historical)', 37.5233306884766, 0.654905666828547, -76.8249969482422, -1.34084914458142, 218, 53, 'PPL', 'P'),
(131983, 'Matchwood', 46.5563888549805, 0.812562273358202, -89.396110534668, -1.56025646730674, 218, 27, 'PPL', 'P'),
(17049, 'Matecumbe', 24.913890838623, 0.434829424616423, -80.6388931274414, -1.40741419023768, 218, 12, 'PPL', 'P'),
(164304, 'Mateer', 40.6419410705566, 0.709335686082722, -79.4733276367188, -1.38707123477695, 218, 45, 'PPL', 'P'),
(110321, 'Matewan', 37.621940612793, 0.65662673468301, -82.163330078125, -1.43402063426617, 218, 58, 'PPL', 'P'),
(125356, 'Matfield', 42.0333290100098, 0.733619986798719, -70.9972229003906, -1.23913529938413, 218, 23, 'PPL', 'P'),
(125357, 'Matfield Corner', 42.0299987792969, 0.733561863307928, -71.0091705322266, -1.23934382489749, 218, 23, 'PPL', 'P'),
(33214, 'Matfield Green', 38.1591682434082, 0.666003125669934, -96.5602798461914, -1.68529480996316, 218, 20, 'PPL', 'P'),
(125358, 'Matfield Junction', 42.0352783203125, 0.733654008681645, -70.9880599975586, -1.23897537656068, 218, 23, 'PPL', 'P'),
(82285, 'Mathais Crossroads', 33.8913917541504, 0.591516374193181, -81.8694381713867, -1.42889125284862, 218, 48, 'PPL', 'P'),
(60794, 'Mathena', 33.1908302307129, 0.579289268996409, -90.3847198486328, -1.57751095485131, 218, 30, 'PPL', 'P'),
(110323, 'Matheny', 37.6647186279297, 0.657373351894614, -81.6005630493164, -1.4241984966918, 218, 58, 'PPL', 'P'),
(88863, 'Matheny Grove', 36.3788909912109, 0.634931426020734, -88.6500015258789, -1.54723440852458, 218, 50, 'PPL', 'P'),
(78703, 'Mather', 39.9347190856934, 0.696992333904369, -80.0738906860352, -1.39755303735333, 218, 45, 'PPL', 'P'),
(175207, 'Mather', 44.1427803039551, 0.770436857288519, -90.3086090087891, -1.57618257009958, 218, 57, 'PPL', 'P'),
(183138, 'Mather', 37.8822212219238, 0.66116948829144, -119.854721069336, -2.09185950671933, 218, 6, 'PPL', 'P'),
(183139, 'Mather Field', 38.5666694641113, 0.6731153636771, -121.295829772949, -2.11701159847653, 218, 6, 'PPL', 'P'),
(37089, 'Mathers Mill', 37.5402793884277, 0.655201477446627, -85.769172668457, -1.49695445977611, 218, 21, 'PPL', 'P'),
(73391, 'Mathers Mills', 39.4313888549805, 0.688207564153606, -84.1022186279297, -1.46786062328948, 218, 41, 'PPL', 'P'),
(131985, 'Matherton', 43.0683288574219, 0.751684141893699, -84.8369369506836, -1.48068387709627, 218, 27, 'PPL', 'P'),
(60796, 'Matherville', 31.8655605316162, 0.556158949270258, -88.565559387207, -1.54576061517733, 218, 30, 'PPL', 'P'),
(120544, 'Matherville', 41.2597198486328, 0.720117959809099, -90.607780456543, -1.58140409689085, 218, 18, 'PPL', 'P'),
(49307, 'Matherwood Heights', 39.413330078125, 0.687892379038595, -77.1772232055664, -1.34699665248371, 218, 25, 'PPL', 'P'),
(193056, 'Matheson', 39.1716690063477, 0.683674597662182, -103.974998474121, -1.81470606312949, 218, 7, 'PPL', 'P'),
(193768, 'Matheson', 40.6630592346191, 0.709704267577589, -122.459999084473, -2.13733018601329, 218, 6, 'PPL', 'P'),
(42009, 'Mathews', 29.6861095428467, 0.518120353630383, -90.5466690063477, -1.58033750087427, 218, 22, 'PPL', 'P'),
(49311, 'Mathews', 39.375560760498, 0.687233180089773, -77.4749984741211, -1.352193811351, 218, 25, 'PPL', 'P'),
(104058, 'Mathews', 37.436939239502, 0.653397851598371, -76.3202819824219, -1.33204020664377, 218, 53, 'PPL', 'P'),
(4036, 'Mathews (historical)', 34.9436111450195, 0.609881067017177, -88.0638885498047, -1.53700480730343, 218, 2, 'PPL', 'P'),
(208048, 'Mathews Corner', 46.4599990844727, 0.810879954497599, -119.193328857422, -2.08031603497438, 218, 56, 'PPL', 'P'),
(60797, 'Mathews Crossing', 33.3363914489746, 0.58182979151829, -90.3944396972656, -1.57768059821275, 218, 30, 'PPL', 'P'),
(82286, 'Mathews Heights', 34.1444396972656, 0.595932893965941, -82.1341705322266, -1.43351170418186, 218, 48, 'PPL', 'P'),
(183140, 'Mathews Mill', 37.1233291625977, 0.647924323188958, -119.371940612793, -2.08343339818838, 218, 6, 'PPL', 'P'),
(33216, 'Mathews Park', 38.9986114501953, 0.680654173511869, -95.6555633544922, -1.66950452838592, 218, 20, 'PPL', 'P'),
(82287, 'Mathews Village', 34.1655616760254, 0.596301542039835, -82.149169921875, -1.43377349291701, 218, 48, 'PPL', 'P'),
(110322, 'Mathias', 38.8777809143066, 0.678545282823662, -78.8663864135742, -1.37647811206699, 218, 58, 'PPL', 'P'),
(125359, 'Mathies Manor', 42.1902809143066, 0.736359314295974, -72.5652770996094, -1.26650300801022, 218, 23, 'PPL', 'P'),
(204837, 'Mathieu Place Condominium', 40.6091690063477, 0.708763705659601, -111.824440002441, -1.95170466224146, 218, 52, 'PPL', 'P'),
(56124, 'Mathis', 37.7216682434082, 0.658367310192459, -93.165283203125, -1.6260409404475, 218, 29, 'PPL', 'P'),
(96050, 'Mathis', 28.0941696166992, 0.490335760425155, -97.8277816772461, -1.70741689019013, 218, 51, 'PPL', 'P'),
(82288, 'Mathis (historical)', 33.0819396972656, 0.577388770663501, -81.3291702270508, -1.41946179837698, 218, 48, 'PPL', 'P'),
(82289, 'Mathis Corner', 34.0944404602051, 0.595060242655749, -79.6972198486328, -1.39097889104442, 218, 48, 'PPL', 'P'),
(60798, 'Mathiston', 33.5400009155273, 0.585383447097865, -89.1241683959961, -1.55551018161201, 218, 30, 'PPL', 'P'),
(38, 'Matilda', 28.9591693878174, 0.505432854460164, -96.6791687011719, -1.6873698119265, 218, 51, 'PPL', 'P'),
(42007, 'Matilda', 29.8844394683838, 0.521581863836241, -91.603889465332, -1.59878947880299, 218, 22, 'PPL', 'P'),
(104059, 'Matildaville (historical)', 38.9972190856934, 0.680629872166922, -77.2630615234375, -1.34849481375493, 218, 53, 'PPL', 'P'),
(183141, 'Matilija', 34.4408302307129, 0.601105884646338, -119.26000213623, -2.08147970321269, 218, 6, 'PPL', 'P'),
(183142, 'Matilija Springs', 34.4833297729492, 0.601847641588953, -119.304443359375, -2.08225534888018, 218, 6, 'PPL', 'P'),
(96051, 'Matinburg', 32.9022216796875, 0.574252099531606, -95.0444412231445, -1.6588384350621, 218, 51, 'PPL', 'P'),
(150611, 'Matinecock', 40.8761100769043, 0.713422706249613, -73.5769424438477, -1.2841598991955, 218, 40, 'PPL', 'P'),
(128088, 'Matinicus', 43.8650016784668, 0.765588705682085, -68.8874969482422, -1.20231363520437, 218, 26, 'PPL', 'P'),
(66667, 'Matkins', 36.2544403076172, 0.632759351835666, -79.519172668457, -1.38787138152646, 218, 33, 'PPL', 'P'),
(139311, 'Matkins', 40.1819381713867, 0.701307120923488, -94.163330078125, -1.64346014450549, 218, 29, 'PPL', 'P'),
(392, 'Matlacha', 26.6294403076172, 0.464771411331212, -82.0711135864258, -1.43241115286138, 218, 12, 'PPL', 'P'),
(204838, 'Matlin', 41.559440612793, 0.725349073980287, -113.358062744141, -1.97847142856757, 218, 52, 'PPL', 'P'),
(37091, 'Matlock', 36.8327789306641, 0.642853264999284, -86.4661102294922, -1.50911831489699, 218, 21, 'PPL', 'P'),
(116773, 'Matlock', 43.2438888549805, 0.75474824188589, -95.9349975585938, -1.67438157529018, 218, 16, 'PPL', 'P'),
(208047, 'Matlock', 47.2380599975586, 0.824459679212022, -123.406669616699, -2.15385270373225, 218, 56, 'PPL', 'P'),
(88864, 'Matlock Ford', 35.8891716003418, 0.626384210239207, -87.4813919067383, -1.5268383230001, 218, 50, 'PPL', 'P'),
(56127, 'Matney', 39.6911087036133, 0.69274053064503, -94.7980575561523, -1.65453822884995, 218, 29, 'PPL', 'P'),
(66668, 'Matney', 36.1916694641113, 0.631663793942234, -81.8111114501953, -1.42787325952194, 218, 33, 'PPL', 'P'),
(104060, 'Matney', 37.3138885498047, 0.651250211916304, -81.9797210693359, -1.43081605252648, 218, 53, 'PPL', 'P'),
(104064, 'Matoaca', 37.230281829834, 0.649790999376022, -77.477783203125, -1.35224241404089, 218, 53, 'PPL', 'P'),
(104061, 'Matoaca (historical)', 37.273609161377, 0.65054720396755, -77.6391677856445, -1.35505910636781, 218, 53, 'PPL', 'P'),
(104063, 'Matoaca Manor', 37.2361106872559, 0.649892732129663, -77.470832824707, -1.35212110705324, 218, 53, 'PPL', 'P'),
(17050, 'Matoaka', 27.4027805328369, 0.47826874449941, -82.5302810668945, -1.44042513721365, 218, 12, 'PPL', 'P'),
(76532, 'Matoaka', 36.6786117553711, 0.640162540191923, -95.9780578613281, -1.6751331193498, 218, 42, 'PPL', 'P'),
(110324, 'Matoaka', 37.4199981689453, 0.653102174138345, -81.2433319091797, -1.41796363710576, 218, 58, 'PPL', 'P'),
(10352, 'Matoka (historical)', 33.0550003051758, 0.576918589573048, -91.7152786254883, -1.60073358639875, 218, 4, 'PPL', 'P'),
(49308, 'Matovich', 39.2894401550293, 0.685730091970533, -77.4441680908203, -1.35165571965275, 218, 25, 'PPL', 'P'),
(76528, 'Matoy', 34.1349983215332, 0.595768110873492, -96.0597229003906, -1.67655844316521, 218, 42, 'PPL', 'P'),
(66669, 'Matrimony', 36.5202789306641, 0.637399111086802, -79.8677825927734, -1.39395577251091, 218, 33, 'PPL', 'P'),
(208049, 'Mats Mats', 47.9419403076172, 0.836744708162503, -122.686393737793, -2.14128151812264, 218, 56, 'PPL', 'P'),
(56125, 'Matson', 38.6080589294434, 0.673837746122784, -90.7969436645508, -1.58470561769422, 218, 29, 'PPL', 'P'),
(22918, 'Matt', 34.2986106872559, 0.59862368535233, -84.1530609130859, -1.4687479885647, 218, 13, 'PPL', 'P'),
(96052, 'Matt Colonia', 26.2479991912842, 0.458114007948718, -97.9749984741211, -1.70998630800983, 218, 51, 'PPL', 'P'),
(125360, 'Mattapan', 42.2722206115723, 0.737789431801347, -71.0875015258789, -1.24071095864308, 218, 23, 'PPL', 'P'),
(49309, 'Mattapanient (historical)', 38.2874984741211, 0.668242910725718, -76.408332824707, -1.3335769837508, 218, 25, 'PPL', 'P'),
(49310, 'Mattapex', 38.901668548584, 0.678962200692314, -76.3499984741211, -1.33255885726606, 218, 25, 'PPL', 'P'),
(125361, 'Mattapoisett', 41.6583290100098, 0.72707500210374, -70.8166732788086, -1.2359841140243, 218, 23, 'PPL', 'P'),
(104065, 'Mattaponi', 37.5347213745117, 0.655104471803921, -76.773063659668, -1.33994273770441, 218, 53, 'PPL', 'P'),
(208050, 'Mattawa', 46.7380599975586, 0.81573303295205, -119.901672363281, -2.09267896138675, 218, 56, 'PPL', 'P'),
(128090, 'Mattawamkeag', 45.5136108398438, 0.794362363626655, -68.3550033569336, -1.19301986879027, 218, 26, 'PPL', 'P'),
(104066, 'Mattawan', 37.6597213745117, 0.657286133368914, -77.3255615234375, -1.34958564453743, 218, 53, 'PPL', 'P'),
(131987, 'Mattawan', 42.2094383239746, 0.736693674170834, -85.7844390869141, -1.49722090904317, 218, 27, 'PPL', 'P'),
(4039, 'Mattawana', 33.922779083252, 0.59206418642941, -86.4902801513672, -1.50954015961366, 218, 2, 'PPL', 'P'),
(164305, 'Mattawana', 40.4961090087891, 0.706790436449906, -77.7297210693359, -1.35663955931672, 218, 45, 'PPL', 'P'),
(49312, 'Mattawoman', 38.6525001525879, 0.674613391790269, -76.8808288574219, -1.34182359522428, 218, 25, 'PPL', 'P'),
(49315, 'Mattawoman Estates', 38.649169921875, 0.674555268299478, -76.8694381713867, -1.34162479024891, 218, 25, 'PPL', 'P'),
(49313, 'Mattawoman Village', 38.5625, 0.673042592800313, -77.1725006103516, -1.34691422764797, 218, 25, 'PPL', 'P'),
(183143, 'Mattei', 36.7002792358398, 0.640540709066714, -119.690826416016, -2.08899900539248, 218, 6, 'PPL', 'P'),
(164306, 'Matternville', 40.8305587768555, 0.712627686085197, -77.9661102294922, -1.36076532847747, 218, 45, 'PPL', 'P'),
(164307, 'Matterstown', 40.5724983215332, 0.708123681470627, -76.8477783203125, -1.34124675453217, 218, 45, 'PPL', 'P'),
(56126, 'Mattese', 38.4855613708496, 0.671699760399668, -90.3486099243164, -1.57688071777935, 218, 29, 'PPL', 'P'),
(120545, 'Matteson', 41.5038909912109, 0.724379550185444, -87.7130584716797, -1.53088166732512, 218, 18, 'PPL', 'P'),
(131988, 'Matteson', 41.9411087036133, 0.732010438814902, -85.190559387207, -1.48685575292253, 218, 27, 'PPL', 'P'),
(37092, 'Matthew', 37.8561096191406, 0.6607137548499, -83.1586074829102, -1.45139150195038, 218, 21, 'PPL', 'P'),
(88865, 'Matthew', 36.0486106872559, 0.629166947262231, -85.6716690063477, -1.49525269983955, 218, 50, 'PPL', 'P'),
(208051, 'Matthew', 46.5577812194824, 0.812586574703149, -118.535278320313, -2.06883088645731, 218, 56, 'PPL', 'P'),
(66670, 'Matthew (historical)', 35.7508316040039, 0.623969721815914, -80.8652801513672, -1.41136538918898, 218, 33, 'PPL', 'P'),
(188986, 'Matthew Place', 32.8491706848145, 0.573326184999613, -108.83528137207, -1.89953400227708, 218, 38, 'PPL', 'P'),
(4038, 'Matthews', 32.2652816772461, 0.563135399351343, -86.0038909912109, -1.50105106732292, 218, 2, 'PPL', 'P'),
(22919, 'Matthews', 33.2108306884766, 0.579638342836291, -82.3077774047852, -1.43654171571209, 218, 13, 'PPL', 'P'),
(27830, 'Matthews', 37.9674987792969, 0.662657862445658, -89.373893737793, -1.55986871105203, 218, 18, 'PPL', 'P'),
(49324, 'Matthews', 38.8161087036133, 0.67746889969008, -75.9530563354492, -1.32563091000633, 218, 25, 'PPL', 'P'),
(56128, 'Matthews', 36.7591705322266, 0.64156855608943, -89.586669921875, -1.56358235603409, 218, 29, 'PPL', 'P'),
(60800, 'Matthews', 34.0924987792969, 0.595026353930878, -89.2183303833008, -1.55715361832069, 218, 30, 'PPL', 'P'),
(66671, 'Matthews', 35.1166687011719, 0.61290149116749, -80.7238922119141, -1.40889770412291, 218, 33, 'PPL', 'P'),
(96053, 'Matthews', 29.4991703033447, 0.5148576483999, -96.3225021362305, -1.68114480603649, 218, 51, 'PPL', 'P'),
(123145, 'Matthews', 40.3886108398438, 0.704914239461946, -85.4994430541992, -1.49224678991717, 218, 19, 'PPL', 'P'),
(145715, 'Matthews', 40.1569404602051, 0.700870828557906, -74.2577819824219, -1.29604279082138, 218, 37, 'PPL', 'P'),
(164308, 'Matthews', 40.1016693115234, 0.699906165032052, -75.6597213745117, -1.32051124912676, 218, 45, 'PPL', 'P'),
(194315, 'Matthews', 40.4797210693359, 0.706504412948832, -104.497222900391, -1.82382059880223, 218, 7, 'PPL', 'P'),
(196991, 'Matthews', 45.6277809143066, 0.79635500733328, -111.083610534668, -1.93877474883301, 218, 31, 'PPL', 'P'),
(66672, 'Matthews Crossroads', 36.0605583190918, 0.629375472775584, -78.0372161865234, -1.36200636154545, 218, 33, 'PPL', 'P'),
(27831, 'Matthews Junction', 37.9524993896484, 0.662396073710504, -89.373893737793, -1.55986871105203, 218, 18, 'PPL', 'P'),
(191839, 'Matthews Place', 30.232780456543, 0.527661560999269, -103.024169921875, -1.79811097427083, 218, 51, 'PPL', 'P'),
(164309, 'Matthews Run', 41.9044418334961, 0.731370481204956, -79.3447189331055, -1.38482658945217, 218, 45, 'PPL', 'P'),
(178602, 'Matthie', 33.9944381713867, 0.593314873456339, -112.808326721191, -1.96887672495029, 218, 5, 'PPL', 'P'),
(208052, 'Matthiesen (historical)', 47.7680587768555, 0.833709902942303, -119.662498474121, -2.0885045895361, 218, 56, 'PPL', 'P'),
(78704, 'Mattie', 39.9194412231445, 0.696725684900224, -78.2983322143555, -1.36656369596085, 218, 45, 'PPL', 'P'),
(110325, 'Mattie (historical)', 38.6091690063477, 0.673857120619714, -81.4697189331055, -1.42191483605705, 218, 58, 'PPL', 'P'),
(128092, 'Mattimo Place', 44.8224983215332, 0.782300174680386, -67.6408309936523, -1.18055520962426, 218, 26, 'PPL', 'P'),
(37093, 'Mattingly', 37.7627792358398, 0.659084832369153, -86.601936340332, -1.51148892774132, 218, 21, 'PPL', 'P'),
(150612, 'Mattituck', 40.9911117553711, 0.715429864184178, -72.5347213745117, -1.26596971000194, 218, 40, 'PPL', 'P'),
(123146, 'Mattix Corner', 40.3441696166992, 0.70413859379446, -86.5669403076172, -1.51087813174531, 218, 19, 'PPL', 'P'),
(104067, 'Mattoax', 37.4269409179688, 0.653223347967944, -77.8727798461914, -1.35913640599672, 218, 53, 'PPL', 'P'),
(27833, 'Mattoon', 39.4830589294434, 0.689109377077734, -88.3727798461914, -1.54239597745613, 218, 18, 'PPL', 'P'),
(37094, 'Mattoon', 37.4033317565918, 0.652811290368281, -88.023063659668, -1.53629227855378, 218, 21, 'PPL', 'P'),
(60802, 'Mattoon', 33.4511108398438, 0.583832022604839, -90.4711074829102, -1.57901870350246, 218, 30, 'PPL', 'P'),
(175208, 'Mattoon', 45.0041694641113, 0.785470934274235, -89.0419387817383, -1.55407500410056, 218, 57, 'PPL', 'P'),
(183144, 'Mattos', 37.5461082458496, 0.655303210200268, -122.016387939453, -2.12958771093416, 218, 6, 'PPL', 'P'),
(17051, 'Mattox', 30.2930603027344, 0.528713642787905, -82.0400009155273, -1.43186813431511, 218, 12, 'PPL', 'P'),
(22920, 'Mattox', 30.9174995422363, 0.539612163495864, -82.084716796875, -1.43264857367256, 218, 13, 'PPL', 'P'),
(96054, 'Mattox', 30.999719619751, 0.541047174559739, -93.7733306884766, -1.63665337107536, 218, 51, 'PPL', 'P'),
(104068, 'Mattox Bridge', 38.2033309936523, 0.66677391106843, -77.0083312988281, -1.34404893263115, 218, 53, 'PPL', 'P'),
(547, 'Mattoxtown', 38.1272201538086, 0.665445526316699, -84.4502792358398, -1.47393542689401, 218, 21, 'PPL', 'P'),
(60801, 'Mattson', 34.0977783203125, 0.595118499304595, -90.5100021362305, -1.57969754326432, 218, 30, 'PPL', 'P'),
(96055, 'Mattson', 33.2519416809082, 0.580355865012986, -99.5975036621094, -1.73830436567092, 218, 51, 'PPL', 'P'),
(136764, 'Mattson', 48.6894416809082, 0.84979106828961, -97.0733337402344, -1.69424928965439, 218, 28, 'PPL', 'P'),
(150613, 'Mattydale', 43.0977783203125, 0.752198131984084, -76.1455612182617, -1.32899075403757, 218, 40, 'PPL', 'P'),
(169479, 'Matunuck', 41.3783302307129, 0.722188101503445, -71.54638671875, -1.24872001614733, 218, 47, 'PPL', 'P'),
(88867, 'Matuta (historical)', 36.2574996948242, 0.632812748215522, -82.595832824707, -1.44156923121795, 218, 50, 'PPL', 'P'),
(73392, 'Matville', 39.7638893127441, 0.69401079190597, -83.1002807617188, -1.45037350862369, 218, 41, 'PPL', 'P'),
(110326, 'Matville', 37.8286094665527, 0.660233786642441, -81.3288879394531, -1.41945687152896, 218, 58, 'PPL', 'P'),
(49316, 'Matyiko Manor', 38.5013885498047, 0.671975996783737, -75.7205581665039, -1.32157305145337, 218, 25, 'PPL', 'P'),
(104070, 'Mauck', 38.5602798461914, 0.673003843806453, -78.4466705322266, -1.36915268801457, 218, 53, 'PPL', 'P'),
(49317, 'Mauck Farm Estates', 39.1469383239746, 0.683242965828508, -76.9416732788086, -1.34288553070895, 218, 25, 'PPL', 'P'),
(30463, 'Mauckport', 38.0247192382813, 0.663656547854438, -86.2019424438477, -1.50450771725979, 218, 19, 'PPL', 'P'),
(88866, 'Maucks (historical)', 36.1355590820313, 0.630684483030385, -82.5986099243164, -1.44161770074979, 218, 50, 'PPL', 'P'),
(4041, 'Maud', 34.6430587768555, 0.604635438618047, -88.1097183227539, -1.53780468773683, 218, 2, 'PPL', 'P'),
(27834, 'Maud', 38.3974990844727, 0.670162783555556, -87.8552780151367, -1.53336386661912, 218, 18, 'PPL', 'P'),
(37095, 'Maud', 37.8213882446289, 0.660107752543853, -85.2966690063477, -1.48870771514457, 218, 21, 'PPL', 'P'),
(56129, 'Maud', 39.6333312988281, 0.691732124698271, -92.1952819824219, -1.60911122539787, 218, 29, 'PPL', 'P'),
(60803, 'Maud', 34.561939239502, 0.603219635603534, -90.4369430541992, -1.57842242173439, 218, 30, 'PPL', 'P'),
(73393, 'Maud', 39.355281829834, 0.686879245980902, -84.3902816772461, -1.47288827195339, 218, 41, 'PPL', 'P'),
(76530, 'Maud', 35.1302795410156, 0.613139045136725, -96.7755584716797, -1.6890521307871, 218, 42, 'PPL', 'P'),
(82291, 'Maud', 35.1474990844727, 0.61343958286574, -81.745002746582, -1.42671944497966, 218, 48, 'PPL', 'P'),
(96056, 'Maud', 33.3327789306641, 0.581766741179483, -94.3424987792969, -1.64658722825746, 218, 51, 'PPL', 'P'),
(116775, 'Maud', 43.226390838623, 0.754442843887885, -91.3702774047852, -1.59471217917408, 218, 16, 'PPL', 'P'),
(208053, 'Maud', 48.3311080932617, 0.843536967364696, -118.078330993652, -2.0608556510989, 218, 56, 'PPL', 'P'),
(42008, 'Maude', 30.3727798461914, 0.530105011299417, -89.8125, -1.56752383444741, 218, 22, 'PPL', 'P'),
(4042, 'Maudlin (historical)', 33.9513893127441, 0.5925635291338, -86.3472213745117, -1.50704331293365, 218, 2, 'PPL', 'P'),
(196992, 'Maudlow', 46.107780456543, 0.804732579753369, -111.172218322754, -1.94032124647802, 218, 31, 'PPL', 'P'),
(96057, 'Maudlowe', 28.4263896942139, 0.496134094619016, -96.8905563354492, -1.69105922214264, 218, 51, 'PPL', 'P'),
(131990, 'Maue Corners', 44.3600006103516, 0.774228066837329, -86.1391677856445, -1.50341209278733, 218, 27, 'PPL', 'P'),
(49318, 'Maugansville', 39.6927795410156, 0.692769692258966, -77.745002746582, -1.35690627489989, 218, 25, 'PPL', 'P'),
(210672, 'Maui Meadows', 20.7013893127441, 0.361307403244551, -156.425567626953, -2.73014118939138, 218, 15, 'PPL', 'P'),
(22921, 'Mauk', 32.5016708374023, 0.567261168512094, -84.4211120605469, -1.47342636365164, 218, 13, 'PPL', 'P'),
(37096, 'Maulden', 37.3555603027344, 0.651977521210005, -83.8686065673828, -1.46378332366057, 218, 21, 'PPL', 'P'),
(10354, 'Mauldin', 34.5938911437988, 0.603777301535797, -93.6658325195313, -1.6347771740874, 218, 4, 'PPL', 'P'),
(82294, 'Mauldin', 34.7786102294922, 0.607001257772419, -82.3102798461914, -1.43658539155397, 218, 48, 'PPL', 'P'),
(22926, 'Mauldins (historical)', 34.6674995422363, 0.605062010445651, -83.648063659668, -1.45993412377902, 218, 13, 'PPL', 'P'),
(56130, 'Maulsby', 36.6463890075684, 0.639600147148725, -89.8099975585938, -1.56748015860553, 218, 29, 'PPL', 'P'),
(116776, 'Maulsby', 42.144718170166, 0.735564094394477, -92.9230575561523, -1.62181330537505, 218, 16, 'PPL', 'P'),
(10355, 'Maumee', 36.0527801513672, 0.629239718139017, -92.6469421386719, -1.6169941822245, 218, 4, 'PPL', 'P'),
(30458, 'Maumee', 39.021110534668, 0.681046856614601, -86.2616729736328, -1.5055502116685, 218, 19, 'PPL', 'P'),
(156369, 'Maumee', 41.5627784729004, 0.725407330629133, -83.6538925170898, -1.46003585653266, 218, 41, 'PPL', 'P'),
(10356, 'Maumelle', 34.8666687011719, 0.608538168037504, -92.404167175293, -1.61275695977213, 218, 4, 'PPL', 'P'),
(10362, 'Maumelle Station', 34.8136100769043, 0.607612120347456, -92.442497253418, -1.61342594583796, 218, 4, 'PPL', 'P'),
(210682, 'Maunalani Heights', 21.2966709136963, 0.371697027157709, -157.792495727539, -2.75399858538464, 218, 15, 'PPL', 'P'),
(210685, 'Maunaloa', 21.1358299255371, 0.36888982234217, -157.216384887695, -2.74394355437294, 218, 15, 'PPL', 'P'),
(210686, 'Maunawili', 21.3727798461914, 0.373025378619927, -157.770553588867, -2.75361562281989, 218, 15, 'PPL', 'P'),
(27835, 'Maunie', 38.0355606079102, 0.663845765449888, -88.0455627441406, -1.53668496165651, 218, 18, 'PPL', 'P'),
(56131, 'Maupin', 38.2405586242676, 0.667423655795382, -90.7838897705078, -1.58447778426296, 218, 29, 'PPL', 'P'),
(201193, 'Maupin', 45.1752815246582, 0.78845740312065, -121.080276489258, -2.11324948396263, 218, 43, 'PPL', 'P'),
(42011, 'Maurepas', 30.2966709136963, 0.528776659837199, -90.6638870239258, -1.58238334122367, 218, 22, 'PPL', 'P'),
(145716, 'Maurer', 40.5369415283203, 0.707503098357612, -74.2694396972656, -1.29624625632867, 218, 37, 'PPL', 'P'),
(156371, 'Maurers Mobile Home Court', 41.4219398498535, 0.72294923294299, -83.6611099243164, -1.46016182405223, 218, 41, 'PPL', 'P'),
(104069, 'Maurertown', 38.9297218322754, 0.679451822858725, -78.4638900756836, -1.36945322574358, 218, 53, 'PPL', 'P'),
(37097, 'Maurice', 39.0127792358398, 0.680901448019083, -84.5336074829102, -1.4753897791653, 218, 21, 'PPL', 'P'),
(42010, 'Maurice', 30.1083297729492, 0.525489486814201, -92.1244430541992, -1.6078748528618, 218, 22, 'PPL', 'P'),
(116777, 'Maurice', 42.9663887023926, 0.749904950548445, -96.1802825927734, -1.67866260674249, 218, 16, 'PPL', 'P'),
(202352, 'Maurice', 44.3977813720703, 0.774887465523233, -103.897216796875, -1.81334851676383, 218, 49, 'PPL', 'P'),
(71094, 'Maurice River', 39.2316703796387, 0.684721819181829, -75.029167175293, -1.30950600223812, 218, 37, 'PPL', 'P'),
(71096, 'Mauricetown', 39.285831451416, 0.685667108210752, -74.9936065673828, -1.30888535254607, 218, 37, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(96058, 'Mauriceville', 30.2033290863037, 0.52714753761937, -93.8661117553711, -1.63827270617618, 218, 51, 'PPL', 'P'),
(56132, 'Maurine', 38.4908294677734, 0.671791706036303, -93.9122161865234, -1.63907738029955, 218, 29, 'PPL', 'P'),
(202355, 'Maurine', 45.0230598449707, 0.785800633617187, -102.593063354492, -1.79058674524303, 218, 49, 'PPL', 'P'),
(66675, 'Maury', 35.4819412231445, 0.619276699342976, -77.5863876342773, -1.35413791894675, 218, 33, 'PPL', 'P'),
(208054, 'Maury', 47.3883285522461, 0.827082360253532, -122.378608703613, -2.13590965588784, 218, 56, 'PPL', 'P'),
(88868, 'Maury City', 35.8147201538086, 0.62508478736433, -89.2255630493164, -1.55727985215636, 218, 50, 'PPL', 'P'),
(88870, 'Maury Junction', 35.8747215270996, 0.626132008883976, -89.20361328125, -1.55689675643356, 218, 50, 'PPL', 'P'),
(196993, 'Maus Trailer Court', 46.9883308410645, 0.820101083192971, -104.185829162598, -1.81838575280766, 218, 31, 'PPL', 'P'),
(164310, 'Mausdale', 40.9863891601563, 0.71534743934844, -76.6352767944336, -1.33753790324007, 218, 45, 'PPL', 'P'),
(56133, 'Mauser Mill', 37.3127784729004, 0.651230837419374, -91.3150024414063, -1.5937474490692, 218, 29, 'PPL', 'P'),
(113687, 'Maushantuxet (historical)', 41.4397201538086, 0.723259557789011, -72.0155563354492, -1.25690857070905, 218, 8, 'PPL', 'P'),
(125363, 'Maushop Village', 41.5638885498047, 0.725426705126063, -70.4716720581055, -1.22996270679963, 218, 23, 'PPL', 'P'),
(175215, 'Mauston', 43.7972183227539, 0.764405662946844, -90.0772171020508, -1.57214401946453, 218, 57, 'PPL', 'P'),
(73394, 'Maustown', 39.4055595397949, 0.687756757560083, -84.4516677856445, -1.47395966165993, 218, 41, 'PPL', 'P'),
(4046, 'Mauvilla', 30.836669921875, 0.538201420487421, -88.184440612793, -1.53910883772264, 218, 2, 'PPL', 'P'),
(30459, 'Mauzy', 39.6238899230957, 0.691567341605823, -85.3383331298828, -1.48943489128021, 218, 19, 'PPL', 'P'),
(104071, 'Mauzy', 38.5641708374023, 0.67307175441425, -78.7425003051758, -1.37431589157796, 218, 53, 'PPL', 'P'),
(66676, 'Mavaton', 36.1738891601563, 0.631353469096213, -76.6425018310547, -1.33766400391769, 218, 33, 'PPL', 'P'),
(178603, 'Maverick', 33.7427787780762, 0.588922588449498, -109.546669006348, -1.91195005875319, 218, 5, 'PPL', 'P'),
(191840, 'Maverick', 31.8333301544189, 0.555596423069005, -100.194717407227, -1.74872771186138, 218, 51, 'PPL', 'P'),
(136765, 'Mavie', 48.144718170166, 0.840283849514137, -95.938606262207, -1.67444455904996, 218, 28, 'PPL', 'P'),
(104072, 'Mavisdale', 37.1983299255371, 0.64923333344376, -82.008056640625, -1.43131060154091, 218, 53, 'PPL', 'P'),
(37099, 'Mavity', 38.3447189331055, 0.669241596134498, -82.6997222900391, -1.44338244444613, 218, 21, 'PPL', 'P'),
(37098, 'Mavo', 37.872501373291, 0.660999844930002, -84.9261093139648, -1.48224022843731, 218, 21, 'PPL', 'P'),
(202353, 'Mawl Springs', 44.0872192382813, 0.769467133756594, -102.800003051758, -1.79419852431339, 218, 49, 'PPL', 'P'),
(56134, 'Max', 37.5747184753418, 0.655802552904658, -91.3833312988281, -1.59494001260534, 218, 29, 'PPL', 'P'),
(116778, 'Max', 43.1861114501953, 0.753739835939131, -95.5950012207031, -1.66844751974927, 218, 16, 'PPL', 'P'),
(123148, 'Max', 40.0102806091309, 0.698311131276176, -86.5819396972656, -1.51113992048047, 218, 19, 'PPL', 'P'),
(136766, 'Max', 47.6147193908691, 0.831033625783855, -94.0677795410156, -1.64179247303088, 218, 28, 'PPL', 'P'),
(209885, 'Max', 47.8211097717285, 0.834635817474296, -101.298332214355, -1.76798942391954, 218, 34, 'PPL', 'P'),
(209887, 'Max', 40.1138916015625, 0.700119484235367, -101.402221679688, -1.76980263714772, 218, 35, 'PPL', 'P'),
(73395, 'Max (historical)', 39.6338882446289, 0.69174184523625, -82.3897171020508, -1.43797183321747, 218, 41, 'PPL', 'P'),
(96059, 'Max Colonia', 26.3330001831055, 0.45959755512346, -98.193000793457, -1.71379116625923, 218, 51, 'PPL', 'P'),
(104073, 'Max Meadows', 36.9702796936035, 0.645253106036582, -80.9497222900391, -1.41283918253623, 218, 53, 'PPL', 'P'),
(73396, 'Maxatawney Subdivision', 38.833610534668, 0.677774364267112, -82.2138900756836, -1.43490307269337, 218, 41, 'PPL', 'P'),
(164311, 'Maxatawny', 40.5424995422363, 0.707600104000318, -75.6891708374023, -1.32102523921714, 218, 45, 'PPL', 'P'),
(198589, 'Maxbass', 48.7216682434082, 0.850353527911835, -101.14111328125, -1.76524543589038, 218, 34, 'PPL', 'P'),
(17052, 'Maxcy Quarters', 27.7147197723389, 0.483713111294886, -81.54638671875, -1.42325294134676, 218, 12, 'PPL', 'P'),
(96060, 'Maxdale', 30.9897193908691, 0.540872637639798, -97.8352813720703, -1.7075477845577, 218, 51, 'PPL', 'P'),
(56135, 'Maxey', 39.6725006103516, 0.692415758150095, -94.8227767944336, -1.65496966094654, 218, 29, 'PPL', 'P'),
(88872, 'Maxey', 36.1330604553223, 0.630640873767535, -89.3163909912109, -1.55886509879523, 218, 50, 'PPL', 'P'),
(96061, 'Maxey', 33.7033309936523, 0.588234094728685, -95.751106262207, -1.67117206670247, 218, 51, 'PPL', 'P'),
(10361, 'Maxey (historical)', 33.4530601501465, 0.583866044487765, -91.3333282470703, -1.59406729471612, 218, 4, 'PPL', 'P'),
(96062, 'Maxey Town', 31.4433307647705, 0.548789649638872, -94.1224975585938, -1.64274748259779, 218, 51, 'PPL', 'P'),
(22922, 'Maxeys', 33.7541694641113, 0.589121393424873, -83.1736068725586, -1.45165329068553, 218, 13, 'PPL', 'P'),
(187035, 'Maxeyville', 37.6180610656738, 0.656559023812295, -106.148887634277, -1.85264758654763, 218, 7, 'PPL', 'P'),
(169480, 'Maxfields Corner', 41.7355613708496, 0.728422961089484, -71.2705612182617, -1.24390595300285, 218, 47, 'PPL', 'P'),
(42012, 'Maxie', 30.3250007629395, 0.529271108983086, -92.4077835083008, -1.61282007668997, 218, 22, 'PPL', 'P'),
(60804, 'Maxie', 30.9777793884277, 0.540664245284499, -89.1958312988281, -1.55676093521796, 218, 30, 'PPL', 'P'),
(104074, 'Maxie', 37.3011093139648, 0.65102717217501, -82.1744384765625, -1.43421451239353, 218, 53, 'PPL', 'P'),
(22923, 'Maxim', 33.7930603027344, 0.589800166607707, -82.3408279418945, -1.43711855640421, 218, 13, 'PPL', 'P'),
(145717, 'Maxim', 40.1527786254883, 0.700798190839174, -74.1819381713867, -1.29471906660156, 218, 37, 'PPL', 'P'),
(125364, 'Maxim Corner', 41.8772201538086, 0.730895373266486, -70.8052825927734, -1.23578530904892, 218, 23, 'PPL', 'P'),
(156372, 'Maximo', 40.8763885498047, 0.713427566518602, -81.1722183227539, -1.41672247087972, 218, 41, 'PPL', 'P'),
(4044, 'Maxine', 33.5777816772461, 0.586042845783768, -87.1488876342773, -1.52103502866871, 218, 2, 'PPL', 'P'),
(37100, 'Maxine', 37.4650001525879, 0.653887606922837, -85.7955627441406, -1.49741505348664, 218, 21, 'PPL', 'P'),
(110327, 'Maxine', 38.1324996948242, 0.665537671690416, -81.6222229003906, -1.42457653240853, 218, 58, 'PPL', 'P'),
(123149, 'Maxinkuckee', 41.2083282470703, 0.71922100715396, -86.3813934326172, -1.50763972785978, 218, 19, 'PPL', 'P'),
(37101, 'Maxon', 37.0888900756836, 0.647323247730928, -88.7305603027344, -1.54864042442209, 218, 21, 'PPL', 'P'),
(116780, 'Maxon', 41.040828704834, 0.716297588646353, -92.7758331298828, -1.61924375439729, 218, 16, 'PPL', 'P'),
(188987, 'Maxon', 32.7533302307129, 0.571653453518934, -105.629997253418, -1.84359124094471, 218, 38, 'PPL', 'P'),
(37102, 'Maxon Crossing', 37.0830612182617, 0.647221514977287, -88.751106262207, -1.54899901906287, 218, 21, 'PPL', 'P'),
(183145, 'Maxson', 34.0761108398438, 0.594740330429804, -118.006942749023, -2.05960969118291, 218, 6, 'PPL', 'P'),
(66677, 'Maxton', 34.7350006103516, 0.606240126332875, -79.3491668701172, -1.38490422059795, 218, 33, 'PPL', 'P'),
(131991, 'Maxton', 46.0338897705078, 0.803442943995498, -83.6758270263672, -1.46041868593936, 218, 27, 'PPL', 'P'),
(10364, 'Maxville', 35.9913902282715, 0.628168261853451, -91.5755615234375, -1.59829506294662, 218, 4, 'PPL', 'P'),
(17053, 'Maxville', 30.1983299255371, 0.527060285804157, -82.0111083984375, -1.43136386476271, 218, 12, 'PPL', 'P'),
(56139, 'Maxville', 37.1980590820313, 0.649228606332825, -94.2680587768555, -1.64528800511967, 218, 29, 'PPL', 'P'),
(112488, 'Maxville', 39.6177787780762, 0.691460682004165, -82.3338928222656, -1.43699751573266, 218, 41, 'PPL', 'P'),
(123150, 'Maxville', 40.1722183227539, 0.70113747756205, -85.105827331543, -1.4853768995692, 218, 19, 'PPL', 'P'),
(175212, 'Maxville', 44.5316696166992, 0.777224256221723, -92.0086135864258, -1.60585324727832, 218, 57, 'PPL', 'P'),
(196994, 'Maxville', 46.4647216796875, 0.810962379333337, -113.233329772949, -1.97629442753449, 218, 31, 'PPL', 'P'),
(201194, 'Maxville', 45.7461090087891, 0.798420222179609, -117.55583190918, -2.0517363217362, 218, 43, 'PPL', 'P'),
(4045, 'Maxwell', 33.0791702270508, 0.577340434289716, -87.5555572509766, -1.52813275244794, 218, 2, 'PPL', 'P'),
(22925, 'Maxwell', 33.4166717529297, 0.583230947146808, -83.6611099243164, -1.46016182405223, 218, 13, 'PPL', 'P'),
(30462, 'Maxwell', 39.3872184753418, 0.687436645597055, -86.4555587768555, -1.50893415730761, 218, 19, 'PPL', 'P'),
(37103, 'Maxwell', 37.5613899230957, 0.65556992578344, -87.0374984741211, -1.51909092107295, 218, 21, 'PPL', 'P'),
(71097, 'Maxwell', 39.6691703796387, 0.692357634659304, -74.54638671875, -1.30107989370716, 218, 37, 'PPL', 'P'),
(76531, 'Maxwell', 34.9033317565918, 0.609178059068423, -96.8438873291016, -1.69024469432324, 218, 42, 'PPL', 'P'),
(88871, 'Maxwell', 35.0924987792969, 0.612479646450821, -86.2227783203125, -1.50487137190664, 218, 50, 'PPL', 'P'),
(96063, 'Maxwell', 29.8808307647705, 0.521518880076461, -97.7930603027344, -1.70681088788408, 218, 51, 'PPL', 'P'),
(104075, 'Maxwell', 37.1049995422363, 0.647604410963013, -81.6230621337891, -1.42459117979453, 218, 53, 'PPL', 'P'),
(110328, 'Maxwell', 39.3436088562012, 0.686675514157511, -81.1258316040039, -1.41591286990834, 218, 58, 'PPL', 'P'),
(116781, 'Maxwell', 41.8919410705566, 0.731152301732652, -93.3994369506836, -1.63012769429828, 218, 16, 'PPL', 'P'),
(120546, 'Maxwell', 40.6886100769043, 0.710150213902123, -89.7002792358398, -1.56556521262371, 218, 18, 'PPL', 'P'),
(150614, 'Maxwell', 42.9766693115234, 0.750084381026889, -77.7727813720703, -1.35739110337634, 218, 40, 'PPL', 'P'),
(164313, 'Maxwell', 40.0105590820313, 0.698315991545165, -79.9702835083008, -1.39574475097317, 218, 45, 'PPL', 'P'),
(183146, 'Maxwell', 39.2763900756836, 0.685502325118304, -122.190277099609, -2.13262264931241, 218, 6, 'PPL', 'P'),
(188988, 'Maxwell', 36.5400009155273, 0.637743324657695, -104.542778015137, -1.82461568554568, 218, 38, 'PPL', 'P'),
(199517, 'Maxwell', 41.0788917541504, 0.716961914180273, -100.524436950684, -1.75448240350288, 218, 35, 'PPL', 'P'),
(10365, 'Maxwell (historical)', 34.017219543457, 0.593712483407087, -93.7008285522461, -1.63538797008341, 218, 4, 'PPL', 'P'),
(27836, 'Maxwell (historical)', 39.6330604553223, 0.691727397587336, -89.899169921875, -1.56903650994657, 218, 18, 'PPL', 'P'),
(170836, 'Maxwell Colony', 43.1822204589844, 0.753671925331334, -97.6341705322266, -1.70403773824098, 218, 49, 'PPL', 'P'),
(96064, 'Maxwell Crossing', 32.6208305358887, 0.569340897586364, -97.9369430541992, -1.70932211563397, 218, 51, 'PPL', 'P'),
(104076, 'Maxwell Garden', 37.0911102294922, 0.647361996724788, -76.5133285522461, -1.33540950489688, 218, 53, 'PPL', 'P'),
(49320, 'Maxwell Hall', 38.5194396972656, 0.672291048740693, -76.6911087036133, -1.33851235388293, 218, 25, 'PPL', 'P'),
(66679, 'Maxwell Mill', 35.4300003051758, 0.618370159307913, -82.3616714477539, -1.43748234420911, 218, 33, 'PPL', 'P'),
(4048, 'Maxwellborn', 33.8808288574219, 0.59133201686672, -85.7169418334961, -1.49604285973497, 218, 2, 'PPL', 'P'),
(56137, 'Maxwells Mill', 37.7058296203613, 0.658090874071309, -90.9719390869141, -1.58775986399037, 218, 29, 'PPL', 'P'),
(183147, 'Maxwellton (historical)', 35.2016716003418, 0.614385071631746, -120.614440917969, -2.10511911947073, 218, 6, 'PPL', 'P'),
(22927, 'Maxwelton', 33.6380615234375, 0.587094927572404, -84.3880615234375, -1.47284952295953, 218, 13, 'PPL', 'P'),
(110329, 'Maxwelton', 37.8661117553711, 0.660888325059355, -80.4100036621094, -1.40341931544451, 218, 58, 'PPL', 'P'),
(208055, 'Maxwelton', 47.9375, 0.836667210174782, -122.443061828613, -2.13703457513229, 218, 56, 'PPL', 'P'),
(37104, 'May', 37.271110534668, 0.6505035947047, -82.8633270263672, -1.44623788576691, 218, 21, 'PPL', 'P'),
(56138, 'May', 36.7511100769043, 0.641427874604846, -94.5219421386719, -1.64971910569939, 218, 29, 'PPL', 'P'),
(76534, 'May', 36.6169395446777, 0.63908615705834, -99.746940612793, -1.74091253248449, 218, 42, 'PPL', 'P'),
(96065, 'May', 31.9794406890869, 0.558146532970811, -98.9197235107422, -1.7264748704249, 218, 51, 'PPL', 'P'),
(110330, 'May', 38.6533317565918, 0.67462790601821, -79.8024978637695, -1.39281633903852, 218, 58, 'PPL', 'P'),
(183149, 'May', 33.8950004577637, 0.591579357952961, -117.48999786377, -2.05058730088388, 218, 6, 'PPL', 'P'),
(195296, 'May', 44.6044387817383, 0.778494317745581, -113.911109924316, -1.98812392278051, 218, 17, 'PPL', 'P'),
(10366, 'May (historical)', 35.9722213745117, 0.62783370224151, -92.4008331298828, -1.61269876970231, 218, 4, 'PPL', 'P'),
(183148, 'May (historical)', 38.4199981689453, 0.670555466658288, -121.00611114502, -2.1119550545148, 218, 6, 'PPL', 'P'),
(88873, 'May Acres', 36.151668548584, 0.63096564626247, -83.4236068725586, -1.45601661381552, 218, 50, 'PPL', 'P'),
(4049, 'May Apple (historical)', 34.3144416809082, 0.598899988315426, -86.5302810668945, -1.51023830729342, 218, 2, 'PPL', 'P'),
(116782, 'May City', 43.3208312988281, 0.756091140865562, -95.4741668701172, -1.66633856248203, 218, 16, 'PPL', 'P'),
(175214, 'May Corner', 45.0491714477539, 0.786256367058726, -87.8505630493164, -1.53328157494144, 218, 57, 'PPL', 'P'),
(22928, 'May Creek', 30.7722206115723, 0.537076567821999, -81.6624984741211, -1.42527947377826, 218, 13, 'PPL', 'P'),
(208057, 'May Creek', 47.8544387817383, 0.835217518435397, -121.666107177734, -2.12347415833577, 218, 56, 'PPL', 'P'),
(211984, 'May Creek', 61.3486099243164, 1.07073523470099, -142.693328857422, -2.49046840919305, 218, 1, 'PPL', 'P'),
(73397, 'May Hill', 39.0127792358398, 0.680901448019083, -83.508056640625, -1.45749054032082, 218, 41, 'PPL', 'P'),
(82293, 'May Hilltop', 34.3172187805176, 0.598948457847265, -79.2200012207031, -1.3826498547352, 218, 48, 'PPL', 'P'),
(208058, 'May Junction', 46.5466690063477, 0.812392629996764, -119.390556335449, -2.08375830384136, 218, 56, 'PPL', 'P'),
(195297, 'May Place', 42.2011108398438, 0.736548332154343, -114.889717102051, -2.00520384011562, 218, 17, 'PPL', 'P'),
(60805, 'May Spring', 33.0930595397949, 0.577582848527941, -88.7236099243164, -1.54851911743444, 218, 30, 'PPL', 'P'),
(88874, 'May Springs (historical)', 36.2077789306641, 0.63194495717432, -83.4625015258789, -1.45669545357738, 218, 50, 'PPL', 'P'),
(187036, 'May Valley', 38.2016716003418, 0.666744949191576, -102.613327026367, -1.79094041303579, 218, 7, 'PPL', 'P'),
(17054, 'Mayacas (historical)', 28.1166706085205, 0.490728476817401, -80.8333282470703, -1.41080772325671, 218, 12, 'PPL', 'P'),
(17055, 'Mayaimi (historical)', 27.1166706085205, 0.473275184297457, -81.1166687011719, -1.41575294708488, 218, 12, 'PPL', 'P'),
(183150, 'Mayaro', 39.8241691589355, 0.695062873694606, -121.421112060547, -2.11919818688954, 218, 6, 'PPL', 'P'),
(60806, 'Maybank', 31.4074993133545, 0.548164272835894, -89.3697204589844, -1.55979587359622, 218, 30, 'PPL', 'P'),
(131992, 'Maybee', 42.0038909912109, 0.733106196445415, -83.5155563354492, -1.4576214346884, 218, 27, 'PPL', 'P'),
(156373, 'Maybee', 40.7788887023926, 0.711725873161069, -82.6213912963867, -1.44201531070053, 218, 41, 'PPL', 'P'),
(194316, 'Maybell', 40.5177803039551, 0.707168671903725, -108.086387634277, -1.88646334080502, 218, 7, 'PPL', 'P'),
(27839, 'Mayberry', 38.2705612182617, 0.667947299844719, -88.5486068725586, -1.54546473798023, 218, 18, 'PPL', 'P'),
(49322, 'Mayberry', 39.6405601501465, 0.691858291954914, -77.0997161865234, -1.345643899808, 218, 25, 'PPL', 'P'),
(56141, 'Mayberry', 36.689998626709, 0.64036127858827, -90.2547225952148, -1.57524207476062, 218, 29, 'PPL', 'P'),
(142372, 'Mayberry', 40.2230606079102, 0.702024842837264, -96.3116683959961, -1.6809557215991, 218, 35, 'PPL', 'P'),
(22929, 'Mayberry (historical)', 32.4061088562012, 0.565593297300404, -82.9722213745117, -1.44813845067884, 218, 13, 'PPL', 'P'),
(88876, 'Mayberry (historical)', 35.8624992370605, 0.625918689680661, -86.8841705322266, -1.51641484365159, 218, 50, 'PPL', 'P'),
(49323, 'Mayberry Ridge', 39.628059387207, 0.691640112482609, -77.10888671875, -1.34580395578951, 218, 25, 'PPL', 'P'),
(113688, 'Mayberry Village', 41.7786102294922, 0.729174305412022, -72.5869369506836, -1.26688104372696, 218, 8, 'PPL', 'P'),
(190463, 'Mayberrys (historical)', 39.5055618286133, 0.689502126759494, -119.893608093262, -2.09253821332314, 218, 39, 'PPL', 'P'),
(183151, 'Maybert (historical)', 39.3527793884277, 0.686835570139025, -120.698608398438, -2.10658811912801, 218, 6, 'PPL', 'P'),
(110331, 'Maybeury', 37.3708305358887, 0.652244037056094, -81.3666687011719, -1.42011627021487, 218, 58, 'PPL', 'P'),
(82295, 'Maybinton', 34.452220916748, 0.601304689621713, -81.475830078125, -1.42202149565871, 218, 48, 'PPL', 'P'),
(104077, 'Maybrook', 37.3030586242676, 0.651061194057936, -80.539436340332, -1.40567834183917, 218, 53, 'PPL', 'P'),
(150615, 'Maybrook', 41.4838905334473, 0.724030476345562, -74.2180633544922, -1.29534956998964, 218, 40, 'PPL', 'P'),
(164314, 'Mayburg', 41.5933303833008, 0.725940562058394, -79.1988906860352, -1.38228140639838, 218, 45, 'PPL', 'P'),
(150618, 'Maybury Mills', 42.600830078125, 0.743524748945914, -76.0661087036133, -1.32760404605797, 218, 40, 'PPL', 'P'),
(96066, 'Mayd', 33.6425018310547, 0.587172425560125, -96.8222198486328, -1.68986652544845, 218, 51, 'PPL', 'P'),
(22930, 'Mayday', 30.827220916748, 0.538036504236918, -83.0091705322266, -1.44878333513681, 218, 13, 'PPL', 'P'),
(60807, 'Mayday', 33.3608283996582, 0.582256296766866, -90.3138885498047, -1.5762747154733, 218, 30, 'PPL', 'P'),
(88878, 'Mayday', 36.2099990844727, 0.63198370616818, -82.4972229003906, -1.43984816336348, 218, 50, 'PPL', 'P'),
(187037, 'Mayday', 37.3505592346191, 0.651890236105277, -108.076110839844, -1.88628397690561, 218, 7, 'PPL', 'P'),
(22931, 'Mayday (historical)', 33.5088882446289, 0.584840428551598, -84.2797164916992, -1.47095854542752, 218, 13, 'PPL', 'P'),
(96067, 'Maydelle', 31.8005599975586, 0.555024475935397, -95.3022232055664, -1.66333757940768, 218, 51, 'PPL', 'P'),
(136771, 'Mayer', 44.8849983215332, 0.783391005462883, -93.8874969482422, -1.63864594820295, 218, 28, 'PPL', 'P'),
(178604, 'Mayer', 34.3977813720703, 0.6003545403238, -112.235557556152, -1.95888001716646, 218, 5, 'PPL', 'P'),
(191842, 'Mayer', 35.2619400024414, 0.6154369536833, -101.737777709961, -1.77565919470092, 218, 51, 'PPL', 'P'),
(33218, 'Mayer (historical)', 37.2700004577637, 0.65048422020777, -94.9055633544922, -1.65641455899596, 218, 20, 'PPL', 'P'),
(42013, 'Mayers', 32.4080581665039, 0.56562731918333, -93.6213912963867, -1.63400152841991, 218, 22, 'PPL', 'P'),
(60808, 'Mayersville', 32.9019393920898, 0.574247172683589, -91.0511093139648, -1.58914164512196, 218, 30, 'PPL', 'P'),
(164315, 'Mayes', 40.8255615234375, 0.712540467559497, -78.6197204589844, -1.37217297900682, 218, 45, 'PPL', 'P'),
(96068, 'Mayes Addition Colonia', 27.7360000610352, 0.484084522398412, -98.088996887207, -1.71197595566023, 218, 51, 'PPL', 'P'),
(4050, 'Mayes Crossroad', 34.0183296203613, 0.593731857904018, -85.8349990844727, -1.49810334747037, 218, 2, 'PPL', 'P'),
(56142, 'Mayesburg', 38.4025001525879, 0.670250068660283, -94.0858306884766, -1.64210752498784, 218, 29, 'PPL', 'P'),
(82296, 'Mayesville', 33.9874992370605, 0.593193766205767, -80.2083282470703, -1.39989941543175, 218, 48, 'PPL', 'P'),
(82297, 'Mayesville East Subdivision', 33.9780616760254, 0.593029049692346, -80.1975021362305, -1.39971046415241, 218, 48, 'PPL', 'P'),
(33219, 'Mayetta', 39.3388900756836, 0.6865931559008, -95.7222213745117, -1.67066793030812, 218, 20, 'PPL', 'P'),
(71098, 'Mayetta', 39.6777801513672, 0.692507903523812, -74.2733306884766, -1.29631416693646, 218, 37, 'PPL', 'P'),
(4052, 'Mayfair', 34.7119407653809, 0.605837656113137, -86.5863876342773, -1.51121755162624, 218, 2, 'PPL', 'P'),
(14189, 'Mayfair', 39.1333312988281, 0.6830054784383, -75.5374984741211, -1.31837805709361, 218, 10, 'PPL', 'P'),
(22933, 'Mayfair', 33.4069404602051, 0.583061104048288, -82.0408325195313, -1.43188264854306, 218, 13, 'PPL', 'P'),
(49326, 'Mayfair', 39.0880584716797, 0.682215318542873, -76.8872222900391, -1.34193518167396, 218, 25, 'PPL', 'P'),
(60809, 'Mayfair', 32.2188911437988, 0.562325731800931, -90.2472229003906, -1.57511118039304, 218, 30, 'PPL', 'P'),
(82298, 'Mayfair', 34.1691703796387, 0.596364525799616, -79.8086090087891, -1.39292299864018, 218, 48, 'PPL', 'P'),
(96069, 'Mayfair', 29.6875, 0.518144621685817, -95.3194427490234, -1.66363811713669, 218, 51, 'PPL', 'P'),
(120548, 'Mayfair', 40.6150016784668, 0.708865504992269, -89.4077835083008, -1.56046019913014, 218, 18, 'PPL', 'P'),
(150616, 'Mayfair', 42.871940612793, 0.748256520412713, -73.9322204589844, -1.29036067031959, 218, 40, 'PPL', 'P'),
(164317, 'Mayfair', 40.0336112976074, 0.698718328606849, -75.0344390869141, -1.30959801445378, 218, 45, 'PPL', 'P'),
(183152, 'Mayfair', 35.3363914489746, 0.616736376558177, -118.913330078125, -2.07542913437409, 218, 6, 'PPL', 'P'),
(104078, 'Mayfair Estates', 37.436939239502, 0.653397851598371, -77.5777816772461, -1.35398771666127, 218, 53, 'PPL', 'P'),
(104079, 'Mayfair Place', 37.5711097717285, 0.655739569144878, -77.3874969482422, -1.35066662162389, 218, 53, 'PPL', 'P'),
(13155, 'Mayfair-Parkside', 38.9013900756836, 0.678957340423325, -76.9499969482422, -1.34303080614641, 218, 9, 'PPL', 'P'),
(10367, 'Mayfield', 36.1336097717285, 0.630650461147459, -93.9438934326172, -1.63963025254185, 218, 4, 'PPL', 'P'),
(14186, 'Mayfield', 39.7972183227539, 0.694592492867071, -75.5083312988281, -1.31786899385124, 218, 10, 'PPL', 'P'),
(22936, 'Mayfield', 33.3549995422363, 0.582154564013225, -82.8008270263672, -1.44514705498441, 218, 13, 'PPL', 'P'),
(33220, 'Mayfield', 37.2583312988281, 0.650280554963406, -97.5444412231445, -1.70247166636196, 218, 20, 'PPL', 'P'),
(37105, 'Mayfield', 36.7416687011719, 0.641263091512398, -88.6366729736328, -1.54700178140337, 218, 21, 'PPL', 'P'),
(49328, 'Mayfield', 39.2936096191406, 0.685802862847319, -76.9186096191406, -1.34248299391019, 218, 25, 'PPL', 'P'),
(56143, 'Mayfield', 37.4541702270508, 0.653698589064468, -89.9491729736328, -1.56990922783579, 218, 29, 'PPL', 'P'),
(66683, 'Mayfield', 36.5111083984375, 0.637239055105288, -79.5669403076172, -1.38870508410571, 218, 33, 'PPL', 'P'),
(76536, 'Mayfield', 35.3388900756836, 0.616779985821027, -99.8763885498047, -1.74317182519526, 218, 42, 'PPL', 'P'),
(104081, 'Mayfield', 37.3844413757324, 0.652481591025329, -79.2347183227539, -1.38290671662233, 218, 53, 'PPL', 'P'),
(123151, 'Mayfield', 40.1949996948242, 0.701535087512799, -85.3499984741211, -1.48963848994555, 218, 19, 'PPL', 'P'),
(131993, 'Mayfield', 44.6261100769043, 0.7788725531994, -85.5286102294922, -1.49275585315954, 218, 27, 'PPL', 'P'),
(150617, 'Mayfield', 43.1044387817383, 0.752314378965666, -74.2652816772461, -1.29617368518896, 218, 40, 'PPL', 'P'),
(156375, 'Mayfield', 41.5519409179688, 0.72521817961271, -81.4394378662109, -1.42138633173873, 218, 41, 'PPL', 'P'),
(164319, 'Mayfield', 40.1361083984375, 0.700507240490083, -79.5980606079102, -1.38924823581003, 218, 45, 'PPL', 'P'),
(170838, 'Mayfield', 43.0825004577637, 0.75193148297994, -97.3183288574219, -1.69852526110062, 218, 49, 'PPL', 'P'),
(175216, 'Mayfield', 43.3291702270508, 0.756236682619135, -88.1966705322266, -1.53932229008401, 218, 57, 'PPL', 'P'),
(191843, 'Mayfield', 34.107780456543, 0.595293069514049, -101.989166259766, -1.78004675259682, 218, 51, 'PPL', 'P'),
(192691, 'Mayfield', 39.1141700744629, 0.682671051984413, -111.709999084473, -1.9497072914239, 218, 52, 'PPL', 'P'),
(195298, 'Mayfield', 43.4180603027344, 0.757788107112161, -115.90055847168, -2.02284635023102, 218, 17, 'PPL', 'P'),
(208059, 'Mayfield', 46.5088882446289, 0.81173323131086, -122.568061828613, -2.13921623669728, 218, 56, 'PPL', 'P'),
(82299, 'Mayfield (historical)', 35.0186080932617, 0.611190010692951, -82.5722198486328, -1.44115710703926, 218, 48, 'PPL', 'P'),
(88879, 'Mayfield (historical)', 36.2813911437988, 0.633229732663201, -85.621940612793, -1.49438477564029, 218, 50, 'PPL', 'P'),
(82300, 'Mayfield Acres', 34.2166709899902, 0.597193567846957, -80.6827774047852, -1.40818011536719, 218, 48, 'PPL', 'P'),
(128094, 'Mayfield Corner', 45.1036109924316, 0.787206516356639, -69.6936111450195, -1.21638298208521, 218, 26, 'PPL', 'P'),
(104082, 'Mayfield Farms', 37.6227798461914, 0.656641382069006, -77.3824996948242, -1.35057940309819, 218, 53, 'PPL', 'P'),
(156376, 'Mayfield Heights', 41.5191688537598, 0.724646199189588, -81.4580612182617, -1.42171137054977, 218, 41, 'PPL', 'P'),
(49329, 'Mayfield Manor', 39.190559387207, 0.684004297005134, -76.7827835083008, -1.34011238106585, 218, 25, 'PPL', 'P'),
(104083, 'Mayfield Trailer Court', 38.1100006103516, 0.665144988587683, -78.9911117553711, -1.37865497994202, 218, 53, 'PPL', 'P'),
(10368, 'Mayflower', 34.9569396972656, 0.610113694138395, -92.4272232055664, -1.61315936341284, 218, 4, 'PPL', 'P'),
(42017, 'Mayflower', 31.9513893127441, 0.557656944093913, -91.3913879394531, -1.59508062751089, 218, 22, 'PPL', 'P'),
(56145, 'Mayflower', 36.5105590820313, 0.637229467725364, -94.0513916015625, -1.64150644952981, 218, 29, 'PPL', 'P'),
(96072, 'Mayflower', 32.3308296203613, 0.564279426776613, -94.6044387817383, -1.65115894374275, 218, 51, 'PPL', 'P'),
(104084, 'Mayflower', 36.829719543457, 0.642799868619428, -83.0808334350586, -1.45003408874276, 218, 53, 'PPL', 'P'),
(88880, 'Mayflower (historical)', 36.3180618286133, 0.633869756852174, -82.545280456543, -1.4406869259488, 218, 50, 'PPL', 'P'),
(183155, 'Mayflower (historical)', 39.0400009155273, 0.681376555957553, -120.817222595215, -2.10865832740139, 218, 6, 'PPL', 'P'),
(204844, 'Mayflower Condominium', 40.769718170166, 0.711565817179555, -111.853332519531, -1.95220893179386, 218, 52, 'PPL', 'P'),
(125365, 'Mayflower Grove', 42.0416717529297, 0.733765595131319, -70.8430633544922, -1.23644470773483, 218, 23, 'PPL', 'P'),
(125366, 'Mayflower Heights', 42.0638885498047, 0.734153351386035, -70.1527786254883, -1.22439696643747, 218, 23, 'PPL', 'P'),
(104085, 'Mayflower Hills', 37.2402801513672, 0.64996550300645, -79.8583297729492, -1.39379078968138, 218, 53, 'PPL', 'P'),
(30464, 'Mayflower Meadows', 39.8833312988281, 0.696095447828257, -86.0844421386719, -1.50245695006237, 218, 19, 'PPL', 'P'),
(116783, 'Mayflower Mobile Home Park', 41.4811096191406, 0.723981940234695, -91.7050018310547, -1.60055422249933, 218, 16, 'PPL', 'P'),
(178605, 'Mayflower Terrace', 33.6152801513672, 0.586697317621655, -112.001670837402, -1.95479792384759, 218, 5, 'PPL', 'P'),
(156384, 'Mayflower Village', 40.8002815246582, 0.712099248345898, -81.5527801513672, -1.42336452779644, 218, 41, 'PPL', 'P'),
(183156, 'Mayflower Village', 34.1150016784668, 0.595419103612638, -118.008888244629, -2.05964364648681, 218, 6, 'PPL', 'P'),
(201195, 'Mayger', 46.1636085510254, 0.805706963817202, -123.106941223145, -2.14862145640301, 218, 43, 'PPL', 'P'),
(22937, 'Mayhaw', 31.1763896942139, 0.54413064904886, -84.8752822875977, -1.4813531294782, 218, 13, 'PPL', 'P'),
(701, 'Mayhew', 33.4847183227539, 0.584418583834929, -88.6344375610352, -1.5469627660934, 218, 30, 'PPL', 'P'),
(66684, 'Mayhew', 35.5636100769043, 0.620702089737414, -80.9127807617188, -1.41219443123632, 218, 33, 'PPL', 'P'),
(76537, 'Mayhew', 34.0608291625977, 0.594473614846632, -95.8858337402344, -1.67352350478696, 218, 42, 'PPL', 'P'),
(136774, 'Mayhew', 45.7133293151855, 0.797848108598432, -94.1105575561523, -1.64253909024249, 218, 28, 'PPL', 'P'),
(183157, 'Mayhew', 38.5652809143066, 0.67309112891118, -121.349716186523, -2.11795209381549, 218, 6, 'PPL', 'P'),
(42018, 'Mayhew Landing', 31.7608299255371, 0.554331055366568, -91.5894393920898, -1.59853727744776, 218, 22, 'PPL', 'P'),
(175217, 'Mayhews (historical)', 42.7630615234375, 0.746356221816887, -88.4899978637695, -1.54444181780553, 218, 57, 'PPL', 'P'),
(96076, 'Mayhill', 33.2040405273438, 0.579519832167783, -97.0840377807617, -1.69443611040486, 218, 51, 'PPL', 'P'),
(188989, 'Mayhill', 32.8894386291504, 0.574028993211285, -105.477500915527, -1.84092967775129, 218, 38, 'PPL', 'P'),
(60810, 'Mayhoff Springs (historical)', 32.2088890075684, 0.562151161591477, -88.7777786254883, -1.54946453962142, 218, 30, 'PPL', 'P'),
(37106, 'Mayking', 37.1333312988281, 0.648098893398413, -82.76611328125, -1.44454118583642, 218, 21, 'PPL', 'P'),
(88881, 'Mayland', 36.0466690063477, 0.629133058537359, -85.1999969482422, -1.48702046943595, 218, 50, 'PPL', 'P'),
(104087, 'Mayland', 38.5883293151855, 0.673493399393836, -78.7713928222656, -1.37482016113036, 218, 53, 'PPL', 'P'),
(4056, 'Maylene', 33.2033309936523, 0.579507448468714, -86.8616714477539, -1.51602216054886, 218, 2, 'PPL', 'P'),
(104088, 'Maylin Hills', 37.2652816772461, 0.650401861951059, -80.0430603027344, -1.39701494565508, 218, 53, 'PPL', 'P'),
(187795, 'Mayline', 37.9599990844727, 0.662526968078081, -101.660003662109, -1.7743017814933, 218, 20, 'PPL', 'P'),
(88882, 'Maymead', 36.415828704834, 0.635576110741615, -81.8372192382813, -1.42832892638445, 218, 50, 'PPL', 'P'),
(42020, 'Mayna', 31.4261093139648, 0.548489078620343, -91.8613891601563, -1.60328369630056, 218, 22, 'PPL', 'P'),
(49330, 'Maynadier', 39.0361099243164, 0.681308645349756, -76.5780563354492, -1.33653921783129, 218, 25, 'PPL', 'P'),
(4057, 'Maynard', 34.3758316040039, 0.599971444600992, -85.8811111450195, -1.49890815475179, 218, 2, 'PPL', 'P'),
(10369, 'Maynard', 36.4197196960449, 0.635644021349412, -90.897216796875, -1.58645571400456, 218, 4, 'PPL', 'P'),
(22938, 'Maynard', 33.0547218322754, 0.576913729304058, -83.8894424438477, -1.46414697830742, 218, 13, 'PPL', 'P'),
(37107, 'Maynard', 36.7691688537598, 0.641743059719857, -86.0758285522461, -1.50230661461884, 218, 21, 'PPL', 'P'),
(96073, 'Maynard', 30.5219402313232, 0.53270835113351, -95.3277816772461, -1.66378365889027, 218, 51, 'PPL', 'P'),
(116784, 'Maynard', 42.7738914489746, 0.746545239675255, -91.8822174072266, -1.60364721778935, 218, 16, 'PPL', 'P'),
(123152, 'Maynard', 41.541389465332, 0.725034022023331, -87.5086135864258, -1.52731343093857, 218, 19, 'PPL', 'P'),
(125367, 'Maynard', 42.4333305358887, 0.740601330438307, -71.4499969482422, -1.24703769728673, 218, 23, 'PPL', 'P'),
(136776, 'Maynard', 44.9069404602051, 0.783773968027636, -95.4686126708984, -1.66624162341836, 218, 28, 'PPL', 'P'),
(150620, 'Maynard', 43.1366691589355, 0.752876905166918, -75.2594375610352, -1.31352497863915, 218, 40, 'PPL', 'P'),
(156379, 'Maynard', 40.1233291625977, 0.700284200748788, -80.8794403076172, -1.41161253053814, 218, 41, 'PPL', 'P'),
(208060, 'Maynard', 47.9977798461914, 0.837719291963418, -122.882499694824, -2.14470421275561, 218, 56, 'PPL', 'P'),
(4058, 'Maynard Cove', 34.7866706848145, 0.607141939257003, -86.0772171020508, -1.50233084938476, 218, 2, 'PPL', 'P'),
(82301, 'Maynards', 34.7680587768555, 0.60681710018304, -80.2697219848633, -1.40097093829634, 218, 48, 'PPL', 'P'),
(104089, 'Maynards Crossroads', 36.7419395446777, 0.641267818623333, -76.876106262207, -1.34174117038854, 218, 53, 'PPL', 'P'),
(88883, 'Maynardville', 36.250560760498, 0.63269164096495, -83.7975006103516, -1.46254229059259, 218, 50, 'PPL', 'P'),
(110332, 'Maynor', 37.8658294677734, 0.660883398211339, -81.2680587768555, -1.4183952023604, 218, 58, 'PPL', 'P'),
(17056, 'Mayo', 30.0527801513672, 0.524519963019357, -83.1750030517578, -1.45167765860951, 218, 12, 'PPL', 'P'),
(22939, 'Mayo', 33.5247192382813, 0.585116731514693, -82.0538864135742, -1.43211048197431, 218, 13, 'PPL', 'P'),
(37109, 'Mayo', 37.8716697692871, 0.660985330702061, -84.9250030517578, -1.48222092051941, 218, 21, 'PPL', 'P'),
(42019, 'Mayo', 31.1991691589355, 0.544528225710095, -93.033332824707, -1.62373797189485, 218, 22, 'PPL', 'P'),
(49331, 'Mayo', 38.8875007629395, 0.6787149261851, -76.5122222900391, -1.33539019697898, 218, 25, 'PPL', 'P'),
(82302, 'Mayo', 35.0838890075684, 0.612329377586314, -81.8600006103516, -1.4287265363352, 218, 48, 'PPL', 'P'),
(96074, 'Mayo', 28.9050006866455, 0.504487432273186, -97.9222183227539, -1.70906512058878, 218, 51, 'PPL', 'P'),
(104090, 'Mayo', 36.5719413757324, 0.638300790852875, -78.8836135864258, -1.37677878295406, 218, 53, 'PPL', 'P'),
(88884, 'Mayo (historical)', 36.019718170166, 0.628662677709824, -83.7958297729492, -1.46251312897866, 218, 50, 'PPL', 'P'),
(125369, 'Mayo Beach', 41.9305610656738, 0.731826347804551, -70.0416717529297, -1.22245778568973, 218, 23, 'PPL', 'P'),
(125370, 'Mayo Corners', 42.6833305358887, 0.744964653568293, -72.3116683959961, -1.26207670112046, 218, 23, 'PPL', 'P'),
(17057, 'Mayo Junction', 30.2055606842041, 0.527186486350313, -83.2666702270508, -1.45327755263437, 218, 12, 'PPL', 'P'),
(82304, 'Mayo Mills', 35.0908317565918, 0.612450551415912, -81.8461074829102, -1.42848405551795, 218, 48, 'PPL', 'P'),
(37108, 'Mayo Village', 37.4524993896484, 0.653669427450532, -82.5236129760742, -1.44030875707401, 218, 21, 'PPL', 'P'),
(66685, 'Mayodan', 36.4122200012207, 0.635513126981835, -79.9672164916992, -1.39569122143526, 218, 33, 'PPL', 'P'),
(10370, 'Mayos', 34.452220916748, 0.601304689621713, -91.0788879394531, -1.58962647359841, 218, 4, 'PPL', 'P'),
(66686, 'Mayos Crossroads', 35.8605613708496, 0.625884867534817, -77.3866729736328, -1.350652240554, 218, 33, 'PPL', 'P'),
(104092, 'Mayos Woods', 37.7299995422363, 0.658512718787977, -77.8891677856445, -1.3594224294978, 218, 53, 'PPL', 'P'),
(209590, 'Mayoworth', 43.8319396972656, 0.765011665252892, -106.791389465332, -1.86386135894963, 218, 59, 'PPL', 'P'),
(96075, 'Maypearl', 32.313060760498, 0.563969301667674, -97.0113906860352, -1.69316817940987, 218, 51, 'PPL', 'P'),
(188990, 'Maypens', 32.360279083252, 0.564793416866999, -103.152221679688, -1.80034589905762, 218, 38, 'PPL', 'P'),
(17058, 'Mayport', 30.3930606842041, 0.530458978697802, -81.4308319091797, -1.42123612945325, 218, 12, 'PPL', 'P'),
(164322, 'Mayport', 41.0336112976074, 0.716171621126792, -79.2516708374023, -1.38320259381944, 218, 45, 'PPL', 'P'),
(4059, 'Mays', 34.0986099243164, 0.595133013532536, -86.1861114501953, -1.50423141429669, 218, 2, 'PPL', 'P'),
(27841, 'Mays', 39.6288909912109, 0.69165462671055, -87.7922210693359, -1.53226331529865, 218, 18, 'PPL', 'P'),
(30465, 'Mays', 39.7436103820801, 0.693656857797099, -85.4300003051758, -1.49103478530508, 218, 19, 'PPL', 'P'),
(208066, 'Mays (historical)', 46.6361083984375, 0.813953641869714, -123.175559997559, -2.14981907994522, 218, 56, 'PPL', 'P'),
(4060, 'Mays Bend', 33.5402793884277, 0.585388307366854, -86.2055587768555, -1.50457083417762, 218, 2, 'PPL', 'P'),
(22940, 'Mays Bluff', 30.9052791595459, 0.539398877582062, -81.8877792358398, -1.42921136481165, 218, 13, 'PPL', 'P'),
(49332, 'Mays Chapel', 39.4330596923828, 0.688236725767542, -76.6497192382813, -1.33778997143725, 218, 25, 'PPL', 'P'),
(49333, 'Mays Chapel North', 39.4550018310547, 0.688619688332296, -76.6544418334961, -1.33787239627299, 218, 25, 'PPL', 'P'),
(49334, 'Mays Chapel Village', 39.4500007629395, 0.688532403227568, -76.6569366455078, -1.33791593895681, 218, 25, 'PPL', 'P'),
(96078, 'Mays Crossing', 28.9461097717285, 0.505204921160367, -98.063606262207, -1.71153280565484, 218, 51, 'PPL', 'P'),
(4061, 'Mays Crossroads', 31.603609085083, 0.551587034047891, -87.9875030517578, -1.53567162886173, 218, 2, 'PPL', 'P'),
(66688, 'Mays Crossroads', 36.0213890075684, 0.62869183932376, -78.1141662597656, -1.36334939368317, 218, 33, 'PPL', 'P'),
(4062, 'Mays Gulf (historical)', 34.6041717529297, 0.603956732014241, -85.6791687011719, -1.49538359420712, 218, 2, 'PPL', 'P'),
(71099, 'Mays Landing', 39.452220916748, 0.688571152221429, -74.7280578613281, -1.30425065330101, 218, 37, 'PPL', 'P'),
(37110, 'Mays Lick', 38.5175018310547, 0.672257226594849, -83.8419418334961, -1.46331793626008, 218, 21, 'PPL', 'P'),
(150621, 'Mays Mills', 42.6672210693359, 0.744683490336208, -76.9941711425781, -1.34380179128199, 218, 40, 'PPL', 'P'),
(150622, 'Mays Point', 42.997501373291, 0.750447969094712, -76.7655563354492, -1.33981171017878, 218, 40, 'PPL', 'P'),
(88885, 'Mays Subdivision', 36.1338882446289, 0.630655321416449, -82.8133316040039, -1.44536530103575, 218, 50, 'PPL', 'P'),
(110337, 'Maysel', 38.4858283996582, 0.671704420931576, -81.1127777099609, -1.41568503647708, 218, 58, 'PPL', 'P'),
(96077, 'Maysfield', 30.8969402313232, 0.539253335828489, -96.850830078125, -1.69036586815284, 218, 51, 'PPL', 'P'),
(22941, 'Maysie (historical)', 31.8655605316162, 0.556158949270258, -82.5380630493164, -1.44056095842924, 218, 13, 'PPL', 'P'),
(17059, 'Maysland', 30.5961093902588, 0.534002847160371, -83.5725021362305, -1.45861532640722, 218, 12, 'PPL', 'P'),
(82305, 'Mayson Crossroads', 33.9363899230957, 0.592301740398645, -82.121940612793, -1.43329825182049, 218, 48, 'PPL', 'P'),
(4063, 'Maysville', 34.769718170166, 0.606846062059895, -86.4302825927734, -1.50849300467304, 218, 2, 'PPL', 'P'),
(10371, 'Maysville', 36.4036102294922, 0.635362858117327, -94.6016693115234, -1.65111060736896, 218, 4, 'PPL', 'P'),
(22942, 'Maysville', 34.2527809143066, 0.597823804918925, -83.5616683959961, -1.45842624196982, 218, 13, 'PPL', 'P'),
(27843, 'Maysville', 39.7075004577637, 0.693026620725132, -90.7991714477539, -1.58474449984613, 218, 18, 'PPL', 'P'),
(30466, 'Maysville', 38.6477813720703, 0.674531033533559, -87.2283325195313, -1.52242160349026, 218, 19, 'PPL', 'P'),
(37111, 'Maysville', 38.6411094665527, 0.674414586814895, -83.7444381713867, -1.46161617632352, 218, 21, 'PPL', 'P'),
(56146, 'Maysville', 39.8891716003418, 0.69619738031898, -94.3616714477539, -1.64692185444843, 218, 29, 'PPL', 'P'),
(66689, 'Maysville', 34.9047203063965, 0.609202293834343, -77.2316665649414, -1.34794686836065, 218, 33, 'PPL', 'P'),
(76538, 'Maysville', 34.8172187805176, 0.607675104107237, -97.4055633544922, -1.70004779029582, 218, 42, 'PPL', 'P'),
(82306, 'Maysville', 34.8108291625977, 0.60756358423659, -80.1669387817383, -1.39917703298606, 218, 48, 'PPL', 'P'),
(110333, 'Maysville', 39.1150016784668, 0.682685566212354, -79.1650009155273, -1.38168991832028, 218, 58, 'PPL', 'P'),
(116785, 'Maysville', 41.648609161377, 0.726905358742302, -90.716667175293, -1.58330452864473, 218, 16, 'PPL', 'P'),
(128098, 'Maysville', 46.7780609130859, 0.816431180631815, -67.9702835083008, -1.18630524073385, 218, 26, 'PPL', 'P'),
(156382, 'Maysville', 40.6972198486328, 0.710300482766631, -81.7927780151367, -1.42755328071697, 218, 41, 'PPL', 'P'),
(164324, 'Maysville', 41.4044418334961, 0.722643834944985, -80.4527816772461, -1.40416593265611, 218, 45, 'PPL', 'P'),
(187038, 'Maysville', 38.5386085510254, 0.672625608352634, -106.189720153809, -1.85336024845534, 218, 7, 'PPL', 'P'),
(10372, 'Maysville (historical)', 35.9288902282715, 0.627077431070954, -90.4816665649414, -1.5792029942499, 218, 4, 'PPL', 'P'),
(22943, 'Maysville (historical)', 33.5230598449707, 0.585087769637839, -82.116943359375, -1.43321103329479, 218, 13, 'PPL', 'P'),
(200061, 'Maysville (historical)', 40.4066696166992, 0.705229424576956, -116.826110839844, -2.03900028645511, 218, 39, 'PPL', 'P'),
(123153, 'Maysville Crossing', 40.3308296203613, 0.70390576693616, -87.147216796875, -1.52100586705478, 218, 19, 'PPL', 'P'),
(10373, 'Mayton', 33.3763885498047, 0.582527872619027, -93.7358322143555, -1.63599889923747, 218, 4, 'PPL', 'P'),
(60811, 'Mayton', 32.1066703796387, 0.560367109977233, -89.7472229003906, -1.56638453413307, 218, 30, 'PPL', 'P'),
(110334, 'Mayton (historical)', 38.6897201538086, 0.675263003359167, -80.289436340332, -1.40131501870918, 218, 58, 'PPL', 'P'),
(4064, 'Maytown', 33.535831451416, 0.585310676221078, -86.9972229003906, -1.51838797970323, 218, 2, 'PPL', 'P'),
(17060, 'Maytown', 28.8069400787354, 0.502775951798646, -80.9602813720703, -1.41302347328366, 218, 12, 'PPL', 'P'),
(37112, 'Maytown', 37.8488883972168, 0.660587720751313, -83.4719390869141, -1.4568601700908, 218, 21, 'PPL', 'P'),
(104093, 'Maytown', 36.9377784729004, 0.644685852724395, -82.4622192382813, -1.43923723420942, 218, 53, 'PPL', 'P'),
(120551, 'Maytown', 41.6283302307129, 0.726551424633431, -89.3677825927734, -1.55976205145037, 218, 18, 'PPL', 'P'),
(164326, 'Maytown', 40.0997200012207, 0.699872143149126, -76.8727798461914, -1.34168311347678, 218, 45, 'PPL', 'P'),
(208061, 'Maytown', 46.8977813720703, 0.818520696823091, -122.942222595215, -2.14574657400627, 218, 56, 'PPL', 'P'),
(10374, 'Mayview', 34.209171295166, 0.59706267347938, -91.3566665649414, -1.59447462520485, 218, 4, 'PPL', 'P'),
(56147, 'Mayview', 39.0530586242676, 0.681604455967836, -93.8302764892578, -1.63764726279417, 218, 29, 'PPL', 'P'),
(120552, 'Mayview', 40.1133308410645, 0.700109697118361, -88.1102828979492, -1.53781454143286, 218, 18, 'PPL', 'P'),
(208062, 'Mayview', 46.6311111450195, 0.813866423344014, -117.464721679688, -2.05014614824931, 218, 56, 'PPL', 'P'),
(88886, 'Mayview Heights', 36.0461082458496, 0.629123271420353, -84.0097198486328, -1.46624621503667, 218, 50, 'PPL', 'P'),
(14187, 'Mayview Manor', 39.7036094665527, 0.692958710117335, -75.5477828979492, -1.31855755415108, 218, 10, 'PPL', 'P'),
(66691, 'Mayview Park', 36.1302795410156, 0.630592337656668, -81.686393737793, -1.42569652480496, 218, 33, 'PPL', 'P'),
(71100, 'Mayville', 39.0672187805176, 0.681851597316996, -74.8319396972656, -1.30606373337113, 218, 37, 'PPL', 'P'),
(128096, 'Mayville', 44.4205589294434, 0.775285008894954, -70.7983322143555, -1.23566400206127, 218, 26, 'PPL', 'P'),
(131996, 'Mayville', 43.3369407653809, 0.756372304097647, -83.3525009155273, -1.45477558074754, 218, 27, 'PPL', 'P'),
(136778, 'Mayville', 43.7638893127441, 0.763823961985744, -92.9091720581055, -1.62157095771586, 218, 28, 'PPL', 'P'),
(140466, 'Mayville', 47.4980583190918, 0.828997505972435, -97.3241729736328, -1.69862726017037, 218, 34, 'PPL', 'P'),
(150623, 'Mayville', 42.2538909912109, 0.737469519575401, -79.5047225952148, -1.38761918017123, 218, 40, 'PPL', 'P'),
(164327, 'Mayville', 41.0872192382813, 0.717107256196764, -80.3125, -1.40171755550795, 218, 45, 'PPL', 'P'),
(175218, 'Mayville', 43.4941711425781, 0.759116491863892, -88.5447235107422, -1.54539696053048, 218, 57, 'PPL', 'P'),
(201196, 'Mayville', 45.0825004577637, 0.786838068019827, -120.191108703613, -2.09773057850047, 218, 43, 'PPL', 'P'),
(66692, 'Mayville Crossing', 34.7069396972656, 0.605750371008409, -78.8427810668945, -1.37606612104636, 218, 33, 'PPL', 'P'),
(150624, 'Mayweed Corner', 42.8311080932617, 0.747543858505007, -77.4147186279297, -1.35114172956236, 218, 40, 'PPL', 'P'),
(30467, 'Maywood', 39.7261085510254, 0.693351393220067, -86.2158279418945, -1.50475006491899, 218, 19, 'PPL', 'P'),
(33222, 'Maywood', 39.1277809143066, 0.682908605953648, -94.8249969482422, -1.6550084099404, 218, 20, 'PPL', 'P'),
(37113, 'Maywood', 37.480281829834, 0.654154322506008, -84.616943359375, -1.47684426459465, 218, 21, 'PPL', 'P'),
(56149, 'Maywood', 39.9541702270508, 0.697331820364327, -91.6030578613281, -1.59877496457505, 218, 29, 'PPL', 'P'),
(60812, 'Maywood', 34.9708290100098, 0.610356108376619, -89.8472213745117, -1.56812983675345, 218, 30, 'PPL', 'P'),
(112637, 'Maywood', 37.9716682434082, 0.662730633322445, -80.8152770996094, -1.41049267129976, 218, 58, 'PPL', 'P'),
(120553, 'Maywood', 41.8791694641113, 0.730929395149412, -87.8430633544922, -1.53315068057386, 218, 18, 'PPL', 'P'),
(131997, 'Maywood', 45.836669921875, 0.800000808286571, -86.9866714477539, -1.51820382211385, 218, 27, 'PPL', 'P'),
(145718, 'Maywood', 40.9025001525879, 0.713883299960142, -74.0622177124023, -1.29262955041028, 218, 37, 'PPL', 'P'),
(150626, 'Maywood', 40.7224998474121, 0.71074170198023, -73.4250030517578, -1.28150805654006, 218, 40, 'PPL', 'P'),
(183158, 'Maywood', 33.9866714477539, 0.593179318556854, -118.184440612793, -2.06270761332094, 218, 6, 'PPL', 'P'),
(199519, 'Maywood', 40.6575012207031, 0.709607261934883, -100.621673583984, -1.75617950290753, 218, 35, 'PPL', 'P'),
(208063, 'Maywood', 47.230281829834, 0.824323924575455, -121.633888244629, -2.1229118318716, 218, 56, 'PPL', 'P'),
(170840, 'Maywood (historical)', 43.5138893127441, 0.759460638855758, -97.9458312988281, -1.70947724476746, 218, 49, 'PPL', 'P'),
(201197, 'Maywood Park', 45.5530586242676, 0.795050857347468, -122.559173583984, -2.13906110756379, 218, 43, 'PPL', 'P'),
(140470, 'Maza', 48.3936080932617, 0.844627798147192, -99.1980590820313, -1.73133274256931, 218, 34, 'PPL', 'P'),
(208064, 'Mazama', 48.5922203063965, 0.848094235201066, -120.402778625488, -2.10142491556462, 218, 56, 'PPL', 'P'),
(10375, 'Mazarn', 34.4308280944824, 0.600931314436884, -93.4336090087891, -1.6307241092244, 218, 4, 'PPL', 'P'),
(198592, 'Mazda', 46.285831451416, 0.807840155850355, -103.861106872559, -1.81271827969186, 218, 34, 'PPL', 'P'),
(164328, 'Maze', 40.6122207641602, 0.708816968881402, -77.1958312988281, -1.34732142497864, 218, 45, 'PPL', 'P'),
(66693, 'Mazeppa', 35.6416702270508, 0.622064496372071, -80.7808303833008, -1.40989146268367, 218, 33, 'PPL', 'P'),
(136781, 'Mazeppa', 44.2730598449707, 0.772710664227229, -92.5447235107422, -1.61521013061026, 218, 28, 'PPL', 'P'),
(164329, 'Mazeppa', 40.9836082458496, 0.715298903237573, -76.9886093139648, -1.34370471906026, 218, 45, 'PPL', 'P'),
(37114, 'Mazie', 38.0269393920898, 0.663695296848299, -82.9725036621094, -1.44814337752686, 218, 21, 'PPL', 'P'),
(76539, 'Mazie', 36.1074981689453, 0.630194727705919, -95.3630599975586, -1.66439938173429, 218, 42, 'PPL', 'P'),
(175221, 'Mazomanie', 43.1766700744629, 0.753575052846683, -89.7947235107422, -1.56721357618041, 218, 57, 'PPL', 'P'),
(120555, 'Mazon', 41.2413902282715, 0.719798047583153, -88.4194412231445, -1.54321037211747, 218, 18, 'PPL', 'P'),
(120557, 'Mazonia', 41.209171295166, 0.719235721118983, -88.2811126708984, -1.54079608343126, 218, 18, 'PPL', 'P'),
(200062, 'Mazuma (historical)', 40.4550018310547, 0.706072980852239, -118.76277923584, -2.07280152648456, 218, 39, 'PPL', 'P'),
(56150, 'Mazzaville Resort', 37.9105606079102, 0.661664103884895, -92.0416717529297, -1.60643022112848, 218, 29, 'PPL', 'P'),
(210603, 'MÃƒÂ¤Ã‚â€˜ili', 21.4219398498535, 0.373883382544124, -158.180282592773, -2.76076674297897, 218, 15, 'PPL', 'P'),
(210598, 'MÃƒÂ¤hukona', 20.1875, 0.352338342746355, -155.902496337891, -2.72101187317459, 218, 15, 'PPL', 'P'),
(210606, 'MÃƒÂ¤kaha', 21.4694404602051, 0.374712424591465, -158.217498779297, -2.76141628796884, 218, 15, 'PPL', 'P'),
(210608, 'MÃƒÂ¤kaha Valley', 21.4822196960449, 0.374935464332759, -158.203887939453, -2.7611787339996, 218, 15, 'PPL', 'P'),
(210644, 'MÃƒÂ¤laÃ‚â€˜e', 21.4283294677734, 0.373994902414771, -157.76611328125, -2.75353812483217, 218, 15, 'PPL', 'P'),
(210653, 'MÃƒÂ¤nÃƒÂ¤', 22.0380592346191, 0.384636694393646, -159.772216796875, -2.78855123631566, 218, 15, 'PPL', 'P'),
(210711, 'MÃƒÂ¶Ã‚â€˜iliÃ‚â€˜ili', 21.2905597686768, 0.371590367556052, -157.829162597656, -2.75463854299459, 218, 15, 'PPL', 'P'),
(210735, 'MÃƒÂ¼Ã‚â€˜olea', 20.6897201538086, 0.361103738000188, -156.020278930664, -2.72306756722003, 218, 15, 'PPL', 'P'),
(195299, 'Mc Arthur', 48.523609161377, 0.846896744816912, -116.432502746582, -2.0321305292652, 218, 17, 'PPL', 'P'),
(164330, 'Mc Gregor', 40.938060760498, 0.714503949652185, -79.2205581665039, -1.38265957527318, 218, 45, 'PPL', 'P'),
(104094, 'McAdam', 37.0302810668945, 0.646300327556228, -80.7249984741211, -1.40891701204081, 218, 53, 'PPL', 'P'),
(208065, 'McAdam', 46.6969413757324, 0.815015377617301, -118.421112060547, -2.06683830932971, 218, 56, 'PPL', 'P'),
(60813, 'McAdams', 33.021110534668, 0.576327101494941, -89.6883316040039, -1.56535668711036, 218, 30, 'PPL', 'P'),
(164331, 'McAdams', 40.3861083984375, 0.704870563620068, -80.2680587768555, -1.40094190984046, 218, 45, 'PPL', 'P'),
(66695, 'McAdenville', 35.2591705322266, 0.615388617309515, -81.0755615234375, -1.41503549148721, 218, 33, 'PPL', 'P'),
(4065, 'McAding', 33.5611114501953, 0.585751895434677, -85.8311080932617, -1.49803543686257, 218, 2, 'PPL', 'P'),
(164332, 'McAdoo', 40.9099998474121, 0.714014194327719, -75.9916687011719, -1.32630482292017, 218, 45, 'PPL', 'P'),
(191844, 'McAdoo', 33.7338905334473, 0.588767459316001, -101.005828857422, -1.76288427726791, 218, 51, 'PPL', 'P'),
(191845, 'McAdoo Acres Colonia', 31.6380596160889, 0.552188309243004, -106.250556945801, -1.85442205078195, 218, 51, 'PPL', 'P'),
(66696, 'McAdoo Heights', 36.100830078125, 0.630078347566283, -79.7855606079102, -1.39252072815752, 218, 33, 'PPL', 'P'),
(164333, 'McAdoo Heights', 40.8916702270508, 0.713694282101773, -75.9952774047852, -1.32636780667995, 218, 45, 'PPL', 'P'),
(4066, 'McAdory', 33.3869400024414, 0.582712030208406, -87.0152816772461, -1.51870316481824, 218, 2, 'PPL', 'P'),
(37116, 'McAfee', 37.8505592346191, 0.660616882365249, -84.851936340332, -1.48094566583142, 218, 21, 'PPL', 'P'),
(60814, 'McAfee', 32.7425003051758, 0.571464435660565, -89.4961090087891, -1.56200176992713, 218, 30, 'PPL', 'P'),
(145720, 'McAfee', 41.1783294677734, 0.718697429683651, -74.5408325195313, -1.30098295464348, 218, 37, 'PPL', 'P'),
(76541, 'McAlester', 34.9333305358887, 0.609701636538732, -95.7694396972656, -1.67149204550745, 218, 42, 'PPL', 'P'),
(164335, 'McAlevys Fort', 40.639720916748, 0.709296937088862, -77.831672668457, -1.35841895039906, 218, 45, 'PPL', 'P'),
(188991, 'McAlister', 34.6922187805176, 0.605493442542244, -103.775833129883, -1.81122997211667, 218, 38, 'PPL', 'P'),
(164336, 'McAlisters Crossroads', 40.5155601501465, 0.707129922909864, -80.2683334350586, -1.40094670353042, 218, 45, 'PPL', 'P'),
(164337, 'McAlisterville', 40.6361083984375, 0.709233886750054, -77.2750015258789, -1.34870320611023, 218, 45, 'PPL', 'P'),
(187796, 'McAllaster', 39.0061111450195, 0.680785067879446, -101.39111328125, -1.76960875902036, 218, 20, 'PPL', 'P'),
(96079, 'McAllen', 26.2030601501465, 0.457329673718176, -98.2297210693359, -1.71443205597556, 218, 51, 'PPL', 'P'),
(175224, 'McAllister', 45.327220916748, 0.791109245776096, -87.7211074829102, -1.53102214907262, 218, 57, 'PPL', 'P'),
(196995, 'McAllister', 45.4444389343262, 0.793155086125495, -111.731391906738, -1.95008066660873, 218, 31, 'PPL', 'P'),
(88887, 'McAllister Hill', 35.0280609130859, 0.611354993522481, -84.3461074829102, -1.47211728681781, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(88888, 'McAllisters Crossroads', 36.3525009155273, 0.634470832310205, -87.3499984741211, -1.52454507498544, 218, 50, 'PPL', 'P'),
(10378, 'McAlmont', 34.8083305358887, 0.60751997497374, -92.1816711425781, -1.60887367142863, 218, 4, 'PPL', 'P'),
(17061, 'McAlpin', 30.1388893127441, 0.526022851401516, -82.9519424438477, -1.44778451656997, 218, 12, 'PPL', 'P'),
(110336, 'McAlpin', 37.6916694641113, 0.657843732722149, -81.2780609130859, -1.41856977256986, 218, 58, 'PPL', 'P'),
(49335, 'McAlpine', 39.2602806091309, 0.685221161886218, -76.8313903808594, -1.3409607310311, 218, 25, 'PPL', 'P'),
(88889, 'McAndore Estates', 35.9230613708496, 0.626975698317313, -86.5238876342773, -1.51012672084375, 218, 50, 'PPL', 'P'),
(37115, 'McAndrews', 37.5736083984375, 0.655783178407728, -82.2683334350586, -1.43585328857031, 218, 21, 'PPL', 'P'),
(10379, 'McArthur', 33.6894416809082, 0.587991680490461, -91.334716796875, -1.59409152948204, 218, 4, 'PPL', 'P'),
(73401, 'McArthur', 39.2463912963867, 0.684978747647994, -82.4786071777344, -1.43952325771049, 218, 41, 'PPL', 'P'),
(140472, 'McArthur', 48.8763885498047, 0.853053906678148, -97.2275009155273, -1.69694001446175, 218, 34, 'PPL', 'P'),
(193770, 'McArthur', 41.3316688537598, 0.721373706842099, -120.536392211914, -2.10375691257315, 218, 6, 'PPL', 'P'),
(66697, 'McArthur Crossroads', 34.7180595397949, 0.605944448872849, -79.4883270263672, -1.3873330235121, 218, 33, 'PPL', 'P'),
(66698, 'McArthur Estates', 34.8416709899902, 0.608101875671922, -77.4691696166992, -1.35209207859735, 218, 33, 'PPL', 'P'),
(49336, 'McAuley Park', 39.0191688537598, 0.68101296788973, -77.1800003051758, -1.34704512201555, 218, 25, 'PPL', 'P'),
(73402, 'McAvan', 39.392219543457, 0.687523930701783, -81.5741729736328, -1.42373790298127, 218, 41, 'PPL', 'P'),
(183159, 'McAvoy', 38.0386085510254, 0.663898962092663, -121.959167480469, -2.12858902552538, 218, 6, 'PPL', 'P'),
(131998, 'McBain', 44.1936111450195, 0.771324022826652, -85.2133331298828, -1.48725322971522, 218, 27, 'PPL', 'P'),
(56151, 'McBaine', 38.8869400024414, 0.678705139068094, -92.4463882446289, -1.61349385644576, 218, 29, 'PPL', 'P'),
(22944, 'McBean', 33.2433280944824, 0.580205529569451, -81.9508285522461, -1.43031178297407, 218, 13, 'PPL', 'P'),
(82308, 'McBee', 34.4688911437988, 0.601595639970804, -80.2561111450195, -1.40073338432711, 218, 48, 'PPL', 'P'),
(37117, 'McBrayer', 37.9752807617188, 0.662793683661252, -84.8855590820313, -1.48153249337762, 218, 21, 'PPL', 'P'),
(22946, 'McBride', 33.3925018310547, 0.58280910243014, -84.7794418334961, -1.47968039799753, 218, 13, 'PPL', 'P'),
(42021, 'McBride', 29.6630592346191, 0.517718049858213, -90.8197174072266, -1.58510309448691, 218, 22, 'PPL', 'P'),
(56152, 'McBride', 37.8327789306641, 0.660306557519227, -89.8399963378906, -1.56800373607584, 218, 29, 'PPL', 'P'),
(60815, 'McBride', 31.7655601501465, 0.55441361336036, -90.7822189331055, -1.58444862264902, 218, 30, 'PPL', 'P'),
(76542, 'McBride', 33.9352798461914, 0.592282365901715, -96.633056640625, -1.68656500464508, 218, 42, 'PPL', 'P'),
(116786, 'McBride', 41.4319381713867, 0.723123736573417, -93.9355621337891, -1.63948484394633, 218, 16, 'PPL', 'P'),
(132000, 'McBride', 43.3541717529297, 0.756673041563745, -85.0427780151367, -1.48427648140678, 218, 27, 'PPL', 'P'),
(164338, 'McBride', 40.7975006103516, 0.712050712235031, -79.9247207641602, -1.39494953107167, 218, 45, 'PPL', 'P'),
(191846, 'McBride', 35.5180587768555, 0.619907069572998, -101.493606567383, -1.77139760432457, 218, 51, 'PPL', 'P'),
(104095, 'McBryant Corner', 37.9313888549805, 0.662027625373691, -77.4024963378906, -1.35092841035904, 218, 53, 'PPL', 'P'),
(4067, 'McBrydes', 31.9922199249268, 0.558369572712105, -87.0213928222656, -1.5188098244199, 218, 2, 'PPL', 'P'),
(88890, 'McBurg', 35.1847190856934, 0.614089194434638, -86.8133316040039, -1.51517847111552, 218, 50, 'PPL', 'P'),
(196996, 'McCabe', 48.2436103820801, 0.842009844216617, -104.377220153809, -1.82172615576294, 218, 31, 'PPL', 'P'),
(82307, 'McCabe (historical)', 34.1041717529297, 0.595230085754269, -80.3255615234375, -1.40194552209726, 218, 48, 'PPL', 'P'),
(49337, 'McCahill Estates', 39.1136093139648, 0.682661264867407, -76.8916702270508, -1.34201281281973, 218, 25, 'PPL', 'P'),
(66701, 'McCain', 35.0605583190918, 0.61192218025564, -79.345832824707, -1.38484603052813, 218, 33, 'PPL', 'P'),
(88891, 'McCains', 35.5180587768555, 0.619907069572998, -87.0555572509766, -1.51940610618796, 218, 50, 'PPL', 'P'),
(4068, 'McCainville', 32.6527786254883, 0.569898496939599, -88.2147216796875, -1.53963734204097, 218, 2, 'PPL', 'P'),
(4069, 'McCaleb Mill', 34.8213882446289, 0.607747874984023, -86.4844436645508, -1.50943829370196, 218, 2, 'PPL', 'P'),
(42022, 'McCall', 30.1158294677734, 0.525620381181778, -91.043327331543, -1.58900582390637, 218, 22, 'PPL', 'P'),
(120558, 'McCall', 40.4527816772461, 0.706034231858378, -91.1969375610352, -1.59168682817575, 218, 18, 'PPL', 'P'),
(195300, 'McCall', 44.9111099243164, 0.783846738904423, -116.097778320313, -2.02628848593995, 218, 17, 'PPL', 'P'),
(60816, 'McCall Creek', 31.5125007629395, 0.549996893850519, -90.6986083984375, -1.58298934352972, 218, 30, 'PPL', 'P'),
(104097, 'McCall Gap', 36.8111114501953, 0.642475096124493, -81.7655563354492, -1.4270781727785, 218, 53, 'PPL', 'P'),
(60818, 'McCall Landing', 30.5244407653809, 0.532751993685874, -88.6791687011719, -1.54774347176695, 218, 30, 'PPL', 'P'),
(104098, 'McCall Place', 37.1916694641113, 0.649117086462178, -81.581672668457, -1.42386879734884, 218, 53, 'PPL', 'P'),
(4070, 'McCalla', 33.3486099243164, 0.582043044142578, -87.0141677856445, -1.51868372374228, 218, 2, 'PPL', 'P'),
(22945, 'McCallie', 34.2586097717285, 0.597925537672566, -84.7649993896484, -1.47942832980035, 218, 13, 'PPL', 'P'),
(82309, 'McCalls Corner', 32.7313919067383, 0.571270557533208, -79.9652786254883, -1.39565739928942, 218, 48, 'PPL', 'P'),
(82310, 'McCalls Crossroads (historical)', 34.2733306884766, 0.598182466138731, -79.7044372558594, -1.39110485856398, 218, 48, 'PPL', 'P'),
(116787, 'McCallsburg', 42.166389465332, 0.735942329848295, -93.3855590820313, -1.62988547979714, 218, 16, 'PPL', 'P'),
(60817, 'McCallum', 31.2374992370605, 0.545197211775923, -89.2125015258789, -1.55705188556705, 218, 30, 'PPL', 'P'),
(164339, 'McCalmont', 40.8194389343262, 0.712433608220757, -79.9447174072266, -1.39529853833253, 218, 45, 'PPL', 'P'),
(17062, 'McCaln', 30.4488906860352, 0.531433396051148, -84.4027786254883, -1.47310638484666, 218, 12, 'PPL', 'P'),
(191847, 'McCamey', 31.1358299255371, 0.543422747541603, -102.223892211914, -1.78414349330169, 218, 51, 'PPL', 'P'),
(195301, 'McCammon', 42.6505584716797, 0.744392673145171, -112.192222595215, -1.95812367941688, 218, 17, 'PPL', 'P'),
(183160, 'McCampbell', 33.9713897705078, 0.592912602973682, -118.112503051758, -2.06145206602502, 218, 6, 'PPL', 'P'),
(156385, 'McCance', 40.6977806091309, 0.710310269883637, -81.8841705322266, -1.42914838105187, 218, 41, 'PPL', 'P'),
(164341, 'McCance', 40.2708282470703, 0.702858545416513, -79.2975006103516, -1.38400247425285, 218, 45, 'PPL', 'P'),
(193771, 'McCann', 40.3236083984375, 0.703779732837572, -123.834999084473, -2.16132846322821, 218, 6, 'PPL', 'P'),
(56153, 'McCann Landing', 38.8647193908691, 0.678317316234352, -90.5972213745117, -1.58121980614341, 218, 29, 'PPL', 'P'),
(140473, 'McCanna', 48.0058288574219, 0.837859773710919, -97.709716796875, -1.70535626929668, 218, 34, 'PPL', 'P'),
(49338, 'McCanns Corner', 39.6261100769043, 0.691606090599683, -76.2763900756836, -1.33127414835621, 218, 25, 'PPL', 'P'),
(175, 'McCansland (historical)', 38.6602783203125, 0.674749146426836, -81.9583282470703, -1.43044267734165, 218, 58, 'PPL', 'P'),
(209591, 'McCargar Place', 42.2011108398438, 0.736548332154343, -107.131942749023, -1.86980513502852, 218, 59, 'PPL', 'P'),
(60819, 'McCarley', 33.5230598449707, 0.585087769637839, -89.8338928222656, -1.56789720963224, 218, 30, 'PPL', 'P'),
(37118, 'McCarr', 37.6108283996582, 0.656432789976625, -82.1699981689453, -1.43413701440581, 218, 21, 'PPL', 'P'),
(164345, 'McCarroll Corner', 41.4661102294922, 0.72372015149954, -76.2561111450195, -1.33092021424733, 218, 45, 'PPL', 'P'),
(132001, 'McCarron', 46.3319396972656, 0.80864489655275, -84.2808303833008, -1.47097798650347, 218, 27, 'PPL', 'P'),
(208067, 'McCarteney', 47.5263900756836, 0.829491988407836, -119.721389770508, -2.08953243655882, 218, 56, 'PPL', 'P'),
(195302, 'McCarthy', 47.4930610656738, 0.828910287446735, -115.908889770508, -2.02299175882654, 218, 17, 'PPL', 'P'),
(211985, 'McCarthy', 61.4333305358887, 1.07221388831723, -142.921676635742, -2.49445382976435, 218, 1, 'PPL', 'P'),
(104099, 'McCarthys Corner', 38.3091697692871, 0.668621146179537, -77.3977813720703, -1.35084611868136, 218, 53, 'PPL', 'P'),
(196997, 'McCarthyville (historical)', 48.2708282470703, 0.84248488557606, -113.438888549805, -1.97988210499699, 218, 31, 'PPL', 'P'),
(164343, 'McCartney', 40.8283309936523, 0.712588803933282, -78.5100021362305, -1.370258033025, 218, 45, 'PPL', 'P'),
(175225, 'McCartney', 42.6833305358887, 0.744964653568293, -90.850830078125, -1.58564611303318, 218, 57, 'PPL', 'P'),
(193772, 'McCartney Place', 40.1741714477539, 0.701171566024003, -122.560562133789, -2.13908534232971, 218, 6, 'PPL', 'P'),
(30468, 'McCarty', 39.6091690063477, 0.691310413139657, -86.1311111450195, -1.50327147788177, 218, 19, 'PPL', 'P'),
(56154, 'McCarty', 36.1177787780762, 0.630374158184364, -89.6988906860352, -1.56554097785779, 218, 29, 'PPL', 'P'),
(76543, 'McCarty', 34.670280456543, 0.605110546556518, -97.317497253418, -1.69851074687268, 218, 42, 'PPL', 'P'),
(128097, 'McCarty', 46.0711097717285, 0.804092555564396, -69.0136108398438, -1.20451473784532, 218, 26, 'PPL', 'P'),
(188992, 'McCartys', 35.0627784729004, 0.611960929249501, -107.668891906738, -1.87917666574646, 218, 38, 'PPL', 'P'),
(164344, 'McCartys Corner', 41.2916717529297, 0.720675625741362, -74.8633270263672, -1.30661154560736, 218, 45, 'PPL', 'P'),
(156386, 'McCartyville', 40.394718170166, 0.705020832484576, -84.2558288574219, -1.47054162755886, 218, 41, 'PPL', 'P'),
(10380, 'McCaskill', 33.9166717529297, 0.59195759340678, -93.6413879394531, -1.63435053568077, 218, 4, 'PPL', 'P'),
(82311, 'McCaskill', 34.1233291625977, 0.595564445629129, -80.7038879394531, -1.408548563704, 218, 48, 'PPL', 'P'),
(164348, 'McCaslin', 41.0130615234375, 0.715812959906986, -80.2569427490234, -1.40074789855505, 218, 45, 'PPL', 'P'),
(10381, 'McCauley', 34.4269409179688, 0.600863470408114, -94.3055572509766, -1.64594247695755, 218, 4, 'PPL', 'P'),
(110338, 'McCauley', 39.0422210693359, 0.681415304951413, -78.7122192382813, -1.37378738725963, 218, 58, 'PPL', 'P'),
(164347, 'McCauley', 40.9527816772461, 0.71476087811835, -76.3349990844727, -1.33229706853091, 218, 45, 'PPL', 'P'),
(183161, 'McCauley (historical)', 38.4283294677734, 0.670700875253807, -122.760559082031, -2.14257594757047, 218, 6, 'PPL', 'P'),
(136784, 'McCauleyville', 46.4416694641113, 0.810560042271653, -96.7074966430664, -1.68786422778287, 218, 28, 'PPL', 'P'),
(191848, 'McCaulley', 32.7819404602051, 0.572152796223324, -100.20361328125, -1.74888297415293, 218, 51, 'PPL', 'P'),
(116788, 'McCausland', 41.7461090087891, 0.728607052099836, -90.4430618286133, -1.57852921449411, 218, 16, 'PPL', 'P'),
(22947, 'McCaysville', 34.9861106872559, 0.610622823959791, -84.3713912963867, -1.47255857261044, 218, 13, 'PPL', 'P'),
(104103, 'McChesney Heights', 36.6141700744629, 0.639037820684555, -82.1586074829102, -1.43393820943043, 218, 53, 'PPL', 'P'),
(110339, 'McClain', 38.9947204589844, 0.680586262904072, -81.5366668701172, -1.42308329798532, 218, 58, 'PPL', 'P'),
(196998, 'McClain', 46.7061080932617, 0.815175367019788, -114.076942443848, -1.99101824625321, 218, 31, 'PPL', 'P'),
(156387, 'McClainville', 40.0233306884766, 0.698538898128405, -80.7930603027344, -1.41010491504504, 218, 41, 'PPL', 'P'),
(96080, 'McClanahan', 31.3569393157959, 0.547281834408696, -96.8283309936523, -1.68997318505011, 218, 51, 'PPL', 'P'),
(42023, 'McClane City', 30.2563896179199, 0.528073618598932, -89.771110534668, -1.56680145200172, 218, 22, 'PPL', 'P'),
(10382, 'McClaren', 35.3252792358398, 0.616542431851792, -92.6780624389648, -1.61753733392882, 218, 4, 'PPL', 'P'),
(164350, 'McClarran', 40.3250007629395, 0.703804034182519, -79.4683303833008, -1.38698401625125, 218, 45, 'PPL', 'P'),
(187039, 'McClave', 38.1375007629395, 0.665624956795143, -102.849998474121, -1.79507110904456, 218, 7, 'PPL', 'P'),
(196999, 'McClave', 46.8086090087891, 0.816964345482049, -109.773330688477, -1.91590605139445, 218, 31, 'PPL', 'P'),
(113689, 'McClaveville', 42.0397186279297, 0.733731506669366, -73.0966720581055, -1.27577759966448, 218, 8, 'PPL', 'P'),
(27844, 'McClay Orchard', 39.4666709899902, 0.68882335357666, -90.5250015258789, -1.57995933199948, 218, 18, 'PPL', 'P'),
(49339, 'McCleans Corner', 39.1980590820313, 0.684135191372711, -76.1897201538086, -1.32976147285704, 218, 25, 'PPL', 'P'),
(164349, 'McCleary', 40.6088905334473, 0.708758845390611, -80.4005584716797, -1.40325446577303, 218, 45, 'PPL', 'P'),
(208068, 'McCleary', 47.0533294677734, 0.821235523238318, -123.264167785645, -2.15136557759023, 218, 56, 'PPL', 'P'),
(208069, 'McCleary Junction', 47.0683288574219, 0.821497311973472, -123.271110534668, -2.15148675141982, 218, 56, 'PPL', 'P'),
(110340, 'McClellan', 39.5536117553711, 0.69034075618676, -80.2852783203125, -1.40124244756948, 218, 58, 'PPL', 'P'),
(78705, 'McClellan Heights', 39.9469413757324, 0.697205653107684, -76.7330627441406, -1.33924459002465, 218, 45, 'PPL', 'P'),
(193773, 'McClellan Place', 40.4872207641602, 0.706635307316409, -123.418891906738, -2.15406602293557, 218, 6, 'PPL', 'P'),
(10384, 'McClelland', 35.1041717529297, 0.612683378274212, -91.4066696166992, -1.59534734309406, 218, 4, 'PPL', 'P'),
(96081, 'McClelland', 31.663330078125, 0.552629362009035, -94.0777816772461, -1.64196704324034, 218, 51, 'PPL', 'P'),
(116789, 'McClelland', 41.3294410705566, 0.721334824690183, -95.6836090087891, -1.66999401739428, 218, 16, 'PPL', 'P'),
(194317, 'McClellands', 40.5280609130859, 0.707348102382169, -105.080276489258, -1.83399680364354, 218, 7, 'PPL', 'P'),
(78706, 'McClellandtown', 39.8869400024414, 0.696158431588038, -79.866943359375, -1.39394112512491, 218, 45, 'PPL', 'P'),
(14188, 'McClellandville', 39.7094383239746, 0.693060442870976, -75.7772216796875, -1.32256201632417, 218, 10, 'PPL', 'P'),
(82312, 'McClellanville', 33.0880584716797, 0.577495563423214, -79.4613876342773, -1.38686284242165, 218, 48, 'PPL', 'P'),
(10385, 'McClendons Corner', 35.5400009155273, 0.620290032137751, -90.2313919067383, -1.57483487742995, 218, 4, 'PPL', 'P'),
(22948, 'McClenney Estates', 33.5166702270508, 0.584976249767192, -84.5141677856445, -1.47505049244242, 218, 13, 'PPL', 'P'),
(73403, 'McClimansville', 39.7286109924316, 0.693395069061944, -83.2716674804688, -1.45336477116007, 218, 41, 'PPL', 'P'),
(164351, 'McClintock', 41.4561080932617, 0.723545581290086, -79.688606262207, -1.39082855560088, 218, 45, 'PPL', 'P'),
(178606, 'McClintock Manor', 33.3894386291504, 0.582755639471256, -111.904716491699, -1.95310575129095, 218, 5, 'PPL', 'P'),
(156388, 'McClintocksburg', 41.1697196960449, 0.718547160819143, -81.0158309936523, -1.4139929970785, 218, 41, 'PPL', 'P'),
(88892, 'McCloud', 36.3666687011719, 0.634718106817419, -82.9700012207031, -1.44809970168498, 218, 50, 'PPL', 'P'),
(110341, 'McCloud', 37.9233283996582, 0.661886943889108, -82.1944427490234, -1.43456365281244, 218, 58, 'PPL', 'P'),
(193774, 'McCloud', 41.2558288574219, 0.720050049201302, -122.138328552246, -2.13171597611929, 218, 6, 'PPL', 'P'),
(197000, 'McCloud', 46.9008293151855, 0.818573893465865, -105.599716186523, -1.84306273662638, 218, 31, 'PPL', 'P'),
(113008, 'McCloy (historical)', 42.2316703796387, 0.737081696741658, -95.1630630493164, -1.66090877649353, 218, 16, 'PPL', 'P'),
(60820, 'McCluney (historical)', 34.0347213745117, 0.59401794798412, -88.5541687011719, -1.54556181020196, 218, 30, 'PPL', 'P'),
(104100, 'McClung', 38.0530586242676, 0.664151163447893, -79.6930618286133, -1.39090631990471, 218, 53, 'PPL', 'P'),
(110342, 'McClung (historical)', 38.0377807617188, 0.663884514443749, -80.726936340332, -1.40895083418666, 218, 58, 'PPL', 'P'),
(104101, 'McClung Mill', 37.9352798461914, 0.662095535981488, -79.3436126708984, -1.38480728153427, 218, 53, 'PPL', 'P'),
(4073, 'McClure', 32.8463897705078, 0.573277648888746, -87.8422164916992, -1.53313590002981, 218, 2, 'PPL', 'P'),
(22949, 'McClure', 34.2425003051758, 0.59764437444048, -83.9333267211914, -1.46491290343693, 218, 13, 'PPL', 'P'),
(27846, 'McClure', 37.3177795410156, 0.651318122524101, -89.4313888549805, -1.56087219015077, 218, 18, 'PPL', 'P'),
(37119, 'McClure', 37.764720916748, 0.659118721094025, -82.4872207641602, -1.43967359315403, 218, 21, 'PPL', 'P'),
(42024, 'McClure', 30.5472202301025, 0.533149570347109, -91.8319396972656, -1.60276970621017, 218, 22, 'PPL', 'P'),
(76545, 'McClure', 35.6513900756836, 0.622234139733509, -99.3052825927734, -1.73320414586731, 218, 42, 'PPL', 'P'),
(104102, 'McClure', 37.1025009155273, 0.647560801700163, -82.3763885498047, -1.43773920609625, 218, 53, 'PPL', 'P'),
(132002, 'McClure', 44.0377807617188, 0.768604269563409, -84.4272232055664, -1.4735330232533, 218, 27, 'PPL', 'P'),
(150627, 'McClure', 42.0483283996582, 0.733881775533874, -75.4872207641602, -1.31750054551442, 218, 40, 'PPL', 'P'),
(156389, 'McClure', 41.3713912963867, 0.722066994252873, -83.9419403076172, -1.46506323888046, 218, 41, 'PPL', 'P'),
(164353, 'McClure', 40.103889465332, 0.699944914025912, -79.5541687011719, -1.38848217752247, 218, 45, 'PPL', 'P'),
(66703, 'McClure Mill', 35.0819396972656, 0.612295355703388, -83.3894424438477, -1.45542033204745, 218, 33, 'PPL', 'P'),
(42025, 'McClure Place', 30.5702800750732, 0.533552040566847, -91.2050018310547, -1.59182757623936, 218, 22, 'PPL', 'P'),
(193776, 'McClure Place', 40.2675018310547, 0.70280048850475, -121.824172973633, -2.12623292690898, 218, 6, 'PPL', 'P'),
(4072, 'McClure Town', 31.8444404602051, 0.555790334485877, -85.9611129760742, -1.50030445011132, 218, 2, 'PPL', 'P'),
(88893, 'McClures Bend', 36.2738914489746, 0.633098838295624, -85.9002838134766, -1.49924278094276, 218, 50, 'PPL', 'P'),
(56155, 'McClurg', 36.7844390869141, 0.642009575565947, -92.7747192382813, -1.61922431332133, 218, 29, 'PPL', 'P'),
(156390, 'McClurg', 40.9952812194824, 0.715502635060964, -80.6533279418945, -1.4076661252768, 218, 41, 'PPL', 'P'),
(27848, 'McClusky', 39.0433311462402, 0.681434679448344, -90.3202819824219, -1.57638630192297, 218, 18, 'PPL', 'P'),
(198594, 'McClusky', 47.4858283996582, 0.828784053611065, -100.442779541016, -1.75305721284552, 218, 34, 'PPL', 'P'),
(88894, 'McCoinsville', 36.3158302307129, 0.633830808121232, -85.6363906860352, -1.49463697699552, 218, 50, 'PPL', 'P'),
(30469, 'McCol Place', 38.6091690063477, 0.673857120619714, -86.1144409179688, -1.50298052753268, 218, 19, 'PPL', 'P'),
(82313, 'McColl', 34.6686096191406, 0.605081384942581, -79.5455627441406, -1.38833197523699, 218, 48, 'PPL', 'P'),
(193775, 'McColl', 40.7272186279297, 0.71082406023694, -122.32861328125, -2.13503707115668, 218, 6, 'PPL', 'P'),
(96082, 'McColl Estates Colonia', 26.3190002441406, 0.459353210093445, -98.1920013427734, -1.71377372255409, 218, 51, 'PPL', 'P'),
(150628, 'McColloms', 44.5102806091309, 0.776850947615921, -74.3055572509766, -1.29687662655869, 218, 40, 'PPL', 'P'),
(4074, 'McCollum', 33.8177795410156, 0.590231598704299, -87.3252792358398, -1.52411364288884, 218, 2, 'PPL', 'P'),
(22950, 'McCollum', 33.4502792358398, 0.583817508376898, -84.7002792358398, -1.47829875002399, 218, 13, 'PPL', 'P'),
(22951, 'McCollum Acres', 34.1058311462402, 0.595259047631124, -84.6399993896484, -1.47724666823536, 218, 13, 'PPL', 'P'),
(17064, 'McColskey', 30.1888904571533, 0.526895536001222, -82.5625, -1.44098746367782, 218, 12, 'PPL', 'P'),
(17063, 'McColsky', 30.1866703033447, 0.526856787007361, -82.5491714477539, -1.4407548365566, 218, 12, 'PPL', 'P'),
(49340, 'McComas', 39.4361114501953, 0.688289988989344, -76.307502746582, -1.33181716690247, 218, 25, 'PPL', 'P'),
(110343, 'McComas', 37.3899993896484, 0.652578596668035, -81.2916717529297, -1.41880732653909, 218, 58, 'PPL', 'P'),
(49341, 'McComas Beach', 39.5016708374023, 0.689434216151697, -79.3733291625977, -1.38532593215656, 218, 25, 'PPL', 'P'),
(60821, 'McComb', 31.2436103820801, 0.545303871377581, -90.4530563354492, -1.57870365154551, 218, 30, 'PPL', 'P'),
(156391, 'McComb', 41.1074981689453, 0.717461190305636, -83.7927780151367, -1.46245986575685, 218, 41, 'PPL', 'P'),
(132004, 'McComb Corner', 46.8661117553711, 0.817967957738845, -88.1083297729492, -1.53778045297091, 218, 27, 'PPL', 'P'),
(136786, 'McComber', 47.8488883972168, 0.835120645950745, -92.0652770996094, -1.60684221214912, 218, 28, 'PPL', 'P'),
(4075, 'McCombs', 33.5633316040039, 0.585790644428538, -86.6172180175781, -1.51175564332449, 218, 2, 'PPL', 'P'),
(37120, 'McCombs', 37.6536102294922, 0.657179473767256, -82.5841674804688, -1.44136563255261, 218, 21, 'PPL', 'P'),
(82314, 'McCombs', 34.1772193908691, 0.596505007547117, -82.2244415283203, -1.43508723028275, 218, 48, 'PPL', 'P'),
(49342, 'McConchie', 38.5019416809082, 0.671985650742688, -77.0602798461914, -1.34495560582427, 218, 25, 'PPL', 'P'),
(60822, 'McCondy', 33.8222198486328, 0.590309096692021, -88.8424987792969, -1.55059411939777, 218, 30, 'PPL', 'P'),
(197002, 'McCone City (historical)', 48.0374984741211, 0.838412512795165, -106.413887023926, -1.85727269841277, 218, 31, 'PPL', 'P'),
(183163, 'McConnel Place', 38.7969398498535, 0.677134340078138, -120.446937561035, -2.10219563438409, 218, 6, 'PPL', 'P'),
(66705, 'McConnell', 35.4577789306641, 0.618854987784362, -77.0199966430664, -1.34425253129649, 218, 33, 'PPL', 'P'),
(88895, 'McConnell', 36.422779083252, 0.635697417729268, -88.8516693115234, -1.55075417537929, 218, 50, 'PPL', 'P'),
(104105, 'McConnell', 36.7311096191406, 0.641078800764964, -82.4802780151367, -1.43955241932443, 218, 53, 'PPL', 'P'),
(110344, 'McConnell', 37.8255615234375, 0.660180589999667, -81.9669418334961, -1.43059301278518, 218, 58, 'PPL', 'P'),
(120559, 'McConnell', 42.434440612793, 0.740620704935237, -89.7313919067383, -1.56610823116998, 218, 18, 'PPL', 'P'),
(104108, 'McConnell Mill', 36.6963882446289, 0.640472798458917, -82.4494400024414, -1.43901419446812, 218, 53, 'PPL', 'P'),
(82315, 'McConnells', 34.8686103820801, 0.608572056762375, -81.227783203125, -1.41769226099068, 218, 48, 'PPL', 'P'),
(164355, 'McConnells Mill', 40.9527816772461, 0.71476087811835, -80.170280456543, -1.39923535621394, 218, 45, 'PPL', 'P'),
(164356, 'McConnells Mills', 40.252498626709, 0.702538633190568, -80.2491683959961, -1.40061221049751, 218, 45, 'PPL', 'P'),
(78707, 'McConnellsburg', 39.9324989318848, 0.696953584910508, -77.9991683959961, -1.36134230232764, 218, 45, 'PPL', 'P'),
(164357, 'McConnellstown', 40.4524993896484, 0.706029305010362, -78.0819396972656, -1.36278693406095, 218, 45, 'PPL', 'P'),
(150630, 'McConnellsville', 43.2730598449707, 0.755257371707286, -75.6944427490234, -1.32111725143281, 218, 40, 'PPL', 'P'),
(73404, 'McConnelsville', 39.648609161377, 0.691998773702416, -81.8533325195313, -1.42861015619557, 218, 41, 'PPL', 'P'),
(192882, 'McConnico', 35.1438903808594, 0.61337659910596, -114.092781066895, -1.99129468237436, 218, 5, 'PPL', 'P'),
(96086, 'McCook', 26.4833297729492, 0.462221301429406, -98.3905563354492, -1.71723916092256, 218, 51, 'PPL', 'P'),
(120560, 'McCook', 41.797779083252, 0.729508865023964, -87.8447189331055, -1.53317957587169, 218, 18, 'PPL', 'P'),
(199520, 'McCook', 40.2019386291504, 0.70165619476337, -100.625282287598, -1.75624248666731, 218, 35, 'PPL', 'P'),
(170843, 'McCook Lake', 42.5416717529297, 0.742492241391291, -96.5055618286133, -1.68433980039626, 218, 49, 'PPL', 'P'),
(88896, 'McCookville', 35.7636108398438, 0.624192761557208, -83.5216674804688, -1.45772809429006, 218, 50, 'PPL', 'P'),
(60823, 'McCool', 33.2019386291504, 0.579483147123767, -89.3450012207031, -1.55936444149962, 218, 30, 'PPL', 'P'),
(123155, 'McCool', 41.5800018310547, 0.725707934937175, -87.1436080932617, -1.52094288329499, 218, 19, 'PPL', 'P'),
(142376, 'McCool Junction', 40.7441711425781, 0.711119937434048, -97.5972213745117, -1.70339285378302, 218, 35, 'PPL', 'P'),
(629, 'McCoole', 39.4463882446289, 0.688469352888761, -78.9725036621094, -1.37833020744709, 218, 25, 'PPL', 'P'),
(150629, 'McCoon Crossing', 42.8958282470703, 0.748673438281365, -75.0519409179688, -1.30990347903081, 218, 40, 'PPL', 'P'),
(73405, 'McCoppin Mill', 39.1824989318848, 0.683863615520551, -83.438606262207, -1.45627840255067, 218, 41, 'PPL', 'P'),
(76546, 'McCord', 36.6786117553711, 0.640162540191923, -97.0369415283203, -1.69361412573441, 218, 42, 'PPL', 'P'),
(175226, 'McCord', 45.5552787780762, 0.795089606341328, -89.8994369506836, -1.56904117047848, 218, 57, 'PPL', 'P'),
(211986, 'McCord', 57.1394386291504, 0.99727133681991, -153.201110839844, -2.67386380186805, 218, 1, 'PPL', 'P'),
(56156, 'McCord Bend', 36.785831451416, 0.642033876910894, -93.5038909912109, -1.6319507612225, 218, 29, 'PPL', 'P'),
(4076, 'McCord Crossroads', 34.1163902282715, 0.595443338378557, -85.459716796875, -1.49155343592737, 218, 2, 'PPL', 'P'),
(188994, 'McCord Place', 34.6986083984375, 0.605604962412891, -107.673889160156, -1.87926388427216, 218, 38, 'PPL', 'P'),
(132003, 'McCords', 42.8675003051758, 0.748179022424991, -85.4438934326172, -1.49127726612233, 218, 27, 'PPL', 'P'),
(30471, 'McCordsville', 39.9080581665039, 0.696527013082905, -85.9227828979492, -1.49963546404549, 218, 19, 'PPL', 'P'),
(104106, 'McCorkle', 36.6761093139648, 0.640118864350045, -82.3861083984375, -1.43790884945769, 218, 53, 'PPL', 'P'),
(110345, 'McCorkle', 38.2158317565918, 0.666992090540735, -81.8361129760742, -1.42830961846655, 218, 58, 'PPL', 'P'),
(4077, 'McCorkle (historical)', 32.3647193908691, 0.56487091485472, -87.5747222900391, -1.52846724548085, 218, 2, 'PPL', 'P'),
(10388, 'McCormick', 35.5977783203125, 0.62129843808451, -90.5811080932617, -1.5809385763323, 218, 4, 'PPL', 'P'),
(27850, 'McCormick', 37.5505599975586, 0.655380907925071, -88.6705627441406, -1.54759326948147, 218, 18, 'PPL', 'P'),
(82316, 'McCormick', 33.913330078125, 0.591899270178907, -82.2936096191406, -1.43629444120488, 218, 48, 'PPL', 'P'),
(164358, 'McCormick', 40.8358306884766, 0.712719698300859, -79.1091690063477, -1.38071546767742, 218, 45, 'PPL', 'P'),
(204847, 'McCormick', 40.6183280944824, 0.708923561904033, -111.850830078125, -1.95216525595199, 218, 52, 'PPL', 'P'),
(208070, 'McCormick', 46.5538902282715, 0.812518664095352, -123.324722290039, -2.15242245306882, 218, 56, 'PPL', 'P'),
(73406, 'McCormick (historical)', 38.8333282470703, 0.677769437419095, -82.3583297729492, -1.43742402098124, 218, 41, 'PPL', 'P'),
(82318, 'McCormick Crossroads', 34.4952812194824, 0.602056233681333, -79.4794387817383, -1.3871778943786, 218, 48, 'PPL', 'P'),
(120561, 'McCormick Place', 41.8527793884277, 0.730468801438883, -87.6116714477539, -1.52911212993881, 218, 18, 'PPL', 'P'),
(178607, 'McCormick Ranch', 33.5525016784668, 0.585601626570169, -111.901390075684, -1.95304769437919, 218, 5, 'PPL', 'P'),
(120562, 'McCormickville', 41.8941688537598, 0.731191183884567, -87.6255569458008, -1.52935447759801, 218, 18, 'PPL', 'P'),
(192692, 'McCornick', 39.2155609130859, 0.684440655949743, -112.407501220703, -1.96188100024081, 218, 52, 'PPL', 'P'),
(4078, 'McCosh Mill', 33.107780456543, 0.577839776994106, -85.2358322143555, -1.48764591281795, 218, 2, 'PPL', 'P'),
(104109, 'McCowan Spring', 38.103328704834, 0.66502854186902, -79.5752792358398, -1.38885062585928, 218, 53, 'PPL', 'P'),
(27849, 'McCown', 39.7991714477539, 0.694626581329024, -87.9280624389648, -1.53463419445909, 218, 18, 'PPL', 'P'),
(30470, 'McCoy', 39.3230590820313, 0.686316852937704, -85.414436340332, -1.49076314287389, 218, 19, 'PPL', 'P'),
(37121, 'McCoy', 37.6186103820801, 0.656568611192219, -86.3816680908203, -1.50764452154974, 218, 21, 'PPL', 'P'),
(73407, 'McCoy', 38.9141693115234, 0.679180380164619, -82.7077789306641, -1.44352305935168, 218, 41, 'PPL', 'P'),
(104111, 'McCoy', 38.9500007629395, 0.679805756967597, -78.2183303833008, -1.36516740060132, 218, 53, 'PPL', 'P'),
(187041, 'McCoy', 39.9161109924316, 0.696667561409434, -106.724998474121, -1.86270261755934, 218, 7, 'PPL', 'P'),
(191849, 'McCoy', 33.8680610656738, 0.591109176862508, -101.437217712402, -1.77041343314373, 218, 51, 'PPL', 'P'),
(200063, 'McCoy', 40.3202781677246, 0.703721609346781, -117.224166870117, -2.0459476747908, 218, 39, 'PPL', 'P'),
(201198, 'McCoy', 45.0422210693359, 0.786135060071073, -123.215278625488, -2.15051230077696, 218, 43, 'PPL', 'P'),
(208071, 'McCoy', 47.1858291625977, 0.823548079170888, -117.308609008789, -2.04742146813805, 218, 56, 'PPL', 'P'),
(42026, 'McCoy (historical)', 33.0022201538086, 0.575997402151989, -94.0177764892578, -1.64091975514166, 218, 22, 'PPL', 'P'),
(190465, 'McCoy (historical)', 39.374439239502, 0.687213605855761, -114.527221679688, -1.99887710147198, 218, 39, 'PPL', 'P'),
(128099, 'McCoy Crossing', 44.436939239502, 0.775570899237974, -69.64111328125, -1.21546672151216, 218, 26, 'PPL', 'P'),
(145721, 'McCoys Corner', 41.1977806091309, 0.719036916143609, -74.6305618286133, -1.3025490265225, 218, 37, 'PPL', 'P'),
(164359, 'McCoys Corners', 41.1269416809082, 0.717800543607539, -80.0966720581055, -1.39795064730408, 218, 45, 'PPL', 'P'),
(82320, 'McCoys Crossroads', 34.3819389343262, 0.600078037623622, -80.2513885498047, -1.40065095949137, 218, 48, 'PPL', 'P'),
(123156, 'McCoysburg', 40.9144401550293, 0.71409169231544, -87.0219421386719, -1.51881941179982, 218, 19, 'PPL', 'P'),
(164360, 'McCoysville', 40.4530601501465, 0.706039092127368, -77.5680618286133, -1.35381807329984, 218, 45, 'PPL', 'P'),
(164361, 'McCoytown', 41.1425018310547, 0.7180721194597, -80.0527801513672, -1.39718458901652, 218, 45, 'PPL', 'P'),
(33225, 'McCracken', 38.5805587768555, 0.673357777915324, -99.5708312988281, -1.73783884511237, 218, 20, 'PPL', 'P'),
(56157, 'McCracken', 37.0175018310547, 0.646077287814934, -93.1577835083008, -1.62591004607992, 218, 29, 'PPL', 'P'),
(164362, 'McCracken', 40.0699996948242, 0.699353425947806, -80.2383270263672, -1.40042299290206, 218, 45, 'PPL', 'P'),
(191850, 'McCracken Estates Colonia', 31.8379993438721, 0.555677915798362, -106.153999328613, -1.85273680244415, 218, 51, 'PPL', 'P'),
(22952, 'McCranie', 32.0727806091309, 0.559775621899126, -83.0841674804688, -1.45009227881258, 218, 13, 'PPL', 'P'),
(22953, 'McCrary', 34.4041709899902, 0.600466060194447, -83.8708267211914, -1.46382207265443, 218, 13, 'PPL', 'P'),
(60824, 'McCrary', 33.4638900756836, 0.584055062346133, -88.2836074829102, -1.54083962611509, 218, 30, 'PPL', 'P'),
(22954, 'McCrary Settlement', 32.9922218322754, 0.575822898521562, -84.4727783203125, -1.47432810999674, 218, 13, 'PPL', 'P'),
(66708, 'McCray', 36.1722183227539, 0.631324307482277, -79.3863906860352, -1.38555389874587, 218, 33, 'PPL', 'P'),
(164365, 'McCrays', 41.4905586242676, 0.724146856485198, -79.0950012207031, -1.3804681931702, 218, 45, 'PPL', 'P'),
(42027, 'McCrea', 30.8688907623291, 0.538763780241105, -91.789436340332, -1.60202788268853, 218, 22, 'PPL', 'P'),
(164363, 'McCrea', 40.2441711425781, 0.702393291174077, -77.4436111450195, -1.35164599911477, 218, 45, 'PPL', 'P'),
(164364, 'McCrea Furnace', 40.9261093139648, 0.714295357559804, -79.2911071777344, -1.38389088780317, 218, 45, 'PPL', 'P'),
(145722, 'McCrea Mills', 40.6616706848145, 0.70968003281167, -74.7666702270508, -1.30492456621485, 218, 37, 'PPL', 'P'),
(195303, 'McCrea Place', 45.3038902282715, 0.790702048445423, -116.476387023926, -2.0328964543947, 218, 17, 'PPL', 'P'),
(104113, 'McCready', 36.9033317565918, 0.644084644108309, -81.7363891601563, -1.42656910953613, 218, 53, 'PPL', 'P'),
(10389, 'McCreanor', 34.7833290100098, 0.60708361602913, -91.7949981689453, -1.60212495491026, 218, 4, 'PPL', 'P'),
(37124, 'McCreary', 37.6711082458496, 0.657484871765261, -84.5155563354492, -1.47507472720834, 218, 21, 'PPL', 'P'),
(82319, 'McCrearys Quarter (historical)', 34.0633316040039, 0.594517290688509, -80.6222229003906, -1.40712323988859, 218, 48, 'PPL', 'P'),
(208072, 'McCredie', 45.8208312988281, 0.799724372165421, -119.996673583984, -2.09433704548143, 218, 56, 'PPL', 'P'),
(201199, 'McCredie Springs', 43.7099990844727, 0.762883400067755, -122.287780761719, -2.13432440924897, 218, 43, 'PPL', 'P'),
(110346, 'McCreery', 37.8488883972168, 0.660587720751313, -81.0924987792969, -1.41533110236821, 218, 58, 'PPL', 'P'),
(10390, 'McCrory', 35.2561111450195, 0.615335220929659, -91.1999969482422, -1.59174022455561, 218, 4, 'PPL', 'P'),
(96087, 'McCroskey', 29.0991706848145, 0.507876338049825, -95.9594421386719, -1.67480821369681, 218, 51, 'PPL', 'P'),
(170844, 'McCroskey Addition', 43.6488914489746, 0.761816870630205, -96.6913909912109, -1.68758313112981, 218, 49, 'PPL', 'P'),
(188995, 'McCrystal Place', 36.8105583190918, 0.642465442165541, -105.144721984863, -1.83512158972993, 218, 38, 'PPL', 'P'),
(110347, 'McCuetown', 38.9497184753418, 0.67980083011958, -80.3319396972656, -1.40205684223082, 218, 58, 'PPL', 'P'),
(4079, 'McCullars (historical)', 33.7991714477539, 0.589906826209364, -85.9080581665039, -1.4993784690003, 218, 2, 'PPL', 'P'),
(66709, 'McCullen', 35.103328704834, 0.61266866430919, -78.2799987792969, -1.36624371715587, 218, 33, 'PPL', 'P'),
(66711, 'McCullers', 35.660831451416, 0.622398922825958, -78.6961135864258, -1.37350629060657, 218, 33, 'PPL', 'P'),
(66710, 'McCullers Crossroads', 35.6650009155273, 0.622471693702744, -78.6994400024414, -1.37356434751834, 218, 33, 'PPL', 'P'),
(4080, 'McCulley', 33.1391716003418, 0.578387655809363, -87.0891723632813, -1.51999280057611, 218, 2, 'PPL', 'P'),
(4083, 'McCulley Creek', 33.0872192382813, 0.577480916037218, -87.1944427490234, -1.52183011541215, 218, 2, 'PPL', 'P'),
(177243, 'McCulley Estates', 40.0402793884277, 0.698834708746485, -80.6747207641602, -1.40803950046163, 218, 58, 'PPL', 'P'),
(120563, 'McCulley Subdivision', 40.8797187805176, 0.713485690009393, -88.5999984741211, -1.54636169063537, 218, 18, 'PPL', 'P'),
(164366, 'McCullochs Mills', 40.4236106872559, 0.705525102036983, -77.5863876342773, -1.35413791894675, 218, 45, 'PPL', 'P'),
(4081, 'McCulloh', 32.7063903808594, 0.570834198588598, -85.1497192382813, -1.48614295785677, 218, 2, 'PPL', 'P'),
(183164, 'McCulloh', 38.9544410705566, 0.679883254955318, -120.525001525879, -2.10355810759778, 218, 6, 'PPL', 'P'),
(120564, 'McCullom Lake', 42.3683280944824, 0.739466823813933, -88.2925033569336, -1.54099488840664, 218, 18, 'PPL', 'P'),
(4082, 'McCullough', 31.1666698455811, 0.543961005687422, -87.5263900756836, -1.52762368920557, 218, 2, 'PPL', 'P'),
(22955, 'McCullough', 34.9697189331055, 0.610336733879689, -84.2133331298828, -1.46979993719528, 218, 13, 'PPL', 'P'),
(104112, 'McCullough', 37.7569389343262, 0.658982899878431, -78.6155624389648, -1.37210040786712, 218, 53, 'PPL', 'P'),
(164367, 'McCullough', 40.3644409179688, 0.704492394745277, -79.6388931274414, -1.38996089771774, 218, 45, 'PPL', 'P'),
(56161, 'McCullough Ford', 36.6291694641113, 0.63929960941971, -94.2527770996094, -1.6450212895365, 218, 29, 'PPL', 'P'),
(33226, 'McCune', 37.3547210693359, 0.651962873824009, -95.0163879394531, -1.65834881289569, 218, 20, 'PPL', 'P'),
(56162, 'McCune', 39.4055595397949, 0.687756757560083, -91.2458267211914, -1.59254010498901, 218, 29, 'PPL', 'P'),
(188996, 'McCune', 35.5277786254883, 0.620076712934436, -108.590278625488, -1.89525789767279, 218, 38, 'PPL', 'P'),
(73408, 'McCuneville', 39.6288909912109, 0.69165462671055, -82.2344436645508, -1.4352618004922, 218, 41, 'PPL', 'P'),
(110348, 'McCurdyville', 39.6122207641602, 0.691363676361459, -80.1727828979492, -1.39927903205581, 218, 58, 'PPL', 'P'),
(139312, 'McCurry', 40.2075004577637, 0.701753266985103, -94.4252777099609, -1.64803199314883, 218, 29, 'PPL', 'P'),
(76549, 'McCurtain', 35.1497192382813, 0.613478331859601, -94.9705581665039, -1.65754893246228, 218, 42, 'PPL', 'P'),
(30472, 'McCutchanville', 38.0641708374023, 0.664345108154278, -87.5244369506836, -1.52758960074361, 218, 19, 'PPL', 'P'),
(22956, 'McCutchen (historical)', 34.6824989318848, 0.605323799180806, -85.3916702270508, -1.49036579923925, 218, 13, 'PPL', 'P'),
(82321, 'McCutchen (historical)', 34.1783294677734, 0.596524382044048, -80.2925033569336, -1.40136854824709, 218, 48, 'PPL', 'P'),
(88898, 'McCutchen Heights', 36.3705596923828, 0.634786017425216, -89.0647201538086, -1.55447261405131, 218, 50, 'PPL', 'P'),
(82322, 'McCutchens Crossroads', 34.1458282470703, 0.595957128731861, -80.2350006103516, -1.40036493599029, 218, 48, 'PPL', 'P'),
(156392, 'McCutchenville', 40.9905586242676, 0.715420210225227, -83.2594375610352, -1.4531513187987, 218, 41, 'PPL', 'P'),
(60825, 'McCutcheon', 33.2344398498535, 0.580050400435954, -90.8797225952148, -1.58615038258558, 218, 30, 'PPL', 'P'),
(4084, 'McDade', 32.315559387207, 0.564012910930524, -86.04638671875, -1.50179275768651, 218, 2, 'PPL', 'P'),
(42028, 'McDade', 32.3233299255371, 0.564148532409036, -93.5280609130859, -1.63237260593916, 218, 22, 'PPL', 'P'),
(66712, 'McDade', 36.1891708374023, 0.631620184679384, -79.1708297729492, -1.38179165107392, 218, 33, 'PPL', 'P'),
(96089, 'McDade', 30.2836093902588, 0.528548693247888, -97.2375030517578, -1.69711458467121, 218, 51, 'PPL', 'P'),
(430, 'McDaniel', 34.5083312988281, 0.602284000533562, -84.6305618286133, -1.47708195172193, 218, 13, 'PPL', 'P'),
(10391, 'McDaniel', 35.6372184753418, 0.621986798647268, -90.8888931274414, -1.5863104385671, 218, 4, 'PPL', 'P'),
(30473, 'McDaniel', 39.4119415283203, 0.687868144272675, -86.4408264160156, -1.50867702910436, 218, 19, 'PPL', 'P'),
(49343, 'McDaniel', 38.8175010681152, 0.677493201035027, -76.2783279418945, -1.33130797050205, 218, 25, 'PPL', 'P'),
(88899, 'McDaniel', 35.8338890075684, 0.625419346976271, -86.6958312988281, -1.5131277039181, 218, 50, 'PPL', 'P'),
(96090, 'McDaniel Addition Colonia', 26.2919998168945, 0.458881963738556, -97.9720001220703, -1.70993397689441, 218, 51, 'PPL', 'P'),
(188997, 'McDaniel Cimarron Place', 36.4683303833008, 0.636492437893684, -104.84610748291, -1.82990978347665, 218, 38, 'PPL', 'P'),
(96091, 'McDaniel Colonia', 26.1889991760254, 0.457084263423725, -98.1880035400391, -1.71370394773353, 218, 51, 'PPL', 'P'),
(49344, 'McDaniel Country Estates', 38.6305618286133, 0.674230495804543, -76.9505615234375, -1.34304065984245, 218, 25, 'PPL', 'P'),
(73409, 'McDaniel Crossroad', 38.7572212219238, 0.676441119246391, -82.478889465332, -1.43952818455851, 218, 41, 'PPL', 'P'),
(14190, 'McDaniel Heights', 39.8022193908691, 0.694679777971798, -75.5483322143555, -1.318567141531, 218, 10, 'PPL', 'P'),
(22957, 'McDaniel Manor', 32.3699989318848, 0.564963060228437, -84.9674987792969, -1.48296261088299, 218, 13, 'PPL', 'P'),
(22958, 'McDaniels', 34.4550018310547, 0.601353225732579, -84.9466705322266, -1.4825990893942, 218, 13, 'PPL', 'P'),
(37125, 'McDaniels', 37.6066703796387, 0.656360218836921, -86.4250030517578, -1.50840085929932, 218, 21, 'PPL', 'P'),
(60826, 'McDaniels', 33.4861106872559, 0.584442885179876, -90.5861129760742, -1.58102592801605, 218, 30, 'PPL', 'P'),
(66713, 'McDaniels', 34.8833312988281, 0.608828985228541, -78.4472198486328, -1.36916227539449, 218, 33, 'PPL', 'P'),
(17065, 'McDavid', 30.8661098480225, 0.538715244130239, -87.3197174072266, -1.52401657066711, 218, 12, 'PPL', 'P'),
(200065, 'McDermitt', 41.997501373291, 0.732994676574768, -117.717216491699, -2.05455301406312, 218, 39, 'PPL', 'P'),
(73410, 'McDermott', 38.8347206115723, 0.677793738764042, -83.0650024414063, -1.44975778577967, 218, 41, 'PPL', 'P'),
(78710, 'McDermott', 39.7488899230957, 0.693749003170816, -76.418327331543, -1.3337514208022, 218, 45, 'PPL', 'P'),
(197003, 'McDermott (historical)', 48.913890838623, 0.853708445095063, -111.522216796875, -1.94642987222839, 218, 31, 'PPL', 'P'),
(10394, 'McDermott Addition', 35.045280456543, 0.611655531251496, -92.0641708374023, -1.60682290423122, 218, 4, 'PPL', 'P'),
(188998, 'McDermott Wells', 33.7722206115723, 0.589436445381829, -104.45361328125, -1.82305946736269, 218, 38, 'PPL', 'P'),
(10392, 'McDonald', 35.2700004577637, 0.615577635167883, -90.601936340332, -1.5813020978211, 218, 4, 'PPL', 'P'),
(17066, 'McDonald', 28.6988906860352, 0.500890134141248, -81.5741729736328, -1.42373790298127, 218, 12, 'PPL', 'P'),
(22959, 'McDonald', 33.9333305358887, 0.592248344018789, -83.4375, -1.45625909463277, 218, 13, 'PPL', 'P'),
(49345, 'McDonald', 39.4333305358887, 0.688241452878477, -77.164436340332, -1.34677347958436, 218, 25, 'PPL', 'P'),
(60828, 'McDonald', 32.6602783203125, 0.570029391307176, -89.1327819824219, -1.55566051705554, 218, 30, 'PPL', 'P'),
(66717, 'McDonald', 34.5538902282715, 0.603079153856032, -79.1758270263672, -1.38187886959962, 218, 33, 'PPL', 'P'),
(71101, 'McDonald', 39.9066696166992, 0.696502778316985, -74.545280456543, -1.30106058578926, 218, 37, 'PPL', 'P'),
(88900, 'McDonald', 35.1133308410645, 0.612843234518644, -84.982780456543, -1.48322932646616, 218, 50, 'PPL', 'P'),
(96092, 'McDonald', 33.5405616760254, 0.585393234214871, -97.8238906860352, -1.70734897958233, 218, 51, 'PPL', 'P'),
(132005, 'McDonald', 42.2652816772461, 0.737668324550776, -86.1569366455078, -1.50372221789627, 218, 27, 'PPL', 'P'),
(156393, 'McDonald', 41.1636085510254, 0.718440501217485, -80.7244415283203, -1.40890729150283, 218, 41, 'PPL', 'P'),
(164368, 'McDonald', 40.3708305358887, 0.704603914615924, -80.2350006103516, -1.40036493599029, 218, 45, 'PPL', 'P'),
(183165, 'McDonald', 38.1883316040039, 0.666512122333276, -122.908332824707, -2.14515508592816, 218, 6, 'PPL', 'P'),
(187798, 'McDonald', 39.785831451416, 0.694393754470724, -101.375282287598, -1.76933245605727, 218, 20, 'PPL', 'P'),
(188999, 'McDonald', 33.1405601501465, 0.578411890575283, -103.316940307617, -1.80322078145436, 218, 38, 'PPL', 'P'),
(197004, 'McDonald', 47.3233299255371, 0.825947920208186, -114.461112976074, -1.9977232869297, 218, 31, 'PPL', 'P'),
(201200, 'McDonald', 45.5888900756836, 0.795676234150446, -120.408889770508, -2.10153157516628, 218, 43, 'PPL', 'P'),
(208073, 'McDonald', 47.0713882446289, 0.821550708353328, -119.21443939209, -2.08068448331119, 218, 56, 'PPL', 'P'),
(42029, 'McDonald (historical)', 30.9386100769043, 0.539980611832676, -92.2441711425781, -1.60996450221113, 218, 22, 'PPL', 'P'),
(73411, 'McDonald (historical)', 39.5299987792969, 0.68992863200807, -84.7780609130859, -1.47965629638966, 218, 41, 'PPL', 'P'),
(22960, 'McDonald Acres', 34.9597206115723, 0.610162230249262, -85.2397232055664, -1.48771382342575, 218, 13, 'PPL', 'P'),
(4085, 'McDonald Chapel', 33.521671295166, 0.585063534871919, -86.9336090087891, -1.51727770784477, 218, 2, 'PPL', 'P'),
(204849, 'McDonald Condo', 40.5986099243164, 0.708579414912167, -111.881942749023, -1.95270827449825, 218, 52, 'PPL', 'P'),
(78711, 'McDonald Heights', 39.9280586242676, 0.696876086922787, -76.7024993896484, -1.33871115885831, 218, 45, 'PPL', 'P'),
(88901, 'McDonald Hill', 36.3916702270508, 0.635154465762029, -82.9791717529297, -1.4482597576665, 218, 50, 'PPL', 'P'),
(4086, 'McDonald Lower Landing', 31.2297191619873, 0.545061423849843, -87.835563659668, -1.53301978620629, 218, 2, 'PPL', 'P'),
(66716, 'McDonald Mill', 35.0644416809082, 0.611989957705383, -83.4027786254883, -1.45565309232672, 218, 33, 'PPL', 'P'),
(156394, 'McDonald Subdivision', 41.4561080932617, 0.723545581290086, -84.5633316040039, -1.47590856294565, 218, 41, 'PPL', 'P'),
(82323, 'McDonalds', 34.6216697692871, 0.604262130012246, -79.5438919067383, -1.38830281362305, 218, 48, 'PPL', 'P'),
(195304, 'McDonalds', 47.0344390869141, 0.820905823895366, -115.151390075684, -2.009770895069, 218, 17, 'PPL', 'P'),
(14192, 'McDonalds Crossroads', 38.6674995422363, 0.674875180525424, -75.4477767944336, -1.31681211837264, 218, 10, 'PPL', 'P'),
(136790, 'McDonalds Lakeview Terrace', 44.8847198486328, 0.783386145193893, -94.4027786254883, -1.6476393100461, 218, 28, 'PPL', 'P'),
(104115, 'McDonalds Mill', 37.2999992370605, 0.651007797678079, -80.2758331298828, -1.401077597898, 218, 53, 'PPL', 'P'),
(142378, 'McDonalds Trailer Court', 42.4577789306641, 0.741028035423965, -98.647216796875, -1.72171873103412, 218, 35, 'PPL', 'P'),
(156396, 'McDonaldsville', 40.8875007629395, 0.713621511224987, -81.4791717529297, -1.42207981888658, 218, 41, 'PPL', 'P'),
(195305, 'McDonaldville', 43.2599983215332, 0.755029405117975, -112.374168395996, -1.96129923270069, 218, 17, 'PPL', 'P'),
(49346, 'McDonogh', 39.3911094665527, 0.687504556204852, -76.7647171020508, -1.33979706279279, 218, 25, 'PPL', 'P'),
(49347, 'McDonogh Manor', 39.3769416809082, 0.687257281697639, -76.8097229003906, -1.34058256215631, 218, 25, 'PPL', 'P'),
(49348, 'McDonogh Park', 39.3772201538086, 0.687262141966628, -76.7916717529297, -1.34026751019935, 218, 25, 'PPL', 'P'),
(42030, 'McDonoghville', 29.9255599975586, 0.522299552460504, -90.0461120605469, -1.57160113407632, 218, 22, 'PPL', 'P'),
(14191, 'McDonough', 39.4913902282715, 0.689254785673252, -75.6500015258789, -1.32034160576532, 218, 10, 'PPL', 'P'),
(22961, 'McDonough', 33.4472198486328, 0.583764111997042, -84.1469421386719, -1.46864119580498, 218, 13, 'PPL', 'P'),
(150631, 'McDonough', 42.4983291625977, 0.741735770483654, -75.7683334350586, -1.32240688719068, 218, 40, 'PPL', 'P'),
(10393, 'McDougal', 36.439998626709, 0.635997955458284, -90.3913879394531, -1.57762733499095, 218, 4, 'PPL', 'P'),
(4087, 'McDowell', 32.5233306884766, 0.56763920422883, -87.9219436645508, -1.53452740169938, 218, 2, 'PPL', 'P'),
(37126, 'McDowell', 37.4558296203613, 0.653727550941323, -82.7363891601563, -1.44402240205607, 218, 21, 'PPL', 'P'),
(56166, 'McDowell', 36.8241691589355, 0.642702996134776, -93.7930603027344, -1.6369977178043, 218, 29, 'PPL', 'P'),
(104114, 'McDowell', 38.3355598449707, 0.669081739890066, -79.4908294677734, -1.38737669935398, 218, 53, 'PPL', 'P'),
(110349, 'McDowell', 37.4027786254883, 0.65280163640933, -81.3805618286133, -1.42035875103212, 218, 58, 'PPL', 'P'),
(120566, 'McDowell', 40.8305587768555, 0.712627686085197, -88.5849990844727, -1.54609990190021, 218, 18, 'PPL', 'P'),
(178608, 'McDowell Mountain Ranch', 33.6327781677246, 0.58700271561966, -111.847503662109, -1.95210719904022, 218, 5, 'PPL', 'P'),
(178609, 'McDowell Trailer Village', 33.4655609130859, 0.58408422396007, -112.007499694824, -1.95489965660123, 218, 5, 'PPL', 'P'),
(104116, 'McDuff', 37.9555587768555, 0.66244947009036, -77.4611129760742, -1.3519514636918, 218, 53, 'PPL', 'P'),
(150633, 'McDuffie Town', 42.7663917541504, 0.746414345307678, -76.7911071777344, -1.34025765650332, 218, 40, 'PPL', 'P'),
(110351, 'McDunn', 38.0569381713867, 0.664218874318608, -81.3091735839844, -1.41911279111613, 218, 58, 'PPL', 'P'),
(22963, 'McEachern Woods', 33.9124984741211, 0.591884755950966, -84.6947174072266, -1.47820167780226, 218, 13, 'PPL', 'P'),
(4088, 'McElderry', 33.4863891601563, 0.584447745448865, -85.9636077880859, -1.50034799279514, 218, 2, 'PPL', 'P'),
(56169, 'McElhany', 36.7880592346191, 0.642072759062809, -94.3986129760742, -1.64756660574834, 218, 29, 'PPL', 'P'),
(164371, 'McElhattan', 41.1597213745117, 0.718372657188716, -77.3616714477539, -1.35021588160939, 218, 45, 'PPL', 'P'),
(22964, 'McElheneys Crossroads', 33.2433280944824, 0.580205529569451, -83.7605590820313, -1.46189753929268, 218, 13, 'PPL', 'P'),
(10397, 'McElroy', 35.2147216796875, 0.614612838483975, -90.8375015258789, -1.58541348591196, 218, 4, 'PPL', 'P'),
(42031, 'McElroy', 30.1402797698975, 0.52604711945695, -90.791389465332, -1.58460867863054, 218, 22, 'PPL', 'P'),
(88902, 'McElroy', 35.7922210693359, 0.624692104261598, -85.563606262207, -1.49336664915555, 218, 50, 'PPL', 'P'),
(96093, 'McElroy', 31.1994400024414, 0.54453295282103, -93.995002746582, -1.64052227834897, 218, 51, 'PPL', 'P'),
(197005, 'McElroy', 48.8802795410156, 0.853121817285945, -104.121673583984, -1.81726602672733, 218, 31, 'PPL', 'P'),
(37127, 'McElroy Ford', 36.7338905334473, 0.641127336875831, -86.4100036621094, -1.50813907056417, 218, 21, 'PPL', 'P'),
(22965, 'McElroys Mill', 33.7763900756836, 0.589509216258615, -83.9855575561523, -1.46582450347806, 218, 13, 'PPL', 'P'),
(60829, 'McElveen', 31.2008304595947, 0.544557220876464, -90.5955581665039, -1.58119077768753, 218, 30, 'PPL', 'P'),
(56168, 'McElyea Place', 36.5008316040039, 0.637059691205871, -90.1391677856445, -1.5732252628671, 218, 29, 'PPL', 'P'),
(4090, 'McEntyre', 31.8083305358887, 0.55516009741391, -87.9655609130859, -1.53528866629698, 218, 2, 'PPL', 'P'),
(22966, 'McEver', 34.2569389343262, 0.597896376058629, -83.883056640625, -1.4640355250158, 218, 13, 'PPL', 'P'),
(88903, 'McEwen', 36.107780456543, 0.630199654553936, -87.633056640625, -1.52948537196559, 218, 50, 'PPL', 'P'),
(201201, 'McEwen', 44.7008285522461, 0.780176636606184, -118.103607177734, -2.06129680373347, 218, 43, 'PPL', 'P'),
(88904, 'McEwen (historical)', 35.9441719055176, 0.627344146654126, -86.8488922119141, -1.51579912080756, 218, 50, 'PPL', 'P'),
(150634, 'McEwens Corner', 44.7658309936523, 0.781311143230558, -74.6902770996094, -1.3035912546151, 218, 40, 'PPL', 'P'),
(164372, 'McEwensville', 41.0727806091309, 0.716855254578616, -76.8180618286133, -1.34072810390988, 218, 45, 'PPL', 'P'),
(10395, 'McFadden', 35.4063911437988, 0.617958101708251, -91.0919418334961, -1.58985430702967, 218, 4, 'PPL', 'P'),
(96094, 'McFadden', 30.0152797698975, 0.523865457891957, -94.0308303833008, -1.64114758857292, 218, 51, 'PPL', 'P'),
(209592, 'McFadden', 41.6544418334961, 0.727007158074971, -106.129997253418, -1.85231788720468, 218, 59, 'PPL', 'P'),
(76550, 'McFadden Cove', 36.704719543457, 0.640618207054435, -96.9338912963867, -1.69181555989222, 218, 42, 'PPL', 'P'),
(96095, 'McFaddin', 28.5536098480225, 0.49835450517787, -97.0136108398438, -1.69320692840373, 218, 51, 'PPL', 'P'),
(139313, 'McFall', 40.1108283996582, 0.700066021276484, -94.2230606079102, -1.6445026389142, 218, 29, 'PPL', 'P'),
(164373, 'McFann', 40.7269401550293, 0.710819199967951, -79.9422225952148, -1.39525499564871, 218, 45, 'PPL', 'P'),
(66719, 'McFarlan', 34.8122215270996, 0.607587885581537, -79.9761123657227, -1.39584648372681, 218, 33, 'PPL', 'P'),
(33228, 'McFarland', 39.0527801513672, 0.681599595698847, -96.2375030517578, -1.67966129215126, 218, 20, 'PPL', 'P'),
(66720, 'McFarland', 35.0138893127441, 0.61110765243624, -79.4058303833008, -1.38589318546875, 218, 33, 'PPL', 'P'),
(88905, 'McFarland', 35.1722183227539, 0.613871014962333, -84.3949966430664, -1.47297056363107, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(132006, 'McFarland', 46.1802787780762, 0.805997914166293, -87.2447204589844, -1.52270762699134, 218, 27, 'PPL', 'P'),
(175227, 'McFarland', 43.0125007629395, 0.750709757829866, -89.2897186279297, -1.55839957823669, 218, 57, 'PPL', 'P'),
(183166, 'McFarland', 35.6780586242676, 0.622699593713028, -119.228332519531, -2.08092696412845, 218, 6, 'PPL', 'P'),
(56170, 'McFarland (historical)', 36.7105598449707, 0.640720139545158, -93.0888900756836, -1.62470762884775, 218, 29, 'PPL', 'P'),
(191851, 'McFarland Place', 30.1875, 0.526871267945788, -103.037216186523, -1.79833867454403, 218, 51, 'PPL', 'P'),
(189000, 'McFarlands', 31.4719390869141, 0.549288959053748, -108.32527923584, -1.89063278580765, 218, 38, 'PPL', 'P'),
(128100, 'McFarlands Corner', 44.4161109924316, 0.775207377749178, -69.3230590820313, -1.209915628536, 218, 26, 'PPL', 'P'),
(156397, 'McFarlands Corners', 41.4116706848145, 0.722770002201627, -81.3383331298828, -1.41962172120044, 218, 41, 'PPL', 'P'),
(76551, 'McFarlin', 36.2058296203613, 0.631910935291394, -95.5330581665039, -1.66736640950475, 218, 42, 'PPL', 'P'),
(10398, 'McFerrin', 35.7777786254883, 0.624440036064422, -90.0422210693359, -1.57153322346852, 218, 4, 'PPL', 'P'),
(4091, 'McFrey Crossroads', 33.9761085510254, 0.592994961230393, -85.5749969482422, -1.49356545413093, 218, 2, 'PPL', 'P'),
(56171, 'McFry Ford', 36.7544403076172, 0.641485998095637, -91.2594375610352, -1.59277765895825, 218, 29, 'PPL', 'P'),
(189001, 'McGaffey', 35.3752784729004, 0.617415083161983, -108.514999389648, -1.893944027149, 218, 38, 'PPL', 'P'),
(104117, 'McGaheysville', 38.3711090087891, 0.669702189845027, -78.7324981689453, -1.3741413213685, 218, 53, 'PPL', 'P'),
(164374, 'McGarey', 41.0819396972656, 0.717015110823048, -79.1166687011719, -1.38084636204499, 218, 45, 'PPL', 'P'),
(116790, 'McGargels Ford', 42.2330589294434, 0.737105931507578, -90.9211120605469, -1.58687276503127, 218, 16, 'PPL', 'P'),
(156398, 'McGarry (historical)', 40.8827781677246, 0.713539086389249, -81.0699996948242, -1.41493841926548, 218, 41, 'PPL', 'P'),
(193777, 'McGarva', 41.2880592346191, 0.720612575402554, -120.560279846191, -2.1041738304418, 218, 6, 'PPL', 'P'),
(30474, 'McGary', 38.2644386291504, 0.66784044050598, -87.6286087036133, -1.52940774081981, 218, 19, 'PPL', 'P'),
(88907, 'McGavock (historical)', 35.9416694641113, 0.627300470812249, -86.8550033569336, -1.51590578040922, 218, 50, 'PPL', 'P'),
(73412, 'McGaw', 38.6377792358398, 0.674356463324104, -83.2247161865234, -1.45254531649265, 218, 41, 'PPL', 'P'),
(56172, 'McGee', 37.0744400024414, 0.647071046375697, -90.195556640625, -1.57420943404794, 218, 29, 'PPL', 'P'),
(76552, 'McGee', 34.8255615234375, 0.607820712439837, -96.9569396972656, -1.69221783037488, 218, 42, 'PPL', 'P'),
(110353, 'McGee', 39.3608283996582, 0.686976051886526, -80.1277770996094, -1.3984935326923, 218, 58, 'PPL', 'P'),
(202358, 'McGee', 44.0380592346191, 0.768609129832398, -103.383613586426, -1.80438444969267, 218, 49, 'PPL', 'P'),
(4092, 'McGee (historical)', 34.9249992370605, 0.609556227943214, -87.5458297729492, -1.52796297592844, 218, 2, 'PPL', 'P'),
(82326, 'McGee Acres', 34.5611114501953, 0.60320518795462, -82.6347198486328, -1.44224793782175, 218, 48, 'PPL', 'P'),
(66722, 'McGee Crossroads', 35.5169410705566, 0.619887561918013, -78.5794372558594, -1.37146990447904, 218, 33, 'PPL', 'P'),
(66721, 'McGee Mill', 35.5036087036133, 0.619654868217767, -78.5977783203125, -1.37179001644207, 218, 33, 'PPL', 'P'),
(4093, 'McGee Town', 34.851390838623, 0.60827151903336, -87.7480621337891, -1.53149259647918, 218, 2, 'PPL', 'P'),
(208075, 'McGees (historical)', 48.0716705322266, 0.839008927721288, -122.86222076416, -2.14435027864674, 218, 56, 'PPL', 'P'),
(164377, 'McGees Mills', 40.8816719055176, 0.713519778471346, -78.7627792358398, -1.37466982568683, 218, 45, 'PPL', 'P'),
(88908, 'McGeetown', 35.0349998474121, 0.611476100773052, -84.3247222900391, -1.47174404479103, 218, 50, 'PPL', 'P'),
(10400, 'McGehee', 33.6288909912109, 0.58693487159089, -91.3994369506836, -1.59522110925839, 218, 4, 'PPL', 'P'),
(42033, 'McGehee (historical)', 30.9741706848145, 0.540601261524719, -91.3349990844727, -1.59409645633005, 218, 22, 'PPL', 'P'),
(4095, 'McGehees', 32.269718170166, 0.563212830760037, -86.3747177124023, -1.50752321456209, 218, 2, 'PPL', 'P'),
(66723, 'McGehees Mill', 36.5166702270508, 0.637336127327022, -79.0288925170898, -1.37931437862793, 218, 33, 'PPL', 'P'),
(210690, 'McGerrow Village', 20.8663902282715, 0.364187212489309, -156.46110534668, -2.73076143960926, 218, 15, 'PPL', 'P'),
(4096, 'McGhee', 34.167781829834, 0.596340291033696, -85.7324981689453, -1.49631436900811, 218, 2, 'PPL', 'P'),
(60830, 'McGhee', 34.5391693115234, 0.602822225389867, -89.9494400024414, -1.5699138883677, 218, 30, 'PPL', 'P'),
(88909, 'McGhee', 35.6113891601563, 0.621535992053745, -84.2088928222656, -1.46972243920756, 218, 50, 'PPL', 'P'),
(189002, 'McGhee Wells', 32.1802787780762, 0.561651818887087, -108.931671142578, -1.90121632113768, 218, 38, 'PPL', 'P'),
(49349, 'McGhiesport', 38.6377792358398, 0.674356463324104, -77.1080627441406, -1.34578957471963, 218, 25, 'PPL', 'P'),
(156399, 'McGill', 41.0188903808594, 0.715914692660627, -84.774169921875, -1.47958838578186, 218, 41, 'PPL', 'P'),
(183167, 'McGill', 38.1986083984375, 0.666691486232692, -122.435562133789, -2.13690368076471, 218, 6, 'PPL', 'P'),
(190466, 'McGill', 39.4049987792969, 0.687746970443077, -114.777778625488, -2.00325014513994, 218, 39, 'PPL', 'P'),
(190467, 'McGill Junction', 39.3722190856934, 0.687174856861901, -114.800277709961, -2.00364282824267, 218, 39, 'PPL', 'P'),
(164376, 'McGillstown', 40.3886108398438, 0.704914239461946, -76.5252838134766, -1.33561816356829, 218, 45, 'PPL', 'P'),
(197006, 'McGillvary', 46.660831451416, 0.814385140545334, -112.593612670898, -1.96512925782238, 218, 31, 'PPL', 'P'),
(208074, 'McGilvara', 47.5911102294922, 0.830621568184193, -122.241668701172, -2.13351960196755, 218, 56, 'PPL', 'P'),
(49350, 'McGinnes', 39.2194404602051, 0.684508366820459, -75.9522171020508, -1.32561626262033, 218, 25, 'PPL', 'P'),
(22967, 'McGinnis (historical)', 34.0974998474121, 0.595113639035605, -84.9552764892578, -1.48274929167968, 218, 13, 'PPL', 'P'),
(66724, 'McGinnis Crossroads', 35.2122192382813, 0.614569162642098, -82.0002822875977, -1.43117491348337, 218, 33, 'PPL', 'P'),
(4097, 'McGinty', 32.7772216796875, 0.572070437966613, -85.1522216796875, -1.48618663369864, 218, 2, 'PPL', 'P'),
(42037, 'McGinty', 33.0016708374023, 0.575987814772065, -91.6288909912109, -1.5992258377476, 218, 22, 'PPL', 'P'),
(10401, 'McGintytown', 35.2472190856934, 0.615180025217134, -92.2916717529297, -1.61079354425847, 218, 4, 'PPL', 'P'),
(56174, 'McGirk', 38.6111106872559, 0.673891009344585, -92.4761123657227, -1.6140126402261, 218, 29, 'PPL', 'P'),
(96096, 'McGirk', 31.5177898406982, 0.550089205671803, -98.3312377929688, -1.71620385704879, 218, 51, 'PPL', 'P'),
(120567, 'McGirr', 41.8175010681152, 0.729853078594856, -88.8022232055664, -1.54989117802805, 218, 18, 'PPL', 'P'),
(88910, 'McGlamerys Stand', 35.146671295166, 0.613425135216827, -87.745002746582, -1.53143920009932, 218, 50, 'PPL', 'P'),
(10402, 'McGlendon Mill', 33.1919403076172, 0.579308643493339, -92.2936096191406, -1.61082736640431, 218, 4, 'PPL', 'P'),
(110354, 'McGlone', 37.5208282470703, 0.654861990986669, -80.4916687011719, -1.40484463925992, 218, 58, 'PPL', 'P'),
(73413, 'McGonigle', 39.4458312988281, 0.688459632350782, -84.6830596923828, -1.47799821229498, 218, 41, 'PPL', 'P'),
(164378, 'McGovern', 40.228889465332, 0.702126575590905, -80.216667175293, -1.40004495718532, 218, 45, 'PPL', 'P'),
(164380, 'McGovernsville', 40.0691719055176, 0.699338978298892, -76.3574981689453, -1.33268975163364, 218, 45, 'PPL', 'P'),
(4098, 'McGowan', 32.0688896179199, 0.559707711291329, -85.9402770996094, -1.49994079546447, 218, 2, 'PPL', 'P'),
(37128, 'McGowan', 37.0577812194824, 0.646780295763688, -87.8444366455078, -1.53317464902367, 218, 21, 'PPL', 'P'),
(208076, 'McGowan', 46.2463912963867, 0.807151795287597, -123.906112670898, -2.16256962945424, 218, 56, 'PPL', 'P'),
(113358, 'McGowan Corners', 41.3788909912109, 0.722197888620451, -71.7622222900391, -1.25248705750925, 218, 47, 'PPL', 'P'),
(66727, 'McGowans Crossroads', 35.523609161377, 0.62000394205765, -77.3069381713867, -1.34926060572638, 218, 33, 'PPL', 'P'),
(66725, 'McGrady', 36.3433303833008, 0.634310776328691, -81.2249984741211, -1.41764365830078, 218, 33, 'PPL', 'P'),
(164379, 'McGrann', 40.7813911437988, 0.711769549002946, -79.5216674804688, -1.38791492421028, 218, 45, 'PPL', 'P'),
(60831, 'McGrath', 33.2894401550293, 0.581010336850873, -90.7980575561523, -1.58472505877017, 218, 30, 'PPL', 'P'),
(136792, 'McGrath', 46.2400016784668, 0.80704027541695, -93.272216796875, -1.62790728373943, 218, 28, 'PPL', 'P'),
(211987, 'McGrath', 62.9563903808594, 1.09879629731688, -155.595825195313, -2.71565945201575, 218, 1, 'PPL', 'P'),
(33227, 'McGraw', 38.0119400024414, 0.663433508113144, -97.3680572509766, -1.69939318529988, 218, 20, 'PPL', 'P'),
(128101, 'McGraw', 46.815559387207, 0.817085652469702, -67.98388671875, -1.18654266154503, 218, 26, 'PPL', 'P'),
(150635, 'McGraw', 42.5961112976074, 0.743442390689204, -76.0936126708984, -1.32808408084445, 218, 40, 'PPL', 'P'),
(22968, 'McGraw Manor', 32.3972206115723, 0.565438168166907, -84.9219436645508, -1.48216752413955, 218, 13, 'PPL', 'P'),
(110355, 'McGraws', 37.6708297729492, 0.657480011496272, -81.4633331298828, -1.42180338276543, 218, 58, 'PPL', 'P'),
(150636, 'McGraws', 42.0733299255371, 0.734318134478483, -77.7300033569336, -1.35664448616474, 218, 40, 'PPL', 'P'),
(123157, 'McGrawsville', 40.6302795410156, 0.709132153996413, -86.0138931274414, -1.50122563753238, 218, 19, 'PPL', 'P'),
(4099, 'McGrawtown', 33.121940612793, 0.578086918343266, -87.128059387207, -1.52067150717992, 218, 2, 'PPL', 'P'),
(150637, 'McGrawville', 42.3491706848145, 0.739132463939074, -78.227783203125, -1.36533238343085, 218, 40, 'PPL', 'P'),
(189003, 'McGreggor Place', 36.8308296203613, 0.642819243116358, -105.845001220703, -1.84734376807869, 218, 38, 'PPL', 'P'),
(10403, 'McGregor', 35.017219543457, 0.611165775927031, -91.2263870239258, -1.59220081826614, 218, 4, 'PPL', 'P'),
(17068, 'McGregor', 26.5605602264404, 0.463569227125636, -81.9147186279297, -1.4296815459021, 218, 12, 'PPL', 'P'),
(22969, 'McGregor', 32.1963882446289, 0.561932982119172, -82.504997253418, -1.43998385142102, 218, 13, 'PPL', 'P'),
(96097, 'McGregor', 31.4438896179199, 0.548799403466364, -97.4088897705078, -1.70010584720759, 218, 51, 'PPL', 'P'),
(116791, 'McGregor', 43.0183296203613, 0.750811490583507, -91.182502746582, -1.59143489313663, 218, 16, 'PPL', 'P'),
(132007, 'McGregor', 43.4824981689453, 0.758912760040501, -82.7474975585938, -1.44421628018343, 218, 27, 'PPL', 'P'),
(136794, 'McGregor', 46.6066703796387, 0.81343985151641, -93.313606262207, -1.62862966618511, 218, 28, 'PPL', 'P'),
(194318, 'McGregor', 40.4794387817383, 0.706499486100815, -107.034439086914, -1.86810337509196, 218, 7, 'PPL', 'P'),
(198599, 'McGregor', 48.5952796936035, 0.848147631580923, -102.927780151367, -1.79642865541022, 218, 34, 'PPL', 'P'),
(116792, 'McGregor Heights', 43.0338897705078, 0.751083066435668, -91.1772232055664, -1.59134274776291, 218, 16, 'PPL', 'P'),
(128102, 'McGregor Mill', 44.9863891601563, 0.785160609428213, -69.054443359375, -1.20522739975303, 218, 26, 'PPL', 'P'),
(199521, 'McGrew', 41.7466697692871, 0.728616839216842, -103.417778015137, -1.80498073146074, 218, 35, 'PPL', 'P'),
(175229, 'McGrew (historical)', 43.3974990844727, 0.757429246155273, -90.48388671875, -1.57924174324376, 218, 57, 'PPL', 'P'),
(132008, 'McGrew Junction', 43.0699996948242, 0.751713303507636, -83.6769409179688, -1.46043812701532, 218, 27, 'PPL', 'P'),
(22970, 'McGriff (historical)', 32.4327812194824, 0.56605881785895, -83.4158325195313, -1.45588092575798, 218, 13, 'PPL', 'P'),
(156400, 'McGuffey', 40.6927795410156, 0.71022298477891, -83.7855606079102, -1.46233389823729, 218, 41, 'PPL', 'P'),
(156401, 'McGuffey Heights', 41.1266708374023, 0.717795816496604, -80.5875015258789, -1.40651723758254, 218, 41, 'PPL', 'P'),
(49351, 'McGuigan Park', 39.4602813720703, 0.688711833706013, -76.3583297729492, -1.33270426586158, 218, 25, 'PPL', 'P'),
(56173, 'McGuire', 36.4980583190918, 0.637011288253059, -89.9705581665039, -1.57028246986257, 218, 29, 'PPL', 'P'),
(195306, 'McGuire', 47.7125015258789, 0.832740245989405, -116.990280151367, -2.04186558147193, 218, 17, 'PPL', 'P'),
(10404, 'McGuire (historical)', 36.0263900756836, 0.628779124428488, -94.008056640625, -1.64075011178023, 218, 4, 'PPL', 'P'),
(110356, 'McGuire Park', 39.0233306884766, 0.681085605608462, -80.4161071777344, -1.40352584188811, 218, 58, 'PPL', 'P'),
(66726, 'McGuires', 35.3022193908691, 0.616139961632054, -83.9958267211914, -1.46600373421942, 218, 33, 'PPL', 'P'),
(22972, 'McGuires (historical)', 33.8055610656738, 0.590018346080011, -84.0763931274414, -1.46740988327498, 218, 13, 'PPL', 'P'),
(178610, 'McGuireville', 34.6380615234375, 0.604548220092347, -111.816390991211, -1.95156418049396, 218, 5, 'PPL', 'P'),
(164381, 'McHaddon', 40.7886085510254, 0.711895516522507, -79.5936126708984, -1.38917060466426, 218, 45, 'PPL', 'P'),
(88911, 'McHaney (historical)', 35.8116683959961, 0.625031524142528, -88.586669921875, -1.54612906351415, 218, 50, 'PPL', 'P'),
(112561, 'McHarg', 35.0047187805176, 0.610947596454726, -84.4005584716797, -1.4730676358528, 218, 50, 'PPL', 'P'),
(132009, 'McHarg', 45.0355606079102, 0.786018813089491, -83.6138916015625, -1.4593377088529, 218, 27, 'PPL', 'P'),
(37129, 'McHargue', 37.0052795410156, 0.645863968611619, -84.0175018310547, -1.46638203625227, 218, 21, 'PPL', 'P'),
(96098, 'McHattie', 29.541389465332, 0.515594511784011, -95.8461074829102, -1.67283015079716, 218, 51, 'PPL', 'P'),
(37130, 'McHenry', 37.3819389343262, 0.652437915183452, -86.9225006103516, -1.51708382971742, 218, 21, 'PPL', 'P'),
(49352, 'McHenry', 39.5583305358887, 0.69042311444347, -79.3530578613281, -1.38497213120575, 218, 25, 'PPL', 'P'),
(60832, 'McHenry', 30.7075004577637, 0.535946988045642, -89.1383285522461, -1.55575732296116, 218, 30, 'PPL', 'P'),
(104118, 'McHenry', 38.1719398498535, 0.666226032253174, -77.7063903808594, -1.35623236198605, 218, 53, 'PPL', 'P'),
(120568, 'McHenry', 42.3333282470703, 0.738855961238897, -88.2666702270508, -1.54054401523409, 218, 18, 'PPL', 'P'),
(140475, 'McHenry', 47.5761108398438, 0.830359779449038, -98.5911102294922, -1.7207394867013, 218, 34, 'PPL', 'P'),
(183168, 'McHenry', 37.7075004577637, 0.658120035685245, -121.003059387207, -2.11190179129299, 218, 6, 'PPL', 'P'),
(195307, 'McHenry', 42.5955581665039, 0.743432736730252, -114.051391601563, -1.99057229992867, 218, 17, 'PPL', 'P'),
(49353, 'McHenry Meadows', 39.4338912963867, 0.688251239995483, -77.0811080932617, -1.34531912731307, 218, 25, 'PPL', 'P'),
(10405, 'McHue', 35.6927795410156, 0.622956522179193, -91.6580581665039, -1.59973490098997, 218, 4, 'PPL', 'P'),
(42036, 'McHugh', 30.6241703033447, 0.534492602484836, -91.1647186279297, -1.59112450171158, 218, 22, 'PPL', 'P'),
(197007, 'McHugh Trailer Court', 46.6155586242676, 0.813594980649908, -112.027778625488, -1.9552535907101, 218, 31, 'PPL', 'P'),
(164383, 'McIlhaney', 40.9219398498535, 0.714222586683018, -75.3597183227539, -1.31527520810755, 218, 45, 'PPL', 'P'),
(88912, 'McIllwain', 35.8627815246582, 0.625923616528678, -88.079719543457, -1.53728111026652, 218, 50, 'PPL', 'P'),
(172235, 'McIndoe Falls', 44.2613906860352, 0.772506998982865, -72.0630569458008, -1.25773761275639, 218, 55, 'PPL', 'P'),
(82327, 'McInnis (historical)', 34.5522193908691, 0.603049992242096, -79.5127792358398, -1.38775979507679, 218, 48, 'PPL', 'P'),
(116793, 'McIntire', 43.4358291625977, 0.758098232221101, -92.5936126708984, -1.61606340742352, 218, 16, 'PPL', 'P'),
(4100, 'McIntosh', 31.2661094665527, 0.545696554480313, -88.0313873291016, -1.53643755399124, 218, 2, 'PPL', 'P'),
(17069, 'McIntosh', 29.4486103057861, 0.513975209972702, -82.2222213745117, -1.43504848128889, 218, 12, 'PPL', 'P'),
(22973, 'McIntosh', 31.8255596160889, 0.555460801590493, -81.5238876342773, -1.42286025824403, 218, 13, 'PPL', 'P'),
(56175, 'McIntosh', 39.4041709899902, 0.687732522794163, -90.9733276367188, -1.58778409875629, 218, 29, 'PPL', 'P'),
(136797, 'McIntosh', 47.6369400024414, 0.831421448617598, -95.8861083984375, -1.67352829847692, 218, 28, 'PPL', 'P'),
(189004, 'McIntosh', 34.8647193908691, 0.608504146154578, -106.051109313965, -1.85094103292111, 218, 38, 'PPL', 'P'),
(202359, 'McIntosh', 45.9213905334473, 0.80147946190281, -101.349166870117, -1.7688766560367, 218, 49, 'PPL', 'P'),
(208077, 'McIntosh', 46.8630599975586, 0.817914694517043, -122.776390075684, -2.14285225053357, 218, 56, 'PPL', 'P'),
(22974, 'McIntosh Corner', 33.3905601501465, 0.582775213705268, -84.5611114501953, -1.47586981395179, 218, 13, 'PPL', 'P'),
(27852, 'McIntosh Settlement (historical)', 38.2155609130859, 0.6669873634298, -88.3625030517578, -1.54221661355671, 218, 18, 'PPL', 'P'),
(22976, 'McIntosh Village', 33.4147186279297, 0.583196858684855, -84.4677810668945, -1.47424089147104, 218, 13, 'PPL', 'P'),
(17070, 'McIntyre', 29.9811096191406, 0.523269076255347, -84.5261077880859, -1.47525888479772, 218, 12, 'PPL', 'P'),
(22977, 'McIntyre', 32.8461112976074, 0.573272788619757, -83.1908264160156, -1.45195382841455, 218, 13, 'PPL', 'P'),
(42038, 'McIntyre', 32.5869407653809, 0.568749409508257, -93.3683319091797, -1.62958480891007, 218, 22, 'PPL', 'P'),
(113198, 'McIntyre', 41.889720916748, 0.731113552738791, -73.6986083984375, -1.28628337069068, 218, 40, 'PPL', 'P'),
(156402, 'McIntyre', 40.3066711425781, 0.703484121956573, -80.7813873291016, -1.40990118322165, 218, 41, 'PPL', 'P'),
(164384, 'McIntyre', 40.5697212219238, 0.708075211938788, -79.2958297729492, -1.38397331263891, 218, 45, 'PPL', 'P'),
(192693, 'McIntyre', 39.8347206115723, 0.695247031283985, -112.168327331543, -1.95770662839017, 218, 52, 'PPL', 'P'),
(60833, 'McIntyre (historical)', 33.4569396972656, 0.58393375535848, -88.5227813720703, -1.54501399796573, 218, 30, 'PPL', 'P'),
(204851, 'McIntyre Building Condominium', 40.7677803039551, 0.711531995033711, -111.89111328125, -1.95286833047977, 218, 52, 'PPL', 'P'),
(49363, 'McIntyre Estates', 39.6166687011719, 0.691441307507235, -77.5130615234375, -1.35285813688492, 218, 25, 'PPL', 'P'),
(132010, 'McIntyre Landing', 44.6650009155273, 0.779551326382234, -84.8083267211914, -1.48018453439188, 218, 27, 'PPL', 'P'),
(22979, 'McIntyre Spring (historical)', 30.6408290863037, 0.534783353096846, -83.3666687011719, -1.45502285525475, 218, 13, 'PPL', 'P'),
(60834, 'McIvor', 34.4383316040039, 0.601062275383488, -89.9747161865234, -1.57035504100227, 218, 30, 'PPL', 'P'),
(132011, 'McIvor', 44.2344398498535, 0.77203661815533, -83.6830596923828, -1.46054491977503, 218, 27, 'PPL', 'P'),
(22980, 'McIvor (historical)', 33.8763885498047, 0.591254518878999, -84.4927825927734, -1.47467725041565, 218, 13, 'PPL', 'P'),
(10409, 'McJester', 35.4738883972168, 0.619136151016447, -91.8183288574219, -1.60253215224093, 218, 4, 'PPL', 'P'),
(49354, 'McKaig', 39.4313888549805, 0.688207564153606, -77.3099975585938, -1.34931400210624, 218, 25, 'PPL', 'P'),
(10411, 'McKamie', 33.2683296203613, 0.58064188851406, -93.498893737793, -1.6318635426968, 218, 4, 'PPL', 'P'),
(156403, 'McKay', 40.7058296203613, 0.710450751631139, -82.2430572509766, -1.43541213593574, 218, 41, 'PPL', 'P'),
(183170, 'McKay', 35.7836112976074, 0.62454183539709, -120.724166870117, -2.1070341986106, 218, 6, 'PPL', 'P'),
(201202, 'McKay', 45.4997215270996, 0.794119949388431, -118.614723205566, -2.07021746127886, 218, 43, 'PPL', 'P'),
(208078, 'McKay', 46.3375015258789, 0.808741968774483, -118.136940002441, -2.0618785712736, 218, 56, 'PPL', 'P'),
(49355, 'McKay Beach', 38.186939239502, 0.666487820988329, -76.5516662597656, -1.33607862412076, 218, 25, 'PPL', 'P'),
(73414, 'McKays', 39.5394401550293, 0.690093415100518, -83.8772201538086, -1.4639336591041, 218, 41, 'PPL', 'P'),
(156404, 'McKays Corners', 41.024169921875, 0.716006838034344, -80.6344375610352, -1.40733642593385, 218, 41, 'PPL', 'P'),
(170845, 'McKays Trailer Court', 42.6124992370605, 0.743728414190278, -96.6444396972656, -1.6867636764624, 218, 49, 'PPL', 'P'),
(199522, 'McKeag', 41.4500007629395, 0.723438988267455, -101.761940002441, -1.77608090625953, 218, 35, 'PPL', 'P'),
(164386, 'McKeages Crossing', 40.723331451416, 0.710756216208171, -78.815559387207, -1.37559101310789, 218, 45, 'PPL', 'P'),
(164387, 'McKean', 41.8183288574219, 0.72986752624377, -78.5577774047852, -1.37109186876231, 218, 45, 'PPL', 'P'),
(164391, 'McKeansburg', 40.6783294677734, 0.709970783423679, -76.0238876342773, -1.32686714938434, 218, 45, 'PPL', 'P'),
(22981, 'McKee', 34.4597206115723, 0.60143558398929, -84.1419372558594, -1.46855384412123, 218, 13, 'PPL', 'P'),
(37131, 'McKee', 37.4302787780762, 0.653281604616789, -83.9980621337891, -1.46604274952939, 218, 21, 'PPL', 'P'),
(164393, 'McKee', 40.4275016784668, 0.70559301264478, -77.2213897705078, -1.34776750446123, 218, 45, 'PPL', 'P'),
(201203, 'McKee', 45.0999984741211, 0.787143466017832, -122.806938171387, -2.1433854153838, 218, 43, 'PPL', 'P'),
(201204, 'McKee Bridge', 42.1277809143066, 0.735268483513478, -123.074996948242, -2.1480639236288, 218, 43, 'PPL', 'P'),
(71102, 'McKee City', 39.4502792358398, 0.688537263496558, -74.64111328125, -1.30273318411188, 218, 37, 'PPL', 'P'),
(110359, 'McKeefrey', 39.8933296203613, 0.696269951458685, -80.7897186279297, -1.41004659181717, 218, 58, 'PPL', 'P'),
(27854, 'McKeen', 39.4583282470703, 0.68867774524406, -87.6138916015625, -1.52915087893267, 218, 18, 'PPL', 'P'),
(128103, 'McKeen Crossing', 46.603889465332, 0.813391315405544, -68.7216720581055, -1.19941944488973, 218, 26, 'PPL', 'P'),
(208079, 'McKees Beach', 48.127498626709, 0.839983311785121, -122.36222076416, -2.13562363238677, 218, 56, 'PPL', 'P'),
(37132, 'McKees Crossroads', 38.1208305358887, 0.665334006446052, -84.7761077880859, -1.47962220792771, 218, 21, 'PPL', 'P'),
(164394, 'McKees Half Falls', 40.6613883972168, 0.709675105963653, -76.918327331543, -1.34247806706217, 218, 45, 'PPL', 'P'),
(164395, 'McKees Rocks', 40.4655609130859, 0.706257271599673, -80.0658264160156, -1.39741228928972, 218, 45, 'PPL', 'P'),
(104119, 'McKees Store', 36.7519416809082, 0.641442388832787, -81.7369384765625, -1.42657869691605, 218, 53, 'PPL', 'P'),
(164401, 'McKeesport', 40.3477783203125, 0.70420157755424, -79.8644409179688, -1.39389744928304, 218, 45, 'PPL', 'P'),
(132012, 'McKeever', 46.7455596923828, 0.815863927319628, -89.0524978637695, -1.554259294848, 218, 27, 'PPL', 'P'),
(150638, 'McKeever', 43.6119384765625, 0.761171919593216, -75.0991668701172, -1.31072772738819, 218, 40, 'PPL', 'P'),
(190468, 'McKeeversville (historical)', 35.9680595397949, 0.627761064522778, -114.851936340332, -2.00454444142972, 218, 39, 'PPL', 'P'),
(96099, 'McKeichan Crossing', 33.0149993896484, 0.576220441893284, -99.2497177124023, -1.73223435575636, 218, 51, 'PPL', 'P'),
(82328, 'McKellar Farms', 34.1877784729004, 0.596689298294551, -82.1047210693359, -1.43299771409147, 218, 48, 'PPL', 'P'),
(82329, 'McKelvey Crossroads', 34.607780456543, 0.604019715774021, -82.3691711425781, -1.43761323857669, 218, 48, 'PPL', 'P'),
(189005, 'McKelvey Place', 32.8233299255371, 0.572875178669008, -108.889717102051, -1.90048408499596, 218, 38, 'PPL', 'P'),
(49356, 'McKendree', 38.7811088562012, 0.676858037115043, -76.6202774047852, -1.33727611450492, 218, 25, 'PPL', 'P'),
(73415, 'McKendree', 39.785831451416, 0.694393754470724, -83.2719421386719, -1.45336956485003, 218, 41, 'PPL', 'P'),
(104120, 'McKendree', 36.8477783203125, 0.643115053734439, -78.9958267211914, -1.37873727161971, 218, 53, 'PPL', 'P'),
(110357, 'McKendree', 37.8877792358398, 0.661266493934146, -81.063606262207, -1.41482683281581, 218, 58, 'PPL', 'P'),
(208080, 'McKenna', 46.935001373291, 0.819170308391988, -122.555282592773, -2.13899319695599, 218, 56, 'PPL', 'P'),
(104121, 'McKenney', 36.9866714477539, 0.645539196116684, -77.7233276367188, -1.35652797286705, 218, 53, 'PPL', 'P'),
(49357, 'McKenney Hills', 39.0202789306641, 0.68103234238666, -77.0516662597656, -1.34480527038073, 218, 25, 'PPL', 'P'),
(82330, 'McKennon', 34.5466690063477, 0.602953119757444, -80.128059387207, -1.39849845954031, 218, 48, 'PPL', 'P'),
(22982, 'McKenny Acres', 33.7847213745117, 0.589654624854134, -84.6980590820313, -1.47826000103013, 218, 13, 'PPL', 'P'),
(4104, 'McKenzie', 31.5422191619873, 0.550515577762325, -86.7149963378906, -1.51346219695102, 218, 2, 'PPL', 'P'),
(22983, 'McKenzie', 31.9269409179688, 0.557230239108256, -83.6741714477539, -1.46038979064154, 218, 13, 'PPL', 'P'),
(42039, 'McKenzie', 32.8444404602051, 0.57324362700582, -93.0972213745117, -1.62485303744327, 218, 22, 'PPL', 'P'),
(49358, 'McKenzie', 39.5672187805176, 0.690578243576967, -78.8241729736328, -1.37574134855142, 218, 25, 'PPL', 'P'),
(88913, 'McKenzie', 36.1324996948242, 0.630631086650529, -88.5186080932617, -1.54494116050992, 218, 50, 'PPL', 'P'),
(198606, 'McKenzie', 46.8241691589355, 0.817235921334209, -100.413063049316, -1.75253856222323, 218, 34, 'PPL', 'P'),
(201205, 'McKenzie Bridge', 44.1752815246582, 0.771004110600706, -122.162780761719, -2.13214274768398, 218, 43, 'PPL', 'P'),
(82331, 'McKenzie Crossroads', 33.9130592346191, 0.591894543067972, -79.9086074829102, -1.39466830126056, 218, 48, 'PPL', 'P'),
(187042, 'McKenzie Junction', 38.1641693115234, 0.666090410774661, -105.190277099609, -1.83591667647337, 218, 7, 'PPL', 'P'),
(193778, 'McKenzie Place', 40.2947196960449, 0.703275529864193, -121.900833129883, -2.12757089904064, 218, 6, 'PPL', 'P'),
(183171, 'McKenzie Spring (historical)', 36.9816703796387, 0.645451911011956, -119.611938476563, -2.08762215110891, 218, 6, 'PPL', 'P'),
(49359, 'McKenzies Discovery', 39.3044395446777, 0.685991880705687, -76.8452835083008, -1.34120321184835, 218, 25, 'PPL', 'P'),
(112548, 'McKeown', 34.6175003051758, 0.604189359135459, -81.182502746582, -1.4169019679372, 218, 48, 'PPL', 'P'),
(4102, 'McKestes', 34.3974990844727, 0.600349613475783, -85.8947219848633, -1.49914570872102, 218, 2, 'PPL', 'P'),
(76555, 'McKey', 35.4824981689453, 0.619286419880955, -94.8847198486328, -1.65605077119106, 218, 42, 'PPL', 'P'),
(4103, 'McKibben', 33.5994415283203, 0.586420881500505, -85.8683319091797, -1.49868511501049, 218, 2, 'PPL', 'P'),
(191852, 'McKibben', 36.1258316040039, 0.630514706510892, -101.338607788086, -1.76869236528927, 218, 51, 'PPL', 'P'),
(76557, 'McKiddyville', 35.0875015258789, 0.612392427925121, -97.211669921875, -1.69666371149866, 218, 42, 'PPL', 'P'),
(110358, 'McKim', 39.3800010681152, 0.687310678077495, -80.9608306884766, -1.41303306066358, 218, 58, 'PPL', 'P'),
(164398, 'McKimm', 40.8347206115723, 0.712700323803929, -80.258056640625, -1.40076733963101, 218, 45, 'PPL', 'P'),
(956, 'McKinley', 36.3091697692871, 0.63371456113965, -82.4105606079102, -1.43833562102237, 218, 50, 'PPL', 'P'),
(4105, 'McKinley', 32.2983283996582, 0.563712173464427, -87.540283203125, -1.52786617002282, 218, 2, 'PPL', 'P'),
(27855, 'McKinley', 38.2324981689453, 0.667282974310799, -89.5483322143555, -1.56291323681021, 218, 18, 'PPL', 'P'),
(30475, 'McKinley', 38.7447204589844, 0.676222939774086, -86.210563659668, -1.50465818586138, 218, 19, 'PPL', 'P'),
(56176, 'McKinley', 37.0611114501953, 0.646838419254479, -93.6272201538086, -1.63410326117355, 218, 29, 'PPL', 'P'),
(104122, 'McKinley', 38.0424995422363, 0.66396687270046, -79.2991714477539, -1.38403163586678, 218, 53, 'PPL', 'P'),
(132013, 'McKinley', 44.6469383239746, 0.779236074688196, -83.9372177124023, -1.46498081404472, 218, 27, 'PPL', 'P'),
(136799, 'McKinley', 47.5127792358398, 0.829254434438601, -92.4108276367188, -1.61287320675371, 218, 28, 'PPL', 'P'),
(150639, 'McKinley', 42.9141693115234, 0.748993550244392, -74.517219543457, -1.30057083046479, 218, 40, 'PPL', 'P'),
(156406, 'McKinley', 41.4186096191406, 0.722891109452198, -81.8016662597656, -1.42770840985047, 218, 41, 'PPL', 'P'),
(164400, 'McKinley', 40.0847206115723, 0.699610354413971, -75.1172180175781, -1.31104277934515, 218, 45, 'PPL', 'P'),
(175230, 'McKinley', 45.5713882446289, 0.795370769573413, -92.1763916015625, -1.60878152605491, 218, 57, 'PPL', 'P'),
(193214, 'McKinley', 43.1888885498047, 0.753788305470971, -124.025001525879, -2.16464463141758, 218, 43, 'PPL', 'P'),
(110360, 'McKinley (historical)', 39.089168548584, 0.682234693039804, -81.5819396972656, -1.42387345788075, 218, 58, 'PPL', 'P'),
(128104, 'McKinley Estates', 43.6841697692871, 0.762432593474232, -70.1963882446289, -1.22515809787702, 218, 26, 'PPL', 'P'),
(156407, 'McKinley Heights', 41.1836090087891, 0.718789575057368, -80.7174987792969, -1.40878611767323, 218, 41, 'PPL', 'P'),
(78712, 'McKinley Hill', 39.7305603027344, 0.69342909094487, -79.9011077880859, -1.39453740689298, 218, 45, 'PPL', 'P'),
(120573, 'McKinley Park', 41.8316688537598, 0.73010035310207, -87.6736068725586, -1.53019310702528, 218, 18, 'PPL', 'P'),
(211988, 'McKinley Park', 63.732780456543, 1.11234686041737, -148.914169311523, -2.59904255735838, 218, 1, 'PPL', 'P'),
(189007, 'McKinley Place', 34.6383285522461, 0.604552880624255, -106.381393432617, -1.85670557825864, 218, 38, 'PPL', 'P'),
(49360, 'McKinleyville', 39.1144409179688, 0.682675779095348, -76.1822204589844, -1.32963057848946, 218, 25, 'PPL', 'P'),
(177245, 'McKinleyville', 40.2436103820801, 0.702383504057071, -80.5963897705078, -1.40667236671604, 218, 58, 'PPL', 'P'),
(193779, 'McKinleyville', 40.9466705322266, 0.714654218516692, -124.09944152832, -2.16594385455537, 218, 6, 'PPL', 'P'),
(96100, 'McKinleyville (historical)', 31.461389541626, 0.549104834753883, -95.0975036621094, -1.65976454933117, 218, 51, 'PPL', 'P'),
(10413, 'McKinney', 33.3888893127441, 0.582746052091332, -93.795280456543, -1.63703646679816, 218, 4, 'PPL', 'P'),
(22985, 'McKinney', 32.9258308410645, 0.574664157131269, -84.2919387817383, -1.47117186463083, 218, 13, 'PPL', 'P'),
(37133, 'McKinney', 37.4524993896484, 0.653669427450532, -84.7591705322266, -1.47932659704671, 218, 21, 'PPL', 'P'),
(96101, 'McKinney', 33.1974983215332, 0.579405649136046, -96.6149978637695, -1.68624981953007, 218, 51, 'PPL', 'P'),
(164402, 'McKinney', 40.1519393920898, 0.700783543453178, -77.6138916015625, -1.35461795373324, 218, 45, 'PPL', 'P'),
(10414, 'McKinney (historical)', 33.7783317565918, 0.589543104983487, -92.0472183227539, -1.60652702703411, 218, 4, 'PPL', 'P'),
(66730, 'McKinney Cove', 36.0283317565918, 0.628813013153359, -82.144172668457, -1.43368627439131, 218, 33, 'PPL', 'P'),
(191853, 'McKinney Springs', 29.3877792358398, 0.512913507514628, -103.075828552246, -1.79901258745787, 218, 51, 'PPL', 'P'),
(150640, 'McKinneys', 42.4786109924316, 0.741391623491788, -76.508056640625, -1.33531749268122, 218, 40, 'PPL', 'P'),
(37134, 'McKinneysburg', 38.5972213745117, 0.673648595106361, -84.2652816772461, -1.47070661038839, 218, 21, 'PPL', 'P'),
(17071, 'McKinnon', 30.788890838623, 0.53736751817109, -87.4733276367188, -1.52669757493649, 218, 12, 'PPL', 'P'),
(22986, 'McKinnon', 31.4249992370605, 0.548469704123413, -81.9269409179688, -1.42989486510542, 218, 13, 'PPL', 'P'),
(88914, 'McKinnon', 36.3161087036133, 0.633835668390221, -87.9069366455078, -1.53426547980617, 218, 50, 'PPL', 'P'),
(209593, 'McKinnon', 41.0277786254883, 0.716069821794124, -109.935279846191, -1.91873259741741, 218, 59, 'PPL', 'P'),
(49361, 'McKinsey Park', 39.0761108398438, 0.68200679302952, -76.5397186279297, -1.33587009860741, 218, 25, 'PPL', 'P'),
(150645, 'McKinstry Hollow', 42.4605598449707, 0.741076571534832, -78.5100021362305, -1.370258033025, 218, 40, 'PPL', 'P'),
(49362, 'McKinstrys Mill', 39.5341682434082, 0.690001402884856, -77.1594390869141, -1.34668626105866, 218, 25, 'PPL', 'P'),
(73419, 'McKitterick (historical)', 38.9091682434082, 0.679093095059892, -82.541389465332, -1.44061901534101, 218, 41, 'PPL', 'P'),
(56180, 'McKittrick', 38.7350006103516, 0.676053296412648, -91.4436111450195, -1.59599209439397, 218, 29, 'PPL', 'P'),
(183172, 'McKittrick', 35.3055610656738, 0.616198284859926, -119.621673583984, -2.08779206078645, 218, 6, 'PPL', 'P'),
(14193, 'McKnatt Corners', 38.9408302307129, 0.679645700986083, -75.6788864135742, -1.32084574215967, 218, 10, 'PPL', 'P'),
(76563, 'McKnight', 34.7661094665527, 0.606783078300115, -99.9119415283203, -1.74379234172924, 218, 42, 'PPL', 'P'),
(88915, 'McKnight', 35.7919387817383, 0.624687177413581, -87.1386108398438, -1.52085566476929, 218, 50, 'PPL', 'P'),
(164403, 'McKnight', 40.5550003051758, 0.707818283472623, -80.0366668701172, -1.39690335920541, 218, 45, 'PPL', 'P'),
(191855, 'McKnight', 34.9072189331055, 0.609245903097193, -100.556938171387, -1.75504965681506, 218, 51, 'PPL', 'P'),
(125371, 'McKnight and Bay', 42.1166687011719, 0.735074538807093, -72.5666732788086, -1.2665273759342, 218, 23, 'PPL', 'P'),
(42040, 'McKnight Crossing', 30.7472190856934, 0.53664020887739, -90.8963928222656, -1.58644133293468, 218, 22, 'PPL', 'P'),
(104123, 'McKnights Mill', 36.6088905334473, 0.638945675310838, -80.9027786254883, -1.41201986102686, 218, 53, 'PPL', 'P'),
(78713, 'McKnightstown', 39.8705596923828, 0.695872541245018, -77.3258285522461, -1.34959030506933, 218, 45, 'PPL', 'P'),
(78714, 'McKnightstown Station', 39.8569412231445, 0.695634854117728, -77.3247222900391, -1.34957099715143, 218, 45, 'PPL', 'P'),
(22987, 'McKown', 33.7702789306641, 0.589402556656958, -84.7055587768555, -1.47839089539771, 218, 13, 'PPL', 'P'),
(150641, 'McKownville', 42.6838912963867, 0.744974440685299, -73.8480606079102, -1.28889180382036, 218, 40, 'PPL', 'P'),
(66731, 'McKoy', 35.2630615234375, 0.615456527917312, -78.4880599975586, -1.36987507046025, 218, 33, 'PPL', 'P'),
(42044, 'McLain', 32.3680610656738, 0.564929238082593, -92.1116714477539, -1.60765194627856, 218, 22, 'PPL', 'P'),
(60835, 'McLain', 31.1086101531982, 0.542947672892647, -88.8272171020508, -1.5503274038146, 218, 30, 'PPL', 'P'),
(76561, 'McLain', 35.5663909912109, 0.62075062584828, -95.2686080932617, -1.66275088501953, 218, 42, 'PPL', 'P'),
(204854, 'McLaines Mountain', 40.6027793884277, 0.708652185788954, -111.788887023926, -1.95108414570747, 218, 52, 'PPL', 'P'),
(33229, 'McLains', 37.999439239502, 0.663215328640839, -97.2627792358398, -1.69755573730578, 218, 20, 'PPL', 'P'),
(164406, 'McLallen Corners', 41.8797187805176, 0.730938982529336, -80.0494384765625, -1.39712626578865, 218, 45, 'PPL', 'P'),
(66732, 'McLamb Crossroads', 35.2000007629395, 0.614355910017809, -78.3855590820313, -1.36808609199799, 218, 33, 'PPL', 'P'),
(164404, 'McLane', 41.9361114501953, 0.731923220289202, -80.1266708374023, -1.39847422477439, 218, 45, 'PPL', 'P'),
(4106, 'McLarty', 34.1766700744629, 0.596495420167193, -86.4019393920898, -1.50799832250056, 218, 2, 'PPL', 'P'),
(202362, 'McLaughlin', 45.8144416809082, 0.799612852294774, -100.809997558594, -1.75946637632491, 218, 49, 'PPL', 'P'),
(150642, 'McLaughlin Acres', 41.3716697692871, 0.722071854521863, -73.7027816772461, -1.28635620814649, 218, 40, 'PPL', 'P'),
(164405, 'McLaughlin Corners', 41.7261085510254, 0.728257978259953, -79.7088928222656, -1.39118262286781, 218, 45, 'PPL', 'P'),
(82332, 'McLaughlin Crossroads', 34.2230606079102, 0.597305087717604, -80.0583267211914, -1.39728139492215, 218, 48, 'PPL', 'P'),
(112440, 'McLaurin', 31.1677799224854, 0.543980380184352, -89.2172164916992, -1.55713417724474, 218, 30, 'PPL', 'P'),
(60836, 'McLaurin Heights', 32.2830581665039, 0.563445657618337, -90.10888671875, -1.57269675854878, 218, 30, 'PPL', 'P'),
(73416, 'McLean', 39.4911117553711, 0.689249925404263, -83.3369369506836, -1.45450393831635, 218, 41, 'PPL', 'P'),
(104124, 'McLean', 38.9341697692871, 0.679529454004501, -77.1777801513672, -1.34700637302169, 218, 53, 'PPL', 'P'),
(120574, 'McLean', 40.3144416809082, 0.703619743435085, -89.1697235107422, -1.55630526835545, 218, 18, 'PPL', 'P'),
(142381, 'McLean', 42.3855590820313, 0.739767561280031, -97.4683303833008, -1.70114328161023, 218, 35, 'PPL', 'P'),
(150643, 'McLean', 42.5519409179688, 0.742671472132653, -76.291389465332, -1.33153593709136, 218, 40, 'PPL', 'P'),
(191854, 'McLean', 35.2324981689453, 0.614923096750969, -100.59944152832, -1.75579148033671, 218, 51, 'PPL', 'P'),
(10416, 'McLean (historical)', 34.3480606079102, 0.599486749282597, -92.6388931274414, -1.616853700477, 218, 4, 'PPL', 'P'),
(88916, 'McLean (historical)', 35.4727783203125, 0.619116776519517, -87.5861129760742, -1.52866605045622, 218, 50, 'PPL', 'P'),
(110361, 'McLean (historical)', 39.0374984741211, 0.681332880115676, -79.9580612182617, -1.39553143176986, 218, 58, 'PPL', 'P'),
(13156, 'McLean Gardens', 38.9372215270996, 0.679582717226303, -77.0755615234375, -1.34522232140744, 218, 9, 'PPL', 'P'),
(104125, 'McLean Hamlet', 38.9397201538086, 0.679626326489153, -77.2191696166992, -1.34772875546737, 218, 53, 'PPL', 'P'),
(104126, 'McLean Manor', 38.9269409179688, 0.679403286747859, -77.1788864135742, -1.34702568093959, 218, 53, 'PPL', 'P'),
(190469, 'McLeans', 38.047779083252, 0.664059018074176, -117.651107788086, -2.05339919952084, 218, 39, 'PPL', 'P'),
(208081, 'McLeans Orchard (historical)', 47.7636108398438, 0.833632271796527, -120.069442749023, -2.09560710700529, 218, 56, 'PPL', 'P'),
(27856, 'McLeansboro', 38.0933303833008, 0.664854038238592, -88.5355606079102, -1.54523703770702, 218, 18, 'PPL', 'P'),
(66735, 'McLeansville', 36.1072196960449, 0.63018986743693, -79.6588897705078, -1.39030990497859, 218, 33, 'PPL', 'P'),
(73417, 'McLeish', 39.5349998474121, 0.690015917112797, -82.1022186279297, -1.43295403824959, 218, 41, 'PPL', 'P'),
(17072, 'McLellan', 30.9863891601563, 0.540814514149007, -86.8863906860352, -1.51645359264545, 218, 12, 'PPL', 'P'),
(42041, 'McLemore Acres', 30.4569396972656, 0.53157387779865, -91.003059387207, -1.5883030156947, 218, 22, 'PPL', 'P'),
(88917, 'McLemoresville', 35.9872207641602, 0.628095490976665, -88.5744400024414, -1.54591561115278, 218, 50, 'PPL', 'P'),
(4107, 'McLendon', 32.1547203063965, 0.561205739404499, -85.0944366455078, -1.48517809459383, 218, 2, 'PPL', 'P'),
(96103, 'McLendon', 32.8461112976074, 0.573272788619757, -96.3897171020508, -1.68231792849667, 218, 51, 'PPL', 'P'),
(22988, 'McLendon (historical)', 31.2894401550293, 0.546103751810986, -84.940559387207, -1.48249242979254, 218, 13, 'PPL', 'P'),
(22989, 'McLendon Crossroads', 32.9925003051758, 0.575827758790551, -84.6266708374023, -1.47701404111414, 218, 13, 'PPL', 'P'),
(96104, 'McLendon-Chisholm', 32.8422203063965, 0.57320487801196, -96.3802795410156, -1.68215321198325, 218, 51, 'PPL', 'P'),
(42042, 'McLeod', 29.646390914917, 0.517427132798636, -90.5177764892578, -1.57983323132186, 218, 22, 'PPL', 'P'),
(60837, 'McLeod', 33.0922203063965, 0.577568201141945, -88.4516677856445, -1.5437728317397, 218, 30, 'PPL', 'P'),
(96106, 'McLeod', 32.9444389343262, 0.574988929626204, -94.0800018310547, -1.6420057922342, 218, 51, 'PPL', 'P'),
(140479, 'McLeod', 46.3936080932617, 0.809721213107305, -97.2991714477539, -1.69819090122576, 218, 34, 'PPL', 'P'),
(197008, 'McLeod', 45.6627807617188, 0.796965869908317, -110.115280151367, -1.92187419539732, 218, 31, 'PPL', 'P'),
(201206, 'McLeod', 42.6624984741211, 0.74460106550047, -122.686668395996, -2.1412863118126, 218, 43, 'PPL', 'P'),
(132016, 'McLeods Corner', 46.3033294677734, 0.80814555384836, -85.3633270263672, -1.48987111706677, 218, 27, 'PPL', 'P'),
(22990, 'McLeods Mill', 30.9713897705078, 0.540552725413852, -82.3888931274414, -1.43795745214758, 218, 13, 'PPL', 'P'),
(76564, 'McLoud', 35.4358291625977, 0.618471892061554, -97.0911102294922, -1.69455954792139, 218, 42, 'PPL', 'P'),
(208082, 'McLoughlin', 45.6108283996582, 0.796059130136172, -122.599716186523, -2.13976870946542, 218, 56, 'PPL', 'P'),
(208083, 'McLoughlin Heights', 45.6241683959961, 0.796291956994472, -122.599716186523, -2.13976870946542, 218, 56, 'PPL', 'P'),
(33230, 'McLouth', 39.1958312988281, 0.684096309220796, -95.2080612182617, -1.66169414269899, 218, 20, 'PPL', 'P'),
(73418, 'McLuney', 39.7402801513672, 0.693598734306308, -82.1025009155273, -1.43295896509761, 218, 41, 'PPL', 'P'),
(88919, 'McMahan', 35.915828704834, 0.626849464481644, -83.6727828979492, -1.46036555587562, 218, 50, 'PPL', 'P'),
(96107, 'McMahan', 29.8525009155273, 0.521024430930574, -97.519172668457, -1.70203064688544, 218, 51, 'PPL', 'P'),
(76565, 'McMahon', 36.3158302307129, 0.633830808121232, -97.2452774047852, -1.69725027272875, 218, 42, 'PPL', 'P'),
(183173, 'McMahons (historical)', 39.5930595397949, 0.691029249907572, -120.95832824707, -2.11112108561944, 218, 6, 'PPL', 'P'),
(42043, 'McManus', 30.8341693878174, 0.538157777935058, -91.1361083984375, -1.59062515900719, 218, 22, 'PPL', 'P'),
(183174, 'McManus', 38.7991714477539, 0.677173288809081, -120.533058166504, -2.10369872250333, 218, 6, 'PPL', 'P'),
(132017, 'McManus Corner', 44.540828704834, 0.777384112466155, -85.4561080932617, -1.49149045216759, 218, 27, 'PPL', 'P'),
(96109, 'McMasters Colonia', 27.742000579834, 0.484189251208279, -98.0989990234375, -1.71215052586969, 218, 51, 'PPL', 'P'),
(150644, 'McMasters Crossing', 44.3530616760254, 0.774106959586758, -74.2161102294922, -1.29531548152768, 218, 40, 'PPL', 'P'),
(110362, 'McMechen', 39.9880599975586, 0.697923308442433, -80.7316665649414, -1.40903339218045, 218, 58, 'PPL', 'P'),
(17073, 'McMeekin', 29.5949993133545, 0.516530180143497, -82.0130615234375, -1.43139795322466, 218, 12, 'PPL', 'P'),
(110363, 'McMellin (historical)', 39.7052803039551, 0.692987871731271, -79.8116683959961, -1.39297639502003, 218, 58, 'PPL', 'P'),
(164407, 'McMichael', 40.9949989318848, 0.715497708212948, -75.3986129760742, -1.31595404786942, 218, 45, 'PPL', 'P'),
(22992, 'McMichael Crossroads', 33.3338890075684, 0.581786115676413, -83.9652786254883, -1.46547056936919, 218, 13, 'PPL', 'P'),
(178611, 'McMicken', 33.4972190856934, 0.584636763307234, -112.426391601563, -1.96221069958377, 218, 5, 'PPL', 'P'),
(208084, 'McMicken Heights', 47.4511108398438, 0.828178117884045, -122.281936645508, -2.13422241017922, 218, 56, 'PPL', 'P'),
(60839, 'McMillan', 33.1699981689453, 0.578925680928586, -89.1091690063477, -1.55524839287685, 218, 30, 'PPL', 'P'),
(66736, 'McMillan', 34.8783302307129, 0.608741700123813, -78.9530563354492, -1.37799078756616, 218, 33, 'PPL', 'P'),
(76567, 'McMillan', 34.0897216796875, 0.594977884399039, -96.9369430541992, -1.69186882311402, 218, 42, 'PPL', 'P'),
(88920, 'McMillan', 36.0436096191406, 0.629079662157503, -83.791389465332, -1.46243563099094, 218, 50, 'PPL', 'P'),
(96110, 'McMillan', 31.3194103240967, 0.546626829938591, -98.6515274047852, -1.72179396533492, 218, 51, 'PPL', 'P'),
(132018, 'McMillan', 46.3388900756836, 0.808766203540403, -85.6872177124023, -1.49552407595462, 218, 27, 'PPL', 'P'),
(164408, 'McMillan', 40.1327781677246, 0.700449116999291, -80.4466705322266, -1.40405927305445, 218, 45, 'PPL', 'P'),
(175234, 'McMillan', 44.7422218322754, 0.780899085630896, -90.163330078125, -1.57364697442572, 218, 57, 'PPL', 'P'),
(195308, 'McMillan', 42.5433311462402, 0.742521203268145, -114.420562744141, -1.99701555187001, 218, 17, 'PPL', 'P'),
(10417, 'McMillan Corner', 33.3869400024414, 0.582712030208406, -91.3083267211914, -1.59363093577151, 218, 4, 'PPL', 'P'),
(132019, 'McMillan Corner', 46.3102798461914, 0.808266860836013, -85.6888885498047, -1.49555323756856, 218, 27, 'PPL', 'P'),
(178612, 'McMillianville', 33.5572204589844, 0.58568398482688, -110.679168701172, -1.93171590720571, 218, 5, 'PPL', 'P'),
(208085, 'McMillin', 47.1399993896484, 0.822748198737483, -122.235282897949, -2.13340814867593, 218, 56, 'PPL', 'P'),
(164410, 'McMinns Summit', 41.2027816772461, 0.719124201248336, -78.7755584716797, -1.37489286542812, 218, 45, 'PPL', 'P'),
(88922, 'McMinnville', 35.6833305358887, 0.62279160592869, -85.7699966430664, -1.49696884084599, 218, 50, 'PPL', 'P'),
(201207, 'McMinnville', 45.2102813720703, 0.789068265695686, -123.19750213623, -2.15020204250997, 218, 43, 'PPL', 'P'),
(156411, 'McMorran', 40.3894386291504, 0.704928687110859, -83.8483276367188, -1.4634293895517, 218, 41, 'PPL', 'P'),
(197009, 'McMullan', 46.3441696166992, 0.80885834891412, -111.712783813477, -1.94975589411379, 218, 31, 'PPL', 'P'),
(4109, 'McMullen', 33.148609161377, 0.578552372322784, -88.1763916015625, -1.53896835597514, 218, 2, 'PPL', 'P'),
(104127, 'McMullen', 38.348331451416, 0.669304646473305, -78.4580612182617, -1.36935149298994, 218, 53, 'PPL', 'P'),
(88923, 'McMullens', 35.7163887023926, 0.623368579778856, -84.1727828979492, -1.46909220213559, 218, 50, 'PPL', 'P'),
(56183, 'McMullin', 36.9541702270508, 0.644971942804497, -89.6202774047852, -1.56416891726418, 218, 29, 'PPL', 'P'),
(104128, 'McMullin', 36.8141708374023, 0.642528492504349, -81.5783309936523, -1.42381047412097, 218, 53, 'PPL', 'P'),
(183175, 'McMullin (historical)', 36.6575012207031, 0.63979409185511, -119.967781066895, -2.09383277592903, 218, 6, 'PPL', 'P'),
(164409, 'McMurray', 40.2777786254883, 0.702979852404167, -80.0841674804688, -1.39773240125275, 218, 45, 'PPL', 'P'),
(208086, 'McMurray', 48.3163909912109, 0.843280105477558, -122.234169006348, -2.13338870759997, 218, 56, 'PPL', 'P'),
(10418, 'McNab', 33.6611099243164, 0.587497198055061, -93.8324966430664, -1.63768601178804, 218, 4, 'PPL', 'P'),
(120576, 'McNabb', 41.1769409179688, 0.718673194917731, -89.2091674804688, -1.55699369549723, 218, 18, 'PPL', 'P'),
(10419, 'McNair', 36.0502815246582, 0.629196108876167, -94.1761093139648, -1.64368318424678, 218, 4, 'PPL', 'P'),
(60841, 'McNair', 31.6383304595947, 0.552193036353939, -91.0419387817383, -1.58898158914045, 218, 30, 'PPL', 'P'),
(96112, 'McNair', 29.8038902282715, 0.520176014386302, -95.0213928222656, -1.65843616457944, 218, 51, 'PPL', 'P'),
(136804, 'McNair', 47.3199996948242, 0.825889796717395, -91.6725006103516, -1.59998696918715, 218, 28, 'PPL', 'P'),
(66737, 'McNair Crossing', 35.9113883972168, 0.626771966493922, -77.5952835083008, -1.35429318123831, 218, 33, 'PPL', 'P'),
(22993, 'McNair Terrace', 33.4113883972168, 0.583138735194064, -82.1172180175781, -1.43321582698475, 218, 13, 'PPL', 'P'),
(96113, 'McNair Village', 31.1338901519775, 0.543388892106246, -97.7588882446289, -1.70621447295795, 218, 51, 'PPL', 'P'),
(88924, 'McNairy', 35.311939239502, 0.616309604993492, -88.6272201538086, -1.54683679857384, 218, 50, 'PPL', 'P'),
(150646, 'McNalls', 43.1655616760254, 0.753381174719325, -78.5747222900391, -1.37138761280136, 218, 40, 'PPL', 'P'),
(116794, 'McNally', 42.940559387207, 0.749454143954921, -96.3905563354492, -1.68233257588267, 218, 16, 'PPL', 'P'),
(128105, 'McNally', 46.9233283996582, 0.818966576568597, -68.583610534668, -1.19700981673542, 218, 26, 'PPL', 'P'),
(197010, 'McNamara', 46.9113883972168, 0.818758184213299, -113.676666259766, -1.98403210892366, 218, 31, 'PPL', 'P'),
(37135, 'McNary', 37.2152786254883, 0.64952914406184, -87.3294372558594, -1.52418621402855, 218, 21, 'PPL', 'P'),
(42045, 'McNary', 30.9872207641602, 0.540829028376948, -92.5761108398438, -1.61575794284649, 218, 22, 'PPL', 'P'),
(164411, 'McNary', 40.2758293151855, 0.702945830521241, -80.2191696166992, -1.4000886330272, 218, 45, 'PPL', 'P'),
(178613, 'McNary', 34.0736083984375, 0.594696654587926, -109.856391906738, -1.91735574313383, 218, 5, 'PPL', 'P'),
(191856, 'McNary', 31.2480602264404, 0.54538153581287, -105.795829772949, -1.84648556441741, 218, 51, 'PPL', 'P'),
(201208, 'McNary', 45.9194412231445, 0.801445440019884, -119.288063049316, -2.08196945853716, 218, 43, 'PPL', 'P'),
(178614, 'McNary Place', 34.2961082458496, 0.598580009510453, -112.490280151367, -1.96332576513218, 218, 5, 'PPL', 'P'),
(56185, 'McNatt', 36.7355613708496, 0.641156498489767, -94.3125, -1.64606365078715, 218, 29, 'PPL', 'P'),
(22994, 'McNatt Falls', 31.9699993133545, 0.557981749878362, -82.4716720581055, -1.43940221703895, 218, 13, 'PPL', 'P'),
(123158, 'McNatts', 40.624439239502, 0.70903022150569, -85.39111328125, -1.49035607870127, 218, 19, 'PPL', 'P'),
(175236, 'McNaughton', 45.7324981689453, 0.798182668210374, -89.5441665649414, -1.56284053251245, 218, 57, 'PPL', 'P'),
(60842, 'McNeal', 32.041389465332, 0.559227743083869, -89.1536102294922, -1.55602403854434, 218, 30, 'PPL', 'P'),
(178615, 'McNeal', 31.601110458374, 0.551543424785041, -109.669441223145, -1.91409283816627, 218, 5, 'PPL', 'P'),
(17074, 'McNeal (historical)', 30.4283294677734, 0.53107453509426, -85.0327835083008, -1.48410204435538, 218, 12, 'PPL', 'P'),
(104129, 'McNeals Corner', 37.7916717529297, 0.65958910192156, -76.4752807617188, -1.33474544567907, 218, 53, 'PPL', 'P'),
(183176, 'McNear', 38.2286109924316, 0.667215130282029, -122.613059997559, -2.14000160290275, 218, 6, 'PPL', 'P'),
(183177, 'McNears Beach', 37.9933280944824, 0.663108669039182, -122.452217102051, -2.1371943647977, 218, 6, 'PPL', 'P'),
(42046, 'McNeely', 31.5055599212646, 0.549875753310434, -92.6833267211914, -1.61762921298643, 218, 22, 'PPL', 'P'),
(164412, 'McNees', 40.7975006103516, 0.712050712235031, -79.4452819824219, -1.38658174576859, 218, 45, 'PPL', 'P'),
(4110, 'McNeiders (historical)', 31.9916706085205, 0.558359985332181, -88.0013885498047, -1.53591397652093, 218, 2, 'PPL', 'P'),
(10420, 'McNeil', 33.3477783203125, 0.582028529914637, -93.209716796875, -1.62681645295693, 218, 4, 'PPL', 'P'),
(96115, 'McNeil', 30.4527797698975, 0.531501273369432, -97.7202835083008, -1.70554069320216, 218, 51, 'PPL', 'P'),
(183178, 'McNeil', 34.1713905334473, 0.596403274793476, -118.347778320313, -2.06555839410982, 218, 6, 'PPL', 'P'),
(88926, 'McNeil Farms', 35.8419418334961, 0.6255598953028, -86.5272216796875, -1.51018491091357, 218, 50, 'PPL', 'P'),
(60844, 'McNeill', 30.6686096191406, 0.535268214862808, -89.6383285522461, -1.56448396922114, 218, 30, 'PPL', 'P'),
(110364, 'McNeill', 39.1399993896484, 0.683121858577936, -78.9136123657227, -1.37730236042437, 218, 58, 'PPL', 'P'),
(4111, 'McNeils (historical)', 32.3255615234375, 0.564187481139979, -87.9436111450195, -1.53490557057417, 218, 2, 'PPL', 'P'),
(82333, 'McNeils (historical)', 34.667781829834, 0.605066937293668, -79.9416732788086, -1.39524540826878, 218, 48, 'PPL', 'P'),
(189008, 'McNess Crossing', 36.6916694641113, 0.640390440202206, -103.062217712402, -1.79877503348864, 218, 38, 'PPL', 'P'),
(14194, 'McNichol Place', 38.7516708374023, 0.676344246761739, -75.1608276367188, -1.31180391078469, 218, 10, 'PPL', 'P'),
(189009, 'McNierney', 34.1936111450195, 0.596791097627219, -106.905563354492, -1.86585406923528, 218, 38, 'PPL', 'P'),
(96116, 'McNorton', 27.8116703033447, 0.485405217272496, -97.5388870239258, -1.70237472729828, 218, 51, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(120578, 'McNulta', 40.3708305358887, 0.704603914615924, -88.4891662597656, -1.54442730357759, 218, 18, 'PPL', 'P'),
(201209, 'McNulty', 45.8405609130859, 0.800068718894368, -122.840560913086, -2.14397224293, 218, 43, 'PPL', 'P'),
(42047, 'McNutt', 31.3138904571533, 0.546530490086158, -92.6474990844727, -1.61700390276248, 218, 22, 'PPL', 'P'),
(60843, 'McNutt', 33.6472206115723, 0.587254783816836, -90.3722229003906, -1.57729284195804, 218, 30, 'PPL', 'P'),
(110365, 'McNutt', 38.6949996948242, 0.675355148732884, -80.6694412231445, -1.40794735508791, 218, 58, 'PPL', 'P'),
(104130, 'McNutt (historical)', 37.997501373291, 0.663181506494995, -79.2563934326172, -1.38328501865518, 218, 53, 'PPL', 'P'),
(22996, 'McNutt Creek', 33.9208297729492, 0.592030164546484, -83.4111099243164, -1.45579850092224, 218, 13, 'PPL', 'P'),
(116795, 'McPaul', 40.8219413757324, 0.712477284062634, -95.8024978637695, -1.67206901935761, 218, 16, 'PPL', 'P'),
(10424, 'McPhearson', 36.1402816772461, 0.630766907866123, -92.2525024414063, -1.61010991080665, 218, 4, 'PPL', 'P'),
(132022, 'McPhees Landing', 46.3722190856934, 0.809347904501504, -85.4199981689453, -1.49086021509562, 218, 27, 'PPL', 'P'),
(88927, 'McPheeter Bend', 36.4900016784668, 0.636870673347503, -82.7219390869141, -1.44377020070084, 218, 50, 'PPL', 'P'),
(164414, 'McPherron', 40.7724990844727, 0.711614353290421, -78.6158294677734, -1.37210506839903, 218, 45, 'PPL', 'P'),
(17075, 'McPherson', 30.2474994659424, 0.527918456175921, -82.0802764892578, -1.43257107568484, 218, 12, 'PPL', 'P'),
(22995, 'McPherson', 33.9474983215332, 0.592495618526003, -84.9066696166992, -1.48190094171443, 218, 13, 'PPL', 'P'),
(33231, 'McPherson', 38.3708305358887, 0.669697329576038, -97.6638870239258, -1.70455638886327, 218, 20, 'PPL', 'P'),
(49365, 'McPherson', 39.4036102294922, 0.687722735677157, -77.1986083984375, -1.34736989451048, 218, 25, 'PPL', 'P'),
(116818, 'McPherson', 41.2402801513672, 0.719778673086223, -94.1183319091797, -1.64267477830003, 218, 16, 'PPL', 'P'),
(145723, 'McPherson', 40.6066703796387, 0.708720096396751, -74.8480606079102, -1.3063450963403, 218, 37, 'PPL', 'P'),
(183179, 'McPherson', 33.7877807617188, 0.58970802123399, -117.826110839844, -2.05645357897505, 218, 6, 'PPL', 'P'),
(110366, 'McPherson Addition', 39.2174987792969, 0.684474478095587, -81.6808319091797, -1.42559945258323, 218, 58, 'PPL', 'P'),
(150647, 'McPherson Cove', 42.7897186279297, 0.746821476059323, -77.7072219848633, -1.35624687621399, 218, 40, 'PPL', 'P'),
(4112, 'McPherson Landing', 33.0761108398438, 0.57728703790986, -87.5886077880859, -1.52870959314005, 218, 2, 'PPL', 'P'),
(150648, 'McPherson Point', 42.7799987792969, 0.746651832697885, -77.7138900756836, -1.35636325635362, 218, 40, 'PPL', 'P'),
(164415, 'McPhersons Corner', 41.3994407653809, 0.722556549840257, -79.5852813720703, -1.38902519606874, 218, 45, 'PPL', 'P'),
(82334, 'McPhersonville', 32.6916694641113, 0.570577270122433, -80.9194412231445, -1.4123106782179, 218, 48, 'PPL', 'P'),
(56186, 'McPheters Ford (historical)', 37.8219413757324, 0.660117406502804, -92.8722229003906, -1.62092607325789, 218, 29, 'PPL', 'P'),
(37137, 'McQuady', 37.7083282470703, 0.658134483334159, -86.5188903808594, -1.51003950231805, 218, 21, 'PPL', 'P'),
(156410, 'McQuaid (historical)', 40.7958297729492, 0.712021550621095, -81.7458267211914, -1.42673382604955, 218, 41, 'PPL', 'P'),
(76570, 'McQueen', 34.6666717529297, 0.605047562796737, -99.7013931274414, -1.7401175788991, 218, 42, 'PPL', 'P'),
(120577, 'McQueen', 42.061939239502, 0.734119329503109, -88.3847198486328, -1.54260436981143, 218, 18, 'PPL', 'P'),
(178617, 'McQueen', 33.3800010681152, 0.582590922957835, -111.830558776855, -1.95181145500117, 218, 5, 'PPL', 'P'),
(197011, 'McQueen', 46.0202789306641, 0.803205390026263, -112.494438171387, -1.96339833627189, 218, 31, 'PPL', 'P'),
(82335, 'McQueen Crossroads', 34.0738906860352, 0.594701581435943, -79.1438903808594, -1.38132146998347, 218, 48, 'PPL', 'P'),
(96117, 'McQueeney', 29.5919399261475, 0.516476783763641, -98.0330581665039, -1.71099964080461, 218, 51, 'PPL', 'P'),
(17080, 'McQueens Village (historical)', 27.7833309173584, 0.484910601679041, -82.4333267211914, -1.43873296465701, 218, 12, 'PPL', 'P'),
(123159, 'McQuinn Estates', 40.4375, 0.705767516275207, -86.9588928222656, -1.5177189936374, 218, 19, 'PPL', 'P'),
(104131, 'McQuire', 39.2216682434082, 0.684547248972374, -78.2772216796875, -1.36619524762403, 218, 53, 'PPL', 'P'),
(4113, 'McRae', 31.0586109161377, 0.542075021582455, -86.2613906860352, -1.50554528482048, 218, 2, 'PPL', 'P'),
(10422, 'McRae', 35.1127815246582, 0.61283364713872, -91.8222198486328, -1.60260006284873, 218, 4, 'PPL', 'P'),
(22997, 'McRae', 32.0677795410156, 0.559688336794399, -82.9008331298828, -1.44689249076285, 218, 13, 'PPL', 'P'),
(104132, 'McRae', 37.461109161377, 0.65381969631504, -78.2827835083008, -1.36629231984577, 218, 53, 'PPL', 'P'),
(197012, 'McRae (historical)', 45.8783302307129, 0.80072791784319, -107.119438171387, -1.86958688897719, 218, 31, 'PPL', 'P'),
(60845, 'McRaney', 31.6094398498535, 0.551688800091046, -89.7172164916992, -1.56586082350471, 218, 30, 'PPL', 'P'),
(60846, 'McRaven', 32.3036117553711, 0.563804385417171, -90.3269424438477, -1.57650254890455, 218, 30, 'PPL', 'P'),
(4114, 'McRitchie Mill', 32.6191711425781, 0.569311935709509, -85.6324996948242, -1.49456906638772, 218, 2, 'PPL', 'P'),
(37138, 'McRoberts', 37.2075004577637, 0.649393389425273, -82.6719436645508, -1.44289761596968, 218, 21, 'PPL', 'P'),
(110367, 'McRoss', 37.9886093139648, 0.663026310782471, -80.7486114501953, -1.4093291362195, 218, 58, 'PPL', 'P'),
(4115, 'McShan', 33.3808288574219, 0.582605370606749, -88.1416702270508, -1.53836235366909, 218, 2, 'PPL', 'P'),
(128106, 'McShea', 46.7619400024414, 0.816149817662648, -67.853889465332, -1.18427378145434, 218, 26, 'PPL', 'P'),
(112786, 'McSherry', 39.785831451416, 0.694393754470724, -77.0138931274414, -1.34414600485289, 218, 45, 'PPL', 'P'),
(78715, 'McSherrystown', 39.8072204589844, 0.694767063076526, -77.0116729736328, -1.34410725585902, 218, 45, 'PPL', 'P'),
(78717, 'McSparran', 39.7649993896484, 0.694030166402901, -76.2083282470703, -1.33008624535198, 218, 45, 'PPL', 'P'),
(60847, 'McSwain', 31.3144397735596, 0.546540077466082, -88.976936340332, -1.55294049747619, 218, 30, 'PPL', 'P'),
(82336, 'McSwain Gardens', 34.8752784729004, 0.608688436902012, -82.3333282470703, -1.43698766203663, 218, 48, 'PPL', 'P'),
(22998, 'McTier', 31.8058300018311, 0.555116454861546, -82.2461090087891, -1.43546539915754, 218, 13, 'PPL', 'P'),
(197013, 'McTwiggan (historical)', 47.0055618286133, 0.820401820659068, -107.70832824707, -1.87986495973019, 218, 31, 'PPL', 'P'),
(208087, 'McVan', 47.4513893127441, 0.828182978153035, -122.287780761719, -2.13432440924897, 218, 56, 'PPL', 'P'),
(231, 'McVay', 31.6066703796387, 0.551640463717261, -87.8955612182617, -1.53406694114691, 218, 2, 'PPL', 'P'),
(178616, 'McVay', 33.8038902282715, 0.589989184466075, -113.83805847168, -1.98684893440863, 218, 5, 'PPL', 'P'),
(33235, 'McVays Corner', 38.1588897705078, 0.665998265400945, -98.2519378662109, -1.71481981223027, 218, 20, 'PPL', 'P'),
(37139, 'McVeigh', 37.538330078125, 0.655167455563701, -82.2561111450195, -1.43563996936699, 218, 21, 'PPL', 'P'),
(27858, 'McVey', 39.389720916748, 0.687480321438933, -89.7463912963867, -1.56637001990513, 218, 18, 'PPL', 'P'),
(110368, 'McVey', 37.7127799987793, 0.658212181058962, -81.2052764892578, -1.41729944472989, 218, 58, 'PPL', 'P'),
(164416, 'McVeytown', 40.4991683959961, 0.706843832829762, -77.7416687011719, -1.35684808483007, 218, 45, 'PPL', 'P'),
(4116, 'McVille', 34.2861099243164, 0.598405505880025, -86.1277770996094, -1.50321328781196, 218, 2, 'PPL', 'P'),
(30476, 'McVille', 39.1530609130859, 0.683349825167247, -86.7386093139648, -1.51387432112971, 218, 19, 'PPL', 'P'),
(37140, 'McVille', 38.9775009155273, 0.680285725175056, -84.8241729736328, -1.48046110367108, 218, 21, 'PPL', 'P'),
(60848, 'McVille', 32.9313888549805, 0.574761162773975, -89.621940612793, -1.56419794572006, 218, 30, 'PPL', 'P'),
(140480, 'McVille', 47.7638893127441, 0.833637132065517, -98.1769409179688, -1.7135108685545, 218, 34, 'PPL', 'P'),
(164418, 'McVille', 40.725830078125, 0.710799825471021, -79.6030578613281, -1.38933545433573, 218, 45, 'PPL', 'P'),
(156412, 'McVitty', 40.7616691589355, 0.711425335432053, -83.5374984741211, -1.45800439725315, 218, 41, 'PPL', 'P'),
(4117, 'McWer', 31.8611106872559, 0.556081284834968, -87.695556640625, -1.53057620274808, 218, 2, 'PPL', 'P'),
(22999, 'McWhorter', 33.6130599975586, 0.586658568627795, -84.836669921875, -1.48067921656436, 218, 13, 'PPL', 'P'),
(37141, 'McWhorter', 37.2341690063477, 0.649858843404792, -84, -1.46607657167524, 218, 21, 'PPL', 'P'),
(110369, 'McWhorter', 39.1272201538086, 0.682898818836642, -80.383056640625, -1.402949001196, 218, 58, 'PPL', 'P'),
(4119, 'McWilliams', 31.8308296203613, 0.555552780516642, -87.0938873291016, -1.52007509225379, 218, 2, 'PPL', 'P'),
(164419, 'McWilliams', 40.9658317565918, 0.714988644970579, -79.2522201538086, -1.38321218119937, 218, 45, 'PPL', 'P'),
(76571, 'McWillie', 36.535831451416, 0.637670553780908, -98.3541717529297, -1.71660413016063, 218, 42, 'PPL', 'P'),
(156413, 'McZena', 40.6972198486328, 0.710300482766631, -82.1374969482422, -1.43356976109362, 218, 41, 'PPL', 'P'),
(88932, 'Meacham', 36.1324996948242, 0.630631086650529, -89.3483276367188, -1.55942249841139, 218, 50, 'PPL', 'P'),
(201210, 'Meacham', 45.5066719055176, 0.794241256376084, -118.420280456543, -2.06682379510177, 218, 43, 'PPL', 'P'),
(56187, 'Meacham Park', 38.5625, 0.673042592800313, -90.4022216796875, -1.57781641942835, 218, 29, 'PPL', 'P'),
(76572, 'Mead', 33.999439239502, 0.593402158561066, -96.5088882446289, -1.68439785730803, 218, 42, 'PPL', 'P'),
(110370, 'Mead', 37.624439239502, 0.65667034394586, -81.2608337402344, -1.41826910168279, 218, 58, 'PPL', 'P'),
(142384, 'Mead', 41.2277793884277, 0.719560493613918, -96.4875030517578, -1.68402461528125, 218, 35, 'PPL', 'P'),
(194319, 'Mead', 40.2333297729492, 0.702204073578626, -104.998062133789, -1.8325618924482, 218, 7, 'PPL', 'P'),
(208088, 'Mead', 47.7675018310547, 0.833700182404324, -117.353889465332, -2.04821176119153, 218, 56, 'PPL', 'P'),
(42048, 'Mead (historical)', 31.4011096954346, 0.548052752965247, -92.5952835083008, -1.61609256903745, 218, 22, 'PPL', 'P'),
(150649, 'Mead Corner', 42.8369407653809, 0.747645657837676, -77.148063659668, -1.34648772239939, 218, 40, 'PPL', 'P'),
(183181, 'Mead Valley', 33.8333282470703, 0.590502974819379, -117.295280456543, -2.04718884101683, 218, 6, 'PPL', 'P'),
(73421, 'Meade', 39.5047187805176, 0.689487412794471, -82.8769378662109, -1.44647543973614, 218, 41, 'PPL', 'P'),
(104134, 'Meade', 37.1297187805176, 0.648035843059606, -82.561393737793, -1.44096815575992, 218, 53, 'PPL', 'P'),
(132023, 'Meade', 42.7177810668945, 0.745565928763406, -82.8744430541992, -1.44643189705232, 218, 27, 'PPL', 'P'),
(187800, 'Meade', 37.2855606079102, 0.650755796059931, -100.339721679688, -1.75125851384528, 218, 20, 'PPL', 'P'),
(4120, 'Meade (historical)', 33.6597213745117, 0.587472963289141, -85.977783203125, -1.50059540046041, 218, 2, 'PPL', 'P'),
(88928, 'Meade (historical)', 35.8088912963867, 0.624983054610689, -85.4711074829102, -1.49175224090275, 218, 50, 'PPL', 'P'),
(49366, 'Meade Heights', 39.1183280944824, 0.682743623124118, -76.7266693115234, -1.33913300357497, 218, 25, 'PPL', 'P'),
(164421, 'Meade Heights', 40.2066688537598, 0.701738752757162, -76.7544403076172, -1.33961769889337, 218, 45, 'PPL', 'P'),
(49367, 'Meade Village', 39.1252784729004, 0.682864930111771, -76.7055587768555, -1.33876455523816, 218, 25, 'PPL', 'P'),
(49368, 'Meadedale', 39.0952796936035, 0.682341352641461, -76.7172164916992, -1.33896802074544, 218, 25, 'PPL', 'P'),
(144128, 'Meaderboro Corner', 43.2986106872559, 0.75570331803182, -71.0297164916992, -1.23970241953827, 218, 36, 'PPL', 'P'),
(39, 'Meaders', 32.8880615234375, 0.574004958182447, -96.8122177124023, -1.68969195523899, 218, 51, 'PPL', 'P'),
(197014, 'Meaderville', 46.0222206115723, 0.803239278751134, -112.504440307617, -1.96357290648134, 218, 31, 'PPL', 'P'),
(88929, 'Meades Quarry', 35.952220916748, 0.627484628401628, -83.8655624389648, -1.46373019359682, 218, 50, 'PPL', 'P'),
(78718, 'Meadetown', 39.8163909912109, 0.69492711905804, -76.5202789306641, -1.33553081188453, 218, 45, 'PPL', 'P'),
(104135, 'Meadewood', 37.3413887023926, 0.651730180123763, -79.9313888549805, -1.39506591121131, 218, 53, 'PPL', 'P'),
(71112, 'Meadford Farms', 39.8636093139648, 0.695751234257365, -74.7427825927734, -1.3045076483462, 218, 37, 'PPL', 'P'),
(110372, 'Meadland', 39.3216705322266, 0.686292618171785, -80.158332824707, -1.39902683070058, 218, 58, 'PPL', 'P'),
(37143, 'Meador', 36.8911094665527, 0.643871324904994, -86.1761093139648, -1.50405684408724, 218, 21, 'PPL', 'P'),
(104136, 'Meador', 37.2002792358398, 0.649267355326685, -79.6566696166992, -1.39027115598473, 218, 53, 'PPL', 'P'),
(110373, 'Meador', 37.6188888549805, 0.656573471461209, -82.0625, -1.43226081741785, 218, 58, 'PPL', 'P'),
(82337, 'Meador (historical)', 34.6852798461914, 0.605372335291672, -81.508056640625, -1.42258395528093, 218, 48, 'PPL', 'P'),
(96118, 'Meador Grove', 31.2852802276611, 0.546031147381768, -97.456672668457, -1.70093981610294, 218, 51, 'PPL', 'P'),
(56188, 'Meadors Ford', 36.6191711425781, 0.639125105789282, -94.2958297729492, -1.64577270043806, 218, 29, 'PPL', 'P'),
(88930, 'Meadorville', 36.4744415283203, 0.636599097495342, -86.0361099243164, -1.50161339378709, 218, 50, 'PPL', 'P'),
(23000, 'Meadow', 33.9780616760254, 0.593029049692346, -84.0975036621094, -1.4677783316118, 218, 13, 'PPL', 'P'),
(88931, 'Meadow', 35.6974983215332, 0.623038880435904, -84.164436340332, -1.46894652722396, 218, 50, 'PPL', 'P'),
(110375, 'Meadow', 39.0902786254883, 0.682254067536734, -78.9541702270508, -1.37801022864212, 218, 58, 'PPL', 'P'),
(132026, 'Meadow', 44.2644386291504, 0.77256019562564, -83.6436080932617, -1.45985635947519, 218, 27, 'PPL', 'P'),
(142386, 'Meadow', 41.0161094665527, 0.71586615654976, -96.1563873291016, -1.67824555571578, 218, 35, 'PPL', 'P'),
(191857, 'Meadow', 33.3369407653809, 0.581839378898214, -102.206108093262, -1.78383310187664, 218, 51, 'PPL', 'P'),
(192694, 'Meadow', 38.8858299255371, 0.678685764571164, -112.409721374512, -1.96191974923468, 218, 52, 'PPL', 'P'),
(202366, 'Meadow', 45.5291709899902, 0.794633939478816, -102.215827941895, -1.78400274523808, 218, 49, 'PPL', 'P'),
(14195, 'Meadow Acres', 38.6583290100098, 0.67471512454391, -75.567497253418, -1.31890163456392, 218, 10, 'PPL', 'P'),
(209594, 'Meadow Acres', 42.857780456543, 0.748009379063553, -106.092781066895, -1.85166834221481, 218, 59, 'PPL', 'P'),
(110374, 'Meadow Bluff', 37.9036102294922, 0.661542796897242, -80.6516723632813, -1.40763722997897, 218, 58, 'PPL', 'P'),
(88933, 'Meadow Branch', 36.3569412231445, 0.634548330297926, -83.2813873291016, -1.45353441452151, 218, 50, 'PPL', 'P'),
(110376, 'Meadow Bridge', 37.8588905334473, 0.660762290960767, -80.8544387817383, -1.41117617159353, 218, 58, 'PPL', 'P'),
(49369, 'Meadow Brook', 39.1605606079102, 0.683480719534824, -76.6413879394531, -1.33764456284173, 218, 25, 'PPL', 'P'),
(82340, 'Meadow Brook', 34.4869384765625, 0.601910625348733, -82.5666732788086, -1.44106030113363, 218, 48, 'PPL', 'P'),
(125372, 'Meadow Brook', 41.9375, 0.731947455055122, -71.1680603027344, -1.24211697454059, 218, 23, 'PPL', 'P'),
(136806, 'Meadow Brook', 47.8627815246582, 0.835363126767997, -92.9544372558594, -1.62236098445323, 218, 28, 'PPL', 'P'),
(183180, 'Meadow Brook', 38.8594398498535, 0.678225170860635, -120.833061218262, -2.10893476352254, 218, 6, 'PPL', 'P'),
(204858, 'Meadow Brook Estates Condominium', 40.8963890075684, 0.713776640358484, -111.885276794434, -1.95276646456807, 218, 52, 'PPL', 'P'),
(116797, 'Meadow Brook Mobile Home Park', 41.4824981689453, 0.724006175000615, -91.7111129760742, -1.60066088210099, 218, 16, 'PPL', 'P'),
(66740, 'Meadow Brook Village', 35.6744384765625, 0.622636410216166, -81.3827819824219, -1.42039750002598, 218, 33, 'PPL', 'P'),
(10425, 'Meadow Cliff', 35.0805587768555, 0.612271254095523, -90.767219543457, -1.58418683391387, 218, 4, 'PPL', 'P'),
(110377, 'Meadow Creek', 37.810001373291, 0.659909014147506, -80.9233322143555, -1.4123785888257, 218, 58, 'PPL', 'P'),
(195309, 'Meadow Creek', 48.8199996948242, 0.852069735497309, -116.155830383301, -2.02730168557667, 218, 17, 'PPL', 'P'),
(204893, 'Meadow Creek Condominium', 41.0694389343262, 0.716796931350743, -111.949172973633, -1.95388166327454, 218, 52, 'PPL', 'P'),
(96119, 'Meadow Creek Country Club Colonia', 26.1919994354248, 0.457136627828659, -98.3519973754883, -1.71656618011509, 218, 51, 'PPL', 'P'),
(42049, 'Meadow Creek Estates', 32.4116706848145, 0.565690369522137, -93.9644393920898, -1.63998884718263, 218, 22, 'PPL', 'P'),
(49370, 'Meadow Creek Estates', 38.5999984741211, 0.6736970646382, -76.5497207641602, -1.33604466881686, 218, 25, 'PPL', 'P'),
(49371, 'Meadow Creek Manor', 38.6066703796387, 0.673813511356864, -76.8194427490234, -1.34075220551774, 218, 25, 'PPL', 'P'),
(42051, 'Meadow Creek Subdivision', 32.9997215270996, 0.575953792889139, -93.4447174072266, -1.63091798735176, 218, 22, 'PPL', 'P'),
(73422, 'Meadow Farm', 39.9141693115234, 0.696633672684562, -82.1055603027344, -1.43301236147747, 218, 41, 'PPL', 'P'),
(183182, 'Meadow Farms Trailer Park', 37.3805618286133, 0.652413880154614, -118.415832519531, -2.06674616395599, 218, 6, 'PPL', 'P'),
(82341, 'Meadow Fields', 34.4388885498047, 0.601071995921467, -82.6416702270508, -1.44236924480941, 218, 48, 'PPL', 'P'),
(110378, 'Meadow Fork', 37.9330596923828, 0.662056786987627, -81.1044387817383, -1.41553949472351, 218, 58, 'PPL', 'P'),
(164422, 'Meadow Gap', 40.1599998474121, 0.700924224937762, -77.9311065673828, -1.36015439932341, 218, 45, 'PPL', 'P'),
(104139, 'Meadow Gate', 37.6272201538086, 0.656718880056727, -77.352783203125, -1.3500607524759, 218, 53, 'PPL', 'P'),
(208089, 'Meadow Glade', 45.7586097717285, 0.798638401651913, -122.559173583984, -2.13906110756379, 218, 56, 'PPL', 'P'),
(14196, 'Meadow Glen', 39.1186103820801, 0.682748549972134, -75.5366668701172, -1.31836354286566, 218, 10, 'PPL', 'P'),
(4121, 'Meadow Green', 33.1530609130859, 0.578630070047587, -86.8202819824219, -1.51529977810317, 218, 2, 'PPL', 'P'),
(204861, 'Meadow Green', 40.6805610656738, 0.710009732154621, -111.930000305176, -1.95354703708358, 218, 52, 'PPL', 'P'),
(88934, 'Meadow Green Acres', 35.9738883972168, 0.627862797276419, -86.8936080932617, -1.51657956016501, 218, 50, 'PPL', 'P'),
(142387, 'Meadow Grove', 42.0288887023926, 0.733542488810998, -97.7336120605469, -1.70577332032338, 218, 35, 'PPL', 'P'),
(110379, 'Meadow Haven', 38.3597183227539, 0.669503384869653, -82.5166702270508, -1.44018758324441, 218, 58, 'PPL', 'P'),
(27860, 'Meadow Heights', 38.6916694641113, 0.675297025242093, -89.9911117553711, -1.5706411976614, 218, 18, 'PPL', 'P'),
(4123, 'Meadow Hills', 34.7930603027344, 0.60725345912765, -86.5808334350586, -1.51112061256256, 218, 2, 'PPL', 'P'),
(23001, 'Meadow Hills', 33.788330078125, 0.589717608613914, -84.0824966430664, -1.46751640971859, 218, 13, 'PPL', 'P'),
(204864, 'Meadow Hollow Condominium', 41.0455589294434, 0.716380146640145, -111.947776794434, -1.95385729535057, 218, 52, 'PPL', 'P'),
(82342, 'Meadow Lake', 34.0780601501465, 0.594774352312729, -81.0036087036133, -1.41377967787519, 218, 48, 'PPL', 'P'),
(189010, 'Meadow Lake', 34.8013916015625, 0.607398867723168, -106.543060302734, -1.85952719743358, 218, 38, 'PPL', 'P'),
(183183, 'Meadow Lake Park', 39.3277816772461, 0.686399277773442, -120.20832824707, -2.09803111622948, 218, 6, 'PPL', 'P'),
(82343, 'Meadow Lakes', 34.9402809143066, 0.609822943526386, -81.0752792358398, -1.4150305646392, 218, 48, 'PPL', 'P'),
(183184, 'Meadow Lakes', 37.0802803039551, 0.64717297886642, -119.429718017578, -2.08444180413513, 218, 6, 'PPL', 'P'),
(211989, 'Meadow Lakes', 61.6247215270996, 1.07555429127252, -149.601104736328, -2.61103184226981, 218, 1, 'PPL', 'P'),
(164423, 'Meadow Lands', 40.2191696166992, 0.701956932229467, -80.220832824707, -1.40011766148308, 218, 45, 'PPL', 'P'),
(96120, 'Meadow Lands Colonia', 26.363000869751, 0.460121165883283, -98.1159973144531, -1.71244720201512, 218, 51, 'PPL', 'P'),
(88935, 'Meadow Lane', 35.8469390869141, 0.6256471138285, -86.4861068725586, -1.50946732215784, 218, 50, 'PPL', 'P'),
(116799, 'Meadow Lane Mobile Home Park', 42.0105590820313, 0.733222576585052, -93.6083297729492, -1.6337735618306, 218, 16, 'PPL', 'P'),
(23002, 'Meadow Lark', 33.8841705322266, 0.591390340094593, -84.8397216796875, -1.48073247978616, 218, 13, 'PPL', 'P'),
(209595, 'Meadow Lark Lake', 44.1755599975586, 0.771008970869696, -107.252777099609, -1.87191409229576, 218, 59, 'PPL', 'P'),
(37144, 'Meadow Lawn', 38.0597190856934, 0.664267410429475, -85.8974990844727, -1.49919417825286, 218, 21, 'PPL', 'P'),
(73424, 'Meadow Look', 38.8025016784668, 0.677231412299872, -82.2427825927734, -1.43540734224578, 218, 41, 'PPL', 'P'),
(49372, 'Meadow Manor', 38.2958297729492, 0.668388319321236, -75.6791687011719, -1.32085066900769, 218, 25, 'PPL', 'P'),
(197015, 'Meadow Manor Incorporated', 48.2000007629395, 0.841248712777072, -114.300003051758, -1.99491138829274, 218, 31, 'PPL', 'P'),
(88937, 'Meadow Mead', 36.3069381713867, 0.633675612408708, -88.291389465332, -1.54097544733068, 218, 50, 'PPL', 'P'),
(104140, 'Meadow Mills', 39.0230598449707, 0.681080878497527, -78.3061065673828, -1.36669938401839, 218, 53, 'PPL', 'P'),
(136808, 'Meadow Mobile Home Park', 43.7013893127441, 0.762733131203247, -92.5688934326172, -1.61563197532693, 218, 28, 'PPL', 'P'),
(49399, 'Meadow Oaks', 38.5708312988281, 0.673188001395832, -76.6111068725586, -1.3371160585234, 218, 25, 'PPL', 'P'),
(82344, 'Meadow Oaks', 34.3327789306641, 0.599220033699426, -80.1047210693359, -1.39809112905158, 218, 48, 'PPL', 'P'),
(42054, 'Meadow Park', 30.3691692352295, 0.530041994250123, -91.0702819824219, -1.58947627131293, 218, 22, 'PPL', 'P'),
(82345, 'Meadow Park', 34.4583282470703, 0.601411282644343, -82.6549987792969, -1.44260187193062, 218, 48, 'PPL', 'P'),
(4128, 'Meadow Ridge', 33.3958282470703, 0.582867159341903, -86.7163925170898, -1.51348656487499, 218, 2, 'PPL', 'P'),
(96121, 'Meadow Ridge Colonia', 27.7199993133545, 0.483805256668603, -98.0309982299805, -1.71096368812989, 218, 51, 'PPL', 'P'),
(82346, 'Meadow Rose', 34.6805610656738, 0.605289977034962, -82.813606262207, -1.44537009472571, 218, 48, 'PPL', 'P'),
(23003, 'Meadow Run', 33.3747215270996, 0.582498777584118, -84.5524978637695, -1.47571947850825, 218, 13, 'PPL', 'P'),
(49375, 'Meadow Run Park', 38.6836090087891, 0.675156343757509, -76.6336135864258, -1.33750887478419, 218, 25, 'PPL', 'P'),
(123160, 'Meadow Shores Park', 41.5833282470703, 0.725765991848939, -85.190559387207, -1.48685575292253, 218, 19, 'PPL', 'P'),
(82347, 'Meadow Spring', 35.0136108398438, 0.61110279216725, -81.9169387817383, -1.42972029489597, 218, 48, 'PPL', 'P'),
(49376, 'Meadow Springs', 39.5527801513672, 0.690326241958819, -76.2758331298828, -1.33126442781823, 218, 25, 'PPL', 'P'),
(49377, 'Meadow Stream', 39.6902809143066, 0.692726082996116, -76.5244369506836, -1.33560338302424, 218, 25, 'PPL', 'P'),
(66744, 'Meadow Summit', 36.5111083984375, 0.637239055105288, -79.7300033569336, -1.39155107120462, 218, 33, 'PPL', 'P'),
(37147, 'Meadow Vale', 38.2830581665039, 0.668165412737997, -85.5719375610352, -1.49351205775107, 218, 21, 'PPL', 'P'),
(175237, 'Meadow Valley', 44.2152786254883, 0.771702191701443, -90.2211074829102, -1.57465538037248, 218, 57, 'PPL', 'P'),
(183185, 'Meadow Valley', 39.9297218322754, 0.696905115378669, -121.059722900391, -2.1128907561638, 218, 6, 'PPL', 'P'),
(204872, 'Meadow Valley Condominium', 40.6997184753418, 0.710344092029481, -111.969436645508, -1.95423533106731, 218, 52, 'PPL', 'P'),
(23004, 'Meadow View', 33.6430587768555, 0.587182146098104, -83.8536071777344, -1.46352153492541, 218, 13, 'PPL', 'P'),
(49378, 'Meadow View', 39.7172203063965, 0.69319626408657, -76.8791732788086, -1.34179469992645, 218, 25, 'PPL', 'P'),
(66745, 'Meadow View', 35.8402786254883, 0.625530866846918, -80.8383331298828, -1.41089507494047, 218, 33, 'PPL', 'P'),
(82348, 'Meadow View', 34.1194381713867, 0.595496535021332, -80.7111129760742, -1.40867466438161, 218, 48, 'PPL', 'P'),
(169481, 'Meadow View', 41.6930618286133, 0.72768120414687, -71.3874969482422, -1.24594686650423, 218, 47, 'PPL', 'P'),
(204873, 'Meadow View', 40.6438903808594, 0.709369707965648, -112.000556945801, -1.95477848277163, 218, 52, 'PPL', 'P'),
(170849, 'Meadow View Addition', 43.6199989318848, 0.761312601077799, -96.7108306884766, -1.68792241785269, 218, 49, 'PPL', 'P'),
(145724, 'Meadow Village', 40.8686103820801, 0.713291811882035, -74.2355575561523, -1.29565490140861, 218, 37, 'PPL', 'P'),
(14197, 'Meadow Vista', 39.3816719055176, 0.687339839691431, -75.7133331298828, -1.32144695077576, 218, 10, 'PPL', 'P'),
(183186, 'Meadow Vista', 39.0011100769043, 0.680697782774719, -121.02082824707, -2.11221191640193, 218, 6, 'PPL', 'P'),
(104142, 'Meadow Wood', 37.3583297729492, 0.65202585758379, -79.291389465332, -1.38389581465119, 218, 53, 'PPL', 'P'),
(177387, 'Meadow Wood', 42.9550018310547, 0.749706212152097, -77.7236099243164, -1.35653289971506, 218, 40, 'PPL', 'P'),
(66746, 'Meadow Wood Acres', 36.4147186279297, 0.635556736244685, -79.6919403076172, -1.3908867456707, 218, 33, 'PPL', 'P'),
(104143, 'Meadow Wood Estates', 37.3250007629395, 0.651444156622689, -80.0133285522461, -1.39649602871668, 218, 53, 'PPL', 'P'),
(125373, 'Meadow Wood Trailer Park', 42.5963897705078, 0.743447250958193, -71.6838912963867, -1.25111992376365, 218, 23, 'PPL', 'P'),
(17076, 'Meadow Woods', 28.3852806091309, 0.495416605731835, -81.3666687011719, -1.42011627021487, 218, 12, 'PPL', 'P'),
(49379, 'Meadow Woods Estates', 38.5930595397949, 0.673575957387629, -76.7386093139648, -1.33934139593027, 218, 25, 'PPL', 'P'),
(4131, 'Meadowbrook', 33.4019393920898, 0.582973818943561, -86.6966705322266, -1.5131423513041, 218, 2, 'PPL', 'P'),
(14198, 'Meadowbrook', 39.7527809143066, 0.693816913778613, -75.7236099243164, -1.32162631467518, 218, 10, 'PPL', 'P'),
(23007, 'Meadowbrook', 33.4030609130859, 0.582993393177573, -82.0666732788086, -1.43233365487366, 218, 13, 'PPL', 'P'),
(27861, 'Meadowbrook', 38.8983306884766, 0.678903944043469, -90.0066680908203, -1.57091270693453, 218, 18, 'PPL', 'P'),
(37145, 'Meadowbrook', 38.0022201538086, 0.663263864751706, -84.2044372558594, -1.46964467490373, 218, 21, 'PPL', 'P'),
(49383, 'Meadowbrook', 39.5711097717285, 0.690646154184764, -76.190559387207, -1.32977612024304, 218, 25, 'PPL', 'P'),
(66748, 'Meadowbrook', 35.6311111450195, 0.621880205624638, -77.3686065673828, -1.35033692228094, 218, 33, 'PPL', 'P'),
(71104, 'Meadowbrook', 39.9677810668945, 0.697569374333562, -75.040283203125, -1.30970001352353, 218, 37, 'PPL', 'P'),
(73425, 'Meadowbrook', 39.9977798461914, 0.698092951803871, -82.0352783203125, -1.43178570947938, 218, 41, 'PPL', 'P'),
(88940, 'Meadowbrook', 36.4183311462402, 0.635619786583493, -82.5666732788086, -1.44106030113363, 218, 50, 'PPL', 'P'),
(104145, 'Meadowbrook', 38.6722183227539, 0.674957538782135, -77.4352798461914, -1.35150059051925, 218, 53, 'PPL', 'P'),
(110382, 'Meadowbrook', 38.8722190856934, 0.678448210601929, -82.116943359375, -1.43321103329479, 218, 58, 'PPL', 'P'),
(113690, 'Meadowbrook', 41.4866714477539, 0.724079012456428, -72.8819427490234, -1.27202986622047, 218, 8, 'PPL', 'P'),
(123164, 'Meadowbrook', 40.420280456543, 0.705466978546192, -86.8097229003906, -1.51511548735574, 218, 19, 'PPL', 'P'),
(128117, 'Meadowbrook', 43.8305587768555, 0.764987563645027, -69.8488922119141, -1.21909314796853, 218, 26, 'PPL', 'P'),
(144130, 'Meadowbrook', 43.0686111450195, 0.751689068741716, -70.7783279418945, -1.23531486164236, 218, 36, 'PPL', 'P'),
(150650, 'Meadowbrook', 41.4452781677246, 0.723356563431717, -74.0813903808594, -1.29296417660125, 218, 40, 'PPL', 'P'),
(164424, 'Meadowbrook', 40.1124992370605, 0.70009518289042, -75.07861328125, -1.31036899958936, 218, 45, 'PPL', 'P'),
(14199, 'Meadowbrook Acres', 39.0647201538086, 0.681807988054146, -75.540283203125, -1.3184266597835, 218, 10, 'PPL', 'P'),
(125374, 'Meadowbrook Acres Mobile Home Park', 42.5088882446289, 0.741920061231087, -71.7541732788086, -1.25234657576175, 218, 23, 'PPL', 'P'),
(204877, 'Meadowbrook Corners', 40.6791687011719, 0.709985430809674, -111.929718017578, -1.95354211023556, 218, 52, 'PPL', 'P'),
(49384, 'Meadowbrook Estates', 39.1916694641113, 0.684023671502064, -77.2538909912109, -1.34833475777342, 218, 25, 'PPL', 'P'),
(66751, 'Meadowbrook Estates', 35.3791694641113, 0.61748299376978, -80.1716690063477, -1.39925959097986, 218, 33, 'PPL', 'P'),
(37146, 'Meadowbrook Farm', 38.2783317565918, 0.668082921323232, -85.5752792358398, -1.49357038097894, 218, 21, 'PPL', 'P'),
(14200, 'Meadowbrook Farms', 39.5088882446289, 0.689560183671257, -75.7241668701172, -1.32163603521315, 218, 10, 'PPL', 'P'),
(82350, 'Meadowbrook Farms', 35.0372200012207, 0.611514849766913, -82.0311126708984, -1.43171300518162, 218, 48, 'PPL', 'P'),
(204879, 'Meadowbrook Farms', 40.6766700744629, 0.709941821546825, -111.93138885498, -1.95357127184949, 218, 52, 'PPL', 'P'),
(14201, 'Meadowbrook Farms South', 39.5033302307129, 0.689463178028551, -75.7236099243164, -1.32162631467518, 218, 10, 'PPL', 'P'),
(104146, 'Meadowbrook Forest', 36.9066696166992, 0.644142900757155, -76.2263870239258, -1.33040143046699, 218, 53, 'PPL', 'P'),
(125375, 'Meadowbrook Green', 42.1747207641602, 0.736087738443814, -72.3344421386719, -1.26247417791315, 218, 23, 'PPL', 'P'),
(82351, 'Meadowbrook Heights', 34.5175018310547, 0.602444056515076, -82.7013931274414, -1.44341160606006, 218, 48, 'PPL', 'P'),
(23009, 'Meadowbrook Mobile Home Park', 33.584171295166, 0.586154365654415, -83.7855606079102, -1.46233389823729, 218, 13, 'PPL', 'P'),
(125376, 'Meadowbrook Mobile Home Park', 42.3902816772461, 0.739849986115769, -71.5808334350586, -1.24932122476342, 218, 23, 'PPL', 'P'),
(164425, 'Meadowbrook Mobile Home Park', 40.1961097717285, 0.701554462009729, -76.9016723632813, -1.34218738302919, 218, 45, 'PPL', 'P'),
(183187, 'Meadowbrook Mobile Home Park', 32.8344383239746, 0.573069056796366, -117.016670227051, -2.04232617518246, 218, 6, 'PPL', 'P'),
(49385, 'Meadowbrook Park', 38.6811103820801, 0.675112734494659, -75.7569427490234, -1.3222080822153, 218, 25, 'PPL', 'P'),
(17077, 'Meadowbrook Terrace', 30.1772193908691, 0.526691837467344, -81.7347183227539, -1.42653994792219, 218, 12, 'PPL', 'P'),
(204881, 'Meadowbrook Valley', 40.6777801513672, 0.709961196043755, -111.930557250977, -1.95355675762155, 218, 52, 'PPL', 'P'),
(204882, 'Meadowbrook Village Condo', 40.6763916015625, 0.709936961277835, -111.924438476563, -1.95344996486184, 218, 52, 'PPL', 'P'),
(183189, 'Meadowbrook Woods', 34.2344398498535, 0.597503692955897, -117.201393127441, -2.04555019799811, 218, 6, 'PPL', 'P'),
(10426, 'Meadowcliff', 34.6966705322266, 0.605571140267047, -92.350830078125, -1.61182605181309, 218, 4, 'PPL', 'P'),
(49386, 'Meadowcliff', 39.4511108398438, 0.688551777724499, -76.5319366455078, -1.33573427739182, 218, 25, 'PPL', 'P'),
(49387, 'Meadowcrest', 39.440559387207, 0.68836762013512, -77.4633331298828, -1.35199021268566, 218, 25, 'PPL', 'P'),
(136810, 'Meadowcrest Estates Mobile Home Park', 44.7833290100098, 0.781616541228563, -94.9863891601563, -1.65782523542538, 218, 28, 'PPL', 'P'),
(23010, 'Meadowdale', 32.4444389343262, 0.566262283366232, -83.7758331298828, -1.4621641217178, 218, 13, 'PPL', 'P'),
(104148, 'Meadowdale', 38.3761100769043, 0.669789474949754, -79.665283203125, -1.39042149142827, 218, 53, 'PPL', 'P'),
(110384, 'Meadowdale', 39.4955596923828, 0.689327556550039, -80.0933303833008, -1.39789232407621, 218, 58, 'PPL', 'P'),
(150651, 'Meadowdale', 42.6705589294434, 0.744741746985053, -73.9841690063477, -1.29126734351271, 218, 40, 'PPL', 'P'),
(164426, 'Meadowdale', 40.1258316040039, 0.700327876590666, -79.1133270263672, -1.38078803881712, 218, 45, 'PPL', 'P'),
(208091, 'Meadowdale', 47.8530616760254, 0.835193483406559, -122.332221984863, -2.13510005491646, 218, 56, 'PPL', 'P'),
(209596, 'Meadowdale', 42.5525016784668, 0.742681259249659, -104.694999694824, -1.82727245504914, 218, 59, 'PPL', 'P'),
(104149, 'Meadowfield', 36.5958290100098, 0.638717708721527, -80.4438934326172, -1.40401080352261, 218, 53, 'PPL', 'P'),
(113691, 'Meadowgate', 41.9469413757324, 0.732112238147571, -72.791389465332, -1.27044941327156, 218, 8, 'PPL', 'P'),
(195310, 'Meadowhurst', 47.3222198486328, 0.825928545711255, -116.560279846191, -2.03436066036203, 218, 17, 'PPL', 'P'),
(23011, 'Meadowlake', 33.9497184753418, 0.592534367519864, -84.3116683959961, -1.47151621135978, 218, 13, 'PPL', 'P'),
(96122, 'Meadowlakes', 30.562219619751, 0.533411359082264, -98.2961120605469, -1.71559079736585, 218, 51, 'PPL', 'P'),
(49388, 'Meadowland', 39.4283294677734, 0.68815416777375, -76.6374969482422, -1.33757665223393, 218, 25, 'PPL', 'P'),
(104150, 'Meadowland', 37.2924995422363, 0.650876903310502, -79.9477767944336, -1.39535193471238, 218, 53, 'PPL', 'P'),
(23012, 'Meadowlands', 33.0911102294922, 0.577548826645015, -85.0319366455078, -1.48408726381133, 218, 13, 'PPL', 'P'),
(136811, 'Meadowlands', 47.0719413757324, 0.82156036231228, -92.7322235107422, -1.61848262295775, 218, 28, 'PPL', 'P'),
(23013, 'Meadowlark', 33.4072189331055, 0.583065964317278, -82.0738906860352, -1.43245962239322, 218, 13, 'PPL', 'P'),
(104151, 'Meadowlark', 37.2088890075684, 0.649417624191193, -79.9997177124023, -1.39625847474745, 218, 53, 'PPL', 'P'),
(49389, 'Meadowlark Estates', 39.639720916748, 0.691843644568918, -76.4686126708984, -1.33462906553943, 218, 25, 'PPL', 'P'),
(197016, 'Meadowlark Mobile Home Park', 48.1694412231445, 0.840715348189757, -114.308326721191, -1.9950566637302, 218, 31, 'PPL', 'P'),
(150652, 'Meadowmere Park', 40.6361083984375, 0.709233886750054, -73.741943359375, -1.28703970844026, 218, 40, 'PPL', 'P'),
(183191, 'Meadowmont', 38.2463912963867, 0.667525455128051, -120.368057250977, -2.10081891325858, 218, 6, 'PPL', 'P'),
(4135, 'Meadowood', 34.3636093139648, 0.599758125397676, -86.5102767944336, -1.50988916687451, 218, 2, 'PPL', 'P'),
(14202, 'Meadowood', 39.7083282470703, 0.693041068374045, -75.6875, -1.32099607760321, 218, 10, 'PPL', 'P'),
(23014, 'Meadowood', 34.2183303833008, 0.597222529723812, -83.835563659668, -1.46320661612651, 218, 13, 'PPL', 'P'),
(49391, 'Meadowood', 39.0641708374023, 0.681798400674221, -77.0061111450195, -1.34401018363729, 218, 25, 'PPL', 'P'),
(66753, 'Meadowood', 35.3011093139648, 0.616120587135123, -81.5008316040039, -1.42245785460332, 218, 33, 'PPL', 'P'),
(88944, 'Meadowood', 35.792781829834, 0.624701891378604, -83.9636077880859, -1.46544140775525, 218, 50, 'PPL', 'P'),
(164427, 'Meadowood', 40.8419418334961, 0.712826357902517, -79.894172668457, -1.39441636622144, 218, 45, 'PPL', 'P'),
(23015, 'Meadowood Subdivision', 33.5202789306641, 0.585039233526972, -83.8122177124023, -1.46279915247973, 218, 13, 'PPL', 'P'),
(49392, 'Meadowoods of Davidsonville', 38.9305610656738, 0.679466470244721, -76.6524963378906, -1.33783844096909, 218, 25, 'PPL', 'P'),
(176, 'Meadows', 38.9150009155273, 0.67919489439256, -79.7427825927734, -1.39177411094592, 218, 58, 'PPL', 'P'),
(10428, 'Meadows', 35.4930610656738, 0.619470777207416, -94.2669372558594, -1.64526843088565, 218, 4, 'PPL', 'P'),
(14203, 'Meadows', 38.6522216796875, 0.67460853152128, -75.5722198486328, -1.31898405939965, 218, 10, 'PPL', 'P'),
(49394, 'Meadows', 38.815559387207, 0.677459312310155, -76.8497161865234, -1.34128057667801, 218, 25, 'PPL', 'P'),
(66756, 'Meadows', 36.3694381713867, 0.634766443191204, -80.1819381713867, -1.39943882172122, 218, 33, 'PPL', 'P'),
(120580, 'Meadows', 40.7444381713867, 0.711124597965956, -88.8047180175781, -1.54993472071187, 218, 18, 'PPL', 'P'),
(195311, 'Meadows', 44.961109161377, 0.784719390214614, -116.242782592773, -2.02881928792385, 218, 17, 'PPL', 'P'),
(164428, 'Meadows at Lower Gwynedd', 40.1500015258789, 0.700749721307334, -75.1833267211914, -1.31219659388742, 218, 45, 'PPL', 'P'),
(204890, 'Meadows at Mutton Hollow Condominium', 41.0461082458496, 0.71638973402007, -111.944442749023, -1.95379910528075, 218, 52, 'PPL', 'P'),
(4143, 'Meadows Crossroads', 32.5086097717285, 0.567382275762665, -85.1719436645508, -1.48653084726954, 218, 2, 'PPL', 'P'),
(183193, 'Meadows Manor Mobile Home Park', 36.9347190856934, 0.644632456344539, -121.76611328125, -2.12521959411421, 218, 6, 'PPL', 'P'),
(4138, 'Meadows Mill', 32.5291709899902, 0.567741136719553, -85.2547225952148, -1.4879756121609, 218, 2, 'PPL', 'P'),
(96123, 'Meadows Place', 29.6511096954346, 0.517509491055346, -95.5877838134766, -1.66832155222971, 218, 51, 'PPL', 'P'),
(145725, 'Meadows Terrace', 40.2422218322754, 0.702359269291151, -74.601936340332, -1.302049417502, 218, 37, 'PPL', 'P'),
(199524, 'Meadows Trailer Court', 42.1016693115234, 0.734812750071938, -102.871673583984, -1.7954494110774, 218, 35, 'PPL', 'P'),
(183194, 'Meadowsweet', 37.9230613708496, 0.6618822833572, -122.508331298828, -2.13817374228857, 218, 6, 'PPL', 'P'),
(37148, 'Meadowthorpe', 38.0699996948242, 0.664446840907919, -84.5233306884766, -1.47521041526588, 218, 21, 'PPL', 'P'),
(49395, 'Meadowvale', 39.5636100769043, 0.690515259817187, -76.1144409179688, -1.32844760233325, 218, 25, 'PPL', 'P'),
(125377, 'Meadowvale', 42.7011108398438, 0.745274978414314, -73.1858291625977, -1.27733368468941, 218, 23, 'PPL', 'P'),
(178618, 'Meadowvale', 33.4347190856934, 0.583545932524737, -111.774436950684, -1.95083194435224, 218, 5, 'PPL', 'P'),
(23018, 'Meadowview', 33.7391700744629, 0.588859604689718, -84.6622161865234, -1.47763442449007, 218, 13, 'PPL', 'P'),
(33236, 'Meadowview', 37.6897201538086, 0.657809710839224, -97.4272232055664, -1.70042582601256, 218, 20, 'PPL', 'P'),
(49397, 'Meadowview', 39.6527786254883, 0.692071544579202, -75.7958297729492, -1.32288678881911, 218, 25, 'PPL', 'P'),
(66758, 'Meadowview', 35.8052787780762, 0.624920004271881, -80.2825012207031, -1.40119397803764, 218, 33, 'PPL', 'P'),
(88948, 'Meadowview', 35.2569389343262, 0.615349668578573, -87.3466720581055, -1.52448701807367, 218, 50, 'PPL', 'P'),
(96124, 'Meadowview', 33.0592918395996, 0.576993490978706, -96.1241607666016, -1.67768309609355, 218, 51, 'PPL', 'P'),
(104155, 'Meadowview', 36.7602806091309, 0.64158793058636, -81.8630599975586, -1.42877993271506, 218, 53, 'PPL', 'P'),
(128107, 'Meadowview', 44.4708290100098, 0.776162387316081, -70.2724990844727, -1.22648648262875, 218, 26, 'PPL', 'P'),
(164429, 'Meadowview', 40.8469390869141, 0.712913576428217, -76.5922164916992, -1.33678635918045, 218, 45, 'PPL', 'P'),
(23020, 'Meadowview Acres', 33.5930595397949, 0.586309494787913, -84.2744369506836, -1.4708664000538, 218, 13, 'PPL', 'P'),
(4139, 'Meadowview Estates', 33.6688919067383, 0.587633019270655, -86.540283203125, -1.51041287750288, 218, 2, 'PPL', 'P'),
(37149, 'Meadowview Estates', 38.2222213745117, 0.667103610411382, -85.6355590820313, -1.49462246276758, 218, 21, 'PPL', 'P'),
(204891, 'Meadowview Heights Number 4', 40.6425018310547, 0.709345473199729, -112.005561828613, -1.95486583445538, 218, 52, 'PPL', 'P'),
(104156, 'Meadowview Hills', 37.4874992370605, 0.654280290025569, -79.1361083984375, -1.38118564876787, 218, 53, 'PPL', 'P'),
(23021, 'Meadowview Mobile Home Park', 33.4000015258789, 0.582939996797717, -84.853889465332, -1.48097975429337, 218, 13, 'PPL', 'P'),
(49398, 'Meadowview Park', 39.6616706848145, 0.692226740291726, -75.8013916015625, -1.32298386104084, 218, 25, 'PPL', 'P'),
(104158, 'Meadowville', 38.7980613708496, 0.67715391431215, -77.815559387207, -1.35813772058794, 218, 53, 'PPL', 'P'),
(110385, 'Meadowville', 39.1180610656738, 0.68273896259221, -79.9097213745117, -1.39468774233652, 218, 58, 'PPL', 'P'),
(128108, 'Meadowville', 45.5202789306641, 0.794478743766291, -68.352783203125, -1.19298111979641, 218, 26, 'PPL', 'P'),
(195312, 'Meadowville', 42.7636108398438, 0.746365809196811, -111.603057861328, -1.94784081497392, 218, 17, 'PPL', 'P'),
(204892, 'Meadowville', 41.8441696166992, 0.730318532574375, -111.398330688477, -1.94426765173936, 218, 52, 'PPL', 'P'),
(37150, 'Meads', 38.4124984741211, 0.670424572290711, -82.7091674804688, -1.4435472941176, 218, 21, 'PPL', 'P'),
(125378, 'Meads Corner', 42.353889465332, 0.739214822195785, -72.4236068725586, -1.26403039609614, 218, 23, 'PPL', 'P'),
(150653, 'Meads Corners', 41.4836082458496, 0.724025549497545, -73.7688903808594, -1.28751002268877, 218, 40, 'PPL', 'P'),
(150654, 'Meads Creek', 42.2719383239746, 0.73778450495333, -77.1005630493164, -1.34565868035205, 218, 40, 'PPL', 'P'),
(132027, 'Meads Landing', 44.4066696166992, 0.77504259465673, -84.8047180175781, -1.4801215506321, 218, 27, 'PPL', 'P'),
(178619, 'Meadview', 36.0022201538086, 0.628357279711819, -114.067497253418, -1.99085339658173, 218, 5, 'PPL', 'P'),
(4140, 'Meadville', 32.0677795410156, 0.559688336794399, -86.1438903808594, -1.50349451762307, 218, 2, 'PPL', 'P'),
(56189, 'Meadville', 39.7841682434082, 0.694364726014842, -93.3019409179688, -1.62842606751978, 218, 29, 'PPL', 'P'),
(60852, 'Meadville', 31.4722194671631, 0.549293852612251, -90.8966674804688, -1.58644612662464, 218, 30, 'PPL', 'P'),
(104159, 'Meadville', 36.8344383239746, 0.642882226876139, -79.0322189331055, -1.37937243553969, 218, 53, 'PPL', 'P'),
(110386, 'Meadville', 39.4086112976074, 0.687810020781884, -81.003059387207, -1.41377009049526, 218, 58, 'PPL', 'P'),
(142389, 'Meadville', 42.7588882446289, 0.746283384361073, -99.8486099243164, -1.74268699671881, 218, 35, 'PPL', 'P'),
(164431, 'Meadville', 40.0691719055176, 0.699338978298892, -75.9958267211914, -1.32637739405988, 218, 45, 'PPL', 'P'),
(110387, 'Meadville (historical)', 38.5449981689453, 0.672737128223281, -80.8586120605469, -1.41124900904934, 218, 58, 'PPL', 'P'),
(164432, 'Meadville Junction', 41.6388893127441, 0.726735715380864, -80.3452835083008, -1.40228973566815, 218, 45, 'PPL', 'P'),
(4141, 'Meadwood Heights', 33.5755615234375, 0.586004096789908, -86.7519378662109, -1.51410694825092, 218, 2, 'PPL', 'P'),
(10430, 'Meaford (historical)', 34.5247192382813, 0.602570024034637, -92.8697204589844, -1.62088239741602, 218, 4, 'PPL', 'P'),
(211990, 'Meakerville', 60.5416717529297, 1.05665150675027, -145.008331298828, -2.5308728239873, 218, 1, 'PPL', 'P'),
(37151, 'Meally', 37.7966690063477, 0.65967632044726, -82.7399978637695, -1.44408538581585, 218, 21, 'PPL', 'P'),
(82355, 'Mean Crossroads', 34.8080596923828, 0.607515247862805, -81.7322235107422, -1.42649640523837, 218, 48, 'PPL', 'P'),
(37152, 'Means', 37.9491691589355, 0.662337950219713, -83.7724990844727, -1.46210593164798, 218, 21, 'PPL', 'P'),
(23022, 'Meansville', 33.0491714477539, 0.576816856819407, -84.3069381713867, -1.47143365336599, 218, 13, 'PPL', 'P'),
(82356, 'Meansville (historical)', 34.8074989318848, 0.607505460745799, -81.7547225952148, -1.4268890883411, 218, 48, 'PPL', 'P'),
(193780, 'Meares', 41.6208305358887, 0.726420530265853, -121.197776794434, -2.11530025116005, 218, 6, 'PPL', 'P'),
(132028, 'Mears', 43.6819381713867, 0.762393644743289, -86.4197235107422, -1.5083087139256, 218, 27, 'PPL', 'P'),
(104160, 'Mears Corner', 36.7802810668945, 0.641937004426242, -76.1919403076172, -1.3298002218509, 218, 53, 'PPL', 'P'),
(104161, 'Mears Station', 37.8561096191406, 0.6607137548499, -75.605827331543, -1.31957062062974, 218, 53, 'PPL', 'P'),
(104162, 'Mearsville', 37.8591690063477, 0.660767151229757, -75.6241683959961, -1.31989073259277, 218, 53, 'PPL', 'P'),
(66759, 'Meat Camp', 36.2994384765625, 0.63354471804113, -81.6766662597656, -1.42552674828547, 218, 33, 'PPL', 'P'),
(178620, 'Meath (historical)', 35.1233291625977, 0.613017738149072, -112.446670532227, -1.96256463369264, 218, 5, 'PPL', 'P'),
(132029, 'Meauwataka', 44.3530616760254, 0.774106959586758, -85.5397186279297, -1.4929497312869, 218, 27, 'PPL', 'P'),
(42056, 'Meaux', 30.0205593109131, 0.523957603265673, -92.182502746582, -1.60888818565657, 218, 22, 'PPL', 'P'),
(66760, 'Mebane', 36.0958290100098, 0.629991062461556, -79.267219543457, -1.38347396993452, 218, 33, 'PPL', 'P'),
(197018, 'Mecaha (historical)', 47.3208312988281, 0.825904310945335, -107.933891296387, -1.8838017776116, 218, 31, 'PPL', 'P'),
(175239, 'Mecan', 43.7961082458496, 0.764386288449914, -89.2149963378906, -1.55709542825087, 218, 57, 'PPL', 'P'),
(17078, 'Mecca', 28.0208301544189, 0.489055745336722, -82.7411117553711, -1.44410482689181, 218, 12, 'PPL', 'P'),
(30477, 'Mecca', 39.7272186279297, 0.693370767716997, -87.3305587768555, -1.52420578826256, 218, 19, 'PPL', 'P'),
(56190, 'Mecca', 39.4841690063477, 0.689128751574664, -94.5227813720703, -1.64973375308539, 218, 29, 'PPL', 'P'),
(88952, 'Mecca', 35.3541717529297, 0.617046701404198, -84.4211120605469, -1.47342636365164, 218, 50, 'PPL', 'P'),
(96125, 'Mecca', 30.9838905334473, 0.540770904886157, -96.0666732788086, -1.67667975015287, 218, 51, 'PPL', 'P'),
(156417, 'Mecca', 41.3894386291504, 0.722381979630803, -80.7372207641602, -1.40913033124413, 218, 41, 'PPL', 'P'),
(183195, 'Mecca', 33.5716705322266, 0.585936186182111, -116.076393127441, -2.02591524391317, 218, 6, 'PPL', 'P'),
(4142, 'Mecca (historical)', 34.954719543457, 0.610074945144534, -87.5611114501953, -1.52822969151162, 218, 2, 'PPL', 'P'),
(23023, 'Mecca (historical)', 33.6269416809082, 0.586900849707965, -84.6949996948242, -1.47820660465028, 218, 13, 'PPL', 'P'),
(33237, 'Mecca Acres', 37.6755599975586, 0.657562569490064, -97.146110534668, -1.69551948433631, 218, 20, 'PPL', 'P'),
(66761, 'Mechanic', 35.6530609130859, 0.622263301347445, -79.9291687011719, -1.39502716221745, 218, 33, 'PPL', 'P'),
(128109, 'Mechanic Falls', 44.1116714477539, 0.769893905321279, -70.392219543457, -1.22857599882002, 218, 26, 'PPL', 'P'),
(78719, 'Mechanic Grove', 39.8486099243164, 0.69548944552221, -76.1588897705078, -1.32922338115879, 218, 45, 'PPL', 'P'),
(23024, 'Mechanic Hill', 33.2975006103516, 0.581151018335456, -81.958610534668, -1.43044760418967, 218, 13, 'PPL', 'P'),
(49400, 'Mechanic Valley', 39.6316719055176, 0.691703162821417, -75.9199981689453, -1.32505393615616, 218, 25, 'PPL', 'P'),
(164434, 'Mechanics Valley', 40.3199996948242, 0.703716749077791, -75.0833282470703, -1.31045129126704, 218, 45, 'PPL', 'P'),
(27864, 'Mechanicsburg', 39.809440612793, 0.694805812070386, -89.397216796875, -1.56027577522465, 218, 18, 'PPL', 'P'),
(60853, 'Mechanicsburg', 32.6324996948242, 0.569544562830727, -90.5027770996094, -1.57957144258671, 218, 30, 'PPL', 'P'),
(104163, 'Mechanicsburg', 37.1480598449707, 0.648355955022633, -80.9413909912109, -1.41269377394071, 218, 53, 'PPL', 'P'),
(110392, 'Mechanicsburg', 39.3352813720703, 0.68653017214102, -78.8105621337891, -1.37550379458219, 218, 58, 'PPL', 'P'),
(123166, 'Mechanicsburg', 40.0050010681152, 0.698218985902459, -85.5572204589844, -1.49325519586393, 218, 19, 'PPL', 'P'),
(156422, 'Mechanicsburg', 40.8583297729492, 0.713112381403591, -81.9833297729492, -1.43087903628626, 218, 41, 'PPL', 'P'),
(164436, 'Mechanicsburg', 40.214168548584, 0.70186964712474, -77.0088882446289, -1.34405865316913, 218, 45, 'PPL', 'P'),
(110388, 'Mechanicstown', 39.2605590820313, 0.685226022155208, -77.829719543457, -1.3583848619371, 218, 58, 'PPL', 'P'),
(150655, 'Mechanicstown', 41.4427795410156, 0.723312954168867, -74.3888931274414, -1.29833111198803, 218, 40, 'PPL', 'P'),
(156423, 'Mechanicstown', 40.6186103820801, 0.708928488752049, -80.9513931274414, -1.41286834415016, 218, 41, 'PPL', 'P'),
(4145, 'Mechanicsville', 32.6666717529297, 0.570140977756851, -85.1469421386719, -1.48609448832493, 218, 2, 'PPL', 'P'),
(14204, 'Mechanicsville', 39.7169418334961, 0.69319140381758, -75.7838897705078, -1.32267839646381, 218, 10, 'PPL', 'P'),
(23025, 'Mechanicsville', 33.9275016784668, 0.592146611265148, -84.2425003051758, -1.47030900043765, 218, 13, 'PPL', 'P'),
(30480, 'Mechanicsville', 38.0338897705078, 0.663816603835952, -87.5622177124023, -1.52824899942952, 218, 19, 'PPL', 'P'),
(49401, 'Mechanicsville', 38.4427795410156, 0.670953076609037, -76.7441711425781, -1.33943846815201, 218, 25, 'PPL', 'P'),
(56191, 'Mechanicsville', 38.6925010681152, 0.675311539470034, -90.7983322143555, -1.58472985246014, 218, 29, 'PPL', 'P'),
(82358, 'Mechanicsville', 34.3447189331055, 0.599428426054725, -79.7574996948242, -1.39203097283306, 218, 48, 'PPL', 'P'),
(104168, 'Mechanicsville', 38.667781829834, 0.674880107373441, -78.7880630493164, -1.37511111147945, 218, 53, 'PPL', 'P'),
(113693, 'Mechanicsville', 41.939998626709, 0.731991064317972, -71.894172668457, -1.25479002606189, 218, 8, 'PPL', 'P'),
(116802, 'Mechanicsville', 41.9044418334961, 0.731370481204956, -91.2544403076172, -1.59269044043255, 218, 16, 'PPL', 'P'),
(125379, 'Mechanicsville', 41.7236099243164, 0.728214368997103, -71.1494369506836, -1.24179193572954, 218, 23, 'PPL', 'P'),
(145727, 'Mechanicsville', 40.422779083252, 0.705510587809042, -74.192497253418, -1.29490335734899, 218, 37, 'PPL', 'P'),
(156424, 'Mechanicsville', 41.7547187805176, 0.728757320964343, -80.8947219848633, -1.41187924612131, 218, 41, 'PPL', 'P'),
(164447, 'Mechanicsville', 40.6894416809082, 0.710164728130064, -76.1861114501953, -1.32969848909726, 218, 45, 'PPL', 'P'),
(172236, 'Mechanicsville', 44.3438911437988, 0.773946903605244, -73.105827331543, -1.27593738932989, 218, 55, 'PPL', 'P'),
(23026, 'Mechanicsville (historical)', 33.3658294677734, 0.582343581871594, -83.8341674804688, -1.46318224820254, 218, 13, 'PPL', 'P'),
(49402, 'Mechanicsville (historical)', 39.6019401550293, 0.691184245883015, -76.3199996948242, -1.33203527979575, 218, 25, 'PPL', 'P'),
(73427, 'Mechanicsville (historical)', 39.6258316040039, 0.691601230330694, -83.7313919067383, -1.46138847605032, 218, 41, 'PPL', 'P'),
(104169, 'Mechanicsville (historical)', 38.0730590820313, 0.664500237287775, -78.1986083984375, -1.36482318703042, 218, 53, 'PPL', 'P'),
(42057, 'Mechanicville', 29.5766696929932, 0.516210267917551, -90.6861114501953, -1.58277123063644, 218, 22, 'PPL', 'P'),
(150656, 'Mechanicville', 42.9027786254883, 0.748794745269018, -73.6877822875977, -1.28609441941134, 218, 40, 'PPL', 'P'),
(164449, 'Mechesneytown', 40.3147201538086, 0.703624603704075, -79.35888671875, -1.38507386395939, 218, 45, 'PPL', 'P'),
(110389, 'Mechlenberg Heights', 39.4333305358887, 0.688241452878477, -77.8300018310547, -1.35838978878512, 218, 58, 'PPL', 'P'),
(145728, 'Mechlings Corner', 40.610279083252, 0.708783080156531, -74.9883270263672, -1.30879320717236, 218, 37, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(104171, 'Mechunk Acres', 37.9944381713867, 0.663128043536112, -78.3322219848633, -1.36715518403895, 218, 53, 'PPL', 'P'),
(164454, 'Meckesville', 40.9997215270996, 0.715580133048686, -75.5522232055664, -1.3186350521388, 218, 45, 'PPL', 'P'),
(150658, 'Mecklenburg', 42.4575004577637, 0.741023175154976, -76.710563659668, -1.33885190692192, 218, 40, 'PPL', 'P'),
(170850, 'Meckling', 42.8424987792969, 0.747742663480382, -97.0691680908203, -1.69417658535663, 218, 49, 'PPL', 'P'),
(164450, 'Mecks Corner', 40.3861083984375, 0.704870563620068, -77.1430587768555, -1.34640037071564, 218, 45, 'PPL', 'P'),
(164451, 'Meckville', 40.4713897705078, 0.706359004353314, -76.3813934326172, -1.33310680266034, 218, 45, 'PPL', 'P'),
(150659, 'Meco', 43.0558280944824, 0.751465962421394, -74.3827819824219, -1.29822445238638, 218, 40, 'PPL', 'P'),
(132032, 'Mecosta', 43.6202812194824, 0.761317527925816, -85.2263870239258, -1.48748106314648, 218, 27, 'PPL', 'P'),
(150660, 'Mecox', 40.9111099243164, 0.714033568824649, -72.3047180175781, -1.26195539413281, 218, 40, 'PPL', 'P'),
(23028, 'Meda', 33.2811088562012, 0.580864928255355, -83.366943359375, -1.45502764894472, 218, 13, 'PPL', 'P'),
(201211, 'Meda', 45.146671295166, 0.78795806041626, -123.91471862793, -2.16271983173972, 218, 43, 'PPL', 'P'),
(189011, 'Medanales', 36.1755599975586, 0.631382630710149, -106.182777404785, -1.85323907462574, 218, 38, 'PPL', 'P'),
(183196, 'Medano (historical)', 37.1297187805176, 0.648035843059606, -120.152221679688, -2.09705187189666, 218, 6, 'PPL', 'P'),
(17079, 'Medart', 30.0825004577637, 0.525038680220677, -84.3872222900391, -1.47283487557353, 218, 12, 'PPL', 'P'),
(170852, 'Medary', 44.2097206115723, 0.771605186058737, -96.7863922119141, -1.6892412152245, 218, 49, 'PPL', 'P'),
(175241, 'Medary', 43.855281829834, 0.765419062320647, -91.2094421386719, -1.59190507422708, 218, 57, 'PPL', 'P'),
(123167, 'Medaryville', 41.0805587768555, 0.716991009215182, -86.8919372558594, -1.51655039855107, 218, 19, 'PPL', 'P'),
(140483, 'Medberry', 46.3758316040039, 0.809410954840311, -98.6205596923828, -1.72125347679169, 218, 34, 'PPL', 'P'),
(172239, 'Medburyville', 42.8702812194824, 0.748227558535858, -72.9208297729492, -1.27270857282427, 218, 55, 'PPL', 'P'),
(128111, 'Meddybemps', 45.038330078125, 0.786067149463276, -67.3563919067383, -1.17559081103624, 218, 26, 'PPL', 'P'),
(116803, 'Mederville', 42.7630615234375, 0.746356221816887, -91.4227828979492, -1.59562857290518, 218, 16, 'PPL', 'P'),
(66763, 'Medfield', 35.8063888549805, 0.624939378768812, -78.7455596923828, -1.37436928795781, 218, 33, 'PPL', 'P'),
(125380, 'Medfield', 42.1875, 0.736310778185108, -71.3069381713867, -1.24454085060672, 218, 23, 'PPL', 'P'),
(125381, 'Medfield Junction', 42.1972198486328, 0.736480421546546, -71.3263931274414, -1.24488040364571, 218, 23, 'PPL', 'P'),
(49404, 'Medford', 39.5480613708496, 0.690243883702108, -77.0541687011719, -1.34484894622261, 218, 25, 'PPL', 'P'),
(56192, 'Medford', 38.651668548584, 0.674598877562328, -94.0069427490234, -1.64073067070427, 218, 29, 'PPL', 'P'),
(71106, 'Medford', 39.9008293151855, 0.696400845826262, -74.8238906860352, -1.30592325162363, 218, 37, 'PPL', 'P'),
(76574, 'Medford', 36.8069381713867, 0.642402258668679, -97.7333297729492, -1.70576839347537, 218, 42, 'PPL', 'P'),
(88954, 'Medford', 36.1811103820801, 0.631479503194801, -84.1438903808594, -1.46858793258318, 218, 50, 'PPL', 'P'),
(123168, 'Medford', 40.1205596923828, 0.700235864375003, -85.3208312988281, -1.48912942670318, 218, 19, 'PPL', 'P'),
(125383, 'Medford', 42.4183311462402, 0.740339541703152, -71.1066665649414, -1.24104545167599, 218, 23, 'PPL', 'P'),
(128113, 'Medford', 45.2852783203125, 0.79037720937146, -68.8522186279297, -1.20169791236035, 218, 26, 'PPL', 'P'),
(136815, 'Medford', 44.1741714477539, 0.770984736103776, -93.2461090087891, -1.62745161687692, 218, 28, 'PPL', 'P'),
(150661, 'Medford', 40.8175010681152, 0.712399786074913, -73.0005569458008, -1.27410007449384, 218, 40, 'PPL', 'P'),
(175243, 'Medford', 45.1386108398438, 0.787817378931676, -90.3399963378906, -1.57673038233581, 218, 57, 'PPL', 'P'),
(201212, 'Medford', 42.3266716003418, 0.738739780836342, -122.874443054199, -2.14456359785005, 218, 43, 'PPL', 'P'),
(10431, 'Medford (historical)', 33.9458312988281, 0.592466523491094, -91.3499984741211, -1.59435824506521, 218, 4, 'PPL', 'P'),
(128114, 'Medford Center', 45.2486114501953, 0.789737251761514, -68.829719543457, -1.20130522925761, 218, 26, 'PPL', 'P'),
(125384, 'Medford Hillside', 42.4124984741211, 0.740237742370484, -71.1258316040039, -1.24137994470891, 218, 23, 'PPL', 'P'),
(71107, 'Medford Lakes', 39.8583297729492, 0.695659088883648, -74.8033294677734, -1.30556439066674, 218, 37, 'PPL', 'P'),
(136816, 'Medford Trailer Park', 44.1741714477539, 0.770984736103776, -93.2461090087891, -1.62745161687692, 218, 28, 'PPL', 'P'),
(211991, 'Medfra', 63.1066703796387, 1.10141917809547, -154.714172363281, -2.70027170723727, 218, 1, 'PPL', 'P'),
(4146, 'Media', 33.6694412231445, 0.587642606650579, -87.0458297729492, -1.51923632966847, 218, 2, 'PPL', 'P'),
(78720, 'Media', 39.9166717529297, 0.69667734852644, -75.3880615234375, -1.31576989028004, 218, 45, 'PPL', 'P'),
(120581, 'Media', 40.7750015258789, 0.711658029132299, -90.8319396972656, -1.58531641369023, 218, 18, 'PPL', 'P'),
(116804, 'Mediapolis', 41.0080604553223, 0.715725674802259, -91.1638870239258, -1.59110998748364, 218, 16, 'PPL', 'P'),
(204895, 'Medical Drive Condominium', 40.8849983215332, 0.71357783538311, -111.865829467773, -1.95242704468714, 218, 52, 'PPL', 'P'),
(208092, 'Medical Lake', 47.5730590820313, 0.830306516227237, -117.681106567383, -2.05392277699115, 218, 56, 'PPL', 'P'),
(201213, 'Medical Springs', 45.017219543457, 0.785698701126464, -117.627502441406, -2.05298720850021, 218, 43, 'PPL', 'P'),
(209597, 'Medicine Bow', 41.8955612182617, 0.731215485229514, -106.204170227051, -1.85361244981057, 218, 59, 'PPL', 'P'),
(198609, 'Medicine Hole', 47.4441719055176, 0.828057010633474, -102.890556335449, -1.7957789772623, 218, 34, 'PPL', 'P'),
(197019, 'Medicine Hot Springs', 45.8461112976074, 0.800165591379019, -114.034439086914, -1.99027642273157, 218, 31, 'PPL', 'P'),
(136819, 'Medicine Lake', 44.9952812194824, 0.785315805140738, -93.415283203125, -1.63040426357749, 218, 28, 'PPL', 'P'),
(197020, 'Medicine Lake', 48.5013885498047, 0.84650892198317, -104.504173278809, -1.82394190578989, 218, 31, 'PPL', 'P'),
(33239, 'Medicine Lodge', 37.2811088562012, 0.650678098335128, -98.5800018310547, -1.72054560857394, 218, 20, 'PPL', 'P'),
(96126, 'Medicine Mound', 34.1877784729004, 0.596689298294551, -99.5941696166992, -1.7382461756011, 218, 51, 'PPL', 'P'),
(76575, 'Medicine Park', 34.7291717529297, 0.606138393579234, -98.5022201538086, -1.71918806220828, 218, 42, 'PPL', 'P'),
(96127, 'Medill', 33.7930603027344, 0.589800166607707, -95.408332824707, -1.66518954162972, 218, 51, 'PPL', 'P'),
(139316, 'Medill', 40.434440612793, 0.705714119895351, -91.7758331298828, -1.60179046187735, 218, 29, 'PPL', 'P'),
(195313, 'Medimont', 47.4761085510254, 0.828614410249627, -116.603332519531, -2.0351120712636, 218, 17, 'PPL', 'P'),
(10432, 'Medina', 33.964168548584, 0.592786568875094, -91.1986083984375, -1.59171598978969, 218, 4, 'PPL', 'P'),
(33241, 'Medina', 39.0777816772461, 0.682035954643456, -95.4208297729492, -1.665407654523, 218, 20, 'PPL', 'P'),
(88955, 'Medina', 35.8027801513672, 0.624876395009031, -88.7747192382813, -1.54941114324156, 218, 50, 'PPL', 'P'),
(96129, 'Medina', 26.9208297729492, 0.469857116906881, -99.2591705322266, -1.73239933858589, 218, 51, 'PPL', 'P'),
(110390, 'Medina', 38.9988899230957, 0.680659033780858, -81.6286087036133, -1.42468798570015, 218, 58, 'PPL', 'P'),
(132034, 'Medina', 41.8080596923828, 0.729688295502408, -84.2638931274414, -1.47068237562247, 218, 27, 'PPL', 'P'),
(136821, 'Medina', 45.0352783203125, 0.786013886241475, -93.5822219848633, -1.63331789496809, 218, 28, 'PPL', 'P'),
(140485, 'Medina', 46.8938903808594, 0.818452786215294, -99.2994384765625, -1.73310214679756, 218, 34, 'PPL', 'P'),
(150662, 'Medina', 43.2200012207031, 0.754331324017238, -78.3872222900391, -1.36811512045387, 218, 40, 'PPL', 'P'),
(156425, 'Medina', 41.1383285522461, 0.717999282003886, -81.8638916015625, -1.428794446943, 218, 41, 'PPL', 'P'),
(175246, 'Medina', 44.2727813720703, 0.77270580395824, -88.6377792358398, -1.54702108932127, 218, 57, 'PPL', 'P'),
(208093, 'Medina', 47.6211090087891, 0.831145145654502, -122.226387023926, -2.13325288638438, 218, 56, 'PPL', 'P'),
(175247, 'Medina Junction', 44.2330589294434, 0.772012516547465, -88.6216735839844, -1.54673999266821, 218, 57, 'PPL', 'P'),
(187043, 'Medina Plaza', 37.1277809143066, 0.648002020913762, -104.79167175293, -1.82895970075776, 218, 7, 'PPL', 'P'),
(120584, 'Medinah', 41.9813919067383, 0.732713513342683, -88.0511093139648, -1.53678176756213, 218, 18, 'PPL', 'P'),
(164452, 'Medix Run', 41.2900009155273, 0.720646464127425, -78.3974990844727, -1.36829448435329, 218, 45, 'PPL', 'P'),
(17081, 'Medley', 25.8402805328369, 0.450997974936999, -80.3266677856445, -1.40196483001516, 218, 12, 'PPL', 'P'),
(104173, 'Medley', 37.315559387207, 0.65127937353024, -80.0052795410156, -1.39635554696918, 218, 53, 'PPL', 'P'),
(110391, 'Medley', 39.1761093139648, 0.683752095649903, -79.0580596923828, -1.3798234418703, 218, 58, 'PPL', 'P'),
(189012, 'Medlin Place', 32.1227798461914, 0.560648273209318, -103.372222900391, -1.8041856447173, 218, 38, 'PPL', 'P'),
(10433, 'Medlock', 33.3499984741211, 0.582067278908498, -93.0250015258789, -1.62359256329934, 218, 4, 'PPL', 'P'),
(104174, 'Medlock', 38.0169410705566, 0.663520793217871, -78.1561126708984, -1.36408149666684, 218, 53, 'PPL', 'P'),
(104175, 'Medmont Lake', 37.2597198486328, 0.650304789729326, -80.0322189331055, -1.39682572805963, 218, 53, 'PPL', 'P'),
(110393, 'Medo', 38.0552787780762, 0.664189912441754, -80.9272232055664, -1.41244649943349, 218, 58, 'PPL', 'P'),
(56194, 'Medoc', 37.3072204589844, 0.651133831776668, -94.5266723632813, -1.64980166369319, 218, 29, 'PPL', 'P'),
(128116, 'Medomak', 44.000560760498, 0.767954657994511, -69.4058303833008, -1.21136026026932, 218, 26, 'PPL', 'P'),
(88956, 'Medon', 35.457218170166, 0.618845200667356, -88.8686065673828, -1.55104978626029, 218, 50, 'PPL', 'P'),
(30481, 'Medora', 38.8250007629395, 0.677624095402604, -86.1699981689453, -1.50395018448558, 218, 19, 'PPL', 'P'),
(33242, 'Medora', 38.1488914489746, 0.665823761770517, -97.8452835083008, -1.70772235476716, 218, 20, 'PPL', 'P'),
(37153, 'Medora', 38.0530586242676, 0.664151163447893, -85.870002746582, -1.49871427662443, 218, 21, 'PPL', 'P'),
(112308, 'Medora', 39.1744384765625, 0.683722934035967, -90.1430587768555, -1.5732931734749, 218, 18, 'PPL', 'P'),
(116805, 'Medora', 41.186939239502, 0.718847698548158, -93.6025009155273, -1.63367182907696, 218, 16, 'PPL', 'P'),
(198610, 'Medora', 46.913890838623, 0.818801860055176, -103.523887634277, -1.80683269368278, 218, 34, 'PPL', 'P'),
(17082, 'Medulla', 27.9675006866455, 0.488124970535739, -81.9736099243164, -1.43070939292482, 218, 12, 'PPL', 'P'),
(150663, 'Medusa', 42.4366683959961, 0.740659587087153, -74.1305618286133, -1.29382238026253, 218, 40, 'PPL', 'P'),
(73428, 'Medway', 39.8819389343262, 0.69607114648331, -84.0097198486328, -1.46624621503667, 218, 41, 'PPL', 'P'),
(125386, 'Medway', 42.1416702270508, 0.735510897751703, -71.397216796875, -1.24611650986567, 218, 23, 'PPL', 'P'),
(128118, 'Medway', 45.6088905334473, 0.796025307990328, -68.5313873291016, -1.19609834985235, 218, 26, 'PPL', 'P'),
(150664, 'Medway', 42.3972206115723, 0.73997109336634, -73.8886108398438, -1.28959953888005, 218, 40, 'PPL', 'P'),
(187803, 'Medway', 38.0136108398438, 0.66346266972708, -101.881942749023, -1.77817534929882, 218, 20, 'PPL', 'P'),
(128120, 'Mee Corners', 43.6438903808594, 0.761729585525478, -70.9472198486328, -1.23826258149492, 218, 26, 'PPL', 'P'),
(37154, 'Meece', 37.0283317565918, 0.646266305673302, -84.5088882446289, -1.47495834706871, 218, 21, 'PPL', 'P'),
(60854, 'Meehan', 32.3280601501465, 0.564231090402829, -88.8663864135742, -1.55101103726643, 218, 30, 'PPL', 'P'),
(175249, 'Meehan', 44.4361114501953, 0.775556451589061, -89.647216796875, -1.56463909835463, 218, 57, 'PPL', 'P'),
(142390, 'Meek', 42.6969413757324, 0.745202207537528, -98.6272201538086, -1.72136972377327, 218, 35, 'PPL', 'P'),
(10434, 'Meek (historical)', 33.8522186279297, 0.59083267416233, -92.3388900756836, -1.61161765945779, 218, 4, 'PPL', 'P'),
(42058, 'Meeker', 31.0563907623291, 0.542036272588595, -92.3805618286133, -1.6123449687515, 218, 22, 'PPL', 'P'),
(76576, 'Meeker', 35.5033302307129, 0.619650007948778, -96.9024963378906, -1.69126761449794, 218, 42, 'PPL', 'P'),
(96131, 'Meeker', 30.0827808380127, 0.52504357377918, -94.258056640625, -1.64511343491021, 218, 51, 'PPL', 'P'),
(110394, 'Meeker', 39.4661102294922, 0.688813566459654, -80.7880630493164, -1.41001769651934, 218, 58, 'PPL', 'P'),
(156429, 'Meeker', 40.6436080932617, 0.709364781117632, -83.3058319091797, -1.45396105292814, 218, 41, 'PPL', 'P'),
(164453, 'Meeker', 41.3136100769043, 0.721058521727088, -76.0661087036133, -1.32760404605797, 218, 45, 'PPL', 'P'),
(175250, 'Meeker', 43.2216682434082, 0.754360419052147, -88.1730575561523, -1.53891016590532, 218, 57, 'PPL', 'P'),
(194320, 'Meeker', 40.0374984741211, 0.698786172635619, -107.912498474121, -1.88342840242677, 218, 7, 'PPL', 'P'),
(208094, 'Meeker', 47.1863899230957, 0.823557866287894, -122.276107788086, -2.13412067742558, 218, 56, 'PPL', 'P'),
(194321, 'Meeker Park', 40.2338905334473, 0.702213860695633, -105.530281066895, -1.84185086517234, 218, 7, 'PPL', 'P'),
(175251, 'Meekers Grove', 42.6455612182617, 0.744305454619471, -90.3694381713867, -1.57724423926814, 218, 57, 'PPL', 'P'),
(23031, 'Meeks', 32.6186103820801, 0.569302148592503, -82.5569381713867, -1.44089039145608, 218, 13, 'PPL', 'P'),
(27866, 'Meeks', 39.9997215270996, 0.698126840528742, -87.5844421386719, -1.52863688884229, 218, 18, 'PPL', 'P'),
(60855, 'Meeks', 33.2994384765625, 0.5811848404813, -90.1891708374023, -1.57409798075632, 218, 30, 'PPL', 'P'),
(82359, 'Meeks', 34.2019386291504, 0.59693643964371, -79.7119369506836, -1.39123575293156, 218, 48, 'PPL', 'P'),
(96132, 'Meeks', 30.9919395446777, 0.540911386633659, -97.116943359375, -1.69501042109394, 218, 51, 'PPL', 'P'),
(183197, 'Meeks Bay', 39.0344390869141, 0.681279483735819, -120.123062133789, -2.09654294181234, 218, 6, 'PPL', 'P'),
(10435, 'Meeks Settlement', 34.0416717529297, 0.594139254971773, -93.3916702270508, -1.6299921393988, 218, 4, 'PPL', 'P'),
(4147, 'Meeksville', 31.9177799224854, 0.55707034957431, -86.0055618286133, -1.50108022893686, 218, 2, 'PPL', 'P'),
(175252, 'Meeme', 43.9205589294434, 0.766558362634982, -87.8313903808594, -1.53294694875047, 218, 57, 'PPL', 'P'),
(104176, 'Meems', 38.7252807617188, 0.67588365305121, -78.6619415283203, -1.37290987568045, 218, 53, 'PPL', 'P'),
(76577, 'Meers', 34.7827796936035, 0.607074028649206, -98.57861328125, -1.72052137380802, 218, 42, 'PPL', 'P'),
(209598, 'Meeteetse', 44.1572189331055, 0.770688858906668, -108.870826721191, -1.90015438565301, 218, 59, 'PPL', 'P'),
(14205, 'Meeting House Hill', 39.7916717529297, 0.694495686961447, -75.692497253418, -1.32108329612891, 218, 10, 'PPL', 'P'),
(125388, 'Meeting House Hill', 42.3069381713867, 0.738395367528367, -71.0625, -1.24027459969847, 218, 23, 'PPL', 'P'),
(14206, 'Meeting House Meadows', 39.7900009155273, 0.69446652534751, -75.6916732788086, -1.32106891505902, 218, 10, 'PPL', 'P'),
(49405, 'Meeting House Overlook', 39.5463905334473, 0.690214722088171, -77.5319366455078, -1.35318756991176, 218, 25, 'PPL', 'P'),
(82360, 'Meeting Street', 33.9416694641113, 0.592393885772362, -81.9283294677734, -1.42991909987134, 218, 48, 'PPL', 'P'),
(104177, 'Meetze', 38.6824989318848, 0.675136969260579, -77.7594375610352, -1.35715820993901, 218, 53, 'PPL', 'P'),
(10436, 'Meg', 35.4041709899902, 0.61791935271439, -93.8880615234375, -1.63865580189899, 218, 4, 'PPL', 'P'),
(23040, 'Megahee', 33.3844413757324, 0.582668420945556, -82.4033279418945, -1.4382093871867, 218, 13, 'PPL', 'P'),
(125389, 'Megansett', 41.6527786254883, 0.726978129619089, -70.6208267211914, -1.23256594676518, 218, 23, 'PPL', 'P'),
(4149, 'Megargel', 31.3797206878662, 0.547679444359445, -87.4283294677734, -1.52591220873103, 218, 2, 'PPL', 'P'),
(96133, 'Megargel', 33.4508285522461, 0.583827095756822, -98.9241714477539, -1.72655250157067, 218, 51, 'PPL', 'P'),
(199526, 'Megeath', 41.079719543457, 0.716976361829187, -101.985282897949, -1.77997897514708, 218, 35, 'PPL', 'P'),
(175255, 'Meggers', 43.9722213745117, 0.767460042401056, -88.041389465332, -1.53661212420069, 218, 57, 'PPL', 'P'),
(82363, 'Meggett', 32.7177810668945, 0.571033003563973, -80.2391662597656, -1.40043764028805, 218, 48, 'PPL', 'P'),
(208096, 'Megler', 46.2511100769043, 0.807234153544308, -123.856391906738, -2.16170183841304, 218, 56, 'PPL', 'P'),
(4148, 'Mehaffey', 31.6175003051758, 0.551829481575629, -88.3986129760742, -1.54284685062868, 218, 2, 'PPL', 'P'),
(201214, 'Mehama', 44.7902793884277, 0.781737848216216, -122.618057250977, -2.14008882142845, 218, 43, 'PPL', 'P'),
(76578, 'Mehan', 36.0449981689453, 0.629103896923423, -96.9422225952148, -1.69196096848774, 218, 42, 'PPL', 'P'),
(164455, 'Meharg', 40.7861099243164, 0.711851907259657, -79.8988876342773, -1.39449865789912, 218, 45, 'PPL', 'P'),
(104178, 'Meherrin', 37.1030616760254, 0.647570588817169, -78.366943359375, -1.367761186345, 218, 53, 'PPL', 'P'),
(56195, 'Mehlville', 38.5083312988281, 0.672097170613335, -90.3227767944336, -1.5764298446068, 218, 29, 'PPL', 'P'),
(164456, 'Mehoopany', 41.5633316040039, 0.725416984588084, -76.0608291625977, -1.32751190068425, 218, 45, 'PPL', 'P'),
(60856, 'Mehr', 33.8036117553711, 0.589984324197086, -90.149169921875, -1.57339983307656, 218, 30, 'PPL', 'P'),
(110395, 'Meighen', 39.7844390869141, 0.694369453125777, -80.7191696166992, -1.40881527928717, 218, 58, 'PPL', 'P'),
(23032, 'Meigs', 31.0722198486328, 0.542312542262177, -84.0891723632813, -1.46763292301628, 218, 13, 'PPL', 'P'),
(73430, 'Meigs', 39.6902809143066, 0.692726082996116, -81.7752838134766, -1.42724794929799, 218, 41, 'PPL', 'P'),
(88957, 'Meigs Cabin Area', 35.6872215270996, 0.622859516536487, -84.7102813720703, -1.47847332023345, 218, 50, 'PPL', 'P'),
(30482, 'Meiks', 39.5530586242676, 0.690331102227808, -85.7502822875977, -1.49662476043315, 218, 19, 'PPL', 'P'),
(183198, 'Meiners Oaks', 34.4469413757324, 0.601212544247996, -119.278327941895, -2.08179954885961, 218, 6, 'PPL', 'P'),
(183199, 'Meiners Oaks Trailer Park', 34.4552803039551, 0.601358086001569, -119.27889251709, -2.08180940255564, 218, 6, 'PPL', 'P'),
(56196, 'Meinert', 37.3352813720703, 0.651623587101133, -93.9905624389648, -1.64044478036125, 218, 29, 'PPL', 'P'),
(183200, 'Meinert', 37.9441719055176, 0.662250731694013, -122.026390075684, -2.12976228114361, 218, 6, 'PPL', 'P'),
(23033, 'Meinhard', 32.1813888549805, 0.561671193384017, -81.2111129760742, -1.41740131064159, 218, 13, 'PPL', 'P'),
(183201, 'Meins Landing', 38.139720916748, 0.665663705789004, -121.906112670898, -2.12766304441436, 218, 6, 'PPL', 'P'),
(136826, 'Meire Grove', 45.6297187805176, 0.796388829479124, -94.8688888549805, -1.65577446822796, 218, 28, 'PPL', 'P'),
(132035, 'Meisenheimer Corners', 43.8627815246582, 0.765549956688224, -86.3994369506836, -1.50795464665868, 218, 27, 'PPL', 'P'),
(164458, 'Meiser Station', 40.8008308410645, 0.712108835725822, -76.9891662597656, -1.34371443959824, 218, 45, 'PPL', 'P'),
(164459, 'Meisertown', 41.0805587768555, 0.716991009215182, -75.2688903808594, -1.31368996146868, 218, 45, 'PPL', 'P'),
(164460, 'Meiserville', 40.6691703796387, 0.709810927179247, -76.9725036621094, -1.3434236224072, 218, 45, 'PPL', 'P'),
(183202, 'Meiss', 38.6383285522461, 0.674366050704028, -120.33528137207, -2.10024686625643, 218, 6, 'PPL', 'P'),
(116806, 'Mekee', 42.4925003051758, 0.741634037730013, -91.0455627441406, -1.58904483921634, 218, 16, 'PPL', 'P'),
(140487, 'Mekinock', 48.0127792358398, 0.837981080698572, -97.3630599975586, -1.69930596677418, 218, 34, 'PPL', 'P'),
(76579, 'Mekko', 35, 0.610865238198015, -95.7536087036133, -1.67121574254435, 218, 42, 'PPL', 'P'),
(211992, 'Mekoryuk', 60.3880615234375, 1.05397050248089, -166.184997558594, -2.9004753748162, 218, 1, 'PPL', 'P'),
(204896, 'Mel Stephenson', 41.1575012207031, 0.718333908194855, -112.101387023926, -1.95653829961995, 218, 52, 'PPL', 'P'),
(116807, 'Mel-Ray Mobile Home Park', 41.7013893127441, 0.727826546163361, -93.6305618286133, -1.63416158440142, 218, 16, 'PPL', 'P'),
(17083, 'Melalevca Isles', 26.1186103820801, 0.455855747212872, -80.3166732788086, -1.40179039296376, 218, 12, 'PPL', 'P'),
(66766, 'Melanchton', 35.8466682434082, 0.625642386717565, -79.6444396972656, -1.39005770362336, 218, 33, 'PPL', 'P'),
(200067, 'Melandco', 41.2833290100098, 0.720530017408762, -114.835563659668, -2.00425868424476, 218, 39, 'PPL', 'P'),
(14207, 'Melanie', 39.6622200012207, 0.692236327671651, -75.626106262207, -1.31992455473861, 218, 10, 'PPL', 'P'),
(23034, 'Melanie Manor', 33.5986099243164, 0.586406367272564, -84.519172668457, -1.47513784412618, 218, 13, 'PPL', 'P'),
(60862, 'Melba', 31.4447193145752, 0.548813884404792, -89.6455612182617, -1.56461020305681, 218, 30, 'PPL', 'P'),
(195315, 'Melba', 43.375560760498, 0.757046350169546, -116.528060913086, -2.03379833389786, 218, 17, 'PPL', 'P'),
(37155, 'Melber', 36.9463882446289, 0.644836121588903, -88.7252807617188, -1.54854827904837, 218, 21, 'PPL', 'P'),
(156431, 'Melbern', 41.4669418334961, 0.723734665727481, -84.6513900756836, -1.47744547321073, 218, 41, 'PPL', 'P'),
(199527, 'Melbeta', 41.7816696166992, 0.729227701791879, -103.517219543457, -1.80671631354315, 218, 35, 'PPL', 'P'),
(4150, 'Melborne', 33.5727806091309, 0.585955560679041, -88.2027816772461, -1.53942894968567, 218, 2, 'PPL', 'P'),
(66767, 'Melborne Heights', 35.9636116027832, 0.627683433377002, -79.9652786254883, -1.39565739928942, 218, 33, 'PPL', 'P'),
(10438, 'Melbourne', 36.059440612793, 0.629355965120599, -91.908332824707, -1.60410301780992, 218, 4, 'PPL', 'P'),
(17084, 'Melbourne', 28.0833301544189, 0.490146576119218, -80.6083297729492, -1.40688075907134, 218, 12, 'PPL', 'P'),
(37158, 'Melbourne', 39.0297203063965, 0.681197125479109, -84.3663864135742, -1.47247122092668, 218, 21, 'PPL', 'P'),
(88959, 'Melbourne', 36.1794395446777, 0.631450341580865, -83.9930572509766, -1.46595539784564, 218, 50, 'PPL', 'P'),
(116808, 'Melbourne', 41.9413909912109, 0.732015365662919, -93.1030578613281, -1.62495490335497, 218, 16, 'PPL', 'P'),
(139317, 'Melbourne', 40.1416702270508, 0.700604312711816, -93.7874984741211, -1.63690064558257, 218, 29, 'PPL', 'P'),
(183203, 'Melbourne', 39.2833290100098, 0.685623432368875, -123.649719238281, -2.15809471987458, 218, 6, 'PPL', 'P'),
(208095, 'Melbourne', 46.9455604553223, 0.819354599139422, -123.624717712402, -2.15765836092997, 218, 56, 'PPL', 'P'),
(17085, 'Melbourne Beach', 28.0680599212646, 0.489880060273128, -80.5605621337891, -1.40604705649209, 218, 12, 'PPL', 'P'),
(17086, 'Melbourne Gardens', 28.0905609130859, 0.490272776665374, -80.6772232055664, -1.40808317630351, 218, 12, 'PPL', 'P'),
(17087, 'Melbourne Shores', 27.9624996185303, 0.488037685431012, -80.5097198486328, -1.40515969121687, 218, 12, 'PPL', 'P'),
(17088, 'Melbourne Village', 28.0849990844727, 0.490175704443641, -80.6666717529297, -1.40789901871413, 218, 12, 'PPL', 'P'),
(56197, 'Melby', 36.605281829834, 0.638882691551058, -89.8786087036133, -1.56867764898968, 218, 29, 'PPL', 'P'),
(136828, 'Melby', 46.0638885498047, 0.803966521465808, -95.7355575561523, -1.67090069058739, 218, 28, 'PPL', 'P'),
(30485, 'Melcher (historical)', 39.792781829834, 0.694515061458377, -87.3372192382813, -1.52432203524414, 218, 19, 'PPL', 'P'),
(116809, 'Melcher-Dallas', 41.2249984741211, 0.719511957503051, -93.2411117553711, -1.62736439835122, 218, 16, 'PPL', 'P'),
(164461, 'Melchris Wood', 41.3766708374023, 0.72215913962659, -75.1563873291016, -1.31172641279697, 218, 45, 'PPL', 'P'),
(156432, 'Melco', 40.6974983215332, 0.71030534303562, -82.35888671875, -1.43743374151922, 218, 41, 'PPL', 'P'),
(202368, 'Melcore Acres Subdivision', 44.0830612182617, 0.76939456261689, -103.439437866211, -1.80535876717748, 218, 49, 'PPL', 'P'),
(164462, 'Melcroft', 40.0519409179688, 0.699038240832795, -79.3894424438477, -1.38560716196768, 218, 45, 'PPL', 'P'),
(42068, 'Melder', 31.1049995422363, 0.542884655843353, -92.6363906860352, -1.61681002463512, 218, 22, 'PPL', 'P'),
(23035, 'Meldrim', 32.1430587768555, 0.561002207318189, -81.378059387207, -1.42031507519024, 218, 13, 'PPL', 'P'),
(17089, 'Meldrim Park', 29.8866691589355, 0.52162077927767, -81.561393737793, -1.42351486323997, 218, 12, 'PPL', 'P'),
(37156, 'Meldrum', 36.6669387817383, 0.639958808368531, -83.6941680908203, -1.46073879790239, 218, 21, 'PPL', 'P'),
(96134, 'Meldrum', 31.9213905334473, 0.557133366623604, -94.334716796875, -1.64645140704187, 218, 51, 'PPL', 'P'),
(189013, 'Melena', 33.542781829834, 0.585431983208731, -104.397499084473, -1.82208008987181, 218, 38, 'PPL', 'P'),
(96135, 'Melendy', 29.8802795410156, 0.521509259407023, -95.5708312988281, -1.6680256750326, 218, 51, 'PPL', 'P'),
(104181, 'Melfa', 37.649169921875, 0.657101975779535, -75.7416687011719, -1.32194149979019, 218, 53, 'PPL', 'P'),
(82362, 'Melgrove (historical)', 32.9291687011719, 0.574722413780114, -79.995002746582, -1.39617618306976, 218, 48, 'PPL', 'P'),
(170855, 'Melham', 44.5574989318848, 0.777675062815246, -97.6861114501953, -1.70494427827604, 218, 49, 'PPL', 'P'),
(142391, 'Melia', 41.0961112976074, 0.717262451909289, -96.2752838134766, -1.68032069083717, 218, 35, 'PPL', 'P'),
(187044, 'Melina', 38.0994415283203, 0.66496069784025, -103.186111450195, -1.80093738713573, 218, 7, 'PPL', 'P'),
(60858, 'Melis', 31.2297191619873, 0.545061423849843, -90.1125030517578, -1.57275987546661, 218, 30, 'PPL', 'P'),
(96138, 'Melissa', 33.285831451416, 0.580947353091092, -96.5725021362305, -1.68550812916648, 218, 51, 'PPL', 'P'),
(110396, 'Melissa', 38.3800010681152, 0.669857385557551, -82.334716796875, -1.43701189680255, 218, 58, 'PPL', 'P'),
(132036, 'Melita', 44.1127815246582, 0.76991327981821, -84.0072174072266, -1.4662025391948, 218, 27, 'PPL', 'P'),
(183204, 'Melita', 38.4566688537598, 0.671195490847262, -122.635833740234, -2.14039907969544, 218, 6, 'PPL', 'P'),
(49407, 'Melitota', 39.2580604553223, 0.685182412892358, -76.1458282470703, -1.32899541456948, 218, 25, 'PPL', 'P'),
(37157, 'Mell', 37.1122207641602, 0.647730445061601, -85.5286102294922, -1.49275585315954, 218, 21, 'PPL', 'P'),
(190470, 'Mellan', 37.7125015258789, 0.658207320789972, -116.593887329102, -2.03494722159212, 218, 39, 'PPL', 'P'),
(175271, 'Mellen', 46.3255615234375, 0.808533576419185, -90.6608276367188, -1.58232994484381, 218, 57, 'PPL', 'P'),
(150665, 'Mellenville', 42.253059387207, 0.73745500534746, -73.6680603027344, -1.28575020584045, 218, 40, 'PPL', 'P'),
(76580, 'Mellette', 35.2172203063965, 0.614656447746825, -95.7155609130859, -1.67055168332654, 218, 42, 'PPL', 'P'),
(170856, 'Mellette', 45.1544418334961, 0.788093681894772, -98.4972229003906, -1.71910084368258, 218, 49, 'PPL', 'P'),
(211993, 'Mellicks Trading Post', 61.684440612793, 1.07659658594415, -157.17805480957, -2.74327456830711, 218, 1, 'PPL', 'P'),
(110397, 'Mellin', 39.122501373291, 0.682816460579931, -81.1711120605469, -1.41670316296182, 218, 58, 'PPL', 'P'),
(164463, 'Mellingertown', 40.1452789306641, 0.700667296471596, -79.5183334350586, -1.38785673414047, 218, 45, 'PPL', 'P'),
(183205, 'Mello', 39.2066688537598, 0.684285460237219, -121.562217712402, -2.12166094510759, 218, 6, 'PPL', 'P'),
(123169, 'Mellott', 40.1652793884277, 0.701016370311478, -87.1477813720703, -1.52101572075081, 218, 19, 'PPL', 'P'),
(164464, 'Mellotts Mill', 40.017219543457, 0.698432238526747, -78.0386123657227, -1.36203072946942, 218, 45, 'PPL', 'P'),
(4158, 'Mellow Valley', 33.1858291625977, 0.579201983891682, -85.7480621337891, -1.49658601143929, 218, 2, 'PPL', 'P'),
(110398, 'Mellville', 37.8413887023926, 0.660456826383735, -81.9449996948242, -1.43021005022043, 218, 58, 'PPL', 'P'),
(10439, 'Mellwood', 34.2197189331055, 0.597246764489732, -90.9502792358398, -1.58738182827364, 218, 4, 'PPL', 'P'),
(49408, 'Mellwood', 38.8102798461914, 0.677367166936439, -76.8244400024414, -1.34083942404344, 218, 25, 'PPL', 'P'),
(156434, 'Melmore', 41.0238914489746, 0.716001977765354, -83.1094436645508, -1.45053343144715, 218, 41, 'PPL', 'P'),
(175257, 'Melnik', 44.247501373291, 0.772264584744641, -87.7458267211914, -1.53145358116921, 218, 57, 'PPL', 'P'),
(40, 'Melo', 28.6241703033447, 0.49958601744495, -97.4199981689453, -1.70029972533494, 218, 51, 'PPL', 'P'),
(42059, 'Melodia Plantation', 29.7730598449707, 0.519637922688051, -90.7280578613281, -1.5835033336201, 218, 22, 'PPL', 'P'),
(23036, 'Melody', 33.5944404602051, 0.586333596395778, -83.7641677856445, -1.46196052305246, 218, 13, 'PPL', 'P'),
(120585, 'Melody', 42.2402801513672, 0.737231965606166, -87.8824996948242, -1.53383897455759, 218, 18, 'PPL', 'P'),
(49410, 'Melody Acres', 38.4930610656738, 0.671830654767246, -76.7819366455078, -1.3400976005218, 218, 25, 'PPL', 'P'),
(88960, 'Melody Acres', 36.1808280944824, 0.631474576346784, -83.3944396972656, -1.45550755057315, 218, 50, 'PPL', 'P'),
(104182, 'Melody Acres', 37.2438888549805, 0.65002848676623, -80.0052795410156, -1.39635554696918, 218, 53, 'PPL', 'P'),
(4152, 'Melody Heights', 31.1819400787354, 0.544227521533512, -85.3819427490234, -1.49019602271976, 218, 2, 'PPL', 'P'),
(30483, 'Melody Hill', 38.0261116027832, 0.663680849199385, -87.5158309936523, -1.52743939845813, 218, 19, 'PPL', 'P'),
(96136, 'Melody Hills', 32.8302803039551, 0.572996485656661, -97.3091735839844, -1.69836547143522, 218, 51, 'PPL', 'P'),
(150666, 'Melody Lake', 41.5947189331055, 0.725964796824313, -74.6655578613281, -1.30315982251851, 218, 40, 'PPL', 'P'),
(14208, 'Melody Meadows', 39.5902786254883, 0.690980713796706, -75.7494430541992, -1.32207718784773, 218, 10, 'PPL', 'P'),
(14209, 'Melody Meadows II', 39.5958290100098, 0.691077586281357, -75.7458267211914, -1.32201407092989, 218, 10, 'PPL', 'P'),
(183206, 'Meloland', 32.8030586242676, 0.572521377718191, -115.446670532227, -2.01492451125247, 218, 6, 'PPL', 'P'),
(96137, 'Melon', 28.8411102294922, 0.503372333435256, -99.1136093139648, -1.729858816064, 218, 51, 'PPL', 'P'),
(208097, 'Melone', 46.9613914489746, 0.819630902102518, -123.329170227051, -2.1525000842146, 218, 56, 'PPL', 'P'),
(183207, 'Melones', 38.0125007629395, 0.66344329523015, -120.497497558594, -2.10307807281129, 218, 6, 'PPL', 'P'),
(183208, 'Melones Sunset Lake Estates', 37.9658317565918, 0.662628767410749, -120.474716186523, -2.10268046286054, 218, 6, 'PPL', 'P'),
(4156, 'Melrose', 33.3927803039551, 0.582813962699129, -88.1177825927734, -1.53794543580044, 218, 2, 'PPL', 'P'),
(10440, 'Melrose', 35.7436103820801, 0.623843687717326, -91.8491668701172, -1.60307037709724, 218, 4, 'PPL', 'P'),
(17090, 'Melrose', 29.7091693878174, 0.518522823850121, -82.0500030517578, -1.43204270452457, 218, 12, 'PPL', 'P'),
(23037, 'Melrose', 30.6408290863037, 0.534783353096846, -83.1358337402344, -1.45099402515768, 218, 13, 'PPL', 'P'),
(27867, 'Melrose', 39.223331451416, 0.684576277428256, -87.7641677856445, -1.53177369313224, 218, 18, 'PPL', 'P'),
(33244, 'Melrose', 37.0308303833008, 0.646309914936152, -94.9580612182617, -1.657330819569, 218, 20, 'PPL', 'P'),
(37160, 'Melrose', 38.5494384765625, 0.672814626211003, -82.7286071777344, -1.44388658084048, 218, 21, 'PPL', 'P'),
(42060, 'Melrose', 31.5986099243164, 0.551499782232677, -92.9669418334961, -1.62257923050456, 218, 22, 'PPL', 'P'),
(49412, 'Melrose', 39.5705604553223, 0.69063656680484, -76.3652801513672, -1.33282557284923, 218, 25, 'PPL', 'P'),
(56198, 'Melrose', 38.5727806091309, 0.673222023278757, -90.7230606079102, -1.5834161150944, 218, 29, 'PPL', 'P'),
(66768, 'Melrose', 35.2194404602051, 0.614695196740686, -82.3227767944336, -1.43680350444725, 218, 33, 'PPL', 'P'),
(82364, 'Melrose', 32.7922210693359, 0.572332226701768, -80.0469436645508, -1.39708272310483, 218, 48, 'PPL', 'P'),
(88961, 'Melrose', 35.7458305358887, 0.623882436711186, -83.8352813720703, -1.4632016892785, 218, 50, 'PPL', 'P'),
(96141, 'Melrose', 28.8033294677734, 0.502712934749352, -97.523063659668, -1.70209855749324, 218, 51, 'PPL', 'P'),
(104185, 'Melrose', 38.4972190856934, 0.67190322590695, -78.8036117553711, -1.37538248759453, 218, 53, 'PPL', 'P'),
(110399, 'Melrose', 37.3866691589355, 0.652520473177244, -81.054443359375, -1.41466690999235, 218, 58, 'PPL', 'P'),
(113694, 'Melrose', 41.9375, 0.731947455055122, -72.5216674804688, -1.26574187657068, 218, 8, 'PPL', 'P'),
(116810, 'Melrose', 40.9761085510254, 0.715168008869996, -93.0502777099609, -1.62403371593391, 218, 16, 'PPL', 'P'),
(125390, 'Melrose', 42.4583282470703, 0.741037622803889, -71.0666732788086, -1.24034743715428, 218, 23, 'PPL', 'P'),
(136829, 'Melrose', 45.6747207641602, 0.797174262263615, -94.8072204589844, -1.65469815167341, 218, 28, 'PPL', 'P'),
(145729, 'Melrose', 40.4908294677734, 0.70669829107619, -74.2972183227539, -1.29673108480511, 218, 37, 'PPL', 'P'),
(150668, 'Melrose', 42.8419418334961, 0.747732942942403, -73.6230621337891, -1.28496483963498, 218, 40, 'PPL', 'P'),
(156435, 'Melrose', 41.0922203063965, 0.717194541301492, -84.4197235107422, -1.47340212888572, 218, 41, 'PPL', 'P'),
(164465, 'Melrose', 41.9297218322754, 0.731811700418555, -75.5041732788086, -1.31779642271153, 218, 45, 'PPL', 'P'),
(175258, 'Melrose', 44.1305618286133, 0.770223604664231, -90.9980621337891, -1.588215797169, 218, 57, 'PPL', 'P'),
(189014, 'Melrose', 34.4302787780762, 0.600921727056959, -103.631942749023, -1.80871861120872, 218, 38, 'PPL', 'P'),
(195314, 'Melrose', 46.4083290100098, 0.809978141573471, -116.45361328125, -2.03249897760201, 218, 17, 'PPL', 'P'),
(197022, 'Melrose', 45.6319389343262, 0.796427578472984, -112.683609008789, -1.96669999023331, 218, 31, 'PPL', 'P'),
(201215, 'Melrose', 43.2477798461914, 0.754816152493687, -123.457778930664, -2.15474472953937, 218, 43, 'PPL', 'P'),
(73435, 'Melrose (historical)', 39.9083290100098, 0.696531740193839, -83.8438873291016, -1.46335189156398, 218, 41, 'PPL', 'P'),
(88963, 'Melrose (historical)', 36.332218170166, 0.634116831622306, -86.3663864135742, -1.50737780596657, 218, 50, 'PPL', 'P'),
(110400, 'Melrose Addition', 39.2605590820313, 0.685226022155208, -81.6222229003906, -1.42457653240853, 218, 58, 'PPL', 'P'),
(170859, 'Melrose Addition', 45.4533309936523, 0.793310281838019, -98.4625015258789, -1.71849484137653, 218, 49, 'PPL', 'P'),
(144131, 'Melrose Beach', 43.1766700744629, 0.753575052846683, -71.170280456543, -1.24215572353445, 218, 36, 'PPL', 'P'),
(144132, 'Melrose Corner', 43.3480606079102, 0.756566381962087, -70.975830078125, -1.23876192419931, 218, 36, 'PPL', 'P'),
(125391, 'Melrose Highlands', 42.4708290100098, 0.741255802276194, -71.0619430541992, -1.24026487916049, 218, 23, 'PPL', 'P'),
(136830, 'Melrose Mobile Home Park', 45.6902809143066, 0.797445838115776, -94.8055572509766, -1.65466912321753, 218, 28, 'PPL', 'P'),
(17091, 'Melrose Park', 26.1130599975586, 0.45575887472822, -80.1936111450195, -1.39964255354461, 218, 12, 'PPL', 'P'),
(88966, 'Melrose Park', 35.4952812194824, 0.619509526201276, -86.100830078125, -1.50274297356345, 218, 50, 'PPL', 'P'),
(96140, 'Melrose Park', 29.8700008392334, 0.521329862218092, -95.3713912963867, -1.66454479032981, 218, 51, 'PPL', 'P'),
(120586, 'Melrose Park', 41.9005584716797, 0.731302703755214, -87.8566665649414, -1.53338810138504, 218, 18, 'PPL', 'P'),
(150670, 'Melrose Park', 42.9086112976074, 0.748896544601686, -76.5405578613281, -1.33588474599341, 218, 40, 'PPL', 'P'),
(164466, 'Melrose Park', 40.0616683959961, 0.699208017352287, -75.1322174072266, -1.3113045680803, 218, 45, 'PPL', 'P'),
(175259, 'Melrose Park', 44.0327796936035, 0.768516984458681, -88.5947189331055, -1.54626954526165, 218, 57, 'PPL', 'P'),
(136833, 'Melrude', 47.2455596923828, 0.824590573579599, -92.4169387817383, -1.61297986635537, 218, 28, 'PPL', 'P'),
(23038, 'Melson', 34.1711082458496, 0.59639834794546, -85.4094390869141, -1.49067592434819, 218, 13, 'PPL', 'P'),
(49413, 'Melson', 38.4416694641113, 0.670933702112107, -75.4763870239258, -1.31731146107703, 218, 25, 'PPL', 'P'),
(183210, 'Melsons Corner', 38.610279083252, 0.673876495116644, -120.70361328125, -2.10667547081177, 218, 6, 'PPL', 'P'),
(197021, 'Melstone', 46.5986099243164, 0.813299170031827, -107.871391296387, -1.8827109468291, 218, 31, 'PPL', 'P'),
(49414, 'Melstone Valley', 39.3800010681152, 0.687310678077495, -76.9291687011719, -1.34266728465762, 218, 25, 'PPL', 'P'),
(132039, 'Melstrand', 46.4630584716797, 0.810933350877455, -86.4150009155273, -1.50822628908987, 218, 27, 'PPL', 'P'),
(4157, 'Melton', 32.7400016784668, 0.571420826397716, -87.6833267211914, -1.53036275038671, 218, 2, 'PPL', 'P'),
(23039, 'Melton', 33.3405609130859, 0.581902562395077, -82.0774993896484, -1.432522606153, 218, 13, 'PPL', 'P'),
(56199, 'Melton', 37.4283294677734, 0.653247582733863, -91.1800003051758, -1.59139121729475, 218, 29, 'PPL', 'P'),
(60859, 'Melton', 31.7863903045654, 0.55477716813867, -91.0569381713867, -1.5892433778756, 218, 30, 'PPL', 'P'),
(17092, 'Melton Manor', 29.6161098480225, 0.516898628480309, -82.3047180175781, -1.43648831933224, 218, 12, 'PPL', 'P'),
(191858, 'Melton Place Addition Colonia', 31.613000869751, 0.551750951612986, -106.25700378418, -1.85453456933801, 218, 51, 'PPL', 'P'),
(60860, 'Meltonia', 33.6025009155273, 0.586474277880361, -90.8861083984375, -1.5862618358772, 218, 30, 'PPL', 'P'),
(104186, 'Meltons', 38.1108283996582, 0.665159436236597, -78.1436080932617, -1.36386325061551, 218, 53, 'PPL', 'P'),
(197023, 'Meltons', 47.938060760498, 0.836676997291788, -114.388061523438, -1.99644829855783, 218, 31, 'PPL', 'P'),
(4159, 'Meltonsville', 34.435001373291, 0.601004151892697, -86.1900024414063, -1.50429932490449, 218, 2, 'PPL', 'P'),
(60861, 'Meltonville', 32.5163917541504, 0.567518096978259, -90.0377807617188, -1.5714557254808, 218, 30, 'PPL', 'P'),
(116812, 'Meltonville', 43.4472198486328, 0.758297037196475, -93.0261077880859, -1.62361187121724, 218, 16, 'PPL', 'P'),
(30484, 'Meltzer', 39.5188903808594, 0.689734753880712, -85.668327331543, -1.49519437661167, 218, 19, 'PPL', 'P'),
(120587, 'Melugin Grove (historical)', 41.7069396972656, 0.727923418648012, -89.1125030517578, -1.55530658294667, 218, 18, 'PPL', 'P'),
(56200, 'Melva', 36.5769386291504, 0.638388009378576, -93.2119369506836, -1.62685520195079, 218, 29, 'PPL', 'P'),
(49415, 'Melvale', 39.3458290100098, 0.686714263151371, -76.6500015258789, -1.33779489828526, 218, 25, 'PPL', 'P'),
(33245, 'Melvern', 38.5069389343262, 0.672072869268388, -95.6374969482422, -1.66918921011286, 218, 20, 'PPL', 'P'),
(27871, 'Melville', 38.936939239502, 0.679577790378286, -90.2458267211914, -1.57508681246907, 218, 18, 'PPL', 'P'),
(42063, 'Melville', 30.6927795410156, 0.535690059579477, -91.7438888549805, -1.60123292910314, 218, 22, 'PPL', 'P'),
(56201, 'Melville', 38.9902801513672, 0.68050876491635, -94.5447235107422, -1.65011671565014, 218, 29, 'PPL', 'P'),
(66769, 'Melville', 36.021671295166, 0.628696766171777, -79.333610534668, -1.38463271132482, 218, 33, 'PPL', 'P'),
(88967, 'Melville', 35.2333297729492, 0.61493761097891, -85.192497253418, -1.48688957506837, 218, 50, 'PPL', 'P'),
(140490, 'Melville', 47.3347206115723, 0.82614672518356, -99.0352783203125, -1.72849168231841, 218, 34, 'PPL', 'P'),
(150671, 'Melville', 40.7933311462402, 0.711977941358245, -73.4155578613281, -1.28134320686858, 218, 40, 'PPL', 'P'),
(169482, 'Melville', 41.5869407653809, 0.725829042187747, -71.2838897705078, -1.24413858012407, 218, 47, 'PPL', 'P'),
(197024, 'Melville', 46.1030616760254, 0.804650221496658, -109.953056335449, -1.9190428556844, 218, 31, 'PPL', 'P'),
(201216, 'Melville', 46.0602798461914, 0.803903537706027, -123.842216491699, -2.16145443074777, 218, 43, 'PPL', 'P'),
(49416, 'Melville Crossroads', 39.0769386291504, 0.682021240678434, -75.788330078125, -1.32275589445153, 218, 25, 'PPL', 'P'),
(172237, 'Melville Landing', 44.7613906860352, 0.781233645242837, -73.1658325195313, -1.27698467742856, 218, 55, 'PPL', 'P'),
(113695, 'Melville Village', 41.1911087036133, 0.718920469424945, -73.2350006103516, -1.27819188835069, 218, 8, 'PPL', 'P'),
(4160, 'Melvin', 31.9302806854248, 0.557288529046615, -88.4588928222656, -1.54389893241731, 218, 2, 'PPL', 'P'),
(37161, 'Melvin', 37.3502807617188, 0.651885375836288, -82.6941680908203, -1.44328550538245, 218, 21, 'PPL', 'P'),
(73436, 'Melvin', 39.473331451416, 0.688939600558242, -83.7177810668945, -1.46115092208108, 218, 41, 'PPL', 'P'),
(96142, 'Melvin', 31.1949996948242, 0.544455454833309, -99.5794372558594, -1.73798904739785, 218, 51, 'PPL', 'P'),
(116814, 'Melvin', 43.2874984741211, 0.755509373325435, -95.60888671875, -1.66868986740847, 218, 16, 'PPL', 'P'),
(120588, 'Melvin', 40.5675010681152, 0.708036462944927, -88.2477798461914, -1.54021431589114, 218, 18, 'PPL', 'P'),
(132040, 'Melvin', 43.1863899230957, 0.753744696208121, -82.8616714477539, -1.44620899046908, 218, 27, 'PPL', 'P'),
(136835, 'Melvin', 47.6208305358887, 0.831140285385513, -96.3888931274414, -1.68230354742679, 218, 28, 'PPL', 'P'),
(183211, 'Melvin', 36.8086090087891, 0.642431420282616, -119.699996948242, -2.08915906137399, 218, 6, 'PPL', 'P'),
(4161, 'Melvin (historical)', 34.9263916015625, 0.609580529288161, -87.8424987792969, -1.53314082687783, 218, 2, 'PPL', 'P'),
(190472, 'Melvin (historical)', 39.6813888549805, 0.692570887283592, -114.793609619141, -2.00352644810304, 218, 39, 'PPL', 'P'),
(14210, 'Melvin Crossroads', 38.9186096191406, 0.67925787815234, -75.7213897705078, -1.32158756568131, 218, 10, 'PPL', 'P'),
(128122, 'Melvin Heights', 44.2177810668945, 0.771745867543321, -69.1016693115234, -1.20605164811041, 218, 26, 'PPL', 'P'),
(150678, 'Melvin Hill', 42.9166717529297, 0.749037226086269, -77.0627822875977, -1.34499928166615, 218, 40, 'PPL', 'P'),
(144133, 'Melvin Mills', 43.2688903808594, 0.755184600830499, -71.9138870239258, -1.25513410647473, 218, 36, 'PPL', 'P'),
(144139, 'Melvin Village', 43.6888885498047, 0.762514951730942, -71.3047180175781, -1.24450210161286, 218, 36, 'PPL', 'P'),
(175262, 'Melvina', 43.8055610656738, 0.764551271279444, -90.7719421386719, -1.58426925874961, 218, 57, 'PPL', 'P'),
(132042, 'Melvindale', 42.2825012207031, 0.737968862279791, -83.1752777099609, -1.45168245229947, 218, 27, 'PPL', 'P'),
(88968, 'Melvine', 35.732780456543, 0.623654669858957, -85.0580596923828, -1.48454319698996, 218, 50, 'PPL', 'P'),
(14211, 'Melvins', 38.9433288574219, 0.679689310248933, -75.523063659668, -1.31812612205448, 218, 10, 'PPL', 'P'),
(14212, 'Melvins Crossroads', 38.9644393920898, 0.680057758585746, -75.5258331298828, -1.31817445842827, 218, 10, 'PPL', 'P'),
(27872, 'Melwood', 39.7616691589355, 0.69397204291211, -87.8636093139648, -1.53350927521464, 218, 18, 'PPL', 'P'),
(82366, 'Melwood', 33.9508285522461, 0.592553742016794, -81.1777801513672, -1.41681954310146, 218, 48, 'PPL', 'P'),
(104187, 'Melwood Manor', 37.4633293151855, 0.6538584453089, -79.0980606079102, -1.38052158955006, 218, 53, 'PPL', 'P'),
(56202, 'Melzo', 38.0099983215332, 0.663399619388273, -90.5694427490234, -1.58073497766696, 218, 29, 'PPL', 'P'),
(88969, 'Memento (historical)', 36.2466697692871, 0.632623730357153, -82.9291687011719, -1.44738703977728, 218, 50, 'PPL', 'P'),
(104188, 'Memorial Heights', 38.7686080932617, 0.676639857642738, -77.0791702270508, -1.34528530516722, 218, 53, 'PPL', 'P'),
(23041, 'Memory Park', 33.521671295166, 0.585063534871919, -82.0736083984375, -1.4324546955452, 218, 13, 'PPL', 'P'),
(4164, 'Memphis', 33.1363906860352, 0.578339119698496, -88.2975006103516, -1.54108210693234, 218, 2, 'PPL', 'P'),
(17093, 'Memphis', 27.5355606079102, 0.480586193990484, -82.561393737793, -1.44096815575992, 218, 12, 'PPL', 'P'),
(30486, 'Memphis', 38.4833297729492, 0.671660811668726, -85.7616729736328, -1.49682356540853, 218, 19, 'PPL', 'P'),
(60863, 'Memphis', 34.9180603027344, 0.609435120692643, -90.1369400024414, -1.57318638071519, 218, 30, 'PPL', 'P'),
(73437, 'Memphis', 39.4097213745117, 0.687829395278815, -83.6094436645508, -1.45926007770712, 218, 41, 'PPL', 'P'),
(88970, 'Memphis', 35.1494407653809, 0.613473471590612, -90.0488891601563, -1.57164960360816, 218, 50, 'PPL', 'P'),
(132043, 'Memphis', 42.8963890075684, 0.748683225398371, -82.7688903808594, -1.44458965536826, 218, 27, 'PPL', 'P'),
(139318, 'Memphis', 40.4577789306641, 0.706121450384079, -92.1711120605469, -1.6086893806812, 218, 29, 'PPL', 'P'),
(142394, 'Memphis', 41.0950012207031, 0.717243077412358, -96.4311065673828, -1.68304031094236, 218, 35, 'PPL', 'P'),
(150672, 'Memphis', 43.0827789306641, 0.75193634324893, -76.3775024414063, -1.33303889205255, 218, 40, 'PPL', 'P'),
(191859, 'Memphis', 34.7247200012207, 0.606060695854431, -100.53360748291, -1.75464245948439, 218, 51, 'PPL', 'P'),
(17094, 'Memphis Heights', 27.5363903045654, 0.480600674928911, -82.554443359375, -1.44084684877226, 218, 12, 'PPL', 'P'),
(37162, 'Memphis Junction', 36.9422187805176, 0.644763350712116, -86.4891662597656, -1.5095207185377, 218, 21, 'PPL', 'P'),
(60864, 'Memphis Junction', 33.8005599975586, 0.589931060975284, -89.7966690063477, -1.56724753148431, 218, 30, 'PPL', 'P'),
(164467, 'Memphord Estates', 40.1372184753418, 0.700526614987013, -76.9977798461914, -1.34386477504177, 218, 45, 'PPL', 'P'),
(10441, 'Mena', 34.586109161377, 0.603641480320203, -94.2394409179688, -1.64478852925722, 218, 4, 'PPL', 'P'),
(96143, 'Mena (historical)', 33.5833282470703, 0.586139651689393, -94.9166717529297, -1.65660843712332, 218, 51, 'PPL', 'P'),
(136836, 'Menahga', 46.7538909912109, 0.816009335915146, -95.0977783203125, -1.65976934302114, 218, 28, 'PPL', 'P'),
(195316, 'Menan', 43.7208290100098, 0.763072417926123, -111.989166259766, -1.95457967779625, 218, 17, 'PPL', 'P'),
(150673, 'Menands', 42.6919403076172, 0.745114922432801, -73.7249984741211, -1.28674396440121, 218, 40, 'PPL', 'P'),
(71111, 'Menantico', 39.3608283996582, 0.686976051886526, -74.991943359375, -1.30885632409019, 218, 37, 'PPL', 'P'),
(27873, 'Menard', 37.9099998474121, 0.661654316767889, -89.8397216796875, -1.56799894238588, 218, 18, 'PPL', 'P'),
(96144, 'Menard', 30.9174995422363, 0.539612163495864, -99.7861099243164, -1.74159616593631, 218, 51, 'PPL', 'P'),
(197025, 'Menard', 45.9738883972168, 0.802395722475852, -111.173332214355, -1.94034068755398, 218, 31, 'PPL', 'P'),
(197026, 'Menard Wye', 45.9672203063965, 0.802279342336215, -111.18138885498, -1.94048130245954, 218, 31, 'PPL', 'P'),
(175264, 'Menasha', 44.202220916748, 0.77147429169116, -88.4463882446289, -1.54368068636598, 218, 57, 'PPL', 'P'),
(125393, 'Menauhant', 41.5541687011719, 0.725257061764625, -70.5505599975586, -1.2313395610832, 218, 23, 'PPL', 'P'),
(78726, 'Mench', 39.973331451416, 0.697666246818213, -78.3247222900391, -1.36702428967137, 218, 45, 'PPL', 'P'),
(175267, 'Menchalville', 44.225830078125, 0.771886349290822, -87.8822174072266, -1.53383404770958, 218, 57, 'PPL', 'P'),
(104189, 'Menchville', 37.0872192382813, 0.647294086116991, -76.5283279418945, -1.33567129363204, 218, 53, 'PPL', 'P'),
(164468, 'Mendelssohn', 40.3041687011719, 0.703440446114696, -79.8930587768555, -1.39439692514548, 218, 45, 'PPL', 'P'),
(211994, 'Mendeltna', 62.0661087036133, 1.08325795077876, -146.449996948242, -2.55603463628247, 218, 1, 'PPL', 'P'),
(211995, 'Mendeltna Lodge', 62.0494384765625, 1.08296700042967, -146.538330078125, -2.55757634023752, 218, 1, 'PPL', 'P'),
(10443, 'Mendenhall', 33.5552787780762, 0.585650096102009, -93.1255569458008, -1.6253475864577, 218, 4, 'PPL', 'P'),
(60865, 'Mendenhall', 31.961669921875, 0.557836374572358, -89.870002746582, -1.5685274467042, 218, 30, 'PPL', 'P'),
(78727, 'Mendenhall', 39.853889465332, 0.695581590895926, -75.6416702270508, -1.3201961971698, 218, 45, 'PPL', 'P'),
(183212, 'Mendenhall Springs', 37.5883293151855, 0.656040106873893, -121.646667480469, -2.12313487161289, 218, 6, 'PPL', 'P'),
(193272, 'Mendenhall Valley', 58.3916702270508, 1.01912690120078, -134.566665649414, -2.34863137901263, 218, 1, 'PPL', 'P'),
(14213, 'Mendenhall Village', 39.7569389343262, 0.693889484918317, -75.6902770996094, -1.32104454713505, 218, 10, 'PPL', 'P'),
(193270, 'Mendenhaven', 58.3919410705566, 1.01913162831172, -134.566940307617, -2.34863617270259, 218, 1, 'PPL', 'P'),
(23042, 'Mendes', 31.9986095428467, 0.558481092582752, -81.9741668701172, -1.4307191134628, 218, 13, 'PPL', 'P'),
(190473, 'Mendha', 37.9561080932617, 0.662459057470284, -114.513610839844, -1.99863954750274, 218, 39, 'PPL', 'P'),
(145730, 'Mendham', 40.7758293151855, 0.711672476781212, -74.6011123657227, -1.30203503643212, 218, 37, 'PPL', 'P'),
(96146, 'Mendiates', 27.9819393157959, 0.488376972153888, -98.2494430541992, -1.71477626954645, 218, 51, 'PPL', 'P'),
(183213, 'Mendocino', 39.3077812194824, 0.68605020393356, -123.798332214355, -2.16068850561827, 218, 6, 'PPL', 'P'),
(56203, 'Mendon', 39.5897216796875, 0.690970993258727, -93.1344375610352, -1.62550258243314, 218, 29, 'PPL', 'P'),
(120590, 'Mendon', 40.0883293151855, 0.699673338173751, -91.2836074829102, -1.59319950367492, 218, 18, 'PPL', 'P'),
(125394, 'Mendon', 42.1055603027344, 0.734880660679735, -71.5527801513672, -1.248831602597, 218, 23, 'PPL', 'P'),
(132046, 'Mendon', 42.0063896179199, 0.733149805708265, -85.4499969482422, -1.49138379256593, 218, 27, 'PPL', 'P'),
(150674, 'Mendon', 42.9977798461914, 0.750452829363701, -77.5047225952148, -1.35271259513134, 218, 40, 'PPL', 'P'),
(156436, 'Mendon', 40.6733283996582, 0.709883498318952, -84.5188903808594, -1.47513291727816, 218, 41, 'PPL', 'P'),
(164469, 'Mendon', 40.1794395446777, 0.701263511660638, -79.6838912963867, -1.3907462639232, 218, 45, 'PPL', 'P'),
(172238, 'Mendon', 43.6513900756836, 0.761860479893056, -72.9274978637695, -1.27282495296391, 218, 55, 'PPL', 'P'),
(204902, 'Mendon', 41.7099990844727, 0.727976815027868, -111.976936340332, -1.95436622543488, 218, 52, 'PPL', 'P'),
(150675, 'Mendon Center', 42.9966697692871, 0.750433454866771, -77.5616683959961, -1.35370648685016, 218, 40, 'PPL', 'P'),
(104190, 'Mendota', 36.7108306884766, 0.640724866656093, -82.3016662597656, -1.43643505611044, 218, 53, 'PPL', 'P'),
(120592, 'Mendota', 41.5472183227539, 0.725135754776972, -89.1175003051758, -1.55539380147237, 218, 18, 'PPL', 'P'),
(136838, 'Mendota', 44.8872184753418, 0.783429754456743, -93.1641693115234, -1.62602149937154, 218, 28, 'PPL', 'P'),
(139319, 'Mendota', 40.5672187805176, 0.708031536096911, -92.8944396972656, -1.62131382951261, 218, 29, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(183215, 'Mendota', 36.7536087036133, 0.641471483867696, -120.380561828613, -2.10103715930991, 218, 6, 'PPL', 'P'),
(191860, 'Mendota', 35.8013916015625, 0.624852160243112, -100.497779846191, -1.75401714926044, 218, 51, 'PPL', 'P'),
(110401, 'Mendota (historical)', 39.6155586242676, 0.691421933010304, -80.9124984741211, -1.4121895043883, 218, 58, 'PPL', 'P'),
(116816, 'Mendota (historical)', 40.5952796936035, 0.708521291421376, -92.9244384765625, -1.62183740698292, 218, 16, 'PPL', 'P'),
(175269, 'Mendota Beach', 43.0863914489746, 0.751999393587737, -89.4749984741211, -1.56163332159032, 218, 57, 'PPL', 'P'),
(136839, 'Mendota Heights', 44.8836097717285, 0.783366770696963, -93.1380615234375, -1.62556583250903, 218, 28, 'PPL', 'P'),
(96147, 'Mendoza', 30.0047206878662, 0.523681167144523, -97.6858291625977, -1.70493935142802, 218, 51, 'PPL', 'P'),
(183216, 'Mendoza (historical)', 39.2344398498535, 0.684770155555613, -121.660827636719, -2.12338201296205, 218, 6, 'PPL', 'P'),
(42064, 'Menefee', 31.952220916748, 0.557671458321854, -92.5658264160156, -1.61557844578902, 218, 22, 'PPL', 'P'),
(125396, 'Menemsha', 41.3516693115234, 0.721722780681981, -70.7647171020508, -1.23507730767313, 218, 23, 'PPL', 'P'),
(10444, 'Meneshea', 35.4263916015625, 0.618307175548133, -90.2144393920898, -1.57453900023284, 218, 4, 'PPL', 'P'),
(56205, 'Menfro', 37.7769393920898, 0.659331973718313, -89.7233276367188, -1.56596748310637, 218, 29, 'PPL', 'P'),
(42065, 'Mengel Landing', 30.5125007629395, 0.532543601330575, -91.1947174072266, -1.59164807918189, 218, 22, 'PPL', 'P'),
(88971, 'Mengelwood', 36.045280456543, 0.62910882377144, -89.5436096191406, -1.56283081197447, 218, 50, 'PPL', 'P'),
(78728, 'Menges Mill', 39.7213897705078, 0.693269034963356, -77.1033325195313, -1.34570701672584, 218, 45, 'PPL', 'P'),
(78729, 'Menges Mills', 39.8608283996582, 0.695702698146498, -76.8952789306641, -1.34207579657951, 218, 45, 'PPL', 'P'),
(10445, 'Menifee', 35.1483306884766, 0.613454097093681, -92.5538864135742, -1.61537005343372, 218, 4, 'PPL', 'P'),
(183217, 'Menifee', 33.728328704834, 0.588670387094268, -117.145561218262, -2.04457574735525, 218, 6, 'PPL', 'P'),
(183218, 'Menifee Lakes', 33.6791687011719, 0.587812383170071, -117.154167175293, -2.04472594964073, 218, 6, 'PPL', 'P'),
(190474, 'Menken (historical)', 39.2083282470703, 0.684314422114074, -115.485557556152, -2.01560321785627, 218, 39, 'PPL', 'P'),
(23043, 'Menlo', 34.4847183227539, 0.601871876354872, -85.4763870239258, -1.49184438627646, 218, 13, 'PPL', 'P'),
(116817, 'Menlo', 41.5191688537598, 0.724646199189588, -94.404167175293, -1.64766354481202, 218, 16, 'PPL', 'P'),
(187805, 'Menlo', 39.3569412231445, 0.686908207857756, -100.722221374512, -1.75793439290784, 218, 20, 'PPL', 'P'),
(208098, 'Menlo', 46.6216697692871, 0.813701640251565, -123.64582824707, -2.15802680926679, 218, 56, 'PPL', 'P'),
(193781, 'Menlo Baths', 41.2658309936523, 0.720224619410757, -120.082778930664, -2.09583986728456, 218, 6, 'PPL', 'P'),
(183219, 'Menlo Oaks', 37.4674987792969, 0.653931216185687, -122.166389465332, -2.13220573144376, 218, 6, 'PPL', 'P'),
(145732, 'Menlo Park', 40.564998626709, 0.70799278710305, -74.3377838134766, -1.29743908618091, 218, 37, 'PPL', 'P'),
(183220, 'Menlo Park', 37.4538917541504, 0.653693728795479, -122.181106567383, -2.1324625933309, 218, 6, 'PPL', 'P'),
(145733, 'Menlo Park Terrace', 40.5525016784668, 0.707774674209772, -74.3238906860352, -1.29719660536366, 218, 37, 'PPL', 'P'),
(96148, 'Menlow', 31.8694400787354, 0.556226660140973, -97.1602783203125, -1.69576675884352, 218, 51, 'PPL', 'P'),
(164470, 'Menno', 40.5783309936523, 0.708225480803296, -77.7702789306641, -1.35734742753446, 218, 45, 'PPL', 'P'),
(170861, 'Menno', 43.2397193908691, 0.754675471009103, -97.5774993896484, -1.70304864021212, 218, 49, 'PPL', 'P'),
(76581, 'Meno', 36.3861083984375, 0.635057393540295, -98.1774978637695, -1.71352058909248, 218, 42, 'PPL', 'P'),
(150677, 'Meno', 44.5291709899902, 0.777180646958873, -74.3952789306641, -1.29844256527965, 218, 40, 'PPL', 'P'),
(33248, 'Menoken', 39.0908317565918, 0.682263721495685, -95.7555618286133, -1.6712498310063, 218, 20, 'PPL', 'P'),
(198612, 'Menoken', 46.8205604553223, 0.817172937574429, -100.530830383301, -1.75459398995255, 218, 34, 'PPL', 'P'),
(208099, 'Menoken', 46.2994384765625, 0.808077643240563, -118.160827636719, -2.06229548914225, 218, 56, 'PPL', 'P'),
(66770, 'Menola', 36.3388900756836, 0.63423327834097, -77.1291732788086, -1.34615802305644, 218, 33, 'PPL', 'P'),
(120594, 'Menominee', 42.4877815246582, 0.741551679473302, -90.5330581665039, -1.58009994690503, 218, 18, 'PPL', 'P'),
(132047, 'Menominee', 45.107780456543, 0.787279287233426, -87.6141662597656, -1.52915567262264, 218, 27, 'PPL', 'P'),
(142395, 'Menominee', 42.7869415283203, 0.746773006527484, -97.3741683959961, -1.69949984490154, 218, 35, 'PPL', 'P'),
(175273, 'Menomonee Falls', 43.1788902282715, 0.753613801840543, -88.1172180175781, -1.53793558210441, 218, 57, 'PPL', 'P'),
(175275, 'Menomonie', 44.875560760498, 0.783226288949461, -91.9191665649414, -1.60429210224731, 218, 57, 'PPL', 'P'),
(175276, 'Menomonie Junction', 44.9141693115234, 0.783900135284279, -91.9247207641602, -1.60438904131099, 218, 57, 'PPL', 'P'),
(132050, 'Menonaqua Beach', 45.4152793884277, 0.792646156041181, -84.9130630493164, -1.48201252816411, 218, 27, 'PPL', 'P'),
(56206, 'Menorkanut', 36.7038917541504, 0.640603759405521, -90.1733322143555, -1.57382154463517, 218, 29, 'PPL', 'P'),
(82367, 'Menriv Park', 32.9708290100098, 0.575449523336733, -79.9847183227539, -1.39599668601229, 218, 48, 'PPL', 'P'),
(211996, 'Mentasta Lake', 62.9211082458496, 1.09818050789383, -143.769165039063, -2.50924529277476, 218, 1, 'PPL', 'P'),
(164472, 'Mentcle', 40.6372184753418, 0.709253261246985, -78.8824996948242, -1.3767593418781, 218, 45, 'PPL', 'P'),
(132051, 'Mentha', 42.3572196960449, 0.739272945686576, -85.7747192382813, -1.49705126568173, 218, 27, 'PPL', 'P'),
(189015, 'Mentmore', 35.5141716003418, 0.619839225544228, -108.845001220703, -1.89970364563852, 218, 38, 'PPL', 'P'),
(4169, 'Mentone', 34.5794410705566, 0.603525100180566, -85.5905609130859, -1.49383709656211, 218, 2, 'PPL', 'P'),
(123170, 'Mentone', 41.1733283996582, 0.718610144578923, -86.0347213745117, -1.50158915902117, 218, 19, 'PPL', 'P'),
(183221, 'Mentone', 34.0699996948242, 0.594633670828146, -117.133613586426, -2.04436722184189, 218, 6, 'PPL', 'P'),
(191862, 'Mentone', 31.7067604064941, 0.553387364234298, -103.598373413086, -1.80813271576891, 218, 51, 'PPL', 'P'),
(30487, 'Mentor', 38.3163909912109, 0.668747180278125, -86.7188873291016, -1.51353010755881, 218, 19, 'PPL', 'P'),
(33250, 'Mentor', 38.7405586242676, 0.676150302055354, -97.602783203125, -1.70348992600475, 218, 20, 'PPL', 'P'),
(37164, 'Mentor', 38.8872184753418, 0.678709999337084, -84.2463912963867, -1.47037691104544, 218, 21, 'PPL', 'P'),
(56207, 'Mentor', 37.1061096191406, 0.647623785459943, -93.1988906860352, -1.62662750167759, 218, 29, 'PPL', 'P'),
(88972, 'Mentor', 35.8216705322266, 0.625206094351983, -84.0119400024414, -1.46628496403054, 218, 50, 'PPL', 'P'),
(136842, 'Mentor', 47.6983299255371, 0.832492904903164, -96.1408309936523, -1.67797404644264, 218, 28, 'PPL', 'P'),
(156437, 'Mentor', 41.6661109924316, 0.727210823319334, -81.3397216796875, -1.41964595596636, 218, 41, 'PPL', 'P'),
(208100, 'Mentor', 46.459171295166, 0.810865506848685, -117.471672058105, -2.05026745523696, 218, 56, 'PPL', 'P'),
(110402, 'Mentor (historical)', 38.8627815246582, 0.678283494088508, -81.6927795410156, -1.42580797809658, 218, 58, 'PPL', 'P'),
(156438, 'Mentor Acres', 41.6888885498047, 0.727608366691056, -81.3441696166992, -1.41972358711214, 218, 41, 'PPL', 'P'),
(156439, 'Mentor Headlands', 41.7397193908691, 0.728495532229189, -81.3119430541992, -1.41916112748991, 218, 41, 'PPL', 'P'),
(156442, 'Mentor-on-the-Lake', 41.7050018310547, 0.727889596502168, -81.3605575561523, -1.42000961061321, 218, 41, 'PPL', 'P'),
(104191, 'Mentow', 37.1925010681152, 0.649131600690119, -79.4272232055664, -1.38626656065358, 218, 53, 'PPL', 'P'),
(96149, 'Mentz', 29.75, 0.519235452468313, -96.4366683959961, -1.68313738316409, 218, 51, 'PPL', 'P'),
(156443, 'Mentzer', 40.5966682434082, 0.708545526187296, -83.581672668457, -1.45877538238873, 218, 41, 'PPL', 'P'),
(164473, 'Mentzer', 40.1252784729004, 0.700318222631714, -77.8852767944336, -1.35935451889, 218, 45, 'PPL', 'P'),
(37165, 'Menzie', 38.7397193908691, 0.676135654669359, -84.3399963378906, -1.47201062721615, 218, 21, 'PPL', 'P'),
(150680, 'Menzie Crossing', 42.9813919067383, 0.750166805862627, -77.807502746582, -1.35799710568239, 218, 40, 'PPL', 'P'),
(82368, 'Mepkin', 33.1147193908691, 0.577960884244678, -79.9524993896484, -1.39543435954812, 218, 48, 'PPL', 'P'),
(27874, 'Meppen', 38.996940612793, 0.680625011897932, -90.6047210693359, -1.58135070051099, 218, 18, 'PPL', 'P'),
(175280, 'Mequon', 43.2363891601563, 0.754617347518312, -87.9844436645508, -1.53561823248188, 218, 57, 'PPL', 'P'),
(42066, 'Mer Rouge', 32.7750015258789, 0.572031688972752, -91.7925033569336, -1.60208141222644, 218, 22, 'PPL', 'P'),
(56208, 'Meramec Springs (historical)', 37.9552803039551, 0.66244460982137, -91.5347213745117, -1.59758226788086, 218, 29, 'PPL', 'P'),
(56209, 'Meramec Terrace', 38.415828704834, 0.670482695781502, -90.8300018310547, -1.58528259154438, 218, 29, 'PPL', 'P'),
(42067, 'Meraux', 29.9327793121338, 0.522425553269578, -89.9497222900391, -1.56991881521572, 218, 22, 'PPL', 'P'),
(183222, 'Merazo', 38.2174987792969, 0.667021185575644, -122.371940612793, -2.1357932757482, 218, 6, 'PPL', 'P'),
(183223, 'Merced', 37.3022193908691, 0.65104654667194, -120.481941223145, -2.10280656353816, 218, 6, 'PPL', 'P'),
(10446, 'Merced (historical)', 35.663890838623, 0.622452319205814, -90.5536117553711, -1.58045867470387, 218, 4, 'PPL', 'P'),
(183225, 'Merced Falls', 37.5230598449707, 0.654900939717612, -120.331390380859, -2.10017895564863, 218, 6, 'PPL', 'P'),
(96150, 'Mercedes', 26.1494407653809, 0.456393838911122, -97.913330078125, -1.70890999145528, 218, 51, 'PPL', 'P'),
(17095, 'Mercer', 30.2769393920898, 0.528432279818738, -83.1141662597656, -1.45061585628289, 218, 12, 'PPL', 'P'),
(37166, 'Mercer', 37.2574996948242, 0.650266040735465, -87.1511077880859, -1.52107377766257, 218, 21, 'PPL', 'P'),
(66771, 'Mercer', 35.836669921875, 0.625467883087138, -77.6933288574219, -1.35600439539674, 218, 33, 'PPL', 'P'),
(88973, 'Mercer', 35.4791717529297, 0.619228362969191, -89.0422210693359, -1.55407993094858, 218, 50, 'PPL', 'P'),
(116819, 'Mercer', 40.9433288574219, 0.71459589528882, -94.6488876342773, -1.65193472256829, 218, 16, 'PPL', 'P'),
(128123, 'Mercer', 44.6780586242676, 0.779779226392517, -69.9369430541992, -1.22062992507556, 218, 26, 'PPL', 'P'),
(139320, 'Mercer', 40.5113906860352, 0.707057152033078, -93.5319366455078, -1.63244025023085, 218, 29, 'PPL', 'P'),
(142396, 'Mercer', 41.374439239502, 0.722120190895648, -96.4255599975586, -1.68294350503673, 218, 35, 'PPL', 'P'),
(156444, 'Mercer', 40.6549987792969, 0.709563586093006, -84.585563659668, -1.47629658551647, 218, 41, 'PPL', 'P'),
(164474, 'Mercer', 41.2269401550293, 0.719545846227923, -80.2399978637695, -1.40045215451599, 218, 45, 'PPL', 'P'),
(177426, 'Mercer', 46.1655616760254, 0.805741052279155, -90.0625, -1.57188715757739, 218, 57, 'PPL', 'P'),
(198616, 'Mercer', 47.4905586242676, 0.828866611604858, -100.710563659668, -1.75773092740056, 218, 34, 'PPL', 'P'),
(60866, 'Mercer (historical)', 33.0444412231445, 0.576734298825614, -89.4508285522461, -1.56121147687365, 218, 30, 'PPL', 'P'),
(82371, 'Mercer (historical)', 35.0194396972656, 0.611204524920891, -81.5425033569336, -1.42318516389702, 218, 48, 'PPL', 'P'),
(201217, 'Mercer (historical)', 44.0666694641113, 0.769108472536788, -124.069442749023, -2.16542027708506, 218, 43, 'PPL', 'P'),
(208101, 'Mercer Heights', 47.5702781677246, 0.83025798011637, -122.230560302734, -2.13332572384019, 218, 56, 'PPL', 'P'),
(208102, 'Mercer Island', 47.5708312988281, 0.830267634075321, -122.220832824707, -2.1331559473207, 218, 56, 'PPL', 'P'),
(208103, 'Mercer Island Town', 47.5844383239746, 0.830505121465529, -122.241668701172, -2.13351960196755, 218, 56, 'PPL', 'P'),
(66772, 'Mercer Landing', 33.9650001525879, 0.592801083103035, -78.2405624389648, -1.36555542317214, 218, 33, 'PPL', 'P'),
(125397, 'Mercer Square', 42.1319389343262, 0.735341054653183, -70.8591690063477, -1.23672580438789, 218, 23, 'PPL', 'P'),
(110404, 'Mercers Bottom', 38.644718170166, 0.674477570574675, -82.1624984741211, -1.43400612003823, 218, 58, 'PPL', 'P'),
(110405, 'Mercers Saltworks (historical)', 37.4824981689453, 0.654193004920842, -80.8786087036133, -1.41159801631019, 218, 58, 'PPL', 'P'),
(78730, 'Mercersburg', 39.8277816772461, 0.695125924033414, -77.9036102294922, -1.35967449769497, 218, 45, 'PPL', 'P'),
(78731, 'Mercersburg Junction', 39.8572196960449, 0.695639714386717, -77.8905563354492, -1.35944666426372, 218, 45, 'PPL', 'P'),
(49417, 'Mercersville', 39.4991683959961, 0.689390540309819, -77.7666702270508, -1.35728444377468, 218, 25, 'PPL', 'P'),
(73438, 'Mercerville', 38.6624984741211, 0.674787895420697, -82.2719421386719, -1.43591627233009, 218, 41, 'PPL', 'P'),
(145735, 'Mercerville', 40.2369384765625, 0.702267057338407, -74.6869430541992, -1.30353306454529, 218, 37, 'PPL', 'P'),
(183231, 'Mercey Hot Springs', 36.7041702270508, 0.640608619674511, -120.859169006348, -2.10939043038505, 218, 6, 'PPL', 'P'),
(104193, 'Merchant', 36.6780586242676, 0.640152886232971, -77.9522171020508, -1.36052284766022, 218, 53, 'PPL', 'P'),
(82369, 'Merchant (historical)', 34.0380592346191, 0.594076204632965, -81.6694412231445, -1.42540064760786, 218, 48, 'PPL', 'P'),
(104194, 'Merchants Hope (historical)', 37.2655601501465, 0.650406722220049, -77.2030563354492, -1.34744752565626, 218, 53, 'PPL', 'P'),
(112470, 'Merchantville', 39.9472198486328, 0.697210513376673, -75.0669403076172, -1.31016526776597, 218, 37, 'PPL', 'P'),
(142397, 'Merchiston', 41.3902816772461, 0.722396693595825, -97.8844375610352, -1.70840572190287, 218, 35, 'PPL', 'P'),
(33253, 'Mercier', 39.7083282470703, 0.693041068374045, -95.6013870239258, -1.66855897304089, 218, 20, 'PPL', 'P'),
(10447, 'Merck (historical)', 35.3122215270996, 0.616314531841508, -90.6111068725586, -1.58146215380261, 218, 4, 'PPL', 'P'),
(177408, 'Mercur', 41.8025016784668, 0.729591289859702, -76.3280563354492, -1.33217589470131, 218, 45, 'PPL', 'P'),
(204905, 'Mercur', 40.3208312988281, 0.703731263305732, -112.211387634277, -1.95845817244979, 218, 52, 'PPL', 'P'),
(4165, 'Mercury', 34.785831451416, 0.607127291871007, -86.5361099243164, -1.51034004004706, 218, 2, 'PPL', 'P'),
(96151, 'Mercury', 31.4122200012207, 0.548246664382118, -99.1572189331055, -1.73061994750355, 218, 51, 'PPL', 'P'),
(190475, 'Mercury', 36.6605606079102, 0.639847488234966, -115.993606567383, -2.02447034586375, 218, 39, 'PPL', 'P'),
(183226, 'Mercuryville', 38.7761116027832, 0.676770818589343, -122.820831298828, -2.14362789620105, 218, 6, 'PPL', 'P'),
(56216, 'Mercyville', 39.9716682434082, 0.697637218362331, -92.6430587768555, -1.61692640477476, 218, 29, 'PPL', 'P'),
(37168, 'Meredith', 37.4025001525879, 0.65279677614034, -86.2369384765625, -1.5051185132558, 218, 21, 'PPL', 'P'),
(120598, 'Meredith', 41.8994407653809, 0.731283196100229, -88.540283203125, -1.54531946254276, 218, 18, 'PPL', 'P'),
(132054, 'Meredith', 44.1305618286133, 0.770223604664231, -84.6072235107422, -1.47667462123321, 218, 27, 'PPL', 'P'),
(144134, 'Meredith', 43.6575012207031, 0.761967139494713, -71.5008316040039, -1.24792492940389, 218, 36, 'PPL', 'P'),
(150681, 'Meredith', 42.3583297729492, 0.739292320183506, -74.9347229003906, -1.30785763868141, 218, 40, 'PPL', 'P'),
(156446, 'Meredith', 40.3861083984375, 0.704870563620068, -83.1316680908203, -1.45092132085992, 218, 41, 'PPL', 'P'),
(164479, 'Meredith', 41.089168548584, 0.71714127807969, -78.9505615234375, -1.37794724488233, 218, 45, 'PPL', 'P'),
(187045, 'Meredith', 39.3630599975586, 0.687015000617469, -106.729438781738, -1.86278011554706, 218, 7, 'PPL', 'P'),
(208104, 'Meredith', 47.3466682434082, 0.826355250696913, -122.234718322754, -2.1333982949799, 218, 56, 'PPL', 'P'),
(144135, 'Meredith Center', 43.6141700744629, 0.761210868324158, -71.5297164916992, -1.24842906579824, 218, 36, 'PPL', 'P'),
(49418, 'Meredith Homes', 39.0119400024414, 0.680886800633087, -76.4236068725586, -1.33384356617591, 218, 25, 'PPL', 'P'),
(17096, 'Merediths', 29.4783306121826, 0.514493927174022, -82.6030578613281, -1.44169533189556, 218, 12, 'PPL', 'P'),
(104195, 'Meredithville', 36.8066711425781, 0.642397598136772, -77.9569396972656, -1.36060527249596, 218, 53, 'PPL', 'P'),
(27875, 'Meredosia', 39.8311080932617, 0.695183980945178, -90.559440612793, -1.58056040745751, 218, 18, 'PPL', 'P'),
(128125, 'Merepoint', 43.8247184753418, 0.764885631154304, -70.0258331298828, -1.22218134956858, 218, 26, 'PPL', 'P'),
(191863, 'Mereta', 31.4569396972656, 0.549027170318593, -100.140556335449, -1.74778242283246, 218, 51, 'PPL', 'P'),
(201218, 'Merganser (historical)', 42.1777801513672, 0.73614113482367, -121.799171447754, -2.12579656796437, 218, 43, 'PPL', 'P'),
(125398, 'Meriams Corner', 42.4597206115723, 0.741061924148836, -71.3249969482422, -1.24485603572173, 218, 23, 'PPL', 'P'),
(198619, 'Merida', 47.2427787780762, 0.824542037468733, -100.928886413574, -1.76154137828824, 218, 34, 'PPL', 'P'),
(150683, 'Meridale', 42.3669395446777, 0.739442589048014, -74.9541702270508, -1.30819705856234, 218, 40, 'PPL', 'P'),
(175283, 'Meridean', 44.7380599975586, 0.780826447912164, -91.7908325195313, -1.6020522506125, 218, 57, 'PPL', 'P'),
(33252, 'Meriden', 39.1888885498047, 0.683975135391198, -95.5694427490234, -1.66800144026668, 218, 20, 'PPL', 'P'),
(110406, 'Meriden', 39.1641693115234, 0.683543703294605, -80.0238876342773, -1.39668031946412, 218, 58, 'PPL', 'P'),
(113696, 'Meriden', 41.5380592346191, 0.72497589853254, -72.807502746582, -1.27073064308267, 218, 8, 'PPL', 'P'),
(116821, 'Meriden', 42.7947196960449, 0.746908761164051, -95.6341705322266, -1.66913115320109, 218, 16, 'PPL', 'P'),
(120599, 'Meriden', 41.5713882446289, 0.72555759949364, -89.033332824707, -1.55392480181508, 218, 18, 'PPL', 'P'),
(136844, 'Meriden', 44.0741691589355, 0.769239366904365, -93.3866729736328, -1.6299049208731, 218, 28, 'PPL', 'P'),
(144137, 'Meriden', 43.5438919067383, 0.759984282905095, -72.253059387207, -1.26105378094576, 218, 36, 'PPL', 'P'),
(145736, 'Meriden', 40.9472198486328, 0.714663805896617, -74.4580612182617, -1.29953832291017, 218, 37, 'PPL', 'P'),
(209599, 'Meriden', 41.5436096191406, 0.725072771017191, -104.31861114502, -1.82070323558824, 218, 59, 'PPL', 'P'),
(144138, 'Meriden Hill', 44.7822189331055, 0.781597166731633, -71.5547180175781, -1.24886542474285, 218, 36, 'PPL', 'P'),
(10448, 'Meridian', 33.0347213745117, 0.576564655464176, -91.9786071777344, -1.60532953664995, 218, 4, 'PPL', 'P'),
(17097, 'Meridian', 30.6383304595947, 0.534739743833995, -84.2819366455078, -1.47099729442138, 218, 12, 'PPL', 'P'),
(23044, 'Meridian', 31.4516696929932, 0.548935191392445, -81.378059387207, -1.42031507519024, 218, 13, 'PPL', 'P'),
(37169, 'Meridian', 38.776668548584, 0.676780539127321, -84.353889465332, -1.4722531080334, 218, 21, 'PPL', 'P'),
(42069, 'Meridian', 30.9252796173096, 0.539747951421944, -92.4052810668945, -1.61277640084809, 218, 22, 'PPL', 'P'),
(60868, 'Meridian', 32.3641700744629, 0.564861327474796, -88.70361328125, -1.54817011017358, 218, 30, 'PPL', 'P'),
(76585, 'Meridian', 34.4272193908691, 0.600868330677103, -97.977783203125, -1.71003491069973, 218, 42, 'PPL', 'P'),
(88974, 'Meridian', 35.8899993896484, 0.626398657888121, -84.9316711425781, -1.48233730065904, 218, 50, 'PPL', 'P'),
(96152, 'Meridian', 31.923059463501, 0.557162494948027, -97.6563873291016, -1.70442549449569, 218, 51, 'PPL', 'P'),
(132055, 'Meridian', 42.6897201538086, 0.74507617343894, -84.3636093139648, -1.47242275139484, 218, 27, 'PPL', 'P'),
(150684, 'Meridian', 43.1655616760254, 0.753381174719325, -76.5372161865234, -1.33582642276553, 218, 40, 'PPL', 'P'),
(164484, 'Meridian', 40.848331451416, 0.712937877773164, -79.9622192382813, -1.39560400290956, 218, 45, 'PPL', 'P'),
(183229, 'Meridian', 39.1433296203613, 0.683179982068727, -121.913330078125, -2.12778901193392, 218, 6, 'PPL', 'P'),
(187046, 'Meridian', 39.5516700744629, 0.690306867461888, -104.858329772949, -1.83012310267996, 218, 7, 'PPL', 'P'),
(195317, 'Meridian', 43.6122207641602, 0.761176846441232, -116.390556335449, -2.03139842628153, 218, 17, 'PPL', 'P'),
(208106, 'Meridian', 47.2097206115723, 0.823965063618567, -122.716667175293, -2.14180988928291, 218, 56, 'PPL', 'P'),
(142398, 'Meridian (historical)', 40.2166709899902, 0.701913322966617, -97.3638916015625, -1.69932048100212, 218, 35, 'PPL', 'P'),
(208107, 'Meridian Heights', 47.3794403076172, 0.826927231120035, -122.11833190918, -2.13136696885844, 218, 56, 'PPL', 'P'),
(30490, 'Meridian Hills', 39.8899993896484, 0.696211827967894, -86.1572189331055, -1.50372714474429, 218, 19, 'PPL', 'P'),
(178621, 'Meridiancheri Mobile Home Park', 33.4208297729492, 0.583303518286513, -111.580558776855, -1.94744813187118, 218, 5, 'PPL', 'P'),
(4166, 'Meridianville', 34.851390838623, 0.60827151903336, -86.5722198486328, -1.51097027711903, 218, 2, 'PPL', 'P'),
(183230, 'Merienda (historical)', 37.5875015258789, 0.65602565922498, -121.960563659668, -2.12861339344935, 218, 6, 'PPL', 'P'),
(104196, 'Merifield Acres', 36.5936088562012, 0.638678959727667, -78.5141677856445, -1.37033073732276, 218, 53, 'PPL', 'P'),
(60869, 'Merigold', 33.8388900756836, 0.590600047041112, -90.7261123657227, -1.5834693783162, 218, 30, 'PPL', 'P'),
(169483, 'Merino', 41.8211097717285, 0.729916062354637, -71.4652786254883, -1.2473044128699, 218, 47, 'PPL', 'P'),
(194322, 'Merino', 40.4824981689453, 0.706552882480671, -103.350830078125, -1.80381226953247, 218, 7, 'PPL', 'P'),
(197027, 'Merino', 47.2438888549805, 0.824561411965663, -110.365280151367, -1.9262375185273, 218, 31, 'PPL', 'P'),
(125399, 'Merino Village', 42.0499992370605, 0.73391093714781, -71.8902816772461, -1.2547221154541, 218, 23, 'PPL', 'P'),
(125400, 'Merino Village (historical)', 42.0497207641602, 0.733906076878821, -71.8888931274414, -1.25469788068818, 218, 23, 'PPL', 'P'),
(164480, 'Merion Hills', 40.0750007629395, 0.699440711052533, -75.3544387817383, -1.31518306273384, 218, 45, 'PPL', 'P'),
(78733, 'Merion Park', 39.9933280944824, 0.698015254079068, -75.2513885498047, -1.31338449689165, 218, 45, 'PPL', 'P'),
(60870, 'Merit', 31.9277801513672, 0.557244886494251, -89.9086074829102, -1.56920122645999, 218, 30, 'PPL', 'P'),
(96153, 'Merit', 33.2166709899902, 0.579740275327014, -96.2872161865234, -1.68052895003441, 218, 51, 'PPL', 'P'),
(96154, 'Merito', 26.2563896179199, 0.458260448519159, -98.2205581665039, -1.7142721331521, 218, 51, 'PPL', 'P'),
(23045, 'Meriwether', 33.1549987792969, 0.578663892193431, -83.3191680908203, -1.45419381320741, 218, 13, 'PPL', 'P'),
(82372, 'Meriwether', 33.6527786254883, 0.587351789459542, -82.1597213745117, -1.43395765050639, 218, 48, 'PPL', 'P'),
(197028, 'Meriwether', 48.6063919067383, 0.848341576287308, -112.76000213623, -1.96803330183306, 218, 31, 'PPL', 'P'),
(104204, 'Meriwether Hill', 38.0605583190918, 0.66428205781547, -78.5936126708984, -1.37171731214431, 218, 53, 'PPL', 'P'),
(191864, 'Merkel', 32.4705581665039, 0.566718149965826, -100.012496948242, -1.74554736488761, 218, 51, 'PPL', 'P'),
(199528, 'Merklin Trailer Court', 40.0519409179688, 0.699038240832795, -101.531387329102, -1.77205700301047, 218, 35, 'PPL', 'P'),
(96155, 'Merle', 30.4491691589355, 0.531438256320138, -96.4622192382813, -1.68358332948862, 218, 51, 'PPL', 'P'),
(116822, 'Merle Junction', 40.7816696166992, 0.711774409271935, -94.5924987792969, -1.65095055138745, 218, 16, 'PPL', 'P'),
(584, 'Merlin', 30.3883304595947, 0.53037642070401, -91.2897186279297, -1.59330616327657, 218, 22, 'PPL', 'P'),
(164481, 'Merlin', 40.1030616760254, 0.699930466376999, -75.579719543457, -1.31911495376723, 218, 45, 'PPL', 'P'),
(183232, 'Merlin', 39.8883285522461, 0.696182666353957, -121.365829467773, -2.1182333236266, 218, 6, 'PPL', 'P'),
(201219, 'Merlin', 42.5175018310547, 0.742070396674622, -123.418609619141, -2.15406109608755, 218, 43, 'PPL', 'P'),
(23047, 'Merlin Meadows', 33.7777786254883, 0.589533451024535, -84.7177810668945, -1.47860421460102, 218, 13, 'PPL', 'P'),
(14217, 'Mermaid', 39.7427787780762, 0.693642343569158, -75.6933288574219, -1.32109781035685, 218, 10, 'PPL', 'P'),
(164482, 'Mermaid', 40.0788917541504, 0.69950862166033, -75.1786117553711, -1.31211430220974, 218, 45, 'PPL', 'P'),
(14214, 'Mermaid Run', 39.7402801513672, 0.693598734306308, -75.6944427490234, -1.32111725143281, 218, 10, 'PPL', 'P'),
(42070, 'Mermentau', 30.1897201538086, 0.526910016939649, -92.5824966430664, -1.61586939613811, 218, 22, 'PPL', 'P'),
(27877, 'Mermet', 37.2730598449707, 0.650537616587626, -88.8461074829102, -1.55065710315755, 218, 18, 'PPL', 'P'),
(156447, 'Mermill', 41.2975006103516, 0.720777358495003, -83.6458282470703, -1.45989510846905, 218, 41, 'PPL', 'P'),
(56217, 'Merna', 38.9711112976074, 0.680174205304409, -92.6494369506836, -1.61703772490832, 218, 29, 'PPL', 'P'),
(120601, 'Merna', 40.5166702270508, 0.707149297406795, -88.8258285522461, -1.55030316904868, 218, 18, 'PPL', 'P'),
(142400, 'Merna', 41.4838905334473, 0.724030476345562, -99.7597198486328, -1.74113557222578, 218, 35, 'PPL', 'P'),
(209600, 'Merna', 42.9463882446289, 0.749555876708562, -110.339996337891, -1.92579623273468, 218, 59, 'PPL', 'P'),
(30488, 'Merom', 39.0563888549805, 0.681662579458627, -87.567497253418, -1.52834114480323, 218, 19, 'PPL', 'P'),
(30489, 'Merom Station', 39.0302810668945, 0.681206912596115, -87.5397186279297, -1.52785631632679, 218, 19, 'PPL', 'P'),
(10449, 'Meroney', 33.9602813720703, 0.592718724846324, -91.73388671875, -1.60105835889369, 218, 4, 'PPL', 'P'),
(4167, 'Merrell Beach', 33.0916709899902, 0.577558613762021, -86.524169921875, -1.51013164769176, 218, 2, 'PPL', 'P'),
(4168, 'Merrellton', 33.8633308410645, 0.591026618868715, -85.741943359375, -1.49647921867958, 218, 2, 'PPL', 'P'),
(96157, 'Merrelltown', 30.454439163208, 0.531530235246287, -97.6947174072266, -1.70509448056152, 218, 51, 'PPL', 'P'),
(27878, 'Merriam', 38.3624992370605, 0.669551920980519, -88.2772216796875, -1.54072817282347, 218, 18, 'PPL', 'P'),
(33255, 'Merriam', 39.023609161377, 0.681090465877451, -94.6933288574219, -1.65271036823577, 218, 20, 'PPL', 'P'),
(73439, 'Merriam', 39.8033294677734, 0.694699152468729, -81.9000015258789, -1.42942468401497, 218, 41, 'PPL', 'P'),
(123171, 'Merriam', 41.2872200012207, 0.720597928016559, -85.434440612793, -1.4911122832928, 218, 19, 'PPL', 'P'),
(136846, 'Merriam', 44.7377815246582, 0.780821587643174, -93.5941696166992, -1.63352642048144, 218, 28, 'PPL', 'P'),
(56218, 'Merriam Woods', 36.7138900756836, 0.640778263035949, -93.1616668701172, -1.62597782352967, 218, 29, 'PPL', 'P'),
(164483, 'Merrian', 40.7783317565918, 0.71171615262309, -76.4094390869141, -1.3335962916687, 218, 45, 'PPL', 'P'),
(33257, 'Merrick', 38.4027786254883, 0.670254928929273, -96.2444381713867, -1.67978233282281, 218, 20, 'PPL', 'P'),
(42074, 'Merrick', 31.0033302307129, 0.541110191609033, -91.7227783203125, -1.60086448076633, 218, 22, 'PPL', 'P'),
(76587, 'Merrick', 35.8563919067383, 0.625812096658031, -97.1408309936523, -1.69542733896259, 218, 42, 'PPL', 'P'),
(123172, 'Merrick', 41.7374992370605, 0.728456783235328, -86.8152770996094, -1.51521242641942, 218, 19, 'PPL', 'P'),
(125401, 'Merrick', 42.1166687011719, 0.735074538807093, -72.625, -1.26754536926088, 218, 23, 'PPL', 'P'),
(150685, 'Merrick', 40.6627807617188, 0.7096994073086, -73.5519409179688, -1.2837235402509, 218, 40, 'PPL', 'P'),
(191865, 'Merrick', 32.3844413757324, 0.565215128425613, -101.839721679688, -1.7774384526252, 218, 51, 'PPL', 'P'),
(150686, 'Merrick Corner', 43.3069381713867, 0.755848660048311, -75.289436340332, -1.31404855610946, 218, 40, 'PPL', 'P'),
(150687, 'Merrickville', 42.2752799987793, 0.737842828181203, -75.1786117553711, -1.31211430220974, 218, 40, 'PPL', 'P'),
(140494, 'Merricourt', 46.2094383239746, 0.806506844250607, -98.7622222900391, -1.72372595554772, 218, 34, 'PPL', 'P'),
(150688, 'Merriewold Park', 41.5719413757324, 0.725567253452592, -74.7188873291016, -1.30409059731949, 218, 40, 'PPL', 'P'),
(37170, 'Merrifield', 38.2786102294922, 0.668087781592221, -85.6402816772461, -1.49470488760332, 218, 21, 'PPL', 'P'),
(104198, 'Merrifield', 36.8791694641113, 0.643662932549695, -76.3827819824219, -1.33313103742626, 218, 53, 'PPL', 'P'),
(136847, 'Merrifield', 46.4650001525879, 0.810967239602326, -94.1725006103516, -1.643620200487, 218, 28, 'PPL', 'P'),
(140496, 'Merrifield', 47.8458290100098, 0.835067249570889, -97.1091690063477, -1.6948747330364, 218, 34, 'PPL', 'P'),
(150689, 'Merrifield', 42.7827796936035, 0.746700368808752, -76.5852813720703, -1.33666531850891, 218, 40, 'PPL', 'P'),
(82377, 'Merrifield Park', 34.8633308410645, 0.608479911388659, -82.3133316040039, -1.43663865477577, 218, 48, 'PPL', 'P'),
(49421, 'Merrill', 39.5988883972168, 0.691130982661213, -79.0833282470703, -1.38026446134681, 218, 25, 'PPL', 'P'),
(60871, 'Merrill', 30.978889465332, 0.54068361978143, -88.7205581665039, -1.54846585421264, 218, 30, 'PPL', 'P'),
(116823, 'Merrill', 42.7197189331055, 0.74559975090925, -96.2483291625977, -1.67985024343061, 218, 16, 'PPL', 'P'),
(132057, 'Merrill', 43.4097213745117, 0.757642565358588, -84.3288879394531, -1.47181674908879, 218, 27, 'PPL', 'P'),
(150690, 'Merrill', 44.764720916748, 0.781291768733628, -73.958610534668, -1.29082126403012, 218, 40, 'PPL', 'P'),
(164485, 'Merrill', 40.666389465332, 0.70976239106838, -80.3552780151367, -1.40246417271955, 218, 45, 'PPL', 'P'),
(175284, 'Merrill', 45.1805610656738, 0.788549548494366, -89.6833267211914, -1.5652693354266, 218, 57, 'PPL', 'P'),
(201220, 'Merrill', 42.0252799987793, 0.733479505051217, -121.59944152832, -2.12231062325551, 218, 43, 'PPL', 'P'),
(96156, 'Merrill Colonia', 26.3330593109131, 0.459598587098383, -98.1255569458008, -1.71261404905741, 218, 51, 'PPL', 'P'),
(128126, 'Merrill Corner', 43.9263916015625, 0.766660161967651, -70.9458312988281, -1.238238346729, 218, 26, 'PPL', 'P'),
(172241, 'Merrill Corner', 44.7033309936523, 0.780220312448062, -72.3391723632813, -1.26255673590695, 218, 55, 'PPL', 'P'),
(144144, 'Merrill Corners', 43.3244400024414, 0.756154124625343, -71.0719375610352, -1.24043931621189, 218, 36, 'PPL', 'P'),
(4170, 'Merrill Mill', 31.5930595397949, 0.551402909748026, -86.4024963378906, -1.50800804303853, 218, 2, 'PPL', 'P'),
(189016, 'Merrill Place', 35.3455581665039, 0.616896365960663, -108.484169006348, -1.89340593545075, 218, 38, 'PPL', 'P'),
(175287, 'Merrillan', 44.4511108398438, 0.775818240324215, -90.8411102294922, -1.58547646967174, 218, 57, 'PPL', 'P'),
(183233, 'Merrills Landing', 39.8783302307129, 0.69600816272353, -122.038612365723, -2.12997560034693, 218, 6, 'PPL', 'P'),
(150692, 'Merrillsville', 43.0188903808594, 0.750821277700514, -75.67138671875, -1.3207148477921, 218, 40, 'PPL', 'P'),
(23048, 'Merrillville', 30.9488906860352, 0.54016004231112, -83.879997253418, -1.46398212863594, 218, 13, 'PPL', 'P'),
(123173, 'Merrillville', 41.482780456543, 0.724011101848631, -87.3327789306641, -1.52424453725642, 218, 19, 'PPL', 'P'),
(17098, 'Merrimac', 28.7250003814697, 0.501345834293274, -81.5625, -1.42353417115788, 218, 12, 'PPL', 'P'),
(27879, 'Merrimac', 38.3708305358887, 0.669697329576038, -90.3333282470703, -1.57661400219617, 218, 18, 'PPL', 'P'),
(37171, 'Merrimac', 37.4124984741211, 0.652971279770768, -85.1286087036133, -1.48577450951995, 218, 21, 'PPL', 'P'),
(104200, 'Merrimac', 37.1894416809082, 0.649078204310263, -80.4258270263672, -1.40369548524955, 218, 53, 'PPL', 'P'),
(110407, 'Merrimac', 37.6352806091309, 0.656859561541311, -82.2161102294922, -1.43494182168723, 218, 58, 'PPL', 'P'),
(116824, 'Merrimac', 41.0872192382813, 0.717107256196764, -91.7186126708984, -1.60079177646857, 218, 16, 'PPL', 'P'),
(125402, 'Merrimac', 42.8305587768555, 0.747534271125083, -71.0027770996094, -1.23923223844781, 218, 23, 'PPL', 'P'),
(175289, 'Merrimac', 43.3733291625977, 0.757007401438604, -89.6233291625977, -1.56422218048598, 218, 57, 'PPL', 'P'),
(183234, 'Merrimac', 39.7661094665527, 0.694049540899831, -121.30638885498, -2.11719588922396, 218, 6, 'PPL', 'P'),
(104201, 'Merrimac Shores', 37.0077781677246, 0.645907577874469, -76.3502807617188, -1.33256378411408, 218, 53, 'PPL', 'P'),
(104202, 'Merrimac South', 38.4511108398438, 0.671098485204556, -78.0713882446289, -1.36260277647157, 218, 53, 'PPL', 'P'),
(125403, 'Merrimac Terrace', 42.4822196960449, 0.741454607251569, -71.0041732788086, -1.23925660637179, 218, 23, 'PPL', 'P'),
(144140, 'Merrimack', 42.8650016784668, 0.748135413162141, -71.4938888549805, -1.24780375557429, 218, 36, 'PPL', 'P'),
(49422, 'Merrimack Park', 38.9747200012207, 0.68023718906419, -77.1277770996094, -1.34613365513247, 218, 25, 'PPL', 'P'),
(104203, 'Merrimack Park', 36.939998626709, 0.644724601718256, -76.273063659668, -1.33121609144444, 218, 53, 'PPL', 'P'),
(125405, 'Merrimacport', 42.8277816772461, 0.747485801593244, -70.9888916015625, -1.23898989078862, 218, 23, 'PPL', 'P'),
(132059, 'Merriman', 45.9174995422363, 0.801411551295013, -88.0555572509766, -1.53685939870791, 218, 27, 'PPL', 'P'),
(197029, 'Merriman', 45.3388900756836, 0.79131291102046, -110.767776489258, -1.93326240485071, 218, 31, 'PPL', 'P'),
(199529, 'Merriman', 42.9197196960449, 0.749090422729044, -101.70027923584, -1.77500472286303, 218, 35, 'PPL', 'P'),
(96158, 'Merriman (historical)', 32.4226913452148, 0.565882716331868, -98.6977310180664, -1.72260037051299, 218, 51, 'PPL', 'P'),
(66785, 'Merrimon', 34.9491691589355, 0.609978072659883, -76.6397171020508, -1.33761540122779, 218, 33, 'PPL', 'P'),
(120603, 'Merrionette Park', 41.6841697692871, 0.727526008434345, -87.7002792358398, -1.53065862758382, 218, 18, 'PPL', 'P'),
(27880, 'Merritt', 39.7144393920898, 0.693147727975703, -90.4158325195313, -1.57805397339758, 218, 18, 'PPL', 'P'),
(56220, 'Merritt', 36.898609161377, 0.644002219272572, -92.8691711425781, -1.62087281003609, 218, 29, 'PPL', 'P'),
(66778, 'Merritt', 35.0977783203125, 0.612571791824538, -76.7147216796875, -1.33892447806162, 218, 33, 'PPL', 'P'),
(73440, 'Merritt', 39.0283317565918, 0.681172890713189, -81.8511123657227, -1.42857140720171, 218, 41, 'PPL', 'P'),
(76588, 'Merritt', 35.3697204589844, 0.617318077519277, -99.504997253418, -1.73668982426006, 218, 42, 'PPL', 'P'),
(132060, 'Merritt', 44.329719543457, 0.773699562519003, -84.9447174072266, -1.48256500093224, 218, 27, 'PPL', 'P'),
(183235, 'Merritt', 38.6141700744629, 0.673944405724441, -121.759437561035, -2.12510308081652, 218, 6, 'PPL', 'P'),
(202372, 'Merritt', 44.1408309936523, 0.770402835405594, -103.568061828613, -1.80760367881836, 218, 49, 'PPL', 'P'),
(208108, 'Merritt', 47.7811088562012, 0.833937669794532, -120.841941833496, -2.10908975949798, 218, 56, 'PPL', 'P'),
(17099, 'Merritt Island', 28.538890838623, 0.498097610001218, -80.6722183227539, -1.40799582461975, 218, 12, 'PPL', 'P'),
(82373, 'Merritts Bridge (historical)', 33.6875, 0.58795779176559, -81.5944366455078, -1.42409157077403, 218, 48, 'PPL', 'P'),
(4171, 'Merritts Crossroads', 31.0869407653809, 0.542569470728342, -85.4850006103516, -1.49199472172, 218, 2, 'PPL', 'P'),
(37172, 'Merrittstown', 36.8463897705078, 0.643090818968519, -87.5713882446289, -1.52840905541103, 218, 21, 'PPL', 'P'),
(73442, 'Merrittstown', 39.4941711425781, 0.689303321784119, -84.1999969482422, -1.469567176916, 218, 41, 'PPL', 'P'),
(78734, 'Merrittstown', 39.9727783203125, 0.697656592859262, -79.8777770996094, -1.39413020956231, 218, 45, 'PPL', 'P'),
(82374, 'Merrittsville (historical)', 35.148609161377, 0.613458957362671, -82.4055633544922, -1.43824840249667, 218, 48, 'PPL', 'P'),
(49423, 'Merriweather', 39.1508293151855, 0.683310876436305, -76.6872177124023, -1.33844444327513, 218, 25, 'PPL', 'P'),
(132062, 'Merriweather', 46.5736083984375, 0.812862811087217, -89.6355590820313, -1.56443563284735, 218, 27, 'PPL', 'P'),
(66779, 'Merriweather Estates', 36.0294418334961, 0.628832387650289, -80.1605606079102, -1.3990657128525, 218, 33, 'PPL', 'P'),
(4172, 'Merriwether', 32.6258316040039, 0.569428182691091, -87.8525009155273, -1.53331539708728, 218, 2, 'PPL', 'P'),
(144143, 'Merriwood Camp', 43.9033317565918, 0.766257691747913, -71.9916687011719, -1.2564916528404, 218, 36, 'PPL', 'P'),
(113698, 'Merrow', 41.8244400024414, 0.729974185845428, -72.3108291625977, -1.26206205373446, 218, 8, 'PPL', 'P'),
(128128, 'Merrow Landing', 44.0719413757324, 0.76920048475245, -70.6113891601563, -1.23240123025176, 218, 26, 'PPL', 'P'),
(4173, 'Merry', 32.3466682434082, 0.564555862897764, -86.0944366455078, -1.50263138711377, 218, 2, 'PPL', 'P'),
(23049, 'Merry Acres', 34.2266693115234, 0.597368071477385, -85.2147216796875, -1.48727746448114, 218, 13, 'PPL', 'P'),
(60872, 'Merry Hell', 31.8063907623291, 0.555126241978552, -89.6624984741211, -1.5649058139378, 218, 30, 'PPL', 'P'),
(66780, 'Merry Hill', 36.0116691589355, 0.628522195962322, -76.7727813720703, -1.3399378108564, 218, 33, 'PPL', 'P'),
(49424, 'Merry Midnight', 39.3202781677246, 0.686268316826838, -77.5516662597656, -1.35353191664071, 218, 25, 'PPL', 'P'),
(104205, 'Merry Moor', 37.4269409179688, 0.653223347967944, -79.1369400024414, -1.38120016299581, 218, 53, 'PPL', 'P'),
(37173, 'Merry Oaks', 37.0222206115723, 0.646159646071645, -86.1061096191406, -1.50283511893716, 218, 21, 'PPL', 'P'),
(66782, 'Merry Oaks', 35.6416702270508, 0.622064496372071, -79.0077819824219, -1.37894593029111, 218, 33, 'PPL', 'P'),
(88975, 'Merry Oaks', 36.1641693115234, 0.631183825734775, -86.6849975585938, -1.51293861948071, 218, 50, 'PPL', 'P'),
(104206, 'Merry Point', 37.7336082458496, 0.658575702547758, -76.482780456543, -1.33487634004665, 218, 53, 'PPL', 'P'),
(104207, 'Merry Point Estates', 37.0636100769043, 0.646882028517329, -76.5194396972656, -1.33551616449854, 218, 53, 'PPL', 'P'),
(164486, 'Merryall', 41.6986083984375, 0.727778010052494, -76.230827331543, -1.33047892845471, 218, 45, 'PPL', 'P'),
(42071, 'Merrydale', 30.5011100769043, 0.532344796355201, -91.1083297729492, -1.59014033053074, 218, 22, 'PPL', 'P'),
(71114, 'Merrygold', 39.6061096191406, 0.691257016759801, -74.4508285522461, -1.2994120890745, 218, 37, 'PPL', 'P'),
(183236, 'Merryman', 36.3258285522461, 0.634005311751659, -119.104438781738, -2.07876461048136, 218, 6, 'PPL', 'P'),
(49431, 'Merryman Heights', 39.4275016784668, 0.688139720124836, -76.915283203125, -1.34242493699842, 218, 25, 'PPL', 'P'),
(49425, 'Merrymans Mill', 39.5077781677246, 0.689540809174327, -76.5749969482422, -1.33648582145144, 218, 25, 'PPL', 'P'),
(128129, 'Merrymeeting Trailer Park', 43.9077796936035, 0.766335322893688, -69.9233322143555, -1.22039237110632, 218, 26, 'PPL', 'P'),
(49426, 'Merrymount', 39.3505592346191, 0.686796821145164, -76.774169921875, -1.33996204562232, 218, 25, 'PPL', 'P'),
(104208, 'Merrymount', 38.8933296203613, 0.678816658938741, -78.2341690063477, -1.36544383672247, 218, 53, 'PPL', 'P'),
(177336, 'Merrymount', 42.2625007629395, 0.737619788439909, -70.9958267211914, -1.23911093146016, 218, 23, 'PPL', 'P'),
(42072, 'Merryville', 30.7541694641113, 0.536761515865043, -93.540283203125, -1.63258592514248, 218, 22, 'PPL', 'P'),
(4174, 'Merrywood', 33.5863914489746, 0.586193114648276, -86.9097213745117, -1.51686078997612, 218, 2, 'PPL', 'P'),
(23051, 'Merrywood', 32.4313888549805, 0.566034516514003, -81.745002746582, -1.42671944497966, 218, 13, 'PPL', 'P'),
(49428, 'Merrywood', 39.4588890075684, 0.688687532361066, -76.4305572509766, -1.33396487316357, 218, 25, 'PPL', 'P'),
(204908, 'Merrywood', 40.7222213745117, 0.71073684171124, -111.709999084473, -1.9497072914239, 218, 52, 'PPL', 'P'),
(49429, 'Merrywood Manor', 38.8983306884766, 0.678903944043469, -76.6347198486328, -1.33752818270209, 218, 25, 'PPL', 'P'),
(42073, 'Merrywoods', 32.5602798461914, 0.568284088686793, -93.5669403076172, -1.63305117938492, 218, 22, 'PPL', 'P'),
(209601, 'Mers Hill', 41.8808288574219, 0.730958357026267, -104.616943359375, -1.82591011499351, 218, 59, 'PPL', 'P'),
(23053, 'Mershon', 31.4638900756836, 0.549148477306247, -82.2574996948242, -1.43566420413291, 218, 13, 'PPL', 'P'),
(37174, 'Mershons', 37.2830581665039, 0.650712120218053, -84.1258316040039, -1.46827274746817, 218, 21, 'PPL', 'P'),
(10450, 'Mersman', 35.3591690063477, 0.617133919929898, -90.7541732788086, -1.58395913364067, 218, 4, 'PPL', 'P'),
(132064, 'Merson', 42.4347190856934, 0.740625565204227, -85.8661117553711, -1.49864636601663, 218, 27, 'PPL', 'P'),
(96159, 'Mertens', 32.0583305358887, 0.559523420543895, -96.8963928222656, -1.69116108805434, 218, 51, 'PPL', 'P'),
(150693, 'Mertensia', 42.9619407653809, 0.749827319402669, -77.3630599975586, -1.35024011637531, 218, 40, 'PPL', 'P'),
(66783, 'Mertie (historical)', 36.3036117553711, 0.633617555496944, -81.2380599975586, -1.41787162489009, 218, 33, 'PPL', 'P'),
(136848, 'Merton', 44.146110534668, 0.77049498077931, -93.1463928222656, -1.62571124110455, 218, 28, 'PPL', 'P'),
(175292, 'Merton', 43.146671295166, 0.753051475376373, -88.3066711425781, -1.54124216291385, 218, 57, 'PPL', 'P'),
(170866, 'Merton (historical)', 44.7638893127441, 0.781277254505687, -97.8611068725586, -1.7079985245722, 218, 49, 'PPL', 'P'),
(204909, 'Merton Park', 40.707218170166, 0.710474986397058, -112.09944152832, -1.95650434431605, 218, 52, 'PPL', 'P'),
(4176, 'Mertz', 30.6625003814697, 0.535161588550664, -88.0883331298828, -1.53743144571006, 218, 2, 'PPL', 'P'),
(33258, 'Mertz', 37.5847206115723, 0.655977123114113, -94.648063659668, -1.6519203414984, 218, 20, 'PPL', 'P'),
(164487, 'Mertz Town', 40.8199996948242, 0.712443395337763, -75.7577819824219, -1.3222227296013, 218, 45, 'PPL', 'P'),
(191866, 'Mertzon', 31.2616691589355, 0.545619056492592, -100.816940307617, -1.7595875501545, 218, 51, 'PPL', 'P'),
(164488, 'Mertztown', 40.5058288574219, 0.706960079811344, -75.6658325195313, -1.32061790872842, 218, 45, 'PPL', 'P'),
(56219, 'Merwin', 38.4047203063965, 0.670288817654144, -94.5908279418945, -1.65092138977351, 218, 29, 'PPL', 'P'),
(73441, 'Merwin', 39.0536117553711, 0.681614109926788, -84.2561111450195, -1.47054655440688, 218, 41, 'PPL', 'P'),
(164489, 'Merwinsburg', 40.9661102294922, 0.714993505239569, -75.4677810668945, -1.31716125879155, 218, 45, 'PPL', 'P'),
(113699, 'Merwinsville', 41.6474990844727, 0.726885984245372, -73.4833297729492, -1.28252604986674, 218, 8, 'PPL', 'P'),
(10451, 'Mesa', 34.7816696166992, 0.607054654152275, -91.4936065673828, -1.59686467912514, 218, 4, 'PPL', 'P'),
(60873, 'Mesa', 31.1472206115723, 0.543621552516978, -90.2002792358398, -1.57429185888368, 218, 30, 'PPL', 'P'),
(178622, 'Mesa', 33.4222183227539, 0.583327753052432, -111.821937561035, -1.95166098639958, 218, 5, 'PPL', 'P'),
(187047, 'Mesa', 39.166389465332, 0.683582452288465, -108.138328552246, -1.88736988084009, 218, 7, 'PPL', 'P'),
(189017, 'Mesa', 33.9841690063477, 0.593135642714976, -104.677223205566, -1.82696219678215, 218, 38, 'PPL', 'P'),
(195318, 'Mesa', 44.6288909912109, 0.778921089310267, -116.449722290039, -2.03243106699421, 218, 17, 'PPL', 'P'),
(208109, 'Mesa', 46.5763893127441, 0.812911347198084, -119.005561828613, -2.07703888209499, 218, 56, 'PPL', 'P'),
(183237, 'Mesa Camp', 37.5077781677246, 0.65463422413444, -118.57250213623, -2.06948056460523, 218, 6, 'PPL', 'P'),
(178623, 'Mesa Del Caballo', 34.2855606079102, 0.598395918500101, -111.294441223145, -1.94245443851118, 218, 5, 'PPL', 'P'),
(178628, 'Mesa Gardens Mobile Home Park', 33.415828704834, 0.583216233181785, -111.852783203125, -1.95219934441394, 218, 5, 'PPL', 'P'),
(183238, 'Mesa Grande', 33.1802787780762, 0.57910511140703, -116.768333435059, -2.03799188050835, 218, 6, 'PPL', 'P'),
(178624, 'Mesa Grande Trailer Ranch', 33.4536094665527, 0.583875631867689, -111.766937255859, -1.95070104998466, 218, 5, 'PPL', 'P'),
(187049, 'Mesa Lakes', 39.0499992370605, 0.68155105958798, -108.091667175293, -1.88655548617874, 218, 7, 'PPL', 'P'),
(187050, 'Mesa Lakes Resort', 39.0491714477539, 0.681536611939067, -108.090827941895, -1.88654083879275, 218, 7, 'PPL', 'P'),
(183239, 'Mesa Oaks', 34.6808280944824, 0.605294637566869, -120.440559387207, -2.10208431425053, 218, 6, 'PPL', 'P'),
(178625, 'Mesa Patios', 33.4297218322754, 0.583458713999037, -111.81861114502, -1.95160292948782, 218, 5, 'PPL', 'P'),
(178626, 'Mesa Shadows East Mobile Home Park', 33.4111099243164, 0.583133874925075, -111.707778930664, -1.94966854243004, 218, 5, 'PPL', 'P'),
(178627, 'Mesa Shadows Mobile Home Park', 33.4111099243164, 0.583133874925075, -111.717498779297, -1.94983818579148, 218, 5, 'PPL', 'P'),
(178629, 'Mesa Travelodge Mobile Home Park', 33.3925018310547, 0.58280910243014, -111.835563659668, -1.95189880668493, 218, 5, 'PPL', 'P'),
(183240, 'Mesa Verde', 33.6058311462402, 0.586532401371152, -114.730278015137, -2.0024211030926, 218, 6, 'PPL', 'P'),
(191867, 'Mesa Verde Colonia', 31.6259994506836, 0.551977819648347, -106.269996643066, -1.85476133750483, 218, 51, 'PPL', 'P'),
(178630, 'Mesa Verde Estates', 34.5847206115723, 0.603617245554283, -111.859443664551, -1.95231559139552, 218, 5, 'PPL', 'P'),
(189018, 'Mesa Village', 35.0897216796875, 0.612431176918982, -106.542503356934, -1.8595174768956, 218, 38, 'PPL', 'P'),
(183241, 'Mesa Vista', 38.8072204589844, 0.677313770556582, -119.794998168945, -2.09081714546867, 218, 6, 'PPL', 'P'),
(136850, 'Mesaba', 47.5688896179199, 0.83023374535045, -92.1316680908203, -1.60800095353941, 218, 28, 'PPL', 'P'),
(183243, 'Mesaville', 33.6941719055176, 0.588074238484253, -114.649169921875, -2.00100549981517, 218, 6, 'PPL', 'P'),
(178631, 'Mescal', 31.9899997711182, 0.558330823718244, -110.434722900391, -1.9274495231394, 218, 5, 'PPL', 'P'),
(189019, 'Mescalero', 33.1575012207031, 0.578707568035309, -105.773612976074, -1.84609780816269, 218, 38, 'PPL', 'P'),
(23054, 'Mesena', 33.4597206115723, 0.583982291469347, -82.5902786254883, -1.44147229215427, 218, 13, 'PPL', 'P'),
(116825, 'Meservey', 42.9127807617188, 0.748969315478472, -93.4780578613281, -1.63149988804994, 218, 16, 'PPL', 'P'),
(37175, 'Meshack', 36.7324981689453, 0.641103035530884, -85.5488891601563, -1.49310978726841, 218, 21, 'PPL', 'P'),
(169484, 'Meshanticut', 41.7666702270508, 0.728965913056724, -71.4694366455078, -1.2473769840096, 218, 47, 'PPL', 'P'),
(211997, 'Meshik', 56.9124984741211, 0.993310483909662, -158.681945800781, -2.76952241769482, 218, 1, 'PPL', 'P'),
(164490, 'Meshoppen', 41.6141700744629, 0.726304283284271, -76.0469436645508, -1.32726955302505, 218, 45, 'PPL', 'P'),
(66784, 'Mesic', 35.2002792358398, 0.614360770286799, -76.644172668457, -1.33769316553162, 218, 33, 'PPL', 'P'),
(132065, 'Mesick', 44.4052810668945, 0.77501835989081, -85.7133331298828, -1.49597987597519, 218, 27, 'PPL', 'P'),
(189020, 'Mesilla', 32.2700004577637, 0.563217757608053, -106.800277709961, -1.86401648808313, 218, 38, 'PPL', 'P'),
(189024, 'Mesilla Park', 32.2758293151855, 0.563319490361694, -106.76611328125, -1.86342020631506, 218, 38, 'PPL', 'P'),
(191868, 'Mesilla Park', 35.5658302307129, 0.620740838731274, -100.951942443848, -1.76194378192895, 218, 51, 'PPL', 'P'),
(187051, 'Mesita', 37.098331451416, 0.647488030823376, -105.601387023926, -1.84309189824032, 218, 7, 'PPL', 'P'),
(189025, 'Mesita', 35.0183296203613, 0.611185150423961, -107.312217712402, -1.8729515266984, 218, 38, 'PPL', 'P'),
(208110, 'Meskill', 46.6383285522461, 0.813992390863575, -123.169723510742, -2.14971721403352, 218, 56, 'PPL', 'P'),
(156448, 'Mesopotamia', 41.4583282470703, 0.723584330283946, -80.9552764892578, -1.4129361215999, 218, 41, 'PPL', 'P'),
(116826, 'Mesquakie Indian Settlement', 41.9822196960449, 0.732727960991597, -92.6425018310547, -1.61691668423678, 218, 16, 'PPL', 'P'),
(183244, 'Mesquite', 33.0213890075684, 0.576331961763931, -115.107498168945, -2.00900483678144, 218, 6, 'PPL', 'P'),
(189027, 'Mesquite', 32.1644401550293, 0.561375382765937, -106.696113586426, -1.86219848116499, 218, 38, 'PPL', 'P'),
(190476, 'Mesquite', 36.8055610656738, 0.642378223639841, -114.066390991211, -1.99083408866383, 218, 39, 'PPL', 'P'),
(191869, 'Mesquite', 32.8702812194824, 0.573694633336425, -101.629722595215, -1.77377327717498, 218, 51, 'PPL', 'P'),
(96161, 'Mesquite Acres Colonia', 26.2329998016357, 0.457852219213563, -97.9570007324219, -1.70967218815926, 218, 51, 'PPL', 'P'),
(178632, 'Mesquite Creek', 34.9666709899902, 0.610283537236915, -114.567779541016, -1.99958496968972, 218, 5, 'PPL', 'P'),
(96162, 'Mesquite Number 1 Colonia', 26.4029998779297, 0.460819280273534, -98.9820022583008, -1.72756183962381, 218, 51, 'PPL', 'P'),
(96163, 'Mesquite Number 2 Colonia', 26.4029998779297, 0.460819280273534, -98.9800033569336, -1.72752695221353, 218, 51, 'PPL', 'P'),
(96164, 'Mesquite Number 3 Colonia', 26.4029998779297, 0.460819280273534, -98.984001159668, -1.72759672703409, 218, 51, 'PPL', 'P'),
(96165, 'Mesquite Number 4 Colonia', 26.4039993286133, 0.460836723978674, -98.9850006103516, -1.72761417073923, 218, 51, 'PPL', 'P'),
(183245, 'Mesquite Oasis', 32.9197196960449, 0.574557497529611, -116.217781066895, -2.02838292897924, 218, 6, 'PPL', 'P'),
(150694, 'Messenger Bay', 43.1575012207031, 0.753240493234742, -75.8016662597656, -1.32298865473081, 218, 40, 'PPL', 'P'),
(150695, 'Messengerville', 42.4888916015625, 0.741571053970232, -76.0749969482422, -1.32775917519146, 218, 40, 'PPL', 'P'),
(76590, 'Messer', 34.0872192382813, 0.594934208557161, -95.4691696166992, -1.66625134395633, 218, 42, 'PPL', 'P'),
(194323, 'Messex', 40.4294395446777, 0.705626834790624, -103.436111450195, -1.80530071026571, 218, 7, 'PPL', 'P'),
(30491, 'Messick', 39.9752807617188, 0.697700268701139, -85.3027801513672, -1.48881437474622, 218, 19, 'PPL', 'P'),
(104209, 'Messick (historical)', 37.1222190856934, 0.647904948692028, -76.3338928222656, -1.332277760613, 218, 53, 'PPL', 'P'),
(14215, 'Messick Development', 38.7013893127441, 0.675466668603531, -75.5374984741211, -1.31837805709361, 218, 10, 'PPL', 'P'),
(56222, 'Messler', 37.0661087036133, 0.646925637780179, -89.8033294677734, -1.56736377846589, 218, 29, 'PPL', 'P'),
(78735, 'Messmore', 39.8783302307129, 0.69600816272353, -79.8450012207031, -1.39355816256016, 218, 45, 'PPL', 'P'),
(104210, 'Messongo', 37.9144401550293, 0.66173181475561, -75.6397171020508, -1.32016210870785, 218, 53, 'PPL', 'P'),
(112373, 'Mestayer', 30.0666694641113, 0.524762377257582, -91.692497253418, -1.600335976448, 218, 22, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(37176, 'Meta', 37.5702781677246, 0.655725054916937, -82.4375, -1.43880580211283, 218, 21, 'PPL', 'P'),
(56221, 'Meta', 38.3125, 0.668679269670328, -92.1658325195313, -1.60859723530748, 218, 29, 'PPL', 'P'),
(42075, 'Metairie', 29.9838905334473, 0.523317612366214, -90.1527786254883, -1.57346281683634, 218, 22, 'PPL', 'P'),
(42076, 'Metairie Terrace', 29.9783306121826, 0.523220573433994, -90.1638870239258, -1.5736566949637, 218, 22, 'PPL', 'P'),
(164493, 'Metal', 40.0138893127441, 0.698374115035956, -77.8791732788086, -1.3592479924464, 218, 45, 'PPL', 'P'),
(88976, 'Metal Ford', 35.4636116027832, 0.61895678711703, -87.4797210693359, -1.52680916138617, 218, 50, 'PPL', 'P'),
(208111, 'Metaline', 48.8505592346191, 0.852603100084625, -117.389717102051, -2.04883707141548, 218, 56, 'PPL', 'P'),
(208112, 'Metaline Falls', 48.8638916015625, 0.852835793784871, -117.371391296387, -2.04851722576856, 218, 56, 'PPL', 'P'),
(190478, 'Metallic City (historical)', 38.1505584716797, 0.665852856805426, -118.085830688477, -2.06098654546648, 218, 39, 'PPL', 'P'),
(110409, 'Metalton', 37.7666702270508, 0.659152742976951, -81.2897186279297, -1.41877323807714, 218, 58, 'PPL', 'P'),
(112240, 'Metalton', 36.2230606079102, 0.632211672757491, -93.5297164916992, -1.63240150123699, 218, 4, 'PPL', 'P'),
(30492, 'Metamora', 39.4497184753418, 0.688527476379552, -85.1394424438477, -1.48596359395735, 218, 19, 'PPL', 'P'),
(120604, 'Metamora', 40.7905616760254, 0.71192960498446, -89.3605575561523, -1.55963595077276, 218, 18, 'PPL', 'P'),
(132066, 'Metamora', 42.9413909912109, 0.749468658182862, -83.2891693115234, -1.4536702357371, 218, 27, 'PPL', 'P'),
(156450, 'Metamora', 41.711669921875, 0.728005976641805, -83.9097213745117, -1.46450091241629, 218, 41, 'PPL', 'P'),
(164494, 'Metamora Station', 40.6375007629395, 0.709258188095001, -75.5316696166992, -1.31827632433996, 218, 45, 'PPL', 'P'),
(23056, 'Metasville', 33.7677803039551, 0.589358947394108, -82.6016693115234, -1.44167109712964, 218, 13, 'PPL', 'P'),
(23055, 'Metcalf', 30.7000007629395, 0.535816093678065, -83.9880599975586, -1.46586817931994, 218, 13, 'PPL', 'P'),
(27882, 'Metcalf', 39.8011093139648, 0.694660403474868, -87.8072204589844, -1.5325251040338, 218, 18, 'PPL', 'P'),
(33259, 'Metcalf', 37.0672187805176, 0.646945012277109, -97.7838897705078, -1.70665083190256, 218, 20, 'PPL', 'P'),
(66786, 'Metcalf', 35.3638916015625, 0.617216344765636, -81.5769424438477, -1.42378623935505, 218, 33, 'PPL', 'P'),
(125406, 'Metcalf', 42.1833305358887, 0.736238007308321, -71.4458312988281, -1.24696499298897, 218, 23, 'PPL', 'P'),
(164495, 'Metcalf', 40.6230583190918, 0.709006119897825, -79.6908264160156, -1.39086730459475, 218, 45, 'PPL', 'P'),
(193782, 'Metcalf (historical)', 41.482780456543, 0.724011101848631, -122.480827331543, -2.13769370750209, 218, 6, 'PPL', 'P'),
(96166, 'Metcalf Gap', 32.7097206115723, 0.570892322079389, -98.4411087036133, -1.7181214661917, 218, 51, 'PPL', 'P'),
(60874, 'Metcalfe', 33.4538917541504, 0.583880558715706, -91.0072174072266, -1.5883755868344, 218, 30, 'PPL', 'P'),
(123174, 'Metea', 40.8691711425781, 0.713301598999041, -86.309440612793, -1.50638391424775, 218, 19, 'PPL', 'P'),
(145737, 'Metedeconk', 40.0566711425781, 0.699120798826587, -74.0838928222656, -1.29300785244313, 218, 37, 'PPL', 'P'),
(175295, 'Meteor', 45.6894416809082, 0.797431190729781, -91.3647232055664, -1.5946152401104, 218, 57, 'PPL', 'P'),
(208113, 'Meteor', 48.2663917541504, 0.842407454167366, -118.283889770508, -2.0644433285614, 218, 56, 'PPL', 'P'),
(178633, 'Meteor City', 35.0944404602051, 0.612513535175693, -110.934722900391, -1.93617616939937, 218, 5, 'PPL', 'P'),
(104211, 'Meter', 38.1252784729004, 0.665411637591828, -76.6336135864258, -1.33750887478419, 218, 53, 'PPL', 'P'),
(197030, 'Metersville (historical)', 47.4902801513672, 0.828861751335868, -107.599998474121, -1.87797424851429, 218, 31, 'PPL', 'P'),
(156451, 'Metham', 40.3677787780762, 0.704550651394123, -81.9850006103516, -1.4309081979002, 218, 41, 'PPL', 'P'),
(66787, 'Method', 35.7947196960449, 0.624735713524448, -78.6930618286133, -1.37345302738477, 218, 33, 'PPL', 'P'),
(88977, 'Methodist (historical)', 35.9002799987793, 0.626578088366565, -85.4855575561523, -1.49200444225798, 218, 50, 'PPL', 'P'),
(150696, 'Methol', 41.9194412231445, 0.731632269940111, -75.0122222900391, -1.30921025819906, 218, 40, 'PPL', 'P'),
(208114, 'Methow', 48.1302795410156, 0.840031847895988, -120.002502441406, -2.09443877823507, 218, 56, 'PPL', 'P'),
(125407, 'Methuen', 42.7261085510254, 0.745711270779897, -71.1913909912109, -1.24252417187126, 218, 23, 'PPL', 'P'),
(42077, 'Methvin', 32.1611099243164, 0.561317259275146, -93.2433319091797, -1.62740314734508, 218, 22, 'PPL', 'P'),
(23057, 'Methvins', 32.1124992370605, 0.560468842730874, -84.0691680908203, -1.46728378259737, 218, 13, 'PPL', 'P'),
(193271, 'Metlakatla', 55.1291694641113, 0.962185521038661, -131.572219848633, -2.29636844051648, 218, 1, 'PPL', 'P'),
(10454, 'Meto', 34.7855606079102, 0.607122564760073, -91.9958267211914, -1.60563007437897, 218, 4, 'PPL', 'P'),
(10455, 'Meto (historical)', 34.7849998474121, 0.607112777643066, -92.0022201538086, -1.60574166082864, 218, 4, 'PPL', 'P'),
(201221, 'Metolius', 44.586669921875, 0.778184192636642, -121.177223205566, -2.11494152336121, 218, 43, 'PPL', 'P'),
(104212, 'Metompkin', 37.7691688537598, 0.659196352239801, -75.6030578613281, -1.31952228425596, 218, 53, 'PPL', 'P'),
(76591, 'Metory', 35.8402786254883, 0.625530866846918, -95.0380630493164, -1.65872711492853, 218, 42, 'PPL', 'P'),
(27883, 'Metropolis', 37.1511116027832, 0.648409218244435, -88.7319412231445, -1.54866452602996, 218, 18, 'PPL', 'P'),
(42078, 'Metropolis', 31.9633293151855, 0.557865336449212, -91.6911087036133, -1.60031174168208, 218, 22, 'PPL', 'P'),
(13157, 'Metropolis View', 38.9277801513672, 0.679417934133854, -77.0005569458008, -1.34391324457361, 218, 9, 'PPL', 'P'),
(132068, 'Metropolitan', 45.9947204589844, 0.802759310543675, -87.8938903808594, -1.53403777953297, 218, 27, 'PPL', 'P'),
(49430, 'Metropolitan Grove', 39.1483306884766, 0.683267267173455, -77.2244415283203, -1.34782076768303, 218, 25, 'PPL', 'P'),
(23058, 'Metropolitan Mobile Home Park', 33.9300003051758, 0.592190220527998, -84.1666717529297, -1.46898554253393, 218, 13, 'PPL', 'P'),
(150697, 'Mettacahonts', 41.8127784729004, 0.729770653759118, -74.2547225952148, -1.29598939444153, 218, 40, 'PPL', 'P'),
(193783, 'Mettah', 41.3102798461914, 0.721000398236297, -123.870826721191, -2.16195377345216, 218, 6, 'PPL', 'P'),
(120608, 'Mettawa', 42.2333297729492, 0.737110658618513, -87.9258270263672, -1.53459517914912, 218, 18, 'PPL', 'P'),
(23059, 'Metter', 32.3969383239746, 0.56543324131889, -82.0602798461914, -1.43222206842399, 218, 13, 'PPL', 'P'),
(145738, 'Mettler', 40.4991683959961, 0.706843832829762, -74.5422210693359, -1.3010071894094, 218, 37, 'PPL', 'P'),
(183248, 'Mettler', 35.0638885498047, 0.611980303746432, -118.969169616699, -2.076403718175, 218, 6, 'PPL', 'P'),
(145739, 'Metuchen', 40.5430603027344, 0.707609891117324, -74.3636093139648, -1.29788982619541, 218, 37, 'PPL', 'P'),
(208115, 'Metum', 47.6919403076172, 0.832381385032517, -122.402778625488, -2.13633150060451, 218, 56, 'PPL', 'P'),
(56223, 'Metz', 37.997501373291, 0.663181506494995, -94.4430618286133, -1.64834238457388, 218, 29, 'PPL', 'P'),
(110410, 'Metz', 39.5802803039551, 0.690806210166278, -80.370002746582, -1.40272116776474, 218, 58, 'PPL', 'P'),
(116827, 'Metz', 41.666389465332, 0.727215683588324, -93.1355590820313, -1.62552215666715, 218, 16, 'PPL', 'P'),
(123176, 'Metz', 41.6161117553711, 0.726338172009143, -84.8394393920898, -1.48072755293814, 218, 19, 'PPL', 'P'),
(132069, 'Metz', 45.2897186279297, 0.790454707359182, -83.8013916015625, -1.46261020120039, 218, 27, 'PPL', 'P'),
(156452, 'Metz', 41.1952781677246, 0.718993240301731, -81.4588928222656, -1.42172588477771, 218, 41, 'PPL', 'P'),
(175298, 'Metz', 44.2136116027832, 0.771673096666534, -88.8863906860352, -1.55136017768533, 218, 57, 'PPL', 'P'),
(183246, 'Metz', 36.3549995422363, 0.634514441573055, -121.210563659668, -2.11552342405939, 218, 6, 'PPL', 'P'),
(191870, 'Metz', 31.7033290863037, 0.553327476399285, -102.656669616699, -1.79169688394343, 218, 51, 'PPL', 'P'),
(82375, 'Metz Store (historical)', 32.9916687011719, 0.57581324456261, -80.4902801513672, -1.404820404494, 218, 48, 'PPL', 'P'),
(73443, 'Metzger', 39.3936080932617, 0.687548165467702, -82.9558334350586, -1.44785242717777, 218, 41, 'PPL', 'P'),
(201222, 'Metzger', 45.4466705322266, 0.793194034856437, -122.757781982422, -2.14252747803863, 218, 43, 'PPL', 'P'),
(170868, 'Metzgerville', 43.5419387817383, 0.759950194443142, -98.2622222900391, -1.71499930928774, 218, 49, 'PPL', 'P'),
(78737, 'Metzler', 39.9205589294434, 0.696745192555209, -79.279167175293, -1.38368249544787, 218, 45, 'PPL', 'P'),
(88979, 'Meux Corner', 35.4397201538086, 0.618539802669351, -89.4058303833008, -1.56042611066818, 218, 50, 'PPL', 'P'),
(183247, 'Mevers', 38.8561096191406, 0.678167047369844, -120.011940002441, -2.09460349474849, 218, 6, 'PPL', 'P'),
(104215, 'Mew', 36.8591690063477, 0.643313858709813, -82.3430633544922, -1.43715757171418, 218, 53, 'PPL', 'P'),
(66788, 'Mewborns Crossroads', 35.3461112976074, 0.616906019919615, -77.5930633544922, -1.35425443224444, 218, 33, 'PPL', 'P'),
(96167, 'Mewshaw', 31.7802791595459, 0.554670508537012, -95.3591690063477, -1.6643314711265, 218, 51, 'PPL', 'P'),
(4177, 'Mexboro', 31.4936103820801, 0.549667194507567, -87.3744430541992, -1.52497171339207, 218, 2, 'PPL', 'P'),
(191002, 'Mexhoma', 36.7194404602051, 0.6408751355206, -102.984169006348, -1.79741282659106, 218, 42, 'PPL', 'P'),
(4178, 'Mexia', 31.5069408416748, 0.549899854918299, -87.3883285522461, -1.52521406105126, 218, 2, 'PPL', 'P'),
(96168, 'Mexia', 31.6797199249268, 0.552915418799623, -96.4819412231445, -1.68392754305952, 218, 51, 'PPL', 'P'),
(4179, 'Mexia Crossing', 31.4883308410645, 0.54957504913385, -87.3713912963867, -1.52491845017027, 218, 2, 'PPL', 'P'),
(183249, 'Mexican Colony', 35.4688911437988, 0.619048932490747, -119.267776489258, -2.08161539127023, 218, 6, 'PPL', 'P'),
(192695, 'Mexican Hat', 37.1519393920898, 0.648423665893348, -109.866386413574, -1.91753018018523, 218, 52, 'PPL', 'P'),
(195319, 'Mexican Place', 45.8127784729004, 0.799583823838892, -116.505561828613, -2.03340565079513, 218, 17, 'PPL', 'P'),
(189028, 'Mexican Springs', 35.792781829834, 0.624701891378604, -108.826393127441, -1.89937887314358, 218, 38, 'PPL', 'P'),
(178634, 'Mexican Town', 32.3680610656738, 0.564929238082593, -112.863059997559, -1.9698320008333, 218, 5, 'PPL', 'P'),
(178635, 'Mexican Water', 36.9669418334961, 0.645194849387736, -109.637222290039, -1.9135305117021, 218, 5, 'PPL', 'P'),
(178636, 'Mexican Water Trading Post', 36.9241714477539, 0.644448365334187, -109.603057861328, -1.91293422993403, 218, 5, 'PPL', 'P'),
(37178, 'Mexico', 37.2249984741211, 0.649698787423278, -88.0966720581055, -1.53757698746363, 218, 21, 'PPL', 'P'),
(49439, 'Mexico', 39.6036109924316, 0.691213407496951, -78.7430572509766, -1.37432561211594, 218, 25, 'PPL', 'P'),
(56225, 'Mexico', 39.1697196960449, 0.683640575779256, -91.8827819824219, -1.60365707148538, 218, 29, 'PPL', 'P'),
(82376, 'Mexico', 34.9377784729004, 0.609779267684508, -81.004997253418, -1.41380391264111, 218, 48, 'PPL', 'P'),
(123177, 'Mexico', 40.8222198486328, 0.712482144331624, -86.1155624389648, -1.5030001017667, 218, 19, 'PPL', 'P'),
(128130, 'Mexico', 44.5608291625977, 0.777733186306037, -70.5458297729492, -1.23125700308941, 218, 26, 'PPL', 'P'),
(150698, 'Mexico', 43.4594383239746, 0.758510289820763, -76.2291717529297, -1.33045003315688, 218, 40, 'PPL', 'P'),
(156453, 'Mexico', 40.9863891601563, 0.71534743934844, -83.1933288574219, -1.45199750425642, 218, 41, 'PPL', 'P'),
(164497, 'Mexico', 41.021110534668, 0.715953441654488, -76.7486114501953, -1.33951596613973, 218, 45, 'PPL', 'P'),
(17100, 'Mexico Beach', 29.9477806091309, 0.522687375294246, -85.4180603027344, -1.49082639294978, 218, 12, 'PPL', 'P'),
(23060, 'Mexico Crossing', 31.1416702270508, 0.543524680032326, -82.7863922119141, -1.44489511994529, 218, 13, 'PPL', 'P'),
(116828, 'Meyer', 43.4577789306641, 0.758481327943908, -92.692497253418, -1.61778926896794, 218, 16, 'PPL', 'P'),
(120607, 'Meyer', 40.1477813720703, 0.700710972313474, -91.5033264160156, -1.59703432248658, 218, 18, 'PPL', 'P'),
(96169, 'Meyerland', 29.6847190856934, 0.51809608557495, -95.4672164916992, -1.66621725549438, 218, 51, 'PPL', 'P'),
(10456, 'Meyers', 34.459171295166, 0.601425996609366, -93.353889465332, -1.62933274071289, 218, 4, 'PPL', 'P'),
(183250, 'Meyers', 37.7586097717285, 0.659012061492367, -121.001670837402, -2.11187755652708, 218, 6, 'PPL', 'P'),
(156454, 'Meyers (historical)', 40.1313896179199, 0.700424882233372, -84.3172225952148, -1.47161315042346, 218, 41, 'PPL', 'P'),
(132072, 'Meyers Beach', 43.8072204589844, 0.764580233156299, -83.9255599975586, -1.46477734853744, 218, 27, 'PPL', 'P'),
(193273, 'Meyers Chuck', 55.7408294677734, 0.972861002005325, -132.256393432617, -2.30830952221218, 218, 1, 'PPL', 'P'),
(194324, 'Meyers Corner', 40.6680603027344, 0.709791552682317, -105.018890380859, -1.832925413937, 218, 7, 'PPL', 'P'),
(197031, 'Meyers Creek', 45.4944381713867, 0.794027737435687, -109.931106567383, -1.91865975996159, 218, 31, 'PPL', 'P'),
(156455, 'Meyers Lake', 40.8125, 0.712312500970186, -81.4166717529297, -1.42098898810409, 218, 41, 'PPL', 'P'),
(193784, 'Meyers Place', 40.2669410705566, 0.702790701387744, -121.919441223145, -2.12789567153557, 218, 6, 'PPL', 'P'),
(197032, 'Meyersburg (historical)', 46.0111083984375, 0.803045334044749, -110.662498474121, -1.93142495685661, 218, 31, 'PPL', 'P'),
(78738, 'Meyersdale', 39.8136100769043, 0.694878582947173, -79.0250015258789, -1.37924646802013, 218, 45, 'PPL', 'P'),
(56227, 'Meyerstown', 38.1613883972168, 0.666041874663795, -92.1613922119141, -1.60851973731976, 218, 29, 'PPL', 'P'),
(110411, 'Meyerstown', 39.2058296203613, 0.684270812851224, -77.8636093139648, -1.35897635001521, 218, 58, 'PPL', 'P'),
(96170, 'Meyersville', 28.9280605316162, 0.504889902492924, -97.3122177124023, -1.69841860149897, 218, 51, 'PPL', 'P'),
(145741, 'Meyersville', 40.6897201538086, 0.710169588399054, -74.470832824707, -1.29976122949341, 218, 37, 'PPL', 'P'),
(164498, 'Meyersville', 40.6463890075684, 0.709413317228498, -75.5486068725586, -1.31857193522096, 218, 45, 'PPL', 'P'),
(14216, 'Meyle Estates', 38.538890838623, 0.672630535200651, -75.0886077880859, -1.31054343664076, 218, 10, 'PPL', 'P'),
(60875, 'Mhoon Landing', 34.7416687011719, 0.606356506472511, -90.4419403076172, -1.57850964026009, 218, 30, 'PPL', 'P'),
(60876, 'Mhoons Valley', 33.579719543457, 0.586076667929612, -88.7541732788086, -1.54905254860078, 218, 30, 'PPL', 'P'),
(4180, 'Mhoontown', 34.8208312988281, 0.607738154446044, -87.9472198486328, -1.53496855433395, 218, 2, 'PPL', 'P'),
(96172, 'Mi Tierra Colonia', 27.9969997406006, 0.488639826153479, -97.9789962768555, -1.71005608283039, 218, 51, 'PPL', 'P'),
(183252, 'Mi-Wuk Village', 38.0658302307129, 0.664374070031133, -120.183891296387, -2.0976046109809, 218, 6, 'PPL', 'P'),
(17101, 'Miakka', 27.3194408416748, 0.476814192491036, -82.2750015258789, -1.43596966870995, 218, 12, 'PPL', 'P'),
(88980, 'Mialoquo (historical)', 35.6155586242676, 0.621608762930531, -84.2425003051758, -1.47030900043765, 218, 50, 'PPL', 'P'),
(17102, 'Miami', 25.773889541626, 0.449839233546705, -80.1938934326172, -1.39964748039263, 218, 12, 'PPL', 'P'),
(56226, 'Miami', 39.3213882446289, 0.686287691323768, -93.227783203125, -1.62713177123, 218, 29, 'PPL', 'P'),
(76592, 'Miami', 36.874439239502, 0.643580374555903, -94.8772201538086, -1.65591987682348, 218, 42, 'PPL', 'P'),
(110412, 'Miami', 38.1522216796875, 0.665881885261308, -81.4480590820313, -1.42153680034032, 218, 58, 'PPL', 'P'),
(116829, 'Miami', 41.1472206115723, 0.718154477716411, -92.8397216796875, -1.62035881994571, 218, 16, 'PPL', 'P'),
(123178, 'Miami', 40.6141700744629, 0.708850990764328, -86.1063919067383, -1.50284004578518, 218, 19, 'PPL', 'P'),
(178637, 'Miami', 33.399169921875, 0.582925482569776, -110.868057250977, -1.93501263431911, 218, 5, 'PPL', 'P'),
(189029, 'Miami', 36.3499984741211, 0.634427156468328, -104.792503356934, -1.8289742149857, 218, 38, 'PPL', 'P'),
(191871, 'Miami', 35.6913909912109, 0.622932287413273, -100.63777923584, -1.75646059956059, 218, 51, 'PPL', 'P'),
(17103, 'Miami Beach', 25.7902793884277, 0.450125290337294, -80.1302795410156, -1.39853720853417, 218, 12, 'PPL', 'P'),
(49433, 'Miami Beach', 39.3069381713867, 0.686035489968537, -76.3702774047852, -1.33291279137493, 218, 25, 'PPL', 'P'),
(71115, 'Miami Beach', 39.0344390869141, 0.681279483735819, -74.9372177124023, -1.30790118136523, 218, 37, 'PPL', 'P'),
(132073, 'Miami Beach', 45.4513893127441, 0.793276393113148, -84.5563888549805, -1.47578738911605, 218, 27, 'PPL', 'P'),
(123179, 'Miami Bend', 40.7508316040039, 0.71123618441563, -86.2980575561523, -1.50618524243043, 218, 19, 'PPL', 'P'),
(17105, 'Miami Gardens', 25.9416694641113, 0.452767545612816, -80.2458267211914, -1.40055388726964, 218, 12, 'PPL', 'P'),
(178638, 'Miami Gardens', 33.4102783203125, 0.583119360697134, -110.827781677246, -1.93430969294939, 218, 5, 'PPL', 'P'),
(73444, 'Miami Grove', 39.2347183227539, 0.684775015824603, -84.3069381713867, -1.47143365336599, 218, 41, 'PPL', 'P'),
(73445, 'Miami Heights', 39.1650009155273, 0.683558217522546, -84.7205581665039, -1.47865268413286, 218, 41, 'PPL', 'P'),
(17106, 'Miami Lakes', 25.9083309173584, 0.452185678204147, -80.3088912963867, -1.40165457174817, 218, 12, 'PPL', 'P'),
(132074, 'Miami Park', 42.4652786254883, 0.741158929791543, -86.25, -1.50534647984511, 218, 27, 'PPL', 'P'),
(17107, 'Miami Shores', 25.8627796173096, 0.451390658039731, -80.1930618286133, -1.39963296616469, 218, 12, 'PPL', 'P'),
(73446, 'Miami Shores', 39.6930618286133, 0.692774619106983, -84.2402801513672, -1.47027025144378, 218, 41, 'PPL', 'P'),
(113700, 'Miami Shores', 41.2844390869141, 0.720549391905692, -72.2780609130859, -1.26149013989037, 218, 8, 'PPL', 'P'),
(17108, 'Miami Springs', 25.8219394683838, 0.450677862973971, -80.2897186279297, -1.4013199455572, 218, 12, 'PPL', 'P'),
(73447, 'Miami Station', 39.2169418334961, 0.684464757557609, -84.6930618286133, -1.47817278250443, 218, 41, 'PPL', 'P'),
(123181, 'Miami Trails Addition', 41.5988883972168, 0.7260375677011, -86.2361068725586, -1.50510399902786, 218, 19, 'PPL', 'P'),
(23061, 'Miami Valley', 32.5536117553711, 0.568167708547156, -83.7966690063477, -1.46252777636465, 218, 13, 'PPL', 'P'),
(73448, 'Miami Villa', 39.8472213745117, 0.69546521075629, -84.1699981689453, -1.46904359944569, 218, 41, 'PPL', 'P'),
(73453, 'Miamisburg', 39.6427803039551, 0.691897040948775, -84.2866668701172, -1.47107985241517, 218, 41, 'PPL', 'P'),
(73454, 'Miamitown', 39.2158317565918, 0.684445383060678, -84.7041702270508, -1.47836666063179, 218, 41, 'PPL', 'P'),
(73455, 'Miamiville', 39.2125015258789, 0.684387259569887, -84.2994384765625, -1.47130275899841, 218, 41, 'PPL', 'P'),
(113701, 'Mianus', 41.0438919067383, 0.716351051605236, -73.591667175293, -1.2844168942407, 218, 8, 'PPL', 'P'),
(23062, 'Mica', 34.357780456543, 0.599656392644035, -84.2727813720703, -1.47083750475597, 218, 13, 'PPL', 'P'),
(104213, 'Mica', 38.1405601501465, 0.665678353174999, -77.355827331543, -1.35011388253964, 218, 53, 'PPL', 'P'),
(195320, 'Mica', 47.6205596923828, 0.831135558274578, -116.870277404785, -2.03977113843263, 218, 17, 'PPL', 'P'),
(208116, 'Mica', 47.5561103820801, 0.830010705609156, -117.211112976074, -2.04571984135954, 218, 56, 'PPL', 'P'),
(183253, 'Micaflores', 33.8041687011719, 0.589994044735064, -117.906936645508, -2.05786425540447, 218, 6, 'PPL', 'P'),
(110413, 'Micajah', 37.4663887023926, 0.653911841688756, -81.3261108398438, -1.41940840199712, 218, 58, 'PPL', 'P'),
(17110, 'Micanopy', 29.5044403076172, 0.514949627326049, -82.2799987792969, -1.43605688723565, 218, 12, 'PPL', 'P'),
(17111, 'Micanopy Junction', 29.5222206115723, 0.51525995217207, -82.2305603027344, -1.43519402304246, 218, 12, 'PPL', 'P'),
(4181, 'Micaville', 33.4966697692871, 0.584627175927309, -85.5411071777344, -1.49297396605282, 218, 2, 'PPL', 'P'),
(66789, 'Micaville', 35.9094390869141, 0.626737944610997, -82.2133331298828, -1.43489335215539, 218, 33, 'PPL', 'P'),
(76593, 'Micawber', 35.624439239502, 0.621763758905974, -96.5119400024414, -1.68445112052983, 218, 42, 'PPL', 'P'),
(17112, 'Micco', 27.8802795410156, 0.486602674367136, -80.5005569458008, -1.40499976839341, 218, 12, 'PPL', 'P'),
(110414, 'Micco', 37.7827796936035, 0.659433906209036, -81.9902801513672, -1.43100034327391, 218, 58, 'PPL', 'P'),
(17113, 'Miccosukee', 30.5944404602051, 0.533973718835948, -84.041389465332, -1.46679895412092, 218, 12, 'PPL', 'P'),
(49434, 'Mich-Trace Estates', 39.709171295166, 0.693055782339068, -76.966667175293, -1.34332175649551, 218, 25, 'PPL', 'P'),
(27889, 'Michael', 39.235279083252, 0.684784802941609, -90.6233291625977, -1.58167547300592, 218, 18, 'PPL', 'P'),
(49435, 'Michaels Corner', 39.5244407653809, 0.689831626365364, -76.2866668701172, -1.33145351225562, 218, 25, 'PPL', 'P'),
(49436, 'Michaels Meadows', 39.5800018310547, 0.690801349897289, -76.3633270263672, -1.33279148438728, 218, 25, 'PPL', 'P'),
(49437, 'Michaels Mill', 39.3288917541504, 0.686418652270373, -77.4180603027344, -1.35120005279023, 218, 25, 'PPL', 'P'),
(49438, 'Michaels Ridge', 39.5755615234375, 0.690723851909567, -77.0072174072266, -1.34402949155519, 218, 25, 'PPL', 'P'),
(49443, 'Michaelsville', 39.4327812194824, 0.688231865498553, -76.1758270263672, -1.32951899203979, 218, 25, 'PPL', 'P'),
(123183, 'Michaelsville', 40.523609161377, 0.707270404657366, -85.7019424438477, -1.49578107099982, 218, 19, 'PPL', 'P'),
(49440, 'Michaelton Manor', 39.2108306884766, 0.684358097955951, -76.664436340332, -1.33804683332439, 218, 25, 'PPL', 'P'),
(104214, 'Michaelwood', 36.8702812194824, 0.643507803416198, -76.1005630493164, -1.32820538783211, 218, 53, 'PPL', 'P'),
(195321, 'Michaud', 42.8902816772461, 0.74857663237574, -112.613609313965, -1.96547826508324, 218, 17, 'PPL', 'P'),
(116, 'Michaux', 37.648609161377, 0.657092188662529, -77.9022216796875, -1.35965026292905, 218, 53, 'PPL', 'P'),
(88981, 'Michell (historical)', 35.9541702270508, 0.627518650284553, -89.6361083984375, -1.56444522022728, 218, 50, 'PPL', 'P'),
(132075, 'Michelson', 44.3788909912109, 0.774557766180281, -84.8427810668945, -1.48078587616602, 218, 27, 'PPL', 'P'),
(66790, 'Michfield', 35.5780601501465, 0.620954291092644, -79.7769393920898, -1.39237025955593, 218, 33, 'PPL', 'P'),
(132076, 'Michiana', 41.7641716003418, 0.728922303793874, -86.8133316040039, -1.51517847111552, 218, 27, 'PPL', 'P'),
(123184, 'Michiana Shores', 41.7558288574219, 0.728776695461274, -86.8166732788086, -1.51523679434339, 218, 19, 'PPL', 'P'),
(88982, 'Michie', 35.0561103820801, 0.611844549109865, -88.4352798461914, -1.54348680823862, 218, 50, 'PPL', 'P'),
(132077, 'Michigamme', 46.5347213745117, 0.812184104483411, -88.1100006103516, -1.53780961458485, 218, 27, 'PPL', 'P'),
(132080, 'Michigan', 44.2502784729004, 0.77231305427648, -85.5002822875977, -1.49226143730317, 218, 27, 'ADM1', 'A'),
(140498, 'Michigan', 48.0250015258789, 0.838194399901888, -98.1166687011719, -1.71245891992392, 218, 34, 'PPL', 'P'),
(172242, 'Michigan', 43.7894401550293, 0.764269908310277, -72.8852767944336, -1.27208805629028, 218, 55, 'PPL', 'P'),
(110415, 'Michigan (historical)', 38.0783309936523, 0.664592249503437, -81.0838928222656, -1.41518090008273, 218, 58, 'PPL', 'P'),
(183254, 'Michigan Bar (historical)', 38.482780456543, 0.671651224288801, -121.043060302734, -2.11259993897276, 218, 6, 'PPL', 'P'),
(120609, 'Michigan Beach', 41.514720916748, 0.724568568043812, -88.0622177124023, -1.53697564568949, 218, 18, 'PPL', 'P'),
(183255, 'Michigan Bluff', 39.0430603027344, 0.681429952337409, -120.740280151367, -2.10731542842171, 218, 6, 'PPL', 'P'),
(132079, 'Michigan Center', 42.2330589294434, 0.737105931507578, -84.3272171020508, -1.47178758747486, 218, 27, 'PPL', 'P'),
(60877, 'Michigan City', 34.9808311462402, 0.610530678586074, -89.2505569458008, -1.55771607794292, 218, 30, 'PPL', 'P'),
(123185, 'Michigan City', 41.7075004577637, 0.727933205765018, -86.8949966430664, -1.51660379493093, 218, 19, 'PPL', 'P'),
(150700, 'Michigan Corners', 41.4669418334961, 0.723734665727481, -74.3480606079102, -1.29761845008033, 218, 40, 'PPL', 'P'),
(208117, 'Michigan Hill', 46.7780609130859, 0.816431180631815, -123.099166870117, -2.14848576834547, 218, 56, 'PPL', 'P'),
(150701, 'Michigan Mills', 43.6036109924316, 0.761026577576724, -75.5977783203125, -1.31943013888224, 218, 40, 'PPL', 'P'),
(178639, 'Michigan Palms Mobile Home Park', 33.6530609130859, 0.587356716307559, -112.03360748291, -1.95535532346374, 218, 5, 'PPL', 'P'),
(13160, 'Michigan Park', 38.9486083984375, 0.67978145562265, -76.9861068725586, -1.34366104321838, 218, 9, 'PPL', 'P'),
(49441, 'Michigan Park Hills', 38.9552803039551, 0.679897902341314, -76.9833297729492, -1.34361257368654, 218, 25, 'PPL', 'P'),
(128132, 'Michigan Settlement', 47.2311096191406, 0.824338372224369, -68.5258331298828, -1.19600141078867, 218, 26, 'PPL', 'P'),
(197033, 'Michigan Settlement (historical)', 47.1394386291504, 0.822738411620477, -110.835563659668, -1.93444551416498, 218, 31, 'PPL', 'P'),
(178640, 'Michigan Trailer Park', 33.4880599975586, 0.584476907062802, -112.126670837402, -1.95697958541258, 218, 5, 'PPL', 'P'),
(33263, 'Michigan Valley', 38.6816711425781, 0.675122521611665, -95.5263900756836, -1.66725002936511, 218, 20, 'PPL', 'P'),
(123188, 'Michigantown', 40.3263893127441, 0.703828268948439, -86.3927764892578, -1.5078383996771, 218, 19, 'PPL', 'P'),
(132081, 'Michillinda', 43.3505592346191, 0.756609991224937, -86.413330078125, -1.50819712747593, 218, 27, 'PPL', 'P'),
(132082, 'Michiwaukee Shores', 45.9511108398438, 0.80199817910413, -86.3550033569336, -1.50717913414925, 218, 27, 'PPL', 'P'),
(183256, 'Michopdo (historical)', 39.7319412231445, 0.693453192552735, -121.852783203125, -2.12673226961337, 218, 6, 'PPL', 'P'),
(42079, 'Michoud', 30.0300006866455, 0.524122386358122, -89.9258270263672, -1.56950176418901, 218, 22, 'PPL', 'P'),
(17114, 'Mickler Landing', 30.1613903045654, 0.526415567793762, -81.3561096191406, -1.41993197946743, 218, 12, 'PPL', 'P'),
(10457, 'Mickles', 35.0688896179199, 0.612067588851159, -93.2900009155273, -1.62821767516448, 218, 4, 'PPL', 'P'),
(71116, 'Mickles Mill', 39.4933280944824, 0.689288607819097, -75.3430633544922, -1.31498452407457, 218, 37, 'PPL', 'P'),
(71117, 'Mickleton', 39.7900009155273, 0.69446652534751, -75.2380599975586, -1.31315186977043, 218, 37, 'PPL', 'P'),
(164499, 'Mickleys', 40.6472206115723, 0.709427831456439, -75.4958267211914, -1.31765074779991, 218, 45, 'PPL', 'P'),
(164500, 'Mickleys Gardens', 40.6497192382813, 0.709471440719289, -75.5055618286133, -1.31782065747745, 218, 45, 'PPL', 'P'),
(30495, 'Mickleyville', 39.747501373291, 0.693724768404896, -86.2613906860352, -1.50554528482048, 218, 19, 'PPL', 'P'),
(96173, 'Mico', 29.5438899993896, 0.515638154336375, -98.9227828979492, -1.72652826680475, 218, 51, 'PPL', 'P'),
(56231, 'Micola', 36.1316719055176, 0.630616639001615, -89.7858276367188, -1.56705831388886, 218, 29, 'PPL', 'P'),
(66791, 'Micro', 35.5636100769043, 0.620702089737414, -78.204719543457, -1.36492984663208, 218, 33, 'PPL', 'P'),
(4183, 'Mid (historical)', 34.4619407653809, 0.601474332983151, -86.158332824707, -1.50374658582024, 218, 2, 'PPL', 'P'),
(204912, 'Mid Avenues Condominium', 40.7750015258789, 0.711658029132299, -111.867218017578, -1.95245127945306, 218, 52, 'PPL', 'P'),
(197034, 'Mid Canon', 47.1322212219238, 0.822612444100916, -111.886940002441, -1.95279549302395, 218, 31, 'PPL', 'P'),
(56230, 'Mid City', 36.2336082458496, 0.632395763767843, -89.8966674804688, -1.5689928341047, 218, 29, 'PPL', 'P'),
(27890, 'Mid City (historical)', 39.2219390869141, 0.684551976083309, -90.3913879394531, -1.57762733499095, 218, 18, 'PPL', 'P'),
(49442, 'Mid Country View', 39.3652801513672, 0.687053749611329, -77.2486114501953, -1.3482426123997, 218, 25, 'PPL', 'P'),
(17115, 'Mid Florida Lakes', 28.8627796173096, 0.503750535599561, -81.7569427490234, -1.42692783733496, 218, 12, 'PPL', 'P'),
(136851, 'Mid Town Mobile Home Park', 43.5611114501953, 0.76028482063411, -91.6358337402344, -1.5993470115772, 218, 28, 'PPL', 'P'),
(187052, 'Mid Vail', 39.6150016784668, 0.691412212472326, -106.367218017578, -1.85645817059337, 218, 7, 'PPL', 'P'),
(96174, 'Mid-Valley Estates Colonia', 26.2019996643066, 0.4573111647486, -97.9850006103516, -1.71016087821929, 218, 51, 'PPL', 'P'),
(197035, 'Midale', 47.9041709899902, 0.836085509213681, -108.161392211914, -1.88777241763885, 218, 31, 'PPL', 'P'),
(37179, 'Midas', 37.5122184753418, 0.654711722122162, -82.8349990844727, -1.44574346991054, 218, 21, 'PPL', 'P'),
(183257, 'Midas', 39.2166709899902, 0.684460030446674, -120.75666809082, -2.10760145192279, 218, 6, 'PPL', 'P'),
(200069, 'Midas', 41.2441711425781, 0.71984658369402, -116.795829772949, -2.03847178213679, 218, 39, 'PPL', 'P'),
(190479, 'Midas (historical)', 39.0402793884277, 0.681381416226542, -117.620559692383, -2.05286603467061, 218, 39, 'PPL', 'P'),
(195322, 'Midasville', 45.5602798461914, 0.795176891446056, -115.469169616699, -2.0153171943552, 218, 17, 'PPL', 'P'),
(197036, 'Midby (historical)', 48.7677803039551, 0.851158335193257, -104.685562133789, -1.82710773853572, 218, 31, 'PPL', 'P'),
(96175, 'Midcity', 33.8422203063965, 0.590658170531903, -95.5141677856445, -1.6670367101618, 218, 51, 'PPL', 'P'),
(183258, 'Midco', 34.9363899230957, 0.609755032918589, -120.461669921875, -2.10245276258734, 218, 6, 'PPL', 'P'),
(82378, 'Middendorf', 34.521671295166, 0.602516827391862, -80.1630630493164, -1.39910938869438, 218, 48, 'PPL', 'P'),
(116830, 'Middle Amana', 41.7955589294434, 0.729470116030103, -91.8994369506836, -1.60394775551837, 218, 16, 'PPL', 'P'),
(156458, 'Middle Bass', 41.6788902282715, 0.727433863060628, -82.8122177124023, -1.44534585995979, 218, 41, 'PPL', 'P'),
(112984, 'Middle Beach', 41.2702789306641, 0.720302250556533, -72.5947189331055, -1.26701686494256, 218, 8, 'PPL', 'P'),
(156459, 'Middle Beaver (historical)', 40.7338905334473, 0.710940506955604, -80.6388931274414, -1.40741419023768, 218, 41, 'PPL', 'P'),
(30494, 'Middle Branch', 39.3077812194824, 0.68605020393356, -85.3858337402344, -1.49026393332755, 218, 19, 'PPL', 'P'),
(150702, 'Middle Bridge', 42.2452812194824, 0.737319250710894, -75.4883270263672, -1.31751985343233, 218, 40, 'PPL', 'P'),
(88983, 'Middle Brook Place', 35.9236106872559, 0.626985285697238, -85.0472183227539, -1.48435397939451, 218, 50, 'PPL', 'P'),
(4184, 'Middle Brooks Crossroads', 32.6938896179199, 0.570616019116294, -85.6025009155273, -1.49404548891741, 218, 2, 'PPL', 'P'),
(88984, 'Middle City', 36.0361099243164, 0.628948767789926, -89.4349975585938, -1.56093517391055, 218, 50, 'PPL', 'P'),
(88985, 'Middle Creek', 35.8213882446289, 0.625201167503966, -83.5391693115234, -1.45803355886709, 218, 50, 'PPL', 'P'),
(120611, 'Middle Creek', 40.3727798461914, 0.70463793649885, -91.0272216796875, -1.58872472725331, 218, 18, 'PPL', 'P'),
(164501, 'Middle Creek', 40.7611083984375, 0.711415548315047, -77.2583312988281, -1.34841225576114, 218, 45, 'PPL', 'P'),
(164502, 'Middle Creek (historical)', 40.6472206115723, 0.709427831456439, -76.3550033569336, -1.33264620894981, 218, 45, 'PPL', 'P'),
(197037, 'Middle Creek (historical)', 45.7000007629395, 0.797615481477214, -111.168891906738, -1.94026318956626, 218, 31, 'PPL', 'P'),
(49445, 'Middle Creek Estates', 39.5777816772461, 0.690762600903428, -77.5377807617188, -1.35328956898151, 218, 25, 'PPL', 'P'),
(96176, 'Middle Crossing', 31.2147197723389, 0.544799635114688, -97.7938919067383, -1.70682540211202, 218, 51, 'PPL', 'P'),
(128133, 'Middle Dam', 44.7799987792969, 0.781558417737772, -70.9227828979492, -1.23783607624634, 218, 26, 'PPL', 'P'),
(49446, 'Middle Earth', 38.3241691589355, 0.668882934914691, -76.517219543457, -1.33547741550468, 218, 25, 'PPL', 'P'),
(139322, 'Middle Fabius', 40.4550018310547, 0.706072980852239, -92.3186111450195, -1.61126372534892, 218, 29, 'PPL', 'P'),
(150703, 'Middle Falls', 43.1005592346191, 0.752246668094951, -73.5252838134766, -1.28325828600846, 218, 40, 'PPL', 'P'),
(66794, 'Middle Fork', 35.1172218322754, 0.612911145126442, -82.8238906860352, -1.44554959178318, 218, 33, 'PPL', 'P'),
(88986, 'Middle Fork', 35.535831451416, 0.620217261260965, -88.4866714477539, -1.54438376089376, 218, 50, 'PPL', 'P'),
(110417, 'Middle Fork', 38.3583297729492, 0.669479150103733, -81.3227767944336, -1.41935021192731, 218, 58, 'PPL', 'P'),
(110418, 'Middle Fork (historical)', 38.913330078125, 0.679165732778623, -80.0791702270508, -1.39764518272705, 218, 58, 'PPL', 'P'),
(204913, 'Middle Fork Ranches', 41.2836112976074, 0.720534944256778, -111.770278930664, -1.95075937321253, 218, 52, 'PPL', 'P'),
(150704, 'Middle Granville', 43.4333305358887, 0.75805462295825, -73.2838897705078, -1.27904516516395, 218, 40, 'PPL', 'P'),
(663, 'Middle Grove', 39.3950004577637, 0.687572466812649, -92.2702789306641, -1.61042016907364, 218, 29, 'PPL', 'P'),
(150705, 'Middle Grove', 43.0897216796875, 0.752057517078528, -73.918327331543, -1.29011818950234, 218, 40, 'PPL', 'P'),
(201223, 'Middle Grove', 44.9700012207031, 0.784874585927139, -122.964172363281, -2.14612966972907, 218, 43, 'PPL', 'P'),
(113702, 'Middle Haddam', 41.5538902282715, 0.725252201495636, -72.5505599975586, -1.26624614612309, 218, 8, 'PPL', 'P'),
(150706, 'Middle Hope', 41.560001373291, 0.725358861097293, -74.0036087036133, -1.29160663023558, 218, 40, 'PPL', 'P'),
(175299, 'Middle Inlet', 45.2916717529297, 0.790488795821135, -87.9922180175781, -1.53575392053942, 218, 57, 'PPL', 'P'),
(128134, 'Middle Intervale', 44.4627799987793, 0.776021905568579, -70.7877807617188, -1.23547984447189, 218, 26, 'PPL', 'P'),
(150707, 'Middle Island', 40.8841705322266, 0.713563387734196, -72.9377822875977, -1.27300445002138, 218, 40, 'PPL', 'P'),
(164503, 'Middle Lancaster', 40.8544387817383, 0.713044470795794, -80.1236114501953, -1.39842082839454, 218, 45, 'PPL', 'P'),
(104216, 'Middle Mountain (historical)', 37.5472183227539, 0.655322584697199, -80.121940612793, -1.3983916667806, 218, 53, 'PPL', 'P'),
(49447, 'Middle Neck', 38.3988914489746, 0.670187084900503, -75.5477828979492, -1.31855755415108, 218, 25, 'PPL', 'P'),
(208118, 'Middle Nemah', 46.4838905334473, 0.811296938945278, -123.885833740234, -2.16221569534537, 218, 56, 'PPL', 'P'),
(125409, 'Middle Pasture (historical)', 41.2750015258789, 0.72038467539227, -70.0166702270508, -1.22202142674512, 218, 23, 'PPL', 'P'),
(23063, 'Middle Place', 31.8013896942139, 0.555038956873825, -81.1122207641602, -1.41567531593911, 218, 13, 'PPL', 'P'),
(104217, 'Middle Plantation', 37.3086090087891, 0.651158066542587, -76.7738876342773, -1.3399571187743, 218, 53, 'PPL', 'P'),
(110420, 'Middle Point', 39.2058296203613, 0.684270812851224, -80.746940612793, -1.40929997460557, 218, 58, 'PPL', 'P'),
(156460, 'Middle Point', 40.8555603027344, 0.713064045029806, -84.4472198486328, -1.47388203051415, 218, 41, 'PPL', 'P'),
(175301, 'Middle Ridge', 43.8008308410645, 0.764468713285652, -90.9466705322266, -1.58731884451386, 218, 57, 'PPL', 'P'),
(17116, 'Middle River', 26.163610458374, 0.45664114670785, -80.1672210693359, -1.39918195983408, 218, 12, 'PPL', 'P'),
(49448, 'Middle River', 39.334171295166, 0.686510797644089, -76.4397201538086, -1.33412479598703, 218, 25, 'PPL', 'P'),
(66798, 'Middle River', 34.0447196960449, 0.594192451614547, -78.2797164916992, -1.36623879030786, 218, 33, 'PPL', 'P'),
(136853, 'Middle River', 48.4341697692871, 0.845335732943962, -96.1638870239258, -1.67837645008336, 218, 28, 'PPL', 'P'),
(17117, 'Middle River Manor', 26.1563892364502, 0.456515112609262, -80.1233291625977, -1.39841590154652, 218, 12, 'PPL', 'P'),
(17118, 'Middle River Vista', 26.1505603790283, 0.45641337985562, -80.1572189331055, -1.39900738962463, 218, 12, 'PPL', 'P'),
(110421, 'Middle Run', 38.5938911437988, 0.67359047161557, -80.8099975585938, -1.41040052592604, 218, 58, 'PPL', 'P'),
(88987, 'Middle Settlement', 35.7972183227539, 0.624779322787298, -84.0552825927734, -1.46704143493817, 218, 50, 'PPL', 'P'),
(164506, 'Middle Spring', 40.0833282470703, 0.699586053069024, -77.5416717529297, -1.35335747958931, 218, 45, 'PPL', 'P'),
(150708, 'Middle Sprite', 43.1205596923828, 0.752595741934833, -74.6391677856445, -1.30269922880798, 218, 40, 'PPL', 'P'),
(88988, 'Middle Valley', 35.1958312988281, 0.614283139141023, -85.1847229003906, -1.48675388701083, 218, 50, 'PPL', 'P'),
(145742, 'Middle Valley', 40.7605590820313, 0.711405960935123, -74.8208312988281, -1.30586985524378, 218, 37, 'PPL', 'P'),
(88989, 'Middle Valley Estates', 35.1672210693359, 0.613783796436633, -85.2027816772461, -1.48706907212584, 218, 50, 'PPL', 'P'),
(178641, 'Middle Verde', 34.6199989318848, 0.604232968398309, -111.890830993652, -1.95286340363175, 218, 5, 'PPL', 'P'),
(132084, 'Middle Village', 45.5502815246582, 0.795002387815628, -85.1133270263672, -1.48550779393678, 218, 27, 'PPL', 'P'),
(150712, 'Middle Village', 42.8330612182617, 0.747577946966961, -74.8302764892578, -1.30603470491525, 218, 40, 'PPL', 'P'),
(175302, 'Middle Village', 44.9338912963867, 0.784244348855171, -88.7394409179688, -1.54879542039753, 218, 57, 'PPL', 'P'),
(210691, 'Middle Village Three', 20.8947200775146, 0.364681661635195, -156.426666259766, -2.73016036415123, 218, 15, 'PPL', 'P'),
(191872, 'Middle Water', 35.848331451416, 0.625671415173447, -102.787216186523, -1.79397535141404, 218, 51, 'PPL', 'P'),
(183259, 'Middle Waters (historical)', 39.5261116027832, 0.6898607879793, -120.681938171387, -2.10629716877892, 218, 6, 'PPL', 'P'),
(189030, 'Middle Wells', 31.6697196960449, 0.552740881879682, -108.833610534668, -1.89950484066314, 218, 38, 'PPL', 'P'),
(76594, 'Middleberg', 35.1061096191406, 0.612717200420056, -97.7347183227539, -1.70579262824129, 218, 42, 'PPL', 'P'),
(30510, 'Middleboro', 39.8938903808594, 0.696279738575691, -84.8319396972656, -1.48059665857057, 218, 19, 'PPL', 'P'),
(73456, 'Middleboro', 39.3505592346191, 0.686796821145164, -84.0416717529297, -1.46680388096894, 218, 41, 'PPL', 'P'),
(125410, 'Middleboro', 41.8930587768555, 0.731171809387636, -70.9116668701172, -1.23764206496093, 218, 23, 'PPL', 'P'),
(164507, 'Middleboro', 41.996940612793, 0.732984889457762, -80.1433334350586, -1.39876504196543, 218, 45, 'PPL', 'P'),
(14219, 'Middleboro East', 39.7222213745117, 0.693283549191297, -75.539436340332, -1.31841187923945, 218, 10, 'PPL', 'P'),
(14220, 'Middleboro Manor', 39.7236099243164, 0.693307783957217, -75.5833282470703, -1.31917793752701, 218, 10, 'PPL', 'P'),
(49449, 'Middleborough', 39.3069381713867, 0.686035489968537, -76.4383316040039, -1.33410056122111, 218, 25, 'PPL', 'P'),
(110422, 'Middlebourne', 39.4922218322754, 0.689269299901193, -80.9038925170898, -1.41203930210282, 218, 58, 'PPL', 'P'),
(156461, 'Middlebourne', 40.0511093139648, 0.699023726604854, -81.336669921875, -1.41959269274456, 218, 41, 'PPL', 'P'),
(156462, 'Middlebranch', 40.8899993896484, 0.713665120487837, -81.3288879394531, -1.41945687152896, 218, 41, 'PPL', 'P'),
(10459, 'Middlebrook', 36.458610534668, 0.636322794532246, -90.9261093139648, -1.58695998355697, 218, 4, 'PPL', 'P'),
(49451, 'Middlebrook', 39.1772193908691, 0.683771470146834, -77.2388916015625, -1.34807296903826, 218, 25, 'PPL', 'P'),
(56233, 'Middlebrook', 37.6622200012207, 0.657329742631764, -90.6469421386719, -1.58208759718461, 218, 29, 'PPL', 'P'),
(104219, 'Middlebrook', 38.0511093139648, 0.664117141564967, -79.2141723632813, -1.38254812198156, 218, 53, 'PPL', 'P'),
(110423, 'Middlebrook', 38.5591697692871, 0.672984469309522, -80.1319427490234, -1.39856623699006, 218, 58, 'PPL', 'P'),
(88990, 'Middlebrook Acres', 35.9411087036133, 0.627290683695243, -84.0605621337891, -1.46713358031189, 218, 50, 'PPL', 'P'),
(88991, 'Middlebrook Heights', 35.9561080932617, 0.627552472430397, -83.9916687011719, -1.46593116307972, 218, 50, 'PPL', 'P'),
(49452, 'Middlebrook Hills', 39.1672210693359, 0.683596966516406, -77.2350006103516, -1.34800505843046, 218, 25, 'PPL', 'P'),
(49453, 'Middlebrook Mobile Home Park', 39.1786117553711, 0.683795771491781, -77.2344436645508, -1.34799533789249, 218, 25, 'PPL', 'P'),
(23064, 'Middlebrooks (historical)', 32.9930610656738, 0.575837545907557, -84.2013931274414, -1.46959154483998, 218, 13, 'PPL', 'P'),
(17130, 'Middleburg', 30.0686092376709, 0.524796232692939, -81.8605575561523, -1.42873625687318, 218, 12, 'PPL', 'P'),
(37180, 'Middleburg', 37.357780456543, 0.652016270203865, -84.8211135864258, -1.48040770729123, 218, 21, 'PPL', 'P'),
(49454, 'Middleburg', 39.5938911437988, 0.691043764135513, -77.2130584716797, -1.34762209586571, 218, 25, 'PPL', 'P'),
(66801, 'Middleburg', 36.3994407653809, 0.635290087240541, -78.3227767944336, -1.36699033436748, 218, 33, 'PPL', 'P'),
(88993, 'Middleburg', 35.5913887023926, 0.621186918213863, -88.2566680908203, -1.54036944502463, 218, 50, 'PPL', 'P'),
(96177, 'Middleburg', 34.2566719055176, 0.597891715526722, -99.8097229003906, -1.742008290115, 218, 51, 'PPL', 'P'),
(104220, 'Middleburg', 38.9686088562012, 0.680130529462532, -77.7358322143555, -1.35674621891838, 218, 53, 'PPL', 'P'),
(116832, 'Middleburg', 43.1136093139648, 0.75247443494718, -96.0686111450195, -1.67671357229871, 218, 16, 'PPL', 'P'),
(156464, 'Middleburg', 40.2924995422363, 0.703236780870332, -83.5824966430664, -1.45878976345862, 218, 41, 'PPL', 'P'),
(164509, 'Middleburg', 40.785831451416, 0.711847046990667, -77.0475006103516, -1.34473256608298, 218, 45, 'PPL', 'P'),
(156465, 'Middleburg Heights', 41.3613891601563, 0.721892424043419, -81.8130569458008, -1.42790721482584, 218, 41, 'PPL', 'P'),
(150710, 'Middleburgh', 42.5986099243164, 0.743485999952054, -74.3333282470703, -1.29736132187708, 218, 40, 'PPL', 'P'),
(113703, 'Middlebury', 41.5277786254883, 0.724796468054096, -73.128059387207, -1.27632541190071, 218, 8, 'PPL', 'P'),
(120612, 'Middlebury', 42.1441688537598, 0.735554507014552, -88.2380599975586, -1.5400446725297, 218, 18, 'PPL', 'P'),
(123189, 'Middlebury', 41.6752815246582, 0.727370879300848, -85.7061080932617, -1.49585377529758, 218, 19, 'PPL', 'P'),
(156467, 'Middlebury', 40.8461112976074, 0.712899128779303, -84.7461090087891, -1.4790986304574, 218, 41, 'PPL', 'P'),
(172243, 'Middlebury', 44.0152816772461, 0.768211586460676, -73.1677780151367, -1.27701863273246, 218, 55, 'PPL', 'P'),
(164511, 'Middlebury Center', 41.8436088562012, 0.730308745457369, -77.2747192382813, -1.34869827926221, 218, 45, 'PPL', 'P'),
(145743, 'Middlebush', 40.497501373291, 0.706814737794853, -74.5297164916992, -1.30078894335807, 218, 37, 'PPL', 'P'),
(120613, 'Middlecreek', 41.9427795410156, 0.732039600428839, -88.3372192382813, -1.54177532776409, 218, 18, 'PPL', 'P'),
(49455, 'Middlecroft', 39.6916694641113, 0.692750317762036, -75.9080581665039, -1.32484554380086, 218, 25, 'PPL', 'P'),
(113705, 'Middlefield', 41.517219543457, 0.724612177306662, -72.7125015258789, -1.26907255898799, 218, 8, 'PPL', 'P'),
(125412, 'Middlefield', 42.348331451416, 0.739117816553079, -73.0155563354492, -1.27436186322899, 218, 23, 'PPL', 'P'),
(150713, 'Middlefield', 42.6872215270996, 0.74503256417609, -74.8402786254883, -1.30620927512471, 218, 40, 'PPL', 'P'),
(156469, 'Middlefield', 41.4619407653809, 0.723647380622754, -81.0738906860352, -1.41500632987328, 218, 41, 'PPL', 'P'),
(150714, 'Middlefield Center', 42.7644386291504, 0.746380256845725, -74.8399963378906, -1.30620434827669, 218, 40, 'PPL', 'P'),
(14221, 'Middleford', 38.6666717529297, 0.67486073287651, -75.567497253418, -1.31890163456392, 218, 10, 'PPL', 'P'),
(14222, 'Middleford Acres', 38.6805610656738, 0.675103147114735, -75.6091690063477, -1.31962894385762, 218, 10, 'PPL', 'P'),
(123191, 'Middlefork', 40.4155616760254, 0.705384620289481, -86.3925018310547, -1.50783360598713, 218, 19, 'PPL', 'P'),
(190480, 'Middlegate', 39.2877807617188, 0.685701130093678, -118.02555847168, -2.0599345968359, 218, 39, 'PPL', 'P'),
(23065, 'Middleground', 32.6411094665527, 0.569694831695235, -81.5327835083008, -1.42301552053558, 218, 13, 'PPL', 'P'),
(120615, 'Middlegrove', 40.7044410705566, 0.710426516865219, -90.0994415283203, -1.5725319088773, 218, 18, 'PPL', 'P'),
(27893, 'Middlepoint', 37.9338912963867, 0.662071301215568, -88.29638671875, -1.54106266585638, 218, 18, 'PPL', 'P'),
(49456, 'Middlepoint', 39.563060760498, 0.690505672437263, -77.5252838134766, -1.35307145608823, 218, 25, 'PPL', 'P'),
(73458, 'Middleport', 39.0016708374023, 0.680707569891725, -82.0488891601563, -1.43202326344861, 218, 41, 'PPL', 'P'),
(150717, 'Middleport', 43.2125015258789, 0.754200429649661, -78.4766693115234, -1.36967626548488, 218, 40, 'PPL', 'P'),
(164515, 'Middleport', 40.7294387817383, 0.710862809230801, -76.0858306884766, -1.32794825962886, 218, 45, 'PPL', 'P'),
(175303, 'Middleport', 46.771110534668, 0.816309873644162, -90.7819366455078, -1.58444369580101, 218, 57, 'PPL', 'P'),
(37181, 'Middlesboro', 36.6083297729492, 0.638935888193832, -83.716667175293, -1.46113148100512, 218, 21, 'PPL', 'P'),
(49457, 'Middlesex', 39.3274993896484, 0.686394350925426, -76.4550018310547, -1.3343915115702, 218, 25, 'PPL', 'P'),
(66803, 'Middlesex', 35.7900009155273, 0.624653355267737, -78.2041702270508, -1.36492025925216, 218, 33, 'PPL', 'P'),
(104222, 'Middlesex', 37.5844383239746, 0.655972196266096, -75.8099975585938, -1.32313406332632, 218, 53, 'PPL', 'P'),
(145744, 'Middlesex', 40.5724983215332, 0.708123681470627, -74.4930572509766, -1.30014911890618, 218, 37, 'PPL', 'P'),
(150718, 'Middlesex', 42.704719543457, 0.745337962174095, -77.2719421386719, -1.34864980973037, 218, 40, 'PPL', 'P'),
(164517, 'Middlesex', 40.2344398498535, 0.702223448075557, -77.1363906860352, -1.346283990576, 218, 45, 'PPL', 'P'),
(172245, 'Middlesex', 44.292781829834, 0.773054877798122, -72.6797180175781, -1.26850037882778, 218, 55, 'PPL', 'P'),
(14223, 'Middlesex Beach', 38.5224990844727, 0.672344445120549, -75.054443359375, -1.30994715487269, 218, 10, 'PPL', 'P'),
(145746, 'Middlesex Downs', 40.2874984741211, 0.703149495765605, -74.404167175293, -1.29859769441315, 218, 37, 'PPL', 'P'),
(27891, 'Middlesworth', 39.4122200012207, 0.687873004541665, -88.7152786254883, -1.54837370883892, 218, 18, 'PPL', 'P'),
(4185, 'Middleton', 33.769718170166, 0.589392769539952, -85.9847183227539, -1.50071644113195, 218, 2, 'PPL', 'P'),
(10460, 'Middleton', 35.336109161377, 0.61673144971016, -92.6361083984375, -1.61680509778711, 218, 4, 'PPL', 'P'),
(23066, 'Middleton', 34.0991706848145, 0.595142800649542, -82.7675018310547, -1.44456542060234, 218, 13, 'PPL', 'P'),
(27892, 'Middleton', 38.2930603027344, 0.668339982947451, -88.6697235107422, -1.54757862209548, 218, 18, 'PPL', 'P'),
(37182, 'Middleton', 36.7508316040039, 0.641423014335857, -86.7347183227539, -1.51380641052191, 218, 21, 'PPL', 'P'),
(56234, 'Middleton', 39.1172218322754, 0.682724315206215, -92.3019409179688, -1.61097277499983, 218, 29, 'PPL', 'P'),
(60878, 'Middleton', 32.1636085510254, 0.561360868537996, -88.6122207641602, -1.54657500983868, 218, 30, 'PPL', 'P'),
(76595, 'Middleton', 36.9558296203613, 0.645000904681351, -97.1138916015625, -1.69495715787213, 218, 42, 'PPL', 'P'),
(88994, 'Middleton', 35.0644416809082, 0.611989957705383, -88.8908309936523, -1.55143767567306, 218, 50, 'PPL', 'P'),
(96178, 'Middleton', 31.1749992370605, 0.544106380993427, -95.8638916015625, -1.67314054222221, 218, 51, 'PPL', 'P'),
(104225, 'Middleton', 36.8858299255371, 0.643779179531277, -76.1800003051758, -1.3295918294956, 218, 53, 'PPL', 'P'),
(125416, 'Middleton', 42.5950012207031, 0.743423016192273, -71.0166702270508, -1.23947471926507, 218, 23, 'PPL', 'P'),
(132086, 'Middleton', 43.1833305358887, 0.753691299828265, -84.7088928222656, -1.47844908546753, 218, 27, 'PPL', 'P'),
(156471, 'Middleton', 40.8433303833008, 0.712850592668436, -80.6513900756836, -1.40763230313096, 218, 41, 'PPL', 'P'),
(164520, 'Middleton', 40.8855590820313, 0.713587622500116, -78.7461090087891, -1.37437887533774, 218, 45, 'PPL', 'P'),
(175304, 'Middleton', 43.0972213745117, 0.752188411446106, -89.5041732788086, -1.56214251799074, 218, 57, 'PPL', 'P'),
(183260, 'Middleton', 38.2066688537598, 0.666832167717276, -122.261940002441, -2.13387340291837, 218, 6, 'PPL', 'P'),
(187053, 'Middleton', 37.8549995422363, 0.66069438035297, -107.571670532227, -1.87747983265791, 218, 7, 'PPL', 'P'),
(192696, 'Middleton', 37.1208305358887, 0.647880713926108, -113.540000915527, -1.98164684869333, 218, 52, 'PPL', 'P'),
(195323, 'Middleton', 43.7069396972656, 0.762830003687899, -116.619171142578, -2.03538850738475, 218, 17, 'PPL', 'P'),
(201224, 'Middleton', 45.3438911437988, 0.791400196125187, -122.863327026367, -2.14436958656464, 218, 43, 'PPL', 'P'),
(156472, 'Middleton (historical)', 41.5461082458496, 0.725116380280041, -83.273063659668, -1.45338913908404, 218, 41, 'PPL', 'P'),
(125417, 'Middleton Colony', 42.5902786254883, 0.743340591356535, -70.9930572509766, -1.23906259508638, 218, 23, 'PPL', 'P'),
(73459, 'Middleton Corner', 39.5805587768555, 0.690811070435267, -83.8616714477539, -1.46366228298903, 218, 41, 'PPL', 'P'),
(144145, 'Middleton Corners', 43.4761085510254, 0.758801240169854, -71.0699996948242, -1.24040549406605, 218, 36, 'PPL', 'P'),
(49458, 'Middleton Farm', 38.8116683959961, 0.677391401702358, -76.918327331543, -1.34247806706217, 218, 25, 'PPL', 'P'),
(104226, 'Middleton Gardens', 37.2938919067383, 0.650901204655449, -80.0827789306641, -1.39770816648683, 218, 53, 'PPL', 'P'),
(66805, 'Middleton Heights', 34.7813911437988, 0.607049793883286, -79.4622192382813, -1.38687735664959, 218, 33, 'PPL', 'P'),
(175305, 'Middleton Junction', 43.0602798461914, 0.751543660146198, -89.5277786254883, -1.56255450901137, 218, 57, 'PPL', 'P'),
(82379, 'Middleton Shores', 34.5638885498047, 0.60325365748646, -82.7013931274414, -1.44341160606006, 218, 48, 'PPL', 'P'),
(104227, 'Middletons Corner', 37.9452781677246, 0.662270039611916, -76.445556640625, -1.33422666189872, 218, 53, 'PPL', 'P'),
(14224, 'Middletown', 39.4494400024414, 0.688522616110562, -75.716667175293, -1.32150514084558, 218, 10, 'PPL', 'P'),
(33265, 'Middletown', 37.7197189331055, 0.658333288309533, -95.8330612182617, -1.67260245052396, 218, 20, 'PPL', 'P'),
(37185, 'Middletown', 37.0205612182617, 0.64613068419479, -85.0761108398438, -1.48485824894691, 218, 21, 'PPL', 'P'),
(49461, 'Middletown', 39.4436111450195, 0.688420883356921, -77.5449981689453, -1.35341553650107, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(56236, 'Middletown', 39.1269416809082, 0.682893958567653, -91.4138870239258, -1.59547331061363, 218, 29, 'PPL', 'P'),
(66804, 'Middletown', 35.4780616760254, 0.619208988472261, -76.0124969482422, -1.32666834440897, 218, 33, 'PPL', 'P'),
(104229, 'Middletown', 37.4838905334473, 0.654217306265788, -75.8677825927734, -1.32414260243114, 218, 53, 'PPL', 'P'),
(113708, 'Middletown', 41.5622215270996, 0.725397610091154, -72.6511077880859, -1.26800103612339, 218, 8, 'PPL', 'P'),
(116834, 'Middletown', 40.8283309936523, 0.712588803933282, -91.2588882446289, -1.59276807157832, 218, 16, 'PPL', 'P'),
(120617, 'Middletown', 40.1002807617188, 0.699881930266132, -89.5908279418945, -1.56365492717379, 218, 18, 'PPL', 'P'),
(123193, 'Middletown', 40.0572204589844, 0.699130386206512, -85.5372161865234, -1.49290605544502, 218, 19, 'PPL', 'P'),
(132087, 'Middletown', 42.9858283996582, 0.750244237271321, -84.1449966430664, -1.46860724050108, 218, 27, 'PPL', 'P'),
(145748, 'Middletown', 40.3941688537598, 0.705011245104652, -74.1175003051758, -1.29359441367322, 218, 37, 'PPL', 'P'),
(150720, 'Middletown', 41.4458312988281, 0.723366217390669, -74.4233322143555, -1.29893218744607, 218, 40, 'PPL', 'P'),
(156476, 'Middletown', 40.773609161377, 0.711633727787352, -82.7919387817383, -1.44499192585092, 218, 41, 'PPL', 'P'),
(164527, 'Middletown', 40.2616691589355, 0.702698689172081, -79.6208267211914, -1.38964557944467, 218, 45, 'PPL', 'P'),
(169485, 'Middletown', 41.5455589294434, 0.725106792900117, -71.2919387817383, -1.24427906187157, 218, 47, 'PPL', 'P'),
(172247, 'Middletown', 43.2838897705078, 0.755446389565654, -72.7305603027344, -1.269387744103, 218, 55, 'PPL', 'P'),
(177671, 'Middletown', 38.752498626709, 0.676358694410653, -122.613891601563, -2.14001611713069, 218, 6, 'PPL', 'P'),
(193786, 'Middletown (historical)', 40.538890838623, 0.707537120240537, -122.471672058105, -2.13753391783668, 218, 6, 'PPL', 'P'),
(200070, 'Middletown (historical)', 40.439998626709, 0.705811125538057, -116.86888885498, -2.03974690366671, 218, 39, 'PPL', 'P'),
(164528, 'Middletown Center', 41.8761100769043, 0.730875998769556, -76.0902786254883, -1.32802589077464, 218, 45, 'PPL', 'P'),
(49462, 'Middletown Downs', 39.7102813720703, 0.693075156835998, -76.7516708374023, -1.33956936251958, 218, 25, 'PPL', 'P'),
(49463, 'Middletown Estates', 39.7147216796875, 0.69315265482372, -76.7555618286133, -1.33963727312738, 218, 25, 'PPL', 'P'),
(37186, 'Middletown Heights', 38.2158317565918, 0.666992090540735, -85.2422180175781, -1.48775736610957, 218, 21, 'PPL', 'P'),
(49464, 'Middletown Heights', 39.4577789306641, 0.688668157864135, -77.5597229003906, -1.35367253154626, 218, 25, 'PPL', 'P'),
(49465, 'Middletown Manor', 39.4347190856934, 0.688265687644397, -77.5358276367188, -1.35325548051956, 218, 25, 'PPL', 'P'),
(123194, 'Middletown Park', 40.1622200012207, 0.700962973931622, -85.4247207641602, -1.49094263993136, 218, 19, 'PPL', 'P'),
(49466, 'Middletown South', 39.4338912963867, 0.688251239995483, -77.5513916015625, -1.35352712295074, 218, 25, 'PPL', 'P'),
(172248, 'Middletown Springs', 43.4855613708496, 0.758966222999385, -73.1186065673828, -1.27616042907118, 218, 55, 'PPL', 'P'),
(49472, 'Middletown Valley Estates', 39.4097213745117, 0.687829395278815, -77.5755615234375, -1.35394896766741, 218, 25, 'PPL', 'P'),
(49467, 'Middletown View', 39.461669921875, 0.688736068471932, -77.570556640625, -1.35386161598366, 218, 25, 'PPL', 'P'),
(104230, 'Middletowne Farms', 37.2677803039551, 0.650445471213909, -76.6811065673828, -1.33833778367348, 218, 53, 'PPL', 'P'),
(110425, 'Middleville', 39.3144416809082, 0.686166450915142, -80.1911087036133, -1.39959887770273, 218, 58, 'PPL', 'P'),
(132088, 'Middleville', 42.7130584716797, 0.745483503927668, -85.4619369506836, -1.49159218492123, 218, 27, 'PPL', 'P'),
(145750, 'Middleville', 41.0558280944824, 0.716559377381508, -74.8633270263672, -1.30661154560736, 218, 37, 'PPL', 'P'),
(150725, 'Middleville', 40.899169921875, 0.713825176469351, -73.2966690063477, -1.27926820490525, 218, 40, 'PPL', 'P'),
(110426, 'Middleway', 39.3033294677734, 0.685972506208757, -77.9830627441406, -1.36106120567458, 218, 58, 'PPL', 'P'),
(191873, 'Middlewell', 35.764720916748, 0.624212136054138, -102.124168395996, -1.78240298437127, 218, 51, 'PPL', 'P'),
(4186, 'Midfield', 33.4613914489746, 0.584011453083283, -86.9088897705078, -1.51684627574818, 218, 2, 'PPL', 'P'),
(96179, 'Midfield', 28.9375, 0.505054652295859, -96.2077789306641, -1.67914250837092, 218, 51, 'PPL', 'P'),
(88995, 'Midfields', 36.5699996948242, 0.638266902128004, -82.5800018310547, -1.44129292825485, 218, 50, 'PPL', 'P'),
(177636, 'Midges Court', 33.5144386291504, 0.584937301036249, -112.155281066895, -1.95747892811697, 218, 5, 'PPL', 'P'),
(150726, 'Midhampton', 40.9497184753418, 0.714707415159467, -72.2411117553711, -1.26084525543241, 218, 40, 'PPL', 'P'),
(33266, 'Midian', 37.8102798461914, 0.659913874416495, -96.9527816772461, -1.69214525923517, 218, 20, 'PPL', 'P'),
(110428, 'Midkiff', 38.1761093139648, 0.66629880312996, -82.1788864135742, -1.4342921435393, 218, 58, 'PPL', 'P'),
(191874, 'Midkiff', 31.6327800750732, 0.552096163869287, -101.83943939209, -1.77743352577718, 218, 51, 'PPL', 'P'),
(204914, 'Midlake', 41.2238883972168, 0.719492583006121, -112.663887023926, -1.96635577666242, 218, 52, 'PPL', 'P'),
(208120, 'Midlakes', 47.6161117553711, 0.831057927128802, -122.18138885498, -2.13246752017891, 218, 56, 'PPL', 'P'),
(110429, 'Midlan (historical)', 39.1866683959961, 0.683936386397337, -80.0272216796875, -1.39673850953393, 218, 58, 'PPL', 'P'),
(10461, 'Midland', 35.0930595397949, 0.612489433567827, -94.3530578613281, -1.6467715190049, 218, 4, 'PPL', 'P'),
(23067, 'Midland', 32.5747184753418, 0.568536090304942, -84.8272171020508, -1.48051423373483, 218, 13, 'PPL', 'P'),
(30500, 'Midland', 39.121940612793, 0.682806673462925, -87.1916732788086, -1.52178177903837, 218, 19, 'PPL', 'P'),
(33268, 'Midland', 37.6138916015625, 0.656486252935509, -97.3349990844727, -1.69881621144971, 218, 20, 'PPL', 'P'),
(37188, 'Midland', 37.3058280944824, 0.65110953043172, -87.2305603027344, -1.52246048564218, 218, 21, 'PPL', 'P'),
(42089, 'Midland', 30.1805591583252, 0.526750127405703, -92.5027770996094, -1.61447802762659, 218, 22, 'PPL', 'P'),
(49468, 'Midland', 39.5900001525879, 0.690975853527716, -78.9499969482422, -1.3779373911863, 218, 25, 'PPL', 'P'),
(56237, 'Midland', 37.978328704834, 0.662846880304027, -91.3269424438477, -1.5939558414245, 218, 29, 'PPL', 'P'),
(66806, 'Midland', 35.2272186279297, 0.614830951377252, -80.5008316040039, -1.40500456208338, 218, 33, 'PPL', 'P'),
(73462, 'Midland', 39.3061103820801, 0.686021042319624, -83.9111099243164, -1.46452514718221, 218, 41, 'PPL', 'P'),
(88996, 'Midland', 35.6699981689453, 0.622558912228444, -86.4805603027344, -1.50937051625222, 218, 50, 'PPL', 'P'),
(104231, 'Midland', 38.5994415283203, 0.673687344100221, -77.7247161865234, -1.35655220763297, 218, 53, 'PPL', 'P'),
(110430, 'Midland', 38.8855590820313, 0.678681037460229, -79.8480606079102, -1.39361155894002, 218, 58, 'PPL', 'P'),
(116835, 'Midland', 43.476390838623, 0.758806167017871, -96.0999984741211, -1.67726138453494, 218, 16, 'PPL', 'P'),
(125419, 'Midland', 42.0930595397949, 0.734662481207431, -71.4819412231445, -1.24759523006093, 218, 23, 'PPL', 'P'),
(132089, 'Midland', 43.6155586242676, 0.761235103090078, -84.2472229003906, -1.47039142527338, 218, 27, 'PPL', 'P'),
(142407, 'Midland', 42.4672203063965, 0.741192818516414, -97.7002792358398, -1.70519155278325, 218, 35, 'PPL', 'P'),
(164533, 'Midland', 40.2588882446289, 0.702650153061215, -80.2183303833008, -1.4000739856412, 218, 45, 'PPL', 'P'),
(183261, 'Midland', 33.8611106872559, 0.590987869874855, -114.801391601563, -2.00366226931863, 218, 6, 'PPL', 'P'),
(187054, 'Midland', 38.8583297729492, 0.678205796363704, -105.161109924316, -1.83540761323101, 218, 7, 'PPL', 'P'),
(191875, 'Midland', 31.9972190856934, 0.558456824527319, -102.077499389648, -1.78158845655187, 218, 51, 'PPL', 'P'),
(201225, 'Midland', 42.1308288574219, 0.735321680156252, -121.81916809082, -2.12614557522523, 218, 43, 'PPL', 'P'),
(202376, 'Midland', 44.0716705322266, 0.769195757641515, -101.154998779297, -1.76548778354958, 218, 49, 'PPL', 'P'),
(208119, 'Midland', 47.1672210693359, 0.823223306675953, -122.403610229492, -2.13634601483245, 218, 56, 'PPL', 'P'),
(197038, 'Midland (historical)', 45.6763916015625, 0.797203423877552, -104.056938171387, -1.81613618063487, 218, 31, 'PPL', 'P'),
(82381, 'Midland Acres', 33.9252815246582, 0.592107862271288, -80.290283203125, -1.40132979925323, 218, 48, 'PPL', 'P'),
(150727, 'Midland Beach', 40.5730590820313, 0.708133468587633, -74.0950012207031, -1.29320173057049, 218, 40, 'PPL', 'P'),
(4187, 'Midland City', 31.3188896179199, 0.546617741901371, -85.4938888549805, -1.49214985085349, 218, 2, 'PPL', 'P'),
(120618, 'Midland City', 40.1452789306641, 0.700667296471596, -89.1336135864258, -1.55567503128348, 218, 18, 'PPL', 'P'),
(178642, 'Midland City', 33.4119415283203, 0.583148389153016, -110.823608398438, -1.93423685549357, 218, 5, 'PPL', 'P'),
(204915, 'Midland Court Condominium', 40.6647186279297, 0.709733229454444, -111.822219848633, -1.9516659132476, 218, 52, 'PPL', 'P'),
(82382, 'Midland Estates', 35.0244407653809, 0.611291810025619, -81.9702835083008, -1.43065133601306, 218, 48, 'PPL', 'P'),
(30501, 'Midland Junction', 39.1072196960449, 0.68254974499676, -87.1944427490234, -1.52183011541215, 218, 19, 'PPL', 'P'),
(136857, 'Midland Junction', 44.3211097717285, 0.773549293654495, -92.0013885498047, -1.6057271466007, 218, 28, 'PPL', 'P'),
(33269, 'Midland Park', 37.5888900756836, 0.656049893990899, -97.3375015258789, -1.69885988729159, 218, 20, 'PPL', 'P'),
(82383, 'Midland Park', 32.9205589294434, 0.574572144915606, -80.0408325195313, -1.39697606350317, 218, 48, 'PPL', 'P'),
(132091, 'Midland Park', 42.3908309936523, 0.739859573495693, -85.3855590820313, -1.49025913963759, 218, 27, 'PPL', 'P'),
(145751, 'Midland Park', 40.9891700744629, 0.715395975459307, -74.14111328125, -1.29400653785191, 218, 37, 'PPL', 'P'),
(204918, 'Midland Square', 41.1952781677246, 0.718993240301731, -112.043327331543, -1.95552496682518, 218, 52, 'PPL', 'P'),
(33270, 'Midland Tower', 37.5999984741211, 0.656243772118257, -97.3338928222656, -1.69879690353181, 218, 20, 'PPL', 'P'),
(82384, 'Midland Valley', 33.5513916015625, 0.585582252073239, -81.8211135864258, -1.4280478297314, 218, 48, 'PPL', 'P'),
(96180, 'Midline', 30.2577800750732, 0.528097886654365, -95.1449966430664, -1.66059345822046, 218, 51, 'PPL', 'P'),
(49469, 'Midlothian', 39.6341705322266, 0.691746772084267, -78.9502792358398, -1.37794231803432, 218, 25, 'PPL', 'P'),
(76597, 'Midlothian', 35.6372184753418, 0.621986798647268, -96.9222183227539, -1.69161182806883, 218, 42, 'PPL', 'P'),
(96181, 'Midlothian', 32.4822196960449, 0.566921682052136, -96.9941711425781, -1.69286764168086, 218, 51, 'PPL', 'P'),
(104232, 'Midlothian', 37.5058288574219, 0.654600202251515, -77.6494369506836, -1.35523833710917, 218, 53, 'PPL', 'P'),
(120619, 'Midlothian', 41.6252784729004, 0.726498161411629, -87.7174987792969, -1.53095916531284, 218, 18, 'PPL', 'P'),
(164535, 'Midmont', 41.6108283996582, 0.726245960056399, -78.6074981689453, -1.37195965980351, 218, 45, 'PPL', 'P'),
(60879, 'Midnight', 33.0494384765625, 0.576821517351314, -90.5733337402344, -1.58080288827476, 218, 30, 'PPL', 'P'),
(195324, 'Midnight', 44.9230613708496, 0.784055330996803, -115.329719543457, -2.01288333143498, 218, 17, 'PPL', 'P'),
(189031, 'Midnight (historical)', 36.7638893127441, 0.641650914346141, -105.35221862793, -1.83874308933828, 218, 38, 'PPL', 'P'),
(14225, 'Midnight Thicket', 38.5763893127441, 0.673285007038538, -75.5388870239258, -1.31840229185953, 218, 10, 'PPL', 'P'),
(183262, 'Midoil', 35.1583290100098, 0.613628600724109, -119.521667480469, -2.08604662500802, 218, 6, 'PPL', 'P'),
(66807, 'Midpine', 35.208610534668, 0.614506178882317, -81.3877792358398, -1.42048471855168, 218, 33, 'PPL', 'P'),
(183263, 'Midpines', 37.5444412231445, 0.655274115165359, -119.919441223145, -2.09298908649569, 218, 6, 'PPL', 'P'),
(56245, 'Midridge', 37.3352813720703, 0.651623587101133, -91.2216720581055, -1.59211852658845, 218, 29, 'PPL', 'P'),
(23068, 'Midriver', 30.9755592346191, 0.540625496290639, -81.8675003051758, -1.42885743070278, 218, 13, 'PPL', 'P'),
(49470, 'Midsummer Hill', 39.6541709899902, 0.692095845924149, -76.4580612182617, -1.33444490795005, 218, 25, 'PPL', 'P'),
(66808, 'Midtown', 35.1577796936035, 0.613619013344185, -79.413330078125, -1.38602407983633, 218, 33, 'PPL', 'P'),
(89021, 'Midtown', 35.8794403076172, 0.626214367140687, -84.5641708374023, -1.47592321033164, 218, 50, 'PPL', 'P'),
(88997, 'Midtown Heights', 35.8763885498047, 0.626161103918885, -84.5566711425781, -1.47579231596406, 218, 50, 'PPL', 'P'),
(117, 'Midvale', 37.8358306884766, 0.660359820741029, -79.2869415283203, -1.38381818350541, 218, 53, 'PPL', 'P'),
(14226, 'Midvale', 39.6597213745117, 0.692192718408801, -75.6108322143555, -1.3196579723135, 218, 10, 'PPL', 'P'),
(56239, 'Midvale', 37.211109161377, 0.649456373185054, -91.7297210693359, -1.60098565459593, 218, 29, 'PPL', 'P'),
(88998, 'Midvale', 35.0886116027832, 0.612411802422052, -85.311393737793, -1.48896471018976, 218, 50, 'PPL', 'P'),
(110431, 'Midvale', 38.9372215270996, 0.679582717226303, -80.0899963378906, -1.39783413400639, 218, 58, 'PPL', 'P'),
(116837, 'Midvale', 41.9294395446777, 0.731806773570538, -93.6100006103516, -1.63380272344454, 218, 16, 'PPL', 'P'),
(136858, 'Midvale', 44.9716682434082, 0.784903680962048, -92.9947204589844, -1.62306405898101, 218, 28, 'PPL', 'P'),
(156477, 'Midvale', 40.4377784729004, 0.705772376544196, -81.3733291625977, -1.42023251719645, 218, 41, 'PPL', 'P'),
(164536, 'Midvale', 41.2669410705566, 0.720243993907687, -75.8636093139648, -1.32406976497532, 218, 45, 'PPL', 'P'),
(195325, 'Midvale', 44.4713897705078, 0.776172174433087, -116.733612060547, -2.03738587820231, 218, 17, 'PPL', 'P'),
(204919, 'Midvale', 40.6111106872559, 0.708797594384472, -111.899169921875, -1.95300894538532, 218, 52, 'PPL', 'P'),
(208121, 'Midvale', 46.2844390869141, 0.807815854505408, -120.013328552246, -2.09462772951441, 218, 56, 'PPL', 'P'),
(209602, 'Midvale', 43.2150001525879, 0.754244038912511, -108.444442749023, -1.89271258146095, 218, 59, 'PPL', 'P'),
(208122, 'Midvale Corner', 47.9927787780762, 0.83763200685869, -122.416389465332, -2.13656905457374, 218, 56, 'PPL', 'P'),
(49471, 'Midvale Manor', 38.3591690063477, 0.669493797489728, -75.5569381713867, -1.31871734381648, 218, 25, 'PPL', 'P'),
(204920, 'Midvale Terrace', 40.6133308410645, 0.708836343378333, -111.859718322754, -1.95232038508548, 218, 52, 'PPL', 'P'),
(14227, 'Midvalf', 39.6588897705078, 0.69217820418086, -75.6138916015625, -1.31971136869335, 218, 10, 'PPL', 'P'),
(183264, 'Midvalley', 36.2980613708496, 0.633520683012292, -119.387222290039, -2.08370011377155, 218, 6, 'PPL', 'P'),
(204921, 'Midvalley', 40.6124992370605, 0.708821829150392, -111.886940002441, -1.95279549302395, 218, 52, 'PPL', 'P'),
(204922, 'Midvalley Estates', 40.6127815246582, 0.708826755998408, -111.869171142578, -1.95248536791502, 218, 52, 'PPL', 'P'),
(23069, 'Midville', 32.8188896179199, 0.572797680681286, -82.2350006103516, -1.43527152103018, 218, 13, 'PPL', 'P'),
(4200, 'Midway', 32.084171295166, 0.5599744268745, -87.4049987792969, -1.52550501140036, 218, 2, 'PPL', 'P'),
(10476, 'Midway', 35.292781829834, 0.615975245118632, -91.607780456543, -1.59885738941079, 218, 4, 'PPL', 'P'),
(14228, 'Midway', 38.7280616760254, 0.675932189162077, -75.1297225952148, -1.31126102539648, 218, 10, 'PPL', 'P'),
(17122, 'Midway', 28.7900009155273, 0.502480307628134, -81.2311096191406, -1.41775031790244, 218, 12, 'PPL', 'P'),
(23080, 'Midway', 32.0313911437988, 0.559053239453442, -81.8936080932617, -1.42931309756529, 218, 13, 'PPL', 'P'),
(37193, 'Midway', 38.1508293151855, 0.665857583916361, -84.6838912963867, -1.47801272652292, 218, 21, 'PPL', 'P'),
(42086, 'Midway', 32.9219398498535, 0.574596246523471, -93.4533309936523, -1.6310683227953, 218, 22, 'PPL', 'P'),
(60885, 'Midway', 32.8863906860352, 0.57397579656851, -90.1922225952148, -1.57415124397812, 218, 30, 'PPL', 'P'),
(66817, 'Midway', 35.1599998474121, 0.613657762338045, -78.4705581665039, -1.36956960588322, 218, 33, 'PPL', 'P'),
(82390, 'Midway', 34.9483299255371, 0.609963425273887, -82.7111129760742, -1.4435812494215, 218, 48, 'PPL', 'P'),
(89020, 'Midway', 36.2999992370605, 0.633554505158136, -82.4238891601563, -1.43856824814359, 218, 50, 'PPL', 'P'),
(104241, 'Midway', 36.7861099243164, 0.642038737179883, -81.8763885498047, -1.42901255983628, 218, 53, 'PPL', 'P'),
(110435, 'Midway', 37.7194404602051, 0.658328428040544, -81.2372207641602, -1.4178569775041, 218, 58, 'PPL', 'P'),
(113710, 'Midway', 41.3413887023926, 0.721543350203537, -72.0338897705078, -1.25722854951402, 218, 8, 'PPL', 'P'),
(116840, 'Midway', 42.3708305358887, 0.739510499655811, -95.7286071777344, -1.67077938359974, 218, 16, 'PPL', 'P'),
(120621, 'Midway', 40.0161094665527, 0.698412864029817, -87.6377792358398, -1.52956779680133, 218, 18, 'PPL', 'P'),
(123195, 'Midway', 41.6186103820801, 0.726381781271993, -85.8905563354492, -1.49907300442326, 218, 19, 'PPL', 'P'),
(136860, 'Midway', 47.4911117553711, 0.828876265563809, -92.5255584716797, -1.61487563757734, 218, 28, 'PPL', 'P'),
(139326, 'Midway', 40.4752807617188, 0.706426914961111, -93.1619415283203, -1.62598261721963, 218, 29, 'PPL', 'P'),
(142415, 'Midway', 41.2147216796875, 0.719332593603635, -98.5566711425781, -1.72013841124327, 218, 35, 'PPL', 'P'),
(150729, 'Midway', 42.5511093139648, 0.742656957904712, -76.4938888549805, -1.335070218174, 218, 40, 'PPL', 'P'),
(156481, 'Midway', 40.9408302307129, 0.71455228602597, -81.3372192382813, -1.41960228012448, 218, 41, 'PPL', 'P'),
(164540, 'Midway', 40.2649993896484, 0.702756812662872, -79.561393737793, -1.38860827820009, 218, 45, 'PPL', 'P'),
(170873, 'Midway', 43.1258316040039, 0.752687754150496, -97.3988876342773, -1.69993127699813, 218, 49, 'PPL', 'P'),
(175308, 'Midway', 43.9291687011719, 0.76670863149949, -91.2577819824219, -1.59274876366042, 218, 57, 'PPL', 'P'),
(178644, 'Midway', 32.6336097717285, 0.569563937327658, -112.854438781738, -1.96968153223171, 218, 5, 'PPL', 'P'),
(187809, 'Midway', 39.8291702270508, 0.695150158799334, -100.777221679688, -1.75889432932276, 218, 20, 'PPL', 'P'),
(189033, 'Midway', 34.2561111450195, 0.597881928409716, -103.243057250977, -1.80193127885455, 218, 38, 'PPL', 'P'),
(190481, 'Midway', 38.7236099243164, 0.675854491437274, -118.300277709961, -2.06472935206248, 218, 39, 'PPL', 'P'),
(191007, 'Midway', 36.8699989318848, 0.643502876568182, -101.360282897949, -1.76907066732211, 218, 42, 'PPL', 'P'),
(191881, 'Midway', 32.732780456543, 0.571294792299128, -100.682502746582, -1.75724117207609, 218, 51, 'PPL', 'P'),
(193785, 'Midway', 40.5022201538086, 0.706897096051564, -121.965278625488, -2.12869568512703, 218, 6, 'PPL', 'P'),
(194326, 'Midway', 40.226390838623, 0.702082966328055, -103.397216796875, -1.80462187050385, 218, 7, 'PPL', 'P'),
(195327, 'Midway', 43.7069396972656, 0.762830003687899, -112.004173278809, -1.95484159968946, 218, 17, 'PPL', 'P'),
(197039, 'Midway', 47.5149993896484, 0.829293183432461, -104.319999694824, -1.82072747035416, 218, 31, 'PPL', 'P'),
(198621, 'Midway', 46.9841690063477, 0.820028445474239, -100.78971862793, -1.75911244221603, 218, 34, 'PPL', 'P'),
(201227, 'Midway', 45.086109161377, 0.786901051779607, -123.66056060791, -2.15828393747003, 218, 43, 'PPL', 'P'),
(204925, 'Midway', 40.5122184753418, 0.707071599681992, -111.473609924316, -1.94558152226315, 218, 52, 'PPL', 'P'),
(208125, 'Midway', 47.3050003051758, 0.82562800798224, -122.588333129883, -2.1395700376481, 218, 56, 'PPL', 'P'),
(4201, 'Midway (historical)', 33.8908309936523, 0.591506587076175, -85.6847229003906, -1.4954805332708, 218, 2, 'PPL', 'P'),
(10477, 'Midway (historical)', 34.3236083984375, 0.599059977717912, -94.0247192382813, -1.64104092897126, 218, 4, 'PPL', 'P'),
(23081, 'Midway (historical)', 34.6005592346191, 0.603893681675433, -84.8455581665039, -1.48083434569786, 218, 13, 'PPL', 'P'),
(60886, 'Midway (historical)', 33.9900016784668, 0.593237442047645, -90.2991714477539, -1.57601785358616, 218, 30, 'PPL', 'P'),
(116841, 'Midway (historical)', 41.6188888549805, 0.726386641540982, -91.4388885498047, -1.59590966955823, 218, 16, 'PPL', 'P'),
(120622, 'Midway (historical)', 40.6986083984375, 0.710324717532551, -90.2433319091797, -1.57504326978525, 218, 18, 'PPL', 'P'),
(156483, 'Midway (historical)', 41.5563888549805, 0.725295810758486, -83.8249969482422, -1.46302219222102, 218, 41, 'PPL', 'P'),
(187058, 'Midway (historical)', 38.3438911437988, 0.669227148485584, -107.053329467773, -1.86843307443492, 218, 7, 'PPL', 'P'),
(197042, 'Midway (historical)', 48.5527801513672, 0.847405874638308, -106.452781677246, -1.85795153817464, 218, 31, 'PPL', 'P'),
(116842, 'Midway Beach', 41.459171295166, 0.723599044248969, -90.8283309936523, -1.58525342993045, 218, 16, 'PPL', 'P'),
(183267, 'Midway City', 33.7447204589844, 0.58895647717437, -117.988327026367, -2.05928478552992, 218, 6, 'PPL', 'P'),
(96200, 'Midway Colonia', 26.3770008087158, 0.460365510913298, -98.8809967041016, -1.72579896014023, 218, 51, 'PPL', 'P'),
(10478, 'Midway Corner', 35.0686111450195, 0.612062728582169, -90.2936096191406, -1.57592078136443, 218, 4, 'PPL', 'P'),
(123196, 'Midway Corners', 41.5208282470703, 0.724675161066443, -86.2022171020508, -1.50451251094975, 218, 19, 'PPL', 'P'),
(96201, 'Midway Crossing', 33.9627799987793, 0.592762334109174, -99.2108306884766, -1.73155564915255, 218, 51, 'PPL', 'P'),
(82394, 'Midway Crossroads', 33.7669410705566, 0.589344300008112, -79.5483322143555, -1.38838031161077, 218, 48, 'PPL', 'P'),
(14229, 'Midway Estates', 38.7347183227539, 0.676048369564631, -75.158332824707, -1.31176036810087, 218, 10, 'PPL', 'P'),
(23082, 'Midway Estates', 33.7572212219238, 0.589174656646674, -84.7113876342773, -1.47849262815135, 218, 13, 'PPL', 'P'),
(104242, 'Midway Island', 38.4986114501953, 0.671927527251897, -77.3691711425781, -1.35034677597697, 218, 53, 'PPL', 'P'),
(104244, 'Midway Mills', 37.665828704834, 0.657392726391544, -78.7225036621094, -1.3739668843171, 218, 53, 'PPL', 'P'),
(23083, 'Midway Mobile Home Park', 33.7550010681152, 0.589135907652814, -84.7069396972656, -1.47841499700557, 218, 13, 'PPL', 'P'),
(49473, 'Midway Mobile Home Park', 39.1080589294434, 0.682564392382755, -76.834716796875, -1.34101878794286, 218, 25, 'PPL', 'P'),
(96202, 'Midway North', 26.1875, 0.457058097866015, -98.0152816772461, -1.71068938253761, 218, 51, 'PPL', 'P'),
(14230, 'Midway Park', 38.7397193908691, 0.676135654669359, -75.1430587768555, -1.31149378567575, 218, 10, 'PPL', 'P'),
(17123, 'Midway Park', 28.735279083252, 0.501525231482204, -81.2997207641602, -1.4189478082866, 218, 12, 'PPL', 'P'),
(66818, 'Midway Park', 34.725830078125, 0.606080070351361, -77.341667175293, -1.34986674119048, 218, 33, 'PPL', 'P'),
(150730, 'Midway Park', 42.2013893127441, 0.736553192423332, -79.4244384765625, -1.38621795796368, 218, 40, 'PPL', 'P'),
(14231, 'Midway Park Subdivision', 38.7380599975586, 0.676106692792504, -75.1433334350586, -1.31149857936571, 218, 10, 'PPL', 'P'),
(49474, 'Midway Pines', 39.5152816772461, 0.689671770120932, -77.2858276367188, -1.34889215738957, 218, 25, 'PPL', 'P'),
(96203, 'Midway South', 26.1572208404541, 0.456529626837202, -98.0194396972656, -1.71076195367732, 218, 51, 'PPL', 'P'),
(116843, 'Midway Trailer Court', 42.4680595397949, 0.741207465902409, -92.0541687011719, -1.60664833402176, 218, 16, 'PPL', 'P'),
(142416, 'Midway Trailer Court', 41.439998626709, 0.723264418058, -96.5116729736328, -1.68444645999792, 218, 35, 'PPL', 'P'),
(76602, 'Midway Village', 35.4594383239746, 0.618883949661217, -97.4452819824219, -1.70074101112757, 218, 42, 'PPL', 'P'),
(96204, 'Midway Village Colonia', 26.1569995880127, 0.456525765253622, -98.0210037231445, -1.71078925107849, 218, 51, 'PPL', 'P'),
(209603, 'Midwest', 43.4113883972168, 0.757671660393497, -106.279441833496, -1.85492618717631, 218, 59, 'PPL', 'P'),
(76603, 'Midwest City', 35.4494400024414, 0.618709446030789, -97.3963928222656, -1.69988773431431, 218, 42, 'PPL', 'P'),
(116844, 'Midwest Country Estates', 41.6124992370605, 0.726275121670335, -93.8666687011719, -1.63828242671416, 218, 16, 'PPL', 'P'),
(204926, 'Midwest Estates', 40.6652793884277, 0.70974301657145, -111.96443939209, -1.95414811254161, 218, 52, 'PPL', 'P'),
(209604, 'Midwest Heights', 42.8541717529297, 0.747946395303773, -106.361106872559, -1.85635151099172, 218, 59, 'PPL', 'P'),
(145753, 'Midwood', 40.0972213745117, 0.699828533886276, -74.4186096191406, -1.29884976261033, 218, 37, 'PPL', 'P'),
(96205, 'Midyett', 32.2349014282227, 0.562605163978308, -94.1674270629883, -1.64353165038076, 218, 51, 'PPL', 'P'),
(164544, 'Miedel Hill', 40.1119384765625, 0.700085395773414, -79.6063919067383, -1.38939364440555, 218, 45, 'PPL', 'P'),
(123197, 'Mier', 40.5752792358398, 0.708172217581494, -85.8255615234375, -1.49793863095694, 218, 19, 'PPL', 'P'),
(189035, 'Miera', 36.0911102294922, 0.629908704204845, -103.551666259766, -1.80731752215923, 218, 38, 'PPL', 'P'),
(136864, 'Miesville', 44.6005592346191, 0.778426606874866, -92.8127822875977, -1.61988863885525, 218, 28, 'PPL', 'P'),
(164545, 'Miffin Cross Roads', 40.9708290100098, 0.715075863496279, -76.315559387207, -1.33195778180803, 218, 45, 'PPL', 'P'),
(30506, 'Mifflin', 38.3061103820801, 0.66856774979968, -86.540283203125, -1.51041287750288, 218, 19, 'PPL', 'P'),
(89022, 'Mifflin', 35.5527801513672, 0.620513071879045, -88.5800018310547, -1.54601268337451, 218, 50, 'PPL', 'P'),
(110436, 'Mifflin', 37.9411087036133, 0.662197268735129, -81.8222198486328, -1.4280671376493, 218, 58, 'PPL', 'P'),
(113392, 'Mifflin', 42.8711090087891, 0.748242006184772, -90.353889465332, -1.57697286315306, 218, 57, 'PPL', 'P'),
(156484, 'Mifflin', 40.7738914489746, 0.711638654635368, -82.3644409179688, -1.4375306805829, 218, 41, 'PPL', 'P'),
(164546, 'Mifflin', 40.5694389343262, 0.708070285090771, -77.4030609130859, -1.35093826405508, 218, 45, 'PPL', 'P'),
(156485, 'Mifflin Cottage Area', 40.7599983215332, 0.711396173818117, -82.3686065673828, -1.43760338488065, 218, 41, 'PPL', 'P'),
(164548, 'Mifflin Junction', 40.3477783203125, 0.70420157755424, -79.9513931274414, -1.39541505163022, 218, 45, 'PPL', 'P'),
(14236, 'Mifflin Meadows', 39.0883293151855, 0.682220045653808, -75.5475006103516, -1.31855262730306, 218, 10, 'PPL', 'P'),
(164553, 'Mifflinburg', 40.9174995422363, 0.714145088695296, -77.0480575561523, -1.34474228662095, 218, 45, 'PPL', 'P'),
(164555, 'Mifflintown', 40.5697212219238, 0.708075211938788, -77.397216796875, -1.35083626498533, 218, 45, 'PPL', 'P'),
(156490, 'Mifflinville', 40.0352783203125, 0.698747423641758, -82.9530563354492, -1.44780395764593, 218, 41, 'PPL', 'P'),
(164557, 'Mifflinville', 41.0322189331055, 0.716147319781845, -76.3083267211914, -1.33183154797236, 218, 45, 'PPL', 'P'),
(4203, 'Miflin', 30.3702793121338, 0.530061368747053, -87.6108322143555, -1.52909748255282, 218, 2, 'PPL', 'P'),
(142417, 'Mignery Ranch', 41.9494400024414, 0.732155847410421, -98.440559387207, -1.71811187881177, 218, 35, 'PPL', 'P'),
(42, 'Miguel', 28.9233303070068, 0.504807344499132, -98.8202819824219, -1.72473928834249, 218, 51, 'PPL', 'P'),
(96206, 'Miguel Barrera Colonia', 26.4120006561279, 0.460976373488335, -98.9209976196289, -1.72649710782, 218, 51, 'PPL', 'P'),
(96207, 'Miguel Garza Colonia', 26.5540008544922, 0.463454744488276, -99.1330032348633, -1.73019730383855, 218, 51, 'PPL', 'P'),
(42088, 'Migues', 29.9624996185303, 0.522944270470898, -91.8658294677734, -1.60336119428828, 218, 22, 'PPL', 'P'),
(132094, 'Mikado', 44.5908317565918, 0.778256830355374, -83.4227828979492, -1.45600223274563, 218, 27, 'PPL', 'P'),
(175310, 'Mikana', 45.5919418334961, 0.795729497372247, -91.6011123657227, -1.59874100927115, 218, 57, 'PPL', 'P'),
(125420, 'Mikas Pond', 41.2833290100098, 0.720530017408762, -70.1036071777344, -1.22353876277619, 218, 23, 'PPL', 'P'),
(17126, 'Mikasuki (historical)', 30.6333293914795, 0.534652458729268, -83.9833297729492, -1.46578562132615, 218, 12, 'PPL', 'P'),
(56246, 'Mike', 39.5963897705078, 0.691087373398363, -92.9572219848633, -1.62240958714312, 218, 29, 'PPL', 'P'),
(197043, 'Mike Horse (historical)', 47.0263900756836, 0.820765342147864, -112.359718322754, -1.96104703134546, 218, 31, 'PPL', 'P'),
(37194, 'Mikegrady', 37.3394393920898, 0.651696158240838, -82.3125, -1.43662414054783, 218, 21, 'PPL', 'P'),
(96208, 'Mikes Colonia', 26.3150005340576, 0.459283401983372, -98.6330032348633, -1.72147065757858, 218, 51, 'PPL', 'P'),
(142418, 'Mikes Meadows', 41.8666687011719, 0.730711215677107, -99.2666702270508, -1.73253023295346, 218, 35, 'PPL', 'P'),
(197044, 'Mikesell Trailer Court', 46.5444412231445, 0.812353747844849, -110.908332824707, -1.93571557568884, 218, 31, 'PPL', 'P'),
(96209, 'Mikeska', 28.2855606079102, 0.493676163380441, -98.0491714477539, -1.71128087061572, 218, 51, 'PPL', 'P'),
(17127, 'Mikesville', 29.9463901519775, 0.522663107238813, -82.6022186279297, -1.44168068450957, 218, 12, 'PPL', 'P'),
(201228, 'Mikkalo', 45.4711112976074, 0.793620606684041, -120.233612060547, -2.09847240202211, 218, 43, 'PPL', 'P'),
(60887, 'Mikoma', 33.9502792358398, 0.59254415463687, -90.2838897705078, -1.57575113800299, 218, 30, 'PPL', 'P'),
(183268, 'Mikon', 38.5875015258789, 0.673478951744923, -121.537216186523, -2.12122458616298, 218, 6, 'PPL', 'P'),
(49475, 'Mikules Manor', 39.708610534668, 0.693045995222062, -76.7675018310547, -1.33984566548268, 218, 25, 'PPL', 'P'),
(104248, 'Mila', 37.8422203063965, 0.660471340611676, -76.3277816772461, -1.33217110101134, 218, 53, 'PPL', 'P'),
(96210, 'Mila Doce', 26.225830078125, 0.457727083931843, -97.958610534668, -1.70970028450876, 218, 51, 'PPL', 'P'),
(136866, 'Milaca', 45.7558288574219, 0.798589865541047, -93.654167175293, -1.63457357542206, 218, 28, 'PPL', 'P'),
(189036, 'Milagro', 34.9383316040039, 0.60978892164346, -105.238609313965, -1.83676023274866, 218, 38, 'PPL', 'P'),
(96211, 'Milagro Estates Colonia', 26.173999786377, 0.45682247468857, -98.1360015869141, -1.71279634243403, 218, 51, 'PPL', 'P'),
(96212, 'Milam', 31.4322204589844, 0.548595738222001, -93.8455581665039, -1.63791397837735, 218, 51, 'PPL', 'P'),
(110438, 'Milam', 38.8138885498047, 0.677430150696219, -79.0994415283203, -1.38054569115793, 218, 58, 'PPL', 'P'),
(42090, 'Milams', 32.1166687011719, 0.56054161360766, -92.6852798461914, -1.61766330144838, 218, 22, 'PPL', 'P'),
(23084, 'Milan', 32.017219543457, 0.558805898367201, -83.0627822875977, -1.44971903678581, 218, 13, 'PPL', 'P'),
(30507, 'Milan', 39.1211090087891, 0.682792159234984, -85.1313934326172, -1.48582311220985, 218, 19, 'PPL', 'P'),
(33276, 'Milan', 37.2597198486328, 0.650304789729326, -97.6736068725586, -1.70472603222471, 218, 20, 'PPL', 'P'),
(89023, 'Milan', 35.9197196960449, 0.626917375089441, -88.7588882446289, -1.54913484027846, 218, 50, 'PPL', 'P'),
(120623, 'Milan', 41.4530601501465, 0.723492384647311, -90.5719375610352, -1.58077852035079, 218, 18, 'PPL', 'P'),
(132098, 'Milan', 42.0852813720703, 0.734526726570864, -83.682502746582, -1.46053519923705, 218, 27, 'PPL', 'P'),
(136869, 'Milan', 45.1086082458496, 0.787293734882339, -95.9130630493164, -1.67399874588348, 218, 28, 'PPL', 'P'),
(139327, 'Milan', 40.202220916748, 0.701661121611387, -93.125, -1.62533786591972, 218, 29, 'PPL', 'P'),
(144147, 'Milan', 44.5733299255371, 0.777951365778341, -71.1855621337891, -1.24242243911762, 218, 36, 'PPL', 'P'),
(150731, 'Milan', 41.9533309936523, 0.732223758018218, -73.7925033569336, -1.28792214686746, 218, 40, 'PPL', 'P'),
(156491, 'Milan', 41.2975006103516, 0.720777358495003, -82.6055603027344, -1.44173900773744, 218, 41, 'PPL', 'P'),
(164558, 'Milan', 41.9075012207031, 0.731423877584812, -76.5236129760742, -1.33558900195435, 218, 45, 'PPL', 'P'),
(175311, 'Milan', 44.9811096191406, 0.785068464054496, -90.179443359375, -1.57392820423683, 218, 57, 'PPL', 'P'),
(189037, 'Milan', 35.1697196960449, 0.613827405699483, -107.890281677246, -1.88304064617205, 218, 38, 'PPL', 'P'),
(208126, 'Milan', 47.9669418334961, 0.837181067107112, -117.330558776855, -2.04780456386086, 218, 56, 'PPL', 'P'),
(4205, 'Milan (historical)', 34.9102783203125, 0.609299299477049, -86.1672210693359, -1.50390171495374, 218, 2, 'PPL', 'P'),
(123198, 'Milan Center', 41.1441688537598, 0.718101214494609, -84.9461135864258, -1.48258936885622, 218, 19, 'PPL', 'P'),
(96213, 'Milano', 30.7102794647217, 0.535995490866995, -96.8630599975586, -1.69057932051421, 218, 51, 'PPL', 'P'),
(164559, 'Milanville', 41.6713905334473, 0.727302968693051, -75.065559387207, -1.3101411661581, 218, 45, 'PPL', 'P'),
(104246, 'Milbank', 38.189998626709, 0.666541217368185, -77.1997222900391, -1.34738933558644, 218, 53, 'PPL', 'P'),
(170874, 'Milbank', 45.2191696166992, 0.789223394829184, -96.6352767944336, -1.68660375363894, 218, 49, 'PPL', 'P'),
(170875, 'Milbank Subdivision', 45.2227783203125, 0.789286378588964, -96.6052780151367, -1.68608017616863, 218, 49, 'PPL', 'P'),
(164560, 'Milbell', 40.2188911437988, 0.701952071960478, -79.709716796875, -1.3911970039377, 218, 45, 'PPL', 'P'),
(33277, 'Milberger', 38.7119407653809, 0.67565082619291, -98.9119415283203, -1.7263390492093, 218, 20, 'PPL', 'P'),
(128135, 'Milbridge', 44.5352783203125, 0.777287239981503, -67.8813934326172, -1.18475381624083, 218, 26, 'PPL', 'P'),
(164561, 'Milbrook', 40.0783309936523, 0.699498834543324, -74.9749984741211, -1.30856058005114, 218, 45, 'PPL', 'P'),
(37195, 'Milburn', 36.7986106872559, 0.642256916652188, -88.8997192382813, -1.55159280480655, 218, 21, 'PPL', 'P'),
(42091, 'Milburn', 30.8675003051758, 0.538739512185672, -92.211669921875, -1.60939724889894, 218, 22, 'PPL', 'P'),
(76604, 'Milburn', 34.2408294677734, 0.597615212826544, -96.5488891601563, -1.68509600498779, 218, 42, 'PPL', 'P'),
(96214, 'Milburn', 31.4375, 0.548687883595717, -99.1094436645508, -1.72978611176625, 218, 51, 'PPL', 'P'),
(110439, 'Milburn', 37.9983291625977, 0.663195954143909, -81.3388900756836, -1.41963144173842, 218, 58, 'PPL', 'P'),
(142419, 'Milburn', 41.7194404602051, 0.728141598120317, -99.730827331543, -1.74063130267338, 218, 35, 'PPL', 'P'),
(150733, 'Milburn', 41.5016708374023, 0.724340801191583, -74.3455581665039, -1.29757477423845, 218, 40, 'PPL', 'P'),
(192697, 'Milburn', 39.7041702270508, 0.692968497234341, -111.424171447754, -1.94471865806996, 218, 52, 'PPL', 'P'),
(49476, 'Milburn Landing', 38.1247215270996, 0.665401917053849, -75.4902801513672, -1.31755394189428, 218, 25, 'PPL', 'P'),
(49477, 'Milburn on the Magothy', 39.1055603027344, 0.682520783119905, -76.4499969482422, -1.33430415988644, 218, 25, 'PPL', 'P'),
(66821, 'Milburnie', 35.7958297729492, 0.624755088021378, -78.5347213745117, -1.3706894651216, 218, 33, 'PPL', 'P'),
(89025, 'Milburnton', 36.3113899230957, 0.633753310133511, -82.6452789306641, -1.44243222856919, 218, 50, 'PPL', 'P'),
(82395, 'Milbury', 32.9241714477539, 0.574635195254414, -81.4302825927734, -1.42122654207332, 218, 48, 'PPL', 'P'),
(17129, 'Mildred', 27.2830600738525, 0.476179228308134, -80.932502746582, -1.41253864480721, 218, 12, 'PPL', 'P'),
(27899, 'Mildred', 39.7625007629395, 0.693986557140051, -89.6341705322266, -1.56441139808143, 218, 18, 'PPL', 'P'),
(33278, 'Mildred', 38.023609161377, 0.663637173357508, -95.1708297729492, -1.66104433139301, 218, 20, 'PPL', 'P'),
(37196, 'Mildred', 37.353889465332, 0.651948359596068, -83.9274978637695, -1.46481117068329, 218, 21, 'PPL', 'P'),
(56247, 'Mildred', 36.6369400024414, 0.639435230898222, -93.0991668701172, -1.62488699274717, 218, 29, 'PPL', 'P'),
(60888, 'Mildred', 31.1477794647217, 0.54363130634447, -89.8419418334961, -1.56803769137974, 218, 30, 'PPL', 'P'),
(66822, 'Mildred', 35.848331451416, 0.625671415173447, -77.4908294677734, -1.35247011431409, 218, 33, 'PPL', 'P'),
(96216, 'Mildred', 32.0349998474121, 0.559116223213222, -96.3766708374023, -1.68209022822347, 218, 51, 'PPL', 'P'),
(136871, 'Mildred', 46.7550010681152, 0.816028710412076, -94.4644393920898, -1.6487154934426, 218, 28, 'PPL', 'P'),
(164562, 'Mildred', 41.4780616760254, 0.723928743591921, -76.3786087036133, -1.33305819997045, 218, 45, 'PPL', 'P'),
(197045, 'Mildred', 46.6758308410645, 0.814646929280489, -104.959442138672, -1.8318878463763, 218, 31, 'PPL', 'P'),
(104247, 'Mildred Crossing', 38.0419387817383, 0.663957085583453, -78.0458297729492, -1.36215669698898, 218, 53, 'PPL', 'P'),
(96217, 'Mile 10 North at Mile 5 West Colonia', 26.2000007629395, 0.45727627733832, -97.9940032958984, -1.7103180047236, 218, 51, 'PPL', 'P'),
(183269, 'Mile High', 34.4127807617188, 0.600616329058954, -117.773063659668, -2.05552773102209, 218, 6, 'PPL', 'P'),
(191882, 'Mile High', 31.271110534668, 0.54578383958504, -105.41194152832, -1.83978545058893, 218, 51, 'PPL', 'P'),
(145754, 'Mile Hollow', 40.160831451416, 0.700938739165703, -74.7002792358398, -1.30376582482456, 218, 37, 'PPL', 'P'),
(150734, 'Mile of Woods', 43.0566711425781, 0.751480676386417, -77.6977767944336, -1.35608202654251, 218, 40, 'PPL', 'P'),
(164563, 'Mile Run', 40.8033294677734, 0.712152444988672, -76.773063659668, -1.33994273770441, 218, 45, 'PPL', 'P'),
(89026, 'Mile Straight', 35.2158317565918, 0.614632212980905, -85.227783203125, -1.48750543107045, 218, 50, 'PPL', 'P'),
(125421, 'Mileoak Corner', 42.107780456543, 0.734919409673596, -72.4372177124023, -1.26426795006538, 218, 23, 'PPL', 'P'),
(42094, 'Miles', 30.1391696929932, 0.526027744960019, -91.0852813720703, -1.58973806004809, 218, 22, 'PPL', 'P'),
(66823, 'Miles', 36.086109161377, 0.629821419100118, -79.2266693115234, -1.38276623487483, 218, 33, 'PPL', 'P'),
(110440, 'Miles', 38.7558288574219, 0.676416817901444, -79.1272201538086, -1.38103051963437, 218, 58, 'PPL', 'P'),
(116845, 'Miles', 42.0483283996582, 0.733881775533874, -90.315559387207, -1.57630387708723, 218, 16, 'PPL', 'P'),
(156493, 'Miles', 41.4491691589355, 0.723424474039514, -81.60888671875, -1.42434377212926, 218, 41, 'PPL', 'P'),
(175312, 'Miles', 45.2272186279297, 0.789363876576685, -87.728889465332, -1.53115797028821, 218, 57, 'PPL', 'P'),
(183270, 'Miles', 35.1855583190918, 0.614103841820633, -120.702217102051, -2.10665110288779, 218, 6, 'PPL', 'P'),
(191883, 'Miles', 31.5972194671631, 0.551475514177244, -100.181938171387, -1.74850467212009, 218, 51, 'PPL', 'P'),
(208128, 'Miles', 47.910831451416, 0.836201756195263, -118.291389465332, -2.06457422292898, 218, 56, 'PPL', 'P'),
(125422, 'Miles Bridge', 41.7722206115723, 0.729062785541375, -71.283332824707, -1.24412885958609, 218, 23, 'PPL', 'P'),
(17131, 'Miles City', 26.1538906097412, 0.456471503346411, -81.3447189331055, -1.41973317449206, 218, 12, 'PPL', 'P'),
(197046, 'Miles City', 46.4083290100098, 0.809978141573471, -105.839996337891, -1.84725641639493, 218, 31, 'PPL', 'P'),
(49479, 'Miles Corner', 39.2472190856934, 0.684993195296908, -77.2961120605469, -1.34907165444704, 218, 25, 'PPL', 'P'),
(128137, 'Miles Corner', 44.857780456543, 0.78291596410344, -69.3005599975586, -1.20952294543327, 218, 26, 'PPL', 'P'),
(197048, 'Miles Crossing', 48.4816703796387, 0.846164774991304, -107.151107788086, -1.87013962806144, 218, 31, 'PPL', 'P'),
(201229, 'Miles Crossing', 46.1525001525879, 0.805513085689844, -123.838333129883, -2.16138665329803, 218, 43, 'PPL', 'P'),
(66824, 'Miles Crossroad', 35.9466705322266, 0.627387755916976, -79.8880615234375, -1.39430970661978, 218, 33, 'PPL', 'P'),
(89027, 'Miles Crossroads', 36.5424995422363, 0.637786933920545, -85.7386093139648, -1.49642102860976, 218, 50, 'PPL', 'P'),
(178645, 'Miles Manor', 31.5583305358887, 0.550796774283924, -110.339172363281, -1.92578185166479, 218, 5, 'PPL', 'P'),
(30508, 'Miles Point', 38.5686111450195, 0.673149252401971, -85.4230575561523, -1.49091361147548, 218, 19, 'PPL', 'P'),
(112899, 'Miles Point', 39.2311096191406, 0.684712032064823, -93.6991729736328, -1.63535907478558, 218, 29, 'PPL', 'P'),
(172250, 'Miles Pond', 44.4472198486328, 0.775750329716418, -71.7969436645508, -1.25309305981529, 218, 55, 'PPL', 'P'),
(125423, 'Miles Standish Park', 42.0133285522461, 0.733270912958837, -70.7061080932617, -1.23405438749843, 218, 23, 'PPL', 'P'),
(27900, 'Miles Station', 39.0694389343262, 0.681890346310856, -90.1072235107422, -1.5726677300929, 218, 18, 'PPL', 'P'),
(164564, 'Milesburg', 40.9416694641113, 0.714566933411965, -77.7852783203125, -1.35760921626962, 218, 45, 'PPL', 'P'),
(150735, 'Mileses', 41.8363914489746, 0.730182777937808, -75.0663909912109, -1.31015568038604, 218, 40, 'PPL', 'P'),
(60889, 'Mileston', 33.110279083252, 0.577883386256956, -90.2733306884766, -1.57556684725556, 218, 30, 'PPL', 'P'),
(42093, 'Mileston Forks', 31.6591701507568, 0.552556757579816, -91.4166717529297, -1.59552191330352, 218, 22, 'PPL', 'P'),
(49480, 'Milestone', 39.2083282470703, 0.684314422114074, -77.2494430541992, -1.34825712662764, 218, 25, 'PPL', 'P'),
(104249, 'Milestone', 37.7680587768555, 0.65917697774287, -76.4466705322266, -1.33424610297468, 218, 53, 'PPL', 'P'),
(113711, 'Milestone Corner', 41.5149993896484, 0.724573428312802, -72.2752838134766, -1.26144167035853, 218, 8, 'PPL', 'P'),
(49481, 'Milestone Manor', 39.4736099243164, 0.688944460827231, -76.6388931274414, -1.33760102015791, 218, 25, 'PPL', 'P'),
(49482, 'Milestown', 38.2872200012207, 0.668238050456729, -76.7738876342773, -1.3399571187743, 218, 25, 'PPL', 'P'),
(202378, 'Milesville', 44.4580612182617, 0.775939547311868, -101.678886413574, -1.7746313476782, 218, 49, 'PPL', 'P'),
(208127, 'Mileta', 47.3894386291504, 0.827101734750462, -122.425827026367, -2.13673377108717, 218, 56, 'PPL', 'P'),
(110441, 'Miletus', 39.2305603027344, 0.684702444684898, -80.5888900756836, -1.40654147234846, 218, 58, 'PPL', 'P'),
(82396, 'Miley', 32.9477806091309, 0.575047252854076, -81.0319366455078, -1.41427409373156, 218, 48, 'PPL', 'P'),
(183271, 'Miley', 36.6222190856934, 0.639178302432057, -119.546112060547, -2.08647326341465, 218, 6, 'PPL', 'P'),
(156494, 'Miley Crossroads', 40.6241683959961, 0.709025494394755, -82.0880584716797, -1.43270689690044, 218, 41, 'PPL', 'P'),
(76605, 'Milfay', 35.7550010681152, 0.6240424926927, -96.565559387207, -1.68538695533688, 218, 42, 'PPL', 'P'),
(10480, 'Milford', 33.9186096191406, 0.591991415552624, -94.0852813720703, -1.64209793760792, 218, 4, 'PPL', 'P'),
(14232, 'Milford', 38.9124984741211, 0.679151218550683, -75.4283294677734, -1.31647269849171, 218, 10, 'PPL', 'P'),
(23086, 'Milford', 33.8808288574219, 0.59133201686672, -84.5977783203125, -1.47650977156173, 218, 13, 'PPL', 'P'),
(33279, 'Milford', 39.1683311462402, 0.683616341013337, -96.9122161865234, -1.69143725785938, 218, 20, 'PPL', 'P'),
(37197, 'Milford', 38.5816688537598, 0.673377152412254, -84.1566696166992, -1.46881097232448, 218, 21, 'PPL', 'P'),
(49483, 'Milford', 39.3477783203125, 0.686748285034297, -76.7413864135742, -1.33938986546211, 218, 25, 'PPL', 'P'),
(56249, 'Milford', 39.4069404602051, 0.687780859167948, -93.3688888549805, -1.62959452944805, 218, 29, 'PPL', 'P'),
(73467, 'Milford', 39.1752815246582, 0.68373764800099, -84.2944412231445, -1.47121554047271, 218, 41, 'PPL', 'P'),
(82398, 'Milford', 33.746940612793, 0.58899522616823, -80.533332824707, -1.40557181539556, 218, 48, 'PPL', 'P'),
(96218, 'Milford', 32.124439239502, 0.560677235086172, -96.9449996948242, -1.69200943801958, 218, 51, 'PPL', 'P'),
(104250, 'Milford', 38.0230598449707, 0.663627585977583, -77.3736114501953, -1.35042427396469, 218, 53, 'PPL', 'P'),
(113712, 'Milford', 41.2222213745117, 0.719463487971212, -73.0569381713867, -1.27508411251662, 218, 8, 'PPL', 'P'),
(116846, 'Milford', 43.3247184753418, 0.756158984894332, -95.1497192382813, -1.6606758830562, 218, 16, 'PPL', 'P'),
(120625, 'Milford', 40.6283302307129, 0.709098132113487, -87.6961135864258, -1.53058592328606, 218, 18, 'PPL', 'P'),
(123200, 'Milford', 41.4097213745117, 0.722735980318701, -85.8455581665039, -1.4982876382178, 218, 19, 'PPL', 'P'),
(125424, 'Milford', 42.139720916748, 0.735476875868777, -71.5166702270508, -1.24820136552504, 218, 23, 'PPL', 'P'),
(128138, 'Milford', 44.9461097717285, 0.78445760147946, -68.6444396972656, -1.19807148590398, 218, 26, 'PPL', 'P'),
(132100, 'Milford', 42.5936088562012, 0.743398714847326, -83.5994415283203, -1.45908550749767, 218, 27, 'PPL', 'P'),
(142422, 'Milford', 40.7744407653809, 0.711648242015293, -97.0502777099609, -1.69384688601368, 218, 35, 'PPL', 'P'),
(144150, 'Milford', 42.8352813720703, 0.747616695960821, -71.6494369506836, -1.25051858198951, 218, 36, 'PPL', 'P'),
(145755, 'Milford', 40.5686111450195, 0.708055837441858, -75.0950012207031, -1.31065502309043, 218, 37, 'PPL', 'P'),
(150736, 'Milford', 42.5905609130859, 0.743345518204552, -74.945556640625, -1.30804672311881, 218, 40, 'PPL', 'P'),
(164566, 'Milford', 41.3222198486328, 0.721208790591595, -74.8027801513672, -1.30555480328682, 218, 45, 'PPL', 'P'),
(175313, 'Milford', 43.100830078125, 0.752251395205886, -88.8466720581055, -1.55066695685359, 218, 57, 'PPL', 'P'),
(192698, 'Milford', 38.3969383239746, 0.67015299643855, -113.01000213623, -1.97239662496305, 218, 52, 'PPL', 'P'),
(193787, 'Milford', 40.1713905334473, 0.701123029913136, -120.371391296387, -2.10087710332839, 218, 6, 'PPL', 'P'),
(209605, 'Milford', 42.8763885498047, 0.748334151558488, -108.78360748291, -1.89863212277392, 218, 59, 'PPL', 'P'),
(42095, 'Milford (historical)', 31.2563896179199, 0.545526911118875, -92.7055587768555, -1.61801723555726, 218, 22, 'PPL', 'P'),
(150737, 'Milford Center', 42.524169921875, 0.742186776814259, -74.9891662597656, -1.30880785455835, 218, 40, 'PPL', 'P'),
(156495, 'Milford Center', 40.1786117553711, 0.701249064011724, -83.4355621337891, -1.45622527248692, 218, 41, 'PPL', 'P'),
(197049, 'Milford Colony', 47.329719543457, 0.826059440078833, -112.208892822266, -1.95841462976597, 218, 31, 'PPL', 'P'),
(14233, 'Milford Crossroads', 39.7155609130859, 0.693167302209715, -75.7411117553711, -1.32193177925221, 218, 10, 'PPL', 'P'),
(123201, 'Milford Junction', 41.4283294677734, 0.723060752813637, -85.8419418334961, -1.49822452129996, 218, 19, 'PPL', 'P'),
(113713, 'Milford Lawns', 41.2247200012207, 0.719507097234062, -73.008056640625, -1.27423096886142, 218, 8, 'PPL', 'P'),
(14235, 'Milford Meadows', 39.7063903808594, 0.693007246228201, -75.7291717529297, -1.32172338689691, 218, 10, 'PPL', 'P'),
(49484, 'Milford Mill', 39.3477783203125, 0.686748285034297, -76.7702789306641, -1.33989413501452, 218, 25, 'PPL', 'P'),
(164567, 'Milford Mills', 40.064998626709, 0.699266140843078, -75.7286071777344, -1.32171353320088, 218, 45, 'PPL', 'P'),
(164568, 'Milford Park', 40.4777793884277, 0.706470524223961, -75.5277786254883, -1.31820841373217, 218, 45, 'PPL', 'P'),
(164569, 'Milford Square', 40.436939239502, 0.705757729158201, -75.399169921875, -1.31596376840739, 218, 45, 'PPL', 'P'),
(156498, 'Milfordton', 40.3108291625977, 0.703556693096278, -82.600830078125, -1.44165644974365, 218, 41, 'PPL', 'P'),
(78744, 'Milfred Terrace', 39.9908294677734, 0.697971644816218, -80.0027770996094, -1.3963118711273, 218, 45, 'PPL', 'P'),
(42096, 'Milhaven Estates', 32.517219543457, 0.567532544627173, -91.9947204589844, -1.60561076646107, 218, 22, 'PPL', 'P'),
(210694, 'Mililani Town', 21.4500007629395, 0.374373137868589, -158.001113891602, -2.757639659227, 218, 15, 'PPL', 'P'),
(4206, 'Military Bridge Landing', 30.7000007629395, 0.535816093678065, -87.9024963378906, -1.53418798181845, 218, 2, 'PPL', 'P'),
(96219, 'Military Crossing', 31.4472198486328, 0.548857526957155, -99.2813873291016, -1.7327870948406, 218, 51, 'PPL', 'P'),
(17132, 'Military Park', 26.7161102294922, 0.466284086830377, -80.1130599975586, -1.39823667080516, 218, 12, 'PPL', 'P'),
(4207, 'Milk Springs', 34.6758308410645, 0.605207419041169, -87.7130584716797, -1.53088166732512, 218, 2, 'PPL', 'P'),
(178646, 'Milkwater', 36.0527801513672, 0.629239718139017, -109.110000610352, -1.90432875750366, 218, 5, 'PPL', 'P'),
(42097, 'Mill', 32.122501373291, 0.560643412940328, -92.8427810668945, -1.62041221632556, 218, 22, 'PPL', 'P'),
(56251, 'Mill', 37.8894386291504, 0.661295455811001, -90.3466720581055, -1.5768468956335, 218, 29, 'PPL', 'P'),
(4208, 'Mill (historical)', 33.9063911437988, 0.591778162928336, -86.3949966430664, -1.50787714867096, 218, 2, 'PPL', 'P'),
(208129, 'Mill A', 45.7569389343262, 0.798609240037977, -121.649169921875, -2.12317854745477, 218, 56, 'PPL', 'P'),
(177246, 'Mill Acres', 40.0325012207031, 0.698698954109919, -80.6566696166992, -1.40772444850467, 218, 58, 'PPL', 'P'),
(49485, 'Mill Bottom', 39.3583297729492, 0.686932442623676, -77.1833267211914, -1.34710317892731, 218, 25, 'PPL', 'P'),
(112460, 'Mill Branch', 34.0402793884277, 0.594114953626826, -78.4733276367188, -1.369617942257, 218, 33, 'PPL', 'P'),
(112547, 'Mill Branch', 34.0647201538086, 0.594541525454429, -79.5513916015625, -1.38843370799063, 218, 48, 'PPL', 'P'),
(104252, 'Mill Branch (historical)', 36.8122215270996, 0.642494470621423, -82.9580612182617, -1.44789130932969, 218, 53, 'PPL', 'P'),
(49486, 'Mill Branch Estates', 38.6583290100098, 0.67471512454391, -76.6522216796875, -1.33783364727913, 218, 25, 'PPL', 'P'),
(66830, 'Mill Bridge', 35.646671295166, 0.622151781476798, -80.6374969482422, -1.40738982231371, 218, 33, 'PPL', 'P'),
(66828, 'Mill Brook', 36.1536102294922, 0.630999534987341, -80.3783264160156, -1.40286644320221, 218, 33, 'PPL', 'P'),
(89028, 'Mill Brook', 36.2661094665527, 0.63296301708003, -82.6272201538086, -1.44211704345418, 218, 50, 'PPL', 'P'),
(113715, 'Mill Brook', 41.9633293151855, 0.732398261648645, -73.120002746582, -1.27618479699515, 218, 8, 'PPL', 'P'),
(128140, 'Mill Brook', 45.371940612793, 0.791889751712571, -69.022216796875, -1.2046649401308, 218, 26, 'PPL', 'P'),
(145757, 'Mill Brook', 40.8644409179688, 0.713219041005249, -74.5577774047852, -1.30127869868253, 218, 37, 'PPL', 'P'),
(49487, 'Mill Brothers Hills', 39.6044387817383, 0.691227855145865, -77.1149978637695, -1.34591061539117, 218, 25, 'PPL', 'P'),
(201231, 'Mill Camp', 43.7958297729492, 0.764381428180924, -123.226387023926, -2.15070617890432, 218, 43, 'PPL', 'P'),
(175315, 'Mill Center', 44.5880584716797, 0.778208427402561, -88.1605606079102, -1.53869205301205, 218, 57, 'PPL', 'P'),
(164576, 'Mill City', 41.4958305358887, 0.72423886870086, -75.8363876342773, -1.32359465703685, 218, 45, 'PPL', 'P'),
(200071, 'Mill City', 40.6836090087891, 0.710062928797396, -118.069442749023, -2.0607005219654, 218, 39, 'PPL', 'P'),
(201230, 'Mill City', 44.7541694641113, 0.781107611144249, -122.476936340332, -2.13762579689429, 218, 43, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(164577, 'Mill City (historical)', 41.3980598449707, 0.722532448232392, -75.9794387817383, -1.3260913705588, 218, 45, 'PPL', 'P'),
(183272, 'Mill City (historical)', 37.6227798461914, 0.656641382069006, -118.991386413574, -2.07679147442972, 218, 6, 'PPL', 'P'),
(66829, 'Mill Corner', 35.3352813720703, 0.616717002061246, -82.3544387817383, -1.43735611037344, 218, 33, 'PPL', 'P'),
(49488, 'Mill Cove Manor', 38.3188896179199, 0.668790789540975, -76.5069427490234, -1.33529805160526, 218, 25, 'PPL', 'P'),
(10483, 'Mill Creek', 35.339168548584, 0.616784846090016, -94.4227828979492, -1.64798845046501, 218, 4, 'PPL', 'P'),
(14237, 'Mill Creek', 39.7847213745117, 0.694374379973793, -75.7052764892578, -1.3213063358702, 218, 10, 'PPL', 'P'),
(27901, 'Mill Creek', 37.3416709899902, 0.65173510697178, -89.2525024414063, -1.55775003324682, 218, 18, 'PPL', 'P'),
(49489, 'Mill Creek', 38.8905601501465, 0.678768322564956, -76.0824966430664, -1.32789006955904, 218, 25, 'PPL', 'P'),
(66833, 'Mill Creek', 34.7758293151855, 0.606952721661553, -76.7474975585938, -1.33949652506377, 218, 33, 'PPL', 'P'),
(76607, 'Mill Creek', 34.4041709899902, 0.600466060194447, -96.8261108398438, -1.68993443605625, 218, 42, 'PPL', 'P'),
(82399, 'Mill Creek', 33.4461097717285, 0.583744737500112, -80.4011077880859, -1.40326405315296, 218, 48, 'PPL', 'P'),
(89034, 'Mill Creek', 36.1133308410645, 0.630296527038588, -85.3638916015625, -1.4898809707628, 218, 50, 'PPL', 'P'),
(96220, 'Mill Creek', 30.1552791595459, 0.526308908192104, -96.4930572509766, -1.68412155434493, 218, 51, 'PPL', 'P'),
(104257, 'Mill Creek', 37.1308288574219, 0.648055217556536, -82.5858306884766, -1.44139466100849, 218, 53, 'PPL', 'P'),
(110442, 'Mill Creek', 38.7313919067383, 0.675990312652868, -79.9702835083008, -1.39574475097317, 218, 58, 'PPL', 'P'),
(112274, 'Mill Creek', 34.3600006103516, 0.599695141637896, -83.8586120605469, -1.46360888660917, 218, 13, 'PPL', 'P'),
(112439, 'Mill Creek', 31.6933307647705, 0.553152972768858, -88.9608306884766, -1.55265940082313, 218, 30, 'PPL', 'P'),
(164580, 'Mill Creek', 41.8813896179199, 0.730968144143273, -77.1263885498047, -1.34610942036655, 218, 45, 'PPL', 'P'),
(193788, 'Mill Creek', 40.3263893127441, 0.703828268948439, -121.521667480469, -2.1209532100479, 218, 6, 'PPL', 'P'),
(197050, 'Mill Creek', 46.1005592346191, 0.804606545654781, -112.883331298828, -1.97018580178412, 218, 31, 'PPL', 'P'),
(208130, 'Mill Creek', 47.860279083252, 0.83531945092612, -122.203056335449, -2.1328456890537, 218, 56, 'PPL', 'P'),
(23091, 'Mill Creek (historical)', 32.4366683959961, 0.56612666188772, -81.6802825927734, -1.42558986520331, 218, 13, 'PPL', 'P'),
(89035, 'Mill Creek (historical)', 36.0724983215332, 0.629583865130882, -84.9902801513672, -1.48336022083374, 218, 50, 'PPL', 'P'),
(175316, 'Mill Creek (historical)', 43.3866691589355, 0.757240228296904, -90.5483322143555, -1.58036652933015, 218, 57, 'PPL', 'P'),
(175317, 'Mill Creek Community', 44.5402793884277, 0.77737452508623, -89.6774978637695, -1.56516760267296, 218, 57, 'PPL', 'P'),
(164581, 'Mill Creek Corner', 40.5588912963867, 0.70788619408042, -75.7486114501953, -1.32206267361978, 218, 45, 'PPL', 'P'),
(23088, 'Mill Creek Crossing', 34.1208305358887, 0.595520836366279, -84.4886093139648, -1.47460441295983, 218, 13, 'PPL', 'P'),
(4209, 'Mill Creek Estates', 33.7241706848145, 0.588597815954563, -87.0094375610352, -1.51860116574849, 218, 2, 'PPL', 'P'),
(82400, 'Mill Creek Estates', 33.9397201538086, 0.592359863889436, -80.9191665649414, -1.41230588452794, 218, 48, 'PPL', 'P'),
(104258, 'Mill Creek Estates', 38.8791694641113, 0.678569517589582, -77.6444396972656, -1.35515111858347, 218, 53, 'PPL', 'P'),
(164582, 'Mill Creek Falls', 40.1338882446289, 0.700468491496222, -74.8747177124023, -1.30681035058274, 218, 45, 'PPL', 'P'),
(14239, 'Mill Creek Manor', 38.7583312988281, 0.676460493743321, -75.1991729736328, -1.31247316316663, 218, 10, 'PPL', 'P'),
(104259, 'Mill Creek Park', 38.8369407653809, 0.677832487757903, -77.225830078125, -1.34784500244895, 218, 53, 'PPL', 'P'),
(23089, 'Mill Creek Place', 33.8236083984375, 0.59033333145794, -84.8069381713867, -1.48016029962596, 218, 13, 'PPL', 'P'),
(190482, 'Mill Creek Settlement (historical)', 39.1786117553711, 0.683795771491781, -119.821937561035, -2.09128732655913, 218, 39, 'PPL', 'P'),
(23090, 'Mill Creek Station', 33.9930610656738, 0.593290838427501, -84.76611328125, -1.47944777087631, 218, 13, 'PPL', 'P'),
(66834, 'Mill Crossroads', 36.2219390869141, 0.632192098523479, -76.668327331543, -1.33811474393218, 218, 33, 'PPL', 'P'),
(104261, 'Mill Farms', 37.1327781677246, 0.648089239439462, -76.4569396972656, -1.33442533371604, 218, 53, 'PPL', 'P'),
(192699, 'Mill Fork', 39.9638900756836, 0.697501463725765, -111.307220458984, -1.94267747825247, 218, 52, 'PPL', 'P'),
(104260, 'Mill Gap', 38.3216705322266, 0.668839325651841, -79.7041702270508, -1.39110019803207, 218, 53, 'PPL', 'P'),
(23093, 'Mill Glen', 33.9666709899902, 0.592830244716972, -84.3352813720703, -1.47192833553847, 218, 13, 'PPL', 'P'),
(49495, 'Mill Green', 39.6630592346191, 0.692250975057646, -76.3252792358398, -1.33212742516947, 218, 25, 'PPL', 'P'),
(49491, 'Mill Green Acres', 39.6572189331055, 0.692149042566923, -76.3033294677734, -1.33174432944666, 218, 25, 'PPL', 'P'),
(66837, 'Mill Grove', 36.0508308410645, 0.629205696256091, -78.9038925170898, -1.37713271706293, 218, 33, 'PPL', 'P'),
(73470, 'Mill Grove', 39.6011085510254, 0.691169731655074, -81.7130584716797, -1.42616191220546, 218, 41, 'PPL', 'P'),
(139329, 'Mill Grove', 40.3091697692871, 0.703527731219423, -93.5933303833008, -1.63351177309545, 218, 29, 'PPL', 'P'),
(150740, 'Mill Grove', 42.0180587768555, 0.733353470952629, -78.3411102294922, -1.36731031317245, 218, 40, 'PPL', 'P'),
(164588, 'Mill Grove', 40.2125015258789, 0.701840552089831, -79.7399978637695, -1.39172550825602, 218, 45, 'PPL', 'P'),
(49492, 'Mill Grove Gardens', 39.1272201538086, 0.682898818836642, -76.9880599975586, -1.34369513168033, 218, 25, 'PPL', 'P'),
(200073, 'Mill Gulch (historical)', 40.311939239502, 0.703576067593208, -116.678886413574, -2.03643073547735, 218, 39, 'PPL', 'P'),
(164589, 'Mill Hall', 41.1072196960449, 0.717456330036647, -77.4847183227539, -1.35236345471243, 218, 45, 'PPL', 'P'),
(113716, 'Mill Hill', 41.1772193908691, 0.71867805518672, -73.1605606079102, -1.2768926652129, 218, 8, 'PPL', 'P'),
(66836, 'Mill Hill (historical)', 35.5200004577637, 0.619940958297869, -80.7197189331055, -1.40882486666709, 218, 33, 'PPL', 'P'),
(49493, 'Mill Hill Estates', 38.6311111450195, 0.674240083184467, -76.9730606079102, -1.34343334294518, 218, 25, 'PPL', 'P'),
(144152, 'Mill Hollow', 43.5533294677734, 0.760148999418516, -72.2658309936523, -1.261276687529, 218, 36, 'PPL', 'P'),
(150741, 'Mill Hook', 41.7958297729492, 0.729474843141038, -74.2474975585938, -1.29586329376391, 218, 40, 'PPL', 'P'),
(197051, 'Mill Iron', 45.8536109924316, 0.800296485746597, -104.218887329102, -1.81896272665782, 218, 31, 'PPL', 'P'),
(164591, 'Mill Lane', 40.0499992370605, 0.699004352107924, -75.5497207641602, -1.31859137629692, 218, 45, 'PPL', 'P'),
(132101, 'Mill Mine Junction', 47.0847206115723, 0.821783402053574, -88.6519393920898, -1.54726823067043, 218, 27, 'PPL', 'P'),
(104262, 'Mill Mountain Estates', 37.2394409179688, 0.649950855620454, -79.9291687011719, -1.39502716221745, 218, 53, 'PPL', 'P'),
(112461, 'Mill Neck', 36.5133285522461, 0.637277804099149, -76.9869384765625, -1.34367555744632, 218, 33, 'PPL', 'P'),
(150742, 'Mill Neck', 40.8869400024414, 0.713611724107981, -73.5555572509766, -1.28378665716873, 218, 40, 'PPL', 'P'),
(189038, 'Mill Place', 33.9402809143066, 0.592369651006442, -107.247497558594, -1.87182194692204, 218, 38, 'PPL', 'P'),
(113719, 'Mill Plain', 41.5550003051758, 0.725271575992566, -73.0130615234375, -1.27431832054517, 218, 8, 'PPL', 'P'),
(208131, 'Mill Plain', 45.6430587768555, 0.796621656337424, -122.492782592773, -2.13790236617349, 218, 56, 'PPL', 'P'),
(89036, 'Mill Point', 36.5774993896484, 0.638397796495581, -82.3602828979492, -1.43745810944319, 218, 50, 'PPL', 'P'),
(110444, 'Mill Point', 38.1580581665039, 0.665983751173004, -80.1811065673828, -1.39942430749328, 218, 58, 'PPL', 'P'),
(49494, 'Mill Point Shores', 38.3369407653809, 0.669105841497931, -76.8333282470703, -1.34099455317694, 218, 25, 'PPL', 'P'),
(37198, 'Mill Pond', 37.2291717529297, 0.649771624879092, -83.7375030517578, -1.46149513565197, 218, 21, 'PPL', 'P'),
(14240, 'Mill Pond Acres', 38.7572212219238, 0.676441119246391, -75.1986083984375, -1.31246330947059, 218, 10, 'PPL', 'P'),
(66838, 'Mill Pond Meadows', 34.8388900756836, 0.608053339561055, -77.4636077880859, -1.35199500637562, 218, 33, 'PPL', 'P'),
(66839, 'Mill Pond Village', 34.8400001525879, 0.608072714057985, -77.4663925170898, -1.35204360906552, 218, 33, 'PPL', 'P'),
(113720, 'Mill Pond Village', 41.920280456543, 0.731646917326107, -72.5397186279297, -1.26605692852764, 218, 8, 'PPL', 'P'),
(23094, 'Mill Ridge', 34.2902793884277, 0.598478276756812, -83.8861083984375, -1.4640887882376, 218, 13, 'PPL', 'P'),
(66840, 'Mill Ridge', 36.1386108398438, 0.630737746252187, -81.7727813720703, -1.42720427345611, 218, 33, 'PPL', 'P'),
(104263, 'Mill Ridge', 38.103328704834, 0.66502854186902, -78.6030578613281, -1.37188216181579, 218, 53, 'PPL', 'P'),
(125427, 'Mill River', 42.5013885498047, 0.74178916686351, -72.6416702270508, -1.26783631960997, 218, 23, 'PPL', 'P'),
(164592, 'Mill Road', 40.0922203063965, 0.699741248781548, -75.3111114501953, -1.31442685814231, 218, 45, 'PPL', 'P'),
(104264, 'Mill Road Park', 37.3038902282715, 0.651075708285876, -80.0302810668945, -1.39679190591379, 218, 53, 'PPL', 'P'),
(156501, 'Mill Rock', 40.7980613708496, 0.712060499352037, -80.591667175293, -1.4065899418803, 218, 41, 'PPL', 'P'),
(49496, 'Mill Run', 38.8891716003418, 0.678744087799037, -75.9622192382813, -1.32579083282979, 218, 25, 'PPL', 'P'),
(73471, 'Mill Run', 39.9505615234375, 0.697268836604546, -81.9966735839844, -1.43111192972359, 218, 41, 'PPL', 'P'),
(89037, 'Mill Run', 36.0849990844727, 0.629802044603187, -83.9000015258789, -1.46433126905485, 218, 50, 'PPL', 'P'),
(104265, 'Mill Run', 38.1619415283203, 0.666051528622746, -78.4791717529297, -1.36971994132675, 218, 53, 'PPL', 'P'),
(164595, 'Mill Run', 40.1833305358887, 0.701331422268435, -75.1033325195313, -1.31080043168595, 218, 45, 'PPL', 'P'),
(110446, 'Mill Run (historical)', 39.014720916748, 0.680935336743954, -79.5469436645508, -1.38835607684485, 218, 58, 'PPL', 'P'),
(14241, 'Mill Run Acres', 38.5508308410645, 0.67283892755595, -75.1091690063477, -1.31090229759764, 218, 10, 'PPL', 'P'),
(104266, 'Mill Run Acres', 38.9791717529297, 0.680314886788993, -77.2847213745117, -1.34887284947167, 218, 53, 'PPL', 'P'),
(49497, 'Mill Run Estates', 39.5180587768555, 0.689720239652771, -76.5652770996094, -1.33631617809, 218, 25, 'PPL', 'P'),
(78746, 'Mill Run Junction', 39.9638900756836, 0.697501463725765, -79.4533309936523, -1.38672222751609, 218, 45, 'PPL', 'P'),
(955, 'Mill Seat', 35.839168548584, 0.625511492349988, -87.2044372558594, -1.52200455246355, 218, 50, 'PPL', 'P'),
(49498, 'Mill Seat', 38.6575012207031, 0.674700676894997, -76.6486129760742, -1.33777066351934, 218, 25, 'PPL', 'P'),
(66841, 'Mill Seat Landing', 35.2963905334473, 0.616038228878413, -76.5849990844727, -1.33666039166089, 218, 33, 'PPL', 'P'),
(27903, 'Mill Shoals', 38.2486114501953, 0.667564204121911, -88.3466720581055, -1.54194031059362, 218, 18, 'PPL', 'P'),
(56253, 'Mill Spring', 37.061939239502, 0.646852866903392, -90.6838912963867, -1.58273248164258, 218, 29, 'PPL', 'P'),
(66842, 'Mill Spring', 35.2975006103516, 0.616057603375343, -82.1613922119141, -1.43398681212033, 218, 33, 'PPL', 'P'),
(89038, 'Mill Spring', 36.1563911437988, 0.631048071098208, -83.5255584716797, -1.45779600489785, 218, 50, 'PPL', 'P'),
(37199, 'Mill Springs', 36.9319381713867, 0.644583920233672, -84.779167175293, -1.47967560430756, 218, 21, 'PPL', 'P'),
(49499, 'Mill Stone Estates', 39.6716690063477, 0.692401243922154, -76.3263931274414, -1.33214686624542, 218, 25, 'PPL', 'P'),
(82401, 'Mill Stone Landing', 32.2861099243164, 0.563498920840139, -81.1194381713867, -1.41580128345867, 218, 48, 'PPL', 'P'),
(49501, 'Mill Stream Hills', 39.7088890075684, 0.693050855491051, -76.8000030517578, -1.34041291879487, 218, 25, 'PPL', 'P'),
(125428, 'Mill Street', 42.2652816772461, 0.737668324550776, -71.8499984741211, -1.25401904092631, 218, 23, 'PPL', 'P'),
(49500, 'Mill Swamp', 38.8844413757324, 0.678661529805244, -76.5688934326172, -1.33637929500783, 218, 25, 'PPL', 'P'),
(60893, 'Mill Town', 32.6355590820313, 0.569597959210584, -90.0325012207031, -1.57136358010708, 218, 30, 'PPL', 'P'),
(89039, 'Mill Town', 36.4722213745117, 0.636560348501481, -85.8786087036133, -1.49886447890991, 218, 50, 'PPL', 'P'),
(96221, 'Mill Town', 30.958610534668, 0.540329685672558, -95.3736114501953, -1.66458353932367, 218, 51, 'PPL', 'P'),
(125429, 'Mill Valley', 42.3555603027344, 0.739243983809721, -72.5208282470703, -1.26572722918468, 218, 23, 'PPL', 'P'),
(183274, 'Mill Valley', 37.9061088562012, 0.661586406160092, -122.543891906738, -2.13879439198061, 218, 6, 'PPL', 'P'),
(4216, 'Mill Village', 34.3380584716797, 0.599312179073143, -86.3144378662109, -1.50647113277345, 218, 2, 'PPL', 'P'),
(104267, 'Mill Village', 36.6155586242676, 0.639062055450475, -78.5441665649414, -1.37085431479307, 218, 53, 'PPL', 'P'),
(125430, 'Mill Village', 42.4333305358887, 0.740601330438307, -72.102783203125, -1.25843096674619, 218, 23, 'PPL', 'P'),
(144154, 'Mill Village', 43.5341682434082, 0.759814572964629, -72.3363876342773, -1.26250813321705, 218, 36, 'PPL', 'P'),
(164596, 'Mill Village', 41.8763885498047, 0.730880859038545, -79.9716720581055, -1.39576898573909, 218, 45, 'PPL', 'P'),
(172254, 'Mill Village', 44.497501373291, 0.776627907874627, -71.6602783203125, -1.25070779958496, 218, 55, 'PPL', 'P'),
(120628, 'Milla', 41.1413917541504, 0.71805274496277, -88.9833297729492, -1.55305208392586, 218, 18, 'PPL', 'P'),
(175318, 'Milladore', 44.6041717529297, 0.778489657213674, -89.8547210693359, -1.56826073112103, 218, 57, 'PPL', 'P'),
(10495, 'Millan (historical)', 35.1069412231445, 0.612731714647997, -93.4005584716797, -1.63014726853229, 218, 4, 'PPL', 'P'),
(183273, 'Millar (historical)', 38.3925018310547, 0.670075565029856, -121.720283508301, -2.1244197136808, 218, 6, 'PPL', 'P'),
(33284, 'Millard', 38.6380615234375, 0.674361390172121, -98.8833312988281, -1.72583970650491, 218, 20, 'PPL', 'P'),
(37202, 'Millard', 37.4077796936035, 0.652888921514057, -82.4383316040039, -1.43882031634077, 218, 21, 'PPL', 'P'),
(60894, 'Millard', 30.7222194671631, 0.536203883222294, -89.5983276367188, -1.56378582154137, 218, 30, 'PPL', 'P'),
(104269, 'Millard', 37.1327781677246, 0.648089239439462, -82.3863906860352, -1.4379137763057, 218, 53, 'PPL', 'P'),
(110447, 'Millard', 38.8786087036133, 0.678559730472576, -81.333610534668, -1.4195392963647, 218, 58, 'PPL', 'P'),
(139328, 'Millard', 40.1072196960449, 0.700003037516703, -92.5458297729492, -1.61522943852816, 218, 29, 'PPL', 'P'),
(142424, 'Millard', 41.2083282470703, 0.71922100715396, -96.1208267211914, -1.67762490602374, 218, 35, 'PPL', 'P'),
(170901, 'Millard', 45.1494407653809, 0.788006396790045, -99.1944427490234, -1.73126962565147, 218, 49, 'PPL', 'P'),
(175321, 'Millard', 42.7344398498535, 0.745856679375415, -88.6213912963867, -1.54673506582019, 218, 57, 'PPL', 'P'),
(204931, 'Millard', 40.6216697692871, 0.708981885131905, -111.836112976074, -1.95190839406485, 218, 52, 'PPL', 'P'),
(142426, 'Millard Mobile Home Park', 41.211109161377, 0.719269543264827, -96.129997253418, -1.67778496200525, 218, 35, 'PPL', 'P'),
(42098, 'Millards', 30.6499996185303, 0.534943409078359, -90.5052795410156, -1.57961511842858, 218, 22, 'PPL', 'P'),
(49502, 'Millards Mill', 38.5777816772461, 0.673309308383485, -77.1108322143555, -1.34583791109341, 218, 25, 'PPL', 'P'),
(164598, 'Millardsville', 40.3813896179199, 0.704788205363358, -76.269172668457, -1.33114818083664, 218, 45, 'PPL', 'P'),
(140506, 'Millarton', 46.6669387817383, 0.814491733567964, -98.7591705322266, -1.72367269232591, 218, 34, 'PPL', 'P'),
(164599, 'Millbach', 40.3325004577637, 0.703934928550096, -76.2383270263672, -1.33060982282229, 218, 45, 'PPL', 'P'),
(164600, 'Millbach Springs', 40.3111114501953, 0.703561619944294, -76.2433319091797, -1.33069717450604, 218, 45, 'PPL', 'P'),
(164601, 'Millbank', 40.2627792358398, 0.702718063669012, -79.2683334350586, -1.38349341101048, 218, 45, 'PPL', 'P'),
(82402, 'Millbank (historical)', 34.2652816772461, 0.598041984391229, -80.5930633544922, -1.40661430980427, 218, 48, 'PPL', 'P'),
(66848, 'Millboro', 35.7997207641602, 0.624822998629175, -79.7483291625977, -1.39187091685154, 218, 33, 'PPL', 'P'),
(112619, 'Millboro', 37.9749984741211, 0.662788756813236, -79.6030578613281, -1.38933545433573, 218, 53, 'PPL', 'P'),
(170879, 'Millboro', 43.0730590820313, 0.751766699887492, -99.9686126708984, -1.7447814397581, 218, 49, 'PPL', 'P'),
(104271, 'Millboro Springs', 37.9958305358887, 0.663152344881059, -79.6230621337891, -1.38968459475464, 218, 53, 'PPL', 'P'),
(78747, 'Millbourne', 39.9633293151855, 0.697491676608759, -75.2505569458008, -1.31336998266371, 218, 45, 'PPL', 'P'),
(183275, 'Millbrae', 37.5986099243164, 0.656219537352337, -122.386108398438, -2.13604055025542, 218, 6, 'PPL', 'P'),
(183276, 'Millbrae Meadows', 37.6022186279297, 0.656282521112118, -122.416107177734, -2.13656412772573, 218, 6, 'PPL', 'P'),
(71120, 'Millbridge', 39.8069381713867, 0.694762136228509, -75.0344390869141, -1.30959801445378, 218, 37, 'PPL', 'P'),
(120629, 'Millbrig (historical)', 42.4775009155273, 0.741372248994858, -90.4044418334961, -1.57785516842221, 218, 18, 'PPL', 'P'),
(4211, 'Millbrook', 32.4797210693359, 0.566878072789286, -86.3619384765625, -1.50730017482079, 218, 2, 'PPL', 'P'),
(49503, 'Millbrook', 39.2713890075684, 0.685415040013576, -76.1527786254883, -1.32911672155713, 218, 25, 'PPL', 'P'),
(56255, 'Millbrook', 38.4991683959961, 0.671937247789876, -92.3563919067383, -1.61192312403483, 218, 29, 'PPL', 'P'),
(66843, 'Millbrook', 35.850830078125, 0.625715024436297, -78.6055603027344, -1.37192583765767, 218, 33, 'PPL', 'P'),
(82403, 'Millbrook', 34.6986083984375, 0.605604962412891, -82.8902816772461, -1.44670833317347, 218, 48, 'PPL', 'P'),
(104272, 'Millbrook', 38.1797218322754, 0.666361853468768, -79.033332824707, -1.37939187661565, 218, 53, 'PPL', 'P'),
(110448, 'Millbrook', 39.2163887023926, 0.684455103598657, -78.5475006103516, -1.37091250486289, 218, 58, 'PPL', 'P'),
(113721, 'Millbrook', 41.3791694641113, 0.72220274888944, -72.8933334350586, -1.27222867119584, 218, 8, 'PPL', 'P'),
(120633, 'Millbrook', 41.598331451416, 0.726027847163121, -88.5527801513672, -1.54553757543604, 218, 18, 'PPL', 'P'),
(125431, 'Millbrook', 42.0486106872559, 0.73388670238189, -70.6875, -1.23372961500349, 218, 23, 'PPL', 'P'),
(132107, 'Millbrook', 43.5486106872559, 0.760066641161805, -85.085563659668, -1.48502323177644, 218, 27, 'PPL', 'P'),
(145758, 'Millbrook', 41.0733299255371, 0.71686484195854, -74.9633331298828, -1.3083569813858, 218, 37, 'PPL', 'P'),
(150744, 'Millbrook', 41.7849998474121, 0.72928582528267, -73.6944427490234, -1.28621066639292, 218, 40, 'PPL', 'P'),
(156503, 'Millbrook', 40.7272186279297, 0.71082406023694, -82.0083312988281, -1.43131539523087, 218, 41, 'PPL', 'P'),
(164602, 'Millbrook', 41.2486114501953, 0.719924081681741, -80.0611114501953, -1.39732999761204, 218, 45, 'PPL', 'P'),
(172255, 'Millbrook', 43.7244415283203, 0.763135468264931, -72.456672668457, -1.26460750310436, 218, 55, 'PPL', 'P'),
(209606, 'Millbrook', 41.3208312988281, 0.721184555825676, -105.919723510742, -1.8486479180645, 218, 59, 'PPL', 'P'),
(150743, 'Millbrook Heights', 41.7655601501465, 0.728946538559793, -73.7138900756836, -1.28655008627385, 218, 40, 'PPL', 'P'),
(145759, 'Millbrook Park', 40.0250015258789, 0.698568059742341, -74.8894424438477, -1.30706734562793, 218, 37, 'PPL', 'P'),
(132103, 'Millburg', 42.1227798461914, 0.735181198408751, -86.341667175293, -1.50694637386997, 218, 27, 'PPL', 'P'),
(120631, 'Millburn', 42.4258308410645, 0.74047043607073, -88.0038909912109, -1.53595765236281, 218, 18, 'PPL', 'P'),
(150745, 'Millburn', 40.6472206115723, 0.709427831456439, -73.6083297729492, -1.28470771143173, 218, 40, 'PPL', 'P'),
(164603, 'Millburn', 41.1686096191406, 0.718527786322213, -80.2305603027344, -1.40028743800257, 218, 45, 'PPL', 'P'),
(208132, 'Millburn', 46.6305618286133, 0.81385683596409, -123.09610748291, -2.14843237196561, 218, 56, 'PPL', 'P'),
(104273, 'Millburn Terrace', 38.9005584716797, 0.678942826195384, -77.1386108398438, -1.34632273956986, 218, 53, 'PPL', 'P'),
(209607, 'Millburne', 41.2583312988281, 0.720093725043179, -110.41194152832, -1.92705191318865, 218, 59, 'PPL', 'P'),
(125432, 'Millbury', 42.1938896179199, 0.736422298055755, -71.7605590820313, -1.25245802905336, 218, 23, 'PPL', 'P'),
(156504, 'Millbury', 41.5661087036133, 0.725465454119924, -83.4247207641602, -1.45603605489147, 218, 41, 'PPL', 'P'),
(125433, 'Millbury Junction', 42.2347183227539, 0.737134893384433, -71.7333297729492, -1.25198278795684, 218, 23, 'PPL', 'P'),
(56256, 'Millcreek', 37.526668548584, 0.654963923477392, -90.3097229003906, -1.57620201117554, 218, 29, 'PPL', 'P'),
(60895, 'Millcreek', 33.1566696166992, 0.578693053807368, -88.9488906860352, -1.55245100846783, 218, 30, 'PPL', 'P'),
(204932, 'Millcreek', 40.686939239502, 0.710121052288187, -111.874717712402, -1.95258217382064, 218, 52, 'PPL', 'P'),
(204934, 'Millcreek Manor Condominium', 41.2425003051758, 0.719817422080084, -111.976387023926, -1.95435663805496, 218, 52, 'PPL', 'P'),
(42099, 'Milldale', 30.6674995422363, 0.535248840365878, -91.0274963378906, -1.58872952094327, 218, 22, 'PPL', 'P'),
(89040, 'Milldale', 36.5900001525879, 0.638615975967886, -86.7636108398438, -1.51431068007432, 218, 50, 'PPL', 'P'),
(104274, 'Milldale', 39.0019416809082, 0.68071229700266, -78.0983276367188, -1.36307295756202, 218, 53, 'PPL', 'P'),
(113722, 'Milldale', 41.5658302307129, 0.725460593850934, -72.892219543457, -1.27220923011988, 218, 8, 'PPL', 'P'),
(23096, 'Milldale (historical)', 31.9036102294922, 0.556823041777582, -83.852783203125, -1.46350715385553, 218, 13, 'PPL', 'P'),
(132104, 'Millecoquins', 46.1352806091309, 0.805212547960829, -85.5074996948242, -1.49238740482273, 218, 27, 'PPL', 'P'),
(23097, 'Milledgeville', 33.0800018310547, 0.577354948517657, -83.2322235107422, -1.45267634401829, 218, 13, 'PPL', 'P'),
(30512, 'Milledgeville', 39.9741706848145, 0.697680894204209, -86.496940612793, -1.50965640659524, 218, 19, 'PPL', 'P'),
(37200, 'Milledgeville', 37.5205612182617, 0.654857330454762, -84.8138885498047, -1.48028160661361, 218, 21, 'PPL', 'P'),
(73474, 'Milledgeville', 39.5927810668945, 0.691024389638583, -83.5875015258789, -1.45887711514237, 218, 41, 'PPL', 'P'),
(89041, 'Milledgeville', 35.3727798461914, 0.617371473899133, -88.3675003051758, -1.54230383208241, 218, 50, 'PPL', 'P'),
(120632, 'Milledgeville', 41.9633293151855, 0.732398261648645, -89.7744369506836, -1.56685950891349, 218, 18, 'PPL', 'P'),
(164607, 'Milledgeville', 41.4702796936035, 0.723792922376327, -80.0625, -1.39735423237796, 218, 45, 'PPL', 'P'),
(82405, 'Milledgeville (historical)', 33.6722183227539, 0.587691076182418, -81.7708282470703, -1.42717018499416, 218, 48, 'PPL', 'P'),
(197054, 'Millegan', 47.0205612182617, 0.820663609394223, -111.36888885498, -1.94375379480703, 218, 31, 'PPL', 'P'),
(23098, 'Millen', 32.8038902282715, 0.572535891946132, -81.9494400024414, -1.43028754820815, 218, 13, 'PPL', 'P'),
(110449, 'Millen', 39.5183296203613, 0.689724966763706, -78.6302795410156, -1.37235726975426, 218, 58, 'PPL', 'P'),
(150746, 'Millen Bay', 44.1691703796387, 0.770897450999049, -76.2441711425781, -1.33071182189204, 218, 40, 'PPL', 'P'),
(104275, 'Millenbeck', 37.6697196960449, 0.657460636999341, -76.4888916015625, -1.3349829996483, 218, 53, 'PPL', 'P'),
(66849, 'Millennium', 36.2486114501953, 0.632657619082025, -77.0941696166992, -1.34554709390238, 218, 33, 'PPL', 'P'),
(4215, 'Miller', 32.1563911437988, 0.561234901018435, -87.7855606079102, -1.53214706831707, 218, 2, 'PPL', 'P'),
(10497, 'Miller', 35.980281829834, 0.627974383726093, -90.4233322143555, -1.57818486776516, 218, 4, 'PPL', 'P'),
(17133, 'Miller', 29.9675006866455, 0.523031555575626, -82.4661102294922, -1.43930514481722, 218, 12, 'PPL', 'P'),
(33286, 'Miller', 38.6344413757324, 0.674298206675258, -95.9902801513672, -1.67534643855312, 218, 20, 'PPL', 'P'),
(37201, 'Miller', 36.5183296203613, 0.637365089203876, -89.3386077880859, -1.55925285504995, 218, 21, 'PPL', 'P'),
(49504, 'Miller', 39.5958290100098, 0.691077586281357, -78.9333267211914, -1.37764644083721, 218, 25, 'PPL', 'P'),
(56258, 'Miller', 37.2147216796875, 0.649519423523861, -93.8397216796875, -1.63781211246565, 218, 29, 'PPL', 'P'),
(60896, 'Miller', 34.9174995422363, 0.609425333575637, -89.7686080932617, -1.56675777615985, 218, 30, 'PPL', 'P'),
(73472, 'Miller', 38.5366706848145, 0.67259178620679, -82.3019409179688, -1.4364398498004, 218, 41, 'PPL', 'P'),
(89043, 'Miller', 36.3097190856934, 0.633724148519574, -82.4338912963867, -1.43874281835305, 218, 50, 'PPL', 'P'),
(104276, 'Miller', 39.1605606079102, 0.683480719534824, -77.7705612182617, -1.35735235438248, 218, 53, 'PPL', 'P'),
(112310, 'Miller', 38.5349998474121, 0.672562624592854, -89.9366683959961, -1.56969098178446, 218, 18, 'PPL', 'P'),
(112793, 'Miller', 34.3163909912109, 0.598934010198351, -95.7447204589844, -1.67106061341085, 218, 42, 'PPL', 'P'),
(116851, 'Miller', 43.1841697692871, 0.75370594721426, -93.5999984741211, -1.63362815323508, 218, 16, 'PPL', 'P'),
(123205, 'Miller', 41.6022186279297, 0.726095691191891, -87.2583312988281, -1.52294518096057, 218, 19, 'PPL', 'P'),
(132106, 'Miller', 42.5491714477539, 0.742623135758868, -82.6588897705078, -1.44266978253842, 218, 27, 'PPL', 'P'),
(142427, 'Miller', 40.9277801513672, 0.714324519173741, -99.3927764892578, -1.73473120243636, 218, 35, 'PPL', 'P'),
(170880, 'Miller', 44.5183296203613, 0.776991429363422, -98.9880599975586, -1.72766756711909, 218, 49, 'PPL', 'P'),
(183277, 'Miller', 36.957218170166, 0.645025139447271, -121.543609619141, -2.12133617261266, 218, 6, 'PPL', 'P'),
(197052, 'Miller', 46.8941688537598, 0.818457646484283, -113.77693939209, -1.985782205234, 218, 31, 'PPL', 'P'),
(10498, 'Miller (historical)', 35.5069389343262, 0.619712991708558, -92.1236114501953, -1.60786033863386, 218, 4, 'PPL', 'P'),
(56257, 'Miller (historical)', 36.7208290100098, 0.64089937028652, -89.9661102294922, -1.57020483871679, 218, 29, 'PPL', 'P'),
(73473, 'Miller (historical)', 39.5661087036133, 0.690558869080037, -82.9408264160156, -1.44759050528456, 218, 41, 'PPL', 'P'),
(183278, 'Miller (historical)', 38.0283317565918, 0.663719598193246, -122.521942138672, -2.13841129625781, 218, 6, 'PPL', 'P'),
(23099, 'Miller Academy', 33.6719398498535, 0.587686215913429, -85.1194381713867, -1.48561445353844, 218, 13, 'PPL', 'P'),
(17134, 'Miller Bend', 30.4730606079102, 0.531855240767817, -85.8850021362305, -1.49897606535959, 218, 12, 'PPL', 'P'),
(56259, 'Miller Brothers (historical)', 37.5338897705078, 0.65508995757598, -94.6147232055664, -1.65133844080022, 218, 29, 'PPL', 'P'),
(204935, 'Miller Calioon Addition', 40.6686096191406, 0.709801140062241, -111.891670227051, -1.95287805101775, 218, 52, 'PPL', 'P'),
(49505, 'Miller Chapel', 39.7066688537598, 0.693012106497191, -77.6474990844727, -1.35520451496333, 218, 25, 'PPL', 'P'),
(27905, 'Miller City', 37.1108283996582, 0.647706143716654, -89.3561096191406, -1.55955831962698, 218, 18, 'PPL', 'P'),
(156507, 'Miller City', 41.1027793884277, 0.717378832048925, -84.1313934326172, -1.4683698196899, 218, 41, 'PPL', 'P'),
(197053, 'Miller Colony', 47.9263916015625, 0.836473332047424, -112.289169311523, -1.95981571881546, 218, 31, 'PPL', 'P'),
(128142, 'Miller Corner', 43.478889465332, 0.758849776280721, -70.9463882446289, -1.23824806726697, 218, 26, 'PPL', 'P'),
(150747, 'Miller Corners', 42.8277816772461, 0.747485801593244, -74.2333297729492, -1.2956160192567, 218, 40, 'PPL', 'P'),
(104278, 'Miller Court', 37.3175010681152, 0.651313262255112, -79.9963912963867, -1.39620041783568, 218, 53, 'PPL', 'P'),
(89044, 'Miller Cove', 35.7097206115723, 0.623252199639219, -83.817497253418, -1.46289129785345, 218, 50, 'PPL', 'P'),
(14242, 'Miller Creek Park Mobile Home Park', 38.5108299255371, 0.672140779876185, -75.1050033569336, -1.31082959329989, 218, 10, 'PPL', 'P'),
(195328, 'Miller Creek Settlement', 42.0816688537598, 0.734463676232056, -116.127220153809, -2.02680234287228, 218, 17, 'PPL', 'P'),
(82406, 'Miller Crossing', 34.9794387817383, 0.610506377241127, -81.0838928222656, -1.41518090008273, 218, 48, 'PPL', 'P'),
(17135, 'Miller Crossroads', 30.9491691589355, 0.54016490258011, -85.7416687011719, -1.49647442498962, 218, 12, 'PPL', 'P'),
(82407, 'Miller Crossroads', 33.708610534668, 0.588326240102402, -79.3150024414063, -1.38430793882988, 218, 48, 'PPL', 'P'),
(170882, 'Miller Dale Colony', 44.4000015258789, 0.774926214517093, -99.1125030517578, -1.7298395081461, 218, 49, 'PPL', 'P'),
(73475, 'Miller Estates', 38.4505615234375, 0.671088897824631, -82.35888671875, -1.43743374151922, 218, 41, 'PPL', 'P'),
(89045, 'Miller Estates', 35.9430618286133, 0.627324772157196, -86.4791717529297, -1.5093462814863, 218, 50, 'PPL', 'P'),
(183279, 'Miller Farms', 33.5741691589355, 0.585979795444961, -114.619438171387, -2.00048658287677, 218, 6, 'PPL', 'P'),
(89046, 'Miller Flats', 36.4375, 0.635954346195434, -82.8724975585938, -1.44639794174842, 218, 50, 'PPL', 'P'),
(56261, 'Miller Ford (historical)', 37.8772201538086, 0.661082203186713, -92.8880615234375, -1.62120250937904, 218, 29, 'PPL', 'P'),
(96222, 'Miller Grove', 33.024169921875, 0.576380497874797, -95.8024978637695, -1.67206901935761, 218, 51, 'PPL', 'P'),
(156508, 'Miller Grove', 40.0066719055176, 0.698248147516396, -84.4641723632813, -1.47417790771126, 218, 41, 'PPL', 'P'),
(104279, 'Miller Heights', 39.1575012207031, 0.683427323154968, -78.1425018310547, -1.3638439426976, 218, 53, 'PPL', 'P'),
(82408, 'Miller Hill', 32.7186088562012, 0.571047451212886, -80.0216674804688, -1.39664157047025, 218, 48, 'PPL', 'P'),
(211998, 'Miller House', 65.524169921875, 1.14361250477295, -145.216110229492, -2.53449925044366, 218, 1, 'PPL', 'P'),
(37203, 'Miller Landing', 37.1838912963867, 0.648981331825611, -88.3791732788086, -1.5425075639058, 218, 21, 'PPL', 'P'),
(164608, 'Miller Manor', 40.7002792358398, 0.710353879146487, -75.4394378662109, -1.31666657661907, 218, 45, 'PPL', 'P'),
(113728, 'Miller Memorial Community', 41.5311088562012, 0.724854591544887, -72.7977828979492, -1.27056099972123, 218, 8, 'PPL', 'P'),
(150748, 'Miller Place', 40.9597206115723, 0.714881985368921, -72.9966735839844, -1.2740322970441, 218, 40, 'PPL', 'P'),
(193789, 'Miller Place', 40.4658317565918, 0.706261998710607, -123.428329467773, -2.15423073944899, 218, 6, 'PPL', 'P'),
(96223, 'Miller Resub Lot A Colonia', 26.1900005340576, 0.457101740418379, -98.1350021362305, -1.71277889872889, 218, 51, 'PPL', 'P'),
(208133, 'Miller River', 47.7200012207031, 0.832871140356983, -121.397216796875, -2.11878113586283, 218, 56, 'PPL', 'P'),
(164609, 'Miller Shaft', 40.3791694641113, 0.704749456369497, -78.6630630493164, -1.37292944991446, 218, 45, 'PPL', 'P'),
(10500, 'Miller Springs (historical)', 36.4752807617188, 0.636613744881337, -94.5627822875977, -1.65043190076515, 218, 4, 'PPL', 'P'),
(178647, 'Miller Valley', 34.5530586242676, 0.603064639628092, -112.475280761719, -1.96306397639703, 218, 5, 'PPL', 'P'),
(204937, 'Millerberg', 40.6091690063477, 0.708763705659601, -111.881942749023, -1.95270827449825, 218, 52, 'PPL', 'P'),
(42100, 'Millerfield (historical)', 31.8472194671631, 0.55583883730723, -91.3516693115234, -1.59438740667915, 218, 22, 'PPL', 'P'),
(10503, 'Millers', 35.0627784729004, 0.611960929249501, -90.2300033569336, -1.57481064266403, 218, 4, 'PPL', 'P'),
(49506, 'Millers', 39.6711082458496, 0.692391456805148, -76.8513870239258, -1.34130973829195, 218, 25, 'PPL', 'P'),
(56268, 'Millers', 37.8605613708496, 0.660791452574704, -90.2702789306641, -1.57551358403375, 218, 29, 'PPL', 'P'),
(150749, 'Millers', 43.3261108398438, 0.756183286239279, -78.4663925170898, -1.36949690158546, 218, 40, 'PPL', 'P'),
(164613, 'Millers', 40.7316703796387, 0.710901757961743, -75.817497253418, -1.3232649576939, 218, 45, 'PPL', 'P'),
(190483, 'Millers', 38.1366691589355, 0.665610442567202, -117.456672668457, -2.05000566650181, 218, 39, 'PPL', 'P'),
(191884, 'Millers', 29.8741703033447, 0.521402633094879, -102.715560913086, -1.79272473096614, 218, 51, 'PPL', 'P'),
(73477, 'Millers (historical)', 39.8250007629395, 0.695077387922547, -83.1444396972656, -1.45114422744316, 218, 41, 'PPL', 'P'),
(10504, 'Millers Bluff', 33.3958282470703, 0.582867159341903, -92.6338882446289, -1.61676634879324, 218, 4, 'PPL', 'P'),
(10505, 'Millers Chapel', 33.0611114501953, 0.577025249174705, -91.4861068725586, -1.59673378475756, 218, 4, 'PPL', 'P'),
(150750, 'Millers Corner', 42.8152809143066, 0.747267622120939, -78.1247177124023, -1.36353355127255, 218, 40, 'PPL', 'P'),
(164614, 'Millers Corner', 40.9233283996582, 0.714246821448938, -76.1524963378906, -1.32911179470912, 218, 45, 'PPL', 'P'),
(150751, 'Millers Corners', 42.5852813720703, 0.743253372830835, -73.5699996948242, -1.28403872536591, 218, 40, 'PPL', 'P'),
(156511, 'Millers Corners', 40.1111106872559, 0.7000709481245, -82.704719543457, -1.44346966297183, 218, 41, 'PPL', 'P'),
(96224, 'Millers Cove', 33.1561088562012, 0.578683266690362, -95.1141662597656, -1.66005536652221, 218, 51, 'PPL', 'P'),
(37204, 'Millers Creek', 37.6716690063477, 0.657494658882267, -83.8969421386719, -1.464277872675, 218, 21, 'PPL', 'P'),
(66850, 'Millers Creek', 36.1891708374023, 0.631620184679384, -81.2377777099609, -1.41786669804208, 218, 33, 'PPL', 'P'),
(10506, 'Millers Crossing', 33.8055610656738, 0.590018346080011, -94.1661071777344, -1.64350861403733, 218, 4, 'PPL', 'P'),
(128143, 'Millers Crossing', 43.4058303833008, 0.757574654750791, -70.4891662597656, -1.23026803821861, 218, 26, 'PPL', 'P'),
(150752, 'Millers Crossing', 42.8105583190918, 0.747185197285201, -78.1694412231445, -1.36431412378806, 218, 40, 'PPL', 'P'),
(82409, 'Millers Crossroads', 33.7441711425781, 0.588946889794445, -82.1011123657227, -1.43293473033169, 218, 48, 'PPL', 'P'),
(164615, 'Millers Crossroads', 40.8486099243164, 0.712942738042153, -76.6869430541992, -1.33843964958517, 218, 45, 'PPL', 'P'),
(164616, 'Millers Eddy', 41.0397186279297, 0.716278214149423, -79.6427764892578, -1.39002867516748, 218, 45, 'PPL', 'P'),
(125435, 'Millers Falls', 42.5819396972656, 0.743195049602963, -72.4930572509766, -1.26524253386629, 218, 23, 'PPL', 'P'),
(4218, 'Millers Ferry', 32.0994415283203, 0.56024094272059, -87.3675003051758, -1.52485053956247, 218, 2, 'PPL', 'P'),
(17136, 'Millers Ferry', 30.5722198486328, 0.533585896002205, -85.8444366455078, -1.49826806398379, 218, 12, 'PPL', 'P'),
(4219, 'Millers Ford', 31.788890838623, 0.554820810691034, -85.4369430541992, -1.49115595913468, 218, 2, 'PPL', 'P'),
(23101, 'Millers Glen', 33.5683288574219, 0.585877862954238, -83.9652786254883, -1.46547056936919, 218, 13, 'PPL', 'P'),
(82414, 'Millers Grove (historical)', 34.1666717529297, 0.596320916536766, -82.2766723632813, -1.43599883032388, 218, 48, 'PPL', 'P'),
(60897, 'Millers Landing', 32.9169387817383, 0.574508961418744, -91.0608291625977, -1.5893112884834, 218, 30, 'PPL', 'P'),
(183280, 'Millers Landing', 38.9566688537598, 0.679922137107233, -121.838607788086, -2.12648486194811, 218, 6, 'PPL', 'P'),
(211999, 'Millers Landing', 59.6674995422363, 1.04139432344423, -151.434722900391, -2.64303451645707, 218, 1, 'PPL', 'P'),
(23102, 'Millers Mill', 33.5349998474121, 0.585296161993137, -84.1413879394531, -1.4685442567413, 218, 13, 'PPL', 'P'),
(82410, 'Millers Mill', 34.2169418334961, 0.597198294957892, -82.3063888549805, -1.43651748094617, 218, 48, 'PPL', 'P'),
(150753, 'Millers Mills', 42.9199981689453, 0.749095282998033, -75.0819396972656, -1.31042705650112, 218, 40, 'PPL', 'P'),
(150754, 'Millers Mills Crossing', 42.9088897705078, 0.748901404870675, -75.0919418334961, -1.31060162671057, 218, 40, 'PPL', 'P'),
(183281, 'Millers Ranch', 36.2519416809082, 0.632715742572816, -121.428886413574, -2.11933387494708, 218, 6, 'PPL', 'P'),
(164617, 'Millers Station', 41.8105583190918, 0.729731904765258, -79.9947204589844, -1.39617125622175, 218, 45, 'PPL', 'P'),
(49507, 'Millers Store', 39.6833305358887, 0.692604776008463, -76.2316665649414, -1.3304935758407, 218, 25, 'PPL', 'P'),
(66851, 'Millers Store', 35.9355583190918, 0.627193811210591, -76.9741668701172, -1.34345265086308, 218, 33, 'PPL', 'P'),
(104281, 'Millers Tavern', 37.8280601501465, 0.660224199262517, -76.9452819824219, -1.34294851446873, 218, 53, 'PPL', 'P'),
(37205, 'Millersburg', 38.3019409179688, 0.668494978922894, -84.1474990844727, -1.46865091634296, 218, 21, 'PPL', 'P'),
(56269, 'Millersburg', 38.898609161377, 0.678908804312458, -92.1233291625977, -1.60785541178584, 218, 29, 'PPL', 'P'),
(116853, 'Millersburg', 41.5733299255371, 0.725591488218512, -92.1597213745117, -1.60849057570582, 218, 16, 'PPL', 'P'),
(120635, 'Millersburg', 41.2413902282715, 0.719798047583153, -90.8183288574219, -1.58507885972099, 218, 18, 'PPL', 'P'),
(123207, 'Millersburg', 40.1947212219238, 0.701530227243809, -86.0238876342773, -1.50140007458378, 218, 19, 'PPL', 'P'),
(132108, 'Millersburg', 45.3344383239746, 0.791235213295657, -84.0608291625977, -1.4671382408438, 218, 27, 'PPL', 'P'),
(136874, 'Millersburg', 44.4277801513672, 0.775411042993542, -93.331672668457, -1.62894498445818, 218, 28, 'PPL', 'P'),
(156512, 'Millersburg', 40.5544395446777, 0.707808496355616, -81.9180603027344, -1.42973986912998, 218, 41, 'PPL', 'P'),
(164618, 'Millersburg', 40.5394401550293, 0.707546707620462, -76.9611129760742, -1.34322481743183, 218, 45, 'PPL', 'P'),
(201232, 'Millersburg', 44.6811103820801, 0.779832489614319, -123.060279846191, -2.14780706174166, 218, 43, 'PPL', 'P'),
(164620, 'Millersdale', 40.2750015258789, 0.702931382872327, -79.6308288574219, -1.38982014965413, 218, 45, 'PPL', 'P'),
(30516, 'Millersport', 38.3430595397949, 0.669212634257643, -87.0538864135742, -1.51937694457403, 218, 19, 'PPL', 'P'),
(73478, 'Millersport', 39.9000015258789, 0.696386398177348, -82.5341720581055, -1.44049304782145, 218, 41, 'PPL', 'P'),
(110450, 'Millersport', 38.535831451416, 0.672577138820795, -82.2916717529297, -1.43626061905904, 218, 58, 'PPL', 'P'),
(150755, 'Millersport', 43.0847206115723, 0.751970231973801, -78.6969375610352, -1.37352067167646, 218, 40, 'PPL', 'P'),
(37206, 'Millerstown', 37.4452781677246, 0.653543393351944, -86.0508270263672, -1.50187025567423, 218, 21, 'PPL', 'P'),
(156513, 'Millerstown', 40.1569404602051, 0.700870828557906, -83.92138671875, -1.46470451108163, 218, 41, 'PPL', 'P'),
(164625, 'Millerstown', 40.5494384765625, 0.707721211250889, -77.1549987792969, -1.34660876307094, 218, 45, 'PPL', 'P'),
(96225, 'Millersview', 31.4086093902588, 0.548183647332824, -99.7552795410156, -1.74105807423806, 218, 51, 'PPL', 'P'),
(27906, 'Millersville', 39.4511108398438, 0.688551777724499, -89.1580581665039, -1.55610166969011, 218, 18, 'PPL', 'P'),
(30517, 'Millersville', 39.8530616760254, 0.695567143247013, -86.091667175293, -1.50258305073999, 218, 19, 'PPL', 'P'),
(49508, 'Millersville', 39.059440612793, 0.681715842680429, -76.6483306884766, -1.33776573667133, 218, 25, 'PPL', 'P'),
(56270, 'Millersville', 37.4327812194824, 0.653325280458666, -89.7994384765625, -1.5672958678581, 218, 29, 'PPL', 'P'),
(66853, 'Millersville', 35.8555603027344, 0.62579758243009, -81.1836090087891, -1.4169212758551, 218, 33, 'PPL', 'P'),
(78749, 'Millersville', 39.9977798461914, 0.698092951803871, -76.3544387817383, -1.33263635525378, 218, 45, 'PPL', 'P'),
(89048, 'Millersville', 36.3711090087891, 0.63479560480514, -86.7099990844727, -1.51337497842532, 218, 50, 'PPL', 'P'),
(110456, 'Millersville', 39.461109161377, 0.688726281354926, -80.1483306884766, -1.39885226049113, 218, 58, 'PPL', 'P'),
(132109, 'Millersville', 44.276668548584, 0.772773647987009, -85.5597229003906, -1.49329887170581, 218, 27, 'PPL', 'P'),
(156514, 'Millersville', 41.311939239502, 0.721029360113151, -83.2813873291016, -1.45353441452151, 218, 41, 'PPL', 'P'),
(183282, 'Millersville', 35.3038902282715, 0.61616912324599, -118.456939697266, -2.06746361955366, 218, 6, 'PPL', 'P'),
(82411, 'Millersville (historical)', 33.1705589294434, 0.578935468045592, -80.9677810668945, -1.41315436765124, 218, 48, 'PPL', 'P'),
(49509, 'Millersville Forest', 39.0625, 0.681769239060285, -76.6516723632813, -1.3378240598992, 218, 25, 'PPL', 'P'),
(33288, 'Millerton', 37.4366683959961, 0.653393124487436, -97.5561065673828, -1.70267526502729, 218, 20, 'PPL', 'P'),
(42101, 'Millerton', 33.0002784729004, 0.575963513427118, -93.2213897705078, -1.62702018478032, 218, 22, 'PPL', 'P'),
(76610, 'Millerton', 33.9858283996582, 0.593164604591831, -95.0133285522461, -1.65829541651583, 218, 42, 'PPL', 'P'),
(116854, 'Millerton', 40.8494415283203, 0.712957252270094, -93.3052825927734, -1.62848439074765, 218, 16, 'PPL', 'P'),
(132110, 'Millerton', 44.0397186279297, 0.768638091709253, -86.0502777099609, -1.5018606682943, 218, 27, 'PPL', 'P'),
(142430, 'Millerton', 41.1858291625977, 0.718828324051228, -97.2144393920898, -1.69671204787244, 218, 35, 'PPL', 'P'),
(150756, 'Millerton', 41.9536094665527, 0.732228618287207, -73.5111083984375, -1.28301087834319, 218, 40, 'PPL', 'P'),
(164628, 'Millerton', 41.9833297729492, 0.732747335488527, -76.9388885498047, -1.34283692801906, 218, 45, 'PPL', 'P'),
(183283, 'Millerton', 38.1091690063477, 0.665130474359742, -122.844436645508, -2.14403988722169, 218, 6, 'PPL', 'P'),
(66854, 'Millerton (historical)', 35.5250015258789, 0.620028243402596, -80.2458267211914, -1.40055388726964, 218, 33, 'PPL', 'P'),
(4220, 'Millertown', 30.8208293914795, 0.537924951076758, -88.2583312988281, -1.54039847348051, 218, 2, 'PPL', 'P'),
(73479, 'Millertown', 39.5997200012207, 0.691145496889154, -82.0972213745117, -1.43286681972389, 218, 41, 'PPL', 'P'),
(89049, 'Millertown', 36.040828704834, 0.629031126046637, -83.8436126708984, -1.46334709787401, 218, 50, 'PPL', 'P'),
(110452, 'Millertown', 39.2997207641602, 0.685909522448977, -79.9591674804688, -1.39555073968776, 218, 58, 'PPL', 'P'),
(150757, 'Millertown', 42.9058303833008, 0.748848008490819, -73.5111083984375, -1.28301087834319, 218, 40, 'PPL', 'P'),
(164630, 'Millertown', 40.0244407653809, 0.698558272625335, -79.3816680908203, -1.38547147391014, 218, 45, 'PPL', 'P'),
(4221, 'Millerville', 33.1913909912109, 0.579299056113415, -85.9258270263672, -1.49968859410924, 218, 2, 'PPL', 'P'),
(10507, 'Millerville', 34.1811103820801, 0.596572918154914, -92.3986129760742, -1.61266002070845, 218, 4, 'PPL', 'P'),
(42103, 'Millerville', 30.4511108398438, 0.531472145045009, -91.0244369506836, -1.58867612456342, 218, 22, 'PPL', 'P'),
(125436, 'Millerville', 42.0208282470703, 0.733401807326414, -71.5, -1.24791041517595, 218, 23, 'PPL', 'P'),
(136875, 'Millerville', 46.0675010681152, 0.804029571804615, -95.5622177124023, -1.66787533958906, 218, 28, 'PPL', 'P'),
(110453, 'Milleson', 39.4622192382813, 0.688745655851857, -78.6866683959961, -1.3733414409351, 218, 58, 'PPL', 'P'),
(110454, 'Millesons Mill', 39.4402809143066, 0.68836275986613, -78.6744384765625, -1.37312798857373, 218, 58, 'PPL', 'P'),
(66855, 'Millesville', 36.3077812194824, 0.63369032637373, -79.4155578613281, -1.38606296198824, 218, 33, 'PPL', 'P'),
(164631, 'Millesville', 40.1813888549805, 0.701297533543564, -79.8686065673828, -1.3939701535808, 218, 45, 'PPL', 'P'),
(110455, 'Millet (historical)', 37.9341697692871, 0.662076161484558, -82.4908294677734, -1.43973657691381, 218, 58, 'PPL', 'P'),
(82412, 'Millett', 33.0811080932617, 0.57737425643556, -81.5358276367188, -1.42306865059933, 218, 48, 'PPL', 'P'),
(96226, 'Millett', 28.5816707611084, 0.498844260502335, -99.1988906860352, -1.73134725679725, 218, 51, 'PPL', 'P'),
(132111, 'Millett', 42.7000007629395, 0.745255603917384, -84.6213912963867, -1.47692189574042, 218, 27, 'PPL', 'P'),
(190484, 'Millett', 39.0152816772461, 0.68094512386096, -117.180000305176, -2.04517682281328, 218, 39, 'PPL', 'P'),
(132112, 'Milleville Beach', 42.0494384765625, 0.733901150030804, -83.1869430541992, -1.4518860509648, 218, 27, 'PPL', 'P'),
(73480, 'Millfield', 39.4327812194824, 0.688231865498553, -82.0969390869141, -1.43286189287588, 218, 41, 'PPL', 'P'),
(49510, 'Millgate', 39.5152816772461, 0.689671770120932, -76.5475006103516, -1.336005919823, 218, 25, 'PPL', 'P'),
(123208, 'Millgrove', 40.4083290100098, 0.705258386453811, -85.2750015258789, -1.48832954626978, 218, 19, 'PPL', 'P'),
(132113, 'Millgrove', 42.5666694641113, 0.742928533756873, -85.8986129760742, -1.49921361932882, 218, 27, 'PPL', 'P'),
(150758, 'Millgrove', 42.9436111450195, 0.749507407176723, -78.5530624389648, -1.37100957708462, 218, 40, 'PPL', 'P'),
(183284, 'Millham City (historical)', 36.0374984741211, 0.628973002555846, -119.998329162598, -2.09436594077926, 218, 6, 'PPL', 'P'),
(49511, 'Millhausens', 39.082218170166, 0.68211338605215, -76.585563659668, -1.33667024535692, 218, 25, 'PPL', 'P'),
(23103, 'Millhaven', 32.9336090087891, 0.574799911767835, -81.6497192382813, -1.42505643403696, 218, 13, 'PPL', 'P'),
(42104, 'Millhaven', 32.4966697692871, 0.567173883407366, -91.9902801513672, -1.60553326847335, 218, 22, 'PPL', 'P'),
(56271, 'Millheim', 37.6175003051758, 0.656549236695289, -89.8872222900391, -1.56882798443322, 218, 29, 'PPL', 'P'),
(96227, 'Millheim', 29.8716697692871, 0.521358990542515, -96.2480621337891, -1.6798455828987, 218, 51, 'PPL', 'P'),
(156515, 'Millheim', 40.9972190856934, 0.715536457206808, -81.4366683959961, -1.42133799536494, 218, 41, 'PPL', 'P'),
(164632, 'Millheim', 40.8908309936523, 0.713679634715778, -77.476936340332, -1.35222763349684, 218, 45, 'PPL', 'P'),
(175322, 'Millhome', 43.8950004577637, 0.766112283152394, -87.9622192382813, -1.53523034306911, 218, 57, 'PPL', 'P'),
(30518, 'Millhousen', 39.2105598449707, 0.684353370845016, -85.432502746582, -1.49107846114696, 218, 19, 'PPL', 'P'),
(120637, 'Millhurst', 41.6227798461914, 0.726454552148779, -88.5522232055664, -1.54552785489806, 218, 18, 'PPL', 'P'),
(145761, 'Millhurst', 40.2536087036133, 0.702558007687498, -74.3419418334961, -1.29751165732062, 218, 37, 'PPL', 'P'),
(96228, 'Millican', 30.4683303833008, 0.531772682774025, -96.2022171020508, -1.67904543614918, 218, 51, 'PPL', 'P'),
(201233, 'Millican', 43.8791694641113, 0.765835980189299, -120.918891906738, -2.11043279163571, 218, 43, 'PPL', 'P'),
(89050, 'Millican Grove', 35.9049987792969, 0.626660446623275, -83.5083312988281, -1.45749533401078, 218, 50, 'PPL', 'P'),
(4222, 'Millie (historical)', 33.9166717529297, 0.59195759340678, -85.8530578613281, -1.49841853258538, 218, 2, 'PPL', 'P'),
(17137, 'Milligan', 30.7522201538086, 0.536727493982117, -86.6408309936523, -1.51216776750318, 218, 12, 'PPL', 'P'),
(30519, 'Milligan', 39.8455581665039, 0.695436182300408, -87.038330078125, -1.51910543530089, 218, 19, 'PPL', 'P'),
(73481, 'Milligan', 39.7277793884277, 0.693380554834003, -82.101936340332, -1.43294911140158, 218, 41, 'PPL', 'P'),
(89051, 'Milligan', 36.3022193908691, 0.633593254151997, -82.2958297729492, -1.43633319019874, 218, 50, 'PPL', 'P'),
(96229, 'Milligan', 33.1858291625977, 0.579201983891682, -96.5469436645508, -1.68506204968389, 218, 51, 'PPL', 'P'),
(142431, 'Milligan', 40.5002784729004, 0.706863207326693, -97.3872222900391, -1.69972767833279, 218, 35, 'PPL', 'P'),
(183285, 'Milligan', 34.276668548584, 0.598240722787576, -115.169441223145, -2.01008594702596, 218, 6, 'PPL', 'P'),
(183286, 'Milligan District (historical)', 38.3480606079102, 0.66929991936237, -120.699722290039, -2.10660756020397, 218, 6, 'PPL', 'P'),
(10508, 'Milligan Ridge', 35.7791709899902, 0.624464337409369, -90.2586135864258, -1.57530998536842, 218, 4, 'PPL', 'P'),
(82413, 'Milligans', 33.4605598449707, 0.583996938855342, -80.4538879394531, -1.40418524057401, 218, 48, 'PPL', 'P'),
(164634, 'Milligantown', 40.5583305358887, 0.707876406963413, -79.6761093139648, -1.39061044270761, 218, 45, 'PPL', 'P'),
(110457, 'Milliken', 38.401668548584, 0.670235554432343, -81.5461120605469, -1.4232481476568, 218, 58, 'PPL', 'P'),
(194327, 'Milliken', 40.3294410705566, 0.70388153217024, -104.854721069336, -1.83006011892018, 218, 7, 'PPL', 'P'),
(128144, 'Milliken Mills', 43.5444412231445, 0.759993870285019, -70.3927764892578, -1.228585719358, 218, 26, 'PPL', 'P'),
(42105, 'Millikens Bend (historical)', 32.4555587768555, 0.566456361230672, -91.1047210693359, -1.59007734677096, 218, 22, 'PPL', 'P'),
(42106, 'Millikin', 32.961669921875, 0.575289667092301, -91.225830078125, -1.59219109772816, 218, 22, 'PPL', 'P'),
(73482, 'Millikin (historical)', 39.3736114501953, 0.687199158206848, -84.4550018310547, -1.47401785172974, 218, 41, 'PPL', 'P'),
(66856, 'Millingport', 35.3805618286133, 0.617507295114727, -80.3052825927734, -1.40159158798839, 218, 33, 'PPL', 'P'),
(49512, 'Millington', 39.2580604553223, 0.685182412892358, -75.8375015258789, -1.32361409811281, 218, 25, 'PPL', 'P'),
(60898, 'Millington', 32.8811111450195, 0.573883651194794, -88.4158325195313, -1.54314738835769, 218, 30, 'PPL', 'P'),
(89052, 'Millington', 35.3413887023926, 0.616823595083877, -89.897216796875, -1.56900242148462, 218, 50, 'PPL', 'P'),
(104282, 'Millington', 38.1233291625977, 0.665377615708902, -78.6125030517578, -1.37204701148726, 218, 53, 'PPL', 'P'),
(113723, 'Millington', 41.4858283996582, 0.724064298491406, -72.355827331543, -1.26284741993993, 218, 8, 'PPL', 'P'),
(120638, 'Millington', 41.5625, 0.725402470360143, -88.5983276367188, -1.54633252902143, 218, 18, 'PPL', 'P'),
(132114, 'Millington', 43.2813911437988, 0.755402780302804, -83.5297164916992, -1.45786857603756, 218, 27, 'PPL', 'P'),
(145762, 'Millington', 40.6772193908691, 0.709951408926749, -74.5180587768555, -1.30058547785079, 218, 37, 'PPL', 'P'),
(201234, 'Millington', 43.3325004577637, 0.756294806109926, -124.196388244629, -2.16763589395396, 218, 43, 'PPL', 'P'),
(125437, 'Millington (historical)', 42.476390838623, 0.741352874497928, -72.3000030517578, -1.26187310245512, 218, 23, 'PPL', 'P'),
(128145, 'Millinocket', 45.6572189331055, 0.796868797686583, -68.7102813720703, -1.19922063991435, 218, 26, 'PPL', 'P'),
(37207, 'Million', 37.7797203063965, 0.65938050982918, -84.3874969482422, -1.47283966926349, 218, 21, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(4223, 'Million Dollar Lake Estates', 33.2733306884766, 0.580729173618788, -87.146110534668, -1.52098655913687, 218, 2, 'PPL', 'P'),
(125438, 'Millis', 42.1674995422363, 0.735961704345226, -71.3583297729492, -1.24543780326186, 218, 23, 'PPL', 'P'),
(142432, 'Millis Beach', 42.4347190856934, 0.740625565204227, -96.4480590820313, -1.68333618813947, 218, 35, 'PPL', 'P'),
(116855, 'Millman', 41.5411109924316, 0.725029161754341, -93.6772232055664, -1.63497597906277, 218, 16, 'PPL', 'P'),
(164635, 'Millmont', 40.8858299255371, 0.713592349611051, -77.14111328125, -1.34636641541174, 218, 45, 'PPL', 'P'),
(116856, 'Millnerville', 42.6986083984375, 0.745231302572437, -96.4880599975586, -1.68403433581923, 218, 16, 'PPL', 'P'),
(49513, 'Millpoint', 39.5286102294922, 0.68990439724215, -77.6858291625977, -1.35587350102916, 218, 25, 'PPL', 'P'),
(14243, 'Millpond Acres', 38.7644386291504, 0.676567086765951, -75.2041702270508, -1.31256038169233, 218, 10, 'PPL', 'P'),
(49514, 'Millpond Acres', 38.5750007629395, 0.673260772272618, -75.7219390869141, -1.32159715306124, 218, 25, 'PPL', 'P'),
(4224, 'Millport', 33.5633316040039, 0.585790644428538, -88.0813903808594, -1.53731027188046, 218, 2, 'PPL', 'P'),
(30520, 'Millport', 38.7713890075684, 0.676688393753605, -86.1033325195313, -1.50278664940533, 218, 19, 'PPL', 'P'),
(37208, 'Millport', 37.3608283996582, 0.65206946684664, -87.2874984741211, -1.52345424420294, 218, 21, 'PPL', 'P'),
(139334, 'Millport', 40.267219543457, 0.702795561656733, -92.0930633544922, -1.60732717378362, 218, 29, 'PPL', 'P'),
(150759, 'Millport', 42.2652816772461, 0.737668324550776, -76.8349990844727, -1.34102371479088, 218, 40, 'PPL', 'P'),
(156516, 'Millport', 40.7000007629395, 0.710349018877498, -80.8866729736328, -1.41173876437381, 218, 41, 'PPL', 'P'),
(164637, 'Millport', 41.9249992370605, 0.731729275582817, -78.1197204589844, -1.36344633274685, 218, 45, 'PPL', 'P'),
(49515, 'Millrace', 39.1138916015625, 0.682666191715424, -76.628059387207, -1.33741193572051, 218, 25, 'PPL', 'P'),
(23106, 'Millridge', 33.9244384765625, 0.592093148306265, -84.4602813720703, -1.47410999710346, 218, 13, 'PPL', 'P'),
(164638, 'Millrift', 41.4091682434082, 0.72272632635975, -74.7436065673828, -1.30452202941609, 218, 45, 'PPL', 'P'),
(116857, 'Millrock', 42.0550003051758, 0.733998222252538, -90.8391723632813, -1.5854426475259, 218, 16, 'PPL', 'P'),
(56272, 'Millrock Ford', 38.3311080932617, 0.669004042165263, -91.3033294677734, -1.59354371724581, 218, 29, 'PPL', 'P'),
(23104, 'Millrun', 33.6311111450195, 0.586973620584751, -84.341667175293, -1.47203978883009, 218, 13, 'PPL', 'P'),
(4225, 'Millry', 31.6338901519775, 0.552115538366217, -88.3133316040039, -1.54135840989543, 218, 2, 'PPL', 'P'),
(10509, 'Mills', 33.9277801513672, 0.592151471534138, -91.5777816772461, -1.59833381194048, 218, 4, 'PPL', 'P'),
(73484, 'Mills', 38.8491706848145, 0.678045940119272, -82.2355575561523, -1.43528124156816, 218, 41, 'PPL', 'P'),
(76611, 'Mills', 36.9663887023926, 0.645185195428785, -94.7588882446289, -1.65385459539812, 218, 42, 'PPL', 'P'),
(96230, 'Mills', 33.7294387817383, 0.588689761591198, -96.5455627441406, -1.68503794807603, 218, 51, 'PPL', 'P'),
(116858, 'Mills', 41.0186080932617, 0.71590976581261, -95.7655563354492, -1.6714242680577, 218, 16, 'PPL', 'P'),
(142433, 'Mills', 42.940559387207, 0.749454143954921, -99.4436111450195, -1.73561843455352, 218, 35, 'PPL', 'P'),
(164639, 'Mills', 41.9461097717285, 0.73209772391963, -77.6866683959961, -1.35588814841515, 218, 45, 'PPL', 'P'),
(183287, 'Mills', 38.413330078125, 0.670439086518652, -122.842216491699, -2.14400113822783, 218, 6, 'PPL', 'P'),
(189039, 'Mills', 36.0852813720703, 0.629806971451204, -104.254722595215, -1.81958817003983, 218, 38, 'PPL', 'P'),
(192701, 'Mills', 39.482780456543, 0.689104516808745, -112.027221679688, -1.95524387017212, 218, 52, 'PPL', 'P'),
(209608, 'Mills', 42.8405609130859, 0.747708841334538, -106.365280151367, -1.85642434844753, 218, 59, 'PPL', 'P'),
(23105, 'Mills (historical)', 34.959171295166, 0.610152642869337, -84.8819427490234, -1.48146937645979, 218, 13, 'PPL', 'P'),
(150760, 'Mills Corners', 43.0622215270996, 0.751577548871069, -74.1233291625977, -1.29369614642686, 218, 40, 'PPL', 'P'),
(49516, 'Mills Farm', 39.0969390869141, 0.682370314518316, -77.2558288574219, -1.34836857991926, 218, 25, 'PPL', 'P'),
(49517, 'Mills Farm East', 39.0974998474121, 0.682380101635322, -77.2513885498047, -1.34829108193154, 218, 25, 'PPL', 'P'),
(204939, 'Mills Heights', 40.6513900756836, 0.709500602333226, -111.953330993652, -1.95395423441425, 218, 52, 'PPL', 'P'),
(204940, 'Mills Junction', 40.6549987792969, 0.709563586093006, -112.288330078125, -1.95980107142946, 218, 52, 'PPL', 'P'),
(49518, 'Mills Manor', 39.5325012207031, 0.689972307849947, -77.3908309936523, -1.35072481169371, 218, 25, 'PPL', 'P'),
(150761, 'Mills Mills', 42.5008316040039, 0.741779446325531, -78.120002746582, -1.36345125959487, 218, 40, 'PPL', 'P'),
(183288, 'Mills Orchard', 39.7377815246582, 0.693555125043458, -122.055282592773, -2.13026655069602, 218, 6, 'PPL', 'P'),
(183289, 'Mills Orchards', 39.2775001525879, 0.685521699615234, -122.273887634277, -2.13408192843172, 218, 6, 'PPL', 'P'),
(27908, 'Mills Prairie (historical)', 38.5041694641113, 0.672024532894603, -87.970832824707, -1.53538067851264, 218, 18, 'PPL', 'P'),
(66857, 'Mills Ridge', 35.8877792358398, 0.62635990889426, -76.1580581665039, -1.32920886693085, 218, 33, 'PPL', 'P'),
(66858, 'Mills River', 35.3883285522461, 0.617642850014212, -82.5669403076172, -1.44106496166554, 218, 33, 'PPL', 'P'),
(197055, 'Mills Springs (historical)', 48.9083290100098, 0.853611372873329, -115.052780151367, -2.00804982721454, 218, 31, 'PPL', 'P'),
(89053, 'Mills Subdivision', 36.4855613708496, 0.636793175359782, -88.0911102294922, -1.5374799152419, 218, 50, 'PPL', 'P'),
(73485, 'Mills Village', 38.8463897705078, 0.677997404008406, -82.2408294677734, -1.43537325378382, 218, 41, 'PPL', 'P'),
(96232, 'Millsap', 32.7480583190918, 0.571561441303272, -98.0088882446289, -1.71057779608794, 218, 51, 'PPL', 'P'),
(14244, 'Millsboro', 38.5913887023926, 0.673546795773693, -75.2916717529297, -1.31408757141943, 218, 10, 'PPL', 'P'),
(78750, 'Millsboro', 39.9866714477539, 0.697899073676513, -79.9938888549805, -1.39615674199381, 218, 45, 'PPL', 'P'),
(110458, 'Millsboro', 39.7322196960449, 0.693458052821724, -80.6666717529297, -1.40789901871413, 218, 58, 'PPL', 'P'),
(156517, 'Millsboro', 40.7488899230957, 0.711202295690759, -82.6377792358398, -1.44230133420161, 218, 41, 'PPL', 'P'),
(150762, 'Millsburg', 41.3727798461914, 0.722091229018793, -74.5258331298828, -1.30072116590833, 218, 40, 'PPL', 'P'),
(120639, 'Millsdale', 41.435001373291, 0.7231771995323, -88.1641693115234, -1.53875503677183, 218, 18, 'PPL', 'P'),
(37209, 'Millseat', 38.4905586242676, 0.671786978925368, -82.6708297729492, -1.44287817489372, 218, 21, 'PPL', 'P'),
(89054, 'Millsfield', 36.1413917541504, 0.630786282363053, -89.3824996948242, -1.56001891333751, 218, 50, 'PPL', 'P'),
(183290, 'Millsholm (historical)', 39.5400009155273, 0.690103202217524, -122.343612670898, -2.13529885989183, 218, 6, 'PPL', 'P'),
(14245, 'Millside', 39.7180595397949, 0.693210911472565, -75.5527801513672, -1.31864477267678, 218, 10, 'PPL', 'P'),
(145763, 'Millside Heights', 40.0072212219238, 0.69825773489632, -74.9533309936523, -1.30818241117635, 218, 37, 'PPL', 'P'),
(183291, 'Millspaugh', 36.0461082458496, 0.629123271420353, -117.459999084473, -2.05006372341357, 218, 6, 'PPL', 'P'),
(183292, 'Millspaugh (historical)', 36.0458297729492, 0.629118411151364, -117.460830688477, -2.05007823764151, 218, 6, 'PPL', 'P'),
(27910, 'Millstadt', 38.4613914489746, 0.671277915683, -90.091667175293, -1.57239622081976, 218, 18, 'PPL', 'P'),
(27911, 'Millstadt Junction', 38.461669921875, 0.671282775951989, -90.2177810668945, -1.57459732346071, 218, 18, 'PPL', 'P'),
(175323, 'Millston', 44.1930618286133, 0.771314435446728, -90.6474990844727, -1.58209731772259, 218, 57, 'PPL', 'P'),
(37210, 'Millstone', 37.1672210693359, 0.64869038147652, -82.7516708374023, -1.44428911763924, 218, 21, 'PPL', 'P'),
(89055, 'Millstone', 35.9199981689453, 0.62692223535843, -84.7944412231445, -1.47994218673268, 218, 50, 'PPL', 'P'),
(104283, 'Millstone', 36.8766708374023, 0.643619323286845, -79.0155563354492, -1.37908161834865, 218, 53, 'PPL', 'P'),
(110459, 'Millstone', 38.8013916015625, 0.677212037802941, -81.0963897705078, -1.41539901297601, 218, 58, 'PPL', 'P'),
(113724, 'Millstone', 41.3108291625977, 0.721009985616221, -72.1669387817383, -1.25955069282652, 218, 8, 'PPL', 'P'),
(145765, 'Millstone', 40.4991683959961, 0.706843832829762, -74.5891723632813, -1.30182664407682, 218, 37, 'PPL', 'P'),
(164640, 'Millstone', 41.3541717529297, 0.721766456523858, -79.0722198486328, -1.38007058321945, 218, 45, 'PPL', 'P'),
(204941, 'Millstream Condominium Phase 1-4', 41.2388916015625, 0.719754438320303, -111.948333740234, -1.95386701588855, 218, 52, 'PPL', 'P'),
(96233, 'Millsville', 27.9125003814697, 0.48716503412082, -97.1852798461914, -1.69620311778813, 218, 51, 'PPL', 'P'),
(602, 'Milltown', 32.6402816772461, 0.569680384046321, -90.0250015258789, -1.57123268573951, 218, 30, 'PPL', 'P'),
(4226, 'Milltown', 33.0544395446777, 0.576908802456042, -85.4847183227539, -1.49198979487198, 218, 2, 'PPL', 'P'),
(10510, 'Milltown', 35.1569404602051, 0.613604365958189, -94.1494369506836, -1.64321766368824, 218, 4, 'PPL', 'P'),
(14246, 'Milltown', 39.7308311462402, 0.693433818055805, -75.666389465332, -1.3206276292664, 218, 10, 'PPL', 'P'),
(17138, 'Milltown', 29.8325004577637, 0.520675357090692, -85.2972183227539, -1.48871730252449, 218, 12, 'PPL', 'P'),
(30521, 'Milltown', 38.3422203063965, 0.669197986871648, -86.2761077880859, -1.50580214670762, 218, 19, 'PPL', 'P'),
(37214, 'Milltown', 37.1222190856934, 0.647904948692028, -85.4075012207031, -1.49064210220235, 218, 21, 'PPL', 'P'),
(66866, 'Milltown', 35.310001373291, 0.616275782847648, -83.815559387207, -1.4628574757076, 218, 33, 'PPL', 'P'),
(104284, 'Milltown', 39.235279083252, 0.684784802941609, -77.626106262207, -1.3548311397785, 218, 53, 'PPL', 'P'),
(110460, 'Milltown', 38.0447196960449, 0.66400562169432, -81.6175003051758, -1.42449410757279, 218, 58, 'PPL', 'P'),
(112562, 'Milltown', 35.9980583190918, 0.628284641993087, -87.5944366455078, -1.52881132589369, 218, 50, 'PPL', 'P'),
(128147, 'Milltown', 45.1697196960449, 0.788360330898916, -67.2911071777344, -1.17445137756385, 218, 26, 'PPL', 'P'),
(139332, 'Milltown', 40.1622200012207, 0.700962973931622, -92.1811065673828, -1.6088638177326, 218, 29, 'PPL', 'P'),
(145772, 'Milltown', 40.7019386291504, 0.710382841023342, -74.3169403076172, -1.29707529837601, 218, 37, 'PPL', 'P'),
(150763, 'Milltown', 41.4124984741211, 0.722784449850541, -73.5605621337891, -1.28387400885248, 218, 40, 'PPL', 'P'),
(164644, 'Milltown', 41.7069396972656, 0.727923418648012, -79.0480575561523, -1.37964887166084, 218, 45, 'PPL', 'P'),
(170886, 'Milltown', 43.4236106872559, 0.757884979596812, -97.8013916015625, -1.7069562964796, 218, 49, 'PPL', 'P'),
(175325, 'Milltown', 45.5261116027832, 0.79458054309896, -92.5083312988281, -1.61457496669027, 218, 57, 'PPL', 'P'),
(195329, 'Milltown', 47.3241691589355, 0.825962567594181, -116.542221069336, -2.03404547524702, 218, 17, 'PPL', 'P'),
(197056, 'Milltown', 46.8713912963867, 0.818060103112562, -113.880828857422, -1.98759541846218, 218, 31, 'PPL', 'P'),
(208135, 'Milltown', 48.3086090087891, 0.843144284261963, -122.346672058105, -2.13535225627169, 218, 56, 'PPL', 'P'),
(49519, 'Milltown Landing', 38.6330604553223, 0.674274105067393, -76.692497253418, -1.33853658864885, 218, 25, 'PPL', 'P'),
(183293, 'Millux', 35.1802787780762, 0.614011696446917, -119.197776794434, -2.08039366612016, 218, 6, 'PPL', 'P'),
(128148, 'Millvale', 44.6286087036133, 0.77891616246225, -68.7705612182617, -1.20027272170299, 218, 26, 'PPL', 'P'),
(164645, 'Millvale', 40.4799995422363, 0.706509273217821, -79.9786071777344, -1.39589002641063, 218, 45, 'PPL', 'P'),
(17139, 'Millview', 30.4177799224854, 0.530890410794395, -87.3561096191406, -1.52465173458709, 218, 12, 'PPL', 'P'),
(89059, 'Millview', 35.8788909912109, 0.626204779760763, -86.7908325195313, -1.51478578801279, 218, 50, 'PPL', 'P'),
(164647, 'Millview', 41.5061111450195, 0.724418299179304, -76.591667175293, -1.33677677180053, 218, 45, 'PPL', 'P'),
(4227, 'Millville', 32.5269393920898, 0.567702187988611, -88.3358306884766, -1.54175109299817, 218, 2, 'PPL', 'P'),
(10511, 'Millville', 33.7113914489746, 0.588374776213269, -92.6563873291016, -1.61715903189598, 218, 4, 'PPL', 'P'),
(14247, 'Millville', 38.5494384765625, 0.672814626211003, -75.1236114501953, -1.31115436579482, 218, 10, 'PPL', 'P'),
(17140, 'Millville', 30.1511096954346, 0.526236137315318, -85.6305618286133, -1.49453524424188, 218, 12, 'PPL', 'P'),
(30523, 'Millville', 39.9247207641602, 0.696817830273941, -85.2519378662109, -1.48792700947101, 218, 19, 'PPL', 'P'),
(37212, 'Millville', 38.1369400024414, 0.665615169678137, -84.8219375610352, -1.48042208836111, 218, 21, 'PPL', 'P'),
(56273, 'Millville', 39.4052810668945, 0.687751897291094, -93.9177780151367, -1.63917445252128, 218, 29, 'PPL', 'P'),
(60900, 'Millville', 32.6708297729492, 0.570213548896555, -89.7686080932617, -1.56675777615985, 218, 30, 'PPL', 'P'),
(89060, 'Millville', 35.1266708374023, 0.613076061376945, -86.8130569458008, -1.51517367742556, 218, 50, 'PPL', 'P'),
(104293, 'Millville', 36.7472190856934, 0.641359963997049, -76.3066711425781, -1.33180265267453, 218, 53, 'PPL', 'P'),
(110461, 'Millville', 39.2938919067383, 0.685807789695336, -77.7861099243164, -1.35762373049756, 218, 58, 'PPL', 'P'),
(113725, 'Millville', 41.4908294677734, 0.724151583596133, -73.067497253418, -1.27526840326406, 218, 8, 'PPL', 'P'),
(116860, 'Millville', 42.7000007629395, 0.745255603917384, -91.0741729736328, -1.58954418192073, 218, 16, 'PPL', 'P'),
(120646, 'Millville', 42.4488906860352, 0.740872906290468, -90.0513916015625, -1.57169327945004, 218, 18, 'PPL', 'P'),
(125440, 'Millville', 42.0277786254883, 0.733523114314067, -71.5813903808594, -1.24933094530139, 218, 23, 'PPL', 'P'),
(132118, 'Millville', 42.5291709899902, 0.742274061918986, -84.1911087036133, -1.46941204778251, 218, 27, 'PPL', 'P'),
(136878, 'Millville', 44.2447204589844, 0.772216048633774, -92.2955627441406, -1.61086145486627, 218, 28, 'PPL', 'P'),
(144155, 'Millville', 42.8025016784668, 0.747044582379645, -71.2149963378906, -1.2429361628919, 218, 36, 'PPL', 'P'),
(145774, 'Millville', 41.313060760498, 0.721048934347163, -74.7802810668945, -1.30516212018409, 218, 37, 'PPL', 'P'),
(150764, 'Millville', 43.2075004577637, 0.754113144544933, -78.3249969482422, -1.36702908336134, 218, 40, 'PPL', 'P'),
(156518, 'Millville', 40.9058303833008, 0.713941423450933, -80.8066711425781, -1.41034246901428, 218, 41, 'PPL', 'P'),
(164649, 'Millville', 41.1202812194824, 0.717684296625957, -76.5302810668945, -1.33570538209399, 218, 45, 'PPL', 'P'),
(169487, 'Millville', 41.5741691589355, 0.725606135604507, -71.682502746582, -1.25109568899773, 218, 47, 'PPL', 'P'),
(175328, 'Millville', 43.0333290100098, 0.751073279318662, -90.9300003051758, -1.58702789416477, 218, 57, 'PPL', 'P'),
(193791, 'Millville', 40.5494384765625, 0.707721211250889, -122.174171447754, -2.13234155265935, 218, 6, 'PPL', 'P'),
(204942, 'Millville', 41.6816711425781, 0.727482399171495, -111.822219848633, -1.9516659132476, 218, 52, 'PPL', 'P'),
(4228, 'Millville (historical)', 31.0291690826416, 0.541561164650124, -85.7127838134766, -1.49597028859527, 218, 2, 'PPL', 'P'),
(82415, 'Millville (historical)', 34.7750015258789, 0.606938274012639, -81.9541702270508, -1.43037010620194, 218, 48, 'PPL', 'P'),
(113726, 'Millville (historical)', 41.1183280944824, 0.717650208164004, -73.5025024414063, -1.28286067605771, 218, 8, 'PPL', 'P'),
(116861, 'Millville Siding', 42.5061111450195, 0.741871591699248, -91.0727767944336, -1.58951981399675, 218, 16, 'PPL', 'P'),
(164651, 'Millway', 40.1611099243164, 0.700943599434692, -76.2361068725586, -1.33057107382842, 218, 45, 'PPL', 'P'),
(4229, 'Millwood', 32.6605606079102, 0.570034318155193, -87.7508316040039, -1.53154093285297, 218, 2, 'PPL', 'P'),
(10515, 'Millwood', 33.6713905334473, 0.587676628533505, -93.982780456543, -1.64030895914565, 218, 4, 'PPL', 'P'),
(17141, 'Millwood', 29.3811092376709, 0.512797094085478, -82.204719543457, -1.43474301671186, 218, 12, 'PPL', 'P'),
(23107, 'Millwood', 31.2655601501465, 0.545686967100389, -82.6605606079102, -1.44269894415236, 218, 13, 'PPL', 'P'),
(33289, 'Millwood', 39.3838882446289, 0.687378522106264, -95.1166687011719, -1.66009904236409, 218, 20, 'PPL', 'P'),
(37213, 'Millwood', 37.4502792358398, 0.653630678456671, -86.3905563354492, -1.50779965068324, 218, 21, 'PPL', 'P'),
(49523, 'Millwood', 39.4972190856934, 0.689356518426893, -76.3627777099609, -1.33278189700735, 218, 25, 'PPL', 'P'),
(56274, 'Millwood', 39.1027793884277, 0.682472247009039, -91.1061096191406, -1.59010158153688, 218, 29, 'PPL', 'P'),
(82424, 'Millwood', 33.9930610656738, 0.593290838427501, -80.9661102294922, -1.4131252060373, 218, 48, 'PPL', 'P'),
(96234, 'Millwood', 32.9958305358887, 0.575885882281342, -96.4180603027344, -1.68281261066916, 218, 51, 'PPL', 'P'),
(104285, 'Millwood', 39.0694389343262, 0.681890346310856, -78.0380630493164, -1.3620211420895, 218, 53, 'PPL', 'P'),
(110462, 'Millwood', 38.8819389343262, 0.678617853963367, -81.8619384765625, -1.42876035848105, 218, 58, 'PPL', 'P'),
(150765, 'Millwood', 41.1922187805176, 0.718939843921875, -73.7977828979492, -1.28801429224118, 218, 40, 'PPL', 'P'),
(156519, 'Millwood', 40.3994407653809, 0.705103257320314, -82.2777786254883, -1.43601813824178, 218, 41, 'PPL', 'P'),
(164652, 'Millwood', 40.3525009155273, 0.704284002389978, -79.2786102294922, -1.3836727749099, 218, 45, 'PPL', 'P'),
(187059, 'Millwood', 37.4216690063477, 0.653131335752281, -108.333061218262, -1.89076860702325, 218, 7, 'PPL', 'P'),
(201235, 'Millwood', 43.3852806091309, 0.757215993530985, -123.544998168945, -2.15626699241846, 218, 43, 'PPL', 'P'),
(208134, 'Millwood', 47.6813888549805, 0.832197227443138, -117.281669616699, -2.0469512870476, 218, 56, 'PPL', 'P'),
(82418, 'Millwood (historical)', 34.0644416809082, 0.59453666518544, -82.6263885498047, -1.44210252922623, 218, 48, 'PPL', 'P'),
(42107, 'Millwood Estates', 32.5947189331055, 0.568885164144824, -93.9258270263672, -1.63931493426878, 218, 22, 'PPL', 'P'),
(82421, 'Millwood Gardens', 33.9127807617188, 0.591889682798983, -80.3791732788086, -1.40288122374626, 218, 48, 'PPL', 'P'),
(49520, 'Millys Delight', 39.2941703796387, 0.685812649964325, -77.0513916015625, -1.34480047669077, 218, 25, 'PPL', 'P'),
(71124, 'Milmay', 39.4391708374023, 0.6883433853692, -74.8572235107422, -1.30650501916376, 218, 37, 'PPL', 'P'),
(27914, 'Milmine', 39.9075012207031, 0.696517292544926, -88.6502838134766, -1.5472393353726, 218, 18, 'PPL', 'P'),
(78752, 'Milmont', 39.8797187805176, 0.69603239748945, -75.3444366455078, -1.31500849252438, 218, 45, 'PPL', 'P'),
(82422, 'Milmont Shores', 34.1130599975586, 0.595385214887766, -81.3966674804688, -1.42063984768518, 218, 48, 'PPL', 'P'),
(27915, 'Milne', 39.2630615234375, 0.685269697997085, -88.7922210693359, -1.54971660781859, 218, 18, 'PPL', 'P'),
(42108, 'Milneburg', 30.024169921875, 0.524020620314967, -90.0611114501953, -1.57186292281147, 218, 22, 'PPL', 'P'),
(4230, 'Milner', 33.4022216796875, 0.582978745791578, -85.5438919067383, -1.49302256874271, 218, 2, 'PPL', 'P'),
(23108, 'Milner', 33.1166687011719, 0.577994906127603, -84.1966705322266, -1.46950912000424, 218, 13, 'PPL', 'P'),
(37218, 'Milner', 38.0333290100098, 0.663806816718946, -84.8072204589844, -1.48016522647397, 218, 21, 'PPL', 'P'),
(194328, 'Milner', 40.4847183227539, 0.706591631474532, -107.018890380859, -1.86783199897688, 218, 7, 'PPL', 'P'),
(195330, 'Milner', 42.5186080932617, 0.742089704592525, -114.021942138672, -1.99005830983829, 218, 17, 'PPL', 'P'),
(10512, 'Milner (historical)', 33.3808288574219, 0.582605370606749, -93.1394424438477, -1.6255899341169, 218, 4, 'PPL', 'P'),
(23109, 'Milner Crossroads', 33.0608291625977, 0.577020322326689, -84.2074966430664, -1.46969807128358, 218, 13, 'PPL', 'P'),
(30527, 'Milners Corner', 39.9161109924316, 0.696667561409434, -85.6922225952148, -1.49561142763838, 218, 19, 'PPL', 'P'),
(189040, 'Milnesand', 33.6427803039551, 0.587177285829115, -103.339172363281, -1.80360880402519, 218, 38, 'PPL', 'P'),
(164653, 'Milnesville', 40.9902801513672, 0.715415349956237, -75.9830627441406, -1.32615462063469, 218, 45, 'PPL', 'P'),
(78753, 'Milnor', 39.7547187805176, 0.693850735924457, -77.7452774047852, -1.35691106858985, 218, 45, 'PPL', 'P'),
(140508, 'Milnor', 46.2591705322266, 0.807374835028891, -97.4558334350586, -1.70092516871695, 218, 34, 'PPL', 'P'),
(503, 'Milo', 39.1722183227539, 0.683684185042106, -97.9672164916992, -1.70985048679424, 218, 20, 'PPL', 'P'),
(37215, 'Milo', 37.916389465332, 0.661765836638536, -82.5769424438477, -1.44123953187499, 218, 21, 'PPL', 'P'),
(56276, 'Milo', 37.7561111450195, 0.658968452229517, -94.3058319091797, -1.64594727064752, 218, 29, 'PPL', 'P'),
(73487, 'Milo', 39.9833297729492, 0.697840750448641, -82.9833297729492, -1.4483323288062, 218, 41, 'PPL', 'P'),
(76612, 'Milo', 34.3325004577637, 0.599215173430437, -97.3391723632813, -1.69888904890553, 218, 42, 'PPL', 'P'),
(89061, 'Milo', 35.6961097717285, 0.623014645669984, -84.9991683959961, -1.48351534996724, 218, 50, 'PPL', 'P'),
(110463, 'Milo', 38.7222213745117, 0.675830256671354, -81.1438903808594, -1.41622805502335, 218, 58, 'PPL', 'P'),
(112238, 'Milo', 33.295280456543, 0.581112269341596, -91.9499969482422, -1.60483019394556, 218, 4, 'PPL', 'P'),
(113043, 'Milo', 41.1925010681152, 0.718944770769892, -89.5822219848633, -1.56350472488831, 218, 18, 'PPL', 'P'),
(116863, 'Milo', 41.2916717529297, 0.720675625741362, -93.4422225952148, -1.63087444466794, 218, 16, 'PPL', 'P'),
(123210, 'Milo', 40.6538887023926, 0.709544211596076, -85.4683303833008, -1.49170377137091, 218, 19, 'PPL', 'P'),
(128149, 'Milo', 45.2536087036133, 0.789824470287214, -68.9863891601563, -1.20403962990685, 218, 26, 'PPL', 'P'),
(183294, 'Milo', 36.2202796936035, 0.632163136646624, -118.816390991211, -2.07373722813356, 218, 6, 'PPL', 'P'),
(195331, 'Milo', 43.6108283996582, 0.761152545096285, -111.883056640625, -1.95272771557421, 218, 17, 'PPL', 'P'),
(201236, 'Milo', 42.9308280944824, 0.749284300856402, -123.048606872559, -2.14760332991827, 218, 43, 'PPL', 'P'),
(204943, 'Milo', 40.6622200012207, 0.709689620191594, -111.816673278809, -1.95156910734197, 218, 52, 'PPL', 'P'),
(209609, 'Milo', 41.6208305358887, 0.726420530265853, -106.419441223145, -1.85736963747645, 218, 59, 'PPL', 'P'),
(150766, 'Milo Center', 42.6344413757324, 0.744111376755032, -76.9997177124023, -1.34389859718762, 218, 40, 'PPL', 'P'),
(191885, 'Milo Center', 34.9830589294434, 0.610569560737989, -102.401672363281, -1.78724634228774, 218, 51, 'PPL', 'P'),
(150767, 'Milo Mills', 42.6586112976074, 0.7445332214717, -77.0263900756836, -1.34436411774616, 218, 40, 'PPL', 'P'),
(210695, 'Milo Village', 20.0163898468018, 0.349351907189454, -155.285003662109, -2.71023459287526, 218, 15, 'PPL', 'P'),
(210697, 'MiloliÃ‚â€˜i', 19.1866703033447, 0.334870569287985, -155.909713745117, -2.72113784069415, 218, 15, 'PPL', 'P'),
(136883, 'Miloma', 43.7627792358398, 0.763804587488813, -95.3680572509766, -1.66448660025999, 218, 28, 'PPL', 'P'),
(183297, 'Milpitas', 37.4283294677734, 0.653247582733863, -121.905563354492, -2.12765345703443, 218, 6, 'PPL', 'P'),
(60901, 'Milro (historical)', 32.3058280944824, 0.563843067832004, -89.8333282470703, -1.5678873559362, 218, 30, 'PPL', 'P'),
(10513, 'Milrose', 33.9199981689453, 0.592015650318544, -94.1858291625977, -1.64385282760822, 218, 4, 'PPL', 'P'),
(30524, 'Milroy', 39.496940612793, 0.689351658157904, -85.4697189331055, -1.49172800613683, 218, 19, 'PPL', 'P'),
(60902, 'Milroy', 33.3069381713867, 0.581315734848878, -90.5902786254883, -1.58109863231381, 218, 30, 'PPL', 'P'),
(110464, 'Milroy', 38.7269401550293, 0.675912614928064, -80.5008316040039, -1.40500456208338, 218, 58, 'PPL', 'P'),
(120641, 'Milroy', 41.0186080932617, 0.71590976581261, -90.9208297729492, -1.58686783818325, 218, 18, 'PPL', 'P'),
(136884, 'Milroy', 44.417781829834, 0.775236539363115, -95.5530624389648, -1.66771554992366, 218, 28, 'PPL', 'P'),
(164654, 'Milroy', 40.7138900756836, 0.710591433115722, -77.5908279418945, -1.35421541693448, 218, 45, 'PPL', 'P'),
(198622, 'Milroy', 48.439998626709, 0.845437465697603, -100.533332824707, -1.75463766579443, 218, 34, 'PPL', 'P'),
(4231, 'Milstead', 32.4425010681152, 0.566228461220388, -85.8974990844727, -1.49919417825286, 218, 2, 'PPL', 'P'),
(23110, 'Milstead', 33.6877784729004, 0.587962652034579, -83.9922180175781, -1.46594075045964, 218, 13, 'PPL', 'P'),
(104287, 'Milteer Acres', 36.8663902282715, 0.643439892808401, -76.4705581665039, -1.33466302084333, 218, 53, 'PPL', 'P'),
(73488, 'Miltomson', 39.3186111450195, 0.686239221791928, -84.3433303833008, -1.47206881728597, 218, 41, 'PPL', 'P'),
(4232, 'Milton', 32.5586090087891, 0.568254927072857, -86.8072204589844, -1.51507181151386, 218, 2, 'PPL', 'P'),
(14248, 'Milton', 38.7775001525879, 0.676795053355262, -75.3102798461914, -1.31441234391437, 218, 10, 'PPL', 'P'),
(17142, 'Milton', 30.6322193145752, 0.534633084232338, -87.0397186279297, -1.51912967006681, 218, 12, 'PPL', 'P'),
(27917, 'Milton', 39.5644416809082, 0.690529774045128, -90.6502838134766, -1.58214592041249, 218, 18, 'PPL', 'P'),
(30526, 'Milton', 39.7880592346191, 0.694432636622639, -85.1552810668945, -1.4862400300785, 218, 19, 'PPL', 'P'),
(33290, 'Milton', 37.4316711425781, 0.653305905961736, -97.771110534668, -1.70642779216127, 218, 20, 'PPL', 'P'),
(37216, 'Milton', 38.7236099243164, 0.675854491437274, -85.3694381713867, -1.48997777666843, 218, 21, 'PPL', 'P'),
(42109, 'Milton', 30.103609085083, 0.525407095267976, -92.0763931274414, -1.60703622343453, 218, 22, 'PPL', 'P'),
(49521, 'Milton', 38.4977798461914, 0.671913013023956, -76.1855621337891, -1.32968890171734, 218, 25, 'PPL', 'P'),
(60904, 'Milton', 31.8527793884277, 0.55593587623945, -89.5999984741211, -1.56381498315531, 218, 30, 'PPL', 'P'),
(66861, 'Milton', 36.538890838623, 0.637723950160764, -79.2088928222656, -1.38245597660784, 218, 33, 'PPL', 'P'),
(76613, 'Milton', 35.1616706848145, 0.613686923951982, -94.8633270263672, -1.65567739600623, 218, 42, 'PPL', 'P'),
(82423, 'Milton', 34.3522186279297, 0.599559320422302, -81.8899993896484, -1.42925011380551, 218, 48, 'PPL', 'P'),
(89062, 'Milton', 35.9297218322754, 0.627091945298895, -86.1816711425781, -1.50415391630897, 218, 50, 'PPL', 'P'),
(96235, 'Milton', 33.514720916748, 0.584942227884266, -95.3741683959961, -1.66459325986165, 218, 51, 'PPL', 'P'),
(104289, 'Milton', 37.3072204589844, 0.651133831776668, -77.0247192382813, -1.34433495613223, 218, 53, 'PPL', 'P'),
(110466, 'Milton', 38.434440612793, 0.670807534855464, -82.1324996948242, -1.43348254256792, 218, 58, 'PPL', 'P'),
(113727, 'Milton', 41.7700004577637, 0.729024036547515, -73.273063659668, -1.27885621388461, 218, 8, 'PPL', 'P'),
(116865, 'Milton', 40.6733283996582, 0.709883498318952, -92.1619415283203, -1.60852932469968, 218, 16, 'PPL', 'P'),
(125442, 'Milton', 42.249439239502, 0.737391821850598, -71.0666732788086, -1.24034743715428, 218, 23, 'PPL', 'P'),
(128151, 'Milton', 44.4477806091309, 0.775760116833424, -70.6536102294922, -1.23313812692539, 218, 26, 'PPL', 'P'),
(132119, 'Milton', 42.6891708374023, 0.745066586059016, -82.8219375610352, -1.44551550332123, 218, 27, 'PPL', 'P'),
(139333, 'Milton', 40.2847213745117, 0.703101026233765, -95.4169387817383, -1.6653397439152, 218, 29, 'PPL', 'P'),
(140511, 'Milton', 48.6263885498047, 0.848690583548163, -98.0422210693359, -1.71115956362807, 218, 34, 'PPL', 'P'),
(144156, 'Milton', 43.4097213745117, 0.757642565358588, -70.9888916015625, -1.23898989078862, 218, 36, 'PPL', 'P'),
(145775, 'Milton', 41.0213890075684, 0.715958301923477, -74.5361099243164, -1.30090052980774, 218, 37, 'PPL', 'P'),
(150771, 'Milton', 40.9619407653809, 0.714920734362782, -73.688606262207, -1.28610880048122, 218, 40, 'PPL', 'P'),
(164656, 'Milton', 41.0119400024414, 0.715793385672974, -76.8480606079102, -1.34125168138019, 218, 45, 'PPL', 'P'),
(172256, 'Milton', 44.639720916748, 0.779110107168635, -73.1108322143555, -1.27602474101364, 218, 55, 'PPL', 'P'),
(175329, 'Milton', 42.7755584716797, 0.746574334710164, -88.9438934326172, -1.55236378994213, 218, 57, 'PPL', 'P'),
(183299, 'Milton', 38.0319404602051, 0.663782581953026, -120.851112365723, -2.10924981547949, 218, 6, 'PPL', 'P'),
(193227, 'Milton', 41.060001373291, 0.716632214837322, -111.730278015137, -1.95006122553277, 218, 52, 'PPL', 'P'),
(208136, 'Milton', 47.2483291625977, 0.824638909953384, -122.311668395996, -2.13474132711762, 218, 56, 'PPL', 'P'),
(183300, 'Milton (historical)', 39.5233306884766, 0.689812251868433, -120.581108093262, -2.1045373519306, 218, 6, 'PPL', 'P'),
(125443, 'Milton Center', 42.2541694641113, 0.737474379844391, -71.0805587768555, -1.24058978481348, 218, 23, 'PPL', 'P'),
(150772, 'Milton Center', 43.040828704834, 0.75120417368624, -73.8902816772461, -1.28962870049398, 218, 40, 'PPL', 'P'),
(156520, 'Milton Center', 41.3025016784668, 0.72086464359973, -83.8288879394531, -1.46309010282882, 218, 41, 'PPL', 'P'),
(164657, 'Milton Grove', 40.1622200012207, 0.700962973931622, -76.5319366455078, -1.33573427739182, 218, 45, 'PPL', 'P'),
(104290, 'Milton Heights', 38.0074996948242, 0.663356010125423, -78.3880615234375, -1.36812976783987, 218, 53, 'PPL', 'P'),
(125444, 'Milton Hill', 42.2649993896484, 0.737663397702759, -71.0583267211914, -1.24020176224266, 218, 23, 'PPL', 'P'),
(104291, 'Milton Hills', 37.9902801513672, 0.663055472396407, -78.4055633544922, -1.3684352324169, 218, 53, 'PPL', 'P'),
(175330, 'Milton Junction', 42.7825012207031, 0.746695508539763, -88.9627838134766, -1.55269348928508, 218, 57, 'PPL', 'P'),
(144157, 'Milton Mills', 43.5011100769043, 0.759237599114464, -70.9641723632813, -1.23855845869202, 218, 36, 'PPL', 'P'),
(125445, 'Milton Upper Mills', 42.2611083984375, 0.737595487094962, -71.095832824707, -1.2408563672386, 218, 23, 'PPL', 'P'),
(125446, 'Milton Village', 42.2666702270508, 0.737692559316695, -71.0722198486328, -1.24044424305991, 218, 23, 'PPL', 'P'),
(201237, 'Milton-Freewater', 45.9327812194824, 0.801678266878184, -118.386672973633, -2.06623723387168, 218, 43, 'PPL', 'P'),
(136887, 'Miltona', 46.0441703796387, 0.803622374473942, -95.2911071777344, -1.66314356812227, 218, 28, 'PPL', 'P'),
(172259, 'Miltonboro', 44.6966705322266, 0.78010406546648, -73.1875, -1.27736284630335, 218, 55, 'PPL', 'P'),
(56279, 'Miltondale', 39.2583312988281, 0.685187140003293, -94.2219390869141, -1.64448306468019, 218, 29, 'PPL', 'P'),
(73490, 'Miltonsburg', 39.8305587768555, 0.695174393565253, -81.1655578613281, -1.41660622389814, 218, 41, 'PPL', 'P'),
(33293, 'Miltonvale', 39.348331451416, 0.686757938993249, -97.4458312988281, -1.70075059850749, 218, 20, 'PPL', 'P'),
(73491, 'Miltonville', 39.5008316040039, 0.689419568765701, -84.4608306884766, -1.47411958448339, 218, 41, 'PPL', 'P'),
(156525, 'Miltonville (historical)', 41.4925003051758, 0.724180745210069, -83.7111129760742, -1.46103454194144, 218, 41, 'PPL', 'P'),
(96236, 'Milvid', 30.4583301544189, 0.531598145854083, -94.79638671875, -1.65450906723601, 218, 51, 'PPL', 'P'),
(66863, 'Milwaukee', 36.4052810668945, 0.635392019731264, -77.2324981689453, -1.34796138258859, 218, 33, 'PPL', 'P'),
(164659, 'Milwaukee', 41.4225006103516, 0.722959020059996, -75.7780609130859, -1.32257666371017, 218, 45, 'PPL', 'P'),
(175334, 'Milwaukee', 43.038890838623, 0.751170351540396, -87.9063873291016, -1.53425589242625, 218, 57, 'PPL', 'P'),
(201238, 'Milwaukie', 45.4463882446289, 0.793189108008421, -122.638061523438, -2.14043796184736, 218, 43, 'PPL', 'P'),
(201239, 'Milwaukie Heights', 45.4302787780762, 0.792907944776336, -122.633331298828, -2.14035540385356, 218, 43, 'PPL', 'P'),
(132122, 'Milwood', 42.2591705322266, 0.737561664949118, -85.565559387207, -1.4934007376175, 218, 27, 'PPL', 'P'),
(96237, 'Milyca Colonia', 26.3110008239746, 0.459213593873298, -98.1920013427734, -1.71377372255409, 218, 51, 'PPL', 'P'),
(37217, 'Mima', 37.9205589294434, 0.661838607515323, -83.0366668701172, -1.44926323676524, 218, 21, 'PPL', 'P'),
(208137, 'Mima', 46.8655586242676, 0.817958303779893, -123.065277099609, -2.14789428026736, 218, 56, 'PPL', 'P'),
(189042, 'Mimbres', 31.8005599975586, 0.555024475935397, -107.753890991211, -1.88066017963169, 218, 38, 'PPL', 'P'),
(82425, 'Mimms Crossroads', 33.9388885498047, 0.592345349661495, -79.9116668701172, -1.39472169764042, 218, 48, 'PPL', 'P'),
(10514, 'Mimosa', 34.5038909912109, 0.602206502545841, -93.7433319091797, -1.63612979360505, 218, 4, 'PPL', 'P'),
(89063, 'Mimosa', 35.2202796936035, 0.614709844126681, -86.519172668457, -1.51004442916606, 218, 50, 'PPL', 'P'),
(49522, 'Mimosa Cove', 38.7838897705078, 0.676906573225909, -76.5441665649414, -1.33594772975319, 218, 25, 'PPL', 'P'),
(89064, 'Mimosa Estates', 35.8477783203125, 0.625661761214496, -83.9683303833008, -1.46552383259099, 218, 50, 'PPL', 'P'),
(42110, 'Mimosa Gardens', 32.5505599975586, 0.568114445325355, -93.5605621337891, -1.63293985925135, 218, 22, 'PPL', 'P'),
(89065, 'Mimosa Heights', 35.8383293151855, 0.625496844963992, -83.9669418334961, -1.46549959782507, 218, 50, 'PPL', 'P'),
(104292, 'Mimosa Hills', 37.6819381713867, 0.65767388962363, -77.3791732788086, -1.35052134618643, 218, 53, 'PPL', 'P'),
(42111, 'Mimosa Park', 29.9061107635498, 0.521960099290059, -90.3561096191406, -1.57701161214692, 218, 22, 'PPL', 'P'),
(66865, 'Mimosa Shores', 35.5194396972656, 0.619931171180863, -77.0177764892578, -1.34421378230263, 218, 33, 'PPL', 'P'),
(17143, 'Mims', 28.6650009155273, 0.500298646063141, -80.8450012207031, -1.4110114550801, 218, 12, 'PPL', 'P'),
(60903, 'Mims', 34.2291717529297, 0.597411747319262, -90.1288909912109, -1.57304589896769, 218, 30, 'PPL', 'P'),
(82426, 'Mims', 33.8472213745117, 0.59074545563663, -81.4916687011719, -1.42229793177986, 218, 48, 'PPL', 'P'),
(96238, 'Mims', 29.0869407653809, 0.507662885688455, -95.2869415283203, -1.66307086382451, 218, 51, 'PPL', 'P'),
(89066, 'Mims (historical)', 36.4241714477539, 0.635721719074215, -86.6305618286133, -1.51198853676182, 218, 50, 'PPL', 'P'),
(96239, 'Mims Chapel', 32.8432693481445, 0.573223187244454, -94.6304779052734, -1.65161341218277, 218, 51, 'PPL', 'P'),
(23111, 'Mimsville', 31.2555599212646, 0.545512430180448, -84.5286102294922, -1.4753025606396, 218, 13, 'PPL', 'P'),
(37220, 'Mina', 37.8624992370605, 0.660825274720548, -84.0672225952148, -1.46724982729347, 218, 21, 'PPL', 'P'),
(150774, 'Mina', 42.1300010681152, 0.735307232507339, -79.6883316040039, -1.39082376191092, 218, 40, 'PPL', 'P'),
(156526, 'Mina', 41.4538917541504, 0.723506898875252, -84.7111129760742, -1.47848783446139, 218, 41, 'PPL', 'P'),
(164660, 'Mina', 41.7438888549805, 0.728568303105975, -78.086669921875, -1.36286949205474, 218, 45, 'PPL', 'P'),
(170888, 'Mina', 45.4333305358887, 0.792961207998137, -98.7583312988281, -1.72365804493992, 218, 49, 'PPL', 'P'),
(183301, 'Mina', 39.9650001525879, 0.697520838222695, -123.357223510742, -2.15298970638101, 218, 6, 'PPL', 'P'),
(190485, 'Mina', 38.3905601501465, 0.670041676304985, -118.107780456543, -2.06136964118929, 218, 39, 'PPL', 'P'),
(201240, 'Minam', 45.621940612793, 0.796253074842557, -117.722221374512, -2.05464036574687, 218, 43, 'PPL', 'P'),
(132123, 'Minards Mill', 42.3375015258789, 0.73892879869471, -84.5469436645508, -1.47562253944457, 218, 27, 'PPL', 'P'),
(199532, 'Minatare', 41.809440612793, 0.729712397110273, -103.503326416016, -1.80647383272589, 218, 35, 'PPL', 'P'),
(56280, 'Minaville', 39.163330078125, 0.683529055908609, -94.4622192382813, -1.64867674444874, 218, 29, 'PPL', 'P'),
(150776, 'Minaville', 42.8858299255371, 0.748498934650937, -74.2169418334961, -1.29532999575562, 218, 40, 'PPL', 'P'),
(175338, 'Minawa Beach', 43.8463897705078, 0.765263866608122, -88.3813934326172, -1.54254631289966, 218, 57, 'PPL', 'P'),
(116866, 'Minburn', 41.7563896179199, 0.72878648257828, -94.0272216796875, -1.64108460481314, 218, 16, 'PPL', 'P'),
(110467, 'Mincar (historical)', 38.0088882446289, 0.663380244891342, -81.0338897705078, -1.41430818219351, 218, 58, 'PPL', 'P'),
(96240, 'Minchin', 33.1791687011719, 0.5790857369101, -97.1533279418945, -1.69564545185587, 218, 51, 'PPL', 'P'),
(76615, 'Minco', 35.3127784729004, 0.616324252379487, -97.9441680908203, -1.70944821631158, 218, 42, 'PPL', 'P'),
(56283, 'Mincy', 36.5641708374023, 0.638165169374363, -93.1100006103516, -1.62507607718456, 218, 29, 'PPL', 'P'),
(120644, 'Mindale', 40.4258308410645, 0.705563851030843, -89.3697204589844, -1.55979587359622, 218, 18, 'PPL', 'P'),
(187060, 'Mindeman', 37.7069396972656, 0.658110248568239, -103.916107177734, -1.81367821610678, 218, 7, 'PPL', 'P'),
(42112, 'Minden', 32.6152801513672, 0.569244025101712, -93.2866668701172, -1.62815948509466, 218, 22, 'PPL', 'P'),
(96241, 'Minden', 32.0133285522461, 0.558737987759404, -94.7072219848633, -1.65295284905302, 218, 51, 'PPL', 'P'),
(110468, 'Minden', 37.975830078125, 0.662803271041177, -81.1197204589844, -1.41580621030668, 218, 58, 'PPL', 'P'),
(116867, 'Minden', 41.4669418334961, 0.723734665727481, -95.5425033569336, -1.66753125917623, 218, 16, 'PPL', 'P'),
(142436, 'Minden', 40.4986114501953, 0.706834112291784, -98.9475021362305, -1.72695969890134, 218, 35, 'PPL', 'P'),
(190487, 'Minden', 38.9541702270508, 0.679878527844383, -119.764717102051, -2.09028864115035, 218, 39, 'PPL', 'P'),
(4235, 'Minden (historical)', 33.702220916748, 0.588214720231755, -86.1061096191406, -1.50283511893716, 218, 2, 'PPL', 'P'),
(132124, 'Minden City', 43.6713905334473, 0.762209553732938, -82.7783279418945, -1.44475437188168, 218, 27, 'PPL', 'P'),
(56282, 'Mindenmines', 37.4713897705078, 0.653999126793484, -94.5897216796875, -1.65090208185561, 218, 29, 'PPL', 'P'),
(150778, 'Mindenville', 42.9919395446777, 0.750350896872978, -74.7180633544922, -1.30407621624961, 218, 40, 'PPL', 'P'),
(175339, 'Mindoro', 44.021110534668, 0.768313319214317, -91.1016693115234, -1.59002408354916, 218, 57, 'PPL', 'P'),
(145776, 'Mine Brook', 40.6930618286133, 0.710227911626926, -74.6074981689453, -1.30214648972374, 218, 37, 'PPL', 'P'),
(197057, 'Mine Creek', 46.105281829834, 0.804688970490519, -112.882781982422, -1.97017621440419, 218, 31, 'PPL', 'P'),
(145777, 'Mine Hill', 40.8777809143066, 0.713451867863549, -74.5941696166992, -1.30191386260252, 218, 37, 'PPL', 'P'),
(56284, 'Mine La Motte', 37.6155586242676, 0.656515347970418, -90.2897186279297, -1.57585287075663, 218, 29, 'PPL', 'P'),
(104294, 'Mine Run', 38.2572212219238, 0.667714472986419, -77.8377838134766, -1.35852561000071, 218, 53, 'PPL', 'P'),
(49527, 'Minefield', 39.6525001525879, 0.692066684310213, -76.383056640625, -1.33313583111623, 218, 25, 'PPL', 'P'),
(37219, 'Minefork', 37.8633308410645, 0.660839788948488, -83.0119400024414, -1.44883167151059, 218, 21, 'PPL', 'P'),
(4236, 'Mineola', 31.2794399261475, 0.545929214891045, -87.6338882446289, -1.52949988619353, 218, 2, 'PPL', 'P'),
(10517, 'Mineola', 34.3133316040039, 0.598880613818495, -94.0305633544922, -1.64114292804101, 218, 4, 'PPL', 'P'),
(23112, 'Mineola', 30.9074993133545, 0.539437626575923, -83.3436126708984, -1.45462045161404, 218, 13, 'PPL', 'P'),
(56286, 'Mineola', 38.8880615234375, 0.678724713302106, -91.5713882446289, -1.59822222549081, 218, 29, 'PPL', 'P'),
(96242, 'Mineola', 32.6630592346191, 0.570077927418043, -95.4880599975586, -1.66658104329929, 218, 51, 'PPL', 'P'),
(116869, 'Mineola', 41.1430587768555, 0.718081839997679, -95.6952819824219, -1.67019774921767, 218, 16, 'PPL', 'P'),
(150779, 'Mineola', 40.7491683959961, 0.711207155959748, -73.64111328125, -1.28527989159194, 218, 40, 'PPL', 'P'),
(56287, 'Miner', 36.8913917541504, 0.643876251753011, -89.538330078125, -1.56273866660075, 218, 29, 'PPL', 'P'),
(116870, 'Miner', 42.7147216796875, 0.74551253238355, -92.1011123657227, -1.60746765553112, 218, 16, 'PPL', 'P'),
(197058, 'Miner', 45.1991691589355, 0.788874320989301, -110.907783508301, -1.93570598830892, 218, 31, 'PPL', 'P'),
(96243, 'Minera', 27.7219390869141, 0.483839112103961, -99.7577819824219, -1.74110175007994, 218, 51, 'PPL', 'P'),
(10518, 'Mineral', 34.1894416809082, 0.596718326750433, -94.3327789306641, -1.64641758489602, 218, 4, 'PPL', 'P'),
(73492, 'Mineral', 39.3238906860352, 0.686331367165645, -82.2647171020508, -1.43579017165247, 218, 41, 'PPL', 'P'),
(96244, 'Mineral', 28.5483303070068, 0.498262359804153, -97.9038925170898, -1.70874527494186, 218, 51, 'PPL', 'P'),
(104295, 'Mineral', 38.0105590820313, 0.663409406505279, -77.9088897705078, -1.35976664306869, 218, 53, 'PPL', 'P'),
(120645, 'Mineral', 41.3824996948242, 0.722260872380231, -89.8363876342773, -1.56794075231606, 218, 18, 'PPL', 'P'),
(193790, 'Mineral', 40.3477783203125, 0.70420157755424, -121.593887329102, -2.12221368419184, 218, 6, 'PPL', 'P'),
(195332, 'Mineral', 44.5652809143066, 0.77781088403084, -117.076667785645, -2.04337333012308, 218, 17, 'PPL', 'P'),
(200074, 'Mineral', 40.1736106872559, 0.701161778906997, -116.185829162598, -2.02782526304698, 218, 39, 'PPL', 'P'),
(208138, 'Mineral', 46.7172203063965, 0.815369311726173, -122.179718017578, -2.13243835856498, 218, 56, 'PPL', 'P'),
(10519, 'Mineral (historical)', 34.874439239502, 0.608673789516016, -92.2938919067383, -1.61083229325233, 218, 4, 'PPL', 'P'),
(42113, 'Mineral (historical)', 31.8694400787354, 0.556226660140973, -93.4569396972656, -1.63113130655508, 218, 22, 'PPL', 'P'),
(104296, 'Mineral (historical)', 37.4874992370605, 0.654280290025569, -78.9069366455078, -1.37718584712668, 218, 53, 'PPL', 'P'),
(110469, 'Mineral Acres', 39.1783294677734, 0.683790844643764, -81.5100021362305, -1.42261791058483, 218, 58, 'PPL', 'P'),
(23113, 'Mineral Bluff', 34.9144401550293, 0.609371937195781, -84.2766723632813, -1.47090541536377, 218, 13, 'PPL', 'P'),
(30529, 'Mineral City', 38.9941711425781, 0.680576675524147, -86.879997253418, -1.51634200619577, 218, 19, 'PPL', 'P'),
(56288, 'Mineral City', 37.7163887023926, 0.658275164818742, -90.5336074829102, -1.58010953428496, 218, 29, 'PPL', 'P'),
(110470, 'Mineral City', 37.7336082458496, 0.658575702547758, -81.8238906860352, -1.42809629926324, 218, 58, 'PPL', 'P'),
(156527, 'Mineral City', 40.6011085510254, 0.708623024175017, -81.3613891601563, -1.42002412484115, 218, 41, 'PPL', 'P'),
(190490, 'Mineral City', 39.2644386291504, 0.685293733025923, -114.946937561035, -2.0062025255244, 218, 39, 'PPL', 'P'),
(27918, 'Mineral City (historical)', 37.4094390869141, 0.652917883390912, -88.3533325195313, -1.5420565575752, 218, 18, 'PPL', 'P'),
(96245, 'Mineral Heights', 33.1100006103516, 0.577878525987967, -96.1158294677734, -1.67753768749804, 218, 51, 'PPL', 'P'),
(189043, 'Mineral Hill', 35.6097183227539, 0.621506830439808, -105.400833129883, -1.83959157246158, 218, 38, 'PPL', 'P'),
(132126, 'Mineral Hills', 46.1133308410645, 0.804829452238021, -88.6477813720703, -1.54719565953072, 218, 27, 'PPL', 'P'),
(187062, 'Mineral Hot Springs', 38.1688919067383, 0.666172835610399, -105.925277709961, -1.84874485712818, 218, 7, 'PPL', 'P'),
(183302, 'Mineral King', 36.4508285522461, 0.636186973316652, -118.593887329102, -2.06985380663201, 218, 6, 'PPL', 'P'),
(89069, 'Mineral Park', 35.1005592346191, 0.612620327935405, -85.0063934326172, -1.48364145064485, 218, 50, 'PPL', 'P'),
(56289, 'Mineral Point', 37.9447212219238, 0.662260319073937, -90.7241668701172, -1.5834354230123, 218, 29, 'PPL', 'P'),
(164662, 'Mineral Point', 40.3794403076172, 0.704754183480432, -78.835563659668, -1.3759401535268, 218, 45, 'PPL', 'P'),
(175341, 'Mineral Point', 42.8600006103516, 0.748048128057414, -90.1797180175781, -1.57393299792679, 218, 57, 'PPL', 'P'),
(156528, 'Mineral Ridge', 41.1399993896484, 0.718028443617823, -80.769172668457, -1.40968799717639, 218, 41, 'PPL', 'P'),
(183303, 'Mineral Slide', 39.7852783203125, 0.694384100511772, -121.61888885498, -2.12265004313645, 218, 6, 'PPL', 'P'),
(49524, 'Mineral Spring', 39.7080612182617, 0.693036407842138, -79.3505630493164, -1.38492858852192, 218, 25, 'PPL', 'P'),
(56290, 'Mineral Spring', 36.6705589294434, 0.640021991865394, -93.7727813720703, -1.63664378369543, 218, 29, 'PPL', 'P'),
(164666, 'Mineral Spring', 40.7261085510254, 0.71080468574001, -79.8008270263672, -1.39278717742458, 218, 45, 'PPL', 'P'),
(66872, 'Mineral Spring (historical)', 35.4169387817383, 0.618142192718602, -81.0119400024414, -1.41392508647071, 218, 33, 'PPL', 'P'),
(4238, 'Mineral Springs', 33.6261100769043, 0.586886335480024, -86.8786087036133, -1.51631777142985, 218, 2, 'PPL', 'P'),
(10522, 'Mineral Springs', 33.875, 0.591230284113079, -93.9136123657227, -1.63910174822352, 218, 4, 'PPL', 'P'),
(17144, 'Mineral Springs', 30.8325004577637, 0.538128649610635, -87.2958297729492, -1.52359965279846, 218, 12, 'PPL', 'P'),
(33294, 'Mineral Springs', 38.8408317565918, 0.6779003983657, -95.6866683959961, -1.67004741377413, 218, 20, 'PPL', 'P'),
(42122, 'Mineral Springs', 32.4583282470703, 0.566504697604456, -92.3591690063477, -1.61197159356667, 218, 22, 'PPL', 'P'),
(60905, 'Mineral Springs', 31.9508304595947, 0.557647190266421, -89.4283294677734, -1.56081879377091, 218, 30, 'PPL', 'P'),
(66869, 'Mineral Springs', 34.9377784729004, 0.609779267684508, -80.6688919067383, -1.40793776770799, 218, 33, 'PPL', 'P'),
(73493, 'Mineral Springs', 38.8869400024414, 0.678705139068094, -83.3294372558594, -1.45437304394877, 218, 41, 'PPL', 'P'),
(89068, 'Mineral Springs', 36.1616706848145, 0.631140216471925, -85.2252807617188, -1.48746175522857, 218, 50, 'PPL', 'P'),
(104298, 'Mineral Springs', 38.9116706848145, 0.679136770901769, -78.2294387817383, -1.36536127872867, 218, 53, 'PPL', 'P'),
(110472, 'Mineral Springs', 38.1230583190918, 0.665372888597967, -82.5824966430664, -1.44133647093867, 218, 58, 'PPL', 'P'),
(123212, 'Mineral Springs', 41.3261108398438, 0.721276701199392, -85.7441711425781, -1.4965181008315, 218, 19, 'PPL', 'P'),
(150780, 'Mineral Springs', 42.670280456543, 0.744736886716064, -74.4513931274414, -1.29942194277053, 218, 40, 'PPL', 'P'),
(164663, 'Mineral Springs', 40.9980583190918, 0.715551104592804, -78.3638916015625, -1.3677079231232, 218, 45, 'PPL', 'P'),
(23114, 'Mineral Springs (historical)', 34.4888916015625, 0.601944713810686, -85.4855575561523, -1.49200444225798, 218, 13, 'PPL', 'P'),
(96246, 'Mineral Springs (historical)', 29.775089263916, 0.519673342730549, -97.6793823242188, -1.70482683287197, 218, 51, 'PPL', 'P'),
(120647, 'Mineral Springs (historical)', 41.7125015258789, 0.728020490869746, -90.1061096191406, -1.57264828901694, 218, 18, 'PPL', 'P'),
(56291, 'Mineral Springs City', 37.336669921875, 0.651647821867053, -91.9491729736328, -1.60481581287568, 218, 29, 'PPL', 'P'),
(60906, 'Mineral Wells', 34.9905586242676, 0.610700455105567, -89.8655624389648, -1.56844994871648, 218, 30, 'PPL', 'P'),
(96247, 'Mineral Wells', 32.8083305358887, 0.572613389933853, -98.1125030517578, -1.71238621562616, 218, 51, 'PPL', 'P'),
(110473, 'Mineralwells', 39.1902809143066, 0.683999436736145, -81.5322189331055, -1.42300566683955, 218, 58, 'PPL', 'P'),
(189044, 'Minero', 31.9349994659424, 0.557370887303325, -108.375831604004, -1.8915150910768, 218, 38, 'PPL', 'P'),
(23118, 'Miners Creek', 33.6527786254883, 0.587351789459542, -84.1791687011719, -1.46920365542721, 218, 13, 'PPL', 'P'),
(209610, 'Miners Delight', 42.5330581665039, 0.742341905947756, -108.680000305176, -1.89682383639376, 218, 59, 'PPL', 'P'),
(164665, 'Miners Mills', 41.2669410705566, 0.720243993907687, -75.8322219848633, -1.32352195273909, 218, 45, 'PPL', 'P'),
(49525, 'Miners Ridge', 39.4413909912109, 0.688382134363061, -76.9333267211914, -1.34273985579732, 218, 25, 'PPL', 'P'),
(164673, 'Miners Village', 40.2669410705566, 0.702790701387744, -76.3988876342773, -1.33341213407932, 218, 45, 'PPL', 'P'),
(73497, 'Minersville', 39.0224990844727, 0.681071091380521, -81.9936065673828, -1.43105840018568, 218, 41, 'PPL', 'P'),
(89070, 'Minersville', 36.160831451416, 0.631125569085929, -84.2072219848633, -1.46969327759362, 218, 50, 'PPL', 'P'),
(142437, 'Minersville', 40.5969390869141, 0.708550253298231, -95.7888870239258, -1.67183146538838, 218, 35, 'PPL', 'P'),
(164668, 'Minersville', 40.690559387207, 0.710184235785049, -76.2624969482422, -1.33103166753895, 218, 45, 'PPL', 'P'),
(175344, 'Minersville', 46.4069404602051, 0.809953906807551, -90.7972183227539, -1.58471041138418, 218, 57, 'PPL', 'P'),
(192702, 'Minersville', 38.214168548584, 0.666963062084853, -112.922782897949, -1.97087436208396, 218, 52, 'PPL', 'P'),
(49526, 'Minersville (historical)', 39.252498626709, 0.685085340670624, -76.6391677856445, -1.33760581384787, 218, 25, 'PPL', 'P'),
(193792, 'Minersville (historical)', 40.851390838623, 0.71299127415302, -122.781936645508, -2.14294905643919, 218, 6, 'PPL', 'P'),
(73495, 'Minerton', 39.0666694641113, 0.681842009937071, -82.4038925170898, -1.43821924088274, 218, 41, 'PPL', 'P'),
(37221, 'Minerva', 38.7052803039551, 0.675534579211328, -83.9191665649414, -1.46466576208777, 218, 21, 'PPL', 'P'),
(60907, 'Minerva', 33.5283317565918, 0.585179781853501, -89.5791702270508, -1.56345146166651, 218, 30, 'PPL', 'P'),
(96248, 'Minerva', 30.7580604553223, 0.53682942647284, -96.9877777099609, -1.69275605523118, 218, 51, 'PPL', 'P'),
(110474, 'Minerva', 38.1624984741211, 0.666061249160725, -82.2375030517578, -1.43531519687206, 218, 58, 'PPL', 'P'),
(116871, 'Minerva', 42.1163902282715, 0.735069678538104, -93.0877838134766, -1.62468832092985, 218, 16, 'PPL', 'P'),
(136891, 'Minerva', 47.3691711425781, 0.826748000378673, -95.3819427490234, -1.66472894791919, 218, 28, 'PPL', 'P'),
(150781, 'Minerva', 43.791389465332, 0.764303930193203, -73.9847183227539, -1.29127693089263, 218, 40, 'PPL', 'P'),
(156529, 'Minerva', 40.7297210693359, 0.710867736078818, -81.1055603027344, -1.41555906895752, 218, 41, 'PPL', 'P'),
(190491, 'Minerva', 38.8283309936523, 0.677682218893395, -114.391387939453, -1.99650635546959, 218, 39, 'PPL', 'P'),
(201241, 'Minerva', 44.0708312988281, 0.76918111025552, -123.959167480469, -2.16349561056526, 218, 43, 'PPL', 'P'),
(156530, 'Minerva Junction', 40.711669921875, 0.710552684121861, -81.1516723632813, -1.41636387623895, 218, 41, 'PPL', 'P'),
(156531, 'Minerva Park', 40.0763893127441, 0.699464945818453, -82.9438934326172, -1.44764403482247, 218, 41, 'PPL', 'P'),
(42115, 'Minerva Plantation', 29.708890914917, 0.518517963581132, -90.8161087036133, -1.58504011072713, 218, 22, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(164670, 'Minerville', 41.6169395446777, 0.726352619658056, -76.6316680908203, -1.33747491948029, 218, 45, 'PPL', 'P'),
(139335, 'Mines', 40.2125015258789, 0.701840552089831, -92.8133316040039, -1.61989822623518, 218, 29, 'PPL', 'P'),
(164671, 'Minesite', 40.5530586242676, 0.707784394747751, -75.5297164916992, -1.31824223587801, 218, 45, 'PPL', 'P'),
(150782, 'Minetto', 43.3980598449707, 0.757439033272279, -76.477783203125, -1.33478912152095, 218, 40, 'PPL', 'P'),
(150784, 'Mineville', 44.0927810668945, 0.769564205978328, -73.5186080932617, -1.28314177271077, 218, 40, 'PPL', 'P'),
(156532, 'Mineyahta-on-the Bay', 41.5133285522461, 0.724544266698865, -82.7416687011719, -1.44411454742979, 218, 41, 'PPL', 'P'),
(73496, 'Minford', 38.8588905334473, 0.678215583480711, -82.8622207641602, -1.44621857784901, 218, 41, 'PPL', 'P'),
(56294, 'Mingo', 36.9372215270996, 0.644676132186416, -90.1999969482422, -1.57428693203566, 218, 29, 'PPL', 'P'),
(60908, 'Mingo', 34.6319389343262, 0.604441360753608, -88.1502838134766, -1.53851268911263, 218, 30, 'PPL', 'P'),
(66871, 'Mingo', 35.1883316040039, 0.614152244773446, -78.5686111450195, -1.3712809531997, 218, 33, 'PPL', 'P'),
(76616, 'Mingo', 36.2205581665039, 0.632167996915614, -95.8686065673828, -1.67322283389989, 218, 42, 'PPL', 'P'),
(96249, 'Mingo', 33.2466697692871, 0.580263852797324, -97.0605621337891, -1.69402638307115, 218, 51, 'PPL', 'P'),
(110475, 'Mingo', 38.4986114501953, 0.671927527251897, -80.054443359375, -1.3972136174724, 218, 58, 'PPL', 'P'),
(116873, 'Mingo', 41.7675018310547, 0.728980427284665, -93.283332824707, -1.62810129502484, 218, 16, 'PPL', 'P'),
(156533, 'Mingo', 40.2080612182617, 0.701763054102109, -83.6383285522461, -1.45976421410148, 218, 41, 'PPL', 'P'),
(164672, 'Mingo', 40.1686096191406, 0.701074493802269, -75.5236129760742, -1.31813570943441, 218, 45, 'PPL', 'P'),
(187810, 'Mingo', 39.2783317565918, 0.685536213843175, -100.961936950684, -1.76211821898035, 218, 20, 'PPL', 'P'),
(156534, 'Mingo Junction', 40.3216705322266, 0.703745910691728, -80.6100006103516, -1.40690992068527, 218, 41, 'PPL', 'P'),
(128153, 'Mingo Springs', 44.9552803039551, 0.784617657460973, -70.7147216796875, -1.23420472294196, 218, 26, 'PPL', 'P'),
(33296, 'Mingona', 37.3238906860352, 0.651424782125759, -98.6900024414063, -1.72246548140378, 218, 20, 'PPL', 'P'),
(164674, 'Mingoville', 40.9322204589844, 0.714402017161462, -77.6483306884766, -1.35521902919127, 218, 45, 'PPL', 'P'),
(96250, 'Mings Chapel', 32.6439895629883, 0.56974509886081, -94.95703125, -1.65731284323165, 218, 51, 'PPL', 'P'),
(56296, 'Mingsville', 37.4516716003418, 0.653654979801618, -92.3394393920898, -1.61162724683772, 218, 29, 'PPL', 'P'),
(96251, 'Mingus', 32.5377807617188, 0.567891405584061, -98.4219436645508, -1.71778697315878, 218, 51, 'PPL', 'P'),
(195333, 'Minidoka', 42.7538909912109, 0.746196165835373, -113.489440917969, -1.98076441026613, 218, 17, 'PPL', 'P'),
(120649, 'Minier', 40.4336090087891, 0.70569960566741, -89.3130569458008, -1.55880690872541, 218, 18, 'PPL', 'P'),
(56297, 'Minimum', 37.3761100769043, 0.652336182429811, -90.5875015258789, -1.58105016278197, 218, 29, 'PPL', 'P'),
(37222, 'Mining City', 37.2272186279297, 0.649737536417139, -86.7788925170898, -1.51457739565749, 218, 21, 'PPL', 'P'),
(23115, 'Minish', 34.1569404602051, 0.596151073438246, -83.3597183227539, -1.4549015482671, 218, 13, 'PPL', 'P'),
(150786, 'Minisink Ford', 41.4824981689453, 0.724006175000615, -74.9772186279297, -1.308599329045, 218, 40, 'PPL', 'P'),
(164675, 'Minisink Hills', 41.0002784729004, 0.715589853586664, -75.1374969482422, -1.31139671345402, 218, 45, 'PPL', 'P'),
(164676, 'Minister', 41.6188888549805, 0.726386641540982, -79.1486129760742, -1.3814038948192, 218, 45, 'PPL', 'P'),
(42116, 'Mink', 31.3947200775146, 0.5479412330946, -93.070556640625, -1.62438765004278, 218, 22, 'PPL', 'P'),
(4239, 'Mink (historical)', 33.8977813720703, 0.591627894063828, -85.7938919067383, -1.4973858918727, 218, 2, 'PPL', 'P'),
(110478, 'Mink (historical)', 38.4375, 0.67086093123532, -81.5722198486328, -1.42370381451931, 218, 58, 'PPL', 'P'),
(197060, 'Mink (historical)', 47.3461112976074, 0.826345530158934, -105.271667480469, -1.83733720659882, 218, 31, 'PPL', 'P'),
(195335, 'Mink Creek', 42.228328704834, 0.737023373513786, -111.714996337891, -1.9497945099496, 218, 17, 'PPL', 'P'),
(82428, 'Mink Creek Estates', 34.976390838623, 0.610453180598353, -82.2013931274414, -1.43468495980009, 218, 48, 'PPL', 'P'),
(82427, 'Mink Point Plantation', 32.4097213745117, 0.565656347639212, -80.7169418334961, -1.40877639713526, 218, 48, 'PPL', 'P'),
(56298, 'Minke', 38.5386085510254, 0.672625608352634, -90.5605621337891, -1.58057998169152, 218, 29, 'PPL', 'P'),
(183304, 'Minkler', 36.7238883972168, 0.640952766666376, -119.457221984863, -2.08492183892162, 218, 6, 'PPL', 'P'),
(208139, 'Minkler', 48.5213890075684, 0.846857995823052, -122.110832214355, -2.13123607449086, 218, 56, 'PPL', 'P'),
(49528, 'Minksville (historical)', 38.3583297729492, 0.669479150103733, -75.5341720581055, -1.31832000018184, 218, 25, 'PPL', 'P'),
(89071, 'Minkton (historical)', 36.4411087036133, 0.636017329955214, -83.6791687011719, -1.46047700916724, 218, 50, 'PPL', 'P'),
(33298, 'Minneapolis', 39.121940612793, 0.682806673462925, -97.7063903808594, -1.70529821238491, 218, 20, 'PPL', 'P'),
(66875, 'Minneapolis', 36.0991706848145, 0.630049385689428, -81.9872207641602, -1.43094694689406, 218, 33, 'PPL', 'P'),
(136893, 'Minneapolis', 44.9799995422363, 0.785049089557566, -93.2636108398438, -1.62775708145395, 218, 28, 'PPL', 'P'),
(33300, 'Minneha', 37.7144393920898, 0.658241142935816, -97.2397232055664, -1.69715333366507, 218, 20, 'PPL', 'P'),
(150788, 'Minnehaha', 43.6616706848145, 0.7620399103715, -75.0683288574219, -1.31018950253188, 218, 40, 'PPL', 'P'),
(178648, 'Minnehaha', 34.163330078125, 0.596262593308893, -112.406669616699, -1.96186648601287, 218, 5, 'PPL', 'P'),
(187063, 'Minnehaha', 38.8494415283203, 0.678050667230207, -104.958892822266, -1.83187825899638, 218, 7, 'PPL', 'P'),
(208140, 'Minnehaha', 45.6591682434082, 0.796902819569509, -122.647499084473, -2.14060267836078, 218, 56, 'PPL', 'P'),
(110479, 'Minnehaha Springs', 38.1630592346191, 0.666071036277731, -79.9811096191406, -1.39593370225251, 218, 58, 'PPL', 'P'),
(73498, 'Minnehan Bend', 39.2105598449707, 0.684353370845016, -83.1527786254883, -1.45128976919674, 218, 41, 'PPL', 'P'),
(136895, 'Minneiska', 44.1949996948242, 0.771348257592572, -91.8716735839844, -1.60346319335803, 218, 28, 'PPL', 'P'),
(202383, 'Minnekahta', 43.4305610656738, 0.758006286584466, -103.687782287598, -1.80969319500964, 218, 49, 'PPL', 'P'),
(183305, 'Minnelusa', 34.2663917541504, 0.59806135888816, -116.891670227051, -2.04014451361746, 218, 6, 'PPL', 'P'),
(17145, 'Minneola', 28.5741691589355, 0.498713332845244, -81.7463912963867, -1.42674367974558, 218, 12, 'PPL', 'P'),
(183307, 'Minneola', 34.8461112976074, 0.608179373659643, -116.776107788086, -2.03812756856589, 218, 6, 'PPL', 'P'),
(187811, 'Minneola', 37.4433288574219, 0.653509371469018, -100.014717102051, -1.74558611388147, 218, 20, 'PPL', 'P'),
(136899, 'Minneota', 44.5588912963867, 0.777699364160193, -95.9852828979492, -1.67525922002742, 218, 28, 'PPL', 'P'),
(197061, 'Minneota (historical)', 48.8855590820313, 0.853213962659662, -110.663330078125, -1.93143947108456, 218, 31, 'PPL', 'P'),
(164677, 'Minnequa', 41.6738891601563, 0.727346577955901, -76.8341674804688, -1.34100920056294, 218, 45, 'PPL', 'P'),
(14249, 'Minners Corners', 38.9705581665039, 0.680164551345458, -75.6305618286133, -1.32000231904245, 218, 10, 'PPL', 'P'),
(209611, 'Minnesela', 43.5858306884766, 0.760716252730703, -108.21639251709, -1.88873235405377, 218, 59, 'PPL', 'P'),
(23116, 'Minnesota', 31.3116703033447, 0.546491741092297, -83.9102783203125, -1.46451063295427, 218, 13, 'PPL', 'P'),
(136909, 'Minnesota', 46.2502784729004, 0.807219639316367, -94.2502822875977, -1.64497774685267, 218, 28, 'ADM1', 'A'),
(193793, 'Minnesota', 40.6622200012207, 0.709689620191594, -122.487777709961, -2.13781501448974, 218, 6, 'PPL', 'P'),
(136902, 'Minnesota Boys Town', 45.5566711425781, 0.795113907686275, -93.1763916015625, -1.62623481857486, 218, 28, 'PPL', 'P'),
(136903, 'Minnesota City', 44.0938911437988, 0.769583580475258, -91.7494430541992, -1.60132986816682, 218, 28, 'PPL', 'P'),
(178649, 'Minnesota Court', 33.4513893127441, 0.583836882873828, -111.968063354492, -1.9542113626175, 218, 5, 'PPL', 'P'),
(183306, 'Minnesota Flat', 39.4494400024414, 0.688522616110562, -120.830001831055, -2.10888136714268, 218, 6, 'PPL', 'P'),
(175345, 'Minnesota Junction', 43.4524993896484, 0.758389182570192, -88.6969375610352, -1.54805359687589, 218, 57, 'PPL', 'P'),
(136906, 'Minnesota Lake', 43.8419418334961, 0.765186235462346, -93.831672668457, -1.63767163071815, 218, 28, 'PPL', 'P'),
(96252, 'Minnesota Road-I Road Colonia', 26.2390003204346, 0.45795694802343, -98.1559982299805, -1.71314534969489, 218, 51, 'PPL', 'P'),
(197063, 'Minnesota Settlement (historical)', 48.8083305358887, 0.851866070252946, -109.111106872559, -1.90434806542156, 218, 31, 'PPL', 'P'),
(66874, 'Minnesott Beach', 34.9686088562012, 0.610317359382759, -76.8119430541992, -1.34062131115017, 218, 33, 'PPL', 'P'),
(23117, 'Minneta', 33.2855606079102, 0.580942625980158, -83.711669921875, -1.46104426247942, 218, 13, 'PPL', 'P'),
(96256, 'Minnetex', 29.6163902282715, 0.516903522038812, -95.3550033569336, -1.66425876682874, 218, 51, 'PPL', 'P'),
(136910, 'Minnetonka', 44.913330078125, 0.783885487898283, -93.503059387207, -1.63193624699455, 218, 28, 'PPL', 'P'),
(136911, 'Minnetonka Beach', 44.9397201538086, 0.784346081608812, -93.5763931274414, -1.63321616221445, 218, 28, 'PPL', 'P'),
(136913, 'Minnetonka Mills', 44.9411087036133, 0.784370316374732, -93.4416732788086, -1.63086485728802, 218, 28, 'PPL', 'P'),
(136915, 'Minnetrista', 44.9383316040039, 0.784321846842893, -93.7174987792969, -1.6356789204325, 218, 28, 'PPL', 'P'),
(140565, 'Minnewaukan', 48.0713882446289, 0.839004000873272, -99.2519378662109, -1.73227310475022, 218, 34, 'PPL', 'P'),
(136919, 'Minnewawa', 46.6986083984375, 0.81504447265221, -93.2747192382813, -1.62795095958131, 218, 28, 'PPL', 'P'),
(49530, 'Minnick', 39.4102783203125, 0.687839115816794, -77.5438919067383, -1.35339622858317, 218, 25, 'PPL', 'P'),
(89072, 'Minnick', 36.2680587768555, 0.632997038962955, -89.3658294677734, -1.55972796298842, 218, 50, 'PPL', 'P'),
(208141, 'Minnick', 46.1652793884277, 0.805736125431138, -118.129722595215, -2.06175260375404, 218, 56, 'PPL', 'P'),
(37223, 'Minnie', 37.4722213745117, 0.654013641021425, -82.7541732788086, -1.44433279348112, 218, 21, 'PPL', 'P'),
(56299, 'Minnie', 39.1888885498047, 0.683975135391198, -92.456672668457, -1.61367335350323, 218, 29, 'PPL', 'P'),
(110480, 'Minnie', 39.5897216796875, 0.690970993258727, -80.8102798461914, -1.41040545277406, 218, 58, 'PPL', 'P'),
(42117, 'Minnie (historical)', 30.0450000762939, 0.524384175093277, -90.9158325195313, -1.58678061965755, 218, 22, 'PPL', 'P'),
(66877, 'Minnie Bert', 35.6997184753418, 0.623077629429764, -77.3455581665039, -1.34993465179828, 218, 33, 'PPL', 'P'),
(96253, 'Minnie Fenton Colonia', 26.3339996337891, 0.4596149988286, -98.1330032348633, -1.71274401131861, 218, 51, 'PPL', 'P'),
(197064, 'Minnie Rahn Place', 45.6338882446289, 0.79646160035591, -110.436111450195, -1.92747375790532, 218, 31, 'PPL', 'P'),
(4240, 'Minniesville', 33.4972190856934, 0.584636763307234, -86.9341735839844, -1.51728756154081, 218, 2, 'PPL', 'P'),
(104299, 'Minnieville', 38.6358299255371, 0.674322441441178, -77.3525009155273, -1.35005582562788, 218, 53, 'PPL', 'P'),
(104300, 'Minnieville Estates', 38.6411094665527, 0.674414586814895, -77.3505630493164, -1.35002200348204, 218, 53, 'PPL', 'P'),
(104301, 'Minnieville Manor', 38.6300010681152, 0.674220708687537, -77.4000015258789, -1.35088486767522, 218, 53, 'PPL', 'P'),
(164678, 'Minnis Corner', 41.4844398498535, 0.724040063725486, -80.3388900756836, -1.40217814921848, 218, 45, 'PPL', 'P'),
(56300, 'Minnith', 37.7980613708496, 0.659700621792207, -90.0500030517578, -1.57166904468412, 218, 29, 'PPL', 'P'),
(110481, 'Minnora', 38.7094383239746, 0.675607150351032, -81.0983276367188, -1.41543283512185, 218, 58, 'PPL', 'P'),
(150789, 'Minoa', 43.0761108398438, 0.751819963109293, -76.001106262207, -1.32646953943359, 218, 40, 'PPL', 'P'),
(175346, 'Minocqua', 45.8713912963867, 0.800606810592618, -89.7108306884766, -1.56574937021309, 218, 57, 'PPL', 'P'),
(175348, 'Minong', 46.0994415283203, 0.804587037999796, -91.8247222900391, -1.60264373869061, 218, 57, 'PPL', 'P'),
(120650, 'Minonk', 40.9044418334961, 0.713917188685013, -89.0344390869141, -1.55394410973298, 218, 18, 'PPL', 'P'),
(4241, 'Minooka', 33.0486106872559, 0.576807069702401, -86.7594375610352, -1.5142378426185, 218, 2, 'PPL', 'P'),
(120652, 'Minooka', 41.4552803039551, 0.723531133641172, -88.2616729736328, -1.54045679670839, 218, 18, 'PPL', 'P'),
(164682, 'Minooka', 41.3791694641113, 0.72220274888944, -75.6927795410156, -1.32108822297693, 218, 45, 'PPL', 'P'),
(4242, 'Minor', 33.5372200012207, 0.585334910986998, -86.940559387207, -1.51739901483243, 218, 2, 'PPL', 'P'),
(37224, 'Minor', 38.1322212219238, 0.665532811421426, -83.2652816772461, -1.45325331786845, 218, 21, 'PPL', 'P'),
(104302, 'Minor', 37.839168548584, 0.660418077389874, -76.9830627441406, -1.34360791315464, 218, 53, 'PPL', 'P'),
(132127, 'Minor Beach', 45.9541702270508, 0.802051575483986, -86.3244400024414, -1.5066457029829, 218, 27, 'PPL', 'P'),
(89073, 'Minor Hill', 35.0552787780762, 0.611830034881924, -87.1575012207031, -1.52118536411225, 218, 50, 'PPL', 'P'),
(37225, 'Minor Lane Heights', 38.1236114501953, 0.665382542556918, -85.7197189331055, -1.49609132926681, 218, 21, 'PPL', 'P'),
(4243, 'Minor Terrace', 33.271110534668, 0.580690424624927, -86.3480606079102, -1.50705796031965, 218, 2, 'PPL', 'P'),
(10525, 'Minorca', 36.4941711425781, 0.636943444224289, -90.8461074829102, -1.58556368819744, 218, 4, 'PPL', 'P'),
(42118, 'Minorca', 31.5791702270508, 0.551160495509801, -91.4816665649414, -1.59665628676984, 218, 22, 'PPL', 'P'),
(37226, 'Minorsville', 38.3294410705566, 0.668974947130354, -84.70361328125, -1.47835694009381, 218, 21, 'PPL', 'P'),
(113729, 'Minortown', 41.5761108398438, 0.725640024329378, -73.1747207641602, -1.27713980656206, 218, 8, 'PPL', 'P'),
(4244, 'Minorville (historical)', 34.3147201538086, 0.598904848584415, -86.2149963378906, -1.50473555069105, 218, 2, 'PPL', 'P'),
(17146, 'Minorville (historical)', 28.5519409179688, 0.498325376853447, -81.5377807617188, -1.42310273906128, 218, 12, 'PPL', 'P'),
(60909, 'Minot', 33.9419403076172, 0.592398612883297, -90.4897232055664, -1.57934360915545, 218, 30, 'PPL', 'P'),
(125448, 'Minot', 42.2402801513672, 0.737231965606166, -70.7624969482422, -1.23503855867927, 218, 23, 'PPL', 'P'),
(128154, 'Minot', 44.0855598449707, 0.76943817187974, -70.320556640625, -1.22732524521407, 218, 26, 'PPL', 'P'),
(198627, 'Minot', 48.2324981689453, 0.841815899510232, -101.295829772949, -1.76794574807766, 218, 34, 'PPL', 'P'),
(197065, 'Minot (historical)', 48.0169410705566, 0.838053718417304, -106.51277923584, -1.85899869311526, 218, 31, 'PPL', 'P'),
(71125, 'Minotola', 39.5186080932617, 0.689729827032695, -74.9486083984375, -1.30809998634061, 218, 37, 'PPL', 'P'),
(66876, 'Minpro', 35.9283294677734, 0.627067643953948, -82.0869369506836, -1.43268732266642, 218, 33, 'PPL', 'P'),
(14250, 'Minquadale', 39.7069396972656, 0.693016833608126, -75.5669403076172, -1.31889191402594, 218, 10, 'PPL', 'P'),
(14251, 'Minquadale Trailer Village', 39.7000007629395, 0.692895726357554, -75.565559387207, -1.31886781241807, 218, 10, 'PPL', 'P'),
(30530, 'Minshall', 39.6716690063477, 0.692401243922154, -87.2216720581055, -1.52230535650868, 218, 19, 'PPL', 'P'),
(150790, 'Minsteed', 43.149169921875, 0.753095084639223, -77.1205596923828, -1.34600768761291, 218, 40, 'PPL', 'P'),
(156535, 'Minster', 40.3930587768555, 0.704991870607721, -84.376106262207, -1.47264086428812, 218, 41, 'PPL', 'P'),
(89074, 'Mint', 35.6416702270508, 0.622064496372071, -84.0386123657227, -1.46675048458908, 218, 50, 'PPL', 'P'),
(178650, 'Mint', 34.7027816772461, 0.605677799868705, -112.571670532227, -1.96474629525763, 218, 5, 'PPL', 'P'),
(183308, 'Mint Canyon', 34.4291687011719, 0.600902352560029, -118.441390991211, -2.06719224343858, 218, 6, 'PPL', 'P'),
(208142, 'Mint Grove', 47.5986099243164, 0.83075246255177, -122.080558776855, -2.13070770333059, 218, 56, 'PPL', 'P'),
(56301, 'Mint Hill', 38.5491714477539, 0.672809965679095, -91.746940612793, -1.60128619232494, 218, 29, 'PPL', 'P'),
(66882, 'Mint Hill', 35.1794395446777, 0.613997049060921, -80.6474990844727, -1.40756439252316, 218, 33, 'PPL', 'P'),
(4245, 'Mint Spring', 34.9516716003418, 0.61002174850176, -86.4680633544922, -1.50915240335894, 218, 2, 'PPL', 'P'),
(104303, 'Mint Spring', 38.0744400024414, 0.66452433889564, -79.1011123657227, -1.38057485277186, 218, 53, 'PPL', 'P'),
(89075, 'Mint Spring (historical)', 36.4683303833008, 0.636492437893684, -88.0355606079102, -1.53651039144705, 218, 50, 'PPL', 'P'),
(4246, 'Minter', 32.0777816772461, 0.559862907003853, -86.9936065673828, -1.51832486278539, 218, 2, 'PPL', 'P'),
(23119, 'Minter', 32.4858283996582, 0.566984665811916, -82.7605590820313, -1.44444424677274, 218, 13, 'PPL', 'P'),
(82429, 'Minter', 34.9036102294922, 0.609182919337412, -82.3494415283203, -1.43726889184774, 218, 48, 'PPL', 'P'),
(96254, 'Minter', 33.4705581665039, 0.58417144248577, -95.392219543457, -1.66490831181861, 218, 51, 'PPL', 'P'),
(208143, 'Minter', 47.3622207641602, 0.826626693391019, -122.686393737793, -2.14128151812264, 218, 56, 'PPL', 'P'),
(60910, 'Minter City', 33.7533302307129, 0.589106746038877, -90.2944412231445, -1.57593529559237, 218, 30, 'PPL', 'P'),
(183309, 'Minter Village', 35.5036087036133, 0.619654868217767, -119.181938171387, -2.08011722999901, 218, 6, 'PPL', 'P'),
(96255, 'Minters Chapel', 32.8855590820313, 0.573961282340569, -97.0602798461914, -1.69402145622314, 218, 51, 'PPL', 'P'),
(199533, 'Mintle', 41.9458312988281, 0.73209286365064, -103.680000305176, -1.80955737379404, 218, 35, 'PPL', 'P'),
(140517, 'Minto', 48.2916717529297, 0.842848673380965, -97.3711090087891, -1.69944644852168, 218, 34, 'PPL', 'P'),
(23120, 'Minton', 31.3549995422363, 0.547247978973339, -83.8188934326172, -1.46291566577742, 218, 13, 'PPL', 'P'),
(82432, 'Minton Mill', 34.5058288574219, 0.602240324691685, -80.4094390869141, -1.40340946174847, 218, 48, 'PPL', 'P'),
(89076, 'Minton Mill', 36.5230598449707, 0.637447647197669, -83.686393737793, -1.46060310984485, 218, 50, 'PPL', 'P'),
(17147, 'Mintons Corner', 28.0783290863037, 0.490059291014491, -80.6708297729492, -1.40797158985383, 218, 12, 'PPL', 'P'),
(104305, 'Mintons Store', 36.8541717529297, 0.643226640184113, -82.7122192382813, -1.4436005573394, 218, 53, 'PPL', 'P'),
(66879, 'Mintonsville', 36.3427810668945, 0.634301188948767, -76.6361083984375, -1.33755241746801, 218, 33, 'PPL', 'P'),
(37227, 'Mintonville', 37.1772193908691, 0.648864885106947, -84.8108291625977, -1.48022821023375, 218, 21, 'PPL', 'P'),
(10526, 'Minturn', 35.9744415283203, 0.62787245123537, -91.0274963378906, -1.58872952094327, 218, 4, 'PPL', 'P'),
(82430, 'Minturn', 34.5169410705566, 0.60243426939807, -79.4725036621094, -1.38705685370706, 218, 48, 'PPL', 'P'),
(128156, 'Minturn', 44.1425018310547, 0.77043199701953, -68.4369430541992, -1.19444998629564, 218, 26, 'PPL', 'P'),
(183313, 'Minturn', 37.139720916748, 0.64821041326906, -120.273330688477, -2.09916562285385, 218, 6, 'PPL', 'P'),
(187064, 'Minturn', 39.5863914489746, 0.690912869767936, -106.430282592773, -1.8575588550719, 218, 7, 'PPL', 'P'),
(66881, 'Mintz', 34.8938903808594, 0.609013275975974, -78.4775009155273, -1.36969077971282, 218, 33, 'PPL', 'P'),
(4247, 'Minvale', 34.459171295166, 0.601425996609366, -85.711669921875, -1.49595084751931, 218, 2, 'PPL', 'P'),
(132128, 'Mio', 44.6522216796875, 0.77932828664094, -84.1297225952148, -1.46834065807597, 218, 27, 'PPL', 'P'),
(164679, 'Miola', 41.2519416809082, 0.719982205172532, -79.3436126708984, -1.38480728153427, 218, 45, 'PPL', 'P'),
(104304, 'Miona', 37.9719390869141, 0.66273536043338, -75.5774993896484, -1.31907620477337, 218, 53, 'PPL', 'P'),
(164680, 'Miquon', 40.060001373291, 0.699178922317378, -75.2658309936523, -1.31363656508883, 218, 45, 'PPL', 'P'),
(42119, 'Mira', 32.9419403076172, 0.574945320363354, -93.8888931274414, -1.63867031612693, 218, 22, 'PPL', 'P'),
(120653, 'Mira', 40.0838890075684, 0.69959584018603, -88.1622161865234, -1.53872094830987, 218, 18, 'PPL', 'P'),
(183310, 'Mira Loma', 33.9925003051758, 0.593281051310495, -117.515556335449, -2.05103338036647, 218, 6, 'PPL', 'P'),
(183311, 'Mira Mesa', 32.9155616760254, 0.574484926389906, -117.143058776855, -2.04453207151337, 218, 6, 'PPL', 'P'),
(183312, 'Mira Monte', 34.4336090087891, 0.60097985054775, -119.284172058105, -2.08190154792936, 218, 6, 'PPL', 'P'),
(183314, 'Mirabel (historical)', 38.7000007629395, 0.675442433837611, -122.600563049316, -2.13978349000947, 218, 6, 'PPL', 'P'),
(183315, 'Mirabel Heights', 38.4905586242676, 0.671786978925368, -122.889442443848, -2.14482538658521, 218, 6, 'PPL', 'P'),
(183316, 'Mirabel Park', 38.4933280944824, 0.671835315299153, -122.894721984863, -2.14491753195893, 218, 6, 'PPL', 'P'),
(56302, 'Mirabile', 39.6161117553711, 0.691431586969256, -94.1416702270508, -1.64308210878875, 218, 29, 'PPL', 'P'),
(37229, 'Miracle', 36.7605590820313, 0.64159279085535, -83.5841674804688, -1.45881892507255, 218, 21, 'PPL', 'P'),
(183317, 'Miracle Hot Springs', 35.5758285522461, 0.620915342361702, -118.53360748291, -2.06880172484337, 218, 6, 'PPL', 'P'),
(112606, 'Miracle Run', 39.6772193908691, 0.692498116406805, -80.2680587768555, -1.40094190984046, 218, 58, 'PPL', 'P'),
(178651, 'Miracle Valley', 31.3791694641113, 0.547669823690007, -110.152778625488, -1.9225286672352, 218, 5, 'PPL', 'P'),
(178652, 'Mirador', 33.5777816772461, 0.586042845783768, -111.863891601563, -1.9523932225413, 218, 5, 'PPL', 'P'),
(183318, 'Mirador', 36.1669387817383, 0.63123216210856, -119.035003662109, -2.07755273902732, 218, 6, 'PPL', 'P'),
(189045, 'Mirage', 32.3300018310547, 0.5642649791277, -107.660003662109, -1.87902153661296, 218, 38, 'PPL', 'P'),
(187065, 'Mirage (historical)', 38.1027793884277, 0.665018954489095, -105.863891601563, -1.84767346742164, 218, 7, 'PPL', 'P'),
(183319, 'Miraleste', 33.7522201538086, 0.589087371541947, -118.32527923584, -2.06516571100709, 218, 6, 'PPL', 'P'),
(23121, 'Miralia', 33.8372192382813, 0.590570885427176, -84.478889465332, -1.4744347695984, 218, 13, 'PPL', 'P'),
(17148, 'Miramar', 25.9869403839111, 0.453557672218729, -80.2324981689453, -1.40032126014842, 218, 12, 'PPL', 'P'),
(23122, 'Miramar', 33.6522216796875, 0.587342068921563, -84.2877807617188, -1.47109929349113, 218, 13, 'PPL', 'P'),
(125449, 'Miramar', 42.0063896179199, 0.733149805708265, -70.720832824707, -1.23431138254362, 218, 23, 'PPL', 'P'),
(183321, 'Miramar', 37.4930610656738, 0.654377362247302, -122.455558776855, -2.13725268802557, 218, 6, 'PPL', 'P'),
(17149, 'Miramar Beach', 30.3741703033447, 0.53012927935485, -86.3586120605469, -1.50724211790903, 218, 12, 'PPL', 'P'),
(17150, 'Miramar Terrace', 30.2794399261475, 0.528475922371102, -81.6586074829102, -1.42521156317046, 218, 12, 'PPL', 'P'),
(113730, 'Miramichi', 41.5497207641602, 0.725179430618849, -72.7011108398438, -1.26887375401261, 218, 8, 'PPL', 'P'),
(56304, 'Miramiguoa Park', 38.2388916015625, 0.667394560760473, -91.0686111450195, -1.58944710969899, 218, 29, 'PPL', 'P'),
(183322, 'Miramonte', 36.6925010681152, 0.640404954430147, -119.051391601563, -2.07783876252839, 218, 6, 'PPL', 'P'),
(187066, 'Miramonte', 39.9305610656738, 0.696919762764664, -105.372222900391, -1.83909222975719, 218, 7, 'PPL', 'P'),
(104306, 'Miran Forest', 37.9680595397949, 0.662667649562664, -78.7152786254883, -1.37384078363949, 218, 53, 'PPL', 'P'),
(170894, 'Miranda', 44.9719390869141, 0.784908408072983, -98.9638900756836, -1.72724572240242, 218, 49, 'PPL', 'P'),
(193794, 'Miranda', 40.2347183227539, 0.702228308344546, -123.82250213623, -2.16111035033493, 218, 6, 'PPL', 'P'),
(66883, 'Miranda (historical)', 35.5938911437988, 0.62123059405574, -80.6533279418945, -1.4076661252768, 218, 33, 'PPL', 'P'),
(89077, 'Miranda (historical)', 36.2866706848145, 0.633321878036918, -85.4194412231445, -1.49085049455764, 218, 50, 'PPL', 'P'),
(96257, 'Mirando City', 27.4394397735596, 0.478908568951302, -99.0008316040039, -1.72789047370233, 218, 51, 'PPL', 'P'),
(96258, 'Mirando City Addition Colonia', 27.4370002746582, 0.478865991663374, -99.0009994506836, -1.72789340317953, 218, 51, 'PPL', 'P'),
(96259, 'Mirasoles Colonia', 26.4080009460449, 0.460906565378261, -98.9899978637695, -1.72770138926493, 218, 51, 'PPL', 'P'),
(42121, 'Mire', 30.2997207641602, 0.528829889769487, -92.1936111450195, -1.60908206378393, 218, 22, 'PPL', 'P'),
(96260, 'Mireles Colonia', 26.4130001068115, 0.460993817193475, -98.9789962768555, -1.72750937535034, 218, 51, 'PPL', 'P'),
(190492, 'Miriam', 39.958610534668, 0.697409318352048, -118.686943054199, -2.07147793542279, 218, 39, 'PPL', 'P'),
(4248, 'Miriam Heights', 31.202220916748, 0.544581488931897, -85.3777770996094, -1.490123318422, 218, 2, 'PPL', 'P'),
(144160, 'Mirror Lake', 43.622501373291, 0.761356276919676, -71.2766723632813, -1.24401261260451, 218, 36, 'PPL', 'P'),
(208144, 'Mirror Lake', 48.660831451416, 0.849291725585221, -122.210563659668, -2.13297671657934, 218, 56, 'PPL', 'P'),
(208146, 'Mirrormont', 47.4625015258789, 0.82837692285942, -121.994438171387, -2.12920461521135, 218, 56, 'PPL', 'P'),
(208147, 'Mirrormount Estates', 47.4508285522461, 0.828173191036028, -122.00666809082, -2.12941806757272, 218, 56, 'PPL', 'P'),
(113731, 'Miry Brook', 41.3663902282715, 0.721979709148146, -73.482780456543, -1.28251646248682, 218, 8, 'PPL', 'P'),
(183324, 'Miscanaka (historical)', 34.2816696166992, 0.598328007892304, -119.297218322754, -2.08212924820256, 218, 6, 'PPL', 'P'),
(73500, 'Misco', 39.7277793884277, 0.693380554834003, -82.0738906860352, -1.43245962239322, 218, 41, 'PPL', 'P'),
(202384, 'Miscol', 45.6769409179688, 0.797213011257476, -101.16194152832, -1.76560895737917, 218, 49, 'PPL', 'P'),
(66885, 'Misenheimer', 35.4847183227539, 0.619325168874816, -80.2886123657227, -1.40130063763929, 218, 33, 'PPL', 'P'),
(89079, 'Miser Station', 35.7783317565918, 0.624449690023373, -84.0905609130859, -1.4676571577822, 218, 50, 'PPL', 'P'),
(60911, 'Mish', 31.6838893890381, 0.552988189676409, -89.5972213745117, -1.56376651362347, 218, 30, 'PPL', 'P'),
(175351, 'Misha Mokwa', 44.4972190856934, 0.77662298102661, -92.0102767944336, -1.6058822757342, 218, 57, 'PPL', 'P'),
(123213, 'Mishawaka', 41.6619415283203, 0.727138052442548, -86.1586074829102, -1.50375137951021, 218, 19, 'PPL', 'P'),
(194329, 'Mishawaka', 40.6872215270996, 0.710125979136203, -105.365280151367, -1.83897105592759, 218, 7, 'PPL', 'P'),
(201242, 'Mishawaka', 45.8633308410645, 0.800466129108035, -123.567222595215, -2.15665488183123, 218, 43, 'PPL', 'P'),
(125450, 'Mishawum', 42.502498626709, 0.74180854136044, -71.1416702270508, -1.24165638083006, 218, 23, 'PPL', 'P'),
(175352, 'Mishicot', 44.2391700744629, 0.772119176149122, -87.64111328125, -1.52962598687114, 218, 57, 'PPL', 'P'),
(156539, 'Mishler', 40.999439239502, 0.715575206200669, -81.3619384765625, -1.42003371222107, 218, 41, 'PPL', 'P'),
(164681, 'Mishler Corners', 41.935001373291, 0.731903845792272, -80.2050018310547, -1.39984135851999, 218, 45, 'PPL', 'P'),
(178653, 'Mishongnovi', 35.8050003051758, 0.624915144002892, -110.491943359375, -1.92844820854818, 218, 5, 'PPL', 'P'),
(183325, 'Mishopshnow (historical)', 34.392219543457, 0.600257468102066, -119.52082824707, -2.08603197762202, 218, 6, 'PPL', 'P'),
(104307, 'Miskimon', 37.8377799987793, 0.660393842623955, -76.4763870239258, -1.33476475359697, 218, 53, 'PPL', 'P'),
(156536, 'Misner Corners', 41.035831451416, 0.716210370120653, -80.7972183227539, -1.41017748618475, 218, 41, 'PPL', 'P'),
(14253, 'Mispillion Light', 38.9472198486328, 0.67975722085673, -75.3152770996094, -1.31449956244007, 218, 10, 'PPL', 'P'),
(169488, 'Misquamicut', 41.3222198486328, 0.721208790591595, -71.8166732788086, -1.25343740654424, 218, 47, 'PPL', 'P'),
(136921, 'Missabe Junction', 46.7594413757324, 0.816106208399798, -92.1283264160156, -1.60794263031154, 218, 28, 'PPL', 'P'),
(120654, 'Missal', 41.098331451416, 0.717301200903149, -88.7422180175781, -1.54884388992937, 218, 18, 'PPL', 'P'),
(60912, 'Missala', 30.4577808380127, 0.531588558474159, -88.4000015258789, -1.5428710853946, 218, 30, 'PPL', 'P'),
(132130, 'Missaukee Junction', 44.3088912963867, 0.773336041030207, -85.414436340332, -1.49076314287389, 218, 27, 'PPL', 'P'),
(14256, 'Mission', 38.5463905334473, 0.672761429568228, -75.3547210693359, -1.31518798958185, 218, 10, 'PPL', 'P'),
(33302, 'Mission', 39.0277786254883, 0.681163236754237, -94.6555633544922, -1.65205123586598, 218, 20, 'PPL', 'P'),
(66886, 'Mission', 35.0711097717285, 0.61210633784502, -83.9300003051758, -1.46485484652516, 218, 33, 'PPL', 'P'),
(96261, 'Mission', 26.2155609130859, 0.457547853190481, -98.3249969482422, -1.7160949337602, 218, 51, 'PPL', 'P'),
(132131, 'Mission', 46.4472198486328, 0.810656914756305, -84.5975036621094, -1.47650497787177, 218, 27, 'PPL', 'P'),
(136922, 'Mission', 46.5880584716797, 0.813115012442448, -94.0508270263672, -1.64149659583378, 218, 28, 'PPL', 'P'),
(183327, 'Mission', 34.438060760498, 0.601057548272553, -119.739723205566, -2.08985241536379, 218, 6, 'PPL', 'P'),
(201243, 'Mission', 45.6705589294434, 0.797101624544883, -118.682502746582, -2.07140043743507, 218, 43, 'PPL', 'P'),
(202385, 'Mission', 43.3058280944824, 0.75582928555138, -100.657783508301, -1.7568097399795, 218, 49, 'PPL', 'P'),
(142439, 'Mission (historical)', 40.0305595397949, 0.698665065385047, -96.408332824707, -1.68264283414966, 218, 35, 'PPL', 'P'),
(17151, 'Mission Bay', 26.3697204589844, 0.460238444839788, -80.2099990844727, -1.39992857704569, 218, 12, 'PPL', 'P'),
(183328, 'Mission Beach', 32.7825012207031, 0.57216258334033, -117.251388549805, -2.04642278272927, 218, 6, 'PPL', 'P'),
(208148, 'Mission Beach', 48.0488891601563, 0.83861131777054, -122.271667480469, -2.13404317943786, 218, 56, 'PPL', 'P'),
(96262, 'Mission Bend', 29.6936092376709, 0.518251247997961, -95.6647186279297, -1.66966431805133, 218, 51, 'PPL', 'P'),
(183329, 'Mission Canyon', 34.4508285522461, 0.601280388276766, -119.711936950684, -2.08936745372929, 218, 6, 'PPL', 'P'),
(17152, 'Mission City', 29.021390914917, 0.506518824973671, -80.9469375610352, -1.41279057984633, 218, 12, 'PPL', 'P'),
(136923, 'Mission Creek', 45.9702796936035, 0.802332738716071, -92.9497222900391, -1.62227869277555, 218, 28, 'PPL', 'P'),
(183348, 'Mission del Magnolia Mobile Home Park', 32.8416709899902, 0.573195290632035, -116.964996337891, -2.0414242956793, 218, 6, 'PPL', 'P'),
(136924, 'Mission Farms', 45.0183296203613, 0.785718075623394, -93.4238891601563, -1.63055446586297, 218, 28, 'PPL', 'P'),
(183331, 'Mission Gorge Villa Mobile Home Park', 32.8338890075684, 0.573059469416441, -117.010559082031, -2.0422195155808, 218, 6, 'PPL', 'P'),
(49531, 'Mission Heights', 39.1611099243164, 0.683490306914749, -76.8138885498047, -1.34065526645406, 218, 25, 'PPL', 'P'),
(183332, 'Mission Highlands', 38.3197212219238, 0.668805303768916, -122.456672668457, -2.13727212910153, 218, 6, 'PPL', 'P'),
(170895, 'Mission Hill', 42.9233283996582, 0.749153406488824, -97.2786102294922, -1.69783204026888, 218, 49, 'PPL', 'P'),
(33304, 'Mission Hills', 39.0177803039551, 0.68098873312381, -94.6166687011719, -1.65137239610412, 218, 20, 'PPL', 'P'),
(183336, 'Mission Hills', 34.6930618286133, 0.605508156507266, -120.433326721191, -2.10195808041486, 218, 6, 'PPL', 'P'),
(191886, 'Mission Hills', 31.788890838623, 0.554820810691034, -106.495559692383, -1.85869815538624, 218, 51, 'PPL', 'P'),
(197066, 'Mission Meadows Trailer Park', 47.5736083984375, 0.830316103607161, -114.106941223145, -1.99154182372352, 218, 31, 'PPL', 'P'),
(178654, 'Mission Monterey', 33.5738906860352, 0.585974935175971, -111.866668701172, -1.95244169207314, 218, 5, 'PPL', 'P'),
(89078, 'Mission Oaks', 34.9883308410645, 0.610661572953652, -85.2569427490234, -1.48801436115476, 218, 50, 'PPL', 'P'),
(49532, 'Mission Ridge', 39.5369415283203, 0.690049805837668, -76.6161117553711, -1.33720341020716, 218, 25, 'PPL', 'P'),
(202386, 'Mission Ridge', 44.6919403076172, 0.780021507472687, -100.795280456543, -1.75920951443777, 218, 49, 'PPL', 'P'),
(183343, 'Mission San Jose District', 37.5330581665039, 0.655075443348039, -121.919166564941, -2.12789087784561, 218, 6, 'PPL', 'P'),
(183345, 'Mission Springs', 37.0663909912109, 0.646930564628195, -122.031387329102, -2.12984949966931, 218, 6, 'PPL', 'P'),
(23125, 'Mission Trace', 30.7819404602051, 0.537246211183437, -81.5919418334961, -1.42404802809021, 218, 13, 'PPL', 'P'),
(191887, 'Mission Trail Estates Colonia', 31.5960006713867, 0.551454242178037, -106.255996704102, -1.85451699247482, 218, 51, 'PPL', 'P'),
(96263, 'Mission Valley', 28.898889541626, 0.504380772671528, -97.1938934326172, -1.69635345323166, 218, 51, 'PPL', 'P'),
(178655, 'Mission Valley', 33.3525009155273, 0.582110954750375, -111.851387023926, -1.95217497648997, 218, 5, 'PPL', 'P'),
(183346, 'Mission Viejo', 33.5999984741211, 0.586430602038484, -117.671112060547, -2.05374833993975, 218, 6, 'PPL', 'P'),
(96264, 'Mission West Estates Colonia', 26.2369995117188, 0.457922027323637, -98.3779983520508, -1.71701998276484, 218, 51, 'PPL', 'P'),
(33306, 'Mission Woods', 39.0349998474121, 0.681289270852825, -94.6083297729492, -1.65122685435054, 218, 20, 'PPL', 'P'),
(42123, 'Missionary', 33.003059387207, 0.576012049537985, -93.8324966430664, -1.63768601178804, 218, 22, 'PPL', 'P'),
(56305, 'Missionary Acres', 37.2041702270508, 0.649335265934482, -90.4208297729492, -1.57814119192328, 218, 29, 'PPL', 'P'),
(120656, 'Missionfield', 40.1047210693359, 0.699959428253853, -87.7536087036133, -1.5315894023848, 218, 18, 'PPL', 'P'),
(123214, 'Missisinewa (historical)', 40.750560760498, 0.711231457304695, -86.0083312988281, -1.50112856531064, 218, 19, 'PPL', 'P'),
(60914, 'Mississippi', 32.7502784729004, 0.571600190297132, -89.7502822875977, -1.56643793051293, 218, 30, 'ADM1', 'A'),
(60913, 'Mississippi City', 30.3816699981689, 0.530260173722428, -89.0438919067383, -1.55410909256251, 218, 30, 'PPL', 'P'),
(187813, 'Missler', 37.3177795410156, 0.651318122524101, -100.434722900391, -1.75291659793997, 218, 20, 'PPL', 'P'),
(197067, 'Missoula', 46.8722190856934, 0.818074550761475, -113.993057250977, -1.98955417344394, 218, 31, 'PPL', 'P'),
(56309, 'Missouri', 38.2502784729004, 0.66759329915682, -92.5002822875977, -1.61443448494277, 218, 29, 'ADM1', 'A'),
(110482, 'Missouri Branch', 37.9983291625977, 0.663195954143909, -82.4063873291016, -1.43826278356656, 218, 58, 'PPL', 'P'),
(56308, 'Missouri City', 39.2408294677734, 0.684881675426261, -94.2877807617188, -1.64563221869056, 218, 29, 'PPL', 'P'),
(96265, 'Missouri City', 29.6183300018311, 0.51693737747417, -95.5374984741211, -1.66744390749247, 218, 51, 'PPL', 'P'),
(197069, 'Missouri Flats (historical)', 44.8027801513672, 0.781956027688521, -111.525001525879, -1.94647847491829, 218, 31, 'PPL', 'P'),
(197070, 'Missouri Meadows Trailer Park', 47.4761085510254, 0.828614410249627, -111.311111450195, -1.94274538886027, 218, 31, 'PPL', 'P'),
(189046, 'Missouri Plaza (historical)', 33.3069381713867, 0.581315734848878, -104.749168395996, -1.82821787723612, 218, 38, 'PPL', 'P'),
(183351, 'Missouri Triangle', 35.4388885498047, 0.61852528844141, -119.689170837402, -2.08897011009465, 218, 6, 'PPL', 'P'),
(116874, 'Missouri Valley', 41.5563888549805, 0.725295810758486, -95.8874969482422, -1.67355253324284, 218, 16, 'PPL', 'P'),
(10536, 'Mist', 33.2738914489746, 0.580738960735794, -91.6913909912109, -1.6003166685301, 218, 4, 'PPL', 'P'),
(201244, 'Mist', 45.9963912963867, 0.802788472157611, -123.255279541016, -2.15121044845673, 218, 43, 'PPL', 'P'),
(60915, 'Misterton', 33.7077789306641, 0.588311725874461, -89.5822219848633, -1.56350472488831, 218, 30, 'PPL', 'P'),
(37230, 'Mistletoe', 37.3125, 0.651225977150384, -83.591667175293, -1.45894981944013, 218, 21, 'PPL', 'P'),
(10537, 'Mistletoe (historical)', 33.7597198486328, 0.589218265909524, -94.2024993896484, -1.64414377795731, 218, 4, 'PPL', 'P'),
(49533, 'Mistletoe Springs', 39.0863914489746, 0.682186223507964, -76.8525009155273, -1.34132917936791, 218, 25, 'PPL', 'P'),
(89080, 'Miston', 36.1647186279297, 0.631193413114699, -89.4902801513672, -1.56190003717349, 218, 50, 'PPL', 'P'),
(49534, 'Mistwood', 39.0583305358887, 0.681696468183499, -76.6933288574219, -1.33855110287679, 218, 25, 'PPL', 'P'),
(104309, 'Mistwood Forest', 37.3241691589355, 0.651429642394748, -77.4194412231445, -1.3512241543981, 218, 53, 'PPL', 'P'),
(23126, 'Misty Cove', 34.1847190856934, 0.596635901914695, -83.9833297729492, -1.46578562132615, 218, 13, 'PPL', 'P'),
(4250, 'Misty Harbor', 34.026668548584, 0.593877399657591, -86.9291687011719, -1.51720020985705, 218, 2, 'PPL', 'P'),
(204952, 'Misty Hills Numbers 1-7', 40.6416702270508, 0.709330958971788, -111.995559692383, -1.95469126424593, 218, 52, 'PPL', 'P'),
(204947, 'Misty Hills Numbers 8-10', 40.6355590820313, 0.70922429937013, -111.986671447754, -1.95453613511243, 218, 52, 'PPL', 'P'),
(49535, 'Misty Meadows', 39.621940612793, 0.691533319722897, -76.0805587768555, -1.3278562474132, 218, 25, 'PPL', 'P'),
(23127, 'Misty Mountain', 34.0894393920898, 0.594972957551022, -84.4530563354492, -1.47398389642585, 218, 13, 'PPL', 'P'),
(4251, 'Misty Pines', 33.7013893127441, 0.588200206003814, -86.5208282470703, -1.51007332446389, 218, 2, 'PPL', 'P'),
(23128, 'Misty Ridge', 33.8952789306641, 0.591584218221951, -84.3899993896484, -1.47288334510537, 218, 13, 'PPL', 'P'),
(89081, 'Misty Ridge', 35.2630615234375, 0.615456527917312, -84.9333267211914, -1.48236619595687, 218, 50, 'PPL', 'P'),
(42124, 'Mitch (historical)', 30.8150005340576, 0.537823218323116, -89.8536071777344, -1.56824129004507, 218, 22, 'PPL', 'P'),
(156538, 'Mitchaw', 41.7019386291504, 0.727836133543285, -83.7622222900391, -1.46192656774857, 218, 41, 'PPL', 'P'),
(4252, 'Mitchell', 32.2461090087891, 0.562800773160374, -85.9377822875977, -1.49989725278064, 218, 2, 'PPL', 'P'),
(10539, 'Mitchell', 36.3236083984375, 0.633966562757799, -92.0124969482422, -1.60592102472806, 218, 4, 'PPL', 'P'),
(23129, 'Mitchell', 33.2197189331055, 0.579793471969788, -82.7033309936523, -1.44344542820591, 218, 13, 'PPL', 'P'),
(27921, 'Mitchell', 38.7619400024414, 0.676523477503101, -90.0852813720703, -1.57228476752814, 218, 18, 'PPL', 'P'),
(30531, 'Mitchell', 38.732780456543, 0.676014547418787, -86.4736099243164, -1.50924920926457, 218, 19, 'PPL', 'P'),
(33312, 'Mitchell', 38.3838882446289, 0.669925229586321, -98.0994415283203, -1.71215824903685, 218, 20, 'PPL', 'P'),
(42126, 'Mitchell', 30.858060836792, 0.538574762382737, -90.5025024414063, -1.57956664889675, 218, 22, 'PPL', 'P'),
(56313, 'Mitchell', 37.8466682434082, 0.660548971757452, -90.579719543457, -1.58091434156638, 218, 29, 'PPL', 'P'),
(60917, 'Mitchell', 34.4283294677734, 0.600887705174033, -89.0486068725586, -1.5541913842402, 218, 30, 'PPL', 'P'),
(89083, 'Mitchell', 36.6269416809082, 0.639260727267794, -86.5680618286133, -1.51089770597932, 218, 50, 'PPL', 'P'),
(96266, 'Mitchell', 32.3452796936035, 0.564531628131844, -99.0608291625977, -1.72893762864295, 218, 51, 'PPL', 'P'),
(104310, 'Mitchell', 37.2919387817383, 0.650867116193496, -80.1002807617188, -1.39801363106386, 218, 53, 'PPL', 'P'),
(110483, 'Mitchell', 38.5422210693359, 0.672688658691442, -79.341667175293, -1.38477332623037, 218, 58, 'PPL', 'P'),
(116875, 'Mitchell', 43.3219413757324, 0.756110515362493, -92.8675003051758, -1.62084364842216, 218, 16, 'PPL', 'P'),
(136927, 'Mitchell', 47.4455604553223, 0.828081245399394, -92.8949966430664, -1.62132355005059, 218, 28, 'PPL', 'P'),
(170898, 'Mitchell', 43.7094383239746, 0.762873612950749, -98.0294418334961, -1.71093652388677, 218, 49, 'PPL', 'P'),
(187067, 'Mitchell', 39.3916702270508, 0.687514343321858, -106.31861114502, -1.85560982062813, 218, 7, 'PPL', 'P'),
(195336, 'Mitchell', 43.3972206115723, 0.757424385886283, -112.110000610352, -1.95668863506349, 218, 17, 'PPL', 'P'),
(199536, 'Mitchell', 41.9402809143066, 0.731995991165989, -103.808059692383, -1.81179243173889, 218, 35, 'PPL', 'P'),
(201245, 'Mitchell', 44.5666694641113, 0.777835118796759, -120.152221679688, -2.09705187189666, 218, 43, 'PPL', 'P'),
(208149, 'Mitchell', 47.1866683959961, 0.823562726556883, -119.222221374512, -2.08082030452679, 218, 56, 'PPL', 'P'),
(82431, 'Mitchell (historical)', 35.0605583190918, 0.61192218025564, -82.2699966430664, -1.43588231702619, 218, 48, 'PPL', 'P'),
(23130, 'Mitchell Acres', 34.9513893127441, 0.610016821653743, -85.2236099243164, -1.48743259361464, 218, 13, 'PPL', 'P'),
(66887, 'Mitchell Aire', 35.7944412231445, 0.624730853255458, -80.8333282470703, -1.41080772325671, 218, 33, 'PPL', 'P'),
(17153, 'Mitchell Beach', 27.7872200012207, 0.484978478997324, -82.7852783203125, -1.44487567886933, 218, 12, 'PPL', 'P'),
(96267, 'Mitchell Colonia', 26.3929996490479, 0.460644743353593, -98.818000793457, -1.72469947408419, 218, 51, 'PPL', 'P'),
(10540, 'Mitchell Corner', 35.232780456543, 0.614928023598986, -91.4836120605469, -1.59669024207374, 218, 4, 'PPL', 'P'),
(128157, 'Mitchell Corner', 44.6738891601563, 0.779706455515731, -69.267219543457, -1.20894104473509, 218, 26, 'PPL', 'P'),
(183352, 'Mitchell Corner', 36.3266716003418, 0.634020025716682, -119.205276489258, -2.08052456048774, 218, 6, 'PPL', 'P'),
(164683, 'Mitchell Creek', 41.935001373291, 0.731903845792272, -77.1063919067383, -1.34576041310569, 218, 45, 'PPL', 'P'),
(96268, 'Mitchell Crossing', 31.4155597686768, 0.548304954320478, -99.3308334350586, -1.73365009219184, 218, 51, 'PPL', 'P'),
(4253, 'Mitchell Crossroads', 32.5386085510254, 0.567905853232974, -85.413330078125, -1.49074383495599, 218, 2, 'PPL', 'P'),
(104311, 'Mitchell Crossroads', 36.8622207641602, 0.643367121931615, -80.7180633544922, -1.40879597136927, 218, 53, 'PPL', 'P'),
(14254, 'Mitchell Estates', 39.7541694641113, 0.693841148544532, -75.658332824707, -1.32048701436084, 218, 10, 'PPL', 'P'),
(23133, 'Mitchell Forks', 32.2433280944824, 0.562752237049508, -81.7024993896484, -1.42597762145802, 218, 13, 'PPL', 'P'),
(110484, 'Mitchell Heights', 37.9072189331055, 0.661605780657023, -81.9833297729492, -1.43087903628626, 218, 58, 'PPL', 'P'),
(37232, 'Mitchell Hill', 37.3530616760254, 0.651933911947155, -87.5374984741211, -1.52781756733293, 218, 21, 'PPL', 'P'),
(17154, 'Mitchell Lake Estates', 25.9055595397949, 0.452137308540848, -80.2280578613281, -1.4002437621607, 218, 12, 'PPL', 'P'),
(37231, 'Mitchell Landing', 37.1841697692871, 0.6489861920946, -88.2886123657227, -1.54092697779884, 218, 21, 'PPL', 'P'),
(49536, 'Mitchell Manor', 39.4186096191406, 0.687984524412312, -79.3963928222656, -1.38572846895533, 218, 25, 'PPL', 'P'),
(10541, 'Mitchell Mill', 36.1974983215332, 0.631765526695875, -90.2411117553711, -1.57500452079139, 218, 4, 'PPL', 'P'),
(104312, 'Mitchell Mill', 37.1563911437988, 0.648501363618151, -79.1191711425781, -1.38089003788687, 218, 53, 'PPL', 'P'),
(183353, 'Mitchell Place', 39.959171295166, 0.697419105469054, -122.716941833496, -2.14181468297287, 218, 6, 'PPL', 'P'),
(189047, 'Mitchell Place', 32.2466697692871, 0.56281056027738, -108.613327026367, -1.89566016815545, 218, 38, 'PPL', 'P'),
(191889, 'Mitchell Place', 30.2419395446777, 0.527821417243701, -103.157783508301, -1.80044297127936, 218, 51, 'PPL', 'P'),
(89084, 'Mitchell Springs', 36.3800010681152, 0.634950800517665, -82.5861129760742, -1.44139958785651, 218, 50, 'PPL', 'P'),
(104313, 'Mitchells', 38.3769416809082, 0.669803989177695, -78.0286102294922, -1.36185615925997, 218, 53, 'PPL', 'P'),
(56314, 'Mitchells Corner', 37.4088897705078, 0.652908296010987, -92.0719375610352, -1.6069584591307, 218, 29, 'PPL', 'P'),
(183354, 'Mitchells Corner', 35.2236099243164, 0.614767967617472, -118.84139251709, -2.07417358707817, 218, 6, 'PPL', 'P'),
(66891, 'Mitchells Fork', 36.3499984741211, 0.634427156468328, -76.6363906860352, -1.33755734431603, 218, 33, 'PPL', 'P'),
(104314, 'Mitchells Mill', 36.5952796936035, 0.638708121341603, -77.5716705322266, -1.35388105705962, 218, 53, 'PPL', 'P'),
(49541, 'Mitchells Range', 39.1158294677734, 0.682700013861268, -77.2816696166992, -1.34881958624987, 218, 25, 'PPL', 'P'),
(120658, 'Mitchells Subdivision', 41.7400016784668, 0.728500459077205, -87.7069396972656, -1.5307748745654, 218, 18, 'PPL', 'P'),
(37234, 'Mitchellsburg', 37.6005592346191, 0.656253559235263, -84.9497222900391, -1.482652352616, 218, 21, 'PPL', 'P'),
(27922, 'Mitchellsville', 37.6505584716797, 0.657126210545455, -88.5377807617188, -1.54527578670089, 218, 18, 'PPL', 'P'),
(150791, 'Mitchellsville', 42.4080581665039, 0.740160244382763, -77.2900009155273, -1.34896499484538, 218, 40, 'PPL', 'P'),
(4254, 'Mitchelltown', 34.8816719055176, 0.608800023351686, -87.4288864135742, -1.52592192926901, 218, 2, 'PPL', 'P'),
(104315, 'Mitchelltown', 38.0127792358398, 0.663448155499139, -79.8116683959961, -1.39297639502003, 218, 53, 'PPL', 'P'),
(4255, 'Mitchellville', 33.7297210693359, 0.588694688439215, -86.0697174072266, -1.50219995501718, 218, 2, 'PPL', 'P'),
(10543, 'Mitchellville', 33.9055595397949, 0.591763648700395, -91.498893737793, -1.59695695765691, 218, 4, 'PPL', 'P'),
(49537, 'Mitchellville', 38.9249992370605, 0.679369398022987, -76.7430572509766, -1.33941902707605, 218, 25, 'PPL', 'P'),
(82433, 'Mitchellville', 32.461669921875, 0.566563020832329, -80.9922180175781, -1.41358087289981, 218, 48, 'PPL', 'P'),
(89085, 'Mitchellville', 36.6319389343262, 0.639347945793495, -86.5408325195313, -1.5104224648828, 218, 50, 'PPL', 'P'),
(116878, 'Mitchellville', 41.6686096191406, 0.727254432582184, -93.3574981689453, -1.62939572447267, 218, 16, 'PPL', 'P'),
(139337, 'Mitchellville', 40.2119407653809, 0.701830764972825, -94.0713882446289, -1.64185545679066, 218, 29, 'PPL', 'P'),
(113733, 'Mitcheltown', 41.8583297729492, 0.730565673923534, -73.4608306884766, -1.28213336676401, 218, 8, 'PPL', 'P'),
(27923, 'Mitchie', 38.2102813720703, 0.666895218056083, -90.3333282470703, -1.57661400219617, 218, 18, 'PPL', 'P'),
(42127, 'Mitchiner', 32.5813903808594, 0.568652537023605, -91.4861068725586, -1.59673378475756, 218, 22, 'PPL', 'P'),
(66892, 'Mitchiners Crossroads', 36.1230583190918, 0.63046630355808, -78.3925018310547, -1.36820726582759, 218, 33, 'PPL', 'P'),
(60918, 'Mitchner (historical)', 34.0155601501465, 0.593683521530233, -90.2805633544922, -1.57569308109123, 218, 30, 'PPL', 'P'),
(82434, 'Mitford', 34.5272216796875, 0.602613699876514, -80.9555587768555, -1.41294104844792, 218, 48, 'PPL', 'P'),
(156540, 'Mitiwanga', 41.3838882446289, 0.722285107146151, -82.4647216796875, -1.4392809100513, 218, 41, 'PPL', 'P'),
(82435, 'Mittenlane', 33.2008285522461, 0.579463772626837, -79.9977798461914, -1.3962246526016, 218, 48, 'PPL', 'P'),
(144161, 'Mittersill', 44.1800003051758, 0.771086468857417, -71.7147216796875, -1.25165801546191, 218, 36, 'PPL', 'P'),
(42128, 'Mittie', 30.7066707611084, 0.535932507107215, -92.9066696166992, -1.62152728187398, 218, 22, 'PPL', 'P'),
(96269, 'Mittie', 31.9716701507568, 0.558010911492299, -95.228889465332, -1.66205766418779, 218, 51, 'PPL', 'P'),
(125451, 'Mittineague', 42.1041717529297, 0.734856425913816, -72.6458282470703, -1.26790889074968, 218, 23, 'PPL', 'P'),
(4256, 'Mitylene', 32.3827781677246, 0.565186099969731, -86.1741714477539, -1.50402302194139, 218, 2, 'PPL', 'P'),
(42129, 'Mix', 30.6574993133545, 0.535074303445937, -91.4850006103516, -1.59671447683966, 218, 22, 'PPL', 'P'),
(164684, 'Mix Run', 41.3394393920898, 0.721509328320611, -78.1927795410156, -1.36472145427678, 218, 45, 'PPL', 'P'),
(30534, 'Mixersville', 39.4883308410645, 0.689201389293396, -84.8249969482422, -1.48047548474097, 218, 19, 'PPL', 'P'),
(89086, 'Mixie', 36.1338882446289, 0.630655321416449, -88.331672668457, -1.54167852185846, 218, 50, 'PPL', 'P'),
(10544, 'Mixon', 35.0905609130859, 0.612445824304977, -93.8797225952148, -1.63851026014541, 218, 4, 'PPL', 'P'),
(60919, 'Mixon', 31.1272201538086, 0.543272478677096, -90.5749969482422, -1.58083191673064, 218, 30, 'PPL', 'P'),
(96270, 'Mixon', 32.0886116027832, 0.560051924862222, -95.2099990844727, -1.66172796484483, 218, 51, 'PPL', 'P'),
(4257, 'Mixonville', 31.704719543457, 0.553351744454719, -86.9486083984375, -1.51753949657993, 218, 2, 'PPL', 'P'),
(4258, 'Mixson', 31.482780456543, 0.549478176649198, -85.9194412231445, -1.49957714081762, 218, 2, 'PPL', 'P'),
(164685, 'Mixtown', 41.8472213745117, 0.730371795796177, -77.5877838134766, -1.35416228687073, 218, 45, 'PPL', 'P'),
(112550, 'Mixville', 33.5419387817383, 0.585417269243709, -81.8163909912109, -1.42796540489566, 218, 48, 'PPL', 'P'),
(113732, 'Mixville', 41.5222206115723, 0.72469946241139, -72.9361114501953, -1.27297528840744, 218, 8, 'PPL', 'P'),
(37233, 'Mize', 37.8594398498535, 0.660771878340692, -83.3736114501953, -1.45514402908435, 218, 21, 'PPL', 'P'),
(60920, 'Mize', 31.8683300018311, 0.556207285644042, -89.5558319091797, -1.56304413117779, 218, 30, 'PPL', 'P'),
(112279, 'Mize', 34.473331451416, 0.601673137958525, -83.3369369506836, -1.45450393831635, 218, 13, 'PPL', 'P'),
(23135, 'Mizell', 32.5761108398438, 0.568560391649889, -84.3061065673828, -1.47141913913804, 218, 13, 'PPL', 'P'),
(89088, 'Mizell (historical)', 36.0055618286133, 0.628415602939692, -86.8058319091797, -1.51504757674794, 218, 50, 'PPL', 'P'),
(156541, 'Mizers', 40.2772216796875, 0.702970131866188, -81.5813903808594, -1.42386387050083, 218, 41, 'PPL', 'P'),
(71126, 'Mizpah', 39.4866714477539, 0.689172427416542, -74.8361129760742, -1.30613657082695, 218, 37, 'PPL', 'P'),
(136929, 'Mizpah', 47.9241714477539, 0.836434583053563, -94.20361328125, -1.64416321903327, 218, 28, 'PPL', 'P'),
(197071, 'Mizpah', 46.2447204589844, 0.807122633673661, -105.266937255859, -1.83725464860503, 218, 31, 'PPL', 'P'),
(200077, 'Mizpah', 40.3958282470703, 0.705040206981506, -114.662498474121, -2.00123812693639, 218, 39, 'PPL', 'P'),
(132133, 'Mizpah Park', 42.1624984741211, 0.735874419240498, -86.4361114501953, -1.50859473742668, 218, 27, 'PPL', 'P'),
(196964, 'MJB Trailer Court', 46.7555618286133, 0.816038497529082, -114.082778930664, -1.9911201121649, 218, 31, 'PPL', 'P'),
(192703, 'Moab', 38.5733299255371, 0.673231610658682, -109.549171447754, -1.91199373459507, 218, 52, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(208150, 'Moab', 47.7244415283203, 0.832948638344704, -117.066673278809, -2.04319889307168, 218, 56, 'PPL', 'P'),
(10545, 'Moab (historical)', 35.0125007629395, 0.61108341767032, -92.7402801513672, -1.6186232378633, 218, 4, 'PPL', 'P'),
(190493, 'Moapa', 36.6758308410645, 0.640114004081056, -114.620002746582, -2.0004964365728, 218, 39, 'PPL', 'P'),
(190495, 'Moapa Town', 36.6822204589844, 0.640225523951703, -114.593330383301, -2.00003091601425, 218, 39, 'PPL', 'P'),
(190497, 'Moapa Valley', 36.5805587768555, 0.638451192875438, -114.469436645508, -1.99786856236716, 218, 39, 'PPL', 'P'),
(10547, 'Moark', 36.4833297729492, 0.636754226628839, -90.5250015258789, -1.57995933199948, 218, 4, 'PPL', 'P'),
(56315, 'Moark', 36.3824996948242, 0.634994409780515, -89.9888916015625, -1.57060244866754, 218, 29, 'PPL', 'P'),
(204954, 'Moark Junction', 40.0827789306641, 0.6995764656891, -111.587501525879, -1.94756930570078, 218, 52, 'PPL', 'P'),
(156542, 'Moats', 41.3316688537598, 0.721373706842099, -84.5258331298828, -1.47525409110776, 218, 41, 'PPL', 'P'),
(110487, 'Moatstown', 38.5380592346191, 0.67261602097271, -79.3949966430664, -1.38570410103135, 218, 58, 'PPL', 'P'),
(110485, 'Moatsville', 39.2102813720703, 0.684348510576027, -79.9333267211914, -1.39509973335715, 218, 58, 'PPL', 'P'),
(210730, 'MoÃ‚â€˜omomi', 21.2000007629395, 0.370009814738603, -157.156112670898, -2.74289160574236, 218, 15, 'PPL', 'P'),
(191890, 'Mobeetie', 35.5130615234375, 0.619819851047298, -100.441390991211, -1.7530329780796, 218, 51, 'PPL', 'P'),
(30533, 'Moberly', 38.269718170166, 0.667932585879697, -86.2094421386719, -1.50463861162737, 218, 19, 'PPL', 'P'),
(37235, 'Moberly', 37.7416687011719, 0.658716384032341, -84.1827774047852, -1.46926663918699, 218, 21, 'PPL', 'P'),
(56316, 'Moberly', 39.4183311462402, 0.687979664143322, -92.4380569458008, -1.61334844785024, 218, 29, 'PPL', 'P'),
(4259, 'Mobile', 30.6941699981689, 0.53571432763491, -88.0430603027344, -1.53664128581463, 218, 2, 'PPL', 'P'),
(96271, 'Mobile City', 32.9225006103516, 0.574606033640477, -96.4108276367188, -1.68268637683349, 218, 51, 'PPL', 'P'),
(197072, 'Mobile City Home Park', 46.6097183227539, 0.813493048159185, -112.0625, -1.95585959301615, 218, 31, 'PPL', 'P'),
(197073, 'Mobile City Trailer Park', 46.8758316040039, 0.818137601100283, -114.020561218262, -1.99003420823042, 218, 31, 'PPL', 'P'),
(17155, 'Mobile Gardens', 26.9288902282715, 0.469997798391465, -82.3194427490234, -1.43674531437743, 218, 12, 'PPL', 'P'),
(14255, 'Mobile Gardens Mobile Home Park', 38.6344413757324, 0.674298206675258, -75.5899963378906, -1.31929431766665, 218, 10, 'PPL', 'P'),
(191891, 'Mobile Haven Estates Colonia', 31.9500007629395, 0.557632709327994, -106.575996398926, -1.86010204075488, 218, 51, 'PPL', 'P'),
(23136, 'Mobile Home Estates', 30.8805599212646, 0.538967445485469, -83.2958297729492, -1.45378648271868, 218, 13, 'PPL', 'P'),
(4262, 'Mobile Junction', 33.3680610656738, 0.582382530602536, -86.9766693115234, -1.51802925190439, 218, 2, 'PPL', 'P'),
(199538, 'Mobile Manor', 41.1505584716797, 0.718212734365256, -100.783889770508, -1.75901070946239, 218, 35, 'PPL', 'P'),
(199539, 'Mobile Manor Trailer Park', 41.0927810668945, 0.717204328418498, -102.470283508301, -1.78844383267189, 218, 35, 'PPL', 'P'),
(136931, 'Mobile Park Estates', 45.8611106872559, 0.800427380114174, -95.3755569458008, -1.66461749462757, 218, 28, 'PPL', 'P'),
(183358, 'Mobile Parks West Mobile Home Park', 37.4150009155273, 0.653014955612645, -121.942222595215, -2.12829328148632, 218, 6, 'PPL', 'P'),
(104316, 'Mobjack', 37.375, 0.652316807932881, -76.3477783203125, -1.3325201082722, 218, 53, 'PPL', 'P'),
(110486, 'Mobley', 39.5569381713867, 0.690398813098523, -80.5488891601563, -1.4058433246687, 218, 58, 'PPL', 'P'),
(10546, 'Mobley (historical)', 35.9008293151855, 0.626587675746489, -91.4477767944336, -1.59606479869173, 218, 4, 'PPL', 'P'),
(89087, 'Mobley (historical)', 36.4361114501953, 0.635930111429514, -88.0097198486328, -1.53605938511645, 218, 50, 'PPL', 'P'),
(23137, 'Mobley Crossing', 32.3230590820313, 0.564143805298101, -83.4077835083008, -1.45574044401048, 218, 13, 'PPL', 'P'),
(82436, 'Mobleys Crossroads', 33.9136085510254, 0.591904130447896, -81.7441711425781, -1.42670493075172, 218, 48, 'PPL', 'P'),
(89090, 'Mobra', 35.8816719055176, 0.626253315871629, -85.2600021362305, -1.48806775753462, 218, 50, 'PPL', 'P'),
(202391, 'Mobridge', 45.5372200012207, 0.794774421226317, -100.42749786377, -1.75279049726235, 218, 49, 'PPL', 'P'),
(197074, 'Mobridge (historical)', 47.6194381713867, 0.831115984040566, -108.680000305176, -1.89682383639376, 218, 31, 'PPL', 'P'),
(164686, 'Mocanaqua', 41.1411094665527, 0.718047818114753, -76.1391677856445, -1.3288791675879, 218, 45, 'PPL', 'P'),
(191003, 'Mocane', 36.8936080932617, 0.643914934167844, -100.372222900391, -1.75182576715747, 218, 42, 'PPL', 'P'),
(27924, 'Moccasin', 39.1472206115723, 0.683247892676524, -88.7577819824219, -1.54911553236056, 218, 18, 'PPL', 'P'),
(89089, 'Moccasin', 35.4033317565918, 0.617904705328395, -87.7405624389648, -1.5313617021116, 218, 50, 'PPL', 'P'),
(178656, 'Moccasin', 36.9094390869141, 0.64419123713094, -112.758056640625, -1.96799934652916, 218, 5, 'PPL', 'P'),
(193795, 'Moccasin', 40.0769386291504, 0.699474533198377, -120.935279846191, -2.11071881513678, 218, 6, 'PPL', 'P'),
(197075, 'Moccasin', 47.0533294677734, 0.821235523238318, -109.909721374512, -1.91828651793482, 218, 31, 'PPL', 'P'),
(172260, 'Moccasin Mill', 44.6002807617188, 0.778421746605877, -71.8019409179688, -1.25318027834099, 218, 55, 'PPL', 'P'),
(56317, 'Moccasin Springs', 37.4516716003418, 0.653654979801618, -89.4583282470703, -1.56134237124122, 218, 29, 'PPL', 'P'),
(183361, 'Mock', 36.5436096191406, 0.637806308417475, -117.932502746582, -2.05831046804511, 218, 6, 'PPL', 'P'),
(208151, 'Mock', 47.3972206115723, 0.827237555966056, -117.649169921875, -2.053365377375, 218, 56, 'PPL', 'P'),
(10548, 'Mock (historical)', 36.4458312988281, 0.636099754790952, -90.9694366455078, -1.5877161881485, 218, 4, 'PPL', 'P'),
(208152, 'Mock City', 46.9833297729492, 0.820013798088244, -122.587501525879, -2.13955552342016, 218, 56, 'PPL', 'P'),
(675, 'Mock Corner', 39.5336112976074, 0.689991682346877, -94.8908309936523, -1.65615743079272, 218, 29, 'PPL', 'P'),
(104317, 'Mock Mill', 36.7166709899902, 0.640826799146816, -81.831672668457, -1.42823212047883, 218, 53, 'PPL', 'P'),
(23138, 'Mockingbird Estates', 31.5116691589355, 0.549982379622578, -84.1269378662109, -1.46829205538607, 218, 13, 'PPL', 'P'),
(14257, 'Mockingbird Hill', 39.7591705322266, 0.69392843364926, -75.6777801513672, -1.32082643424177, 218, 10, 'PPL', 'P'),
(23139, 'Mockingbird Hill', 33.5558280944824, 0.585659683481933, -84.3827819824219, -1.47275737758581, 218, 13, 'PPL', 'P'),
(89091, 'Mockingbird Hill', 35.9002799987793, 0.626578088366565, -83.9824981689453, -1.4657711070982, 218, 50, 'PPL', 'P'),
(14266, 'Mockingbird Hills', 39.7602806091309, 0.69394780814619, -75.6777801513672, -1.32082643424177, 218, 10, 'PPL', 'P'),
(104319, 'Mockingbird Ridge', 38.7294387817383, 0.675956224190915, -77.4013900756836, -1.35090910244114, 218, 53, 'PPL', 'P'),
(37236, 'Mockingbird Valley', 38.2724990844727, 0.667981121990563, -85.6822204589844, -1.49543685742892, 218, 21, 'PPL', 'P'),
(208153, 'Mockonema', 46.877498626709, 0.818166696135192, -117.440826416016, -2.0497290972226, 218, 56, 'PPL', 'P'),
(66896, 'Mocksville', 35.7183303833008, 0.623402468503727, -80.4991683959961, -1.40497553362749, 218, 33, 'PPL', 'P'),
(208154, 'Moclips', 47.2363891601563, 0.824430517598086, -124.211669921875, -2.16790260953713, 218, 56, 'PPL', 'P'),
(183364, 'Mococo', 38.0255584716797, 0.663671195240434, -122.11499786377, -2.13130877878862, 218, 6, 'PPL', 'P'),
(37238, 'Moct', 37.6613883972168, 0.657315228403823, -83.345832824707, -1.4546592006079, 218, 21, 'PPL', 'P'),
(116879, 'Modale', 41.6197204589844, 0.726401155768923, -96.0116729736328, -1.67571981373795, 218, 16, 'PPL', 'P'),
(132134, 'Moddersville', 44.2202796936035, 0.771789476806171, -84.9524993896484, -1.48270082214784, 218, 27, 'PPL', 'P'),
(27926, 'Mode', 39.2663917541504, 0.685327821487876, -88.7336120605469, -1.54869368764389, 218, 18, 'PPL', 'P'),
(187068, 'Model', 37.3722190856934, 0.652268271822014, -104.244438171387, -1.81940867298236, 218, 7, 'PPL', 'P'),
(150794, 'Model City', 43.185001373291, 0.753720461442201, -78.98388671875, -1.37852887926441, 218, 40, 'PPL', 'P'),
(17156, 'Modello', 25.5022201538086, 0.445097708252415, -80.4433288574219, -1.40400094982658, 218, 12, 'PPL', 'P'),
(78755, 'Modena', 39.9666709899902, 0.697549999836631, -75.8000030517578, -1.32295962627492, 218, 45, 'PPL', 'P'),
(120660, 'Modena', 41.1352806091309, 0.717946085361112, -89.7630615234375, -1.56666097025422, 218, 18, 'PPL', 'P'),
(139341, 'Modena', 40.3002815246582, 0.703372602085926, -93.6802825927734, -1.63502937544263, 218, 29, 'PPL', 'P'),
(150792, 'Modena', 41.6683311462402, 0.727249572313195, -74.1030578613281, -1.29334234547604, 218, 40, 'PPL', 'P'),
(175356, 'Modena', 44.4575004577637, 0.775929760194862, -91.79638671875, -1.60214918967618, 218, 57, 'PPL', 'P'),
(192704, 'Modena', 37.7988891601563, 0.659715069441121, -113.923332214355, -1.98833724198383, 218, 52, 'PPL', 'P'),
(150793, 'Modena Gardens', 41.6474990844727, 0.726885984245372, -74.1216735839844, -1.29366725112903, 218, 40, 'PPL', 'P'),
(164687, 'Modena Park', 40.0783309936523, 0.699498834543324, -74.9883270263672, -1.30879320717236, 218, 45, 'PPL', 'P'),
(116880, 'Modern Manor Mobile Home Park', 41.6416702270508, 0.726784251491731, -91.480827331543, -1.59664163938384, 218, 16, 'PPL', 'P'),
(73502, 'Modest', 39.1930618286133, 0.684047972847011, -84.1072235107422, -1.46794797497324, 218, 41, 'PPL', 'P'),
(104320, 'Modest Town', 37.8127784729004, 0.659957483679345, -75.5652770996094, -1.31886288557005, 218, 53, 'PPL', 'P'),
(42130, 'Modeste', 30.1708297729492, 0.526580317596697, -91.0147171020508, -1.58850648120198, 218, 22, 'PPL', 'P'),
(27927, 'Modesto', 39.478328704834, 0.689026819083942, -89.9819412231445, -1.57048114167989, 218, 18, 'PPL', 'P'),
(30536, 'Modesto', 39.269718170166, 0.68538587839964, -86.5483322143555, -1.51055335925038, 218, 19, 'PPL', 'P'),
(183362, 'Modesto', 37.6391716003418, 0.656927472149108, -120.995826721191, -2.11177555745732, 218, 6, 'PPL', 'P'),
(201246, 'Modeville', 44.7911109924316, 0.781752362444157, -123.131942749023, -2.14905781534762, 218, 43, 'PPL', 'P'),
(183363, 'Modjeska', 33.709171295166, 0.588336027219408, -117.625282287598, -2.05294845950635, 218, 6, 'PPL', 'P'),
(10550, 'Modoc', 34.3358306884766, 0.599273296921227, -90.7794418334961, -1.58440015311719, 218, 4, 'PPL', 'P'),
(23141, 'Modoc', 32.6555595397949, 0.569947033050466, -82.309440612793, -1.43657074416798, 218, 13, 'PPL', 'P'),
(27928, 'Modoc', 38.0525016784668, 0.664141442909914, -90.0372161865234, -1.57144587178477, 218, 18, 'PPL', 'P'),
(37237, 'Modoc', 36.7358283996582, 0.641161159021675, -85.3027801513672, -1.48881437474622, 218, 21, 'PPL', 'P'),
(73501, 'Modoc', 39.4683303833008, 0.688852315453514, -82.129997253418, -1.43343886672604, 218, 41, 'PPL', 'P'),
(82439, 'Modoc', 33.7333297729492, 0.588757672198995, -82.2058334350586, -1.43476245778781, 218, 48, 'PPL', 'P'),
(110488, 'Modoc', 38.024169921875, 0.663646960474514, -80.3452835083008, -1.40228973566815, 218, 58, 'PPL', 'P'),
(123215, 'Modoc', 40.045280456543, 0.698921993851213, -85.1263885498047, -1.48573576052609, 218, 19, 'PPL', 'P'),
(187814, 'Modoc', 38.4869384765625, 0.671723795428506, -101.081390380859, -1.76420307463972, 218, 20, 'PPL', 'P'),
(189048, 'Modoc (historical)', 32.3438911437988, 0.564507393365924, -106.579170227051, -1.86015743450555, 218, 38, 'PPL', 'P'),
(10549, 'Modoc Landing', 34.2966690063477, 0.598589796627459, -90.7936096191406, -1.5846474276244, 218, 4, 'PPL', 'P'),
(201247, 'Modoc Point', 42.4449996948242, 0.740804995682671, -121.867218017578, -2.1269842046525, 218, 43, 'PPL', 'P'),
(82437, 'Modoc Subdivision', 33.7097206115723, 0.588345614599333, -82.2180633544922, -1.43497591014918, 218, 48, 'PPL', 'P'),
(145779, 'Moe', 41.1622200012207, 0.718416266451566, -74.3869400024414, -1.29829702352608, 218, 37, 'PPL', 'P'),
(170902, 'Moe', 43.1561088562012, 0.753216191889795, -96.6086120605469, -1.68613836623845, 218, 49, 'PPL', 'P'),
(175358, 'Moe Settlement (historical)', 43.5986099243164, 0.760939292471997, -89.6994400024414, -1.56555056523771, 218, 57, 'PPL', 'P'),
(42131, 'Moeling (historical)', 30.583610534668, 0.533784700977579, -92.7861099243164, -1.61942311829671, 218, 22, 'PPL', 'P'),
(27929, 'Moellenbrocks', 38.7063903808594, 0.675553953708258, -90.0722198486328, -1.57205680093883, 218, 18, 'PPL', 'P'),
(178657, 'Moenave', 36.1386108398438, 0.630737746252187, -111.336669921875, -1.94319146834286, 218, 5, 'PPL', 'P'),
(178658, 'Moenkopi', 36.1111106872559, 0.630257778044727, -111.221672058105, -1.94118437698732, 218, 5, 'PPL', 'P'),
(202390, 'Moenville', 44.476390838623, 0.776259459537814, -101.254997253418, -1.76723308616996, 218, 49, 'PPL', 'P'),
(145780, 'Moerls Corner', 40.3605613708496, 0.704424683874562, -74.3177795410156, -1.297089945762, 218, 37, 'PPL', 'P'),
(197076, 'Moes Trailer Court', 48.098331451416, 0.839474248542753, -105.633331298828, -1.84364943101453, 218, 31, 'PPL', 'P'),
(175359, 'Moeville', 44.6886100769043, 0.779963383981896, -92.5272216796875, -1.61490466603322, 218, 57, 'PPL', 'P'),
(191892, 'Mofeta', 30.0541706085205, 0.524544231074791, -102.225563049316, -1.78417265491563, 218, 51, 'PPL', 'P'),
(4263, 'Moffat', 33.0530586242676, 0.576884700848177, -87.1830596923828, -1.52163144359483, 218, 2, 'PPL', 'P'),
(96272, 'Moffat', 31.1997203826904, 0.544537846379533, -97.4680633544922, -1.70113862107832, 218, 51, 'PPL', 'P'),
(187069, 'Moffat', 37.9988899230957, 0.663205741260915, -105.909439086914, -1.84846842100703, 218, 7, 'PPL', 'P'),
(89092, 'Moffatt', 36.3266716003418, 0.634020025716682, -89.0911102294922, -1.55493320776184, 218, 50, 'PPL', 'P'),
(4264, 'Moffet', 30.8541698455811, 0.53850685177494, -88.3974990844727, -1.54282740955272, 218, 2, 'PPL', 'P'),
(76619, 'Moffett', 35.3902816772461, 0.617676938476166, -94.4466705322266, -1.64840536833366, 218, 42, 'PPL', 'P'),
(104321, 'Moffett', 36.6308288574219, 0.639328571296564, -78.7538909912109, -1.37451469655333, 218, 53, 'PPL', 'P'),
(208155, 'Moffetts Hot Springs', 45.6552810668945, 0.796834975540739, -121.956672668457, -2.12854548284155, 218, 56, 'PPL', 'P'),
(198632, 'Moffit', 46.6772193908691, 0.814671164046408, -100.290832519531, -1.75040523703202, 218, 34, 'PPL', 'P'),
(4265, 'Moffits Mill', 32.5099983215332, 0.567406510528585, -85.1852798461914, -1.48676360754881, 218, 2, 'PPL', 'P'),
(82438, 'Moffitsville', 34.2897186279297, 0.598468489639805, -82.7111129760742, -1.4435812494215, 218, 48, 'PPL', 'P'),
(150798, 'Moffitsville', 44.6386108398438, 0.779090732671705, -73.7563934326172, -1.28729190979549, 218, 40, 'PPL', 'P'),
(17157, 'Moffitt', 27.454439163208, 0.479170357686457, -81.7969436645508, -1.42762598501473, 218, 12, 'PPL', 'P'),
(96273, 'Moffitt', 31.3980598449707, 0.547999523032959, -94.6430587768555, -1.65183298981465, 218, 51, 'PPL', 'P'),
(123216, 'Moffitt', 41.101390838623, 0.717354597283006, -87.2186126708984, -1.52225196012882, 218, 19, 'PPL', 'P'),
(156543, 'Moffitt (historical)', 41.0222206115723, 0.715972816151418, -83.8472213745117, -1.46341008163379, 218, 41, 'PPL', 'P'),
(156544, 'Moffitt Heights', 40.7783317565918, 0.71171615262309, -81.5744400024414, -1.42374256351317, 218, 41, 'PPL', 'P'),
(66898, 'Moffitt Hill', 35.6055603027344, 0.621434259300104, -82.1761093139648, -1.43424367400747, 218, 33, 'PPL', 'P'),
(78757, 'Moffitt Sterling', 39.7577781677246, 0.693904132304313, -79.936393737793, -1.39515326289506, 218, 45, 'PPL', 'P'),
(164690, 'Moffitts Mills', 40.0586090087891, 0.699154620972431, -79.9533309936523, -1.39544887377606, 218, 45, 'PPL', 'P'),
(156545, 'Mogadore', 41.0463905334473, 0.716394660868086, -81.398063659668, -1.42066421560915, 218, 41, 'PPL', 'P'),
(104322, 'Mogarts Beach', 37.0319404602051, 0.646329289433083, -76.6011123657227, -1.336941621472, 218, 53, 'PPL', 'P'),
(164688, 'Mogees Station', 40.107780456543, 0.700012824633709, -75.3199996948242, -1.31458198727581, 218, 45, 'PPL', 'P'),
(164689, 'Mogeetown', 40.107780456543, 0.700012824633709, -75.3133316040039, -1.31446560713617, 218, 45, 'PPL', 'P'),
(189049, 'Mogollon', 33.396671295166, 0.582881873306926, -108.793609619141, -1.89880669298338, 218, 38, 'PPL', 'P'),
(187070, 'Mogote', 37.059440612793, 0.646809257640542, -106.091667175293, -1.85164890113885, 218, 7, 'PPL', 'P'),
(23142, 'Mogul', 32.8497200012207, 0.573335772379537, -83.5650024414063, -1.45848443203964, 218, 13, 'PPL', 'P'),
(190498, 'Mogul', 39.5138893127441, 0.689647468775985, -119.925003051758, -2.09308615871742, 218, 39, 'PPL', 'P'),
(198633, 'Mohall', 48.7633285522461, 0.851080637468454, -101.51277923584, -1.77173223051554, 218, 34, 'PPL', 'P'),
(178660, 'Mohave Crossing', 35.3333282470703, 0.616682913599293, -114.58805847168, -1.99993890379859, 218, 5, 'PPL', 'P'),
(178661, 'Mohave Valley', 34.9330596923828, 0.609696909427798, -114.58805847168, -1.99993890379859, 218, 5, 'PPL', 'P'),
(10551, 'Mohawk', 33.0680618286133, 0.577146556162359, -93.1849975585938, -1.62638502086034, 218, 4, 'PPL', 'P'),
(17158, 'Mohawk', 28.5719394683838, 0.498674417403815, -81.7300033569336, -1.42645765624451, 218, 12, 'PPL', 'P'),
(30535, 'Mohawk', 39.8436088562012, 0.695402160417482, -85.8408279418945, -1.49820508022401, 218, 19, 'PPL', 'P'),
(76618, 'Mohawk', 36.2058296203613, 0.631910935291394, -95.9272232055664, -1.67424588723264, 218, 42, 'PPL', 'P'),
(89093, 'Mohawk', 36.2008285522461, 0.631823650186666, -83.0527801513672, -1.44954446657635, 218, 50, 'PPL', 'P'),
(110489, 'Mohawk', 37.5047187805176, 0.654580827754584, -81.915283203125, -1.42969139959814, 218, 58, 'PPL', 'P'),
(132136, 'Mohawk', 47.3038902282715, 0.825608633485309, -88.3647232055664, -1.54225536255057, 218, 27, 'PPL', 'P'),
(150795, 'Mohawk', 43.0113906860352, 0.750690383332936, -75.0044403076172, -1.30907443698347, 218, 40, 'PPL', 'P'),
(178662, 'Mohawk', 32.7266693115234, 0.57118813269747, -113.754440307617, -1.98538952213127, 218, 5, 'PPL', 'P'),
(183366, 'Mohawk', 39.7788887023926, 0.694272580641125, -120.634437561035, -2.10546812673158, 218, 6, 'PPL', 'P'),
(201248, 'Mohawk', 44.1425018310547, 0.77043199701953, -122.915000915527, -2.1452714660678, 218, 43, 'PPL', 'P'),
(104323, 'Mohawk (historical)', 36.8494415283203, 0.643144082190321, -82.8888931274414, -1.44668409840755, 218, 53, 'PPL', 'P'),
(42132, 'Mohawk City', 29.8994407653809, 0.521843685860909, -89.9016723632813, -1.56908018578845, 218, 22, 'PPL', 'P'),
(56318, 'Mohawk Corner', 37.7577781677246, 0.658997547264426, -93.3052825927734, -1.62848439074765, 218, 29, 'PPL', 'P'),
(89094, 'Mohawk Crossroad', 36.2213897705078, 0.632182511143555, -83.029167175293, -1.44913234239766, 218, 50, 'PPL', 'P'),
(150796, 'Mohawk Gardens', 43.226390838623, 0.754442843887885, -75.4400024414063, -1.3166764303151, 218, 40, 'PPL', 'P'),
(150797, 'Mohawk Hill', 43.5247192382813, 0.759649656714126, -75.4700012207031, -1.31720000778541, 218, 40, 'PPL', 'P'),
(201249, 'Mohawk Post (historical)', 44.1441688537598, 0.770461092054439, -122.914436340332, -2.14526161237176, 218, 43, 'PPL', 'P'),
(150799, 'Mohawk View', 42.7836112976074, 0.746714883036693, -73.7888870239258, -1.28785902994962, 218, 40, 'PPL', 'P'),
(156547, 'Mohawk Village', 40.3250007629395, 0.703804034182519, -82.079719543457, -1.43256135514686, 218, 41, 'PPL', 'P'),
(183367, 'Mohawk Vista', 39.7808303833008, 0.694306469365996, -120.577499389648, -2.10447436817082, 218, 6, 'PPL', 'P'),
(110490, 'Mohegan', 37.4530601501465, 0.653679214567538, -81.6308288574219, -1.42472673469401, 218, 58, 'PPL', 'P'),
(113734, 'Mohegan', 41.4766693115234, 0.723904442246974, -72.1002807617188, -1.25838729090432, 218, 8, 'PPL', 'P'),
(169489, 'Mohegan', 41.9858283996582, 0.732790944751377, -71.6230621337891, -1.25005825459509, 218, 47, 'PPL', 'P'),
(60921, 'Mohegan (historical)', 32.9936103820801, 0.575847133287482, -88.4841690063477, -1.54434008505189, 218, 30, 'PPL', 'P'),
(113735, 'Mohegan (historical)', 41.4766693115234, 0.723904442246974, -72.1002807617188, -1.25838729090432, 218, 8, 'PPL', 'P'),
(150801, 'Mohegan Heights', 40.9530601501465, 0.714765738387339, -73.8433303833008, -1.28880924582657, 218, 40, 'PPL', 'P'),
(150802, 'Mohegan Lake', 41.3183288574219, 0.721140879983798, -73.8594436645508, -1.28909047563768, 218, 40, 'PPL', 'P'),
(49538, 'Mohican Hills', 38.964168548584, 0.680053031474811, -77.1272201538086, -1.34612393459449, 218, 25, 'PPL', 'P'),
(150803, 'Mohican Lake', 41.5180587768555, 0.724626824692658, -74.8183288574219, -1.3058261794019, 218, 40, 'PPL', 'P'),
(156549, 'Mohicanville', 40.7280616760254, 0.710838774201963, -82.1913909912109, -1.43451038959064, 218, 41, 'PPL', 'P'),
(195337, 'Mohler', 46.2897186279297, 0.807907999879125, -116.345283508301, -2.03060826638611, 218, 17, 'PPL', 'P'),
(199540, 'Mohler', 41.7147216796875, 0.728059239863606, -103.234443664551, -1.80178094341101, 218, 35, 'PPL', 'P'),
(201251, 'Mohler', 45.7075004577637, 0.797746375844791, -123.861671447754, -2.16179398378676, 218, 43, 'PPL', 'P'),
(208156, 'Mohler', 47.4049987792969, 0.827373310602623, -118.328056335449, -2.06521418053892, 218, 56, 'PPL', 'P'),
(164691, 'Mohns Hill', 40.2758293151855, 0.702945830521241, -76.04638671875, -1.32725983248707, 218, 45, 'PPL', 'P'),
(164692, 'Mohnton', 40.285831451416, 0.703120400730695, -75.9847183227539, -1.32618351593252, 218, 45, 'PPL', 'P'),
(60922, 'Mohoba (historical)', 31.0716705322266, 0.542302954882252, -88.4499969482422, -1.54374367012576, 218, 30, 'PPL', 'P'),
(150804, 'Mohonk Lake', 41.7686080932617, 0.728999735202568, -74.1561126708984, -1.29426832658706, 218, 40, 'PPL', 'P'),
(192705, 'Mohrland', 39.4402809143066, 0.68836275986613, -111.014442443848, -1.93756753791088, 218, 52, 'PPL', 'P'),
(164694, 'Mohrsville', 40.4738883972168, 0.706402613616164, -75.9772186279297, -1.32605262156494, 218, 45, 'PPL', 'P'),
(112654, 'Mohrtown', 38.7374992370605, 0.676096905675498, -82.1258316040039, -1.43336616242828, 218, 58, 'PPL', 'P'),
(208158, 'Mohrweis', 47.3116683959961, 0.825744388121876, -123.233329772949, -2.15082735273392, 218, 56, 'PPL', 'P'),
(197077, 'Moiese', 47.3705596923828, 0.826772235144592, -114.264999389648, -1.99430045913868, 218, 31, 'PPL', 'P'),
(116881, 'Moingona', 42.0169410705566, 0.733333963297644, -93.9322204589844, -1.63942652071846, 218, 16, 'PPL', 'P'),
(150805, 'Moira', 44.8180618286133, 0.782222743271692, -74.5561065673828, -1.3012495370686, 218, 40, 'PPL', 'P'),
(178663, 'Moivayi', 32.5633316040039, 0.568337351908594, -112.458061218262, -1.96276343866801, 218, 5, 'PPL', 'P'),
(183368, 'Mojave', 35.0525016784668, 0.611781565350084, -118.173057556152, -2.06250894150362, 218, 6, 'PPL', 'P'),
(183369, 'Mojave Base', 35.3305587768555, 0.616634577225509, -116.899719238281, -2.04028499536497, 218, 6, 'PPL', 'P'),
(178664, 'Mojave City', 35.0444412231445, 0.611640883865501, -114.622222900391, -2.00053518556666, 218, 5, 'PPL', 'P'),
(183370, 'Mojave Heights', 34.5686111450195, 0.603336082322198, -117.324722290039, -2.04770269794916, 218, 6, 'PPL', 'P'),
(178665, 'Mojave Ranch Estates', 34.9427795410156, 0.609866552789236, -114.589996337891, -1.99997272594444, 218, 5, 'PPL', 'P'),
(208157, 'Mojonnier', 46.0269393920898, 0.803321637007845, -118.423889160156, -2.06688677886155, 218, 56, 'PPL', 'P'),
(210713, 'Mokae', 20.7208309173584, 0.361646723256941, -155.995834350586, -2.72264092881339, 218, 15, 'PPL', 'P'),
(56319, 'Mokane', 38.6749992370605, 0.675006074893001, -91.8741683959961, -1.60350673604185, 218, 29, 'PPL', 'P'),
(210714, 'Mokaoku', 19.7313899993896, 0.344377721484431, -155.067779541016, -2.70644331674742, 218, 15, 'PPL', 'P'),
(183371, 'Mokelumne City', 38.253059387207, 0.667641835267687, -121.438056945801, -2.11949393092859, 218, 6, 'PPL', 'P'),
(183372, 'Mokelumne Hill', 38.3005599975586, 0.668470877315029, -120.705276489258, -2.10670449926765, 218, 6, 'PPL', 'P'),
(120661, 'Mokena', 41.5261116027832, 0.724767373019187, -87.8891677856445, -1.53395535469723, 218, 18, 'PPL', 'P'),
(10552, 'Moko', 36.4674987792969, 0.636477923665743, -91.8397216796875, -1.60290552742576, 218, 4, 'PPL', 'P'),
(210716, 'Mokulau', 20.6455593109131, 0.360332985891205, -156.110565185547, -2.72464335963703, 218, 15, 'PPL', 'P'),
(210718, 'MokulÃƒÂ«Ã‚â€˜ia Beach Colony', 21.5830593109131, 0.376695447628652, -158.17805480957, -2.76072786082705, 218, 15, 'PPL', 'P'),
(210717, 'Mokuleia', 21.5841693878174, 0.376714822125582, -158.151947021484, -2.76027219396454, 218, 15, 'PPL', 'P'),
(201250, 'Molalla', 45.1474990844727, 0.787972508065173, -122.575828552246, -2.13935179159677, 218, 43, 'PPL', 'P'),
(136933, 'Moland', 44.1966705322266, 0.771377419206508, -93.061393737793, -1.62422772721932, 218, 28, 'PPL', 'P'),
(156550, 'Molasses Gap', 41.1502799987793, 0.718207874096267, -84.476936340332, -1.47440068113644, 218, 41, 'PPL', 'P'),
(17159, 'Molasses Junction', 29.850830078125, 0.520995269316637, -81.4938888549805, -1.42233668077372, 218, 12, 'PPL', 'P'),
(208161, 'Mold', 47.7430610656738, 0.833273610576721, -119.340827941895, -2.08289037964211, 218, 56, 'PPL', 'P'),
(89096, 'Mole', 36.4808311462402, 0.636710617365989, -82.7547225952148, -1.44434238086105, 218, 50, 'PPL', 'P'),
(175360, 'Mole Lake', 45.4797210693359, 0.793770875548548, -88.9830627441406, -1.55304742339395, 218, 57, 'PPL', 'P'),
(200079, 'Moleen', 40.7386093139648, 0.711022865212315, -115.946670532227, -2.02365115751244, 218, 39, 'PPL', 'P'),
(192706, 'Molen', 39.0883293151855, 0.682220045653808, -111.072776794434, -1.93858566439562, 218, 52, 'PPL', 'P'),
(23143, 'Molena', 33.0119400024414, 0.576167045513427, -84.5002822875977, -1.47480814478323, 218, 13, 'PPL', 'P'),
(183373, 'Molena', 38.1258316040039, 0.665421291550779, -121.875556945801, -2.12712974640607, 218, 6, 'PPL', 'P'),
(23144, 'Molena Mobile Home Park', 32.639720916748, 0.569670596929315, -83.6913909912109, -1.46069032837055, 218, 13, 'PPL', 'P'),
(110491, 'Moler Crossroads', 39.3958282470703, 0.687586914461563, -77.7652816772461, -1.35726020900876, 218, 58, 'PPL', 'P'),
(49539, 'Molesworth Hills', 39.3525009155273, 0.686830709870035, -77.2222213745117, -1.34778201868917, 218, 25, 'PPL', 'P'),
(208159, 'Molfait Tracts', 45.6063919067383, 0.795981698727478, -122.230560302734, -2.13332572384019, 218, 56, 'PPL', 'P'),
(187071, 'Molina', 39.1891708374023, 0.683980062239214, -108.059722900391, -1.88599795340453, 218, 7, 'PPL', 'P'),
(33316, 'Moline', 37.360279083252, 0.652059879466715, -96.3036117553711, -1.68081510669354, 218, 20, 'PPL', 'P'),
(96274, 'Moline', 31.3836097717285, 0.547747321677729, -98.3102798461914, -1.71583807187306, 218, 51, 'PPL', 'P'),
(120662, 'Moline', 41.5066719055176, 0.724428086296311, -90.5149993896484, -1.57978476179002, 218, 18, 'PPL', 'P'),
(132137, 'Moline', 42.7391700744629, 0.745939237369208, -85.6638870239258, -1.49511687862395, 218, 27, 'PPL', 'P'),
(156551, 'Moline', 41.5586090087891, 0.725334559752346, -83.5113906860352, -1.45754873039064, 218, 41, 'PPL', 'P'),
(56320, 'Moline Acres', 38.746940612793, 0.676261688767947, -90.2399978637695, -1.57498507971543, 218, 29, 'PPL', 'P'),
(17160, 'Molino', 30.7238903045654, 0.53623304483623, -87.3141708374023, -1.52391976476149, 218, 12, 'PPL', 'P'),
(56321, 'Molino', 39.3016700744629, 0.685943544331902, -91.878059387207, -1.60357464664965, 218, 29, 'PPL', 'P'),
(60923, 'Molino', 34.5752792358398, 0.603452462461834, -88.8925018310547, -1.55146683728699, 218, 30, 'PPL', 'P'),
(89095, 'Molino', 35.1072196960449, 0.612736574916987, -86.6747207641602, -1.51275925558129, 218, 50, 'PPL', 'P'),
(164695, 'Molino', 40.6091690063477, 0.708763705659601, -76.0255584716797, -1.32689631099828, 218, 45, 'PPL', 'P'),
(183375, 'Molino', 34.125560760498, 0.595603394360071, -117.194717407227, -2.04543368470042, 218, 6, 'PPL', 'P'),
(17161, 'Molino Crossroads', 30.7177791595459, 0.536126385234572, -87.3388900756836, -1.52435119685808, 218, 12, 'PPL', 'P'),
(49540, 'Molitor Estates', 39.6644401550293, 0.692275076665511, -75.8444366455078, -1.32373513878435, 218, 25, 'PPL', 'P'),
(164696, 'Mollenauer', 40.353328704834, 0.704298450038892, -80.0252838134766, -1.39670468738809, 218, 45, 'PPL', 'P'),
(42133, 'Moller', 31.3561096191406, 0.547267353470269, -92.293327331543, -1.6108224395563, 218, 22, 'PPL', 'P'),
(4266, 'Mollie', 32.2413902282715, 0.562718414903664, -88.2716674804688, -1.54063123375979, 218, 2, 'PPL', 'P'),
(66899, 'Mollie', 34.1511116027832, 0.596049340684605, -78.7408294677734, -1.37428672996402, 218, 33, 'PPL', 'P'),
(4267, 'Molloy', 33.7366714477539, 0.588815995426868, -88.2022171020508, -1.53941909598964, 218, 2, 'PPL', 'P'),
(164700, 'Molltown', 40.4772186279297, 0.706460737106955, -75.8808288574219, -1.32437030270434, 218, 45, 'PPL', 'P'),
(10553, 'Mollus (historical)', 36.2533302307129, 0.632739977338735, -90.6977767944336, -1.58297482930177, 218, 4, 'PPL', 'P'),
(104324, 'Mollusk', 37.7299995422363, 0.658512718787977, -76.538330078125, -1.33584586384149, 218, 53, 'PPL', 'P'),
(82440, 'Molly Tree Plantation', 34.7874984741211, 0.607156386905916, -82.2591705322266, -1.43569336574685, 218, 48, 'PPL', 'P'),
(208160, 'Molson', 48.9811096191406, 0.85488163413427, -119.199440002441, -2.08042269457604, 218, 56, 'PPL', 'P'),
(197078, 'Molt', 45.8613891601563, 0.800432240383164, -108.927223205566, -1.90113868999191, 218, 31, 'PPL', 'P'),
(132138, 'Moltke', 45.4000015258789, 0.792379507037037, -83.9274978637695, -1.46481117068329, 218, 27, 'PPL', 'P'),
(66900, 'Moltonville', 34.9908294677734, 0.610705182216502, -78.2508316040039, -1.3657346539135, 218, 33, 'PPL', 'P'),
(128158, 'Molunkus', 45.6152801513672, 0.796136827860975, -68.3038864135742, -1.19212770982509, 218, 26, 'PPL', 'P'),
(37239, 'Molus', 36.813060760498, 0.642509118007419, -83.4905624389648, -1.45718520890184, 218, 21, 'PPL', 'P'),
(183377, 'Molus', 36.4680595397949, 0.636487710782749, -121.393058776855, -2.11870856472313, 218, 6, 'PPL', 'P'),
(189050, 'Moly', 36.6969413757324, 0.640482452417868, -105.492218017578, -1.84118653963842, 218, 38, 'PPL', 'P'),
(150807, 'Molyneaux Corners', 43.2102813720703, 0.7541616806558, -78.7975006103516, -1.37527582799288, 218, 40, 'PPL', 'P'),
(113741, 'Momauguin', 41.2519416809082, 0.719982205172532, -72.8766708374023, -1.2719378540048, 218, 8, 'PPL', 'P'),
(150808, 'Mombaccus', 41.814998626709, 0.729809402752979, -74.3119430541992, -1.29698807985031, 218, 40, 'PPL', 'P'),
(120664, 'Momence', 41.1666717529297, 0.718493964176369, -87.6627807617188, -1.53000415574594, 218, 18, 'PPL', 'P'),
(156552, 'Momeneetown', 41.6597213745117, 0.727099303448687, -83.4097213745117, -1.45577426615632, 218, 41, 'PPL', 'P'),
(66902, 'Momeyer', 35.961109161377, 0.627639757535125, -78.0572204589844, -1.36235550196436, 218, 33, 'PPL', 'P'),
(66901, 'Momford Landing', 34.7275009155273, 0.606109231965297, -77.4061126708984, -1.35099152727688, 218, 33, 'PPL', 'P'),
(204957, 'Mon de Ville Condominium', 40.7708282470703, 0.711585191676485, -111.873062133789, -1.95255327852281, 218, 52, 'PPL', 'P'),
(4269, 'Mon Louis', 30.4402809143066, 0.531283127186641, -88.105827331543, -1.53773677712903, 218, 2, 'PPL', 'P'),
(89097, 'Mona', 35.9872207641602, 0.628095490976665, -86.42138671875, -1.50833774238149, 218, 50, 'PPL', 'P'),
(116882, 'Mona', 43.4872207641602, 0.758995184876239, -92.9411087036133, -1.62212835733201, 218, 16, 'PPL', 'P'),
(177751, 'Mona', 39.8161087036133, 0.694922192210023, -111.854721069336, -1.95223316655978, 218, 52, 'PPL', 'P'),
(209612, 'Mona', 44.810001373291, 0.782082061787109, -104.380828857422, -1.82178913952272, 218, 59, 'PPL', 'P'),
(4268, 'Mona (historical)', 34.0250015258789, 0.593848304622682, -85.603889465332, -1.49406972368333, 218, 2, 'PPL', 'P'),
(197079, 'Mona (historical)', 47.9694404602051, 0.837224676369963, -104.697776794434, -1.82732092458098, 218, 31, 'PPL', 'P'),
(33317, 'Mona Kay Heights', 37.5988883972168, 0.656224397621327, -97.3116683959961, -1.69840901411904, 218, 20, 'PPL', 'P'),
(164697, 'Monaca', 40.6872215270996, 0.710125979136203, -80.2716674804688, -1.40100489360024, 218, 45, 'PPL', 'P'),
(104325, 'Monacan Hill', 37.6083297729492, 0.656389180713775, -77.6847229003906, -1.35585419311126, 218, 53, 'PPL', 'P'),
(104326, 'Monacan Town (historical)', 38.0819396972656, 0.664655233263218, -78.4372177124023, -1.36898770518504, 218, 53, 'PPL', 'P'),
(183378, 'Monache (historical)', 36.0805587768555, 0.629724546615466, -119.051940917969, -2.07784834990832, 218, 6, 'PPL', 'P'),
(183379, 'Monaco', 33.8730583190918, 0.591196395388208, -118.358329772949, -2.0657425516992, 218, 6, 'PPL', 'P'),
(183380, 'Monada', 38.0369415283203, 0.663869867057753, -121.277221679688, -2.11668682598159, 218, 6, 'PPL', 'P'),
(82442, 'Monaghan', 34.8655586242676, 0.608518793540574, -82.4291687011719, -1.43866039351731, 218, 48, 'PPL', 'P'),
(144162, 'Monahan Corners', 42.9213905334473, 0.74911958434298, -70.9922180175781, -1.23904794770038, 218, 36, 'PPL', 'P'),
(191893, 'Monahans', 31.5941696166992, 0.551422284244956, -102.892219543457, -1.79580800571818, 218, 51, 'PPL', 'P'),
(140521, 'Monango', 46.172779083252, 0.805867019798716, -98.5941696166992, -1.72079288308116, 218, 34, 'PPL', 'P'),
(10558, 'Monarch', 36.3772201538086, 0.634902264406798, -92.8455581665039, -1.6204606858574, 218, 4, 'PPL', 'P'),
(17162, 'Monarch', 28.8352794647217, 0.503270567392101, -82.0488891601563, -1.43202326344861, 218, 12, 'PPL', 'P'),
(56322, 'Monarch', 38.6433296203613, 0.674453335808756, -90.67138671875, -1.58251423559125, 218, 29, 'PPL', 'P'),
(60924, 'Monarch', 31.5125007629395, 0.549996893850519, -89.0727767944336, -1.55461322895687, 218, 30, 'PPL', 'P'),
(78758, 'Monarch', 39.9791717529297, 0.697768179308936, -79.6580581665039, -1.39029539075065, 218, 45, 'PPL', 'P'),
(82443, 'Monarch', 34.7183303833008, 0.605949175983784, -81.5966720581055, -1.424130586084, 218, 48, 'PPL', 'P'),
(104327, 'Monarch', 36.8352813720703, 0.642896940841161, -83.0311126708984, -1.44916629770156, 218, 53, 'PPL', 'P'),
(110492, 'Monarch', 38.2150001525879, 0.666977576312794, -81.4572219848633, -1.42169672316377, 218, 58, 'PPL', 'P'),
(197080, 'Monarch', 47.098331451416, 0.822020956022809, -110.837783813477, -1.93448426315884, 218, 31, 'PPL', 'P'),
(204958, 'Monarch', 40.4172210693359, 0.705413582166335, -110.104721069336, -1.92168990464988, 218, 52, 'PPL', 'P'),
(209613, 'Monarch', 44.9030609130859, 0.783706257156921, -107.034439086914, -1.86810337509196, 218, 59, 'PPL', 'P'),
(190499, 'Monarch (historical)', 38.5322189331055, 0.672514088481987, -116.887222290039, -2.04006688247169, 218, 39, 'PPL', 'P'),
(49545, 'Monarch Meadow', 39.5272216796875, 0.68988016247623, -76.9305572509766, -1.34269151942354, 218, 25, 'PPL', 'P'),
(128164, 'Monarda', 45.7969398498535, 0.799307387717741, -68.3244400024414, -1.19248643762393, 218, 26, 'PPL', 'P'),
(56323, 'Monark Springs', 36.8644409179688, 0.643405870925476, -94.291389465332, -1.64569520245034, 218, 29, 'PPL', 'P'),
(104328, 'Monaskon', 37.7374992370605, 0.658643613155555, -76.5658264160156, -1.33632576546992, 218, 53, 'PPL', 'P'),
(139338, 'Monastery', 40.226390838623, 0.702082966328055, -94.7177810668945, -1.65313713980046, 218, 29, 'PPL', 'P'),
(169495, 'Monastery Heights', 41.9361114501953, 0.731923220289202, -71.399169921875, -1.24615059832762, 218, 47, 'PPL', 'P'),
(13163, 'Monastery Lot (historical)', 38.9194412231445, 0.679272392380281, -76.9736099243164, -1.3434429303251, 218, 9, 'PPL', 'P'),
(104329, 'Monasukapanough (historical)', 38.101390838623, 0.664994719723176, -78.460563659668, -1.36939516883182, 218, 53, 'PPL', 'P'),
(96275, 'Monaville', 29.9505596160889, 0.5227358781156, -96.0386123657227, -1.6761899948284, 218, 51, 'PPL', 'P'),
(110493, 'Monaville', 37.811939239502, 0.65994283629335, -81.995002746582, -1.43108276810965, 218, 58, 'PPL', 'P'),
(120667, 'Monaville', 42.3994407653809, 0.740009842360201, -88.1113891601563, -1.53783384935077, 218, 18, 'PPL', 'P'),
(66905, 'Monbo', 35.6641693115234, 0.622457179474803, -80.9786071777344, -1.41334331893058, 218, 33, 'PPL', 'P'),
(175362, 'Monches', 43.1911087036133, 0.753827054464831, -88.3436126708984, -1.54188691421376, 218, 57, 'PPL', 'P'),
(82444, 'Moncks Corner', 33.1958312988281, 0.579376554101136, -80.0133285522461, -1.39649602871668, 218, 48, 'PPL', 'P'),
(42141, 'Moncla', 31.2041702270508, 0.544615510814823, -92.1188888549805, -1.60777791379812, 218, 22, 'PPL', 'P'),
(110494, 'Monclo', 37.9083290100098, 0.661625155153953, -81.8386077880859, -1.42835316115037, 218, 58, 'PPL', 'P'),
(156553, 'Monclova', 41.5586090087891, 0.725334559752346, -83.7330627441406, -1.46141763766425, 218, 41, 'PPL', 'P'),
(23145, 'Moncrief', 30.7124996185303, 0.536034239860856, -84.1374969482422, -1.46847634613351, 218, 13, 'PPL', 'P'),
(60925, 'Moncure', 32.0552787780762, 0.559470157322094, -90.2594375610352, -1.5753243664383, 218, 30, 'PPL', 'P'),
(66903, 'Moncure', 35.622501373291, 0.62172993676013, -79.07861328125, -1.38018216966913, 218, 33, 'PPL', 'P'),
(104330, 'Moncure Corner', 37.9505615234375, 0.66236225156466, -77.4677810668945, -1.35206784383144, 218, 53, 'PPL', 'P'),
(178666, 'MonDak Mobile Home Park', 33.4194412231445, 0.583279283520593, -111.749443054199, -1.95039571856568, 218, 5, 'PPL', 'P'),
(116883, 'Mondamin', 41.7105598449707, 0.727986602144874, -96.0213928222656, -1.67588945709939, 218, 16, 'PPL', 'P'),
(49542, 'Mondawmin', 39.3175010681152, 0.686219847294998, -76.6597213745117, -1.3379645416467, 218, 25, 'PPL', 'P'),
(56324, 'Monday', 38.2166709899902, 0.66700673792673, -91.021110534668, -1.58861806765165, 218, 29, 'PPL', 'P'),
(73503, 'Monday', 39.4922218322754, 0.689269299901193, -82.2108306884766, -1.43484967631351, 218, 41, 'PPL', 'P'),
(73505, 'Monday Creek Junction', 39.5819396972656, 0.690835172043133, -82.2752838134766, -1.43597459555796, 218, 41, 'PPL', 'P'),
(189051, 'Mondel', 32.2616691589355, 0.563072349012535, -108.913887023926, -1.90090592971263, 218, 38, 'PPL', 'P'),
(49543, 'Mondell', 39.4941711425781, 0.689303321784119, -77.7622222900391, -1.35720681262891, 218, 25, 'PPL', 'P'),
(175363, 'Mondovi', 44.5677795410156, 0.77785449329369, -91.6708297729492, -1.59995780757321, 218, 57, 'PPL', 'P'),
(208162, 'Mondovi', 47.6813888549805, 0.832197227443138, -118.015281677246, -2.05975523293648, 218, 56, 'PPL', 'P'),
(120668, 'Monee', 41.4199981689453, 0.722915344218118, -87.7416687011719, -1.53138101002951, 218, 18, 'PPL', 'P'),
(116884, 'Moneek', 43.1602783203125, 0.753288962766581, -91.6241683959961, -1.59914341291186, 218, 16, 'PPL', 'P'),
(56325, 'Monegaw Springs', 38.0291709899902, 0.663734245579241, -93.8388900756836, -1.63779759823771, 218, 29, 'PPL', 'P'),
(104331, 'Moneiro', 37.3005599975586, 0.651017584795086, -80.0627822875977, -1.39735915922598, 218, 53, 'PPL', 'P'),
(209614, 'Monell', 41.5905609130859, 0.725892225684609, -108.483329772949, -1.89339128806476, 218, 59, 'PPL', 'P'),
(189052, 'Monero', 36.9019393920898, 0.644060342763363, -106.854721069336, -1.86496670396007, 218, 38, 'PPL', 'P'),
(164701, 'Monessen', 40.1483306884766, 0.700720559693398, -79.8880615234375, -1.39430970661978, 218, 45, 'PPL', 'P'),
(17163, 'Monet', 26.8377799987793, 0.468407624904578, -80.0944366455078, -1.39791163199411, 218, 12, 'PPL', 'P'),
(104332, 'Moneta', 37.1811103820801, 0.648932795714744, -79.6175003051758, -1.38958752253291, 218, 53, 'PPL', 'P'),
(116885, 'Moneta', 43.1291694641113, 0.752746010799341, -95.3902816772461, -1.66487448967276, 218, 16, 'PPL', 'P'),
(209615, 'Moneta', 43.1616706848145, 0.753313264111528, -107.724166870117, -1.88014139585134, 218, 59, 'PPL', 'P'),
(33318, 'Monett', 37.1444396972656, 0.648292771525771, -96.1055603027344, -1.67735845675667, 218, 20, 'PPL', 'P'),
(56327, 'Monett', 36.9288902282715, 0.644530723590898, -93.9274978637695, -1.63934409588272, 218, 29, 'PPL', 'P'),
(82445, 'Monetta', 33.8499984741211, 0.59079392516847, -81.6097183227539, -1.4243582863572, 218, 48, 'PPL', 'P'),
(10554, 'Monette', 35.8905601501465, 0.626408445005127, -90.3441696166992, -1.57680321979162, 218, 4, 'PPL', 'P'),
(116886, 'Monette', 41.0847206115723, 0.717063646933914, -94.0719375610352, -1.64186504417059, 218, 16, 'PPL', 'P'),
(60926, 'Money', 33.6511116027832, 0.587322694424633, -90.2091674804688, -1.57444698801718, 218, 30, 'PPL', 'P'),
(104333, 'Money', 37.4005584716797, 0.652762887415469, -76.521110534668, -1.33554532611247, 218, 53, 'PPL', 'P'),
(136936, 'Money Creek', 43.8213882446289, 0.764827507663513, -91.6133270263672, -1.59895419531641, 218, 28, 'PPL', 'P'),
(66904, 'Money Island Beach', 34.6969413757324, 0.605575867377982, -76.7213897705078, -1.33904085820126, 218, 33, 'PPL', 'P'),
(104334, 'Moneys Corner', 38.9244384765625, 0.679359610905981, -77.3724975585938, -1.35040483288874, 218, 53, 'PPL', 'P'),
(37241, 'Monford', 37.267219543457, 0.650435684096903, -86.6413879394531, -1.51217748804116, 218, 21, 'PPL', 'P'),
(197081, 'Monforton (historical)', 45.6752815246582, 0.797184049380621, -111.169998168945, -1.94028249748416, 218, 31, 'PPL', 'P'),
(150809, 'Mongaup', 41.4247207641602, 0.722997769053856, -74.7624969482422, -1.30485172875904, 218, 40, 'PPL', 'P'),
(150810, 'Mongaup Valley', 41.6686096191406, 0.727254432582184, -74.7850036621094, -1.30524454501983, 218, 40, 'PPL', 'P'),
(104335, 'Mongle Spring', 36.7849998474121, 0.642019362682953, -82.0458297729492, -1.43196986706876, 218, 53, 'PPL', 'P'),
(123217, 'Mongo', 41.6847190856934, 0.727535595814269, -85.2797164916992, -1.48841183794746, 218, 19, 'PPL', 'P'),
(164703, 'Mongtown', 41.2444381713867, 0.719851244225928, -79.5386123657227, -1.38821066824934, 218, 45, 'PPL', 'P'),
(164704, 'Mongul', 40.0783309936523, 0.699498834543324, -77.5922164916992, -1.35423965170039, 218, 45, 'PPL', 'P'),
(42134, 'Monhegan', 30.5405597686768, 0.533033323365527, -91.0908279418945, -1.58983486595371, 218, 22, 'PPL', 'P'),
(128159, 'Monhegan', 43.7622184753418, 0.763794800371807, -69.3208312988281, -1.20987674638409, 218, 26, 'PPL', 'P'),
(23146, 'Moniac', 30.5180606842041, 0.532640640262795, -82.2252807617188, -1.43510187766874, 218, 13, 'PPL', 'P'),
(10555, 'Monica', 34.9961090087891, 0.610797327590218, -90.7861099243164, -1.58451653325682, 218, 4, 'PPL', 'P'),
(37240, 'Monica', 37.584171295166, 0.655967535734189, -83.6016693115234, -1.45912438964958, 218, 21, 'PPL', 'P'),
(96276, 'Monica', 25.9638900756836, 0.453155368446558, -97.2458267211914, -1.69725986010867, 218, 51, 'PPL', 'P'),
(120671, 'Monica', 40.9236106872559, 0.714251748296954, -89.8230590820313, -1.56770812519484, 218, 18, 'PPL', 'P'),
(10556, 'Monica (historical)', 34.2986106872559, 0.59862368535233, -91.3819427490234, -1.59491577783942, 218, 4, 'PPL', 'P'),
(189053, 'Monica (historical)', 33.957218170166, 0.592665261887441, -107.494720458984, -1.87613680052019, 218, 38, 'PPL', 'P'),
(96277, 'Monica Acres Colonia', 26.2660007476807, 0.45842819437832, -98.3150024414063, -1.7159204967088, 218, 51, 'PPL', 'P'),
(175366, 'Monico', 45.5763893127441, 0.795458054678141, -89.1549987792969, -1.55604827331026, 218, 57, 'PPL', 'P'),
(197082, 'Monida', 44.561939239502, 0.777752560802967, -112.312782287598, -1.96022784299415, 218, 31, 'PPL', 'P'),
(49544, 'Monie', 38.186939239502, 0.666487820988329, -75.8208312988281, -1.32332314776372, 218, 25, 'PPL', 'P'),
(164706, 'Moninger', 40.2416687011719, 0.702349615332199, -80.2127838134766, -1.39997717973558, 218, 45, 'PPL', 'P'),
(116887, 'Moningers', 42.1091690063477, 0.734943644439516, -93.0341720581055, -1.62375261928085, 218, 16, 'PPL', 'P'),
(192943, 'Monista (historical)', 32.8347206115723, 0.573073983644382, -106.073608398438, -1.85133371602384, 218, 38, 'PPL', 'P'),
(164707, 'Moniteau', 41.063060760498, 0.716685611217178, -79.8997192382813, -1.39451317212706, 218, 45, 'PPL', 'P'),
(37242, 'Monitor', 38.6547203063965, 0.67465214078413, -85.2663879394531, -1.48817921082624, 218, 21, 'PPL', 'P'),
(104336, 'Monitor', 37.6172218322754, 0.6565443764263, -79.083610534668, -1.38026938819483, 218, 53, 'PPL', 'P'),
(110499, 'Monitor', 37.6558303833008, 0.657218222761117, -80.4905624389648, -1.40482533134201, 218, 58, 'PPL', 'P'),
(123218, 'Monitor', 40.4197196960449, 0.705457191429186, -86.7563934326172, -1.51418471255476, 218, 19, 'PPL', 'P'),
(201252, 'Monitor', 45.1016693115234, 0.787172627631768, -122.746940612793, -2.14233826044318, 218, 43, 'PPL', 'P'),
(208163, 'Monitor', 47.4869384765625, 0.828803428107996, -120.416938781738, -2.10167205691378, 218, 56, 'PPL', 'P'),
(17164, 'Monkey Box', 26.9327793121338, 0.470065675709748, -81.0561065673828, -1.41469593844823, 218, 12, 'PPL', 'P'),
(10557, 'Monkey Run', 36.3452796936035, 0.634344798211617, -92.4797210693359, -1.61407562398588, 218, 4, 'PPL', 'P'),
(56332, 'Monkey Run', 39.6722183227539, 0.692410831302078, -91.3011093139648, -1.59350496825195, 218, 29, 'PPL', 'P'),
(37243, 'Monkeys Eyebrow', 37.1866683959961, 0.64902980135745, -88.9877777099609, -1.55312971507164, 218, 21, 'PPL', 'P'),
(209895, 'Monkland', 45.4858283996582, 0.793877468571179, -120.625556945801, -2.10531313075614, 218, 43, 'PPL', 'P'),
(145781, 'Monks', 41.1227798461914, 0.717727905888807, -74.3000030517578, -1.29677968749501, 218, 37, 'PPL', 'P'),
(23147, 'Monks Crossing', 30.898609161377, 0.539282464152912, -83.1030578613281, -1.45042197815553, 218, 13, 'PPL', 'P'),
(66921, 'Monks Crossroads', 35.2066688537598, 0.614472290157446, -78.3369369506836, -1.36723747571664, 218, 33, 'PPL', 'P'),
(42135, 'Monks Hammock', 31.2600002288818, 0.545589928168169, -93.4783325195313, -1.63150468173991, 218, 22, 'PPL', 'P'),
(49546, 'Monks Misery', 39.4049987792969, 0.687746970443077, -77.01611328125, -1.34418475384675, 218, 25, 'PPL', 'P'),
(96280, 'Monkstown', 33.790828704834, 0.589761217876764, -95.9280624389648, -1.67426053461864, 218, 51, 'PPL', 'P'),
(49547, 'Monkton', 39.5786094665527, 0.690777048552342, -76.6158294677734, -1.33719848335914, 218, 25, 'PPL', 'P'),
(172261, 'Monkton Boro', 44.2374992370605, 0.772090014535186, -73.1444396972656, -1.27661130224373, 218, 55, 'PPL', 'P'),
(49548, 'Monkton Farms', 39.5569381713867, 0.690398813098523, -76.6083297729492, -1.33706758899156, 218, 25, 'PPL', 'P'),
(172262, 'Monkton Ridge', 44.2544403076172, 0.772385691995212, -73.1247177124023, -1.27626708867284, 218, 55, 'PPL', 'P'),
(4270, 'Monmouth', 33.7355613708496, 0.588796620929937, -86.7477798461914, -1.51403437711122, 218, 2, 'PPL', 'P'),
(33319, 'Monmouth', 37.3630599975586, 0.652108415577582, -94.9366683959961, -1.65695744438418, 218, 20, 'PPL', 'P'),
(116888, 'Monmouth', 42.0769386291504, 0.734381118238264, -90.8797225952148, -1.58615038258558, 218, 16, 'PPL', 'P'),
(120672, 'Monmouth', 40.9113883972168, 0.714038429093639, -90.647216796875, -1.58209239087458, 218, 18, 'PPL', 'P'),
(123219, 'Monmouth', 40.8677787780762, 0.713277297654094, -84.9444427490234, -1.48256020724228, 218, 19, 'PPL', 'P'),
(128161, 'Monmouth', 44.2386093139648, 0.772109389032116, -70.0361099243164, -1.222360713468, 218, 26, 'PPL', 'P'),
(183382, 'Monmouth', 36.5661087036133, 0.638198991520207, -119.739166259766, -2.08984269482581, 218, 6, 'PPL', 'P'),
(201253, 'Monmouth', 44.8486099243164, 0.782755908121926, -123.232780456543, -2.150817765354, 218, 43, 'PPL', 'P'),
(145782, 'Monmouth Beach', 40.3302803039551, 0.703896179556236, -73.9819412231445, -1.29122846136079, 218, 37, 'PPL', 'P'),
(145785, 'Monmouth Heights at Manalapan', 40.3008308410645, 0.70338218946585, -74.2938919067383, -1.29667302789335, 218, 37, 'PPL', 'P'),
(145786, 'Monmouth Heights at Marlboro', 40.3277816772461, 0.703852570293386, -74.2436065673828, -1.29579538315612, 218, 37, 'PPL', 'P'),
(145787, 'Monmouth Hills', 40.4030609130859, 0.705166440817176, -74.0022201538086, -1.29158239546966, 218, 37, 'PPL', 'P'),
(145788, 'Monmouth Junction', 40.3788909912109, 0.704744596100508, -74.5469436645508, -1.30108961424514, 218, 37, 'PPL', 'P'),
(156555, 'Monnett', 40.7174987792969, 0.710654416875502, -83.0400009155273, -1.44932142683506, 218, 41, 'PPL', 'P'),
(10559, 'Monnie Springs', 34.9194412231445, 0.609459222300508, -92.4858322143555, -1.61418228358754, 218, 4, 'PPL', 'P'),
(183383, 'Mono City', 38.040828704834, 0.663937711086523, -119.143608093262, -2.07944824393318, 218, 6, 'PPL', 'P'),
(183391, 'Mono Hot Springs', 37.3266716003418, 0.651473318236625, -119.016670227051, -2.07723276022234, 218, 6, 'PPL', 'P'),
(183385, 'Mono Mills', 37.8875007629395, 0.661261633665157, -118.95832824707, -2.07621450057955, 218, 6, 'PPL', 'P'),
(183386, 'Mono Village', 37.9738883972168, 0.662769382316305, -120.323333740234, -2.10003834074307, 218, 6, 'PPL', 'P'),
(183387, 'Mono Village (historical)', 38.1497192382813, 0.665838209419431, -119.376106262207, -2.08350610248613, 218, 6, 'PPL', 'P'),
(183388, 'Mono Vista', 37.9977798461914, 0.663186366763985, -120.268890380859, -2.09908812486613, 218, 6, 'PPL', 'P'),
(164708, 'Monocacy', 40.2583312988281, 0.702640432523236, -75.7816696166992, -1.32263964746995, 218, 45, 'PPL', 'P'),
(49549, 'Monocacy (historical)', 39.211109161377, 0.68436295822494, -77.4652786254883, -1.35202416798956, 218, 25, 'PPL', 'P'),
(49550, 'Monocacy Meadows', 39.5255584716797, 0.689851134020348, -77.3552780151367, -1.35010429515972, 218, 25, 'PPL', 'P'),
(49551, 'Monocacy Overlook', 39.3055610656738, 0.6860114549397, -77.4194412231445, -1.3512241543981, 218, 25, 'PPL', 'P'),
(66906, 'Monogram', 33.9391708374023, 0.592350276509512, -78.3550033569336, -1.3675527939897, 218, 33, 'PPL', 'P'),
(210725, 'Monohaa', 19.5522193908691, 0.341250604442947, -155.858337402344, -2.72024115435512, 218, 15, 'PPL', 'P'),
(183389, 'Monola', 37.1436080932617, 0.64827825729783, -118.242782592773, -2.06372587296373, 218, 6, 'PPL', 'P'),
(183390, 'Monolith', 35.1199989318848, 0.612959614658281, -118.373329162598, -2.06600434043435, 218, 6, 'PPL', 'P'),
(125452, 'Monomoscoy Island', 41.5697212219238, 0.725528504458731, -70.5055618286133, -1.23055419487774, 218, 23, 'PPL', 'P'),
(125453, 'Monomoy', 41.2777786254883, 0.72043314492411, -70.081672668457, -1.2231559333695, 218, 23, 'PPL', 'P'),
(123220, 'Monon', 40.8677787780762, 0.713277297654094, -86.8788909912109, -1.51632269827787, 218, 19, 'PPL', 'P'),
(116890, 'Monona', 43.0516700744629, 0.75139339128169, -91.3891677856445, -1.59504187851703, 218, 16, 'PPL', 'P'),
(175368, 'Monona', 43.0622215270996, 0.751577548871069, -89.3338928222656, -1.55917056337226, 218, 57, 'PPL', 'P'),
(156556, 'Mononcue', 40.827220916748, 0.712569429436351, -83.2686080932617, -1.45331137478021, 218, 41, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(110496, 'Monongah', 39.4625015258789, 0.688750582699873, -80.2183303833008, -1.4000739856412, 218, 58, 'PPL', 'P'),
(164709, 'Monongahela', 40.2030601501465, 0.701675768997382, -79.9263916015625, -1.39497869268561, 218, 45, 'PPL', 'P'),
(132141, 'Monongahela Location', 46.0869407653809, 0.804368858527492, -88.3713912963867, -1.54237174269021, 218, 27, 'PPL', 'P'),
(123222, 'Monoquet', 41.2894401550293, 0.720636677010419, -85.8616714477539, -1.49856886802891, 218, 19, 'PPL', 'P'),
(89098, 'Monoville', 36.3069381713867, 0.633675612408708, -85.9736099243164, -1.50052256300459, 218, 50, 'PPL', 'P'),
(142442, 'Monowi', 42.8286094665527, 0.747500249242157, -98.3294372558594, -1.71617243174792, 218, 35, 'PPL', 'P'),
(125454, 'Monponsett', 42.0183296203613, 0.733358198063564, -70.8472213745117, -1.23651727887453, 218, 23, 'PPL', 'P'),
(10560, 'Monroe', 34.7347183227539, 0.606235199484858, -91.1044387817383, -1.59007241992294, 218, 4, 'PPL', 'P'),
(23148, 'Monroe', 33.7947196960449, 0.589829128484561, -83.7133331298828, -1.46107329093531, 218, 13, 'PPL', 'P'),
(37244, 'Monroe', 37.2322196960449, 0.649824821521866, -85.6977767944336, -1.49570836670206, 218, 21, 'PPL', 'P'),
(42137, 'Monroe', 32.814998626709, 0.572729770073489, -92.2055587768555, -1.60929058929728, 218, 22, 'PPL', 'P'),
(60928, 'Monroe', 31.4713897705078, 0.549279371673824, -90.8266677856445, -1.58522440147456, 218, 30, 'PPL', 'P'),
(66907, 'Monroe', 34.985279083252, 0.61060830973185, -80.5497207641602, -1.40585783889664, 218, 33, 'PPL', 'P'),
(73508, 'Monroe', 38.8563919067383, 0.67817197421786, -82.6291732788086, -1.44215113191613, 218, 41, 'PPL', 'P'),
(76621, 'Monroe', 34.9925003051758, 0.610734343830438, -94.5166702270508, -1.64962709348373, 218, 42, 'PPL', 'P'),
(89099, 'Monroe', 36.436939239502, 0.635944559078428, -85.2425003051758, -1.48776229295759, 218, 50, 'PPL', 'P'),
(96278, 'Monroe', 32.3352813720703, 0.564357124501417, -94.7375030517578, -1.65348135337135, 218, 51, 'PPL', 'P'),
(104337, 'Monroe', 37.5019416809082, 0.654532358222745, -79.128059387207, -1.38104516702037, 218, 53, 'PPL', 'P'),
(113736, 'Monroe', 41.3325004577637, 0.72138822107004, -73.2077789306641, -1.27771678041222, 218, 8, 'PPL', 'P'),
(116893, 'Monroe', 41.5222206115723, 0.72469946241139, -93.1016693115234, -1.62493066858905, 218, 16, 'PPL', 'P'),
(123224, 'Monroe', 40.2863883972168, 0.703130121268674, -86.7352828979492, -1.51381626421794, 218, 19, 'PPL', 'P'),
(128163, 'Monroe', 44.6150016784668, 0.778678675072042, -69.0186080932617, -1.20460195637102, 218, 26, 'PPL', 'P'),
(132142, 'Monroe', 41.916389465332, 0.731579006718309, -83.3977813720703, -1.45556587380102, 218, 27, 'PPL', 'P'),
(142443, 'Monroe', 41.4741706848145, 0.723860832984124, -97.5991668701172, -1.70342680908691, 218, 35, 'PPL', 'P'),
(144163, 'Monroe', 44.2602806091309, 0.772487624485935, -72.0552825927734, -1.25760192469885, 218, 36, 'PPL', 'P'),
(145790, 'Monroe', 41.1144409179688, 0.717582364135235, -74.6344375610352, -1.30261667081419, 218, 37, 'PPL', 'P'),
(150811, 'Monroe', 41.3305587768555, 0.721354332345168, -74.1872177124023, -1.29481121197528, 218, 40, 'PPL', 'P'),
(164713, 'Monroe', 41.1941719055176, 0.718973932383828, -79.5908279418945, -1.38912200197436, 218, 45, 'PPL', 'P'),
(170905, 'Monroe', 43.4863891601563, 0.758980670648298, -97.2147216796875, -1.69671697472046, 218, 49, 'PPL', 'P'),
(175370, 'Monroe', 42.6011085510254, 0.743529609214904, -89.6383285522461, -1.56448396922114, 218, 57, 'PPL', 'P'),
(183392, 'Monroe', 38.4527816772461, 0.671127646818492, -122.750282287598, -2.14239658367106, 218, 6, 'PPL', 'P'),
(192707, 'Monroe', 38.6300010681152, 0.674220708687537, -112.120002746582, -1.95686320527294, 218, 52, 'PPL', 'P'),
(201254, 'Monroe', 44.3141708374023, 0.773428186403924, -123.295562744141, -2.15191352298451, 218, 43, 'PPL', 'P'),
(208164, 'Monroe', 47.8555603027344, 0.835237092669409, -121.969718933105, -2.12877318311476, 218, 56, 'PPL', 'P'),
(125455, 'Monroe Bridge', 42.7222213745117, 0.745643426751127, -72.9416732788086, -1.27307236062918, 218, 23, 'PPL', 'P'),
(120674, 'Monroe Center', 42.098331451416, 0.734754493423093, -89.0005569458008, -1.55335275481293, 218, 18, 'PPL', 'P'),
(128169, 'Monroe Center', 44.5999984741211, 0.77841681975786, -69.0391693115234, -1.20496081732791, 218, 26, 'PPL', 'P'),
(132143, 'Monroe Center', 44.6136093139648, 0.778654373727095, -85.6966705322266, -1.49568905878415, 218, 27, 'PPL', 'P'),
(156557, 'Monroe Center', 41.8444404602051, 0.73032325968531, -80.5716705322266, -1.40624093461945, 218, 41, 'PPL', 'P'),
(175371, 'Monroe Center', 44.1119384765625, 0.769898565853187, -89.9394378662109, -1.56973931815824, 218, 57, 'PPL', 'P'),
(27930, 'Monroe City', 38.2558288574219, 0.667690171641472, -90.2658309936523, -1.57543595288798, 218, 18, 'PPL', 'P'),
(30537, 'Monroe City', 38.6152801513672, 0.673963780221372, -87.3544387817383, -1.52462257297316, 218, 19, 'PPL', 'P'),
(56333, 'Monroe City', 39.6536102294922, 0.692086058807143, -91.7344436645508, -1.60106807943166, 218, 29, 'PPL', 'P'),
(96279, 'Monroe City', 29.7847194671631, 0.519841421484847, -94.5849990844727, -1.65081965701987, 218, 51, 'PPL', 'P'),
(104338, 'Monroe Corner', 38.1552810668945, 0.665935281641164, -77.2655563354492, -1.34853835643875, 218, 53, 'PPL', 'P'),
(82456, 'Monroe Crossroads', 34.5449981689453, 0.602923958143508, -79.6552810668945, -1.39024692121881, 218, 48, 'PPL', 'P'),
(164715, 'Monroe Furnace', 40.6969413757324, 0.710295622497641, -77.8930587768555, -1.3594903401056, 218, 45, 'PPL', 'P'),
(49552, 'Monroe Gardens', 39.1533317565918, 0.683354552278182, -76.6263885498047, -1.33738277410657, 218, 25, 'PPL', 'P'),
(104344, 'Monroe Gardens', 37.0455589294434, 0.646566976560372, -76.3450012207031, -1.33247163874036, 218, 53, 'PPL', 'P'),
(104339, 'Monroe Hall', 38.2397193908691, 0.667409008409387, -76.9925003051758, -1.34377262966806, 218, 53, 'PPL', 'P'),
(164716, 'Monroe Heights', 40.4169387817383, 0.705408655318319, -79.7525024414063, -1.39194375430736, 218, 45, 'PPL', 'P'),
(208165, 'Monroe Junction', 47.8563919067383, 0.83525160689735, -121.961112976074, -2.12862298082928, 218, 56, 'PPL', 'P'),
(164717, 'Monroe Lake', 41.1147193908691, 0.717587224404224, -75.14111328125, -1.31145983037185, 218, 45, 'PPL', 'P'),
(123225, 'Monroe Manor', 41.6011085510254, 0.726076316694961, -86.6883316040039, -1.51299680955053, 218, 19, 'PPL', 'P'),
(156558, 'Monroe Mills', 40.4080581665039, 0.705253659342876, -82.3691711425781, -1.43761323857669, 218, 41, 'PPL', 'P'),
(14258, 'Monroe Park', 39.7722206115723, 0.694156200501489, -75.5963897705078, -1.31940590411632, 218, 10, 'PPL', 'P'),
(73517, 'Monroefield', 39.8205604553223, 0.694999889934826, -81.2024993896484, -1.41725097519805, 218, 41, 'PPL', 'P'),
(125457, 'Monroes', 41.7755584716797, 0.729121042190221, -71.3166732788086, -1.24471076028427, 218, 23, 'PPL', 'P'),
(17166, 'Monroes Corner', 29.0252799987793, 0.506586702291954, -82.120002746582, -1.43326442967464, 218, 12, 'PPL', 'P'),
(4272, 'Monroeton', 31.5380592346191, 0.550442973333107, -87.2780609130859, -1.52328952768952, 218, 2, 'PPL', 'P'),
(66910, 'Monroeton', 36.2894401550293, 0.633370214410703, -79.7350006103516, -1.39163828973032, 218, 33, 'PPL', 'P'),
(164725, 'Monroeton', 41.7125015258789, 0.728020490869746, -76.4749984741211, -1.33474051883105, 218, 45, 'PPL', 'P'),
(66911, 'Monroetown', 35.2186088562012, 0.614680682512745, -79.4452819824219, -1.38658174576859, 218, 33, 'PPL', 'P'),
(4273, 'Monroeville', 31.5277805328369, 0.550263576144176, -87.3247222900391, -1.52410392235086, 218, 2, 'PPL', 'P'),
(71128, 'Monroeville', 39.6288909912109, 0.69165462671055, -75.1597213745117, -1.31178460286679, 218, 37, 'PPL', 'P'),
(123236, 'Monroeville', 40.9747200012207, 0.715143774104076, -84.8683319091797, -1.48123182249055, 218, 19, 'PPL', 'P'),
(156575, 'Monroeville', 40.5977783203125, 0.708564900684226, -80.8377838134766, -1.41088548756054, 218, 41, 'PPL', 'P'),
(164726, 'Monroeville', 40.4211082458496, 0.705481426195105, -79.788330078125, -1.39256906453131, 218, 45, 'PPL', 'P'),
(4274, 'Monrovia', 34.7863883972168, 0.607137012408986, -86.7138900756836, -1.51344288903311, 218, 2, 'PPL', 'P'),
(30545, 'Monrovia', 39.5788917541504, 0.690781975400358, -86.4822235107422, -1.5093995447081, 218, 19, 'PPL', 'P'),
(33322, 'Monrovia', 39.524169921875, 0.689826899254429, -95.345832824707, -1.66409871084722, 218, 20, 'PPL', 'P'),
(49554, 'Monrovia', 39.371940612793, 0.687169996592911, -77.272216796875, -1.34865460342034, 218, 25, 'PPL', 'P'),
(104343, 'Monrovia', 38.1549987792969, 0.665930354793148, -77.9991683959961, -1.36134230232764, 218, 53, 'PPL', 'P'),
(183393, 'Monrovia', 34.1480598449707, 0.595996077462803, -117.998062133789, -2.05945469520747, 218, 6, 'PPL', 'P'),
(183394, 'Mons', 33.9205589294434, 0.59202543743555, -116.746391296387, -2.0376089179436, 218, 6, 'PPL', 'P'),
(183395, 'Monsanto', 38.0261116027832, 0.663680849199385, -122.054443359375, -2.13025190331002, 218, 6, 'PPL', 'P'),
(128166, 'Monsapec', 44.6088905334473, 0.778572015470384, -67.6016693115234, -1.17987170933049, 218, 26, 'PPL', 'P'),
(208166, 'Monse', 48.1413917541504, 0.840225792602373, -119.676666259766, -2.08875186404332, 218, 56, 'PPL', 'P'),
(42138, 'Monsecour', 29.6700000762939, 0.517839190398298, -89.9538879394531, -1.56999151951347, 218, 22, 'PPL', 'P'),
(150814, 'Monsey', 41.1111106872559, 0.717524240644444, -74.0688934326172, -1.29274606370797, 218, 40, 'PPL', 'P'),
(110500, 'Monson', 37.2649993896484, 0.650396935103043, -81.4830627441406, -1.42214772949438, 218, 58, 'PPL', 'P'),
(125458, 'Monson', 42.1041717529297, 0.734856425913816, -72.3194427490234, -1.262212389178, 218, 23, 'PPL', 'P'),
(128167, 'Monson', 45.2869415283203, 0.790406237827342, -69.5016708374023, -1.21303299175, 218, 26, 'PPL', 'P'),
(183397, 'Monson', 36.4922218322754, 0.636909422341364, -119.335563659668, -2.0827985005845, 218, 6, 'PPL', 'P'),
(187072, 'Monson', 37.5161094665527, 0.654779632729959, -104.70361328125, -1.82742279049268, 218, 7, 'PPL', 'P'),
(128168, 'Monson Junction', 45.2152786254883, 0.789155484221387, -69.4719390869141, -1.21251407481159, 218, 26, 'PPL', 'P'),
(96281, 'Mont', 29.3819103240967, 0.512811075681201, -97.0051193237305, -1.69305872348907, 218, 51, 'PPL', 'P'),
(78761, 'Mont Alto', 39.8441696166992, 0.695411947534488, -77.5586090087891, -1.3536530904703, 218, 45, 'PPL', 'P'),
(96282, 'Mont Belvieu', 29.8474998474121, 0.520937145825846, -94.8905563354492, -1.65615263710275, 218, 51, 'PPL', 'P'),
(82446, 'Mont Clare', 34.396671295166, 0.600335165826869, -79.8213882446289, -1.39314603838147, 218, 48, 'PPL', 'P'),
(164736, 'Mont Clare', 40.1388893127441, 0.700555776600949, -75.5027770996094, -1.31777205478756, 218, 45, 'PPL', 'P'),
(60929, 'Mont Helena', 32.9455604553223, 0.575008503860216, -90.8638916015625, -1.58587407962249, 218, 30, 'PPL', 'P'),
(33323, 'Mont Ida', 38.2166709899902, 0.66700673792673, -95.3680572509766, -1.66448660025999, 218, 20, 'PPL', 'P'),
(27933, 'Mont Station', 38.767219543457, 0.676615622876818, -89.9302825927734, -1.56957952849284, 218, 18, 'PPL', 'P'),
(144165, 'Mont Vernon', 42.8944396972656, 0.748649203515445, -71.6747207641602, -1.25095986778214, 218, 36, 'PPL', 'P'),
(183398, 'Monta Vista', 37.3227806091309, 0.651405407628828, -122.056938171387, -2.13029544599385, 218, 6, 'PPL', 'P'),
(208167, 'Monta Vista', 47.1811103820801, 0.823465720914177, -122.482498168945, -2.13772286911602, 218, 56, 'PPL', 'P'),
(23150, 'Montage Manor', 33.6861114501953, 0.58793355699967, -84.7822189331055, -1.47972886752936, 218, 13, 'PPL', 'P'),
(4275, 'Montague', 34.9694404602051, 0.6103318736107, -85.8005599975586, -1.49750227201234, 218, 2, 'PPL', 'P'),
(17167, 'Montague', 29.1502799987793, 0.508768363856947, -82.0749969482422, -1.43247893031112, 218, 12, 'PPL', 'P'),
(56340, 'Montague', 36.9280586242676, 0.644516209362957, -93.3277816772461, -1.62887707385038, 218, 29, 'PPL', 'P'),
(66912, 'Montague', 34.4336090087891, 0.60097985054775, -78.0663909912109, -1.36251555794587, 218, 33, 'PPL', 'P'),
(82448, 'Montague', 34.8727798461914, 0.608644827639162, -82.5972213745117, -1.44159346598387, 218, 48, 'PPL', 'P'),
(89102, 'Montague', 35.4566688537598, 0.618835613287432, -85.0977783203125, -1.4852364178217, 218, 50, 'PPL', 'P'),
(96283, 'Montague', 33.6647186279297, 0.587560181814841, -97.7202835083008, -1.70554069320216, 218, 51, 'PPL', 'P'),
(104346, 'Montague', 38.2444381713867, 0.667491366666098, -77.1877822875977, -1.34718094323114, 218, 53, 'PPL', 'P'),
(125474, 'Montague', 42.5355606079102, 0.742385581789633, -72.5355606079102, -1.26598435738793, 218, 23, 'PPL', 'P'),
(132148, 'Montague', 43.4166717529297, 0.757763872346241, -86.3569412231445, -1.50721295629509, 218, 27, 'PPL', 'P'),
(145792, 'Montague', 41.3030586242676, 0.720874364137709, -74.7938919067383, -1.30539967415332, 218, 37, 'PPL', 'P'),
(193797, 'Montague', 41.728328704834, 0.728296727253814, -122.526672363281, -2.1384938542516, 218, 6, 'PPL', 'P'),
(197083, 'Montague', 47.6791687011719, 0.832158478449278, -110.453330993652, -1.92777429563433, 218, 31, 'PPL', 'P'),
(201255, 'Montague (historical)', 45.6263885498047, 0.796330705988333, -120.093063354492, -2.09601936434203, 218, 43, 'PPL', 'P'),
(125460, 'Montague City', 42.586669921875, 0.743277607596755, -72.5749969482422, -1.26667265137166, 218, 23, 'PPL', 'P'),
(56341, 'Montague Hill', 39.1283302307129, 0.682918193333572, -93.1522216796875, -1.62581297385819, 218, 29, 'PPL', 'P'),
(125461, 'Montague Station', 42.5438919067383, 0.742530990385151, -72.5355606079102, -1.26598435738793, 218, 23, 'PPL', 'P'),
(96285, 'Montague Village', 31.1162490844727, 0.543080997394719, -97.8326187133789, -1.70750131239668, 218, 51, 'PPL', 'P'),
(49555, 'Montaine', 38.5208282470703, 0.672315283506613, -77.146110534668, -1.34645363393744, 218, 25, 'PPL', 'P'),
(96286, 'Montalba', 31.8763904571533, 0.556347967128626, -95.7324981689453, -1.67084729420754, 218, 51, 'PPL', 'P'),
(4276, 'Montalla Acres', 33.1322212219238, 0.57826634882171, -86.789436340332, -1.51476142008881, 218, 2, 'PPL', 'P'),
(183399, 'Montalvin Manor', 37.9955596923828, 0.663147617770124, -122.331672668457, -2.13509046753653, 218, 6, 'PPL', 'P'),
(183400, 'Montalvo', 34.2538909912109, 0.597843179415855, -119.202781677246, -2.08048101780391, 218, 6, 'PPL', 'P'),
(96287, 'Montalvo Hills Colonia', 26.3330001831055, 0.45959755512346, -98.7089996337891, -1.7227970449595, 218, 51, 'PPL', 'P'),
(42139, 'Montan Estates', 30.3500003814697, 0.529707434638182, -91.0236129760742, -1.58866174349353, 218, 22, 'PPL', 'P'),
(10565, 'Montana', 35.4249992370605, 0.618282874203186, -93.5447235107422, -1.6326634231302, 218, 4, 'PPL', 'P'),
(33324, 'Montana', 37.2752799987793, 0.650576365581487, -95.123893737793, -1.6602251430417, 218, 20, 'PPL', 'P'),
(110501, 'Montana', 39.5233306884766, 0.689812251868433, -80.1097183227539, -1.39817834757729, 218, 58, 'PPL', 'P'),
(145794, 'Montana', 40.7649993896484, 0.711483458922844, -75.0677795410156, -1.31017991515196, 218, 37, 'PPL', 'P'),
(175378, 'Montana', 44.3413887023926, 0.773903227763367, -91.6647186279297, -1.59985114797155, 218, 57, 'PPL', 'P'),
(197085, 'Montana', 47.0002784729004, 0.820309608706324, -109.750282287598, -1.91550378091179, 218, 31, 'ADM1', 'A'),
(212000, 'Montana', 62.079719543457, 1.083495504748, -150.072784423828, -2.61926420583146, 218, 1, 'PPL', 'P'),
(156576, 'Montana (historical)', 40.9755592346191, 0.715158421490072, -84.3358306884766, -1.47193792291839, 218, 41, 'PPL', 'P'),
(197084, 'Montana City', 46.5377807617188, 0.812237500863267, -111.931938171387, -1.95358085922942, 218, 31, 'PPL', 'P'),
(191894, 'Montana Land Estates Colonia', 31.8349990844727, 0.555625551393428, -106.144996643066, -1.85257967593984, 218, 51, 'PPL', 'P'),
(197086, 'Montanapolis Springs (historical)', 45.3122215270996, 0.790847457040941, -110.565826416016, -1.92973771114799, 218, 31, 'PPL', 'P'),
(164727, 'Montandon', 40.9652786254883, 0.714978991011628, -76.8511123657227, -1.34130494460199, 218, 45, 'PPL', 'P'),
(197087, 'Montaqua', 45.5091705322266, 0.794284865638934, -108.90055847168, -1.90067330259141, 218, 31, 'PPL', 'P'),
(178667, 'Montara', 33.5944404602051, 0.586333596395778, -112.191673278809, -1.95811409203695, 218, 5, 'PPL', 'P'),
(183401, 'Montara', 37.5422210693359, 0.655235366171498, -122.514999389648, -2.13829012242821, 218, 6, 'PPL', 'P'),
(150816, 'Montario Point', 43.6916694641113, 0.762563487841809, -76.2013931274414, -1.32996520468043, 218, 40, 'PPL', 'P'),
(56342, 'Montauk', 37.4477806091309, 0.653587069193821, -91.695556640625, -1.60038937282786, 218, 29, 'PPL', 'P'),
(150817, 'Montauk', 41.035831451416, 0.716210370120653, -71.9550018310547, -1.25585169523045, 218, 40, 'PPL', 'P'),
(150818, 'Montauk Beach', 41.0258293151855, 0.716035799911198, -71.9674987792969, -1.25606980812373, 218, 40, 'PPL', 'P'),
(150819, 'Montauk Station', 41.0491714477539, 0.716443196978953, -71.9541702270508, -1.25583718100251, 218, 40, 'PPL', 'P'),
(201256, 'Montavilla', 45.5191688537598, 0.794459369269361, -122.577781677246, -2.13938588005872, 218, 43, 'PPL', 'P'),
(187073, 'Montbello', 39.7936096191406, 0.694529509107291, -104.833061218262, -1.82968208320344, 218, 7, 'PPL', 'P'),
(208170, 'Montborne', 48.3813896179199, 0.844414545522904, -122.220558166504, -2.13315115363074, 218, 56, 'PPL', 'P'),
(17168, 'Montbrook', 29.326940536499, 0.5118516718985, -82.4505615234375, -1.43903376870214, 218, 12, 'PPL', 'P'),
(110502, 'Montcalm', 37.353889465332, 0.651948359596068, -81.2527770996094, -1.41812848677723, 218, 58, 'PPL', 'P'),
(144167, 'Montcalm', 43.5999984741211, 0.760963527237917, -72.1708297729492, -1.25961860343432, 218, 36, 'PPL', 'P'),
(14259, 'Montchan', 39.7763900756836, 0.694228971378275, -75.5924987792969, -1.31933799350852, 218, 10, 'PPL', 'P'),
(14260, 'Montchanin', 39.7897186279297, 0.694461598499494, -75.5894393920898, -1.31928459712867, 218, 10, 'PPL', 'P'),
(42140, 'Montcla', 31.2027797698975, 0.544591242759389, -92.1194381713867, -1.60778750117804, 218, 22, 'PPL', 'P'),
(17169, 'Montclair', 28.8216705322266, 0.50303304671238, -81.916389465332, -1.42971070751604, 218, 12, 'PPL', 'P'),
(23151, 'Montclair', 33.5088882446289, 0.584840428551598, -82.0688934326172, -1.43237240386752, 218, 13, 'PPL', 'P'),
(30547, 'Montclair', 39.8480606079102, 0.695479858142285, -86.5669403076172, -1.51087813174531, 218, 19, 'PPL', 'P'),
(37247, 'Montclair', 38.2200012207031, 0.667064861417522, -85.3288879394531, -1.48927004160874, 218, 21, 'PPL', 'P'),
(66913, 'Montclair', 34.7591705322266, 0.606661971049543, -77.3280563354492, -1.34962918722125, 218, 33, 'PPL', 'P'),
(104347, 'Montclair', 38.6108283996582, 0.673886082496569, -77.3399963378906, -1.34983757957655, 218, 53, 'PPL', 'P'),
(125463, 'Montclair', 42.2708282470703, 0.7377651304564, -71.0361099243164, -1.23981400598794, 218, 23, 'PPL', 'P'),
(145795, 'Montclair', 40.8258285522461, 0.712545128091404, -74.2094421386719, -1.29519910138805, 218, 37, 'PPL', 'P'),
(183402, 'Montclair', 34.0774993896484, 0.594764565195723, -117.688888549805, -2.05405859820675, 218, 6, 'PPL', 'P'),
(150820, 'Montclair Colony', 41.0508308410645, 0.716472158855808, -72.3497161865234, -1.26274076033827, 218, 40, 'PPL', 'P'),
(104348, 'Montclair Estates', 37.3161087036133, 0.651288960910165, -80.022216796875, -1.39665115785018, 218, 53, 'PPL', 'P'),
(145796, 'Montclair Heights', 40.8574981689453, 0.71309786717565, -74.2027816772461, -1.29508285440646, 218, 37, 'PPL', 'P'),
(178668, 'Montclair Terrace', 33.6305618286133, 0.586964033204827, -111.992500305176, -1.95463786786607, 218, 5, 'PPL', 'P'),
(14261, 'Montclare', 39.726390838623, 0.693356320068083, -75.6763916015625, -1.32080219947585, 218, 10, 'PPL', 'P'),
(49556, 'Montclare', 39.4552803039551, 0.688624548601285, -77.029167175293, -1.344412587278, 218, 25, 'PPL', 'P'),
(110503, 'Montcoal', 37.913890838623, 0.661722227375686, -81.5358276367188, -1.42306865059933, 218, 58, 'PPL', 'P'),
(89106, 'Montcrest', 35.8499984741211, 0.625700510208356, -84.5630569458008, -1.47590376925568, 218, 50, 'PPL', 'P'),
(164728, 'Montdale', 41.5338897705078, 0.724903127655753, -75.6100006103516, -1.31964345808556, 218, 45, 'PPL', 'P'),
(96288, 'Monte Alban Colonia', 26.2919998168945, 0.458881963738556, -98.2490005493164, -1.71476854637929, 218, 51, 'PPL', 'P'),
(96289, 'Monte Alto', 26.3727798461914, 0.460291841219644, -97.9713897705078, -1.70992332425005, 218, 51, 'PPL', 'P'),
(189054, 'Monte Aplanado', 35.9552803039551, 0.627538024781484, -105.394439697266, -1.8394799860119, 218, 38, 'PPL', 'P'),
(4278, 'Monte Bello', 33.1622200012207, 0.578789926292019, -86.8199996948242, -1.51529485125515, 218, 2, 'PPL', 'P'),
(33326, 'Monte Carlo (historical)', 37.2813911437988, 0.650683025183144, -94.8772201538086, -1.65591987682348, 218, 20, 'PPL', 'P'),
(204962, 'Monte Carlo Condominium', 40.6430587768555, 0.709355193737707, -111.842781066895, -1.95202477420449, 218, 52, 'PPL', 'P'),
(89107, 'Monte Carlo Estates', 35.2855606079102, 0.615849211020044, -84.8099975585938, -1.48021369600581, 218, 50, 'PPL', 'P'),
(30546, 'Monte Cassino Shrine', 38.1808280944824, 0.666381161386671, -86.8061065673828, -1.5150523704379, 218, 19, 'PPL', 'P'),
(96290, 'Monte Christo', 26.3822193145752, 0.460456591022579, -98.2966690063477, -1.71560051790383, 218, 51, 'PPL', 'P'),
(208168, 'Monte Cristo', 47.9858283996582, 0.837510699871037, -121.392776489258, -2.11870363787511, 218, 56, 'PPL', 'P'),
(183403, 'Monte Cristo (historical)', 39.5963897705078, 0.691087373398363, -120.856391906738, -2.10934196085321, 218, 6, 'PPL', 'P'),
(96291, 'Monte Cristo Acres Colonia', 26.3540000915527, 0.459964072668482, -98.2129974365234, -1.71414017352008, 218, 51, 'PPL', 'P'),
(204963, 'Monte Cristo Condo', 40.6366691589355, 0.70924367386706, -111.836669921875, -1.95191811460283, 218, 52, 'PPL', 'P'),
(96292, 'Monte Cristo Heights Colonia', 26.3880004882813, 0.460557491538379, -98.1490020751953, -1.71302324375891, 218, 51, 'PPL', 'P'),
(96293, 'Monte Cristo Hills Colonia', 26.3190002441406, 0.459353210093445, -98.0329971313477, -1.71099857554017, 218, 51, 'PPL', 'P'),
(96294, 'Monte Grande', 26.2683296203613, 0.458468840874457, -97.5188903808594, -1.70202572003742, 218, 51, 'PPL', 'P'),
(183405, 'Monte Grande Heights', 37.9769401550293, 0.662822645538107, -120.267501831055, -2.09906389010021, 218, 6, 'PPL', 'P'),
(10566, 'Monte Ne', 36.2872200012207, 0.633331465416842, -94.0688934326172, -1.64181191410684, 218, 4, 'PPL', 'P'),
(10567, 'Monte Ne Shores', 36.2841682434082, 0.633278202195041, -94.0761108398438, -1.6419378816264, 218, 4, 'PPL', 'P'),
(183406, 'Monte Nido', 34.0808296203613, 0.594822688686514, -118.686111450195, -2.07146342119485, 218, 6, 'PPL', 'P'),
(183407, 'Monte Rio', 38.4655609130859, 0.671350686559786, -123.007781982422, -2.14689080116862, 218, 6, 'PPL', 'P'),
(183408, 'Monte Rosa', 38.5038909912109, 0.672019672625614, -123.026107788086, -2.14721064681554, 218, 6, 'PPL', 'P'),
(183409, 'Monte Sereno', 37.2363891601563, 0.649897592398653, -121.991386413574, -2.12915135198955, 218, 6, 'PPL', 'P'),
(183410, 'Monte Toyon', 36.9963912963867, 0.645708839478122, -121.894996643066, -2.12746903312894, 218, 6, 'PPL', 'P'),
(4281, 'Monte Vista', 34.0363883972168, 0.594047043019029, -86.0044403076172, -1.50106065470284, 218, 2, 'PPL', 'P'),
(104349, 'Monte Vista', 37.3008308410645, 0.65102231190602, -80.0124969482422, -1.39648151448874, 218, 53, 'PPL', 'P'),
(183411, 'Monte Vista', 39.1866683959961, 0.683936386397337, -120.831672668457, -2.10891052875662, 218, 6, 'PPL', 'P'),
(187074, 'Monte Vista', 37.5791702270508, 0.655880250629461, -106.147499084473, -1.85262335178171, 218, 7, 'PPL', 'P'),
(89109, 'Monte Vista Estates', 36.1697196960449, 0.631280698219427, -83.2802810668945, -1.45351510660361, 218, 50, 'PPL', 'P'),
(187075, 'Monte Vista Estates', 39.3652801513672, 0.687053749611329, -104.920829772949, -1.83121393346246, 218, 7, 'PPL', 'P'),
(4283, 'Monte-Sano', 33.480281829834, 0.584341152426235, -86.9027786254883, -1.51673961614652, 218, 2, 'PPL', 'P'),
(89110, 'Monteagle', 35.2400016784668, 0.615054057697574, -85.8397216796875, -1.4981857723061, 218, 50, 'PPL', 'P'),
(104350, 'Montebello', 37.8636093139648, 0.660844649217478, -79.1380615234375, -1.38121973722982, 218, 53, 'PPL', 'P'),
(150821, 'Montebello', 41.1358299255371, 0.717955672741036, -74.1188888549805, -1.29361864843914, 218, 40, 'PPL', 'P'),
(164729, 'Montebello', 40.4280586242676, 0.705602733182758, -77.0738906860352, -1.3451931597935, 218, 45, 'PPL', 'P'),
(183412, 'Montebello', 34.0094413757324, 0.593576728770521, -118.104438781738, -2.06131131796141, 218, 6, 'PPL', 'P'),
(49557, 'Montebello Park', 39.3424987792969, 0.68665613966058, -76.5688934326172, -1.33637929500783, 218, 25, 'PPL', 'P'),
(110504, 'Montecarlo', 37.5161094665527, 0.654779632729959, -81.3619384765625, -1.42003371222107, 218, 58, 'PPL', 'P'),
(183413, 'Montecito', 34.4366683959961, 0.601033246927606, -119.63111114502, -2.08795677729987, 218, 6, 'PPL', 'P'),
(189055, 'Montecito', 36.189998626709, 0.631634632328298, -105.854438781738, -1.84750848459211, 218, 38, 'PPL', 'P'),
(178669, 'Montecito Mobile Home Estates', 33.4216690063477, 0.583318165672508, -111.880828857422, -1.9526888334223, 218, 5, 'PPL', 'P'),
(42144, 'Montegut', 29.4741706848145, 0.514421322744804, -90.5569381713867, -1.58051673161563, 218, 22, 'PPL', 'P'),
(23152, 'Monteideo (historical)', 34.3375015258789, 0.599302458535164, -82.8444366455078, -1.44590818642396, 218, 13, 'PPL', 'P'),
(23153, 'Monteith', 32.1802787780762, 0.561651818887087, -81.1902770996094, -1.41703765599474, 218, 13, 'PPL', 'P'),
(116906, 'Monteith', 41.6313896179199, 0.726604821013287, -94.4283294677734, -1.64808525637063, 218, 16, 'PPL', 'P'),
(49560, 'Monteith (historical)', 39.0400009155273, 0.681376555957553, -76.8794403076172, -1.34179936045836, 218, 25, 'PPL', 'P'),
(66920, 'Monteith (historical)', 35.3136100769043, 0.616338766607428, -80.709716796875, -1.40865029645764, 218, 33, 'PPL', 'P'),
(56343, 'Monteith Junction', 38.214168548584, 0.666963062084853, -94.3666687011719, -1.64700907297413, 218, 29, 'PPL', 'P'),
(49561, 'Montel', 39.6263885498047, 0.691610950868673, -78.8983306884766, -1.3770356448412, 218, 25, 'PPL', 'P'),
(191895, 'Montell', 29.5377807617188, 0.515531528024231, -100.011108398438, -1.74552313012169, 218, 51, 'PPL', 'P'),
(190500, 'Montelle (historical)', 38.5872192382813, 0.673474024896906, -118.84944152832, -2.07431406882567, 218, 39, 'PPL', 'P'),
(125464, 'Montello', 42.1083297729492, 0.73492899705352, -71.0166702270508, -1.23947471926507, 218, 23, 'PPL', 'P'),
(164730, 'Montello', 40.3122215270996, 0.703580994441225, -76.0372161865234, -1.32709977650556, 218, 45, 'PPL', 'P'),
(175377, 'Montello', 43.791389465332, 0.764303930193203, -89.3197174072266, -1.558923155707, 218, 57, 'PPL', 'P'),
(200080, 'Montello', 41.2613906860352, 0.720147121423035, -114.193328857422, -1.99304957237467, 218, 39, 'PPL', 'P'),
(96295, 'Montemayor Subivision Colonia', 26.3379993438721, 0.459684806938674, -98.1240005493164, -1.7125868848143, 218, 51, 'PPL', 'P'),
(17170, 'Monteocha', 29.7961101531982, 0.520040226460221, -82.2855606079102, -1.43615395945738, 218, 12, 'PPL', 'P'),
(96296, 'Monteola', 28.6975002288818, 0.500865866085814, -97.9155578613281, -1.70894887360719, 218, 51, 'PPL', 'P'),
(150822, 'Monteola', 43.6458282470703, 0.761763407671322, -75.6624984741211, -1.3205597186586, 218, 40, 'PPL', 'P'),
(4284, 'Monterey', 31.9033298492432, 0.556818148219079, -86.8819427490234, -1.51637596149967, 218, 2, 'PPL', 'P'),
(10568, 'Monterey', 35.4225006103516, 0.618239264940336, -90.6005630493164, -1.58127812937129, 218, 4, 'PPL', 'P'),
(23154, 'Monterey', 33.5930595397949, 0.586309494787913, -84.4772186279297, -1.47440560798446, 218, 13, 'PPL', 'P'),
(37249, 'Monterey', 38.4219398498535, 0.67058935538316, -84.8724975585938, -1.48130452678831, 218, 21, 'PPL', 'P'),
(42145, 'Monterey', 31.4497203826904, 0.548901169509519, -91.7180633544922, -1.60078218908864, 218, 22, 'PPL', 'P'),
(56344, 'Monterey', 37.5719413757324, 0.655754083372819, -90.8530578613281, -1.58568499518509, 218, 29, 'PPL', 'P'),
(60930, 'Monterey', 32.1847190856934, 0.561729316874808, -90.0808334350586, -1.57220713638237, 218, 30, 'PPL', 'P'),
(89111, 'Monterey', 36.1474990844727, 0.630892875385684, -85.2683334350586, -1.48821316613014, 218, 50, 'PPL', 'P'),
(96298, 'Monterey', 32.8352813720703, 0.573083770761388, -94.0480575561523, -1.64144825945999, 218, 51, 'PPL', 'P'),
(104351, 'Monterey', 38.4122200012207, 0.670419712021722, -79.5808334350586, -1.38894756492296, 218, 53, 'PPL', 'P'),
(116907, 'Monterey', 40.6522216796875, 0.709515116561167, -92.5877838134766, -1.61596167466988, 218, 16, 'PPL', 'P'),
(120678, 'Monterey', 40.5311088562012, 0.707401299024943, -89.9458312988281, -1.56985090460792, 218, 18, 'PPL', 'P'),
(123237, 'Monterey', 41.1569404602051, 0.718324121077849, -86.482780456543, -1.50940926524608, 218, 19, 'PPL', 'P'),
(125465, 'Monterey', 42.1791687011719, 0.736165369589589, -73.2125015258789, -1.27779920524796, 218, 23, 'PPL', 'P'),
(142448, 'Monterey', 41.792781829834, 0.729421646498264, -96.8047180175781, -1.68956106087142, 218, 35, 'PPL', 'P'),
(150823, 'Monterey', 42.3055610656738, 0.738371332499529, -77.0494384765625, -1.34476638822882, 218, 40, 'PPL', 'P'),
(156577, 'Monterey', 40.4505615234375, 0.705995482864518, -84.7838897705078, -1.4797580291433, 218, 41, 'PPL', 'P'),
(164733, 'Monterey', 40.0702781677246, 0.699358286216795, -76.17138671875, -1.32944149405207, 218, 45, 'PPL', 'P'),
(175380, 'Monterey', 43.1711082458496, 0.753477980624949, -88.4994430541992, -1.544606667477, 218, 57, 'PPL', 'P'),
(183414, 'Monterey', 36.6002807617188, 0.63879540644633, -121.893608093262, -2.12744479836302, 218, 6, 'PPL', 'P'),
(82452, 'Monterey (historical)', 34.1674995422363, 0.596335364185679, -82.540283203125, -1.4405997074231, 218, 48, 'PPL', 'P'),
(23155, 'Monterey Acres', 33.8027801513672, 0.589969809969145, -84.0519409179688, -1.4669831117103, 218, 13, 'PPL', 'P'),
(71129, 'Monterey Beach', 39.9847183227539, 0.69786498521456, -74.0677795410156, -1.29272662263202, 218, 37, 'PPL', 'P'),
(132152, 'Monterey Center', 42.6383285522461, 0.744179220783801, -85.8397216796875, -1.4981857723061, 218, 27, 'PPL', 'P'),
(112255, 'Monterey Farms', 39.6266708374023, 0.691615877716689, -75.6427764892578, -1.32021550508771, 218, 10, 'PPL', 'P'),
(4286, 'Monterey Heights', 32.5119400024414, 0.567440399253456, -85.0908279418945, -1.48511511083405, 218, 2, 'PPL', 'P'),
(82453, 'Monterey Hills', 34.997501373291, 0.610821628935165, -81.0374984741211, -1.41437116595329, 218, 48, 'PPL', 'P'),
(104352, 'Monterey Hills', 37.3163909912109, 0.651293887758181, -79.918327331543, -1.394837944622, 218, 53, 'PPL', 'P'),
(104354, 'Monterey Orchards', 38.9027786254883, 0.678981575189245, -78.0849990844727, -1.36284033044081, 218, 53, 'PPL', 'P'),
(66936, 'Monterey Park', 35.2969398498535, 0.616047816258337, -81.1430587768555, -1.41621354079541, 218, 33, 'PPL', 'P'),
(183416, 'Monterey Park', 34.0625, 0.594502776460568, -118.121940612793, -2.06161678253845, 218, 6, 'PPL', 'P'),
(123238, 'Monterey Village', 40.0536117553711, 0.699067402446731, -86.0244369506836, -1.5014096619637, 218, 19, 'PPL', 'P'),
(183417, 'Monterey Vista Mobile Home Park', 36.9300003051758, 0.644550098087828, -121.789169311523, -2.12562199775492, 218, 6, 'PPL', 'P'),
(191896, 'Monterosales Colonia', 31.6520004272461, 0.552431622298096, -106.285003662109, -1.85502325939804, 218, 51, 'PPL', 'P'),
(49562, 'Monterrey Village', 39.0433311462402, 0.681434679448344, -77.0577774047852, -1.34491192998239, 218, 25, 'PPL', 'P'),
(110505, 'Monterville', 38.5588912963867, 0.672979609040533, -80.1052780151367, -1.39810084958956, 218, 58, 'PPL', 'P'),
(110506, 'Montes (historical)', 38.8461112976074, 0.677992543739416, -79.7286071777344, -1.39152670328065, 218, 58, 'PPL', 'P'),
(183418, 'Montesano', 38.4872207641602, 0.671728722276523, -123.01611328125, -2.14703620976414, 218, 6, 'PPL', 'P'),
(208169, 'Montesano', 46.9813919067383, 0.8199799759424, -123.601387023926, -2.1572511635993, 218, 56, 'PPL', 'P'),
(4288, 'Montevallo', 33.1005592346191, 0.577713742895518, -86.8641662597656, -1.51606570323268, 218, 2, 'PPL', 'P'),
(56345, 'Montevallo', 37.7261085510254, 0.65844480818018, -94.1080627441406, -1.64249554755866, 218, 29, 'PPL', 'P'),
(23156, 'Montevideo', 34.2722206115723, 0.598163091641801, -82.8219375610352, -1.44551550332123, 218, 13, 'PPL', 'P'),
(49563, 'Montevideo', 39.1624984741211, 0.683514541680668, -76.767219543457, -1.33984073863466, 218, 25, 'PPL', 'P'),
(104355, 'Montevideo', 38.3644409179688, 0.669585809705391, -78.7697219848633, -1.37479099951643, 218, 53, 'PPL', 'P'),
(136940, 'Montevideo', 44.9425010681152, 0.784394617719679, -95.7233276367188, -1.67068723822602, 218, 28, 'PPL', 'P'),
(195338, 'Monteview', 43.9719390869141, 0.767455115553039, -112.53556060791, -1.96411605818566, 218, 17, 'PPL', 'P'),
(60931, 'Montevista', 33.7050018310547, 0.588263256342622, -89.2355575561523, -1.55745428920776, 218, 30, 'PPL', 'P'),
(23157, 'Montezuma', 32.3050003051758, 0.56382862018309, -84.0274963378906, -1.46655647330367, 218, 13, 'PPL', 'P'),
(27934, 'Montezuma', 39.5519409179688, 0.690311594572823, -90.579719543457, -1.58091434156638, 218, 18, 'PPL', 'P'),
(30550, 'Montezuma', 39.792781829834, 0.694515061458377, -87.3708267211914, -1.52490859647423, 218, 19, 'PPL', 'P'),
(66922, 'Montezuma', 36.064998626709, 0.629452970763305, -81.9027786254883, -1.42947315354681, 218, 33, 'PPL', 'P'),
(89113, 'Montezuma', 35.3936080932617, 0.617734995387929, -88.6933288574219, -1.54799061311611, 218, 50, 'PPL', 'P'),
(104356, 'Montezuma', 38.4091682434082, 0.67036644879992, -78.9883270263672, -1.37860637725213, 218, 53, 'PPL', 'P'),
(116908, 'Montezuma', 41.5858306884766, 0.725809667690816, -92.5272216796875, -1.61490466603322, 218, 16, 'PPL', 'P'),
(150824, 'Montezuma', 43.0099983215332, 0.750666081987989, -76.70361328125, -1.33873059993426, 218, 40, 'PPL', 'P'),
(156580, 'Montezuma', 40.4888916015625, 0.706664468930346, -84.5486068725586, -1.47565156790045, 218, 41, 'PPL', 'P'),
(178670, 'Montezuma', 33.0758285522461, 0.577282111061844, -113.222221374512, -1.97610054940713, 218, 5, 'PPL', 'P'),
(183421, 'Montezuma', 37.9047203063965, 0.661562171394173, -120.452499389648, -2.10229270660583, 218, 6, 'PPL', 'P'),
(187076, 'Montezuma', 39.5811080932617, 0.690820657815192, -105.866668701172, -1.84772193695348, 218, 7, 'PPL', 'P'),
(189056, 'Montezuma', 35.6522216796875, 0.62224865396145, -105.275833129883, -1.83740991089658, 218, 38, 'PPL', 'P'),
(190501, 'Montezuma', 37.7038917541504, 0.658057051925465, -117.368057250977, -2.04845903569875, 218, 39, 'PPL', 'P'),
(193058, 'Montezuma', 37.5958290100098, 0.656171001241471, -100.442779541016, -1.75305721284552, 218, 20, 'PPL', 'P'),
(189057, 'Montezuma (historical)', 35.3097190856934, 0.616270855999631, -106.403610229492, -1.85709333451336, 218, 38, 'PPL', 'P'),
(190502, 'Montezuma (historical)', 38.5927810668945, 0.67357109711864, -114.729721069336, -2.00241138255462, 218, 39, 'PPL', 'P'),
(156581, 'Montezuma Acres', 40.5019416809082, 0.706892235782575, -84.5586090087891, -1.47582613810991, 218, 41, 'PPL', 'P'),
(192708, 'Montezuma Creek', 37.2700004577637, 0.65048422020777, -109.319999694824, -1.90799393295388, 218, 52, 'PPL', 'P'),
(30548, 'Montezuma Station', 39.7949981689453, 0.69455374387321, -87.3866729736328, -1.52518516575344, 218, 19, 'PPL', 'P'),
(190504, 'Montezuma Wells', 38.1719398498535, 0.666226032253174, -117.415557861328, -2.04928807774609, 218, 39, 'PPL', 'P'),
(104357, 'Montford', 38.2405586242676, 0.667423655795382, -78.1680603027344, -1.36429002218019, 218, 53, 'PPL', 'P'),
(49564, 'Montford Glen', 39.5513916015625, 0.690302007192899, -76.4305572509766, -1.33396487316357, 218, 25, 'PPL', 'P'),
(66924, 'Montford Hills', 35.6044387817383, 0.621414685066092, -82.5741729736328, -1.44119119550121, 218, 33, 'PPL', 'P'),
(66925, 'Montford Point', 34.7241706848145, 0.606051108474506, -77.4147186279297, -1.35114172956236, 218, 33, 'PPL', 'P'),
(96299, 'Montfort', 32.2222213745117, 0.562383855291722, -96.3491668701172, -1.68161019343698, 218, 51, 'PPL', 'P'),
(113396, 'Montfort', 42.9716682434082, 0.749997095922161, -90.4330596923828, -1.57835464428465, 218, 57, 'PPL', 'P'),
(4289, 'Montgomery', 32.3666687011719, 0.564904936737646, -86.3000030517578, -1.50621919773433, 218, 2, 'PPL', 'P'),
(23158, 'Montgomery', 31.9402809143066, 0.557463065966556, -81.1222229003906, -1.41584988614856, 218, 13, 'PPL', 'P'),
(30549, 'Montgomery', 38.6624984741211, 0.674787895420697, -87.0461120605469, -1.51924125651649, 218, 19, 'PPL', 'P'),
(37250, 'Montgomery', 36.878059387207, 0.643643558052765, -87.7405624389648, -1.5313617021116, 218, 21, 'PPL', 'P'),
(42148, 'Montgomery', 31.6672191619873, 0.552697239327318, -92.8905563354492, -1.62124605206287, 218, 22, 'PPL', 'P'),
(60933, 'Montgomery', 31.6416702270508, 0.552251326292298, -90.4194412231445, -1.57811695715736, 218, 30, 'PPL', 'P'),
(73521, 'Montgomery', 39.2280616760254, 0.684658835422048, -84.3541717529297, -1.47225803488142, 218, 41, 'PPL', 'P'),
(82454, 'Montgomery', 34.1336097717285, 0.595743876107573, -81.1344375610352, -1.41606307219382, 218, 48, 'PPL', 'P'),
(89115, 'Montgomery', 36.3258285522461, 0.634005311751659, -84.3708267211914, -1.4725487189144, 218, 50, 'PPL', 'P'),
(96300, 'Montgomery', 30.3880596160889, 0.530371693593075, -95.6961135864258, -1.67021226344561, 218, 51, 'PPL', 'P'),
(104358, 'Montgomery', 37.1563911437988, 0.648501363618151, -80.3191680908203, -1.40183393564758, 218, 53, 'PPL', 'P'),
(110507, 'Montgomery', 38.1802787780762, 0.666371574006747, -81.32861328125, -1.419452077839, 218, 58, 'PPL', 'P'),
(116909, 'Montgomery', 43.4408302307129, 0.758185517325828, -95.2024993896484, -1.66159707047726, 218, 16, 'PPL', 'P'),
(120679, 'Montgomery', 41.7305603027344, 0.728335675984756, -88.345832824707, -1.54192566320762, 218, 18, 'PPL', 'P'),
(125467, 'Montgomery', 42.2066688537598, 0.736645337797049, -72.8055572509766, -1.27069668777877, 218, 23, 'PPL', 'P'),
(132154, 'Montgomery', 41.7772216796875, 0.729150070646103, -84.8041687011719, -1.48011196325217, 218, 27, 'PPL', 'P'),
(136942, 'Montgomery', 44.4388885498047, 0.7756049211209, -93.5811080932617, -1.63329845389213, 218, 28, 'PPL', 'P'),
(145798, 'Montgomery', 40.478328704834, 0.706480111603885, -74.7541732788086, -1.30470645332158, 218, 37, 'PPL', 'P'),
(150826, 'Montgomery', 41.5275001525879, 0.724791607785106, -74.2372207641602, -1.2956839298645, 218, 40, 'PPL', 'P'),
(164734, 'Montgomery', 41.170280456543, 0.718556947936149, -76.8772201538086, -1.3417606114645, 218, 45, 'PPL', 'P'),
(172264, 'Montgomery', 44.9025001525879, 0.783696470039915, -72.6386108398438, -1.26778292323012, 218, 55, 'PPL', 'P'),
(183422, 'Montgomery', 39.2336082458496, 0.684755641327673, -123.388610839844, -2.15353751861724, 218, 6, 'PPL', 'P'),
(89116, 'Montgomery (historical)', 36.1136093139648, 0.630301387307577, -84.6144409179688, -1.47680058875277, 218, 50, 'PPL', 'P'),
(172265, 'Montgomery Center', 44.878059387207, 0.783269898212312, -72.602783203125, -1.26715761300617, 218, 55, 'PPL', 'P'),
(56347, 'Montgomery City', 38.9775009155273, 0.680285725175056, -91.5047225952148, -1.59705869041055, 218, 29, 'PPL', 'P'),
(183423, 'Montgomery City', 37.8286094665527, 0.660233786642441, -118.430000305176, -2.06699343846321, 218, 6, 'PPL', 'P'),
(193798, 'Montgomery Creek', 40.8416709899902, 0.712821630791582, -121.922500610352, -2.12794906791543, 218, 6, 'PPL', 'P'),
(104360, 'Montgomery Farms', 37.2027816772461, 0.649311031168563, -80.4861068725586, -1.40474756703818, 218, 53, 'PPL', 'P'),
(164737, 'Montgomery Ferry', 40.4988899230957, 0.706838972560773, -76.9730606079102, -1.34343334294518, 218, 45, 'PPL', 'P'),
(73523, 'Montgomery Heights', 39.2366714477539, 0.684809104286556, -84.3569412231445, -1.4723063712552, 218, 41, 'PPL', 'P'),
(110508, 'Montgomery Heights', 38.1297187805176, 0.665489135579549, -81.2727813720703, -1.41847762719614, 218, 58, 'PPL', 'P'),
(4292, 'Montgomery Hill', 31.163890838623, 0.543912502866069, -87.7863922119141, -1.53216158254501, 218, 2, 'PPL', 'P'),
(4293, 'Montgomery Hill Landing', 31.1813907623291, 0.544217934153587, -87.8541717529297, -1.53334455870122, 218, 2, 'PPL', 'P'),
(49566, 'Montgomery Hills', 39.0105590820313, 0.680862699025222, -77.0480575561523, -1.34474228662095, 218, 25, 'PPL', 'P'),
(49568, 'Montgomery Knolls', 39.0097198486328, 0.680848051639227, -76.9958267211914, -1.34383068657982, 218, 25, 'PPL', 'P'),
(4294, 'Montgomery Lakes', 33.3977813720703, 0.582901247803856, -87.7094421386719, -1.53081855040728, 218, 2, 'PPL', 'P'),
(49569, 'Montgomery Manor', 39.2119407653809, 0.684377472452881, -76.73388671875, -1.33925897109454, 218, 25, 'PPL', 'P'),
(193799, 'Montgomery Place', 40.086669921875, 0.699644376296897, -122.574996948242, -2.13933727736883, 218, 6, 'PPL', 'P'),
(49570, 'Montgomery Run', 39.2177810668945, 0.684479404943604, -76.8041687011719, -1.34048562309263, 218, 25, 'PPL', 'P'),
(49571, 'Montgomery Square', 39.0550003051758, 0.681638344692708, -77.1672210693359, -1.34682208227425, 218, 25, 'PPL', 'P'),
(49572, 'Montgomery Village', 39.1766700744629, 0.68376188276691, -77.195556640625, -1.34731663128868, 218, 25, 'PPL', 'P'),
(104379, 'Montgomery Village', 37.2627792358398, 0.650358186109182, -79.8711090087891, -1.39401382942267, 218, 53, 'PPL', 'P'),
(183424, 'Montgomery Village', 38.4444389343262, 0.670982038485892, -122.6875, -2.14130082604054, 218, 6, 'PPL', 'P'),
(104361, 'Montgomery White Sulphur Springs (historical)', 37.170280456543, 0.648743777856376, -80.3486099243164, -1.40234779257991, 218, 53, 'PPL', 'P'),
(14262, 'Montgomery Woods', 39.7972183227539, 0.694592492867071, -75.6694412231445, -1.3206808924882, 218, 10, 'PPL', 'P'),
(49573, 'Montgomery Woods', 39.209171295166, 0.684329136079096, -76.7336120605469, -1.33925417740457, 218, 25, 'PPL', 'P'),
(164741, 'Montgomeryville', 40.2472190856934, 0.702446487816851, -75.2441711425781, -1.31325852937209, 218, 45, 'PPL', 'P'),
(175383, 'Montgomeryville', 43.3563919067383, 0.756711790557605, -90.7397232055664, -1.58370693228544, 218, 57, 'PPL', 'P'),
(96302, 'Monthalia', 29.4686107635498, 0.514324283812584, -97.6083297729492, -1.70358673191037, 218, 51, 'PPL', 'P'),
(177323, 'Monti', 42.3769416809082, 0.739617159257468, -91.6372222900391, -1.59937124634312, 218, 16, 'PPL', 'P'),
(588, 'Monticello', 32.5963897705078, 0.56891432575876, -91.3938903808594, -1.59512430335277, 218, 22, 'PPL', 'P'),
(4295, 'Monticello', 31.8252792358398, 0.55545590803199, -85.7786102294922, -1.49711917628953, 218, 2, 'PPL', 'P'),
(10573, 'Monticello', 33.6288909912109, 0.58693487159089, -91.7908325195313, -1.6020522506125, 218, 4, 'PPL', 'P'),
(17171, 'Monticello', 30.5450000762939, 0.533110821353249, -83.8702774047852, -1.46381248527451, 218, 12, 'PPL', 'P'),
(23161, 'Monticello', 33.396671295166, 0.582881873306926, -82.0380630493164, -1.43183431216927, 218, 13, 'PPL', 'P'),
(33328, 'Monticello', 38.9988899230957, 0.680659033780858, -94.8438873291016, -1.65533810928335, 218, 20, 'PPL', 'P'),
(37255, 'Monticello', 37.9922218322754, 0.663089361121278, -84.5502777099609, -1.47568072951439, 218, 21, 'PPL', 'P'),
(60936, 'Monticello', 31.5536098480225, 0.5507143827377, -90.1072235107422, -1.5726677300929, 218, 30, 'PPL', 'P'),
(66928, 'Monticello', 35.7988891601563, 0.624808484401234, -80.9352798461914, -1.41258711433905, 218, 33, 'PPL', 'P'),
(82457, 'Monticello', 34.3525009155273, 0.599564247270319, -81.2986068725586, -1.41892836721064, 218, 48, 'PPL', 'P'),
(89120, 'Monticello', 36.2008285522461, 0.631823650186666, -86.5583267211914, -1.51072779630178, 218, 50, 'PPL', 'P'),
(96303, 'Monticello', 33.0958290100098, 0.577631184901726, -95.085563659668, -1.65955615697588, 218, 51, 'PPL', 'P'),
(116911, 'Monticello', 42.2383308410645, 0.73719794372324, -91.1869430541992, -1.59151239112435, 218, 16, 'PPL', 'P'),
(120681, 'Monticello', 40.0277786254883, 0.698616529274181, -88.5733337402344, -1.54589630323487, 218, 18, 'PPL', 'P'),
(123240, 'Monticello', 40.7452812194824, 0.711139311930979, -86.7647171020508, -1.51432998799222, 218, 19, 'PPL', 'P'),
(128171, 'Monticello', 46.3083305358887, 0.808232838953088, -67.8430633544922, -1.184084830175, 218, 26, 'PPL', 'P'),
(136945, 'Monticello', 45.3055610656738, 0.790731210059359, -93.7938919067383, -1.63701223203225, 218, 28, 'PPL', 'P'),
(139340, 'Monticello', 40.1183280944824, 0.700196915644061, -91.7119369506836, -1.60067526317088, 218, 29, 'PPL', 'P'),
(150829, 'Monticello', 41.6555595397949, 0.727026665729955, -74.6897201538086, -1.30358153407713, 218, 40, 'PPL', 'P'),
(156585, 'Monticello', 40.6974983215332, 0.71030534303562, -84.4255599975586, -1.47350399479741, 218, 41, 'PPL', 'P'),
(164742, 'Monticello', 40.9683303833008, 0.715032254233429, -76.2477798461914, -1.33077480565182, 218, 45, 'PPL', 'P'),
(175384, 'Monticello', 42.7455596923828, 0.746050757239855, -89.5947189331055, -1.56372283778159, 218, 57, 'PPL', 'P'),
(189059, 'Monticello', 33.3969383239746, 0.582886533838834, -107.45027923584, -1.8753611548527, 218, 38, 'PPL', 'P'),
(192709, 'Monticello', 37.8713912963867, 0.660980470433072, -109.342216491699, -1.90838168920859, 218, 52, 'PPL', 'P'),
(66929, 'Monticello (historical)', 35.7655601501465, 0.624226783440134, -76.7366714477539, -1.33930757378443, 218, 33, 'PPL', 'P'),
(73524, 'Monticello (historical)', 39.9000015258789, 0.696386398177348, -82.5625, -1.44098746367782, 218, 41, 'PPL', 'P'),
(183425, 'Monticello (historical)', 38.5777816772461, 0.673309308383485, -122.206108093262, -2.13289895227551, 218, 6, 'PPL', 'P'),
(208171, 'Monticello (historical)', 46.1383285522461, 0.805265744603603, -122.936943054199, -2.14565442863255, 218, 56, 'PPL', 'P'),
(104362, 'Monticello Estates', 37.3097190856934, 0.651177441039517, -80.017219543457, -1.39656393932448, 218, 53, 'PPL', 'P'),
(104363, 'Monticello Forest', 38.7852783203125, 0.676930807991829, -77.190559387207, -1.34722941276298, 218, 53, 'PPL', 'P'),
(66930, 'Monticello Heights', 35.8091697692871, 0.624987914879678, -80.9252777099609, -1.4124125441296, 218, 33, 'PPL', 'P'),
(104364, 'Monticello Park', 38.832218170166, 0.677750062922165, -77.0691680908203, -1.34511073495777, 218, 53, 'PPL', 'P'),
(104365, 'Monticello Village', 36.9211082458496, 0.644394902375304, -76.2627792358398, -1.33103659438697, 218, 53, 'PPL', 'P'),
(104366, 'Monticello Woods', 38.7872200012207, 0.6769646967167, -77.1705627441406, -1.34688040550212, 218, 53, 'PPL', 'P'),
(56352, 'Montier', 36.9869384765625, 0.645543856648591, -91.5752792358398, -1.5982901360986, 218, 29, 'PPL', 'P'),
(17174, 'Montivilla', 30.5475006103516, 0.533154463905612, -83.8886108398438, -1.46413246407948, 218, 12, 'PPL', 'P'),
(82459, 'Montmorenci', 33.5277786254883, 0.585170127894549, -81.6366729736328, -1.42482873376376, 218, 48, 'PPL', 'P'),
(123241, 'Montmorenci', 40.4741706848145, 0.70640754046418, -87.0294418334961, -1.5189503061674, 218, 19, 'PPL', 'P'),
(164743, 'Montmorenci', 41.4983291625977, 0.72428247796371, -78.7405624389648, -1.37428206943211, 218, 45, 'PPL', 'P'),
(150830, 'Montoma', 42.0205612182617, 0.733397146794507, -74.133056640625, -1.29386592294635, 218, 40, 'PPL', 'P'),
(10574, 'Montongo', 33.7430610656738, 0.588927515297515, -91.8222198486328, -1.60260006284873, 218, 4, 'PPL', 'P'),
(169490, 'Montop (historical)', 41.6736106872559, 0.727341717686912, -71.2402801513672, -1.24337744868452, 218, 47, 'PPL', 'P'),
(96304, 'Montopolis', 30.2430591583252, 0.5278409581882, -97.6902770996094, -1.7050169825738, 218, 51, 'PPL', 'P'),
(189060, 'Montosa', 35.3722190856934, 0.617361686782127, -104.777778625488, -1.82871721994051, 218, 38, 'PPL', 'P'),
(113010, 'Montour', 41.9813919067383, 0.732713513342683, -92.7147216796875, -1.61817715838071, 218, 16, 'PPL', 'P'),
(195339, 'Montour', 43.9249992370605, 0.766635860622704, -116.327781677246, -2.03030280180908, 218, 17, 'PPL', 'P'),
(150831, 'Montour Falls', 42.3472213745117, 0.739098442056148, -76.8455581665039, -1.34120800553831, 218, 40, 'PPL', 'P'),
(164745, 'Montour Junction', 40.5061111450195, 0.706965006659361, -80.1405563354492, -1.39871657243359, 218, 45, 'PPL', 'P'),
(164746, 'Montoursville', 41.2541694641113, 0.720021087324447, -76.9208297729492, -1.34252174290405, 218, 45, 'PPL', 'P'),
(113738, 'Montowese', 41.3502807617188, 0.721698545916061, -72.8602828979492, -1.27165183050373, 218, 8, 'PPL', 'P'),
(189061, 'Montoya', 35.0997200012207, 0.612605680549409, -104.063331604004, -1.81624776708454, 218, 38, 'PPL', 'P'),
(191897, 'Montoya', 31.8505592346191, 0.555897127245589, -106.580276489258, -1.86017674242345, 218, 51, 'PPL', 'P'),
(23162, 'Montpelier', 33.0800018310547, 0.577354948517657, -83.1638870239258, -1.45148364732409, 218, 13, 'PPL', 'P'),
(37253, 'Montpelier', 37.0188903808594, 0.646101522580854, -85.1855621337891, -1.48676853439683, 218, 21, 'PPL', 'P'),
(42150, 'Montpelier', 30.6808300018311, 0.53548150077661, -90.6488876342773, -1.58212155248851, 218, 22, 'PPL', 'P'),
(49574, 'Montpelier', 39.0613899230957, 0.681749864563355, -76.8511123657227, -1.34130494460199, 218, 25, 'PPL', 'P'),
(60937, 'Montpelier', 33.7177810668945, 0.588486296083916, -88.9477767944336, -1.55243156739187, 218, 30, 'PPL', 'P'),
(104368, 'Montpelier', 37.8211097717285, 0.660102892274864, -77.6847229003906, -1.35585419311126, 218, 53, 'PPL', 'P'),
(110509, 'Montpelier', 39.2808303833008, 0.685579823106025, -80.3252792358398, -1.40194059524924, 218, 58, 'PPL', 'P'),
(116912, 'Montpelier', 41.459171295166, 0.723599044248969, -90.8069381713867, -1.58488005474562, 218, 16, 'PPL', 'P'),
(123242, 'Montpelier', 40.5538902282715, 0.707798908975692, -85.2774963378906, -1.4883730889536, 218, 19, 'PPL', 'P'),
(128173, 'Montpelier', 44.082218170166, 0.769379848651867, -69.1677780151367, -1.20720546265268, 218, 26, 'PPL', 'P'),
(140524, 'Montpelier', 46.7002792358398, 0.815073634266147, -98.5897216796875, -1.72071525193538, 218, 34, 'PPL', 'P'),
(156586, 'Montpelier', 41.5844383239746, 0.725785366345869, -84.6055603027344, -1.47664559277733, 218, 41, 'PPL', 'P'),
(172267, 'Montpelier', 44.2599983215332, 0.772482697637918, -72.5758285522461, -1.2666871655996, 218, 55, 'PPL', 'P'),
(183426, 'Montpelier', 37.5449981689453, 0.655283835703338, -120.705001831055, -2.10669970557769, 218, 6, 'PPL', 'P'),
(195340, 'Montpelier', 42.3222198486328, 0.738662083111539, -111.296943664551, -1.94249811435305, 218, 17, 'PPL', 'P'),
(23163, 'Montpelier (historical)', 32.8436088562012, 0.573229112777879, -83.8891677856445, -1.46414218461746, 218, 13, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(49575, 'Montpelier Forest', 39.0683288574219, 0.681870971813926, -76.8644409179688, -1.34153757172321, 218, 25, 'PPL', 'P'),
(49576, 'Montpelier Hills', 39.0499992370605, 0.68155105958798, -76.845832824707, -1.34121279922827, 218, 25, 'PPL', 'P'),
(172268, 'Montpelier Junction', 44.2569389343262, 0.772429301258062, -72.6083297729492, -1.26725441891179, 218, 55, 'PPL', 'P'),
(49577, 'Montpelier Woods', 39.0519409179688, 0.681584948312852, -76.8291702270508, -1.34092198203724, 218, 25, 'PPL', 'P'),
(89121, 'Montpier Farms', 35.9844398498535, 0.628046954865798, -86.9388885498047, -1.51736985321849, 218, 50, 'PPL', 'P'),
(156587, 'Montra', 40.4319381713867, 0.705670444053474, -84.0950012207031, -1.46773465576992, 218, 41, 'PPL', 'P'),
(10575, 'Montreal', 35.1175003051758, 0.612916005395431, -94.3483276367188, -1.6466889610111, 218, 4, 'PPL', 'P'),
(23164, 'Montreal', 33.8241691589355, 0.590343118574946, -84.2366714477539, -1.470207267684, 218, 13, 'PPL', 'P'),
(56354, 'Montreal', 37.9688911437988, 0.662682163790605, -92.5919418334961, -1.61603424580958, 218, 29, 'PPL', 'P'),
(175388, 'Montreal', 46.4280586242676, 0.810322488302418, -90.2458267211914, -1.57508681246907, 218, 57, 'PPL', 'P'),
(73525, 'Montreal (historical)', 38.4372215270996, 0.670856070966331, -82.5416717529297, -1.44062394218902, 218, 41, 'PPL', 'P'),
(49578, 'Montreal Acres', 39.5286102294922, 0.68990439724215, -76.2241668701172, -1.33036268147313, 218, 25, 'PPL', 'P'),
(66932, 'Montreat', 35.6441688537598, 0.622108105634921, -82.3030624389648, -1.43645942403441, 218, 33, 'PPL', 'P'),
(4299, 'Montrose', 30.565559387207, 0.533469649020623, -87.9016723632813, -1.53417360074856, 218, 2, 'PPL', 'P'),
(10576, 'Montrose', 33.2975006103516, 0.581151018335456, -91.4936065673828, -1.59686467912514, 218, 4, 'PPL', 'P'),
(23165, 'Montrose', 32.559440612793, 0.568269441300797, -83.1533279418945, -1.45129935657666, 218, 13, 'PPL', 'P'),
(27938, 'Montrose', 39.1652793884277, 0.683563077791535, -88.3791732788086, -1.5425075639058, 218, 18, 'PPL', 'P'),
(33330, 'Montrose', 39.7844390869141, 0.694369453125777, -98.0875015258789, -1.71194985668155, 218, 20, 'PPL', 'P'),
(37254, 'Montrose', 38.0722198486328, 0.66448558990178, -84.4052810668945, -1.47315006068854, 218, 21, 'PPL', 'P'),
(42151, 'Montrose', 31.5705604553223, 0.551010226645294, -92.9916687011719, -1.62301079575921, 218, 22, 'PPL', 'P'),
(49580, 'Montrose', 39.0569381713867, 0.681672166838552, -77.1316680908203, -1.34620156574026, 218, 25, 'PPL', 'P'),
(56355, 'Montrose', 38.2577781677246, 0.667724193524398, -93.9811096191406, -1.64027979753172, 218, 29, 'PPL', 'P'),
(60938, 'Montrose', 32.1241683959961, 0.560672507975237, -89.2355575561523, -1.55745428920776, 218, 30, 'PPL', 'P'),
(66933, 'Montrose', 35.0424995422363, 0.61160699514063, -79.3358306884766, -1.38467146031868, 218, 33, 'PPL', 'P'),
(82460, 'Montrose', 34.6355590820313, 0.60450454425047, -79.8730621337891, -1.39404791788463, 218, 48, 'PPL', 'P'),
(104369, 'Montrose', 37.5205612182617, 0.654857330454762, -77.3786087036133, -1.35051149249039, 218, 53, 'PPL', 'P'),
(110510, 'Montrose', 39.0683288574219, 0.681870971813926, -79.8105621337891, -1.39295708710213, 218, 58, 'PPL', 'P'),
(116914, 'Montrose', 40.5322189331055, 0.707420673521874, -91.4147186279297, -1.59548782484157, 218, 16, 'PPL', 'P'),
(125469, 'Montrose', 42.5158309936523, 0.742041235060686, -71.0541687011719, -1.24012919110295, 218, 23, 'PPL', 'P'),
(132159, 'Montrose', 43.1766700744629, 0.753575052846683, -83.8927764892578, -1.46420516837724, 218, 27, 'PPL', 'P'),
(136948, 'Montrose', 45.064998626709, 0.786532603442795, -93.9108276367188, -1.63905314553363, 218, 28, 'PPL', 'P'),
(145800, 'Montrose', 40.3016700744629, 0.703396836851846, -74.2216720581055, -1.29541255374942, 218, 37, 'PPL', 'P'),
(150833, 'Montrose', 41.2522201538086, 0.719987065441522, -73.9319381713867, -1.29035574347157, 218, 40, 'PPL', 'P'),
(156588, 'Montrose', 41.1355590820313, 0.717950945630102, -81.6374969482422, -1.42484311483365, 218, 41, 'PPL', 'P'),
(164749, 'Montrose', 41.8338890075684, 0.730139102095931, -75.8775024414063, -1.32431224579257, 218, 45, 'PPL', 'P'),
(170910, 'Montrose', 43.6986083984375, 0.762684595092381, -97.1833267211914, -1.69616902932618, 218, 49, 'PPL', 'P'),
(175393, 'Montrose', 42.8827781677246, 0.748445671429136, -89.5772171020508, -1.56341737320456, 218, 57, 'PPL', 'P'),
(183427, 'Montrose', 34.2063903808594, 0.597014137368513, -118.223327636719, -2.06338631992475, 218, 6, 'PPL', 'P'),
(187079, 'Montrose', 38.478328704834, 0.671573526563998, -107.875556945801, -1.88278365112686, 218, 7, 'PPL', 'P'),
(199541, 'Montrose', 42.9225006103516, 0.74913895883991, -103.728332519531, -1.81040093006933, 218, 35, 'PPL', 'P'),
(104371, 'Montrose Heights', 37.5194396972656, 0.65483775622075, -77.3925018310547, -1.35075397330764, 218, 53, 'PPL', 'P'),
(164750, 'Montrose Hill', 40.5036087036133, 0.706921330817484, -79.855827331543, -1.3937471138395, 218, 45, 'PPL', 'P'),
(136949, 'Montrose Manor Mobile Home Park', 45.0627784729004, 0.786493854448934, -93.9138870239258, -1.63910654191348, 218, 28, 'PPL', 'P'),
(104372, 'Montross', 38.0950012207031, 0.664883199852529, -76.8277816772461, -1.34089774727132, 218, 53, 'PPL', 'P'),
(164753, 'Montsera', 40.1088905334473, 0.70003219913064, -77.2841720581055, -1.34886326209174, 218, 45, 'PPL', 'P'),
(56356, 'Montserrat', 38.7747192382813, 0.676746517244396, -93.6216735839844, -1.63400645526793, 218, 29, 'PPL', 'P'),
(125470, 'Montserrat', 42.5625, 0.742855762880086, -70.8666687011719, -1.23685669875546, 218, 23, 'PPL', 'P'),
(128174, 'Montsweag', 43.9622192382813, 0.767285472191601, -69.7244415283203, -1.21692107378346, 218, 26, 'PPL', 'P'),
(89122, 'Montvale', 35.6855583190918, 0.622830488080605, -83.9727783203125, -1.46560146373677, 218, 50, 'PPL', 'P'),
(104374, 'Montvale', 37.3844413757324, 0.652481591025329, -79.7313919067383, -1.39157530597054, 218, 53, 'PPL', 'P'),
(125471, 'Montvale', 42.4777793884277, 0.741377109263847, -71.125, -1.24136543048097, 218, 23, 'PPL', 'P'),
(145801, 'Montvale', 41.0466690063477, 0.716399521137076, -74.0233306884766, -1.29195084380648, 218, 37, 'PPL', 'P'),
(89123, 'Montvale Springs', 35.6411094665527, 0.622054709255065, -83.960563659668, -1.46538827769151, 218, 50, 'PPL', 'P'),
(17172, 'Montverde', 28.6000003814697, 0.499164172728281, -81.6741714477539, -1.42548320560165, 218, 12, 'PPL', 'P'),
(17173, 'Montverde Junction', 28.561939239502, 0.498499880483874, -81.682502746582, -1.42562861419717, 218, 12, 'PPL', 'P'),
(66934, 'Montview', 36.1399993896484, 0.630761981018106, -80.2366714477539, -1.40039409760423, 218, 33, 'PPL', 'P'),
(125472, 'Montville', 42.1186103820801, 0.735108427531964, -73.1263885498047, -1.27629625028677, 218, 23, 'PPL', 'P'),
(145803, 'Montville', 40.9147186279297, 0.71409655258443, -74.3841705322266, -1.2982486871523, 218, 37, 'PPL', 'P'),
(150834, 'Montville', 42.7144393920898, 0.745507605535533, -76.4036102294922, -1.33349455891506, 218, 40, 'PPL', 'P'),
(156589, 'Montville', 41.6072196960449, 0.726182976296618, -81.0505599975586, -1.4145991325426, 218, 41, 'PPL', 'P'),
(113739, 'Montville Center', 41.478889465332, 0.723943191240834, -72.1516723632813, -1.25928424355946, 218, 8, 'PPL', 'P'),
(89124, 'Montvue', 35.9208297729492, 0.626936749586371, -84.0422210693359, -1.46681346834886, 218, 50, 'PPL', 'P'),
(104375, 'Montvue', 38.0705604553223, 0.664456628024925, -78.5136108398438, -1.37032101678478, 218, 53, 'PPL', 'P'),
(23166, 'Montwicke', 33.8869400024414, 0.591438676468378, -84.4030609130859, -1.47311131169468, 218, 13, 'PPL', 'P'),
(42152, 'Monty', 30.0427799224854, 0.524345426099416, -91.0569381713867, -1.5892433778756, 218, 22, 'PPL', 'P'),
(104376, 'Montyville', 38.7416687011719, 0.676169676552284, -77.4166717529297, -1.35117581802431, 218, 53, 'PPL', 'P'),
(104377, 'Montyville Estates', 38.7405586242676, 0.676150302055354, -77.4208297729492, -1.35124838916402, 218, 53, 'PPL', 'P'),
(42153, 'Montz', 30.0066699981689, 0.523715189027449, -90.4686126708984, -1.57897516081864, 218, 22, 'PPL', 'P'),
(164754, 'Monument', 41.1111106872559, 0.717524240644444, -77.704719543457, -1.35620320037211, 218, 45, 'PPL', 'P'),
(187081, 'Monument', 39.0916709899902, 0.682278368881681, -104.872222900391, -1.83036558349721, 218, 7, 'PPL', 'P'),
(187816, 'Monument', 39.1044387817383, 0.682501208885893, -101.00666809082, -1.76289892465391, 218, 20, 'PPL', 'P'),
(189062, 'Monument', 32.6238899230957, 0.56939429396622, -103.263893127441, -1.8022949335014, 218, 38, 'PPL', 'P'),
(201257, 'Monument', 44.8194389343262, 0.78224677830053, -119.419998168945, -2.0842721607737, 218, 43, 'PPL', 'P'),
(125473, 'Monument Beach', 41.7194404602051, 0.728141598120317, -70.6125030517578, -1.23242067132772, 218, 23, 'PPL', 'P'),
(187082, 'Monument Park', 37.2069396972656, 0.649383602308267, -105.045829772949, -1.83339559502745, 218, 7, 'PPL', 'P'),
(49581, 'Monumental', 39.2344398498535, 0.684770155555613, -76.6549987792969, -1.33788211681096, 218, 25, 'PPL', 'P'),
(104378, 'Monumental Mills', 38.5997200012207, 0.673692204369211, -78.0061111450195, -1.36146347615723, 218, 53, 'PPL', 'P'),
(113009, 'Mooar', 40.4436111450195, 0.705874175876865, -91.4522171020508, -1.59614229667945, 218, 16, 'PPL', 'P'),
(113742, 'Moodus', 41.5027809143066, 0.724360175688513, -72.4505615234375, -1.2645008435027, 218, 8, 'PPL', 'P'),
(4301, 'Moody', 33.5908317565918, 0.586270612635997, -86.4908294677734, -1.50954974699358, 218, 2, 'PPL', 'P'),
(56358, 'Moody', 36.5294418334961, 0.637559033910261, -91.9891662597656, -1.60551382739739, 218, 29, 'PPL', 'P'),
(96305, 'Moody', 31.3080596923828, 0.546428724043003, -97.3611068725586, -1.69927187831223, 218, 51, 'PPL', 'P'),
(123243, 'Moody', 40.9916687011719, 0.715439584722157, -87.0236129760742, -1.51884857341376, 218, 19, 'PPL', 'P'),
(128177, 'Moody', 43.2750015258789, 0.755291260432157, -70.5975036621094, -1.23215888259256, 218, 26, 'PPL', 'P'),
(150839, 'Moody', 44.2277793884277, 0.771920371173748, -74.4852828979492, -1.30001343084864, 218, 40, 'PPL', 'P'),
(183428, 'Moody', 33.8380584716797, 0.590585532813171, -118.044998168945, -2.06027388355877, 218, 6, 'PPL', 'P'),
(195341, 'Moody', 43.8369407653809, 0.765098950357619, -111.634170532227, -1.94838383352018, 218, 17, 'PPL', 'P'),
(208172, 'Moody', 47.2227783203125, 0.824192963628851, -118.915557861328, -2.075468016526, 218, 56, 'PPL', 'P'),
(10578, 'Moody (historical)', 33.4683303833008, 0.584132560333854, -91.9347229003906, -1.60456361152045, 218, 4, 'PPL', 'P'),
(73526, 'Moody (historical)', 38.7061080932617, 0.675549026860241, -82.3038864135742, -1.4364738051043, 218, 41, 'PPL', 'P'),
(128178, 'Moody Beach', 43.2755584716797, 0.755300980970136, -70.5833282470703, -1.23191147492729, 218, 26, 'PPL', 'P'),
(125477, 'Moody Corner', 42.2805595397949, 0.73793497355492, -72.5591735839844, -1.26639648156662, 218, 23, 'PPL', 'P'),
(177345, 'Moody Corner', 45.0047187805176, 0.785480521654159, -69.725830078125, -1.21694530854938, 218, 26, 'PPL', 'P'),
(82461, 'Moody Cove', 34.9322204589844, 0.609682262041802, -83.0708312988281, -1.44985951853331, 218, 48, 'PPL', 'P'),
(128179, 'Moody Point', 43.2863883972168, 0.755489998828504, -70.5727767944336, -1.23172731733792, 218, 26, 'PPL', 'P'),
(76625, 'Moodys', 36.0311088562012, 0.628861482685199, -94.9574966430664, -1.65732096587297, 218, 42, 'PPL', 'P'),
(4302, 'Moodys Chapel', 33.9958305358887, 0.593339174801286, -86.3236083984375, -1.50663118875496, 218, 2, 'PPL', 'P'),
(104380, 'Moodys Corner', 37.8702812194824, 0.660961095936142, -77.7122192382813, -1.35633409473969, 218, 53, 'PPL', 'P'),
(23167, 'Moodys Crossing (historical)', 32.0333290100098, 0.559087061599286, -81.8675003051758, -1.42885743070278, 218, 13, 'PPL', 'P'),
(4303, 'Moodys Crossroads', 31.7347202301025, 0.553875355214542, -86.3947219848633, -1.50787235498099, 218, 2, 'PPL', 'P'),
(89126, 'Moodyville', 36.5380592346191, 0.637709435932823, -85.0752792358398, -1.48484373471897, 218, 50, 'PPL', 'P'),
(150835, 'Mooers', 44.9633293151855, 0.784758139208475, -73.5877838134766, -1.28434911679095, 218, 40, 'PPL', 'P'),
(150836, 'Mooers Forks', 44.9580612182617, 0.78466619357184, -73.64111328125, -1.28527989159194, 218, 40, 'PPL', 'P'),
(37256, 'Mook', 37.6733283996582, 0.657523620759122, -86.3522186279297, -1.50713053145935, 218, 21, 'PPL', 'P'),
(37257, 'Mooleyville', 38.021110534668, 0.663593564094658, -86.4638900756836, -1.50907956590313, 218, 21, 'PPL', 'P'),
(104384, 'Moomaw (historical)', 37.374439239502, 0.652307020815875, -80.146110534668, -1.39881351149727, 218, 53, 'PPL', 'P'),
(199542, 'Moomaw Corner', 41.8166694641113, 0.729838564366915, -103.323333740234, -1.80333236790404, 218, 35, 'PPL', 'P'),
(104381, 'Moomaw Heights', 37.2902793884277, 0.650838154316641, -80.0111083984375, -1.39645727972282, 218, 53, 'PPL', 'P'),
(37258, 'Moon', 37.973331451416, 0.662759661778327, -83.0488891601563, -1.44947655596856, 218, 21, 'PPL', 'P'),
(60940, 'Moon', 34.4219398498535, 0.600776185303386, -90.4883270263672, -1.57931924123148, 218, 30, 'PPL', 'P'),
(76623, 'Moon', 33.8241691589355, 0.590343118574946, -94.5713882446289, -1.65058210305063, 218, 42, 'PPL', 'P'),
(104382, 'Moon', 37.4433288574219, 0.653509371469018, -76.2930603027344, -1.3315650987053, 218, 53, 'PPL', 'P'),
(164756, 'Moon', 40.5088882446289, 0.707013476191201, -80.2394409179688, -1.40044243397802, 218, 45, 'PPL', 'P'),
(175391, 'Moon', 44.771671295166, 0.781413075721281, -89.7877807617188, -1.56709240235081, 218, 57, 'PPL', 'P'),
(202392, 'Moon', 43.9463882446289, 0.767009169228506, -104.007781982422, -1.8152782432897, 218, 49, 'PPL', 'P'),
(89127, 'Moon (historical)', 35.2011108398438, 0.61437528451474, -87.6291732788086, -1.52941759451585, 218, 50, 'PPL', 'P'),
(191898, 'Moon Addition Colonia', 31.6620006561279, 0.552606159218037, -106.291000366211, -1.85512792162888, 218, 51, 'PPL', 'P'),
(191899, 'Moon Addition Number 2 Colonia', 31.6609992980957, 0.552588682223384, -106.292999267578, -1.85516280903916, 218, 51, 'PPL', 'P'),
(191900, 'Moon Addition Number 3 Colonia', 31.6639995574951, 0.552641046628317, -106.287002563477, -1.85505814680832, 218, 51, 'PPL', 'P'),
(191901, 'Moon Addition Number 4 Colonia', 31.6620006561279, 0.552606159218037, -106.287002563477, -1.85505814680832, 218, 51, 'PPL', 'P'),
(150838, 'Moon Beach', 43.3974990844727, 0.757429246155273, -76.6444396972656, -1.33769782606353, 218, 40, 'PPL', 'P'),
(104383, 'Moon Corner', 37.8683280944824, 0.660927007474189, -76.5480575561523, -1.33601564036098, 218, 53, 'PPL', 'P'),
(197088, 'Moon Creek (historical)', 46.1944389343262, 0.806245055515452, -106.047218322754, -1.85087312231331, 218, 31, 'PPL', 'P'),
(164757, 'Moon Crest', 40.5230598449707, 0.707260817277442, -80.1913909912109, -1.39960380455075, 218, 45, 'PPL', 'P'),
(60941, 'Moon Lake (historical)', 34.439998626709, 0.601091370418397, -90.4952774047852, -1.57944054821913, 218, 30, 'PPL', 'P'),
(37259, 'Moon Lake Estates', 38.2872200012207, 0.668238050456729, -84.561393737793, -1.4758747407998, 218, 21, 'PPL', 'P'),
(204969, 'Moon Lake Lodge', 40.5694389343262, 0.708070285090771, -110.50666809082, -1.92870520359337, 218, 52, 'PPL', 'P'),
(204970, 'Moon Lake Resort', 40.5613899230957, 0.70792980334327, -110.491668701172, -1.92844341485822, 218, 52, 'PPL', 'P'),
(204971, 'Moon Park', 41.0022201538086, 0.715623742311536, -111.902221679688, -1.95306220860713, 218, 52, 'PPL', 'P'),
(164758, 'Moon Run', 40.4530601501465, 0.706039092127368, -80.1097183227539, -1.39817834757729, 218, 45, 'PPL', 'P'),
(89128, 'Moon Shadows', 35.1930618286133, 0.614234802767238, -85.0652770996094, -1.48466916450952, 218, 50, 'PPL', 'P'),
(175392, 'Moon Valley', 43.3702812194824, 0.75695420479583, -89.6725006103516, -1.56508038414726, 218, 57, 'PPL', 'P'),
(178672, 'Moon Valley Canyon', 33.6375007629395, 0.587085140455398, -112.080833435059, -1.95617957182112, 218, 5, 'PPL', 'P'),
(178671, 'Moon Valley Mobile Home Estates', 33.6425018310547, 0.587172425560125, -112.053886413574, -1.95570925757261, 218, 5, 'PPL', 'P'),
(208173, 'Moona', 45.785831451416, 0.799113509590384, -120.104438781738, -2.0962179030013, 218, 56, 'PPL', 'P'),
(145805, 'Moonachie', 40.8411102294922, 0.712811843674576, -74.0455627441406, -1.2923388663773, 218, 37, 'PPL', 'P'),
(23168, 'Mooney', 34.2550010681152, 0.597862553912785, -83.8661117553711, -1.46373978097675, 218, 13, 'PPL', 'P'),
(89129, 'Mooney', 35.410831451416, 0.618035599695972, -87.8938903808594, -1.53403777953297, 218, 50, 'PPL', 'P'),
(183430, 'Mooney Flat', 39.2155609130859, 0.684440655949743, -121.273330688477, -2.1166189153738, 218, 6, 'PPL', 'P'),
(96306, 'Mooney Lane Colonia', 27.8910007476807, 0.486789794723228, -97.1849975585938, -1.69619819094011, 218, 51, 'PPL', 'P'),
(156592, 'Mooney Meadows Subdivision', 41.0675010681152, 0.716763109204899, -84.7286071777344, -1.47879316588037, 218, 41, 'PPL', 'P'),
(89130, 'Mooneyham', 35.7455596923828, 0.623877709600251, -85.3375015258789, -1.48942037705227, 218, 50, 'PPL', 'P'),
(49582, 'Moonglow Manor', 38.3080596923828, 0.668601771682606, -75.6097183227539, -1.31963853123754, 218, 25, 'PPL', 'P'),
(33332, 'Moonlight', 39.0027809143066, 0.680726944388655, -97.1022186279297, -1.69475342604874, 218, 20, 'PPL', 'P'),
(104386, 'Moonlight', 37.0336112976074, 0.646358451047019, -76.7225036621094, -1.33906029927722, 218, 53, 'PPL', 'P'),
(123244, 'Moonlight', 41.5844383239746, 0.725785366345869, -85.0311126708984, -1.48407288274145, 218, 19, 'PPL', 'P'),
(23171, 'Moonlight Forest', 33.6847190856934, 0.587909255654723, -84.2444381713867, -1.47034282258349, 218, 13, 'PPL', 'P'),
(183431, 'Moonlight Rim', 33.9625015258789, 0.592757473840185, -117.158058166504, -2.04479386024852, 218, 6, 'PPL', 'P'),
(183432, 'Moonridge', 34.235279083252, 0.597518340341892, -116.854721069336, -2.0394996291595, 218, 6, 'PPL', 'P'),
(187083, 'Moonridge', 39.3652801513672, 0.687053749611329, -105.116943359375, -1.83463676125348, 218, 7, 'PPL', 'P'),
(23169, 'Moons', 34.9305610656738, 0.609653300164948, -85.3486099243164, -1.48961425517963, 218, 13, 'PPL', 'P'),
(89131, 'Moons', 36.3722190856934, 0.634814979302071, -88.1194381713867, -1.53797433109827, 218, 50, 'PPL', 'P'),
(150840, 'Moons', 42.2836112976074, 0.737988236776721, -79.29638671875, -1.38398303317689, 218, 40, 'PPL', 'P'),
(27939, 'Moonshine', 39.190559387207, 0.684004297005134, -87.8955612182617, -1.53406694114691, 218, 18, 'PPL', 'P'),
(96307, 'Moonshine Hill', 30.0027809143066, 0.523647311709166, -95.2361068725586, -1.66218363170735, 218, 51, 'PPL', 'P'),
(193800, 'Moonstone', 41.0302810668945, 0.716113497636001, -124.108329772949, -2.16609898368887, 218, 6, 'PPL', 'P'),
(164760, 'Moonstown', 40.2813911437988, 0.703042902742974, -76.3072204589844, -1.33181224005446, 218, 45, 'PPL', 'P'),
(4304, 'Moontown', 34.7333297729492, 0.606210964718938, -86.4569396972656, -1.50895825891547, 218, 2, 'PPL', 'P'),
(82462, 'Moonville', 34.7169418334961, 0.605924941217864, -82.3877792358398, -1.43793801107162, 218, 48, 'PPL', 'P'),
(123245, 'Moonville', 40.1938896179199, 0.701515713015868, -85.6013870239258, -1.49402604784145, 218, 19, 'PPL', 'P'),
(200081, 'Moor', 41.1172218322754, 0.717630900246101, -114.814170837402, -2.00388530905993, 218, 39, 'PPL', 'P'),
(104387, 'Moor Green Estates', 38.7083282470703, 0.675587775854102, -77.4944381713867, -1.35253309807387, 218, 53, 'PPL', 'P'),
(209616, 'Moorcroft', 44.2633285522461, 0.772540821128709, -104.949722290039, -1.83171820301486, 218, 59, 'PPL', 'P'),
(10581, 'Moore', 35.7550010681152, 0.6240424926927, -92.9780578613281, -1.62277324178997, 218, 4, 'PPL', 'P'),
(23170, 'Moore', 34.2613906860352, 0.597974073783432, -83.9036102294922, -1.46439425281463, 218, 13, 'PPL', 'P'),
(37260, 'Moore', 37.3349990844727, 0.651618660253116, -84.8963928222656, -1.48172157781502, 218, 21, 'PPL', 'P'),
(42154, 'Moore', 31.8411102294922, 0.555732210995086, -92.5841674804688, -1.61589855775204, 218, 22, 'PPL', 'P'),
(76624, 'Moore', 35.3394393920898, 0.616789573200951, -97.4863891601563, -1.70145846672524, 218, 42, 'PPL', 'P'),
(78765, 'Moore', 39.8891716003418, 0.69619738031898, -75.3050003051758, -1.31432019854065, 218, 45, 'PPL', 'P'),
(82463, 'Moore', 34.8333282470703, 0.607956267339322, -81.9922180175781, -1.43103416541976, 218, 48, 'PPL', 'P'),
(96309, 'Moore', 29.0550003051758, 0.507105419493275, -99.0100021362305, -1.72805052968384, 218, 51, 'PPL', 'P'),
(110512, 'Moore', 39.084171295166, 0.682147474514104, -79.7180633544922, -1.39134267884932, 218, 58, 'PPL', 'P'),
(123246, 'Moore', 41.3969383239746, 0.72251287399838, -84.9524993896484, -1.48270082214784, 218, 19, 'PPL', 'P'),
(145806, 'Moore', 40.3241691589355, 0.703789519954578, -74.9150009155273, -1.30751342511052, 218, 37, 'PPL', 'P'),
(183433, 'Moore', 35.3894386291504, 0.617662224511143, -115.263610839844, -2.0117295168927, 218, 6, 'PPL', 'P'),
(192710, 'Moore', 38.9666709899902, 0.680096707316688, -111.152778625488, -1.93998195975515, 218, 52, 'PPL', 'P'),
(195342, 'Moore', 43.7358283996582, 0.763334206661278, -113.365562438965, -1.97860232293515, 218, 17, 'PPL', 'P'),
(197089, 'Moore', 46.9755592346191, 0.819878176609731, -109.696113586426, -1.91455835872482, 218, 31, 'PPL', 'P'),
(208174, 'Moore', 48.235279083252, 0.841864435621099, -120.614723205566, -2.10512404631874, 218, 56, 'PPL', 'P'),
(73527, 'Moore (historical)', 38.7986106872559, 0.677163501692075, -83.4283294677734, -1.45609903865125, 218, 41, 'PPL', 'P'),
(4305, 'Moore Corner', 33.5194396972656, 0.585024586140977, -86.6569366455078, -1.51244886415624, 218, 2, 'PPL', 'P'),
(212001, 'Moore Creek', 62.6005592346191, 1.09258587223385, -157.141937255859, -2.74264419807709, 218, 1, 'PPL', 'P'),
(82466, 'Moore Crossroads', 33.8505592346191, 0.590803712285476, -79.8399963378906, -1.39347081087641, 218, 48, 'PPL', 'P'),
(96310, 'Moore Grove', 30.5738906860352, 0.533615057616141, -95.541389465332, -1.66751181810027, 218, 51, 'PPL', 'P'),
(17175, 'Moore Haven', 26.8327808380127, 0.468320373089365, -81.0933303833008, -1.41534561659615, 218, 12, 'PPL', 'P'),
(37261, 'Moore Hill', 36.9355583190918, 0.644647103730534, -84.0813903808594, -1.46749710180069, 218, 21, 'PPL', 'P'),
(96311, 'Moore Hill', 30.6902809143066, 0.535646450316627, -95.0319366455078, -1.65862018901077, 218, 51, 'PPL', 'P'),
(73528, 'Moore Junction', 39.3791694641113, 0.687296163849554, -81.4986114501953, -1.42241910560946, 218, 41, 'PPL', 'P'),
(150841, 'Moore Landing', 44.3002815246582, 0.773185772165699, -75.9911117553711, -1.32629510238219, 218, 40, 'PPL', 'P'),
(132160, 'Moore Park', 42.0138893127441, 0.733280700075843, -85.6355590820313, -1.49462246276758, 218, 27, 'PPL', 'P'),
(189063, 'Moore Place', 32.8913917541504, 0.574063081673238, -108.986938476563, -1.90218091808451, 218, 38, 'PPL', 'P'),
(96313, 'Moore Road Colonia', 26.1639995574951, 0.456647937768629, -98.1289978027344, -1.71267410334, 218, 51, 'PPL', 'P'),
(96314, 'Moore Settlement', 30.0444393157959, 0.524374387976271, -94.6416702270508, -1.65180875504873, 218, 51, 'PPL', 'P'),
(96315, 'Moore Station', 32.1816711425781, 0.561676120232034, -95.5666732788086, -1.66795310389289, 218, 51, 'PPL', 'P'),
(4306, 'Moore Town', 32.5508308410645, 0.56811917243629, -88.1069412231445, -1.53775621820499, 218, 2, 'PPL', 'P'),
(43, 'Mooredale', 29.3105602264404, 0.51156578155548, -95.8280563354492, -1.6725150988402, 218, 51, 'PPL', 'P'),
(164762, 'Mooredale', 40.127498626709, 0.700356971625575, -77.2927780151367, -1.34901346437722, 218, 45, 'PPL', 'P'),
(4307, 'Moorefield', 32.8250007629395, 0.572904340282944, -85.4441680908203, -1.49128205981229, 218, 2, 'PPL', 'P'),
(10582, 'Moorefield', 35.7683296203613, 0.624275119813919, -91.5702819824219, -1.5982029175729, 218, 4, 'PPL', 'P'),
(30554, 'Moorefield', 38.8055610656738, 0.677284808679728, -85.170280456543, -1.48650181881365, 218, 19, 'PPL', 'P'),
(37262, 'Moorefield', 38.2730598449707, 0.667990909107569, -83.9311065673828, -1.46487415444307, 218, 21, 'PPL', 'P'),
(82464, 'Moorefield', 33.2886085510254, 0.580995822622932, -80.1688919067383, -1.39921112144802, 218, 48, 'PPL', 'P'),
(110513, 'Moorefield', 39.0622215270996, 0.681764378791296, -78.9697189331055, -1.37828160475719, 218, 58, 'PPL', 'P'),
(156593, 'Moorefield', 40.1997184753418, 0.701617445769509, -81.1711120605469, -1.41670316296182, 218, 41, 'PPL', 'P'),
(199543, 'Moorefield', 40.689998626709, 0.710174448668043, -100.398887634277, -1.75229115455796, 218, 35, 'PPL', 'P'),
(96316, 'Moorefield Acres Colonia', 26.3190002441406, 0.459353210093445, -98.3399963378906, -1.71635672249536, 218, 51, 'PPL', 'P'),
(120685, 'Moorefield Estates', 41.6497192382813, 0.726924733239232, -87.9436111450195, -1.53490557057417, 218, 18, 'PPL', 'P'),
(96317, 'Moorefield Grove Estates Colonia', 26.2900009155273, 0.458847076328276, -98.3450012207031, -1.71644407417911, 218, 51, 'PPL', 'P'),
(189064, 'Moorehead Place', 34.6305618286133, 0.60441732572477, -106.27082824707, -1.85477585173277, 218, 38, 'PPL', 'P'),
(30555, 'Mooreland', 39.997501373291, 0.698088091534882, -85.251106262207, -1.48791249524307, 218, 19, 'PPL', 'P'),
(76628, 'Mooreland', 36.4391708374023, 0.63598350780937, -99.2044372558594, -1.73144406270287, 218, 42, 'PPL', 'P'),
(104388, 'Mooreland', 37.5688896179199, 0.655700820151017, -77.5988922119141, -1.35435616499809, 218, 53, 'PPL', 'P'),
(89133, 'Mooreland Estates', 35.9716682434082, 0.627824048282558, -86.8180618286133, -1.51526102910931, 218, 50, 'PPL', 'P'),
(104389, 'Mooreland Farms', 37.5733299255371, 0.655778318138738, -77.5908279418945, -1.35421541693448, 218, 53, 'PPL', 'P'),
(89134, 'Mooreland Heights', 35.916389465332, 0.62685925159865, -83.8894424438477, -1.46414697830742, 218, 50, 'PPL', 'P'),
(23172, 'Moores', 32.5183296203613, 0.567551919124103, -82.9897232055664, -1.44844391525588, 218, 13, 'PPL', 'P'),
(104390, 'Moores', 37.1266708374023, 0.647982646416831, -76.4102783203125, -1.3336109390547, 218, 53, 'PPL', 'P'),
(27940, 'Moores (historical)', 39.499439239502, 0.689395267420754, -91.0124969482422, -1.58846773220812, 218, 18, 'PPL', 'P'),
(66938, 'Moores (historical)', 35.7552795410156, 0.62404735296169, -81.0880584716797, -1.41525360438049, 218, 33, 'PPL', 'P'),
(89135, 'Moores (historical)', 35.9674987792969, 0.627751277405772, -86.8166732788086, -1.51523679434339, 218, 50, 'PPL', 'P'),
(197090, 'Moores (historical)', 45.2686080932617, 0.790086259022369, -105.596672058105, -1.84300960656264, 218, 31, 'PPL', 'P'),
(14263, 'Moores Acres', 39.6186103820801, 0.691475196232106, -75.6638870239258, -1.32058395342452, 218, 10, 'PPL', 'P'),
(66939, 'Moores Beach', 35.398609161377, 0.617822280492657, -76.6233291625977, -1.33732937772672, 218, 33, 'PPL', 'P'),
(4309, 'Moores Bridge', 33.4486083984375, 0.583788346762962, -87.7936096191406, -1.53228755006457, 218, 2, 'PPL', 'P'),
(89136, 'Moores Camp', 36.1494407653809, 0.630926764110555, -84.3858337402344, -1.47281064080761, 218, 50, 'PPL', 'P'),
(66940, 'Moores Chapel', 35.6819381713867, 0.622767304583743, -78.1902770996094, -1.36467777843491, 218, 33, 'PPL', 'P'),
(89137, 'Moores Chapel', 35.9422187805176, 0.627310058192173, -88.8502807617188, -1.55072994061337, 218, 50, 'PPL', 'P'),
(14264, 'Moores Corner', 39.2094383239746, 0.684333796611004, -75.605827331543, -1.31957062062974, 218, 10, 'PPL', 'P'),
(66941, 'Moores Corner', 35.0458297729492, 0.611665118631421, -76.6913909912109, -1.33851728073095, 218, 33, 'PPL', 'P'),
(71130, 'Moores Corner', 39.5544395446777, 0.690355203835673, -75.466667175293, -1.31714181771559, 218, 37, 'PPL', 'P'),
(82465, 'Moores Corner', 33.0999984741211, 0.577703955778512, -79.4691696166992, -1.38699866363724, 218, 48, 'PPL', 'P'),
(104392, 'Moores Corner', 38.4508285522461, 0.671093558356539, -77.4888916015625, -1.35243629216825, 218, 53, 'PPL', 'P'),
(120686, 'Moores Corner', 40.2663917541504, 0.702781114007819, -87.6519393920898, -1.52981493815048, 218, 18, 'PPL', 'P'),
(125475, 'Moores Corner', 42.4944381713867, 0.741667859875857, -72.4688873291016, -1.26482068914962, 218, 23, 'PPL', 'P'),
(208175, 'Moores Corner', 46.3461112976074, 0.808892237638991, -124.040000915527, -2.16490642015273, 218, 56, 'PPL', 'P'),
(125476, 'Moores Corners', 42.4333305358887, 0.740601330438307, -71.8125, -1.25336456908843, 218, 23, 'PPL', 'P'),
(156595, 'Moores Corners', 40.0591697692871, 0.699164408089437, -82.9533309936523, -1.44780875133589, 218, 41, 'PPL', 'P'),
(164763, 'Moores Corners', 41.0402793884277, 0.716288001266429, -80.1108322143555, -1.39819778865324, 218, 45, 'PPL', 'P'),
(37263, 'Moores Creek', 37.2830581665039, 0.650712120218053, -83.995002746582, -1.46598935314954, 218, 21, 'PPL', 'P'),
(96318, 'Moores Crossing', 30.1686096191406, 0.526541568602836, -97.6636123657227, -1.70455159517331, 218, 51, 'PPL', 'P'),
(4312, 'Moores Crossroads', 33.1505584716797, 0.57858639420571, -86.8263931274414, -1.51540643770483, 218, 2, 'PPL', 'P'),
(23174, 'Moores Crossroads', 31.7444400787354, 0.55404499857598, -85.017219543457, -1.4838304019242, 218, 13, 'PPL', 'P'),
(66943, 'Moores Crossroads', 35.6588897705078, 0.622365034101086, -78.0550003051758, -1.3623167529705, 218, 33, 'PPL', 'P'),
(82472, 'Moores Crossroads', 32.978889465332, 0.575590204821316, -81.3258285522461, -1.41940347514911, 218, 48, 'PPL', 'P'),
(183435, 'Moores Flat', 39.4191703796387, 0.687994311529318, -120.849716186523, -2.10922544755552, 218, 6, 'PPL', 'P'),
(73530, 'Moores Fork', 39.1963882446289, 0.684106029758775, -84.0227813720703, -1.46647418162599, 218, 41, 'PPL', 'P'),
(30560, 'Moores Hill', 39.1133308410645, 0.682656404598418, -85.0880584716797, -1.48506677446026, 218, 19, 'PPL', 'P'),
(73531, 'Moores Junction', 39.7030601501465, 0.69294912273741, -82.1163864135742, -1.43320131275681, 218, 41, 'PPL', 'P'),
(14265, 'Moores Lake Development', 39.125, 0.682860069842781, -75.517219543457, -1.31802412298473, 218, 10, 'PPL', 'P'),
(82467, 'Moores Landing', 32.9397201538086, 0.574906571369493, -79.6575012207031, -1.39028567021267, 218, 48, 'PPL', 'P'),
(4313, 'Moores Mill', 34.8438911437988, 0.608140624665783, -86.5183334350586, -1.51002978178007, 218, 2, 'PPL', 'P'),
(10584, 'Moores Mill', 33.2938919067383, 0.581088034575676, -92.0074996948242, -1.60583380620236, 218, 4, 'PPL', 'P'),
(49584, 'Moores Mill', 39.5491714477539, 0.690263258199038, -76.3386077880859, -1.33236005229069, 218, 25, 'PPL', 'P'),
(60942, 'Moores Mill', 34.4819412231445, 0.601823406823033, -88.3263931274414, -1.54158637648474, 218, 30, 'PPL', 'P'),
(71131, 'Moores Mill', 39.8613891601563, 0.695712485263504, -74.7255630493164, -1.30420711061719, 218, 37, 'PPL', 'P'),
(104393, 'Moores Mill', 37.9183311462402, 0.661799725363408, -76.6588897705078, -1.33795002741876, 218, 53, 'PPL', 'P'),
(150842, 'Moores Mill', 41.7041702270508, 0.727875082274227, -73.7491683959961, -1.28716580911788, 218, 40, 'PPL', 'P'),
(116916, 'Moores Siding (historical)', 43.459171295166, 0.758505629288855, -94.1277770996094, -1.6428396279715, 218, 16, 'PPL', 'P'),
(66944, 'Moores Springs', 36.4211082458496, 0.635668256115332, -80.2891693115234, -1.40131035817727, 218, 33, 'PPL', 'P'),
(4314, 'Moores Valley', 32.0608291625977, 0.559567029806746, -87.629997253418, -1.52943197558573, 218, 2, 'PPL', 'P'),
(66945, 'Mooresboro', 35.2986106872559, 0.616076977872273, -81.6991729736328, -1.42591956454626, 218, 33, 'PPL', 'P'),
(89138, 'Mooresburg', 36.3463897705078, 0.634364172708548, -83.2283325195313, -1.45260843341049, 218, 50, 'PPL', 'P'),
(164764, 'Mooresburg', 40.982780456543, 0.71528445558866, -76.7050018310547, -1.33875483470018, 218, 45, 'PPL', 'P'),
(89139, 'Mooresburg Springs', 36.371940612793, 0.634810119033081, -83.2305603027344, -1.4526473155624, 218, 50, 'PPL', 'P'),
(49589, 'Mooresfield', 39.1616706848145, 0.683500094031755, -76.9208297729492, -1.34252174290405, 218, 25, 'PPL', 'P'),
(169491, 'Mooresfield', 41.4905586242676, 0.724146856485198, -71.4883270263672, -1.24770668335255, 218, 47, 'PPL', 'P'),
(30556, 'Moorestown', 38.7186088562012, 0.675767206332546, -86.6158294677734, -1.51173140855857, 218, 19, 'PPL', 'P'),
(71132, 'Moorestown', 39.9669418334961, 0.697554726947566, -74.9430618286133, -1.30800318043498, 218, 37, 'PPL', 'P'),
(132162, 'Moorestown', 44.4658317565918, 0.776075168790381, -85.0019378662109, -1.48356368634102, 218, 27, 'PPL', 'P'),
(164765, 'Moorestown', 40.7786102294922, 0.711721012892079, -75.370002746582, -1.31545470516503, 218, 45, 'PPL', 'P'),
(4315, 'Mooresville', 34.6283302307129, 0.604378376993828, -86.8802795410156, -1.51634693304379, 218, 2, 'PPL', 'P'),
(30557, 'Mooresville', 39.6127815246582, 0.691373463478465, -86.3741683959961, -1.50751362718216, 218, 19, 'PPL', 'P'),
(37264, 'Mooresville', 37.7988891601563, 0.659715069441121, -85.2652816772461, -1.48815990290834, 218, 21, 'PPL', 'P'),
(56363, 'Mooresville', 39.7452812194824, 0.693686019411035, -93.7174987792969, -1.6356789204325, 218, 29, 'PPL', 'P'),
(66946, 'Mooresville', 35.5847206115723, 0.621070538074226, -80.8102798461914, -1.41040545277406, 218, 33, 'PPL', 'P'),
(73532, 'Mooresville', 39.3277816772461, 0.686399277773442, -82.8513870239258, -1.44602949341161, 218, 41, 'PPL', 'P'),
(89140, 'Mooresville', 35.439998626709, 0.618544662938341, -86.9141693115234, -1.5169384211219, 218, 50, 'PPL', 'P'),
(110515, 'Mooresville', 39.689998626709, 0.6927211561481, -80.1483306884766, -1.39885226049113, 218, 58, 'PPL', 'P'),
(128180, 'Mooresville', 45.4141693115234, 0.79262678154425, -69.1002807617188, -1.20602741334449, 218, 26, 'PPL', 'P'),
(164766, 'Mooresville', 40.6375007629395, 0.709258188095001, -77.9627838134766, -1.36070727156571, 218, 45, 'PPL', 'P'),
(10586, 'Mooresville (historical)', 35.0077781677246, 0.611000992834582, -91.6947174072266, -1.60037472544186, 218, 4, 'PPL', 'P'),
(104394, 'Mooresville Estates', 36.6827812194824, 0.640235311068709, -78.5791702270508, -1.37146524394714, 218, 53, 'PPL', 'P'),
(140532, 'Mooreton', 46.2686080932617, 0.807539551542313, -96.8758316040039, -1.69080222709745, 218, 34, 'PPL', 'P'),
(66947, 'Mooretown', 34.4136085510254, 0.600630776707868, -77.8274993896484, -1.35834611294324, 218, 33, 'PPL', 'P'),
(89141, 'Mooretown', 35.7433280944824, 0.623838760869309, -86.0541687011719, -1.5019285789021, 218, 50, 'PPL', 'P'),
(104395, 'Mooretown', 38.1041717529297, 0.665043255834042, -79.9013900756836, -1.394542333741, 218, 53, 'PPL', 'P'),
(60943, 'Mooreville', 34.2675018310547, 0.59808073338509, -88.5766677856445, -1.54595449330469, 218, 30, 'PPL', 'P'),
(96319, 'Mooreville', 31.3019409179688, 0.546321931283291, -97.1405563354492, -1.69542254527263, 218, 51, 'PPL', 'P'),
(113743, 'Mooreville', 41.9094390869141, 0.731457699730656, -73.0605621337891, -1.27514736259251, 218, 8, 'PPL', 'P'),
(132163, 'Mooreville', 42.1030616760254, 0.734837051416885, -83.7333297729492, -1.46142229819616, 218, 27, 'PPL', 'P'),
(116917, 'Mooreville (historical)', 42.2455596923828, 0.737324110979883, -92.3002777099609, -1.61094374654395, 218, 16, 'PPL', 'P'),
(76630, 'Moorewood', 35.7402801513672, 0.623785564226535, -99.3486099243164, -1.73396035045884, 218, 42, 'PPL', 'P'),
(60944, 'Moorhead', 33.4500007629395, 0.583812648107909, -90.5055618286133, -1.5796200452766, 218, 30, 'PPL', 'P'),
(116918, 'Moorhead', 41.9225006103516, 0.731685666319967, -95.8511123657227, -1.67291750248091, 218, 16, 'PPL', 'P'),
(136953, 'Moorhead', 46.8738899230957, 0.818103712375412, -96.767219543457, -1.68890658903353, 218, 28, 'PPL', 'P'),
(164767, 'Moorhead', 42.1858291625977, 0.736281616571171, -79.9036102294922, -1.39458108273486, 218, 45, 'PPL', 'P'),
(197091, 'Moorhead', 45.064998626709, 0.786532603442795, -105.870559692383, -1.84778984756128, 218, 31, 'PPL', 'P'),
(164768, 'Moorheadville', 42.1919403076172, 0.736388276172829, -79.9102783203125, -1.3946974628745, 218, 45, 'PPL', 'P'),
(150843, 'Moorhouse Corner', 42.3494415283203, 0.739137191050009, -73.5713882446289, -1.28406296013183, 218, 40, 'PPL', 'P'),
(89144, 'Mooring', 36.3138885498047, 0.633796919396361, -89.5158309936523, -1.56234598349802, 218, 50, 'PPL', 'P'),
(96320, 'Mooring', 30.6894397735596, 0.535631769641117, -96.5552825927734, -1.68520759143746, 218, 51, 'PPL', 'P'),
(104396, 'Moorings', 37.0947189331055, 0.647424980484569, -76.8638916015625, -1.34152798434328, 218, 53, 'PPL', 'P'),
(49585, 'Moorings on the Magothy', 39.0708312988281, 0.681914647655803, -76.5016708374023, -1.3352060393896, 218, 25, 'PPL', 'P'),
(42155, 'Mooringsport', 32.6875, 0.570504499245647, -93.9608306884766, -1.63992586342285, 218, 22, 'PPL', 'P'),
(37265, 'Moorland', 38.2722206115723, 0.667976261721574, -85.583610534668, -1.49371578957446, 218, 21, 'PPL', 'P'),
(49586, 'Moorland', 39.5611114501953, 0.690471650554337, -76.3047180175781, -1.33176856421258, 218, 25, 'PPL', 'P'),
(116919, 'Moorland', 42.4416694641113, 0.74074687219188, -94.2947235107422, -1.64575339252016, 218, 16, 'PPL', 'P'),
(132164, 'Moorland', 43.228328704834, 0.754476666033729, -85.9877777099609, -1.50076983751181, 218, 27, 'PPL', 'P'),
(208176, 'Moorland', 47.6055603027344, 0.830873769539423, -122.211669921875, -2.13299602449724, 218, 56, 'PPL', 'P'),
(208177, 'Moorlands', 47.7438888549805, 0.833288058225635, -122.240829467773, -2.13350495458155, 218, 56, 'PPL', 'P'),
(37266, 'Moorman', 37.3833312988281, 0.652462216528399, -87.144172668457, -1.52095273699103, 218, 21, 'PPL', 'P'),
(89142, 'Moorman', 35.3111114501953, 0.616295157344578, -89.3874969482422, -1.56010613186321, 218, 50, 'PPL', 'P'),
(183436, 'Moorpark', 34.2855606079102, 0.598395918500101, -118.88111114502, -2.07486680790992, 218, 6, 'PPL', 'P'),
(183437, 'Moorpark Home Acres', 34.2655601501465, 0.598046844660219, -118.914169311523, -2.07544378176008, 218, 6, 'PPL', 'P'),
(56365, 'Moors', 39.7194404602051, 0.69323501308043, -94.3919372558594, -1.64745009245065, 218, 29, 'PPL', 'P'),
(164769, 'Moors Mill', 40.1152801513672, 0.700143719001287, -77.2816696166992, -1.34881958624987, 218, 45, 'PPL', 'P'),
(209617, 'Moose', 43.6558303833008, 0.761937977880777, -110.717498779297, -1.93238489327153, 218, 59, 'PPL', 'P'),
(195343, 'Moose City', 46.7869415283203, 0.816586176607257, -115.107498168945, -2.00900483678144, 218, 17, 'PPL', 'P'),
(212249, 'Moose Creek', 64.7099990844727, 1.12940254298656, -147.143615722656, -2.56814056764965, 218, 1, 'PPL', 'P'),
(175394, 'Moose Junction', 46.2874984741211, 0.807869250885264, -92.1547164916992, -1.60840322402207, 218, 57, 'PPL', 'P'),
(136957, 'Moose Lake', 46.4541702270508, 0.810778221743958, -92.7616729736328, -1.61899661304813, 218, 28, 'PPL', 'P'),
(212002, 'Moose Pass', 60.4874992370605, 1.05570601798426, -149.368896484375, -2.60697904372293, 218, 1, 'PPL', 'P'),
(128181, 'Moose River', 45.6527786254883, 0.796791299698862, -70.2666702270508, -1.22638474987511, 218, 26, 'PPL', 'P'),
(197092, 'Moose Town', 45.7761116027832, 0.798943866228946, -112.567222595215, -1.96466866411186, 218, 31, 'PPL', 'P'),
(209618, 'Moose Wilson Road', 43.5252799987793, 0.759659443831132, -110.843887329102, -1.93459078960245, 218, 59, 'PPL', 'P'),
(128183, 'Moosehead', 45.5833282470703, 0.795579161928712, -69.7141723632813, -1.21674184304209, 218, 26, 'PPL', 'P'),
(164770, 'Moosehead', 41.1197204589844, 0.717674509508951, -75.7936096191406, -1.32284803982525, 218, 45, 'PPL', 'P'),
(120687, 'Mooseheart', 41.8238906860352, 0.729964598465503, -88.334716796875, -1.54173165192221, 218, 18, 'PPL', 'P'),
(128184, 'Moosehorn', 45.2286109924316, 0.789388177921632, -69.4863891601563, -1.21276627616682, 218, 26, 'PPL', 'P'),
(128185, 'Moosehorn (historical)', 45.3855590820313, 0.79212743883986, -70.7947235107422, -1.23560101830149, 218, 26, 'PPL', 'P'),
(197093, 'Moosehorn (historical)', 45.5361099243164, 0.794755046729387, -113.738327026367, -1.98510829232016, 218, 31, 'PPL', 'P'),
(169492, 'Moosehorn Corner', 41.6533317565918, 0.72698778357804, -71.5430603027344, -1.24866195923557, 218, 47, 'PPL', 'P'),
(128186, 'Moosehorn Crossing', 46.3313903808594, 0.808635309172826, -68.7816696166992, -1.20046659983035, 218, 26, 'PPL', 'P'),
(128187, 'Mooselookmeguntic', 44.9633293151855, 0.784758139208475, -70.793327331543, -1.23557665037752, 218, 26, 'PPL', 'P'),
(164774, 'Moosic', 41.353328704834, 0.721751742558835, -75.7386093139648, -1.32188810341033, 218, 45, 'PPL', 'P'),
(113744, 'Moosup', 41.7127799987793, 0.728025351138735, -71.8813934326172, -1.2545669863206, 218, 8, 'PPL', 'P'),
(169493, 'Moosup Valley', 41.7369384765625, 0.728446996118322, -71.7611083984375, -1.25246761643329, 218, 47, 'PPL', 'P'),
(210736, 'Mopua', 20.8141708374023, 0.363275812185256, -156.614440917969, -2.73343765018869, 218, 15, 'PPL', 'P'),
(175397, 'Moquah', 46.5705604553223, 0.812809614444443, -91.0830612182617, -1.58969931105422, 218, 57, 'PPL', 'P'),
(178673, 'Moqui', 35.0605583190918, 0.61192218025564, -110.815277099609, -1.93409144689806, 218, 5, 'PPL', 'P'),
(189065, 'Moquino', 35.1725006103516, 0.61387594181035, -107.36833190918, -1.87393090418927, 218, 38, 'PPL', 'P'),
(23175, 'Mora', 31.413890838623, 0.548275825996055, -82.9538879394531, -1.44781847187387, 218, 13, 'PPL', 'P'),
(42156, 'Mora', 31.3730602264404, 0.547563197377863, -92.9477767944336, -1.62224473747165, 218, 22, 'PPL', 'P'),
(56366, 'Mora', 38.523609161377, 0.672363819617479, -93.2155609130859, -1.62691845202668, 218, 29, 'PPL', 'P'),
(136965, 'Mora', 45.8769416809082, 0.80070368307727, -93.2936096191406, -1.62828065892426, 218, 28, 'PPL', 'P'),
(177716, 'Mora', 35.9741706848145, 0.627867724124435, -105.329437255859, -1.83834547938753, 218, 38, 'PPL', 'P'),
(195344, 'Mora', 43.4597206115723, 0.75851521666878, -116.35221862793, -2.03072930705765, 218, 17, 'PPL', 'P'),
(208178, 'Mora', 47.9213905334473, 0.836386046942697, -124.616668701172, -2.17497117170241, 218, 56, 'PPL', 'P'),
(183438, 'Morada', 38.0386085510254, 0.663898962092663, -121.244720458984, -2.11611957266941, 218, 6, 'PPL', 'P'),
(164772, 'Morado', 40.7880592346191, 0.711885929142582, -80.3330612182617, -1.40207641646483, 218, 45, 'PPL', 'P'),
(177637, 'Morado Encanto', 33.6508293151855, 0.587317767576616, -112.135276794434, -1.95712978769806, 218, 5, 'PPL', 'P'),
(183439, 'Moraga', 37.8349990844727, 0.660345306513088, -122.128608703613, -2.13154633275786, 218, 6, 'PPL', 'P'),
(4316, 'Moragne', 34.0294418334961, 0.593925802610403, -86.1111068725586, -1.50292233746286, 218, 2, 'PPL', 'P'),
(73533, 'Moraine', 39.7061080932617, 0.693002319380185, -84.2194366455078, -1.46990646363888, 218, 41, 'PPL', 'P'),
(96321, 'Morales', 29.1272201538086, 0.508365893637209, -96.7622222900391, -1.68881937050783, 218, 51, 'PPL', 'P'),
(96322, 'Morales - Sanchez Colonia', 26.7810001373291, 0.467416629373446, -99.1220016479492, -1.73000528992396, 218, 51, 'PPL', 'P'),
(191903, 'Morales Circle Colonia', 28.6889991760254, 0.500717494723583, -100.480003356934, -1.75370689099345, 218, 51, 'PPL', 'P'),
(191907, 'Morales Number 2 East Colonia', 28.6800003051758, 0.500560434798296, -100.467002868652, -1.75347998966857, 218, 51, 'PPL', 'P'),
(191904, 'Morales Number 2 West Colonia', 28.6800003051758, 0.500560434798296, -100.481002807617, -1.75372433469859, 218, 51, 'PPL', 'P'),
(191905, 'Morales Number 2A Colonia', 28.6830005645752, 0.50061279920323, -100.471000671387, -1.75354976448913, 218, 51, 'PPL', 'P'),
(191906, 'Morales Number 3 Colonia', 28.6800003051758, 0.500560434798296, -100.483001708984, -1.75375922210887, 218, 51, 'PPL', 'P'),
(89143, 'Moralfa', 35.7922210693359, 0.624692104261598, -84.1044387817383, -1.46789937228334, 218, 50, 'PPL', 'P'),
(23176, 'Morallion Hills', 33.3583297729492, 0.582212687504016, -84.5449981689453, -1.47558858414067, 218, 13, 'PPL', 'P'),
(42157, 'Morameal', 32.3666687011719, 0.564904936737646, -93.5699996948242, -1.63310457576477, 218, 22, 'PPL', 'P'),
(10585, 'Moran', 35.7411117553711, 0.623800078454476, -89.9636077880859, -1.57016116287491, 218, 4, 'PPL', 'P'),
(23177, 'Moran', 32.8486099243164, 0.573316397882607, -83.9319381713867, -1.46488866867101, 218, 13, 'PPL', 'P'),
(33335, 'Moran', 37.9161109924316, 0.661760976369547, -95.1699981689453, -1.66102981716507, 218, 20, 'PPL', 'P'),
(96323, 'Moran', 32.5475006103516, 0.568061048945499, -99.1655578613281, -1.73076548925712, 218, 51, 'PPL', 'P'),
(104397, 'Moran', 37.2291717529297, 0.649771624879092, -78.2597198486328, -1.365889783047, 218, 53, 'PPL', 'P'),
(116922, 'Moran', 41.8108291625977, 0.729736631876193, -93.9075012207031, -1.63899508862186, 218, 16, 'PPL', 'P'),
(123247, 'Moran', 40.3875007629395, 0.704894864965015, -86.5152816772461, -1.50997651855827, 218, 19, 'PPL', 'P'),
(132166, 'Moran', 45.9941711425781, 0.802749723163751, -84.8308334350586, -1.48057735065266, 218, 27, 'PPL', 'P'),
(156605, 'Moran', 41.2638893127441, 0.720190730685885, -81.3886108398438, -1.42049923277962, 218, 41, 'PPL', 'P'),
(193801, 'Moran', 40.901668548584, 0.713868785732201, -120.489166259766, -2.10293266421577, 218, 6, 'PPL', 'P'),
(209619, 'Moran', 43.8416709899902, 0.765181508351412, -110.506942749023, -1.92870999728333, 218, 59, 'PPL', 'P'),
(150844, 'Moran Corner', 42.9602813720703, 0.749798357525814, -77.6202774047852, -1.35472940702486, 218, 40, 'PPL', 'P'),
(120689, 'Moran Corners', 42.290828704834, 0.738114204296282, -87.8872222900391, -1.53392139939333, 218, 18, 'PPL', 'P'),
(37267, 'Moranburg', 38.6711082458496, 0.674938164285204, -83.8130569458008, -1.46281379986573, 218, 21, 'PPL', 'P'),
(128188, 'Morang Corner', 44.2638893127441, 0.772550608245715, -69.2750015258789, -1.20907686595068, 218, 26, 'PPL', 'P'),
(164773, 'Morann', 40.7863883972168, 0.711856767528646, -78.3672180175781, -1.36776598003496, 218, 45, 'PPL', 'P'),
(49587, 'Morantown', 39.6786117553711, 0.692522417751752, -78.89111328125, -1.37690967732164, 218, 25, 'PPL', 'P'),
(104398, 'Morattico', 37.7891693115234, 0.659545426079683, -76.6294403076172, -1.33743603732838, 218, 53, 'PPL', 'P'),
(66948, 'Moratuc (historical)', 35.8572196960449, 0.625826544306944, -76.7766723632813, -1.34000572146419, 218, 33, 'PPL', 'P'),
(76631, 'Moravia', 35.1191711425781, 0.612945167009367, -99.5097198486328, -1.7367722490958, 218, 42, 'PPL', 'P'),
(96324, 'Moravia', 29.5894393920898, 0.516433141211277, -96.9847183227539, -1.69270265885133, 218, 51, 'PPL', 'P'),
(113320, 'Moravia', 40.9211082458496, 0.714208072455077, -80.3763885498047, -1.40283262105636, 218, 45, 'PPL', 'P'),
(116920, 'Moravia', 40.8908309936523, 0.713679634715778, -92.8150024414063, -1.61992738784911, 218, 16, 'PPL', 'P'),
(150845, 'Moravia', 42.7125015258789, 0.745473783389689, -76.4219436645508, -1.33381453772003, 218, 40, 'PPL', 'P'),
(193152, 'Moravia', 48.6483306884766, 0.849073546112916, -116.378059387207, -2.03118031338826, 218, 17, 'PPL', 'P'),
(66949, 'Moravian Falls', 36.0966682434082, 0.630005709847551, -81.182502746582, -1.4169019679372, 218, 33, 'PPL', 'P'),
(156596, 'Moraville (historical)', 40.2852783203125, 0.703110746771744, -81.0844421386719, -1.41519048746266, 218, 41, 'PPL', 'P'),
(33336, 'Moray', 39.7625007629395, 0.693986557140051, -95.17138671875, -1.66105405193099, 218, 20, 'PPL', 'P'),
(42158, 'Morbihan', 30.0116691589355, 0.523802440842663, -91.7744369506836, -1.60176609395337, 218, 22, 'PPL', 'P'),
(164775, 'Mordansville', 41.0669403076172, 0.716753322087893, -76.498893737793, -1.33515756985776, 218, 45, 'PPL', 'P'),
(27942, 'Morea', 38.9266700744629, 0.679398559636924, -87.6322174072266, -1.52947072457959, 218, 18, 'PPL', 'P'),
(164776, 'Morea', 40.7894401550293, 0.711910030750448, -76.1716690063477, -1.32944642090008, 218, 45, 'PPL', 'P'),
(202394, 'Moreau', 45.3558311462402, 0.791608588480486, -100.397499084473, -1.75226691979204, 218, 49, 'PPL', 'P'),
(42159, 'Moreauville', 31.0344390869141, 0.541653143576273, -91.9755630493164, -1.60527640658621, 218, 22, 'PPL', 'P'),
(37268, 'Moree', 37.7188911437988, 0.65831884066062, -82.5044403076172, -1.43997413088304, 218, 21, 'PPL', 'P'),
(104399, 'Morefield', 36.9136085510254, 0.644264008007726, -82.3022232055664, -1.43644477664842, 218, 53, 'PPL', 'P'),
(104400, 'Morefield Mill', 36.9472198486328, 0.644850635816844, -78.966667175293, -1.37822834153539, 218, 53, 'PPL', 'P'),
(120690, 'Morehaven', 42.4244384765625, 0.740446134725783, -89.0233306884766, -1.55375023160563, 218, 18, 'PPL', 'P'),
(33337, 'Morehead', 37.3841705322266, 0.652476863914394, -95.5074996948242, -1.66692033002216, 218, 20, 'PPL', 'P'),
(37271, 'Morehead', 37.271110534668, 0.6505035947047, -87.1763916015625, -1.5215150634552, 218, 21, 'PPL', 'P'),
(66951, 'Morehead City', 34.7227783203125, 0.606026807129559, -76.7263870239258, -1.33912807672696, 218, 33, 'PPL', 'P'),
(56369, 'Morehouse', 36.8472213745117, 0.64310533319646, -89.6852798461914, -1.56530342388855, 218, 29, 'PPL', 'P'),
(156597, 'Morehouse (historical)', 40.4069404602051, 0.705234151687891, -82.9008331298828, -1.44689249076285, 218, 41, 'PPL', 'P'),
(145808, 'Morehousetown', 40.7966690063477, 0.71203619800709, -74.3413925170898, -1.29750206994069, 218, 37, 'PPL', 'P'),
(150849, 'Morehouseville', 43.3908309936523, 0.757312866015636, -74.774169921875, -1.30505546058243, 218, 40, 'PPL', 'P'),
(197095, 'Morel', 46.1505584716797, 0.805479196964973, -112.766937255859, -1.96815434250461, 218, 31, 'PPL', 'P'),
(4318, 'Moreland', 34.2411117553711, 0.597620139674561, -87.3005599975586, -1.52368221079225, 218, 2, 'PPL', 'P'),
(10587, 'Moreland', 35.3675003051758, 0.617279328525417, -92.9983291625977, -1.62312704274079, 218, 4, 'PPL', 'P'),
(23178, 'Moreland', 33.2866706848145, 0.580962000477088, -84.7677764892578, -1.47947679933219, 218, 13, 'PPL', 'P'),
(37270, 'Moreland', 37.5055618286133, 0.654595541719607, -84.8133316040039, -1.48027188607563, 218, 21, 'PPL', 'P'),
(42162, 'Moreland', 31.1966705322266, 0.544484616447245, -92.4230575561523, -1.61308665911508, 218, 22, 'PPL', 'P'),
(82469, 'Moreland', 32.7833290100098, 0.572177030989243, -79.9736099243164, -1.39580280788493, 218, 48, 'PPL', 'P'),
(150850, 'Moreland', 42.3077812194824, 0.73841008149339, -76.9072189331055, -1.34228418893481, 218, 40, 'PPL', 'P'),
(156599, 'Moreland', 40.7125015258789, 0.710567198349802, -81.9444427490234, -1.43020032968245, 218, 41, 'PPL', 'P'),
(164777, 'Moreland', 41.1891708374023, 0.718886647279101, -76.6524963378906, -1.33783844096909, 218, 45, 'PPL', 'P'),
(195345, 'Moreland', 43.2227783203125, 0.754379793549077, -112.441673278809, -1.96247741516694, 218, 17, 'PPL', 'P'),
(156600, 'Moreland Corners', 40.0252799987793, 0.698572920011331, -82.6999969482422, -1.44338723813609, 218, 41, 'PPL', 'P'),
(156601, 'Moreland Hills', 41.4477806091309, 0.723400239273594, -81.4277801513672, -1.42118286623144, 218, 41, 'PPL', 'P'),
(82470, 'Moreland Landing', 33.0094413757324, 0.576123436250577, -79.9000015258789, -1.39451809897508, 218, 48, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(183440, 'Moreland Mill', 35.5072212219238, 0.619717918556575, -118.35417175293, -2.06566998055949, 218, 6, 'PPL', 'P'),
(17176, 'Moreland Park', 28.8891696929932, 0.50421112931009, -82.0419387817383, -1.43190195646096, 218, 12, 'PPL', 'P'),
(10589, 'Morelock (historical)', 35.0602798461914, 0.611917319986651, -91.1216735839844, -1.59037322396807, 218, 4, 'PPL', 'P'),
(89146, 'Morelock (historical)', 36.2944412231445, 0.63345749951543, -82.8949966430664, -1.44679062485116, 218, 50, 'PPL', 'P'),
(183441, 'Morena', 32.7808303833008, 0.572133421726393, -117.206939697266, -2.04564700390373, 218, 6, 'PPL', 'P'),
(183444, 'Morena Village', 32.6794395446777, 0.570363817761063, -116.504173278809, -2.03338141602921, 218, 6, 'PPL', 'P'),
(132168, 'Morenci', 41.7194404602051, 0.728141598120317, -84.2180633544922, -1.46988249518907, 218, 27, 'PPL', 'P'),
(178674, 'Morenci', 33.0786094665527, 0.57733064717271, -109.364723205566, -1.90877450546938, 218, 5, 'PPL', 'P'),
(183443, 'Moreno', 32.8733291625977, 0.573747829979199, -116.924171447754, -2.04071176692965, 218, 6, 'PPL', 'P'),
(189068, 'Moreno (historical)', 36.6536102294922, 0.639726181247313, -105.281936645508, -1.83751643734019, 218, 38, 'PPL', 'P'),
(96326, 'Moreno Colonia', 26.4009990692139, 0.46078435957374, -98.9990005493164, -1.72785851576925, 218, 51, 'PPL', 'P'),
(183445, 'Moreno Knolls', 33.9255599975586, 0.592112722540277, -117.10888671875, -2.04393565658725, 218, 6, 'PPL', 'P'),
(183446, 'Moreno Valley', 33.9375, 0.592321114895576, -117.229721069336, -2.04604461385448, 218, 6, 'PPL', 'P'),
(172270, 'Moretown', 44.2508316040039, 0.772322708235432, -72.7613906860352, -1.26992583580125, 218, 55, 'PPL', 'P'),
(183447, 'Morettis Junction', 33.2000007629395, 0.579449324977923, -116.71028137207, -2.03697868087163, 218, 6, 'PPL', 'P'),
(66954, 'Moretz', 36.2649993896484, 0.632943642583099, -81.6205596923828, -1.42454750395265, 218, 33, 'PPL', 'P'),
(76636, 'Moreville', 36.7861099243164, 0.642038737179883, -94.7916717529297, -1.65442677555833, 218, 42, 'PPL', 'P'),
(164779, 'Morewood', 40.1480598449707, 0.700715832582463, -79.5633316040039, -1.38864210034593, 218, 45, 'PPL', 'P'),
(96329, 'Morey', 29.8811092376709, 0.52152374034545, -94.2825012207031, -1.64554007331684, 218, 51, 'PPL', 'P'),
(132170, 'Morey', 44.4252815246582, 0.775367433730692, -85.2169418334961, -1.487316213475, 218, 27, 'PPL', 'P'),
(190505, 'Morey', 38.6666717529297, 0.67486073287651, -116.25611114502, -2.02905191504507, 218, 39, 'PPL', 'P'),
(194331, 'Morey', 40.2174987792969, 0.701927770615531, -105.092216491699, -1.83420519599884, 218, 7, 'PPL', 'P'),
(128190, 'Morey Brow', 46.2933311462402, 0.807971050217933, -67.9580612182617, -1.18609192153054, 218, 26, 'PPL', 'P'),
(150851, 'Morey Park', 42.5441703796387, 0.742535850654141, -73.6002807617188, -1.28456722968423, 218, 40, 'PPL', 'P'),
(78766, 'Morford', 39.7969398498535, 0.694587632598082, -80.4783325195313, -1.40461187898064, 218, 45, 'PPL', 'P'),
(110516, 'Morford', 38.8050003051758, 0.677275021562722, -81.2888870239258, -1.4187587238492, 218, 58, 'PPL', 'P'),
(4319, 'Morgan', 33.333610534668, 0.581781255407424, -86.9166717529297, -1.51698209696377, 218, 2, 'PPL', 'P'),
(10590, 'Morgan', 34.8863906860352, 0.608882381608397, -92.3722229003906, -1.61219942699792, 218, 4, 'PPL', 'P'),
(23180, 'Morgan', 33.746940612793, 0.58899522616823, -85.0730590820313, -1.48480498572511, 218, 13, 'PPL', 'P'),
(37272, 'Morgan', 38.6027793884277, 0.673745600749067, -84.3988876342773, -1.47303847423887, 218, 21, 'PPL', 'P'),
(49588, 'Morgan', 39.3611106872559, 0.686980978734543, -77.0466690063477, -1.34471805185503, 218, 25, 'PPL', 'P'),
(56372, 'Morgan', 37.5102806091309, 0.654677899976318, -92.6763916015625, -1.61750817231489, 218, 29, 'PPL', 'P'),
(82471, 'Morgan', 32.3036117553711, 0.563804385417171, -81.0824966430664, -1.41515653215876, 218, 48, 'PPL', 'P'),
(96327, 'Morgan', 32.0186080932617, 0.558830133133121, -97.6080627441406, -1.70358207137847, 218, 51, 'PPL', 'P'),
(110517, 'Morgan', 39.0261116027832, 0.681134141719328, -81.7633285522461, -1.42703929062658, 218, 58, 'PPL', 'P'),
(116921, 'Morgan', 40.6094398498535, 0.708768432770536, -93.6216735839844, -1.63400645526793, 218, 16, 'PPL', 'P'),
(132171, 'Morgan', 42.622501373291, 0.743902984399733, -85.1763916015625, -1.48660847841531, 218, 27, 'PPL', 'P'),
(136970, 'Morgan', 44.4169387817383, 0.775221825398092, -94.9252777099609, -1.6567586394088, 218, 28, 'PPL', 'P'),
(145809, 'Morgan', 40.4666709899902, 0.706276646096603, -74.2686080932617, -1.29623174210072, 218, 37, 'PPL', 'P'),
(164781, 'Morgan', 40.059440612793, 0.699169135200372, -79.6044387817383, -1.3893595559436, 218, 45, 'PPL', 'P'),
(172272, 'Morgan', 44.9136085510254, 0.783890348167273, -72.0147171020508, -1.25689392332306, 218, 55, 'PPL', 'P'),
(175396, 'Morgan', 44.8849983215332, 0.783391005462883, -88.8244400024414, -1.55027893428276, 218, 57, 'PPL', 'P'),
(187084, 'Morgan', 37.3277816772461, 0.651492692733556, -106.019439697266, -1.85038829383687, 218, 7, 'PPL', 'P'),
(195346, 'Morgan', 43.0605583190918, 0.751548520415187, -111.926666259766, -1.95348884701376, 218, 17, 'PPL', 'P'),
(197094, 'Morgan', 48.9933280944824, 0.855094886758558, -107.831672668457, -1.88201772599736, 218, 31, 'PPL', 'P'),
(201258, 'Morgan', 45.5527801513672, 0.795045997078478, -119.919441223145, -2.09298908649569, 218, 43, 'PPL', 'P'),
(204972, 'Morgan', 41.0361099243164, 0.716215230389642, -111.676109313965, -1.94911580334579, 218, 52, 'PPL', 'P'),
(89147, 'Morgan (historical)', 35.7852783203125, 0.624570930431999, -88.251106262207, -1.5402723728029, 218, 50, 'PPL', 'P'),
(128189, 'Morgan Beach', 45.2705612182617, 0.790120347484322, -68.5555572509766, -1.19652019456901, 218, 26, 'PPL', 'P'),
(42164, 'Morgan Bluff', 30.3286094665527, 0.529334092742866, -89.7125015258789, -1.56577853182702, 218, 22, 'PPL', 'P'),
(96328, 'Morgan Bluff', 30.208890914917, 0.527244609841104, -93.720832824707, -1.63573711050232, 218, 51, 'PPL', 'P'),
(89148, 'Morgan Branch', 36.1666717529297, 0.631227501576652, -82.0227813720703, -1.4315675965861, 218, 50, 'PPL', 'P'),
(156603, 'Morgan Center', 40.2805595397949, 0.703028388515033, -82.4175033569336, -1.43845679485197, 218, 41, 'PPL', 'P'),
(172275, 'Morgan Center', 44.9091682434082, 0.783812850179551, -71.9794387817383, -1.25627820047903, 218, 55, 'PPL', 'P'),
(4320, 'Morgan Chapel', 32.0430603027344, 0.559256904697806, -88.210563659668, -1.53956477090126, 218, 2, 'PPL', 'P'),
(4321, 'Morgan City', 34.4719390869141, 0.601648836613578, -86.5697174072266, -1.51092660127715, 218, 2, 'PPL', 'P'),
(42165, 'Morgan City', 29.6991691589355, 0.51834828693018, -91.206672668457, -1.5918567378533, 218, 22, 'PPL', 'P'),
(60945, 'Morgan City', 33.3805618286133, 0.582600710074841, -90.3502807617188, -1.57690987939328, 218, 30, 'PPL', 'P'),
(27943, 'Morgan City (historical)', 39.7638893127441, 0.69401079190597, -90.4291687011719, -1.57828673367685, 218, 18, 'PPL', 'P'),
(42166, 'Morgan City Beach', 29.6936092376709, 0.518251247997961, -91.101936340332, -1.59002874408107, 218, 22, 'PPL', 'P'),
(132173, 'Morgan Corners', 42.355281829834, 0.739239123540732, -85.1816711425781, -1.48670062378903, 218, 27, 'PPL', 'P'),
(150852, 'Morgan Corners', 42.0536117553711, 0.733973987486618, -79.6597213745117, -1.39032441920653, 218, 40, 'PPL', 'P'),
(172273, 'Morgan Corners', 43.7361106872559, 0.763339133509295, -72.6430587768555, -1.26786055437589, 218, 55, 'PPL', 'P'),
(89150, 'Morgan Estates', 35.1361083984375, 0.613240777890366, -85.0813903808594, -1.48495039432063, 218, 50, 'PPL', 'P'),
(113745, 'Morgan Fair Corners', 41.4086112976074, 0.722716605821771, -73.3061065673828, -1.27943292141867, 218, 8, 'PPL', 'P'),
(96330, 'Morgan Farm Area', 28.0083293914795, 0.488837565864417, -97.5461120605469, -1.70250082797589, 218, 51, 'PPL', 'P'),
(96331, 'Morgan Farm Colonia', 28.0189990997314, 0.489023787403641, -97.5479965209961, -1.70253371801536, 218, 51, 'PPL', 'P'),
(66956, 'Morgan Ford', 35.5858306884766, 0.621089912571157, -80.2247161865234, -1.40018543893282, 218, 33, 'PPL', 'P'),
(110521, 'Morgan Grove', 39.4230613708496, 0.688062222137115, -77.820556640625, -1.35822493911364, 218, 58, 'PPL', 'P'),
(56375, 'Morgan Heights', 37.8411102294922, 0.660451966114746, -92.0944366455078, -1.60735114223343, 218, 29, 'PPL', 'P'),
(110519, 'Morgan Heights', 39.6341705322266, 0.691746772084267, -79.9850006103516, -1.39600161286031, 218, 58, 'PPL', 'P'),
(145810, 'Morgan Heights', 40.4625015258789, 0.706203875219817, -74.2636108398438, -1.29614452357502, 218, 37, 'PPL', 'P'),
(150853, 'Morgan Hill', 41.9555587768555, 0.732262640170133, -74.1108322143555, -1.29347803353358, 218, 40, 'PPL', 'P'),
(164783, 'Morgan Hill', 40.3522186279297, 0.704279075541962, -80.1527786254883, -1.39892989163691, 218, 45, 'PPL', 'P'),
(183448, 'Morgan Hill', 37.1305618286133, 0.648050557024628, -121.653327941895, -2.12325111859448, 218, 6, 'PPL', 'P'),
(110520, 'Morgan Hills', 37.8088912963867, 0.659889639650575, -81.2283325195313, -1.4177018483706, 218, 58, 'PPL', 'P'),
(96332, 'Morgan Lane Colonia', 27.886999130249, 0.48671995332364, -97.1859970092773, -1.69621563464525, 218, 51, 'PPL', 'P'),
(49590, 'Morgan Manor', 39.5555610656738, 0.690374778069685, -76.6563873291016, -1.33790635157688, 218, 25, 'PPL', 'P'),
(73548, 'Morgan Manor', 39.9972190856934, 0.698083164686865, -81.7077789306641, -1.42606976683174, 218, 41, 'PPL', 'P'),
(96333, 'Morgan Mill', 32.3880615234375, 0.565278311922475, -98.1669387817383, -1.71333629834504, 218, 51, 'PPL', 'P'),
(49591, 'Morgan Park', 39.3466682434082, 0.686728910537367, -76.5791702270508, -1.33655865890725, 218, 25, 'PPL', 'P'),
(123248, 'Morgan Park', 41.6083297729492, 0.726202350793549, -87.0458297729492, -1.51923632966847, 218, 19, 'PPL', 'P'),
(136971, 'Morgan Park', 46.6883316040039, 0.814865108752794, -92.2099990844727, -1.609368087285, 218, 28, 'PPL', 'P'),
(17177, 'Morgan Place', 30.0097198486328, 0.523768418959737, -84.7555618286133, -1.47926361328693, 218, 12, 'PPL', 'P'),
(42167, 'Morgan Place', 30.5458297729492, 0.533125302291676, -91.0458297729492, -1.58904949974825, 218, 22, 'PPL', 'P'),
(73537, 'Morgan Place', 39.8636093139648, 0.695751234257365, -84.2852783203125, -1.47105561764925, 218, 41, 'PPL', 'P'),
(195347, 'Morgan Place', 43.1080589294434, 0.752377562462529, -116.273887634277, -2.02936217331206, 218, 17, 'PPL', 'P'),
(42168, 'Morgan Place West', 30.5555591583252, 0.533295112100682, -91.0519409179688, -1.5891561593499, 218, 22, 'PPL', 'P'),
(82476, 'Morgan River Estates', 32.4341697692871, 0.56608305262487, -80.6269378662109, -1.40720553156627, 218, 48, 'PPL', 'P'),
(156604, 'Morgan Run', 40.2813911437988, 0.703042902742974, -81.7944412231445, -1.42758230917285, 218, 41, 'PPL', 'P'),
(4323, 'Morgan Springs', 32.7452812194824, 0.571512971771432, -87.4158325195313, -1.52569409583775, 218, 2, 'PPL', 'P'),
(10591, 'Morgan Springs', 34.892219543457, 0.608984114362038, -94.3333282470703, -1.64642717227595, 218, 4, 'PPL', 'P'),
(89151, 'Morgan Springs', 35.5613899230957, 0.620663340743553, -85.101936340332, -1.48530898896141, 218, 50, 'PPL', 'P'),
(193802, 'Morgan Springs', 40.3622207641602, 0.704453645751416, -121.51000213623, -2.12074961138257, 218, 6, 'PPL', 'P'),
(71134, 'Morgan Village', 39.9124984741211, 0.696604511070626, -75.1127777099609, -1.31096528135742, 218, 37, 'PPL', 'P'),
(96334, 'Morgan''s Lakefront Lodge Colonia', 26.8840007781982, 0.469214329688277, -99.2740020751953, -1.73265819784384, 218, 51, 'PPL', 'P'),
(82473, 'Morgana', 33.6069412231445, 0.586551775868082, -82.054443359375, -1.43212020251229, 218, 48, 'PPL', 'P'),
(156608, 'Morgandale', 41.2655601501465, 0.720219892299822, -80.7830581665039, -1.40993034483559, 218, 41, 'PPL', 'P'),
(37274, 'Morganfield', 37.6833305358887, 0.657698190968577, -87.9166717529297, -1.53443538948372, 218, 21, 'PPL', 'P'),
(76635, 'Morgans Corner', 36.3680610656738, 0.634742408162366, -96.2138900756836, -1.67924916797258, 218, 42, 'PPL', 'P'),
(66960, 'Morgans Corners', 36.4172210693359, 0.635600412086562, -76.3494415283203, -1.33254913672808, 218, 33, 'PPL', 'P'),
(4326, 'Morgans Crossroads', 33.957218170166, 0.592665261887441, -86.039436340332, -1.50167145069885, 218, 2, 'PPL', 'P'),
(110522, 'Morgans Glade', 39.5991706848145, 0.69113590950923, -79.602783203125, -1.38933066064577, 218, 58, 'PPL', 'P'),
(164784, 'Morgans Land', 40.8327789306641, 0.712666435079057, -78.5400009155273, -1.37078161049531, 218, 45, 'PPL', 'P'),
(110523, 'Morgans Landing', 38.4749984741211, 0.671515403073207, -81.8402786254883, -1.42838232276431, 218, 58, 'PPL', 'P'),
(183449, 'Morgans Landing', 38.3283309936523, 0.668955572633423, -121.574722290039, -2.12187919115892, 218, 6, 'PPL', 'P'),
(49594, 'Morgans Neglect', 38.8652801513672, 0.678327103351358, -76.0252838134766, -1.32689151730832, 218, 25, 'PPL', 'P'),
(96335, 'Morgans Point', 29.6791706085205, 0.517999246379812, -94.9897232055664, -1.6578834254952, 218, 51, 'PPL', 'P'),
(96336, 'Morgans Point Resort', 31.1480598449707, 0.543636199902973, -97.4630584716797, -1.70105126939456, 218, 51, 'PPL', 'P'),
(49595, 'Morgans Ridge', 38.5283317565918, 0.672446244453217, -76.9994430541992, -1.34389380349765, 218, 25, 'PPL', 'P'),
(60946, 'Morgans Store', 32.0933303833008, 0.560134283118932, -90.3722229003906, -1.57729284195804, 218, 30, 'PPL', 'P'),
(104401, 'Morgansburg', 38.5597190856934, 0.672994056689447, -77.7391662597656, -1.3568044089882, 218, 53, 'PPL', 'P'),
(110530, 'Morgansville', 39.2813911437988, 0.685589610223031, -80.6966705322266, -1.40842259618444, 218, 58, 'PPL', 'P'),
(10596, 'Morganton', 35.4724998474121, 0.619111916250527, -92.3394393920898, -1.61162724683772, 218, 4, 'PPL', 'P'),
(23182, 'Morganton', 34.875, 0.608683576633022, -84.2555618286133, -1.47053696702696, 218, 13, 'PPL', 'P'),
(66961, 'Morganton', 35.7452812194824, 0.623872849331262, -81.6849975585938, -1.42567215688099, 218, 33, 'PPL', 'P'),
(89152, 'Morganton', 35.6433296203613, 0.622093458248926, -84.2272186279297, -1.47004228485447, 218, 50, 'PPL', 'P'),
(17178, 'Morgantown', 27.0058307647705, 0.471340664081624, -81.9677810668945, -1.43060766017118, 218, 12, 'PPL', 'P'),
(30563, 'Morgantown', 39.3713912963867, 0.687160409212987, -86.2611083984375, -1.50554035797247, 218, 19, 'PPL', 'P'),
(37275, 'Morgantown', 37.2255592346191, 0.649708574540284, -86.6836090087891, -1.51291438471479, 218, 21, 'PPL', 'P'),
(49596, 'Morgantown', 38.3452796936035, 0.669251383251504, -76.9713897705078, -1.34340418133124, 218, 25, 'PPL', 'P'),
(60949, 'Morgantown', 33.3055610656738, 0.58129169982004, -88.996940612793, -1.5532896378951, 218, 30, 'PPL', 'P'),
(66963, 'Morgantown', 36.121940612793, 0.630446795903095, -79.4291687011719, -1.38630051595748, 218, 33, 'PPL', 'P'),
(89153, 'Morgantown', 35.5033302307129, 0.619650007948778, -85.029167175293, -1.48403892743755, 218, 50, 'PPL', 'P'),
(104402, 'Morgantown', 38.8455581665039, 0.677982889780465, -77.8791732788086, -1.3592479924464, 218, 53, 'PPL', 'P'),
(110524, 'Morgantown', 39.6294403076172, 0.691664214090474, -79.9561080932617, -1.3954973433079, 218, 58, 'PPL', 'P'),
(156609, 'Morgantown', 40.973331451416, 0.715119539338157, -80.6324996948242, -1.40730260378801, 218, 41, 'PPL', 'P'),
(164785, 'Morgantown', 40.1549987792969, 0.700836939833034, -75.8902816772461, -1.32453528553387, 218, 45, 'PPL', 'P'),
(178675, 'Morgantown', 33.6269416809082, 0.586900849707965, -114.437217712402, -1.99730623590299, 218, 5, 'PPL', 'P'),
(73543, 'Morgantown (historical)', 39.1158294677734, 0.682700013861268, -82.601936340332, -1.44167575766155, 218, 41, 'PPL', 'P'),
(190507, 'Morgantown (historical)', 35.4900016784668, 0.61941738082756, -115.081390380859, -2.00854916991893, 218, 39, 'PPL', 'P'),
(23183, 'Morganville', 34.9363899230957, 0.609755032918589, -85.45361328125, -1.49144690948377, 218, 13, 'PPL', 'P'),
(27946, 'Morganville', 38.2802810668945, 0.668116943206157, -88.9022216796875, -1.55163648064843, 218, 18, 'PPL', 'P'),
(33338, 'Morganville', 39.4663887023926, 0.688818426728643, -97.2016677856445, -1.6964891412892, 218, 20, 'PPL', 'P'),
(73544, 'Morganville', 39.6322212219238, 0.691712750201341, -81.954719543457, -1.43037969358187, 218, 41, 'PPL', 'P'),
(145811, 'Morganville', 40.3763885498047, 0.70470092025863, -74.2447204589844, -1.29581482423207, 218, 37, 'PPL', 'P'),
(150854, 'Morganville', 43.0022201538086, 0.750530327351422, -78.0744400024414, -1.36265603969337, 218, 40, 'PPL', 'P'),
(164786, 'Morganville', 40.1541709899902, 0.700822492184121, -75.0999984741211, -1.31074224161613, 218, 45, 'PPL', 'P'),
(208179, 'Morganville', 47.3125, 0.825758902349817, -122.019721984863, -2.12964590100398, 218, 56, 'PPL', 'P'),
(89154, 'Morganville (historical)', 35.7591705322266, 0.624115263569487, -86.9977798461914, -1.51839770024121, 218, 50, 'PPL', 'P'),
(42170, 'Morganza', 30.7383308410645, 0.536485079743892, -91.5941696166992, -1.59861983544155, 218, 22, 'PPL', 'P'),
(49597, 'Morganza', 38.3752784729004, 0.669774960721813, -76.6958312988281, -1.33859477871867, 218, 25, 'PPL', 'P'),
(164787, 'Morganza', 40.273609161377, 0.70290708152738, -80.1577835083008, -1.39901724332066, 218, 45, 'PPL', 'P'),
(42171, 'Morganza Landing', 30.7408294677734, 0.536528689006743, -91.5877838134766, -1.59850838214993, 218, 22, 'PPL', 'P'),
(156610, 'Morges', 40.6352806091309, 0.70921943910114, -81.2458267211914, -1.41800717978958, 218, 41, 'PPL', 'P'),
(116928, 'Morgin Valley (historical)', 41.4900016784668, 0.724137135947219, -93.2916717529297, -1.62824683677841, 218, 16, 'PPL', 'P'),
(49598, 'Morgnec', 39.2536087036133, 0.685104715167555, -76.0008316040039, -1.32646474574363, 218, 25, 'PPL', 'P'),
(116929, 'Morhain', 42.6441688537598, 0.744281153274524, -93.6761093139648, -1.63495653798681, 218, 16, 'PPL', 'P'),
(4325, 'Moriah', 32.9336090087891, 0.574799911767835, -86.345832824707, -1.50701907816773, 218, 2, 'PPL', 'P'),
(27947, 'Moriah', 39.2172203063965, 0.684469617826598, -87.9394378662109, -1.53483273311836, 218, 18, 'PPL', 'P'),
(66964, 'Moriah', 36.2574996948242, 0.632812748215522, -78.829719543457, -1.37583815445705, 218, 33, 'PPL', 'P'),
(150855, 'Moriah', 44.0461082458496, 0.7687496115799, -73.5055618286133, -1.28291407243757, 218, 40, 'PPL', 'P'),
(150856, 'Moriah Center', 44.0611114501953, 0.769011466894082, -73.5102767944336, -1.28299636411525, 218, 40, 'PPL', 'P'),
(189069, 'Moriarty', 34.9900016784668, 0.610690734567588, -106.048606872559, -1.85089735707923, 218, 38, 'PPL', 'P'),
(150858, 'Moriches', 40.8072204589844, 0.712220355596469, -72.8216705322266, -1.27097791758989, 218, 40, 'PPL', 'P'),
(17179, 'Moriczville', 28.1191692352295, 0.490772086080251, -82.1500015258789, -1.43378800714495, 218, 12, 'PPL', 'P'),
(96337, 'Morida Colonia', 26.4130001068115, 0.460993817193475, -98.9769973754883, -1.72747448794006, 218, 51, 'PPL', 'P'),
(189070, 'Morine Place', 33.9194412231445, 0.592005929780565, -107.58943939209, -1.87778995776685, 218, 38, 'PPL', 'P'),
(191908, 'Morita', 32.184440612793, 0.561724456605819, -101.633331298828, -1.77383626093476, 218, 51, 'PPL', 'P'),
(170915, 'Moritz', 44.8338890075684, 0.782498979655761, -96.5608291625977, -1.68530439734309, 218, 49, 'PPL', 'P'),
(128191, 'Morkill', 45.4263916015625, 0.792840100747566, -69.4980621337891, -1.21297000799022, 218, 26, 'PPL', 'P'),
(200082, 'Morlan (historical)', 41.7094383239746, 0.727967027910862, -115.091667175293, -2.00872853381834, 218, 39, 'PPL', 'P'),
(187818, 'Morland', 39.3494415283203, 0.686777313490179, -100.07527923584, -1.74664312251812, 218, 20, 'PPL', 'P'),
(42172, 'Morley', 30.3913898468018, 0.530429817083866, -91.3211135864258, -1.59385410867086, 218, 22, 'PPL', 'P'),
(56376, 'Morley', 37.0436096191406, 0.646532954677447, -89.6102828979492, -1.56399448021278, 218, 29, 'PPL', 'P'),
(89155, 'Morley', 36.5511093139648, 0.637937202785052, -84.0483322143555, -1.46692012795052, 218, 50, 'PPL', 'P'),
(116930, 'Morley', 42.0061111450195, 0.733144945439276, -91.2461090087891, -1.59254503183703, 218, 16, 'PPL', 'P'),
(132174, 'Morley', 43.4908294677734, 0.75905816863602, -85.4438934326172, -1.49127726612233, 218, 27, 'PPL', 'P'),
(150859, 'Morley', 44.6650009155273, 0.779551326382234, -75.1991729736328, -1.31247316316663, 218, 40, 'PPL', 'P'),
(193803, 'Morley (historical)', 40.7769393920898, 0.711691851278143, -122.379997253418, -2.13593389065376, 218, 6, 'PPL', 'P'),
(110525, 'Morlunda', 37.8313903808594, 0.660282322753308, -80.4916687011719, -1.40484463925992, 218, 58, 'PPL', 'P'),
(183450, 'Mormon', 37.9502792358398, 0.662357324716643, -121.264717102051, -2.11646857993026, 218, 6, 'PPL', 'P'),
(183451, 'Mormon Bar', 37.4622192382813, 0.65383907081197, -119.946937561035, -2.09346898812412, 218, 6, 'PPL', 'P'),
(178676, 'Mormon Crossing', 34.6169395446777, 0.604179572018453, -110.78694152832, -1.93359689788363, 218, 5, 'PPL', 'P'),
(96341, 'Mormon Grove (historical)', 33.5616683959961, 0.585761615972656, -96.6986083984375, -1.68770909864938, 218, 51, 'PPL', 'P'),
(178677, 'Mormon Lake', 34.9083290100098, 0.609265277594123, -111.462501525879, -1.94538764413579, 218, 5, 'PPL', 'P'),
(60951, 'Mormon Springs', 33.8263893127441, 0.590381867568807, -88.2955627441406, -1.54104828478649, 218, 30, 'PPL', 'P'),
(23192, 'Morning Creek Estates', 33.5094413757324, 0.584850082510549, -84.4505615234375, -1.47394035374202, 218, 13, 'PPL', 'P'),
(37276, 'Morning Glory', 38.4005584716797, 0.670216179935412, -84.1477813720703, -1.46865584319098, 218, 21, 'PPL', 'P'),
(191913, 'Morning Glory', 31.5699996948242, 0.551000439528288, -106.215278625488, -1.85380632793793, 218, 51, 'PPL', 'P'),
(191909, 'Morning Glory Manor Colonia', 31.5709991455078, 0.551017883233428, -106.212997436523, -1.85376651367963, 218, 51, 'PPL', 'P'),
(23185, 'Morning Side Hills', 34.2924995422363, 0.598517025750672, -83.7930603027344, -1.46246479260487, 218, 13, 'PPL', 'P'),
(272, 'Morning Star', 32.2197189331055, 0.562340179449845, -90.5736083984375, -1.58080768196472, 218, 30, 'PPL', 'P'),
(10600, 'Morning Star', 35.9727783203125, 0.627843422779488, -92.5938873291016, -1.61606820111348, 218, 4, 'PPL', 'P'),
(66966, 'Morning Star', 35.5127792358398, 0.619814924199281, -82.8150024414063, -1.44539446264968, 218, 33, 'PPL', 'P'),
(73545, 'Morning Star', 39.0208282470703, 0.681041929766584, -81.9236068725586, -1.4298366750356, 218, 41, 'PPL', 'P'),
(104403, 'Morning Star', 38.646110534668, 0.674501871919622, -78.3661117553711, -1.36774667211706, 218, 53, 'PPL', 'P'),
(110526, 'Morning Star', 38.7747192382813, 0.676746517244396, -81.4555587768555, -1.42166769470789, 218, 58, 'PPL', 'P'),
(10601, 'Morning Sun', 35.1949996948242, 0.614268624913082, -91.7305603027344, -1.60100030198192, 218, 4, 'PPL', 'P'),
(73546, 'Morning Sun', 39.5963897705078, 0.691087373398363, -84.7372207641602, -1.4789435013239, 218, 41, 'PPL', 'P'),
(116931, 'Morning Sun', 41.0961112976074, 0.717262451909289, -91.2574996948242, -1.5927438368124, 218, 16, 'PPL', 'P'),
(4327, 'Morning Sun Villas', 33.4127807617188, 0.583163036539011, -86.695556640625, -1.51312291022814, 218, 2, 'PPL', 'P'),
(37277, 'Morning View', 38.8319396972656, 0.677745202653175, -84.4563903808594, -1.47404208649566, 218, 21, 'PPL', 'P'),
(125478, 'Morningdale', 42.3138885498047, 0.73851667451602, -71.7583312988281, -1.25241914690145, 218, 23, 'PPL', 'P'),
(4329, 'Morningside', 33.6294403076172, 0.586944458970815, -86.6658325195313, -1.51260412644779, 218, 2, 'PPL', 'P'),
(23187, 'Morningside', 33.7966690063477, 0.589863150367487, -84.3688888549805, -1.47251489676856, 218, 13, 'PPL', 'P'),
(49600, 'Morningside', 38.8300018310547, 0.677711380507331, -76.8916702270508, -1.34201281281973, 218, 25, 'PPL', 'P'),
(82474, 'Morningside', 34.8844413757324, 0.608848359725471, -82.341667175293, -1.4371332037902, 218, 48, 'PPL', 'P'),
(104405, 'Morningside', 37.2605590820313, 0.650319437115321, -79.9230575561523, -1.39492050261579, 218, 53, 'PPL', 'P'),
(113746, 'Morningside', 41.2127799987793, 0.719298704878763, -73.0102767944336, -1.27426971785528, 218, 8, 'PPL', 'P'),
(116933, 'Morningside', 42.4688911437988, 0.74122198013035, -96.35888671875, -1.68177983679842, 218, 16, 'PPL', 'P'),
(123250, 'Morningside', 40.2238883972168, 0.702039290486178, -85.3663864135742, -1.48992451344662, 218, 19, 'PPL', 'P'),
(164788, 'Morningside', 40.4824981689453, 0.706552882480671, -79.9297180175781, -1.39503674959737, 218, 45, 'PPL', 'P'),
(170916, 'Morningside', 44.3658294677734, 0.77432979959097, -98.1880569458008, -1.71370487983991, 218, 49, 'PPL', 'P'),
(208180, 'Morningside', 47.7013893127441, 0.83254630128302, -122.310562133789, -2.13472201919972, 218, 56, 'PPL', 'P'),
(204976, 'Morningside Cove', 40.6555595397949, 0.709573373210012, -111.928611755371, -1.95352280231766, 218, 52, 'PPL', 'P'),
(96338, 'Morningside Estates Colonia', 26.2609996795654, 0.458340909273593, -98.1210021972656, -1.71253455369888, 218, 51, 'PPL', 'P'),
(49601, 'Morningside Heights', 39.4277801513672, 0.688144580393826, -76.783332824707, -1.34012196844578, 218, 25, 'PPL', 'P'),
(82475, 'Morningside Heights', 34.6566696166992, 0.604872992587283, -82.8580627441406, -1.4461460067093, 218, 48, 'PPL', 'P'),
(104406, 'Morningside Hills', 36.7266693115234, 0.641001302777243, -81.942497253418, -1.43016637437855, 218, 53, 'PPL', 'P'),
(66968, 'Morningside Manor', 36.0769386291504, 0.629661363118604, -80.2033309936523, -1.39981219690605, 218, 33, 'PPL', 'P'),
(96339, 'Morningside Mobile Home Park Colonia', 26.1919994354248, 0.457136627828659, -98.1370010375977, -1.71281378613917, 218, 51, 'PPL', 'P'),
(17180, 'Morningside Park', 28.4430599212646, 0.496425044968107, -81.4069366455078, -1.42081907842654, 218, 12, 'PPL', 'P'),
(113747, 'Morningside Park', 41.3480606079102, 0.7216597969222, -72.1277770996094, -1.25886719253275, 218, 8, 'PPL', 'P'),
(183452, 'Morningside Park', 33.9597206115723, 0.592708937729318, -118.325561523438, -2.0651706378551, 218, 6, 'PPL', 'P'),
(136975, 'Morningside Terrace', 44.0277786254883, 0.768429699353954, -91.6236114501953, -1.59913369237388, 218, 28, 'PPL', 'P'),
(96340, 'Morningsun Colonia', 26.2089996337891, 0.457433337263607, -98.1330032348633, -1.71274401131861, 218, 51, 'PPL', 'P'),
(156611, 'Morningview', 40.1386108398438, 0.70055091633196, -80.7941665649414, -1.41012422296294, 218, 41, 'PPL', 'P'),
(89159, 'Morny', 36.2880592346191, 0.633346112802837, -86.8938903808594, -1.51658448701303, 218, 50, 'PPL', 'P'),
(10602, 'Moro', 34.7949981689453, 0.607287281273494, -90.9911117553711, -1.58809449018134, 218, 4, 'PPL', 'P'),
(27948, 'Moro', 38.9247207641602, 0.679364537753998, -90.0219421386719, -1.57117928935965, 218, 18, 'PPL', 'P'),
(42174, 'Moro', 31.6066703796387, 0.551640463717261, -91.709716796875, -1.60063651417702, 218, 22, 'PPL', 'P'),
(201259, 'Moro', 45.4841690063477, 0.793848506694324, -120.730003356934, -2.1071360645223, 218, 43, 'PPL', 'P'),
(10603, 'Moro Bay', 33.3063888549805, 0.581306147468953, -92.3502807617188, -1.61181646443317, 218, 4, 'PPL', 'P'),
(56378, 'Morocco', 36.7366714477539, 0.641175872986698, -90.3600006103516, -1.57707952275472, 218, 29, 'PPL', 'P'),
(123251, 'Morocco', 40.9461097717285, 0.714644431399686, -87.4533309936523, -1.52634856767564, 218, 19, 'PPL', 'P'),
(110527, 'Morocco (historical)', 38.4311103820801, 0.670749411364673, -81.0944366455078, -1.41536492451406, 218, 58, 'PPL', 'P'),
(183454, 'Morongo Valley', 34.0469398498535, 0.594231200608408, -116.580001831055, -2.03470487393292, 218, 6, 'PPL', 'P'),
(192711, 'Moroni', 39.5250015258789, 0.68984141348237, -111.589721679688, -1.94760805469464, 218, 52, 'PPL', 'P'),
(120693, 'Moronts', 41.2861099243164, 0.720578553519628, -89.2944412231445, -1.55848200307242, 218, 18, 'PPL', 'P'),
(156612, 'Morral', 40.6877784729004, 0.710135699674182, -83.2125015258789, -1.45233213044739, 218, 41, 'PPL', 'P'),
(145812, 'Morrell Corners', 40.4111099243164, 0.705306922564678, -74.1908264160156, -1.29487419573506, 218, 37, 'PPL', 'P'),
(89160, 'Morrell Mill', 35.0774993896484, 0.612217857715667, -86.8724975585938, -1.5162111118282, 218, 50, 'PPL', 'P'),
(49602, 'Morrell Park', 39.2644386291504, 0.685293733025923, -76.6611099243164, -1.33798877641262, 218, 25, 'PPL', 'P'),
(164789, 'Morrell Park', 40.0733299255371, 0.699411549438597, -74.9888916015625, -1.30880306086839, 218, 45, 'PPL', 'P'),
(27950, 'Morrelville', 39.8502807617188, 0.695518607136146, -90.8002777099609, -1.58476380776404, 218, 18, 'PPL', 'P'),
(132175, 'Morres Junction', 44.0116691589355, 0.768148536121869, -84.0955581665039, -1.4677443763079, 218, 27, 'PPL', 'P'),
(132176, 'Morrice', 42.8386116027832, 0.747674819451612, -84.1783294677734, -1.46918900804121, 218, 27, 'PPL', 'P'),
(33340, 'Morrill', 39.9283294677734, 0.696880814033722, -95.6916732788086, -1.67013476545789, 218, 20, 'PPL', 'P'),
(37278, 'Morrill', 37.5191688537598, 0.654833029109815, -84.1975021362305, -1.46952363423218, 218, 21, 'PPL', 'P'),
(96342, 'Morrill', 31.5936107635498, 0.551412530417464, -95.0644378662109, -1.65918744232295, 218, 51, 'PPL', 'P'),
(128193, 'Morrill', 44.4430618286133, 0.775677758576714, -69.1497192382813, -1.20689027753767, 218, 26, 'PPL', 'P'),
(136976, 'Morrill', 45.8388900756836, 0.800039557280431, -93.9694366455078, -1.64007606570833, 218, 28, 'PPL', 'P'),
(199546, 'Morrill', 41.9633293151855, 0.732398261648645, -103.925827026367, -1.81384785946822, 218, 35, 'PPL', 'P'),
(199548, 'Morrill Mobile Home Estates', 41.9633293151855, 0.732398261648645, -103.925827026367, -1.81384785946822, 218, 35, 'PPL', 'P'),
(128195, 'Morrills Corner', 43.6875, 0.762490716965023, -70.2936096191406, -1.22685493096556, 218, 26, 'PPL', 'P'),
(10606, 'Morrilton', 35.1508293151855, 0.613497706356531, -92.7438888549805, -1.61868622162308, 218, 4, 'PPL', 'P'),
(4333, 'Morris', 33.7480583190918, 0.589014733823215, -86.8086090087891, -1.51509604627978, 218, 2, 'PPL', 'P'),
(10607, 'Morris', 33.6699981689453, 0.587652327188558, -93.2463912963867, -1.62745654372493, 218, 4, 'PPL', 'P'),
(23191, 'Morris', 31.7941703796387, 0.55491295606475, -84.9463882446289, -1.48259416254618, 218, 13, 'PPL', 'P'),
(30564, 'Morris', 39.2822189331055, 0.685604057871945, -85.1774978637695, -1.48662778633321, 218, 19, 'PPL', 'P'),
(33342, 'Morris', 39.061939239502, 0.681759451943279, -94.7513885498047, -1.65372370103055, 218, 20, 'PPL', 'P'),
(42175, 'Morris', 32.5330581665039, 0.567808980748323, -93.5955581665039, -1.63355065524736, 218, 22, 'PPL', 'P'),
(60950, 'Morris', 31.4622192382813, 0.54911931569231, -89.6613922119141, -1.5648865060199, 218, 30, 'PPL', 'P'),
(71135, 'Morris', 39.9872207641602, 0.697908661056438, -75.0447235107422, -1.30977751151125, 218, 37, 'PPL', 'P'),
(76637, 'Morris', 35.6074981689453, 0.621468081445948, -95.8600006103516, -1.67307263161441, 218, 42, 'PPL', 'P'),
(110528, 'Morris', 38.5058288574219, 0.672053494771458, -80.8027801513672, -1.41027455840648, 218, 58, 'PPL', 'P'),
(113749, 'Morris', 41.6841697692871, 0.727526008434345, -73.1966705322266, -1.27752290228486, 218, 8, 'PPL', 'P'),
(120694, 'Morris', 41.3572196960449, 0.721819653166632, -88.4211120605469, -1.54323953373141, 218, 18, 'PPL', 'P'),
(136978, 'Morris', 45.586109161377, 0.795627698039579, -95.9136123657227, -1.67400833326341, 218, 28, 'PPL', 'P'),
(150860, 'Morris', 42.5486106872559, 0.742613348641862, -75.2455596923828, -1.31328276413801, 218, 40, 'PPL', 'P'),
(164790, 'Morris', 41.5950012207031, 0.72596972367233, -77.2925033569336, -1.34900867068726, 218, 45, 'PPL', 'P'),
(42176, 'Morris (historical)', 31.4424991607666, 0.548775135410931, -92.5536117553711, -1.61536525974375, 218, 22, 'PPL', 'P'),
(110529, 'Morris (historical)', 38.3633308410645, 0.66956643520846, -81.3652801513672, -1.42009203544895, 218, 58, 'PPL', 'P'),
(13164, 'Morris Addition (historical)', 38.9055595397949, 0.679030111300111, -76.9694366455078, -1.34337009286929, 218, 9, 'PPL', 'P'),
(71136, 'Morris Beach', 39.3083305358887, 0.686059791313484, -74.6369400024414, -1.30266034665607, 218, 37, 'PPL', 'P'),
(89161, 'Morris Chapel', 35.3238906860352, 0.616518197085872, -88.3522186279297, -1.54203711649924, 218, 50, 'PPL', 'P'),
(125479, 'Morris Corner', 42.0402793884277, 0.733741293786372, -71.0908279418945, -1.24076901555484, 218, 23, 'PPL', 'P'),
(128196, 'Morris Corner', 46.877498626709, 0.818166696135192, -67.851936340332, -1.18423969299239, 218, 26, 'PPL', 'P'),
(113750, 'Morris Cove', 41.2580604553223, 0.720088997932244, -72.8919372558594, -1.27220430327187, 218, 8, 'PPL', 'P'),
(4334, 'Morris Crossroads', 34.9288902282715, 0.609624138551011, -86.9888916015625, -1.51824257110771, 218, 2, 'PPL', 'P'),
(78769, 'Morris Crossroads', 39.7533302307129, 0.693826501158537, -79.8574981689453, -1.39377627545344, 218, 45, 'PPL', 'P'),
(14267, 'Morris Estates', 39.1463890075684, 0.683233378448583, -75.5202789306641, -1.31807751936459, 218, 10, 'PPL', 'P'),
(23193, 'Morris Estates', 34.9755592346191, 0.610438666370412, -85.1766662597656, -1.48661327210527, 218, 13, 'PPL', 'P'),
(10608, 'Morris Ferry (historical)', 33.8883285522461, 0.591462911234298, -94.3855590820313, -1.64733877231708, 218, 4, 'PPL', 'P'),
(37279, 'Morris Fork', 37.3824996948242, 0.652447702300458, -83.51611328125, -1.45763115522638, 218, 21, 'PPL', 'P'),
(96345, 'Morris Grove', 33.0369415283203, 0.576603404458037, -95.3141708374023, -1.66354610492103, 218, 51, 'PPL', 'P'),
(4335, 'Morris Heights', 31.1891708374023, 0.544353722079668, -85.3786087036133, -1.49013783264994, 218, 2, 'PPL', 'P'),
(150861, 'Morris Heights', 40.8497200012207, 0.712962112539083, -73.920280456543, -1.29015227796429, 218, 40, 'PPL', 'P'),
(49605, 'Morris Hills', 39.2005615234375, 0.684178867214589, -76.6063919067383, -1.33703376684572, 218, 25, 'PPL', 'P'),
(4336, 'Morris Mill', 34.6477813720703, 0.604717863453785, -85.857780456543, -1.49850095742112, 218, 2, 'PPL', 'P'),
(14270, 'Morris Mill', 38.6388893127441, 0.674375837821034, -75.3172225952148, -1.31453351774397, 218, 10, 'PPL', 'P'),
(49603, 'Morris Mill', 38.3244400024414, 0.668887662025626, -75.5924987792969, -1.31933799350852, 218, 25, 'PPL', 'P'),
(49604, 'Morris Mobile Home Park', 38.3163909912109, 0.668747180278125, -75.1291732788086, -1.31125143801655, 218, 25, 'PPL', 'P'),
(150863, 'Morris Park', 40.6902809143066, 0.710179375516059, -73.8163909912109, -1.28833906473611, 218, 40, 'PPL', 'P'),
(145814, 'Morris Plains', 40.8216705322266, 0.7124725569517, -74.4813919067383, -1.29994552024084, 218, 37, 'PPL', 'P'),
(96344, 'Morris Ranch', 30.2169399261475, 0.527385091588605, -99.0119400024414, -1.72808435182968, 218, 51, 'PPL', 'P'),
(164792, 'Morris Run', 41.6772193908691, 0.727404701446692, -77.0183334350586, -1.34422350284061, 218, 45, 'PPL', 'P'),
(150865, 'Morrisania', 40.8291702270508, 0.712603451319277, -73.9069366455078, -1.28991938452696, 218, 40, 'PPL', 'P'),
(116934, 'Morrisburgh (historical)', 41.5999984741211, 0.72605694219803, -94.3177795410156, -1.64615579616087, 218, 16, 'PPL', 'P'),
(164797, 'Morrisdale', 40.9488906860352, 0.714692967510553, -78.2255630493164, -1.36529363443699, 218, 45, 'PPL', 'P'),
(209621, 'Morrisey', 43.5180587768555, 0.759533409732544, -104.383056640625, -1.82182802167464, 218, 59, 'PPL', 'P'),
(209620, 'Morrisey (historical)', 41.4866714477539, 0.724079012456428, -106.14111328125, -1.85251189849009, 218, 59, 'PPL', 'P'),
(89162, 'Morrisgap (historical)', 35.7402801513672, 0.623785564226535, -84.5611114501953, -1.47586981395179, 218, 50, 'PPL', 'P'),
(42178, 'Morrison', 30.7124996185303, 0.536034239860856, -91.5286102294922, -1.5974756082792, 218, 22, 'PPL', 'P'),
(56380, 'Morrison', 38.672779083252, 0.674967325899141, -91.6361083984375, -1.59935180526716, 218, 29, 'PPL', 'P'),
(76639, 'Morrison', 36.2972183227539, 0.63350596904727, -97.0077819824219, -1.69310519565009, 218, 42, 'PPL', 'P'),
(89163, 'Morrison', 35.6027793884277, 0.621385723189237, -85.9197235107422, -1.49958206766563, 218, 50, 'PPL', 'P'),
(104407, 'Morrison', 37.0552787780762, 0.64673661992181, -76.4630584716797, -1.33453212647575, 218, 53, 'PPL', 'P'),
(116935, 'Morrison', 42.3441696166992, 0.739045178834347, -92.6736068725586, -1.61745956962499, 218, 16, 'PPL', 'P'),
(120697, 'Morrison', 41.8097190856934, 0.729717257379262, -89.9649963378906, -1.57018539764083, 218, 18, 'PPL', 'P'),
(175400, 'Morrison', 44.2991714477539, 0.773166397668769, -87.9888916015625, -1.53569586362765, 218, 57, 'PPL', 'P'),
(183455, 'Morrison', 38.7097206115723, 0.675612077199049, -120.323333740234, -2.10003834074307, 218, 6, 'PPL', 'P'),
(187085, 'Morrison', 39.6536102294922, 0.692086058807143, -105.190559387207, -1.83592160332139, 218, 7, 'PPL', 'P'),
(110531, 'Morrison (historical)', 38.2252807617188, 0.667157006791238, -80.9047164916992, -1.41205368317271, 218, 58, 'PPL', 'P'),
(164798, 'Morrison (historical)', 41.8041687011719, 0.729620384894611, -78.9166717529297, -1.37735575680423, 218, 45, 'PPL', 'P'),
(201260, 'Morrison (historical)', 44.6450004577637, 0.779202252542352, -123.861671447754, -2.16179398378676, 218, 43, 'PPL', 'P'),
(10610, 'Morrison Bluff', 35.3877792358398, 0.617633262634288, -93.5283279418945, -1.63237726647107, 218, 4, 'PPL', 'P'),
(89164, 'Morrison City', 36.5913887023926, 0.638640210733806, -82.5736083984375, -1.44118134180518, 218, 50, 'PPL', 'P'),
(128197, 'Morrison Corner', 44.663330078125, 0.779522164768298, -69.5777816772461, -1.21436137650173, 218, 26, 'PPL', 'P'),
(89165, 'Morrison Creek', 36.3305587768555, 0.634087869745452, -85.5944366455078, -1.4939047408538, 218, 50, 'PPL', 'P'),
(4340, 'Morrison Crossroad', 33.4263916015625, 0.583400590508246, -85.4933319091797, -1.49214013031552, 218, 2, 'PPL', 'P'),
(96346, 'Morrison Falls', 29.5641708374023, 0.51599212173476, -98.0199966430664, -1.7107716742153, 218, 51, 'PPL', 'P'),
(150866, 'Morrison Heights', 41.5061111450195, 0.724418299179304, -74.206672668457, -1.29515076501426, 218, 40, 'PPL', 'P'),
(104408, 'Morrisons Corner', 38.0013885498047, 0.663249350523765, -76.5805587768555, -1.33658289367317, 218, 53, 'PPL', 'P'),
(66970, 'Morrisons Store', 35.6944389343262, 0.622985484056048, -76.6338882446289, -1.33751366847415, 218, 33, 'PPL', 'P'),
(27951, 'Morrisonville', 39.4199981689453, 0.688008759178232, -89.4555587768555, -1.56129403486744, 218, 18, 'PPL', 'P'),
(42179, 'Morrisonville', 30.3219394683838, 0.529217679313716, -91.2247161865234, -1.5921716566522, 218, 22, 'PPL', 'P'),
(104410, 'Morrisonville', 39.2230606079102, 0.684571550317321, -77.6686096191406, -1.35557296330014, 218, 53, 'PPL', 'P'),
(150867, 'Morrisonville', 44.6930618286133, 0.780041081706699, -73.5625, -1.28390783099833, 218, 40, 'PPL', 'P'),
(175402, 'Morrisonville', 43.2772216796875, 0.755330009426018, -89.3594436645508, -1.5596165096968, 218, 57, 'PPL', 'P'),
(10611, 'Morriston', 36.2658309936523, 0.63295815681104, -91.7802810668945, -1.60186809302312, 218, 4, 'PPL', 'P'),
(17183, 'Morriston', 29.2813892364502, 0.511056651734084, -82.4380569458008, -1.4388155226508, 218, 12, 'PPL', 'P'),
(60952, 'Morriston', 31.4155597686768, 0.548304954320478, -89.1961135864258, -1.55676586206598, 218, 30, 'PPL', 'P'),
(30565, 'Morristown', 39.6733283996582, 0.692430205799008, -85.6986083984375, -1.49572288093, 218, 19, 'PPL', 'P'),
(89168, 'Morristown', 36.2138900756836, 0.632051616775977, -83.2949981689453, -1.45377196849074, 218, 50, 'PPL', 'P'),
(110532, 'Morristown', 39.0469398498535, 0.681497663208124, -81.4927825927734, -1.42231737285582, 218, 58, 'PPL', 'P'),
(120698, 'Morristown', 41.3963890075684, 0.722503286618456, -90.2986068725586, -1.57600799989013, 218, 18, 'PPL', 'P'),
(136982, 'Morristown', 44.2272186279297, 0.771910584056742, -93.4444427490234, -1.6309131936618, 218, 28, 'PPL', 'P'),
(145818, 'Morristown', 40.7966690063477, 0.71203619800709, -74.4819412231445, -1.29995510762076, 218, 37, 'PPL', 'P'),
(150868, 'Morristown', 44.5863914489746, 0.778179332367652, -75.6486129760742, -1.3203173709994, 218, 40, 'PPL', 'P'),
(156615, 'Morristown', 40.063060760498, 0.699232318697234, -81.0744400024414, -1.4150159172532, 218, 41, 'PPL', 'P'),
(172276, 'Morristown', 44.5572204589844, 0.777670202546256, -72.6241683959961, -1.26753085503294, 218, 55, 'PPL', 'P'),
(177638, 'Morristown', 33.8566703796387, 0.590910371887133, -112.622497558594, -1.96563339421674, 218, 5, 'PPL', 'P'),
(183456, 'Morristown', 39.6525001525879, 0.692066684310213, -120.903610229492, -2.11016607605254, 218, 6, 'PPL', 'P'),
(202398, 'Morristown', 45.9386100769043, 0.801779999631825, -101.722778320313, -1.77539740596576, 218, 49, 'PPL', 'P'),
(120699, 'Morristown (historical)', 42.1725006103516, 0.736048989449953, -89.0669403076172, -1.55451136304517, 218, 18, 'PPL', 'P'),
(150869, 'Morristown Center', 44.5966682434082, 0.778358696267069, -75.5927810668945, -1.31934292035654, 218, 40, 'PPL', 'P'),
(110533, 'Morrisvale', 38.1358299255371, 0.665595795181206, -81.9124984741211, -1.42964279690824, 218, 58, 'PPL', 'P'),
(4337, 'Morrisville', 33.7266693115234, 0.588641425217413, -85.9572219848633, -1.50023653950352, 218, 2, 'PPL', 'P'),
(49606, 'Morrisville', 39.461109161377, 0.688726281354926, -76.7027816772461, -1.33871608570632, 218, 25, 'PPL', 'P'),
(56381, 'Morrisville', 37.4811096191406, 0.654168770154922, -93.4272232055664, -1.63061265593278, 218, 29, 'PPL', 'P'),
(66971, 'Morrisville', 35.8233299255371, 0.625235056228838, -78.8258285522461, -1.37577024384925, 218, 33, 'PPL', 'P'),
(71137, 'Morrisville', 39.9722213745117, 0.697646872321283, -75.0491714477539, -1.30985514265703, 218, 37, 'PPL', 'P'),
(73550, 'Morrisville', 39.355281829834, 0.686879245980902, -83.8027801513672, -1.46263443596631, 218, 41, 'PPL', 'P'),
(82477, 'Morrisville', 33.6069412231445, 0.586551775868082, -79.5388870239258, -1.3882154619393, 218, 48, 'PPL', 'P'),
(104409, 'Morrisville', 38.5016708374023, 0.671980923631753, -77.7002792358398, -1.35612570238439, 218, 53, 'PPL', 'P'),
(150871, 'Morrisville', 42.898609161377, 0.748721974392231, -75.6405563354492, -1.32017675609385, 218, 40, 'PPL', 'P'),
(164799, 'Morrisville', 40.2113914489746, 0.7018211775929, -74.788330078125, -1.30530260193159, 218, 45, 'PPL', 'P'),
(172278, 'Morrisville', 44.5616683959961, 0.777747833692032, -72.5988922119141, -1.26708970239837, 218, 55, 'PPL', 'P'),
(4338, 'Morrisville (historical)', 31.0547199249268, 0.542007110974658, -85.9111099243164, -1.4994317322221, 218, 2, 'PPL', 'P'),
(150872, 'Morrisville Station', 42.8913917541504, 0.748596006872671, -75.6044387817383, -1.31954638586382, 218, 40, 'PPL', 'P'),
(183457, 'Morro Bay', 35.3658294677734, 0.61725016691148, -120.848892211914, -2.10921106648563, 218, 6, 'PPL', 'P'),
(587, 'Morrow', 30.829719543457, 0.538080113499768, -92.0800018310547, -1.60709920719431, 218, 22, 'PPL', 'P'),
(10612, 'Morrow', 35.8583297729492, 0.625845918803875, -94.4372177124023, -1.64824038550413, 218, 4, 'PPL', 'P'),
(23195, 'Morrow', 33.5830612182617, 0.586134991157485, -84.3394393920898, -1.47200090667817, 218, 13, 'PPL', 'P'),
(73551, 'Morrow', 39.3544387817383, 0.686864532015879, -84.1272201538086, -1.46829698223409, 218, 41, 'PPL', 'P'),
(195348, 'Morrow', 46.1269416809082, 0.805067006207256, -116.522499084473, -2.03370126167613, 218, 17, 'PPL', 'P'),
(66972, 'Morrows (historical)', 35.1136093139648, 0.612848094787634, -80.8811111450195, -1.41164169215207, 218, 33, 'PPL', 'P'),
(164801, 'Morrows Corner', 40.9077796936035, 0.713975445333858, -79.5408325195313, -1.3882494172432, 218, 45, 'PPL', 'P'),
(4341, 'Morrows Grove', 33.0533294677734, 0.576889427959111, -87.9947204589844, -1.53579759638129, 218, 2, 'PPL', 'P'),
(33345, 'Morrowville', 39.8444404602051, 0.695416674645423, -97.17138671875, -1.69596063697088, 218, 20, 'PPL', 'P'),
(56383, 'Morschels', 38.5394401550293, 0.672640122580575, -90.5358276367188, -1.58014828327882, 218, 29, 'PPL', 'P'),
(33346, 'Morse', 38.8502807617188, 0.678065314616203, -94.7236099243164, -1.6532388725541, 218, 20, 'PPL', 'P'),
(42180, 'Morse', 30.1216697692871, 0.525722313672501, -92.4980621337891, -1.61439573594891, 218, 22, 'PPL', 'P'),
(66973, 'Morse', 36.5183296203613, 0.637365089203876, -76.1666717529297, -1.32935920237438, 218, 33, 'PPL', 'P'),
(76640, 'Morse', 35.5366706848145, 0.62023190864696, -96.2819366455078, -1.6804368046607, 218, 42, 'PPL', 'P'),
(116936, 'Morse', 41.749439239502, 0.728665175590626, -91.434440612793, -1.59583203841246, 218, 16, 'PPL', 'P'),
(120700, 'Morse', 41.230281829834, 0.719604169455795, -89.6449966430664, -1.56460034936077, 218, 18, 'PPL', 'P'),
(150880, 'Morse', 43.3699989318848, 0.756949277947813, -76.1341705322266, -1.3287919490622, 218, 40, 'PPL', 'P'),
(175403, 'Morse', 46.2222213745117, 0.806729950570928, -90.6275024414063, -1.58174831046174, 218, 57, 'PPL', 'P'),
(183458, 'Morse', 36.8377799987793, 0.642940550104011, -121.492218017578, -2.12043921995752, 218, 6, 'PPL', 'P'),
(192969, 'Morse', 36.0625, 0.629409361500455, -101.474998474121, -1.77107283182963, 218, 51, 'PPL', 'P'),
(142450, 'Morse Bluff', 41.4319381713867, 0.723123736573417, -96.76611328125, -1.68888728111563, 218, 35, 'PPL', 'P'),
(125480, 'Morse Corner', 42.0499992370605, 0.73391093714781, -71.0852813720703, -1.24067220964922, 218, 23, 'PPL', 'P'),
(191910, 'Morse Junction', 36.0322189331055, 0.628880857182129, -101.473609924316, -1.77104859706372, 218, 51, 'PPL', 'P'),
(56384, 'Morse Mill', 38.276668548584, 0.66805389286735, -90.6530609130859, -1.58219438994433, 218, 29, 'PPL', 'P'),
(150873, 'Morse Mill', 42.7269401550293, 0.745725785007838, -76.3594436645508, -1.33272370693754, 218, 40, 'PPL', 'P'),
(17181, 'Morse Shores', 26.6805591583252, 0.465663603585902, -81.7977828979492, -1.42764063240072, 218, 12, 'PPL', 'P'),
(125481, 'Morse Village', 42.5430603027344, 0.74251647615721, -72.3375015258789, -1.26252757429301, 218, 23, 'PPL', 'P'),
(145820, 'Morsemere', 40.8427810668945, 0.712841005288512, -74.004997253418, -1.2916308650015, 218, 37, 'PPL', 'P'),
(172279, 'Morses Line', 45.0122184753418, 0.785611416021736, -72.9786071777344, -1.27371697877103, 218, 55, 'PPL', 'P'),
(172280, 'Morses Mill', 44.5883293151855, 0.778213154513496, -72.7919387817383, -1.27045900065148, 218, 55, 'PPL', 'P'),
(172281, 'Morses Mills', 44.3800010681152, 0.774577140677211, -72.0924987792969, -1.25825146968872, 218, 55, 'PPL', 'P'),
(120701, 'Morseville', 42.3055610656738, 0.738371332499529, -89.9791717529297, -1.5704328053061, 218, 18, 'PPL', 'P'),
(125483, 'Morseville', 42.1452789306641, 0.735573881511483, -71.9694366455078, -1.25610363026957, 218, 23, 'PPL', 'P'),
(132177, 'Morseville', 43.2363891601563, 0.754617347518312, -83.8661117553711, -1.46373978097675, 218, 27, 'PPL', 'P'),
(56385, 'Morsey (historical)', 38.9511108398438, 0.679825131464527, -91.2227783203125, -1.59213783450636, 218, 29, 'PPL', 'P'),
(150874, 'Morsston', 41.8841705322266, 0.731016680254139, -74.8108291625977, -1.30569528503432, 218, 40, 'PPL', 'P'),
(113318, 'Morstein', 40.0166702270508, 0.698422651146823, -75.5872192382813, -1.31924584813481, 218, 45, 'PPL', 'P'),
(136987, 'Mort', 45.3605613708496, 0.791691146474278, -93.1852798461914, -1.62638994770836, 218, 28, 'PPL', 'P'),
(49607, 'Mort Hills', 39.5269393920898, 0.689875235628214, -77.2569427490234, -1.34838802099522, 218, 25, 'PPL', 'P'),
(183461, 'Mortero Palms', 32.7191696166992, 0.571057238329892, -116.150833129883, -2.02721446705097, 218, 6, 'PPL', 'P'),
(27952, 'Mortimer', 39.855281829834, 0.695605892240873, -87.7244415283203, -1.53108033914244, 218, 18, 'PPL', 'P'),
(66974, 'Mortimer', 35.985279083252, 0.628061602251793, -81.7613906860352, -1.42700546848074, 218, 33, 'PPL', 'P'),
(150875, 'Mortimer', 43.0930595397949, 0.752115773727374, -77.649169921875, -1.35523367657727, 218, 40, 'PPL', 'P'),
(156614, 'Mortimer', 41.1094398498535, 0.717495079030507, -83.6502838134766, -1.45997287277288, 218, 41, 'PPL', 'P'),
(116937, 'Mortimer (historical)', 40.8844413757324, 0.713568114845131, -94.3194427490234, -1.64618482461675, 218, 16, 'PPL', 'P'),
(183459, 'Mortmar', 33.521671295166, 0.585063534871919, -115.934997558594, -2.02344742568905, 218, 6, 'PPL', 'P'),
(10614, 'Morton', 35.2511100769043, 0.615247935824932, -91.0933303833008, -1.58987854179559, 218, 4, 'PPL', 'P'),
(23198, 'Morton', 32.9780616760254, 0.575575757172403, -83.5258331298828, -1.45780079858782, 218, 13, 'PPL', 'P'),
(30566, 'Morton', 39.7630615234375, 0.693996344257057, -86.936393737793, -1.51732631053467, 218, 19, 'PPL', 'P'),
(56386, 'Morton', 39.3194389343262, 0.686253669440842, -93.8605575561523, -1.6381757671125, 218, 29, 'PPL', 'P'),
(60953, 'Morton', 32.3536109924316, 0.564677036727362, -89.6544418334961, -1.56476519903225, 218, 30, 'PPL', 'P'),
(73552, 'Morton', 39.6733283996582, 0.692430205799008, -80.9499969482422, -1.41284397622619, 218, 41, 'PPL', 'P'),
(120702, 'Morton', 40.6127815246582, 0.708826755998408, -89.4591674804688, -1.56135701862722, 218, 18, 'PPL', 'P'),
(136988, 'Morton', 44.5513916015625, 0.777568469792615, -94.9841690063477, -1.65778648643152, 218, 28, 'PPL', 'P'),
(150876, 'Morton', 43.3280601501465, 0.756217308122205, -77.9955596923828, -1.36127931856786, 218, 40, 'PPL', 'P'),
(164802, 'Morton', 40.0416717529297, 0.698859010091432, -75.1833267211914, -1.31219659388742, 218, 45, 'PPL', 'P'),
(183460, 'Morton', 33.913890838623, 0.591909057295913, -118.183059692383, -2.06268351171308, 218, 6, 'PPL', 'P'),
(191911, 'Morton', 33.7249984741211, 0.588612263603477, -102.758888244629, -1.79348093555767, 218, 51, 'PPL', 'P'),
(195349, 'Morton', 48.2013893127441, 0.841272947542992, -116.691390991211, -2.03664898152868, 218, 17, 'PPL', 'P'),
(204979, 'Morton', 41.9391708374023, 0.731976616669058, -111.947219848633, -1.95384757481259, 218, 52, 'PPL', 'P'),
(208181, 'Morton', 46.5586090087891, 0.812601022352063, -122.273887634277, -2.13408192843172, 218, 56, 'PPL', 'P'),
(209622, 'Morton', 43.2005615234375, 0.753992037294362, -108.773887634277, -1.89846247941249, 218, 59, 'PPL', 'P'),
(4342, 'Morton (historical)', 34.0750007629395, 0.594720955932873, -86.0069427490234, -1.50110433054472, 218, 2, 'PPL', 'P'),
(200083, 'Morton (historical)', 41.5699996948242, 0.725533364727721, -115.210830688477, -2.01080832947164, 218, 39, 'PPL', 'P'),
(175409, 'Morton Corner', 44.7905616760254, 0.781742775064233, -92.4719390869141, -1.61393980277029, 218, 57, 'PPL', 'P'),
(150878, 'Morton Corners', 42.5994415283203, 0.743500514179995, -76.3441696166992, -1.33245712451242, 218, 40, 'PPL', 'P'),
(73553, 'Morton Flats', 38.8288917541504, 0.677692006010401, -82.2638931274414, -1.43577579058259, 218, 41, 'PPL', 'P'),
(66976, 'Morton Fork', 34.8244400024414, 0.607801138205825, -77.2297210693359, -1.34791291305675, 218, 33, 'PPL', 'P'),
(110534, 'Morton Grove', 39.4813919067383, 0.689080282042825, -78.2624969482422, -1.36593825257884, 218, 58, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(120703, 'Morton Grove', 42.0405616760254, 0.733746220634389, -87.7825012207031, -1.53209367193721, 218, 18, 'PPL', 'P'),
(89170, 'Morton Hill', 35.4713897705078, 0.619092541753597, -89.2886123657227, -1.55838027031878, 218, 50, 'PPL', 'P'),
(66975, 'Morton Manor', 34.8072204589844, 0.607500600476809, -77.3833312988281, -1.35059391732613, 218, 33, 'PPL', 'P'),
(116938, 'Morton Mills', 41.079719543457, 0.716976361829187, -94.9844436645508, -1.65779128012148, 218, 16, 'PPL', 'P'),
(96348, 'Morton Valley', 32.4711112976074, 0.566727803924778, -98.8163909912109, -1.72467137773469, 218, 51, 'PPL', 'P'),
(37281, 'Mortons Gap', 37.2366714477539, 0.649902519246669, -87.4752807617188, -1.52673166339845, 218, 21, 'PPL', 'P'),
(23196, 'Mortons Mobile Home Park', 32.0405616760254, 0.559213295434956, -81.1852798461914, -1.41695043746904, 218, 13, 'PPL', 'P'),
(37280, 'Mortonsville', 37.9719390869141, 0.66273536043338, -84.7563934326172, -1.47927812751487, 218, 21, 'PPL', 'P'),
(78773, 'Mortonville', 39.9463882446289, 0.697195999148732, -75.7780609130859, -1.32257666371017, 218, 45, 'PPL', 'P'),
(42181, 'Morvant', 29.8125, 0.52032628325081, -90.8969421386719, -1.5864509203146, 218, 22, 'PPL', 'P'),
(23197, 'Morven', 30.9413890838623, 0.540029114654029, -83.4994430541992, -1.45734020487729, 218, 13, 'PPL', 'P'),
(30567, 'Morven', 39.422779083252, 0.688057295289098, -85.6611099243164, -1.49506840909211, 218, 19, 'PPL', 'P'),
(66978, 'Morven', 34.8638916015625, 0.608489698505665, -80.0013885498047, -1.39628763636138, 218, 33, 'PPL', 'P'),
(42182, 'Morville', 31.5080604553223, 0.549919395862797, -91.5250015258789, -1.59741262451942, 218, 22, 'PPL', 'P'),
(4343, 'Morvin', 31.985559463501, 0.558253325730523, -87.9933319091797, -1.53577336161537, 218, 2, 'PPL', 'P'),
(76642, 'Morvin', 35.2033309936523, 0.6144140335086, -97.0155563354492, -1.69324088370763, 218, 42, 'PPL', 'P'),
(30568, 'Morvins Landing', 38.0102806091309, 0.663404546236289, -86.1675033569336, -1.50390664180176, 218, 19, 'PPL', 'P'),
(104411, 'Morwanda Park', 37.2922210693359, 0.650872043041513, -80.0208282470703, -1.39662692308426, 218, 53, 'PPL', 'P'),
(164803, 'Morwood', 40.3152809143066, 0.703634390821081, -75.392219543457, -1.31584246141974, 218, 45, 'PPL', 'P'),
(104412, 'Moryen', 37.4180603027344, 0.653068351992501, -78.0758285522461, -1.36268027445929, 218, 53, 'PPL', 'P'),
(164804, 'Morysville', 40.3244400024414, 0.703794247065513, -75.6513900756836, -1.32036584053124, 218, 45, 'PPL', 'P'),
(212005, 'Morzhovoi', 54.9069404602051, 0.958306893227069, -163.318603515625, -2.85044736110684, 218, 1, 'PPL', 'P'),
(56387, 'Mosby', 39.315559387207, 0.686185958570127, -94.2936096191406, -1.6457339514442, 218, 29, 'PPL', 'P'),
(197096, 'Mosby', 46.9922218322754, 0.820168993800768, -107.883056640625, -1.88291454549444, 218, 31, 'PPL', 'P'),
(10615, 'Mosby Spur', 34.1794395446777, 0.596543756540978, -90.9672164916992, -1.58767743915464, 218, 4, 'PPL', 'P'),
(104413, 'Mosby Woods', 38.8663902282715, 0.678346477848288, -77.2972183227539, -1.34909096236494, 218, 53, 'PPL', 'P'),
(187086, 'Mosca', 37.6483306884766, 0.65708732839354, -105.873329162598, -1.84783818393506, 218, 7, 'PPL', 'P'),
(60954, 'Moscos', 31.6049995422363, 0.551611302103325, -89.4875030517578, -1.56185156764165, 218, 30, 'PPL', 'P'),
(4345, 'Moscow', 32.4377784729004, 0.56614603638465, -87.9961090087891, -1.53582183114721, 218, 2, 'PPL', 'P'),
(10616, 'Moscow', 34.1463890075684, 0.595966915848867, -91.7949981689453, -1.60212495491026, 218, 4, 'PPL', 'P'),
(27953, 'Moscow', 37.4113883972168, 0.652951905273837, -89.0524978637695, -1.554259294848, 218, 18, 'PPL', 'P'),
(30569, 'Moscow', 39.485279083252, 0.689148126071595, -85.5566711425781, -1.49324560848401, 218, 19, 'PPL', 'P'),
(37282, 'Moscow', 36.6069412231445, 0.638911653427912, -89.0361099243164, -1.55397327134692, 218, 21, 'PPL', 'P'),
(49608, 'Moscow', 39.5436096191406, 0.690166185977305, -79.0052795410156, -1.37890225444924, 218, 25, 'PPL', 'P'),
(60955, 'Moscow', 32.7099990844727, 0.570897182348379, -88.8000030517578, -1.54985242903419, 218, 30, 'PPL', 'P'),
(73554, 'Moscow', 38.8569412231445, 0.678181561597785, -84.2291717529297, -1.47007637331643, 218, 41, 'PPL', 'P'),
(89171, 'Moscow', 35.061939239502, 0.611946281863506, -89.4038925170898, -1.56039228852234, 218, 50, 'PPL', 'P'),
(96349, 'Moscow', 30.9130592346191, 0.539534665508142, -94.8249969482422, -1.6550084099404, 218, 51, 'PPL', 'P'),
(104414, 'Moscow', 38.3169403076172, 0.668756767658049, -79.0891723632813, -1.38036646041656, 218, 53, 'PPL', 'P'),
(116941, 'Moscow', 41.5750007629395, 0.725620649832448, -91.0824966430664, -1.58968945735819, 218, 16, 'PPL', 'P'),
(128198, 'Moscow', 45.0705604553223, 0.786629675664528, -69.8916702270508, -1.21983976518013, 218, 26, 'PPL', 'P'),
(132179, 'Moscow', 42.0494384765625, 0.733901150030804, -84.5100021362305, -1.47497778814466, 218, 27, 'PPL', 'P'),
(136990, 'Moscow', 43.707218170166, 0.762834863956888, -93.0980606079102, -1.62486768482927, 218, 28, 'PPL', 'P'),
(164805, 'Moscow', 41.336669921875, 0.721460991946826, -75.5188903808594, -1.31805328459867, 218, 45, 'PPL', 'P'),
(169494, 'Moscow', 41.5227813720703, 0.724709249528396, -71.741943359375, -1.25213312340038, 218, 47, 'PPL', 'P'),
(172282, 'Moscow', 44.4413909912109, 0.775648596962777, -72.7158279418945, -1.26913061589975, 218, 55, 'PPL', 'P'),
(175405, 'Moscow', 42.8333282470703, 0.747582607498868, -89.8550033569336, -1.56826565796905, 218, 57, 'PPL', 'P'),
(177247, 'Moscow', 40.5455589294434, 0.707653500380174, -80.6324996948242, -1.40730260378801, 218, 58, 'PPL', 'P'),
(187821, 'Moscow', 37.3236083984375, 0.651419855277742, -101.205276489258, -1.76636529512876, 218, 20, 'PPL', 'P'),
(195350, 'Moscow', 46.7324981689453, 0.815635960730317, -116.999168395996, -2.04202071060542, 218, 17, 'PPL', 'P'),
(73555, 'Moscow (historical)', 39.961109161377, 0.697452927614898, -82.4677810668945, -1.43933430643115, 218, 41, 'PPL', 'P'),
(120705, 'Moscow (historical)', 40.1641693115234, 0.700996995814548, -90.1638870239258, -1.5736566949637, 218, 18, 'PPL', 'P'),
(150879, 'Moscow Hill', 42.7936096191406, 0.746889386667121, -75.4063873291016, -1.31608973592696, 218, 40, 'PPL', 'P'),
(56389, 'Moscow Mills', 38.9477806091309, 0.679767007973736, -90.9180603027344, -1.58681950180947, 218, 29, 'PPL', 'P'),
(73556, 'Moscow Mills', 39.6027793884277, 0.69119889326901, -81.6258316040039, -1.42463951616831, 218, 41, 'PPL', 'P'),
(140540, 'Mose', 47.5786094665527, 0.830403388711888, -98.4544372558594, -1.71835409331292, 218, 34, 'PPL', 'P'),
(175407, 'Mosel', 43.8055610656738, 0.764551271279444, -87.7402801513672, -1.53135677526359, 218, 57, 'PPL', 'P'),
(200084, 'Mosel', 40.6738891601563, 0.709893285435958, -116.648330688477, -2.03589743746906, 218, 39, 'PPL', 'P'),
(164807, 'Moselem', 40.500560760498, 0.70686813417471, -75.8844375610352, -1.32443328646412, 218, 45, 'PPL', 'P'),
(164808, 'Moselem Springs', 40.4855613708496, 0.706606345439555, -75.8388900756836, -1.32363833287873, 218, 45, 'PPL', 'P'),
(60956, 'Moseley', 32.4513893127441, 0.566383590353885, -88.8291702270508, -1.55036149227656, 218, 30, 'PPL', 'P'),
(104415, 'Moseley', 37.4749984741211, 0.654062110553264, -77.779167175293, -1.35750255666796, 218, 53, 'PPL', 'P'),
(132181, 'Moseley', 43.0294418334961, 0.751005435289893, -85.351936340332, -1.48967231209139, 218, 27, 'PPL', 'P'),
(194333, 'Moseley', 40.2488899230957, 0.702475649430787, -103.753608703613, -1.8108420827039, 218, 7, 'PPL', 'P'),
(60957, 'Moseley (historical)', 32.2449989318848, 0.562781398663444, -89.8111114501953, -1.56749959968149, 218, 30, 'PPL', 'P'),
(183462, 'Moseley (historical)', 39.6416702270508, 0.691877666451844, -121.429168701172, -2.1193388017951, 218, 6, 'PPL', 'P'),
(37283, 'Moseleyville', 37.6630592346191, 0.657344390017759, -87.1933288574219, -1.5218106743362, 218, 21, 'PPL', 'P'),
(56390, 'Moselle', 38.3866691589355, 0.669973765697188, -90.8977813720703, -1.5864655677006, 218, 29, 'PPL', 'P'),
(60958, 'Moselle', 31.5022201538086, 0.549817463372074, -89.2788925170898, -1.55821062695735, 218, 30, 'PPL', 'P'),
(82478, 'Moselle', 32.9658317565918, 0.575362304811033, -81.0127792358398, -1.4139397338567, 218, 48, 'PPL', 'P'),
(96350, 'Moselle', 32.6291694641113, 0.569486439339936, -97.3536071777344, -1.69914098394465, 218, 51, 'PPL', 'P'),
(140541, 'Moselle', 46.2319412231445, 0.806899593932367, -97.0830612182617, -1.69441906617388, 218, 34, 'PPL', 'P'),
(42183, 'Moselys Bluff', 32.7011108398438, 0.570742053214882, -92.352783203125, -1.61186014027505, 218, 22, 'PPL', 'P'),
(49609, 'Moser', 39.4680595397949, 0.688847588342579, -77.5924987792969, -1.35424457854841, 218, 25, 'PPL', 'P'),
(191912, 'Moser', 30.4925003051758, 0.532194527490693, -101.931938171387, -1.77904793402999, 218, 51, 'PPL', 'P'),
(189071, 'Moses', 36.7122192382813, 0.640749101422012, -103.059722900391, -1.79873149080482, 218, 38, 'PPL', 'P'),
(208182, 'Moses', 46.4294395446777, 0.810346589910283, -117.209716796875, -2.04569547343557, 218, 56, 'PPL', 'P'),
(82479, 'Moses Heights', 33.8938903808594, 0.591559983456031, -80.3272171020508, -1.40197441739508, 218, 48, 'PPL', 'P'),
(208183, 'Moses Lake', 47.1302795410156, 0.822578555376045, -119.27693939209, -2.08177531409369, 218, 56, 'PPL', 'P'),
(212003, 'Moses Point', 64.6999969482422, 1.12922797277711, -162.033325195313, -2.82801502261289, 218, 1, 'PPL', 'P'),
(212004, 'Moses Point Fishing Village', 64.6977767944336, 1.12918922378325, -162.028060913086, -2.82792314355528, 218, 1, 'PPL', 'P'),
(164811, 'Mosgrove', 40.8688888549805, 0.713296672151025, -79.4755630493164, -1.38711025008692, 218, 45, 'PPL', 'P'),
(164810, 'Moshannon', 41.0322189331055, 0.716147319781845, -78.0052795410156, -1.36144896192929, 218, 45, 'PPL', 'P'),
(4346, 'Moshat', 34.1186103820801, 0.595482087372418, -85.6222229003906, -1.49438970248831, 218, 2, 'PPL', 'P'),
(89172, 'Mosheim', 36.1894416809082, 0.631624911790319, -82.958610534668, -1.44790089670961, 218, 50, 'PPL', 'P'),
(96351, 'Mosheim', 31.6261100769043, 0.551979750440137, -97.5997161865234, -1.70343639646684, 218, 51, 'PPL', 'P'),
(56391, 'Mosher', 37.9711112976074, 0.662720912784466, -90.0766677856445, -1.57213443208461, 218, 29, 'PPL', 'P'),
(202400, 'Mosher', 43.4683303833008, 0.758665485533287, -100.297782897949, -1.75052654401967, 218, 49, 'PPL', 'P'),
(128201, 'Mosher Corner', 43.6908302307129, 0.762548840455814, -70.4027786254883, -1.22876028956746, 218, 26, 'PPL', 'P'),
(150881, 'Mosher Corners', 42.5908317565918, 0.743350245315487, -76.4016723632813, -1.33346073676922, 218, 40, 'PPL', 'P'),
(132182, 'Mosherville', 42.0602798461914, 0.734090367626254, -84.6594390869141, -1.47758595495823, 218, 27, 'PPL', 'P'),
(150882, 'Mosherville', 43.0616683959961, 0.751567894912117, -74.019172668457, -1.29187827266677, 218, 40, 'PPL', 'P'),
(164812, 'Mosherville', 41.9769401550293, 0.73263581561788, -76.9069366455078, -1.34227926208679, 218, 45, 'PPL', 'P'),
(150883, 'Moshier Falls', 43.8699989318848, 0.765675924207785, -75.1397171020508, -1.31143546244788, 218, 40, 'PPL', 'P'),
(89173, 'Moshina Heights', 35.985279083252, 0.628061602251793, -83.8016662597656, -1.46261499489035, 218, 50, 'PPL', 'P'),
(204980, 'Mosida', 40.1272201538086, 0.700352111356585, -111.955833435059, -1.95399791025613, 218, 52, 'PPL', 'P'),
(190508, 'Mosier', 39.2605590820313, 0.685226022155208, -114.826110839844, -2.00409370141522, 218, 39, 'PPL', 'P'),
(201262, 'Mosier', 45.6836090087891, 0.797329391397112, -121.396110534668, -2.11876182794493, 218, 43, 'PPL', 'P'),
(164813, 'Mosiertown', 41.7724990844727, 0.729067645810365, -80.2063903808594, -1.3998655932859, 218, 45, 'PPL', 'P'),
(175413, 'Mosinee', 44.7930603027344, 0.781786384327083, -89.7030563354492, -1.56561368215555, 218, 57, 'PPL', 'P'),
(209623, 'Moskee', 44.271671295166, 0.772686429461309, -104.178329467773, -1.81825485844008, 218, 59, 'PPL', 'P'),
(10617, 'Mosley', 35.1811103820801, 0.614026210674858, -93.2516708374023, -1.62754868909865, 218, 4, 'PPL', 'P'),
(49610, 'Mosley Acres', 38.3963890075684, 0.670143409058626, -76.4577789306641, -1.33443998110204, 218, 25, 'PPL', 'P'),
(189073, 'Mosley Place', 35.0825004577637, 0.612305142820394, -106.16194152832, -1.85287541997889, 218, 38, 'PPL', 'P'),
(175412, 'Mosling', 44.8688888549805, 0.783109842230798, -88.3694381713867, -1.54233765422826, 218, 57, 'PPL', 'P'),
(189072, 'Mosquero', 35.7769393920898, 0.624425388678426, -103.956108093262, -1.81437636378654, 218, 38, 'PPL', 'P'),
(23199, 'Mosquito Crossing', 33.4744415283203, 0.584239219935512, -83.1172180175781, -1.45066911950469, 218, 13, 'PPL', 'P'),
(17194, 'Mosquito Grove', 29.063060760498, 0.507246100977858, -81.456672668457, -1.42168713578385, 218, 12, 'PPL', 'P'),
(193274, 'Mosquito Lake', 59.5291709899902, 1.03898003475802, -136.091110229492, -2.37523795619917, 218, 1, 'PPL', 'P'),
(17191, 'Mosquito Landing', 30.2761096954346, 0.528417798880311, -85.0569381713867, -1.48452362275594, 218, 12, 'PPL', 'P'),
(150885, 'Mosquito Point', 42.2602806091309, 0.737581039446048, -74.399169921875, -1.29851047588745, 218, 40, 'PPL', 'P'),
(172283, 'Mosquitoville', 44.2702789306641, 0.772662128116362, -72.1444396972656, -1.25915800972379, 218, 55, 'PPL', 'P'),
(4348, 'Moss', 32.1744384765625, 0.561549886396364, -86.6719436645508, -1.51271078604945, 218, 2, 'PPL', 'P'),
(42184, 'Moss', 32.3144416809082, 0.563993403275539, -93.5841674804688, -1.63335185027199, 218, 22, 'PPL', 'P'),
(60959, 'Moss', 31.8150005340576, 0.55527651084306, -89.1777801513672, -1.556445883261, 218, 30, 'PPL', 'P'),
(89174, 'Moss', 36.589168548584, 0.638601461739945, -85.616943359375, -1.49429755711459, 218, 50, 'PPL', 'P'),
(110535, 'Moss', 38.8708305358887, 0.678423975836009, -80.8050003051758, -1.41031330740034, 218, 58, 'PPL', 'P'),
(183464, 'Moss', 36.7986106872559, 0.642256916652188, -121.785003662109, -2.12554929345716, 218, 6, 'PPL', 'P'),
(195351, 'Moss', 43.6158294677734, 0.761239830201012, -116.619171142578, -2.03538850738475, 218, 17, 'PPL', 'P'),
(4347, 'Moss (historical)', 32.127498626709, 0.560730631466028, -87.8166732788086, -1.53269008686333, 218, 2, 'PPL', 'P'),
(197097, 'Moss Agate', 46.3658294677734, 0.809236384630857, -110.827499389648, -1.93430476610137, 218, 31, 'PPL', 'P'),
(183465, 'Moss Beach', 37.5275001525879, 0.654978437705333, -122.512222290039, -2.13824165289637, 218, 6, 'PPL', 'P'),
(17192, 'Moss Bluff', 29.0830593109131, 0.507595141528227, -81.8838882446289, -1.42914345420385, 218, 12, 'PPL', 'P'),
(42185, 'Moss Bluff', 30.3024997711182, 0.52887839259084, -93.190559387207, -1.62648209308207, 218, 22, 'PPL', 'P'),
(96352, 'Moss Bluff', 29.937219619751, 0.522503051257299, -94.7630615234375, -1.65392743285394, 218, 51, 'PPL', 'P'),
(23200, 'Moss Creek', 33.0902786254883, 0.577534312417074, -85.0444412231445, -1.48430550986267, 218, 13, 'PPL', 'P'),
(82483, 'Moss Creek', 33.538890838623, 0.585364072600934, -79.0527801513672, -1.37973129649658, 218, 48, 'PPL', 'P'),
(82480, 'Moss Grove', 33.3333282470703, 0.581776328559407, -80.1769409179688, -1.39935160319552, 218, 48, 'PPL', 'P'),
(66980, 'Moss Hill', 35.1961097717285, 0.614287999410012, -77.7466735839844, -1.35693543651383, 218, 33, 'PPL', 'P'),
(96353, 'Moss Hill', 30.2472190856934, 0.527913562617418, -94.7413864135742, -1.65354913082109, 218, 51, 'PPL', 'P'),
(49611, 'Moss Hill Acres', 38.377498626709, 0.669813709715674, -75.5719375610352, -1.31897913255164, 218, 25, 'PPL', 'P'),
(42189, 'Moss Lake', 30.1136093139648, 0.525581632187917, -93.3408279418945, -1.62910477412358, 218, 22, 'PPL', 'P'),
(183466, 'Moss Landing', 36.8044395446777, 0.642358649405829, -121.785827636719, -2.12556367452705, 218, 6, 'PPL', 'P'),
(66981, 'Moss Neck', 34.6672210693359, 0.605057150176662, -79.1530609130859, -1.38148152596498, 218, 33, 'PPL', 'P'),
(104417, 'Moss Neck', 38.2205581665039, 0.6670745819555, -77.2994384765625, -1.34912971135881, 218, 53, 'PPL', 'P'),
(23201, 'Moss Oak', 32.4194412231445, 0.56582599100065, -83.7744369506836, -1.46213975379383, 218, 13, 'PPL', 'P'),
(60960, 'Moss Point', 30.4113903045654, 0.530778890923748, -88.5344390869141, -1.54521746347301, 218, 30, 'PPL', 'P'),
(82485, 'Moss Point', 32.9700012207031, 0.575435075687819, -80.1458282470703, -1.39880858464925, 218, 48, 'PPL', 'P'),
(82486, 'Moss Pond (historical)', 33.3805618286133, 0.582600710074841, -80.1449966430664, -1.39879407042131, 218, 48, 'PPL', 'P'),
(73557, 'Moss Run', 39.4736099243164, 0.688944460827231, -81.3150024414063, -1.41921452386977, 218, 41, 'PPL', 'P'),
(104418, 'Moss Run', 37.788330078125, 0.659530778693687, -80.101936340332, -1.39804252636169, 218, 53, 'PPL', 'P'),
(17193, 'Moss Town', 28.458890914917, 0.496701347931203, -82.1805572509766, -1.43432130515324, 218, 12, 'PPL', 'P'),
(4350, 'Mossboro', 33.2508316040039, 0.580336490516056, -86.8983306884766, -1.51666198500075, 218, 2, 'PPL', 'P'),
(183468, 'Mossdale', 37.7847213745117, 0.659467794933907, -121.307502746582, -2.11721533029992, 218, 6, 'PPL', 'P'),
(164814, 'Mosserville', 40.6941719055176, 0.710247286123857, -75.7630615234375, -1.32231487497502, 218, 45, 'PPL', 'P'),
(104419, 'Mossingford', 36.9638900756836, 0.645141586165935, -78.6425018310547, -1.37257058895757, 218, 53, 'PPL', 'P'),
(197098, 'Mossmain', 45.6847190856934, 0.797348765894043, -108.71028137207, -1.89735234071209, 218, 31, 'PPL', 'P'),
(189074, 'Mossman', 33.0538902282715, 0.576899215076118, -104.353057861328, -1.82130444420433, 218, 38, 'PPL', 'P'),
(10619, 'Mossville', 35.8950004577637, 0.626485942992848, -93.3899993896484, -1.62996297778486, 218, 4, 'PPL', 'P'),
(42187, 'Mossville', 30.2474994659424, 0.527918456175921, -93.3088912963867, -1.62854737450743, 218, 22, 'PPL', 'P'),
(120706, 'Mossville', 40.815559387207, 0.712365897350042, -89.5677795410156, -1.56325265669114, 218, 18, 'PPL', 'P'),
(164815, 'Mossville', 41.2719383239746, 0.720331212433387, -76.2794418334961, -1.33132741157801, 218, 45, 'PPL', 'P'),
(104420, 'Mosswood Hills', 39.3086090087891, 0.686064651582474, -78.3408279418945, -1.36730538632443, 218, 53, 'PPL', 'P'),
(110536, 'Mossy', 37.9761085510254, 0.662808131310166, -81.2819366455078, -1.41863741686155, 218, 58, 'PPL', 'P'),
(37285, 'Mossy Bottom', 37.5299987792969, 0.655022046968183, -82.5794372558594, -1.44128307455882, 218, 21, 'PPL', 'P'),
(23203, 'Mossy Creek', 34.5411109924316, 0.602856114114738, -83.6855621337891, -1.46058859561691, 218, 13, 'PPL', 'P'),
(23204, 'Mossy Dell', 31.7605590820313, 0.554326328255633, -84.1133270263672, -1.46805450141684, 218, 13, 'PPL', 'P'),
(4355, 'Mossy Grove', 31.7544403076172, 0.554219535495921, -85.9599990844727, -1.50028500903536, 218, 2, 'PPL', 'P'),
(96354, 'Mossy Grove', 30.8519401550293, 0.538467936333511, -95.751106262207, -1.67117206670247, 218, 51, 'PPL', 'P'),
(4352, 'Mossy Grove Estates', 31.7241706848145, 0.553691230914676, -85.9594421386719, -1.50027528849738, 218, 2, 'PPL', 'P'),
(4353, 'Mossy Grove Village', 31.7333297729492, 0.553851087159108, -85.9569396972656, -1.5002316126555, 218, 2, 'PPL', 'P'),
(17195, 'Mossy Head', 30.7430591583252, 0.536567604448171, -86.3150024414063, -1.50648098646948, 218, 12, 'PPL', 'P'),
(23205, 'Mossy Oaks', 31.563060760498, 0.550879332277716, -83.9805603027344, -1.46573728495236, 218, 13, 'PPL', 'P'),
(56393, 'Mossy Resort (historical)', 37.8688888549805, 0.660936794591195, -92.1224975585938, -1.6078408975579, 218, 29, 'PPL', 'P'),
(89175, 'Mossy Spring', 36.3547210693359, 0.634509581304066, -83.9205627441406, -1.46469013001174, 218, 50, 'PPL', 'P'),
(208184, 'Mossyrock', 46.5297203063965, 0.812096819378683, -122.48388671875, -2.13774710388194, 218, 56, 'PPL', 'P'),
(4354, 'Mostellers', 33.1063919067383, 0.577815542228187, -86.5086135864258, -1.50986013841863, 218, 2, 'PPL', 'P'),
(164816, 'Mostoller', 40.0719413757324, 0.699387314672677, -78.9416732788086, -1.37779211574884, 218, 45, 'PPL', 'P'),
(96355, 'Mostyn', 30.2280597686768, 0.527579169453045, -95.6900024414063, -1.67010560384395, 218, 51, 'PPL', 'P'),
(42188, 'Mot', 32.9066696166992, 0.574329730677382, -93.5711135864258, -1.63312401684073, 218, 22, 'PPL', 'P'),
(89176, 'Motch', 36.5825004577637, 0.638485081600309, -83.7841720581055, -1.46230966347137, 218, 50, 'PPL', 'P'),
(23206, 'Motes Hill', 34.084171295166, 0.594881011914387, -84.579719543457, -1.47619458644672, 218, 13, 'PPL', 'P'),
(183469, 'Mother Lode Acres', 38.107780456543, 0.665106239593823, -120.902496337891, -2.11014663497658, 218, 6, 'PPL', 'P'),
(183470, 'Mother Lode West', 37.9466705322266, 0.662294340956863, -120.415283203125, -2.10164316161596, 218, 6, 'PPL', 'P'),
(66982, 'Mother Vineyard', 35.9219398498535, 0.626956124083301, -75.6738891601563, -1.32075852363397, 218, 33, 'PPL', 'P'),
(193804, 'Motion', 40.6744384765625, 0.709902872815882, -122.459442138672, -2.13732046547531, 218, 6, 'PPL', 'P'),
(66983, 'Motleta', 35.7338905334473, 0.623674044355888, -79.9572219848633, -1.39551678438386, 218, 33, 'PPL', 'P'),
(4356, 'Motley', 33.1169395446777, 0.577999633238538, -85.6588897705078, -1.49502966009825, 218, 2, 'PPL', 'P'),
(37284, 'Motley', 36.9075012207031, 0.644157414985096, -86.2880630493164, -1.50601080537903, 218, 21, 'PPL', 'P'),
(56394, 'Motley', 37.0602798461914, 0.646823905026538, -94.1858291625977, -1.64385282760822, 218, 29, 'PPL', 'P'),
(104421, 'Motley', 37.0694389343262, 0.64698376127097, -79.3413925170898, -1.38476853254041, 218, 53, 'PPL', 'P'),
(136993, 'Motley', 46.336669921875, 0.808727454546542, -94.6458282470703, -1.65188132618843, 218, 28, 'PPL', 'P'),
(104423, 'Motleys Mill', 36.8219413757324, 0.642664113982861, -79.311393737793, -1.3842449550701, 218, 53, 'PPL', 'P'),
(192712, 'Motoqua', 37.3038902282715, 0.651075708285876, -113.998893737793, -1.98965603935563, 218, 52, 'PPL', 'P'),
(116943, 'Motor', 42.8069381713867, 0.747122013788339, -91.3511123657227, -1.59437768614117, 218, 16, 'PPL', 'P'),
(183471, 'Motor City', 38.7338905334473, 0.676033921915718, -120.739440917969, -2.10730078103572, 218, 6, 'PPL', 'P'),
(183472, 'Motordrome (historical)', 33.9686088562012, 0.592864066862815, -118.438331604004, -2.06713884705872, 218, 6, 'PPL', 'P'),
(104422, 'Motorun', 37.3372192382813, 0.651657409246977, -76.3008270263672, -1.33170065360478, 218, 53, 'PPL', 'P'),
(17196, 'Mott', 26.6891708374023, 0.465813905739923, -80.8686065673828, -1.41142344610074, 218, 12, 'PPL', 'P'),
(73558, 'Mott', 38.4455604553223, 0.671001612719904, -82.3608322143555, -1.43746769682312, 218, 41, 'PPL', 'P'),
(193807, 'Mott', 41.2599983215332, 0.720122820078088, -122.274436950684, -2.13409151581164, 218, 6, 'PPL', 'P'),
(198646, 'Mott', 46.372501373291, 0.80935283134952, -102.326667785645, -1.78593726545391, 218, 34, 'PPL', 'P'),
(56395, 'Mott (historical)', 36.5752792358398, 0.638359047501721, -91.8050003051758, -1.60229952511972, 218, 29, 'PPL', 'P'),
(150886, 'Mott Haven', 40.8088912963867, 0.712249517210405, -73.9233322143555, -1.29020554118609, 218, 40, 'PPL', 'P'),
(30570, 'Mott Station', 38.2980613708496, 0.668427268052179, -86.0905609130859, -1.50256374282209, 218, 19, 'PPL', 'P'),
(164817, 'Mottarns Mill', 40.8352813720703, 0.712710110920935, -79.0577774047852, -1.37981851502228, 218, 45, 'PPL', 'P'),
(49612, 'Motters', 39.6588897705078, 0.69217820418086, -77.3305587768555, -1.34967286306313, 218, 25, 'PPL', 'P'),
(4357, 'Motts', 32.5722198486328, 0.568492481042092, -85.1386108398438, -1.48594907972941, 218, 2, 'PPL', 'P'),
(150887, 'Motts Corner', 43.0272216796875, 0.750966686296032, -77.4005584716797, -1.3508945882132, 218, 40, 'PPL', 'P'),
(82487, 'Motts Crossroads', 33.9786109924316, 0.59303863707227, -79.9055633544922, -1.39461517119681, 218, 48, 'PPL', 'P'),
(190509, 'Mottsville', 38.9286117553711, 0.679432448361795, -119.836669921875, -2.09154445476237, 218, 39, 'PPL', 'P'),
(132183, 'Mottville', 41.7994384765625, 0.729537826900818, -85.7569427490234, -1.49674100741474, 218, 27, 'PPL', 'P'),
(150888, 'Mottville', 42.9736099243164, 0.750030984647033, -76.4427795410156, -1.33417819236688, 218, 40, 'PPL', 'P'),
(197099, 'Mouat (historical)', 45.3499984741211, 0.791506789147818, -109.91667175293, -1.91840782492247, 218, 31, 'PPL', 'P'),
(164818, 'Moudy Hill', 40.3813896179199, 0.704788205363358, -78.6897201538086, -1.3733947041569, 218, 45, 'PPL', 'P'),
(78775, 'Moulstown', 39.8519401550293, 0.695547569013001, -76.9330596923828, -1.34273519526542, 218, 45, 'PPL', 'P'),
(4358, 'Moulton', 34.4811096191406, 0.601808892595092, -87.293327331543, -1.52355597695658, 218, 2, 'PPL', 'P'),
(66984, 'Moulton', 36.1713905334473, 0.631309859833363, -78.2525024414063, -1.36576381552744, 218, 33, 'PPL', 'P'),
(96356, 'Moulton', 29.5747203826904, 0.516176246034625, -97.1425018310547, -1.69545650057652, 218, 51, 'PPL', 'P'),
(116945, 'Moulton', 40.6858291625977, 0.710101677791256, -92.6772232055664, -1.61752268654283, 218, 16, 'PPL', 'P'),
(156616, 'Moulton', 40.5561103820801, 0.707837657969553, -84.2972183227539, -1.47126401000455, 218, 41, 'PPL', 'P'),
(197100, 'Moulton', 47.3458290100098, 0.826340603310918, -109.353889465332, -1.90858542103199, 218, 31, 'PPL', 'P'),
(208185, 'Moulton', 45.8347206115723, 0.799966786403645, -122.383613586426, -2.1359970075716, 218, 56, 'PPL', 'P'),
(73559, 'Moulton (historical)', 38.7174987792969, 0.675747831835616, -82.6277770996094, -1.44212676399215, 218, 41, 'PPL', 'P'),
(4359, 'Moulton Heights', 34.5972213745117, 0.603835425026588, -87.0144424438477, -1.51868851743224, 218, 2, 'PPL', 'P'),
(144168, 'Moultonborough', 43.7547187805176, 0.76366390600423, -71.397216796875, -1.24611650986567, 218, 36, 'PPL', 'P'),
(144169, 'Moultonborough Falls', 43.7438888549805, 0.763474888145862, -71.4111099243164, -1.24635899068292, 218, 36, 'PPL', 'P'),
(144171, 'Moultonville', 43.7544403076172, 0.76365904573524, -71.170280456543, -1.24215572353445, 218, 36, 'PPL', 'P'),
(17197, 'Moultrie', 29.8199996948242, 0.520457177618387, -81.3227767944336, -1.41935021192731, 218, 12, 'PPL', 'P'),
(23208, 'Moultrie', 31.1797199249268, 0.544188772539651, -83.7891693115234, -1.46239688199707, 218, 13, 'PPL', 'P'),
(156618, 'Moultrie', 40.7963905334473, 0.712031337738101, -81.0711135864258, -1.41495786034144, 218, 41, 'PPL', 'P'),
(17207, 'Moultrie Junction', 29.8911094665527, 0.521698277265391, -81.334716796875, -1.4195586042826, 218, 12, 'PPL', 'P'),
(56396, 'Mounce', 37.6661109924316, 0.657397653239561, -91.3869400024414, -1.59500299636512, 218, 29, 'PPL', 'P'),
(42190, 'Mound', 32.339168548584, 0.564424968530186, -91.0238876342773, -1.58866653718349, 218, 22, 'PPL', 'P'),
(96357, 'Mound', 31.3516693115234, 0.547189855482548, -97.6372222900391, -1.70409100146278, 218, 51, 'PPL', 'P'),
(136997, 'Mound', 44.9366683959961, 0.784292818387011, -93.6658325195313, -1.6347771740874, 218, 28, 'PPL', 'P'),
(198640, 'Mound', 46.4025001525879, 0.80987640881983, -103.738059997559, -1.81057070658882, 218, 34, 'PPL', 'P'),
(110537, 'Mound (historical)', 38.3713912963867, 0.669707116693044, -81.7091674804688, -1.42609400159766, 218, 58, 'PPL', 'P'),
(201263, 'Mound (historical)', 43.8944396972656, 0.766102496035388, -123.449996948242, -2.15460890832378, 218, 43, 'PPL', 'P'),
(60961, 'Mound Bayou', 33.878059387207, 0.591283680492935, -90.7272186279297, -1.58348868623411, 218, 30, 'PPL', 'P'),
(89177, 'Mound Bottom (historical)', 36.1388893127441, 0.630742606521176, -87.1013870239258, -1.52020598662137, 218, 50, 'PPL', 'P'),
(10620, 'Mound City', 35.1902809143066, 0.614186266656371, -90.1291732788086, -1.5730508258157, 218, 4, 'PPL', 'P'),
(27955, 'Mound City', 37.0852813720703, 0.647260263971147, -89.1624984741211, -1.55617916767783, 218, 18, 'PPL', 'P'),
(33350, 'Mound City', 38.1427803039551, 0.66571710216886, -94.8133316040039, -1.65480481127506, 218, 20, 'PPL', 'P'),
(60963, 'Mound City', 34.452220916748, 0.601304689621713, -88.9188919067383, -1.55192743099752, 218, 30, 'PPL', 'P'),
(96359, 'Mound City', 31.5766696929932, 0.551116852957438, -95.4055633544922, -1.66514120525593, 218, 51, 'PPL', 'P'),
(139345, 'Mound City', 40.1311111450195, 0.700420021964382, -95.2313919067383, -1.66210134002966, 218, 29, 'PPL', 'P'),
(202403, 'Mound City', 45.7252807617188, 0.798056700690813, -100.068061828613, -1.74651715499856, 218, 49, 'PPL', 'P'),
(204984, 'Mound City', 40.5252799987793, 0.707299566271302, -111.491111755371, -1.94588698684018, 218, 52, 'PPL', 'P'),
(183473, 'Mound City (historical)', 34.0563888549805, 0.594396116858911, -117.264717102051, -2.04665540985049, 218, 6, 'PPL', 'P'),
(73560, 'Mound Crossing', 39.5061111450195, 0.689511714139418, -82.6230621337891, -1.44204447231447, 218, 41, 'PPL', 'P'),
(17198, 'Mound Grove', 29.4019393920898, 0.513160648863788, -81.1130599975586, -1.4156899633251, 218, 12, 'PPL', 'P'),
(76650, 'Mound Grove', 34.0819396972656, 0.594842063183445, -95.0869369506836, -1.65958012542569, 218, 42, 'PPL', 'P'),
(30571, 'Mound Haven', 39.3838882446289, 0.687378522106264, -84.9783325195313, -1.48315169532039, 218, 19, 'PPL', 'P'),
(190510, 'Mound House (historical)', 39.2172203063965, 0.684469617826598, -119.674171447754, -2.08870832135949, 218, 39, 'PPL', 'P'),
(60964, 'Mound Landing', 33.6072196960449, 0.586556636137072, -91.1269378662109, -1.59046510302568, 218, 30, 'PPL', 'P'),
(96360, 'Mound Prairie', 31.8697204589844, 0.556231553699476, -95.5680618286133, -1.66797733865881, 218, 51, 'PPL', 'P'),
(33352, 'Mound Valley', 37.2052803039551, 0.649354640431413, -95.4047164916992, -1.66512642471188, 218, 20, 'PPL', 'P'),
(195352, 'Mound Valley', 42.3572196960449, 0.739272945686576, -111.711669921875, -1.94973645303784, 218, 17, 'PPL', 'P'),
(156619, 'Mound View', 41.6163902282715, 0.726343032278132, -83.4861068725586, -1.45710744459801, 218, 41, 'PPL', 'P'),
(33357, 'Moundridge', 38.2030601501465, 0.666769183957495, -97.5188903808594, -1.70202572003742, 218, 20, 'PPL', 'P'),
(10623, 'Mounds', 36.1572189331055, 0.631062518747122, -90.2938919067383, -1.57592570821244, 218, 4, 'PPL', 'P'),
(27958, 'Mounds', 37.1141700744629, 0.647764466944527, -89.1977767944336, -1.55679489052186, 218, 18, 'PPL', 'P'),
(76645, 'Mounds', 35.8763885498047, 0.626161103918885, -96.0608291625977, -1.67657775108312, 218, 42, 'PPL', 'P'),
(137001, 'Mounds View', 45.1049995422363, 0.787230751122559, -93.2083282470703, -1.62679221819101, 218, 28, 'PPL', 'P'),
(73561, 'Moundsville', 39.6666717529297, 0.692314025396454, -81.4824981689453, -1.42213787579835, 218, 41, 'PPL', 'P'),
(110538, 'Moundsville', 39.920280456543, 0.69674033228622, -80.7433319091797, -1.40923699084578, 218, 58, 'PPL', 'P'),
(4360, 'Moundville', 32.997501373291, 0.575915043895279, -87.629997253418, -1.52943197558573, 218, 2, 'PPL', 'P'),
(56398, 'Moundville', 37.7641716003418, 0.659109133714101, -94.4519424438477, -1.64849738054932, 218, 29, 'PPL', 'P'),
(71138, 'Mount', 39.6852798461914, 0.692638797891389, -74.6061096191406, -1.30212225495782, 218, 37, 'PPL', 'P'),
(156621, 'Mount Acres Trailer Park', 40.6697196960449, 0.709820514559171, -80.5875015258789, -1.40651723758254, 218, 41, 'PPL', 'P'),
(10624, 'Mount Adams', 34.4883308410645, 0.60193492669368, -91.2563934326172, -1.5927245288945, 218, 4, 'PPL', 'P'),
(73562, 'Mount Adams', 39.1091690063477, 0.682583766879686, -84.4961090087891, -1.47473530732741, 218, 41, 'PPL', 'P'),
(37295, 'Mount Aerial', 36.7533302307129, 0.641466623598707, -86.3927764892578, -1.5078383996771, 218, 21, 'PPL', 'P'),
(49613, 'Mount Aetna', 39.6022186279297, 0.691189106152004, -77.6244430541992, -1.35480211132262, 218, 25, 'PPL', 'P'),
(164819, 'Mount Aetna', 40.4191703796387, 0.705447604049261, -76.2955627441406, -1.33160877454717, 218, 45, 'PPL', 'P'),
(49614, 'Mount Air', 38.4355583190918, 0.670827042510449, -77.0066680908203, -1.34401990417527, 218, 25, 'PPL', 'P'),
(156622, 'Mount Air', 40.1324996948242, 0.700444256730302, -83.0363922119141, -1.44925844307528, 218, 41, 'PPL', 'P'),
(164820, 'Mount Air', 40.901668548584, 0.713868785732201, -80.4416732788086, -1.40397205452875, 218, 45, 'PPL', 'P'),
(204986, 'Mount Aire', 40.7261085510254, 0.71080468574001, -111.71639251709, -1.94981887787357, 218, 52, 'PPL', 'P'),
(23207, 'Mount Airy', 34.5186080932617, 0.602463364432979, -83.5008316040039, -1.45736443964321, 218, 13, 'PPL', 'P'),
(42191, 'Mount Airy', 30.0511093139648, 0.524490801405421, -90.6377792358398, -1.58192767436116, 218, 22, 'PPL', 'P'),
(49615, 'Mount Airy', 39.3761100769043, 0.687242767469698, -77.1549987792969, -1.34660876307094, 218, 25, 'PPL', 'P'),
(56400, 'Mount Airy', 39.3769416809082, 0.687257281697639, -92.6347198486328, -1.61678086302119, 218, 29, 'PPL', 'P'),
(66985, 'Mount Airy', 36.4991683959961, 0.637030662749989, -80.6074981689453, -1.4068662448434, 218, 33, 'PPL', 'P'),
(73563, 'Mount Airy', 39.1913909912109, 0.684018811233075, -84.5702819824219, -1.4760298699333, 218, 41, 'PPL', 'P'),
(89179, 'Mount Airy', 35.4402809143066, 0.618549589786357, -85.3483276367188, -1.48960932833161, 218, 50, 'PPL', 'P'),
(104427, 'Mount Airy', 38.7197189331055, 0.675786580829477, -78.6291732788086, -1.37233796183636, 218, 53, 'PPL', 'P'),
(145821, 'Mount Airy', 40.398609161377, 0.705088743092373, -74.9075012207031, -1.30738253074294, 218, 37, 'PPL', 'P'),
(150890, 'Mount Airy', 41.2269401550293, 0.719545846227923, -73.8713912963867, -1.28929900115103, 218, 40, 'PPL', 'P'),
(164825, 'Mount Airy', 40.0988883972168, 0.699857628921185, -76.9069366455078, -1.34227926208679, 218, 45, 'PPL', 'P'),
(190512, 'Mount Airy', 39.5036087036133, 0.689468038297541, -117.378608703613, -2.04864319328812, 218, 39, 'PPL', 'P'),
(73564, 'Mount Airy Center', 39.1666717529297, 0.683587379136482, -84.5813903808594, -1.47622374806066, 218, 41, 'PPL', 'P'),
(49617, 'Mount Airy Estates', 39.3972206115723, 0.68761121580651, -77.2333297729492, -1.34797589681653, 218, 25, 'PPL', 'P'),
(49618, 'Mount Airy Overview Estates', 39.3958282470703, 0.687586914461563, -77.1883316040039, -1.34719053061106, 218, 25, 'PPL', 'P'),
(89180, 'Mount Airy Springs', 36.1955604553223, 0.631731704550031, -83.2458267211914, -1.45291376482947, 218, 50, 'PPL', 'P'),
(164826, 'Mount Airy Terrace', 41.3161087036133, 0.721102130989938, -75.9419403076172, -1.32543689872092, 218, 45, 'PPL', 'P'),
(164827, 'Mount Allen', 40.1791687011719, 0.701258784549703, -76.9741668701172, -1.34345265086308, 218, 45, 'PPL', 'P'),
(164828, 'Mount Allen Estates', 40.185001373291, 0.701360583882371, -76.9791717529297, -1.34354000254684, 218, 45, 'PPL', 'P'),
(110539, 'Mount Alto', 38.8644409179688, 0.678312455965362, -81.8783264160156, -1.42904638198212, 218, 58, 'PPL', 'P'),
(164829, 'Mount Alton', 41.7941703796387, 0.729445881264183, -78.628059387207, -1.3723185207604, 218, 45, 'PPL', 'P'),
(78776, 'Mount Alverno', 39.8833312988281, 0.696095447828257, -75.4266662597656, -1.31644367003583, 218, 45, 'PPL', 'P'),
(4362, 'Mount Andrew', 32.3444404602051, 0.564516980745849, -85.7361068725586, -1.49637735276789, 218, 2, 'PPL', 'P'),
(201264, 'Mount Angel', 45.0680618286133, 0.786586066401678, -122.798889160156, -2.1432449336363, 218, 43, 'PPL', 'P'),
(197101, 'Mount Aqua Trailer Court', 45.5224990844727, 0.794517492760152, -108.861106872559, -1.89998474229157, 218, 31, 'PPL', 'P'),
(150891, 'Mount Arab', 44.1741714477539, 0.770984736103776, -74.6016693115234, -1.3020447569701, 218, 40, 'PPL', 'P'),
(89181, 'Mount Ararat', 35.9019393920898, 0.626607050243419, -85.9444427490234, -1.50001349976223, 218, 50, 'PPL', 'P'),
(164830, 'Mount Ararat', 40.3830604553223, 0.704817366977294, -76.4805603027344, -1.33483759105279, 218, 45, 'PPL', 'P'),
(145822, 'Mount Arlington', 40.9258308410645, 0.714290497290815, -74.6352767944336, -1.30263131820019, 218, 37, 'PPL', 'P'),
(104428, 'Mount Athos (historical)', 37.3875007629395, 0.652534987405185, -79.0444412231445, -1.37958575474301, 218, 53, 'PPL', 'P'),
(27960, 'Mount Auburn', 39.7661094665527, 0.694049540899831, -89.2616729736328, -1.55791008922833, 218, 18, 'PPL', 'P'),
(30574, 'Mount Auburn', 39.8127784729004, 0.694864068719232, -85.1897201538086, -1.48684110553653, 218, 19, 'PPL', 'P'),
(37286, 'Mount Auburn', 38.7894401550293, 0.677003445710561, -84.2727813720703, -1.47083750475597, 218, 21, 'PPL', 'P'),
(73565, 'Mount Auburn', 39.1180610656738, 0.68273896259221, -84.5036087036133, -1.47486620169499, 218, 41, 'PPL', 'P'),
(116947, 'Mount Auburn', 42.2550010681152, 0.737488894072332, -92.0924987792969, -1.60731732008759, 218, 16, 'PPL', 'P'),
(125484, 'Mount Auburn', 42.375, 0.739583270532597, -71.1500015258789, -1.24180178942558, 218, 23, 'PPL', 'P'),
(49620, 'Mount Augustine', 39.2083282470703, 0.684314422114074, -76.7152786254883, -1.3389341985996, 218, 25, 'PPL', 'P'),
(116948, 'Mount Ayr', 40.7147216796875, 0.710605947343663, -94.2350006103516, -1.6447110312695, 218, 16, 'PPL', 'P'),
(123253, 'Mount Ayr', 40.9519386291504, 0.714746164153327, -87.2991714477539, -1.52365797602633, 218, 19, 'PPL', 'P'),
(193257, 'Mount Baker', 47.5786094665527, 0.830403388711888, -122.288330078125, -2.1343339966289, 218, 56, 'PPL', 'P'),
(183474, 'Mount Baldy', 34.2361106872559, 0.597532854569833, -117.659172058105, -2.05353994758445, 218, 6, 'PPL', 'P'),
(23209, 'Mount Berry', 34.2750015258789, 0.598211627752667, -85.1833267211914, -1.48672951908686, 218, 13, 'PPL', 'P'),
(23210, 'Mount Bethel', 33.9661102294922, 0.592820457599965, -84.4113922119141, -1.4732567202902, 218, 13, 'PPL', 'P'),
(96361, 'Mount Bethel', 33.0483283996582, 0.576802142854384, -96.1091690063477, -1.67742144051645, 218, 51, 'PPL', 'P'),
(145825, 'Mount Bethel', 40.8261108398438, 0.712550054939421, -74.9016723632813, -1.3072807979893, 218, 37, 'PPL', 'P'),
(164831, 'Mount Bethel', 40.9047203063965, 0.713922048954002, -75.1119384765625, -1.31095063397143, 218, 45, 'PPL', 'P'),
(82489, 'Mount Bethel (historical)', 34.3380584716797, 0.599312179073143, -81.5625, -1.42353417115788, 218, 48, 'PPL', 'P'),
(889, 'Mount Beulah', 33.4433288574219, 0.583696201389245, -81.5363922119141, -1.42307850429536, 218, 48, 'PPL', 'P'),
(37287, 'Mount Beulah', 37.2983283996582, 0.650978636064143, -85.9394378662109, -1.49992614807847, 218, 21, 'PPL', 'P'),
(156623, 'Mount Blanchard', 40.8983306884766, 0.713810529083355, -83.5561065673828, -1.45832916974809, 218, 41, 'PPL', 'P'),
(73566, 'Mount Blanco', 39.1883316040039, 0.683965414853219, -82.2630615234375, -1.43576127635465, 218, 41, 'PPL', 'P'),
(104429, 'Mount Blanco', 37.3619384765625, 0.65208884134357, -77.313606262207, -1.34937698586602, 218, 53, 'PPL', 'P'),
(191915, 'Mount Blanco', 33.815559387207, 0.590192849710439, -101.192779541016, -1.76614718223548, 218, 51, 'PPL', 'P'),
(125485, 'Mount Bowdoin', 42.3041687011719, 0.738347031154582, -71.0749969482422, -1.24049271259175, 218, 23, 'PPL', 'P'),
(78777, 'Mount Braddock', 39.9427795410156, 0.697133015388952, -79.6447219848633, -1.39006263047138, 218, 45, 'PPL', 'P'),
(49621, 'Mount Briar', 39.4425010681152, 0.688401508859991, -77.6861114501953, -1.35587842787717, 218, 25, 'PPL', 'P'),
(183475, 'Mount Bullion', 37.5072212219238, 0.654624503596462, -120.043891906738, -2.09516116068076, 218, 6, 'PPL', 'P'),
(183476, 'Mount Bullion (historical)', 38.6605606079102, 0.674754073274853, -119.725280761719, -2.08960034716662, 218, 6, 'PPL', 'P'),
(49622, 'Mount Bush Estates', 39.4622192382813, 0.688745655851857, -76.2597198486328, -1.33098319800711, 218, 25, 'PPL', 'P'),
(96362, 'Mount Calm', 31.7561092376709, 0.554248663820344, -96.8788909912109, -1.6908556234773, 218, 51, 'PPL', 'P'),
(23211, 'Mount Calvary', 32.6097183227539, 0.569146952879979, -83.4852828979492, -1.45709306352813, 218, 13, 'PPL', 'P'),
(82490, 'Mount Calvary', 34.4313888549805, 0.60094110155389, -79.3277816772461, -1.38453097857117, 218, 48, 'PPL', 'P'),
(175415, 'Mount Calvary', 43.8263893127441, 0.76491479276824, -88.2461090087891, -1.5401851542772, 218, 57, 'PPL', 'P'),
(49647, 'Mount Calvert', 38.7852783203125, 0.676930807991829, -76.7149963378906, -1.33892927175158, 218, 25, 'PPL', 'P'),
(27963, 'Mount Carbon', 37.7519416809082, 0.658895681352731, -89.3211135864258, -1.55894752363097, 218, 18, 'PPL', 'P'),
(110560, 'Mount Carbon', 38.1377792358398, 0.665629817064132, -81.2858276367188, -1.41870532746934, 218, 58, 'PPL', 'P'),
(164832, 'Mount Carbon', 40.6747207641602, 0.709907799663899, -76.188606262207, -1.32974203178108, 218, 45, 'PPL', 'P'),
(4367, 'Mount Carmel', 32.0608291625977, 0.559567029806746, -86.3652801513672, -1.50735849804866, 218, 2, 'PPL', 'P'),
(10627, 'Mount Carmel', 35.7441711425781, 0.623853474834332, -91.440559387207, -1.59593883117217, 218, 4, 'PPL', 'P'),
(17199, 'Mount Carmel', 30.9808292388916, 0.540717475216787, -87.1186065673828, -1.52050652435039, 218, 12, 'PPL', 'P'),
(23212, 'Mount Carmel', 34.6627807617188, 0.60497965218894, -85.3099975585938, -1.48894034226579, 218, 13, 'PPL', 'P'),
(27964, 'Mount Carmel', 38.410831451416, 0.670395477255802, -87.7613906860352, -1.5317252236004, 218, 18, 'PPL', 'P'),
(30576, 'Mount Carmel', 38.7169418334961, 0.675738111297637, -86.2494430541992, -1.50533675930713, 218, 19, 'PPL', 'P'),
(37289, 'Mount Carmel', 37.1674995422363, 0.648695241745509, -87.3683319091797, -1.52486505379041, 218, 21, 'PPL', 'P'),
(42192, 'Mount Carmel', 31.4691696166992, 0.549240622679963, -93.3802795410156, -1.62979333442342, 218, 22, 'PPL', 'P'),
(49626, 'Mount Carmel', 39.4727783203125, 0.68892994659929, -77.6555633544922, -1.35534526302694, 218, 25, 'PPL', 'P'),
(60965, 'Mount Carmel', 31.6450004577637, 0.552309449783089, -89.7897186279297, -1.56712622449666, 218, 30, 'PPL', 'P'),
(82491, 'Mount Carmel', 34.0072212219238, 0.59353797977666, -82.5072174072266, -1.44002260041488, 218, 48, 'PPL', 'P'),
(89188, 'Mount Carmel', 36.1505584716797, 0.63094627176554, -82.5963897705078, -1.44157895175593, 218, 50, 'PPL', 'P'),
(104430, 'Mount Carmel', 36.853328704834, 0.643211926219091, -81.4783325195313, -1.42206517150059, 218, 53, 'PPL', 'P'),
(110540, 'Mount Carmel', 39.1708297729492, 0.683659950276187, -81.3688888549805, -1.42015501920873, 218, 58, 'PPL', 'P'),
(113752, 'Mount Carmel', 41.4241714477539, 0.722988181673932, -72.9058303833008, -1.27244678408912, 218, 8, 'PPL', 'P'),
(116950, 'Mount Carmel', 42.1525001525879, 0.735699915610071, -94.908332824707, -1.65646289536975, 218, 16, 'PPL', 'P'),
(140542, 'Mount Carmel', 48.935001373291, 0.854076893431875, -98.3863906860352, -1.7171664566248, 218, 34, 'PPL', 'P'),
(150892, 'Mount Carmel', 42.1086082458496, 0.73493385732251, -75.5644378662109, -1.31884823818406, 218, 40, 'PPL', 'P'),
(156624, 'Mount Carmel', 41.271110534668, 0.720316764784473, -82.9369430541992, -1.44752272783482, 218, 41, 'PPL', 'P'),
(164834, 'Mount Carmel', 40.7969398498535, 0.712040925118025, -76.4122161865234, -1.33364476120054, 218, 45, 'PPL', 'P'),
(192713, 'Mount Carmel', 37.2472190856934, 0.650086610257021, -112.663612365723, -1.96635098297246, 218, 52, 'PPL', 'P'),
(23213, 'Mount Carmel (historical)', 32.9022216796875, 0.574252099531606, -83.2125015258789, -1.45233213044739, 218, 13, 'PPL', 'P'),
(89189, 'Mount Carmel (historical)', 36.0572204589844, 0.629317216126738, -86.3680572509766, -1.5074069675805, 218, 50, 'PPL', 'P'),
(113753, 'Mount Carmel Center', 41.4386100769043, 0.723240183292081, -72.9100036621094, -1.27251962154493, 218, 8, 'PPL', 'P'),
(10628, 'Mount Carmel Estates', 34.938060760498, 0.609784194532525, -91.9297180175781, -1.60447625983669, 218, 4, 'PPL', 'P'),
(23214, 'Mount Carmel Estates', 33.4375, 0.583594468635604, -84.2627792358398, -1.47066293454652, 218, 13, 'PPL', 'P'),
(49627, 'Mount Carmel Estates', 38.5633316040039, 0.673057107028254, -77.003059387207, -1.34395692041549, 218, 25, 'PPL', 'P'),
(49628, 'Mount Carmel Farms', 39.5805587768555, 0.690811070435267, -76.7205581665039, -1.33902634397332, 218, 25, 'PPL', 'P'),
(73568, 'Mount Carmel Heights', 39.1183280944824, 0.682743623124118, -84.3011093139648, -1.47133192061234, 218, 41, 'PPL', 'P'),
(164835, 'Mount Carmel Junction', 40.7833290100098, 0.71180337114879, -76.4355621337891, -1.33405222484732, 218, 45, 'PPL', 'P'),
(192714, 'Mount Carmel Junction', 37.2241706848145, 0.649684339774365, -112.679718017578, -1.96663207962552, 218, 52, 'PPL', 'P'),
(192715, 'Mount Carmel Trailer Park', 37.2236099243164, 0.649674552657359, -112.680557250977, -1.96664672701151, 218, 52, 'PPL', 'P'),
(49629, 'Mount Carmel Woods', 38.5641708374023, 0.67307175441425, -76.995002746582, -1.34381630550993, 218, 25, 'PPL', 'P'),
(73569, 'Mount Carrick', 39.7522201538086, 0.693807126661607, -81.0469436645508, -1.41453601562477, 218, 41, 'PPL', 'P'),
(17200, 'Mount Carrie', 30.1949996948242, 0.527002162313366, -82.5038909912109, -1.43996454350312, 218, 12, 'PPL', 'P'),
(120709, 'Mount Carroll', 42.0950012207031, 0.734696369932302, -89.9780578613281, -1.57041336423014, 218, 18, 'PPL', 'P'),
(190513, 'Mount Charleston', 36.2572212219238, 0.632807887946532, -115.641937255859, -2.01833255849944, 218, 39, 'PPL', 'P'),
(164838, 'Mount Chestnut', 40.8877792358398, 0.713626371493976, -79.980827331543, -1.3959287754045, 218, 45, 'PPL', 'P'),
(164839, 'Mount Chestnut Springs', 40.8863906860352, 0.713602136728057, -79.9916687011719, -1.39611799299995, 218, 45, 'PPL', 'P'),
(27966, 'Mount Clare', 39.0986099243164, 0.682399476132252, -89.8261108398438, -1.56776138841664, 218, 18, 'PPL', 'P'),
(49630, 'Mount Clare', 39.285831451416, 0.685667108210752, -76.6322174072266, -1.33748450686022, 218, 25, 'PPL', 'P'),
(116951, 'Mount Clare', 40.5230598449707, 0.707260817277442, -91.4519424438477, -1.59613750298949, 218, 16, 'PPL', 'P'),
(142456, 'Mount Clare', 40.1827812194824, 0.701321834888511, -98.2177810668945, -1.71422366362026, 218, 35, 'PPL', 'P'),
(132185, 'Mount Clemens', 42.5972213745117, 0.743461765186134, -82.878059387207, -1.44649501397016, 218, 27, 'PPL', 'P'),
(104431, 'Mount Clifton', 38.7613906860352, 0.676513890123177, -78.711669921875, -1.37377779987971, 218, 53, 'PPL', 'P'),
(104432, 'Mount Clinton', 38.4861106872559, 0.671709347779592, -78.9599990844727, -1.37811196139576, 218, 53, 'PPL', 'P'),
(164840, 'Mount Cobb', 41.413330078125, 0.722798964078482, -75.4936065673828, -1.31761199880604, 218, 45, 'PPL', 'P'),
(30577, 'Mount Comfort', 39.8308296203613, 0.695179120676188, -85.915283203125, -1.49950456967791, 218, 19, 'PPL', 'P'),
(156625, 'Mount Cory', 40.9366683959961, 0.714479648307238, -83.8225021362305, -1.4629786495372, 218, 41, 'PPL', 'P'),
(104433, 'Mount Crawford', 38.3569412231445, 0.669454915337813, -78.9411087036133, -1.3777822620528, 218, 53, 'PPL', 'P'),
(89190, 'Mount Crest', 35.6697196960449, 0.622554051959455, -85.2399978637695, -1.48771861711571, 218, 50, 'PPL', 'P'),
(187087, 'Mount Crested Butte', 38.9052810668945, 0.679025251031122, -106.959716796875, -1.86679922510615, 218, 7, 'PPL', 'P'),
(82492, 'Mount Croghan', 34.769718170166, 0.606846062059895, -80.2280578613281, -1.4002437621607, 218, 48, 'PPL', 'P'),
(104444, 'Mount Cross', 36.6388893127441, 0.639469252781148, -79.4880599975586, -1.38732836298019, 218, 53, 'PPL', 'P'),
(14268, 'Mount Cuba', 39.791389465332, 0.69449076011343, -75.6399993896484, -1.32016703555587, 218, 10, 'PPL', 'P'),
(89191, 'Mount Cumberland', 35.4116706848145, 0.618050247081967, -84.5519409179688, -1.47570975797027, 218, 50, 'PPL', 'P'),
(164841, 'Mount Dallas', 40.0119400024414, 0.69834009315303, -78.3952789306641, -1.36825573535943, 218, 45, 'PPL', 'P'),
(177250, 'Mount de Chantal', 40.0699996948242, 0.699353425947806, -80.688606262207, -1.40828184812083, 218, 58, 'PPL', 'P'),
(89192, 'Mount Denson', 36.5430603027344, 0.637796721037551, -86.8888931274414, -1.51649726848733, 218, 50, 'PPL', 'P'),
(49631, 'Mount DeSales', 39.2827796936035, 0.685613844988951, -76.7255630493164, -1.33911369565707, 218, 25, 'PPL', 'P'),
(17201, 'Mount Dora', 28.8022193908691, 0.502693560252422, -81.6447219848633, -1.42496921551126, 218, 12, 'PPL', 'P'),
(189075, 'Mount Dora', 36.5194396972656, 0.637384463700806, -103.488609313965, -1.80621697083876, 218, 38, 'PPL', 'P'),
(164842, 'Mount Eagle', 40.9819412231445, 0.715269808202664, -77.7058334350586, -1.35622264144807, 218, 45, 'PPL', 'P'),
(156626, 'Mount Eaton', 40.6944389343262, 0.710251946655764, -81.7033309936523, -1.42599213568596, 218, 41, 'PPL', 'P'),
(177248, 'Mount Echo', 40.1022186279297, 0.699915752411976, -80.5297164916992, -1.40550869847773, 218, 58, 'PPL', 'P'),
(37290, 'Mount Eden', 38.0561103820801, 0.664204426669695, -85.1511077880859, -1.48616719262269, 218, 21, 'PPL', 'P'),
(183477, 'Mount Eden', 37.6361083984375, 0.656874009190224, -122.098892211914, -2.13102768213556, 218, 6, 'PPL', 'P'),
(193275, 'Mount Edgecombe', 57.0511093139648, 0.99572969944389, -135.354446411133, -2.36238074708849, 218, 1, 'PPL', 'P'),
(10629, 'Mount Elba', 33.850830078125, 0.590808439396411, -92.158332824707, -1.6084663409399, 218, 4, 'PPL', 'P'),
(104434, 'Mount Elliott Springs', 38.1266708374023, 0.665435938936775, -79.2836074829102, -1.3837599934356, 218, 53, 'PPL', 'P'),
(204989, 'Mount Emmons', 40.3477783203125, 0.70420157755424, -110.274436950684, -1.92465200557232, 218, 52, 'PPL', 'P'),
(66988, 'Mount Energy', 36.1252784729004, 0.630505052551941, -78.6416702270508, -1.37255607472963, 218, 33, 'PPL', 'P'),
(17202, 'Mount Enon', 28.0369396209717, 0.489336908568807, -82.0725021362305, -1.4324353876273, 218, 12, 'PPL', 'P'),
(96363, 'Mount Enterprise', 31.9177799224854, 0.55707034957431, -94.6808319091797, -1.65249225534249, 218, 51, 'PPL', 'P'),
(49632, 'Mount Ephraim', 39.2458305358887, 0.684968960530988, -77.3988876342773, -1.35086542659926, 218, 25, 'PPL', 'P'),
(71139, 'Mount Ephraim', 39.8783302307129, 0.69600816272353, -75.0930633544922, -1.31062120094459, 218, 37, 'PPL', 'P'),
(73570, 'Mount Ephraim', 39.8472213745117, 0.69546521075629, -81.4180603027344, -1.42101322287001, 218, 41, 'PPL', 'P'),
(27967, 'Mount Erie', 38.5149993896484, 0.672213550752972, -88.2311096191406, -1.53992336554204, 218, 18, 'PPL', 'P'),
(116952, 'Mount Etna', 41.1205596923828, 0.717689156894947, -94.7350006103516, -1.65343767752947, 218, 16, 'PPL', 'P'),
(123254, 'Mount Etna', 40.7425003051758, 0.711090775820112, -85.5619430541992, -1.49333762069967, 218, 19, 'PPL', 'P'),
(164843, 'Mount Etna', 40.5202789306641, 0.707212281166575, -78.1727828979492, -1.36437244701593, 218, 45, 'PPL', 'P'),
(96364, 'Mount Evergreen', 30.1516704559326, 0.526245924432324, -94.1747207641602, -1.64365894948087, 218, 51, 'PPL', 'P'),
(145826, 'Mount Fern', 40.8655586242676, 0.713238548660234, -74.5788879394531, -1.30164714701935, 218, 37, 'PPL', 'P'),
(132187, 'Mount Forest', 43.8872184753418, 0.7659764619368, -84.1141662597656, -1.46806914880283, 218, 27, 'PPL', 'P'),
(73572, 'Mount Forest Trails', 39.0991706848145, 0.682409263249258, -84.2994384765625, -1.47130275899841, 218, 41, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(56401, 'Mount Freedom', 38.1933288574219, 0.666599340858976, -90.647216796875, -1.58209239087458, 218, 29, 'PPL', 'P'),
(145827, 'Mount Freedom', 40.8261108398438, 0.712550054939421, -74.570556640625, -1.30150173842383, 218, 37, 'PPL', 'P'),
(27969, 'Mount Fulcher', 39.9919395446777, 0.697991019313148, -89.5122222900391, -1.56228299973824, 218, 18, 'PPL', 'P'),
(96365, 'Mount Gainor', 30.1436100006104, 0.526105242947741, -98.1347198486328, -1.71277397188087, 218, 51, 'PPL', 'P'),
(82493, 'Mount Gallagher', 34.3952789306641, 0.600310864481922, -82.1883316040039, -1.43445699321078, 218, 48, 'PPL', 'P'),
(66989, 'Mount Gallows', 36.417781829834, 0.635610199203568, -76.9480590820313, -1.34299698400057, 218, 33, 'PPL', 'P'),
(104435, 'Mount Garland', 37.9355583190918, 0.662100396250478, -77.8122177124023, -1.35807939736007, 218, 53, 'PPL', 'P'),
(104436, 'Mount Gate', 37.0583305358887, 0.646789883143612, -81.5308303833008, -1.42298143207363, 218, 53, 'PPL', 'P'),
(110541, 'Mount Gay', 37.8413887023926, 0.660456826383735, -82.0088882446289, -1.43132511576885, 218, 58, 'PPL', 'P'),
(10630, 'Mount Gaylor', 35.753059387207, 0.624008603967829, -94.1149978637695, -1.64261658823021, 218, 4, 'PPL', 'P'),
(10631, 'Mount George', 35.1130599975586, 0.61283850740771, -93.2416687011719, -1.62737411888919, 218, 4, 'PPL', 'P'),
(4369, 'Mount Gilead', 32.0897216796875, 0.560071299359152, -85.2383270263672, -1.48768945550177, 218, 2, 'PPL', 'P'),
(37292, 'Mount Gilead', 38.5108299255371, 0.672140779876185, -83.7030563354492, -1.46089392703589, 218, 21, 'PPL', 'P'),
(66991, 'Mount Gilead', 35.2147216796875, 0.614612838483975, -80.0025024414063, -1.39630707743734, 218, 33, 'PPL', 'P'),
(82494, 'Mount Gilead', 33.5750007629395, 0.585994309672902, -79.0188903808594, -1.37913980841847, 218, 48, 'PPL', 'P'),
(89193, 'Mount Gilead', 35.7658309936523, 0.624231510551069, -88.5397186279297, -1.54530960884673, 218, 50, 'PPL', 'P'),
(104437, 'Mount Gilead', 39.0586090087891, 0.681701328452488, -77.6647186279297, -1.35550505269235, 218, 53, 'PPL', 'P'),
(156628, 'Mount Gilead', 41.1808280944824, 0.718741038946501, -83.2375030517578, -1.452768489392, 218, 41, 'PPL', 'P'),
(4370, 'Mount Gilead (historical)', 33.8866691589355, 0.591433949357443, -85.8666687011719, -1.49865608655461, 218, 2, 'PPL', 'P'),
(89194, 'Mount Gilead (historical)', 35.8444404602051, 0.62560350456565, -85.1750030517578, -1.48658424364939, 218, 50, 'PPL', 'P'),
(4371, 'Mount Gillis', 31.0888900756836, 0.542603492611268, -87.522216796875, -1.52755085174975, 218, 2, 'PPL', 'P'),
(66993, 'Mount Gould', 36.1194381713867, 0.630403120061218, -76.7633285522461, -1.33977282802687, 218, 33, 'PPL', 'P'),
(66994, 'Mount Gould Landing', 36.1233291625977, 0.630471030669015, -76.7433319091797, -1.33942382076601, 218, 33, 'PPL', 'P'),
(164844, 'Mount Gretna', 40.247501373291, 0.702451414664868, -76.4697189331055, -1.33464837345734, 218, 45, 'PPL', 'P'),
(164845, 'Mount Gretna Heights', 40.2480583190918, 0.702461135202846, -76.4647216796875, -1.33456115493164, 218, 45, 'PPL', 'P'),
(116953, 'Mount Hamill', 40.750560760498, 0.711231457304695, -91.6130599975586, -1.59894953478451, 218, 16, 'PPL', 'P'),
(183478, 'Mount Hannah Lodge', 38.8877792358398, 0.67871978645409, -122.729438781738, -2.14203279586615, 218, 6, 'PPL', 'P'),
(49633, 'Mount Harmon', 39.3824996948242, 0.687354287340345, -75.9372177124023, -1.32535447388518, 218, 25, 'PPL', 'P'),
(49634, 'Mount Harmony', 38.6983299255371, 0.675413272223675, -76.6044387817383, -1.33699967838377, 218, 25, 'PPL', 'P'),
(89197, 'Mount Harmony', 35.3813896179199, 0.617521742763641, -84.3486099243164, -1.47216096265969, 218, 50, 'PPL', 'P'),
(110542, 'Mount Harmony', 39.5097198486328, 0.689574697899198, -80.0780563354492, -1.39762574165109, 218, 58, 'PPL', 'P'),
(49635, 'Mount Harmony Estates', 38.7052803039551, 0.675534579211328, -76.6319427490234, -1.33747971317025, 218, 25, 'PPL', 'P'),
(49636, 'Mount Harmony Hills', 38.7069396972656, 0.675563541088182, -76.6372222900391, -1.33757185854397, 218, 25, 'PPL', 'P'),
(194334, 'Mount Harris', 40.4836082458496, 0.706572256977602, -107.144172668457, -1.87001858738989, 218, 7, 'PPL', 'P'),
(73573, 'Mount Harrison', 39.1150016784668, 0.682685566212354, -84.5602798461914, -1.47585529972384, 218, 41, 'PPL', 'P'),
(30578, 'Mount Healthy', 39.0805587768555, 0.682084424175296, -86.0377807617188, -1.50164255540103, 218, 19, 'PPL', 'P'),
(73574, 'Mount Healthy', 39.2336082458496, 0.684755641327673, -84.5458297729492, -1.47560309836861, 218, 41, 'PPL', 'P'),
(73575, 'Mount Healthy Heights', 39.2702789306641, 0.685395665516646, -84.5680618286133, -1.47599112093944, 218, 41, 'PPL', 'P'),
(4373, 'Mount Hebron', 34.142219543457, 0.59589414497208, -86.289436340332, -1.50603477382884, 218, 2, 'PPL', 'P'),
(42193, 'Mount Hebron', 32.211669921875, 0.562199697702343, -92.5105590820313, -1.61461384884219, 218, 22, 'PPL', 'P'),
(49637, 'Mount Hebron', 39.3050003051758, 0.686001667822693, -76.8305587768555, -1.34094621680316, 218, 25, 'PPL', 'P'),
(193805, 'Mount Hebron', 41.7872200012207, 0.72932457427653, -122.003059387207, -2.12935508381294, 218, 6, 'PPL', 'P'),
(104438, 'Mount Hebron Park', 38.7916717529297, 0.677042394441503, -77.1511077880859, -1.34654085246314, 218, 53, 'PPL', 'P'),
(89198, 'Mount Helen', 36.3955612182617, 0.635222376369826, -84.709716796875, -1.47846346653741, 218, 50, 'PPL', 'P'),
(183479, 'Mount Helix', 32.7686080932617, 0.571920102523078, -116.980560302734, -2.04169593811049, 218, 6, 'PPL', 'P'),
(23215, 'Mount Herman', 31.9533290863037, 0.557690799529271, -81.1455612182617, -1.41625721663729, 218, 13, 'PPL', 'P'),
(60966, 'Mount Herman', 33.2252807617188, 0.579890544191522, -89.7027816772461, -1.56560888846559, 218, 30, 'PPL', 'P'),
(66996, 'Mount Herman', 36.5341682434082, 0.637641525325026, -80.4686126708984, -1.40444223561921, 218, 33, 'PPL', 'P'),
(76647, 'Mount Herman', 34.3058280944824, 0.598749652871891, -94.8141708374023, -1.65481945866106, 218, 42, 'PPL', 'P'),
(96366, 'Mount Herman', 31.6980590820313, 0.553235497473137, -94.3013916015625, -1.64586977265979, 218, 51, 'PPL', 'P'),
(112564, 'Mount Herman', 36.0825004577637, 0.629758435340337, -85.4763870239258, -1.49184438627646, 218, 50, 'PPL', 'P'),
(164847, 'Mount Herman', 40.0488891601563, 0.698984977610993, -80.23388671875, -1.40034549491434, 218, 45, 'PPL', 'P'),
(37293, 'Mount Hermon', 36.8066711425781, 0.642397598136772, -85.8208312988281, -1.49785607296315, 218, 21, 'PPL', 'P'),
(42194, 'Mount Hermon', 30.9599990844727, 0.540353920438478, -90.2958297729492, -1.57595953035829, 218, 22, 'PPL', 'P'),
(49638, 'Mount Hermon', 38.353889465332, 0.669401652116012, -75.5297164916992, -1.31824223587801, 218, 25, 'PPL', 'P'),
(104439, 'Mount Hermon', 36.6783294677734, 0.640157613343906, -79.4225006103516, -1.38618413581784, 218, 53, 'PPL', 'P'),
(125486, 'Mount Hermon', 42.6680603027344, 0.744698137722203, -72.4858322143555, -1.26511643318868, 218, 23, 'PPL', 'P'),
(145828, 'Mount Hermon', 40.9247207641602, 0.714271122793884, -74.9941711425781, -1.30889520624211, 218, 37, 'PPL', 'P'),
(183480, 'Mount Hermon', 37.0511093139648, 0.646663849045024, -122.057502746582, -2.13030529968988, 218, 6, 'PPL', 'P'),
(49639, 'Mount Hermon Heights', 38.355281829834, 0.669425953460958, -75.5374984741211, -1.31837805709361, 218, 25, 'PPL', 'P'),
(104440, 'Mount Hermon Heights', 37.7405586242676, 0.658697009535411, -77.4341735839844, -1.35148128260135, 218, 53, 'PPL', 'P'),
(49640, 'Mount Hermon Manor', 38.3463897705078, 0.669270757748434, -75.4763870239258, -1.31731146107703, 218, 25, 'PPL', 'P'),
(125487, 'Mount Hermon Station', 42.6838912963867, 0.744974440685299, -72.491943359375, -1.26522309279033, 218, 23, 'PPL', 'P'),
(104441, 'Mount Heron', 37.1877784729004, 0.649049175854381, -82.0047225952148, -1.43125241147109, 218, 53, 'PPL', 'P'),
(156629, 'Mount Heron', 40.1358299255371, 0.700502380221093, -84.6894378662109, -1.47810953242854, 218, 41, 'PPL', 'P'),
(10632, 'Mount Hersey', 36.0136108398438, 0.628556084687194, -92.9499969482422, -1.62228348646551, 218, 4, 'PPL', 'P'),
(4374, 'Mount Hester', 34.728328704834, 0.606123679614211, -88.0119400024414, -1.53609813411031, 218, 2, 'PPL', 'P'),
(4375, 'Mount Hillard', 32.060001373291, 0.559552582157832, -85.8680572509766, -1.49868032132053, 218, 2, 'PPL', 'P'),
(10633, 'Mount Holly', 33.3025016784668, 0.581238303440184, -92.954719543457, -1.62236591130125, 218, 4, 'PPL', 'P'),
(49641, 'Mount Holly', 38.5525016784668, 0.672868089169886, -76.0033264160156, -1.32650828842745, 218, 25, 'PPL', 'P'),
(66998, 'Mount Holly', 35.2980613708496, 0.616067390492349, -81.01611328125, -1.41399792392652, 218, 33, 'PPL', 'P'),
(71141, 'Mount Holly', 39.9927787780762, 0.698005666699144, -74.7880630493164, -1.30529794139968, 218, 37, 'PPL', 'P'),
(73578, 'Mount Holly', 39.5716705322266, 0.69065594130177, -84.0325012207031, -1.46664382498742, 218, 41, 'PPL', 'P'),
(82495, 'Mount Holly', 33.0341682434082, 0.576555001505225, -80.0347213745117, -1.39686940390151, 218, 48, 'PPL', 'P'),
(104443, 'Mount Holly', 38.0911102294922, 0.664815289244732, -76.7183303833008, -1.3389874618214, 218, 53, 'PPL', 'P'),
(172284, 'Mount Holly', 43.452220916748, 0.758384322301202, -72.8252792358398, -1.27104090134967, 218, 55, 'PPL', 'P'),
(172285, 'Mount Holly Heights', 43.4377784729004, 0.758132254104026, -72.7677764892578, -1.27003728909287, 218, 55, 'PPL', 'P'),
(164848, 'Mount Holly Springs', 40.1183280944824, 0.700196915644061, -77.1902770996094, -1.34722448591496, 218, 45, 'PPL', 'P'),
(17203, 'Mount Homer', 28.8286094665527, 0.503154153962951, -81.7008285522461, -1.42594845984409, 218, 12, 'PPL', 'P'),
(201265, 'Mount Hood', 45.5380592346191, 0.794789068612313, -121.567222595215, -2.12174829679135, 218, 43, 'PPL', 'P'),
(201266, 'Mount Hood Village', 45.3555603027344, 0.791603861369551, -121.979438781738, -2.12894282647619, 218, 43, 'PPL', 'P'),
(4377, 'Mount Hope', 33.7691688537598, 0.589383182160027, -87.2411117553711, -1.52264464323156, 218, 2, 'PPL', 'P'),
(33359, 'Mount Hope', 37.8686103820801, 0.660931934322205, -97.6647186279297, -1.70457090309121, 218, 20, 'PPL', 'P'),
(49643, 'Mount Hope', 38.4597206115723, 0.671248754069063, -77.1763916015625, -1.34698213825577, 218, 25, 'PPL', 'P'),
(56402, 'Mount Hope', 38.2983283996582, 0.668431928584086, -90.8736114501953, -1.58604372298393, 218, 29, 'PPL', 'P'),
(89202, 'Mount Hope', 35.3591690063477, 0.617133919929898, -87.7477798461914, -1.53148766963116, 218, 50, 'PPL', 'P'),
(104445, 'Mount Hope', 39.0916709899902, 0.682278368881681, -78.3413925170898, -1.36731524002047, 218, 53, 'PPL', 'P'),
(110545, 'Mount Hope', 38.6127815246582, 0.673920170958522, -81.445556640625, -1.42149312449844, 218, 58, 'PPL', 'P'),
(113754, 'Mount Hope', 41.8238906860352, 0.729964598465503, -72.17138671875, -1.25962832397229, 218, 8, 'PPL', 'P'),
(125488, 'Mount Hope', 42.2833290100098, 0.737983309928705, -71.125, -1.24136543048097, 218, 23, 'PPL', 'P'),
(145830, 'Mount Hope', 40.9261093139648, 0.714295357559804, -74.5430603027344, -1.3010218367954, 218, 37, 'PPL', 'P'),
(150895, 'Mount Hope', 40.9888916015625, 0.715391115190317, -73.8683319091797, -1.28924560477117, 218, 40, 'PPL', 'P'),
(156630, 'Mount Hope', 40.6238899230957, 0.709020634125766, -81.7847213745117, -1.42741266581141, 218, 41, 'PPL', 'P'),
(164854, 'Mount Hope', 40.6455612182617, 0.709398869579585, -75.2861099243164, -1.3139904991977, 218, 45, 'PPL', 'P'),
(175417, 'Mount Hope', 42.9672203063965, 0.749919464776385, -90.85888671875, -1.58578672793873, 218, 57, 'PPL', 'P'),
(208186, 'Mount Hope', 47.4494400024414, 0.828148956270109, -117.215827941895, -2.04580213303723, 218, 56, 'PPL', 'P'),
(23216, 'Mount Hope (historical)', 34.2458305358887, 0.597702497931272, -85.4072189331055, -1.49063717535433, 218, 13, 'PPL', 'P'),
(89203, 'Mount Hope (historical)', 36.2958297729492, 0.63348173428135, -82.8272171020508, -1.44560764869494, 218, 50, 'PPL', 'P'),
(175418, 'Mount Hope Corners', 44.7344398498535, 0.780763264415302, -91.5686111450195, -1.59817375595897, 218, 57, 'PPL', 'P'),
(183482, 'Mount Hope House (historical)', 39.5169410705566, 0.689700731997786, -121.216667175293, -2.115629950503, 218, 6, 'PPL', 'P'),
(60967, 'Mount Horeb', 31.5833301544189, 0.55123309993902, -89.5702819824219, -1.56329633253302, 218, 30, 'PPL', 'P'),
(89204, 'Mount Horeb', 36.0911102294922, 0.629908704204845, -83.4402770996094, -1.45630756416461, 218, 50, 'PPL', 'P'),
(145831, 'Mount Horeb', 40.6183280944824, 0.708923561904033, -74.5619430541992, -1.30135140298029, 218, 37, 'PPL', 'P'),
(175421, 'Mount Horeb', 43.0086097717285, 0.750641847222069, -89.7383270263672, -1.56622927184152, 218, 57, 'PPL', 'P'),
(42195, 'Mount Houmas', 30.201940536499, 0.527123302853451, -91.0111083984375, -1.5884434974422, 218, 22, 'PPL', 'P'),
(112592, 'Mount Houston', 29.8908290863037, 0.521693383706888, -95.3055572509766, -1.6633957694775, 218, 51, 'PPL', 'P'),
(10634, 'Mount Ida', 34.5566711425781, 0.603127689966899, -93.6338882446289, -1.63421964131319, 218, 4, 'PPL', 'P'),
(104446, 'Mount Ida', 38.8300018310547, 0.677711380507331, -77.0661087036133, -1.34505733857791, 218, 53, 'PPL', 'P'),
(125489, 'Mount Ida', 42.3041687011719, 0.738347031154582, -71.0633316040039, -1.24028911392641, 218, 23, 'PPL', 'P'),
(175423, 'Mount Ida', 42.9719390869141, 0.750001823033096, -90.7608337402344, -1.58407538062225, 218, 57, 'PPL', 'P'),
(195353, 'Mount Idaho', 45.9038887023926, 0.801173997325778, -116.081108093262, -2.02599753559085, 218, 17, 'PPL', 'P'),
(78781, 'Mount Independence', 39.9311103820801, 0.696929350144588, -79.6447219848633, -1.39006263047138, 218, 45, 'PPL', 'P'),
(150897, 'Mount Ivy', 41.1866683959961, 0.718842971437224, -74.0352783203125, -1.29215936931983, 218, 40, 'PPL', 'P'),
(30580, 'Mount Jackson', 39.7652816772461, 0.694035093250917, -86.206672668457, -1.50459027525358, 218, 19, 'PPL', 'P'),
(104447, 'Mount Jackson', 38.7458305358887, 0.676242314271016, -78.6425018310547, -1.37257058895757, 218, 53, 'PPL', 'P'),
(164855, 'Mount Jackson', 40.9622192382813, 0.714925594631772, -80.4355621337891, -1.40386539492709, 218, 45, 'PPL', 'P'),
(183483, 'Mount Jackson', 38.5133285522461, 0.672184389139035, -122.90389251709, -2.14507758794044, 218, 6, 'PPL', 'P'),
(4378, 'Mount Jefferson', 32.7094383239746, 0.570887395231373, -85.3724975585938, -1.49003117304828, 218, 2, 'PPL', 'P'),
(156631, 'Mount Jefferson', 40.2425003051758, 0.70236412956014, -84.3333282470703, -1.47189424707651, 218, 41, 'PPL', 'P'),
(164856, 'Mount Jewett', 41.7255592346191, 0.728248390880029, -78.6386108398438, -1.37250267834978, 218, 45, 'PPL', 'P'),
(204990, 'Mount Jordan Addition', 40.5833282470703, 0.708312699328996, -111.877777099609, -1.9526355702005, 218, 52, 'PPL', 'P'),
(14269, 'Mount Joy', 38.6319389343262, 0.674254530833381, -75.29638671875, -1.31416986309712, 218, 10, 'PPL', 'P'),
(73579, 'Mount Joy', 38.9513893127441, 0.679829991733517, -83.1736068725586, -1.45165329068553, 218, 41, 'PPL', 'P'),
(89205, 'Mount Joy', 35.5247192382813, 0.62002331655458, -87.2613906860352, -1.52299857734043, 218, 50, 'PPL', 'P'),
(96367, 'Mount Joy', 33.4749984741211, 0.584248940473491, -95.6205596923828, -1.66889359923186, 218, 51, 'PPL', 'P'),
(116954, 'Mount Joy', 41.6150016784668, 0.726318797512212, -90.565559387207, -1.58066720021722, 218, 16, 'PPL', 'P'),
(145832, 'Mount Joy', 40.5869407653809, 0.708375749667803, -75.1872177124023, -1.31226450449522, 218, 37, 'PPL', 'P'),
(164860, 'Mount Joy', 40.1450004577637, 0.700662436202607, -79.5022201538086, -1.38757550432935, 218, 45, 'PPL', 'P'),
(96368, 'Mount Joy Crossing', 33.4836082458496, 0.584399209337999, -95.6163864135742, -1.66882076177604, 218, 51, 'PPL', 'P'),
(116955, 'Mount Joy Mobile Home Park', 41.6175003051758, 0.726362406775062, -90.5611114501953, -1.58058956907144, 218, 16, 'PPL', 'P'),
(10635, 'Mount Judea', 35.9213905334473, 0.626946536703377, -93.0599975585938, -1.62420335929535, 218, 4, 'PPL', 'P'),
(89206, 'Mount Juliet', 36.2000007629395, 0.631809202537753, -86.5186080932617, -1.51003457547003, 218, 50, 'PPL', 'P'),
(197102, 'Mount Jumbo Trailer Court', 46.8741683959961, 0.818108572644401, -113.943061828613, -1.98868158871277, 218, 31, 'PPL', 'P'),
(150898, 'Mount Kisco', 41.2041702270508, 0.719148436014256, -73.7275009155273, -1.28678764024309, 218, 40, 'PPL', 'P'),
(164863, 'Mount Laffee', 40.7169418334961, 0.710644696337524, -76.228889465332, -1.33044510630886, 218, 45, 'PPL', 'P'),
(183484, 'Mount Laguna', 32.8722190856934, 0.573728455482269, -116.417503356934, -2.03186874053004, 218, 6, 'PPL', 'P'),
(104448, 'Mount Landing', 37.939998626709, 0.662177894238199, -76.9216690063477, -1.34253639029004, 218, 53, 'PPL', 'P'),
(71142, 'Mount Laurel', 39.9338912963867, 0.696977886255455, -74.8913879394531, -1.30710130093183, 218, 37, 'PPL', 'P'),
(104464, 'Mount Laurel', 36.8752784729004, 0.643595021941898, -78.7877807617188, -1.37510618463144, 218, 53, 'PPL', 'P'),
(164864, 'Mount Laurel', 40.934440612793, 0.714440766155323, -75.9938888549805, -1.32634357191403, 218, 45, 'PPL', 'P'),
(30579, 'Mount Lawn', 39.9116706848145, 0.696590063421712, -85.4613876342773, -1.49158259754131, 218, 19, 'PPL', 'P'),
(4379, 'Mount Lebanon', 34.8644409179688, 0.608499285885589, -86.6072235107422, -1.51158120627309, 218, 2, 'PPL', 'P'),
(37294, 'Mount Lebanon', 37.8266716003418, 0.660199964496597, -84.5044403076172, -1.47488071592293, 218, 21, 'PPL', 'P'),
(42196, 'Mount Lebanon', 32.5036087036133, 0.567294990657937, -93.0488891601563, -1.62400948116799, 218, 22, 'PPL', 'P'),
(49644, 'Mount Lebanon', 39.2816696166992, 0.68559447049202, -77.1780624389648, -1.3470112998697, 218, 25, 'PPL', 'P'),
(89210, 'Mount Lebanon', 35.6069412231445, 0.621458360907969, -89.7072219848633, -1.56568638645331, 218, 50, 'PPL', 'P'),
(145833, 'Mount Lebanon', 40.7569389343262, 0.711342777438261, -74.8680572509766, -1.30669410360116, 218, 37, 'PPL', 'P'),
(164865, 'Mount Lebanon', 40.355281829834, 0.704332538500845, -80.0497207641602, -1.39713119263667, 218, 45, 'PPL', 'P'),
(73580, 'Mount Leigh (historical)', 38.9555587768555, 0.679902762610303, -83.5736083984375, -1.45863463432512, 218, 41, 'PPL', 'P'),
(49645, 'Mount Lena', 39.5591697692871, 0.690437761829466, -77.6283264160156, -1.35486988877236, 218, 25, 'PPL', 'P'),
(89211, 'Mount Leo', 35.6711082458496, 0.622578286725375, -85.7552795410156, -1.49671197895885, 218, 50, 'PPL', 'P'),
(56403, 'Mount Leonard', 39.1241683959961, 0.682845555614841, -93.3927764892578, -1.6300114473167, 218, 29, 'PPL', 'P'),
(30581, 'Mount Liberty', 39.1841697692871, 0.683892777134487, -86.1302795410156, -1.50325696365383, 218, 19, 'PPL', 'P'),
(110546, 'Mount Liberty', 39.0791702270508, 0.682060189409376, -80.0219421386719, -1.39664636416022, 218, 58, 'PPL', 'P'),
(156632, 'Mount Liberty', 40.3466682434082, 0.70418220305731, -82.6302795410156, -1.44217043983403, 218, 41, 'PPL', 'P'),
(187088, 'Mount Lincoln', 39.1061096191406, 0.68253037049983, -108.382781982422, -1.89163639806445, 218, 7, 'PPL', 'P'),
(73581, 'Mount Lookout', 39.1288909912109, 0.682927980450578, -84.4302825927734, -1.47358641963315, 218, 41, 'PPL', 'P'),
(110547, 'Mount Lookout', 38.1666717529297, 0.666134086616539, -80.9119415283203, -1.41217978385032, 218, 58, 'PPL', 'P'),
(96369, 'Mount Lucas', 28.1866703033447, 0.491950201967474, -97.9461135864258, -1.70948217161548, 218, 51, 'PPL', 'P'),
(116956, 'Mount Lucia', 42.5405616760254, 0.74247286689436, -96.4644393920898, -1.68362207848249, 218, 16, 'PPL', 'P'),
(144172, 'Mount Major', 43.5222206115723, 0.759606047451276, -71.2716674804688, -1.24392526092075, 218, 36, 'PPL', 'P'),
(150900, 'Mount Marion', 42.0386085510254, 0.733712132172436, -73.9869384765625, -1.29131567988649, 218, 40, 'PPL', 'P'),
(150901, 'Mount Marion Park', 42.0369415283203, 0.733683037137527, -73.9972229003906, -1.29149517694396, 218, 40, 'PPL', 'P'),
(187089, 'Mount Massive Lakes', 39.1522216796875, 0.683335177781252, -106.300003051758, -1.85528504813319, 218, 7, 'PPL', 'P'),
(4380, 'Mount Meigs', 32.3624992370605, 0.564832165860859, -86.101936340332, -1.50276228148135, 218, 2, 'PPL', 'P'),
(4381, 'Mount Meigs Station', 32.399169921875, 0.565472190049833, -86.1069412231445, -1.50284963316511, 218, 2, 'PPL', 'P'),
(30582, 'Mount Meridian', 39.6019401550293, 0.691184245883015, -86.7574996948242, -1.51420402047266, 218, 19, 'PPL', 'P'),
(71144, 'Mount Misery', 39.9197196960449, 0.696730545169214, -74.5233306884766, -1.30067749006645, 218, 37, 'PPL', 'P'),
(78783, 'Mount Misery', 39.8397216796875, 0.695334316388713, -77.0438919067383, -1.3446695823232, 218, 45, 'PPL', 'P'),
(67000, 'Mount Mitchell', 35.9122200012207, 0.626786480721863, -82.291389465332, -1.43625569221102, 218, 33, 'PPL', 'P'),
(96370, 'Mount Mitchell', 33.121940612793, 0.578086918343266, -94.8041687011719, -1.65464488845161, 218, 51, 'PPL', 'P'),
(190516, 'Mount Montgomery', 37.9797210693359, 0.662871181648974, -118.320556640625, -2.06508328617135, 218, 39, 'PPL', 'P'),
(4384, 'Mount Moriah', 34.5441703796387, 0.602909510494594, -87.3244400024414, -1.52409899550285, 218, 2, 'PPL', 'P'),
(10638, 'Mount Moriah', 34.1088905334473, 0.59531244401098, -93.6908264160156, -1.63521339987395, 218, 4, 'PPL', 'P'),
(42197, 'Mount Moriah', 32.2866706848145, 0.563508707957145, -92.413330078125, -1.61291688259559, 218, 22, 'PPL', 'P'),
(49646, 'Mount Moriah', 39.5369415283203, 0.690049805837668, -77.7850036621094, -1.35760442257966, 218, 25, 'PPL', 'P'),
(60968, 'Mount Moriah', 34.9713897705078, 0.610365895493626, -88.9402770996094, -1.5523006730243, 218, 30, 'PPL', 'P'),
(89214, 'Mount Moriah', 36.3038902282715, 0.633622415765933, -89.2330627441406, -1.55741074652394, 218, 50, 'PPL', 'P'),
(110548, 'Mount Moriah', 38.7863883972168, 0.676950182488759, -81.7658309936523, -1.42708296646846, 218, 58, 'PPL', 'P'),
(139346, 'Mount Moriah', 40.329719543457, 0.70388639243923, -93.7944412231445, -1.63702181941217, 218, 29, 'PPL', 'P'),
(96371, 'Mount Morian', 30.726110458374, 0.536271793830091, -95.4913864135742, -1.66663910021105, 218, 51, 'PPL', 'P'),
(78784, 'Mount Morris', 39.7330589294434, 0.69347270020772, -80.0680618286133, -1.39745130459969, 218, 45, 'PPL', 'P'),
(120713, 'Mount Morris', 42.0502815246582, 0.733915863995827, -89.4311065673828, -1.56086726330275, 218, 18, 'PPL', 'P'),
(132190, 'Mount Morris', 43.1186103820801, 0.752561720051908, -83.6949996948242, -1.46075331213033, 218, 27, 'PPL', 'P'),
(150902, 'Mount Morris', 42.7255592346191, 0.745701683399972, -77.8744430541992, -1.35916543445261, 218, 40, 'PPL', 'P'),
(175425, 'Mount Morris', 44.1144409179688, 0.769942241695064, -89.190559387207, -1.5566689230023, 218, 57, 'PPL', 'P'),
(67001, 'Mount Mourne', 35.5430603027344, 0.620343428517607, -80.8475036621094, -1.41105513092198, 218, 33, 'PPL', 'P'),
(4385, 'Mount Nebo', 32.2897186279297, 0.563561904599919, -87.0524978637695, -1.51935270980811, 218, 2, 'PPL', 'P'),
(10639, 'Mount Nebo', 35.2188911437988, 0.614685609360761, -93.2522201538086, -1.62755827647857, 218, 4, 'PPL', 'P'),
(60969, 'Mount Nebo', 32.7027816772461, 0.570771214828818, -88.7069396972656, -1.54822816708535, 218, 30, 'PPL', 'P'),
(89216, 'Mount Nebo', 35.6500015258789, 0.622209904967589, -87.1655578613281, -1.5213259790178, 218, 50, 'PPL', 'P'),
(104450, 'Mount Nebo', 37.5105590820313, 0.654682760245307, -77.579719543457, -1.35402153880712, 218, 53, 'PPL', 'P'),
(110550, 'Mount Nebo', 39.6022186279297, 0.691189106152004, -79.7080612182617, -1.39116810863987, 218, 58, 'PPL', 'P'),
(164868, 'Mount Nebo', 40.1222190856934, 0.700264826251858, -79.6072235107422, -1.38940815863349, 218, 45, 'PPL', 'P'),
(89217, 'Mount Nebo (historical)', 35.725830078125, 0.623533362871304, -83.8399963378906, -1.46328398095618, 218, 50, 'PPL', 'P'),
(204998, 'Mount Ogden Park', 41.2097206115723, 0.719245308498907, -111.934722900391, -1.95362946191931, 218, 52, 'PPL', 'P'),
(204999, 'Mount Ogden Park Condominium Phase One', 41.2066688537598, 0.719192045277106, -111.936111450195, -1.95365369668523, 218, 52, 'PPL', 'P'),
(205000, 'Mount Ogden Park Estates', 41.2038917541504, 0.719143575745266, -111.937782287598, -1.95368285829917, 218, 52, 'PPL', 'P'),
(205002, 'Mount Ogden Terrace Condominium Project', 41.207218170166, 0.71920163265703, -111.943893432617, -1.95378951790083, 218, 52, 'PPL', 'P'),
(4395, 'Mount Olive', 33.2991714477539, 0.581180179949393, -87.6508331298828, -1.52979563023258, 218, 2, 'PPL', 'P'),
(10645, 'Mount Olive', 36.0016708374023, 0.628347692331895, -93.9511108398438, -1.63975622006141, 218, 4, 'PPL', 'P'),
(17204, 'Mount Olive', 29.2013893127441, 0.509660389664069, -82.2850036621094, -1.4361442389194, 218, 12, 'PPL', 'P'),
(23217, 'Mount Olive', 32.5833282470703, 0.568686359169449, -83.3874969482422, -1.45538637674355, 218, 13, 'PPL', 'P'),
(27970, 'Mount Olive', 39.0722198486328, 0.681938882421723, -89.7272186279297, -1.56603539371416, 218, 18, 'PPL', 'P'),
(30583, 'Mount Olive', 38.7986106872559, 0.677163501692075, -86.6941680908203, -1.51309867546222, 218, 19, 'PPL', 'P'),
(37297, 'Mount Olive', 37.6150016784668, 0.656505627432439, -83.7302780151367, -1.46136903497436, 218, 21, 'PPL', 'P'),
(42198, 'Mount Olive', 32.3311080932617, 0.564284287045603, -92.8038864135742, -1.6197333765637, 218, 22, 'PPL', 'P'),
(56404, 'Mount Olive', 38.9005584716797, 0.678942826195384, -93.6947174072266, -1.63528131048175, 218, 29, 'PPL', 'P'),
(60973, 'Mount Olive', 31.7441692352295, 0.554040271465045, -89.0522232055664, -1.55425450115803, 218, 30, 'PPL', 'P'),
(67007, 'Mount Olive', 35.1963882446289, 0.614292859679002, -78.0666732788086, -1.36252048479389, 218, 33, 'PPL', 'P'),
(73582, 'Mount Olive', 38.8866691589355, 0.678700411957159, -84.0919418334961, -1.46768125939006, 218, 41, 'PPL', 'P'),
(82497, 'Mount Olive', 34.3800010681152, 0.600044215477778, -82.1536102294922, -1.43385099090473, 218, 48, 'PPL', 'P'),
(89221, 'Mount Olive', 35.8875007629395, 0.62635504862527, -86.4408264160156, -1.50867702910436, 218, 50, 'PPL', 'P'),
(96373, 'Mount Olive', 29.3924999237061, 0.512995899060853, -97.0997161865234, -1.69470975020687, 218, 51, 'PPL', 'P'),
(104452, 'Mount Olive', 38.9777793884277, 0.680290585444046, -78.4574966430664, -1.36934163929391, 218, 53, 'PPL', 'P'),
(110554, 'Mount Olive', 38.8216705322266, 0.677565971911813, -81.4274978637695, -1.42117793938343, 218, 58, 'PPL', 'P'),
(145834, 'Mount Olive', 40.851390838623, 0.71299127415302, -74.7333297729492, -1.30434266551667, 218, 37, 'PPL', 'P'),
(4396, 'Mount Olive (historical)', 34.9416694641113, 0.609847178292305, -88.084716796875, -1.53736832879222, 218, 2, 'PPL', 'P'),
(10646, 'Mount Olive (historical)', 33.9494400024414, 0.592529507250874, -93.9066696166992, -1.63898057439392, 218, 4, 'PPL', 'P'),
(23218, 'Mount Olive (historical)', 30.8152809143066, 0.53782811188162, -84.0522232055664, -1.46698803855832, 218, 13, 'PPL', 'P'),
(89222, 'Mount Olive (historical)', 35.8722190856934, 0.626088333042099, -86.4305572509766, -1.508497798363, 218, 50, 'PPL', 'P'),
(49648, 'Mount Olive Manor', 38.3086090087891, 0.66861135906253, -75.5036087036133, -1.3177865690155, 218, 25, 'PPL', 'P'),
(104453, 'Mount Olive Terrace', 37.6647186279297, 0.657373351894614, -77.7113876342773, -1.35631958051175, 218, 53, 'PPL', 'P'),
(164870, 'Mount Oliver', 40.4141693115234, 0.705360318944534, -79.9880599975586, -1.39605500924016, 218, 45, 'PPL', 'P'),
(23219, 'Mount Olivet', 34.4002799987793, 0.60039814958665, -82.9855575561523, -1.44837121095812, 218, 13, 'PPL', 'P'),
(37298, 'Mount Olivet', 38.5313911437988, 0.672499640833073, -84.0369415283203, -1.46672132297515, 218, 21, 'PPL', 'P'),
(60974, 'Mount Olivet', 34.2936096191406, 0.598536400247602, -89.7880630493164, -1.56709732919883, 218, 30, 'PPL', 'P'),
(104455, 'Mount Olivet', 37.0444412231445, 0.646547468905388, -80.8102798461914, -1.41040545277406, 218, 53, 'PPL', 'P'),
(177249, 'Mount Olivet', 40.0191688537598, 0.698466260409673, -80.6952819824219, -1.40839836141852, 218, 58, 'PPL', 'P'),
(187090, 'Mount Olivet', 39.7874984741211, 0.694422849505633, -105.141670227051, -1.83506832650813, 218, 7, 'PPL', 'P'),
(89223, 'Mount Olivet (historical)', 35.7041702270508, 0.623155327154568, -86.2994384765625, -1.50620934403829, 218, 50, 'PPL', 'P'),
(30584, 'Mount Olympus', 38.4472198486328, 0.671030574596759, -87.4749984741211, -1.52672673655043, 218, 19, 'PPL', 'P'),
(205003, 'Mount Olympus', 40.6855583190918, 0.710096950680322, -111.787780761719, -1.95106483778957, 218, 52, 'PPL', 'P'),
(205006, 'Mount Olympus Gardens Condominium', 40.6547203063965, 0.709558725824017, -111.865280151367, -1.95241745730722, 218, 52, 'PPL', 'P'),
(73583, 'Mount Orab', 39.0275001525879, 0.681158376485248, -83.9197235107422, -1.46467548262575, 218, 41, 'PPL', 'P'),
(89224, 'Mount Orange', 35.9566688537598, 0.627562259547403, -89.0033264160156, -1.55340109118672, 218, 50, 'PPL', 'P'),
(120715, 'Mount Palatine', 41.1925010681152, 0.718944770769892, -89.1630630493164, -1.55618902137387, 218, 18, 'PPL', 'P'),
(113755, 'Mount Parnassus', 41.4716682434082, 0.723817157142246, -72.413330078125, -1.26385103219672, 218, 8, 'PPL', 'P'),
(164872, 'Mount Patrick', 40.5272216796875, 0.707333454996174, -76.9886093139648, -1.34370471906026, 218, 45, 'PPL', 'P'),
(187091, 'Mount Pearl', 38.9625015258789, 0.680023936439902, -102.788887023926, -1.79400451302798, 218, 7, 'PPL', 'P'),
(89225, 'Mount Pelia', 36.3175010681152, 0.633859969735168, -88.9494400024414, -1.55246059584776, 218, 50, 'PPL', 'P'),
(164873, 'Mount Penn', 40.3280601501465, 0.703857430562375, -75.89111328125, -1.32454979976181, 218, 45, 'PPL', 'P'),
(10648, 'Mount Perrian (historical)', 36.4833297729492, 0.636754226628839, -92.8358306884766, -1.62029090933791, 218, 4, 'PPL', 'P'),
(73584, 'Mount Perry', 39.8786087036133, 0.696013022992519, -82.2200012207031, -1.43500973229503, 218, 41, 'PPL', 'P'),
(10649, 'Mount Pilgrim', 34.8944396972656, 0.609022863355899, -92.4413909912109, -1.61340663792006, 218, 4, 'PPL', 'P'),
(67008, 'Mount Pilgrim', 36.0097198486328, 0.628488174079397, -77.3363876342773, -1.34977459581677, 218, 33, 'PPL', 'P'),
(23220, 'Mount Pisgah', 34.8458290100098, 0.608174446811627, -85.1791687011719, -1.48665694794715, 218, 13, 'PPL', 'P'),
(37299, 'Mount Pisgah', 36.6588897705078, 0.63981832662103, -84.8147201538086, -1.48029612084155, 218, 21, 'PPL', 'P'),
(49650, 'Mount Pisgah', 38.5336112976074, 0.672538389826934, -77.1130599975586, -1.34587679324533, 218, 25, 'PPL', 'P'),
(73585, 'Mount Pisgah', 38.9836082458496, 0.680392318197687, -84.2319412231445, -1.47012470969021, 218, 41, 'PPL', 'P'),
(82499, 'Mount Pisgah', 34.5580596923828, 0.603151924732819, -80.4452819824219, -1.40403503828853, 218, 48, 'PPL', 'P'),
(89226, 'Mount Pisgah', 35.8494415283203, 0.625690789670378, -85.5936126708984, -1.49389035978392, 218, 50, 'PPL', 'P'),
(104456, 'Mount Pisgah', 38.2533302307129, 0.667646562378622, -79.003059387207, -1.37886350545538, 218, 53, 'PPL', 'P'),
(110556, 'Mount Pisgah', 39.2897186279297, 0.685734952239522, -79.1716690063477, -1.38180629845991, 218, 58, 'PPL', 'P'),
(123255, 'Mount Pisgah', 41.6030616760254, 0.726110405156914, -85.2436065673828, -1.48778160087549, 218, 19, 'PPL', 'P'),
(128204, 'Mount Pisgah', 43.8530616760254, 0.765380313326786, -69.6222229003906, -1.21513702216921, 218, 26, 'PPL', 'P'),
(145836, 'Mount Pisgah', 41.1508293151855, 0.718217461476191, -74.7655563354492, -1.3049051251389, 218, 37, 'PPL', 'P'),
(67009, 'Mount Pisgah (historical)', 35.4683303833008, 0.619039145373741, -81.8861083984375, -1.42918220319772, 218, 33, 'PPL', 'P'),
(23221, 'Mount Pisgah Estates', 33.8011093139648, 0.589940648355208, -84.5886077880859, -1.47634971558022, 218, 13, 'PPL', 'P'),
(4400, 'Mount Pleasant', 33.3125, 0.581412807070611, -85.3930587768555, -1.49039003400517, 218, 2, 'PPL', 'P'),
(10655, 'Mount Pleasant', 33.458610534668, 0.583962916972416, -93.4936065673828, -1.63177126416502, 218, 4, 'PPL', 'P'),
(13165, 'Mount Pleasant', 38.9305610656738, 0.679466470244721, -77.0411071777344, -1.3446209796333, 218, 9, 'PPL', 'P'),
(14272, 'Mount Pleasant', 39.5108299255371, 0.689594072396129, -75.711669921875, -1.32141792231988, 218, 10, 'PPL', 'P'),
(17206, 'Mount Pleasant', 30.1391696929932, 0.526027744960019, -84.3883285522461, -1.47285418349143, 218, 12, 'PPL', 'P'),
(23228, 'Mount Pleasant', 31.4338893890381, 0.548624866546423, -81.679443359375, -1.42557521781731, 218, 13, 'PPL', 'P'),
(27972, 'Mount Pleasant', 37.4519386291504, 0.653659640333526, -89.0736083984375, -1.55462774318481, 218, 18, 'PPL', 'P'),
(37301, 'Mount Pleasant', 38.6130599975586, 0.673925031227511, -85.3838882446289, -1.49022997802366, 218, 21, 'PPL', 'P'),
(42201, 'Mount Pleasant', 32.4408302307129, 0.566199299606452, -92.3000030517578, -1.61093895285399, 218, 22, 'PPL', 'P'),
(49656, 'Mount Pleasant', 38.3527793884277, 0.669382277619081, -75.3349990844727, -1.31484377601096, 218, 25, 'PPL', 'P'),
(60978, 'Mount Pleasant', 31.0786094665527, 0.542424062132824, -91.1500015258789, -1.59086763982444, 218, 30, 'PPL', 'P'),
(67017, 'Mount Pleasant', 36.2244415283203, 0.632235774365356, -80.628059387207, -1.40722510580028, 218, 33, 'PPL', 'P'),
(82500, 'Mount Pleasant', 32.7938919067383, 0.572361388315704, -79.8627777099609, -1.39386842082716, 218, 48, 'PPL', 'P'),
(89229, 'Mount Pleasant', 35.5341682434082, 0.620188232805083, -87.2069396972656, -1.52204822830543, 218, 50, 'PPL', 'P'),
(96375, 'Mount Pleasant', 33.1566696166992, 0.578693053807368, -94.9680633544922, -1.65750538977846, 218, 51, 'PPL', 'P'),
(104463, 'Mount Pleasant', 37.2044410705566, 0.649339993045417, -76.8252792358398, -1.34085407142944, 218, 53, 'PPL', 'P'),
(110558, 'Mount Pleasant', 39.2586097717285, 0.685192000272282, -77.9486083984375, -1.36045986390044, 218, 58, 'PPL', 'P'),
(116957, 'Mount Pleasant', 40.9636116027832, 0.714949895976718, -91.5577774047852, -1.59798467152157, 218, 16, 'PPL', 'P'),
(123257, 'Mount Pleasant', 40.0888900756836, 0.699683125290757, -85.3058319091797, -1.48886763796803, 218, 19, 'PPL', 'P'),
(125490, 'Mount Pleasant', 41.6624984741211, 0.727147772980527, -70.9527816772461, -1.23835965371665, 218, 23, 'PPL', 'P'),
(132194, 'Mount Pleasant', 43.5977783203125, 0.760924778244056, -84.7675018310547, -1.47947200564223, 218, 27, 'PPL', 'P'),
(139347, 'Mount Pleasant', 40.2272186279297, 0.702097413976969, -94.5008316040039, -1.64935065736258, 218, 29, 'PPL', 'P'),
(145840, 'Mount Pleasant', 40.9666709899902, 0.715003292356575, -75.0763931274414, -1.3103302505955, 218, 37, 'PPL', 'P'),
(150908, 'Mount Pleasant', 41.0961112976074, 0.717262451909289, -73.7938919067383, -1.28794638163338, 218, 40, 'PPL', 'P'),
(156637, 'Mount Pleasant', 40.9077796936035, 0.713975445333858, -81.4055633544922, -1.42079510997673, 218, 41, 'PPL', 'P'),
(164891, 'Mount Pleasant', 40.1369400024414, 0.700521754718023, -76.9633331298828, -1.34326356642569, 218, 45, 'PPL', 'P'),
(172287, 'Mount Pleasant', 43.8083305358887, 0.764599607653229, -73.0894393920898, -1.27565136582881, 218, 55, 'PPL', 'P'),
(183485, 'Mount Pleasant', 39.6124992370605, 0.691368536630448, -120.977500915527, -2.11145571181041, 218, 6, 'PPL', 'P'),
(192716, 'Mount Pleasant', 39.5469398498535, 0.690224309468096, -111.454719543457, -1.9452518229202, 218, 52, 'PPL', 'P'),
(201267, 'Mount Pleasant', 45.339168548584, 0.791317771289449, -122.605278015137, -2.13986578168715, 218, 43, 'PPL', 'P'),
(208188, 'Mount Pleasant', 45.560001373291, 0.795172031177066, -122.256393432617, -2.13377659701274, 218, 56, 'PPL', 'P'),
(4401, 'Mount Pleasant (historical)', 34.7708282470703, 0.606865436556825, -87.6069412231445, -1.52902957194502, 218, 2, 'PPL', 'P'),
(10656, 'Mount Pleasant (historical)', 36.1819381713867, 0.631493950843715, -93.0341720581055, -1.62375261928085, 218, 4, 'PPL', 'P'),
(49657, 'Mount Pleasant (historical)', 39.7041702270508, 0.692968497234341, -76.1736068725586, -1.32948024304593, 218, 25, 'PPL', 'P'),
(156638, 'Mount Pleasant (historical)', 40.0944404602051, 0.699779997775409, -84.7072219848633, -1.47841992385359, 218, 41, 'PPL', 'P'),
(49659, 'Mount Pleasant Acres', 39.6597213745117, 0.692192718408801, -76.083610534668, -1.327909510635, 218, 25, 'PPL', 'P'),
(49660, 'Mount Pleasant Beach', 39.1497192382813, 0.683291501939374, -76.5322189331055, -1.33573920423983, 218, 25, 'PPL', 'P'),
(49661, 'Mount Pleasant East', 39.4508285522461, 0.688546850876482, -77.3152770996094, -1.34940614747996, 218, 25, 'PPL', 'P'),
(49662, 'Mount Pleasant Estates', 39.4599990844727, 0.688706906857996, -77.3108291625977, -1.34932851633418, 218, 25, 'PPL', 'P'),
(104465, 'Mount Pleasant Estates', 38.3363914489746, 0.669096254118007, -77.4541702270508, -1.3518302898622, 218, 53, 'PPL', 'P'),
(110559, 'Mount Pleasant Estates', 39.1855583190918, 0.683917011900407, -81.503059387207, -1.42249673675523, 218, 58, 'PPL', 'P'),
(49663, 'Mount Pleasant Farms', 38.788890838623, 0.676993858330637, -76.2461090087891, -1.33074564403788, 218, 25, 'PPL', 'P'),
(56406, 'Mount Pleasant Ford', 38.1683311462402, 0.666163048493393, -91.5438919067383, -1.59774232386237, 218, 29, 'PPL', 'P'),
(4402, 'Mount Pleasant Landing', 31.3491706848145, 0.547146246219698, -87.7211074829102, -1.53102214907262, 218, 2, 'PPL', 'P'),
(49664, 'Mount Pleasant Manor', 39.6730613708496, 0.692425545267101, -76.1083297729492, -1.32834094273159, 218, 25, 'PPL', 'P'),
(164892, 'Mount Pleasant Mill', 40.7238883972168, 0.71076593674615, -77.0066680908203, -1.34401990417527, 218, 45, 'PPL', 'P'),
(164893, 'Mount Pleasant Mills', 40.7230606079102, 0.710751489097236, -77.01611328125, -1.34418475384675, 218, 45, 'PPL', 'P'),
(14271, 'Mount Pleasant Mobile Home Park', 39.5152816772461, 0.689671770120932, -75.7119369506836, -1.32142258285178, 218, 10, 'PPL', 'P'),
(49665, 'Mount Pleasant View', 39.6699981689453, 0.692372082308217, -76.1236114501953, -1.32860765831476, 218, 25, 'PPL', 'P'),
(17208, 'Mount Plymouth', 28.8077793121338, 0.502790599184642, -81.533332824707, -1.42302510791551, 218, 12, 'PPL', 'P'),
(17209, 'Mount Plymouth Lakes', 28.7677803039551, 0.502092484794391, -81.5199966430664, -1.42279234763623, 218, 12, 'PPL', 'P'),
(164899, 'Mount Pocono', 41.121940612793, 0.717713258502812, -75.3649978637695, -1.31536735348127, 218, 45, 'PPL', 'P'),
(4403, 'Mount Polk', 33.8708305358887, 0.591157513236293, -85.8688888549805, -1.49869483554847, 218, 2, 'PPL', 'P'),
(120717, 'Mount Prospect', 42.0663909912109, 0.734197027227912, -87.9372177124023, -1.5347939841245, 218, 18, 'PPL', 'P'),
(49666, 'Mount Prospect Estates', 39.5486106872559, 0.690253471082032, -77.4208297729492, -1.35124838916402, 218, 25, 'PPL', 'P'),
(150910, 'Mount Prosper', 41.5908317565918, 0.725896952795544, -74.5358276367188, -1.30089560295973, 218, 40, 'PPL', 'P'),
(120718, 'Mount Pulaski', 40.0108299255371, 0.6983207186561, -89.2822189331055, -1.55826868386911, 218, 18, 'PPL', 'P'),
(49667, 'Mount Radnor Heights', 39.3008308410645, 0.685928896945907, -77.1911087036133, -1.3472390001429, 218, 25, 'PPL', 'P'),
(49668, 'Mount Rainier', 38.9413909912109, 0.679655488103089, -76.9652786254883, -1.34329752172959, 218, 25, 'PPL', 'P'),
(150911, 'Mount Read', 43.2527809143066, 0.754903437598414, -77.6594390869141, -1.35541290731863, 218, 40, 'PPL', 'P'),
(104466, 'Mount Regis Heights', 37.2744407653809, 0.650561718195491, -80.0638885498047, -1.39737846714388, 218, 53, 'PPL', 'P'),
(82501, 'Mount Rena', 33.5180587768555, 0.585000484533111, -79.1297225952148, -1.38107419547625, 218, 48, 'PPL', 'P'),
(73588, 'Mount Repose', 39.2005615234375, 0.684178867214589, -84.2244415283203, -1.46999381532263, 218, 41, 'PPL', 'P'),
(150912, 'Mount Riga', 41.9947204589844, 0.732946140463902, -73.5149993896484, -1.28307878895099, 218, 40, 'PPL', 'P'),
(164903, 'Mount Rock', 40.6133308410645, 0.708836343378333, -77.5719375610352, -1.35388571759152, 218, 45, 'PPL', 'P'),
(67018, 'Mount Rose', 36.2561111450195, 0.632788513449602, -76.6708297729492, -1.33815841977406, 218, 33, 'PPL', 'P'),
(145841, 'Mount Rose', 40.3691711425781, 0.70457495273907, -74.7394409179688, -1.30444932511833, 218, 37, 'PPL', 'P'),
(150913, 'Mount Ross', 42.0050010681152, 0.733125570942346, -73.7155609130859, -1.28657924788779, 218, 40, 'PPL', 'P'),
(17210, 'Mount Royal', 29.4294395446777, 0.513640617071247, -81.521110534668, -1.42281178871219, 218, 12, 'PPL', 'P'),
(49669, 'Mount Royal', 39.3074989318848, 0.686045277085543, -76.6311111450195, -1.33746519894231, 218, 25, 'PPL', 'P'),
(71147, 'Mount Royal', 39.810001373291, 0.694815599187392, -75.211669921875, -1.31269127605991, 218, 37, 'PPL', 'P'),
(164904, 'Mount Royal', 40.0391693115234, 0.698815334249555, -76.8880615234375, -1.34194982905995, 218, 45, 'PPL', 'P'),
(4404, 'Mount Rozell', 34.935001373291, 0.609730798152669, -87.1402816772461, -1.52088482638323, 218, 2, 'PPL', 'P'),
(104467, 'Mount Rush', 37.5374984741211, 0.655152941335761, -78.6147232055664, -1.37208576048112, 218, 53, 'PPL', 'P'),
(73589, 'Mount Saint John', 39.7186088562012, 0.693220498852489, -84.0997161865234, -1.4678169474476, 218, 41, 'PPL', 'P'),
(73590, 'Mount Saint Joseph', 39.0963897705078, 0.682360727138392, -84.6374969482422, -1.47720299239348, 218, 41, 'PPL', 'P'),
(37302, 'Mount Salem', 37.4172210693359, 0.653053704606506, -84.7994384765625, -1.48002940525838, 218, 21, 'PPL', 'P'),
(145843, 'Mount Salem', 41.3144416809082, 0.721073035955029, -74.6163864135742, -1.30230161885723, 218, 37, 'PPL', 'P'),
(37303, 'Mount Savage', 38.2652816772461, 0.667855154471003, -82.8913879394531, -1.44672764109138, 218, 21, 'PPL', 'P'),
(49670, 'Mount Savage', 39.6955604553223, 0.692818228369833, -78.879997253418, -1.37671566603623, 218, 25, 'PPL', 'P'),
(49671, 'Mount Savage Junction', 39.6877784729004, 0.692682407154239, -78.7822189331055, -1.3750091124097, 218, 25, 'PPL', 'P'),
(96376, 'Mount Selman', 32.0680618286133, 0.559693263642415, -95.2838897705078, -1.66301760060271, 218, 51, 'PPL', 'P'),
(4405, 'Mount Sharon', 33.2102813720703, 0.579628755456367, -86.4108276367188, -1.50815345163405, 218, 2, 'PPL', 'P'),
(193806, 'Mount Shasta', 41.310001373291, 0.720995537967307, -122.309440612793, -2.13470244496571, 218, 6, 'PPL', 'P'),
(10659, 'Mount Sherman', 36.0308303833008, 0.628856622416209, -93.2561111450195, -1.62762618708637, 218, 4, 'PPL', 'P'),
(37304, 'Mount Sherman', 37.4524993896484, 0.653669427450532, -85.668327331543, -1.49519437661167, 218, 21, 'PPL', 'P'),
(56410, 'Mount Shira', 36.5816688537598, 0.638470567372368, -94.4641723632813, -1.64871083291069, 218, 29, 'PPL', 'P'),
(104468, 'Mount Sidney', 38.2572212219238, 0.667714472986419, -78.959716796875, -1.37810703454774, 218, 53, 'PPL', 'P'),
(183486, 'Mount Signal', 32.6783294677734, 0.570344443264133, -115.638328552246, -2.01826957473966, 218, 6, 'PPL', 'P'),
(4407, 'Mount Sinai', 32.2938919067383, 0.563634742055733, -86.4683303833008, -1.50915706389085, 218, 2, 'PPL', 'P'),
(30588, 'Mount Sinai', 39.0805587768555, 0.682084424175296, -84.9986114501953, -1.48350562942926, 218, 19, 'PPL', 'P'),
(67019, 'Mount Sinai', 35.2008285522461, 0.614370357666723, -81.6002807617188, -1.42419356984378, 218, 33, 'PPL', 'P'),
(73591, 'Mount Sinai', 39.1425018310547, 0.683165534419814, -82.7986068725586, -1.44510830599055, 218, 41, 'PPL', 'P'),
(150914, 'Mount Sinai', 40.9469413757324, 0.714658945627627, -73.0299987792969, -1.27461393142617, 218, 40, 'PPL', 'P'),
(104469, 'Mount Solon', 38.3447189331055, 0.669241596134498, -79.0852813720703, -1.38029854980877, 218, 53, 'PPL', 'P'),
(10660, 'Mount Springs Estates', 34.9716682434082, 0.610370755762615, -91.9061126708984, -1.60406426881606, 218, 4, 'PPL', 'P'),
(4408, 'Mount Sterling', 32.0936088562012, 0.560139143387922, -88.1630630493164, -1.53873572885392, 218, 2, 'PPL', 'P'),
(27974, 'Mount Sterling', 39.9872207641602, 0.697908661056438, -90.7633285522461, -1.58411892330607, 218, 18, 'PPL', 'P'),
(30589, 'Mount Sterling', 38.7958297729492, 0.677114965581208, -85.0738906860352, -1.48481949995305, 218, 19, 'PPL', 'P'),
(37305, 'Mount Sterling', 38.0563888549805, 0.664209286938684, -83.9433288574219, -1.46508747364638, 218, 21, 'PPL', 'P'),
(56411, 'Mount Sterling', 38.4650001525879, 0.67134089944278, -91.6269378662109, -1.59919174928565, 218, 29, 'PPL', 'P'),
(67020, 'Mount Sterling', 35.7619400024414, 0.624163599943272, -83.103889465332, -1.45043649238347, 218, 33, 'PPL', 'P'),
(73593, 'Mount Sterling', 39.9563903808594, 0.697370569358187, -82.1500015258789, -1.43378800714495, 218, 41, 'PPL', 'P'),
(78790, 'Mount Sterling', 39.8461112976074, 0.69544583625936, -79.9352798461914, -1.39513382181911, 218, 45, 'PPL', 'P'),
(116959, 'Mount Sterling', 40.6177787780762, 0.708913974524108, -91.9319381713867, -1.60451500883055, 218, 16, 'PPL', 'P'),
(175430, 'Mount Sterling', 43.3152809143066, 0.755994268380911, -90.9286117553711, -1.58700365939885, 218, 57, 'PPL', 'P'),
(205009, 'Mount Sterling', 41.6097183227539, 0.726226585559468, -111.936393737793, -1.95365862353325, 218, 52, 'PPL', 'P'),
(89230, 'Mount Sterling (historical)', 35.8880615234375, 0.626364835742277, -85.8016662597656, -1.49752157993024, 218, 50, 'PPL', 'P'),
(110561, 'Mount Storm', 39.2772216796875, 0.685516839346245, -79.2411117553711, -1.38301830307201, 218, 58, 'PPL', 'P'),
(89231, 'Mount Sulphur', 35.7730598449707, 0.624357677807711, -84.8199996948242, -1.48038826621527, 218, 50, 'PPL', 'P'),
(73594, 'Mount Summit', 39.0886116027832, 0.682224972501825, -84.3300018310547, -1.47183619016475, 218, 41, 'PPL', 'P'),
(123261, 'Mount Summit', 40.0044403076172, 0.698209198785453, -85.3847198486328, -1.4902444922516, 218, 19, 'PPL', 'P'),
(144173, 'Mount Sunapee', 43.3405609130859, 0.75643548759451, -72.0713882446289, -1.25788302135191, 218, 36, 'PPL', 'P'),
(96377, 'Mount Sylvan', 32.457218170166, 0.566485323107526, -95.4686126708984, -1.66624162341836, 218, 51, 'PPL', 'P'),
(4409, 'Mount Tabor', 34.440559387207, 0.601101157535403, -86.8666687011719, -1.51610937907456, 218, 2, 'PPL', 'P'),
(10661, 'Mount Tabor', 34.7075004577637, 0.605760158125415, -93.3377838134766, -1.62905164405983, 218, 4, 'PPL', 'P'),
(30590, 'Mount Tabor', 39.3113899230957, 0.686113187693341, -86.6333312988281, -1.51203687313561, 218, 19, 'PPL', 'P'),
(37306, 'Mount Tabor', 36.958610534668, 0.645049440792218, -87.2191696166992, -1.5222616806668, 218, 21, 'PPL', 'P'),
(67022, 'Mount Tabor', 35.8699989318848, 0.626049584048238, -76.4422225952148, -1.3341684718289, 218, 33, 'PPL', 'P'),
(82502, 'Mount Tabor', 33.6177787780762, 0.586740926884505, -79.1949996948242, -1.38221349579059, 218, 48, 'PPL', 'P'),
(89234, 'Mount Tabor', 35.7591705322266, 0.624115263569487, -86.3361129760742, -1.5068494348063, 218, 50, 'PPL', 'P'),
(104470, 'Mount Tabor', 37.2663917541504, 0.65042123644799, -80.4002838134766, -1.40324967208307, 218, 53, 'PPL', 'P'),
(110563, 'Mount Tabor', 37.7983283996582, 0.659705282324115, -81.232780456543, -1.41777947951638, 218, 58, 'PPL', 'P'),
(156640, 'Mount Tabor', 40.5200004577637, 0.707207420897586, -81.3733291625977, -1.42023251719645, 218, 41, 'PPL', 'P'),
(164906, 'Mount Tabor', 40.9874992370605, 0.71536681384537, -79.2177810668945, -1.38261110574134, 218, 45, 'PPL', 'P'),
(172288, 'Mount Tabor', 43.3505592346191, 0.756609991224937, -72.9830627441406, -1.27379474307486, 218, 55, 'PPL', 'P'),
(175432, 'Mount Tabor', 43.7005615234375, 0.762718683554333, -90.4541702270508, -1.57872309262146, 218, 57, 'PPL', 'P'),
(156641, 'Mount Tabor (historical)', 40.392219543457, 0.704977223221726, -83.9094390869141, -1.46449598556827, 218, 41, 'PPL', 'P'),
(104471, 'Mount Tabor Village', 37.2638893127441, 0.650377560606112, -80.3966674804688, -1.40318655516523, 218, 53, 'PPL', 'P'),
(110564, 'Mount Tell', 38.6241683959961, 0.674118909354869, -81.616943359375, -1.42448438703482, 218, 58, 'PPL', 'P'),
(89235, 'Mount Tema', 35.5263900756836, 0.620052478168516, -86.9097213745117, -1.51686078997612, 218, 50, 'PPL', 'P'),
(67023, 'Mount Tirzah', 36.2799987792969, 0.633205431318254, -78.9072189331055, -1.3771907739747, 218, 33, 'PPL', 'P'),
(125491, 'Mount Tom', 42.2861099243164, 0.738031846039572, -72.6166687011719, -1.26739996066536, 218, 23, 'PPL', 'P'),
(164907, 'Mount Top', 40.0586090087891, 0.699154620972431, -76.9894409179688, -1.3437192332882, 218, 45, 'PPL', 'P'),
(104472, 'Mount Torry Furnace', 37.9452781677246, 0.662270039611916, -78.9641723632813, -1.37818479885157, 218, 53, 'PPL', 'P'),
(150915, 'Mount Tremper', 42.0447196960449, 0.733818791774093, -74.2758331298828, -1.29635784277834, 218, 40, 'PPL', 'P'),
(110565, 'Mount Trimble', 39.6399993896484, 0.691848504837908, -78.1100006103516, -1.36327668938542, 218, 58, 'PPL', 'P'),
(178678, 'Mount Trumbull', 36.4119415283203, 0.635508266712846, -113.324722290039, -1.97788952786939, 218, 5, 'PPL', 'P'),
(89236, 'Mount Tucker Addition', 36.5447196960449, 0.637825682914405, -82.2961120605469, -1.43633811704676, 218, 50, 'PPL', 'P'),
(67025, 'Mount Ulla', 35.6583290100098, 0.622355246984081, -80.726936340332, -1.40895083418666, 218, 33, 'PPL', 'P'),
(4410, 'Mount Union', 31.3863906860352, 0.547795857788595, -86.7699966430664, -1.51442213336594, 218, 2, 'PPL', 'P'),
(42202, 'Mount Union', 32.9333305358887, 0.574795051498846, -92.5550003051758, -1.61538949450967, 218, 22, 'PPL', 'P'),
(89238, 'Mount Union', 36.5363883972168, 0.637680274318887, -85.1063919067383, -1.48538675326524, 218, 50, 'PPL', 'P'),
(96378, 'Mount Union', 30.6988906860352, 0.535796719181134, -94.022216796875, -1.64099725312939, 218, 51, 'PPL', 'P'),
(104473, 'Mount Union', 37.4516716003418, 0.653654979801618, -79.9702835083008, -1.39574475097317, 218, 53, 'PPL', 'P'),
(116960, 'Mount Union', 41.0577812194824, 0.716593465843461, -91.3902816772461, -1.59506131959299, 218, 16, 'PPL', 'P'),
(156642, 'Mount Union', 40.9013900756836, 0.713863925463211, -81.1061096191406, -1.41556865633745, 218, 41, 'PPL', 'P'),
(164908, 'Mount Union', 40.3844413757324, 0.704841468585159, -77.8824996948242, -1.35930604935816, 218, 45, 'PPL', 'P'),
(156643, 'Mount Union (historical)', 40.4563903808594, 0.706097215618159, -81.9013900756836, -1.42944891878089, 218, 41, 'PPL', 'P'),
(150916, 'Mount Upton', 42.4263916015625, 0.740480223187736, -75.3836135864258, -1.31569225913426, 218, 40, 'PPL', 'P'),
(67027, 'Mount Valley', 35.285831451416, 0.615853938130979, -82.2941665649414, -1.43630416174286, 218, 33, 'PPL', 'P'),
(89239, 'Mount Verd', 35.478328704834, 0.619213649004169, -84.60888671875, -1.47670364968909, 218, 50, 'PPL', 'P'),
(4413, 'Mount Vernon', 31.0849990844727, 0.542535582003471, -88.0133285522461, -1.53612236887623, 218, 2, 'PPL', 'P'),
(10664, 'Mount Vernon', 35.5513916015625, 0.620488837113126, -93.4300003051758, -1.63066112546462, 218, 4, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(23234, 'Mount Vernon', 34.7841682434082, 0.607098263415126, -85.0519409179688, -1.48443640423024, 218, 13, 'PPL', 'P'),
(27976, 'Mount Vernon', 38.3172187805176, 0.668761627927038, -88.9030609130859, -1.55165112803443, 218, 18, 'PPL', 'P'),
(33362, 'Mount Vernon', 37.7174987792969, 0.658294539315673, -97.8452835083008, -1.70772235476716, 218, 20, 'PPL', 'P'),
(37308, 'Mount Vernon', 37.3527793884277, 0.651928985099138, -84.3405609130859, -1.47202048091218, 218, 21, 'PPL', 'P'),
(56412, 'Mount Vernon', 37.1036109924316, 0.647580176197093, -93.8183288574219, -1.63743873728082, 218, 29, 'PPL', 'P'),
(60980, 'Mount Vernon', 32.2338905334473, 0.562587520536086, -89.0722198486328, -1.55460350841889, 218, 30, 'PPL', 'P'),
(67029, 'Mount Vernon', 35.4105606079102, 0.618030872585037, -81.9086074829102, -1.42957488630045, 218, 33, 'PPL', 'P'),
(89246, 'Mount Vernon', 36.040828704834, 0.629031126046637, -86.1374969482422, -1.50338293117339, 218, 50, 'PPL', 'P'),
(96380, 'Mount Vernon', 31.4082508087158, 0.548177388904263, -95.0871810913086, -1.65958438648343, 218, 51, 'PPL', 'P'),
(104474, 'Mount Vernon', 38.7077789306641, 0.675578188474178, -77.0863876342773, -1.34541127268678, 218, 53, 'PPL', 'P'),
(110566, 'Mount Vernon', 39.5255584716797, 0.689851134020348, -79.8300018310547, -1.39329637382501, 218, 58, 'PPL', 'P'),
(112392, 'Mount Vernon', 39.2975006103516, 0.685870773455116, -76.6161117553711, -1.33720341020716, 218, 25, 'PPL', 'P'),
(113395, 'Mount Vernon', 42.9469413757324, 0.749565530667514, -89.6558303833008, -1.56478943379817, 218, 57, 'PPL', 'P'),
(116962, 'Mount Vernon', 41.9219398498535, 0.731675879202961, -91.4166717529297, -1.59552191330352, 218, 16, 'PPL', 'P'),
(123259, 'Mount Vernon', 40.6694412231445, 0.709815654290182, -85.8241729736328, -1.49791439619103, 218, 19, 'PPL', 'P'),
(128205, 'Mount Vernon', 44.5011100769043, 0.776690891634407, -69.9880599975586, -1.22152208404073, 218, 26, 'PPL', 'P'),
(132196, 'Mount Vernon', 42.7419395446777, 0.745987573742992, -83.0869369506836, -1.45014061518637, 218, 27, 'PPL', 'P'),
(145844, 'Mount Vernon', 40.9952812194824, 0.715502635060964, -75.0330581665039, -1.30957391284591, 218, 37, 'PPL', 'P'),
(150919, 'Mount Vernon', 40.9124984741211, 0.714057803590569, -73.8375015258789, -1.28870751307292, 218, 40, 'PPL', 'P'),
(156644, 'Mount Vernon', 40.3933296203613, 0.704996597718656, -82.4858322143555, -1.43964935838811, 218, 41, 'PPL', 'P'),
(164911, 'Mount Vernon', 40.5566711425781, 0.707847445086559, -79.753059387207, -1.39195347484533, 218, 45, 'PPL', 'P'),
(170923, 'Mount Vernon', 43.7105598449707, 0.762893187184761, -98.2600021362305, -1.71496056029388, 218, 49, 'PPL', 'P'),
(183487, 'Mount Vernon', 39.1736106872559, 0.683708486387053, -121.752220153809, -2.12497711329696, 218, 6, 'PPL', 'P'),
(201268, 'Mount Vernon', 44.417781829834, 0.775236539363115, -119.112503051758, -2.07890535854497, 218, 43, 'PPL', 'P'),
(208189, 'Mount Vernon', 48.4213905334473, 0.845112693202668, -122.332778930664, -2.13510977545444, 218, 56, 'PPL', 'P'),
(209888, 'Mount Vernon', 41.1066703796387, 0.717446742656722, -103.199172973633, -1.80116535372504, 218, 35, 'PPL', 'P'),
(10665, 'Mount Vernon (historical)', 35.0250015258789, 0.611301597142625, -90.7874984741211, -1.58454076802274, 218, 4, 'PPL', 'P'),
(183488, 'Mount Vernon (historical)', 39.5297203063965, 0.68992377173908, -120.815277099609, -2.10862437209749, 218, 6, 'PPL', 'P'),
(187092, 'Mount Vernon Club Place', 39.7227783203125, 0.693293269729276, -105.293327331543, -1.83771524231556, 218, 7, 'PPL', 'P'),
(205010, 'Mount Vernon Cove Condominium', 40.6694412231445, 0.709815654290182, -111.871109008789, -1.95251919006086, 218, 52, 'PPL', 'P'),
(49674, 'Mount Vernon Estates', 39.6972198486328, 0.692847190246688, -76.3013916015625, -1.33171050730081, 218, 25, 'PPL', 'P'),
(104475, 'Mount Vernon Forest', 37.2125015258789, 0.649480674530001, -80.023063659668, -1.39666593839423, 218, 53, 'PPL', 'P'),
(164912, 'Mount Vernon Gardens', 40.1183280944824, 0.700196915644061, -75.129997253418, -1.31126581908644, 218, 45, 'PPL', 'P'),
(104476, 'Mount Vernon Heights', 37.232780456543, 0.649834608638872, -80.0041732788086, -1.39633623905128, 218, 53, 'PPL', 'P'),
(23240, 'Mount Vernon Lake', 33.9536094665527, 0.592602278127661, -84.3236083984375, -1.47172460371508, 218, 13, 'PPL', 'P'),
(104478, 'Mount Vernon Manor', 38.7188911437988, 0.675772133180563, -77.1102828979492, -1.34582832371349, 218, 53, 'PPL', 'P'),
(110567, 'Mount Vernon Meadows', 38.4486083984375, 0.671054809362678, -81.9555587768555, -1.43039434096786, 218, 58, 'PPL', 'P'),
(125492, 'Mount Vernon Park', 42.6875, 0.745037424445079, -71.1666717529297, -1.24209273977467, 218, 23, 'PPL', 'P'),
(23236, 'Mount Vernon Springs', 33.9466705322266, 0.592481170877089, -84.3208312988281, -1.47167613418324, 218, 13, 'PPL', 'P'),
(67032, 'Mount Vernon Springs', 35.667781829834, 0.622520229813611, -79.4255599975586, -1.3862375321977, 218, 33, 'PPL', 'P'),
(13167, 'Mount Vernon Square', 38.9047203063965, 0.679015463914116, -77.023063659668, -1.3443060608344, 218, 9, 'PPL', 'P'),
(104479, 'Mount Vernon Woods', 38.7402801513672, 0.676145441786365, -77.1050033569336, -1.34573617833977, 218, 53, 'PPL', 'P'),
(37309, 'Mount Victor', 36.9791717529297, 0.645408301749106, -86.3949966430664, -1.50787714867096, 218, 21, 'PPL', 'P'),
(49675, 'Mount Victoria', 38.353328704834, 0.669391864999005, -76.896110534668, -1.34209031080745, 218, 25, 'PPL', 'P'),
(37310, 'Mount Victory', 37.0291709899902, 0.646280953059298, -84.3863906860352, -1.47282036134559, 218, 21, 'PPL', 'P'),
(156647, 'Mount Victory', 40.5344390869141, 0.707459422515734, -83.5205612182617, -1.45770878637215, 218, 41, 'PPL', 'P'),
(4415, 'Mount View', 34.2547187805176, 0.597857627064769, -86.7847213745117, -1.51467912841113, 218, 2, 'PPL', 'P'),
(76648, 'Mount View', 34.7969398498535, 0.607321169998365, -98.1763916015625, -1.71350128117457, 218, 42, 'PPL', 'P'),
(82505, 'Mount View', 35.0311088562012, 0.611408190165255, -82.3563919067383, -1.43739019883539, 218, 48, 'PPL', 'P'),
(89250, 'Mount View', 35.292781829834, 0.615975245118632, -85.8652801513672, -1.49863185178869, 218, 50, 'PPL', 'P'),
(164913, 'Mount View', 40.2799987792969, 0.703018601398027, -76.966667175293, -1.34332175649551, 218, 45, 'PPL', 'P'),
(169496, 'Mount View', 41.6355590820313, 0.726677591890073, -71.4111099243164, -1.24635899068292, 218, 47, 'PPL', 'P'),
(175433, 'Mount View', 44.9516716003418, 0.784554673701193, -89.7266693115234, -1.56602580633424, 218, 57, 'PPL', 'P'),
(208190, 'Mount View', 47.4947204589844, 0.82893924932359, -122.348609924316, -2.13538607841753, 218, 56, 'PPL', 'P'),
(67033, 'Mount View Estates', 36.413890838623, 0.635542288595771, -79.9411087036133, -1.39523555457275, 218, 33, 'PPL', 'P'),
(89251, 'Mount View Estates', 35.7780609130859, 0.624444962912438, -86.3916702270508, -1.50781909175919, 218, 50, 'PPL', 'P'),
(104480, 'Mount Vinco', 37.5922203063965, 0.65610801748169, -78.6016693115234, -1.37185792704987, 218, 53, 'PPL', 'P'),
(89252, 'Mount Vinson', 35.190559387207, 0.614191126925361, -88.3944396972656, -1.54277401317286, 218, 50, 'PPL', 'P'),
(150921, 'Mount Vision', 42.5783309936523, 0.743132065843182, -75.0583267211914, -1.31001493232243, 218, 40, 'PPL', 'P'),
(205012, 'Mount Vista', 40.6366691589355, 0.70924367386706, -111.944442749023, -1.95379910528075, 218, 52, 'PPL', 'P'),
(208191, 'Mount Vista', 45.7344398498535, 0.798216556935245, -122.63166809082, -2.14032637539768, 218, 56, 'PPL', 'P'),
(89253, 'Mount Vista (historical)', 36.3758316040039, 0.634878029640878, -88.1763916015625, -1.53896835597514, 218, 50, 'PPL', 'P'),
(49676, 'Mount Vista Estates', 39.4619407653809, 0.688740795582867, -76.4499969482422, -1.33430415988644, 218, 25, 'PPL', 'P'),
(139349, 'Mount Waller', 40.4705581665039, 0.706344490125373, -94.3752822875977, -1.64715940841767, 218, 29, 'PPL', 'P'),
(37311, 'Mount Washington', 38.0499992370605, 0.664097767068037, -85.5458297729492, -1.49305639088856, 218, 21, 'PPL', 'P'),
(49677, 'Mount Washington', 39.3641700744629, 0.687034375114399, -76.6730575561523, -1.33819730192598, 218, 25, 'PPL', 'P'),
(56414, 'Mount Washington', 39.0994415283203, 0.682413990360193, -94.4661102294922, -1.64874465505653, 218, 29, 'PPL', 'P'),
(73595, 'Mount Washington', 39.0875015258789, 0.682205598004894, -84.3863906860352, -1.47282036134559, 218, 41, 'PPL', 'P'),
(164915, 'Mount Washington', 40.7605590820313, 0.711405960935123, -80.3258285522461, -1.40195018262916, 218, 45, 'PPL', 'P'),
(183489, 'Mount Washington', 34.0991706848145, 0.595142800649542, -118.219436645508, -2.06331840931695, 218, 6, 'PPL', 'P'),
(110568, 'Mount Welcome', 38.600830078125, 0.673711578866141, -81.3899993896484, -1.42052346754554, 218, 58, 'PPL', 'P'),
(49678, 'Mount Wesley', 38.1713905334473, 0.666216444873249, -75.3436126708984, -1.3149941114545, 218, 25, 'PPL', 'P'),
(96381, 'Mount Wesley', 30.0744400024414, 0.524897998736094, -99.1591720581055, -1.7306540359655, 218, 51, 'PPL', 'P'),
(104481, 'Mount Williams', 39.1519393920898, 0.683330250933235, -78.3330612182617, -1.36716983142495, 218, 53, 'PPL', 'P'),
(4416, 'Mount Willing', 32.060001373291, 0.559552582157832, -86.7013931274414, -1.51322477613984, 218, 2, 'PPL', 'P'),
(82506, 'Mount Willing', 34.0041694641113, 0.593484716554858, -81.6680603027344, -1.42537654599999, 218, 48, 'PPL', 'P'),
(49679, 'Mount Wilson', 39.3830604553223, 0.687364074457351, -76.7569427490234, -1.33966137473525, 218, 25, 'PPL', 'P'),
(164916, 'Mount Wilson', 40.2561111450195, 0.702601683529375, -76.5100021362305, -1.33535144798512, 218, 45, 'PPL', 'P'),
(183490, 'Mount Wilson', 34.226390838623, 0.597363211208395, -118.065277099609, -2.06062781766764, 218, 6, 'PPL', 'P'),
(49680, 'Mount Winans', 39.2636108398438, 0.685279285377009, -76.6394424438477, -1.33761060753783, 218, 25, 'PPL', 'P'),
(164917, 'Mount Wolf', 40.063060760498, 0.699232318697234, -76.7041702270508, -1.33874032047224, 218, 45, 'PPL', 'P'),
(4419, 'Mount Zion', 32.8588905334473, 0.573495828361051, -85.959716796875, -1.50028008218734, 218, 2, 'PPL', 'P'),
(10671, 'Mount Zion', 35.5602798461914, 0.620643966246623, -93.4497222900391, -1.63100533903552, 218, 4, 'PPL', 'P'),
(23238, 'Mount Zion', 33.3611106872559, 0.582261223614883, -83.0077819824219, -1.44875910037089, 218, 13, 'PPL', 'P'),
(27978, 'Mount Zion', 39.7713890075684, 0.694141686273548, -88.8741683959961, -1.55114685848202, 218, 18, 'PPL', 'P'),
(37315, 'Mount Zion', 37.1841697692871, 0.6489861920946, -84.6763916015625, -1.47788183215534, 218, 21, 'PPL', 'P'),
(42205, 'Mount Zion', 31.7241706848145, 0.553691230914676, -92.8605575561523, -1.62072247459256, 218, 22, 'PPL', 'P'),
(49683, 'Mount Zion', 39.1847190856934, 0.683902364514411, -77.1011123657227, -1.34566826773197, 218, 25, 'PPL', 'P'),
(56416, 'Mount Zion', 38.2174987792969, 0.667021185575644, -93.6377792358398, -1.63428755192099, 218, 29, 'PPL', 'P'),
(60982, 'Mount Zion', 34.8408317565918, 0.608087228285926, -88.9649963378906, -1.55273210512089, 218, 30, 'PPL', 'P'),
(67037, 'Mount Zion', 36.1533317565918, 0.630994674718352, -81.4461135864258, -1.42150284503642, 218, 33, 'PPL', 'P'),
(73596, 'Mount Zion', 39.8747215270996, 0.69594517896375, -81.5250015258789, -1.42287969931999, 218, 41, 'PPL', 'P'),
(76649, 'Mount Zion', 33.9391708374023, 0.592350276509512, -95.0344390869141, -1.65866386485264, 218, 42, 'PPL', 'P'),
(82509, 'Mount Zion', 34.978328704834, 0.610487002744197, -82.0572204589844, -1.43216867204413, 218, 48, 'PPL', 'P'),
(89262, 'Mount Zion', 35.5711097717285, 0.620832984104991, -85.820556640625, -1.49785127927319, 218, 50, 'PPL', 'P'),
(96382, 'Mount Zion', 30.4938907623291, 0.532218795546127, -95.4319381713867, -1.66560153265035, 218, 51, 'PPL', 'P'),
(104484, 'Mount Zion', 37.6719398498535, 0.657499385993202, -76.6675033569336, -1.3381003628623, 218, 53, 'PPL', 'P'),
(110569, 'Mount Zion', 38.8622207641602, 0.678273706971501, -81.1230621337891, -1.41586453353456, 218, 58, 'PPL', 'P'),
(116965, 'Mount Zion', 40.7886085510254, 0.711895516522507, -91.9336090087891, -1.60454417044449, 218, 16, 'PPL', 'P'),
(123260, 'Mount Zion', 40.6502799987793, 0.709481227836295, -85.334716796875, -1.48937177436238, 218, 19, 'PPL', 'P'),
(164923, 'Mount Zion', 40.0022201538086, 0.698170449791592, -76.6833267211914, -1.33837653266734, 218, 45, 'PPL', 'P'),
(175434, 'Mount Zion', 43.2566719055176, 0.754971348206211, -90.7336120605469, -1.58360027268378, 218, 57, 'PPL', 'P'),
(4421, 'Mount Zion (historical)', 34.2077789306641, 0.597038372134433, -86.0875015258789, -1.50251034644223, 218, 2, 'PPL', 'P'),
(23239, 'Mount Zion (historical)', 31.9897193908691, 0.558325930159741, -84.7769393920898, -1.47963672215565, 218, 13, 'PPL', 'P'),
(42206, 'Mount Zion (historical)', 32.3816719055176, 0.565166792051828, -92.6125030517578, -1.61639310676647, 218, 22, 'PPL', 'P'),
(60983, 'Mount Zion (historical)', 33.4083290100098, 0.583085338814208, -88.3063888549805, -1.54123723606583, 218, 30, 'PPL', 'P'),
(73597, 'Mount Zion (historical)', 38.9463882446289, 0.679742706628789, -83.5911102294922, -1.45894009890215, 218, 41, 'PPL', 'P'),
(56417, 'Mount Zion Community', 39.7433280944824, 0.693651930949082, -91.4527816772461, -1.59615215037549, 218, 29, 'PPL', 'P'),
(30592, 'Mount Zion Corner', 39.521110534668, 0.689773502874573, -86.5641708374023, -1.51082979537153, 218, 19, 'PPL', 'P'),
(49684, 'Mount Zion Estates', 39.3866691589355, 0.687427058217131, -77.4955596923828, -1.35255267230788, 218, 25, 'PPL', 'P'),
(49685, 'Mount Zion Knolls', 39.3894386291504, 0.687475394590916, -77.4958267211914, -1.35255733283979, 218, 25, 'PPL', 'P'),
(73598, 'Mount Zion Subdivision', 38.8458290100098, 0.6779876168914, -82.2458267211914, -1.43546047230952, 218, 41, 'PPL', 'P'),
(49686, 'Mount Zoar', 39.6813888549805, 0.692570887283592, -76.1811065673828, -1.32961113741351, 218, 25, 'PPL', 'P'),
(49687, 'Mountain', 39.4652786254883, 0.688799052231713, -76.3691711425781, -1.33289348345703, 218, 25, 'PPL', 'P'),
(110570, 'Mountain', 39.3619384765625, 0.686995426383456, -80.9105606079102, -1.41215568224246, 218, 58, 'PPL', 'P'),
(140545, 'Mountain', 48.6877784729004, 0.849762039833729, -97.8647232055664, -1.70806164149003, 218, 34, 'PPL', 'P'),
(175435, 'Mountain', 45.1847190856934, 0.788622119634071, -88.4736099243164, -1.54415579430445, 218, 57, 'PPL', 'P'),
(60984, 'Mountain (historical)', 30.850830078125, 0.538448561836581, -88.6933288574219, -1.54799061311611, 218, 30, 'PPL', 'P'),
(89263, 'Mountain (historical)', 35.2125015258789, 0.614574089490114, -85.5388870239258, -1.49293521705896, 218, 50, 'PPL', 'P'),
(4422, 'Mountain Acres', 34.2625007629395, 0.597993448280363, -85.5902786254883, -1.4938321697141, 218, 2, 'PPL', 'P'),
(197103, 'Mountain Acres Mobile Home Park', 47.0724983215332, 0.821570082850259, -109.430557250977, -1.9099235263217, 218, 31, 'PPL', 'P'),
(201269, 'Mountain Air Park', 45.3591690063477, 0.791666845129331, -121.989440917969, -2.12911739668565, 218, 43, 'PPL', 'P'),
(37316, 'Mountain Ash', 36.6575012207031, 0.63979409185511, -84.1288909912109, -1.46832614384803, 218, 21, 'PPL', 'P'),
(144174, 'Mountain Base', 42.9863891601563, 0.750254024388327, -71.5791702270508, -1.24929219630753, 218, 36, 'PPL', 'P'),
(4426, 'Mountain Brook', 33.5008316040039, 0.584699813646041, -86.7522201538086, -1.51411187509894, 218, 2, 'PPL', 'P'),
(82511, 'Mountain Brook', 34.8605613708496, 0.608431575014874, -82.3027801513672, -1.43645449718639, 218, 48, 'PPL', 'P'),
(208192, 'Mountain Brook', 45.790828704834, 0.799200728116084, -121.410278320313, -2.11900910245214, 218, 56, 'PPL', 'P'),
(104485, 'Mountain Brook Estates', 37.3624992370605, 0.652098628460576, -80.0913925170898, -1.39785850193037, 218, 53, 'PPL', 'P'),
(4425, 'Mountain Brook Village', 33.4836082458496, 0.584399209337999, -86.7738876342773, -1.51449004397373, 218, 2, 'PPL', 'P'),
(23243, 'Mountain Brooke', 33.8494415283203, 0.590784204630491, -84.1444396972656, -1.46859751996311, 218, 13, 'PPL', 'P'),
(183491, 'Mountain Center', 33.7041702270508, 0.588248742114681, -116.724998474121, -2.03723554275877, 218, 6, 'PPL', 'P'),
(23241, 'Mountain City', 34.9180603027344, 0.609435120692643, -83.3855590820313, -1.45535255459771, 218, 13, 'PPL', 'P'),
(89264, 'Mountain City', 36.4744415283203, 0.636599097495342, -81.8050003051758, -1.42776659992028, 218, 50, 'PPL', 'P'),
(96383, 'Mountain City', 30.0369396209717, 0.524243493608693, -97.8866729736328, -1.70844473721284, 218, 51, 'PPL', 'P'),
(200086, 'Mountain City', 41.8386116027832, 0.730221526931669, -115.96443939209, -2.02396128262138, 218, 39, 'PPL', 'P'),
(23242, 'Mountain Cove', 33.7886085510254, 0.589722468882903, -84.0605621337891, -1.46713358031189, 218, 13, 'PPL', 'P'),
(110571, 'Mountain Cove', 38.1286087036133, 0.665469761082618, -81.0497207641602, -1.41458448515661, 218, 58, 'PPL', 'P'),
(4427, 'Mountain Creek', 32.7105598449707, 0.570906969465385, -86.478889465332, -1.50934135463828, 218, 2, 'PPL', 'P'),
(23244, 'Mountain Creek', 34.024169921875, 0.593833790394741, -84.415283203125, -1.473324630898, 218, 13, 'PPL', 'P'),
(82512, 'Mountain Creek', 34.4458312988281, 0.601193169751066, -82.7083282470703, -1.44353264673161, 218, 48, 'PPL', 'P'),
(60985, 'Mountain Creek (historical)', 32.0930595397949, 0.560129556007998, -90.1311111450195, -1.57308464796155, 218, 30, 'PPL', 'P'),
(10673, 'Mountain Crest', 35.7583312988281, 0.624100616183491, -93.8874969482422, -1.63864594820295, 218, 4, 'PPL', 'P'),
(56418, 'Mountain Dale', 37.1888885498047, 0.649068550351311, -92.7538909912109, -1.61886079183254, 218, 29, 'PPL', 'P'),
(110572, 'Mountain Dale', 39.6172218322754, 0.691450961466186, -79.5144424438477, -1.38778882353267, 218, 58, 'PPL', 'P'),
(150925, 'Mountain Dale', 41.6894416809082, 0.727618020650007, -74.5316696166992, -1.30082303182002, 218, 40, 'PPL', 'P'),
(164924, 'Mountain Dale', 40.336669921875, 0.704007699426883, -76.879997253418, -1.34180908099634, 218, 45, 'PPL', 'P'),
(205017, 'Mountain Dell Park', 40.8036117553711, 0.712157371836689, -111.679168701172, -1.94916919972565, 218, 52, 'PPL', 'P'),
(49688, 'Mountain Estates', 39.1347198486328, 0.683029713204219, -76.5583267211914, -1.33619487110234, 218, 25, 'PPL', 'P'),
(205018, 'Mountain Estates', 40.6111106872559, 0.708797594384472, -111.798057556152, -1.95124420168898, 218, 52, 'PPL', 'P'),
(104486, 'Mountain Falls', 39.1172218322754, 0.682724315206215, -78.3958282470703, -1.36826532273935, 218, 53, 'PPL', 'P'),
(104487, 'Mountain Falls Park', 39.1577796936035, 0.683432183423958, -78.39111328125, -1.36818303106167, 218, 53, 'PPL', 'P'),
(10674, 'Mountain Fork', 34.6416702270508, 0.604611203852128, -94.4286117553711, -1.64809018321865, 218, 4, 'PPL', 'P'),
(193808, 'Mountain Gate', 40.7163887023926, 0.710635042378572, -122.330558776855, -2.13507102646058, 218, 6, 'PPL', 'P'),
(178679, 'Mountain Gate Mobile Home Park', 33.360279083252, 0.582246709386942, -112.088890075684, -1.95632018672667, 218, 5, 'PPL', 'P'),
(27981, 'Mountain Glen', 37.5275001525879, 0.654978437705333, -89.2897186279297, -1.55839957823669, 218, 18, 'PPL', 'P'),
(164927, 'Mountain Green', 40.1166687011719, 0.700167953767206, -77.8122177124023, -1.35807939736007, 218, 45, 'PPL', 'P'),
(205020, 'Mountain Green', 41.1430587768555, 0.718081839997679, -111.790832519531, -1.95111810101137, 218, 52, 'PPL', 'P'),
(4430, 'Mountain Grove', 34.0886116027832, 0.594958509902108, -86.6172180175781, -1.51175564332449, 218, 2, 'PPL', 'P'),
(10676, 'Mountain Grove', 35.0555610656738, 0.61183496172994, -93.8102798461914, -1.63729825553332, 218, 4, 'PPL', 'P'),
(56419, 'Mountain Grove', 37.1305618286133, 0.648050557024628, -92.2633285522461, -1.61029886208599, 218, 29, 'PPL', 'P'),
(67040, 'Mountain Grove', 35.2197189331055, 0.614700057009675, -83.258056640625, -1.45312721719084, 218, 33, 'PPL', 'P'),
(104488, 'Mountain Grove', 38.0986099243164, 0.664946183612309, -79.8869400024414, -1.39429013238577, 218, 53, 'PPL', 'P'),
(164925, 'Mountain Grove', 40.9813919067383, 0.71526022082274, -76.2111129760742, -1.33013484804187, 218, 45, 'PPL', 'P'),
(96384, 'Mountain Heaven', 31.9591693878174, 0.557792732019994, -95.331672668457, -1.66385156949806, 218, 51, 'PPL', 'P'),
(104489, 'Mountain Heights', 37.3202781677246, 0.651361731786951, -80.0577774047852, -1.39727180754222, 218, 53, 'PPL', 'P'),
(104490, 'Mountain Heights East', 37.3236083984375, 0.651419855277742, -80.0597229003906, -1.39730576284612, 218, 53, 'PPL', 'P'),
(23245, 'Mountain Hill', 32.7230606079102, 0.571125148937689, -85.0227813720703, -1.48392747414593, 218, 13, 'PPL', 'P'),
(49689, 'Mountain Hill', 39.5591697692871, 0.690437761829466, -76.0183334350586, -1.32677021032066, 218, 25, 'PPL', 'P'),
(104491, 'Mountain Hill', 36.5566711425781, 0.638034275006786, -79.3188934326172, -1.38437584943768, 218, 53, 'PPL', 'P'),
(4432, 'Mountain Home', 34.5794410705566, 0.603525100180566, -87.26611328125, -1.52308100217616, 218, 2, 'PPL', 'P'),
(10700, 'Mountain Home', 36.3352813720703, 0.63417029458119, -92.3850021362305, -1.61242246673922, 218, 4, 'PPL', 'P'),
(67041, 'Mountain Home', 35.3694381713867, 0.617313150671261, -82.4930572509766, -1.43977545906572, 218, 33, 'PPL', 'P'),
(89265, 'Mountain Home', 36.3105583190918, 0.63373879590557, -82.3733291625977, -1.43768580971639, 218, 50, 'PPL', 'P'),
(96385, 'Mountain Home', 30.1744403839111, 0.526643334645991, -99.379997253418, -1.73450816269507, 218, 51, 'PPL', 'P'),
(183493, 'Mountain Home', 36.2347183227539, 0.632415138264773, -118.694999694824, -2.07161855032835, 218, 6, 'PPL', 'P'),
(195355, 'Mountain Home', 43.1330604553223, 0.752813921407138, -115.690277099609, -2.01917624793278, 218, 17, 'PPL', 'P'),
(205021, 'Mountain Home', 40.399169921875, 0.705098530209379, -110.38777923584, -1.92663020163004, 218, 52, 'PPL', 'P'),
(209626, 'Mountain Home', 41.0080604553223, 0.715725674802259, -106.171943664551, -1.85304999018835, 218, 59, 'PPL', 'P'),
(67042, 'Mountain Home (historical)', 35.5750007629395, 0.620900894712788, -81.845832824707, -1.42847926182799, 218, 33, 'PPL', 'P'),
(195354, 'Mountain Home (historical)', 47.0191688537598, 0.820639308049276, -116.927223205566, -2.04076503015145, 218, 17, 'PPL', 'P'),
(208193, 'Mountain Home Park', 46.2372207641602, 0.806991739306083, -117.892501831055, -2.05761232036535, 218, 56, 'PPL', 'P'),
(172290, 'Mountain Home Trailer Park', 42.8699989318848, 0.748222631687841, -72.6127777099609, -1.26733205005757, 218, 55, 'PPL', 'P'),
(183494, 'Mountain Home Village', 34.1005592346191, 0.595167035415462, -116.998329162598, -2.04200606321943, 218, 6, 'PPL', 'P'),
(150922, 'Mountain House', 41.3583297729492, 0.721839027663563, -74.1750030517578, -1.29459802593002, 218, 40, 'PPL', 'P'),
(183495, 'Mountain House', 37.7833290100098, 0.65944349358896, -121.54167175293, -2.12130235046681, 218, 6, 'PPL', 'P'),
(190519, 'Mountain House (historical)', 38.747501373291, 0.676271475884953, -119.566108703613, -2.0868222706755, 218, 39, 'PPL', 'P'),
(137006, 'Mountain Iron', 47.5325012207031, 0.829598648009493, -92.6233291625977, -1.61658205804581, 218, 28, 'PPL', 'P'),
(67043, 'Mountain Island', 35.3333282470703, 0.616682913599293, -80.9997177124023, -1.41371176726739, 218, 33, 'PPL', 'P'),
(104493, 'Mountain Lake', 37.355281829834, 0.651972660941015, -80.5380630493164, -1.40565437338936, 218, 53, 'PPL', 'P'),
(137008, 'Mountain Lake', 43.9388885498047, 0.766878274860928, -94.929443359375, -1.65683134370656, 218, 28, 'PPL', 'P'),
(164926, 'Mountain Lake', 41.7622184753418, 0.728888215331921, -76.583610534668, -1.33663615689497, 218, 45, 'PPL', 'P'),
(67044, 'Mountain Lake Camp', 35.2949981689453, 0.616013927533466, -82.4736099243164, -1.43943603918479, 218, 33, 'PPL', 'P'),
(82514, 'Mountain Lake Colony', 35.0724983215332, 0.612130572610939, -82.6230621337891, -1.44204447231447, 218, 48, 'PPL', 'P'),
(49690, 'Mountain Lake Park', 39.3983306884766, 0.68763059030344, -79.3819427490234, -1.3854762676001, 218, 25, 'PPL', 'P'),
(17211, 'Mountain Lake Station', 27.9494400024414, 0.487809752131215, -81.5952835083008, -1.42410635131808, 218, 12, 'PPL', 'P'),
(49691, 'Mountain Lake View', 39.5911102294922, 0.690995228024647, -76.961669921875, -1.34323453796981, 218, 25, 'PPL', 'P'),
(82515, 'Mountain Lakes', 34.6572189331055, 0.604882579967207, -81.2605590820313, -1.41826430799283, 218, 48, 'PPL', 'P'),
(144175, 'Mountain Lakes', 44.1213912963867, 0.770063548682718, -71.9558334350586, -1.25586620945839, 218, 36, 'PPL', 'P'),
(145845, 'Mountain Lakes', 40.894718170166, 0.713747478744548, -74.4333267211914, -1.29910662449747, 218, 37, 'PPL', 'P'),
(104495, 'Mountain Laurel', 37.6630592346191, 0.657344390017759, -77.4847183227539, -1.35236345471243, 218, 53, 'PPL', 'P'),
(49692, 'Mountain Laurel Estates', 39.480281829834, 0.689060907545895, -77.4741668701172, -1.35217929712306, 218, 25, 'PPL', 'P'),
(49693, 'Mountain Laurel Manor', 38.5072212219238, 0.672077796116405, -76.5583267211914, -1.33619487110234, 218, 25, 'PPL', 'P'),
(150924, 'Mountain Lodge', 41.3883285522461, 0.722362605133872, -74.142219543457, -1.29402584576981, 218, 40, 'PPL', 'P'),
(178680, 'Mountain Meadow', 34.3227806091309, 0.599045530068998, -111.005561828613, -1.93741254193544, 218, 5, 'PPL', 'P'),
(89266, 'Mountain Meadows', 36.1847190856934, 0.631542486954581, -85.39111328125, -1.49035607870127, 218, 50, 'PPL', 'P'),
(178681, 'Mountain Meadows', 34.329719543457, 0.59916663731957, -111.010559082031, -1.93749976046114, 218, 5, 'PPL', 'P'),
(194335, 'Mountain Meadows', 40.0238914489746, 0.698548685245411, -105.379997253418, -1.83922791781472, 218, 7, 'PPL', 'P'),
(205022, 'Mountain Meadows Condominiums', 41.1775016784668, 0.718682982034737, -111.933326721191, -1.95360509399534, 218, 52, 'PPL', 'P'),
(191916, 'Mountain Meadows Estates Colonia', 31.8110008239746, 0.555206702732986, -106.129997253418, -1.85231788720468, 218, 51, 'PPL', 'P'),
(205024, 'Mountain Men Estates', 40.6588897705078, 0.709631496700803, -112.019439697266, -1.95510804895653, 218, 52, 'PPL', 'P'),
(183496, 'Mountain Mesa', 35.6394386291504, 0.622025547641129, -118.404716491699, -2.06655215267058, 218, 6, 'PPL', 'P'),
(4434, 'Mountain Mills (historical)', 34.7041702270508, 0.605702034634624, -87.8930587768555, -1.53402326530503, 218, 2, 'PPL', 'P'),
(110573, 'Mountain Mission', 39.2458305358887, 0.684968960530988, -77.7938919067383, -1.35775955171315, 218, 58, 'PPL', 'P'),
(67046, 'Mountain Page', 35.2097206115723, 0.614525553379248, -82.3683319091797, -1.43759859119069, 218, 33, 'PPL', 'P'),
(4436, 'Mountain Park', 33.564998626709, 0.585819739463447, -86.7713928222656, -1.51444650128991, 218, 2, 'PPL', 'P'),
(23260, 'Mountain Park', 34.0808296203613, 0.594822688686514, -84.4113922119141, -1.4732567202902, 218, 13, 'PPL', 'P'),
(67047, 'Mountain Park', 36.3741683959961, 0.634849001184996, -80.8550033569336, -1.41118602528956, 218, 33, 'PPL', 'P'),
(76651, 'Mountain Park', 34.6972198486328, 0.605580727646971, -98.9491729736328, -1.72698886051528, 218, 42, 'PPL', 'P'),
(125494, 'Mountain Park', 42.2436103820801, 0.737290089096957, -72.6319427490234, -1.26766654309048, 218, 23, 'PPL', 'P'),
(189076, 'Mountain Park', 32.9505615234375, 0.575095788964943, -105.824172973633, -1.84698024658989, 218, 38, 'PPL', 'P'),
(183497, 'Mountain Pass', 35.4702796936035, 0.619073167256667, -115.544166564941, -2.01662613803097, 218, 6, 'PPL', 'P'),
(96386, 'Mountain Peak', 32.4124984741211, 0.565704817171051, -97.017219543457, -1.69326991216352, 218, 51, 'PPL', 'P'),
(10679, 'Mountain Pine', 34.5719413757324, 0.603394205812989, -93.1730575561523, -1.62617662850504, 218, 4, 'PPL', 'P'),
(193276, 'Mountain Point', 55.2944412231445, 0.965070057394353, -131.532501220703, -2.29567521968473, 218, 1, 'PPL', 'P'),
(183498, 'Mountain Ranch', 38.228328704834, 0.667210203434012, -120.53971862793, -2.10381496948491, 218, 6, 'PPL', 'P'),
(183499, 'Mountain Ranch Subdivision', 38.1969413757324, 0.666662391197783, -120.644172668457, -2.10563803640913, 218, 6, 'PPL', 'P'),
(183500, 'Mountain Retreat', 38.2533302307129, 0.667646562378622, -120.325828552246, -2.1000818834269, 218, 6, 'PPL', 'P'),
(23247, 'Mountain Ridge', 34.0752792358398, 0.594725816201863, -84.4824981689453, -1.47449775335818, 218, 13, 'PPL', 'P'),
(56421, 'Mountain Ridge', 38.5499992370605, 0.672824413328009, -90.5408325195313, -1.58023563496257, 218, 29, 'PPL', 'P'),
(23248, 'Mountain Ridge Estates', 34.0977783203125, 0.595118499304595, -84.7574996948242, -1.47929743543277, 218, 13, 'PPL', 'P'),
(104496, 'Mountain Road', 36.7594413757324, 0.641573283200365, -78.9872207641602, -1.37858706933423, 218, 53, 'PPL', 'P'),
(23249, 'Mountain Scene', 34.8572196960449, 0.608373251787001, -83.7222213745117, -1.4612284200688, 218, 13, 'PPL', 'P'),
(197104, 'Mountain Shadows Estates', 46.4966697692871, 0.811519978686572, -114.090278625488, -1.99125100653248, 218, 31, 'PPL', 'P'),
(178682, 'Mountain Shadows Mobile Homes Park', 33.6902809143066, 0.588006327876456, -112.120559692383, -1.95687292581092, 218, 5, 'PPL', 'P'),
(205031, 'Mountain Spa', 40.5250015258789, 0.707294706002313, -111.466667175293, -1.94546034843355, 218, 52, 'PPL', 'P'),
(10680, 'Mountain Springs', 35.0261116027832, 0.611320971639555, -92.0702819824219, -1.60692956383287, 218, 4, 'PPL', 'P'),
(23250, 'Mountain Springs', 32.899169921875, 0.574198836309804, -83.4558334350586, -1.45657907343774, 218, 13, 'PPL', 'P'),
(96387, 'Mountain Springs', 33.480281829834, 0.584341152426235, -97.0436096191406, -1.69373050587404, 218, 51, 'PPL', 'P'),
(104498, 'Mountain Springs', 36.6183280944824, 0.639110391824259, -82.648063659668, -1.44248083125908, 218, 53, 'PPL', 'P'),
(190521, 'Mountain Springs', 36.0208282470703, 0.628682052206754, -115.508056640625, -2.01599590095901, 218, 39, 'PPL', 'P'),
(4438, 'Mountain Star', 34.541389465332, 0.602860974383728, -87.6536102294922, -1.52984409976442, 218, 2, 'PPL', 'P'),
(205033, 'Mountain Terrace Subdivision Number 1-4', 41.2422218322754, 0.719812561811094, -111.933609008789, -1.95361002084336, 218, 52, 'PPL', 'P'),
(10681, 'Mountain Top', 35.6241683959961, 0.621759031795039, -93.7297210693359, -1.63589223963581, 218, 4, 'PPL', 'P'),
(37317, 'Mountain Top', 38.2900009155273, 0.668286586567595, -83.1255569458008, -1.45081466125827, 218, 21, 'PPL', 'P'),
(96388, 'Mountain Top', 32.2272682189941, 0.562471939344777, -98.949951171875, -1.72700244263684, 218, 51, 'PPL', 'P'),
(164929, 'Mountain Top', 41.1694412231445, 0.718542300550154, -75.8777770996094, -1.32431703948254, 218, 45, 'PPL', 'P'),
(208194, 'Mountain Top', 46.2419395446777, 0.807074097562794, -117.763328552246, -2.05535782134454, 218, 56, 'PPL', 'P'),
(164930, 'Mountain Top Estates', 41.0991706848145, 0.717315848289145, -75.0580596923828, -1.31001027179052, 218, 45, 'PPL', 'P'),
(183501, 'Mountain Top Junction', 34.3902816772461, 0.600223645956222, -117.57527923584, -2.05207574161713, 218, 6, 'PPL', 'P'),
(205034, 'Mountain Top Park', 40.8027801513672, 0.712142857608748, -111.705001831055, -1.9496200728982, 218, 52, 'PPL', 'P'),
(89268, 'Mountain Trace', 35.7591705322266, 0.624115263569487, -83.9111099243164, -1.46452514718221, 218, 50, 'PPL', 'P'),
(10682, 'Mountain Valley', 34.6291694641113, 0.604393024379823, -93.0566711425781, -1.62414530238358, 218, 4, 'PPL', 'P'),
(37318, 'Mountain Valley', 37.6613883972168, 0.657315228403823, -83.2688903808594, -1.45331630162823, 218, 21, 'PPL', 'P'),
(67048, 'Mountain Valley', 35.2163887023926, 0.614641933518884, -82.4863891601563, -1.43965907892609, 218, 33, 'PPL', 'P'),
(4439, 'Mountain Valley (historical)', 33.7416687011719, 0.588903213952568, -87.3930587768555, -1.52529661904506, 218, 2, 'PPL', 'P'),
(205036, 'Mountain Valley Meadows', 41.2533302307129, 0.720006439938452, -111.735557556152, -1.95015337090649, 218, 52, 'PPL', 'P'),
(197105, 'Mountain Valley Trailer Court', 46.2347183227539, 0.806948063464206, -112.125282287598, -1.95695535064666, 218, 31, 'PPL', 'P'),
(4441, 'Mountain View', 34.3050003051758, 0.598735205222977, -86.2980575561523, -1.50618524243043, 218, 2, 'PPL', 'P'),
(10684, 'Mountain View', 35.8683280944824, 0.626020422434302, -92.1175003051758, -1.6077536790322, 218, 4, 'PPL', 'P'),
(23255, 'Mountain View', 34.9122200012207, 0.60933318820192, -85.3188934326172, -1.48909560455734, 218, 13, 'PPL', 'P'),
(49695, 'Mountain View', 39.4438896179199, 0.688425743625911, -77.4677810668945, -1.35206784383144, 218, 25, 'PPL', 'P'),
(56422, 'Mountain View', 36.9952812194824, 0.645689464981191, -91.70361328125, -1.60052998773341, 218, 29, 'PPL', 'P'),
(67053, 'Mountain View', 36.3088912963867, 0.633709700870661, -80.3041687011719, -1.40157214691243, 218, 33, 'PPL', 'P'),
(76653, 'Mountain View', 35.0974998474121, 0.612566931555549, -98.7461090087891, -1.7234447257366, 218, 42, 'PPL', 'P'),
(82517, 'Mountain View', 35.0872192382813, 0.612387501077105, -81.929443359375, -1.4299385409473, 218, 48, 'PPL', 'P'),
(89270, 'Mountain View', 36.3819389343262, 0.634984622663509, -84.5858306884766, -1.47630124604838, 218, 50, 'PPL', 'P'),
(104507, 'Mountain View', 37.2805595397949, 0.650668510955203, -80.0730590820313, -1.39753852312539, 218, 53, 'PPL', 'P'),
(110575, 'Mountain View', 39.4313888549805, 0.688207564153606, -79.7611083984375, -1.39209395659284, 218, 58, 'PPL', 'P'),
(113257, 'Mountain View', 41.7050018310547, 0.727889596502168, -81.3583297729492, -1.41997072846129, 218, 41, 'PPL', 'P'),
(145847, 'Mountain View', 40.917781829834, 0.714150015543313, -74.2663879394531, -1.29619299310686, 218, 37, 'PPL', 'P'),
(150927, 'Mountain View', 42.7041702270508, 0.745328374794171, -73.6527786254883, -1.28548349025727, 218, 40, 'PPL', 'P'),
(164931, 'Mountain View', 40.3305587768555, 0.703901039825225, -76.7774963378906, -1.34002010253408, 218, 45, 'PPL', 'P'),
(178683, 'Mountain View', 32.002498626709, 0.558548969901036, -110.681106567383, -1.93174972935155, 218, 5, 'PPL', 'P'),
(183504, 'Mountain View', 37.3861083984375, 0.652510686060238, -122.082778930664, -2.13074645232445, 218, 6, 'PPL', 'P'),
(189077, 'Mountain View', 33.3400001525879, 0.581892775278071, -104.52278137207, -1.82426667828482, 218, 38, 'PPL', 'P'),
(191917, 'Mountain View', 31.8663902282715, 0.556173430208685, -106.414436340332, -1.8572822857927, 218, 51, 'PPL', 'P'),
(194336, 'Mountain View', 40.5924987792969, 0.708472755310509, -105.128608703613, -1.83484035991882, 218, 7, 'PPL', 'P'),
(197106, 'Mountain View', 45.389720916748, 0.792200076558592, -109.898612976074, -1.91809263980746, 218, 31, 'PPL', 'P'),
(201270, 'Mountain View', 42.1122207641602, 0.734996907661317, -122.383056640625, -2.13598728703362, 218, 43, 'PPL', 'P'),
(208196, 'Mountain View', 48.848331451416, 0.85256421793271, -122.669998168945, -2.14099536146351, 218, 56, 'PPL', 'P'),
(209625, 'Mountain View', 41.2688903808594, 0.720278015790613, -110.339172363281, -1.92578185166479, 218, 59, 'PPL', 'P'),
(210732, 'Mountain View', 19.5558300018311, 0.341313621492241, -155.108062744141, -2.70714639127521, 218, 15, 'PPL', 'P'),
(212007, 'Mountain View', 61.226390838623, 1.06860210924686, -149.804168701172, -2.61457597704849, 218, 1, 'PPL', 'P'),
(190522, 'Mountain View (historical)', 38.9766693115234, 0.680271210947115, -118.938606262207, -2.07587028700866, 218, 39, 'PPL', 'P'),
(197107, 'Mountain View (historical)', 47.6444396972656, 0.831552342985176, -114.074996948242, -1.99098429094931, 218, 31, 'PPL', 'P'),
(201271, 'Mountain View (historical)', 42.4941711425781, 0.741663199343949, -122.792778015137, -2.14313827403464, 218, 43, 'PPL', 'P'),
(89271, 'Mountain View Acres', 35.1952781677246, 0.614273485182071, -86.0966720581055, -1.50267040242374, 218, 50, 'PPL', 'P'),
(104509, 'Mountain View Acres', 39.3055610656738, 0.6860114549397, -78.3472213745117, -1.36741697277411, 218, 53, 'PPL', 'P'),
(164932, 'Mountain View Acres', 40.3616714477539, 0.704444058371492, -76.8008270263672, -1.34042729986475, 218, 45, 'PPL', 'P'),
(183506, 'Mountain View Acres', 34.4966697692871, 0.602080468447253, -117.34806060791, -2.04811002843789, 218, 6, 'PPL', 'P'),
(197108, 'Mountain View Court', 46.8833312988281, 0.81826849546786, -113.893058776855, -1.98780887082355, 218, 31, 'PPL', 'P'),
(67055, 'Mountain View Development', 35.8658294677734, 0.625976813171452, -81.496940612793, -1.42238994399552, 218, 33, 'PPL', 'P'),
(49698, 'Mountain View Estates', 39.5569381713867, 0.690398813098523, -77.6802825927734, -1.35577669512353, 218, 25, 'PPL', 'P'),
(67056, 'Mountain View Estates', 35.7219390869141, 0.623465452263507, -80.2983322143555, -1.40147028100073, 218, 33, 'PPL', 'P'),
(89273, 'Mountain View Estates', 35.913890838623, 0.6268156423358, -84.9272232055664, -1.48225966951327, 218, 50, 'PPL', 'P'),
(96390, 'Mountain View Estates', 31.0049991607666, 0.541139319933456, -97.7624969482422, -1.70627745671773, 218, 51, 'PPL', 'P'),
(104510, 'Mountain View Estates', 38.8588905334473, 0.678215583480711, -77.6613922119141, -1.35544699578058, 218, 53, 'PPL', 'P'),
(164933, 'Mountain View Estates', 40.3033294677734, 0.7034257987287, -76.9483337402344, -1.34300177769053, 218, 45, 'PPL', 'P'),
(172291, 'Mountain View Estates', 43.6636085510254, 0.762073732517344, -72.9944381713867, -1.27399328173413, 218, 55, 'PPL', 'P'),
(178684, 'Mountain View Estates', 34.5374984741211, 0.602793063775931, -111.837501525879, -1.95193262883077, 218, 5, 'PPL', 'P'),
(205041, 'Mountain View Estates', 41.3113899230957, 0.721019772733227, -111.830833435059, -1.95181624869113, 218, 52, 'PPL', 'P'),
(205043, 'Mountain View Estates Numbers 23,24,25,26', 40.5155601501465, 0.707129922909864, -111.929168701172, -1.95353252285563, 218, 52, 'PPL', 'P'),
(89274, 'Mountain View Meadows', 36.2644386291504, 0.632933855466093, -83.2627792358398, -1.45320964202657, 218, 50, 'PPL', 'P'),
(178685, 'Mountain View Meadows', 33.5561103820801, 0.58566461032995, -112.1875, -1.95804125458114, 218, 5, 'PPL', 'P'),
(178686, 'Mountain View Mobile Home Park', 33.4775009155273, 0.584292616315368, -111.909721374512, -1.9531931029747, 218, 5, 'PPL', 'P'),
(197110, 'Mountain View Mobile Home Park', 48.8902816772461, 0.8532963874954, -115.056938171387, -2.00812239835424, 218, 31, 'PPL', 'P'),
(205044, 'Mountain View Orchard Heights', 40.6577796936035, 0.709612122203873, -111.863059997559, -1.95237870831336, 218, 52, 'PPL', 'P'),
(205045, 'Mountain View Park Condo', 40.6725006103516, 0.709869050670038, -111.923606872559, -1.9534354506339, 218, 52, 'PPL', 'P'),
(205046, 'Mountain View Subdivision Number 10', 40.5250015258789, 0.707294706002313, -111.952781677246, -1.95394464703432, 218, 52, 'PPL', 'P'),
(205047, 'Mountain View Subdivision Number 11', 40.5250015258789, 0.707294706002313, -111.952781677246, -1.95394464703432, 218, 52, 'PPL', 'P'),
(205048, 'Mountain View Subdivision Number 12', 40.5250015258789, 0.707294706002313, -111.952781677246, -1.95394464703432, 218, 52, 'PPL', 'P'),
(205049, 'Mountain View Subdivision Number 13', 40.5250015258789, 0.707294706002313, -111.952781677246, -1.95394464703432, 218, 52, 'PPL', 'P'),
(89275, 'Mountain View Terrace', 36.1258316040039, 0.630514706510892, -82.8652801513672, -1.44627197422886, 218, 50, 'PPL', 'P'),
(178687, 'Mountain View Trailer Court', 33.5736083984375, 0.585970008327955, -112.09139251709, -1.95636386256855, 218, 5, 'PPL', 'P'),
(197113, 'Mountain View Trailer Court', 46.2675018310547, 0.80752024362441, -114.155563354492, -1.99239044000487, 218, 31, 'PPL', 'P'),
(49699, 'Mountain Village', 39.3930587768555, 0.687538578087778, -77.4280624389648, -1.35137462299969, 218, 25, 'PPL', 'P'),
(187095, 'Mountain Village', 37.9313888549805, 0.662027625373691, -107.855827331543, -1.88243930439791, 218, 7, 'PPL', 'P'),
(212006, 'Mountain Village', 62.0855598449707, 1.08359743723872, -163.729446411133, -2.85761792234188, 218, 1, 'PPL', 'P'),
(49700, 'Mountain Vista', 39.4366683959961, 0.688299709527323, -77.1069412231445, -1.34577000048562, 218, 25, 'PPL', 'P'),
(178688, 'Mountain Vista', 33.6436080932617, 0.587191733478028, -112.017776489258, -1.95507902050064, 218, 5, 'PPL', 'P'),
(49701, 'Mountain Vistas', 39.6458282470703, 0.691950237591549, -78.0319366455078, -1.36191421617173, 218, 25, 'PPL', 'P'),
(49702, 'Mountain Wood', 39.1097183227539, 0.68259335425961, -76.4805603027344, -1.33483759105279, 218, 25, 'PPL', 'P'),
(23257, 'Mountain Woods', 33.8458290100098, 0.590721154291683, -84.1908264160156, -1.46940712093449, 218, 13, 'PPL', 'P'),
(190523, 'Mountain''s Edge', 36.0250015258789, 0.628754889662568, -115.241668701172, -2.01134655432795, 218, 39, 'PPL', 'P'),
(189078, 'Mountainair', 34.5202789306641, 0.602492526046915, -106.240562438965, -1.85424761373055, 218, 38, 'PPL', 'P'),
(178689, 'Mountainaire', 35.0852813720703, 0.612353678931261, -111.665283203125, -1.94892685206645, 218, 5, 'PPL', 'P'),
(4444, 'Mountainboro', 34.1469383239746, 0.595976503228791, -86.1305618286133, -1.50326189050185, 218, 2, 'PPL', 'P'),
(4445, 'Mountainbrook', 33.0980606079102, 0.577670133632668, -87.7033309936523, -1.53071189080562, 218, 2, 'PPL', 'P'),
(23258, 'Mountainbrook', 32.8586082458496, 0.573490901513034, -84.8505630493164, -1.48092169738161, 218, 13, 'PPL', 'P'),
(67058, 'Mountainbrook', 35.598331451416, 0.621308092043461, -82.529167175293, -1.44040569613769, 218, 33, 'PPL', 'P'),
(82519, 'Mountainbrook', 35.0213890075684, 0.611238546803817, -81.9649963378906, -1.43055905748129, 218, 48, 'PPL', 'P'),
(89276, 'Mountainbrook', 35.2013893127441, 0.614380144783729, -84.9097213745117, -1.48195420493623, 218, 50, 'PPL', 'P'),
(10696, 'Mountainburg', 35.6355590820313, 0.621957836770413, -94.1672210693359, -1.64352805511329, 218, 4, 'PPL', 'P'),
(113757, 'Mountaincrest', 41.4705581665039, 0.723797782645316, -72.9402770996094, -1.2730479927052, 218, 8, 'PPL', 'P'),
(4447, 'Mountaindale', 33.5122184753418, 0.584898552042389, -86.7324981689453, -1.51376766152805, 218, 2, 'PPL', 'P'),
(49703, 'Mountaindale', 39.5194396972656, 0.689744341260636, -77.4508285522461, -1.35177196663433, 218, 25, 'PPL', 'P'),
(82520, 'Mountaindale', 34.7097206115723, 0.605798907119276, -82.8102798461914, -1.44531203781394, 218, 48, 'PPL', 'P'),
(164934, 'Mountaindale', 40.6933288574219, 0.710232572158834, -78.4250030517578, -1.36877451913977, 218, 45, 'PPL', 'P'),
(201272, 'Mountaindale', 45.625, 0.796306471222413, -123.037780761719, -2.14741437863893, 218, 43, 'PPL', 'P'),
(164935, 'Mountainhome', 41.1736106872559, 0.71861507142694, -75.2713928222656, -1.31373363731056, 218, 45, 'PPL', 'P'),
(205050, 'Mountains Meadows', 40.8447189331055, 0.712874827434356, -111.89778137207, -1.9529847106194, 218, 52, 'PPL', 'P'),
(145848, 'Mountainside', 40.6722183227539, 0.709864123822021, -74.357780456543, -1.29778809344177, 218, 37, 'PPL', 'P'),
(23259, 'Mountaintown', 34.7555618286133, 0.606598987289763, -84.5602798461914, -1.47585529972384, 218, 13, 'PPL', 'P'),
(104513, 'Mountainview', 38.5663909912109, 0.67311050340811, -77.6050033569336, -1.35446282459974, 218, 53, 'PPL', 'P'),
(128207, 'Mountainview', 44.9672203063965, 0.784826049816272, -70.7622222900391, -1.2350337649893, 218, 26, 'PPL', 'P'),
(189079, 'Mountainview', 34.9949989318848, 0.610777953093288, -106.663887023926, -1.86163602154276, 218, 38, 'PPL', 'P'),
(128208, 'Mountainview Park', 43.6297187805176, 0.761482244439237, -70.2263870239258, -1.22568167534733, 218, 26, 'PPL', 'P'),
(128209, 'Mountainville', 44.2119407653809, 0.771643935052598, -68.6294403076172, -1.19780969716883, 218, 26, 'PPL', 'P'),
(145850, 'Mountainville', 40.690559387207, 0.710184235785049, -74.8119430541992, -1.30571472611028, 218, 37, 'PPL', 'P'),
(150928, 'Mountainville', 41.4008293151855, 0.722580784606177, -74.0788879394531, -1.29292050075937, 218, 40, 'PPL', 'P'),
(89277, 'Mountainville (historical)', 35.5680618286133, 0.620779787462217, -84.1416702270508, -1.46854918358932, 218, 50, 'PPL', 'P'),
(104514, 'Mountcastle', 37.4533309936523, 0.653683941678473, -77.0941696166992, -1.34554709390238, 218, 53, 'PPL', 'P'),
(183509, 'Mountclef Village', 34.2344398498535, 0.597503692955897, -118.877777099609, -2.0748086178401, 218, 6, 'PPL', 'P'),
(104515, 'Mountfair', 38.1697196960449, 0.666187283259313, -78.6744384765625, -1.37312798857373, 218, 53, 'PPL', 'P'),
(205053, 'Mounthaven', 40.6488914489746, 0.709456993070376, -111.647216796875, -1.94861153379339, 218, 52, 'PPL', 'P'),
(120719, 'Mountjoy', 40.2866706848145, 0.703135048116691, -89.2819366455078, -1.55826375702109, 218, 18, 'PPL', 'P'),
(208197, 'Mountlake Terrace', 47.788330078125, 0.83406370389312, -122.307502746582, -2.13466862281986, 218, 56, 'PPL', 'P'),
(30593, 'Mounts', 38.2305603027344, 0.667249152164955, -87.7063903808594, -1.53076528718548, 218, 19, 'PPL', 'P'),
(145851, 'Mounts Mills', 40.3255615234375, 0.703813821299525, -74.3613891601563, -1.29785107720155, 218, 37, 'PPL', 'P'),
(49704, 'Mounts Scenic Acres', 39.5247192382813, 0.689836486634353, -77.2350006103516, -1.34800505843046, 218, 25, 'PPL', 'P'),
(49705, 'Mountview', 39.3180618286133, 0.686229634412004, -76.9408264160156, -1.3428707501649, 218, 25, 'PPL', 'P'),
(73602, 'Mountview', 39.1152801513672, 0.682690426481343, -84.6627807617188, -1.47764427818611, 218, 41, 'PPL', 'P'),
(110577, 'Mountview', 37.6419410705566, 0.656975808522893, -81.065559387207, -1.41486092127776, 218, 58, 'PPL', 'P'),
(23262, 'Mountville', 33.0391693115234, 0.576642286609952, -84.8808288574219, -1.48144993538383, 218, 13, 'PPL', 'P'),
(49706, 'Mountville', 39.3438911437988, 0.686680441005527, -77.5177764892578, -1.3529404285626, 218, 25, 'PPL', 'P'),
(73599, 'Mountville', 39.5180587768555, 0.689720239652771, -81.9858322143555, -1.43092271212814, 218, 41, 'PPL', 'P'),
(82521, 'Mountville', 34.3627815246582, 0.599743677748763, -81.9677810668945, -1.43060766017118, 218, 48, 'PPL', 'P'),
(104516, 'Mountville', 39.0252799987793, 0.681119627491387, -77.7122192382813, -1.35633409473969, 218, 53, 'PPL', 'P'),
(164938, 'Mountville', 40.0391693115234, 0.698815334249555, -76.4311065673828, -1.33397446054349, 218, 45, 'PPL', 'P'),
(49707, 'Mountville Manor', 39.2999992370605, 0.685914382717966, -77.4824981689453, -1.35232470571857, 218, 25, 'PPL', 'P'),
(49708, 'Mountvista', 39.4602813720703, 0.688711833706013, -76.4569396972656, -1.33442533371604, 218, 25, 'PPL', 'P'),
(96391, 'Moursund', 28.8861103057861, 0.504157732930234, -97.057502746582, -1.6939729866913, 218, 51, 'PPL', 'P'),
(128210, 'Mouse Island', 43.832218170166, 0.765016525521881, -69.6430587768555, -1.21550067681606, 218, 26, 'PPL', 'P'),
(191004, 'Mouser', 36.8705596923828, 0.643512663685188, -101.41471862793, -1.770020750041, 218, 42, 'PPL', 'P'),
(189080, 'Mouser Place', 31.7994403839111, 0.555004934990899, -108.921669006348, -1.90104175092823, 218, 38, 'PPL', 'P'),
(89280, 'Mousetail (historical)', 35.6833305358887, 0.62279160592869, -88.0152816772461, -1.53615645733818, 218, 50, 'PPL', 'P'),
(49709, 'Mousetown', 39.5041694641113, 0.689477825414547, -77.642219543457, -1.35511236958961, 218, 25, 'PPL', 'P'),
(37324, 'Mousie', 37.4183311462402, 0.653073079103436, -82.8783264160156, -1.44649967450206, 218, 21, 'PPL', 'P'),
(128211, 'Moussam', 44.0802803039551, 0.769346026506023, -70.3413925170898, -1.22768889986092, 218, 26, 'PPL', 'P'),
(37319, 'Moutardier', 37.3349990844727, 0.651618660253116, -86.2477798461914, -1.50530773085125, 218, 21, 'PPL', 'P'),
(104517, 'Mouth of Laurel', 37.1169395446777, 0.647812803318311, -81.7119369506836, -1.42614233797144, 218, 53, 'PPL', 'P'),
(104518, 'Mouth of Wilson', 36.5894393920898, 0.63860618885088, -81.336669921875, -1.41959269274456, 218, 53, 'PPL', 'P'),
(37320, 'Mouthcard', 37.3841705322266, 0.652476863914394, -82.2552795410156, -1.43562545513905, 218, 21, 'PPL', 'P'),
(42209, 'Mouton', 30.273889541626, 0.52837904988645, -92.0330581665039, -1.60627988568495, 218, 22, 'PPL', 'P'),
(10697, 'Mouton (historical)', 34.2869415283203, 0.598420020107966, -94.0188903808594, -1.64093919621762, 218, 4, 'PPL', 'P'),
(42207, 'Mouton Cove', 29.8758296966553, 0.521431594971733, -92.1747207641602, -1.60875236444098, 218, 22, 'PPL', 'P'),
(82522, 'Mouzon', 33.7344398498535, 0.588777046695925, -79.9269409179688, -1.39498828006553, 218, 48, 'PPL', 'P'),
(60986, 'Movella', 30.7638893127441, 0.536931159226481, -88.5063934326172, -1.54472797446466, 218, 30, 'PPL', 'P'),
(4448, 'Movico', 31.0644397735596, 0.542176754336096, -88.0255584716797, -1.5363358212376, 218, 2, 'PPL', 'P'),
(116966, 'Moville', 42.4888916015625, 0.741571053970232, -96.0722198486328, -1.67677655605849, 218, 16, 'PPL', 'P'),
(42208, 'Mowata', 30.3916702270508, 0.530434710642369, -92.4094390869141, -1.61284897198779, 218, 22, 'PPL', 'P'),
(89279, 'Mowbray', 35.276668548584, 0.61569401530752, -85.2222213745117, -1.48740835884872, 218, 50, 'PPL', 'P'),
(89281, 'Mowd (historical)', 35.7180595397949, 0.623397741392792, -87.0694427490234, -1.51964845384716, 218, 50, 'PPL', 'P'),
(27984, 'Moweaqua', 39.6247215270996, 0.691581855833764, -89.0188903808594, -1.55367273361791, 218, 18, 'PPL', 'P'),
(164939, 'Moween', 40.4816703796387, 0.706538434831758, -79.4322204589844, -1.38635377917928, 218, 45, 'PPL', 'P'),
(71148, 'Mowers', 39.586669921875, 0.690917730036925, -75.3630599975586, -1.31533353133543, 218, 37, 'PPL', 'P'),
(164940, 'Mowersville', 40.1119384765625, 0.700085395773414, -77.5822219848633, -1.35406521464899, 218, 45, 'PPL', 'P'),
(208198, 'Mowich Illahee', 48.3974990844727, 0.844695708754989, -119.812782287598, -2.09112753689372, 218, 56, 'PPL', 'P'),
(89282, 'Mowls Mill', 36.3969383239746, 0.635246411398664, -82.8611068725586, -1.44619913677305, 218, 50, 'PPL', 'P'),
(49710, 'Mowry', 39.2916717529297, 0.685769040701475, -77.4888916015625, -1.35243629216825, 218, 25, 'PPL', 'P'),
(164942, 'Mowry', 40.7622184753418, 0.711434922811977, -76.4044418334961, -1.333509073143, 218, 45, 'PPL', 'P'),
(195356, 'Mowry', 47.309440612793, 0.825705505969961, -116.995002746582, -2.04194800630767, 218, 17, 'PPL', 'P'),
(183510, 'Mowry Landing', 37.5061111450195, 0.654605129099531, -122.017776489258, -2.12961194570008, 218, 6, 'PPL', 'P'),
(73600, 'Mowrystown', 39.038330078125, 0.681347394343616, -83.7486114501953, -1.46168901377933, 218, 41, 'PPL', 'P'),
(73601, 'Moxahala', 39.6624984741211, 0.69224118794064, -82.1363906860352, -1.43355045317572, 218, 41, 'PPL', 'P'),
(73603, 'Moxahala Park', 39.8800010681152, 0.696037324337466, -82.0547180175781, -1.43212499620225, 218, 41, 'PPL', 'P'),
(208199, 'Moxee City', 46.5538902282715, 0.812518664095352, -120.381942749023, -2.10106126091777, 218, 56, 'PPL', 'P'),
(33363, 'Moxham', 37.1144409179688, 0.647769194055461, -97.04638671875, -1.69377897540588, 218, 20, 'PPL', 'P'),
(164943, 'Moxham', 40.2941703796387, 0.703265942484268, -78.9077835083008, -1.37720062767073, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(23263, 'Moxley', 32.9194412231445, 0.574552637260621, -82.3913879394531, -1.4380009948314, 218, 13, 'PPL', 'P'),
(37321, 'Moxley', 38.5625, 0.673042592800313, -85.0091705322266, -1.48368992017669, 218, 21, 'PPL', 'P'),
(49711, 'Moxley', 39.5902786254883, 0.690980713796706, -76.184440612793, -1.32966932748332, 218, 25, 'PPL', 'P'),
(67059, 'Moxley', 36.3291702270508, 0.634063634979532, -81.0922164916992, -1.4153261755202, 218, 33, 'PPL', 'P'),
(49712, 'Moxley Acres', 39.5555610656738, 0.690374778069685, -76.2594375610352, -1.3309782711591, 218, 25, 'PPL', 'P'),
(37322, 'Moxley Landing', 37.1861114501953, 0.649020080819472, -88.3058319091797, -1.54122751552786, 218, 21, 'PPL', 'P'),
(82523, 'Moyd', 33.3411102294922, 0.581912149775001, -79.3694381713867, -1.38525802154877, 218, 48, 'PPL', 'P'),
(23264, 'Moye', 31.6108303070068, 0.551713068146479, -84.7769393920898, -1.47963672215565, 218, 13, 'PPL', 'P'),
(164944, 'Moyer', 40.0494384765625, 0.698994564990918, -79.5658264160156, -1.38868564302975, 218, 45, 'PPL', 'P'),
(76655, 'Moyers', 34.3261108398438, 0.599103653559789, -95.6533279418945, -1.66946551307595, 218, 42, 'PPL', 'P'),
(110578, 'Moyers', 38.5158309936523, 0.672228064980913, -79.3625030517578, -1.38513698087722, 218, 58, 'PPL', 'P'),
(164945, 'Moyers', 40.5519409179688, 0.707764887092766, -76.2502822875977, -1.33081848149369, 218, 45, 'PPL', 'P'),
(150929, 'Moyers Corners', 43.1802787780762, 0.753638036606463, -76.2619400024414, -1.33102194700098, 218, 40, 'PPL', 'P'),
(164946, 'Moyers Grove', 41.0605583190918, 0.7166419353753, -76.0647201538086, -1.32757981129205, 218, 45, 'PPL', 'P'),
(195357, 'Moyie Springs', 48.726390838623, 0.850435952747573, -116.1875, -2.02785442466091, 218, 17, 'PPL', 'P'),
(78794, 'Moylan', 39.9088897705078, 0.696541527310846, -75.3966674804688, -1.31592009256552, 218, 45, 'PPL', 'P'),
(78795, 'Moylan-Rose Valley Station', 39.9055595397949, 0.696483403820055, -75.3883285522461, -1.31577455081194, 218, 45, 'PPL', 'P'),
(197114, 'Moyne', 46.2563896179199, 0.807326298918024, -110.874443054199, -1.93512408761073, 218, 31, 'PPL', 'P'),
(67061, 'Moyock', 36.5244407653809, 0.637471748805534, -76.1786117553711, -1.32956759472968, 218, 33, 'PPL', 'P'),
(10699, 'Mozart', 35.8355598449707, 0.625448508590208, -92.3177795410156, -1.61124921112098, 218, 4, 'PPL', 'P'),
(164947, 'Mozart', 40.2758293151855, 0.702945830521241, -75.0541687011719, -1.30994236118273, 218, 45, 'PPL', 'P'),
(177251, 'Mozart', 40.0322189331055, 0.698694027261902, -80.7149963378906, -1.40874244183136, 218, 58, 'PPL', 'P'),
(195358, 'Mozart', 47.4111099243164, 0.827479970204281, -116.935829162598, -2.04091523243693, 218, 17, 'PPL', 'P'),
(177252, 'Mozart Meadows', 40.0269393920898, 0.698601881888185, -80.706672668457, -1.40859716639389, 218, 58, 'PPL', 'P'),
(37323, 'Mozelle', 37.002498626709, 0.645815432500752, -83.398063659668, -1.45557080064904, 218, 21, 'PPL', 'P'),
(96392, 'Mozelle', 31.5988903045654, 0.551504675791181, -99.4925003051758, -1.73647171136678, 218, 51, 'PPL', 'P'),
(110579, 'Mozelle (historical)', 39.0277786254883, 0.681163236754237, -81.7280578613281, -1.42642370094061, 218, 58, 'PPL', 'P'),
(110580, 'Mozer', 38.8025016784668, 0.677231412299872, -79.2091674804688, -1.3824607702978, 218, 58, 'PPL', 'P'),
(27983, 'Mozier', 39.2924995422363, 0.685783488350389, -90.7491683959961, -1.58387178195691, 218, 18, 'PPL', 'P'),
(27985, 'Mozier Landing', 39.2555618286133, 0.685138803629508, -90.725830078125, -1.58346445146819, 218, 18, 'PPL', 'P'),
(49713, 'Mozinger', 39.6852798461914, 0.692638797891389, -77.2597198486328, -1.34843649052706, 218, 25, 'PPL', 'P'),
(96393, 'Mozo', 30.6913890838623, 0.535665791524043, -97.5247192382813, -1.70212745279106, 218, 51, 'PPL', 'P'),
(17212, 'Muce', 26.8274993896484, 0.468228194426134, -81.4961090087891, -1.42237542976758, 218, 12, 'PPL', 'P'),
(156648, 'Muchinippi (historical)', 40.4391708374023, 0.705796677889143, -83.9458312988281, -1.46513114948826, 218, 41, 'PPL', 'P'),
(4449, 'Muck City', 34.4824981689453, 0.601833127361012, -87.3547210693359, -1.52462749982117, 218, 2, 'PPL', 'P'),
(104519, 'Muck Cross', 36.7177810668945, 0.640846173643746, -78.3680572509766, -1.36778062742096, 218, 53, 'PPL', 'P'),
(137014, 'Muckland', 43.7447204589844, 0.763489402373802, -93.1888885498047, -1.62645293146814, 218, 28, 'PPL', 'P'),
(193278, 'Mud Bay', 55.4208297729492, 0.967275953725265, -131.76806640625, -2.29978660777559, 218, 1, 'PPL', 'P'),
(202407, 'Mud Butte', 45.0047187805176, 0.785480521654159, -102.877220153809, -1.79554621698303, 218, 49, 'PPL', 'P'),
(67063, 'Mud Castle', 36.3699989318848, 0.63477623030821, -77.5313873291016, -1.35317798253183, 218, 33, 'PPL', 'P'),
(30594, 'Mud Center', 37.9558296203613, 0.662454197201295, -87.6286087036133, -1.52940774081981, 218, 19, 'PPL', 'P'),
(4450, 'Mud Creek', 33.4027786254883, 0.582988466329556, -87.1569366455078, -1.52117551041621, 218, 2, 'PPL', 'P'),
(89284, 'Mud Creek', 35.3069381713867, 0.616222319888764, -88.3938903808594, -1.54276442579294, 218, 50, 'PPL', 'P'),
(4451, 'Mud Creek (historical)', 34.8227806091309, 0.60777217632897, -86.057502746582, -1.50198676897192, 218, 2, 'PPL', 'P'),
(104520, 'Mud Fork', 37.2186088562012, 0.649587267552631, -81.458610534668, -1.42172095792969, 218, 53, 'PPL', 'P'),
(150930, 'Mud Hill', 43.3902816772461, 0.757303278635712, -75.9274978637695, -1.32518483052374, 218, 40, 'PPL', 'P'),
(10701, 'Mud Lake', 34.9122200012207, 0.60933318820192, -90.5138931274414, -1.57976545387212, 218, 4, 'PPL', 'P'),
(195359, 'Mud Lake', 43.8413887023926, 0.765176581503395, -112.475280761719, -1.96306397639703, 218, 17, 'PPL', 'P'),
(197115, 'Mud Lake (historical)', 48.1194381713867, 0.839842630300538, -113.998611450195, -1.98965111250762, 218, 31, 'PPL', 'P'),
(4452, 'Mud Landing', 30.9244403839111, 0.539733304035949, -87.8758316040039, -1.53372259441796, 218, 2, 'PPL', 'P'),
(128212, 'Mud Landing', 44.8569412231445, 0.782901316717445, -67.4477767944336, -1.17718577821309, 218, 26, 'PPL', 'P'),
(37325, 'Mud Lick', 36.7527809143066, 0.641457036218783, -85.7805633544922, -1.49715326475148, 218, 21, 'PPL', 'P'),
(150932, 'Mud Lock', 42.9463882446289, 0.749555876708562, -76.7363891601563, -1.33930264693641, 218, 40, 'PPL', 'P'),
(150931, 'Mud Mills', 43.0750007629395, 0.751800588612363, -77.0758285522461, -1.34522698193935, 218, 40, 'PPL', 'P'),
(73604, 'Mud Run', 39.8813896179199, 0.696061559103386, -81.3772201538086, -1.42030042780425, 218, 41, 'PPL', 'P'),
(164948, 'Mud Run', 40.9897193908691, 0.715405562839231, -75.7127838134766, -1.32143736339583, 218, 45, 'PPL', 'P'),
(150933, 'Mud Settlement', 43.2836112976074, 0.755441529296665, -76.1141662597656, -1.32844280864329, 218, 40, 'PPL', 'P'),
(208200, 'Mud Spring', 47.8305587768555, 0.8348007337248, -119.812217712402, -2.09111768319769, 218, 56, 'PPL', 'P'),
(190524, 'Mud Springs', 38.2799987792969, 0.668112016358141, -114.134719848633, -1.99202665219997, 218, 39, 'PPL', 'P'),
(195360, 'Mud Springs', 45.8636093139648, 0.800470989377024, -115.58528137207, -2.0173437267867, 218, 17, 'PPL', 'P'),
(200089, 'Mud Springs (historical)', 40.3858299255371, 0.704865703351079, -116.731109619141, -2.03734220236043, 218, 39, 'PPL', 'P'),
(56425, 'Mud Town', 38.0194396972656, 0.663564402480721, -90.7394409179688, -1.58370200543742, 218, 29, 'PPL', 'P'),
(137016, 'Mudbaden', 44.6916694641113, 0.780016780361752, -93.6175003051758, -1.63393361781211, 218, 28, 'PPL', 'P'),
(110581, 'Muddlety', 38.3672218322754, 0.669634345816257, -80.8277816772461, -1.41071091735109, 218, 58, 'PPL', 'P'),
(27986, 'Muddy', 37.7649993896484, 0.659123581363014, -88.5166702270508, -1.54490733836407, 218, 18, 'PPL', 'P'),
(197116, 'Muddy', 45.621940612793, 0.796253074842557, -106.759719848633, -1.86330861986538, 218, 31, 'PPL', 'P'),
(67064, 'Muddy Creek', 36.0269393920898, 0.628788711808412, -80.3438873291016, -1.40226536774418, 218, 33, 'PPL', 'P'),
(164949, 'Muddy Creek', 40.9722213745117, 0.715100164841226, -79.9713897705078, -1.39576405889107, 218, 45, 'PPL', 'P'),
(78796, 'Muddy Creek Forks', 39.8080596923828, 0.694781710462521, -76.4755630493164, -1.33475037252709, 218, 45, 'PPL', 'P'),
(67066, 'Muddy Cross', 36.3636093139648, 0.634664710437563, -76.6277770996094, -1.33740700887249, 218, 33, 'PPL', 'P'),
(104521, 'Muddy Cross', 36.9225006103516, 0.644419203720251, -76.6005630493164, -1.33693203409208, 218, 53, 'PPL', 'P'),
(17213, 'Muddy Ford', 30.4594402313232, 0.531617520351014, -86.8949966430664, -1.51660379493093, 218, 12, 'PPL', 'P'),
(37326, 'Muddy Ford', 38.3091697692871, 0.668621146179537, -84.5025024414063, -1.47484689377709, 218, 21, 'PPL', 'P'),
(10702, 'Muddy Fork', 34.1358299255371, 0.595782625101433, -93.8947219848633, -1.63877204888057, 218, 4, 'PPL', 'P'),
(209627, 'Muddy Gap', 42.3516693115234, 0.739176073201924, -107.456672668457, -1.87547274130238, 218, 59, 'PPL', 'P'),
(112566, 'Muddy Pond', 36.2083282470703, 0.631954544554244, -85.1127777099609, -1.48549820655686, 218, 50, 'PPL', 'P'),
(110582, 'Mudfork', 38.6391716003418, 0.674380764669051, -81.0752792358398, -1.4150305646392, 218, 58, 'PPL', 'P'),
(113758, 'Mudgetown', 41.8955612182617, 0.731215485229514, -73.4766693115234, -1.28240980288516, 218, 8, 'PPL', 'P'),
(123262, 'Mudlavia Springs', 40.3383293151855, 0.704036661303737, -87.2927780151367, -1.52354638957666, 218, 19, 'PPL', 'P'),
(73605, 'Mudlick', 39.6169395446777, 0.69144603461817, -84.3916702270508, -1.47291250671931, 218, 41, 'PPL', 'P'),
(82524, 'Mudlick', 34.2694396972656, 0.598114555530934, -81.8697204589844, -1.42889617969664, 218, 48, 'PPL', 'P'),
(89289, 'Mudsink', 35.9102783203125, 0.626752591996992, -86.8130569458008, -1.51517367742556, 218, 50, 'PPL', 'P'),
(156649, 'Mudsock', 40.0022201538086, 0.698170449791592, -83.1822204589844, -1.45180362612907, 218, 41, 'PPL', 'P'),
(89285, 'Mudtavern', 36.1511116027832, 0.630955925724491, -86.6916732788086, -1.5130551327784, 218, 50, 'PPL', 'P'),
(42210, 'Mudville', 31.7127799987793, 0.553492425939302, -92.396110534668, -1.61261634486657, 218, 22, 'PPL', 'P'),
(89286, 'Mudville', 35.377498626709, 0.617453832155844, -89.7383270263672, -1.56622927184152, 218, 50, 'PPL', 'P'),
(96394, 'Mudville', 30.6802806854248, 0.535471913396686, -96.5508270263672, -1.68512982713363, 218, 51, 'PPL', 'P'),
(82525, 'Mudville (historical)', 33.271110534668, 0.580690424624927, -80.1805572509766, -1.39941472011335, 218, 48, 'PPL', 'P'),
(96395, 'Muehlsville', 29.5497207641602, 0.51573992037953, -98.0430603027344, -1.71117421101406, 218, 51, 'PPL', 'P'),
(96396, 'Muellersville', 30.0949993133545, 0.525256826403469, -96.4244384765625, -1.68292393080272, 218, 51, 'PPL', 'P'),
(96397, 'Muenster', 33.651668548584, 0.587332414962612, -97.376106262207, -1.69953366704738, 218, 51, 'PPL', 'P'),
(164951, 'Muff', 40.8844413757324, 0.713568114845131, -79.3383331298828, -1.38471513616055, 218, 45, 'PPL', 'P'),
(193809, 'Mugginsville', 41.5736083984375, 0.725596348487501, -122.950561523438, -2.14589211575984, 218, 6, 'PPL', 'P'),
(164956, 'Muhlenberg', 40.3830604553223, 0.704817366977294, -75.9391708374023, -1.32538856234713, 218, 45, 'PPL', 'P'),
(164952, 'Muhlenberg Park', 40.3847198486328, 0.704846328854149, -75.9416732788086, -1.32543223818901, 218, 45, 'PPL', 'P'),
(164954, 'Muhlenburg', 41.228889465332, 0.719579868110849, -76.1594390869141, -1.32923296853871, 218, 45, 'PPL', 'P'),
(96398, 'Muil', 27.7602806091309, 0.484508297906871, -98.216667175293, -1.7142042225443, 218, 51, 'PPL', 'P'),
(10705, 'Muir', 35.5313911437988, 0.620139763273243, -90.1827774047852, -1.57398639430665, 218, 4, 'PPL', 'P'),
(37328, 'Muir', 38.1058311462402, 0.665072217710897, -84.3772201538086, -1.47266030536408, 218, 21, 'PPL', 'P'),
(132200, 'Muir', 42.9958305358887, 0.750418807480775, -84.942497253418, -1.48252625193838, 218, 27, 'PPL', 'P'),
(164955, 'Muir', 40.5922203063965, 0.70846789504152, -76.5188903808594, -1.33550657711861, 218, 45, 'PPL', 'P'),
(183512, 'Muir', 39.3983306884766, 0.68763059030344, -123.343887329102, -2.15275694610174, 218, 6, 'PPL', 'P'),
(197117, 'Muir', 45.6630592346191, 0.796970730177306, -110.792778015137, -1.93369876379532, 218, 31, 'PPL', 'P'),
(183513, 'Muir Beach', 37.8622207641602, 0.660820414451558, -122.580276489258, -2.13942942274254, 218, 6, 'PPL', 'P'),
(23268, 'Muir Woods', 33.5919418334961, 0.586289987132928, -84.5224990844727, -1.47519590103794, 218, 13, 'PPL', 'P'),
(145853, 'Muirhead', 40.4513893127441, 0.706009930513432, -74.8594436645508, -1.30654376815762, 218, 37, 'PPL', 'P'),
(49714, 'Muirkirk', 39.0616683959961, 0.681754724832344, -76.8855590820313, -1.34190615321807, 218, 25, 'PPL', 'P'),
(132198, 'Muirs', 42.5563888549805, 0.742749103278429, -82.5872192382813, -1.44141889577441, 218, 27, 'PPL', 'P'),
(150934, 'Muitzes Kill', 42.4766693115234, 0.741357734766917, -73.7313919067383, -1.28685555085088, 218, 40, 'PPL', 'P'),
(23265, 'Mukerson', 32.250560760498, 0.562878470885177, -83.0747222900391, -1.44992742914111, 218, 13, 'PPL', 'P'),
(208201, 'Mukilteo', 47.9447212219238, 0.83679324427337, -122.303329467773, -2.13459578536405, 218, 56, 'PPL', 'P'),
(4453, 'Muklassa (historical)', 32.4249992370605, 0.565922996643356, -86.1624984741211, -1.503819290118, 218, 2, 'PPL', 'P'),
(175438, 'Mukwonago', 42.8666687011719, 0.74816450819705, -88.3333282470703, -1.54170741715629, 218, 57, 'PPL', 'P'),
(17214, 'Mulat', 30.5511093139648, 0.533217447665393, -87.1233291625977, -1.52058894918612, 218, 12, 'PPL', 'P'),
(42211, 'Mulatto Bend Landing', 30.5108299255371, 0.532514439716639, -91.2322235107422, -1.59230268417783, 218, 22, 'PPL', 'P'),
(4456, 'Mulberry', 31.5947208404541, 0.551431904914394, -86.4336090087891, -1.5085510615848, 218, 2, 'PPL', 'P'),
(10707, 'Mulberry', 35.500560760498, 0.619601671574993, -94.0513916015625, -1.64150644952981, 218, 4, 'PPL', 'P'),
(17215, 'Mulberry', 27.8950004577637, 0.486859602833301, -81.9736099243164, -1.43070939292482, 218, 12, 'PPL', 'P'),
(23267, 'Mulberry', 34.207218170166, 0.597028585017427, -83.8583297729492, -1.46360395976115, 218, 13, 'PPL', 'P'),
(33364, 'Mulberry', 37.5569381713867, 0.655492228058637, -94.6216735839844, -1.65145974778787, 218, 20, 'PPL', 'P'),
(37329, 'Mulberry', 38.2649993896484, 0.667850227622986, -85.1341705322266, -1.48587158174169, 218, 21, 'PPL', 'P'),
(42212, 'Mulberry', 29.5544395446777, 0.51582227863624, -90.7194366455078, -1.58335286501851, 218, 22, 'PPL', 'P'),
(56426, 'Mulberry', 38.2905616760254, 0.668296373684601, -94.5644378662109, -1.65046079606298, 218, 29, 'PPL', 'P'),
(60988, 'Mulberry', 31.4769401550293, 0.549376244158476, -88.8477783203125, -1.55068626477149, 218, 30, 'PPL', 'P'),
(67069, 'Mulberry', 36.3269386291504, 0.63402468624859, -80.8030624389648, -1.4102794852545, 218, 33, 'PPL', 'P'),
(73606, 'Mulberry', 39.1933288574219, 0.684052633378919, -84.2422180175781, -1.47030407358963, 218, 41, 'PPL', 'P'),
(82526, 'Mulberry', 33.9519386291504, 0.592573116513724, -80.3330612182617, -1.40207641646483, 218, 48, 'PPL', 'P'),
(89287, 'Mulberry', 35.2105598449707, 0.614540200765243, -86.4602813720703, -1.50901658214335, 218, 50, 'PPL', 'P'),
(96399, 'Mulberry', 33.7211112976074, 0.588544419574707, -96.2808303833008, -1.68041749674279, 218, 51, 'PPL', 'P'),
(123263, 'Mulberry', 40.3444404602051, 0.704143320905395, -86.665283203125, -1.51259453906787, 218, 19, 'PPL', 'P'),
(132199, 'Mulberry', 41.7436103820801, 0.728563442836985, -83.8816680908203, -1.46401129024988, 218, 27, 'PPL', 'P'),
(23272, 'Mulberry Grove', 32.1894416809082, 0.561811741710546, -81.1594390869141, -1.41649943113843, 218, 13, 'PPL', 'P'),
(27987, 'Mulberry Grove', 38.9249992370605, 0.679369398022987, -89.2688903808594, -1.55803605674789, 218, 18, 'PPL', 'P'),
(156650, 'Mulberry Grove', 40.1025009155273, 0.699920679259993, -84.329719543457, -1.47183126331673, 218, 41, 'PPL', 'P'),
(104524, 'Mulberry Hill', 36.9063911437988, 0.644138040488166, -78.6997222900391, -1.37356927436635, 218, 53, 'PPL', 'P'),
(42213, 'Mulberry Hill (historical)', 32.0727806091309, 0.559775621899126, -92.8430633544922, -1.62041714317358, 218, 22, 'PPL', 'P'),
(14273, 'Mulberry Landing', 38.4858283996582, 0.671704420931576, -75.0766677856445, -1.31033504428546, 218, 10, 'PPL', 'P'),
(82527, 'Mulberry Landing', 33.584171295166, 0.586154365654415, -79.1025009155273, -1.38059908753778, 218, 48, 'PPL', 'P'),
(23271, 'Mulberry Place', 33.8277816772461, 0.590406168913754, -84.9333267211914, -1.48236619595687, 218, 13, 'PPL', 'P'),
(49716, 'Mulberry Point', 38.7541694641113, 0.676387856024589, -76.2502822875977, -1.33081848149369, 218, 25, 'PPL', 'P'),
(96400, 'Mulberry Springs', 32.5994415283203, 0.568967588980562, -94.6061096191406, -1.65118810535668, 218, 51, 'PPL', 'P'),
(49717, 'Mulberry Tree Acres', 39.3541717529297, 0.686859871483971, -77.4880599975586, -1.35242177794031, 218, 25, 'PPL', 'P'),
(104525, 'Mulch', 37.9033317565918, 0.661537936628253, -76.5711135864258, -1.33641804400169, 218, 53, 'PPL', 'P'),
(60989, 'Muldon', 33.7322196960449, 0.588738297702065, -88.6538925170898, -1.54730231913238, 218, 30, 'PPL', 'P'),
(96401, 'Muldoon', 29.815559387207, 0.520379679630666, -97.0708312988281, -1.69420561381251, 218, 51, 'PPL', 'P'),
(37330, 'Muldraugh', 37.936939239502, 0.662124497858343, -85.9916687011719, -1.50083774811961, 218, 21, 'PPL', 'P'),
(60990, 'Muldrow', 33.5466690063477, 0.585499827237501, -88.7044372558594, -1.54818449124347, 218, 30, 'PPL', 'P'),
(76656, 'Muldrow', 35.4061088562012, 0.617953174860234, -94.5986099243164, -1.65105721098911, 218, 42, 'PPL', 'P'),
(82528, 'Muldrow Mill', 34.1997184753418, 0.59689769064985, -79.8847198486328, -1.39425138339191, 218, 48, 'PPL', 'P'),
(82529, 'Muldrows Mill', 34.1425018310547, 0.595899071820097, -79.7750015258789, -1.39233643741009, 218, 48, 'PPL', 'P'),
(76658, 'Mule Barn', 36.2169418334961, 0.632104879997779, -96.3116683959961, -1.6809557215991, 218, 42, 'PPL', 'P'),
(189081, 'Mule Creek', 33.121940612793, 0.578086918343266, -108.955558776855, -1.90163323900633, 218, 38, 'PPL', 'P'),
(178690, 'Mule Crossing', 34.4575004577637, 0.601396834995429, -111.000282287598, -1.93732039656172, 218, 5, 'PPL', 'P'),
(89290, 'Mule Hollow', 35.9799995422363, 0.627969456878076, -83.8505630493164, -1.46346840486167, 218, 50, 'PPL', 'P'),
(187096, 'Muleshoe', 37.5897216796875, 0.65606440821884, -105.181938171387, -1.8357711347198, 218, 7, 'PPL', 'P'),
(191919, 'Muleshoe', 34.226390838623, 0.597363211208395, -102.723327636719, -1.79286028586563, 218, 51, 'PPL', 'P'),
(183514, 'Mulford', 37.7094383239746, 0.658153857831089, -122.178611755371, -2.13241905064707, 218, 6, 'PPL', 'P'),
(187097, 'Mulford', 39.4000015258789, 0.687659751917377, -107.151390075684, -1.87014455490945, 218, 7, 'PPL', 'P'),
(183515, 'Mulford Gardens', 37.704719543457, 0.658071499574378, -122.178611755371, -2.13241905064707, 218, 6, 'PPL', 'P'),
(37331, 'Mulfordtown', 37.5436096191406, 0.655259600937418, -88.0725021362305, -1.53715514274696, 218, 21, 'PPL', 'P'),
(4457, 'Mulga', 33.5497207641602, 0.585553090459303, -86.9741668701172, -1.51798557606252, 218, 2, 'PPL', 'P'),
(73608, 'Mulga', 39.1172218322754, 0.682724315206215, -82.4686126708984, -1.43934882065909, 218, 41, 'PPL', 'P'),
(4458, 'Mulga Mine', 33.5561103820801, 0.58566461032995, -86.9936065673828, -1.51832486278539, 218, 2, 'PPL', 'P'),
(76662, 'Mulhall', 36.0647201538086, 0.629448110494316, -97.4066696166992, -1.70006709821372, 218, 42, 'PPL', 'P'),
(201273, 'Mulino', 45.2216682434082, 0.789267004092034, -122.580833435059, -2.13943914328052, 218, 43, 'PPL', 'P'),
(191918, 'Mulkey', 34.4655609130859, 0.601537516480013, -102.213607788086, -1.78396399624422, 218, 51, 'PPL', 'P'),
(193810, 'Mulkey Place', 41.8650016784668, 0.730682120642198, -120.63777923584, -2.10552644995945, 218, 6, 'PPL', 'P'),
(27989, 'Mulkeytown', 37.9708290100098, 0.662715985936449, -89.1113891601563, -1.55528714187071, 218, 18, 'PPL', 'P'),
(10710, 'Mull', 36.0774993896484, 0.62967115023561, -92.6052780151367, -1.61626700608886, 218, 4, 'PPL', 'P'),
(123264, 'Mull', 40.207218170166, 0.701748340137087, -85.0730590820313, -1.48480498572511, 218, 19, 'PPL', 'P'),
(195361, 'Mullan', 47.4702796936035, 0.828512677495986, -115.800827026367, -2.02110570814254, 218, 17, 'PPL', 'P'),
(199552, 'Mullen', 42.042781829834, 0.733784969628249, -101.042221069336, -1.7635194411879, 218, 35, 'PPL', 'P'),
(183516, 'Mullen (historical)', 38.6519393920898, 0.674603604673263, -121.764999389648, -2.12520015303825, 218, 6, 'PPL', 'P'),
(189082, 'Mullen Place', 36.9211082458496, 0.644394902375304, -107.52555847168, -1.87667502537649, 218, 38, 'PPL', 'P'),
(110583, 'Mullens', 37.5830612182617, 0.655948161237258, -81.3805618286133, -1.42035875103212, 218, 58, 'PPL', 'P'),
(110584, 'Mullensville', 37.577220916748, 0.655846228746535, -81.5588912963867, -1.42347118739809, 218, 58, 'PPL', 'P'),
(17216, 'Mullet Lake Park', 28.788890838623, 0.502460933131204, -81.1386108398438, -1.41613590964963, 218, 12, 'PPL', 'P'),
(132202, 'Mullett Lake', 45.561939239502, 0.79520585332291, -84.5255584716797, -1.4752492974178, 218, 27, 'PPL', 'P'),
(71149, 'Mullica Hill', 39.7391700744629, 0.693579359809378, -75.2244415283203, -1.31291418264314, 218, 37, 'PPL', 'P'),
(10711, 'Mulligan', 35.7013893127441, 0.623106791043701, -90.6961135864258, -1.58294580084589, 218, 4, 'PPL', 'P'),
(132203, 'Mulliken', 42.7622184753418, 0.746341507851864, -84.8963928222656, -1.48172157781502, 218, 27, 'PPL', 'P'),
(37332, 'Mullikin Junction', 37.225830078125, 0.649713301651219, -88.3252792358398, -1.54156693540879, 218, 21, 'PPL', 'P'),
(96402, 'Mullin', 31.5566692352295, 0.550767779117556, -98.665283203125, -1.72203404930719, 218, 51, 'PPL', 'P'),
(49718, 'Mullinix', 39.2944412231445, 0.68581737707526, -77.146110534668, -1.34645363393744, 218, 25, 'PPL', 'P'),
(4459, 'Mullins', 31.1769409179688, 0.544140269718298, -85.3986129760742, -1.49048697306885, 218, 2, 'PPL', 'P'),
(37333, 'Mullins', 37.3450012207031, 0.651793230462571, -84.2272186279297, -1.47004228485447, 218, 21, 'PPL', 'P'),
(82530, 'Mullins', 34.2055587768555, 0.596999623140572, -79.2547225952148, -1.38325585704124, 218, 48, 'PPL', 'P'),
(191923, 'Mullins Crossing', 31.5361099243164, 0.550408951450181, -100.218063354492, -1.74913517550816, 218, 51, 'PPL', 'P'),
(67072, 'Mullins Crossroads', 36.1002807617188, 0.630068760186359, -77.4716720581055, -1.35213575443923, 218, 33, 'PPL', 'P'),
(96403, 'Mullins Prairie', 29.8504390716553, 0.520988444966344, -96.8107223510742, -1.68966585626031, 218, 51, 'PPL', 'P'),
(49719, 'Mullins Trailer Park', 39.5166702270508, 0.689696004886851, -76.1449966430664, -1.32898090034154, 218, 25, 'PPL', 'P'),
(33368, 'Mullinville', 37.586109161377, 0.656001357880033, -99.4752807617188, -1.73617117363777, 218, 20, 'PPL', 'P'),
(17217, 'Mullis City', 28.0397205352783, 0.489385444679674, -82.5091705322266, -1.44005668887684, 218, 12, 'PPL', 'P'),
(89291, 'Mulloy', 36.5497207641602, 0.637912968019133, -86.6233291625977, -1.51186230292615, 218, 50, 'PPL', 'P'),
(201274, 'Mulloy', 45.3338890075684, 0.791225625915732, -122.789169311523, -2.14307529027486, 218, 43, 'PPL', 'P'),
(42214, 'Mulnix', 32.6944389343262, 0.570625606496218, -93.0388870239258, -1.62383491095853, 218, 22, 'PPL', 'P'),
(201275, 'Multnomah', 45.4697189331055, 0.793596305339094, -122.706108093262, -2.14162559853548, 218, 43, 'PPL', 'P'),
(60991, 'Multona Springs', 33.1986083984375, 0.579425023632976, -89.4444427490234, -1.56110002358203, 218, 30, 'PPL', 'P'),
(33370, 'Mulvane', 37.4744415283203, 0.654052390015285, -97.2436065673828, -1.69722111111481, 218, 20, 'PPL', 'P'),
(110587, 'Mulvane (historical)', 38.160831451416, 0.666032154125816, -81.0491714477539, -1.41457489777669, 218, 58, 'PPL', 'P'),
(42215, 'Mulvey', 30.0061092376709, 0.523705401910443, -92.4038925170898, -1.61275216608217, 218, 22, 'PPL', 'P'),
(164957, 'Mumbauersville', 40.4183311462402, 0.705432956663266, -75.4599990844727, -1.31702543757595, 218, 45, 'PPL', 'P'),
(183517, 'Mumbert Acres', 38.2680587768555, 0.667903624002842, -120.31861114502, -2.09995591590734, 218, 6, 'PPL', 'P'),
(56427, 'Mumford', 37.1877784729004, 0.649049175854381, -93.2005615234375, -1.62665666329153, 218, 29, 'PPL', 'P'),
(96404, 'Mumford', 30.7341709136963, 0.536412475314674, -96.5647201538086, -1.68537230795089, 218, 51, 'PPL', 'P'),
(150935, 'Mumford', 42.9927787780762, 0.750365544258974, -77.8605575561523, -1.35892308679341, 218, 40, 'PPL', 'P'),
(49720, 'Mumfords Landing', 38.3861083984375, 0.669963978580182, -75.1369400024414, -1.31138699291604, 218, 25, 'PPL', 'P'),
(78797, 'Mummasburg', 39.8855590820313, 0.696134329980172, -77.2897186279297, -1.34896006799737, 218, 45, 'PPL', 'P'),
(37334, 'Mummie', 37.3936080932617, 0.652641580427816, -83.8711090087891, -1.46382699950245, 218, 21, 'PPL', 'P'),
(199554, 'Mumper', 41.7613906860352, 0.728873767683007, -102.439720153809, -1.78791040150555, 218, 35, 'PPL', 'P'),
(194337, 'Mumper Corner', 40.4519386291504, 0.706019517893356, -104.696670532227, -1.82730161666308, 218, 7, 'PPL', 'P'),
(156651, 'Mumper Estates', 40.0122184753418, 0.69834495342202, -83.7152786254883, -1.4611072462392, 218, 41, 'PPL', 'P'),
(178691, 'Mumurva', 35.8841705322266, 0.626296925134479, -110.688606262207, -1.93188062371913, 218, 5, 'PPL', 'P'),
(49721, 'Muncaster Manor', 39.1674995422363, 0.683601826785396, -77.1222229003906, -1.34603671606879, 218, 25, 'PPL', 'P'),
(33371, 'Muncie', 39.0875015258789, 0.682205598004894, -94.7472229003906, -1.65365099673279, 218, 20, 'PPL', 'P'),
(120722, 'Muncie', 40.1155586242676, 0.700148579270276, -87.8447189331055, -1.53317957587169, 218, 18, 'PPL', 'P'),
(123265, 'Muncie', 40.1933288574219, 0.701505925898862, -85.3863906860352, -1.49027365386553, 218, 19, 'PPL', 'P'),
(89292, 'Muncie (historical)', 36.2311096191406, 0.632352154504993, -86.3816680908203, -1.50764452154974, 218, 50, 'PPL', 'P'),
(156652, 'Muncie Hollow', 41.3858299255371, 0.722318995871022, -83.084716796875, -1.45010186619251, 218, 41, 'PPL', 'P'),
(164958, 'Muncy', 41.2055587768555, 0.719172670780175, -76.7858276367188, -1.3401655111296, 218, 45, 'PPL', 'P'),
(191005, 'Muncy', 36.8199996948242, 0.64263022525799, -101.762222290039, -1.77608583310755, 218, 42, 'PPL', 'P'),
(191920, 'Muncy', 34.0663909912109, 0.594570687068366, -101.39111328125, -1.76960875902036, 218, 51, 'PPL', 'P'),
(190526, 'Muncy (historical)', 39.601390838623, 0.691174658503091, -114.552780151367, -1.99932318095457, 218, 39, 'PPL', 'P'),
(164959, 'Muncy Valley', 41.3424987792969, 0.721562724700467, -76.585563659668, -1.33667024535692, 218, 45, 'PPL', 'P'),
(125495, 'Mundale', 42.1183280944824, 0.735103500683948, -72.8116683959961, -1.27080334738043, 218, 23, 'PPL', 'P'),
(150936, 'Mundale', 42.2547187805176, 0.737483967224315, -75.0500030517578, -1.30986965688497, 218, 40, 'PPL', 'P'),
(96405, 'Munday', 33.4491691589355, 0.583798133879968, -99.6224975585938, -1.73874059145747, 218, 51, 'PPL', 'P'),
(110585, 'Munday', 39.0052795410156, 0.680770553651505, -81.2063903808594, -1.41731888580585, 218, 58, 'PPL', 'P'),
(120723, 'Mundelein', 42.2630615234375, 0.737629575556915, -88.0038909912109, -1.53595765236281, 218, 18, 'PPL', 'P'),
(10712, 'Mundell (historical)', 36.3666687011719, 0.634718106817419, -93.8666687011719, -1.63828242671416, 218, 4, 'PPL', 'P'),
(33372, 'Munden', 39.913890838623, 0.696628812415573, -97.5377807617188, -1.70235541938037, 218, 20, 'PPL', 'P'),
(104526, 'Munden', 36.5777816772461, 0.638402723343598, -76.0361099243164, -1.32708046858766, 218, 53, 'PPL', 'P'),
(164962, 'Munderf', 41.2844390869141, 0.720549391905692, -78.9497222900391, -1.37793259749634, 218, 45, 'PPL', 'P'),
(183518, 'Mundo', 33.273609161377, 0.580734033887777, -115.568328857422, -2.01704784958959, 218, 6, 'PPL', 'P'),
(67073, 'Mundo Vista', 35.7583312988281, 0.624100616183491, -79.9038925170898, -1.39458600958288, 218, 33, 'PPL', 'P'),
(178692, 'Munds Park', 34.9455604553223, 0.609915088900102, -111.639442443848, -1.94847584573585, 218, 5, 'PPL', 'P'),
(56428, 'Mundy Landing', 39.5516700744629, 0.690306867461888, -91.1608276367188, -1.59105659110378, 218, 29, 'PPL', 'P'),
(164968, 'Mundys Corner', 40.4447212219238, 0.705893550373795, -78.8413925170898, -1.37604188628044, 218, 45, 'PPL', 'P'),
(37335, 'Mundys Landing', 37.8541717529297, 0.660679932704056, -84.7708282470703, -1.47953006255399, 218, 21, 'PPL', 'P'),
(23273, 'Mundys Mill', 33.4900016784668, 0.584510795787673, -84.3894424438477, -1.47287362456739, 218, 13, 'PPL', 'P'),
(23274, 'Mundys Point', 34.2591705322266, 0.597935324789572, -83.9147186279297, -1.46458813094199, 218, 13, 'PPL', 'P'),
(4461, 'Munford', 33.5297203063965, 0.585204016619421, -85.9508285522461, -1.50012495305385, 218, 2, 'PPL', 'P'),
(89293, 'Munford', 35.4491691589355, 0.618704718919854, -89.8150024414063, -1.56756751028928, 218, 50, 'PPL', 'P'),
(104527, 'Munford', 37.5097198486328, 0.654668112859312, -79.6136093139648, -1.38951961192511, 218, 53, 'PPL', 'P'),
(37336, 'Munfordville', 37.2722206115723, 0.650522969201631, -85.89111328125, -1.49908272496124, 218, 21, 'PPL', 'P'),
(156653, 'Mungen', 41.2747192382813, 0.720379748544254, -83.6500015258789, -1.45996794592487, 218, 41, 'PPL', 'P'),
(56429, 'Munger', 37.5974998474121, 0.656200162855407, -90.79638671875, -1.58469589715624, 218, 29, 'PPL', 'P'),
(96406, 'Munger', 31.7958297729492, 0.554941917941605, -96.7061080932617, -1.68783999301695, 218, 51, 'PPL', 'P'),
(120727, 'Munger', 41.9644393920898, 0.732417636145575, -88.2227783203125, -1.53977795694653, 218, 18, 'PPL', 'P'),
(132205, 'Munger', 43.5219383239746, 0.759601120603259, -83.7733306884766, -1.46212044587592, 218, 27, 'PPL', 'P'),
(137020, 'Munger', 46.8008308410645, 0.816828590845482, -92.3436126708984, -1.61170008429353, 218, 28, 'PPL', 'P'),
(56430, 'Munger Resort (historical)', 37.8516693115234, 0.660636256862179, -92.0758285522461, -1.6070263697385, 218, 29, 'PPL', 'P'),
(56431, 'Mungers', 39.7555618286133, 0.693865449889479, -91.4022216796875, -1.59526971194829, 218, 29, 'PPL', 'P'),
(150937, 'Mungers Corners', 43.3969383239746, 0.757419459038267, -76.2569427490234, -1.33093472847527, 218, 40, 'PPL', 'P'),
(191921, 'Mungerville', 32.7733306884766, 0.572002527358816, -102.090827941895, -1.78182108367309, 218, 51, 'PPL', 'P'),
(125496, 'Mungo Corner', 42.1944389343262, 0.736431885435679, -70.7813873291016, -1.23536825802222, 218, 23, 'PPL', 'P'),
(164964, 'Munhall', 40.392219543457, 0.704977223221726, -79.9002838134766, -1.3945230258231, 218, 45, 'PPL', 'P'),
(140547, 'Munich', 48.6691703796387, 0.849437267338793, -98.8322219848633, -1.72494768069779, 218, 34, 'PPL', 'P'),
(71150, 'Munion Field', 39.6644401550293, 0.692275076665511, -74.392219543457, -1.2983891688998, 218, 37, 'PPL', 'P'),
(132206, 'Munising', 46.4111099243164, 0.810026677684338, -86.6477813720703, -1.51228907449084, 218, 27, 'PPL', 'P'),
(132213, 'Munising Junction', 46.3791694641113, 0.809469211489157, -86.7099990844727, -1.51337497842532, 218, 27, 'PPL', 'P'),
(132209, 'Munith', 42.3905601501465, 0.739854846384758, -84.2505569458008, -1.4704496153432, 218, 27, 'PPL', 'P'),
(96407, 'Muniz', 26.2561092376709, 0.458255554960656, -98.0891723632813, -1.71197901829549, 218, 51, 'PPL', 'P'),
(96408, 'Muniz Colonia', 26.2520008087158, 0.458183849348305, -98.0839996337891, -1.71188873713453, 218, 51, 'PPL', 'P'),
(33373, 'Munjor', 38.8111114501953, 0.677381681164379, -99.2644424438477, -1.73249135080155, 218, 20, 'PPL', 'P'),
(128213, 'Munjoy Hill', 43.6672210693359, 0.762136782856151, -70.2494430541992, -1.22608407898804, 218, 26, 'PPL', 'P'),
(37337, 'Munk', 38.7755584716797, 0.676761164630391, -84.6966705322266, -1.47823576626421, 218, 21, 'PPL', 'P'),
(73609, 'Munks Corners', 39.917781829834, 0.69669672302337, -82.9169387817383, -1.44717358741591, 218, 41, 'PPL', 'P'),
(23275, 'Munnerlyn', 32.9533309936523, 0.575144125338728, -81.9622192382813, -1.43051058794945, 218, 13, 'PPL', 'P'),
(150938, 'Munns', 42.9811096191406, 0.75016187901461, -75.5780563354492, -1.31908592531135, 218, 40, 'PPL', 'P'),
(125497, 'Munns Ferry', 42.6541709899902, 0.744455723483979, -72.466667175293, -1.26478194015576, 218, 23, 'PPL', 'P'),
(150939, 'Munnsville', 42.9769401550293, 0.750089108137823, -75.5872192382813, -1.31924584813481, 218, 40, 'PPL', 'P'),
(164972, 'Munntown', 40.2322196960449, 0.702184699081696, -80.0897216796875, -1.39782934031643, 218, 45, 'PPL', 'P'),
(96409, 'Munoz Colonia', 26.4069995880127, 0.460889088383608, -98.9860000610352, -1.72763161444437, 218, 51, 'PPL', 'P'),
(96410, 'Munoz Estates Colonia', 26.2660007476807, 0.45842819437832, -98.3809967041016, -1.71707231388026, 218, 51, 'PPL', 'P'),
(96411, 'Munoz-Garcia Colonia', 26.4060001373291, 0.460871644678468, -98.9889984130859, -1.72768394555979, 218, 51, 'PPL', 'P'),
(67074, 'Munroe (historical)', 35.9238891601563, 0.626990145966227, -80.3061065673828, -1.40160596905827, 218, 33, 'PPL', 'P'),
(156654, 'Munroe Falls', 41.1444396972656, 0.718105941605544, -81.4400024414063, -1.42139618543476, 218, 41, 'PPL', 'P'),
(125498, 'Munroe Station', 42.440559387207, 0.74072749769495, -71.2130584716797, -1.24290234074605, 218, 23, 'PPL', 'P'),
(56432, 'Munsell', 37.0980606079102, 0.647483303712441, -91.3274993896484, -1.59396556196248, 218, 29, 'PPL', 'P'),
(150940, 'Munsey Park', 40.7986106872559, 0.712070086731961, -73.6802825927734, -1.28596352504376, 218, 40, 'PPL', 'P'),
(17218, 'Munson', 30.8575000762939, 0.538564975265731, -86.8730621337891, -1.51622096552423, 218, 12, 'PPL', 'P'),
(96412, 'Munson', 32.896671295166, 0.574155227046954, -96.2980575561523, -1.68071816762986, 218, 51, 'PPL', 'P'),
(132211, 'Munson', 41.7113914489746, 0.728001116372815, -84.3291702270508, -1.47182167593681, 218, 27, 'PPL', 'P'),
(164969, 'Munson', 40.954719543457, 0.714794700264194, -78.1733322143555, -1.36438203439585, 218, 45, 'PPL', 'P'),
(60992, 'Munson (historical)', 33.0694389343262, 0.577170591191197, -89.5541687011719, -1.5630151027219, 218, 30, 'PPL', 'P'),
(120724, 'Munson (historical)', 41.5261116027832, 0.724767373019187, -88.852783203125, -1.55077361645524, 218, 18, 'PPL', 'P'),
(49722, 'Munson Heights', 39.1450004577637, 0.683209143682664, -76.688606262207, -1.33846867804105, 218, 25, 'PPL', 'P'),
(156656, 'Munson Hill', 41.8019409179688, 0.729581502742696, -80.8341674804688, -1.41082237064271, 218, 41, 'PPL', 'P'),
(42216, 'Munsons', 29.9572200775146, 0.522852125097181, -91.0311126708984, -1.58879263786111, 218, 22, 'PPL', 'P'),
(56433, 'Munsons', 38.2513885498047, 0.667612673653751, -90.4261093139648, -1.578233337297, 218, 29, 'PPL', 'P'),
(150941, 'Munsons Corner', 43.0200004577637, 0.750840652197444, -76.8133316040039, -1.34064554591609, 218, 40, 'PPL', 'P'),
(150942, 'Munsons Corners', 42.582218170166, 0.743199909871952, -76.2094421386719, -1.33010568642793, 218, 40, 'PPL', 'P'),
(144176, 'Munsonville', 43.0141716003418, 0.750738919443803, -72.149169921875, -1.25924056771758, 218, 36, 'PPL', 'P'),
(150943, 'Munsonville', 43.0888900756836, 0.752043002850587, -74.2399978637695, -1.29573239939634, 218, 40, 'PPL', 'P'),
(82531, 'Munster', 34.0533294677734, 0.594342720479055, -81.0661087036133, -1.41487050865768, 218, 48, 'PPL', 'P'),
(120726, 'Munster', 41.1055603027344, 0.717427368159792, -88.9027786254883, -1.55164620118641, 218, 18, 'PPL', 'P'),
(123266, 'Munster', 41.5644416809082, 0.725436359085014, -87.5124969482422, -1.52738120838832, 218, 19, 'PPL', 'P'),
(140549, 'Munster', 47.7202796936035, 0.832876000625972, -99.2713928222656, -1.7326126577892, 218, 34, 'PPL', 'P'),
(164970, 'Munster', 40.4683303833008, 0.706305607973458, -78.6544418334961, -1.37277898131287, 218, 45, 'PPL', 'P'),
(156658, 'Munsville (historical)', 40.3422203063965, 0.704104571911534, -81.8005599975586, -1.42768910193256, 218, 41, 'PPL', 'P'),
(156659, 'Muntanna', 40.975830078125, 0.715163148601007, -84.3011093139648, -1.47133192061234, 218, 41, 'PPL', 'P'),
(116968, 'Munterville', 41.0355606079102, 0.716205643009718, -92.620002746582, -1.61652400113405, 218, 16, 'PPL', 'P'),
(132212, 'Munuscong', 46.2452812194824, 0.807132420790667, -84.1849975585938, -1.46930538818085, 218, 27, 'PPL', 'P'),
(183520, 'Munyon', 33.0405616760254, 0.576666587954899, -115.414169311523, -2.01435725794028, 218, 6, 'PPL', 'P'),
(82532, 'Murad', 32.4958305358887, 0.567159236021371, -80.8702774047852, -1.41145260771468, 218, 48, 'PPL', 'P'),
(104528, 'Murat', 37.7458305358887, 0.658789021751073, -79.5261077880859, -1.387992422198, 218, 53, 'PPL', 'P'),
(175441, 'Murat', 45.1894416809082, 0.788704544469809, -90.445556640625, -1.57857275717793, 218, 57, 'PPL', 'P'),
(156660, 'Murat (historical)', 41.0625, 0.716675824100172, -84.3758316040039, -1.47263607059816, 218, 41, 'PPL', 'P'),
(67075, 'Murchison', 35.829719543457, 0.625346576099485, -82.3161087036133, -1.43668712430761, 218, 33, 'PPL', 'P'),
(96413, 'Murchison', 32.2783317565918, 0.563363166203572, -95.7494430541992, -1.67114303824659, 218, 51, 'PPL', 'P'),
(23276, 'Murchisons (historical)', 34.2425003051758, 0.59764437444048, -85.0144424438477, -1.48378193239236, 218, 13, 'PPL', 'P'),
(67076, 'Murchisontown', 35.3544387817383, 0.617051361936106, -79.1341705322266, -1.38115182662203, 218, 33, 'PPL', 'P'),
(104529, 'Murdens Corner', 36.7872200012207, 0.642058111676814, -76.0524978637695, -1.32736649208873, 218, 53, 'PPL', 'P'),
(191922, 'Murdo', 35.6094398498535, 0.621501970170819, -102.350563049316, -1.78635431648062, 218, 51, 'PPL', 'P'),
(202408, 'Murdo', 43.8883285522461, 0.76599583643373, -100.712501525879, -1.7577647495464, 218, 49, 'PPL', 'P'),
(17219, 'Murdock', 27.0125007629395, 0.471457077510774, -82.1463928222656, -1.43372502338517, 218, 12, 'PPL', 'P'),
(27991, 'Murdock', 39.8008308410645, 0.694655543205879, -88.0783309936523, -1.5372568755006, 218, 18, 'PPL', 'P'),
(30596, 'Murdock', 38.9097213745117, 0.679102749018843, -86.5083312988281, -1.50985521157061, 218, 19, 'PPL', 'P'),
(33375, 'Murdock', 37.6111106872559, 0.656437716824642, -97.9305572509766, -1.70921066234235, 218, 20, 'PPL', 'P'),
(73613, 'Murdock', 39.2919387817383, 0.685773701233383, -84.2061080932617, -1.46967383651766, 218, 41, 'PPL', 'P'),
(78798, 'Murdock', 39.9580612182617, 0.697399730972123, -79.0991668701172, -1.38054089746796, 218, 45, 'PPL', 'P'),
(137022, 'Murdock', 45.2238883972168, 0.789305753085894, -95.3930587768555, -1.6649229592046, 218, 28, 'PPL', 'P'),
(142461, 'Murdock', 40.9255599975586, 0.71428577017988, -96.2797164916992, -1.68039805566684, 218, 35, 'PPL', 'P'),
(192979, 'Murdock', 38.5036087036133, 0.672014745777597, -112.983329772949, -1.9719311044045, 218, 52, 'PPL', 'P'),
(208202, 'Murdock', 45.6544418334961, 0.796820328154744, -121.187217712402, -2.11511596041261, 218, 56, 'PPL', 'P'),
(60993, 'Murdock Crossing', 33.4169387817383, 0.583235607678716, -90.3063888549805, -1.57614382110572, 218, 30, 'PPL', 'P'),
(150944, 'Murdock Woods', 40.9630584716797, 0.714940242017767, -73.7600021362305, -1.28735489355527, 218, 40, 'PPL', 'P'),
(104530, 'Murdocks', 37.0269393920898, 0.646242004328355, -78.0602798461914, -1.36240889834421, 218, 53, 'PPL', 'P'),
(67077, 'Murdocksville', 35.2238883972168, 0.614772827886461, -79.4822235107422, -1.3872264970685, 218, 33, 'PPL', 'P'),
(164973, 'Murdocksville', 40.4786109924316, 0.706485038451902, -80.3561096191406, -1.40247868694749, 218, 45, 'PPL', 'P'),
(30595, 'Muren', 38.3663902282715, 0.669619831588316, -87.2688903808594, -1.523129471708, 218, 19, 'PPL', 'P'),
(10713, 'Murfreesboro', 34.0622215270996, 0.594497916191579, -93.6897201538086, -1.63519409195605, 218, 4, 'PPL', 'P'),
(67078, 'Murfreesboro', 36.4422187805176, 0.636036704452145, -77.0988922119141, -1.34562951873811, 218, 33, 'PPL', 'P'),
(89294, 'Murfreesboro', 35.8455581665039, 0.625623012220635, -86.3902816772461, -1.50779485699327, 218, 50, 'PPL', 'P'),
(142462, 'Muriel', 40.5099983215332, 0.707032850688131, -98.3536071777344, -1.71659427646459, 218, 35, 'PPL', 'P'),
(183521, 'Murietta Farm', 36.651668548584, 0.639692292522442, -120.45832824707, -2.10239443935947, 218, 6, 'PPL', 'P'),
(96414, 'Murillo Colonia', 26.2560005187988, 0.458253657458379, -98.1129989624023, -1.7123948708997, 218, 51, 'PPL', 'P'),
(209628, 'Murke', 41.4247207641602, 0.722997769053856, -105.214721679688, -1.83634331488001, 218, 59, 'PPL', 'P'),
(37338, 'Murl', 36.8133316040039, 0.642513845118354, -84.9580612182617, -1.48279789436957, 218, 21, 'PPL', 'P'),
(73610, 'Murlin Heights', 39.857780456543, 0.695649501503724, -84.1994400024414, -1.46955745637802, 218, 41, 'PPL', 'P'),
(208203, 'Murnen', 46.6291694641113, 0.813832534619143, -123.321670532227, -2.15236918984702, 218, 56, 'PPL', 'P'),
(183522, 'Muroc (historical)', 34.9230613708496, 0.60952240579737, -117.871391296387, -2.05724387202854, 218, 6, 'PPL', 'P'),
(67080, 'Murphey', 34.8066711425781, 0.607491013096885, -77.9427795410156, -1.3603581311468, 218, 33, 'PPL', 'P'),
(104531, 'Murpheyville', 36.8919410705566, 0.643885839132935, -81.2888870239258, -1.4187587238492, 218, 53, 'PPL', 'P'),
(4462, 'Murphree', 33.9972190856934, 0.593363409567205, -86.4080581665039, -1.50810511526027, 218, 2, 'PPL', 'P'),
(89295, 'Murphree', 36.035831451416, 0.628943907520937, -86.4663925170898, -1.50912324174501, 218, 50, 'PPL', 'P'),
(4463, 'Murphree Place', 34.6986083984375, 0.605604962412891, -86.9569396972656, -1.51768490517545, 218, 2, 'PPL', 'P'),
(60994, 'Murphreesboro (historical)', 33.8994407653809, 0.591656855940683, -89.9741668701172, -1.57034545362235, 218, 30, 'PPL', 'P'),
(23277, 'Murphy', 31.0708293914795, 0.542288274206743, -83.8236083984375, -1.46299795745511, 218, 13, 'PPL', 'P'),
(56434, 'Murphy', 38.4902801513672, 0.671782118656379, -90.4869384765625, -1.57929500646556, 218, 29, 'PPL', 'P'),
(60995, 'Murphy', 33.1208305358887, 0.578067543846335, -90.7013931274414, -1.58303794621961, 218, 30, 'PPL', 'P'),
(67081, 'Murphy', 35.0875015258789, 0.612392427925121, -84.0347213745117, -1.46668257398128, 218, 33, 'PPL', 'P'),
(71151, 'Murphy', 39.6544418334961, 0.692100573035084, -74.8324966430664, -1.30607345390911, 218, 37, 'PPL', 'P'),
(73611, 'Murphy', 39.4152793884277, 0.687926400921521, -81.2022171020508, -1.41724604835003, 218, 41, 'PPL', 'P'),
(76665, 'Murphy', 36.1469383239746, 0.630883088268678, -95.2444381713867, -1.66232904030287, 218, 42, 'PPL', 'P'),
(96415, 'Murphy', 33.0149993896484, 0.576220441893284, -96.6127777099609, -1.68621107053621, 218, 51, 'PPL', 'P'),
(104532, 'Murphy', 37.1263885498047, 0.647977719568815, -82.1744384765625, -1.43421451239353, 218, 53, 'PPL', 'P'),
(110586, 'Murphy', 39.0574989318848, 0.681681953955558, -80.1413879394531, -1.39873108666153, 218, 58, 'PPL', 'P'),
(116969, 'Murphy', 41.6583290100098, 0.72707500210374, -92.9736099243164, -1.6226956106442, 218, 16, 'PPL', 'P'),
(142463, 'Murphy', 40.8791694641113, 0.713476102629469, -98.1116714477539, -1.71237170139822, 218, 35, 'PPL', 'P'),
(195362, 'Murphy', 43.2183303833008, 0.754302162403302, -116.551391601563, -2.03420553122853, 218, 17, 'PPL', 'P'),
(201277, 'Murphy', 42.3477783203125, 0.739108162594127, -123.332221984863, -2.1525533474364, 218, 43, 'PPL', 'P'),
(202411, 'Murphy', 44.0444412231445, 0.768720516544991, -103.126670837402, -1.79989995273309, 218, 49, 'PPL', 'P'),
(137024, 'Murphy City', 47.5097198486328, 0.829201038058745, -91.3244400024414, -1.59391216558262, 218, 28, 'PPL', 'P'),
(128217, 'Murphy Corner', 44.040828704834, 0.768657466206183, -70.23388671875, -1.2258125697149, 218, 26, 'PPL', 'P'),
(175442, 'Murphy Corner', 44.3863906860352, 0.774688660547858, -88.334716796875, -1.54173165192221, 218, 57, 'PPL', 'P'),
(4464, 'Murphy Cross Roads', 34.9819412231445, 0.610550053083004, -87.898063659668, -1.53411061698878, 218, 2, 'PPL', 'P'),
(23278, 'Murphy Estates', 33.9352798461914, 0.592282365901715, -84.041389465332, -1.46679895412092, 218, 13, 'PPL', 'P'),
(37339, 'Murphy Ford', 37.1472206115723, 0.648341307636638, -87.6500015258789, -1.52978111600464, 218, 21, 'PPL', 'P'),
(23279, 'Murphy Hills', 33.6425018310547, 0.587172425560125, -83.8647232055664, -1.46371554621083, 218, 13, 'PPL', 'P'),
(89296, 'Murphy Hills', 36.0644416809082, 0.629443250225326, -83.9199981689453, -1.46468027631571, 218, 50, 'PPL', 'P'),
(195363, 'Murphy Hot Springs', 42.0302810668945, 0.733566790155945, -115.368057250977, -2.01355245065886, 218, 17, 'PPL', 'P'),
(23280, 'Murphy Junction', 34.8847198486328, 0.608853219994461, -84.3083267211914, -1.47145788813191, 218, 13, 'PPL', 'P'),
(67083, 'Murphy Junction', 35.5961112976074, 0.621269343049601, -82.5780563354492, -1.44125897295095, 218, 33, 'PPL', 'P'),
(89297, 'Murphy Mill', 36.4844398498535, 0.636773601125769, -83.5480575561523, -1.45818868800059, 218, 50, 'PPL', 'P'),
(23281, 'Murphy Mobile Home Park', 33.4797210693359, 0.584331365309229, -82.1122207641602, -1.43312860845905, 218, 13, 'PPL', 'P'),
(189083, 'Murphy Place', 33.0416717529297, 0.576685962451829, -107.789436340332, -1.88128056300762, 218, 38, 'PPL', 'P'),
(193811, 'Murphy Place', 40.2933311462402, 0.703251295098273, -123.220283508301, -2.15059965246072, 218, 6, 'PPL', 'P'),
(37340, 'Murphyfork', 37.829719543457, 0.660253161139371, -83.4191665649414, -1.4559391158278, 218, 21, 'PPL', 'P'),
(156661, 'Murphys', 41.0833282470703, 0.717039345588967, -83.726936340332, -1.46131071174649, 218, 41, 'PPL', 'P'),
(183523, 'Murphys', 38.1375007629395, 0.665624956795143, -120.458610534668, -2.10239936620748, 218, 6, 'PPL', 'P'),
(10714, 'Murphys Corner', 35.6080589294434, 0.621477868562954, -91.1847229003906, -1.59147364213049, 218, 4, 'PPL', 'P'),
(104534, 'Murphys Corner', 39.1061096191406, 0.68253037049983, -77.8247222900391, -1.3582976434114, 218, 53, 'PPL', 'P'),
(128214, 'Murphys Corner', 43.9266700744629, 0.76666502223664, -69.7344436645508, -1.21709564399291, 218, 26, 'PPL', 'P'),
(208204, 'Murphys Corner', 47.8783302307129, 0.835634502883076, -122.205558776855, -2.13288936489558, 218, 56, 'PPL', 'P'),
(82533, 'Murphys Estates', 33.6011085510254, 0.586449976535414, -81.9444427490234, -1.43020032968245, 218, 48, 'PPL', 'P'),
(197118, 'Murphys Trailer Court', 45.8916702270508, 0.80096074470149, -111.550827026367, -1.94692921493278, 218, 31, 'PPL', 'P'),
(27993, 'Murphysboro', 37.7644386291504, 0.659113794246008, -89.3349990844727, -1.55918987129017, 218, 18, 'PPL', 'P'),
(37341, 'Murphysville', 38.5680618286133, 0.673139665022047, -83.8658294677734, -1.46373485412873, 218, 21, 'PPL', 'P'),
(67085, 'Murphytown', 34.6749992370605, 0.605192904813228, -78.3536071777344, -1.36752842606573, 218, 33, 'PPL', 'P'),
(110589, 'Murphytown', 39.2338905334473, 0.684760568175689, -81.4436111450195, -1.42145916919454, 218, 58, 'PPL', 'P'),
(23282, 'Murphyville', 33.9316711425781, 0.592219382141935, -84.0422210693359, -1.46681346834886, 218, 13, 'PPL', 'P'),
(10715, 'Murray', 35.9300003051758, 0.627096805567885, -93.3116683959961, -1.62859584403927, 218, 4, 'PPL', 'P'),
(37342, 'Murray', 36.610279083252, 0.638969910076758, -88.3147201538086, -1.54138264466135, 218, 21, 'PPL', 'P'),
(82534, 'Murray', 33.9533309936523, 0.592597417858671, -81.4169387817383, -1.42099364863599, 218, 48, 'PPL', 'P'),
(96416, 'Murray', 33.0563888549805, 0.576942824338967, -98.8947219848633, -1.72603851148029, 218, 51, 'PPL', 'P'),
(110590, 'Murray', 38.8955612182617, 0.678855607669684, -81.6402816772461, -1.42489171752354, 218, 58, 'PPL', 'P'),
(113759, 'Murray', 41.1944389343262, 0.718978592915736, -73.2861099243164, -1.27908391415781, 218, 8, 'PPL', 'P'),
(116970, 'Murray', 41.0416717529297, 0.716312302611376, -93.9491729736328, -1.63972239791556, 218, 16, 'PPL', 'P'),
(123267, 'Murray', 40.7919387817383, 0.711953640013298, -85.2008285522461, -1.48703498366389, 218, 19, 'PPL', 'P'),
(137025, 'Murray', 47.8161087036133, 0.834548532369569, -92.1802825927734, -1.60884943666271, 218, 28, 'PPL', 'P'),
(140551, 'Murray', 47.4258308410645, 0.827736898670446, -97.2758331298828, -1.69778357073704, 218, 34, 'PPL', 'P'),
(142464, 'Murray', 40.9152793884277, 0.714106339701436, -95.9300003051758, -1.67429435676448, 218, 35, 'PPL', 'P'),
(150945, 'Murray', 43.2738914489746, 0.755271885935227, -78.0461120605469, -1.362161623837, 218, 40, 'PPL', 'P'),
(164975, 'Murray', 41.4719390869141, 0.723821884253181, -76.3441696166992, -1.33245712451242, 218, 45, 'PPL', 'P'),
(183524, 'Murray', 36.0941696166992, 0.629962100584701, -120.002502441406, -2.09443877823507, 218, 6, 'PPL', 'P'),
(195364, 'Murray', 47.6272201538086, 0.83125180525616, -115.857498168945, -2.0220948061714, 218, 17, 'PPL', 'P'),
(205060, 'Murray', 40.6669387817383, 0.709771978448305, -111.887222290039, -1.95280041987197, 218, 52, 'PPL', 'P'),
(82535, 'Murray (historical)', 34.4119415283203, 0.600601681672959, -82.3744430541992, -1.43770525079235, 218, 48, 'PPL', 'P'),
(73612, 'Murray City', 39.5113906860352, 0.689603859513135, -82.1636123657227, -1.43402556111419, 218, 41, 'PPL', 'P'),
(205062, 'Murray Condominium', 40.6305618286133, 0.70913708084443, -111.873611450195, -1.95256286590274, 218, 52, 'PPL', 'P'),
(14279, 'Murray Estates', 38.561939239502, 0.673032805683307, -75.0780563354492, -1.31035927905138, 218, 10, 'PPL', 'P'),
(89298, 'Murray Estates', 36.0299987792969, 0.628842108188268, -86.8513870239258, -1.51584266349138, 218, 50, 'PPL', 'P'),
(82537, 'Murray Forest', 34.0180587768555, 0.593727130793083, -81.2458267211914, -1.41800717978958, 218, 48, 'PPL', 'P'),
(33378, 'Murray Gill', 37.5930595397949, 0.656122664867686, -97.4069366455078, -1.70007175874563, 218, 20, 'PPL', 'P'),
(71152, 'Murray Grove', 39.8569412231445, 0.695634854117728, -74.1780624389648, -1.29465142230987, 218, 37, 'PPL', 'P'),
(17222, 'Murray Hill', 30.312219619751, 0.529048035952278, -81.7102813720703, -1.42611344267362, 218, 12, 'PPL', 'P'),
(23288, 'Murray Hill', 32.9594383239746, 0.575250718361358, -81.7169418334961, -1.4262296896552, 218, 13, 'PPL', 'P'),
(37343, 'Murray Hill', 38.2902793884277, 0.668291446836585, -85.5883331298828, -1.4937982144102, 218, 21, 'PPL', 'P'),
(49726, 'Murray Hill', 39.1458282470703, 0.683223591331577, -76.8758316040039, -1.34173637669858, 218, 25, 'PPL', 'P'),
(144177, 'Murray Hill', 43.5422210693359, 0.759955121291158, -71.7958297729492, -1.25307361873934, 218, 36, 'PPL', 'P'),
(145854, 'Murray Hill', 40.6952781677246, 0.71026659404176, -74.4013900756836, -1.29854922488131, 218, 37, 'PPL', 'P'),
(150946, 'Murray Hill', 40.9988899230957, 0.715565618820745, -73.7877807617188, -1.28783972203172, 218, 40, 'PPL', 'P'),
(23285, 'Murray Hills', 33.4850006103516, 0.584423510682946, -82.0486068725586, -1.4320183366006, 218, 13, 'PPL', 'P'),
(89299, 'Murray Hills', 35.0930595397949, 0.612489433567827, -85.2033309936523, -1.48707865950577, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(42217, 'Murray Junction', 31.8958301544189, 0.556687253851502, -92.4877777099609, -1.61421623889144, 218, 22, 'PPL', 'P'),
(89302, 'Murray Lake Estates', 35.2236099243164, 0.614767967617472, -86.1319427490234, -1.50328599210972, 218, 50, 'PPL', 'P'),
(82536, 'Murray Landing', 32.8338890075684, 0.573059469416441, -79.9875030517578, -1.39604528870219, 218, 48, 'PPL', 'P'),
(89300, 'Murray Lane Estates', 36.0144386291504, 0.628570532336107, -86.8399963378906, -1.51564385851601, 218, 50, 'PPL', 'P'),
(183525, 'Murray Park', 37.9444389343262, 0.66225539222592, -122.55249786377, -2.1389445942661, 218, 6, 'PPL', 'P'),
(187098, 'Murray Place', 37.5161094665527, 0.654779632729959, -102.996673583984, -1.7976310726424, 218, 7, 'PPL', 'P'),
(197119, 'Murray Place', 47.8066711425781, 0.834383815856148, -107.065277099609, -1.86864159994827, 218, 31, 'PPL', 'P'),
(89301, 'Murray Store', 35.6169395446777, 0.621632864538397, -84.6241683959961, -1.47697036527226, 218, 50, 'PPL', 'P'),
(67087, 'Murray Town', 34.6055603027344, 0.603980966780161, -77.8938903808594, -1.35950485433354, 218, 33, 'PPL', 'P'),
(197120, 'Murray Trailer Park', 48.3499984741211, 0.843866666707647, -107.870826721191, -1.88270109313307, 218, 31, 'PPL', 'P'),
(104535, 'Murrayfield', 36.7238883972168, 0.640952766666376, -81.6902770996094, -1.42576430225471, 218, 53, 'PPL', 'P'),
(14274, 'Murrays Corner', 38.7519416809082, 0.676348973872674, -75.1505584716797, -1.31162468004333, 218, 10, 'PPL', 'P'),
(150949, 'Murrays Corner', 42.9986114501953, 0.750467343591642, -78.477783203125, -1.36969570656083, 218, 40, 'PPL', 'P'),
(23286, 'Murrays Crossroads', 32.3208312988281, 0.564104923146186, -84.2944412231445, -1.47121554047271, 218, 13, 'PPL', 'P'),
(14275, 'Murrays Development', 38.6972198486328, 0.675393897726744, -75.383056640625, -1.31568253859628, 218, 10, 'PPL', 'P'),
(14276, 'Murrays Haven', 38.5483283996582, 0.672795251714072, -75.1022186279297, -1.31078099060999, 218, 10, 'PPL', 'P'),
(67088, 'Murrays Hill', 35.6772193908691, 0.622684946327032, -81.095832824707, -1.41538929243803, 218, 33, 'PPL', 'P'),
(67089, 'Murraysville', 34.2955589294434, 0.598570422130528, -77.8477783203125, -1.35870004705211, 218, 33, 'PPL', 'P'),
(82538, 'Murraysville', 33.1811103820801, 0.579119625634971, -80.1016693115234, -1.39803786582978, 218, 48, 'PPL', 'P'),
(110591, 'Murraysville', 39.0774993896484, 0.68203102779544, -81.8066711425781, -1.42779576153422, 218, 58, 'PPL', 'P'),
(67090, 'Murraytown', 35.8363914489746, 0.625463022818148, -78.2397232055664, -1.36554077578615, 218, 33, 'PPL', 'P'),
(23287, 'Murrayville', 34.4186096191406, 0.600718061812595, -83.9058303833008, -1.46443300180849, 218, 13, 'PPL', 'P'),
(27995, 'Murrayville', 39.5855598449707, 0.690898355539995, -90.2519378662109, -1.57519347207073, 218, 18, 'PPL', 'P'),
(164979, 'Murrell', 40.1686096191406, 0.701074493802269, -76.1675033569336, -1.32937371660233, 218, 45, 'PPL', 'P'),
(82539, 'Murrell (historical)', 33.4261093139648, 0.58339566366023, -80.0305633544922, -1.39679683276181, 218, 48, 'PPL', 'P'),
(82540, 'Murrells Inlet', 33.5508308410645, 0.585572464956233, -79.0416717529297, -1.37953741836922, 218, 48, 'PPL', 'P'),
(89303, 'Murrelltown', 36.4813919067383, 0.636720404482995, -83.1277770996094, -1.45085341025213, 218, 50, 'PPL', 'P'),
(183527, 'Murrieta', 33.5538902282715, 0.585625861336089, -117.21305847168, -2.04575379666344, 218, 6, 'PPL', 'P'),
(183528, 'Murrieta Hot Springs', 33.5605583190918, 0.585742241475726, -117.157218933105, -2.04477921286253, 218, 6, 'PPL', 'P'),
(164976, 'Murrinsville', 41.1433296203613, 0.718086567108614, -79.8841705322266, -1.39424179601198, 218, 45, 'PPL', 'P'),
(56436, 'Murry', 39.042781829834, 0.68142509206842, -92.1766662597656, -1.60878631974488, 218, 29, 'PPL', 'P'),
(175443, 'Murry', 45.6005592346191, 0.795879899394809, -91.2005615234375, -1.59175007825164, 218, 57, 'PPL', 'P'),
(164977, 'Murry Hill', 40.2755584716797, 0.702941103410306, -80.1575012207031, -1.39901231647264, 218, 45, 'PPL', 'P'),
(14277, 'Murry Landing', 38.5705604553223, 0.673183274284897, -75.0933303833008, -1.31062586147649, 218, 10, 'PPL', 'P'),
(76671, 'Murry Spur', 35.2597198486328, 0.615398204689439, -94.5483322143555, -1.65017969940992, 218, 42, 'PPL', 'P'),
(4465, 'Murrycross', 34.1205596923828, 0.595516109255344, -85.8586120605469, -1.49851547164906, 218, 2, 'PPL', 'P'),
(164978, 'Murrysville', 40.4283294677734, 0.705607460293693, -79.6977767944336, -1.3909886115824, 218, 45, 'PPL', 'P'),
(10717, 'Murta', 36.1133308410645, 0.630296527038588, -90.8936080932617, -1.58639273024478, 218, 4, 'PPL', 'P'),
(137028, 'Murtaugh', 43.5999984741211, 0.760963527237917, -93.3280563354492, -1.62888186754034, 218, 28, 'PPL', 'P'),
(195365, 'Murtaugh', 42.4925003051758, 0.741634037730013, -114.161392211914, -1.99249217275851, 218, 17, 'PPL', 'P'),
(4466, 'Muscadine', 33.7344398498535, 0.588777046695925, -85.3861083984375, -1.49026872701752, 218, 2, 'PPL', 'P'),
(183529, 'Muscatel', 36.792781829834, 0.642155183898547, -119.858329772949, -2.09192249047911, 218, 6, 'PPL', 'P'),
(116971, 'Muscatine', 41.4244384765625, 0.722992842205839, -91.0430603027344, -1.58900116337446, 218, 16, 'PPL', 'P'),
(125499, 'Muschopauge', 42.3974990844727, 0.739975953635329, -71.9208297729492, -1.25525528030433, 218, 23, 'PPL', 'P'),
(4467, 'Muscle Shoals', 34.7447204589844, 0.606409769694313, -87.6675033569336, -1.53008658058167, 218, 2, 'PPL', 'P'),
(183530, 'Muscle Shoals', 34.3563919067383, 0.599632157878116, -119.441673278809, -2.08465046280654, 218, 6, 'PPL', 'P'),
(197121, 'Muscleshell City (historical)', 47.4555587768555, 0.828255749029821, -107.913887023926, -1.88345263719269, 218, 31, 'PPL', 'P'),
(4468, 'Muscoda', 33.3794403076172, 0.582581135840829, -86.9397201538086, -1.51738436744643, 218, 2, 'PPL', 'P'),
(175445, 'Muscoda', 43.185001373291, 0.753720461442201, -90.4430618286133, -1.57852921449411, 218, 57, 'PPL', 'P'),
(17221, 'Muscogee', 30.6055603027344, 0.534167796700387, -87.3966674804688, -1.52535960280484, 218, 12, 'PPL', 'P'),
(23289, 'Muscogee', 32.4513893127441, 0.566383590353885, -84.9516677856445, -1.4826863079199, 218, 13, 'PPL', 'P'),
(23291, 'Muscogee Manor', 32.4952812194824, 0.567149648641446, -84.8661117553711, -1.48119307349669, 218, 13, 'PPL', 'P'),
(128216, 'Muscongus', 43.9694404602051, 0.767411506290189, -69.4438934326172, -1.21202458580324, 218, 26, 'PPL', 'P'),
(33377, 'Muscotah', 39.5527801513672, 0.690326241958819, -95.5213928222656, -1.66716281083941, 218, 20, 'PPL', 'P'),
(183531, 'Muscoy', 34.1541709899902, 0.596102737064461, -117.343330383301, -2.0480274704441, 218, 6, 'PPL', 'P'),
(76667, 'Muse', 34.6719398498535, 0.605139508433372, -94.7624969482422, -1.6539175791579, 218, 42, 'PPL', 'P'),
(104537, 'Muse', 37.2933311462402, 0.650891417538443, -79.852783203125, -1.39369398377576, 218, 53, 'PPL', 'P'),
(164983, 'Muse', 40.292781829834, 0.703241707718349, -80.2005615234375, -1.39976386053226, 218, 45, 'PPL', 'P'),
(42218, 'Muse (historical)', 31.2216701507568, 0.544920942102341, -92.7972183227539, -1.61961699642407, 218, 22, 'PPL', 'P'),
(164980, 'Muse Junction', 40.313060760498, 0.70359564182722, -80.195556640625, -1.39967650884851, 218, 45, 'PPL', 'P'),
(23292, 'Musella', 32.797779083252, 0.572429232344474, -84.0322189331055, -1.46663889813941, 218, 13, 'PPL', 'P'),
(164981, 'Musellmans Crossing', 41.0911102294922, 0.717175166804561, -77.9191665649414, -1.35994600696811, 218, 45, 'PPL', 'P'),
(37344, 'Muses Mills', 38.3499984741211, 0.669333741508214, -83.5272216796875, -1.45782503335374, 218, 21, 'PPL', 'P'),
(73614, 'Museville', 39.7886085510254, 0.694442224002563, -81.7983322143555, -1.42765021978065, 218, 41, 'PPL', 'P'),
(104536, 'Museville', 36.9122200012207, 0.644239773241807, -79.591667175293, -1.38913664936036, 218, 53, 'PPL', 'P'),
(67091, 'Musgrave Crossroads', 35.4833297729492, 0.619300934108896, -77.8783264160156, -1.35923321190235, 218, 33, 'PPL', 'P'),
(96417, 'Musgrove', 32.9552803039551, 0.575178147221654, -95.2275009155273, -1.66203342942187, 218, 51, 'PPL', 'P'),
(4469, 'Musgrove (historical)', 34.5130615234375, 0.602366558527354, -85.8255615234375, -1.49793863095694, 218, 2, 'PPL', 'P'),
(23293, 'Musgrove (historical)', 32.4169387817383, 0.565782315158772, -83.0899963378906, -1.45019401156622, 218, 13, 'PPL', 'P'),
(49725, 'Musgrove Estates', 38.6441688537598, 0.674467983194751, -76.6258316040039, -1.3373730535686, 218, 25, 'PPL', 'P'),
(208205, 'Mushroom Corner', 47.0469398498535, 0.821124003367671, -122.763610839844, -2.14262921079227, 218, 56, 'PPL', 'P'),
(164982, 'Mushroom Farms', 41.146671295166, 0.718144890336487, -75.3547210693359, -1.31518798958185, 218, 45, 'PPL', 'P'),
(37345, 'Music', 38.3080596923828, 0.668601771682606, -82.8241729736328, -1.4455545186312, 218, 21, 'PPL', 'P'),
(89304, 'Music (historical)', 35.7763900756836, 0.624415801298502, -85.0633316040039, -1.48463520920562, 218, 50, 'PPL', 'P'),
(89305, 'Music Acres', 36.2583312988281, 0.632827262443463, -83.2455596923828, -1.45290910429756, 218, 50, 'PPL', 'P'),
(110592, 'Musick', 37.6549987792969, 0.657203708533176, -82.0749969482422, -1.43247893031112, 218, 58, 'PPL', 'P'),
(183533, 'Musick (historical)', 35.2077789306641, 0.614491664654376, -120.399169921875, -2.10136193180484, 218, 6, 'PPL', 'P'),
(56437, 'Musicks Ferry', 38.8613891601563, 0.678259192743561, -90.3383331298828, -1.57670135387993, 218, 29, 'PPL', 'P'),
(183534, 'Musk (historical)', 36.3280601501465, 0.634044260482602, -119.150001525879, -2.07955983038285, 218, 6, 'PPL', 'P'),
(212008, 'Musk Ox', 64.9002838134766, 1.13272363802395, -147.822494506836, -2.57998923765552, 218, 1, 'PPL', 'P'),
(60997, 'Muskedine', 33.2244415283203, 0.579875896805526, -90.9836120605469, -1.58796359581377, 218, 30, 'PPL', 'P'),
(175448, 'Muskeg', 46.5705604553223, 0.812809614444443, -91.4905624389648, -1.59681154906139, 218, 57, 'PPL', 'P'),
(175449, 'Muskego', 42.9058303833008, 0.748848008490819, -88.1388931274414, -1.53831388413725, 218, 57, 'PPL', 'P'),
(60998, 'Muskegon', 32.3480606079102, 0.564580164242711, -89.3522186279297, -1.55949040901918, 218, 30, 'PPL', 'P'),
(132214, 'Muskegon', 43.2341690063477, 0.754578598524452, -86.2483291625977, -1.50531731823117, 218, 27, 'PPL', 'P'),
(132216, 'Muskegon Heights', 43.2011108398438, 0.754001624674286, -86.2388916015625, -1.50515260171775, 218, 27, 'PPL', 'P'),
(23294, 'Musket Ridge', 33.9372215270996, 0.592316254626586, -84.790283203125, -1.47986961559298, 218, 13, 'PPL', 'P'),
(73617, 'Muskingum (historical)', 39.8933296203613, 0.696269951458685, -82.022216796875, -1.43155774289007, 218, 41, 'PPL', 'P'),
(137029, 'Muskoda', 46.8616714477539, 0.817890459751124, -96.4063873291016, -1.68260887884576, 218, 28, 'PPL', 'P'),
(76669, 'Muskogee', 35.7477798461914, 0.623916458594112, -95.3694381713867, -1.66451070186786, 218, 42, 'PPL', 'P'),
(212009, 'Muskwa Village', 60.4033317565918, 1.05423701832698, -149.359176635742, -2.60680940036149, 218, 1, 'PPL', 'P'),
(123268, 'Musquabuck Park', 41.3686103820801, 0.722018458142007, -85.7813873291016, -1.49716764582137, 218, 19, 'PPL', 'P'),
(49731, 'Mussel Shoals', 39.2402801513672, 0.684872088046336, -75.9194412231445, -1.32504421561818, 218, 25, 'PPL', 'P'),
(56439, 'Musselfork', 39.5513916015625, 0.690302007192899, -92.8752822875977, -1.62097946963775, 218, 29, 'PPL', 'P'),
(73620, 'Musselman', 39.3680610656738, 0.687102285722196, -83.1425018310547, -1.45111040529732, 218, 41, 'PPL', 'P'),
(164985, 'Musselman Grove', 40.2902793884277, 0.703198031876471, -78.5052795410156, -1.37017560818927, 218, 45, 'PPL', 'P'),
(195366, 'Musselshell', 46.3572196960449, 0.809086115766349, -115.742782592773, -2.02009264166388, 218, 17, 'PPL', 'P'),
(197123, 'Musselshell', 46.5186080932617, 0.811902874672298, -108.090560913086, -1.88653617826084, 218, 31, 'PPL', 'P'),
(23301, 'Musselwhite', 31.9500007629395, 0.557632709327994, -83.6988906860352, -1.46082122273813, 218, 13, 'PPL', 'P'),
(104541, 'Musser', 36.9238891601563, 0.64444343848617, -81.2747192382813, -1.41851144934199, 218, 53, 'PPL', 'P'),
(164984, 'Musser', 40.7261085510254, 0.71080468574001, -77.9847183227539, -1.36109010097241, 218, 45, 'PPL', 'P'),
(183535, 'Mussey Grove (historical)', 32.9277801513672, 0.574698179014194, -116.905563354492, -2.04038699443472, 218, 6, 'PPL', 'P'),
(42219, 'Musson', 30.4391708374023, 0.53126375268971, -91.519172668457, -1.59731089176578, 218, 22, 'PPL', 'P'),
(76672, 'Mustang', 35.3841705322266, 0.617570278874508, -97.7241668701172, -1.70560847065191, 218, 42, 'PPL', 'P'),
(96421, 'Mustang', 32.0133285522461, 0.558737987759404, -96.4291687011719, -1.68300648879651, 218, 51, 'PPL', 'P'),
(190527, 'Mustang', 39.5219383239746, 0.689787950523486, -119.627502441406, -2.08789379354009, 218, 39, 'PPL', 'P'),
(110593, 'Mustang Acres', 39.2813911437988, 0.685589610223031, -81.4819412231445, -1.42212815526037, 218, 58, 'PPL', 'P'),
(96422, 'Mustang Beach', 27.8033294677734, 0.485259642229409, -97.0905609130859, -1.69454996054146, 218, 51, 'PPL', 'P'),
(190528, 'Mustang Ranch', 39.5108299255371, 0.689594072396129, -119.632217407227, -2.08797608521778, 218, 39, 'PPL', 'P'),
(96423, 'Mustang Ridge', 30.0566692352295, 0.524587840337641, -97.6908264160156, -1.70502656995372, 218, 51, 'PPL', 'P'),
(164986, 'Mustard', 40.2350006103516, 0.702233235192563, -79.8188934326172, -1.39310249569765, 218, 45, 'PPL', 'P'),
(104539, 'Mustoe', 38.3086090087891, 0.66861135906253, -77.2799987792969, -1.34879042463593, 218, 53, 'PPL', 'P'),
(104540, 'Mutt', 37.1897201538086, 0.649083064579252, -78.1722183227539, -1.3643625933199, 218, 53, 'PPL', 'P'),
(67092, 'Muttenz (historical)', 35.8847198486328, 0.626306512514404, -81.6999969482422, -1.42593394561615, 218, 33, 'PPL', 'P'),
(205072, 'Mutton Hollow Acres', 41.0583305358887, 0.716603053223385, -111.91056060791, -1.9532077503607, 218, 52, 'PPL', 'P'),
(104542, 'Mutton Hunk', 37.7838897705078, 0.659453280705966, -75.5999984741211, -1.3194688878761, 218, 53, 'PPL', 'P'),
(150953, 'Muttontown', 40.8238906860352, 0.71251130594556, -73.5480575561523, -1.28365576280115, 218, 40, 'PPL', 'P'),
(73621, 'Muttonville', 39.6580581665039, 0.692163689952919, -84.6858291625977, -1.47804654866876, 218, 41, 'PPL', 'P'),
(132221, 'Muttonville', 42.7963905334473, 0.746937922777987, -82.7352828979492, -1.44400309413817, 218, 27, 'PPL', 'P'),
(17223, 'Mutual', 29.7427806854248, 0.519109451659239, -82.8333282470703, -1.4457143082966, 218, 12, 'PPL', 'P'),
(49727, 'Mutual', 38.4708290100098, 0.671442632196421, -76.5483322143555, -1.33602043405094, 218, 25, 'PPL', 'P'),
(76673, 'Mutual', 36.2313919067383, 0.632357081353009, -99.1677780151367, -1.73080423825098, 218, 42, 'PPL', 'P'),
(156666, 'Mutual', 40.0786094665527, 0.699503694812313, -83.6369400024414, -1.45973997933556, 218, 41, 'PPL', 'P'),
(164989, 'Mutual', 40.2366714477539, 0.702262396806499, -79.4977798461914, -1.38749800634163, 218, 45, 'PPL', 'P'),
(49728, 'Mutual Consent', 38.4622192382813, 0.671292363331913, -76.5608291625977, -1.33623854694422, 218, 25, 'PPL', 'P'),
(205074, 'Mutual Dell', 40.4463882446289, 0.705922645408704, -111.643333435059, -1.94854375634364, 218, 52, 'PPL', 'P'),
(49729, 'Mutual Estates', 38.4861106872559, 0.671709347779592, -76.5541687011719, -1.33612229996264, 218, 25, 'PPL', 'P'),
(164988, 'Muzette', 41.4727783203125, 0.723836531639177, -79.23388671875, -1.38289220239439, 218, 45, 'PPL', 'P'),
(49730, 'My Ladies Manor', 39.4930610656738, 0.689283947287189, -76.9561080932617, -1.34313746574807, 218, 25, 'PPL', 'P'),
(49740, 'My Ladys Manor Estates', 39.5694389343262, 0.690616992570828, -76.5744400024414, -1.33647610091346, 218, 25, 'PPL', 'P'),
(17224, 'Myakka City', 27.3494396209717, 0.477337769961346, -82.1616668701172, -1.43399160581029, 218, 12, 'PPL', 'P'),
(17225, 'Myakka Head', 27.4677791595459, 0.479403184544757, -82.0758285522461, -1.43249344453907, 218, 12, 'PPL', 'P'),
(42220, 'Myatt (historical)', 32.4102783203125, 0.565666068177191, -92.1497192382813, -1.60831600549637, 218, 22, 'PPL', 'P'),
(150950, 'Mycenae', 43.0488891601563, 0.751344855170823, -75.9308319091797, -1.32524302059356, 218, 40, 'PPL', 'P'),
(37346, 'Myers', 38.350830078125, 0.669348255736155, -83.9533309936523, -1.46526204385584, 218, 21, 'PPL', 'P'),
(76674, 'Myers', 36.7533302307129, 0.641466623598707, -96.4005584716797, -1.68250714609212, 218, 42, 'PPL', 'P'),
(82544, 'Myers', 32.8166694641113, 0.572758931687426, -79.9505615234375, -1.39540053740228, 218, 48, 'PPL', 'P'),
(89306, 'Myers', 35.2136116027832, 0.614593463987045, -86.1333312988281, -1.50331022687563, 218, 50, 'PPL', 'P'),
(150951, 'Myers', 42.5394401550293, 0.742453292660348, -76.5397186279297, -1.33587009860741, 218, 40, 'PPL', 'P'),
(156663, 'Myers', 40.771110534668, 0.711590118524502, -81.1327819824219, -1.41603417689599, 218, 41, 'PPL', 'P'),
(189084, 'Myers', 35.439998626709, 0.618544662938341, -105.213333129883, -1.83631908011409, 218, 38, 'PPL', 'P'),
(195367, 'Myers', 42.6088905334473, 0.743665430430498, -113.753890991211, -1.98537993475135, 218, 17, 'PPL', 'P'),
(197124, 'Myers', 46.2508316040039, 0.807229293275318, -107.339721679688, -1.87343156148489, 218, 31, 'PPL', 'P'),
(208206, 'Myers', 46.7216682434082, 0.815446942871949, -118.760833740234, -2.07276757118066, 218, 56, 'PPL', 'P'),
(82543, 'Myers (historical)', 32.5416717529297, 0.567959316191858, -81.2541732788086, -1.41815285470121, 218, 48, 'PPL', 'P'),
(110594, 'Myers (historical)', 39.5102806091309, 0.689584485016204, -78.154167175293, -1.36404754136294, 218, 58, 'PPL', 'P'),
(156664, 'Myers (historical)', 40.8430595397949, 0.712845865557501, -82.6230621337891, -1.44204447231447, 218, 41, 'PPL', 'P'),
(49732, 'Myers Acres', 39.5858306884766, 0.69090308265093, -77.0738906860352, -1.3451931597935, 218, 25, 'PPL', 'P'),
(150952, 'Myers Corner', 41.6061096191406, 0.726163601799688, -73.8733291625977, -1.28933282329687, 218, 40, 'PPL', 'P'),
(156665, 'Myers Corners', 40.2902793884277, 0.703198031876471, -82.6311111450195, -1.44218495406197, 218, 41, 'PPL', 'P'),
(49733, 'Myers Estates', 39.1355590820313, 0.683044360590215, -76.654167175293, -1.33786760258302, 218, 25, 'PPL', 'P'),
(193812, 'Myers Flat', 40.2663917541504, 0.702781114007819, -123.869171142578, -2.16192487815433, 218, 6, 'PPL', 'P'),
(150954, 'Myers Grove', 41.4463882446289, 0.723375937928647, -74.601936340332, -1.302049417502, 218, 40, 'PPL', 'P'),
(164990, 'Myersbrook', 40.0722198486328, 0.699392174941666, -79.2911071777344, -1.38389088780317, 218, 45, 'PPL', 'P'),
(164991, 'Myersburg', 41.7969398498535, 0.729494217637968, -76.3794403076172, -1.33307271419839, 218, 45, 'PPL', 'P'),
(49734, 'Myersdale', 39.7033309936523, 0.692953849848345, -78.1911087036133, -1.36469229266285, 218, 25, 'PPL', 'P'),
(164993, 'Myerstown', 40.374439239502, 0.704666898375705, -76.3030624389648, -1.33173966891475, 218, 45, 'PPL', 'P'),
(10718, 'Myersville', 35.8849983215332, 0.626311372783393, -91.876106262207, -1.60354055818769, 218, 4, 'PPL', 'P'),
(49735, 'Myersville', 39.5050010681152, 0.689492339642488, -77.5666732788086, -1.35379383853392, 218, 25, 'PPL', 'P'),
(156667, 'Myersville', 40.9761085510254, 0.715168008869996, -81.4238891601563, -1.42111495562365, 218, 41, 'PPL', 'P'),
(202414, 'Myersville', 44.103328704834, 0.769748296988679, -103.738609313965, -1.81058029396874, 218, 49, 'PPL', 'P'),
(120729, 'Myersville (historical)', 40.2658309936523, 0.702771326890813, -87.6405563354492, -1.52961626633316, 218, 18, 'PPL', 'P'),
(209629, 'Myersville (historical)', 42.5633316040039, 0.742870277108027, -108.105560302734, -1.88679796699599, 218, 59, 'PPL', 'P'),
(183536, 'Myford', 33.7286109924316, 0.588675313942284, -117.780563354492, -2.05565862538967, 218, 6, 'PPL', 'P'),
(96424, 'Mykawa', 29.6205596923828, 0.516976292915599, -95.304443359375, -1.66337632840154, 218, 51, 'PPL', 'P'),
(60999, 'Myles', 32.019718170166, 0.558849507630051, -90.7063903808594, -1.58312516474531, 218, 30, 'PPL', 'P'),
(82545, 'Mylintee Estates', 34.6488914489746, 0.604737237950716, -82.8930587768555, -1.44675680270531, 218, 48, 'PPL', 'P'),
(120730, 'Mylith Park', 42.2641716003418, 0.737648950053845, -88.1916732788086, -1.53923507155831, 218, 18, 'PPL', 'P'),
(140552, 'Mylo', 48.6352806091309, 0.848845779260687, -99.6183319091797, -1.73866788715971, 218, 34, 'PPL', 'P'),
(164995, 'Mylo Park', 40.4799995422363, 0.706509273217821, -78.7427825927734, -1.37432081842597, 218, 45, 'PPL', 'P'),
(142465, 'Mynard', 40.9736099243164, 0.715124399607146, -95.9236068725586, -1.67418277031481, 218, 35, 'PPL', 'P'),
(89307, 'Mynatt', 36.1066703796387, 0.630180280057006, -83.8880615234375, -1.46412287669955, 218, 50, 'PPL', 'P'),
(189085, 'Myndus', 32.2599983215332, 0.563043187398599, -107.456672668457, -1.87547274130238, 218, 38, 'PPL', 'P'),
(4470, 'Mynot', 34.6455612182617, 0.604679114459925, -88.0505599975586, -1.53677218018221, 218, 2, 'PPL', 'P'),
(164996, 'Myobeach', 41.6019401550293, 0.726090830922902, -76.0819396972656, -1.32788034902106, 218, 45, 'PPL', 'P'),
(164997, 'Myoma', 40.7299995422363, 0.710872596347807, -80.0258331298828, -1.39671427476801, 218, 45, 'PPL', 'P'),
(183537, 'Myoma', 33.7513885498047, 0.589072857314006, -116.277496337891, -2.02942515707184, 218, 6, 'PPL', 'P'),
(37347, 'Myra', 37.2897186279297, 0.650828367199635, -82.5999984741211, -1.44164193551571, 218, 21, 'PPL', 'P'),
(96425, 'Myra', 33.6238899230957, 0.586847586486163, -97.3141708374023, -1.69845268996092, 218, 51, 'PPL', 'P'),
(110595, 'Myra', 38.2213897705078, 0.667089096183441, -82.1127777099609, -1.43313832899703, 218, 58, 'PPL', 'P'),
(128218, 'Myra', 44.980281829834, 0.785054016405583, -68.3969421386719, -1.19375183861588, 218, 26, 'PPL', 'P'),
(140554, 'Myra', 46.8536109924316, 0.81774977826654, -97.3197174072266, -1.69854949586654, 218, 34, 'PPL', 'P'),
(175451, 'Myra', 43.415828704834, 0.757749158381218, -88.0955581665039, -1.53755754638767, 218, 57, 'PPL', 'P'),
(112281, 'Myrdell Estates', 34.0913887023926, 0.595006979433948, -83.9511108398438, -1.46522329486198, 218, 13, 'PPL', 'P'),
(132222, 'Myren', 46.4261093139648, 0.810288466419492, -86.4272232055664, -1.50843960829318, 218, 27, 'PPL', 'P'),
(56441, 'Myrick', 39.1755599975586, 0.683742508269979, -93.9027786254883, -1.63891266378613, 218, 29, 'PPL', 'P'),
(61003, 'Myrick', 31.6608295440674, 0.552585719456671, -88.9941711425781, -1.55324130152131, 218, 30, 'PPL', 'P'),
(113074, 'Myricks', 41.8305587768555, 0.73008097860514, -71.0277786254883, -1.23966859739242, 218, 23, 'PPL', 'P'),
(183538, 'Myricks Corner', 35.5163917541504, 0.619877974538089, -119.290000915527, -2.082003280683, 218, 6, 'PPL', 'P'),
(23295, 'Myricks Mill', 32.7841682434082, 0.572191678375239, -83.3766708374023, -1.45519742546421, 218, 13, 'PPL', 'P'),
(61000, 'Myrleville', 32.7130584716797, 0.570950578728235, -90.2774963378906, -1.57563955155331, 218, 30, 'PPL', 'P'),
(10719, 'Myron', 36.1836090087891, 0.631523112457651, -91.7055587768555, -1.60056394303731, 218, 4, 'PPL', 'P'),
(17226, 'Myrtis', 30.0652809143066, 0.524738142491662, -82.6002807617188, -1.44164686236372, 218, 12, 'PPL', 'P'),
(42222, 'Myrtis', 32.9247207641602, 0.574644782634338, -93.9913864135742, -1.64045916143113, 218, 22, 'PPL', 'P'),
(10720, 'Myrtle', 36.3613891601563, 0.634625961443702, -93.0844421386719, -1.62462999770198, 218, 4, 'PPL', 'P'),
(23296, 'Myrtle', 32.4872207641602, 0.567008967156863, -83.815559387207, -1.4628574757076, 218, 13, 'PPL', 'P'),
(56442, 'Myrtle', 36.5086097717285, 0.637195445842438, -91.2669372558594, -1.59290855332582, 218, 29, 'PPL', 'P'),
(61001, 'Myrtle', 34.5583305358887, 0.603156651843754, -89.1191711425781, -1.55542296308631, 218, 30, 'PPL', 'P'),
(96426, 'Myrtle', 29.6499996185303, 0.517490116558416, -95.4044418334961, -1.66512163102192, 218, 51, 'PPL', 'P'),
(104544, 'Myrtle', 36.7727813720703, 0.641806110058665, -76.6922225952148, -1.33853179495889, 218, 53, 'PPL', 'P'),
(110596, 'Myrtle', 37.7677803039551, 0.659172117473881, -82.1913909912109, -1.43451038959064, 218, 58, 'PPL', 'P'),
(120731, 'Myrtle', 42.1680603027344, 0.735971491462232, -89.3566665649414, -1.55956804016496, 218, 18, 'PPL', 'P'),
(137030, 'Myrtle', 43.5644416809082, 0.760342944124901, -93.163330078125, -1.62600685198555, 218, 28, 'PPL', 'P'),
(164998, 'Myrtle', 41.9816703796387, 0.732718373611673, -78.241943359375, -1.36557952478001, 218, 45, 'PPL', 'P'),
(195368, 'Myrtle', 46.496940612793, 0.811524705797507, -116.724998474121, -2.03723554275877, 218, 17, 'PPL', 'P'),
(199561, 'Myrtle (historical)', 41.3444404602051, 0.721596613425338, -100.597221374512, -1.75575273134285, 218, 35, 'PPL', 'P'),
(82547, 'Myrtle Beach', 33.6888885498047, 0.587982026531509, -78.8869400024414, -1.37683683986583, 218, 48, 'PPL', 'P'),
(113761, 'Myrtle Beach', 41.1961097717285, 0.719007754529672, -73.0769424438477, -1.27543325293553, 218, 8, 'PPL', 'P'),
(201278, 'Myrtle Creek', 43.0202789306641, 0.750845512466433, -123.291938781738, -2.15185027290862, 218, 43, 'PPL', 'P'),
(10721, 'Myrtle Grove', 33.3102798461914, 0.58137405807675, -91.271110534668, -1.59298139078164, 218, 4, 'PPL', 'P'),
(17227, 'Myrtle Grove', 30.4208297729492, 0.530943640726683, -87.307502746582, -1.52380338462185, 218, 12, 'PPL', 'P'),
(23297, 'Myrtle Grove', 31.8844394683838, 0.556488448876128, -81.2458267211914, -1.41800717978958, 218, 13, 'PPL', 'P'),
(42228, 'Myrtle Grove', 29.6372203826904, 0.517267076817122, -89.9491729736328, -1.56990922783579, 218, 22, 'PPL', 'P'),
(67094, 'Myrtle Grove', 34.1344413757324, 0.595758390335514, -77.8819427490234, -1.35929632882018, 218, 33, 'PPL', 'P'),
(82553, 'Myrtle Grove', 32.7916717529297, 0.572322639321844, -80.0516662597656, -1.39716514794056, 218, 48, 'PPL', 'P'),
(145855, 'Myrtle Grove', 41.1072196960449, 0.717456330036647, -74.7897186279297, -1.30532683669751, 218, 37, 'PPL', 'P'),
(42225, 'Myrtle Grove (historical)', 29.5791702270508, 0.516253910469915, -90.6600036621094, -1.58231556377393, 218, 22, 'PPL', 'P'),
(49736, 'Myrtle Grove Estates', 38.5499992370605, 0.672824413328009, -77.0888900756836, -1.34545494852866, 218, 25, 'PPL', 'P'),
(67095, 'Myrtle Grove Junction', 34.1399993896484, 0.59585539597822, -77.8938903808594, -1.35950485433354, 218, 33, 'PPL', 'P'),
(42226, 'Myrtle Grove Plantation', 30.291389465332, 0.528684481173969, -91.2627792358398, -1.59283598218612, 218, 22, 'PPL', 'P'),
(67096, 'Myrtle Head', 34.1425018310547, 0.595899071820097, -78.498893737793, -1.37006415489765, 218, 33, 'PPL', 'P'),
(17228, 'Myrtle Island', 29.5852794647217, 0.516360536782059, -81.4413909912109, -1.42142042020068, 218, 12, 'PPL', 'P'),
(82550, 'Myrtle Island', 32.211669921875, 0.562199697702343, -80.8649978637695, -1.41136046234096, 218, 48, 'PPL', 'P'),
(49737, 'Myrtle Point', 38.3261108398438, 0.668916823639563, -76.5013885498047, -1.33520111254158, 218, 25, 'PPL', 'P'),
(201279, 'Myrtle Point', 43.064998626709, 0.751626018402908, -124.13777923584, -2.16661297377926, 218, 43, 'PPL', 'P'),
(82551, 'Myrtle Ridge', 33.6883316040039, 0.587972305993531, -78.914436340332, -1.37731674149426, 218, 48, 'PPL', 'P'),
(67098, 'Myrtle Sound', 34.0686111450195, 0.594609436062226, -77.8863906860352, -1.35937395996596, 218, 33, 'PPL', 'P'),
(96427, 'Myrtle Springs', 32.6097183227539, 0.569146952879979, -95.9300003051758, -1.67429435676448, 218, 51, 'PPL', 'P'),
(23298, 'Myrtle Springs (historical)', 32.1258316040039, 0.560701536431119, -84.3091735839844, -1.47147266867596, 218, 13, 'PPL', 'P'),
(82552, 'Myrtle Trace', 33.7841682434082, 0.589644970895182, -78.9991683959961, -1.37879559484758, 218, 48, 'PPL', 'P'),
(193813, 'Myrtletown', 40.788890838623, 0.711900443370523, -124.129173278809, -2.16646277149378, 218, 6, 'PPL', 'P'),
(4471, 'Myrtlewood', 32.2502784729004, 0.562873544037161, -87.9497222900391, -1.53501223017583, 218, 2, 'PPL', 'P'),
(23299, 'Mystic', 31.621940612793, 0.551906979563351, -83.3358306884766, -1.45448463039845, 218, 13, 'PPL', 'P'),
(37348, 'Mystic', 37.8969383239746, 0.661426350178578, -86.4427795410156, -1.50871111756632, 218, 21, 'PPL', 'P'),
(42227, 'Mystic', 30.5741691589355, 0.533619917885131, -93.5288925170898, -1.6323871201671, 218, 22, 'PPL', 'P'),
(113760, 'Mystic', 41.3541717529297, 0.721766456523858, -71.9669418334961, -1.25606008758575, 218, 8, 'PPL', 'P'),
(116974, 'Mystic', 40.7775001525879, 0.711701638395149, -92.9436111450195, -1.62217203317389, 218, 16, 'PPL', 'P'),
(139352, 'Mystic', 40.1563911437988, 0.700861241177981, -92.9316711425781, -1.62196364081859, 218, 29, 'PPL', 'P'),
(183539, 'Mystic', 39.4375, 0.688314223755264, -120.018890380859, -2.09472480173615, 218, 6, 'PPL', 'P'),
(194338, 'Mystic', 40.5699996948242, 0.708080072207777, -106.995277404785, -1.86741987479819, 218, 7, 'PPL', 'P'),
(202415, 'Mystic', 44.0769386291504, 0.76928770327815, -103.64111328125, -1.80887866719024, 218, 49, 'PPL', 'P'),
(125501, 'Mystic Grove', 42.1819381713867, 0.736213705963374, -72.0027770996094, -1.25668553096776, 218, 23, 'PPL', 'P'),
(49738, 'Mystic Harbor', 38.3222198486328, 0.668848913031766, -75.121940612793, -1.31112520418088, 218, 25, 'PPL', 'P'),
(71154, 'Mystic Islands', 39.5441703796387, 0.690175973094311, -74.3827819824219, -1.29822445238638, 218, 37, 'PPL', 'P'),
(164999, 'Mystic Park', 41.6738891601563, 0.727346577955901, -79.7647171020508, -1.39215694035262, 218, 45, 'PPL', 'P'),
(113762, 'Mystic Seaport', 41.3611106872559, 0.721887563774429, -71.9669418334961, -1.25606008758575, 218, 8, 'PPL', 'P'),
(89308, 'Mystic Valley', 36.5416717529297, 0.637772486271631, -82.4652786254883, -1.43929063058927, 218, 50, 'PPL', 'P'),
(205077, 'Myton', 40.1944389343262, 0.701525300395793, -110.061111450195, -1.92092877321034, 218, 52, 'PPL', 'P'),
(178693, 'Na Ah Tee', 35.4902801513672, 0.619422241096549, -110.143890380859, -1.92237353810171, 218, 5, 'PPL', 'P'),
(14278, 'Naaman', 39.811939239502, 0.694849421333236, -75.4441680908203, -1.31674913461286, 218, 10, 'PPL', 'P'),
(96428, 'Naaman', 32.9536094665527, 0.575148985607717, -96.6269378662109, -1.68645821188536, 218, 51, 'PPL', 'P'),
(14280, 'Naamans Gardens', 39.8250007629395, 0.695077387922547, -75.5166702270508, -1.31801453560481, 218, 10, 'PPL', 'P'),
(14281, 'Naamans Manor', 39.8227806091309, 0.695038638928687, -75.5008316040039, -1.31773809948366, 218, 10, 'PPL', 'P'),
(30597, 'Nabb', 38.6055603027344, 0.673794136859934, -85.6327819824219, -1.49457399323574, 218, 19, 'PPL', 'P'),
(212010, 'Nabesna', 62.371940612793, 1.08859572455161, -143.008605957031, -2.49597103263737, 218, 1, 'PPL', 'P'),
(125502, 'Nabnasset', 42.6124992370605, 0.743728414190278, -71.4208297729492, -1.24652863404436, 218, 23, 'PPL', 'P'),
(175452, 'Nabob', 43.420280456543, 0.757826856106021, -88.2708282470703, -1.54061658637379, 218, 57, 'PPL', 'P'),
(42232, 'Naborton', 32.0416717529297, 0.559232669931886, -93.5830612182617, -1.63333254235408, 218, 22, 'PPL', 'P'),
(125503, 'Nabs Corner', 41.3722190856934, 0.722081441901787, -70.6833267211914, -1.23365677754768, 218, 23, 'PPL', 'P'),
(104545, 'Nace', 37.4394416809082, 0.653441527440248, -79.8241729736328, -1.39319464107137, 218, 53, 'PPL', 'P'),
(73623, 'Nace Corner', 39.0672187805176, 0.681851597316996, -83.3625030517578, -1.45495015095699, 218, 41, 'PPL', 'P'),
(165000, 'Naces Corner', 40.3347206115723, 0.703973677543957, -75.2069396972656, -1.31260871806611, 218, 45, 'PPL', 'P'),
(165001, 'Nacetown', 40.3886108398438, 0.704914239461946, -76.3525009155273, -1.33260253310794, 218, 45, 'PPL', 'P'),
(165002, 'Naceville', 40.351390838623, 0.704264627893048, -75.3727798461914, -1.31550317469687, 218, 45, 'PPL', 'P'),
(208207, 'Naches', 46.7311096191406, 0.815611725964397, -120.698333740234, -2.10658332543805, 218, 56, 'PPL', 'P'),
(120733, 'Nachusa', 41.8313903808594, 0.730095492833081, -89.3897171020508, -1.56014488085707, 218, 18, 'PPL', 'P'),
(183540, 'Nacimiento', 35.8091697692871, 0.624987914879678, -120.740562438965, -2.10732035526973, 218, 6, 'PPL', 'P'),
(178694, 'Naco', 31.3352794647217, 0.54690379869196, -109.94750213623, -1.91894591662072, 218, 5, 'PPL', 'P'),
(208208, 'Naco', 47.2772216796875, 0.825143179505791, -121.928611755371, -2.12805572751709, 218, 56, 'PPL', 'P'),
(13168, 'Nacocktanke (historical)', 38.8916702270508, 0.678787697061887, -76.9583282470703, -1.34317621474193, 218, 9, 'PPL', 'P'),
(96429, 'Nacogdoches', 31.6033306121826, 0.551582173778902, -94.6552810668945, -1.65204630901796, 218, 51, 'PPL', 'P'),
(110597, 'Nacols', 37.4555587768555, 0.653722823830388, -81.8180618286133, -1.42799456650959, 218, 58, 'PPL', 'P'),
(183542, 'Nacomis Indian Rancheria', 38.9861106872559, 0.680435994039564, -123.056938171387, -2.14774873851379, 218, 6, 'PPL', 'P'),
(23300, 'Nacoochee', 34.685001373291, 0.605367475022683, -83.710563659668, -1.46102495456152, 218, 13, 'PPL', 'P'),
(142467, 'Nacora', 42.3186111450195, 0.738599099351758, -96.6605606079102, -1.68704503943156, 218, 35, 'PPL', 'P'),
(13169, 'Nacotchtanke (historical)', 38.8916702270508, 0.678787697061887, -76.959716796875, -1.34320044950785, 218, 9, 'PPL', 'P'),
(96432, 'Nada', 29.4047203063965, 0.513209184974655, -96.3861083984375, -1.68225494473689, 218, 51, 'PPL', 'P'),
(37349, 'Nada Lombard PO', 37.814998626709, 0.659996232673206, -83.7194366455078, -1.46117981737891, 218, 21, 'PPL', 'P'),
(4473, 'Nadawah', 31.8141708374023, 0.555262029904632, -87.1722183227539, -1.52144222599938, 218, 2, 'PPL', 'P'),
(96431, 'Nadeau', 29.3841705322266, 0.512850523754848, -94.9444427490234, -1.65709313244172, 218, 51, 'PPL', 'P'),
(132223, 'Nadeau', 45.6088905334473, 0.796025307990328, -87.5527801513672, -1.5280842829161, 218, 27, 'PPL', 'P'),
(183543, 'Nadeau', 33.9655609130859, 0.592810870220041, -118.242218017578, -2.0637160192677, 218, 6, 'PPL', 'P'),
(165003, 'Nadine', 40.476390838623, 0.706446289458041, -79.8691711425781, -1.39398000727683, 218, 45, 'PPL', 'P'),
(189086, 'Nadine', 32.6238899230957, 0.56939429396622, -103.126937866211, -1.799904613265, 218, 38, 'PPL', 'P'),
(195369, 'Naf', 42.0102806091309, 0.733217716316062, -113.284721374512, -1.97719138018963, 218, 17, 'PPL', 'P'),
(42229, 'Naff', 32.935001373291, 0.574824213112782, -91.918327331543, -1.60427745486132, 218, 22, 'PPL', 'P'),
(104546, 'Naff', 37.1480598449707, 0.648355955022633, -80.0124969482422, -1.39648151448874, 218, 53, 'PPL', 'P'),
(4474, 'Naftel', 32.0094413757324, 0.558670143730634, -86.2891693115234, -1.50603011329693, 218, 2, 'PPL', 'P'),
(169497, 'Nag Creek', 41.649169921875, 0.726915145859308, -71.3294372558594, -1.24493353370946, 218, 47, 'PPL', 'P'),
(189087, 'Nageezi', 36.2666702270508, 0.632972804197036, -107.741386413574, -1.88044193358036, 218, 38, 'PPL', 'P'),
(165005, 'Naginey', 40.7041702270508, 0.710421789754284, -77.5519409179688, -1.35353671033067, 218, 45, 'PPL', 'P'),
(56444, 'Nagle', 37.1666717529297, 0.648680794096596, -91.8191680908203, -1.60254679962693, 218, 29, 'PPL', 'P'),
(178695, 'Nagles Crossing', 36.8638916015625, 0.643396283545551, -112.578887939453, -1.96487226277719, 218, 5, 'PPL', 'P'),
(165004, 'Nagles Crossroad', 40.6369400024414, 0.709248400977995, -78.5927810668945, -1.37170279791637, 218, 45, 'PPL', 'P'),
(197125, 'Nagos', 46.9916687011719, 0.820159339841817, -114.111938476563, -1.99162904224922, 218, 31, 'PPL', 'P'),
(208209, 'Nagrom', 47.2252807617188, 0.824236639470728, -121.60221862793, -2.12235909278735, 218, 56, 'PPL', 'P'),
(67099, 'Nags Head', 35.957218170166, 0.627571846927328, -75.6244430541992, -1.31989552628273, 218, 33, 'PPL', 'P'),
(23303, 'Naguchee (historical)', 34.6833305358887, 0.605338313408747, -83.7083282470703, -1.46098593925155, 218, 13, 'PPL', 'P'),
(116975, 'Nahant', 41.4874992370605, 0.724093460105342, -90.6377792358398, -1.58192767436116, 218, 16, 'PPL', 'P'),
(125504, 'Nahant', 42.4263916015625, 0.740480223187736, -70.9194412231445, -1.23777775301847, 218, 23, 'PPL', 'P'),
(202416, 'Nahant', 44.1766700744629, 0.771028345366626, -103.754997253418, -1.81086631746982, 218, 49, 'PPL', 'P'),
(10722, 'Nahay (historical)', 34.6402816772461, 0.604586969086208, -91.5458297729492, -1.59777614600822, 218, 4, 'PPL', 'P'),
(208212, 'Nahcotta', 46.4986114501953, 0.811553867411444, -124.032218933105, -2.16477059893714, 218, 56, 'PPL', 'P'),
(4475, 'Naheola', 32.2275009155273, 0.562476000665439, -88.0288925170898, -1.53639401130742, 218, 2, 'PPL', 'P'),
(132227, 'Nahma', 45.8416709899902, 0.800088093391298, -86.6638870239258, -1.51257017114389, 218, 27, 'PPL', 'P'),
(132225, 'Nahma Junction', 45.8972206115723, 0.801057617186141, -86.7083282470703, -1.51334581681138, 218, 27, 'PPL', 'P'),
(212011, 'Nahodka', 59.8211097717285, 1.04407532771362, -151.600555419922, -2.64592883992977, 218, 1, 'PPL', 'P'),
(170928, 'Nahon', 45.3855590820313, 0.79212743883986, -98.4061126708984, -1.71751067019569, 218, 49, 'PPL', 'P'),
(104547, 'Nahor', 37.9086112976074, 0.661630082001969, -78.3483276367188, -1.36743628069201, 218, 53, 'PPL', 'P'),
(212012, 'Nahotka', 59.8097190856934, 1.04387652273824, -151.612503051758, -2.64613736544312, 218, 1, 'PPL', 'P'),
(23302, 'Nahunta', 31.2041702270508, 0.544615510814823, -81.9813919067383, -1.43084521414042, 218, 13, 'PPL', 'P'),
(67101, 'Nahunta', 35.5077781677246, 0.619727639094554, -78.063606262207, -1.36246695525598, 218, 33, 'PPL', 'P'),
(10723, 'Nail', 35.8244400024414, 0.625254430725768, -93.2927780151367, -1.62826614469632, 218, 4, 'PPL', 'P'),
(89311, 'Naillon (historical)', 35.8238906860352, 0.625244843345844, -83.0922164916992, -1.45023276056008, 218, 50, 'PPL', 'P'),
(89312, 'Naillontown (historical)', 35.7994384765625, 0.624818071781158, -83.1313934326172, -1.45091652716996, 218, 50, 'PPL', 'P'),
(104548, 'Nain', 39.2391700744629, 0.684852713549406, -78.1999969482422, -1.36484742179634, 218, 53, 'PPL', 'P'),
(42230, 'Nairn', 29.4277801513672, 0.513611655194393, -89.6108322143555, -1.5640040675927, 218, 22, 'PPL', 'P'),
(183544, 'Nairn (historical)', 37.374439239502, 0.652307020815875, -120.502220153809, -2.10316049764703, 218, 6, 'PPL', 'P'),
(205079, 'Naisbitt Acres', 41.1594390869141, 0.718367730340699, -112.142501831055, -1.95725588837567, 218, 52, 'PPL', 'P'),
(197126, 'Naismith', 48.3863906860352, 0.844501830627631, -111.773612976074, -1.95081756328235, 218, 31, 'PPL', 'P'),
(42231, 'Naka', 30.4883308410645, 0.532121756613907, -92.0897216796875, -1.60726885055575, 218, 22, 'PPL', 'P'),
(189088, 'Nakaibito', 35.792781829834, 0.624701891378604, -108.826393127441, -1.89937887314358, 218, 38, 'PPL', 'P'),
(212014, 'Nakeen', 58.9338912963867, 1.02859044413438, -157.038604736328, -2.74084070538689, 218, 1, 'PPL', 'P'),
(67103, 'Nakina', 34.1344413757324, 0.595758390335514, -78.668327331543, -1.37302132897207, 218, 33, 'PPL', 'P'),
(212013, 'Naknek', 58.728328704834, 1.02500270009285, -157.013885498047, -2.74040927329029, 218, 1, 'PPL', 'P'),
(137032, 'Nakoda', 48.5149993896484, 0.846746475952405, -93.4580612182617, -1.63115088078909, 218, 28, 'PPL', 'P'),
(23304, 'Nakomis', 32.5466690063477, 0.568046534717558, -84.001106262207, -1.46609587959314, 218, 13, 'PPL', 'P'),
(205080, 'Nalani', 40.6388893127441, 0.709282422860921, -111.836936950684, -1.95192277513474, 218, 52, 'PPL', 'P'),
(17230, 'Nalcrest', 27.858060836792, 0.486214884822907, -81.4252777099609, -1.42113919038957, 218, 12, 'PPL', 'P'),
(10724, 'Nalle', 35.8955612182617, 0.626495730109854, -90.8372192382813, -1.58540855906394, 218, 4, 'PPL', 'P'),
(110598, 'Nallen', 38.1105613708496, 0.665154775704689, -80.8772201538086, -1.41157378154427, 218, 58, 'PPL', 'P'),
(208210, 'Nallpee', 46.5583305358887, 0.812596162083073, -123.611106872559, -2.15742080696074, 218, 56, 'PPL', 'P'),
(125505, 'Namasket Village', 41.9041709899902, 0.731365754094021, -70.9305572509766, -1.23797176430388, 218, 23, 'PPL', 'P'),
(189089, 'Nambe', 35.8933296203613, 0.626456781378911, -105.981941223145, -1.84973382199898, 218, 38, 'PPL', 'P'),
(189090, 'Nambe Pueblo', 35.8875007629395, 0.62635504862527, -105.96443939209, -1.84942835742195, 218, 38, 'PPL', 'P'),
(175454, 'Namekagon', 46.2127799987793, 0.80656516747848, -91.045280456543, -1.58903991236832, 218, 57, 'PPL', 'P'),
(23305, 'Nameless', 32.3869400024414, 0.565258737688463, -83.0722198486328, -1.44988375329923, 218, 13, 'PPL', 'P'),
(89313, 'Nameless', 36.2550010681152, 0.632769138952672, -85.7102813720703, -1.49592661275339, 218, 50, 'PPL', 'P'),
(96433, 'Nameless', 30.5245399475098, 0.532753724740582, -97.9267883300781, -1.70914488226342, 218, 51, 'PPL', 'P'),
(125506, 'Nameloc Heights', 41.8216705322266, 0.729925849471643, -70.5477828979492, -1.23129109155136, 218, 23, 'PPL', 'P'),
(27996, 'Nameoki', 38.7316703796387, 0.675995172921857, -90.1277770996094, -1.57302645789173, 218, 18, 'PPL', 'P'),
(104549, 'Namozine', 37.249439239502, 0.650125359250882, -77.7252807617188, -1.356562061329, 218, 53, 'PPL', 'P'),
(195370, 'Nampa', 43.540828704834, 0.759930819946211, -116.5625, -2.03439940935589, 218, 17, 'PPL', 'P'),
(56445, 'Namrash (historical)', 39.3263893127441, 0.686374976428495, -92.9947204589844, -1.62306405898101, 218, 29, 'PPL', 'P'),
(125507, 'Namskaket', 41.7916717529297, 0.729402272001333, -70.0166702270508, -1.22202142674512, 218, 23, 'PPL', 'P'),
(175455, 'Namur', 44.7347183227539, 0.780768124684291, -87.6699981689453, -1.5301301232655, 218, 57, 'PPL', 'P'),
(4476, 'Nanafalia', 32.1127815246582, 0.56047376957889, -87.9880599975586, -1.53568134939971, 218, 2, 'PPL', 'P'),
(89314, 'Nanatlugunyi (historical)', 36.2916717529297, 0.633409163141645, -82.4749984741211, -1.43946027395071, 218, 50, 'PPL', 'P'),
(210752, 'Nanawale Estates', 19.5061092376709, 0.340445830451038, -154.91194152832, -2.70372343032613, 218, 15, 'PPL', 'P'),
(210753, 'Nanawale Estates *', 19.5069408416748, 0.340460344678979, -154.913330078125, -2.70374766509205, 218, 15, 'PPL', 'P'),
(10725, 'Nance', 34.5480613708496, 0.602977421102391, -92.7705612182617, -1.61915174218163, 218, 4, 'PPL', 'P'),
(56446, 'Nance', 36.6108283996582, 0.638979497456682, -92.8000030517578, -1.61966559911396, 218, 29, 'PPL', 'P'),
(89315, 'Nance', 35.8347206115723, 0.625433861204212, -89.1208267211914, -1.55545185838413, 218, 50, 'PPL', 'P'),
(104550, 'Nance', 37.461109161377, 0.65381969631504, -77.1277770996094, -1.34613365513247, 218, 53, 'PPL', 'P'),
(23306, 'Nance Springs', 34.622501373291, 0.604276644240187, -84.9400024414063, -1.48248270925456, 218, 13, 'PPL', 'P'),
(4477, 'Nances Creek', 33.857780456543, 0.590929746384064, -85.6569366455078, -1.4949955716363, 218, 2, 'PPL', 'P'),
(89316, 'Nances Grove', 36.1222190856934, 0.630451656172085, -83.6005630493164, -1.45910508173168, 218, 50, 'PPL', 'P'),
(183545, 'Nanceville', 36.0694389343262, 0.629530468751026, -119.072219848633, -2.07820228401719, 218, 6, 'PPL', 'P'),
(37350, 'Nancy', 37.0716705322266, 0.647022710001912, -84.7480621337891, -1.47913271891935, 218, 21, 'PPL', 'P'),
(61004, 'Nancy', 31.9433307647705, 0.557516295898844, -88.8424987792969, -1.55059411939777, 218, 30, 'PPL', 'P'),
(96434, 'Nancy', 31.1055603027344, 0.542894442960359, -94.4305572509766, -1.64812413852255, 218, 51, 'PPL', 'P'),
(104551, 'Nancy', 37.1300010681152, 0.648040769907622, -82.2780609130859, -1.4360230650898, 218, 53, 'PPL', 'P'),
(208211, 'Nancy', 46.6647186279297, 0.814452984574104, -119.56861114502, -2.08686594651738, 218, 56, 'PPL', 'P'),
(73625, 'Nancy (historical)', 39.3899993896484, 0.687485181707922, -82.6594390869141, -1.44267936991835, 218, 41, 'PPL', 'P'),
(89317, 'Nancy (historical)', 35.4666709899902, 0.619010183496886, -87.5919418334961, -1.52876778320987, 218, 50, 'PPL', 'P'),
(96435, 'Nancy Colonia', 26.1590003967285, 0.456560685953415, -97.8440017700195, -1.707699984214, 218, 51, 'PPL', 'P'),
(110599, 'Nancy Run', 38.8180618286133, 0.677502988152033, -81.3516693115234, -1.41985448147971, 218, 58, 'PPL', 'P'),
(104552, 'Nancy Wrights Corner', 38.0902786254883, 0.664800775016791, -77.5127792358398, -1.3528532100369, 218, 53, 'PPL', 'P'),
(125508, 'Nancys Corner', 42.648609161377, 0.744358651262245, -70.8722229003906, -1.23695363781914, 218, 23, 'PPL', 'P'),
(23307, 'Nancytown (historical)', 34.4666709899902, 0.601556890976943, -83.4861068725586, -1.45710744459801, 218, 13, 'PPL', 'P'),
(14282, 'Nandains Landing', 39.2625007629395, 0.685259910880079, -75.5277786254883, -1.31820841373217, 218, 10, 'PPL', 'P'),
(104553, 'Nandua', 37.6241683959961, 0.656665616834926, -75.8502807617188, -1.3238371378541, 218, 53, 'PPL', 'P'),
(76681, 'Nani-chito', 34.4222183227539, 0.600781045572376, -94.6466674804688, -1.65189597357443, 218, 42, 'PPL', 'P'),
(61006, 'Nanih Waiya', 32.9213905334473, 0.574586659143547, -88.9486083984375, -1.55244608161981, 218, 30, 'PPL', 'P'),
(116976, 'Nanito', 41.315559387207, 0.721092543610014, -94.289436340332, -1.64566111398839, 218, 16, 'PPL', 'P'),
(67105, 'Nanito (historical)', 35.4625015258789, 0.6189374126201, -82.0783309936523, -1.43253712038094, 218, 33, 'PPL', 'P'),
(49739, 'Nanjemoy', 38.454719543457, 0.671161468964336, -77.2172164916992, -1.34769466700542, 218, 25, 'PPL', 'P'),
(23308, 'Nankin', 30.6658306121826, 0.535219712041455, -83.4680633544922, -1.45679252579911, 218, 13, 'PPL', 'P'),
(156676, 'Nankin', 40.9213905334473, 0.714212999303094, -82.2819366455078, -1.43609070938149, 218, 41, 'PPL', 'P'),
(89318, 'Nankipoo', 35.8736114501953, 0.626112634387046, -89.4880599975586, -1.56186128817963, 218, 50, 'PPL', 'P'),
(23309, 'Nankipooh', 32.5563888549805, 0.568216178078996, -84.9449996948242, -1.48256992778026, 218, 13, 'PPL', 'P'),
(67104, 'Nanney (historical)', 35.4258308410645, 0.618297388431127, -82.084716796875, -1.43264857367256, 218, 33, 'PPL', 'P'),
(23310, 'Nannie', 34.3661117553711, 0.599801801239554, -85.0502777099609, -1.48440737577436, 218, 13, 'PPL', 'P'),
(76676, 'Nanos', 36.7963905334473, 0.642218167658327, -96.269172668457, -1.68021403123551, 218, 42, 'PPL', 'P'),
(104554, 'Nansemond', 36.7669410705566, 0.641704177567942, -76.5311126708984, -1.33571989632193, 218, 53, 'PPL', 'P'),
(104556, 'Nansemond Gardens', 36.7497215270996, 0.641403639838927, -76.5749969482422, -1.33648582145144, 218, 53, 'PPL', 'P'),
(104562, 'Nansemond Shores', 36.8644409179688, 0.643405870925476, -76.4983291625977, -1.33514771616173, 218, 53, 'PPL', 'P'),
(104557, 'Nansemond Square', 36.7113914489746, 0.640734653773099, -76.591667175293, -1.33677677180053, 218, 53, 'PPL', 'P'),
(116977, 'Nansen', 43.1119384765625, 0.752445273333244, -92.2375030517578, -1.60984812207149, 218, 16, 'PPL', 'P'),
(137033, 'Nansen', 44.3502807617188, 0.774058423475891, -92.9316711425781, -1.62196364081859, 218, 28, 'PPL', 'P'),
(165007, 'Nansen', 41.582218170166, 0.725746617352009, -78.8630599975586, -1.37642005515523, 218, 45, 'PPL', 'P'),
(201280, 'Nansene', 45.4044418334961, 0.792457005024758, -121.055557250977, -2.11281805186604, 218, 43, 'PPL', 'P'),
(140556, 'Nanson', 48.5738906860352, 0.847774322975121, -99.7794418334961, -1.74147978579667, 218, 34, 'PPL', 'P'),
(67106, 'Nantahala', 35.2880592346191, 0.615892820282894, -83.6666717529297, -1.46025889627396, 218, 33, 'PPL', 'P'),
(89319, 'Nantahala Estates', 35.0872192382813, 0.612387501077105, -84.7874984741211, -1.47982101290308, 218, 50, 'PPL', 'P'),
(142469, 'Nantasket (historical)', 41.0277786254883, 0.716069821794124, -98.8583297729492, -1.7254033475603, 218, 35, 'PPL', 'P'),
(125509, 'Nantasket Beach', 42.2777786254883, 0.737886437444053, -70.8666687011719, -1.23685669875546, 218, 23, 'PPL', 'P'),
(125510, 'Nantasket Junction', 42.2449989318848, 0.737314323862877, -70.8705596923828, -1.23692460936326, 218, 23, 'PPL', 'P'),
(49742, 'Nanticoke', 38.2722206115723, 0.667976261721574, -75.9058303833008, -1.32480666164895, 218, 25, 'PPL', 'P'),
(150955, 'Nanticoke', 42.2747192382813, 0.737833041064197, -76.054443359375, -1.32740044739263, 218, 40, 'PPL', 'P'),
(165006, 'Nanticoke', 41.2052803039551, 0.719167810511186, -76.0052795410156, -1.32654237688941, 218, 45, 'PPL', 'P'),
(14283, 'Nanticoke Acres', 38.6394386291504, 0.674385425200959, -75.5849990844727, -1.31920709914095, 218, 10, 'PPL', 'P'),
(49741, 'Nanticoke Acres', 38.2583312988281, 0.667733847483349, -75.9105606079102, -1.32488921964274, 218, 25, 'PPL', 'P'),
(14284, 'Nanticoke Estates', 38.6230583190918, 0.674099534857939, -75.6208267211914, -1.3198324093649, 218, 10, 'PPL', 'P'),
(14285, 'Nanticoke Farms', 39.7769393920898, 0.6942385587582, -75.6066665649414, -1.31958526801574, 218, 10, 'PPL', 'P'),
(14287, 'Nanticoke Shores Mobile Home Park', 38.6300010681152, 0.674220708687537, -75.1394424438477, -1.31143066875792, 218, 10, 'PPL', 'P'),
(165008, 'Nantilly', 40.1697196960449, 0.7010938682992, -76.9683303833008, -1.34335078495139, 218, 45, 'PPL', 'P'),
(165009, 'Nantmeal Village', 40.1413917541504, 0.700599452442827, -75.704719543457, -1.32129661533222, 218, 45, 'PPL', 'P'),
(49743, 'Nantucket', 38.3769416809082, 0.669803989177695, -75.1605606079102, -1.31179925025278, 218, 25, 'PPL', 'P'),
(125511, 'Nantucket', 41.2833290100098, 0.720530017408762, -70.0999984741211, -1.22347577901641, 218, 23, 'PPL', 'P'),
(165010, 'Nanty Glo', 40.4722213745117, 0.706373518581255, -78.833610534668, -1.37590606506484, 218, 45, 'PPL', 'P'),
(150957, 'Nanuet', 41.0886116027832, 0.717131557541711, -74.0138931274414, -1.29178612729306, 218, 40, 'PPL', 'P'),
(104558, 'Naola', 37.5550003051758, 0.655458405912793, -79.3119430541992, -1.38425454245002, 218, 53, 'PPL', 'P'),
(89320, 'Naola (historical)', 35.6405601501465, 0.622045121875141, -86.033332824707, -1.50156492425525, 218, 50, 'PPL', 'P'),
(110601, 'Naoma', 37.8675003051758, 0.660912559825275, -81.4875030517578, -1.4222252274821, 218, 58, 'PPL', 'P'),
(23311, 'Naomi', 34.6930618286133, 0.605508156507266, -85.2077789306641, -1.48715629065154, 218, 13, 'PPL', 'P'),
(37353, 'Naomi', 37.0088882446289, 0.645926952371399, -84.7919387817383, -1.4798985108908, 218, 21, 'PPL', 'P'),
(42233, 'Naomi', 29.7099990844727, 0.518537304788549, -89.9922180175781, -1.5706605055793, 218, 22, 'PPL', 'P'),
(56447, 'Naomi', 39.9263916015625, 0.696846991887878, -91.695556640625, -1.60038937282786, 218, 29, 'PPL', 'P'),
(132228, 'Naomi', 42.042781829834, 0.733784969628249, -86.271110534668, -1.50571492818192, 218, 27, 'PPL', 'P'),
(156668, 'Naomi', 41.4861106872559, 0.724069225339422, -84.144172668457, -1.4685928594312, 218, 41, 'PPL', 'P'),
(165012, 'Naomi', 40.1069412231445, 0.699998177247714, -79.841667175293, -1.39349997249034, 218, 45, 'PPL', 'P'),
(170929, 'Naomi', 43.3305587768555, 0.756260917385055, -96.9241714477539, -1.69164591653078, 218, 49, 'PPL', 'P'),
(183546, 'Napa', 38.2972183227539, 0.668412554087156, -122.284439086914, -2.1342660860211, 218, 6, 'PPL', 'P'),
(183548, 'Napa Abajo', 38.2922210693359, 0.668325335561456, -122.284439086914, -2.1342660860211, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(170930, 'Napa Junction', 42.9411087036133, 0.749463731334846, -97.4533309936523, -1.70088149287507, 218, 49, 'PPL', 'P'),
(183550, 'Napa Junction', 38.1875, 0.666497608105335, -122.249717712402, -2.13366008371505, 218, 6, 'PPL', 'P'),
(183551, 'Napa Soda Springs', 38.3908309936523, 0.67004640341592, -122.278327941895, -2.13415942641944, 218, 6, 'PPL', 'P'),
(212015, 'Napaimiut', 61.5400009155273, 1.07407563765628, -158.674163818359, -2.76938659647923, 218, 1, 'PPL', 'P'),
(212016, 'Napakiak', 60.6966705322266, 1.05935674578557, -161.951934814453, -2.82659449248744, 218, 1, 'PPL', 'P'),
(61007, 'Napanee', 33.5061111450195, 0.584791959019758, -90.8708267211914, -1.58599512029403, 218, 30, 'PPL', 'P'),
(150958, 'Napanoch', 41.7438888549805, 0.728568303105975, -74.371940612793, -1.29803523479093, 218, 40, 'PPL', 'P'),
(212017, 'Napaskiak', 60.7080612182617, 1.05955555076095, -161.76611328125, -2.82335129491194, 218, 1, 'PPL', 'P'),
(208213, 'Napavine', 46.5747184753418, 0.812882185584148, -122.906936645508, -2.14513071800419, 218, 56, 'PPL', 'P'),
(150959, 'Napeague', 41.0094413757324, 0.715749776410124, -72.0686111450195, -1.25783455182007, 218, 40, 'PPL', 'P'),
(142470, 'Naper', 42.9636116027832, 0.749856481016605, -99.0963897705078, -1.72955827833499, 218, 35, 'PPL', 'P'),
(120735, 'Naperville', 41.785831451416, 0.72930033951061, -88.147216796875, -1.53845915957472, 218, 18, 'PPL', 'P'),
(37351, 'Napfor', 37.3133316040039, 0.651240491378325, -83.3122177124023, -1.45407250621976, 218, 21, 'PPL', 'P'),
(37352, 'Napier', 36.9844398498535, 0.645500247385741, -83.2855606079102, -1.45360725197732, 218, 21, 'PPL', 'P'),
(73624, 'Napier', 39.3736114501953, 0.687199158206848, -81.7169418334961, -1.4262296896552, 218, 41, 'PPL', 'P'),
(89321, 'Napier', 35.4388885498047, 0.61852528844141, -87.4763870239258, -1.52675097131635, 218, 50, 'PPL', 'P'),
(96436, 'Napier', 30.4836101531982, 0.532039365067682, -95.0058288574219, -1.65816452214825, 218, 51, 'PPL', 'P'),
(110600, 'Napier', 38.790828704834, 0.677027680476481, -80.5888900756836, -1.40654147234846, 218, 58, 'PPL', 'P'),
(116978, 'Napier', 41.9797210693359, 0.732684351728747, -93.7177810668945, -1.63568384728051, 218, 16, 'PPL', 'P'),
(132229, 'Napier', 42.0936088562012, 0.734672068587355, -86.2802810668945, -1.50587498416344, 218, 27, 'PPL', 'P'),
(139353, 'Napier', 40.0488891601563, 0.698984977610993, -95.2574996948242, -1.66255700689218, 218, 29, 'PPL', 'P'),
(165013, 'Napier', 40.0369415283203, 0.69877645209764, -78.5586090087891, -1.37110638299025, 218, 45, 'PPL', 'P'),
(4478, 'Napier Field', 31.3152809143066, 0.546554758141591, -85.4541702270508, -1.49145663002175, 218, 2, 'PPL', 'P'),
(165015, 'Napiersville', 40.1824989318848, 0.701316908040494, -76.1066665649414, -1.32831191427571, 218, 45, 'PPL', 'P'),
(120737, 'Naplate', 41.333610534668, 0.72140759556697, -88.878059387207, -1.55121476908982, 218, 18, 'PPL', 'P'),
(17231, 'Naples', 26.1416702270508, 0.45625821743261, -81.7949981689453, -1.42759202971083, 218, 12, 'PPL', 'P'),
(27998, 'Naples', 39.7572212219238, 0.693894411766334, -90.6072235107422, -1.58139437635287, 218, 18, 'PPL', 'P'),
(37354, 'Naples', 38.4358291625977, 0.670831769621384, -82.7697219848633, -1.4446041695962, 218, 21, 'PPL', 'P'),
(67109, 'Naples', 35.3925018310547, 0.617715687470026, -82.5008316040039, -1.43991114712326, 218, 33, 'PPL', 'P'),
(96437, 'Naples', 33.2030601501465, 0.579502721357779, -94.6800003051758, -1.65247774111455, 218, 51, 'PPL', 'P'),
(128219, 'Naples', 43.9716682434082, 0.767450388442105, -70.6097183227539, -1.23237206863782, 218, 26, 'PPL', 'P'),
(150960, 'Naples', 42.6152801513672, 0.743776950301145, -77.4027786254883, -1.35093333720706, 218, 40, 'PPL', 'P'),
(170931, 'Naples', 44.771671295166, 0.781413075721281, -97.5113906860352, -1.70189482566985, 218, 49, 'PPL', 'P'),
(183553, 'Naples', 34.4408302307129, 0.601105884646338, -119.958061218262, -2.09366313256759, 218, 6, 'PPL', 'P'),
(195371, 'Naples', 48.5711097717285, 0.847725786864254, -116.391387939453, -2.03141294050948, 218, 17, 'PPL', 'P'),
(205082, 'Naples', 40.4269409179688, 0.705583225527774, -109.498611450195, -1.91111129616787, 218, 52, 'PPL', 'P'),
(42234, 'Naples (historical)', 31.0269393920898, 0.541522249208696, -91.7458267211914, -1.60126675124898, 218, 22, 'PPL', 'P'),
(104559, 'Naples (historical)', 38.3691711425781, 0.669668367699183, -79.6975021362305, -1.39098381789244, 218, 53, 'PPL', 'P'),
(17232, 'Naples Manor', 26.0883293151855, 0.455327242894545, -81.7263870239258, -1.42639453932667, 218, 12, 'PPL', 'P'),
(17233, 'Naples Park', 26.2613906860352, 0.458347733623886, -81.809440612793, -1.427844097908, 218, 12, 'PPL', 'P'),
(210762, 'NapoÃ‚â€˜opoÃ‚â€˜o', 19.4769401550293, 0.339936733919156, -155.921676635742, -2.72134663252362, 218, 15, 'PPL', 'P'),
(4479, 'Napoleon', 33.3238906860352, 0.581611612045985, -85.3591690063477, -1.48979854592706, 218, 2, 'PPL', 'P'),
(30598, 'Napoleon', 39.204719543457, 0.684251438354293, -85.3308334350586, -1.48930399691264, 218, 19, 'PPL', 'P'),
(37355, 'Napoleon', 38.7602806091309, 0.676494515626247, -84.7888870239258, -1.479845247669, 218, 21, 'PPL', 'P'),
(56448, 'Napoleon', 39.1313896179199, 0.682971589713429, -94.070556640625, -1.64184094256272, 218, 29, 'PPL', 'P'),
(61008, 'Napoleon', 30.3261108398438, 0.529290483480016, -89.6275024414063, -1.5642950179418, 218, 30, 'PPL', 'P'),
(132230, 'Napoleon', 42.1605606079102, 0.735840597094654, -84.2461090087891, -1.47037198419743, 218, 27, 'PPL', 'P'),
(140557, 'Napoleon', 46.5083312988281, 0.811723510772882, -99.7708282470703, -1.74132945035314, 218, 34, 'PPL', 'P'),
(156669, 'Napoleon', 41.392219543457, 0.722430515741669, -84.1252822875977, -1.46826316008825, 218, 41, 'PPL', 'P'),
(42236, 'Napoleonville', 29.9402809143066, 0.522556480926669, -91.0247192382813, -1.58868105141143, 218, 22, 'PPL', 'P'),
(150961, 'Napoli', 42.1997184753418, 0.736524030809396, -78.892219543457, -1.37692898523954, 218, 40, 'PPL', 'P'),
(142471, 'Naponee', 40.0766716003418, 0.699469872666469, -99.14111328125, -1.73033885085049, 218, 35, 'PPL', 'P'),
(123270, 'Nappanee', 41.4427795410156, 0.723312954168867, -86.0013885498047, -1.50100739148104, 218, 19, 'PPL', 'P'),
(104560, 'Naptha', 36.8288917541504, 0.642785420970514, -77.8411102294922, -1.35858366691248, 218, 53, 'PPL', 'P'),
(56449, 'Napton', 39.0527801513672, 0.681599595698847, -93.083610534668, -1.62461548347404, 218, 29, 'PPL', 'P'),
(212018, 'Naptowne', 60.5275001525879, 1.05640416566403, -150.725006103516, -2.6306476215949, 218, 1, 'PPL', 'P'),
(42235, 'Naquin', 29.7897205352783, 0.519928706589574, -90.8413925170898, -1.58548139651976, 218, 22, 'PPL', 'P'),
(189092, 'Nara Visa', 35.6074981689453, 0.621468081445948, -103.099166870117, -1.7994199179466, 218, 38, 'PPL', 'P'),
(17234, 'Naranja', 25.5177803039551, 0.445369284104575, -80.4230575561523, -1.40364714887576, 218, 12, 'PPL', 'P'),
(183554, 'Naranjo', 36.4047203063965, 0.635382232614258, -119.061668395996, -2.07801812642781, 218, 6, 'PPL', 'P'),
(189093, 'Naranjos', 36.1616706848145, 0.631140216471925, -104.982498168945, -1.83229025001701, 218, 38, 'PPL', 'P'),
(165016, 'Narberth', 40.0083312988281, 0.69827710939325, -75.2608337402344, -1.31354934656313, 218, 45, 'PPL', 'P'),
(183555, 'Narbo (historical)', 37.2172203063965, 0.649563032786711, -119.70027923584, -2.08916398822201, 218, 6, 'PPL', 'P'),
(178696, 'Narcho Santos', 32.1452789306641, 0.56104095631205, -112.14111328125, -1.95723165360975, 218, 5, 'PPL', 'P'),
(96439, 'Narciso Pena Colonia', 26.3020000457764, 0.459056500658497, -98.640998840332, -1.7216102072197, 218, 51, 'PPL', 'P'),
(76678, 'Narcissa', 36.8011093139648, 0.642300525915038, -94.9266662597656, -1.65678287417472, 218, 42, 'PPL', 'P'),
(165018, 'Narcissa', 40.1261100769043, 0.700332736859655, -75.2588882446289, -1.31351539125923, 218, 45, 'PPL', 'P'),
(191924, 'Narcisso', 34.0002784729004, 0.593416805947061, -100.47306060791, -1.75358571716385, 218, 51, 'PPL', 'P'),
(17235, 'Narcoossee', 28.298059463501, 0.493894309563232, -81.2391662597656, -1.417890932808, 218, 12, 'PPL', 'P'),
(76680, 'Nardin', 36.8055610656738, 0.642378223639841, -97.445556640625, -1.70074580481753, 218, 42, 'PPL', 'P'),
(132232, 'Narenta', 45.726390838623, 0.798076075187743, -87.2425003051758, -1.52266887799748, 218, 27, 'PPL', 'P'),
(183556, 'Nares (historical)', 36.5366706848145, 0.637685201166904, -120.09944152832, -2.0961306844756, 218, 6, 'PPL', 'P'),
(178697, 'Nariska', 32.5044403076172, 0.567309504885878, -111.26277923584, -1.94190183258499, 218, 5, 'PPL', 'P'),
(112309, 'Narita', 39.9830589294434, 0.697836023337706, -89.2188873291016, -1.55716333885867, 218, 18, 'PPL', 'P'),
(33379, 'Narka', 39.9605598449707, 0.697443340234974, -97.4255599975586, -1.70039679755668, 218, 20, 'PPL', 'P'),
(61009, 'Narkeeta (historical)', 32.6569404602051, 0.569971134658331, -88.4652786254883, -1.54401038570893, 218, 30, 'PPL', 'P'),
(183557, 'Narlon', 34.8105583190918, 0.607558857125655, -120.597778320313, -2.10482830227969, 218, 6, 'PPL', 'P'),
(49744, 'Narnia', 39.5155601501465, 0.689676630389921, -77.0736083984375, -1.34518823294549, 218, 25, 'PPL', 'P'),
(183558, 'Narod', 34.0580596923828, 0.594425278472847, -117.683609008789, -2.05396645283303, 218, 6, 'PPL', 'P'),
(169498, 'Narragansett', 41.4500007629395, 0.723438988267455, -71.4499969482422, -1.24703769728673, 218, 47, 'PPL', 'P'),
(169499, 'Narragansett Beach', 41.4372215270996, 0.723215948526161, -71.4516677856445, -1.24706685890066, 218, 47, 'PPL', 'P'),
(169500, 'Narragansett Pier', 41.4322204589844, 0.723128663421434, -71.4569396972656, -1.24715887111633, 218, 47, 'PPL', 'P'),
(169501, 'Narragansett Terrace', 41.5499992370605, 0.725184290887838, -71.3833312988281, -1.24587416220647, 218, 47, 'PPL', 'P'),
(104561, 'Narrow Beach', 38.1227798461914, 0.665368028328977, -76.6374969482422, -1.33757665223393, 218, 53, 'PPL', 'P'),
(125514, 'Narrow Creek (historical)', 41.2805595397949, 0.720481681034977, -70.2180633544922, -1.22553639990986, 218, 23, 'PPL', 'P'),
(67110, 'Narrow Ridge', 35.1202812194824, 0.612964541506298, -79.5583267211914, -1.38855474866217, 218, 33, 'PPL', 'P'),
(37356, 'Narrows', 37.5672187805176, 0.655671658537081, -86.7300033569336, -1.51372411884423, 218, 21, 'PPL', 'P'),
(49745, 'Narrows', 38.9700012207031, 0.680154830807479, -76.2430572509766, -1.33069238081608, 218, 25, 'PPL', 'P'),
(104564, 'Narrows', 37.2052803039551, 0.649354640431413, -79.9591674804688, -1.39555073968776, 218, 53, 'PPL', 'P'),
(201281, 'Narrows', 43.2791709899902, 0.755364031308943, -118.961112976074, -2.07626310326945, 218, 43, 'PPL', 'P'),
(4480, 'Narrows (historical)', 34.9075012207031, 0.609250829945209, -86.0305633544922, -1.50151658788147, 218, 2, 'PPL', 'P'),
(165020, 'Narrows Creek', 41.1347198486328, 0.717936298244106, -78.7005615234375, -1.37358392175235, 218, 45, 'PPL', 'P'),
(56450, 'Narrows Creek (historical)', 39.6647186279297, 0.692279936934501, -92.4194412231445, -1.61302354219725, 218, 29, 'PPL', 'P'),
(49746, 'Narrows Park', 39.6666717529297, 0.692314025396454, -78.8005599975586, -1.37532922437273, 218, 25, 'PPL', 'P'),
(150964, 'Narrowsburg', 41.6086082458496, 0.726207211062538, -75.0622177124023, -1.31008284293023, 218, 40, 'PPL', 'P'),
(165021, 'Narrowsville', 40.5699996948242, 0.708080072207777, -75.1291732788086, -1.31125143801655, 218, 45, 'PPL', 'P'),
(96438, 'Naruna', 30.9886093139648, 0.540853263142868, -98.3172225952148, -1.71595924570266, 218, 51, 'PPL', 'P'),
(104565, 'Naruna', 37.1058311462402, 0.647618925190954, -79.0027770996094, -1.37885857860736, 218, 53, 'PPL', 'P'),
(156671, 'Narva', 40.3172187805176, 0.703668212966925, -80.9622192382813, -1.4130572954295, 218, 41, 'PPL', 'P'),
(37357, 'Narvel', 36.7847213745117, 0.642014502413964, -85.0455627441406, -1.48432508409668, 218, 21, 'PPL', 'P'),
(165022, 'Narvon', 40.1027793884277, 0.699925539528982, -75.9780578613281, -1.32606726895094, 218, 45, 'PPL', 'P'),
(137034, 'Nary', 47.3669395446777, 0.82670905164773, -94.8230590820313, -1.65497458779456, 218, 28, 'PPL', 'P'),
(175457, 'Nasbro', 43.5947189331055, 0.7608713818642, -88.5047225952148, -1.54469881285072, 218, 57, 'PPL', 'P'),
(156672, 'Nasby', 41.6302795410156, 0.726585446516356, -83.6113891601563, -1.45929403301102, 218, 41, 'PPL', 'P'),
(189094, 'Naschitti', 36.064998626709, 0.629452970763305, -108.68138885498, -1.89684807115968, 218, 38, 'PPL', 'P'),
(10727, 'Nasco', 35.964168548584, 0.627693153914981, -91.9850006103516, -1.60544112309963, 218, 4, 'PPL', 'P'),
(208214, 'Naselle', 46.3655586242676, 0.809231657519922, -123.809440612793, -2.16088238374562, 218, 56, 'PPL', 'P'),
(17236, 'Nash', 30.4541702270508, 0.531525541424865, -83.8930587768555, -1.46421009522525, 218, 12, 'PPL', 'P'),
(30599, 'Nash', 39.749439239502, 0.69375859055074, -86.5380630493164, -1.51037412850902, 218, 19, 'PPL', 'P'),
(37358, 'Nash', 37.3202781677246, 0.651361731786951, -86.4308319091797, -1.50850259205296, 218, 21, 'PPL', 'P'),
(56452, 'Nash', 37.2380599975586, 0.649926754012589, -89.6194381713867, -1.56415426987818, 218, 29, 'PPL', 'P'),
(76682, 'Nash', 36.6661109924316, 0.639944360719618, -98.0500030517578, -1.71129538484366, 218, 42, 'PPL', 'P'),
(89322, 'Nash', 36.0597190856934, 0.629360825389588, -85.6558303833008, -1.4949762637184, 218, 50, 'PPL', 'P'),
(96441, 'Nash', 32.2655601501465, 0.563140259620332, -96.8125, -1.68969688208701, 218, 51, 'PPL', 'P'),
(104566, 'Nash', 37.8574981689453, 0.66073798961582, -79.04638671875, -1.3796197100469, 218, 53, 'PPL', 'P'),
(140559, 'Nash', 48.4705581665039, 0.845970830284919, -97.5127792358398, -1.70191906043577, 218, 34, 'PPL', 'P'),
(205086, 'Nash', 40.454719543457, 0.706068054004222, -111.92138671875, -1.95339670164004, 218, 52, 'PPL', 'P'),
(4481, 'Nash (historical)', 33.9877815246582, 0.593198693053784, -86.2736129760742, -1.5057586040238, 218, 2, 'PPL', 'P'),
(42237, 'Nash (historical)', 32.3647193908691, 0.56487091485472, -92.4366683959961, -1.61332421308432, 218, 22, 'PPL', 'P'),
(10728, 'Nash Corner', 34.8811111450195, 0.60879023623468, -91.0805587768555, -1.58965563521235, 218, 4, 'PPL', 'P'),
(104567, 'Nash Corner', 37.9461097717285, 0.662284553839857, -75.5400009155273, -1.31842173293548, 218, 53, 'PPL', 'P'),
(128221, 'Nash Corner', 44.7491683959961, 0.781020326039522, -69.4472198486328, -1.212082642715, 218, 26, 'PPL', 'P'),
(104568, 'Nash Ford', 36.9700012207031, 0.645248245767592, -82.0755615234375, -1.43248878400716, 218, 53, 'PPL', 'P'),
(104569, 'Nash Grove', 37.2852783203125, 0.650750869211914, -77.5711135864258, -1.35387133652164, 218, 53, 'PPL', 'P'),
(212019, 'Nash Harbor', 60.2055587768555, 1.0507852286591, -166.938323974609, -2.91362340111792, 218, 1, 'PPL', 'P'),
(89323, 'Nash Landing', 35.0716705322266, 0.612116124962026, -88.2908325195313, -1.5409657267927, 218, 50, 'PPL', 'P'),
(104573, 'Nash Mill', 36.6019401550293, 0.638824368323185, -83.5833282470703, -1.45880427768656, 218, 53, 'PPL', 'P'),
(104570, 'Nash Town', 38.1761093139648, 0.66629880312996, -77.0038909912109, -1.34397143464343, 218, 53, 'PPL', 'P'),
(4482, 'Nash Town (historical)', 33.1180610656738, 0.57801920747255, -87.0597229003906, -1.51947881048572, 218, 2, 'PPL', 'P'),
(125515, 'Nashaquitsa', 41.3208312988281, 0.721184555825676, -70.7702789306641, -1.23517437989486, 218, 23, 'PPL', 'P'),
(210763, 'Nashiwa Village', 20.9016704559326, 0.364802968622849, -156.36833190918, -2.7291422376665, 218, 15, 'PPL', 'P'),
(183559, 'Nashmead', 39.8224983215332, 0.69503371208067, -123.413612365723, -2.15397387756185, 218, 6, 'PPL', 'P'),
(112507, 'Nashoba', 34.4819412231445, 0.601823406823033, -95.2149963378906, -1.66181518337053, 218, 42, 'PPL', 'P'),
(76684, 'Nashoba Y', 34.482780456543, 0.601838054209028, -95.2811126708984, -1.66296913107087, 218, 42, 'PPL', 'P'),
(175459, 'Nashotah', 43.0977783203125, 0.752198131984084, -88.4022216796875, -1.54290983438846, 218, 57, 'PPL', 'P'),
(156673, 'Nashport', 40.0705604553223, 0.699363213064812, -82.1758270263672, -1.43423874715945, 218, 41, 'PPL', 'P'),
(37359, 'Nashtown', 38.5091705322266, 0.672111817999331, -83.5327835083008, -1.45792210557547, 218, 21, 'PPL', 'P'),
(17237, 'Nashua', 29.5183296203613, 0.515192041564273, -81.6711120605469, -1.42542980922179, 218, 12, 'PPL', 'P'),
(56453, 'Nashua', 39.3005599975586, 0.685924169834972, -94.579719543457, -1.65072751164615, 218, 29, 'PPL', 'P'),
(116979, 'Nashua', 42.9527816772461, 0.749667463158237, -92.5361099243164, -1.61505979516672, 218, 16, 'PPL', 'P'),
(137035, 'Nashua', 46.0374984741211, 0.803505927755279, -96.3077774047852, -1.6808878109913, 218, 28, 'PPL', 'P'),
(144178, 'Nashua', 42.7652816772461, 0.746394970810747, -71.4680633544922, -1.24735301555979, 218, 36, 'PPL', 'P'),
(165023, 'Nashua', 41.0786094665527, 0.716956987332257, -80.399169921875, -1.40323023100711, 218, 45, 'PPL', 'P'),
(183560, 'Nashua', 36.7413902282715, 0.641258231243408, -121.764717102051, -2.12519522619023, 218, 6, 'PPL', 'P'),
(197127, 'Nashua', 48.1322212219238, 0.840065736620859, -106.355827331543, -1.856259365618, 218, 31, 'PPL', 'P'),
(10729, 'Nashville', 33.9455604553223, 0.592461796380159, -93.8469390869141, -1.63793807998521, 218, 4, 'PPL', 'P'),
(23312, 'Nashville', 31.2072200775146, 0.544668740747111, -83.2502822875977, -1.4529915291333, 218, 13, 'PPL', 'P'),
(28000, 'Nashville', 38.3436088562012, 0.669222221637567, -89.3805618286133, -1.55998509119167, 218, 18, 'PPL', 'P'),
(30601, 'Nashville', 39.9283294677734, 0.696880814033722, -85.6594390869141, -1.49503924747818, 218, 19, 'PPL', 'P'),
(33380, 'Nashville', 37.4416694641113, 0.653480409592164, -98.4222183227539, -1.71779176684875, 218, 20, 'PPL', 'P'),
(56454, 'Nashville', 37.374439239502, 0.652307020815875, -94.4905624389648, -1.64917142662122, 218, 29, 'PPL', 'P'),
(67112, 'Nashville', 35.9744415283203, 0.62787245123537, -77.9658279418945, -1.36076040162945, 218, 33, 'PPL', 'P'),
(89325, 'Nashville', 36.165828704834, 0.631212787611629, -86.7844390869141, -1.51467420156311, 218, 50, 'PPL', 'P'),
(116980, 'Nashville', 42.0625, 0.734129116620115, -90.7836074829102, -1.58447285741494, 218, 16, 'PPL', 'P'),
(132233, 'Nashville', 42.6027793884277, 0.74355877082884, -85.0930633544922, -1.48515412614402, 218, 27, 'PPL', 'P'),
(142472, 'Nashville', 41.4063911437988, 0.72267785682791, -95.9963912963867, -1.67545309815478, 218, 35, 'PPL', 'P'),
(150966, 'Nashville', 43.077220916748, 0.751839337606224, -78.8661117553711, -1.37647331837703, 218, 40, 'PPL', 'P'),
(156675, 'Nashville', 40.5961112976074, 0.708535805649317, -82.1122207641602, -1.43312860845905, 218, 41, 'PPL', 'P'),
(165024, 'Nashville', 40.7966690063477, 0.71203619800709, -78.9272232055664, -1.37753991439361, 218, 45, 'PPL', 'P'),
(172293, 'Nashville', 44.4519386291504, 0.775832687973129, -72.9388885498047, -1.27302375793928, 218, 55, 'PPL', 'P'),
(175461, 'Nashville', 45.5227813720703, 0.794522419608169, -89.0247192382813, -1.55377446637155, 218, 57, 'PPL', 'P'),
(183561, 'Nashville', 38.5788917541504, 0.673328682880415, -120.844169616699, -2.1091286416499, 218, 6, 'PPL', 'P'),
(190529, 'Nashville', 39.7891693115234, 0.694452011119569, -119.829170227051, -2.0914135603948, 218, 39, 'PPL', 'P'),
(195372, 'Nashville', 42.0494384765625, 0.733901150030804, -111.807777404785, -1.95141384505042, 218, 17, 'PPL', 'P'),
(201282, 'Nashville', 44.6536102294922, 0.779352521406859, -123.607223510742, -2.157353029511, 218, 43, 'PPL', 'P'),
(56455, 'Nashville (historical)', 38.827220916748, 0.677662844396465, -92.3566665649414, -1.61192791772479, 218, 29, 'PPL', 'P'),
(61011, 'Nashville (historical)', 33.3263893127441, 0.581655221308836, -88.3236083984375, -1.54153777379485, 218, 30, 'PPL', 'P'),
(137037, 'Nashville Center', 43.834171295166, 0.765050613983834, -94.307502746582, -1.64597643226145, 218, 28, 'PPL', 'P'),
(137039, 'Nashwauk', 47.3802795410156, 0.82694187850603, -93.1680603027344, -1.62608940997934, 218, 28, 'PPL', 'P'),
(128223, 'Naskeag', 44.2344398498535, 0.77203661815533, -68.5325012207031, -1.1961177909283, 218, 26, 'PPL', 'P'),
(125516, 'Nasketucket', 41.6441688537598, 0.726827860754581, -70.875, -1.23700210735098, 218, 23, 'PPL', 'P'),
(28002, 'Nason', 38.1761093139648, 0.66629880312996, -88.9674987792969, -1.55277578096277, 218, 18, 'PPL', 'P'),
(61012, 'Nason', 33.7230606079102, 0.588578441457633, -89.8986129760742, -1.56902678940859, 218, 30, 'PPL', 'P'),
(128224, 'Nason Beach', 44.1544418334961, 0.770640389374829, -70.1155624389648, -1.2237474214476, 218, 26, 'PPL', 'P'),
(144179, 'Nason Corners', 42.9199981689453, 0.749095282998033, -70.9088897705078, -1.23759359542909, 218, 36, 'PPL', 'P'),
(208215, 'Nason Creek', 47.7663917541504, 0.833680807907394, -120.795280456543, -2.10827536483663, 218, 56, 'PPL', 'P'),
(104571, 'Nasons', 38.2550010681152, 0.667675723992558, -78.0269393920898, -1.36182699764603, 218, 53, 'PPL', 'P'),
(128225, 'Nasons Corner', 43.6749992370605, 0.762272537492718, -70.3147201538086, -1.22722337930237, 218, 26, 'PPL', 'P'),
(169503, 'Nasonville', 41.9816703796387, 0.732718373611673, -71.6172180175781, -1.24995625552534, 218, 47, 'PPL', 'P'),
(175463, 'Nasonville', 44.5988883972168, 0.77839744526093, -90.2583312988281, -1.5753050585204, 218, 57, 'PPL', 'P'),
(208216, 'Nass', 46.3388900756836, 0.808766203540403, -120.144996643066, -2.09692577121904, 218, 56, 'PPL', 'P'),
(14288, 'Nassau', 38.7519416809082, 0.676348973872674, -75.1880569458008, -1.31227915188122, 218, 10, 'PPL', 'P'),
(137041, 'Nassau', 45.0663909912109, 0.786556904787742, -96.4394378662109, -1.68318571953788, 218, 28, 'PPL', 'P'),
(150967, 'Nassau', 42.5158309936523, 0.742041235060686, -73.6105575561523, -1.28474659358365, 218, 40, 'PPL', 'P'),
(96442, 'Nassau Bay', 29.5444393157959, 0.515647741716299, -95.0908279418945, -1.65964803603348, 218, 51, 'PPL', 'P'),
(150969, 'Nassau Farms', 41.017219543457, 0.715885531046691, -72.4530563354492, -1.26454438618653, 218, 40, 'PPL', 'P'),
(56457, 'Nassau Junction', 37.8202781677246, 0.660088378046923, -94.3216705322266, -1.64622370676867, 218, 29, 'PPL', 'P'),
(14289, 'Nassau Park Mobile Home Park', 38.7497215270996, 0.676310224878813, -75.1902770996094, -1.31231790087508, 218, 10, 'PPL', 'P'),
(150970, 'Nassau Shores', 40.6619415283203, 0.709684759922605, -73.440559387207, -1.28177956581319, 218, 40, 'PPL', 'P'),
(17239, 'Nassauville', 30.5691699981689, 0.533532666069917, -81.5197219848633, -1.42278755394627, 218, 12, 'PPL', 'P'),
(104572, 'Nassawadox', 37.4747200012207, 0.654057250284275, -75.8586120605469, -1.32398254644962, 218, 53, 'PPL', 'P'),
(104574, 'Nassawadox Estates', 37.4799995422363, 0.654149395657991, -75.8438873291016, -1.32372555140443, 218, 53, 'PPL', 'P'),
(49758, 'Nassawango Hills', 38.2249984741211, 0.667152079943222, -75.4697189331055, -1.31719508093739, 218, 25, 'PPL', 'P'),
(116982, 'Nasset', 43.2844390869141, 0.755455976945578, -91.6666717529297, -1.59988523643351, 218, 16, 'PPL', 'P'),
(187099, 'Nast', 39.2916717529297, 0.685769040701475, -106.600830078125, -1.86053547022229, 218, 7, 'PPL', 'P'),
(96447, 'Nat', 31.7133293151855, 0.553502013319226, -94.8263931274414, -1.65503277786438, 218, 51, 'PPL', 'P'),
(104576, 'Natal', 36.9866714477539, 0.645539196116684, -79.2675018310547, -1.38347889678254, 218, 53, 'PPL', 'P'),
(42238, 'Natalbany', 30.5461101531982, 0.533130195850179, -90.4847183227539, -1.5792562574717, 218, 22, 'PPL', 'P'),
(46, 'Natalia', 29.1894397735596, 0.509451830861203, -98.8622207641602, -1.7254712581681, 218, 51, 'PPL', 'P'),
(132234, 'Natalie', 46.3469390869141, 0.808906685287905, -85.5774993896484, -1.4936091299728, 218, 27, 'PPL', 'P'),
(165025, 'Natalie', 40.8172187805176, 0.712394859226896, -76.4633331298828, -1.33453692016572, 218, 45, 'PPL', 'P'),
(113763, 'Natchaug (historical)', 41.810001373291, 0.729722184227279, -72.1147232055664, -1.25863935910149, 218, 8, 'PPL', 'P'),
(178698, 'Natches', 33.2108306884766, 0.579638342836291, -110.299438476563, -1.92508836451693, 218, 5, 'PPL', 'P'),
(4483, 'Natchez', 31.7275009155273, 0.553749354405467, -87.2605590820313, -1.52298406311249, 218, 2, 'PPL', 'P'),
(30602, 'Natchez', 38.6172218322754, 0.673997668946243, -86.7108306884766, -1.51338949265326, 218, 19, 'PPL', 'P'),
(42239, 'Natchez', 31.6752796173096, 0.552837920811901, -93.0444412231445, -1.62393185002221, 218, 22, 'PPL', 'P'),
(61013, 'Natchez', 31.5602798461914, 0.55083079616685, -91.4030609130859, -1.59528435933428, 218, 30, 'PPL', 'P'),
(89326, 'Natchez Hills Estate', 36.0194396972656, 0.628657817440835, -86.966667175293, -1.51785468169494, 218, 50, 'PPL', 'P'),
(61015, 'Natchez Under the Hill (historical)', 31.5625, 0.55086954516071, -91.408332824707, -1.59537637154995, 218, 30, 'PPL', 'P'),
(42240, 'Natchitoches', 31.7605590820313, 0.554326328255633, -93.0861129760742, -1.62465915931591, 218, 22, 'PPL', 'P'),
(89327, 'Natco', 35.642219543457, 0.622074083751995, -87.0541687011719, -1.51938187142204, 218, 50, 'PPL', 'P'),
(145856, 'Natco', 40.4397201538086, 0.705806265269068, -74.1597213745117, -1.29433131034684, 218, 37, 'PPL', 'P'),
(61016, 'Natcole', 31.1738891601563, 0.544087006496496, -89.8497161865234, -1.56817337943728, 218, 30, 'PPL', 'P'),
(104575, 'Nathalie', 36.9347190856934, 0.644632456344539, -78.9475021362305, -1.37789384850248, 218, 53, 'PPL', 'P'),
(10731, 'Nathan', 34.1061096191406, 0.595263907900113, -93.813606262207, -1.63735631244508, 218, 4, 'PPL', 'P'),
(132235, 'Nathan', 45.5791702270508, 0.795506590789008, -87.7069396972656, -1.5307748745654, 218, 27, 'PPL', 'P'),
(49747, 'Nathaniels Retreat', 38.1708297729492, 0.666206657756243, -75.3483276367188, -1.31507640313218, 218, 25, 'PPL', 'P'),
(67114, 'Nathans Creek', 36.4488906860352, 0.636153151170808, -81.3888931274414, -1.42050415962764, 218, 33, 'PPL', 'P'),
(49748, 'Nathans Hill', 39.1616706848145, 0.683500094031755, -77.1999969482422, -1.3473941292764, 218, 25, 'PPL', 'P'),
(187100, 'Nathrop (historical)', 38.7472190856934, 0.676266549036936, -106.074996948242, -1.85135795078976, 218, 7, 'PPL', 'P'),
(125517, 'Natick', 42.2833290100098, 0.737983309928705, -71.3499984741211, -1.24529239466634, 218, 23, 'PPL', 'P'),
(169504, 'Natick', 41.7200012207031, 0.728151385237323, -71.4922180175781, -1.24777459396035, 218, 47, 'PPL', 'P'),
(199555, 'Natick', 41.9558296203613, 0.732267367281068, -100.439170837402, -1.75299422908574, 218, 35, 'PPL', 'P'),
(49749, 'National', 39.6088905334473, 0.691305552870668, -78.940559387207, -1.37777267467288, 218, 25, 'PPL', 'P'),
(110602, 'National', 39.5838890075684, 0.690869193926059, -80.0377807617188, -1.39692280028137, 218, 58, 'PPL', 'P'),
(208217, 'National', 46.7566719055176, 0.816057872026013, -122.054718017578, -2.13025669699998, 218, 56, 'PPL', 'P'),
(200092, 'National (historical)', 41.8283309936523, 0.730042096453225, -117.58528137207, -2.05225031182658, 218, 39, 'PPL', 'P'),
(28003, 'National City', 38.6455612182617, 0.674492284539698, -90.1608276367188, -1.57360329858384, 218, 18, 'PPL', 'P'),
(132236, 'National City', 44.2341690063477, 0.772031891044395, -83.7233276367188, -1.46124772798671, 218, 27, 'PPL', 'P'),
(183562, 'National City', 32.6780586242676, 0.570339716153198, -117.098327636719, -2.04375136583981, 218, 6, 'PPL', 'P'),
(17241, 'National Gardens', 29.3322200775146, 0.511943817272217, -81.1266708374023, -1.41592751729434, 218, 12, 'PPL', 'P'),
(165026, 'National Hill', 40.3455581665039, 0.70416282856038, -80.1572189331055, -1.39900738962463, 218, 45, 'PPL', 'P'),
(23313, 'National Hills', 33.5130615234375, 0.584913266007411, -82.0169372558594, -1.43146559751635, 218, 13, 'PPL', 'P'),
(132237, 'National Mine', 46.458610534668, 0.810855719731679, -87.6813888549805, -1.53032892824087, 218, 27, 'PPL', 'P'),
(49750, 'National Mobile Home Park', 38.2847213745117, 0.668194441193879, -76.4783325195313, -1.33479870890087, 218, 25, 'PPL', 'P'),
(71155, 'National Park', 39.8658294677734, 0.695789983251225, -75.1791687011719, -1.31212402274772, 218, 37, 'PPL', 'P'),
(4484, 'Natis', 34.0419387817383, 0.59414391550368, -87.4291687011719, -1.52592685611702, 218, 2, 'PPL', 'P'),
(10736, 'Native (historical)', 33.9447212219238, 0.592447148994164, -93.2980575561523, -1.62835829007003, 218, 4, 'PPL', 'P'),
(120739, 'Native Prairie', 41.8838882446289, 0.731011753406123, -88.4316711425781, -1.54342382447884, 218, 18, 'PPL', 'P'),
(183563, 'Natividad', 36.732780456543, 0.641107962378901, -121.595558166504, -2.12224284580577, 218, 6, 'PPL', 'P'),
(37360, 'Natlee', 38.4469413757324, 0.671025714327769, -84.6619415283203, -1.47762963080011, 218, 21, 'PPL', 'P'),
(33381, 'Natoma', 39.1908302307129, 0.684009024116069, -99.0283279418945, -1.72837037533076, 218, 20, 'PPL', 'P'),
(177673, 'Natoma', 38.6549987792969, 0.674657001053119, -121.180282592773, -2.11499491974107, 218, 6, 'PPL', 'P'),
(110603, 'Natrium', 39.7480583190918, 0.693734488942875, -80.8516693115234, -1.41112783521974, 218, 58, 'PPL', 'P'),
(33383, 'Natrona', 37.7119407653809, 0.658197533672966, -98.664436340332, -1.72201926876314, 218, 20, 'PPL', 'P'),
(120740, 'Natrona', 40.2708282470703, 0.702858545416513, -89.6322174072266, -1.56437730961948, 218, 18, 'PPL', 'P'),
(165027, 'Natrona', 40.6144409179688, 0.708855717875263, -79.7197189331055, -1.39137157414715, 218, 45, 'PPL', 'P'),
(209630, 'Natrona', 43.0297203063965, 0.751010295558882, -106.808609008789, -1.86416189667865, 218, 59, 'PPL', 'P'),
(165028, 'Natrona Heights', 40.6233291625977, 0.70901084700876, -79.7300033569336, -1.39155107120462, 218, 45, 'PPL', 'P'),
(862, 'Natura', 35.7400016784668, 0.623780703957545, -95.9352798461914, -1.6743865021382, 218, 42, 'PPL', 'P'),
(4485, 'Natural Bridge', 34.0933303833008, 0.595040868158819, -87.601936340332, -1.52894222026127, 218, 2, 'PPL', 'P'),
(104577, 'Natural Bridge', 37.6300010681152, 0.656767416167594, -79.543327331543, -1.38829295992702, 218, 53, 'PPL', 'P'),
(150972, 'Natural Bridge', 44.0688896179199, 0.769147221530649, -75.4941711425781, -1.31762185250208, 218, 40, 'PPL', 'P'),
(56461, 'Natural Bridge Junction', 38.7574996948242, 0.67644597951538, -90.4330596923828, -1.57835464428465, 218, 29, 'PPL', 'P'),
(104579, 'Natural Bridge Station', 37.6208305358887, 0.65660736018608, -79.5061111450195, -1.38764341493715, 218, 53, 'PPL', 'P'),
(10733, 'Natural Dam', 35.648609161377, 0.622185603622642, -94.3944396972656, -1.64749376829252, 218, 4, 'PPL', 'P'),
(150973, 'Natural Dam', 44.3372192382813, 0.77383045688658, -75.5033264160156, -1.31778164216748, 218, 40, 'PPL', 'P'),
(10734, 'Natural Steps', 34.8619384765625, 0.608455610043712, -92.4752807617188, -1.61399812599816, 218, 4, 'PPL', 'P'),
(104580, 'Natural Tunnel', 36.7000007629395, 0.640535848797724, -82.7505569458008, -1.44426967656329, 218, 53, 'PPL', 'P'),
(49751, 'Natural Woods', 39.1694412231445, 0.683635715510267, -77.415283203125, -1.35115158325839, 218, 25, 'PPL', 'P'),
(187101, 'Naturita', 38.2183303833008, 0.667035699803585, -108.568061828613, -1.89487014141808, 218, 7, 'PPL', 'P'),
(209632, 'Natwick', 41.9608306884766, 0.732354652385795, -105.056106567383, -1.83357495892687, 218, 59, 'PPL', 'P'),
(132238, 'Naubinway', 46.0924987792969, 0.804465864170198, -85.4475021362305, -1.49134024988211, 218, 27, 'PPL', 'P'),
(113764, 'Naubuc (historical)', 41.7224998474121, 0.728194994500173, -72.6113891601563, -1.26730781529165, 218, 8, 'PPL', 'P'),
(183564, 'Naud Junction', 34.0605583190918, 0.594468887735697, -118.235282897949, -2.06359497859616, 218, 6, 'PPL', 'P'),
(175464, 'Naugart', 45.0761108398438, 0.78672654814918, -89.788330078125, -1.56710198973074, 218, 57, 'PPL', 'P'),
(110604, 'Naugatuck', 37.7897186279297, 0.659555013459607, -82.3491668701172, -1.43726409815778, 218, 58, 'PPL', 'P'),
(113765, 'Naugatuck', 41.4858283996582, 0.724064298491406, -73.0511093139648, -1.27498237976298, 218, 8, 'PPL', 'P'),
(113766, 'Naugatuck Gardens', 41.2127799987793, 0.719298704878763, -73.095832824707, -1.27576295227848, 218, 8, 'PPL', 'P'),
(113767, 'Naugatuck Junction', 41.2075004577637, 0.719206559505047, -73.1061096191406, -1.2759423161779, 218, 8, 'PPL', 'P'),
(145857, 'Naughright', 40.7966690063477, 0.71203619800709, -74.7461090087891, -1.30456570525796, 218, 37, 'PPL', 'P'),
(193279, 'Naukati Bay', 55.8736114501953, 0.975178484785912, -133.184722900391, -2.32451192796811, 218, 1, 'PPL', 'P'),
(104581, 'Naulakla', 38.0827789306641, 0.664669880649213, -77.1811065673828, -1.34706442993345, 218, 53, 'PPL', 'P'),
(132239, 'Naults', 45.9916687011719, 0.802706047321873, -88.3938903808594, -1.54276442579294, 218, 27, 'PPL', 'P'),
(165029, 'Naumanstown', 40.1624984741211, 0.700967834200612, -76.4322204589844, -1.33399390161945, 218, 45, 'PPL', 'P'),
(150975, 'Naumburg', 43.9011116027832, 0.766218942754052, -75.4944381713867, -1.31762651303399, 218, 40, 'PPL', 'P'),
(150974, 'Nauraushaun', 41.0569381713867, 0.716578751878438, -73.9927825927734, -1.29141767895624, 218, 40, 'PPL', 'P'),
(169505, 'Nausauket', 41.6902809143066, 0.727632668036003, -71.438606262207, -1.24683889231135, 218, 47, 'PPL', 'P'),
(125519, 'Nauset Heights', 41.8041687011719, 0.729620384894611, -69.9436111450195, -1.22074630521519, 218, 23, 'PPL', 'P'),
(125520, 'Naushon Station', 41.4916687011719, 0.724166230982128, -70.7444381713867, -1.23472337356425, 218, 23, 'PPL', 'P'),
(82554, 'Nautical Watch Villas', 32.4019393920898, 0.565520526423618, -80.4347229003906, -1.4038507475411, 218, 48, 'PPL', 'P'),
(82555, 'Nauvassee (historical)', 34.9916687011719, 0.610719829602497, -80.9250030517578, -1.41240775043963, 218, 48, 'PPL', 'P'),
(4486, 'Nauvoo', 33.9894409179688, 0.593227654930639, -87.4888916015625, -1.52696921736768, 218, 2, 'PPL', 'P'),
(56458, 'Nauvoo', 36.5038909912109, 0.637113087585727, -93.5119400024414, -1.63209124297, 218, 29, 'PPL', 'P'),
(89328, 'Nauvoo', 36.0936088562012, 0.629952313467695, -89.4141693115234, -1.56057165242176, 218, 50, 'PPL', 'P'),
(120741, 'Nauvoo', 40.5499992370605, 0.707730998367895, -91.3847198486328, -1.59496424737126, 218, 18, 'PPL', 'P'),
(165031, 'Nauvoo', 40.1572189331055, 0.700875688826895, -76.8850021362305, -1.3418964326801, 218, 45, 'PPL', 'P'),
(165032, 'Nauvoo Estates', 40.1577796936035, 0.700885475943901, -76.8783264160156, -1.3417799193824, 218, 45, 'PPL', 'P'),
(89329, 'Navaho Hills', 36.1708297729492, 0.631300072716357, -83.4105606079102, -1.45578891354232, 218, 50, 'PPL', 'P'),
(17242, 'Navair', 30.1700000762939, 0.52656583665827, -82.5844421386719, -1.44137042624257, 218, 12, 'PPL', 'P'),
(178699, 'Navajo', 35.1241683959961, 0.613032385535067, -109.537498474121, -1.91179000277168, 218, 5, 'PPL', 'P'),
(189096, 'Navajo', 36.9461097717285, 0.644831261319913, -107.0625, -1.86859313041643, 218, 38, 'PPL', 'P'),
(197128, 'Navajo', 48.7922210693359, 0.851584907020861, -105.059722900391, -1.8336380758447, 218, 31, 'PPL', 'P'),
(183566, 'Navajo (historical)', 35.3788909912109, 0.617478133500791, -120.281112670898, -2.09930144406945, 218, 6, 'PPL', 'P'),
(189097, 'Navajo City', 36.7519416809082, 0.641442388832787, -107.601669311523, -1.87800341012822, 218, 38, 'PPL', 'P'),
(189098, 'Navajo Dam', 36.8002815246582, 0.642286078266124, -107.611938476563, -1.87818264086959, 218, 38, 'PPL', 'P'),
(178701, 'Navajo Gospel Mission', 36.0361099243164, 0.628948767789926, -110.508888244629, -1.92874395258723, 218, 5, 'PPL', 'P'),
(192718, 'Navajo lake Lodge', 37.5202789306641, 0.654852403606745, -112.802780151367, -1.96877991904466, 218, 52, 'PPL', 'P'),
(192717, 'Navajo Mountain', 37.0194396972656, 0.646111109960778, -110.790557861328, -1.93366001480146, 218, 52, 'PPL', 'P'),
(178702, 'Navajo Mountain Mission', 36.9347190856934, 0.644632456344539, -110.77555847168, -1.93339822606631, 218, 5, 'PPL', 'P'),
(189099, 'Navajo Wingate Village', 35.5497207641602, 0.620459675499189, -108.59806060791, -1.89539371888839, 218, 38, 'PPL', 'P'),
(208218, 'Naval Depot Junction', 47.5966682434082, 0.830718573826899, -122.71028137207, -2.14169843599129, 218, 56, 'PPL', 'P'),
(116983, 'Navan', 43.0977783203125, 0.752198131984084, -92.0625, -1.60679374261728, 218, 16, 'PPL', 'P'),
(150976, 'Navarino', 42.9275016784668, 0.749226243944638, -76.274169921875, -1.33123539936234, 218, 40, 'PPL', 'P'),
(175465, 'Navarino', 44.6111106872559, 0.778610764464245, -88.491943359375, -1.54447577310943, 218, 57, 'PPL', 'P'),
(17243, 'Navarre', 30.4013900756836, 0.530604354003807, -86.8636093139648, -1.5160559826947, 218, 12, 'PPL', 'P'),
(33384, 'Navarre', 38.7969398498535, 0.677134340078138, -97.1055603027344, -1.69481174927662, 218, 20, 'PPL', 'P'),
(156677, 'Navarre', 40.7244415283203, 0.710775590705101, -81.522216796875, -1.42283109663009, 218, 41, 'PPL', 'P'),
(189100, 'Navarre Place', 35.3236083984375, 0.616513270237855, -108.454719543457, -1.89289194536037, 218, 38, 'PPL', 'P'),
(96443, 'Navarro', 31.9983291625977, 0.558476199024249, -96.378059387207, -1.68211446298939, 218, 51, 'PPL', 'P'),
(183567, 'Navarro', 39.1519393920898, 0.683330250933235, -123.540832519531, -2.1561942881207, 218, 6, 'PPL', 'P'),
(96445, 'Navarro Mills', 31.9577808380127, 0.557768497254074, -96.6819381713867, -1.68741814830028, 218, 51, 'PPL', 'P'),
(96446, 'Navasota', 30.3877792358398, 0.530366800034572, -96.0875015258789, -1.67704327164166, 218, 51, 'PPL', 'P'),
(67115, 'Navassa', 34.2552795410156, 0.597867414181775, -78.0077819824219, -1.36149263777117, 218, 33, 'PPL', 'P'),
(4489, 'Navco', 30.6294403076172, 0.534584581410985, -88.1052780151367, -1.53772718974911, 218, 2, 'PPL', 'P'),
(4490, 'Nave', 32.4858283996582, 0.566984665811916, -87.2669372558594, -1.52309538324605, 218, 2, 'PPL', 'P'),
(89330, 'Navehill', 36.2822189331055, 0.633244180312115, -83.7216720581055, -1.46121883268888, 218, 50, 'PPL', 'P'),
(183568, 'Navelencia', 36.6833305358887, 0.640244898448633, -119.384719848633, -2.08365643792967, 218, 6, 'PPL', 'P'),
(145858, 'Navesink', 40.3994407653809, 0.705103257320314, -74.0358276367188, -1.29216895669975, 218, 37, 'PPL', 'P'),
(145859, 'Navesink Beach', 40.3894386291504, 0.704928687110859, -73.975830078125, -1.29112180175914, 218, 37, 'PPL', 'P'),
(96448, 'Navidad', 29.0652809143066, 0.507284849971719, -96.7688903808594, -1.68893575064747, 218, 51, 'PPL', 'P'),
(30603, 'Navilleton', 38.3816719055176, 0.669886547171488, -85.938606262207, -1.49991163385053, 218, 19, 'PPL', 'P'),
(76687, 'Navina', 35.7988891601563, 0.624808484401234, -97.5599975585938, -1.70274317563509, 218, 42, 'PPL', 'P'),
(178703, 'Naviska', 32.4925003051758, 0.56710111253058, -111.254440307617, -1.94175629083141, 218, 5, 'PPL', 'P'),
(96449, 'Navo', 33.2205581665039, 0.579808119355784, -96.9297180175781, -1.69174272243641, 218, 51, 'PPL', 'P'),
(104582, 'Navy', 38.889720916748, 0.678753675178961, -77.3783264160156, -1.35050656564238, 218, 53, 'PPL', 'P'),
(197129, 'Navy', 45.4847183227539, 0.793858094074248, -112.694999694824, -1.96689879520869, 218, 31, 'PPL', 'P'),
(201283, 'Navy Heights', 46.189998626709, 0.806167557527731, -123.778060913086, -2.16033470466745, 218, 43, 'PPL', 'P'),
(156678, 'Navy Park Housing Project (historical)', 41.457218170166, 0.723564955787016, -81.7402801513672, -1.42663702014393, 218, 41, 'PPL', 'P'),
(17244, 'Navy Point', 30.3797206878662, 0.530226151839502, -87.293327331543, -1.52355597695658, 218, 12, 'PPL', 'P'),
(3, 'Navy Town', 52.8408317565918, 0.922246493644906, 173.175567626953, 3.02248383910044, 218, 1, 'PPL', 'P'),
(208221, 'Navy Yard City', 47.5536117553711, 0.829967096346306, -122.663330078125, -2.14087898132387, 218, 56, 'PPL', 'P'),
(210764, 'Nawiliwili', 21.9658298492432, 0.383376053802143, -159.356384277344, -2.78129358971297, 218, 15, 'PPL', 'P'),
(178704, 'Nawt Vaya', 32.0330581665039, 0.559082334488351, -111.488327026367, -1.94583838415029, 218, 5, 'PPL', 'P'),
(104585, 'Naxera', 37.3405609130859, 0.65171573247485, -76.4475021362305, -1.33426061720262, 218, 53, 'PPL', 'P'),
(165033, 'Nay Aug', 41.399169921875, 0.722551822729322, -75.5869369506836, -1.31924092128679, 218, 45, 'PPL', 'P'),
(169506, 'Nayatt', 41.7269401550293, 0.728272492487894, -71.3363876342773, -1.24505484069711, 218, 47, 'PPL', 'P'),
(10735, 'Naylor', 35.1586112976074, 0.613633527572125, -92.1872177124023, -1.60897047733426, 218, 4, 'PPL', 'P'),
(23314, 'Naylor', 30.9086093902588, 0.539457001072853, -83.0783309936523, -1.44999041290089, 218, 13, 'PPL', 'P'),
(42242, 'Naylor', 32.3477783203125, 0.564575237394694, -93.6536102294922, -1.63456385488408, 218, 22, 'PPL', 'P'),
(49752, 'Naylor', 38.7122192382813, 0.675655686461899, -76.7461090087891, -1.33947229029785, 218, 25, 'PPL', 'P'),
(56459, 'Naylor', 36.5752792358398, 0.638359047501721, -90.603889465332, -1.58133618628305, 218, 29, 'PPL', 'P'),
(156679, 'Naylor', 40.9183311462402, 0.714159602923237, -80.9730606079102, -1.41324651302495, 218, 41, 'PPL', 'P'),
(208219, 'Naylor', 47.2627792358398, 0.824891111308615, -119.612503051758, -2.08763200480494, 218, 56, 'PPL', 'P'),
(13170, 'Naylor Gardens', 38.8566703796387, 0.67817683448685, -76.9669418334961, -1.34332655018547, 218, 9, 'PPL', 'P'),
(49753, 'Naylor Mill Village Trailer Park', 38.4111099243164, 0.670400337524791, -75.6069412231445, -1.3195900617057, 218, 25, 'PPL', 'P'),
(183569, 'Naylor Place', 34.6044387817383, 0.603961392546148, -118.664436340332, -2.071085119162, 218, 6, 'PPL', 'P'),
(104583, 'Naylors', 37.9747200012207, 0.662783896544246, -76.8597183227539, -1.34145514688747, 218, 53, 'PPL', 'P'),
(104584, 'Naylors Beach', 37.9775009155273, 0.662832432655113, -76.8633270263672, -1.34151813064725, 218, 53, 'PPL', 'P'),
(205085, 'Nayon Heights Condominium', 41.0750007629395, 0.716894003572476, -111.941673278809, -1.95375076890697, 218, 52, 'PPL', 'P'),
(137043, 'Naytahwaush', 47.2627792358398, 0.824891111308615, -95.6258316040039, -1.66898561144752, 218, 28, 'PPL', 'P'),
(37361, 'Nazareth', 37.8480606079102, 0.660573273102399, -85.4727783203125, -1.49178140251668, 218, 21, 'PPL', 'P'),
(165038, 'Nazareth', 40.7402801513672, 0.711052026826251, -75.3099975585938, -1.31440741706635, 218, 45, 'PPL', 'P'),
(191925, 'Nazareth', 34.5441703796387, 0.602909510494594, -102.10221862793, -1.78201988864846, 218, 51, 'PPL', 'P'),
(178705, 'Nazlini', 35.8963890075684, 0.626510177758768, -109.448059082031, -1.91022899089873, 218, 5, 'PPL', 'P'),
(210737, 'NÃƒÂ¤Ã‚â€˜ÃƒÂ¤lehu', 19.0638904571533, 0.332727656716852, -155.585830688477, -2.71548501496435, 218, 15, 'PPL', 'P'),
(210738, 'NÃƒÂ¤hiku', 20.8277797698975, 0.363513332864978, -156.094436645508, -2.7243618635098, 218, 15, 'PPL', 'P'),
(210751, 'NÃƒÂ¤nÃƒÂ¤kuli', 21.3905601501465, 0.373335703465949, -158.154724121094, -2.76032066349638, 218, 15, 'PPL', 'P'),
(210771, 'NÃƒÂ¯nole', 19.1338901519775, 0.333949381866926, -155.512496948242, -2.71420509974446, 218, 15, 'PPL', 'P'),
(4491, 'Ne Smith', 34.5961112976074, 0.603816050529657, -87.4283294677734, -1.52591220873103, 218, 2, 'PPL', 'P'),
(104586, 'Neabsco Hills', 38.6258316040039, 0.674147937810751, -77.334716796875, -1.34974543420283, 218, 53, 'PPL', 'P'),
(123269, 'Nead', 40.707218170166, 0.710474986397058, -86.1275024414063, -1.50320849412199, 218, 19, 'PPL', 'P'),
(28004, 'Neadmore', 39.2491683959961, 0.685027217179833, -87.8602828979492, -1.53345121830288, 218, 18, 'PPL', 'P'),
(37362, 'Neafus', 37.3950004577637, 0.652665881772763, -86.6119384765625, -1.51166349795078, 218, 21, 'PPL', 'P'),
(208220, 'Neah Bay', 48.3683280944824, 0.844186578933593, -124.623611450195, -2.17509234553201, 218, 56, 'PPL', 'P'),
(201284, 'Neahkahnie Beach', 45.7294387817383, 0.798129271830518, -123.939437866211, -2.16315126383632, 218, 43, 'PPL', 'P'),
(23316, 'Neal', 33.0508308410645, 0.576845818696261, -84.4858322143555, -1.47455594342799, 218, 13, 'PPL', 'P'),
(28005, 'Neal', 39.3019409179688, 0.685948271442837, -88.341667175293, -1.54185295890986, 218, 18, 'PPL', 'P'),
(33385, 'Neal', 37.834171295166, 0.660330858864174, -96.0800018310547, -1.67691237727408, 218, 20, 'PPL', 'P'),
(76688, 'Neal', 35.3330612182617, 0.616678253067386, -96.789436340332, -1.68929434528824, 218, 42, 'PPL', 'P'),
(110605, 'Neal', 38.3566703796387, 0.669450188226878, -82.5930633544922, -1.44152089484416, 218, 58, 'PPL', 'P'),
(183570, 'Neal', 37.4136085510254, 0.652990654267698, -122.142776489258, -2.13179360726507, 218, 6, 'PPL', 'P'),
(195373, 'Neal (historical)', 43.4830589294434, 0.758922547157507, -115.997222900391, -2.02453346278158, 218, 17, 'PPL', 'P'),
(89331, 'Neal Circle', 35.9291687011719, 0.627082291339944, -86.5483322143555, -1.51055335925038, 218, 50, 'PPL', 'P'),
(23317, 'Neal Crossing', 34.5527801513672, 0.603059779359102, -85.4150009155273, -1.49077299656992, 218, 13, 'PPL', 'P'),
(589, 'Neal Landing', 30.3727798461914, 0.530105011299417, -90.647216796875, -1.58209239087458, 218, 22, 'PPL', 'P'),
(82556, 'Neal Shoals', 34.6647186279297, 0.605013474334784, -81.4499969482422, -1.42157062248616, 218, 48, 'PPL', 'P'),
(10737, 'Neal Springs', 33.9244384765625, 0.592093148306265, -94.373893737793, -1.64713517365175, 218, 4, 'PPL', 'P'),
(42243, 'Neale', 30.7730598449707, 0.537091215207995, -93.4583282470703, -1.631155541321, 218, 22, 'PPL', 'P'),
(96450, 'Neale', 31.5227794647217, 0.550176291039449, -97.0238876342773, -1.69338629230315, 218, 51, 'PPL', 'P'),
(165035, 'Neale', 40.7033309936523, 0.710407142368289, -79.5583267211914, -1.38855474866217, 218, 45, 'PPL', 'P'),
(125521, 'Neale Place', 42.6566696166992, 0.744499332746829, -72.1369400024414, -1.25902711535621, 218, 23, 'PPL', 'P'),
(165036, 'Nealeys', 40.9541702270508, 0.71478511288427, -80.0822219848633, -1.39769844594885, 218, 45, 'PPL', 'P'),
(128226, 'Nealeys Corner', 44.6983299255371, 0.780133027343334, -68.9449996948242, -1.20331724746117, 218, 26, 'PPL', 'P'),
(183571, 'Nealeys Corner', 34.1872215270996, 0.596679577756572, -117.438331604004, -2.04968555453878, 218, 6, 'PPL', 'P'),
(165037, 'Nealmont', 40.6661109924316, 0.709757530799391, -78.2194366455078, -1.36518670851922, 218, 45, 'PPL', 'P'),
(17245, 'Neals', 29.7686100006104, 0.519560258252762, -82.7127838134766, -1.44361041103544, 218, 12, 'PPL', 'P'),
(61017, 'Neals (historical)', 33.9583282470703, 0.592684636384371, -88.9272232055664, -1.55207283959304, 218, 30, 'PPL', 'P'),
(73627, 'Neals Corner', 38.9627799987793, 0.680028796708891, -83.9741668701172, -1.46562569850269, 218, 41, 'PPL', 'P'),
(104588, 'Neals Corner', 36.8888893127441, 0.643832575911134, -78.7969436645508, -1.3752661074549, 218, 53, 'PPL', 'P'),
(128227, 'Neals Corner', 44.4850006103516, 0.776409728402322, -69.1119384765625, -1.20623087885177, 218, 26, 'PPL', 'P'),
(23322, 'Neals Landing', 30.9772205352783, 0.540654491457007, -85.0052795410156, -1.4836220095689, 218, 13, 'PPL', 'P'),
(110606, 'Neals Run', 39.4833297729492, 0.689114104188669, -78.4966735839844, -1.37002540590379, 218, 58, 'PPL', 'P'),
(37363, 'Nealton', 37.936939239502, 0.662124497858343, -84.6044387817383, -1.47662601854331, 218, 21, 'PPL', 'P'),
(37364, 'Nealy', 37.273609161377, 0.65054720396755, -82.866943359375, -1.44630100268474, 218, 21, 'PPL', 'P'),
(104589, 'Nealy Ridge', 37.1211090087891, 0.647885574195098, -82.3411102294922, -1.43712348325222, 218, 53, 'PPL', 'P'),
(42244, 'Neame', 30.9744396209717, 0.54060595534614, -93.2816696166992, -1.62807226656896, 218, 22, 'PPL', 'P'),
(89332, 'Neapolis', 35.7105598449707, 0.623266847025215, -86.9755630493164, -1.51800994398649, 218, 50, 'PPL', 'P'),
(156681, 'Neapolis', 41.4927787780762, 0.724185605479059, -83.8733291625977, -1.46386574849631, 218, 41, 'PPL', 'P'),
(4492, 'Near Acres Estates', 33.7105598449707, 0.588360261985328, -86.5811080932617, -1.51112540625253, 218, 2, 'PPL', 'P'),
(33386, 'Nearman', 39.1647186279297, 0.683553290674529, -94.6975021362305, -1.65278320569159, 218, 20, 'PPL', 'P'),
(73632, 'Nease Settlement', 39.021671295166, 0.681056643731607, -81.9555587768555, -1.43039434096786, 218, 41, 'PPL', 'P'),
(165039, 'Neason Hill', 41.6283302307129, 0.726551424633431, -80.1449966430664, -1.39879407042131, 218, 45, 'PPL', 'P'),
(165040, 'Neath', 41.8733291625977, 0.730827462658689, -76.1355590820313, -1.32881618382812, 218, 45, 'PPL', 'P'),
(67116, 'Neatman', 36.3136100769043, 0.633792059127371, -80.2647171020508, -1.40088358661259, 218, 33, 'PPL', 'P'),
(37365, 'Neatsville', 37.1972198486328, 0.649213958946829, -85.1255569458008, -1.48572124629815, 218, 21, 'PPL', 'P'),
(37366, 'Neave', 38.6474990844727, 0.674526106685542, -84.2022171020508, -1.46960592590986, 218, 21, 'PPL', 'P'),
(30604, 'Neavill Grove', 38.7833290100098, 0.676896786108903, -85.5116729736328, -1.49246024227854, 218, 19, 'PPL', 'P'),
(49754, 'Neavitt', 38.7244415283203, 0.675869005665214, -76.2827835083008, -1.33138573480588, 218, 25, 'PPL', 'P'),
(183572, 'Nebelhorn', 38.8113899230957, 0.677386541433369, -120.033332824707, -2.09497686993332, 218, 6, 'PPL', 'P'),
(137044, 'Nebish', 47.7713890075684, 0.833768026433094, -94.8472213745117, -1.65539629935317, 218, 28, 'PPL', 'P'),
(677, 'Nebo', 37.5711097717285, 0.655739569144878, -92.3349990844727, -1.61154974885, 218, 29, 'PPL', 'P'),
(4493, 'Nebo', 34.5550003051758, 0.603098528352963, -86.3375015258789, -1.50687366957222, 218, 2, 'PPL', 'P'),
(10741, 'Nebo', 36.4166717529297, 0.635590824706638, -94.4408264160156, -1.64830336926391, 218, 4, 'PPL', 'P'),
(23318, 'Nebo', 33.8383293151855, 0.590590259924106, -84.831672668457, -1.48059199803866, 218, 13, 'PPL', 'P'),
(28006, 'Nebo', 39.4425010681152, 0.688401508859991, -90.7908325195313, -1.58459895809256, 218, 18, 'PPL', 'P'),
(37368, 'Nebo', 37.2416687011719, 0.649989737772369, -87.1941680908203, -1.52182532172219, 218, 21, 'PPL', 'P'),
(42245, 'Nebo', 31.5886096954346, 0.551325245312736, -92.1416702270508, -1.60817552374887, 218, 22, 'PPL', 'P'),
(67120, 'Nebo', 35.7150001525879, 0.623344345012936, -81.9311065673828, -1.42996756940318, 218, 33, 'PPL', 'P'),
(76689, 'Nebo', 34.3613891601563, 0.599719376403816, -96.9524993896484, -1.69214033238716, 218, 42, 'PPL', 'P'),
(104590, 'Nebo', 36.9416694641113, 0.644753763332192, -81.4419403076172, -1.4214300075806, 218, 53, 'PPL', 'P'),
(110608, 'Nebo', 38.9883308410645, 0.680474743033425, -80.084716796875, -1.39774198863268, 218, 58, 'PPL', 'P'),
(165041, 'Nebo', 40.059440612793, 0.699169135200372, -79.3647232055664, -1.38517572987108, 218, 45, 'PPL', 'P'),
(183573, 'Nebo', 34.8800010681152, 0.60877086173775, -116.956672668457, -2.04127902024184, 218, 6, 'PPL', 'P'),
(23319, 'Nebo Gardens', 33.8416709899902, 0.590648583151979, -84.8197174072266, -1.48038333936725, 218, 13, 'PPL', 'P'),
(23320, 'Nebo Place', 33.8530616760254, 0.590847388127353, -84.8077774047852, -1.48017494701195, 218, 13, 'PPL', 'P'),
(89333, 'Neboville', 36.0566711425781, 0.629307628746814, -89.1302795410156, -1.55561684121366, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(30605, 'Nebraska', 39.0636100769043, 0.681788613557215, -85.4594421386719, -1.49154864223741, 218, 19, 'PPL', 'P'),
(67119, 'Nebraska', 35.4575004577637, 0.618850127515373, -76.063606262207, -1.32756037021609, 218, 33, 'PPL', 'P'),
(142474, 'Nebraska', 41.5002784729004, 0.724316499846636, -99.7502822875977, -1.74097085571236, 218, 35, 'ADM1', 'A'),
(165043, 'Nebraska', 41.524169921875, 0.724733484294315, -75.5374984741211, -1.31837805709361, 218, 45, 'PPL', 'P'),
(10740, 'Nebraska (historical)', 34.8705596923828, 0.608606078645301, -93.7533264160156, -1.63630423065645, 218, 4, 'PPL', 'P'),
(73628, 'Nebraska (historical)', 39.7041702270508, 0.692968497234341, -82.892219543457, -1.44674215531932, 218, 41, 'PPL', 'P'),
(199557, 'Nebraska Boys Ranch', 41.8963890075684, 0.731229932878427, -102.813888549805, -1.79444087197259, 218, 35, 'PPL', 'P'),
(142473, 'Nebraska City', 40.6766700744629, 0.709941821546825, -95.85888671875, -1.67305319053845, 218, 35, 'PPL', 'P'),
(23321, 'Nebula', 32.8502807617188, 0.573345559496543, -84.6772232055664, -1.47789634638328, 218, 13, 'PPL', 'P'),
(61018, 'Necaise', 30.6016693115234, 0.53409988609259, -89.4141693115234, -1.56057165242176, 218, 30, 'PPL', 'P'),
(201285, 'Necanicum (historical)', 45.9069404602051, 0.80122726054758, -123.78360748291, -2.16043151057307, 218, 43, 'PPL', 'P'),
(175470, 'Necedah', 44.0261116027832, 0.768400604319045, -90.0738906860352, -1.57208596255277, 218, 57, 'PPL', 'P'),
(96451, 'Necessity', 32.6483306884766, 0.569820865793823, -98.7747192382813, -1.72394406844099, 218, 51, 'PPL', 'P'),
(96452, 'Nechanitz', 30.045560836792, 0.524393962210283, -96.8266677856445, -1.68994415659422, 218, 51, 'PPL', 'P'),
(140561, 'Neche', 48.9861106872559, 0.854968919238997, -97.554443359375, -1.70264623657141, 218, 34, 'PPL', 'P'),
(96453, 'Neches', 31.8666706085205, 0.556178323767188, -95.4955596923828, -1.66671193766686, 218, 51, 'PPL', 'P'),
(56460, 'Neck City', 37.2569389343262, 0.650256253618459, -94.4441680908203, -1.64836169249178, 218, 29, 'PPL', 'P'),
(49755, 'Necker', 39.3913917541504, 0.687509483052869, -76.4886093139648, -1.33497807280029, 218, 25, 'PPL', 'P'),
(23326, 'Neco', 33.4144401550293, 0.583191998415866, -82.0069427490234, -1.43129116046495, 218, 13, 'PPL', 'P'),
(71157, 'Necombtown', 39.398609161377, 0.68763545057243, -75.0513916015625, -1.30989389165089, 218, 37, 'PPL', 'P'),
(4494, 'Nectar', 33.9597206115723, 0.592708937729318, -86.6394424438477, -1.51214353273726, 218, 2, 'PPL', 'P'),
(165044, 'Nectarine', 41.1958312988281, 0.719002894260683, -79.9316711425781, -1.39507083805933, 218, 45, 'PPL', 'P'),
(37369, 'Ned', 37.4083290100098, 0.652898508893981, -83.2708282470703, -1.45335012377408, 218, 21, 'PPL', 'P'),
(78801, 'Ned', 39.725830078125, 0.693346532951077, -80.4824981689453, -1.4046845832784, 218, 45, 'PPL', 'P'),
(82557, 'Ned Swamp', 33.8716697692871, 0.591172160622288, -79.1313934326172, -1.38110335709019, 218, 48, 'PPL', 'P'),
(175469, 'Neda', 43.4213905334473, 0.757846230602952, -88.5374984741211, -1.54527085985287, 218, 57, 'PPL', 'P'),
(96454, 'Nederland', 29.9741706848145, 0.523147969004776, -93.9922180175781, -1.64047367565908, 218, 51, 'PPL', 'P'),
(187102, 'Nederland', 39.9613914489746, 0.697457854462915, -105.510276794434, -1.84150172475343, 218, 7, 'PPL', 'P'),
(201286, 'Nedonna Beach', 45.6441688537598, 0.796641030834354, -123.938888549805, -2.16314167645639, 218, 43, 'PPL', 'P'),
(150977, 'Nedrow', 42.9749984741211, 0.750055219412952, -76.1416702270508, -1.32892284342977, 218, 40, 'PPL', 'P'),
(183574, 'Need', 38.3022193908691, 0.668499839191883, -121.323608398438, -2.11749642695298, 218, 6, 'PPL', 'P'),
(165045, 'Needful', 41.0308303833008, 0.716123085015926, -78.3419418334961, -1.36732482740039, 218, 45, 'PPL', 'P'),
(73629, 'Needfull', 39.1041717529297, 0.682496548353986, -83.8594436645508, -1.46362340083711, 218, 41, 'PPL', 'P'),
(4495, 'Needham', 31.9877796173096, 0.558292074724384, -88.336669921875, -1.54176574038416, 218, 2, 'PPL', 'P'),
(10742, 'Needham', 35.8224983215332, 0.625220542000897, -90.5350036621094, -1.58013390220893, 218, 4, 'PPL', 'P'),
(23323, 'Needham', 31.1558303833008, 0.543771821381486, -82.4286117553711, -1.43865067297933, 218, 13, 'PPL', 'P'),
(30606, 'Needham', 39.5299987792969, 0.68992863200807, -85.9711074829102, -1.50047888716272, 218, 19, 'PPL', 'P'),
(125522, 'Needham', 42.2833290100098, 0.737983309928705, -71.2333297729492, -1.24325614169687, 218, 23, 'PPL', 'P'),
(125523, 'Needham Corner', 42.5180587768555, 0.742080117212601, -70.9499969482422, -1.23831105102676, 218, 23, 'PPL', 'P'),
(125524, 'Needham Heights', 42.2944412231445, 0.73817725463509, -71.2333297729492, -1.24325614169687, 218, 23, 'PPL', 'P'),
(125525, 'Needham Junction', 42.2722206115723, 0.737789431801347, -71.2458267211914, -1.24347425459015, 218, 23, 'PPL', 'P'),
(183575, 'Needles', 34.8480606079102, 0.608213395542569, -114.613327026367, -2.00037992327511, 218, 6, 'PPL', 'P'),
(187103, 'Needleton', 37.6405601501465, 0.656951706915027, -107.690826416016, -1.87955949515316, 218, 7, 'PPL', 'P'),
(4500, 'Needmore', 34.2472190856934, 0.597726732697191, -87.579719543457, -1.52855446400655, 218, 2, 'PPL', 'P'),
(10744, 'Needmore', 34.8088912963867, 0.607529762090746, -94.0386123657227, -1.64128340978851, 218, 4, 'PPL', 'P'),
(17246, 'Needmore', 30.5361099243164, 0.532955658930238, -82.6313934326172, -1.44218988090999, 218, 12, 'PPL', 'P'),
(23325, 'Needmore', 30.6788902282715, 0.535447645341252, -82.711669921875, -1.44359096995948, 218, 13, 'PPL', 'P'),
(30610, 'Needmore', 39.6188888549805, 0.691480056501095, -87.4102783203125, -1.52559715677407, 218, 19, 'PPL', 'P'),
(37374, 'Needmore', 38.5744400024414, 0.673250985155612, -84.7341690063477, -1.4788902381021, 218, 21, 'PPL', 'P'),
(56463, 'Needmore', 38.0716705322266, 0.664476002521855, -90.2383270263672, -1.57495591810149, 218, 29, 'PPL', 'P'),
(67124, 'Needmore', 35.3266716003418, 0.616566733196739, -83.523063659668, -1.45775246221403, 218, 33, 'PPL', 'P'),
(76690, 'Needmore', 35.1311111450195, 0.613153559364666, -97.2119369506836, -1.69666837203057, 218, 42, 'PPL', 'P'),
(78802, 'Needmore', 39.8458290100098, 0.695440909411343, -78.1449966430664, -1.36388748538142, 218, 45, 'PPL', 'P'),
(89338, 'Needmore', 36.4661102294922, 0.636453688899824, -87.57861328125, -1.52853515608865, 218, 50, 'PPL', 'P'),
(104591, 'Needmore', 36.9577789306641, 0.645034926564277, -82.6327819824219, -1.44221411567591, 218, 53, 'PPL', 'P'),
(110610, 'Needmore', 39.0505599975586, 0.681560846704986, -78.7869415283203, -1.37509153724544, 218, 58, 'PPL', 'P'),
(132240, 'Needmore', 42.6833305358887, 0.744964653568293, -84.8561096191406, -1.48101850328724, 218, 27, 'PPL', 'P'),
(156684, 'Needmore', 40.1958312988281, 0.70154960174074, -84.5027770996094, -1.47485168746705, 218, 41, 'PPL', 'P'),
(191927, 'Needmore', 33.3266716003418, 0.581660148156852, -102.326110839844, -1.78592754491593, 218, 51, 'PPL', 'P'),
(61019, 'Needmore (historical)', 33.8822212219238, 0.591356318211667, -90.1688919067383, -1.57374404664745, 218, 30, 'PPL', 'P'),
(156682, 'Needmore (historical)', 40.7794418334961, 0.71173552712002, -84.3080596923828, -1.4714532276, 218, 41, 'PPL', 'P'),
(96457, 'Needville', 29.399169921875, 0.513112312490003, -95.8375015258789, -1.67267994851168, 218, 51, 'PPL', 'P'),
(201287, 'Needy', 45.172779083252, 0.788413727278772, -122.701393127441, -2.14154330685779, 218, 43, 'PPL', 'P'),
(4501, 'Neel', 34.4655609130859, 0.601537516480013, -87.0611114501953, -1.51950304525164, 218, 2, 'PPL', 'P'),
(73630, 'Neel', 38.7705612182617, 0.676673946104691, -83.7152786254883, -1.4611072462392, 218, 41, 'PPL', 'P'),
(110609, 'Neel (historical)', 39.4277801513672, 0.688144580393826, -80.0008316040039, -1.3962779158234, 218, 58, 'PPL', 'P'),
(49756, 'Neeld Estates', 38.6130599975586, 0.673925031227511, -76.5144424438477, -1.33542894597284, 218, 25, 'PPL', 'P'),
(132241, 'Neeley', 42.5, 0.74176493209759, -85.554443359375, -1.49320672633209, 218, 27, 'PPL', 'P'),
(195374, 'Neeley', 42.7336082458496, 0.745842165147474, -112.914169311523, -1.97072402664042, 218, 17, 'PPL', 'P'),
(192719, 'Neels', 39.0449981689453, 0.681463774483253, -112.768608093262, -1.96818350411854, 218, 52, 'PPL', 'P'),
(49757, 'Neelsville', 39.1952781677246, 0.684086655261845, -77.2441711425781, -1.34816511441198, 218, 25, 'PPL', 'P'),
(4502, 'Neely', 30.7319393157959, 0.536373526583732, -88.1002807617188, -1.53763997122341, 218, 2, 'PPL', 'P'),
(61020, 'Neely', 31.1647205352783, 0.543926983804496, -88.7547225952148, -1.54906213598071, 218, 30, 'PPL', 'P'),
(89339, 'Neely', 35.542781829834, 0.620338568248618, -88.9527816772461, -1.55251891907563, 218, 50, 'PPL', 'P'),
(89340, 'Neely Crossroads', 36.5033302307129, 0.637103300468721, -85.4511108398438, -1.49140323364189, 218, 50, 'PPL', 'P'),
(23327, 'Neely Farm', 33.9791717529297, 0.593048424189276, -84.2527770996094, -1.47048836433706, 218, 13, 'PPL', 'P'),
(191928, 'Neely Ward', 33.7571907043457, 0.589174124014456, -102.901298522949, -1.79596646380304, 218, 51, 'PPL', 'P'),
(56466, 'Neelys Landing', 37.5022201538086, 0.654537218491734, -89.5019378662109, -1.56210350268077, 218, 29, 'PPL', 'P'),
(73631, 'Neelysville', 39.6269416809082, 0.691620604827624, -81.7777786254883, -1.42729149198181, 218, 41, 'PPL', 'P'),
(165046, 'Neelyton', 40.160831451416, 0.700938739165703, -77.8227767944336, -1.3582636881075, 218, 45, 'PPL', 'P'),
(150978, 'Neelytown', 41.4836082458496, 0.724025549497545, -74.2441711425781, -1.29580523685215, 218, 40, 'PPL', 'P'),
(56465, 'Neelyville', 36.5616683959961, 0.638121493532486, -90.5061111450195, -1.57962963265653, 218, 29, 'PPL', 'P'),
(4503, 'Neenah', 31.9144401550293, 0.557012059635951, -87.1780624389648, -1.52154422506913, 218, 2, 'PPL', 'P'),
(104592, 'Neenah', 38.0483283996582, 0.664068605454101, -76.720832824707, -1.33903113766328, 218, 53, 'PPL', 'P'),
(175471, 'Neenah', 44.1858291625977, 0.771188201611058, -88.4625015258789, -1.54396191617709, 218, 57, 'PPL', 'P'),
(139354, 'Neeper', 40.3325004577637, 0.703934928550096, -91.791389465332, -1.60206197115048, 218, 29, 'PPL', 'P'),
(104594, 'Neersville', 39.2611083984375, 0.685235609535132, -77.7261123657227, -1.35657657555694, 218, 53, 'PPL', 'P'),
(112280, 'Neese', 34.0774993896484, 0.594764565195723, -83.3152770996094, -1.45412590259962, 218, 13, 'PPL', 'P'),
(82558, 'Neeses', 33.5316696166992, 0.585238038502346, -81.1233291625977, -1.41586919406646, 218, 48, 'PPL', 'P'),
(76691, 'Neff', 35.0727806091309, 0.612135499458956, -94.591667175293, -1.65093603715951, 218, 42, 'PPL', 'P'),
(104593, 'Neff', 36.7102813720703, 0.640715279276168, -81.8627777099609, -1.42877500586704, 218, 53, 'PPL', 'P'),
(165047, 'Neff', 40.5436096191406, 0.707619478497248, -78.0841674804688, -1.36282581621286, 218, 45, 'PPL', 'P'),
(178706, 'Neff', 31.4791698455811, 0.549415159599904, -109.97917175293, -1.91949865570497, 218, 5, 'PPL', 'P'),
(183576, 'Neff', 33.809440612793, 0.590086056950727, -117.931938171387, -2.05830061434908, 218, 6, 'PPL', 'P'),
(30611, 'Neff Corner', 39.1652793884277, 0.683563077791535, -85.5322189331055, -1.49281883691932, 218, 19, 'PPL', 'P'),
(156683, 'Neffs', 40.0272216796875, 0.698606808736202, -80.8152770996094, -1.41049267129976, 218, 41, 'PPL', 'P'),
(165048, 'Neffs', 40.6944389343262, 0.710251946655764, -75.6100006103516, -1.31964345808556, 218, 45, 'PPL', 'P'),
(165049, 'Neffs Mills', 40.6358299255371, 0.709229026481065, -77.9641723632813, -1.36073150633163, 218, 45, 'PPL', 'P'),
(165050, 'Neffsville', 40.0999984741211, 0.699877003418115, -76.3055572509766, -1.33178321159857, 218, 45, 'PPL', 'P'),
(139355, 'Nefy (historical)', 40.1538887023926, 0.700817565336104, -92.7013931274414, -1.6179445312595, 218, 29, 'PPL', 'P'),
(30612, 'Negangards Corner', 39.1911087036133, 0.684013884385058, -85.0947189331055, -1.48518302144185, 218, 19, 'PPL', 'P'),
(132242, 'Negaunee', 46.4991683959961, 0.811563587949422, -87.6116714477539, -1.52911212993881, 218, 27, 'PPL', 'P'),
(96458, 'Negley', 33.7599983215332, 0.589223126178514, -95.0849990844727, -1.65954630327984, 218, 51, 'PPL', 'P'),
(156685, 'Negley', 40.7900009155273, 0.711919817867454, -80.5391693115234, -1.40567368130726, 218, 41, 'PPL', 'P'),
(189101, 'Negra', 34.663890838623, 0.604999026685871, -105.536666870117, -1.84196231846396, 218, 38, 'PPL', 'P'),
(42246, 'Negreet', 31.4691696166992, 0.549240622679963, -93.5747222900391, -1.63318700060051, 218, 22, 'PPL', 'P'),
(76692, 'Negro Bend', 34.3258285522461, 0.599098726711773, -95.9352798461914, -1.6743865021382, 218, 42, 'PPL', 'P'),
(10745, 'Negro Bend (historical)', 33.4180603027344, 0.583255181912728, -91.9763870239258, -1.60529078765609, 218, 4, 'PPL', 'P'),
(191929, 'Negro Crossing', 31.353609085083, 0.547223710917905, -100.536392211914, -1.75469106217429, 218, 51, 'PPL', 'P'),
(89341, 'Negro Gull (historical)', 35.785831451416, 0.624580584390951, -85.9499969482422, -1.5001104388259, 218, 50, 'PPL', 'P'),
(10746, 'Negro Head Corner', 35.3438911437988, 0.616867270925754, -91.3574981689453, -1.59448913943279, 218, 4, 'PPL', 'P'),
(197130, 'Negro Prairie (historical)', 48.1208305358887, 0.839866931645485, -114.016670227051, -1.98996629762263, 218, 31, 'PPL', 'P'),
(96459, 'Negros Liberty Settlement', 30.0125007629395, 0.523816955070604, -94.7847213745117, -1.65430546857067, 218, 51, 'PPL', 'P'),
(17247, 'Negrotown Knoll', 27.3058300018311, 0.476576638521801, -81.5363922119141, -1.42307850429536, 218, 12, 'PPL', 'P'),
(201288, 'Nehalem', 45.7202796936035, 0.797969415586086, -123.892776489258, -2.16233686917497, 218, 43, 'PPL', 'P'),
(150981, 'Nehasane', 44.0041694641113, 0.768017641754291, -74.7769393920898, -1.30510379695621, 218, 40, 'PPL', 'P'),
(142475, 'Nehawka', 40.8294410705566, 0.712608178430212, -95.9913864135742, -1.67536574647102, 218, 35, 'PPL', 'P'),
(17248, 'Neheb', 28.6916694641113, 0.50076410004266, -81.2005615234375, -1.41721715305221, 218, 12, 'PPL', 'P'),
(128228, 'Nehumkeag (historical)', 44.1694412231445, 0.770902178109984, -69.7538909912109, -1.21743506387384, 218, 26, 'PPL', 'P'),
(110611, 'Neibert', 37.7880592346191, 0.659526051582752, -81.9419403076172, -1.43015665384058, 218, 58, 'PPL', 'P'),
(56467, 'Neier', 38.3911094665527, 0.670051263684909, -91.1102828979492, -1.59017441899269, 218, 29, 'PPL', 'P'),
(165051, 'Neiffer', 40.2627792358398, 0.702718063669012, -75.5205612182617, -1.31808244621261, 218, 45, 'PPL', 'P'),
(82559, 'Neighbors Crossroads', 34.4580612182617, 0.601406622112435, -81.8066711425781, -1.42779576153422, 218, 48, 'PPL', 'P'),
(4505, 'Neighbors Mill', 34.3886108398438, 0.600194484342286, -86.4247207641602, -1.5083959324513, 218, 2, 'PPL', 'P'),
(197131, 'Neihart', 46.9333305358887, 0.819141146778052, -110.735000610352, -1.93269035784857, 218, 31, 'PPL', 'P'),
(61021, 'Neil', 34.5961112976074, 0.603816050529657, -88.2302780151367, -1.5399088513141, 218, 30, 'PPL', 'P'),
(89342, 'Neil', 35.0349998474121, 0.611476100773052, -86.3152770996094, -1.50648578015945, 218, 50, 'PPL', 'P'),
(78803, 'Neil Corner', 39.8997192382813, 0.696381471329332, -79.9844436645508, -1.39599189232233, 218, 45, 'PPL', 'P'),
(17249, 'Neilhurst', 30.1208305358887, 0.525707666286505, -81.7275009155273, -1.42641398040263, 218, 12, 'PPL', 'P'),
(76693, 'Neill', 34.8216705322266, 0.60775280183204, -97.5122222900391, -1.70190933989779, 218, 42, 'PPL', 'P'),
(175474, 'Neillsville', 44.560001373291, 0.777718738657123, -90.5961074829102, -1.58120036506745, 218, 57, 'PPL', 'P'),
(165052, 'Neilltown', 41.6055603027344, 0.726154014419764, -79.5058288574219, -1.38763848808913, 218, 45, 'PPL', 'P'),
(17250, 'Neilson', 27.6780605316162, 0.483073286842995, -81.501106262207, -1.42246264829328, 218, 12, 'PPL', 'P'),
(28007, 'Neilson', 37.6302795410156, 0.656772276436583, -88.960563659668, -1.55265474029122, 218, 18, 'PPL', 'P'),
(205087, 'Neilson', 40.6333312988281, 0.709185417218215, -111.609169006348, -1.94794747457557, 218, 52, 'PPL', 'P'),
(208222, 'Neilton', 47.4130592346191, 0.827513992087207, -123.879173278809, -2.16209944836379, 218, 56, 'PPL', 'P'),
(78804, 'Neiman', 39.8188896179199, 0.694970728320889, -76.7941665649414, -1.34031105288317, 218, 45, 'PPL', 'P'),
(191930, 'Neinda', 32.7966690063477, 0.572409857847544, -100.092498779297, -1.74694366024714, 218, 51, 'PPL', 'P'),
(42247, 'Neita', 30.8355598449707, 0.538182045990491, -91.8108291625977, -1.60240125787336, 218, 22, 'PPL', 'P'),
(113324, 'Nekoda', 40.5858306884766, 0.708356375170873, -77.0999984741211, -1.34564882665602, 218, 45, 'PPL', 'P'),
(33398, 'Nekoma', 38.4736099243164, 0.671491168307288, -99.4416732788086, -1.73558461240768, 218, 20, 'PPL', 'P'),
(120747, 'Nekoma', 41.172779083252, 0.718600557198999, -90.188606262207, -1.57408812706029, 218, 18, 'PPL', 'P'),
(140564, 'Nekoma', 48.577220916748, 0.847832446465912, -98.370002746582, -1.71688043312372, 218, 34, 'PPL', 'P'),
(175477, 'Nekoosa', 44.3125, 0.773399024789987, -89.904167175293, -1.56912372847227, 218, 57, 'PPL', 'P'),
(175478, 'Nekoosa Junction', 44.3377799987793, 0.773840244003586, -89.8891677856445, -1.56886193973712, 218, 57, 'PPL', 'P'),
(76694, 'Nelagoney', 36.6263885498047, 0.639251073308843, -96.241943359375, -1.67973879013899, 218, 42, 'PPL', 'P'),
(212020, 'Nelchina', 61.9919395446777, 1.0819634547519, -146.768615722656, -2.56159558295467, 218, 1, 'PPL', 'P'),
(61022, 'Nelia (historical)', 33.4297218322754, 0.583458713999037, -90.9419403076172, -1.58723628652006, 218, 30, 'PPL', 'P'),
(142478, 'Neligh', 42.1286087036133, 0.735282931162392, -98.0294418334961, -1.71093652388677, 218, 35, 'PPL', 'P'),
(165054, 'Nelighsville', 40.6983299255371, 0.710319857263561, -75.4499969482422, -1.3168508673665, 218, 45, 'PPL', 'P'),
(37375, 'Nell', 37.0094413757324, 0.645936606330351, -85.4833297729492, -1.49196556010606, 218, 21, 'PPL', 'P'),
(96464, 'Nell', 28.7108306884766, 0.501098526496546, -98.0713882446289, -1.71166862687044, 218, 51, 'PPL', 'P'),
(10747, 'Nella', 34.7602806091309, 0.606681345546474, -94.163330078125, -1.64346014450549, 218, 4, 'PPL', 'P'),
(67126, 'Nella', 36.5691719055176, 0.63825245447909, -81.5475006103516, -1.42327238242272, 218, 33, 'PPL', 'P'),
(96460, 'Nelle Estates Colonia', 26.2819995880127, 0.458707426818615, -98.1210021972656, -1.71253455369888, 218, 51, 'PPL', 'P'),
(96461, 'Nelleva', 30.454439163208, 0.531530235246287, -96.1861114501953, -1.67876433949613, 218, 51, 'PPL', 'P'),
(4504, 'Nellie', 31.9013900756836, 0.556784292783722, -87.3827819824219, -1.52511725514564, 218, 2, 'PPL', 'P'),
(67127, 'Nellie', 35.6263885498047, 0.6217977807889, -83.1125030517578, -1.45058682782701, 218, 33, 'PPL', 'P'),
(76695, 'Nellie', 34.5794410705566, 0.603525100180566, -98.1241683959961, -1.7125898142915, 218, 42, 'PPL', 'P'),
(156686, 'Nellie', 40.3363914489746, 0.704002839157893, -82.0680618286133, -1.43235788963958, 218, 41, 'PPL', 'P'),
(165053, 'Nellie', 40.0250015258789, 0.698568059742341, -79.6780624389648, -1.39064453116956, 218, 45, 'PPL', 'P'),
(61023, 'Nellieburg', 32.4066696166992, 0.56560308441741, -88.7772216796875, -1.54945481908344, 218, 30, 'PPL', 'P'),
(110613, 'Nellis', 38.1508293151855, 0.665857583916361, -81.7427825927734, -1.4266806959858, 218, 58, 'PPL', 'P'),
(191931, 'Nellis Lands Colonia', 28.6860008239746, 0.500665163608163, -100.485000610352, -1.75379410951915, 218, 51, 'PPL', 'P'),
(150979, 'Nelliston', 42.9347190856934, 0.749352211464199, -74.6138916015625, -1.30225807617341, 218, 40, 'PPL', 'P'),
(132245, 'Nellsville', 44.3358306884766, 0.77380622212066, -84.8133316040039, -1.48027188607563, 218, 27, 'PPL', 'P'),
(67130, 'Nelly Green Estates', 35.8022193908691, 0.624866607892025, -80.831672668457, -1.41077882795889, 218, 33, 'PPL', 'P'),
(49759, 'Nellys Corner (historical)', 39.7133293151855, 0.693128353478773, -75.936393737793, -1.32534009281529, 218, 25, 'PPL', 'P'),
(104595, 'Nellysford', 37.8902816772461, 0.661310169776024, -78.8724975585938, -1.37658477166865, 218, 53, 'PPL', 'P'),
(175480, 'Nelma', 46.019718170166, 0.803195602909257, -88.8177795410156, -1.55016268730118, 218, 57, 'PPL', 'P'),
(67128, 'Nelms', 35.0513916015625, 0.611762190853154, -76.7052764892578, -1.33875962839015, 218, 33, 'PPL', 'P'),
(37376, 'Nelse', 37.4038887023926, 0.65282101090626, -82.4402770996094, -1.43885427164466, 218, 21, 'PPL', 'P'),
(4508, 'Nelson', 33.2152786254883, 0.579715973982067, -86.5811080932617, -1.51112540625253, 218, 2, 'PPL', 'P'),
(23328, 'Nelson', 34.3819389343262, 0.600078037623622, -84.3711090087891, -1.47255364576242, 218, 13, 'PPL', 'P'),
(37377, 'Nelson', 37.329719543457, 0.6515265148794, -87.0508270263672, -1.51932354819417, 218, 21, 'PPL', 'P'),
(49761, 'Nelson', 37.9691696166992, 0.662687024059595, -75.8488922119141, -1.32381290308818, 218, 25, 'PPL', 'P'),
(56468, 'Nelson', 38.9947204589844, 0.680586262904072, -93.0325012207031, -1.62372345766691, 218, 29, 'PPL', 'P'),
(67129, 'Nelson', 35.8822212219238, 0.626262903251554, -78.8502807617188, -1.37619701541393, 218, 33, 'PPL', 'P'),
(76696, 'Nelson', 34.1272201538086, 0.595632356236926, -95.6849975585938, -1.6700182521602, 218, 42, 'PPL', 'P'),
(96462, 'Nelson', 32.3136100769043, 0.563978889047598, -96.8566665649414, -1.69046773406453, 218, 51, 'PPL', 'P'),
(104597, 'Nelson', 36.5622215270996, 0.638131147491437, -78.7050018310547, -1.37366141974007, 218, 53, 'PPL', 'P'),
(110612, 'Nelson', 38.0688896179199, 0.664427466410989, -81.6227798461914, -1.42458625294651, 218, 58, 'PPL', 'P'),
(120748, 'Nelson', 41.7963905334473, 0.729484630258044, -89.6016693115234, -1.56384414476924, 218, 18, 'PPL', 'P'),
(132246, 'Nelson', 43.334171295166, 0.756323967723862, -84.2297210693359, -1.47008596069635, 218, 27, 'PPL', 'P'),
(137046, 'Nelson', 45.8894386291504, 0.800921795970547, -95.2638931274414, -1.66266859334185, 218, 28, 'PPL', 'P'),
(142482, 'Nelson', 40.2016716003418, 0.701651534231462, -98.067497253418, -1.71160071626264, 218, 35, 'PPL', 'P'),
(144181, 'Nelson', 42.9905586242676, 0.750326795265113, -72.1313934326172, -1.25893030945058, 218, 36, 'PPL', 'P'),
(150980, 'Nelson', 42.9172210693359, 0.749046813466194, -75.7772216796875, -1.32256201632417, 218, 40, 'PPL', 'P'),
(156687, 'Nelson', 41.310001373291, 0.720995537967307, -81.0516662597656, -1.41461844046051, 218, 41, 'PPL', 'P'),
(165055, 'Nelson', 41.978328704834, 0.7326600503838, -77.2363891601563, -1.34802929319638, 218, 45, 'PPL', 'P'),
(175481, 'Nelson', 44.420280456543, 0.775280148625965, -92.008056640625, -1.60584352674034, 218, 57, 'PPL', 'P'),
(178708, 'Nelson', 35.5141716003418, 0.619839225544228, -113.319442749023, -1.97779738249567, 218, 5, 'PPL', 'P'),
(183578, 'Nelson', 39.5522193908691, 0.690316454841813, -121.764442443848, -2.12519043250027, 218, 6, 'PPL', 'P'),
(190530, 'Nelson', 35.7080612182617, 0.623223237762365, -114.823890686035, -2.00405495242136, 218, 39, 'PPL', 'P'),
(194339, 'Nelson', 40.2527809143066, 0.702543560038584, -103.660278320313, -1.80921316022315, 218, 7, 'PPL', 'P'),
(197132, 'Nelson', 46.8169403076172, 0.817109754077567, -111.808326721191, -1.95142343243035, 218, 31, 'PPL', 'P'),
(208223, 'Nelson', 47.1938896179199, 0.823688760655471, -121.051940917969, -2.1127549349482, 218, 56, 'PPL', 'P'),
(195376, 'Nelson (historical)', 47.6541709899902, 0.831722186083695, -116.088890075684, -2.02613335680645, 218, 17, 'PPL', 'P'),
(197133, 'Nelson (historical)', 47.1047210693359, 0.822132475893456, -109.237503051758, -1.90655409491053, 218, 31, 'PPL', 'P'),
(183577, 'Nelson Bar (historical)', 39.6958312988281, 0.692822955480768, -121.560279846191, -2.12162712296175, 218, 6, 'PPL', 'P'),
(96463, 'Nelson City', 29.8772201538086, 0.521455863027167, -98.7949981689453, -1.72429800254986, 218, 51, 'PPL', 'P'),
(150982, 'Nelson Corner', 44.3722190856934, 0.774441319461617, -75.6941680908203, -1.32111245774284, 218, 40, 'PPL', 'P'),
(150983, 'Nelson Corners', 41.4124984741211, 0.722784449850541, -73.9130630493164, -1.29002631044473, 218, 40, 'PPL', 'P'),
(4509, 'Nelson Heights', 33.6022186279297, 0.586469351032344, -86.7113876342773, -1.51339921319124, 218, 2, 'PPL', 'P'),
(82560, 'Nelson Hill', 33.3494415283203, 0.582057558370519, -80.1500015258789, -1.39888142210507, 218, 48, 'PPL', 'P'),
(4510, 'Nelson Landing', 31.0855598449707, 0.542545369120477, -87.8636093139648, -1.53350927521464, 218, 2, 'PPL', 'P'),
(183579, 'Nelson Mill', 39.4313888549805, 0.688207564153606, -120.997779846191, -2.11180964591928, 218, 6, 'PPL', 'P'),
(104598, 'Nelson Park', 37.2669410705566, 0.650430823827914, -76.6708297729492, -1.33815841977406, 218, 53, 'PPL', 'P'),
(189102, 'Nelson Place', 34.776668548584, 0.606967369047548, -106.334167480469, -1.85588132990126, 218, 38, 'PPL', 'P'),
(119, 'Nelsonia', 37.8197212219238, 0.660078657508944, -75.5875015258789, -1.31925077498282, 218, 53, 'PPL', 'P'),
(113366, 'Nelsons Corner', 43.4102783203125, 0.757652285896567, -72.4899978637695, -1.26518913748643, 218, 55, 'PPL', 'P'),
(113769, 'Nelsons Corner', 41.9461097717285, 0.73209772391963, -73.0508270263672, -1.27497745291497, 218, 8, 'PPL', 'P'),
(208224, 'Nelsons Corner', 47.9219398498535, 0.836395634322621, -122.299171447754, -2.13452321422435, 218, 56, 'PPL', 'P'),
(183580, 'Nelsons Crossing', 39.663890838623, 0.692265489285587, -121.214721679688, -2.1155959951991, 218, 6, 'PPL', 'P'),
(197134, 'Nelsons Crossing (historical)', 45.7874984741211, 0.799142604625293, -111.251388549805, -1.94170302760961, 218, 31, 'PPL', 'P'),
(125527, 'Nelsons Grove', 41.8486099243164, 0.730396030562096, -70.9319381713867, -1.23799586591174, 218, 23, 'PPL', 'P'),
(125528, 'Nelsons Shores', 41.8250007629395, 0.729983972962434, -70.9375, -1.23809293813348, 218, 23, 'PPL', 'P'),
(197135, 'Nelsons Trailer Court', 45.6888885498047, 0.797421536770829, -111.058326721191, -1.93833346304039, 218, 31, 'PPL', 'P'),
(89343, 'Nelsontown', 36.5561103820801, 0.63802448788978, -82.5491714477539, -1.4407548365566, 218, 50, 'PPL', 'P'),
(10749, 'Nelsonville', 36.0699996948242, 0.629540255868033, -91.4263916015625, -1.59569155666496, 218, 4, 'PPL', 'P'),
(37379, 'Nelsonville', 37.7308311462402, 0.658527233015918, -85.6397171020508, -1.49469503390728, 218, 21, 'PPL', 'P'),
(56475, 'Nelsonville', 39.9261093139648, 0.696842065039861, -91.79638671875, -1.60214918967618, 218, 29, 'PPL', 'P'),
(73633, 'Nelsonville', 39.458610534668, 0.688682672092076, -82.2319412231445, -1.43521812465033, 218, 41, 'PPL', 'P'),
(96465, 'Nelsonville', 29.976390838623, 0.523186717998636, -96.4030609130859, -1.682550821934, 218, 51, 'PPL', 'P'),
(145860, 'Nelsonville', 40.170280456543, 0.701103655416206, -74.5352783203125, -1.3008860155798, 218, 37, 'PPL', 'P'),
(150985, 'Nelsonville', 41.4244384765625, 0.722992842205839, -73.9469375610352, -1.29061753220673, 218, 40, 'PPL', 'P'),
(175484, 'Nelsonville', 44.4949989318848, 0.776584232032749, -89.3097229003906, -1.5587487186556, 218, 57, 'PPL', 'P'),
(212021, 'Nelsonville', 59.0066719055176, 1.02986070539532, -158.533615112305, -2.76693355879916, 218, 1, 'PPL', 'P'),
(175485, 'Nelsonville (historical)', 44.6541709899902, 0.779362308523865, -91.5697174072266, -1.59819306387687, 218, 57, 'PPL', 'P'),
(96466, 'Nelta', 33.3022193908691, 0.581233376592167, -95.4763870239258, -1.66637731147589, 218, 51, 'PPL', 'P'),
(104599, 'Nelwood Estates', 37.7013893127441, 0.658013376083587, -77.7180633544922, -1.35643609380944, 218, 53, 'PPL', 'P'),
(183581, 'Nema (historical)', 36.961109161377, 0.645093050055068, -121.550003051758, -2.12144775906233, 218, 6, 'PPL', 'P'),
(78805, 'Nemacolin', 39.8783302307129, 0.69600816272353, -79.9250030517578, -1.39495445791969, 218, 45, 'PPL', 'P'),
(137050, 'Nemadji', 46.4794387817383, 0.811219241220475, -92.5944366455078, -1.6160777884934, 218, 28, 'PPL', 'P'),
(208225, 'Nemah', 46.5122184753418, 0.811791354801651, -123.884719848633, -2.16219625426941, 218, 56, 'PPL', 'P'),
(208226, 'Nemah Junction', 46.5205612182617, 0.811936963134251, -123.884437561035, -2.1621913274214, 218, 56, 'PPL', 'P'),
(116985, 'Nemaha', 42.5158309936523, 0.742041235060686, -95.0880584716797, -1.6595996996597, 218, 16, 'PPL', 'P'),
(142485, 'Nemaha', 40.3383293151855, 0.704036661303737, -95.6727828979492, -1.66980506611494, 218, 35, 'PPL', 'P'),
(4511, 'Neman', 32.579719543457, 0.568623375409669, -85.9841690063477, -1.50070685375203, 218, 2, 'PPL', 'P'),
(125529, 'Nemasket', 41.9119415283203, 0.731501375572534, -70.8811111450195, -1.23710876695264, 218, 23, 'PPL', 'P'),
(10750, 'Nemo', 35.8730583190918, 0.626102980428094, -90.8600006103516, -1.58580616901469, 218, 4, 'PPL', 'P'),
(56469, 'Nemo', 37.8766708374023, 0.661072615806789, -93.2616729736328, -1.6277232593081, 218, 29, 'PPL', 'P'),
(89344, 'Nemo', 36.0669403076172, 0.629486859488176, -84.6524963378906, -1.47746478112863, 218, 50, 'PPL', 'P'),
(96467, 'Nemo', 32.2597198486328, 0.563038327129609, -97.6516723632813, -1.70434320281801, 218, 51, 'PPL', 'P'),
(202417, 'Nemo', 44.1941719055176, 0.771333809943658, -103.504440307617, -1.80649327380185, 218, 49, 'PPL', 'P'),
(208227, 'Nemo', 47.3430595397949, 0.826292266937133, -118.594436645508, -2.06986339401193, 218, 56, 'PPL', 'P'),
(110614, 'Nemours', 37.3013916015625, 0.651032099023026, -81.304443359375, -1.41903023312233, 218, 58, 'PPL', 'P'),
(96468, 'Nena', 32.3269386291504, 0.564211516168816, -96.8555603027344, -1.69044842614663, 218, 51, 'PPL', 'P'),
(189103, 'Nenahnezad', 36.7361106872559, 0.641166085869692, -108.417503356934, -1.8922424003705, 218, 38, 'PPL', 'P'),
(201290, 'Nenamusa (historical)', 45.2458305358887, 0.789688715650648, -123.593063354492, -2.15710588816184, 218, 43, 'PPL', 'P'),
(212022, 'Nenana', 64.5638885498047, 1.12685243308476, -149.093063354492, -2.60216484742039, 218, 1, 'PPL', 'P'),
(210766, 'NeneleÃ‚â€˜a * (historical)', 21.5786094665527, 0.376617783193362, -158.274169921875, -2.76240538599769, 218, 15, 'PPL', 'P'),
(4512, 'Nenemoosha', 30.8097190856934, 0.537731039659886, -88.0047225952148, -1.53597216659075, 218, 2, 'PPL', 'P'),
(175487, 'Nenno', 43.4461097717285, 0.758277662699545, -88.3913879394531, -1.54272074995106, 218, 57, 'PPL', 'P'),
(89345, 'Nenny', 36.2444381713867, 0.632584781626211, -83.1447219848633, -1.45114915429118, 218, 50, 'PPL', 'P'),
(14290, 'Nentego Manor', 38.5152816772461, 0.672218477600988, -75.3608322143555, -1.31529464918351, 218, 10, 'PPL', 'P'),
(199558, 'Nenzel', 42.9277801513672, 0.749231104213627, -101.102500915527, -1.76457152297653, 218, 35, 'PPL', 'P'),
(33390, 'Neodesha', 37.4183311462402, 0.653073079103436, -95.6800003051758, -1.6699310336345, 218, 20, 'PPL', 'P'),
(76697, 'Neodesha', 36.0461082458496, 0.629123271420353, -95.4341735839844, -1.66564054796032, 218, 42, 'PPL', 'P'),
(17251, 'Neoga', 29.5261096954346, 0.515327829490353, -81.336669921875, -1.41959269274456, 218, 12, 'PPL', 'P'),
(28008, 'Neoga', 39.3194389343262, 0.686253669440842, -88.4527816772461, -1.54379227281566, 218, 18, 'PPL', 'P'),
(33393, 'Neola', 37.8694381713867, 0.660946381971119, -98.5086135864258, -1.71929964865795, 218, 20, 'PPL', 'P'),
(56470, 'Neola', 37.5055618286133, 0.654595541719607, -93.8694381713867, -1.63833076308794, 218, 29, 'PPL', 'P'),
(110615, 'Neola', 37.9658317565918, 0.662628767410749, -80.1302795410156, -1.39853720853417, 218, 58, 'PPL', 'P'),
(116986, 'Neola', 41.4488906860352, 0.723419613770525, -95.6152801513672, -1.66880145385814, 218, 16, 'PPL', 'P'),
(165057, 'Neola', 40.9588890075684, 0.71486747114098, -75.3405609130859, -1.3149408482327, 218, 45, 'PPL', 'P'),
(205090, 'Neola', 40.4333305358887, 0.705694745398421, -110.029167175293, -1.92037124043613, 218, 52, 'PPL', 'P'),
(37385, 'Neon', 37.1913909912109, 0.649112226193188, -82.7136077880859, -1.44362479210532, 218, 21, 'PPL', 'P'),
(37380, 'Neon Junction', 37.1794395446777, 0.648903634100808, -82.7138900756836, -1.44362971895334, 218, 21, 'PPL', 'P'),
(56471, 'Neongwah', 38.0327796936035, 0.663797229339022, -92.7925033569336, -1.61953470474638, 218, 29, 'PPL', 'P'),
(175488, 'Neopit', 44.9808311462402, 0.785063603785507, -88.8308334350586, -1.55039052073244, 218, 57, 'PPL', 'P'),
(37381, 'Neosheo', 36.7119407653809, 0.640744241153023, -86.6786117553711, -1.51282716618909, 218, 21, 'PPL', 'P'),
(56472, 'Neosho', 36.8688888549805, 0.643483502071251, -94.3677825927734, -1.64702851405009, 218, 29, 'PPL', 'P'),
(175489, 'Neosho', 43.3102798461914, 0.755906983276183, -88.5180587768555, -1.54493157312999, 218, 57, 'PPL', 'P'),
(33395, 'Neosho Falls', 38.0055618286133, 0.663322187979579, -95.5569381713867, -1.66778319421535, 218, 20, 'PPL', 'P'),
(33397, 'Neosho Rapids', 38.3694381713867, 0.669673028231091, -95.9916687011719, -1.67537067331904, 218, 20, 'PPL', 'P'),
(201291, 'Neotsu', 45.0013885498047, 0.785422398163368, -123.980003356934, -2.16385926521211, 218, 43, 'PPL', 'P'),
(156689, 'Neowash (historical)', 41.4738883972168, 0.723855906136107, -83.767219543457, -1.46201378627427, 218, 41, 'PPL', 'P'),
(113770, 'Nepaug', 41.829719543457, 0.730066331219144, -72.9994430541992, -1.27408063341788, 218, 8, 'PPL', 'P'),
(132248, 'Nepco Camp Number 7', 47.4033317565918, 0.827344215567714, -88.1444396972656, -1.53841069004288, 218, 27, 'PPL', 'P'),
(150986, 'Nepera Park', 40.975830078125, 0.715163148601007, -73.8675003051758, -1.28923109054323, 218, 40, 'PPL', 'P'),
(187104, 'Nepesta', 38.1688919067383, 0.666172835610399, -104.142501831055, -1.81762954821613, 218, 7, 'PPL', 'P'),
(192720, 'Nephi', 39.7102813720703, 0.693075156835998, -111.835563659668, -1.95189880668493, 218, 52, 'PPL', 'P'),
(110616, 'Neponset', 37.4683303833008, 0.653945730413628, -80.8463897705078, -1.41103568984602, 218, 58, 'PPL', 'P'),
(113041, 'Neponset', 41.2958297729492, 0.720748196881066, -89.790283203125, -1.56713607819269, 218, 18, 'PPL', 'P'),
(125530, 'Neponset', 42.2861099243164, 0.738031846039572, -71.0458297729492, -1.23998364934938, 218, 23, 'PPL', 'P'),
(183590, 'Neponset', 36.7286109924316, 0.641035191502114, -121.783332824707, -2.12552013184322, 218, 6, 'PPL', 'P'),
(150987, 'Neponsit', 40.5716705322266, 0.708109233821714, -73.8619384765625, -1.2891340183215, 218, 40, 'PPL', 'P'),
(150988, 'Nepperhan', 40.9555587768555, 0.71480934765019, -73.866943359375, -1.28922137000525, 218, 40, 'PPL', 'P'),
(37382, 'Nepton', 38.4352798461914, 0.67082218224146, -83.8341674804688, -1.46318224820254, 218, 21, 'PPL', 'P'),
(89346, 'Neptune', 36.3497200012207, 0.634422296199339, -87.204719543457, -1.52200947931157, 218, 50, 'PPL', 'P'),
(110617, 'Neptune', 39.0752792358398, 0.681992278801579, -81.7799987792969, -1.42733024097567, 218, 58, 'PPL', 'P'),
(116988, 'Neptune', 42.6636085510254, 0.7446204399974, -96.1558303833008, -1.6782358351778, 218, 16, 'PPL', 'P'),
(156690, 'Neptune', 40.6030616760254, 0.70865711263697, -84.4916687011719, -1.47465780933969, 218, 41, 'PPL', 'P'),
(175492, 'Neptune', 43.3730583190918, 0.757002674327669, -90.267219543457, -1.5754601876539, 218, 57, 'PPL', 'P'),
(17252, 'Neptune Beach', 30.3116703033447, 0.529038448572354, -81.3966674804688, -1.42063984768518, 218, 12, 'PPL', 'P'),
(208228, 'Neptune Beach', 48.8161087036133, 0.852001824889512, -122.706390380859, -2.1416305253835, 218, 56, 'PPL', 'P'),
(145861, 'Neptune City', 40.2000007629395, 0.701622372617526, -74.0283279418945, -1.29203806233218, 218, 37, 'PPL', 'P'),
(200094, 'Neptune City (historical)', 40.7055587768555, 0.710446024520204, -118.014999389648, -2.05975030608846, 218, 39, 'PPL', 'P'),
(128229, 'Nequasset', 43.9397201538086, 0.766892789088869, -69.7830581665039, -1.21794412711621, 218, 26, 'PPL', 'P'),
(128230, 'Nequsset (historical)', 43.9186096191406, 0.766524340752057, -69.8016662597656, -1.21826889961115, 218, 26, 'PPL', 'P'),
(96469, 'Neri', 32.3636093139648, 0.56485154035779, -97.7747192382813, -1.70649077592105, 218, 51, 'PPL', 'P'),
(175493, 'Nerike', 44.5505599975586, 0.777553955564674, -92.1655578613281, -1.60859244161752, 218, 57, 'PPL', 'P'),
(37383, 'Nerinx', 37.6641693115234, 0.65736376451469, -85.3994369506836, -1.49050135413874, 218, 21, 'PPL', 'P'),
(586, 'Nero', 29.6113891601563, 0.516816236934085, -89.8683319091797, -1.56849828509027, 218, 22, 'PPL', 'P'),
(37384, 'Nero', 37.7483291625977, 0.658832631013923, -82.7436065673828, -1.44414836957563, 218, 21, 'PPL', 'P'),
(110618, 'Nero (historical)', 39.1755599975586, 0.683742508269979, -78.4388885498047, -1.36901686679897, 218, 58, 'PPL', 'P'),
(183582, 'Neroly', 37.9894409179688, 0.663040825010412, -121.749443054199, -2.12492864376512, 218, 6, 'PPL', 'P'),
(137052, 'Nerstrand', 44.3419418334961, 0.773912881722318, -93.0677795410156, -1.62433918051094, 218, 28, 'PPL', 'P'),
(205092, 'Nerva', 41.3688888549805, 0.722023318410996, -112.040832519531, -1.95548142414135, 218, 52, 'PPL', 'P'),
(183583, 'Nervo', 38.6877784729004, 0.675229114634296, -122.879173278809, -2.14464615584385, 218, 6, 'PPL', 'P'),
(56474, 'Nesbit', 36.0902786254883, 0.629894189976904, -90.1347198486328, -1.57314763172133, 218, 29, 'PPL', 'P'),
(61024, 'Nesbit', 34.8816719055176, 0.608800023351686, -90.0086135864258, -1.57094666223843, 218, 30, 'PPL', 'P'),
(165058, 'Nesbit Corners', 41.2763900756836, 0.72040891015819, -80.1252822875977, -1.39844999000847, 218, 45, 'PPL', 'P'),
(96471, 'Nesbitt', 31.0980606079102, 0.542763548592782, -96.5966720581055, -1.68592997388315, 218, 51, 'PPL', 'P'),
(71158, 'Nesco', 39.6380615234375, 0.691814682692064, -74.6969375610352, -1.30370750159669, 218, 37, 'PPL', 'P'),
(150989, 'Nesconset', 40.8519401550293, 0.713000861532944, -73.1544418334961, -1.27678587245318, 218, 40, 'PPL', 'P'),
(165059, 'Nescopeck', 41.0519409179688, 0.716491533352738, -76.2211074829102, -1.33030928509327, 218, 45, 'PPL', 'P'),
(165060, 'Nescopeck Pass', 41.0761108398438, 0.716913378069407, -75.9591674804688, -1.32573756960799, 218, 45, 'PPL', 'P'),
(165063, 'Neshaminy', 40.2294387817383, 0.702136162970829, -75.1391677856445, -1.31142587506795, 218, 45, 'PPL', 'P'),
(165064, 'Neshaminy (historical)', 40.1722183227539, 0.70113747756205, -74.9516677856445, -1.30815338272046, 218, 45, 'PPL', 'P'),
(165065, 'Neshaminy Falls', 40.1533317565918, 0.700807844798125, -74.959716796875, -1.30829386446797, 218, 45, 'PPL', 'P'),
(165066, 'Neshaminy Heights', 40.1483306884766, 0.700720559693398, -74.9188919067383, -1.30758133571832, 218, 45, 'PPL', 'P'),
(165067, 'Neshaminy Hills', 40.1594390869141, 0.700914437820756, -74.9591674804688, -1.30828427708804, 218, 45, 'PPL', 'P'),
(165068, 'Neshaminy Woods', 40.1647186279297, 0.701006583194472, -74.9569396972656, -1.30824539493613, 218, 45, 'PPL', 'P'),
(145864, 'Neshanic', 40.4977798461914, 0.706819598063843, -74.7202835083008, -1.30411496524347, 218, 37, 'PPL', 'P'),
(145865, 'Neshanic Station', 40.5080604553223, 0.706999028542287, -74.7305603027344, -1.30429432914289, 218, 37, 'PPL', 'P'),
(165069, 'Neshannock', 41.2158317565918, 0.719351968100565, -80.396110534668, -1.40317683462725, 218, 45, 'PPL', 'P'),
(165072, 'Neshannock Falls', 41.0827789306641, 0.717029758209043, -80.2977828979492, -1.40146069362081, 218, 45, 'PPL', 'P'),
(175494, 'Neshkoro', 43.9658317565918, 0.767348522530409, -89.2174987792969, -1.55713910409275, 218, 57, 'PPL', 'P'),
(61025, 'Neshoba', 32.6233291625977, 0.569384506849214, -89.1380615234375, -1.55575266242926, 218, 30, 'PPL', 'P'),
(172294, 'Neshobe Beach', 43.6391716003418, 0.761647227268767, -73.2088928222656, -1.27773622148818, 218, 55, 'PPL', 'P'),
(4513, 'Neshota', 30.6391696929932, 0.534754391219991, -88.0891723632813, -1.53744609309605, 218, 2, 'PPL', 'P'),
(208230, 'Nesika', 46.4741706848145, 0.81112729558384, -122.288063049316, -2.13432933609699, 218, 56, 'PPL', 'P'),
(201292, 'Nesika Beach', 42.5063896179199, 0.741876451968237, -124.412216186523, -2.17140280215782, 218, 43, 'PPL', 'P'),
(116989, 'Neska', 41.4083290100098, 0.722711678973754, -92.5133285522461, -1.61466218521597, 218, 16, 'PPL', 'P'),
(201293, 'Neskowin', 45.1069412231445, 0.78726463984743, -123.983062744141, -2.16391266159197, 218, 43, 'PPL', 'P'),
(4514, 'Nesmith', 34.1755599975586, 0.596476045670263, -87.1091690063477, -1.52034180783696, 218, 2, 'PPL', 'P'),
(82561, 'Nesmith', 33.6588897705078, 0.5874584490612, -79.5136108398438, -1.38777430930473, 218, 48, 'PPL', 'P'),
(42270, 'Nesom (historical)', 30.8072204589844, 0.537687430397036, -90.9194412231445, -1.58684360341733, 218, 22, 'PPL', 'P'),
(208229, 'Nespelem', 48.1672210693359, 0.840676599195896, -118.973609924316, -2.07648121616272, 218, 56, 'PPL', 'P'),
(165071, 'Nesquehoning', 40.8644409179688, 0.713219041005249, -75.811393737793, -1.3231584312503, 218, 45, 'PPL', 'P'),
(165074, 'Nesquehoning Junction', 40.8727798461914, 0.713364582758822, -75.7555618286133, -1.32218398060744, 218, 45, 'PPL', 'P'),
(33403, 'Ness City', 38.4527816772461, 0.671127646818492, -99.9061126708984, -1.7436906089756, 218, 20, 'PPL', 'P'),
(110619, 'Nesselroad', 38.9916687011719, 0.68053299968227, -81.7041702270508, -1.42600678307196, 218, 58, 'PPL', 'P'),
(110620, 'Nesselroad (historical)', 38.9855613708496, 0.68042640665964, -81.7122192382813, -1.42614726481946, 218, 58, 'PPL', 'P'),
(132249, 'Nessen City', 44.5200004577637, 0.777020590977359, -85.878059387207, -1.49885489152999, 218, 27, 'PPL', 'P'),
(42248, 'Nesser', 30.3980598449707, 0.530546230513016, -91.0519409179688, -1.5891561593499, 218, 22, 'PPL', 'P'),
(104603, 'Nester', 36.7041702270508, 0.640608619674511, -80.5749969482422, -1.40629899153121, 218, 53, 'PPL', 'P'),
(104600, 'Nesting', 37.7338905334473, 0.658580629395774, -76.6488876342773, -1.33777545720931, 218, 53, 'PPL', 'P'),
(89347, 'Nestledown Estates', 35.9216690063477, 0.626951396972366, -86.4241714477539, -1.50838634507138, 218, 50, 'PPL', 'P'),
(67131, 'Nestleway Acres', 35.9963912963867, 0.628255546958178, -80.3499984741211, -1.40237202734583, 218, 33, 'PPL', 'P'),
(49762, 'Nestling Wind', 39.7075004577637, 0.693026620725132, -76.5083312988281, -1.33532228637118, 218, 25, 'PPL', 'P'),
(110621, 'Nestlow', 38.1755599975586, 0.666289215750036, -82.2836074829102, -1.43611987099543, 218, 58, 'PPL', 'P'),
(42249, 'Nestor', 29.496940612793, 0.514818732958471, -89.6961135864258, -1.56549250832595, 218, 22, 'PPL', 'P'),
(183584, 'Nestor', 32.5758285522461, 0.568555464801872, -117.08332824707, -2.04348957710466, 218, 6, 'PPL', 'P'),
(132251, 'Nestoria', 46.5702781677246, 0.812804687596426, -88.2636108398438, -1.54049061885423, 218, 27, 'PPL', 'P'),
(110624, 'Nestorville', 39.1797218322754, 0.683815145988711, -79.9094390869141, -1.3946828154885, 218, 58, 'PPL', 'P'),
(208231, 'Nestos (historical)', 48.5058288574219, 0.846586419970891, -121.698608398438, -2.12404141164796, 218, 56, 'PPL', 'P'),
(178709, 'Nesuftanga', 35.7802810668945, 0.624483711906299, -110.140556335449, -1.92231534803189, 218, 5, 'PPL', 'P'),
(201294, 'Netarts', 45.435001373291, 0.792990369612073, -123.944717407227, -2.16324340921003, 218, 43, 'PPL', 'P'),
(33426, 'Netawaka', 39.6027793884277, 0.69119889326901, -95.7180633544922, -1.67059535916842, 218, 20, 'PPL', 'P'),
(145866, 'Netcong', 40.8988914489746, 0.713820316200361, -74.7069396972656, -1.30388207180614, 218, 37, 'PPL', 'P'),
(56476, 'Netherlands', 36.2991714477539, 0.633540057509222, -89.751106262207, -1.56645231158281, 218, 29, 'PPL', 'P'),
(89348, 'Netherlands (historical)', 36.2444381713867, 0.632584781626211, -85.3844375610352, -1.49023956540358, 218, 50, 'PPL', 'P'),
(104601, 'Nethers', 38.5702781677246, 0.67317834743688, -78.2780609130859, -1.36620989501003, 218, 53, 'PPL', 'P'),
(145868, 'Netherwood', 40.6305618286133, 0.70913708084443, -74.4124984741211, -1.29874310300867, 218, 37, 'PPL', 'P'),
(150990, 'Netherwood', 41.797779083252, 0.729508865023964, -73.8188934326172, -1.28838274057799, 218, 40, 'PPL', 'P'),
(110622, 'Nethkin', 39.3899993896484, 0.687485181707922, -79.1338882446289, -1.38114689977401, 218, 58, 'PPL', 'P'),
(42250, 'Netpinunsh (historical)', 29.8833293914795, 0.521562489339311, -91.5583267211914, -1.59799425890149, 218, 22, 'PPL', 'P'),
(137057, 'Nett Lake', 48.1111106872559, 0.839697288284047, -93.0938873291016, -1.62479484737345, 218, 28, 'PPL', 'P'),
(104602, 'Netta (historical)', 36.7350006103516, 0.641146711372761, -77.9738922119141, -1.36090114969306, 218, 53, 'PPL', 'P'),
(110623, 'Nettie', 38.2183303833008, 0.667035699803585, -80.6861114501953, -1.408238305437, 218, 58, 'PPL', 'P'),
(89349, 'Nettle Carrier (historical)', 36.3888893127441, 0.635105929651162, -85.1977767944336, -1.48698172044209, 218, 50, 'PPL', 'P'),
(120783, 'Nettle Creek', 41.4425010681152, 0.723308093899878, -88.5780563354492, -1.54597872807061, 218, 18, 'PPL', 'P'),
(78807, 'Nettle Hill', 39.7966690063477, 0.694582905487147, -80.383056640625, -1.402949001196, 218, 45, 'PPL', 'P'),
(156691, 'Nettle Lake', 41.6791687011719, 0.727438723329618, -84.7233276367188, -1.47870102050665, 218, 41, 'PPL', 'P'),
(4515, 'Nettleboro', 31.7988891601563, 0.554995314321461, -87.6222229003906, -1.52929628752819, 218, 2, 'PPL', 'P'),
(104604, 'Nettleridge', 36.5858306884766, 0.6385432050911, -80.1397171020508, -1.39870192504759, 218, 53, 'PPL', 'P'),
(10751, 'Nettleton', 35.8194389343262, 0.625167145621041, -90.6511077880859, -1.58216030148237, 218, 4, 'PPL', 'P'),
(33405, 'Nettleton', 37.9986114501953, 0.663200880991926, -99.3283309936523, -1.73360641634996, 218, 20, 'PPL', 'P'),
(56477, 'Nettleton', 39.7580604553223, 0.693909059152329, -93.9044418334961, -1.63894169224201, 218, 29, 'PPL', 'P'),
(61027, 'Nettleton', 34.0888900756836, 0.594963370171098, -88.6222229003906, -1.54674958004814, 218, 30, 'PPL', 'P'),
(156692, 'Nettleton (historical)', 40.1188888549805, 0.700206702761067, -83.8744430541992, -1.46388518957227, 218, 41, 'PPL', 'P'),
(37386, 'Netty', 37.746940612793, 0.658808396248003, -83.2386093139648, -1.45278779730991, 218, 21, 'PPL', 'P'),
(89353, 'Neubert', 35.8933296203613, 0.626456781378911, -83.841667175293, -1.46331314257012, 218, 50, 'PPL', 'P'),
(89350, 'Neubert Springs', 35.8791694641113, 0.626209640029752, -83.8744430541992, -1.46388518957227, 218, 50, 'PPL', 'P'),
(33406, 'Neuchatel', 39.5680618286133, 0.69059295754199, -96.2016677856445, -1.67903584876926, 218, 20, 'PPL', 'P'),
(175497, 'Neuern', 44.5019416809082, 0.776705405862348, -87.7247161865234, -1.5310851328324, 218, 57, 'PPL', 'P'),
(183585, 'Neufeld', 35.6194381713867, 0.621676473801246, -119.331672668457, -2.0827305899767, 218, 6, 'PPL', 'P'),
(10753, 'Neuhardt', 35.0611114501953, 0.611931834214592, -90.3288879394531, -1.57653650420845, 218, 4, 'PPL', 'P'),
(28010, 'Neunert', 37.7227783203125, 0.658386684689389, -89.5455627441406, -1.56286490043642, 218, 18, 'PPL', 'P'),
(183586, 'Neuralia (historical)', 35.1986083984375, 0.614331608672863, -118.044441223145, -2.06026416302079, 218, 6, 'PPL', 'P'),
(67132, 'Neuse', 35.8972206115723, 0.626524691986708, -78.5694427490234, -1.37129546742764, 218, 33, 'PPL', 'P'),
(67133, 'Neuse Crossroads', 35.8933296203613, 0.626456781378911, -78.5599975585938, -1.37113061775617, 218, 33, 'PPL', 'P'),
(67134, 'Neuse Forest', 34.9636116027832, 0.610230140857059, -76.9449996948242, -1.34294358762071, 218, 33, 'PPL', 'P'),
(33408, 'Neutral', 37.0977783203125, 0.647478376864425, -94.7947235107422, -1.65448003878013, 218, 20, 'PPL', 'P'),
(96472, 'Neuville', 31.6780605316162, 0.552886456922768, -94.142219543457, -1.64309169616868, 218, 51, 'PPL', 'P'),
(33409, 'Neva', 38.3980598449707, 0.670172570672562, -96.6158294677734, -1.68626433375801, 218, 20, 'PPL', 'P'),
(89351, 'Neva', 36.3930587768555, 0.635178700527948, -81.8638916015625, -1.428794446943, 218, 50, 'PPL', 'P'),
(175498, 'Neva', 45.2394409179688, 0.789577195780001, -89.1130599975586, -1.55531630348465, 218, 57, 'PPL', 'P'),
(195377, 'Neva', 46.7986106872559, 0.816789841851621, -116.296669006348, -2.02975978326281, 218, 17, 'PPL', 'P'),
(175499, 'Neva Corners', 45.2200012207031, 0.789237909057125, -89.1444396972656, -1.55586398256282, 218, 57, 'PPL', 'P'),
(37398, 'Nevada', 37.6963882446289, 0.65792609097886, -84.9097213745117, -1.48195420493623, 218, 21, 'PPL', 'P'),
(56478, 'Nevada', 37.839168548584, 0.660418077389874, -94.3544387817383, -1.64679562061276, 218, 29, 'PPL', 'P'),
(61028, 'Nevada', 32.5238914489746, 0.567648991345836, -90.4680633544922, -1.57896557343871, 218, 30, 'PPL', 'P'),
(96473, 'Nevada', 33.0422210693359, 0.576695549831754, -96.3736114501953, -1.68203683184362, 218, 51, 'PPL', 'P'),
(116990, 'Nevada', 42.0227813720703, 0.733435895788367, -93.4522171020508, -1.63104888171934, 218, 16, 'PPL', 'P'),
(120752, 'Nevada', 41.0858306884766, 0.717083021430845, -88.5513916015625, -1.54551334067012, 218, 18, 'PPL', 'P'),
(123271, 'Nevada', 40.3952789306641, 0.705030619601582, -86.0041732788086, -1.50105599417094, 218, 19, 'PPL', 'P'),
(156693, 'Nevada', 40.8191719055176, 0.712428947688849, -83.1305618286133, -1.45090201294202, 218, 41, 'PPL', 'P'),
(183587, 'Nevada', 34.065559387207, 0.594556172840425, -117.217216491699, -2.04582636780315, 218, 6, 'PPL', 'P'),
(190536, 'Nevada', 39.2502784729004, 0.685046591676764, -116.750282287598, -2.0376768285514, 218, 39, 'ADM1', 'A'),
(183588, 'Nevada City', 39.2616691589355, 0.685245396652138, -121.014999389648, -2.11211018364829, 218, 6, 'PPL', 'P'),
(190532, 'Nevada City (historical)', 39.4375, 0.688314223755264, -118.670280456543, -2.07118711823175, 218, 39, 'PPL', 'P'),
(190533, 'Nevada Hills (historical)', 39.246940612793, 0.684988335027918, -118.198333740234, -2.06295009413819, 218, 39, 'PPL', 'P'),
(123272, 'Nevada Mills', 41.7269401550293, 0.728272492487894, -85.0822219848633, -1.48496490854857, 218, 19, 'PPL', 'P'),
(190535, 'Nevada Station (historical)', 39.4116706848145, 0.687863417161741, -119.236938476563, -2.08107716641393, 218, 39, 'PPL', 'P'),
(187105, 'Nevadaville', 39.795280456543, 0.694558670721227, -105.531936645508, -1.84187976047017, 218, 7, 'PPL', 'P'),
(82562, 'Nevadum', 32.458610534668, 0.566509624452473, -80.8894424438477, -1.41178710074759, 218, 48, 'PPL', 'P'),
(10755, 'Nevark', 33.5561103820801, 0.58566461032995, -93.1669387817383, -1.62606983574533, 218, 4, 'PPL', 'P'),
(37387, 'Nevelsville', 36.8411102294922, 0.642998673594802, -84.559440612793, -1.47584065233785, 218, 21, 'PPL', 'P'),
(199560, 'Nevens', 41.185001373291, 0.718813876402314, -101.423889160156, -1.77018080602251, 218, 35, 'PPL', 'P'),
(56479, 'Never Spur (historical)', 36.9130592346191, 0.644254420627802, -89.4338912963867, -1.56091586599265, 218, 29, 'PPL', 'P'),
(89352, 'Neverfail (historical)', 35.9874992370605, 0.628100351245654, -85.2416687011719, -1.48774777872965, 218, 50, 'PPL', 'P'),
(150991, 'Neversink', 41.8472213745117, 0.730371795796177, -74.6194381713867, -1.30235488207903, 218, 40, 'PPL', 'P'),
(165075, 'Neversink', 40.3074989318848, 0.703498569605487, -75.8877792358398, -1.32449160969199, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(201295, 'Neverstill', 45.9761085510254, 0.802434471469712, -123.343330383301, -2.15274722556376, 218, 43, 'PPL', 'P'),
(172295, 'Nevesville', 44.4500007629395, 0.775798865827285, -72.2230606079102, -1.26053020347545, 218, 55, 'PPL', 'P'),
(61029, 'Neville', 32.583610534668, 0.568691286017466, -89.2477798461914, -1.55766760841108, 218, 30, 'PPL', 'P'),
(73634, 'Neville', 38.810001373291, 0.677362306667449, -84.2122192382813, -1.46978049611932, 218, 41, 'PPL', 'P'),
(183591, 'Nevills (historical)', 36.7463912963867, 0.641345516348136, -119.902221679688, -2.09268854876667, 218, 6, 'PPL', 'P'),
(23329, 'Nevils', 32.2636108398438, 0.563106237737406, -81.7611083984375, -1.42700054163272, 218, 13, 'PPL', 'P'),
(37388, 'Nevin', 37.9461097717285, 0.662284553839857, -84.8833312988281, -1.48149361122571, 218, 21, 'PPL', 'P'),
(183592, 'Nevin', 34.0141716003418, 0.593659286764313, -118.245277404785, -2.06376941564756, 218, 6, 'PPL', 'P'),
(190537, 'Nevin (historical)', 39.9516716003418, 0.697288211101476, -116.553886413574, -2.03424907391236, 218, 39, 'PPL', 'P'),
(17253, 'Nevins', 27.6113891601563, 0.481909651894198, -80.3852767944336, -1.40298775018986, 218, 12, 'PPL', 'P'),
(28011, 'Nevins', 39.5338897705078, 0.689996542615867, -87.6386108398438, -1.52958231102927, 218, 18, 'PPL', 'P'),
(175501, 'Nevins', 44.4963912963867, 0.776608533377696, -90.3649978637695, -1.57716674128042, 218, 57, 'PPL', 'P'),
(49763, 'Nevins Addition', 38.3422203063965, 0.669197986871648, -75.5661087036133, -1.318877399798, 218, 25, 'PPL', 'P'),
(49764, 'Nevins Mill', 38.3405609130859, 0.669169024994793, -75.5605621337891, -1.31878059389237, 218, 25, 'PPL', 'P'),
(116993, 'Nevinville', 41.1472206115723, 0.718154477716411, -94.5005569458008, -1.64934586367262, 218, 16, 'PPL', 'P'),
(137060, 'Nevis', 46.9652786254883, 0.819698746131287, -94.8391723632813, -1.65525581760567, 218, 28, 'PPL', 'P'),
(150993, 'Nevis', 42.0605583190918, 0.734095227895244, -73.8433303833008, -1.28880924582657, 218, 40, 'PPL', 'P'),
(37389, 'Nevisdale', 36.6866683959961, 0.640303155097479, -84.0461120605469, -1.46688137895666, 218, 21, 'PPL', 'P'),
(37390, 'New', 38.4277801513672, 0.670691287873882, -84.8105621337891, -1.48022354970185, 218, 21, 'PPL', 'P'),
(89354, 'New (historical)', 35.6830596923828, 0.622786878817755, -85.9230575561523, -1.49964025773545, 218, 50, 'PPL', 'P'),
(49765, 'New Addition', 39.3183288574219, 0.686234294943912, -77.6466674804688, -1.35519000073539, 218, 25, 'PPL', 'P'),
(30614, 'New Albany', 38.2855606079102, 0.668209088579874, -85.8241729736328, -1.49791439619103, 218, 19, 'PPL', 'P'),
(33411, 'New Albany', 37.5683288574219, 0.655691033034011, -95.9375, -1.67442525113206, 218, 20, 'PPL', 'P'),
(61030, 'New Albany', 34.4941711425781, 0.602036859184403, -89.0077819824219, -1.55347885549055, 218, 30, 'PPL', 'P'),
(145869, 'New Albany', 40.0013885498047, 0.698155935563652, -74.9716720581055, -1.30850252313937, 218, 37, 'PPL', 'P'),
(156695, 'New Albany', 40.9422187805176, 0.714576520791889, -80.8361129760742, -1.41085632594661, 218, 41, 'PPL', 'P'),
(165077, 'New Albany', 41.5999984741211, 0.72605694219803, -76.4422225952148, -1.3341684718289, 218, 45, 'PPL', 'P'),
(116995, 'New Albin', 43.4966697692871, 0.759160101126742, -91.289436340332, -1.59330123642856, 218, 16, 'PPL', 'P'),
(116996, 'New Albion', 42.6427803039551, 0.744256918508604, -92.7313919067383, -1.61846810872981, 218, 16, 'PPL', 'P'),
(150994, 'New Albion', 42.2894401550293, 0.738089969530362, -78.8897171020508, -1.37688530939767, 218, 40, 'PPL', 'P'),
(156696, 'New Alexander', 40.7886085510254, 0.711895516522507, -80.9941711425781, -1.41361496136177, 218, 41, 'PPL', 'P'),
(104605, 'New Alexandria', 38.7763900756836, 0.676775678858332, -77.0569381713867, -1.3448972825964, 218, 53, 'PPL', 'P'),
(156697, 'New Alexandria', 40.2905616760254, 0.703202958724488, -80.679443359375, -1.40812192529737, 218, 41, 'PPL', 'P'),
(165079, 'New Alexandria', 40.398609161377, 0.705088743092373, -79.4222183227539, -1.38617920896982, 218, 45, 'PPL', 'P'),
(37391, 'New Allen', 37.6147193908691, 0.656500700584422, -82.7216720581055, -1.44376554016893, 218, 21, 'PPL', 'P'),
(183593, 'New Almaden', 37.1761093139648, 0.648845510610017, -121.819717407227, -2.12615516260515, 218, 6, 'PPL', 'P'),
(187824, 'New Almelo', 39.5941696166992, 0.691048624404503, -100.117500305176, -1.74738001919175, 218, 20, 'PPL', 'P'),
(30616, 'New Alsace', 39.2338905334473, 0.684760568175689, -85.003059387207, -1.48358326057504, 218, 19, 'PPL', 'P'),
(30617, 'New Amsterdam', 38.1022186279297, 0.665009167372089, -86.2750015258789, -1.50578283878972, 218, 19, 'PPL', 'P'),
(175502, 'New Amsterdam', 43.982780456543, 0.76764433314849, -91.3163909912109, -1.59377168383512, 218, 57, 'PPL', 'P'),
(73635, 'New Antioch', 39.4072189331055, 0.687785719436937, -83.7461090087891, -1.46164533793745, 218, 41, 'PPL', 'P'),
(89355, 'New Antwerp (historical)', 35.3861083984375, 0.617604101020352, -86.158332824707, -1.50374658582024, 218, 50, 'PPL', 'P'),
(125531, 'New Ashford', 42.6049995422363, 0.743597519822701, -73.2399978637695, -1.27827910687639, 218, 23, 'PPL', 'P'),
(28012, 'New Athens', 38.3263893127441, 0.668921683908552, -89.8769378662109, -1.56864848737575, 218, 18, 'PPL', 'P'),
(156698, 'New Athens', 40.1847190856934, 0.701355657034355, -80.9958267211914, -1.41364385665959, 218, 41, 'PPL', 'P'),
(165081, 'New Athens', 41.0136108398438, 0.71582254728691, -79.5369415283203, -1.3881815066354, 218, 45, 'PPL', 'P'),
(28013, 'New Athens (historical)', 39.646671295166, 0.691964951556572, -87.9466705322266, -1.53495896695403, 218, 18, 'PPL', 'P'),
(183594, 'New Auberry', 37.0933303833008, 0.647400745718649, -119.496109008789, -2.08560054552543, 218, 6, 'PPL', 'P'),
(128231, 'New Auburn', 44.0833282470703, 0.769399223148797, -70.2233276367188, -1.22562827896747, 218, 26, 'PPL', 'P'),
(137063, 'New Auburn', 44.6736106872559, 0.779701595246742, -94.2294387817383, -1.64461395904777, 218, 28, 'PPL', 'P'),
(175503, 'New Auburn', 45.2041702270508, 0.788961606094029, -91.5580596923828, -1.59798959836959, 218, 57, 'PPL', 'P'),
(10756, 'New Augusta', 35.271110534668, 0.615597009664814, -91.3586120605469, -1.59450858050874, 218, 4, 'PPL', 'P'),
(30618, 'New Augusta', 39.8833312988281, 0.696095447828257, -86.2386093139648, -1.50514767486973, 218, 19, 'PPL', 'P'),
(61031, 'New Augusta', 31.202220916748, 0.544581488931897, -89.0347213745117, -1.553949036581, 218, 30, 'PPL', 'P'),
(28015, 'New Baden', 38.5349998474121, 0.672562624592854, -89.7005615234375, -1.56557013947173, 218, 18, 'PPL', 'P'),
(96474, 'New Baden', 31.0508308410645, 0.541939233656375, -96.4288864135742, -1.6830015619485, 218, 51, 'PPL', 'P'),
(30619, 'New Baltimore', 38.1772193908691, 0.666318177626891, -87.9175033569336, -1.53444990371166, 218, 19, 'PPL', 'P'),
(78809, 'New Baltimore', 39.8250007629395, 0.695077387922547, -76.9736099243164, -1.3434429303251, 218, 45, 'PPL', 'P'),
(104606, 'New Baltimore', 38.767219543457, 0.676615622876818, -77.7286071777344, -1.35662011824076, 218, 53, 'PPL', 'P'),
(132252, 'New Baltimore', 42.6811103820801, 0.744925904574432, -82.7369384765625, -1.444031989436, 218, 27, 'PPL', 'P'),
(150996, 'New Baltimore', 42.4461097717285, 0.740824370179601, -73.7888870239258, -1.28785902994962, 218, 40, 'PPL', 'P'),
(156699, 'New Baltimore', 40.9844398498535, 0.715313417465514, -81.2497177124023, -1.41807509039738, 218, 41, 'PPL', 'P'),
(156700, 'New Bavaria', 41.2036094665527, 0.71913864889725, -84.168327331543, -1.46901443783176, 218, 41, 'PPL', 'P'),
(165082, 'New Beaver', 40.8763885498047, 0.713427566518602, -80.3708267211914, -1.40273554883463, 218, 45, 'PPL', 'P'),
(120755, 'New Bedford', 41.5127792358398, 0.724534679318941, -89.7205581665039, -1.56591914673258, 218, 18, 'PPL', 'P'),
(125533, 'New Bedford', 41.6361083984375, 0.726687179269997, -70.9347229003906, -1.23804446860164, 218, 23, 'PPL', 'P'),
(145870, 'New Bedford', 40.1791687011719, 0.701258784549703, -74.0625, -1.2926344772583, 218, 37, 'PPL', 'P'),
(156701, 'New Bedford', 40.4447212219238, 0.705893550373795, -81.7652816772461, -1.42707337908854, 218, 41, 'PPL', 'P'),
(165084, 'New Bedford', 41.0972213745117, 0.717281826406219, -80.504997253418, -1.40507726638114, 218, 45, 'PPL', 'P'),
(67137, 'New Belden', 35.6183280944824, 0.621657099304316, -77.2949981689453, -1.34905221337108, 218, 33, 'PPL', 'P'),
(165085, 'New Bergen (historical)', 41.628059387207, 0.726546697522496, -77.7152786254883, -1.35638749111954, 218, 45, 'PPL', 'P'),
(17254, 'New Berlin', 30.3983306884766, 0.530550957623951, -81.5527801513672, -1.42336452779644, 218, 12, 'PPL', 'P'),
(28016, 'New Berlin', 39.7252807617188, 0.693336945571153, -89.9105606079102, -1.56923531492195, 218, 18, 'PPL', 'P'),
(67138, 'New Berlin', 34.314998626709, 0.598909708853404, -78.2200012207031, -1.36519656221525, 218, 33, 'PPL', 'P'),
(96475, 'New Berlin', 29.4638900756836, 0.51424189226636, -98.100830078125, -1.71218248380277, 218, 51, 'PPL', 'P'),
(150998, 'New Berlin', 42.6241683959961, 0.743932079434642, -75.3319396972656, -1.31479037963111, 218, 40, 'PPL', 'P'),
(165086, 'New Berlin', 40.8788909912109, 0.713471242360479, -76.9872207641602, -1.34368048429434, 218, 45, 'PPL', 'P'),
(175505, 'New Berlin', 42.976390838623, 0.750079520757899, -88.1083297729492, -1.53778045297091, 218, 57, 'PPL', 'P'),
(165088, 'New Berlinville', 40.3452796936035, 0.70415796829139, -75.6333312988281, -1.32005065541623, 218, 45, 'PPL', 'P'),
(67139, 'New Bern', 35.1083297729492, 0.612755949413917, -77.0444412231445, -1.34467916970312, 218, 33, 'PPL', 'P'),
(4516, 'New Bethel', 34.6450004577637, 0.604669327342919, -87.7916717529297, -1.53225372791872, 218, 2, 'PPL', 'P'),
(61032, 'New Bethel', 34.4927787780762, 0.602012557839456, -88.2486114501953, -1.54022883011908, 218, 30, 'PPL', 'P'),
(89358, 'New Bethel', 36.4261093139648, 0.635755541220059, -82.3530578613281, -1.43733200876558, 218, 50, 'PPL', 'P'),
(165089, 'New Bethlehem', 41.0016708374023, 0.715614154931612, -79.331672668457, -1.38459888917897, 218, 45, 'PPL', 'P'),
(96476, 'New Bielau', 29.6341991424561, 0.517214346227538, -96.7730331420898, -1.68900805547106, 218, 51, 'PPL', 'P'),
(4517, 'New Bingham', 32.4691696166992, 0.566693915199907, -86.1619415283203, -1.50380956958002, 218, 2, 'PPL', 'P'),
(49766, 'New Birmingham Manor', 39.1058311462402, 0.68252551023084, -76.9150009155273, -1.34242001015041, 218, 25, 'PPL', 'P'),
(96477, 'New Birthright', 33.2722206115723, 0.580709799121857, -95.5841674804688, -1.66825843531187, 218, 51, 'PPL', 'P'),
(10757, 'New Blaine', 35.2894401550293, 0.615916921890759, -93.4199981689453, -1.63048655525517, 218, 4, 'PPL', 'P'),
(183595, 'New Blinzing (historical)', 39.7188911437988, 0.693225425700506, -121.420829772949, -2.11919326004152, 218, 6, 'PPL', 'P'),
(56480, 'New Bloomfield', 38.7202796936035, 0.675796367946483, -92.0911102294922, -1.60729308532167, 218, 29, 'PPL', 'P'),
(165091, 'New Bloomfield', 40.4197196960449, 0.705457191429186, -77.1866683959961, -1.34716150215518, 218, 45, 'PPL', 'P'),
(156702, 'New Bloomington', 40.5833282470703, 0.708312699328996, -83.3166732788086, -1.45415027052359, 218, 41, 'PPL', 'P'),
(96478, 'New Blox', 30.9819393157959, 0.540736849713718, -93.9863891601563, -1.64037194290543, 218, 51, 'PPL', 'P'),
(104607, 'New Bohemia', 37.1836090087891, 0.648976404977594, -77.320556640625, -1.34949829285367, 218, 53, 'PPL', 'P'),
(30621, 'New Boston', 38.0586090087891, 0.664248035932545, -86.8102798461914, -1.51512520789372, 218, 19, 'PPL', 'P'),
(56481, 'New Boston', 39.9519386291504, 0.697292871633384, -92.8594436645508, -1.6207030335166, 218, 29, 'PPL', 'P'),
(73637, 'New Boston', 38.7522201538086, 0.676353834141663, -82.9369430541992, -1.44752272783482, 218, 41, 'PPL', 'P'),
(89359, 'New Boston', 36.336109161377, 0.634184742230103, -88.4430618286133, -1.54362262945422, 218, 50, 'PPL', 'P'),
(96479, 'New Boston', 33.4597206115723, 0.583982291469347, -94.415283203125, -1.64785755609743, 218, 51, 'PPL', 'P'),
(116997, 'New Boston', 40.5605583190918, 0.707915289115329, -91.5052795410156, -1.59706841094853, 218, 16, 'PPL', 'P'),
(120756, 'New Boston', 41.170280456543, 0.718556947936149, -90.9966735839844, -1.58819156240308, 218, 18, 'PPL', 'P'),
(125537, 'New Boston', 42.4019393920898, 0.740053451623051, -71.9936065673828, -1.25652547498624, 218, 23, 'PPL', 'P'),
(128232, 'New Boston', 43.8941688537598, 0.766097768924453, -70.9775009155273, -1.23879108581324, 218, 26, 'PPL', 'P'),
(132254, 'New Boston', 42.1624984741211, 0.735874419240498, -83.4030609130859, -1.45565801917474, 218, 27, 'PPL', 'P'),
(144183, 'New Boston', 42.9761085510254, 0.750074593909883, -71.6944427490234, -1.25130408135303, 218, 36, 'PPL', 'P'),
(151001, 'New Boston', 43.7999992370605, 0.764454199057711, -75.7461090087891, -1.32201899777791, 218, 40, 'PPL', 'P'),
(165092, 'New Boston', 40.7969398498535, 0.712040925118025, -76.1524963378906, -1.32911179470912, 218, 45, 'PPL', 'P'),
(172296, 'New Boston', 43.8208312988281, 0.764817787125534, -72.7647171020508, -1.26998389271301, 218, 55, 'PPL', 'P'),
(190538, 'New Boston (historical)', 38.4338912963867, 0.67079794747554, -118.150833129883, -2.06212105209085, 218, 39, 'PPL', 'P'),
(56482, 'New Bourbon', 37.9497184753418, 0.662347537599637, -90.0208282470703, -1.57115984828369, 218, 29, 'PPL', 'P'),
(125538, 'New Braintree', 42.3166694641113, 0.738565210626887, -72.1263885498047, -1.25884295776683, 218, 23, 'PPL', 'P'),
(23330, 'New Branch', 32.0819396972656, 0.559935478143558, -82.2516708374023, -1.43556247137927, 218, 13, 'PPL', 'P'),
(96480, 'New Braunfels', 29.7027797698975, 0.518411303979474, -98.1241683959961, -1.7125898142915, 218, 51, 'PPL', 'P'),
(96481, 'New Bremen', 29.9238891601563, 0.522270390846567, -96.4044418334961, -1.68257492354187, 218, 51, 'PPL', 'P'),
(151002, 'New Bremen', 43.8377799987793, 0.765113597743615, -75.440559387207, -1.31668615085308, 218, 40, 'PPL', 'P'),
(156703, 'New Bremen', 40.436939239502, 0.705757729158201, -84.3797225952148, -1.47270398120595, 218, 41, 'PPL', 'P'),
(145871, 'New Bridge', 40.9166717529297, 0.714130641046383, -74.0286102294922, -1.29204298918019, 218, 37, 'PPL', 'P'),
(201296, 'New Bridge', 44.8005599975586, 0.78191727869466, -117.188888549805, -2.04533195194677, 218, 43, 'PPL', 'P'),
(23331, 'New Bridge (historical)', 34.4311103820801, 0.6009362412849, -83.9722213745117, -1.46559174319879, 218, 13, 'PPL', 'P'),
(49767, 'New Bridge Haven', 38.0297203063965, 0.663743832959165, -75.5877838134766, -1.31925570183084, 218, 25, 'PPL', 'P'),
(78811, 'New Bridgeville', 39.9124984741211, 0.696604511070626, -76.4888916015625, -1.3349829996483, 218, 45, 'PPL', 'P'),
(137067, 'New Brighton', 45.065559387207, 0.786542390559801, -93.2016677856445, -1.62667597120943, 218, 28, 'PPL', 'P'),
(151030, 'New Brighton', 40.642219543457, 0.709340546351712, -74.0933303833008, -1.29317256895655, 218, 40, 'PPL', 'P'),
(165093, 'New Brighton', 40.730281829834, 0.710877523195824, -80.3102798461914, -1.40167880651409, 218, 45, 'PPL', 'P'),
(183596, 'New Brighton (historical)', 36.9799995422363, 0.64542274939802, -121.933609008789, -2.12814294604279, 218, 6, 'PPL', 'P'),
(132255, 'New Bristol Location', 46.1044387817383, 0.804674256525496, -88.3863906860352, -1.54263353142536, 218, 27, 'PPL', 'P'),
(113772, 'New Britain', 41.6611099243164, 0.727123538214607, -72.7799987792969, -1.27025060829618, 218, 8, 'PPL', 'P'),
(151004, 'New Britain', 42.454719543457, 0.740974639044109, -73.4902801513672, -1.28264735685439, 218, 40, 'PPL', 'P'),
(165095, 'New Britain', 40.2988891601563, 0.703348300740979, -75.1813888549805, -1.31216277174158, 218, 45, 'PPL', 'P'),
(30622, 'New Britton', 39.9797210693359, 0.69777776668886, -86.0100021362305, -1.50115772692458, 218, 19, 'PPL', 'P'),
(67165, 'New Britton', 34.0941696166992, 0.595055515544814, -78.5461120605469, -1.37088827009697, 218, 33, 'PPL', 'P'),
(4518, 'New Brockton', 31.3855590820313, 0.547781343560654, -85.929443359375, -1.49975171102707, 218, 2, 'PPL', 'P'),
(71159, 'New Brooklyn', 39.6930618286133, 0.692774619106983, -74.9430618286133, -1.30800318043498, 218, 37, 'PPL', 'P'),
(30624, 'New Brunswick', 39.2058296203613, 0.684270812851224, -87.1213912963867, -1.52055512704028, 218, 19, 'PPL', 'P'),
(145872, 'New Brunswick', 40.4861106872559, 0.706615932819479, -74.4522171020508, -1.29943632384042, 218, 37, 'PPL', 'P'),
(116998, 'New Buda', 40.601390838623, 0.708627951023034, -93.8102798461914, -1.63729825553332, 218, 16, 'PPL', 'P'),
(165098, 'New Buena Vista', 40.0088882446289, 0.698286829931229, -78.6986083984375, -1.3735498332904, 218, 45, 'PPL', 'P'),
(117000, 'New Buffalo', 42.0347213745117, 0.733644288143666, -91.70361328125, -1.60052998773341, 218, 16, 'PPL', 'P'),
(132256, 'New Buffalo', 41.7938919067383, 0.729441020995194, -86.7438888549805, -1.51396646650342, 218, 27, 'PPL', 'P'),
(156704, 'New Buffalo', 40.9880599975586, 0.715376600962376, -80.7125015258789, -1.40869889914753, 218, 41, 'PPL', 'P'),
(165099, 'New Buffalo', 40.4541702270508, 0.706058466624298, -76.9700012207031, -1.34337994656532, 218, 45, 'PPL', 'P'),
(73640, 'New Burlington', 39.2594413757324, 0.685206514500223, -84.5572204589844, -1.47580190334399, 218, 41, 'PPL', 'P'),
(123273, 'New Burlington', 40.1199989318848, 0.700226077257997, -85.2977828979492, -1.48872715622052, 218, 19, 'PPL', 'P'),
(28018, 'New Burnside', 37.5791702270508, 0.655880250629461, -88.7708282470703, -1.54934323263376, 218, 18, 'PPL', 'P'),
(61033, 'New Byram', 32.1852798461914, 0.561739103991814, -90.2594375610352, -1.5753243664383, 218, 30, 'PPL', 'P'),
(10758, 'New Caledonia', 33.0550003051758, 0.576918589573048, -92.6675033569336, -1.61735304318139, 218, 4, 'PPL', 'P'),
(42252, 'New California', 30.8483295440674, 0.538404919284217, -91.745002746582, -1.6012523701791, 218, 22, 'PPL', 'P'),
(156705, 'New California', 40.1561088562012, 0.700856314329965, -83.2366714477539, -1.45275397516406, 218, 41, 'PPL', 'P'),
(33412, 'New Cambria', 38.8791694641113, 0.678569517589582, -97.5055618286133, -1.7017930929162, 218, 20, 'PPL', 'P'),
(56483, 'New Cambria', 39.7752799987793, 0.694209596881345, -92.7502822875977, -1.61879780807276, 218, 29, 'PPL', 'P'),
(37392, 'New Camp', 37.6602783203125, 0.657295853906893, -82.2858276367188, -1.43615861998929, 218, 21, 'PPL', 'P'),
(96482, 'New Camp Ruby', 30.7049293518066, 0.535902113781274, -94.7435531616211, -1.65358694770857, 218, 51, 'PPL', 'P'),
(151005, 'New Campbellwood Wye', 43.6152801513672, 0.761230242821088, -75.7174987792969, -1.32151965507352, 218, 40, 'PPL', 'P'),
(4519, 'New Canaan', 34.2822189331055, 0.598337595272228, -86.4944381713867, -1.50961273075336, 218, 2, 'PPL', 'P'),
(61034, 'New Canaan', 34.9474983215332, 0.609948911045946, -89.1177825927734, -1.55539872832039, 218, 30, 'PPL', 'P'),
(113774, 'New Canaan', 41.146671295166, 0.718144890336487, -73.4952774047852, -1.28273457538009, 218, 8, 'PPL', 'P'),
(67141, 'New Candler', 35.545280456543, 0.620382177511468, -82.6788864135742, -1.44301878979928, 218, 33, 'PPL', 'P'),
(96483, 'New Caney', 30.1550006866455, 0.526304047923115, -95.2111129760742, -1.66174740592079, 218, 51, 'PPL', 'P'),
(28019, 'New Canton', 39.6361083984375, 0.691780594230111, -91.095832824707, -1.58992221763746, 218, 18, 'PPL', 'P'),
(89360, 'New Canton', 36.5213890075684, 0.637418485583732, -82.7583312988281, -1.44440536462083, 218, 50, 'PPL', 'P'),
(104608, 'New Canton', 37.7050018310547, 0.658076426422395, -78.2997207641602, -1.36658793072677, 218, 53, 'PPL', 'P'),
(145874, 'New Canton', 40.186939239502, 0.701394406028215, -74.5669403076172, -1.30143862150599, 218, 37, 'PPL', 'P'),
(73641, 'New Carlisle', 39.9361114501953, 0.697016635249316, -84.0255584716797, -1.46652265115783, 218, 41, 'PPL', 'P'),
(123274, 'New Carlisle', 41.7002792358398, 0.72780717166643, -86.5094375610352, -1.50987451948852, 218, 19, 'PPL', 'P'),
(30625, 'New Carrollton', 38.9447212219238, 0.67971361159388, -85.3652801513672, -1.48990520552872, 218, 19, 'PPL', 'P'),
(49768, 'New Carrollton', 38.9697189331055, 0.680149903959462, -76.8802795410156, -1.34181400784436, 218, 25, 'PPL', 'P'),
(42253, 'New Carthage (historical)', 32.2138900756836, 0.562238446696204, -91.1258316040039, -1.59044579510777, 218, 22, 'PPL', 'P'),
(151006, 'New Cassel', 40.7588882446289, 0.711376799321186, -73.5699996948242, -1.28403872536591, 218, 40, 'PPL', 'P'),
(4520, 'New Castle', 33.6488914489746, 0.587283945430772, -86.7686080932617, -1.51439789860002, 218, 2, 'PPL', 'P'),
(14291, 'New Castle', 39.6619415283203, 0.692231467402661, -75.5666732788086, -1.31888725349403, 218, 10, 'PPL', 'P'),
(30626, 'New Castle', 39.9288902282715, 0.696890601150728, -85.3702774047852, -1.48999242405442, 218, 19, 'PPL', 'P'),
(37393, 'New Castle', 38.4333305358887, 0.670788160358534, -85.1697235107422, -1.48649209827568, 218, 21, 'PPL', 'P'),
(56484, 'New Castle', 38.5705604553223, 0.673183274284897, -93.6363906860352, -1.63426331715507, 218, 29, 'PPL', 'P'),
(67142, 'New Castle', 36.1072196960449, 0.63018986743693, -80.9061126708984, -1.41207805109668, 218, 33, 'PPL', 'P'),
(73643, 'New Castle', 38.5858306884766, 0.673449790130986, -82.6969375610352, -1.44333384175623, 218, 41, 'PPL', 'P'),
(104609, 'New Castle', 37.5, 0.654498469497874, -80.1111068725586, -1.3982025823432, 218, 53, 'PPL', 'P'),
(144185, 'New Castle', 43.0722198486328, 0.751752052501496, -70.716667175293, -1.23423867824586, 218, 36, 'PPL', 'P'),
(165103, 'New Castle', 40.7299995422363, 0.710872596347807, -76.2119369506836, -1.33014922911176, 218, 45, 'PPL', 'P'),
(187106, 'New Castle', 39.5727806091309, 0.690675315798701, -107.535827636719, -1.87685425611785, 218, 7, 'PPL', 'P'),
(67143, 'New Castle (historical)', 36.166389465332, 0.631222574728636, -80.9558334350586, -1.41294584213788, 218, 33, 'PPL', 'P'),
(120758, 'New Castle (historical)', 40.5786094665527, 0.708230341072285, -89.3611068725586, -1.55964553815268, 218, 18, 'PPL', 'P'),
(14294, 'New Castle Industrial Park', 39.7041702270508, 0.692968497234341, -75.5361099243164, -1.31835382232769, 218, 10, 'PPL', 'P'),
(165104, 'New Castle Junction', 40.9652786254883, 0.714978991011628, -80.3694381713867, -1.40271131406871, 218, 45, 'PPL', 'P'),
(165108, 'New Centerville', 40.7174987792969, 0.710654416875502, -75.3688888549805, -1.31543526408907, 218, 45, 'PPL', 'P'),
(195378, 'New Centerville', 43.8811111450195, 0.76586986891417, -115.909172058105, -2.02299668567455, 218, 17, 'PPL', 'P'),
(96484, 'New Chapel Hill', 32.3050003051758, 0.56382862018309, -95.1727828979492, -1.66107841985496, 218, 51, 'PPL', 'P'),
(89361, 'New Chelsea', 35.1755599975586, 0.613929338190206, -90.0069427490234, -1.5709175006245, 218, 50, 'PPL', 'P'),
(175531, 'New Chester (historical)', 43.8616714477539, 0.765530582191294, -89.6374969482422, -1.5644694549932, 218, 57, 'PPL', 'P'),
(73644, 'New Chicago', 39.7319412231445, 0.693453192552735, -84.2586135864258, -1.47059023024876, 218, 41, 'PPL', 'P'),
(123275, 'New Chicago', 41.5583305358887, 0.725329699483357, -87.2744369506836, -1.52322627761363, 218, 19, 'PPL', 'P'),
(183597, 'New Chicago', 38.4372215270996, 0.670856070966331, -120.83528137207, -2.1089735125164, 218, 6, 'PPL', 'P'),
(197136, 'New Chicago', 46.6269416809082, 0.813793652467227, -113.141387939453, -1.97468973981966, 218, 31, 'PPL', 'P'),
(112622, 'New Church', 37.978889465332, 0.662856667421033, -75.5313873291016, -1.31827139749195, 218, 53, 'PPL', 'P'),
(28020, 'New City', 39.670280456543, 0.692377009156234, -89.5352783203125, -1.56268540337895, 218, 18, 'PPL', 'P'),
(128234, 'New City', 45.9900016784668, 0.802676952286964, -68.9113922119141, -1.20273068623108, 218, 26, 'PPL', 'P'),
(151008, 'New City', 41.1474990844727, 0.7181593379854, -73.9897232055664, -1.29136428257639, 218, 40, 'PPL', 'P'),
(175508, 'New City (historical)', 44.3488883972168, 0.774034122130944, -91.4408264160156, -1.59594349170408, 218, 57, 'PPL', 'P'),
(151009, 'New City Park', 41.1333312988281, 0.717912063478186, -74.0025024414063, -1.29158732231768, 218, 40, 'PPL', 'P'),
(96485, 'New Clarkson', 31.0058307647705, 0.541153834161397, -96.9052810668945, -1.69131621718783, 218, 51, 'PPL', 'P'),
(156706, 'New Cleveland', 41.0736083984375, 0.716869702227529, -84.0388870239258, -1.46675527827904, 218, 41, 'PPL', 'P'),
(104611, 'New Cold Harbor', 37.5827789306641, 0.655943234389242, -77.291389465332, -1.3489892296113, 218, 53, 'PPL', 'P'),
(96487, 'New Colony', 33.047779083252, 0.57679255547446, -94.2988891601563, -1.64582609681792, 218, 51, 'PPL', 'P'),
(28021, 'New Columbia', 37.3105583190918, 0.651192088425513, -88.7752838134766, -1.54942099693759, 218, 18, 'PPL', 'P'),
(165109, 'New Columbia', 41.040828704834, 0.716297588646353, -76.8672180175781, -1.34158604125505, 218, 45, 'PPL', 'P'),
(37394, 'New Columbus', 38.4575004577637, 0.671210005075203, -84.6452789306641, -1.47733881360907, 218, 21, 'PPL', 'P'),
(123276, 'New Columbus', 40.0188903808594, 0.698461400140684, -85.6558303833008, -1.4949762637184, 218, 19, 'PPL', 'P'),
(165111, 'New Columbus', 41.1733283996582, 0.718610144578923, -76.2938919067383, -1.33157961293324, 218, 45, 'PPL', 'P'),
(37395, 'New Concord', 36.5483283996582, 0.637888666674186, -88.1547164916992, -1.5385900539423, 218, 21, 'PPL', 'P'),
(73645, 'New Concord', 39.9936103820801, 0.698020180927085, -81.7341690063477, -1.42653036054227, 218, 41, 'PPL', 'P'),
(151010, 'New Concord', 42.3952789306641, 0.739937204641469, -73.5269393920898, -1.28328718130629, 218, 40, 'PPL', 'P'),
(151011, 'New Connecticut', 42.2730598449707, 0.737804079187342, -76.1483306884766, -1.32903909041136, 218, 40, 'PPL', 'P'),
(4522, 'New Convert', 32.8197212219238, 0.572812194909227, -86.8372192382813, -1.51559538898417, 218, 2, 'PPL', 'P'),
(89362, 'New Corinth', 36.2016716003418, 0.631838364151689, -83.6152801513672, -1.45936194361882, 218, 50, 'PPL', 'P'),
(96488, 'New Corn Hill', 30.7694396972656, 0.537028031711132, -97.5872192382813, -1.70321828357356, 218, 51, 'PPL', 'P'),
(123277, 'New Corydon', 40.5686111450195, 0.708055837441858, -84.8399963378906, -1.48073727347612, 218, 19, 'PPL', 'P'),
(139356, 'New Court Village', 40.1066703796387, 0.699993450136779, -91.8130569458008, -1.60244014002527, 218, 29, 'PPL', 'P'),
(110625, 'New Creek', 39.375, 0.687223392972767, -79.0269393920898, -1.37928029016597, 218, 58, 'PPL', 'P'),
(156707, 'New Cumberland', 40.5386085510254, 0.707532193392521, -81.3002777099609, -1.41895752882457, 218, 41, 'PPL', 'P'),
(165118, 'New Cumberland', 40.2322196960449, 0.702184699081696, -76.8850021362305, -1.3418964326801, 218, 45, 'PPL', 'P'),
(177253, 'New Cumberland', 40.4966697692871, 0.706800223566913, -80.6069412231445, -1.40685652430542, 218, 58, 'PPL', 'P'),
(82567, 'New Cut', 34.7786102294922, 0.607001257772419, -80.6733322143555, -1.40801526569571, 218, 48, 'PPL', 'P'),
(49769, 'New Cut Farms', 39.1194381713867, 0.682762997621048, -76.6513900756836, -1.33781913305118, 218, 25, 'PPL', 'P'),
(82568, 'New Cut Landing', 32.7058296203613, 0.570824411471592, -80.1780624389648, -1.39937117742953, 218, 48, 'PPL', 'P'),
(183607, 'New Cuyama', 34.9469413757324, 0.609939190507968, -119.684440612793, -2.08888755210086, 218, 6, 'PPL', 'P'),
(37397, 'New Cypress', 37.2519416809082, 0.650169035092759, -87.2399978637695, -1.5226252021556, 218, 21, 'PPL', 'P'),
(132259, 'New Dalton', 46.3919410705566, 0.809692118072396, -87.1997222900391, -1.52192226078587, 218, 27, 'PPL', 'P'),
(78814, 'New Danville', 39.9863891601563, 0.697894146828497, -76.3152770996094, -1.33195285496001, 218, 45, 'PPL', 'P'),
(42255, 'New Darbonne (historical)', 30.6111106872559, 0.534264669185039, -91.8708267211914, -1.60344841281398, 218, 22, 'PPL', 'P'),
(96516, 'New Davy', 29.0555591583252, 0.507115173320767, -97.6125030517578, -1.70365956936619, 218, 51, 'PPL', 'P'),
(89363, 'New Deal', 36.517219543457, 0.637345714706946, -86.563606262207, -1.51081994167549, 218, 50, 'PPL', 'P'),
(191932, 'New Deal', 33.7372207641602, 0.588825582806792, -101.836112976074, -1.77737546886542, 218, 51, 'PPL', 'P'),
(197137, 'New Deal (historical)', 48.0244407653809, 0.838184612784882, -106.464172363281, -1.85815034315001, 218, 31, 'PPL', 'P'),
(28022, 'New Delhi', 39.0316696166992, 0.681231147362034, -90.2611083984375, -1.57535352805224, 218, 18, 'PPL', 'P'),
(89364, 'New Dellrose', 35.1094398498535, 0.612775323910847, -86.8091735839844, -1.51510589997581, 218, 50, 'PPL', 'P'),
(28023, 'New Dennison', 37.6927795410156, 0.65786310721908, -88.8555603027344, -1.55082208598708, 218, 18, 'PPL', 'P'),
(165114, 'New Derry', 40.3505592346191, 0.704250113665107, -79.3166732788086, -1.38433710044382, 218, 45, 'PPL', 'P'),
(104612, 'New Design', 36.6336097717285, 0.639377107407431, -79.3977813720703, -1.38575270372125, 218, 53, 'PPL', 'P'),
(49770, 'New Design Acres', 39.3074989318848, 0.686045277085543, -77.460563659668, -1.35194187631187, 218, 25, 'PPL', 'P'),
(175510, 'New Diggings', 42.5352783203125, 0.742380654941616, -90.3352813720703, -1.57664809065813, 218, 57, 'PPL', 'P'),
(30627, 'New Discovery', 39.7316703796387, 0.6934484654418, -87.1305618286133, -1.52071518302179, 218, 19, 'PPL', 'P'),
(10759, 'New Dixie', 35.0424995422363, 0.61160699514063, -92.6119384765625, -1.61638325307044, 218, 4, 'PPL', 'P'),
(117001, 'New Dixon', 41.7347183227539, 0.728408247124461, -90.771110534668, -1.58425474452167, 218, 16, 'PPL', 'P'),
(151012, 'New Dorp', 40.5738906860352, 0.708147982815574, -74.1163864135742, -1.29357497259726, 218, 40, 'PPL', 'P'),
(151013, 'New Dorp Beach', 40.5652809143066, 0.707997713951067, -74.1033325195313, -1.29334713916601, 218, 40, 'PPL', 'P'),
(28024, 'New Douglas', 38.9700012207031, 0.680154830807479, -89.666389465332, -1.5649737245456, 218, 18, 'PPL', 'P'),
(145875, 'New Dover', 40.5849990844727, 0.708341860942932, -74.3436126708984, -1.29754081893455, 218, 37, 'PPL', 'P'),
(156708, 'New Dover', 40.2466697692871, 0.702436900436927, -83.3047180175781, -1.45394161185218, 218, 41, 'PPL', 'P'),
(82569, 'New Dublin (historical)', 33.9936103820801, 0.593300425807425, -81.0380630493164, -1.41438101964933, 218, 48, 'PPL', 'P'),
(137070, 'New Duluth', 46.6599998474121, 0.814370626317393, -92.2261123657227, -1.60964931709612, 218, 28, 'PPL', 'P'),
(183599, 'New Dunn', 35.0494384765625, 0.611728102391201, -116.425277709961, -2.03200442858758, 218, 6, 'PPL', 'P'),
(144187, 'New Durham', 43.4366683959961, 0.758112879607096, -71.1727828979492, -1.24219939937633, 218, 36, 'PPL', 'P'),
(145877, 'New Durham', 40.5436096191406, 0.707619478497248, -74.4063873291016, -1.29863644340701, 218, 37, 'PPL', 'P'),
(144188, 'New Durham Corner', 43.4219398498535, 0.757855817982876, -71.125, -1.24136543048097, 218, 36, 'PPL', 'P'),
(165115, 'New Eagle', 40.2077789306641, 0.701758127254093, -79.9472198486328, -1.39534221417441, 218, 45, 'PPL', 'P'),
(151014, 'New Ebenezer', 42.8566703796387, 0.747990004566623, -78.7416687011719, -1.37430137735002, 218, 40, 'PPL', 'P'),
(17255, 'New Eden', 28.2777805328369, 0.493540375454361, -81.1797180175781, -1.4168533652473, 218, 12, 'PPL', 'P'),
(10760, 'New Edinburg', 33.7572212219238, 0.589174656646674, -92.2383270263672, -1.60986250314138, 218, 4, 'PPL', 'P'),
(170934, 'New Effington', 45.8563919067383, 0.800345021857463, -96.9199981689453, -1.69157307907497, 218, 49, 'PPL', 'P'),
(145878, 'New Egypt', 40.0675010681152, 0.699309816684956, -74.5311126708984, -1.30081331128204, 218, 37, 'PPL', 'P'),
(30628, 'New Elizabethtown', 38.9172210693359, 0.679233643386421, -85.9869384765625, -1.50075519012581, 218, 19, 'PPL', 'P'),
(82570, 'New Ellenton', 33.4213905334473, 0.583313305403519, -81.6858291625977, -1.42568667110893, 218, 48, 'PPL', 'P'),
(104613, 'New Ellett', 37.1994400024414, 0.64925270794069, -80.3636093139648, -1.40260958131507, 218, 53, 'PPL', 'P'),
(123279, 'New Elliott', 41.4930610656738, 0.724190532327075, -87.4175033569336, -1.52572325745169, 218, 19, 'PPL', 'P'),
(23332, 'New Elm', 31.2936096191406, 0.546176522687773, -83.8191680908203, -1.46292045946738, 218, 13, 'PPL', 'P'),
(170936, 'New Elm Springs Colony', 43.4888916015625, 0.759024346490176, -97.82861328125, -1.70743140441807, 218, 49, 'PPL', 'P'),
(190539, 'New Empire', 39.1797218322754, 0.683815145988711, -119.724166870117, -2.08958090609066, 218, 39, 'PPL', 'P'),
(23333, 'New England', 34.9102783203125, 0.609299299477049, -85.4802780151367, -1.49191229688426, 218, 13, 'PPL', 'P'),
(110627, 'New England', 39.2069396972656, 0.684290187348154, -81.7088928222656, -1.4260892079077, 218, 58, 'PPL', 'P'),
(156709, 'New England', 40.7961082458496, 0.712026410890084, -81.5016708374023, -1.42247250198932, 218, 41, 'PPL', 'P'),
(165117, 'New England', 40.3347206115723, 0.703973677543957, -79.9272232055664, -1.39499320691355, 218, 45, 'PPL', 'P'),
(198655, 'New England', 46.5391693115234, 0.812261735629187, -102.867782592773, -1.79538150046961, 218, 34, 'PPL', 'P'),
(156710, 'New England (historical)', 40.5169410705566, 0.707154024517729, -81.3919372558594, -1.42055728969138, 218, 41, 'PPL', 'P'),
(205095, 'New England Condominium', 40.7719383239746, 0.711604566173415, -111.873062133789, -1.95255327852281, 218, 52, 'PPL', 'P'),
(71167, 'New England Crossroads', 39.3611106872559, 0.686980978734543, -75.2255630493164, -1.31293375687716, 218, 37, 'PPL', 'P'),
(49771, 'New England Estates', 38.7374992370605, 0.676096905675498, -76.9266662597656, -1.34262360881574, 218, 25, 'PPL', 'P'),
(110628, 'New England Heights Addition', 39.2158317565918, 0.684445383060678, -81.6722183227539, -1.4254491171397, 218, 58, 'PPL', 'P'),
(49772, 'New Enterprise', 38.5905609130859, 0.673532348124779, -76.6563873291016, -1.33790635157688, 218, 25, 'PPL', 'P'),
(89365, 'New Enterprise', 35.9055595397949, 0.626670233740281, -88.8497161865234, -1.55072008691733, 218, 50, 'PPL', 'P'),
(165134, 'New Enterprise', 40.170280456543, 0.701103655416206, -78.4072189331055, -1.36846412771473, 218, 45, 'PPL', 'P'),
(23334, 'New Era', 32.1141700744629, 0.56049800434481, -84.1363906860352, -1.4684570382156, 218, 13, 'PPL', 'P'),
(42257, 'New Era', 31.3669395446777, 0.547456371328637, -91.8272171020508, -1.60268728137443, 218, 22, 'PPL', 'P'),
(110629, 'New Era', 38.9094390869141, 0.679097822170826, -81.6638870239258, -1.42530370854418, 218, 58, 'PPL', 'P'),
(112563, 'New Era', 35.8411102294922, 0.625545381074859, -83.601936340332, -1.45912905018149, 218, 50, 'PPL', 'P'),
(117002, 'New Era', 41.4661102294922, 0.72372015149954, -90.8919372558594, -1.58636356863085, 218, 16, 'PPL', 'P'),
(123280, 'New Era', 41.2938919067383, 0.720714374735222, -85.1213912963867, -1.48564854200039, 218, 19, 'PPL', 'P'),
(132260, 'New Era', 43.5591697692871, 0.760250931909239, -86.3455581665039, -1.50701428447777, 218, 27, 'PPL', 'P'),
(165119, 'New Era', 41.6269416809082, 0.726527189867511, -76.3502807617188, -1.33256378411408, 218, 45, 'PPL', 'P'),
(201297, 'New Era', 45.3008308410645, 0.790648652065567, -122.657783508301, -2.14078217541825, 218, 43, 'PPL', 'P'),
(89367, 'New Era (historical)', 35.5055618286133, 0.61968895667972, -87.970832824707, -1.53538067851264, 218, 50, 'PPL', 'P'),
(104614, 'New Erection', 38.4736099243164, 0.671491168307288, -78.9277801513672, -1.37754963493159, 218, 53, 'PPL', 'P'),
(49773, 'New Estates', 39.3858299255371, 0.687412410831136, -77.1750030517578, -1.34695790348985, 218, 25, 'PPL', 'P'),
(4523, 'New Everdale', 32.4099998474121, 0.565661207908201, -86.8783264160156, -1.51631284458184, 218, 2, 'PPL', 'P'),
(30629, 'New Fairfield', 39.5069389343262, 0.689526161788331, -84.9725036621094, -1.48304996256675, 218, 19, 'PPL', 'P'),
(113776, 'New Fairfield', 41.4663887023926, 0.72372501176853, -73.4861068725586, -1.28257451939858, 218, 8, 'PPL', 'P'),
(48, 'New Falcon', 26.6383304595947, 0.464926573754222, -99.0952835083008, -1.72953897041709, 218, 51, 'PPL', 'P'),
(96489, 'New Falcon Colonia', 26.6389999389648, 0.464938258373505, -99.0960006713867, -1.72955148727421, 218, 51, 'PPL', 'P'),
(175512, 'New Fane', 43.5550003051758, 0.760178161032452, -88.1858291625977, -1.53913307248856, 218, 57, 'PPL', 'P'),
(61035, 'New Fannin', 32.4216690063477, 0.565864873152565, -89.9741668701172, -1.57034545362235, 218, 30, 'PPL', 'P'),
(30630, 'New Farmington', 38.9249992370605, 0.679369398022987, -85.866943359375, -1.49866088024457, 218, 19, 'PPL', 'P'),
(61036, 'New Fellowship', 32.2125015258789, 0.562214211930284, -88.9702835083008, -1.55282438365266, 218, 30, 'PPL', 'P'),
(61037, 'New Fitler', 32.7008285522461, 0.570737126366865, -91.0202789306641, -1.58860355342371, 218, 30, 'PPL', 'P'),
(42258, 'New Flanders', 30.1091709136963, 0.52550416748971, -92.0325012207031, -1.60627016514697, 218, 22, 'PPL', 'P'),
(73647, 'New Floodwood', 39.4136085510254, 0.687897239307585, -82.1880569458008, -1.43445219952082, 218, 41, 'PPL', 'P'),
(56485, 'New Florence', 38.9102783203125, 0.679112469556822, -91.4480590820313, -1.59606972553975, 218, 29, 'PPL', 'P'),
(165120, 'New Florence', 40.3802795410156, 0.704768830866427, -79.0755615234375, -1.38012890644733, 218, 45, 'PPL', 'P'),
(89368, 'New Flys Village', 35.788890838623, 0.624633980770807, -87.1650009155273, -1.52131625847982, 218, 50, 'PPL', 'P'),
(151015, 'New Forge', 42.1061096191406, 0.73489024805966, -73.6750030517578, -1.28587137967004, 218, 40, 'PPL', 'P'),
(209633, 'New Fork', 42.7016716003418, 0.745284765531321, -109.71443939209, -1.91487820437173, 218, 59, 'PPL', 'P'),
(212024, 'New Fort Hamilton', 62.7324981689453, 1.09488864104941, -164.925003051758, -2.87848432211487, 218, 1, 'PPL', 'P'),
(96490, 'New Fountain', 29.3863906860352, 0.512889272748709, -99.0597229003906, -1.72891832072504, 218, 51, 'PPL', 'P'),
(175513, 'New Franken', 44.5308303833008, 0.777209608835727, -87.8258285522461, -1.53284987652874, 218, 57, 'PPL', 'P'),
(30631, 'New Frankfort', 38.7366714477539, 0.676082458026584, -85.7111129760742, -1.49594112698133, 218, 19, 'PPL', 'P'),
(56486, 'New Frankfort', 39.3055610656738, 0.6860114549397, -93.0058288574219, -1.62325793710837, 218, 29, 'PPL', 'P'),
(56487, 'New Franklin', 39.017219543457, 0.680978946006804, -92.7372207641602, -1.61856984148345, 218, 29, 'PPL', 'P'),
(78815, 'New Franklin', 39.8808288574219, 0.69605177198638, -77.6361083984375, -1.35500570998796, 218, 45, 'PPL', 'P'),
(156712, 'New Franklin', 40.9416694641113, 0.714566933411965, -81.5416717529297, -1.42317064966908, 218, 41, 'PPL', 'P'),
(71161, 'New Freedom', 39.6552810668945, 0.692115220421079, -75.1902770996094, -1.31231790087508, 218, 37, 'PPL', 'P'),
(78816, 'New Freedom', 39.7377815246582, 0.693555125043458, -76.7016677856445, -1.33869664463037, 218, 45, 'PPL', 'P'),
(78818, 'New Freeport', 39.7597198486328, 0.693938021029184, -80.4258270263672, -1.40369548524955, 218, 45, 'PPL', 'P'),
(958, 'New Friendship', 35.5183296203613, 0.619911796683933, -88.6072235107422, -1.54648779131298, 218, 50, 'PPL', 'P'),
(42259, 'New Friendship', 32.2641716003418, 0.563116024854412, -92.8724975585938, -1.62093086694786, 218, 22, 'PPL', 'P'),
(183600, 'New Frontier Mobile Home Park', 32.8447189331055, 0.57324848727481, -116.966667175293, -2.04145345729324, 218, 6, 'PPL', 'P'),
(165122, 'New Galena', 40.3302803039551, 0.703896179556236, -75.1880569458008, -1.31227915188122, 218, 45, 'PPL', 'P'),
(165123, 'New Galena (historical)', 40.3327789306641, 0.703939788819086, -75.1766662597656, -1.31208034690584, 218, 45, 'PPL', 'P'),
(165124, 'New Galilee', 40.8355598449707, 0.712714971189924, -80.3997192382813, -1.40323981838704, 218, 45, 'PPL', 'P'),
(56488, 'New Garden', 39.3230590820313, 0.686316852937704, -94.1658325195313, -1.64350382034737, 218, 29, 'PPL', 'P'),
(78819, 'New Garden', 39.8141708374023, 0.694888370064179, -75.7525024414063, -1.32213058422758, 218, 45, 'PPL', 'P'),
(156713, 'New Garden', 40.795280456543, 0.71201196324117, -80.9263916015625, -1.41243198520555, 218, 41, 'PPL', 'P'),
(56489, 'New Garver', 36.4011116027832, 0.635319248854477, -89.8177795410156, -1.56761597982112, 218, 29, 'PPL', 'P'),
(10761, 'New Gascony', 34.226390838623, 0.597363211208395, -91.7763900756836, -1.60180018241533, 218, 4, 'PPL', 'P'),
(78821, 'New Geneva', 39.788330078125, 0.694437363733574, -79.9094390869141, -1.3946828154885, 218, 45, 'PPL', 'P'),
(4524, 'New Georgia', 34.2372207641602, 0.597552229066764, -87.1622161865234, -1.52126765578993, 218, 2, 'PPL', 'P'),
(23335, 'New Georgia', 33.8088912963867, 0.590076469570802, -84.8899993896484, -1.48160999136534, 218, 13, 'PPL', 'P'),
(4525, 'New Georgia (historical)', 34.9011116027832, 0.609139310074562, -87.2474975585938, -1.52275609652318, 218, 2, 'PPL', 'P'),
(23336, 'New Georgia Estates', 33.8158302307129, 0.590197576821374, -84.8986129760742, -1.48176032680888, 218, 13, 'PPL', 'P'),
(165126, 'New Germantown', 40.3088912963867, 0.703522870950434, -77.5699996948242, -1.35385189544568, 218, 45, 'PPL', 'P'),
(631, 'New Germany', 39.6324996948242, 0.69171761047033, -79.1224975585938, -1.38094809479864, 218, 25, 'PPL', 'P'),
(73648, 'New Germany', 39.7747192382813, 0.694199809764339, -84.0800018310547, -1.46747286703477, 218, 41, 'PPL', 'P'),
(137072, 'New Germany', 44.8841705322266, 0.783376557813969, -93.9702835083008, -1.64009084625238, 218, 28, 'PPL', 'P'),
(165127, 'New Germany', 40.4122200012207, 0.705326297061608, -78.7552795410156, -1.37453893131925, 218, 45, 'PPL', 'P'),
(67145, 'New Gilead', 35.4500007629395, 0.618719233147795, -80.5461120605469, -1.40579485513686, 218, 33, 'PPL', 'P'),
(175514, 'New Glarus', 42.8144416809082, 0.747252974734944, -89.6350021362305, -1.56442591230937, 218, 57, 'PPL', 'P'),
(104616, 'New Glasgow', 37.6291694641113, 0.656752901939653, -78.9791717529297, -1.37844658758672, 218, 53, 'PPL', 'P'),
(49774, 'New Glatz', 38.7733306884766, 0.676722282478476, -77.0063934326172, -1.34401511048531, 218, 25, 'PPL', 'P'),
(128235, 'New Gloucester', 43.9627799987793, 0.767295259308607, -70.2830581665039, -1.22667077337618, 218, 26, 'PPL', 'P'),
(30633, 'New Goshen', 39.5811080932617, 0.690820657815192, -87.4622192382813, -1.52650369680913, 218, 19, 'PPL', 'P'),
(73649, 'New Gottingen', 39.9683303833008, 0.697578961713486, -81.3988876342773, -1.42067859667904, 218, 41, 'PPL', 'P'),
(33413, 'New Gottland', 38.4497184753418, 0.671074183859608, -97.6111068725586, -1.70363520144221, 218, 20, 'PPL', 'P'),
(28026, 'New Grand Chain', 37.2519416809082, 0.650169035092759, -89.021110534668, -1.55371148261177, 218, 18, 'PPL', 'P'),
(132261, 'New Greenleaf', 43.6616706848145, 0.7620399103715, -83.0783309936523, -1.44999041290089, 218, 27, 'PPL', 'P'),
(165128, 'New Grenada', 40.1344413757324, 0.700478145455173, -78.0877838134766, -1.3628889331307, 218, 45, 'PPL', 'P'),
(71162, 'New Gretna', 39.5922203063965, 0.691014602521577, -74.4513931274414, -1.29942194277053, 218, 37, 'PPL', 'P'),
(56490, 'New Grove', 37.2447204589844, 0.650043000994171, -92.663330078125, -1.61728020572558, 218, 29, 'PPL', 'P'),
(156714, 'New Guilford', 40.290828704834, 0.703207619256396, -82.1616668701172, -1.43399160581029, 218, 41, 'PPL', 'P'),
(113778, 'New Guinea (historical)', 41.3038902282715, 0.72088887836565, -72.9155578613281, -1.27261656060861, 218, 8, 'PPL', 'P'),
(156715, 'New Guinea (historical)', 40.9447212219238, 0.714620196633767, -81.100830078125, -1.41547651096373, 218, 41, 'PPL', 'P'),
(151016, 'New Hackensack', 41.6227798461914, 0.726454552148779, -73.8711090087891, -1.28929407430301, 218, 40, 'PPL', 'P'),
(156716, 'New Hagerstown', 40.4433288574219, 0.705869249028848, -81.1872177124023, -1.41698425961488, 218, 41, 'PPL', 'P'),
(113779, 'New Halville', 41.2911109924316, 0.720665838624356, -72.9541702270508, -1.27329047352246, 218, 8, 'PPL', 'P'),
(56491, 'New Hamburg', 37.1263885498047, 0.647977719568815, -89.5933303833008, -1.56369860301567, 218, 29, 'PPL', 'P'),
(151017, 'New Hamburg', 41.5883293151855, 0.725853276953666, -73.945556640625, -1.29059343059886, 218, 40, 'PPL', 'P'),
(165129, 'New Hamburg', 41.3252792358398, 0.721262186971452, -80.3419418334961, -1.40223141244028, 218, 45, 'PPL', 'P'),
(61038, 'New Hamilton', 33.7377815246582, 0.588835369923798, -88.4447174072266, -1.54365152475205, 218, 30, 'PPL', 'P'),
(212023, 'New Hamilton', 62.7311096191406, 1.09486440628349, -163.925827026367, -2.86104541066481, 218, 1, 'PPL', 'P'),
(110630, 'New Hamlin', 38.2788887023926, 0.66809264186121, -82.1144409179688, -1.43316735745291, 218, 58, 'PPL', 'P'),
(104617, 'New Hampden', 38.4927787780762, 0.671825727919229, -79.563606262207, -1.38864689403589, 218, 53, 'PPL', 'P'),
(144190, 'New Hampshire', 43.6669387817383, 0.762131856008134, -71.5002822875977, -1.24791534202396, 218, 36, 'ADM1', 'A'),
(156717, 'New Hampshire', 40.5561103820801, 0.707837657969553, -83.9527816772461, -1.46525245647591, 218, 41, 'PPL', 'P'),
(49775, 'New Hampshire Estates', 38.996940612793, 0.680625011897932, -76.9908294677734, -1.34374346805412, 218, 25, 'PPL', 'P'),
(49776, 'New Hampshire Gardens', 38.9869384765625, 0.680450441688478, -76.991943359375, -1.34376290913008, 218, 25, 'PPL', 'P'),
(151018, 'New Hampstead', 41.1500015258789, 0.718203013827277, -74.0366668701172, -1.29218360408575, 218, 40, 'PPL', 'P'),
(117003, 'New Hampton', 43.0591697692871, 0.751524285649267, -92.317497253418, -1.61124428427297, 218, 16, 'PPL', 'P'),
(139357, 'New Hampton', 40.2636108398438, 0.702732577896953, -94.1958312988281, -1.64402739781768, 218, 29, 'PPL', 'P'),
(144198, 'New Hampton', 43.6055603027344, 0.76106059945965, -71.6547164916992, -1.25061072736323, 218, 36, 'PPL', 'P'),
(145879, 'New Hampton', 40.7219390869141, 0.710731914863224, -74.960563659668, -1.30830864501202, 218, 37, 'PPL', 'P'),
(151019, 'New Hampton', 41.410831451416, 0.722755354815632, -74.4075012207031, -1.29865588448297, 218, 40, 'PPL', 'P'),
(28027, 'New Hanover', 38.3866691589355, 0.669973765697188, -90.2272186279297, -1.57476203997413, 218, 18, 'PPL', 'P'),
(165130, 'New Hanover', 40.297779083252, 0.703328926244049, -75.581672668457, -1.31914904222918, 218, 45, 'PPL', 'P'),
(165131, 'New Hanover Square', 40.3105583190918, 0.703551965985343, -75.5388870239258, -1.31840229185953, 218, 45, 'PPL', 'P'),
(128237, 'New Harbor', 43.8758316040039, 0.765777723540453, -69.4905624389648, -1.21283911362264, 218, 26, 'PPL', 'P'),
(4527, 'New Harmony', 34.2425003051758, 0.59764437444048, -86.533332824707, -1.51029157051522, 218, 2, 'PPL', 'P'),
(17256, 'New Harmony', 30.8533306121826, 0.538492204388944, -86.2799987792969, -1.50587005731542, 218, 12, 'PPL', 'P'),
(30634, 'New Harmony', 38.1297187805176, 0.665489135579549, -87.9349975585938, -1.53475523513064, 218, 19, 'PPL', 'P'),
(56492, 'New Harmony', 39.2941703796387, 0.685812649964325, -91.3747177124023, -1.5947896771618, 218, 29, 'PPL', 'P'),
(61039, 'New Harmony', 34.3938903808594, 0.600286629716003, -88.9197235107422, -1.55194194522546, 218, 30, 'PPL', 'P'),
(73650, 'New Harmony', 39.0136108398438, 0.680915962247024, -84.0122222900391, -1.46628989087855, 218, 41, 'PPL', 'P'),
(89371, 'New Harmony', 36.4891700744629, 0.636856159119562, -86.0927810668945, -1.50260249181595, 218, 50, 'PPL', 'P'),
(96493, 'New Harmony', 32.4141693115234, 0.565733978784988, -95.4658279418945, -1.66619302072846, 218, 51, 'PPL', 'P'),
(192721, 'New Harmony', 37.4794387817383, 0.654139608540985, -113.308891296387, -1.97761322490629, 218, 52, 'PPL', 'P'),
(10762, 'New Haroldton', 35.3708305358887, 0.617337452016208, -94.241943359375, -1.6448322050991, 218, 4, 'PPL', 'P'),
(96494, 'New Harp', 33.4524993896484, 0.583856257370759, -97.5725021362305, -1.70296142168642, 218, 51, 'PPL', 'P'),
(156718, 'New Harrisburg', 40.6213912963867, 0.708977024862916, -81.146110534668, -1.41626680401721, 218, 41, 'PPL', 'P'),
(156719, 'New Harrison', 40.1122207641602, 0.700090322621431, -84.5175018310547, -1.47510868251224, 218, 41, 'PPL', 'P'),
(156720, 'New Harrison (historical)', 41.1666717529297, 0.718493964176369, -84.8008270263672, -1.4800536400243, 218, 41, 'PPL', 'P'),
(28028, 'New Hartford', 39.5755615234375, 0.690723851909567, -90.9100036621094, -1.58667888690391, 218, 18, 'PPL', 'P'),
(56493, 'New Hartford', 39.1994400024414, 0.684159292980577, -91.2699966430664, -1.59296194970568, 218, 29, 'PPL', 'P'),
(113780, 'New Hartford', 41.8822212219238, 0.730982658371213, -72.9775009155273, -1.27369767085313, 218, 8, 'PPL', 'P'),
(117005, 'New Hartford', 42.5669403076172, 0.742933260867808, -92.621940612793, -1.61655782327989, 218, 16, 'PPL', 'P'),
(137074, 'New Hartford', 43.8786087036133, 0.765826193072292, -91.4755630493164, -1.59654976032624, 218, 28, 'PPL', 'P'),
(151020, 'New Hartford', 43.0733299255371, 0.751771426998427, -75.2880630493164, -1.31402458765965, 218, 40, 'PPL', 'P'),
(4529, 'New Haven', 34.6333312988281, 0.604465662098555, -86.7613906860352, -1.51427193108046, 218, 2, 'PPL', 'P'),
(28029, 'New Haven', 37.9086112976074, 0.661630082001969, -88.1291732788086, -1.53814424077582, 218, 18, 'PPL', 'P'),
(37399, 'New Haven', 37.6577796936035, 0.657252244644043, -85.5911102294922, -1.49384668394204, 218, 21, 'PPL', 'P'),
(56494, 'New Haven', 38.6083297729492, 0.673842473233719, -91.2188873291016, -1.59206992389856, 218, 29, 'PPL', 'P'),
(61040, 'New Haven', 31.8158302307129, 0.555290991781487, -89.584716796875, -1.56354826757214, 218, 30, 'PPL', 'P'),
(67147, 'New Haven', 36.5316696166992, 0.637597916062176, -81.1602783203125, -1.41651407852443, 218, 33, 'PPL', 'P'),
(89374, 'New Haven', 36.5077781677246, 0.637180931614497, -87.8158264160156, -1.53267530631928, 218, 50, 'PPL', 'P'),
(110636, 'New Haven', 38.9863891601563, 0.680440854308554, -81.9736099243164, -1.43070939292482, 218, 58, 'PPL', 'P'),
(113782, 'New Haven', 41.3080596923828, 0.720961649242436, -72.9286117553711, -1.27284439403987, 218, 8, 'PPL', 'P'),
(117006, 'New Haven', 43.2844390869141, 0.755455976945578, -92.6419372558594, -1.61690683054075, 218, 16, 'PPL', 'P'),
(123281, 'New Haven', 41.0705604553223, 0.716816505584755, -85.0144424438477, -1.48378193239236, 218, 19, 'PPL', 'P'),
(132263, 'New Haven', 43.0936088562012, 0.752125361107298, -84.1533279418945, -1.4687526490966, 218, 27, 'PPL', 'P'),
(151022, 'New Haven', 43.4797210693359, 0.758864290508662, -76.315559387207, -1.33195778180803, 218, 40, 'PPL', 'P'),
(156721, 'New Haven', 41.0316696166992, 0.716137732401921, -82.6816711425781, -1.44306739248917, 218, 41, 'PPL', 'P'),
(165133, 'New Haven', 40.0161094665527, 0.698412864029817, -79.6080627441406, -1.38942280601949, 218, 45, 'PPL', 'P'),
(172297, 'New Haven', 44.124439239502, 0.770116745325492, -73.154167175293, -1.27678107876322, 218, 55, 'PPL', 'P'),
(194340, 'New Haven', 40.4830589294434, 0.706562669597677, -102.835830688477, -1.79482383453734, 218, 7, 'PPL', 'P'),
(209634, 'New Haven', 44.7441711425781, 0.780933107513822, -104.844169616699, -1.8298759613308, 218, 59, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(197138, 'New Haven (historical)', 46.4625015258789, 0.810923630339476, -111.985557556152, -1.95451669403647, 218, 31, 'PPL', 'P'),
(132264, 'New Haven Center', 43.2488899230957, 0.754835526990617, -84.7772216796875, -1.47964164900366, 218, 27, 'PPL', 'P'),
(172298, 'New Haven Junction', 44.1233291625977, 0.770097370828562, -73.1841735839844, -1.27730478939159, 218, 55, 'PPL', 'P'),
(172299, 'New Haven Mills', 44.0916709899902, 0.769544831481397, -73.1091690063477, -1.27599571255776, 218, 55, 'PPL', 'P'),
(28031, 'New Hebron', 38.9500007629395, 0.679805756967597, -87.7444381713867, -1.53142934640329, 218, 18, 'PPL', 'P'),
(61041, 'New Hebron', 31.7308292388916, 0.553807444606745, -89.9786071777344, -1.57042295161007, 218, 30, 'PPL', 'P'),
(142498, 'New Helena', 41.6113891601563, 0.726255747173405, -99.7508316040039, -1.74098044309228, 218, 35, 'PPL', 'P'),
(89375, 'New Herman', 35.3349990844727, 0.61671207521323, -86.4433288574219, -1.50872070494624, 218, 50, 'PPL', 'P'),
(4530, 'New Hill', 33.4183311462402, 0.583259909023663, -86.9219436645508, -1.51707410917944, 218, 2, 'PPL', 'P'),
(67148, 'New Hill', 35.6808280944824, 0.622747930086813, -78.9358291625977, -1.37769011667909, 218, 33, 'PPL', 'P'),
(82572, 'New Hill', 34.726390838623, 0.606089857468367, -81.5899963378906, -1.42401407278631, 218, 48, 'PPL', 'P'),
(112655, 'New Hill', 39.6683311462402, 0.692342987273308, -80.0716705322266, -1.39751428835947, 218, 58, 'PPL', 'P'),
(23337, 'New Holland', 34.3069381713867, 0.598769027368821, -83.8024978637695, -1.46262950911829, 218, 13, 'PPL', 'P'),
(67149, 'New Holland', 35.4433288574219, 0.618602786429132, -76.1699981689453, -1.32941725928615, 218, 33, 'PPL', 'P'),
(73652, 'New Holland', 39.5538902282715, 0.690345616455749, -83.2569427490234, -1.45310777611488, 218, 41, 'PPL', 'P'),
(82573, 'New Holland', 33.6941719055176, 0.588074238484253, -81.4908294677734, -1.42228328439386, 218, 48, 'PPL', 'P'),
(120760, 'New Holland', 40.1847190856934, 0.701355657034355, -89.5808334350586, -1.56348049012239, 218, 18, 'PPL', 'P'),
(132267, 'New Holland', 42.8561096191406, 0.747980217449617, -86.0788879394531, -1.50236001099869, 218, 27, 'PPL', 'P'),
(165145, 'New Holland', 40.1016693115234, 0.699906165032052, -76.085563659668, -1.32794359909695, 218, 45, 'PPL', 'P'),
(170937, 'New Holland', 43.4272193908691, 0.757947963356593, -98.60888671875, -1.7210497449683, 218, 49, 'PPL', 'P'),
(82574, 'New Holland Crossroads', 33.7008285522461, 0.588190418886808, -81.4805603027344, -1.4221040536525, 218, 48, 'PPL', 'P'),
(61042, 'New Holmesville (historical)', 31.2124996185303, 0.544760886120827, -90.3138885498047, -1.5762747154733, 218, 30, 'PPL', 'P'),
(175519, 'New Holstein', 43.9500007629395, 0.767072219567313, -88.0841674804688, -1.5373587414123, 218, 57, 'PPL', 'P'),
(4532, 'New Home', 34.6022186279297, 0.603922643552288, -85.6991729736328, -1.49573273462603, 218, 2, 'PPL', 'P'),
(10763, 'New Home', 35.0322189331055, 0.611427564662186, -90.5763931274414, -1.58085628465462, 218, 4, 'PPL', 'P'),
(17257, 'New Home', 30.6088905334473, 0.534225920191178, -86.2197189331055, -1.50481797552678, 218, 12, 'PPL', 'P'),
(56496, 'New Home', 38.1436080932617, 0.665731549817773, -94.4722213745117, -1.64885131465819, 218, 29, 'PPL', 'P'),
(67150, 'New Home', 35.5055618286133, 0.61968895667972, -81.6672210693359, -1.425361898614, 218, 33, 'PPL', 'P'),
(191933, 'New Home', 33.3263893127441, 0.581655221308836, -101.911666870117, -1.77869413307917, 218, 51, 'PPL', 'P'),
(67151, 'New Home (historical)', 36.4497184753418, 0.636167598819722, -80.9297180175781, -1.41249004211732, 218, 33, 'PPL', 'P'),
(178710, 'New Home Mobile Park', 33.5161094665527, 0.584966462650185, -112.11499786377, -1.95677585358919, 218, 5, 'PPL', 'P'),
(4543, 'New Hope', 33.3591690063477, 0.582227334890012, -86.7372207641602, -1.51385008636379, 218, 2, 'PPL', 'P'),
(10772, 'New Hope', 33.0647201538086, 0.577088232934486, -92.9252777099609, -1.62185205436891, 218, 4, 'PPL', 'P'),
(17260, 'New Hope', 30.5777797698975, 0.533682934934425, -85.8088912963867, -1.49764768060785, 218, 12, 'PPL', 'P'),
(23345, 'New Hope', 33.9580612182617, 0.592679975852464, -84.789436340332, -1.47985483504893, 218, 13, 'PPL', 'P'),
(28032, 'New Hope', 37.7938919067383, 0.659627850915421, -88.6888885498047, -1.54791311512839, 218, 18, 'PPL', 'P'),
(30636, 'New Hope', 37.9897193908691, 0.663045685279401, -87.2225036621094, -1.52231987073662, 218, 19, 'PPL', 'P'),
(37400, 'New Hope', 37.6319389343262, 0.656801238313438, -85.5083312988281, -1.49240191905067, 218, 21, 'PPL', 'P'),
(42260, 'New Hope', 32.1444396972656, 0.561026308926054, -93.4247207641602, -1.63056898009091, 218, 22, 'PPL', 'P'),
(49778, 'New Hope', 38.3908309936523, 0.67004640341592, -75.335563659668, -1.31485362970699, 218, 25, 'PPL', 'P'),
(56498, 'New Hope', 39.1366691589355, 0.683063735087145, -90.8641662597656, -1.58587887331245, 218, 29, 'PPL', 'P'),
(61049, 'New Hope', 33.9422187805176, 0.592403473152286, -89.5511093139648, -1.56296170634205, 218, 30, 'PPL', 'P'),
(67162, 'New Hope', 35.795280456543, 0.624745500641454, -77.9508285522461, -1.3604986128943, 218, 33, 'PPL', 'P'),
(73654, 'New Hope', 39.7916717529297, 0.694495686961447, -84.7133331298828, -1.47852658345525, 218, 41, 'PPL', 'P'),
(82578, 'New Hope', 33.3505592346191, 0.582077066025504, -79.4711074829102, -1.38703248578309, 218, 48, 'PPL', 'P'),
(89392, 'New Hope', 36.0177803039551, 0.62862885556398, -87.1597213745117, -1.52122411310611, 218, 50, 'PPL', 'P'),
(96509, 'New Hope', 32.6563911437988, 0.569961547278407, -95.4180603027344, -1.66535931814921, 218, 51, 'PPL', 'P'),
(104620, 'New Hope', 38.8477783203125, 0.678021638774326, -77.2341690063477, -1.34799054420252, 218, 53, 'PPL', 'P'),
(110633, 'New Hope', 39.5966682434082, 0.691092233667353, -78.1741714477539, -1.36439668178185, 218, 58, 'PPL', 'P'),
(137077, 'New Hope', 45.0380592346191, 0.786062422352341, -93.3863906860352, -1.62989999402508, 218, 28, 'PPL', 'P'),
(151024, 'New Hope', 42.7980613708496, 0.746967084391924, -76.3475036621094, -1.33251531458224, 218, 40, 'PPL', 'P'),
(165137, 'New Hope', 40.3641700744629, 0.704487667634342, -74.9516677856445, -1.30815338272046, 218, 45, 'PPL', 'P'),
(175522, 'New Hope', 44.5036087036133, 0.776734500897257, -89.2636108398438, -1.55794391137417, 218, 57, 'PPL', 'P'),
(178711, 'New Hope', 33.6305618286133, 0.586964033204827, -113.766937255859, -1.98560763502455, 218, 5, 'PPL', 'P'),
(183604, 'New Hope', 38.226390838623, 0.667176381288169, -121.422782897949, -2.11922734850348, 218, 6, 'PPL', 'P'),
(201298, 'New Hope', 42.3624992370605, 0.739365091060292, -123.366668701172, -2.15315455605249, 218, 43, 'PPL', 'P'),
(10773, 'New Hope (historical)', 34.1827812194824, 0.596602079768851, -90.9216690063477, -1.58688248556925, 218, 4, 'PPL', 'P'),
(28033, 'New Hope (historical)', 38.4155616760254, 0.670478035249594, -87.9583282470703, -1.53516243246131, 218, 18, 'PPL', 'P'),
(42261, 'New Hope (historical)', 29.7063903808594, 0.518474321028768, -90.5583267211914, -1.58054096638155, 218, 22, 'PPL', 'P'),
(61051, 'New Hope (historical)', 32.9847183227539, 0.575691937574957, -89.7541732788086, -1.56650584112072, 218, 30, 'PPL', 'P'),
(67163, 'New Hope (historical)', 35.9427795410156, 0.627319845309179, -81.0061111450195, -1.41382335371706, 218, 33, 'PPL', 'P'),
(89393, 'New Hope (historical)', 35.9583282470703, 0.627591221424258, -88.6986083984375, -1.54808275848983, 218, 50, 'PPL', 'P'),
(189104, 'New Hope (historical)', 33.776668548584, 0.589514076527605, -103.374717712402, -1.80422918740112, 218, 38, 'PPL', 'P'),
(104621, 'New Hope Forest', 38.8763885498047, 0.678520981478715, -77.6558303833008, -1.35534992355885, 218, 53, 'PPL', 'P'),
(61052, 'New Hope Grove', 32.4236106872559, 0.565898761877436, -90.1861114501953, -1.57404458437647, 218, 30, 'PPL', 'P'),
(183605, 'New Hope Landing', 38.2280616760254, 0.667205542902105, -121.489723205566, -2.12039567727369, 218, 6, 'PPL', 'P'),
(178712, 'New Hope Trailer Park', 33.4127807617188, 0.583163036539011, -111.702499389648, -1.94957639705632, 218, 5, 'PPL', 'P'),
(89395, 'New Hopewell', 35.9283294677734, 0.627067643953948, -83.8005599975586, -1.46259568697245, 218, 50, 'PPL', 'P'),
(49779, 'New Horizons', 39.4427795410156, 0.68840636912898, -77.0997161865234, -1.345643899808, 218, 25, 'PPL', 'P'),
(178713, 'New Horizons', 33.3580589294434, 0.582207960393081, -111.849166870117, -1.95213622749611, 218, 5, 'PPL', 'P'),
(137079, 'New Horizons Mobile Home Park', 43.670280456543, 0.762190179236007, -92.0830612182617, -1.60715260357417, 218, 28, 'PPL', 'P'),
(189105, 'New Horse Springs', 33.9249992370605, 0.592102935423271, -108.1875, -1.88822808450137, 218, 38, 'PPL', 'P'),
(67172, 'New House', 35.3927803039551, 0.617720547739016, -81.6919403076172, -1.42579333071059, 218, 33, 'PPL', 'P'),
(198660, 'New Hradec', 46.999439239502, 0.820294961320329, -102.883888244629, -1.79566259712266, 218, 34, 'PPL', 'P'),
(132268, 'New Hudson', 42.5108299255371, 0.741953949955958, -83.6155624389648, -1.45936687046684, 218, 27, 'PPL', 'P'),
(151026, 'New Hurley', 41.6380615234375, 0.72672126773195, -74.144172668457, -1.29405993423177, 218, 40, 'PPL', 'P'),
(151027, 'New Hyde Park', 40.7350006103516, 0.710959881452535, -73.6883316040039, -1.28610400679126, 218, 40, 'PPL', 'P'),
(42262, 'New Iberia', 30.0033302307129, 0.52365689908909, -91.8186111450195, -1.60253707908895, 218, 22, 'PPL', 'P'),
(201299, 'New Idanha', 44.6977806091309, 0.78012343996341, -122.072776794434, -2.130571882115, 218, 43, 'PPL', 'P'),
(212028, 'New Igloo', 65.1275024414063, 1.13668935120318, -165.168334960938, -2.88273126510522, 218, 1, 'PPL', 'P'),
(144192, 'New Ipswich', 42.7480583190918, 0.746094366502705, -71.8547210693359, -1.25410146576205, 218, 36, 'PPL', 'P'),
(144193, 'New Ipswich Center', 42.7580604553223, 0.746268936712159, -71.8522186279297, -1.25405778992018, 218, 36, 'PPL', 'P'),
(61054, 'New Ireland', 32.5638885498047, 0.568347072446573, -89.1769409179688, -1.55643123587501, 218, 30, 'PPL', 'P'),
(151028, 'New Ireland', 42.1786117553711, 0.736155649051611, -75.9544372558594, -1.32565501161419, 218, 40, 'PPL', 'P'),
(165139, 'New Ireland', 41.8797187805176, 0.730938982529336, -79.9277801513672, -1.39500292745153, 218, 45, 'PPL', 'P'),
(71164, 'New Italy', 39.4597206115723, 0.688702046589006, -74.9372177124023, -1.30790118136523, 218, 37, 'PPL', 'P'),
(4544, 'New Jagger', 33.8152809143066, 0.590187989441449, -87.3569412231445, -1.52466624881503, 218, 2, 'PPL', 'P'),
(73655, 'New Jasper', 39.6541709899902, 0.692095845924149, -83.8194427490234, -1.46292525315735, 218, 41, 'PPL', 'P'),
(209635, 'New Jelm', 41.0819396972656, 0.717015110823048, -106.009437561035, -1.85021372362741, 218, 59, 'PPL', 'P'),
(10776, 'New Jenny Lind', 35.2508316040039, 0.615243075555942, -94.3172225952148, -1.64614607562289, 218, 4, 'PPL', 'P'),
(145881, 'New Jersey', 40.1669387817383, 0.701045332188333, -74.5002822875977, -1.30027521958379, 218, 37, 'ADM1', 'A'),
(156723, 'New Jerusalem', 40.3738899230957, 0.70465731099578, -83.6575012207031, -1.46009884029244, 218, 41, 'PPL', 'P'),
(165140, 'New Jerusalem', 40.4480590820313, 0.70595180702264, -75.7474975585938, -1.32204323254383, 218, 45, 'PPL', 'P'),
(156724, 'New Jerusalem (historical)', 41.6388893127441, 0.726735715380864, -83.3027801513672, -1.45390778970634, 218, 41, 'PPL', 'P'),
(89394, 'New Johnsonville', 36.021110534668, 0.628686979054771, -87.9669418334961, -1.53531276790484, 218, 50, 'PPL', 'P'),
(208232, 'New Kamilche', 47.1119384765625, 0.822258443413017, -123.084442138672, -2.14822877330028, 218, 56, 'PPL', 'P'),
(96510, 'New Katy', 30.3469390869141, 0.529654004968812, -97.5247192382813, -1.70212745279106, 218, 51, 'PPL', 'P'),
(165141, 'New Kensington', 40.5697212219238, 0.708075211938788, -79.7649993896484, -1.39216186720063, 218, 45, 'PPL', 'P'),
(112615, 'New Kent', 37.5175018310547, 0.654803934074906, -76.9791717529297, -1.34354000254684, 218, 53, 'PPL', 'P'),
(151029, 'New Kingston', 42.2136116027832, 0.736766511626648, -74.682502746582, -1.30345556655756, 218, 40, 'PPL', 'P'),
(165143, 'New Kingstown', 40.2330589294434, 0.702199346467692, -77.0800018310547, -1.34529981939516, 218, 45, 'PPL', 'P'),
(56499, 'New Kirk', 37.2874984741211, 0.650789618205775, -93.8300018310547, -1.63764246910421, 218, 29, 'PPL', 'P'),
(212025, 'New Knockhock', 62.127498626709, 1.08432940706433, -164.888336181641, -2.87784436450492, 218, 1, 'PPL', 'P'),
(156725, 'New Knoxville', 40.4936103820801, 0.706746827187056, -84.3147201538086, -1.47156947458158, 218, 41, 'PPL', 'P'),
(23346, 'New Lacy', 31.5391693115234, 0.550462347830037, -82.3716735839844, -1.43765691441857, 218, 13, 'PPL', 'P'),
(189106, 'New Laguna', 35.040828704834, 0.611577833526693, -107.42138671875, -1.8748568853003, 218, 38, 'PPL', 'P'),
(33415, 'New Lancaster', 38.4625015258789, 0.67129729017993, -94.732780456543, -1.65339892853561, 218, 20, 'PPL', 'P'),
(123282, 'New Lancaster', 40.2550010681152, 0.702582309032445, -85.879997253418, -1.49888871367583, 218, 19, 'PPL', 'P'),
(165144, 'New Lancaster', 40.0752792358398, 0.699445571321522, -77.4175033569336, -1.35119033225225, 218, 45, 'PPL', 'P'),
(120761, 'New Lancaster (historical)', 40.7550010681152, 0.711308955292417, -90.730827331543, -1.58355166999389, 218, 18, 'PPL', 'P'),
(42263, 'New Landgrove Landing', 32.9324989318848, 0.574780537270905, -91.7247161865234, -1.60089830291217, 218, 22, 'PPL', 'P'),
(82579, 'New Landing', 32.5127792358398, 0.567455046639451, -81.2305603027344, -1.41774073052252, 218, 48, 'PPL', 'P'),
(67173, 'New Lands', 35.8402786254883, 0.625530866846918, -76.2766723632813, -1.33127907520422, 218, 33, 'PPL', 'P'),
(89396, 'New Las Casas (historical)', 35.9527816772461, 0.627494415518634, -86.2805633544922, -1.50587991101145, 218, 50, 'PPL', 'P'),
(89397, 'New Lawton', 35.2044410705566, 0.614433408005531, -88.4702835083008, -1.54409773739269, 218, 50, 'PPL', 'P'),
(30637, 'New Lebanon', 39.040828704834, 0.681391003606466, -87.4711074829102, -1.52665882594263, 218, 19, 'PPL', 'P'),
(56500, 'New Lebanon', 38.7638893127441, 0.676557499386027, -92.9391708374023, -1.62209453518617, 218, 29, 'PPL', 'P'),
(73657, 'New Lebanon', 39.7452812194824, 0.693686019411035, -84.3850021362305, -1.47279612657967, 218, 41, 'PPL', 'P'),
(120762, 'New Lebanon', 42.0988883972168, 0.734764213961072, -88.6030578613281, -1.54641508701522, 218, 18, 'PPL', 'P'),
(151041, 'New Lebanon', 42.4638900756836, 0.741134695025623, -73.3969421386719, -1.28101830121559, 218, 40, 'PPL', 'P'),
(165194, 'New Lebanon', 41.4147186279297, 0.722823198844401, -80.0749969482422, -1.39757234527124, 218, 45, 'PPL', 'P'),
(151031, 'New Lebanon Center', 42.4705581665039, 0.741251075165259, -73.4225006103516, -1.28146438069818, 218, 40, 'PPL', 'P'),
(198661, 'New Leipzig', 46.3761100769043, 0.809415815109301, -101.939437866211, -1.77917882839756, 218, 34, 'PPL', 'P'),
(120763, 'New Lenox', 41.5119400024414, 0.724520031932945, -87.9655609130859, -1.53528866629698, 218, 18, 'PPL', 'P'),
(125540, 'New Lenox', 42.3944396972656, 0.739922557255473, -73.2430572509766, -1.27833250325625, 218, 23, 'PPL', 'P'),
(4545, 'New Lexington', 33.5622215270996, 0.585771269931607, -87.6575012207031, -1.52991201037222, 218, 2, 'PPL', 'P'),
(73659, 'New Lexington', 39.7599983215332, 0.693942881298173, -84.5338897705078, -1.47539470601332, 218, 41, 'PPL', 'P'),
(78822, 'New Lexington', 39.9372215270996, 0.697036009746246, -79.2369384765625, -1.3829454656162, 218, 45, 'PPL', 'P'),
(4546, 'New Liberty', 33.9355583190918, 0.592287226170704, -85.8208312988281, -1.49785607296315, 218, 2, 'PPL', 'P'),
(10777, 'New Liberty', 36.1313896179199, 0.630611712153599, -91.8663864135742, -1.60337091482626, 218, 4, 'PPL', 'P'),
(23347, 'New Liberty', 34.9694404602051, 0.6103318736107, -85.1572189331055, -1.48627385222434, 218, 13, 'PPL', 'P'),
(28034, 'New Liberty', 37.121940612793, 0.647900088423039, -88.4477767944336, -1.5437049211319, 218, 18, 'PPL', 'P'),
(30638, 'New Liberty', 38.5680618286133, 0.673139665022047, -85.8672180175781, -1.49866567393454, 218, 19, 'PPL', 'P'),
(37402, 'New Liberty', 38.6158294677734, 0.673973367601296, -84.9066696166992, -1.48190094171443, 218, 21, 'PPL', 'P'),
(56501, 'New Liberty', 36.8644409179688, 0.643405870925476, -91.2805633544922, -1.59314637361117, 218, 29, 'PPL', 'P'),
(61055, 'New Liberty', 33.8913917541504, 0.591516374193181, -89.2361068725586, -1.55746387658769, 218, 30, 'PPL', 'P'),
(76698, 'New Liberty', 35.3636093139648, 0.61721141791762, -99.7172164916992, -1.74039374870414, 218, 42, 'PPL', 'P'),
(112598, 'New Liberty', 33.1716690063477, 0.578954842542522, -94.2569427490234, -1.64509399383425, 218, 51, 'PPL', 'P'),
(113013, 'New Liberty', 41.7177810668945, 0.728112636243462, -90.8788909912109, -1.58613586835764, 218, 16, 'PPL', 'P'),
(165147, 'New Liberty', 40.8772201538086, 0.713442080746543, -78.2508316040039, -1.3657346539135, 218, 45, 'PPL', 'P'),
(67174, 'New Life', 34.1305618286133, 0.595690679464798, -78.8411102294922, -1.37603695943242, 218, 33, 'PPL', 'P'),
(583, 'New Light', 32.2611083984375, 0.563062561895529, -91.7836074829102, -1.60192614993489, 218, 22, 'PPL', 'P'),
(67175, 'New Light', 36.0127792358398, 0.628541570459253, -78.5975036621094, -1.37178522275211, 218, 33, 'PPL', 'P'),
(82580, 'New Light', 34.589168548584, 0.603694876700059, -82.8030624389648, -1.44518607029438, 218, 48, 'PPL', 'P'),
(104623, 'New Light', 36.8008308410645, 0.642295665646049, -76.182502746582, -1.32963550533748, 218, 53, 'PPL', 'P'),
(76699, 'New Lima', 35.1716690063477, 0.613861427582409, -96.5922164916992, -1.68585220957932, 218, 42, 'PPL', 'P'),
(128238, 'New Limerick', 46.1011085510254, 0.804616133034705, -67.960563659668, -1.18613559737241, 218, 26, 'PPL', 'P'),
(71165, 'New Lisbon', 39.9580612182617, 0.697399730972123, -74.6283264160156, -1.30251001121253, 218, 37, 'PPL', 'P'),
(123283, 'New Lisbon', 40.2436103820801, 0.702383504057071, -84.8244400024414, -1.48046576420299, 218, 19, 'PPL', 'P'),
(151033, 'New Lisbon', 42.5877799987793, 0.743296982093685, -75.184440612793, -1.31221603496338, 218, 40, 'PPL', 'P'),
(175524, 'New Lisbon', 43.8791694641113, 0.765835980189299, -90.165283203125, -1.57368106288767, 218, 57, 'PPL', 'P'),
(42264, 'New Llano', 31.1147193908691, 0.543054299204791, -93.2713928222656, -1.62789290266954, 218, 22, 'PPL', 'P'),
(191934, 'New Loco', 34.7483291625977, 0.606472753454093, -100.205833435059, -1.74892172314679, 218, 51, 'PPL', 'P'),
(23348, 'New Lois', 31.0849990844727, 0.542535582003471, -83.2683334350586, -1.45330658109025, 218, 13, 'PPL', 'P'),
(4547, 'New London', 33.4816703796387, 0.584365387192155, -86.3594436645508, -1.50725663213697, 218, 2, 'PPL', 'P'),
(10778, 'New London', 33.1883316040039, 0.579245659733559, -92.3391723632813, -1.61162258630581, 218, 4, 'PPL', 'P'),
(49780, 'New London', 39.4219398498535, 0.688042647903103, -77.2533264160156, -1.34832490407738, 218, 25, 'PPL', 'P'),
(56503, 'New London', 39.5852813720703, 0.690893495271005, -91.4008331298828, -1.59524547718237, 218, 29, 'PPL', 'P'),
(67177, 'New London', 35.4430618286133, 0.618598125897224, -80.2194366455078, -1.40009329355911, 218, 33, 'PPL', 'P'),
(96511, 'New London', 32.2386093139648, 0.562669878792797, -94.9402770996094, -1.65702042814396, 218, 51, 'PPL', 'P'),
(104625, 'New London', 38.1386108398438, 0.665644331292073, -77.3180618286133, -1.34945475016985, 218, 53, 'PPL', 'P'),
(113785, 'New London', 41.3555603027344, 0.721790691289778, -72.0999984741211, -1.2583823640563, 218, 8, 'PPL', 'P'),
(117008, 'New London', 40.9269409179688, 0.714309871787745, -91.3994369506836, -1.59522110925839, 218, 16, 'PPL', 'P'),
(123284, 'New London', 40.4433288574219, 0.705869249028848, -86.2713928222656, -1.50571985502994, 218, 19, 'PPL', 'P'),
(137081, 'New London', 45.3011093139648, 0.790653512334556, -94.9438934326172, -1.65708354506179, 218, 28, 'PPL', 'P'),
(144195, 'New London', 43.413890838623, 0.757715336235374, -71.9855575561523, -1.25638499323874, 218, 36, 'PPL', 'P'),
(151035, 'New London', 43.2052803039551, 0.754074395551073, -75.5880584716797, -1.3192604955208, 218, 40, 'PPL', 'P'),
(156726, 'New London', 41.0849990844727, 0.717068507202904, -82.4000015258789, -1.43815133027494, 218, 41, 'PPL', 'P'),
(165148, 'New London', 40.7886085510254, 0.711895516522507, -78.4333267211914, -1.36891979457724, 218, 45, 'PPL', 'P'),
(175526, 'New London', 44.3927803039551, 0.774800180418505, -88.7397232055664, -1.54880034724555, 218, 57, 'PPL', 'P'),
(208233, 'New London', 47.0574989318848, 0.821308294115104, -123.925827026367, -2.16291370986708, 218, 56, 'PPL', 'P'),
(28035, 'New London (historical)', 38.1683311462402, 0.666163048493393, -88.4055633544922, -1.54296815761633, 218, 18, 'PPL', 'P'),
(132269, 'New Lothrop', 43.1166687011719, 0.752527831327036, -83.9700012207031, -1.46555299420493, 218, 27, 'PPL', 'P'),
(89398, 'New Loyston', 36.2269401550293, 0.632279383628206, -83.9227828979492, -1.4647288790056, 218, 50, 'PPL', 'P'),
(156728, 'New Lyme', 41.6047210693359, 0.726139367033768, -80.7811126708984, -1.40989638953169, 218, 41, 'PPL', 'P'),
(156729, 'New Lyme Station', 41.5902786254883, 0.725887298836592, -80.845832824707, -1.41102596930805, 218, 41, 'PPL', 'P'),
(191935, 'New Lynn', 33.2113914489746, 0.579648129953297, -101.665000915527, -1.774389000019, 218, 51, 'PPL', 'P'),
(73660, 'New Madison', 39.9677810668945, 0.697569374333562, -84.7091674804688, -1.47845387915749, 218, 41, 'PPL', 'P'),
(56504, 'New Madrid', 36.5863914489746, 0.638552992208106, -89.5277786254883, -1.56255450901137, 218, 29, 'PPL', 'P'),
(165149, 'New Mahoning', 40.7975006103516, 0.712050712235031, -75.8105621337891, -1.32314391702236, 218, 45, 'PPL', 'P'),
(177254, 'New Manchester', 40.5313911437988, 0.70740622587296, -80.5802764892578, -1.40639113690493, 218, 58, 'PPL', 'P'),
(76700, 'New Mannford', 36.1227798461914, 0.630461443289091, -96.3572235107422, -1.68175080834254, 218, 42, 'PPL', 'P'),
(73661, 'New Mansfield', 39.3238906860352, 0.686331367165645, -82.2200012207031, -1.43500973229503, 218, 41, 'PPL', 'P'),
(30640, 'New Marion', 39.0074996948242, 0.680809302645366, -85.35888671875, -1.48979361907905, 218, 19, 'PPL', 'P'),
(4548, 'New Market', 34.9099998474121, 0.609294439208059, -86.4277801513672, -1.50844932883116, 218, 2, 'PPL', 'P'),
(14295, 'New Market', 38.8072204589844, 0.677313770556582, -75.397216796875, -1.31592967994544, 218, 10, 'PPL', 'P'),
(30642, 'New Market', 39.9524993896484, 0.69730265875039, -86.92138671875, -1.51706438864146, 218, 19, 'PPL', 'P'),
(37403, 'New Market', 37.5016708374023, 0.65452763111181, -85.3108291625977, -1.48895485649373, 218, 21, 'PPL', 'P'),
(49781, 'New Market', 39.3824996948242, 0.687354287340345, -77.2697219848633, -1.34861106073651, 218, 25, 'PPL', 'P'),
(56507, 'New Market', 39.502498626709, 0.68944866380061, -94.7991714477539, -1.65455766992591, 218, 29, 'PPL', 'P'),
(67178, 'New Market', 35.8291702270508, 0.62533698871956, -79.8658294677734, -1.39392168404896, 218, 33, 'PPL', 'P'),
(73662, 'New Market', 39.1352806091309, 0.683039500321226, -83.6688919067383, -1.46029764526782, 218, 41, 'PPL', 'P'),
(82582, 'New Market', 34.1627807617188, 0.596253005928969, -82.1347198486328, -1.43352129156178, 218, 48, 'PPL', 'P'),
(89399, 'New Market', 36.103889465332, 0.630131743946139, -83.5527801513672, -1.45827111283632, 218, 50, 'PPL', 'P'),
(104627, 'New Market', 38.6477813720703, 0.674531033533559, -78.6716690063477, -1.37307965219994, 218, 53, 'PPL', 'P'),
(117010, 'New Market', 40.7311096191406, 0.710891970844737, -94.8994369506836, -1.6563076330782, 218, 16, 'PPL', 'P'),
(137085, 'New Market', 44.5730590820313, 0.777946638667407, -93.3533325195313, -1.62932302017491, 218, 28, 'PPL', 'P'),
(145882, 'New Market', 40.5741691589355, 0.708152843084564, -74.4527816772461, -1.29944617753645, 218, 37, 'PPL', 'P'),
(165150, 'New Market', 40.2230606079102, 0.702024842837264, -76.8525009155273, -1.34132917936791, 218, 45, 'PPL', 'P'),
(28036, 'New Market (historical)', 37.7916717529297, 0.65958910192156, -88.2383270263672, -1.5400493330616, 218, 18, 'PPL', 'P'),
(82583, 'New Market (historical)', 33.5333290100098, 0.585267000379201, -79.9974975585938, -1.39621972575359, 218, 48, 'PPL', 'P'),
(49782, 'New Market Farms', 39.3899993896484, 0.687485181707922, -77.2861099243164, -1.34889708423759, 218, 25, 'PPL', 'P'),
(49783, 'New Market View', 39.3519401550293, 0.686820922753029, -77.2541732788086, -1.34833968462143, 218, 25, 'PPL', 'P'),
(14296, 'New Market Village Mobile Home Park', 38.8097190856934, 0.677357379819432, -75.3874969482422, -1.315760036584, 218, 10, 'PPL', 'P'),
(49784, 'New Market West', 39.3886108398438, 0.687460946942002, -77.2808303833008, -1.34880493886387, 218, 25, 'PPL', 'P'),
(89400, 'New Markham', 36.4558296203613, 0.63627425842138, -89.4005584716797, -1.56033409845252, 218, 50, 'PPL', 'P'),
(125541, 'New Marlborough', 42.1227798461914, 0.735181198408751, -73.2291717529297, -1.27809015559705, 218, 23, 'PPL', 'P'),
(73664, 'New Marshfield', 39.3250007629395, 0.686350741662576, -82.2180633544922, -1.43497591014918, 218, 41, 'PPL', 'P'),
(73665, 'New Martinsburg', 39.396671295166, 0.687601628426586, -83.4638900756836, -1.4567196883433, 218, 41, 'PPL', 'P'),
(110635, 'New Martinsville', 39.6444396972656, 0.691926002825629, -80.857780456543, -1.4112344948214, 218, 58, 'PPL', 'P'),
(28037, 'New Massillon (historical)', 38.438060760498, 0.670870718352326, -88.1963882446289, -1.539317363236, 218, 18, 'PPL', 'P'),
(73666, 'New Matamoras', 39.5244407653809, 0.689831626365364, -81.0672225952148, -1.41488994973364, 218, 41, 'PPL', 'P'),
(30643, 'New Maysville', 39.7905616760254, 0.694476312464516, -86.7291717529297, -1.51370960461629, 218, 19, 'PPL', 'P'),
(195379, 'New Meadows', 44.9713897705078, 0.784898820693058, -116.283058166504, -2.02952222929357, 218, 17, 'PPL', 'P'),
(56508, 'New Melle', 38.7097206115723, 0.675612077199049, -90.8794403076172, -1.58614545573757, 218, 29, 'PPL', 'P'),
(28038, 'New Memphis', 38.4791717529297, 0.671588240529021, -89.6783294677734, -1.5651821169009, 218, 18, 'PPL', 'P'),
(28039, 'New Memphis Station', 38.4580612182617, 0.671219792192209, -89.6766662597656, -1.56515308844502, 218, 18, 'PPL', 'P'),
(96512, 'New Mesquite', 33.1166687011719, 0.577994906127603, -96.4333267211914, -1.68307905993622, 218, 51, 'PPL', 'P'),
(49785, 'New Mexico', 39.603328704834, 0.691208480648935, -76.9491729736328, -1.34301642507653, 218, 25, 'PPL', 'P'),
(189107, 'New Mexico', 34.5002784729004, 0.602143452207033, -106.000282287598, -1.85005393396201, 218, 38, 'ADM1', 'A'),
(73667, 'New Miami', 39.4347190856934, 0.688265687644397, -84.5369415283203, -1.47544796923512, 218, 41, 'PPL', 'P'),
(197139, 'New Miami Colony', 48.1919403076172, 0.841108031292489, -112.281387329102, -1.95967989759986, 218, 31, 'PPL', 'P'),
(120765, 'New Michigan (historical)', 41.0550003051758, 0.716544929732594, -88.7427825927734, -1.54885374362541, 218, 18, 'PPL', 'P'),
(89401, 'New Middleton', 36.1747207641602, 0.631367983324154, -86.0058288574219, -1.50108488946876, 218, 50, 'PPL', 'P'),
(156731, 'New Middleton', 40.8644409179688, 0.713219041005249, -80.915283203125, -1.41223810707819, 218, 41, 'PPL', 'P'),
(30644, 'New Middletown', 38.163890838623, 0.666085550505672, -86.0508270263672, -1.50187025567423, 218, 19, 'PPL', 'P'),
(156732, 'New Middletown', 40.961109161377, 0.714906220134841, -80.5577774047852, -1.40599845380219, 218, 41, 'PPL', 'P'),
(49786, 'New Midway', 39.5669403076172, 0.690573383307978, -77.2911071777344, -1.34898430276329, 218, 25, 'PPL', 'P'),
(89402, 'New Midway', 35.8405609130859, 0.625535793694935, -84.4186096191406, -1.47338268780976, 218, 50, 'PPL', 'P'),
(17261, 'New Mikasuki (historical)', 30.4833297729492, 0.532034471509179, -83.6500015258789, -1.45996794592487, 218, 12, 'PPL', 'P'),
(113788, 'New Milford', 41.5769386291504, 0.725654471978292, -73.4088897705078, -1.28122682672895, 218, 8, 'PPL', 'P'),
(120766, 'New Milford', 42.186939239502, 0.736300991068102, -89.0677795410156, -1.55452601043117, 218, 18, 'PPL', 'P'),
(145883, 'New Milford', 40.935001373291, 0.714450553272329, -74.0194396972656, -1.29188293319868, 218, 37, 'PPL', 'P'),
(151036, 'New Milford', 41.2344398498535, 0.7196767405955, -74.4141693115234, -1.29877226462261, 218, 40, 'PPL', 'P'),
(156734, 'New Milford', 41.1047210693359, 0.717412720773796, -81.2147216796875, -1.41746429440137, 218, 41, 'PPL', 'P'),
(165151, 'New Milford', 41.872501373291, 0.730813015009775, -75.7275009155273, -1.32169422528297, 218, 45, 'PPL', 'P'),
(165154, 'New Millport', 40.8936080932617, 0.713728104247617, -78.5388870239258, -1.37076216941936, 218, 45, 'PPL', 'P'),
(165155, 'New Milltown', 40.0208282470703, 0.698495222286528, -76.0591735839844, -1.32748300538642, 218, 45, 'PPL', 'P'),
(110637, 'New Milton', 39.2299995422363, 0.684692657567892, -80.6827774047852, -1.40818011536719, 218, 58, 'PPL', 'P'),
(28040, 'New Minden', 38.4413909912109, 0.670928841843117, -89.3702774047852, -1.55980559413419, 218, 18, 'PPL', 'P'),
(175529, 'New Miner', 44.1697196960449, 0.770907038378973, -90.0361099243164, -1.57142656386686, 218, 57, 'PPL', 'P'),
(165156, 'New Mines', 40.6752815246582, 0.709917586780905, -76.3277816772461, -1.33217110101134, 218, 45, 'PPL', 'P'),
(140571, 'New Minneapolis (historical)', 46.8938903808594, 0.818452786215294, -98.9236068725586, -1.72654264787464, 218, 34, 'PPL', 'P'),
(110638, 'New Moatsville (historical)', 39.2174987792969, 0.684474478095587, -79.9380569458008, -1.39518229135095, 218, 58, 'PPL', 'P'),
(191936, 'New Mobeetie', 35.5319404602051, 0.620149350653168, -100.441108703613, -1.75302805123159, 218, 51, 'PPL', 'P'),
(145885, 'New Monmouth', 40.4119415283203, 0.705321436792619, -74.1036071777344, -1.29335193285597, 218, 37, 'PPL', 'P'),
(183608, 'New Monterey', 36.6147193908691, 0.639047408064479, -121.901107788086, -2.1275756927306, 218, 6, 'PPL', 'P'),
(4549, 'New Moon', 34.3930587768555, 0.600272115488062, -85.5202789306641, -1.49261044456402, 218, 2, 'PPL', 'P'),
(10779, 'New Moon (historical)', 34.3291702270508, 0.599157049939645, -94.0416717529297, -1.64133680616837, 218, 4, 'PPL', 'P'),
(42265, 'New Moore', 31.8527793884277, 0.55593587623945, -92.5883331298828, -1.6159712620498, 218, 22, 'PPL', 'P'),
(191937, 'New Moore', 33.0219383239746, 0.576341549143855, -102.032218933105, -1.78079816349839, 218, 51, 'PPL', 'P'),
(73668, 'New Moorefield', 39.9919395446777, 0.697991019313148, -83.7172164916992, -1.46114106838505, 218, 41, 'PPL', 'P'),
(165158, 'New Morgan', 40.1808280944824, 0.701287746426557, -75.8905563354492, -1.32454007922383, 218, 45, 'PPL', 'P'),
(156735, 'New Moscow', 40.2105598449707, 0.701806663364959, -81.9719390869141, -1.43068023131088, 218, 41, 'PPL', 'P'),
(104628, 'New Mount Cross', 36.6477813720703, 0.639624448493672, -79.498893737793, -1.38751744741759, 218, 53, 'PPL', 'P'),
(4550, 'New Mount Hebron', 32.8569412231445, 0.573461806478125, -88.1011123657227, -1.53765448545135, 218, 2, 'PPL', 'P'),
(10780, 'New Mount Moriah (historical)', 33.6305618286133, 0.586964033204827, -93.3041687011719, -1.62846494967169, 218, 4, 'PPL', 'P'),
(123285, 'New Mount Pleasant', 40.3558311462402, 0.704342125880769, -85.0650024414063, -1.48466437081955, 218, 19, 'PPL', 'P'),
(104629, 'New Mount Vinco', 37.5863914489746, 0.656006284728049, -78.6013870239258, -1.37185300020185, 218, 53, 'PPL', 'P'),
(96513, 'New Mountain', 32.8286094665527, 0.572967324042725, -94.8102798461914, -1.65475154805326, 218, 51, 'PPL', 'P'),
(137088, 'New Munich', 45.6302795410156, 0.79639861659613, -94.7533264160156, -1.65375752317639, 218, 28, 'PPL', 'P'),
(175530, 'New Munster', 42.5794410705566, 0.743151440340113, -88.227783203125, -1.53986530863028, 218, 57, 'PPL', 'P'),
(10781, 'New Neely', 35.1158294677734, 0.612886843781494, -93.0811080932617, -1.62457180763216, 218, 4, 'PPL', 'P'),
(76701, 'New Oberlin', 33.894718170166, 0.591574431104945, -95.8511123657227, -1.67291750248091, 218, 42, 'PPL', 'P'),
(56509, 'New Offenburg', 37.9086112976074, 0.661630082001969, -90.1972198486328, -1.57423846250382, 218, 29, 'PPL', 'P'),
(151037, 'New Ohio', 42.2222213745117, 0.736916780491155, -75.7130584716797, -1.3214421570858, 218, 40, 'PPL', 'P'),
(151038, 'New Oregon', 42.5883293151855, 0.74330656947361, -78.7919387817383, -1.37517875577114, 218, 40, 'PPL', 'P'),
(42266, 'New Orleans', 29.954439163208, 0.522803588986315, -90.0749969482422, -1.57210527047067, 218, 22, 'PPL', 'P'),
(78825, 'New Oxford', 39.8636093139648, 0.695751234257365, -77.0561065673828, -1.34488276836846, 218, 45, 'PPL', 'P'),
(56510, 'New Oyer', 37.9530601501465, 0.66240586082751, -93.871940612793, -1.63837443892982, 218, 29, 'PPL', 'P'),
(28041, 'New Palestine', 37.9963912963867, 0.663162131998065, -89.820556640625, -1.56766444935296, 218, 18, 'PPL', 'P'),
(30645, 'New Palestine', 39.7219390869141, 0.69327862234328, -85.8891677856445, -1.49904876965734, 218, 19, 'PPL', 'P'),
(73669, 'New Palestine', 39.0086097717285, 0.680828677142296, -84.3050003051758, -1.47139983122014, 218, 41, 'PPL', 'P'),
(96514, 'New Palm Colonia', 26.1800003051758, 0.456927203498438, -98.109001159668, -1.71232509607914, 218, 51, 'PPL', 'P'),
(151039, 'New Paltz', 41.747501373291, 0.728631353444783, -74.0872192382813, -1.29306590935489, 218, 40, 'PPL', 'P'),
(73670, 'New Paris', 39.8569412231445, 0.695634854117728, -84.793327331543, -1.47992274565672, 218, 41, 'PPL', 'P'),
(123286, 'New Paris', 41.5002784729004, 0.724316499846636, -85.8280563354492, -1.49798217364077, 218, 19, 'PPL', 'P'),
(165159, 'New Paris', 40.1063919067383, 0.69998858986779, -78.6449966430664, -1.3726141316414, 218, 45, 'PPL', 'P'),
(175532, 'New Paris', 43.7330589294434, 0.763285870287493, -87.9719390869141, -1.53539998643054, 218, 57, 'PPL', 'P'),
(78827, 'New Park', 39.7347183227539, 0.693501662084575, -76.5058288574219, -1.3352786105293, 218, 45, 'PPL', 'P'),
(487, 'New Pekin', 38.5050010681152, 0.672039047122544, -86.0169372558594, -1.50127876759612, 218, 19, 'PPL', 'P'),
(30646, 'New Pennington', 39.2797203063965, 0.685560448609094, -85.3247222900391, -1.48919733731098, 218, 19, 'PPL', 'P'),
(73671, 'New Petersburg', 39.2622184753418, 0.685254984032062, -83.4449996948242, -1.45638998900035, 218, 41, 'PPL', 'P'),
(30647, 'New Philadelphia', 38.6263885498047, 0.67415765834873, -85.9700012207031, -1.50045957924481, 218, 19, 'PPL', 'P'),
(120768, 'New Philadelphia', 40.4894409179688, 0.70667405631027, -90.4722213745117, -1.57903814457842, 218, 18, 'PPL', 'P'),
(156736, 'New Philadelphia', 40.4897193908691, 0.706678916579259, -81.4458312988281, -1.4214979181884, 218, 41, 'PPL', 'P'),
(165161, 'New Philadelphia', 40.7194404602051, 0.710688305600374, -76.1161117553711, -1.32847676394719, 218, 45, 'PPL', 'P'),
(193814, 'New Pine Creek', 41.9927787780762, 0.73291225173903, -120.296112060547, -2.0995632328046, 218, 6, 'PPL', 'P'),
(201300, 'New Pine Creek', 41.9941711425781, 0.732936553083977, -120.296112060547, -2.0995632328046, 218, 43, 'PPL', 'P'),
(56511, 'New Piper', 38.357780456543, 0.669469562723809, -94.0136108398438, -1.6408470508439, 218, 29, 'PPL', 'P'),
(123287, 'New Pittsburg', 40.3074989318848, 0.703498569605487, -84.899169921875, -1.48177004734686, 218, 19, 'PPL', 'P'),
(156738, 'New Pittsburg', 40.839168548584, 0.712777954949704, -82.1002807617188, -1.43292021610375, 218, 41, 'PPL', 'P'),
(156739, 'New Pittsburgh', 40.9958305358887, 0.715512222440889, -82.7311096191406, -1.44393025668236, 218, 41, 'PPL', 'P'),
(73673, 'New Plymouth', 39.3847198486328, 0.687393036334205, -82.3963928222656, -1.43808834651516, 218, 41, 'PPL', 'P'),
(195380, 'New Plymouth', 43.9700012207031, 0.767421293407195, -116.818061828613, -2.03885980470761, 218, 17, 'PPL', 'P'),
(23349, 'New Point', 32.0547218322754, 0.559460436784115, -84.3024978637695, -1.47135615537826, 218, 13, 'PPL', 'P'),
(30648, 'New Point', 39.3097190856934, 0.686084026079404, -85.3291702270508, -1.48927496845675, 218, 19, 'PPL', 'P'),
(104630, 'New Point', 37.3455581665039, 0.65180295100055, -76.2780609130859, -1.33130330997014, 218, 53, 'PPL', 'P'),
(139358, 'New Point', 40.0547218322754, 0.699086776943662, -95.0788879394531, -1.65943964367818, 218, 29, 'PPL', 'P'),
(17262, 'New Point Comfort', 26.9305591583252, 0.470026926715888, -82.3411102294922, -1.43712348325222, 218, 12, 'PPL', 'P'),
(112396, 'New Port', 39.3633308410645, 0.687019727728403, -77.0688934326172, -1.3451059412678, 218, 25, 'PPL', 'P'),
(17263, 'New Port Richey', 28.2438907623291, 0.492948887376254, -82.7194366455078, -1.44372652485896, 218, 12, 'PPL', 'P'),
(156740, 'New Portage', 41.0283317565918, 0.716079475753076, -81.591667175293, -1.42404323440024, 218, 41, 'PPL', 'P'),
(128240, 'New Portland', 44.8841705322266, 0.783376557813969, -70.0972213745117, -1.22342730948457, 218, 26, 'PPL', 'P'),
(144197, 'New Portsmouth', 43.5050010681152, 0.759305509722261, -71.0541687011719, -1.24012919110295, 218, 36, 'PPL', 'P'),
(104631, 'New Post', 38.232780456543, 0.667287901158816, -77.4063873291016, -1.35099632096684, 218, 53, 'PPL', 'P'),
(175533, 'New Post', 45.8958282470703, 0.801033315841195, -91.1858291625977, -1.59149295004839, 218, 57, 'PPL', 'P'),
(137090, 'New Prague', 44.5433311462402, 0.777427788308032, -93.5758285522461, -1.63320630851841, 218, 28, 'PPL', 'P'),
(113790, 'New Preston', 41.6749992370605, 0.727365952452831, -73.3522186279297, -1.28023772870009, 218, 8, 'PPL', 'P'),
(156741, 'New Princeton', 40.3875007629395, 0.704894864965015, -82.061393737793, -1.43224150949994, 218, 41, 'PPL', 'P'),
(201301, 'New Princeton', 43.2830581665039, 0.755431875337713, -118.581672668457, -2.06964062058675, 218, 43, 'PPL', 'P'),
(4552, 'New Prospect', 32.8397216796875, 0.57316126874911, -87.7363891601563, -1.53128886465579, 218, 2, 'PPL', 'P'),
(67180, 'New Prospect', 35.3494415283203, 0.616964143410406, -81.4783325195313, -1.42206517150059, 218, 33, 'PPL', 'P'),
(82584, 'New Prospect', 35.1322212219238, 0.613172933861596, -82.0441665649414, -1.43194083861287, 218, 48, 'PPL', 'P'),
(89403, 'New Prospect', 35.2244415283203, 0.614782481845413, -87.251106262207, -1.52281908028296, 218, 50, 'PPL', 'P'),
(96515, 'New Prospect', 32.2013893127441, 0.562020267223899, -94.7344436645508, -1.65342795699149, 218, 51, 'PPL', 'P'),
(175534, 'New Prospect', 43.6158294677734, 0.761239830201012, -88.1786117553711, -1.539007104969, 218, 57, 'PPL', 'P'),
(89404, 'New Prospect (historical)', 36.4019393920898, 0.635333696503391, -83.8433303833008, -1.463342171026, 218, 50, 'PPL', 'P'),
(82585, 'New Prospect Estates', 34.5111083984375, 0.602332470065401, -82.728889465332, -1.4438915076885, 218, 48, 'PPL', 'P'),
(4553, 'New Providence', 33.0188903808594, 0.576288352501081, -85.9852828979492, -1.50072629482799, 218, 2, 'PPL', 'P'),
(37404, 'New Providence', 36.5288887023926, 0.63754937995131, -88.2369384765625, -1.54002509829569, 218, 21, 'PPL', 'P'),
(61056, 'New Providence', 32.3574981689453, 0.564744880756132, -88.9205627441406, -1.55195659261146, 218, 30, 'PPL', 'P'),
(67181, 'New Providence', 36.4130592346191, 0.63552777436783, -76.0938873291016, -1.32808887453442, 218, 33, 'PPL', 'P'),
(78828, 'New Providence', 39.9252815246582, 0.696827617390947, -76.1983337402344, -1.32991180830058, 218, 45, 'PPL', 'P'),
(89406, 'New Providence', 36.5486106872559, 0.637893593522202, -87.3791732788086, -1.52505427138586, 218, 50, 'PPL', 'P'),
(117012, 'New Providence', 42.2811088562012, 0.737944560934844, -93.17138671875, -1.6261474668911, 218, 16, 'PPL', 'P'),
(145886, 'New Providence', 40.6983299255371, 0.710319857263561, -74.4019393920898, -1.29855881226124, 218, 37, 'PPL', 'P'),
(76702, 'New Prue', 36.253059387207, 0.632735250227801, -96.2705612182617, -1.68023826600143, 218, 42, 'PPL', 'P'),
(42268, 'New Quarters', 32.1536102294922, 0.561186364907568, -91.4252777099609, -1.595672115589, 218, 22, 'PPL', 'P'),
(42269, 'New Ramah', 32.1586112976074, 0.561273650012296, -93.1172180175781, -1.62520204470413, 218, 22, 'PPL', 'P'),
(194341, 'New Raymer', 40.6066703796387, 0.708720096396751, -103.843330383301, -1.81240802142486, 218, 7, 'PPL', 'P'),
(73674, 'New Reading', 39.8091697692871, 0.694801084959451, -82.3499984741211, -1.43727861238572, 218, 41, 'PPL', 'P'),
(208235, 'New Reliance', 46.8102798461914, 0.816993507095985, -122.264999389648, -2.13392679929822, 218, 56, 'PPL', 'P'),
(190541, 'New Reveille (historical)', 38.0044403076172, 0.663302613745567, -116.188056945801, -2.02786414519889, 218, 39, 'PPL', 'P'),
(137093, 'New Richland', 43.8938903808594, 0.766092908655464, -93.4936065673828, -1.63177126416502, 218, 28, 'PPL', 'P'),
(156742, 'New Richland', 40.4858283996582, 0.706611005971462, -83.7733306884766, -1.46212044587592, 218, 41, 'PPL', 'P'),
(177, 'New Richmond', 37.5699996948242, 0.655720194647947, -81.4888916015625, -1.42224946224802, 218, 58, 'PPL', 'P'),
(73675, 'New Richmond', 38.9486083984375, 0.67978145562265, -84.2799987792969, -1.47096347227553, 218, 41, 'PPL', 'P'),
(123288, 'New Richmond', 40.1955604553223, 0.701544874629805, -86.978889465332, -1.51806800089825, 218, 19, 'PPL', 'P'),
(132270, 'New Richmond', 42.6477813720703, 0.744344203613332, -86.1055603027344, -1.50282553155724, 218, 27, 'PPL', 'P'),
(165163, 'New Richmond', 41.7213897705078, 0.728175620003243, -79.9513931274414, -1.39541505163022, 218, 45, 'PPL', 'P'),
(175535, 'New Richmond', 45.1230583190918, 0.78754593623757, -92.5363922119141, -1.61506472201474, 218, 57, 'PPL', 'P'),
(82586, 'New Richmond (historical)', 33.5352783203125, 0.585301022262127, -82.0138931274414, -1.4314124674526, 218, 48, 'PPL', 'P'),
(110639, 'New Richmond (historical)', 37.7794418334961, 0.65937564956019, -80.8938903808594, -1.41186473189337, 218, 58, 'PPL', 'P'),
(156743, 'New Riegel', 41.0513916015625, 0.716481945972814, -83.3186111450195, -1.45418409266943, 218, 41, 'PPL', 'P'),
(165164, 'New Ringgold', 40.6858291625977, 0.710101677791256, -75.9994430541992, -1.32644051097771, 218, 45, 'PPL', 'P'),
(17264, 'New River', 29.9608306884766, 0.522915142146476, -82.2655563354492, -1.43580481903847, 218, 12, 'PPL', 'P'),
(89407, 'New River', 36.3824996948242, 0.634994409780515, -84.5486068725586, -1.47565156790045, 218, 50, 'PPL', 'P'),
(104632, 'New River', 37.1333312988281, 0.648098893398413, -80.591667175293, -1.4065899418803, 218, 53, 'PPL', 'P'),
(178716, 'New River', 33.915828704834, 0.591942879441757, -112.135276794434, -1.95712978769806, 218, 5, 'PPL', 'P'),
(67182, 'New River Heights', 36.2174987792969, 0.632114600535758, -81.6402816772461, -1.42489171752354, 218, 33, 'PPL', 'P'),
(49788, 'New Road Landing', 38.2625007629395, 0.667806618360136, -75.8202819824219, -1.3233135603838, 218, 25, 'PPL', 'P'),
(42271, 'New Roads', 30.7013893127441, 0.535840328443984, -91.4361114501953, -1.5958612000264, 218, 22, 'PPL', 'P'),
(151042, 'New Rochelle', 40.9113883972168, 0.714038429093639, -73.7827835083008, -1.28775250350602, 218, 40, 'PPL', 'P'),
(156745, 'New Rochester', 41.3624992370605, 0.721911798540349, -83.5074996948242, -1.45748081978284, 218, 41, 'PPL', 'P'),
(23350, 'New Rock Hill', 31.0011100769043, 0.541071442615172, -83.5744400024414, -1.45864914855306, 218, 13, 'PPL', 'P'),
(42272, 'New Rockdale', 32.0499992370605, 0.559378011948377, -93.6361083984375, -1.63425839030705, 218, 22, 'PPL', 'P'),
(140572, 'New Rockford', 47.6800003051758, 0.832172992677219, -99.1374969482422, -1.73027573393266, 218, 34, 'PPL', 'P'),
(197140, 'New Rockport Colony', 47.8636093139648, 0.835377574416911, -112.02278137207, -1.9551663721844, 218, 31, 'PPL', 'P'),
(37405, 'New Roe', 36.665828704834, 0.639939433871601, -86.3824996948242, -1.50765903577768, 218, 21, 'PPL', 'P'),
(23351, 'New Rome', 34.2172203063965, 0.597203155226882, -85.1752777099609, -1.48658903733935, 218, 13, 'PPL', 'P'),
(73676, 'New Rome', 39.9516716003418, 0.697288211101476, -83.142219543457, -1.4511054784493, 218, 41, 'PPL', 'P'),
(137096, 'New Rome', 44.5433311462402, 0.777427788308032, -94.0922164916992, -1.64221897827946, 218, 28, 'PPL', 'P'),
(175537, 'New Rome', 44.2194404602051, 0.771774829420175, -89.8808288574219, -1.56871639798354, 218, 57, 'PPL', 'P'),
(175538, 'New Rome (historical)', 44.2422218322754, 0.772172439370924, -89.8625030517578, -1.56839655233663, 218, 57, 'PPL', 'P'),
(30649, 'New Ross', 39.9647216796875, 0.697515977953705, -86.7144393920898, -1.51345247641304, 218, 19, 'PPL', 'P'),
(156746, 'New Rumley', 40.401668548584, 0.705142139472229, -81.0311126708984, -1.41425971266167, 218, 41, 'PPL', 'P'),
(17272, 'New Run', 29.3836097717285, 0.512840736637842, -81.3847198486328, -1.42043132217182, 218, 12, 'PPL', 'P'),
(151044, 'New Russia', 44.163330078125, 0.770795518508326, -73.6119384765625, -1.28477069519151, 218, 40, 'PPL', 'P'),
(144199, 'New Rye', 43.1838912963867, 0.753701086945271, -71.3638916015625, -1.24553487548359, 218, 36, 'PPL', 'P'),
(89408, 'New Safford', 35.728889465332, 0.62358675925116, -88.2041702270508, -1.53945318445159, 218, 50, 'PPL', 'P'),
(10784, 'New Salem', 35.2847213745117, 0.615834563634049, -91.2872161865234, -1.5932624874347, 218, 4, 'PPL', 'P'),
(28043, 'New Salem', 39.7075004577637, 0.693026620725132, -90.8475036621094, -1.58558805612141, 218, 18, 'PPL', 'P'),
(30651, 'New Salem', 38.6213912963867, 0.674070439823029, -85.904167175293, -1.4993105583925, 218, 19, 'PPL', 'P'),
(33416, 'New Salem', 37.3105583190918, 0.651192088425513, -96.8949966430664, -1.69113672013036, 218, 20, 'PPL', 'P'),
(37407, 'New Salem', 37.4091682434082, 0.652913156279977, -84.7675018310547, -1.47947200564223, 218, 21, 'PPL', 'P'),
(61057, 'New Salem', 34.1394386291504, 0.595845608861214, -88.3586120605469, -1.54214870294891, 218, 30, 'PPL', 'P'),
(67184, 'New Salem', 35.1308288574219, 0.613148632516649, -80.3694381713867, -1.40271131406871, 218, 33, 'PPL', 'P'),
(73677, 'New Salem', 39.8477783203125, 0.695474931294269, -82.4725036621094, -1.43941673126689, 218, 41, 'PPL', 'P'),
(82587, 'New Salem', 34.5538902282715, 0.603079153856032, -82.7263870239258, -1.44384783184662, 218, 48, 'PPL', 'P'),
(89410, 'New Salem', 36.3138885498047, 0.633796919396361, -85.6697235107422, -1.49521874453565, 218, 50, 'PPL', 'P'),
(112599, 'New Salem', 31.9413890838623, 0.557482407173972, -94.9594421386719, -1.65735492117687, 218, 51, 'PPL', 'P'),
(125543, 'New Salem', 42.5041694641113, 0.741837702974376, -72.3324966430664, -1.26244022260925, 218, 23, 'PPL', 'P'),
(132271, 'New Salem', 42.7538909912109, 0.746196165835373, -85.8019409179688, -1.4975263736202, 218, 27, 'PPL', 'P'),
(151046, 'New Salem', 41.8952789306641, 0.731210558381497, -74.0163879394531, -1.29182966997688, 218, 40, 'PPL', 'P'),
(165166, 'New Salem', 40.9880599975586, 0.715376600962376, -79.2444381713867, -1.38307635998377, 218, 45, 'PPL', 'P'),
(198664, 'New Salem', 46.8450012207031, 0.817599509402032, -101.410827636719, -1.7699528394332, 218, 34, 'PPL', 'P'),
(28044, 'New Salem (historical)', 39.978889465332, 0.697763252460919, -89.8438873291016, -1.56807164668364, 218, 18, 'PPL', 'P'),
(73678, 'New Salem (historical)', 39.3283309936523, 0.686408865153367, -83.3583297729492, -1.45487731350118, 218, 41, 'PPL', 'P'),
(30652, 'New Salisbury', 38.3136100769043, 0.668698644167258, -86.0950012207031, -1.50264124080981, 218, 19, 'PPL', 'P'),
(156748, 'New Salisbury', 40.5930595397949, 0.708482542427516, -80.7363891601563, -1.40911581701619, 218, 41, 'PPL', 'P'),
(56512, 'New Santa Fe', 38.9066696166992, 0.679049485797042, -94.6044387817383, -1.65115894374275, 218, 29, 'PPL', 'P'),
(123289, 'New Santa Fe', 40.6736106872559, 0.709888425166968, -85.9877777099609, -1.50076983751181, 218, 19, 'PPL', 'P'),
(42273, 'New Sarpy', 29.9777793884277, 0.523210952764556, -90.3877792358398, -1.57756435123117, 218, 22, 'PPL', 'P'),
(151047, 'New Scotland', 42.6286087036133, 0.744009577422363, -73.9138870239258, -1.29004069151462, 218, 40, 'PPL', 'P'),
(151049, 'New Scriba', 43.6063919067383, 0.761075113687591, -75.9311065673828, -1.32524781428352, 218, 40, 'PPL', 'P'),
(125545, 'New Seabury', 41.5713882446289, 0.72555759949364, -70.475830078125, -1.23003527793933, 218, 23, 'PPL', 'P'),
(10785, 'New Shady Grove', 35.1319389343262, 0.61316800701358, -90.4447174072266, -1.57855810979193, 218, 4, 'PPL', 'P'),
(165168, 'New Shaefferstown', 40.4533309936523, 0.706043819238303, -76.1677780151367, -1.32937851029229, 218, 45, 'PPL', 'P'),
(4554, 'New Sharon', 34.9472198486328, 0.609944050776957, -86.6416702270508, -1.51218241488918, 218, 2, 'PPL', 'P'),
(117013, 'New Sharon', 41.4700012207031, 0.723788062107337, -92.6511077880859, -1.61706688652226, 218, 16, 'PPL', 'P'),
(128242, 'New Sharon', 44.6388893127441, 0.779095592940694, -70.01611328125, -1.22201170620714, 218, 26, 'PPL', 'P'),
(145888, 'New Sharon', 40.2061080932617, 0.701728965640156, -74.5508270263672, -1.30115739169488, 218, 37, 'PPL', 'P'),
(165169, 'New Sheffield', 40.5988883972168, 0.708584275181157, -80.2802810668945, -1.40115522904378, 218, 45, 'PPL', 'P'),
(89411, 'New Shiloh', 35.8680610656738, 0.626015761902394, -88.8919372558594, -1.55145698359096, 218, 50, 'PPL', 'P'),
(169507, 'New Shoreham', 41.1722183227539, 0.718590770081993, -71.5583267211914, -1.24892840850263, 218, 47, 'PPL', 'P'),
(169508, 'New Shoreham Center', 41.1713905334473, 0.718576322433079, -71.5777816772461, -1.24926796154161, 218, 47, 'PPL', 'P'),
(61058, 'New Sight', 31.6541690826416, 0.552469472475089, -90.4483337402344, -1.57862122670977, 218, 30, 'PPL', 'P'),
(165170, 'New Silver Brook', 40.8838882446289, 0.713558460886179, -75.9669418334961, -1.32587325766552, 218, 45, 'PPL', 'P'),
(4555, 'New Site', 33.0372200012207, 0.576608264727026, -85.774169921875, -1.49704167830181, 218, 2, 'PPL', 'P'),
(61059, 'New Site', 34.5591697692871, 0.603171299229749, -88.4094390869141, -1.54303580190802, 218, 30, 'PPL', 'P'),
(165171, 'New Smithville', 40.579719543457, 0.708249715569215, -75.7286071777344, -1.32171353320088, 218, 45, 'PPL', 'P'),
(17265, 'New Smyrna (historical)', 29.0499992370605, 0.507018134388547, -80.9333267211914, -1.4125530258771, 218, 12, 'PPL', 'P'),
(17266, 'New Smyrna Beach', 29.0255603790283, 0.506591595850457, -80.9272232055664, -1.41244649943349, 218, 12, 'PPL', 'P'),
(156749, 'New Somerset', 40.5158309936523, 0.707134650020799, -80.7061080932617, -1.40858731269786, 218, 41, 'PPL', 'P'),
(89412, 'New South Memphis', 35.086669921875, 0.61237791369718, -90.0566711425781, -1.57178542482375, 218, 50, 'PPL', 'P'),
(10786, 'New Spadra', 35.420280456543, 0.618200515946475, -93.51611328125, -1.63216408042581, 218, 4, 'PPL', 'P'),
(156750, 'New Springfield', 40.9172210693359, 0.714140228426307, -80.6063919067383, -1.40684693692549, 218, 41, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(151050, 'New Springville', 40.5933303833008, 0.70848726953845, -74.1636123657227, -1.29439922095464, 218, 40, 'PPL', 'P'),
(125546, 'New Squantum', 42.2941703796387, 0.738172527524155, -71.0272216796875, -1.23965887685444, 218, 23, 'PPL', 'P'),
(151051, 'New Square', 41.1366691589355, 0.717970320127032, -74.038330078125, -1.29221263254163, 218, 40, 'PPL', 'P'),
(165172, 'New Stanton', 40.2191696166992, 0.701956932229467, -79.6097183227539, -1.38945170131731, 218, 45, 'PPL', 'P'),
(156751, 'New Stark', 40.8338890075684, 0.712685809575988, -83.7375030517578, -1.46149513565197, 218, 41, 'PPL', 'P'),
(73679, 'New Straitsville', 39.5777816772461, 0.690762600903428, -82.2377777099609, -1.43531999056202, 218, 41, 'PPL', 'P'),
(73680, 'New Strasburg', 39.6519393920898, 0.692056897193207, -82.7627792358398, -1.4444829957666, 218, 41, 'PPL', 'P'),
(33417, 'New Strawn', 38.2625007629395, 0.667806618360136, -95.7416687011719, -1.67100735018905, 218, 20, 'PPL', 'P'),
(212026, 'New Stuyahok', 59.4527816772461, 1.0376467897373, -157.311935424805, -2.74561122584755, 218, 1, 'PPL', 'P'),
(212027, 'New Stuyarok', 59.4833297729492, 1.03817995458754, -157.33332824707, -2.74598460103238, 218, 1, 'PPL', 'P'),
(151052, 'New Suffolk', 40.9913902282715, 0.715434724453167, -72.4763870239258, -1.2649515835172, 218, 40, 'PPL', 'P'),
(96518, 'New Summerfield', 31.9805603027344, 0.558166073915309, -95.0936126708984, -1.65969663872338, 218, 51, 'PPL', 'P'),
(56513, 'New Survey', 36.103328704834, 0.630121956829133, -89.9138870239258, -1.56929337183371, 218, 29, 'PPL', 'P'),
(132272, 'New Swanzy', 46.2775001525879, 0.807694747254837, -87.4258270263672, -1.52586853288915, 218, 27, 'PPL', 'P'),
(96519, 'New Sweden', 30.4083309173584, 0.530725494543892, -97.5127792358398, -1.70191906043577, 218, 51, 'PPL', 'P'),
(128244, 'New Sweden', 46.9416694641113, 0.819286688531625, -68.1211090087891, -1.18893764231334, 218, 26, 'PPL', 'P'),
(137099, 'New Sweden', 44.4075012207031, 0.775057108884671, -94.1897201538086, -1.64392073821602, 218, 28, 'PPL', 'P'),
(128245, 'New Sweden Station', 46.9536094665527, 0.819495080886924, -68.1011123657227, -1.18858863505249, 218, 26, 'PPL', 'P'),
(23352, 'New Switzerland', 34.535831451416, 0.602763968741022, -83.4652786254883, -1.45674392310922, 218, 13, 'PPL', 'P'),
(96520, 'New Taiton', 29.3091697692871, 0.511541513500047, -96.3413925170898, -1.68147450537945, 218, 51, 'PPL', 'P'),
(89413, 'New Tazewell', 36.4425010681152, 0.636041631300161, -83.5997161865234, -1.45909030118763, 218, 50, 'PPL', 'P'),
(96521, 'New Territory', 29.5938892364502, 0.516510805646567, -95.6805572509766, -1.66994075417248, 218, 51, 'PPL', 'P'),
(165174, 'New Texas', 40.4966697692871, 0.706800223566913, -79.753059387207, -1.39195347484533, 218, 45, 'PPL', 'P'),
(110641, 'New Thacker (historical)', 37.5708312988281, 0.655734708875888, -82.0897216796875, -1.43273592535632, 218, 58, 'PPL', 'P'),
(10788, 'New Thompson (historical)', 34.2847213745117, 0.598381271114105, -93.9569396972656, -1.63985795281505, 218, 4, 'PPL', 'P'),
(4557, 'New Town', 33.6022186279297, 0.586469351032344, -86.8869400024414, -1.51646318002537, 218, 2, 'PPL', 'P'),
(10789, 'New Town', 35.4194412231445, 0.61818586856048, -94.2050018310547, -1.64418745379919, 218, 4, 'PPL', 'P'),
(23354, 'New Town', 33.811939239502, 0.590129666213577, -82.8108291625977, -1.44532162519387, 218, 13, 'PPL', 'P'),
(61060, 'New Town', 33.2708282470703, 0.58068549777691, -90.7533264160156, -1.58394435309662, 218, 30, 'PPL', 'P'),
(67187, 'New Town', 34.896671295166, 0.609061812086841, -79.3647232055664, -1.38517572987108, 218, 33, 'PPL', 'P'),
(73681, 'New Town', 39.5208282470703, 0.689768576026556, -82.1708297729492, -1.43415152863375, 218, 41, 'PPL', 'P'),
(89416, 'New Town', 35.7536087036133, 0.624018191347753, -86.9172210693359, -1.5169916843437, 218, 50, 'PPL', 'P'),
(165175, 'New Town', 40.8491706848145, 0.712952525159159, -78.2616729736328, -1.36592387150895, 218, 45, 'PPL', 'P'),
(198666, 'New Town', 47.9808311462402, 0.837423481345337, -102.489723205566, -1.78878311939477, 218, 34, 'PPL', 'P'),
(10790, 'New Town (historical)', 36.3230590820313, 0.633956975377874, -93.4361114501953, -1.63076778506628, 218, 4, 'PPL', 'P'),
(104633, 'New Town (historical)', 36.8294410705566, 0.642795008350439, -76.1986083984375, -1.32991660199054, 218, 53, 'PPL', 'P'),
(125547, 'New Town (historical)', 42.5183296203613, 0.742084844323536, -71.466667175293, -1.24732864763582, 218, 23, 'PPL', 'P'),
(189108, 'New Trementina', 35.4638900756836, 0.61896164738602, -104.49388885498, -1.82376240873242, 218, 38, 'PPL', 'P'),
(30653, 'New Trenton', 39.309440612793, 0.686079165810415, -84.9005584716797, -1.48179428211278, 218, 19, 'PPL', 'P'),
(137101, 'New Trier', 44.601390838623, 0.778441121102807, -92.9338912963867, -1.62200238981245, 218, 28, 'PPL', 'P'),
(165176, 'New Tripoli', 40.6808280944824, 0.710014392686529, -75.7522201538086, -1.32212565737957, 218, 45, 'PPL', 'P'),
(132273, 'New Troy', 41.8763885498047, 0.730880859038545, -86.5497207641602, -1.5105775940163, 218, 27, 'PPL', 'P'),
(56514, 'New Truxton', 38.978328704834, 0.68030017282397, -91.2377777099609, -1.59239962324151, 218, 29, 'PPL', 'P'),
(178714, 'New Tucson', 31.9772205352783, 0.55810778397695, -110.703887939453, -1.9321473393023, 218, 5, 'PPL', 'P'),
(76703, 'New Tulsa', 36.0750007629395, 0.62962754097276, -95.6725006103516, -1.66980013926692, 218, 42, 'PPL', 'P'),
(96522, 'New Ulm', 29.891939163208, 0.521712758203818, -96.4899978637695, -1.68406815796507, 218, 51, 'PPL', 'P'),
(137103, 'New Ulm', 44.3125, 0.773399024789987, -94.4602813720703, -1.64864292230289, 218, 28, 'PPL', 'P'),
(137104, 'New Ulm Mobile Village', 44.2861099243164, 0.772938431079458, -94.4333267211914, -1.64817247489633, 218, 28, 'PPL', 'P'),
(202419, 'New Underwood', 44.0933303833008, 0.769573793358252, -102.835830688477, -1.79482383453734, 218, 49, 'PPL', 'P'),
(10791, 'New Union', 33.1611099243164, 0.578770551795089, -92.2452774047852, -1.60998381012903, 218, 4, 'PPL', 'P'),
(61061, 'New Union', 31.3933296203613, 0.547916965039167, -89.7430572509766, -1.56631182983531, 218, 30, 'PPL', 'P'),
(89417, 'New Union', 35.5325012207031, 0.620159137770174, -86.0808334350586, -1.50239396630259, 218, 50, 'PPL', 'P'),
(30654, 'New Unionville', 39.211109161377, 0.68436295822494, -86.4622192382813, -1.50905040428919, 218, 19, 'PPL', 'P'),
(17267, 'New Upsala', 28.7961101531982, 0.502586933940278, -81.3166732788086, -1.4192436854837, 218, 12, 'PPL', 'P'),
(104635, 'New Upton', 37.5083312988281, 0.654643878093392, -76.5130615234375, -1.33540484436497, 218, 53, 'PPL', 'P'),
(151053, 'New Utrecht', 40.6130599975586, 0.708831616267398, -73.9963912963867, -1.29148066271602, 218, 40, 'PPL', 'P'),
(208234, 'New Utsaladdy', 48.2425003051758, 0.841990469719687, -122.470001220703, -2.13750475622274, 218, 56, 'PPL', 'P'),
(49789, 'New Valley', 39.6555595397949, 0.692120080690069, -76.1374969482422, -1.32885000597396, 218, 25, 'PPL', 'P'),
(49790, 'New Venture Estates', 39.4861106872559, 0.689162640299536, -77.1125030517578, -1.34586707270735, 218, 25, 'PPL', 'P'),
(42274, 'New Verda', 31.6922206878662, 0.553133598271928, -92.7641677856445, -1.61904015573195, 218, 22, 'PPL', 'P'),
(145889, 'New Vernon', 40.7452812194824, 0.711139311930979, -74.4977798461914, -1.30023154374192, 218, 37, 'PPL', 'P'),
(151054, 'New Vernon', 41.5016708374023, 0.724340801191583, -74.4847183227539, -1.3000035771526, 218, 40, 'PPL', 'P'),
(165177, 'New Vernon', 41.415828704834, 0.722842573341332, -80.121940612793, -1.3983916667806, 218, 45, 'PPL', 'P'),
(89418, 'New Victory', 36.228328704834, 0.632303618394126, -82.5197219848633, -1.44024084646621, 218, 50, 'PPL', 'P'),
(73682, 'New Vienna', 39.3236083984375, 0.686326440317629, -83.6911087036133, -1.46068540152254, 218, 41, 'PPL', 'P'),
(117014, 'New Vienna', 42.5480613708496, 0.742603761261938, -91.1141662597656, -1.59024219644244, 218, 16, 'PPL', 'P'),
(125548, 'New Village', 42.1147193908691, 0.735040516924167, -71.6833267211914, -1.25111007006762, 218, 23, 'PPL', 'P'),
(145890, 'New Village', 40.7172203063965, 0.710649556606513, -75.0827789306641, -1.31044170388712, 218, 37, 'PPL', 'P'),
(128247, 'New Vineyard', 44.8041687011719, 0.781980262454441, -70.121940612793, -1.22385874158117, 218, 26, 'PPL', 'P'),
(117015, 'New Virginia', 41.1822204589844, 0.718765340291448, -93.7286071777344, -1.63587279855985, 218, 16, 'PPL', 'P'),
(165180, 'New Virginia', 41.2194404602051, 0.719414951860345, -80.4063873291016, -1.40335619852667, 218, 45, 'PPL', 'P'),
(67188, 'New Visitors Center', 34.6841697692871, 0.605352960794742, -77.0691680908203, -1.34511073495777, 218, 33, 'PPL', 'P'),
(110642, 'New Vrindaban', 39.940559387207, 0.697094266395091, -80.621940612793, -1.40711831304057, 218, 58, 'PPL', 'P'),
(4560, 'New Wakefield', 31.3472194671631, 0.547112191047258, -88.0319366455078, -1.53644714137116, 218, 2, 'PPL', 'P'),
(30655, 'New Washington', 38.563060760498, 0.673052379917319, -85.5397186279297, -1.4929497312869, 218, 19, 'PPL', 'P'),
(156752, 'New Washington', 40.9622192382813, 0.714925594631772, -82.8544387817383, -1.44608275663341, 218, 41, 'PPL', 'P'),
(165181, 'New Washington', 40.8233299255371, 0.712501518828554, -78.7055587768555, -1.37367114027805, 218, 45, 'PPL', 'P'),
(96523, 'New Washington (historical)', 29.7619400024414, 0.519443844823612, -95.0917816162109, -1.6596646807903, 218, 51, 'PPL', 'P'),
(190543, 'New Washoe City', 39.2963905334473, 0.685851398958186, -119.774719238281, -2.0904632113598, 218, 39, 'PPL', 'P'),
(156753, 'New Waterford', 40.8450012207031, 0.712879754282373, -80.6147232055664, -1.40699234552101, 218, 41, 'PPL', 'P'),
(96524, 'New Waverly', 30.5375003814697, 0.532979926985671, -95.4830627441406, -1.66649382477359, 218, 51, 'PPL', 'P'),
(123290, 'New Waverly', 40.7641716003418, 0.71146901127393, -86.192497253418, -1.50434286758831, 218, 19, 'PPL', 'P'),
(156754, 'New Way', 40.1541709899902, 0.700822492184121, -82.5736083984375, -1.44118134180518, 218, 41, 'PPL', 'P'),
(96525, 'New Wehdem', 30.0720996856689, 0.524857152502875, -96.3459014892578, -1.68155320178966, 218, 51, 'PPL', 'P'),
(56515, 'New Wells', 37.5561103820801, 0.655477780409723, -89.6244430541992, -1.56424162156194, 218, 29, 'PPL', 'P'),
(4561, 'New West Greene', 32.9238891601563, 0.574630268406397, -88.1350021362305, -1.53824597352946, 218, 2, 'PPL', 'P'),
(156755, 'New Weston', 40.3372192382813, 0.704017286806807, -84.6433334350586, -1.47730485830517, 218, 41, 'PPL', 'P'),
(73683, 'New Westville', 39.8224983215332, 0.69503371208067, -84.7925033569336, -1.47990836458684, 218, 41, 'PPL', 'P'),
(156756, 'New Wheeling (historical)', 40.5847206115723, 0.708337000673943, -82.1916732788086, -1.43451531643865, 218, 41, 'PPL', 'P'),
(30656, 'New Whiteland', 39.5580596923828, 0.690418387332535, -86.0952835083008, -1.50264616765782, 218, 19, 'PPL', 'P'),
(96526, 'New Willard', 30.7966709136963, 0.537503306097171, -94.8927764892578, -1.65619138609661, 218, 51, 'PPL', 'P'),
(165183, 'New Wilmington', 41.1222190856934, 0.717718118771801, -80.3330612182617, -1.40207641646483, 218, 45, 'PPL', 'P'),
(30657, 'New Winchester', 39.7605590820313, 0.693952668415179, -86.6508331298828, -1.51234233771264, 218, 19, 'PPL', 'P'),
(156757, 'New Winchester', 40.7188911437988, 0.710678718220449, -82.9191665649414, -1.44721246956782, 218, 41, 'PPL', 'P'),
(49791, 'New Windsor', 39.5419387817383, 0.690137024363368, -77.1083297729492, -1.34579423525154, 218, 25, 'PPL', 'P'),
(120771, 'New Windsor', 41.202220916748, 0.71911441413133, -90.4422225952148, -1.57851456710811, 218, 18, 'PPL', 'P'),
(151055, 'New Windsor', 41.4766693115234, 0.723904442246974, -74.024169921875, -1.29196549119247, 218, 40, 'PPL', 'P'),
(151057, 'New Woodstock', 42.848331451416, 0.74784446281305, -75.8547210693359, -1.32391463584183, 218, 40, 'PPL', 'P'),
(56516, 'New Woollam', 38.3769416809082, 0.669803989177695, -91.5727767944336, -1.59824646025672, 218, 29, 'PPL', 'P'),
(125549, 'New Worcester (historical)', 42.2483291625977, 0.737372447353668, -71.8391723632813, -1.25383008964697, 218, 23, 'PPL', 'P'),
(61062, 'New Wren', 33.9716682434082, 0.592917463242672, -88.6133270263672, -1.54659431775658, 218, 30, 'PPL', 'P'),
(49792, 'New Yarmouth', 39.1191711425781, 0.68275833708914, -76.2291717529297, -1.33045003315688, 218, 25, 'PPL', 'P'),
(197141, 'New Year', 47.1719398498535, 0.823305664932663, -109.28971862793, -1.90746542863555, 218, 31, 'PPL', 'P'),
(676, 'New York', 39.6852798461914, 0.692638797891389, -93.9266662597656, -1.63932958165478, 218, 29, 'PPL', 'P'),
(17268, 'New York', 30.8383293151855, 0.538230382364276, -87.2008285522461, -1.52194156870377, 218, 12, 'PPL', 'P'),
(37408, 'New York', 36.9888916015625, 0.645577945110544, -88.9524993896484, -1.55251399222761, 218, 21, 'PPL', 'P'),
(96527, 'New York', 32.167781829834, 0.561433705993809, -95.6688919067383, -1.66973715550714, 218, 51, 'PPL', 'P'),
(113012, 'New York', 40.8516693115234, 0.712996134422009, -93.2597198486328, -1.62768917084615, 218, 16, 'PPL', 'P'),
(151061, 'New York', 43.0002784729004, 0.750496438626551, -75.5002822875977, -1.31772851210374, 218, 40, 'ADM1', 'A'),
(189109, 'New York', 35.0586090087891, 0.611888158372715, -107.526672363281, -1.87669446645245, 218, 38, 'PPL', 'P'),
(23355, 'New York (historical)', 31.8133296966553, 0.555247349229123, -83.9994430541992, -1.46606685113726, 218, 13, 'PPL', 'P'),
(56517, 'New York (historical)', 37.1666717529297, 0.648680794096596, -89.4447174072266, -1.56110481727199, 218, 29, 'PPL', 'P'),
(61063, 'New York (historical)', 33.9208297729492, 0.592030164546484, -88.8891677856445, -1.55140864721717, 218, 30, 'PPL', 'P'),
(89419, 'New York (historical)', 36.461109161377, 0.636366403795096, -87.5305633544922, -1.52769652666138, 218, 50, 'PPL', 'P'),
(183609, 'New York Flat (historical)', 39.4961090087891, 0.689337143929963, -121.277778625488, -2.11669654651957, 218, 6, 'PPL', 'P'),
(137106, 'New York Mills', 46.5180587768555, 0.811893287292374, -95.3758316040039, -1.66462228831753, 218, 28, 'PPL', 'P'),
(151060, 'New York Mills', 43.105281829834, 0.752329092930689, -75.2916717529297, -1.31408757141943, 218, 40, 'PPL', 'P'),
(37410, 'New Zion', 38.1791687011719, 0.666352199509816, -84.4886093139648, -1.47460441295983, 218, 21, 'PPL', 'P'),
(82588, 'New Zion', 33.8441696166992, 0.590692192414829, -80.0294418334961, -1.39677725852779, 218, 48, 'PPL', 'P'),
(89421, 'New Zion', 36.5697212219238, 0.638262041859015, -86.1733322143555, -1.5040083745554, 218, 50, 'PPL', 'P'),
(128249, 'Newagen', 43.7891693115234, 0.764265181199343, -69.6566696166992, -1.2157382307853, 218, 26, 'PPL', 'P'),
(175539, 'Newald', 45.7386093139648, 0.798289327812031, -88.7052764892578, -1.54819913862947, 218, 57, 'PPL', 'P'),
(76704, 'Newalla', 35.4049987792969, 0.617933800363304, -97.1624984741211, -1.69580550783738, 218, 42, 'PPL', 'P'),
(10792, 'Newark', 35.7016716003418, 0.623111717891717, -91.4413909912109, -1.59595334540011, 218, 4, 'PPL', 'P'),
(14297, 'Newark', 39.6836090087891, 0.692609636277453, -75.75, -1.3220869083857, 218, 10, 'PPL', 'P'),
(23356, 'Newark', 30.8236103057861, 0.537973487187624, -83.9097213745117, -1.46450091241629, 218, 13, 'PPL', 'P'),
(30658, 'Newark', 39.1288909912109, 0.682927980450578, -86.8072204589844, -1.51507181151386, 218, 19, 'PPL', 'P'),
(49794, 'Newark', 38.250560760498, 0.667598226004837, -75.291389465332, -1.31408264457142, 218, 25, 'PPL', 'P'),
(56519, 'Newark', 39.9930610656738, 0.69801059354716, -91.9727783203125, -1.60522780389631, 218, 29, 'PPL', 'P'),
(96528, 'Newark', 33.0011100769043, 0.575978027655059, -97.4841690063477, -1.70141971773138, 218, 51, 'PPL', 'P'),
(110643, 'Newark', 39.1188888549805, 0.682753410241124, -81.3977813720703, -1.42065928876113, 218, 58, 'PPL', 'P'),
(113391, 'Newark', 42.5422210693359, 0.742501828771215, -89.2275009155273, -1.55731367430221, 218, 57, 'PPL', 'P'),
(120772, 'Newark', 41.5369415283203, 0.724956390877555, -88.5833282470703, -1.54607074028627, 218, 18, 'PPL', 'P'),
(132283, 'Newark', 43.2486114501953, 0.754830666721628, -84.709716796875, -1.47846346653741, 218, 27, 'PPL', 'P'),
(142500, 'Newark', 40.6411094665527, 0.709321171854782, -98.9627838134766, -1.72722641448452, 218, 35, 'PPL', 'P'),
(145891, 'Newark', 40.7355613708496, 0.710969668569541, -74.1727828979492, -1.29455927693616, 218, 37, 'PPL', 'P'),
(151062, 'Newark', 43.0466690063477, 0.751306106176962, -77.0955581665039, -1.3455713286683, 218, 40, 'PPL', 'P'),
(156758, 'Newark', 40.0580596923828, 0.699145033592507, -82.4013900756836, -1.43817556504086, 218, 41, 'PPL', 'P'),
(170939, 'Newark', 45.9294395446777, 0.801619943650312, -97.7911071777344, -1.70677679942212, 218, 49, 'PPL', 'P'),
(183610, 'Newark', 37.5297203063965, 0.655017186699194, -122.039169311523, -2.12998532088491, 218, 6, 'PPL', 'P'),
(190544, 'Newark (historical)', 39.540828704834, 0.690117649866438, -115.783889770508, -2.02081009726154, 218, 39, 'PPL', 'P'),
(96529, 'Newark Beach', 32.9944381713867, 0.575861580936395, -97.5091705322266, -1.70185607667599, 218, 51, 'PPL', 'P'),
(145892, 'Newark Heights', 40.7224998474121, 0.71074170198023, -74.2583312988281, -1.29605237820131, 218, 37, 'PPL', 'P'),
(172301, 'Newark Hollow', 44.6997184753418, 0.780157262109254, -71.929443359375, -1.25540561574786, 218, 55, 'PPL', 'P'),
(14298, 'Newark Oaks', 39.6794395446777, 0.692536865400666, -75.7172164916992, -1.3215147282255, 218, 10, 'PPL', 'P'),
(151063, 'Newark Valley', 42.2236099243164, 0.736941015257075, -76.1836090087891, -1.32965481325538, 218, 40, 'PPL', 'P'),
(30659, 'Newark Village', 39.9677810668945, 0.697569374333562, -86.1233291625977, -1.50313565666618, 218, 19, 'PPL', 'P'),
(209923, 'Newaukum', 47.2574996948242, 0.824798965934898, -122.100563049316, -2.1310568437495, 218, 56, 'PPL', 'P'),
(132276, 'Newaygo', 43.4197196960449, 0.757817068989015, -85.8000030517578, -1.49749255147436, 218, 27, 'PPL', 'P'),
(201302, 'Newberg', 45.3002815246582, 0.790639064685642, -122.971939086914, -2.14626522462856, 218, 43, 'PPL', 'P'),
(4562, 'Newbern', 32.5930595397949, 0.568856202267969, -87.5327835083008, -1.52773527565524, 218, 2, 'PPL', 'P'),
(28046, 'Newbern', 39.0069389343262, 0.68079951552836, -90.3369369506836, -1.57667698595596, 218, 18, 'PPL', 'P'),
(30660, 'Newbern', 39.235279083252, 0.684784802941609, -85.7508316040039, -1.49663434781308, 218, 19, 'PPL', 'P'),
(37411, 'Newbern', 37.0858306884766, 0.647269851351072, -88.3172225952148, -1.54142632050323, 218, 21, 'PPL', 'P'),
(89423, 'Newbern', 36.1127815246582, 0.630286939658663, -89.2616729736328, -1.55791008922833, 218, 50, 'PPL', 'P'),
(104636, 'Newbern', 37.0733299255371, 0.647051671878767, -80.6908264160156, -1.40832059711469, 218, 53, 'PPL', 'P'),
(117018, 'Newbern', 41.160831451416, 0.718392031685646, -93.3083267211914, -1.6285375208114, 218, 16, 'PPL', 'P'),
(156761, 'Newbern', 40.2513885498047, 0.702519258693637, -84.2411117553711, -1.47028476567173, 218, 41, 'PPL', 'P'),
(110644, 'Newberne', 39.0438919067383, 0.68144446656535, -80.8930587768555, -1.41185021766542, 218, 58, 'PPL', 'P'),
(17269, 'Newberry', 29.646110534668, 0.517422239240133, -82.6066665649414, -1.44175831565534, 218, 12, 'PPL', 'P'),
(30661, 'Newberry', 38.9249992370605, 0.679369398022987, -87.0194396972656, -1.51877573595794, 218, 19, 'PPL', 'P'),
(82589, 'Newberry', 34.2744407653809, 0.598201840635661, -81.6188888549805, -1.42451834233871, 218, 48, 'PPL', 'P'),
(132280, 'Newberry', 46.3549995422363, 0.809047366772488, -85.5094375610352, -1.49242122696857, 218, 27, 'PPL', 'P'),
(165185, 'Newberry', 41.2397193908691, 0.719768885969217, -77.0530624389648, -1.34482963830471, 218, 45, 'PPL', 'P'),
(113791, 'Newberry Corner', 41.7891693115234, 0.729358596159456, -73.1405563354492, -1.27654352479399, 218, 8, 'PPL', 'P'),
(4563, 'Newberry Cove', 34.1666717529297, 0.596320916536766, -85.5783309936523, -1.49362364420074, 218, 2, 'PPL', 'P'),
(4564, 'Newberry Crossroads', 34.1627807617188, 0.596253005928969, -85.5722198486328, -1.49351698459909, 218, 2, 'PPL', 'P'),
(183611, 'Newberry Springs', 34.827220916748, 0.607849674316691, -116.6875, -2.03658107092088, 218, 6, 'PPL', 'P'),
(104638, 'Newberry Station', 38.732780456543, 0.676014547418787, -77.1780624389648, -1.3470112998697, 218, 53, 'PPL', 'P'),
(113323, 'Newberrytown', 40.1305618286133, 0.700410434584458, -76.7925033569336, -1.34028202442729, 218, 45, 'PPL', 'P'),
(175541, 'Newbold', 45.6980590820313, 0.797581592752343, -89.5100021362305, -1.56224425074438, 218, 57, 'PPL', 'P'),
(71168, 'Newbolds Corner', 39.9630584716797, 0.697486949497824, -74.7799987792969, -1.30515719333607, 218, 37, 'PPL', 'P'),
(23357, 'Newborn', 33.5169410705566, 0.584980976878126, -83.6961135864258, -1.46077275320629, 218, 13, 'PPL', 'P'),
(78833, 'Newboro', 39.9338912963867, 0.696977886255455, -79.8450012207031, -1.39355816256016, 218, 45, 'PPL', 'P'),
(151065, 'Newbridge', 44.2863883972168, 0.772943291348448, -74.975830078125, -1.30857509427908, 218, 40, 'PPL', 'P'),
(165187, 'Newbridge', 40.146671295166, 0.700691597816543, -77.7266693115234, -1.35658629609492, 218, 45, 'PPL', 'P'),
(4565, 'Newburg', 34.480281829834, 0.601794444946178, -87.5758285522461, -1.52848655339875, 218, 2, 'PPL', 'P'),
(10793, 'Newburg', 36.1155586242676, 0.630335409190503, -91.9497222900391, -1.6048254002556, 218, 4, 'PPL', 'P'),
(28047, 'Newburg', 39.9811096191406, 0.69780200145478, -88.8038864135742, -1.54992020648393, 218, 18, 'PPL', 'P'),
(37412, 'Newburg', 38.1599998474121, 0.666017639897875, -85.6597213745117, -1.49504417432619, 218, 21, 'PPL', 'P'),
(49795, 'Newburg', 38.3772201538086, 0.669808849446685, -76.95361328125, -1.34309392306425, 218, 25, 'PPL', 'P'),
(56520, 'Newburg', 37.9141693115234, 0.661727087644676, -91.9024963378906, -1.60400115189822, 218, 29, 'PPL', 'P'),
(96530, 'Newburg', 31.7866706848145, 0.554782061697173, -98.5216674804688, -1.71952748208921, 218, 51, 'PPL', 'P'),
(110645, 'Newburg', 39.3883285522461, 0.687456020093986, -79.8530578613281, -1.39369877746572, 218, 58, 'PPL', 'P'),
(117019, 'Newburg', 41.8186111450195, 0.729872453091787, -92.774169921875, -1.61921472594141, 218, 16, 'PPL', 'P'),
(132282, 'Newburg', 42.9088897705078, 0.748901404870675, -84.0691680908203, -1.46728378259737, 218, 27, 'PPL', 'P'),
(137118, 'Newburg', 43.5672187805176, 0.76039141365674, -91.8144378662109, -1.60246424163314, 218, 28, 'PPL', 'P'),
(151066, 'Newburg', 42.6930618286133, 0.745134496666813, -78.120002746582, -1.36345125959487, 218, 40, 'PPL', 'P'),
(165192, 'Newburg', 40.7030601501465, 0.710402415257354, -75.3300018310547, -1.31475655748526, 218, 45, 'PPL', 'P'),
(175543, 'Newburg', 43.4316711425781, 0.758025661081396, -88.04638671875, -1.53669934272639, 218, 57, 'PPL', 'P'),
(193815, 'Newburg', 40.5999984741211, 0.708603649678087, -124.123611450195, -2.16636569927204, 218, 6, 'PPL', 'P'),
(198669, 'Newburg', 48.7150001525879, 0.850237147772199, -100.912498474121, -1.76125535478717, 218, 34, 'PPL', 'P'),
(89422, 'Newburg (historical)', 35.5166702270508, 0.619882834807078, -87.4138870239258, -1.52566014053385, 218, 50, 'PPL', 'P'),
(165193, 'Newburg Homes', 40.7030601501465, 0.710402415257354, -75.2750015258789, -1.31379662107034, 218, 45, 'PPL', 'P'),
(30662, 'Newburgh', 37.9444389343262, 0.66225539222592, -87.4052810668945, -1.52550993824837, 218, 19, 'PPL', 'P'),
(151067, 'Newburgh', 41.5033302307129, 0.724369763068438, -74.0108337402344, -1.2917327309132, 218, 40, 'PPL', 'P'),
(156763, 'Newburgh (historical)', 41.0827789306641, 0.717029758209043, -84.408332824707, -1.47320332391034, 218, 41, 'PPL', 'P'),
(128250, 'Newburgh Center', 44.7216682434082, 0.780540357832062, -69.0027770996094, -1.20432565340793, 218, 26, 'PPL', 'P'),
(156764, 'Newburgh Heights', 41.4500007629395, 0.723438988267455, -81.6636123657227, -1.42529891485422, 218, 41, 'PPL', 'P'),
(151068, 'Newburgh Junction', 41.2969398498535, 0.720767571377997, -74.1391677856445, -1.29397258254801, 218, 40, 'PPL', 'P'),
(128251, 'Newburgh Village', 44.6966705322266, 0.78010406546648, -68.9794387817383, -1.2039183229192, 218, 26, 'PPL', 'P'),
(17270, 'Newburn', 30.2722206115723, 0.528349921562027, -83.1408309936523, -1.45108124368338, 218, 12, 'PPL', 'P'),
(33420, 'Newbury', 39.0847206115723, 0.682157061894028, -96.1750030517578, -1.67857046136877, 218, 20, 'PPL', 'P'),
(144200, 'Newbury', 43.3213882446289, 0.756100861403541, -72.0363922119141, -1.2572722253559, 218, 36, 'PPL', 'P'),
(172303, 'Newbury', 44.0791702270508, 0.769326652009093, -72.0588912963867, -1.25766490845863, 218, 55, 'PPL', 'P'),
(156766, 'Newbury Center', 41.4633293151855, 0.723671615388673, -81.2444381713867, -1.41798294502366, 218, 41, 'PPL', 'P'),
(172304, 'Newbury Center', 44.1236114501953, 0.770102297676578, -72.1488876342773, -1.25923564086956, 218, 55, 'PPL', 'P'),
(125550, 'Newbury Old Town', 42.7666702270508, 0.746419205576667, -70.845832824707, -1.23649304410861, 218, 23, 'PPL', 'P'),
(183612, 'Newbury Park', 34.1841697692871, 0.59662631453477, -118.909721374512, -2.07536615061431, 218, 6, 'PPL', 'P'),
(125552, 'Newburyport', 42.8125, 0.747219086010072, -70.8777770996094, -1.23705057688282, 218, 23, 'PPL', 'P'),
(4566, 'Newby', 31.5555591583252, 0.550748404620625, -86.1316680908203, -1.50328119841975, 218, 2, 'PPL', 'P'),
(28049, 'Newby', 39.4408302307129, 0.688372347246055, -88.3180618286133, -1.54144096788923, 218, 18, 'PPL', 'P'),
(37413, 'Newby', 37.7630615234375, 0.65908975921717, -84.415283203125, -1.473324630898, 218, 21, 'PPL', 'P'),
(76706, 'Newby', 35.7113914489746, 0.623281361253155, -96.3516693115234, -1.68165386927886, 218, 42, 'PPL', 'P'),
(96531, 'Newby', 31.3600006103516, 0.547335264078066, -96.1780624389648, -1.67862385774862, 218, 51, 'PPL', 'P'),
(10795, 'Newcastle', 35.1208305358887, 0.612974128886222, -90.7122192382813, -1.58322689749895, 218, 4, 'PPL', 'P'),
(17271, 'Newcastle', 30.371940612793, 0.530090363913421, -81.5858306884766, -1.42394136848855, 218, 12, 'PPL', 'P'),
(28050, 'Newcastle', 37.6505584716797, 0.657126210545455, -88.67138671875, -1.54760765055136, 218, 18, 'PPL', 'P'),
(76708, 'Newcastle', 35.2472190856934, 0.615180025217134, -97.5994415283203, -1.70343160277688, 218, 42, 'PPL', 'P'),
(89427, 'Newcastle', 35.2202796936035, 0.614709844126681, -89.1752777099609, -1.55640220741913, 218, 50, 'PPL', 'P'),
(96532, 'Newcastle', 33.1938896179199, 0.579342665376265, -98.7383270263672, -1.72330890452101, 218, 51, 'PPL', 'P'),
(128253, 'Newcastle', 44.0349998474121, 0.768555733452542, -69.5372161865234, -1.21365337512593, 218, 26, 'PPL', 'P'),
(142502, 'Newcastle', 42.6513900756836, 0.744407187373112, -96.8733291625977, -1.69075855125557, 218, 35, 'PPL', 'P'),
(156768, 'Newcastle', 40.3349990844727, 0.703978537812946, -82.1658325195313, -1.43406431010805, 218, 41, 'PPL', 'P'),
(183613, 'Newcastle', 38.8741683959961, 0.678482232484855, -121.132217407227, -2.11415602399769, 218, 6, 'PPL', 'P'),
(192722, 'Newcastle', 37.6666717529297, 0.657407440356567, -113.548606872559, -1.98179705097881, 218, 52, 'PPL', 'P'),
(208237, 'Newcastle', 47.5391693115234, 0.82971502814913, -122.154441833496, -2.13199720593041, 218, 56, 'PPL', 'P'),
(209636, 'Newcastle', 43.8547210693359, 0.765409275203641, -104.204437255859, -1.81871052530259, 218, 59, 'PPL', 'P'),
(78834, 'Newchester', 39.9033317565918, 0.696444521668139, -77.095832824707, -1.34557612235826, 218, 45, 'PPL', 'P'),
(17279, 'Newco', 30.1827793121338, 0.526788876399564, -82.602783203125, -1.4416905382056, 218, 12, 'PPL', 'P'),
(49796, 'Newcomb', 38.7536087036133, 0.676378068907583, -76.1763916015625, -1.32952884573582, 218, 25, 'PPL', 'P'),
(89424, 'Newcomb', 36.5536117553711, 0.63798087862693, -84.1661071777344, -1.4689756888379, 218, 50, 'PPL', 'P'),
(151071, 'Newcomb', 43.9694404602051, 0.767411506290189, -74.1650009155273, -1.29442345572056, 218, 40, 'PPL', 'P'),
(189110, 'Newcomb', 36.2847213745117, 0.633287856153992, -108.705276489258, -1.89726498902833, 218, 38, 'PPL', 'P'),
(197142, 'Newcomb', 45.9199981689453, 0.801455160557863, -112.518890380859, -1.96382510783657, 218, 31, 'PPL', 'P'),
(125554, 'Newcomb Hollow', 41.9638900756836, 0.732408048765651, -69.9966735839844, -1.22167241948427, 218, 23, 'PPL', 'P'),
(37414, 'Newcombe', 38.0844383239746, 0.664698842526068, -83.0541687011719, -1.44956870134227, 218, 21, 'PPL', 'P'),
(56521, 'Newcomer', 39.5113906860352, 0.689603859513135, -93.0894393920898, -1.62471721622768, 218, 29, 'PPL', 'P'),
(78835, 'Newcomer', 39.8791694641113, 0.696022810109525, -79.7925033569336, -1.39264190198712, 218, 45, 'PPL', 'P'),
(156770, 'Newcomerstown', 40.2722206115723, 0.70288284676146, -81.6061096191406, -1.42429530259742, 218, 41, 'PPL', 'P'),
(67190, 'Newdale', 35.9105606079102, 0.626757518845009, -82.1891708374023, -1.43447164059678, 218, 33, 'PPL', 'P'),
(110646, 'Newdale', 39.6722183227539, 0.692410831302078, -80.7108306884766, -1.4086697375336, 218, 58, 'PPL', 'P'),
(195381, 'Newdale', 43.8833312988281, 0.76590861790803, -111.605560302734, -1.94788449081579, 218, 17, 'PPL', 'P'),
(4567, 'Newell', 33.4330596923828, 0.583516970647883, -85.4336090087891, -1.49109776906486, 218, 2, 'PPL', 'P'),
(10797, 'Newell', 33.165828704834, 0.5788529100518, -92.7444381713867, -1.61869580900301, 218, 4, 'PPL', 'P'),
(23358, 'Newell', 30.9413890838623, 0.540029114654029, -82.022216796875, -1.43155774289007, 218, 13, 'PPL', 'P'),
(67191, 'Newell', 35.2794418334961, 0.615742418260332, -80.7358322143555, -1.40910609647821, 218, 33, 'PPL', 'P'),
(89425, 'Newell', 36.1172218322754, 0.630364437646385, -89.0686111450195, -1.55454052465911, 218, 50, 'PPL', 'P'),
(117021, 'Newell', 42.6055603027344, 0.743607306939707, -95.0025024414063, -1.65810646523649, 218, 16, 'PPL', 'P'),
(120774, 'Newell', 40.1630592346191, 0.700977621317618, -87.583610534668, -1.52862237461435, 218, 18, 'PPL', 'P'),
(156771, 'Newell', 40.2602806091309, 0.702674454406162, -80.8363876342773, -1.41086111963657, 218, 41, 'PPL', 'P'),
(165197, 'Newell', 40.0755615234375, 0.699450498169539, -79.8983306884766, -1.39448893736114, 218, 45, 'PPL', 'P'),
(177255, 'Newell', 40.6183280944824, 0.708923561904033, -80.6044387817383, -1.40681284846354, 218, 58, 'PPL', 'P'),
(193816, 'Newell', 41.8883285522461, 0.731089251393844, -121.371109008789, -2.11832546900032, 218, 6, 'PPL', 'P'),
(202422, 'Newell', 44.7147216796875, 0.780419117423436, -103.420280456543, -1.80502440730262, 218, 49, 'PPL', 'P'),
(73684, 'Newell Run', 39.3869400024414, 0.687431785328066, -81.2677764892578, -1.41839027551239, 218, 41, 'PPL', 'P'),
(89426, 'Newell Station', 35.8708305358887, 0.626064098276179, -83.7569427490234, -1.46183442237485, 218, 50, 'PPL', 'P'),
(42275, 'Newellton', 32.0724983215332, 0.559770695051109, -91.2408294677734, -1.59245288646331, 218, 22, 'PPL', 'P'),
(165199, 'Newelltown', 41.5833282470703, 0.725765991848939, -76.9122161865234, -1.34237140746051, 218, 45, 'PPL', 'P'),
(113792, 'Newent', 41.6044387817383, 0.726134440185751, -72.0183334350586, -1.25695704024089, 218, 8, 'PPL', 'P'),
(187107, 'Newett', 38.8666687011719, 0.678351338117277, -105.988327026367, -1.8498452752906, 218, 7, 'PPL', 'P'),
(73687, 'Newfain', 39.1197204589844, 0.682767924469065, -83.317497253418, -1.45416465159348, 218, 41, 'PPL', 'P'),
(151072, 'Newfane', 43.2866706848145, 0.755494925676521, -78.710563659668, -1.3737584919618, 218, 40, 'PPL', 'P'),
(172311, 'Newfane', 42.9855613708496, 0.750239576739413, -72.6563873291016, -1.26809318149711, 218, 55, 'PPL', 'P'),
(71169, 'Newfield', 39.5463905334473, 0.690214722088171, -75.0252838134766, -1.30943822478837, 218, 37, 'PPL', 'P'),
(113795, 'Newfield', 41.857780456543, 0.73055608654361, -73.1297225952148, -1.27635444035659, 218, 8, 'PPL', 'P'),
(128262, 'Newfield', 43.6480598449707, 0.761802356402264, -70.8475036621094, -1.23652220572255, 218, 26, 'PPL', 'P'),
(151074, 'Newfield', 42.3619384765625, 0.739355303943286, -76.5911102294922, -1.33676705126255, 218, 40, 'PPL', 'P'),
(165201, 'Newfield', 41.8800010681152, 0.730943909377353, -77.8141708374023, -1.35811348582202, 218, 45, 'PPL', 'P'),
(178715, 'Newfield', 31.5475006103516, 0.550607756425555, -111.732780456543, -1.95010490137465, 218, 5, 'PPL', 'P'),
(113796, 'Newfield Heights', 41.5574989318848, 0.725315185255416, -72.6755599975586, -1.26842780768808, 218, 8, 'PPL', 'P'),
(165202, 'Newfield Junction', 41.8683280944824, 0.730740177553962, -77.8225021362305, -1.35825889441754, 218, 45, 'PPL', 'P'),
(144203, 'Newfields', 43.0369415283203, 0.75113632965747, -70.9388885498047, -1.2381171728994, 218, 36, 'PPL', 'P'),
(137110, 'Newfolden', 48.3555603027344, 0.843963738929381, -96.329719543457, -1.68127077355605, 218, 28, 'PPL', 'P'),
(67193, 'Newfound', 35.6041717529297, 0.621410024534184, -82.7319412231445, -1.4439447709103, 218, 33, 'PPL', 'P'),
(110647, 'Newfound', 37.6072196960449, 0.656369806216845, -81.4766693115234, -1.42203614304471, 218, 58, 'PPL', 'P'),
(37415, 'Newfoundland', 38.1313896179199, 0.665518297193485, -83.0994415283203, -1.4503588612377, 218, 21, 'PPL', 'P'),
(67194, 'Newfoundland', 35.9483299255371, 0.627416717793831, -76.129997253418, -1.32871911160638, 218, 33, 'PPL', 'P'),
(145894, 'Newfoundland', 41.0463905334473, 0.716394660868086, -74.4355621337891, -1.29914563980744, 218, 37, 'PPL', 'P'),
(165203, 'Newfoundland', 41.3072204589844, 0.720947001856441, -75.3202819824219, -1.31458691412382, 218, 45, 'PPL', 'P'),
(96533, 'Newgulf', 29.2549991607666, 0.510596058023555, -95.8997192382813, -1.67376585244616, 218, 51, 'PPL', 'P'),
(96534, 'Newgulf Junction', 29.2338905334473, 0.510227642976256, -95.9194412231445, -1.67411006601705, 218, 51, 'PPL', 'P'),
(208238, 'Newhalem', 48.6738891601563, 0.849519625595504, -121.246109008789, -2.11614380743533, 218, 56, 'PPL', 'P'),
(212029, 'Newhalen', 59.7200012207031, 1.0423106505963, -154.897216796875, -2.70346643528093, 218, 1, 'PPL', 'P'),
(56522, 'Newhall', 39.577220916748, 0.690752813786422, -93.0319366455078, -1.62371360397088, 218, 29, 'PPL', 'P'),
(110648, 'Newhall', 37.2636108398438, 0.650372700337123, -81.6188888549805, -1.42451834233871, 218, 58, 'PPL', 'P'),
(117023, 'Newhall', 41.9955596923828, 0.732960787849897, -91.9674987792969, -1.6051356585226, 218, 16, 'PPL', 'P'),
(128256, 'Newhall', 43.7513885498047, 0.763605782513439, -70.4322204589844, -1.22927414649979, 218, 26, 'PPL', 'P'),
(183614, 'Newhall', 34.3847198486328, 0.600126573734489, -118.529998779297, -2.06873874108359, 218, 6, 'PPL', 'P'),
(165204, 'Newhard', 40.7247200012207, 0.71078045097409, -75.616943359375, -1.31976463191516, 218, 45, 'PPL', 'P'),
(42276, 'Newhlock', 32.7966690063477, 0.572409857847544, -91.8986129760742, -1.60393337444848, 218, 22, 'PPL', 'P'),
(10801, 'Newhope', 34.230281829834, 0.597431121816192, -93.879997253418, -1.63851505383538, 218, 4, 'PPL', 'P'),
(42277, 'Newhope', 32.6816711425781, 0.570402766492006, -91.5274963378906, -1.59745616720324, 218, 22, 'PPL', 'P'),
(67195, 'Newhope Proper', 36.190559387207, 0.631644419445304, -76.3797225952148, -1.33307764104641, 218, 33, 'PPL', 'P'),
(137112, 'Newhouse', 43.5250015258789, 0.759654583562143, -91.6999969482422, -1.60046687081558, 218, 28, 'PPL', 'P'),
(192723, 'Newhouse', 38.4811096191406, 0.671622062674865, -113.341110229492, -1.97817555137046, 218, 52, 'PPL', 'P'),
(156772, 'Newhouse (historical)', 40.7827796936035, 0.711793783768866, -80.6833267211914, -1.40818970274711, 218, 41, 'PPL', 'P'),
(128257, 'Newichawanoc (historical)', 43.2658309936523, 0.755131204450643, -70.8649978637695, -1.23682753714153, 218, 26, 'PPL', 'P'),
(151083, 'Newieden', 41.5877799987793, 0.725843689573742, -74.9897232055664, -1.30881757509633, 218, 40, 'PPL', 'P'),
(73685, 'Newingburg (historical)', 39.2677803039551, 0.685352056253796, -83.1013870239258, -1.4503928165416, 218, 41, 'PPL', 'P'),
(23359, 'Newington', 32.5900001525879, 0.568802805888113, -81.5041732788086, -1.42251617783119, 218, 13, 'PPL', 'P'),
(104639, 'Newington', 38.7383308410645, 0.676111419903439, -77.1852798461914, -1.34713726738926, 218, 53, 'PPL', 'P'),
(113797, 'Newington', 41.6977806091309, 0.72776356240358, -72.7241668701172, -1.26927615765332, 218, 8, 'PPL', 'P'),
(144204, 'Newington', 43.0999984741211, 0.752236880977945, -70.8341674804688, -1.23628944544328, 218, 36, 'PPL', 'P'),
(113798, 'Newington Junction', 41.714168548584, 0.728049585904655, -72.7375030517578, -1.2695089179326, 218, 8, 'PPL', 'P'),
(82591, 'Newington Plantation', 32.9847183227539, 0.575691937574957, -80.2055587768555, -1.39985107905796, 218, 48, 'PPL', 'P'),
(144205, 'Newington Station', 43.1122207641602, 0.752450200181261, -70.8219375610352, -1.23607599308191, 218, 36, 'PPL', 'P'),
(73686, 'Newkirk', 39.4055595397949, 0.687756757560083, -84.7877807617188, -1.4798259397511, 218, 41, 'PPL', 'P'),
(76709, 'Newkirk', 36.8822212219238, 0.643716195771497, -97.0530624389648, -1.69389548870357, 218, 42, 'PPL', 'P'),
(117024, 'Newkirk', 43.0699996948242, 0.751713303507636, -95.977783203125, -1.67512832565984, 218, 16, 'PPL', 'P'),
(151077, 'Newkirk', 43.1130599975586, 0.752464847567256, -74.5097198486328, -1.30043993609721, 218, 40, 'PPL', 'P'),
(165205, 'Newkirk', 40.7905616760254, 0.71192960498446, -75.9933319091797, -1.32633385137605, 218, 45, 'PPL', 'P'),
(189111, 'Newkirk', 35.0683288574219, 0.612057801734153, -104.264167785645, -1.8197530197113, 218, 38, 'PPL', 'P'),
(96535, 'Newkirk Colonia', 26.2959995269775, 0.45895177184863, -98.2570037841797, -1.71490822917846, 218, 51, 'PPL', 'P'),
(56523, 'Newland', 38.809440612793, 0.677352519550443, -93.1730575561523, -1.62617662850504, 218, 29, 'PPL', 'P'),
(67196, 'Newland', 36.0872192382813, 0.629840793597048, -81.9274978637695, -1.4299045856434, 218, 33, 'PPL', 'P'),
(82592, 'Newland', 33.2041702270508, 0.579522095854709, -79.6163864135742, -1.38956808145695, 218, 48, 'PPL', 'P'),
(104640, 'Newland', 38.0497207641602, 0.664092906799048, -76.871940612793, -1.34166846609078, 218, 53, 'PPL', 'P'),
(123293, 'Newland', 41.0458297729492, 0.71638487375108, -87.0341720581055, -1.51903286416119, 218, 19, 'PPL', 'P'),
(132285, 'Newland', 44.3013916015625, 0.77320514666263, -86.2433319091797, -1.50523009970547, 218, 27, 'PPL', 'P'),
(89428, 'Newland (historical)', 36.2488899230957, 0.632662479351014, -84.3930587768555, -1.47293674148523, 218, 50, 'PPL', 'P'),
(190547, 'Newland (historical)', 38.041389465332, 0.663947498203529, -114.179443359375, -1.99280722471547, 218, 39, 'PPL', 'P'),
(49797, 'Newland Park', 38.3916702270508, 0.670061050801915, -75.6258316040039, -1.31991976104865, 218, 25, 'PPL', 'P'),
(110649, 'Newlandsville', 39.2816696166992, 0.68559447049202, -81.2594375610352, -1.41824473375881, 218, 58, 'PPL', 'P'),
(67198, 'Newlife (historical)', 36.3491706848145, 0.634412708819414, -81.1658325195313, -1.41661101758811, 218, 33, 'PPL', 'P'),
(42278, 'Newlight', 32.103328704834, 0.56030878674936, -91.4333267211914, -1.5958125973365, 218, 22, 'PPL', 'P'),
(67199, 'Newlight', 34.7633285522461, 0.606734542189248, -78.7836074829102, -1.37503334717562, 218, 33, 'PPL', 'P'),
(42279, 'Newlin', 30.6805591583252, 0.535476773665675, -93.4008331298828, -1.63015206222226, 218, 22, 'PPL', 'P'),
(165206, 'Newlin', 40.8849983215332, 0.71357783538311, -76.3844375610352, -1.33315993272409, 218, 45, 'PPL', 'P'),
(191938, 'Newlin', 34.5897216796875, 0.60370453065901, -100.443893432617, -1.75307665392148, 218, 51, 'PPL', 'P'),
(78837, 'Newlinville', 39.9730606079102, 0.697661519707278, -75.8288879394531, -1.32346376266928, 218, 45, 'PPL', 'P'),
(197143, 'Newlon Junction', 47.6586112976074, 0.831799684071417, -104.196670532227, -1.81857497040311, 218, 31, 'PPL', 'P'),
(165207, 'Newlonsburg', 40.4244384765625, 0.705539549685896, -79.6647186279297, -1.39041163773223, 218, 45, 'PPL', 'P'),
(110650, 'Newlonton', 38.7444381713867, 0.676218012926069, -80.2358322143555, -1.40037945021824, 218, 58, 'PPL', 'P'),
(183615, 'Newlove', 37.9938888549805, 0.663118456156188, -121.761672973633, -2.12514209612649, 218, 6, 'PPL', 'P'),
(110651, 'Newlyn', 37.9441719055176, 0.662250731694013, -81.085563659668, -1.41521006169667, 218, 58, 'PPL', 'P'),
(110652, 'Newlyn (historical)', 38.0736083984375, 0.664509824667699, -81.0833282470703, -1.4151710463867, 218, 58, 'PPL', 'P'),
(28051, 'Newman', 39.7986106872559, 0.694616794212018, -87.9858322143555, -1.5356424672478, 218, 18, 'PPL', 'P'),
(33422, 'Newman', 39.0805587768555, 0.682084424175296, -95.4644393920898, -1.66616878596254, 218, 20, 'PPL', 'P'),
(37416, 'Newman', 37.8369407653809, 0.660379195237959, -87.295280456543, -1.52359006541853, 218, 21, 'PPL', 'P'),
(61064, 'Newman', 32.2355613708496, 0.562616682150023, -90.6972198486328, -1.5829651087638, 218, 30, 'PPL', 'P'),
(104641, 'Newman', 37.6272201538086, 0.656718880056727, -77.2986068725586, -1.34911519713086, 218, 53, 'PPL', 'P'),
(140579, 'Newman', 46.9911117553711, 0.820149619303838, -97.0991668701172, -1.69470016282694, 218, 34, 'PPL', 'P'),
(156773, 'Newman', 40.8311080932617, 0.712637273465121, -81.5652770996094, -1.42358264068971, 218, 41, 'PPL', 'P'),
(183616, 'Newman', 37.3138885498047, 0.651250211916304, -121.019721984863, -2.11219260848403, 218, 6, 'PPL', 'P'),
(189112, 'Newman', 32.0033302307129, 0.558563484128976, -106.32250213623, -1.85567773123593, 218, 38, 'PPL', 'P'),
(191939, 'Newman', 31.997730255127, 0.558465746116971, -106.327278137207, -1.85576108817805, 218, 51, 'PPL', 'P'),
(195382, 'Newman', 48.2077789306641, 0.841384467413639, -116.434173583984, -2.03215969087913, 218, 17, 'PPL', 'P'),
(42280, 'Newman (historical)', 32.2013893127441, 0.562020267223899, -92.9869384765625, -1.62292823776542, 218, 22, 'PPL', 'P'),
(142504, 'Newman Grove', 41.75, 0.728674962707633, -97.7750015258789, -1.70649570276907, 218, 35, 'PPL', 'P'),
(208241, 'Newman Lake', 47.7769393920898, 0.833864898917746, -117.093887329102, -2.04367386785209, 218, 56, 'PPL', 'P'),
(183617, 'Newman Springs', 39.1963882446289, 0.684106029758775, -122.714721679688, -2.14177593397901, 218, 6, 'PPL', 'P'),
(61065, 'Newmans', 32.350830078125, 0.564628500616496, -90.7527770996094, -1.58393476571669, 218, 30, 'PPL', 'P'),
(104643, 'Newmans', 36.6380615234375, 0.639454805132234, -78.3747177124023, -1.36789687440254, 218, 53, 'PPL', 'P'),
(156774, 'Newmans', 40.4841690063477, 0.706582044094608, -83.1913909912109, -1.45196368211058, 218, 41, 'PPL', 'P'),
(49798, 'Newmans Corner', 39.1661109924316, 0.683577592019476, -75.9669418334961, -1.32587325766552, 218, 25, 'PPL', 'P'),
(151078, 'Newmans Corner', 42.1902809143066, 0.736359314295974, -75.8813934326172, -1.32438015640037, 218, 40, 'PPL', 'P'),
(61066, 'Newmans Grove', 32.3458290100098, 0.564541215511768, -90.7708282470703, -1.58424981767365, 218, 30, 'PPL', 'P'),
(165208, 'Newmanstown', 40.3494415283203, 0.704230606010122, -76.2136077880859, -1.33017839072569, 218, 45, 'PPL', 'P'),
(89429, 'Newmansville', 36.2788887023926, 0.633186056821324, -82.7594375610352, -1.44442467253873, 218, 50, 'PPL', 'P'),
(120776, 'Newmansville', 40.0033302307129, 0.698189824288523, -90.0116729736328, -1.57100005861829, 218, 18, 'PPL', 'P'),
(165209, 'Newmansville', 41.4286117553711, 0.723065679661653, -79.3686065673828, -1.38524350732082, 218, 45, 'PPL', 'P'),
(49799, 'Newmarket', 38.4736099243164, 0.671491168307288, -76.7747192382813, -1.33997163300224, 218, 25, 'PPL', 'P'),
(56524, 'Newmarket', 39.7597198486328, 0.693938021029184, -91.7319412231445, -1.60102440358979, 218, 29, 'PPL', 'P'),
(104642, 'Newmarket', 37.0188903808594, 0.646101522580854, -76.4297180175781, -1.33395022577757, 218, 53, 'PPL', 'P'),
(144208, 'Newmarket', 43.0827789306641, 0.75193634324893, -70.9355621337891, -1.23805911598763, 218, 36, 'PPL', 'P'),
(23360, 'Newnan', 33.3805618286133, 0.582600710074841, -84.7997207641602, -1.4800343321064, 218, 13, 'PPL', 'P'),
(23361, 'Newnan Pines', 33.4263916015625, 0.583400590508246, -84.7819366455078, -1.47972394068135, 218, 13, 'PPL', 'P'),
(23362, 'Newnan Springs', 34.9775009155273, 0.610472555095283, -85.2444381713867, -1.48779611510343, 218, 13, 'PPL', 'P'),
(17273, 'Newnans Lake Homesites', 29.6497192382813, 0.517485222999913, -82.2397232055664, -1.43535394586592, 218, 12, 'PPL', 'P'),
(17274, 'Newnansville', 29.8083305358887, 0.520253512374023, -82.476936340332, -1.43949409609656, 218, 12, 'PPL', 'P'),
(10798, 'Newnata', 35.8894386291504, 0.626388870771114, -92.2516708374023, -1.61009539657871, 218, 4, 'PPL', 'P'),
(190548, 'Newpass', 39.6055603027344, 0.691247429379877, -117.476387023926, -2.05034974691465, 218, 39, 'PPL', 'P'),
(10800, 'Newport', 35.6047210693359, 0.621419611914108, -91.2816696166992, -1.59316568152907, 218, 4, 'PPL', 'P'),
(14299, 'Newport', 39.7136116027832, 0.693133280326789, -75.6097183227539, -1.31963853123754, 218, 10, 'PPL', 'P'),
(17276, 'Newport', 30.1991691589355, 0.527074933190152, -84.1808319091797, -1.46923268388309, 218, 12, 'PPL', 'P'),
(23363, 'Newport', 34.7227783203125, 0.606026807129559, -84.23388671875, -1.47015866499411, 218, 13, 'PPL', 'P'),
(28053, 'Newport', 38.6808280944824, 0.675107807646643, -90.1758270263672, -1.573865087319, 218, 18, 'PPL', 'P'),
(30663, 'Newport', 39.8841705322266, 0.696110095214253, -87.4086074829102, -1.52556799516014, 218, 19, 'PPL', 'P'),
(37417, 'Newport', 39.0913887023926, 0.682273442033664, -84.4958267211914, -1.47473038047939, 218, 21, 'PPL', 'P'),
(42281, 'Newport', 32.0825004577637, 0.559945265260564, -92.3680572509766, -1.61212672270016, 218, 22, 'PPL', 'P'),
(49801, 'Newport', 38.4002799987793, 0.670211319666423, -75.1552810668945, -1.31170710487907, 218, 25, 'PPL', 'P'),
(56530, 'Newport', 37.5277786254883, 0.654983297974323, -94.1041717529297, -1.64242763695087, 218, 29, 'PPL', 'P'),
(61067, 'Newport', 32.936939239502, 0.574858035258626, -89.7644424438477, -1.56668507186209, 218, 30, 'PPL', 'P'),
(67200, 'Newport', 34.7863883972168, 0.607137012408986, -76.8594436645508, -1.34145035319751, 218, 33, 'PPL', 'P'),
(76711, 'Newport', 34.2527809143066, 0.597823804918925, -97.2744369506836, -1.69775920281306, 218, 42, 'PPL', 'P'),
(82598, 'Newport', 34.9897193908691, 0.610685807719571, -81.1011123657227, -1.41548143781175, 218, 48, 'PPL', 'P'),
(89430, 'Newport', 35.9669418334961, 0.627741556867793, -83.1877822875977, -1.4519006983508, 218, 50, 'PPL', 'P'),
(96536, 'Newport', 33.4677810668945, 0.58412297295393, -98.01611328125, -1.71070389676556, 218, 51, 'PPL', 'P'),
(104646, 'Newport', 38.5786094665527, 0.673323756032398, -78.5966720581055, -1.37177070852417, 218, 53, 'PPL', 'P'),
(110653, 'Newport', 39.2583312988281, 0.685187140003293, -81.561393737793, -1.42351486323997, 218, 58, 'PPL', 'P'),
(117027, 'Newport', 41.0888900756836, 0.717136417810701, -91.1827774047852, -1.59143968682659, 218, 16, 'PPL', 'P'),
(128258, 'Newport', 44.8352813720703, 0.782523281000708, -69.2744369506836, -1.20906701225465, 218, 26, 'PPL', 'P'),
(132287, 'Newport', 42.0022201538086, 0.733077034831479, -83.3086090087891, -1.45400952245998, 218, 27, 'PPL', 'P'),
(137113, 'Newport', 44.8663902282715, 0.783066232967948, -93.0002822875977, -1.62316113120274, 218, 28, 'PPL', 'P'),
(142507, 'Newport', 42.601390838623, 0.74353453606292, -99.3269424438477, -1.73358218158404, 218, 35, 'PPL', 'P'),
(144210, 'Newport', 43.3652801513672, 0.756866919691102, -72.1738891601563, -1.25967199981417, 218, 36, 'PPL', 'P'),
(145895, 'Newport', 40.7249984741211, 0.71078531124308, -74.9094390869141, -1.30741635288879, 218, 37, 'PPL', 'P'),
(151082, 'Newport', 41.2758293151855, 0.720399123041184, -74.4697189331055, -1.29974178841745, 218, 40, 'PPL', 'P'),
(156776, 'Newport', 40.3591690063477, 0.704400382529615, -81.3430633544922, -1.41970427919423, 218, 41, 'PPL', 'P'),
(165213, 'Newport', 40.9000015258789, 0.713839690697292, -80.3547210693359, -1.40245445218157, 218, 45, 'PPL', 'P'),
(169510, 'Newport', 41.4900016784668, 0.724137135947219, -71.3133316040039, -1.2446524370564, 218, 47, 'PPL', 'P'),
(172307, 'Newport', 44.9363899230957, 0.784287958118022, -72.2055587768555, -1.26022473889842, 218, 55, 'PPL', 'P'),
(183618, 'Newport', 39.5774993896484, 0.690757674055411, -123.773612976074, -2.16025707352167, 218, 6, 'PPL', 'P'),
(201303, 'Newport', 44.6369400024414, 0.779061571057768, -124.052223205566, -2.16511973935605, 218, 43, 'PPL', 'P'),
(208240, 'Newport', 48.1797218322754, 0.840894778668201, -117.042221069336, -2.04277212150699, 218, 56, 'PPL', 'P'),
(4568, 'Newport (historical)', 34.7788887023926, 0.607006118041409, -87.9061126708984, -1.53425109873628, 218, 2, 'PPL', 'P'),
(61068, 'Newport (historical)', 33.9066696166992, 0.591783023197325, -88.7616729736328, -1.54918344296836, 218, 30, 'PPL', 'P'),
(156777, 'Newport (historical)', 41.0530586242676, 0.716511041007723, -80.5741729736328, -1.40628461046132, 218, 41, 'PPL', 'P'),
(183619, 'Newport Beach', 33.6188888549805, 0.586760301381436, -117.928062438965, -2.05823297005739, 218, 6, 'PPL', 'P'),
(165212, 'Newport Center', 41.1891708374023, 0.718886647279101, -76.0258331298828, -1.32690110468824, 218, 45, 'PPL', 'P'),
(172308, 'Newport Center', 44.9508285522461, 0.78453995973617, -72.3069381713867, -1.26199414312667, 218, 55, 'PPL', 'P'),
(14300, 'Newport Heights', 39.7138900756836, 0.693138140595779, -75.6041717529297, -1.31954172533192, 218, 10, 'PPL', 'P'),
(183620, 'Newport Heights', 33.6191711425781, 0.586765228229452, -117.922500610352, -2.05813589783566, 218, 6, 'PPL', 'P'),
(201304, 'Newport Heights', 44.6444396972656, 0.779192465425346, -124.023330688477, -2.16461546980364, 218, 43, 'PPL', 'P'),
(205103, 'Newport Heights Condominium', 40.848331451416, 0.712937877773164, -111.874717712402, -1.95258217382064, 218, 52, 'PPL', 'P'),
(49803, 'Newport Hills', 38.2752799987793, 0.66802965810143, -75.2194366455078, -1.31282683095939, 218, 25, 'PPL', 'P'),
(208242, 'Newport Hills', 47.5411109924316, 0.829748916874001, -122.175277709961, -2.13236086057726, 218, 56, 'PPL', 'P'),
(71172, 'Newport Landing', 39.2897186279297, 0.685734952239522, -75.1977767944336, -1.31244879524265, 218, 37, 'PPL', 'P'),
(104648, 'Newport News', 36.9786109924316, 0.6453985146321, -76.4283294677734, -1.33392599101165, 218, 53, 'PPL', 'P'),
(208243, 'Newport Shores', 47.5708312988281, 0.830267634075321, -122.191108703613, -2.13263716354035, 218, 56, 'PPL', 'P'),
(49804, 'Newport South', 38.2355613708496, 0.667336437269682, -75.1888885498047, -1.31229366610916, 218, 25, 'PPL', 'P'),
(165216, 'Newportville', 40.1236114501953, 0.700289127596805, -74.9002838134766, -1.30725656322338, 218, 45, 'PPL', 'P'),
(165217, 'Newportville Terrace', 40.121940612793, 0.700259965982869, -74.9069366455078, -1.30737267704691, 218, 45, 'PPL', 'P'),
(30664, 'Newry', 38.9047203063965, 0.679015463914116, -85.8222198486328, -1.49788030772907, 218, 19, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(82593, 'Newry', 34.7249984741211, 0.60606555612342, -82.9100036621094, -1.44705254674436, 218, 48, 'PPL', 'P'),
(128260, 'Newry', 44.4872207641602, 0.776448477396183, -70.7874984741211, -1.23547491762388, 218, 26, 'PPL', 'P'),
(165218, 'Newry', 40.3936080932617, 0.705001457987646, -78.4358291625977, -1.36896347041912, 218, 45, 'PPL', 'P'),
(175546, 'Newry', 43.711669921875, 0.762912561681691, -90.8172225952148, -1.58505955180309, 218, 57, 'PPL', 'P'),
(151085, 'Newrys', 42.4377784729004, 0.740678961584083, -73.9902801513672, -1.29137400311437, 218, 40, 'PPL', 'P'),
(165220, 'Newside', 40.690559387207, 0.710184235785049, -75.6447219848633, -1.3202494603916, 218, 45, 'PPL', 'P'),
(61069, 'Newsom', 31.3261108398438, 0.546743775999959, -89.9341735839844, -1.56964743910064, 218, 30, 'PPL', 'P'),
(67202, 'Newsom', 35.535831451416, 0.620217261260965, -80.1877822875977, -1.39954082079097, 218, 33, 'PPL', 'P'),
(89431, 'Newsom', 36.0800018310547, 0.629714826077487, -86.9972229003906, -1.51838797970323, 218, 50, 'PPL', 'P'),
(183623, 'Newsom Springs', 35.122501373291, 0.613003290500158, -120.544166564941, -2.10389260063069, 218, 6, 'PPL', 'P'),
(23364, 'Newsome', 30.7755603790283, 0.537134857760358, -83.2200012207031, -1.45246302481497, 218, 13, 'PPL', 'P'),
(96537, 'Newsome', 32.9772186279297, 0.57556104320738, -95.1386108398438, -1.66048200492884, 218, 51, 'PPL', 'P'),
(195383, 'Newsome', 45.9075012207031, 0.801237047664586, -115.629173278809, -2.01810978507426, 218, 17, 'PPL', 'P'),
(4569, 'Newsome Springs', 34.6477813720703, 0.604717863453785, -87.9055633544922, -1.53424151135636, 218, 2, 'PPL', 'P'),
(67203, 'Newsome Store', 36.2622184753418, 0.632895106472233, -76.7680587768555, -1.33985538602066, 218, 33, 'PPL', 'P'),
(104650, 'Newsoms', 36.624439239502, 0.639217051425917, -77.125, -1.34608518560063, 218, 53, 'PPL', 'P'),
(37418, 'Newstead', 36.7991714477539, 0.642266703769194, -87.6302795410156, -1.52943690243375, 218, 21, 'PPL', 'P'),
(145896, 'Newstead', 40.752498626709, 0.711265279450539, -74.2783279418945, -1.29640138546216, 218, 37, 'PPL', 'P'),
(56526, 'Newstead (historical)', 36.7897186279297, 0.642101720939664, -94.1080627441406, -1.64249554755866, 218, 29, 'PPL', 'P'),
(104652, 'Newstead Farm', 37.2561111450195, 0.650241805969545, -77.2761077880859, -1.34872251402813, 218, 53, 'PPL', 'P'),
(125555, 'Newstead Montegrade', 42.3111114501953, 0.738468204984181, -71.095832824707, -1.2408563672386, 218, 23, 'PPL', 'P'),
(145897, 'Newstead North', 40.7594413757324, 0.711386453280138, -74.2727813720703, -1.29630457955654, 218, 37, 'PPL', 'P'),
(37419, 'Newt', 37.1791687011719, 0.648898906989873, -85.5647201538086, -1.49338609023151, 218, 21, 'PPL', 'P'),
(96538, 'Newt', 33.8386116027832, 0.590595186772123, -95.8986129760742, -1.67374654452825, 218, 51, 'PPL', 'P'),
(212030, 'Newtok', 60.9427795410156, 1.06365215830776, -164.629440307617, -2.87332577908339, 218, 1, 'PPL', 'P'),
(4571, 'Newton', 31.1625003814697, 0.543888234810636, -85.3955612182617, -1.49043370984705, 218, 2, 'PPL', 'P'),
(23365, 'Newton', 31.312780380249, 0.546511115589227, -84.3358306884766, -1.47193792291839, 218, 13, 'PPL', 'P'),
(33423, 'Newton', 38.0466690063477, 0.664039643577246, -97.3447189331055, -1.69898585481115, 218, 20, 'PPL', 'P'),
(42282, 'Newton', 30.3113899230957, 0.529033555013851, -93.2002792358398, -1.62665173644351, 218, 22, 'PPL', 'P'),
(49816, 'Newton', 38.764720916748, 0.676572013613968, -75.9319381713867, -1.32526232851146, 218, 25, 'PPL', 'P'),
(61070, 'Newton', 32.3211097717285, 0.564109783415175, -89.163330078125, -1.55619368190577, 218, 30, 'PPL', 'P'),
(67204, 'Newton', 35.6697196960449, 0.622554051959455, -81.2216720581055, -1.41758560138902, 218, 33, 'PPL', 'P'),
(89432, 'Newton', 35.7947196960449, 0.624735713524448, -85.2125015258789, -1.48723871548728, 218, 50, 'PPL', 'P'),
(96539, 'Newton', 30.8483295440674, 0.538404919284217, -93.7572174072266, -1.63637214126424, 218, 51, 'PPL', 'P'),
(110658, 'Newton', 38.5913887023926, 0.673546795773693, -81.1788864135742, -1.41683885101936, 218, 58, 'PPL', 'P'),
(112307, 'Newton', 38.9908294677734, 0.680518352296275, -88.1624984741211, -1.53872587515789, 218, 18, 'PPL', 'P'),
(117029, 'Newton', 41.6997184753418, 0.727797384549424, -93.0477828979492, -1.62399017325008, 218, 16, 'PPL', 'P'),
(123295, 'Newton', 40.9672203063965, 0.715012879736499, -85.8213882446289, -1.49786579350113, 218, 19, 'PPL', 'P'),
(125556, 'Newton', 42.3369407653809, 0.738919011577704, -71.209716796875, -1.24284401751818, 218, 23, 'PPL', 'P'),
(144212, 'Newton', 42.8694381713867, 0.748212844570835, -71.0350036621094, -1.23979469807004, 218, 36, 'PPL', 'P'),
(145901, 'Newton', 41.0580596923828, 0.71659832611245, -74.753059387207, -1.30468701224562, 218, 37, 'PPL', 'P'),
(165221, 'Newton', 41.2224998474121, 0.719468348240201, -75.8955612182617, -1.32462743090759, 218, 45, 'PPL', 'P'),
(175548, 'Newton', 43.5897216796875, 0.7607841633385, -91.0627822875977, -1.58934537694535, 218, 57, 'PPL', 'P'),
(197144, 'Newton', 45.978889465332, 0.802483007580579, -108.057777404785, -1.88596399810063, 218, 31, 'PPL', 'P'),
(205104, 'Newton', 41.8627815246582, 0.730643371648337, -111.98999786377, -1.95459419202419, 218, 52, 'PPL', 'P'),
(208244, 'Newton', 47.0813903808594, 0.821725278562783, -124.054168701172, -2.16515369465995, 218, 56, 'PPL', 'P'),
(104653, 'Newton (historical)', 36.9991683959961, 0.645757309009961, -79.4574966430664, -1.38679493181385, 218, 53, 'PPL', 'P'),
(189113, 'Newton (historical)', 32.7155609130859, 0.570994254570112, -108.196670532227, -1.88838814048288, 218, 38, 'PPL', 'P'),
(125557, 'Newton Center', 42.3305587768555, 0.738807624865112, -71.1999969482422, -1.24267437415674, 218, 23, 'PPL', 'P'),
(165222, 'Newton Center', 41.4474983215332, 0.723395312425578, -75.7841720581055, -1.32268332331183, 218, 45, 'PPL', 'P'),
(23366, 'Newton Chase', 33.5111083984375, 0.584879177545458, -83.8291702270508, -1.46309502967684, 218, 13, 'PPL', 'P'),
(125558, 'Newton Corner', 42.3611106872559, 0.739340856294373, -71.1958312988281, -1.24260166985898, 218, 23, 'PPL', 'P'),
(120779, 'Newton Corners', 41.7363891601563, 0.728437408738397, -90.1163864135742, -1.57282765291635, 218, 18, 'PPL', 'P'),
(151087, 'Newton Falls', 44.2105598449707, 0.771619833444733, -74.9894409179688, -1.30881264824831, 218, 40, 'PPL', 'P'),
(156778, 'Newton Falls', 41.1883316040039, 0.718871999893105, -80.9783325195313, -1.41333852524062, 218, 41, 'PPL', 'P'),
(67205, 'Newton Grove', 35.2449989318848, 0.615141276223274, -78.3544387817383, -1.36754294029367, 218, 33, 'PPL', 'P'),
(165223, 'Newton Hamilton', 40.3916702270508, 0.704967635841802, -77.8372192382813, -1.35851575630468, 218, 45, 'PPL', 'P'),
(145898, 'Newton Heights', 40.4327812194824, 0.705685158018496, -74.3983306884766, -1.29849582850146, 218, 37, 'PPL', 'P'),
(125559, 'Newton Highlands', 42.3208312988281, 0.738637848345619, -71.1999969482422, -1.24267437415674, 218, 23, 'PPL', 'P'),
(151088, 'Newton Hook', 42.3544387817383, 0.739224409575709, -73.7830581665039, -1.28775729719598, 218, 40, 'PPL', 'P'),
(144215, 'Newton Junction', 42.8672218322754, 0.748174162156002, -71.0663909912109, -1.24034251030627, 218, 36, 'PPL', 'P'),
(165225, 'Newton Junction', 40.8030586242676, 0.712147717877737, -76.1361083984375, -1.32882577120804, 218, 45, 'PPL', 'P'),
(125560, 'Newton Lower Falls', 42.3291702270508, 0.738783390099192, -71.2541732788086, -1.24361992950177, 218, 23, 'PPL', 'P'),
(104655, 'Newton Park', 36.8327789306641, 0.642853264999284, -76.2522201538086, -1.33085230363954, 218, 53, 'PPL', 'P'),
(23368, 'Newton Plantation', 33.5397186279297, 0.585378520249848, -84.4433288574219, -1.47381411990635, 218, 13, 'PPL', 'P'),
(23369, 'Newton Ridge', 33.5875015258789, 0.586212489145206, -83.7786102294922, -1.46221259124964, 218, 13, 'PPL', 'P'),
(30666, 'Newton Stewart', 38.375, 0.669770100452824, -86.625, -1.51189146454009, 218, 19, 'PPL', 'P'),
(125561, 'Newton Upper Falls', 42.3138885498047, 0.73851667451602, -71.2200012207031, -1.24302351457565, 218, 23, 'PPL', 'P'),
(14301, 'Newton Woods', 38.7669410705566, 0.676610762607829, -75.5930633544922, -1.31934784720456, 218, 10, 'PPL', 'P'),
(23370, 'Newton Woods', 33.5855598449707, 0.586178600420335, -83.9088897705078, -1.46448639818835, 218, 13, 'PPL', 'P'),
(104656, 'Newton Woods', 38.7305603027344, 0.675975798424927, -77.0977783203125, -1.34561007766216, 218, 53, 'PPL', 'P'),
(165227, 'Newtonburg', 40.9186096191406, 0.714164463192227, -78.7608337402344, -1.37463587038293, 218, 45, 'PPL', 'P'),
(175550, 'Newtonburg', 44.0516700744629, 0.768846683801633, -87.7616729736328, -1.53173015044842, 218, 57, 'PPL', 'P'),
(56529, 'Newtonia', 36.8766708374023, 0.643619323286845, -94.1852798461914, -1.6438432402283, 218, 29, 'PPL', 'P'),
(61072, 'Newtonia', 31.0402793884277, 0.541755076066996, -91.2058334350586, -1.5918420904673, 218, 30, 'PPL', 'P'),
(156782, 'Newtons (historical)', 41.0272216796875, 0.716060101256145, -82.1500015258789, -1.43378800714495, 218, 41, 'PPL', 'P'),
(14302, 'Newtons Acres', 38.5855598449707, 0.673445063020052, -75.0761108398438, -1.31032532374748, 218, 10, 'PPL', 'P'),
(67210, 'Newtons Crossroads', 34.6875, 0.605411084285533, -78.1624984741211, -1.36419294995846, 218, 33, 'PPL', 'P'),
(144214, 'Newtons Mobile Park', 44.3025016784668, 0.77322452115956, -71.7477798461914, -1.25223498931207, 218, 36, 'PPL', 'P'),
(73692, 'Newtonsville', 39.1819381713867, 0.683853828403544, -84.0863876342773, -1.46758432032639, 218, 41, 'PPL', 'P'),
(4572, 'Newtonville', 33.545280456543, 0.585475592471581, -87.8013916015625, -1.53242337128016, 218, 2, 'PPL', 'P'),
(30665, 'Newtonville', 38.0019416809082, 0.663259004482716, -86.9433288574219, -1.51744735120621, 218, 19, 'PPL', 'P'),
(71173, 'Newtonville', 39.5588912963867, 0.690432901560476, -74.8663864135742, -1.30666494198722, 218, 37, 'PPL', 'P'),
(82594, 'Newtonville', 34.7083282470703, 0.605774605774329, -79.6383285522461, -1.3899510440217, 218, 48, 'PPL', 'P'),
(96541, 'Newtonville', 29.6519393920898, 0.517523971993774, -97.1947174072266, -1.69636783430155, 218, 51, 'PPL', 'P'),
(125563, 'Newtonville', 42.3499984741211, 0.739146911587988, -71.2041702270508, -1.24274721161255, 218, 23, 'PPL', 'P'),
(151089, 'Newtonville', 42.7244415283203, 0.745682175744988, -73.7588882446289, -1.28733545247932, 218, 40, 'PPL', 'P'),
(61073, 'Newtonville (historical)', 33.063060760498, 0.577059271057631, -89.415283203125, -1.56059109349771, 218, 30, 'PPL', 'P'),
(205107, 'Newtopia Acres', 40.6183280944824, 0.708923561904033, -111.818061828613, -1.95159334210789, 218, 52, 'PPL', 'P'),
(10804, 'Newtown', 34.3338890075684, 0.599239408196356, -91.8397216796875, -1.60290552742576, 218, 4, 'PPL', 'P'),
(23372, 'Newtown', 34.0747184753418, 0.594716029084857, -83.0449981689453, -1.44940864536076, 218, 13, 'PPL', 'P'),
(37420, 'Newtown', 38.2202796936035, 0.667069721686511, -84.4700012207031, -1.4742796404649, 218, 21, 'PPL', 'P'),
(49808, 'Newtown', 38.9055595397949, 0.679030111300111, -76.0480575561523, -1.32728899410101, 218, 25, 'PPL', 'P'),
(73693, 'Newtown', 39.124439239502, 0.682850282725775, -84.3616714477539, -1.472388929249, 218, 41, 'PPL', 'P'),
(82595, 'Newtown', 34.4066696166992, 0.600509669457297, -79.3574981689453, -1.38504962919347, 218, 48, 'PPL', 'P'),
(89435, 'Newtown', 36.4036102294922, 0.635362858117327, -84.4497222900391, -1.47392570635603, 218, 50, 'PPL', 'P'),
(104664, 'Newtown', 38.4152793884277, 0.670473108401578, -78.5983276367188, -1.371799603822, 218, 53, 'PPL', 'P'),
(110655, 'Newtown', 37.6277809143066, 0.656728667173733, -82.0858306884766, -1.43266801474852, 218, 58, 'PPL', 'P'),
(120781, 'Newtown', 40.1672210693359, 0.70105025903635, -87.769172668457, -1.53186104481599, 218, 18, 'PPL', 'P'),
(123298, 'Newtown', 40.2041702270508, 0.701695143494312, -87.1477813720703, -1.52101572075081, 218, 19, 'PPL', 'P'),
(125564, 'Newtown', 41.6716690063477, 0.72730782896204, -70.4391708374023, -1.22939545348744, 218, 23, 'PPL', 'P'),
(128263, 'Newtown', 43.4330596923828, 0.758049895847316, -70.4055633544922, -1.22880889225735, 218, 26, 'PPL', 'P'),
(139359, 'Newtown', 40.3763885498047, 0.70470092025863, -93.334716796875, -1.62899811452192, 218, 29, 'PPL', 'P'),
(145900, 'Newtown', 40.5519409179688, 0.707764887092766, -74.4608306884766, -1.29958665928395, 218, 37, 'PPL', 'P'),
(151092, 'Newtown', 40.8794403076172, 0.713480829740404, -72.5036087036133, -1.26542669145567, 218, 40, 'PPL', 'P'),
(165235, 'Newtown', 40.6505584716797, 0.709486088105285, -76.3483276367188, -1.33252969565212, 218, 45, 'PPL', 'P'),
(177315, 'Newtown', 41.413890838623, 0.722808751195488, -73.3038864135742, -1.27939417242481, 218, 8, 'PPL', 'P'),
(193817, 'Newtown', 40.6572189331055, 0.709602335086867, -122.395278930664, -2.13620060623693, 218, 6, 'PPL', 'P'),
(197145, 'Newtown', 48.482780456543, 0.846184149488234, -108.755561828613, -1.89814263376557, 218, 31, 'PPL', 'P'),
(49809, 'Newtown (historical)', 38.2552795410156, 0.667680584261548, -76.7011108398438, -1.33868692409239, 218, 25, 'PPL', 'P'),
(104665, 'Newtown (historical)', 37.1344413757324, 0.648118267895344, -76.8186111450195, -1.3407376912898, 218, 53, 'PPL', 'P'),
(117034, 'Newtown (historical)', 41.4536094665527, 0.723501972027235, -95.3361129760742, -1.66392906748579, 218, 16, 'PPL', 'P'),
(156783, 'Newtown (historical)', 40.2033309936523, 0.701680496108317, -80.908332824707, -1.41211680009054, 218, 41, 'PPL', 'P'),
(183628, 'Newtown (historical)', 37.7033309936523, 0.658047264808459, -120.190826416016, -2.09772565165245, 218, 6, 'PPL', 'P'),
(49810, 'Newtown Estates', 38.5002784729004, 0.671956622286806, -76.9375, -1.34281269325314, 218, 25, 'PPL', 'P'),
(165236, 'Newtown Grant', 40.2599983215332, 0.702669527558145, -74.9552764892578, -1.30821636648024, 218, 45, 'PPL', 'P'),
(78838, 'Newtown Heights', 39.982780456543, 0.697831163068716, -75.4127807617188, -1.31620132237663, 218, 45, 'PPL', 'P'),
(49811, 'Newtown Square', 38.9336090087891, 0.679519666887495, -76.0577774047852, -1.32745863746245, 218, 25, 'PPL', 'P'),
(78839, 'Newtown Square', 39.9866714477539, 0.697899073676513, -75.4013900756836, -1.31600251740126, 218, 45, 'PPL', 'P'),
(4573, 'Newville', 31.4216709136963, 0.548411613922135, -85.3377838134766, -1.48942530390029, 218, 2, 'PPL', 'P'),
(104668, 'Newville', 37.0127792358398, 0.645994862979196, -77.1766662597656, -1.34698693194573, 218, 53, 'PPL', 'P'),
(110656, 'Newville', 38.6786117553711, 0.675069125231809, -80.5908279418945, -1.4065752944943, 218, 58, 'PPL', 'P'),
(123299, 'Newville', 41.3486099243164, 0.721669384302125, -84.8450012207031, -1.48082462515988, 218, 19, 'PPL', 'P'),
(140580, 'Newville', 48.5586090087891, 0.847507607391949, -98.9869384765625, -1.72764799288508, 218, 34, 'PPL', 'P'),
(151093, 'Newville', 42.976390838623, 0.750079520757899, -74.8261108398438, -1.30596200061749, 218, 40, 'PPL', 'P'),
(156784, 'Newville', 40.6302795410156, 0.709132153996413, -82.3855590820313, -1.43789926207776, 218, 41, 'PPL', 'P'),
(165241, 'Newville', 40.1469383239746, 0.700696258348451, -76.6297225952148, -1.33744096417639, 218, 45, 'PPL', 'P'),
(175551, 'Newville', 42.8288917541504, 0.747505176090174, -89.0213928222656, -1.55371640945978, 218, 57, 'PPL', 'P'),
(183629, 'Newville', 39.7911109924316, 0.694485899844441, -122.527221679688, -2.13850344163152, 218, 6, 'PPL', 'P'),
(123300, 'Newville Center', 41.3141708374023, 0.721068308844094, -84.8300018310547, -1.48056283642472, 218, 19, 'PPL', 'P'),
(82596, 'Nexsen (historical)', 33.6405601501465, 0.587138536835254, -79.774169921875, -1.39232192318215, 218, 48, 'PPL', 'P'),
(156785, 'Ney', 41.3811111450195, 0.722236637614312, -84.5227813720703, -1.47520082788596, 218, 41, 'PPL', 'P'),
(23373, 'Neyami', 31.8236103057861, 0.555426779707567, -84.2152786254883, -1.46983389249918, 218, 13, 'PPL', 'P'),
(96542, 'Neylandville', 33.1994400024414, 0.579439537860917, -96.003059387207, -1.67556947829441, 218, 51, 'PPL', 'P'),
(82597, 'Neyles', 32.8250007629395, 0.572904340282944, -80.5586090087891, -1.40601296803013, 218, 48, 'PPL', 'P'),
(195385, 'Nezperce', 46.2350006103516, 0.806952990312223, -116.239723205566, -2.02876589154399, 218, 17, 'PPL', 'P'),
(42283, 'Nezpique', 30.3547191619873, 0.529789792894892, -92.6025009155273, -1.61621853655702, 218, 22, 'PPL', 'P'),
(37421, 'Niagara', 37.7208290100098, 0.658352662806464, -87.4863891601563, -1.5269255415258, 218, 21, 'PPL', 'P'),
(67211, 'Niagara', 35.207218170166, 0.61448187753737, -79.355827331543, -1.38502046757953, 218, 33, 'PPL', 'P'),
(112618, 'Niagara', 37.2550010681152, 0.650222431472615, -79.8727798461914, -1.39404299103661, 218, 53, 'PPL', 'P'),
(140581, 'Niagara', 47.9963912963867, 0.837695057197498, -97.870002746582, -1.70815378686375, 218, 34, 'PPL', 'P'),
(165243, 'Niagara', 41.7324981689453, 0.7283694981306, -75.3427810668945, -1.31497959722656, 218, 45, 'PPL', 'P'),
(175552, 'Niagara', 45.7713890075684, 0.798861441393208, -87.9947204589844, -1.53579759638129, 218, 57, 'PPL', 'P'),
(201305, 'Niagara', 44.7580604553223, 0.781175521752046, -122.334999084473, -2.1351485244483, 218, 43, 'PPL', 'P'),
(151094, 'Niagara Falls', 43.0944404602051, 0.752139875335239, -79.0569381713867, -1.37980386763628, 218, 40, 'PPL', 'P'),
(56533, 'Niangua', 37.3872184753418, 0.652530060557169, -92.8324966430664, -1.62023271926809, 218, 29, 'PPL', 'P'),
(56532, 'Niangua Junction', 37.396671295166, 0.652695043386699, -92.8447189331055, -1.62044603847141, 218, 29, 'PPL', 'P'),
(28054, 'Niantic', 39.853889465332, 0.695581590895926, -89.1661071777344, -1.55624215143761, 218, 18, 'PPL', 'P'),
(56536, 'Niantic', 39.9655609130859, 0.697530625339701, -93.456672668457, -1.63112664602317, 218, 29, 'PPL', 'P'),
(113801, 'Niantic', 41.3252792358398, 0.721262186971452, -72.1936111450195, -1.26001621338506, 218, 8, 'PPL', 'P'),
(165244, 'Niantic', 40.3788909912109, 0.704744596100508, -75.5719375610352, -1.31897913255164, 218, 45, 'PPL', 'P'),
(197146, 'Niarada', 47.8141708374023, 0.834514710223725, -114.603607177734, -2.00021027991367, 218, 31, 'PPL', 'P'),
(197147, 'Nibbe', 45.9838905334473, 0.802570292685306, -108.026672363281, -1.88542111271242, 218, 31, 'PPL', 'P'),
(123302, 'Nibbyville', 41.7138900756836, 0.728044725635665, -85.8608322143555, -1.49855422064292, 218, 19, 'PPL', 'P'),
(42284, 'Niblett', 30.1027793884277, 0.525392614329549, -92.8536071777344, -1.6206011676049, 218, 22, 'PPL', 'P'),
(42290, 'Niblett Bluff', 30.1986103057861, 0.52706517936266, -93.6797180175781, -1.63501952174659, 218, 22, 'PPL', 'P'),
(61074, 'Niblett Landing', 33.7030601501465, 0.588229367617751, -91.0377807617188, -1.58890901800074, 218, 30, 'PPL', 'P'),
(205108, 'Nibley', 41.6744384765625, 0.727356165335825, -111.832221984863, -1.95184048345705, 218, 52, 'PPL', 'P'),
(96544, 'Niblock', 31.1411094665527, 0.54351489291532, -99.3916702270508, -1.73471189451846, 218, 51, 'PPL', 'P'),
(42285, 'Nibot (historical)', 30.8899993896484, 0.539132195288404, -92.1324996948242, -1.60801546776735, 218, 22, 'PPL', 'P'),
(67212, 'Nicanor', 36.3327789306641, 0.634126618739312, -76.478889465332, -1.33480842943885, 218, 33, 'PPL', 'P'),
(183633, 'Nicasio', 38.0616683959961, 0.664301432312401, -122.69750213623, -2.14147539625, 218, 6, 'PPL', 'P'),
(183635, 'Nice', 39.1233291625977, 0.682830908228845, -122.847221374512, -2.14408848991158, 218, 6, 'PPL', 'P'),
(104671, 'Nicelytown', 37.8413887023926, 0.660456826383735, -79.7486114501953, -1.39187584369956, 218, 53, 'PPL', 'P'),
(165246, 'Nicetown', 40.0130615234375, 0.698359667387043, -75.1572189331055, -1.31174092702491, 218, 45, 'PPL', 'P'),
(165245, 'Nicetown-Tioga', 40.026668548584, 0.69859715477725, -75.1566696166992, -1.31173133964499, 218, 45, 'PPL', 'P'),
(17277, 'Niceville', 30.5166702270508, 0.532616372207362, -86.4822235107422, -1.5093995447081, 218, 12, 'PPL', 'P'),
(104670, 'Nicewood', 37.1088905334473, 0.64767232157081, -76.5341720581055, -1.33577329270179, 218, 53, 'PPL', 'P'),
(4574, 'Nichburg', 31.4794406890869, 0.549419886710839, -87.1366729736328, -1.52082184262345, 218, 2, 'PPL', 'P'),
(125565, 'Nichewaug', 42.4375, 0.740674101315094, -72.2041702270508, -1.2602005041325, 218, 23, 'PPL', 'P'),
(165247, 'Nichola', 40.8727798461914, 0.713364582758822, -79.6852798461914, -1.39077049868912, 218, 45, 'PPL', 'P'),
(42286, 'Nicholas', 29.9638900756836, 0.522968538526332, -91.8788909912109, -1.60358916087759, 218, 22, 'PPL', 'P'),
(96543, 'Nicholas', 30.7822208404541, 0.53725110474194, -96.5944366455078, -1.68589095857318, 218, 51, 'PPL', 'P'),
(104672, 'Nicholas', 37.7658309936523, 0.659138095590955, -78.4674987792969, -1.36951620950336, 218, 53, 'PPL', 'P'),
(104674, 'Nicholas Manor', 37.2383308410645, 0.649931481123524, -80.4513931274414, -1.40414169789019, 218, 53, 'PPL', 'P'),
(23375, 'Nicholasville', 33.8680610656738, 0.591109176862508, -83.7547225952148, -1.46179567338099, 218, 13, 'PPL', 'P'),
(37422, 'Nicholasville', 37.8805618286133, 0.661140526414586, -84.5730590820313, -1.47607833946514, 218, 21, 'PPL', 'P'),
(23376, 'Nicholasville (historical)', 31.1263904571533, 0.543257997738668, -84.6986083984375, -1.47826958841006, 218, 13, 'PPL', 'P'),
(195386, 'Nicholia', 44.3600006103516, 0.774228066837329, -113.010833740234, -1.97241113919099, 218, 17, 'PPL', 'P'),
(197148, 'Nicholia (historical)', 44.5152816772461, 0.776938232720648, -112.886108398438, -1.97023427131596, 218, 31, 'PPL', 'P'),
(42287, 'Nicholle (historical)', 30.0419406890869, 0.524330778713421, -90.8274993896484, -1.58523891570251, 218, 22, 'PPL', 'P'),
(23377, 'Nicholls', 31.517219543457, 0.550079252107229, -82.6350021362305, -1.44225286466977, 218, 13, 'PPL', 'P'),
(42288, 'Nicholls (historical)', 29.4236106872559, 0.513538884317606, -89.5997161865234, -1.56381005630729, 218, 22, 'PPL', 'P'),
(17278, 'Nichols', 27.8899993896484, 0.486772317728574, -82.0316696166992, -1.4317227257196, 218, 12, 'PPL', 'P'),
(37423, 'Nichols', 36.6936111450195, 0.640424328927077, -88.8697204589844, -1.55106922733624, 218, 21, 'PPL', 'P'),
(49812, 'Nichols', 38.7230606079102, 0.675844904057349, -75.8122177124023, -1.32317281232018, 218, 25, 'PPL', 'P'),
(56537, 'Nichols', 37.2177810668945, 0.649572819903718, -93.3619384765625, -1.62947322246039, 218, 29, 'PPL', 'P'),
(61075, 'Nichols', 33.3177795410156, 0.581504952444328, -90.4127807617188, -1.57800071017578, 218, 30, 'PPL', 'P'),
(76712, 'Nichols', 36.5200004577637, 0.637394250817812, -96.1377792358398, -1.67792078322084, 218, 42, 'PPL', 'P'),
(82599, 'Nichols', 34.2336082458496, 0.597489178727956, -79.1488876342773, -1.38140868850917, 218, 48, 'PPL', 'P'),
(113802, 'Nichols', 41.2408294677734, 0.719788260466147, -73.1616668701172, -1.2769119731308, 218, 8, 'PPL', 'P'),
(117035, 'Nichols', 41.4811096191406, 0.723981940234695, -91.307502746582, -1.59361655470162, 218, 16, 'PPL', 'P'),
(137117, 'Nichols', 46.3269386291504, 0.808557611448023, -93.7847213745117, -1.63685217605073, 218, 28, 'PPL', 'P'),
(151099, 'Nichols', 42.021671295166, 0.733416521291437, -76.3672180175781, -1.33285939499508, 218, 40, 'PPL', 'P'),
(175559, 'Nichols', 44.563060760498, 0.777772135036979, -88.4633331298828, -1.54397643040504, 218, 57, 'PPL', 'P'),
(183636, 'Nichols', 38.041389465332, 0.663947498203529, -121.986938476563, -2.12907372084377, 218, 6, 'PPL', 'P'),
(197149, 'Nichols', 46.2638893127441, 0.807457193285602, -106.816108703613, -1.86429279104622, 218, 31, 'PPL', 'P'),
(4576, 'Nichols (historical)', 32.8430595397949, 0.573219525397955, -87.2522201538086, -1.52283852135891, 218, 2, 'PPL', 'P'),
(42289, 'Nichols (historical)', 32.4491691589355, 0.566344841360025, -93.8741683959961, -1.63841332108174, 218, 22, 'PPL', 'P'),
(169513, 'Nichols Corner', 41.6477813720703, 0.726890911093389, -71.4749984741211, -1.24747405623134, 218, 47, 'PPL', 'P'),
(151100, 'Nichols Corners', 42.9452781677246, 0.749536502211632, -76.225830078125, -1.33039170992901, 218, 40, 'PPL', 'P'),
(104673, 'Nichols Estates', 37.2186088562012, 0.649587267552631, -80.0208282470703, -1.39662692308426, 218, 53, 'PPL', 'P'),
(139366, 'Nichols Grove', 40.0194396972656, 0.698470987520608, -95.084716796875, -1.65954137643183, 218, 29, 'PPL', 'P'),
(76713, 'Nichols Hills', 35.5508308410645, 0.62047904999612, -97.5486068725586, -1.70254437065972, 218, 42, 'PPL', 'P'),
(4577, 'Nichols Landing', 31.7627792358398, 0.554365077249494, -88.1125030517578, -1.53785329042673, 218, 2, 'PPL', 'P'),
(151101, 'Nichols Run', 42.0033302307129, 0.733096409328409, -78.5208282470703, -1.37044698430434, 218, 40, 'PPL', 'P'),
(175556, 'Nichols Shore Acres', 44.0972213745117, 0.769641703966049, -88.6397171020508, -1.54705491146711, 218, 57, 'PPL', 'P'),
(23378, 'Nicholson', 34.1138916015625, 0.595399729115707, -83.4316711425781, -1.45615736187913, 218, 13, 'PPL', 'P'),
(37425, 'Nicholson', 38.9055595397949, 0.679030111300111, -84.5441665649414, -1.47557406991273, 218, 21, 'PPL', 'P'),
(61076, 'Nicholson', 30.4769401550293, 0.531922951638532, -89.6936111450195, -1.56544883248407, 218, 30, 'PPL', 'P'),
(132290, 'Nicholson', 42.7769393920898, 0.746598436318029, -84.123893737793, -1.46823892532233, 218, 27, 'PPL', 'P'),
(140584, 'Nicholson', 46.1091690063477, 0.804756814519289, -97.8677825927734, -1.70811503786989, 218, 34, 'PPL', 'P'),
(165248, 'Nicholson', 41.6261100769043, 0.72651267563957, -75.7808303833008, -1.32262500008396, 218, 45, 'PPL', 'P'),
(175558, 'Nicholson', 44.5319404602051, 0.777228983332657, -88.8186111450195, -1.55017720152912, 218, 57, 'PPL', 'P'),
(4578, 'Nicholson (historical)', 34.3105583190918, 0.598832210865683, -85.9155578613281, -1.49950936336787, 218, 2, 'PPL', 'P'),
(89436, 'Nicholson Heights', 35.8291702270508, 0.62533698871956, -85.0888900756836, -1.48508128868821, 218, 50, 'PPL', 'P'),
(89437, 'Nicholson Springs (historical)', 35.6616706848145, 0.622413570211953, -85.8841705322266, -1.49896155113164, 218, 50, 'PPL', 'P'),
(82602, 'Nicholson Village', 33.5544395446777, 0.585635448716013, -81.6544418334961, -1.4251388588727, 218, 48, 'PPL', 'P'),
(23379, 'Nicholsonville', 31.9591693878174, 0.557792732019994, -81.1377792358398, -1.41612139542169, 218, 13, 'PPL', 'P'),
(4579, 'Nicholsville', 32.0080604553223, 0.558646042122769, -87.9019393920898, -1.53417826128047, 218, 2, 'PPL', 'P'),
(73695, 'Nicholsville', 38.9583282470703, 0.679951098984088, -84.1694412231445, -1.46903387890772, 218, 41, 'PPL', 'P'),
(132291, 'Nicholsville', 42.0436096191406, 0.733799417277163, -85.896110534668, -1.49916994348694, 218, 27, 'PPL', 'P'),
(151103, 'Nicholsville', 43.2730598449707, 0.755257371707286, -75.9641723632813, -1.32582492129174, 218, 40, 'PPL', 'P'),
(67213, 'Nicholsville (historical)', 35.2030601501465, 0.614409306397666, -81.6650009155273, -1.42532314962014, 218, 33, 'PPL', 'P'),
(82600, 'Nicholtown', 34.8402786254883, 0.608077574326975, -82.3713912963867, -1.43765198757055, 218, 48, 'PPL', 'P'),
(151104, 'Nicholville', 44.6972198486328, 0.780113652846404, -74.6597213745117, -1.30305795660682, 218, 40, 'PPL', 'P'),
(37426, 'Nick', 37.1297187805176, 0.648035843059606, -86.3111114501953, -1.50641307586169, 218, 21, 'PPL', 'P'),
(96545, 'Nick Garza Colonia', 26.2329998016357, 0.457852219213563, -98.3679962158203, -1.71684541255539, 218, 51, 'PPL', 'P'),
(10806, 'Nick Springs', 33.1983299255371, 0.579420163363987, -92.5602798461914, -1.61548163988339, 218, 4, 'PPL', 'P'),
(23380, 'Nickajack (historical)', 33.836669921875, 0.590561298047251, -84.5422210693359, -1.47554011460883, 218, 13, 'PPL', 'P'),
(89438, 'Nickajack (historical)', 34.9958305358887, 0.610792467321229, -85.6083297729492, -1.49414722167105, 218, 50, 'PPL', 'P'),
(42296, 'Nickel', 31.8091697692871, 0.555174744799905, -92.0538864135742, -1.60664340717374, 218, 22, 'PPL', 'P'),
(96547, 'Nickel', 29.5552806854248, 0.515836959311749, -97.2186126708984, -1.69678488532826, 218, 51, 'PPL', 'P'),
(191940, 'Nickel Creek Station', 31.9216709136963, 0.557138260182107, -104.746109008789, -1.82816448085626, 218, 51, 'PPL', 'P'),
(37427, 'Nickell', 37.833610534668, 0.660321071747168, -83.3261108398438, -1.45431498703701, 218, 21, 'PPL', 'P'),
(110659, 'Nickells Mill', 37.6902809143066, 0.65781949795623, -80.5052795410156, -1.40508219322915, 218, 58, 'PPL', 'P'),
(56538, 'Nickellton', 39.9266700744629, 0.696851852156867, -92.3072204589844, -1.61106492037355, 218, 29, 'PPL', 'P'),
(156789, 'Nickelplate (historical)', 41.2641716003418, 0.720195657533902, -82.1577835083008, -1.43392382836055, 218, 41, 'PPL', 'P'),
(209637, 'Nickelson Place', 43.5361099243164, 0.759848461689501, -108.053062438965, -1.88588170642295, 218, 59, 'PPL', 'P'),
(23381, 'Nickelsville', 34.6016693115234, 0.603913056172363, -84.866943359375, -1.48120758772463, 218, 13, 'PPL', 'P'),
(104675, 'Nickelsville', 36.7527809143066, 0.641457036218783, -82.4147186279297, -1.43840819216208, 218, 53, 'PPL', 'P'),
(56539, 'Nickelville', 37.2400016784668, 0.64996064273746, -93.7005615234375, -1.6353833095515, 218, 29, 'PPL', 'P'),
(33427, 'Nickerson', 38.1472206115723, 0.665794600156581, -98.0833282470703, -1.71187701922574, 218, 20, 'PPL', 'P'),
(137119, 'Nickerson', 46.410831451416, 0.810021817415348, -92.4991683959961, -1.61441504386681, 218, 28, 'PPL', 'P'),
(142512, 'Nickerson', 41.5344390869141, 0.724912715035678, -96.4700012207031, -1.68371915070422, 218, 35, 'PPL', 'P'),
(128264, 'Nickerson Mills', 44.5394401550293, 0.777359877700235, -69.0388870239258, -1.20495589047989, 218, 26, 'PPL', 'P'),
(10807, 'Nickey (historical)', 34.9888916015625, 0.610671360070658, -90.4194412231445, -1.57811695715736, 218, 4, 'PPL', 'P'),
(96546, 'Nickleberry', 33.146671295166, 0.57851855017694, -94.5199966430664, -1.6496851503955, 218, 51, 'PPL', 'P'),
(23382, 'Nicklesville', 32.6861114501953, 0.570480264479727, -83.085563659668, -1.45011664673656, 218, 13, 'PPL', 'P'),
(89439, 'Nickletown', 35.0908317565918, 0.612450551415912, -85.5944366455078, -1.4939047408538, 218, 50, 'PPL', 'P'),
(23383, 'Nickleville', 30.8055591583252, 0.537658435230668, -84.3352813720703, -1.47192833553847, 218, 13, 'PPL', 'P'),
(165254, 'Nickleville', 41.2750015258789, 0.72038467539227, -79.6477813720703, -1.39011602685123, 218, 45, 'PPL', 'P'),
(165251, 'Nicklin', 41.3983306884766, 0.722537175343327, -79.8855590820313, -1.3942660307779, 218, 45, 'PPL', 'P'),
(183638, 'Nicklin', 33.9436111450195, 0.592427774497233, -117.013328552246, -2.04226785195458, 218, 6, 'PPL', 'P'),
(42292, 'Nicks (historical)', 31.1069393157959, 0.542918511278711, -92.0630569458008, -1.60680346315526, 218, 22, 'PPL', 'P'),
(183639, 'Nicks Cove', 38.1997184753418, 0.666710860729623, -122.919998168945, -2.1453586845935, 218, 6, 'PPL', 'P'),
(178717, 'Nicksville', 31.4383296966553, 0.548702364534145, -110.248329162598, -1.92419633870981, 218, 5, 'PPL', 'P'),
(165252, 'Nicktown', 40.6133308410645, 0.708836343378333, -78.8036117553711, -1.37538248759453, 218, 45, 'PPL', 'P'),
(23384, 'Nickville', 34.1133308410645, 0.595389941998701, -83.0016708374023, -1.44865244076923, 218, 13, 'PPL', 'P'),
(197150, 'Nickwall', 48.0491714477539, 0.838616244618556, -105.30638885498, -1.83794320890487, 218, 31, 'PPL', 'P'),
(33429, 'Nicodemus', 39.3944396972656, 0.687562679695643, -99.6166687011719, -1.73863885870383, 218, 20, 'PPL', 'P'),
(78847, 'Nicodemus', 39.788330078125, 0.694437363733574, -77.601936340332, -1.35440929506183, 218, 45, 'PPL', 'P'),
(49813, 'Nicodemus Heights', 39.4861106872559, 0.689162640299536, -76.9927825927734, -1.34377755651607, 218, 25, 'PPL', 'P'),
(183640, 'Nicolaus', 38.9033317565918, 0.678991229148196, -121.576667785645, -2.12191314646282, 218, 6, 'PPL', 'P'),
(110660, 'Nicolette', 39.2102813720703, 0.684348510576027, -81.5133285522461, -1.4226759674966, 218, 58, 'PPL', 'P'),
(205109, 'Nicoletti Drive', 40.6194381713867, 0.708942936400963, -111.888061523438, -1.95281506725797, 218, 52, 'PPL', 'P'),
(128265, 'Nicolin (historical)', 44.6211090087891, 0.778785268094673, -68.5149993896484, -1.19581232635127, 218, 26, 'PPL', 'P'),
(137121, 'Nicollet', 44.2761116027832, 0.772763927449031, -94.1872177124023, -1.64387706237414, 218, 28, 'PPL', 'P'),
(137123, 'Nicollet Landing', 44.2827796936035, 0.772880307588667, -94.2161102294922, -1.64438133192655, 218, 28, 'PPL', 'P'),
(137126, 'Nicols', 44.8222198486328, 0.782295314411397, -93.2202835083008, -1.62700087686242, 218, 28, 'PPL', 'P'),
(137127, 'Nicolville', 43.6747207641602, 0.762267677223729, -92.878059387207, -1.62102793916959, 218, 28, 'PPL', 'P'),
(76714, 'Nicoma Park', 35.4911117553711, 0.61943675532449, -97.3227767944336, -1.6986028922464, 218, 42, 'PPL', 'P'),
(76715, 'Nicut', 35.5838890075684, 0.621056023846285, -94.5591735839844, -1.65036891700537, 218, 42, 'PPL', 'P'),
(110661, 'Nicut', 38.7130584716797, 0.675670333847895, -81.022216796875, -1.41410445037012, 218, 58, 'PPL', 'P'),
(76716, 'Nida', 34.1430587768555, 0.595908792358076, -96.4986114501953, -1.68421849340861, 218, 42, 'PPL', 'P'),
(110662, 'Nida', 38.4619407653809, 0.671287503062924, -79.8769378662109, -1.39411556217631, 218, 58, 'PPL', 'P'),
(139360, 'Nida (historical)', 40.0102806091309, 0.698311131276176, -94.8919372558594, -1.65617673871062, 218, 29, 'PPL', 'P'),
(104676, 'Niday', 37.2547187805176, 0.650217504624598, -81.029167175293, -1.41422575735778, 218, 53, 'PPL', 'P'),
(96548, 'Niederwald', 30.0091705322266, 0.523758831579813, -97.727783203125, -1.70567158756974, 218, 51, 'PPL', 'P'),
(183641, 'Nielsburg', 38.957218170166, 0.679931724487158, -121.032218933105, -2.11241072137731, 218, 6, 'PPL', 'P'),
(193818, 'Nielson Place', 40.0069389343262, 0.698252808048303, -123.343330383301, -2.15274722556376, 218, 6, 'PPL', 'P'),
(137129, 'Nielsville', 47.5275001525879, 0.829511362904766, -96.8147201538086, -1.68973563108087, 218, 28, 'PPL', 'P'),
(10808, 'Niemeyer (historical)', 34.7577781677246, 0.606637669704596, -92.2294387817383, -1.60970737400788, 218, 4, 'PPL', 'P'),
(104677, 'Nieswanders Fort', 39.0466690063477, 0.681492936097189, -78.2966690063477, -1.36653466750496, 218, 53, 'PPL', 'P'),
(151105, 'Niets Crest', 42.1180610656738, 0.73509884015204, -79.3894424438477, -1.38560716196768, 218, 40, 'PPL', 'P'),
(37428, 'Nigh', 37.4305610656738, 0.653286531464806, -82.2699966430664, -1.43588231702619, 218, 21, 'PPL', 'P'),
(187108, 'Nighthawk', 39.3547210693359, 0.686869458863896, -105.168891906738, -1.8355434344466, 218, 7, 'PPL', 'P'),
(208245, 'Nighthawk', 48.9666709899902, 0.854629632516121, -119.640830993652, -2.08812642066131, 218, 56, 'PPL', 'P'),
(49814, 'Nightingale', 39.4130592346191, 0.68788765192766, -77.3041687011719, -1.3492122693526, 218, 25, 'PPL', 'P'),
(200096, 'Nightingale', 40.0108299255371, 0.6983207186561, -119.224998474121, -2.08086877405863, 218, 39, 'PPL', 'P'),
(212031, 'Nightmute', 60.4794387817383, 1.05556533649968, -164.723892211914, -2.87497427579815, 218, 1, 'PPL', 'P'),
(96549, 'Nigton', 31.2213897705078, 0.544916048543838, -94.9075012207031, -1.65644838114181, 218, 51, 'PPL', 'P'),
(202424, 'Nihart', 43.6563911437988, 0.761947764997783, -103.590560913086, -1.80799636192109, 218, 49, 'PPL', 'P'),
(113322, 'Nihil', 40.4300003051758, 0.70563662190763, -79.4905624389648, -1.38737203882207, 218, 45, 'PPL', 'P'),
(37429, 'Nihizertown', 37.9883308410645, 0.663021450513481, -84.3633270263672, -1.47241782454682, 218, 21, 'PPL', 'P'),
(49815, 'Nikep', 39.5505599975586, 0.690287492964958, -78.9974975585938, -1.37876643323364, 218, 25, 'PPL', 'P'),
(212033, 'Nikishka', 60.7027816772461, 1.05946340538723, -151.402786254883, -2.64247711684092, 218, 1, 'PPL', 'P'),
(212032, 'Nikiski', 60.6902809143066, 1.05924522591493, -151.28889465332, -2.64048933340328, 218, 1, 'PPL', 'P'),
(212034, 'Nikolaevsk', 59.811939239502, 1.0439152717321, -151.610565185547, -2.64610354329728, 218, 1, 'PPL', 'P'),
(212035, 'Nikolai', 63.0133285522461, 1.09979005587765, -154.375, -2.69435203276625, 218, 1, 'PPL', 'P'),
(212036, 'Nikolski', 52.938060760498, 0.923943459891504, -168.867782592773, -2.94729880678586, 218, 1, 'PPL', 'P'),
(78842, 'Nilan', 39.732780456543, 0.693467839938731, -79.8841705322266, -1.39424179601198, 218, 45, 'PPL', 'P'),
(183643, 'Niland', 33.2400016784668, 0.580147472657687, -115.518058776855, -2.01617047116846, 218, 6, 'PPL', 'P'),
(61077, 'Nile', 32.9458312988281, 0.575013230971151, -89.5166702270508, -1.56236063088402, 218, 30, 'PPL', 'P'),
(110665, 'Nile', 38.3044395446777, 0.668538588185744, -80.7352828979492, -1.40909650909828, 218, 58, 'PPL', 'P'),
(112900, 'Nile', 37.3600006103516, 0.652055019197726, -91.6658325195313, -1.59987058904751, 218, 29, 'PPL', 'P'),
(151106, 'Nile', 42.1780586242676, 0.736145995092659, -78.1458282470703, -1.36390199960937, 218, 40, 'PPL', 'P'),
(208246, 'Nile', 46.8208312988281, 0.817177664685364, -120.938331604004, -2.11077207835858, 218, 56, 'PPL', 'P'),
(17280, 'Niles', 29.7869396209717, 0.519880170478708, -85.274169921875, -1.48831503204183, 218, 12, 'PPL', 'P'),
(33431, 'Niles', 38.9694404602051, 0.680145043690473, -97.4625015258789, -1.70104154885658, 218, 20, 'PPL', 'P'),
(61078, 'Niles', 33.855281829834, 0.590886137121214, -90.9572219848633, -1.58750300210324, 218, 30, 'PPL', 'P'),
(76717, 'Niles', 35.434440612793, 0.618447657295634, -98.2544403076172, -1.71486348807215, 218, 42, 'PPL', 'P'),
(120784, 'Niles', 42.0188903808594, 0.73336798518057, -87.8027801513672, -1.53244760604608, 218, 18, 'PPL', 'P'),
(132292, 'Niles', 41.829719543457, 0.730066331219144, -86.2541732788086, -1.50541931730092, 218, 27, 'PPL', 'P'),
(140585, 'Niles', 48.2811088562012, 0.842664316054504, -99.3488922119141, -1.73396527730685, 218, 34, 'PPL', 'P'),
(151107, 'Niles', 42.8375015258789, 0.747655444954682, -76.4138870239258, -1.33367392281448, 218, 40, 'PPL', 'P'),
(156786, 'Niles', 41.1827812194824, 0.718775127408454, -80.7655563354492, -1.40962488025855, 218, 41, 'PPL', 'P'),
(165253, 'Niles', 41.3977813720703, 0.722527587963403, -79.9150009155273, -1.39477988771024, 218, 45, 'PPL', 'P'),
(156787, 'Niles Beach', 41.6863899230957, 0.727564757428206, -83.370002746582, -1.45508104532457, 218, 41, 'PPL', 'P'),
(183644, 'Niles District', 37.5788917541504, 0.655875390360472, -121.976669311523, -2.12889449010241, 218, 6, 'PPL', 'P'),
(156788, 'Niles Junction', 41.1711082458496, 0.718571395585063, -80.8033294677734, -1.4102841457864, 218, 41, 'PPL', 'P'),
(183645, 'Niles Junction', 37.5763893127441, 0.655831714518594, -121.970283508301, -2.12878303681079, 218, 6, 'PPL', 'P'),
(165255, 'Niles Valley', 41.8250007629395, 0.729983972962434, -77.2877807617188, -1.34892624585152, 218, 45, 'PPL', 'P'),
(117037, 'Nilesville', 43.1405601501465, 0.752944815774715, -92.6133270263672, -1.61640748783636, 218, 16, 'PPL', 'P'),
(212037, 'Nililak', 62.589168548584, 1.09238706725847, -164.785827636719, -2.87605525288461, 218, 1, 'PPL', 'P'),
(208247, 'Nilles Corner', 48.0055618286133, 0.837855113179012, -119.406936645508, -2.08404419418438, 218, 56, 'PPL', 'P'),
(28056, 'Nilwood', 39.3980598449707, 0.687625863192506, -89.8086090087891, -1.56745592383961, 218, 18, 'PPL', 'P'),
(142514, 'Nim City', 40.0438919067383, 0.698897759085293, -95.8694381713867, -1.67323734812783, 218, 35, 'PPL', 'P'),
(23385, 'Nimblewill', 34.5633316040039, 0.603243936948481, -84.1402816772461, -1.4685249488234, 218, 13, 'PPL', 'P'),
(142515, 'Nimburg', 41.3652801513672, 0.721960334651216, -96.9469375610352, -1.69204326016542, 218, 35, 'PPL', 'P'),
(183646, 'Nimbus', 38.6291694641113, 0.674206194459596, -121.214172363281, -2.11558640781917, 218, 6, 'PPL', 'P'),
(104681, 'Nimcock (historical)', 37.7825012207031, 0.659429045940046, -76.6938934326172, -1.33856095657283, 218, 53, 'PPL', 'P'),
(110663, 'Nimitz', 37.646110534668, 0.657048579399679, -80.9602813720703, -1.41302347328366, 218, 58, 'PPL', 'P'),
(104678, 'Nimitz Trailer Park', 37.2527809143066, 0.650183682478754, -77.3180618286133, -1.34945475016985, 218, 53, 'PPL', 'P'),
(10809, 'Nimmo', 35.1847190856934, 0.614089194434638, -91.4736099243164, -1.59651567186428, 218, 4, 'PPL', 'P'),
(104679, 'Nimmo', 36.7597198486328, 0.641578143469354, -76.0166702270508, -1.32674118186478, 218, 53, 'PPL', 'P'),
(10810, 'Nimmons', 36.3066711425781, 0.6336709518768, -90.0944366455078, -1.57244455719355, 218, 4, 'PPL', 'P'),
(82601, 'Nimmons', 34.9900016784668, 0.610690734567588, -82.8386077880859, -1.44580645367032, 218, 48, 'PPL', 'P'),
(10811, 'Nimrod', 34.959171295166, 0.610152642869337, -93.0763931274414, -1.62448951595447, 218, 4, 'PPL', 'P'),
(96551, 'Nimrod', 30.3138904571533, 0.529077197566215, -95.1055603027344, -1.65990516423673, 218, 51, 'PPL', 'P'),
(137132, 'Nimrod', 46.6388893127441, 0.814002177980581, -94.8805618286133, -1.65597820005135, 218, 28, 'PPL', 'P'),
(197152, 'Nimrod', 48.2388916015625, 0.841927485959906, -113.567497253418, -1.98212675032176, 218, 31, 'PPL', 'P'),
(201306, 'Nimrod', 44.1138916015625, 0.76993265431514, -122.422500610352, -2.1366757141754, 218, 43, 'PPL', 'P'),
(67214, 'Nims', 35.309440612793, 0.616265995730642, -81.0305633544922, -1.41425012528175, 218, 33, 'PPL', 'P'),
(183647, 'Nimshew', 39.8436088562012, 0.695402160417482, -121.618057250977, -2.1226355289085, 218, 6, 'PPL', 'P'),
(37430, 'Nina', 37.663890838623, 0.6573589042457, -84.4663925170898, -1.47421665670512, 218, 21, 'PPL', 'P'),
(110664, 'Nina', 39.2405586242676, 0.684876948315326, -80.6361083984375, -1.40736558754779, 218, 58, 'PPL', 'P'),
(96552, 'Nina Colonia', 26.2810001373291, 0.458689983113475, -98.5810012817383, -1.72056305227908, 218, 51, 'PPL', 'P'),
(42293, 'Nina Station', 30.3050003051758, 0.528922035143204, -91.8411102294922, -1.60292976219168, 218, 22, 'PPL', 'P'),
(187109, 'Ninaview', 37.6438903808594, 0.657009830405818, -103.240280151367, -1.80188280932271, 218, 7, 'PPL', 'P'),
(139361, 'Nind', 40.0705604553223, 0.699363213064812, -92.7677764892578, -1.61910313949173, 218, 29, 'PPL', 'P'),
(104680, 'Ninde', 38.271110534668, 0.667956887224644, -77.0563888549805, -1.34488769521647, 218, 53, 'PPL', 'P'),
(156791, 'Nindeville (historical)', 41.1358299255371, 0.717955672741036, -84.7852783203125, -1.47978226390922, 218, 41, 'PPL', 'P'),
(125566, 'Nine Acre Corner', 42.4291687011719, 0.740528692719575, -71.3766708374023, -1.24575791522489, 218, 23, 'PPL', 'P'),
(42294, 'Nine Forks', 32.5900001525879, 0.568802805888113, -93.2044372558594, -1.62672430758321, 218, 22, 'PPL', 'P'),
(17281, 'Nine Mile', 29.7166690826416, 0.518653718217699, -85.1213912963867, -1.48564854200039, 218, 12, 'PPL', 'P'),
(123304, 'Nine Mile', 40.9749984741211, 0.715148634373066, -85.2249984741211, -1.48745682838056, 218, 19, 'PPL', 'P'),
(132295, 'Nine Mile', 43.8766708374023, 0.765792370926448, -84.0652770996094, -1.46721587198957, 218, 27, 'PPL', 'P'),
(198673, 'Nine Mile Corner', 48.8069381713867, 0.851841768907999, -102.086936950684, -1.78175317306529, 218, 34, 'PPL', 'P'),
(208248, 'Nine Mile Falls', 47.7758293151855, 0.833845524420816, -117.544998168945, -2.0515472372988, 218, 56, 'PPL', 'P'),
(165256, 'Nine Row', 40.5441703796387, 0.707629265614254, -78.7977828979492, -1.37528075484089, 218, 45, 'PPL', 'P'),
(82603, 'Nine Times', 34.9150009155273, 0.609381724312787, -82.8441696166992, -1.44590352589205, 218, 48, 'PPL', 'P'),
(197153, 'Nine-mile', 45.9052810668945, 0.801198298670725, -112.465560913086, -1.96289433303559, 218, 31, 'PPL', 'P'),
(73697, 'Ninemile', 39.0394401550293, 0.681366768840547, -84.2977828979492, -1.47127386370058, 218, 41, 'PPL', 'P'),
(89440, 'Ninemile', 35.6997184753418, 0.623077629429764, -85.0955581665039, -1.48519766882784, 218, 50, 'PPL', 'P'),
(197154, 'Ninemile', 47.0200004577637, 0.820653822277217, -114.408332824707, -1.99680209950864, 218, 31, 'PPL', 'P'),
(193819, 'Ninemile (historical)', 40.2872200012207, 0.703144635496615, -122.277496337891, -2.1341449121915, 218, 6, 'PPL', 'P'),
(17282, 'Ninemile Bend', 26.6774997711182, 0.465610207206046, -80.5411071777344, -1.4057075034531, 218, 12, 'PPL', 'P'),
(194344, 'Ninemile Corner', 40.1161117553711, 0.700158233229228, -103.792221069336, -1.81151599561774, 218, 7, 'PPL', 'P'),
(190549, 'Ninemile Rocks', 37.7825012207031, 0.659429045940046, -114.224716186523, -1.9935973846109, 218, 39, 'PPL', 'P'),
(78843, 'Ninepoints', 39.913330078125, 0.696619025298567, -76.0455627441406, -1.32724545141719, 218, 45, 'PPL', 'P'),
(37431, 'Nineteen', 37.3274993896484, 0.651487765885539, -86.9466705322266, -1.51750567443408, 218, 21, 'PPL', 'P'),
(191941, 'Nineteen Mile Crossing', 29.3977794647217, 0.513088044434569, -100.001670837402, -1.74535841360827, 218, 51, 'PPL', 'P'),
(82604, 'Ninety Six', 34.1749992370605, 0.596466258553257, -82.024169921875, -1.43159183135202, 218, 48, 'PPL', 'P'),
(151109, 'Ninety Six Corners', 43.3411102294922, 0.756445074974434, -75.0941696166992, -1.31064050886249, 218, 40, 'PPL', 'P'),
(187110, 'Ninetyfour', 39.8274993896484, 0.695120997185397, -105.635833740234, -1.84369310685641, 218, 7, 'PPL', 'P'),
(183648, 'Ninetynine Oaks', 34.475830078125, 0.601716747221375, -118.615829467773, -2.07023676919676, 218, 6, 'PPL', 'P'),
(10812, 'Ninetysix Corner', 35.023609161377, 0.611277295797678, -90.3375015258789, -1.57668683965199, 218, 4, 'PPL', 'P'),
(37433, 'Ninevah', 38.0825004577637, 0.664665020380224, -84.8788909912109, -1.48141611323798, 218, 21, 'PPL', 'P'),
(113803, 'Ninevah (historical)', 41.3569412231445, 0.721814792897643, -72.6119384765625, -1.26731740267157, 218, 8, 'PPL', 'P'),
(30667, 'Nineveh', 39.3622207641602, 0.687000353231473, -86.084716796875, -1.50246174375234, 218, 19, 'PPL', 'P'),
(96553, 'Nineveh', 31.3833293914795, 0.547742428119226, -95.8058319091797, -1.67212720942743, 218, 51, 'PPL', 'P'),
(104682, 'Nineveh', 39.0158309936523, 0.680954711240884, -78.165283203125, -1.36424155264835, 218, 53, 'PPL', 'P'),
(139362, 'Nineveh', 40.274169921875, 0.702916868644386, -92.6944427490234, -1.61782322427184, 218, 29, 'PPL', 'P'),
(151110, 'Nineveh', 42.1941719055176, 0.736427224903771, -75.602783203125, -1.319517490566, 218, 40, 'PPL', 'P'),
(156792, 'Nineveh', 40.0488891601563, 0.698984977610993, -84.545280456543, -1.47559351098869, 218, 41, 'PPL', 'P'),
(165257, 'Nineveh', 41.264720916748, 0.720205244913826, -79.601936340332, -1.38931588010172, 218, 45, 'PPL', 'P'),
(151111, 'Nineveh Junction', 42.2069396972656, 0.736650064907984, -75.5936126708984, -1.31935743458448, 218, 40, 'PPL', 'P'),
(212038, 'Ninilchik', 60.0513916015625, 1.04809450385174, -151.668884277344, -2.64712140346591, 218, 1, 'PPL', 'P'),
(137134, 'Nininger', 44.7691688537598, 0.781369399879404, -92.9019393920898, -1.62144472388019, 218, 28, 'PPL', 'P'),
(76718, 'Ninnekah', 34.9477806091309, 0.609953837893963, -97.9236068725586, -1.70908935535469, 218, 42, 'PPL', 'P'),
(56542, 'Ninnescah Park', 38.1883316040039, 0.666512122333276, -93.6147232055664, -1.63388514828027, 218, 29, 'PPL', 'P'),
(42295, 'Ninock', 32.2466697692871, 0.56281056027738, -93.4569396972656, -1.63113130655508, 218, 22, 'PPL', 'P'),
(183649, 'Ninth Street Junction', 34.0202789306641, 0.593765879786944, -118.219718933105, -2.06332333616497, 218, 6, 'PPL', 'P'),
(151112, 'Niobe', 42.0125007629395, 0.733256465309923, -79.4497222900391, -1.38665924375631, 218, 40, 'PPL', 'P'),
(198674, 'Niobe', 48.6888885498047, 0.849781414330659, -102.215278625488, -1.78399315785815, 218, 34, 'PPL', 'P'),
(142517, 'Niobrara', 42.7547187805176, 0.746210613484287, -98.0283279418945, -1.71091708281082, 218, 35, 'PPL', 'P'),
(73699, 'Nioga (historical)', 39.7827796936035, 0.694340491248922, -83.3188934326172, -1.45418901951745, 218, 41, 'PPL', 'P'),
(89441, 'Niota', 35.5133285522461, 0.619824511579205, -84.545280456543, -1.47559351098869, 218, 50, 'PPL', 'P'),
(120786, 'Niota', 40.6175003051758, 0.708909114255119, -91.2877807617188, -1.59327234113073, 218, 18, 'PPL', 'P'),
(33436, 'Niotaze', 37.0736083984375, 0.647056532147756, -96.0133285522461, -1.67574870903577, 218, 20, 'PPL', 'P'),
(110666, 'Nipetown', 39.5313911437988, 0.689952933353017, -77.9274978637695, -1.36009141556363, 218, 58, 'PPL', 'P'),
(73700, 'Nipgen', 39.1911087036133, 0.684013884385058, -83.1494369506836, -1.45123144596886, 218, 41, 'PPL', 'P'),
(183650, 'Nipinnawasee', 37.4041709899902, 0.652825937754277, -119.731941223145, -2.0897165941482, 218, 6, 'PPL', 'P'),
(183652, 'Nipomo', 35.042781829834, 0.611611921988646, -120.474998474121, -2.10268538970856, 218, 6, 'PPL', 'P'),
(37432, 'Nippa', 37.8658294677734, 0.660883398211339, -82.7874984741211, -1.44491442786319, 218, 21, 'PPL', 'P'),
(28058, 'Nipper Corner', 38.0386085510254, 0.663898962092663, -88.4702835083008, -1.54409773739269, 218, 18, 'PPL', 'P'),
(165259, 'Nippono Park (historical)', 41.1902809143066, 0.718906021776031, -77.1936111450195, -1.34728267598478, 218, 45, 'PPL', 'P'),
(183654, 'Nipton', 35.4666709899902, 0.619010183496886, -115.271392822266, -2.01186533810829, 218, 6, 'PPL', 'P'),
(117038, 'Nira', 41.4541702270508, 0.723511759144241, -91.9322204589844, -1.60451993567857, 218, 16, 'PPL', 'P'),
(132296, 'Nirvana', 43.9025001525879, 0.766243177519972, -85.7119369506836, -1.49595550805122, 218, 27, 'PPL', 'P'),
(30668, 'Nisbet', 38.146110534668, 0.665775225659651, -87.6527786254883, -1.52982958553648, 218, 19, 'PPL', 'P'),
(165260, 'Nisbet', 41.2180595397949, 0.71939085025248, -77.1136093139648, -1.34588638062525, 218, 45, 'PPL', 'P'),
(4580, 'Nisbit (historical)', 33.9527816772461, 0.592587830478747, -85.9291687011719, -1.49974691733711, 218, 2, 'PPL', 'P'),
(117039, 'Nishna', 41.6958312988281, 0.727729540520654, -94.9186096191406, -1.65664225926916, 218, 16, 'PPL', 'P'),
(139364, 'Nishnabotna', 40.2958297729492, 0.703294904361123, -95.5083312988281, -1.6669348442501, 218, 29, 'PPL', 'P'),
(151113, 'Niskayuna', 42.7797203063965, 0.746646972428896, -73.8461074829102, -1.2888577153584, 218, 40, 'PPL', 'P'),
(165261, 'Nisky', 40.7516708374023, 0.711250831801626, -75.2850036621094, -1.3139711912798, 218, 45, 'PPL', 'P'),
(202426, 'Nisland', 44.6730613708496, 0.779692007866817, -103.553062438965, -1.80734189008321, 218, 49, 'PPL', 'P'),
(208249, 'Nisqually', 47.0566711425781, 0.82129384646619, -122.699996948242, -2.14151893893382, 218, 56, 'PPL', 'P'),
(208250, 'Nisqually Vista', 46.7869415283203, 0.816586176607257, -121.746391296387, -2.12487538054332, 218, 56, 'PPL', 'P'),
(151115, 'Nissequogue', 40.9038887023926, 0.713907534726062, -73.1983337402344, -1.27755193074075, 218, 40, 'PPL', 'P'),
(197155, 'Nissler', 46.0047187805176, 0.802933814174102, -112.641387939453, -1.96596309355969, 218, 31, 'PPL', 'P'),
(208251, 'Nisson', 47.1161117553711, 0.822331280868831, -123.807777404785, -2.16085335528974, 218, 56, 'PPL', 'P'),
(137139, 'Nisswa', 46.5205612182617, 0.811936963134251, -94.288330078125, -1.64564180607048, 218, 28, 'PPL', 'P'),
(132297, 'Nisula', 46.7649993896484, 0.816203214042504, -88.7944412231445, -1.54975535681245, 218, 27, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(195387, 'Niter', 42.5036087036133, 0.74182791585737, -111.730003356934, -1.95005643184281, 218, 17, 'PPL', 'P'),
(112397, 'Nithsdale', 38.3444404602051, 0.669236735865508, -75.6738891601563, -1.32075852363397, 218, 25, 'PPL', 'P'),
(42297, 'Nitram (historical)', 30.9541702270508, 0.540252187684837, -92.9925003051758, -1.62302530998715, 218, 22, 'PPL', 'P'),
(257, 'Nitrate City', 34.7572212219238, 0.606627949166618, -87.5597229003906, -1.5282054567457, 218, 2, 'PPL', 'P'),
(110667, 'Nitro', 38.4147186279297, 0.670463321284572, -81.8441696166992, -1.42845023337211, 218, 58, 'PPL', 'P'),
(183655, 'Nitro', 38.0091705322266, 0.663385171739359, -122.363609313965, -2.13564786715269, 218, 6, 'PPL', 'P'),
(82605, 'Nitrolee', 34.5827789306641, 0.603583356829412, -80.9069366455078, -1.41209243216657, 218, 48, 'PPL', 'P'),
(61079, 'Nitta Yuma', 33.024169921875, 0.576380497874797, -90.8491668701172, -1.5856170845773, 218, 30, 'PPL', 'P'),
(165262, 'Nittany', 40.997501373291, 0.715541384054825, -77.5563888549805, -1.35361434147644, 218, 45, 'PPL', 'P'),
(210774, 'Niu', 21.2849998474121, 0.371493328623832, -157.742218017578, -2.75312107380546, 218, 15, 'PPL', 'P'),
(210776, 'Niu Village', 20.0133304595947, 0.349298510809598, -155.27555847168, -2.71006974320379, 218, 15, 'PPL', 'P'),
(210782, 'NiuÃ‚â€˜oÃ‚â€˜u (historical)', 19.1277809143066, 0.333842755554782, -155.919998168945, -2.72131733775163, 218, 15, 'PPL', 'P'),
(210778, 'NiuliÃ‚â€˜i', 20.2255592346191, 0.353002601701248, -155.745834350586, -2.71827760568341, 218, 15, 'PPL', 'P'),
(210779, 'Niumalu', 21.9552803039551, 0.383191929502278, -159.365005493164, -2.78144405831456, 218, 15, 'PPL', 'P'),
(78845, 'Niver Junction', 39.901668548584, 0.696415493212257, -78.9622192382813, -1.37815071038962, 218, 45, 'PPL', 'P'),
(78846, 'Niverton', 39.7308311462402, 0.693433818055805, -79.1319427490234, -1.38111294447011, 218, 45, 'PPL', 'P'),
(151116, 'Niverville', 42.4408302307129, 0.740732224805885, -73.6613922119141, -1.28563382570081, 218, 40, 'PPL', 'P'),
(190550, 'Nivloc', 37.7155609130859, 0.658260717169828, -117.758056640625, -2.05526580912888, 218, 39, 'PPL', 'P'),
(194345, 'Niwot', 40.103889465332, 0.699944914025912, -105.170280456543, -1.83556766921252, 218, 7, 'PPL', 'P'),
(4581, 'Nix', 34.351390838623, 0.599544872773388, -87.7841720581055, -1.53212283355115, 218, 2, 'PPL', 'P'),
(96554, 'Nix', 31.107889175415, 0.542935089456496, -98.366569519043, -1.71682051199919, 218, 51, 'PPL', 'P'),
(4582, 'Nix (historical)', 33.9963912963867, 0.593348961918292, -86.307502746582, -1.50635009210191, 218, 2, 'PPL', 'P'),
(10815, 'Nix (historical)', 33.9838905334473, 0.593130782445987, -92.7463912963867, -1.61872989746496, 218, 4, 'PPL', 'P'),
(175560, 'Nix Corner', 44.646671295166, 0.779231414156288, -91.3469390869141, -1.59430484868535, 218, 57, 'PPL', 'P'),
(4583, 'Nix Mill', 34.3472213745117, 0.599472101896602, -87.8069381713867, -1.53252017718579, 218, 2, 'PPL', 'P'),
(56543, 'Nixa', 37.0433311462402, 0.646528094408457, -93.2941665649414, -1.62829037946224, 218, 29, 'PPL', 'P'),
(112213, 'Nixburg', 32.8277816772461, 0.572952876393811, -86.1111068725586, -1.50292233746286, 218, 2, 'PPL', 'P'),
(17283, 'Nixon', 30.3222198486328, 0.529222572872219, -85.4513931274414, -1.49140816048991, 218, 12, 'PPL', 'P'),
(23386, 'Nixon', 33.3369407653809, 0.581839378898214, -81.9561080932617, -1.43040392834779, 218, 13, 'PPL', 'P'),
(61080, 'Nixon', 34.2866706848145, 0.598415292997031, -88.9722213745117, -1.5528582057985, 218, 30, 'PPL', 'P'),
(89442, 'Nixon', 35.1147193908691, 0.612867469284564, -88.2566680908203, -1.54036944502463, 218, 50, 'PPL', 'P'),
(96555, 'Nixon', 29.267219543457, 0.510809343937357, -97.7641677856445, -1.70630661833167, 218, 51, 'PPL', 'P'),
(128266, 'Nixon', 46.8797187805176, 0.818205445129053, -68.5224990844727, -1.19594322071885, 218, 26, 'PPL', 'P'),
(145902, 'Nixon', 40.5141716003418, 0.707105688143945, -74.3677825927734, -1.29796266365122, 218, 37, 'PPL', 'P'),
(165264, 'Nixon', 41.9386100769043, 0.731966829552052, -76.1361083984375, -1.32882577120804, 218, 45, 'PPL', 'P'),
(190551, 'Nixon', 39.8319396972656, 0.695198495173118, -119.356941223145, -2.08317160945322, 218, 39, 'PPL', 'P'),
(4584, 'Nixon Chapel', 34.2038917541504, 0.596970528105663, -86.3847198486328, -1.50769778477154, 218, 2, 'PPL', 'P'),
(67216, 'Nixons Beach', 36.0213890075684, 0.62869183932376, -76.4749984741211, -1.33474051883105, 218, 33, 'PPL', 'P'),
(82606, 'Nixons Crossroads', 33.8574981689453, 0.590924819536047, -78.6605606079102, -1.37288577407258, 218, 48, 'PPL', 'P'),
(67217, 'Nixonton', 36.2005615234375, 0.631818989654759, -76.273063659668, -1.33121609144444, 218, 33, 'PPL', 'P'),
(82607, 'Nixonville', 33.8344383239746, 0.590522349316309, -78.8855590820313, -1.37681273825796, 218, 48, 'PPL', 'P'),
(82608, 'Nixville', 32.7427787780762, 0.571469295929555, -81.1522216796875, -1.41637346361887, 218, 48, 'PPL', 'P'),
(189115, 'No Agua', 36.7205581665039, 0.640894643175585, -105.968612670898, -1.84950119487776, 218, 38, 'PPL', 'P'),
(554, 'No Creek', 37.4805603027344, 0.654159182774998, -86.9583282470703, -1.51770913994137, 218, 21, 'PPL', 'P'),
(82609, 'No Mans Land (historical)', 34.7799987792969, 0.607025492538339, -81.4672164916992, -1.42187116021518, 218, 48, 'PPL', 'P'),
(96556, 'Noack', 30.5575008392334, 0.533329000825553, -97.3041687011719, -1.69827811975146, 218, 51, 'PPL', 'P'),
(957, 'Noah', 35.5750007629395, 0.620900894712788, -86.1919403076172, -1.50433314705033, 218, 50, 'PPL', 'P'),
(4585, 'Noah', 34.1322212219238, 0.595719641341653, -85.5586090087891, -1.49327943062985, 218, 2, 'PPL', 'P'),
(23387, 'Noah', 33.2152786254883, 0.579715973982067, -82.2861099243164, -1.4361635468373, 218, 13, 'PPL', 'P'),
(178718, 'Noah', 32.6847190856934, 0.57045596313478, -114.021392822266, -1.99004872245836, 218, 5, 'PPL', 'P'),
(10816, 'Noahs', 35.8158302307129, 0.62510416186126, -92.5502777099609, -1.61530706967394, 218, 4, 'PPL', 'P'),
(113804, 'Noank', 41.3277816772461, 0.721305862813329, -71.9911117553711, -1.25648193230242, 218, 8, 'PPL', 'P'),
(212039, 'Noatak', 67.5711135864258, 1.1793384113222, -162.965286254883, -2.84428081160276, 218, 1, 'PPL', 'P'),
(49818, 'Nob Hill', 39.2755584716797, 0.685487810890363, -76.841667175293, -1.34114009493051, 218, 25, 'PPL', 'P'),
(104683, 'Nob Hill', 38.0202789306641, 0.663579049866717, -78.5252838134766, -1.37052474860817, 218, 53, 'PPL', 'P'),
(140586, 'Nobart (historical)', 46.9397201538086, 0.819252666648699, -98.1466674804688, -1.71298249739423, 218, 34, 'PPL', 'P'),
(110669, 'Nobe', 38.9863891601563, 0.680440854308554, -81.0344390869141, -1.41431776957344, 218, 58, 'PPL', 'P'),
(96557, 'Nobility', 33.3758316040039, 0.582518152081048, -96.3661117553711, -1.68190593747604, 218, 51, 'PPL', 'P'),
(23389, 'Noble', 34.7805595397949, 0.607035279655345, -85.2544403076172, -1.48797068531289, 218, 13, 'PPL', 'P'),
(28059, 'Noble', 38.6974983215332, 0.675398757995734, -88.2236099243164, -1.53979247117447, 218, 18, 'PPL', 'P'),
(37434, 'Noble', 37.4508285522461, 0.653640265836596, -83.1888885498047, -1.4519200062687, 218, 21, 'PPL', 'P'),
(42298, 'Noble', 31.6894397735596, 0.553085062161061, -93.6838912963867, -1.63509235920241, 218, 22, 'PPL', 'P'),
(56544, 'Noble', 36.747501373291, 0.641364890845066, -92.5697174072266, -1.61564635639681, 218, 29, 'PPL', 'P'),
(76720, 'Noble', 35.1391716003418, 0.613294240849249, -97.3944396972656, -1.69985364585235, 218, 42, 'PPL', 'P'),
(96558, 'Noble', 33.5519409179688, 0.585591839453163, -95.7938919067383, -1.67191881707213, 218, 51, 'PPL', 'P'),
(117051, 'Noble', 41.166389465332, 0.718489037328352, -91.6194381713867, -1.59906085491807, 218, 16, 'PPL', 'P'),
(123305, 'Noble', 40.4694404602051, 0.706324982470388, -84.8261108398438, -1.48049492581693, 218, 19, 'PPL', 'P'),
(156793, 'Noble', 41.5950012207031, 0.72596972367233, -81.5138931274414, -1.42268582119263, 218, 41, 'PPL', 'P'),
(165265, 'Noble', 40.1055603027344, 0.699974075639849, -75.1252822875977, -1.31118352740876, 218, 45, 'PPL', 'P'),
(197156, 'Noble', 46.5200004577637, 0.811927176017245, -111.486106872559, -1.94579963515643, 218, 31, 'PPL', 'P'),
(208252, 'Noble', 47.3794403076172, 0.826927231120035, -122.005828857422, -2.12940342018672, 218, 56, 'PPL', 'P'),
(201307, 'Noble (historical)', 45.0022201538086, 0.785436912391309, -122.638893127441, -2.1404524760753, 218, 43, 'PPL', 'P'),
(151117, 'Noble Corner', 43.086109161377, 0.751994466739721, -76.8097229003906, -1.34058256215631, 218, 40, 'PPL', 'P'),
(73701, 'Noble Cottage Area', 39.8880615234375, 0.69617800582205, -81.3847198486328, -1.42043132217182, 218, 41, 'PPL', 'P'),
(104684, 'Noble Furnace', 36.8091697692871, 0.642441207399622, -81.0969390869141, -1.41540860035593, 218, 53, 'PPL', 'P'),
(4586, 'Noble Hill', 34.0819396972656, 0.594842063183445, -86.1069412231445, -1.50284963316511, 218, 2, 'PPL', 'P'),
(10817, 'Noble Lake', 34.1730613708496, 0.596432436407413, -91.8541717529297, -1.60315772878099, 218, 4, 'PPL', 'P'),
(42299, 'Noble Manor', 29.8705596923828, 0.521339616045585, -89.9972229003906, -1.57074785726306, 218, 22, 'PPL', 'P'),
(49819, 'Noble Mill', 39.6177787780762, 0.691460682004165, -76.2391662597656, -1.33062447020828, 218, 25, 'PPL', 'P'),
(151118, 'Noble Shores', 43.5449981689453, 0.760003590822998, -75.8786087036133, -1.32433155371048, 218, 40, 'PPL', 'P'),
(128267, 'Nobleboro', 44.0794410705566, 0.769331379120027, -69.4855575561523, -1.21275176193888, 218, 26, 'PPL', 'P'),
(151119, 'Nobleboro', 43.3958282470703, 0.757400084541336, -74.8622207641602, -1.30659223768946, 218, 40, 'PPL', 'P'),
(89443, 'Nobles', 36.355281829834, 0.634519368421072, -88.2197189331055, -1.53972456056667, 218, 50, 'PPL', 'P'),
(128269, 'Nobles Corner', 44.2613906860352, 0.772506998982865, -70.6252822875977, -1.23264371106901, 218, 26, 'PPL', 'P'),
(67221, 'Nobles Crossing', 34.2847213745117, 0.598381271114105, -78.8383331298828, -1.37598848990058, 218, 33, 'PPL', 'P'),
(67222, 'Nobles Crossroads', 35.103328704834, 0.61266866430919, -77.6852798461914, -1.35586391364923, 218, 33, 'PPL', 'P'),
(67223, 'Nobles Mill', 35.0955581665039, 0.612533042830677, -77.6405563354492, -1.35508334113373, 218, 33, 'PPL', 'P'),
(49820, 'Nobles Mill Estates', 39.6175003051758, 0.691455821735176, -76.2416687011719, -1.33066814605016, 218, 25, 'PPL', 'P'),
(165266, 'Noblestown', 40.3911094665527, 0.704957848724796, -80.1988906860352, -1.39973469891833, 218, 45, 'PPL', 'P'),
(123312, 'Noblesville', 40.0455589294434, 0.698926854120202, -86.0086135864258, -1.50113349215866, 218, 19, 'PPL', 'P'),
(17284, 'Nobleton', 28.6452808380127, 0.499954465781762, -82.2641677856445, -1.43578058427255, 218, 12, 'PPL', 'P'),
(175561, 'Nobleton', 45.6791687011719, 0.797251893409391, -91.7024993896484, -1.60051054665746, 218, 57, 'PPL', 'P'),
(76725, 'Nobletown', 35.2030601501465, 0.614409306397666, -96.5294418334961, -1.68475658510686, 218, 42, 'PPL', 'P'),
(37435, 'Nobob', 36.8652801513672, 0.643420518311471, -85.774169921875, -1.49704167830181, 218, 21, 'PPL', 'P'),
(42300, 'Nobrac', 30.9727802276611, 0.540576993469286, -92.397216796875, -1.61263565278448, 218, 22, 'PPL', 'P'),
(76726, 'Nobscot', 35.8486099243164, 0.625676275442437, -98.7352828979492, -1.72325577445726, 218, 42, 'PPL', 'P'),
(125567, 'Nobscot', 42.3291702270508, 0.738783390099192, -71.4369430541992, -1.24680986385547, 218, 23, 'PPL', 'P'),
(17285, 'Nocatee', 27.1599998474121, 0.474031422178499, -81.8824996948242, -1.42911921943793, 218, 12, 'PPL', 'P'),
(67224, 'Nocho Park', 36.0658302307129, 0.629467484991246, -79.7713928222656, -1.39227345365031, 218, 33, 'PPL', 'P'),
(96559, 'Nockenut', 29.3461093902588, 0.512186231510441, -97.9113922119141, -1.70887616930943, 218, 51, 'PPL', 'P'),
(96560, 'Nocona', 33.7866706848145, 0.58968864673706, -97.7255630493164, -1.70563283857588, 218, 51, 'PPL', 'P'),
(37438, 'Noctor', 37.559440612793, 0.655535903900514, -83.3372192382813, -1.45450886516437, 218, 21, 'PPL', 'P'),
(61081, 'Nod', 32.7563896179199, 0.57170684989879, -90.2305603027344, -1.57482036320201, 218, 30, 'PPL', 'P'),
(56546, 'Nodaway', 39.9094390869141, 0.69655111469077, -94.9674987792969, -1.65749553608243, 218, 29, 'PPL', 'P'),
(117042, 'Nodaway', 40.9372215270996, 0.714489302266189, -94.8947219848633, -1.65622534140051, 218, 16, 'PPL', 'P'),
(37436, 'Node', 37.1291694641113, 0.648026255679681, -85.6438903808594, -1.4947678713631, 218, 21, 'PPL', 'P'),
(10818, 'Nodena', 35.5569381713867, 0.62058564301875, -89.9494400024414, -1.5699138883677, 218, 4, 'PPL', 'P'),
(137138, 'Nodine', 43.9049987792969, 0.766286786782822, -91.4361114501953, -1.5958612000264, 218, 28, 'PPL', 'P'),
(42301, 'Noel', 30.1308307647705, 0.525882203206446, -91.070556640625, -1.58948106500289, 218, 22, 'PPL', 'P'),
(56547, 'Noel', 36.5455589294434, 0.637840330300401, -94.4850006103516, -1.64907435439949, 218, 29, 'PPL', 'P'),
(76727, 'Noel', 36.7811088562012, 0.641951452075156, -98.7188873291016, -1.72296961779813, 218, 42, 'PPL', 'P'),
(104685, 'Noel', 37.9044418334961, 0.661557311125183, -77.5444412231445, -1.35340581596309, 218, 53, 'PPL', 'P'),
(165268, 'Noel', 40.4830589294434, 0.706562669597677, -78.6624984741211, -1.37291959621843, 218, 45, 'PPL', 'P'),
(187111, 'Noel', 38.0997200012207, 0.664965558109239, -107.912216186523, -1.88342347557875, 218, 7, 'PPL', 'P'),
(117046, 'Noel (historical)', 41.750560760498, 0.728684749824639, -90.5919418334961, -1.5811276607697, 218, 16, 'PPL', 'P'),
(183659, 'Noel Heights', 38.4938888549805, 0.671845102416159, -122.961112976074, -2.14607627334922, 218, 6, 'PPL', 'P'),
(191942, 'Noelke', 31.148609161377, 0.543645787282898, -100.929168701172, -1.76154630513626, 218, 51, 'PPL', 'P'),
(89444, 'Noeton (historical)', 36.2994384765625, 0.63354471804113, -83.3333282470703, -1.45444095455657, 218, 50, 'PPL', 'P'),
(37437, 'Noetown', 36.6163902282715, 0.639076569678416, -83.7552795410156, -1.46180539391897, 218, 21, 'PPL', 'P'),
(10820, 'Nogal', 35.0758285522461, 0.61218869610173, -92.5672225952148, -1.61560281371299, 218, 4, 'PPL', 'P'),
(189116, 'Nogal', 33.5580596923828, 0.585698632212876, -105.707221984863, -1.8449390667724, 218, 38, 'PPL', 'P'),
(178719, 'Nogales', 31.3402805328369, 0.546991083796687, -110.933609008789, -1.93615672832341, 218, 5, 'PPL', 'P'),
(96561, 'Nogalus', 31.2552795410156, 0.545507536621945, -95.0880584716797, -1.6595996996597, 218, 51, 'PPL', 'P'),
(212040, 'Nogamut', 61.0194396972656, 1.06499013043942, -157.674438476563, -2.75193809764925, 218, 1, 'PPL', 'P'),
(61082, 'Nogan', 32.2477798461914, 0.562829934774311, -90.2127838134766, -1.57451010493501, 218, 30, 'PPL', 'P'),
(10821, 'Nogo', 35.6408309936523, 0.622049848986076, -92.8791732788086, -1.62104738024555, 218, 4, 'PPL', 'P'),
(56548, 'Nogo', 37.2527809143066, 0.650183682478754, -93.165283203125, -1.6260409404475, 218, 29, 'PPL', 'P'),
(104689, 'Nohead Bottom', 37.5930595397949, 0.656122664867686, -76.4997177124023, -1.33517195092765, 218, 53, 'PPL', 'P'),
(197157, 'Nohly', 47.9955596923828, 0.837680542969557, -104.09139251709, -1.81673752240901, 218, 31, 'PPL', 'P'),
(178720, 'Noipa Kam', 32.2849998474121, 0.563479546343208, -112.148063659668, -1.95735296059741, 218, 5, 'PPL', 'P'),
(104686, 'Nokesville', 38.6986083984375, 0.675418132492664, -77.5800018310547, -1.35402646565513, 218, 53, 'PPL', 'P'),
(4587, 'Nokomis', 31.0100002288818, 0.541226605038183, -87.5647201538086, -1.5282926752714, 218, 2, 'PPL', 'P'),
(17286, 'Nokomis', 27.1188907623291, 0.473313933291318, -82.4444427490234, -1.43892697594242, 218, 12, 'PPL', 'P'),
(28061, 'Nokomis', 39.3011093139648, 0.685933757214896, -89.2850036621094, -1.558317286559, 218, 18, 'PPL', 'P'),
(104687, 'Nokomis', 37.9441719055176, 0.662250731694013, -76.4802780151367, -1.33483266420477, 218, 53, 'PPL', 'P'),
(17287, 'Nokomis Beach', 27.1261100769043, 0.473439934100392, -82.4711074829102, -1.43939236334292, 218, 12, 'PPL', 'P'),
(10829, 'Nola', 34.8777809143066, 0.608732112743889, -93.7411117553711, -1.63609104461119, 218, 4, 'PPL', 'P'),
(61083, 'Nola', 31.6141700744629, 0.551771358084838, -90.2380599975586, -1.57495125756958, 218, 30, 'PPL', 'P'),
(23393, 'Nola (historical)', 31.1722202301025, 0.544057878172074, -83.5088882446289, -1.45750505454876, 218, 13, 'PPL', 'P'),
(33441, 'Nolan', 39.5666694641113, 0.690568656197043, -96.2777786254883, -1.68036423352099, 218, 20, 'PPL', 'P'),
(110668, 'Nolan', 37.7397193908691, 0.658682362149415, -82.3313903808594, -1.43695383989078, 218, 58, 'PPL', 'P'),
(140589, 'Nolan', 47.1380615234375, 0.822714376591639, -97.5569381713867, -1.70268977925523, 218, 34, 'PPL', 'P'),
(191943, 'Nolan', 32.273609161377, 0.563280741367834, -100.242218017578, -1.74955675390872, 218, 51, 'PPL', 'P'),
(212041, 'Nolan', 67.4766693115234, 1.1776900477655, -150.229721069336, -2.62200326701261, 218, 1, 'PPL', 'P'),
(189117, 'Nolan (historical)', 36.1661109924316, 0.631217714459646, -104.669998168945, -1.82683609610453, 218, 38, 'PPL', 'P'),
(4588, 'Nolan Hills', 34.7097206115723, 0.605798907119276, -86.7241668701172, -1.51362225293253, 218, 2, 'PPL', 'P'),
(4589, 'Noland', 33.2763900756836, 0.580782569998644, -87.9372177124023, -1.5347939841245, 218, 2, 'PPL', 'P'),
(10822, 'Noland', 36.1933288574219, 0.631692755819089, -91.0505599975586, -1.58913205774204, 218, 4, 'PPL', 'P'),
(37439, 'Noland', 37.6477813720703, 0.657077741013615, -84.0547180175781, -1.46703158124214, 218, 21, 'PPL', 'P'),
(194346, 'Noland', 40.2591705322266, 0.702655079909231, -105.253890991211, -1.83702694833183, 218, 7, 'PPL', 'P'),
(23390, 'Nolans Store', 33.7102813720703, 0.588355401716339, -83.498893737793, -1.45733061749736, 218, 13, 'PPL', 'P'),
(37442, 'Nolansburg', 36.9255599975586, 0.644472600100107, -83.1638870239258, -1.45148364732409, 218, 21, 'PPL', 'P'),
(96562, 'Nolanville', 31.0786094665527, 0.542424062132824, -97.6052780151367, -1.70353346868857, 218, 51, 'PPL', 'P'),
(89446, 'Nolensville', 35.952220916748, 0.627484628401628, -86.6694412231445, -1.51266711020757, 218, 50, 'PPL', 'P'),
(42302, 'Noles Landing', 32.4636116027832, 0.5665969095572, -93.3488922119141, -1.62924552218719, 218, 22, 'PPL', 'P'),
(76728, 'Nolia', 34.476390838623, 0.601726534338381, -95.1513900756836, -1.66070504467014, 218, 42, 'PPL', 'P'),
(178721, 'Nolic', 32.0352783203125, 0.559121083482212, -111.951942443848, -1.95392999964833, 218, 5, 'PPL', 'P'),
(89447, 'Nolichucky (historical)', 36.1583290100098, 0.631081893244052, -82.5808334350586, -1.44130744248279, 218, 50, 'PPL', 'P'),
(37440, 'Nolin', 37.5611114501953, 0.65556506551445, -85.9027786254883, -1.49928632362658, 218, 21, 'PPL', 'P'),
(201308, 'Nolin', 45.6833305358887, 0.797324531128123, -119.09944152832, -2.07867739195566, 218, 43, 'PPL', 'P'),
(37441, 'Nolin Lake Estates', 37.3591690063477, 0.652040504969785, -86.164436340332, -1.50385311226385, 218, 21, 'PPL', 'P'),
(110670, 'Nollville', 39.4625015258789, 0.688750582699873, -78.0202789306641, -1.36171075066445, 218, 58, 'PPL', 'P'),
(165269, 'Nolo', 40.5722198486328, 0.708118821201638, -78.959716796875, -1.37810703454774, 218, 45, 'PPL', 'P'),
(96563, 'Nolte', 29.5744400024414, 0.516171352476122, -98.0308303833008, -1.71096075865269, 218, 51, 'PPL', 'P'),
(28063, 'Noltings', 38.4877815246582, 0.671738509393529, -89.1991729736328, -1.55681925844583, 218, 18, 'PPL', 'P'),
(17288, 'Noma', 30.9819393157959, 0.540736849713718, -85.6186065673828, -1.49432658557047, 218, 12, 'PPL', 'P'),
(17289, 'Noma Junction', 30.9724998474121, 0.540572099910783, -85.6177825927734, -1.49431220450058, 218, 12, 'PPL', 'P'),
(132299, 'Nomad', 45.5950012207031, 0.795782893752103, -85.5149993896484, -1.49251829919031, 218, 27, 'PPL', 'P'),
(17296, 'Nombre de Dios (historical)', 29.8999996185303, 0.521853439688402, -81.3166732788086, -1.4192436854837, 218, 12, 'PPL', 'P'),
(96569, 'Nome', 30.0355606079102, 0.524219425290342, -94.4241714477539, -1.64801268523093, 218, 51, 'PPL', 'P'),
(140591, 'Nome', 46.6777801513672, 0.814680951163415, -97.8099975585938, -1.70710649876508, 218, 34, 'PPL', 'P'),
(212042, 'Nome', 64.501106262207, 1.12575667545425, -165.406387329102, -2.88688606272185, 218, 1, 'PPL', 'P'),
(104688, 'Nomini', 38.098331451416, 0.66494132334332, -76.7380599975586, -1.33933180855035, 218, 53, 'PPL', 'P'),
(104690, 'Nomini Grove', 38.0349998474121, 0.663835978332882, -76.7486114501953, -1.33951596613973, 218, 53, 'PPL', 'P'),
(178722, 'Nommel Place', 33.082218170166, 0.577393630932491, -114.686393737793, -2.00165517796309, 218, 5, 'PPL', 'P'),
(76733, 'Non', 34.7777786254883, 0.606986743544478, -96.2405624389648, -1.67971468853112, 218, 42, 'PPL', 'P'),
(104691, 'Non Intervention (historical)', 36.9055595397949, 0.644123526260225, -78.133056640625, -1.36367909302613, 218, 53, 'PPL', 'P'),
(23391, 'Nona', 33.2197189331055, 0.579793471969788, -83.3461074829102, -1.45466399429787, 218, 13, 'PPL', 'P'),
(56551, 'Nona', 38.5661087036133, 0.673105576560094, -90.9402770996094, -1.58720725806418, 218, 29, 'PPL', 'P'),
(96564, 'Nona', 30.3333301544189, 0.529416484289091, -94.2916717529297, -1.64570012929836, 218, 51, 'PPL', 'P'),
(89448, 'Nonaburg', 35.4122200012207, 0.618059834461892, -84.4613876342773, -1.47412930502136, 218, 50, 'PPL', 'P'),
(125568, 'Nonantum', 42.3624992370605, 0.739365091060292, -71.2027816772461, -1.24272297684663, 218, 23, 'PPL', 'P'),
(125569, 'Nonatomqua Mobile Home Park', 42.2013893127441, 0.736553192423332, -72.0986099243164, -1.25835812929038, 218, 23, 'PPL', 'P'),
(14303, 'Nonatum Mills', 39.6897201538086, 0.69271629587911, -75.7541732788086, -1.32215974584152, 218, 10, 'PPL', 'P'),
(89449, 'Nonaville', 36.2686080932617, 0.63300662634288, -86.5286102294922, -1.51020914567948, 218, 50, 'PPL', 'P'),
(89450, 'Nonconnah', 35.061939239502, 0.611946281863506, -90.0361099243164, -1.57142656386686, 218, 50, 'PPL', 'P'),
(212044, 'Nondalton', 59.9736099243164, 1.04673695748607, -154.845825195313, -2.70256948262579, 218, 1, 'PPL', 'P'),
(37443, 'Nonesuch', 37.9061088562012, 0.661586406160092, -84.7555618286133, -1.47926361328693, 218, 21, 'PPL', 'P'),
(132300, 'Nonesuch', 46.7552795410156, 0.816033570681066, -89.6194381713867, -1.56415426987818, 218, 27, 'PPL', 'P'),
(37444, 'Nonnell', 37.2372207641602, 0.649912106626594, -87.059440612793, -1.51947388363771, 218, 21, 'PPL', 'P'),
(210788, 'Nonopahu Village', 21.9713897705078, 0.383473092734363, -159.638885498047, -2.78622416615515, 218, 15, 'PPL', 'P'),
(199562, 'Nonpareil', 42.3722190856934, 0.73953473442173, -103.18083190918, -1.80084524176201, 218, 35, 'PPL', 'P'),
(125570, 'Nonquitt', 41.5625, 0.725402470360143, -70.9430618286133, -1.23819001035521, 218, 23, 'PPL', 'P'),
(191945, 'Noodle', 32.6022186279297, 0.569016058512401, -100.051666259766, -1.74623099833943, 218, 51, 'PPL', 'P'),
(4591, 'Noojinsville', 34.0019416809082, 0.593445834402943, -85.9186096191406, -1.49956262658968, 218, 2, 'PPL', 'P'),
(165270, 'Nook', 40.5069389343262, 0.706979454308275, -77.5277786254883, -1.35311499877205, 218, 45, 'PPL', 'P'),
(208253, 'Nooksack', 48.9277801513672, 0.853950859333287, -122.320281982422, -2.13489166256116, 218, 56, 'PPL', 'P'),
(208259, 'Nooksack Salmon Hatchery', 48.8972206115723, 0.853417494745971, -122.14111328125, -2.13176457880919, 218, 56, 'PPL', 'P'),
(201309, 'Noon', 44.5455589294434, 0.777466670459947, -123.396942138672, -2.15368292721276, 218, 43, 'PPL', 'P'),
(208254, 'Noon', 48.8041687011719, 0.851793432534214, -122.397216796875, -2.13623442838278, 218, 56, 'PPL', 'P'),
(96565, 'Noonan', 29.2688903808594, 0.510838505551293, -98.9016723632813, -1.72615981846794, 218, 51, 'PPL', 'P'),
(198675, 'Noonan', 48.8888893127441, 0.853272086150453, -103.008331298828, -1.79783453814968, 218, 34, 'PPL', 'P'),
(23392, 'Noonday', 34.061939239502, 0.594492989343562, -84.5213928222656, -1.47517659312004, 218, 13, 'PPL', 'P'),
(96567, 'Noonday', 32.2355613708496, 0.562616682150023, -95.4058303833008, -1.66514586578784, 218, 51, 'PPL', 'P'),
(144216, 'Noone', 42.8597183227539, 0.748043201209397, -71.9649963378906, -1.25602613228185, 218, 36, 'PPL', 'P'),
(132301, 'Noordeloos', 42.8413887023926, 0.747723288983452, -86.0583267211914, -1.50200115004181, 218, 27, 'PPL', 'P'),
(212045, 'Noorvik', 66.8383331298828, 1.16654897966126, -161.032775878906, -2.81055214271302, 218, 1, 'PPL', 'P'),
(169514, 'Nooseneck', 41.6208305358887, 0.726420530265853, -71.6361083984375, -1.2502859548683, 218, 47, 'PPL', 'P'),
(191946, 'Nopal', 30.2880592346191, 0.528626357683178, -103.926109313965, -1.81385278631623, 218, 51, 'PPL', 'P'),
(30672, 'Nora', 39.9124984741211, 0.696604511070626, -86.1347198486328, -1.50333446164155, 218, 19, 'PPL', 'P'),
(37445, 'Nora', 36.7605590820313, 0.64159279085535, -85.0427780151367, -1.48427648140678, 218, 21, 'PPL', 'P'),
(104692, 'Nora', 37.0708312988281, 0.647008062615917, -82.3475036621094, -1.4372350697019, 218, 53, 'PPL', 'P'),
(120788, 'Nora', 42.4558296203613, 0.740994013541039, -89.9452819824219, -1.56984131722799, 218, 18, 'PPL', 'P'),
(142520, 'Nora', 40.1616706848145, 0.700953386551698, -97.9700012207031, -1.70989908948413, 218, 35, 'PPL', 'P'),
(170943, 'Nora', 42.9391708374023, 0.749429909189002, -96.706672668457, -1.68784984671299, 218, 49, 'PPL', 'P'),
(175563, 'Nora', 43.0308303833008, 0.751029670055812, -89.1500015258789, -1.55596105478456, 218, 57, 'PPL', 'P'),
(195388, 'Nora', 46.7638893127441, 0.816183839545574, -116.700828552246, -2.0368136980421, 218, 17, 'PPL', 'P'),
(117048, 'Nora Junction', 43.1399993896484, 0.752935028657709, -93.01611328125, -1.62343743416584, 218, 16, 'PPL', 'P'),
(117049, 'Nora Springs', 43.1427803039551, 0.752983564768576, -93.0041732788086, -1.62322904181054, 218, 16, 'PPL', 'P'),
(49821, 'Nora Valley', 39.4599990844727, 0.688706906857996, -76.899169921875, -1.34214370718731, 218, 25, 'PPL', 'P'),
(42303, 'Norah', 29.6138896942139, 0.516859879486449, -90.4911117553711, -1.57936784392137, 218, 22, 'PPL', 'P'),
(4590, 'Norala Junction', 34.7194404602051, 0.605968550480714, -87.6594390869141, -1.52994583251806, 218, 2, 'PPL', 'P'),
(49822, 'Norbeck', 39.1100006103516, 0.682598281107627, -77.0761108398438, -1.34523190878737, 218, 25, 'PPL', 'P'),
(170944, 'Norbeck', 45.1841697692871, 0.788612532254147, -99.2122192382813, -1.73157988391847, 218, 49, 'PPL', 'P'),
(49823, 'Norbeck Estates', 39.1333312988281, 0.6830054784383, -77.0833282470703, -1.34535787630693, 218, 25, 'PPL', 'P'),
(42304, 'Norbert', 29.978889465332, 0.523230327261486, -91.8969421386719, -1.60390421283454, 218, 22, 'PPL', 'P'),
(56550, 'Norborne', 39.3025016784668, 0.685958058559843, -93.6772232055664, -1.63497597906277, 218, 29, 'PPL', 'P'),
(37446, 'Norbourne Estates', 38.2463912963867, 0.667525455128051, -85.6477813720703, -1.49483578197089, 218, 21, 'PPL', 'P'),
(49824, 'Norbourne Mobile Home Park', 38.8083305358887, 0.677333145053513, -76.8263931274414, -1.3408735125054, 218, 25, 'PPL', 'P'),
(49825, 'Norbrook Village', 39.1333312988281, 0.6830054784383, -77.0611114501953, -1.34497012005221, 218, 25, 'PPL', 'P'),
(71174, 'Norburys Landing', 39.0502815246582, 0.681555986435997, -74.9280624389648, -1.30774139169983, 218, 37, 'PPL', 'P'),
(187825, 'Norcatur', 39.8369407653809, 0.695285780277846, -100.1875, -1.74860174434182, 218, 20, 'PPL', 'P'),
(42305, 'Norco', 29.9988899230957, 0.523579401101369, -90.4122161865234, -1.57799085647975, 218, 22, 'PPL', 'P'),
(183660, 'Norco', 33.9311103820801, 0.592209595024929, -117.547782897949, -2.0515958399887, 218, 6, 'PPL', 'P'),
(23394, 'Norcross', 33.9411087036133, 0.592384098655356, -84.2136077880859, -1.46980473088524, 218, 13, 'PPL', 'P'),
(104693, 'Norcross', 37.3502807617188, 0.651885375836288, -80.7002792358398, -1.40848557994422, 218, 53, 'PPL', 'P'),
(128270, 'Norcross', 45.6294403076172, 0.796383969210134, -68.8030624389648, -1.20083997501518, 218, 26, 'PPL', 'P'),
(137143, 'Norcross', 45.8691711425781, 0.800568061598758, -96.1972198486328, -1.67895821762348, 218, 28, 'PPL', 'P'),
(23395, 'Norcross Mobile Home City', 33.9647216796875, 0.592796222834046, -84.1750030517578, -1.46913095112945, 218, 13, 'PPL', 'P'),
(104694, 'Norcum Park', 36.8313903808594, 0.642829030233364, -76.3341674804688, -1.33228255430296, 218, 53, 'PPL', 'P'),
(183661, 'Nord', 39.7797203063965, 0.694287094869066, -121.956108093262, -2.12853562914552, 218, 6, 'PPL', 'P'),
(49826, 'Nordeau', 39.1511116027832, 0.683315803284321, -76.8130569458008, -1.34064075222612, 218, 25, 'PPL', 'P'),
(10824, 'Norden', 35.5541687011719, 0.620537306644965, -90.1341705322266, -1.5731380443414, 218, 4, 'PPL', 'P'),
(183662, 'Norden', 39.3180618286133, 0.686229634412004, -120.355003356934, -2.10059107982732, 218, 6, 'PPL', 'P'),
(199564, 'Norden', 42.8686103820801, 0.748198396921922, -100.073608398438, -1.74661396090418, 218, 35, 'PPL', 'P'),
(96570, 'Nordheim', 28.9208297729492, 0.504763701946768, -97.6094436645508, -1.70360617298633, 218, 51, 'PPL', 'P'),
(205120, 'Nordic Valley Estates', 41.3058280944824, 0.720922700511494, -111.856391906738, -1.95226232817372, 218, 52, 'PPL', 'P'),
(104695, 'Nordic Village', 39.3055610656738, 0.6860114549397, -78.3083267211914, -1.36673813301225, 218, 53, 'PPL', 'P'),
(208255, 'Nordland', 48.0511093139648, 0.8386500667644, -122.689720153809, -2.1413395750344, 218, 56, 'PPL', 'P'),
(56553, 'Nordlow (historical)', 36.5969390869141, 0.638737083218458, -89.8952789306641, -1.56896859933878, 218, 29, 'PPL', 'P'),
(195390, 'Nordman', 48.6338882446289, 0.84882147791574, -116.944717407227, -2.04107036157043, 218, 17, 'PPL', 'P'),
(165274, 'Nordmont', 41.3791694641113, 0.72220274888944, -76.4741668701172, -1.33472600460311, 218, 45, 'PPL', 'P'),
(117050, 'Nordness', 43.2344398498535, 0.754583325635387, -91.7716674804688, -1.60171775757959, 218, 16, 'PPL', 'P'),
(208256, 'Nordrum (historical)', 47.5588912963867, 0.830059241720023, -121.533889770508, -2.12116652925122, 218, 56, 'PPL', 'P'),
(190552, 'Nordyke', 38.8913917541504, 0.678782836792897, -119.186111450195, -2.08019006745482, 218, 39, 'PPL', 'P'),
(89451, 'Norene', 36.0566711425781, 0.629307628746814, -86.2425003051758, -1.50521558547753, 218, 50, 'PPL', 'P'),
(61084, 'Norfield', 31.4074993133545, 0.548164272835894, -90.4672164916992, -1.57895079289466, 218, 30, 'PPL', 'P'),
(17290, 'Norfleet', 30.4424991607666, 0.531321842890988, -84.3919372558594, -1.47291716725121, 218, 12, 'PPL', 'P'),
(37447, 'Norfleet', 37.0361099243164, 0.646402060309869, -84.79638671875, -1.47997614203658, 218, 21, 'PPL', 'P'),
(67225, 'Norfleet', 36.1419410705566, 0.630795869742978, -77.2988891601563, -1.34912012397888, 218, 33, 'PPL', 'P'),
(61085, 'Norfolk', 34.9513893127441, 0.610016821653743, -90.2305603027344, -1.57482036320201, 218, 30, 'PPL', 'P'),
(104696, 'Norfolk', 36.8466682434082, 0.643095679237509, -76.2855606079102, -1.33143420433772, 218, 53, 'PPL', 'P'),
(112985, 'Norfolk', 41.9938888549805, 0.732931626235961, -73.2024993896484, -1.2776246350385, 218, 8, 'PPL', 'P'),
(125571, 'Norfolk', 42.1194381713867, 0.735122875180878, -71.3255615234375, -1.24486588941777, 218, 23, 'PPL', 'P'),
(142523, 'Norfolk', 42.0283317565918, 0.733532768273019, -97.4166717529297, -1.70024166842318, 218, 35, 'PPL', 'P'),
(151120, 'Norfolk', 44.8008308410645, 0.781922005805595, -74.9913864135742, -1.30884660355221, 218, 40, 'PPL', 'P'),
(194347, 'Norfolk', 40.910831451416, 0.71402870855566, -104.969169616699, -1.8320576228958, 218, 7, 'PPL', 'P'),
(56552, 'Norfolk (historical)', 36.9294395446777, 0.644540310970822, -89.1172180175781, -1.55538887462435, 218, 29, 'PPL', 'P'),
(49827, 'Norfolk Downs', 38.4866714477539, 0.671719134896598, -75.7022171020508, -1.32125293949035, 218, 25, 'PPL', 'P'),
(125573, 'Norfolk Downs', 42.2722206115723, 0.737789431801347, -71.0208282470703, -1.23954729040477, 218, 23, 'PPL', 'P'),
(104697, 'Norfolk Highlands', 36.815559387207, 0.642552727270269, -76.2322235107422, -1.33050329637868, 218, 53, 'PPL', 'P'),
(142525, 'Norfolk Mobile Home Community', 42.0283317565918, 0.733532768273019, -97.4166717529297, -1.70024166842318, 218, 35, 'PPL', 'P'),
(10825, 'Norfork', 36.2094383239746, 0.631973919051174, -92.2841720581055, -1.61066264989089, 218, 4, 'PPL', 'P'),
(10826, 'Norfork Lake Estates', 36.3861083984375, 0.635057393540295, -92.1997222900391, -1.60918872338559, 218, 4, 'PPL', 'P'),
(10827, 'Norfork Village', 36.2222213745117, 0.632197025371496, -92.3069381713867, -1.61105999352553, 218, 4, 'PPL', 'P'),
(193820, 'Norgaar (historical)', 40.415828704834, 0.705389280821389, -123.406936645508, -2.15385736426416, 218, 6, 'PPL', 'P'),
(76729, 'Norge', 34.9883308410645, 0.610661572953652, -97.9966735839844, -1.71036461004268, 218, 42, 'PPL', 'P'),
(104699, 'Norge', 37.3686103820801, 0.652205288062234, -76.7708282470703, -1.33990372239444, 218, 53, 'PPL', 'P'),
(197158, 'Norheim (historical)', 48.9925003051758, 0.855080439109644, -109.273612976074, -1.90718433198249, 218, 31, 'PPL', 'P'),
(33442, 'Noria', 38.9494400024414, 0.679795969850591, -95.1769409179688, -1.66115099099467, 218, 20, 'PPL', 'P'),
(189118, 'Noria', 31.8047199249268, 0.555097080364616, -106.862777709961, -1.86510731886562, 218, 38, 'PPL', 'P'),
(96571, 'Noria Willie', 27.0852794647217, 0.472727305482201, -98.1269378662109, -1.71263815066528, 218, 51, 'PPL', 'P'),
(96573, 'Norias', 26.7897205352783, 0.467568829029744, -97.7758331298828, -1.70651021699701, 218, 51, 'PPL', 'P'),
(37448, 'Noris', 37.9972190856934, 0.663176579646979, -82.7191696166992, -1.44372186432706, 218, 21, 'PPL', 'P'),
(17291, 'Norland', 25.9486103057861, 0.452888686152901, -80.2125015258789, -1.39997225288756, 218, 12, 'PPL', 'P'),
(104700, 'Norland', 37.1641693115234, 0.648637118254718, -82.5244369506836, -1.4403231381439, 218, 53, 'PPL', 'P'),
(195389, 'Norland', 42.7947196960449, 0.746908761164051, -113.672500610352, -1.9839594046259, 218, 17, 'PPL', 'P'),
(67226, 'Norlina', 36.4455604553223, 0.636095027680017, -78.1986083984375, -1.36482318703042, 218, 33, 'PPL', 'P'),
(42306, 'Norma', 31.0419406890869, 0.541784071233364, -92.1336135864258, -1.60803490884331, 218, 22, 'PPL', 'P'),
(71175, 'Norma', 39.4961090087891, 0.689337143929963, -75.0883331298828, -1.31053864295079, 218, 37, 'PPL', 'P'),
(89452, 'Norma', 36.3369407653809, 0.634199256458044, -84.3855590820313, -1.47280584711765, 218, 50, 'PPL', 'P'),
(175564, 'Norma', 44.9516716003418, 0.784554673701193, -91.3694381713867, -1.59469753178809, 218, 57, 'PPL', 'P'),
(198677, 'Norma', 48.728889465332, 0.850479562010423, -101.972778320313, -1.77976072909575, 218, 34, 'PPL', 'P'),
(123314, 'Norma Jean Addition', 40.3763885498047, 0.70470092025863, -86.883056640625, -1.51639540257563, 218, 19, 'PPL', 'P'),
(4592, 'Normal', 34.788890838623, 0.607180688250863, -86.5719375610352, -1.51096535027101, 218, 2, 'PPL', 'P'),
(89453, 'Normal', 35.1161117553711, 0.612891770629511, -89.9366683959961, -1.56969098178446, 218, 50, 'PPL', 'P'),
(112348, 'Normal', 38.4436111450195, 0.670967590836978, -82.6125030517578, -1.44186018156704, 218, 21, 'PPL', 'P'),
(120791, 'Normal', 40.5141716003418, 0.707105688143945, -88.9905624389648, -1.55317831776153, 218, 18, 'PPL', 'P'),
(123315, 'Normal', 40.4650001525879, 0.706247484482667, -85.8252792358398, -1.49793370410893, 218, 19, 'PPL', 'P'),
(183663, 'Normal Heights', 32.7633285522461, 0.571827957149361, -117.121940612793, -2.0441634900185, 218, 6, 'PPL', 'P'),
(178723, 'Normal Junction', 33.410831451416, 0.583129014656085, -111.91471862793, -1.9532803215004, 218, 5, 'PPL', 'P'),
(165271, 'Normal Square', 40.788890838623, 0.711900443370523, -75.8011093139648, -1.32297893419283, 218, 45, 'PPL', 'P'),
(78848, 'Normalville', 39.9986114501953, 0.698107466031812, -79.4483337402344, -1.38663500899039, 218, 45, 'PPL', 'P'),
(4593, 'Norman', 32.5566711425781, 0.568221104927013, -87.2980575561523, -1.52363853495037, 218, 2, 'PPL', 'P'),
(10828, 'Norman', 34.4550018310547, 0.601353225732579, -93.6800003051758, -1.63502444859461, 218, 4, 'PPL', 'P'),
(17292, 'Norman', 28.5552806854248, 0.498383666791806, -82.4866714477539, -1.4396640057741, 218, 12, 'PPL', 'P'),
(23396, 'Norman', 33.9338912963867, 0.592258131135795, -82.7633285522461, -1.44449258314653, 218, 13, 'PPL', 'P'),
(30673, 'Norman', 38.9524993896484, 0.679849366230447, -86.2750015258789, -1.50578283878972, 218, 19, 'PPL', 'P'),
(67227, 'Norman', 35.170280456543, 0.613837192816489, -79.7230606079102, -1.39142989737502, 218, 33, 'PPL', 'P'),
(76730, 'Norman', 35.2224998474121, 0.614748593120542, -97.4391708374023, -1.70063435152591, 218, 42, 'PPL', 'P'),
(96572, 'Norman', 30.4939498901367, 0.532219827521049, -97.493896484375, -1.70158949425087, 218, 51, 'PPL', 'P'),
(104701, 'Norman', 38.5125007629395, 0.672169941490122, -78.0652770996094, -1.36249611686991, 218, 53, 'PPL', 'P'),
(140598, 'Norman', 46.6588897705078, 0.814351251820463, -96.9430618286133, -1.69197561587374, 218, 34, 'PPL', 'P'),
(142527, 'Norman', 40.4797210693359, 0.706504412948832, -98.7919387817383, -1.72424460617001, 218, 35, 'PPL', 'P'),
(165272, 'Norman', 41.1072196960449, 0.717456330036647, -79.0927810668945, -1.38042944417634, 218, 45, 'PPL', 'P'),
(175565, 'Norman', 44.3708305358887, 0.774417084695697, -87.6033325195313, -1.52896658818524, 218, 57, 'PPL', 'P'),
(183665, 'Norman', 39.4080581665039, 0.687800366822933, -122.190826416016, -2.13263223669234, 218, 6, 'PPL', 'P'),
(208257, 'Norman', 48.208610534668, 0.84139898164158, -122.265556335449, -2.1339365198362, 218, 56, 'PPL', 'P'),
(117052, 'Norman (historical)', 43.4930610656738, 0.759097117366962, -93.498893737793, -1.6318635426968, 218, 16, 'PPL', 'P'),
(82611, 'Norman Landing', 32.9844398498535, 0.575687077305968, -80.4086074829102, -1.40339494752053, 218, 48, 'PPL', 'P'),
(23397, 'Norman Park', 31.2688903808594, 0.54574509059118, -83.6872177124023, -1.46061749091474, 218, 13, 'PPL', 'P'),
(123316, 'Normanda', 40.3025016784668, 0.703411351079787, -86.1647186279297, -1.50385803911186, 218, 19, 'PPL', 'P'),
(4594, 'Normandale', 31.2124996185303, 0.544760886120827, -85.4075012207031, -1.49064210220235, 218, 2, 'PPL', 'P'),
(145903, 'Normandie', 40.3797187805176, 0.704759043749421, -73.9755630493164, -1.29111714122723, 218, 37, 'PPL', 'P'),
(17293, 'Normandy', 30.3055591583252, 0.528931788970696, -81.7608337402344, -1.42699574794276, 218, 12, 'PPL', 'P'),
(23398, 'Normandy', 33.6111106872559, 0.586624546744869, -84.4563903808594, -1.47404208649566, 218, 13, 'PPL', 'P'),
(37449, 'Normandy', 38.0980606079102, 0.664936596232385, -85.3427810668945, -1.48951252242599, 218, 21, 'PPL', 'P'),
(56555, 'Normandy', 38.7208290100098, 0.675805955326407, -90.2972183227539, -1.57598376512421, 218, 29, 'PPL', 'P'),
(89455, 'Normandy', 35.4519386291504, 0.618753055293639, -86.2600021362305, -1.50552105005456, 218, 50, 'PPL', 'P'),
(120794, 'Normandy', 41.561939239502, 0.725392683243137, -89.649169921875, -1.56467318681659, 218, 18, 'PPL', 'P'),
(165273, 'Normandy', 40.103328704834, 0.699935126908906, -74.9961090087891, -1.30892902838795, 218, 45, 'PPL', 'P'),
(191947, 'Normandy', 28.9099998474121, 0.5045746840884, -100.597503662109, -1.75575765819086, 218, 51, 'PPL', 'P'),
(145904, 'Normandy Beach', 40.002498626709, 0.698175310060582, -74.0608291625977, -1.29260531564436, 218, 37, 'PPL', 'P'),
(49828, 'Normandy Heights', 39.288890838623, 0.685720504590608, -76.8055572509766, -1.34050985785855, 218, 25, 'PPL', 'P'),
(14305, 'Normandy Manor', 39.7866706848145, 0.694408401856719, -75.5144424438477, -1.31797565345289, 218, 10, 'PPL', 'P'),
(205122, 'Normandy Mobile Homes Estates', 40.6375007629395, 0.709258188095001, -111.941108703613, -1.95374091521093, 218, 52, 'PPL', 'P'),
(82612, 'Normandy Park', 34.4752807617188, 0.601707159841451, -82.6022186279297, -1.44168068450957, 218, 48, 'PPL', 'P'),
(208258, 'Normandy Park', 47.4363899230957, 0.82792118941788, -122.33943939209, -2.13522602243602, 218, 56, 'PPL', 'P'),
(82613, 'Normandy Park Junior', 34.4786109924316, 0.601765283332242, -82.6074981689453, -1.44177282988328, 218, 48, 'PPL', 'P'),
(17294, 'Normandy Shores', 25.8594398498535, 0.451332368101372, -80.1391677856445, -1.39869233766767, 218, 12, 'PPL', 'P'),
(17295, 'Normandy Village', 30.2794399261475, 0.528475922371102, -81.7813873291016, -1.42735447574159, 218, 12, 'PPL', 'P'),
(42308, 'Normandy Village', 32.4722213745117, 0.566747178421708, -93.7527770996094, -1.63629464327652, 218, 22, 'PPL', 'P'),
(49829, 'Normandy Woods', 39.2830581665039, 0.68561870525794, -76.8050003051758, -1.34050013732057, 218, 25, 'PPL', 'P'),
(96574, 'Normangee', 31.0294399261475, 0.541565891761059, -96.1144409179688, -1.67751345273212, 218, 51, 'PPL', 'P'),
(137154, 'Normania', 44.646671295166, 0.779231414156288, -95.8083267211914, -1.67217075211125, 218, 28, 'PPL', 'P'),
(96575, 'Normanna', 28.5294399261475, 0.497932660461201, -97.7819366455078, -1.70661674344061, 218, 51, 'PPL', 'P'),
(145905, 'Normanook', 41.1866683959961, 0.718842971437224, -74.8027801513672, -1.30555480328682, 218, 37, 'PPL', 'P'),
(49830, 'Normans', 38.9413909912109, 0.679655488103089, -76.3525009155273, -1.33260253310794, 218, 25, 'PPL', 'P'),
(96576, 'Normans Crossing', 30.4911098480225, 0.53217025943526, -97.4897232055664, -1.70151665679505, 218, 51, 'PPL', 'P'),
(151122, 'Normansville', 42.6341705322266, 0.744106649644097, -73.7980575561523, -1.28801908593114, 218, 40, 'PPL', 'P'),
(23400, 'Normantown', 32.3061103820801, 0.563847994680021, -82.3697204589844, -1.43762282595661, 218, 13, 'PPL', 'P'),
(110671, 'Normantown', 38.8516693115234, 0.678089549382123, -80.9366683959961, -1.41261134910497, 218, 58, 'PPL', 'P'),
(120796, 'Normantown', 41.6547203063965, 0.72701201834396, -88.2322235107422, -1.539942806618, 218, 18, 'PPL', 'P'),
(67230, 'Normanville', 35.9630584716797, 0.62767377941805, -82.1177825927734, -1.43322568068078, 218, 33, 'PPL', 'P'),
(205124, 'Normikemark Estates', 40.6569404602051, 0.709597474817877, -111.815277099609, -1.951544739418, 218, 52, 'PPL', 'P'),
(113806, 'Noroton', 41.0644416809082, 0.716709712825043, -73.4891662597656, -1.28262791577844, 218, 8, 'PPL', 'P'),
(113807, 'Noroton Heights', 41.0750007629395, 0.716894003572476, -73.4922180175781, -1.28268117900024, 218, 8, 'PPL', 'P'),
(10830, 'Norphlet', 33.3158302307129, 0.581470930561402, -92.6627807617188, -1.61727061834565, 218, 4, 'PPL', 'P'),
(191948, 'Norrick', 35.2127799987793, 0.614578949759104, -100.136108398438, -1.74770479168668, 218, 51, 'PPL', 'P'),
(120797, 'Norridge', 41.9633293151855, 0.732398261648645, -87.8272171020508, -1.53287411129466, 218, 18, 'PPL', 'P'),
(128271, 'Norridgewock', 44.7130584716797, 0.780390088967554, -69.7911071777344, -1.21808460886371, 218, 26, 'PPL', 'P'),
(132303, 'Norrie', 46.4463882446289, 0.810642400528364, -90.1627807617188, -1.57363738704579, 218, 27, 'PPL', 'P'),
(175566, 'Norrie', 44.8855590820313, 0.783400792579889, -89.2541732788086, -1.55777919486075, 218, 57, 'PPL', 'P'),
(187113, 'Norrie', 39.3247184753418, 0.686345814814559, -106.654998779297, -1.86148089240926, 218, 7, 'PPL', 'P'),
(151123, 'Norrie Heights', 41.839168548584, 0.730231247469648, -73.9255599975586, -1.29024442333801, 218, 40, 'PPL', 'P'),
(67231, 'Norrington Crossroads', 35.353328704834, 0.617031987439176, -78.9130630493164, -1.37729277304445, 218, 33, 'PPL', 'P'),
(23401, 'Norris', 33.3824996948242, 0.582634532220685, -82.7241668701172, -1.44380908285276, 218, 13, 'PPL', 'P'),
(56557, 'Norris', 38.5205612182617, 0.672310622974705, -93.8952789306641, -1.63878176941855, 218, 29, 'PPL', 'P'),
(61086, 'Norris', 32.2938919067383, 0.563634742055733, -89.4358291625977, -1.56094968813849, 218, 30, 'PPL', 'P'),
(76732, 'Norris', 34.9988899230957, 0.610845863701085, -94.9702835083008, -1.65754413877232, 218, 42, 'PPL', 'P'),
(82615, 'Norris', 34.7599983215332, 0.606676418698457, -82.7538909912109, -1.4443278666331, 218, 48, 'PPL', 'P'),
(89457, 'Norris', 36.2708282470703, 0.63304537533674, -81.9291687011719, -1.42993374725734, 218, 50, 'PPL', 'P'),
(120798, 'Norris', 40.6258316040039, 0.709054522850637, -90.0319366455078, -1.57135372641105, 218, 18, 'PPL', 'P'),
(197159, 'Norris', 45.5680618286133, 0.79531271266165, -111.690002441406, -1.94935828416304, 218, 31, 'PPL', 'P'),
(202428, 'Norris', 43.473331451416, 0.758752770638015, -101.195831298828, -1.76620044545728, 218, 49, 'PPL', 'P'),
(67232, 'Norris (historical)', 36.2694396972656, 0.633021140570821, -81.6561126708984, -1.42516802048664, 218, 33, 'PPL', 'P'),
(28065, 'Norris City', 37.9811096191406, 0.662895416414893, -88.3291702270508, -1.54163484601658, 218, 18, 'PPL', 'P'),
(49832, 'Norris Corner', 39.475830078125, 0.688983209821092, -76.2966690063477, -1.33162808246508, 218, 25, 'PPL', 'P'),
(125575, 'Norris Corner', 42.689998626709, 0.745081033707929, -71.4016723632813, -1.2461942741695, 218, 23, 'PPL', 'P'),
(4598, 'Norris Junction', 33.5497207641602, 0.585553090459303, -86.6733322143555, -1.51273502081537, 218, 2, 'PPL', 'P'),
(23402, 'Norris Lake Shores', 33.7661094665527, 0.589329785780171, -84.0327835083008, -1.46664875183544, 218, 13, 'PPL', 'P'),
(89458, 'Norris Park', 36.2249984741211, 0.632245494903335, -84.0780563354492, -1.46743891173087, 218, 50, 'PPL', 'P'),
(49848, 'Norris Run Woods', 39.4527816772461, 0.688580939338435, -76.8522186279297, -1.34132425251989, 218, 25, 'PPL', 'P'),
(117053, 'Norris Siding', 42.5499992370605, 0.742637583407782, -92.4805603027344, -1.61409027137188, 218, 16, 'PPL', 'P'),
(42309, 'Norris Springs', 31.8575000762939, 0.556018267785674, -91.7138900756836, -1.60070935163283, 218, 22, 'PPL', 'P'),
(96577, 'Norris Tract Number 2 Colonia', 28.0330009460449, 0.489268165723169, -97.8899993896484, -1.7085027941246, 218, 51, 'PPL', 'P'),
(23403, 'Norristown', 32.5066719055176, 0.567348453616821, -82.4944381713867, -1.43979956067359, 218, 13, 'PPL', 'P'),
(30674, 'Norristown', 39.3652801513672, 0.687053749611329, -85.7605590820313, -1.49680412433257, 218, 19, 'PPL', 'P'),
(156797, 'Norristown', 40.6652793884277, 0.70974301657145, -80.9516677856445, -1.41287313784012, 218, 41, 'PPL', 'P'),
(165275, 'Norristown', 40.1213912963867, 0.700250378602944, -75.3402786254883, -1.31493592138468, 218, 45, 'PPL', 'P'),
(23404, 'Norristown Junction', 32.5574989318848, 0.568235552575926, -82.4886093139648, -1.43969782791995, 218, 13, 'PPL', 'P'),
(49833, 'Norrisville', 39.704719543457, 0.692978084614265, -76.5350036621094, -1.33578780692973, 218, 25, 'PPL', 'P'),
(165277, 'Norrisville', 41.7158317565918, 0.728078614360537, -80.2702789306641, -1.40098065883432, 218, 45, 'PPL', 'P'),
(165278, 'Norritonville', 40.1644401550293, 0.701001722925483, -75.3361129760742, -1.31486321708692, 218, 45, 'PPL', 'P'),
(96578, 'Norse', 31.755880355835, 0.554244669078709, -97.6721878051758, -1.70470126482657, 218, 51, 'PPL', 'P'),
(137157, 'Norseland', 44.4127807617188, 0.775149254258387, -94.1163864135742, -1.64264082299613, 218, 28, 'PPL', 'P'),
(137158, 'Norshor Junction', 47.3666687011719, 0.826704324536795, -91.6255569458008, -1.59916764767778, 218, 28, 'PPL', 'P'),
(175568, 'Norske', 44.6525001525879, 0.779333146909929, -89.2083282470703, -1.55697904811124, 218, 57, 'PPL', 'P'),
(61087, 'Nortac', 30.7849998474121, 0.537299607563293, -89.5666732788086, -1.56323334877324, 218, 30, 'PPL', 'P'),
(151124, 'Norten', 42.524169921875, 0.742186776814259, -76.5266723632813, -1.33564239833421, 218, 40, 'PPL', 'P'),
(82617, 'North', 33.6155586242676, 0.586702177890645, -81.1022186279297, -1.41550074572965, 218, 48, 'PPL', 'P'),
(4599, 'North (historical)', 34.4111099243164, 0.600587167445018, -86.274169921875, -1.50576832456178, 218, 2, 'PPL', 'P'),
(96579, 'North Abilene', 32.5447196960449, 0.568012512834632, -99.769172668457, -1.74130055505531, 218, 51, 'PPL', 'P'),
(125576, 'North Abington', 42.1291694641113, 0.735292718279398, -70.9499969482422, -1.23831105102676, 218, 23, 'PPL', 'P'),
(49834, 'North Accokeek', 38.6694412231445, 0.674909069250295, -77.0069427490234, -1.34402469786523, 218, 25, 'PPL', 'P'),
(189119, 'North Acomita Village', 35.0633316040039, 0.611970583208453, -107.565277099609, -1.87736824620824, 218, 38, 'PPL', 'P'),
(82618, 'North Acres', 34.8919410705566, 0.608979254093048, -82.3672180175781, -1.43757915011474, 218, 48, 'PPL', 'P'),
(125577, 'North Acton', 42.5125007629395, 0.741983111569895, -71.4124984741211, -1.24638322544884, 218, 23, 'PPL', 'P'),
(125578, 'North Adams', 42.7008285522461, 0.745270051566298, -73.1091690063477, -1.27599571255776, 218, 23, 'PPL', 'P'),
(132304, 'North Adams', 41.9708290100098, 0.732529156016222, -84.5258331298828, -1.47525409110776, 218, 27, 'PPL', 'P'),
(151125, 'North Adams', 43.8861083984375, 0.76595708743987, -76.0297164916992, -1.32696888213798, 218, 40, 'PPL', 'P'),
(151126, 'North Afton', 42.2677803039551, 0.737711933813626, -75.5436096191406, -1.31848471669526, 218, 40, 'PPL', 'P'),
(125580, 'North Agawam', 42.0977783203125, 0.734744839464141, -72.6361083984375, -1.26773924738824, 218, 23, 'PPL', 'P'),
(156798, 'North Akron', 41.107780456543, 0.717466117153653, -81.5105590820313, -1.42262763112281, 218, 41, 'PPL', 'P'),
(4600, 'North Alabama Junction', 33.2822189331055, 0.580884302752285, -87.2858276367188, -1.523425082589, 218, 2, 'PPL', 'P'),
(96580, 'North Alamo', 26.2169399261475, 0.457571921508832, -98.1286087036133, -1.71266731227922, 218, 51, 'PPL', 'P'),
(96581, 'North Alamo Village Colonia', 26.2089996337891, 0.457433337263607, -98.0970001220703, -1.71211563845941, 218, 51, 'PPL', 'P'),
(201310, 'North Albany', 44.6530609130859, 0.779342934026935, -123.100563049316, -2.14851013626944, 218, 43, 'PPL', 'P'),
(151127, 'North Alexander', 42.9294395446777, 0.749260066090482, -78.241943359375, -1.36557952478001, 218, 40, 'PPL', 'P'),
(128273, 'North Alfred', 43.521671295166, 0.759596460071352, -70.7647171020508, -1.23507730767313, 218, 26, 'PPL', 'P'),
(96582, 'North Alfred Colonia', 27.8899993896484, 0.486772317728574, -97.9739990234375, -1.70996886430469, 218, 51, 'PPL', 'P'),
(177388, 'North Almond', 42.3905601501465, 0.739854846384758, -77.7699966430664, -1.35734250068645, 218, 40, 'PPL', 'P'),
(198680, 'North Almont', 46.8397216796875, 0.817507364028316, -101.509170532227, -1.77166924675576, 218, 34, 'PPL', 'P'),
(28064, 'North Alton', 38.9222183227539, 0.679320861912121, -90.1963882446289, -1.57422394827588, 218, 18, 'PPL', 'P'),
(151128, 'North Amboy', 43.4036102294922, 0.75753590575693, -75.8866729736328, -1.32447230177409, 218, 40, 'PPL', 'P'),
(117054, 'North American Trailer Park', 41.3388900756836, 0.721499740940687, -93.5583267211914, -1.63290084394138, 218, 16, 'PPL', 'P'),
(125581, 'North Amherst', 42.4102783203125, 0.740198993376623, -72.5313873291016, -1.26591151993212, 218, 23, 'PPL', 'P'),
(128274, 'North Amity', 45.9416694641113, 0.801833396011682, -67.8308334350586, -1.18387137781363, 218, 26, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(151129, 'North Amityville', 40.6974983215332, 0.71030534303562, -73.4255599975586, -1.28151777707804, 218, 40, 'PPL', 'P'),
(123317, 'North Anderson', 40.1352806091309, 0.700492792841169, -85.6780624389648, -1.49536428628922, 218, 19, 'PPL', 'P'),
(113073, 'North Andover', 42.6986083984375, 0.745231302572437, -71.1355590820313, -1.2415497212284, 218, 23, 'PPL', 'P'),
(175569, 'North Andover', 42.815559387207, 0.747272482389928, -90.9658279418945, -1.58765320438872, 218, 57, 'PPL', 'P'),
(125582, 'North Andover Center', 42.6833305358887, 0.744964653568293, -71.1125030517578, -1.24114731758769, 218, 23, 'PPL', 'P'),
(17297, 'North Andrew Gardens', 26.1783294677734, 0.456898041884501, -80.1458282470703, -1.39880858464925, 218, 12, 'PPL', 'P'),
(17298, 'North Andrews Gardens', 26.1911106109619, 0.457121114915309, -80.1444396972656, -1.39878434988333, 218, 12, 'PPL', 'P'),
(104703, 'North Anna', 37.8908309936523, 0.661319757155948, -77.5177764892578, -1.3529404285626, 218, 53, 'PPL', 'P'),
(128275, 'North Anson', 44.8549995422363, 0.782867427992573, -69.9002838134766, -1.21999010062366, 218, 26, 'PPL', 'P'),
(165281, 'North Apollo', 40.5961112976074, 0.708535805649317, -79.5558319091797, -1.38851120597835, 218, 45, 'PPL', 'P'),
(128276, 'North Appleton', 44.3041687011719, 0.773253616194469, -69.209716796875, -1.20793743247829, 218, 26, 'PPL', 'P'),
(4601, 'North Arab', 34.3430595397949, 0.59939946417787, -86.5044403076172, -1.50978730096282, 218, 2, 'PPL', 'P'),
(151130, 'North Argyle', 43.2669410705566, 0.755150578947574, -73.466667175293, -1.2822352326757, 218, 40, 'PPL', 'P'),
(145906, 'North Arlington', 40.788330078125, 0.711890656253517, -74.1336135864258, -1.29387564348433, 218, 37, 'PPL', 'P'),
(132306, 'North Arms', 44.9711112976074, 0.784893960424069, -85.2313919067383, -1.48756841483023, 218, 27, 'PPL', 'P'),
(125584, 'North Ashburnham', 42.6749992370605, 0.744819244972775, -71.9436111450195, -1.25565289025508, 218, 23, 'PPL', 'P'),
(67233, 'North Asheboro', 35.7369384765625, 0.623727240998662, -79.8083267211914, -1.39291807179216, 218, 33, 'PPL', 'P'),
(113808, 'North Ashford', 41.9541702270508, 0.732238405404213, -72.1052780151367, -1.25847450943002, 218, 8, 'PPL', 'P'),
(23405, 'North Atlanta', 33.8650016784668, 0.591055780482652, -84.336669921875, -1.47195257030439, 218, 13, 'PPL', 'P'),
(125585, 'North Attleboro', 41.9833297729492, 0.732747335488527, -71.3333282470703, -1.24500144431725, 218, 23, 'PPL', 'P'),
(192926, 'North Atwood', 39.8236083984375, 0.6950530865776, -101.04638671875, -1.76359214548566, 218, 20, 'PPL', 'P'),
(4602, 'North Auburn', 32.6547203063965, 0.56993238566447, -85.4511108398438, -1.49140323364189, 218, 2, 'PPL', 'P'),
(128277, 'North Auburn', 44.1772193908691, 0.77103793274655, -70.2738876342773, -1.22651071739467, 218, 26, 'PPL', 'P'),
(156799, 'North Auburn', 40.9674987792969, 0.715017740005488, -82.7922210693359, -1.44499685269893, 218, 41, 'PPL', 'P'),
(183666, 'North Auburn', 38.9313888549805, 0.679480917893634, -121.080833435059, -2.11325920450061, 218, 6, 'PPL', 'P'),
(82619, 'North Augusta', 33.5016708374023, 0.584714461032037, -81.9652786254883, -1.4305639843293, 218, 48, 'PPL', 'P'),
(128278, 'North Augusta', 44.3705596923828, 0.774412357584762, -69.7922210693359, -1.21810404993967, 218, 26, 'PPL', 'P'),
(30675, 'North Augusta Addition', 39.9280586242676, 0.696876086922787, -86.227783203125, -1.50495872359039, 218, 19, 'PPL', 'P'),
(132307, 'North Aurelius', 42.5819396972656, 0.743195049602963, -84.5430603027344, -1.47555476199483, 218, 27, 'PPL', 'P'),
(120799, 'North Aurora', 41.8061103820801, 0.729654273619482, -88.3272171020508, -1.54160075755463, 218, 18, 'PPL', 'P'),
(113161, 'North Avon', 42.9300003051758, 0.749269853207488, -77.6780624389648, -1.35573794612967, 218, 40, 'PPL', 'P'),
(49835, 'North Avondale', 38.9550018310547, 0.679893042072324, -76.9797210693359, -1.34354958992676, 218, 25, 'PPL', 'P'),
(187114, 'North Avondale', 38.2619400024414, 0.66779683124313, -104.345558166504, -1.82117354983675, 218, 7, 'PPL', 'P'),
(151131, 'North Babylon', 40.7163887023926, 0.710635042378572, -73.3222198486328, -1.27971415122978, 218, 40, 'PPL', 'P'),
(151132, 'North Bailey', 42.9905586242676, 0.750326795265113, -78.8047180175781, -1.37540179551244, 218, 40, 'PPL', 'P'),
(17299, 'North Bal Harbor', 26.1536102294922, 0.456466609787908, -80.1163864135742, -1.39829472771692, 218, 12, 'PPL', 'P'),
(128279, 'North Baldwin', 43.8455581665039, 0.765249352380181, -70.6894378662109, -1.23376343714934, 218, 26, 'PPL', 'P'),
(156800, 'North Baltimore', 41.1827812194824, 0.718775127408454, -83.6783294677734, -1.46046236178124, 218, 41, 'PPL', 'P'),
(128280, 'North Bancroft', 45.7519416809082, 0.798522021512277, -67.9463882446289, -1.18588818970714, 218, 26, 'PPL', 'P'),
(128281, 'North Bangor', 44.8394393920898, 0.782595852140412, -68.8311080932617, -1.20132946402353, 218, 26, 'PPL', 'P'),
(151133, 'North Bangor', 44.8419418334961, 0.78263952798229, -74.4013900756836, -1.29854922488131, 218, 40, 'PPL', 'P'),
(165283, 'North Bangor', 40.9047203063965, 0.713922048954002, -75.1944427490234, -1.31239060517284, 218, 45, 'PPL', 'P'),
(23406, 'North Banks Cove', 34.3519401550293, 0.599554460153313, -83.8333282470703, -1.46316760081654, 218, 13, 'PPL', 'P'),
(49836, 'North Barnaby', 38.8216705322266, 0.677565971911813, -76.9550018310547, -1.34311815783017, 218, 25, 'PPL', 'P'),
(165284, 'North Barnesboro', 40.6699981689453, 0.709825374828161, -78.7908325195313, -1.37515944785324, 218, 45, 'PPL', 'P'),
(67234, 'North Barringer (historical)', 35.5475006103516, 0.620420926505329, -80.4524993896484, -1.40416100580809, 218, 33, 'PPL', 'P'),
(120800, 'North Barrington', 42.2077789306641, 0.736664712293979, -88.1405563354492, -1.53834291259314, 218, 18, 'PPL', 'P'),
(183667, 'North Barstow', 34.9166717529297, 0.609410885926723, -117.018890380859, -2.04236492417632, 218, 6, 'PPL', 'P'),
(151134, 'North Barton', 42.1188888549805, 0.735113287800954, -76.4908294677734, -1.33501682179415, 218, 40, 'PPL', 'P'),
(104704, 'North Bassett', 36.7691688537598, 0.641743059719857, -79.9994430541992, -1.39625368105748, 218, 53, 'PPL', 'P'),
(128282, 'North Bath', 43.9347190856934, 0.766805503984142, -69.8163909912109, -1.21852589465634, 218, 26, 'PPL', 'P'),
(200098, 'North Battle Mountain', 40.7127799987793, 0.710572058618792, -116.899169921875, -2.04027540798504, 218, 39, 'PPL', 'P'),
(151135, 'North Bay', 43.2299995422363, 0.754505827647665, -75.7486114501953, -1.32206267361978, 218, 40, 'PPL', 'P'),
(175571, 'North Bay', 42.764720916748, 0.746385183693741, -87.7797164916992, -1.53204506924732, 218, 57, 'PPL', 'P'),
(151136, 'North Bay Shore', 40.7361106872559, 0.710979255949465, -73.2630615234375, -1.27868164367516, 218, 40, 'PPL', 'P'),
(17300, 'North Bay Village', 25.8458309173584, 0.451094847421651, -80.154167175293, -1.39895412640283, 218, 12, 'PPL', 'P'),
(17301, 'North Beach', 27.7880592346191, 0.484993126383319, -80.414436340332, -1.40349668027417, 218, 12, 'PPL', 'P'),
(49837, 'North Beach', 38.707218170166, 0.675568401357172, -76.5313873291016, -1.33572469001189, 218, 25, 'PPL', 'P'),
(71176, 'North Beach', 39.6791687011719, 0.692532138289731, -74.1516723632813, -1.29419082859934, 218, 37, 'PPL', 'P'),
(96583, 'North Beach', 27.8208293914795, 0.485565073516928, -97.3899993896484, -1.69977614786463, 218, 51, 'PPL', 'P'),
(144217, 'North Beach', 42.9338912963867, 0.749337763815285, -70.7988891601563, -1.23567372259925, 218, 36, 'PPL', 'P'),
(151148, 'North Beach', 40.7658309936523, 0.711497973150785, -73.8763885498047, -1.28938621967673, 218, 40, 'PPL', 'P'),
(201311, 'North Beach', 43.8936080932617, 0.766087981807447, -124.10888671875, -2.16610870422685, 218, 43, 'PPL', 'P'),
(208261, 'North Beach', 48.5727806091309, 0.84775494847819, -122.628890991211, -2.14027790586584, 218, 56, 'PPL', 'P'),
(71177, 'North Beach Haven', 39.5730590820313, 0.69068017606769, -74.2319412231445, -1.29559178449078, 218, 37, 'PPL', 'P'),
(49838, 'North Beach Park', 38.7155609130859, 0.675714009689772, -76.529167175293, -1.33568594101803, 218, 25, 'PPL', 'P'),
(128283, 'North Belgrade', 44.5188903808594, 0.777001216480428, -69.7927780151367, -1.21811377047765, 218, 26, 'PPL', 'P'),
(128284, 'North Belgrade Station', 44.5058288574219, 0.776773249891118, -69.7788925170898, -1.21787142281845, 218, 26, 'PPL', 'P'),
(151137, 'North Belle Isle', 43.083610534668, 0.751950857476871, -76.2522201538086, -1.33085230363954, 218, 40, 'PPL', 'P'),
(165286, 'North Belle Vernon', 40.1291694641113, 0.700386133239511, -79.8683319091797, -1.39396535989083, 218, 45, 'PPL', 'P'),
(30676, 'North Belleville', 39.6944389343262, 0.692798654135821, -86.4944381713867, -1.50961273075336, 218, 19, 'PPL', 'P'),
(117056, 'North Bellevue', 42.2783317565918, 0.737896091403005, -90.434440612793, -1.57837874589252, 218, 16, 'PPL', 'P'),
(125587, 'North Bellingham', 42.1208305358887, 0.735147176525825, -71.4561080932617, -1.24714435688838, 218, 23, 'PPL', 'P'),
(151138, 'North Bellmore', 40.6913909912109, 0.71019875001299, -73.5338897705078, -1.28340848829394, 218, 40, 'PPL', 'P'),
(151139, 'North Bellport', 40.774169921875, 0.711643514904358, -72.9433288574219, -1.27310125592701, 218, 40, 'PPL', 'P'),
(67235, 'North Belmont', 35.2722206115723, 0.615616384161744, -81.0483322143555, -1.41456025039069, 218, 33, 'PPL', 'P'),
(183670, 'North Belridge', 35.5463905334473, 0.620401552008398, -119.78971862793, -2.09072500009496, 218, 6, 'PPL', 'P'),
(23407, 'North Bend', 34.0444412231445, 0.594187591345558, -84.6736068725586, -1.47783322946545, 218, 13, 'PPL', 'P'),
(42312, 'North Bend', 29.6825008392334, 0.518057369870603, -91.4697189331055, -1.59644776125649, 218, 22, 'PPL', 'P'),
(49840, 'North Bend', 39.2805595397949, 0.68557509599509, -76.704719543457, -1.33874990785217, 218, 25, 'PPL', 'P'),
(61088, 'North Bend', 32.8680610656738, 0.573655884342565, -88.9930572509766, -1.55322186044535, 218, 30, 'PPL', 'P'),
(73704, 'North Bend', 39.1525001525879, 0.683340038050241, -84.7480621337891, -1.47913271891935, 218, 41, 'PPL', 'P'),
(110672, 'North Bend', 38.2297210693359, 0.66723450477896, -80.4433288574219, -1.40400094982658, 218, 58, 'PPL', 'P'),
(142528, 'North Bend', 41.4619407653809, 0.723647380622754, -96.7794418334961, -1.68911990823684, 218, 35, 'PPL', 'P'),
(165288, 'North Bend', 41.3499984741211, 0.721693619068044, -77.7024993896484, -1.35616445137825, 218, 45, 'PPL', 'P'),
(175573, 'North Bend', 44.0913887023926, 0.769539904633381, -91.1166687011719, -1.59028587228431, 218, 57, 'PPL', 'P'),
(201312, 'North Bend', 43.4066696166992, 0.757589302136786, -124.22306060791, -2.1681014145125, 218, 43, 'PPL', 'P'),
(208263, 'North Bend', 47.4958305358887, 0.82895862382052, -121.78556060791, -2.12555901399514, 218, 56, 'PPL', 'P'),
(49841, 'North Bend Estates', 38.7847213745117, 0.67692108745385, -76.1255569458008, -1.32864161361866, 218, 25, 'PPL', 'P'),
(49842, 'North Bend Heights', 39.6313896179199, 0.6916982359734, -76.4619369506836, -1.33451255224174, 218, 25, 'PPL', 'P'),
(49843, 'North Bend Woodland', 38.7849998474121, 0.67692594772284, -76.1177825927734, -1.32850592556112, 218, 25, 'PPL', 'P'),
(172312, 'North Bennington', 42.9302787780762, 0.749274713476477, -73.2430572509766, -1.27833250325625, 218, 55, 'PPL', 'P'),
(137160, 'North Benton', 45.7794418334961, 0.799001989719737, -93.9458312988281, -1.63966407468769, 218, 28, 'PPL', 'P'),
(156801, 'North Benton', 40.9850006103516, 0.71532320458252, -81.0127792358398, -1.4139397338567, 218, 41, 'PPL', 'P'),
(156802, 'North Benton Station', 40.9933280944824, 0.715468546599011, -81.0216674804688, -1.4140948629902, 218, 41, 'PPL', 'P'),
(145908, 'North Bergen', 40.8041687011719, 0.712167092374667, -74.0124969482422, -1.29176175936908, 218, 37, 'PPL', 'P'),
(151140, 'North Bergen', 43.1236114501953, 0.752649005156635, -78.0136108398438, -1.36159437052481, 218, 40, 'PPL', 'P'),
(110673, 'North Berkeley', 39.6308288574219, 0.691688448856394, -78.2213897705078, -1.36522079698117, 218, 58, 'PPL', 'P'),
(125588, 'North Bernardston', 42.7194404602051, 0.74559489064026, -72.5736083984375, -1.26664841660574, 218, 23, 'PPL', 'P'),
(73705, 'North Berne', 39.7055587768555, 0.69299273200026, -82.4986114501953, -1.4398723981294, 218, 41, 'PPL', 'P'),
(128285, 'North Berwick', 43.3036117553711, 0.755790603136547, -70.73388671875, -1.23453921597488, 218, 26, 'PPL', 'P'),
(132308, 'North Bessemer', 46.5094413757324, 0.811742885269812, -90.0661087036133, -1.57195014133717, 218, 27, 'PPL', 'P'),
(165289, 'North Bessemer', 40.4933280944824, 0.70674190033904, -79.7975006103516, -1.39272912051282, 218, 45, 'PPL', 'P'),
(128287, 'North Bethel', 44.452220916748, 0.775837614821146, -70.8291702270508, -1.23620222691758, 218, 26, 'PPL', 'P'),
(49844, 'North Bethesda', 39.0444412231445, 0.681454053945274, -77.1191711425781, -1.34598345284699, 218, 25, 'PPL', 'P'),
(151141, 'North Bethlehem', 42.6699981689453, 0.744731959868047, -73.8463897705078, -1.28886264220642, 218, 40, 'PPL', 'P'),
(125589, 'North Beverly', 42.5805587768555, 0.743170947995097, -70.8874969482422, -1.23722022024426, 218, 23, 'PPL', 'P'),
(4603, 'North Bibb', 33.2038917541504, 0.57951723558572, -87.1530609130859, -1.52110786612453, 218, 2, 'PPL', 'P'),
(125590, 'North Billerica', 42.5833282470703, 0.743219284368882, -71.2850036621094, -1.24415802120002, 218, 23, 'PPL', 'P'),
(61089, 'North Biloxi', 30.4361095428467, 0.531210323020341, -88.9499969482422, -1.55247031638573, 218, 30, 'PPL', 'P'),
(10835, 'North Bingen', 33.9880599975586, 0.593203553322773, -93.7877807617188, -1.63690557243059, 218, 4, 'PPL', 'P'),
(165291, 'North Bingham', 41.9872207641602, 0.732815246096324, -77.7619400024414, -1.35720188578089, 218, 45, 'PPL', 'P'),
(4604, 'North Birmingham', 33.5536117553711, 0.5856210010671, -86.8188934326172, -1.51527554333725, 218, 2, 'PPL', 'P'),
(125591, 'North Blandford', 42.2102813720703, 0.736708388135857, -72.9819412231445, -1.27377516884085, 218, 23, 'PPL', 'P'),
(132309, 'North Blendon', 42.9288902282715, 0.749250478710558, -85.9622192382813, -1.50032375802922, 218, 27, 'PPL', 'P'),
(151142, 'North Blenheim', 42.4708290100098, 0.741255802276194, -74.4458312988281, -1.2993248705488, 218, 40, 'PPL', 'P'),
(113809, 'North Bloomfield', 41.8861083984375, 0.731050502399983, -72.746940612793, -1.26967363444602, 218, 8, 'PPL', 'P'),
(151143, 'North Bloomfield', 42.9408302307129, 0.749458871065856, -77.5772171020508, -1.35397786296524, 218, 40, 'PPL', 'P'),
(156803, 'North Bloomfield', 41.464168548584, 0.723686262774669, -80.8686065673828, -1.41142344610074, 218, 41, 'PPL', 'P'),
(175575, 'North Bloomfield', 42.5744400024414, 0.743064155235385, -88.3550033569336, -1.54208571918913, 218, 57, 'PPL', 'P'),
(183671, 'North Bloomfield', 39.3683280944824, 0.687106946254104, -120.898330688477, -2.11007393067882, 218, 6, 'PPL', 'P'),
(49845, 'North Bluff', 39.5011100769043, 0.68942442903469, -75.9161071777344, -1.32498602554837, 218, 25, 'PPL', 'P'),
(151144, 'North Bolton', 43.6016693115234, 0.760992688851853, -73.6547164916992, -1.28551731240312, 218, 40, 'PPL', 'P'),
(208264, 'North Bonneville', 45.6375007629395, 0.796524650694718, -121.970001220703, -2.12877810996277, 218, 56, 'PPL', 'P'),
(151145, 'North Boston', 42.6855583190918, 0.745003535720208, -78.7769393920898, -1.37491696703599, 218, 40, 'PPL', 'P'),
(151146, 'North Boylston', 43.6836090087891, 0.762422806357226, -76.0058288574219, -1.32655196426933, 218, 40, 'PPL', 'P'),
(165292, 'North Braddock', 40.3988914489746, 0.70509366994039, -79.8411102294922, -1.39349025195236, 218, 45, 'PPL', 'P'),
(128288, 'North Bradford', 45.1180610656738, 0.78745871771187, -68.9622192382813, -1.20361778519018, 218, 26, 'PPL', 'P'),
(132310, 'North Bradley', 43.7113914489746, 0.762907701412702, -84.4899978637695, -1.47462864772575, 218, 27, 'PPL', 'P'),
(37450, 'North Branch', 38.3302803039551, 0.668989594516349, -82.8061065673828, -1.44523920035813, 218, 21, 'PPL', 'P'),
(49846, 'North Branch', 39.5894393920898, 0.69096606641071, -78.7324981689453, -1.3741413213685, 218, 25, 'PPL', 'P'),
(117055, 'North Branch', 41.6458282470703, 0.726856822631435, -94.7149963378906, -1.65308853711056, 218, 16, 'PPL', 'P'),
(132311, 'North Branch', 43.2294387817383, 0.754496040530659, -83.1966705322266, -1.4520558274843, 218, 27, 'PPL', 'P'),
(137161, 'North Branch', 45.5113906860352, 0.794323614632794, -92.9800033569336, -1.62280719709387, 218, 28, 'PPL', 'P'),
(144218, 'North Branch', 43.0805587768555, 0.751897594255069, -71.977783203125, -1.2562493051812, 218, 36, 'PPL', 'P'),
(145910, 'North Branch', 40.6019401550293, 0.708637538402958, -74.6777801513672, -1.30337314172183, 218, 37, 'PPL', 'P'),
(151147, 'North Branch', 41.8066711425781, 0.729664060736488, -74.991943359375, -1.30885632409019, 218, 40, 'PPL', 'P'),
(175576, 'North Branch', 44.4474983215332, 0.775755189985408, -90.998893737793, -1.58823031139694, 218, 57, 'PPL', 'P'),
(49847, 'North Branch (historical)', 39.3969383239746, 0.687606288958493, -76.8847198486328, -1.34189150583208, 218, 25, 'PPL', 'P'),
(145911, 'North Branch Depot', 40.5897216796875, 0.70842428577867, -74.6816711425781, -1.30344105232962, 218, 37, 'PPL', 'P'),
(113137, 'North Branch Mobile Home Park', 45.5083312988281, 0.794270218252938, -92.9861068725586, -1.62291372353747, 218, 28, 'PPL', 'P'),
(113810, 'North Branford', 41.3274993896484, 0.721300935965312, -72.7677764892578, -1.27003728909287, 218, 8, 'PPL', 'P'),
(49852, 'North Brentwood', 38.9452781677246, 0.679723332131859, -76.9519424438477, -1.34306476145031, 218, 25, 'PPL', 'P'),
(67239, 'North Brevard', 35.2455596923828, 0.61515106334028, -82.7180633544922, -1.44370255640915, 218, 33, 'PPL', 'P'),
(128289, 'North Brewer', 44.8183288574219, 0.7822274038036, -68.7033309936523, -1.1990993329267, 218, 26, 'PPL', 'P'),
(156808, 'North Brewster', 40.7205581665039, 0.710707813255358, -81.5975036621094, -1.42414510031194, 218, 41, 'PPL', 'P'),
(151150, 'North Bridgewater', 42.9241714477539, 0.749168120453847, -75.2472229003906, -1.31331179259389, 218, 40, 'PPL', 'P'),
(128290, 'North Bridgton', 44.0986099243164, 0.769665938731969, -70.6991729736328, -1.23393334682688, 218, 26, 'PPL', 'P'),
(125592, 'North Brighton', 42.3583297729492, 0.739292320183506, -71.1388931274414, -1.24160791129822, 218, 23, 'PPL', 'P'),
(113397, 'North Bristol', 43.2666702270508, 0.755145851836639, -89.2122192382813, -1.55704695871904, 218, 57, 'PPL', 'P'),
(156805, 'North Bristol', 41.4088897705078, 0.72272146609076, -80.8691711425781, -1.41143329979677, 218, 41, 'PPL', 'P'),
(151149, 'North Broadalbin', 43.1069412231445, 0.752358054807544, -74.1627807617188, -1.2943847067267, 218, 40, 'PPL', 'P'),
(67237, 'North Brook (historical)', 35.480281829834, 0.619247737466122, -81.4805603027344, -1.4221040536525, 218, 33, 'PPL', 'P'),
(125593, 'North Brookfield', 42.2666702270508, 0.737692559316695, -72.0833282470703, -1.25809141370721, 218, 23, 'PPL', 'P'),
(151151, 'North Brookfield', 42.8502807617188, 0.747878484695976, -75.39111328125, -1.31582315350184, 218, 40, 'PPL', 'P'),
(128296, 'North Brooklin', 44.3052787780762, 0.773272990691399, -68.570556640625, -1.19678198330417, 218, 26, 'PPL', 'P'),
(144219, 'North Brookline', 42.7591705322266, 0.74628831120909, -71.6755599975586, -1.25097451516814, 218, 36, 'PPL', 'P'),
(17302, 'North Brooksville', 28.5727806091309, 0.498689098079324, -82.408332824707, -1.43829673887046, 218, 12, 'PPL', 'P'),
(128291, 'North Brooksville', 44.3952789306641, 0.774843789681355, -68.7111129760742, -1.1992351541423, 218, 26, 'PPL', 'P'),
(197160, 'North Browning', 48.5702781677246, 0.847711272636313, -113.008613586426, -1.97237239019713, 218, 31, 'PPL', 'P'),
(128292, 'North Buckfield', 44.3102798461914, 0.773360275796127, -70.4049987792969, -1.22879903856132, 218, 26, 'PPL', 'P'),
(128293, 'North Bucksport', 44.6611099243164, 0.779483415774437, -68.8138885498047, -1.20102892629452, 218, 26, 'PPL', 'P'),
(117057, 'North Buena Vista', 42.6797218322754, 0.744901669808513, -90.9563903808594, -1.5874884878753, 218, 16, 'PPL', 'P'),
(96584, 'North Buena Vista Colonia', 27.7439994812012, 0.484224138618559, -98.245002746582, -1.71469877155873, 218, 51, 'PPL', 'P'),
(165295, 'North Buffalo', 40.7627792358398, 0.711444709928983, -79.5838928222656, -1.38900096130282, 218, 45, 'PPL', 'P'),
(151152, 'North Burke', 44.9866714477539, 0.78516553627623, -74.1747207641602, -1.294593099082, 218, 40, 'PPL', 'P'),
(104705, 'North Burlington Heights', 37.3549995422363, 0.651967734092999, -79.9633331298828, -1.39562344398552, 218, 53, 'PPL', 'P'),
(151153, 'North Bush', 43.0847206115723, 0.751970231973801, -74.4927825927734, -1.30014432521621, 218, 40, 'PPL', 'P'),
(165297, 'North Butler', 40.8716697692871, 0.713345208261891, -79.879997253418, -1.39416895855617, 218, 45, 'PPL', 'P'),
(132313, 'North Byron', 42.8450012207031, 0.747786339322259, -85.732780456543, -1.49631929585612, 218, 27, 'PPL', 'P'),
(172326, 'North Calais', 44.3899993896484, 0.774751644307639, -72.4469375610352, -1.26443759342681, 218, 55, 'PPL', 'P'),
(110674, 'North Caldwell', 37.7844390869141, 0.65946286808589, -80.4016723632813, -1.40327390684899, 218, 58, 'PPL', 'P'),
(145913, 'North Caldwell', 40.8647193908691, 0.713223901274238, -74.2586135864258, -1.29605730504932, 218, 37, 'PPL', 'P'),
(120801, 'North Caledonia (historical)', 42.3694381713867, 0.739486198310864, -88.8925018310547, -1.55146683728699, 218, 18, 'PPL', 'P'),
(125595, 'North Cambridge', 42.3958282470703, 0.739946792021393, -71.1305618286133, -1.2414625027027, 218, 23, 'PPL', 'P'),
(151154, 'North Cambridge', 43.0247192382813, 0.750923010454155, -73.4502792358398, -1.28194920917463, 218, 40, 'PPL', 'P'),
(172313, 'North Cambridge', 44.686939239502, 0.77993422236796, -72.8574981689453, -1.27160322781384, 218, 55, 'PPL', 'P'),
(104706, 'North Camellia Acres', 36.9219398498535, 0.644409416603245, -76.2027816772461, -1.32998943944635, 218, 53, 'PPL', 'P'),
(151155, 'North Cameron', 42.2536087036133, 0.737464592727385, -77.3649978637695, -1.35027393852116, 218, 40, 'PPL', 'P'),
(23408, 'North Canton', 34.2438888549805, 0.5976686092064, -84.4938888549805, -1.47469655833355, 218, 13, 'PPL', 'P'),
(113813, 'North Canton', 41.8977813720703, 0.731254234223374, -72.8930587768555, -1.27222387750588, 218, 8, 'PPL', 'P'),
(156806, 'North Canton', 40.8758316040039, 0.713417845980623, -81.4024963378906, -1.42074158043882, 218, 41, 'PPL', 'P'),
(175577, 'North Cape', 42.7786102294922, 0.746627597931966, -88.0708312988281, -1.53712598113302, 218, 57, 'PPL', 'P'),
(49849, 'North Cape Arthur', 39.0791702270508, 0.682060189409376, -76.5308303833008, -1.33571496947391, 218, 25, 'PPL', 'P'),
(71178, 'North Cape May', 38.9819412231445, 0.680363223162778, -74.9583282470703, -1.30826962970205, 218, 37, 'PPL', 'P'),
(96585, 'North Capisallo Colonia', 26.1620006561279, 0.456613050358349, -97.8740005493164, -1.70822356168431, 218, 51, 'PPL', 'P'),
(189120, 'North Carmen', 35.9066696166992, 0.626689608237212, -105.325828552246, -1.83828249562775, 218, 38, 'PPL', 'P'),
(67240, 'North Carolina', 35.500560760498, 0.619601671574993, -80.0005569458008, -1.39627312213344, 218, 33, 'ADM1', 'A'),
(4607, 'North Carolina (historical)', 34.9255599975586, 0.60956601506022, -87.4936065673828, -1.52705150904536, 218, 2, 'PPL', 'P'),
(61090, 'North Carrollton', 33.5180587768555, 0.585000484533111, -89.9205627441406, -1.5694098851314, 218, 30, 'PPL', 'P'),
(125596, 'North Carver', 41.920280456543, 0.731646917326107, -70.8000030517578, -1.23569316367521, 218, 23, 'PPL', 'P'),
(128294, 'North Castine', 44.4188919067383, 0.775255913860045, -68.7724990844727, -1.20030654384883, 218, 26, 'PPL', 'P'),
(165306, 'North Catasauqua', 40.6597213745117, 0.709646010928744, -75.4772186279297, -1.31732597530497, 218, 45, 'PPL', 'P'),
(151157, 'North Cazenovia', 42.9919395446777, 0.750350896872978, -75.8705596923828, -1.32419107196298, 218, 40, 'PPL', 'P'),
(117058, 'North Cedar', 42.5547218322754, 0.74272000824352, -92.4555587768555, -1.61365391242727, 218, 16, 'PPL', 'P'),
(61091, 'North Center (historical)', 33.2694396972656, 0.580661263010991, -89.5902786254883, -1.56364533979387, 218, 30, 'PPL', 'P'),
(145915, 'North Centerville', 40.4249992370605, 0.705549336802902, -74.1611099243164, -1.29435554511276, 218, 37, 'PPL', 'P'),
(165299, 'North Centre', 41.0755615234375, 0.716903790689482, -76.379997253418, -1.33308243473637, 218, 45, 'PPL', 'P'),
(165301, 'North Charleroi', 40.1511116027832, 0.700769095804265, -79.9077835083008, -1.39465392019067, 218, 45, 'PPL', 'P'),
(208, 'North Charleston', 38.3741683959961, 0.669755586224883, -81.684440612793, -1.42566243634301, 218, 58, 'PPL', 'P'),
(82622, 'North Charleston', 32.8544387817383, 0.573418130636248, -79.9749984741211, -1.39582704265085, 218, 48, 'PPL', 'P'),
(144220, 'North Charlestown', 43.3083305358887, 0.755872961393258, -72.3874969482422, -1.26340015902417, 218, 36, 'PPL', 'P'),
(125597, 'North Chatham', 41.7013893127441, 0.727826546163361, -69.9541702270508, -1.22093059596263, 218, 23, 'PPL', 'P'),
(144221, 'North Chatham', 44.2422218322754, 0.772172439370924, -71.017219543457, -1.23948430664499, 218, 36, 'PPL', 'P'),
(151158, 'North Chatham', 42.4719390869141, 0.741275176773124, -73.6322174072266, -1.28512462930039, 218, 40, 'PPL', 'P'),
(89461, 'North Chattanooga', 35.0625, 0.611956068980512, -85.3088912963867, -1.48892103434788, 218, 50, 'PPL', 'P'),
(189121, 'North Chaves', 35.3919410705566, 0.61770590035302, -108.157501220703, -1.88770450703106, 218, 38, 'PPL', 'P'),
(125598, 'North Chelmsford', 42.6388893127441, 0.744189007900807, -71.3833312988281, -1.24587416220647, 218, 23, 'PPL', 'P'),
(151159, 'North Chemung', 42.0999984741211, 0.734783588458002, -76.6922225952148, -1.33853179495889, 218, 40, 'PPL', 'P'),
(125599, 'North Chester', 42.3236083984375, 0.738686317877458, -72.9277801513672, -1.27282987981193, 218, 23, 'PPL', 'P'),
(144222, 'North Chester', 43.0038909912109, 0.750559488965359, -71.2758331298828, -1.24399796521851, 218, 36, 'PPL', 'P'),
(172314, 'North Chester', 43.2727813720703, 0.755252511438296, -72.5897216796875, -1.26692964641686, 218, 55, 'PPL', 'P'),
(128295, 'North Chesterville', 44.5944404602051, 0.778319814115154, -70.1125030517578, -1.22369402506775, 218, 26, 'PPL', 'P'),
(49851, 'North Chevy Chase', 39.000560760498, 0.680688195394795, -77.0730590820313, -1.34517864556556, 218, 25, 'PPL', 'P'),
(120803, 'North Chicago', 42.3255615234375, 0.738720406339412, -87.8411102294922, -1.53311659211191, 218, 18, 'PPL', 'P'),
(144223, 'North Chichester', 43.2574996948242, 0.754985795855125, -71.3730621337891, -1.24569493146511, 218, 36, 'PPL', 'P'),
(125600, 'North Chicopee', 42.1833305358887, 0.736238007308321, -72.5999984741211, -1.26710901031627, 218, 23, 'PPL', 'P'),
(151160, 'North Chili', 43.1197204589844, 0.752581094548838, -77.8058319091797, -1.35796794406845, 218, 40, 'PPL', 'P'),
(120804, 'North Chillicothe', 40.9308280944824, 0.714377715816515, -89.5013885498047, -1.56209391530084, 218, 18, 'PPL', 'P'),
(151161, 'North Chittenango', 43.0811080932617, 0.751907181634993, -75.8730621337891, -1.32423474780485, 218, 40, 'PPL', 'P'),
(172315, 'North Chittenden', 43.7402801513672, 0.763411904386081, -72.9763870239258, -1.27367822977717, 218, 55, 'PPL', 'P'),
(151162, 'North Church Corner', 43.5052795410156, 0.75931036999125, -76.2322235107422, -1.33050329637868, 218, 40, 'PPL', 'P'),
(208266, 'North City', 47.7558288574219, 0.833496450580933, -122.312217712402, -2.13475091449755, 218, 56, 'PPL', 'P'),
(183672, 'North Clairemont', 32.8327789306641, 0.573040094919511, -117.199172973633, -2.04551144900425, 218, 6, 'PPL', 'P'),
(172316, 'North Clarendon', 43.5666694641113, 0.760381826276816, -72.9658279418945, -1.27349393902974, 218, 55, 'PPL', 'P'),
(23409, 'North Clayton', 33.5819396972656, 0.586115416923473, -84.3033294677734, -1.47137066960621, 218, 13, 'PPL', 'P'),
(175578, 'North Clayton', 43.3808288574219, 0.757138295806181, -90.7094421386719, -1.58317842796711, 218, 57, 'PPL', 'P'),
(89464, 'North Cleveland', 35.1752815246582, 0.613924477921217, -84.8680572509766, -1.48122702880059, 218, 50, 'PPL', 'P'),
(96586, 'North Cleveland', 30.3416690826416, 0.529562026042663, -95.1416702270508, -1.6605354013087, 218, 51, 'PPL', 'P'),
(13173, 'North Cleveland Park', 38.9500007629395, 0.679805756967597, -77.0708312988281, -1.34513976341365, 218, 9, 'PPL', 'P'),
(151163, 'North Clove', 41.7002792358398, 0.72780717166643, -73.6669387817383, -1.28573063160643, 218, 40, 'PPL', 'P'),
(42313, 'North Club Estates', 32.6041717529297, 0.569050146974354, -93.8880615234375, -1.63865580189899, 218, 22, 'PPL', 'P'),
(89463, 'North Club Estates', 35.2322196960449, 0.61491823648198, -84.8222198486328, -1.48042701520913, 218, 50, 'PPL', 'P'),
(151164, 'North Clymer', 42.0750007629395, 0.73434729609242, -79.5727767944336, -1.38880695001741, 218, 40, 'PPL', 'P'),
(125601, 'North Cohasset', 42.2583312988281, 0.737547017563123, -70.8430633544922, -1.23644470773483, 218, 23, 'PPL', 'P'),
(151165, 'North Cohocton', 42.5611114501953, 0.742831528114167, -77.4649963378906, -1.35201924114154, 218, 40, 'PPL', 'P'),
(23410, 'North Cohutta (historical)', 34.8952789306641, 0.609037510741894, -84.711669921875, -1.47849755499937, 218, 13, 'PPL', 'P'),
(113818, 'North Colebrook', 42.0175018310547, 0.733343750414651, -73.1152801513672, -1.27610237215942, 218, 8, 'PPL', 'P'),
(151166, 'North Colesville', 42.2411117553711, 0.737246479834107, -75.7219390869141, -1.32159715306124, 218, 40, 'PPL', 'P'),
(73706, 'North College Hill', 39.2183303833008, 0.684488992323528, -84.5508270263672, -1.47569031689431, 218, 41, 'PPL', 'P'),
(151167, 'North Collins', 42.5952796936035, 0.743427876461263, -78.9413909912109, -1.37778718890082, 218, 40, 'PPL', 'P'),
(61092, 'North Colony', 32.3972206115723, 0.565438168166907, -90.1722183227539, -1.57380210355921, 218, 30, 'PPL', 'P'),
(151169, 'North Columbia', 42.9777793884277, 0.750103755523819, -75.0719375610352, -1.31025248629166, 218, 40, 'PPL', 'P'),
(183673, 'North Columbia', 39.3727798461914, 0.687184643978907, -120.986106872559, -2.11160591409589, 218, 6, 'PPL', 'P'),
(30677, 'North Columbus', 39.2333297729492, 0.684750781058683, -85.908332824707, -1.49938326269026, 218, 19, 'PPL', 'P'),
(125602, 'North Commons', 42.2472190856934, 0.737353072856738, -71.0166702270508, -1.23947471926507, 218, 23, 'PPL', 'P'),
(67244, 'North Concord', 35.4341697692871, 0.6184429301847, -80.6208267211914, -1.40709887196461, 218, 33, 'PPL', 'P'),
(172317, 'North Concord', 44.4683303833008, 0.776118778053231, -71.855827331543, -1.25412077367996, 218, 55, 'PPL', 'P'),
(156807, 'North Condit', 40.2649993896484, 0.702756812662872, -82.7877807617188, -1.44491935471121, 218, 41, 'PPL', 'P'),
(151170, 'North Constantia', 43.3424987792969, 0.756469309740354, -75.9972229003906, -1.32640176198385, 218, 40, 'PPL', 'P'),
(82623, 'North Conway', 33.8527793884277, 0.590842461279336, -79.0508270263672, -1.37969720803463, 218, 48, 'PPL', 'P'),
(144224, 'North Conway', 44.0536117553711, 0.768880572526504, -71.1288909912109, -1.24143334108876, 218, 36, 'PPL', 'P'),
(23411, 'North Conyers Farms', 33.6875, 0.58795779176559, -83.9091720581055, -1.46449132503637, 218, 13, 'PPL', 'P'),
(67245, 'North Cooleemee', 35.8191719055176, 0.625162485089133, -80.5497207641602, -1.40585783889664, 218, 33, 'PPL', 'P'),
(165303, 'North Coplay', 40.6802787780762, 0.710004805306605, -75.503059387207, -1.31777698163557, 218, 45, 'PPL', 'P'),
(37451, 'North Corbin', 36.9605598449707, 0.645083462675144, -84.0933303833008, -1.46770549415598, 218, 21, 'PPL', 'P'),
(113814, 'North Cornwall', 41.8708305358887, 0.730783853395839, -73.3150024414063, -1.27958818371022, 218, 8, 'PPL', 'P'),
(165304, 'North Cornwall', 40.2861099243164, 0.703125260999685, -76.4169387817383, -1.33372718603628, 218, 45, 'PPL', 'P'),
(96587, 'North Country Estates Colonia', 26.2639999389648, 0.458393273678526, -98.3150024414063, -1.7159204967088, 218, 51, 'PPL', 'P'),
(96588, 'North Country Estates Number 2 Colonia', 26.2649993896484, 0.458410717383666, -98.3479995727539, -1.71649640529453, 218, 51, 'PPL', 'P'),
(4605, 'North Courtland', 34.6722183227539, 0.605144368702362, -87.329719543457, -1.52419114087656, 218, 2, 'PPL', 'P'),
(67246, 'North Cove', 35.8358306884766, 0.625453235701142, -81.9891662597656, -1.43098090219795, 218, 33, 'PPL', 'P'),
(208267, 'North Cove', 46.6666717529297, 0.814487073036057, -124.054168701172, -2.16515369465995, 218, 56, 'PPL', 'P'),
(67247, 'North Cove Crossing', 35.8313903808594, 0.625375737713421, -82.0008316040039, -1.43118450086329, 218, 33, 'PPL', 'P'),
(113815, 'North Coventry', 41.7983283996582, 0.729518452403888, -72.3722229003906, -1.26313357659906, 218, 8, 'PPL', 'P'),
(4606, 'North Cowarts', 31.2175006866455, 0.544848171225555, -85.3008270263672, -1.48878028628427, 218, 2, 'PPL', 'P'),
(191949, 'North Cowden', 32.0044403076172, 0.558582858625907, -102.512496948242, -1.78918059618747, 218, 51, 'PPL', 'P'),
(123319, 'North Crane', 40.3386116027832, 0.704041588151754, -86.8102798461914, -1.51512520789372, 218, 19, 'PPL', 'P'),
(187115, 'North Creede', 37.8641700744629, 0.660854436334484, -106.925277709961, -1.86619814964812, 218, 7, 'PPL', 'P'),
(151171, 'North Creek', 43.6977806091309, 0.762670147443467, -73.9863891601563, -1.29130609250657, 218, 40, 'PPL', 'P'),
(156813, 'North Creek', 41.1463890075684, 0.71813996348847, -84.2194366455078, -1.46990646363888, 218, 41, 'PPL', 'P'),
(175579, 'North Creek', 44.2708282470703, 0.772671715496287, -91.4319381713867, -1.59578836257058, 218, 57, 'PPL', 'P'),
(192725, 'North Creek', 38.3372192382813, 0.66911070176692, -112.577217102051, -1.96484310116326, 218, 52, 'PPL', 'P'),
(208268, 'North Creek', 47.8197212219238, 0.834611582708377, -122.175003051758, -2.13235606688729, 218, 56, 'PPL', 'P'),
(10836, 'North Creek (historical)', 34.584171295166, 0.603607658174359, -90.8050003051758, -1.58484623259977, 218, 4, 'PPL', 'P'),
(49853, 'North Creek Farms', 39.0441703796387, 0.681449326834339, -76.8747177124023, -1.34171693562262, 218, 25, 'PPL', 'P'),
(205129, 'North Crest Park Condominium', 40.7805595397949, 0.711755034775005, -111.876106262207, -1.95260640858656, 218, 52, 'PPL', 'P'),
(151186, 'North Croghan', 44.0333290100098, 0.768526571838606, -75.5072174072266, -1.31784955277528, 218, 40, 'PPL', 'P'),
(151172, 'North Croghan Crossing', 44.0347213745117, 0.768550873183553, -75.4972229003906, -1.31767511572388, 218, 40, 'PPL', 'P'),
(113816, 'North Cromwell', 41.6113891601563, 0.726255747173405, -72.644172668457, -1.26787999545185, 218, 8, 'PPL', 'P'),
(96589, 'North Cross Estates Colonia', 26.2730007171631, 0.458550366893327, -98.2979965209961, -1.71562368740531, 218, 51, 'PPL', 'P'),
(10837, 'North Crossett', 33.1655616760254, 0.578848249519892, -91.9413909912109, -1.60467999166008, 218, 4, 'PPL', 'P'),
(82625, 'North Crossing', 34.1369400024414, 0.595801999598364, -80.8786087036133, -1.41159801631019, 218, 48, 'PPL', 'P'),
(112560, 'North Crossville Addition', 36.0333290100098, 0.628900231679059, -85.033332824707, -1.48411163173531, 218, 50, 'PPL', 'P'),
(145916, 'North Crosswicks', 40.1588897705078, 0.700904850440831, -74.648063659668, -1.30285449109953, 218, 37, 'PPL', 'P'),
(30678, 'North Crows Nest', 39.8658294677734, 0.695789983251225, -86.163330078125, -1.50383380434594, 218, 19, 'PPL', 'P'),
(151173, 'North Cuba', 42.2413902282715, 0.737251340103097, -78.2736129760742, -1.36613226386425, 218, 40, 'PPL', 'P'),
(183682, 'North Cucamonga', 34.0933303833008, 0.595040868158819, -117.580833435059, -2.05217268068081, 218, 6, 'PPL', 'P'),
(128308, 'North Cushing', 44.038890838623, 0.768623644060339, -69.2111129760742, -1.20796180040227, 218, 26, 'PPL', 'P'),
(128297, 'North Cutler', 44.6691703796387, 0.77962409725902, -67.2600021362305, -1.17390849217564, 218, 26, 'PPL', 'P'),
(4608, 'North Dadeville', 32.8574981689453, 0.573471527016104, -85.7727813720703, -1.49701744353589, 218, 2, 'PPL', 'P'),
(198683, 'North Dakota', 47.5002784729004, 0.829036254966296, -100.000282287598, -1.74533417884235, 218, 34, 'ADM1', 'A'),
(125603, 'North Dana (historical)', 42.4555587768555, 0.740989286430105, -72.279167175293, -1.26150944780827, 218, 23, 'PPL', 'P'),
(144225, 'North Danville', 42.9455604553223, 0.749541429059649, -71.1138916015625, -1.24117155235361, 218, 36, 'PPL', 'P'),
(172318, 'North Danville', 44.4588890075684, 0.775953994960782, -72.0944366455078, -1.25828529183457, 218, 55, 'PPL', 'P'),
(10838, 'North Dardanelle', 35.2294387817383, 0.614869700371113, -93.14111328125, -1.62561909573083, 218, 4, 'PPL', 'P'),
(125604, 'North Dartmouth', 41.6388893127441, 0.726735715380864, -70.970832824707, -1.23867470567361, 218, 23, 'PPL', 'P'),
(4609, 'North Daye Hill', 34.8563919067383, 0.608358804138087, -86.7241668701172, -1.51362225293253, 218, 2, 'PPL', 'P'),
(89465, 'North Dayton', 35.5038909912109, 0.619659795065784, -85.0108337402344, -1.48371894863258, 218, 50, 'PPL', 'P'),
(156809, 'North Dayton', 40.3305587768555, 0.703901039825225, -84.7755584716797, -1.47961262054778, 218, 41, 'PPL', 'P'),
(17303, 'North De Land', 29.0491695404053, 0.50700365345012, -81.2983322143555, -1.41892357352068, 218, 12, 'PPL', 'P'),
(49854, 'North Deale', 38.7863883972168, 0.676950182488759, -76.5505599975586, -1.33605931620286, 218, 25, 'PPL', 'P'),
(23413, 'North Decatur', 33.7902793884277, 0.58975163049684, -84.3061065673828, -1.47141913913804, 218, 13, 'PPL', 'P'),
(128298, 'North Deer Isle', 44.2661094665527, 0.772589357239576, -68.6733322143555, -1.19857575545639, 218, 26, 'PPL', 'P'),
(82624, 'North Deerfield', 33.9416694641113, 0.592393885772362, -80.4027786254883, -1.40329321476689, 218, 48, 'PPL', 'P'),
(128299, 'North Deering', 43.6997184753418, 0.762703969589311, -70.288330078125, -1.22676278559184, 218, 26, 'PPL', 'P'),
(23412, 'North DeKalb', 33.810001373291, 0.590095844067733, -84.273063659668, -1.47084243160399, 218, 13, 'PPL', 'P'),
(187116, 'North Delta', 38.7586097717285, 0.67646535401231, -108.06861114502, -1.88615308253803, 218, 7, 'PPL', 'P'),
(71179, 'North Dennis', 39.2011108398438, 0.684188454594513, -74.8544387817383, -1.30645641647387, 218, 37, 'PPL', 'P'),
(125605, 'North Dennis', 41.7397193908691, 0.728495532229189, -70.220832824707, -1.22558473628365, 218, 23, 'PPL', 'P'),
(96590, 'North Depot Road Colonia', 26.2180004119873, 0.457590430478408, -98.2419967651367, -1.71464630728525, 218, 51, 'PPL', 'P'),
(172319, 'North Derby', 45.0055618286133, 0.785495235619182, -72.1716690063477, -1.25963325082031, 218, 55, 'PPL', 'P'),
(128300, 'North Dexter', 45.0761108398438, 0.78672654814918, -69.334716796875, -1.21011909404329, 218, 26, 'PPL', 'P'),
(125606, 'North Dighton', 41.8638916015625, 0.730662746145268, -71.125, -1.24136543048097, 218, 23, 'PPL', 'P'),
(183674, 'North Dinuba', 36.5675010681152, 0.638223292865154, -119.393608093262, -2.08381156706317, 218, 6, 'PPL', 'P'),
(128301, 'North Dixmont', 44.7249984741211, 0.780598481322853, -69.1733322143555, -1.20730240171636, 218, 26, 'PPL', 'P'),
(151175, 'North Dock', 41.3974990844727, 0.722522661115386, -73.9561080932617, -1.29077758818824, 218, 40, 'PPL', 'P'),
(144226, 'North Dorchester', 43.8025016784668, 0.764497874899588, -71.9713897705078, -1.25613771873153, 218, 36, 'PPL', 'P'),
(132314, 'North Dorr', 42.7686080932617, 0.746453027722511, -85.7619400024414, -1.49682822594044, 218, 27, 'PPL', 'P'),
(172320, 'North Dorset', 43.2838897705078, 0.755446389565654, -73.0027770996094, -1.2741388234877, 218, 55, 'PPL', 'P'),
(156810, 'North Dover', 41.4772186279297, 0.723914029626898, -81.9211120605469, -1.42979313235178, 218, 41, 'PPL', 'P'),
(23414, 'North Druid Hills', 33.8166694641113, 0.590212224207369, -84.3133316040039, -1.47154523981566, 218, 13, 'PPL', 'P'),
(28066, 'North Dupo', 38.5494384765625, 0.672814626211003, -90.2005615234375, -1.5742967857317, 218, 18, 'PPL', 'P'),
(125607, 'North Duxbury', 42.0713882446289, 0.734284245753612, -70.720832824707, -1.23431138254362, 218, 23, 'PPL', 'P'),
(172321, 'North Duxbury', 44.3583297729492, 0.774198905223393, -72.8294372558594, -1.27111347248937, 218, 55, 'PPL', 'P'),
(202432, 'North Eagle Butte', 45.0041694641113, 0.785470934274235, -101.233329772949, -1.76685491729517, 218, 49, 'PPL', 'P'),
(49855, 'North East', 39.5999984741211, 0.691150357158144, -75.9416732788086, -1.32543223818901, 218, 25, 'PPL', 'P'),
(165312, 'North East', 42.2155609130859, 0.736800533509573, -79.8344421386719, -1.39337387181273, 218, 45, 'PPL', 'P'),
(128302, 'North East Carry', 45.8663902282715, 0.800519525487891, -69.6269378662109, -1.2152193138469, 218, 26, 'PPL', 'P'),
(49857, 'North East Harbor', 39.5888900756836, 0.690956479030786, -75.9447174072266, -1.32548536825275, 218, 25, 'PPL', 'P'),
(49858, 'North East Isles', 39.5958290100098, 0.691077586281357, -75.9538879394531, -1.32564542423427, 218, 25, 'PPL', 'P'),
(151176, 'North East Junction', 42.0200004577637, 0.733387359677501, -79.4391708374023, -1.38647508616693, 218, 40, 'PPL', 'P'),
(49859, 'North East Park', 39.6088905334473, 0.691305552870668, -75.9505615234375, -1.3255873673225, 218, 25, 'PPL', 'P'),
(125608, 'North Eastham', 41.8650016784668, 0.730682120642198, -69.9916687011719, -1.22158506780051, 218, 23, 'PPL', 'P'),
(49860, 'North Easton', 38.8036117553711, 0.677250786796802, -76.0616683959961, -1.32752654807025, 218, 25, 'PPL', 'P'),
(125609, 'North Easton', 42.0666694641113, 0.734201887496901, -71.1041717529297, -1.24100190899217, 218, 23, 'PPL', 'P'),
(151178, 'North Easton', 43.0099983215332, 0.750666081987989, -73.5505599975586, -1.28369943864303, 218, 40, 'PPL', 'P'),
(156811, 'North Eaton', 41.3133316040039, 0.721053661458098, -81.9813919067383, -1.43084521414042, 218, 41, 'PPL', 'P'),
(128303, 'North Edgecomb', 43.9888916015625, 0.767750992750147, -69.6408309936523, -1.21546179466415, 218, 26, 'PPL', 'P'),
(165310, 'North Edinburg', 41.0202789306641, 0.715938927426547, -80.4394378662109, -1.40393303921878, 218, 45, 'PPL', 'P'),
(145917, 'North Edison', 40.5999984741211, 0.708603649678087, -74.3777770996094, -1.29813710070262, 218, 37, 'PPL', 'P'),
(151179, 'North Edmeston', 42.7566719055176, 0.74624470194624, -75.2375030517578, -1.31314214923246, 218, 40, 'PPL', 'P'),
(183675, 'North Edwards', 35.0166702270508, 0.611156188547107, -117.831939697266, -2.0565553117287, 218, 6, 'PPL', 'P'),
(125610, 'North Egremont', 42.1966705322266, 0.736470834166622, -73.4383316040039, -1.28174068366128, 218, 23, 'PPL', 'P'),
(183676, 'North El Monte', 34.1027793884277, 0.595205784409322, -118.023330688477, -2.05989571468398, 218, 6, 'PPL', 'P'),
(151180, 'North Elba', 44.2433280944824, 0.772191747288827, -73.954719543457, -1.29075335342232, 218, 40, 'PPL', 'P'),
(23415, 'North Elberton', 34.1269416809082, 0.595627495967936, -82.85888671875, -1.44616038777919, 218, 13, 'PPL', 'P'),
(165311, 'North Eldred', 41.3424987792969, 0.721562724700467, -76.970832824707, -1.34339446079327, 218, 45, 'PPL', 'P'),
(67249, 'North Elkin', 36.288330078125, 0.633350839913772, -80.8530578613281, -1.41115206998566, 218, 33, 'PPL', 'P'),
(128304, 'North Ellsworth', 44.6152801513672, 0.778683535341032, -68.5250015258789, -1.19598689656073, 218, 26, 'PPL', 'P'),
(96591, 'North Elm', 30.9322204589844, 0.539869091962029, -97.0480575561523, -1.69380813701982, 218, 51, 'PPL', 'P'),
(4610, 'North Elmore', 32.5563888549805, 0.568216178078996, -86.3191680908203, -1.50655369076724, 218, 2, 'PPL', 'P'),
(183677, 'North Elsinore', 33.689998626709, 0.58800140102844, -117.338333129883, -2.0479402519184, 218, 6, 'PPL', 'P'),
(112608, 'North Emporia', 36.6936111450195, 0.640424328927077, -77.5361099243164, -1.35326040736757, 218, 53, 'PPL', 'P'),
(23416, 'North End', 31.2580604553223, 0.545556072732811, -81.4375, -1.42135250959288, 218, 13, 'PPL', 'P'),
(113817, 'North End', 41.6166687011719, 0.726347892547121, -72.8716735839844, -1.2718506354791, 218, 8, 'PPL', 'P'),
(125612, 'North End', 42.3650016784668, 0.73940876690217, -71.0550003051758, -1.24014370533089, 218, 23, 'PPL', 'P'),
(82626, 'North End (historical)', 33.4291687011719, 0.583449060040086, -79.915283203125, -1.39478481455825, 218, 48, 'PPL', 'P'),
(104707, 'North End (historical)', 36.5669403076172, 0.638213505748148, -75.9244384765625, -1.32513143414388, 218, 53, 'PPL', 'P'),
(117059, 'North English', 41.5138893127441, 0.724554053815871, -92.0761108398438, -1.60703129658651, 218, 16, 'PPL', 'P'),
(76740, 'North Enid', 36.4355583190918, 0.635920457470563, -97.8686065673828, -1.70812941893978, 218, 42, 'PPL', 'P'),
(172322, 'North Enosburg', 44.920280456543, 0.784006794885936, -72.7577819824219, -1.26986285204147, 218, 55, 'PPL', 'P'),
(144227, 'North Epping', 43.0713882446289, 0.751737538273555, -71.0608291625977, -1.24024543808453, 218, 36, 'PPL', 'P'),
(132315, 'North Epworth', 43.9780616760254, 0.767561974891779, -86.466667175293, -1.50912803543497, 218, 27, 'PPL', 'P'),
(96592, 'North Escobares', 26.4141693115234, 0.461014223665328, -98.9775009155273, -1.72748327637165, 218, 51, 'PPL', 'P'),
(96593, 'North Escobares Ranchettes Colonia', 26.431999206543, 0.461325414038704, -98.9720001220703, -1.72738726941436, 218, 51, 'PPL', 'P'),
(89466, 'North Etowah', 35.3419418334961, 0.616833249042828, -84.529167175293, -1.47531228117758, 218, 50, 'PPL', 'P'),
(151182, 'North Evans', 42.6969413757324, 0.745202207537528, -78.9416732788086, -1.37779211574884, 218, 40, 'PPL', 'P'),
(73708, 'North Excello', 39.4897193908691, 0.689225624059316, -84.4155578613281, -1.47332942458796, 218, 41, 'PPL', 'P'),
(151183, 'North Fair Haven', 43.3327789306641, 0.756299666378916, -76.6999969482422, -1.33866748301643, 218, 40, 'PPL', 'P'),
(172323, 'North Fairfax', 44.7605590820313, 0.781219131014896, -73.0625, -1.27518118473836, 218, 55, 'PPL', 'P'),
(128305, 'North Fairfield', 44.6494407653809, 0.779279750530073, -69.6763916015625, -1.21608244435619, 218, 26, 'PPL', 'P'),
(156812, 'North Fairfield', 41.103889465332, 0.717398206545856, -82.6119384765625, -1.441850327871, 218, 41, 'PPL', 'P'),
(125613, 'North Fairhaven', 41.6583290100098, 0.72707500210374, -70.908332824707, -1.23758387489111, 218, 23, 'PPL', 'P'),
(104708, 'North Fairlington', 38.8363914489746, 0.677822900377978, -77.0975036621094, -1.34560528397219, 218, 53, 'PPL', 'P'),
(125614, 'North Falmouth', 41.6458282470703, 0.726856822631435, -70.6188888549805, -1.23253212461934, 218, 23, 'PPL', 'P'),
(128306, 'North Falmouth', 43.7813911437988, 0.764129426562776, -70.336669921875, -1.22760647502518, 218, 26, 'PPL', 'P'),
(125615, 'North Falmouth Station', 41.6480598449707, 0.726895771362378, -70.6144409179688, -1.23245449347356, 218, 23, 'PPL', 'P'),
(49861, 'North Farm', 39.3013916015625, 0.685938684062913, -76.8591690063477, -1.34144555950755, 218, 25, 'PPL', 'P'),
(132317, 'North Farmington', 42.5277786254883, 0.742249760574039, -83.3797225952148, -1.45525068868601, 218, 27, 'PPL', 'P'),
(205131, 'North Farmington Junction', 41.0122184753418, 0.715798245941963, -111.912216186523, -1.95323664565853, 218, 52, 'PPL', 'P'),
(125616, 'North Farms', 42.3652801513672, 0.739413627171159, -72.6716690063477, -1.26835989708028, 218, 23, 'PPL', 'P'),
(128307, 'North Fayette', 44.4500007629395, 0.775798865827285, -70.0694427490234, -1.22294248100813, 218, 26, 'PPL', 'P'),
(23417, 'North Fayette Estates', 33.5200004577637, 0.585034373257983, -84.4541702270508, -1.4740033375018, 218, 13, 'PPL', 'P'),
(172324, 'North Fayston', 44.2419395446777, 0.772167512522907, -72.8386077880859, -1.27127352847088, 218, 55, 'PPL', 'P'),
(73709, 'North Feesburg (historical)', 38.9083290100098, 0.679078447673896, -83.9677810668945, -1.46551424521107, 218, 41, 'PPL', 'P'),
(151184, 'North Fenton', 42.2425003051758, 0.737270714600027, -75.7949981689453, -1.32287227459117, 218, 40, 'PPL', 'P'),
(172325, 'North Ferrisburgh', 44.2594413757324, 0.772472977099939, -73.211669921875, -1.27778469102002, 218, 55, 'PPL', 'P'),
(183679, 'North Fillmore', 34.4066696166992, 0.600509669457297, -118.932502746582, -2.07576376056506, 218, 6, 'PPL', 'P'),
(4611, 'North Florence', 34.8183288574219, 0.607694478604167, -87.6805572509766, -1.53031441401293, 218, 2, 'PPL', 'P'),
(165314, 'North Fogelsville', 40.5947189331055, 0.70851150430437, -75.6308288574219, -1.32000697957435, 218, 45, 'PPL', 'P'),
(175580, 'North Fond du Lac', 43.8113899230957, 0.764653004033085, -88.4833297729492, -1.54432543766589, 218, 57, 'PPL', 'P'),
(183680, 'North Fontana', 34.1394386291504, 0.595845608861214, -117.461387634277, -2.05008795817949, 218, 6, 'PPL', 'P'),
(10840, 'North Fordyce', 33.8250007629395, 0.590357632802887, -92.4116668701172, -1.61288785413971, 218, 4, 'PPL', 'P'),
(23419, 'North Forest', 34.3974990844727, 0.600349613475783, -83.9369430541992, -1.46497602035476, 218, 13, 'PPL', 'P'),
(151185, 'North Forest Acres', 43.0050010681152, 0.750578863462289, -78.7458267211914, -1.37437394848972, 218, 40, 'PPL', 'P'),
(82627, 'North Forest Estates', 34.5919418334961, 0.603743279652871, -82.7030563354492, -1.44344063451594, 218, 48, 'PPL', 'P'),
(49862, 'North Forestville', 38.8541717529297, 0.678133225224, -76.878059387207, -1.3417752588505, 218, 25, 'PPL', 'P'),
(56566, 'North Fork', 39.6111106872559, 0.691344301864529, -91.9188919067383, -1.60428730855735, 218, 29, 'PPL', 'P'),
(67250, 'North Fork', 36.327220916748, 0.634029613096606, -81.7777786254883, -1.42729149198181, 218, 33, 'PPL', 'P'),
(104710, 'North Fork', 37.0699996948242, 0.646993548387976, -82.7213897705078, -1.44376061332092, 218, 53, 'PPL', 'P'),
(165316, 'North Fork', 41.9805603027344, 0.732698999114742, -77.6241683959961, -1.35479731763266, 218, 45, 'PPL', 'P'),
(183681, 'North Fork', 37.2297210693359, 0.649781212259016, -119.508613586426, -2.08581879157676, 218, 6, 'PPL', 'P'),
(195391, 'North Fork', 45.4061088562012, 0.792486100059667, -113.993057250977, -1.98955417344394, 218, 17, 'PPL', 'P'),
(197161, 'North Fork', 48.586109161377, 0.847987575599409, -109.110282897949, -1.90433368435167, 218, 31, 'PPL', 'P'),
(200099, 'North Fork', 41.4824981689453, 0.724006175000615, -115.815826416016, -2.0213674968777, 218, 39, 'PPL', 'P'),
(201313, 'North Fork', 43.788890838623, 0.764260320930353, -123.922218322754, -2.1628507261073, 218, 43, 'PPL', 'P'),
(61093, 'North Fork (historical)', 31.8177795410156, 0.555325013664413, -91.0952835083008, -1.58991263025754, 218, 30, 'PPL', 'P'),
(205133, 'North Fork Estates', 41.3377799987793, 0.721480366443756, -111.857223510742, -1.95227684240166, 218, 52, 'PPL', 'P'),
(73710, 'North Fork Village', 39.3358306884766, 0.686539759520944, -83.029167175293, -1.44913234239766, 218, 41, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(82628, 'North Forks', 34.6138916015625, 0.604126375375679, -82.6805572509766, -1.44304795141321, 218, 48, 'PPL', 'P'),
(17304, 'North Fort Myers', 26.6669406890869, 0.465425916458612, -81.8802795410156, -1.42908047044407, 218, 12, 'PPL', 'P'),
(42315, 'North Fort Polk', 31.1144409179688, 0.543049438935802, -93.1677780151367, -1.62608448313132, 218, 22, 'PPL', 'P'),
(169515, 'North Foster', 41.8313903808594, 0.730095492833081, -71.751106262207, -1.25229304622383, 218, 47, 'PPL', 'P'),
(125617, 'North Foxboro', 42.0766716003418, 0.734376457706356, -71.2583312988281, -1.24369250064148, 218, 23, 'PPL', 'P'),
(151188, 'North Frankfort', 43.0422210693359, 0.751228475031187, -75.059440612793, -1.31003437339839, 218, 40, 'PPL', 'P'),
(113819, 'North Franklin', 41.6333312988281, 0.726638709738158, -72.1638870239258, -1.25949742960472, 218, 8, 'PPL', 'P'),
(151187, 'North Franklin', 42.392219543457, 0.739883808261613, -75.0858306884766, -1.31049496710892, 218, 40, 'PPL', 'P'),
(104712, 'North Frederick Terrace', 39.214168548584, 0.684416354604796, -78.1875, -1.36462930890307, 218, 53, 'PPL', 'P'),
(165318, 'North Fredericktown', 40.0097198486328, 0.69830134415917, -80.0002822875977, -1.39626832844348, 218, 45, 'PPL', 'P'),
(165319, 'North Freedom', 41.0219383239746, 0.715967889303401, -79.2099990844727, -1.38247528452574, 218, 45, 'PPL', 'P'),
(175582, 'North Freedom', 43.4597206115723, 0.75851521666878, -89.8683319091797, -1.56849828509027, 218, 57, 'PPL', 'P'),
(128310, 'North Fryeburg', 44.1208305358887, 0.770053761565711, -70.977783203125, -1.23879601266126, 218, 26, 'PPL', 'P'),
(151200, 'North Gage', 43.2255592346191, 0.754428329659944, -75.1263885498047, -1.31120283532666, 218, 40, 'PPL', 'P'),
(151189, 'North Gainesville', 42.684440612793, 0.744984028065223, -78.1336135864258, -1.36368881356411, 218, 40, 'PPL', 'P'),
(151190, 'North Galway', 43.0522193908691, 0.751402978661614, -74.0586090087891, -1.2925665666505, 218, 40, 'PPL', 'P'),
(104713, 'North Gap', 37.2563896179199, 0.650246666238535, -81.1161117553711, -1.4157432265469, 218, 53, 'PPL', 'P'),
(104714, 'North Garden', 37.940559387207, 0.662187681355205, -78.6369400024414, -1.37247351673584, 218, 53, 'PPL', 'P'),
(13174, 'North Gate', 38.9872207641602, 0.680455368536494, -77.0355606079102, -1.34452417372768, 218, 9, 'PPL', 'P'),
(30679, 'North Gate', 39.2638893127441, 0.685284145645999, -85.9463882446289, -1.50004745506612, 218, 19, 'PPL', 'P'),
(49865, 'North Gate', 39.5999984741211, 0.691150357158144, -75.8024978637695, -1.32300316895875, 218, 25, 'PPL', 'P'),
(82629, 'North Gate', 34.2261085510254, 0.597358284360379, -79.7949981689453, -1.39268544467094, 218, 48, 'PPL', 'P'),
(104715, 'North Gate', 36.7552795410156, 0.641500645481633, -76.5872192382813, -1.33669914065475, 218, 53, 'PPL', 'P'),
(23422, 'North Gate Manor Trailer Park', 30.899169921875, 0.539292251269918, -83.3216705322266, -1.45423748904929, 218, 13, 'PPL', 'P'),
(151191, 'North Gates', 43.1763916015625, 0.753570192577693, -77.7016677856445, -1.35614993715031, 218, 40, 'PPL', 'P'),
(96594, 'North Georgetown', 30.6472206115723, 0.534894906257006, -97.6769409179688, -1.70478422229453, 218, 51, 'PPL', 'P'),
(156814, 'North Georgetown', 40.8430595397949, 0.712845865557501, -80.9861068725586, -1.41347421329816, 218, 41, 'PPL', 'P'),
(49863, 'North Germantown', 39.1763916015625, 0.68375702249792, -77.2736129760742, -1.34867897134431, 218, 25, 'PPL', 'P'),
(151192, 'North Germantown', 42.1544418334961, 0.735733804334942, -73.8777770996094, -1.28941045444265, 218, 40, 'PPL', 'P'),
(165320, 'North Ghent', 41.8919410705566, 0.731152301732652, -76.4422225952148, -1.3341684718289, 218, 45, 'PPL', 'P'),
(49864, 'North Glade', 39.5008316040039, 0.689419568765701, -79.2369384765625, -1.3829454656162, 218, 25, 'PPL', 'P'),
(120808, 'North Glen Ellyn', 41.8919410705566, 0.731152301732652, -88.0630569458008, -1.53699029307549, 218, 18, 'PPL', 'P'),
(89467, 'North Glen Estates', 35.1363906860352, 0.613245704738383, -85.2555618286133, -1.4879902595469, 218, 50, 'PPL', 'P'),
(183683, 'North Glendale', 34.1605606079102, 0.596214256935108, -118.263610839844, -2.06408939445253, 218, 6, 'PPL', 'P'),
(49866, 'North Glenwood', 38.7794418334961, 0.676828942080133, -76.0944366455078, -1.32809846191434, 218, 25, 'PPL', 'P'),
(128311, 'North Gorham', 43.7983283996582, 0.764425037443775, -70.4552764892578, -1.2296765501405, 218, 26, 'PPL', 'P'),
(113820, 'North Goshen', 41.898609161377, 0.731268681872288, -73.2127838134766, -1.27780413209598, 218, 8, 'PPL', 'P'),
(151193, 'North Gouverneur', 44.4211082458496, 0.775294596274878, -75.4702835083008, -1.31720493463343, 218, 40, 'PPL', 'P'),
(125618, 'North Grafton', 42.2333297729492, 0.737110658618513, -71.7083282470703, -1.25154642901223, 218, 23, 'PPL', 'P'),
(113821, 'North Granby', 41.9958305358887, 0.732965514960832, -72.8300018310547, -1.2711233261854, 218, 8, 'PPL', 'P'),
(140605, 'North Grand Forks', 47.9794387817383, 0.83739918000039, -97.0905609130859, -1.69454996054146, 218, 34, 'PPL', 'P'),
(144228, 'North Grantham', 43.5288887023926, 0.759722427590913, -72.1313934326172, -1.25893030945058, 218, 36, 'PPL', 'P'),
(151194, 'North Granville', 43.4502792358398, 0.758350433576331, -73.3419418334961, -1.28005836480067, 218, 40, 'PPL', 'P'),
(128312, 'North Gray', 43.9169387817383, 0.76649517913812, -70.3197174072266, -1.22731059782807, 218, 26, 'PPL', 'P'),
(197163, 'North Great Falls (historical)', 47.5333290100098, 0.829613095658407, -111.260559082031, -1.94186308359113, 218, 31, 'PPL', 'P'),
(151195, 'North Great River', 40.7472190856934, 0.711173134076823, -73.170280456543, -1.27706230857433, 218, 40, 'PPL', 'P'),
(151196, 'North Greece', 43.2536087036133, 0.754917885247328, -77.732780456543, -1.35669295569658, 218, 40, 'PPL', 'P'),
(49867, 'North Green Ridge', 39.6913909912109, 0.692745457493047, -76.5658264160156, -1.33632576546992, 218, 25, 'PPL', 'P'),
(151198, 'North Greenfield', 43.1641693115234, 0.753356873374378, -73.8613891601563, -1.28912443094158, 218, 40, 'PPL', 'P'),
(156815, 'North Greenfield', 40.377498626709, 0.704720294755561, -83.5894393920898, -1.45891093728822, 218, 41, 'PPL', 'P'),
(113822, 'North Greenwich', 41.0958290100098, 0.717257525061272, -73.6897201538086, -1.28612824155718, 218, 8, 'PPL', 'P'),
(151199, 'North Greenwich', 43.1586112976074, 0.753259867731672, -73.4861068725586, -1.28257451939858, 218, 40, 'PPL', 'P'),
(175584, 'North Grimms', 44.1533317565918, 0.770621014877898, -87.9022216796875, -1.53418318812849, 218, 57, 'PPL', 'P'),
(96595, 'North Groesbeck', 34.4180603027344, 0.600708474432671, -99.8413925170898, -1.74256102919925, 218, 51, 'PPL', 'P'),
(113823, 'North Grosvenor Dale', 41.9855613708496, 0.73278628421947, -71.899169921875, -1.25487724458759, 218, 8, 'PPL', 'P'),
(144229, 'North Groton', 43.7597198486328, 0.763751191108957, -71.8702774047852, -1.25437297503519, 218, 36, 'PPL', 'P'),
(123320, 'North Grove', 40.6122207641602, 0.708816968881402, -85.9661102294922, -1.50039166863702, 218, 19, 'PPL', 'P'),
(170953, 'North Grove Addition', 44.4313888549805, 0.775474026753323, -96.7880630493164, -1.68927037683843, 218, 49, 'PPL', 'P'),
(189122, 'North Guam', 35.4886093139648, 0.619393079482613, -108.372779846191, -1.89146182785499, 218, 38, 'PPL', 'P'),
(113824, 'North Guilford', 41.3669395446777, 0.72198929652807, -72.7174987792969, -1.26915977751369, 218, 8, 'PPL', 'P'),
(128313, 'North Guilford', 45.2347183227539, 0.789494770944263, -69.42138671875, -1.21163176954245, 218, 26, 'PPL', 'P'),
(61094, 'North Gulfport', 30.4141693115234, 0.530827393745101, -89.0941696166992, -1.5549866041417, 218, 30, 'PPL', 'P'),
(145918, 'North Hackensack', 40.9147186279297, 0.71409655258443, -74.0388870239258, -1.29222235307961, 218, 37, 'PPL', 'P'),
(125619, 'North Hadley', 42.3861083984375, 0.739777148659955, -72.5819396972656, -1.26679382520126, 218, 23, 'PPL', 'P'),
(145919, 'North Haledon', 40.9550018310547, 0.714799627112211, -74.186393737793, -1.29479683090539, 218, 37, 'PPL', 'P'),
(104717, 'North Halifax', 37.026668548584, 0.646237277217421, -78.9569396972656, -1.3780585650159, 218, 53, 'PPL', 'P'),
(67258, 'North Hamlet', 34.9033317565918, 0.609178059068423, -79.6913909912109, -1.39087715829078, 218, 33, 'PPL', 'P'),
(151201, 'North Hamlin', 43.3386116027832, 0.756401465711584, -77.9019393920898, -1.35964533608104, 218, 40, 'PPL', 'P'),
(151202, 'North Hammond', 44.4833297729492, 0.776380566788386, -75.7297210693359, -1.32173297427683, 218, 40, 'PPL', 'P'),
(73711, 'North Hampton', 39.9900016784668, 0.697957197167304, -83.9400024414063, -1.46502941673462, 218, 41, 'PPL', 'P'),
(120809, 'North Hampton', 40.9311103820801, 0.714382642664532, -89.5388870239258, -1.56274838713873, 218, 18, 'PPL', 'P'),
(144235, 'North Hampton', 42.9724998474121, 0.750011610150102, -70.8302764892578, -1.23622153483548, 218, 36, 'PPL', 'P'),
(144230, 'North Hampton Center', 42.976390838623, 0.750079520757899, -70.8483276367188, -1.23653658679244, 218, 36, 'PPL', 'P'),
(144231, 'North Hampton Mobile Home Park', 42.9961090087891, 0.750423667749765, -70.8130569458008, -1.23592099710646, 218, 36, 'PPL', 'P'),
(125620, 'North Hancock', 42.6111106872559, 0.743704179424359, -73.2880630493164, -1.27911800261977, 218, 23, 'PPL', 'P'),
(151203, 'North Hannibal', 43.3558311462402, 0.756702003440599, -76.5408325195313, -1.33588953968337, 218, 40, 'PPL', 'P'),
(120810, 'North Hanover', 42.2936096191406, 0.738162740407149, -90.2786102294922, -1.57565899262927, 218, 18, 'PPL', 'P'),
(125621, 'North Hanover', 42.1458282470703, 0.735583468891407, -70.8680572509766, -1.23688093352138, 218, 23, 'PPL', 'P'),
(125622, 'North Hanson', 42.0583305358887, 0.734056345743328, -70.9000015258789, -1.23743846629559, 218, 23, 'PPL', 'P'),
(28068, 'North Harbor', 38.726390838623, 0.67590302754814, -89.2930603027344, -1.55845790146456, 218, 18, 'PPL', 'P'),
(49868, 'North Harford Heights', 39.6263885498047, 0.691610950868673, -76.4655609130859, -1.33457580231763, 218, 25, 'PPL', 'P'),
(197162, 'North Harlem Colony', 48.5908317565918, 0.848070000435147, -108.757499694824, -1.89817645591141, 218, 31, 'PPL', 'P'),
(67257, 'North Harlowe', 34.860279083252, 0.608426648166857, -76.772216796875, -1.33992795716036, 218, 33, 'PPL', 'P'),
(151205, 'North Harpersfield', 42.4724998474121, 0.741284963890131, -74.6922225952148, -1.303625209919, 218, 40, 'PPL', 'P'),
(128351, 'North Harpswell', 43.8208312988281, 0.764817787125534, -69.9669418334961, -1.22115350254587, 218, 26, 'PPL', 'P'),
(151206, 'North Hartland', 43.288890838623, 0.755533674670381, -78.6050033569336, -1.37191611711969, 218, 40, 'PPL', 'P'),
(172327, 'North Hartland', 43.5927810668945, 0.760837559718356, -72.3522186279297, -1.26278443618015, 218, 55, 'PPL', 'P'),
(82631, 'North Hartsville', 34.3936080932617, 0.600281702867986, -80.0697174072266, -1.39748019989752, 218, 48, 'PPL', 'P'),
(125623, 'North Harwich', 41.6958312988281, 0.727729540520654, -70.1208267211914, -1.22383930050521, 218, 23, 'PPL', 'P'),
(125624, 'North Hatfield', 42.4111099243164, 0.740213507604564, -72.6227798461914, -1.26750662026702, 218, 23, 'PPL', 'P'),
(61095, 'North Haven', 34.5208282470703, 0.602502113426839, -88.9888916015625, -1.5531491561476, 218, 30, 'PPL', 'P'),
(113825, 'North Haven', 41.3908309936523, 0.72240628097575, -72.8600006103516, -1.27164690365571, 218, 8, 'PPL', 'P'),
(128314, 'North Haven', 44.128059387207, 0.770179928822354, -68.8747177124023, -1.20209059546308, 218, 26, 'PPL', 'P'),
(151207, 'North Haven', 41.0127792358398, 0.715808033058969, -72.3133316040039, -1.26210572957634, 218, 40, 'PPL', 'P'),
(113826, 'North Haven Bridge', 41.3899993896484, 0.722391766747809, -72.8730621337891, -1.27187487024502, 218, 8, 'PPL', 'P'),
(144233, 'North Haverhill', 44.0902786254883, 0.76952053013645, -72.0269393920898, -1.25710724252637, 218, 36, 'PPL', 'P'),
(123321, 'North Hayden', 41.2900009155273, 0.720646464127425, -87.4583282470703, -1.52643578620134, 218, 19, 'PPL', 'P'),
(125625, 'North Heath', 42.7063903808594, 0.745367123788031, -72.8263931274414, -1.27106034242562, 218, 23, 'PPL', 'P'),
(151208, 'North Hebron', 43.3230590820313, 0.756130023017477, -73.3208312988281, -1.27968991646386, 218, 40, 'PPL', 'P'),
(165321, 'North Heidelberg', 40.3958282470703, 0.705040206981506, -76.1344375610352, -1.3287966095941, 218, 45, 'PPL', 'P'),
(67259, 'North Henderson', 36.3416709899902, 0.634281814451837, -78.3902816772461, -1.36816851683373, 218, 33, 'PPL', 'P'),
(120812, 'North Henderson', 41.089168548584, 0.71714127807969, -90.4752807617188, -1.57909154095828, 218, 18, 'PPL', 'P'),
(128316, 'North Hermon', 44.8488883972168, 0.782760768390916, -68.876106262207, -1.202114830229, 218, 26, 'PPL', 'P'),
(172328, 'North Hero', 44.8175010681152, 0.782212956154686, -73.2897186279297, -1.27914689791759, 218, 55, 'PPL', 'P'),
(67260, 'North Hickory', 35.7780609130859, 0.624444962912438, -81.3238906860352, -1.41936965300326, 218, 33, 'PPL', 'P'),
(23423, 'North High Shoals', 33.8199996948242, 0.59027034769816, -83.5061111450195, -1.45745658501692, 218, 13, 'PPL', 'P'),
(123322, 'North Highland', 41.0888900756836, 0.717136417810701, -85.1661071777344, -1.48642898135784, 218, 19, 'PPL', 'P'),
(151210, 'North Highland', 41.461109161377, 0.723632866394813, -73.9172210693359, -1.29009888158444, 218, 40, 'PPL', 'P'),
(201314, 'North Highland', 45.2541694641113, 0.789834257404221, -122.408332824707, -2.13642843966819, 218, 43, 'PPL', 'P'),
(4615, 'North Highlands', 33.4230613708496, 0.583342467017455, -86.9891662597656, -1.51824736479767, 218, 2, 'PPL', 'P'),
(23425, 'North Highlands', 32.4944381713867, 0.567134934676424, -84.9852828979492, -1.48327300230804, 218, 13, 'PPL', 'P'),
(42317, 'North Highlands', 30.4933300018311, 0.53220900842912, -91.1402816772461, -1.590697996463, 218, 22, 'PPL', 'P'),
(183685, 'North Highlands', 38.6858291625977, 0.67519509275137, -121.371109008789, -2.11832546900032, 218, 6, 'PPL', 'P'),
(71180, 'North Highlands Beach', 39.0149993896484, 0.680940197012943, -74.9447174072266, -1.30803207573281, 218, 37, 'PPL', 'P'),
(208269, 'North Hill', 47.4194412231445, 0.827625378799799, -122.322219848633, -2.134925484707, 218, 56, 'PPL', 'P'),
(82632, 'North Hill Acres', 35.0138893127441, 0.61110765243624, -81.9955596923828, -1.43109248864763, 218, 48, 'PPL', 'P'),
(14309, 'North Hills', 39.7722206115723, 0.694156200501489, -75.5105590820313, -1.31790787600315, 218, 10, 'PPL', 'P'),
(49869, 'North Hills', 39.7077789306641, 0.693031480994121, -76.0619430541992, -1.32753134176021, 218, 25, 'PPL', 'P'),
(82633, 'North Hills', 35.0125007629395, 0.61108341767032, -81.9508285522461, -1.43031178297407, 218, 48, 'PPL', 'P'),
(89469, 'North Hills', 36.0052795410156, 0.628410676091675, -83.908332824707, -1.46447667765037, 218, 50, 'PPL', 'P'),
(104719, 'North Hills', 37.3388900756836, 0.651686570860913, -79.9533309936523, -1.39544887377606, 218, 53, 'PPL', 'P'),
(110677, 'North Hills', 39.6661109924316, 0.692304238279448, -79.9513931274414, -1.39541505163022, 218, 58, 'PPL', 'P'),
(151211, 'North Hills', 40.7808303833008, 0.71175976188594, -73.6769409179688, -1.28590520181589, 218, 40, 'PPL', 'P'),
(165324, 'North Hills', 41.0250015258789, 0.716021352262285, -76.8424987792969, -1.34115460915845, 218, 45, 'PPL', 'P'),
(67264, 'North Hills Estates', 35.4819412231445, 0.619276699342976, -77.4199981689453, -1.35123387493608, 218, 33, 'PPL', 'P'),
(73714, 'North Hills Estates', 39.2119407653809, 0.684377472452881, -84.5238876342773, -1.47522013580386, 218, 41, 'PPL', 'P'),
(82636, 'North Hills Estates', 34.2611083984375, 0.597969146935416, -82.1800003051758, -1.43431158461526, 218, 48, 'PPL', 'P'),
(49871, 'North Hills Sligo Park', 39.0138893127441, 0.680920822516013, -77.0216674804688, -1.34428169291043, 218, 25, 'PPL', 'P'),
(10844, 'North Hills Subdivision', 35.1672210693359, 0.613783796436633, -92.7291717529297, -1.61842935973594, 218, 4, 'PPL', 'P'),
(151212, 'North Hillsdale', 42.2355613708496, 0.737149607349455, -73.5077819824219, -1.28295282143143, 218, 40, 'PPL', 'P'),
(96596, 'North Hilltop Addition Colonia', 27.7490005493164, 0.484311423723286, -98.0660018920898, -1.71157461728396, 218, 51, 'PPL', 'P'),
(144234, 'North Hinsdale', 42.8250007629395, 0.747437265482377, -72.519172668457, -1.26569833388686, 218, 36, 'PPL', 'P'),
(42318, 'North Hodge', 32.2833290100098, 0.563450384729272, -92.7158279418945, -1.61819646629862, 218, 22, 'PPL', 'P'),
(128317, 'North Hollis', 43.6572189331055, 0.761962212646697, -70.6755599975586, -1.23352122264819, 218, 26, 'PPL', 'P'),
(113828, 'North Hollow', 42.0338897705078, 0.733629773915725, -72.9305572509766, -1.27287834934377, 218, 8, 'PPL', 'P'),
(183686, 'North Hollywood', 34.1722183227539, 0.59641772244239, -118.378059387207, -2.06608689842814, 218, 6, 'PPL', 'P'),
(104720, 'North Holston', 36.910831451416, 0.644215538475887, -81.7161102294922, -1.42621517542726, 218, 53, 'PPL', 'P'),
(120813, 'North Hooper', 40.9505615234375, 0.714722129124489, -87.6069412231445, -1.52902957194502, 218, 18, 'PPL', 'P'),
(151230, 'North Hoosick', 42.9280586242676, 0.749235964482617, -73.3433303833008, -1.28008259956659, 218, 40, 'PPL', 'P'),
(128318, 'North Hope Corner', 44.2902793884277, 0.773011201956245, -69.1908264160156, -1.20760773313534, 218, 26, 'PPL', 'P'),
(96597, 'North Hopkins', 33.2706718444824, 0.580682768036793, -95.6179885864258, -1.66884872496749, 218, 51, 'PPL', 'P'),
(151213, 'North Hornell', 42.3461112976074, 0.739079067559218, -77.6616668701172, -1.35545178947054, 218, 40, 'PPL', 'P'),
(96598, 'North Houston', 29.9252796173096, 0.522294658902001, -95.5149993896484, -1.66705122438974, 218, 51, 'PPL', 'P'),
(201315, 'North Howell', 45.0313911437988, 0.785946042212705, -122.872222900391, -2.14452484885619, 218, 43, 'PPL', 'P'),
(151214, 'North Hudson', 43.9524993896484, 0.767115828830163, -73.728889465332, -1.28681187500901, 218, 40, 'PPL', 'P'),
(175585, 'North Hudson', 44.9930610656738, 0.785277056146877, -92.7566680908203, -1.61890926136438, 218, 57, 'PPL', 'P'),
(10846, 'North Hughes', 34.9627799987793, 0.610215626629118, -90.4527816772461, -1.57869885785554, 218, 4, 'PPL', 'P'),
(189123, 'North Hurley', 32.7227783203125, 0.571120222089673, -108.131942749023, -1.88725842754847, 218, 38, 'PPL', 'P'),
(151216, 'North Huron', 43.2636108398438, 0.755092455456783, -76.8844375610352, -1.34188657898406, 218, 40, 'PPL', 'P'),
(67270, 'North Hyde Park', 36.1266708374023, 0.630529353896888, -79.809440612793, -1.39293751286812, 218, 33, 'PPL', 'P'),
(172330, 'North Hyde Park', 44.6705589294434, 0.77964833202494, -72.5986099243164, -1.26708477555035, 218, 55, 'PPL', 'P'),
(151217, 'North Ilion', 43.0219383239746, 0.750874474343288, -75.0288925170898, -1.30950120854815, 218, 40, 'PPL', 'P'),
(49872, 'North Indian Creek Estates', 38.5099983215332, 0.672126265648244, -76.7666702270508, -1.33983115125474, 218, 25, 'PPL', 'P'),
(49873, 'North Indian Head Estates', 38.6330604553223, 0.674274105067393, -77.0811080932617, -1.34531912731307, 218, 25, 'PPL', 'P'),
(30680, 'North Indianapolis', 39.8077812194824, 0.694776850193532, -86.1780624389648, -1.50409093254919, 218, 19, 'PPL', 'P'),
(156816, 'North Industry', 40.7388916015625, 0.711027792060332, -81.366943359375, -1.42012106390483, 218, 41, 'PPL', 'P'),
(132318, 'North Ironwood', 46.5108299255371, 0.811767120035732, -90.1552810668945, -1.57350649267822, 218, 27, 'PPL', 'P'),
(37452, 'North Irvine', 37.714168548584, 0.658236415824882, -83.9797210693359, -1.46572263756637, 218, 21, 'PPL', 'P'),
(165326, 'North Irwin', 40.3375015258789, 0.704022213654824, -79.7136077880859, -1.39126491454549, 218, 45, 'PPL', 'P'),
(42319, 'North Island', 29.7133293151855, 0.51859542827934, -92.7344436645508, -1.61852137195161, 218, 22, 'PPL', 'P'),
(128319, 'North Islesboro', 44.3369407653809, 0.773825596617591, -68.9002838134766, -1.20253680810372, 218, 26, 'PPL', 'P'),
(156817, 'North Jackson', 41.0999984741211, 0.717330295938059, -80.8574981689453, -1.41122956797338, 218, 41, 'PPL', 'P'),
(165328, 'North Jackson', 41.8872184753418, 0.731069876896914, -75.5822219848633, -1.31915862960911, 218, 45, 'PPL', 'P'),
(156818, 'North Jacksonville', 40.2272186279297, 0.702097413976969, -84.4858322143555, -1.47455594342799, 218, 41, 'PPL', 'P'),
(183687, 'North Jamul', 32.7255592346191, 0.571168758200539, -116.868606567383, -2.0397419768187, 218, 6, 'PPL', 'P'),
(151218, 'North Java', 42.6836090087891, 0.744969513837282, -78.3380584716797, -1.36725704995065, 218, 40, 'PPL', 'P'),
(128320, 'North Jay', 44.5472183227539, 0.777495632336802, -70.2386093139648, -1.22589499455064, 218, 26, 'PPL', 'P'),
(151219, 'North Jay', 44.3983306884766, 0.774897052903157, -73.6738891601563, -1.28585193859409, 218, 40, 'PPL', 'P'),
(49874, 'North Jefferson', 39.3758316040039, 0.687237907200708, -77.545280456543, -1.35342046334909, 218, 25, 'PPL', 'P'),
(56569, 'North Jefferson', 38.6058311462402, 0.673798863970869, -92.1636123657227, -1.60855848631362, 218, 29, 'PPL', 'P'),
(128321, 'North Jefferson', 44.2136116027832, 0.771673096666534, -69.4377822875977, -1.21191792620158, 218, 26, 'PPL', 'P'),
(96599, 'North Jericho', 31.860559463501, 0.55607166416553, -94.158332824707, -1.64337292597979, 218, 51, 'PPL', 'P'),
(104721, 'North Jericho', 36.7333297729492, 0.641117549758825, -76.5697174072266, -1.33639367607772, 218, 53, 'PPL', 'P'),
(4617, 'North Johns', 33.3672218322754, 0.582367883216541, -87.1036071777344, -1.52024473561523, 218, 2, 'PPL', 'P'),
(89472, 'North Johnson City', 36.3444404602051, 0.634330150825622, -82.3769378662109, -1.43774879347617, 218, 50, 'PPL', 'P'),
(123323, 'North Judson', 41.2150001525879, 0.719337453872624, -86.7758331298828, -1.51452399927763, 218, 19, 'PPL', 'P'),
(61096, 'North Junction', 34.2569389343262, 0.597896376058629, -89.0152816772461, -1.55360974985812, 218, 30, 'PPL', 'P'),
(67268, 'North Kannapolis', 35.5255584716797, 0.620037963940575, -80.6138916015625, -1.40697783129307, 218, 33, 'PPL', 'P'),
(56570, 'North Kansas City', 39.1300010681152, 0.682947354947509, -94.5619430541992, -1.65041725337916, 218, 29, 'PPL', 'P'),
(49875, 'North Kaywood', 38.3605613708496, 0.669518098834675, -75.5458297729492, -1.31852346568912, 218, 25, 'PPL', 'P'),
(49876, 'North Kenilworth', 38.9216690063477, 0.679311274532196, -76.9277801513672, -1.3426430498917, 218, 25, 'PPL', 'P'),
(73715, 'North Kenova', 38.4116706848145, 0.670410124641797, -82.5780563354492, -1.44125897295095, 218, 41, 'PPL', 'P'),
(49877, 'North Kensington', 39.0302810668945, 0.681206912596115, -77.0727767944336, -1.34517371871755, 218, 25, 'PPL', 'P'),
(113829, 'North Kent', 41.7669410705566, 0.728970640167659, -73.4288864135742, -1.2815758339898, 218, 8, 'PPL', 'P'),
(209865, 'North Kenyon', 42.4322204589844, 0.740581955941377, -113.860282897949, -1.9872368238214, 218, 17, 'PPL', 'P'),
(17305, 'North Key Largo', 25.266939163208, 0.440991280299081, -80.3236083984375, -1.4019114336353, 218, 12, 'PPL', 'P'),
(49878, 'North Keys', 38.7077789306641, 0.675578188474178, -76.7675018310547, -1.33984566548268, 218, 25, 'PPL', 'P'),
(49879, 'North Keys Estates', 38.7152786254883, 0.675709082841755, -76.7847213745117, -1.3401462032117, 218, 25, 'PPL', 'P'),
(73716, 'North Kingman', 39.5105590820313, 0.689589345285194, -83.9430618286133, -1.46508281311447, 218, 41, 'PPL', 'P'),
(23429, 'North Kingsley Estates', 33.7880592346191, 0.589712881502979, -84.6433334350586, -1.47730485830517, 218, 13, 'PPL', 'P'),
(169516, 'North Kingston Beach', 41.6097183227539, 0.726226585559468, -71.415283203125, -1.24643182813873, 218, 47, 'PPL', 'P'),
(169517, 'North Kingstown', 41.5499992370605, 0.725184290887838, -71.466667175293, -1.24732864763582, 218, 47, 'PPL', 'P'),
(156819, 'North Kingsville', 41.9058303833008, 0.731394715970876, -80.690559387207, -1.40831593658278, 218, 41, 'PPL', 'P'),
(172331, 'North Kirby', 44.5158309936523, 0.776947820100572, -71.9394378662109, -1.25558005279926, 218, 55, 'PPL', 'P'),
(23431, 'North Kirkwood', 33.7616691589355, 0.58925228779245, -84.3288879394531, -1.47181674908879, 218, 13, 'PPL', 'P'),
(89473, 'North Knoxville', 36.0019416809082, 0.62835241944283, -83.9124984741211, -1.46454938194813, 218, 50, 'PPL', 'P'),
(178724, 'North Komelik', 32.5077781677246, 0.567367761534724, -111.945831298828, -1.95382334004667, 218, 5, 'PPL', 'P'),
(151220, 'North Kortright', 42.4361114501953, 0.740649866549174, -74.7397232055664, -1.30445425196634, 218, 40, 'PPL', 'P'),
(175587, 'North La Crosse', 43.8463897705078, 0.765263866608122, -91.2480621337891, -1.59257912029898, 218, 57, 'PPL', 'P'),
(96600, 'North La Feria Village Colonia', 26.1569995880127, 0.456525765253622, -97.8349990844727, -1.70754285770969, 218, 51, 'PPL', 'P'),
(187117, 'North La Junta', 37.996940612793, 0.663171719377989, -103.531387329102, -1.80696358805036, 218, 7, 'PPL', 'P'),
(23432, 'North Lake', 33.0419387817383, 0.576690622983737, -85.1350021362305, -1.48588609596963, 218, 13, 'PPL', 'P'),
(132319, 'North Lake', 46.4936103820801, 0.811466582306716, -87.7275009155273, -1.53113373552229, 218, 27, 'PPL', 'P'),
(175588, 'North Lake', 43.1561088562012, 0.753216191889795, -88.3705596923828, -1.54235722846227, 218, 57, 'PPL', 'P'),
(4618, 'North Lake Park', 33.5961112976074, 0.586362758009714, -86.746940612793, -1.51401972972522, 218, 2, 'PPL', 'P'),
(132320, 'North Lakeport', 43.1372184753418, 0.752886492546843, -82.496940612793, -1.43984323651547, 218, 27, 'PPL', 'P'),
(67269, 'North Lakes', 35.7755584716797, 0.624401287070561, -81.3752822875977, -1.4202666056584, 218, 33, 'PPL', 'P'),
(104722, 'North Lakes', 37.327220916748, 0.65148290561655, -80.0083312988281, -1.39640881019098, 218, 53, 'PPL', 'P'),
(96601, 'North Lakeshore Gardens Colonia', 28.1310005187988, 0.490978580933273, -97.8759994506836, -1.70825844909459, 218, 51, 'PPL', 'P'),
(23433, 'North Lakeside', 33.1349983215332, 0.578314818353549, -85.0097198486328, -1.48369950755662, 218, 13, 'PPL', 'P'),
(125626, 'North Lakeville', 41.8574981689453, 0.730551159695593, -70.9427795410156, -1.23818508350719, 218, 23, 'PPL', 'P'),
(128322, 'North Lamoine', 44.5077781677246, 0.776807271774043, -68.3511123657227, -1.19295195818247, 218, 26, 'PPL', 'P'),
(172332, 'North Landgrove', 43.2597198486328, 0.755024544848986, -72.8491668701172, -1.27145781921832, 218, 55, 'PPL', 'P'),
(104723, 'North Landing', 36.7183303833008, 0.64085576102367, -76.0999984741211, -1.32819553413607, 218, 53, 'PPL', 'P'),
(151221, 'North Landing', 43.7355613708496, 0.76332954612937, -76.1847229003906, -1.32967425433134, 218, 40, 'PPL', 'P'),
(183688, 'North Landing', 37.6352806091309, 0.656859561541311, -118.743606567383, -2.07246690029359, 218, 6, 'PPL', 'P'),
(151222, 'North Lansing', 42.6111106872559, 0.743704179424359, -76.4977798461914, -1.3351381287818, 218, 40, 'PPL', 'P'),
(195392, 'North Lapwai', 46.4438896179199, 0.810598791265514, -116.834999084473, -2.03915541558861, 218, 17, 'PPL', 'P'),
(190553, 'North Las Vegas', 36.1988906860352, 0.631789828040822, -115.116668701172, -2.00916489276295, 218, 39, 'PPL', 'P'),
(17306, 'North Lauderdale', 26.2169399261475, 0.457571921508832, -80.2261123657227, -1.4002098068568, 218, 12, 'PPL', 'P'),
(49880, 'North Laurel', 39.1388893127441, 0.683102484081006, -76.8708267211914, -1.34164902501483, 218, 25, 'PPL', 'P'),
(49881, 'North Laurel Park', 39.1147193908691, 0.682680639364337, -76.8430633544922, -1.34116446285449, 218, 25, 'PPL', 'P'),
(151223, 'North Lawrence', 44.8050003051758, 0.781994776682381, -74.6752777099609, -1.30332946587995, 218, 40, 'PPL', 'P'),
(156821, 'North Lawrence', 40.8397216796875, 0.712787608908656, -81.6286087036133, -1.42468798570015, 218, 41, 'PPL', 'P'),
(128323, 'North Lebanon', 43.4377784729004, 0.758132254104026, -70.8847198486328, -1.23717175071242, 218, 26, 'PPL', 'P'),
(128324, 'North Leeds', 44.3433303833008, 0.773937116488238, -70.1316680908203, -1.22402851810066, 218, 26, 'PPL', 'P'),
(175590, 'North Leeds', 43.3319396972656, 0.75628501899292, -89.3252792358398, -1.55902022792873, 218, 57, 'PPL', 'P'),
(198687, 'North Lemmon', 45.9461097717285, 0.801910893999403, -102.157218933105, -1.78297982506338, 218, 34, 'PPL', 'P'),
(56571, 'North Lenox', 37.6647186279297, 0.657373351894614, -91.7563934326172, -1.60145117515447, 218, 29, 'PPL', 'P'),
(125627, 'North Leominster', 42.5416717529297, 0.742492241391291, -71.7375030517578, -1.25205562541265, 218, 23, 'PPL', 'P'),
(132321, 'North Leslie', 42.4805603027344, 0.741425645374714, -84.4441680908203, -1.47382876729235, 218, 27, 'PPL', 'P'),
(125628, 'North Leverett', 42.5083312988281, 0.741910340693108, -72.4930572509766, -1.26524253386629, 218, 23, 'PPL', 'P'),
(156822, 'North Lewisburg', 40.2230606079102, 0.702024842837264, -83.557502746582, -1.45835353767206, 218, 41, 'PPL', 'P'),
(195393, 'North Lewiston', 46.4247207641602, 0.810264231653573, -117.003059387207, -2.04208862121322, 218, 17, 'PPL', 'P'),
(10847, 'North Lexa', 34.6111106872559, 0.604077839264812, -90.7555618286133, -1.58398336840659, 218, 4, 'PPL', 'P'),
(125629, 'North Lexington', 42.4633293151855, 0.741124907908617, -71.2375030517578, -1.24332897915268, 218, 23, 'PPL', 'P'),
(151224, 'North Lexington', 42.2747192382813, 0.737833041064197, -74.3863906860352, -1.29828743614616, 218, 40, 'PPL', 'P'),
(89474, 'North Liberty', 35.4986114501953, 0.619567649692067, -84.6111068725586, -1.47674239868295, 218, 50, 'PPL', 'P'),
(117061, 'North Liberty', 41.7491683959961, 0.728660448479692, -91.5977783203125, -1.59868281920133, 218, 16, 'PPL', 'P'),
(123324, 'North Liberty', 41.5341682434082, 0.724907987924743, -86.4272232055664, -1.50843960829318, 218, 19, 'PPL', 'P'),
(156823, 'North Liberty', 40.5374984741211, 0.70751281889559, -82.408332824707, -1.43829673887046, 218, 41, 'PPL', 'P'),
(165330, 'North Liberty', 41.0927810668945, 0.717204328418498, -80.0944366455078, -1.39791163199411, 218, 45, 'PPL', 'P'),
(56572, 'North Lilbourn', 36.6016693115234, 0.63881964121225, -89.620002746582, -1.56416412357422, 218, 29, 'PPL', 'P'),
(156824, 'North Lima', 40.9483299255371, 0.714683180393547, -80.6591720581055, -1.40776812434655, 218, 41, 'PPL', 'P'),
(128325, 'North Limington', 43.7472190856934, 0.763533011636652, -70.6822204589844, -1.23363746962977, 218, 26, 'PPL', 'P'),
(128326, 'North Lincoln', 45.4269409179688, 0.79284968812749, -68.4625015258789, -1.19489606577823, 218, 26, 'PPL', 'P'),
(151225, 'North Lindenhurst', 40.714168548584, 0.710596293384711, -73.3819427490234, -1.28075651248044, 218, 40, 'PPL', 'P'),
(104724, 'North Linkhorn Park', 36.8800010681152, 0.643677446777636, -76.0008316040039, -1.32646474574363, 218, 53, 'PPL', 'P'),
(156825, 'North Linndale', 41.4500007629395, 0.723438988267455, -81.7619400024414, -1.42701505586066, 218, 41, 'PPL', 'P'),
(49882, 'North Linthicum', 39.2224998474121, 0.684561763200315, -76.6516723632813, -1.3378240598992, 218, 25, 'PPL', 'P'),
(82637, 'North Litchfield Beach', 33.4888916015625, 0.584491421290743, -79.0827789306641, -1.38025487396689, 218, 48, 'PPL', 'P'),
(10848, 'North Little Rock', 34.7694396972656, 0.606841201790906, -92.2669372558594, -1.61036184584577, 218, 4, 'PPL', 'P'),
(144236, 'North Littleton', 44.3597183227539, 0.774223139989312, -71.8024978637695, -1.25318999887897, 218, 36, 'PPL', 'P'),
(128327, 'North Livermore', 44.4422187805176, 0.775663044611691, -70.2183303833008, -1.22554106044177, 218, 26, 'PPL', 'P'),
(205139, 'North Logan', 41.7694396972656, 0.729014249430509, -111.803886413574, -1.95134593444262, 218, 52, 'PPL', 'P'),
(183689, 'North Loma Linda', 34.0711097717285, 0.594653045325076, -117.25611114502, -2.04650520756501, 218, 6, 'PPL', 'P'),
(144237, 'North Londonderry', 42.9180603027344, 0.749061460852189, -71.3994369506836, -1.24615525885953, 218, 36, 'PPL', 'P'),
(183690, 'North Long Beach', 33.8600006103516, 0.590968495377924, -118.184722900391, -2.06271254016896, 218, 6, 'PPL', 'P'),
(145922, 'North Long Branch', 40.313060760498, 0.70359564182722, -73.9844436645508, -1.29127213720267, 218, 37, 'PPL', 'P'),
(96602, 'North Loop', 29.5277805328369, 0.51535699110429, -98.4591674804688, -1.71843665130671, 218, 51, 'PPL', 'P'),
(191950, 'North Loop Acres Colonia', 31.6709995269775, 0.552763219143325, -106.28099822998, -1.85495335141942, 218, 51, 'PPL', 'P'),
(142542, 'North Loup', 41.4952812194824, 0.724229281320936, -98.7727813720703, -1.72391024629515, 218, 35, 'PPL', 'P'),
(128328, 'North Lovell', 44.2419395446777, 0.772167512522907, -70.8775024414063, -1.23704578319286, 218, 26, 'PPL', 'P'),
(175591, 'North Lowell', 43.3702812194824, 0.75695420479583, -88.7961120605469, -1.54978451842639, 218, 57, 'PPL', 'P'),
(128329, 'North Lubec', 44.8683280944824, 0.783100055113792, -67.0183334350586, -1.16969057764117, 218, 26, 'PPL', 'P'),
(189124, 'North Lucy', 34.8572196960449, 0.608373251787001, -105.580558776855, -1.84272837675153, 218, 38, 'PPL', 'P'),
(113830, 'North Lyme', 41.4119415283203, 0.722774729312562, -72.3372192382813, -1.26252264744499, 218, 8, 'PPL', 'P'),
(151226, 'North Lynbrook', 40.6022186279297, 0.708642398671948, -73.6650009155273, -1.28569680946059, 218, 40, 'PPL', 'P'),
(49883, 'North Lynch Estates', 39.5083312988281, 0.689550463133279, -77.602783203125, -1.35442407560588, 218, 25, 'PPL', 'P'),
(128330, 'North Lyndon', 46.9394416809082, 0.81924780637971, -68.024169921875, -1.18724573607281, 218, 26, 'PPL', 'P'),
(151227, 'North Macedon', 43.082218170166, 0.751926556131924, -77.3047180175781, -1.34922185673252, 218, 40, 'PPL', 'P'),
(30681, 'North Madison', 38.7677803039551, 0.676625409993824, -85.3966674804688, -1.49045301776495, 218, 19, 'PPL', 'P'),
(113831, 'North Madison', 41.3597183227539, 0.721863262429482, -72.6372222900391, -1.2677586884642, 218, 8, 'PPL', 'P'),
(156826, 'North Madison', 41.8019409179688, 0.729581502742696, -81.0491714477539, -1.41457489777669, 218, 41, 'PPL', 'P'),
(178725, 'North Mammoth', 32.7336082458496, 0.571309239948041, -110.646392822266, -1.93114386020356, 218, 5, 'PPL', 'P'),
(123325, 'North Manchester', 41.000560760498, 0.715594780434681, -85.7686080932617, -1.49694460608007, 218, 19, 'PPL', 'P'),
(132322, 'North Manitou', 45.1202812194824, 0.787497466705731, -85.9791717529297, -1.50061963522633, 218, 27, 'PPL', 'P'),
(137171, 'North Mankato', 44.1733283996582, 0.770970022138753, -94.0336074829102, -1.64119605810476, 218, 28, 'PPL', 'P'),
(151228, 'North Manlius', 43.0997200012207, 0.752232020708956, -75.9775009155273, -1.32605754841296, 218, 40, 'PPL', 'P'),
(113328, 'North Manor', 40.0258293151855, 0.698582507391255, -79.5947189331055, -1.38918991258216, 218, 45, 'PPL', 'P'),
(128331, 'North Mariaville', 44.7805595397949, 0.781568204854778, -68.3736114501953, -1.1933446412852, 218, 26, 'PPL', 'P'),
(123326, 'North Marion', 40.9708290100098, 0.715075863496279, -87.1500015258789, -1.52105446974467, 218, 19, 'PPL', 'P'),
(125630, 'North Marshfield', 42.1430587768555, 0.735535132517622, -70.7708282470703, -1.23518396727478, 218, 23, 'PPL', 'P'),
(42320, 'North Maryland', 30.5536098480225, 0.533261090217756, -91.1986083984375, -1.59171598978969, 218, 22, 'PPL', 'P'),
(208271, 'North Marysville', 48.0994415283203, 0.839493623039683, -122.147499084473, -2.13187603210081, 218, 56, 'PPL', 'P'),
(151229, 'North Massapequa', 40.7008285522461, 0.710363466526411, -73.4625015258789, -1.28216252837795, 218, 40, 'PPL', 'P'),
(110680, 'North Matewan', 37.6263885498047, 0.656704365828786, -82.1483306884766, -1.43375884553102, 218, 58, 'PPL', 'P'),
(76746, 'North McAlester', 34.9558296203613, 0.610094319641465, -95.7605590820313, -1.671337049532, 218, 42, 'PPL', 'P'),
(96603, 'North McColl Colonia', 26.326000213623, 0.459475382608453, -98.1910018920898, -1.71375627884895, 218, 51, 'PPL', 'P'),
(183691, 'North McHenry', 37.7400016784668, 0.658687288997432, -121.008331298828, -2.11199380350866, 218, 6, 'PPL', 'P'),
(208270, 'North McNary', 45.9427795410156, 0.801852770508612, -119.307502746582, -2.08230874526003, 218, 56, 'PPL', 'P'),
(17307, 'North Meadowbrook Terrace', 30.1783294677734, 0.526711211964275, -81.7513885498047, -1.42683089827128, 218, 12, 'PPL', 'P'),
(128332, 'North Meadows', 43.9061088562012, 0.766306161279752, -69.8619384765625, -1.21932084824173, 218, 26, 'PPL', 'P'),
(165333, 'North Mehoopany', 41.5758285522461, 0.725635097481362, -76.0625, -1.32754106229819, 218, 45, 'PPL', 'P'),
(175592, 'North Menomonie', 44.8977813720703, 0.783614111783204, -91.9316711425781, -1.60451034829865, 218, 57, 'PPL', 'P'),
(151231, 'North Merrick', 40.6911087036133, 0.710193823164973, -73.563606262207, -1.28392713891623, 218, 40, 'PPL', 'P'),
(17308, 'North Miami', 25.889720916748, 0.451860872419698, -80.1869430541992, -1.39952617340497, 218, 12, 'PPL', 'P'),
(76747, 'North Miami', 36.9172210693359, 0.644327058346534, -94.8794403076172, -1.65595862581734, 218, 42, 'PPL', 'P'),
(17309, 'North Miami Beach', 25.9327793121338, 0.452612383189805, -80.1627807617188, -1.39910446184636, 218, 12, 'PPL', 'P'),
(113833, 'North Mianus', 41.0580596923828, 0.71659832611245, -73.5819396972656, -1.2842471177212, 218, 8, 'PPL', 'P'),
(13175, 'North Michigan Park', 38.9430618286133, 0.679684649717025, -76.977783203125, -1.34351576778092, 218, 9, 'PPL', 'P'),
(125631, 'North Middleboro', 41.9333305358887, 0.731874684178336, -70.9749984741211, -1.23874740997136, 218, 23, 'PPL', 'P'),
(37453, 'North Middletown', 38.1450004577637, 0.66575585116272, -84.1113891601563, -1.46802067927099, 218, 21, 'PPL', 'P'),
(73717, 'North Middletown', 39.5333290100098, 0.689986755498861, -84.3655624389648, -1.47245683985679, 218, 41, 'PPL', 'P'),
(145923, 'North Middletown', 40.4394416809082, 0.705801405000078, -74.1194381713867, -1.29362823581906, 218, 37, 'PPL', 'P'),
(156827, 'North Milan', 41.3122215270996, 0.721034286961168, -82.6047210693359, -1.44172436035144, 218, 41, 'PPL', 'P'),
(125632, 'North Milford', 42.1833305358887, 0.736238007308321, -71.538330078125, -1.24857940124177, 218, 23, 'PPL', 'P'),
(14306, 'North Milford (historical)', 38.9172210693359, 0.679233643386421, -75.4286117553711, -1.31647762533973, 218, 10, 'PPL', 'P'),
(165335, 'North Mills', 41.3025016784668, 0.72086464359973, -80.1822204589844, -1.39944374856924, 218, 45, 'PPL', 'P'),
(151232, 'North Milton', 43.0697212219238, 0.751708443238646, -73.8947219848633, -1.2897061984817, 218, 40, 'PPL', 'P'),
(14307, 'North Minister', 39.8302803039551, 0.695169533296264, -75.5033264160156, -1.31778164216748, 218, 10, 'PPL', 'P'),
(110681, 'North Mitchell Heights', 37.9211082458496, 0.661848194895247, -81.9747161865234, -1.43072870084272, 218, 58, 'PPL', 'P'),
(4619, 'North Mobile', 30.7613906860352, 0.536887549963631, -88.0913925170898, -1.53748484208991, 218, 2, 'PPL', 'P'),
(128333, 'North Monmouth', 44.2777786254883, 0.77279302248394, -70.0313873291016, -1.22227828863226, 218, 26, 'PPL', 'P'),
(42321, 'North Monroe', 32.5683288574219, 0.568424570434295, -92.0738906860352, -1.60699254759265, 218, 22, 'PPL', 'P'),
(128334, 'North Monroe', 44.624439239502, 0.778843391585464, -69.0966720581055, -1.20596442958471, 218, 26, 'PPL', 'P'),
(156828, 'North Monroeville', 41.2874984741211, 0.720602788285548, -82.725830078125, -1.44383811130864, 218, 41, 'PPL', 'P'),
(125633, 'North Monson', 42.1222190856934, 0.735171411291745, -72.3083267211914, -1.26201837789259, 218, 23, 'PPL', 'P'),
(4620, 'North Montgomery', 32.3938903808594, 0.565380044676116, -86.3138885498047, -1.50646154539353, 218, 2, 'PPL', 'P'),
(172333, 'North Montpelier', 44.3036117553711, 0.77324389565649, -72.4469375610352, -1.26443759342681, 218, 55, 'PPL', 'P'),
(56576, 'North Moor', 39.1925010681152, 0.684038185730005, -94.6127777099609, -1.65130448549632, 218, 29, 'PPL', 'P'),
(73718, 'North Moreland', 38.7630615234375, 0.676543051737113, -82.9361114501953, -1.44750821360688, 218, 41, 'PPL', 'P'),
(132323, 'North Morenci', 41.7636108398438, 0.728912516676868, -84.2236099243164, -1.46997930109469, 218, 27, 'PPL', 'P'),
(172334, 'North Moretown', 44.3241691589355, 0.773602690034351, -72.7452774047852, -1.26964460599014, 218, 55, 'PPL', 'P'),
(28070, 'North Mounds', 37.1230583190918, 0.647919596078024, -89.2002792358398, -1.55683856636374, 218, 18, 'PPL', 'P'),
(104725, 'North Mount Vernon', 38.7205581665039, 0.675801228215472, -77.0580596923828, -1.34491685683041, 218, 53, 'PPL', 'P'),
(156829, 'North Mount Vernon', 40.4061088562012, 0.70521963745995, -82.4775009155273, -1.43950394979259, 218, 41, 'PPL', 'P'),
(104727, 'North Mountain', 38.1597213745117, 0.666012779628886, -79.2702789306641, -1.38352736631438, 218, 53, 'PPL', 'P'),
(110682, 'North Mountain', 39.5633316040039, 0.690510399548198, -77.9805603027344, -1.3610175298327, 218, 58, 'PPL', 'P'),
(165336, 'North Mountain', 41.2922210693359, 0.720685213121286, -76.5527801513672, -1.33609806519672, 218, 45, 'PPL', 'P'),
(104726, 'North Mountain Estates', 39.1916694641113, 0.684023671502064, -78.3963928222656, -1.36827517643538, 218, 53, 'PPL', 'P'),
(82638, 'North Mullins', 34.2169418334961, 0.597198294957892, -79.2574996948242, -1.38330432657308, 218, 48, 'PPL', 'P'),
(156830, 'North Munson', 41.5541687011719, 0.725257061764625, -81.2569427490234, -1.41820119107499, 218, 41, 'PPL', 'P'),
(183692, 'North Muroc (historical)', 35.0050010681152, 0.610952523302743, -117.818061828613, -2.05631309722755, 218, 6, 'PPL', 'P'),
(132324, 'North Muskegon', 43.2561111450195, 0.754961561089205, -86.2675018310547, -1.50565194442214, 218, 27, 'PPL', 'P'),
(82639, 'North Myrtle Beach', 33.8158302307129, 0.590197576821374, -78.6802825927734, -1.37322998764348, 218, 48, 'PPL', 'P'),
(17315, 'North Naples', 26.2188892364502, 0.457605943391758, -81.7919387817383, -1.42753863333097, 218, 12, 'PPL', 'P'),
(151233, 'North Nassau', 42.5791702270508, 0.743146713229178, -73.5436096191406, -1.28357813165538, 218, 40, 'PPL', 'P'),
(125634, 'North Natick', 42.3013916015625, 0.738298561622743, -71.3583297729492, -1.24543780326186, 218, 23, 'PPL', 'P'),
(208272, 'North Nemah', 46.5138893127441, 0.811820516415588, -123.862503051758, -2.1618084980147, 218, 56, 'PPL', 'P'),
(212047, 'North Nenana', 64.5788879394531, 1.12711422181991, -149.113891601563, -2.60252836890919, 218, 1, 'PPL', 'P'),
(151234, 'North New Hyde Park', 40.7430610656738, 0.711100562937118, -73.6936111450195, -1.28619615216498, 218, 40, 'PPL', 'P'),
(128335, 'North New Portland', 44.9249992370605, 0.784089153142647, -70.0236129760742, -1.22214260057472, 218, 26, 'PPL', 'P'),
(113078, 'North New Salem', 42.5458297729492, 0.742564812530995, -72.3194427490234, -1.262212389178, 218, 23, 'PPL', 'P'),
(128336, 'North Newburgh', 44.7555618286133, 0.781131912489196, -68.9736099243164, -1.20381659016556, 218, 26, 'PPL', 'P'),
(128337, 'North Newcastle', 44.0858306884766, 0.769442898990675, -69.5747222900391, -1.21430798012187, 218, 26, 'PPL', 'P'),
(128338, 'North Newport', 44.8913917541504, 0.783502591912557, -69.2069396972656, -1.20788896294645, 218, 26, 'PPL', 'P'),
(144238, 'North Newport', 43.3886108398438, 0.757274117021775, -72.2149963378906, -1.26038945541184, 218, 36, 'PPL', 'P'),
(128339, 'North Newry', 44.5458297729492, 0.777471397570882, -70.833610534668, -1.2362797249053, 218, 26, 'PPL', 'P'),
(33445, 'North Newton', 38.0722198486328, 0.66448558990178, -97.3452835083008, -1.69899570850719, 218, 20, 'PPL', 'P'),
(120822, 'North Northfield', 42.1383285522461, 0.73545257452383, -87.8813934326172, -1.53381966663969, 218, 18, 'PPL', 'P'),
(183693, 'North Norton', 34.1055603027344, 0.595254320520189, -117.251937866211, -2.0464323701092, 218, 6, 'PPL', 'P'),
(128340, 'North Norway', 44.2563896179199, 0.772419713878138, -70.6352767944336, -1.23281814812041, 218, 26, 'PPL', 'P'),
(151235, 'North Norwich', 42.6169395446777, 0.743805912178, -75.5272216796875, -1.31819869319419, 218, 40, 'PPL', 'P'),
(144239, 'North Nottingham', 43.1669387817383, 0.753405209748163, -71.1061096191406, -1.24103573113802, 218, 36, 'PPL', 'P'),
(17310, 'North Oak Hill', 30.2533302307129, 0.528020222219076, -81.773063659668, -1.42720920030413, 218, 12, 'PPL', 'P'),
(165338, 'North Oakland', 40.9219398498535, 0.714222586683018, -79.7936096191406, -1.39266120990502, 218, 45, 'PPL', 'P'),
(123327, 'North Oaks', 40.776668548584, 0.711687124167208, -85.1738891601563, -1.48656480257343, 218, 19, 'PPL', 'P'),
(137173, 'North Oaks', 45.1027793884277, 0.787192002128698, -93.0788879394531, -1.6245330586383, 218, 28, 'PPL', 'P'),
(49884, 'North Ocean City', 38.3738899230957, 0.669750725955894, -75.0702819824219, -1.31022359099384, 218, 25, 'PPL', 'P'),
(49885, 'North Ocean Pines', 38.3899993896484, 0.670031889187979, -75.1694412231445, -1.31195424622823, 218, 25, 'PPL', 'P'),
(205140, 'North Ogden', 41.3072204589844, 0.720947001856441, -111.959442138672, -1.95406089401591, 218, 52, 'PPL', 'P'),
(30682, 'North Ogilville', 39.1319389343262, 0.682981177093353, -86.0077819824219, -1.50111897793072, 218, 19, 'PPL', 'P'),
(151237, 'North Olean', 42.0950012207031, 0.734696369932302, -78.4322204589844, -1.36890048665934, 218, 40, 'PPL', 'P'),
(156831, 'North Olmsted', 41.4155616760254, 0.722837912809424, -81.9236068725586, -1.4298366750356, 218, 41, 'PPL', 'P'),
(208273, 'North Olympia', 47.1027793884277, 0.822098587168585, -122.881393432617, -2.14468490483771, 218, 56, 'PPL', 'P'),
(208275, 'North Omak', 48.4452781677246, 0.84552961107132, -119.443328857422, -2.08467935810437, 218, 56, 'PPL', 'P'),
(183694, 'North Ontario', 34.0941696166992, 0.595055515544814, -117.650283813477, -2.05338481845096, 218, 6, 'PPL', 'P'),
(125635, 'North Orange', 42.6352806091309, 0.744126024141027, -72.2624969482422, -1.26121849745918, 218, 23, 'PPL', 'P'),
(96604, 'North Orange Estates Colonia', 27.9850006103516, 0.488430401823257, -97.9660034179688, -1.70982931466357, 218, 51, 'PPL', 'P'),
(128341, 'North Orland', 44.6386108398438, 0.779090732671705, -68.64111328125, -1.19801342899222, 218, 26, 'PPL', 'P'),
(128342, 'North Orrington', 44.7483291625977, 0.781005678653526, -68.8072204589844, -1.20091254615488, 218, 26, 'PPL', 'P'),
(165339, 'North Orwell', 41.9124984741211, 0.731511096110512, -76.3150024414063, -1.33194806127005, 218, 45, 'PPL', 'P'),
(151238, 'North Osceola', 43.5708312988281, 0.760454463995548, -75.7127838134766, -1.32143736339583, 218, 40, 'PPL', 'P'),
(125636, 'North Otis', 42.2313919067383, 0.737076836472669, -73.1097183227539, -1.27600529993768, 218, 23, 'PPL', 'P'),
(125637, 'North Oxford', 42.1500015258789, 0.735656306347221, -71.8688888549805, -1.25434874026927, 218, 23, 'PPL', 'P'),
(82640, 'North Pacolet', 35.1655616760254, 0.613754834559779, -82.0849990844727, -1.43265350052058, 218, 48, 'PPL', 'P'),
(110685, 'North Page', 38.0708312988281, 0.66446135513586, -81.2611083984375, -1.41827389537275, 218, 58, 'PPL', 'P'),
(128344, 'North Palermo', 44.4513893127441, 0.775823100593205, -69.3949966430664, -1.21117117583192, 218, 26, 'PPL', 'P'),
(17311, 'North Palm Beach', 26.8172206878662, 0.468048797237204, -80.0822219848633, -1.39769844594885, 218, 12, 'PPL', 'P'),
(156833, 'North Palm Beach', 41.4069404602051, 0.722687444207835, -82.5713882446289, -1.44114259281132, 218, 41, 'PPL', 'P'),
(17312, 'North Palm Beach Heights', 26.889440536499, 0.469309271381138, -80.1308288574219, -1.3985467959141, 218, 12, 'PPL', 'P'),
(183695, 'North Palm Springs', 33.922779083252, 0.59206418642941, -116.542221069336, -2.03404547524702, 218, 6, 'PPL', 'P'),
(128345, 'North Paris', 44.3375015258789, 0.773835383734597, -70.5297164916992, -1.2309757732783, 218, 26, 'PPL', 'P'),
(30683, 'North Park', 39.2966690063477, 0.685856259227175, -85.9541702270508, -1.50018327628172, 218, 19, 'PPL', 'P'),
(120816, 'North Park', 42.3427810668945, 0.739020944068427, -89.0519409179688, -1.55424957431002, 218, 18, 'PPL', 'P'),
(165340, 'North Park', 40.1666717529297, 0.701040671656425, -74.8166732788086, -1.30579728410407, 218, 45, 'PPL', 'P'),
(177257, 'North Park', 40.0855598449707, 0.699625001799966, -80.7144393920898, -1.40873272129338, 218, 58, 'PPL', 'P'),
(208274, 'North Park', 47.7066688537598, 0.832638446656737, -122.348609924316, -2.13538607841753, 218, 56, 'PPL', 'P'),
(42322, 'North Park Estates', 32.6083297729492, 0.569122718114059, -93.8861083984375, -1.63862171343703, 218, 22, 'PPL', 'P'),
(110684, 'North Parkersburg', 39.2877807617188, 0.685701130093678, -81.5330581665039, -1.42302031422554, 218, 58, 'PPL', 'P'),
(128346, 'North Parsonsfield', 43.7572212219238, 0.763707581846107, -70.9230575561523, -1.2378408699363, 218, 26, 'PPL', 'P'),
(42324, 'North Pass', 30.3072204589844, 0.528960784137064, -90.4047164916992, -1.57785996211217, 218, 22, 'PPL', 'P'),
(125638, 'North Pasture (historical)', 41.2750015258789, 0.72038467539227, -70.0458297729492, -1.22253035682944, 218, 23, 'PPL', 'P'),
(151239, 'North Patchogue', 40.7869415283203, 0.711866421487597, -73.0094375610352, -1.27425507046928, 218, 40, 'PPL', 'P'),
(56578, 'North Patton', 37.5302810668945, 0.6550269738162, -90.0149993896484, -1.57105811553005, 218, 29, 'PPL', 'P'),
(172335, 'North Pawlet', 43.3827781677246, 0.757172317689107, -73.2044372558594, -1.27765845718435, 218, 55, 'PPL', 'P'),
(132326, 'North Paynesville', 46.5641708374023, 0.812698094573796, -89.1155624389648, -1.55535997932652, 218, 27, 'PPL', 'P'),
(23435, 'North Peachtree Estates', 33.4180603027344, 0.583255181912728, -84.5661087036133, -1.47595703247749, 218, 13, 'PPL', 'P'),
(23436, 'North Peachtree Woods', 33.9408302307129, 0.592379238386367, -84.2958297729492, -1.47123977523863, 218, 13, 'PPL', 'P'),
(104728, 'North Pearisburg', 37.3416709899902, 0.65173510697178, -80.7708282470703, -1.40971689247422, 218, 53, 'PPL', 'P'),
(96605, 'North Pearsall', 28.9147205352783, 0.504657075634624, -99.0961074829102, -1.72955335148697, 218, 51, 'PPL', 'P'),
(120818, 'North Pekin', 40.6150016784668, 0.708865504992269, -89.6222229003906, -1.56420287256808, 218, 18, 'PPL', 'P'),
(144240, 'North Pelham', 42.773609161377, 0.746540312827238, -71.3530578613281, -1.2453457910462, 218, 36, 'PPL', 'P'),
(151240, 'North Pelham', 40.9188919067383, 0.714169390040243, -73.8063888549805, -1.28816449452666, 218, 40, 'PPL', 'P'),
(125639, 'North Pembroke', 42.0930595397949, 0.734662481207431, -70.7930603027344, -1.23557198984561, 218, 23, 'PPL', 'P'),
(144241, 'North Pembroke', 43.2027816772461, 0.754030786288223, -71.4286117553711, -1.24666445525995, 218, 36, 'PPL', 'P'),
(151241, 'North Pembroke', 43.021110534668, 0.750860026694374, -78.3361129760742, -1.36722309464675, 218, 40, 'PPL', 'P'),
(128347, 'North Penobscot', 44.521671295166, 0.777049752591295, -68.6619415283203, -1.19837695048102, 218, 26, 'PPL', 'P'),
(120819, 'North Peoria', 40.7174987792969, 0.710654416875502, -89.5841674804688, -1.56353868019221, 218, 18, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(125640, 'North Pepperell', 42.6930618286133, 0.745134496666813, -71.591667175293, -1.24951030920081, 218, 23, 'PPL', 'P'),
(4622, 'North Perry', 32.7847213745117, 0.57220133233419, -87.4055633544922, -1.52551486509639, 218, 2, 'PPL', 'P'),
(128349, 'North Perry', 45.0302810668945, 0.785926667715775, -67.1086120605469, -1.17126623690012, 218, 26, 'PPL', 'P'),
(156834, 'North Perry', 41.7783317565918, 0.729169445143033, -81.1500015258789, -1.41633471462501, 218, 41, 'PPL', 'P'),
(151245, 'North Petersburg', 42.8230590820313, 0.747403376757506, -73.3327789306641, -1.27989844197721, 218, 40, 'PPL', 'P'),
(151242, 'North Pharsalia', 42.6083297729492, 0.743655643313492, -75.7019424438477, -1.32124814580038, 218, 40, 'PPL', 'P'),
(165341, 'North Philipsburg', 40.9075012207031, 0.713970585064869, -78.2080612182617, -1.36498816985995, 218, 45, 'PPL', 'P'),
(208276, 'North Pine', 47.2819404602051, 0.825225537762502, -117.363891601563, -2.04838633140099, 218, 56, 'PPL', 'P'),
(165342, 'North Pine Grove', 41.3952789306641, 0.722483912121525, -79.2222213745117, -1.38268860372906, 218, 45, 'PPL', 'P'),
(82642, 'North Pines', 34.1480598449707, 0.595996077462803, -80.9749984741211, -1.4132803351708, 218, 48, 'PPL', 'P'),
(104729, 'North Pines', 38.170280456543, 0.666197070376319, -78.4233322143555, -1.36874535752584, 218, 53, 'PPL', 'P'),
(151243, 'North Pitcher', 42.622501373291, 0.743902984399733, -75.8199996948242, -1.32330863353578, 218, 40, 'PPL', 'P'),
(112241, 'North Pitts', 35.6780586242676, 0.622699593713028, -91.0274963378906, -1.58872952094327, 218, 4, 'PPL', 'P'),
(128350, 'North Pittston', 44.2236099243164, 0.771847600296962, -69.6930618286133, -1.21637339470528, 218, 26, 'PPL', 'P'),
(23437, 'North Place', 33.9991683959961, 0.593397431450131, -83.3797225952148, -1.45525068868601, 218, 13, 'PPL', 'P'),
(183697, 'North Placerville', 38.7550010681152, 0.67640237025253, -120.830558776855, -2.10889108768066, 218, 6, 'PPL', 'P'),
(145924, 'North Plainfield', 40.6300010681152, 0.709127293727424, -74.4277801513672, -1.29900981859184, 218, 37, 'PPL', 'P'),
(201316, 'North Plains', 45.5972213745117, 0.795821642745964, -122.992218017578, -2.14661915873743, 218, 43, 'PPL', 'P'),
(120820, 'North Plato', 42.0550003051758, 0.733998222252538, -88.4641723632813, -1.54399107779103, 218, 18, 'PPL', 'P'),
(199567, 'North Platte', 41.1238899230957, 0.717747280385738, -100.764999389648, -1.75868101011944, 218, 35, 'PPL', 'P'),
(37454, 'North Pleasureville', 38.3597183227539, 0.669503384869653, -85.1072235107422, -1.48540126749318, 218, 21, 'PPL', 'P'),
(125641, 'North Plymouth', 41.9708290100098, 0.732529156016222, -70.6833267211914, -1.23365677754768, 218, 23, 'PPL', 'P'),
(125642, 'North Plympton', 41.9883308410645, 0.732834620593255, -70.8077774047852, -1.23582885173275, 218, 23, 'PPL', 'P'),
(125643, 'North Pocasset', 41.6958312988281, 0.727729540520654, -70.6055603027344, -1.23229949749812, 218, 23, 'PPL', 'P'),
(23438, 'North Point', 33.9638900756836, 0.592781708606105, -84.3408279418945, -1.47202514144409, 218, 13, 'PPL', 'P'),
(42323, 'North Point', 31.2999992370605, 0.54628804255842, -92.1547164916992, -1.60840322402207, 218, 22, 'PPL', 'P'),
(49887, 'North Point', 38.728889465332, 0.67594663681099, -76.1527786254883, -1.32911672155713, 218, 25, 'PPL', 'P'),
(67272, 'North Point', 36.1966705322266, 0.631751079046962, -75.7630615234375, -1.32231487497502, 218, 33, 'PPL', 'P'),
(165345, 'North Point', 40.9036102294922, 0.713902674457072, -79.1316680908203, -1.38110815078015, 218, 45, 'PPL', 'P'),
(49888, 'North Point Village', 39.2666702270508, 0.685332681756865, -76.4719390869141, -1.3346871224512, 218, 25, 'PPL', 'P'),
(23440, 'North Pointe', 34.0905609130859, 0.594992531785034, -84.0669403076172, -1.46724490044545, 218, 13, 'PPL', 'P'),
(76748, 'North Pole', 34.0916709899902, 0.595011906281964, -94.8891677856445, -1.65612840233683, 218, 42, 'PPL', 'P'),
(151244, 'North Pole', 44.4008293151855, 0.774940662166007, -73.8494415283203, -1.28891590542822, 218, 40, 'PPL', 'P'),
(195394, 'North Pole', 47.9044418334961, 0.836090236324616, -116.741111755371, -2.03751677256988, 218, 17, 'PPL', 'P'),
(212046, 'North Pole', 64.751106262207, 1.13011999858423, -147.34944152832, -2.57173290564405, 218, 1, 'PPL', 'P'),
(172336, 'North Pomfret', 43.7227783203125, 0.763106439809049, -72.4802780151367, -1.265019494125, 218, 55, 'PPL', 'P'),
(183699, 'North Pomona', 34.0900001525879, 0.594982744668028, -117.749443054199, -2.05511547368534, 218, 6, 'PPL', 'P'),
(17313, 'North Pompano Beach', 26.2786102294922, 0.458648271352901, -80.1030578613281, -1.3980621005957, 218, 12, 'PPL', 'P'),
(23441, 'North Pond', 33.5233306884766, 0.585092496748774, -84.414436340332, -1.47330985035395, 218, 13, 'PPL', 'P'),
(17314, 'North Port', 27.0438899993896, 0.472004923036517, -82.2361068725586, -1.43529082894808, 218, 12, 'PPL', 'P'),
(4623, 'North Port (historical)', 34.788330078125, 0.607170901133857, -87.6722183227539, -1.53016887225936, 218, 2, 'PPL', 'P'),
(151261, 'North Port Byron', 43.0525016784668, 0.751407905509631, -76.6327819824219, -1.33749436055625, 218, 40, 'PPL', 'P'),
(71181, 'North Port Norris', 39.2686080932617, 0.685366503902709, -75.0272216796875, -1.30947204693422, 218, 37, 'PPL', 'P'),
(201317, 'North Portland', 45.6105613708496, 0.796054469604264, -122.702217102051, -2.14155768792768, 218, 43, 'PPL', 'P'),
(49889, 'North Potomac', 39.0827789306641, 0.682123173169156, -77.2652816772461, -1.34853356274879, 218, 25, 'PPL', 'P'),
(49890, 'North Potomac Vista', 38.788330078125, 0.676984071213631, -77.0105590820313, -1.34408781478307, 218, 25, 'PPL', 'P'),
(201318, 'North Powder', 45.0286102294922, 0.785897506101838, -117.918891906738, -2.05807291407588, 218, 43, 'PPL', 'P'),
(128352, 'North Pownal', 43.9375, 0.766854040095009, -70.1933288574219, -1.22510470149716, 218, 26, 'PPL', 'P'),
(172337, 'North Pownal', 42.7975006103516, 0.746957297274918, -73.2649993896484, -1.278715465821, 218, 55, 'PPL', 'P'),
(96606, 'North Prairie', 31.3416690826416, 0.547015318562607, -97.0833282470703, -1.69442372670579, 218, 51, 'PPL', 'P'),
(137176, 'North Prairie', 45.8008308410645, 0.799375298325538, -94.3491668701172, -1.6467036083971, 218, 28, 'PPL', 'P'),
(175593, 'North Prairie', 42.934440612793, 0.749347351195209, -88.4052810668945, -1.54296323076832, 218, 57, 'PPL', 'P'),
(125644, 'North Prescott', 42.4561080932617, 0.740998873810029, -72.3441696166992, -1.26264395443265, 218, 23, 'PPL', 'P'),
(145926, 'North Princeton', 40.3638916015625, 0.704482807365353, -74.6613922119141, -1.30308711822075, 218, 37, 'PPL', 'P'),
(208277, 'North Prosser', 46.2322196960449, 0.806904454201356, -119.767219543457, -2.09033231699223, 218, 56, 'PPL', 'P'),
(169519, 'North Providence', 41.8499984741211, 0.730420265328016, -71.466667175293, -1.24732864763582, 218, 47, 'PPL', 'P'),
(208278, 'North Puyallup', 47.2069396972656, 0.8239165275077, -122.281112670898, -2.13420802910934, 218, 56, 'PPL', 'P'),
(169521, 'North Quidnessett', 41.6386108398438, 0.726730855111875, -71.4194412231445, -1.24650439927844, 218, 47, 'PPL', 'P'),
(28076, 'North Quincy', 39.9705581665039, 0.697617843865401, -91.396110534668, -1.59516305234663, 218, 18, 'PPL', 'P'),
(113076, 'North Quincy', 42.2769393920898, 0.737871790058058, -71.0208282470703, -1.23954729040477, 218, 23, 'PPL', 'P'),
(183700, 'North Ranch', 34.1966705322266, 0.596844494007075, -118.81916809082, -2.0737856976654, 218, 6, 'PPL', 'P'),
(156837, 'North Randall', 41.4347190856934, 0.723172272684284, -81.5258331298828, -1.42289421354793, 218, 41, 'PPL', 'P'),
(125645, 'North Randolph', 42.1972198486328, 0.736480421546546, -71.0625, -1.24027459969847, 218, 23, 'PPL', 'P'),
(172338, 'North Randolph', 43.9738883972168, 0.767489137435965, -72.5563888549805, -1.26634787887673, 218, 55, 'PPL', 'P'),
(110686, 'North Ravenswood', 38.9605598449707, 0.67999004771503, -81.7688903808594, -1.42713636284832, 218, 58, 'PPL', 'P'),
(128353, 'North Raymond', 43.980281829834, 0.767600723885639, -70.4049987792969, -1.22879903856132, 218, 26, 'PPL', 'P'),
(175595, 'North Readfield', 44.2866706848145, 0.772948218196464, -88.7694396972656, -1.54931899786784, 218, 57, 'PPL', 'P'),
(125646, 'North Reading', 42.5750007629395, 0.743073942352391, -71.0791702270508, -1.24056555004756, 218, 23, 'PPL', 'P'),
(151246, 'North Reading', 42.4516716003418, 0.740921442401335, -76.9730606079102, -1.34343334294518, 218, 40, 'PPL', 'P'),
(175596, 'North Red Wing', 44.577220916748, 0.778019276386139, -92.5475006103516, -1.6152586001421, 218, 57, 'PPL', 'P'),
(17316, 'North Redington Beach', 27.8158302307129, 0.485477821701714, -82.8208312988281, -1.44549619540332, 218, 12, 'PPL', 'P'),
(96607, 'North Redland', 31.7369403839111, 0.553914104208402, -94.6627807617188, -1.65217720338554, 218, 51, 'PPL', 'P'),
(137178, 'North Redwood', 44.5633316040039, 0.777776862147914, -95.0941696166992, -1.65970635926136, 218, 28, 'PPL', 'P'),
(125648, 'North Rehoboth', 41.9027786254883, 0.731341452749074, -71.2194366455078, -1.24301366087962, 218, 23, 'PPL', 'P'),
(96608, 'North Richland Hills', 32.834171295166, 0.573064396264458, -97.2286071777344, -1.69695932237966, 218, 51, 'PPL', 'P'),
(144242, 'North Richmond', 42.7930603027344, 0.746879799287196, -72.2724990844727, -1.26139306766864, 218, 36, 'PPL', 'P'),
(156839, 'North Richmond', 41.7144393920898, 0.72805431301559, -80.5688934326172, -1.40619246508761, 218, 41, 'PPL', 'P'),
(183701, 'North Richmond', 37.9588890075684, 0.662507593581151, -122.366386413574, -2.13569633668453, 218, 6, 'PPL', 'P'),
(23442, 'North Ridge', 33.0897216796875, 0.577524591879095, -85.0563888549805, -1.48451403537602, 218, 13, 'PPL', 'P'),
(49891, 'North Ridge', 39.121940612793, 0.682806673462925, -76.8358306884766, -1.34103822901882, 218, 25, 'PPL', 'P'),
(67275, 'North Ridge', 35.6188888549805, 0.621666886421322, -77.5861129760742, -1.35413312525679, 218, 33, 'PPL', 'P'),
(82643, 'North Ridge', 35.1063919067383, 0.612722127268073, -82.0697174072266, -1.43238678493741, 218, 48, 'PPL', 'P'),
(151247, 'North Ridge', 43.2125015258789, 0.754200429649661, -78.8261108398438, -1.37577517069727, 218, 40, 'PPL', 'P'),
(33447, 'North Ridge (historical)', 37.7361106872559, 0.658619378389635, -95.5961074829102, -1.66846682766717, 218, 20, 'PPL', 'P'),
(4624, 'North Ridge Mobile Home Park', 31.8569393157959, 0.556008480668668, -85.9997177124023, -1.50097822986711, 218, 2, 'PPL', 'P'),
(30684, 'North Ridge Village', 39.935001373291, 0.696997260752385, -86.149169921875, -1.50358666299678, 218, 19, 'PPL', 'P'),
(156840, 'North Ridgeville', 41.3894386291504, 0.722381979630803, -82.019172668457, -1.43150461282632, 218, 41, 'PPL', 'P'),
(156841, 'North Ridgeville (historical)', 41.1341705322266, 0.717926710864182, -83.8616714477539, -1.46366228298903, 218, 41, 'PPL', 'P'),
(151248, 'North Ridgeway', 43.290828704834, 0.755567496816225, -78.4655609130859, -1.36948238735752, 218, 40, 'PPL', 'P'),
(178726, 'North Rim', 36.2105598449707, 0.631993493285186, -112.060562133789, -1.9558257708703, 218, 5, 'PPL', 'P'),
(56579, 'North River', 39.8438911437988, 0.695407087265499, -91.4894409179688, -1.59679197482738, 218, 29, 'PPL', 'P'),
(67276, 'North River', 34.8163909912109, 0.607660656458323, -76.6361083984375, -1.33755241746801, 218, 33, 'PPL', 'P'),
(140610, 'North River', 46.9508285522461, 0.819446544776057, -96.8022232055664, -1.68951751818759, 218, 34, 'PPL', 'P'),
(151249, 'North River', 43.7386093139648, 0.763382742772145, -74.0491714477539, -1.29240185013708, 218, 40, 'PPL', 'P'),
(67277, 'North River Corner', 34.7825012207031, 0.607069168380216, -76.6266708374023, -1.33738770095459, 218, 33, 'PPL', 'P'),
(23443, 'North River Crossing', 33.9958305358887, 0.593339174801286, -84.2391662597656, -1.47025081036783, 218, 13, 'PPL', 'P'),
(49892, 'North River Forest', 38.985279083252, 0.680421479811623, -76.5922164916992, -1.33678635918045, 218, 25, 'PPL', 'P'),
(110687, 'North River Mills', 39.3363914489746, 0.68654954663795, -78.5033264160156, -1.37014151972731, 218, 58, 'PPL', 'P'),
(23445, 'North River Oaks', 30.7583293914795, 0.536834120294261, -81.5236129760742, -1.42285546455407, 218, 13, 'PPL', 'P'),
(17317, 'North River Shores', 27.2172203063965, 0.475030107587279, -80.2699966430664, -1.4009757319863, 218, 12, 'PPL', 'P'),
(120824, 'North Riverside', 41.8427810668945, 0.730294297808455, -87.8230590820313, -1.53280154015495, 218, 18, 'PPL', 'P'),
(156843, 'North Robinson', 40.7924995422363, 0.711963427130304, -82.8572235107422, -1.44613135932331, 218, 41, 'PPL', 'P'),
(49897, 'North Roblee Acres', 38.8208312988281, 0.677551324525817, -76.8119430541992, -1.34062131115017, 218, 25, 'PPL', 'P'),
(191951, 'North Roby', 32.8066711425781, 0.572584428056998, -100.386672973633, -1.7520779685127, 218, 51, 'PPL', 'P'),
(125649, 'North Rochester', 41.7819404602051, 0.729232428902813, -70.8902816772461, -1.23726882293415, 218, 23, 'PPL', 'P'),
(144243, 'North Rochester', 43.3727798461914, 0.75699781405868, -70.9861068725586, -1.23894128809872, 218, 36, 'PPL', 'P'),
(165346, 'North Rochester', 40.7061080932617, 0.710455611900128, -80.2713928222656, -1.40100009991028, 218, 45, 'PPL', 'P'),
(209639, 'North Rock Springs', 41.6436080932617, 0.726818073637575, -109.264999389648, -1.90703399653896, 218, 59, 'PPL', 'P'),
(42326, 'North Rodessa', 32.9808311462402, 0.575624093546188, -94.0013885498047, -1.64063373164059, 218, 22, 'PPL', 'P'),
(104732, 'North Rolleston', 36.8430595397949, 0.643032695477728, -76.2027816772461, -1.32998943944635, 218, 53, 'PPL', 'P'),
(23446, 'North Rome', 34.2633285522461, 0.598007895929276, -85.158332824707, -1.4862932933003, 218, 13, 'PPL', 'P'),
(165347, 'North Rome', 41.872501373291, 0.730813015009775, -76.4013900756836, -1.3334558099212, 218, 45, 'PPL', 'P'),
(151250, 'North Rose', 43.1855583190918, 0.75373018198018, -76.8927764892578, -1.34203212073764, 218, 40, 'PPL', 'P'),
(156844, 'North Royalton', 41.3136100769043, 0.721058521727088, -81.7247161865234, -1.42636537771274, 218, 41, 'PPL', 'P'),
(172339, 'North Royalton', 43.827220916748, 0.764929306996181, -72.5669403076172, -1.26653203646611, 218, 55, 'PPL', 'P'),
(104733, 'North Run Estates', 37.6483306884766, 0.65708732839354, -77.4749984741211, -1.352193811351, 218, 53, 'PPL', 'P'),
(172340, 'North Rupert', 43.2994384765625, 0.755717765680733, -73.146110534668, -1.27664046385767, 218, 55, 'PPL', 'P'),
(151251, 'North Rush', 43.0033302307129, 0.750549701848353, -77.7058334350586, -1.35622264144807, 218, 40, 'PPL', 'P'),
(17318, 'North Ruskin', 27.764440536499, 0.484580902336089, -82.3947219848633, -1.43805918490122, 218, 12, 'PPL', 'P'),
(151252, 'North Russell', 44.502498626709, 0.776715126400327, -75.1230621337891, -1.3111447784149, 218, 40, 'PPL', 'P'),
(125650, 'North Rutland', 42.4305610656738, 0.740552994064522, -71.9763870239258, -1.25622493725723, 218, 23, 'PPL', 'P'),
(10851, 'North Sabie (historical)', 35.959171295166, 0.627605935389281, -89.9375, -1.5697054960124, 218, 4, 'PPL', 'P'),
(183702, 'North Sacramento', 38.6061096191406, 0.673803724239858, -121.456390380859, -2.11981390973357, 218, 6, 'PPL', 'P'),
(73720, 'North Sagamore Heights', 39.2127799987793, 0.684392119838877, -84.408332824707, -1.47320332391034, 218, 41, 'PPL', 'P'),
(137181, 'North Saint Paul', 45.0125007629395, 0.785616342869753, -92.9916687011719, -1.62301079575921, 218, 28, 'PPL', 'P'),
(30685, 'North Salem', 39.8597183227539, 0.695683323649567, -86.6425018310547, -1.51219692911712, 218, 19, 'PPL', 'P'),
(96617, 'North Salem', 31.3141708374023, 0.546535383644661, -96.0736083984375, -1.67680079082441, 218, 51, 'PPL', 'P'),
(125651, 'North Salem', 42.5263900756836, 0.742225525808119, -70.9055633544922, -1.23753553851732, 218, 23, 'PPL', 'P'),
(139370, 'North Salem', 40.0313911437988, 0.698679579612988, -92.9883270263672, -1.62295247253134, 218, 29, 'PPL', 'P'),
(144244, 'North Salem', 42.8369407653809, 0.747645657837676, -71.2211074829102, -1.24304282249355, 218, 36, 'PPL', 'P'),
(151253, 'North Salem', 41.3347206115723, 0.7214269700639, -73.5716705322266, -1.28406788697984, 218, 40, 'PPL', 'P'),
(156846, 'North Salem', 40.1433296203613, 0.700633274588671, -81.5458297729492, -1.42324322080878, 218, 41, 'PPL', 'P'),
(205147, 'North Salt Lake', 40.8486099243164, 0.712942738042153, -111.906112670898, -1.95313011921492, 218, 52, 'PPL', 'P'),
(183703, 'North San Juan', 39.3694381713867, 0.687126320751034, -121.102783203125, -2.11364230022342, 218, 6, 'PPL', 'P'),
(96609, 'North San Pedro', 27.8024997711182, 0.485245161290982, -97.6827774047852, -1.70488608820622, 218, 51, 'PPL', 'P'),
(189125, 'North San Ysidro', 35.4691696166992, 0.619053792759736, -105.553062438965, -1.84224847512309, 218, 38, 'PPL', 'P'),
(144245, 'North Sanbornton', 43.5519409179688, 0.760124764652596, -71.6100006103516, -1.24983028800578, 218, 36, 'PPL', 'P'),
(144246, 'North Sandwich', 43.8405609130859, 0.765162133854481, -71.3974990844727, -1.24612143671368, 218, 36, 'PPL', 'P'),
(165348, 'North Sandy', 41.3883285522461, 0.722362605133872, -79.9997177124023, -1.39625847474745, 218, 45, 'PPL', 'P'),
(151255, 'North Sanford', 42.1547203063965, 0.735738664603932, -75.4527816772461, -1.31689947005639, 218, 40, 'PPL', 'P'),
(96611, 'North Santa Cruz Colonia', 26.3659992218018, 0.460173496998703, -98.7710037231445, -1.72387922046845, 218, 51, 'PPL', 'P'),
(183704, 'North Santa Maria', 34.9569396972656, 0.610113694138395, -120.44361114502, -2.10213757747233, 218, 6, 'PPL', 'P'),
(82645, 'North Santee', 33.2299995422363, 0.579972902448232, -79.3769378662109, -1.38538891591634, 218, 48, 'PPL', 'P'),
(17319, 'North Sarasota', 27.3736095428467, 0.477759614678014, -82.5186080932617, -1.44022140539026, 218, 12, 'PPL', 'P'),
(125652, 'North Saugus', 42.4958305358887, 0.741692161220804, -71.0202789306641, -1.23953770302485, 218, 23, 'PPL', 'P'),
(128354, 'North Scarborough', 43.6419410705566, 0.761695563642552, -70.3983306884766, -1.22868265842168, 218, 26, 'PPL', 'P'),
(151256, 'North Schodack', 42.5844383239746, 0.743238658865813, -73.5986099243164, -1.2845380680703, 218, 40, 'PPL', 'P'),
(125653, 'North Scituate', 42.2188911437988, 0.736858657000364, -70.7861099243164, -1.23545068285796, 218, 23, 'PPL', 'P'),
(169522, 'North Scituate', 41.8316688537598, 0.73010035310207, -71.5877838134766, -1.24944253175107, 218, 47, 'PPL', 'P'),
(165349, 'North Scottdale', 40.1094398498535, 0.700041786510564, -79.5663909912109, -1.38869549672579, 218, 45, 'PPL', 'P'),
(151257, 'North Scriba', 43.4886093139648, 0.759019419642159, -76.3852767944336, -1.33317458011009, 218, 40, 'PPL', 'P'),
(151258, 'North Sea', 40.9327812194824, 0.714411804278468, -72.4147186279297, -1.26387526696264, 218, 40, 'PPL', 'P'),
(96612, 'North Seadrift', 28.5075492858887, 0.497550596713316, -96.7777709960938, -1.68909074662291, 218, 51, 'PPL', 'P'),
(14323, 'North Seaford Heights', 38.6549987792969, 0.674657001053119, -75.6041717529297, -1.31954172533192, 218, 10, 'PPL', 'P'),
(128355, 'North Searsmont', 44.4088897705078, 0.77508134365059, -69.2169418334961, -1.20806353315591, 218, 26, 'PPL', 'P'),
(128356, 'North Searsport', 44.5538902282715, 0.777612079055465, -68.956672668457, -1.20352097928456, 218, 26, 'PPL', 'P'),
(128357, 'North Sebago', 43.8880615234375, 0.765991175901823, -70.6324996948242, -1.23276967858857, 218, 26, 'PPL', 'P'),
(128358, 'North Sedgwick', 44.3405609130859, 0.773888780114453, -68.5894393920898, -1.19711154948907, 218, 26, 'PPL', 'P'),
(125654, 'North Seekonk', 41.8891716003418, 0.731103965358867, -71.3305587768555, -1.24495310794347, 218, 23, 'PPL', 'P'),
(151259, 'North Settlement', 42.3402786254883, 0.73897726822655, -74.2905578613281, -1.29661483782353, 218, 40, 'PPL', 'P'),
(165350, 'North Sewickley', 40.8430595397949, 0.712845865557501, -80.2699966430664, -1.4009757319863, 218, 45, 'PPL', 'P'),
(96613, 'North Shadydale', 29.8447208404541, 0.520888643004493, -95.3108291625977, -1.66348778169316, 218, 51, 'PPL', 'P'),
(183705, 'North Shafter', 35.5113906860352, 0.619790689433361, -119.28360748291, -2.08189169423333, 218, 6, 'PPL', 'P'),
(128359, 'North Shapleigh', 43.6016693115234, 0.760992688851853, -70.8883285522461, -1.2372347344722, 218, 26, 'PPL', 'P'),
(151260, 'North Sheldon', 42.7700004577637, 0.746477329067458, -78.4188919067383, -1.36866785953812, 218, 40, 'PPL', 'P'),
(172341, 'North Sheldon', 44.9105606079102, 0.783837151524498, -72.9075012207031, -1.27247594570305, 218, 55, 'PPL', 'P'),
(172342, 'North Sherburne', 43.7102813720703, 0.762888326915772, -72.8277816772461, -1.27108457719154, 218, 55, 'PPL', 'P'),
(96614, 'North Sherman Junction', 33.6619415283203, 0.587511712283001, -96.5902786254883, -1.68581838743347, 218, 51, 'PPL', 'P'),
(183706, 'North Sherman Way', 34.2005615234375, 0.596912404614872, -118.448333740234, -2.06731341726818, 218, 6, 'PPL', 'P'),
(49893, 'North Sherwood Forest', 39.0927810668945, 0.682297743378611, -77.0149993896484, -1.34416531277079, 218, 25, 'PPL', 'P'),
(125655, 'North Shirley', 42.5847206115723, 0.743243585713829, -71.647216796875, -1.25047983299565, 218, 23, 'PPL', 'P'),
(17320, 'North Shore', 30.3841705322266, 0.530303816274791, -81.6569366455078, -1.42518240155653, 218, 12, 'PPL', 'P'),
(42328, 'North Shore', 30.2175006866455, 0.527394878705611, -89.8208312988281, -1.56766924304293, 218, 22, 'PPL', 'P'),
(49895, 'North Shore', 39.413890838623, 0.687902166155601, -77.3138885498047, -1.34938191271404, 218, 25, 'PPL', 'P'),
(67281, 'North Shore', 35.7277793884277, 0.62356738475423, -79.7925033569336, -1.39264190198712, 218, 33, 'PPL', 'P'),
(96615, 'North Shore', 30.0263900756836, 0.524059369308828, -95.2230606079102, -1.66195593143415, 218, 51, 'PPL', 'P'),
(104734, 'North Shore', 37.0819396972656, 0.647201940743275, -79.6586074829102, -1.39030497813058, 218, 53, 'PPL', 'P'),
(120825, 'North Shore', 42.2400016784668, 0.737227105337177, -88.3613891601563, -1.54219717248075, 218, 18, 'PPL', 'P'),
(137183, 'North Shore', 45.8027801513672, 0.799409320208464, -94.7377777099609, -1.65348614706131, 218, 28, 'PPL', 'P'),
(142550, 'North Shore', 42.440559387207, 0.74072749769495, -96.4413909912109, -1.68321980799983, 218, 35, 'PPL', 'P'),
(170957, 'North Shore', 44.9486083984375, 0.78450121074231, -97.2063903808594, -1.69657156612494, 218, 49, 'PPL', 'P'),
(175597, 'North Shore', 42.9111099243164, 0.748940153864536, -88.920280456543, -1.55195166576344, 218, 57, 'PPL', 'P'),
(183707, 'North Shore', 34.2680587768555, 0.598090453923069, -117.183326721191, -2.04523487972504, 218, 6, 'PPL', 'P'),
(96616, 'North Shore Acres', 30.4150009155273, 0.530841907973042, -97.9625015258789, -1.70976819511656, 218, 51, 'PPL', 'P'),
(42329, 'North Shore Beach', 30.2247200012207, 0.527520879514686, -89.8463897705078, -1.56811532252551, 218, 22, 'PPL', 'P'),
(156847, 'North Shore Cottage Area', 40.5330581665039, 0.707435320907869, -81.2808303833008, -1.41861810894364, 218, 41, 'PPL', 'P'),
(28077, 'North Shoreline', 37.610279083252, 0.656423202596701, -88.9208297729492, -1.55196125314337, 218, 18, 'PPL', 'P'),
(14312, 'North Shores', 38.6533317565918, 0.67462790601821, -75.5833282470703, -1.31917793752701, 218, 10, 'PPL', 'P'),
(23447, 'North Shores', 34.0550003051758, 0.594371882092991, -84.7183303833008, -1.47861380198095, 218, 13, 'PPL', 'P'),
(177355, 'North Shores', 41.8363914489746, 0.730182777937808, -83.4075012207031, -1.45573551716246, 218, 27, 'PPL', 'P'),
(14313, 'North Shores Addition', 38.6580581665039, 0.674710397432975, -75.5774993896484, -1.31907620477337, 218, 10, 'PPL', 'P'),
(42330, 'North Shreveport', 32.5433311462402, 0.567988278068712, -93.8000030517578, -1.6371188916339, 218, 22, 'PPL', 'P'),
(172343, 'North Shrewsbury', 43.5288887023926, 0.759722427590913, -72.8274993896484, -1.27107965034353, 218, 55, 'PPL', 'P'),
(42331, 'North Side', 30.1591701507568, 0.526376818799901, -89.5999984741211, -1.56381498315531, 218, 22, 'PPL', 'P'),
(67279, 'North Side', 36.084171295166, 0.629787596954274, -78.746940612793, -1.37439338956568, 218, 33, 'PPL', 'P'),
(156848, 'North Side', 41.1180610656738, 0.717645547632097, -80.6469421386719, -1.40755467198518, 218, 41, 'PPL', 'P'),
(82646, 'North Side Heights', 34.8861083984375, 0.60887745476038, -82.3597183227539, -1.43744825574716, 218, 48, 'PPL', 'P'),
(137185, 'North Side Mobile Home Park', 45.1505584716797, 0.78802590444503, -94.6827774047852, -1.65252621064639, 218, 28, 'PPL', 'P'),
(128360, 'North Sidney', 44.4669418334961, 0.776094543287311, -69.6919403076172, -1.21635382047127, 218, 26, 'PPL', 'P'),
(170958, 'North Sioux City', 42.5272216796875, 0.74224004003606, -96.482780456543, -1.68394219044551, 218, 49, 'PPL', 'P'),
(165355, 'North Skyline View', 40.3433303833008, 0.704123946408465, -76.7241668701172, -1.3390893277331, 218, 45, 'PPL', 'P'),
(42332, 'North Slidell', 30.3044395446777, 0.528912248026198, -89.7780609130859, -1.56692275898938, 218, 22, 'PPL', 'P'),
(169523, 'North Smithfield', 41.9666709899902, 0.732456584876518, -71.5500030517578, -1.24878313306516, 218, 47, 'PPL', 'P'),
(76749, 'North Sobol', 34.1858291625977, 0.596655276411625, -95.2383270263672, -1.66222238070121, 218, 42, 'PPL', 'P'),
(89477, 'North Soddy', 35.2836112976074, 0.615815189137118, -85.1294403076172, -1.48578902374789, 218, 50, 'PPL', 'P'),
(156849, 'North Solon', 41.4241714477539, 0.722988181673932, -81.4805603027344, -1.4221040536525, 218, 41, 'PPL', 'P'),
(113834, 'North Somers', 42.0161094665527, 0.733319449069703, -72.4486083984375, -1.26446675504075, 218, 8, 'PPL', 'P'),
(195395, 'North South Ski Bowl', 47.1166687011719, 0.822341001406809, -116.658889770508, -2.03608172821649, 218, 17, 'PPL', 'P'),
(202438, 'North Spearfish', 44.5066719055176, 0.77678796385614, -103.891670227051, -1.8132517108582, 218, 49, 'PPL', 'P'),
(125656, 'North Spencer', 42.3063888549805, 0.738385780148443, -71.9861068725586, -1.25639458061867, 218, 23, 'PPL', 'P'),
(151262, 'North Spencer', 42.2558288574219, 0.737503341721245, -76.5077819824219, -1.33531269899126, 218, 40, 'PPL', 'P'),
(110688, 'North Spring', 37.5680618286133, 0.655686372502103, -81.8255615234375, -1.42812546087717, 218, 58, 'PPL', 'P'),
(49896, 'North Springbrook', 39.0688896179199, 0.681880758930932, -77.0116729736328, -1.34410725585902, 218, 25, 'PPL', 'P'),
(104735, 'North Springfield', 38.8041687011719, 0.677260507334781, -77.2050018310547, -1.34748148096016, 218, 53, 'PPL', 'P'),
(156850, 'North Springfield', 41.0411109924316, 0.71630251549437, -81.4349975585938, -1.421308833751, 218, 41, 'PPL', 'P'),
(165356, 'North Springfield', 41.9944381713867, 0.732941213615885, -80.4252777099609, -1.40368589786962, 218, 45, 'PPL', 'P'),
(172344, 'North Springfield', 43.3327789306641, 0.756299666378916, -72.5258331298828, -1.26581458086844, 218, 55, 'PPL', 'P'),
(201319, 'North Springfield', 44.0750007629395, 0.769253881132306, -123.001937866211, -2.14678880209887, 218, 43, 'PPL', 'P'),
(67280, 'North Springhaven', 35.3713912963867, 0.617347239133214, -80.1661071777344, -1.39916251875812, 218, 33, 'PPL', 'P'),
(82647, 'North Springs', 34.1347198486328, 0.595763250604503, -80.8874969482422, -1.41175314544369, 218, 48, 'PPL', 'P'),
(89476, 'North Springs', 36.4669418334961, 0.636468203127765, -85.7552795410156, -1.49671197895885, 218, 50, 'PPL', 'P'),
(113835, 'North Stamford', 41.1380615234375, 0.717994621471979, -73.5438919067383, -1.28358305850339, 218, 8, 'PPL', 'P'),
(104736, 'North Stanton', 36.9661102294922, 0.645180335159795, -79.0830612182617, -1.38025980081491, 218, 53, 'PPL', 'P'),
(208279, 'North Stanwood', 48.2588882446289, 0.842276493220761, -122.34139251709, -2.13526011089797, 218, 56, 'PPL', 'P'),
(14314, 'North Star', 39.7611083984375, 0.693962255795104, -75.7194366455078, -1.32155347721936, 218, 10, 'PPL', 'P'),
(132329, 'North Star', 43.2483291625977, 0.754825739873611, -84.543327331543, -1.47555942252674, 218, 27, 'PPL', 'P'),
(137186, 'North Star', 44.2905616760254, 0.773016128804261, -94.0791702270508, -1.64199127800626, 218, 28, 'PPL', 'P'),
(142548, 'North Star', 41.3733291625977, 0.722100816398717, -98.1344375610352, -1.71276904503286, 218, 35, 'PPL', 'P'),
(156851, 'North Star', 40.3247184753418, 0.703799107334502, -84.570556640625, -1.47603466362326, 218, 41, 'PPL', 'P'),
(175598, 'North Star', 44.6175003051758, 0.778722284334892, -89.4225006103516, -1.56071706101727, 218, 57, 'PPL', 'P'),
(183709, 'North Star', 39.586669921875, 0.690917730036925, -121.075828552246, -2.11317185281685, 218, 6, 'PPL', 'P'),
(14315, 'North Star Addition', 39.7583312988281, 0.693913786263264, -75.7138900756836, -1.32145667131374, 218, 10, 'PPL', 'P'),
(183708, 'North Star Ranch', 34.4341697692871, 0.600989637664756, -117.358329772949, -2.04828925917925, 218, 6, 'PPL', 'P'),
(145927, 'North Stelton', 40.5369415283203, 0.707503098357612, -74.42138671875, -1.29889823214217, 218, 37, 'PPL', 'P'),
(151263, 'North Stephentown', 42.5969390869141, 0.743456838338117, -73.370002746582, -1.28054812012514, 218, 40, 'PPL', 'P'),
(151264, 'North Sterling', 43.3697204589844, 0.756944417678824, -76.6236114501953, -1.33733430457474, 218, 40, 'PPL', 'P'),
(151265, 'North Stockholm', 44.7694396972656, 0.781374126990339, -74.9349975585938, -1.30786243237137, 218, 40, 'PPL', 'P'),
(113836, 'North Stonington', 41.4408302307129, 0.723278932285941, -71.8816680908203, -1.25457178001056, 218, 8, 'PPL', 'P'),
(125657, 'North Stoughton', 42.1513900756836, 0.735680541113141, -71.0749969482422, -1.24049271259175, 218, 23, 'PPL', 'P'),
(144247, 'North Stratford', 44.7516708374023, 0.781064001881399, -71.6291732788086, -1.25016491419675, 218, 36, 'PPL', 'P'),
(117062, 'North Street Mobile Home Park', 42.4819412231445, 0.741449746982579, -92.0569381713867, -1.60669667039555, 218, 16, 'PPL', 'P'),
(10853, 'North Stuttgart', 34.5138893127441, 0.602381006176268, -91.5374984741211, -1.5976307374127, 218, 4, 'PPL', 'P'),
(125658, 'North Sudbury', 42.4091682434082, 0.740179618879693, -71.4049987792969, -1.24625233108126, 218, 23, 'PPL', 'P'),
(165358, 'North Sulger', 41.1733283996582, 0.718610144578923, -78.954719543457, -1.37801981602204, 218, 45, 'PPL', 'P'),
(128361, 'North Sullivan', 44.5405616760254, 0.777379451934247, -68.2436065673828, -1.19107562803646, 218, 26, 'PPL', 'P'),
(208280, 'North Sultan', 47.8819389343262, 0.835697486642857, -121.80583190918, -2.12591281494596, 218, 56, 'PPL', 'P'),
(125659, 'North Sunderland', 42.5041694641113, 0.741837702974376, -72.5583267211914, -1.26638170102257, 218, 23, 'PPL', 'P'),
(144248, 'North Sutton', 43.3638916015625, 0.756842684925183, -71.9400024414063, -1.2555899064953, 218, 36, 'PPL', 'P'),
(125660, 'North Swansea', 41.7680587768555, 0.728990147822643, -71.2638931274414, -1.24378957286321, 218, 23, 'PPL', 'P'),
(144249, 'North Swanzey', 42.9111099243164, 0.748940153864536, -72.2708282470703, -1.2613639060547, 218, 36, 'PPL', 'P'),
(151266, 'North Syracuse', 43.1347198486328, 0.752842883283993, -76.1302795410156, -1.3287240384544, 218, 40, 'PPL', 'P'),
(49898, 'North Takoma Park', 38.9891700744629, 0.68048939041942, -77.0155563354492, -1.34417503330877, 218, 25, 'PPL', 'P'),
(17321, 'North Tampa Heights', 28.0658302307129, 0.4898411448317, -82.4602813720703, -1.43920341206357, 218, 12, 'PPL', 'P'),
(104737, 'North Tazewell', 37.1327781677246, 0.648089239439462, -81.5272216796875, -1.42291844831385, 218, 53, 'PPL', 'P'),
(30686, 'North Terre Haute', 39.5277786254883, 0.689889883014209, -87.3602828979492, -1.52472457204291, 218, 19, 'PPL', 'P'),
(125661, 'North Tewksbury', 42.6344413757324, 0.744111376755032, -71.2463912963867, -1.24348410828618, 218, 23, 'PPL', 'P'),
(172345, 'North Thetford', 43.8430595397949, 0.765205743117331, -72.1861114501953, -1.25988531901749, 218, 55, 'PPL', 'P'),
(113838, 'North Thompsonville', 42.0161094665527, 0.733319449069703, -72.5927810668945, -1.26698304279671, 218, 8, 'PPL', 'P'),
(151267, 'North Thurston', 42.2675018310547, 0.737707073544636, -77.2808303833008, -1.34880493886387, 218, 40, 'PPL', 'P'),
(125662, 'North Tisbury', 41.4055595397949, 0.722663342599969, -70.6750030517578, -1.23351150211021, 218, 23, 'PPL', 'P'),
(169525, 'North Tiverton', 41.6647186279297, 0.727186521974387, -71.1919403076172, -1.24253375925118, 218, 47, 'PPL', 'P'),
(175599, 'North Tomah', 44.0116691589355, 0.768148536121869, -90.5149993896484, -1.57978476179002, 218, 57, 'PPL', 'P'),
(151268, 'North Tonawanda', 43.0386085510254, 0.751165424692379, -78.8644409179688, -1.37644415676309, 218, 40, 'PPL', 'P'),
(33449, 'North Topeka', 39.0722198486328, 0.681938882421723, -95.6666717529297, -1.66969840651328, 218, 20, 'PPL', 'P'),
(67282, 'North Topsail Beach', 34.4900016784668, 0.601964088307616, -77.4319381713867, -1.35144226729138, 218, 33, 'PPL', 'P'),
(165359, 'North Towanda', 41.7877807617188, 0.729334361393536, -76.4541702270508, -1.33437699734226, 218, 45, 'PPL', 'P'),
(49899, 'North Town Creek Manor', 38.3022193908691, 0.668499839191883, -76.5041732788086, -1.33524971523148, 218, 25, 'PPL', 'P'),
(128362, 'North Trescott', 44.8594398498535, 0.782944925980295, -67.1322174072266, -1.17167822792075, 218, 26, 'PPL', 'P'),
(172346, 'North Troy', 44.9944381713867, 0.785301091175715, -72.4002838134766, -1.26362333192352, 218, 55, 'PPL', 'P'),
(125663, 'North Truro', 42.0333290100098, 0.733619986798719, -70.095832824707, -1.22340307471866, 218, 23, 'PPL', 'P'),
(172347, 'North Tunbridge', 43.9147186279297, 0.76645643014426, -72.478889465332, -1.26499525935908, 218, 55, 'PPL', 'P'),
(61099, 'North Tunica', 34.7008285522461, 0.605643711406751, -90.378059387207, -1.57739470786973, 218, 30, 'PPL', 'P'),
(128363, 'North Turner', 44.3430595397949, 0.773932389377303, -70.2569427490234, -1.22621497335562, 218, 26, 'PPL', 'P'),
(201320, 'North Umpqua Village', 43.3027801513672, 0.755776088908606, -122.949996948242, -2.14588226206381, 218, 43, 'PPL', 'P'),
(172348, 'North Underhill', 44.5852813720703, 0.778159957870722, -72.9327774047852, -1.27291709833763, 218, 55, 'PPL', 'P'),
(30687, 'North Union', 39.9655609130859, 0.697530625339701, -86.9033279418945, -1.51674920352645, 218, 19, 'PPL', 'P'),
(128364, 'North Union', 44.2769393920898, 0.772778375097944, -69.3099975585938, -1.20968766194669, 218, 26, 'PPL', 'P'),
(61113, 'North Union (historical)', 33.2013893127441, 0.579473559743843, -89.6958312988281, -1.56548758147793, 218, 30, 'PPL', 'P'),
(73721, 'North Uniontown', 39.0888900756836, 0.682229832770814, -83.4897232055664, -1.45717056151585, 218, 41, 'PPL', 'P'),
(151270, 'North Urbana', 42.4127807617188, 0.740242669218501, -77.1672210693359, -1.34682208227425, 218, 40, 'PPL', 'P'),
(96618, 'North Uvalde Colonia', 29.2390003204346, 0.51031682558326, -99.802001953125, -1.74187353416384, 218, 51, 'PPL', 'P'),
(125664, 'North Uxbridge', 42.0875015258789, 0.734565475564724, -71.6416702270508, -1.25038302709003, 218, 23, 'PPL', 'P'),
(42333, 'North Vacherie', 29.9966697692871, 0.523540652107508, -90.7055587768555, -1.58311065051737, 218, 22, 'PPL', 'P'),
(23449, 'North Valley', 34.149169921875, 0.596015451959733, -84.3013916015625, -1.47133684746036, 218, 13, 'PPL', 'P'),
(189126, 'North Valley', 35.1733283996582, 0.613890389459264, -106.622779846191, -1.86091856594509, 218, 38, 'PPL', 'P'),
(140613, 'North Valley City', 46.9461097717285, 0.819364186519346, -97.9963912963867, -1.71035968319466, 218, 34, 'PPL', 'P'),
(151271, 'North Valley Stream', 40.685001373291, 0.710087230142343, -73.7022171020508, -1.28634635445046, 218, 40, 'PPL', 'P'),
(165362, 'North Vandergrift', 40.6072196960449, 0.708729683776675, -79.5597229003906, -1.38857911658615, 218, 45, 'PPL', 'P'),
(128365, 'North Vassalboro', 44.4861106872559, 0.776429102899252, -69.6230621337891, -1.21515166955521, 218, 26, 'PPL', 'P'),
(28078, 'North Venice', 38.6808280944824, 0.675107807646643, -90.166389465332, -1.57370037080557, 218, 18, 'PPL', 'P'),
(30688, 'North Vernon', 39.0061111450195, 0.680785067879446, -85.6236114501953, -1.49441393725422, 218, 19, 'PPL', 'P'),
(172349, 'North Vernon', 42.7822189331055, 0.746690581691746, -72.524169921875, -1.26578555241256, 218, 55, 'PPL', 'P'),
(165363, 'North Versailles', 40.3797187805176, 0.704759043749421, -79.8097229003906, -1.39294243971613, 218, 45, 'PPL', 'P'),
(151272, 'North Victory', 43.2561111450195, 0.754961561089205, -76.6430587768555, -1.33767372445567, 218, 40, 'PPL', 'P'),
(67283, 'North View', 34.791389465332, 0.607224297513714, -79.4580612182617, -1.38680478550988, 218, 33, 'PPL', 'P'),
(104738, 'North View', 36.7805595397949, 0.641941864695232, -78.2444381713867, -1.36562306746383, 218, 53, 'PPL', 'P'),
(110690, 'North View', 39.295280456543, 0.685832024461255, -80.3511123657227, -1.40239146842179, 218, 58, 'PPL', 'P'),
(192726, 'North View', 37.6575012207031, 0.657247384375053, -112.833610534668, -1.96931801074292, 218, 52, 'PPL', 'P'),
(165365, 'North View Hills', 40.000560760498, 0.698141487914738, -76.7013931274414, -1.3386918509404, 218, 45, 'PPL', 'P'),
(76750, 'North Village', 35.9855613708496, 0.62806652909981, -96.6516723632813, -1.68688991029807, 218, 42, 'PPL', 'P'),
(125667, 'North Village', 42.4694404602051, 0.741231567510274, -71.6750030517578, -1.25096479463016, 218, 23, 'PPL', 'P'),
(144250, 'North Village', 42.8988914489746, 0.748726901240248, -71.9394378662109, -1.25558005279926, 218, 36, 'PPL', 'P'),
(71182, 'North Vineland', 39.5261116027832, 0.6898607879793, -75.0227813720703, -1.3093945489465, 218, 37, 'PPL', 'P'),
(4629, 'North Vinemont', 34.2791709899902, 0.598284398629454, -86.8555603027344, -1.5159155009472, 218, 2, 'PPL', 'P'),
(104739, 'North Virginia Beach', 36.9038887023926, 0.644094364646288, -75.9927825927734, -1.32632426399613, 218, 53, 'PPL', 'P'),
(151281, 'North Volney', 43.413330078125, 0.757705549118368, -76.3272171020508, -1.33216124731531, 218, 40, 'PPL', 'P'),
(128366, 'North Wade', 46.829719543457, 0.817332793818861, -68.1800003051758, -1.18996548933606, 218, 26, 'PPL', 'P'),
(144251, 'North Wakefield', 43.6361083984375, 0.761593764309884, -71.0552825927734, -1.24014863217891, 218, 36, 'PPL', 'P'),
(172350, 'North Walden', 44.5050010681152, 0.776758802242204, -72.2636108398438, -1.26123793853514, 218, 55, 'PPL', 'P'),
(128367, 'North Waldoboro', 44.1841697692871, 0.771159239734203, -69.3758316040039, -1.21083668279901, 218, 26, 'PPL', 'P'),
(165366, 'North Wales', 40.2108306884766, 0.701811390475894, -75.2786102294922, -1.31385960483012, 218, 45, 'PPL', 'P'),
(197164, 'North Walkerville (historical)', 46.0333290100098, 0.803433156878492, -112.533332824707, -1.96407717603375, 218, 31, 'PPL', 'P'),
(144252, 'North Walpole', 43.1388893127441, 0.752915654160779, -72.4486083984375, -1.26446675504075, 218, 36, 'PPL', 'P'),
(4630, 'North Walter', 34.1313896179199, 0.595705127113712, -86.6819381713867, -1.51288522310085, 218, 2, 'PPL', 'P'),
(151273, 'North Wantagh', 40.6933288574219, 0.710232572158834, -73.508056640625, -1.28295761512139, 218, 40, 'PPL', 'P'),
(56583, 'North Wardell', 36.3586082458496, 0.634577425332836, -89.8144378662109, -1.56755765659325, 218, 29, 'PPL', 'P'),
(165368, 'North Warren', 41.8741683959961, 0.730842110044685, -79.1524963378906, -1.38147167226895, 218, 45, 'PPL', 'P'),
(117063, 'North Washington', 43.1180610656738, 0.752552132671983, -92.4166717529297, -1.61297520582346, 218, 16, 'PPL', 'P'),
(165370, 'North Washington', 40.5327796936035, 0.70743046063888, -79.5980606079102, -1.38924823581003, 218, 45, 'PPL', 'P'),
(187118, 'North Washington', 39.8072204589844, 0.694767063076526, -104.978332519531, -1.83221754571925, 218, 7, 'PPL', 'P'),
(82650, 'North Washington Park', 34.1180610656738, 0.595472499992494, -80.9563903808594, -1.41295556267586, 218, 48, 'PPL', 'P'),
(165371, 'North Water Gap', 41.0044403076172, 0.715662491305396, -75.1366729736328, -1.31138233238413, 218, 45, 'PPL', 'P'),
(128369, 'North Waterboro', 43.6202812194824, 0.761317527925816, -70.7358322143555, -1.23457317127877, 218, 26, 'PPL', 'P'),
(128370, 'North Waterford', 44.2316703796387, 0.771988281781545, -70.769172668457, -1.23515507197696, 218, 26, 'PPL', 'P'),
(151274, 'North Waverly', 42.021671295166, 0.733416521291437, -76.5238876342773, -1.33559379564431, 218, 40, 'PPL', 'P'),
(183710, 'North Wawona', 37.547779083252, 0.655332371814205, -119.643608093262, -2.08817489019315, 218, 6, 'PPL', 'P'),
(183711, 'North Wawona (historical)', 37.5486106872559, 0.655346886042146, -119.639999389648, -2.08811190643337, 218, 6, 'PPL', 'P'),
(128371, 'North Wayne', 44.3741683959961, 0.774475341344543, -70.033332824707, -1.22231224393616, 218, 26, 'PPL', 'P'),
(144253, 'North Weare', 43.1144409179688, 0.752488949175121, -71.7383270263672, -1.25207000648254, 218, 36, 'PPL', 'P'),
(123328, 'North Webster', 41.3255615234375, 0.721267113819468, -85.6977767944336, -1.49570836670206, 218, 19, 'PPL', 'P'),
(151275, 'North Weedsport', 43.0588912963867, 0.751519425380278, -76.559440612793, -1.3362143121783, 218, 40, 'PPL', 'P'),
(104740, 'North Weems', 37.6611099243164, 0.657310368134834, -76.4402770996094, -1.33413451652501, 218, 53, 'PPL', 'P'),
(165372, 'North Weissport', 40.8358306884766, 0.712719698300859, -75.6986083984375, -1.32118995573057, 218, 45, 'PPL', 'P'),
(49900, 'North Welham', 39.185001373291, 0.683907291362428, -76.6269378662109, -1.3373923614865, 218, 25, 'PPL', 'P'),
(104741, 'North Wellville', 37.1502799987793, 0.648394704016494, -77.9172210693359, -1.35991205166421, 218, 53, 'PPL', 'P'),
(117064, 'North Welton', 41.9136085510254, 0.731530470607443, -90.6044387817383, -1.58134577366297, 218, 16, 'PPL', 'P'),
(197165, 'North West Mobile Home Park', 46.3166694641113, 0.80837838070666, -114.152778625488, -1.99234183731498, 218, 31, 'PPL', 'P'),
(23450, 'North West Point', 32.9030609130859, 0.574266746917601, -85.1600036621094, -1.48632245491424, 218, 13, 'PPL', 'P'),
(113839, 'North Westchester', 41.5808296203613, 0.725722382586089, -72.4016723632813, -1.26364756668944, 218, 8, 'PPL', 'P'),
(151276, 'North Western', 43.3422203063965, 0.756464449471364, -75.3638916015625, -1.31534804556337, 218, 40, 'PPL', 'P'),
(172351, 'North Westminster', 43.1188888549805, 0.752566580320897, -72.4555587768555, -1.2645880620284, 218, 55, 'PPL', 'P'),
(125668, 'North Westport', 41.6602783203125, 0.727109023986666, -71.0888900756836, -1.240735193409, 218, 23, 'PPL', 'P'),
(125669, 'North Weymouth', 42.2458305358887, 0.737328838090818, -70.9472198486328, -1.23826258149492, 218, 23, 'PPL', 'P'),
(132331, 'North Wheeler', 43.4661102294922, 0.758626736539427, -84.4286117553711, -1.47355725801921, 218, 27, 'PPL', 'P'),
(151277, 'North White Plains', 41.0550003051758, 0.716544929732594, -73.767219543457, -1.28748086107483, 218, 40, 'PPL', 'P'),
(128372, 'North Whitefield', 44.2219390869141, 0.771818438683025, -69.5877838134766, -1.21453594671118, 218, 26, 'PPL', 'P'),
(125670, 'North Wilbraham', 42.1527786254883, 0.73570477587906, -72.4252777099609, -1.26405955771008, 218, 23, 'PPL', 'P'),
(71183, 'North Wildwood', 39.000560760498, 0.680688195394795, -74.7997207641602, -1.30550140690696, 218, 37, 'PPL', 'P'),
(67285, 'North Wilkesboro', 36.1583290100098, 0.631081893244052, -81.1477813720703, -1.41629596563115, 218, 33, 'PPL', 'P'),
(132332, 'North Williams', 43.639720916748, 0.761656814648692, -84.0888900756836, -1.46762799616826, 218, 27, 'PPL', 'P'),
(172352, 'North Williston', 44.4669418334961, 0.776094543287311, -73.0466690063477, -1.27490488177526, 218, 55, 'PPL', 'P'),
(125671, 'North Wilmington', 42.5694389343262, 0.742976870130658, -71.1569366455078, -1.24192283009712, 218, 23, 'PPL', 'P'),
(144254, 'North Wilmot', 43.4963912963867, 0.759155240857753, -71.934440612793, -1.25549283427356, 218, 36, 'PPL', 'P'),
(151278, 'North Wilmurt', 43.4497184753418, 0.758340646459325, -75.0169372558594, -1.30929254987675, 218, 40, 'PPL', 'P'),
(151279, 'North Wilna', 44.0955581665039, 0.769612675510167, -75.5972213745117, -1.31942041834426, 218, 40, 'PPL', 'P'),
(113840, 'North Wilton', 41.2122192382813, 0.719288917761757, -73.466667175293, -1.2822352326757, 218, 8, 'PPL', 'P'),
(28079, 'North Wind', 39.9269409179688, 0.696856579267802, -89.6711120605469, -1.56505614938134, 218, 18, 'PPL', 'P'),
(49901, 'North Wind', 39.4088897705078, 0.687814881050874, -76.5108337402344, -1.33536596221306, 218, 25, 'PPL', 'P'),
(49902, 'North Wind Farms', 39.4055595397949, 0.687756757560083, -76.5055618286133, -1.3352739499974, 218, 25, 'PPL', 'P'),
(113841, 'North Windham', 41.749439239502, 0.728665175590626, -72.1549987792969, -1.25934230047122, 218, 8, 'PPL', 'P'),
(128373, 'North Windham', 43.834171295166, 0.765050613983834, -70.4388885498047, -1.22939052663943, 218, 26, 'PPL', 'P'),
(172353, 'North Windham', 43.2174987792969, 0.754287648175361, -72.7402801513672, -1.26955738746444, 218, 55, 'PPL', 'P'),
(128374, 'North Windsor', 44.348331451416, 0.774024401592965, -69.5813903808594, -1.21442436026151, 218, 26, 'PPL', 'P'),
(151280, 'North Winfield', 42.9319381713867, 0.749303675353332, -75.1883316040039, -1.31228394557118, 218, 40, 'PPL', 'P'),
(67287, 'North Winston', 36.1197204589844, 0.630408046909235, -80.2341690063477, -1.40035042176235, 218, 33, 'PPL', 'P'),
(128375, 'North Winterport', 44.6775016784668, 0.779769505854539, -68.8491668701172, -1.20164464913854, 218, 26, 'PPL', 'P'),
(125672, 'North Woburn', 42.5083312988281, 0.741910340693108, -71.158332824707, -1.24194719802109, 218, 23, 'PPL', 'P'),
(151286, 'North Wolcott', 43.2841682434082, 0.755451249834644, -76.7822189331055, -1.34010252736982, 218, 40, 'PPL', 'P'),
(172354, 'North Wolcott', 44.6111106872559, 0.778610764464245, -72.4608306884766, -1.26468007424407, 218, 55, 'PPL', 'P'),
(144255, 'North Wolfeboro', 43.6536102294922, 0.761899228886916, -71.1347198486328, -1.2415350738424, 218, 36, 'PPL', 'P'),
(71185, 'North Woodbury', 39.8541717529297, 0.695586517743943, -75.1363906860352, -1.31137740553611, 218, 37, 'PPL', 'P'),
(113842, 'North Woodbury', 41.5502815246582, 0.725189217735855, -73.2058334350586, -1.27768282510832, 218, 8, 'PPL', 'P'),
(156875, 'North Woodbury', 40.5938911437988, 0.708497056655456, -82.6624984741211, -1.4427327662982, 218, 41, 'PPL', 'P'),
(151282, 'North Woodmere', 40.6500015258789, 0.709476367567306, -73.7244415283203, -1.28673424386323, 218, 40, 'PPL', 'P'),
(49903, 'North Woodridge', 38.9449996948242, 0.679718471862869, -76.9736099243164, -1.3434429303251, 218, 25, 'PPL', 'P'),
(125673, 'North Woods', 42.3916702270508, 0.739874220881688, -71.8772201538086, -1.25449414886478, 218, 23, 'PPL', 'P'),
(113843, 'North Woodstock', 41.9902801513672, 0.73286864247618, -71.9974975585938, -1.25659338559404, 218, 8, 'PPL', 'P'),
(128376, 'North Woodstock', 44.4088897705078, 0.77508134365059, -70.6383285522461, -1.23287141134221, 218, 26, 'PPL', 'P'),
(144256, 'North Woodstock', 44.0302810668945, 0.768473375195831, -71.686393737793, -1.25116359960553, 218, 36, 'PPL', 'P'),
(125674, 'North Worcester', 42.3166694641113, 0.738565210626887, -71.8180618286133, -1.25346164131016, 218, 23, 'PPL', 'P'),
(208285, 'North Yelm', 46.9633293151855, 0.819664724248362, -122.601669311523, -2.13980279792737, 218, 56, 'PPL', 'P'),
(78854, 'North York', 39.9780616760254, 0.697748804812006, -76.7333297729492, -1.33924925055656, 218, 45, 'PPL', 'P'),
(175600, 'North York', 46.3927803039551, 0.809706765458392, -90.7774963378906, -1.58436619781329, 218, 57, 'PPL', 'P'),
(73722, 'North Zanesville', 39.9786109924316, 0.69775839219193, -82.0036087036133, -1.43123297039513, 218, 41, 'PPL', 'P'),
(96626, 'North Zulch', 30.9174995422363, 0.539612163495864, -96.1080627441406, -1.67740213259855, 218, 51, 'PPL', 'P'),
(183712, 'Northam (historical)', 33.8800010681152, 0.591317569217806, -117.997222900391, -2.05944004782147, 218, 6, 'PPL', 'P'),
(190556, 'Northam (historical)', 39.4947204589844, 0.689312909164043, -119.009719848633, -2.07711145323469, 218, 39, 'PPL', 'P'),
(49905, 'Northampton', 39.642219543457, 0.691887253831769, -76.4505615234375, -1.33431401358248, 218, 25, 'PPL', 'P'),
(104745, 'Northampton', 37.0449981689453, 0.646557189443366, -76.4241714477539, -1.33385341987195, 218, 53, 'PPL', 'P'),
(125675, 'Northampton', 42.3250007629395, 0.738710619222405, -72.6416702270508, -1.26783631960997, 218, 23, 'PPL', 'P'),
(151283, 'Northampton', 40.8886108398438, 0.713640885721917, -72.6900024414063, -1.26867987588526, 218, 40, 'PPL', 'P'),
(165374, 'Northampton', 40.6861114501953, 0.710106604639273, -75.4972229003906, -1.31767511572388, 218, 45, 'PPL', 'P'),
(156853, 'Northampton Center', 41.166389465332, 0.718489037328352, -81.5369415283203, -1.42308809167529, 218, 41, 'PPL', 'P'),
(165376, 'Northampton Heights', 40.6122207641602, 0.708816968881402, -75.3461074829102, -1.31503765413832, 218, 45, 'PPL', 'P'),
(89479, 'Northaven', 35.2666702270508, 0.615519511677092, -90.0483322143555, -1.57163988307018, 218, 50, 'PPL', 'P'),
(49906, 'Northaven Mobile Home Park', 39.6916694641113, 0.692750317762036, -77.7238922119141, -1.35653782656308, 218, 25, 'PPL', 'P'),
(117081, 'Northboro', 40.607780456543, 0.708739470893681, -95.291389465332, -1.66314849497028, 218, 16, 'PPL', 'P'),
(125677, 'Northborough', 42.3194389343262, 0.738613547000672, -71.6416702270508, -1.25038302709003, 218, 23, 'PPL', 'P'),
(33451, 'Northbranch', 39.9727783203125, 0.697656592859262, -98.3713912963867, -1.71690466788964, 218, 20, 'PPL', 'P'),
(125679, 'Northbridge', 42.1513900756836, 0.735680541113141, -71.6500015258789, -1.25052843568555, 218, 23, 'PPL', 'P'),
(125680, 'Northbridge Center', 42.1347198486328, 0.735389590764049, -71.6730575561523, -1.25093083932626, 218, 23, 'PPL', 'P'),
(49907, 'Northbrook', 39.6069412231445, 0.691271530987742, -76.8763885498047, -1.34174609723656, 218, 25, 'PPL', 'P'),
(73723, 'Northbrook', 39.2463912963867, 0.684978747647994, -84.583610534668, -1.47626249705452, 218, 41, 'PPL', 'P'),
(78857, 'Northbrook', 39.920280456543, 0.69674033228622, -75.6891708374023, -1.32102523921714, 218, 45, 'PPL', 'P'),
(89480, 'Northbrook', 36.0486106872559, 0.629166947262231, -83.9816665649414, -1.46575659287026, 218, 50, 'PPL', 'P'),
(120826, 'Northbrook', 42.127498626709, 0.735263556665461, -87.8288879394531, -1.5329032729086, 218, 18, 'PPL', 'P'),
(49908, 'Northbrook Estates', 39.0283317565918, 0.681172890713189, -77.0408325195313, -1.34461618594334, 218, 25, 'PPL', 'P'),
(82652, 'Northbrook Park', 35.0194396972656, 0.611204524920891, -81.9541702270508, -1.43037010620194, 218, 48, 'PPL', 'P'),
(104744, 'Northbury', 37.6152801513672, 0.656510487701428, -77.1836090087891, -1.34710810577533, 218, 53, 'PPL', 'P'),
(30689, 'Northcliff', 39.2894401550293, 0.685730091970533, -85.8775024414063, -1.49884517099201, 218, 19, 'PPL', 'P'),
(96619, 'Northcliff', 29.6208305358887, 0.516981020026534, -98.2244415283203, -1.71433991060184, 218, 51, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(23451, 'Northcliff Colony', 34.3375015258789, 0.599302458535164, -83.8447189331055, -1.46336640579192, 218, 13, 'PPL', 'P'),
(137208, 'Northcote', 48.8452796936035, 0.852510954710908, -97.0008316040039, -1.69298388866244, 218, 28, 'PPL', 'P'),
(89481, 'Northcott', 36.5727806091309, 0.638315438238871, -82.5341720581055, -1.44049304782145, 218, 50, 'PPL', 'P'),
(14316, 'Northcrest', 39.8305587768555, 0.695174393565253, -75.4961090087891, -1.31765567464792, 218, 10, 'PPL', 'P'),
(96620, 'Northcrest', 31.6363906860352, 0.552159180918581, -97.0994415283203, -1.6947049565169, 218, 51, 'PPL', 'P'),
(123331, 'Northcrest', 41.1230583190918, 0.717732766157797, -85.1350021362305, -1.48588609596963, 218, 19, 'PPL', 'P'),
(56585, 'Northcut', 38.122501373291, 0.665363168059988, -90.9661102294922, -1.58765813123673, 218, 29, 'PPL', 'P'),
(23452, 'Northcutt', 34.730281829834, 0.606157768076164, -84.4305572509766, -1.47359121332311, 218, 13, 'PPL', 'P'),
(37456, 'Northcutt', 38.7272186279297, 0.675917475197054, -84.5566711425781, -1.47579231596406, 218, 21, 'PPL', 'P'),
(89483, 'Northcutts Cove', 35.5044403076172, 0.619669382445708, -85.7533264160156, -1.4966778904969, 218, 50, 'PPL', 'P'),
(137190, 'Northdale', 45.1786117553711, 0.788515526611441, -93.2799987792969, -1.62804310495502, 218, 28, 'PPL', 'P'),
(187119, 'Northdale', 37.809440612793, 0.6598992270305, -109.01611328125, -1.90269011448493, 218, 7, 'PPL', 'P'),
(151285, 'Northeast', 41.9166717529297, 0.731583933566326, -73.5666732788086, -1.28398066845414, 218, 40, 'PPL', 'P'),
(197166, 'Northeast Annexation Trailer Court', 45.7019386291504, 0.797649303623058, -111.025001525879, -1.93775182865832, 218, 31, 'PPL', 'P'),
(13176, 'Northeast Boundary', 38.8925018310547, 0.678802211289828, -76.9166717529297, -1.34244917176434, 218, 9, 'PPL', 'P'),
(151289, 'Northeast Center', 41.9316711425781, 0.731845722301481, -73.5344390869141, -1.28341807567386, 218, 40, 'PPL', 'P'),
(128379, 'Northeast Harbor', 44.2941703796387, 0.773079112564041, -68.290283203125, -1.19189028901391, 218, 26, 'PPL', 'P'),
(49916, 'Northeast Heights', 39.5730590820313, 0.69068017606769, -75.9508285522461, -1.32559202785441, 218, 25, 'PPL', 'P'),
(42335, 'Northeast Place', 30.5791702270508, 0.533707202989858, -91.054443359375, -1.58919983519178, 218, 22, 'PPL', 'P'),
(208281, 'Northeast Tacoma', 47.2811088562012, 0.825211023534561, -122.36888885498, -2.1357400125264, 218, 56, 'PPL', 'P'),
(175601, 'Northeim', 43.9941711425781, 0.767843138123864, -87.6986083984375, -1.53062946596989, 218, 57, 'PPL', 'P'),
(117065, 'Northend Mobile Home Park', 42.5522193908691, 0.742676332401642, -90.6944427490234, -1.58291663923196, 218, 16, 'PPL', 'P'),
(37455, 'Northern', 37.5077781677246, 0.65463422413444, -82.815559387207, -1.44540418318766, 218, 21, 'PPL', 'P'),
(96621, 'Northern Acres Colonia', 26.1989994049072, 0.457258800343666, -97.9940032958984, -1.7103180047236, 218, 51, 'PPL', 'P'),
(30691, 'Northern Beach', 39.9555587768555, 0.697356055130246, -86.070556640625, -1.50221460240318, 218, 19, 'PPL', 'P'),
(165382, 'Northern Cambria', 40.6591682434082, 0.709636356969792, -78.7819366455078, -1.37500418556169, 218, 45, 'PPL', 'P'),
(56587, 'Northern Heights', 39.2133293151855, 0.684401707218801, -94.6022186279297, -1.65112019474889, 218, 29, 'PPL', 'P'),
(89484, 'Northern Hills', 35.1450004577637, 0.61339597360289, -85.2427825927734, -1.48776721980561, 218, 50, 'PPL', 'P'),
(128382, 'Northern Maine Junction', 44.7924995422363, 0.781776597210077, -68.8597183227539, -1.20182880672792, 218, 26, 'PPL', 'P'),
(30692, 'Northern Meadows', 39.9666709899902, 0.697549999836631, -86.2588882446289, -1.50550160897861, 218, 19, 'PPL', 'P'),
(10861, 'Northern Ohio', 35.5033302307129, 0.619650007948778, -90.45361328125, -1.57871337208348, 218, 4, 'PPL', 'P'),
(82653, 'Northfall Acres', 34.2491683959961, 0.597760754580117, -82.1875, -1.43444247898284, 218, 48, 'PPL', 'P'),
(37458, 'Northfield', 37.0061111450195, 0.64587848283956, -84.508056640625, -1.47494383284076, 218, 21, 'PPL', 'P'),
(104749, 'Northfield', 37.3080596923828, 0.651148479162663, -79.932502746582, -1.39508535228727, 218, 53, 'PPL', 'P'),
(113845, 'Northfield', 41.6947212219238, 0.727710166023724, -73.1111068725586, -1.2760295347036, 218, 8, 'PPL', 'P'),
(117066, 'Northfield', 41.0588912963867, 0.716612840340391, -91.1216735839844, -1.59037322396807, 218, 16, 'PPL', 'P'),
(120828, 'Northfield', 42.0997200012207, 0.734778728189012, -87.7808303833008, -1.53206451032327, 218, 18, 'PPL', 'P'),
(123332, 'Northfield', 40.0308303833008, 0.698669792495982, -86.2802810668945, -1.50587498416344, 218, 19, 'PPL', 'P'),
(125682, 'Northfield', 42.6958312988281, 0.745182833040598, -72.4533309936523, -1.26454917987649, 218, 23, 'PPL', 'P'),
(128383, 'Northfield', 44.8288917541504, 0.782411761130061, -67.5711135864258, -1.1793384113222, 218, 26, 'PPL', 'P'),
(132333, 'Northfield', 42.3438911437988, 0.739040318565357, -83.7263870239258, -1.46130112436656, 218, 27, 'PPL', 'P'),
(137195, 'Northfield', 44.4583282470703, 0.775944207843776, -93.1613922119141, -1.6259730298397, 218, 28, 'PPL', 'P'),
(144257, 'Northfield', 43.4330596923828, 0.758049895847316, -71.5927810668945, -1.24952975027677, 218, 36, 'PPL', 'P'),
(145928, 'Northfield', 40.774169921875, 0.711643514904358, -74.3249969482422, -1.29721591328156, 218, 37, 'PPL', 'P'),
(151287, 'Northfield', 42.246940612793, 0.737348212587748, -75.1891708374023, -1.31229859295717, 218, 40, 'PPL', 'P'),
(156856, 'Northfield', 41.3450012207031, 0.721606400542344, -81.5286102294922, -1.42294268307977, 218, 41, 'PPL', 'P'),
(172355, 'Northfield', 44.1511116027832, 0.770582265884038, -72.6569366455078, -1.26810276887704, 218, 55, 'PPL', 'P'),
(175602, 'Northfield', 44.459171295166, 0.775958921808799, -91.0994415283203, -1.58998520139724, 218, 57, 'PPL', 'P'),
(191952, 'Northfield', 34.2872200012207, 0.598424880376955, -100.598327636719, -1.75577203926075, 218, 51, 'PPL', 'P'),
(156857, 'Northfield Center', 41.3141708374023, 0.721068308844094, -81.539436340332, -1.42313163435911, 218, 41, 'PPL', 'P'),
(172356, 'Northfield Center', 44.1347198486328, 0.770296175803936, -72.6613922119141, -1.26818053318087, 218, 55, 'PPL', 'P'),
(172357, 'Northfield Falls', 44.1719398498535, 0.770945787372834, -72.6513900756836, -1.26800596297141, 218, 55, 'PPL', 'P'),
(125683, 'Northfield Farms', 42.6147193908691, 0.743767163184139, -72.4749984741211, -1.26492734875128, 218, 23, 'PPL', 'P'),
(123333, 'Northfield Village', 40.0616683959961, 0.699208017352287, -86.477783203125, -1.50932204672038, 218, 19, 'PPL', 'P'),
(120829, 'Northfield Woods', 42.086669921875, 0.734550961336783, -87.8752822875977, -1.53371300703803, 218, 18, 'PPL', 'P'),
(104750, 'Northfields', 38.0794410705566, 0.664611624000368, -78.4588928222656, -1.36936600721788, 218, 53, 'PPL', 'P'),
(113846, 'Northford', 41.3936080932617, 0.722454750507589, -72.7916717529297, -1.27045434011958, 218, 8, 'PPL', 'P'),
(110698, 'Northfork', 37.4208297729492, 0.653116688366286, -81.4402770996094, -1.42140097912472, 218, 58, 'PPL', 'P'),
(42336, 'Northgate', 32.5466690063477, 0.568046534717558, -92.0736083984375, -1.60698762074464, 218, 22, 'PPL', 'P'),
(49909, 'Northgate', 38.6133308410645, 0.673929758338446, -76.8844375610352, -1.34188657898406, 218, 25, 'PPL', 'P'),
(82657, 'Northgate', 35.0680618286133, 0.612053141202245, -81.9749984741211, -1.43073362769074, 218, 48, 'PPL', 'P'),
(156860, 'Northgate', 41.7147216796875, 0.728059239863606, -83.5438919067383, -1.45811598370283, 218, 41, 'PPL', 'P'),
(194348, 'Northgate', 40.8858299255371, 0.713592349611051, -106.293609619141, -1.85517346168352, 218, 7, 'PPL', 'P'),
(198696, 'Northgate', 48.9908294677734, 0.855051277495708, -102.261672973633, -1.78480289198759, 218, 34, 'PPL', 'P'),
(4634, 'Northgate Trailer Park', 33.7200012207031, 0.588525045077777, -86.6811065673828, -1.51287070887291, 218, 2, 'PPL', 'P'),
(49911, 'Northgate Woods', 39.1202812194824, 0.682777711586071, -76.8344421386719, -1.3410139942529, 218, 25, 'PPL', 'P'),
(187120, 'Northglenn', 39.8855590820313, 0.696134329980172, -104.986671447754, -1.83236308747283, 218, 7, 'PPL', 'P'),
(89485, 'Northhampton Acres', 36.0016708374023, 0.628347692331895, -84.0883331298828, -1.46761827563028, 218, 50, 'PPL', 'P'),
(23456, 'Northlake', 34.3624992370605, 0.599738750900746, -83.8294372558594, -1.46309969020875, 218, 13, 'PPL', 'P'),
(82658, 'Northlake', 34.5661087036133, 0.603292406480321, -82.6841735839844, -1.44311106833105, 218, 48, 'PPL', 'P'),
(96622, 'Northlake', 33.1272201538086, 0.578179063716982, -97.2652816772461, -1.69759941314766, 218, 51, 'PPL', 'P'),
(120831, 'Northlake', 41.9172210693359, 0.73159352094625, -87.8955612182617, -1.53406694114691, 218, 18, 'PPL', 'P'),
(67293, 'Northlakes', 35.7816696166992, 0.624507946672219, -81.3752822875977, -1.4202666056584, 218, 33, 'PPL', 'P'),
(37459, 'Northland', 38.065559387207, 0.664369342920198, -84.4794387817383, -1.47444435697832, 218, 21, 'PPL', 'P'),
(132335, 'Northland', 46.0730590820313, 0.804126577447322, -87.5955581665039, -1.5288309001277, 218, 27, 'PPL', 'P'),
(175604, 'Northland', 44.5950012207031, 0.77832960123216, -89.2077789306641, -1.55696946073131, 218, 57, 'PPL', 'P'),
(175605, 'Northline', 44.9891700744629, 0.78520914553908, -92.7149963378906, -1.61818195207068, 218, 57, 'PPL', 'P'),
(49912, 'Northminster at Fair Hill', 39.6958312988281, 0.692822955480768, -75.8736114501953, -1.32424433518478, 218, 25, 'PPL', 'P'),
(67294, 'Northmont', 35.8166694641113, 0.625118809247256, -80.9241714477539, -1.41239323621169, 218, 33, 'PPL', 'P'),
(112475, 'Northmont', 39.8833312988281, 0.696095447828257, -75.0952835083008, -1.31065994993845, 218, 37, 'PPL', 'P'),
(56589, 'Northmoor', 39.1830596923828, 0.683873402637557, -94.5924987792969, -1.65095055138745, 218, 29, 'PPL', 'P'),
(137200, 'Northome', 47.872501373291, 0.835532770129435, -94.2802810668945, -1.64550132432298, 218, 28, 'PPL', 'P'),
(42337, 'Northpark Village', 32.5805587768555, 0.568638022795664, -92.0802764892578, -1.60710400088427, 218, 22, 'PPL', 'P'),
(10856, 'Northpoint', 34.8349990844727, 0.607985428953258, -92.5516662597656, -1.61533130443986, 218, 4, 'PPL', 'P'),
(89487, 'Northpoint', 35.6222190856934, 0.621725009912113, -84.4780578613281, -1.47442025537046, 218, 50, 'PPL', 'P'),
(205152, 'Northpoint Condominium', 41.1805610656738, 0.718736378414593, -112.024436950684, -1.95519526748223, 218, 52, 'PPL', 'P'),
(205153, 'Northpoint Estates Condominium', 40.7866706848145, 0.711861694376663, -111.878890991211, -1.95265501127645, 218, 52, 'PPL', 'P'),
(4635, 'Northport', 33.228889465332, 0.579953527951302, -87.5772171020508, -1.52851078816467, 218, 2, 'PPL', 'P'),
(49913, 'Northport', 39.0394401550293, 0.681366768840547, -76.470832824707, -1.33466781453329, 218, 25, 'PPL', 'P'),
(89489, 'Northport', 35.9749984741211, 0.627882171773349, -83.1797180175781, -1.45175995028719, 218, 50, 'PPL', 'P'),
(128385, 'Northport', 44.3377799987793, 0.773840244003586, -68.9619369506836, -1.20361285834217, 218, 26, 'PPL', 'P'),
(132336, 'Northport', 45.1313896179199, 0.787691344833088, -85.6166687011719, -1.49429276342463, 218, 27, 'PPL', 'P'),
(151288, 'Northport', 40.9008293151855, 0.713854138346205, -73.3436126708984, -1.28008752641461, 218, 40, 'PPL', 'P'),
(175607, 'Northport', 44.4097213745117, 0.775095857878531, -88.7938919067383, -1.54974576943253, 218, 57, 'PPL', 'P'),
(199573, 'Northport', 41.6822204589844, 0.727491986551419, -103.086936950684, -1.79920646558523, 218, 35, 'PPL', 'P'),
(208283, 'Northport', 48.9161109924316, 0.853747194088923, -117.780563354492, -2.05565862538967, 218, 56, 'PPL', 'P'),
(23459, 'Northridge', 33.5397186279297, 0.585378520249848, -84.4674987792969, -1.47423596462302, 218, 13, 'PPL', 'P'),
(49914, 'Northridge', 39.5013885498047, 0.68942928930368, -76.2983322143555, -1.33165711092096, 218, 25, 'PPL', 'P'),
(73726, 'Northridge', 39.8074989318848, 0.694771923345515, -84.1969375610352, -1.46951378053615, 218, 41, 'PPL', 'P'),
(183719, 'Northridge', 34.228328704834, 0.597397033354239, -118.535827636719, -2.06884047383723, 218, 6, 'PPL', 'P'),
(96623, 'Northridge Colonia', 26.4139995574951, 0.461011260898615, -98.9970016479492, -1.72782362835897, 218, 51, 'PPL', 'P'),
(23460, 'Northridge Estates', 34.0863914489746, 0.594919760908248, -84.5863876342773, -1.47631096658636, 218, 13, 'PPL', 'P'),
(197167, 'Northridge Heights', 48.2180595397949, 0.841563897892083, -114.331939697266, -1.99546878790889, 218, 31, 'PPL', 'P'),
(205155, 'Northridge Heights Condominium', 40.7755584716797, 0.711667749670278, -111.873062133789, -1.95255327852281, 218, 52, 'PPL', 'P'),
(49915, 'Northridge Manor', 39.6952781677246, 0.692813301521816, -77.7191696166992, -1.35645540172734, 218, 25, 'PPL', 'P'),
(23461, 'Northridge Park', 33.9938888549805, 0.593305286076414, -83.3833312988281, -1.45531367244579, 218, 13, 'PPL', 'P'),
(137203, 'Northrop', 43.7363891601563, 0.763343993778284, -94.4361114501953, -1.64822107758623, 218, 28, 'PPL', 'P'),
(49, 'Northrup', 30.1002807617188, 0.525349005066699, -96.9700012207031, -1.69244579696419, 218, 51, 'PPL', 'P'),
(145929, 'Northrup', 41.1361083984375, 0.717960533010026, -74.7174987792969, -1.30406636255357, 218, 37, 'PPL', 'P'),
(208284, 'Northrup', 47.6330604553223, 0.831353737746883, -122.184173583984, -2.13251612286881, 218, 56, 'PPL', 'P'),
(30693, 'Norths Landing', 38.9022216796875, 0.678971854651266, -84.8736114501953, -1.48132396786427, 218, 19, 'PPL', 'P'),
(14318, 'Northshire', 39.8180618286133, 0.694956280671976, -75.5027770996094, -1.31777205478756, 218, 10, 'PPL', 'P'),
(170963, 'Northshore Development', 42.8666687011719, 0.74816450819705, -97.5277786254883, -1.70218084917092, 218, 49, 'PPL', 'P'),
(89490, 'Northshore Estates', 35.1161117553711, 0.612891770629511, -85.2122192382813, -1.48723378863926, 218, 50, 'PPL', 'P'),
(89492, 'Northshore Woods', 35.896110534668, 0.626505317489778, -84.0263900756836, -1.46653716538577, 218, 50, 'PPL', 'P'),
(4636, 'Northside', 34.0344390869141, 0.594013021136103, -85.976936340332, -1.50058061991636, 218, 2, 'PPL', 'P'),
(96624, 'Northside', 34.3047218322754, 0.598730344953988, -99.2975006103516, -1.73306832465171, 218, 51, 'PPL', 'P'),
(104752, 'Northside', 37.2805595397949, 0.650668510955203, -79.9444427490234, -1.39529374464257, 218, 53, 'PPL', 'P'),
(125685, 'Northside', 42.1647186279297, 0.735913168234359, -71.95361328125, -1.25582746046453, 218, 23, 'PPL', 'P'),
(4637, 'Northside Acres', 34.8116683959961, 0.607578231622585, -86.6547164916992, -1.51241011516238, 218, 2, 'PPL', 'P'),
(199574, 'Northside Mobile Home Ranch', 41.8916702270508, 0.731147574621717, -103.6875, -1.80968826816162, 218, 35, 'PPL', 'P'),
(23464, 'Northside Park', 33.809440612793, 0.590086056950727, -84.4130630493164, -1.47328588190414, 218, 13, 'PPL', 'P'),
(42338, 'Northside Terrace', 32.5783309936523, 0.568599140643749, -92.0741729736328, -1.60699747444067, 218, 22, 'PPL', 'P'),
(96625, 'Northside Village Colonia Number 2', 26.2159996032715, 0.457555509778615, -98.1220016479492, -1.71255199740402, 218, 51, 'PPL', 'P'),
(142551, 'Northside Village Mobile Home Park', 40.7386093139648, 0.711022865212315, -99.5372161865234, -1.73725215072423, 218, 35, 'PPL', 'P'),
(183713, 'Northspur', 39.422779083252, 0.688057295289098, -123.550827026367, -2.1563687251721, 218, 6, 'PPL', 'P'),
(37460, 'Northtown', 37.214168548584, 0.64950976956491, -86.0008316040039, -1.50099767094306, 218, 21, 'PPL', 'P'),
(144259, 'Northumberland', 44.5633316040039, 0.777776862147914, -71.5591735839844, -1.24894318904668, 218, 36, 'PPL', 'P'),
(151290, 'Northumberland', 43.1272201538086, 0.752711988916415, -73.5886077880859, -1.28436349786084, 218, 40, 'PPL', 'P'),
(165384, 'Northumberland', 40.8916702270508, 0.713694282101773, -76.7977828979492, -1.34037416980101, 218, 45, 'PPL', 'P'),
(156863, 'Northumberland (historical)', 40.4530601501465, 0.706039092127368, -84.1802825927734, -1.46922309650317, 218, 41, 'PPL', 'P'),
(190557, 'Northumberland (historical)', 38.9516716003418, 0.679834918581533, -116.846939086914, -2.03936380794391, 218, 39, 'PPL', 'P'),
(73727, 'Northup', 38.7819404602051, 0.676872551342984, -82.2838897705078, -1.43612479784344, 218, 41, 'PPL', 'P'),
(145930, 'Northvale', 41.0063896179199, 0.715696513188322, -73.9494400024414, -1.29066120804861, 218, 37, 'PPL', 'P'),
(23466, 'Northview', 33.3800010681152, 0.582590922957835, -82.0066680908203, -1.43128636677499, 218, 13, 'PPL', 'P'),
(56590, 'Northview', 37.2866706848145, 0.650775170556861, -92.9963912963867, -1.62309322059495, 218, 29, 'PPL', 'P'),
(67301, 'Northview', 35.5288887023926, 0.620096087431366, -79.1861114501953, -1.38205836665709, 218, 33, 'PPL', 'P'),
(73728, 'Northview', 39.8430595397949, 0.695392573037558, -84.2797164916992, -1.47095854542752, 218, 41, 'PPL', 'P'),
(132337, 'Northview', 43.0455589294434, 0.751286731680032, -85.6005630493164, -1.49401166677157, 218, 27, 'PPL', 'P'),
(82660, 'Northview Acres', 34.9647216796875, 0.610249515353989, -82.1333312988281, -1.43349705679586, 218, 48, 'PPL', 'P'),
(137205, 'Northview Court', 44.9063911437988, 0.783764380647712, -94.3816680908203, -1.64727086170929, 218, 28, 'PPL', 'P'),
(104755, 'Northview Mobile Home Park', 37.3480606079102, 0.651846626842427, -79.956672668457, -1.39550719700394, 218, 53, 'PPL', 'P'),
(10857, 'Northview Subdivision', 35.1791687011719, 0.613992321949986, -92.7252807617188, -1.61836144912815, 218, 4, 'PPL', 'P'),
(71188, 'Northville', 39.5111083984375, 0.689598932665118, -75.204719543457, -1.31256996907225, 218, 37, 'PPL', 'P'),
(113847, 'Northville', 41.6291694641113, 0.726566072019426, -73.3936080932617, -1.28096011114577, 218, 8, 'PPL', 'P'),
(120833, 'Northville', 41.5633316040039, 0.725416984588084, -88.7052764892578, -1.54819913862947, 218, 18, 'PPL', 'P'),
(125686, 'Northville', 42.0602798461914, 0.734090367626254, -70.9277801513672, -1.23792329477204, 218, 23, 'PPL', 'P'),
(132338, 'Northville', 42.4311103820801, 0.740562581444447, -83.4833297729492, -1.45705897506617, 218, 27, 'PPL', 'P'),
(151293, 'Northville', 40.9700012207031, 0.715061415847365, -72.6194381713867, -1.26744829703915, 218, 40, 'PPL', 'P'),
(156864, 'Northville', 40.1819381713867, 0.701307120923488, -83.8122177124023, -1.46279915247973, 218, 41, 'PPL', 'P'),
(170964, 'Northville', 45.1555595397949, 0.788113189549757, -98.5788879394531, -1.72052616749799, 218, 49, 'PPL', 'P'),
(125687, 'Northville (historical)', 42.2930603027344, 0.738153153027225, -71.8097229003906, -1.25331609955659, 218, 23, 'PPL', 'P'),
(165388, 'Northvue', 40.9205589294434, 0.714198485075153, -79.9322204589844, -1.39508042543925, 218, 45, 'PPL', 'P'),
(212049, 'Northway', 62.961669921875, 1.0988884426906, -141.937225341797, -2.47727191335949, 218, 1, 'PPL', 'P'),
(212050, 'Northway Indian Village', 62.9822196960449, 1.09924710391041, -141.951675415039, -2.47752411471472, 218, 1, 'PPL', 'P'),
(212051, 'Northway Junction', 63.0022201538086, 1.09959617775029, -141.777221679688, -2.47447932264043, 218, 1, 'PPL', 'P'),
(104756, 'Northwest', 36.5613899230957, 0.638116633263496, -76.2013931274414, -1.32996520468043, 218, 53, 'PPL', 'P'),
(112462, 'Northwest', 34.3127784729004, 0.598870959859544, -78.1613922119141, -1.36417364204055, 218, 33, 'PPL', 'P'),
(156865, 'Northwest', 41.6916694641113, 0.727656902801923, -84.7333297729492, -1.4788755907161, 218, 41, 'PPL', 'P'),
(89494, 'Northwest Acres', 35.2436103820801, 0.615117041457354, -84.8763885498047, -1.48137243739611, 218, 50, 'PPL', 'P'),
(128388, 'Northwest Bethel', 44.422779083252, 0.775323757888815, -70.8450012207031, -1.23647852988067, 218, 26, 'PPL', 'P'),
(151294, 'Northwest Corners', 42.6294403076172, 0.744024091650304, -75.7738876342773, -1.32250382625436, 218, 40, 'PPL', 'P'),
(125688, 'Northwest Duxbury', 42.0583305358887, 0.734056345743328, -70.7416687011719, -1.23467503719047, 218, 23, 'PPL', 'P'),
(23467, 'Northwest Harbor', 34.1388893127441, 0.595836021481289, -84.0224990844727, -1.46646925477797, 218, 13, 'PPL', 'P'),
(151295, 'Northwest Harbor', 41.0097198486328, 0.715754636679113, -72.2216720581055, -1.26050596870953, 218, 40, 'PPL', 'P'),
(151296, 'Northwest Landing', 41.0099983215332, 0.715759496948103, -72.2461090087891, -1.26093247395811, 218, 40, 'PPL', 'P'),
(30694, 'Northwest Manor', 39.899169921875, 0.696371883949407, -86.2747192382813, -1.5057779119417, 218, 19, 'PPL', 'P'),
(49918, 'Northwest Park', 39.0072212219238, 0.680804442376377, -76.9844436645508, -1.3436320147625, 218, 25, 'PPL', 'P'),
(13179, 'Northwest Rectangle', 38.8944396972656, 0.678836033435672, -77.045280456543, -1.34469381708911, 218, 9, 'PPL', 'P'),
(23469, 'Northwest Woods', 33.8786087036133, 0.59129326787286, -83.459716796875, -1.45664685088748, 218, 13, 'PPL', 'P'),
(23471, 'Northwind', 34.0163917541504, 0.593698035758174, -84.6616668701172, -1.47762483711015, 218, 13, 'PPL', 'P'),
(49919, 'Northwind Farms', 39.4080581665039, 0.687800366822933, -76.4941711425781, -1.33507514502202, 218, 25, 'PPL', 'P'),
(117067, 'Northwind Mobile Home Park', 42.4908294677734, 0.741604876116076, -91.1263885498047, -1.59045551564575, 218, 16, 'PPL', 'P'),
(49920, 'Northwind Village', 39.4019393920898, 0.687693574063221, -76.5016708374023, -1.3352060393896, 218, 25, 'PPL', 'P'),
(14320, 'Northwood', 39.7958297729492, 0.694568258101151, -75.5027770996094, -1.31777205478756, 218, 10, 'PPL', 'P'),
(17323, 'Northwood', 30.4333305358887, 0.531161820198988, -81.6624984741211, -1.42527947377826, 218, 12, 'PPL', 'P'),
(23473, 'Northwood', 30.8758296966553, 0.538884887491677, -83.3000030517578, -1.4538593201745, 218, 13, 'PPL', 'P'),
(49921, 'Northwood', 38.6472206115723, 0.674521246416553, -76.904167175293, -1.34223092571301, 218, 25, 'PPL', 'P'),
(82663, 'Northwood', 35.0694389343262, 0.612077176231083, -81.9863891601563, -1.43093243266612, 218, 48, 'PPL', 'P'),
(117068, 'Northwood', 43.4441719055176, 0.758243840553701, -93.220832824707, -1.62701046424234, 218, 16, 'PPL', 'P'),
(123334, 'Northwood', 41.6544418334961, 0.727007158074971, -85.4205627441406, -1.49087006879166, 218, 19, 'PPL', 'P'),
(132341, 'Northwood', 42.3327789306641, 0.738846373858972, -85.5897216796875, -1.49382244917612, 218, 27, 'PPL', 'P'),
(140620, 'Northwood', 47.7341690063477, 0.833118414864197, -97.5663909912109, -1.70285476208476, 218, 34, 'PPL', 'P'),
(144261, 'Northwood', 43.1941719055176, 0.753880517423715, -71.1513900756836, -1.2418260241915, 218, 36, 'PPL', 'P'),
(145932, 'Northwood', 40.9719390869141, 0.71509523799321, -74.6361083984375, -1.30264583242813, 218, 37, 'PPL', 'P'),
(151297, 'Northwood', 43.3486099243164, 0.756575969342011, -75.0716705322266, -1.31024782575976, 218, 40, 'PPL', 'P'),
(156869, 'Northwood', 41.6072196960449, 0.726182976296618, -83.4688873291016, -1.456806906869, 218, 41, 'PPL', 'P'),
(165390, 'Northwood', 40.6852798461914, 0.710092090411332, -78.2300033569336, -1.36537113242471, 218, 45, 'PPL', 'P'),
(183714, 'Northwood', 38.4755592346191, 0.671525190190213, -123.000556945801, -2.146764700491, 218, 6, 'PPL', 'P'),
(208286, 'Northwood', 48.9644393920898, 0.854590683785179, -122.406112670898, -2.13638969067433, 218, 56, 'PPL', 'P'),
(10859, 'Northwood (historical)', 35.6016693115234, 0.621366348692307, -92.8663864135742, -1.6208242073462, 218, 4, 'PPL', 'P'),
(30696, 'Northwood (historical)', 39.8305587768555, 0.695174393565253, -86.1208267211914, -1.5030919808243, 218, 19, 'PPL', 'P'),
(144262, 'Northwood Center', 43.2172203063965, 0.754282787906371, -71.2072219848633, -1.24280047483436, 218, 36, 'PPL', 'P'),
(23474, 'Northwood Estates', 31.2383308410645, 0.545211726003864, -81.5180587768555, -1.42275852549039, 218, 13, 'PPL', 'P'),
(42339, 'Northwood Estates', 32.5688896179199, 0.568434357551301, -92.1958312988281, -1.60912081277779, 218, 22, 'PPL', 'P'),
(49923, 'Northwood Estates', 39.1444396972656, 0.683199356565658, -76.6722183227539, -1.33818265453998, 218, 25, 'PPL', 'P'),
(82666, 'Northwood Estates', 32.9516716003418, 0.575115163461873, -80.0519409179688, -1.39716994163053, 218, 48, 'PPL', 'P'),
(205158, 'Northwood Estates', 40.6472206115723, 0.709427831456439, -111.966110229492, -1.95417727415554, 218, 52, 'PPL', 'P'),
(49924, 'Northwood Forest', 39.0333290100098, 0.681260109238889, -77.024169921875, -1.3443253687523, 218, 25, 'PPL', 'P'),
(104757, 'Northwood Heights', 37.3580589294434, 0.652021130472855, -79.524169921875, -1.38795860005216, 218, 53, 'PPL', 'P'),
(165392, 'Northwood Heights', 40.702220916748, 0.710387767871358, -75.2666702270508, -1.31365121247482, 218, 45, 'PPL', 'P'),
(183715, 'Northwood Heights', 38.4797210693359, 0.671597827908945, -122.998329162598, -2.14672581833909, 218, 6, 'PPL', 'P'),
(4643, 'Northwood Hills', 34.8549995422363, 0.60833450279314, -87.6958312988281, -1.53058099643805, 218, 2, 'PPL', 'P'),
(30697, 'Northwood Hills', 39.9613914489746, 0.697457854462915, -86.0616683959961, -1.50205947326968, 218, 19, 'PPL', 'P'),
(104758, 'Northwood Hills', 39.3116683959961, 0.68611804796233, -78.3319396972656, -1.36715025719094, 218, 53, 'PPL', 'P'),
(183716, 'Northwood Lodge', 38.4772186279297, 0.671554152067068, -122.996673583984, -2.14669692304126, 218, 6, 'PPL', 'P'),
(144263, 'Northwood Narrows', 43.225830078125, 0.754433056770879, -71.2444381713867, -1.24345001982423, 218, 36, 'PPL', 'P'),
(49925, 'Northwood Park', 39.0277786254883, 0.681163236754237, -77.01611328125, -1.34418475384675, 218, 25, 'PPL', 'P'),
(73730, 'Northwood Park', 39.6230583190918, 0.691552827377882, -82.9297180175781, -1.4473966271572, 218, 41, 'PPL', 'P'),
(123335, 'Northwood Park', 41.5286102294922, 0.724810982282037, -87.0488891601563, -1.51928972604833, 218, 19, 'PPL', 'P'),
(144264, 'Northwood Ridge', 43.2094383239746, 0.754146966690777, -71.1805572509766, -1.24233508743386, 218, 36, 'PPL', 'P'),
(110696, 'Northwood Villa Estates', 39.3161087036133, 0.686195545950051, -81.4527816772461, -1.42161922517605, 218, 58, 'PPL', 'P'),
(23475, 'Northwoods', 33.877498626709, 0.591273893375929, -84.2877807617188, -1.47109929349113, 218, 13, 'PPL', 'P'),
(42342, 'Northwoods', 30.5472202301025, 0.533149570347109, -90.9977798461914, -1.58821087032098, 218, 22, 'PPL', 'P'),
(56593, 'Northwoods', 38.7041702270508, 0.675515204714397, -90.283332824707, -1.57574141746501, 218, 29, 'PPL', 'P'),
(89495, 'Northwoods', 35.1527786254883, 0.613531728239457, -85.251106262207, -1.48791249524307, 218, 50, 'PPL', 'P'),
(104759, 'Northwoods', 37.6405601501465, 0.656951706915027, -77.4791717529297, -1.35226664880681, 218, 53, 'PPL', 'P'),
(178727, 'Northwoods', 34.0283317565918, 0.593906428113473, -109.456108093262, -1.91036947264623, 218, 5, 'PPL', 'P'),
(208287, 'Northwoods', 46.0591697692871, 0.803884163209097, -122.018890380859, -2.12963138677603, 218, 56, 'PPL', 'P'),
(175608, 'Northwoods Beach', 45.9141693115234, 0.801353427804222, -91.4033279418945, -1.59528901986619, 218, 57, 'PPL', 'P'),
(151298, 'Northwoods Club', 43.8452796936035, 0.765244492111192, -74.146110534668, -1.29409375637761, 218, 40, 'PPL', 'P'),
(104760, 'Northwoods Mobile Home Park', 38.1338882446289, 0.665561906456335, -78.4269409179688, -1.36880834128562, 218, 53, 'PPL', 'P'),
(56594, 'Northwye', 37.9749984741211, 0.662788756813236, -91.7555618286133, -1.60143666092653, 218, 29, 'PPL', 'P'),
(4647, 'Norton', 34.5533294677734, 0.603069366739026, -86.5391693115234, -1.51039343642692, 218, 2, 'PPL', 'P'),
(23477, 'Norton', 34.8547210693359, 0.608329642524151, -84.8499984741211, -1.48091184368558, 218, 13, 'PPL', 'P'),
(30698, 'Norton', 38.4944381713867, 0.671854689796084, -86.6830596923828, -1.51290479733486, 218, 19, 'PPL', 'P'),
(33452, 'Norton', 39.8338890075684, 0.695232517056044, -99.89111328125, -1.74342882024045, 218, 20, 'PPL', 'P'),
(42343, 'Norton', 32.3330612182617, 0.564318375507556, -93.6963882446289, -1.63531047209568, 218, 22, 'PPL', 'P'),
(56595, 'Norton', 39.1961097717285, 0.684101169489786, -93.1347198486328, -1.62550750928116, 218, 29, 'PPL', 'P'),
(67312, 'Norton', 35.0166702270508, 0.611156188547107, -83.3811111450195, -1.45527492345193, 218, 33, 'PPL', 'P'),
(104761, 'Norton', 36.9333305358887, 0.644608221578619, -82.6291732788086, -1.44215113191613, 218, 53, 'PPL', 'P'),
(110697, 'Norton', 38.9316711425781, 0.679485844741651, -79.9658279418945, -1.39566698666934, 218, 58, 'PPL', 'P'),
(125689, 'Norton', 41.9666709899902, 0.732456584876518, -71.1875, -1.24245626126346, 218, 23, 'PPL', 'P'),
(132342, 'Norton', 42.3761100769043, 0.739602645029527, -83.3141708374023, -1.45410659468171, 218, 27, 'PPL', 'P'),
(145933, 'Norton', 40.6572189331055, 0.709602335086867, -74.9794387817383, -1.30863807803886, 218, 37, 'PPL', 'P'),
(156874, 'Norton', 41.0291709899902, 0.716094123139071, -81.6383285522461, -1.42485762906159, 218, 41, 'PPL', 'P'),
(172359, 'Norton', 45.0099983215332, 0.785572667027876, -71.795280456543, -1.25306403135941, 218, 55, 'PPL', 'P'),
(177425, 'Norton', 45.0163917541504, 0.78568425347755, -91.8341674804688, -1.60280858836209, 218, 57, 'PPL', 'P'),
(178728, 'Norton', 32.8105583190918, 0.572652272085768, -113.798057556152, -1.98615078672887, 218, 5, 'PPL', 'P'),
(183718, 'Norton', 38.586109161377, 0.673454650399976, -121.970001220703, -2.12877810996277, 218, 6, 'PPL', 'P'),
(189127, 'Norton', 34.9983291625977, 0.610836076584079, -103.524719238281, -1.80684720791072, 218, 38, 'PPL', 'P'),
(191953, 'Norton', 31.8708305358887, 0.556250928196406, -100.125831604004, -1.74752542778726, 218, 51, 'PPL', 'P'),
(10860, 'Norton (historical)', 36.3380584716797, 0.634218764113029, -93.4533309936523, -1.6310683227953, 218, 4, 'PPL', 'P'),
(23478, 'Norton (historical)', 33.6819381713867, 0.587860719543856, -84.3361129760742, -1.47194284976641, 218, 13, 'PPL', 'P'),
(82668, 'Norton (historical)', 34.2099990844727, 0.597077121128294, -78.9763870239258, -1.37839798489683, 218, 48, 'PPL', 'P'),
(170969, 'Norton Acres', 43.577220916748, 0.760565983866195, -96.7041702270508, -1.68780617087111, 218, 49, 'PPL', 'P'),
(42344, 'Norton Corner', 32.9486083984375, 0.57506170050299, -93.2252807617188, -1.62708809538812, 218, 22, 'PPL', 'P'),
(89497, 'Norton Creek Ranch', 35.7166709899902, 0.623373506626872, -83.5763931274414, -1.45868323701501, 218, 50, 'PPL', 'P'),
(125690, 'Norton Furnace (historical)', 41.9386100769043, 0.731966829552052, -71.1600036621094, -1.24197635963503, 218, 23, 'PPL', 'P'),
(125691, 'Norton Grove', 41.9916687011719, 0.7328928772421, -71.1958312988281, -1.24260166985898, 218, 23, 'PPL', 'P'),
(151299, 'Norton Hill', 42.4113883972168, 0.740218367873554, -74.0672225952148, -1.29271690209404, 218, 40, 'PPL', 'P'),
(132343, 'Norton Shores', 43.1688919067383, 0.753439298210116, -86.2638931274414, -1.50558896066236, 218, 27, 'PPL', 'P'),
(151300, 'Norton Summit', 42.1097183227539, 0.73495323181944, -78.0130615234375, -1.36158478314489, 218, 40, 'PPL', 'P'),
(30699, 'Nortonburg', 39.2683296203613, 0.68536164363372, -85.8233337402344, -1.49789974880503, 218, 19, 'PPL', 'P'),
(201321, 'Nortons', 44.663890838623, 0.779531951885304, -123.700828552246, -2.1589867456817, 218, 43, 'PPL', 'P'),
(178729, 'Nortons Corner', 33.3066711425781, 0.58131107431697, -111.788887023926, -1.95108414570747, 218, 5, 'PPL', 'P'),
(178730, 'Nortons Landing', 33.0505599975586, 0.576841091585326, -114.643333435059, -2.00090363390347, 218, 5, 'PPL', 'P'),
(104764, 'Nortonsville', 38.2372207641602, 0.667365399146537, -78.5483322143555, -1.37092701909083, 218, 53, 'PPL', 'P'),
(28084, 'Nortonville', 39.5622215270996, 0.690491025051267, -90.1397171020508, -1.57323485024703, 218, 18, 'PPL', 'P'),
(33457, 'Nortonville', 39.4166717529297, 0.687950702266468, -95.3333282470703, -1.66388046479589, 218, 20, 'PPL', 'P'),
(37461, 'Nortonville', 37.1908302307129, 0.649102439076182, -87.4527816772461, -1.52633898029571, 218, 21, 'PPL', 'P'),
(71196, 'Nortonville', 39.7852783203125, 0.694384100511772, -75.4063873291016, -1.31608973592696, 218, 37, 'PPL', 'P'),
(140624, 'Nortonville', 46.5583305358887, 0.812596162083073, -98.7383270263672, -1.72330890452101, 218, 34, 'PPL', 'P'),
(183722, 'Nortonville', 37.9577789306641, 0.66248821908422, -121.879440307617, -2.12719752385581, 218, 6, 'PPL', 'P'),
(17324, 'Norum', 30.5977802276611, 0.534032008774307, -85.7577819824219, -1.49675565480073, 218, 12, 'PPL', 'P'),
(128392, 'Norumbega', 44.3208312988281, 0.773544433385506, -68.7236099243164, -1.19945326703557, 218, 26, 'PPL', 'P'),
(183720, 'Norval (historical)', 38.184440612793, 0.666444211725479, -120.840278625488, -2.1090607310421, 218, 6, 'PPL', 'P'),
(10862, 'Norvell', 35.2794418334961, 0.615742418260332, -90.4775009155273, -1.57913028995214, 218, 4, 'PPL', 'P'),
(132345, 'Norvell', 42.1575012207031, 0.735787200714798, -84.1841735839844, -1.46929100711096, 218, 27, 'PPL', 'P'),
(193821, 'Norvell', 40.4863891601563, 0.706620793088468, -121.004440307617, -2.11192589290086, 218, 6, 'PPL', 'P'),
(110701, 'Norvell (historical)', 37.8377799987793, 0.660393842623955, -81.0975036621094, -1.41541845405197, 218, 58, 'PPL', 'P'),
(104765, 'Norvella Heights', 36.8905601501465, 0.64386173752507, -76.2263870239258, -1.33040143046699, 218, 53, 'PPL', 'P'),
(10863, 'Norvelle (historical)', 34.0780601501465, 0.594774352312729, -93.7516708374023, -1.63627533535862, 218, 4, 'PPL', 'P'),
(104766, 'Norvello', 36.628059387207, 0.639280234922779, -78.32861328125, -1.36709220027917, 218, 53, 'PPL', 'P'),
(165393, 'Norvelt', 40.2080612182617, 0.701763054102109, -79.4977798461914, -1.38749800634163, 218, 45, 'PPL', 'P'),
(104767, 'Norview', 36.8883285522461, 0.643822788794127, -76.2458267211914, -1.33074071718986, 218, 53, 'PPL', 'P'),
(56596, 'Norville', 39.7544403076172, 0.693845875655467, -93.4722213745117, -1.63139802213825, 218, 29, 'PPL', 'P'),
(67316, 'Norville Crags (historical)', 36.560001373291, 0.638092398497577, -80.8936080932617, -1.41185980504535, 218, 33, 'PPL', 'P'),
(17325, 'Norwalk', 29.4347190856934, 0.513732762444964, -81.716667175293, -1.42622489596524, 218, 12, 'PPL', 'P'),
(56597, 'Norwalk', 36.6269416809082, 0.639260727267794, -93.533332824707, -1.63246461815483, 218, 29, 'PPL', 'P'),
(113848, 'Norwalk', 41.1175003051758, 0.717635760515091, -73.408332824707, -1.28121710619097, 218, 8, 'PPL', 'P'),
(117069, 'Norwalk', 41.4755592346191, 0.723885067750043, -93.6786117553711, -1.63500021382869, 218, 16, 'PPL', 'P'),
(132347, 'Norwalk', 44.3416709899902, 0.773908154611383, -86.1622161865234, -1.50381436326999, 218, 27, 'PPL', 'P'),
(156876, 'Norwalk', 41.2425003051758, 0.719817422080084, -82.6158294677734, -1.4419182384788, 218, 41, 'PPL', 'P'),
(175609, 'Norwalk', 43.8305587768555, 0.764987563645027, -90.6213912963867, -1.58164165086008, 218, 57, 'PPL', 'P'),
(183721, 'Norwalk', 33.9022216796875, 0.591705392051549, -118.080833435059, -2.06089932694078, 218, 6, 'PPL', 'P'),
(33458, 'Norway', 39.6961097717285, 0.692827815749757, -97.7736129760742, -1.70647146800315, 218, 20, 'PPL', 'P'),
(61110, 'Norway', 32.9038887023926, 0.574281194566515, -90.398063659668, -1.57774384828864, 218, 30, 'PPL', 'P'),
(78859, 'Norway', 39.8488883972168, 0.695494305791199, -75.6105575561523, -1.31965317862354, 218, 45, 'PPL', 'P'),
(82669, 'Norway', 33.4516716003418, 0.583841809721845, -81.1255569458008, -1.41590807621838, 218, 48, 'PPL', 'P'),
(110699, 'Norway', 39.4705581665039, 0.688891197605429, -80.1866683959961, -1.39952137971501, 218, 58, 'PPL', 'P'),
(117071, 'Norway', 41.9027786254883, 0.731341452749074, -91.92138671875, -1.60433085124117, 218, 16, 'PPL', 'P'),
(120836, 'Norway', 41.4655609130859, 0.723710564119616, -88.664436340332, -1.54748634356371, 218, 18, 'PPL', 'P'),
(123336, 'Norway', 40.7783317565918, 0.71171615262309, -86.7594375610352, -1.5142378426185, 218, 19, 'PPL', 'P'),
(128393, 'Norway', 44.2138900756836, 0.771677956935524, -70.545280456543, -1.23124741570948, 218, 26, 'PPL', 'P'),
(132348, 'Norway', 45.7869415283203, 0.799132884087314, -87.9036102294922, -1.53420742289441, 218, 27, 'PPL', 'P'),
(140625, 'Norway', 46.1388893127441, 0.805275531720609, -98.1452789306641, -1.71295826262831, 218, 34, 'PPL', 'P'),
(151301, 'Norway', 43.2083282470703, 0.754127592193847, -74.9524993896484, -1.30816789694841, 218, 40, 'PPL', 'P'),
(199575, 'Norway', 41.9988899230957, 0.733018911340688, -100.717781066895, -1.75785689492012, 218, 35, 'PPL', 'P'),
(201322, 'Norway', 43.1011085510254, 0.752256255474876, -124.155563354492, -2.1669233652043, 218, 43, 'PPL', 'P'),
(117072, 'Norway Center', 41.3458290100098, 0.721620848191258, -94.8722229003906, -1.65583265829778, 218, 16, 'PPL', 'P'),
(128397, 'Norway Center', 44.2336082458496, 0.772022103927389, -70.6119384765625, -1.23241081763168, 218, 26, 'PPL', 'P'),
(170970, 'Norway Center', 43.1272201538086, 0.752711988916415, -96.628059387207, -1.68647778611938, 218, 49, 'PPL', 'P'),
(175611, 'Norway Grove', 43.2486114501953, 0.754830666721628, -89.4024963378906, -1.56036792059836, 218, 57, 'PPL', 'P'),
(128394, 'Norway Lake', 44.2133293151855, 0.771668169818517, -70.5802764892578, -1.23185821170549, 218, 26, 'PPL', 'P'),
(137212, 'Norway Lake', 45.2836112976074, 0.790348114336551, -95.1347198486328, -1.66041409432104, 218, 28, 'PPL', 'P'),
(175612, 'Norway Ridge', 44.1247215270996, 0.770121672173508, -90.3291702270508, -1.57654143105647, 218, 57, 'PPL', 'P'),
(137216, 'Norwegian Grove', 46.6091690063477, 0.81348346077926, -96.2202835083008, -1.67936075442225, 218, 28, 'PPL', 'P'),
(197168, 'Norwegian Settlement (historical)', 46.1083297729492, 0.804742167133293, -109.974998474121, -1.91942581824915, 218, 31, 'PPL', 'P'),
(125693, 'Norwell', 42.1616706848145, 0.735859971591585, -70.7944412231445, -1.23559609145347, 218, 23, 'PPL', 'P'),
(125694, 'Norwell Homes', 42.1722183227539, 0.736044062601936, -70.8722229003906, -1.23695363781914, 218, 23, 'PPL', 'P'),
(23480, 'Norwich', 32.5363883972168, 0.567867104239114, -84.4444427490234, -1.47383356098231, 218, 13, 'PPL', 'P'),
(33459, 'Norwich', 37.457218170166, 0.653751785707243, -97.8486099243164, -1.70778041167892, 218, 20, 'PPL', 'P'),
(73731, 'Norwich', 39.9850006103516, 0.697869912062577, -81.7916717529297, -1.42753397279907, 218, 41, 'PPL', 'P'),
(113850, 'Norwich', 41.524169921875, 0.724733484294315, -72.0763931274414, -1.25797037303567, 218, 8, 'PPL', 'P'),
(117076, 'Norwich', 40.7425003051758, 0.711090775820112, -95.2563934326172, -1.66253769897427, 218, 16, 'PPL', 'P'),
(125696, 'Norwich', 42.288890838623, 0.738080382150438, -72.8388900756836, -1.2712784553189, 218, 23, 'PPL', 'P'),
(151303, 'Norwich', 42.5311088562012, 0.74230788406483, -75.5238876342773, -1.31814050312437, 218, 40, 'PPL', 'P'),
(165394, 'Norwich', 41.6594390869141, 0.727094376600671, -78.3736114501953, -1.36787756648464, 218, 45, 'PPL', 'P'),
(172361, 'Norwich', 43.7152786254883, 0.762975545441472, -72.3083267211914, -1.26201837789259, 218, 55, 'PPL', 'P'),
(198700, 'Norwich', 48.2463912963867, 0.842058380327484, -100.988609313965, -1.7625837395389, 218, 34, 'PPL', 'P'),
(49926, 'Norwich Acres', 39.0894393920898, 0.682239420150738, -76.5016708374023, -1.3352060393896, 218, 25, 'PPL', 'P'),
(125697, 'Norwich Bridge', 42.2480583190918, 0.737367720242733, -72.8694381713867, -1.27181162016913, 218, 23, 'PPL', 'P'),
(151304, 'Norwich Corners', 43.0144386291504, 0.750743579975711, -75.2125015258789, -1.31270579028785, 218, 40, 'PPL', 'P'),
(113852, 'Norwichtown', 41.5530586242676, 0.725237687267695, -72.105827331543, -1.25848409680994, 218, 8, 'PPL', 'P'),
(4648, 'Norwood', 33.5338897705078, 0.585276787496207, -86.7991714477539, -1.51493132976636, 218, 2, 'PPL', 'P'),
(10864, 'Norwood', 36.1186103820801, 0.630388672412304, -94.4611129760742, -1.64865743653083, 218, 4, 'PPL', 'P'),
(17326, 'Norwood', 30.3766708374023, 0.530172921907214, -81.6680603027344, -1.42537654599999, 218, 12, 'PPL', 'P'),
(23481, 'Norwood', 33.4625015258789, 0.584030827580213, -82.7052764892578, -1.44347938350981, 218, 13, 'PPL', 'P'),
(33460, 'Norwood', 38.7097206115723, 0.675612077199049, -95.2466735839844, -1.66236805561284, 218, 20, 'PPL', 'P'),
(37463, 'Norwood', 37.151668548584, 0.648418938782413, -84.6319427490234, -1.4771060533298, 218, 21, 'PPL', 'P'),
(42345, 'Norwood', 30.9675006866455, 0.540484848095569, -91.103889465332, -1.59006283254302, 218, 22, 'PPL', 'P'),
(49942, 'Norwood', 38.4333305358887, 0.670788160358534, -76.8683319091797, -1.341605482331, 218, 25, 'PPL', 'P'),
(56598, 'Norwood', 37.1083297729492, 0.647662534453804, -92.4147186279297, -1.61294111736151, 218, 29, 'PPL', 'P'),
(61111, 'Norwood', 32.3752784729004, 0.565055205602154, -90.1855621337891, -1.57403499699654, 218, 30, 'PPL', 'P'),
(67314, 'Norwood', 35.2194404602051, 0.614695196740686, -80.1191711425781, -1.39834333040682, 218, 33, 'PPL', 'P'),
(73733, 'Norwood', 39.4191703796387, 0.687994311529318, -81.4333267211914, -1.42127967213707, 218, 41, 'PPL', 'P'),
(78860, 'Norwood', 39.8916702270508, 0.69624098958183, -75.3000030517578, -1.31423298001495, 218, 45, 'PPL', 'P'),
(89499, 'Norwood', 36.0302810668945, 0.628847035036285, -84.3236083984375, -1.47172460371508, 218, 50, 'PPL', 'P'),
(96627, 'Norwood', 31.4050006866455, 0.548120663573044, -94.2119369506836, -1.64430849447074, 218, 51, 'PPL', 'P'),
(104771, 'Norwood', 37.3061103820801, 0.651114457279737, -80.01611328125, -1.39654463140658, 218, 53, 'PPL', 'P'),
(117077, 'Norwood', 41.1166687011719, 0.71762124628715, -93.4786071777344, -1.63150947542987, 218, 16, 'PPL', 'P'),
(120838, 'Norwood', 40.7055587768555, 0.710446024520204, -89.6986083984375, -1.56553605100977, 218, 18, 'PPL', 'P'),
(125698, 'Norwood', 42.1944389343262, 0.736431885435679, -71.1999969482422, -1.24267437415674, 218, 23, 'PPL', 'P'),
(132354, 'Norwood', 45.2166709899902, 0.789179785566334, -85.3813934326172, -1.49018643533983, 218, 27, 'PPL', 'P'),
(145934, 'Norwood', 40.9980583190918, 0.715551104592804, -73.9622192382813, -1.2908842477899, 218, 37, 'PPL', 'P'),
(151307, 'Norwood', 44.7513885498047, 0.781059075033382, -74.9947204589844, -1.30890479362203, 218, 40, 'PPL', 'P'),
(169526, 'Norwood', 41.7519416809082, 0.728708851432504, -71.4286117553711, -1.24666445525995, 218, 47, 'PPL', 'P'),
(187121, 'Norwood', 38.1305618286133, 0.665503849544572, -108.29167175293, -1.89004622457756, 218, 7, 'PPL', 'P'),
(195396, 'Norwood', 44.8086090087891, 0.782057760442162, -116.10221862793, -2.02636598392767, 218, 17, 'PPL', 'P'),
(201323, 'Norwood', 45.3594398498535, 0.791671572240266, -122.752777099609, -2.14244012635488, 218, 43, 'PPL', 'P'),
(208288, 'Norwood', 47.4916687011719, 0.828885986101788, -123.808326721191, -2.16086294266967, 218, 56, 'PPL', 'P'),
(67315, 'Norwood Beach', 35.232780456543, 0.614928023598986, -80.0991668701172, -1.39799418998791, 218, 33, 'PPL', 'P'),
(56599, 'Norwood Court', 38.7183303833008, 0.675762346063557, -90.2922210693359, -1.57589654659851, 218, 29, 'PPL', 'P'),
(82670, 'Norwood Crossroad', 33.9677810668945, 0.592849619213902, -79.9416732788086, -1.39524540826878, 218, 48, 'PPL', 'P'),
(49928, 'Norwood Estates', 39.1138916015625, 0.682666191715424, -77.0147171020508, -1.34416038592277, 218, 25, 'PPL', 'P'),
(49929, 'Norwood Heights', 39.2755584716797, 0.685487810890363, -76.6902770996094, -1.33849783965499, 218, 25, 'PPL', 'P'),
(73734, 'Norwood Heights', 39.1749992370605, 0.683732721152973, -84.4319381713867, -1.47361531493098, 218, 41, 'PPL', 'P'),
(67317, 'Norwood Hollow', 36.1347198486328, 0.63066983564439, -81.8494415283203, -1.42854224558777, 218, 33, 'PPL', 'P'),
(49930, 'Norwood Park', 39.2727813720703, 0.685439341358523, -76.5227813720703, -1.33557448772641, 218, 25, 'PPL', 'P'),
(49931, 'Norwood Village', 39.1191711425781, 0.68275833708914, -77.0388870239258, -1.34458223063944, 218, 25, 'PPL', 'P'),
(208289, 'Norwood Village', 47.589168548584, 0.830587679459322, -122.169166564941, -2.1322542009756, 218, 56, 'PPL', 'P'),
(137219, 'Norwood Young America', 44.773609161377, 0.781446897867125, -93.92138671875, -1.63923743628106, 218, 28, 'PPL', 'P'),
(10865, 'Norwoodville', 33.9500007629395, 0.59253929436788, -94.3216705322266, -1.64622370676867, 218, 4, 'PPL', 'P'),
(117078, 'Norwoodville', 41.6438903808594, 0.726823000485591, -93.5608291625977, -1.63294451978326, 218, 16, 'PPL', 'P'),
(89500, 'Nosegay (historical)', 36.1780586242676, 0.631426239972999, -87.2219390869141, -1.52231001704059, 218, 50, 'PPL', 'P'),
(56600, 'Noser Mill', 38.3930587768555, 0.670085285567835, -91.1922225952148, -1.59160453649807, 218, 29, 'PPL', 'P'),
(151308, 'Noseville', 44.0752792358398, 0.769258741401296, -75.9158325195313, -1.3249812318584, 218, 40, 'PPL', 'P'),
(165396, 'Nossville', 40.2336082458496, 0.702208933847616, -77.7658309936523, -1.35726979638869, 218, 45, 'PPL', 'P'),
(49932, 'Nostalgia', 38.4430618286133, 0.670958003457054, -76.5208282470703, -1.33554039926446, 218, 25, 'PPL', 'P'),
(110702, 'Noswad (historical)', 39.4808311462402, 0.689070494925819, -78.9263916015625, -1.37752540016567, 218, 58, 'PPL', 'P'),
(56601, 'Not', 36.8952789306641, 0.643944095781781, -91.5802764892578, -1.5983773546243, 218, 29, 'PPL', 'P'),
(23482, 'Notalee Orchards', 34.8783302307129, 0.608741700123813, -84.0052795410156, -1.46616871704895, 218, 13, 'PPL', 'P'),
(183723, 'Notarb', 37.0111083984375, 0.64596570136526, -120.118057250977, -2.09645559012859, 218, 6, 'PPL', 'P'),
(4650, 'Notasulga', 32.5605583190918, 0.568288948955782, -85.6725006103516, -1.49526721406749, 218, 2, 'PPL', 'P'),
(56602, 'Notch', 36.6761093139648, 0.640118864350045, -93.3383331298828, -1.62906123143976, 218, 29, 'PPL', 'P'),
(49933, 'Notch Cliff', 39.4436111450195, 0.688420883356921, -76.5105590820313, -1.3353611685231, 218, 25, 'PPL', 'P'),
(193822, 'Notchko', 41.2963905334473, 0.720757983998072, -123.868606567383, -2.1619150244583, 218, 6, 'PPL', 'P'),
(144270, 'Notchland', 44.1155586242676, 0.769961749350049, -71.3555603027344, -1.24538946688808, 218, 36, 'PPL', 'P'),
(89501, 'Notchy Creek', 35.4652786254883, 0.61898588215194, -84.3716735839844, -1.47256349945845, 218, 50, 'PPL', 'P'),
(23483, 'Note', 33.2675018310547, 0.580627440865147, -83.4638900756836, -1.4567196883433, 218, 13, 'PPL', 'P'),
(42346, 'Notelyville', 30.5055599212646, 0.53242246079049, -92.0105590820313, -1.60588720258222, 218, 22, 'PPL', 'P'),
(209898, 'Noti', 44.0591697692871, 0.768977578169211, -123.44750213623, -2.15456536563996, 218, 43, 'PPL', 'P'),
(76752, 'Notichtown', 35.5766716003418, 0.620930056326725, -95.0913925170898, -1.65965788972952, 218, 42, 'PPL', 'P'),
(89502, 'Notime (historical)', 35.7713890075684, 0.624328516193775, -83.8769378662109, -1.46392873225609, 218, 50, 'PPL', 'P'),
(183724, 'Notleys Landing', 36.3983306884766, 0.63527071274361, -121.902496337891, -2.12759992749652, 218, 6, 'PPL', 'P'),
(42348, 'Notnac', 32.1030616760254, 0.560304126217452, -91.2022171020508, -1.59177897354947, 218, 22, 'PPL', 'P'),
(192727, 'Notom', 38.2333297729492, 0.66729748853874, -111.117782592773, -1.93937116375914, 218, 52, 'PPL', 'P'),
(172363, 'Notown', 43.6949996948242, 0.7626216113326, -72.7186126708984, -1.26917921858965, 218, 55, 'PPL', 'P'),
(28086, 'Notre Dame', 38.5555610656738, 0.672921485549742, -90.0374984741211, -1.57145079863278, 218, 18, 'PPL', 'P'),
(128396, 'Notre Dame', 47.2544403076172, 0.824745569555042, -68.0658264160156, -1.1879727790504, 218, 26, 'PPL', 'P'),
(191954, 'Notrees', 31.9172191619873, 0.557060562457304, -102.755279541016, -1.79341795179789, 218, 51, 'PPL', 'P'),
(42349, 'Nott (historical)', 30.3438892364502, 0.529600775036524, -90.0233306884766, -1.57120352412557, 218, 22, 'PPL', 'P'),
(96632, 'Nottawa', 29.538890838623, 0.515550902521161, -96.1486129760742, -1.67810986765824, 218, 51, 'PPL', 'P'),
(132356, 'Nottawa', 41.9188919067383, 0.731622682560187, -85.4488906860352, -1.49136448464803, 218, 27, 'PPL', 'P'),
(132359, 'Notten', 42.2786102294922, 0.737900951671994, -84.1233291625977, -1.46822907162629, 218, 27, 'PPL', 'P'),
(4652, 'Nottingham', 33.3622207641602, 0.582280598111813, -86.2227783203125, -1.50487137190664, 218, 2, 'PPL', 'P'),
(23485, 'Nottingham', 33.7972183227539, 0.589872737747411, -84.6036071777344, -1.47661150431537, 218, 13, 'PPL', 'P'),
(49936, 'Nottingham', 39.3638916015625, 0.68702951484541, -76.4524993896484, -1.33434783572832, 218, 25, 'PPL', 'P'),
(104775, 'Nottingham', 36.6352806091309, 0.639406269021367, -82.5149993896484, -1.44015842163048, 218, 53, 'PPL', 'P'),
(110704, 'Nottingham', 38.5180587768555, 0.672266947132828, -79.8433303833008, -1.39352900094622, 218, 58, 'PPL', 'P'),
(123337, 'Nottingham', 40.5811080932617, 0.708273950335135, -85.1502838134766, -1.4861528115528, 218, 19, 'PPL', 'P'),
(144266, 'Nottingham', 43.1144409179688, 0.752488949175121, -71.1002807617188, -1.24093399838437, 218, 36, 'PPL', 'P'),
(145936, 'Nottingham', 40.2324981689453, 0.702189559350686, -74.6822204589844, -1.30345063970955, 218, 37, 'PPL', 'P'),
(156882, 'Nottingham', 41.5741691589355, 0.725606135604507, -81.5480575561523, -1.4232821029607, 218, 41, 'PPL', 'P'),
(165399, 'Nottingham', 40.1202812194824, 0.700231004106014, -74.9688873291016, -1.30845392044948, 218, 45, 'PPL', 'P'),
(156883, 'Nottingham (historical)', 40.2075004577637, 0.701753266985103, -81.1194381713867, -1.41580128345867, 218, 41, 'PPL', 'P'),
(23484, 'Nottingham Estates', 34.202220916748, 0.596941366491727, -85.1402816772461, -1.48597824134334, 218, 13, 'PPL', 'P'),
(151309, 'Nottingham Estates', 43.1830596923828, 0.75368657271733, -78.6427764892578, -1.37257538264754, 218, 40, 'PPL', 'P'),
(49937, 'Nottingham Fields', 39.7144393920898, 0.693147727975703, -76.0647201538086, -1.32757981129205, 218, 25, 'PPL', 'P'),
(104776, 'Nottingham Forest', 37.3352813720703, 0.651623587101133, -79.2583312988281, -1.38331884080102, 218, 53, 'PPL', 'P'),
(14321, 'Nottingham Green', 39.6861114501953, 0.69265331211933, -75.7786102294922, -1.32258625109009, 218, 10, 'PPL', 'P'),
(104777, 'Nottingham Heights', 37.2291717529297, 0.649771624879092, -80.0277786254883, -1.39674823007191, 218, 53, 'PPL', 'P'),
(104778, 'Nottingham Hills', 37.226390838623, 0.649723088768225, -80.0244369506836, -1.39668990684404, 218, 53, 'PPL', 'P'),
(14322, 'Nottingham Manor', 39.6847190856934, 0.692629010774383, -75.7666702270508, -1.3223778587348, 218, 10, 'PPL', 'P'),
(144267, 'Nottingham Square', 43.1030616760254, 0.752290343936828, -71.1111068725586, -1.24112294966372, 218, 36, 'PPL', 'P'),
(49938, 'Nottingham Village', 39.3758316040039, 0.687237907200708, -77.1294403076172, -1.34616268358835, 218, 25, 'PPL', 'P'),
(49940, 'Nottingham Woods', 38.3899993896484, 0.670031889187979, -75.5527801513672, -1.31864477267678, 218, 25, 'PPL', 'P'),
(96628, 'Nottingham Woods', 31.3419399261475, 0.547020045673542, -95.4463882446289, -1.66585373400559, 218, 51, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(120841, 'Nottingham Woods', 41.829719543457, 0.730066331219144, -88.4652786254883, -1.54401038570893, 218, 18, 'PPL', 'P'),
(49941, 'Nottinghamshire Farms', 39.651668548584, 0.692052170082272, -76.5819396972656, -1.33660699528103, 218, 25, 'PPL', 'P'),
(56603, 'Nottinghill', 36.6683311462402, 0.639983109713478, -92.5744400024414, -1.61572878123255, 218, 29, 'PPL', 'P'),
(104780, 'Nottoway Court House', 37.1305618286133, 0.648050557024628, -78.0769424438477, -1.36269971553525, 218, 53, 'PPL', 'P'),
(195397, 'Notus', 43.7255592346191, 0.763154975919916, -116.800277709961, -2.03854941328256, 218, 17, 'PPL', 'P'),
(89503, 'Nough', 35.8819389343262, 0.626257976403537, -83.0105590820313, -1.44880756990273, 218, 50, 'PPL', 'P'),
(195398, 'Nounan', 42.4777793884277, 0.741377109263847, -111.45027923584, -1.94517432493248, 218, 17, 'PPL', 'P'),
(172364, 'Nourses Corner', 44.5547218322754, 0.777626593283406, -73.1913909912109, -1.27743075691115, 218, 55, 'PPL', 'P'),
(78863, 'Nova', 39.7316703796387, 0.6934484654418, -77.8197174072266, -1.35821029172765, 218, 45, 'PPL', 'P'),
(177400, 'Nova', 41.0288887023926, 0.716089196291054, -82.3047180175781, -1.43648831933224, 218, 41, 'PPL', 'P'),
(202444, 'Novak', 44.2163887023926, 0.771721566198374, -103.551391601563, -1.80731272846927, 218, 49, 'PPL', 'P'),
(120842, 'Novak Park', 41.9588890075684, 0.732320763660924, -88.3177795410156, -1.54143604104121, 218, 18, 'PPL', 'P'),
(208291, 'Novara', 46.8758316040039, 0.818137601100283, -119.152496337891, -2.07960337306668, 218, 56, 'PPL', 'P'),
(197169, 'Novary (historical)', 47.0625, 0.821395579219831, -109.037498474121, -1.90306335651171, 218, 31, 'PPL', 'P'),
(183725, 'Novato', 38.1074981689453, 0.665101312745806, -122.56861114502, -2.13922582407721, 218, 6, 'PPL', 'P'),
(139372, 'Novelty', 40.0125007629395, 0.698349880270037, -92.2080612182617, -1.60933426513916, 218, 29, 'PPL', 'P'),
(156885, 'Novelty', 41.4947204589844, 0.72421949420393, -81.3408279418945, -1.41966526388426, 218, 41, 'PPL', 'P'),
(208290, 'Novelty', 47.709171295166, 0.832682122498614, -121.983329772949, -2.12901073708399, 218, 56, 'PPL', 'P'),
(195399, 'Novene', 42.4972190856934, 0.741716395986723, -111.412498474121, -1.94451492624657, 218, 17, 'PPL', 'P'),
(183726, 'Noverd', 38.0911102294922, 0.664815289244732, -121.686668395996, -2.12383301929266, 218, 6, 'PPL', 'P'),
(132361, 'Novi', 42.4805603027344, 0.741425645374714, -83.4755630493164, -1.45692342016669, 218, 27, 'PPL', 'P'),
(96630, 'Novice', 33.7880592346191, 0.589712881502979, -95.3847198486328, -1.66477741745103, 218, 51, 'PPL', 'P'),
(139371, 'Novinger', 40.2319412231445, 0.702179838812707, -92.7083282470703, -1.61806557193104, 218, 29, 'PPL', 'P'),
(96631, 'Novohrad', 29.6055603027344, 0.516714504180444, -97.0486068725586, -1.69381772439974, 218, 51, 'PPL', 'P'),
(104783, 'Novum', 38.4836082458496, 0.671665671937715, -78.1897201538086, -1.36466805789693, 218, 53, 'PPL', 'P'),
(76753, 'Nowata', 36.7005615234375, 0.64054563591473, -95.6377792358398, -1.66919413696087, 218, 42, 'PPL', 'P'),
(17327, 'Nowatney', 28.0736103057861, 0.48997693275778, -82.4469375610352, -1.43897051862625, 218, 12, 'PPL', 'P'),
(175615, 'Nowell (historical)', 44.4894409179688, 0.776487226390043, -88.7980575561523, -1.54981847373029, 218, 57, 'PPL', 'P'),
(104782, 'Noweta Gardens', 37.2272186279297, 0.649737536417139, -77.4552764892578, -1.3518495977801, 218, 53, 'PPL', 'P'),
(76756, 'Nowhere', 35.1591682434082, 0.613643248110104, -98.4419403076172, -1.71813598041964, 218, 42, 'PPL', 'P'),
(202445, 'Nowlin', 44.0497207641602, 0.768812661918707, -101.302223205566, -1.76805733452734, 218, 49, 'PPL', 'P'),
(23490, 'Nowlin Estates', 34.086669921875, 0.594924621177237, -84.603889465332, -1.47661643116339, 218, 13, 'PPL', 'P'),
(23487, 'Nowlin Station', 34.084171295166, 0.594881011914387, -84.5713882446289, -1.4760491778512, 218, 13, 'PPL', 'P'),
(23488, 'Nowlin Woods', 34.0422210693359, 0.594148842351697, -84.6444396972656, -1.47732416622308, 218, 13, 'PPL', 'P'),
(165401, 'Nowrytown', 40.5311088562012, 0.707401299024943, -79.4302825927734, -1.38631995703343, 218, 45, 'PPL', 'P'),
(177360, 'Nowthen', 45.3280601501465, 0.791123893162091, -93.4700012207031, -1.63135927314439, 218, 28, 'PPL', 'P'),
(56605, 'Noxall', 36.7224998474121, 0.640928531900457, -89.5777816772461, -1.56342722690059, 218, 29, 'PPL', 'P'),
(61112, 'Noxapater', 32.9922218322754, 0.575822898521562, -89.0661087036133, -1.55449684881723, 218, 30, 'PPL', 'P'),
(10868, 'Noxburn', 36.1083297729492, 0.63020924193386, -90.4813919067383, -1.57919820055993, 218, 4, 'PPL', 'P'),
(165402, 'Noxen', 41.4213905334473, 0.722939645563065, -76.0588912963867, -1.32747807853841, 218, 45, 'PPL', 'P'),
(864, 'Noxie', 36.9713897705078, 0.645272480533512, -95.7322235107422, -1.67084250051758, 218, 42, 'PPL', 'P'),
(10866, 'Noxobe', 33.1452789306641, 0.578494248831993, -93.1041717529297, -1.62497434443092, 218, 4, 'PPL', 'P'),
(151312, 'Noxon', 41.6427803039551, 0.726803625988661, -73.815559387207, -1.28832455050817, 218, 40, 'PPL', 'P'),
(197170, 'Noxon', 47.9961090087891, 0.837690130349481, -115.780563354492, -2.02075204034978, 218, 31, 'PPL', 'P'),
(96638, 'Noxville', 30.389720916748, 0.530400688759443, -99.4669418334961, -1.73602563188419, 218, 51, 'PPL', 'P'),
(151310, 'Noyack', 40.9955596923828, 0.715507495329954, -72.341667175293, -1.26260027859077, 218, 40, 'PPL', 'P'),
(137221, 'Noyes', 48.997501373291, 0.855167724214371, -97.2041702270508, -1.69653281713108, 218, 28, 'PPL', 'P'),
(137222, 'Noyes Junction', 47.7947196960449, 0.834175223763767, -96.6052780151367, -1.68608017616863, 218, 28, 'PPL', 'P'),
(144269, 'Noyes Terrace', 42.7544403076172, 0.746205753215297, -71.2033309936523, -1.24273256422656, 218, 36, 'PPL', 'P'),
(183727, 'Noyo', 39.4283294677734, 0.68815416777375, -123.802223205566, -2.16075641622606, 218, 6, 'PPL', 'P'),
(165406, 'Nuangola', 41.1549987792969, 0.718290232352978, -75.9786071777344, -1.32607685633086, 218, 45, 'PPL', 'P'),
(165408, 'Nuangola Station', 41.149169921875, 0.718188499599337, -75.945556640625, -1.32550001563875, 218, 45, 'PPL', 'P'),
(42350, 'Nuba', 30.5872192382813, 0.53384768473736, -92.0702819824219, -1.60692956383287, 218, 22, 'PPL', 'P'),
(17328, 'Nubbin Ridge', 30.8402805328369, 0.538264437536715, -86.6747207641602, -1.51275925558129, 218, 12, 'PPL', 'P'),
(23489, 'Nuberg', 34.2644386291504, 0.598027270426207, -82.8949966430664, -1.44679062485116, 218, 13, 'PPL', 'P'),
(89504, 'Nubia', 36.6352806091309, 0.639406269021367, -86.3627777099609, -1.50731482220679, 218, 50, 'PPL', 'P'),
(151311, 'Nubia', 42.5858306884766, 0.74326296021076, -76.2897186279297, -1.33150677547742, 218, 40, 'PPL', 'P'),
(193823, 'Nubieber', 41.0958290100098, 0.717257525061272, -121.181938171387, -2.11502381503889, 218, 6, 'PPL', 'P'),
(212053, 'Nuchek', 60.3333282470703, 1.05301522659788, -146.6552734375, -2.55961738689696, 218, 1, 'PPL', 'P'),
(10867, 'Nuckles', 35.5677795410156, 0.6207748606142, -91.3572235107422, -1.59448434574282, 218, 4, 'PPL', 'P'),
(110703, 'Nuckolls', 38.0924987792969, 0.664839524010651, -81.3913879394531, -1.42054770231146, 218, 58, 'PPL', 'P'),
(4653, 'Nuckols', 32.3380584716797, 0.564405594033256, -85.0547180175781, -1.48448487376208, 218, 2, 'PPL', 'P'),
(37464, 'Nuckols', 37.5233306884766, 0.654905666828547, -87.1122207641602, -1.52039507105877, 218, 21, 'PPL', 'P'),
(104784, 'Nuckols', 37.5938911437988, 0.656137179095627, -78.3216705322266, -1.36697102644957, 218, 53, 'PPL', 'P'),
(195400, 'Nuckols', 47.5188903808594, 0.829361094040258, -115.936943054199, -2.02348138099295, 218, 17, 'PPL', 'P'),
(187122, 'Nucla', 38.2694396972656, 0.667927725610707, -108.547218322754, -1.89450635361317, 218, 7, 'PPL', 'P'),
(96633, 'Nueces', 27.8138904571533, 0.485443966266356, -97.461669921875, -1.70102703462864, 218, 51, 'PPL', 'P'),
(96634, 'Nueces Bay Colonia', 27.8850002288818, 0.48668506591336, -97.3420028686523, -1.69893845054375, 218, 51, 'PPL', 'P'),
(96635, 'Nueces Bayfront Colonia', 27.8850002288818, 0.48668506591336, -97.3440017700195, -1.69897333795403, 218, 51, 'PPL', 'P'),
(96636, 'Nueces Campsite Lots Colonia', 28.7880001068115, 0.50244538692834, -99.8190002441406, -1.74217021030928, 218, 51, 'PPL', 'P'),
(117079, 'Nuel (historical)', 42.6261100769043, 0.743965968159513, -93.9644393920898, -1.63998884718263, 218, 16, 'PPL', 'P'),
(183729, 'Nuestro', 39.1838912963867, 0.683887916865498, -121.661109924316, -2.12338693981007, 218, 6, 'PPL', 'P'),
(183730, 'Nuevo', 33.8013916015625, 0.589945575203225, -117.144996643066, -2.04456589365921, 218, 6, 'PPL', 'P'),
(96639, 'Nuevo Alton Colonia', 26.2950000762939, 0.45893432814349, -98.3099975585938, -1.71583314502505, 218, 51, 'PPL', 'P'),
(96640, 'Nuevo Penitas Colonia', 26.2409992218018, 0.45799183543371, -98.4400024414063, -1.7181021582738, 218, 51, 'PPL', 'P'),
(183731, 'Nuga (historical)', 36.8938903808594, 0.643919861015861, -121.793609619141, -2.12569949574264, 218, 6, 'PPL', 'P'),
(17329, 'Nugalla (historical)', 30.0333309173584, 0.524180509848913, -83.8166732788086, -1.46287691678356, 218, 12, 'PPL', 'P'),
(42351, 'Nugent', 30.8630599975586, 0.538662014197951, -91.9561080932617, -1.60493685354722, 218, 22, 'PPL', 'P'),
(61115, 'Nugent', 30.4702796936035, 0.53180670465695, -89.1036071777344, -1.55515132065512, 218, 30, 'PPL', 'P'),
(96641, 'Nugent', 32.6938896179199, 0.570616019116294, -99.6672210693359, -1.73952116397298, 218, 51, 'PPL', 'P'),
(117080, 'Nugent', 41.2061080932617, 0.7191822581601, -92.1897201538086, -1.60901415317613, 218, 16, 'PPL', 'P'),
(37465, 'Nugent Crossroads', 38.1233291625977, 0.665377615708902, -84.6986083984375, -1.47826958841006, 218, 21, 'PPL', 'P'),
(71190, 'Nugentown', 39.6113891601563, 0.691349162133518, -74.355827331543, -1.29775400497981, 218, 37, 'PPL', 'P'),
(208292, 'Nugents Corner', 48.8436088562012, 0.852481793096972, -122.28694152832, -2.13430976186298, 218, 56, 'PPL', 'P'),
(187123, 'Nugget', 39.8636093139648, 0.695751234257365, -105.587783813477, -1.84285447742914, 218, 7, 'PPL', 'P'),
(201324, 'Nugget (historical)', 43.0416717529297, 0.751218887651262, -123.074996948242, -2.1480639236288, 218, 43, 'PPL', 'P'),
(10869, 'Nugulf', 33.2491683959961, 0.580307462060174, -92.6316680908203, -1.61672759979938, 218, 4, 'PPL', 'P'),
(212054, 'Nuiqsut', 70.2174987792969, 1.22552654621383, -150.97639465332, -2.6350351794908, 218, 1, 'PPL', 'P'),
(212055, 'Nulato', 64.7194366455078, 1.12956725949999, -158.103057861328, -2.75941891715128, 218, 1, 'PPL', 'P'),
(208293, 'Nulls Crossing', 46.7063903808594, 0.815180293867804, -122.861106872559, -2.14433083757078, 218, 56, 'PPL', 'P'),
(30700, 'Nulltown', 39.579719543457, 0.690796423049272, -85.158332824707, -1.4862932933003, 218, 19, 'PPL', 'P'),
(30701, 'Numa', 39.6308288574219, 0.691688448856394, -87.3702774047852, -1.52489900909431, 218, 19, 'PPL', 'P'),
(42352, 'Numa', 29.9766693115234, 0.523191578267626, -91.8916702270508, -1.60381220061888, 218, 22, 'PPL', 'P'),
(76757, 'Numa', 36.8033294677734, 0.642339274908899, -97.605827331543, -1.7035430560685, 218, 42, 'PPL', 'P'),
(117082, 'Numa', 40.688060760498, 0.710140626522199, -92.977783203125, -1.62276844810001, 218, 16, 'PPL', 'P'),
(56606, 'Number Eight', 39.7316703796387, 0.6934484654418, -92.5611114501953, -1.61549615411133, 218, 29, 'PPL', 'P'),
(151313, 'Number Four', 43.8655586242676, 0.765598426220063, -75.1811065673828, -1.31215784489356, 218, 40, 'PPL', 'P'),
(10870, 'Number Nine', 35.9877815246582, 0.628105278093671, -89.807502746582, -1.56743661592171, 218, 4, 'PPL', 'P'),
(37466, 'Number One', 36.8108291625977, 0.642470169276476, -84.8683319091797, -1.48123182249055, 218, 21, 'PPL', 'P'),
(200100, 'Number One Settlement', 41.9905586242676, 0.73287350274517, -116.13111114502, -2.02687025348007, 218, 39, 'PPL', 'P'),
(197171, 'Number Seven', 47.4036102294922, 0.827349075836703, -111.151107788086, -1.93995279814121, 218, 31, 'PPL', 'P'),
(23500, 'Number Ten (historical)', 32.8383293151855, 0.573136967404163, -82.2822189331055, -1.43609563622951, 218, 13, 'PPL', 'P'),
(165409, 'Number Thirty-Seven', 40.2511100769043, 0.702514398424648, -78.8600006103516, -1.37636665877537, 218, 45, 'PPL', 'P'),
(165411, 'Numidia', 40.8805618286133, 0.713500403974416, -76.4024963378906, -1.3334751178391, 218, 45, 'PPL', 'P'),
(210798, 'Numila', 21.9016704559326, 0.382256261142792, -159.559722900391, -2.78484251818161, 218, 15, 'PPL', 'P'),
(165405, 'NuMine', 40.7961082458496, 0.712026410890084, -79.283332824707, -1.38375519974563, 218, 45, 'PPL', 'P'),
(71191, 'Nummytown', 39.0250015258789, 0.681114767222398, -74.8966674804688, -1.30719344630555, 218, 37, 'PPL', 'P'),
(212056, 'Nunachuak', 59.5966682434082, 1.04015808406622, -157.058334350586, -2.74118505211583, 218, 1, 'PPL', 'P'),
(212058, 'Nunachuk', 60.938060760498, 1.06356980005105, -162.582778930664, -2.83760479938215, 218, 1, 'PPL', 'P'),
(212057, 'Nunaka Valley', 61.2066688537598, 1.06825789567597, -149.768325805664, -2.61395040050843, 218, 1, 'PPL', 'P'),
(212059, 'Nunam Iqua', 62.5336112976074, 1.09141741030557, -164.841110229492, -2.87702011614754, 218, 1, 'PPL', 'P'),
(212060, 'Nunapitchuk', 60.8969383239746, 1.06285207813727, -162.459442138672, -2.83545216627304, 218, 1, 'PPL', 'P'),
(212061, 'Nunapitsinchak', 60.7955589294434, 1.06108267390903, -161.375564575195, -2.81653493410188, 218, 1, 'PPL', 'P'),
(151314, 'Nunda', 42.5794410705566, 0.743151440340113, -77.9427795410156, -1.3603581311468, 218, 40, 'PPL', 'P'),
(156886, 'Nunda', 40.5352783203125, 0.70747406990173, -82.3602828979492, -1.43745810944319, 218, 41, 'PPL', 'P'),
(170976, 'Nunda', 44.1622200012207, 0.770776144011395, -97.0186080932617, -1.69329414692943, 218, 49, 'PPL', 'P'),
(23491, 'Nunez', 32.4911117553711, 0.56707687776466, -82.3472213745117, -1.43723014285388, 218, 13, 'PPL', 'P'),
(42353, 'Nunez', 29.9911098480225, 0.523443613175288, -92.2286071777344, -1.60969285977994, 218, 22, 'PPL', 'P'),
(132365, 'Nunica', 43.079719543457, 0.751882946869074, -86.0672225952148, -1.50215641233336, 218, 27, 'PPL', 'P'),
(10872, 'Nunley', 34.5405616760254, 0.602846526734814, -94.1600036621094, -1.64340208759373, 218, 4, 'PPL', 'P'),
(37467, 'Nunn', 37.4275016784668, 0.65323313508495, -87.9700012207031, -1.5353661642847, 218, 21, 'PPL', 'P'),
(194349, 'Nunn', 40.7036094665527, 0.710412002637278, -104.780281066895, -1.82876089578239, 218, 7, 'PPL', 'P'),
(96642, 'Nunnelee', 33.6163902282715, 0.586716692118586, -96.2213897705078, -1.67938006234015, 218, 51, 'PPL', 'P'),
(89505, 'Nunnelly', 35.8594398498535, 0.625865293300805, -87.4691696166992, -1.52662500379679, 218, 50, 'PPL', 'P'),
(78864, 'Nunnery', 39.7900009155273, 0.69446652534751, -77.5788879394531, -1.35400702457918, 218, 45, 'PPL', 'P'),
(205161, 'Nunns', 40.336109161377, 0.703997912309877, -111.610557556152, -1.94797170934149, 218, 52, 'PPL', 'P'),
(165410, 'Nuremberg', 40.9394416809082, 0.71452805126005, -76.1719436645508, -1.32945121459005, 218, 45, 'PPL', 'P'),
(96643, 'Nurillo', 26.2666702270508, 0.458439878997603, -98.1211090087891, -1.71253641791164, 218, 51, 'PPL', 'P'),
(110705, 'Nuriva', 37.5974998474121, 0.656200162855407, -81.3816680908203, -1.42037805895002, 218, 58, 'PPL', 'P'),
(17330, 'Nurmi Isles', 26.1222190856934, 0.455918730972652, -80.1172180175781, -1.39830924194486, 218, 12, 'PPL', 'P'),
(104785, 'Nurney', 36.642219543457, 0.639527376271939, -76.6141662597656, -1.33716945490326, 218, 53, 'PPL', 'P'),
(104786, 'Nurneysville', 36.6558303833008, 0.639764930241174, -76.6377792358398, -1.33758157908195, 218, 53, 'PPL', 'P'),
(96644, 'Nursery', 28.9233303070068, 0.504807344499132, -97.0983276367188, -1.69468551544095, 218, 51, 'PPL', 'P'),
(82688, 'Nursery (historical)', 34.9130592346191, 0.609347835587916, -82.3222198486328, -1.43679378390927, 218, 48, 'PPL', 'P'),
(49945, 'Nursery View', 39.3555603027344, 0.686884106249891, -77.1202774047852, -1.34600276076489, 218, 25, 'PPL', 'P'),
(212062, 'Nushagak', 58.9480590820313, 1.02883771864159, -158.492218017578, -2.76621104319542, 218, 1, 'PPL', 'P'),
(113853, 'Nut Plains', 41.3244400024414, 0.721247539585456, -72.6847229003906, -1.26858773051154, 218, 8, 'PPL', 'P'),
(17331, 'Nutall Rise', 30.1502799987793, 0.526221656376891, -83.9641723632813, -1.46545126145129, 218, 12, 'PPL', 'P'),
(89506, 'Nutbush', 35.6980590820313, 0.62304866755291, -89.4080581665039, -1.5604649928201, 218, 50, 'PPL', 'P'),
(104789, 'Nutbush', 37.0447196960449, 0.646552329174377, -78.2766723632813, -1.36618566024411, 218, 53, 'PPL', 'P'),
(49943, 'Nutcracker Point', 38.8061103820801, 0.677294396059652, -76.2861099243164, -1.33144379171764, 218, 25, 'PPL', 'P'),
(145937, 'Nutley', 40.8222198486328, 0.712482144331624, -74.1602783203125, -1.29434103088482, 218, 37, 'PPL', 'P'),
(205162, 'Nutree West', 40.6208305358887, 0.70896723774591, -111.801391601563, -1.9513023917588, 218, 52, 'PPL', 'P'),
(187124, 'Nutria', 37.2308311462402, 0.649800586755947, -107.125, -1.86968396119893, 218, 7, 'PPL', 'P'),
(178731, 'Nutrioso', 33.9530601501465, 0.592592690747736, -109.208610534668, -1.90604982535812, 218, 5, 'PPL', 'P'),
(189130, 'Nutt', 32.5727806091309, 0.568502268159098, -107.448890686035, -1.87533692008678, 218, 38, 'PPL', 'P'),
(110706, 'Nuttalburg (historical)', 38.0499992370605, 0.664097767068037, -81.0405578613281, -1.41442456233315, 218, 58, 'PPL', 'P'),
(104787, 'Nuttall', 37.4324989318848, 0.65332035361065, -76.4805603027344, -1.33483759105279, 218, 53, 'PPL', 'P'),
(144271, 'Nutter', 44.144718170166, 0.770470679434363, -71.9452819824219, -1.25568205186901, 218, 36, 'PPL', 'P'),
(128398, 'Nutter Corner', 44.9208297729492, 0.784016382265861, -69.3555603027344, -1.21048288184819, 218, 26, 'PPL', 'P'),
(110707, 'Nutter Farm', 39.2408294677734, 0.684881675426261, -81.2249984741211, -1.41764365830078, 218, 58, 'PPL', 'P'),
(110708, 'Nutter Fort', 39.2633285522461, 0.685274358528993, -80.3199996948242, -1.40184844987552, 218, 58, 'PPL', 'P'),
(110709, 'Nutterville', 38.0875015258789, 0.664752305484951, -80.8141708374023, -1.41047336338185, 218, 58, 'PPL', 'P'),
(175616, 'Nutterville', 45.0038909912109, 0.785466074005245, -89.5272216796875, -1.5625447884734, 218, 57, 'PPL', 'P'),
(125700, 'Nutting Lake', 42.5377807617188, 0.742424330783494, -71.2694396972656, -1.24388637876884, 218, 23, 'PPL', 'P'),
(144272, 'Nuttings Beach', 43.6624984741211, 0.762054358020413, -71.7905578613281, -1.25298160652367, 218, 36, 'PPL', 'P'),
(104788, 'Nuttree (historical)', 37.4249992370605, 0.653189459243072, -77.658332824707, -1.35539359940073, 218, 53, 'PPL', 'P'),
(10871, 'Nutts', 34.1988906860352, 0.596883243000936, -93.4613876342773, -1.63120893770085, 218, 4, 'PPL', 'P'),
(104790, 'Nuttsville', 37.7933311462402, 0.659618063798415, -76.5511093139648, -1.33606890358278, 218, 53, 'PPL', 'P'),
(23492, 'Nutview (historical)', 31.6322193145752, 0.552086376752281, -84.1138916015625, -1.46806435511287, 218, 13, 'PPL', 'P'),
(49944, 'Nutwell', 38.7797203063965, 0.676833802349123, -76.5763931274414, -1.33651018937541, 218, 25, 'PPL', 'P'),
(28087, 'Nutwood', 39.0847206115723, 0.682157061894028, -90.5558319091797, -1.58049742369773, 218, 18, 'PPL', 'P'),
(123339, 'Nutwood', 41.5938911437988, 0.7259503491754, -86.2819366455078, -1.50590387946126, 218, 19, 'PPL', 'P'),
(156887, 'Nutwood', 41.3111114501953, 0.721014912464238, -80.6363906860352, -1.4073705143958, 218, 41, 'PPL', 'P'),
(177675, 'Nutwood', 33.8069381713867, 0.590042381108849, -117.949172973633, -2.0586014183942, 218, 6, 'PPL', 'P'),
(210796, 'Nuu (historical)', 20.6319408416748, 0.360095298763915, -156.186386108398, -2.72596668438269, 218, 15, 'PPL', 'P'),
(191955, 'Nuway', 31.937219619751, 0.557409636297186, -106.597221374512, -1.8604724864625, 218, 51, 'PPL', 'P'),
(191956, 'Nuway Addition Colonia', 31.9349994659424, 0.557370887303325, -106.599998474121, -1.86052095599434, 218, 51, 'PPL', 'P'),
(76759, 'Nuyaka', 35.6530609130859, 0.622263301347445, -96.1394424438477, -1.67794981167673, 218, 42, 'PPL', 'P'),
(110710, 'Nuzums', 38.915828704834, 0.679209342041474, -81.7069396972656, -1.42605511944574, 218, 58, 'PPL', 'P'),
(212063, 'Nyac', 61.0041694641113, 1.06472361459333, -159.940567016602, -2.79148950194634, 218, 1, 'PPL', 'P'),
(151316, 'Nyack', 41.0905609130859, 0.717165579424637, -73.918327331543, -1.29011818950234, 218, 40, 'PPL', 'P'),
(197172, 'Nyack', 48.4394416809082, 0.845427745159625, -113.804718017578, -1.98626703371045, 218, 31, 'PPL', 'P'),
(190559, 'Nyala', 38.2488899230957, 0.667569064390901, -115.727783203125, -2.01983085292872, 218, 39, 'PPL', 'P'),
(187125, 'Nyberg', 38.2683296203613, 0.667908351113777, -104.397499084473, -1.82208008987181, 218, 7, 'PPL', 'P'),
(96645, 'Nye', 27.559440612793, 0.481002978701081, -99.5066680908203, -1.73671898587399, 218, 51, 'PPL', 'P'),
(110711, 'Nye', 38.3358306884766, 0.669086467001001, -82.0369415283203, -1.43181473793526, 218, 58, 'PPL', 'P'),
(175617, 'Nye', 45.3144416809082, 0.790886206034802, -92.5802764892578, -1.61583064714425, 218, 57, 'PPL', 'P'),
(197173, 'Nye', 45.4355583190918, 0.793000090150052, -109.808326721191, -1.91651684739046, 218, 31, 'PPL', 'P'),
(201325, 'Nye', 45.4605598449707, 0.793436449094662, -118.978889465332, -2.07657336153644, 218, 43, 'PPL', 'P'),
(128399, 'Nyes Corner', 44.6533317565918, 0.77934766113787, -69.6186065673828, -1.21507390525138, 218, 26, 'PPL', 'P'),
(30702, 'Nyesville', 39.7844390869141, 0.694369453125777, -87.1744384765625, -1.52148097499325, 218, 19, 'PPL', 'P'),
(165412, 'Nyesville', 40.0294418334961, 0.698645557730063, -77.6230621337891, -1.35477800971475, 218, 45, 'PPL', 'P'),
(56607, 'Nyhart', 38.2041702270508, 0.666788558454426, -94.4333267211914, -1.64817247489633, 218, 29, 'PPL', 'P'),
(183733, 'Nyland', 34.2255592346191, 0.597348696980454, -119.134170532227, -2.07928352741976, 218, 6, 'PPL', 'P'),
(117083, 'Nyman', 40.8808288574219, 0.713505064506323, -95.20361328125, -1.66161651155321, 218, 16, 'PPL', 'P'),
(4654, 'Nymph', 31.3380603790283, 0.546952334802826, -86.9397201538086, -1.51738436744643, 218, 2, 'PPL', 'P'),
(4655, 'Nyota', 33.8499984741211, 0.59079392516847, -86.7452774047852, -1.51399070126934, 218, 2, 'PPL', 'P'),
(56608, 'Nyssa', 36.639720916748, 0.639483767009089, -90.2425003051758, -1.57502875555731, 218, 29, 'PPL', 'P'),
(201326, 'Nyssa', 43.8769416809082, 0.765797098037383, -116.99388885498, -2.04192856523171, 218, 43, 'PPL', 'P'),
(201327, 'Nyssa Heights', 43.8944396972656, 0.766102496035388, -117.025001525879, -2.04247158377798, 218, 43, 'PPL', 'P'),
(142553, 'Nysted', 41.1344413757324, 0.717931437975117, -98.6141662597656, -1.72114189034201, 218, 35, 'PPL', 'P'),
(96646, 'O and J Colonia', 26.1040000915527, 0.455600749538496, -97.9560012817383, -1.70965474445412, 218, 51, 'PPL', 'P'),
(23493, 'O Neal', 31.4002799987793, 0.54803827202682, -81.936393737793, -1.43005984793495, 218, 13, 'PPL', 'P'),
(37468, 'O''Bannon', 38.2886085510254, 0.668262285222648, -85.5136108398438, -1.49249406442439, 218, 21, 'PPL', 'P'),
(17333, 'O''Brien', 30.0380592346191, 0.524263034553192, -82.9402770996094, -1.44758091790464, 218, 12, 'PPL', 'P'),
(33462, 'O''Brien', 38.5133285522461, 0.672184389139035, -95.0277786254883, -1.65854761787106, 218, 20, 'PPL', 'P'),
(96647, 'O''Brien', 33.3800010681152, 0.582590922957835, -99.8433303833008, -1.74259485134509, 218, 51, 'PPL', 'P'),
(193216, 'O''Brien', 42.0675010681152, 0.734216401724842, -123.701942443848, -2.15900618675766, 218, 43, 'PPL', 'P'),
(193256, 'O''Brien', 47.4124984741211, 0.827504204970201, -122.235832214355, -2.13341773605585, 218, 56, 'PPL', 'P'),
(193824, 'O''Brien', 40.8122215270996, 0.712307640701196, -122.323059082031, -2.134940132093, 218, 6, 'PPL', 'P'),
(110712, 'O''Brien (historical)', 39.0522193908691, 0.681589808581841, -80.0313873291016, -1.39681121383169, 218, 58, 'PPL', 'P'),
(125701, 'O''Briens Corner', 42.0875015258789, 0.734565475564724, -72.6402816772461, -1.26781208484405, 218, 23, 'PPL', 'P'),
(110713, 'O''Brion', 38.5752792358398, 0.673265632541607, -80.9619369506836, -1.41305236858149, 218, 58, 'PPL', 'P'),
(73736, 'O''Bryonsville', 39.1322212219238, 0.682986103941369, -84.4611129760742, -1.4741245113314, 218, 41, 'PPL', 'P'),
(96648, 'O''Canas Family Colonia', 26.2150001525879, 0.457538066073475, -97.8300018310547, -1.70745563918399, 218, 51, 'PPL', 'P'),
(89507, 'O''Conner', 36.0180587768555, 0.62863371583297, -85.5058288574219, -1.49235824320879, 218, 50, 'PPL', 'P'),
(142554, 'O''Connor', 41.5105590820313, 0.72449593032508, -98.4736099243164, -1.71868871950389, 218, 35, 'PPL', 'P'),
(156889, 'O''Connor Point', 40.4966697692871, 0.706800223566913, -83.8522186279297, -1.4634973001595, 218, 41, 'PPL', 'P'),
(49973, 'O''Donnell', 39.2522201538086, 0.685080480401635, -76.8636093139648, -1.34152305749527, 218, 25, 'PPL', 'P'),
(165413, 'O''Donnell', 41.0961112976074, 0.717262451909289, -78.9383316040039, -1.37773379252096, 218, 45, 'PPL', 'P'),
(191957, 'O''Donnell', 32.9636116027832, 0.575323555817172, -101.832221984863, -1.77730755825762, 218, 51, 'PPL', 'P'),
(10873, 'O''Donnell Bend', 35.7969398498535, 0.624774462518308, -89.8033294677734, -1.56736377846589, 218, 4, 'PPL', 'P'),
(49946, 'O''Donnell Heights', 39.2761116027832, 0.685497464849314, -76.5419387817383, -1.33590884760127, 218, 25, 'PPL', 'P'),
(96649, 'O''Donnell Place', 28.4458293914795, 0.496473381341892, -97.3322219848633, -1.69876774191787, 218, 51, 'PPL', 'P'),
(28088, 'O''Fallon', 38.5922203063965, 0.673561310001634, -89.9111099243164, -1.56924490230187, 218, 18, 'PPL', 'P'),
(56609, 'O''Fallon', 38.8105583190918, 0.677372027205428, -90.6997222900391, -1.58300878460567, 218, 29, 'PPL', 'P'),
(199576, 'O''Fallons', 41.1602783203125, 0.718382377726694, -101.076667785645, -1.76412064980398, 218, 35, 'PPL', 'P'),
(96650, 'O''Farrell', 33.124439239502, 0.578130527606116, -94.320556640625, -1.64620426569271, 218, 51, 'PPL', 'P'),
(96651, 'O''Farrell Acres Number 1 Colonia', 28.0179996490479, 0.489006343698501, -97.4899978637695, -1.70152145048502, 218, 51, 'PPL', 'P'),
(96652, 'O''Farrell Acres Number 2 Colonia', 28.0249996185303, 0.489128516213508, -97.5630035400391, -1.70279563990857, 218, 51, 'PPL', 'P'),
(10874, 'O''Kean', 36.1691703796387, 0.631271110839502, -90.8141708374023, -1.58500628858129, 218, 4, 'PPL', 'P'),
(23494, 'O''Leary', 32.2105598449707, 0.562180323205413, -81.1761093139648, -1.41679038148752, 218, 13, 'PPL', 'P'),
(117085, 'O''Leary', 42.7066688537598, 0.745371984057021, -96.0583267211914, -1.67653407524124, 218, 16, 'PPL', 'P'),
(4656, 'O''Neal', 34.851390838623, 0.60827151903336, -87.0416717529297, -1.51916375852877, 218, 2, 'PPL', 'P'),
(10876, 'O''Neal', 35.7763900756836, 0.624415801298502, -91.8594436645508, -1.60324974099666, 218, 4, 'PPL', 'P'),
(82671, 'O''Neal', 35.0072212219238, 0.610991272296603, -82.2811126708984, -1.4360763283116, 218, 48, 'PPL', 'P'),
(104791, 'O''Neal', 38.3461112976074, 0.669265897479445, -78.2677764892578, -1.36603039795256, 218, 53, 'PPL', 'P'),
(42354, 'O''Neal Place', 30.4338893890381, 0.53117157402648, -91.0016708374023, -1.58827878092878, 218, 22, 'PPL', 'P'),
(183734, 'O''Neals', 37.1283302307129, 0.648011608293686, -119.693328857422, -2.08904268123435, 218, 6, 'PPL', 'P'),
(23495, 'O''Neals Crossroad', 33.1941719055176, 0.579347592224282, -85.2236099243164, -1.48743259361464, 218, 13, 'PPL', 'P'),
(17334, 'O''Neil', 30.6172199249268, 0.534371295497183, -81.5144424438477, -1.42269540857255, 218, 12, 'PPL', 'P'),
(61116, 'O''Neil', 31.3036098480225, 0.546351059607714, -90.8844375610352, -1.58623267426327, 218, 30, 'PPL', 'P'),
(132366, 'O''Neil', 44.6413917541504, 0.779139268782571, -85.0738906860352, -1.48481949995305, 218, 27, 'PPL', 'P'),
(200101, 'O''Neil (historical)', 41.7849998474121, 0.72928582528267, -115.014999389648, -2.00739042852863, 218, 39, 'PPL', 'P'),
(201328, 'O''Neil Corners', 45.2708282470703, 0.79012500801623, -122.66056060791, -2.14083064495009, 218, 43, 'PPL', 'P'),
(189131, 'O''Neil Landing', 35.8663902282715, 0.625986600288458, -106.794998168945, -1.86392434270941, 218, 38, 'PPL', 'P'),
(183735, 'O''Neil Place', 39.6988906860352, 0.692876351860624, -122.959167480469, -2.14604231804532, 218, 6, 'PPL', 'P'),
(110714, 'O''Neill', 39.2930603027344, 0.685793275467395, -80.4113922119141, -1.40344355021043, 218, 58, 'PPL', 'P'),
(117086, 'O''Neill', 42.6088905334473, 0.743665430430498, -90.8866729736328, -1.58627168957324, 218, 16, 'PPL', 'P'),
(142558, 'O''Neill', 42.4577789306641, 0.741028035423965, -98.647216796875, -1.72171873103412, 218, 35, 'PPL', 'P'),
(96653, 'O''Quinn', 29.8216705322266, 0.520486339232323, -96.9727783203125, -1.69249426649603, 218, 51, 'PPL', 'P'),
(61117, 'O''Reilly', 33.6672210693359, 0.587603857656718, -90.7291717529297, -1.58352277469606, 218, 30, 'PPL', 'P'),
(23496, 'O''Reily Estates', 32.714168548584, 0.570969953225165, -83.6277770996094, -1.4595800565121, 218, 13, 'PPL', 'P'),
(170981, 'Oacoma', 43.7961082458496, 0.764386288449914, -99.3952789306641, -1.73477487827824, 218, 49, 'PPL', 'P'),
(202448, 'Oahe', 44.4577789306641, 0.775934620463852, -100.530563354492, -1.75458932942064, 218, 49, 'PPL', 'P'),
(4657, 'Oak', 30.3177795410156, 0.529145074884498, -87.7063903808594, -1.53076528718548, 218, 2, 'PPL', 'P'),
(17335, 'Oak', 29.2519397735596, 0.510542661643699, -82.1158294677734, -1.43319159221883, 218, 12, 'PPL', 'P'),
(23497, 'Oak', 30.8877792358398, 0.539093446294543, -83.2761077880859, -1.45344226914779, 218, 13, 'PPL', 'P'),
(28090, 'Oak', 37.5763893127441, 0.655831714518594, -88.5177764892578, -1.54492664628198, 218, 18, 'PPL', 'P'),
(56611, 'Oak', 39.8936080932617, 0.696274811727674, -94.5294418334961, -1.64985000006697, 218, 29, 'PPL', 'P'),
(73737, 'Oak', 39.7411117553711, 0.693613248534249, -80.9397201538086, -1.41266461232677, 218, 41, 'PPL', 'P'),
(132367, 'Oak', 42.3802795410156, 0.739675415906314, -83.2344436645508, -1.45271509301215, 218, 27, 'PPL', 'P'),
(142557, 'Oak', 40.2369384765625, 0.702267057338407, -97.9030609130859, -1.70873076071392, 218, 35, 'PPL', 'P'),
(110715, 'Oak (historical)', 39.1319389343262, 0.682981177093353, -81.6966705322266, -1.42587588870438, 218, 58, 'PPL', 'P'),
(14346, 'Oak Acres', 38.4944381713867, 0.671854689796084, -75.1122207641602, -1.31095556081945, 218, 10, 'PPL', 'P'),
(49947, 'Oak Acres', 39.4061088562012, 0.687766344940007, -77.3233337402344, -1.34954676238551, 218, 25, 'PPL', 'P'),
(110716, 'Oak Acres', 39.2222213745117, 0.684556902931325, -81.6816711425781, -1.42561409996923, 218, 58, 'PPL', 'P'),
(42356, 'Oak Alley', 29.9866695404053, 0.523366115187567, -90.7705612182617, -1.58424515714174, 218, 22, 'PPL', 'P'),
(205178, 'Oak at Wasatch Place', 40.601390838623, 0.708627951023034, -111.793891906738, -1.95117149739122, 218, 52, 'PPL', 'P'),
(151317, 'Oak Beach', 40.6391716003418, 0.709287349708937, -73.2888870239258, -1.27913238368965, 218, 40, 'PPL', 'P'),
(23498, 'Oak Bluff', 31.2208309173584, 0.544906294716346, -81.5361099243164, -1.42307357744735, 218, 13, 'PPL', 'P'),
(125702, 'Oak Bluffs', 41.4541702270508, 0.723511759144241, -70.5625, -1.2315479534385, 218, 23, 'PPL', 'P'),
(193825, 'Oak Bottom (historical)', 40.649169921875, 0.709461853339365, -122.581939697266, -2.13945845119843, 218, 6, 'PPL', 'P'),
(10878, 'Oak Bower', 34.2836112976074, 0.598361896617175, -93.1650009155273, -1.62603601359948, 218, 4, 'PPL', 'P'),
(23499, 'Oak Bower (historical)', 34.3836097717285, 0.600107199237559, -82.8661117553711, -1.4462864884568, 218, 13, 'PPL', 'P'),
(4658, 'Oak Bowery', 32.750560760498, 0.571605117145149, -85.436393737793, -1.49114637175475, 218, 2, 'PPL', 'P'),
(61118, 'Oak Bowery', 31.6191692352295, 0.551858609900052, -89.3891677856445, -1.56013529347715, 218, 30, 'PPL', 'P'),
(61119, 'Oak Bowery (historical)', 31.8908290863037, 0.556599968746775, -89.0933303833008, -1.5549719567557, 218, 30, 'PPL', 'P'),
(120844, 'Oak Brook', 41.8327789306641, 0.730119727599001, -87.9288864135742, -1.53464857552898, 218, 18, 'PPL', 'P'),
(137226, 'Oak Center', 44.353889465332, 0.774121407235671, -92.4002838134766, -1.61268918232239, 218, 28, 'PPL', 'P'),
(175619, 'Oak Center', 43.660831451416, 0.762025262985504, -88.5999984741211, -1.54636169063537, 218, 57, 'PPL', 'P'),
(23501, 'Oak Chase', 34.0227813720703, 0.593809555628821, -84.4000015258789, -1.47305791531483, 218, 13, 'PPL', 'P'),
(67322, 'Oak City', 35.9636116027832, 0.627683433377002, -77.3083267211914, -1.3492848404923, 218, 33, 'PPL', 'P'),
(89508, 'Oak City', 35.898609161377, 0.626548926752628, -83.7027816772461, -1.46088913334593, 218, 50, 'PPL', 'P'),
(192728, 'Oak City', 39.375, 0.687223392972767, -112.334716796875, -1.96061067240085, 218, 52, 'PPL', 'P'),
(96654, 'Oak Cliff', 32.7391700744629, 0.571406312169775, -96.8108291625977, -1.68966772047307, 218, 51, 'PPL', 'P'),
(96655, 'Oak Cliff Acres', 29.8064498901367, 0.520220688913588, -98.5117492675781, -1.71935437661835, 218, 51, 'PPL', 'P'),
(67323, 'Oak Cliffs', 35.3716697692871, 0.617352099402203, -80.4527816772461, -1.40416593265611, 218, 33, 'PPL', 'P'),
(42357, 'Oak Cluster', 30.514720916748, 0.532582350324436, -91.0088882446289, -1.58840474844834, 218, 22, 'PPL', 'P'),
(96656, 'Oak Colonia', 26.3190002441406, 0.459353210093445, -98.0090026855469, -1.71057979345876, 218, 51, 'PPL', 'P'),
(82672, 'Oak Corner', 33.1688919067383, 0.578906373010683, -79.7083282470703, -1.39117276917178, 218, 48, 'PPL', 'P'),
(104792, 'Oak Corner', 37.996940612793, 0.663171719377989, -77.3166732788086, -1.34943051540393, 218, 53, 'PPL', 'P'),
(49948, 'Oak Court', 38.9833297729492, 0.680387457928697, -76.5516662597656, -1.33607862412076, 218, 25, 'PPL', 'P'),
(23502, 'Oak Creek', 33.851390838623, 0.590818226513417, -84.8402786254883, -1.48074220032414, 218, 13, 'PPL', 'P'),
(82675, 'Oak Creek', 34.9313888549805, 0.609667747813861, -81.855827331543, -1.42865369887939, 218, 48, 'PPL', 'P'),
(175618, 'Oak Creek', 42.8858299255371, 0.748498934650937, -87.8630599975586, -1.53349968783472, 218, 57, 'PPL', 'P'),
(178732, 'Oak Creek', 34.7791709899902, 0.607011044889425, -111.762496948242, -1.95062355199694, 218, 5, 'PPL', 'P'),
(192729, 'Oak Creek', 39.6747207641602, 0.692454507143955, -111.433609008789, -1.94488337458338, 218, 52, 'PPL', 'P'),
(194350, 'Oak Creek', 40.2750015258789, 0.702931382872327, -106.957778930664, -1.86676540296031, 218, 7, 'PPL', 'P'),
(201329, 'Oak Creek (historical)', 43.2666702270508, 0.755145851836639, -123.206939697266, -2.15036675902339, 218, 43, 'PPL', 'P'),
(23503, 'Oak Creek Estates', 34.0311088562012, 0.593954897645312, -84.5155563354492, -1.47507472720834, 218, 13, 'PPL', 'P'),
(183736, 'Oak Creek Hills', 38.714168548584, 0.675689708344825, -121.075828552246, -2.11317185281685, 218, 6, 'PPL', 'P'),
(205165, 'Oak Creek Hills', 40.6055603027344, 0.70870072189982, -111.799171447754, -1.95126364276494, 218, 52, 'PPL', 'P'),
(192730, 'Oak Creek Residential Area', 37.2105598449707, 0.649446785805129, -112.986389160156, -1.97198450078436, 218, 52, 'PPL', 'P'),
(49949, 'Oak Crest', 39.0855598449707, 0.682171709280023, -76.8616714477539, -1.34148923534942, 218, 25, 'PPL', 'P'),
(67324, 'Oak Crest', 36.1386108398438, 0.630737746252187, -80.2825012207031, -1.40119397803764, 218, 33, 'PPL', 'P'),
(82677, 'Oak Crest', 33.9902801513672, 0.593242302316634, -81.1647186279297, -1.41659157651215, 218, 48, 'PPL', 'P'),
(4684, 'Oak Crossing', 33.5258293151855, 0.585136106011624, -86.5461120605469, -1.51051461025652, 218, 2, 'PPL', 'P'),
(49950, 'Oak Dale', 39.5541687011719, 0.690350476724738, -76.2927780151367, -1.33156017185728, 218, 25, 'PPL', 'P'),
(89509, 'Oak Dale', 36.4191703796387, 0.635634433969488, -85.2058334350586, -1.48712233534764, 218, 50, 'PPL', 'P'),
(67326, 'Oak Dale Crossroads', 34.4197196960449, 0.600737436309526, -78.8186111450195, -1.37564427632969, 218, 33, 'PPL', 'P'),
(42358, 'Oak Dale Landing', 31.8286094665527, 0.555514031522781, -91.5680618286133, -1.59816416857904, 218, 22, 'PPL', 'P'),
(23504, 'Oak Dale Manor', 33.9305610656738, 0.592200007645004, -84.7897186279297, -1.47985976189694, 218, 13, 'PPL', 'P'),
(14324, 'Oak Drive', 38.5902786254883, 0.673527421276762, -75.3055572509766, -1.31432991907863, 218, 10, 'PPL', 'P'),
(110717, 'Oak Drive Subdivision', 38.8183288574219, 0.67750764868394, -81.3638916015625, -1.42006780068303, 218, 58, 'PPL', 'P'),
(49951, 'Oak Estates', 38.5013885498047, 0.671975996783737, -76.7852783203125, -1.34015592374967, 218, 25, 'PPL', 'P'),
(96658, 'Oak Flat', 31.8022193908691, 0.555053437812252, -94.795280456543, -1.65448975931811, 218, 51, 'PPL', 'P'),
(110718, 'Oak Flat', 38.6594390869141, 0.674734499040841, -79.2130584716797, -1.3825286809056, 218, 58, 'PPL', 'P'),
(10879, 'Oak Flat (historical)', 35.7686080932617, 0.624279980082908, -92.5500030517578, -1.61530227598397, 218, 4, 'PPL', 'P'),
(96659, 'Oak Flats', 31.9472198486328, 0.557584173217127, -94.7666702270508, -1.65399041661372, 218, 51, 'PPL', 'P'),
(4661, 'Oak Forest', 33.6022186279297, 0.586469351032344, -86.7819366455078, -1.51463052572123, 218, 2, 'PPL', 'P'),
(10881, 'Oak Forest', 34.7419395446777, 0.606361233583446, -92.3294372558594, -1.61145267662826, 218, 4, 'PPL', 'P'),
(23506, 'Oak Forest', 33.6355590820313, 0.587051251730527, -84.3944396972656, -1.47296084309309, 218, 13, 'PPL', 'P'),
(30703, 'Oak Forest', 39.3847198486328, 0.687393036334205, -85.0852813720703, -1.48501830492843, 218, 19, 'PPL', 'P'),
(37469, 'Oak Forest', 36.7158317565918, 0.64081215176082, -86.0983276367188, -1.50269929772157, 218, 21, 'PPL', 'P'),
(42359, 'Oak Forest', 29.6313896179199, 0.517165310773967, -90.9327774047852, -1.58707636369661, 218, 22, 'PPL', 'P'),
(49952, 'Oak Forest', 39.2608299255371, 0.685230749266143, -76.7433319091797, -1.33942382076601, 218, 25, 'PPL', 'P'),
(67328, 'Oak Forest', 35.3572196960449, 0.617099898046973, -78.4247207641602, -1.36876959229176, 218, 33, 'PPL', 'P'),
(78865, 'Oak Forest', 39.8419418334961, 0.695373065382573, -80.2391662597656, -1.40043764028805, 218, 45, 'PPL', 'P'),
(82680, 'Oak Forest', 34.9094390869141, 0.609284652091053, -81.9944381713867, -1.43107291441362, 218, 48, 'PPL', 'P'),
(96660, 'Oak Forest', 29.4986095428467, 0.514847861282894, -97.5844421386719, -1.70316981404172, 218, 51, 'PPL', 'P'),
(104795, 'Oak Forest', 37.6752815246582, 0.657557709221075, -77.351936340332, -1.35004597193185, 218, 53, 'PPL', 'P'),
(120845, 'Oak Forest', 41.6027793884277, 0.726105478308897, -87.7438888549805, -1.53141975902337, 218, 18, 'PPL', 'P'),
(14325, 'Oak Forest Estates', 39.1841697692871, 0.683892777134487, -75.70361328125, -1.32127730741432, 218, 10, 'PPL', 'P'),
(14326, 'Oak Forest Mobile Home Park', 38.6294403076172, 0.674210921570531, -75.1722183227539, -1.31200271576007, 218, 10, 'PPL', 'P'),
(23508, 'Oak Forest Mobile Home Park', 33.5708312988281, 0.585921538796115, -83.9613876342773, -1.46540265876139, 218, 13, 'PPL', 'P'),
(49953, 'Oak Forest Park', 39.2619400024414, 0.685250123763073, -76.7480621337891, -1.3395063787598, 218, 25, 'PPL', 'P'),
(183737, 'Oak Gardens Estates', 37.9902801513672, 0.663055472396407, -120.274169921875, -2.09918027023985, 218, 6, 'PPL', 'P'),
(145939, 'Oak Glen', 40.1691703796387, 0.701084280919275, -74.1977767944336, -1.29499550272271, 218, 37, 'PPL', 'P'),
(193826, 'Oak Glen', 40.2825012207031, 0.703062277239905, -123.73999786377, -2.15967037913353, 218, 6, 'PPL', 'P'),
(4674, 'Oak Grove', 33.1916694641113, 0.579303916382405, -86.2994384765625, -1.50620934403829, 218, 2, 'PPL', 'P'),
(10900, 'Oak Grove', 35.1958312988281, 0.614283139141023, -93.2169418334961, -1.62694255363455, 218, 4, 'PPL', 'P'),
(14328, 'Oak Grove', 38.660831451416, 0.674758800385788, -75.706672668457, -1.32133070379418, 218, 10, 'PPL', 'P'),
(17341, 'Oak Grove', 28.5997200012207, 0.499159279169778, -82.0436096191406, -1.43193111807489, 218, 12, 'PPL', 'P'),
(23518, 'Oak Grove', 33.7280616760254, 0.58866572656236, -82.5666732788086, -1.44106030113363, 218, 13, 'PPL', 'P'),
(37471, 'Oak Grove', 37.3441696166992, 0.65177871623463, -86.7547225952148, -1.51415555094082, 218, 21, 'PPL', 'P'),
(42367, 'Oak Grove', 32.8608283996582, 0.573529650506895, -91.3883285522461, -1.59502723113104, 218, 22, 'PPL', 'P'),
(49956, 'Oak Grove', 38.8741683959961, 0.678482232484855, -76.7769393920898, -1.3400103819961, 218, 25, 'PPL', 'P'),
(56614, 'Oak Grove', 37.5727806091309, 0.655768730758814, -90.3947219848633, -1.57768552506077, 218, 29, 'PPL', 'P'),
(61125, 'Oak Grove', 31.0361099243164, 0.541682305190209, -88.9741668701172, -1.5528921611024, 218, 30, 'PPL', 'P'),
(67339, 'Oak Grove', 36.2247200012207, 0.632240634634346, -81.7091674804688, -1.42609400159766, 218, 33, 'PPL', 'P'),
(73738, 'Oak Grove', 39.4486083984375, 0.688508101882621, -81.466667175293, -1.42186157283525, 218, 41, 'PPL', 'P'),
(76763, 'Oak Grove', 36.2052803039551, 0.631901347911469, -96.3377838134766, -1.68141152161966, 218, 42, 'PPL', 'P'),
(82686, 'Oak Grove', 33.3858299255371, 0.582692655711476, -79.4608306884766, -1.38685312188367, 218, 48, 'PPL', 'P'),
(89538, 'Oak Grove', 36.4116706848145, 0.635503539601911, -82.4247207641602, -1.43858276237153, 218, 50, 'PPL', 'P'),
(96668, 'Oak Grove', 32.8213882446289, 0.572841289944137, -95.3447189331055, -1.66407926977127, 218, 51, 'PPL', 'P'),
(104804, 'Oak Grove', 38.1816711425781, 0.666395875351694, -76.9972229003906, -1.34385505450379, 218, 53, 'PPL', 'P'),
(110720, 'Oak Grove', 38.6258316040039, 0.674147937810751, -79.3550033569336, -1.38500608650964, 218, 58, 'PPL', 'P'),
(120847, 'Oak Grove', 41.4105606079102, 0.722750627704697, -90.570556640625, -1.58075441874292, 218, 18, 'PPL', 'P'),
(123340, 'Oak Grove', 41.2877807617188, 0.720607715133565, -86.4861068725586, -1.50946732215784, 218, 19, 'PPL', 'P'),
(125704, 'Oak Grove', 42.4347190856934, 0.740625565204227, -71.0749969482422, -1.24049271259175, 218, 23, 'PPL', 'P'),
(132370, 'Oak Grove', 44.9724998474121, 0.784918195189989, -84.682502746582, -1.477988491757, 218, 27, 'PPL', 'P'),
(137227, 'Oak Grove', 45.3408317565918, 0.791346799745331, -93.3266677856445, -1.62885763277442, 218, 28, 'PPL', 'P'),
(145940, 'Oak Grove', 40.5341682434082, 0.707454695404799, -74.954719543457, -1.30820664594227, 218, 37, 'PPL', 'P'),
(165419, 'Oak Grove', 40.2594413757324, 0.702659807020166, -79.2016677856445, -1.38232987593022, 218, 45, 'PPL', 'P'),
(175621, 'Oak Grove', 43.3861083984375, 0.757230441179898, -88.7455596923828, -1.54890221315725, 218, 57, 'PPL', 'P'),
(178733, 'Oak Grove', 36.1527786254883, 0.6309850207594, -113.583061218262, -1.98239839275295, 218, 5, 'PPL', 'P'),
(183742, 'Oak Grove', 36.4505615234375, 0.636182312784745, -118.791107177734, -2.07329594234093, 218, 6, 'PPL', 'P'),
(187126, 'Oak Grove', 38.4599990844727, 0.671253614338053, -107.92749786377, -1.88369019116192, 218, 7, 'PPL', 'P'),
(189132, 'Oak Grove', 32.6308288574219, 0.569515401216791, -108.344169616699, -1.8909624851506, 218, 38, 'PPL', 'P'),
(201331, 'Oak Grove', 45.6627807617188, 0.796965869908317, -121.587501525879, -2.12210223090022, 218, 43, 'PPL', 'P'),
(4676, 'Oak Grove (historical)', 32.5347213745117, 0.567838009204205, -87.1205596923828, -1.52054061281234, 218, 2, 'PPL', 'P'),
(23519, 'Oak Grove (historical)', 31.0544395446777, 0.542002217416155, -84.2377777099609, -1.47022657560191, 218, 13, 'PPL', 'P'),
(61126, 'Oak Grove (historical)', 34.0447196960449, 0.594192451614547, -89.0694427490234, -1.55455503888705, 218, 30, 'PPL', 'P'),
(110721, 'Oak Grove (historical)', 39.4466705322266, 0.688474279736777, -80.2927780151367, -1.40137334193705, 218, 58, 'PPL', 'P'),
(175622, 'Oak Grove (historical)', 44.6725006103516, 0.779682220749811, -91.6050033569336, -1.59880891987895, 218, 57, 'PPL', 'P'),
(183743, 'Oak Grove (historical)', 39.3422203063965, 0.686651279391591, -121.319442749023, -2.11742372265522, 218, 6, 'PPL', 'P'),
(4678, 'Oak Grove Estates', 33.4588890075684, 0.583967777241406, -86.8269424438477, -1.51541602508475, 218, 2, 'PPL', 'P'),
(23520, 'Oak Grove Estates', 34.0930595397949, 0.595036141047884, -84.6047210693359, -1.47663094539133, 218, 13, 'PPL', 'P'),
(82689, 'Oak Grove Estates', 33.9805603027344, 0.593072658955196, -81.158332824707, -1.41648012322053, 218, 48, 'PPL', 'P'),
(104805, 'Oak Grove Estates', 37.6669387817383, 0.657412100888475, -77.6838912963867, -1.35583967888331, 218, 53, 'PPL', 'P'),
(104806, 'Oak Grove Farms', 37.2519416809082, 0.650169035092759, -80.0350036621094, -1.39687433074953, 218, 53, 'PPL', 'P'),
(10901, 'Oak Grove Heights', 36.1208305358887, 0.630427421406165, -90.5105590820313, -1.5797072638023, 218, 4, 'PPL', 'P'),
(56615, 'Oak Grove Heights', 37.1738891601563, 0.648806761616156, -93.1183319091797, -1.62522148578008, 218, 29, 'PPL', 'P'),
(89539, 'Oak Grove Heights', 35.9672203063965, 0.627746417136782, -84.1119384765625, -1.46803026665092, 218, 50, 'PPL', 'P'),
(67342, 'Oak Grove Inn', 35.5672187805176, 0.620765073497194, -78.1913909912109, -1.36469721951086, 218, 33, 'PPL', 'P'),
(125705, 'Oak Grove Village', 41.7024993896484, 0.727845920660291, -71.1263885498047, -1.24138966524689, 218, 23, 'PPL', 'P'),
(165420, 'Oak Hall', 40.7938919067383, 0.711987728475251, -77.8027801513672, -1.35791468084665, 218, 45, 'PPL', 'P'),
(175626, 'Oak Hall', 42.9505615234375, 0.749628714164376, -89.4369430541992, -1.56096912921445, 218, 57, 'PPL', 'P'),
(89540, 'Oak Hampton', 36.038330078125, 0.628987516783787, -86.8602828979492, -1.51599792578294, 218, 50, 'PPL', 'P'),
(17342, 'Oak Harbor', 30.3600006103516, 0.529881971558123, -81.4250030517578, -1.4211343966996, 218, 12, 'PPL', 'P'),
(23522, 'Oak Harbor', 34.3833312988281, 0.600102338968569, -83.8663864135742, -1.46374457466671, 218, 13, 'PPL', 'P'),
(156890, 'Oak Harbor', 41.5066719055176, 0.724428086296311, -83.1466674804688, -1.45118310959508, 218, 41, 'PPL', 'P'),
(208294, 'Oak Harbor', 48.2933311462402, 0.842877635257819, -122.641937255859, -2.14050560613905, 218, 56, 'PPL', 'P'),
(23523, 'Oak Haven', 33.9925003051758, 0.593281051310495, -84.7716674804688, -1.47954470993999, 218, 13, 'PPL', 'P'),
(49957, 'Oak Haven', 38.4277801513672, 0.670691287873882, -75.5677795410156, -1.31890656141193, 218, 25, 'PPL', 'P'),
(82690, 'Oak Haven Acres', 33.9124984741211, 0.591884755950966, -80.4108276367188, -1.40343369651439, 218, 48, 'PPL', 'P'),
(89541, 'Oak Haven Acres', 36.4283294677734, 0.63579429021392, -88.1177825927734, -1.53794543580044, 218, 50, 'PPL', 'P'),
(183744, 'Oak Haven Estates', 33.4397201538086, 0.583633217629465, -117.094169616699, -2.04367879470011, 218, 6, 'PPL', 'P'),
(4680, 'Oak Hill', 33.5849990844727, 0.586168813303329, -85.8144378662109, -1.49774448651348, 218, 2, 'PPL', 'P'),
(10903, 'Oak Hill', 36.4772186279297, 0.636647567027182, -93.6983337402344, -1.63534442739958, 218, 4, 'PPL', 'P'),
(17344, 'Oak Hill', 28.8641700744629, 0.503774803654994, -80.8547210693359, -1.41118109844154, 218, 12, 'PPL', 'P'),
(23542, 'Oak Hill', 31.6025009155273, 0.551567692840475, -84.4772186279297, -1.47440560798446, 218, 13, 'PPL', 'P'),
(30705, 'Oak Hill', 38.3044395446777, 0.668538588185744, -87.3744430541992, -1.52497171339207, 218, 19, 'PPL', 'P'),
(33463, 'Oak Hill', 39.2483291625977, 0.685012569793838, -97.3411102294922, -1.69892287105137, 218, 20, 'PPL', 'P'),
(37473, 'Oak Hill', 37.0580596923828, 0.646785156032677, -84.6463928222656, -1.47735825468503, 218, 21, 'PPL', 'P'),
(42370, 'Oak Hill', 32.0127792358398, 0.55872840037948, -93.7477798461914, -1.63620742475082, 218, 22, 'PPL', 'P'),
(49958, 'Oak Hill', 39.3858299255371, 0.687412410831136, -76.6319427490234, -1.33747971317025, 218, 25, 'PPL', 'P'),
(56616, 'Oak Hill', 38.2058296203613, 0.66681752033128, -91.4205627441406, -1.59558982391132, 218, 29, 'PPL', 'P'),
(61128, 'Oak Hill', 34.3227806091309, 0.599045530068998, -88.9472198486328, -1.55242184685389, 218, 30, 'PPL', 'P'),
(67349, 'Oak Hill', 34.9552803039551, 0.61008473226154, -79.3938903808594, -1.38568479311345, 218, 33, 'PPL', 'P'),
(76764, 'Oak Hill', 34.040828704834, 0.59412454100675, -94.835563659668, -1.65519283384589, 218, 42, 'PPL', 'P'),
(82693, 'Oak Hill', 33.5416717529297, 0.585412608711801, -79.0647201538086, -1.37993968885188, 218, 48, 'PPL', 'P'),
(89555, 'Oak Hill', 36.3544387817383, 0.634504654456049, -82.5922164916992, -1.44150611430011, 218, 50, 'PPL', 'P'),
(96672, 'Oak Hill', 30.235279083252, 0.527705170262119, -97.8597183227539, -1.70797428980628, 218, 51, 'PPL', 'P'),
(104813, 'Oak Hill', 37.2547187805176, 0.650217504624598, -79.9661102294922, -1.39567191351736, 218, 53, 'PPL', 'P'),
(112653, 'Oak Hill', 38.791389465332, 0.677037467593487, -81.7099990844727, -1.4261085158256, 218, 58, 'PPL', 'P'),
(120849, 'Oak Hill', 40.7874984741211, 0.711876142025576, -89.8663864135742, -1.56846432978637, 218, 18, 'PPL', 'P'),
(125706, 'Oak Hill', 42.2583312988281, 0.737547017563123, -71.790283203125, -1.25297681283371, 218, 23, 'PPL', 'P'),
(128403, 'Oak Hill', 43.8950004577637, 0.766112283152394, -69.6805572509766, -1.21615514865395, 218, 26, 'PPL', 'P'),
(132371, 'Oak Hill', 44.2244415283203, 0.771862114524903, -86.3038864135742, -1.50628697518407, 218, 27, 'PPL', 'P'),
(145942, 'Oak Hill', 40.3666687011719, 0.704531276897192, -74.1347198486328, -1.29389495140223, 218, 37, 'PPL', 'P'),
(151319, 'Oak Hill', 42.9708290100098, 0.749982448536166, -73.4044418334961, -1.28114919558317, 218, 40, 'PPL', 'P'),
(156891, 'Oak Hill', 40.4141693115234, 0.705360318944534, -82.2411117553711, -1.43537818063184, 218, 41, 'PPL', 'P'),
(165424, 'Oak Hill', 41.4127807617188, 0.722789376698557, -79.8399963378906, -1.39347081087641, 218, 45, 'PPL', 'P'),
(175627, 'Oak Hill', 42.9358291625977, 0.749371585961129, -88.586669921875, -1.54612906351415, 218, 57, 'PPL', 'P'),
(183745, 'Oak Hill', 34.0652809143066, 0.594551312571435, -118.784172058105, -2.07317490166939, 218, 6, 'PPL', 'P'),
(4681, 'Oak Hill (historical)', 34.1116714477539, 0.595360980121847, -85.8605575561523, -1.49854942695295, 218, 2, 'PPL', 'P'),
(10904, 'Oak Hill (historical)', 34.0519409179688, 0.594318485713135, -94.0599975585938, -1.64165665181529, 218, 4, 'PPL', 'P'),
(104814, 'Oak Hill Corner', 37.1591682434082, 0.648549833149991, -77.0697174072266, -1.34512032233769, 218, 53, 'PPL', 'P'),
(67350, 'Oak Hill Court', 35.3861083984375, 0.617604101020352, -82.5630569458008, -1.4409971842158, 218, 33, 'PPL', 'P'),
(49961, 'Oak Hill Estates', 38.2130584716797, 0.666943687587923, -75.2930603027344, -1.31411180618535, 218, 25, 'PPL', 'P'),
(89556, 'Oak Hill Estates', 36.0475006103516, 0.6291475727653, -86.7911071777344, -1.51479058170275, 218, 50, 'PPL', 'P'),
(104817, 'Oak Hill Estates', 38.6861114501953, 0.675200019599386, -77.418327331543, -1.35120471332214, 218, 53, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(23529, 'Oak Hill Farms', 33.545280456543, 0.585475592471581, -83.970832824707, -1.46556750843287, 218, 13, 'PPL', 'P'),
(104818, 'Oak Hill Farms', 38.6650009155273, 0.674831571262574, -77.4252777099609, -1.35132602030979, 218, 53, 'PPL', 'P'),
(110725, 'Oak Hill Junction', 37.9822196960449, 0.662914790911824, -81.1744384765625, -1.41676121987359, 218, 58, 'PPL', 'P'),
(151320, 'Oak Hill Landing', 42.1941719055176, 0.736427224903771, -73.850830078125, -1.28894014019414, 218, 40, 'PPL', 'P'),
(104819, 'Oak Hill Mobile Home Park', 38.0047187805176, 0.663307474014556, -78.5233306884766, -1.37049066014622, 218, 53, 'PPL', 'P'),
(89557, 'Oak Hill North', 35.146671295166, 0.613425135216827, -85.2613906860352, -1.48809199230054, 218, 50, 'PPL', 'P'),
(17345, 'Oak Hill Park', 30.2447204589844, 0.527869953354568, -81.7780609130859, -1.42729641882983, 218, 12, 'PPL', 'P'),
(125707, 'Oak Hill Park', 42.2944412231445, 0.73817725463509, -71.1861114501953, -1.24243202649754, 218, 23, 'PPL', 'P'),
(89558, 'Oak Hill Subdivision', 35.7152786254883, 0.623349205281925, -89.5002822875977, -1.56207460738294, 218, 50, 'PPL', 'P'),
(4685, 'Oak Hills', 33.4900016784668, 0.584510795787673, -86.9022216796875, -1.51672989560854, 218, 2, 'PPL', 'P'),
(23530, 'Oak Hills', 33.4980583190918, 0.584651410693229, -84.475830078125, -1.47438137321854, 218, 13, 'PPL', 'P'),
(28091, 'Oak Hills', 38.6380615234375, 0.674361390172121, -89.9805603027344, -1.57045704007202, 218, 18, 'PPL', 'P'),
(42372, 'Oak Hills', 30.3624992370605, 0.529925580820973, -91.0877838134766, -1.58978173588996, 218, 22, 'PPL', 'P'),
(89560, 'Oak Hills', 35.8772201538086, 0.626175618146826, -84.5083312988281, -1.47494862653073, 218, 50, 'PPL', 'P'),
(104821, 'Oak Hills', 36.5905609130859, 0.638625763084892, -79.4702835083008, -1.3870181047132, 218, 53, 'PPL', 'P'),
(165425, 'Oak Hills', 40.8247184753418, 0.712525753594474, -79.913330078125, -1.3947507260963, 218, 45, 'PPL', 'P'),
(183747, 'Oak Hills', 34.3997192382813, 0.600388362469644, -117.339721679688, -2.04796448668432, 218, 6, 'PPL', 'P'),
(201332, 'Oak Hills', 45.541389465332, 0.794847192103104, -122.839996337891, -2.14396238923397, 218, 43, 'PPL', 'P'),
(170984, 'Oak Hills Addition', 42.8666687011719, 0.74816450819705, -97.5325012207031, -1.70226327400666, 218, 49, 'PPL', 'P'),
(89561, 'Oak Hills Estates', 35.9855613708496, 0.62806652909981, -84.3333282470703, -1.47189424707651, 218, 50, 'PPL', 'P'),
(42373, 'Oak Hills Place', 30.3597202301025, 0.52987707799962, -91.0875015258789, -1.58977680904195, 218, 22, 'PPL', 'P'),
(49962, 'Oak Hollow', 39.1080589294434, 0.682564392382755, -76.5475006103516, -1.336005919823, 218, 25, 'PPL', 'P'),
(82695, 'Oak Hollow', 34.9436111450195, 0.609881067017177, -82.3694381713867, -1.4376178991086, 218, 48, 'PPL', 'P'),
(67354, 'Oak Hollow Lake', 36.0352783203125, 0.628934253561985, -80.0055618286133, -1.3963604738172, 218, 33, 'PPL', 'P'),
(82696, 'Oak Hurst', 34.9313888549805, 0.609667747813861, -81.8952789306641, -1.42934225917923, 218, 48, 'PPL', 'P'),
(67355, 'Oak Island', 33.916389465332, 0.591952666558763, -78.1613922119141, -1.36417364204055, 218, 33, 'PPL', 'P'),
(96701, 'Oak Island', 29.2275009155273, 0.510116123105609, -98.559440612793, -1.72018674761705, 218, 51, 'PPL', 'P'),
(125708, 'Oak Island', 42.4249992370605, 0.740455921842789, -70.9875030517578, -1.2389656560227, 218, 23, 'PPL', 'P'),
(145943, 'Oak Island Junction', 40.7122192382813, 0.710562271501786, -74.1463928222656, -1.29409868322563, 218, 37, 'PPL', 'P'),
(17346, 'Oak Knoll', 27.5113906860352, 0.480164349273815, -82.2777786254883, -1.43601813824178, 218, 12, 'PPL', 'P'),
(137229, 'Oak Knoll', 44.9713897705078, 0.784898820693058, -93.4277801513672, -1.63062237647076, 218, 28, 'PPL', 'P'),
(156893, 'Oak Knoll', 40.5611114501953, 0.70792494307428, -83.1458282470703, -1.45116846220908, 218, 41, 'PPL', 'P'),
(175629, 'Oak Knoll', 42.8686103820801, 0.748198396921922, -88.3377838134766, -1.54178518146012, 218, 57, 'PPL', 'P'),
(183749, 'Oak Knoll', 38.3583297729492, 0.669479150103733, -122.333892822266, -2.13512921653039, 218, 6, 'PPL', 'P'),
(17347, 'Oak Knoll Estates', 30.523609161377, 0.532737479457933, -84.2663879394531, -1.4707259183063, 218, 12, 'PPL', 'P'),
(178734, 'Oak Knoll Village', 34.5152816772461, 0.602405307521215, -112.443893432617, -1.9625161641608, 218, 5, 'PPL', 'P'),
(23531, 'Oak Knolls', 32.4886093139648, 0.567033201922783, -83.7880630493164, -1.46237757407917, 218, 13, 'PPL', 'P'),
(49963, 'Oak Knolls', 38.5800018310547, 0.673348057377345, -76.9905624389648, -1.34373880752221, 218, 25, 'PPL', 'P'),
(23532, 'Oak Lake', 33.4922218322754, 0.584549544781534, -82.1483306884766, -1.43375884553102, 218, 13, 'PPL', 'P'),
(17348, 'Oak Landing', 30.2533302307129, 0.528020222219076, -81.434440612793, -1.42129911321303, 218, 12, 'PPL', 'P'),
(42374, 'Oak Landing', 32.9613914489746, 0.575284806823311, -91.7172164916992, -1.60076740854459, 218, 22, 'PPL', 'P'),
(49964, 'Oak Landing', 39.0847206115723, 0.682157061894028, -76.5305633544922, -1.33571030894201, 218, 25, 'PPL', 'P'),
(165426, 'Oak Lane', 40.0563888549805, 0.699115871978571, -75.1216735839844, -1.31112054364898, 218, 45, 'PPL', 'P'),
(14330, 'Oak Lane Manor', 39.7930603027344, 0.694519921727366, -75.5305633544922, -1.31825701642206, 218, 10, 'PPL', 'P'),
(165427, 'Oak Lane Manor', 40.0516700744629, 0.69903351372186, -75.1116714477539, -1.31094597343952, 218, 45, 'PPL', 'P'),
(4687, 'Oak Lawn', 33.5813903808594, 0.586105829543549, -86.7527770996094, -1.51412159563692, 218, 2, 'PPL', 'P'),
(104822, 'Oak Lawn', 36.8186111450195, 0.64260599049207, -77.6147232055664, -1.35463246796118, 218, 53, 'PPL', 'P'),
(120850, 'Oak Lawn', 41.7108306884766, 0.727991329255809, -87.758056640625, -1.53166703353058, 218, 18, 'PPL', 'P'),
(67356, 'Oak Lawn (historical)', 35.4894409179688, 0.619407593710554, -80.7686080932617, -1.40967814348036, 218, 33, 'PPL', 'P'),
(49965, 'Oak Lea', 39.2775001525879, 0.685521699615234, -76.8566665649414, -1.34140188366567, 218, 25, 'PPL', 'P'),
(96674, 'Oak Leaf', 32.5202789306641, 0.567585941007029, -96.8544387817383, -1.69042885191262, 218, 51, 'PPL', 'P'),
(4690, 'Oak Level', 33.8494415283203, 0.590784204630491, -85.4780578613281, -1.4918735478904, 218, 2, 'PPL', 'P'),
(23533, 'Oak Level', 31.8555603027344, 0.555984412350316, -81.2252807617188, -1.4176485851488, 218, 13, 'PPL', 'P'),
(37474, 'Oak Level', 36.8669395446777, 0.643449480188326, -88.4655609130859, -1.54401531255695, 218, 21, 'PPL', 'P'),
(104823, 'Oak Level', 36.8152809143066, 0.642547867001279, -79.9358291625977, -1.39514340919903, 218, 53, 'PPL', 'P'),
(123342, 'Oak Lodge', 41.5947189331055, 0.725964796824313, -85.2024993896484, -1.48706414527782, 218, 19, 'PPL', 'P'),
(78869, 'Oak Manor', 39.9172210693359, 0.696686935906364, -76.6777801513672, -1.33827972676171, 218, 45, 'PPL', 'P'),
(104824, 'Oak Manor', 37.2230606079102, 0.649664965277434, -80.4475021362305, -1.40407378728239, 218, 53, 'PPL', 'P'),
(156894, 'Oak Meadows', 41.5352783203125, 0.724927362421673, -83.5952835083008, -1.45901293635797, 218, 41, 'PPL', 'P'),
(14331, 'Oak Meadows Mobile Home Park', 38.6119384765625, 0.673905456993499, -75.2002792358398, -1.31249247108453, 218, 10, 'PPL', 'P'),
(142564, 'Oak Mill', 40.225830078125, 0.702073179211049, -97.8755569458008, -1.70825072592743, 218, 35, 'PPL', 'P'),
(33464, 'Oak Mills', 39.4455604553223, 0.688454905239847, -95.0102767944336, -1.65824215329403, 218, 20, 'PPL', 'P'),
(56618, 'Oak Mound', 36.6822204589844, 0.640225523951703, -92.1780624389648, -1.60881068766885, 218, 29, 'PPL', 'P'),
(23535, 'Oak Mountain', 32.7425003051758, 0.571464435660565, -84.7252807617188, -1.4787351089686, 218, 13, 'PPL', 'P'),
(23536, 'Oak Mountain Spring (historical)', 32.7561111450195, 0.571701989629801, -84.690559387207, -1.47812910666255, 218, 13, 'PPL', 'P'),
(120851, 'Oak Openings', 41.9330596923828, 0.731869957067401, -88.4644393920898, -1.54399573832294, 218, 18, 'PPL', 'P'),
(14332, 'Oak Orchard', 38.5961112976074, 0.673629220609431, -75.1730575561523, -1.31201736314606, 218, 10, 'PPL', 'P'),
(49966, 'Oak Orchard', 39.4916687011719, 0.689259645942242, -77.154167175293, -1.346594248843, 218, 25, 'PPL', 'P'),
(151322, 'Oak Orchard', 43.274169921875, 0.755276746204216, -78.3327789306641, -1.36716490457693, 218, 40, 'PPL', 'P'),
(175630, 'Oak Orchard', 44.7813911437988, 0.781582719082719, -87.9258270263672, -1.53459517914912, 218, 57, 'PPL', 'P'),
(14333, 'Oak Orchard West Mobile Home Park', 38.6094398498535, 0.673861847730649, -75.1963882446289, -1.31242456047673, 218, 10, 'PPL', 'P'),
(4692, 'Oak Park', 34.7488899230957, 0.606482540571099, -86.5524978637695, -1.51062606354814, 218, 2, 'PPL', 'P'),
(10905, 'Oak Park', 35.4305610656738, 0.618379946424919, -94.3913879394531, -1.64744050507072, 218, 4, 'PPL', 'P'),
(17349, 'Oak Park', 30.1022205352783, 0.525382860502057, -84.4958267211914, -1.47473038047939, 218, 12, 'PPL', 'P'),
(23538, 'Oak Park', 32.3580589294434, 0.564754667873138, -82.3147201538086, -1.43666288954169, 218, 13, 'PPL', 'P'),
(30706, 'Oak Park', 38.3055610656738, 0.668558162419756, -85.6963882446289, -1.49568413193614, 218, 19, 'PPL', 'P'),
(49968, 'Oak Park', 39.478328704834, 0.689026819083942, -77.5897216796875, -1.35419610901657, 218, 25, 'PPL', 'P'),
(67361, 'Oak Park', 36.1925010681152, 0.631678308170175, -80.3877792358398, -1.40303142603174, 218, 33, 'PPL', 'P'),
(89591, 'Oak Park', 35.3458290100098, 0.616901093071598, -86.2180633544922, -1.50478908022896, 218, 50, 'PPL', 'P'),
(104826, 'Oak Park', 37.3008308410645, 0.65102231190602, -80.0202789306641, -1.39661733570434, 218, 53, 'PPL', 'P'),
(112549, 'Oak Park', 33.1450004577637, 0.578489388563004, -80.0625, -1.39735423237796, 218, 48, 'PPL', 'P'),
(120852, 'Oak Park', 41.8849983215332, 0.731031127903053, -87.7844390869141, -1.53212749408306, 218, 18, 'PPL', 'P'),
(132373, 'Oak Park', 42.4594383239746, 0.74105699730082, -83.1827774047852, -1.45181334666704, 218, 27, 'PPL', 'P'),
(137232, 'Oak Park', 45.6977806091309, 0.797576732483353, -93.8177795410156, -1.6374291499009, 218, 28, 'PPL', 'P'),
(156896, 'Oak Park', 40.2516708374023, 0.702524185541654, -80.998893737793, -1.4136973861975, 218, 41, 'PPL', 'P'),
(165429, 'Oak Park', 40.913890838623, 0.714082104935516, -76.7605590820313, -1.33972449165308, 218, 45, 'PPL', 'P'),
(183752, 'Oak Park', 34.1791687011719, 0.596539029430043, -118.761940002441, -2.07278687909856, 218, 6, 'PPL', 'P'),
(201333, 'Oak Park', 44.9644393920898, 0.784777513705405, -122.982498168945, -2.14644951537599, 218, 43, 'PPL', 'P'),
(208295, 'Oak Park', 45.582218170166, 0.795559787431782, -122.387222290039, -2.13605999133138, 218, 56, 'PPL', 'P'),
(89563, 'Oak Park Estates', 36.2000007629395, 0.631809202537753, -85.4711074829102, -1.49175224090275, 218, 50, 'PPL', 'P'),
(170989, 'Oak Park Estates', 43.7305603027344, 0.763242261024643, -96.4916687011719, -1.68409731957901, 218, 49, 'PPL', 'P'),
(183753, 'Oak Park Estates', 38.188060760498, 0.666507395222341, -120.660827636719, -2.10592872044211, 218, 6, 'PPL', 'P'),
(137233, 'Oak Park Heights', 45.0313911437988, 0.785946042212705, -92.7927780151367, -1.61953949843634, 218, 28, 'PPL', 'P'),
(42377, 'Oak Park Mobile Homes Court', 31.3061103820801, 0.546394702160077, -92.4555587768555, -1.61365391242727, 218, 22, 'PPL', 'P'),
(89564, 'Oak Plains', 36.4291687011719, 0.635808937599916, -87.1691665649414, -1.52138896277758, 218, 50, 'PPL', 'P'),
(23541, 'Oak Point', 33.8436088562012, 0.590682405297823, -83.3311080932617, -1.45440220556271, 218, 13, 'PPL', 'P'),
(28092, 'Oak Point', 39.211109161377, 0.68436295822494, -87.9761123657227, -1.53547282388636, 218, 18, 'PPL', 'P'),
(96675, 'Oak Point', 33.189998626709, 0.579274754768468, -96.9913864135742, -1.69281903899096, 218, 51, 'PPL', 'P'),
(132375, 'Oak Point', 42.1927795410156, 0.736402923558825, -84.2558288574219, -1.47054162755886, 218, 27, 'PPL', 'P'),
(151323, 'Oak Point', 44.5141716003418, 0.776918858223718, -75.7516708374023, -1.32211606999964, 218, 40, 'PPL', 'P'),
(208296, 'Oak Point', 46.1911087036133, 0.806186932024661, -123.1875, -2.15002747230051, 218, 56, 'PPL', 'P'),
(89565, 'Oak Point (historical)', 36.0611114501953, 0.629385126734535, -86.2866668701172, -1.50598643745506, 218, 50, 'PPL', 'P'),
(14334, 'Oak Point Acres', 39.0991706848145, 0.682409263249258, -75.6616668701172, -1.32054520443066, 218, 10, 'PPL', 'P'),
(4695, 'Oak Ridge', 33.600830078125, 0.586445116266425, -86.2794418334961, -1.50586033677744, 218, 2, 'PPL', 'P'),
(10906, 'Oak Ridge', 35.8938903808594, 0.626466568495918, -90.7838897705078, -1.58447778426296, 218, 4, 'PPL', 'P'),
(17350, 'Oak Ridge', 28.4708309173584, 0.496909740286502, -81.4247207641602, -1.42112946985159, 218, 12, 'PPL', 'P'),
(23560, 'Oak Ridge', 33.5638885498047, 0.585800364966517, -84.3061065673828, -1.47141913913804, 218, 13, 'PPL', 'P'),
(37477, 'Oak Ridge', 38.9688911437988, 0.680135456310549, -84.5038909912109, -1.47487112854301, 218, 21, 'PPL', 'P'),
(42380, 'Oak Ridge', 30.5380592346191, 0.532989680813164, -90.408332824707, -1.57792307903, 218, 22, 'PPL', 'P'),
(49971, 'Oak Ridge', 39.6152801513672, 0.691417072741315, -77.751106262207, -1.35701280134349, 218, 25, 'PPL', 'P'),
(56622, 'Oak Ridge', 37.8591690063477, 0.660767151229757, -94.1486129760742, -1.64320328261835, 218, 29, 'PPL', 'P'),
(61129, 'Oak Ridge', 32.4811096191406, 0.566902307555205, -90.7063903808594, -1.58312516474531, 218, 30, 'PPL', 'P'),
(67363, 'Oak Ridge', 36.5027809143066, 0.637093713088797, -80.129997253418, -1.39853228168616, 218, 33, 'PPL', 'P'),
(76765, 'Oak Ridge', 36.8969383239746, 0.643973057658635, -96.1127777099609, -1.67748442427623, 218, 42, 'PPL', 'P'),
(82698, 'Oak Ridge', 33.4208297729492, 0.583303518286513, -79.6444396972656, -1.39005770362336, 218, 48, 'PPL', 'P'),
(89566, 'Oak Ridge', 36.0102806091309, 0.628497961196403, -84.2697219848633, -1.47078410837612, 218, 50, 'PPL', 'P'),
(96679, 'Oak Ridge', 31.5713901519775, 0.551024707583721, -94.5410919189453, -1.6500533324162, 218, 51, 'PPL', 'P'),
(104830, 'Oak Ridge', 36.7230606079102, 0.640938319017463, -76.6425018310547, -1.33766400391769, 218, 53, 'PPL', 'P'),
(110727, 'Oak Ridge', 38.0750007629395, 0.664534126012646, -81.1097183227539, -1.41563164009723, 218, 58, 'PPL', 'P'),
(120854, 'Oak Ridge', 40.8113899230957, 0.712293126473255, -89.4375, -1.56097884975243, 218, 18, 'PPL', 'P'),
(128405, 'Oak Ridge', 43.4355583190918, 0.758093505110166, -70.4302825927734, -1.22924032435395, 218, 26, 'PPL', 'P'),
(132376, 'Oak Ridge', 46.2886085510254, 0.807888625382195, -84.2099990844727, -1.46974174712546, 218, 27, 'PPL', 'P'),
(145944, 'Oak Ridge', 41.0461082458496, 0.71638973402007, -74.4863891601563, -1.30003273876654, 218, 37, 'PPL', 'P'),
(151324, 'Oak Ridge', 42.7963905334473, 0.746937922777987, -74.3405609130859, -1.29748755571275, 218, 40, 'PPL', 'P'),
(156897, 'Oak Ridge', 40.8397216796875, 0.712787608908656, -81.5047225952148, -1.42252576521112, 218, 41, 'PPL', 'P'),
(165431, 'Oak Ridge', 40.8494415283203, 0.712957252270094, -78.4966735839844, -1.37002540590379, 218, 45, 'PPL', 'P'),
(61130, 'Oak Ridge (historical)', 33.2402801513672, 0.580152332926677, -89.5083312988281, -1.56221508913044, 218, 30, 'PPL', 'P'),
(104831, 'Oak Ridge East', 36.7275009155273, 0.641015817005184, -76.6374969482422, -1.33757665223393, 218, 53, 'PPL', 'P'),
(71193, 'Oak Ridge Estates', 39.9705581665039, 0.697617843865401, -74.2244415283203, -1.2954608901232, 218, 37, 'PPL', 'P'),
(104833, 'Oak Ridge Estates', 36.7249984741211, 0.640972141163307, -76.6486129760742, -1.33777066351934, 218, 53, 'PPL', 'P'),
(49972, 'Oak Ridge Manor', 39.1494407653809, 0.683286641670385, -76.6183319091797, -1.33724215920102, 218, 25, 'PPL', 'P'),
(96680, 'Oak Ridge North', 30.1599998474121, 0.526391299738329, -95.4441680908203, -1.66581498501172, 218, 51, 'PPL', 'P'),
(4698, 'Oak Ridge Park', 33.5394401550293, 0.585373659980859, -86.7399978637695, -1.51389855589563, 218, 2, 'PPL', 'P'),
(17351, 'Oak Ridge Park', 29.6355590820313, 0.517238081650754, -81.95361328125, -1.43036038566397, 218, 12, 'PPL', 'P'),
(42383, 'Oak Ridge Park', 29.9119396209717, 0.5220618320437, -89.8916702270508, -1.56890561557899, 218, 22, 'PPL', 'P'),
(67366, 'Oak Ridge Park', 34.9136085510254, 0.60935742296784, -79.7733306884766, -1.39230727579615, 218, 33, 'PPL', 'P'),
(137236, 'Oak Ridge Trailer Court', 46.3549995422363, 0.809047366772488, -94.793327331543, -1.65445567085616, 218, 28, 'PPL', 'P'),
(183754, 'Oak Ridge Village', 38.6794395446777, 0.675083572880723, -121.07527923584, -2.11316226543693, 218, 6, 'PPL', 'P'),
(104834, 'Oak Row', 38.060001373291, 0.664272337277492, -76.8822174072266, -1.3418478299902, 218, 53, 'PPL', 'P'),
(120857, 'Oak Run', 40.9633293151855, 0.714944969128702, -90.1449966430664, -1.57332699562074, 218, 18, 'PPL', 'P'),
(193139, 'Oak Run', 40.6852798461914, 0.710092090411332, -122.023612976074, -2.12971381161177, 218, 6, 'PPL', 'P'),
(71194, 'Oak Shade', 39.8691711425781, 0.695848306479098, -74.7333297729492, -1.30434266551667, 218, 37, 'PPL', 'P'),
(78870, 'Oak Shade', 39.8044395446777, 0.694718526965659, -76.1127777099609, -1.32841857387737, 218, 45, 'PPL', 'P'),
(96681, 'Oak Shade', 30.5342197418213, 0.532922669022234, -94.5784301757813, -1.65070500793494, 218, 51, 'PPL', 'P'),
(104835, 'Oak Shade', 38.5813903808594, 0.673372292143265, -77.7891693115234, -1.35767712687741, 218, 53, 'PPL', 'P'),
(132377, 'Oak Shade Park', 42.0683288574219, 0.734230849373756, -84.1605606079102, -1.46887888293227, 218, 27, 'PPL', 'P'),
(42384, 'Oak Shadows Place', 30.5216693878174, 0.532703624022575, -91.0325012207031, -1.58881687262703, 218, 22, 'PPL', 'P'),
(178735, 'Oak Springs', 35.4755592346191, 0.619165312630384, -109.126937866211, -1.90462436838466, 218, 5, 'PPL', 'P'),
(190562, 'Oak Springs (historical)', 37.2194404602051, 0.649601781780572, -116.056938171387, -2.02557569087419, 218, 39, 'PPL', 'P'),
(50018, 'Oak Summit', 39.394718170166, 0.687567539964633, -76.5149993896484, -1.33543866651082, 218, 25, 'PPL', 'P'),
(165432, 'Oak Summit', 40.0950012207031, 0.699789784892415, -75.1600036621094, -1.3117895297148, 218, 45, 'PPL', 'P'),
(17352, 'Oak Terrace', 27.8388900756836, 0.485880291921452, -81.9775009155273, -1.43077730353262, 218, 12, 'PPL', 'P'),
(104851, 'Oak Terrace', 38.0647201538086, 0.664354695534202, -78.496940612793, -1.37003006643569, 218, 53, 'PPL', 'P'),
(128406, 'Oak Terrace', 43.089168548584, 0.752047863119577, -70.7583312988281, -1.23496585438151, 218, 26, 'PPL', 'P'),
(137237, 'Oak Terrace', 44.896110534668, 0.783584950169268, -93.4702835083008, -1.63136419999241, 218, 28, 'PPL', 'P'),
(137238, 'Oak Terrace Estates', 44.000560760498, 0.767954657994511, -92.4305572509766, -1.61321755348266, 218, 28, 'PPL', 'P'),
(49974, 'Oak Terrace Trailer Park', 38.4683303833008, 0.671399022933571, -75.7638931274414, -1.32232938920296, 218, 25, 'PPL', 'P'),
(42385, 'Oak Thicket Acres', 32.5638885498047, 0.568347072446573, -93.6180572509766, -1.63394333835009, 218, 22, 'PPL', 'P'),
(96682, 'Oak Trail Shores', 32.4886093139648, 0.567033201922783, -97.8338928222656, -1.70752354979178, 218, 51, 'PPL', 'P'),
(145945, 'Oak Tree', 40.5777816772461, 0.708215893423371, -74.3769378662109, -1.29812245331663, 218, 37, 'PPL', 'P'),
(165433, 'Oak Tree', 40.8105583190918, 0.712278612245315, -79.0502777099609, -1.3796876206547, 218, 45, 'PPL', 'P'),
(104836, 'Oak Tree Corner', 38.628059387207, 0.674186819962666, -77.7141723632813, -1.35636818320164, 218, 53, 'PPL', 'P'),
(30712, 'Oak Tree Crossroads', 39.3722190856934, 0.687174856861901, -85.003059387207, -1.48358326057504, 218, 19, 'PPL', 'P'),
(183755, 'Oak Tree Village', 38.7069396972656, 0.675563541088182, -121.074172973633, -2.11314295751903, 218, 6, 'PPL', 'P'),
(61134, 'Oak Vale', 31.4383296966553, 0.548702364534145, -89.9644393920898, -1.57017567710285, 218, 30, 'PPL', 'P'),
(33465, 'Oak Valley', 37.3433303833008, 0.651764068848635, -96.0097198486328, -1.67568572527599, 218, 20, 'PPL', 'P'),
(49975, 'Oak Valley', 39.6624984741211, 0.69224118794064, -76.5891723632813, -1.3367332291167, 218, 25, 'PPL', 'P'),
(96683, 'Oak Valley', 32.0333290100098, 0.559087061599286, -96.5127792358398, -1.68446576791582, 218, 51, 'PPL', 'P'),
(112477, 'Oak Valley', 39.8011093139648, 0.694660403474868, -75.1627807617188, -1.31183799924664, 218, 37, 'PPL', 'P'),
(169527, 'Oak Valley', 41.9655609130859, 0.732437210379588, -71.6002807617188, -1.24966064464435, 218, 47, 'PPL', 'P'),
(183756, 'Oak Valley', 39.4986114501953, 0.68938081977184, -121.03694152832, -2.11249314621305, 218, 6, 'PPL', 'P'),
(82700, 'Oak View', 34.9172210693359, 0.609420473306647, -82.288330078125, -1.43620229583116, 218, 48, 'PPL', 'P'),
(89569, 'Oak View', 35.7838897705078, 0.624546695666079, -83.82861328125, -1.46308530913886, 218, 50, 'PPL', 'P'),
(183757, 'Oak View', 34.4000015258789, 0.60039328931766, -119.299171447754, -2.08216333666452, 218, 6, 'PPL', 'P'),
(23545, 'Oak View Homes', 33.6383285522461, 0.587099588104312, -84.3450012207031, -1.47209797889991, 218, 13, 'PPL', 'P'),
(49976, 'Oak View Village', 39.172779083252, 0.683693972159113, -76.8294372558594, -1.34092664256914, 218, 25, 'PPL', 'P'),
(67368, 'Oak Villa', 36.3733291625977, 0.634834353799001, -76.9472198486328, -1.34298233661458, 218, 33, 'PPL', 'P'),
(4699, 'Oak Village', 32.8974990844727, 0.574169674695868, -87.7647171020508, -1.53178328051216, 218, 2, 'PPL', 'P'),
(23546, 'Oak Village', 34.0061111450195, 0.59351860527973, -84.0180587768555, -1.46639175679025, 218, 13, 'PPL', 'P'),
(96684, 'Oak Village', 28.7188892364502, 0.501239174691616, -97.1500015258789, -1.6955873949441, 218, 51, 'PPL', 'P'),
(183758, 'Oak Village', 34.392219543457, 0.600257468102066, -118.962501525879, -2.07628733803537, 218, 6, 'PPL', 'P'),
(178736, 'Oak Wells', 32.788890838623, 0.572274103210977, -110.936943054199, -1.93621491839323, 218, 5, 'PPL', 'P'),
(49977, 'Oak West', 39.2799987792969, 0.685565308878084, -76.8080596923828, -1.34055353370042, 218, 25, 'PPL', 'P'),
(89570, 'Oak Wood Estates', 36.4874992370605, 0.636826997505626, -88.0736083984375, -1.53717445066486, 218, 50, 'PPL', 'P'),
(132378, 'Oak Wood Shores', 44.211669921875, 0.771639207941663, -83.5536117553711, -1.45828562706426, 218, 27, 'PPL', 'P'),
(4705, 'Oakahalla', 33.7150001525879, 0.588437759973049, -87.0761108398438, -1.5197648339868, 218, 2, 'PPL', 'P'),
(96685, 'Oakalla', 30.9861106872559, 0.540809653880018, -97.9250030517578, -1.70911372327867, 218, 51, 'PPL', 'P'),
(82701, 'Oakatee', 33.0416717529297, 0.576685962451829, -80.0791702270508, -1.39764518272705, 218, 48, 'PPL', 'P'),
(193827, 'Oakbar', 41.8375015258789, 0.730202152434739, -122.9375, -2.14566414917053, 218, 6, 'PPL', 'P'),
(49978, 'Oakbluff', 38.9394416809082, 0.679621466220163, -76.5430603027344, -1.33592842183528, 218, 25, 'PPL', 'P'),
(67370, 'Oakboro', 35.2255592346191, 0.614801989500398, -80.3291702270508, -1.40200850585704, 218, 33, 'PPL', 'P'),
(78871, 'Oakbourne', 39.9402809143066, 0.697089406126102, -75.5783309936523, -1.31909071900131, 218, 45, 'PPL', 'P'),
(23548, 'Oakbrook', 33.5449981689453, 0.585470665623565, -83.9980621337891, -1.46604274952939, 218, 13, 'PPL', 'P'),
(37478, 'Oakbrook', 38.9997215270996, 0.680673548008799, -84.6852798461914, -1.47803696128884, 218, 21, 'PPL', 'P'),
(42387, 'Oakbrook', 30.3730602264404, 0.53010990485792, -91.0788879394531, -1.58962647359841, 218, 22, 'PPL', 'P'),
(82702, 'Oakbrook', 32.9583282470703, 0.575231343864428, -80.1722183227539, -1.39926917835978, 218, 48, 'PPL', 'P'),
(110728, 'Oakbrook', 39.1805610656738, 0.683829793374707, -81.5208282470703, -1.42280686186417, 218, 58, 'PPL', 'P'),
(151325, 'Oakbrook', 41.1119384765625, 0.717538688293357, -74.0108337402344, -1.2917327309132, 218, 40, 'PPL', 'P'),
(120858, 'Oakbrook Estates Mobile Home Park', 42.223331451416, 0.736936154988086, -88.2788925170898, -1.5407573344374, 218, 18, 'PPL', 'P'),
(23549, 'Oakbrook Forest', 33.9888916015625, 0.593218067550714, -84.0224990844727, -1.46646925477797, 218, 13, 'PPL', 'P'),
(23550, 'Oakbrook Station', 33.9277801513672, 0.592151471534138, -84.1919403076172, -1.46942656201045, 218, 13, 'PPL', 'P'),
(120859, 'Oakbrook Terrace', 41.8499984741211, 0.730420265328016, -87.9644393920898, -1.53526909206297, 218, 18, 'PPL', 'P'),
(137241, 'Oakbury', 44.9488906860352, 0.784506137590326, -92.9336090087891, -1.62199746296443, 218, 28, 'PPL', 'P'),
(4700, 'Oakchia', 32.2983283996582, 0.563712173464427, -88.0105590820313, -1.53607403250244, 218, 2, 'PPL', 'P'),
(205180, 'Oakcliff Park Two', 40.6666717529297, 0.709767317916397, -111.800003051758, -1.95127815699288, 218, 52, 'PPL', 'P'),
(23551, 'Oakcrest', 32.4541702270508, 0.566432126464752, -81.7561111450195, -1.42691332310702, 218, 13, 'PPL', 'P'),
(28093, 'Oakcrest', 39.3844413757324, 0.687388176065216, -87.7077789306641, -1.5307895219514, 218, 18, 'PPL', 'P'),
(82703, 'Oakcrest', 32.7238883972168, 0.571139596586603, -79.9611129760742, -1.39558469499166, 218, 48, 'PPL', 'P'),
(104837, 'Oakcrest', 38.827220916748, 0.677662844396465, -77.0880584716797, -1.34544043430072, 218, 53, 'PPL', 'P'),
(193234, 'Oakcrest', 40.6372184753418, 0.709253261246985, -111.823059082031, -1.95168056063359, 218, 52, 'PPL', 'P'),
(4702, 'Oakdale', 34.8208312988281, 0.607738154446044, -86.9119415283203, -1.51689953896998, 218, 2, 'PPL', 'P'),
(14335, 'Oakdale', 39.665828704834, 0.692299311431431, -75.6980590820313, -1.32118036835064, 218, 10, 'PPL', 'P'),
(17353, 'Oakdale', 30.7102794647217, 0.535995490866995, -85.1852798461914, -1.48676360754881, 218, 12, 'PPL', 'P'),
(23553, 'Oakdale', 33.3591690063477, 0.582227334890012, -84.5313873291016, -1.47535103017144, 218, 13, 'PPL', 'P'),
(28094, 'Oakdale', 38.2616691589355, 0.667792104132195, -89.5013885498047, -1.56209391530084, 218, 18, 'PPL', 'P'),
(37481, 'Oakdale', 37.035831451416, 0.64639720004088, -88.5669403076172, -1.5457847167852, 218, 21, 'PPL', 'P'),
(42390, 'Oakdale', 30.8052806854248, 0.537653574961678, -92.6213912963867, -1.61654823589997, 218, 22, 'PPL', 'P'),
(49981, 'Oakdale', 39.1302795410156, 0.682952215216498, -77.0713882446289, -1.34514948395163, 218, 25, 'PPL', 'P'),
(56623, 'Oakdale', 39.7605590820313, 0.693952668415179, -91.9327774047852, -1.60452965621655, 218, 29, 'PPL', 'P'),
(67377, 'Oakdale', 36.0938911437988, 0.629957240315712, -81.3377838134766, -1.41961213382052, 218, 33, 'PPL', 'P'),
(73745, 'Oakdale', 39.6908302307129, 0.692735670376041, -84.1341705322266, -1.46841828922174, 218, 41, 'PPL', 'P'),
(82706, 'Oakdale', 34.8800010681152, 0.60877086173775, -81.0513916015625, -1.41461364677055, 218, 48, 'PPL', 'P'),
(89574, 'Oakdale', 36.4747200012207, 0.636603957764331, -86.7122192382813, -1.51341372741918, 218, 50, 'PPL', 'P'),
(96688, 'Oakdale', 30.2916698455811, 0.528689374732472, -94.977783203125, -1.6576750331399, 218, 51, 'PPL', 'P'),
(104841, 'Oakdale', 36.7374992370605, 0.641190320635611, -76.5538864135742, -1.33611737311462, 218, 53, 'PPL', 'P'),
(110729, 'Oakdale', 39.4491691589355, 0.688517888999628, -80.396110534668, -1.40317683462725, 218, 58, 'PPL', 'P'),
(113854, 'Oakdale', 41.4661102294922, 0.72372015149954, -72.1577835083008, -1.25939090316111, 218, 8, 'PPL', 'P'),
(117089, 'Oakdale', 41.7063903808594, 0.727913831268088, -91.602783203125, -1.59877017088509, 218, 16, 'PPL', 'P'),
(123343, 'Oakdale', 40.7683296203613, 0.711541582413635, -86.0536117553711, -1.50191885836412, 218, 19, 'PPL', 'P'),
(125712, 'Oakdale', 42.3902816772461, 0.739849986115769, -71.7938919067383, -1.25303979659349, 218, 23, 'PPL', 'P'),
(128407, 'Oakdale', 43.660831451416, 0.762025262985504, -70.2816696166992, -1.22664653861026, 218, 26, 'PPL', 'P'),
(137242, 'Oakdale', 44.9630584716797, 0.78475341209754, -92.9647216796875, -1.6225404815107, 218, 28, 'PPL', 'P'),
(142566, 'Oakdale', 42.0697212219238, 0.734255150718703, -97.9688873291016, -1.70987964840818, 218, 35, 'PPL', 'P'),
(151327, 'Oakdale', 40.7438888549805, 0.711115010586032, -73.1391677856445, -1.27651929002807, 218, 40, 'PPL', 'P'),
(165435, 'Oakdale', 40.9919395446777, 0.715444311833092, -75.9205627441406, -1.3250637898522, 218, 45, 'PPL', 'P'),
(175631, 'Oakdale', 43.9597206115723, 0.767241862928751, -90.3816680908203, -1.57745769162951, 218, 57, 'PPL', 'P'),
(183759, 'Oakdale', 37.7666702270508, 0.659152742976951, -120.84610748291, -2.10916246379574, 218, 6, 'PPL', 'P'),
(198702, 'Oakdale', 47.4730606079102, 0.828561213606853, -102.864440917969, -1.79532317724173, 218, 34, 'PPL', 'P'),
(201334, 'Oakdale', 44.9055595397949, 0.783749866419771, -123.379173278809, -2.15337280210382, 218, 43, 'PPL', 'P'),
(205184, 'Oakdale', 40.646671295166, 0.709418244076515, -111.840278625488, -1.95198109836261, 218, 52, 'PPL', 'P'),
(10907, 'Oakdale (historical)', 33.7924995422363, 0.589790379490701, -91.6269378662109, -1.59919174928565, 218, 4, 'PPL', 'P'),
(56624, 'Oakdale (historical)', 37.3405609130859, 0.65171573247485, -91.0650024414063, -1.58938412593921, 218, 29, 'PPL', 'P'),
(156898, 'Oakdale (historical)', 41.1327781677246, 0.717902409519235, -83.9577789306641, -1.46533967500161, 218, 41, 'PPL', 'P'),
(4704, 'Oakdale Acres', 34.8163909912109, 0.607660656458323, -86.9097213745117, -1.51686078997612, 218, 2, 'PPL', 'P'),
(49982, 'Oakdale Acres', 38.4311103820801, 0.670749411364673, -75.5708312988281, -1.31895982463373, 218, 25, 'PPL', 'P'),
(82707, 'Oakdale Acres', 34.8772201538086, 0.608722325626883, -81.0522232055664, -1.41462816099849, 218, 48, 'PPL', 'P'),
(23557, 'Oakdale Estates', 33.6563911437988, 0.58741483979835, -84.8041687011719, -1.48011196325217, 218, 13, 'PPL', 'P'),
(82708, 'Oakdale Estates', 32.9958305358887, 0.575885882281342, -80.2133331298828, -1.3999867671155, 218, 48, 'PPL', 'P'),
(104842, 'Oakdale Farms', 36.9219398498535, 0.644409416603245, -76.2572174072266, -1.33093952216524, 218, 53, 'PPL', 'P'),
(49983, 'Oakdale Manor', 39.5924987792969, 0.691019462790566, -76.8636093139648, -1.34152305749527, 218, 25, 'PPL', 'P'),
(113855, 'Oakdale Manor', 41.4444389343262, 0.723341916045722, -73.2527770996094, -1.27850214661769, 218, 8, 'PPL', 'P'),
(23558, 'Oakdale Woods', 33.9249992370605, 0.592102935423271, -83.9805603027344, -1.46573728495236, 218, 13, 'PPL', 'P'),
(23559, 'Oakengate', 33.8194389343262, 0.590260560581154, -84.2188873291016, -1.46989687625896, 218, 13, 'PPL', 'P'),
(140630, 'Oakes', 46.1386108398438, 0.80527067145162, -98.0899963378906, -1.71199339936537, 218, 34, 'PPL', 'P'),
(151328, 'Oakes', 41.688060760498, 0.727593919042142, -73.9502792358398, -1.2906758554346, 218, 40, 'PPL', 'P'),
(128408, 'Oakes Corner', 44.2872200012207, 0.772957805576388, -69.2699966430664, -1.20898951426693, 218, 26, 'PPL', 'P'),
(208297, 'Oakesdale', 47.1283302307129, 0.822544533493119, -117.241668701172, -2.04625313936783, 218, 56, 'PPL', 'P'),
(205186, 'Oakeson Villa', 40.6555595397949, 0.709573373210012, -111.967498779297, -1.95420150892146, 218, 52, 'PPL', 'P'),
(82709, 'Oakey Bay', 33.8436088562012, 0.590682405297823, -79.1333312988281, -1.38113717923603, 218, 48, 'PPL', 'P'),
(4715, 'Oakey Grove', 31.4883308410645, 0.54957504913385, -85.2600021362305, -1.48806775753462, 218, 2, 'PPL', 'P'),
(23561, 'Oakfield', 31.7777805328369, 0.554626899274162, -83.9713897705078, -1.46557722897085, 218, 13, 'PPL', 'P'),
(89576, 'Oakfield', 35.7133293151855, 0.623315183398999, -88.7938919067383, -1.54974576943253, 218, 50, 'PPL', 'P'),
(117090, 'Oakfield', 41.5333290100098, 0.724893340538747, -94.9075012207031, -1.65644838114181, 218, 16, 'PPL', 'P'),
(128409, 'Oakfield', 46.0988883972168, 0.804577384040845, -68.1505584716797, -1.18945163240373, 218, 26, 'PPL', 'P'),
(151330, 'Oakfield', 43.0658302307129, 0.751640532630849, -78.2699966430664, -1.36606914694642, 218, 40, 'PPL', 'P'),
(156899, 'Oakfield', 41.4088897705078, 0.72272146609076, -80.8499984741211, -1.4110986736058, 218, 41, 'PPL', 'P'),
(175634, 'Oakfield', 43.6861114501953, 0.762466482199103, -88.54638671875, -1.54542598898637, 218, 57, 'PPL', 'P'),
(120861, 'Oakford', 40.1025009155273, 0.699920679259993, -89.9630584716797, -1.57015157549499, 218, 18, 'PPL', 'P'),
(123344, 'Oakford', 40.4191703796387, 0.705447604049261, -86.1041717529297, -1.50280129679132, 218, 19, 'PPL', 'P'),
(165437, 'Oakford', 40.1483306884766, 0.700720559693398, -74.9641723632813, -1.3083716287718, 218, 45, 'PPL', 'P'),
(4706, 'Oakfuskee (historical)', 32.8166694641113, 0.572758931687426, -85.8736114501953, -1.49877726038421, 218, 2, 'PPL', 'P'),
(4707, 'Oakfuskudshi (historical)', 32.9694404602051, 0.575425288570813, -85.6458282470703, -1.49480169350894, 218, 2, 'PPL', 'P'),
(120863, 'Oakglen', 41.563060760498, 0.725412257477149, -87.5583267211914, -1.52818108882172, 218, 18, 'PPL', 'P'),
(10908, 'Oakgrove', 36.4561080932617, 0.636279118690369, -93.436393737793, -1.6307727119143, 218, 4, 'PPL', 'P'),
(67382, 'Oakgrove', 35.2730598449707, 0.615631031547739, -81.4247207641602, -1.42112946985159, 218, 33, 'PPL', 'P'),
(82711, 'Oakgrove', 32.6266708374023, 0.569442830077086, -80.2130584716797, -1.39998197342554, 218, 48, 'PPL', 'P'),
(156900, 'Oakgrove', 40.1405601501465, 0.700584938214886, -81.2286071777344, -1.41770664206056, 218, 41, 'PPL', 'P'),
(165438, 'Oakgrove', 40.2999992370605, 0.703367675237909, -77.279167175293, -1.34877591040799, 218, 45, 'PPL', 'P'),
(73749, 'Oakgrove (historical)', 38.9913902282715, 0.680528139413281, -81.9080581665039, -1.42956529892052, 218, 41, 'PPL', 'P'),
(125713, 'Oakham', 42.3527793884277, 0.739195447698854, -72.0458297729492, -1.25743694186932, 218, 23, 'PPL', 'P'),
(10909, 'Oakhaven', 33.7291717529297, 0.58868510105929, -93.6205596923828, -1.63398701419197, 218, 4, 'PPL', 'P'),
(67383, 'Oakhaven Farms', 36.4686088562012, 0.636497298162674, -79.5325012207031, -1.38810400864768, 218, 33, 'PPL', 'P'),
(104843, 'Oakhaven Farms', 37.4388885498047, 0.653431873481297, -77.6152801513672, -1.35464218849916, 218, 53, 'PPL', 'P'),
(4708, 'Oakhill', 31.9208297729492, 0.557123579506598, -87.0827789306641, -1.51988121412643, 218, 2, 'PPL', 'P'),
(23564, 'Oakhill', 33.5602798461914, 0.585737381206736, -84.2302780151367, -1.47009568123433, 218, 13, 'PPL', 'P'),
(42391, 'Oakhill', 31.7619400024414, 0.554350429863498, -93.1477813720703, -1.62573547587047, 218, 22, 'PPL', 'P'),
(49984, 'Oakhill', 39.0855598449707, 0.682171709280023, -76.5694427490234, -1.33638888238776, 218, 25, 'PPL', 'P'),
(56625, 'Oakhill', 36.5008316040039, 0.637059691205871, -93.7099990844727, -1.63554802606492, 218, 29, 'PPL', 'P'),
(104844, 'Oakhill', 37.1933288574219, 0.649146048339032, -77.4561080932617, -1.35186411200804, 218, 53, 'PPL', 'P'),
(4709, 'Oakhurst', 33.5558280944824, 0.585659683481933, -86.836669921875, -1.51558580160425, 218, 2, 'PPL', 'P'),
(17354, 'Oakhurst', 30.3875007629395, 0.530361939765582, -81.6736068725586, -1.42547335190562, 218, 12, 'PPL', 'P'),
(23566, 'Oakhurst', 33.7633285522461, 0.589281249669305, -84.3108291625977, -1.47150156397378, 218, 13, 'PPL', 'P'),
(49985, 'Oakhurst', 39.4152793884277, 0.687926400921521, -76.4902801513672, -1.33500723441422, 218, 25, 'PPL', 'P'),
(76771, 'Oakhurst', 36.0752792358398, 0.629632401241749, -96.0641708374023, -1.67663607431099, 218, 42, 'PPL', 'P'),
(82712, 'Oakhurst', 34.5800018310547, 0.603534887297572, -80.6469421386719, -1.40755467198518, 218, 48, 'PPL', 'P'),
(96689, 'Oakhurst', 30.7369403839111, 0.536460811688459, -95.3158264160156, -1.66357500021886, 218, 51, 'PPL', 'P'),
(104845, 'Oakhurst', 37.2000007629395, 0.649262495057696, -77.3722229003906, -1.35040003919877, 218, 53, 'PPL', 'P'),
(132380, 'Oakhurst', 43.639720916748, 0.761656814648692, -83.6061096191406, -1.45920188763731, 218, 27, 'PPL', 'P'),
(145946, 'Oakhurst', 40.2708282470703, 0.702858545416513, -74.0166702270508, -1.2918345968249, 218, 37, 'PPL', 'P'),
(165439, 'Oakhurst', 40.3580589294434, 0.704381008032685, -78.9447174072266, -1.37784524581258, 218, 45, 'PPL', 'P'),
(178737, 'Oakhurst', 33.6425018310547, 0.587172425560125, -111.951110839844, -1.95391548542039, 218, 5, 'PPL', 'P'),
(183760, 'Oakhurst', 37.3280601501465, 0.651497553002545, -119.648330688477, -2.08825731502889, 218, 6, 'PPL', 'P'),
(10910, 'Oakhurst (historical)', 33.8805618286133, 0.591327356334812, -92.6908264160156, -1.61776010735401, 218, 4, 'PPL', 'P'),
(17355, 'Oakhurst (historical)', 27.8388900756836, 0.485880291921452, -82.8019409179688, -1.44516649606037, 218, 12, 'PPL', 'P'),
(183761, 'Oakhurst (historical)', 36.7491683959961, 0.641393985879975, -119.437217712402, -2.08457269850271, 218, 6, 'PPL', 'P'),
(17356, 'Oakhurst Acres', 27.8638896942139, 0.486316617576548, -82.8375015258789, -1.44578714575241, 218, 12, 'PPL', 'P'),
(145947, 'Oakhurst Manor', 40.2602806091309, 0.702674454406162, -74.0124969482422, -1.29176175936908, 218, 37, 'PPL', 'P'),
(67386, 'Oakhurst River Estates', 34.7616691589355, 0.606705580312393, -77.4716720581055, -1.35213575443923, 218, 33, 'PPL', 'P'),
(17357, 'Oakhurst Shores', 27.8250007629395, 0.485637877683228, -82.8000030517578, -1.44513267391453, 218, 12, 'PPL', 'P'),
(17358, 'Oakhurst Terrace', 27.8527793884277, 0.486122706159677, -82.8249969482422, -1.44556889970108, 218, 12, 'PPL', 'P'),
(49986, 'Oakington', 39.503059387207, 0.689458450917616, -76.1147232055664, -1.32845252918127, 218, 25, 'PPL', 'P'),
(49987, 'Oakington Manor', 39.5122184753418, 0.689618307162048, -76.1277770996094, -1.32868036261252, 218, 25, 'PPL', 'P'),
(37482, 'Oakla', 38.2480583190918, 0.66755455016296, -83.7249984741211, -1.46127688960064, 218, 21, 'PPL', 'P'),
(96690, 'Oaklake', 31.5722408294678, 0.551039554706798, -97.013069152832, -1.69319747418186, 218, 51, 'PPL', 'P'),
(4713, 'Oakland', 34.7291717529297, 0.606138393579234, -86.8069381713867, -1.51506688466584, 218, 2, 'PPL', 'P'),
(10912, 'Oakland', 36.4608306884766, 0.636361543526107, -92.5708312988281, -1.61566579747277, 218, 4, 'PPL', 'P'),
(14336, 'Oakland', 39.6805610656738, 0.692556439634678, -75.7652816772461, -1.32235362396888, 218, 10, 'PPL', 'P'),
(17359, 'Oakland', 28.5547199249268, 0.4983738796748, -81.6333312988281, -1.42477041053589, 218, 12, 'PPL', 'P'),
(23571, 'Oakland', 33.1083297729492, 0.577849364374031, -84.5911102294922, -1.47639339142209, 218, 13, 'PPL', 'P'),
(28096, 'Oakland', 39.6538887023926, 0.692090919076132, -88.0261077880859, -1.53634540861752, 218, 18, 'PPL', 'P'),
(33468, 'Oakland', 39.0666694641113, 0.681842009937071, -95.6361083984375, -1.66916497534694, 218, 20, 'PPL', 'P'),
(37483, 'Oakland', 37.0419387817383, 0.64650379306351, -86.2483291625977, -1.50531731823117, 218, 21, 'PPL', 'P'),
(42394, 'Oakland', 32.9955596923828, 0.575881155170408, -92.3505630493164, -1.61182139128119, 218, 22, 'PPL', 'P'),
(56627, 'Oakland', 38.5763893127441, 0.673285007038538, -90.3855590820313, -1.57752560223731, 218, 29, 'PPL', 'P'),
(61137, 'Oakland', 34.0555610656738, 0.594381669209997, -89.916389465332, -1.56933704767559, 218, 30, 'PPL', 'P'),
(67389, 'Oakland', 35.1133308410645, 0.612843234518644, -82.9755630493164, -1.44819677390672, 218, 33, 'PPL', 'P'),
(76772, 'Oakland', 34.0999984741211, 0.595157248298456, -96.7936096191406, -1.68936718274406, 218, 42, 'PPL', 'P'),
(82714, 'Oakland', 33.982780456543, 0.593111407949057, -80.4886093139648, -1.40479124288006, 218, 48, 'PPL', 'P'),
(89589, 'Oakland', 36.2708282470703, 0.63304537533674, -86.3424987792969, -1.50696088809792, 218, 50, 'PPL', 'P'),
(96696, 'Oakland', 32.5711097717285, 0.568473106545161, -95.7552795410156, -1.67124490415829, 218, 51, 'PPL', 'P'),
(104849, 'Oakland', 36.851390838623, 0.643178104073246, -76.5899963378906, -1.33674761018659, 218, 53, 'PPL', 'P'),
(110731, 'Oakland', 39.4811096191406, 0.689075355194808, -78.2519378662109, -1.36575396183141, 218, 58, 'PPL', 'P'),
(112896, 'Oakland', 38.9886093139648, 0.680479603302414, -75.8763885498047, -1.32429280471662, 218, 25, 'PPL', 'P'),
(113856, 'Oakland', 41.8061103820801, 0.729654273619482, -72.5183334350586, -1.26568368650086, 218, 8, 'PPL', 'P'),
(117093, 'Oakland', 41.3091697692871, 0.720981023739366, -95.3963928222656, -1.66498114927442, 218, 16, 'PPL', 'P'),
(125715, 'Oakland', 41.9111099243164, 0.731486861344593, -71.1388931274414, -1.24160791129822, 218, 23, 'PPL', 'P'),
(128411, 'Oakland', 44.5402793884277, 0.77737452508623, -69.7225036621094, -1.21688725163761, 218, 26, 'PPL', 'P'),
(137244, 'Oakland', 43.6738891601563, 0.762253162995788, -93.0886077880859, -1.62470270199974, 218, 28, 'PPL', 'P'),
(142568, 'Oakland', 41.8358306884766, 0.730172990820802, -96.466667175293, -1.6836609606344, 218, 35, 'PPL', 'P'),
(145948, 'Oakland', 41.0130615234375, 0.715812959906986, -74.2647171020508, -1.29616383149293, 218, 37, 'PPL', 'P'),
(151332, 'Oakland', 42.5777816772461, 0.743122478463258, -77.9705581665039, -1.36084295962325, 218, 40, 'PPL', 'P'),
(156901, 'Oakland', 40.0513916015625, 0.69902865345287, -82.7774963378906, -1.44473985765374, 218, 41, 'PPL', 'P'),
(165445, 'Oakland', 41.9500007629395, 0.732165634527427, -75.6052780151367, -1.31956103324982, 218, 45, 'PPL', 'P'),
(169528, 'Oakland', 41.957218170166, 0.732291602046987, -71.6483306884766, -1.25049927407161, 218, 47, 'PPL', 'P'),
(172365, 'Oakland', 44.7430610656738, 0.780913733016891, -73.0852813720703, -1.27557879468911, 218, 55, 'PPL', 'P'),
(175638, 'Oakland', 42.9766693115234, 0.750084381026889, -88.9555587768555, -1.55256738860747, 218, 57, 'PPL', 'P'),
(183762, 'Oakland', 37.8044395446777, 0.659811941925772, -122.269721984863, -2.13400922413396, 218, 6, 'PPL', 'P'),
(201335, 'Oakland', 43.4222183227539, 0.757860678251865, -123.297218322754, -2.15194241828234, 218, 43, 'PPL', 'P'),
(208299, 'Oakland', 47.2313919067383, 0.824343299072386, -122.488059997559, -2.13781994133776, 218, 56, 'PPL', 'P'),
(56628, 'Oakland (historical)', 38.9669418334961, 0.680101434427623, -93.8422164916992, -1.63785565514947, 218, 29, 'PPL', 'P'),
(73753, 'Oakland (historical)', 39.9402809143066, 0.697089406126102, -81.9783325195313, -1.43079181776056, 218, 41, 'PPL', 'P'),
(89590, 'Oakland (historical)', 35.6458282470703, 0.622137067511776, -86.9033279418945, -1.51674920352645, 218, 50, 'PPL', 'P'),
(49995, 'Oakland Acres', 38.3072204589844, 0.668587124296611, -75.5638885498047, -1.31883865080414, 218, 25, 'PPL', 'P'),
(117094, 'Oakland Acres', 41.7172203063965, 0.728102849126456, -92.8202819824219, -1.62001953322283, 218, 16, 'PPL', 'P'),
(169529, 'Oakland Beach', 41.6925010681152, 0.727671417029863, -71.3994369506836, -1.24615525885953, 218, 47, 'PPL', 'P'),
(120865, 'Oakland Center', 40.2338905334473, 0.702213860695633, -90.5083312988281, -1.57966838165039, 218, 18, 'PPL', 'P'),
(30708, 'Oakland City', 38.3386116027832, 0.669135003111867, -87.3450012207031, -1.52445785645974, 218, 19, 'PPL', 'P'),
(30709, 'Oakland City Junction', 38.3316688537598, 0.669013829282269, -87.3013916015625, -1.52369672502019, 218, 19, 'PPL', 'P'),
(82715, 'Oakland Crossroads', 34.538890838623, 0.602817365120878, -79.3663864135742, -1.38520475832696, 218, 48, 'PPL', 'P'),
(4714, 'Oakland Estates', 31.2730598449707, 0.545817861467966, -85.3963928222656, -1.49044822407499, 218, 2, 'PPL', 'P'),
(49996, 'Oakland Estates', 38.5158309936523, 0.672228064980913, -76.9661102294922, -1.34331203595753, 218, 25, 'PPL', 'P'),
(89592, 'Oakland Estates', 35.8838882446289, 0.626291998286463, -86.3561096191406, -1.50719844206715, 218, 50, 'PPL', 'P'),
(96697, 'Oakland Estates', 29.5375003814697, 0.515526634465728, -98.5997161865234, -1.72088968898678, 218, 51, 'PPL', 'P'),
(104852, 'Oakland Estates', 37.3300018310547, 0.651531441727416, -79.9436111450195, -1.39527923041462, 218, 53, 'PPL', 'P'),
(113858, 'Oakland Gardens', 41.7324981689453, 0.7283694981306, -72.7841720581055, -1.270323445752, 218, 8, 'PPL', 'P'),
(151333, 'Oakland Gardens', 40.7538909912109, 0.711289580795486, -73.7663879394531, -1.28746634684689, 218, 40, 'PPL', 'P'),
(10913, 'Oakland Heights', 34.2719383239746, 0.598158164793784, -92.1291732788086, -1.60795741085559, 218, 4, 'PPL', 'P'),
(23572, 'Oakland Heights', 34.2122192382813, 0.597115870122154, -84.795280456543, -1.47995683411868, 218, 13, 'PPL', 'P'),
(67393, 'Oakland Heights', 35.9011116027832, 0.626592602594506, -80.6897201538086, -1.40830128919679, 218, 33, 'PPL', 'P'),
(125716, 'Oakland Heights', 42.2249984741211, 0.736965250022995, -71.7805633544922, -1.25280716947227, 218, 23, 'PPL', 'P'),
(175639, 'Oakland Heights', 43.0661087036133, 0.751645392899839, -89.4119415283203, -1.56053277026984, 218, 57, 'PPL', 'P'),
(49997, 'Oakland Hill', 39.0461082458496, 0.681483148980183, -76.4711074829102, -1.33467260822326, 218, 25, 'PPL', 'P'),
(49998, 'Oakland Hills', 39.413330078125, 0.687892379038595, -76.9019393920898, -1.34219204356109, 218, 25, 'PPL', 'P'),
(49999, 'Oakland Mills', 39.2186088562012, 0.684493852592518, -76.8441696166992, -1.34118377077239, 218, 25, 'PPL', 'P'),
(117095, 'Oakland Mills', 40.9361114501953, 0.714469927769259, -91.6163864135742, -1.59900759169627, 218, 16, 'PPL', 'P'),
(145949, 'Oakland Mills', 40.2330589294434, 0.702199346467692, -74.3447189331055, -1.29756012685246, 218, 37, 'PPL', 'P'),
(165446, 'Oakland Mills', 40.6144409179688, 0.708855717875263, -77.3172225952148, -1.34944010278385, 218, 45, 'PPL', 'P'),
(23573, 'Oakland North', 33.9436111450195, 0.592427774497233, -84.0563888549805, -1.46706074285608, 218, 13, 'PPL', 'P'),
(17361, 'Oakland Park', 28.8036098480225, 0.502717828307856, -81.6774978637695, -1.42554126251341, 218, 12, 'PPL', 'P'),
(23574, 'Oakland Park', 32.4130592346191, 0.565714604288057, -84.960563659668, -1.48284157021145, 218, 13, 'PPL', 'P'),
(50000, 'Oakland Park', 39.3716697692871, 0.687165269481976, -76.7677764892578, -1.33985045917264, 218, 25, 'PPL', 'P'),
(56629, 'Oakland Park', 37.1127815246582, 0.647740232178607, -94.475830078125, -1.64891429841797, 218, 29, 'PPL', 'P'),
(104853, 'Oakland Park', 37.5105590820313, 0.654682760245307, -75.8216705322266, -1.32333779514971, 218, 53, 'PPL', 'P'),
(125717, 'Oakland Square', 42.0361099243164, 0.733668522909586, -70.8005599975586, -1.23570288421319, 218, 23, 'PPL', 'P'),
(104854, 'Oakland Terrace', 37.2902793884277, 0.650838154316641, -79.9322204589844, -1.39508042543925, 218, 53, 'PPL', 'P'),
(125718, 'Oakland Vale', 42.4716682434082, 0.74127044966219, -71.0319366455078, -1.23974116853213, 218, 23, 'PPL', 'P'),
(151334, 'Oakland Valley', 41.5069389343262, 0.724432746828218, -74.6494369506836, -1.30287845954934, 218, 40, 'PPL', 'P'),
(30710, 'Oaklandon', 39.8727798461914, 0.695911290238878, -85.9569396972656, -1.5002316126555, 218, 19, 'PPL', 'P'),
(50001, 'Oaklands', 38.7391700744629, 0.676126067289434, -76.1005630493164, -1.32820538783211, 218, 25, 'PPL', 'P'),
(104855, 'Oaklands', 37.6916694641113, 0.657843732722149, -77.852783203125, -1.35878739873587, 218, 53, 'PPL', 'P'),
(125719, 'Oaklands', 42.6333312988281, 0.744092002258101, -71.2861099243164, -1.24417732911793, 218, 23, 'PPL', 'P'),
(165451, 'Oaklane', 40.0550003051758, 0.699091637212651, -75.1233291625977, -1.3111494389468, 218, 45, 'PPL', 'P'),
(10914, 'Oaklawn', 33.9111099243164, 0.591860521185046, -91.4305572509766, -1.59576426096272, 218, 4, 'PPL', 'P'),
(23577, 'Oaklawn', 33.329719543457, 0.581713344799626, -84.7808303833008, -1.47970463276344, 218, 13, 'PPL', 'P'),
(33471, 'Oaklawn', 37.610279083252, 0.656423202596701, -97.2966690063477, -1.69814722538389, 218, 20, 'PPL', 'P'),
(42396, 'Oaklawn', 30.2986106872559, 0.528810515272557, -89.9211120605469, -1.56941947251133, 218, 22, 'PPL', 'P'),
(50002, 'Oaklawn', 38.7727813720703, 0.676712695098551, -76.9511108398438, -1.34305024722237, 218, 25, 'PPL', 'P'),
(61138, 'Oaklawn', 32.0050010681152, 0.558592645742913, -90.9977798461914, -1.58821087032098, 218, 30, 'PPL', 'P'),
(82717, 'Oaklawn', 33.9469413757324, 0.592485897988024, -80.345832824707, -1.40229932304807, 218, 48, 'PPL', 'P'),
(89597, 'Oaklawn', 35.2841682434082, 0.615824909675097, -90.0400009155273, -1.57149447447466, 218, 50, 'PPL', 'P'),
(169530, 'Oaklawn', 41.7519416809082, 0.728708851432504, -71.477783203125, -1.24752265892123, 218, 47, 'PPL', 'P'),
(201336, 'Oaklawn', 45.1194381713867, 0.787482752740708, -122.728332519531, -2.14201348794825, 218, 43, 'PPL', 'P'),
(132383, 'Oaklawn Beechwood', 42.8050003051758, 0.747088191642495, -86.1144409179688, -1.50298052753268, 218, 27, 'PPL', 'P'),
(205190, 'Oakleaf', 40.8469390869141, 0.712913576428217, -111.896110534668, -1.95295554900547, 218, 52, 'PPL', 'P'),
(42397, 'Oakleaf Estates', 31.7636108398438, 0.554379591477435, -93.1366729736328, -1.62554159774311, 218, 22, 'PPL', 'P'),
(172366, 'Oakledge Park', 44.4530601501465, 0.775852262207141, -73.2300033569336, -1.27810466982499, 218, 55, 'PPL', 'P'),
(50003, 'Oaklee Village', 39.2677803039551, 0.685352056253796, -76.6852798461914, -1.33841062112929, 218, 25, 'PPL', 'P'),
(50004, 'Oakleigh', 39.4049987792969, 0.687746970443077, -76.5591735839844, -1.33620965164639, 218, 25, 'PPL', 'P'),
(165452, 'Oakleigh', 40.2580604553223, 0.702635705412301, -76.8208312988281, -1.34077644028366, 218, 45, 'PPL', 'P'),
(50005, 'Oakleigh Forest', 39.0794410705566, 0.682064916520311, -76.5388870239258, -1.33585558437947, 218, 25, 'PPL', 'P'),
(50006, 'Oakleigh Manor', 39.3952789306641, 0.687577327081639, -76.5563888549805, -1.3361610489565, 218, 25, 'PPL', 'P'),
(50007, 'Oakleigh Ridge', 39.6986083984375, 0.692871425012607, -76.9261093139648, -1.34261388827776, 218, 25, 'PPL', 'P'),
(50008, 'Oaklett Estates', 39.6886100769043, 0.69269692138218, -77.8249969482422, -1.35830243710137, 218, 25, 'PPL', 'P'),
(104857, 'Oaklette', 36.8266716003418, 0.642746671976654, -76.2386093139648, -1.3306147496703, 218, 53, 'PPL', 'P'),
(818, 'Oakley', 39.1536102294922, 0.683359412547171, -84.4250030517578, -1.47349427425943, 218, 41, 'PPL', 'P'),
(4717, 'Oakley', 32.9911117553711, 0.575803524024632, -86.9022216796875, -1.51672989560854, 218, 2, 'PPL', 'P'),
(14337, 'Oakley', 38.8063888549805, 0.677299256328642, -75.4891662597656, -1.31753450081832, 218, 10, 'PPL', 'P'),
(28097, 'Oakley', 39.8761100769043, 0.695969413729669, -88.8058319091797, -1.54995416178783, 218, 18, 'PPL', 'P'),
(37484, 'Oakley', 37.2383308410645, 0.649931481123524, -84.0977783203125, -1.46778312530176, 218, 21, 'PPL', 'P'),
(42400, 'Oakley', 30.2688903808594, 0.528291798071237, -91.103889465332, -1.59006283254302, 218, 22, 'PPL', 'P'),
(50009, 'Oakley', 38.2727813720703, 0.66798604883858, -76.7399978637695, -1.33936563069619, 218, 25, 'PPL', 'P'),
(56630, 'Oakley', 37.1488914489746, 0.648370469250574, -90.9552764892578, -1.58746904679934, 218, 29, 'PPL', 'P'),
(61139, 'Oakley', 32.2174987792969, 0.562301430455984, -90.503059387207, -1.57957636943472, 218, 30, 'PPL', 'P'),
(67400, 'Oakley', 35.7577781677246, 0.62409096222454, -77.2869415283203, -1.34891159846553, 218, 33, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(82718, 'Oakley', 33.1238899230957, 0.578120940226191, -80.019172668457, -1.39659802778643, 218, 48, 'PPL', 'P'),
(89602, 'Oakley', 36.5077781677246, 0.637180931614497, -85.3105621337891, -1.48895019596182, 218, 50, 'PPL', 'P'),
(104858, 'Oakley', 37.7747192382813, 0.659293224724452, -76.7552795410156, -1.33963234627936, 218, 53, 'PPL', 'P'),
(117098, 'Oakley', 41.1011085510254, 0.717349670434989, -93.3649978637695, -1.62952661884025, 218, 16, 'PPL', 'P'),
(123345, 'Oakley', 40.7019386291504, 0.710382841023342, -86.0124969482422, -1.5012012696084, 218, 19, 'PPL', 'P'),
(132384, 'Oakley', 43.139720916748, 0.75293016838872, -84.1680603027344, -1.46900977729985, 218, 27, 'PPL', 'P'),
(165453, 'Oakley', 41.7366714477539, 0.728442335586414, -75.7547225952148, -1.32216933322144, 218, 45, 'PPL', 'P'),
(175643, 'Oakley', 42.5269393920898, 0.742235113188044, -89.4677810668945, -1.56150735407075, 218, 57, 'PPL', 'P'),
(183763, 'Oakley', 37.997501373291, 0.663181506494995, -121.711387634277, -2.12426445138925, 218, 6, 'PPL', 'P'),
(187829, 'Oakley', 39.1333312988281, 0.6830054784383, -100.863327026367, -1.76039715112589, 218, 20, 'PPL', 'P'),
(195401, 'Oakley', 42.2433280944824, 0.73728516224894, -113.88111114502, -1.9876003453102, 218, 17, 'PPL', 'P'),
(205191, 'Oakley', 40.7147216796875, 0.710605947343663, -111.300003051758, -1.94255151073291, 218, 52, 'PPL', 'P'),
(42401, 'Oakley Landing', 32.0311088562012, 0.559048312605425, -91.6197204589844, -1.59906578176609, 218, 22, 'PPL', 'P'),
(104859, 'Oakley Landing', 37.7986106872559, 0.659710209172131, -76.6527786254883, -1.3378433678171, 218, 53, 'PPL', 'P'),
(132385, 'Oakley Park', 42.5688896179199, 0.742967282750734, -83.4966735839844, -1.4572918685035, 218, 27, 'PPL', 'P'),
(73756, 'Oakley Square', 39.1511116027832, 0.683315803284321, -84.4336090087891, -1.47364447654492, 218, 41, 'PPL', 'P'),
(71197, 'Oaklyn', 39.9008293151855, 0.696400845826262, -75.0849990844727, -1.31048045288098, 218, 37, 'PPL', 'P'),
(89603, 'Oaklyn', 35.961109161377, 0.627639757535125, -85.0680618286133, -1.48471776719941, 218, 50, 'PPL', 'P'),
(165454, 'Oaklyn', 40.8583297729492, 0.713112381403591, -76.7544403076172, -1.33961769889337, 218, 45, 'PPL', 'P'),
(50010, 'Oaklyn Manor', 39.4291687011719, 0.688168815159745, -76.3766708374023, -1.33302437782461, 218, 25, 'PPL', 'P'),
(4718, 'Oakman', 33.7133293151855, 0.588408598359113, -87.3886108398438, -1.52521898789928, 218, 2, 'PPL', 'P'),
(23578, 'Oakman', 34.5663909912109, 0.603297333328337, -84.7083282470703, -1.47843923177149, 218, 13, 'PPL', 'P'),
(76773, 'Oakman', 34.832218170166, 0.607936892842392, -96.6166687011719, -1.686278981144, 218, 42, 'PPL', 'P'),
(89618, 'Oakman (historical)', 36.3488883972168, 0.634407781971398, -83.5605621337891, -1.45840693405192, 218, 50, 'PPL', 'P'),
(14338, 'Oakmont', 39.711109161377, 0.693089604484912, -75.5527801513672, -1.31864477267678, 218, 10, 'PPL', 'P'),
(50013, 'Oakmont', 39.0036087036133, 0.680741392037569, -77.1136093139648, -1.34588638062525, 218, 25, 'PPL', 'P'),
(56647, 'Oakmont', 36.5325012207031, 0.637612430290117, -93.2783279418945, -1.62801394334109, 218, 29, 'PPL', 'P'),
(112546, 'Oakmont', 32.4013900756836, 0.565510939043693, -80.7680587768555, -1.40966855610043, 218, 48, 'PPL', 'P'),
(156902, 'Oakmont', 41.5416717529297, 0.725038948871347, -83.5972213745117, -1.45904675850381, 218, 41, 'PPL', 'P'),
(165456, 'Oakmont', 40.2516708374023, 0.702524185541654, -76.6900024414063, -1.33849304596503, 218, 45, 'PPL', 'P'),
(177259, 'Oakmont', 40.0622215270996, 0.699217671311239, -80.6766662597656, -1.40807345576553, 218, 58, 'PPL', 'P'),
(183764, 'Oakmont', 38.4408302307129, 0.670919054726111, -122.603332519531, -2.13983182638326, 218, 6, 'PPL', 'P'),
(67402, 'Oakmont Estates', 35.8466682434082, 0.625642386717565, -81.5444412231445, -1.42321898604286, 218, 33, 'PPL', 'P'),
(177260, 'Oakmont Hills', 40.0675010681152, 0.699309816684956, -80.6722183227539, -1.40799582461975, 218, 58, 'PPL', 'P'),
(50014, 'Oakmont Manor', 39.1327781677246, 0.682995824479348, -77.1836090087891, -1.34710810577533, 218, 25, 'PPL', 'P'),
(4719, 'Oakmulgee', 32.7963905334473, 0.572404997578554, -87.0438919067383, -1.51920250752263, 218, 2, 'PPL', 'P'),
(42403, 'Oaknolia', 30.732780456543, 0.536388207259241, -90.9905624389648, -1.58808490280142, 218, 22, 'PPL', 'P'),
(104860, 'Oakpark', 38.3666687011719, 0.669624691857306, -78.1602783203125, -1.3641542009646, 218, 53, 'PPL', 'P'),
(156903, 'Oakpoint (historical)', 41.4355583190918, 0.723186920070279, -82.2486114501953, -1.43550907499942, 218, 41, 'PPL', 'P'),
(137247, 'Oakport', 46.9319381713867, 0.819116845433105, -96.7786102294922, -1.6891053940089, 218, 28, 'PPL', 'P'),
(50016, 'Oakridge', 39.3344383239746, 0.686515458175997, -77.3177795410156, -1.34944982332183, 218, 25, 'PPL', 'P'),
(76774, 'Oakridge', 36.0750007629395, 0.62962754097276, -96.0355606079102, -1.6761367316066, 218, 42, 'PPL', 'P'),
(78873, 'Oakridge', 39.9363899230957, 0.697021495518305, -76.7091674804688, -1.33882753899794, 218, 45, 'PPL', 'P'),
(82722, 'Oakridge', 33.9166717529297, 0.59195759340678, -81.2233276367188, -1.41761449668685, 218, 48, 'PPL', 'P'),
(89605, 'Oakridge', 36.3941688537598, 0.635198075024879, -87.4583282470703, -1.52643578620134, 218, 50, 'PPL', 'P'),
(137249, 'Oakridge', 44.1208305358887, 0.770053761565711, -91.9197235107422, -1.60430182278529, 218, 28, 'PPL', 'P'),
(175644, 'Oakridge', 44.5883293151855, 0.778213154513496, -92.3952789306641, -1.61260183063863, 218, 57, 'PPL', 'P'),
(201337, 'Oakridge', 43.7466697692871, 0.763523424256728, -122.460563659668, -2.13734003970932, 218, 43, 'PPL', 'P'),
(205195, 'Oakridge Country Club Estates', 40.9986114501953, 0.715560758551755, -111.917221069336, -1.95332399734228, 218, 52, 'PPL', 'P'),
(10915, 'Oakridge Estates', 35.0158309936523, 0.611141541161111, -92.0025024414063, -1.60574658767666, 218, 4, 'PPL', 'P'),
(205196, 'Oakridge Farms', 41.0027809143066, 0.715633529428542, -111.922218322754, -1.95341121586798, 218, 52, 'PPL', 'P'),
(205200, 'Oakridge Place', 41.000560760498, 0.715594780434681, -111.91056060791, -1.9532077503607, 218, 52, 'PPL', 'P'),
(183765, 'Oakridge Ranches', 33.6061096191406, 0.586537261640142, -116.97444152832, -2.04158914535078, 218, 6, 'PPL', 'P'),
(205202, 'Oakridge Village', 41.0080604553223, 0.715725674802259, -111.918891906738, -1.95335315895622, 218, 52, 'PPL', 'P'),
(205203, 'Oakridge Village Condominium', 41.0041694641113, 0.715657764194461, -111.917221069336, -1.95332399734228, 218, 52, 'PPL', 'P'),
(78874, 'Oakryn', 39.776668548584, 0.694233831647265, -76.1416702270508, -1.32892284342977, 218, 45, 'PPL', 'P'),
(37488, 'Oaks', 36.9683303833008, 0.645219084153656, -88.5441665649414, -1.54538723999251, 218, 21, 'PPL', 'P'),
(42404, 'Oaks', 32.9199981689453, 0.5745623577986, -93.1186065673828, -1.62522627947005, 218, 22, 'PPL', 'P'),
(50017, 'Oaks', 38.4986114501953, 0.671927527251897, -76.7769393920898, -1.3400103819961, 218, 25, 'PPL', 'P'),
(56631, 'Oaks', 39.1963882446289, 0.684106029758775, -94.5694427490234, -1.65054814774674, 218, 29, 'PPL', 'P'),
(61141, 'Oaks', 32.7997207641602, 0.572463121069345, -89.976936340332, -1.57039378999613, 218, 30, 'PPL', 'P'),
(67404, 'Oaks', 35.9533309936523, 0.627504002898558, -79.2574996948242, -1.38330432657308, 218, 33, 'PPL', 'P'),
(76775, 'Oaks', 36.1661109924316, 0.631217714459646, -94.8544387817383, -1.65552226687273, 218, 42, 'PPL', 'P'),
(96698, 'Oaks', 28.6086101531982, 0.499314441592789, -98.0313873291016, -1.71097047919067, 218, 51, 'PPL', 'P'),
(165458, 'Oaks', 40.1316719055176, 0.700429809081388, -75.4599990844727, -1.31702543757595, 218, 45, 'PPL', 'P'),
(183767, 'Oaks', 35.1188888549805, 0.612940240161351, -120.593887329102, -2.10476039167189, 218, 6, 'PPL', 'P'),
(201338, 'Oaks', 43.1875, 0.753764070705051, -123.360832214355, -2.15305269014079, 218, 43, 'PPL', 'P'),
(137250, 'Oaks Corner', 48.4244384765625, 0.845165889845443, -94.9497222900391, -1.65718527781543, 218, 28, 'PPL', 'P'),
(151335, 'Oaks Corners', 42.9322204589844, 0.749308602201349, -77.0127792358398, -1.34412656377693, 218, 40, 'PPL', 'P'),
(82723, 'Oaks Crossroads', 33.4583282470703, 0.5839579901244, -80.6247177124023, -1.40716678257241, 218, 48, 'PPL', 'P'),
(23579, 'Oaks of Cumberland', 33.8916702270508, 0.59152123446217, -84.4730606079102, -1.47433303684475, 218, 13, 'PPL', 'P'),
(50019, 'Oaks of Harford', 39.4650001525879, 0.688794191962723, -76.3230590820313, -1.33208867617561, 218, 25, 'PPL', 'P'),
(50020, 'Oaks of Parsonage', 39.6538887023926, 0.692090919076132, -76.7088928222656, -1.33882274530798, 218, 25, 'PPL', 'P'),
(50021, 'Oaks of Severna Park', 39.0938911437988, 0.682317117875542, -76.5702819824219, -1.33640352977375, 218, 25, 'PPL', 'P'),
(104861, 'Oaks of Shenandoah', 38.6530609130859, 0.674623178907275, -77.4619369506836, -1.35196584476169, 218, 53, 'PPL', 'P'),
(104862, 'Oakshade', 38.5994415283203, 0.673687344100221, -77.9552764892578, -1.36057624404007, 218, 53, 'PPL', 'P'),
(156904, 'Oakshade', 41.6688919067383, 0.727259359430201, -84.1522216796875, -1.4687333411787, 218, 41, 'PPL', 'P'),
(42405, 'Oakshire Manor', 29.6466693878174, 0.517431993067625, -90.7566680908203, -1.58400267632449, 218, 22, 'PPL', 'P'),
(56632, 'Oakside', 37.1072196960449, 0.647643159956873, -91.6522216796875, -1.59963303507827, 218, 29, 'PPL', 'P'),
(151336, 'Oaksville', 42.7247200012207, 0.745687036013977, -75.0052795410156, -1.30908908436946, 218, 40, 'PPL', 'P'),
(73757, 'Oakthorpe', 39.8055610656738, 0.694738101199671, -82.4361114501953, -1.43878156734691, 218, 41, 'PPL', 'P'),
(23580, 'Oakton', 34.5994415283203, 0.603874174020448, -85.2869415283203, -1.48853793862507, 218, 13, 'PPL', 'P'),
(37486, 'Oakton', 36.663330078125, 0.639895824608751, -89.0672225952148, -1.55451628989319, 218, 21, 'PPL', 'P'),
(56633, 'Oakton', 37.4580612182617, 0.653766499672265, -94.353889465332, -1.64678603323284, 218, 29, 'PPL', 'P'),
(67407, 'Oakton', 34.4952812194824, 0.602056233681333, -79.0491714477539, -1.3796683127368, 218, 33, 'PPL', 'P'),
(104863, 'Oakton', 38.8808288574219, 0.678598479466437, -77.3011093139648, -1.34915887297274, 218, 53, 'PPL', 'P'),
(110733, 'Oakton', 38.4877815246582, 0.671738509393529, -81.0475006103516, -1.41454573616275, 218, 58, 'PPL', 'P'),
(120867, 'Oakton', 42.026668548584, 0.733503739817137, -87.6711120605469, -1.53014956434145, 218, 18, 'PPL', 'P'),
(30711, 'Oaktown', 38.8711090087891, 0.678428836104999, -87.4413909912109, -1.52614017532034, 218, 19, 'PPL', 'P'),
(104864, 'Oaktree', 37.3333282470703, 0.65158949863918, -76.7050018310547, -1.33875483470018, 218, 53, 'PPL', 'P'),
(14339, 'Oaktree Apartments', 39.6472206115723, 0.691974538936496, -75.783332824707, -1.32266867592583, 218, 10, 'PPL', 'P'),
(165459, 'Oaktree Hollow', 40.1477813720703, 0.700710972313474, -74.8408279418945, -1.30621886250463, 218, 45, 'PPL', 'P'),
(56634, 'Oakvale', 38.0916709899902, 0.664825076361738, -90.4599990844727, -1.5788248253751, 218, 29, 'PPL', 'P'),
(110734, 'Oakvale', 37.334171295166, 0.651604212604203, -80.9627838134766, -1.41306714912554, 218, 58, 'PPL', 'P'),
(151337, 'Oakvale', 44.3980598449707, 0.774892325792222, -75.7313919067383, -1.32176213589077, 218, 40, 'PPL', 'P'),
(50022, 'Oakview', 39.0161094665527, 0.680959571509874, -76.9811096191406, -1.34357382469268, 218, 25, 'PPL', 'P'),
(56635, 'Oakview', 39.208610534668, 0.68431934896209, -94.5680618286133, -1.65052404613887, 218, 29, 'PPL', 'P'),
(67408, 'Oakview', 35.9930610656738, 0.628197423467387, -80.0252838134766, -1.39670468738809, 218, 33, 'PPL', 'P'),
(89608, 'Oakview', 36.5572204589844, 0.63804386238671, -82.3402786254883, -1.43710896902428, 218, 50, 'PPL', 'P'),
(104874, 'Oakview', 37.3611106872559, 0.652074393694656, -79.2624969482422, -1.38339154509878, 218, 53, 'PPL', 'P'),
(110735, 'Oakview', 39.6666717529297, 0.692314025396454, -79.9705581665039, -1.39574954466313, 218, 58, 'PPL', 'P'),
(156905, 'Oakview', 40.6938896179199, 0.71024235927584, -84.2102813720703, -1.46974667397348, 218, 41, 'PPL', 'P'),
(89609, 'Oakview (historical)', 35.7900009155273, 0.624653355267737, -88.0027770996094, -1.53593821128685, 218, 50, 'PPL', 'P'),
(205204, 'Oakview Estates Subdivision Number 1', 40.6108283996582, 0.708792667536455, -111.808326721191, -1.95142343243035, 218, 52, 'PPL', 'P'),
(205205, 'Oakview Estates Subdivision Numbers 2,3 and 4', 40.6138916015625, 0.708846130495339, -111.797218322754, -1.95122955430299, 218, 52, 'PPL', 'P'),
(110736, 'Oakview Heights', 38.3911094665527, 0.670051263684909, -82.5827789306641, -1.44134139778669, 218, 58, 'PPL', 'P'),
(82724, 'Oakview Park', 32.7419395446777, 0.57145464854356, -79.982780456543, -1.39596286386645, 218, 48, 'PPL', 'P'),
(4722, 'Oakville', 34.4452781677246, 0.601183515792114, -87.1622161865234, -1.52126765578993, 218, 2, 'PPL', 'P'),
(23582, 'Oakville', 31.8525009155273, 0.55593101597046, -84.4641723632813, -1.47417790771126, 218, 13, 'PPL', 'P'),
(37487, 'Oakville', 36.7488899230957, 0.641389125610986, -86.8755569458008, -1.51626450820805, 218, 21, 'PPL', 'P'),
(42406, 'Oakville', 29.7827796936035, 0.519807566049489, -90.0263900756836, -1.57125692050543, 218, 22, 'PPL', 'P'),
(50024, 'Oakville', 38.3911094665527, 0.670051263684909, -76.6438903808594, -1.33768823868361, 218, 25, 'PPL', 'P'),
(56637, 'Oakville', 38.4700012207031, 0.671428184547507, -90.304443359375, -1.57610986580182, 218, 29, 'PPL', 'P'),
(67410, 'Oakville', 36.497501373291, 0.63700156771508, -78.100830078125, -1.3631166334039, 218, 33, 'PPL', 'P'),
(71199, 'Oakville', 39.3619384765625, 0.686995426383456, -74.7569427490234, -1.30475478969536, 218, 37, 'PPL', 'P'),
(89610, 'Oakville', 35.064998626709, 0.611999678243362, -89.9408264160156, -1.56976355292416, 218, 50, 'PPL', 'P'),
(96699, 'Oakville', 28.4488906860352, 0.496526811011262, -98.1016693115234, -1.71219713118876, 218, 51, 'PPL', 'P'),
(104865, 'Oakville', 37.4316711425781, 0.653305905961736, -78.8563919067383, -1.37630367501559, 218, 53, 'PPL', 'P'),
(113859, 'Oakville', 41.5933303833008, 0.725940562058394, -73.0858306884766, -1.27558838206903, 218, 8, 'PPL', 'P'),
(117099, 'Oakville', 41.0997200012207, 0.717325435669069, -91.0444412231445, -1.58902526498233, 218, 16, 'PPL', 'P'),
(123346, 'Oakville', 40.0791702270508, 0.699513481929319, -85.3905563354492, -1.49034635816329, 218, 19, 'PPL', 'P'),
(132386, 'Oakville', 42.0813903808594, 0.734458815963067, -83.5808334350586, -1.45876073500273, 218, 27, 'PPL', 'P'),
(151338, 'Oakville', 40.8588905334473, 0.713122168520597, -72.6100006103516, -1.26728358052573, 218, 40, 'PPL', 'P'),
(165461, 'Oakville', 40.3436088562012, 0.704128806677454, -79.7022171020508, -1.39106610957012, 218, 45, 'PPL', 'P'),
(183766, 'Oakville', 38.436939239502, 0.670851144118314, -122.401107788086, -2.13630233899057, 218, 6, 'PPL', 'P'),
(208300, 'Oakville', 46.8405609130859, 0.817522011414311, -123.231109619141, -2.15078860374006, 218, 56, 'PPL', 'P'),
(82725, 'Oakway', 34.6011085510254, 0.603903269055357, -83.0258331298828, -1.44907415232784, 218, 48, 'PPL', 'P'),
(4725, 'Oakwood', 34.7461090087891, 0.606434004460233, -86.60888671875, -1.51161023472898, 218, 2, 'PPL', 'P'),
(10916, 'Oakwood', 34.7299995422363, 0.606152841228147, -90.7477798461914, -1.58384754719099, 218, 4, 'PPL', 'P'),
(23584, 'Oakwood', 33.5480613708496, 0.585524128582448, -83.9744415283203, -1.46563049219265, 218, 13, 'PPL', 'P'),
(50029, 'Oakwood', 39.540828704834, 0.690117649866438, -76.2230606079102, -1.33034337355522, 218, 25, 'PPL', 'P'),
(56639, 'Oakwood', 39.6852798461914, 0.692638797891389, -91.3966674804688, -1.59517277288461, 218, 29, 'PPL', 'P'),
(67411, 'Oakwood', 36.0397186279297, 0.629011751549706, -79.8499984741211, -1.39364538108586, 218, 33, 'PPL', 'P'),
(76776, 'Oakwood', 35.9316711425781, 0.627125967181821, -98.704719543457, -1.72272234329092, 218, 42, 'PPL', 'P'),
(82729, 'Oakwood', 35.105281829834, 0.612702752771143, -81.0633316040039, -1.41482203912584, 218, 48, 'PPL', 'P'),
(89614, 'Oakwood', 35.7605590820313, 0.624139498335406, -86.4069366455078, -1.50808554102626, 218, 50, 'PPL', 'P'),
(96700, 'Oakwood', 31.5847206115723, 0.551257367994453, -95.8488922119141, -1.67287875348705, 218, 51, 'PPL', 'P'),
(104871, 'Oakwood', 38.5186080932617, 0.672276534512752, -78.7180633544922, -1.37388938632938, 218, 53, 'PPL', 'P'),
(110737, 'Oakwood', 38.3422203063965, 0.669197986871648, -81.6638870239258, -1.42530370854418, 218, 58, 'PPL', 'P'),
(117100, 'Oakwood', 43.0091705322266, 0.750651634339075, -92.7769393920898, -1.61926306231519, 218, 16, 'PPL', 'P'),
(120868, 'Oakwood', 40.1161117553711, 0.700158233229228, -87.7783279418945, -1.5320208344814, 218, 18, 'PPL', 'P'),
(123348, 'Oakwood', 41.5497207641602, 0.725179430618849, -84.9136123657227, -1.48202211554403, 218, 19, 'PPL', 'P'),
(128413, 'Oakwood', 44.6488914489746, 0.779270163150149, -69.3544387817383, -1.21046330761418, 218, 26, 'PPL', 'P'),
(132389, 'Oakwood', 42.2563896179199, 0.737513128838251, -85.620002746582, -1.49435095349444, 218, 27, 'PPL', 'P'),
(140634, 'Oakwood', 48.4269409179688, 0.84520956568732, -97.2949981689453, -1.69811806376995, 218, 34, 'PPL', 'P'),
(145951, 'Oakwood', 40.1411094665527, 0.70059452559481, -74.258056640625, -1.29604758451135, 218, 37, 'PPL', 'P'),
(151340, 'Oakwood', 40.5638885498047, 0.70797341260612, -74.1163864135742, -1.29357497259726, 218, 40, 'PPL', 'P'),
(156907, 'Oakwood', 41.0955581665039, 0.717252797950337, -84.3805618286133, -1.47271862859195, 218, 41, 'PPL', 'P'),
(165462, 'Oakwood', 41.0105590820313, 0.715769284065109, -80.3797225952148, -1.40289081112618, 218, 45, 'PPL', 'P'),
(175646, 'Oakwood', 44.0463905334473, 0.768754538427916, -88.602783203125, -1.54641029332526, 218, 57, 'PPL', 'P'),
(10917, 'Oakwood (historical)', 34.7108306884766, 0.605818281616206, -93.3930587768555, -1.63001637416472, 218, 4, 'PPL', 'P'),
(67413, 'Oakwood Acres', 35.6594390869141, 0.622374621481011, -80.2355575561523, -1.40037465652827, 218, 33, 'PPL', 'P'),
(205207, 'Oakwood Acres', 40.646671295166, 0.709418244076515, -111.842781066895, -1.95202477420449, 218, 52, 'PPL', 'P'),
(71200, 'Oakwood Beach', 39.5550003051758, 0.690364990952679, -75.5188903808594, -1.31805328459867, 218, 37, 'PPL', 'P'),
(151341, 'Oakwood Beach', 40.5525016784668, 0.707774674209772, -74.1147232055664, -1.29354594414138, 218, 40, 'PPL', 'P'),
(137251, 'Oakwood Court', 45.5055618286133, 0.794221881879153, -92.9794387817383, -1.62279734339784, 218, 28, 'PPL', 'P'),
(82731, 'Oakwood Estates', 34.5583305358887, 0.603156651843754, -82.6647186279297, -1.44277151529206, 218, 48, 'PPL', 'P'),
(110739, 'Oakwood Estates', 39.295280456543, 0.685832024461255, -81.4541702270508, -1.42164345994197, 218, 58, 'PPL', 'P'),
(205208, 'Oakwood Estates Subdivision', 40.6016693115234, 0.708632811292023, -111.844436645508, -1.95205366950231, 218, 52, 'PPL', 'P'),
(104872, 'Oakwood Forest', 37.797779083252, 0.65969569494419, -80.0083312988281, -1.39640881019098, 218, 53, 'PPL', 'P'),
(28099, 'Oakwood Heights', 38.8816719055176, 0.678613193431459, -90.0683288574219, -1.57198889033103, 218, 18, 'PPL', 'P'),
(117101, 'Oakwood Heights Mobile Home Park', 41.6916694641113, 0.727656902801923, -93.5472183227539, -1.63270696581402, 218, 16, 'PPL', 'P'),
(151342, 'Oakwood Heights Station', 40.5647201538086, 0.707987926834061, -74.1275024414063, -1.29376898388267, 218, 40, 'PPL', 'P'),
(14340, 'Oakwood Hills', 39.7625007629395, 0.693986557140051, -75.6680603027344, -1.32065679088033, 218, 10, 'PPL', 'P'),
(120869, 'Oakwood Hills', 42.2463912963867, 0.737338625207824, -88.2427825927734, -1.54012709736544, 218, 18, 'PPL', 'P'),
(23585, 'Oakwood Homes Mobile Home Park', 30.7866706848145, 0.53732876917723, -81.6808319091797, -1.42559945258323, 218, 13, 'PPL', 'P'),
(50030, 'Oakwood Knolls', 38.985279083252, 0.680421479811623, -77.1288909912109, -1.34615309620842, 218, 25, 'PPL', 'P'),
(71201, 'Oakwood Lakes', 39.8727798461914, 0.695911290238878, -74.8319396972656, -1.30606373337113, 218, 37, 'PPL', 'P'),
(42409, 'Oakwood Landing', 32.0605583190918, 0.559562302695811, -91.5747222900391, -1.59828041556062, 218, 22, 'PPL', 'P'),
(23586, 'Oakwood Manor', 33.5069389343262, 0.584806406668672, -84.2430572509766, -1.47031872097562, 218, 13, 'PPL', 'P'),
(50031, 'Oakwood Manor', 39.1472206115723, 0.683247892676524, -76.6194381713867, -1.33726146711892, 218, 25, 'PPL', 'P'),
(56640, 'Oakwood Manor', 39.1969413757324, 0.684115683717727, -94.5641708374023, -1.65045613553107, 218, 29, 'PPL', 'P'),
(50032, 'Oakwood Overlook', 39.2508316040039, 0.685056245635715, -76.9852828979492, -1.3436466621485, 218, 25, 'PPL', 'P'),
(50033, 'Oakwood Park', 39.1419410705566, 0.683155747302807, -76.6111068725586, -1.3371160585234, 218, 25, 'PPL', 'P'),
(56641, 'Oakwood Park', 39.2033309936523, 0.684227203588374, -94.5736083984375, -1.6506208520445, 218, 29, 'PPL', 'P'),
(82732, 'Oakwood Park', 32.4208297729492, 0.56585022576657, -80.6419372558594, -1.40746732030143, 218, 48, 'PPL', 'P'),
(123349, 'Oakwood Park', 41.4113883972168, 0.72276507535361, -85.7383270263672, -1.49641610176175, 218, 19, 'PPL', 'P'),
(145952, 'Oakwood Park', 40.7094383239746, 0.710513735390919, -74.4072189331055, -1.29865095763495, 218, 37, 'PPL', 'P'),
(165463, 'Oakwood Park', 40.2405586242676, 0.702330240835269, -76.9591674804688, -1.34319086212793, 218, 45, 'PPL', 'P'),
(205210, 'Oakwood Park Condo', 40.5919418334961, 0.708463034772531, -111.868606567383, -1.95247551421898, 218, 52, 'PPL', 'P'),
(117102, 'Oakwood Station (historical)', 41.9372215270996, 0.731942594786133, -93.51611328125, -1.63216408042581, 218, 16, 'PPL', 'P'),
(17362, 'Oakwood Villa', 30.3177795410156, 0.529145074884498, -81.5791702270508, -1.42382512150697, 218, 12, 'PPL', 'P'),
(50034, 'Oakwood Village', 39.3611106872559, 0.686980978734543, -76.7944412231445, -1.34031584657313, 218, 25, 'PPL', 'P'),
(67416, 'Oakwoods', 36.1147193908691, 0.630320761804507, -81.1341705322266, -1.41605841166191, 218, 33, 'PPL', 'P'),
(112235, 'Oakwoods (historical)', 33.5750007629395, 0.585994309672902, -91.8008270263672, -1.6022266876639, 218, 4, 'PPL', 'P'),
(4728, 'Oakworth', 34.5902786254883, 0.603714251196989, -86.9897232055664, -1.51825708533565, 218, 2, 'PPL', 'P'),
(23587, 'Oaky', 32.5247192382813, 0.56766343899475, -81.39111328125, -1.4205429086215, 218, 13, 'PPL', 'P'),
(4729, 'Oaky Streak', 31.5780601501465, 0.551141121012871, -86.5536117553711, -1.51064550462409, 218, 2, 'PPL', 'P'),
(10918, 'Oark', 35.6894416809082, 0.622898265530348, -93.5722198486328, -1.63314332475863, 218, 4, 'PPL', 'P'),
(23588, 'Oasis', 34.9152793884277, 0.609386584581776, -84.4822235107422, -1.47449295966821, 218, 13, 'PPL', 'P'),
(42410, 'Oasis', 31.4130592346191, 0.548261311768114, -92.7147216796875, -1.61817715838071, 218, 22, 'PPL', 'P'),
(56642, 'Oasis', 39.0827789306641, 0.682123173169156, -90.746940612793, -1.583832899805, 218, 29, 'PPL', 'P'),
(117103, 'Oasis', 41.7061080932617, 0.727908904420071, -91.3852767944336, -1.59497396790924, 218, 16, 'PPL', 'P'),
(183769, 'Oasis', 33.4658317565918, 0.584088951071004, -116.09806060791, -2.02629341278796, 218, 6, 'PPL', 'P'),
(189133, 'Oasis', 32.9244384765625, 0.574639855786321, -107.316673278809, -1.87302929100223, 218, 38, 'PPL', 'P'),
(192731, 'Oasis', 39.2938919067383, 0.685807789695336, -112.627502441406, -1.96572074590049, 218, 52, 'PPL', 'P'),
(200102, 'Oasis', 41.0286102294922, 0.716084336022065, -114.486106872559, -1.99815951271626, 218, 39, 'PPL', 'P'),
(56643, 'Oasis (historical)', 36.5386085510254, 0.637719023312748, -93.2994384765625, -1.6283823916779, 218, 29, 'PPL', 'P'),
(120871, 'Oasis Mobile Home Park', 42.0138893127441, 0.733280700075843, -87.9352798461914, -1.53476016197865, 218, 18, 'PPL', 'P'),
(183770, 'Oasis Mobile Home Park', 33.7877807617188, 0.58970802123399, -117.91667175293, -2.05803416508202, 218, 6, 'PPL', 'P'),
(56644, 'Oates', 37.5627784729004, 0.655594160549359, -91.0563888549805, -1.58923379049568, 218, 29, 'PPL', 'P'),
(96702, 'Oates Prairie', 29.7966709136963, 0.520050013577227, -95.2422180175781, -1.66229029130901, 218, 51, 'PPL', 'P'),
(4730, 'Oateston', 31.7619400024414, 0.554350429863498, -85.3744430541992, -1.49006512835218, 218, 2, 'PPL', 'P'),
(151343, 'Oatka', 42.7172203063965, 0.7455561416464, -78.0891723632813, -1.36291316789662, 218, 40, 'PPL', 'P'),
(82733, 'Oatland', 33.4949989318848, 0.584598014313373, -79.3475036621094, -1.38487519214207, 218, 48, 'PPL', 'P'),
(104875, 'Oatlands', 39.0291709899902, 0.681187538099184, -77.6213912963867, -1.35474884810082, 218, 53, 'PPL', 'P'),
(178738, 'Oatman', 35.0263900756836, 0.611325831908545, -114.382781982422, -1.99635615318411, 218, 5, 'PPL', 'P'),
(96703, 'Oatmeal', 30.6966705322266, 0.535757970187274, -98.0941696166992, -1.71206623682119, 218, 51, 'PPL', 'P'),
(82735, 'Oats', 34.2533302307129, 0.597833392298849, -80.0777816772461, -1.39762094796113, 218, 48, 'PPL', 'P'),
(30713, 'Oatsville', 38.4069404602051, 0.670327566648005, -87.4075012207031, -1.52554868724223, 218, 19, 'PPL', 'P'),
(33472, 'Oatville', 37.6222190856934, 0.656631594952, -97.3888931274414, -1.69975683994673, 218, 20, 'PPL', 'P'),
(73763, 'Obad (historical)', 38.9625015258789, 0.680023936439902, -82.3747177124023, -1.43771004448231, 218, 41, 'PPL', 'P'),
(61144, 'Obadiah', 32.5122184753418, 0.567445259522445, -88.7266693115234, -1.54857251381429, 218, 30, 'PPL', 'P'),
(183771, 'Oban', 34.7744407653809, 0.606928486895633, -118.147216796875, -2.06205793517302, 218, 6, 'PPL', 'P'),
(189134, 'Obar', 35.5349998474121, 0.620202747033024, -103.200828552246, -1.80119424902287, 218, 38, 'PPL', 'P'),
(10921, 'Obear (historical)', 35.7150001525879, 0.623344345012936, -90.8433303833008, -1.5855152186656, 218, 4, 'PPL', 'P'),
(28100, 'Obed', 39.5652809143066, 0.690544421431123, -88.9024963378906, -1.55164127433839, 218, 18, 'PPL', 'P'),
(82734, 'Obed (historical)', 35.1530609130859, 0.613536655087474, -82.0933303833008, -1.4327989091161, 218, 48, 'PPL', 'P'),
(89619, 'Obed Junction', 36.0794410705566, 0.629705038960481, -84.7638931274414, -1.47940902188245, 218, 50, 'PPL', 'P'),
(89620, 'Obed River Estates', 35.9333305358887, 0.627154929058676, -85.0944366455078, -1.48517809459383, 218, 50, 'PPL', 'P'),
(33473, 'Obeeville', 38.0574989318848, 0.664228661435614, -97.8486099243164, -1.70778041167892, 218, 20, 'PPL', 'P'),
(165464, 'Obelisk', 40.2880592346191, 0.703159282882611, -75.5116729736328, -1.31792731707911, 218, 45, 'PPL', 'P'),
(123350, 'Ober', 41.2708282470703, 0.720311837936457, -86.5244369506836, -1.51013630822367, 218, 19, 'PPL', 'P'),
(183772, 'Oberg (historical)', 34.4333305358887, 0.600974990278761, -118.592498779297, -2.06982957186609, 218, 6, 'PPL', 'P'),
(42414, 'Oberlin', 30.6200008392334, 0.53441983160805, -92.7624969482422, -1.61901099411802, 218, 22, 'PPL', 'P'),
(67418, 'Oberlin', 35.7986106872559, 0.624803624132245, -78.6533279418945, -1.37275954023691, 218, 33, 'PPL', 'P'),
(76777, 'Oberlin', 33.8736114501953, 0.591206049347159, -95.8513870239258, -1.67292229617087, 218, 42, 'PPL', 'P'),
(132390, 'Oberlin', 44.0744400024414, 0.7692440940153, -84.5061111450195, -1.47490987753687, 218, 27, 'PPL', 'P'),
(156923, 'Oberlin', 41.2938919067383, 0.720714374735222, -82.2174987792969, -1.43496605645315, 218, 41, 'PPL', 'P'),
(165465, 'Oberlin', 40.2413902282715, 0.70234475506321, -76.8150024414063, -1.34067470753002, 218, 45, 'PPL', 'P'),
(187831, 'Oberlin', 39.8183288574219, 0.694960941203884, -100.527778625488, -1.75454072673075, 218, 20, 'PPL', 'P'),
(132391, 'Oberlin (historical)', 44.6930618286133, 0.780041081706699, -86.2200012207031, -1.5048229023748, 218, 27, 'PPL', 'P'),
(156909, 'Oberlin Beach', 41.3827781677246, 0.722265732649221, -82.5077819824219, -1.44003245411092, 218, 41, 'PPL', 'P'),
(165466, 'Oberlin Gardens', 40.2436103820801, 0.702383504057071, -76.8227767944336, -1.34081039558756, 218, 45, 'PPL', 'P'),
(23589, 'Oberlochen', 33.7877807617188, 0.58970802123399, -84.79638671875, -1.47997614203658, 218, 13, 'PPL', 'P'),
(96704, 'Oberly Crossing', 29.9197196960449, 0.522197619969781, -98.5875015258789, -1.72067650294152, 218, 51, 'PPL', 'P'),
(151344, 'Obernburg', 41.8447189331055, 0.730328119954299, -75.0074996948242, -1.30912783336332, 218, 40, 'PPL', 'P'),
(140636, 'Oberon', 47.9230613708496, 0.836415208556633, -99.20361328125, -1.73142968163299, 218, 34, 'PPL', 'P'),
(23590, 'Oberry', 31.3850002288818, 0.547771589733162, -82.980827331543, -1.44828865296433, 218, 13, 'PPL', 'P'),
(142572, 'Obert', 42.6897201538086, 0.74507617343894, -97.0277786254883, -1.69345420291095, 218, 35, 'PPL', 'P'),
(73764, 'Obetz', 39.8788909912109, 0.696017949840536, -82.9508285522461, -1.44776507549402, 218, 41, 'PPL', 'P'),
(89621, 'Obey City', 36.1736106872559, 0.631348608827224, -85.1680603027344, -1.48646306981979, 218, 50, 'PPL', 'P'),
(151346, 'Obi', 42.0863914489746, 0.734546101067794, -78.258056640625, -1.36586075459112, 218, 40, 'PPL', 'P'),
(67417, 'Obids', 36.3083305358887, 0.633699913753655, -81.3872222900391, -1.4204749980137, 218, 33, 'PPL', 'P'),
(193828, 'Obie', 41.1697196960449, 0.718547160819143, -121.713607788086, -2.12430320038311, 218, 6, 'PPL', 'P'),
(10919, 'Obin (historical)', 34.4094390869141, 0.600558005831082, -92.3080596923828, -1.61107956775954, 218, 4, 'PPL', 'P'),
(89622, 'Obion', 36.2588882446289, 0.632836982981442, -89.1916732788086, -1.55668836407826, 218, 50, 'PPL', 'P'),
(28101, 'Oblong', 39.0019416809082, 0.68071229700266, -87.9088897705078, -1.53429956826812, 218, 18, 'PPL', 'P'),
(96705, 'Obregon', 31.7219390869141, 0.553652282183734, -99.2322235107422, -1.73192902433738, 218, 51, 'PPL', 'P'),
(183773, 'Obregon', 32.8580589294434, 0.57348131413311, -114.788330078125, -2.00343430272932, 218, 6, 'PPL', 'P'),
(50035, 'Obretch Estates', 39.3758316040039, 0.687237907200708, -76.9869384765625, -1.34367555744632, 218, 25, 'PPL', 'P'),
(195402, 'Obsidian', 44.0788917541504, 0.769321791740103, -114.846389770508, -2.0044476355241, 218, 17, 'PPL', 'P'),
(113860, 'Obtuse Hill', 41.4663887023926, 0.72372501176853, -73.3619384765625, -1.28040737206153, 218, 8, 'PPL', 'P'),
(17363, 'Ocala', 29.186939239502, 0.509408188308839, -82.1402816772461, -1.43361836378351, 218, 12, 'PPL', 'P'),
(104876, 'Ocala', 36.8600006103516, 0.643328372937754, -80.6386108398438, -1.40740926338966, 218, 53, 'PPL', 'P'),
(190563, 'Ocala', 39.9102783203125, 0.696565762076765, -118.734443664551, -2.07230697747013, 218, 39, 'PPL', 'P'),
(17364, 'Ocala Estates', 29.201940536499, 0.509670010333507, -82.3097229003906, -1.43657567101599, 218, 12, 'PPL', 'P'),
(17365, 'Ocala Highlands Estates', 29.2552795410156, 0.510600951582058, -82.1444396972656, -1.43369093492322, 218, 12, 'PPL', 'P'),
(17366, 'Ocala Park Ranch', 29.2527809143066, 0.510557342319208, -82.2216720581055, -1.43503889390896, 218, 12, 'PPL', 'P'),
(17367, 'Ocala Ridge', 29.1930599212646, 0.509515014358065, -82.2138900756836, -1.43490307269337, 218, 12, 'PPL', 'P'),
(17368, 'Ocala Thoroughbred Acres', 29.1722202301025, 0.509151293132187, -82.2436065673828, -1.43542172331566, 218, 12, 'PPL', 'P'),
(17369, 'Ocala Waterway', 29.0688896179199, 0.507347833731499, -82.1930618286133, -1.43453955120457, 218, 12, 'PPL', 'P'),
(4731, 'Ocampo', 33.0313911437988, 0.576506531973385, -86.7636108398438, -1.51431068007432, 218, 2, 'PPL', 'P'),
(89624, 'Ocana', 36.3824996948242, 0.634994409780515, -86.5583267211914, -1.51072779630178, 218, 50, 'PPL', 'P'),
(189135, 'Ocate', 36.1755599975586, 0.631382630710149, -105.047500610352, -1.83342475664139, 218, 38, 'PPL', 'P'),
(96706, 'Ocaw', 31.6230602264404, 0.551926520507849, -97.0777816772461, -1.69432692080017, 218, 51, 'PPL', 'P'),
(151345, 'Occanum', 42.0858306884766, 0.734536313950788, -75.6975021362305, -1.32117064781266, 218, 40, 'PPL', 'P'),
(30714, 'Occident', 39.6911087036133, 0.69274053064503, -85.4783325195313, -1.49187834158036, 218, 19, 'PPL', 'P'),
(183774, 'Occidental', 38.4075012207031, 0.670337353765011, -122.947219848633, -2.14583379253197, 218, 6, 'PPL', 'P'),
(187128, 'Occidental', 37.5149993896484, 0.654760258233028, -105.106391906738, -1.8344526036641, 218, 7, 'PPL', 'P'),
(104877, 'Occoquan', 38.6836090087891, 0.675156343757509, -77.2605590820313, -1.34845113791305, 218, 53, 'PPL', 'P'),
(104878, 'Occoquan Forest', 38.7230606079102, 0.675844904057349, -77.3916702270508, -1.3507394590797, 218, 53, 'PPL', 'P'),
(104881, 'Occoquan River Hills', 38.7197189331055, 0.675786580829477, -77.4072189331055, -1.35101083519478, 218, 53, 'PPL', 'P'),
(113861, 'Occum', 41.5950012207031, 0.72596972367233, -72.0511093139648, -1.25752908724304, 218, 8, 'PPL', 'P'),
(104880, 'Occupacia', 38.0402793884277, 0.663928123706599, -77.0177764892578, -1.34421378230263, 218, 53, 'PPL', 'P'),
(50037, 'Ocean', 39.6025009155273, 0.691194033000021, -78.9441680908203, -1.37783565843266, 218, 25, 'PPL', 'P'),
(67420, 'Ocean', 34.711669921875, 0.605832929002202, -76.9916687011719, -1.34375811544012, 218, 33, 'PPL', 'P'),
(71202, 'Ocean Acres', 39.7433280944824, 0.693651930949082, -74.2813873291016, -1.29645478184202, 218, 37, 'PPL', 'P'),
(151347, 'Ocean Bay Park', 40.648609161377, 0.709452066222359, -73.1405563354492, -1.27654352479399, 218, 40, 'PPL', 'P'),
(71203, 'Ocean Beach', 39.9813919067383, 0.697806928302797, -74.0666732788086, -1.29270731471411, 218, 37, 'PPL', 'P'),
(151348, 'Ocean Beach', 40.646671295166, 0.709418244076515, -73.1575012207031, -1.27683926883304, 218, 40, 'PPL', 'P'),
(183775, 'Ocean Beach', 32.7444381713867, 0.57149825780641, -117.261108398438, -2.04659242609071, 218, 6, 'PPL', 'P'),
(125720, 'Ocean Bluff', 42.0972213745117, 0.734735118926162, -70.654167175293, -1.23314784746336, 218, 23, 'PPL', 'P'),
(17370, 'Ocean Breeze Park', 27.235559463501, 0.475350186260792, -80.220832824707, -1.40011766148308, 218, 12, 'PPL', 'P'),
(17371, 'Ocean City', 30.4408302307129, 0.531292714566565, -86.6136093139648, -1.51169265956471, 218, 12, 'PPL', 'P'),
(50039, 'Ocean City', 38.3363914489746, 0.669096254118007, -75.0852813720703, -1.31048537972899, 218, 25, 'PPL', 'P'),
(71204, 'Ocean City', 39.2775001525879, 0.685521699615234, -74.5749969482422, -1.30157923641155, 218, 37, 'PPL', 'P'),
(208301, 'Ocean City', 47.0711097717285, 0.821545848084339, -124.16471862793, -2.16708315486971, 218, 56, 'PPL', 'P'),
(67421, 'Ocean City Beach', 34.4563903808594, 0.601377460498499, -77.4916687011719, -1.35248476170009, 218, 33, 'PPL', 'P'),
(82736, 'Ocean Drive Beach', 33.8183288574219, 0.590241186084224, -78.6736068725586, -1.37311347434579, 218, 48, 'PPL', 'P'),
(67423, 'Ocean Dunes', 36.1599998474121, 0.631111054857988, -75.7436065673828, -1.32197532193603, 218, 33, 'PPL', 'P'),
(82737, 'Ocean Forest', 33.7297210693359, 0.588694688439215, -78.8383331298828, -1.37598848990058, 218, 48, 'PPL', 'P'),
(71207, 'Ocean Gate', 39.9266700744629, 0.696851852156867, -74.1341705322266, -1.29388536402231, 218, 37, 'PPL', 'P'),
(125721, 'Ocean Grove', 41.7291717529297, 0.728311441218837, -71.209716796875, -1.24284401751818, 218, 23, 'PPL', 'P'),
(145953, 'Ocean Grove', 40.2119407653809, 0.701830764972825, -74.0069427490234, -1.2916648203054, 218, 37, 'PPL', 'P'),
(208306, 'Ocean Grove', 47.1822204589844, 0.823485095411107, -124.194999694824, -2.16761165918804, 218, 56, 'PPL', 'P'),
(71209, 'Ocean Heights', 39.3291702270508, 0.686423512539362, -74.5877838134766, -1.3018024093109, 218, 37, 'PPL', 'P'),
(125722, 'Ocean Heights', 41.4063911437988, 0.72267785682791, -70.5522232055664, -1.23136858953908, 218, 23, 'PPL', 'P'),
(183778, 'Ocean Hills', 33.1641693115234, 0.578823948174945, -117.254173278809, -2.04647138541917, 218, 6, 'PPL', 'P'),
(67424, 'Ocean Isle Beach', 33.8941688537598, 0.59156484372502, -78.4269409179688, -1.36880834128562, 218, 33, 'PPL', 'P'),
(82738, 'Ocean Lakes', 33.6258316040039, 0.586881475211034, -78.9538879394531, -1.3780053017941, 218, 48, 'PPL', 'P'),
(104895, 'Ocean Park', 36.9091682434082, 0.644186510020005, -76.1016693115234, -1.32822469575001, 218, 53, 'PPL', 'P'),
(128414, 'Ocean Park', 43.500560760498, 0.759228011734539, -70.3866729736328, -1.2284791929144, 218, 26, 'PPL', 'P'),
(183779, 'Ocean Park', 34.0022201538086, 0.593450694671933, -118.482780456543, -2.06791462588426, 218, 6, 'PPL', 'P'),
(201339, 'Ocean Park', 44.7255592346191, 0.780608268439859, -124.053886413574, -2.16514876781193, 218, 43, 'PPL', 'P'),
(208302, 'Ocean Park', 46.4916687011719, 0.811432693581845, -124.048889160156, -2.16506154928623, 218, 56, 'PPL', 'P'),
(50040, 'Ocean Pines', 38.3952789306641, 0.670124034561695, -75.1561126708984, -1.31172161910701, 218, 25, 'PPL', 'P'),
(67425, 'Ocean Pines', 36.204719543457, 0.631891560794463, -75.7666702270508, -1.3223778587348, 218, 33, 'PPL', 'P'),
(82739, 'Ocean Pines', 33.5902786254883, 0.586260958677046, -79.0124969482422, -1.3790282219688, 218, 48, 'PPL', 'P'),
(128415, 'Ocean Point', 43.8158302307129, 0.764730502020807, -69.5963897705078, -1.21468614899666, 218, 26, 'PPL', 'P'),
(151349, 'Ocean Point', 40.622501373291, 0.708996399359846, -73.7261123657227, -1.28676340547717, 218, 40, 'PPL', 'P'),
(17372, 'Ocean Ridge', 26.5266704559326, 0.46297773904753, -80.0486068725586, -1.39711175156071, 218, 12, 'PPL', 'P'),
(183780, 'Ocean Roar', 38.2161102294922, 0.666996950809724, -122.923889160156, -2.14542659520129, 218, 6, 'PPL', 'P'),
(208303, 'Ocean Shores', 46.9738883972168, 0.819849014995795, -124.154998779297, -2.16691351150827, 218, 56, 'PPL', 'P'),
(61145, 'Ocean Springs', 30.4111099243164, 0.530773997365245, -88.8277816772461, -1.55033725751064, 218, 30, 'PPL', 'P'),
(365, 'Ocean View', 38.5449981689453, 0.672737128223281, -75.0894393920898, -1.3105579508687, 218, 10, 'PPL', 'P'),
(71210, 'Ocean View', 39.1763916015625, 0.68375702249792, -74.73388671875, -1.30435238605465, 218, 37, 'PPL', 'P'),
(104882, 'Ocean View', 36.9497184753418, 0.644894245079694, -76.2466735839844, -1.33075549773391, 218, 53, 'PPL', 'P'),
(125723, 'Ocean View', 42.6847190856934, 0.744988888334213, -70.625, -1.232638784221, 218, 23, 'PPL', 'P'),
(183781, 'Ocean View', 33.7155609130859, 0.588447547090055, -117.987777709961, -2.05927519814999, 218, 6, 'PPL', 'P'),
(17373, 'Ocean View Heights', 25.7363891601563, 0.449184728419305, -80.2380599975586, -1.40041833237015, 218, 12, 'PPL', 'P'),
(128416, 'Ocean View Village', 43.1786117553711, 0.753608941571554, -70.6083297729492, -1.2323478338719, 218, 26, 'PPL', 'P'),
(14341, 'Ocean Village', 38.5569381713867, 0.67294552057858, -75.0597229003906, -1.3100393002464, 218, 10, 'PPL', 'P'),
(17374, 'Ocean Vue', 26.3177795410156, 0.459331904804725, -80.0772171020508, -1.3976110942651, 218, 12, 'PPL', 'P'),
(14342, 'Ocean Way Estates', 38.5366706848145, 0.67259178620679, -75.0808334350586, -1.31040774858322, 218, 10, 'PPL', 'P'),
(193829, 'Ocean West Mobile Home Park', 40.9555587768555, 0.71480934765019, -124.110282897949, -2.16613307215082, 218, 6, 'PPL', 'P'),
(104883, 'Oceana', 36.8419418334961, 0.643013187822743, -76.0133285522461, -1.32668285863691, 218, 53, 'PPL', 'P'),
(110740, 'Oceana', 37.6919403076172, 0.657848459833084, -81.6241683959961, -1.42461048771243, 218, 58, 'PPL', 'P'),
(183783, 'Oceana', 33.2105598449707, 0.579633615725356, -117.329170227051, -2.04778032909494, 218, 6, 'PPL', 'P'),
(104884, 'Oceanair', 36.9366683959961, 0.644666478227465, -76.2455596923828, -1.33073605665795, 218, 53, 'PPL', 'P'),
(145955, 'Oceanic', 40.3777809143066, 0.704725221603577, -74.0111083984375, -1.29173752460316, 218, 37, 'PPL', 'P'),
(82740, 'Oceanmarsh Subdivision', 32.3980598449707, 0.565452815552902, -80.4394378662109, -1.40393303921878, 218, 48, 'PPL', 'P'),
(183784, 'Oceano', 35.0988883972168, 0.612591166321468, -120.611389160156, -2.10506585624892, 218, 6, 'PPL', 'P'),
(183785, 'Oceano Beach', 35.1055603027344, 0.612707613040132, -120.629173278809, -2.10537624767397, 218, 6, 'PPL', 'P'),
(145956, 'Oceanport', 40.3180618286133, 0.703682926931947, -74.0155563354492, -1.29181515574894, 218, 37, 'PPL', 'P'),
(151350, 'Oceanside', 40.6386108398438, 0.709277562591931, -73.6405563354492, -1.28527017105396, 218, 40, 'PPL', 'P'),
(183786, 'Oceanside', 33.1958312988281, 0.579376554101136, -117.378608703613, -2.04864319328812, 218, 6, 'PPL', 'P'),
(201341, 'Oceanside', 45.461109161377, 0.793446036474586, -123.966667175293, -2.16362650493284, 218, 43, 'PPL', 'P'),
(208304, 'Oceanside', 46.4086112976074, 0.809983068421487, -124.051109313965, -2.16510029828009, 218, 56, 'PPL', 'P'),
(82741, 'Oceanside Village', 33.5944404602051, 0.586333596395778, -78.9911117553711, -1.37865497994202, 218, 48, 'PPL', 'P'),
(82742, 'Oceanview', 32.7177810668945, 0.571033003563973, -79.9338912963867, -1.39510958705319, 218, 48, 'PPL', 'P'),
(208305, 'Oceanview', 46.3216705322266, 0.808465665811388, -124.056106567383, -2.16518751680579, 218, 56, 'PPL', 'P'),
(71212, 'Oceanville', 39.4711112976074, 0.688900851564381, -74.4608306884766, -1.29958665928395, 218, 37, 'PPL', 'P'),
(128417, 'Oceanville', 44.1863899230957, 0.771197988728064, -68.6224975585938, -1.19768852333923, 218, 26, 'PPL', 'P'),
(17375, 'Oceanway', 30.4666690826416, 0.531743687607656, -81.6324996948242, -1.42475589630795, 218, 12, 'PPL', 'P'),
(82743, 'Oceda', 33.351390838623, 0.582091580253445, -79.6372222900391, -1.3899317361038, 218, 48, 'PPL', 'P'),
(23591, 'Ocee', 34.0644416809082, 0.59453666518544, -84.2127838134766, -1.46979034981535, 218, 13, 'PPL', 'P'),
(96707, 'Ocee', 31.5558300018311, 0.55075313173156, -97.3552780151367, -1.69917014555859, 218, 51, 'PPL', 'P'),
(4732, 'Oceola', 34.1650009155273, 0.596291754922829, -85.4869384765625, -1.49202854386584, 218, 2, 'PPL', 'P'),
(156910, 'Oceola', 40.8447189331055, 0.712874827434356, -83.0938873291016, -1.45026192217402, 218, 41, 'PPL', 'P'),
(50041, 'Oceola Estates', 39.4688911437988, 0.68886210257052, -77.1216735839844, -1.34602712868886, 218, 25, 'PPL', 'P'),
(151351, 'Oceola Lake', 41.3386116027832, 0.721494880671697, -73.7986068725586, -1.28802867331106, 218, 40, 'PPL', 'P'),
(17376, 'Ocheesee', 30.5755596160889, 0.533644185940564, -85.0169372558594, -1.48382547507618, 218, 12, 'PPL', 'P'),
(17381, 'Ocheesee Gardens', 30.6572208404541, 0.535069443176947, -84.9700012207031, -1.48300628672487, 218, 12, 'PPL', 'P'),
(17377, 'Ocheesee Landing', 30.5819396972656, 0.533755539363643, -84.9661102294922, -1.48293837611707, 218, 12, 'PPL', 'P'),
(17378, 'Ocheeseulga (historical)', 30.3999996185303, 0.530580085948373, -85.0666732788086, -1.48469353243349, 218, 12, 'PPL', 'P'),
(76778, 'Ochelata', 36.5999984741211, 0.638790479598314, -95.9794387817383, -1.67515722095767, 218, 42, 'PPL', 'P'),
(33474, 'Ocheltree', 38.7686080932617, 0.676639857642738, -94.8158264160156, -1.65484835395889, 218, 20, 'PPL', 'P'),
(117104, 'Ocheyedan', 43.4161109924316, 0.757754085229235, -95.5344390869141, -1.66739051111262, 218, 16, 'PPL', 'P'),
(23592, 'Ochillee', 32.3941688537598, 0.565384904945105, -84.8444366455078, -1.48081477146384, 218, 13, 'PPL', 'P'),
(17379, 'Ochisi (historical)', 30.4833297729492, 0.532034471509179, -84.9499969482422, -1.48265714630596, 218, 12, 'PPL', 'P'),
(23593, 'Ochlocknee', 30.9736099243164, 0.540591474407713, -84.0530624389648, -1.46700268594431, 218, 13, 'PPL', 'P'),
(17380, 'Ochlockonee', 30.4722194671631, 0.531840560092308, -84.4069366455078, -1.47317895598637, 218, 12, 'PPL', 'P'),
(189136, 'Ochoa', 32.1916694641113, 0.561850623862461, -103.439720153809, -1.8053636940255, 218, 38, 'PPL', 'P'),
(191959, 'Ochoa', 29.6669406890869, 0.517785794018442, -104.500282287598, -1.82387399518209, 218, 51, 'PPL', 'P'),
(17382, 'Ochopee', 25.9011096954346, 0.452059644105559, -81.3036117553711, -1.41901571889439, 218, 12, 'PPL', 'P'),
(165470, 'Ochre Mill', 41.1283302307129, 0.717824778373459, -75.7808303833008, -1.32262500008396, 218, 45, 'PPL', 'P'),
(112278, 'Ochwalkee', 32.1936111450195, 0.561884512587333, -82.6399993896484, -1.44234008319547, 218, 13, 'PPL', 'P'),
(56645, 'Ocie', 36.5586090087891, 0.63806809715263, -92.7588882446289, -1.61894801035824, 218, 29, 'PPL', 'P'),
(23594, 'Ocilla', 31.5941696166992, 0.551422284244956, -83.2505569458008, -1.45299632282326, 218, 13, 'PPL', 'P'),
(183788, 'Ockenden', 37.0888900756836, 0.647323247730928, -119.316673278809, -2.08246880124155, 218, 6, 'PPL', 'P'),
(96708, 'Ocker', 31.0705604553223, 0.542283580385322, -97.1433334350586, -1.69547101480447, 218, 51, 'PPL', 'P'),
(17383, 'Ocklawaha', 29.0424995422363, 0.50688724002097, -81.929443359375, -1.4299385409473, 218, 12, 'PPL', 'P'),
(123351, 'Ockley', 40.4883308410645, 0.70665468181334, -86.6338882446289, -1.51204659367359, 218, 19, 'PPL', 'P'),
(17384, 'Ocklockonee (historical)', 30.6666698455811, 0.53523435942745, -84.3000030517578, -1.47131261269444, 218, 12, 'PPL', 'P'),
(156911, 'Oco', 40.1097183227539, 0.700046646779553, -80.9977798461914, -1.41367794512155, 218, 41, 'PPL', 'P'),
(61146, 'Ocobla', 32.7547187805176, 0.571677688284854, -89.0252838134766, -1.55378432006758, 218, 30, 'PPL', 'P'),
(17385, 'Ocoee', 28.5688896179199, 0.498621187471527, -81.5441665649414, -1.4232141923529, 218, 12, 'PPL', 'P'),
(89625, 'Ocoee', 35.1222190856934, 0.612998363652142, -84.7188873291016, -1.47862352251893, 218, 50, 'PPL', 'P'),
(67427, 'Oconaluftee Indian Village', 35.4866714477539, 0.619359257336769, -83.3227767944336, -1.45425679696719, 218, 33, 'PPL', 'P'),
(23595, 'Oconee', 32.855281829834, 0.57343284460127, -82.9499969482422, -1.44775056126607, 218, 13, 'PPL', 'P'),
(28103, 'Oconee', 39.2855606079102, 0.685662381099817, -89.1074981689453, -1.55521923126291, 218, 18, 'PPL', 'P'),
(142573, 'Oconee', 41.4700012207031, 0.723788062107337, -97.5186080932617, -1.70202079318941, 218, 35, 'PPL', 'P'),
(10920, 'Oconee (historical)', 36.3891716003418, 0.635110856499179, -91.147216796875, -1.59081903713455, 218, 4, 'PPL', 'P'),
(82745, 'Oconee Estates', 34.7041702270508, 0.605702034634624, -83.0069427490234, -1.44874445298489, 218, 48, 'PPL', 'P'),
(23597, 'Oconee Heights', 33.9897193908691, 0.593232515199628, -83.4258270263672, -1.45605536280938, 218, 13, 'PPL', 'P'),
(23598, 'Oconee Old Town (historical)', 33.0044403076172, 0.57603615114585, -83.1563873291016, -1.45135275295652, 218, 13, 'PPL', 'P'),
(82746, 'Oconee Point', 34.5980606079102, 0.603850072412583, -82.8688888549805, -1.44633495798864, 218, 48, 'PPL', 'P'),
(23599, 'Oconee Springs', 33.2886085510254, 0.580995822622932, -83.1994400024414, -1.45210416385808, 218, 13, 'PPL', 'P'),
(175648, 'Oconomowoc', 43.1116714477539, 0.752440612801336, -88.4991683959961, -1.54460187378704, 218, 57, 'PPL', 'P'),
(175649, 'Oconomowoc Lake', 43.1044387817383, 0.752314378965666, -88.4591674804688, -1.54390372610728, 218, 57, 'PPL', 'P'),
(73765, 'Oconorville (historical)', 39.6591682434082, 0.692183064449849, -82.1588897705078, -1.43394313627845, 218, 41, 'PPL', 'P'),
(142575, 'Oconto', 41.1411094665527, 0.718047818114753, -99.7627792358398, -1.74118896860564, 218, 35, 'PPL', 'P'),
(175652, 'Oconto', 44.8872184753418, 0.783429754456743, -87.8644409179688, -1.53352378944258, 218, 57, 'PPL', 'P'),
(175654, 'Oconto Falls', 44.8738899230957, 0.783197127335525, -88.1427764892578, -1.538381661587, 218, 57, 'PPL', 'P'),
(104885, 'Ocoonita', 36.7333297729492, 0.641117549758825, -83.1374969482422, -1.45102305361356, 218, 53, 'PPL', 'P'),
(208310, 'Ocosta', 46.8888893127441, 0.818365501110566, -124.037216186523, -2.16485781746284, 218, 56, 'PPL', 'P'),
(178740, 'Ocotillo', 34.3636093139648, 0.599758125397676, -112.201110839844, -1.95827880855037, 218, 5, 'PPL', 'P'),
(183789, 'Ocotillo', 32.7386093139648, 0.571396525052769, -115.99333190918, -2.02446555217379, 218, 6, 'PPL', 'P'),
(183790, 'Ocotillo Wells', 33.1444396972656, 0.578479601445998, -116.133331298828, -2.02690900247393, 218, 6, 'PPL', 'P'),
(120873, 'Ocoya', 40.8050003051758, 0.712181606602608, -88.6838912963867, -1.54782589660269, 218, 18, 'PPL', 'P'),
(132394, 'Ocqueoc', 45.4083290100098, 0.792524849053528, -84.0899963378906, -1.46764730408617, 218, 27, 'PPL', 'P'),
(67429, 'Ocracoke', 35.1144409179688, 0.612862609015575, -75.9813919067383, -1.32612545902076, 218, 33, 'PPL', 'P'),
(104886, 'Ocran', 37.6602783203125, 0.657295853906893, -76.3494415283203, -1.33254913672808, 218, 53, 'PPL', 'P'),
(104887, 'Ocre (historical)', 37.3444404602051, 0.651783443345565, -77.3341674804688, -1.34973584682291, 218, 53, 'PPL', 'P'),
(56646, 'Octa', 36.1711082458496, 0.631304932985346, -90.1230621337891, -1.57294416621405, 218, 29, 'PPL', 'P'),
(73766, 'Octa', 39.603889465332, 0.691218267765941, -83.6130599975586, -1.45932319462496, 218, 41, 'PPL', 'P'),
(4733, 'Octagon', 32.2041702270508, 0.562068803334766, -87.7552795410156, -1.53161856399874, 218, 2, 'PPL', 'P'),
(104888, 'Octagon', 36.9027786254883, 0.644074990149358, -77.8988876342773, -1.35959207285924, 218, 53, 'PPL', 'P'),
(123352, 'Octagon', 40.5263900756836, 0.707318940768233, -86.9922180175781, -1.51830062801947, 218, 19, 'PPL', 'P'),
(17386, 'Octahatchee', 30.5791702270508, 0.533707202989858, -83.190559387207, -1.45194916788264, 218, 12, 'PPL', 'P'),
(50042, 'Octararo (historical)', 39.7069396972656, 0.693016833608126, -76.1152801513672, -1.32846224971925, 218, 25, 'PPL', 'P'),
(50043, 'Octararo Lakes', 39.7027816772461, 0.692944262468421, -76.1180572509766, -1.32851071925108, 218, 25, 'PPL', 'P'),
(178741, 'Octave', 34.1416702270508, 0.595884557592156, -112.689170837402, -1.96679706245505, 218, 5, 'PPL', 'P'),
(76779, 'Octavia', 34.526668548584, 0.602604045917562, -94.7027816772461, -1.6528753510653, 218, 42, 'PPL', 'P'),
(142576, 'Octavia', 41.3480606079102, 0.7216597969222, -97.0586090087891, -1.6939922946092, 218, 35, 'PPL', 'P'),
(183791, 'Octol', 36.1238899230957, 0.630480817786021, -119.327499389648, -2.08265775252089, 218, 6, 'PPL', 'P'),
(50044, 'Octoraro', 39.6586112976074, 0.69217334391187, -76.1549987792969, -1.32915547055099, 218, 25, 'PPL', 'P'),
(23600, 'Oculus (historical)', 34.5366706848145, 0.602778616127017, -83.7850036621094, -1.46232417769932, 218, 13, 'PPL', 'P'),
(208307, 'Odair', 47.6111106872559, 0.830970642024075, -119.266670227051, -2.08159608335233, 218, 56, 'PPL', 'P'),
(175660, 'Odanah', 46.6083297729492, 0.813468813393265, -90.6966705322266, -1.58295552138387, 218, 57, 'PPL', 'P'),
(110743, 'Odaville', 38.9324989318848, 0.679500292390565, -81.6408309936523, -1.42490130490347, 218, 58, 'PPL', 'P'),
(156912, 'Odbert (historical)', 40.4808311462402, 0.706523787445762, -81.4863891601563, -1.42220578640614, 218, 41, 'PPL', 'P'),
(104889, 'Odd', 37.1291694641113, 0.648026255679681, -76.3513870239258, -1.33258309203198, 218, 53, 'PPL', 'P'),
(110741, 'Odd', 37.5933303833008, 0.656127391978621, -81.1941680908203, -1.41710556660253, 218, 58, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(89626, 'Odd Fellows Hall', 35.3041687011719, 0.616173983514979, -86.9580612182617, -1.51770447940946, 218, 50, 'PPL', 'P'),
(183792, 'Odd Fellows Park', 38.5022201538086, 0.671990511011678, -122.946113586426, -2.14581448461406, 218, 6, 'PPL', 'P'),
(50045, 'Oddessy', 39.5716705322266, 0.69065594130177, -75.8166732788086, -1.32325057662401, 218, 25, 'PPL', 'P'),
(37489, 'Odds', 37.7555618286133, 0.658958864849593, -82.6930618286133, -1.44326619746454, 218, 21, 'PPL', 'P'),
(96709, 'Odds', 31.4088897705078, 0.548188540891328, -96.7155609130859, -1.68800497584648, 218, 51, 'PPL', 'P'),
(37490, 'Oddville', 38.4555587768555, 0.671176116350331, -84.2388916015625, -1.47024601667786, 218, 21, 'PPL', 'P'),
(117106, 'Odebolt', 42.3122215270996, 0.738487579481111, -95.2502822875977, -1.66243103937262, 218, 16, 'PPL', 'P'),
(10922, 'Odell', 35.7724990844727, 0.624347890690705, -94.4180603027344, -1.64790602562927, 218, 4, 'PPL', 'P'),
(67433, 'Odell', 36.3572196960449, 0.634553190566916, -77.9438934326172, -1.36037757222275, 218, 33, 'PPL', 'P'),
(96710, 'Odell', 34.3458290100098, 0.599447800551655, -99.4186096191406, -1.73518207560891, 218, 51, 'PPL', 'P'),
(110742, 'Odell', 38.3902816772461, 0.670036816035995, -81.3655624389648, -1.42009696229696, 218, 58, 'PPL', 'P'),
(120874, 'Odell', 41.0036087036133, 0.715647977077456, -88.5252838134766, -1.54505767380761, 218, 18, 'PPL', 'P'),
(123353, 'Odell', 40.2877807617188, 0.703154422613621, -87.0741729736328, -1.51973101184095, 218, 19, 'PPL', 'P'),
(142577, 'Odell', 40.0499992370605, 0.699004352107924, -96.8030624389648, -1.68953216557359, 218, 35, 'PPL', 'P'),
(151352, 'Odell', 41.6794395446777, 0.727443450440553, -74.9177780151367, -1.30756189464236, 218, 40, 'PPL', 'P'),
(156913, 'Odell', 40.1508293151855, 0.700764168956248, -81.476936340332, -1.42204080357661, 218, 41, 'PPL', 'P'),
(165467, 'Odell', 40.1127815246582, 0.700100109738437, -80.1086120605469, -1.39815903965938, 218, 45, 'PPL', 'P'),
(201342, 'Odell', 45.6272201538086, 0.796345220216274, -121.541938781738, -2.12130701099872, 218, 43, 'PPL', 'P'),
(140638, 'Odell (historical)', 47.0647201538086, 0.821434328213692, -98.1972198486328, -1.71386480266337, 218, 34, 'PPL', 'P'),
(201343, 'Odell Lake', 43.5491714477539, 0.760076428278811, -121.963607788086, -2.1286665235131, 218, 43, 'PPL', 'P'),
(110745, 'Odell Town', 38.1977806091309, 0.666677038583779, -80.7136077880859, -1.40871820706544, 218, 58, 'PPL', 'P'),
(96711, 'Odem', 27.9502792358398, 0.48782439951721, -97.5819396972656, -1.70312613819984, 218, 51, 'PPL', 'P'),
(89627, 'Odemville (historical)', 36.2444381713867, 0.632584781626211, -82.0388870239258, -1.43184869323916, 218, 50, 'PPL', 'P'),
(10923, 'Oden', 34.6188888549805, 0.604213593901379, -93.7766723632813, -1.63671169430323, 218, 4, 'PPL', 'P'),
(132395, 'Oden', 45.4236106872559, 0.792791564636699, -84.8280563354492, -1.48052888112082, 218, 27, 'PPL', 'P'),
(195403, 'Oden', 48.3222198486328, 0.843381838231199, -116.411666870117, -2.03176687461835, 218, 17, 'PPL', 'P'),
(42411, 'Oden (historical)', 31.1144409179688, 0.543049438935802, -92.5061111450195, -1.61453621769641, 218, 22, 'PPL', 'P'),
(67431, 'Oden Mill', 35.5361099243164, 0.620222121529954, -76.8438873291016, -1.34117884392437, 218, 33, 'PPL', 'P'),
(4734, 'Oden Ridge', 34.3738899230957, 0.59993755587612, -86.7622222900391, -1.5142864453084, 218, 2, 'PPL', 'P'),
(4735, 'Odena', 33.2108306884766, 0.579638342836291, -86.2786102294922, -1.5058458225495, 218, 2, 'PPL', 'P'),
(17387, 'Odena', 29.7399997711182, 0.519060915548372, -85.186393737793, -1.48678304862477, 218, 12, 'PPL', 'P'),
(42412, 'Odenburg', 30.920280456543, 0.53966069960673, -91.8105621337891, -1.60239659734145, 218, 22, 'PPL', 'P'),
(33475, 'Odense', 37.7030601501465, 0.658042537697524, -95.2516708374023, -1.66245527413854, 218, 20, 'PPL', 'P'),
(50051, 'Odenton', 39.0838890075684, 0.682142547666087, -76.7005615234375, -1.33867733671246, 218, 25, 'PPL', 'P'),
(50046, 'Odenton Heights', 39.0702781677246, 0.681904993696852, -76.6999969482422, -1.33866748301643, 218, 25, 'PPL', 'P'),
(50047, 'Odenton Park', 39.047779083252, 0.68151231059412, -76.6961135864258, -1.33859970556669, 218, 25, 'PPL', 'P'),
(4736, 'Odenville', 33.6772193908691, 0.587778361287146, -86.3966674804688, -1.50790631028489, 218, 2, 'PPL', 'P'),
(14343, 'Odessa', 39.457218170166, 0.688658370747129, -75.6616668701172, -1.32054520443066, 218, 10, 'PPL', 'P'),
(17388, 'Odessa', 28.1936092376709, 0.492071309218046, -82.5919418334961, -1.44150132061015, 218, 12, 'PPL', 'P'),
(23601, 'Odessa', 31.5575008392334, 0.550782293345497, -81.8202819824219, -1.42803331550345, 218, 13, 'PPL', 'P'),
(56648, 'Odessa', 38.9991683959961, 0.680663894049848, -93.9533309936523, -1.63979496905527, 218, 29, 'PPL', 'P'),
(110744, 'Odessa', 38.4286117553711, 0.670705802101823, -81.2380599975586, -1.41787162489009, 218, 58, 'PPL', 'P'),
(137253, 'Odessa', 45.2597198486328, 0.789931129888872, -96.32861328125, -1.68125146563815, 218, 28, 'PPL', 'P'),
(142578, 'Odessa', 40.7016716003418, 0.710378180491434, -99.2563934326172, -1.73235086905405, 218, 35, 'PPL', 'P'),
(151353, 'Odessa', 42.336669921875, 0.738914284466769, -76.7888870239258, -1.34021890750945, 218, 40, 'PPL', 'P'),
(191960, 'Odessa', 31.8455600738525, 0.555809875430375, -102.367218017578, -1.7866450005136, 218, 51, 'PPL', 'P'),
(208308, 'Odessa', 47.3333282470703, 0.826122423838613, -118.689720153809, -2.07152640495463, 218, 56, 'PPL', 'P'),
(183793, 'Odessa (historical)', 36.2713890075684, 0.633055162453746, -119.644996643066, -2.08819912495907, 218, 6, 'PPL', 'P'),
(14344, 'Odessa Heights', 39.452220916748, 0.688571152221429, -75.6624984741211, -1.3205597186586, 218, 10, 'PPL', 'P'),
(23602, 'Odessadale', 33.0158309936523, 0.576234956121224, -84.8130569458008, -1.48026709238567, 218, 13, 'PPL', 'P'),
(76782, 'Odetta', 34.663890838623, 0.604999026685871, -98.8433303833008, -1.72514155882515, 218, 42, 'PPL', 'P'),
(28105, 'Odgen', 38.4519386291504, 0.671112932853469, -87.8269424438477, -1.5328693176047, 218, 18, 'PPL', 'P'),
(37492, 'Odgen Gap', 37.3622207641602, 0.652093768191586, -82.9902801513672, -1.44845363579386, 218, 21, 'PPL', 'P'),
(132402, 'Odgers Location', 46.0974998474121, 0.804553149274925, -88.3488922119141, -1.54197905958748, 218, 27, 'PPL', 'P'),
(28106, 'Odin', 38.6172218322754, 0.673997668946243, -89.0522232055664, -1.55425450115803, 218, 18, 'PPL', 'P'),
(33478, 'Odin', 38.5661087036133, 0.673105576560094, -98.6083297729492, -1.72104002443032, 218, 20, 'PPL', 'P'),
(56651, 'Odin', 37.2683296203613, 0.650455058593834, -92.6183319091797, -1.61649483952011, 218, 29, 'PPL', 'P'),
(137256, 'Odin', 43.8663902282715, 0.765612940448004, -94.7425003051758, -1.65356857189705, 218, 28, 'PPL', 'P'),
(165469, 'Odin', 41.6977806091309, 0.72776356240358, -78.086669921875, -1.36286949205474, 218, 45, 'PPL', 'P'),
(23603, 'Odis Crossroads', 34.394718170166, 0.600301077364916, -83.3949966430664, -1.45551727111113, 218, 13, 'PPL', 'P'),
(191961, 'Odlaw', 29.2350006103516, 0.510247017473187, -100.168060302734, -1.74826245761894, 218, 51, 'PPL', 'P'),
(165471, 'Odle Corners', 41.9477806091309, 0.732126885533566, -77.3388900756836, -1.34981827165865, 218, 45, 'PPL', 'P'),
(96712, 'Odom', 32.378059387207, 0.56510374171302, -96.0311126708984, -1.67605910046082, 218, 51, 'PPL', 'P'),
(42413, 'Odom (historical)', 31.3658294677734, 0.547436996831707, -92.7541732788086, -1.61886571868055, 218, 22, 'PPL', 'P'),
(4737, 'Odom Crossroads', 31.5377807617188, 0.550438113064117, -86.7861099243164, -1.51470336317705, 218, 2, 'PPL', 'P'),
(30715, 'Odon', 38.8427810668945, 0.677934420248625, -86.9913864135742, -1.51828611379153, 218, 19, 'PPL', 'P'),
(42415, 'Odra', 31.5969390869141, 0.551470620618741, -92.8361129760742, -1.62029583618593, 218, 22, 'PPL', 'P'),
(104890, 'Odricks Corner', 38.9386100769043, 0.679606951992222, -77.2316665649414, -1.34794686836065, 218, 53, 'PPL', 'P'),
(23604, 'Odum', 31.6658306121826, 0.552673004561398, -82.0280609130859, -1.43165974195982, 218, 13, 'PPL', 'P'),
(89628, 'Odum (historical)', 36.3294410705566, 0.634068362090467, -86.3675003051758, -1.50739724704252, 218, 50, 'PPL', 'P'),
(50048, 'Odyssey', 38.7452812194824, 0.676232726891092, -76.6297225952148, -1.33744096417639, 218, 25, 'PPL', 'P'),
(187127, 'Oehlmann Park', 39.5188903808594, 0.689734753880712, -105.258613586426, -1.83710937316757, 218, 7, 'PPL', 'P'),
(50049, 'Oella', 39.2738914489746, 0.685458715855453, -76.7869415283203, -1.34018495220556, 218, 25, 'PPL', 'P'),
(202449, 'Oelrichs', 43.1788902282715, 0.753613801840543, -103.230278015137, -1.80170823911325, 218, 49, 'PPL', 'P'),
(117107, 'Oelwein', 42.6733283996582, 0.744790083358838, -91.913330078125, -1.60419023633562, 218, 16, 'PPL', 'P'),
(96713, 'Oenaville', 31.1275005340576, 0.543277372235599, -97.2280578613281, -1.69694973499973, 218, 51, 'PPL', 'P'),
(56649, 'Oermann', 38.3080596923828, 0.668601771682606, -90.7233276367188, -1.58342077562631, 218, 29, 'PPL', 'P'),
(56650, 'Oetters', 38.5552787780762, 0.672916558701725, -90.7936096191406, -1.5846474276244, 218, 29, 'PPL', 'P'),
(61147, 'Ofahoma', 32.707218170166, 0.570848646237512, -89.7005615234375, -1.56557013947173, 218, 30, 'PPL', 'P'),
(4738, 'Ofelia', 33.3183288574219, 0.581514539824252, -85.6136093139648, -1.49423936704477, 218, 2, 'PPL', 'P'),
(67432, 'Offer (historical)', 36.292781829834, 0.633428537638575, -81.0599975585938, -1.41476384905603, 218, 33, 'PPL', 'P'),
(33479, 'Offerle', 37.8908309936523, 0.661319757155948, -99.557502746582, -1.73760621799115, 218, 20, 'PPL', 'P'),
(23605, 'Offerman', 31.4094390869141, 0.548198128271252, -82.1119384765625, -1.43312368161103, 218, 13, 'PPL', 'P'),
(104891, 'Office Hall', 38.2388916015625, 0.667394560760473, -77.1505584716797, -1.34653126508321, 218, 53, 'PPL', 'P'),
(208309, 'Officers Row', 45.6283302307129, 0.796364594713204, -122.658332824707, -2.14079176279817, 218, 56, 'PPL', 'P'),
(194351, 'Offield Place', 40.9858283996582, 0.715337652231434, -108.662498474121, -1.89651837181673, 218, 7, 'PPL', 'P'),
(89631, 'Offset', 36.6063919067383, 0.638902066047988, -81.9197235107422, -1.42976889758586, 218, 50, 'PPL', 'P'),
(37491, 'Offutt', 37.8499984741211, 0.660607095248243, -82.7297210693359, -1.44390602191644, 218, 21, 'PPL', 'P'),
(89629, 'Offutt', 36.1688919067383, 0.631266250570513, -84.1302795410156, -1.46835037861395, 218, 50, 'PPL', 'P'),
(208311, 'Offutt Lake', 46.9105606079102, 0.818743736564385, -122.824440002441, -2.14369087996083, 218, 56, 'PPL', 'P'),
(10926, 'Offutt Landing', 34.1883316040039, 0.596698952253502, -90.9024963378906, -1.58654785937828, 218, 4, 'PPL', 'P'),
(50050, 'Offutt Ridge', 39.3624992370605, 0.687005213500463, -76.8305587768555, -1.34094621680316, 218, 25, 'PPL', 'P'),
(104892, 'Offutt Village', 38.8930587768555, 0.678811931827807, -77.1866683959961, -1.34716150215518, 218, 53, 'PPL', 'P'),
(10925, 'Oga (historical)', 35.9480590820313, 0.627411990682896, -92.2866668701172, -1.61070619257472, 218, 4, 'PPL', 'P'),
(33480, 'Ogallah', 38.9913902282715, 0.680528139413281, -99.7319412231445, -1.74065074374933, 218, 20, 'PPL', 'P'),
(199577, 'Ogallala', 41.128059387207, 0.717820051262524, -101.719169616699, -1.77533442220598, 218, 35, 'PPL', 'P'),
(56652, 'Ogborn', 37.8311080932617, 0.660277395905291, -90.4216690063477, -1.57815583930928, 218, 29, 'PPL', 'P'),
(96714, 'Ogburn', 32.8400001525879, 0.573166129018099, -95.2222213745117, -1.66194128404815, 218, 51, 'PPL', 'P'),
(104893, 'Ogburn', 36.7966690063477, 0.642223027927317, -78.2261123657227, -1.36530322181691, 218, 53, 'PPL', 'P'),
(67434, 'Ogburn Crossroads', 35.5555610656738, 0.620561607989912, -78.6383285522461, -1.37249775150176, 218, 33, 'PPL', 'P'),
(67435, 'Ogburn Station', 36.149169921875, 0.63092203699962, -80.2241668701172, -1.4001758515529, 218, 33, 'PPL', 'P'),
(67436, 'Ogburns Crossroads', 36.2466697692871, 0.632623730357153, -79.9211120605469, -1.39488654731189, 218, 33, 'PPL', 'P'),
(10927, 'Ogden', 33.5825004577637, 0.586125204040479, -94.0425033569336, -1.64135132039631, 218, 4, 'PPL', 'P'),
(30722, 'Ogden', 39.7991714477539, 0.694626581329024, -85.4688873291016, -1.49171349190888, 218, 19, 'PPL', 'P'),
(33482, 'Ogden', 39.1111106872559, 0.682617655604557, -96.7058334350586, -1.68783519932699, 218, 20, 'PPL', 'P'),
(56653, 'Ogden', 36.7444381713867, 0.641311427886183, -89.5563888549805, -1.56305385171576, 218, 29, 'PPL', 'P'),
(67437, 'Ogden', 34.2722206115723, 0.598163091641801, -77.8188934326172, -1.35819591065776, 218, 33, 'PPL', 'P'),
(71213, 'Ogden', 39.8116683959961, 0.694844694222302, -75.2024993896484, -1.31253122007839, 218, 37, 'PPL', 'P'),
(73767, 'Ogden', 39.4308280944824, 0.6881977770366, -83.9113922119141, -1.46453007403023, 218, 41, 'PPL', 'P'),
(78876, 'Ogden', 39.829719543457, 0.695159746179258, -75.456672668457, -1.31696738066419, 218, 45, 'PPL', 'P'),
(82747, 'Ogden', 34.8624992370605, 0.608465397160718, -81.0947189331055, -1.41536985136207, 218, 48, 'PPL', 'P'),
(89630, 'Ogden', 35.5086097717285, 0.619742153322495, -85.1013870239258, -1.48529940158148, 218, 50, 'PPL', 'P'),
(110748, 'Ogden', 39.3016700744629, 0.685943544331902, -81.4022216796875, -1.42073678674886, 218, 58, 'PPL', 'P'),
(117108, 'Ogden', 42.0391693115234, 0.733721919289442, -94.0274963378906, -1.6410893985031, 218, 16, 'PPL', 'P'),
(120876, 'Ogden', 40.1138916015625, 0.700119484235367, -87.9561080932617, -1.53512368346745, 218, 18, 'PPL', 'P'),
(132398, 'Ogden', 41.8177795410156, 0.729857938863846, -83.9800033569336, -1.46572756441438, 218, 27, 'PPL', 'P'),
(191962, 'Ogden', 34.0908317565918, 0.594997258895969, -100.123062133789, -1.74747709141348, 218, 51, 'PPL', 'P'),
(205214, 'Ogden', 41.2230606079102, 0.719478135357207, -111.97306060791, -1.9542985811432, 218, 52, 'PPL', 'P'),
(205215, 'Ogden Canyon Wildwood Estates', 41.2536087036133, 0.720011300207441, -111.868606567383, -1.95247551421898, 218, 52, 'PPL', 'P'),
(132399, 'Ogden Center', 41.7719383239746, 0.729057858693359, -83.959716796875, -1.46537349714746, 218, 27, 'PPL', 'P'),
(151354, 'Ogden Center', 43.1722183227539, 0.75349735512188, -77.8047180175781, -1.35794850299249, 218, 40, 'PPL', 'P'),
(123354, 'Ogden Dunes', 41.6227798461914, 0.726454552148779, -87.1916732788086, -1.52178177903837, 218, 19, 'PPL', 'P'),
(104894, 'Ogden Hills', 37.2388916015625, 0.64994126824053, -79.9861068725586, -1.39602092077821, 218, 53, 'PPL', 'P'),
(145957, 'Ogdensburg', 41.0816688537598, 0.717010383712113, -74.5927810668945, -1.3018896278366, 218, 37, 'PPL', 'P'),
(151356, 'Ogdensburg', 44.6941719055176, 0.78006045620363, -75.4866714477539, -1.3174909581345, 218, 40, 'PPL', 'P'),
(165472, 'Ogdensburg', 41.6152801513672, 0.726323657781202, -76.970832824707, -1.34339446079327, 218, 45, 'PPL', 'P'),
(175661, 'Ogdensburg', 44.4519386291504, 0.775832687973129, -89.0316696166992, -1.5538957733592, 218, 57, 'PPL', 'P'),
(165473, 'Ogdonia', 41.4113883972168, 0.72276507535361, -76.7058334350586, -1.33876934892812, 218, 45, 'PPL', 'P'),
(4739, 'Ogee (historical)', 33.9383316040039, 0.592335629123517, -86.3847198486328, -1.50769778477154, 218, 2, 'PPL', 'P'),
(23606, 'Ogeechee', 32.6197204589844, 0.569321523089433, -81.7649993896484, -1.42706845224052, 218, 13, 'PPL', 'P'),
(76783, 'Ogeechee', 36.7625007629395, 0.641626679580221, -94.8141708374023, -1.65481945866106, 218, 42, 'PPL', 'P'),
(23607, 'Ogeechee Farms', 31.9883308410645, 0.558301695393822, -81.2569427490234, -1.41820119107499, 218, 13, 'PPL', 'P'),
(23608, 'Ogeecheeton', 32.0597190856934, 0.559547655309815, -81.1305618286133, -1.41599542790213, 218, 13, 'PPL', 'P'),
(137259, 'Ogema', 47.1027793884277, 0.822098587168585, -95.9247207641602, -1.67420221139077, 218, 28, 'PPL', 'P'),
(175663, 'Ogema', 45.4436111450195, 0.793140638476581, -90.2980575561523, -1.5759984125102, 218, 57, 'PPL', 'P'),
(10930, 'Ogemaw', 33.4625015258789, 0.584030827580213, -93.0250015258789, -1.62359256329934, 218, 4, 'PPL', 'P'),
(132404, 'Ogemaw Springs', 44.3036117553711, 0.77324389565649, -84.2925033569336, -1.47118171832686, 218, 27, 'PPL', 'P'),
(191964, 'Ogg', 34.8352813720703, 0.607990355801275, -101.889717102051, -1.77831103735636, 218, 51, 'PPL', 'P'),
(183794, 'Ogilby', 32.8169403076172, 0.572763658798361, -114.83805847168, -2.00430222692858, 218, 6, 'PPL', 'P'),
(137262, 'Ogilvie', 45.832218170166, 0.799923110561768, -93.4261093139648, -1.63059321485683, 218, 28, 'PPL', 'P'),
(30716, 'Ogilville', 39.1258316040039, 0.682874584070722, -86.0152816772461, -1.50124987229829, 218, 19, 'PPL', 'P'),
(202451, 'Oglala', 43.1886100769043, 0.753783445201981, -102.739166259766, -1.79313672198678, 218, 49, 'PPL', 'P'),
(37493, 'Ogle', 37.0299987792969, 0.646295400708212, -83.711669921875, -1.46104426247942, 218, 21, 'PPL', 'P'),
(120878, 'Ogle', 41.1072196960449, 0.717456330036647, -90.8836135864258, -1.58621829319338, 218, 18, 'PPL', 'P'),
(165486, 'Ogle', 40.7041702270508, 0.710421789754284, -80.1044387817383, -1.39808620220357, 218, 45, 'PPL', 'P'),
(28108, 'Ogles', 38.5466690063477, 0.672766289837218, -90.0547180175781, -1.5717513363618, 218, 18, 'PPL', 'P'),
(73769, 'Ogles (historical)', 39.5405616760254, 0.69011298933453, -83.831672668457, -1.46313870551872, 218, 41, 'PPL', 'P'),
(23610, 'Oglesby', 34.0755615234375, 0.594730743049879, -82.9672164916992, -1.44805109899509, 218, 13, 'PPL', 'P'),
(76784, 'Oglesby', 36.6263885498047, 0.639251073308843, -95.8563919067383, -1.67300964785463, 218, 42, 'PPL', 'P'),
(89632, 'Oglesby', 36.0400009155273, 0.629016678397723, -86.7436065673828, -1.51396153965541, 218, 50, 'PPL', 'P'),
(96717, 'Oglesby', 31.4183292388916, 0.548353290694263, -97.5069427490234, -1.70181719452407, 218, 51, 'PPL', 'P'),
(120880, 'Oglesby', 41.295280456543, 0.720738609501142, -89.059440612793, -1.55438046867759, 218, 18, 'PPL', 'P'),
(56654, 'Oglesville', 36.5802803039551, 0.638446332606448, -90.3102798461914, -1.57621173171352, 218, 29, 'PPL', 'P'),
(23609, 'Oglethorpe', 32.2936096191406, 0.563629815207716, -84.0611114501953, -1.46714316769181, 218, 13, 'PPL', 'P'),
(23614, 'Oglethorpe Manor', 31.2694396972656, 0.545754677971104, -81.4327774047852, -1.42127008475714, 218, 13, 'PPL', 'P'),
(23615, 'Oglethorpe Park', 31.1680603027344, 0.543985273742855, -81.3808288574219, -1.42036341156403, 218, 13, 'PPL', 'P'),
(73768, 'Ogleton (historical)', 39.4711112976074, 0.688900851564381, -84.7380599975586, -1.4789581487099, 218, 41, 'PPL', 'P'),
(14345, 'Ogletown', 39.6780586242676, 0.692512763792801, -75.6977767944336, -1.32117544150263, 218, 10, 'PPL', 'P'),
(165475, 'Ogletown', 40.2024993896484, 0.701665981880376, -78.7033309936523, -1.37363225812613, 218, 45, 'PPL', 'P'),
(128418, 'Ogontz', 45.8202781677246, 0.799714718206469, -69.7136077880859, -1.21673198934606, 218, 26, 'PPL', 'P'),
(132405, 'Ogontz', 45.8683280944824, 0.800553347633735, -86.7908325195313, -1.51478578801279, 218, 27, 'PPL', 'P'),
(156914, 'Ogontz', 41.3438911437988, 0.721587026045414, -82.4594421386719, -1.43918876467758, 218, 41, 'PPL', 'P'),
(67438, 'Ogreeta', 35.1533317565918, 0.613541382198409, -84.1413879394531, -1.4685442567413, 218, 33, 'PPL', 'P'),
(128419, 'Ogren', 46.910831451416, 0.81874846367532, -68.0563888549805, -1.18780806253698, 218, 26, 'PPL', 'P'),
(128420, 'Ogunquit', 43.2488899230957, 0.754835526990617, -70.5997161865234, -1.23219749842837, 218, 26, 'PPL', 'P'),
(4740, 'Ohatchee', 33.7833290100098, 0.589630323509187, -86.0025024414063, -1.501026832557, 218, 2, 'PPL', 'P'),
(17398, 'Ohathlockhouchy (historical)', 30.5333309173584, 0.532907156108885, -84.4833297729492, -1.47451226758612, 218, 12, 'PPL', 'P'),
(210800, 'Ohia (historical)', 19.5880603790283, 0.341876147693493, -155.078323364258, -2.70662734117875, 218, 15, 'PPL', 'P'),
(23617, 'Ohio', 32.5827789306641, 0.568676771789525, -83.8158264160156, -1.46286213623951, 218, 13, 'PPL', 'P'),
(56655, 'Ohio', 38.1555595397949, 0.665940141910154, -93.8516693115234, -1.638020637979, 218, 29, 'PPL', 'P'),
(96718, 'Ohio', 31.5391693115234, 0.550462347830037, -98.0858306884766, -1.71192069506761, 218, 51, 'PPL', 'P'),
(120881, 'Ohio', 41.5574989318848, 0.725315185255416, -89.4608306884766, -1.5613860470831, 218, 18, 'PPL', 'P'),
(151358, 'Ohio', 43.3222198486328, 0.756115375631482, -74.978889465332, -1.30862849065893, 218, 40, 'PPL', 'P'),
(156917, 'Ohio', 40.2502784729004, 0.702499884196707, -83.0002822875977, -1.44862820600331, 218, 41, 'ADM1', 'A'),
(187129, 'Ohio', 38.5666694641113, 0.6731153636771, -106.611106872559, -1.8607148341217, 218, 7, 'PPL', 'P'),
(197174, 'Ohio Camp', 48.8330612182617, 0.85229770208662, -111.845832824707, -1.95207803742629, 218, 31, 'PPL', 'P'),
(156916, 'Ohio City', 40.7713890075684, 0.711594978793491, -84.6155624389648, -1.47682016298678, 218, 41, 'PPL', 'P'),
(73770, 'Ohio Furnace', 38.6027793884277, 0.673745600749067, -82.7847213745117, -1.44486595833136, 218, 41, 'PPL', 'P'),
(78875, 'Ohiopyle', 39.8716697692871, 0.695891915741948, -79.4925003051758, -1.38740586096791, 218, 45, 'PPL', 'P'),
(165479, 'Ohioview', 40.6538887023926, 0.709544211596076, -80.3880615234375, -1.40303635287975, 218, 45, 'PPL', 'P'),
(151360, 'Ohioville', 41.7408294677734, 0.728514906726119, -74.0569381713867, -1.29253740503657, 218, 40, 'PPL', 'P'),
(165480, 'Ohioville', 40.6791687011719, 0.709985430809674, -80.495002746582, -1.40490282932974, 218, 45, 'PPL', 'P'),
(142582, 'Ohiowa', 40.4144401550293, 0.705365046055469, -97.4524993896484, -1.70086697864713, 218, 35, 'PPL', 'P'),
(165482, 'Ohl', 41.0833282470703, 0.717039345588967, -79.1611099243164, -1.38162200771248, 218, 45, 'PPL', 'P'),
(110747, 'Ohley', 38.1069412231445, 0.665091592207827, -81.4491729736328, -1.42155624141627, 218, 58, 'PPL', 'P'),
(28109, 'Ohlman', 39.3450012207031, 0.686699815502458, -89.2186126708984, -1.55715854516871, 218, 18, 'PPL', 'P'),
(56657, 'Ohlman', 37.4263916015625, 0.653213760588019, -91.1152801513672, -1.59026163751839, 218, 29, 'PPL', 'P'),
(156918, 'Ohlton (historical)', 41.1216697692871, 0.717708531391877, -80.7802810668945, -1.40988187530375, 218, 41, 'PPL', 'P'),
(156919, 'Ohltown', 41.1283302307129, 0.717824778373459, -80.7852783203125, -1.40996909382945, 218, 41, 'PPL', 'P'),
(183795, 'Ohm', 37.6266708374023, 0.656709292676803, -121.283058166504, -2.11678869189329, 218, 6, 'PPL', 'P'),
(183796, 'Ohmer (historical)', 38.0097198486328, 0.663394759119283, -122.021667480469, -2.12967985630787, 218, 6, 'PPL', 'P'),
(212064, 'Ohogamiut', 61.5677795410156, 1.07456046613273, -161.863616943359, -2.8250530548485, 218, 1, 'PPL', 'P'),
(23618, 'Ohoopee', 32.1800003051758, 0.561646958618097, -82.2197189331055, -1.43500480544701, 218, 13, 'PPL', 'P'),
(208312, 'Ohop', 46.9458312988281, 0.819359326250357, -122.189437866211, -2.13260800192642, 218, 56, 'PPL', 'P'),
(208313, 'Ohop Bob', 46.8722190856934, 0.818074550761475, -122.336936950684, -2.13518234659414, 218, 56, 'PPL', 'P'),
(28110, 'Oil Center', 38.9680595397949, 0.680120942082608, -87.8327789306641, -1.53297118351639, 218, 18, 'PPL', 'P'),
(37495, 'Oil Center', 37.1058311462402, 0.647618925190954, -84.7069396972656, -1.47841499700557, 218, 21, 'PPL', 'P'),
(76787, 'Oil Center', 34.8686103820801, 0.608572056762375, -96.8238906860352, -1.68989568706238, 218, 42, 'PPL', 'P'),
(189137, 'Oil Center', 32.4991683959961, 0.567217492670216, -103.260833740234, -1.80224153712154, 218, 38, 'PPL', 'P'),
(156920, 'Oil Center (historical)', 41.211109161377, 0.719269543264827, -83.6449966430664, -1.45988059424111, 218, 41, 'PPL', 'P'),
(37496, 'Oil City', 37.0333290100098, 0.646353524199002, -85.9830627441406, -1.50068754583412, 218, 21, 'PPL', 'P'),
(42420, 'Oil City', 32.7438888549805, 0.571488670426485, -93.9713897705078, -1.64011015417028, 218, 22, 'PPL', 'P'),
(50063, 'Oil City', 38.9049987792969, 0.679020324183105, -75.8150024414063, -1.32322141501008, 218, 25, 'PPL', 'P'),
(56658, 'Oil City', 39.3444404602051, 0.686690028385452, -92.8491668701172, -1.62052366961718, 218, 29, 'PPL', 'P'),
(61148, 'Oil City', 32.6911087036133, 0.570567483005427, -90.4338912963867, -1.57836915851259, 218, 30, 'PPL', 'P'),
(76789, 'Oil City', 34.2744407653809, 0.598201840635661, -97.4180603027344, -1.7002659031891, 218, 42, 'PPL', 'P'),
(132406, 'Oil City', 43.6108283996582, 0.761152545096285, -84.5883331298828, -1.47634492189026, 218, 27, 'PPL', 'P'),
(165484, 'Oil City', 41.4338912963867, 0.72315782503537, -79.706672668457, -1.39114387387395, 218, 45, 'PPL', 'P'),
(175665, 'Oil City', 43.750560760498, 0.763591334864525, -90.586669921875, -1.58103564855403, 218, 57, 'PPL', 'P'),
(183797, 'Oil City', 35.4263916015625, 0.618307175548133, -118.959442138672, -2.07623394165551, 218, 6, 'PPL', 'P'),
(191963, 'Oil City', 35.746940612793, 0.623901811208117, -101.513061523438, -1.77173715736356, 218, 51, 'PPL', 'P'),
(208314, 'Oil City', 47.750560760498, 0.833404504944298, -124.424171447754, -2.17161146082923, 218, 56, 'PPL', 'P'),
(28111, 'Oil Grove', 38.8627815246582, 0.678283494088508, -87.6416702270508, -1.52963570740912, 218, 18, 'PPL', 'P'),
(183798, 'Oil Junction', 35.4197196960449, 0.618190728829469, -119.056106567383, -2.07792105420607, 218, 6, 'PPL', 'P'),
(110749, 'Oil Spring', 39.2222213745117, 0.684556902931325, -81.2886123657227, -1.41875393015924, 218, 58, 'PPL', 'P'),
(37498, 'Oil Springs', 37.810001373291, 0.659909014147506, -82.942497253418, -1.4476196668985, 218, 21, 'PPL', 'P'),
(209641, 'Oil Springs', 41.9911117553711, 0.732883156704121, -106.266937255859, -1.85470794112497, 218, 59, 'PPL', 'P'),
(156921, 'Oil Station', 41.2561111450195, 0.720054976049319, -83.0119400024414, -1.44883167151059, 218, 41, 'PPL', 'P'),
(10928, 'Oil Trough', 35.6308288574219, 0.621875278776621, -91.4602813720703, -1.59628304474306, 218, 4, 'PPL', 'P'),
(37497, 'Oil Valley', 36.7744407653809, 0.64183507193552, -84.7983322143555, -1.48001009734048, 218, 21, 'PPL', 'P'),
(4741, 'Oil Well Landing', 31.5891704559326, 0.551335032429742, -88.0661087036133, -1.53704355629729, 218, 2, 'PPL', 'P'),
(183799, 'Oildale', 35.4197196960449, 0.618190728829469, -119.018608093262, -2.07726658236819, 218, 6, 'PPL', 'P'),
(28112, 'Oilfield', 39.3938903808594, 0.687553092315719, -87.9886093139648, -1.53569093677964, 218, 18, 'PPL', 'P'),
(96719, 'Oilla', 30.0974998474121, 0.525300468955832, -93.8908309936523, -1.63870413827277, 218, 51, 'PPL', 'P'),
(197175, 'Oilmont', 48.7400016784668, 0.850673506716808, -111.839996337891, -1.95197617151459, 218, 31, 'PPL', 'P'),
(37499, 'Oilton', 36.774169921875, 0.641830344824585, -84.8788909912109, -1.48141611323798, 218, 21, 'PPL', 'P'),
(76790, 'Oilton', 36.0844383239746, 0.629792257486181, -96.5833282470703, -1.68569708044582, 218, 42, 'PPL', 'P'),
(96720, 'Oilton', 27.4655609130859, 0.47936446884041, -98.9738922119141, -1.72742029261187, 218, 51, 'PPL', 'P'),
(104896, 'Oilville', 37.7038917541504, 0.658057051925465, -77.7855606079102, -1.35761414311763, 218, 53, 'PPL', 'P'),
(110750, 'Oilville', 37.7277793884277, 0.658473969794117, -82.0372161865234, -1.43181953162522, 218, 58, 'PPL', 'P'),
(67442, 'Oine', 36.4833297729492, 0.636754226628839, -78.230827331543, -1.36538551349459, 218, 33, 'PPL', 'P'),
(178742, 'Oit Ihuk', 32.315559387207, 0.564012910930524, -112.245002746582, -1.95904486683793, 218, 5, 'PPL', 'P'),
(183800, 'Ojai', 34.4480590820313, 0.601232051902981, -119.241943359375, -2.08116451809768, 218, 6, 'PPL', 'P'),
(183802, 'Ojai Valley Estates Mobile Home Park', 34.4508285522461, 0.601280388276766, -119.273063659668, -2.081707669802, 218, 6, 'PPL', 'P'),
(183803, 'Ojala', 34.4844398498535, 0.601867016085883, -119.298332214355, -2.08214868927852, 218, 6, 'PPL', 'P'),
(140640, 'Ojata (historical)', 47.9174995422363, 0.8363181363349, -97.2688903808594, -1.69766239690744, 218, 34, 'PPL', 'P'),
(175666, 'Ojibwa', 45.7980613708496, 0.799326961951753, -91.1166687011719, -1.59028587228431, 218, 57, 'PPL', 'P'),
(89633, 'Ojibwa Subdivision', 35.8624992370605, 0.625918689680661, -85.040283203125, -1.48423293872296, 218, 50, 'PPL', 'P'),
(132407, 'Ojibway', 47.3394393920898, 0.826229083440271, -88.3277816772461, -1.54161061125066, 218, 27, 'PPL', 'P'),
(189138, 'Ojita', 35.4986114501953, 0.619567649692067, -105.245002746582, -1.83687181919833, 218, 38, 'PPL', 'P'),
(189140, 'Ojito', 36.1405601501465, 0.630771768135112, -105.714172363281, -1.84506037376005, 218, 38, 'PPL', 'P'),
(189141, 'Ojitos Frios', 35.5166702270508, 0.619882834807078, -105.316940307617, -1.83812736649425, 218, 38, 'PPL', 'P'),
(189142, 'Ojo Amarillo', 36.6933288574219, 0.640419402079061, -108.368606567383, -1.89138899039918, 218, 38, 'PPL', 'P'),
(189144, 'Ojo Caliente', 36.3030586242676, 0.633607901537992, -106.046112060547, -1.85085381439541, 218, 38, 'PPL', 'P'),
(96721, 'Ojo de Angua', 27.4644393920898, 0.479344894606398, -97.4216690063477, -1.70032888694888, 218, 51, 'PPL', 'P'),
(189146, 'Ojo Encino', 35.9555587768555, 0.627542885050473, -107.347221374512, -1.87356245585246, 218, 38, 'PPL', 'P'),
(189147, 'Ojo Feliz', 36.0577812194824, 0.629327003243744, -105.117782592773, -1.83465140863948, 218, 38, 'PPL', 'P'),
(189148, 'Ojo Sarco', 36.122501373291, 0.630456583020102, -105.782783508301, -1.84625786414421, 218, 38, 'PPL', 'P'),
(17389, 'Ojus', 25.9480590820313, 0.452879065483463, -80.1508331298828, -1.39889593633301, 218, 12, 'PPL', 'P'),
(42355, 'OK Landing', 31.7694396972656, 0.554481324231076, -91.5605621337891, -1.59803327421146, 218, 22, 'PPL', 'P'),
(110753, 'Oka', 38.6561088562012, 0.67467637555005, -81.1366729736328, -1.41610208750379, 218, 58, 'PPL', 'P'),
(61149, 'Oka Hullo (historical)', 32.5763893127441, 0.568565251918878, -89.0625, -1.55443386505745, 218, 30, 'PPL', 'P'),
(4743, 'Oka Kapassa (historical)', 34.7416687011719, 0.606356506472511, -87.7333297729492, -1.53123546827593, 218, 2, 'PPL', 'P'),
(61150, 'Oka Kapassa (historical)', 32.5291709899902, 0.567741136719553, -89.1500015258789, -1.55596105478456, 218, 30, 'PPL', 'P'),
(137264, 'Okabena', 43.7394409179688, 0.763397257000086, -95.315559387207, -1.66357033968695, 218, 28, 'PPL', 'P'),
(61151, 'Okahola', 31.2069396972656, 0.544663847188608, -89.3863906860352, -1.56008682394531, 218, 30, 'PPL', 'P'),
(61152, 'Okahta Talaia (historical)', 32.4625015258789, 0.56657753506027, -89.2472229003906, -1.5576578878731, 218, 30, 'PPL', 'P'),
(17390, 'Okahumpka', 28.7474994659424, 0.501738517396006, -81.896110534668, -1.42935677340717, 218, 12, 'PPL', 'P'),
(17391, 'Okahumpka (historical)', 28.7666702270508, 0.502073110297461, -81.9000015258789, -1.42942468401497, 218, 12, 'PPL', 'P'),
(89634, 'Okalona', 36.3263893127441, 0.634015098868665, -85.3399963378906, -1.48946391973609, 218, 50, 'PPL', 'P'),
(17392, 'Okaloo', 30.9155597686768, 0.539578308060506, -86.4861068725586, -1.50946732215784, 218, 12, 'PPL', 'P'),
(42417, 'Okaloosa', 32.3800010681152, 0.565137630437892, -92.3277816772461, -1.61142378133044, 218, 22, 'PPL', 'P'),
(208315, 'Okanogan', 48.3613891601563, 0.844065471683022, -119.582221984863, -2.08710350048661, 218, 56, 'PPL', 'P'),
(208316, 'Okanogan City (historical)', 47.6416702270508, 0.831504006611391, -119.995002746582, -2.0943078838675, 218, 56, 'PPL', 'P'),
(76791, 'Okarche', 35.725830078125, 0.623533362871304, -97.9761123657227, -1.71000574908579, 218, 42, 'PPL', 'P'),
(82751, 'Okatie', 32.3519401550293, 0.564647875113426, -80.9783325195313, -1.41333852524062, 218, 48, 'PPL', 'P'),
(202452, 'Okaton', 43.8861083984375, 0.76595708743987, -100.891387939453, -1.76088690645035, 218, 49, 'PPL', 'P'),
(4742, 'Okatuppa', 31.9447193145752, 0.557540530664763, -88.396110534668, -1.5428031747868, 218, 2, 'PPL', 'P'),
(175668, 'Okauchee', 43.1136093139648, 0.75247443494718, -88.4358291625977, -1.54349639561855, 218, 57, 'PPL', 'P'),
(175669, 'Okauchee Lake', 43.1233291625977, 0.752644078308618, -88.440559387207, -1.54357895361234, 218, 57, 'PPL', 'P'),
(17394, 'Okawahathako (historical)', 29.5666694641113, 0.51603573099761, -81.716667175293, -1.42622489596524, 218, 12, 'PPL', 'P'),
(28114, 'Okawville', 38.4341697692871, 0.670802807744529, -89.5502777099609, -1.56294719211411, 218, 18, 'PPL', 'P'),
(10931, 'Okay', 33.7675018310547, 0.589354087125118, -93.9238891601563, -1.63928111212294, 218, 4, 'PPL', 'P'),
(76792, 'Okay', 35.8505592346191, 0.625710297325362, -95.3180618286133, -1.66361401552883, 218, 42, 'PPL', 'P'),
(10932, 'Okay (historical)', 35.5558280944824, 0.62056626852182, -92.8427810668945, -1.62041221632556, 218, 4, 'PPL', 'P'),
(17395, 'Okeafenoke Swamp (historical)', 30.1666698455811, 0.526507713167479, -82.4166717529297, -1.43844228062403, 218, 12, 'PPL', 'P'),
(73775, 'Okeana', 39.3477783203125, 0.686748285034297, -84.7675018310547, -1.47947200564223, 218, 41, 'PPL', 'P'),
(175670, 'Okee', 43.357780456543, 0.756736025323525, -89.5800018310547, -1.56346597589445, 218, 57, 'PPL', 'P'),
(17396, 'Okeechobee', 27.2436103820801, 0.475490701297808, -80.8300018310547, -1.41074966634495, 218, 12, 'PPL', 'P'),
(17399, 'Okeelanta', 26.6094398498535, 0.464422337491329, -80.711669921875, -1.40868438491959, 218, 12, 'PPL', 'P'),
(76793, 'Okeene', 36.1161117553711, 0.630345063149454, -98.3166732788086, -1.71594965832274, 218, 42, 'PPL', 'P'),
(67439, 'Okeewemee', 35.4075012207031, 0.617977476205181, -79.8541717529297, -1.39371821854168, 218, 33, 'PPL', 'P'),
(76794, 'Okemah', 35.4324989318848, 0.618413768570763, -96.3047180175781, -1.68083441461144, 218, 42, 'PPL', 'P'),
(132408, 'Okemos', 42.7222213745117, 0.745643426751127, -84.4274978637695, -1.47353781694326, 218, 27, 'PPL', 'P'),
(76796, 'Okesa', 36.7127799987793, 0.640758888539019, -96.1344375610352, -1.67786245999297, 218, 42, 'PPL', 'P'),
(56659, 'Okete', 39.0977783203125, 0.682384961904311, -90.9302825927734, -1.58703282101278, 218, 29, 'PPL', 'P'),
(23619, 'Oketeyeconne (historical)', 31.6430606842041, 0.552275594347731, -85.0805587768555, -1.48493588009269, 218, 13, 'PPL', 'P'),
(33488, 'Oketo', 39.9636116027832, 0.697496603456775, -96.5994415283203, -1.68597831025693, 218, 20, 'PPL', 'P'),
(73776, 'Okey', 38.6291694641113, 0.674206194459596, -82.3683319091797, -1.43759859119069, 218, 41, 'PPL', 'P'),
(76797, 'Okfuskee', 35.5952796936035, 0.62125482882166, -96.2280578613281, -1.67949644247979, 218, 42, 'PPL', 'P'),
(67440, 'Okisko', 36.2591705322266, 0.632841909829458, -76.3550033569336, -1.33264620894981, 218, 33, 'PPL', 'P'),
(37500, 'Oklahoma', 37.6616706848145, 0.65732015525184, -86.8772201538086, -1.51629353666393, 218, 21, 'PPL', 'P'),
(42418, 'Oklahoma', 31.0086097717285, 0.54120233698275, -92.2083282470703, -1.60933892567107, 218, 22, 'PPL', 'P'),
(50052, 'Oklahoma', 39.4136085510254, 0.687897239307585, -76.9230575561523, -1.34256062505596, 218, 25, 'PPL', 'P'),
(61158, 'Oklahoma', 33.333610534668, 0.581781255407424, -90.168327331543, -1.57373419295142, 218, 30, 'PPL', 'P'),
(76804, 'Oklahoma', 35.5002784729004, 0.619596744726976, -97.5002822875977, -1.70170094754249, 218, 42, 'ADM1', 'A'),
(96722, 'Oklahoma', 30.1552791595459, 0.526308908192104, -95.5936126708984, -1.66842328498335, 218, 51, 'PPL', 'P'),
(165506, 'Oklahoma', 41.1138916015625, 0.71757277675531, -78.7336120605469, -1.37416076244446, 218, 45, 'PPL', 'P'),
(73777, 'Oklahoma (historical)', 39.7863883972168, 0.694403475008703, -84.6338882446289, -1.4771400086337, 218, 41, 'PPL', 'P'),
(151363, 'Oklahoma Beach', 43.2391700744629, 0.754665883629179, -77.5186080932617, -1.35295494279054, 218, 40, 'PPL', 'P'),
(76800, 'Oklahoma City', 35.4674987792969, 0.6190246311458, -97.51611328125, -1.70197725050558, 218, 42, 'PPL', 'P'),
(191974, 'Oklahoma Flat', 33.7861099243164, 0.589678859620054, -102.40055847168, -1.78722690121178, 218, 51, 'PPL', 'P'),
(125729, 'Oklahoma Heights', 41.4388885498047, 0.72324504356107, -70.6091690063477, -1.2323624812579, 218, 23, 'PPL', 'P'),
(201344, 'Oklahoma Hill', 46.1433296203613, 0.80535302970833, -123.404716491699, -2.1538186152703, 218, 43, 'PPL', 'P'),
(23620, 'Oklahoma Hills', 33.4077796936035, 0.583075751434284, -82.0647201538086, -1.43229956641171, 218, 13, 'PPL', 'P'),
(76803, 'Oklahoma Hills', 34.4819412231445, 0.601823406823033, -97.9280624389648, -1.70916711965853, 218, 42, 'PPL', 'P'),
(191965, 'Oklahoma Lane', 34.3855094909668, 0.60014035559313, -102.886428833008, -1.79570693875481, 218, 51, 'PPL', 'P'),
(96723, 'Oklaunion', 34.1294403076172, 0.595671105230786, -99.1425018310547, -1.73036308561641, 218, 51, 'PPL', 'P'),
(137266, 'Oklee', 47.839168548584, 0.834951002589307, -95.8541717529297, -1.67297089886077, 218, 28, 'PPL', 'P'),
(76805, 'Okmulgee', 35.6233291625977, 0.621744384409044, -95.9602813720703, -1.67482286108281, 218, 42, 'PPL', 'P'),
(117110, 'Okoboji', 43.3863906860352, 0.757235368027915, -95.148063659668, -1.66064698775837, 218, 16, 'PPL', 'P'),
(202454, 'Okobojo', 44.649169921875, 0.779275023419138, -100.395278930664, -1.75222817079818, 218, 49, 'PPL', 'P'),
(210803, 'Okoe (historical)', 19.1544399261475, 0.334308043086733, -155.912780761719, -2.72119137023206, 218, 15, 'PPL', 'P'),
(76807, 'Okoee', 36.5186080932617, 0.637369949472865, -95.0944366455078, -1.65971101979326, 218, 42, 'PPL', 'P'),
(10933, 'Okolona', 33.9972190856934, 0.593363409567205, -93.3377838134766, -1.62905164405983, 218, 4, 'PPL', 'P'),
(37503, 'Okolona', 38.1411094665527, 0.665687940554923, -85.6877822875977, -1.49553392965066, 218, 21, 'PPL', 'P'),
(61153, 'Okolona', 34.0016708374023, 0.593441107292008, -88.7552795410156, -1.54907185651868, 218, 30, 'PPL', 'P'),
(89636, 'Okolona', 36.5819396972656, 0.638475294483303, -82.7727813720703, -1.44465756597606, 218, 50, 'PPL', 'P'),
(156922, 'Okolona', 41.355281829834, 0.721785831020788, -84.2177810668945, -1.46987756834105, 218, 41, 'PPL', 'P'),
(89637, 'Okolona Estates', 36.288890838623, 0.633360627030778, -82.3041687011719, -1.43647873195231, 218, 50, 'PPL', 'P'),
(165491, 'Okome', 41.4372215270996, 0.723215948526161, -77.413330078125, -1.35111749479644, 218, 45, 'PPL', 'P'),
(110751, 'Okonoko', 39.5230598449707, 0.689807524757498, -78.5255584716797, -1.37052954229814, 218, 58, 'PPL', 'P'),
(89638, 'Okra', 36.6158294677734, 0.639066782561409, -85.121940612793, -1.48565812938032, 218, 50, 'PPL', 'P'),
(96724, 'Okra', 32.1436080932617, 0.561011794698114, -98.8770599365234, -1.72573025058411, 218, 51, 'PPL', 'P'),
(202456, 'Okreek', 43.3622207641602, 0.756813523311246, -100.385833740234, -1.7520633211267, 218, 49, 'PPL', 'P'),
(76808, 'Oktaha', 35.5763893127441, 0.620925129478708, -95.4747161865234, -1.66634814986196, 218, 42, 'PPL', 'P'),
(17400, 'Oktahatko (historical)', 30.9333305358887, 0.539888466458959, -85.2666702270508, -1.48818413767426, 218, 12, 'PPL', 'P'),
(61154, 'Oktibbeha (historical)', 32.5813903808594, 0.568652537023605, -88.8069381713867, -1.54997346970573, 218, 30, 'PPL', 'P'),
(61157, 'Oktoc', 33.332218170166, 0.581756954062477, -88.7577819824219, -1.54911553236056, 218, 30, 'PPL', 'P'),
(10934, 'Ola', 35.0322189331055, 0.611427564662186, -93.2230606079102, -1.62704934639426, 218, 4, 'PPL', 'P'),
(23621, 'Ola', 33.4358291625977, 0.583565307021668, -84.0419387817383, -1.46680854150085, 218, 13, 'PPL', 'P'),
(67441, 'Ola', 35.6694412231445, 0.622549191690466, -83.0980606079102, -1.45033475962983, 218, 33, 'PPL', 'P'),
(96727, 'Ola', 32.5752792358398, 0.568545877421948, -96.1752777099609, -1.67857525505873, 218, 51, 'PPL', 'P'),
(170997, 'Ola', 43.600830078125, 0.760978041465858, -99.2102813720703, -1.73154606177262, 218, 49, 'PPL', 'P'),
(195404, 'Ola', 44.1783294677734, 0.771057307243481, -116.29167175293, -2.02967256473711, 218, 17, 'PPL', 'P'),
(200105, 'Ola', 40.7213897705078, 0.710722327483299, -114.14582824707, -1.99222053032732, 218, 39, 'PPL', 'P'),
(50053, 'Olacin', 39.4055595397949, 0.687756757560083, -77.3613891601563, -1.35021095476138, 218, 25, 'PPL', 'P'),
(117112, 'Olaf', 42.8866691589355, 0.748513582036933, -93.7244415283203, -1.6358000942621, 218, 16, 'PPL', 'P'),
(201345, 'Olalla', 43.0672187805176, 0.751664767396769, -123.553329467773, -2.15641240101398, 218, 43, 'PPL', 'P'),
(208318, 'Olalla', 47.4294395446777, 0.827799882430227, -122.544441223145, -2.13880397936054, 218, 56, 'PPL', 'P'),
(128422, 'Olamon', 45.1208305358887, 0.787507054085655, -68.6111068725586, -1.19748971836386, 218, 26, 'PPL', 'P'),
(183805, 'Olancha', 36.2819404602051, 0.633239320043125, -118.005561828613, -2.05958558957504, 218, 6, 'PPL', 'P'),
(197176, 'Olanda (historical)', 47.1222190856934, 0.822437873891461, -105.607498168945, -1.84319855784198, 218, 31, 'PPL', 'P'),
(82748, 'Olanta', 33.9352798461914, 0.592282365901715, -79.9327774047852, -1.39509014597723, 218, 48, 'PPL', 'P'),
(165492, 'Olanta', 40.9166717529297, 0.714130641046383, -78.5066680908203, -1.37019984295519, 218, 45, 'PPL', 'P'),
(82749, 'Olar', 33.1802787780762, 0.57910511140703, -81.1855621337891, -1.41695536431705, 218, 48, 'PPL', 'P'),
(33490, 'Olathe', 38.8813896179199, 0.678608266583443, -94.8188934326172, -1.6549018834968, 218, 20, 'PPL', 'P'),
(187130, 'Olathe', 38.6049995422363, 0.673784349742928, -107.981666564941, -1.8846356133489, 218, 7, 'PPL', 'P'),
(56660, 'Olathia', 37.0272216796875, 0.646246931176372, -92.5194396972656, -1.61476884481763, 218, 29, 'PPL', 'P'),
(37501, 'Olaton', 37.5258293151855, 0.654949276091397, -86.6875, -1.51298229532258, 218, 21, 'PPL', 'P'),
(178743, 'Olberg', 33.0922203063965, 0.577568201141945, -111.685562133789, -1.94928078617532, 218, 5, 'PPL', 'P'),
(73778, 'Olbers', 39.482780456543, 0.689104516808745, -82.1100006103516, -1.43308985946519, 218, 41, 'PPL', 'P'),
(172367, 'Olcot Falls Mobile Home Park', 43.6813888549805, 0.762384057363365, -72.3083267211914, -1.26201837789259, 218, 55, 'PPL', 'P'),
(37502, 'Olcott', 36.6858291625977, 0.640288507711483, -83.833610534668, -1.46317252766456, 218, 21, 'PPL', 'P'),
(96725, 'Olcott', 29.5947208404541, 0.516525319874508, -95.1705627441406, -1.6610396708611, 218, 51, 'PPL', 'P'),
(110752, 'Olcott', 38.2344398498535, 0.66731686303567, -81.7244415283203, -1.42636058402278, 218, 58, 'PPL', 'P'),
(151364, 'Olcott', 43.3377799987793, 0.756386951483643, -78.7149963378906, -1.37383585679147, 218, 40, 'PPL', 'P'),
(183806, 'Olcott', 38.2772216796875, 0.668063546826301, -121.823059082031, -2.12621348583303, 218, 6, 'PPL', 'P'),
(123355, 'Old Adamsboro', 40.7833290100098, 0.71180337114879, -86.2611083984375, -1.50554035797247, 218, 19, 'PPL', 'P'),
(183807, 'Old Adobe', 35.7377815246582, 0.623741954963685, -120.698890686035, -2.10659304597603, 218, 6, 'PPL', 'P'),
(197177, 'Old Agency', 47.3288917541504, 0.826044992429919, -114.294998168945, -1.99482403660899, 218, 31, 'PPL', 'P'),
(96726, 'Old Airport Road Colonia', 28.4249992370605, 0.496109826563583, -97.7679977416992, -1.70637346367503, 218, 51, 'PPL', 'P'),
(10935, 'Old Alabam', 36.1344413757324, 0.6306649753754, -93.679443359375, -1.63501472805663, 218, 4, 'PPL', 'P'),
(175671, 'Old Albertville', 44.9366683959961, 0.784292818387011, -91.5999984741211, -1.5987215681952, 218, 57, 'PPL', 'P'),
(76809, 'Old Allison', 33.8813896179199, 0.591341803983726, -96.3369369506836, -1.68139674107561, 218, 42, 'PPL', 'P'),
(61159, 'Old Americus', 30.7091693878174, 0.535976116370065, -88.595832824707, -1.54628898633761, 218, 30, 'PPL', 'P'),
(50054, 'Old Annapolis Neck', 38.9430618286133, 0.679684649717025, -76.4911117553711, -1.33502174864216, 218, 25, 'PPL', 'P'),
(89639, 'Old Antioch', 36.4094390869141, 0.635464590870968, -85.5352783203125, -1.49287223329918, 218, 50, 'PPL', 'P'),
(175672, 'Old Ashippun', 43.2247200012207, 0.754413682273949, -88.5197219848633, -1.54496060158587, 218, 57, 'PPL', 'P'),
(42419, 'Old Athens', 32.6455612182617, 0.569772529420038, -93.057502746582, -1.62415981661152, 218, 22, 'PPL', 'P'),
(4744, 'Old Atkinson Crossing', 32.9633293151855, 0.575318628969155, -85.2350006103516, -1.48763139859001, 218, 2, 'PPL', 'P'),
(10936, 'Old Austin', 34.9866714477539, 0.610632611076797, -91.9638900756836, -1.60507267476282, 218, 4, 'PPL', 'P'),
(61160, 'Old Avera', 31.3608303070068, 0.547349745016493, -88.5669403076172, -1.5457847167852, 218, 30, 'PPL', 'P'),
(113862, 'Old Avon Village', 41.8074989318848, 0.729678508385402, -72.8294372558594, -1.27111347248937, 218, 8, 'PPL', 'P'),
(183808, 'Old Bailey Place', 39.1680603027344, 0.683611613902402, -123.481391906738, -2.15515685371806, 218, 6, 'PPL', 'P'),
(117113, 'Old Balltown', 42.6316719055176, 0.744063040381247, -90.8583297729492, -1.58577700740076, 218, 16, 'PPL', 'P'),
(50055, 'Old Baltimore', 39.4058303833008, 0.687761484671018, -76.2416687011719, -1.33066814605016, 218, 25, 'PPL', 'P'),
(104897, 'Old Bandana', 37.8913917541504, 0.661329544272954, -77.6655578613281, -1.35551970007834, 218, 53, 'PPL', 'P'),
(197178, 'Old Banks Place', 48.920280456543, 0.85381996496571, -111.116111755371, -1.9393420021452, 218, 31, 'PPL', 'P'),
(30723, 'Old Bargersville', 39.5175018310547, 0.689710519114792, -86.1558303833008, -1.50370290997837, 218, 19, 'PPL', 'P'),
(61161, 'Old Bassfield (historical)', 31.4777793884277, 0.549390891544471, -89.7583312988281, -1.56657841226043, 218, 30, 'PPL', 'P'),
(30724, 'Old Bath', 39.5083312988281, 0.689550463133279, -84.8916702270508, -1.48163915297928, 218, 19, 'PPL', 'P'),
(200103, 'Old Battle Mountain (historical)', 40.6127815246582, 0.708826755998408, -117.055557250977, -2.04300488178626, 218, 39, 'PPL', 'P'),
(17401, 'Old Bay View', 30.436939239502, 0.531224803958768, -86.1100006103516, -1.50290302954496, 218, 12, 'PPL', 'P'),
(50056, 'Old Bayside', 38.6788902282715, 0.675073985500799, -76.5488891601563, -1.33603015458892, 218, 25, 'PPL', 'P'),
(195405, 'Old Beaver', 44.4105606079102, 0.775110505264527, -112.196388244629, -1.95819638371464, 218, 17, 'PPL', 'P'),
(191966, 'Old Beekley Place', 30.2275009155273, 0.527569415625552, -103.224166870117, -1.80160157951159, 218, 51, 'PPL', 'P'),
(104898, 'Old Belle Fair (historical)', 38.5527801513672, 0.672872949438875, -77.4550018310547, -1.35184480409014, 218, 53, 'PPL', 'P'),
(76810, 'Old Bennington', 34.0475006103516, 0.594240987725414, -96.0250015258789, -1.67595244085917, 218, 42, 'PPL', 'P'),
(172368, 'Old Bennington', 42.8833312988281, 0.748455325388087, -73.2138900756836, -1.27782344001388, 218, 55, 'PPL', 'P'),
(4745, 'Old Bethel', 34.5811080932617, 0.603554195215475, -87.5236129760742, -1.52757521967373, 218, 2, 'PPL', 'P'),
(67443, 'Old Bethlehem', 36.2533302307129, 0.632739977338735, -77.9802780151367, -1.36101260298468, 218, 33, 'PPL', 'P'),
(89640, 'Old Bethpage', 36.4947204589844, 0.636953031604214, -86.2983322143555, -1.50619003612039, 218, 50, 'PPL', 'P'),
(151365, 'Old Bethpage', 40.7625007629395, 0.711439849659994, -73.45361328125, -1.28200739924445, 218, 40, 'PPL', 'P'),
(212065, 'Old Bettles (historical)', 66.9069366455078, 1.16774633688736, -151.683059692383, -2.64736881113118, 218, 1, 'PPL', 'P'),
(4746, 'Old Bingham', 32.4416694641113, 0.566213946992447, -86.1302795410156, -1.50325696365383, 218, 2, 'PPL', 'P'),
(56661, 'Old Bland', 38.314998626709, 0.668722878933178, -91.6227798461914, -1.59911917814594, 218, 29, 'PPL', 'P'),
(4747, 'Old Blevins Mill', 34.7397193908691, 0.606322484589585, -85.6322174072266, -1.49456413953971, 218, 2, 'PPL', 'P'),
(76811, 'Old Bliss', 36.5475006103516, 0.637874219025272, -97.144172668457, -1.69548566219046, 218, 42, 'PPL', 'P'),
(4748, 'Old Bluffport', 32.5922203063965, 0.568841554881974, -88.0569381713867, -1.53688350031577, 218, 2, 'PPL', 'P'),
(125724, 'Old Boat Point', 42.2383308410645, 0.73719794372324, -70.9733276367188, -1.23871824835743, 218, 23, 'PPL', 'P'),
(10939, 'Old Bonnerdale', 34.4030609130859, 0.600446685697516, -93.392219543457, -1.63000172677872, 218, 4, 'PPL', 'P'),
(96728, 'Old Boston', 33.4038887023926, 0.583007840826487, -94.4161071777344, -1.64787193716732, 218, 51, 'PPL', 'P'),
(165493, 'Old Boston', 41.2933311462402, 0.720704587618216, -75.7686080932617, -1.32241168088064, 218, 45, 'PPL', 'P'),
(10937, 'Old Botkinburg', 35.6761093139648, 0.622665571830102, -92.4880599975586, -1.61422116573946, 218, 4, 'PPL', 'P'),
(4749, 'Old Bratt Road Estates', 30.9986095428467, 0.541027800062809, -87.4569396972656, -1.52641155143542, 218, 2, 'PPL', 'P'),
(96729, 'Old Brazoria', 29.0552806854248, 0.507110313051778, -95.5650024414063, -1.66792394227896, 218, 51, 'PPL', 'P'),
(183809, 'Old Bretz Mill', 37.0816688537598, 0.64719721363234, -119.297782897949, -2.0821391018986, 218, 6, 'PPL', 'P'),
(145959, 'Old Bridge', 40.4147186279297, 0.705369906324458, -74.3658294677734, -1.29792857518927, 218, 37, 'PPL', 'P'),
(209642, 'Old Brooks Place', 41.6861114501953, 0.727559897159216, -106.340827941895, -1.85599757688284, 218, 59, 'PPL', 'P'),
(151366, 'Old Brookville', 40.8319396972656, 0.712651787693062, -73.6052780151367, -1.28465444820993, 218, 40, 'PPL', 'P'),
(28116, 'Old Brownfield', 37.3588905334473, 0.652035644700796, -88.5963897705078, -1.54629870687558, 218, 18, 'PPL', 'P'),
(37504, 'Old Brownsboro Place', 38.2891693115234, 0.668272072339654, -85.6122207641602, -1.49421513227885, 218, 21, 'PPL', 'P'),
(82750, 'Old Buckhead', 34.4500007629395, 0.601265940627852, -81.3011093139648, -1.41897204305251, 218, 48, 'PPL', 'P'),
(10938, 'Old Buffalo', 36.1683311462402, 0.631256463453507, -92.456672668457, -1.61367335350323, 218, 4, 'PPL', 'P'),
(200104, 'Old Bullion', 40.5322189331055, 0.707420673521874, -115.983612060547, -2.02429590881235, 218, 39, 'PPL', 'P'),
(191967, 'Old Burk Place', 31.3969402313232, 0.547979982088461, -101.048332214355, -1.76362610078956, 218, 51, 'PPL', 'P'),
(4750, 'Old Burleson', 34.410831451416, 0.600582307176029, -88.0366668701172, -1.53652969936496, 218, 2, 'PPL', 'P'),
(17402, 'Old Callaway', 30.1433296203613, 0.526100349389238, -85.5716705322266, -1.49350739721916, 218, 12, 'PPL', 'P'),
(125725, 'Old Cambridge', 42.3777809143066, 0.739631806643464, -71.1166687011719, -1.24122002188545, 218, 23, 'PPL', 'P'),
(190564, 'Old Camp', 37.2583312988281, 0.650280554963406, -117.323890686035, -2.04768818372122, 218, 39, 'PPL', 'P'),
(189153, 'Old Campbell Place', 33.8444404602051, 0.590696919525764, -108.891937255859, -1.90052283398983, 218, 38, 'PPL', 'P'),
(151367, 'Old Campbellwood Wye', 43.6169395446777, 0.761259204697943, -75.6647186279297, -1.32059846765246, 218, 40, 'PPL', 'P'),
(104899, 'Old Cannon Estates', 37.5022201538086, 0.654537218491734, -77.2430572509766, -1.34814567333602, 218, 53, 'PPL', 'P'),
(189154, 'Old Carthage', 33.8766708374023, 0.591259445727016, -106.726936340332, -1.86273643970518, 218, 38, 'PPL', 'P'),
(96730, 'Old Caseyville Crossing', 33.0127792358398, 0.576181692899423, -98.6136093139648, -1.72113216980403, 218, 51, 'PPL', 'P'),
(42421, 'Old Castor', 32.2666702270508, 0.563159634117262, -93.1258316040039, -1.62535238014766, 218, 22, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(23622, 'Old Cedar Creek', 34.1069412231445, 0.595278422128054, -84.6486129760742, -1.47739700367889, 218, 13, 'PPL', 'P'),
(89641, 'Old Cedar Fork', 36.4991683959961, 0.637030662749989, -83.5055618286133, -1.457446997637, 218, 50, 'PPL', 'P'),
(50057, 'Old Cedar Point', 38.9291687011719, 0.679442168899774, -76.5305633544922, -1.33571030894201, 218, 25, 'PPL', 'P'),
(96732, 'Old Center', 32.0061111450195, 0.558612020239843, -94.1875, -1.64388198922216, 218, 51, 'PPL', 'P'),
(151368, 'Old Central Bridge', 42.7063903808594, 0.745367123788031, -74.331672668457, -1.29733242657925, 218, 40, 'PPL', 'P'),
(67444, 'Old Chapel Crossroads', 36.3380584716797, 0.634218764113029, -76.6350021362305, -1.33753310955011, 218, 33, 'PPL', 'P'),
(151369, 'Old Chatham', 42.440559387207, 0.74072749769495, -73.5622177124023, -1.28390290415031, 218, 40, 'PPL', 'P'),
(56662, 'Old Chilhowee', 38.6063919067383, 0.673808651087875, -93.8505630493164, -1.6380013300611, 218, 29, 'PPL', 'P'),
(89642, 'Old Chilhowee', 35.7827796936035, 0.624527321169149, -83.767219543457, -1.46201378627427, 218, 50, 'PPL', 'P'),
(189155, 'Old Chilili', 34.9063911437988, 0.609231455448279, -106.196670532227, -1.85348155544299, 218, 38, 'PPL', 'P'),
(23623, 'Old Chimney', 32.9372215270996, 0.574862962106643, -85.0205612182617, -1.48388872515207, 218, 13, 'PPL', 'P'),
(183810, 'Old Chinatown (historical)', 34.0561103820801, 0.594391256589921, -118.235832214355, -2.06360456597608, 218, 6, 'PPL', 'P'),
(191968, 'Old Christian Place', 31.5405597686768, 0.550486615885471, -104.280281066895, -1.82003424952241, 218, 51, 'PPL', 'P'),
(37505, 'Old Christianburg', 38.2813911437988, 0.668136317703088, -85.0849990844727, -1.48501337808041, 218, 21, 'PPL', 'P'),
(23624, 'Old Church', 33.0458297729492, 0.576758533591534, -81.9375, -1.43007915585285, 218, 13, 'PPL', 'P'),
(104900, 'Old Church', 37.6444396972656, 0.657019417785743, -77.2213897705078, -1.34776750446123, 218, 53, 'PPL', 'P'),
(125726, 'Old City', 42.6375007629395, 0.744164773134888, -71.7300033569336, -1.25192473104508, 218, 23, 'PPL', 'P'),
(128423, 'Old City', 46.0122184753418, 0.80306470854168, -68.866943359375, -1.20195490740554, 218, 26, 'PPL', 'P'),
(151370, 'Old City', 43.1627807617188, 0.753332638608458, -74.9852828979492, -1.30874007710861, 218, 40, 'PPL', 'P'),
(172369, 'Old City', 43.8802795410156, 0.765855354686229, -72.3683319091797, -1.26306566599126, 218, 55, 'PPL', 'P'),
(165494, 'Old Clarendon', 41.7738914489746, 0.729091947155312, -79.101936340332, -1.38058923384175, 218, 45, 'PPL', 'P'),
(23625, 'Old Clyattville', 30.7102794647217, 0.535995490866995, -83.3202819824219, -1.45421325428337, 218, 13, 'PPL', 'P'),
(120, 'Old Coach Hills', 37.4430618286133, 0.65350471093711, -77.519172668457, -1.35296479648657, 218, 53, 'PPL', 'P'),
(104901, 'Old Cold Harbor', 37.5908317565918, 0.656083782715771, -77.2708282470703, -1.34863036865442, 218, 53, 'PPL', 'P'),
(4751, 'Old Coloma', 34.0305595397949, 0.593945310265388, -85.6183319091797, -1.49432179188051, 218, 2, 'PPL', 'P'),
(165495, 'Old Colonial Village', 40.3199996948242, 0.703716749077791, -76.8266677856445, -1.34087830619536, 218, 45, 'PPL', 'P'),
(205217, 'Old Colony', 40.6611099243164, 0.709670245694664, -111.809722900391, -1.95144780035432, 218, 52, 'PPL', 'P'),
(201346, 'Old Colton', 45.1722183227539, 0.788403940161766, -122.413612365723, -2.13652058504191, 218, 43, 'PPL', 'P'),
(178744, 'Old Columbine', 32.707218170166, 0.570848646237512, -109.908889770508, -1.91827200370688, 218, 5, 'PPL', 'P'),
(125727, 'Old Common', 42.1847190856934, 0.736262242074241, -71.7861099243164, -1.2529039753779, 218, 23, 'PPL', 'P'),
(165496, 'Old Concord', 40.0086097717285, 0.69828196966224, -80.3369369506836, -1.40214406075652, 218, 45, 'PPL', 'P'),
(104902, 'Old Conde', 38.7416687011719, 0.676169676552284, -77.9286117553711, -1.36011085663958, 218, 53, 'PPL', 'P'),
(23626, 'Old Condor', 32.5341682434082, 0.567828355245253, -82.8358306884766, -1.44575798413848, 218, 13, 'PPL', 'P'),
(191969, 'Old Corbett Place', 30.0249996185303, 0.524035101253395, -103.043609619141, -1.7984502609937, 218, 51, 'PPL', 'P'),
(82752, 'Old Cordesville', 33.1775016784668, 0.579056641875191, -79.9169387817383, -1.39481370985608, 218, 48, 'PPL', 'P'),
(183811, 'Old Corral', 37.3569412231445, 0.65200162281787, -119.606109619141, -2.08752041835526, 218, 6, 'PPL', 'P'),
(50059, 'Old County Estates', 39.0558280944824, 0.681652792341621, -76.533332824707, -1.33575864531579, 218, 25, 'PPL', 'P'),
(82753, 'Old Court', 34.1822204589844, 0.596592292651845, -79.8775024414063, -1.39412541587235, 218, 48, 'PPL', 'P'),
(104903, 'Old Courthouse', 38.913890838623, 0.67917551989563, -77.2380599975586, -1.34805845481032, 218, 53, 'PPL', 'P'),
(10940, 'Old Cove', 34.4472198486328, 0.601217404516985, -94.373893737793, -1.64713517365175, 218, 4, 'PPL', 'P'),
(165497, 'Old Crabtree', 40.3499984741211, 0.704240326548101, -79.438606262207, -1.3864652324709, 218, 45, 'PPL', 'P'),
(67445, 'Old Cumbee Place', 34.1586112976074, 0.596180235052182, -78.2197189331055, -1.36519163536724, 218, 33, 'PPL', 'P'),
(89643, 'Old Cumberland', 35.5486106872559, 0.620440301002259, -85.3724975585938, -1.49003117304828, 218, 50, 'PPL', 'P'),
(37506, 'Old Cypress', 36.723331451416, 0.640943046128397, -88.8997192382813, -1.55159280480655, 218, 21, 'PPL', 'P'),
(183812, 'Old Dale', 34.122501373291, 0.595549997980215, -115.794441223145, -2.02099425485092, 218, 6, 'PPL', 'P'),
(23627, 'Old Damascus', 31.3072204589844, 0.546414076657008, -84.7372207641602, -1.4789435013239, 218, 13, 'PPL', 'P'),
(23628, 'Old Davis Mill Estates', 33.8438911437988, 0.590687332145839, -84.8202819824219, -1.48039319306328, 218, 13, 'PPL', 'P'),
(4752, 'Old Davisville', 33.648609161377, 0.587279018582756, -85.6558303833008, -1.4949762637184, 218, 2, 'PPL', 'P'),
(96733, 'Old Davy', 29.0833301544189, 0.507599868639162, -97.6269378662109, -1.70391150440531, 218, 51, 'PPL', 'P'),
(10941, 'Old De Roche', 34.271671295166, 0.598153504261876, -93.1263885498047, -1.62536210068564, 218, 4, 'PPL', 'P'),
(175673, 'Old Deerfield', 43.0830612182617, 0.751941270096946, -89.0755615234375, -1.55466183164676, 218, 57, 'PPL', 'P'),
(23629, 'Old Dellwood', 32.6683311462402, 0.570169939633705, -82.3658294677734, -1.43755491534882, 218, 13, 'PPL', 'P'),
(96734, 'Old Diana', 32.7405586242676, 0.571430546935694, -94.7430572509766, -1.65357829243503, 218, 51, 'PPL', 'P'),
(96735, 'Old Dime Box', 30.3769397735596, 0.530177615728635, -96.8627777099609, -1.69057439366619, 218, 51, 'PPL', 'P'),
(50060, 'Old Dixie Manor', 39.5747184753418, 0.690709137944545, -76.3638916015625, -1.33280133808331, 218, 25, 'PPL', 'P'),
(67446, 'Old Dock', 34.167781829834, 0.596340291033696, -78.5975036621094, -1.37178522275211, 218, 33, 'PPL', 'P'),
(61162, 'Old Dominion', 33.3944396972656, 0.582842924575984, -90.3863906860352, -1.57754011646525, 218, 30, 'PPL', 'P'),
(104904, 'Old Dominion', 37.8274993896484, 0.660214412145511, -78.666389465332, -1.37298750682623, 218, 53, 'PPL', 'P'),
(104905, 'Old Dominion Court', 37.3497200012207, 0.651875588719282, -79.9505615234375, -1.39540053740228, 218, 53, 'PPL', 'P'),
(104906, 'Old Dominion Gardens', 38.9438896179199, 0.679699097365939, -77.1916732788086, -1.34724885383894, 218, 53, 'PPL', 'P'),
(28117, 'Old Du Quoin', 37.9749984741211, 0.662788756813236, -89.1830596923828, -1.55653802863472, 218, 18, 'PPL', 'P'),
(17403, 'Old Duette', 27.5366706848145, 0.480605568487414, -82.0994415283203, -1.43290556871775, 218, 12, 'PPL', 'P'),
(89644, 'Old Dunbar (historical)', 35.4655609130859, 0.618990808999956, -88.1672210693359, -1.53880829999363, 218, 50, 'PPL', 'P'),
(4753, 'Old Eastaboga', 33.5863914489746, 0.586193114648276, -86.0216674804688, -1.50136132558991, 218, 2, 'PPL', 'P'),
(191970, 'Old Edith Lochausen Place', 30.1149997711182, 0.525605900243351, -103.088890075684, -1.79924055404719, 218, 51, 'PPL', 'P'),
(96736, 'Old Elwood', 31.0716705322266, 0.542302954882252, -95.8027801513672, -1.67207394620563, 218, 51, 'PPL', 'P'),
(89645, 'Old Englewood', 35.4086112976074, 0.617996850702111, -84.4866714477539, -1.47457059081399, 218, 50, 'PPL', 'P'),
(76812, 'Old Eucha', 36.3447189331055, 0.634335011094611, -94.9449996948242, -1.65710285297969, 218, 42, 'PPL', 'P'),
(10942, 'Old Euclid (historical)', 34.1555595397949, 0.596126971830381, -94.045280456543, -1.64139978992815, 218, 4, 'PPL', 'P'),
(4754, 'Old Fabius', 34.8288917541504, 0.607878835930628, -85.7772216796875, -1.49709494152361, 218, 2, 'PPL', 'P'),
(50061, 'Old Farm', 39.0502815246582, 0.681555986435997, -77.1447219848633, -1.34642939917152, 218, 25, 'PPL', 'P'),
(67448, 'Old Farm', 35.8005599975586, 0.624837646015171, -80.8405609130859, -1.41093395709238, 218, 33, 'PPL', 'P'),
(89646, 'Old Farm', 35.0597190856934, 0.611907532869645, -85.3491668701172, -1.48962397571761, 218, 50, 'PPL', 'P'),
(67453, 'Old Farm Acres', 35.5377807617188, 0.620251283143891, -78.3580627441406, -1.36760619036956, 218, 33, 'PPL', 'P'),
(191971, 'Old Farm Crossing', 35.5213890075684, 0.619965193063789, -102.59944152832, -1.79069806537659, 218, 51, 'PPL', 'P'),
(205218, 'Old Farm Estates', 40.9033317565918, 0.713897814188083, -111.896942138672, -1.95297006323341, 218, 52, 'PPL', 'P'),
(76813, 'Old Farris', 34.2438888549805, 0.5976686092064, -95.875, -1.67333442034956, 218, 42, 'PPL', 'P'),
(17404, 'Old Fernandina', 30.6894397735596, 0.535631769641117, -81.4524993896484, -1.42161429832804, 218, 12, 'PPL', 'P'),
(165498, 'Old Ferry', 40.5277786254883, 0.707343175534152, -77.1377792358398, -1.34630822534192, 218, 45, 'PPL', 'P'),
(151371, 'Old Field', 40.9597206115723, 0.714881985368921, -73.129997253418, -1.27635923404655, 218, 40, 'PPL', 'P'),
(104908, 'Old Field Estates', 38.8566703796387, 0.67817683448685, -77.581672668457, -1.35405562726907, 218, 53, 'PPL', 'P'),
(50064, 'Old Field Point', 39.5180587768555, 0.689720239652771, -75.9013900756836, -1.32472916366123, 218, 25, 'PPL', 'P'),
(50065, 'Old Fields', 39.5497207641602, 0.690272845578963, -76.3555603027344, -1.33265592948779, 218, 25, 'PPL', 'P'),
(110754, 'Old Fields', 39.1347198486328, 0.683029713204219, -78.9499969482422, -1.3779373911863, 218, 58, 'PPL', 'P'),
(89647, 'Old Fields Place', 36.0902786254883, 0.629894189976904, -87.8369369506836, -1.5330437546561, 218, 50, 'PPL', 'P'),
(104909, 'Old Fitzhugh', 36.6861114501953, 0.6402934345595, -77.7533264160156, -1.35705155033736, 218, 53, 'PPL', 'P'),
(37507, 'Old Flat Lick', 36.8383293151855, 0.642950137483936, -83.771110534668, -1.46208169688206, 218, 21, 'PPL', 'P'),
(96737, 'Old Flatonia', 29.6627807617188, 0.517713189589224, -97.0905609130859, -1.69454996054146, 218, 51, 'PPL', 'P'),
(183813, 'Old Forbestown', 39.5280609130859, 0.689894809862226, -121.279716491699, -2.11673036866542, 218, 6, 'PPL', 'P'),
(67455, 'Old Ford', 35.6341705322266, 0.621933602004494, -77.0641708374023, -1.34502351643207, 218, 33, 'PPL', 'P'),
(23630, 'Old Ford Acres', 33.5299987792969, 0.58520887688841, -84.4733276367188, -1.47433769737666, 218, 13, 'PPL', 'P'),
(50066, 'Old Ford Hills', 38.7416687011719, 0.676169676552284, -76.9661102294922, -1.34331203595753, 218, 25, 'PPL', 'P'),
(197179, 'Old Ford Place', 45.9038887023926, 0.801173997325778, -107.456672668457, -1.87547274130238, 218, 31, 'PPL', 'P'),
(151372, 'Old Forge', 43.7099990844727, 0.762883400067755, -74.9747161865234, -1.30855565320312, 218, 40, 'PPL', 'P'),
(165499, 'Old Forge', 41.3711090087891, 0.722062067404857, -75.7352828979492, -1.32183004649857, 218, 45, 'PPL', 'P'),
(67456, 'Old Fort', 35.6288909912109, 0.621841456630777, -82.1808319091797, -1.4343260988432, 218, 33, 'PPL', 'P'),
(156924, 'Old Fort', 41.2400016784668, 0.719773812817234, -83.1500015258789, -1.4512412996649, 218, 41, 'PPL', 'P'),
(165501, 'Old Fort', 40.8352813720703, 0.712710110920935, -77.6719436645508, -1.35563115336996, 218, 45, 'PPL', 'P'),
(175674, 'Old Fort', 46.7547187805176, 0.81602378356406, -90.7822189331055, -1.58444862264902, 218, 57, 'PPL', 'P'),
(209864, 'Old Fort', 44.8116683959961, 0.782111156822018, -116.156669616699, -2.02731633296266, 218, 17, 'PPL', 'P'),
(50067, 'Old Fort Acres', 38.7324981689453, 0.676009620570771, -76.9730606079102, -1.34343334294518, 218, 25, 'PPL', 'P'),
(187131, 'Old Fort Bent (historical)', 38.0405616760254, 0.663933050554615, -103.428886413574, -1.8051746095881, 218, 7, 'PPL', 'P'),
(23631, 'Old Fort Estates', 34.9527816772461, 0.61004112299869, -85.2388916015625, -1.48769930919781, 218, 13, 'PPL', 'P'),
(82756, 'Old Fort Estates', 32.9575004577637, 0.575216896215514, -80.1302795410156, -1.39853720853417, 218, 48, 'PPL', 'P'),
(183814, 'Old Fort Jim', 38.7105598449707, 0.675626724585044, -120.717781066895, -2.10692274531898, 218, 6, 'PPL', 'P'),
(187132, 'Old Fort Lyons', 38.0958290100098, 0.664897647501442, -102.772216796875, -1.79371356267889, 218, 7, 'PPL', 'P'),
(4755, 'Old Fort Stoddard Mount Vernon Landing', 31.0891704559326, 0.542608386169771, -87.9786071777344, -1.53551636657018, 218, 2, 'PPL', 'P'),
(183815, 'Old Fort Tejon', 34.8736114501953, 0.608659341867103, -118.893333435059, -2.07508012711323, 218, 6, 'PPL', 'P'),
(194352, 'Old Fort Vasquez (historical)', 40.1944389343262, 0.701525300395793, -104.820556640625, -1.82946383715211, 218, 7, 'PPL', 'P'),
(89648, 'Old Fosterville (historical)', 35.6713905334473, 0.622583213573391, -86.4194412231445, -1.50830378707759, 218, 50, 'PPL', 'P'),
(78880, 'Old Frame', 39.8074989318848, 0.694771923345515, -79.8625030517578, -1.39386362713719, 218, 45, 'PPL', 'P'),
(191972, 'Old Freitag Place', 31.4558296203613, 0.549007795821663, -101.094436645508, -1.76443077491292, 218, 51, 'PPL', 'P'),
(89649, 'Old Fremont', 36.4361114501953, 0.635930111429514, -89.1727828979492, -1.5563586647353, 218, 50, 'PPL', 'P'),
(137268, 'Old Frontenac', 44.5261116027832, 0.777127250579016, -92.3319396972656, -1.61149635247014, 218, 28, 'PPL', 'P'),
(14351, 'Old Furnace', 38.6666717529297, 0.67486073287651, -75.5166702270508, -1.31801453560481, 218, 10, 'PPL', 'P'),
(165503, 'Old Furnace', 41.0738906860352, 0.716874629075546, -76.9352798461914, -1.34277394425928, 218, 45, 'PPL', 'P'),
(104910, 'Old Furnace (historical)', 38.4633293151855, 0.671311737828844, -78.7680587768555, -1.37476197106055, 218, 53, 'PPL', 'P'),
(183816, 'Old Garlock', 35.3758316040039, 0.617424737120935, -117.824172973633, -2.05641975682921, 218, 6, 'PPL', 'P'),
(110756, 'Old Gauley', 38.1561088562012, 0.665949729290078, -81.1919403076172, -1.41706668445062, 218, 58, 'PPL', 'P'),
(61163, 'Old Georgetown (historical)', 31.8708305358887, 0.556250928196406, -90.1430587768555, -1.5732931734749, 218, 30, 'PPL', 'P'),
(50068, 'Old Georgetown Estates', 39.0472183227539, 0.681502523477114, -77.1333312988281, -1.34623059419615, 218, 25, 'PPL', 'P'),
(50069, 'Old Germantown', 39.1619415283203, 0.68350482114269, -77.2816696166992, -1.34881958624987, 218, 25, 'PPL', 'P'),
(120884, 'Old Gilchrist', 41.2311096191406, 0.719618617104709, -90.625, -1.58170463461986, 218, 18, 'PPL', 'P'),
(67458, 'Old Gilreath', 36.0741691589355, 0.629613026744819, -81.1175003051758, -1.41576746131282, 218, 33, 'PPL', 'P'),
(183817, 'Old Gilroy', 36.9997215270996, 0.645766962968913, -121.525283813477, -2.12101632696574, 218, 6, 'PPL', 'P'),
(104911, 'Old Glade Spring', 36.7691688537598, 0.641743059719857, -81.7808303833008, -1.42734475520361, 218, 53, 'PPL', 'P'),
(89650, 'Old Glory', 35.7763900756836, 0.624415801298502, -84.0255584716797, -1.46652265115783, 218, 50, 'PPL', 'P'),
(178745, 'Old Glory', 31.4341697692871, 0.548629760104926, -111.253059387207, -1.94173218922355, 218, 5, 'PPL', 'P'),
(191973, 'Old Glory', 33.1297187805176, 0.578222672979832, -100.055557250977, -1.74629890894723, 218, 51, 'PPL', 'P'),
(50070, 'Old Glory Beach', 39.1519393920898, 0.683330250933235, -76.5477828979492, -1.33601084667102, 218, 25, 'PPL', 'P'),
(195406, 'Old Golden', 45.7891693115234, 0.799171766239229, -115.652778625488, -2.01852177609489, 218, 17, 'PPL', 'P'),
(73779, 'Old Gore', 39.5774993896484, 0.690757674055411, -82.3050003051758, -1.43649324618026, 218, 41, 'PPL', 'P'),
(4756, 'Old Goshen Center (historical)', 33.9583282470703, 0.592684636384371, -85.5722198486328, -1.49351698459909, 218, 2, 'PPL', 'P'),
(10945, 'Old Grand Glaise', 35.4897193908691, 0.619412453979543, -91.3752822875977, -1.59479953085784, 218, 4, 'PPL', 'P'),
(56663, 'Old Greenville (historical)', 37.100830078125, 0.647531640086226, -90.454719543457, -1.57873268000139, 218, 29, 'PPL', 'P'),
(113863, 'Old Greenwich', 41.0227813720703, 0.715982603268424, -73.5652770996094, -1.28395630053017, 218, 8, 'PPL', 'P'),
(17405, 'Old Grove', 25.958610534668, 0.453063223072842, -81.60888671875, -1.42434377212926, 218, 12, 'PPL', 'P'),
(165504, 'Old Gum Tree', 40.6747207641602, 0.709907799663899, -79.5244369506836, -1.38796326058407, 218, 45, 'PPL', 'P'),
(104912, 'Old Gun', 37.5344390869141, 0.655099544955905, -77.5924987792969, -1.35424457854841, 218, 53, 'PPL', 'P'),
(189156, 'Old Hachita', 31.913890838623, 0.557002472256027, -108.432220458984, -1.89249926225763, 218, 38, 'PPL', 'P'),
(123356, 'Old Halfway', 40.4905586242676, 0.706693563965255, -87.0658264160156, -1.51958533692933, 218, 19, 'PPL', 'P'),
(89651, 'Old Hall', 36.146110534668, 0.630868640619764, -88.7911071777344, -1.54969716674263, 218, 50, 'PPL', 'P'),
(125728, 'Old Harbor', 41.5999984741211, 0.72605694219803, -69.9833297729492, -1.22143952604694, 218, 23, 'PPL', 'P'),
(212066, 'Old Harbor', 57.2027816772461, 0.998376881567429, -153.303894042969, -2.67565770717833, 218, 1, 'PPL', 'P'),
(169531, 'Old Harbor Landing', 41.1661109924316, 0.718484177059363, -71.5491714477539, -1.24876861883722, 218, 47, 'PPL', 'P'),
(4757, 'Old Harmony', 33.9386100769043, 0.592340489392506, -86.0619430541992, -1.50206426695964, 218, 2, 'PPL', 'P'),
(209643, 'Old Haymaker Place', 41.5322189331055, 0.724873966041817, -106.883056640625, -1.8654612529745, 218, 59, 'PPL', 'P'),
(197180, 'Old Hellgate Village Trailer Park', 46.8841705322266, 0.818283142853856, -114.080558776855, -1.99108136317104, 218, 31, 'PPL', 'P'),
(17406, 'Old Henley Place', 28.3977794647217, 0.495634751914626, -82.142219543457, -1.43365218592936, 218, 12, 'PPL', 'P'),
(23632, 'Old Heritage Farm', 33.8624992370605, 0.591012104640774, -83.3119430541992, -1.4540677125298, 218, 13, 'PPL', 'P'),
(10943, 'Old Hickory', 35.3266716003418, 0.616566733196739, -92.8027801513672, -1.6197140686458, 218, 4, 'PPL', 'P'),
(50071, 'Old Hickory', 38.3516693115234, 0.669362903122151, -76.4361114501953, -1.33406181222725, 218, 25, 'PPL', 'P'),
(89652, 'Old Hickory', 36.2597198486328, 0.632851497209383, -86.6477813720703, -1.51228907449084, 218, 50, 'PPL', 'P'),
(30726, 'Old Hill', 39.3019409179688, 0.685948271442837, -87.2074966430664, -1.52205794884341, 218, 19, 'PPL', 'P'),
(125730, 'Old Hill', 42.1041717529297, 0.734856425913816, -72.5680618286133, -1.26655161070012, 218, 23, 'PPL', 'P'),
(183818, 'Old Hilltown', 36.6313896179199, 0.63933835841357, -121.668327331543, -2.12351290732963, 218, 6, 'PPL', 'P'),
(67459, 'Old Hollow Estates', 36.1775016784668, 0.631416519435021, -80.1986083984375, -1.39972977207031, 218, 33, 'PPL', 'P'),
(50072, 'Old Home Estates', 39.4269409179688, 0.68812993300783, -76.9444427490234, -1.34293386708274, 218, 25, 'PPL', 'P'),
(194353, 'Old Homestead', 40.4402809143066, 0.705816052386074, -106.143058776855, -1.85254585379399, 218, 7, 'PPL', 'P'),
(183819, 'Old Hopland', 38.975830078125, 0.68025656356112, -123.099166870117, -2.14848576834547, 218, 6, 'PPL', 'P'),
(189157, 'Old Horner Place', 32.7988891601563, 0.572448606841404, -104.506942749023, -1.82399024216367, 218, 38, 'PPL', 'P'),
(189158, 'Old Horse Springs', 33.9244384765625, 0.592093148306265, -108.22721862793, -1.88892130533311, 218, 38, 'PPL', 'P'),
(61164, 'Old Houlka', 34.0380592346191, 0.594076204632965, -88.9941711425781, -1.55324130152131, 218, 30, 'PPL', 'P'),
(82757, 'Old House', 32.4594383239746, 0.566524072101387, -80.8966674804688, -1.41191320142521, 218, 48, 'PPL', 'P'),
(50073, 'Old House Cove Estates', 38.3438911437988, 0.669227148485584, -76.4372177124023, -1.33408112014515, 218, 25, 'PPL', 'P'),
(191981, 'Old House Place', 31.2194404602051, 0.544882026660912, -103.976936340332, -1.81473988527534, 218, 51, 'PPL', 'P'),
(96738, 'Old Houston Highway Colonia', 28.4190006256104, 0.496005131043229, -97.7239990234375, -1.70560554117471, 218, 51, 'PPL', 'P'),
(191975, 'Old Houston Place', 32.021110534668, 0.558873808974998, -101.702781677246, -1.77504839870491, 218, 51, 'PPL', 'P'),
(193830, 'Old Hulbert Place', 41.4383316040039, 0.723235323023091, -121.051666259766, -2.11275014125824, 218, 6, 'PPL', 'P'),
(67460, 'Old Hundred', 34.8291702270508, 0.607883696199617, -79.5905609130859, -1.38911734144245, 218, 33, 'PPL', 'P'),
(96739, 'Old Ingleside Colonia', 27.8400001525879, 0.485899666418382, -97.2200012207031, -1.69680912009418, 218, 51, 'PPL', 'P'),
(192732, 'Old Irontown', 37.5999984741211, 0.656243772118257, -113.449440002441, -1.98006626258637, 218, 52, 'PPL', 'P'),
(189159, 'Old Isaacs Place', 31.6947193145752, 0.553177207534778, -108.897216796875, -1.90061497936354, 218, 38, 'PPL', 'P'),
(4758, 'Old Island Landing', 31.1172199249268, 0.543097941757155, -87.8608322143555, -1.5334608056828, 218, 2, 'PPL', 'P'),
(42422, 'Old Jefferson', 30.3824996948242, 0.530274654660855, -91.0169372558594, -1.58854523019584, 218, 22, 'PPL', 'P'),
(10946, 'Old Jenny Lind', 35.2400016784668, 0.615054057697574, -94.3266677856445, -1.64631092529437, 218, 4, 'PPL', 'P'),
(10947, 'Old Joe', 36.1744384765625, 0.631363056476137, -92.2313919067383, -1.60974146246983, 218, 4, 'PPL', 'P'),
(82758, 'Old Joe', 33.0555610656738, 0.576928376690054, -79.8080596923828, -1.39291341126025, 218, 48, 'PPL', 'P'),
(4759, 'Old Jonesboro', 33.3930587768555, 0.582818822968118, -86.9844436645508, -1.51816493996193, 218, 2, 'PPL', 'P'),
(28118, 'Old Kane', 39.1888885498047, 0.683975135391198, -90.3724975585938, -1.577297635648, 218, 18, 'PPL', 'P'),
(28119, 'Old Kaskaskia', 37.9488906860352, 0.662333089950723, -89.9219436645508, -1.56943398673927, 218, 18, 'PPL', 'P'),
(4760, 'Old Kingston', 32.5736083984375, 0.568516715808011, -86.600830078125, -1.51146961982342, 218, 2, 'PPL', 'P'),
(192733, 'Old La Sal', 38.3313903808594, 0.669008969013279, -109.148612976074, -1.9050026704175, 218, 52, 'PPL', 'P'),
(14348, 'Old Landing', 38.686939239502, 0.6752144672483, -75.1283264160156, -1.3112366574725, 218, 10, 'PPL', 'P'),
(37508, 'Old Landing', 37.6363906860352, 0.656878936038241, -83.8069381713867, -1.46270700710601, 218, 21, 'PPL', 'P'),
(14349, 'Old Landing Woods', 38.7013893127441, 0.675466668603531, -75.1341705322266, -1.31133865654225, 218, 10, 'PPL', 'P'),
(10948, 'Old Lapile', 33.0686111450195, 0.577156143542283, -92.2472229003906, -1.61001776543293, 218, 4, 'PPL', 'P'),
(89653, 'Old Lawton', 35.2127799987793, 0.614578949759104, -88.4694366455078, -1.54408295684864, 218, 50, 'PPL', 'P'),
(175675, 'Old Lebanon', 43.2261085510254, 0.754437917039868, -88.6302795410156, -1.54689019495369, 218, 57, 'PPL', 'P'),
(178746, 'Old Leupp', 35.2838897705078, 0.615820049406108, -110.96443939209, -1.93669482002166, 218, 5, 'PPL', 'P'),
(10949, 'Old Lexington', 35.7197189331055, 0.623426703269647, -92.4108276367188, -1.61287320675371, 218, 4, 'PPL', 'P'),
(104913, 'Old Liberty', 36.6549987792969, 0.639750416013233, -79.8238906860352, -1.39318971422335, 218, 53, 'PPL', 'P'),
(10950, 'Old Liberty (historical)', 35.4713897705078, 0.619092541753597, -92.6777801513672, -1.61753240708081, 218, 4, 'PPL', 'P'),
(205219, 'Old Limber Pine', 41.9199981689453, 0.73164199047809, -111.473609924316, -1.94558152226315, 218, 52, 'PPL', 'P'),
(10951, 'Old Linder (historical)', 35.160831451416, 0.613672276565986, -92.3986129760742, -1.61266002070845, 218, 4, 'PPL', 'P'),
(50074, 'Old Line Village of Fair Hill', 39.7205581665039, 0.693254520735415, -75.8936080932617, -1.32459334244563, 218, 25, 'PPL', 'P'),
(56664, 'Old Linn Creek', 38.0724983215332, 0.664490450170769, -92.7363891601563, -1.61855532725551, 218, 29, 'PPL', 'P'),
(96740, 'Old London', 32.2266693115234, 0.562461486437498, -94.9444427490234, -1.65709313244172, 218, 51, 'PPL', 'P'),
(189160, 'Old Longbotbam Place', 32.9333305358887, 0.574795051498846, -105.171112060547, -1.83558218344046, 218, 38, 'PPL', 'P'),
(113864, 'Old Lyme', 41.3158302307129, 0.721097270720948, -72.3294372558594, -1.2623868262294, 218, 8, 'PPL', 'P'),
(113865, 'Old Lyme Shores', 41.2902793884277, 0.720651324396415, -72.2752838134766, -1.26144167035853, 218, 8, 'PPL', 'P'),
(82759, 'Old Madison', 34.6124992370605, 0.604102074030732, -83.1963882446289, -1.45205090063628, 218, 48, 'PPL', 'P'),
(183820, 'Old Mammoth', 37.6261100769043, 0.656699505559797, -118.982223510742, -2.07663155160626, 218, 6, 'PPL', 'P'),
(104914, 'Old Manor', 37.3327789306641, 0.651579911259256, -79.9369430541992, -1.39516285027499, 218, 53, 'PPL', 'P'),
(17407, 'Old Marco Junction', 26.0224990844727, 0.454178288621258, -81.7008285522461, -1.42594845984409, 218, 12, 'PPL', 'P'),
(28120, 'Old Marissa', 38.2583312988281, 0.667733847483349, -89.7541732788086, -1.56650584112072, 218, 18, 'PPL', 'P'),
(10952, 'Old Martin Mill Place', 35.939998626709, 0.627271309198312, -91.1980590820313, -1.59170640240976, 218, 4, 'PPL', 'P'),
(151373, 'Old Mastic', 40.7805595397949, 0.711755034775005, -72.8249969482422, -1.27103597450165, 218, 40, 'PPL', 'P'),
(4762, 'Old Maylene', 33.1941719055176, 0.579347592224282, -86.8613891601563, -1.51601723370084, 218, 2, 'PPL', 'P'),
(209644, 'Old McKeal Place', 41.5886116027832, 0.725858203801683, -106.958892822266, -1.86678484403627, 218, 59, 'PPL', 'P'),
(56665, 'Old Merritt', 36.8997192382813, 0.644021593769502, -92.8872222900391, -1.62118786199305, 218, 29, 'PPL', 'P'),
(137269, 'Old Mesaba', 47.582218170166, 0.830466372471668, -92.1322174072266, -1.60801054091934, 218, 28, 'PPL', 'P'),
(89654, 'Old Middleton', 36.1761093139648, 0.631392218090074, -85.9936065673828, -1.50087157026545, 218, 50, 'PPL', 'P'),
(30727, 'Old Milan', 39.1463890075684, 0.683233378448583, -85.1324996948242, -1.48584242012775, 218, 19, 'PPL', 'P'),
(50076, 'Old Mill', 39.1208305358887, 0.682787298965995, -76.6166687011719, -1.33721313074514, 218, 25, 'PPL', 'P'),
(67461, 'Old Mill', 35.9124984741211, 0.626791340990853, -80.3438873291016, -1.40226536774418, 218, 33, 'PPL', 'P'),
(104915, 'Old Mill', 37.3908309936523, 0.652593110895976, -79.5041732788086, -1.38760959279131, 218, 53, 'PPL', 'P'),
(14350, 'Old Mill Acres', 38.6047210693359, 0.673779489473938, -75.6430587768555, -1.32022043193572, 218, 10, 'PPL', 'P'),
(50075, 'Old Mill Bottom Estates', 39.0233306884766, 0.681085605608462, -76.4638900756836, -1.33454664070369, 218, 25, 'PPL', 'P'),
(23633, 'Old Mill Chase', 33.8494415283203, 0.590784204630491, -83.3313903808594, -1.45440713241073, 218, 13, 'PPL', 'P'),
(120885, 'Old Mill Creek', 42.4219398498535, 0.740402525462933, -87.9725036621094, -1.53540984012658, 218, 18, 'PPL', 'P'),
(82766, 'Old Mill Estates', 34.9294395446777, 0.609633725930935, -82.309440612793, -1.43657074416798, 218, 48, 'PPL', 'P'),
(104916, 'Old Mill Estates', 38.9816703796387, 0.680358496051843, -77.2997207641602, -1.34913463820682, 218, 53, 'PPL', 'P'),
(145962, 'Old Mill Farms', 40.314998626709, 0.703629463973064, -74.6041717529297, -1.30208843281197, 218, 37, 'PPL', 'P'),
(104917, 'Old Mill Forest', 37.204719543457, 0.649344853314407, -80.0227813720703, -1.39666101154621, 218, 53, 'PPL', 'P'),
(132409, 'Old Mill Gardens', 42.2680587768555, 0.737716794082615, -85.1988906860352, -1.48700116151804, 218, 27, 'PPL', 'P'),
(14352, 'Old Mill Manor', 39.6916694641113, 0.692750317762036, -75.7041702270508, -1.3212870279523, 218, 10, 'PPL', 'P'),
(183821, 'Old Mill Park Mobile Home Park', 36.9886093139648, 0.645573018262528, -121.955833435059, -2.12853083545556, 218, 6, 'PPL', 'P'),
(205220, 'Old Mill Subdivision Phase 1-3', 41.2394409179688, 0.719764025700227, -111.947776794434, -1.95385729535057, 218, 52, 'PPL', 'P'),
(110757, 'Old Mill Village', 37.7727813720703, 0.659259402578608, -81.2180633544922, -1.41752261762924, 218, 58, 'PPL', 'P'),
(89656, 'Old Millersburg (historical)', 35.6991691589355, 0.62306804204984, -86.3550033569336, -1.50717913414925, 218, 50, 'PPL', 'P'),
(10953, 'Old Milo', 33.2947196960449, 0.58110248222459, -91.8899993896484, -1.60378303900495, 218, 4, 'PPL', 'P'),
(96741, 'Old Milwaukee East Colonia', 27.488000869751, 0.47975611996822, -99.4219970703125, -1.73524119778511, 218, 51, 'PPL', 'P'),
(96742, 'Old Milwaukee West Colonia', 27.488000869751, 0.47975611996822, -99.4250030517578, -1.73529366205858, 218, 51, 'PPL', 'P'),
(56666, 'Old Mines', 38.0152816772461, 0.663491831341017, -90.7558288574219, -1.5839880289385, 218, 29, 'PPL', 'P'),
(212067, 'Old Minto', 64.8872222900391, 1.13249567143464, -149.174713134766, -2.60358990491969, 218, 1, 'PPL', 'P'),
(132410, 'Old Mission', 44.9622192382813, 0.784738764711545, -85.4852828979492, -1.49199964856801, 218, 27, 'PPL', 'P'),
(56668, 'Old Monroe', 38.9316711425781, 0.679485844741651, -90.7466735839844, -1.58382823927309, 218, 29, 'PPL', 'P'),
(4764, 'Old Monrovia', 34.769718170166, 0.606846062059895, -86.7063903808594, -1.51331199466554, 218, 2, 'PPL', 'P'),
(42423, 'Old Montgomery (historical)', 31.6588897705078, 0.552551864021313, -92.9000015258789, -1.62141090173434, 218, 22, 'PPL', 'P'),
(82760, 'Old Morrisville', 33.598331451416, 0.586401507003575, -79.5074996948242, -1.38766764970307, 218, 48, 'PPL', 'P'),
(189161, 'Old Moses', 36.6838912963867, 0.640254685565639, -103.077217102051, -1.79903682222379, 218, 38, 'PPL', 'P'),
(96743, 'Old Moulton', 29.5877799987793, 0.516404179334423, -97.1763916015625, -1.69604798865463, 218, 51, 'PPL', 'P'),
(42424, 'Old Mount Pleasant (historical)', 32.1500015258789, 0.561123381147788, -92.1897201538086, -1.60901415317613, 218, 22, 'PPL', 'P'),
(104918, 'Old Mount Vinco', 37.6094398498535, 0.656408555210706, -78.5969390869141, -1.37177536905608, 218, 53, 'PPL', 'P'),
(165514, 'Old Mountain House', 40.0188903808594, 0.698461400140684, -78.1891708374023, -1.364658470517, 218, 45, 'PPL', 'P'),
(187133, 'Old Mountain View (historical)', 38.8338890075684, 0.677779224536101, -104.990829467773, -1.83243565861253, 218, 7, 'PPL', 'P'),
(125731, 'Old Mouth North River', 42.1258316040039, 0.735234461630552, -70.6797180175781, -1.2335937937879, 218, 23, 'PPL', 'P'),
(17408, 'Old Myakka', 27.312780380249, 0.476697945509454, -82.2669372558594, -1.43582892064633, 218, 12, 'PPL', 'P'),
(104919, 'Old Myndus', 37.8213882446289, 0.660107752543853, -78.8550033569336, -1.37627944024967, 218, 53, 'PPL', 'P'),
(61165, 'Old Myrtle', 34.5275001525879, 0.602618560145503, -89.1224975585938, -1.55548101999807, 218, 30, 'PPL', 'P'),
(113867, 'Old Mystic', 41.3913917541504, 0.722416068092756, -71.9622192382813, -1.25597766275001, 218, 8, 'PPL', 'P'),
(61166, 'Old Narkeetah (historical)', 32.6930618286133, 0.57060157146738, -88.4847183227539, -1.54434967243181, 218, 30, 'PPL', 'P'),
(23634, 'Old National East', 33.6044387817383, 0.586508100026205, -84.4627838134766, -1.47415367294534, 218, 13, 'PPL', 'P'),
(4765, 'Old Nauvoo', 34.4500007629395, 0.601265940627852, -87.9272232055664, -1.5346195470731, 218, 2, 'PPL', 'P'),
(104920, 'Old Neck Landing', 37.5422210693359, 0.655235366171498, -75.9250030517578, -1.32514128783992, 218, 53, 'PPL', 'P'),
(10954, 'Old Neely', 35.1505584716797, 0.613492979245597, -93.0941696166992, -1.62479977422147, 218, 4, 'PPL', 'P'),
(23635, 'Old Newman (historical)', 33.0486106872559, 0.576807069702401, -84.3236083984375, -1.47172460371508, 218, 13, 'PPL', 'P'),
(42425, 'Old Newport (historical)', 32.1049995422363, 0.560337948363296, -92.3402786254883, -1.61164189422371, 218, 22, 'PPL', 'P'),
(120887, 'Old Niota', 40.6133308410645, 0.708836343378333, -91.3019409179688, -1.59351948247989, 218, 18, 'PPL', 'P'),
(125732, 'Old North Ashburnham Station', 42.6555595397949, 0.744479958249899, -71.9833297729492, -1.25634611108683, 218, 23, 'PPL', 'P'),
(125733, 'Old Oaken Bucket Homestead', 42.1777801513672, 0.73614113482367, -70.7563934326172, -1.23493203223566, 218, 23, 'PPL', 'P'),
(104921, 'Old Oaks', 37.6341705322266, 0.65684018704438, -77.7891693115234, -1.35767712687741, 218, 53, 'PPL', 'P'),
(96747, 'Old Ocean', 29.079719543457, 0.507536851589868, -95.7494430541992, -1.67114303824659, 218, 51, 'PPL', 'P'),
(37509, 'Old Olga', 36.9255599975586, 0.644472600100107, -85.1686096191406, -1.48647265719972, 218, 21, 'PPL', 'P'),
(82761, 'Old Orchard', 32.7211112976074, 0.571091127054764, -79.9430618286133, -1.3952696430347, 218, 48, 'PPL', 'P'),
(104922, 'Old Orchard', 37.1072196960449, 0.647643159956873, -76.545280456543, -1.33596717082914, 218, 53, 'PPL', 'P'),
(165507, 'Old Orchard', 40.6577796936035, 0.709612122203873, -75.2624969482422, -1.31357837501901, 218, 45, 'PPL', 'P'),
(128424, 'Old Orchard Beach', 43.517219543457, 0.759518762346549, -70.378059387207, -1.22832885747087, 218, 26, 'PPL', 'P'),
(151374, 'Old Orchard Cove', 42.8008308410645, 0.747015420765708, -77.7041702270508, -1.35619361299219, 218, 40, 'PPL', 'P'),
(50077, 'Old Orchard Estates', 39.2969398498535, 0.68586098633811, -77.3152770996094, -1.34940614747996, 218, 25, 'PPL', 'P'),
(117114, 'Old Orchard Mobile Home Park', 42.0069389343262, 0.73315939308819, -93.6263885498047, -1.63408874694561, 218, 16, 'PPL', 'P'),
(151375, 'Old Orchard Point', 42.7947196960449, 0.746908761164051, -77.7099990844727, -1.35629534574583, 218, 40, 'PPL', 'P'),
(183822, 'Old Ornbaun Hot Springs', 38.9124984741211, 0.679151218550683, -123.309722900391, -2.15216066433367, 218, 6, 'PPL', 'P'),
(191976, 'Old Oscar Nance Place', 30.4833297729492, 0.532034471509179, -103.191940307617, -1.80103911988937, 218, 51, 'PPL', 'P'),
(190565, 'Old Overton (historical)', 36.5608291625977, 0.63810684614649, -114.440826416016, -1.99736921966277, 218, 39, 'PPL', 'P'),
(191977, 'Old Parker Place', 30.4883308410645, 0.532121756613907, -103.211112976074, -1.80137374608034, 218, 51, 'PPL', 'P'),
(191978, 'Old Patterson Place', 31.038330078125, 0.54172105418407, -105.342216491699, -1.83856851912882, 218, 51, 'PPL', 'P'),
(89655, 'Old Patty', 35.2455596923828, 0.61515106334028, -84.6149978637695, -1.47681030929075, 218, 50, 'PPL', 'P'),
(28121, 'Old Pearl', 39.4416694641113, 0.68838699463205, -90.648063659668, -1.58210717141863, 218, 18, 'PPL', 'P'),
(56667, 'Old Peculiar', 38.7191696166992, 0.675776993449552, -94.4413909912109, -1.64831322295994, 218, 29, 'PPL', 'P'),
(30728, 'Old Pekin', 38.4972190856934, 0.67190322590695, -86.0033264160156, -1.50104121362689, 218, 19, 'PPL', 'P'),
(82763, 'Old Peru', 33.420280456543, 0.583293930906589, -79.9869384765625, -1.39603543500615, 218, 48, 'PPL', 'P'),
(117115, 'Old Peru', 41.2358283996582, 0.71970097536142, -93.9449996948242, -1.63964956045975, 218, 16, 'PPL', 'P'),
(82764, 'Old Pickens', 34.7861099243164, 0.607132152139997, -82.8888931274414, -1.44668409840755, 218, 48, 'PPL', 'P'),
(104923, 'Old Pilot (historical)', 37.3194389343262, 0.651347084400956, -78.9222183227539, -1.37745256270985, 218, 53, 'PPL', 'P'),
(156925, 'Old Pimtown (historical)', 40.2400016784668, 0.70232052029729, -83.7586135864258, -1.46186358398879, 218, 41, 'PPL', 'P'),
(37510, 'Old Pine Grove', 38.0263900756836, 0.663685709468374, -84.2719421386719, -1.47082285736998, 218, 21, 'PPL', 'P'),
(10955, 'Old Piney (historical)', 33.6441688537598, 0.587201520595035, -91.6402816772461, -1.59942464272298, 218, 4, 'PPL', 'P'),
(183823, 'Old Pino', 38.8180618286133, 0.677502988152033, -120.646110534668, -2.10567185855497, 218, 6, 'PPL', 'P'),
(151376, 'Old Place', 40.6302795410156, 0.709132153996413, -74.186393737793, -1.29479683090539, 218, 40, 'PPL', 'P'),
(191979, 'Old Place Windmill', 30.9072208404541, 0.539432766306933, -103.836112976074, -1.8122820539053, 218, 51, 'PPL', 'P'),
(191980, 'Old Place Windmills', 32.1741714477539, 0.561545225864456, -102.533332824707, -1.78954425083432, 218, 51, 'PPL', 'P'),
(42426, 'Old Pleasant Hill', 31.8555603027344, 0.555984412350316, -93.5130615234375, -1.63211081720401, 218, 22, 'PPL', 'P'),
(183824, 'Old Point Comfort', 34.4152793884277, 0.600659938321804, -117.832778930664, -2.05656995911469, 218, 6, 'PPL', 'P'),
(50084, 'Old Point Estates', 38.9397201538086, 0.679626326489153, -76.2855606079102, -1.33143420433772, 218, 25, 'PPL', 'P'),
(82765, 'Old Point Station', 34.9597206115723, 0.610162230249262, -81.0488891601563, -1.41456997092867, 218, 48, 'PPL', 'P'),
(165508, 'Old Port', 40.5250015258789, 0.707294706002313, -77.3916702270508, -1.3507394590797, 218, 45, 'PPL', 'P'),
(28146, 'Old Princeton', 39.878059387207, 0.696003435612595, -90.1638870239258, -1.5736566949637, 218, 18, 'PPL', 'P'),
(4766, 'Old Providence', 33.0963897705078, 0.577640972018732, -85.9222183227539, -1.49962561034946, 218, 2, 'PPL', 'P'),
(125734, 'Old Quaker Meetinghouse', 41.7463912963867, 0.728611978947852, -70.4588928222656, -1.22973966705833, 218, 23, 'PPL', 'P'),
(212068, 'Old Rampart', 67.164436340332, 1.17224055438492, -141.670837402344, -2.47262256672843, 218, 1, 'PPL', 'P'),
(96744, 'Old Rebel Field Colonia', 26.1730003356934, 0.45680503098343, -97.8769989013672, -1.70827589279973, 218, 51, 'PPL', 'P'),
(96745, 'Old Rebel Heights Colonia Number 1', 26.1900005340576, 0.457101740418379, -97.8759994506836, -1.70825844909459, 218, 51, 'PPL', 'P'),
(96746, 'Old Rebel Heights Colonia Number 2', 26.1889991760254, 0.457084263423725, -97.8759994506836, -1.70825844909459, 218, 51, 'PPL', 'P'),
(183825, 'Old Red Rock Place', 38.7930603027344, 0.677066629207423, -123.440826416016, -2.15444885234226, 218, 6, 'PPL', 'P'),
(191982, 'Old Reed Place', 30.0819396972656, 0.525028893103671, -103.126388549805, -1.79989502588507, 218, 51, 'PPL', 'P'),
(76814, 'Old Retrop', 35.1452789306641, 0.61340083387188, -99.3422164916992, -1.73384876400916, 218, 42, 'PPL', 'P'),
(190566, 'Old Reveille (historical)', 38.0349998474121, 0.663835978332882, -116.183059692383, -2.02777692667319, 218, 39, 'PPL', 'P'),
(10956, 'Old Reyno', 36.3319396972656, 0.634111971353317, -90.7597198486328, -1.58405593954629, 218, 4, 'PPL', 'P'),
(28122, 'Old Ripley', 38.896110534668, 0.678865195049608, -89.5699996948242, -1.563291405685, 218, 18, 'PPL', 'P'),
(183826, 'Old River', 35.267219543457, 0.615529099057017, -119.108062744141, -2.07882786055725, 218, 6, 'PPL', 'P'),
(96748, 'Old River Community', 29.8902797698975, 0.521683796326964, -94.8125, -1.65479029704712, 218, 51, 'PPL', 'P'),
(82767, 'Old River Estates', 33.8527793884277, 0.590842461279336, -78.6416702270508, -1.37255607472963, 218, 48, 'PPL', 'P'),
(96749, 'Old River-Winfree', 29.8680591583252, 0.521295973493221, -94.8324966430664, -1.65513930430798, 218, 51, 'PPL', 'P'),
(194354, 'Old Roach', 40.9244384765625, 0.714266195945868, -106.116668701172, -1.85208526008346, 218, 7, 'PPL', 'P'),
(23636, 'Old Rock Hill', 31.0100002288818, 0.541226605038183, -83.5736083984375, -1.45863463432512, 218, 13, 'PPL', 'P'),
(96753, 'Old Round Rock (historical)', 30.514440536499, 0.532577456765933, -97.6813888549805, -1.7048618534403, 218, 51, 'PPL', 'P'),
(208323, 'Old Royal', 48.1794395446777, 0.840889851820184, -124.457221984863, -2.17218830152134, 218, 56, 'PPL', 'P'),
(89657, 'Old Safford (historical)', 35.7430610656738, 0.623834100337402, -88.1927795410156, -1.53925437947622, 218, 50, 'PPL', 'P'),
(82768, 'Old Saint George', 33.1711082458496, 0.578945055425516, -80.6125030517578, -1.40695359652715, 218, 48, 'PPL', 'P'),
(30729, 'Old Saint Louis', 39.3205604553223, 0.686273243674854, -85.7855606079102, -1.49724048327718, 218, 19, 'PPL', 'P'),
(96750, 'Old Saint Marys', 28.1016693115234, 0.490466654792732, -97.208610534668, -1.6966103151188, 218, 51, 'PPL', 'P'),
(4767, 'Old Salem', 31.5394401550293, 0.550467074940972, -87.4061126708984, -1.52552445247631, 218, 2, 'PPL', 'P'),
(89658, 'Old Salem', 35.0838890075684, 0.612329377586314, -86.2505569458008, -1.50535620038309, 218, 50, 'PPL', 'P'),
(96751, 'Old Salem', 33.4513893127441, 0.583836882873828, -94.5269393920898, -1.64980632422509, 218, 51, 'PPL', 'P'),
(28124, 'Old Salem Chautauqua', 39.9922218322754, 0.697995946161165, -89.8352813720703, -1.56792144439816, 218, 18, 'PPL', 'P'),
(50078, 'Old Salem Village', 39.0936088562012, 0.682312191027525, -77.0061111450195, -1.34401018363729, 218, 25, 'PPL', 'P'),
(42427, 'Old Saline', 32.1852798461914, 0.561739103991814, -93.0138931274414, -1.62339868517198, 218, 22, 'PPL', 'P'),
(4768, 'Old Samuel', 31.8722190856934, 0.556275162962326, -88.3061065673828, -1.54123230921782, 218, 2, 'PPL', 'P'),
(96752, 'Old Santa Elena', 26.7222194671631, 0.466390713142521, -98.4761123657227, -1.71873239534576, 218, 51, 'PPL', 'P'),
(23637, 'Old Sardis', 32.9630584716797, 0.575313901858221, -81.7624969482422, -1.42702477639864, 218, 13, 'PPL', 'P'),
(132411, 'Old Saugatuck', 42.666389465332, 0.744668976108267, -86.2127838134766, -1.50469693485524, 218, 27, 'PPL', 'P'),
(113868, 'Old Saybrook', 41.2916717529297, 0.720675625741362, -72.3766708374023, -1.26321120774483, 218, 8, 'PPL', 'P'),
(61167, 'Old Scooba (historical)', 32.8277816772461, 0.572952876393811, -88.4333267211914, -1.54345271977667, 218, 30, 'PPL', 'P'),
(76815, 'Old Scott', 34.3608283996582, 0.59970958928681, -97.4394378662109, -1.70063901205782, 218, 42, 'PPL', 'P'),
(50079, 'Old Severna Park', 39.0702781677246, 0.681904993696852, -76.5527801513672, -1.33609806519672, 218, 25, 'PPL', 'P'),
(165509, 'Old Shade Furnace', 40.151668548584, 0.700778816342243, -78.8274993896484, -1.37579940546319, 218, 45, 'PPL', 'P'),
(28125, 'Old Shawneetown', 37.6969413757324, 0.657935744937812, -88.1366729736328, -1.53827513514339, 218, 18, 'PPL', 'P'),
(165510, 'Old Sheffield', 41.6699981689453, 0.727278667348104, -79.024169921875, -1.37923195379219, 218, 45, 'PPL', 'P'),
(42428, 'Old Shell Beach', 29.8663902282715, 0.521266845168798, -89.6783294677734, -1.5651821169009, 218, 22, 'PPL', 'P'),
(42429, 'Old Shongaloo', 32.9916687011719, 0.57581324456261, -93.3099975585938, -1.62856668242533, 218, 22, 'PPL', 'P'),
(178747, 'Old Shongopavi (historical)', 35.8044395446777, 0.624905356885886, -110.519721984863, -1.92893303702463, 218, 5, 'PPL', 'P'),
(165511, 'Old Side', 41.0613899230957, 0.716656449603241, -77.9408264160156, -1.36032404268484, 218, 45, 'PPL', 'P'),
(10959, 'Old Siloam', 36.4530601501465, 0.636225922047595, -90.9044418334961, -1.58658181468218, 218, 4, 'PPL', 'P'),
(125735, 'Old Silver Beach', 41.6266708374023, 0.726522462756576, -70.6366729736328, -1.23284251604439, 218, 23, 'PPL', 'P'),
(4769, 'Old Snead', 34.1069412231445, 0.595278422128054, -86.3652801513672, -1.50735849804866, 218, 2, 'PPL', 'P'),
(67465, 'Old Sneedsboro', 34.8325004577637, 0.607941819690408, -79.936393737793, -1.39515326289506, 218, 33, 'PPL', 'P'),
(104924, 'Old Somerset', 38.2236099243164, 0.667127845177302, -78.2202835083008, -1.36520148906327, 218, 53, 'PPL', 'P'),
(23638, 'Old South', 33.5472183227539, 0.585509414617425, -84.3000030517578, -1.47131261269444, 218, 13, 'PPL', 'P'),
(89659, 'Old South Estates', 35.8402786254883, 0.625530866846918, -86.4749984741211, -1.50927344403049, 218, 50, 'PPL', 'P'),
(125736, 'Old Spain', 42.2433280944824, 0.73728516224894, -70.9441680908203, -1.23820931827311, 218, 23, 'PPL', 'P'),
(249, 'Old Sparta', 31.3627796173096, 0.547383766899419, -86.9872207641602, -1.51821340949377, 218, 2, 'PPL', 'P'),
(67466, 'Old Sparta', 35.7886085510254, 0.62462905392279, -77.5552825927734, -1.35359503355854, 218, 33, 'PPL', 'P'),
(4770, 'Old Spring Hill', 32.4375, 0.566141176115661, -87.7736129760742, -1.53193854280371, 218, 2, 'PPL', 'P'),
(67467, 'Old Spring Hope', 35.9225006103516, 0.626965911200307, -78.0511093139648, -1.3622488423627, 218, 33, 'PPL', 'P'),
(89660, 'Old Springville', 36.2880592346191, 0.633346112802837, -88.1452789306641, -1.53842533742887, 218, 50, 'PPL', 'P'),
(132412, 'Old Squaw Skin Landing', 42.6413917541504, 0.744232683742685, -86.0691680908203, -1.50219036763726, 218, 27, 'PPL', 'P'),
(104925, 'Old Stage Run', 37.4602813720703, 0.653805248666126, -79.095832824707, -1.38048270739814, 218, 53, 'PPL', 'P'),
(67468, 'Old Stanhope (historical)', 35.8611106872559, 0.625894454914741, -78.1283264160156, -1.36359653503233, 218, 33, 'PPL', 'P'),
(165512, 'Old Stanton', 40.2272186279297, 0.702097413976969, -79.6061096191406, -1.38938871755753, 218, 45, 'PPL', 'P'),
(28126, 'Old State Mobile Home Village', 39.4538917541504, 0.688600313835365, -88.3736114501953, -1.54241049168407, 218, 18, 'PPL', 'P'),
(193831, 'Old Station', 40.6752815246582, 0.709917586780905, -121.429718017578, -2.11934838917502, 218, 6, 'PPL', 'P'),
(37511, 'Old Stephensburg', 37.6144409179688, 0.656495840315433, -86.0202789306641, -1.50133709082399, 218, 21, 'PPL', 'P'),
(28127, 'Old Stonington', 39.6113891601563, 0.691349162133518, -89.1477813720703, -1.5559223057907, 218, 18, 'PPL', 'P'),
(125737, 'Old Sturbridge Village', 42.1069412231445, 0.7349047622876, -72.0991668701172, -1.25836784982836, 218, 23, 'PPL', 'P'),
(56669, 'Old Success', 37.4575004577637, 0.653756712555259, -92.0869369506836, -1.60722024786586, 218, 29, 'PPL', 'P'),
(165513, 'Old Sugar Loaf', 40.9622192382813, 0.714925594631772, -75.9661102294922, -1.32585874343758, 218, 45, 'PPL', 'P'),
(23639, 'Old Suwanee Estates', 34.0855598449707, 0.594905246680307, -84.023063659668, -1.466479108474, 218, 13, 'PPL', 'P'),
(89661, 'Old Sweetwater', 35.6477813720703, 0.622171155973729, -84.4263916015625, -1.47351850902535, 218, 50, 'PPL', 'P'),
(50080, 'Old Sycamore Estates', 38.4491691589355, 0.671064596479684, -76.8688888549805, -1.34161520286898, 218, 25, 'PPL', 'P'),
(208319, 'Old Tacoma', 47.2761116027832, 0.825123805008861, -122.468063354492, -2.1374709340769, 218, 56, 'PPL', 'P'),
(23640, 'Old Tallapoosa', 33.7541694641113, 0.589121393424873, -85.2958297729492, -1.48869306775857, 218, 13, 'PPL', 'P'),
(145963, 'Old Tappan', 41.0105590820313, 0.715769284065109, -73.9916687011719, -1.29139823788029, 218, 37, 'PPL', 'P'),
(104926, 'Old Tavern', 38.8313903808594, 0.677735615273251, -77.8122177124023, -1.35807939736007, 218, 53, 'PPL', 'P'),
(42430, 'Old Ten', 32.5202789306641, 0.567585941007029, -92.1361083984375, -1.60807845152713, 218, 22, 'PPL', 'P'),
(4771, 'Old Texas', 31.7694396972656, 0.554481324231076, -87.0002822875977, -1.51844137608308, 218, 2, 'PPL', 'P'),
(10960, 'Old Texas', 35.3236083984375, 0.616513270237855, -92.2888870239258, -1.61074494156858, 218, 4, 'PPL', 'P'),
(10961, 'Old Thompson (historical)', 34.2947196960449, 0.598555774744533, -93.9722213745117, -1.64012466839822, 218, 4, 'PPL', 'P'),
(123357, 'Old Tip Town', 41.2236099243164, 0.719487722737132, -86.1152801513672, -1.50299517491868, 218, 19, 'PPL', 'P'),
(208320, 'Old Toroda', 48.7777786254883, 0.851332838823685, -118.910278320313, -2.07537587115229, 218, 56, 'PPL', 'P'),
(4774, 'Old Town', 33.6916694641113, 0.588030562642376, -87.8361129760742, -1.53302937358621, 218, 2, 'PPL', 'P'),
(10963, 'Old Town', 34.3863906860352, 0.600155735348425, -90.7541732788086, -1.58395913364067, 218, 4, 'PPL', 'P'),
(17409, 'Old Town', 29.601110458374, 0.516636839745155, -82.9819412231445, -1.44830809404028, 218, 12, 'PPL', 'P'),
(23641, 'Old Town', 32.913890838623, 0.57445576477597, -82.3091735839844, -1.43656608363607, 218, 13, 'PPL', 'P'),
(50082, 'Old Town', 39.1419410705566, 0.683155747302807, -76.1063919067383, -1.32830712058575, 218, 25, 'PPL', 'P'),
(56670, 'Old Town', 36.5038909912109, 0.637113087585727, -91.543327331543, -1.59773247016634, 218, 29, 'PPL', 'P'),
(67473, 'Old Town', 34.1363906860352, 0.595792412218439, -77.9608306884766, -1.36067318310375, 218, 33, 'PPL', 'P'),
(82769, 'Old Town', 32.8044395446777, 0.572545479326056, -79.9847183227539, -1.39599668601229, 218, 48, 'PPL', 'P'),
(117116, 'Old Town', 43.3136100769043, 0.755965106766974, -95.1438903808594, -1.66057415030256, 218, 16, 'PPL', 'P'),
(123358, 'Old Town', 40.2580604553223, 0.702635705412301, -87.3866729736328, -1.52518516575344, 218, 19, 'PPL', 'P'),
(128426, 'Old Town', 44.9341697692871, 0.784249209124161, -68.6458282470703, -1.1980957206699, 218, 26, 'PPL', 'P'),
(156926, 'Old Town', 40.4425010681152, 0.705854801379934, -81.4633331298828, -1.42180338276543, 218, 41, 'PPL', 'P'),
(183831, 'Old Town', 35.1427803039551, 0.61335722460903, -118.49388885498, -2.06810850401162, 218, 6, 'PPL', 'P'),
(189163, 'Old Town', 32.5530586242676, 0.568158054588205, -107.914169311523, -1.88345756404071, 218, 38, 'PPL', 'P'),
(197181, 'Old Town', 47.2350006103516, 0.824406282832166, -114.698333740234, -2.00186357031839, 218, 31, 'PPL', 'P'),
(201347, 'Old Town', 43.4330596923828, 0.758049895847316, -123.294441223145, -2.1518939487505, 218, 43, 'PPL', 'P'),
(208321, 'Old Town', 48.1505584716797, 0.840385782004859, -123.150001525879, -2.14937300046263, 218, 56, 'PPL', 'P'),
(89662, 'Old Town (historical)', 35.9930610656738, 0.628197423467387, -86.9375, -1.51734561845257, 218, 50, 'PPL', 'P'),
(67470, 'Old Town Harbor', 35.0897216796875, 0.612431176918982, -77.0650024414063, -1.34503803066001, 218, 33, 'PPL', 'P'),
(125738, 'Old Town Landing', 41.8041687011719, 0.729620384894611, -71.1213912963867, -1.24130244672119, 218, 23, 'PPL', 'P'),
(128427, 'Old Town Landing', 44.9425010681152, 0.784394617719679, -68.7925033569336, -1.20065568426774, 218, 26, 'PPL', 'P'),
(183830, 'Old Town San Diego', 32.7541694641113, 0.571668100904929, -117.196113586426, -2.04545805262439, 218, 6, 'PPL', 'P'),
(151377, 'Old Town Station', 40.5958290100098, 0.708530878801301, -74.0875015258789, -1.29307083620291, 218, 40, 'PPL', 'P'),
(67472, 'Old Trap', 36.2405586242676, 0.632517070755496, -76.0272216796875, -1.32692533945416, 218, 33, 'PPL', 'P'),
(104928, 'Old Trap', 38.1380615234375, 0.665634743912149, -77.5458297729492, -1.35343005072901, 218, 53, 'PPL', 'P'),
(117117, 'Old Tripoli', 42.8261108398438, 0.747456639979307, -92.2652816772461, -1.61033295054794, 218, 16, 'PPL', 'P'),
(104929, 'Old Trower', 37.5916709899902, 0.656098430101766, -75.7058334350586, -1.32131605640818, 218, 53, 'PPL', 'P'),
(178748, 'Old Tucson', 32.2180595397949, 0.56231121757299, -111.129440307617, -1.93957462926642, 218, 5, 'PPL', 'P'),
(200106, 'Old Tuscarora (historical)', 41.2880592346191, 0.720612575402554, -116.248329162598, -2.02891609382947, 218, 39, 'PPL', 'P'),
(212069, 'Old Tyonek', 61.0380592346191, 1.06531510267143, -151.283065795898, -2.64038760064964, 218, 1, 'PPL', 'P'),
(175676, 'Old Tyrone (historical)', 44.7138900756836, 0.780404603195495, -91.8424987792969, -1.6029539969576, 218, 57, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(10964, 'Old Union', 33.2338905334473, 0.58004081305603, -92.5361099243164, -1.61505979516672, 218, 4, 'PPL', 'P'),
(61168, 'Old Union', 34.1474990844727, 0.595986290345797, -88.7366714477539, -1.54874708402375, 218, 30, 'PPL', 'P'),
(96757, 'Old Union', 33.1875, 0.579231145505618, -94.9136123657227, -1.65655504074346, 218, 51, 'PPL', 'P'),
(10966, 'Old Union (historical)', 34.3380584716797, 0.599312179073143, -94.095832824707, -1.64228209519729, 218, 4, 'PPL', 'P'),
(212070, 'Old Valdez', 61.1158294677734, 1.06667244930002, -146.266387939453, -2.55283005454278, 218, 1, 'PPL', 'P'),
(82770, 'Old Vat (historical)', 32.9316711425781, 0.574766089621991, -79.8486099243164, -1.39362114631994, 218, 48, 'PPL', 'P'),
(132413, 'Old Victoria Historic Townsite', 46.7077789306641, 0.815204528633724, -89.2263870239258, -1.55729423322625, 218, 27, 'PPL', 'P'),
(50083, 'Old Villa', 38.7983283996582, 0.677158574844058, -76.1094436645508, -1.32836038380755, 218, 25, 'PPL', 'P'),
(23642, 'Old Villa Rica', 33.7458305358887, 0.5889758516713, -84.929443359375, -1.48229841850713, 218, 13, 'PPL', 'P'),
(37512, 'Old Volney', 36.774169921875, 0.641830344824585, -87.0124969482422, -1.51865456212834, 218, 21, 'PPL', 'P'),
(61169, 'Old Wahalak (historical)', 32.9194412231445, 0.574552637260621, -88.4372177124023, -1.54352063038447, 218, 30, 'PPL', 'P'),
(37513, 'Old Washington', 38.6158294677734, 0.673973367601296, -83.8086090087891, -1.46273616871995, 218, 21, 'PPL', 'P'),
(89663, 'Old Washington', 35.5344390869141, 0.620192959916018, -84.9072189331055, -1.48191052909436, 218, 50, 'PPL', 'P'),
(156927, 'Old Washington', 40.0386085510254, 0.698805547132549, -81.4447174072266, -1.42147847711244, 218, 41, 'PPL', 'P'),
(189164, 'Old Waterman Place', 33.4313888549805, 0.583487809033946, -108.737777709961, -1.89783224234052, 218, 38, 'PPL', 'P'),
(208322, 'Old Wauconda', 48.7125015258789, 0.850193538509349, -118.95361328125, -2.07613220890187, 218, 56, 'PPL', 'P'),
(96758, 'Old Waverly', 30.5288906097412, 0.532829658121163, -95.3525009155273, -1.66421509098686, 218, 51, 'PPL', 'P'),
(67474, 'Old Weeksville', 36.2063903808594, 0.6319207224084, -76.1744384765625, -1.32949475727387, 218, 33, 'PPL', 'P'),
(197182, 'Old Weiss And French Place', 46.8069381713867, 0.816935183868112, -111.923606872559, -1.9534354506339, 218, 31, 'PPL', 'P'),
(104930, 'Old Welbourne', 39.0111083984375, 0.680872286405146, -77.8194427490234, -1.35820549803769, 218, 53, 'PPL', 'P'),
(89664, 'Old Well Crossing', 35.622501373291, 0.62172993676013, -85.8844375610352, -1.49896621166355, 218, 50, 'PPL', 'P'),
(104931, 'Old Well Crossing', 36.6172218322754, 0.639091083906356, -80.0208282470703, -1.39662692308426, 218, 53, 'PPL', 'P'),
(187134, 'Old Wells', 38.9000015258789, 0.678933105657405, -102.325828552246, -1.78592261806792, 218, 7, 'PPL', 'P'),
(10967, 'Old Weona', 35.5352783203125, 0.620207607302013, -90.5730590820313, -1.5807980945848, 218, 4, 'PPL', 'P'),
(151378, 'Old Westbury', 40.7886085510254, 0.711895516522507, -73.5999984741211, -1.28456230283622, 218, 40, 'PPL', 'P'),
(56671, 'Old Westport Landing', 39.1755599975586, 0.683742508269979, -90.7333297729492, -1.58359534583576, 218, 29, 'PPL', 'P'),
(197183, 'Old Whitcomb Place', 47.985279083252, 0.837501112491113, -107.977783203125, -1.88456783589916, 218, 31, 'PPL', 'P'),
(4775, 'Old White Hall (historical)', 32.2633285522461, 0.56310131088939, -87.6083297729492, -1.52905380671094, 218, 2, 'PPL', 'P'),
(104932, 'Old Wilkins', 37.2872200012207, 0.650784757936785, -79.9347229003906, -1.39512410128113, 218, 53, 'PPL', 'P'),
(195407, 'Old Williamsburg (historical)', 42.9427795410156, 0.749492892948782, -111.339721679688, -1.94324473156466, 218, 17, 'PPL', 'P'),
(89665, 'Old Winesap', 35.7902793884277, 0.624658215536727, -85.165283203125, -1.48641460028795, 218, 50, 'PPL', 'P'),
(56672, 'Old Woollam', 38.3927803039551, 0.670080425298845, -91.5533294677734, -1.59790704037579, 218, 29, 'PPL', 'P'),
(189165, 'Old Wright Place', 32.4805603027344, 0.566892720175281, -105.899436950684, -1.84829385079757, 218, 38, 'PPL', 'P'),
(50093, 'Old York Manor', 39.5158309936523, 0.689681357500856, -76.5769424438477, -1.33651977675533, 218, 25, 'PPL', 'P'),
(89666, 'Old Zion', 35.9724998474121, 0.627838562510499, -85.5638885498047, -1.49337157600357, 218, 50, 'PPL', 'P'),
(165515, 'Old Zionsville', 40.4863891601563, 0.706620793088468, -75.5205612182617, -1.31808244621261, 218, 45, 'PPL', 'P'),
(165516, 'Old Zollarsville', 40.0111083984375, 0.69832557892509, -80.0758285522461, -1.39758685949918, 218, 45, 'PPL', 'P'),
(125739, 'Olde English Village', 42.5583305358887, 0.7427829920033, -71.9983291625977, -1.25660789982198, 218, 23, 'PPL', 'P'),
(67476, 'Olde Farm', 35.0041694641113, 0.610938009074802, -80.5113906860352, -1.40518885283081, 218, 33, 'PPL', 'P'),
(23643, 'Olde Federal Pointe', 34.2211112976074, 0.597271065834679, -83.9458312988281, -1.46513114948826, 218, 13, 'PPL', 'P'),
(104933, 'Olde Hunting Hills', 36.628059387207, 0.639280234922779, -79.4494400024414, -1.38665431690829, 218, 53, 'PPL', 'P'),
(50086, 'Olde Mill', 38.4630584716797, 0.671307010717909, -76.5669403076172, -1.33634520654588, 218, 25, 'PPL', 'P'),
(89667, 'Olde Mill', 35.1674995422363, 0.613788656705623, -85.2266693115234, -1.48748598999449, 218, 50, 'PPL', 'P'),
(50087, 'Olde Mill Estates', 39.3824996948242, 0.687354287340345, -76.7744369506836, -1.33996670615422, 218, 25, 'PPL', 'P'),
(50088, 'Olde Oak Run', 39.4197196960449, 0.688003898909242, -77.1213912963867, -1.34602220184085, 218, 25, 'PPL', 'P'),
(67479, 'Olde Providence', 35.1150016784668, 0.612872396132581, -80.7916717529297, -1.41008068027912, 218, 33, 'PPL', 'P'),
(104934, 'Olde South Estates', 38.8752784729004, 0.678501606981785, -77.5761108398438, -1.35395855504734, 218, 53, 'PPL', 'P'),
(50089, 'Olde Washington Valley', 39.4613914489746, 0.688731208202943, -77.0105590820313, -1.34408781478307, 218, 25, 'PPL', 'P'),
(73780, 'Olde West Chester', 39.3316688537598, 0.686467121802212, -84.4072189331055, -1.47318388283439, 218, 41, 'PPL', 'P'),
(56673, 'Olden', 36.8338890075684, 0.642872639496214, -91.9102783203125, -1.60413697311382, 218, 29, 'PPL', 'P'),
(96759, 'Olden', 32.4188919067383, 0.565816403620725, -98.7505569458008, -1.72352235688238, 218, 51, 'PPL', 'P'),
(28128, 'Oldenburg', 38.7969398498535, 0.677134340078138, -90.1013870239258, -1.5725658641812, 218, 18, 'PPL', 'P'),
(30730, 'Oldenburg', 39.3397216796875, 0.686607670128741, -85.2044372558594, -1.48709796742367, 218, 19, 'PPL', 'P'),
(61170, 'Oldenburg', 31.5738906860352, 0.551068350136085, -90.9744415283203, -1.58780353983225, 218, 30, 'PPL', 'P'),
(96760, 'Oldenburg', 29.976390838623, 0.523186717998636, -96.7647171020508, -1.68886291319165, 218, 51, 'PPL', 'P'),
(104935, 'Oldenplace (historical)', 37.0055618286133, 0.645868895459635, -77.8444366455078, -1.35864172382424, 218, 53, 'PPL', 'P'),
(4776, 'Oldfield', 33.2027816772461, 0.57949786108879, -86.2180633544922, -1.50478908022896, 218, 2, 'PPL', 'P'),
(42431, 'Oldfield', 30.6272201538086, 0.534545832417124, -90.8444366455078, -1.5855345265835, 218, 22, 'PPL', 'P'),
(50091, 'Oldfield', 39.4961090087891, 0.689337143929963, -77.1930618286133, -1.34727308860486, 218, 25, 'PPL', 'P'),
(56674, 'Oldfield', 36.978328704834, 0.645393587784083, -93.0400009155273, -1.62385435203449, 218, 29, 'PPL', 'P'),
(50092, 'Oldfield Acres', 39.5536117553711, 0.69034075618676, -75.8788909912109, -1.32433648055849, 218, 25, 'PPL', 'P'),
(121, 'Oldfields', 37.3611106872559, 0.652074393694656, -79.9400024414063, -1.39521624665484, 218, 53, 'PPL', 'P'),
(128429, 'Oldfields', 43.2158317565918, 0.754258553140452, -70.8008270263672, -1.23570754474509, 218, 26, 'PPL', 'P'),
(89669, 'Oldfort', 35.0652809143066, 0.612004605091378, -84.7324981689453, -1.47886107648816, 218, 50, 'PPL', 'P'),
(37514, 'Oldham', 38.497501373291, 0.671908152754967, -85.4211120605469, -1.49087965617158, 218, 21, 'PPL', 'P'),
(56676, 'Oldham', 38.7308311462402, 0.675980525535862, -92.2627792358398, -1.61028927470606, 218, 29, 'PPL', 'P'),
(61171, 'Oldham', 34.7730598449707, 0.606904385287768, -88.1283264160156, -1.53812946023177, 218, 30, 'PPL', 'P'),
(89670, 'Oldham', 35.7761116027832, 0.624410941029513, -83.4822235107422, -1.45703966714827, 218, 50, 'PPL', 'P'),
(96763, 'Oldham', 30.7411193847656, 0.536533749012814, -94.2339935302734, -1.64469345440631, 218, 51, 'PPL', 'P'),
(156928, 'Oldham', 40.0708312988281, 0.699367940175747, -81.5991668701172, -1.42417412876782, 218, 41, 'PPL', 'P'),
(171000, 'Oldham', 44.2275009155273, 0.771915510904759, -97.307502746582, -1.69833630982128, 218, 49, 'PPL', 'P'),
(37515, 'Oldham Acres', 38.3977813720703, 0.670167710403573, -85.6202774047852, -1.49435574718441, 218, 21, 'PPL', 'P'),
(125740, 'Oldham Pines', 42.0722198486328, 0.734298759981553, -70.8291702270508, -1.23620222691758, 218, 23, 'PPL', 'P'),
(125741, 'Oldham Village', 42.0666694641113, 0.734201887496901, -70.8291702270508, -1.23620222691758, 218, 23, 'PPL', 'P'),
(104936, 'Oldhams', 38.002498626709, 0.663268725020695, -76.6691665649414, -1.33812939131818, 218, 53, 'PPL', 'P'),
(71214, 'Oldmans', 39.7566719055176, 0.69388482438641, -75.4305572509766, -1.31651158064362, 218, 37, 'PPL', 'P'),
(132414, 'Oldport', 41.9947204589844, 0.732946140463902, -83.2866668701172, -1.45362655989523, 218, 27, 'PPL', 'P'),
(104938, 'Oldrag', 38.5569381713867, 0.67294552057858, -78.3333282470703, -1.36717449195686, 218, 53, 'PPL', 'P'),
(104937, 'Oldrag (historical)', 38.5569381713867, 0.67294552057858, -78.3324966430664, -1.36715997772891, 218, 53, 'PPL', 'P'),
(67483, 'Olds', 36.1749992370605, 0.631372843593143, -75.8633270263672, -1.32406483812731, 218, 33, 'PPL', 'P'),
(117118, 'Olds', 41.1341705322266, 0.717926710864182, -91.5447235107422, -1.59775683809031, 218, 16, 'PPL', 'P'),
(208324, 'Olds', 47.4636116027832, 0.82839629735635, -120.327499389648, -2.10011104504083, 218, 56, 'PPL', 'P'),
(17410, 'Oldsmar', 28.0338897705078, 0.489283678636519, -82.665283203125, -1.4427813689881, 218, 12, 'PPL', 'P'),
(28129, 'Oldtown', 37.6022186279297, 0.656282521112118, -88.6883316040039, -1.54790339459041, 218, 18, 'PPL', 'P'),
(30731, 'Oldtown', 39.0947189331055, 0.682331565524455, -84.8469390869141, -1.48085844730572, 218, 19, 'PPL', 'P'),
(37517, 'Oldtown', 38.4402809143066, 0.670909467346187, -82.8983306884766, -1.44684881492097, 218, 21, 'PPL', 'P'),
(50094, 'Oldtown', 39.541389465332, 0.690127436983444, -78.6116714477539, -1.37203249725932, 218, 25, 'PPL', 'P'),
(67485, 'Oldtown', 36.1525001525879, 0.630980160490411, -80.2941665649414, -1.40139757670297, 218, 33, 'PPL', 'P'),
(73781, 'Oldtown', 39.730281829834, 0.693424230675881, -83.9377822875977, -1.46499066774076, 218, 41, 'PPL', 'P'),
(89671, 'Oldtown', 35.9799995422363, 0.627969456878076, -83.1658325195313, -1.45151760262799, 218, 50, 'PPL', 'P'),
(112626, 'Oldtown', 36.6549987792969, 0.639750416013233, -80.958610534668, -1.41299431166972, 218, 53, 'PPL', 'P'),
(195408, 'Oldtown', 48.1788902282715, 0.84088026444026, -117.03694152832, -2.04267997613327, 218, 17, 'PPL', 'P'),
(82771, 'Oldtown (historical)', 34.1733283996582, 0.59643709693932, -81.7819366455078, -1.42736406312152, 218, 48, 'PPL', 'P'),
(110758, 'Oldtown (historical)', 38.9008293151855, 0.678947553306319, -82.0802764892578, -1.43257107568484, 218, 58, 'PPL', 'P'),
(73782, 'Oldtown Flats', 38.9966697692871, 0.680620284786998, -81.8424987792969, -1.42842107175817, 218, 41, 'PPL', 'P'),
(145965, 'Oldwick', 40.6725006103516, 0.709869050670038, -74.7477798461914, -1.3045948668719, 218, 37, 'PPL', 'P'),
(82775, 'Oldwoods', 34.9625015258789, 0.610210766360128, -81.0697174072266, -1.41493349241746, 218, 48, 'PPL', 'P'),
(104939, 'Ole Orchard Estates', 39.2561111450195, 0.685148391009432, -78.1327819824219, -1.36367429933616, 218, 53, 'PPL', 'P'),
(82772, 'Ole Salem Estates', 34.9122200012207, 0.60933318820192, -82.5519409179688, -1.44080317293039, 218, 48, 'PPL', 'P'),
(30732, 'Olean', 38.9902801513672, 0.68050876491635, -85.2186126708984, -1.48734537508894, 218, 19, 'PPL', 'P'),
(56677, 'Olean', 38.410831451416, 0.670395477255802, -92.529167175293, -1.61493862133712, 218, 29, 'PPL', 'P'),
(104940, 'Olean', 37.3905601501465, 0.652588383785041, -80.6597213745117, -1.40777771172648, 218, 53, 'PPL', 'P'),
(142584, 'Olean', 41.5608291625977, 0.725373308746207, -98.8072204589844, -1.72451132175318, 218, 35, 'PPL', 'P'),
(151379, 'Olean', 42.0774993896484, 0.73439090535527, -78.4300003051758, -1.36886173766547, 218, 40, 'PPL', 'P'),
(4779, 'Oleander', 34.413890838623, 0.600635703555885, -86.5280609130859, -1.51019955829956, 218, 2, 'PPL', 'P'),
(183832, 'Oleander', 36.6344413757324, 0.639391621635372, -119.753890991211, -2.09009968987101, 218, 6, 'PPL', 'P'),
(183833, 'Olema', 38.040828704834, 0.663937711086523, -122.78694152832, -2.14303640812295, 218, 6, 'PPL', 'P'),
(208326, 'Olema', 48.285831451416, 0.842746740890242, -119.803062438965, -2.09095789353228, 218, 56, 'PPL', 'P'),
(10968, 'Olena', 34.336109161377, 0.599278157190217, -91.4102783203125, -1.59541032685384, 218, 4, 'PPL', 'P'),
(120889, 'Olena', 40.7855606079102, 0.711842319879732, -90.938606262207, -1.58717809645025, 218, 18, 'PPL', 'P'),
(156944, 'Olena', 41.1544418334961, 0.718280511814999, -82.5411071777344, -1.44061408849299, 218, 41, 'PPL', 'P'),
(193217, 'Olene', 42.1719398498535, 0.736039202332947, -121.629722595215, -2.12283912757384, 218, 43, 'PPL', 'P'),
(156930, 'Olentangy', 40.063060760498, 0.699232318697234, -83.04638671875, -1.44943288012668, 218, 41, 'PPL', 'P'),
(183834, 'Oleo (historical)', 33.9205589294434, 0.59202543743555, -117.877502441406, -2.05735053163019, 218, 6, 'PPL', 'P'),
(165517, 'Oleona', 41.5561103820801, 0.725290950489496, -77.7019424438477, -1.35615473084027, 218, 45, 'PPL', 'P'),
(165518, 'Oleopolis', 41.4555587768555, 0.723535993910161, -79.6175003051758, -1.38958752253291, 218, 45, 'PPL', 'P'),
(208325, 'Olequa', 46.3741683959961, 0.809381926384429, -122.938606262207, -2.14568345708843, 218, 56, 'PPL', 'P'),
(76816, 'Oleta', 34.1994400024414, 0.59689283038086, -95.3436126708984, -1.66405996185336, 218, 42, 'PPL', 'P'),
(96764, 'Oletha', 31.3583297729492, 0.54730610246413, -96.4127807617188, -1.68272046529544, 218, 51, 'PPL', 'P'),
(183835, 'Oleum', 38.0447196960449, 0.66400562169432, -122.247222900391, -2.13361654103123, 218, 6, 'PPL', 'P'),
(201348, 'Olex', 45.4972190856934, 0.794076273546553, -120.167778015137, -2.09732338116979, 218, 43, 'PPL', 'P'),
(165519, 'Oley', 40.3875007629395, 0.704894864965015, -75.7900009155273, -1.32278505606547, 218, 45, 'PPL', 'P'),
(165520, 'Oley Furnace', 40.4083290100098, 0.705258386453811, -75.7888870239258, -1.32276561498951, 218, 45, 'PPL', 'P'),
(165521, 'Oley Line', 40.3438911437988, 0.704133733525471, -75.8047180175781, -1.32304191795261, 218, 45, 'PPL', 'P'),
(96765, 'Olfen', 31.6094398498535, 0.551688800091046, -99.9602813720703, -1.74463603116258, 218, 51, 'PPL', 'P'),
(17411, 'Olga', 26.7186107635498, 0.46632772938274, -81.7125015258789, -1.42615219166748, 218, 12, 'PPL', 'P'),
(28130, 'Olga', 37.9913902282715, 0.663074846893338, -88.5769424438477, -1.54595928699465, 218, 18, 'PPL', 'P'),
(37520, 'Olga', 36.9508285522461, 0.644913619576624, -85.1602783203125, -1.4863272486042, 218, 21, 'PPL', 'P'),
(42432, 'Olga', 29.3463897705078, 0.512191125068944, -89.4027786254883, -1.56037284744638, 218, 22, 'PPL', 'P'),
(56678, 'Olga', 37.0886116027832, 0.647318387461938, -92.9066696166992, -1.62152728187398, 218, 29, 'PPL', 'P'),
(113136, 'Olga', 47.6872215270996, 0.832299026775806, -95.663330078125, -1.66964008328541, 218, 28, 'PPL', 'P'),
(140641, 'Olga', 48.7983283996582, 0.851691500043491, -98.0374984741211, -1.71107713879233, 218, 34, 'PPL', 'P'),
(178749, 'Olga', 32.2997207641602, 0.563736474809374, -109.358612060547, -1.90866784586772, 218, 5, 'PPL', 'P'),
(183836, 'Olga', 34.1124992370605, 0.59537542777076, -118.16471862793, -2.06236339975005, 218, 6, 'PPL', 'P'),
(208327, 'Olga', 48.6197204589844, 0.848574203408526, -122.834167480469, -2.14386065648033, 218, 56, 'PPL', 'P'),
(82773, 'Olga (historical)', 35.0027809143066, 0.610913774308882, -82.5586090087891, -1.44091955307002, 218, 48, 'PPL', 'P'),
(23645, 'Olifftown', 32.4944381713867, 0.567134934676424, -82.0975036621094, -1.43287174657191, 218, 13, 'PPL', 'P'),
(183838, 'Olig (historical)', 35.3250007629395, 0.616537571582802, -119.655563354492, -2.08838354886456, 218, 6, 'PPL', 'P'),
(37518, 'Olin', 37.3519401550293, 0.651914337713142, -83.9663925170898, -1.46549001044515, 218, 21, 'PPL', 'P'),
(67486, 'Olin', 35.9524993896484, 0.627489488670617, -80.8399963378906, -1.41092410339635, 218, 33, 'PPL', 'P'),
(82774, 'Olin', 33.4249992370605, 0.583376289163299, -79.4652786254883, -1.38693075302944, 218, 48, 'PPL', 'P'),
(112597, 'Olin', 31.8772201538086, 0.556362448067053, -98.1066665649414, -1.71228434971446, 218, 51, 'PPL', 'P'),
(117119, 'Olin', 41.9980583190918, 0.733004397112747, -91.1413879394531, -1.59071730438091, 218, 16, 'PPL', 'P'),
(120890, 'Olin', 40.7527809143066, 0.711270206298556, -89.7683334350586, -1.56675298246988, 218, 18, 'PPL', 'P'),
(123359, 'Olin', 40.149169921875, 0.700735207079393, -87.4305572509766, -1.52595109088294, 218, 19, 'PPL', 'P'),
(193832, 'Olinda', 40.4438896179199, 0.705879036145854, -122.406387329102, -2.13639448436429, 218, 6, 'PPL', 'P'),
(183837, 'Olinda (historical)', 33.9261093139648, 0.592122309920201, -117.836669921875, -2.05663786972249, 218, 6, 'PPL', 'P'),
(56679, 'Olinger', 37.276668548584, 0.650600600347406, -93.8369369506836, -1.63776350977576, 218, 29, 'PPL', 'P'),
(104941, 'Olinger', 36.8172187805176, 0.642581689147123, -82.8647232055664, -1.44626225369088, 218, 53, 'PPL', 'P'),
(190567, 'Olinghouse', 39.6583290100098, 0.692168417063854, -119.428062438965, -2.08441290883731, 218, 39, 'PPL', 'P'),
(10969, 'Olio', 34.9147186279297, 0.60937679746477, -93.8483276367188, -1.63796231475113, 218, 4, 'PPL', 'P'),
(30733, 'Olio', 39.9713897705078, 0.697632358093342, -85.9211120605469, -1.49960630243155, 218, 19, 'PPL', 'P'),
(61172, 'Olio', 31.0544395446777, 0.542002217416155, -90.9211120605469, -1.58687276503127, 218, 30, 'PPL', 'P'),
(89672, 'Olio', 36.4402809143066, 0.636002882306301, -85.9944381713867, -1.50088608449339, 218, 50, 'PPL', 'P'),
(89673, 'Olio (historical)', 35.5486106872559, 0.620440301002259, -85.4722213745117, -1.4917716819787, 218, 50, 'PPL', 'P'),
(78882, 'Oliphant Furnace', 39.8422203063965, 0.695377925651563, -79.7261123657227, -1.39148316059683, 218, 45, 'PPL', 'P'),
(71216, 'Oliphants Mills', 39.8849983215332, 0.696124542863166, -74.8333282470703, -1.30608796813705, 218, 37, 'PPL', 'P'),
(96766, 'Olivarez', 26.2280597686768, 0.457765999373272, -97.991943359375, -1.71028205204889, 218, 51, 'PPL', 'P'),
(96767, 'Olivarez Colonia', 26.3920001983643, 0.460627299648453, -98.8349990844727, -1.72499615022963, 218, 51, 'PPL', 'P'),
(96768, 'Olivarez Number 1 Colonia', 26.1860008239746, 0.457031932308305, -97.9800033569336, -1.71007365969359, 218, 51, 'PPL', 'P'),
(96769, 'Olivarez Number 10 Colonia', 26.2240009307861, 0.457695159288276, -97.9660034179688, -1.70982931466357, 218, 51, 'PPL', 'P'),
(96770, 'Olivarez Number 15 Colonia', 26.2329998016357, 0.457852219213563, -98.0009994506836, -1.71044011065958, 218, 51, 'PPL', 'P'),
(96771, 'Olivarez Number 17 Colonia', 26.2329998016357, 0.457852219213563, -97.9869995117188, -1.71019576562957, 218, 51, 'PPL', 'P'),
(96772, 'Olivarez Number 18 Colonia', 26.2549991607666, 0.458236180463725, -97.9739990234375, -1.70996886430469, 218, 51, 'PPL', 'P'),
(96773, 'Olivarez Number 2 Colonia', 26.2119998931885, 0.457485701668541, -97.9850006103516, -1.71016087821929, 218, 51, 'PPL', 'P'),
(96774, 'Olivarez Number 3 Colonia', 26.2089996337891, 0.457433337263607, -97.9850006103516, -1.71016087821929, 218, 51, 'PPL', 'P'),
(96775, 'Olivarez Number 4 Colonia', 26.2269992828369, 0.457747490403696, -97.9609985351563, -1.70974196297982, 218, 51, 'PPL', 'P'),
(96776, 'Olivarez Number 5 Colonia', 26.1469993591309, 0.456351228333681, -97.9759979248047, -1.71000375171497, 218, 51, 'PPL', 'P'),
(96777, 'Olivarez Number 6 Colonia', 26.2159996032715, 0.457555509778615, -97.9850006103516, -1.71016087821929, 218, 51, 'PPL', 'P'),
(96778, 'Olivarez Number 7 Colonia', 26.257999420166, 0.458288544868659, -97.9749984741211, -1.70998630800983, 218, 51, 'PPL', 'P'),
(96779, 'Olivarez Number 8 Colonia', 26.2560005187988, 0.458253657458379, -97.9909973144531, -1.71026554045013, 218, 51, 'PPL', 'P'),
(96780, 'Olivarez Number 9 Colonia', 26.2590007781982, 0.458306021863313, -97.9779968261719, -1.71003863912525, 218, 51, 'PPL', 'P'),
(17412, 'Olive', 30.5086097717285, 0.532475690722778, -87.2552795410156, -1.52289191773877, 218, 12, 'PPL', 'P'),
(37519, 'Olive', 36.8008308410645, 0.642295665646049, -88.2611083984375, -1.54044694301235, 218, 21, 'PPL', 'P'),
(50095, 'Olive', 39.3274993896484, 0.686394350925426, -77.5827789306641, -1.35407493518697, 218, 25, 'PPL', 'P'),
(56680, 'Olive', 37.459171295166, 0.653785874169196, -93.1086120605469, -1.62505184241864, 218, 29, 'PPL', 'P'),
(76819, 'Olive', 36.0283317565918, 0.628813013153359, -96.4797210693359, -1.68388879406566, 218, 42, 'PPL', 'P'),
(104942, 'Olive', 38.2194404602051, 0.667055074300515, -77.4413909912109, -1.35160725012091, 218, 53, 'PPL', 'P'),
(110760, 'Olive', 38.5636100769043, 0.673061967297244, -79.8202819824219, -1.39312673046357, 218, 58, 'PPL', 'P'),
(123360, 'Olive', 41.7000007629395, 0.727802311397441, -86.4480590820313, -1.50880326294003, 218, 19, 'PPL', 'P'),
(183839, 'Olive', 33.836109161377, 0.590551510930245, -117.845283508301, -2.05678820516602, 218, 6, 'PPL', 'P'),
(189166, 'Olive', 33.9508285522461, 0.592553742016794, -104.037498474121, -1.81579689391199, 218, 38, 'PPL', 'P'),
(197184, 'Olive', 45.5505599975586, 0.795007248084618, -105.527496337891, -1.84180226248245, 218, 31, 'PPL', 'P'),
(23646, 'Olive Branch', 32.6725006103516, 0.570242710510492, -84.6097183227539, -1.47671816391703, 218, 13, 'PPL', 'P'),
(28131, 'Olive Branch', 37.1686096191406, 0.64871461624244, -89.3516693115234, -1.55948082163926, 218, 18, 'PPL', 'P'),
(37523, 'Olive Branch', 38.125560760498, 0.665416564439844, -85.2649993896484, -1.48815497606032, 218, 21, 'PPL', 'P'),
(42444, 'Olive Branch', 30.7438907623291, 0.536582118676112, -91.0619430541992, -1.58933072955936, 218, 22, 'PPL', 'P'),
(61173, 'Olive Branch', 34.961669921875, 0.610196252132187, -89.8294372558594, -1.56781944532841, 218, 30, 'PPL', 'P'),
(67488, 'Olive Branch', 35.103889465332, 0.612678451426196, -80.3213882446289, -1.40187268464144, 218, 33, 'PPL', 'P'),
(73783, 'Olive Branch', 39.0838890075684, 0.682142547666087, -84.2252807617188, -1.47000846270863, 218, 41, 'PPL', 'P'),
(89674, 'Olive Branch', 35.7347183227539, 0.623688492004801, -89.6744384765625, -1.5651142062931, 218, 50, 'PPL', 'P'),
(132415, 'Olive Center', 42.9141693115234, 0.748993550244392, -86.0813903808594, -1.50240368684057, 218, 27, 'PPL', 'P'),
(178750, 'Olive City (historical)', 33.6111106872559, 0.586624546744869, -114.525001525879, -1.99883835247812, 218, 5, 'PPL', 'P'),
(73784, 'Olive Furnace', 38.7616691589355, 0.676518750392166, -82.629997253418, -1.44216551298601, 218, 41, 'PPL', 'P'),
(156932, 'Olive Green', 40.3191719055176, 0.703702301428878, -82.8302764892578, -1.4456610450748, 218, 41, 'PPL', 'P'),
(67489, 'Olive Grove', 35.5430603027344, 0.620343428517607, -81.5838928222656, -1.4239075463427, 218, 33, 'PPL', 'P'),
(37522, 'Olive Hill', 38.2999992370605, 0.668461090198023, -83.1741714477539, -1.45166314438156, 218, 21, 'PPL', 'P'),
(67491, 'Olive Hill', 36.4244384765625, 0.635726379606123, -79.0497207641602, -1.37967790011672, 218, 33, 'PPL', 'P'),
(183840, 'Olive Hill', 39.288330078125, 0.685710717473602, -121.469169616699, -2.12003694947486, 218, 6, 'PPL', 'P'),
(183841, 'Olive Springs (historical)', 37.0583305358887, 0.646789883143612, -121.918609619141, -2.12788115730763, 218, 6, 'PPL', 'P'),
(23647, 'Olive Terrace', 33.3994407653809, 0.582930209680711, -82.1288909912109, -1.43341955880814, 218, 13, 'PPL', 'P'),
(183842, 'Olive View', 34.3244400024414, 0.599074491945853, -118.442779541016, -2.0672164782045, 218, 6, 'PPL', 'P'),
(178751, 'Olive West', 33.5694389343262, 0.585897237451168, -112.214996337891, -1.95852115620957, 218, 5, 'PPL', 'P'),
(151383, 'Olivebridge', 41.9277801513672, 0.731777811693684, -74.2158279418945, -1.29531055467967, 218, 40, 'PPL', 'P'),
(165523, 'Oliveburg', 40.9908294677734, 0.715424937336161, -79.0266723632813, -1.37927562963407, 218, 45, 'PPL', 'P'),
(89675, 'Olivehill', 35.2738914489746, 0.61564554577568, -88.0322189331055, -1.53645206821918, 218, 50, 'PPL', 'P'),
(183843, 'Olivehurst', 39.0955581665039, 0.682346212910451, -121.551109313965, -2.12146706698023, 218, 6, 'PPL', 'P'),
(183844, 'Olivenhain', 33.0461082458496, 0.576763393860523, -117.23388671875, -2.04611731815224, 218, 6, 'PPL', 'P'),
(122, 'Oliver', 37.8580589294434, 0.660747776732826, -77.5330581665039, -1.35320714414577, 218, 53, 'PPL', 'P'),
(4778, 'Oliver', 34.8108291625977, 0.60756358423659, -87.2502822875977, -1.52280469921307, 218, 2, 'PPL', 'P'),
(10970, 'Oliver', 34.9316711425781, 0.609672674661878, -94.2605590820313, -1.64515711075209, 218, 4, 'PPL', 'P'),
(23648, 'Oliver', 32.5213890075684, 0.567605315503959, -81.533332824707, -1.42302510791551, 218, 13, 'PPL', 'P'),
(30734, 'Oliver', 38.0433311462402, 0.6639813869284, -87.8391723632813, -1.53308276996607, 218, 19, 'PPL', 'P'),
(42434, 'Oliver', 30.4936103820801, 0.532213901987623, -90.4577789306641, -1.57878607638124, 218, 22, 'PPL', 'P'),
(78883, 'Oliver', 39.9186096191406, 0.696711170672284, -79.7180633544922, -1.39134267884932, 218, 45, 'PPL', 'P'),
(112464, 'Oliver', 35.4933280944824, 0.619475437739323, -78.2594375610352, -1.36588485619898, 218, 33, 'PPL', 'P'),
(120892, 'Oliver', 41.8008308410645, 0.729562128245765, -90.0680618286133, -1.57198422979913, 218, 18, 'PPL', 'P'),
(175677, 'Oliver', 46.6575012207031, 0.814327017054543, -92.1949996948242, -1.60910629854985, 218, 57, 'PPL', 'P'),
(199578, 'Oliver', 41.2294387817383, 0.719589455490773, -103.787498474121, -1.811433570782, 218, 35, 'PPL', 'P'),
(183845, 'Oliver (historical)', 39.1327781677246, 0.682995824479348, -121.58943939209, -2.12213605304606, 218, 6, 'PPL', 'P'),
(50096, 'Oliver Beach', 39.3727798461914, 0.687184643978907, -76.3430633544922, -1.33243781659452, 218, 25, 'PPL', 'P'),
(82776, 'Oliver Crossroads', 34.3844413757324, 0.600121713465499, -79.2638931274414, -1.38341591302276, 218, 48, 'PPL', 'P'),
(128430, 'Oliver Hill Corner', 45.0658302307129, 0.786547117670736, -69.1733322143555, -1.20730240171636, 218, 26, 'PPL', 'P'),
(165524, 'Oliver Manor', 41.435001373291, 0.7231771995323, -79.6788864135742, -1.39065891223945, 218, 45, 'PPL', 'P'),
(165525, 'Oliver Mills', 41.2169418334961, 0.719371342597495, -75.8422164916992, -1.32369638979049, 218, 45, 'PPL', 'P'),
(89679, 'Oliver Springs', 36.0444412231445, 0.629094176385444, -84.3444366455078, -1.47208812520387, 218, 50, 'PPL', 'P'),
(37524, 'Oliver Station', 38.6247215270996, 0.67412856331382, -82.8625030517578, -1.44622350469702, 218, 21, 'PPL', 'P'),
(151384, 'Oliverea', 42.0652809143066, 0.734177652730982, -74.460563659668, -1.29958199875204, 218, 40, 'PPL', 'P'),
(61174, 'Oliverfried', 34.1736106872559, 0.596442023787337, -90.2977828979492, -1.57599361882024, 218, 30, 'PPL', 'P'),
(67493, 'Olivers', 35.0141716003418, 0.611112579284256, -77.2936096191406, -1.34902797860516, 218, 33, 'PPL', 'P'),
(132420, 'Olivers', 43.8824996948242, 0.765894103680089, -85.5822219848633, -1.49369155480854, 218, 27, 'PPL', 'P'),
(205222, 'Olivers', 40.4844398498535, 0.706586771205543, -111.922500610352, -1.953416142716, 218, 52, 'PPL', 'P'),
(10973, 'Olivers Chapel', 34.5911102294922, 0.60372876542493, -94.2750015258789, -1.64540917894927, 218, 4, 'PPL', 'P'),
(104943, 'Olivers Corner', 38.2058296203613, 0.66681752033128, -77.6561126708984, -1.35535485040687, 218, 53, 'PPL', 'P'),
(67495, 'Olivers Crossroads', 35.0186080932617, 0.611190010692951, -77.3019409179688, -1.34917338720068, 218, 33, 'PPL', 'P'),
(23649, 'Olivers Mill', 31.8722190856934, 0.556275162962326, -84.3363876342773, -1.47194764345637, 218, 13, 'PPL', 'P'),
(197185, 'Oliverville', 47.1847190856934, 0.823528704673958, -114.872222900391, -2.00489850869665, 218, 31, 'PPL', 'P'),
(156933, 'Olivesburg', 40.8858299255371, 0.713592349611051, -82.4288864135742, -1.43865546666929, 218, 41, 'PPL', 'P'),
(28135, 'Olivet', 39.9419403076172, 0.697118368002957, -87.6436080932617, -1.52966952955497, 218, 18, 'PPL', 'P'),
(50097, 'Olivet', 38.3377799987793, 0.669120488883926, -76.4430618286133, -1.3341831192149, 218, 25, 'PPL', 'P'),
(67496, 'Olivet', 35.4544410705566, 0.618796731135517, -83.2966690063477, -1.45380113010468, 218, 33, 'PPL', 'P'),
(71217, 'Olivet', 39.5480613708496, 0.690243883702108, -75.1549987792969, -1.31170217803105, 218, 37, 'PPL', 'P'),
(89677, 'Olivet', 35.214168548584, 0.614603184525023, -88.2002792358398, -1.53938527384379, 218, 50, 'PPL', 'P'),
(112327, 'Olivet', 38.4805603027344, 0.671612475294941, -95.7513885498047, -1.67117699355049, 218, 20, 'PPL', 'P'),
(117121, 'Olivet', 41.3136100769043, 0.721058521727088, -92.8300018310547, -1.62018917658427, 218, 16, 'PPL', 'P'),
(132421, 'Olivet', 42.4413909912109, 0.740742011922891, -84.9241714477539, -1.48220640629147, 218, 27, 'PPL', 'P'),
(165529, 'Olivet', 40.586669921875, 0.708371022556868, -79.4116668701172, -1.38599505138045, 218, 45, 'PPL', 'P'),
(171004, 'Olivet', 43.2408294677734, 0.754694845506034, -97.6750030517578, -1.70475040014868, 218, 49, 'PPL', 'P'),
(175679, 'Olivet', 44.7863883972168, 0.781669937608419, -92.2569427490234, -1.61018740879437, 218, 57, 'PPL', 'P'),
(50098, 'Olivet Hill', 39.3380584716797, 0.686578641672859, -75.8663864135742, -1.32411823450716, 218, 25, 'PPL', 'P'),
(156934, 'Olivett', 40.0219383239746, 0.698514596783458, -81.1380615234375, -1.41612632226971, 218, 41, 'PPL', 'P'),
(56682, 'Olivette', 38.6652793884277, 0.674836431531563, -90.3758316040039, -1.57735582571782, 218, 29, 'PPL', 'P'),
(67497, 'Olivette', 35.9461097717285, 0.62737796879997, -81.616943359375, -1.42448438703482, 218, 33, 'PPL', 'P'),
(104944, 'Oliveville', 37.1472206115723, 0.648341307636638, -78.2333297729492, -1.36542918933647, 218, 53, 'PPL', 'P'),
(89678, 'Oliveville (historical)', 35.9755592346191, 0.627891958890355, -85.5611114501953, -1.49332310647173, 218, 50, 'PPL', 'P'),
(67498, 'Olivia', 35.3594398498535, 0.617138647040833, -79.1100006103516, -1.38072998190536, 218, 33, 'PPL', 'P'),
(96781, 'Olivia', 28.6383304595947, 0.499833158794109, -96.4552764892578, -1.68346215565903, 218, 51, 'PPL', 'P'),
(137270, 'Olivia', 44.7763900756836, 0.781495433977992, -94.9894409179688, -1.65787849864718, 218, 28, 'PPL', 'P'),
(96782, 'Olivia Lopez de Gutierrez Colonia', 26.3269996643066, 0.459492826313593, -98.7170028686523, -1.72293672775867, 218, 51, 'PPL', 'P'),
(42435, 'Olivier', 29.9752807617188, 0.523167343501706, -91.7558288574219, -1.60144132145844, 218, 22, 'PPL', 'P'),
(192734, 'Oljato', 37.0361099243164, 0.646402060309869, -110.317497253418, -1.92540354963194, 218, 52, 'PPL', 'P'),
(42436, 'Olla', 31.9027805328369, 0.556808560839155, -92.2430572509766, -1.60994506113517, 218, 22, 'PPL', 'P'),
(4783, 'Ollie', 31.4713897705078, 0.549279371673824, -87.3422164916992, -1.52440925376984, 218, 2, 'PPL', 'P'),
(23650, 'Ollie', 34.7483291625977, 0.606472753454093, -84.600830078125, -1.47656303478353, 218, 13, 'PPL', 'P'),
(37525, 'Ollie', 37.2519416809082, 0.650169035092759, -86.1802825927734, -1.50412968154305, 218, 21, 'PPL', 'P'),
(42437, 'Ollie', 29.7427806854248, 0.519109451659239, -90.0175018310547, -1.57110179137193, 218, 22, 'PPL', 'P'),
(96783, 'Ollie', 30.7902793884277, 0.53739175293701, -94.7799987792969, -1.65422304373494, 218, 51, 'PPL', 'P'),
(117122, 'Ollie', 41.1980590820313, 0.719041776412598, -92.0922164916992, -1.60731239323957, 218, 16, 'PPL', 'P'),
(197186, 'Ollie', 46.5847206115723, 0.813056755793602, -104.084167480469, -1.81661142173139, 218, 31, 'PPL', 'P'),
(156935, 'Ollins Corners', 41.7994384765625, 0.729537826900818, -80.6694412231445, -1.40794735508791, 218, 41, 'PPL', 'P'),
(96784, 'Olmito', 26.021390914917, 0.454158947413841, -97.5338897705078, -1.70228750877258, 218, 51, 'PPL', 'P'),
(96785, 'Olmito and Olmito Number 2 Colonia', 26.3400001525879, 0.459719727638467, -98.6399993896484, -1.72159276351456, 218, 51, 'PPL', 'P'),
(33494, 'Olmitz', 38.5166702270508, 0.672242712366908, -98.9361114501953, -1.72676089392597, 218, 20, 'PPL', 'P'),
(117123, 'Olmitz', 41.0816688537598, 0.717010383712113, -93.1691665649414, -1.62610871789724, 218, 16, 'PPL', 'P'),
(96788, 'Olmos', 26.3591709136963, 0.460054320539922, -98.7825012207031, -1.72407988965659, 218, 51, 'PPL', 'P'),
(96789, 'Olmos Park', 29.478609085083, 0.514498787443012, -98.4872207641602, -1.71892627347312, 218, 51, 'PPL', 'P'),
(10985, 'Olmstead', 34.9430618286133, 0.609871479637252, -92.2122192382813, -1.60940683627887, 218, 4, 'PPL', 'P'),
(37526, 'Olmstead', 36.7522201538086, 0.641447249101777, -87.0149993896484, -1.51869823797022, 218, 21, 'PPL', 'P'),
(205224, 'Olmstead', 40.3166694641113, 0.703658625587001, -111.653610229492, -1.94872312024306, 218, 52, 'PPL', 'P'),
(165530, 'Olmstead (historical)', 41.9280586242676, 0.731782671962673, -78.9494400024414, -1.37792767064832, 218, 45, 'PPL', 'P'),
(28136, 'Olmsted', 37.1805610656738, 0.64892320833482, -89.0888900756836, -1.55489445876798, 218, 18, 'PPL', 'P'),
(156936, 'Olmsted', 41.4069404602051, 0.722687444207835, -81.8969421386719, -1.42937128763511, 218, 41, 'PPL', 'P'),
(165531, 'Olmsted', 41.750560760498, 0.728684749824639, -78.0658264160156, -1.36250570424984, 218, 45, 'PPL', 'P'),
(156937, 'Olmsted Falls', 41.375, 0.722129978012654, -81.908332824707, -1.42957009261049, 218, 41, 'PPL', 'P'),
(151385, 'Olmstedville', 43.7713890075684, 0.763954856353321, -73.9316711425781, -1.29035108293967, 218, 40, 'PPL', 'P'),
(165532, 'Olmsville', 41.6566696166992, 0.727046040226886, -77.4024963378906, -1.35092841035904, 218, 45, 'PPL', 'P'),
(212071, 'Olnes', 65.0741729736328, 1.1357585764022, -147.669998168945, -2.57732767446209, 218, 1, 'PPL', 'P'),
(4784, 'Olney', 33.1411094665527, 0.578421477955207, -88.0386123657227, -1.53656365466885, 218, 2, 'PPL', 'P'),
(23653, 'Olney', 32.2552795410156, 0.562960829141888, -81.4608306884766, -1.42175970692356, 218, 13, 'PPL', 'P'),
(28138, 'Olney', 38.7308311462402, 0.675980525535862, -88.0852813720703, -1.53737818248826, 218, 18, 'PPL', 'P'),
(37527, 'Olney', 37.2247200012207, 0.649693927154289, -87.7799987792969, -1.53204999609533, 218, 21, 'PPL', 'P'),
(50099, 'Olney', 39.1530609130859, 0.683349825167247, -77.0672225952148, -1.34507677965387, 218, 25, 'PPL', 'P'),
(56683, 'Olney', 39.0838890075684, 0.682142547666087, -91.2430572509766, -1.59249176861523, 218, 29, 'PPL', 'P'),
(76823, 'Olney', 34.4724998474121, 0.601658623730584, -96.3608322143555, -1.68181379210232, 218, 42, 'PPL', 'P'),
(96790, 'Olney', 33.3705596923828, 0.582426139865386, -98.7525024414063, -1.72355631218628, 218, 51, 'PPL', 'P'),
(165533, 'Olney', 40.0411109924316, 0.698849222974426, -75.1241683959961, -1.3111640863328, 218, 45, 'PPL', 'P'),
(197187, 'Olney', 48.5486106872559, 0.847333103761522, -114.577217102051, -1.99974968620314, 218, 31, 'PPL', 'P'),
(201349, 'Olney', 46.1002807617188, 0.804601685385792, -123.756393432617, -2.15995653579266, 218, 43, 'PPL', 'P'),
(50100, 'Olney Acres', 39.1500015258789, 0.683296428787391, -77.091667175293, -1.3455034180605, 218, 25, 'PPL', 'P'),
(104945, 'Olney Corner', 38.2344398498535, 0.66731686303567, -77.3266677856445, -1.34960495245533, 218, 53, 'PPL', 'P'),
(132423, 'Olney Corners', 43.128059387207, 0.752726636302411, -84.3447189331055, -1.47209305205189, 218, 27, 'PPL', 'P'),
(50101, 'Olney Estates', 39.146671295166, 0.6832383052966, -77.0475006103516, -1.34473256608298, 218, 25, 'PPL', 'P'),
(50102, 'Olney Mill', 39.1758308410645, 0.683747235380914, -77.0722198486328, -1.34516399817957, 218, 25, 'PPL', 'P'),
(50103, 'Olney Oaks', 39.1525001525879, 0.683340038050241, -77.081672668457, -1.3453289810091, 218, 25, 'PPL', 'P'),
(104946, 'Olney Park', 38.9191703796387, 0.679267665269346, -77.1969375610352, -1.34734073289654, 218, 53, 'PPL', 'P'),
(187135, 'Olney Springs', 38.1661109924316, 0.666124299499533, -103.94416809082, -1.81416797143124, 218, 7, 'PPL', 'P'),
(50104, 'Olney Square', 39.1580581665039, 0.683437043692947, -77.0819396972656, -1.34533364154101, 218, 25, 'PPL', 'P'),
(50105, 'Olney Town', 39.1577796936035, 0.683432183423958, -77.0683288574219, -1.34509608757177, 218, 25, 'PPL', 'P'),
(169532, 'Olneyville', 41.8147201538086, 0.72980454248399, -71.4469375610352, -1.24698430090687, 218, 47, 'PPL', 'P'),
(61175, 'Oloh', 31.2966709136963, 0.546229952357142, -89.5899963378906, -1.56364041294585, 218, 30, 'PPL', 'P'),
(210815, 'Olokele', 21.9222202301025, 0.382614922362598, -159.628616333008, -2.78604493541378, 218, 15, 'PPL', 'P'),
(210817, 'Olowalu', 20.8147201538086, 0.36328539956518, -156.625, -2.73362194093612, 218, 15, 'PPL', 'P'),
(33495, 'Olpe', 38.2625007629395, 0.667806618360136, -96.1666717529297, -1.67842505277325, 218, 20, 'PPL', 'P'),
(33496, 'Olsburg', 39.4305610656738, 0.688193116504692, -96.6152801513672, -1.68625474637808, 218, 20, 'PPL', 'P'),
(195409, 'Olsen', 43.2852783203125, 0.755470624331574, -112.621109008789, -1.96560915945082, 218, 17, 'PPL', 'P'),
(132424, 'Olson', 43.625560760498, 0.761409673299532, -84.4291687011719, -1.47356697855719, 218, 27, 'PPL', 'P'),
(197188, 'Olson Place', 47.4713897705078, 0.828532051992917, -112.009170532227, -1.95492881821516, 218, 31, 'PPL', 'P'),
(137274, 'Olson''s Mobile Park', 45.8863906860352, 0.800868599327773, -95.3555603027344, -1.66426848736672, 218, 28, 'PPL', 'P'),
(195410, 'Olsons', 47.0027809143066, 0.820353284548202, -115.129173278809, -2.00938313881429, 218, 17, 'PPL', 'P'),
(202457, 'Olsonville', 43.1277809143066, 0.752721776033421, -100.608612060547, -1.75595153631822, 218, 49, 'PPL', 'P'),
(156940, 'Olszeski Town', 40.1944389343262, 0.701525300395793, -80.7888870239258, -1.41003207758923, 218, 41, 'PPL', 'P'),
(191984, 'Olton', 34.1833305358887, 0.596611667148775, -102.134170532227, -1.78257755458072, 218, 51, 'PPL', 'P'),
(4785, 'Olustee', 31.9027805328369, 0.556808560839155, -86.1624984741211, -1.503819290118, 218, 2, 'PPL', 'P'),
(17413, 'Olustee', 30.2038898468018, 0.527157324736376, -82.4288864135742, -1.43865546666929, 218, 12, 'PPL', 'P'),
(76824, 'Olustee', 34.5486106872559, 0.602987008482316, -99.4219436645508, -1.73524026567873, 218, 42, 'PPL', 'P'),
(10974, 'Olvey', 36.1908302307129, 0.631649146556239, -92.9658279418945, -1.6225597894286, 218, 4, 'PPL', 'P'),
(165534, 'Olwen Heights', 41.3588905334473, 0.721848814780569, -75.5494384765625, -1.3185864494489, 218, 45, 'PPL', 'P'),
(37528, 'Olympia', 38.0980606079102, 0.664936596232385, -83.6958312988281, -1.46076782635827, 218, 21, 'PPL', 'P'),
(56684, 'Olympia', 37.7261085510254, 0.65844480818018, -94.0283279418945, -1.64110391273104, 218, 29, 'PPL', 'P'),
(67500, 'Olympia', 35.1388893127441, 0.613289314001233, -76.9711074829102, -1.34339925448323, 218, 33, 'PPL', 'P'),
(82777, 'Olympia', 33.976390838623, 0.59299988807841, -81.0299987792969, -1.41424027158572, 218, 48, 'PPL', 'P'),
(183847, 'Olympia', 37.0697212219238, 0.646988688118986, -122.057502746582, -2.13030529968988, 218, 6, 'PPL', 'P'),
(208328, 'Olympia', 47.0380592346191, 0.820969007392228, -122.899436950684, -2.14499982363661, 218, 56, 'PPL', 'P'),
(23654, 'Olympia (historical)', 30.6544399261475, 0.535020907066081, -83.345832824707, -1.4546592006079, 218, 13, 'PPL', 'P'),
(73789, 'Olympia (historical)', 39.5411109924316, 0.690122576714455, -83.3777770996094, -1.45521673338211, 218, 41, 'PPL', 'P'),
(120894, 'Olympia Fields', 41.5133285522461, 0.724544266698865, -87.6741714477539, -1.53020296072131, 218, 18, 'PPL', 'P'),
(183848, 'Olympia Glade', 39.2330589294434, 0.684746053947748, -121.034439086914, -2.11244947037117, 218, 6, 'PPL', 'P'),
(17414, 'Olympia Heights', 25.726390838623, 0.449010224788877, -80.3555603027344, -1.40246909956757, 218, 12, 'PPL', 'P'),
(37529, 'Olympia Springs', 38.061939239502, 0.664306159423336, -83.6730575561523, -1.46037034956558, 218, 21, 'PPL', 'P'),
(56685, 'Olympian Village', 38.1361083984375, 0.665600655450196, -90.4577789306641, -1.57878607638124, 218, 29, 'PPL', 'P'),
(96791, 'Olympic Colonia', 26.1840000152588, 0.456997011608511, -97.9039993286133, -1.70874713915462, 218, 51, 'PPL', 'P'),
(183849, 'Olympic Heights', 39.3358306884766, 0.686539759520944, -120.156669616699, -2.09712950304243, 218, 6, 'PPL', 'P'),
(208329, 'Olympic Hot Springs', 47.976390838623, 0.837345983357616, -123.686943054199, -2.15874439802251, 218, 56, 'PPL', 'P'),
(42438, 'Olympic Landing', 31.7577800750732, 0.55427782543428, -91.5505599975586, -1.59785870400201, 218, 22, 'PPL', 'P'),
(104947, 'Olympic Mobile Home Park', 37.1688919067383, 0.648719543090456, -77.3597183227539, -1.35018179314744, 218, 53, 'PPL', 'P'),
(144274, 'Olympic Mobile Home Park', 43.6433296203613, 0.761719798408472, -72.1797180175781, -1.25977373256781, 218, 36, 'PPL', 'P'),
(208330, 'Olympic View', 47.6941719055176, 0.83242033376346, -122.739166259766, -2.14220257238564, 218, 56, 'PPL', 'P'),
(194355, 'Olympus Heights', 40.3777809143066, 0.704725221603577, -105.483329772949, -1.84103141050493, 218, 7, 'PPL', 'P'),
(205228, 'Olympus Shadows Estates', 40.6494407653809, 0.7094665804503, -111.805557250977, -1.95137509605656, 218, 52, 'PPL', 'P'),
(205229, 'Olympus View', 40.6433296203613, 0.709359920848642, -111.851112365723, -1.9521701828, 218, 52, 'PPL', 'P'),
(10976, 'Olyphant', 35.5244407653809, 0.62001845628559, -91.3822174072266, -1.59492057152938, 218, 4, 'PPL', 'P'),
(165535, 'Olyphant', 41.4683303833008, 0.723758900493401, -75.6033325195313, -1.31952707794592, 218, 45, 'PPL', 'P'),
(67502, 'Olyphic', 33.9908294677734, 0.593251889696558, -78.6591720581055, -1.37286153930666, 218, 33, 'PPL', 'P'),
(10977, 'Oma', 34.396110534668, 0.600325378709863, -93.2644424438477, -1.62777159568189, 218, 4, 'PPL', 'P'),
(61176, 'Oma', 31.7266693115234, 0.553734840177527, -90.1447219848633, -1.57332220193078, 218, 30, 'PPL', 'P'),
(4786, 'Omaha', 33.3025016784668, 0.581238303440184, -85.3102798461914, -1.4889452691138, 218, 2, 'PPL', 'P'),
(10978, 'Omaha', 36.452220916748, 0.636211274661599, -93.1883316040039, -1.62644321093016, 218, 4, 'PPL', 'P'),
(23655, 'Omaha', 32.146110534668, 0.561055470539991, -85.0133285522461, -1.4837624913164, 218, 13, 'PPL', 'P'),
(28140, 'Omaha', 37.8902816772461, 0.661310169776024, -88.3030624389648, -1.54117917915407, 218, 18, 'PPL', 'P'),
(37530, 'Omaha', 37.2750015258789, 0.650571505312497, -82.8419418334961, -1.44586464374014, 218, 21, 'PPL', 'P'),
(96792, 'Omaha', 33.1805610656738, 0.579110038255047, -94.7438888549805, -1.65359280666297, 218, 51, 'PPL', 'P'),
(104948, 'Omaha', 37.0974998474121, 0.647473516595435, -82.4347229003906, -1.43875733258099, 218, 53, 'PPL', 'P'),
(139373, 'Omaha', 40.5325012207031, 0.70742560036989, -92.8005599975586, -1.61967531965194, 218, 29, 'PPL', 'P'),
(142592, 'Omaha', 41.2586097717285, 0.720098585312169, -95.9375, -1.67442525113206, 218, 35, 'PPL', 'P'),
(142593, 'Omaha Regency', 41.2694396972656, 0.720287603170537, -96.1855621337891, -1.6787547521162, 218, 35, 'PPL', 'P'),
(23656, 'Omaha Springs', 33.1694412231445, 0.578915960390607, -82.543327331543, -1.44065283748685, 218, 13, 'PPL', 'P'),
(208331, 'Omak', 48.4111099243164, 0.844933262724224, -119.526390075684, -2.08612904984375, 218, 56, 'PPL', 'P'),
(208332, 'Omans', 47.6022186279297, 0.830815446311551, -118.076942443848, -2.06083141633298, 218, 56, 'PPL', 'P'),
(210818, 'Omao', 21.9325008392334, 0.382794352841042, -159.489166259766, -2.78361107249356, 218, 15, 'PPL', 'P'),
(14353, 'Omar', 38.5272216796875, 0.672426869956287, -75.1999969482422, -1.31248754423651, 218, 10, 'PPL', 'P'),
(28142, 'Omar', 37.5016708374023, 0.65452763111181, -88.9686126708984, -1.55279522203872, 218, 18, 'PPL', 'P'),
(110761, 'Omar', 37.7555618286133, 0.658958864849593, -81.9997177124023, -1.43116505978733, 218, 58, 'PPL', 'P'),
(151386, 'Omar', 44.2616691589355, 0.772511859251855, -75.9738922119141, -1.32599456465318, 218, 40, 'PPL', 'P'),
(156941, 'Omar', 41.1241683959961, 0.717752140654727, -82.8713912963867, -1.44637863383052, 218, 41, 'PPL', 'P'),
(50106, 'Omar (historical)', 39.063060760498, 0.681779026177291, -76.595832824707, -1.33684947609829, 218, 25, 'PPL', 'P'),
(50107, 'Omar Acres', 39.5372200012207, 0.690054666106658, -77.021110534668, -1.34427197237245, 218, 25, 'PPL', 'P'),
(56686, 'Omba (historical)', 36.8683280944824, 0.643473714954245, -92.1611099243164, -1.60851481047174, 218, 29, 'PPL', 'P'),
(190569, 'Omco', 38.6080589294434, 0.673837746122784, -117.892219543457, -2.05760739351733, 218, 39, 'PPL', 'P'),
(4787, 'Omega', 31.975830078125, 0.558083515921517, -85.7850036621094, -1.4972307627392, 218, 2, 'PPL', 'P'),
(10980, 'Omega', 33.8213882446289, 0.59029458246408, -91.4775009155273, -1.59658358247208, 218, 4, 'PPL', 'P'),
(23657, 'Omega', 31.3408298492432, 0.547000671176611, -83.5936126708984, -1.45898377474403, 218, 13, 'PPL', 'P'),
(28143, 'Omega', 38.7044410705566, 0.675519931825332, -88.7805633544922, -1.54951314231131, 218, 18, 'PPL', 'P'),
(37531, 'Omega', 36.9519386291504, 0.644932994073554, -84.5086135864258, -1.47495355337874, 218, 21, 'PPL', 'P'),
(42440, 'Omega', 32.5163917541504, 0.567518096978259, -91.1394424438477, -1.59068334907701, 218, 22, 'PPL', 'P'),
(61177, 'Omega', 33.1233291625977, 0.578111153109185, -90.3130569458008, -1.57626020124536, 218, 30, 'PPL', 'P'),
(73791, 'Omega', 39.151668548584, 0.6833255238223, -82.9102783203125, -1.44705734043433, 218, 41, 'PPL', 'P'),
(76826, 'Omega', 35.8702812194824, 0.626054510896255, -98.1975021362305, -1.71386972951139, 218, 42, 'PPL', 'P'),
(104949, 'Omega', 36.6716690063477, 0.640041366362324, -78.8069381713867, -1.3754405445063, 218, 53, 'PPL', 'P'),
(123363, 'Omega', 40.1983299255371, 0.70159321100359, -85.9391708374023, -1.49992148754656, 218, 19, 'PPL', 'P'),
(183851, 'Omega', 39.3333282470703, 0.686496083679067, -120.748329162598, -2.10745591016922, 218, 6, 'PPL', 'P'),
(189169, 'Omega', 34.3230590820313, 0.599050390337988, -108.373893737793, -1.89148126893095, 218, 38, 'PPL', 'P'),
(194356, 'Omega', 40.5397186279297, 0.707551567889451, -105.080001831055, -1.83399200995357, 218, 7, 'PPL', 'P'),
(195414, 'Omega', 47.3338890075684, 0.826132210955619, -116.477500915527, -2.03291589547066, 218, 17, 'PPL', 'P'),
(89680, 'Omega (historical)', 36.2416687011719, 0.632536445252426, -87.5388870239258, -1.52784180209885, 218, 50, 'PPL', 'P'),
(169533, 'Omega (historical)', 41.8349990844727, 0.730158476592861, -71.3613891601563, -1.24549119964172, 218, 47, 'PPL', 'P'),
(198709, 'Omemee', 48.7063903808594, 0.850086878907691, -100.354721069336, -1.75152030258044, 218, 34, 'PPL', 'P'),
(96793, 'Omen', 32.2172203063965, 0.562296570186995, -95.103889465332, -1.65987600262279, 218, 51, 'PPL', 'P'),
(132425, 'Omena', 45.0555610656738, 0.786367886929373, -85.5888900756836, -1.49380793494818, 218, 27, 'PPL', 'P'),
(132426, 'Omer', 44.0475006103516, 0.768773912924847, -83.8544387817383, -1.46353604915336, 218, 27, 'PPL', 'P'),
(151387, 'Omi', 42.3250007629395, 0.738710619222405, -73.6819381713867, -1.28599242034159, 218, 40, 'PPL', 'P'),
(195411, 'Omill', 46.4938888549805, 0.811471442575706, -115.925827026367, -2.02328736970753, 218, 17, 'PPL', 'P'),
(183852, 'Omira', 39.9669418334961, 0.697554726947566, -120.076393127441, -2.09572841399294, 218, 6, 'PPL', 'P'),
(189167, 'Omlee', 32.8369407653809, 0.573112732638243, -105.97110748291, -1.84954473756158, 218, 38, 'PPL', 'P'),
(42441, 'Omo (historical)', 30.8075008392334, 0.537692323955539, -92.2611083984375, -1.61026011309213, 218, 22, 'PPL', 'P'),
(183853, 'Omo Ranch', 38.5813903808594, 0.673372292143265, -120.572219848633, -2.1043822227971, 218, 6, 'PPL', 'P'),
(151388, 'Omro', 42.7838897705078, 0.746719743305682, -76.4322204589844, -1.33399390161945, 218, 40, 'PPL', 'P'),
(175681, 'Omro', 44.0394401550293, 0.768633231440263, -88.7441711425781, -1.54887797839133, 218, 57, 'PPL', 'P'),
(183855, 'Omus', 38.7197189331055, 0.675786580829477, -122.918609619141, -2.14533444982758, 218, 6, 'PPL', 'P'),
(198710, 'On-a-Slant Village (historical)', 46.7669410705566, 0.816237102767375, -100.846389770508, -1.76010154024489, 218, 34, 'PPL', 'P'),
(17415, 'Ona', 27.4816703796387, 0.479645632072495, -81.9191665649414, -1.42975917704788, 218, 12, 'PPL', 'P'),
(110762, 'Ona', 38.4247207641602, 0.670637891494026, -82.2133331298828, -1.43489335215539, 218, 58, 'PPL', 'P'),
(201350, 'Ona', 44.5041694641113, 0.776744288014263, -124.021110534668, -2.16457672080978, 218, 43, 'PPL', 'P'),
(10982, 'Ona (historical)', 34.5519409179688, 0.603045131973107, -91.5477828979492, -1.59781023447017, 218, 4, 'PPL', 'P'),
(33498, 'Onaga', 39.4888916015625, 0.689211176410402, -96.1697235107422, -1.67847831599505, 218, 20, 'PPL', 'P'),
(171007, 'Onaka', 45.1927795410156, 0.788762801118654, -99.4658279418945, -1.73600619080823, 218, 49, 'PPL', 'P'),
(96794, 'Onalaska', 30.8055591583252, 0.537658435230668, -95.1161117553711, -1.66008932182611, 218, 51, 'PPL', 'P'),
(175684, 'Onalaska', 43.8844413757324, 0.765927992404961, -91.2350006103516, -1.59235115370967, 218, 57, 'PPL', 'P'),
(208333, 'Onalaska', 46.5752792358398, 0.812891972701154, -122.716941833496, -2.14181468297287, 218, 56, 'PPL', 'P'),
(10983, 'Onalaska (historical)', 33.6699981689453, 0.587652327188558, -92.7399978637695, -1.61861831101529, 218, 4, 'PPL', 'P'),
(137276, 'Onamia', 46.0705604553223, 0.804082968184471, -93.6675033569336, -1.63480633570133, 218, 28, 'PPL', 'P'),
(104950, 'Onan', 37.9880599975586, 0.663016723402547, -78.8244400024414, -1.37574600908333, 218, 53, 'PPL', 'P'),
(104951, 'Onancock', 37.711669921875, 0.658192806562032, -75.7494430541992, -1.32207718784773, 218, 53, 'PPL', 'P'),
(76828, 'Onapa', 35.4058303833008, 0.617948314591245, -95.5530624389648, -1.66771554992366, 218, 42, 'PPL', 'P'),
(120895, 'Onarga', 40.7150001525879, 0.710610807612652, -88.0061111450195, -1.53599640135667, 218, 18, 'PPL', 'P'),
(151389, 'Onativia', 42.8894386291504, 0.748561918410718, -76.0883331298828, -1.32799193547074, 218, 40, 'PPL', 'P'),
(189168, 'Onava', 35.6966705322266, 0.62302443278699, -105.093887329102, -1.83423435761277, 218, 38, 'PPL', 'P'),
(117125, 'Onawa', 42.026668548584, 0.733503739817137, -96.0969390869141, -1.67720798815508, 218, 16, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(128431, 'Onawa', 45.3666687011719, 0.791797739496909, -69.3722229003906, -1.21077369903923, 218, 26, 'PPL', 'P'),
(117126, 'Onawa Junction', 42.7249984741211, 0.745691896282966, -95.557502746582, -1.66779304791138, 218, 16, 'PPL', 'P'),
(132428, 'Onaway', 45.3574981689453, 0.791637683515395, -84.2238922119141, -1.46998422794271, 218, 27, 'PPL', 'P'),
(195412, 'Onaway', 46.9283294677734, 0.819053861673325, -116.889999389648, -2.04011535200353, 218, 17, 'PPL', 'P'),
(165537, 'Onberg', 40.6669387817383, 0.709771978448305, -79.0552825927734, -1.37977497233846, 218, 45, 'PPL', 'P'),
(151390, 'Onchiota', 44.4941711425781, 0.776569784383836, -74.123893737793, -1.29370600012289, 218, 40, 'PPL', 'P'),
(10984, 'Onda', 35.8663902282715, 0.625986600288458, -94.2916717529297, -1.64570012929836, 218, 4, 'PPL', 'P'),
(56687, 'One Hundred and One Ranch', 38.3505592346191, 0.669343528625221, -90.6655578613281, -1.5824125028376, 218, 29, 'PPL', 'P'),
(183856, 'One Hundred Palms', 33.561939239502, 0.585766343083591, -116.171669006348, -2.02757812169782, 218, 6, 'PPL', 'P'),
(178752, 'One Mile', 36.8050003051758, 0.642368436522835, -112.053611755371, -1.95570446388265, 218, 5, 'PPL', 'P'),
(42442, 'One North Place', 32.6069412231445, 0.569098483348139, -93.8430633544922, -1.63787043569352, 218, 22, 'PPL', 'P'),
(96795, 'One River Place Colonia', 27.4029998779297, 0.478272572793477, -99.484001159668, -1.73632337329406, 218, 51, 'PPL', 'P'),
(17416, 'Oneco', 27.4472198486328, 0.479044356877382, -82.54638671875, -1.44070623386671, 218, 12, 'PPL', 'P'),
(113870, 'Oneco', 41.6936111450195, 0.727690791526794, -71.8088912963867, -1.25330158532865, 218, 8, 'PPL', 'P'),
(120897, 'Oneco', 42.4874992370605, 0.741546752625285, -89.6641693115234, -1.56493497555174, 218, 18, 'PPL', 'P'),
(137279, 'Onega', 47.3186111450195, 0.825865561951475, -92.8272171020508, -1.62014057389438, 218, 28, 'PPL', 'P'),
(110763, 'Onego', 38.8477783203125, 0.678021638774326, -79.4222183227539, -1.38617920896982, 218, 58, 'PPL', 'P'),
(10986, 'Oneida', 34.4613914489746, 0.601464745603226, -90.7830581665039, -1.58446327003502, 218, 4, 'PPL', 'P'),
(33499, 'Oneida', 39.8638916015625, 0.695756161105381, -95.9388885498047, -1.67444948589798, 218, 20, 'PPL', 'P'),
(37532, 'Oneida', 37.2694396972656, 0.650474433090764, -83.649169921875, -1.45995343169693, 218, 21, 'PPL', 'P'),
(42443, 'Oneida', 30.0191707611084, 0.523933368499754, -90.7977828979492, -1.58472026508021, 218, 22, 'PPL', 'P'),
(76830, 'Oneida', 35.9708290100098, 0.627809400896563, -98.0669403076172, -1.71159099572466, 218, 42, 'PPL', 'P'),
(89681, 'Oneida', 36.4980583190918, 0.637011288253059, -84.5127792358398, -1.4750262576765, 218, 50, 'PPL', 'P'),
(117128, 'Oneida', 42.542781829834, 0.742511615888221, -91.3533325195313, -1.59441643513503, 218, 16, 'PPL', 'P'),
(120899, 'Oneida', 41.0722198486328, 0.71684546746161, -90.2252807617188, -1.57472821782829, 218, 18, 'PPL', 'P'),
(151394, 'Oneida', 43.0924987792969, 0.752105986610368, -75.6516723632813, -1.32037076737926, 218, 40, 'PPL', 'P'),
(156942, 'Oneida', 40.6986083984375, 0.710324717532551, -81.149169921875, -1.41632020039707, 218, 41, 'PPL', 'P'),
(165539, 'Oneida', 40.9075012207031, 0.713970585064869, -76.1258316040039, -1.32864640730862, 218, 45, 'PPL', 'P'),
(175687, 'Oneida', 44.4986114501953, 0.776647282371557, -88.1827774047852, -1.53907980926676, 218, 57, 'PPL', 'P'),
(208335, 'Oneida', 46.3144416809082, 0.808339498554745, -123.67749786377, -2.15857954835103, 218, 56, 'PPL', 'P'),
(151391, 'Oneida Castle', 43.0825004577637, 0.75193148297994, -75.6338882446289, -1.32006037595421, 218, 40, 'PPL', 'P'),
(151392, 'Oneida Corners', 43.3752784729004, 0.75704142332153, -73.6291732788086, -1.28507149923664, 218, 40, 'PPL', 'P'),
(151395, 'Oneida Lake Beach East', 43.166389465332, 0.753395622368239, -75.7647171020508, -1.32234377027284, 218, 40, 'PPL', 'P'),
(151396, 'Oneida Lake Beach West', 43.1575012207031, 0.753240493234742, -75.845832824707, -1.32375950670833, 218, 40, 'PPL', 'P'),
(89682, 'Oneida Subdivision', 35.8722190856934, 0.626088333042099, -85.085563659668, -1.48502323177644, 218, 50, 'PPL', 'P'),
(151397, 'Oneida Valley', 43.1544418334961, 0.753187096854885, -75.7216720581055, -1.32159249252933, 218, 40, 'PPL', 'P'),
(197189, 'Oneill (historical)', 46.148609161377, 0.805445175082047, -105.150001525879, -1.83521373510365, 218, 31, 'PPL', 'P'),
(132431, 'Onekama', 44.3636093139648, 0.774291050597109, -86.2050018310547, -1.50456111363964, 218, 27, 'PPL', 'P'),
(132432, 'Onekama Junction', 44.3369407653809, 0.773825596617591, -86.2024993896484, -1.50451743779777, 218, 27, 'PPL', 'P'),
(104957, 'Onemo', 37.3955612182617, 0.652675668889769, -76.273063659668, -1.33121609144444, 218, 53, 'PPL', 'P'),
(4795, 'Oneonta', 33.9480590820313, 0.592505405643009, -86.4727783203125, -1.50923469503662, 218, 2, 'PPL', 'P'),
(37533, 'Oneonta', 38.9749984741211, 0.680242049333179, -84.3016662597656, -1.47134164115032, 218, 21, 'PPL', 'P'),
(151399, 'Oneonta', 42.4527816772461, 0.740940816898265, -75.0641708374023, -1.31011693139218, 218, 40, 'PPL', 'P'),
(33500, 'Oneonta (historical)', 39.6500015258789, 0.692023075047363, -97.8833312988281, -1.70838641398497, 218, 20, 'PPL', 'P'),
(137280, 'Oneota', 46.7463912963867, 0.815878441547569, -92.1658325195313, -1.60859723530748, 218, 28, 'PPL', 'P'),
(190571, 'Oneota (historical)', 38.0250015258789, 0.663661474702455, -115.341667175293, -2.01309185694833, 218, 39, 'PPL', 'P'),
(76829, 'Oneta', 36.0188903808594, 0.62864823006091, -95.7077789306641, -1.67041586211095, 218, 42, 'PPL', 'P'),
(71218, 'Ong', 39.910831451416, 0.696575416035717, -74.6211090087891, -1.30238404369297, 218, 37, 'PPL', 'P'),
(142596, 'Ong', 40.398609161377, 0.705088743092373, -97.835563659668, -1.70755271140572, 218, 35, 'PPL', 'P'),
(56688, 'Ongo', 36.9905586242676, 0.645607040145453, -92.8938903808594, -1.62130424213269, 218, 29, 'PPL', 'P'),
(338, 'Onia', 35.9188919067383, 0.626902927440527, -92.3269424438477, -1.61140913394444, 218, 4, 'PPL', 'P'),
(202458, 'Onida', 44.7080612182617, 0.780302870441854, -100.059440612793, -1.74636668639697, 218, 49, 'PPL', 'P'),
(110764, 'Onie (historical)', 39.6197204589844, 0.691494570729036, -80.6311111450195, -1.40727836902209, 218, 58, 'PPL', 'P'),
(137281, 'Onigum', 47.1094398498535, 0.822214834150167, -94.5444412231445, -1.65011178880213, 218, 28, 'PPL', 'P'),
(96797, 'Onion Creek', 30.1363906860352, 0.525979242138666, -97.7838897705078, -1.70665083190256, 218, 51, 'PPL', 'P'),
(208336, 'Onion Creek', 48.7838897705078, 0.851439498425342, -117.810562133789, -2.05618220285998, 218, 56, 'PPL', 'P'),
(191985, 'Onion Spring', 29.3999996185303, 0.51312679342843, -103.33332824707, -1.80350680495544, 218, 51, 'PPL', 'P'),
(151403, 'Oniontown', 43.1172218322754, 0.752537485285988, -75.8302764892578, -1.3234879974352, 218, 40, 'PPL', 'P'),
(165541, 'Oniontown', 41.3466682434082, 0.721635495577253, -80.3405609130859, -1.40220731083241, 218, 45, 'PPL', 'P'),
(89684, 'Onks', 36.2986106872559, 0.633530270392216, -82.4422225952148, -1.43888822694856, 218, 50, 'PPL', 'P'),
(104952, 'Onley', 37.6908302307129, 0.657829085336154, -75.7163925170898, -1.32150034715561, 218, 53, 'PPL', 'P'),
(56689, 'Only', 37.9166717529297, 0.661770763486553, -92.9502792358398, -1.62228841331352, 218, 29, 'PPL', 'P'),
(89683, 'Only', 35.8616714477539, 0.625904242031747, -87.6916732788086, -1.53050842529834, 218, 50, 'PPL', 'P'),
(165546, 'Onnalinda', 40.309440612793, 0.703532458330358, -78.6802825927734, -1.37322998764348, 218, 45, 'PPL', 'P'),
(37534, 'Ono', 36.9886093139648, 0.645573018262528, -84.966667175293, -1.48294809665505, 218, 21, 'PPL', 'P'),
(165542, 'Ono', 40.4027786254883, 0.705161513969159, -76.5350036621094, -1.33578780692973, 218, 45, 'PPL', 'P'),
(175690, 'Ono', 44.6555595397949, 0.779386543289785, -92.2561111450195, -1.61017289456643, 218, 57, 'PPL', 'P'),
(193833, 'Ono', 40.4752807617188, 0.706426914961111, -122.616943359375, -2.14006938035249, 218, 6, 'PPL', 'P'),
(210827, 'Onomea (historical)', 19.8166694641113, 0.345866128928163, -155.103607177734, -2.70706862697137, 218, 15, 'PPL', 'P'),
(132434, 'Onondaga', 42.4441719055176, 0.740790548033757, -84.5622177124023, -1.47588912186969, 218, 27, 'PPL', 'P'),
(151404, 'Onondaga Castle', 42.9705581665039, 0.749977721425231, -76.1413879394531, -1.32891791658176, 218, 40, 'PPL', 'P'),
(151406, 'Onondaga Hill', 43.0047187805176, 0.750573936614272, -76.1836090087891, -1.32965481325538, 218, 40, 'PPL', 'P'),
(132436, 'Onota', 46.4711112976074, 0.811073899203984, -86.9958267211914, -1.51836361177925, 218, 27, 'PPL', 'P'),
(110765, 'Onoto', 38.271110534668, 0.667956887224644, -80.1069412231445, -1.39812987804545, 218, 58, 'PPL', 'P'),
(151409, 'Onoville', 42.0269393920898, 0.733508466928072, -78.9655609130859, -1.37820903361749, 218, 40, 'PPL', 'P'),
(125742, 'Onset', 41.7416687011719, 0.728529554112114, -70.658332824707, -1.23322055176112, 218, 23, 'PPL', 'P'),
(125743, 'Onset Station', 41.7561111450195, 0.72878162230929, -70.6774978637695, -1.23355504479404, 218, 23, 'PPL', 'P'),
(117131, 'Onslow', 42.1069412231445, 0.7349047622876, -91.0149993896484, -1.58851140804999, 218, 16, 'PPL', 'P'),
(208337, 'Onslow', 47.1705589294434, 0.823281563324798, -124.113059997559, -2.16618154168266, 218, 56, 'PPL', 'P'),
(165543, 'Onspaugh Corners', 41.6472206115723, 0.726881123976382, -80.2088928222656, -1.39990926912778, 218, 45, 'PPL', 'P'),
(137282, 'Onstad Trailer Park', 43.5611114501953, 0.76028482063411, -91.6358337402344, -1.5993470115772, 218, 28, 'PPL', 'P'),
(132438, 'Onsted', 42.0061111450195, 0.733144945439276, -84.1900024414063, -1.4693927398646, 218, 27, 'PPL', 'P'),
(33502, 'Ontario', 39.5666694641113, 0.690568656197043, -95.8819427490234, -1.67345559417916, 218, 20, 'PPL', 'P'),
(76831, 'Ontario', 36.9874992370605, 0.645553643765597, -94.7627792358398, -1.65392250600592, 218, 42, 'PPL', 'P'),
(104953, 'Ontario', 36.9883308410645, 0.645568157993538, -78.4863891601563, -1.36984590884631, 218, 53, 'PPL', 'P'),
(113046, 'Ontario', 41.0786094665527, 0.716956987332257, -90.307502746582, -1.57616326218168, 218, 18, 'PPL', 'P'),
(117132, 'Ontario', 42.035831451416, 0.733663662640596, -93.6813888549805, -1.63504868336053, 218, 16, 'PPL', 'P'),
(123364, 'Ontario', 41.702220916748, 0.727841060391301, -85.3824996948242, -1.49020574325774, 218, 19, 'PPL', 'P'),
(151410, 'Ontario', 43.2208290100098, 0.754345771666152, -77.283332824707, -1.34884861470575, 218, 40, 'PPL', 'P'),
(156943, 'Ontario', 40.7594413757324, 0.711386453280138, -82.5902786254883, -1.44147229215427, 218, 41, 'PPL', 'P'),
(165544, 'Ontario', 40.103328704834, 0.699935126908906, -80.0747222900391, -1.39756755158128, 218, 45, 'PPL', 'P'),
(175691, 'Ontario', 43.725830078125, 0.763159703030851, -90.5913925170898, -1.58111807338977, 218, 57, 'PPL', 'P'),
(183859, 'Ontario', 34.0633316040039, 0.594517290688509, -117.650001525879, -2.05337989160294, 218, 6, 'PPL', 'P'),
(201351, 'Ontario', 44.026668548584, 0.768410324857024, -116.961936950684, -2.04137089929945, 218, 43, 'PPL', 'P'),
(151411, 'Ontario Beach', 43.2599983215332, 0.755029405117975, -77.6113891601563, -1.35457427789136, 218, 40, 'PPL', 'P'),
(151412, 'Ontario Center', 43.225830078125, 0.754433056770879, -77.3061065673828, -1.34924609149844, 218, 40, 'PPL', 'P'),
(201352, 'Ontario Heights', 44.0705604553223, 0.769176383144585, -117.022499084473, -2.0424279079361, 218, 43, 'PPL', 'P'),
(151414, 'Ontario on the Lake', 43.2780609130859, 0.755344656812013, -77.3486099243164, -1.34998791502008, 218, 40, 'PPL', 'P'),
(120901, 'Ontarioville', 41.9874992370605, 0.732820106365314, -88.1500015258789, -1.53850776226461, 218, 18, 'PPL', 'P'),
(165545, 'Ontelaunee', 40.4169387817383, 0.705408655318319, -75.9447174072266, -1.32548536825275, 218, 45, 'PPL', 'P'),
(151416, 'Onteo Beach', 43.3563919067383, 0.756711790557605, -77.9105606079102, -1.35979580468263, 218, 40, 'PPL', 'P'),
(151417, 'Onteora Park', 42.2200012207031, 0.736878031497295, -74.1358337402344, -1.29391439247819, 218, 40, 'PPL', 'P'),
(37535, 'Onton', 37.5550003051758, 0.655458405912793, -87.4369430541992, -1.52606254417456, 218, 21, 'PPL', 'P'),
(132439, 'Ontonagon', 46.8711090087891, 0.818055176264545, -89.3138885498047, -1.55882142295336, 218, 27, 'PPL', 'P'),
(67505, 'Onvil', 35.2805595397949, 0.615761925915317, -79.8672180175781, -1.39394591881488, 218, 33, 'PPL', 'P'),
(104954, 'Onville (historical)', 38.4911117553711, 0.67179663288432, -77.4449996948242, -1.35167023388069, 218, 53, 'PPL', 'P'),
(61178, 'Onward', 32.7252807617188, 0.57116389793155, -90.9419403076172, -1.58723628652006, 218, 30, 'PPL', 'P'),
(123365, 'Onward', 40.6947212219238, 0.710256873503781, -86.1949996948242, -1.50438654343019, 218, 19, 'PPL', 'P'),
(144275, 'Onway Lake', 43.0341682434082, 0.751087926704658, -71.216667175293, -1.24296532450583, 218, 36, 'PPL', 'P'),
(4789, 'Onycha', 31.2138900756836, 0.544785154176261, -86.283332824707, -1.50592824738524, 218, 2, 'PPL', 'P'),
(10989, 'Onyx', 34.851390838623, 0.60827151903336, -93.4077835083008, -1.63027336920991, 218, 4, 'PPL', 'P'),
(183860, 'Onyx', 35.6902809143066, 0.622912912916343, -118.219718933105, -2.06332333616497, 218, 6, 'PPL', 'P'),
(183861, 'Oo-moo-chah (historical)', 38.4083290100098, 0.670351801413924, -121.370826721191, -2.1183205421523, 218, 6, 'PPL', 'P'),
(37536, 'Oolite', 38.0677795410156, 0.664408091914058, -86.2799987792969, -1.50587005731542, 218, 21, 'PPL', 'P'),
(30735, 'Oolitic', 38.9008293151855, 0.678947553306319, -86.5252838134766, -1.51015108876772, 218, 19, 'PPL', 'P'),
(76832, 'Oologah', 36.4469413757324, 0.636119129287883, -95.7080612182617, -1.67042078895896, 218, 42, 'PPL', 'P'),
(89685, 'Ooltewah', 35.0750007629395, 0.612174248452817, -85.0622177124023, -1.48461576812966, 218, 50, 'PPL', 'P'),
(23658, 'Oostanaula', 34.4813919067383, 0.601813819443109, -85.0144424438477, -1.48378193239236, 218, 13, 'PPL', 'P'),
(175693, 'Oostburg', 43.6227798461914, 0.761361137188666, -87.7944412231445, -1.53230206429251, 218, 57, 'PPL', 'P'),
(151418, 'Oot Park', 43.0644416809082, 0.751616297864929, -76.0305633544922, -1.32698366268203, 218, 40, 'PPL', 'P'),
(76834, 'Oowala', 36.4233283996582, 0.635707005109193, -95.6144409179688, -1.66878680647214, 218, 42, 'PPL', 'P'),
(17417, 'Opa-locka', 25.9019393920898, 0.452074125043986, -80.2505569458008, -1.40063644526343, 218, 12, 'PPL', 'P'),
(76836, 'Opah', 36.7511100769043, 0.641427874604846, -96.2930603027344, -1.68063094910416, 218, 42, 'PPL', 'P'),
(10988, 'Opal', 34.5394401550293, 0.602826952500802, -93.9894409179688, -1.64042520612724, 218, 4, 'PPL', 'P'),
(56690, 'Opal', 37.021110534668, 0.646140271574714, -93.7699966430664, -1.63659518100554, 218, 29, 'PPL', 'P'),
(104955, 'Opal', 38.6208305358887, 0.674060652706023, -77.8002777099609, -1.35787100500477, 218, 53, 'PPL', 'P'),
(110766, 'Opal', 38.3866691589355, 0.669973765697188, -80.7663879394531, -1.4096393944865, 218, 58, 'PPL', 'P'),
(202461, 'Opal', 44.8916702270508, 0.783507452181546, -102.449996948242, -1.78808976540497, 218, 49, 'PPL', 'P'),
(209645, 'Opal', 41.7691688537598, 0.729009522319574, -110.32527923584, -1.92553937084754, 218, 59, 'PPL', 'P'),
(201353, 'Opal City', 44.4447212219238, 0.775706720453568, -121.212501525879, -2.11555724620524, 218, 43, 'PPL', 'P'),
(183862, 'Opal Cliffs', 36.9608306884766, 0.645088189786079, -121.96305847168, -2.12865693613317, 218, 6, 'PPL', 'P'),
(28147, 'Opdyke', 38.2597198486328, 0.667758082249269, -88.7905578613281, -1.54968757936271, 218, 18, 'PPL', 'P'),
(191986, 'Opdyke', 33.5930595397949, 0.586309494787913, -102.275001525879, -1.78503551910881, 218, 51, 'PPL', 'P'),
(191987, 'Opdyke West', 33.5922203063965, 0.586294847401917, -102.301940917969, -1.78550570019926, 218, 51, 'PPL', 'P'),
(193834, 'Opegoi (historical)', 41.2597198486328, 0.720117959809099, -123.605003356934, -2.15731428051713, 218, 6, 'PPL', 'P'),
(110767, 'Opekiska', 39.5572204589844, 0.69040373994654, -80.0558319091797, -1.39723785223832, 218, 58, 'PPL', 'P'),
(23659, 'Opeleika (historical)', 34.9755592346191, 0.610438666370412, -85.1416702270508, -1.48600247610926, 218, 13, 'PPL', 'P'),
(4790, 'Opelika', 32.6452789306641, 0.569767602572022, -85.3783264160156, -1.49013290580192, 218, 2, 'PPL', 'P'),
(96798, 'Opelika', 32.2969398498535, 0.563687938698507, -95.6741714477539, -1.66982930088086, 218, 51, 'PPL', 'P'),
(42445, 'Opelousas', 30.5333309173584, 0.532907156108885, -92.0813903808594, -1.60712344196023, 218, 22, 'PPL', 'P'),
(50108, 'Open Acres Manor', 39.4905586242676, 0.689240271445312, -76.3722229003906, -1.33294674667883, 218, 25, 'PPL', 'P'),
(104956, 'Open Fork', 37.0438919067383, 0.646537881525463, -82.3541717529297, -1.43735144984153, 218, 53, 'PPL', 'P'),
(37537, 'Open Gates', 38.0050010681152, 0.663312400862573, -84.5380630493164, -1.47546754346913, 218, 21, 'PPL', 'P'),
(17418, 'Open Sands', 30.2049999237061, 0.527176699233307, -85.857780456543, -1.49850095742112, 218, 12, 'PPL', 'P'),
(104958, 'Opequon', 39.1572189331055, 0.683422396306952, -78.246940612793, -1.36566674330571, 218, 53, 'PPL', 'P'),
(50109, 'Opequon Farms', 39.5480613708496, 0.690243883702108, -77.8397216796875, -1.35855943214656, 218, 25, 'PPL', 'P'),
(73793, 'Opera (historical)', 39.9094390869141, 0.69655111469077, -82.1627807617188, -1.43401104688625, 218, 41, 'PPL', 'P'),
(197190, 'Opheim', 48.8566703796387, 0.852709759686283, -106.406669616699, -1.85714673089321, 218, 31, 'PPL', 'P'),
(104959, 'Ophelia', 37.9099998474121, 0.661654316767889, -76.2838897705078, -1.33140504272378, 218, 53, 'PPL', 'P'),
(61180, 'Ophelia (historical)', 32.5588912963867, 0.568259853920873, -89.8166732788086, -1.56759667190322, 218, 30, 'PPL', 'P'),
(110768, 'Ophelia (historical)', 38.209171295166, 0.666875843559153, -80.7200012207031, -1.40882979351511, 218, 58, 'PPL', 'P'),
(120902, 'Ophiem', 41.252498626709, 0.719991925710511, -90.3874969482422, -1.57755942438315, 218, 18, 'PPL', 'P'),
(4792, 'Ophir', 34.3600006103516, 0.599695141637896, -85.945556640625, -1.50003294083818, 218, 2, 'PPL', 'P'),
(10990, 'Ophir', 34.4402809143066, 0.601096297266414, -93.6111068725586, -1.63382203136244, 218, 4, 'PPL', 'P'),
(23660, 'Ophir', 34.3294410705566, 0.59916177705058, -84.2649993896484, -1.47070168354038, 218, 13, 'PPL', 'P'),
(37538, 'Ophir', 37.9072189331055, 0.661605780657023, -83.0144424438477, -1.44887534735247, 218, 21, 'PPL', 'P'),
(67506, 'Ophir', 35.4777793884277, 0.619204061624244, -79.9791717529297, -1.39589988010667, 218, 33, 'PPL', 'P'),
(183865, 'Ophir', 38.8911094665527, 0.678777909944881, -121.122497558594, -2.11398638063625, 218, 6, 'PPL', 'P'),
(187136, 'Ophir', 37.8569412231445, 0.660728269077841, -107.831939697266, -1.88202238652926, 218, 7, 'PPL', 'P'),
(205232, 'Ophir', 40.3694381713867, 0.704579613270977, -112.257781982422, -1.95926790657923, 218, 52, 'PPL', 'P'),
(208338, 'Ophir', 48.209171295166, 0.841408768758586, -119.716667175293, -2.08945001172308, 218, 56, 'PPL', 'P'),
(209897, 'Ophir', 42.5633316040039, 0.742870277108027, -124.38166809082, -2.17086963730758, 218, 43, 'PPL', 'P'),
(212072, 'Ophir', 63.144718170166, 1.10208323731329, -156.519439697266, -2.731779566094, 218, 1, 'PPL', 'P'),
(190572, 'Ophir (historical)', 38.9472198486328, 0.67975722085673, -117.273063659668, -2.04680108476212, 218, 39, 'PPL', 'P'),
(197191, 'Ophir (historical)', 47.9319381713867, 0.836570137953048, -110.472221374512, -1.92810399497729, 218, 31, 'PPL', 'P'),
(190573, 'Ophir City (historical)', 39.292781829834, 0.685788415198405, -119.82527923584, -2.091345649787, 218, 39, 'PPL', 'P'),
(183866, 'Ophir Hill Acres', 39.1930618286133, 0.684047972847011, -121.039436340332, -2.11253668889687, 218, 6, 'PPL', 'P'),
(187137, 'Ophir Loop', 37.8597183227539, 0.660776738609681, -107.867782592773, -1.88264796306932, 218, 7, 'PPL', 'P'),
(104960, 'Opie', 36.7686080932617, 0.641733272602851, -78.1830596923828, -1.36455181091535, 218, 53, 'PPL', 'P'),
(210840, 'Opihikao', 19.4297199249268, 0.339112585430317, -154.883331298828, -2.70322408762174, 218, 15, 'PPL', 'P'),
(4794, 'Opine', 31.3274993896484, 0.546768010765879, -86.2872161865234, -1.50599602483498, 218, 2, 'PPL', 'P'),
(10991, 'Opitz (historical)', 34.4874992370605, 0.601920412465739, -92.6402816772461, -1.61687793524292, 218, 4, 'PPL', 'P'),
(96799, 'Oplin', 32.1386108398438, 0.560924576172413, -99.5583267211914, -1.73762059906104, 218, 51, 'PPL', 'P'),
(137284, 'Opole', 45.7466697692871, 0.798430009296615, -94.3686065673828, -1.64704289511997, 218, 28, 'PPL', 'P'),
(33501, 'Opolis', 37.3444404602051, 0.651783443345565, -94.6208267211914, -1.65144496724382, 218, 20, 'PPL', 'P'),
(17419, 'Oponys Town (historical)', 27.7833309173584, 0.484910601679041, -81.8000030517578, -1.42767938139458, 218, 12, 'PPL', 'P'),
(89686, 'Opossum', 35.7097206115723, 0.623252199639219, -89.5644378662109, -1.56319433346327, 218, 50, 'PPL', 'P'),
(89687, 'Opossum (historical)', 36.5750007629395, 0.638354187232732, -82.783332824707, -1.44484172356544, 218, 50, 'PPL', 'P'),
(89688, 'Opossum Creek Pines', 35.3058280944824, 0.616202945391834, -85.0980606079102, -1.48524134466972, 218, 50, 'PPL', 'P'),
(82778, 'Opossum Point Landing', 32.1769409179688, 0.561593562238241, -80.773063659668, -1.40975590778419, 218, 48, 'PPL', 'P'),
(4796, 'Opp', 31.2824993133545, 0.545982611270901, -86.2555618286133, -1.50544355206684, 218, 2, 'PPL', 'P'),
(10992, 'Oppelo', 35.1011085510254, 0.612629915315329, -92.7675018310547, -1.61909834580177, 218, 4, 'PPL', 'P'),
(151419, 'Oppenheim', 43.0722198486328, 0.751752052501496, -74.6930618286133, -1.303639857305, 218, 40, 'PPL', 'P'),
(165548, 'Oppenheimer', 40.1236114501953, 0.700289127596805, -78.4713897705078, -1.36958412011116, 218, 45, 'PPL', 'P'),
(73794, 'Opperman', 39.8905601501465, 0.6962216150849, -81.600830078125, -1.4242031572237, 218, 41, 'PPL', 'P'),
(165549, 'Oppermans Corner', 40.0783309936523, 0.699498834543324, -75.6344375610352, -1.32006996333413, 218, 45, 'PPL', 'P'),
(142597, 'Opportunity', 42.5961112976074, 0.743442390689204, -98.5008316040039, -1.71916382744236, 218, 35, 'PPL', 'P'),
(197192, 'Opportunity', 46.1072196960449, 0.804722792636363, -112.827217102051, -1.96920642429324, 218, 31, 'PPL', 'P'),
(208339, 'Opportunity', 47.6575012207031, 0.831780309574486, -117.238891601563, -2.04620466983599, 218, 56, 'PPL', 'P'),
(56693, 'Opportunity Farms', 38.2341690063477, 0.667312135924735, -93.4577789306641, -1.63114595394107, 218, 29, 'PPL', 'P'),
(10993, 'Opposition (historical)', 36.2286109924316, 0.632308545242143, -91.2958297729492, -1.59341282287823, 218, 4, 'PPL', 'P'),
(140644, 'Ops', 48.2277793884277, 0.841733541253521, -97.5966720581055, -1.70338326640309, 218, 34, 'PPL', 'P'),
(137285, 'Opstead', 46.2338905334473, 0.806933615815292, -93.4719390869141, -1.63139309529023, 218, 28, 'PPL', 'P'),
(191008, 'Optima', 36.7583312988281, 0.641553908703434, -101.355827331543, -1.76899290301828, 218, 42, 'PPL', 'P'),
(189170, 'Optimo', 35.8902816772461, 0.626403584736137, -104.803062438965, -1.82915850573314, 218, 38, 'PPL', 'P'),
(10994, 'Optimus', 36.0447196960449, 0.629099036654434, -92.125, -1.60788457339978, 218, 4, 'PPL', 'P'),
(165550, 'Option', 40.3463897705078, 0.704177342788321, -79.9736099243164, -1.39580280788493, 218, 45, 'PPL', 'P'),
(120904, 'Oquawka', 40.9319381713867, 0.714397090313445, -90.9469375610352, -1.58732350504576, 218, 18, 'PPL', 'P'),
(205233, 'Oquirlane', 40.6983299255371, 0.710319857263561, -112.087783813477, -1.95630087880877, 218, 52, 'PPL', 'P'),
(205257, 'Oquirrh', 40.6305618286133, 0.70913708084443, -112.033058166504, -1.95534573608381, 218, 52, 'PPL', 'P'),
(205235, 'Oquirrh Hills Office Building Condo', 40.6563911437988, 0.709587887437953, -111.985282897949, -1.95451190034651, 218, 52, 'PPL', 'P'),
(205236, 'Oquirrh Hills Subdivision', 40.7088890075684, 0.710504148010995, -112.094436645508, -1.9564169926323, 218, 52, 'PPL', 'P'),
(205237, 'Oquirrh Hills Subdivision 2-4', 40.7013893127441, 0.710373253643417, -112.098327636719, -1.9564849032401, 218, 52, 'PPL', 'P'),
(205238, 'Oquirrh Hills Subdivision 5, 6, 8 and 9', 40.6980590820313, 0.710315130152626, -112.093887329102, -1.95640740525237, 218, 52, 'PPL', 'P'),
(205239, 'Oquirrh Shadows', 40.6324996948242, 0.709170902990274, -112.013893127441, -1.9550112430509, 218, 52, 'PPL', 'P'),
(205240, 'Oquirrh View', 41.1513900756836, 0.718227248593197, -111.925277709961, -1.95346461224784, 218, 52, 'PPL', 'P'),
(128432, 'Oquossoc', 44.9663887023926, 0.784811535588331, -70.774169921875, -1.23524229050266, 218, 26, 'PPL', 'P'),
(61181, 'Ora', 31.6574993133545, 0.55252759596588, -89.5744400024414, -1.56336890367272, 218, 30, 'PPL', 'P'),
(67508, 'Ora', 35.3066711425781, 0.616217659356857, -81.583610534668, -1.42390261949469, 218, 33, 'PPL', 'P'),
(82779, 'Ora', 34.5816688537598, 0.603563982332481, -81.9958267211914, -1.43109714917954, 218, 48, 'PPL', 'P'),
(96800, 'Ora', 31.2772197723389, 0.545890465897184, -94.4274978637695, -1.64807074214269, 218, 51, 'PPL', 'P'),
(123373, 'Ora', 41.1738891601563, 0.718619931695929, -86.5530624389648, -1.51063591724417, 218, 19, 'PPL', 'P'),
(183867, 'Ora', 36.1513900756836, 0.630960785993481, -120.325561523438, -2.10007722289499, 218, 6, 'PPL', 'P'),
(195415, 'Ora', 44.086109161377, 0.769447759259664, -111.532501220703, -1.94660936928586, 218, 17, 'PPL', 'P'),
(178753, 'Oracle', 32.6108283996582, 0.569166327376909, -110.770278930664, -1.93330608069259, 218, 5, 'PPL', 'P'),
(178754, 'Oracle Foothills Estates', 32.2997207641602, 0.563736474809374, -110.952781677246, -1.93649135451438, 218, 5, 'PPL', 'P'),
(178755, 'Oracle Junction', 32.5550003051758, 0.568191943313076, -110.932777404785, -1.93614221409547, 218, 5, 'PPL', 'P'),
(178756, 'Oracle Place Shopping Center', 32.3363914489746, 0.564376498998347, -110.976387023926, -1.93690334553502, 218, 5, 'PPL', 'P'),
(145966, 'Oradell', 40.958610534668, 0.714862610871991, -74.0372161865234, -1.29219319146567, 218, 37, 'PPL', 'P'),
(199579, 'Orafino', 40.4972190856934, 0.706809810946837, -100.228607177734, -1.74931919993949, 218, 35, 'PPL', 'P'),
(178757, 'Oraibi', 35.8763885498047, 0.626161103918885, -110.639717102051, -1.93102734690587, 218, 5, 'PPL', 'P'),
(89689, 'Oral', 35.8333282470703, 0.625409559859265, -84.3563919067383, -1.47229678387528, 218, 50, 'PPL', 'P'),
(202462, 'Oral', 43.4049987792969, 0.75756014052285, -103.268608093262, -1.80237722517908, 218, 49, 'PPL', 'P'),
(110769, 'Oral Lake', 39.2752799987793, 0.685482950621373, -80.2158279418945, -1.40003030979933, 218, 58, 'PPL', 'P'),
(104962, 'Oral Oaks', 36.9150009155273, 0.644288309352673, -78.1961135864258, -1.3647796443466, 218, 53, 'PPL', 'P'),
(117133, 'Oralabor', 41.7000007629395, 0.727802311397441, -93.5877838134766, -1.63341496718982, 218, 16, 'PPL', 'P'),
(151421, 'Oramel', 42.3661117553711, 0.7394281413991, -78.1358337402344, -1.36372756255797, 218, 40, 'PPL', 'P'),
(23682, 'Oran', 34.7930603027344, 0.60725345912765, -84.7675018310547, -1.47947200564223, 218, 13, 'PPL', 'P'),
(56691, 'Oran', 37.0849990844727, 0.647255337123131, -89.6552810668945, -1.56477984641824, 218, 29, 'PPL', 'P'),
(96801, 'Oran', 32.9625015258789, 0.575304181320242, -98.1594390869141, -1.71320540397747, 218, 51, 'PPL', 'P'),
(113007, 'Oran', 42.7013893127441, 0.745279838683304, -92.0744400024414, -1.60700213497258, 218, 16, 'PPL', 'P'),
(151422, 'Oran', 42.9780616760254, 0.750108682371836, -75.9333267211914, -1.32528656327738, 218, 40, 'PPL', 'P'),
(156945, 'Oran', 40.2911109924316, 0.703212546104412, -84.3216705322266, -1.47169078156923, 218, 41, 'PPL', 'P'),
(104969, 'Oranda', 39.0275001525879, 0.681158376485248, -78.333610534668, -1.36717941880487, 218, 53, 'PPL', 'P'),
(104963, 'Orander Park', 37.2336082458496, 0.649849056287786, -80.0250015258789, -1.39669976054007, 218, 53, 'PPL', 'P'),
(4797, 'Orange', 34.3574981689453, 0.599651465796019, -87.5533294677734, -1.52809387029602, 218, 2, 'PPL', 'P'),
(17420, 'Orange', 30.2275009155273, 0.527569415625552, -85.0250015258789, -1.48396622313979, 218, 12, 'PPL', 'P'),
(23661, 'Orange', 34.2555618286133, 0.597872341029791, -84.3413925170898, -1.47203499514013, 218, 13, 'PPL', 'P'),
(28149, 'Orange', 39.2066688537598, 0.684285460237219, -87.8213882446289, -1.53277237854102, 218, 18, 'PPL', 'P'),
(30741, 'Orange', 39.584171295166, 0.690874120774075, -85.2991714477539, -1.48875139098644, 218, 19, 'PPL', 'P'),
(56692, 'Orange', 37.0449981689453, 0.646557189443366, -93.716667175293, -1.63566440620456, 218, 29, 'PPL', 'P'),
(61183, 'Orange', 32.0950012207031, 0.560163444732869, -88.9205627441406, -1.55195659261146, 218, 30, 'PPL', 'P'),
(67509, 'Orange', 35.1294403076172, 0.61312439775073, -78.5224990844727, -1.37047614591828, 218, 33, 'PPL', 'P'),
(96802, 'Orange', 30.0927791595459, 0.525218077409608, -93.7363891601563, -1.63600861977545, 218, 51, 'PPL', 'P'),
(104964, 'Orange', 38.2452812194824, 0.66750608063112, -78.1111068725586, -1.36329599730332, 218, 53, 'PPL', 'P'),
(113871, 'Orange', 41.2783317565918, 0.720442798883061, -73.0261077880859, -1.27454602081837, 218, 8, 'PPL', 'P'),
(117135, 'Orange', 42.4258308410645, 0.74047043607073, -92.3563919067383, -1.61192312403483, 218, 16, 'PPL', 'P'),
(125744, 'Orange', 42.5902786254883, 0.743340591356535, -72.3102798461914, -1.26205246635454, 218, 23, 'PPL', 'P'),
(144276, 'Orange', 43.6544418334961, 0.761913743114857, -71.9719390869141, -1.25614730611145, 218, 36, 'PPL', 'P'),
(145968, 'Orange', 40.7705612182617, 0.711580531144577, -74.2330627441406, -1.29561135872479, 218, 37, 'PPL', 'P'),
(156948, 'Orange', 40.1741714477539, 0.701171566024003, -83.008056640625, -1.44876389406085, 218, 41, 'PPL', 'P'),
(165551, 'Orange', 41.3886108398438, 0.722367531981889, -75.8938903808594, -1.32459826929365, 218, 45, 'PPL', 'P'),
(172370, 'Orange', 44.1483306884766, 0.770533729773171, -72.4030609130859, -1.26367180145536, 218, 55, 'PPL', 'P'),
(183868, 'Orange', 33.7877807617188, 0.58970802123399, -117.85221862793, -2.05690924583757, 218, 6, 'PPL', 'P'),
(189171, 'Orange', 31.8608303070068, 0.556076391276465, -106.635559082031, -1.86114160568639, 218, 38, 'PPL', 'P'),
(96803, 'Orange Acres Colonia', 27.9409999847412, 0.48766244603342, -97.9420013427734, -1.7094103994241, 218, 51, 'PPL', 'P'),
(183869, 'Orange Avenue Junction', 34.0924987792969, 0.595026353930878, -117.942222595215, -2.05848011140655, 218, 6, 'PPL', 'P'),
(4798, 'Orange Beach', 30.2941703796387, 0.528733017284835, -87.5736083984375, -1.52844780440489, 218, 2, 'PPL', 'P'),
(17421, 'Orange Bend', 28.8608303070068, 0.503716513716635, -81.7988891601563, -1.42765994031863, 218, 12, 'PPL', 'P'),
(17422, 'Orange Blossom', 28.687780380249, 0.500696222724376, -81.7866668701172, -1.42744662111531, 218, 12, 'PPL', 'P'),
(96804, 'Orange Blossom Estates Colonia', 27.9500007629395, 0.487819539248221, -97.9619979858398, -1.70975940668496, 218, 51, 'PPL', 'P'),
(17423, 'Orange Blossom Gardens Mobile Home Park (historical)', 28.9466705322266, 0.505214708277373, -81.9477767944336, -1.43025851975227, 218, 12, 'PPL', 'P'),
(17424, 'Orange Blossom Hills', 28.9950008392334, 0.506058231263142, -82.0008316040039, -1.43118450086329, 218, 12, 'PPL', 'P'),
(17425, 'Orange Blossom Hills South', 28.9280605316162, 0.504889902492924, -81.9483337402344, -1.43026824029025, 218, 12, 'PPL', 'P'),
(156949, 'Orange Center', 41.4619407653809, 0.723647380622754, -81.4383316040039, -1.42136702382082, 218, 41, 'PPL', 'P'),
(17426, 'Orange City', 28.9486103057861, 0.505248563712731, -81.2988891601563, -1.41893329405865, 218, 12, 'PPL', 'P'),
(117136, 'Orange City', 43.0072212219238, 0.75061761245615, -96.0580596923828, -1.67652941470933, 218, 16, 'PPL', 'P'),
(17427, 'Orange City Hills', 28.9286098480225, 0.504899489872848, -81.29638671875, -1.41888961821678, 218, 12, 'PPL', 'P'),
(183871, 'Orange Cove', 36.624439239502, 0.639217051425917, -119.312782287598, -2.08240089063375, 218, 6, 'PPL', 'P'),
(67511, 'Orange Factory', 36.1272201538086, 0.630538941276812, -78.8758316040039, -1.37664296173847, 218, 33, 'PPL', 'P'),
(61185, 'Orange Grove', 30.420560836792, 0.530938946905262, -88.458610534668, -1.5438940055693, 218, 30, 'PPL', 'P'),
(67512, 'Orange Grove', 35.975830078125, 0.62789668600129, -79.1941680908203, -1.38219898156265, 218, 33, 'PPL', 'P'),
(82780, 'Orange Grove', 32.4002799987793, 0.565491564546763, -80.6622161865234, -1.4078212544103, 218, 48, 'PPL', 'P'),
(96805, 'Orange Grove', 27.9563903808594, 0.487931059118868, -97.9366683959961, -1.70931732194401, 218, 51, 'PPL', 'P'),
(50111, 'Orange Grove (historical)', 39.2427787780762, 0.684915697309186, -76.751106262207, -1.33955950882355, 218, 25, 'PPL', 'P'),
(178758, 'Orange Grove Estates', 32.3211097717285, 0.564109783415175, -111.040000915527, -1.93801361739347, 218, 5, 'PPL', 'P'),
(42446, 'Orange Grove Plantation', 29.8488903045654, 0.52096141388128, -90.811393737793, -1.58495781904945, 218, 22, 'PPL', 'P'),
(96806, 'Orange Grove Villa Colonia', 27.9650001525879, 0.488081327983375, -97.927001953125, -1.70914861068895, 218, 51, 'PPL', 'P'),
(17429, 'Orange Grove Villas', 28.2863903045654, 0.493690644318868, -82.188606262207, -1.43446178690074, 218, 12, 'PPL', 'P'),
(17430, 'Orange Heights', 29.7194404602051, 0.518702087880997, -82.1394424438477, -1.43360371639752, 218, 12, 'PPL', 'P'),
(17431, 'Orange Home', 28.8291702270508, 0.503163941079957, -81.9958267211914, -1.43109714917954, 218, 12, 'PPL', 'P'),
(17432, 'Orange Lake', 29.4233303070068, 0.513533990759103, -82.2169418334961, -1.43495633591517, 218, 12, 'PPL', 'P'),
(151424, 'Orange Lake', 41.5397186279297, 0.725004860409394, -74.0986099243164, -1.29326471433027, 218, 40, 'PPL', 'P'),
(175695, 'Orange Mill', 43.901668548584, 0.766228663292031, -90.2322235107422, -1.57484939165789, 218, 57, 'PPL', 'P'),
(17433, 'Orange Mills', 29.6847190856934, 0.51809608557495, -81.5733337402344, -1.42372325559527, 218, 12, 'PPL', 'P'),
(17434, 'Orange Mountain', 28.5027809143066, 0.497467372929251, -81.7200012207031, -1.42628308603505, 218, 12, 'PPL', 'P'),
(17435, 'Orange Park', 30.1658306121826, 0.526493065781483, -81.706672668457, -1.42605045891384, 218, 12, 'PPL', 'P'),
(183873, 'Orange Park Acres', 33.8019409179688, 0.589955162583149, -117.781387329102, -2.05567300645955, 218, 6, 'PPL', 'P'),
(120907, 'Orange Prairie', 40.7775001525879, 0.711701638395149, -89.6697235107422, -1.56503191461542, 218, 18, 'PPL', 'P'),
(23662, 'Orange Springs', 30.8319396972656, 0.538118862493629, -84.3102798461914, -1.47149197659386, 218, 13, 'PPL', 'P'),
(112894, 'Orange Springs', 29.5058307647705, 0.514973895381482, -81.945556640625, -1.43021977075841, 218, 12, 'PPL', 'P'),
(17436, 'Orange Terrace', 27.8527793884277, 0.486122706159677, -82.8333282470703, -1.4457143082966, 218, 12, 'PPL', 'P'),
(96807, 'Orange Valley Estates Colonia', 27.9979991912842, 0.488657269858619, -97.9550018310547, -1.70963730074898, 218, 51, 'PPL', 'P'),
(82782, 'Orangeburg', 33.4916687011719, 0.584539890822582, -80.855827331543, -1.41120040635945, 218, 48, 'PPL', 'P'),
(112349, 'Orangeburg', 38.5675010681152, 0.673129877905041, -83.6888885498047, -1.46064665252867, 218, 21, 'PPL', 'P'),
(151426, 'Orangeburg', 41.0463905334473, 0.716394660868086, -73.9499969482422, -1.29067092858658, 218, 40, 'PPL', 'P'),
(73796, 'Orangeburg (historical)', 39.8386116027832, 0.695314941891782, -84.746940612793, -1.47911314468534, 218, 41, 'PPL', 'P'),
(17438, 'Orangedale', 30.0083293914795, 0.523744150904304, -81.6133270263672, -1.42442127011698, 218, 12, 'PPL', 'P'),
(96808, 'Orangedale', 28.4391708374023, 0.496357167649824, -97.8258285522461, -1.70738280172817, 218, 51, 'PPL', 'P'),
(104966, 'Orangedale', 38.6691703796387, 0.67490434213936, -77.3913879394531, -1.35073453223169, 218, 53, 'PPL', 'P'),
(96809, 'Orangefield', 30.0747203826904, 0.524902892294597, -93.8555603027344, -1.6380885485868, 218, 51, 'PPL', 'P'),
(120909, 'Orangemans Hall', 41.3136100769043, 0.721058521727088, -90.6080627441406, -1.58140902373886, 218, 18, 'PPL', 'P'),
(151427, 'Orangeport', 43.1983299255371, 0.753953088563419, -78.5961074829102, -1.37176085482814, 218, 40, 'PPL', 'P'),
(17439, 'Orangetree', 26.2924995422363, 0.458890685591126, -81.5886077880859, -1.42398983802039, 218, 12, 'PPL', 'P'),
(178759, 'Orangetree', 33.3369407653809, 0.581839378898214, -111.894439697266, -1.95292638739153, 218, 5, 'PPL', 'P'),
(178760, 'Orangetree Estates', 33.5863914489746, 0.586193114648276, -111.964172363281, -1.9541434520097, 218, 5, 'PPL', 'P'),
(183876, 'Orangevale', 38.6786117553711, 0.675069125231809, -121.224716186523, -2.1157704322505, 218, 6, 'PPL', 'P'),
(50112, 'Orangeville', 39.2986106872559, 0.685890147952046, -76.5500030517578, -1.33604959566488, 218, 25, 'PPL', 'P'),
(61186, 'Orangeville', 32.4716682434082, 0.566737524462757, -90.4794387817383, -1.57916411209798, 218, 30, 'PPL', 'P'),
(96810, 'Orangeville', 33.478328704834, 0.584307063964282, -96.3394393920898, -1.68144041691749, 218, 51, 'PPL', 'P'),
(120910, 'Orangeville', 42.4683303833008, 0.741212193013344, -89.6438903808594, -1.56458104144287, 218, 18, 'PPL', 'P'),
(123367, 'Orangeville', 41.3358306884766, 0.72144634456083, -84.8569412231445, -1.48103301751518, 218, 19, 'PPL', 'P'),
(132444, 'Orangeville', 42.5527801513672, 0.742686119518648, -85.519172668457, -1.49259113664612, 218, 27, 'PPL', 'P'),
(156956, 'Orangeville', 41.339168548584, 0.721504601209676, -80.519172668457, -1.4053246740464, 218, 41, 'PPL', 'P'),
(165553, 'Orangeville', 41.0780601501465, 0.716947399952332, -76.4147186279297, -1.33368843704242, 218, 45, 'PPL', 'P'),
(192735, 'Orangeville', 39.2272186279297, 0.684644121457025, -111.052780151367, -1.93823665713476, 218, 52, 'PPL', 'P'),
(151429, 'Orangeville Center', 42.7502784729004, 0.746133115496565, -78.2486114501953, -1.36569590491964, 218, 40, 'PPL', 'P'),
(178761, 'Orangewood Village Mobilehome Park', 33.6566696166992, 0.587419700067339, -112.11833190918, -1.95683404365901, 218, 5, 'PPL', 'P'),
(104967, 'Orapax Farms', 37.5336112976074, 0.655085097306991, -77.2058334350586, -1.3474959951881, 218, 53, 'PPL', 'P'),
(96811, 'Orason Acres Colonia', 26.0769996643066, 0.455129503183607, -97.443000793457, -1.70070119686927, 218, 51, 'PPL', 'P'),
(28151, 'Oraville', 37.8650016784668, 0.660868950562425, -89.3833312988281, -1.56003342756545, 218, 18, 'PPL', 'P'),
(50113, 'Oraville', 38.417781829834, 0.670516784243455, -76.6944427490234, -1.33857054395275, 218, 25, 'PPL', 'P'),
(165555, 'Orbisonia', 40.2427787780762, 0.70236898982913, -77.8933334350586, -1.35949513379556, 218, 45, 'PPL', 'P'),
(73797, 'Orbiston', 39.4855613708496, 0.689153052919611, -82.1686096191406, -1.43411277963989, 218, 41, 'PPL', 'P'),
(212073, 'Orca', 60.5722198486328, 1.0571846716005, -145.699996948242, -2.54294466689252, 218, 1, 'PPL', 'P'),
(208340, 'Orcas', 48.5980606079102, 0.848196167691789, -122.943328857422, -2.14576588192417, 218, 56, 'PPL', 'P'),
(183877, 'Orchams', 34.4755592346191, 0.60171202011044, -119.883888244629, -2.0923685699617, 218, 6, 'PPL', 'P'),
(4799, 'Orchard', 30.7194404602051, 0.536155380400941, -88.2072219848633, -1.53950644767339, 218, 2, 'PPL', 'P'),
(42447, 'Orchard', 29.2686100006104, 0.51083361199279, -89.3544387817383, -1.55952915801304, 218, 22, 'PPL', 'P'),
(96812, 'Orchard', 29.603889465332, 0.516685342566508, -95.9694366455078, -1.67498265074821, 218, 51, 'PPL', 'P'),
(117140, 'Orchard', 43.2275009155273, 0.754462218384815, -92.7719421386719, -1.61917584378949, 218, 16, 'PPL', 'P'),
(142598, 'Orchard', 42.3355598449707, 0.738894909969839, -98.2425003051758, -1.71465509571685, 218, 35, 'PPL', 'P'),
(183878, 'Orchard', 38.336109161377, 0.66909132726999, -122.77278137207, -2.14278926677379, 218, 6, 'PPL', 'P'),
(194357, 'Orchard', 40.3311080932617, 0.703910627205149, -104.117782592773, -1.81719811611954, 218, 7, 'PPL', 'P'),
(195416, 'Orchard', 43.3147201538086, 0.755984481263905, -116.025283813477, -2.02502321810605, 218, 17, 'PPL', 'P'),
(10995, 'Orchard (historical)', 34.9319381713867, 0.609677335193786, -92.6769409179688, -1.61751775969481, 218, 4, 'PPL', 'P'),
(78, 'Orchard Acres', 34.9080581665039, 0.609260550483188, -82.3225021362305, -1.43679871075729, 218, 48, 'PPL', 'P'),
(14354, 'Orchard Acres', 39.0327796936035, 0.681250521858965, -75.5447235107422, -1.31850415777122, 218, 10, 'PPL', 'P'),
(104968, 'Orchard Acres', 38.0733299255371, 0.66450496439871, -78.7130584716797, -1.37380203464563, 218, 53, 'PPL', 'P'),
(208341, 'Orchard Avenue', 47.6816711425781, 0.832202154291155, -117.302780151367, -2.04731973538441, 218, 56, 'PPL', 'P'),
(50114, 'Orchard Beach', 39.1705589294434, 0.683655223165252, -76.5269393920898, -1.33564705886612, 218, 25, 'PPL', 'P'),
(132447, 'Orchard Beach', 45.5569381713867, 0.795118568218183, -84.4644393920898, -1.47418256824317, 218, 27, 'PPL', 'P'),
(156959, 'Orchard Beach', 41.4063911437988, 0.72267785682791, -82.4094390869141, -1.43831604678836, 218, 41, 'PPL', 'P'),
(165557, 'Orchard Beach', 42.2413902282715, 0.737251340103097, -79.8288879394531, -1.39327693274905, 218, 45, 'PPL', 'P'),
(71219, 'Orchard Center', 39.4769401550293, 0.689002584318022, -75.2177810668945, -1.31279793566156, 218, 37, 'PPL', 'P'),
(187140, 'Orchard City', 38.8283309936523, 0.677682218893395, -107.970283508301, -1.88443694153158, 218, 7, 'PPL', 'P'),
(205243, 'Orchard Corners Condominium', 40.8461112976074, 0.712899128779303, -111.900001525879, -1.95302345961327, 218, 52, 'PPL', 'P'),
(205244, 'Orchard Country Woods Condo', 40.6191711425781, 0.708938275869055, -111.859718322754, -1.95232038508548, 218, 52, 'PPL', 'P'),
(104970, 'Orchard Court', 37.2702789306641, 0.650489080476759, -80.0416717529297, -1.39699071088916, 218, 53, 'PPL', 'P'),
(165558, 'Orchard Courts', 40.1833305358887, 0.701331422268435, -75.5216674804688, -1.31810175413051, 218, 45, 'PPL', 'P'),
(165559, 'Orchard Crest', 40.214168548584, 0.70186964712474, -76.9863891601563, -1.3436659700664, 218, 45, 'PPL', 'P'),
(50115, 'Orchard Estates', 39.6722183227539, 0.692410831302078, -77.5977783203125, -1.35433672392213, 218, 25, 'PPL', 'P'),
(145969, 'Orchard Estates', 40.2833290100098, 0.703076724888818, -74.2472229003906, -1.29585850007395, 218, 37, 'PPL', 'P'),
(56694, 'Orchard Farm', 38.8786087036133, 0.678559730472576, -90.4461135864258, -1.57858247771591, 218, 29, 'PPL', 'P'),
(137320, 'Orchard Garden', 44.7255592346191, 0.780608268439859, -93.2958297729492, -1.62831940791812, 218, 28, 'PPL', 'P'),
(104971, 'Orchard Gardens', 37.6327781677246, 0.656815885699433, -77.2819366455078, -1.34882424678177, 218, 53, 'PPL', 'P'),
(50116, 'Orchard Gate At Piney Orchard', 39.0736083984375, 0.681963117187643, -76.7125015258789, -1.33888572906776, 218, 25, 'PPL', 'P'),
(37539, 'Orchard Grass Hills', 38.3236083984375, 0.668873147797685, -85.5213928222656, -1.49262988563998, 218, 21, 'PPL', 'P'),
(123368, 'Orchard Grove', 41.2897186279297, 0.720641537279409, -87.3536071777344, -1.52460805874522, 218, 19, 'PPL', 'P'),
(175697, 'Orchard Grove', 43.4983291625977, 0.759189063003597, -88.1408309936523, -1.5383477062831, 218, 57, 'PPL', 'P'),
(208342, 'Orchard Grove', 47.3894386291504, 0.827101734750462, -122.021942138672, -2.12968464999784, 218, 56, 'PPL', 'P'),
(104972, 'Orchard Heights', 37.2680587768555, 0.650450331482899, -80.045280456543, -1.39705369464894, 218, 53, 'PPL', 'P'),
(145970, 'Orchard Heights', 40.436939239502, 0.705757729158201, -74.4033279418945, -1.29858304702716, 218, 37, 'PPL', 'P'),
(208343, 'Orchard Heights', 47.5305595397949, 0.829564759284622, -122.597778320313, -2.13973488731958, 218, 56, 'PPL', 'P'),
(123369, 'Orchard Heights Addition', 41.6016693115234, 0.726086103811967, -86.2397232055664, -1.50516711594569, 218, 19, 'PPL', 'P'),
(123370, 'Orchard Highlands', 41.6827812194824, 0.727501773668425, -86.8358306884766, -1.51557115421825, 218, 19, 'PPL', 'P'),
(23663, 'Orchard Hill', 33.1863899230957, 0.579211771008688, -84.2113876342773, -1.46976598189138, 218, 13, 'PPL', 'P'),
(50117, 'Orchard Hill', 39.2194404602051, 0.684508366820459, -76.0972213745117, -1.32814706460423, 218, 25, 'PPL', 'P'),
(82789, 'Orchard Hill', 33.0252799987793, 0.576399872371728, -80.2227783203125, -1.40015161678698, 218, 48, 'PPL', 'P'),
(165560, 'Orchard Hill', 40.1469383239746, 0.700696258348451, -79.5286102294922, -1.38803609803988, 218, 45, 'PPL', 'P'),
(23665, 'Orchard Hills', 34.9500007629395, 0.609992586887824, -85.2880630493164, -1.48855751285909, 218, 13, 'PPL', 'P'),
(50119, 'Orchard Hills', 39.6888885498047, 0.692701781651169, -77.7255630493164, -1.35656698817702, 218, 25, 'PPL', 'P'),
(67514, 'Orchard Hills', 35.6130599975586, 0.621565153667681, -80.5019378662109, -1.40502387000128, 218, 33, 'PPL', 'P'),
(165561, 'Orchard Hills', 40.586109161377, 0.708361235439862, -79.5316696166992, -1.38808949441974, 218, 45, 'PPL', 'P'),
(125746, 'Orchard Hills Estates', 42.1072196960449, 0.73490962255659, -71.8372192382813, -1.25379600118502, 218, 23, 'PPL', 'P'),
(197194, 'Orchard Hills Mobile Home Park', 48.0061111450195, 0.837864700558936, -114.061668395996, -1.99075166382809, 218, 31, 'PPL', 'P'),
(197193, 'Orchard Homes', 46.8633308410645, 0.817919421627978, -114.047500610352, -1.99050438932088, 218, 31, 'PPL', 'P'),
(195417, 'Orchard Homes (historical)', 46.5966682434082, 0.813265281306956, -116.728889465332, -2.03730345336657, 218, 17, 'PPL', 'P'),
(96815, 'Orchard Homes Addition Number 2 Colonia', 26.0909996032715, 0.455373848213622, -97.963996887207, -1.70979429409524, 218, 51, 'PPL', 'P'),
(156961, 'Orchard Island', 40.4797210693359, 0.706504412948832, -83.8852767944336, -1.46407427400966, 218, 41, 'PPL', 'P'),
(89692, 'Orchard Knob', 35.0397186279297, 0.611558459029763, -85.2780609130859, -1.48838294264963, 218, 50, 'PPL', 'P'),
(151431, 'Orchard Knoll', 42.1508293151855, 0.735670753996134, -76.8005599975586, -1.34042263933285, 218, 40, 'PPL', 'P'),
(132448, 'Orchard Lake', 42.5830612182617, 0.743214623836975, -83.3594436645508, -1.45489675457714, 218, 27, 'PPL', 'P'),
(50120, 'Orchard Lakes', 39.5341682434082, 0.690001402884856, -76.4833297729492, -1.33488592742657, 218, 25, 'PPL', 'P'),
(117141, 'Orchard Lane Mobile Home Court', 42.4916687011719, 0.741619523502072, -91.4680633544922, -1.59641886595866, 218, 16, 'PPL', 'P'),
(183879, 'Orchard Lane Mobile Home Park', 36.9866714477539, 0.645539196116684, -121.944442749023, -2.12833203048018, 218, 6, 'PPL', 'P'),
(14355, 'Orchard Manor', 38.5997200012207, 0.673692204369211, -75.1797180175781, -1.31213361012764, 218, 10, 'PPL', 'P'),
(187138, 'Orchard Mesa', 39.0430603027344, 0.681429952337409, -108.551666259766, -1.89458398475895, 218, 7, 'PPL', 'P'),
(23667, 'Orchard Park', 33.6708297729492, 0.587666841416499, -84.7727813720703, -1.47956415101594, 218, 13, 'PPL', 'P'),
(30742, 'Orchard Park', 39.9375, 0.697040870015235, -86.129997253418, -1.50325203680582, 218, 19, 'PPL', 'P'),
(33505, 'Orchard Park', 37.3583297729492, 0.65202585758379, -95.2758331298828, -1.66287698569715, 218, 20, 'PPL', 'P'),
(82786, 'Orchard Park', 34.8541717529297, 0.608320055144227, -82.3236083984375, -1.43681801867519, 218, 48, 'PPL', 'P'),
(132450, 'Orchard Park', 42.3408317565918, 0.738986922185501, -85.1855621337891, -1.48676853439683, 218, 27, 'PPL', 'P'),
(151435, 'Orchard Park', 42.7675018310547, 0.746433719804608, -78.7441711425781, -1.37434505319189, 218, 40, 'PPL', 'P'),
(187139, 'Orchard Park', 38.4722213745117, 0.671466933541368, -105.227783203125, -1.83657128146932, 218, 7, 'PPL', 'P'),
(208344, 'Orchard Park', 47.6755599975586, 0.832095494689497, -117.324172973633, -2.04769311056924, 218, 56, 'PPL', 'P'),
(205252, 'Orchard Park Estates Subdivision Number One and Two', 41.2388916015625, 0.719754438320303, -111.946113586426, -1.95382826689469, 218, 52, 'PPL', 'P'),
(117142, 'Orchard Park Mobile Home Court', 43.1450004577637, 0.753022313762437, -93.3727798461914, -1.62966244005584, 218, 16, 'PPL', 'P'),
(205253, 'Orchard Park Subdivision Number 3-7', 41.2388916015625, 0.719754438320303, -111.942497253418, -1.95376514997685, 218, 52, 'PPL', 'P'),
(189172, 'Orchard Place', 34.6927795410156, 0.60550322965925, -107.476387023926, -1.87581682171521, 218, 38, 'PPL', 'P'),
(132451, 'Orchard Point', 45.2158317565918, 0.789165138180338, -83.495002746582, -1.45726270688957, 218, 27, 'PPL', 'P'),
(50122, 'Orchard Point At Piney Orchard', 39.0688896179199, 0.681880758930932, -76.7083282470703, -1.33881289161195, 218, 25, 'PPL', 'P'),
(208345, 'Orchard Prairie', 47.7319412231445, 0.833079532712282, -117.313331604004, -2.04750389297379, 218, 56, 'PPL', 'P'),
(151433, 'Orchard Terrace', 42.1947212219238, 0.736436812283696, -79.4580612182617, -1.38680478550988, 218, 40, 'PPL', 'P'),
(165562, 'Orchard Terrace', 40.1699981689453, 0.701098728568189, -76.9805603027344, -1.34356423731276, 218, 45, 'PPL', 'P'),
(209646, 'Orchard Valley', 41.0966682434082, 0.717272172447268, -104.818893432617, -1.82943480869623, 218, 59, 'PPL', 'P'),
(89690, 'Orchard Valley Estates', 35.9655609130859, 0.627717455259928, -84.4191665649414, -1.47339240834774, 218, 50, 'PPL', 'P'),
(50126, 'Orchard View', 39.0327796936035, 0.681250521858965, -76.0350036621094, -1.32706116066975, 218, 25, 'PPL', 'P'),
(89691, 'Orchard View', 35.9949989318848, 0.628231245613231, -84.3772201538086, -1.47266030536408, 218, 50, 'PPL', 'P'),
(145971, 'Orchard View', 40.0658302307129, 0.699280655071019, -74.8744430541992, -1.30680555689278, 218, 37, 'PPL', 'P'),
(156962, 'Orchard View', 41.5958290100098, 0.725984171321244, -83.4241714477539, -1.45602646751155, 218, 41, 'PPL', 'P'),
(151434, 'Orchard Village', 43.042781829834, 0.751238262148193, -76.2813873291016, -1.33136136688191, 218, 40, 'PPL', 'P'),
(208346, 'Orchards', 45.6666717529297, 0.797033780516114, -122.559722900391, -2.13907069494371, 218, 56, 'PPL', 'P'),
(50129, 'Orchards of Linthicum', 39.2069396972656, 0.684290187348154, -76.6552810668945, -1.33788704365898, 218, 25, 'PPL', 'P'),
(50127, 'Orchardview Estates', 39.5561103820801, 0.69038436544961, -76.1372222900391, -1.328845212284, 218, 25, 'PPL', 'P'),
(28153, 'Orchardville', 38.5063896179199, 0.672063281888464, -88.6502838134766, -1.5472393353726, 218, 18, 'PPL', 'P'),
(17440, 'Orchid', 27.7724990844727, 0.484721550531159, -80.4172210693359, -1.40354528296407, 218, 12, 'PPL', 'P'),
(56695, 'Orchid', 39.9516716003418, 0.697288211101476, -94.5294418334961, -1.64985000006697, 218, 29, 'PPL', 'P'),
(104974, 'Orchid', 37.8288917541504, 0.660238713490458, -77.8955612182617, -1.35953401594747, 218, 53, 'PPL', 'P'),
(210844, 'Orchidlands Estates', 19.5633296966553, 0.341444515859818, -155.016937255859, -2.70555595147221, 218, 15, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(183880, 'Orcutt', 34.8652801513672, 0.608513933271584, -120.434997558594, -2.10198724202879, 218, 6, 'PPL', 'P'),
(113873, 'Orcutts', 41.9766693115234, 0.732631088506945, -72.3222198486328, -1.26226085870984, 218, 8, 'PPL', 'P'),
(76837, 'Ord', 33.9099998474121, 0.591841146688116, -95.4991683959961, -1.66677492142664, 218, 42, 'PPL', 'P'),
(117143, 'Ord', 41.2511100769043, 0.719967690944591, -94.0708312988281, -1.64184573625268, 218, 16, 'PPL', 'P'),
(142599, 'Ord', 41.603328704834, 0.726115065688821, -98.9258270263672, -1.7265813968685, 218, 35, 'PPL', 'P'),
(183881, 'Ordbend', 39.6297187805176, 0.691669074359464, -122.004440307617, -2.1293791854208, 218, 6, 'PPL', 'P'),
(192736, 'Orderville', 37.2758293151855, 0.650585952961411, -112.636940002441, -1.96588546241391, 218, 52, 'PPL', 'P'),
(37540, 'Ordinary', 38.1547203063965, 0.665925494524158, -83.1947174072266, -1.45202173902234, 218, 21, 'PPL', 'P'),
(104975, 'Ordinary', 37.3152809143066, 0.651274513261251, -76.5136108398438, -1.3354144317449, 218, 53, 'PPL', 'P'),
(71220, 'Ordmont', 39.7408294677734, 0.693608321686232, -75.4588928222656, -1.31700612965805, 218, 37, 'PPL', 'P'),
(104976, 'Ordsburg', 36.9502792358398, 0.6449040321967, -77.8755569458008, -1.35918487552856, 218, 53, 'PPL', 'P'),
(171015, 'Ordway', 45.5786094665527, 0.795496803672001, -98.4116668701172, -1.71760760925937, 218, 49, 'PPL', 'P'),
(183882, 'Ordway', 34.0041694641113, 0.593484716554858, -117.166938781738, -2.04494885622397, 218, 6, 'PPL', 'P'),
(187141, 'Ordway', 38.2180595397949, 0.66703097269265, -103.755561828613, -1.81087617116585, 218, 7, 'PPL', 'P'),
(56696, 'Ore', 38.7277793884277, 0.67592726231406, -94.3338928222656, -1.64643702597198, 218, 29, 'PPL', 'P'),
(96814, 'Ore City', 32.7999992370605, 0.572467981338335, -94.7205581665039, -1.6531856093323, 218, 51, 'PPL', 'P'),
(113874, 'Ore Hill', 41.957218170166, 0.732291602046987, -73.4674987792969, -1.28224974690365, 218, 8, 'PPL', 'P'),
(165563, 'Ore Hill', 40.2936096191406, 0.703256155367262, -78.4011077880859, -1.36835746811307, 218, 45, 'PPL', 'P'),
(67525, 'Ore Knob', 36.4002799987793, 0.635304734626536, -81.3294372558594, -1.41946645890889, 218, 33, 'PPL', 'P'),
(89693, 'Ore Springs', 36.2947196960449, 0.633462359784419, -88.5780563354492, -1.54597872807061, 218, 50, 'PPL', 'P'),
(78891, 'Ore Valley', 39.9313888549805, 0.696934210413578, -76.6575012207031, -1.33792579265284, 218, 45, 'PPL', 'P'),
(193835, 'Ore''q (historical)', 41.2861099243164, 0.720578553519628, -124.059722900391, -2.16525063372363, 218, 6, 'PPL', 'P'),
(28154, 'Oreana', 39.9386100769043, 0.697060244512166, -88.8655624389648, -1.55099665619654, 218, 18, 'PPL', 'P'),
(195418, 'Oreana', 43.0536117553711, 0.751427280006561, -116.394172668457, -2.03146154319937, 218, 17, 'PPL', 'P'),
(200108, 'Oreana', 40.3344383239746, 0.70396875069594, -118.321388244629, -2.06509780039929, 218, 39, 'PPL', 'P'),
(200109, 'Oreana (historical)', 40.3108291625977, 0.703556693096278, -118.369438171387, -2.06593642982655, 218, 39, 'PPL', 'P'),
(142602, 'Oreapolis', 41.0475006103516, 0.716414035365017, -95.9180603027344, -1.67408596440918, 218, 35, 'PPL', 'P'),
(56697, 'Orearville', 39.1716690063477, 0.683674597662182, -93.0741729736328, -1.62445076696061, 218, 29, 'PPL', 'P'),
(10997, 'Oreb (historical)', 34.1902809143066, 0.596732974136428, -94.0541687011719, -1.64155491906165, 218, 4, 'PPL', 'P'),
(89694, 'Orebank', 36.5555610656738, 0.638014900509855, -82.4680633544922, -1.43933923327917, 218, 50, 'PPL', 'P'),
(23668, 'Oreburg', 34.2619400024414, 0.597983661163357, -85.3127822875977, -1.48898894495568, 218, 13, 'PPL', 'P'),
(165564, 'Orefield', 40.6347198486328, 0.709209651984134, -75.584716796875, -1.31920217229293, 218, 45, 'PPL', 'P'),
(37541, 'Oregon', 37.9122200012207, 0.66169306576175, -84.8236083984375, -1.48045124997505, 218, 21, 'PPL', 'P'),
(50128, 'Oregon', 39.4972190856934, 0.689356518426893, -76.6866683959961, -1.33843485589521, 218, 25, 'PPL', 'P'),
(56698, 'Oregon', 39.9869384765625, 0.697903734208421, -95.1447219848633, -1.6605886645305, 218, 29, 'PPL', 'P'),
(61187, 'Oregon', 33.1438903808594, 0.578470014066073, -90.1133270263672, -1.5727742565365, 218, 30, 'PPL', 'P'),
(112187, 'Oregon', 40, 0.698131700797732, -76.2452774047852, -1.33073112980994, 218, 45, 'PPL', 'P'),
(120911, 'Oregon', 42.014720916748, 0.733295214303784, -89.3322219848633, -1.55914140175833, 218, 18, 'PPL', 'P'),
(151437, 'Oregon', 43.5574989318848, 0.760221770295302, -74.1208267211914, -1.29365247058498, 218, 40, 'PPL', 'P'),
(156963, 'Oregon', 41.6436080932617, 0.726818073637575, -83.4869384765625, -1.45712195882595, 218, 41, 'PPL', 'P'),
(175698, 'Oregon', 42.9261093139648, 0.749201942599691, -89.3844375610352, -1.56005273548335, 218, 57, 'PPL', 'P'),
(201355, 'Oregon', 44.0002784729004, 0.767949731146494, -120.500282287598, -2.10312667550118, 218, 43, 'ADM1', 'A'),
(10996, 'Oregon (historical)', 36.3019409179688, 0.633588393883007, -93.0208282470703, -1.62351972584352, 218, 4, 'PPL', 'P'),
(89695, 'Oregon (historical)', 35.9691696166992, 0.627780439019708, -86.2127838134766, -1.50469693485524, 218, 50, 'PPL', 'P'),
(104977, 'Oregon Acres', 36.8166694641113, 0.642572101767199, -76.3574981689453, -1.33268975163364, 218, 53, 'PPL', 'P'),
(183883, 'Oregon City', 39.5938911437988, 0.691043764135513, -121.528327941895, -2.12106945702948, 218, 6, 'PPL', 'P'),
(201354, 'Oregon City', 45.3574981689453, 0.791637683515395, -122.605560302734, -2.13987070853517, 218, 43, 'PPL', 'P'),
(156964, 'Oregon Corners', 41.166389465332, 0.718489037328352, -81.4049987792969, -1.4207852562807, 218, 41, 'PPL', 'P'),
(67518, 'Oregon Hill', 36.4483299255371, 0.636143364053802, -79.6372222900391, -1.3899317361038, 218, 33, 'PPL', 'P'),
(165565, 'Oregon Hill', 41.524169921875, 0.724733484294315, -77.3072204589844, -1.3492655325744, 218, 45, 'PPL', 'P'),
(183884, 'Oregon House', 39.3563919067383, 0.686898620477832, -121.278060913086, -2.11670147336759, 218, 6, 'PPL', 'P'),
(178762, 'Oregon Trail Mobile Home Park', 33.5577812194824, 0.585693771943886, -112.114440917969, -1.95676613305121, 218, 5, 'PPL', 'P'),
(73799, 'Oregonia', 39.4508285522461, 0.688546850876482, -84.0961074829102, -1.46775396368782, 218, 41, 'PPL', 'P'),
(110770, 'Oreide', 39.3611106872559, 0.686980978734543, -80.1999969482422, -1.39975400683623, 218, 58, 'PPL', 'P'),
(137287, 'Oreland', 46.4508285522461, 0.810719898516085, -93.9186096191406, -1.63918896674922, 218, 28, 'PPL', 'P'),
(165566, 'Oreland', 40.1183280944824, 0.700196915644061, -75.1780624389648, -1.31210471482982, 218, 45, 'PPL', 'P'),
(96818, 'Orelia', 28.6861095428467, 0.50066706111044, -98.8480606079102, -1.72522411681894, 218, 51, 'PPL', 'P'),
(37542, 'Orell', 38.0716705322266, 0.664476002521855, -85.8847198486328, -1.49897113851157, 218, 21, 'PPL', 'P'),
(199582, 'Orella', 42.8933296203613, 0.748629829018515, -103.5, -1.80641577581413, 218, 35, 'PPL', 'P'),
(183885, 'Orella (historical)', 34.4625015258789, 0.601484120100157, -120.050003051758, -2.09526782028241, 218, 6, 'PPL', 'P'),
(205258, 'Orem', 40.2969398498535, 0.703314278858053, -111.693893432617, -1.94942619477084, 218, 52, 'PPL', 'P'),
(205259, 'Orem Station', 40.3097190856934, 0.703537318599347, -111.704170227051, -1.94960555867026, 218, 52, 'PPL', 'P'),
(165567, 'Oreminea', 40.4047203063965, 0.705195402694031, -78.2555618286133, -1.3658172119073, 218, 45, 'PPL', 'P'),
(201356, 'Orenco', 45.5277786254883, 0.794609638133869, -122.910827636719, -2.14519862861198, 218, 43, 'PPL', 'P'),
(123372, 'Orestes', 40.2694396972656, 0.702834310650594, -85.7280578613281, -1.49623687102038, 218, 19, 'PPL', 'P'),
(73800, 'Oreton', 39.163890838623, 0.683538843025615, -82.4127807617188, -1.43837437001623, 218, 41, 'PPL', 'P'),
(104985, 'Oreton', 36.815559387207, 0.642552727270269, -82.7816696166992, -1.44481269510955, 218, 53, 'PPL', 'P'),
(201357, 'Oretown', 45.1538887023926, 0.78808402793582, -123.954170227051, -2.16340839203956, 218, 43, 'PPL', 'P'),
(42448, 'Oretta', 30.5258293151855, 0.532776228451794, -93.4372177124023, -1.63078709298419, 218, 22, 'PPL', 'P'),
(73801, 'Oreville', 39.5847206115723, 0.690883708153999, -82.2688903808594, -1.43586300910829, 218, 41, 'PPL', 'P'),
(165568, 'Oreville', 40.5186080932617, 0.707183119552639, -75.6902770996094, -1.32104454713505, 218, 45, 'PPL', 'P'),
(202463, 'Oreville', 43.8675003051758, 0.765632314944935, -103.622497558594, -1.80855376153725, 218, 49, 'PPL', 'P'),
(128433, 'Orffs Corner', 44.1636085510254, 0.770800378777315, -69.415283203125, -1.21152524309885, 218, 26, 'PPL', 'P'),
(144278, 'Orford', 43.9052810668945, 0.766291713630838, -72.1405563354492, -1.25909023227404, 218, 36, 'PPL', 'P'),
(183887, 'Orford', 37.9772186279297, 0.662827505807096, -121.188331604004, -2.11513540148857, 218, 6, 'PPL', 'P'),
(144280, 'Orfordville', 43.8833312988281, 0.76590861790803, -72.102783203125, -1.25843096674619, 218, 36, 'PPL', 'P'),
(175701, 'Orfordville', 42.627498626709, 0.743990202925433, -89.253059387207, -1.5577597537848, 218, 57, 'PPL', 'P'),
(137288, 'Org', 43.5813903808594, 0.760638754742982, -95.6513900756836, -1.66943169093011, 218, 28, 'PPL', 'P'),
(89696, 'Orgains Crossroads', 36.4388885498047, 0.635978580961354, -87.3691711425781, -1.5248797011764, 218, 50, 'PPL', 'P'),
(104979, 'Orgainville', 36.7174987792969, 0.640841246795729, -78.5849990844727, -1.37156697670078, 218, 53, 'PPL', 'P'),
(189173, 'Organ', 32.4255599975586, 0.565932783760362, -106.59610748291, -1.86045304538655, 218, 38, 'PPL', 'P'),
(110771, 'Organ Cave', 37.7127799987793, 0.658212181058962, -80.4413909912109, -1.40396712768074, 218, 58, 'PPL', 'P'),
(30744, 'Organ Springs', 38.4766693115234, 0.671544564687144, -86.1647186279297, -1.50385803911186, 218, 19, 'PPL', 'P'),
(110772, 'Orgas', 38.0583305358887, 0.664243175663555, -81.5725021362305, -1.42370874136733, 218, 58, 'PPL', 'P'),
(104980, 'Oriana', 37.1336097717285, 0.648103753667403, -76.5252838134766, -1.33561816356829, 218, 53, 'PPL', 'P'),
(191988, 'Oriana (historical)', 33.1808891296387, 0.57911576405139, -100.444892883301, -1.75309409762662, 218, 51, 'PPL', 'P'),
(23669, 'Orianna', 32.4738883972168, 0.566776273456617, -82.6452789306641, -1.44243222856919, 218, 13, 'PPL', 'P'),
(193836, 'Orick', 41.2869415283203, 0.720593067747569, -124.058609008789, -2.16523119264767, 218, 6, 'PPL', 'P'),
(23670, 'Orico (historical)', 31.9486103057861, 0.55760844127256, -82.5194396972656, -1.4402359196182, 218, 13, 'PPL', 'P'),
(28156, 'Orient', 37.9183311462402, 0.661799725363408, -88.9775009155273, -1.55295035117222, 218, 18, 'PPL', 'P'),
(73802, 'Orient', 39.8027801513672, 0.694689565088804, -83.1519393920898, -1.45127512181074, 218, 41, 'PPL', 'P'),
(78885, 'Orient', 39.9511108398438, 0.69727842398447, -79.8541717529297, -1.39371821854168, 218, 45, 'PPL', 'P'),
(117145, 'Orient', 41.2030601501465, 0.719129061517325, -94.414436340332, -1.64784277555338, 218, 16, 'PPL', 'P'),
(128436, 'Orient', 45.8169403076172, 0.799656461557623, -67.8405609130859, -1.18404115433312, 218, 26, 'PPL', 'P'),
(151438, 'Orient', 41.1388893127441, 0.718009069120892, -72.3038864135742, -1.26194087990486, 218, 40, 'PPL', 'P'),
(171018, 'Orient', 44.9002799987793, 0.783657721046054, -99.0888900756836, -1.72942738396741, 218, 49, 'PPL', 'P'),
(191990, 'Orient', 31.6566696166992, 0.552513115027453, -100.331390380859, -1.75111310524976, 218, 51, 'PPL', 'P'),
(201358, 'Orient', 45.4674987792969, 0.793557556345233, -122.351387023926, -2.13543454794937, 218, 43, 'PPL', 'P'),
(209925, 'Orient', 48.8661117553711, 0.852874542778731, -118.201667785645, -2.06300828420801, 218, 56, 'PPL', 'P'),
(125747, 'Orient Heights', 42.3875007629395, 0.739801450004902, -71.0041732788086, -1.23925660637179, 218, 23, 'PPL', 'P'),
(110773, 'Orient Hill', 38.0280609130859, 0.663714871082311, -80.7261123657227, -1.40893645311677, 218, 58, 'PPL', 'P'),
(17441, 'Orient Park', 27.9722194671631, 0.48820732879245, -82.3730621337891, -1.43768114918449, 218, 12, 'PPL', 'P'),
(151439, 'Orient Point', 41.1522216796875, 0.718241762821138, -72.2516708374023, -1.26102954617984, 218, 40, 'PPL', 'P'),
(76838, 'Orienta', 36.3600006103516, 0.634601726677783, -98.4736099243164, -1.71868871950389, 218, 42, 'PPL', 'P'),
(151440, 'Orienta', 40.9372215270996, 0.714489302266189, -73.728889465332, -1.28681187500901, 218, 40, 'PPL', 'P'),
(17442, 'Orienta Gardens', 28.6572208404541, 0.500162858137061, -81.3822174072266, -1.42038764632995, 218, 12, 'PPL', 'P'),
(67519, 'Oriental', 35.0308303833008, 0.611403329896266, -76.6933288574219, -1.33855110287679, 218, 33, 'PPL', 'P'),
(71221, 'Oriental', 39.815559387207, 0.694912604830099, -74.7275009155273, -1.30424093276303, 218, 37, 'PPL', 'P'),
(76839, 'Oriental', 35.5363883972168, 0.620226981798944, -96.2286071777344, -1.67950602985971, 218, 42, 'PPL', 'P'),
(165569, 'Oriental', 40.6333312988281, 0.709185417218215, -77.0063934326172, -1.34401511048531, 218, 45, 'PPL', 'P'),
(151441, 'Oriental Park', 42.1555595397949, 0.735753311989927, -79.3850021362305, -1.38552966397995, 218, 40, 'PPL', 'P'),
(96816, 'Oriente Colonia', 26.0939998626709, 0.455426212618555, -97.9400024414063, -1.70937551201382, 218, 51, 'PPL', 'P'),
(56700, 'Origanna', 37.478328704834, 0.654120234044055, -92.5113906860352, -1.61462836307013, 218, 29, 'PPL', 'P'),
(190577, 'Original (historical)', 36.899169921875, 0.644012006389578, -116.880279541016, -2.03994570864209, 218, 39, 'PPL', 'P'),
(175704, 'Orihula', 44.209171295166, 0.771595598678813, -88.8327789306641, -1.55042447603634, 218, 57, 'PPL', 'P'),
(117147, 'Orillia', 41.5097198486328, 0.724481282939085, -93.7286071777344, -1.63587279855985, 218, 16, 'PPL', 'P'),
(208347, 'Orillia', 47.4413909912109, 0.828008474522607, -122.244438171387, -2.13356793834133, 218, 56, 'PPL', 'P'),
(208348, 'Orin', 48.4911117553711, 0.846329558083753, -117.908889770508, -2.05789834386642, 218, 56, 'PPL', 'P'),
(209647, 'Orin', 42.6533317565918, 0.744441076097983, -105.191940307617, -1.83594570492926, 218, 59, 'PPL', 'P'),
(209648, 'Orin Junction', 42.6558303833008, 0.744484685360833, -105.183326721191, -1.83579536948572, 218, 59, 'PPL', 'P'),
(183888, 'Orinda', 37.8772201538086, 0.661082203186713, -122.178611755371, -2.13241905064707, 218, 6, 'PPL', 'P'),
(183889, 'Orinda Village', 37.8875007629395, 0.661261633665157, -122.194442749023, -2.13269535361017, 218, 6, 'PPL', 'P'),
(197195, 'Orinoco', 46.2961082458496, 0.808019519749772, -106.59139251709, -1.86037075370886, 218, 31, 'PPL', 'P'),
(28157, 'Orio', 38.5544395446777, 0.67290191131573, -87.7788925170898, -1.53203068817743, 218, 18, 'PPL', 'P'),
(30745, 'Oriole', 38.1688919067383, 0.666172835610399, -86.5047225952148, -1.50979222781083, 218, 19, 'PPL', 'P'),
(37546, 'Oriole', 37.297779083252, 0.650969048684219, -87.5702819824219, -1.52838974749313, 218, 21, 'PPL', 'P'),
(50130, 'Oriole', 38.1730613708496, 0.666245606487186, -75.8080596923828, -1.32310024118048, 218, 25, 'PPL', 'P'),
(56701, 'Oriole', 37.4422187805176, 0.653489996972088, -89.5352783203125, -1.56268540337895, 218, 29, 'PPL', 'P'),
(165570, 'Oriole', 41.1411094665527, 0.718047818114753, -77.2102813720703, -1.34757362633387, 218, 45, 'PPL', 'P'),
(110774, 'Oriole (historical)', 39.4319381713867, 0.68821715153353, -79.7986068725586, -1.39274842843072, 218, 58, 'PPL', 'P'),
(17443, 'Oriole Beach', 30.3736095428467, 0.530119492237844, -87.0913925170898, -1.52003154956997, 218, 12, 'PPL', 'P'),
(4800, 'Orion', 31.958610534668, 0.557782978192501, -86.0055618286133, -1.50108022893686, 218, 2, 'PPL', 'P'),
(10998, 'Orion', 34.4741706848145, 0.601687785344521, -92.253059387207, -1.61011963134463, 218, 4, 'PPL', 'P'),
(61188, 'Orion', 34.7152786254883, 0.605895912761982, -89.6519393920898, -1.56472152319037, 218, 30, 'PPL', 'P'),
(67520, 'Orion', 36.3974990844727, 0.63525619851567, -81.4211120605469, -1.42106648609181, 218, 33, 'PPL', 'P'),
(76840, 'Orion', 36.2166709899902, 0.632100152886844, -98.7783279418945, -1.72400705220077, 218, 42, 'PPL', 'P'),
(120914, 'Orion', 41.3547210693359, 0.721776043903782, -90.3813934326172, -1.57745289793955, 218, 18, 'PPL', 'P'),
(175705, 'Orion', 43.2030601501465, 0.754035646557212, -90.4277801513672, -1.57826249891093, 218, 57, 'PPL', 'P'),
(183890, 'Orion (historical)', 36.3102798461914, 0.63373393563658, -119.739723205566, -2.08985241536379, 218, 6, 'PPL', 'P'),
(140647, 'Oriska', 46.9305610656738, 0.819092810404267, -97.7886123657227, -1.7067332567383, 218, 34, 'PPL', 'P'),
(112629, 'Oriskany', 37.6163902282715, 0.656529862198359, -79.98388671875, -1.39598217178435, 218, 53, 'PPL', 'P'),
(151442, 'Oriskany', 43.1572189331055, 0.753235566386725, -75.3330612182617, -1.31480995386512, 218, 40, 'PPL', 'P'),
(151448, 'Oriskany Falls', 42.9391708374023, 0.749429909189002, -75.4613876342773, -1.31704967234187, 218, 40, 'PPL', 'P'),
(183891, 'Orita', 32.9772186279297, 0.57556104320738, -115.404441833496, -2.01418748142079, 218, 6, 'PPL', 'P'),
(42449, 'Oriza (historical)', 30.2572193145752, 0.528088099537359, -92.5069427490234, -1.61455073192435, 218, 22, 'PPL', 'P'),
(190574, 'Orizaba (historical)', 38.5119400024414, 0.672160154373116, -117.617500305176, -2.05281263829075, 218, 39, 'PPL', 'P'),
(37543, 'Orkney', 37.4300003051758, 0.6532767443478, -82.7352828979492, -1.44400309413817, 218, 21, 'PPL', 'P'),
(104981, 'Orkney Springs', 38.795280456543, 0.677105378201284, -78.8147201538086, -1.37557636572189, 218, 53, 'PPL', 'P'),
(56702, 'Orla', 37.5263900756836, 0.654959063208403, -92.5824966430664, -1.61586939613811, 218, 29, 'PPL', 'P'),
(191991, 'Orla', 31.8250007629395, 0.555451047763001, -103.908332824707, -1.81354252804924, 218, 51, 'PPL', 'P'),
(23671, 'Orland', 32.4333305358887, 0.566068405238874, -82.6725006103516, -1.44290733650766, 218, 13, 'PPL', 'P'),
(73803, 'Orland', 39.3827781677246, 0.687359147609334, -82.4238891601563, -1.43856824814359, 218, 41, 'PPL', 'P'),
(123374, 'Orland', 41.7305603027344, 0.728335675984756, -85.1716690063477, -1.48652605357957, 218, 19, 'PPL', 'P'),
(128435, 'Orland', 44.5702781677246, 0.77789810255654, -68.7363891601563, -1.19967630677687, 218, 26, 'PPL', 'P'),
(171021, 'Orland', 43.8916702270508, 0.766054159661603, -97.1888885498047, -1.69626610154791, 218, 49, 'PPL', 'P'),
(183892, 'Orland', 39.747501373291, 0.693724768404896, -122.195281982422, -2.13271000099617, 218, 6, 'PPL', 'P'),
(171022, 'Orland (historical)', 43.9191703796387, 0.766534127869063, -97.1816711425781, -1.69614013402835, 218, 49, 'PPL', 'P'),
(120916, 'Orland Hills', 41.5852813720703, 0.725800080310892, -87.8430633544922, -1.53315068057386, 218, 18, 'PPL', 'P'),
(120917, 'Orland Park', 41.6302795410156, 0.726585446516356, -87.853889465332, -1.5333396318532, 218, 18, 'PPL', 'P'),
(10999, 'Orlando', 33.7197189331055, 0.58852011822976, -92.14111328125, -1.60816580321089, 218, 4, 'PPL', 'P'),
(17444, 'Orlando', 28.5380592346191, 0.498083095773277, -81.3794403076172, -1.42033917679811, 218, 12, 'PPL', 'P'),
(37544, 'Orlando', 37.3727798461914, 0.65227805893902, -84.2680587768555, -1.47075507992023, 218, 21, 'PPL', 'P'),
(67521, 'Orlando', 35.0033302307129, 0.610923361688806, -83.3794403076172, -1.45524576183799, 218, 33, 'PPL', 'P'),
(76841, 'Orlando', 36.1488914489746, 0.630917176730631, -97.3777770996094, -1.69956282866132, 218, 42, 'PPL', 'P'),
(104982, 'Orlando', 36.7166709899902, 0.640826799146816, -76.5766677856445, -1.33651498306537, 218, 53, 'PPL', 'P'),
(110775, 'Orlando', 38.8711090087891, 0.678428836104999, -80.5938873291016, -1.40662869087416, 218, 58, 'PPL', 'P'),
(151443, 'Orlando', 42.3044395446777, 0.738351758265517, -78.7163925170898, -1.37386022471544, 218, 40, 'PPL', 'P'),
(42450, 'Orlandos Mobile Home Park', 29.9777793884277, 0.523210952764556, -90.1975021362305, -1.57424338935184, 218, 22, 'PPL', 'P'),
(104983, 'Orlean', 38.752498626709, 0.676358694410653, -77.9641723632813, -1.36073150633163, 218, 53, 'PPL', 'P'),
(96817, 'Orleander Estates Colonia', 26.2709999084473, 0.458515446193534, -98.4169998168945, -1.71770068673947, 218, 51, 'PPL', 'P'),
(28158, 'Orleans', 39.7236099243164, 0.693307783957217, -90.0794372558594, -1.57218276845839, 218, 18, 'PPL', 'P'),
(30746, 'Orleans', 38.6616706848145, 0.674773447771783, -86.4516677856445, -1.50886624669981, 218, 19, 'PPL', 'P'),
(67522, 'Orleans', 35.4697189331055, 0.619063380139661, -81.4027786254883, -1.42074650728683, 218, 33, 'PPL', 'P'),
(117149, 'Orleans', 43.4472198486328, 0.758297037196475, -95.0922164916992, -1.6596722707994, 218, 16, 'PPL', 'P'),
(125748, 'Orleans', 41.7897186279297, 0.72936818353938, -69.9902801513672, -1.22156083303459, 218, 23, 'PPL', 'P'),
(132455, 'Orleans', 43.0686111450195, 0.751689068741716, -85.1350021362305, -1.48588609596963, 218, 27, 'PPL', 'P'),
(137290, 'Orleans', 48.9261093139648, 0.853921697719351, -96.936393737793, -1.6918592357341, 218, 28, 'PPL', 'P'),
(142603, 'Orleans', 40.1291694641113, 0.700386133239511, -99.4550018310547, -1.73581723952889, 218, 35, 'PPL', 'P'),
(151444, 'Orleans', 42.9186096191406, 0.749071048232113, -77.1147232055664, -1.34590582170121, 218, 40, 'PPL', 'P'),
(172373, 'Orleans', 44.8166694641113, 0.782198441926745, -72.2333297729492, -1.26070943421681, 218, 55, 'PPL', 'P'),
(193837, 'Orleans', 41.3016700744629, 0.720850129371789, -123.540000915527, -2.15617977389276, 218, 6, 'PPL', 'P'),
(23672, 'Orleans (historical)', 33.6272201538086, 0.586905709976954, -84.0869369506836, -1.46759390770631, 218, 13, 'PPL', 'P'),
(56703, 'Orleans (historical)', 37.5222206115723, 0.654886292331616, -93.5188903808594, -1.63221254995765, 218, 29, 'PPL', 'P'),
(110776, 'Orleans Cross Roads', 39.624439239502, 0.691576928985747, -78.3794403076172, -1.36797929923828, 218, 58, 'PPL', 'P'),
(183893, 'Orleans Flat', 39.4288902282715, 0.688163954890756, -120.833892822266, -2.10894927775048, 218, 6, 'PPL', 'P'),
(151446, 'Orleans Four Corners', 44.190559387207, 0.77127075960485, -75.9002838134766, -1.32470985574332, 218, 40, 'PPL', 'P'),
(183894, 'Orlem (historical)', 36.1911087036133, 0.631654006825228, -119.045280456543, -2.07773210292673, 218, 6, 'PPL', 'P'),
(23673, 'Orletta (historical)', 32.1802787780762, 0.561651818887087, -84.9444427490234, -1.48256020724228, 218, 13, 'PPL', 'P'),
(89698, 'Orlinda', 36.600830078125, 0.638804993826255, -86.716667175293, -1.51349135856495, 218, 50, 'PPL', 'P'),
(17445, 'Orlovista', 28.5380592346191, 0.498083095773277, -81.460563659668, -1.42175504639165, 218, 12, 'PPL', 'P'),
(110777, 'Orma', 38.7480583190918, 0.676281196422932, -81.0999984741211, -1.41546199673579, 218, 58, 'PPL', 'P'),
(183895, 'Ormand', 34.0111083984375, 0.59360582380543, -117.417503356934, -2.04932203304999, 218, 6, 'PPL', 'P'),
(117159, 'Ormanville', 40.9086112976074, 0.713989959561799, -92.4830627441406, -1.61413394721376, 218, 16, 'PPL', 'P'),
(123375, 'Ormas', 41.2949981689453, 0.720733682653125, -85.5461120605469, -1.49306131773657, 218, 19, 'PPL', 'P'),
(50131, 'Orme', 38.6425018310547, 0.674438888159842, -76.7658309936523, -1.33981650386874, 218, 25, 'PPL', 'P'),
(89699, 'Orme', 35.0119400024414, 0.611073630553314, -85.8047180175781, -1.49757484315204, 218, 50, 'PPL', 'P'),
(187142, 'Ormega', 37.9608306884766, 0.662541482306022, -103.585830688477, -1.8079138039273, 218, 7, 'PPL', 'P'),
(23674, 'Ormewood', 33.7299995422363, 0.588699548708204, -84.3569412231445, -1.4723063712552, 218, 13, 'PPL', 'P'),
(71222, 'Ormond', 39.3283309936523, 0.686408865153367, -74.9533309936523, -1.30818241117635, 218, 37, 'PPL', 'P'),
(17446, 'Ormond Beach', 29.2855606079102, 0.511129455900384, -81.0561065673828, -1.41469593844823, 218, 12, 'PPL', 'P'),
(17447, 'Ormond-by-the-Sea', 29.3488903045654, 0.512234767621308, -81.0666732788086, -1.41488036235372, 218, 12, 'PPL', 'P'),
(120919, 'Ormonde', 40.8549995422363, 0.7130542579128, -90.6130599975586, -1.58149624226456, 218, 18, 'PPL', 'P'),
(67524, 'Ormondsville', 35.4719390869141, 0.619102129133521, -77.5461120605469, -1.35343497757703, 218, 33, 'PPL', 'P'),
(165571, 'Ormrod', 40.6711082458496, 0.709844749325091, -75.5552825927734, -1.31868844851865, 218, 45, 'PPL', 'P'),
(137291, 'Ormsby', 43.848331451416, 0.765297755332993, -94.6975021362305, -1.65278320569159, 218, 28, 'PPL', 'P'),
(165572, 'Ormsby', 41.8088912963867, 0.729702809730349, -78.5419387817383, -1.37081543264116, 218, 45, 'PPL', 'P'),
(175707, 'Ormsby', 45.2561111450195, 0.789868146129092, -89.2525024414063, -1.55775003324682, 218, 57, 'PPL', 'P'),
(110778, 'Orndoff', 38.5374984741211, 0.672606233855704, -80.4244384765625, -1.40367125048363, 218, 58, 'PPL', 'P'),
(165573, 'Orners Corner', 40.5583305358887, 0.707876406963413, -78.3908309936523, -1.36817810421365, 218, 45, 'PPL', 'P'),
(187143, 'Oro', 39.235279083252, 0.684784802941609, -106.251670837402, -1.85444149185791, 218, 7, 'PPL', 'P'),
(178763, 'Oro Blanco', 31.4958305358887, 0.549705943501427, -111.279167175293, -1.94218785608606, 218, 5, 'PPL', 'P'),
(193838, 'Oro Fino', 41.5805587768555, 0.725717655475154, -122.920280456543, -2.14536361144151, 218, 6, 'PPL', 'P'),
(195419, 'Oro Fino (historical)', 46.4822196960449, 0.811267777331342, -115.796669006348, -2.02103313700284, 218, 17, 'PPL', 'P'),
(183896, 'Oro Grande', 34.5988883972168, 0.603864520061497, -117.33332824707, -2.04785290023464, 218, 6, 'PPL', 'P'),
(183897, 'Oro Loma', 36.8908309936523, 0.643866464636005, -120.689437866211, -2.1064280631465, 218, 6, 'PPL', 'P'),
(178764, 'Oro Valley', 32.3908309936523, 0.56532664829626, -110.965827941895, -1.93671905478758, 218, 5, 'PPL', 'P'),
(194358, 'Orodell', 40.0149993896484, 0.698393489532887, -105.324722290039, -1.83826318770984, 218, 7, 'PPL', 'P'),
(195420, 'Orofino', 46.4794387817383, 0.811219241220475, -116.254173278809, -2.02901809289922, 218, 17, 'PPL', 'P'),
(189174, 'Orogrande', 32.3711090087891, 0.564982434725367, -106.083892822266, -1.85151321308131, 218, 38, 'PPL', 'P'),
(195421, 'Orogrande', 45.7055587768555, 0.79771248711992, -115.542503356934, -2.01659710957509, 218, 17, 'PPL', 'P'),
(183898, 'Oroleve', 39.526668548584, 0.689870508517279, -121.178329467773, -2.11496083127911, 218, 6, 'PPL', 'P'),
(208349, 'Orondo', 47.6261100769043, 0.83123243075923, -120.224166870117, -2.09830755235063, 218, 56, 'PPL', 'P'),
(128438, 'Orono', 44.8830604553223, 0.783357183317039, -68.6725006103516, -1.19856124122845, 218, 26, 'PPL', 'P'),
(137293, 'Orono', 44.9713897705078, 0.784898820693058, -93.6041717529297, -1.6337009906909, 218, 28, 'PPL', 'P'),
(104984, 'Oronoco', 37.7372207641602, 0.658638752886565, -79.2538909912109, -1.3832413428133, 218, 53, 'PPL', 'P'),
(137295, 'Oronoco', 44.1661109924316, 0.770844054619192, -92.5347213745117, -1.6150355604008, 218, 28, 'PPL', 'P'),
(137296, 'Oronoco Estates', 44.1236114501953, 0.770102297676578, -92.5166702270508, -1.61472050844385, 218, 28, 'PPL', 'P'),
(56704, 'Oronogo', 37.1883316040039, 0.649058829813332, -94.4700012207031, -1.64881256566433, 218, 29, 'PPL', 'P'),
(113875, 'Oronoke', 41.541389465332, 0.725034022023331, -73.0897216796875, -1.27565629267683, 218, 8, 'PPL', 'P'),
(113876, 'Oronoque', 41.2477798461914, 0.7199095674538, -73.101936340332, -1.27586947872209, 218, 8, 'PPL', 'P'),
(187838, 'Oronoque', 39.788890838623, 0.69444715085058, -100.025001525879, -1.74576561093894, 218, 20, 'PPL', 'P'),
(113877, 'Oronoque Hills North', 41.2538909912109, 0.720016227055458, -73.1133270263672, -1.27606828369746, 218, 8, 'PPL', 'P'),
(113878, 'Oronoque Hills South', 41.2472190856934, 0.719899780336794, -73.1116714477539, -1.27603938839964, 218, 8, 'PPL', 'P'),
(183899, 'Orosi', 36.5449981689453, 0.637830543183395, -119.286392211914, -2.08194029692322, 218, 6, 'PPL', 'P'),
(200110, 'Orovada', 41.5699996948242, 0.725533364727721, -117.784439086914, -2.05572626968135, 218, 39, 'PPL', 'P'),
(183900, 'Oroville', 39.5138893127441, 0.689647468775985, -121.555282592773, -2.12153990443605, 218, 6, 'PPL', 'P'),
(208350, 'Oroville', 48.9391708374023, 0.854149664308661, -119.434440612793, -2.08452422897087, 218, 56, 'PPL', 'P'),
(183901, 'Oroville Junction', 39.5097198486328, 0.689574697899198, -121.649436950684, -2.12318320798668, 218, 6, 'PPL', 'P'),
(96819, 'Orozimbo', 29.2533302307129, 0.510566929699132, -95.5769424438477, -1.66813233463426, 218, 51, 'PPL', 'P'),
(209649, 'Orpha', 42.8547210693359, 0.747955982683697, -105.503059387207, -1.84137575723387, 218, 59, 'PPL', 'P'),
(210845, 'Orpheum Village', 20.9030609130859, 0.364827236678282, -156.372222900391, -2.72921014827429, 218, 15, 'PPL', 'P'),
(73804, 'Orpheus', 38.9630584716797, 0.68003365697788, -82.4583282470703, -1.43916932360162, 218, 41, 'PPL', 'P'),
(37545, 'Orr', 38.1355590820313, 0.665591068070272, -82.8919372558594, -1.4467372284713, 218, 21, 'PPL', 'P'),
(76843, 'Orr', 34.0319404602051, 0.593969411873253, -97.5352783203125, -1.7023117435385, 218, 42, 'PPL', 'P'),
(110780, 'Orr', 38.9397201538086, 0.679626326489153, -80.0538864135742, -1.39720389693443, 218, 58, 'PPL', 'P'),
(132458, 'Orr', 43.3802795410156, 0.757128708426257, -84.170280456543, -1.46904852629371, 218, 27, 'PPL', 'P'),
(137299, 'Orr', 48.0536117553711, 0.838693742606277, -92.8308334350586, -1.62020369081221, 218, 28, 'PPL', 'P'),
(140650, 'Orr', 48.0933303833008, 0.839386963438025, -97.6750030517578, -1.70475040014868, 218, 34, 'PPL', 'P'),
(187144, 'Orr', 38.1074981689453, 0.665101312745806, -103.534721374512, -1.80702177812018, 218, 7, 'PPL', 'P'),
(11000, 'Orr (historical)', 35.8958282470703, 0.626500390641762, -90.271110534668, -1.57552809826169, 218, 4, 'PPL', 'P'),
(42452, 'Orr (historical)', 30.4744396209717, 0.531879309086169, -91.0325012207031, -1.58881687262703, 218, 22, 'PPL', 'P'),
(50132, 'Orr Acres', 39.1305618286133, 0.682957142064515, -76.5069427490234, -1.33529805160526, 218, 25, 'PPL', 'P'),
(56705, 'Orrick', 39.2127799987793, 0.684392119838877, -94.1224975585938, -1.64274748259779, 218, 29, 'PPL', 'P'),
(198714, 'Orrin', 48.0913887023926, 0.839353074713154, -100.162780761719, -1.74817031224523, 218, 34, 'PPL', 'P'),
(128440, 'Orrington', 44.7311096191406, 0.780705140924511, -68.8269424438477, -1.20125675972577, 218, 26, 'PPL', 'P'),
(128441, 'Orrington Center', 44.7211112976074, 0.780530637294083, -68.7891693115234, -1.20059749419792, 218, 26, 'PPL', 'P'),
(183902, 'Orris', 35.853889465332, 0.625768420816153, -119.060279846191, -2.07799389166189, 218, 6, 'PPL', 'P'),
(137301, 'Orrock', 45.4438896179199, 0.793145498745571, -93.7361068725586, -1.63600369292743, 218, 28, 'PPL', 'P'),
(23675, 'Orrs', 33.4811096191406, 0.584355600075149, -84.3388900756836, -1.47199131929825, 218, 13, 'PPL', 'P'),
(82790, 'Orrs', 34.7169418334961, 0.605924941217864, -81.1236114501953, -1.41587412091448, 218, 48, 'PPL', 'P'),
(89700, 'Orrs', 35.4238891601563, 0.618263499706255, -86.7230606079102, -1.51360294501463, 218, 50, 'PPL', 'P'),
(96820, 'Orrs', 32.8424987792969, 0.573209738280949, -94.5244369506836, -1.64976264838322, 218, 51, 'PPL', 'P'),
(128443, 'Orrs Island', 43.7605590820313, 0.763765838494953, -69.9766693115234, -1.22132327906536, 218, 26, 'PPL', 'P'),
(151449, 'Orrs Mill', 41.434440612793, 0.723167412415294, -74.0580596923828, -1.29255697927058, 218, 40, 'PPL', 'P'),
(183903, 'Orrs Springs', 39.2294387817383, 0.684682870450886, -123.363609313965, -2.15310115967263, 218, 6, 'PPL', 'P'),
(139374, 'Orrsburg', 40.4308280944824, 0.705651069556543, -94.7211074829102, -1.65319519671222, 218, 29, 'PPL', 'P'),
(165574, 'Orrstown', 40.0586090087891, 0.699154620972431, -77.6102828979492, -1.35455496997346, 218, 45, 'PPL', 'P'),
(78886, 'Orrtanna', 39.8450012207031, 0.695426461762429, -77.3611068725586, -1.35020602791336, 218, 45, 'PPL', 'P'),
(67526, 'Orrum', 34.4658317565918, 0.601542243590948, -79.0094375610352, -1.37897482558894, 218, 33, 'PPL', 'P'),
(4802, 'Orrville', 34.6672210693359, 0.605057150176662, -86.976936340332, -1.5180339124363, 218, 2, 'PPL', 'P'),
(30748, 'Orrville', 38.4580612182617, 0.671219792192209, -87.6861114501953, -1.53041135307661, 218, 19, 'PPL', 'P'),
(56707, 'Orrville', 38.6369400024414, 0.674341815938108, -90.6600036621094, -1.58231556377393, 218, 29, 'PPL', 'P'),
(156966, 'Orrville', 40.8436088562012, 0.712855452937426, -81.7641677856445, -1.42705393801258, 218, 41, 'PPL', 'P'),
(187145, 'Orsa', 39.4222183227539, 0.688047508172092, -104.913330078125, -1.83108303909488, 218, 7, 'PPL', 'P'),
(33506, 'Orsemus', 37.4972190856934, 0.654449933387007, -97.9352798461914, -1.70929308717809, 218, 20, 'PPL', 'P'),
(17448, 'Orsino', 28.5275001525879, 0.497898805025843, -80.6655578613281, -1.40787957763817, 218, 12, 'PPL', 'P'),
(23676, 'Orsman', 34.3666687011719, 0.599811521777533, -85.2388916015625, -1.48769930919781, 218, 13, 'PPL', 'P'),
(117152, 'Orson', 41.7794418334961, 0.729188819639963, -95.9830627441406, -1.67522047103356, 218, 16, 'PPL', 'P'),
(165576, 'Orson', 41.8136100769043, 0.729785167987059, -75.4483337402344, -1.31682183891062, 218, 45, 'PPL', 'P'),
(191992, 'Ort', 31.2966709136963, 0.546229952357142, -104.355827331543, -1.82135278057811, 218, 51, 'PPL', 'P'),
(17449, 'Ortega', 30.2702808380127, 0.52831606612667, -81.7083282470703, -1.42607935421166, 218, 12, 'PPL', 'P'),
(183905, 'Ortega', 37.9047203063965, 0.661562171394173, -121.271110534668, -2.11658016637994, 218, 6, 'PPL', 'P'),
(17450, 'Ortega Farms', 30.2519397735596, 0.527995954163642, -81.7222213745117, -1.42632183502892, 218, 12, 'PPL', 'P'),
(17451, 'Ortega Forest', 30.2613906860352, 0.528160903703659, -81.7108306884766, -1.42612303005354, 218, 12, 'PPL', 'P'),
(17454, 'Ortega Terrace', 30.2638893127441, 0.528204512966509, -81.7008285522461, -1.42594845984409, 218, 12, 'PPL', 'P'),
(137303, 'Orth', 47.839168548584, 0.834951002589307, -94.3150024414063, -1.64610732662903, 218, 28, 'PPL', 'P'),
(110781, 'Ortin Heights', 38.4474983215332, 0.671035434865748, -81.8180618286133, -1.42799456650959, 218, 58, 'PPL', 'P'),
(208351, 'Orting', 47.0980606079102, 0.822016228911874, -122.203056335449, -2.1328456890537, 218, 56, 'PPL', 'P'),
(37547, 'Ortiz', 37.5563888549805, 0.655482640678712, -87.6091690063477, -1.52906845409694, 218, 21, 'PPL', 'P'),
(187146, 'Ortiz', 37.0041694641113, 0.645844594114688, -106.043609619141, -1.85081013855353, 218, 7, 'PPL', 'P'),
(56714, 'Ortiz (historical)', 39.0911102294922, 0.682268581764675, -91.9024963378906, -1.60400115189822, 218, 29, 'PPL', 'P'),
(189175, 'Ortiz (historical)', 35.336109161377, 0.61673144971016, -106.151107788086, -1.85268633554149, 218, 38, 'PPL', 'P'),
(171024, 'Ortley', 45.332218170166, 0.791196464301796, -97.1952819824219, -1.69637768799758, 218, 49, 'PPL', 'P'),
(201359, 'Ortley', 45.6561088562012, 0.796849423189653, -121.28694152832, -2.11685646934303, 218, 43, 'PPL', 'P'),
(71223, 'Ortley Beach', 39.9538917541504, 0.697326960095337, -74.0719375610352, -1.29279919377172, 218, 37, 'PPL', 'P'),
(71224, 'Ortley Terrace', 39.9577789306641, 0.697394804124107, -74.0691680908203, -1.29275085739794, 218, 37, 'PPL', 'P'),
(11001, 'Orton', 33.646110534668, 0.587235409319906, -93.9233322143555, -1.63927139158496, 218, 4, 'PPL', 'P'),
(110782, 'Orton', 38.8349990844727, 0.677798599033031, -80.9286117553711, -1.41247073419941, 218, 58, 'PPL', 'P'),
(117154, 'Orton', 41.5886116027832, 0.725858203801683, -95.8099975585938, -1.67219991372519, 218, 16, 'PPL', 'P'),
(202464, 'Orton', 44.7102813720703, 0.780341619435715, -100.841667175293, -1.76001911540915, 218, 49, 'PPL', 'P'),
(96823, 'Orton Hill', 31.5966701507568, 0.55146592679732, -94.6377792358398, -1.65174084444093, 218, 51, 'PPL', 'P'),
(17453, 'Ortona', 29.2522201538086, 0.510547555202202, -81.0258331298828, -1.41416756728796, 218, 12, 'PPL', 'P'),
(117155, 'Ortonville', 41.6150016784668, 0.726318797512212, -93.9594421386719, -1.63990162865693, 218, 16, 'PPL', 'P'),
(132459, 'Ortonville', 42.8522186279297, 0.74791230684182, -83.4430618286133, -1.4563561668545, 218, 27, 'PPL', 'P'),
(137305, 'Ortonville', 45.3047218322754, 0.790716562673364, -96.4444427490234, -1.68327307122163, 218, 28, 'PPL', 'P'),
(183906, 'Ortonville', 34.3213882446289, 0.599021228724051, -119.290557861328, -2.08201300122098, 218, 6, 'PPL', 'P'),
(82791, 'Orum', 34.0819396972656, 0.594842063183445, -79.5683288574219, -1.38872931887163, 218, 48, 'PPL', 'P'),
(142605, 'Orum', 41.5458297729492, 0.725111520011052, -96.2702789306641, -1.68023333915341, 218, 35, 'PPL', 'P'),
(175708, 'Orva', 46.4519386291504, 0.810739273013016, -90.2313919067383, -1.57483487742995, 218, 57, 'PPL', 'P'),
(96821, 'Orvil', 27.6391696929932, 0.482394513660161, -99.4858322143555, -1.73635533122714, 218, 51, 'PPL', 'P'),
(165577, 'Orvilla', 40.2663917541504, 0.702781114007819, -75.2925033569336, -1.31410208564737, 218, 45, 'PPL', 'P'),
(37548, 'Orville', 38.3983306884766, 0.670177297783497, -84.9155578613281, -1.48205607084793, 218, 21, 'PPL', 'P'),
(110783, 'Orville', 37.8141708374023, 0.659981785024292, -81.892219543457, -1.42928886279937, 218, 58, 'PPL', 'P'),
(165578, 'Orville', 40.5497207641602, 0.707726138098906, -79.7841720581055, -1.3924964933916, 218, 45, 'PPL', 'P'),
(67528, 'Orville (historical)', 35.1761093139648, 0.61393892557013, -80.6258316040039, -1.40718622364837, 218, 33, 'PPL', 'P'),
(209863, 'Orvin', 43.5333290100098, 0.759799925578634, -112.008613586426, -1.95491909767718, 218, 17, 'PPL', 'P'),
(61191, 'Orvisburg', 30.9127807617188, 0.539529805239153, -89.5252838134766, -1.56251096632755, 218, 30, 'PPL', 'P'),
(165579, 'Orviston', 41.1063919067383, 0.717441882387733, -77.7525024414063, -1.35703716926747, 218, 45, 'PPL', 'P'),
(33507, 'Orwell', 38.0155601501465, 0.663496691610006, -99.7152786254883, -1.7403599265583, 218, 20, 'PPL', 'P'),
(151450, 'Orwell', 43.5747184753418, 0.760522308024318, -75.9966735839844, -1.32639217460393, 218, 40, 'PPL', 'P'),
(156967, 'Orwell', 41.5349998474121, 0.724922502152684, -80.8683319091797, -1.41141865241078, 218, 41, 'PPL', 'P'),
(165580, 'Orwell', 41.8838882446289, 0.731011753406123, -76.2774963378906, -1.33129345627411, 218, 45, 'PPL', 'P'),
(172375, 'Orwell', 43.8038902282715, 0.764522109665508, -73.2983322143555, -1.27929723336113, 218, 55, 'PPL', 'P'),
(78887, 'Orwig', 39.7608299255371, 0.693957395526114, -76.6283264160156, -1.33741659625242, 218, 45, 'PPL', 'P'),
(165582, 'Orwigsburg', 40.6547203063965, 0.709558725824017, -76.1011123657227, -1.32821497521203, 218, 45, 'PPL', 'P'),
(165584, 'Orwin', 40.5838890075684, 0.708322486446002, -76.5330581665039, -1.33575385162583, 218, 45, 'PPL', 'P'),
(183907, 'Orwood', 37.939998626709, 0.662177894238199, -121.567779541016, -2.12175801732932, 218, 6, 'PPL', 'P'),
(89701, 'Orysa', 35.6222190856934, 0.621725009912113, -89.4977798461914, -1.56203093154106, 218, 50, 'PPL', 'P'),
(56708, 'Osa', 36.9044418334961, 0.64410401860524, -93.6341705322266, -1.6342245681612, 218, 29, 'PPL', 'P'),
(11002, 'Osage', 36.1824989318848, 0.631503737960721, -93.4044418334961, -1.63021504598204, 218, 4, 'PPL', 'P'),
(71225, 'Osage', 39.8502807617188, 0.695518607136146, -75.0072174072266, -1.30912290651531, 218, 37, 'PPL', 'P'),
(76844, 'Osage', 36.292781829834, 0.633428537638575, -96.4155578613281, -1.68276893482728, 218, 42, 'PPL', 'P'),
(89702, 'Osage', 36.3558311462402, 0.634528955800996, -88.4116668701172, -1.54307468405993, 218, 50, 'PPL', 'P'),
(96822, 'Osage', 31.5244407653809, 0.550205286205817, -97.5644378662109, -1.70282067362281, 218, 51, 'PPL', 'P'),
(110784, 'Osage', 39.6586112976074, 0.69217334391187, -80.0077819824219, -1.39639922281106, 218, 58, 'PPL', 'P'),
(117156, 'Osage', 43.2841682434082, 0.755451249834644, -92.8108291625977, -1.6198545503933, 218, 16, 'PPL', 'P'),
(137308, 'Osage', 46.920280456543, 0.818913379925823, -95.2566680908203, -1.66254249266424, 218, 28, 'PPL', 'P'),
(156969, 'Osage', 40.4744415283203, 0.706412267575115, -80.7222213745117, -1.40886854250897, 218, 41, 'PPL', 'P'),
(209650, 'Osage', 43.9808311462402, 0.767610311265564, -104.42138671875, -1.82249700774047, 218, 59, 'PPL', 'P'),
(56709, 'Osage Beach', 38.1502799987793, 0.665847996536437, -92.6177825927734, -1.61648525214019, 218, 29, 'PPL', 'P'),
(56710, 'Osage Bend', 38.4061088562012, 0.670313052420064, -92.1430587768555, -1.60819975851479, 218, 29, 'PPL', 'P'),
(56711, 'Osage Bluff', 38.4375, 0.67086093123532, -92.2172164916992, -1.60949405480457, 218, 29, 'PPL', 'P'),
(33509, 'Osage City', 38.6338882446289, 0.674288552716307, -95.8255615234375, -1.67247155615638, 218, 20, 'PPL', 'P'),
(56712, 'Osage City', 38.5525016784668, 0.672868089169886, -92.0322189331055, -1.60626523829895, 218, 29, 'PPL', 'P'),
(56715, 'Osage Heights', 37.9830589294434, 0.662929438297819, -93.8099975585938, -1.6372933286853, 218, 29, 'PPL', 'P'),
(56716, 'Osage Hills', 38.5683288574219, 0.673144325553954, -90.4477767944336, -1.57861150617179, 218, 29, 'PPL', 'P'),
(76846, 'Osage Junction', 36.5352783203125, 0.637660899821957, -96.7180633544922, -1.68804865168836, 218, 42, 'PPL', 'P'),
(11007, 'Osage Mills', 36.2811088562012, 0.633224805815184, -94.2686080932617, -1.64529759249959, 218, 4, 'PPL', 'P'),
(4803, 'Osage Woodyard Landing', 31.857780456543, 0.556023161344177, -88.1483306884766, -1.53847860065068, 218, 2, 'PPL', 'P'),
(4804, 'Osaka', 31.0636100769043, 0.542162273397669, -87.2238922119141, -1.52234410550254, 218, 2, 'PPL', 'P'),
(104986, 'Osaka', 36.9469413757324, 0.644845775547854, -82.8108291625977, -1.44532162519387, 218, 53, 'PPL', 'P'),
(137310, 'Osakis', 45.8669395446777, 0.800529112867815, -95.1519393920898, -1.66071463205006, 218, 28, 'PPL', 'P'),
(4805, 'Osanippa', 32.7611083984375, 0.571789208155501, -85.1511077880859, -1.48616719262269, 218, 2, 'PPL', 'P'),
(33516, 'Osawatomie', 38.4972190856934, 0.67190322590695, -94.9502792358398, -1.65719499835341, 218, 20, 'PPL', 'P'),
(28159, 'Osbernville', 39.7611083984375, 0.693962255795104, -89.1786117553711, -1.55646039748895, 218, 18, 'PPL', 'P'),
(4807, 'Osborn', 32.6836090087891, 0.570436588637849, -87.1430587768555, -1.52093329591507, 218, 2, 'PPL', 'P'),
(23677, 'Osborn', 34.9222183227539, 0.609507691832347, -83.6999969482422, -1.46084053065603, 218, 13, 'PPL', 'P'),
(37549, 'Osborn', 37.4766693115234, 0.6540912721672, -82.6127777099609, -1.441864975257, 218, 21, 'PPL', 'P'),
(56729, 'Osborn', 39.7472190856934, 0.693719841556879, -94.3550033569336, -1.64680547430879, 218, 29, 'PPL', 'P'),
(61189, 'Osborn', 33.5213890075684, 0.585058608023902, -88.7222213745117, -1.54849488266852, 218, 30, 'PPL', 'P'),
(82792, 'Osborn', 32.7555618286133, 0.571692402249876, -80.3463897705078, -1.40230904358605, 218, 48, 'PPL', 'P'),
(89703, 'Osborn', 36.454719543457, 0.636254883924449, -81.725830078125, -1.4263848187887, 218, 50, 'PPL', 'P'),
(120922, 'Osborn', 41.5224990844727, 0.724704322680379, -90.273063659668, -1.57556218672365, 218, 18, 'PPL', 'P'),
(123376, 'Osborn', 41.5924987792969, 0.725926047830453, -87.4688873291016, -1.52662007694877, 218, 19, 'PPL', 'P'),
(165585, 'Osborn', 41.4619407653809, 0.723647380622754, -80.2891693115234, -1.40131035817727, 218, 45, 'PPL', 'P'),
(11006, 'Osborn (historical)', 36.4813919067383, 0.636720404482995, -93.9411087036133, -1.63958164985195, 218, 4, 'PPL', 'P'),
(208352, 'Osborn Corner', 47.8777809143066, 0.835624915503152, -122.16471862793, -2.13217656982982, 218, 56, 'PPL', 'P'),
(156970, 'Osborn Corners', 41.2016716003418, 0.719104826751406, -81.6788864135742, -1.42556549727933, 218, 41, 'PPL', 'P'),
(56730, 'Osborn Crossing', 36.9063911437988, 0.644138040488166, -92.1922225952148, -1.60905782901801, 218, 29, 'PPL', 'P'),
(104987, 'Osborn Landing', 37.4136085510254, 0.652990654267698, -76.9688873291016, -1.34336050548937, 218, 53, 'PPL', 'P'),
(123377, 'Osborn Landing', 41.2811088562012, 0.720491268414901, -85.7969436645508, -1.4974391550945, 218, 19, 'PPL', 'P'),
(145972, 'Osborn Mills', 40.7216682434082, 0.710727187752289, -74.5311126708984, -1.30081331128204, 218, 37, 'PPL', 'P'),
(33519, 'Osborne', 39.4388885498047, 0.688338458521183, -98.6944427490234, -1.7225429793915, 218, 20, 'PPL', 'P'),
(50133, 'Osborne', 39.5366706848145, 0.690045078726733, -76.1175003051758, -1.32850099871311, 218, 25, 'PPL', 'P'),
(67529, 'Osborne', 34.8116683959961, 0.607578231622585, -79.7702789306641, -1.39225401257435, 218, 33, 'PPL', 'P'),
(110785, 'Osborne', 38.4991683959961, 0.671937247789876, -81.3486099243164, -1.41980108509986, 218, 58, 'PPL', 'P'),
(117158, 'Osborne', 42.7919387817383, 0.746860225053184, -91.4452819824219, -1.59602125600791, 218, 16, 'PPL', 'P'),
(165586, 'Osborne', 40.5316696166992, 0.707411086141949, -80.1691665649414, -1.39921591513798, 218, 45, 'PPL', 'P'),
(193839, 'Osborne', 40.7183303833008, 0.710668931103443, -122.029167175293, -2.12981075067545, 218, 6, 'PPL', 'P'),
(208353, 'Osborne', 47.9041709899902, 0.836085509213681, -119.063331604004, -2.07804715488369, 218, 56, 'PPL', 'P'),
(67530, 'Osborne Apartments', 35.2922210693359, 0.615965458001626, -81.5305633544922, -1.42297677154172, 218, 33, 'PPL', 'P'),
(208354, 'Osborne Corner', 48.0488891601563, 0.83861131777054, -119.233612060547, -2.08101910950216, 218, 56, 'PPL', 'P'),
(61190, 'Osborne Creek', 34.6258316040039, 0.604334767730978, -88.6222229003906, -1.54674958004814, 218, 30, 'PPL', 'P'),
(50134, 'Osborne Heights', 39.1847190856934, 0.683902364514411, -76.6500015258789, -1.33779489828526, 218, 25, 'PPL', 'P'),
(67531, 'Osborne Knob', 35.8352813720703, 0.625443648321218, -82.1097183227539, -1.43308493261717, 218, 33, 'PPL', 'P'),
(209653, 'Osborne Place', 43.0991706848145, 0.752222433329031, -107.420280456543, -1.87483757738239, 218, 59, 'PPL', 'P'),
(104988, 'Osbornes (historical)', 37.3444404602051, 0.651783443345565, -77.3694381713867, -1.35035143650888, 218, 53, 'PPL', 'P'),
(110786, 'Osbornes Mills', 38.5441703796387, 0.672722680574368, -81.3080596923828, -1.41909335004017, 218, 58, 'PPL', 'P'),
(145973, 'Osbornes Mills', 40.1536102294922, 0.700812705067115, -74.0591735839844, -1.29257642034654, 218, 37, 'PPL', 'P'),
(50135, 'Osborns Ruins', 39.4575004577637, 0.688663297595146, -76.2847213745117, -1.33141955695172, 218, 25, 'PPL', 'P'),
(104989, 'Osborns Store', 36.9786109924316, 0.6453985146321, -81.6561126708984, -1.42516802048664, 218, 53, 'PPL', 'P'),
(145974, 'Osbornsville', 40.038330078125, 0.69880068686356, -74.1080627441406, -1.2934296971598, 218, 37, 'PPL', 'P'),
(67532, 'Osbornville', 36.0755615234375, 0.629637328089766, -80.8977813720703, -1.41193264250116, 218, 33, 'PPL', 'P'),
(42453, 'Osburn', 30.9211101531982, 0.539675180545158, -92.6975021362305, -1.6178766206517, 218, 22, 'PPL', 'P'),
(165589, 'Osburn', 40.2966690063477, 0.703309551747118, -79.3633270263672, -1.38515136194711, 218, 45, 'PPL', 'P'),
(195422, 'Osburn', 47.5061111450195, 0.829138054298964, -115.998329162598, -2.02455277069949, 218, 17, 'PPL', 'P'),
(37550, 'Oscaloosa', 37.0969390869141, 0.647463729478429, -82.8886108398438, -1.44667917155954, 218, 21, 'PPL', 'P'),
(37551, 'Oscar', 37.1363906860352, 0.648152289778269, -89.0269393920898, -1.55381321536541, 218, 21, 'PPL', 'P'),
(42454, 'Oscar', 30.6149997711182, 0.534332546503322, -91.4611129760742, -1.596297558971, 218, 22, 'PPL', 'P'),
(56731, 'Oscar', 37.4141693115234, 0.653000441384704, -91.8302764892578, -1.60274067775429, 218, 29, 'PPL', 'P'),
(76850, 'Oscar', 33.9838905334473, 0.593130782445987, -97.7525024414063, -1.70610301966633, 218, 42, 'PPL', 'P'),
(96825, 'Oscar', 31.0505599975586, 0.54193450654544, -97.2619400024414, -1.69754108991978, 218, 51, 'PPL', 'P'),
(110787, 'Oscar', 38.0586090087891, 0.664248035932545, -80.3677825927734, -1.40268241877088, 218, 58, 'PPL', 'P'),
(165590, 'Oscar', 40.8402786254883, 0.712797329446635, -79.3713912963867, -1.38529211001072, 218, 45, 'PPL', 'P'),
(33523, 'Oscar (historical)', 39.5175018310547, 0.689710519114792, -97.1272201538086, -1.69518978499335, 218, 20, 'PPL', 'P'),
(197198, 'Oscar (historical)', 48.4238891601563, 0.845156302465518, -109.608329772949, -1.91302624214969, 218, 31, 'PPL', 'P'),
(144281, 'Oscars Mobile Home Park', 43.660831451416, 0.762025262985504, -72.2613906860352, -1.26119918954128, 218, 36, 'PPL', 'P'),
(23678, 'Oscarville', 34.2483291625977, 0.597746107194121, -83.9749984741211, -1.46564021273063, 218, 13, 'PPL', 'P'),
(212074, 'Oscarville', 60.7227783203125, 1.05981241264809, -161.770004272461, -2.82341920551974, 218, 1, 'PPL', 'P'),
(151452, 'Oscawana', 41.2277793884277, 0.719560493613918, -73.914436340332, -1.29005027889454, 218, 40, 'PPL', 'P'),
(151456, 'Oscawana Corners', 41.3783302307129, 0.722188101503445, -73.8563919067383, -1.28903721241588, 218, 40, 'PPL', 'P'),
(11010, 'Osceola', 35.7050018310547, 0.623169841382508, -89.9694366455078, -1.57026289562855, 218, 4, 'PPL', 'P'),
(17455, 'Osceola', 28.7927799224854, 0.502528810449487, -81.059440612793, -1.41475412851805, 218, 12, 'PPL', 'P'),
(42456, 'Osceola', 31.9694404602051, 0.55797199605087, -91.2527770996094, -1.59266141197667, 218, 22, 'PPL', 'P'),
(56732, 'Osceola', 38.0466690063477, 0.664039643577246, -93.7041702270508, -1.63544629331128, 218, 29, 'PPL', 'P'),
(67533, 'Osceola', 36.2277793884277, 0.632294031014202, -79.6158294677734, -1.38955836091897, 218, 33, 'PPL', 'P'),
(73805, 'Osceola', 39.3416709899902, 0.686641692011667, -84.0552825927734, -1.46704143493817, 218, 41, 'PPL', 'P'),
(96824, 'Osceola', 32.1305618286133, 0.560784094424912, -97.226936340332, -1.69693016076572, 218, 51, 'PPL', 'P'),
(104990, 'Osceola', 36.6730613708496, 0.640065667707271, -81.8627777099609, -1.42877500586704, 218, 53, 'PPL', 'P'),
(110788, 'Osceola', 38.7138900756836, 0.675684848075835, -79.6336135864258, -1.38986875234402, 218, 58, 'PPL', 'P'),
(117160, 'Osceola', 41.0338897705078, 0.716176481395782, -93.7652816772461, -1.63651288932786, 218, 16, 'PPL', 'P'),
(120923, 'Osceola', 41.2130584716797, 0.719303565147753, -89.7797164916992, -1.5669516542872, 218, 18, 'PPL', 'P'),
(123378, 'Osceola', 41.6650009155273, 0.727191448822404, -86.0758285522461, -1.50230661461884, 218, 19, 'PPL', 'P'),
(132460, 'Osceola', 47.2313919067383, 0.824343299072386, -88.45361328125, -1.5438067870436, 218, 27, 'PPL', 'P'),
(142608, 'Osceola', 41.1797218322754, 0.718721731028598, -97.5472183227539, -1.7025201358938, 218, 35, 'PPL', 'P'),
(151453, 'Osceola', 43.5, 0.759218224617533, -75.7225036621094, -1.32160700675727, 218, 40, 'PPL', 'P'),
(165591, 'Osceola', 41.9819412231445, 0.732723100722607, -77.3427810668945, -1.34988618226644, 218, 45, 'PPL', 'P'),
(171027, 'Osceola', 44.4674987792969, 0.77610426382529, -97.8383331298828, -1.7076010477795, 218, 49, 'PPL', 'P'),
(175710, 'Osceola', 45.3205604553223, 0.790992998794514, -92.704719543457, -1.61800258817126, 218, 57, 'PPL', 'P'),
(190575, 'Osceola', 39.0905609130859, 0.682258994384751, -114.384719848633, -1.99638997532995, 218, 39, 'PPL', 'P'),
(208355, 'Osceola', 47.1952781677246, 0.823712995421391, -122.036109924316, -2.12993192450505, 218, 56, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(76851, 'Osceola (historical)', 35.750560760498, 0.623964994704979, -99.1769409179688, -1.73096416107444, 218, 42, 'PPL', 'P'),
(165592, 'Osceola Mills', 40.8499984741211, 0.712966972808073, -78.2708282470703, -1.36608366117436, 218, 45, 'PPL', 'P'),
(23679, 'Osceola Village', 33.9383316040039, 0.592335629123517, -83.5344390869141, -1.4579510008733, 218, 13, 'PPL', 'P'),
(262, 'Osco', 31.8769397735596, 0.55635755450855, -85.2358322143555, -1.48764591281795, 218, 2, 'PPL', 'P'),
(120925, 'Osco', 41.3477783203125, 0.721654870074184, -90.2802810668945, -1.57568815424321, 218, 18, 'PPL', 'P'),
(132464, 'Oscoda', 44.420280456543, 0.775280148625965, -83.3308334350586, -1.45439741187275, 218, 27, 'PPL', 'P'),
(189177, 'Oscura', 33.4836082458496, 0.584399209337999, -106.053886413574, -1.85098950245295, 218, 38, 'PPL', 'P'),
(76852, 'Oseuma', 36.7297210693359, 0.641054565999045, -94.8905563354492, -1.65615263710275, 218, 42, 'PPL', 'P'),
(506, 'Osgood', 38.6577796936035, 0.674705537163986, -99.8438873291016, -1.74260457188307, 218, 20, 'PPL', 'P'),
(30749, 'Osgood', 39.1291694641113, 0.682932840719568, -85.2916717529297, -1.48862049661887, 218, 19, 'PPL', 'P'),
(67534, 'Osgood', 35.5538902282715, 0.620532446375976, -79.1286087036133, -1.38105475440029, 218, 33, 'PPL', 'P'),
(110789, 'Osgood', 39.5666694641113, 0.690568656197043, -80.0772171020508, -1.3976110942651, 218, 58, 'PPL', 'P'),
(117165, 'Osgood', 43.1933288574219, 0.753865803458692, -94.7011108398438, -1.65284618945137, 218, 16, 'PPL', 'P'),
(139375, 'Osgood', 40.1994400024414, 0.70161258550052, -93.3469390869141, -1.62921143372524, 218, 29, 'PPL', 'P'),
(156971, 'Osgood', 40.3397216796875, 0.704060962648684, -84.4952774047852, -1.47472079309947, 218, 41, 'PPL', 'P'),
(165595, 'Osgood', 41.4447212219238, 0.723346842893738, -80.3677825927734, -1.40268241877088, 218, 45, 'PPL', 'P'),
(195423, 'Osgood', 43.5702781677246, 0.760444810036597, -112.10221862793, -1.95655281384789, 218, 17, 'PPL', 'P'),
(151455, 'Osgood Landing', 42.5722198486328, 0.743025406241525, -76.6455612182617, -1.33771740029754, 218, 40, 'PPL', 'P'),
(165596, 'Oshanter', 40.9352798461914, 0.714455413541318, -78.461669921875, -1.36941447674972, 218, 45, 'PPL', 'P'),
(137317, 'Oshawa', 44.3002815246582, 0.773185772165699, -94.1050033569336, -1.64244215117881, 218, 28, 'PPL', 'P'),
(175714, 'Oshkosh', 44.0247192382813, 0.768376302974098, -88.5425033569336, -1.54535821153662, 218, 57, 'PPL', 'P'),
(199586, 'Oshkosh', 41.4049987792969, 0.722653555482963, -102.343887329102, -1.78623780318293, 218, 35, 'PPL', 'P'),
(42457, 'Oshkosh (historical)', 32.0297203063965, 0.559024077839506, -92.9922180175781, -1.62302038313913, 218, 22, 'PPL', 'P'),
(209651, 'Oshoto', 44.5875015258789, 0.778198706864583, -104.937217712402, -1.83149995696353, 218, 59, 'PPL', 'P'),
(132467, 'Oshtemo', 42.2588882446289, 0.737556738101101, -85.6774978637695, -1.49535443259319, 218, 27, 'PPL', 'P'),
(187147, 'Osier', 37.0133285522461, 0.64600445035912, -106.335830688477, -1.85591035835714, 218, 7, 'PPL', 'P'),
(23680, 'Osierfield', 31.6669406890869, 0.552692379058329, -83.1161117553711, -1.45064981158679, 218, 13, 'PPL', 'P'),
(200111, 'Osino', 40.9322204589844, 0.714402017161462, -115.659721374512, -2.01864294992449, 218, 39, 'PPL', 'P'),
(56734, 'Osiris', 37.667781829834, 0.657426814853497, -94.0355606079102, -1.64123014656671, 218, 29, 'PPL', 'P'),
(192737, 'Osiris', 38.0222206115723, 0.663612938591588, -111.960830688477, -1.95408512878183, 218, 52, 'PPL', 'P'),
(28160, 'Oskaloosa', 38.7597198486328, 0.676484728509241, -88.6488876342773, -1.54721496744863, 218, 18, 'PPL', 'P'),
(33524, 'Oskaloosa', 39.2152786254883, 0.684435729101727, -95.3125, -1.6635169433071, 218, 20, 'PPL', 'P'),
(56735, 'Oskaloosa', 37.6391716003418, 0.656927472149108, -94.5922164916992, -1.65094562453943, 218, 29, 'PPL', 'P'),
(117166, 'Oskaloosa', 41.2963905334473, 0.720757983998072, -92.644172668457, -1.61694584585072, 218, 16, 'PPL', 'P'),
(208356, 'Oskams Corner', 47.7322196960449, 0.833084392981271, -122.192497253418, -2.13266139830627, 218, 56, 'PPL', 'P'),
(132469, 'Oskar', 47.1747207641602, 0.82335420104353, -88.6483306884766, -1.54720524691065, 218, 27, 'PPL', 'P'),
(212075, 'Oskawalik', 61.7438888549805, 1.07763415350484, -158.192779541016, -2.76098485587225, 218, 1, 'PPL', 'P'),
(89704, 'Oslin', 35.5283317565918, 0.620086366893387, -86.7641677856445, -1.51432040061229, 218, 50, 'PPL', 'P'),
(17457, 'Oslo', 27.586389541626, 0.481473326239103, -80.3805618286133, -1.40290545851218, 218, 12, 'PPL', 'P'),
(137322, 'Oslo', 48.1952781677246, 0.841166287941334, -97.1316680908203, -1.69526741613913, 218, 28, 'PPL', 'P'),
(137324, 'Oslund', 47.6555595397949, 0.831746420849615, -94.0330581665039, -1.64118647072484, 218, 28, 'PPL', 'P'),
(120927, 'Osman', 40.2958297729492, 0.703294904361123, -88.4719390869141, -1.54412663269052, 218, 18, 'PPL', 'P'),
(175717, 'Osman', 43.9686088562012, 0.767396992062248, -87.8208312988281, -1.53276265800304, 218, 57, 'PPL', 'P'),
(191993, 'Osman', 29.8908290863037, 0.521693383706888, -101.652221679688, -1.77416596027771, 218, 51, 'PPL', 'P'),
(67535, 'Osmond', 36.4469413757324, 0.636119129287883, -79.1586074829102, -1.3815783318706, 218, 33, 'PPL', 'P'),
(142610, 'Osmond', 42.3600006103516, 0.739321481797442, -97.5963897705078, -1.70337833955507, 218, 35, 'PPL', 'P'),
(209652, 'Osmond Community', 42.6830596923828, 0.744959926457358, -110.93138885498, -1.93611797932955, 218, 59, 'PPL', 'P'),
(140654, 'Osnabrock', 48.6688919067383, 0.849432407069804, -98.1508331298828, -1.71305520169199, 218, 34, 'PPL', 'P'),
(208357, 'Oso', 48.2708282470703, 0.84248488557606, -121.928329467773, -2.12805080066907, 218, 56, 'PPL', 'P'),
(17458, 'Osochi (historical)', 30.6333293914795, 0.534652458729268, -84.9499969482422, -1.48265714630596, 218, 12, 'PPL', 'P'),
(11008, 'Osotouy (historical)', 33.9666709899902, 0.592830244716972, -91.2624969482422, -1.5928310553381, 218, 4, 'PPL', 'P'),
(17459, 'Osowaw Junction', 27.5791702270508, 0.481347325430028, -80.8349990844727, -1.41083688487065, 218, 12, 'PPL', 'P'),
(17460, 'Osprey', 27.1958293914795, 0.474656765691963, -82.4905624389648, -1.4397319163819, 218, 12, 'PPL', 'P'),
(67537, 'Osprey', 36.1855583190918, 0.631557134340577, -75.758056640625, -1.32222752329126, 218, 33, 'PPL', 'P'),
(113879, 'Osprey Beach', 41.315559387207, 0.721092543610014, -72.0941696166992, -1.25828063130266, 218, 8, 'PPL', 'P'),
(120928, 'Ospur', 40.0886116027832, 0.699678265021768, -88.9552764892578, -1.55256246175945, 218, 18, 'PPL', 'P'),
(33526, 'Osro', 37.0658302307129, 0.646920777511189, -96.4358291625977, -1.6831227357781, 218, 20, 'PPL', 'P'),
(23681, 'Ossahatchie', 32.6538887023926, 0.569917871436529, -84.7766723632813, -1.47963206162374, 218, 13, 'PPL', 'P'),
(132470, 'Ossawinamakee Beach', 45.9980583190918, 0.80281756719252, -86.2936096191406, -1.50610761128465, 218, 27, 'PPL', 'P'),
(132471, 'Osseo', 41.8858299255371, 0.731045642130994, -84.5441665649414, -1.47557406991273, 218, 27, 'PPL', 'P'),
(137325, 'Osseo', 45.1194381713867, 0.787482752740708, -93.4022216796875, -1.63017629698818, 218, 28, 'PPL', 'P'),
(175718, 'Osseo', 44.5722198486328, 0.777931991281411, -91.2272186279297, -1.59221533249408, 218, 57, 'PPL', 'P'),
(61192, 'Osseola', 33.3058280944824, 0.581296360351947, -90.8724975585938, -1.58602428190797, 218, 30, 'PPL', 'P'),
(197196, 'Ossette (historical)', 48.5916709899902, 0.848084647821142, -106.008888244629, -1.85020413624749, 218, 31, 'PPL', 'P'),
(110790, 'Ossia', 38.5888900756836, 0.673503186510843, -81.0269393920898, -1.41418687520586, 218, 58, 'PPL', 'P'),
(117168, 'Ossian', 43.1463890075684, 0.753046548528357, -91.7644424438477, -1.60159165690197, 218, 16, 'PPL', 'P'),
(123380, 'Ossian', 40.8805618286133, 0.713500403974416, -85.166389465332, -1.48643390820586, 218, 19, 'PPL', 'P'),
(151457, 'Ossian', 42.521110534668, 0.742133380434402, -77.7797164916992, -1.35751214404788, 218, 40, 'PPL', 'P'),
(132472, 'Ossineke', 44.9022216796875, 0.783691609770926, -83.442497253418, -1.45634631315847, 218, 27, 'PPL', 'P'),
(151459, 'Ossining', 41.1627807617188, 0.718426053568572, -73.8619384765625, -1.2891340183215, 218, 40, 'PPL', 'P'),
(67536, 'Ossipee', 36.1719398498535, 0.631319447213287, -79.5108337402344, -1.38772583977289, 218, 33, 'PPL', 'P'),
(144282, 'Ossipee', 43.6852798461914, 0.762451967971162, -71.1172180175781, -1.24122960926537, 218, 36, 'PPL', 'P'),
(144283, 'Ossipee Lake Shores', 43.8025016784668, 0.764497874899588, -71.0941696166992, -1.24082733878272, 218, 36, 'PPL', 'P'),
(128445, 'Ossipee Mills', 43.6508293151855, 0.761850692776049, -70.7611083984375, -1.23501432391335, 218, 26, 'PPL', 'P'),
(144284, 'Ossipee Valley', 43.7919387817383, 0.764313517573127, -71.1780624389648, -1.24229154475004, 218, 36, 'PPL', 'P'),
(104991, 'Osso', 38.3097190856934, 0.668630733559461, -77.230827331543, -1.34793222097465, 218, 53, 'PPL', 'P'),
(42458, 'Ossun', 30.2758293151855, 0.528412905321808, -92.1122207641602, -1.60766153365848, 218, 22, 'PPL', 'P'),
(17461, 'Osteen', 28.8458309173584, 0.50345472498148, -81.1627807617188, -1.4165577543663, 218, 12, 'PPL', 'P'),
(89705, 'Ostella', 35.3227806091309, 0.616498822588942, -86.7919387817383, -1.51480509593069, 218, 50, 'PPL', 'P'),
(165599, 'Ostend', 40.8691711425781, 0.713301598999041, -78.7191696166992, -1.37390869424728, 218, 45, 'PPL', 'P'),
(137327, 'Oster', 44.9799995422363, 0.785049089557566, -93.9819412231445, -1.64029431175966, 218, 28, 'PPL', 'P'),
(165597, 'Osterburg', 40.1694412231445, 0.70108900803021, -78.5205612182617, -1.37044232377244, 218, 45, 'PPL', 'P'),
(117169, 'Osterdock', 42.7336082458496, 0.745842165147474, -91.1577835083008, -1.59100346104004, 218, 16, 'PPL', 'P'),
(165598, 'Osterhout', 41.5097198486328, 0.724481282939085, -75.8988876342773, -1.32468548781935, 218, 45, 'PPL', 'P'),
(125750, 'Osterville', 41.6283302307129, 0.726551424633431, -70.3874969482422, -1.22849357398429, 218, 23, 'PPL', 'P'),
(137328, 'Ostrander', 43.6136093139648, 0.761201081207152, -92.4277801513672, -1.61316908395082, 218, 28, 'PPL', 'P'),
(156973, 'Ostrander', 40.2661094665527, 0.702776187159803, -83.2127838134766, -1.45233705729541, 218, 41, 'PPL', 'P'),
(175720, 'Ostrander', 44.3927803039551, 0.774800180418505, -88.8377838134766, -1.55051182772009, 218, 57, 'PPL', 'P'),
(208358, 'Ostrander', 46.1927795410156, 0.806216093638598, -122.890830993652, -2.14484962135113, 218, 56, 'PPL', 'P'),
(137329, 'Ostrander Mobile Home Park', 43.6169395446777, 0.761259204697943, -92.4277801513672, -1.61316908395082, 218, 28, 'PPL', 'P'),
(42459, 'Ostrica', 29.3680591583252, 0.512569327233249, -89.529167175293, -1.56257874377729, 218, 22, 'PPL', 'P'),
(183909, 'Ostrom', 39.0694389343262, 0.681890346310856, -121.510559082031, -2.12075933192054, 218, 6, 'PPL', 'P'),
(67538, 'Ostwalt', 35.6824989318848, 0.622777091700749, -80.8613891601563, -1.41129747858118, 218, 33, 'PPL', 'P'),
(139376, 'Oswald', 40.2686080932617, 0.702819796422653, -95.2388916015625, -1.66223223439724, 218, 29, 'PPL', 'P'),
(140656, 'Oswald', 46.0588912963867, 0.803879302940108, -96.727783203125, -1.6882182950498, 218, 34, 'PPL', 'P'),
(183915, 'Oswald', 39.0691719055176, 0.681885685778949, -121.625, -2.1227567027381, 218, 6, 'PPL', 'P'),
(110791, 'Oswald (historical)', 37.860279083252, 0.660786525726687, -81.1725006103516, -1.41672739772774, 218, 58, 'PPL', 'P'),
(82795, 'Oswald Park', 34.0349998474121, 0.594022808253109, -81.4136123657227, -1.42093559172423, 218, 48, 'PPL', 'P'),
(82796, 'Oswald Place', 32.7194404602051, 0.571061965440827, -79.938606262207, -1.39519187873087, 218, 48, 'PPL', 'P'),
(76853, 'Oswalt', 34.0275001525879, 0.593891913885532, -97.3344421386719, -1.69880649091174, 218, 42, 'PPL', 'P'),
(117180, 'Oswalt', 41.6958312988281, 0.727729540520654, -93.2975006103516, -1.62834856953205, 218, 16, 'PPL', 'P'),
(165600, 'Oswayo', 41.9211082458496, 0.73166136497502, -78.0186080932617, -1.36168158905051, 218, 45, 'PPL', 'P'),
(113880, 'Oswegatchie', 41.3549995422363, 0.721780904172772, -72.1766662597656, -1.25972046934601, 218, 8, 'PPL', 'P'),
(151461, 'Oswegatchie', 44.1827812194824, 0.771135004968284, -75.070556640625, -1.3102283846838, 218, 40, 'PPL', 'P'),
(33527, 'Oswego', 37.1674995422363, 0.648695241745509, -95.1097183227539, -1.65997773537643, 218, 20, 'PPL', 'P'),
(61193, 'Oswego', 33.2169418334961, 0.579745002437949, -90.2244415283203, -1.57471357044229, 218, 30, 'PPL', 'P'),
(67539, 'Oswego', 36.1500015258789, 0.630936551227561, -78.1975021362305, -1.36480387911252, 218, 33, 'PPL', 'P'),
(82797, 'Oswego', 34.0072212219238, 0.59353797977666, -80.2877807617188, -1.40128612341135, 218, 48, 'PPL', 'P'),
(89706, 'Oswego', 36.5699996948242, 0.638266902128004, -84.1563873291016, -1.46880604547646, 218, 50, 'PPL', 'P'),
(120929, 'Oswego', 41.6827812194824, 0.727501773668425, -88.3513870239258, -1.5420226022713, 218, 18, 'PPL', 'P'),
(123381, 'Oswego', 41.3202781677246, 0.721174901866724, -85.7872161865234, -1.49726937857501, 218, 19, 'PPL', 'P'),
(151467, 'Oswego', 43.4552803039551, 0.758437718681058, -76.5108337402344, -1.33536596221306, 218, 40, 'PPL', 'P'),
(197197, 'Oswego', 48.0586090087891, 0.838780961131978, -105.880561828613, -1.84796441777073, 218, 31, 'PPL', 'P'),
(151463, 'Oswego Beach', 43.4500007629395, 0.758345573307342, -76.5569381713867, -1.33617063633643, 218, 40, 'PPL', 'P'),
(151464, 'Oswego Bitter', 43.0611114501953, 0.751558174374138, -76.3638916015625, -1.33280133808331, 218, 40, 'PPL', 'P'),
(151465, 'Oswego Center', 43.4144401550293, 0.757724923615299, -76.5341720581055, -1.33577329270179, 218, 40, 'PPL', 'P'),
(4808, 'Oswichee', 32.2794418334961, 0.563382540700502, -85.0038909912109, -1.48359777480298, 218, 2, 'PPL', 'P'),
(61194, 'Osyka', 31.0066699981689, 0.541168481547392, -90.4722213745117, -1.57903814457842, 218, 30, 'PPL', 'P'),
(183912, 'Otay', 32.5947189331055, 0.568885164144824, -117.063606262207, -2.04314536353377, 218, 6, 'PPL', 'P'),
(67540, 'Oteen', 35.5872192382813, 0.621114147337076, -82.4913864135742, -1.43974629745179, 218, 33, 'PPL', 'P'),
(33530, 'Otego', 39.827220916748, 0.695116136916408, -98.3469390869141, -1.71647789632496, 218, 20, 'PPL', 'P'),
(151470, 'Otego', 42.3972206115723, 0.73997109336634, -75.1738891601563, -1.312031877374, 218, 40, 'PPL', 'P'),
(178765, 'Otero', 31.5305595397949, 0.550312078965529, -111.014167785645, -1.93756274422092, 218, 5, 'PPL', 'P'),
(89707, 'Otes', 36.3088912963867, 0.633709700870661, -83.023063659668, -1.44902581595406, 218, 50, 'PPL', 'P'),
(96826, 'Otey', 29.2855606079102, 0.511129455900384, -95.545280456543, -1.66757972870807, 218, 51, 'PPL', 'P'),
(183916, 'Oteys Sierra Village', 37.3586082458496, 0.652030717852779, -118.45832824707, -2.06748785431958, 218, 6, 'PPL', 'P'),
(67541, 'Othello', 36.3622207641602, 0.634640475671643, -81.4463882446289, -1.42150763872638, 218, 33, 'PPL', 'P'),
(71226, 'Othello', 39.4124984741211, 0.687877864810654, -75.3472213745117, -1.31505709521428, 218, 37, 'PPL', 'P'),
(208359, 'Othello', 46.8261108398438, 0.817269810059081, -119.174171447754, -2.07998167509952, 218, 56, 'PPL', 'P'),
(104992, 'Othma', 37.7724990844727, 0.659254475730592, -77.9800033569336, -1.36100780929472, 218, 53, 'PPL', 'P'),
(4809, 'Otho', 31.6894397735596, 0.553085062161061, -85.1297225952148, -1.48579395059591, 218, 2, 'PPL', 'P'),
(61195, 'Otho', 32.235279083252, 0.562611755302006, -89.408332824707, -1.56046978651006, 218, 30, 'PPL', 'P'),
(117170, 'Otho', 42.4247207641602, 0.740451061573799, -94.1500015258789, -1.64322751738427, 218, 16, 'PPL', 'P'),
(73806, 'Otho (historical)', 39.6811103820801, 0.692566027014602, -81.6977767944336, -1.42589519662228, 218, 41, 'PPL', 'P'),
(37554, 'Otia', 36.6877784729004, 0.640322529594409, -85.5691680908203, -1.49346372137728, 218, 21, 'PPL', 'P'),
(4810, 'Otipalin (historical)', 33.7999992370605, 0.589921273858278, -86.0611114501953, -1.5020497527317, 218, 2, 'PPL', 'P'),
(17462, 'Otis', 30.3091697692871, 0.52899480601999, -81.8952789306641, -1.42934225917923, 218, 12, 'PPL', 'P'),
(33531, 'Otis', 38.5347213745117, 0.672557764323864, -99.0527801513672, -1.72879714689544, 218, 20, 'PPL', 'P'),
(42460, 'Otis', 31.2152805328369, 0.544809422231694, -92.727783203125, -1.61840512497003, 218, 22, 'PPL', 'P'),
(56736, 'Otis', 36.6133308410645, 0.639023173298559, -89.6033325195313, -1.56387317322513, 218, 29, 'PPL', 'P'),
(117172, 'Otis', 41.9513893127441, 0.732189869293346, -91.6230621337891, -1.59912410499396, 218, 16, 'PPL', 'P'),
(123382, 'Otis', 41.5991706848145, 0.726042494549117, -86.9058303833008, -1.51679287936832, 218, 19, 'PPL', 'P'),
(125751, 'Otis', 42.1930618286133, 0.736407850406841, -73.0922164916992, -1.27569983536065, 218, 23, 'PPL', 'P'),
(128446, 'Otis', 44.7122192382813, 0.780375441581559, -68.4533309936523, -1.19473600979672, 218, 26, 'PPL', 'P'),
(151473, 'Otis', 43.2586097717285, 0.755005170352055, -77.8786087036133, -1.35923813875036, 218, 40, 'PPL', 'P'),
(175721, 'Otis', 45.2688903808594, 0.790091185870386, -89.6933288574219, -1.56544390563606, 218, 57, 'PPL', 'P'),
(177717, 'Otis', 32.3511085510254, 0.564633360885485, -104.168060302734, -1.81807562769872, 218, 38, 'PPL', 'P'),
(194359, 'Otis', 40.1488914489746, 0.700730346810404, -102.962501525879, -1.79703465771627, 218, 7, 'PPL', 'P'),
(201360, 'Otis', 45.0244407653809, 0.785824735225052, -123.945281982422, -2.16325326290607, 218, 43, 'PPL', 'P'),
(191994, 'Otis Chalk', 32.1277313232422, 0.560734692786691, -101.257049560547, -1.76726890568662, 218, 51, 'PPL', 'P'),
(199588, 'Otis Motel and Trailer Court', 42.8047218322754, 0.747083331373506, -102.202781677246, -1.78377504496488, 218, 35, 'PPL', 'P'),
(208360, 'Otis Orchards', 47.7005615234375, 0.832531853634107, -117.105278015137, -2.04387267282747, 218, 56, 'PPL', 'P'),
(125753, 'Otis Wood Lanes', 42.1855583190918, 0.736276889460237, -73.1013870239258, -1.27585989134216, 218, 23, 'PPL', 'P'),
(23685, 'Otisco', 30.8530597686768, 0.53848747727801, -84.4655609130859, -1.47420214247718, 218, 13, 'PPL', 'P'),
(30750, 'Otisco', 38.5422210693359, 0.672688658691442, -85.6672210693359, -1.49517506869377, 218, 19, 'PPL', 'P'),
(137332, 'Otisco', 43.9786109924316, 0.767571562271703, -93.5019378662109, -1.63191667276054, 218, 28, 'PPL', 'P'),
(151474, 'Otisco', 42.8600006103516, 0.748048128057414, -76.2183303833008, -1.33026081556143, 218, 40, 'PPL', 'P'),
(151475, 'Otisco Valley', 42.8286094665527, 0.747500249242157, -76.2322235107422, -1.33050329637868, 218, 40, 'PPL', 'P'),
(128448, 'Otisfield Gore', 44.1483306884766, 0.770533729773171, -70.5644378662109, -1.23158177558434, 218, 26, 'PPL', 'P'),
(132475, 'Otisville', 43.1661109924316, 0.753390762099249, -83.5244369506836, -1.45777643066384, 218, 27, 'PPL', 'P'),
(137334, 'Otisville', 45.246940612793, 0.789708090147578, -92.7647171020508, -1.61904974311188, 218, 28, 'PPL', 'P'),
(151477, 'Otisville', 41.473331451416, 0.723846185598128, -74.5388870239258, -1.30094899933958, 218, 40, 'PPL', 'P'),
(117173, 'Otley', 41.4588890075684, 0.723594117400952, -93.0355606079102, -1.62377685404677, 218, 16, 'PPL', 'P'),
(56737, 'Oto', 36.8586082458496, 0.643304071592807, -93.454719543457, -1.63109255756122, 218, 29, 'PPL', 'P'),
(117174, 'Oto', 42.2838897705078, 0.737993097045711, -95.8927764892578, -1.67364467861656, 218, 16, 'PPL', 'P'),
(76854, 'Otoe', 36.3838882446289, 0.635018644546435, -97.1830596923828, -1.69616436879427, 218, 42, 'PPL', 'P'),
(142612, 'Otoe', 40.7236099243164, 0.71076107647716, -96.1166687011719, -1.67755233488403, 218, 35, 'PPL', 'P'),
(189179, 'Otowi', 35.8758316040039, 0.626151383380907, -106.141937255859, -1.85252627955998, 218, 38, 'PPL', 'P'),
(82798, 'Otranto', 32.9650001525879, 0.575347790583092, -80.0444412231445, -1.39703904726295, 218, 48, 'PPL', 'P'),
(117176, 'Otranto', 43.4583282470703, 0.758490915323833, -92.9855575561523, -1.62290413615755, 218, 16, 'PPL', 'P'),
(23683, 'Otranto Hills', 33.5530586242676, 0.585611347108148, -84.456672668457, -1.47404701334368, 218, 13, 'PPL', 'P'),
(151478, 'Otsdawa', 42.4847183227539, 0.741498216514419, -75.1747207641602, -1.31204639160194, 218, 40, 'PPL', 'P'),
(110792, 'Otsego', 37.6124992370605, 0.656461951590562, -81.3755569458008, -1.42027139934836, 218, 58, 'PPL', 'P'),
(132476, 'Otsego', 42.4605598449707, 0.741076571534832, -85.6963882446289, -1.49568413193614, 218, 27, 'PPL', 'P'),
(137336, 'Otsego', 45.274169921875, 0.790183331244103, -93.5911102294922, -1.63347302410158, 218, 28, 'PPL', 'P'),
(156975, 'Otsego', 41.4474983215332, 0.723395312425578, -83.779167175293, -1.46222231178762, 218, 41, 'PPL', 'P'),
(175722, 'Otsego', 43.4022216796875, 0.757511670991011, -89.1661071777344, -1.55624215143761, 218, 57, 'PPL', 'P'),
(123383, 'Otsego Center', 41.5724983215332, 0.725576973990571, -84.9088897705078, -1.48193969070829, 218, 19, 'PPL', 'P'),
(132478, 'Otsego Lake', 44.9169387817383, 0.783948471658064, -84.692497253418, -1.4781629288084, 218, 27, 'PPL', 'P'),
(151480, 'Otselic', 42.7224998474121, 0.745648287020116, -75.7202835083008, -1.32156825776341, 218, 40, 'PPL', 'P'),
(151481, 'Otselic Center', 42.7011108398438, 0.745274978414314, -75.7461090087891, -1.32201899777791, 218, 40, 'PPL', 'P'),
(11009, 'Ott', 36.4986114501953, 0.637020942212011, -92.0791702270508, -1.60708469296637, 218, 4, 'PPL', 'P'),
(82799, 'Ott (historical)', 33.3125, 0.581412807070611, -81.0936126708984, -1.41535054344417, 218, 48, 'PPL', 'P'),
(78888, 'Ott Town', 39.9780616760254, 0.697748804812006, -78.4466705322266, -1.36915268801457, 218, 45, 'PPL', 'P'),
(67542, 'Ottanola', 35.3916702270508, 0.617701173242085, -82.2786102294922, -1.43603265246973, 218, 33, 'PPL', 'P'),
(33532, 'Ottawa', 38.6155586242676, 0.673968640490361, -95.2675018310547, -1.66273157710163, 218, 20, 'PPL', 'P'),
(37552, 'Ottawa', 37.3616714477539, 0.652084180811662, -84.4561080932617, -1.47403715964765, 218, 21, 'PPL', 'P'),
(76857, 'Ottawa', 36.8566703796387, 0.643270249446963, -94.7874984741211, -1.65435393810251, 218, 42, 'PPL', 'P'),
(110793, 'Ottawa', 37.958610534668, 0.662502733312161, -81.8166732788086, -1.42797033174367, 218, 58, 'PPL', 'P'),
(117179, 'Ottawa', 41.311939239502, 0.721029360113151, -93.5019378662109, -1.63191667276054, 218, 16, 'PPL', 'P'),
(120931, 'Ottawa', 41.3455581665039, 0.721616121080323, -88.8424987792969, -1.55059411939777, 218, 18, 'PPL', 'P'),
(132482, 'Ottawa', 41.767219543457, 0.728975500436648, -83.5213928222656, -1.45772330060009, 218, 27, 'PPL', 'P'),
(137338, 'Ottawa', 44.3822212219238, 0.774615889671072, -93.945556640625, -1.63965928099773, 218, 28, 'PPL', 'P'),
(156976, 'Ottawa', 41.0191688537598, 0.715919552929616, -84.0472183227539, -1.46690068687456, 218, 41, 'PPL', 'P'),
(165604, 'Ottawa', 41.0816688537598, 0.717010383712113, -76.7038879394531, -1.33873539362423, 218, 45, 'PPL', 'P'),
(175724, 'Ottawa', 42.9761085510254, 0.750074593909883, -88.4497222900391, -1.5437388764358, 218, 57, 'PPL', 'P'),
(132483, 'Ottawa Center', 43.0294418334961, 0.751005435289893, -86.0311126708984, -1.50152617526139, 218, 27, 'PPL', 'P'),
(23684, 'Ottawa Estates', 32.1324996948242, 0.560817916570756, -81.2944412231445, -1.41885566291288, 218, 13, 'PPL', 'P'),
(156979, 'Ottawa Hills', 41.6641693115234, 0.727176934594463, -83.6433334350586, -1.45985156578523, 218, 41, 'PPL', 'P'),
(33534, 'Ottawa Junction', 38.6341705322266, 0.674293479564324, -95.2694396972656, -1.66276539924747, 218, 20, 'PPL', 'P'),
(37553, 'Ottenheim', 37.4230613708496, 0.653155637097228, -84.595832824707, -1.47647581625783, 218, 21, 'PPL', 'P'),
(140657, 'Ottention (historical)', 48.9958305358887, 0.855138562600435, -97.5605621337891, -1.70275302933112, 218, 34, 'PPL', 'P'),
(156982, 'Otter', 40.2758293151855, 0.702945830521241, -83.4191665649414, -1.4559391158278, 218, 41, 'PPL', 'P'),
(197199, 'Otter', 45.2077789306641, 0.789024589853809, -106.201110839844, -1.85355905343071, 218, 31, 'PPL', 'P'),
(120933, 'Otter (historical)', 41.1791687011719, 0.718712077069646, -88.7786102294922, -1.54947905384936, 218, 18, 'PPL', 'P'),
(113881, 'Otter Cove Estates', 41.3372192382813, 0.72147057932675, -72.3711090087891, -1.2631141355231, 218, 8, 'PPL', 'P'),
(17463, 'Otter Creek', 29.3247203826904, 0.51181292290464, -82.7719421386719, -1.44464291859006, 218, 12, 'PPL', 'P'),
(23686, 'Otter Creek', 31.3236103057861, 0.546700133447596, -82.1344375610352, -1.43351636471376, 218, 13, 'PPL', 'P'),
(117181, 'Otter Creek', 42.2405586242676, 0.737236825875156, -90.682502746582, -1.58270824687666, 218, 16, 'PPL', 'P'),
(128450, 'Otter Creek', 44.3183288574219, 0.773500757543628, -68.2080612182617, -1.19045524466052, 218, 26, 'PPL', 'P'),
(137340, 'Otter Creek', 46.6252784729004, 0.813764624011346, -92.5386123657227, -1.6151034710086, 218, 28, 'PPL', 'P'),
(151484, 'Otter Creek', 43.7186088562012, 0.763033668932263, -75.3677825927734, -1.31541595617117, 218, 40, 'PPL', 'P'),
(198721, 'Otter Creek', 47.0491714477539, 0.821162952098613, -101.554718017578, -1.77246420034115, 218, 34, 'PPL', 'P'),
(67543, 'Otter Creek (historical)', 35.5202789306641, 0.619945818566858, -82.0944366455078, -1.432818217034, 218, 33, 'PPL', 'P'),
(30751, 'Otter Creek Junction', 39.5463905334473, 0.690214722088171, -87.3483276367188, -1.5245159133715, 218, 19, 'PPL', 'P'),
(89708, 'Otter Creek Junction', 35.9355583190918, 0.627193811210591, -84.9319381713867, -1.48234196119095, 218, 50, 'PPL', 'P'),
(123, 'Otter Hill', 37.2577781677246, 0.650270901004455, -79.4480590820313, -1.38663021530043, 218, 53, 'PPL', 'P'),
(82800, 'Otter Hole', 32.1949996948242, 0.561908747353252, -80.73388671875, -1.40907214117431, 218, 48, 'PPL', 'P'),
(151485, 'Otter Hook', 42.4041709899902, 0.740092400353993, -73.7994384765625, -1.288043187539, 218, 40, 'PPL', 'P'),
(151486, 'Otter Kill', 41.3777809143066, 0.722178514123521, -74.2949981689453, -1.29669233581125, 218, 40, 'PPL', 'P'),
(132485, 'Otter Lake', 43.2133293151855, 0.754214877298574, -83.4544372558594, -1.45655470551377, 218, 27, 'PPL', 'P'),
(151487, 'Otter Lake', 43.5911102294922, 0.76080839810442, -75.1122207641602, -1.31095556081945, 218, 40, 'PPL', 'P'),
(37555, 'Otter Pond', 37.0277786254883, 0.646256651714351, -87.8230590820313, -1.53280154015495, 218, 21, 'PPL', 'P'),
(125754, 'Otter River', 42.5977783203125, 0.743471485724113, -72.0513916015625, -1.25753401409106, 218, 23, 'PPL', 'P'),
(201361, 'Otter Rock', 44.7472190856934, 0.780986304156596, -124.060279846191, -2.1652603542616, 218, 43, 'PPL', 'P'),
(104995, 'Otter View (historical)', 37.1166687011719, 0.647808076207377, -79.5708312988281, -1.38877299471351, 218, 53, 'PPL', 'P'),
(30754, 'Otter Village', 39.1186103820801, 0.682748549972134, -85.3313903808594, -1.48931371745061, 218, 19, 'PPL', 'P'),
(123385, 'Otterbein', 40.4905586242676, 0.706693563965255, -87.0963897705078, -1.52011876809567, 218, 19, 'PPL', 'P'),
(156986, 'Otterbein', 40.584171295166, 0.708327413294018, -83.5055618286133, -1.457446997637, 218, 41, 'PPL', 'P'),
(177406, 'Otterbein', 40.1202812194824, 0.700231004106014, -77.6013870239258, -1.35439970768191, 218, 45, 'PPL', 'P'),
(183917, 'Otterbein', 33.9874992370605, 0.593193766205767, -117.883888244629, -2.05746198492181, 218, 6, 'PPL', 'P'),
(104993, 'Otterburn', 37.3388900756836, 0.651686570860913, -77.9986114501953, -1.36133258178966, 218, 53, 'PPL', 'P'),
(104994, 'Otterdale', 37.4469413757324, 0.653572421807826, -77.708610534668, -1.35627111097991, 218, 53, 'PPL', 'P'),
(50136, 'Otterdale Mill', 39.6161117553711, 0.691431586969256, -77.1672210693359, -1.34682208227425, 218, 25, 'PPL', 'P'),
(104996, 'Otterdam Mobile Home Park', 36.7541694641113, 0.641481270984703, -77.4858322143555, -1.35238289578839, 218, 53, 'PPL', 'P'),
(50137, 'Ottersdale', 39.6316719055176, 0.691703162821417, -77.1669387817383, -1.34681715542623, 218, 25, 'PPL', 'P'),
(137344, 'Ottertail', 46.4255599975586, 0.810278879039568, -95.5569381713867, -1.66778319421535, 218, 28, 'PPL', 'P'),
(104997, 'Otterview Gardens', 37.3522186279297, 0.651919197982132, -79.9711074829102, -1.39575913204306, 218, 53, 'PPL', 'P'),
(28164, 'Otterville', 39.0505599975586, 0.681560846704986, -90.3983306884766, -1.57774850882055, 218, 18, 'PPL', 'P'),
(56738, 'Otterville', 38.6997184753418, 0.675437506989594, -93.0019378662109, -1.62319002650057, 218, 29, 'PPL', 'P'),
(105001, 'Otterville', 37.4308280944824, 0.653291191996713, -79.4861068725586, -1.38729427451824, 218, 53, 'PPL', 'P'),
(117188, 'Otterville', 42.5086097717285, 0.741915200962098, -91.9463882446289, -1.60476721018578, 218, 16, 'PPL', 'P'),
(144286, 'Otterville', 43.4294395446777, 0.757986712350453, -72.0461120605469, -1.25744186871734, 218, 36, 'PPL', 'P'),
(4811, 'Ottery', 33.7991714477539, 0.589906826209364, -86.0372161865234, -1.50163270170499, 218, 2, 'PPL', 'P'),
(96828, 'Ottine', 29.5977802276611, 0.516578716254364, -97.5838928222656, -1.7031602266618, 218, 51, 'PPL', 'P'),
(89709, 'Ottinger', 36.0563888549805, 0.629302701898797, -83.045280456543, -1.44941357220877, 218, 50, 'PPL', 'P'),
(175728, 'Ottman Corners', 44.7033309936523, 0.780220312448062, -92.5169372558594, -1.61472516897575, 218, 57, 'PPL', 'P'),
(11013, 'Otto', 35.0294418334961, 0.611379095130346, -92.192497253418, -1.60906262270797, 218, 4, 'PPL', 'P'),
(30755, 'Otto', 38.5708312988281, 0.673188001395832, -85.4669418334961, -1.49167953660499, 218, 19, 'PPL', 'P'),
(56741, 'Otto', 38.3708305358887, 0.669697329576038, -90.5002822875977, -1.57952789990288, 218, 29, 'PPL', 'P'),
(67544, 'Otto', 35.060001373291, 0.611912459717662, -83.3877792358398, -1.45539130359157, 218, 33, 'PPL', 'P'),
(96827, 'Otto', 31.4488906860352, 0.548886688571092, -96.8086090087891, -1.68962897147921, 218, 51, 'PPL', 'P'),
(110794, 'Otto', 38.7522201538086, 0.676353834141663, -81.2211074829102, -1.41757574769299, 218, 58, 'PPL', 'P'),
(120935, 'Otto', 41.0472183227539, 0.716409108517, -87.89111328125, -1.53398931000113, 218, 18, 'PPL', 'P'),
(137346, 'Otto', 48.0880584716797, 0.839294951222363, -94.6072235107422, -1.65120754643264, 218, 28, 'PPL', 'P'),
(151488, 'Otto', 42.3561096191406, 0.739253571189645, -78.8319396972656, -1.37587690345091, 218, 40, 'PPL', 'P'),
(165607, 'Otto', 40.7188911437988, 0.710678718220449, -76.7980575561523, -1.34037896349097, 218, 45, 'PPL', 'P'),
(189180, 'Otto', 35.0730590820313, 0.612140359727945, -106.008331298828, -1.85019441570951, 218, 38, 'PPL', 'P'),
(209655, 'Otto', 41.0908317565918, 0.717170306535572, -105.074440002441, -1.83389493773184, 218, 59, 'PPL', 'P'),
(23687, 'Otto (historical)', 34.8197212219238, 0.607718779949114, -83.9797210693359, -1.46572263756637, 218, 13, 'PPL', 'P'),
(120936, 'Otto (historical)', 40.2986106872559, 0.70334344047199, -90.2069396972656, -1.57440810586526, 218, 18, 'PPL', 'P'),
(151489, 'Otto Mills', 43.6025009155273, 0.761007203079794, -75.8197174072266, -1.32330370668776, 218, 40, 'PPL', 'P'),
(104998, 'Ottobine', 38.4313888549805, 0.670754271633663, -79.0397186279297, -1.37950332990727, 218, 53, 'PPL', 'P'),
(156983, 'Ottokee', 41.6022186279297, 0.726095691191891, -84.1344375610352, -1.46842294975365, 218, 41, 'PPL', 'P'),
(156984, 'Ottokee Station', 41.5997200012207, 0.726052081929041, -84.1549987792969, -1.46878181071054, 218, 41, 'PPL', 'P'),
(104999, 'Ottoman', 37.7016716003418, 0.658018302931604, -76.5202789306641, -1.33553081188453, 218, 53, 'PPL', 'P'),
(117189, 'Ottosen', 42.8950004577637, 0.748658990632451, -94.3797225952148, -1.64723690640539, 218, 16, 'PPL', 'P'),
(156985, 'Ottoville', 40.9322204589844, 0.714402017161462, -84.3388900756836, -1.47199131929825, 218, 41, 'PPL', 'P'),
(105000, 'Ottoway', 37.9130592346191, 0.661707713147745, -78.7919387817383, -1.37517875577114, 218, 53, 'PPL', 'P'),
(165609, 'Ottsville', 40.4730606079102, 0.70638816596725, -75.1613922119141, -1.31181376448072, 218, 45, 'PPL', 'P'),
(33540, 'Ottumwa', 38.2777786254883, 0.66807326736428, -95.7986068725586, -1.67200110874982, 218, 20, 'PPL', 'P'),
(117190, 'Ottumwa', 41.0200004577637, 0.715934067157557, -92.4111099243164, -1.61287813360173, 218, 16, 'PPL', 'P'),
(202465, 'Ottumwa', 44.2336082458496, 0.772022103927389, -101.346672058105, -1.76883311335288, 218, 49, 'PPL', 'P'),
(117191, 'Ottumwa Junction', 41.0483283996582, 0.71642848301393, -92.4394378662109, -1.6133725494581, 218, 16, 'PPL', 'P'),
(37556, 'Ottusville', 38.3227806091309, 0.668858700148772, -84.8955612182617, -1.48170706358708, 218, 21, 'PPL', 'P'),
(120938, 'Ottville', 41.3480606079102, 0.7216597969222, -89.2586135864258, -1.55785669284847, 218, 18, 'PPL', 'P'),
(89710, 'Ottway', 36.267219543457, 0.63298239157696, -82.866943359375, -1.44630100268474, 218, 50, 'PPL', 'P'),
(67545, 'Otway', 34.7755584716797, 0.606947994550618, -76.5583267211914, -1.33619487110234, 218, 33, 'PPL', 'P'),
(73809, 'Otway', 38.8663902282715, 0.678346477848288, -83.1875, -1.45189577150278, 218, 41, 'PPL', 'P'),
(11014, 'Otwell', 35.725830078125, 0.623533362871304, -90.8377838134766, -1.58541841275998, 218, 4, 'PPL', 'P'),
(30756, 'Otwell', 38.454719543457, 0.671161468964336, -87.0922164916992, -1.52004593063986, 218, 19, 'PPL', 'P'),
(11015, 'Ouachita', 33.8522186279297, 0.59083267416233, -92.8291702270508, -1.62017466235633, 218, 4, 'PPL', 'P'),
(42461, 'Ouachita City', 32.7249984741211, 0.571158971083533, -92.0708312988281, -1.6069391512128, 218, 22, 'PPL', 'P'),
(151491, 'Ouaquaga', 42.1261100769043, 0.735239321899542, -75.6474990844727, -1.32029792992344, 218, 40, 'PPL', 'P'),
(42464, 'Oubre', 30.0166702270508, 0.52388972594739, -90.7080612182617, -1.58315432635925, 218, 22, 'PPL', 'P'),
(128451, 'Ouellette', 47.1708297729492, 0.823286290435733, -68.3933334350586, -1.1936888548561, 218, 26, 'PPL', 'P'),
(199589, 'Ough', 40.3222198486328, 0.703755498071652, -101.512222290039, -1.77172250997756, 218, 35, 'PPL', 'P'),
(11022, 'Ouitaville', 35.3027801513672, 0.61614974874906, -93.170280456543, -1.6261281589732, 218, 4, 'PPL', 'P'),
(175729, 'Oulu', 46.6330604553223, 0.81390044522694, -91.5316696166992, -1.59752900465906, 218, 57, 'PPL', 'P'),
(4812, 'Our Town', 32.8280601501465, 0.5729577366628, -85.9619369506836, -1.5003188311812, 218, 2, 'PPL', 'P'),
(187149, 'Ouray', 38.0227813720703, 0.663622725708594, -107.670829772949, -1.8792104878923, 218, 7, 'PPL', 'P'),
(205262, 'Ouray', 40.089168548584, 0.699687985559747, -109.676666259766, -1.91421893884388, 218, 52, 'PPL', 'P'),
(67546, 'Ourdell', 35.7833290100098, 0.624536908549073, -80.8499984741211, -1.4110986736058, 218, 33, 'PPL', 'P'),
(33542, 'Oursler', 38.2905616760254, 0.668296373684601, -96.982780456543, -1.69266883670548, 218, 20, 'PPL', 'P'),
(175731, 'Ourtown', 43.6972198486328, 0.762660360326461, -87.8211135864258, -1.53276758485106, 218, 57, 'PPL', 'P'),
(23688, 'Ousley', 30.7941703796387, 0.537459663544807, -83.4308319091797, -1.45614271449313, 218, 13, 'PPL', 'P'),
(178766, 'Out West Trailer Park', 33.4508285522461, 0.583827095756822, -112.128059387207, -1.9570038201785, 218, 5, 'PPL', 'P'),
(197200, 'Outback Mobile Home Settlement', 48.4111099243164, 0.844933262724224, -114.336669921875, -1.99555134590269, 218, 31, 'PPL', 'P'),
(145975, 'Outcalt', 40.3772201538086, 0.704715434486571, -74.4077835083008, -1.29866081133099, 218, 37, 'PPL', 'P'),
(78889, 'Outcrop', 39.7658309936523, 0.694044680630842, -79.8252792358398, -1.39321394898927, 218, 45, 'PPL', 'P'),
(137348, 'Outing', 46.8205604553223, 0.817172937574429, -93.9477767944336, -1.63969802999159, 218, 28, 'PPL', 'P'),
(183918, 'Outingdale', 38.6166687011719, 0.673988014987291, -120.728889465332, -2.10711662344634, 218, 6, 'PPL', 'P'),
(82801, 'Outland', 33.7266693115234, 0.588641425217413, -79.3727798461914, -1.38531634477664, 218, 48, 'PPL', 'P'),
(67547, 'Outlaws Bridge', 35.1391716003418, 0.613294240849249, -77.8497161865234, -1.35873386919796, 218, 33, 'PPL', 'P'),
(165610, 'Outlet', 41.339168548584, 0.721504601209676, -76.0605621337891, -1.32750724015234, 218, 45, 'PPL', 'P'),
(195424, 'Outlet Bay', 48.4944381713867, 0.846387614995516, -116.892219543457, -2.04015410099739, 218, 17, 'PPL', 'P'),
(197201, 'Outlook', 48.8875007629395, 0.853247851384533, -104.777221679688, -1.82870749940253, 218, 31, 'PPL', 'P'),
(208361, 'Outlook', 46.3313903808594, 0.808635309172826, -120.089996337891, -2.09596583480412, 218, 56, 'PPL', 'P'),
(73810, 'Outville', 39.9949989318848, 0.698044415693004, -82.595832824707, -1.44156923121795, 218, 41, 'PPL', 'P'),
(165612, 'Outwood', 40.5441703796387, 0.707629265614254, -76.4763870239258, -1.33476475359697, 218, 45, 'PPL', 'P'),
(212076, 'Ouzinkie', 57.9236106872559, 1.01095772113599, -152.502212524414, -2.66166572512716, 218, 1, 'PPL', 'P'),
(37557, 'Ova', 37.7252807617188, 0.658430360531267, -83.1716690063477, -1.45161946853969, 218, 21, 'PPL', 'P'),
(67549, 'Oval', 36.3302803039551, 0.634083009476462, -81.4883270263672, -1.42223960855199, 218, 33, 'PPL', 'P'),
(165611, 'Oval', 41.1511116027832, 0.718222388324208, -77.1694412231445, -1.34686083126811, 218, 45, 'PPL', 'P'),
(156991, 'Oval City', 40.8958282470703, 0.713766853241478, -81.3274993896484, -1.41943263676304, 218, 41, 'PPL', 'P'),
(96837, 'Ovalo', 32.172779083252, 0.561520924519509, -99.807502746582, -1.74196954112114, 218, 51, 'PPL', 'P'),
(197202, 'Ovando', 47.0202789306641, 0.820658682546206, -113.132217407227, -1.97452968383815, 218, 31, 'PPL', 'P'),
(110795, 'Ovapa', 38.5213890075684, 0.672325070623619, -81.1488876342773, -1.41631527354905, 218, 58, 'PPL', 'P'),
(183919, 'Ovejo (historical)', 37.0544395446777, 0.646721972535815, -120.315559387207, -2.09990265268553, 218, 6, 'PPL', 'P'),
(37558, 'Oven Fork', 37.0591697692871, 0.646804530529607, -82.8086090087891, -1.44528287620001, 218, 21, 'PPL', 'P'),
(73811, 'Over-The-Rhine', 39.1113891601563, 0.682622515873546, -84.5152816772461, -1.47506993351838, 218, 41, 'PPL', 'P'),
(89711, 'Overall', 35.810001373291, 0.625002429107619, -86.4749984741211, -1.50927344403049, 218, 50, 'PPL', 'P'),
(112630, 'Overall', 38.8061103820801, 0.677294396059652, -78.3477783203125, -1.36742669331209, 218, 53, 'PPL', 'P'),
(89712, 'Overall Acres', 35.8255615234375, 0.62527400495978, -86.3150024414063, -1.50648098646948, 218, 50, 'PPL', 'P'),
(4813, 'Overbrook', 33.1216697692871, 0.578082191232331, -86.1983337402344, -1.50444473350001, 218, 2, 'PPL', 'P'),
(14356, 'Overbrook', 38.7675018310547, 0.676620549724835, -75.2152786254883, -1.31275425981969, 218, 10, 'PPL', 'P'),
(23689, 'Overbrook', 32.2374992370605, 0.562650504295866, -81.8122177124023, -1.42789256743984, 218, 13, 'PPL', 'P'),
(33543, 'Overbrook', 38.7805595397949, 0.676848449735118, -95.5569381713867, -1.66778319421535, 218, 20, 'PPL', 'P'),
(50138, 'Overbrook', 39.4347190856934, 0.688265687644397, -77.4691696166992, -1.35209207859735, 218, 25, 'PPL', 'P'),
(71227, 'Overbrook', 39.8177795410156, 0.694951353823959, -74.9883270263672, -1.30879320717236, 218, 37, 'PPL', 'P'),
(76866, 'Overbrook', 34.0672187805176, 0.594585134717279, -97.1408309936523, -1.69542733896259, 218, 42, 'PPL', 'P'),
(82802, 'Overbrook', 34.8597183227539, 0.608416861049851, -82.378059387207, -1.43776836771019, 218, 48, 'PPL', 'P'),
(89713, 'Overbrook', 35.2108306884766, 0.614544927876178, -84.9088897705078, -1.48193969070829, 218, 50, 'PPL', 'P'),
(125755, 'Overbrook', 42.3050003051758, 0.738361545382523, -71.3249969482422, -1.24485603572173, 218, 23, 'PPL', 'P'),
(165613, 'Overbrook', 40.3849983215332, 0.704851189123138, -79.9936065673828, -1.39615181514579, 218, 45, 'PPL', 'P'),
(4814, 'Overbrook Estates', 33.7272186279297, 0.588651012597337, -86.6416702270508, -1.51218241488918, 218, 2, 'PPL', 'P'),
(50140, 'Overbrook Manor', 38.3925018310547, 0.670075565029856, -75.6002807617188, -1.31947381472412, 218, 25, 'PPL', 'P'),
(14357, 'Overbrook Shores', 38.7583312988281, 0.676460493743321, -75.2255630493164, -1.31293375687716, 218, 10, 'PPL', 'P'),
(61196, 'Overby', 33.1436080932617, 0.578465087218057, -90.8533325195313, -1.58568978887506, 218, 30, 'PPL', 'P'),
(11024, 'Overcup', 35.3541717529297, 0.617046701404198, -91.2302780151367, -1.59226872887393, 218, 4, 'PPL', 'P'),
(96829, 'Overcup Landing', 33.2377815246582, 0.580108723663826, -94.3661117553711, -1.64699935243615, 218, 51, 'PPL', 'P'),
(37559, 'Overda', 38.1197204589844, 0.665314631949121, -82.8002777099609, -1.44513746760449, 218, 21, 'PPL', 'P'),
(110796, 'Overfield', 39.1691703796387, 0.683630988399332, -80.2044372558594, -1.39983150482395, 218, 58, 'PPL', 'P'),
(178768, 'Overgaard', 34.3908309936523, 0.600233233336147, -110.55249786377, -1.92950508402678, 218, 5, 'PPL', 'P'),
(110797, 'Overhill', 38.9619407653809, 0.680014149322896, -80.1516723632813, -1.398910583719, 218, 58, 'PPL', 'P'),
(67553, 'Overhills', 35.2208290100098, 0.614719431506605, -79.0319366455078, -1.37936750869167, 218, 33, 'PPL', 'P'),
(132487, 'Overisel', 42.728328704834, 0.745750019773757, -86.0097198486328, -1.50115280007656, 218, 27, 'PPL', 'P'),
(128452, 'Overlake', 44.7419395446777, 0.780894158782879, -70.0899963378906, -1.22330120880696, 218, 26, 'PPL', 'P'),
(208362, 'Overlake', 47.6436080932617, 0.831537828757235, -122.141937255859, -2.13177895987907, 218, 56, 'PPL', 'P'),
(56740, 'Overland', 38.7011108398438, 0.675461808334541, -90.3622207641602, -1.57711827174858, 218, 29, 'PPL', 'P'),
(96830, 'Overland', 33.1552810668945, 0.578668819041448, -95.7472229003906, -1.67110428925273, 218, 51, 'PPL', 'P'),
(142616, 'Overland', 41.0774993896484, 0.716937612835326, -97.9858322143555, -1.71017539244723, 218, 35, 'PPL', 'P'),
(117192, 'Overland Mobile Home Park', 41.2511100769043, 0.719967690944591, -95.8944396972656, -1.67367370707244, 218, 16, 'PPL', 'P'),
(33544, 'Overland Park', 38.9822196960449, 0.680368083431767, -94.6705627441406, -1.65231302460113, 218, 20, 'PPL', 'P'),
(178769, 'Overland Trail', 33.6555595397949, 0.587400325570409, -112.160003662109, -1.95756135295271, 218, 5, 'PPL', 'P'),
(50141, 'Overlea', 39.3633308410645, 0.687019727728403, -76.5208282470703, -1.33554039926446, 218, 25, 'PPL', 'P'),
(105002, 'Overlee Knolls', 38.8894386291504, 0.678748748330944, -77.148063659668, -1.34648772239939, 218, 53, 'PPL', 'P'),
(4815, 'Overlook', 34.8019409179688, 0.607408455103092, -85.6800003051758, -1.49539810843506, 218, 2, 'PPL', 'P'),
(23691, 'Overlook', 33.9444389343262, 0.592442222146147, -84.2441711425781, -1.47033816205158, 218, 13, 'PPL', 'P'),
(50143, 'Overlook', 38.9433288574219, 0.679689310248933, -76.1305618286133, -1.32872896530242, 218, 25, 'PPL', 'P'),
(67551, 'Overlook', 35.3077812194824, 0.616237033853787, -82.48388671875, -1.43961540308421, 218, 33, 'PPL', 'P'),
(113882, 'Overlook', 41.5666694641113, 0.72547524123693, -73.0486068725586, -1.27493870392111, 218, 8, 'PPL', 'P'),
(145976, 'Overlook', 40.7125015258789, 0.710567198349802, -74.351936340332, -1.29768609437202, 218, 37, 'PPL', 'P'),
(151492, 'Overlook', 43.2924995422363, 0.755596658430162, -73.9469375610352, -1.29061753220673, 218, 40, 'PPL', 'P'),
(165615, 'Overlook', 40.8199996948242, 0.712443395337763, -76.5752792358398, -1.33649074829945, 218, 45, 'PPL', 'P'),
(183920, 'Overlook', 32.7713890075684, 0.571968638633945, -117.198333740234, -2.04549680161825, 218, 6, 'PPL', 'P'),
(14358, 'Overlook Colony', 39.8041687011719, 0.694713799854724, -75.4694366455078, -1.31719015408938, 218, 10, 'PPL', 'P'),
(105003, 'Overlook Heights', 38.4605598449707, 0.671263401455059, -78.0430603027344, -1.3621083606152, 218, 53, 'PPL', 'P'),
(165616, 'Overlook Heights', 40.8072204589844, 0.712220355596469, -77.8844375610352, -1.35933987150401, 218, 45, 'PPL', 'P'),
(156987, 'Overlook Hills', 40.3836097717285, 0.704826954357218, -80.6922225952148, -1.40834496503866, 218, 41, 'PPL', 'P'),
(23692, 'Overlook Lake', 33.9494400024414, 0.592529507250874, -83.2874984741211, -1.45364107412317, 218, 13, 'PPL', 'P'),
(165617, 'Overlook Springs', 40.5361099243164, 0.707488584129671, -75.4766693115234, -1.31731638792505, 218, 45, 'PPL', 'P'),
(23694, 'Overlook Village', 33.9269409179688, 0.592136824148142, -83.4702835083008, -1.45683127479297, 218, 13, 'PPL', 'P'),
(198722, 'Overly', 48.6819381713867, 0.849660107343006, -100.149719238281, -1.74794234565592, 218, 34, 'PPL', 'P'),
(73812, 'Overpeck', 39.4508285522461, 0.688546850876482, -84.5144424438477, -1.47505528613238, 218, 41, 'PPL', 'P'),
(67552, 'Overshot', 35.3063888549805, 0.61621273250884, -78.3633270263672, -1.36769806942716, 218, 33, 'PPL', 'P'),
(165618, 'Overshot', 41.7619400024414, 0.728883355062931, -76.524169921875, -1.33559872249233, 218, 45, 'PPL', 'P'),
(17464, 'Overstreet', 29.9980602264404, 0.523564920162941, -85.3688888549805, -1.4899681892885, 218, 12, 'PPL', 'P'),
(4818, 'Overton', 33.5044403076172, 0.584762797405822, -86.6897201538086, -1.51302104431645, 218, 2, 'PPL', 'P'),
(50145, 'Overton', 39.0327796936035, 0.681250521858965, -76.2102813720703, -1.33012033381393, 218, 25, 'PPL', 'P'),
(56747, 'Overton', 38.9477806091309, 0.679767007973736, -92.5761108398438, -1.61575794284649, 218, 29, 'PPL', 'P'),
(89714, 'Overton', 35.246940612793, 0.615175164948145, -89.9955596923828, -1.57071882880718, 218, 50, 'PPL', 'P'),
(96831, 'Overton', 32.2744407653809, 0.563295255595775, -94.9783325195313, -1.65768462051982, 218, 51, 'PPL', 'P'),
(105004, 'Overton', 37.957218170166, 0.662478431967214, -78.4677810668945, -1.36952113635138, 218, 53, 'PPL', 'P'),
(142617, 'Overton', 40.7386093139648, 0.711022865212315, -99.5372161865234, -1.73725215072423, 218, 35, 'PPL', 'P'),
(156988, 'Overton', 40.8647193908691, 0.713223901274238, -82.0102767944336, -1.43134935053477, 218, 41, 'PPL', 'P'),
(177410, 'Overton', 41.5699996948242, 0.725533364727721, -76.5033264160156, -1.33523493468743, 218, 45, 'PPL', 'P'),
(190578, 'Overton', 36.5433311462402, 0.637801448148485, -114.446113586426, -1.99746149819455, 218, 39, 'PPL', 'P'),
(42465, 'Overton (historical)', 32.5875015258789, 0.568759196625263, -93.3033294677734, -1.6284503022857, 218, 22, 'PPL', 'P'),
(200112, 'Overton (historical)', 41.9541702270508, 0.732238405404213, -118.693061828613, -2.0715847281825, 218, 39, 'PPL', 'P'),
(4820, 'Overton Manor', 33.4650001525879, 0.584074436843063, -86.7244415283203, -1.51362704662249, 218, 2, 'PPL', 'P'),
(165620, 'Overview', 40.3188896179199, 0.703697374580861, -76.9233322143555, -1.34256541874592, 218, 45, 'PPL', 'P'),
(14359, 'Overview Gardens', 39.7138900756836, 0.693138140595779, -75.565559387207, -1.31886781241807, 218, 10, 'PPL', 'P'),
(50148, 'Overview Manor', 39.4874992370605, 0.689186875065455, -76.3005599975586, -1.33169599307287, 218, 25, 'PPL', 'P'),
(61197, 'Ovett', 31.485279083252, 0.549521785912048, -89.0327835083008, -1.55391521443516, 218, 30, 'PPL', 'P'),
(117193, 'Ovia', 40.8549995422363, 0.7130542579128, -93.317497253418, -1.62869757679291, 218, 16, 'PPL', 'P'),
(132491, 'Ovid', 43.0058288574219, 0.750593311111203, -84.3716735839844, -1.47256349945845, 218, 27, 'PPL', 'P'),
(151493, 'Ovid', 42.6763916015625, 0.744843546317722, -76.8233337402344, -1.34082011612554, 218, 40, 'PPL', 'P'),
(156989, 'Ovid', 40.0433311462402, 0.698887971968287, -82.8091735839844, -1.44529272989604, 218, 41, 'PPL', 'P'),
(194360, 'Ovid', 40.9605598449707, 0.714896632754917, -102.387496948242, -1.78699893462247, 218, 7, 'PPL', 'P'),
(195425, 'Ovid', 42.288890838623, 0.738080382150438, -111.397499084473, -1.94425313751142, 218, 17, 'PPL', 'P'),
(56742, 'Ovid (historical)', 39.4674987792969, 0.688837801225573, -93.8838882446289, -1.63858296444317, 218, 29, 'PPL', 'P'),
(17465, 'Oviedo', 28.6697196960449, 0.500381004319852, -81.2083282470703, -1.41735270795169, 218, 12, 'PPL', 'P'),
(56743, 'Oviet (historical)', 38.6502799987793, 0.674574642796409, -94.2161102294922, -1.64438133192655, 218, 29, 'PPL', 'P'),
(37561, 'Ovil', 36.9469413757324, 0.644845775547854, -87.288330078125, -1.52346875843088, 218, 21, 'PPL', 'P'),
(89716, 'Ovilla', 35.3133316040039, 0.616333906338439, -87.5611114501953, -1.52822969151162, 218, 50, 'PPL', 'P'),
(96832, 'Ovilla', 32.5263900756836, 0.567692600608686, -96.8861083984375, -1.69098159099686, 218, 51, 'PPL', 'P'),
(142620, 'Ovina', 40.9686088562012, 0.715037114502419, -98.4550018310547, -1.71836394700895, 218, 35, 'PPL', 'P'),
(208363, 'Ovington', 48.064998626709, 0.838892481002625, -123.85888671875, -2.16174538109686, 218, 56, 'PPL', 'P'),
(89717, 'Ovoca', 35.4094390869141, 0.618011298351025, -86.2044372558594, -1.50455125994361, 218, 50, 'PPL', 'P'),
(28165, 'Owaneco', 39.4822196960449, 0.689094729691739, -89.1936111450195, -1.5567221862241, 218, 18, 'PPL', 'P'),
(137349, 'Owanka', 44.1261100769043, 0.770145906939428, -95.6755599975586, -1.66985353564678, 218, 28, 'PPL', 'P'),
(202466, 'Owanka', 44.0222206115723, 0.768332693711248, -102.586936950684, -1.79047981932526, 218, 49, 'PPL', 'P'),
(117194, 'Owasa', 42.4336090087891, 0.740606190707297, -93.2069396972656, -1.62676798342509, 218, 16, 'PPL', 'P'),
(123386, 'Owasco', 40.4608306884766, 0.70617471360588, -86.628059387207, -1.51194486091994, 218, 19, 'PPL', 'P'),
(139377, 'Owasco', 40.1380615234375, 0.700541328952035, -92.977783203125, -1.62276844810001, 218, 29, 'PPL', 'P'),
(151495, 'Owasco', 42.8549995422363, 0.747960842952687, -76.4655609130859, -1.33457580231763, 218, 40, 'PPL', 'P'),
(199591, 'Owasco', 41.2394409179688, 0.719764025700227, -103.574440002441, -1.80771499895193, 218, 35, 'PPL', 'P'),
(151496, 'Owasco Hill', 42.7275009155273, 0.745735572124844, -76.4649963378906, -1.3345659486216, 218, 40, 'PPL', 'P'),
(151497, 'Owasco Lake Station', 42.8405609130859, 0.747708841334538, -76.5266723632813, -1.33564239833421, 218, 40, 'PPL', 'P'),
(4821, 'Owassa', 31.4930591583252, 0.549657573838129, -86.9316711425781, -1.51724388569893, 218, 2, 'PPL', 'P'),
(96833, 'Owassa Estates Colonia', 26.242000579834, 0.458009312428364, -98.1220016479492, -1.71255199740402, 218, 51, 'PPL', 'P'),
(96834, 'Owassa Rd-Tower Rd Colonia', 26.238000869751, 0.45793950431829, -98.0910034179688, -1.71201097622857, 218, 51, 'PPL', 'P'),
(96835, 'Owassa-I Rd Colonia', 26.2450008392334, 0.458061676833298, -98.161003112793, -1.71323270137864, 218, 51, 'PPL', 'P'),
(96836, 'Owassa-Kennedy Colonia', 26.2439994812012, 0.458044199838644, -98.1520004272461, -1.71307557487433, 218, 51, 'PPL', 'P'),
(165621, 'Owassee', 41.7133293151855, 0.728034938518659, -77.4569396972656, -1.35187862623599, 218, 45, 'PPL', 'P'),
(76867, 'Owasso', 36.2694396972656, 0.633021140570821, -95.8544387817383, -1.67297555939268, 218, 42, 'PPL', 'P'),
(137350, 'Owatonna', 44.0838890075684, 0.769409010265803, -93.225830078125, -1.62709768276804, 218, 28, 'PPL', 'P'),
(82803, 'Owdoms', 33.9844398498535, 0.593140369825911, -81.8797225952148, -1.4290707499061, 218, 48, 'PPL', 'P'),
(117195, 'Owego', 42.2794418334961, 0.737915465899935, -96.154167175293, -1.67820680672192, 218, 16, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(151499, 'Owego', 42.103328704834, 0.734841711948793, -76.2624969482422, -1.33103166753895, 218, 40, 'PPL', 'P'),
(23695, 'Owen', 31.3436107635498, 0.547049207287478, -82.1900024414063, -1.43448615482472, 218, 13, 'PPL', 'P'),
(33547, 'Owen', 36.9991683959961, 0.645757309009961, -95.9316711425781, -1.67432351837842, 218, 20, 'PPL', 'P'),
(76869, 'Owen', 36.9991683959961, 0.645757309009961, -95.9313888549805, -1.6743185915304, 218, 42, 'PPL', 'P'),
(112319, 'Owen', 38.4580612182617, 0.671219792192209, -85.5419387817383, -1.49298848028076, 218, 19, 'PPL', 'P'),
(117196, 'Owen', 43.0374984741211, 0.751146050195449, -93.0819396972656, -1.6245863218601, 218, 16, 'PPL', 'P'),
(175733, 'Owen', 44.9486083984375, 0.78450121074231, -90.5641708374023, -1.5806429654513, 218, 57, 'PPL', 'P'),
(56744, 'Owen (historical)', 38.9188919067383, 0.679262805000357, -90.8649978637695, -1.58589338754039, 218, 29, 'PPL', 'P'),
(50146, 'Owen Brown', 39.1894416809082, 0.683984789350149, -76.8424987792969, -1.34115460915845, 218, 25, 'PPL', 'P'),
(120940, 'Owen Center', 42.3683280944824, 0.739466823813933, -89.116943359375, -1.55538408093439, 218, 18, 'PPL', 'P'),
(105005, 'Owen Corner', 36.6425018310547, 0.639532303119955, -82.4944381713867, -1.43979956067359, 218, 53, 'PPL', 'P'),
(125756, 'Owen District', 42.1591682434082, 0.735816295749707, -72.690559387207, -1.26868959642323, 218, 23, 'PPL', 'P'),
(50147, 'Owen Soper Woods', 38.6316719055176, 0.674249870301474, -76.5430603027344, -1.33592842183528, 218, 25, 'PPL', 'P'),
(132492, 'Owendale', 43.7291717529297, 0.763218026258723, -83.2680587768555, -1.45330178740029, 218, 27, 'PPL', 'P'),
(56745, 'Owenmont', 36.6199989318848, 0.639139553438196, -90.7836074829102, -1.58447285741494, 218, 29, 'PPL', 'P'),
(113883, 'Owenoke', 41.1066703796387, 0.717446742656722, -73.3608322143555, -1.28038806414363, 218, 8, 'PPL', 'P'),
(4823, 'Owens', 33.3083305358887, 0.581340036193825, -88.0597229003906, -1.53693210300567, 218, 2, 'PPL', 'P'),
(11030, 'Owens', 33.0252799987793, 0.576399872371728, -93.054443359375, -1.62410642023167, 218, 4, 'PPL', 'P'),
(14360, 'Owens', 38.8055610656738, 0.677284808679728, -75.5263900756836, -1.31818417896625, 218, 10, 'PPL', 'P'),
(56746, 'Owens', 37.2188911437988, 0.649592194400648, -92.4027786254883, -1.61273272500621, 218, 29, 'PPL', 'P'),
(67554, 'Owens', 35.0438919067383, 0.611631296485577, -78.9352798461914, -1.37768052929916, 218, 33, 'PPL', 'P'),
(82805, 'Owens', 33.6897201538086, 0.58799654075945, -78.9055633544922, -1.37716187867687, 218, 48, 'PPL', 'P'),
(105008, 'Owens', 36.8536109924316, 0.643216853067107, -77.4247207641602, -1.35131629977181, 218, 53, 'PPL', 'P'),
(145977, 'Owens', 41.2636108398438, 0.720185870416896, -74.5283279418945, -1.30076470859215, 218, 37, 'PPL', 'P'),
(156990, 'Owens', 40.5202789306641, 0.707212281166575, -83.1580581665039, -1.45138191457045, 218, 41, 'PPL', 'P'),
(191995, 'Owens', 33.5583305358887, 0.58570335932381, -101.352500915527, -1.76893484610652, 218, 51, 'PPL', 'P'),
(82806, 'Owens (historical)', 34.4150009155273, 0.600655078052815, -82.168327331543, -1.43410785279187, 218, 48, 'PPL', 'P'),
(89719, 'Owens (historical)', 35.9708290100098, 0.627809400896563, -86.774169921875, -1.51449497082175, 218, 50, 'PPL', 'P'),
(191996, 'Owens Addition Number 1 Colonia', 29.3649997711182, 0.512515930853393, -100.929000854492, -1.76154337565906, 218, 51, 'PPL', 'P'),
(191997, 'Owens Addition Number 2 Colonia', 29.367000579834, 0.512550851553187, -100.928001403809, -1.76152593195392, 218, 51, 'PPL', 'P'),
(165622, 'Owens Corners', 42.1161117553711, 0.735064818269114, -79.9199981689453, -1.39486710623594, 218, 45, 'PPL', 'P'),
(4825, 'Owens Cross Roads', 34.5880584716797, 0.603675502203128, -86.4588928222656, -1.50899234737743, 218, 2, 'PPL', 'P'),
(110799, 'Owens Crossing', 38.351390838623, 0.669358042853161, -82.2733306884766, -1.43594050709601, 218, 58, 'PPL', 'P'),
(82807, 'Owens Crossroad', 33.1566696166992, 0.578693053807368, -81.4011077880859, -1.4207173456729, 218, 48, 'PPL', 'P'),
(23696, 'Owens Meadows', 34.0261116027832, 0.593867679119612, -84.6469421386719, -1.47736784206495, 218, 13, 'PPL', 'P'),
(151501, 'Owens Mills', 42.0686111450195, 0.734235776221773, -76.5975036621094, -1.33687863771222, 218, 40, 'PPL', 'P'),
(105009, 'Owens Store', 36.6808280944824, 0.640201222606756, -79.0297164916992, -1.37932875969781, 218, 53, 'PPL', 'P'),
(61198, 'Owens Wells', 33.0950012207031, 0.577616737252812, -89.9677810668945, -1.57023400033073, 218, 30, 'PPL', 'P'),
(23697, 'Owensboro', 31.8772201538086, 0.556362448067053, -83.4280624389648, -1.45609437811935, 218, 13, 'PPL', 'P'),
(37562, 'Owensboro', 37.774169921875, 0.659283637344528, -87.1133270263672, -1.52041437897667, 218, 21, 'PPL', 'P'),
(30761, 'Owensburg', 38.9230613708496, 0.679335575877143, -86.7297210693359, -1.51371919199621, 218, 19, 'PPL', 'P'),
(23698, 'Owensbyville', 33.1872215270996, 0.579226285236629, -85.0861129760742, -1.48503281915637, 218, 13, 'PPL', 'P'),
(165623, 'Owensdale', 40.0763893127441, 0.699464945818453, -79.603889465332, -1.38934996856367, 218, 45, 'PPL', 'P'),
(11032, 'Owensville', 34.6158294677734, 0.604160197521523, -92.8213882446289, -1.62003884114073, 218, 4, 'PPL', 'P'),
(30762, 'Owensville', 38.2719383239746, 0.667971334873557, -87.6877822875977, -1.53044051469054, 218, 19, 'PPL', 'P'),
(50149, 'Owensville', 38.7363891601563, 0.676077531178568, -76.6447219848633, -1.33770275291155, 218, 25, 'PPL', 'P'),
(56748, 'Owensville', 38.3455581665039, 0.669256243520493, -91.5013885498047, -1.59700050034073, 218, 29, 'PPL', 'P'),
(73814, 'Owensville', 38.8511085510254, 0.678079762265116, -83.040283203125, -1.44932635368307, 218, 41, 'PPL', 'P'),
(96839, 'Owensville', 31.0727806091309, 0.542322329379183, -96.519172668457, -1.6845773543655, 218, 51, 'PPL', 'P'),
(105010, 'Owensville', 38.1011085510254, 0.664989792875159, -78.5752792358398, -1.37139733333934, 218, 53, 'PPL', 'P'),
(4824, 'Owenton', 33.514720916748, 0.584942227884266, -86.8555603027344, -1.5159155009472, 218, 2, 'PPL', 'P'),
(37563, 'Owenton', 38.5363883972168, 0.672586859358773, -84.8419418334961, -1.48077122878002, 218, 21, 'PPL', 'P'),
(105011, 'Owenton', 37.8836097717285, 0.66119372305736, -77.1005630493164, -1.34565868035205, 218, 53, 'PPL', 'P'),
(96840, 'Owentown', 32.4355583190918, 0.566107287390789, -95.195556640625, -1.66147589664766, 218, 51, 'PPL', 'P'),
(183921, 'Owenyo', 36.6783294677734, 0.640157613343906, -118.043327331543, -2.06024472194484, 218, 6, 'PPL', 'P'),
(50150, 'Owings', 38.7174987792969, 0.675747831835616, -76.6016693115234, -1.33695134200998, 218, 25, 'PPL', 'P'),
(82808, 'Owings', 34.6308288574219, 0.604421986256678, -82.1336135864258, -1.43350198364388, 218, 48, 'PPL', 'P'),
(110798, 'Owings', 39.3794403076172, 0.687300890960489, -80.2591705322266, -1.40078678070696, 218, 58, 'PPL', 'P'),
(50151, 'Owings Beach', 38.7724990844727, 0.676707768250535, -76.5547180175781, -1.33613188734256, 218, 25, 'PPL', 'P'),
(50152, 'Owings Farm', 38.709171295166, 0.675602489819125, -76.5494384765625, -1.33603974196885, 218, 25, 'PPL', 'P'),
(50153, 'Owings Hills', 38.7144393920898, 0.67569443545576, -76.6044387817383, -1.33699967838377, 218, 25, 'PPL', 'P'),
(50154, 'Owings Mills', 39.4194412231445, 0.687999038640253, -76.7805633544922, -1.34007363207199, 218, 25, 'PPL', 'P'),
(50155, 'Owings Ridge', 39.440559387207, 0.68836762013512, -76.791389465332, -1.34026258335133, 218, 25, 'PPL', 'P'),
(50156, 'Owings Station', 38.711669921875, 0.675646099081975, -76.6091690063477, -1.33708223637756, 218, 25, 'PPL', 'P'),
(50157, 'Owings Town Center', 38.7169418334961, 0.675738111297637, -76.6050033569336, -1.3370095320798, 218, 25, 'PPL', 'P'),
(50158, 'Owings Wood', 38.709171295166, 0.675602489819125, -76.540283203125, -1.33587995230344, 218, 25, 'PPL', 'P'),
(37564, 'Owingsville', 38.144718170166, 0.665750924314704, -83.7641677856445, -1.46196052305246, 218, 21, 'PPL', 'P'),
(195426, 'Owinza', 42.8994407653809, 0.748736488620172, -114.05583190918, -1.9906497979164, 218, 17, 'PPL', 'P'),
(178770, 'Owl', 32.7219390869141, 0.571105574703677, -113.791389465332, -1.98603440658923, 218, 5, 'PPL', 'P'),
(183922, 'Owl', 33.9277801513672, 0.592151471534138, -116.816673278809, -2.03883556994169, 218, 6, 'PPL', 'P'),
(194361, 'Owl Canyon', 40.7625007629395, 0.711439849659994, -105.175003051758, -1.83565009404826, 218, 7, 'PPL', 'P'),
(89721, 'Owl City', 35.7269401550293, 0.623552737368235, -89.1919403076172, -1.55669302461016, 218, 50, 'PPL', 'P'),
(89722, 'Owl Creek', 35.9977798461914, 0.628279781724098, -86.7027816772461, -1.51324901090576, 218, 50, 'PPL', 'P'),
(96841, 'Owl Creek', 31.2272205352783, 0.545017814586993, -97.5113906860352, -1.70189482566985, 218, 51, 'PPL', 'P'),
(209656, 'Owl Creek', 43.7811088562012, 0.764124499714759, -108.566390991211, -1.89484097980414, 218, 59, 'PPL', 'P'),
(165624, 'Owl Hollow', 41.9822196960449, 0.732727960991597, -76.3388900756836, -1.3323649791387, 218, 45, 'PPL', 'P'),
(50161, 'Owl Hollow Acres', 38.0816688537598, 0.664650506152283, -75.4377822875977, -1.31663768132124, 218, 25, 'PPL', 'P'),
(89723, 'Owl Hoot', 36.1911087036133, 0.631654006825228, -89.5338897705078, -1.56266116861303, 218, 50, 'PPL', 'P'),
(17466, 'Owl Landing', 30.0180606842041, 0.523913994002823, -85.01611328125, -1.48381109400629, 218, 12, 'PPL', 'P'),
(183923, 'Owl Mobile Manor', 34.2238883972168, 0.597319535366518, -119.142501831055, -2.07942893601528, 218, 6, 'PPL', 'P'),
(96842, 'Owl Ranch Number 1 Colonia', 27.8929996490479, 0.486824682133508, -98.0930023193359, -1.71204586363885, 218, 51, 'PPL', 'P'),
(96843, 'Owl Ranch Number 2 Colonia', 27.886999130249, 0.48671995332364, -98.0970001220703, -1.71211563845941, 218, 51, 'PPL', 'P'),
(96844, 'Owl Ranch Number 3 Colonia', 27.8950004577637, 0.486859602833301, -98.0970001220703, -1.71211563845941, 218, 51, 'PPL', 'P'),
(156998, 'Owl Town (historical)', 40.0069389343262, 0.698252808048303, -83.8216705322266, -1.46296413530926, 218, 41, 'PPL', 'P'),
(105012, 'Owl Trap', 37.5297203063965, 0.655017186699194, -76.6277770996094, -1.33740700887249, 218, 53, 'PPL', 'P'),
(96845, 'Owlett Green', 32.5019416809082, 0.567265895623028, -95.6636123657227, -1.66964501013342, 218, 51, 'PPL', 'P'),
(11033, 'Owley', 34.5141716003418, 0.602385933024285, -93.6619415283203, -1.6347092634796, 218, 4, 'PPL', 'P'),
(56749, 'Owls Bend', 37.184440612793, 0.648990919205535, -91.1872177124023, -1.59151718481431, 218, 29, 'PPL', 'P'),
(128453, 'Owls Head', 44.082218170166, 0.769379848651867, -69.0577774047852, -1.20528558982285, 218, 26, 'PPL', 'P'),
(151502, 'Owls Head', 44.7344398498535, 0.780763264415302, -74.1691665649414, -1.29449616001832, 218, 40, 'PPL', 'P'),
(14361, 'Owls Nest', 39.8138885498047, 0.694883443216162, -75.633056640625, -1.32004586172627, 218, 10, 'PPL', 'P'),
(151503, 'Owls Nest', 43.1819381713867, 0.753666998483318, -77.1388931274414, -1.34632766641788, 218, 40, 'PPL', 'P'),
(165625, 'Owls Nest', 41.4713897705078, 0.723812296873257, -78.8877792358398, -1.37685148725182, 218, 45, 'PPL', 'P'),
(156992, 'Owls Town (historical)', 40.3597183227539, 0.704409969909539, -82.1572189331055, -1.43391397466451, 218, 41, 'PPL', 'P'),
(151504, 'Owlsville', 42.4644393920898, 0.741144282405547, -74.4194412231445, -1.29886427683827, 218, 40, 'PPL', 'P'),
(23699, 'Owltown', 34.813060760498, 0.607602532967532, -83.9400024414063, -1.46502941673462, 218, 13, 'PPL', 'P'),
(67555, 'Owltown', 35.5999984741211, 0.62133718707837, -82.7238922119141, -1.4438042891628, 218, 33, 'PPL', 'P'),
(165626, 'Owltown', 41.5072212219238, 0.724437673676235, -79.6516723632813, -1.39018393745903, 218, 45, 'PPL', 'P'),
(132493, 'Owosso', 42.9977798461914, 0.750452829363701, -84.1766662597656, -1.46915997958533, 218, 27, 'PPL', 'P'),
(37565, 'Owsley', 37.5013885498047, 0.654522704263793, -82.5886077880859, -1.44144313054033, 218, 21, 'PPL', 'P'),
(56750, 'Owsley', 38.6452789306641, 0.674487357691681, -93.5152816772461, -1.63214956619787, 218, 29, 'PPL', 'P'),
(195427, 'Owyhee', 43.4183311462402, 0.757792834223096, -116.199722290039, -2.02806774386423, 218, 17, 'PPL', 'P'),
(200113, 'Owyhee', 41.9477806091309, 0.732126885533566, -116.097778320313, -2.02628848593995, 218, 39, 'PPL', 'P'),
(201362, 'Owyhee', 43.7949981689453, 0.764366913952984, -117.054168701172, -2.04298064702034, 218, 43, 'PPL', 'P'),
(195429, 'Owyhee Heights', 43.6247215270996, 0.761395025913537, -116.989723205566, -2.04185586093395, 218, 17, 'PPL', 'P'),
(113884, 'Ox Hill', 41.228328704834, 0.719570080993842, -73.2194366455078, -1.2779202459195, 218, 8, 'PPL', 'P'),
(4826, 'Ox Level', 32.0297203063965, 0.559024077839506, -85.6286087036133, -1.49450115577993, 218, 2, 'PPL', 'P'),
(183924, 'Oxalis', 36.9119415283203, 0.644234912972817, -120.548889160156, -2.10397502546643, 218, 6, 'PPL', 'P'),
(4827, 'Oxanna', 33.649169921875, 0.587288805699762, -85.8377838134766, -1.49815195016026, 218, 2, 'PPL', 'P'),
(61199, 'Oxberry', 33.7849998474121, 0.589659485123123, -90.0355606079102, -1.57141697648694, 218, 30, 'PPL', 'P'),
(175735, 'Oxbo', 45.8627815246582, 0.800456541728111, -90.7041702270508, -1.58308641575145, 218, 57, 'PPL', 'P'),
(137354, 'Oxboro', 44.8263893127441, 0.782368085288183, -93.2916717529297, -1.62824683677841, 218, 28, 'PPL', 'P'),
(42466, 'Oxbow', 32.024169921875, 0.558927205354854, -93.3955612182617, -1.63006005000659, 218, 22, 'PPL', 'P'),
(110800, 'Oxbow', 39.0938911437988, 0.682317117875542, -81.211669921875, -1.41741103117956, 218, 58, 'PPL', 'P'),
(128455, 'Oxbow', 46.4186096191406, 0.810157572051915, -68.4905624389648, -1.19538582110269, 218, 26, 'PPL', 'P'),
(132499, 'Oxbow', 42.6405601501465, 0.744218169514744, -83.4730606079102, -1.45687974432481, 218, 27, 'PPL', 'P'),
(140661, 'Oxbow', 46.6699981689453, 0.81454512994782, -96.8000030517578, -1.68947876919373, 218, 34, 'PPL', 'P'),
(151505, 'Oxbow', 44.2872200012207, 0.772957805576388, -75.6233291625977, -1.31987608520678, 218, 40, 'PPL', 'P'),
(201363, 'Oxbow', 44.9749984741211, 0.784961804452839, -116.861938476563, -2.03962559667906, 218, 43, 'PPL', 'P'),
(201364, 'Oxbow (historical)', 44.9658317565918, 0.784801815050352, -116.851387023926, -2.03944143908968, 218, 43, 'PPL', 'P'),
(178771, 'Oxbow Estates', 34.1830596923828, 0.59660694003784, -111.339721679688, -1.94324473156466, 218, 5, 'PPL', 'P'),
(132500, 'Oxbow Park', 43.5072212219238, 0.759344258716121, -85.601936340332, -1.49403563522138, 218, 27, 'PPL', 'P'),
(4828, 'Oxford', 33.6141700744629, 0.586677943124725, -85.8349990844727, -1.49810334747037, 218, 2, 'PPL', 'P'),
(11034, 'Oxford', 36.2211112976074, 0.632177650874565, -91.9291687011719, -1.60446667245677, 218, 4, 'PPL', 'P'),
(17467, 'Oxford', 28.9272193908691, 0.504875221817415, -82.0374984741211, -1.43182445847324, 218, 12, 'PPL', 'P'),
(23700, 'Oxford', 33.6188888549805, 0.586760301381436, -83.8675003051758, -1.46376401574267, 218, 13, 'PPL', 'P'),
(33549, 'Oxford', 37.274169921875, 0.650556991084556, -97.1686096191406, -1.69591216743904, 218, 20, 'PPL', 'P'),
(37567, 'Oxford', 38.2683296203613, 0.667908351113777, -84.503059387207, -1.47485661431506, 218, 21, 'PPL', 'P'),
(42468, 'Oxford', 29.853889465332, 0.521048665696493, -91.4786071777344, -1.59660289038998, 218, 22, 'PPL', 'P'),
(50159, 'Oxford', 38.6863899230957, 0.675204879868376, -76.1719436645508, -1.32945121459005, 218, 25, 'PPL', 'P'),
(61201, 'Oxford', 34.3663902282715, 0.599806661508543, -89.519172668457, -1.56240430672589, 218, 30, 'PPL', 'P'),
(67557, 'Oxford', 36.3105583190918, 0.63373879590557, -78.5911102294922, -1.37167363630244, 218, 33, 'PPL', 'P'),
(73815, 'Oxford', 39.5069389343262, 0.689526161788331, -84.7452774047852, -1.47908411622946, 218, 41, 'PPL', 'P'),
(78892, 'Oxford', 39.7852783203125, 0.694384100511772, -75.9791717529297, -1.32608671002689, 218, 45, 'PPL', 'P'),
(82810, 'Oxford', 34.7361106872559, 0.606259500829805, -82.9416732788086, -1.44760528582861, 218, 48, 'PPL', 'P'),
(96846, 'Oxford', 30.603889465332, 0.534138635086451, -98.7038879394531, -1.72270782906298, 218, 51, 'PPL', 'P'),
(105013, 'Oxford', 37.5391693115234, 0.655182102949697, -77.5480575561523, -1.35346893288093, 218, 53, 'PPL', 'P'),
(110801, 'Oxford', 39.2055587768555, 0.684266085740289, -80.8649978637695, -1.41136046234096, 218, 58, 'PPL', 'P'),
(113885, 'Oxford', 41.4338912963867, 0.72315782503537, -73.1172180175781, -1.27613619430526, 218, 8, 'PPL', 'P'),
(117198, 'Oxford', 41.723331451416, 0.728209508728114, -91.790283203125, -1.60204266323258, 218, 16, 'PPL', 'P'),
(123388, 'Oxford', 40.519718170166, 0.707202494049569, -87.2477798461914, -1.52276102337119, 218, 19, 'PPL', 'P'),
(125758, 'Oxford', 42.1166687011719, 0.735074538807093, -71.8652801513672, -1.25428575650949, 218, 23, 'PPL', 'P'),
(128460, 'Oxford', 44.1316719055176, 0.770242979161162, -70.4936065673828, -1.23034553620633, 218, 26, 'PPL', 'P'),
(132501, 'Oxford', 42.8247184753418, 0.74743233863436, -83.2647171020508, -1.45324346417242, 218, 27, 'PPL', 'P'),
(139378, 'Oxford', 40.4211082458496, 0.705481426195105, -94.540283203125, -1.65003921766242, 218, 29, 'PPL', 'P'),
(142621, 'Oxford', 40.2483291625977, 0.702465862313781, -99.633056640625, -1.73892488220491, 218, 35, 'PPL', 'P'),
(145978, 'Oxford', 40.8030586242676, 0.712147717877737, -74.9899978637695, -1.30882236878629, 218, 37, 'PPL', 'P'),
(151507, 'Oxford', 41.350830078125, 0.721708133295985, -74.2163925170898, -1.2953204083757, 218, 40, 'PPL', 'P'),
(175736, 'Oxford', 43.7813911437988, 0.764129426562776, -89.5725021362305, -1.56333508152688, 218, 57, 'PPL', 'P'),
(183925, 'Oxford', 38.3072204589844, 0.668587124296611, -121.619720458984, -2.12266455736439, 218, 6, 'PPL', 'P'),
(187152, 'Oxford', 37.1688919067383, 0.648719543090456, -107.713607788086, -1.87995710510391, 218, 7, 'PPL', 'P'),
(195430, 'Oxford', 42.2588882446289, 0.737556738101101, -112.020561218262, -1.95512762319054, 218, 17, 'PPL', 'P'),
(120942, 'Oxford (historical)', 41.1736106872559, 0.71861507142694, -90.4330596923828, -1.57835464428465, 218, 18, 'PPL', 'P'),
(82809, 'Oxford Acres', 34.7994384765625, 0.607364779261215, -82.4499969482422, -1.4390239150061, 218, 48, 'PPL', 'P'),
(165627, 'Oxford Circle', 40.0499992370605, 0.699004352107924, -75.0722198486328, -1.31025741313968, 218, 45, 'PPL', 'P'),
(105014, 'Oxford Furnace', 37.375560760498, 0.652326595049887, -79.041389465332, -1.3795324915212, 218, 53, 'PPL', 'P'),
(50160, 'Oxford Green', 39.061939239502, 0.681759451943279, -76.8413925170898, -1.34113530124055, 218, 25, 'PPL', 'P'),
(125759, 'Oxford Heights', 42.1736106872559, 0.736068363946883, -71.8791732788086, -1.25452823732674, 218, 23, 'PPL', 'P'),
(89724, 'Oxford Hills', 35.7069396972656, 0.623203663528352, -83.9916687011719, -1.46593116307972, 218, 50, 'PPL', 'P'),
(117199, 'Oxford Junction', 41.9836082458496, 0.732752195757517, -90.9561080932617, -1.58748356102728, 218, 16, 'PPL', 'P'),
(142623, 'Oxford Junction', 40.2350006103516, 0.702233235192563, -99.5986099243164, -1.73832367358882, 218, 35, 'PPL', 'P'),
(205264, 'Oxford Manor Condominium', 40.7708282470703, 0.711585191676485, -111.883888244629, -1.95274222980215, 218, 52, 'PPL', 'P'),
(183929, 'Oxford Mill', 39.5719413757324, 0.690660668412705, -120.824440002441, -2.10878429492095, 218, 6, 'PPL', 'P'),
(117200, 'Oxford Mills', 41.9702796936035, 0.732519568636298, -90.959716796875, -1.58754654478706, 218, 16, 'PPL', 'P'),
(67559, 'Oxford Park', 35.7638893127441, 0.624197621826197, -81.1727828979492, -1.41673232457576, 218, 33, 'PPL', 'P'),
(113886, 'Oxford Park', 41.6080589294434, 0.726197623682614, -72.670280456543, -1.26833566231436, 218, 8, 'PPL', 'P'),
(128458, 'Oxford Station', 44.144718170166, 0.770470679434363, -70.4627838134766, -1.22980757766613, 218, 26, 'PPL', 'P'),
(165628, 'Oxford Valley', 40.1811103820801, 0.701292673274574, -74.8666687011719, -1.30666986883524, 218, 45, 'PPL', 'P'),
(113887, 'Oxford Village', 41.7661094665527, 0.728956125939718, -72.5633316040039, -1.26646905270633, 218, 8, 'PPL', 'P'),
(165629, 'Oxford Village', 40.0400009155273, 0.698829848477496, -75.0999984741211, -1.31074224161613, 218, 45, 'PPL', 'P'),
(105015, 'Oxfordshire', 38.6816711425781, 0.675122521611665, -77.5069427490234, -1.3527513441252, 218, 53, 'PPL', 'P'),
(11035, 'Oxley', 35.8422203063965, 0.625564755571789, -92.4569396972656, -1.61367801403513, 218, 4, 'PPL', 'P'),
(208364, 'Oxley', 46.6175003051758, 0.813628869374779, -122.906112670898, -2.1451163369343, 218, 56, 'PPL', 'P'),
(137357, 'Oxlip', 45.5002784729004, 0.794129669926409, -93.3886108398438, -1.62993874301894, 218, 28, 'PPL', 'P'),
(56751, 'Oxly', 36.5950012207031, 0.638703261072614, -90.6875, -1.58279546540236, 218, 29, 'PPL', 'P'),
(4833, 'Oxmoor', 33.4327812194824, 0.583512110378893, -86.8594436645508, -1.51598327839694, 218, 2, 'PPL', 'P'),
(89725, 'Oxmore Hills', 35.9941711425781, 0.628216797964318, -84.1047210693359, -1.46790429913136, 218, 50, 'PPL', 'P'),
(183926, 'Oxnard', 34.1974983215332, 0.596858941655989, -119.176109313965, -2.08001549724537, 218, 6, 'PPL', 'P'),
(183927, 'Oxnard Beach', 34.163330078125, 0.596262593308893, -119.226936340332, -2.08090259620447, 218, 6, 'PPL', 'P'),
(183928, 'Oxnard Shores', 34.1908302307129, 0.596742561516352, -119.240562438965, -2.08114041648982, 218, 6, 'PPL', 'P'),
(50162, 'Oxon Hill', 38.8033294677734, 0.677245859948785, -76.9899978637695, -1.34372895382618, 218, 25, 'PPL', 'P'),
(50163, 'Oxon Run Hills', 38.8438911437988, 0.677953794745556, -76.9619369506836, -1.34323919850171, 218, 25, 'PPL', 'P'),
(73817, 'Oxtoby (historical)', 39.901668548584, 0.696415493212257, -83.695556640625, -1.46076303266831, 218, 41, 'PPL', 'P'),
(28166, 'Oxville', 39.704719543457, 0.692978084614265, -90.5611114501953, -1.58058956907144, 218, 18, 'PPL', 'P'),
(187151, 'Oxyoke', 39.3030586242676, 0.685967779097822, -105.197776794434, -1.83604757084095, 218, 7, 'PPL', 'P'),
(117203, 'Oyens', 42.8202781677246, 0.747354840646639, -96.057502746582, -1.67651969417135, 218, 16, 'PPL', 'P'),
(56752, 'Oyer', 37.9605598449707, 0.662536755195087, -93.8708267211914, -1.63835499785386, 218, 29, 'PPL', 'P'),
(208367, 'Oyhut', 47.0175018310547, 0.820610213014367, -124.16056060791, -2.16701058373, 218, 56, 'PPL', 'P'),
(137356, 'Oylen', 46.5747184753418, 0.812882185584148, -94.7983322143555, -1.65454302253991, 218, 28, 'PPL', 'P'),
(105016, 'Oyster', 37.2863883972168, 0.650770243708844, -75.9227828979492, -1.32510253884606, 218, 53, 'PPL', 'P'),
(4830, 'Oyster Bay', 30.2852802276611, 0.528577854861825, -87.7430572509766, -1.53140524479543, 218, 2, 'PPL', 'P'),
(151509, 'Oyster Bay', 40.8655586242676, 0.713238548660234, -73.5325012207031, -1.28338425352802, 218, 40, 'PPL', 'P'),
(151510, 'Oyster Bay Cove', 40.8708305358887, 0.713330560875896, -73.5113906860352, -1.28301580519121, 218, 40, 'PPL', 'P'),
(105017, 'Oyster Cove', 37.2580604553223, 0.650275827852471, -76.4691696166992, -1.33463878607741, 218, 53, 'PPL', 'P'),
(67562, 'Oyster Creek', 35.1180610656738, 0.612925792512437, -75.975830078125, -1.32602838679902, 218, 33, 'PPL', 'P'),
(71228, 'Oyster Creek', 39.5041694641113, 0.689477825414547, -74.4169387817383, -1.29882060099639, 218, 37, 'PPL', 'P'),
(96847, 'Oyster Creek', 29.0027809143066, 0.506194019189222, -95.331672668457, -1.66385156949806, 218, 51, 'PPL', 'P'),
(67563, 'Oyster Creek Landing', 35.3905601501465, 0.617681798745155, -76.3150024414063, -1.33194806127005, 218, 33, 'PPL', 'P'),
(50164, 'Oyster Harbor', 38.9244384765625, 0.679359610905981, -76.4655609130859, -1.33457580231763, 218, 25, 'PPL', 'P'),
(125761, 'Oyster Harbors', 41.6208305358887, 0.726420530265853, -70.4158325195313, -1.22898812299871, 218, 23, 'PPL', 'P'),
(17468, 'Oyster Lodge', 30.9677791595459, 0.540489708364558, -87.2341690063477, -1.52252346940196, 218, 12, 'PPL', 'P'),
(82811, 'Oyster Point', 32.7219390869141, 0.571105574703677, -79.9286117553711, -1.39501744167947, 218, 48, 'PPL', 'P'),
(105018, 'Oyster Point', 37.105281829834, 0.647609337811029, -76.5077819824219, -1.33531269899126, 218, 53, 'PPL', 'P'),
(165630, 'Oyster Point', 40.0586090087891, 0.699154620972431, -76.4038925170898, -1.33349948576308, 218, 45, 'PPL', 'P'),
(14367, 'Oyster Rocks', 38.8019409179688, 0.677221625182866, -75.2030563354492, -1.31254094061637, 218, 10, 'PPL', 'P'),
(201365, 'Oysterville', 44.5780601501465, 0.778033923772134, -124.000831604004, -2.16422278670091, 218, 43, 'PPL', 'P'),
(208365, 'Oysterville', 46.5491714477539, 0.812436305838641, -124.02693939209, -2.16467845356342, 218, 56, 'PPL', 'P'),
(37568, 'Oz', 36.7063903808594, 0.640647368668371, -84.567497253418, -1.4759812672434, 218, 21, 'PPL', 'P'),
(4831, 'Ozan', 33.1058311462402, 0.57780575511118, -86.7155609130859, -1.51347205064705, 218, 2, 'PPL', 'P'),
(11036, 'Ozan', 33.8477783203125, 0.590755176174609, -93.7188873291016, -1.63570315519842, 218, 4, 'PPL', 'P'),
(197203, 'Ozan', 46.7008285522461, 0.815083221646071, -113.242218017578, -1.97644955666798, 218, 31, 'PPL', 'P'),
(4832, 'Ozark', 31.458890914917, 0.549061225491033, -85.6405563354492, -1.49470968129328, 218, 2, 'PPL', 'P'),
(11038, 'Ozark', 35.4869384765625, 0.619363917868676, -93.8274993896484, -1.63759879326234, 218, 4, 'PPL', 'P'),
(28167, 'Ozark', 37.5424995422363, 0.655240226440488, -88.7627792358398, -1.54920275088626, 218, 18, 'PPL', 'P'),
(37569, 'Ozark', 37.0791702270508, 0.64715360436949, -85.2313919067383, -1.48756841483023, 218, 21, 'PPL', 'P'),
(56753, 'Ozark', 37.0208282470703, 0.646135344726698, -93.2058334350586, -1.62674867550719, 218, 29, 'PPL', 'P'),
(61202, 'Ozark', 34.413890838623, 0.600635703555885, -88.4694366455078, -1.54408295684864, 218, 30, 'PPL', 'P'),
(67564, 'Ozark', 35.2683296203613, 0.615548473553947, -81.1600036621094, -1.41650928483446, 218, 33, 'PPL', 'P'),
(73818, 'Ozark', 39.8266716003418, 0.695106549536484, -81.0819396972656, -1.41514681162078, 218, 41, 'PPL', 'P'),
(76871, 'Ozark', 34.6380615234375, 0.604548220092347, -99.2113876342773, -1.73156536969053, 218, 42, 'PPL', 'P'),
(117204, 'Ozark', 42.1952781677246, 0.736446532821675, -90.8752822875977, -1.58607288459786, 218, 16, 'PPL', 'P'),
(132503, 'Ozark', 46.1419410705566, 0.805328794942411, -84.9655609130859, -1.48292878873715, 218, 27, 'PPL', 'P'),
(117205, 'Ozark (historical)', 42.1575012207031, 0.735787200714798, -90.8741683959961, -1.58605344352191, 218, 16, 'PPL', 'P'),
(11039, 'Ozark Acres', 36.2947196960449, 0.633462359784419, -91.3827819824219, -1.59493042522541, 218, 4, 'PPL', 'P'),
(56754, 'Ozark Beach', 36.6588897705078, 0.63981832662103, -93.1386108398438, -1.62557541988895, 218, 29, 'PPL', 'P'),
(56756, 'Ozark Junction', 38.167781829834, 0.666153461113469, -92.1216735839844, -1.60782651648801, 218, 29, 'PPL', 'P'),
(11040, 'Ozark Lithia', 34.5955581665039, 0.603806396570706, -93.0122222900391, -1.62336952355804, 218, 4, 'PPL', 'P'),
(56757, 'Ozark Springs', 37.8397216796875, 0.660427731348826, -92.3377838134766, -1.61159835153989, 218, 29, 'PPL', 'P'),
(56758, 'Ozark View', 38.5763893127441, 0.673285007038538, -90.4625015258789, -1.57886850121698, 218, 29, 'PPL', 'P'),
(33553, 'Ozawkie', 39.2333297729492, 0.684750781058683, -95.466667175293, -1.66620766811446, 218, 20, 'PPL', 'P'),
(105019, 'Ozeana', 37.8250007629395, 0.660170802882661, -76.8016662597656, -1.34044194725075, 218, 53, 'PPL', 'P'),
(17469, 'Ozello', 28.8255596160889, 0.503100924030663, -82.6572189331055, -1.44264062092449, 218, 12, 'PPL', 'P'),
(208366, 'Ozette', 48.1549987792969, 0.840463279992581, -124.665832519531, -2.17582924220564, 218, 56, 'PPL', 'P'),
(11043, 'Ozmont Bluff (historical)', 33.5550003051758, 0.585645235833019, -91.7930603027344, -1.60209113276442, 218, 4, 'PPL', 'P'),
(183930, 'Ozol', 38.026668548584, 0.663690569737364, -122.16194152832, -2.13212810029798, 218, 6, 'PPL', 'P'),
(17470, 'Ozona', 28.0691699981689, 0.489899434770059, -82.7758331298828, -1.44471082919786, 218, 12, 'PPL', 'P'),
(61203, 'Ozona', 30.5844402313232, 0.533799181916007, -89.6636123657227, -1.56492525501376, 218, 30, 'PPL', 'P'),
(191998, 'Ozona', 30.7099990844727, 0.535990597308492, -101.20027923584, -1.76627807660306, 218, 51, 'PPL', 'P'),
(11044, 'Ozone', 35.6411094665527, 0.622054709255065, -93.4430618286133, -1.63088909205394, 218, 4, 'PPL', 'P'),
(89727, 'Ozone', 36.5083312988281, 0.637190585573449, -85.283332824707, -1.48847495486529, 218, 50, 'PPL', 'P'),
(151512, 'Ozone Park', 40.6766700744629, 0.709941821546825, -73.8441696166992, -1.28882389321256, 218, 40, 'PPL', 'P'),
(56765, 'Ozora', 37.8644409179688, 0.660859163445419, -90.0344390869141, -1.57139740225293, 218, 29, 'PPL', 'P'),
(178772, 'P and E Junction', 34.6061096191406, 0.603990554160085, -112.40389251709, -1.96181801648103, 218, 5, 'PPL', 'P'),
(117206, 'P and H Mobile Home Court', 41.5458297729492, 0.725111520011052, -93.595832824707, -1.63355544893732, 218, 16, 'PPL', 'P'),
(137358, 'P and J Modern Trailer Court', 43.6522216796875, 0.761874994120996, -94.7266693115234, -1.65329226893395, 218, 28, 'PPL', 'P'),
(165631, 'P and W Patch', 40.2638893127441, 0.702737438165942, -80.4775009155273, -1.4045973647527, 218, 45, 'PPL', 'P'),
(189181, 'P Simmons Place', 35.2319412231445, 0.61491337621299, -106.117782592773, -1.85210470115942, 218, 38, 'PPL', 'P'),
(210850, 'Paako', 20.625560760498, 0.359983945340837, -156.442504882813, -2.73043680027238, 218, 15, 'PPL', 'P'),
(189182, 'Paako Communities', 35.184440612793, 0.614084334165649, -106.32861328125, -1.85578439083758, 218, 38, 'PPL', 'P'),
(210857, 'Paauhau', 20.0852794647217, 0.350554257842598, -155.440567016602, -2.7129496856066, 218, 15, 'PPL', 'P'),
(132504, 'Paavola', 47.1502799987793, 0.822927629215927, -88.5441665649414, -1.54538723999251, 218, 27, 'PPL', 'P'),
(210859, 'PaÃ‚â€˜auilo', 20.0419406890869, 0.349797853513988, -155.371109008789, -2.71173741467839, 218, 15, 'PPL', 'P'),
(197204, 'Pablo', 47.6002807617188, 0.830781624165707, -114.118057250977, -1.99173583500893, 218, 31, 'PPL', 'P'),
(17472, 'Pablo Keys', 30.2719402313232, 0.528345028003524, -81.4238891601563, -1.42111495562365, 218, 12, 'PPL', 'P'),
(96848, 'Pablo Pena Colonia', 26.30299949646, 0.459073944363637, -98.6399993896484, -1.72159276351456, 218, 51, 'PPL', 'P'),
(183931, 'Pabrico', 37.5827789306641, 0.655943234389242, -122.005279541016, -2.1293938328068, 218, 6, 'PPL', 'P'),
(23701, 'Pabst', 32.4402809143066, 0.566189712226527, -83.6275024414063, -1.45957526282214, 218, 13, 'PPL', 'P'),
(151513, 'Pacama', 41.9305610656738, 0.731826347804551, -74.1675033569336, -1.29446713156244, 218, 40, 'PPL', 'P'),
(11045, 'Pace', 35.6958312988281, 0.623009785400995, -90.0899963378906, -1.57236705920583, 218, 4, 'PPL', 'P'),
(17474, 'Pace', 30.5991706848145, 0.53405627682974, -87.1611099243164, -1.52124834787203, 218, 12, 'PPL', 'P'),
(23702, 'Pace', 33.5786094665527, 0.586057293432682, -83.9630584716797, -1.46543182037533, 218, 13, 'PPL', 'P'),
(42474, 'Pace', 32.6652793884277, 0.570116676411904, -93.3219375610352, -1.62877507478063, 218, 22, 'PPL', 'P'),
(61204, 'Pace', 33.791389465332, 0.58977100499377, -90.8569412231445, -1.58575277263484, 218, 30, 'PPL', 'P'),
(89728, 'Pace (historical)', 36.3891716003418, 0.635110856499179, -88.0500030517578, -1.53676245964423, 218, 50, 'PPL', 'P'),
(11046, 'Pace City', 33.4027786254883, 0.582988466329556, -92.9119415283203, -1.62161929408964, 218, 4, 'PPL', 'P'),
(183932, 'Pacer', 34.9352798461914, 0.609735658421658, -120.488891601563, -2.10292787052581, 218, 6, 'PPL', 'P'),
(105020, 'Paces', 36.6452789306641, 0.639580772651795, -79.0988922119141, -1.380536103778, 218, 53, 'PPL', 'P'),
(4834, 'Paces (historical)', 32.4697189331055, 0.566703502579831, -87.9486083984375, -1.53499278909987, 218, 2, 'PPL', 'P'),
(23703, 'Paces Lakes', 33.8727798461914, 0.591191535119219, -84.8569412231445, -1.48103301751518, 218, 13, 'PPL', 'P'),
(23704, 'Paces Meadows', 33.8636093139648, 0.591031479137705, -84.8597183227539, -1.48108148704702, 218, 13, 'PPL', 'P'),
(56768, 'Pacetown', 37.7533302307129, 0.65891991611865, -93.9952774047852, -1.64052707203893, 218, 29, 'PPL', 'P'),
(23705, 'Paceville (historical)', 31.7813892364502, 0.554689883033943, -82.8274993896484, -1.44561257554296, 218, 13, 'PPL', 'P'),
(183933, 'Pachappa', 33.9466705322266, 0.592481170877089, -117.384170532227, -2.04874026550986, 218, 6, 'PPL', 'P'),
(113889, 'Pachaug', 41.584171295166, 0.725780705813962, -71.9411087036133, -1.2556092144132, 218, 8, 'PPL', 'P'),
(193840, 'Pacheco', 40.5127792358398, 0.707081386798998, -122.332778930664, -2.13510977545444, 218, 6, 'PPL', 'P'),
(189185, 'Pacheco Village', 35.9630584716797, 0.62767377941805, -105.383056640625, -1.83928131419458, 218, 38, 'PPL', 'P'),
(151514, 'Pachin Mills', 41.9952812194824, 0.732955927580908, -73.6586074829102, -1.28558522301092, 218, 40, 'PPL', 'P'),
(23706, 'Pachitla', 31.7627792358398, 0.554365077249494, -84.6813888549805, -1.47796905068104, 218, 13, 'PPL', 'P'),
(61205, 'Pachuta', 32.0402793884277, 0.559208368586939, -88.8847198486328, -1.5513310160714, 218, 30, 'PPL', 'P'),
(56766, 'Pacific', 38.4819412231445, 0.671636576902806, -90.7413864135742, -1.58373596074132, 218, 29, 'PPL', 'P'),
(183935, 'Pacific', 38.7602806091309, 0.676494515626247, -120.50611114502, -2.10322840825482, 218, 6, 'PPL', 'P'),
(208372, 'Pacific', 47.264720916748, 0.824925000033486, -122.248893737793, -2.13364570264516, 218, 56, 'PPL', 'P'),
(89729, 'Pacific (historical)', 36.353889465332, 0.634495067076125, -85.5791702270508, -1.49363829158674, 218, 50, 'PPL', 'P'),
(183936, 'Pacific Beach', 32.797779083252, 0.572429232344474, -117.239440917969, -2.04621425721592, 218, 6, 'PPL', 'P'),
(208368, 'Pacific Beach', 47.209171295166, 0.823955476238643, -124.201942443848, -2.16773283301763, 218, 56, 'PPL', 'P'),
(117207, 'Pacific City', 41.047779083252, 0.716418895634006, -95.8000030517578, -1.67202547667379, 218, 16, 'PPL', 'P'),
(201366, 'Pacific City', 45.2024993896484, 0.788932444480092, -123.961669921875, -2.16353928640714, 218, 43, 'PPL', 'P'),
(208369, 'Pacific City (historical)', 46.2838897705078, 0.807806267125484, -124.054168701172, -2.16515369465995, 218, 56, 'PPL', 'P'),
(183944, 'Pacific Grove', 36.6177787780762, 0.639100804444335, -121.915557861328, -2.12782789408583, 218, 6, 'PPL', 'P'),
(183937, 'Pacific Grove Acres', 36.6288909912109, 0.63929474915072, -121.928886413574, -2.12806052120705, 218, 6, 'PPL', 'P'),
(210862, 'Pacific Heights', 21.3266696929932, 0.372220604628019, -157.842498779297, -2.75487130327386, 218, 15, 'PPL', 'P'),
(117208, 'Pacific Junction', 41.0186080932617, 0.71590976581261, -95.7988891601563, -1.67200603559783, 218, 16, 'PPL', 'P'),
(197205, 'Pacific Junction', 48.5563888549805, 0.847468858398089, -109.759170532227, -1.91565891004529, 218, 31, 'PPL', 'P'),
(183939, 'Pacific Manor', 37.6502799987793, 0.657121350276465, -122.488609313965, -2.13782952871768, 218, 6, 'PPL', 'P'),
(178773, 'Pacific Mobile Manor', 33.4161109924316, 0.583221160029802, -111.617782592773, -1.94809781001911, 218, 5, 'PPL', 'P'),
(183940, 'Pacific Palisades', 34.0480613708496, 0.59425077484242, -118.52555847168, -2.06866124309587, 218, 6, 'PPL', 'P'),
(201367, 'Pacific Palisades', 44.8444404602051, 0.78268313724514, -124.049438476563, -2.16507113666615, 218, 43, 'PPL', 'P'),
(210863, 'Pacific Palisades', 21.4255599975586, 0.373946566040986, -157.960830688477, -2.75693658469922, 218, 15, 'PPL', 'P'),
(193841, 'Pacific Shores', 41.8555603027344, 0.730517337549749, -124.20027923584, -2.16770380456175, 218, 6, 'PPL', 'P'),
(183941, 'Pacific Skies Mobile Home Park', 37.6411094665527, 0.656961294294952, -122.492500305176, -2.13789743932548, 218, 6, 'PPL', 'P'),
(183943, 'Pacifica', 37.6138916015625, 0.656486252935509, -122.485832214355, -2.13778105918584, 218, 6, 'PPL', 'P'),
(96849, 'Pacio', 33.4316711425781, 0.583492735881963, -95.5400009155273, -1.66748758333435, 218, 51, 'PPL', 'P'),
(56767, 'Pack', 36.5066719055176, 0.637161623696594, -94.5327835083008, -1.64990832329485, 218, 29, 'PPL', 'P'),
(197206, 'Pack and Lacey Crossing', 47.5447196960449, 0.829811900633782, -110.899169921875, -1.93555565286538, 218, 31, 'PPL', 'P'),
(50165, 'Pack Town', 39.086669921875, 0.682191083776953, -76.5608291625977, -1.33623854694422, 218, 25, 'PPL', 'P'),
(145980, 'Packanack Lake', 40.9425010681152, 0.714581447639906, -74.2566680908203, -1.29602334974543, 218, 37, 'PPL', 'P'),
(37570, 'Packard', 36.6674995422363, 0.639968595485538, -84.0558319091797, -1.4670510223181, 218, 21, 'PPL', 'P'),
(117209, 'Packard', 42.850830078125, 0.7478880720759, -92.7319412231445, -1.61847769610973, 218, 16, 'PPL', 'P'),
(132505, 'Packard', 42.6822204589844, 0.744945279071363, -84.6030578613281, -1.47660191693545, 218, 27, 'PPL', 'P'),
(175741, 'Packard', 45.3547210693359, 0.791589213983556, -87.6941680908203, -1.53055196798216, 218, 57, 'PPL', 'P'),
(208371, 'Packard', 47.2150001525879, 0.824057208992284, -118.493057250977, -2.06809398978368, 218, 56, 'PPL', 'P'),
(125762, 'Packard Heights', 42.6333312988281, 0.744092002258101, -72.2297210693359, -1.26064645045703, 218, 23, 'PPL', 'P'),
(128461, 'Packard Landing', 45.2966690063477, 0.790576014346835, -69.3341674804688, -1.21010950666336, 218, 26, 'PPL', 'P'),
(128462, 'Packards', 45.4811096191406, 0.793795110314468, -68.9394378662109, -1.20322017523943, 218, 26, 'PPL', 'P'),
(4835, 'Packards Bend', 31.7758293151855, 0.554592844101723, -87.4894409179688, -1.5269788047476, 218, 2, 'PPL', 'P'),
(125763, 'Packardville', 42.3458290100098, 0.739074140711201, -72.3847198486328, -1.26335168949233, 218, 23, 'PPL', 'P'),
(42473, 'Packenham Mobile Home Park', 29.9294395446777, 0.522367263331219, -89.9541702270508, -1.56999644636149, 218, 22, 'PPL', 'P'),
(113890, 'Packer', 41.666389465332, 0.727215683588324, -71.9527816772461, -1.25581294623659, 218, 8, 'PPL', 'P'),
(178774, 'Packer', 34.098331451416, 0.595128153263546, -112.268608093262, -1.95945685785857, 218, 5, 'PPL', 'P'),
(172377, 'Packer Corner', 42.7388916015625, 0.745934377100218, -72.6436080932617, -1.26787014175582, 218, 55, 'PPL', 'P'),
(197207, 'Packers', 47.4972190856934, 0.82898285858644, -112.886108398438, -1.97023427131596, 218, 31, 'PPL', 'P'),
(197208, 'Packers Roost', 48.7458305358887, 0.850775239470449, -113.779167175293, -1.98582108738592, 218, 31, 'PPL', 'P'),
(123389, 'Packerton', 41.1163902282715, 0.71761638601816, -85.7975006103516, -1.49744887563248, 218, 19, 'PPL', 'P'),
(165634, 'Packerton', 40.8549995422363, 0.7130542579128, -75.7194366455078, -1.32155347721936, 218, 45, 'PPL', 'P'),
(165633, 'Packerton Junction', 40.8633308410645, 0.713199666508318, -75.7213897705078, -1.32158756568131, 218, 45, 'PPL', 'P'),
(14362, 'Packing House Corner', 38.4658317565918, 0.671355413670721, -75.6736068725586, -1.32075359678596, 218, 10, 'PPL', 'P'),
(110802, 'Packs Branch', 37.9052810668945, 0.661571958511179, -81.2347183227539, -1.41781330166222, 218, 58, 'PPL', 'P'),
(110803, 'Packsville', 37.9519386291504, 0.662386286593498, -81.5283279418945, -1.42293775623175, 218, 58, 'PPL', 'P'),
(42475, 'Packton', 31.7975006103516, 0.554971079555541, -92.5766677856445, -1.61576766338447, 218, 22, 'PPL', 'P'),
(175742, 'Packwaukee', 43.7633285522461, 0.763814174868738, -89.4583282470703, -1.56134237124122, 218, 57, 'PPL', 'P'),
(117212, 'Packwood', 41.1327781677246, 0.717902409519235, -92.0824966430664, -1.60714274987813, 218, 16, 'PPL', 'P'),
(208373, 'Packwood', 46.6066703796387, 0.81343985151641, -121.669441223145, -2.12353234840559, 218, 56, 'PPL', 'P'),
(183945, 'Packwood (historical)', 35.5875015258789, 0.621119074185093, -120.059173583984, -2.09542787626393, 218, 6, 'PPL', 'P'),
(151515, 'Packwood Corners', 42.8930587768555, 0.74862510190758, -76.9194412231445, -1.34249750813813, 218, 40, 'PPL', 'P'),
(17476, 'Packwood Place', 28.937780380249, 0.505059545854362, -80.8697204589844, -1.4114428871767, 218, 12, 'PPL', 'P'),
(183946, 'Pacoima', 34.2625007629395, 0.597993448280363, -118.426109313965, -2.06692552785541, 218, 6, 'PPL', 'P'),
(82812, 'Pacolet', 34.8988914489746, 0.609100561080702, -81.7619400024414, -1.42701505586066, 218, 48, 'PPL', 'P'),
(82813, 'Pacolet Mills', 34.9225006103516, 0.609512618680364, -81.7427825927734, -1.4266806959858, 218, 48, 'PPL', 'P'),
(82814, 'Pacolet Park', 34.9205589294434, 0.609478729955493, -81.7422180175781, -1.42667084228977, 218, 48, 'PPL', 'P'),
(202468, 'Pactola (historical)', 44.0736083984375, 0.769229579787359, -103.483329772949, -1.80612482546504, 218, 49, 'PPL', 'P'),
(37571, 'Pactolus', 38.3652801513672, 0.669600457091386, -82.9349975585938, -1.44748877253092, 218, 21, 'PPL', 'P'),
(67565, 'Pactolus', 35.6283302307129, 0.621831669513771, -77.2177810668945, -1.34770452070145, 218, 33, 'PPL', 'P'),
(89730, 'Pactolus', 36.4988899230957, 0.637025802481, -82.5216674804688, -1.44027480177011, 218, 50, 'PPL', 'P'),
(187153, 'Pactolus', 39.917781829834, 0.69669672302337, -105.463890075684, -1.84069212378205, 218, 7, 'PPL', 'P'),
(190580, 'Pactolus', 38.6691703796387, 0.67490434213936, -117.801391601563, -2.05602214687846, 218, 39, 'PPL', 'P'),
(11048, 'Pactolus (historical)', 36.3675003051758, 0.63473262104536, -94.5358276367188, -1.64996145335859, 218, 4, 'PPL', 'P'),
(110804, 'Pad (historical)', 38.6419410705566, 0.674429101042836, -81.3352813720703, -1.41956845797864, 218, 58, 'PPL', 'P'),
(157002, 'Padanaram', 41.6536102294922, 0.72699264384703, -80.5369415283203, -1.40563479915534, 218, 41, 'PPL', 'P'),
(73820, 'Paddison Hills', 39.0805587768555, 0.682084424175296, -84.3605575561523, -1.47236948817304, 218, 41, 'PPL', 'P'),
(142626, 'Paddock', 41.0816688537598, 0.717010383712113, -98.0602798461914, -1.71147474874308, 218, 35, 'PPL', 'P'),
(208376, 'Paddock', 46.2602806091309, 0.807394209525822, -118.463333129883, -2.06757520600333, 218, 56, 'PPL', 'P'),
(175744, 'Paddock Lake', 42.5774993896484, 0.743117551615241, -88.1050033569336, -1.53772239605915, 218, 57, 'PPL', 'P'),
(151516, 'Paddy Hill', 43.9997215270996, 0.767940010608516, -75.982780456543, -1.32614969378668, 218, 40, 'PPL', 'P'),
(835, 'Paddytown', 39.8486099243164, 0.69548944552221, -79.2752838134766, -1.38361471799813, 218, 45, 'PPL', 'P'),
(151517, 'Padelford', 42.9402809143066, 0.749449283685932, -77.3180618286133, -1.34945475016985, 218, 40, 'PPL', 'P'),
(61206, 'Paden', 34.6597213745117, 0.604926255809084, -88.2658309936523, -1.54052936784809, 218, 30, 'PPL', 'P'),
(76872, 'Paden', 35.5077781677246, 0.619727639094554, -96.5672225952148, -1.68541598379276, 218, 42, 'PPL', 'P'),
(110805, 'Paden City', 39.6027793884277, 0.69119889326901, -80.9369430541992, -1.41261614279493, 218, 58, 'PPL', 'P'),
(14363, 'Paden Corner', 39.1555595397949, 0.683393434430097, -75.6127777099609, -1.3196919276174, 218, 10, 'PPL', 'P'),
(23707, 'Padena', 34.8527793884277, 0.60829575379928, -84.2188873291016, -1.46989687625896, 218, 13, 'PPL', 'P'),
(28169, 'Paderborn', 38.360279083252, 0.669513171986659, -90.0425033569336, -1.57153815031654, 218, 18, 'PPL', 'P'),
(67567, 'Padgett', 34.6741714477539, 0.605178457164315, -77.5911102294922, -1.35422034378249, 218, 33, 'PPL', 'P'),
(96850, 'Padgett', 33.3008308410645, 0.581209141826247, -98.9100036621094, -1.72630522706346, 218, 51, 'PPL', 'P'),
(4836, 'Padgett (historical)', 34.8194389343262, 0.607713853101097, -86.3063888549805, -1.50633065102595, 218, 2, 'PPL', 'P'),
(82815, 'Padgett Acres', 33.9799995422363, 0.59306287183819, -80.8813934326172, -1.41164661900009, 218, 48, 'PPL', 'P'),
(23708, 'Padgett Crossing (historical)', 33.2213897705078, 0.579822633583725, -82.2613906860352, -1.43573211474071, 218, 13, 'PPL', 'P'),
(82816, 'Padgett Landing', 32.8452796936035, 0.573258274391816, -80.3997192382813, -1.40323981838704, 218, 48, 'PPL', 'P'),
(89731, 'Padgett Mill', 35.8455581665039, 0.625623012220635, -83.2263870239258, -1.45257447810659, 218, 50, 'PPL', 'P'),
(82817, 'Padgetts', 33.0716705322266, 0.577209539922139, -80.8863906860352, -1.41173383752579, 218, 48, 'PPL', 'P'),
(17477, 'Padlock', 30.2311096191406, 0.527632399385333, -82.966667175293, -1.44804151161517, 218, 12, 'PPL', 'P'),
(33555, 'Padonia', 39.9233283996582, 0.696793528928994, -95.5625, -1.66788026643708, 218, 20, 'PPL', 'P'),
(50166, 'Padonia', 39.4558296203613, 0.688634135981209, -76.633056640625, -1.33749915424621, 218, 25, 'PPL', 'P'),
(194363, 'Padroni', 40.7777786254883, 0.711706498664138, -103.172218322754, -1.80069490631848, 218, 7, 'PPL', 'P'),
(120946, 'Padua', 40.4502792358398, 0.705990556016501, -88.7638931274414, -1.54922219196222, 218, 18, 'PPL', 'P'),
(137360, 'Padua', 45.6141700744629, 0.796117453364044, -95.0566711425781, -1.65905188742347, 218, 28, 'PPL', 'P'),
(156999, 'Padua', 40.5083312988281, 0.707003755653222, -84.7838897705078, -1.4797580291433, 218, 41, 'PPL', 'P'),
(552, 'Paducah', 37.0833282470703, 0.647226175509194, -88.5999984741211, -1.54636169063537, 218, 21, 'PPL', 'P'),
(191999, 'Paducah', 34.0122184753418, 0.59362519830236, -100.301666259766, -1.75059432146942, 218, 51, 'PPL', 'P'),
(61207, 'Paducah (historical)', 33.4147186279297, 0.583196858684855, -91.0166702270508, -1.58854056966393, 218, 30, 'PPL', 'P'),
(175746, 'Padus', 45.4930610656738, 0.794003702406849, -88.6641693115234, -1.5474816830318, 218, 57, 'PPL', 'P'),
(105021, 'Paeonian Springs', 39.149169921875, 0.68328191455945, -77.6194381713867, -1.35471475963886, 218, 53, 'PPL', 'P'),
(11049, 'Paepcke (historical)', 35.9888916015625, 0.628124652590601, -89.9897232055664, -1.57061696289548, 218, 4, 'PPL', 'P'),
(151518, 'Paerdegat', 40.6313896179199, 0.709151528493343, -73.9186096191406, -1.29012311635036, 218, 40, 'PPL', 'P'),
(195431, 'Pagari', 43.1180610656738, 0.752552132671983, -114.071937561035, -1.99093089456945, 218, 17, 'PPL', 'P'),
(678, 'Page', 36.4861106872559, 0.636802762739706, -89.9705581665039, -1.57028246986257, 218, 29, 'PPL', 'P'),
(867, 'Page', 34.7105598449707, 0.605813554505271, -94.5494384765625, -1.65019900732783, 218, 42, 'PPL', 'P'),
(105022, 'Page', 37.1797218322754, 0.648908560948825, -81.9955596923828, -1.43109248864763, 218, 53, 'PPL', 'P'),
(112656, 'Page', 38.0527801513672, 0.664146303178904, -81.2699966430664, -1.41842902450625, 218, 58, 'PPL', 'P'),
(123390, 'Page', 41.6875, 0.727584131925136, -84.8597183227539, -1.48108148704702, 218, 19, 'PPL', 'P'),
(137361, 'Page', 45.8875007629395, 0.800887973824703, -93.663330078125, -1.63473349824552, 218, 28, 'PPL', 'P'),
(140662, 'Page', 47.1597213745117, 0.823092412308375, -97.5708312988281, -1.70293226007249, 218, 34, 'PPL', 'P'),
(142629, 'Page', 42.4008293151855, 0.74003407712612, -98.4169387817383, -1.71769962147503, 218, 35, 'PPL', 'P'),
(177389, 'Page', 43.6555595397949, 0.761933250769842, -75.5619430541992, -1.31880469550024, 218, 40, 'PPL', 'P'),
(178775, 'Page', 36.9086112976074, 0.644176789482026, -111.472778320313, -1.94556700803521, 218, 5, 'PPL', 'P'),
(189186, 'Page', 35.3211097717285, 0.616469660975005, -108.440002441406, -1.89263508347323, 218, 38, 'PPL', 'P'),
(195432, 'Page', 47.5327796936035, 0.829603508278483, -116.202781677246, -2.02812114024408, 218, 17, 'PPL', 'P'),
(208375, 'Page', 46.3294410705566, 0.8086012872899, -118.741386413574, -2.07242815129973, 218, 56, 'PPL', 'P'),
(165635, 'Page (historical)', 40.3333282470703, 0.70394937619901, -77.9958267211914, -1.36128397909976, 218, 45, 'PPL', 'P'),
(151519, 'Page Brook', 42.2583312988281, 0.737547017563123, -75.7652816772461, -1.32235362396888, 218, 40, 'PPL', 'P'),
(117210, 'Page Center', 40.7122192382813, 0.710562271501786, -95.1294403076172, -1.66032194894733, 218, 16, 'PPL', 'P'),
(56769, 'Page City', 39.1269416809082, 0.682893958567653, -93.730827331543, -1.63591154755372, 218, 29, 'PPL', 'P'),
(187839, 'Page City', 39.0897216796875, 0.682244346998755, -101.14582824707, -1.76532772756806, 218, 20, 'PPL', 'P'),
(105024, 'Page Hollow', 36.8852806091309, 0.643769592151353, -81.6811065673828, -1.42560424627319, 218, 53, 'PPL', 'P'),
(73822, 'Page Manor', 39.7658309936523, 0.694044680630842, -84.1097183227539, -1.46799151765706, 218, 41, 'PPL', 'P'),
(17478, 'Page Park', 26.5788898468018, 0.463889139351582, -81.8622207641602, -1.42876528532906, 218, 12, 'PPL', 'P'),
(82818, 'Page Place', 34.1688919067383, 0.596359665530626, -82.1916732788086, -1.43451531643865, 218, 48, 'PPL', 'P'),
(178776, 'Page Springs', 34.7675018310547, 0.606807379645062, -111.892776489258, -1.95289735893565, 218, 5, 'PPL', 'P'),
(105026, 'Pagebrook', 37.5922203063965, 0.65610801748169, -77.6616668701172, -1.35545178947054, 218, 53, 'PPL', 'P'),
(56770, 'Pagedale', 38.6833305358887, 0.67515148348852, -90.307502746582, -1.57616326218168, 218, 29, 'PPL', 'P'),
(82819, 'Pageland', 34.7730598449707, 0.606904385287768, -80.3919372558594, -1.40310399717144, 218, 48, 'PPL', 'P'),
(82821, 'Pages (historical)', 34.0105590820313, 0.593596236425506, -79.2636108398438, -1.38341098617474, 218, 48, 'PPL', 'P'),
(144288, 'Pages Corner', 43.3997192382813, 0.757467995149133, -71.9400024414063, -1.2555899064953, 218, 36, 'PPL', 'P'),
(145989, 'Pages Corner', 40.2133293151855, 0.701854999738744, -74.583610534668, -1.30172957185508, 218, 37, 'PPL', 'P'),
(151520, 'Pages Corner', 43.0902786254883, 0.752067237616507, -73.9013900756836, -1.28982257862134, 218, 40, 'PPL', 'P'),
(172378, 'Pages Corner', 44.5347213745117, 0.777277519443524, -73.0752792358398, -1.27540422447965, 218, 55, 'PPL', 'P'),
(23709, 'Pages Mobile Home Park', 34.0830612182617, 0.594861637417457, -84.6519393920898, -1.47745506059065, 218, 13, 'PPL', 'P'),
(157000, 'Paget', 40.3208312988281, 0.703731263305732, -83.0124969482422, -1.44884139204857, 218, 41, 'PPL', 'P'),
(110806, 'Pageton', 37.3491706848145, 0.651866001339357, -81.4655609130859, -1.42184226491735, 218, 58, 'PPL', 'P'),
(157001, 'Pagetown', 40.3572196960449, 0.704366360646689, -82.8183288574219, -1.44545251956145, 218, 41, 'PPL', 'P'),
(50167, 'Pagetts Corner', 38.7930603027344, 0.677066629207423, -76.9286117553711, -1.34265756411964, 218, 25, 'PPL', 'P'),
(73821, 'Pageville', 39.1666717529297, 0.683587379136482, -82.1366729736328, -1.43355538002373, 218, 41, 'PPL', 'P'),
(165636, 'Pageville', 41.8600006103516, 0.730594835537471, -80.2666702270508, -1.40091767507454, 218, 45, 'PPL', 'P'),
(194362, 'Pagoda', 40.3369407653809, 0.704012426537818, -107.415283203125, -1.87475035885669, 218, 7, 'PPL', 'P'),
(187154, 'Pagosa Junction', 37.0380592346191, 0.646436082192795, -107.198608398438, -1.87096867010878, 218, 7, 'PPL', 'P'),
(187155, 'Pagosa Springs', 37.2694396972656, 0.650474433090764, -107.009170532227, -1.86766235561545, 218, 7, 'PPL', 'P'),
(189187, 'Paguate', 35.1386108398438, 0.613284453732243, -107.378326416016, -1.87410534124068, 218, 38, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(208377, 'Paha', 47.0233306884766, 0.820711945768008, -118.488059997559, -2.06800677125798, 218, 56, 'PPL', 'P'),
(145981, 'Pahaquarry', 40.9850006103516, 0.71532320458252, -75.1291732788086, -1.31125143801655, 218, 37, 'PPL', 'P'),
(209657, 'Pahaska Tepee', 44.503059387207, 0.776724913517333, -109.962219238281, -1.91920277850786, 218, 59, 'PPL', 'P'),
(17479, 'Pahokee', 26.8197193145752, 0.468092406500054, -80.6655578613281, -1.40787957763817, 218, 12, 'PPL', 'P'),
(210879, 'Paholoi', 20.8802795410156, 0.364429626727533, -156.345565795898, -2.72874489403186, 218, 15, 'PPL', 'P'),
(190582, 'Pahrump', 36.2083282470703, 0.631954544554244, -115.983062744141, -2.02428632143242, 218, 39, 'PPL', 'P'),
(210880, 'Paia', 20.9033298492432, 0.364831930499703, -156.369445800781, -2.72916167874245, 218, 15, 'PPL', 'P'),
(183947, 'Paicines', 36.7286109924316, 0.641035191502114, -121.277496337891, -2.11669161967156, 218, 6, 'PPL', 'P'),
(67568, 'Paige', 35.6150016784668, 0.621599042392552, -77.3944396972656, -1.35078779545349, 218, 33, 'PPL', 'P'),
(96851, 'Paige', 30.2099990844727, 0.52726395104852, -97.1147232055664, -1.69497167210008, 218, 51, 'PPL', 'P'),
(105025, 'Paige', 38.0724983215332, 0.664490450170769, -77.4191665649414, -1.35121936070814, 218, 53, 'PPL', 'P'),
(183948, 'Paige', 36.1819381713867, 0.631493950843715, -119.419723510742, -2.08426736708373, 218, 6, 'PPL', 'P'),
(193842, 'Paige Bar', 40.5813903808594, 0.708278877183152, -122.541389465332, -2.13875071613874, 218, 6, 'PPL', 'P'),
(151521, 'Pail Shop Corners', 42.7238883972168, 0.745672521786036, -74.980827331543, -1.30866231280478, 218, 40, 'PPL', 'P'),
(89732, 'Pailo', 35.4705581665039, 0.619078027525656, -85.3199996948242, -1.48911491247524, 218, 50, 'PPL', 'P'),
(212077, 'Paimiut', 61.964168548584, 1.08147875943351, -160.23193359375, -2.79657480804785, 218, 1, 'PPL', 'P'),
(42479, 'Paincourtville', 29.9899997711182, 0.523424238678358, -91.0550003051758, -1.58920955572976, 218, 22, 'PPL', 'P'),
(165638, 'Paine', 41.3622207641602, 0.72190693827136, -78.5761108398438, -1.37141184756728, 218, 45, 'PPL', 'P'),
(128466, 'Paine Corner', 44.1580581665039, 0.770703506292664, -70.4313888549805, -1.22925963227185, 218, 26, 'PPL', 'P'),
(89733, 'Paine Spring', 35.5744400024414, 0.620891107595782, -85.0088882446289, -1.48368499332868, 218, 50, 'PPL', 'P'),
(132506, 'Paines', 43.3997192382813, 0.757467995149133, -84.0388870239258, -1.46675527827904, 218, 27, 'PPL', 'P'),
(128463, 'Paines Corner', 44.5125007629395, 0.776889696609781, -69.5744400024414, -1.21430305327385, 218, 26, 'PPL', 'P'),
(151522, 'Paines Corner', 42.8394393920898, 0.747689267100526, -78.0097198486328, -1.36152645991702, 218, 40, 'PPL', 'P'),
(151523, 'Paines Hollow', 42.9613914489746, 0.749817732022744, -74.9036102294922, -1.30731462013514, 218, 40, 'PPL', 'P'),
(132507, 'Painesdale', 47.0433311462402, 0.82106101960789, -88.6722183227539, -1.5476221647793, 218, 27, 'PPL', 'P'),
(157003, 'Painesville', 41.7244415283203, 0.728228883225044, -81.2458267211914, -1.41800717978958, 218, 41, 'PPL', 'P'),
(157004, 'Painesville on-the-Lake', 41.7666702270508, 0.728965913056724, -81.2311096191406, -1.41775031790244, 218, 41, 'PPL', 'P'),
(28170, 'Paineville', 37.8088912963867, 0.659889639650575, -89.0016708374023, -1.55337219588889, 218, 18, 'PPL', 'P'),
(105027, 'Paineville', 37.3872184753418, 0.652530060557169, -78.1205596923828, -1.36346098013285, 218, 53, 'PPL', 'P'),
(165637, 'Paint', 40.2436103820801, 0.702383504057071, -78.8491668701172, -1.37617757433798, 218, 45, 'PPL', 'P'),
(105028, 'Paint Bank', 37.5688896179199, 0.655700820151017, -80.2622222900391, -1.40084004392876, 218, 53, 'PPL', 'P'),
(50168, 'Paint Branch Farms', 39.0805587768555, 0.682084424175296, -76.9941711425781, -1.34380179128199, 218, 25, 'PPL', 'P'),
(96852, 'Paint Creek', 33.0627784729004, 0.577054344209615, -99.6725006103516, -1.73961330934669, 218, 51, 'PPL', 'P'),
(132508, 'Paint Creek', 42.1575012207031, 0.735787200714798, -83.581672668457, -1.45877538238873, 218, 27, 'PPL', 'P'),
(96853, 'Paint Crossing', 33.0505599975586, 0.576841091585326, -99.3705596923828, -1.73434344618164, 218, 51, 'PPL', 'P'),
(67570, 'Paint Fork', 35.8394393920898, 0.625516219460923, -82.458610534668, -1.43917425044964, 218, 33, 'PPL', 'P'),
(67571, 'Paint Gap', 35.8791694641113, 0.626209640029752, -82.4077835083008, -1.43828715149053, 218, 33, 'PPL', 'P'),
(82822, 'Paint Hill', 34.2366714477539, 0.597542641686839, -80.5608291625977, -1.406051717024, 218, 48, 'PPL', 'P'),
(37572, 'Paint Lick', 37.6166687011719, 0.656534722467348, -84.4094390869141, -1.47322263182825, 218, 21, 'PPL', 'P'),
(165639, 'Paint Mills', 41.2513885498047, 0.719972551213581, -79.4141693115234, -1.38603872722232, 218, 45, 'PPL', 'P'),
(4837, 'Paint Rock', 34.6605606079102, 0.60494090319508, -86.3288879394531, -1.50672333412868, 218, 2, 'PPL', 'P'),
(67572, 'Paint Rock', 35.9305610656738, 0.627106592684891, -82.8897171020508, -1.44669847947744, 218, 33, 'PPL', 'P'),
(89734, 'Paint Rock', 35.7441711425781, 0.623853474834332, -84.5147171020508, -1.47506007982235, 218, 50, 'PPL', 'P'),
(96854, 'Paint Rock', 31.5083293914795, 0.549924089684218, -99.9197235107422, -1.74392816294484, 218, 51, 'PPL', 'P'),
(89735, 'Paint Rock (historical)', 35.7847213745117, 0.62456120989402, -84.459716796875, -1.47410014340743, 218, 50, 'PPL', 'P'),
(89736, 'Paint Rock Farm Lake Estates', 35.7958297729492, 0.624755088021378, -84.4569396972656, -1.47405167387559, 218, 50, 'PPL', 'P'),
(67573, 'Paint Town', 35.4691696166992, 0.619053792759736, -83.2927780151367, -1.45373321949688, 218, 33, 'PPL', 'P'),
(157010, 'Paint Valley', 40.5858306884766, 0.708356375170873, -82.0058288574219, -1.43127171938899, 218, 41, 'PPL', 'P'),
(151524, 'Painted Post', 42.1619415283203, 0.735864698702519, -77.0944366455078, -1.34555175443428, 218, 40, 'PPL', 'P'),
(4838, 'Painter', 34.3127784729004, 0.598870959859544, -86.0774993896484, -1.50233577623277, 218, 2, 'PPL', 'P'),
(105029, 'Painter', 37.5852813720703, 0.655986910231119, -75.7852783203125, -1.32270263122973, 218, 53, 'PPL', 'P'),
(157009, 'Painter Creek', 40.0355606079102, 0.698752350489775, -84.4694366455078, -1.47426978676887, 218, 41, 'PPL', 'P'),
(165643, 'Painter Hill', 41.0422210693359, 0.7163218899913, -80.3055572509766, -1.40159638167835, 218, 45, 'PPL', 'P'),
(165644, 'Painter Run', 41.8600006103516, 0.730594835537471, -77.0580596923828, -1.34491685683041, 218, 45, 'PPL', 'P'),
(89738, 'Painter Spring', 36.124439239502, 0.630490405165945, -82.5972213745117, -1.44159346598387, 218, 50, 'PPL', 'P'),
(78898, 'Painters Crossroads', 39.8808288574219, 0.69605177198638, -75.5472183227539, -1.31854770045504, 218, 45, 'PPL', 'P'),
(17480, 'Painters Hill', 29.5327796936035, 0.515444242919504, -81.1533279418945, -1.41639277153677, 218, 12, 'PPL', 'P'),
(73827, 'Paintersville', 39.5855598449707, 0.690898355539995, -83.8197174072266, -1.46293004684731, 218, 41, 'PPL', 'P'),
(165651, 'Paintersville', 40.2130584716797, 0.701850272627809, -79.6069412231445, -1.38940323178547, 218, 45, 'PPL', 'P'),
(183949, 'Paintersville', 38.3199996948242, 0.668810164037905, -121.574996948242, -2.12188398484888, 218, 6, 'PPL', 'P'),
(165646, 'Paintertown', 40.3499984741211, 0.704240326548101, -79.6933288574219, -1.39091098043662, 218, 45, 'PPL', 'P'),
(105030, 'Paintlick', 37.0097198486328, 0.64594146659934, -81.7777786254883, -1.42729149198181, 218, 53, 'PPL', 'P'),
(56771, 'Painton', 37.082218170166, 0.647206801012264, -89.7947235107422, -1.56721357618041, 218, 29, 'PPL', 'P'),
(37576, 'Paintsville', 37.8144416809082, 0.659986512135227, -82.8072204589844, -1.44525864143409, 218, 21, 'PPL', 'P'),
(187156, 'Paisaje', 37.0677795410156, 0.646954799394115, -106.059997558594, -1.85109616205461, 218, 7, 'PPL', 'P'),
(192003, 'Paisano Heights Colonia', 28.6730003356934, 0.500438262283288, -100.495002746582, -1.7539686797286, 218, 51, 'PPL', 'P'),
(96855, 'Paisano Park Colonia', 28.0949993133545, 0.490350241363582, -97.8600006103516, -1.7079792166543, 218, 51, 'PPL', 'P'),
(17481, 'Paisley', 28.9833297729492, 0.505854532729264, -81.5419387817383, -1.42317531020099, 218, 12, 'PPL', 'P'),
(78896, 'Paisley', 39.8624992370605, 0.695731859760434, -79.9550018310547, -1.39547803539, 218, 45, 'PPL', 'P'),
(201368, 'Paisley', 42.6938896179199, 0.745148944315727, -120.544998168945, -2.10390711485863, 218, 43, 'PPL', 'P'),
(28176, 'Paisley Corners', 38.9813919067383, 0.680353635782853, -89.470832824707, -1.56156061729256, 218, 18, 'PPL', 'P'),
(189189, 'Pajarita', 35.4719390869141, 0.619102129133521, -105.644439697266, -1.84384330914189, 218, 38, 'PPL', 'P'),
(192944, 'Pajarito', 35.9052810668945, 0.626665373471292, -106.126670837402, -1.85225983029292, 218, 38, 'PPL', 'P'),
(183950, 'Pajaro', 36.9041709899902, 0.644099291494305, -121.747497558594, -2.12489468846122, 218, 6, 'PPL', 'P'),
(183951, 'Pajaro Mobile Manor', 36.9055595397949, 0.644123526260225, -121.746391296387, -2.12487538054332, 218, 6, 'PPL', 'P'),
(125764, 'Pakachoag', 42.2249984741211, 0.736965250022995, -71.8138885498047, -1.25338880385435, 218, 23, 'PPL', 'P'),
(210882, 'Pakala Village', 21.936939239502, 0.38287181753925, -159.652221679688, -2.78645692643442, 218, 15, 'PPL', 'P'),
(192000, 'Pakan', 35.2847213745117, 0.615834563634049, -100.431106567383, -1.75285348102213, 218, 51, 'PPL', 'P'),
(183952, 'Pala', 33.3652801513672, 0.582333994491669, -117.075828552246, -2.04335868273708, 218, 6, 'PPL', 'P'),
(67574, 'Pala Alto', 34.8019409179688, 0.607408455103092, -77.2183303833008, -1.34771410808137, 218, 33, 'PPL', 'P'),
(183954, 'Pala Mesa', 33.332218170166, 0.581756954062477, -117.162780761719, -2.04487628508426, 218, 6, 'PPL', 'P'),
(56772, 'Palace', 37.6202812194824, 0.656597772806156, -92.1397171020508, -1.60814143528691, 218, 29, 'PPL', 'P'),
(56773, 'Palace (historical)', 37.1208305358887, 0.647880713926108, -93.164436340332, -1.62602615990345, 218, 29, 'PPL', 'P'),
(169534, 'Palace Garden', 41.7422218322754, 0.728539208071066, -71.4013900756836, -1.24618934732148, 218, 47, 'PPL', 'P'),
(110813, 'Palace Valley', 38.7552795410156, 0.676407230521519, -80.1575012207031, -1.39901231647264, 218, 58, 'PPL', 'P'),
(96856, 'Palacios', 28.7077808380127, 0.501045296564258, -96.2172164916992, -1.67930722488434, 218, 51, 'PPL', 'P'),
(96857, 'Palacios Estates Colonia', 26.1459999084473, 0.456333784628541, -97.661003112793, -1.70450605511867, 218, 51, 'PPL', 'P'),
(96858, 'Palafox', 27.7997207641602, 0.485196658469629, -99.8716735839844, -1.74308953351757, 218, 51, 'PPL', 'P'),
(210890, 'Palani Junction', 19.6913890838623, 0.343679573804667, -155.978607177734, -2.72234025792633, 218, 15, 'PPL', 'P'),
(11050, 'Palarm', 34.9049987792969, 0.609207154103332, -92.4475021362305, -1.61351329752171, 218, 4, 'PPL', 'P'),
(71229, 'Palatine', 39.5533294677734, 0.690335829338743, -75.1813888549805, -1.31216277174158, 218, 37, 'PPL', 'P'),
(110807, 'Palatine', 39.4791717529297, 0.689041533048964, -80.1374969482422, -1.39866317605373, 218, 58, 'PPL', 'P'),
(120947, 'Palatine', 42.110279083252, 0.734963018936446, -88.0341720581055, -1.53648615668113, 218, 18, 'PPL', 'P'),
(151525, 'Palatine Bridge', 42.910831451416, 0.748935293595547, -74.5744400024414, -1.30156951587357, 218, 40, 'PPL', 'P'),
(11052, 'Palatka', 36.4663887023926, 0.636458549168813, -90.6577835083008, -1.58227681478006, 218, 4, 'PPL', 'P'),
(17482, 'Palatka', 29.6483306884766, 0.517460988233993, -81.6377792358398, -1.42484804168167, 218, 12, 'PPL', 'P'),
(132512, 'Palatka', 46.0497207641602, 0.803719246958594, -88.623893737793, -1.54677874166207, 218, 27, 'PPL', 'P'),
(23710, 'Palatkee (historical)', 32.1500015258789, 0.561123381147788, -81.793327331543, -1.42756286809689, 218, 13, 'PPL', 'P'),
(23711, 'Palato', 33.3827781677246, 0.582639392489674, -83.7444381713867, -1.46161617632352, 218, 13, 'PPL', 'P'),
(192001, 'Palava', 32.5777816772461, 0.568589553263825, -100.335830688477, -1.75119060323748, 218, 51, 'PPL', 'P'),
(33559, 'Palco', 39.2522201538086, 0.685080480401635, -99.5625, -1.73769343651685, 218, 20, 'PPL', 'P'),
(56774, 'Palemon', 39.3180618286133, 0.686229634412004, -93.6102828979492, -1.63380765029255, 218, 29, 'PPL', 'P'),
(151527, 'Palentown', 41.8788909912109, 0.730924534880423, -74.3219375610352, -1.29716251690171, 218, 40, 'PPL', 'P'),
(151528, 'Palenville', 42.1744384765625, 0.736082811595797, -74.0205612182617, -1.29190250743269, 218, 40, 'PPL', 'P'),
(28171, 'Palermo', 39.8655586242676, 0.69578525614029, -87.8808288574219, -1.53380981294366, 218, 18, 'PPL', 'P'),
(33560, 'Palermo', 39.7324981689453, 0.693462913090714, -94.9763870239258, -1.65765066521592, 218, 20, 'PPL', 'P'),
(71231, 'Palermo', 39.2400016784668, 0.684867227777347, -74.6727828979492, -1.30328592319613, 218, 37, 'PPL', 'P'),
(110809, 'Palermo', 38.1694412231445, 0.666182422990324, -82.0586090087891, -1.43219290681005, 218, 58, 'PPL', 'P'),
(128464, 'Palermo', 44.4077796936035, 0.77506196915366, -69.4744415283203, -1.21255775065347, 218, 26, 'PPL', 'P'),
(151529, 'Palermo', 43.3650016784668, 0.756862059422113, -76.2827835083008, -1.33138573480588, 218, 40, 'PPL', 'P'),
(157011, 'Palermo', 40.4900016784668, 0.706683843427276, -81.1547164916992, -1.41641700630269, 218, 41, 'PPL', 'P'),
(183955, 'Palermo', 39.4355583190918, 0.688280335030392, -121.53694152832, -2.12121979247302, 218, 6, 'PPL', 'P'),
(198725, 'Palermo', 48.3397216796875, 0.843687302808231, -102.228607177734, -1.78422578497937, 218, 34, 'PPL', 'P'),
(157012, 'Palermo-on-the-Lakes', 40.5013885498047, 0.706882581823623, -81.1477813720703, -1.41629596563115, 218, 41, 'PPL', 'P'),
(4839, 'Palestine', 33.9413909912109, 0.592389025503373, -85.4502792358398, -1.49138871941395, 218, 2, 'PPL', 'P'),
(11054, 'Palestine', 34.9722213745117, 0.610380409721566, -90.9024963378906, -1.58654785937828, 218, 4, 'PPL', 'P'),
(28172, 'Palestine', 39.0036087036133, 0.680741392037569, -87.6127777099609, -1.52913143785672, 218, 18, 'PPL', 'P'),
(61212, 'Palestine', 34.1833305358887, 0.596611667148775, -89.5936126708984, -1.56370352986369, 218, 30, 'PPL', 'P'),
(67575, 'Palestine', 35.4041709899902, 0.61791935271439, -80.164436340332, -1.39913335714419, 218, 33, 'PPL', 'P'),
(89741, 'Palestine', 36.2588882446289, 0.632836982981442, -88.4019393920898, -1.54290490754044, 218, 50, 'PPL', 'P'),
(96860, 'Palestine', 33.0844383239746, 0.577432379926351, -95.8063888549805, -1.67213692996541, 218, 51, 'PPL', 'P'),
(110811, 'Palestine', 39.0299987792969, 0.681201985748098, -81.4069366455078, -1.42081907842654, 218, 58, 'PPL', 'P'),
(113891, 'Palestine', 41.3655586242676, 0.721965194920205, -73.3202819824219, -1.27968032908394, 218, 8, 'PPL', 'P'),
(123395, 'Palestine', 41.1783294677734, 0.718697429683651, -85.9497222900391, -1.50010564513594, 218, 19, 'PPL', 'P'),
(132509, 'Palestine', 45.4055595397949, 0.792476512679743, -87.533332824707, -1.52774486303517, 218, 27, 'PPL', 'P'),
(157013, 'Palestine', 40.0494384765625, 0.698994564990918, -84.7433319091797, -1.47905016092556, 218, 41, 'PPL', 'P'),
(165648, 'Palestine', 41.0230598449707, 0.715987463537413, -78.2216720581055, -1.36522572382919, 218, 45, 'PPL', 'P'),
(4840, 'Palestine (historical)', 34.9736099243164, 0.610404644487486, -87.4541702270508, -1.52636321506163, 218, 2, 'PPL', 'P'),
(89742, 'Palestine (historical)', 35.5974998474121, 0.62129357781552, -87.4550018310547, -1.52637772928957, 218, 50, 'PPL', 'P'),
(117215, 'Palestine (historical)', 40.6944389343262, 0.710251946655764, -91.7938919067383, -1.60210564699236, 218, 16, 'PPL', 'P'),
(113330, 'Paletown', 40.4263916015625, 0.705573638147849, -75.3161087036133, -1.31451407666801, 218, 45, 'PPL', 'P'),
(23712, 'Paletree', 31.0436096191406, 0.541813199557787, -82.7263870239258, -1.44384783184662, 218, 13, 'PPL', 'P'),
(210896, 'PaliÃ‚â€˜aÃ‚â€˜alii', 19.9858303070068, 0.348818542602138, -155.550003051758, -2.7148597047404, 218, 15, 'PPL', 'P'),
(210897, 'PalihoÃ‚â€˜oukapapa', 19.9713897705078, 0.348566507694476, -155.532501220703, -2.71455424016337, 218, 15, 'PPL', 'P'),
(89743, 'Palin (historical)', 35.6791687011719, 0.622718968209958, -84.2497177124023, -1.47043496795721, 218, 50, 'PPL', 'P'),
(137363, 'Palisade', 46.7133293151855, 0.815301401118376, -93.4883270263672, -1.63167911879131, 218, 28, 'PPL', 'P'),
(187157, 'Palisade', 39.110279083252, 0.682603141376616, -108.350280761719, -1.89106914475226, 218, 7, 'PPL', 'P'),
(199592, 'Palisade', 40.3491706848145, 0.704225878899187, -101.107223510742, -1.76465394781227, 218, 35, 'PPL', 'P'),
(200114, 'Palisade', 40.610279083252, 0.708783080156531, -116.197776794434, -2.02803378856033, 218, 39, 'PPL', 'P'),
(11056, 'Palisades', 35.5319404602051, 0.620149350653168, -92.3363876342773, -1.61157398361592, 218, 4, 'PPL', 'P'),
(37573, 'Palisades', 37.021671295166, 0.64615005869172, -88.0272216796875, -1.53636484969348, 218, 21, 'PPL', 'P'),
(120950, 'Palisades', 41.7136116027832, 0.728039865366676, -87.9336090087891, -1.53473100036472, 218, 18, 'PPL', 'P'),
(151531, 'Palisades', 41.0111083984375, 0.715778871445033, -73.9138870239258, -1.29004069151462, 218, 40, 'PPL', 'P'),
(192002, 'Palisades', 35.0616683959961, 0.611941554752571, -101.801940917969, -1.77677905393929, 218, 51, 'PPL', 'P'),
(195433, 'Palisades', 43.3519401550293, 0.756634092832802, -111.216941833496, -1.94110181899353, 218, 17, 'PPL', 'P'),
(208378, 'Palisades', 47.4191703796387, 0.827620651688864, -119.913330078125, -2.09288242689403, 218, 56, 'PPL', 'P'),
(195434, 'Palisades Corner', 43.9752807617188, 0.767513438780912, -116.911666870117, -2.04049352087832, 218, 17, 'PPL', 'P'),
(183956, 'Palisades Del Rey (historical)', 33.9402809143066, 0.592369651006442, -118.436943054199, -2.06711461229281, 218, 6, 'PPL', 'P'),
(23713, 'Palisades Estates', 33.6444396972656, 0.587206247705969, -84.2777786254883, -1.47092472328167, 218, 13, 'PPL', 'P'),
(50171, 'Palisades on the Severn', 39.042781829834, 0.68142509206842, -76.5777816772461, -1.33653442414133, 218, 25, 'PPL', 'P'),
(50170, 'Palisades Park', 39.0386085510254, 0.681352254612606, -76.5736083984375, -1.33646158668552, 218, 25, 'PPL', 'P'),
(132510, 'Palisades Park', 42.3125, 0.738492439750101, -86.3211135864258, -1.50658764607114, 218, 27, 'PPL', 'P'),
(145983, 'Palisades Park', 40.8480606079102, 0.712933150662229, -73.9980621337891, -1.29150982432996, 218, 37, 'PPL', 'P'),
(96861, 'Palito Blanco', 27.5913906097412, 0.48156061134383, -98.1888885498047, -1.71371939406785, 218, 51, 'PPL', 'P'),
(89745, 'Pall Mall', 36.5505599975586, 0.637927615405128, -84.9677810668945, -1.48296753773101, 218, 50, 'PPL', 'P'),
(165649, 'Pallas', 40.7122192382813, 0.710562271501786, -76.95361328125, -1.34309392306425, 218, 45, 'PPL', 'P'),
(17483, 'Palm', 27.9388904571533, 0.487625627831349, -82.398063659668, -1.43811750812909, 218, 12, 'PPL', 'P'),
(165650, 'Palm', 40.4280586242676, 0.705602733182758, -75.533332824707, -1.31830535279585, 218, 45, 'PPL', 'P'),
(67576, 'Palm (historical)', 35.6749992370605, 0.622646197333172, -82.9749984741211, -1.44818692021068, 218, 33, 'PPL', 'P'),
(96862, 'Palm Acres Estates Colonia', 26.2399997711182, 0.45797439172857, -98.3679962158203, -1.71684541255539, 218, 51, 'PPL', 'P'),
(96863, 'Palm Acres Number 1 Colonia', 26.2299995422363, 0.457799854808629, -98.3150024414063, -1.7159204967088, 218, 51, 'PPL', 'P'),
(17484, 'Palm Aire', 26.2058296203613, 0.457378010091961, -80.1919403076172, -1.39961339193067, 218, 12, 'PPL', 'P'),
(17485, 'Palm Bay', 28.0341701507568, 0.489288572195022, -80.5888900756836, -1.40654147234846, 218, 12, 'PPL', 'P'),
(17486, 'Palm Beach', 26.7052803039551, 0.466095068972008, -80.0366668701172, -1.39690335920541, 218, 12, 'PPL', 'P'),
(120951, 'Palm Beach', 42.3766708374023, 0.739612432146533, -88.1972198486328, -1.53933187746394, 218, 18, 'PPL', 'P'),
(17499, 'Palm Beach Farms', 26.6688899993896, 0.465459938341538, -80.1497192382813, -1.39887649525705, 218, 12, 'PPL', 'P'),
(17488, 'Palm Beach Gardens', 26.8230590820313, 0.468150696438413, -80.1388931274414, -1.39868754397771, 218, 12, 'PPL', 'P'),
(17489, 'Palm Beach Isles', 26.7916698455811, 0.46760285091267, -80.0366668701172, -1.39690335920541, 218, 12, 'PPL', 'P'),
(17490, 'Palm Beach Lakes', 26.7250003814697, 0.466439249253387, -80.0708312988281, -1.39749964097348, 218, 12, 'PPL', 'P'),
(17491, 'Palm Beach Shores', 26.7777805328369, 0.467360436674446, -80.0358276367188, -1.39688871181941, 218, 12, 'PPL', 'P'),
(17492, 'Palm City', 27.1674995422363, 0.474162316546076, -80.2663879394531, -1.40091274822652, 218, 12, 'PPL', 'P'),
(183957, 'Palm City', 32.583610534668, 0.568691286017466, -117.08332824707, -2.04348957710466, 218, 6, 'PPL', 'P'),
(17493, 'Palm Coast', 29.5847206115723, 0.516350782954566, -81.2080612182617, -1.41734804741978, 218, 12, 'PPL', 'P'),
(183958, 'Palm Desert', 33.7222213745117, 0.588563794071637, -116.373611450195, -2.03110268224248, 218, 6, 'PPL', 'P'),
(183959, 'Palm Desert Country', 33.7405586242676, 0.588883839455638, -116.314720153809, -2.03007483521977, 218, 6, 'PPL', 'P'),
(96864, 'Palm Drive North Colonia', 26.2639999389648, 0.458393273678526, -98.3679962158203, -1.71684541255539, 218, 51, 'PPL', 'P'),
(28174, 'Palm Garden Mobile Home Park', 39.9008293151855, 0.696400845826262, -91.4022216796875, -1.59526971194829, 218, 18, 'PPL', 'P'),
(178783, 'Palm Gardens Mobile Home Manor', 33.4130592346191, 0.583167896808001, -111.768058776855, -1.95072062421867, 218, 5, 'PPL', 'P'),
(96865, 'Palm Grove', 25.8525009155273, 0.451211260850801, -97.4175033569336, -1.70025618265112, 218, 51, 'PPL', 'P'),
(117217, 'Palm Grove', 42.3261108398438, 0.738729993719336, -94.1738891601563, -1.64364443525292, 218, 16, 'PPL', 'P'),
(177676, 'Palm Grove', 32.735279083252, 0.571338401561978, -116.208892822266, -2.02822779984574, 218, 6, 'PPL', 'P'),
(17494, 'Palm Grove Colony', 28.5511093139648, 0.498310862625506, -82.6263885498047, -1.44210252922623, 218, 12, 'PPL', 'P'),
(17495, 'Palm Harbor', 28.0777797698975, 0.490049703634567, -82.7638931274414, -1.44450243684256, 218, 12, 'PPL', 'P'),
(96866, 'Palm Harbor', 27.9702796936035, 0.488173473357092, -97.0936126708984, -1.69460322376326, 218, 51, 'PPL', 'P'),
(96867, 'Palm Heights Colonia', 26.1949996948242, 0.457188992233592, -98.1959991455078, -1.71384349737465, 218, 51, 'PPL', 'P'),
(208379, 'Palm Lake', 47.2180595397949, 0.82411060537214, -118.013610839844, -2.05972607132254, 218, 56, 'PPL', 'P'),
(96868, 'Palm Lake Estates Number 1 Colonia', 26.2910003662109, 0.458864520033416, -98.2949981689453, -1.71557135628989, 218, 51, 'PPL', 'P'),
(96869, 'Palm Lake Estates Number 2 Colonia', 26.2940006256104, 0.458916884438349, -98.2939987182617, -1.71555391258475, 218, 51, 'PPL', 'P'),
(96870, 'Palm Lake Estates Number 3 Colonia', 26.2889995574951, 0.458829599333622, -98.2900009155273, -1.71548413776419, 218, 51, 'PPL', 'P'),
(96871, 'Palm Lake Estates Number 4 Colonia', 26.2889995574951, 0.458829599333622, -98.2919998168945, -1.71551902517447, 218, 51, 'PPL', 'P'),
(17496, 'Palm Lake Park', 27.2250003814697, 0.475165895513359, -80.2516708374023, -1.40065588633939, 218, 12, 'PPL', 'P'),
(178777, 'Palm Lakes Village', 33.6352806091309, 0.587046391461537, -112.008331298828, -1.95491417082917, 218, 5, 'PPL', 'P'),
(17498, 'Palm River', 27.9424991607666, 0.48768861159113, -82.3977813720703, -1.43811258128108, 218, 12, 'PPL', 'P'),
(17512, 'Palm River Estates', 26.2780609130859, 0.458638683972977, -81.7780609130859, -1.42729641882983, 218, 12, 'PPL', 'P'),
(17500, 'Palm River Shores', 26.273609161377, 0.458560986248174, -81.7880630493164, -1.42747098903928, 218, 12, 'PPL', 'P'),
(17501, 'Palm Shadows', 28.788330078125, 0.502451146014198, -81.1430587768555, -1.41621354079541, 218, 12, 'PPL', 'P'),
(178778, 'Palm Shadows Mobile Home Park', 33.5438919067383, 0.585451357705662, -112.169998168945, -1.95773579000411, 218, 5, 'PPL', 'P'),
(17502, 'Palm Shores', 28.1841697692871, 0.491906559415111, -80.6530609130859, -1.40766146474489, 218, 12, 'PPL', 'P'),
(17504, 'Palm Springs', 26.6355590820313, 0.464878204090924, -80.0963897705078, -1.39794572045607, 218, 12, 'PPL', 'P'),
(178779, 'Palm Springs', 33.4047203063965, 0.583022355054428, -111.537780761719, -1.94670151465958, 218, 5, 'PPL', 'P'),
(183961, 'Palm Springs', 33.8302803039551, 0.590449778176604, -116.544441223145, -2.03408422424088, 218, 6, 'PPL', 'P'),
(17505, 'Palm Springs Estates', 25.8822193145752, 0.451729944762607, -80.3063888549805, -1.40161089590629, 218, 12, 'PPL', 'P'),
(14364, 'Palm Springs Manor', 39.6416702270508, 0.691877666451844, -75.7855606079102, -1.32270755807775, 218, 10, 'PPL', 'P'),
(17506, 'Palm Springs North', 25.9305591583252, 0.452573634195944, -80.32861328125, -1.40199878531906, 218, 12, 'PPL', 'P'),
(17507, 'Palm Valley', 30.1772193908691, 0.526691837467344, -81.3877792358398, -1.42048471855168, 218, 12, 'PPL', 'P'),
(96872, 'Palm Valley', 26.2013893127441, 0.45730051210424, -97.7538909912109, -1.70612725443225, 218, 51, 'PPL', 'P'),
(17508, 'Palm Valley Landing', 30.1755599975586, 0.52666287559049, -81.4005584716797, -1.42070775829297, 218, 12, 'PPL', 'P'),
(17509, 'Palm View', 27.5683307647705, 0.481158141124092, -82.5572204589844, -1.4408953183041, 218, 12, 'PPL', 'P'),
(183965, 'Palm Wells', 34.0777816772461, 0.59476949204374, -116.538612365723, -2.03398249148724, 218, 6, 'PPL', 'P'),
(37574, 'Palma', 36.9625015258789, 0.645117351400015, -88.3783264160156, -1.54249278336175, 218, 21, 'PPL', 'P'),
(189192, 'Palma', 34.9786109924316, 0.610491929592213, -105.465278625488, -1.84071635854797, 218, 38, 'PPL', 'P'),
(96873, 'Palma Alta Colonia', 26.2320003509521, 0.457834775508423, -98.3860015869141, -1.71715966556402, 218, 51, 'PPL', 'P'),
(17510, 'Palma Ceia', 27.920560836792, 0.487305715605403, -82.4955596923828, -1.4398191349076, 218, 12, 'PPL', 'P'),
(96874, 'Palma Colonia', 26.2970008850098, 0.458969248843283, -98.1019973754883, -1.71220285698511, 218, 51, 'PPL', 'P'),
(17511, 'Palma Sola', 27.5119400024414, 0.480173936653739, -82.6322174072266, -1.44220426197988, 218, 12, 'PPL', 'P'),
(17513, 'Palma Sola Park', 27.4913902282715, 0.479815275433933, -82.6369400024414, -1.44228668681561, 218, 12, 'PPL', 'P'),
(96875, 'Palmarina Colonia', 26.2560005187988, 0.458253657458379, -98.390998840332, -1.71724688408972, 218, 51, 'PPL', 'P'),
(178780, 'Palmaritas', 33.5588912963867, 0.585713146440817, -112.131942749023, -1.95707159762824, 218, 5, 'PPL', 'P'),
(96876, 'Palmas Colonia Number 2', 26.2970008850098, 0.458969248843283, -98.1009979248047, -1.71218541327997, 218, 51, 'PPL', 'P'),
(178782, 'Palmas del Sol', 33.4508285522461, 0.583827095756822, -111.696113586426, -1.9494649437647, 218, 5, 'PPL', 'P'),
(23714, 'Palmas Realas', 30.8455600738525, 0.538356582910432, -81.5694427490234, -1.42365534498747, 218, 13, 'PPL', 'P'),
(178781, 'Palmas Royale', 33.5569381713867, 0.585679057978863, -112.08332824707, -1.95622311450494, 218, 5, 'PPL', 'P'),
(17514, 'Palmdale', 26.9449996948242, 0.47027896162355, -81.3163909912109, -1.41923875863569, 218, 12, 'PPL', 'P'),
(137364, 'Palmdale', 45.4555587768555, 0.793349163989934, -92.7333297729492, -1.61850193087565, 218, 28, 'PPL', 'P'),
(165652, 'Palmdale', 40.297779083252, 0.703328926244049, -76.6188888549805, -1.337251879739, 218, 45, 'PPL', 'P'),
(183963, 'Palmdale', 34.5794410705566, 0.603525100180566, -118.115562438965, -2.06150546240488, 218, 6, 'PPL', 'P'),
(337, 'Palmer', 34.5761108398438, 0.603466976689775, -91.065559387207, -1.58939384647719, 218, 4, 'PPL', 'P'),
(28175, 'Palmer', 39.4577789306641, 0.688668157864135, -89.4038925170898, -1.56039228852234, 218, 18, 'PPL', 'P'),
(33562, 'Palmer', 39.6319389343262, 0.691707823353324, -97.1399993896484, -1.69541282473465, 218, 20, 'PPL', 'P'),
(37575, 'Palmer', 37.8133316040039, 0.659967137638297, -84.0663909912109, -1.46723531306553, 218, 21, 'PPL', 'P'),
(56776, 'Palmer', 37.8394393920898, 0.660422804500809, -90.9958267211914, -1.58817678185903, 218, 29, 'PPL', 'P'),
(89747, 'Palmer', 35.3511085510254, 0.616993238445315, -85.5677795410156, -1.49343948661136, 218, 50, 'PPL', 'P'),
(96877, 'Palmer', 32.4311103820801, 0.566029656245014, -96.6675033569336, -1.68716621326116, 218, 51, 'PPL', 'P'),
(105032, 'Palmer', 37.2902793884277, 0.650838154316641, -80.0475006103516, -1.39709244364281, 218, 53, 'PPL', 'P'),
(110812, 'Palmer', 38.6575012207031, 0.674700676894997, -80.5894393920898, -1.40655105972839, 218, 58, 'PPL', 'P'),
(113061, 'Palmer', 41.3913917541504, 0.722416068092756, -87.2388916015625, -1.52260589423769, 218, 19, 'PPL', 'P'),
(117218, 'Palmer', 42.6305618286133, 0.744043665884316, -94.6002807617188, -1.65108637260304, 218, 16, 'PPL', 'P'),
(125765, 'Palmer', 42.1583290100098, 0.735801648363712, -72.3291702270508, -1.26238216569749, 218, 23, 'PPL', 'P'),
(132511, 'Palmer', 46.4408302307129, 0.810545394885658, -87.5930633544922, -1.52878735744388, 218, 27, 'PPL', 'P'),
(137365, 'Palmer', 44.1530609130859, 0.770616287766963, -93.5416717529297, -1.6326101599084, 218, 28, 'PPL', 'P'),
(142630, 'Palmer', 41.2222213745117, 0.719463487971212, -98.2569427490234, -1.71490716391403, 218, 35, 'PPL', 'P'),
(151532, 'Palmer', 43.2452812194824, 0.754772543230837, -73.8177795410156, -1.28836329950203, 218, 40, 'PPL', 'P'),
(165653, 'Palmer', 41.7608299255371, 0.728863980566001, -80.429443359375, -1.40375860216738, 218, 45, 'PPL', 'P'),
(175747, 'Palmer', 44.9055595397949, 0.783749866419771, -92.3947219848633, -1.61259211010065, 218, 57, 'PPL', 'P'),
(208380, 'Palmer', 47.3144416809082, 0.825792791074688, -121.89111328125, -2.1274012556792, 218, 56, 'PPL', 'P'),
(212078, 'Palmer', 61.5997200012207, 1.07511793232791, -149.112777709961, -2.60250892783323, 218, 1, 'PPL', 'P'),
(50172, 'Palmer (historical)', 39.6974983215332, 0.692852050515677, -77.2152786254883, -1.34766084485957, 218, 25, 'PPL', 'P'),
(183964, 'Palmer (historical)', 34.8291702270508, 0.607883696199617, -120.321113586426, -2.09999959174921, 218, 6, 'PPL', 'P'),
(89746, 'Palmer Acres South', 35.7797203063965, 0.624473924789293, -86.4063873291016, -1.50807595364633, 218, 50, 'PPL', 'P'),
(125766, 'Palmer Center', 42.1811103820801, 0.736199258314461, -72.3152770996094, -1.26213968488024, 218, 23, 'PPL', 'P'),
(96878, 'Palmer Colonia', 26.07200050354, 0.455042251368393, -97.6399993896484, -1.70413947099462, 218, 51, 'PPL', 'P'),
(172379, 'Palmer Corner', 44.0044403076172, 0.768022368865226, -73.3736114501953, -1.28061110388492, 218, 55, 'PPL', 'P'),
(105033, 'Palmer Crossroads', 36.5722198486328, 0.638305651121865, -78.2041702270508, -1.36492025925216, 218, 53, 'PPL', 'P'),
(125767, 'Palmer Green Estates', 42.165828704834, 0.735932542731289, -72.3450012207031, -1.26265846866059, 218, 23, 'PPL', 'P'),
(165654, 'Palmer Heights', 40.6872215270996, 0.710125979136203, -75.2627792358398, -1.31358330186703, 218, 45, 'PPL', 'P'),
(208381, 'Palmer Junction', 47.3122215270996, 0.825754042080828, -121.888893127441, -2.12736250668534, 218, 56, 'PPL', 'P'),
(187158, 'Palmer Lake', 39.1222190856934, 0.682811533731915, -104.91667175293, -1.83114136232275, 218, 7, 'PPL', 'P'),
(42478, 'Palmer Landing', 32.3277816772461, 0.564226230133839, -93.6763916015625, -1.63496146483483, 218, 22, 'PPL', 'P'),
(14365, 'Palmer Park', 39.1027793884277, 0.682472247009039, -75.540283203125, -1.3184266597835, 218, 10, 'PPL', 'P'),
(50173, 'Palmer Park', 38.9208297729492, 0.679296627146201, -76.871940612793, -1.34166846609078, 218, 25, 'PPL', 'P'),
(105035, 'Palmer Park', 37.288330078125, 0.650804132433716, -80.04638671875, -1.39707300256685, 218, 53, 'PPL', 'P'),
(105036, 'Palmer Springs', 36.5605583190918, 0.638102119035555, -78.2394409179688, -1.36553584893813, 218, 53, 'PPL', 'P'),
(96879, 'Palmeras Colonia', 26.3250007629395, 0.459457938903313, -98.3259963989258, -1.71611237746534, 218, 51, 'PPL', 'P'),
(4841, 'Palmerdale', 33.7386093139648, 0.588849817572712, -86.646110534668, -1.5122599128769, 218, 2, 'PPL', 'P'),
(4842, 'Palmerdale Trailer Park', 33.7322196960449, 0.588738297702065, -86.6500015258789, -1.5123278234847, 218, 2, 'PPL', 'P'),
(50174, 'Palmers', 38.2336082458496, 0.667302348807729, -76.7577819824219, -1.33967602212124, 218, 25, 'PPL', 'P'),
(137368, 'Palmers', 46.9247207641602, 0.818990877913544, -91.8505630493164, -1.60309474502121, 218, 28, 'PPL', 'P'),
(165656, 'Palmers', 40.2649993896484, 0.702756812662872, -79.4166717529297, -1.3860824030642, 218, 45, 'PPL', 'P'),
(50175, 'Palmers Corner', 38.7755584716797, 0.676761164630391, -76.9580612182617, -1.34317155421003, 218, 25, 'PPL', 'P'),
(61213, 'Palmers Crossing', 31.2822208404541, 0.545977751001912, -89.2755584716797, -1.55815243688753, 218, 30, 'PPL', 'P'),
(4843, 'Palmers Crossroads', 31.2997207641602, 0.54628318228943, -87.5486068725586, -1.52801144546028, 218, 2, 'PPL', 'P'),
(105037, 'Palmers Crossroads', 38.7122192382813, 0.675655686461899, -77.9286117553711, -1.36011085663958, 218, 53, 'PPL', 'P'),
(113892, 'Palmers Hill', 41.0636100769043, 0.716695198597102, -73.5663909912109, -1.28397574160613, 218, 8, 'PPL', 'P'),
(89749, 'Palmersville', 36.4033317565918, 0.635357997848338, -88.5872192382813, -1.54613865089407, 218, 50, 'PPL', 'P'),
(120952, 'Palmerton', 40.000560760498, 0.698141487914738, -90.1488876342773, -1.57339490622854, 218, 18, 'PPL', 'P'),
(165657, 'Palmerton', 40.8013916015625, 0.712118622842828, -75.6105575561523, -1.31965317862354, 218, 45, 'PPL', 'P'),
(113893, 'Palmertown', 41.4474983215332, 0.723395312425578, -72.1313934326172, -1.25893030945058, 218, 8, 'PPL', 'P'),
(165660, 'Palmertown', 40.4713897705078, 0.706359004353314, -79.1816711425781, -1.38198086866937, 218, 45, 'PPL', 'P'),
(67577, 'Palmerville', 35.4272193908691, 0.618321623197046, -80.1177825927734, -1.3983190956409, 218, 33, 'PPL', 'P'),
(82823, 'Palmerville', 33.2538909912109, 0.580389886895912, -79.6477813720703, -1.39011602685123, 218, 48, 'PPL', 'P'),
(151533, 'Palmerville', 44.4174995422363, 0.775231612515098, -75.1283264160156, -1.3112366574725, 218, 40, 'PPL', 'P'),
(96880, 'Palmetal', 26.1955604553223, 0.457198779350598, -97.6630630493164, -1.70454200779338, 218, 51, 'PPL', 'P'),
(4844, 'Palmetto', 33.4838905334473, 0.584404136186015, -87.977783203125, -1.53550198550029, 218, 2, 'PPL', 'P'),
(17515, 'Palmetto', 27.521110534668, 0.480333992635253, -82.5725021362305, -1.44116203388727, 218, 12, 'PPL', 'P'),
(23716, 'Palmetto', 33.9058303833008, 0.59176837581133, -82.9230575561523, -1.44728038017562, 218, 13, 'PPL', 'P'),
(42481, 'Palmetto', 30.7172203063965, 0.53611663140708, -91.9091720581055, -1.60411766519591, 218, 22, 'PPL', 'P'),
(50176, 'Palmetto', 38.2238883972168, 0.667132705446291, -75.646110534668, -1.32027369515752, 218, 25, 'PPL', 'P'),
(56777, 'Palmetto', 37.142219543457, 0.64825402253191, -93.0952835083008, -1.62481921529743, 218, 29, 'PPL', 'P'),
(61214, 'Palmetto', 34.1916694641113, 0.596757208902348, -88.7808303833008, -1.54951780284322, 218, 30, 'PPL', 'P'),
(82824, 'Palmetto', 34.2519416809082, 0.597809157532929, -79.8274993896484, -1.39325269798313, 218, 48, 'PPL', 'P'),
(89750, 'Palmetto', 35.4919395446777, 0.619451202973404, -86.664436340332, -1.51257975852382, 218, 50, 'PPL', 'P'),
(96881, 'Palmetto', 29.5355606079102, 0.51549277903037, -95.4661102294922, -1.66619794757648, 218, 51, 'PPL', 'P'),
(105038, 'Palmetto', 36.5550003051758, 0.638005113392849, -80.2169418334961, -1.40004975087528, 218, 53, 'PPL', 'P'),
(183966, 'Palmetto', 39.8238906860352, 0.695058013425617, -121.318061828613, -2.11739962104735, 218, 6, 'PPL', 'P'),
(17516, 'Palmetto Bay', 25.6213893890381, 0.447177603774253, -80.3249969482422, -1.40193566840122, 218, 12, 'PPL', 'P'),
(4845, 'Palmetto Beach', 30.2474994659424, 0.527918456175921, -87.8397216796875, -1.53309235734599, 218, 2, 'PPL', 'P'),
(82825, 'Palmetto Bluff', 32.2077789306641, 0.562131787094546, -80.8844375610352, -1.41169974906384, 218, 48, 'PPL', 'P'),
(82826, 'Palmetto Downs', 34.8583297729492, 0.608392626283931, -82.2827835083008, -1.43610548992554, 218, 48, 'PPL', 'P'),
(82827, 'Palmetto Dunes', 32.1786117553711, 0.561622723852178, -80.7152786254883, -1.40874736867937, 218, 48, 'PPL', 'P'),
(17517, 'Palmetto Estates', 25.6211109161377, 0.447172743505264, -80.3622207641602, -1.40258534654915, 218, 12, 'PPL', 'P'),
(82829, 'Palmetto Estates', 34.9513893127441, 0.610016821653743, -82.1933288574219, -1.43454421173648, 218, 48, 'PPL', 'P'),
(82831, 'Palmetto Fort', 32.8325004577637, 0.573035234650522, -79.8086090087891, -1.39292299864018, 218, 48, 'PPL', 'P'),
(82833, 'Palmetto Hall Plantation', 32.2333297729492, 0.56257773341908, -80.7063903808594, -1.40859223954588, 218, 48, 'PPL', 'P'),
(96882, 'Palmetto Park', 30.7491703033447, 0.536674264049829, -95.311393737793, -1.66349763538919, 218, 51, 'PPL', 'P'),
(23717, 'Palmetto Pines', 33.4947204589844, 0.584593154044384, -84.6297225952148, -1.47706730433594, 218, 13, 'PPL', 'P'),
(23718, 'Palmetto Pines Mobile Home Park', 30.7805595397949, 0.537222109575572, -81.6827774047852, -1.42563340788713, 218, 13, 'PPL', 'P'),
(82836, 'Palmetto Shores', 33.8574981689453, 0.590924819536047, -78.6527786254883, -1.37274995285699, 218, 48, 'PPL', 'P'),
(82839, 'Palmetto Terrace', 34.8263893127441, 0.60783516008875, -82.4749984741211, -1.43946027395071, 218, 48, 'PPL', 'P'),
(96883, 'Palmhurst', 26.2580604553223, 0.458289610133095, -98.3177795410156, -1.71596896624064, 218, 51, 'PPL', 'P'),
(96884, 'Palmhurst Estates Colonia', 26.2520008087158, 0.458183849348305, -98.306999206543, -1.71578081390963, 218, 51, 'PPL', 'P'),
(96885, 'Palmhurst Manor Number 1 Colonia', 26.2490005493164, 0.458131484943371, -98.2770004272461, -1.71525723643932, 218, 51, 'PPL', 'P'),
(17518, 'Palmo', 29.9661102294922, 0.523007287520192, -81.567497253418, -1.42362138968358, 218, 12, 'PPL', 'P'),
(183967, 'Palmo', 35.5591697692871, 0.620624591749692, -119.330276489258, -2.08270622205273, 218, 6, 'PPL', 'P'),
(17519, 'Palmona Park', 26.6861095428467, 0.465760476070553, -81.8966674804688, -1.42936649394515, 218, 12, 'PPL', 'P'),
(132513, 'Palms', 43.6136093139648, 0.761201081207152, -82.7683334350586, -1.44457993483028, 218, 27, 'PPL', 'P'),
(183968, 'Palms', 34.0227813720703, 0.593809555628821, -118.404716491699, -2.06655215267058, 218, 6, 'PPL', 'P'),
(178784, 'Palms Trailer Park', 33.4663887023926, 0.584098671608983, -112.037498474121, -1.95542323407154, 218, 5, 'PPL', 'P'),
(105039, 'Palmtown', 38.0933303833008, 0.664854038238592, -76.6555633544922, -1.337891970507, 218, 53, 'PPL', 'P'),
(96886, 'Palmview', 26.233060836792, 0.457853284477999, -98.3705596923828, -1.7168901536617, 218, 51, 'PPL', 'P'),
(96887, 'Palmview Paradise Colonia', 26.2339992523193, 0.457869662918703, -98.3600006103516, -1.71670586291427, 218, 51, 'PPL', 'P'),
(96888, 'Palmview South', 26.2152805328369, 0.457542959631978, -98.3783264160156, -1.71702570856119, 218, 51, 'PPL', 'P'),
(4847, 'Palmyra', 31.6677799224854, 0.552707026444324, -86.0272216796875, -1.50145826465359, 218, 2, 'PPL', 'P'),
(11057, 'Palmyra', 33.922779083252, 0.59206418642941, -91.9302825927734, -1.60448611353273, 218, 4, 'PPL', 'P'),
(23719, 'Palmyra', 31.6375007629395, 0.552178555415511, -84.1944427490234, -1.46947023785232, 218, 13, 'PPL', 'P'),
(30764, 'Palmyra', 38.4077796936035, 0.670342214034, -86.1100006103516, -1.50290302954496, 218, 19, 'PPL', 'P'),
(56778, 'Palmyra', 39.7941703796387, 0.694539296224297, -91.523063659668, -1.59737880237358, 218, 29, 'PPL', 'P'),
(67582, 'Palmyra', 36.0711097717285, 0.629559630364963, -77.3413925170898, -1.34986194750052, 218, 33, 'PPL', 'P'),
(89752, 'Palmyra', 36.4375, 0.635954346195434, -87.4855575561523, -1.52691102729786, 218, 50, 'PPL', 'P'),
(105041, 'Palmyra', 36.7597198486328, 0.641578143469354, -76.5911102294922, -1.33676705126255, 218, 53, 'PPL', 'P'),
(117219, 'Palmyra', 41.4361114501953, 0.723196574029231, -93.4380569458008, -1.63080174037018, 218, 16, 'PPL', 'P'),
(120953, 'Palmyra', 41.8516693115234, 0.730449426941952, -89.5777816772461, -1.56342722690059, 218, 18, 'PPL', 'P'),
(128467, 'Palmyra', 44.8463897705078, 0.782717159128066, -69.3591690063477, -1.21054586560797, 218, 26, 'PPL', 'P'),
(132514, 'Palmyra', 41.8597183227539, 0.730589908689454, -83.9358291625977, -1.4649565792788, 218, 27, 'PPL', 'P'),
(142631, 'Palmyra', 40.7044410705566, 0.710426516865219, -96.3872222900391, -1.68227438581285, 218, 35, 'PPL', 'P'),
(145986, 'Palmyra', 40.5613899230957, 0.70792980334327, -75.0155563354492, -1.30926844826888, 218, 37, 'PPL', 'P'),
(151534, 'Palmyra', 43.0638885498047, 0.751606643905978, -77.2336120605469, -1.34798082366455, 218, 40, 'PPL', 'P'),
(157017, 'Palmyra', 41.0988883972168, 0.717310921441128, -81.0516662597656, -1.41461844046051, 218, 41, 'PPL', 'P'),
(165661, 'Palmyra', 40.3088912963867, 0.703522870950434, -76.5936126708984, -1.33681072710443, 218, 45, 'PPL', 'P'),
(175748, 'Palmyra', 42.8777809143066, 0.748358452903436, -88.5861129760742, -1.54611934297617, 218, 57, 'PPL', 'P'),
(205269, 'Palmyra', 40.1402816772461, 0.700580077945896, -111.698059082031, -1.9494988990686, 218, 52, 'PPL', 'P'),
(190585, 'Palmyra (historical)', 39.1713905334473, 0.683669737393193, -119.478057861328, -2.08528549356847, 218, 39, 'PPL', 'P'),
(117221, 'Palo', 42.0661087036133, 0.734192100379895, -91.795280456543, -1.60212988175828, 218, 16, 'PPL', 'P'),
(132516, 'Palo', 43.1124992370605, 0.75245506045025, -84.9855575561523, -1.483277795998, 218, 27, 'PPL', 'P'),
(137371, 'Palo', 47.4152793884277, 0.827552741081067, -92.2594375610352, -1.61023095147819, 218, 28, 'PPL', 'P'),
(42482, 'Palo Alto', 30.0916690826416, 0.525198702912678, -91.0380630493164, -1.58891394484876, 218, 22, 'PPL', 'P'),
(61216, 'Palo Alto', 33.6805610656738, 0.587836684515018, -88.8000030517578, -1.54985242903419, 218, 30, 'PPL', 'P'),
(96889, 'Palo Alto', 27.6613903045654, 0.482782336493904, -97.7972183227539, -1.70688345902378, 218, 51, 'PPL', 'P'),
(105043, 'Palo Alto', 38.4233283996582, 0.670613590149079, -79.3705596923828, -1.38527759578278, 218, 53, 'PPL', 'P'),
(165665, 'Palo Alto', 40.6872215270996, 0.710125979136203, -76.1725006103516, -1.32946093512803, 218, 45, 'PPL', 'P'),
(183969, 'Palo Alto', 37.4419403076172, 0.653485136703098, -122.141937255859, -2.13177895987907, 218, 6, 'PPL', 'P'),
(96891, 'Palo Alto Heights', 29.3302803039551, 0.511909961836859, -98.5563888549805, -1.72013348439525, 218, 51, 'PPL', 'P'),
(96890, 'Palo Alto Park', 29.3369808197021, 0.512026907898227, -98.5536804199219, -1.7200862132859, 218, 51, 'PPL', 'P'),
(189193, 'Palo Blanco (historical)', 36.5033302307129, 0.637103300468721, -104.063056945801, -1.81624297339458, 218, 38, 'PPL', 'P'),
(96892, 'Palo Blanco Colonia', 26.386999130249, 0.460540014543726, -98.9020004272461, -1.72616554426428, 218, 51, 'PPL', 'P'),
(193844, 'Palo Cedro', 40.5638885498047, 0.70797341260612, -122.237777709961, -2.13345169135975, 218, 6, 'PPL', 'P'),
(96893, 'Palo Hueco Estates Colonia', 27.8579998016357, 0.486213819558471, -97.9960021972656, -1.71035289213388, 218, 51, 'PPL', 'P'),
(56779, 'Palo Pinto', 38.3816719055176, 0.669886547171488, -93.4552764892578, -1.6311022780992, 218, 29, 'PPL', 'P'),
(96894, 'Palo Pinto', 32.767219543457, 0.571895867757158, -98.2983322143555, -1.71562954635971, 218, 51, 'PPL', 'P'),
(178785, 'Palo Verde', 33.3480606079102, 0.582033456762654, -112.676666259766, -1.96657881640371, 218, 5, 'PPL', 'P'),
(183970, 'Palo Verde', 33.4327812194824, 0.583512110378893, -114.731391906738, -2.00244054416856, 218, 6, 'PPL', 'P'),
(96896, 'Palo Verde Colonia', 26.1229991912842, 0.455932346383725, -98.1989974975586, -1.71389582849007, 218, 51, 'PPL', 'P'),
(178786, 'Palo Verde Mobile Home and Recreational Vehicle Park', 33.4897193908691, 0.584505868939656, -112.935562133789, -1.97109740182525, 218, 5, 'PPL', 'P'),
(178787, 'Palo Verde Mobile Manor', 33.464168548584, 0.584059922615123, -111.990280151367, -1.95459911887221, 218, 5, 'PPL', 'P'),
(178788, 'Palo Verde Stand', 32.3363914489746, 0.564376498998347, -112.032218933105, -1.95533108869782, 218, 5, 'PPL', 'P'),
(192004, 'Paloduro', 34.8169403076172, 0.607670243838247, -101.187782287598, -1.76605996370978, 218, 51, 'PPL', 'P'),
(120955, 'Paloma', 40.0227813720703, 0.698529310748481, -91.1949996948242, -1.59165300602991, 218, 18, 'PPL', 'P'),
(183972, 'Paloma', 38.2594413757324, 0.66775322198028, -120.762222290039, -2.10769839098647, 218, 6, 'PPL', 'P'),
(192005, 'Paloma', 28.8841705322266, 0.504123877494876, -100.424438476563, -1.75273710088249, 218, 51, 'PPL', 'P'),
(42483, 'Paloma (historical)', 30.6988906860352, 0.535796719181134, -91.2991714477539, -1.5934711461061, 218, 22, 'PPL', 'P'),
(183971, 'Paloma (historical)', 35.172779083252, 0.613880802079339, -119.163063049316, -2.07978779697217, 218, 6, 'PPL', 'P'),
(50177, 'Paloma Villa', 39.3794403076172, 0.687300890960489, -77.1722183227539, -1.34690930079995, 218, 25, 'PPL', 'P'),
(183974, 'Palomar Mountain', 33.3227806091309, 0.581592237549055, -116.877777099609, -2.03990203280021, 218, 6, 'PPL', 'P'),
(183975, 'Palomar Park', 37.4816703796387, 0.654178557271928, -122.263328552246, -2.13389763768429, 218, 6, 'PPL', 'P'),
(183977, 'Palomar West Mobile Home Park', 33.1383285522461, 0.57837294184434, -117.210830688477, -2.04571491451153, 218, 6, 'PPL', 'P'),
(178789, 'Palomas', 32.9088897705078, 0.574368479671242, -113.480560302734, -1.98060941429069, 218, 5, 'PPL', 'P'),
(189194, 'Palomas', 35.1283302307129, 0.613105023253799, -103.917221069336, -1.81369765718273, 218, 38, 'PPL', 'P'),
(178790, 'Palominas', 31.3797206878662, 0.547679444359445, -110.117782592773, -1.92191787123919, 218, 5, 'PPL', 'P'),
(113331, 'Palomino Farms', 40.2394409179688, 0.702310733180284, -75.1297225952148, -1.31126102539648, 218, 45, 'PPL', 'P'),
(4848, 'Palos', 33.6455612182617, 0.587225821939982, -87.0449981689453, -1.51922181544053, 218, 2, 'PPL', 'P'),
(73829, 'Palos', 39.5319404602051, 0.689962520732941, -82.0733337402344, -1.43244990185524, 218, 41, 'PPL', 'P'),
(105044, 'Palos', 38.5727806091309, 0.673222023278757, -78.9655609130859, -1.37820903361749, 218, 53, 'PPL', 'P'),
(120956, 'Palos Heights', 41.6680603027344, 0.72724484520226, -87.79638671875, -1.53233601959641, 218, 18, 'PPL', 'P'),
(120957, 'Palos Hills', 41.6966705322266, 0.72774418790665, -87.8169403076172, -1.53269474739524, 218, 18, 'PPL', 'P'),
(120958, 'Palos Park', 41.6672210693359, 0.727230197816265, -87.8302764892578, -1.53292750767451, 218, 18, 'PPL', 'P'),
(183978, 'Palos Verdes Estates', 33.8005599975586, 0.589931060975284, -118.389167785645, -2.0662807765555, 218, 6, 'PPL', 'P'),
(209926, 'Palouse', 46.9102783203125, 0.818738809716368, -117.074722290039, -2.04333937481918, 218, 56, 'PPL', 'P'),
(96897, 'Paluxy', 32.2705612182617, 0.563227544725059, -97.9072189331055, -1.70880333185362, 218, 51, 'PPL', 'P'),
(28178, 'Palzo', 37.648609161377, 0.657092188662529, -88.7633285522461, -1.54921233826619, 218, 18, 'PPL', 'P'),
(96898, 'Pamela Heights', 29.6269397735596, 0.517087646338678, -95.4491729736328, -1.66590233669548, 218, 51, 'PPL', 'P'),
(67579, 'Pamlico', 35.0847206115723, 0.612343891814255, -76.6352767944336, -1.33753790324007, 218, 33, 'PPL', 'P'),
(105045, 'Pamlico', 36.9436111450195, 0.644787652057063, -76.2636108398438, -1.33105110861491, 218, 53, 'PPL', 'P'),
(67580, 'Pamlico Beach', 35.3925018310547, 0.617715687470026, -76.600830078125, -1.33693669462399, 218, 33, 'PPL', 'P'),
(67584, 'Pamlico Shores', 35.1186103820801, 0.612935379892361, -75.9847183227539, -1.32618351593252, 218, 33, 'PPL', 'P'),
(105046, 'Pampa', 37.5258293151855, 0.654949276091397, -76.5930633544922, -1.3368011397245, 218, 53, 'PPL', 'P'),
(192006, 'Pampa', 35.5361099243164, 0.620222121529954, -100.959442138672, -1.76207467629653, 218, 51, 'PPL', 'P'),
(208382, 'Pampa', 46.7775001525879, 0.816421393514809, -117.953056335449, -2.05866919584395, 218, 56, 'PPL', 'P'),
(82837, 'Pamplico', 33.9958305358887, 0.593339174801286, -79.5702819824219, -1.38876340733358, 218, 48, 'PPL', 'P'),
(105047, 'Pamplin', 37.2633285522461, 0.650367773489106, -78.6827774047852, -1.3732735303273, 218, 53, 'PPL', 'P'),
(105048, 'Pamunkey (historical)', 37.6691703796387, 0.657451049619417, -77.2044372558594, -1.34747162726412, 218, 53, 'PPL', 'P'),
(105049, 'Pamunkey Estates', 37.6980590820313, 0.657955252592796, -77.2813873291016, -1.34881465940185, 218, 53, 'PPL', 'P'),
(89751, 'Pan Gap', 35.0516700744629, 0.611767051122143, -85.3677825927734, -1.4899488813706, 218, 50, 'PPL', 'P'),
(178791, 'Pan Tak', 32.0116691589355, 0.558709025882549, -111.564720153809, -1.94717169575003, 218, 5, 'PPL', 'P'),
(4849, 'Pana', 34.038890838623, 0.594090718860906, -86.2949981689453, -1.50613184605057, 218, 2, 'PPL', 'P'),
(28179, 'Pana', 39.3888893127441, 0.687465807210992, -89.0800018310547, -1.55473932963448, 218, 18, 'PPL', 'P'),
(190586, 'Panaca', 37.7905616760254, 0.65956972742463, -114.388610839844, -1.99645788593775, 218, 39, 'PPL', 'P'),
(17520, 'Panacea', 30.0372200012207, 0.524248387167196, -84.3877792358398, -1.47284459611151, 218, 12, 'PPL', 'P'),
(17521, 'Panacea Park', 30.0288906097412, 0.524103011861192, -84.3988876342773, -1.47303847423887, 218, 12, 'PPL', 'P'),
(17522, 'Panacoochee Retreats', 28.7999992370605, 0.502654811258561, -82.1355590820313, -1.43353593894778, 218, 12, 'PPL', 'P'),
(28181, 'Panama', 39.0294418334961, 0.681192265210119, -89.524169921875, -1.56249152525159, 218, 18, 'PPL', 'P'),
(37577, 'Panama', 37.8494415283203, 0.660597374710264, -83.3013916015625, -1.45388355494042, 218, 21, 'PPL', 'P'),
(56780, 'Panama', 38.0469398498535, 0.664044370688181, -94.3547210693359, -1.64680054746078, 218, 29, 'PPL', 'P'),
(76876, 'Panama', 35.1672210693359, 0.613783796436633, -94.6722183227539, -1.65234191989896, 218, 42, 'PPL', 'P'),
(117224, 'Panama', 41.726390838623, 0.72826290510797, -95.4719390869141, -1.66629968033012, 218, 16, 'PPL', 'P'),
(123391, 'Panama', 41.7063903808594, 0.727913831268088, -85.1074981689453, -1.48540606118314, 218, 19, 'PPL', 'P'),
(142633, 'Panama', 40.5977783203125, 0.708564900684226, -96.5105590820313, -1.68442701892196, 218, 35, 'PPL', 'P'),
(151537, 'Panama', 42.0750007629395, 0.73434729609242, -79.4833297729492, -1.3872458049864, 218, 40, 'PPL', 'P'),
(183979, 'Panama', 35.2669410705566, 0.615524238788027, -119.05583190918, -2.07791626051611, 218, 6, 'PPL', 'P'),
(200115, 'Panama', 40.313060760498, 0.70359564182722, -118.158889770508, -2.06226166699641, 218, 39, 'PPL', 'P'),
(17523, 'Panama City', 30.1586093902588, 0.526367031682895, -85.6602783203125, -1.49505389486417, 218, 12, 'PPL', 'P'),
(17524, 'Panama City Beach', 30.1763896942139, 0.526677356528917, -85.8055572509766, -1.49758949053804, 218, 12, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(17525, 'Panama Park', 30.3847198486328, 0.530313403654716, -81.6408309936523, -1.42490130490347, 218, 12, 'PPL', 'P'),
(193843, 'Panamenik (historical)', 41.3027801513672, 0.720869503868719, -123.540283203125, -2.15618470074078, 218, 6, 'PPL', 'P'),
(183980, 'Panamint', 36.1183280944824, 0.630383745564288, -117.094436645508, -2.04368345523202, 218, 6, 'PPL', 'P'),
(183981, 'Panamint Springs', 36.3397216796875, 0.634247792568911, -117.466941833496, -2.05018489724317, 218, 6, 'PPL', 'P'),
(96899, 'Pancake', 31.6175003051758, 0.551829481575629, -97.7994384765625, -1.70692220801764, 218, 51, 'PPL', 'P'),
(110814, 'Pancake', 39.2580604553223, 0.685182412892358, -78.8341674804688, -1.37591578560282, 218, 58, 'PPL', 'P'),
(165667, 'Pancake', 41.0522193908691, 0.716496393621727, -77.9180603027344, -1.3599266990502, 218, 45, 'PPL', 'P'),
(42484, 'Panchoville', 30.3649997711182, 0.529969223373337, -92.6511077880859, -1.61706688652226, 218, 22, 'PPL', 'P'),
(37578, 'Panco', 37.2372207641602, 0.649912106626594, -83.5336074829102, -1.45793648664536, 218, 21, 'PPL', 'P'),
(71230, 'Pancoast', 39.5224990844727, 0.689797737640492, -74.8711090087891, -1.30674736682296, 218, 37, 'PPL', 'P'),
(165668, 'Pancoast', 41.1286087036133, 0.717829638642448, -78.8230590820313, -1.37572190747546, 218, 45, 'PPL', 'P'),
(73830, 'Pancoastburg', 39.624439239502, 0.691576928985747, -83.2655563354492, -1.45325811155841, 218, 41, 'PPL', 'P'),
(23723, 'Pancras', 32.9980583190918, 0.575924764433257, -83.2574996948242, -1.45311749665286, 218, 13, 'PPL', 'P'),
(192007, 'Pandale', 30.1841697692871, 0.526813144454997, -101.550559997559, -1.77239162920144, 218, 51, 'PPL', 'P'),
(187159, 'Pando', 39.457218170166, 0.688658370747129, -106.333061218262, -1.85586202198336, 218, 7, 'PPL', 'P'),
(89753, 'Pandora', 36.4216690063477, 0.635678043232338, -81.9416732788086, -1.43015199330867, 218, 50, 'PPL', 'P'),
(96900, 'Pandora', 29.25, 0.510508806208341, -97.8375015258789, -1.70758653355156, 218, 51, 'PPL', 'P'),
(157019, 'Pandora', 40.9480590820313, 0.714678453282612, -83.9611129760742, -1.46539786507143, 218, 41, 'PPL', 'P'),
(165669, 'Pandora', 40.3241691589355, 0.703789519954578, -79.3600006103516, -1.38509330503534, 218, 45, 'PPL', 'P'),
(187160, 'Pandora', 37.9333305358887, 0.662061514098562, -107.785003662109, -1.88120319817795, 218, 7, 'PPL', 'P'),
(208383, 'Pandora', 47.2408294677734, 0.824508015585807, -117.272216796875, -2.04678630421807, 218, 56, 'PPL', 'P'),
(261, 'Pane (historical)', 34.5805587768555, 0.603544607835551, -87.5791702270508, -1.52854487662663, 218, 2, 'PPL', 'P'),
(96901, 'Panfilo Martinez Colonia', 26.1560001373291, 0.456508321548482, -98.0459976196289, -1.71122547686505, 218, 51, 'PPL', 'P'),
(11060, 'Pangburn', 35.4266700744629, 0.618312035817122, -91.836669921875, -1.60285226420396, 218, 4, 'PPL', 'P'),
(192738, 'Panguitch', 37.8227806091309, 0.6601320538888, -112.434997558594, -1.96236090186925, 218, 52, 'PPL', 'P'),
(192739, 'Panguitch Lake Resort', 37.7080612182617, 0.658129822802251, -112.640830993652, -1.96595337302171, 218, 52, 'PPL', 'P'),
(4850, 'Panhandle', 32.6861114501953, 0.570480264479727, -87.0258331298828, -1.51888732240762, 218, 2, 'PPL', 'P'),
(23724, 'Panhandle', 32.5577812194824, 0.568240479423943, -84.1816711425781, -1.46924733126909, 218, 13, 'PPL', 'P'),
(37582, 'Panhandle', 37.5566711425781, 0.655487567526729, -83.3833312988281, -1.45531367244579, 218, 21, 'PPL', 'P'),
(157020, 'Panhandle', 40.3586082458496, 0.704390595412609, -80.8688888549805, -1.41142837294876, 218, 41, 'PPL', 'P'),
(192009, 'Panhandle', 35.3455581665039, 0.616896365960663, -101.379997253418, -1.76941474773495, 218, 51, 'PPL', 'P'),
(157021, 'Panhandle Corners', 40.0766716003418, 0.699469872666469, -82.6888885498047, -1.44319336000873, 218, 41, 'PPL', 'P'),
(165670, 'Panic', 41.0361099243164, 0.716215230389642, -78.9475021362305, -1.37789384850248, 218, 45, 'PPL', 'P'),
(105054, 'Panier', 38.1808280944824, 0.666381161386671, -77.7638931274414, -1.35723597424284, 218, 53, 'PPL', 'P'),
(11058, 'Pankey', 34.8002815246582, 0.607379493226238, -92.420280456543, -1.61303818958324, 218, 4, 'PPL', 'P'),
(28182, 'Pankeyville', 37.7083282470703, 0.658134483334159, -88.5361099243164, -1.54524662508695, 218, 18, 'PPL', 'P'),
(11059, 'Pankov', 33.7044410705566, 0.588253469225616, -94.3397216796875, -1.64653875872562, 218, 4, 'PPL', 'P'),
(96903, 'Panna Maria', 28.9580593109131, 0.505413479963234, -97.897216796875, -1.70862876164417, 218, 51, 'PPL', 'P'),
(144289, 'Pannaway Manor', 43.0644416809082, 0.751616297864929, -70.8016662597656, -1.23572219213109, 218, 36, 'PPL', 'P'),
(23725, 'Pannell', 33.7683296203613, 0.589368534774032, -83.6750030517578, -1.46040430486948, 218, 13, 'PPL', 'P'),
(61217, 'Pannell', 34.1549987792969, 0.596117184713374, -89.1127777099609, -1.55531137663663, 218, 30, 'PPL', 'P'),
(105050, 'Pannill Fork', 36.7088890075684, 0.640690977931222, -80.0133285522461, -1.39649602871668, 218, 53, 'PPL', 'P'),
(144290, 'Panno Place', 44.1472206115723, 0.770514355276241, -71.1377792358398, -1.24158847022226, 218, 36, 'PPL', 'P'),
(183982, 'Panoche', 36.5969390869141, 0.638737083218458, -120.832496643066, -2.1089249098265, 218, 6, 'PPL', 'P'),
(183983, 'Panoche Junction', 36.5461082458496, 0.637849917680325, -120.486938476563, -2.10289378206386, 218, 6, 'PPL', 'P'),
(4854, 'Panola', 32.9505615234375, 0.575095788964943, -88.2688903808594, -1.54058276422795, 218, 2, 'PPL', 'P'),
(23726, 'Panola', 33.646110534668, 0.587235409319906, -84.1875, -1.46934906402273, 218, 13, 'PPL', 'P'),
(37579, 'Panola', 37.660831451416, 0.657305507865844, -84.1152801513672, -1.46808858987879, 218, 21, 'PPL', 'P'),
(42485, 'Panola', 32.9075012207031, 0.574344244905323, -91.225830078125, -1.59219109772816, 218, 22, 'PPL', 'P'),
(76877, 'Panola', 34.9286117553711, 0.609619278282022, -95.2130584716797, -1.66178136122469, 218, 42, 'PPL', 'P'),
(82838, 'Panola', 33.6561088562012, 0.587409912950333, -80.4116668701172, -1.40344834390039, 218, 48, 'PPL', 'P'),
(96904, 'Panola', 32.357780456543, 0.564749807604149, -94.0911102294922, -1.64219967036156, 218, 51, 'PPL', 'P'),
(120960, 'Panola', 40.7836112976074, 0.711808297996806, -89.021110534668, -1.55371148261177, 218, 18, 'PPL', 'P'),
(132517, 'Panola', 46.0494384765625, 0.803714320110577, -88.32861328125, -1.5416251254786, 218, 27, 'PPL', 'P'),
(82840, 'Panola Village', 34.1697196960449, 0.59637411317954, -82.149169921875, -1.43377349291701, 218, 48, 'PPL', 'P'),
(23727, 'Panola Woods', 33.6272201538086, 0.586905709976954, -84.2319412231445, -1.47012470969021, 218, 13, 'PPL', 'P'),
(191010, 'Panoma', 36.8338890075684, 0.642872639496214, -101.259170532227, -1.76730592362577, 218, 42, 'PPL', 'P'),
(117225, 'Panora', 41.6916694641113, 0.727656902801923, -94.3627777099609, -1.64694116236633, 218, 16, 'PPL', 'P'),
(205274, 'Panorama Apartments Condominium', 40.7772216796875, 0.711696778126159, -111.889999389648, -1.95284888940381, 218, 52, 'PPL', 'P'),
(183984, 'Panorama City', 34.2247200012207, 0.597334049594459, -118.448890686035, -2.06732313780616, 218, 6, 'PPL', 'P'),
(105051, 'Panorama Court', 37.2902793884277, 0.650838154316641, -80.0036087036133, -1.39632638535524, 218, 53, 'PPL', 'P'),
(50178, 'Panorama Estates', 39.5888900756836, 0.690956479030786, -77.061393737793, -1.34497504690023, 218, 25, 'PPL', 'P'),
(82841, 'Panorama Estates', 35.0405616760254, 0.611573172994786, -81.9658279418945, -1.43057357170923, 218, 48, 'PPL', 'P'),
(105052, 'Panorama Heights', 37.2877807617188, 0.650794545053791, -80.0005569458008, -1.39627312213344, 218, 53, 'PPL', 'P'),
(183987, 'Panorama Heights', 35.8050003051758, 0.624915144002892, -118.628326416016, -2.07045488209004, 218, 6, 'PPL', 'P'),
(28183, 'Panorama Hills', 38.7174987792969, 0.675747831835616, -89.2900009155273, -1.5584045050847, 218, 18, 'PPL', 'P'),
(78900, 'Panorama Hills', 39.9605598449707, 0.697443340234974, -76.6172180175781, -1.33722271812506, 218, 45, 'PPL', 'P'),
(105053, 'Panorama Hills', 37.4199981689453, 0.653102174138345, -79.2113876342773, -1.38249951929166, 218, 53, 'PPL', 'P'),
(117226, 'Panorama Park', 41.5555610656738, 0.725281363109572, -90.4530563354492, -1.57870365154551, 218, 16, 'PPL', 'P'),
(96906, 'Panorama Village', 30.3808307647705, 0.530245526336432, -95.4933319091797, -1.66667305551495, 218, 51, 'PPL', 'P'),
(165671, 'Panorama Village', 40.7841682434082, 0.711818018534785, -77.8102798461914, -1.35804557521423, 218, 45, 'PPL', 'P'),
(4853, 'Pansey', 31.1538906097412, 0.543737965946128, -85.1755599975586, -1.48659396418737, 218, 2, 'PPL', 'P'),
(11061, 'Pansy', 33.8219413757324, 0.590304236423031, -92.0027770996094, -1.60575138136662, 218, 4, 'PPL', 'P'),
(37580, 'Pansy', 36.7750015258789, 0.641844859052526, -83.3288879394531, -1.45436345656885, 218, 21, 'PPL', 'P'),
(73832, 'Pansy', 39.3430595397949, 0.686665926777586, -83.9524993896484, -1.4652475296279, 218, 41, 'PPL', 'P'),
(110815, 'Pansy', 38.9124984741211, 0.679151218550683, -79.1861114501953, -1.38205836665709, 218, 58, 'PPL', 'P'),
(165672, 'Pansy', 41.0416717529297, 0.716312302611376, -79.1516723632813, -1.38145729119906, 218, 45, 'PPL', 'P'),
(165673, 'Pansy Hill', 40.3488883972168, 0.704220952051171, -76.4655609130859, -1.33457580231763, 218, 45, 'PPL', 'P'),
(178792, 'Pantano', 31.999439239502, 0.558495573521179, -110.579437255859, -1.92997526511723, 218, 5, 'PPL', 'P'),
(67585, 'Pantego', 35.5888900756836, 0.621143308951013, -76.6624984741211, -1.33801301117854, 218, 33, 'PPL', 'P'),
(96907, 'Pantego', 32.714168548584, 0.570969953225165, -97.1561126708984, -1.69569405454576, 218, 51, 'PPL', 'P'),
(192008, 'Pantera', 28.9872207641602, 0.505922443337061, -103.20361328125, -1.80124285171276, 218, 51, 'PPL', 'P'),
(23728, 'Pantertown', 34.9863891601563, 0.61062768422878, -84.3480606079102, -1.47215137527976, 218, 13, 'PPL', 'P'),
(37581, 'Panther', 37.6399993896484, 0.656941919798021, -87.2249984741211, -1.52236341342044, 218, 21, 'PPL', 'P'),
(76878, 'Panther', 35.1347198486328, 0.613216543124446, -94.9983291625977, -1.65803362778068, 218, 42, 'PPL', 'P'),
(110816, 'Panther', 37.4833297729492, 0.654207519148782, -81.896110534668, -1.42935677340717, 218, 58, 'PPL', 'P'),
(117227, 'Panther', 41.6883316040039, 0.727598646153077, -94.1061096191406, -1.64246145909671, 218, 16, 'PPL', 'P'),
(165675, 'Panther', 41.2799987792969, 0.720471893917971, -75.2997207641602, -1.31422805316694, 218, 45, 'PPL', 'P'),
(961, 'Panther (historical)', 36.1263885498047, 0.630524427048871, -84.0347213745117, -1.46668257398128, 218, 50, 'PPL', 'P'),
(61219, 'Panther Burn', 33.0661087036133, 0.577112467700406, -90.8683319091797, -1.58595157761021, 218, 30, 'PPL', 'P'),
(67588, 'Panther Creek', 35.6433296203613, 0.622093458248926, -82.9800033569336, -1.44827427189444, 218, 33, 'PPL', 'P'),
(89755, 'Panther Creek (historical)', 36.1866683959961, 0.631576508837507, -83.3836135864258, -1.45531859929381, 218, 50, 'PPL', 'P'),
(89756, 'Panther Hills', 36.1866683959961, 0.631576508837507, -83.3919372558594, -1.45546387473127, 218, 50, 'PPL', 'P'),
(192010, 'Panther Junction', 29.3283290863037, 0.51187590666442, -103.204719543457, -1.80126215963066, 218, 51, 'PPL', 'P'),
(89757, 'Panther Lake', 36.1927795410156, 0.631683168439165, -83.3877792358398, -1.45539130359157, 218, 50, 'PPL', 'P'),
(151538, 'Panther Lake', 43.3261108398438, 0.756183286239279, -75.9008331298828, -1.32471944312325, 218, 40, 'PPL', 'P'),
(67589, 'Panther Landing', 36.5338897705078, 0.637636665056037, -76.149169921875, -1.32905373779735, 218, 33, 'PPL', 'P'),
(56781, 'Panther Valley', 37.1888885498047, 0.649068550351311, -93.0175018310547, -1.62346166893176, 218, 29, 'PPL', 'P'),
(190589, 'Panther Valley', 39.5908317565918, 0.690990367755657, -119.817497253418, -2.09120982857141, 218, 39, 'PPL', 'P'),
(23729, 'Panthersville', 33.707218170166, 0.588301938757455, -84.2719421386719, -1.47082285736998, 218, 13, 'PPL', 'P'),
(151540, 'Pantigo', 40.9677810668945, 0.715022666853505, -72.165283203125, -1.25952179752869, 218, 40, 'PPL', 'P'),
(172380, 'Panton', 44.148609161377, 0.77053859004216, -73.3408279418945, -1.28003892372472, 218, 55, 'PPL', 'P'),
(17526, 'Paola', 28.7936096191406, 0.502543291387914, -81.3630599975586, -1.42005328645509, 218, 12, 'PPL', 'P'),
(33567, 'Paola', 38.5722198486328, 0.673212236161751, -94.8788909912109, -1.65594903843742, 218, 20, 'PPL', 'P'),
(193846, 'Paola (historical)', 41.4552803039551, 0.723531133641172, -120.527496337891, -2.1036016502816, 218, 6, 'PPL', 'P'),
(23730, 'Paoli', 34.0922203063965, 0.595021493661889, -83.091667175293, -1.45022317318016, 218, 13, 'PPL', 'P'),
(30767, 'Paoli', 38.5561103820801, 0.672931072929666, -86.4683303833008, -1.50915706389085, 218, 19, 'PPL', 'P'),
(76879, 'Paoli', 34.8266716003418, 0.607840086936767, -97.2588882446289, -1.69748782669798, 218, 42, 'PPL', 'P'),
(165676, 'Paoli', 40.0419387817383, 0.69886367062334, -75.4766693115234, -1.31731638792505, 218, 45, 'PPL', 'P'),
(175751, 'Paoli', 42.9294395446777, 0.749260066090482, -89.5236129760742, -1.56248180471361, 218, 57, 'PPL', 'P'),
(194364, 'Paoli', 40.6122207641602, 0.708816968881402, -102.472221374512, -1.78847765481774, 218, 7, 'PPL', 'P'),
(165677, 'Paoli Road', 40.0569381713867, 0.699125459358495, -75.4869384765625, -1.31749561866641, 218, 45, 'PPL', 'P'),
(192924, 'Paonia', 38.8683280944824, 0.678380299994132, -107.59139251709, -1.87782404622881, 218, 7, 'PPL', 'P'),
(178793, 'Papago', 33.1041717529297, 0.577776793234326, -113.138328552246, -1.9746363434398, 218, 5, 'PPL', 'P'),
(178794, 'Papago Farms', 31.7858295440674, 0.554767381021664, -112.308326721191, -1.96015007869032, 218, 5, 'PPL', 'P'),
(178795, 'Papago Peaks Village', 33.4563903808594, 0.583924167978556, -111.96639251709, -1.95418220100356, 218, 5, 'PPL', 'P'),
(145988, 'Papakating', 41.1938896179199, 0.718969005535812, -74.5888900756836, -1.3018217172288, 218, 37, 'PPL', 'P'),
(210934, 'Papaloa', 19.5094394683838, 0.340503953941829, -155.798324584961, -2.7191937330984, 218, 15, 'PPL', 'P'),
(96908, 'Papalote', 28.1722202301025, 0.491698000612244, -97.6016693115234, -1.70347048492879, 218, 51, 'PPL', 'P'),
(192011, 'Papalote Colorado', 29.4922199249268, 0.514736341412247, -104.014442443848, -1.81539449027128, 218, 51, 'PPL', 'P'),
(96909, 'Papalote del Norte', 27.0575008392334, 0.472242477005752, -98.0697174072266, -1.7116394652565, 218, 51, 'PPL', 'P'),
(192012, 'Papalote Escondido', 29.475830078125, 0.514450284621659, -103.998611450195, -1.81511818730818, 218, 51, 'PPL', 'P'),
(192013, 'Papalote Llano', 29.4330596923828, 0.513703800568109, -103.946113586426, -1.81420192673514, 218, 51, 'PPL', 'P'),
(192014, 'Papalote Seco', 29.458610534668, 0.514149746892643, -103.905281066895, -1.81348926482744, 218, 51, 'PPL', 'P'),
(112395, 'Papas', 38.3824996948242, 0.669900994820401, -76.4105606079102, -1.33361586590271, 218, 25, 'PPL', 'P'),
(89758, 'Papaw', 36.4211082458496, 0.635668256115332, -83.3625030517578, -1.45495015095699, 218, 50, 'PPL', 'P'),
(56784, 'Pape', 37.9711112976074, 0.662720912784466, -93.9505615234375, -1.63974663268148, 218, 29, 'PPL', 'P'),
(193845, 'Pape Place', 40.1713905334473, 0.701123029913136, -121.801666259766, -2.1258401106482, 218, 6, 'PPL', 'P'),
(165678, 'Paper Mill', 41.0297203063965, 0.716103710518995, -76.4411087036133, -1.33414903075295, 218, 45, 'PPL', 'P'),
(151539, 'Paper Mill Corners', 43.1522216796875, 0.753148347861025, -74.845832824707, -1.30630621418839, 218, 40, 'PPL', 'P'),
(125770, 'Paper Mill Village', 41.9902801513672, 0.73286864247618, -70.942497253418, -1.23818015665918, 218, 23, 'PPL', 'P'),
(172382, 'Paper Mill Village', 42.9116706848145, 0.748949940981542, -73.2361068725586, -1.27821119626859, 218, 55, 'PPL', 'P'),
(165679, 'Paper Mills', 40.1399993896484, 0.700575151097879, -75.0744400024414, -1.31029616213354, 218, 45, 'PPL', 'P'),
(4855, 'Papertown', 33.276668548584, 0.580787430267633, -86.2291717529297, -1.50498295835631, 218, 2, 'PPL', 'P'),
(89759, 'Paperville', 36.5744400024414, 0.638344400115725, -82.1416702270508, -1.43364259854943, 218, 50, 'PPL', 'P'),
(165680, 'Paperville', 41.860279083252, 0.73059969580646, -80.2713928222656, -1.40100009991028, 218, 45, 'PPL', 'P'),
(187161, 'Papeton', 38.8763885498047, 0.678520981478715, -104.801391601563, -1.8291293441192, 218, 7, 'PPL', 'P'),
(142636, 'Papillion', 41.1544418334961, 0.718280511814999, -96.0419387817383, -1.67624805174016, 218, 35, 'PPL', 'P'),
(56782, 'Papin', 38.0677795410156, 0.664408091914058, -90.4705581665039, -1.57900911612254, 218, 29, 'PPL', 'P'),
(120964, 'Papineau', 40.9691696166992, 0.715046901619425, -87.7163925170898, -1.53093985739493, 218, 18, 'PPL', 'P'),
(56783, 'Papinville', 38.0672187805176, 0.664398304797052, -94.2266693115234, -1.64456562267398, 218, 29, 'PPL', 'P'),
(142639, 'Paplin (historical)', 41.2802810668945, 0.720476820765987, -98.7363891601563, -1.72327508237517, 218, 35, 'PPL', 'P'),
(197210, 'Pappas Place', 45.9713897705078, 0.802352113213002, -112.358062744141, -1.96101813604763, 218, 31, 'PPL', 'P'),
(189195, 'Paquita', 34.8652801513672, 0.608513933271584, -106.776390075684, -1.86359957021448, 218, 38, 'PPL', 'P'),
(187162, 'Parachute', 39.4519386291504, 0.688566225373413, -108.052223205566, -1.88586705903696, 218, 7, 'PPL', 'P'),
(11062, 'Paraclifta (historical)', 33.8652801513672, 0.591060640751641, -94.1861114501953, -1.64385775445624, 218, 4, 'PPL', 'P'),
(202471, 'Parade', 45.0238914489746, 0.785815147845127, -101.10417175293, -1.76460068459047, 218, 49, 'PPL', 'P'),
(23740, 'Parade Rest', 31.2058296203613, 0.544644472691677, -81.5180587768555, -1.42275852549039, 218, 13, 'PPL', 'P'),
(42488, 'Paradis', 29.8794403076172, 0.521494612021027, -90.4338912963867, -1.57836915851259, 218, 22, 'PPL', 'P'),
(11064, 'Paradise', 35.6322212219238, 0.621899580121568, -93.8338928222656, -1.63771037971201, 218, 4, 'PPL', 'P'),
(17527, 'Paradise', 29.704719543457, 0.518445159414832, -82.3455581665039, -1.437201114398, 218, 12, 'PPL', 'P'),
(28184, 'Paradise', 39.4102783203125, 0.687839115816794, -88.4366683959961, -1.54351104300454, 218, 18, 'PPL', 'P'),
(30768, 'Paradise', 37.9955596923828, 0.663147617770124, -87.3794403076172, -1.52505893191777, 218, 19, 'PPL', 'P'),
(33566, 'Paradise', 39.1136093139648, 0.682661264867407, -98.9180603027344, -1.72644584196901, 218, 20, 'PPL', 'P'),
(37583, 'Paradise', 37.2680587768555, 0.650450331482899, -86.9836120605469, -1.51815042573399, 218, 21, 'PPL', 'P'),
(42486, 'Paradise', 31.3838901519775, 0.547752215236232, -92.4069366455078, -1.61280529614592, 218, 22, 'PPL', 'P'),
(50204, 'Paradise', 39.2694396972656, 0.68538101813065, -76.7183303833008, -1.3389874618214, 218, 25, 'PPL', 'P'),
(56785, 'Paradise', 39.4275016784668, 0.688139720124836, -94.5155563354492, -1.64960765240778, 218, 29, 'PPL', 'P'),
(71233, 'Paradise', 39.839168548584, 0.695324662429761, -75.2225036621094, -1.3128803604973, 218, 37, 'PPL', 'P'),
(96910, 'Paradise', 33.1500015258789, 0.578576673667731, -97.6869430541992, -1.70495879250398, 218, 51, 'PPL', 'P'),
(110817, 'Paradise', 38.5847206115723, 0.673430415634056, -81.8000030517578, -1.42767938139458, 218, 58, 'PPL', 'P'),
(132519, 'Paradise', 46.627498626709, 0.813803373005206, -85.0374984741211, -1.48418433603307, 218, 27, 'PPL', 'P'),
(151541, 'Paradise', 41.4966697692871, 0.724253516086856, -74.6449966430664, -1.30280096156162, 218, 40, 'PPL', 'P'),
(157022, 'Paradise', 40.9736099243164, 0.715124399607146, -80.7077789306641, -1.4086164743118, 218, 41, 'PPL', 'P'),
(165682, 'Paradise', 40.5688896179199, 0.708060697710847, -76.3813934326172, -1.33310680266034, 218, 45, 'PPL', 'P'),
(178796, 'Paradise', 31.9347190856934, 0.557365993744822, -109.218330383301, -1.90621946871956, 218, 5, 'PPL', 'P'),
(183989, 'Paradise', 39.7597198486328, 0.693938021029184, -121.620826721191, -2.12268386528229, 218, 6, 'PPL', 'P'),
(190591, 'Paradise', 36.0972213745117, 0.630015363806503, -115.14582824707, -2.00967382284727, 218, 39, 'PPL', 'P'),
(197211, 'Paradise', 47.3894386291504, 0.827101734750462, -114.801109313965, -2.00365734247062, 218, 31, 'PPL', 'P'),
(201369, 'Paradise', 45.9383316040039, 0.801775139362836, -117.220832824707, -2.04588948472098, 218, 43, 'PPL', 'P'),
(205277, 'Paradise', 41.5688896179199, 0.72551399023079, -111.837219238281, -1.95192770198275, 218, 52, 'PPL', 'P'),
(208384, 'Paradise', 46.7863883972168, 0.816576522648306, -121.734169006348, -2.12466206134, 218, 56, 'PPL', 'P'),
(209658, 'Paradise', 42.0908317565918, 0.734623599055515, -106.448890686035, -1.85788362756684, 218, 59, 'PPL', 'P'),
(212079, 'Paradise', 62.4155616760254, 1.08935705572823, -160.049163818359, -2.79338487369415, 218, 1, 'PPL', 'P'),
(11065, 'Paradise (historical)', 33.5416717529297, 0.585412608711801, -91.7930603027344, -1.60209113276442, 218, 4, 'PPL', 'P'),
(157023, 'Paradise (historical)', 40.8447189331055, 0.712874827434356, -81.8208312988281, -1.42804290288338, 218, 41, 'PPL', 'P'),
(23731, 'Paradise Acres', 30.8188896179199, 0.5378910956414, -84.879997253418, -1.48143542115589, 218, 13, 'PPL', 'P'),
(178797, 'Paradise Acres', 34.5366706848145, 0.602778616127017, -111.848892211914, -1.95213143380614, 218, 5, 'PPL', 'P'),
(17528, 'Paradise Beach', 30.4005603790283, 0.53058987306538, -87.4205627441406, -1.52577665383154, 218, 12, 'PPL', 'P'),
(50179, 'Paradise Beach', 39.1483306884766, 0.683267267173455, -76.4638900756836, -1.33454664070369, 218, 25, 'PPL', 'P'),
(151542, 'Paradise Beach', 43.3505592346191, 0.756609991224937, -73.6802825927734, -1.28596352504376, 218, 40, 'PPL', 'P'),
(183991, 'Paradise Cay', 37.9127807617188, 0.661702852878756, -122.47444152832, -2.13758225421047, 218, 6, 'PPL', 'P'),
(178798, 'Paradise City', 33.6405601501465, 0.587138536835254, -112.030281066895, -1.95529726655198, 218, 5, 'PPL', 'P'),
(183990, 'Paradise Cove Mobile Home Park', 34.0202789306641, 0.593765879786944, -118.788887023926, -2.07325719334707, 218, 6, 'PPL', 'P'),
(165692, 'Paradise Crossing', 41.1277809143066, 0.717815190993535, -75.3405609130859, -1.3149408482327, 218, 45, 'PPL', 'P'),
(23732, 'Paradise Estates', 33.7480583190918, 0.589014733823215, -84.9516677856445, -1.4826863079199, 218, 13, 'PPL', 'P'),
(142640, 'Paradise Estates', 41.4199981689453, 0.722915344218118, -96.4974975585938, -1.68419905233265, 218, 35, 'PPL', 'P'),
(23733, 'Paradise Falls', 33.8172187805176, 0.590221811587293, -83.4983291625977, -1.45732076380133, 218, 13, 'PPL', 'P'),
(165683, 'Paradise Furnace', 40.3122215270996, 0.703580994441225, -78.1255569458008, -1.36354819865855, 218, 45, 'PPL', 'P'),
(178803, 'Paradise Grove Family Park', 33.5605583190918, 0.585742241475726, -112.210830688477, -1.95844845191181, 218, 5, 'PPL', 'P'),
(178799, 'Paradise Grove Trailer Park', 33.5338897705078, 0.585276787496207, -112.186111450195, -1.95801701981522, 218, 5, 'PPL', 'P'),
(17529, 'Paradise Heights', 28.6233291625977, 0.49957133676944, -81.5441665649414, -1.4232141923529, 218, 12, 'PPL', 'P'),
(76880, 'Paradise Hill', 35.6261100769043, 0.62179292051991, -95.0672225952148, -1.65923604501285, 218, 42, 'PPL', 'P'),
(151544, 'Paradise Hill', 43.1683311462402, 0.75342951109311, -75.6405563354492, -1.32017675609385, 218, 40, 'PPL', 'P'),
(157024, 'Paradise Hill', 40.8661117553711, 0.713248202619185, -82.4030609130859, -1.43820472665479, 218, 41, 'PPL', 'P'),
(200118, 'Paradise Hill', 41.2791709899902, 0.720457446269057, -117.689720153809, -2.05407311243469, 218, 39, 'PPL', 'P'),
(208385, 'Paradise Hill', 48.1861114501953, 0.841006298538848, -119.883331298828, -2.09235884942372, 218, 56, 'PPL', 'P'),
(37584, 'Paradise Hills', 37.0127792358398, 0.645994862979196, -88.0352783203125, -1.53650546459904, 218, 21, 'PPL', 'P'),
(73833, 'Paradise Hills', 38.7066688537598, 0.675558813977247, -83.6477813720703, -1.45992919693101, 218, 41, 'PPL', 'P'),
(187163, 'Paradise Hills', 39.7125015258789, 0.693113905829859, -105.251106262207, -1.83697834564193, 218, 7, 'PPL', 'P'),
(189196, 'Paradise Hills', 35.2005615234375, 0.614365697134815, -106.700561523438, -1.86227611231076, 218, 38, 'PPL', 'P'),
(195435, 'Paradise Hot Springs', 43.5538902282715, 0.760158786535522, -115.27278137207, -2.01188957287421, 218, 17, 'PPL', 'P'),
(50181, 'Paradise Island', 38.9019393920898, 0.678966927803249, -76.353889465332, -1.33262676787386, 218, 25, 'PPL', 'P'),
(71232, 'Paradise Lakes', 39.5263900756836, 0.689865648248289, -75.3391723632813, -1.31491661346678, 218, 37, 'PPL', 'P'),
(117242, 'Paradise Mobile Home Park', 41.6144409179688, 0.726309010395206, -93.7055587768555, -1.6354705280772, 218, 16, 'PPL', 'P'),
(169535, 'Paradise Mobile Home Park', 41.500560760498, 0.724321426694653, -71.2786102294922, -1.24404643475035, 218, 47, 'PPL', 'P'),
(178800, 'Paradise North Mobile Home Park', 33.6536102294922, 0.587366303687483, -112.029441833496, -1.95528261916598, 218, 5, 'PPL', 'P'),
(17530, 'Paradise Palms', 26.3530597686768, 0.459947660938265, -80.1263885498047, -1.39846929792638, 218, 12, 'PPL', 'P'),
(178801, 'Paradise Palms Trailer Resorts', 33.4161109924316, 0.583221160029802, -111.794998168945, -1.95119080530913, 218, 5, 'PPL', 'P'),
(17531, 'Paradise Park', 27.4716701507568, 0.479471095152554, -80.3433303833008, -1.4022556472062, 218, 12, 'PPL', 'P'),
(23735, 'Paradise Park', 31.5524997711182, 0.550695008240769, -81.7088928222656, -1.4260892079077, 218, 13, 'PPL', 'P'),
(67590, 'Paradise Park', 34.7308311462402, 0.606167355456088, -77.476936340332, -1.35222763349684, 218, 33, 'PPL', 'P'),
(142641, 'Paradise Park', 41.1222190856934, 0.717718118771801, -95.8944396972656, -1.67367370707244, 218, 35, 'PPL', 'P'),
(183993, 'Paradise Park', 37.0102806091309, 0.645951253716346, -122.042503356934, -2.13004351095472, 218, 6, 'PPL', 'P'),
(201370, 'Paradise Park', 45.3161087036133, 0.790915301069711, -122.383613586426, -2.1359970075716, 218, 43, 'PPL', 'P'),
(205280, 'Paradise Park', 40.6563911437988, 0.709587887437953, -111.861106872559, -1.9523446198514, 218, 52, 'PPL', 'P'),
(96911, 'Paradise Park Colonia', 26.2140007019043, 0.457520622368335, -98.1490020751953, -1.71302324375891, 218, 51, 'PPL', 'P'),
(183994, 'Paradise Pines', 39.8302803039551, 0.695169533296264, -121.595001220703, -2.12223312526779, 218, 6, 'PPL', 'P'),
(17532, 'Paradise Point', 28.8833293914795, 0.504109196819367, -82.5922164916992, -1.44150611430011, 218, 12, 'PPL', 'P'),
(67591, 'Paradise Point', 35.1886100769043, 0.614157105042435, -81.04638671875, -1.41452629508679, 218, 33, 'PPL', 'P'),
(157025, 'Paradise Point', 40.5513916015625, 0.707755299712842, -81.2194366455078, -1.41754658607905, 218, 41, 'PPL', 'P'),
(4856, 'Paradise Point Estates', 33.1566696166992, 0.578693053807368, -86.4963912963867, -1.50964681921531, 218, 2, 'PPL', 'P'),
(4857, 'Paradise Points', 34.7991714477539, 0.607360118729308, -87.5497207641602, -1.52803088653624, 218, 2, 'PPL', 'P'),
(17533, 'Paradise Port', 26.8852806091309, 0.46923666695192, -80.0744400024414, -1.39756262473326, 218, 12, 'PPL', 'P'),
(178802, 'Paradise Shadows Mobile Home Park', 33.6599998474121, 0.58747782355813, -112.024719238281, -1.95520019433024, 218, 5, 'PPL', 'P'),
(4858, 'Paradise Shores', 34.7219390869141, 0.606012159743564, -87.1302795410156, -1.52071025617378, 218, 2, 'PPL', 'P'),
(183995, 'Paradise Springs', 34.3958282470703, 0.600320451861847, -117.805557250977, -2.05609485117622, 218, 6, 'PPL', 'P'),
(137372, 'Paradise Trailer Court', 43.9991683959961, 0.767930356649564, -92.4286117553711, -1.61318359817876, 218, 28, 'PPL', 'P'),
(165684, 'Paradise Valley', 41.121940612793, 0.717713258502812, -75.2811126708984, -1.313903280672, 218, 45, 'PPL', 'P'),
(178804, 'Paradise Valley', 33.5311088562012, 0.58522825138534, -111.941940307617, -1.95375542943887, 218, 5, 'PPL', 'P'),
(200117, 'Paradise Valley', 41.4936103820801, 0.724200119707, -117.53360748291, -2.05134843232343, 218, 39, 'PPL', 'P'),
(209659, 'Paradise Valley', 42.8175010681152, 0.7473063711148, -106.39778137207, -1.85699160175972, 218, 59, 'PPL', 'P'),
(178805, 'Paradise Valley Miranda', 33.6391716003418, 0.587114302069334, -111.978332519531, -1.95439059335886, 218, 5, 'PPL', 'P'),
(178806, 'Paradise Valley Mobilhome Park', 33.6352806091309, 0.587046391461537, -112.016937255859, -1.95506437311465, 218, 5, 'PPL', 'P'),
(178807, 'Paradise Valley Oasis', 33.6241683959961, 0.586852446755152, -112.001670837402, -1.95479792384759, 218, 5, 'PPL', 'P'),
(195436, 'Paradise Valley Summer Home Area', 44.6697196960449, 0.779633684638945, -115.658058166504, -2.01861392146861, 218, 17, 'PPL', 'P'),
(76881, 'Paradise View', 36.1441688537598, 0.630834751894893, -95.3019409179688, -1.66333265255966, 218, 42, 'PPL', 'P'),
(178808, 'Paradise View Mobile Home Park', 33.4811096191406, 0.584355600075149, -111.981391906738, -1.95444398973871, 218, 5, 'PPL', 'P'),
(23737, 'Paradise Village Mobile Home Park', 31.5269393920898, 0.550248895468667, -84.1208267211914, -1.46818539578442, 218, 13, 'PPL', 'P'),
(178809, 'Paradise Village North II', 33.6133308410645, 0.58666329573873, -111.973609924316, -1.95430816852312, 218, 5, 'PPL', 'P'),
(151545, 'Paradox', 43.8913917541504, 0.766049299392614, -73.646110534668, -1.28536711011764, 218, 40, 'PPL', 'P'),
(187164, 'Paradox', 38.3683280944824, 0.66965365373416, -108.961669921875, -1.90173989860799, 218, 7, 'PPL', 'P'),
(30769, 'Paragon', 39.3950004577637, 0.687572466812649, -86.5625, -1.51080063375759, 218, 19, 'PPL', 'P'),
(37585, 'Paragon', 38.0480613708496, 0.664063944922193, -83.3994369506836, -1.45559476909885, 218, 21, 'PPL', 'P'),
(112211, 'Paragon', 31.8761100769043, 0.556343073570123, -88.3744430541992, -1.54242500591201, 218, 2, 'PPL', 'P'),
(197212, 'Paragon', 46.3652801513672, 0.809226797250932, -106.002777099609, -1.85009747664583, 218, 31, 'PPL', 'P'),
(42487, 'Paragon (historical)', 31.9572200775146, 0.557758710137068, -93.9269409179688, -1.63933437534474, 218, 22, 'PPL', 'P'),
(187165, 'Paragon Estates', 39.9819412231445, 0.697816515682721, -105.174171447754, -1.83563557982032, 218, 7, 'PPL', 'P'),
(89760, 'Paragon Mills', 36.0847206115723, 0.629797184334198, -86.727783203125, -1.51368536985037, 218, 50, 'PPL', 'P'),
(192740, 'Paragonah', 37.8858299255371, 0.661232472051221, -112.774436950684, -1.96828523687218, 218, 52, 'PPL', 'P'),
(11066, 'Paragould', 36.0583305358887, 0.629336590623669, -90.4972229003906, -1.57947450352303, 218, 4, 'PPL', 'P'),
(189197, 'Paraje', 35.0552787780762, 0.611830034881924, -107.474998474121, -1.87579258694929, 218, 38, 'PPL', 'P'),
(189198, 'Paraje (historical)', 33.5563888549805, 0.585669470598939, -107.05638885498, -1.86848647081477, 218, 38, 'PPL', 'P'),
(96912, 'Parajitos Colonia', 26.0830001831055, 0.455234231993474, -97.9739990234375, -1.70996886430469, 218, 51, 'PPL', 'P'),
(76883, 'Parallel', 35.898609161377, 0.626548926752628, -98.8311080932617, -1.72492823962183, 218, 42, 'PPL', 'P'),
(11067, 'Paraloma', 33.797779083252, 0.589882524864417, -94.0188903808594, -1.64093919621762, 218, 4, 'PPL', 'P'),
(117229, 'Paralta', 42.0313911437988, 0.733586164652875, -91.442497253418, -1.59597265331802, 218, 16, 'PPL', 'P'),
(67592, 'Paramore Farm', 35.5838890075684, 0.621056023846285, -77.3463897705078, -1.34994916602622, 218, 33, 'PPL', 'P'),
(23738, 'Paramore Hill', 32.7583312988281, 0.571740738623661, -81.8880615234375, -1.42921629165967, 218, 13, 'PPL', 'P'),
(4860, 'Paramount', 33.3133316040039, 0.581427321298552, -86.8288879394531, -1.51544998038865, 218, 2, 'PPL', 'P'),
(50183, 'Paramount', 39.6830596923828, 0.692600048897528, -77.6963882446289, -1.35605779177659, 218, 25, 'PPL', 'P'),
(183997, 'Paramount', 33.8894386291504, 0.591482285731228, -118.158889770508, -2.06226166699641, 218, 6, 'PPL', 'P'),
(50184, 'Paramount Manor', 39.6824989318848, 0.692590261780522, -77.6919403076172, -1.35598016063082, 218, 25, 'PPL', 'P'),
(82842, 'Paramount Park', 34.8050003051758, 0.607461851482949, -82.3708267211914, -1.43764213387452, 218, 48, 'PPL', 'P'),
(205281, 'Paramount Park', 40.6450004577637, 0.709389082462578, -111.991111755371, -1.95461363310015, 218, 52, 'PPL', 'P'),
(208386, 'Paramount Park', 47.7363891601563, 0.833157163858057, -122.318328857422, -2.13485757409921, 218, 56, 'PPL', 'P'),
(145990, 'Paramus', 40.9444389343262, 0.71461526978575, -74.0758285522461, -1.29286710437952, 218, 37, 'PPL', 'P'),
(4861, 'Paran', 33.2069396972656, 0.579570432228494, -85.2555618286133, -1.4879902595469, 218, 2, 'PPL', 'P'),
(151547, 'Parc', 44.6669387817383, 0.779585148528078, -73.4544372558594, -1.28202178031433, 218, 40, 'PPL', 'P'),
(42489, 'Parc D''Orleans Number 2 Mobile Home Park', 30.0200004577637, 0.523947849438181, -89.9583282470703, -1.5700690175012, 218, 22, 'PPL', 'P'),
(151546, 'Parcells Corners', 42.4577789306641, 0.741028035423965, -79.0969390869141, -1.38050201531605, 218, 40, 'PPL', 'P'),
(61221, 'Parchman', 33.917781829834, 0.59197696790371, -90.4963912963867, -1.57945998929509, 218, 30, 'PPL', 'P'),
(132521, 'Parchment', 42.3280601501465, 0.738764015602262, -85.5697174072266, -1.49347330875721, 218, 27, 'PPL', 'P'),
(110820, 'Parchment Valley', 38.7719383239746, 0.676697981133529, -81.7372207641602, -1.42658362376407, 218, 58, 'PPL', 'P'),
(110818, 'Parcoal', 38.459171295166, 0.671239166689139, -80.3736114501953, -1.40278415152452, 218, 58, 'PPL', 'P'),
(105055, 'Pardee', 37.0066719055176, 0.645888269956566, -82.7516708374023, -1.44428911763924, 218, 53, 'PPL', 'P'),
(110819, 'Pardee', 37.8058280944824, 0.659836176691692, -81.7016677856445, -1.42596310723008, 218, 58, 'PPL', 'P'),
(165687, 'Pardee', 40.8605613708496, 0.713151330134533, -77.272216796875, -1.34865460342034, 218, 45, 'PPL', 'P'),
(183998, 'Pardee', 34.4150009155273, 0.600655078052815, -118.53971862793, -2.06890838444503, 218, 6, 'PPL', 'P'),
(195438, 'Pardee', 46.2986106872559, 0.808063195591649, -116.124443054199, -2.02675387334044, 218, 17, 'PPL', 'P'),
(195437, 'Pardee Corner', 46.3147201538086, 0.808344358823735, -116.095832824707, -2.02625453063605, 218, 17, 'PPL', 'P'),
(165688, 'Pardeesville', 41.0016708374023, 0.715614154931612, -75.966667175293, -1.32586846397556, 218, 45, 'PPL', 'P'),
(175752, 'Pardeeville', 43.5377807617188, 0.759877623303437, -89.3000030517578, -1.55857907529416, 218, 57, 'PPL', 'P'),
(165689, 'Pardoe', 41.2180595397949, 0.71939085025248, -80.1449966430664, -1.39879407042131, 218, 45, 'PPL', 'P'),
(89763, 'Pardue (historical)', 36.3033294677734, 0.633612628648927, -87.154167175293, -1.52112717404243, 218, 50, 'PPL', 'P'),
(23739, 'Pardue Mill', 34.5922203063965, 0.60374813992186, -83.5852813720703, -1.45883836614851, 218, 13, 'PPL', 'P'),
(165690, 'Pardus', 41.1458282470703, 0.718130176371464, -78.8872222900391, -1.37684176671384, 218, 45, 'PPL', 'P'),
(96913, 'Paredes Estates Colonia', 26.1100006103516, 0.455705478348364, -97.4700012207031, -1.70117244322416, 218, 51, 'PPL', 'P'),
(128469, 'Parent', 47.2336082458496, 0.824381981487219, -68.0294418334961, -1.18733774828847, 218, 26, 'PPL', 'P'),
(137373, 'Parent', 45.6324996948242, 0.79643736558999, -93.9861068725586, -1.64036701605742, 218, 28, 'PPL', 'P'),
(175754, 'Parfreyville', 44.3127784729004, 0.773403885058977, -89.1311111450195, -1.5556313554416, 218, 57, 'PPL', 'P'),
(61222, 'Parham', 34.0097198486328, 0.59358158903951, -88.3405609130859, -1.54183365099196, 218, 30, 'PPL', 'P'),
(89761, 'Parham', 35.7730598449707, 0.624357677807711, -85.0124969482422, -1.48374797708846, 218, 50, 'PPL', 'P'),
(11068, 'Parham (historical)', 34.5405616760254, 0.602846526734814, -91.5038909912109, -1.59704417618261, 218, 4, 'PPL', 'P'),
(23741, 'Parhams', 34.4266700744629, 0.600858743297179, -83.2405624389648, -1.45282188577186, 218, 13, 'PPL', 'P'),
(42490, 'Parhams', 31.4675006866455, 0.549211494355541, -91.7863922119141, -1.60197475262478, 218, 22, 'PPL', 'P'),
(192741, 'Paria', 37.2483291625977, 0.650105984753951, -111.948333740234, -1.95386701588855, 218, 52, 'PPL', 'P'),
(11069, 'Paris', 35.2919387817383, 0.615960531153609, -93.7297210693359, -1.63589223963581, 218, 4, 'PPL', 'P'),
(28186, 'Paris', 39.6111106872559, 0.691344301864529, -87.6961135864258, -1.53058592328606, 218, 18, 'PPL', 'P'),
(30770, 'Paris', 38.8241691589355, 0.677609581174663, -85.6338882446289, -1.49459330115364, 218, 19, 'PPL', 'P'),
(37590, 'Paris', 38.2097206115723, 0.666885430939077, -84.253059387207, -1.47049329118508, 218, 21, 'PPL', 'P'),
(50185, 'Paris', 38.7024993896484, 0.675486043100461, -76.5830612182617, -1.33662656951505, 218, 25, 'PPL', 'P'),
(56786, 'Paris', 39.4808311462402, 0.689070494925819, -92.001106262207, -1.60572221975269, 218, 29, 'PPL', 'P'),
(61223, 'Paris', 34.1786117553711, 0.596529308892064, -89.459716796875, -1.56136660600714, 218, 30, 'PPL', 'P'),
(82843, 'Paris', 34.8938903808594, 0.609013275975974, -82.3625030517578, -1.43749685843705, 218, 48, 'PPL', 'P'),
(89762, 'Paris', 36.3019409179688, 0.633588393883007, -88.3266677856445, -1.54159117017471, 218, 50, 'PPL', 'P'),
(96914, 'Paris', 33.660831451416, 0.587492337786071, -95.5552825927734, -1.66775429891752, 218, 51, 'PPL', 'P'),
(105056, 'Paris', 39.0044403076172, 0.68075590626551, -77.9516677856445, -1.36051326028029, 218, 53, 'PPL', 'P'),
(117231, 'Paris', 42.2386093139648, 0.73720280399223, -91.5788879394531, -1.59835311985838, 218, 16, 'PPL', 'P'),
(128470, 'Paris', 44.2597198486328, 0.772477837368929, -70.501106262207, -1.23047643057391, 218, 26, 'PPL', 'P'),
(132522, 'Paris', 43.7733306884766, 0.763988745078192, -85.5025024414063, -1.49230018629703, 218, 27, 'PPL', 'P'),
(144293, 'Paris', 44.6511116027832, 0.779308912144009, -71.3213882446289, -1.24479305196195, 218, 36, 'PPL', 'P'),
(151548, 'Paris', 43.000560760498, 0.750501365474568, -75.3141708374023, -1.31448025452217, 218, 40, 'PPL', 'P'),
(157027, 'Paris', 40.7975006103516, 0.712050712235031, -81.1650009155273, -1.41659650336016, 218, 41, 'PPL', 'P'),
(165691, 'Paris', 40.4036102294922, 0.7051760281971, -80.5127792358398, -1.40521308759673, 218, 45, 'PPL', 'P'),
(175757, 'Paris', 42.6336097717285, 0.744096862527091, -88.0513916015625, -1.53678669441015, 218, 57, 'PPL', 'P'),
(183999, 'Paris', 34.4719390869141, 0.601648836613578, -118.180000305176, -2.06263011533322, 218, 6, 'PPL', 'P'),
(195439, 'Paris', 42.2272186279297, 0.737003999016855, -111.400283813477, -1.94430174020131, 218, 17, 'PPL', 'P'),
(201371, 'Paris', 44.2527809143066, 0.772356730118357, -123.769439697266, -2.16018423606586, 218, 43, 'PPL', 'P'),
(11070, 'Paris (historical)', 36.1800003051758, 0.631460128697871, -90.4555587768555, -1.57874732738738, 218, 4, 'PPL', 'P'),
(67593, 'Paris (historical)', 34.9205589294434, 0.609478729955493, -80.0208282470703, -1.39662692308426, 218, 33, 'PPL', 'P'),
(117232, 'Paris (historical)', 42.2350006103516, 0.737139820232449, -91.4580612182617, -1.5962442957492, 218, 16, 'PPL', 'P'),
(197213, 'Paris (historical)', 47.2911109924316, 0.825385593744015, -106.158332824707, -1.85281243621911, 218, 31, 'PPL', 'P'),
(201372, 'Paris (historical)', 43.9388885498047, 0.766878274860928, -117.326393127441, -2.0477318595631, 218, 43, 'PPL', 'P'),
(30771, 'Paris Crossing', 38.8294410705566, 0.677701593390325, -85.648063659668, -1.49484070881891, 218, 19, 'PPL', 'P'),
(50186, 'Paris Estates', 38.704719543457, 0.675524792094322, -76.5808334350586, -1.33658768736313, 218, 25, 'PPL', 'P'),
(105057, 'Paris Heights', 39.0250015258789, 0.681114767222398, -77.9594421386719, -1.36064894833783, 218, 53, 'PPL', 'P'),
(23742, 'Paris Manor', 33.8499984741211, 0.59079392516847, -84.6999969482422, -1.47829382317598, 218, 13, 'PPL', 'P'),
(50187, 'Paris Oaks', 38.7105598449707, 0.675626724585044, -76.5749969482422, -1.33648582145144, 218, 25, 'PPL', 'P'),
(50188, 'Paris Pines', 38.7024993896484, 0.675486043100461, -76.5783309936523, -1.33654401152125, 218, 25, 'PPL', 'P'),
(82844, 'Paris Point', 34.922779083252, 0.609517478949353, -82.4141693115234, -1.43839860478215, 218, 48, 'PPL', 'P'),
(50189, 'Paris Poplars', 38.7041702270508, 0.675515204714397, -76.5686111450195, -1.33637436815982, 218, 25, 'PPL', 'P'),
(56787, 'Paris Springs', 37.1941719055176, 0.649160762304055, -93.6791687011719, -1.63500993436667, 218, 29, 'PPL', 'P'),
(151549, 'Paris Station', 42.9633293151855, 0.749851554168588, -75.3091735839844, -1.31439303599647, 218, 40, 'PPL', 'P'),
(105058, 'Paris Store', 36.6166687011719, 0.639081429947405, -77.7013931274414, -1.35614514346035, 218, 53, 'PPL', 'P'),
(14366, 'Paris Villa', 39.0647201538086, 0.681807988054146, -75.529167175293, -1.31823264849809, 218, 10, 'PPL', 'P'),
(4862, 'Parish', 31.2024993896484, 0.544586349200886, -85.3824996948242, -1.49020574325774, 218, 2, 'PPL', 'P'),
(23743, 'Parish', 32.3938903808594, 0.565380044676116, -81.9888916015625, -1.43097610850799, 218, 13, 'PPL', 'P'),
(151551, 'Parish', 43.4061088562012, 0.75757951501978, -76.126106262207, -1.32865120099859, 218, 40, 'PPL', 'P'),
(151552, 'Parish Center', 43.4019393920898, 0.757506744142994, -76.0686111450195, -1.32764772189984, 218, 40, 'PPL', 'P'),
(110821, 'Parish-Morris Subdivision', 39.3263893127441, 0.686374976428495, -81.4361114501953, -1.42132827482696, 218, 58, 'PPL', 'P'),
(132524, 'Parishfield', 42.4966697692871, 0.741706808606799, -83.8300018310547, -1.46310954390478, 218, 27, 'PPL', 'P'),
(151554, 'Parishville', 44.6286087036133, 0.77891616246225, -74.8141708374023, -1.30575360826219, 218, 40, 'PPL', 'P'),
(151555, 'Parishville Center', 44.6288909912109, 0.778921089310267, -74.8902816772461, -1.30708199301393, 218, 40, 'PPL', 'P'),
(132525, 'Parisville', 43.7138900756836, 0.762951310675552, -82.7994384765625, -1.44512282021849, 218, 27, 'PPL', 'P'),
(30772, 'Park', 39.0161094665527, 0.680959571509874, -86.8494415283203, -1.51580870818749, 218, 19, 'PPL', 'P'),
(37586, 'Park', 37.1402816772461, 0.648220200386066, -85.7747192382813, -1.49705126568173, 218, 21, 'PPL', 'P'),
(56788, 'Park', 36.9791717529297, 0.645408301749106, -94.1966705322266, -1.64404204520367, 218, 29, 'PPL', 'P'),
(96915, 'Park', 29.9454708099365, 0.522647061693245, -96.7506713867188, -1.68861776921331, 218, 51, 'PPL', 'P'),
(105059, 'Park', 38.2099990844727, 0.666890291208067, -77.2377777099609, -1.3480535279623, 218, 53, 'PPL', 'P'),
(187840, 'Park', 39.1124992370605, 0.682641890370477, -100.358329772949, -1.75158328634022, 218, 20, 'PPL', 'P'),
(165703, 'Park Away Mobile Home Park', 40.148609161377, 0.700725419962387, -76.8133316040039, -1.34064554591609, 218, 45, 'PPL', 'P'),
(190592, 'Park Canyon (historical)', 39.0288887023926, 0.681182611251168, -117.223892211914, -2.04594288110084, 218, 39, 'PPL', 'P'),
(187168, 'Park Center', 38.4777793884277, 0.671563939184074, -105.205558776855, -1.83618339205655, 218, 7, 'PPL', 'P'),
(50190, 'Park Chesapeake', 38.3663902282715, 0.669619831588316, -76.3988876342773, -1.33341213407932, 218, 25, 'PPL', 'P'),
(4864, 'Park City', 30.6430606842041, 0.534822301827788, -87.9122161865234, -1.53435762517989, 218, 2, 'PPL', 'P'),
(23744, 'Park City', 34.9455604553223, 0.609915088900102, -85.2669372558594, -1.48818879820616, 218, 13, 'PPL', 'P'),
(33570, 'Park City', 37.7999992370605, 0.659734443938051, -97.3180618286133, -1.69852060056872, 218, 20, 'PPL', 'P'),
(37587, 'Park City', 37.0938911437988, 0.647410532835655, -86.04638671875, -1.50179275768651, 218, 21, 'PPL', 'P'),
(82846, 'Park City', 34.1311111450195, 0.595700266844723, -79.7455596923828, -1.39182258047776, 218, 48, 'PPL', 'P'),
(89765, 'Park City', 35.0819396972656, 0.612295355703388, -86.5711135864258, -1.51095096920113, 218, 50, 'PPL', 'P'),
(120966, 'Park City', 42.348331451416, 0.739117816553079, -87.8841705322266, -1.53386813617153, 218, 18, 'PPL', 'P'),
(187166, 'Park City', 39.2783317565918, 0.685536213843175, -106.092498779297, -1.8516634153668, 218, 7, 'PPL', 'P'),
(197216, 'Park City', 46.541389465332, 0.812300484623047, -112.108612060547, -1.95666440029757, 218, 31, 'PPL', 'P'),
(205285, 'Park City', 40.646110534668, 0.709408456959509, -111.497222900391, -1.94599364644184, 218, 52, 'PPL', 'P'),
(89766, 'Park City Heights', 35.0830612182617, 0.6123149299374, -86.5755615234375, -1.5110286003469, 218, 50, 'PPL', 'P'),
(4865, 'Park Courts', 33.4775009155273, 0.584292616315368, -86.8863906860352, -1.51645359264545, 218, 2, 'PPL', 'P'),
(165693, 'Park Crest', 40.8166694641113, 0.712385271846972, -76.0475006103516, -1.32727927356303, 218, 45, 'PPL', 'P'),
(197219, 'Park Dale (historical)', 48.0436096191406, 0.838519172396823, -106.440559387207, -1.85773821897132, 218, 31, 'PPL', 'P'),
(23745, 'Park East', 33.9236106872559, 0.592078700657351, -83.3261108398438, -1.45431498703701, 218, 13, 'PPL', 'P'),
(33571, 'Park East', 37.6841697692871, 0.657712838354572, -97.1694412231445, -1.69592668166698, 218, 20, 'PPL', 'P'),
(184000, 'Park Encinitas Trailer Park', 33.0566711425781, 0.576947751186984, -117.264717102051, -2.04665540985049, 218, 6, 'PPL', 'P'),
(50191, 'Park Estates', 38.6208305358887, 0.674060652706023, -76.7808303833008, -1.3400782926039, 218, 25, 'PPL', 'P'),
(142642, 'Park EZ Mobile Home Court', 40.6719398498535, 0.709859263553032, -95.8666687011719, -1.67318901175405, 218, 35, 'PPL', 'P'),
(175758, 'Park Falls', 45.934440612793, 0.801707228755039, -90.4413909912109, -1.57850005288017, 218, 57, 'PPL', 'P'),
(23747, 'Park Forest', 33.7786102294922, 0.589547965252476, -84.682502746582, -1.477988491757, 218, 13, 'PPL', 'P'),
(120967, 'Park Forest', 41.4913902282715, 0.724161370713139, -87.6744384765625, -1.53020762125322, 218, 18, 'PPL', 'P'),
(165694, 'Park Forest Village', 40.8066711425781, 0.712210768216545, -77.9172210693359, -1.35991205166421, 218, 45, 'PPL', 'P'),
(165695, 'Park Gate', 40.8541717529297, 0.713039810263886, -80.307502746582, -1.40163033698225, 218, 45, 'PPL', 'P'),
(11072, 'Park Grove', 34.6922187805176, 0.605493442542244, -91.211669921875, -1.591943956379, 218, 4, 'PPL', 'P'),
(89767, 'Park Grove', 35.3116683959961, 0.616304877882557, -87.3730621337891, -1.5249476117842, 218, 50, 'PPL', 'P'),
(197218, 'Park Grove', 48.0302810668945, 0.838286545275604, -106.444717407227, -1.85781079011103, 218, 31, 'PPL', 'P'),
(50192, 'Park Hall', 39.4550018310547, 0.688619688332296, -77.6477813720703, -1.35520944181135, 218, 25, 'PPL', 'P'),
(50194, 'Park Hall Estates', 39.4127807617188, 0.687882791658671, -77.6627807617188, -1.3554712305465, 218, 25, 'PPL', 'P'),
(17534, 'Park Haven', 26.2947196960449, 0.458929434584986, -80.1116714477539, -1.39821243603924, 218, 12, 'PPL', 'P'),
(50195, 'Park Head', 39.6630592346191, 0.692250975057646, -78.0627822875977, -1.36245257418609, 218, 25, 'PPL', 'P'),
(157032, 'Park Heights', 40.7069396972656, 0.710470126128069, -81.5980606079102, -1.42415482084992, 218, 41, 'PPL', 'P'),
(205287, 'Park Heights', 40.6611099243164, 0.709670245694664, -111.974998474121, -1.95433240328904, 218, 52, 'PPL', 'P'),
(205289, 'Park Heights Condo', 40.6613883972168, 0.709675105963653, -111.974998474121, -1.95433240328904, 218, 52, 'PPL', 'P'),
(4867, 'Park Hill', 33.5963897705078, 0.586367618278703, -86.2861099243164, -1.50597671691708, 218, 2, 'PPL', 'P'),
(11073, 'Park Hill', 34.785831451416, 0.607127291871007, -92.2602767944336, -1.61024559886419, 218, 4, 'PPL', 'P'),
(76884, 'Park Hill', 35.8611106872559, 0.625894454914741, -94.958610534668, -1.65734040694893, 218, 42, 'PPL', 'P'),
(151557, 'Park Hill', 40.9236106872559, 0.714251748296954, -73.8905563354492, -1.28963349418394, 218, 40, 'PPL', 'P'),
(184002, 'Park Hill', 35.5638885498047, 0.620706950006403, -121.103889465332, -2.11366160814132, 218, 6, 'PPL', 'P'),
(37588, 'Park Hills', 39.0713882446289, 0.681924368193782, -84.5322189331055, -1.47536554439938, 218, 21, 'PPL', 'P'),
(56789, 'Park Hills', 37.8541717529297, 0.660679932704056, -90.5180587768555, -1.57983815816988, 218, 29, 'PPL', 'P'),
(82855, 'Park Hills', 34.935001373291, 0.609730798152669, -81.9499969482422, -1.43029726874613, 218, 48, 'PPL', 'P'),
(110822, 'Park Hills', 39.6472206115723, 0.691974538936496, -79.9475021362305, -1.39534714102242, 218, 58, 'PPL', 'P'),
(165696, 'Park Hills', 40.7975006103516, 0.712050712235031, -77.8994369506836, -1.35960166023916, 218, 45, 'PPL', 'P'),
(208387, 'Park Junction', 46.7608299255371, 0.816130443165717, -122.139442443848, -2.13173541719525, 218, 56, 'PPL', 'P'),
(37589, 'Park Lake', 38.3450012207031, 0.669246522982514, -85.4733276367188, -1.49179098989661, 218, 21, 'PPL', 'P'),
(132526, 'Park Lake', 44.1458282470703, 0.770490053931294, -85.2061080932617, -1.4871271290376, 218, 27, 'PPL', 'P'),
(50196, 'Park Lake Estates', 39.3394393920898, 0.686602743280724, -77.2102813720703, -1.34757362633387, 218, 25, 'PPL', 'P'),
(89768, 'Park Lane', 36.5602798461914, 0.638097258766566, -87.394172668457, -1.52531606012101, 218, 50, 'PPL', 'P'),
(96916, 'Park Lane Colonia', 26.2220001220703, 0.457660238588482, -98.3710021972656, -1.71689787682886, 218, 51, 'PPL', 'P'),
(73834, 'Park Lane Subdivision', 38.8388900756836, 0.677866509640828, -82.2605590820313, -1.43571760051277, 218, 41, 'PPL', 'P'),
(82848, 'Park Lane Terrace', 34.7655601501465, 0.60677349092019, -82.3988876342773, -1.43813188919898, 218, 48, 'PPL', 'P'),
(73835, 'Park Layne', 39.8863906860352, 0.696148844208113, -84.0397186279297, -1.46676979250698, 218, 41, 'PPL', 'P'),
(73836, 'Park Layne Manor', 39.8880615234375, 0.69617800582205, -84.0352783203125, -1.46669229451926, 218, 41, 'PPL', 'P'),
(105060, 'Park Manor', 36.8250007629395, 0.642717510362717, -76.3858337402344, -1.33318430064806, 218, 53, 'PPL', 'P'),
(142643, 'Park Meadow Estates Mobile Home Community', 41.3244400024414, 0.721247539585456, -96.0861129760742, -1.67701903687574, 218, 35, 'PPL', 'P'),
(50198, 'Park Mills', 39.297779083252, 0.685875633724105, -77.4080581665039, -1.35102548258078, 218, 25, 'PPL', 'P'),
(151561, 'Park of Edgewater', 40.8224983215332, 0.712487004600613, -73.8099975585938, -1.28822747828644, 218, 40, 'PPL', 'P'),
(17536, 'Park of the Palms', 29.7927799224854, 0.51998210296943, -82.0386123657227, -1.43184389954919, 218, 12, 'PPL', 'P'),
(50199, 'Park Pines', 38.1722183227539, 0.666230892522163, -76.3874969482422, -1.33321332910395, 218, 25, 'PPL', 'P'),
(4870, 'Park Place', 33.5572204589844, 0.58568398482688, -86.8216705322266, -1.51532401286909, 218, 2, 'PPL', 'P'),
(11074, 'Park Place', 34.8288917541504, 0.607878835930628, -90.5961074829102, -1.58120036506745, 218, 4, 'PPL', 'P'),
(13182, 'Park Place', 38.9305610656738, 0.679466470244721, -77.0055618286133, -1.34400059625737, 218, 9, 'PPL', 'P'),
(23749, 'Park Place', 33.9811096191406, 0.59308224633512, -84.7724990844727, -1.47955922416793, 218, 13, 'PPL', 'P'),
(73837, 'Park Place', 39.2391700744629, 0.684852713549406, -84.4716720581055, -1.47430880207884, 218, 41, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(82849, 'Park Place', 34.8694381713867, 0.608586504411289, -82.4088897705078, -1.43830645940844, 218, 48, 'PPL', 'P'),
(96917, 'Park Place', 29.6922206878662, 0.518227013232041, -95.2772216796875, -1.66290122046307, 218, 51, 'PPL', 'P'),
(105062, 'Park Place', 37.2830581665039, 0.650712120218053, -80.0347213745117, -1.39686940390151, 218, 53, 'PPL', 'P'),
(165697, 'Park Place', 40.8383293151855, 0.712763307563709, -76.0983276367188, -1.32816637252214, 218, 45, 'PPL', 'P'),
(201373, 'Park Place', 45.3761100769043, 0.791962522589357, -122.581390380859, -2.1394488638185, 218, 43, 'PPL', 'P'),
(205292, 'Park Place', 40.6480598449707, 0.709442478842435, -111.845832824707, -1.95207803742629, 218, 52, 'PPL', 'P'),
(175760, 'Park Place Homes', 46.730281829834, 0.815597278315484, -92.0955581665039, -1.60737071646745, 218, 57, 'PPL', 'P'),
(117234, 'Park Place Mobile Home Court', 42.7586097717285, 0.746278524092084, -95.5516662597656, -1.66769118199969, 218, 16, 'PPL', 'P'),
(23751, 'Park Place South', 33.6061096191406, 0.586537261640142, -84.4430618286133, -1.47380945937445, 218, 13, 'PPL', 'P'),
(178810, 'Park Place Travel Resort', 33.4088897705078, 0.583095125931214, -111.702781677246, -1.94958132390434, 218, 5, 'PPL', 'P'),
(137374, 'Park Rapids', 46.9222183227539, 0.818947202071667, -95.0583267211914, -1.6590807827213, 218, 28, 'PPL', 'P'),
(208388, 'Park Rapids', 48.5263900756836, 0.846945280927779, -117.638061523438, -2.05317149924764, 218, 56, 'PPL', 'P'),
(120970, 'Park Ridge', 42.0111083984375, 0.733232163964976, -87.8405609130859, -1.53310700473199, 218, 18, 'PPL', 'P'),
(145992, 'Park Ridge', 41.0374984741211, 0.716239465155562, -74.0411071777344, -1.29226110207347, 218, 37, 'PPL', 'P'),
(175761, 'Park Ridge', 44.5194396972656, 0.777010803860353, -89.5458297729492, -1.56286956096833, 218, 57, 'PPL', 'P'),
(73838, 'Park Ridge Acres', 39.9063911437988, 0.696497918047995, -83.8708267211914, -1.46382207265443, 218, 41, 'PPL', 'P'),
(50201, 'Park Ridge Estates', 39.5330581665039, 0.689982028387926, -76.1988906860352, -1.32992152883855, 218, 25, 'PPL', 'P'),
(205294, 'Park Ridge Estates', 40.6197204589844, 0.70894786324898, -111.833892822266, -1.95186964507099, 218, 52, 'PPL', 'P'),
(140669, 'Park River', 48.398609161377, 0.844715083251919, -97.7408294677734, -1.70589928784294, 218, 34, 'PPL', 'P'),
(197220, 'Park Road Trailer Court', 45.6472206115723, 0.796694294056156, -110.572219848633, -1.92984929759767, 218, 31, 'PPL', 'P'),
(89770, 'Park Settlement', 35.7208290100098, 0.623446077766577, -83.6936111450195, -1.46072907736441, 218, 50, 'PPL', 'P'),
(184004, 'Park Sierra Mobile Home Park', 37.7338905334473, 0.658580629395774, -120.960563659668, -2.11116010092941, 218, 6, 'PPL', 'P'),
(23752, 'Park South', 33.6311111450195, 0.586973620584751, -84.4944381713867, -1.47470614571348, 218, 13, 'PPL', 'P'),
(67595, 'Park Spring', 36.4658317565918, 0.636448828630834, -79.4130630493164, -1.38601941930442, 218, 33, 'PPL', 'P'),
(96918, 'Park Springs', 33.4052810668945, 0.583032142171434, -97.8186111450195, -1.70725683420861, 218, 51, 'PPL', 'P'),
(189199, 'Park Springs', 35.2619400024414, 0.6154369536833, -104.928062438965, -1.83134016729813, 218, 38, 'PPL', 'P'),
(89771, 'Park Station', 35.526668548584, 0.620057338437506, -86.9166717529297, -1.51698209696377, 218, 50, 'PPL', 'P'),
(67596, 'Park Sumter Terrace Apartments', 35.2933311462402, 0.615984832498556, -81.5555572509766, -1.42341299732828, 218, 33, 'PPL', 'P'),
(67597, 'Park Terrace', 36.1177787780762, 0.630374158184364, -80.208610534668, -1.39990434227977, 218, 33, 'PPL', 'P'),
(151559, 'Park Terrace', 42.0697212219238, 0.734255150718703, -75.913330078125, -1.32493755601653, 218, 40, 'PPL', 'P'),
(73839, 'Park Terrace Mobile Home Park', 39.9844398498535, 0.697860124945571, -84.0005569458008, -1.46608629221322, 218, 41, 'PPL', 'P'),
(205296, 'Park Valley', 41.8175010681152, 0.729853078594856, -113.328330993652, -1.97795251162917, 218, 52, 'PPL', 'P'),
(13183, 'Park View', 38.9319381713867, 0.679490505273559, -77.0238876342773, -1.34432044190429, 218, 9, 'PPL', 'P'),
(17535, 'Park View', 28.7772197723389, 0.502257234597326, -81.2663879394531, -1.41836604074647, 218, 12, 'PPL', 'P'),
(105063, 'Park View', 38.4661102294922, 0.67136027393971, -78.8808288574219, -1.37673018026417, 218, 53, 'PPL', 'P'),
(110824, 'Park View', 39.3175010681152, 0.686219847294998, -80.0283279418945, -1.39675781745184, 218, 58, 'PPL', 'P'),
(117235, 'Park View', 41.6941719055176, 0.7277005786438, -90.5455627441406, -1.58031819295637, 218, 16, 'PPL', 'P'),
(165698, 'Park View', 40.5016708374023, 0.70688750867164, -79.9313888549805, -1.39506591121131, 218, 45, 'PPL', 'P'),
(50202, 'Park View Estates', 39.2583312988281, 0.685187140003293, -77.2080612182617, -1.34753487734001, 218, 25, 'PPL', 'P'),
(123393, 'Park View Heights', 40.7413902282715, 0.711071401323182, -86.0497207641602, -1.50185094775633, 218, 19, 'PPL', 'P'),
(165699, 'Park View Heights', 40.917781829834, 0.714150015543313, -77.7583312988281, -1.35713890202111, 218, 45, 'PPL', 'P'),
(117236, 'Park View Village Mobile Home Park', 41.663890838623, 0.727172074325474, -93.7736129760742, -1.63665829792337, 218, 16, 'PPL', 'P'),
(145994, 'Park Village', 40.6513900756836, 0.709500602333226, -74.2911071777344, -1.29662442520346, 218, 37, 'PPL', 'P'),
(151560, 'Park Village', 43.0250015258789, 0.750927937302171, -78.8452835083008, -1.37610979688823, 218, 40, 'PPL', 'P'),
(184007, 'Park Village', 36.5111083984375, 0.637239055105288, -116.854721069336, -2.0394996291595, 218, 6, 'PPL', 'P'),
(137377, 'Park Village Mobile Home Park', 45.1363906860352, 0.787778629937816, -94.533332824707, -1.64991791067477, 218, 28, 'PPL', 'P'),
(23754, 'Park Villas', 33.5200004577637, 0.585034373257983, -84.4172210693359, -1.47335845304384, 218, 13, 'PPL', 'P'),
(165700, 'Park Way Manor', 40.5883293151855, 0.708399984433723, -75.5497207641602, -1.31859137629692, 218, 45, 'PPL', 'P'),
(82852, 'Park West', 33.9166717529297, 0.59195759340678, -80.4055633544922, -1.40334181745679, 218, 48, 'PPL', 'P'),
(76886, 'Park Wheeler Corner', 35.624439239502, 0.621763758905974, -96.1572189331055, -1.67826006994372, 218, 42, 'PPL', 'P'),
(205300, 'Park Wood', 40.6411094665527, 0.709321171854782, -112.011940002441, -1.95497715458895, 218, 52, 'PPL', 'P'),
(89773, 'Parkburg', 35.4655609130859, 0.618990808999956, -88.804443359375, -1.54992992702191, 218, 50, 'PPL', 'P'),
(23755, 'Parkchester', 32.4555587768555, 0.566456361230672, -84.9333267211914, -1.48236619595687, 218, 13, 'PPL', 'P'),
(151562, 'Parkchester', 40.8388900756836, 0.712773094680715, -73.8608322143555, -1.2891147104036, 218, 40, 'PPL', 'P'),
(4871, 'Parkdale', 33.0977783203125, 0.577665206784652, -86.1122207641602, -1.50294177853882, 218, 2, 'PPL', 'P'),
(11075, 'Parkdale', 33.1213912963867, 0.578077330963341, -91.5455627441406, -1.59777148547631, 218, 4, 'PPL', 'P'),
(56791, 'Parkdale', 39.189998626709, 0.683994509888128, -94.6474990844727, -1.65191048780237, 218, 29, 'PPL', 'P'),
(71234, 'Parkdale', 39.7211112976074, 0.693264174694367, -74.7602767944336, -1.30481297976518, 218, 37, 'PPL', 'P'),
(82853, 'Parkdale', 32.7819404602051, 0.572152796223324, -80.0436096191406, -1.39702453303501, 218, 48, 'PPL', 'P'),
(132529, 'Parkdale', 44.2675018310547, 0.772613658584523, -86.3027801513672, -1.50626766726617, 218, 27, 'PPL', 'P'),
(137379, 'Parkdale', 46.2333297729492, 0.806923828698286, -96.0124969482422, -1.67573419480783, 218, 28, 'PPL', 'P'),
(201374, 'Parkdale', 45.5200004577637, 0.794473883497302, -121.595558166504, -2.12224284580577, 218, 43, 'PPL', 'P'),
(197221, 'Parkdale (historical)', 48.2166709899902, 0.841539663126163, -114.311111450195, -1.9951052664201, 218, 31, 'PPL', 'P'),
(50203, 'Parke West', 39.1355590820313, 0.683044360590215, -76.6477813720703, -1.3377561492914, 218, 25, 'PPL', 'P'),
(4873, 'Parker', 34.7144393920898, 0.605881265375987, -86.8152770996094, -1.51521242641942, 218, 2, 'PPL', 'P'),
(17537, 'Parker', 30.1308307647705, 0.525882203206446, -85.6033325195313, -1.49406000314535, 218, 12, 'PPL', 'P'),
(28189, 'Parker', 37.5702781677246, 0.655725054916937, -88.8000030517578, -1.54985242903419, 218, 18, 'PPL', 'P'),
(33573, 'Parker', 38.3283309936523, 0.668955572633423, -94.9916687011719, -1.65791738079909, 218, 20, 'PPL', 'P'),
(56792, 'Parker', 37.0644416809082, 0.64689654274527, -89.67138671875, -1.5650609430713, 218, 29, 'PPL', 'P'),
(67600, 'Parker', 36.4577789306641, 0.636308280304305, -81.6894378662109, -1.42574965486871, 218, 33, 'PPL', 'P'),
(76888, 'Parker', 34.7377815246582, 0.606288662443741, -96.1800003051758, -1.67865767989447, 218, 42, 'PPL', 'P'),
(82854, 'Parker', 34.8505592346191, 0.608257004805419, -82.45361328125, -1.43908703192394, 218, 48, 'PPL', 'P'),
(89775, 'Parker', 36.589168548584, 0.638601461739945, -85.0999984741211, -1.48527516681556, 218, 50, 'PPL', 'P'),
(96921, 'Parker', 32.2438888549805, 0.562762024166514, -97.2808303833008, -1.69787078926274, 218, 51, 'PPL', 'P'),
(105064, 'Parker', 38.2750015258789, 0.668024797832441, -77.7574996948242, -1.35712438779317, 218, 53, 'PPL', 'P'),
(144291, 'Parker', 43.0258293151855, 0.750942384951085, -71.628059387207, -1.25014547312079, 218, 36, 'PPL', 'P'),
(145995, 'Parker', 40.7583312988281, 0.711367078783208, -74.7586135864258, -1.3047839513093, 218, 37, 'PPL', 'P'),
(151563, 'Parker', 42.4027786254883, 0.740068099009046, -75.4622192382813, -1.31706418656982, 218, 40, 'PPL', 'P'),
(165701, 'Parker', 41.0958290100098, 0.717257525061272, -79.6827774047852, -1.39072682284724, 218, 45, 'PPL', 'P'),
(171038, 'Parker', 43.3974990844727, 0.757429246155273, -97.1361083984375, -1.69534491412685, 218, 49, 'PPL', 'P'),
(178811, 'Parker', 34.1500015258789, 0.596029966187674, -114.288330078125, -1.99470765646935, 218, 5, 'PPL', 'P'),
(187169, 'Parker', 39.5186080932617, 0.689729827032695, -104.760833740234, -1.82842147590146, 218, 7, 'PPL', 'P'),
(195440, 'Parker', 43.9594383239746, 0.767236936080735, -111.756942749023, -1.95052661293326, 218, 17, 'PPL', 'P'),
(197222, 'Parker', 46.1797218322754, 0.805988193628314, -111.606941223145, -1.94790859242366, 218, 31, 'PPL', 'P'),
(208389, 'Parker', 46.5011100769043, 0.811597476674294, -120.464172363281, -2.10249643842922, 218, 56, 'PPL', 'P'),
(209896, 'Parker', 44.7724990844727, 0.781427523370195, -123.20361328125, -2.15030870211163, 218, 43, 'PPL', 'P'),
(23756, 'Parker (historical)', 32.9561080932617, 0.575192594870568, -83.711669921875, -1.46104426247942, 218, 13, 'PPL', 'P'),
(190593, 'Parker (historical)', 39.7027816772461, 0.692944262468421, -114.099998474121, -1.99142064989392, 218, 39, 'PPL', 'P'),
(123394, 'Parker City', 40.1888885498047, 0.701428427911141, -85.2041702270508, -1.48709330689176, 218, 19, 'PPL', 'P'),
(23757, 'Parker Courthouse', 30.9880599975586, 0.540843675762943, -84.4188919067383, -1.47338761465778, 218, 13, 'PPL', 'P'),
(82877, 'Parker Crossroads', 34.1761093139648, 0.596485633050187, -79.6161117553711, -1.38956328776699, 218, 48, 'PPL', 'P'),
(89777, 'Parker Crossroads', 35.7936096191406, 0.624716339027517, -88.3908309936523, -1.54271102941308, 218, 50, 'PPL', 'P'),
(184008, 'Parker Dam', 34.2872200012207, 0.598424880376955, -114.142219543457, -1.99215754656754, 218, 6, 'PPL', 'P'),
(89776, 'Parker Ford', 36.0169410705566, 0.628614208177985, -85.022216796875, -1.4839176204499, 218, 50, 'PPL', 'P'),
(165702, 'Parker Ford', 40.1994400024414, 0.70161258550052, -75.5841674804688, -1.31919258491301, 218, 45, 'PPL', 'P'),
(128472, 'Parker Head', 43.7844390869141, 0.76418262320555, -69.8030624389648, -1.21829326753512, 218, 26, 'PPL', 'P'),
(4874, 'Parker Heights', 33.5561103820801, 0.58566461032995, -86.7513885498047, -1.514097360871, 218, 2, 'PPL', 'P'),
(50205, 'Parker Heights', 38.3772201538086, 0.669808849446685, -75.5411071777344, -1.31844104085339, 218, 25, 'PPL', 'P'),
(89778, 'Parker Hill', 35.7041702270508, 0.623155327154568, -86.0972213745117, -1.50267998980367, 218, 50, 'PPL', 'P'),
(144292, 'Parker Hill', 44.2541694641113, 0.772380964884277, -71.9505615234375, -1.25577419724273, 218, 36, 'PPL', 'P'),
(17538, 'Parker Island', 27.2444400787354, 0.475505182236235, -81.2983322143555, -1.41892357352068, 218, 12, 'PPL', 'P'),
(184009, 'Parker Junction', 34.7702789306641, 0.606855849176901, -114.595283508301, -2.00006500447621, 218, 6, 'PPL', 'P'),
(56793, 'Parker Lake', 37.6866683959961, 0.657756447617422, -90.0774993896484, -1.57214894631255, 218, 29, 'PPL', 'P'),
(4875, 'Parker Landing', 34.9497184753418, 0.609987660039807, -88.1655578613281, -1.53877927153775, 218, 2, 'PPL', 'P'),
(105066, 'Parker Landing', 37.8036117553711, 0.659797494276859, -75.6774978637695, -1.32082150739375, 218, 53, 'PPL', 'P'),
(208390, 'Parker Landing Light', 45.5786094665527, 0.795496803672001, -122.38166809082, -2.1359630522677, 218, 56, 'PPL', 'P'),
(50206, 'Parker Meadows', 38.7174987792969, 0.675747831835616, -76.9577789306641, -1.34316662736201, 218, 25, 'PPL', 'P'),
(96923, 'Parker Point', 31.0980606079102, 0.542763548592782, -94.2158279418945, -1.64437640507853, 218, 51, 'PPL', 'P'),
(197223, 'Parker School', 48.25, 0.842121364087264, -109.736106872559, -1.91525637324652, 218, 31, 'PPL', 'P'),
(4876, 'Parker Springs', 31.0547199249268, 0.542007110974658, -86.8097229003906, -1.51511548735574, 218, 2, 'PPL', 'P'),
(89779, 'Parker Town (historical)', 36.5999984741211, 0.638790479598314, -87.6977767944336, -1.53061495174194, 218, 50, 'PPL', 'P'),
(4877, 'Parker Village', 31.1674995422363, 0.543975486625849, -85.4700012207031, -1.49173293298484, 218, 2, 'PPL', 'P'),
(50207, 'Parker Wharf', 38.4244384765625, 0.67063296464601, -76.5672225952148, -1.3363501333939, 218, 25, 'PPL', 'P'),
(33575, 'Parkerfield', 37.0750007629395, 0.647080833492703, -96.998893737793, -1.6929500665166, 218, 20, 'PPL', 'P'),
(23758, 'Parkerosa', 34.0999984741211, 0.595157248298456, -84.8466720581055, -1.48085378677381, 218, 13, 'PPL', 'P'),
(11076, 'Parkers', 34.6183280944824, 0.604203806784373, -92.315559387207, -1.61121046212712, 218, 4, 'PPL', 'P'),
(23759, 'Parkers', 32.6997184753418, 0.570717751869935, -81.8099975585938, -1.42785381844598, 218, 13, 'PPL', 'P'),
(128473, 'Parkers', 45.1916694641113, 0.788743426621724, -68.8988876342773, -1.20251244017975, 218, 26, 'PPL', 'P'),
(151564, 'Parkers', 43.7322196960449, 0.763271222901498, -75.6711120605469, -1.32071005410213, 218, 40, 'PPL', 'P'),
(23760, 'Parkers (historical)', 31.9766693115234, 0.558098163307512, -84.1127777099609, -1.46804491403691, 218, 13, 'PPL', 'P'),
(11077, 'Parkers Chapel', 33.1713905334473, 0.578949982273533, -92.7216720581055, -1.61829846536837, 218, 4, 'PPL', 'P'),
(11078, 'Parkers Corner', 34.6575012207031, 0.604887506815224, -91.7186126708984, -1.60079177646857, 218, 4, 'PPL', 'P'),
(132530, 'Parkers Corners', 42.5680618286133, 0.74295283510182, -84.1133270263672, -1.46805450141684, 218, 27, 'PPL', 'P'),
(151565, 'Parkers Corners', 42.7433280944824, 0.746011808508912, -73.9852828979492, -1.29128678458867, 218, 40, 'PPL', 'P'),
(165706, 'Parkers Corners', 41.0924987792969, 0.717199401570481, -79.6975021362305, -1.39098381789244, 218, 45, 'PPL', 'P'),
(50208, 'Parkers Creek', 38.5255584716797, 0.672397841500405, -76.533332824707, -1.33575864531579, 218, 25, 'PPL', 'P'),
(4878, 'Parkers Crossroads', 32.5616683959961, 0.568308323452713, -85.3447189331055, -1.48954634457183, 218, 2, 'PPL', 'P'),
(82856, 'Parkers Ferry', 32.7599983215332, 0.57176983365857, -80.3963928222656, -1.40318176147527, 218, 48, 'PPL', 'P'),
(82857, 'Parkers Ferry Landing', 32.8591690063477, 0.57350068863004, -80.4038925170898, -1.40331265584285, 218, 48, 'PPL', 'P'),
(67604, 'Parkers Fork', 36.5180587768555, 0.637360362092941, -76.5994415283203, -1.33691245985807, 218, 33, 'PPL', 'P'),
(165707, 'Parkers Glen', 41.4361114501953, 0.723196574029231, -74.8863906860352, -1.30701408240613, 218, 45, 'PPL', 'P'),
(56794, 'Parkers Landing', 39.0558280944824, 0.681652792341621, -90.7191696166992, -1.5833482044866, 218, 29, 'PPL', 'P'),
(71241, 'Parkers Landing', 39.5897216796875, 0.690970993258727, -74.3397216796875, -1.29747290832676, 218, 37, 'PPL', 'P'),
(56795, 'Parkers Park', 39.0436096191406, 0.681439539717333, -90.720832824707, -1.58337723294249, 218, 29, 'PPL', 'P'),
(137383, 'Parkers Prairie', 46.1530609130859, 0.80552287280685, -95.32861328125, -1.66379817311821, 218, 28, 'PPL', 'P'),
(30774, 'Parkers Settlement', 38.0466690063477, 0.664039643577246, -87.7161102294922, -1.53093493054692, 218, 19, 'PPL', 'P'),
(30775, 'Parkers Station', 38.7619400024414, 0.676523477503101, -85.6538925170898, -1.49494244157255, 218, 19, 'PPL', 'P'),
(125771, 'Parkers Station', 42.6416702270508, 0.744237544011674, -72.1125030517578, -1.25860061010763, 218, 23, 'PPL', 'P'),
(110825, 'Parkers Towne', 39.3224983215332, 0.686307065820698, -81.4441680908203, -1.42146888973252, 218, 58, 'PPL', 'P'),
(23761, 'Parkersburg', 31.9844398498535, 0.558233784786025, -81.0522232055664, -1.41462816099849, 218, 13, 'PPL', 'P'),
(28191, 'Parkersburg', 38.5897216796875, 0.673517700738783, -88.0566711425781, -1.53687883978387, 218, 18, 'PPL', 'P'),
(30776, 'Parkersburg', 39.8733291625977, 0.695920877618803, -86.9027786254883, -1.51673961614652, 218, 19, 'PPL', 'P'),
(61226, 'Parkersburg', 33.9655609130859, 0.592810870220041, -88.9527816772461, -1.55251891907563, 218, 30, 'PPL', 'P'),
(67601, 'Parkersburg', 34.8369407653809, 0.608019317678129, -78.4436111450195, -1.36909929163471, 218, 33, 'PPL', 'P'),
(76889, 'Parkersburg', 35.4925003051758, 0.61946099009041, -99.0233306884766, -1.72828315680506, 218, 42, 'PPL', 'P'),
(110826, 'Parkersburg', 39.2666702270508, 0.685332681756865, -81.5616683959961, -1.42351965692993, 218, 58, 'PPL', 'P'),
(117237, 'Parkersburg', 42.5774993896484, 0.743117551615241, -92.7866668701172, -1.61943283883469, 218, 16, 'PPL', 'P'),
(201375, 'Parkersburg', 43.1430587768555, 0.752988425037565, -124.341110229492, -2.17016176908984, 218, 43, 'PPL', 'P'),
(78903, 'Parkersville', 39.8888893127441, 0.696192453470963, -75.6463928222656, -1.32027862200554, 218, 45, 'PPL', 'P'),
(82858, 'Parkersville', 33.4538917541504, 0.583880558715706, -79.1233291625977, -1.38096260902658, 218, 48, 'PPL', 'P'),
(208391, 'Parkersville', 45.579719543457, 0.795516178168932, -122.374443054199, -2.13583695159008, 218, 56, 'PPL', 'P'),
(201376, 'Parkersville (historical)', 44.6894416809082, 0.779977898209837, -118.42138671875, -2.06684310301967, 218, 43, 'PPL', 'P'),
(139379, 'Parkerton', 40.1283302307129, 0.700371485853516, -93.6605606079102, -1.63468516187173, 218, 29, 'PPL', 'P'),
(209661, 'Parkerton', 42.8511085510254, 0.74789293234489, -105.972503662109, -1.84956910548556, 218, 59, 'PPL', 'P'),
(4881, 'Parkertown', 34.9097213745117, 0.60928957893907, -87.5108337402344, -1.52735217993243, 218, 2, 'PPL', 'P'),
(23762, 'Parkertown', 34.4575004577637, 0.601396834995429, -83.0400009155273, -1.44932142683506, 218, 13, 'PPL', 'P'),
(50215, 'Parkertown', 38.3869400024414, 0.669978492808123, -75.186393737793, -1.31225012342533, 218, 25, 'PPL', 'P'),
(71236, 'Parkertown', 39.6269416809082, 0.691620604827624, -74.3152770996094, -1.29704626992013, 218, 37, 'PPL', 'P'),
(157034, 'Parkertown', 41.3438911437988, 0.721587026045414, -82.7872161865234, -1.44490950101518, 218, 41, 'PPL', 'P'),
(23763, 'Parkertown Mill', 34.4538917541504, 0.601333851235649, -83.043327331543, -1.44937948374682, 218, 13, 'PPL', 'P'),
(17539, 'Parkerville', 30.6238899230957, 0.534487708926333, -86.8483276367188, -1.51578926711153, 218, 12, 'PPL', 'P'),
(23764, 'Parkerville', 31.4394397735596, 0.548721739031075, -83.9308319091797, -1.4648693607531, 218, 13, 'PPL', 'P'),
(33580, 'Parkerville', 38.7638893127441, 0.676557499386027, -96.6611099243164, -1.68705462681149, 218, 20, 'PPL', 'P'),
(125772, 'Parkerville', 42.5522193908691, 0.742676332401642, -71.4388885498047, -1.24684381915937, 218, 23, 'PPL', 'P'),
(78904, 'Parkesburg', 39.958610534668, 0.697409318352048, -75.9197235107422, -1.3250491424662, 218, 45, 'PPL', 'P'),
(30777, 'Parkeville', 39.8169403076172, 0.694936706437964, -87.0844421386719, -1.51991024258232, 218, 19, 'PPL', 'P'),
(61227, 'Parkeville (historical)', 33.0208282470703, 0.576322174646925, -88.6097183227539, -1.5465313339968, 218, 30, 'PPL', 'P'),
(105067, 'Parkfairfax', 38.8369407653809, 0.677832487757903, -77.079719543457, -1.34529489254715, 218, 53, 'PPL', 'P'),
(50209, 'Parkfield', 39.4913902282715, 0.689254785673252, -76.9625015258789, -1.34324905219775, 218, 25, 'PPL', 'P'),
(184010, 'Parkfield', 35.8997192382813, 0.626568301249559, -120.431671142578, -2.10192918511703, 218, 6, 'PPL', 'P'),
(184011, 'Parkfield Junction', 36.0819396972656, 0.629748648223331, -120.479438781738, -2.10276288769628, 218, 6, 'PPL', 'P'),
(105068, 'Parkglen', 38.8558311462402, 0.678162187100854, -77.1166687011719, -1.34593977700511, 218, 53, 'PPL', 'P'),
(67602, 'Parkhill', 35.7136116027832, 0.623320110247016, -81.7997207641602, -1.42767445454657, 218, 33, 'PPL', 'P'),
(82859, 'Parkhill', 33.7619400024414, 0.589257014903385, -81.8958282470703, -1.42935184655915, 218, 48, 'PPL', 'P'),
(165708, 'Parkhill', 40.3611106872559, 0.704434271254486, -78.8711090087891, -1.37656053690273, 218, 45, 'PPL', 'P'),
(184012, 'Parkhill', 39.7224998474121, 0.693288409460286, -121.495559692383, -2.12049754318539, 218, 6, 'PPL', 'P'),
(128475, 'Parkhurst', 46.7483291625977, 0.815912263693413, -67.9572219848633, -1.18607727414454, 218, 26, 'PPL', 'P'),
(140672, 'Parkhurst', 46.976390838623, 0.819892690837672, -98.7502822875977, -1.72351756319242, 218, 34, 'PPL', 'P'),
(117238, 'Parkhurst (historical)', 41.6061096191406, 0.726163601799688, -91.4000015258789, -1.59523096295443, 218, 16, 'PPL', 'P'),
(50210, 'Parkhurst Manor', 38.3838882446289, 0.669925229586321, -75.5563888549805, -1.31870775643656, 218, 25, 'PPL', 'P'),
(11079, 'Parkin', 35.2633285522461, 0.61546118844922, -90.5711135864258, -1.5807641392809, 218, 4, 'PPL', 'P'),
(132531, 'Parkington', 46.0111083984375, 0.803045334044749, -85.9472198486328, -1.50006196929407, 218, 27, 'PPL', 'P'),
(82860, 'Parkins Lake', 34.8097190856934, 0.607544209739659, -82.3483276367188, -1.43724945077178, 218, 48, 'PPL', 'P'),
(105069, 'Parkins Mills', 39.1069412231445, 0.682544884727771, -78.1572189331055, -1.36410080458474, 218, 53, 'PPL', 'P'),
(195441, 'Parkinson', 43.8161087036133, 0.764735362289796, -111.658332824707, -1.9488055450788, 218, 17, 'PPL', 'P'),
(151566, 'Parkis Mills', 43.0397186279297, 0.751184799189309, -74.0133285522461, -1.29177627359702, 218, 40, 'PPL', 'P'),
(184014, 'Parklabrea', 34.0658302307129, 0.59456089995136, -118.35417175293, -2.06566998055949, 218, 6, 'PPL', 'P'),
(17540, 'Parkland', 26.3097190856934, 0.459191223320141, -80.2375030517578, -1.40040861183217, 218, 12, 'PPL', 'P'),
(37591, 'Parkland', 38.2422218322754, 0.667452684251264, -85.8158264160156, -1.4977687212794, 218, 21, 'PPL', 'P'),
(50211, 'Parkland', 38.8502807617188, 0.678065314616203, -76.9052810668945, -1.34225036678897, 218, 25, 'PPL', 'P'),
(67603, 'Parkland', 35.7491683959961, 0.623940693360032, -78.6488876342773, -1.37268204224919, 218, 33, 'PPL', 'P'),
(76890, 'Parkland', 35.8400001525879, 0.625526006577929, -96.8419418334961, -1.69021073901934, 218, 42, 'PPL', 'P'),
(120972, 'Parkland', 40.4625015258789, 0.706203875219817, -89.7513885498047, -1.56645723843083, 218, 18, 'PPL', 'P'),
(165709, 'Parkland', 40.1588897705078, 0.700904850440831, -74.9322204589844, -1.30781396283953, 218, 45, 'PPL', 'P'),
(175763, 'Parkland', 46.6477813720703, 0.814157373693105, -91.9974975585938, -1.60565923599291, 218, 57, 'PPL', 'P'),
(208392, 'Parkland', 47.1555595397949, 0.823019774589643, -122.432777404785, -2.13685507807482, 218, 56, 'PPL', 'P'),
(165710, 'Parkland Heights', 40.1569404602051, 0.700870828557906, -74.9422225952148, -1.30798853304899, 218, 45, 'PPL', 'P'),
(50212, 'Parkland Terrace', 38.8419418334961, 0.67791977286263, -76.9266662597656, -1.34262360881574, 218, 25, 'PPL', 'P'),
(105070, 'Parklawn', 38.8338890075684, 0.677779224536101, -77.1488876342773, -1.34650210346928, 218, 53, 'PPL', 'P'),
(195442, 'Parkline', 47.3383293151855, 0.82620970894334, -116.685562133789, -2.03654724877504, 218, 17, 'PPL', 'P'),
(128476, 'Parkman', 45.1336097717285, 0.787730093826949, -69.4336090087891, -1.21184508874577, 218, 26, 'PPL', 'P'),
(157035, 'Parkman', 41.3705596923828, 0.722052480024933, -81.0652770996094, -1.41485599442974, 218, 41, 'PPL', 'P'),
(209662, 'Parkman', 44.9569396972656, 0.784646619337828, -107.331939697266, -1.87329574026929, 218, 59, 'PPL', 'P'),
(144294, 'Parkman Corner', 42.9944381713867, 0.750394506135828, -70.9280624389648, -1.23792822162006, 218, 36, 'PPL', 'P'),
(4880, 'Parkmanville', 32.3880615234375, 0.565278311922475, -85.1722183227539, -1.4865356409595, 218, 2, 'PPL', 'P'),
(184013, 'Parkmoor', 37.3211097717285, 0.651376246014892, -121.929718017578, -2.12807503543499, 218, 6, 'PPL', 'P'),
(50213, 'Parkridge', 39.146671295166, 0.6832383052966, -77.2416687011719, -1.3481214385701, 218, 25, 'PPL', 'P'),
(50214, 'Parkridge Estates', 39.1502799987793, 0.68330128905638, -77.2402801513672, -1.34809720380418, 218, 25, 'PPL', 'P'),
(201377, 'Parkrose', 45.5597190856934, 0.79516710432905, -122.559173583984, -2.13906110756379, 218, 43, 'PPL', 'P'),
(11080, 'Parks', 34.8019409179688, 0.607408455103092, -93.960563659668, -1.63992120289094, 218, 4, 'PPL', 'P'),
(42500, 'Parks', 30.2141704559326, 0.52733675521482, -91.8319396972656, -1.60276970621017, 218, 22, 'PPL', 'P'),
(56796, 'Parks', 36.6138916015625, 0.639032960415565, -90.5652770996094, -1.5806622733692, 218, 29, 'PPL', 'P'),
(61228, 'Parks', 34.4905586242676, 0.601973808845595, -88.8758316040039, -1.5511758869379, 218, 30, 'PPL', 'P'),
(178819, 'Parks', 35.2605590820313, 0.615412852075435, -111.948059082031, -1.95386222219859, 218, 5, 'PPL', 'P'),
(199594, 'Parks', 40.0416717529297, 0.698859010091432, -101.724716186523, -1.7754312281116, 218, 35, 'PPL', 'P'),
(157038, 'Parks Corner', 41.6111106872559, 0.726250886904415, -81.3283309936523, -1.41944715099099, 218, 41, 'PPL', 'P'),
(96924, 'Parks Corner Windmill', 28.7594394683838, 0.501946909751305, -99.3141708374023, -1.7333592750008, 218, 51, 'PPL', 'P'),
(165711, 'Parks Crossroad', 41.8172187805176, 0.72984815174684, -76.0175018310547, -1.32675569609272, 218, 45, 'PPL', 'P'),
(67617, 'Parks Crossroads', 35.7036094665527, 0.623145540037562, -79.6050033569336, -1.38936940963963, 218, 33, 'PPL', 'P'),
(23765, 'Parks Mill', 33.5027809143066, 0.584733835528967, -83.288330078125, -1.45365558835111, 218, 13, 'PPL', 'P'),
(82861, 'Parks Mill', 33.8530616760254, 0.590847388127353, -82.2263870239258, -1.43512118558665, 218, 48, 'PPL', 'P'),
(105084, 'Parks Mill', 36.6436080932617, 0.639551611037858, -81.9594421386719, -1.43046211841761, 218, 53, 'PPL', 'P'),
(157039, 'Parks Mills', 40.0355606079102, 0.698752350489775, -82.9316711425781, -1.44743071561916, 218, 41, 'PPL', 'P'),
(61229, 'Parks Place (historical)', 32.7880592346191, 0.572259588983036, -91.1344375610352, -1.59059599739325, 218, 30, 'PPL', 'P'),
(89781, 'Parks Store', 35.0613899230957, 0.611936694483581, -84.9569396972656, -1.48277832013556, 218, 50, 'PPL', 'P'),
(184015, 'Parksdale', 36.9472198486328, 0.644850635816844, -120.021942138672, -2.09477806495795, 218, 6, 'PPL', 'P'),
(50240, 'Parkshire', 39.5094413757324, 0.689569837630209, -76.4347229003906, -1.33403757746133, 218, 25, 'PPL', 'P'),
(89782, 'Parkshore Estates', 35.1752815246582, 0.613924477921217, -85.1655578613281, -1.48641939397792, 218, 50, 'PPL', 'P'),
(14370, 'Parkside', 39.5563888549805, 0.690389225718599, -75.7041702270508, -1.3212870279523, 218, 10, 'PPL', 'P'),
(30778, 'Parkside', 39.2383308410645, 0.684838066163411, -85.9113922119141, -1.49943665907011, 218, 19, 'PPL', 'P'),
(37592, 'Parkside', 38.2463912963867, 0.667525455128051, -85.6369400024414, -1.49464656437544, 218, 21, 'PPL', 'P'),
(50217, 'Parkside', 39.0275001525879, 0.681158376485248, -77.1041717529297, -1.34572166411183, 218, 25, 'PPL', 'P'),
(71237, 'Parkside', 39.9283294677734, 0.696880814033722, -75.0969390869141, -1.31068884523627, 218, 37, 'PPL', 'P'),
(151575, 'Parkside', 40.7105598449707, 0.710533309624931, -73.8513870239258, -1.28894986073212, 218, 40, 'PPL', 'P'),
(165712, 'Parkside', 41.1011085510254, 0.717349670434989, -75.2508316040039, -1.31337477635367, 218, 45, 'PPL', 'P'),
(178812, 'Parkside', 33.3499984741211, 0.582067278908498, -111.987503051758, -1.95455064934037, 218, 5, 'PPL', 'P'),
(165713, 'Parkside Courts', 40.6047210693359, 0.708686074513825, -75.533332824707, -1.31830535279585, 218, 45, 'PPL', 'P'),
(50218, 'Parkside Heights', 39.3763885498047, 0.687247627738687, -76.5780563354492, -1.33653921783129, 218, 25, 'PPL', 'P'),
(137386, 'Parkside Mobile Home Park', 43.9991683959961, 0.767930356649564, -92.4361114501953, -1.61331449254634, 218, 28, 'PPL', 'P'),
(105071, 'Parksley', 37.7819404602051, 0.65941925882304, -75.6538925170898, -1.32040951637312, 218, 53, 'PPL', 'P'),
(61230, 'Parksplace', 34.5102806091309, 0.602318022416488, -90.0569381713867, -1.57179008535566, 218, 30, 'PPL', 'P'),
(151568, 'Parkston', 41.9044418334961, 0.731370481204956, -74.7733306884766, -1.30504081319643, 218, 40, 'PPL', 'P'),
(171041, 'Parkston', 43.3988914489746, 0.75745354750022, -97.9833297729492, -1.71013171660535, 218, 49, 'PPL', 'P'),
(67606, 'Parkstown', 35.377498626709, 0.617453832155844, -77.8180618286133, -1.35818139642982, 218, 33, 'PPL', 'P'),
(165715, 'Parkstown', 41.0163917541504, 0.715871083397777, -80.4066696166992, -1.40336112537469, 218, 45, 'PPL', 'P'),
(23766, 'Parksville', 31.5094394683838, 0.549943464181149, -84.7636108398438, -1.47940409503443, 218, 13, 'PPL', 'P'),
(37593, 'Parksville', 37.5977783203125, 0.656205023124396, -84.8913879394531, -1.48163422613126, 218, 21, 'PPL', 'P'),
(82864, 'Parksville', 33.7861099243164, 0.589678859620054, -82.2197189331055, -1.43500480544701, 218, 48, 'PPL', 'P'),
(89783, 'Parksville', 35.0991706848145, 0.612596093169485, -84.6508331298828, -1.47743575267275, 218, 50, 'PPL', 'P'),
(151569, 'Parksville', 41.855281829834, 0.73051247728076, -74.7600021362305, -1.30480818607522, 218, 40, 'PPL', 'P'),
(117239, 'Parksville (historical)', 40.8688888549805, 0.713296672151025, -91.9269409179688, -1.60442779030485, 218, 16, 'PPL', 'P'),
(50219, 'Parkton', 39.6408309936523, 0.691863019065849, -76.6594390869141, -1.33795961479869, 218, 25, 'PPL', 'P'),
(67607, 'Parkton', 34.9025001525879, 0.609163544840482, -79.0119400024414, -1.37901850143082, 218, 33, 'PPL', 'P'),
(112463, 'Parktown', 36.313060760498, 0.633782471747447, -78.1419372558594, -1.36383408900157, 218, 33, 'PPL', 'P'),
(50220, 'Parktowne', 39.3736114501953, 0.687199158206848, -76.5238876342773, -1.33559379564431, 218, 25, 'PPL', 'P'),
(165716, 'Parkvale', 41.7177810668945, 0.728112636243462, -75.8724975585938, -1.32422489410882, 218, 45, 'PPL', 'P'),
(205305, 'Parkvale', 41.3091697692871, 0.720981023739366, -112.106666564941, -1.95663044499367, 218, 52, 'PPL', 'P'),
(30779, 'Parkview', 39.5163917541504, 0.689691144617862, -87.3919372558594, -1.52527704481104, 218, 19, 'PPL', 'P'),
(50221, 'Parkview', 39.1066703796387, 0.682540157616836, -76.5749969482422, -1.33648582145144, 218, 25, 'PPL', 'P'),
(89784, 'Parkview', 35.8377799987793, 0.625487257584068, -84.695556640625, -1.47821632518825, 218, 50, 'PPL', 'P'),
(105074, 'Parkview', 36.8405609130859, 0.642989086214878, -76.3105621337891, -1.33187056328233, 218, 53, 'PPL', 'P'),
(142644, 'Parkview', 40.9027786254883, 0.713888160229131, -98.3472213745117, -1.71648282317297, 218, 35, 'PPL', 'P'),
(157040, 'Parkview', 41.4286117553711, 0.723065679661653, -81.8694381713867, -1.42889125284862, 218, 41, 'PPL', 'P'),
(177263, 'Parkview', 40.0519409179688, 0.699038240832795, -80.6613922119141, -1.40780687334041, 218, 58, 'PPL', 'P'),
(105075, 'Parkview Court', 37.2722206115723, 0.650522969201631, -79.914436340332, -1.3947700340142, 218, 53, 'PPL', 'P'),
(50224, 'Parkview Estates', 39.0052795410156, 0.680770553651505, -77.0666732788086, -1.34506719227394, 218, 25, 'PPL', 'P'),
(178813, 'Parkview Estates', 33.7033309936523, 0.588234094728685, -112.165000915527, -1.95764857147841, 218, 5, 'PPL', 'P'),
(105076, 'Parkview Hills', 38.9602813720703, 0.679985187446041, -77.1800003051758, -1.34704512201555, 218, 53, 'PPL', 'P'),
(178814, 'Parkview Mesa', 33.3805618286133, 0.582600710074841, -111.843330383301, -1.95203436158441, 218, 5, 'PPL', 'P'),
(117240, 'Parkview Mobile Home Park', 41.6902809143066, 0.727632668036003, -91.8033294677734, -1.60227036350578, 218, 16, 'PPL', 'P'),
(137387, 'Parkview Mobile Home Park', 44.8824996948242, 0.783347396200033, -94.0355606079102, -1.64123014656671, 218, 28, 'PPL', 'P'),
(178815, 'Parkview North', 33.6375007629395, 0.587085140455398, -112.148612976074, -1.95736254797733, 218, 5, 'PPL', 'P'),
(117241, 'Parkview Terrace', 42.7944412231445, 0.746903900895061, -96.1875, -1.67878857426205, 218, 16, 'PPL', 'P'),
(50225, 'Parkview Trail', 39.311939239502, 0.686122775073265, -76.7788925170898, -1.34004447045805, 218, 25, 'PPL', 'P'),
(205306, 'Parkview Trailer Court', 40.514720916748, 0.707115275523869, -111.41194152832, -1.94450520570859, 218, 52, 'PPL', 'P'),
(178816, 'Parkview Village Mobile Home and Recreational Vehicle Park', 33.4511108398438, 0.583832022604839, -111.965827941895, -1.95417234730753, 218, 5, 'PPL', 'P'),
(28193, 'Parkville', 39.8916702270508, 0.69624098958183, -88.3611068725586, -1.54219224563274, 218, 18, 'PPL', 'P'),
(50226, 'Parkville', 39.3772201538086, 0.687262141966628, -76.5400009155273, -1.33587502545543, 218, 25, 'PPL', 'P'),
(56797, 'Parkville', 39.1949996948242, 0.684081794992855, -94.6819381713867, -1.6525115632604, 218, 29, 'PPL', 'P'),
(67610, 'Parkville', 36.291389465332, 0.633404236293628, -76.3994369506836, -1.33342172145925, 218, 33, 'PPL', 'P'),
(71238, 'Parkville', 39.8147201538086, 0.694897957444103, -75.182502746582, -1.31218221281754, 218, 37, 'PPL', 'P'),
(78909, 'Parkville', 39.7811088562012, 0.694311329634986, -76.9636077880859, -1.34326836011565, 218, 45, 'PPL', 'P'),
(113894, 'Parkville', 41.7630615234375, 0.728902929296943, -72.6941680908203, -1.26875258018301, 218, 8, 'PPL', 'P'),
(132532, 'Parkville', 42.0158309936523, 0.733314588800714, -85.5477828979492, -1.49309047935051, 218, 27, 'PPL', 'P'),
(137388, 'Parkville', 47.5311088562012, 0.829574346664546, -92.5788879394531, -1.61580641237833, 218, 28, 'PPL', 'P'),
(151570, 'Parkville', 40.6330604553223, 0.70918069010728, -73.978889465332, -1.29117519813899, 218, 40, 'PPL', 'P'),
(187170, 'Parkville', 38.2272186279297, 0.667190828937082, -106.099998474121, -1.85179430973437, 218, 7, 'PPL', 'P'),
(187171, 'Parkville (historical)', 39.4988899230957, 0.68938568004083, -106.949440002441, -1.86661986120673, 218, 7, 'PPL', 'P'),
(50227, 'Parkville Heights', 39.3805618286133, 0.687320465194501, -76.5516662597656, -1.33607862412076, 218, 25, 'PPL', 'P'),
(208394, 'Parkwater', 47.6763916015625, 0.832110008917438, -117.330833435059, -2.04780935755082, 218, 56, 'PPL', 'P'),
(56798, 'Parkway', 38.3380584716797, 0.669125349152916, -90.9697189331055, -1.58772111499651, 218, 29, 'PPL', 'P'),
(96925, 'Parkway', 31.2027797698975, 0.544591242759389, -94.0688934326172, -1.64181191410684, 218, 51, 'PPL', 'P'),
(184016, 'Parkway', 38.4961090087891, 0.67188385141002, -121.457778930664, -2.11983814449949, 218, 6, 'PPL', 'P'),
(105077, 'Parkway Acres', 37.2024993896484, 0.649306104320546, -79.9652786254883, -1.39565739928942, 218, 53, 'PPL', 'P'),
(4885, 'Parkway Estates', 34.6588897705078, 0.604911741581143, -86.5741729736328, -1.51100436558098, 218, 2, 'PPL', 'P'),
(23769, 'Parkway Estates', 32.9755592346191, 0.575532081330525, -85.0472183227539, -1.48435397939451, 218, 13, 'PPL', 'P'),
(89786, 'Parkway Estates', 35.9047203063965, 0.626655586354286, -85.0350036621094, -1.48414079334924, 218, 50, 'PPL', 'P'),
(105078, 'Parkway Estates', 37.2808303833008, 0.650673238066138, -76.6725006103516, -1.338187581388, 218, 53, 'PPL', 'P'),
(67613, 'Parkway Forest', 35.582218170166, 0.621026862232349, -82.4816665649414, -1.43957665409035, 218, 33, 'PPL', 'P'),
(123396, 'Parkway Hills', 41.0283317565918, 0.716079475753076, -85.2644424438477, -1.48814525552234, 218, 19, 'PPL', 'P'),
(71239, 'Parkway Manor', 39.9569396972656, 0.697380156738111, -74.2152786254883, -1.29530096729974, 218, 37, 'PPL', 'P'),
(105079, 'Parkway Meadows', 37.2272186279297, 0.649737536417139, -79.9036102294922, -1.39458108273486, 218, 53, 'PPL', 'P'),
(157041, 'Parkway Mobile Home Village', 40.8458290100098, 0.712894201931286, -83.295280456543, -1.45377689533876, 218, 41, 'PPL', 'P'),
(145996, 'Parkway Pines', 40.1027793884277, 0.699925539528982, -74.1500015258789, -1.29416166698541, 218, 37, 'PPL', 'P'),
(82865, 'Parkway Place', 33.964168548584, 0.592786568875094, -81.1052780151367, -1.41555414210951, 218, 48, 'PPL', 'P'),
(110828, 'Parkway Terrace', 38.3816719055176, 0.669886547171488, -81.8024978637695, -1.42772292407841, 218, 58, 'PPL', 'P'),
(37594, 'Parkway Village', 38.2125015258789, 0.666933967049944, -85.7402801513672, -1.4964501902237, 218, 21, 'PPL', 'P'),
(89787, 'Parkway Village', 35.0641708374023, 0.611985230594448, -89.9061126708984, -1.56915768377617, 218, 50, 'PPL', 'P'),
(145997, 'Parkway Village', 40.2591705322266, 0.702655079909231, -74.7888870239258, -1.30531232246957, 218, 37, 'PPL', 'P'),
(4886, 'Parkwood', 33.3622207641602, 0.582280598111813, -86.8794403076172, -1.5163322856578, 218, 2, 'PPL', 'P'),
(14369, 'Parkwood', 39.7497215270996, 0.693763517398757, -75.654167175293, -1.32041431006308, 218, 10, 'PPL', 'P'),
(23771, 'Parkwood', 31.2266693115234, 0.545008193917555, -81.5072174072266, -1.42256930789494, 218, 13, 'PPL', 'P'),
(37595, 'Parkwood', 38.1555595397949, 0.665940141910154, -85.8013916015625, -1.49751678624028, 218, 21, 'PPL', 'P'),
(50230, 'Parkwood', 39.019718170166, 0.681022555269654, -77.091667175293, -1.3455034180605, 218, 25, 'PPL', 'P'),
(67614, 'Parkwood', 35.4286117553711, 0.618345924541993, -79.4933319091797, -1.38742037519586, 218, 33, 'PPL', 'P'),
(82868, 'Parkwood', 33.9647216796875, 0.592796222834046, -81.1536102294922, -1.41639769838479, 218, 48, 'PPL', 'P'),
(165717, 'Parkwood', 40.6188888549805, 0.708933349021039, -79.3013916015625, -1.38407038486064, 218, 45, 'PPL', 'P'),
(178817, 'Parkwood', 33.478328704834, 0.584307063964282, -112.153610229492, -1.95744976650303, 218, 5, 'PPL', 'P'),
(184017, 'Parkwood', 36.9269409179688, 0.644496701707972, -120.043609619141, -2.09515623383274, 218, 6, 'PPL', 'P'),
(208396, 'Parkwood', 47.5333290100098, 0.829613095658407, -122.60888671875, -2.13992876544693, 218, 56, 'PPL', 'P'),
(125773, 'Parkwood Beach', 41.7458305358887, 0.728602191830846, -70.6999969482422, -1.23394772789677, 218, 23, 'PPL', 'P'),
(23774, 'Parkwood Commons', 34.064998626709, 0.594546385723419, -84.584716796875, -1.47628180497242, 218, 13, 'PPL', 'P'),
(89789, 'Parkwood Estates', 35.7891693115234, 0.624638841039796, -86.440559387207, -1.50867236857245, 218, 50, 'PPL', 'P'),
(96926, 'Parkwood Estates', 29.9222202301025, 0.522241262522145, -95.3088912963867, -1.66345395954732, 218, 51, 'PPL', 'P'),
(105080, 'Parkwood Estates', 36.6180610656738, 0.639105731292352, -82.1094436645508, -1.43308013892721, 218, 53, 'PPL', 'P'),
(137389, 'Parkwood Estates', 45.1300010681152, 0.787667110067169, -95.084716796875, -1.65954137643183, 218, 28, 'PPL', 'P'),
(205310, 'Parkwood Estates Condominium', 41.2641716003418, 0.720195657533902, -111.976387023926, -1.95435663805496, 218, 52, 'PPL', 'P'),
(4891, 'Parkwood Hills', 33.3472213745117, 0.582018809376659, -86.8969421386719, -1.51663775023483, 218, 2, 'PPL', 'P'),
(67619, 'Parkwood Lake', 36.0349998474121, 0.628929393292996, -80.3777770996094, -1.40285685582228, 218, 33, 'PPL', 'P'),
(42506, 'Parlange', 30.628059387207, 0.534560479803119, -91.4875030517578, -1.59675815268153, 218, 22, 'PPL', 'P'),
(157042, 'Parlatt (historical)', 40.3083305358887, 0.703513083833428, -80.8822174072266, -1.41166100006997, 218, 41, 'PPL', 'P'),
(82872, 'Parler', 33.4933280944824, 0.584568852699437, -80.5105590820313, -1.40517433860287, 218, 48, 'PPL', 'P'),
(157043, 'Parlett', 40.3074989318848, 0.703498569605487, -80.8630599975586, -1.41132664019512, 218, 41, 'PPL', 'P'),
(192742, 'Parley', 39.564998626709, 0.690539494583107, -112.140281677246, -1.95721713938181, 218, 52, 'PPL', 'P'),
(157044, 'Parliament Place', 41.5702781677246, 0.72553822499671, -83.5899963378906, -1.45892065782619, 218, 41, 'PPL', 'P'),
(50231, 'Parliament Ridge', 39.5461082458496, 0.690209795240155, -76.3769378662109, -1.33302903835651, 218, 25, 'PPL', 'P'),
(184018, 'Parlier', 36.6116714477539, 0.638994211421705, -119.526107788086, -2.08612412299574, 218, 6, 'PPL', 'P'),
(145998, 'Parlin', 40.4619407653809, 0.70619408810281, -74.3386077880859, -1.2974534672508, 218, 37, 'PPL', 'P'),
(187172, 'Parlin', 38.5027809143066, 0.672000298128684, -106.727783203125, -1.86275122024923, 218, 7, 'PPL', 'P'),
(11084, 'Parma', 35.7191696166992, 0.623417115889722, -92.1788864135742, -1.60882506873874, 218, 4, 'PPL', 'P'),
(56799, 'Parma', 36.6136093139648, 0.639028033567549, -89.8163909912109, -1.5675917450552, 218, 29, 'PPL', 'P'),
(132533, 'Parma', 42.2583312988281, 0.737547017563123, -84.5997161865234, -1.47654359370758, 218, 27, 'PPL', 'P'),
(157045, 'Parma', 41.4047203063965, 0.722648695213974, -81.7230606079102, -1.42633648241491, 218, 41, 'PPL', 'P'),
(187173, 'Parma', 37.5372200012207, 0.655148081066771, -106.038063049316, -1.85071333264791, 218, 7, 'PPL', 'P'),
(195443, 'Parma', 43.7852783203125, 0.764197270591546, -116.942222595215, -2.04102681888661, 218, 17, 'PPL', 'P'),
(11085, 'Parma (historical)', 33.9652786254883, 0.592805943372025, -91.5458297729492, -1.59777614600822, 218, 4, 'PPL', 'P'),
(151571, 'Parma Center', 43.2586097717285, 0.755005170352055, -77.791389465332, -1.35771587587128, 218, 40, 'PPL', 'P'),
(151572, 'Parma Corners', 43.2183303833008, 0.754302162403302, -77.7922210693359, -1.35773039009922, 218, 40, 'PPL', 'P'),
(157046, 'Parma Heights', 41.3899993896484, 0.722391766747809, -81.7597198486328, -1.4269763068668, 218, 41, 'PPL', 'P'),
(17541, 'Parmalee', 27.3708305358887, 0.477711111856661, -82.2183303833008, -1.43498057068109, 218, 12, 'PPL', 'P'),
(67620, 'Parmele', 35.8163909912109, 0.625113948978266, -77.3144378662109, -1.34939150009396, 218, 33, 'PPL', 'P'),
(132536, 'Parmelee', 42.7544403076172, 0.746205753215297, -85.4741668701172, -1.4918056372826, 218, 27, 'PPL', 'P'),
(202472, 'Parmelee', 43.3230590820313, 0.756130023017477, -101.026107788086, -1.76323821137679, 218, 49, 'PPL', 'P'),
(192016, 'Parmerton', 34.579719543457, 0.603529960449556, -102.801940917969, -1.79423234645924, 218, 51, 'PPL', 'P'),
(110829, 'Parmeta Crest', 39.3263893127441, 0.686374976428495, -81.4233322143555, -1.42110523508567, 218, 58, 'PPL', 'P'),
(37596, 'Parmleysville', 36.6841697692871, 0.640259545834629, -84.7538909912109, -1.47923445167299, 218, 21, 'PPL', 'P'),
(11086, 'Parn (historical)', 36.3397216796875, 0.634247792568911, -94.3450012207031, -1.64663090409934, 218, 4, 'PPL', 'P'),
(82874, 'Parnassus', 34.4925003051758, 0.602007697570466, -79.6425018310547, -1.39002388147752, 218, 48, 'PPL', 'P'),
(105081, 'Parnassus', 38.2947196960449, 0.668368944824306, -79.1183319091797, -1.38087539050088, 218, 53, 'PPL', 'P'),
(165719, 'Parnassus', 40.5569381713867, 0.707852105618467, -79.7622222900391, -1.39211339766879, 218, 45, 'PPL', 'P'),
(4892, 'Parnell', 32.6947212219238, 0.570630533344235, -86.9147186279297, -1.51694800850182, 218, 2, 'PPL', 'P'),
(11087, 'Parnell', 34.9166717529297, 0.609410885926723, -92.0005569458008, -1.60571263237276, 218, 4, 'PPL', 'P'),
(33576, 'Parnell', 39.5063896179199, 0.689516574408407, -95.2063903808594, -1.66166498108505, 218, 20, 'PPL', 'P'),
(37597, 'Parnell', 36.8677787780762, 0.643464127574321, -84.9452819824219, -1.48257485462828, 218, 21, 'PPL', 'P'),
(117243, 'Parnell', 41.5830612182617, 0.725761331317031, -92.0038909912109, -1.60577082244258, 218, 16, 'PPL', 'P'),
(120974, 'Parnell', 40.2230606079102, 0.702024842837264, -88.7205581665039, -1.54846585421264, 218, 18, 'PPL', 'P'),
(132535, 'Parnell', 43.0433311462402, 0.751247849528117, -85.4113922119141, -1.49071001281014, 218, 27, 'PPL', 'P'),
(139380, 'Parnell', 40.439998626709, 0.705811125538057, -94.6230621337891, -1.65148398255379, 218, 29, 'PPL', 'P'),
(192017, 'Parnell', 34.5230598449707, 0.602541062157782, -100.603332519531, -1.7558593909445, 218, 51, 'PPL', 'P'),
(192018, 'Parnell (historical)', 35.8974304199219, 0.626528353833207, -100.819267272949, -1.75962816336113, 218, 51, 'PPL', 'P'),
(50232, 'Parole', 38.9794387817383, 0.6803195473209, -76.5308303833008, -1.33571496947391, 218, 25, 'PPL', 'P'),
(11088, 'Paron', 34.7727813720703, 0.606899525018778, -92.7583312988281, -1.61893828982026, 218, 4, 'PPL', 'P'),
(11089, 'Paroquet', 35.6744384765625, 0.622636410216166, -91.3636093139648, -1.59459579903444, 218, 4, 'PPL', 'P'),
(192743, 'Parowan', 37.8422203063965, 0.660471340611676, -112.827217102051, -1.96920642429324, 218, 52, 'PPL', 'P'),
(178818, 'Parque Vista Estates', 33.6555595397949, 0.587400325570409, -112.011672973633, -1.95497249405704, 218, 5, 'PPL', 'P'),
(82875, 'Parr', 34.2658309936523, 0.598051571771154, -81.3327789306641, -1.41952478213676, 218, 48, 'PPL', 'P'),
(105082, 'Parr', 37.6597213745117, 0.657286133368914, -79.9097213745117, -1.39468774233652, 218, 53, 'PPL', 'P'),
(123397, 'Parr', 41.0272216796875, 0.716060101256145, -87.2186126708984, -1.52225196012882, 218, 19, 'PPL', 'P'),
(151574, 'Parr Harbor', 42.9036102294922, 0.748809259496959, -76.8775024414063, -1.34176553831252, 218, 40, 'PPL', 'P'),
(89790, 'Parragon', 36.1941719055176, 0.631707469784112, -85.4113922119141, -1.49071001281014, 218, 50, 'PPL', 'P'),
(157049, 'Parral', 40.5611114501953, 0.70792494307428, -81.4972229003906, -1.42239487084354, 218, 41, 'PPL', 'P'),
(17542, 'Parramore', 30.871940612793, 0.538817010173393, -84.9930572509766, -1.48340869036558, 218, 12, 'PPL', 'P'),
(184021, 'Parramore Springs', 39.3136100769043, 0.686151936687201, -122.878890991211, -2.14464122899583, 218, 6, 'PPL', 'P'),
(50233, 'Parran', 38.6027793884277, 0.673745600749067, -76.570556640625, -1.33640832346371, 218, 25, 'PPL', 'P'),
(190594, 'Parran', 39.8013916015625, 0.694665330322885, -118.772216796875, -2.07296624299798, 218, 39, 'PPL', 'P'),
(50234, 'Parran Hunt Estates', 38.5888900756836, 0.673503186510843, -76.5605621337891, -1.33623388641231, 218, 25, 'PPL', 'P'),
(50235, 'Parrans Woods', 38.6086082458496, 0.673847333502708, -76.5699996948242, -1.33639860292574, 218, 25, 'PPL', 'P'),
(187175, 'Parras Plaza', 37.1772193908691, 0.648864885106947, -104.955833435059, -1.83182486261652, 218, 7, 'PPL', 'P'),
(23775, 'Parrett Crossing', 34.975830078125, 0.610443393481347, -84.9580612182617, -1.48279789436957, 218, 13, 'PPL', 'P'),
(96929, 'Parris (historical)', 33.2527618408203, 0.580370179503845, -96.6058578491211, -1.68609029618077, 218, 51, 'PPL', 'P'),
(394, 'Parrish', 27.5872192382813, 0.48148780717753, -82.4252777099609, -1.43859248290951, 218, 12, 'PPL', 'P'),
(4893, 'Parrish', 33.7305603027344, 0.58870933582521, -87.2844390869141, -1.52340084782308, 218, 2, 'PPL', 'P'),
(28194, 'Parrish', 37.9413909912109, 0.662202195583146, -88.8127822875977, -1.55007546877548, 218, 18, 'PPL', 'P'),
(113329, 'Parrish', 41.4913902282715, 0.724161370713139, -78.996940612793, -1.37875671269566, 218, 45, 'PPL', 'P'),
(175765, 'Parrish', 45.4197196960449, 0.792723654028902, -89.4024963378906, -1.56036792059836, 218, 57, 'PPL', 'P'),
(187174, 'Parrish', 38.1216697692871, 0.665348653832047, -102.384170532227, -1.78694087771071, 218, 7, 'PPL', 'P'),
(105083, 'Parrish Court', 37.7588882446289, 0.659016921761357, -79.9877777099609, -1.39605008239215, 218, 53, 'PPL', 'P'),
(67624, 'Parrish Gap', 35.2252807617188, 0.614797129231408, -83.4533309936523, -1.45653539759586, 218, 33, 'PPL', 'P'),
(128479, 'Parrot', 45.2550010681152, 0.789848771632161, -69.554443359375, -1.213954046013, 218, 26, 'PPL', 'P'),
(82876, 'Parrot Point', 32.7286109924316, 0.571222021422341, -79.9113922119141, -1.39471690395045, 218, 48, 'PPL', 'P'),
(67622, 'Parrots', 35.3111114501953, 0.616295157344578, -77.6911087036133, -1.35596564640288, 218, 33, 'PPL', 'P'),
(23776, 'Parrott', 31.8933296203613, 0.556643611299138, -84.5133285522461, -1.47503584505643, 218, 13, 'PPL', 'P'),
(73840, 'Parrott', 39.6141700744629, 0.691397698244385, -83.5316696166992, -1.45790266449951, 218, 41, 'PPL', 'P'),
(105085, 'Parrott', 37.2050018310547, 0.649349780162423, -80.6158294677734, -1.40701165343891, 218, 53, 'PPL', 'P'),
(193260, 'Parrott Crossing', 46.0791702270508, 0.804233237048979, -121.264717102051, -2.11646857993026, 218, 56, 'PPL', 'P'),
(67623, 'Parrott Fork', 35.2213897705078, 0.614729218623611, -77.616943359375, -1.35467121695504, 218, 33, 'PPL', 'P'),
(89791, 'Parrottsville', 36.0091705322266, 0.628478586699472, -83.0924987792969, -1.4502376874081, 218, 50, 'PPL', 'P'),
(165720, 'Parrs Mill', 40.9069404602051, 0.713960797947863, -76.4725036621094, -1.33469697614723, 218, 45, 'PPL', 'P'),
(50236, 'Parrs Ridge', 39.1205596923828, 0.68278257185506, -76.9833297729492, -1.34361257368654, 218, 25, 'PPL', 'P'),
(50238, 'Parrsville', 39.3627815246582, 0.687010140348479, -77.154167175293, -1.346594248843, 218, 25, 'PPL', 'P'),
(71240, 'Parry', 39.9874992370605, 0.697913521325427, -75.0102767944336, -1.30917630289516, 218, 37, 'PPL', 'P'),
(89792, 'Parry', 35.8769416809082, 0.626170757877837, -86.8813934326172, -1.51636637411975, 218, 50, 'PPL', 'P'),
(165721, 'Parryville', 40.8180618286133, 0.712409573191919, -75.6730575561523, -1.32074400940603, 218, 45, 'PPL', 'P'),
(194365, 'Parshall', 40.0569381713867, 0.699125459358495, -106.17472076416, -1.85309845972018, 218, 7, 'PPL', 'P'),
(198729, 'Parshall', 47.9533309936523, 0.836943513137877, -102.134437561035, -1.78258221511263, 218, 34, 'PPL', 'P'),
(132537, 'Parshallburg', 43.1463890075684, 0.753046548528357, -84.1361083984375, -1.46845211136759, 218, 27, 'PPL', 'P'),
(132538, 'Parshallville', 42.6919403076172, 0.745114922432801, -83.7822189331055, -1.46227557500942, 218, 27, 'PPL', 'P'),
(56800, 'Parshley', 37.0741691589355, 0.647066319264762, -94.2394409179688, -1.64478852925722, 218, 29, 'PPL', 'P'),
(145999, 'Parsippany', 40.857780456543, 0.713102794023667, -74.4263916015625, -1.29898558382592, 218, 37, 'PPL', 'P'),
(110830, 'Parsley', 37.8497200012207, 0.660602234979253, -82.2002792358398, -1.43466551872413, 218, 58, 'PPL', 'P'),
(110831, 'Parsley Bottom', 37.7911109924316, 0.659579314804554, -82.2669372558594, -1.43582892064633, 218, 58, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(96927, 'Parsley Crossing', 31.5674991607666, 0.550956796975924, -98.1119384765625, -1.71237636193013, 218, 51, 'PPL', 'P'),
(96928, 'Parsley Hill', 34.0401000976563, 0.594111824412545, -99.4164199829102, -1.73514385924727, 218, 51, 'PPL', 'P'),
(151576, 'Parson Farms', 43.0366706848145, 0.751131602546535, -76.2805633544922, -1.33134698581202, 218, 40, 'PPL', 'P'),
(50239, 'Parson Hill', 39.3072204589844, 0.686040416816554, -76.0986099243164, -1.32817129937015, 218, 25, 'PPL', 'P'),
(128480, 'Parson Landing', 45.2613906860352, 0.789960291502809, -69.1883316040039, -1.20756419045152, 218, 26, 'PPL', 'P'),
(151577, 'Parson Mill', 43.4494400024414, 0.758335786190336, -75.5669403076172, -1.31889191402594, 218, 40, 'PPL', 'P'),
(105086, 'Parsonage', 36.8358306884766, 0.642906528221086, -82.2474975585938, -1.43548963392346, 218, 53, 'PPL', 'P'),
(128481, 'Parsonage Corner', 43.3080596923828, 0.755868234282323, -70.6866683959961, -1.23371510077555, 218, 26, 'PPL', 'P'),
(82878, 'Parsonage Point', 32.8338890075684, 0.573059469416441, -80.0416717529297, -1.39699071088916, 218, 48, 'PPL', 'P'),
(4894, 'Parsons', 33.6277809143066, 0.58691549709396, -86.5002822875977, -1.50971472982311, 218, 2, 'PPL', 'P'),
(33577, 'Parsons', 37.3402786254883, 0.651710805626833, -95.2608337402344, -1.66261519696199, 218, 20, 'PPL', 'P'),
(61233, 'Parsons', 33.7333297729492, 0.588757672198995, -90.0316696166992, -1.57134906587914, 218, 30, 'PPL', 'P'),
(89793, 'Parsons', 35.6497192382813, 0.622204978119573, -88.1266708374023, -1.53810056493394, 218, 50, 'PPL', 'P'),
(110832, 'Parsons', 39.0963897705078, 0.682360727138392, -79.6811065673828, -1.39069766123331, 218, 58, 'PPL', 'P'),
(139381, 'Parsons', 40.0786094665527, 0.699503694812313, -93.2716674804688, -1.6278976963595, 218, 29, 'PPL', 'P'),
(165723, 'Parsons', 41.2599983215332, 0.720122820078088, -75.8422164916992, -1.32369638979049, 218, 45, 'PPL', 'P'),
(151578, 'Parsons Beach', 40.7719383239746, 0.711604566173415, -73.7516708374023, -1.28720948495975, 218, 40, 'PPL', 'P'),
(178820, 'Parsons Grove', 32.8244400024414, 0.572894553165938, -110.475563049316, -1.92816231820516, 218, 5, 'PPL', 'P'),
(50241, 'Parsons Ridge', 39.5149993896484, 0.689666843272915, -76.3141708374023, -1.33193354704211, 218, 25, 'PPL', 'P'),
(50242, 'Parsonsburg', 38.3875007629395, 0.669988279925129, -75.4713897705078, -1.31722424255133, 218, 25, 'PPL', 'P'),
(128482, 'Parsonsfield', 43.7269401550293, 0.763179077527781, -70.9291687011719, -1.23794752953796, 218, 26, 'PPL', 'P'),
(165726, 'Parsonsville', 40.8466682434082, 0.712908849317282, -78.3324966430664, -1.36715997772891, 218, 45, 'PPL', 'P'),
(50243, 'Parsonville', 37.9922218322754, 0.663089361121278, -75.7847213745117, -1.32269291069175, 218, 25, 'PPL', 'P'),
(67625, 'Parsonville', 36.2161102294922, 0.632090365769838, -81.3625030517578, -1.42004356591711, 218, 33, 'PPL', 'P'),
(146001, 'Parsonville', 40.1697196960449, 0.7010938682992, -74.6972198486328, -1.3037124284447, 218, 37, 'PPL', 'P'),
(165725, 'Parsonville', 41.059440612793, 0.716622427720315, -79.8097229003906, -1.39294243971613, 218, 45, 'PPL', 'P'),
(11090, 'Partain', 35.6277809143066, 0.621822082133847, -92.2397232055664, -1.60988687106535, 218, 4, 'PPL', 'P'),
(11091, 'Partee', 33.2422218322754, 0.580186221651548, -93.2444381713867, -1.62742245526298, 218, 4, 'PPL', 'P'),
(61234, 'Partee', 33.9524993896484, 0.59258290363073, -89.4819412231445, -1.56175449541991, 218, 30, 'PPL', 'P'),
(132539, 'Partello', 42.4044418334961, 0.740097127464928, -84.8477783203125, -1.48087309469172, 218, 27, 'PPL', 'P'),
(151579, 'Partello Corners', 42.7975006103516, 0.746957297274918, -76.3663864135742, -1.33284488076713, 218, 40, 'PPL', 'P'),
(82879, 'Partersville', 33.5116691589355, 0.584888964662464, -80.5066680908203, -1.40510642799507, 218, 48, 'PPL', 'P'),
(11092, 'Parthenon', 35.9530601501465, 0.627499275787623, -93.241943359375, -1.62737891257916, 218, 4, 'PPL', 'P'),
(125774, 'Partidgeville', 42.547779083252, 0.742598834413921, -72.0472183227539, -1.25746117663524, 218, 23, 'PPL', 'P'),
(105087, 'Partlow', 38.0386085510254, 0.663898962092663, -77.6391677856445, -1.35505910636781, 218, 53, 'PPL', 'P'),
(151580, 'Partlow', 43.9741706848145, 0.767494064283982, -74.8277816772461, -1.30599116223143, 218, 40, 'PPL', 'P'),
(192744, 'Partoun', 39.6433296203613, 0.691906628328699, -113.886940002441, -1.98770207806384, 218, 52, 'PPL', 'P'),
(33579, 'Partridge', 37.9672203063965, 0.662653002176669, -98.0922164916992, -1.71203214835923, 218, 20, 'PPL', 'P'),
(37598, 'Partridge', 37.0063896179199, 0.645883343108549, -82.898063659668, -1.44684415438907, 218, 21, 'PPL', 'P'),
(178821, 'Partridge (historical)', 31.4797191619873, 0.549424746979829, -111.274719238281, -1.94211022494028, 218, 5, 'PPL', 'P'),
(4895, 'Partridge Crossroads', 33.7616691589355, 0.58925228779245, -86.9355621337891, -1.51731179630673, 218, 2, 'PPL', 'P'),
(105088, 'Partridge Hills', 37.5750007629395, 0.655807479752675, -77.6669387817383, -1.35554380168621, 218, 53, 'PPL', 'P'),
(82880, 'Partridge Woods', 32.461109161377, 0.566553233715323, -80.658332824707, -1.40775347696056, 218, 48, 'PPL', 'P'),
(125776, 'Partridgeville', 42.5733299255371, 0.743044780738455, -72.2586135864258, -1.26115072000944, 218, 23, 'PPL', 'P'),
(192019, 'Partwood Crossing', 35.5194396972656, 0.619931171180863, -102.678062438965, -1.79207025912826, 218, 51, 'PPL', 'P'),
(50244, 'Parvilla', 38.9249992370605, 0.679369398022987, -76.5719375610352, -1.33643242507158, 218, 25, 'PPL', 'P'),
(50, 'Parvin', 33.2533302307129, 0.580380099778906, -96.870002746582, -1.69070049434381, 218, 51, 'PPL', 'P'),
(76894, 'Parvin', 36.0719413757324, 0.629574144592904, -98.1738891601563, -1.7134576053327, 218, 42, 'PPL', 'P'),
(165728, 'Parvin', 41.0591697692871, 0.716617700609381, -77.5158309936523, -1.3529064732587, 218, 45, 'PPL', 'P'),
(208398, 'Parvin', 46.848331451416, 0.817657632892823, -117.282218933105, -2.04696087442752, 218, 56, 'PPL', 'P'),
(17543, 'Pasadena', 27.7702808380127, 0.484682834826812, -82.732780456543, -1.44395941829629, 218, 12, 'PPL', 'P'),
(50245, 'Pasadena', 39.1072196960449, 0.68254974499676, -76.5713882446289, -1.33642283769166, 218, 25, 'PPL', 'P'),
(73841, 'Pasadena', 39.6991691589355, 0.692881212129613, -84.1486129760742, -1.46867035741892, 218, 41, 'PPL', 'P'),
(96930, 'Pasadena', 29.6908302307129, 0.518202745176608, -95.2088928222656, -1.66170865692693, 218, 51, 'PPL', 'P'),
(184022, 'Pasadena', 34.1477813720703, 0.595991217193814, -118.143608093262, -2.06199495141324, 218, 6, 'PPL', 'P'),
(50246, 'Pasadena Beach', 39.1458282470703, 0.683223591331577, -76.4580612182617, -1.33444490795005, 218, 25, 'PPL', 'P'),
(56807, 'Pasadena Hills', 38.7083282470703, 0.675587775854102, -90.2927780151367, -1.57590626713649, 218, 29, 'PPL', 'P'),
(50247, 'Pasadena Manor', 39.1094398498535, 0.682588493990621, -76.5638885498047, -1.33629194332408, 218, 25, 'PPL', 'P'),
(56802, 'Pasadena Park', 38.7105598449707, 0.675626724585044, -90.2980575561523, -1.5759984125102, 218, 29, 'PPL', 'P'),
(208399, 'Pasadena Park', 47.6969413757324, 0.832468670137245, -117.281669616699, -2.0469512870476, 218, 56, 'PPL', 'P'),
(17544, 'Pasadena Shores', 28.3147201538086, 0.494185093464755, -82.2058334350586, -1.43476245778781, 218, 12, 'PPL', 'P'),
(184023, 'Pasatiempo', 37.0044403076172, 0.645849321225623, -122.024719238281, -2.12973311952967, 218, 6, 'PPL', 'P'),
(61235, 'Pascagoula', 30.3655605316162, 0.529979010490343, -88.5561065673828, -1.5455956323478, 218, 30, 'PPL', 'P'),
(61238, 'Pascagoula River Estates', 30.8425006866455, 0.538303186530576, -88.7561111450195, -1.54908637074663, 218, 30, 'PPL', 'P'),
(37599, 'Pascal', 37.2169418334961, 0.649558172517722, -85.7302780151367, -1.49627562001424, 218, 21, 'PPL', 'P'),
(23777, 'Paschal (historical)', 32.6088905334473, 0.569132505231065, -84.4705581665039, -1.47428936100288, 218, 13, 'PPL', 'P'),
(89794, 'Paschal Estates', 35.8455581665039, 0.625623012220635, -86.4677810668945, -1.50914747651092, 218, 50, 'PPL', 'P'),
(67626, 'Paschall', 36.5416717529297, 0.637772486271631, -78.1580581665039, -1.36411545197074, 218, 33, 'PPL', 'P'),
(96931, 'Pasche', 31.2163906097412, 0.544828796728624, -99.686393737793, -1.73985579016394, 218, 51, 'PPL', 'P'),
(17545, 'Pasco', 28.3244400024414, 0.494354736826193, -82.3372192382813, -1.43705557264443, 218, 12, 'PPL', 'P'),
(23778, 'Pasco', 30.9113903045654, 0.53950553718372, -83.9958267211914, -1.46600373421942, 218, 13, 'PPL', 'P'),
(157050, 'Pasco', 40.2833290100098, 0.703076724888818, -84.100830078125, -1.46783638852356, 218, 41, 'PPL', 'P'),
(208400, 'Pasco', 46.2397193908691, 0.807035348568933, -119.09944152832, -2.07867739195566, 218, 56, 'PPL', 'P'),
(208401, 'Pasco West', 46.2350006103516, 0.806952990312223, -119.140281677246, -2.07939018702142, 218, 56, 'PPL', 'P'),
(169536, 'Pascoag', 41.9555587768555, 0.732262640170133, -71.7027816772461, -1.25144962310661, 218, 47, 'PPL', 'P'),
(56803, 'Pascola', 36.2666702270508, 0.632972804197036, -89.8266677856445, -1.56777110895462, 218, 29, 'PPL', 'P'),
(178822, 'Pascua Yaqui Indian Village', 32.2483291625977, 0.562839522154235, -110.983612060547, -1.93702944621263, 218, 5, 'PPL', 'P'),
(96932, 'Paseo de Palmas Colonia', 26.2479991912842, 0.458114007948718, -98.3919982910156, -1.71726432779486, 218, 51, 'PPL', 'P'),
(112313, 'Pasfield', 39.7775001525879, 0.694248345875206, -89.82861328125, -1.56780506425852, 218, 18, 'PPL', 'P'),
(56805, 'Pashaw (historical)', 37.8397216796875, 0.660427731348826, -94.0924987792969, -1.64222390512748, 218, 29, 'PPL', 'P'),
(184024, 'Paskenta', 39.8847198486328, 0.696119682594177, -122.544723510742, -2.13880890620856, 218, 6, 'PPL', 'P'),
(56806, 'Pasley', 36.628059387207, 0.639280234922779, -93.8883285522461, -1.6386604624309, 218, 29, 'PPL', 'P'),
(67627, 'Pasley', 34.7852783203125, 0.607117637912056, -77.9008331298828, -1.35962602816313, 218, 33, 'PPL', 'P'),
(192023, 'Paso del Rey Colonia', 31.8649997711182, 0.556149162153252, -106.146003723145, -1.85259725280303, 218, 51, 'PPL', 'P'),
(192024, 'Paso del Rey Number 2 Colonia', 31.8659992218018, 0.556166605858392, -106.138999938965, -1.852475013709, 218, 51, 'PPL', 'P'),
(192025, 'Paso el Rey Number 3 Colonia', 31.8689994812012, 0.556218970263325, -106.147003173828, -1.85261469650817, 218, 51, 'PPL', 'P'),
(184025, 'Paso Robles', 35.6266708374023, 0.621802707636916, -120.690002441406, -2.10643791684253, 218, 6, 'PPL', 'P'),
(192020, 'Paso View Colonia', 31.8570003509521, 0.556009545933104, -106.137001037598, -1.85244012629872, 218, 51, 'PPL', 'P'),
(192021, 'Paso View Number 2 Colonia', 31.863000869751, 0.556114274742971, -106.138999938965, -1.852475013709, 218, 51, 'PPL', 'P'),
(192022, 'Paso View West Colonia', 31.8659992218018, 0.556166605858392, -106.153999328613, -1.85273680244415, 218, 51, 'PPL', 'P'),
(4896, 'Pasqua', 33.1408309936523, 0.578416617686217, -86.7527770996094, -1.51412159563692, 218, 2, 'PPL', 'P'),
(89795, 'Pasquo', 36.0344390869141, 0.62891960617599, -86.9738922119141, -1.51798078237255, 218, 50, 'PPL', 'P'),
(67628, 'Pasquotank', 36.267219543457, 0.63298239157696, -76.3388900756836, -1.3323649791387, 218, 33, 'PPL', 'P'),
(61236, 'Pass Christian', 30.315559387207, 0.529106325890637, -89.2474975585938, -1.55766268156306, 218, 30, 'PPL', 'P'),
(17547, 'Pass Station', 29.9808292388916, 0.523264182696844, -81.7733306884766, -1.42721386083604, 218, 12, 'PPL', 'P'),
(177368, 'Passaconaway', 43.9949989318848, 0.767857585772778, -71.3405609130859, -1.24512767815292, 218, 36, 'PPL', 'P'),
(128484, 'Passadumkeag', 45.1852798461914, 0.788631906751077, -68.6172180175781, -1.19759637796551, 218, 26, 'PPL', 'P'),
(56810, 'Passaic', 38.3219413757324, 0.668844052762776, -94.3480606079102, -1.6466843004792, 218, 29, 'PPL', 'P'),
(146002, 'Passaic', 40.8566703796387, 0.713083419526736, -74.1288909912109, -1.29379321864859, 218, 37, 'PPL', 'P'),
(146004, 'Passaic Junction', 40.9022216796875, 0.713878439691152, -74.1044387817383, -1.29336644708391, 218, 37, 'PPL', 'P'),
(50248, 'Passapae Landing', 38.9241714477539, 0.679354950374074, -75.8258285522461, -1.32341036628942, 218, 25, 'PPL', 'P'),
(105089, 'Passapatanzy', 38.2972183227539, 0.668412554087156, -77.3144378662109, -1.34939150009396, 218, 53, 'PPL', 'P'),
(165727, 'Passer', 40.517219543457, 0.707158884786719, -75.3322219848633, -1.31479530647912, 218, 45, 'PPL', 'P'),
(56808, 'Passover', 38.0808296203613, 0.664635858766288, -92.5988922119141, -1.61615555279724, 218, 29, 'PPL', 'P'),
(28197, 'Passport', 38.7891693115234, 0.676998718599626, -88.2436065673828, -1.54014147843532, 218, 18, 'PPL', 'P'),
(172383, 'Passumpsic', 44.3766708374023, 0.77451901718642, -72.0280609130859, -1.25712681676038, 218, 55, 'PPL', 'P'),
(151581, 'Pastime Park', 42.8394393920898, 0.747689267100526, -76.9422225952148, -1.34289511808888, 218, 40, 'PPL', 'P'),
(212080, 'Pastolik', 62.9972190856934, 1.09950889264556, -163.304168701172, -2.85019542606772, 218, 1, 'PPL', 'P'),
(11093, 'Pastoria', 34.3580589294434, 0.599661252913025, -92.0400009155273, -1.60640105951455, 218, 4, 'PPL', 'P'),
(112628, 'Pastoria', 37.7497215270996, 0.65885693235887, -75.6305618286133, -1.32000231904245, 218, 53, 'PPL', 'P'),
(189200, 'Pastura', 34.7827796936035, 0.607074028649206, -104.94416809082, -1.83162126395119, 218, 38, 'PPL', 'P'),
(192026, 'Pastura', 32.9602813720703, 0.575265432326381, -100.019172668457, -1.7456638781853, 218, 51, 'PPL', 'P'),
(61239, 'Pat', 32.1783294677734, 0.561617797004161, -90.0100021362305, -1.57097089700435, 218, 30, 'PPL', 'P'),
(105091, 'Pat Town', 37.2983283996582, 0.650978636064143, -75.9502792358398, -1.32558244047449, 218, 53, 'PPL', 'P'),
(165729, 'Patagonia', 41.2477798461914, 0.7199095674538, -80.5122222900391, -1.40520336705875, 218, 45, 'PPL', 'P'),
(178823, 'Patagonia', 31.5394401550293, 0.550467074940972, -110.755561828613, -1.93304921880545, 218, 5, 'PPL', 'P'),
(208402, 'Pataha', 46.5602798461914, 0.812630183965999, -118.181106567383, -2.06264942325112, 218, 56, 'PPL', 'P'),
(50251, 'Patapsco', 39.5386085510254, 0.690078900872578, -76.892219543457, -1.34202240019966, 218, 25, 'PPL', 'P'),
(50252, 'Patapsco Estates', 39.3661117553711, 0.68706826383927, -76.9905624389648, -1.34373880752221, 218, 25, 'PPL', 'P'),
(50253, 'Patapsco Overlook', 39.3505592346191, 0.686796821145164, -77.0761108398438, -1.34523190878737, 218, 25, 'PPL', 'P'),
(50254, 'Patapsco Park', 39.2152786254883, 0.684435729101727, -76.6399993896484, -1.33762032807581, 218, 25, 'PPL', 'P'),
(50255, 'Patapsco Park Estates', 39.2999992370605, 0.685914382717966, -76.8294372558594, -1.34092664256914, 218, 25, 'PPL', 'P'),
(50257, 'Patapsco Woods', 39.5263900756836, 0.689865648248289, -76.8905563354492, -1.34199337174377, 218, 25, 'PPL', 'P'),
(73842, 'Pataskala', 39.9955596923828, 0.698054202810011, -82.6744384765625, -1.4429411586535, 218, 41, 'PPL', 'P'),
(151582, 'Pataukunk', 41.7916717529297, 0.729402272001333, -74.3063888549805, -1.29689114078663, 218, 40, 'PPL', 'P'),
(184032, 'Patch', 35.2527809143066, 0.615277097438868, -118.894996643066, -2.07510915556911, 218, 6, 'PPL', 'P'),
(175767, 'Patch Grove', 42.9402809143066, 0.749449283685932, -90.9719390869141, -1.58775986399037, 218, 57, 'PPL', 'P'),
(151583, 'Patchin', 42.6577796936035, 0.744518707243759, -78.7477798461914, -1.37440803695167, 218, 40, 'PPL', 'P'),
(151584, 'Patchinville', 42.5308303833008, 0.742303023795841, -77.5891723632813, -1.35418652163665, 218, 40, 'PPL', 'P'),
(165730, 'Patchinville', 40.7805595397949, 0.711755034775005, -78.7769393920898, -1.37491696703599, 218, 45, 'PPL', 'P'),
(151585, 'Patchogue', 40.7655601501465, 0.71149324603985, -73.0155563354492, -1.27436186322899, 218, 40, 'PPL', 'P'),
(151586, 'Patchogue Highlands', 40.7825012207031, 0.711788923499876, -73.0274963378906, -1.27457025558429, 218, 40, 'PPL', 'P'),
(50258, 'Patchwork Farms', 39.5705604553223, 0.69063656680484, -76.5930633544922, -1.3368011397245, 218, 25, 'PPL', 'P'),
(4897, 'Pate', 32.4824981689453, 0.566926542321125, -86.5058288574219, -1.50981153572874, 218, 2, 'PPL', 'P'),
(89796, 'Pate Hill', 36.0972213745117, 0.630015363806503, -83.0405578613281, -1.44933114737304, 218, 50, 'PPL', 'P'),
(42509, 'Pate Place', 30.3791694641113, 0.530216531170064, -90.9922180175781, -1.58811379809925, 218, 22, 'PPL', 'P'),
(151590, 'Patent', 42.6772193908691, 0.744857993966635, -75.1002807617188, -1.31074716846415, 218, 40, 'PPL', 'P'),
(209924, 'Pateros', 48.0511093139648, 0.8386500667644, -119.902221679688, -2.09268854876667, 218, 56, 'PPL', 'P'),
(146006, 'Paterson', 40.9166717529297, 0.714130641046383, -74.1722183227539, -1.29454942324012, 218, 37, 'PPL', 'P'),
(208403, 'Paterson', 45.9372215270996, 0.801755764865906, -119.601669311523, -2.08744292036754, 218, 56, 'PPL', 'P'),
(56809, 'Paterson Ford', 36.7333297729492, 0.641117549758825, -90.7333297729492, -1.58359534583576, 218, 29, 'PPL', 'P'),
(105092, 'Patersons Corner', 37.9358291625977, 0.662105123361412, -77.4636077880859, -1.35199500637562, 218, 53, 'PPL', 'P'),
(17548, 'Patersonville', 29.6886100769043, 0.518163996182747, -81.584716796875, -1.42392192741259, 218, 12, 'PPL', 'P'),
(67630, 'Pates', 34.6897201538086, 0.605449833279394, -79.2152786254883, -1.38256742989946, 218, 33, 'PPL', 'P'),
(11095, 'Pates (historical)', 34.2625007629395, 0.597993448280363, -93.9980621337891, -1.64057567472883, 218, 4, 'PPL', 'P'),
(105093, 'Pates Field (historical)', 37.0097198486328, 0.64594146659934, -76.6069412231445, -1.33704335422564, 218, 53, 'PPL', 'P'),
(37600, 'Patesville', 37.7819404602051, 0.65941925882304, -86.7188873291016, -1.51353010755881, 218, 21, 'PPL', 'P'),
(67631, 'Patetown', 35.4605598449707, 0.618903523895229, -77.9252777099609, -1.36005266656977, 218, 33, 'PPL', 'P'),
(23780, 'Pateville', 31.8358306884766, 0.555640065621369, -83.8238906860352, -1.46300288430312, 218, 13, 'PPL', 'P'),
(37601, 'Pathfork', 36.7558288574219, 0.641510232861557, -83.4647216796875, -1.45673420257124, 218, 21, 'PPL', 'P'),
(4898, 'Pathkiller Cove', 34.1875, 0.596684438025561, -85.6222229003906, -1.49438970248831, 218, 2, 'PPL', 'P'),
(78912, 'Patience', 39.8733291625977, 0.695920877618803, -78.6108322143555, -1.37201784987333, 218, 45, 'PPL', 'P'),
(96933, 'Patillo', 32.502498626709, 0.567275616161007, -98.168327331543, -1.71336053311096, 218, 51, 'PPL', 'P'),
(112269, 'Patillo', 33.2016716003418, 0.579478486591859, -84.0924987792969, -1.46769097992804, 218, 13, 'PPL', 'P'),
(23781, 'Patillo Point', 33.5919418334961, 0.586289987132928, -84.2074966430664, -1.46969807128358, 218, 13, 'PPL', 'P'),
(42511, 'Patin', 30.6897201538086, 0.535636663199621, -91.4061126708984, -1.59533762255609, 218, 22, 'PPL', 'P'),
(205314, 'Patio Springs', 41.3269386291504, 0.721291148848306, -111.833061218262, -1.95185513084305, 218, 52, 'PPL', 'P'),
(208404, 'Patit', 46.3358306884766, 0.808712807160547, -117.858329772949, -2.05701590543922, 218, 56, 'PPL', 'P'),
(96934, 'Patman', 32.9550018310547, 0.575173286952664, -94.5722198486328, -1.65059661727858, 218, 51, 'PPL', 'P'),
(11096, 'Patmos', 33.5116691589355, 0.584888964662464, -93.5661087036133, -1.63303666515698, 218, 4, 'PPL', 'P'),
(23782, 'Patmos', 31.3758296966553, 0.547611533751648, -84.5650024414063, -1.47593772455958, 218, 13, 'PPL', 'P'),
(61242, 'Patmos', 32.813060760498, 0.572695947927645, -90.7283325195313, -1.58350812731006, 218, 30, 'PPL', 'P'),
(157051, 'Patmos', 40.9736099243164, 0.715124399607146, -80.9061126708984, -1.41207805109668, 218, 41, 'PPL', 'P'),
(105094, 'Patna', 38.2336082458496, 0.667302348807729, -79.524169921875, -1.38795860005216, 218, 53, 'PPL', 'P'),
(11097, 'Patoka', 35.0733299255371, 0.61214508683888, -90.3111114501953, -1.57622624594146, 218, 4, 'PPL', 'P'),
(28195, 'Patoka', 38.7552795410156, 0.676407230521519, -89.0952835083008, -1.55500604521765, 218, 18, 'PPL', 'P'),
(30780, 'Patoka', 38.4069404602051, 0.670327566648005, -87.585563659668, -1.5286564630763, 218, 19, 'PPL', 'P'),
(33583, 'Paton', 37.2161102294922, 0.649543658289781, -97.1769409179688, -1.69605757603456, 218, 20, 'PPL', 'P'),
(117244, 'Paton', 42.1644401550293, 0.73590830796537, -94.254997253418, -1.64506003853036, 218, 16, 'PPL', 'P'),
(96935, 'Patonia', 30.8539695739746, 0.538503356376009, -95.0251922607422, -1.65850247729059, 218, 51, 'PPL', 'P'),
(132540, 'Patons Corner', 45.4716682434082, 0.793630327222019, -84.9944381713867, -1.48343279197345, 218, 27, 'PPL', 'P'),
(61240, 'Patosi', 32.916389465332, 0.57449937403882, -90.6194381713867, -1.58160756239813, 218, 30, 'PPL', 'P'),
(42512, 'Patoutville', 29.9033298492432, 0.521911563179193, -91.7336120605469, -1.60105356520372, 218, 22, 'PPL', 'P'),
(151587, 'Patria', 42.6172218322754, 0.743810839026016, -74.4286117553711, -1.29902433281978, 218, 40, 'PPL', 'P'),
(193078, 'Patricia', 32.5544395446777, 0.56818215619607, -102.019996643066, -1.78058484429507, 218, 51, 'PPL', 'P'),
(202473, 'Patricia', 43.2872200012207, 0.755504513056445, -101.511672973633, -1.77171292259764, 218, 49, 'PPL', 'P'),
(37602, 'Patrick', 37.9238891601563, 0.661896731006114, -82.6436080932617, -1.44240306695525, 218, 21, 'PPL', 'P'),
(61241, 'Patrick', 33.4877815246582, 0.584472046793812, -88.7716674804688, -1.54935788001976, 218, 30, 'PPL', 'P'),
(82881, 'Patrick', 34.5744400024414, 0.603437815075839, -80.0461120605469, -1.39706820887689, 218, 48, 'PPL', 'P'),
(96937, 'Patrick', 31.6841697692871, 0.552993083234912, -97.2477798461914, -1.69729394857062, 218, 51, 'PPL', 'P'),
(112227, 'Patrick', 35.8430595397949, 0.625579402957785, -93.8836135864258, -1.63857817075321, 218, 4, 'PPL', 'P'),
(190595, 'Patrick', 39.5472183227539, 0.690229169737085, -119.578330993652, -2.08703558987882, 218, 39, 'PPL', 'P'),
(193847, 'Patrick Creek', 41.8752784729004, 0.730861484541615, -123.843887329102, -2.16148359236171, 218, 6, 'PPL', 'P'),
(105096, 'Patrick Henry', 37.0277786254883, 0.646256651714351, -78.8986129760742, -1.37704057168922, 218, 53, 'PPL', 'P'),
(105097, 'Patrick Henry Heights', 37.6841697692871, 0.657712838354572, -77.3861083984375, -1.35064238685797, 218, 53, 'PPL', 'P'),
(132541, 'Patrick Landing', 45.9847183227539, 0.80258474033422, -84.3772201538086, -1.47266030536408, 218, 27, 'PPL', 'P'),
(178824, 'Patrick Park', 33.3936080932617, 0.582828410348043, -112.019996643066, -1.9551177694945, 218, 5, 'PPL', 'P'),
(205315, 'Patrick Place', 40.0858306884766, 0.699629728910901, -111.419723510742, -1.94464102692419, 218, 52, 'PPL', 'P'),
(50259, 'Patrick Plains', 38.6794395446777, 0.675083572880723, -76.1105575561523, -1.32837982488351, 218, 25, 'PPL', 'P'),
(105100, 'Patrick Springs', 36.6416702270508, 0.639517788892014, -80.1952819824219, -1.39967171515855, 218, 53, 'PPL', 'P'),
(146008, 'Patricks Corners', 40.4238891601563, 0.705529962305972, -74.4772186279297, -1.29987268278503, 218, 37, 'PPL', 'P'),
(50260, 'Patricks Landing', 38.3450012207031, 0.669246522982514, -75.6619415283203, -1.32054999812062, 218, 25, 'PPL', 'P'),
(193848, 'Patricks Point', 41.1236114501953, 0.717742420116748, -124.155563354492, -2.1669233652043, 218, 6, 'PPL', 'P'),
(30785, 'Patricksburg', 39.315559387207, 0.686185958570127, -86.9591674804688, -1.51772378732736, 218, 19, 'PPL', 'P'),
(165731, 'Patricksburg', 40.7730598449707, 0.711624140407428, -76.8002777099609, -1.34041771248483, 218, 45, 'PPL', 'P'),
(30786, 'Patriot', 38.8386116027832, 0.677861649371839, -84.8269424438477, -1.48050944004487, 218, 19, 'PPL', 'P'),
(73844, 'Patriot', 38.7744407653809, 0.676741656975406, -82.3838882446289, -1.43787010046383, 218, 41, 'PPL', 'P'),
(50261, 'Patriots Choice', 39.4166717529297, 0.687950702266468, -76.9433288574219, -1.34291442600678, 218, 25, 'PPL', 'P'),
(23783, 'Patriots Hill', 33.8444404602051, 0.590696919525764, -84.1800003051758, -1.46921816965515, 218, 13, 'PPL', 'P'),
(105101, 'Patromdale', 37.3777809143066, 0.652365344043747, -77.4674987792969, -1.35206291698342, 218, 53, 'PPL', 'P'),
(61243, 'Patrons Union (historical)', 32.3688888549805, 0.564943685731507, -89.3055572509766, -1.55867601435784, 218, 30, 'PPL', 'P'),
(30787, 'Patronville', 37.8583297729492, 0.660752503843761, -87.1105575561523, -1.52036604260288, 218, 19, 'PPL', 'P'),
(96938, 'Patroon', 31.6227798461914, 0.551921626949346, -93.980827331543, -1.6402748706837, 218, 51, 'PPL', 'P'),
(197224, 'Pats Trailer Park', 48.5583305358887, 0.84750274712296, -109.647216796875, -1.9137049487535, 218, 31, 'PPL', 'P'),
(4899, 'Patsburg', 31.7863903045654, 0.55477716813867, -86.2283325195313, -1.50496831097032, 218, 2, 'PPL', 'P'),
(555, 'Patsey', 37.711669921875, 0.658192806562032, -83.7977828979492, -1.46254721744061, 218, 21, 'PPL', 'P'),
(110833, 'Patsey (historical)', 38.6772193908691, 0.675044823886862, -81.4230575561523, -1.42110044139571, 218, 58, 'PPL', 'P'),
(193849, 'Patsiluvra (historical)', 41.545280456543, 0.725101932631128, -123.527496337891, -2.15596152784143, 218, 6, 'PPL', 'P'),
(200121, 'Patsville', 41.8102798461914, 0.729727044496268, -115.956672668457, -2.02382572772189, 218, 39, 'PPL', 'P'),
(56812, 'Patsy', 37.9619407653809, 0.662560856802952, -91.272216796875, -1.59300069869954, 218, 29, 'PPL', 'P'),
(128488, 'Pattee Corner', 44.5869407653809, 0.778188919747577, -69.0827789306641, -1.20572194876746, 218, 26, 'PPL', 'P'),
(23785, 'Patten', 30.9169406890869, 0.539602409668371, -83.8147201538086, -1.46284282832161, 218, 13, 'PPL', 'P'),
(67633, 'Patten', 35.6508293151855, 0.622224352616503, -81.8602828979492, -1.42873146318322, 218, 33, 'PPL', 'P'),
(128490, 'Patten', 45.9963912963867, 0.802788472157611, -68.4466705322266, -1.19461976281513, 218, 26, 'PPL', 'P'),
(128489, 'Patten Junction', 45.913330078125, 0.801338780418227, -68.413330078125, -1.19403786211695, 218, 26, 'PPL', 'P'),
(73845, 'Patten Mills', 39.457218170166, 0.688658370747129, -81.7816696166992, -1.42735940258961, 218, 41, 'PPL', 'P'),
(146009, 'Pattenburg', 40.6361083984375, 0.709233886750054, -75.0166702270508, -1.30928788934484, 218, 37, 'PPL', 'P'),
(151588, 'Pattens Mills', 43.3827781677246, 0.757172317689107, -73.6044387817383, -1.28463980082394, 218, 40, 'PPL', 'P'),
(125777, 'Pattenville', 42.5791702270508, 0.743146713229178, -71.2266693115234, -1.24313989471529, 218, 23, 'PPL', 'P'),
(11101, 'Patterson', 34.9919395446777, 0.610724556713432, -94.3608322143555, -1.64690720706243, 218, 4, 'PPL', 'P'),
(23784, 'Patterson', 34.0297203063965, 0.593930662879392, -83.2452774047852, -1.45290417744954, 218, 13, 'PPL', 'P'),
(28198, 'Patterson', 39.4805603027344, 0.689065767814884, -90.482780456543, -1.57922243532585, 218, 18, 'PPL', 'P'),
(33581, 'Patterson', 37.9433288574219, 0.66223601772899, -97.6547164916992, -1.70439633288176, 218, 20, 'PPL', 'P'),
(42513, 'Patterson', 29.6930599212646, 0.518241660618036, -91.3019409179688, -1.59351948247989, 218, 22, 'PPL', 'P'),
(56811, 'Patterson', 37.1883316040039, 0.649058829813332, -90.5505599975586, -1.58040541148207, 218, 29, 'PPL', 'P'),
(61244, 'Patterson', 32.9775009155273, 0.575565970055397, -89.4319381713867, -1.5608817775307, 218, 30, 'PPL', 'P'),
(67632, 'Patterson', 35.9991683959961, 0.628304016490018, -81.5641708374023, -1.42356333277181, 218, 33, 'PPL', 'P'),
(76896, 'Patterson', 34.954719543457, 0.610074945144534, -95.4013900756836, -1.66506836780012, 218, 42, 'PPL', 'P'),
(89797, 'Patterson', 35.8230590820313, 0.625230329117903, -86.6094436645508, -1.51161995526695, 218, 50, 'PPL', 'P'),
(105103, 'Patterson', 37.2644386291504, 0.650387147986036, -81.9761123657227, -1.4307530687667, 218, 53, 'PPL', 'P'),
(117247, 'Patterson', 41.348331451416, 0.721664524033135, -93.8802795410156, -1.63851998068339, 218, 16, 'PPL', 'P'),
(151589, 'Patterson', 41.5136108398438, 0.724549193546882, -73.6066665649414, -1.28467868297585, 218, 40, 'PPL', 'P'),
(157052, 'Patterson', 40.7805595397949, 0.711755034775005, -83.5258331298828, -1.45780079858782, 218, 41, 'PPL', 'P'),
(184033, 'Patterson', 37.4716682434082, 0.654003987062473, -121.128608703613, -2.11409304023791, 218, 6, 'PPL', 'P'),
(195444, 'Patterson', 44.523609161377, 0.777083574737139, -113.711387634277, -1.98463811122971, 218, 17, 'PPL', 'P'),
(197225, 'Patterson', 45.628059387207, 0.796359867602269, -111.051391601563, -1.93821242236884, 218, 31, 'PPL', 'P'),
(11100, 'Patterson (historical)', 35.1416702270508, 0.613337850112099, -90.5527801513672, -1.58044416047593, 218, 4, 'PPL', 'P'),
(190596, 'Patterson (historical)', 38.5980606079102, 0.673663242492356, -114.692497253418, -2.0017617044067, 218, 39, 'PPL', 'P'),
(197226, 'Patterson (historical)', 47.6455612182617, 0.831571917219188, -110.565277099609, -1.92972812376807, 218, 31, 'PPL', 'P'),
(208405, 'Patterson (historical)', 47.4913902282715, 0.828881125832799, -120.301391601563, -2.09965537817832, 218, 56, 'PPL', 'P'),
(205316, 'Patterson Addition Magna', 40.7044410705566, 0.710426516865219, -112.104438781738, -1.95659156284175, 218, 52, 'PPL', 'P'),
(197227, 'Patterson Corner', 45.7874984741211, 0.799142604625293, -112.891387939453, -1.97032641668967, 218, 31, 'PPL', 'P'),
(110834, 'Patterson Creek', 39.5666694641113, 0.690568656197043, -78.7333297729492, -1.37415583559644, 218, 58, 'PPL', 'P'),
(187176, 'Patterson Crossing', 37.2174987792969, 0.649567893055701, -104.207778930664, -1.81876884853046, 218, 7, 'PPL', 'P'),
(89798, 'Patterson Crossroads', 36.5658302307129, 0.638194131251218, -83.647216796875, -1.45991934323497, 218, 50, 'PPL', 'P'),
(132542, 'Patterson Gardens', 41.9183311462402, 0.731612895443181, -83.4305572509766, -1.45613792080317, 218, 27, 'PPL', 'P'),
(165732, 'Patterson Grove', 41.2316703796387, 0.719628404221715, -76.2402801513672, -1.33064391128424, 218, 45, 'PPL', 'P'),
(165733, 'Patterson Heights', 40.7394409179688, 0.711037379440256, -80.3294372558594, -1.40201316638894, 218, 45, 'PPL', 'P'),
(165735, 'Patterson Hill', 40.2802810668945, 0.703023528246044, -79.8708267211914, -1.39400890257466, 218, 45, 'PPL', 'P'),
(89799, 'Patterson Hills', 36.1730613708496, 0.631339021447299, -83.4583282470703, -1.45662261612156, 218, 50, 'PPL', 'P'),
(82882, 'Patterson Mill', 33.1783294677734, 0.579071089524104, -81.4791717529297, -1.42207981888658, 218, 48, 'PPL', 'P'),
(89800, 'Patterson Mill', 34.9905586242676, 0.610700455105567, -84.4397201538086, -1.47375113614657, 218, 50, 'PPL', 'P'),
(50262, 'Patterson Park', 38.4052810668945, 0.67029860477115, -76.5097198486328, -1.3353465211371, 218, 25, 'PPL', 'P'),
(187177, 'Patterson Place', 39.1138916015625, 0.682666191715424, -107.416938781738, -1.87477925415452, 218, 7, 'PPL', 'P'),
(14371, 'Patterson Place Mobile Home Park', 38.6533317565918, 0.67462790601821, -75.2600021362305, -1.31353483233519, 218, 10, 'PPL', 'P'),
(28199, 'Patterson Springs', 39.7922210693359, 0.694505274341371, -88.1927795410156, -1.53925437947622, 218, 18, 'PPL', 'P'),
(67634, 'Patterson Springs', 35.235279083252, 0.614971632861836, -81.5147171020508, -1.42270020226252, 218, 33, 'PPL', 'P'),
(105104, 'Patterson Store', 38.1894416809082, 0.666531496830206, -78.5722198486328, -1.37134393695948, 218, 53, 'PPL', 'P'),
(73847, 'Pattersons Corner', 39.6366691589355, 0.691790381347117, -83.7702789306641, -1.46206718265412, 218, 41, 'PPL', 'P'),
(165737, 'Pattersons Mill', 40.2922210693359, 0.703231920601343, -80.4486083984375, -1.4040930952003, 218, 45, 'PPL', 'P'),
(4900, 'Pattersontown', 33.3063888549805, 0.581306147468953, -87.2225036621094, -1.52231987073662, 218, 2, 'PPL', 'P'),
(89801, 'Pattersonville', 35.1386108398438, 0.613284453732243, -89.3033294677734, -1.55863713220592, 218, 50, 'PPL', 'P'),
(151592, 'Pattersonville', 42.8899993896484, 0.748571705527724, -74.0819396972656, -1.29297376398118, 218, 40, 'PPL', 'P'),
(157054, 'Pattersonville', 40.6744384765625, 0.709902872815882, -81.0486068725586, -1.41456504408065, 218, 41, 'PPL', 'P'),
(165738, 'Pattersonville', 40.8394393920898, 0.712782682060639, -76.2275009155273, -1.33042087154294, 218, 45, 'PPL', 'P'),
(89802, 'Pattie Gap (historical)', 35.7241706848145, 0.62350440099445, -84.5319366455078, -1.47536061755136, 218, 50, 'PPL', 'P'),
(82884, 'Pattillo (historical)', 32.9811096191406, 0.575628953815177, -80.7699966430664, -1.40970237824628, 218, 48, 'PPL', 'P'),
(61246, 'Pattison', 31.8883304595947, 0.556556359483925, -90.8872222900391, -1.58628127695316, 218, 30, 'PPL', 'P'),
(96939, 'Pattison', 29.8250007629395, 0.520544462723114, -95.9947204589844, -1.67542393654084, 218, 51, 'PPL', 'P'),
(4902, 'Patton', 33.7005615234375, 0.588185758354901, -87.454719543457, -1.52637280244156, 218, 2, 'PPL', 'P'),
(28202, 'Patton', 38.4769401550293, 0.671549291798079, -87.7536087036133, -1.5315894023848, 218, 18, 'PPL', 'P'),
(56813, 'Patton', 37.5022201538086, 0.654537218491734, -90.0133285522461, -1.57102895391612, 218, 29, 'PPL', 'P'),
(76899, 'Patton', 36.4766693115234, 0.636637979647257, -95.2555618286133, -1.66252318474633, 218, 42, 'PPL', 'P'),
(112652, 'Patton', 37.6919403076172, 0.657848459833084, -80.4877777099609, -1.40477672865212, 218, 58, 'PPL', 'P'),
(123398, 'Patton', 40.7080612182617, 0.710489700362081, -86.7405624389648, -1.51390840959166, 218, 19, 'PPL', 'P'),
(165740, 'Patton', 40.1941719055176, 0.701520639863885, -80.2533264160156, -1.40068478163721, 218, 45, 'PPL', 'P'),
(184034, 'Patton', 34.1358299255371, 0.595782625101433, -117.22306060791, -2.0459283668729, 218, 6, 'PPL', 'P'),
(201378, 'Patton', 45.4472198486328, 0.793203622236362, -123.14111328125, -2.14921787132913, 218, 43, 'PPL', 'P'),
(4901, 'Patton Chapel', 33.3941688537598, 0.582838197465049, -86.7980575561523, -1.5149118886904, 218, 2, 'PPL', 'P'),
(30788, 'Patton Hill', 38.9005584716797, 0.678942826195384, -86.5380630493164, -1.51037412850902, 218, 19, 'PPL', 'P'),
(56814, 'Patton Junction', 37.5188903808594, 0.654828168840825, -90.0152816772461, -1.57106304237807, 218, 29, 'PPL', 'P'),
(96940, 'Patton Village', 30.1927795410156, 0.526963413319505, -95.1686096191406, -1.66100558239915, 218, 51, 'PPL', 'P'),
(193850, 'Patton Village', 40.1411094665527, 0.70059452559481, -120.15389251709, -2.09708103351059, 218, 6, 'PPL', 'P'),
(96941, 'Patton Woods', 29.4597206115723, 0.514169121389574, -94.646110534668, -1.65188625303645, 218, 51, 'PPL', 'P'),
(61248, 'Pattona (historical)', 31.9402809143066, 0.557463065966556, -90.7666702270508, -1.58417724653395, 218, 30, 'PPL', 'P'),
(96942, 'Pattonfield', 32.6500701904297, 0.56985122583025, -94.9197311401367, -1.65666183350318, 218, 51, 'PPL', 'P'),
(157055, 'Pattons Corners', 40.2269401550293, 0.702092553707979, -82.5197219848633, -1.44024084646621, 218, 41, 'PPL', 'P'),
(67638, 'Pattons Ridge', 36.2311096191406, 0.632352154504993, -81.4372177124023, -1.42134758274487, 218, 33, 'PPL', 'P'),
(120977, 'Pattonsburg', 40.9377784729004, 0.714499022804168, -89.184440612793, -1.55656213024259, 218, 18, 'PPL', 'P'),
(139382, 'Pattonsburg', 40.0466690063477, 0.698946228617133, -94.1355590820313, -1.6429754491871, 218, 29, 'PPL', 'P'),
(73848, 'Pattonsville', 39.0316696166992, 0.681231147362034, -82.4974975585938, -1.43985295705344, 218, 41, 'PPL', 'P'),
(105105, 'Pattonsville', 36.6994400024414, 0.640526061680718, -82.8513870239258, -1.44602949341161, 218, 53, 'PPL', 'P'),
(11102, 'Pattonville', 35.792781829834, 0.624701891378604, -91.7141723632813, -1.60071427848085, 218, 4, 'PPL', 'P'),
(56815, 'Pattonville', 38.7363891601563, 0.676077531178568, -90.4066696166992, -1.57789405057412, 218, 29, 'PPL', 'P'),
(96943, 'Pattonville', 33.5791702270508, 0.586067080549688, -95.3919372558594, -1.66490338497059, 218, 51, 'PPL', 'P'),
(165742, 'Pattonville', 40.7750015258789, 0.711658029132299, -79.521110534668, -1.3879052036723, 218, 45, 'PPL', 'P'),
(11103, 'Pattsville', 33.4419403076172, 0.583671966623325, -92.1066665649414, -1.6075645945948, 218, 4, 'PPL', 'P'),
(89803, 'Patty', 35.2347183227539, 0.61496184574483, -84.64111328125, -1.47726610931131, 218, 50, 'PPL', 'P'),
(14372, 'Patty Cannon Estates', 38.5927810668945, 0.67357109711864, -75.6449966430664, -1.32025425408157, 218, 10, 'PPL', 'P'),
(157061, 'Pattytown', 40.0219383239746, 0.698514596783458, -84.4136123657227, -1.47329546928406, 218, 41, 'PPL', 'P'),
(125778, 'Patuisset', 41.6833305358887, 0.72751136104835, -70.6269378662109, -1.23267260636684, 218, 23, 'PPL', 'P'),
(50272, 'Patuxent', 39.0547218322754, 0.681633484423718, -76.7363891601563, -1.33930264693641, 218, 25, 'PPL', 'P'),
(50264, 'Patuxent Highland', 38.7066688537598, 0.675558813977247, -76.6930618286133, -1.33854644234489, 218, 25, 'PPL', 'P'),
(50265, 'Patuxent Hills', 39.225830078125, 0.684619886691106, -76.9186096191406, -1.34248299391019, 218, 25, 'PPL', 'P'),
(50266, 'Patuxent Knolls', 38.4900016784668, 0.671777258387389, -76.7041702270508, -1.33874032047224, 218, 25, 'PPL', 'P'),
(50267, 'Patuxent Manor', 38.9124984741211, 0.679151218550683, -76.6669387817383, -1.33809050916626, 218, 25, 'PPL', 'P'),
(50268, 'Patuxent Mobile Homes', 38.8152809143066, 0.677454452041166, -76.6949996948242, -1.33858026449073, 218, 25, 'PPL', 'P'),
(50269, 'Patuxent Palisades', 38.7416687011719, 0.676169676552284, -76.6808319091797, -1.33833298998352, 218, 25, 'PPL', 'P'),
(50270, 'Patuxent Park', 38.2638893127441, 0.667830853126056, -76.4647216796875, -1.33456115493164, 218, 25, 'PPL', 'P'),
(50271, 'Patuxent Riding', 39.0149993896484, 0.680940197012943, -76.7519378662109, -1.33957402305149, 218, 25, 'PPL', 'P'),
(50276, 'Patuxent River Estates', 38.9794387817383, 0.6803195473209, -76.6963882446289, -1.33860449925665, 218, 25, 'PPL', 'P'),
(50273, 'Patuxent View', 38.5041694641113, 0.672024532894603, -76.6611099243164, -1.33798877641262, 218, 25, 'PPL', 'P'),
(50275, 'Patuxent Woods', 38.5333290100098, 0.672533462978917, -76.7425003051758, -1.33940930653807, 218, 25, 'PPL', 'P'),
(125779, 'Patuxet (historical)', 41.9583282470703, 0.732310976543918, -70.6677780151367, -1.2333854014326, 218, 23, 'PPL', 'P'),
(175770, 'Patzau', 46.4913902282715, 0.811427833312856, -92.2205581665039, -1.60955237803244, 218, 57, 'PPL', 'P'),
(210937, 'Pauahi', 19.5072193145752, 0.340465204947969, -155.826385498047, -2.71968348842286, 218, 15, 'PPL', 'P'),
(125780, 'Paucatuck (historical)', 42.1111106872559, 0.734977533164387, -72.6861114501953, -1.26861196527746, 218, 23, 'PPL', 'P'),
(144295, 'Paugus Mill', 43.9238891601563, 0.766616486125773, -71.3047180175781, -1.24450210161286, 218, 36, 'PPL', 'P'),
(210940, 'Paukaa', 19.7655601501465, 0.344974103121041, -155.095001220703, -2.70691842468589, 218, 15, 'PPL', 'P'),
(175771, 'Paukotuk', 43.9680595397949, 0.767387404682324, -88.5208282470703, -1.54497990950378, 218, 57, 'PPL', 'P'),
(210942, 'Paukukalo', 20.9086093902588, 0.36492407587342, -156.487777709961, -2.73122696016781, 218, 15, 'PPL', 'P'),
(4904, 'Paul', 31.3199996948242, 0.546637116398302, -86.7438888549805, -1.51396646650342, 218, 2, 'PPL', 'P'),
(61249, 'Paul', 33.9116706848145, 0.591870308302052, -89.9527816772461, -1.56997221159557, 218, 30, 'PPL', 'P'),
(113159, 'Paul', 40.5952796936035, 0.708521291421376, -95.8963928222656, -1.67370779553439, 218, 35, 'PPL', 'P'),
(195446, 'Paul', 42.6080589294434, 0.743650916202557, -113.782501220703, -1.98587927745574, 218, 17, 'PPL', 'P'),
(96944, 'Paul Junction', 31.1566696166992, 0.543786468767481, -99.2724990844727, -1.7326319657071, 218, 51, 'PPL', 'P'),
(197228, 'Paul Place', 45.9786109924316, 0.80247814731159, -112.255279541016, -1.95922423073735, 218, 31, 'PPL', 'P'),
(151594, 'Paul Smiths', 44.4386100769043, 0.77560006085191, -74.253059387207, -1.29596036598565, 218, 40, 'PPL', 'P'),
(151595, 'Paul Smiths Easy Street', 44.4397201538086, 0.775619435348841, -74.2300033569336, -1.29555796234493, 218, 40, 'PPL', 'P'),
(178825, 'Paul Spur', 31.3661098480225, 0.54744189039021, -109.73388671875, -1.91521762425266, 218, 5, 'PPL', 'P'),
(61250, 'Paula (historical)', 32.3158302307129, 0.564017638041459, -89.0555572509766, -1.55431269122785, 218, 30, 'PPL', 'P'),
(89804, 'Paula Heights', 36.5302810668945, 0.637573681296256, -87.2375030517578, -1.52258165947178, 218, 50, 'PPL', 'P'),
(184036, 'Paularino', 33.6813888549805, 0.587851132163932, -117.877777099609, -2.05735532532016, 218, 6, 'PPL', 'P'),
(146010, 'Paulas Corners', 40.4150009155273, 0.705374833172475, -74.4647216796875, -1.29965456989175, 218, 37, 'PPL', 'P'),
(178826, 'Paulcell Place', 34.9619407653809, 0.610200979243122, -109.82527923584, -1.91681272458757, 218, 5, 'PPL', 'P'),
(178827, 'Paulden', 34.8855590820313, 0.608867867380456, -112.467498779297, -1.96292815518143, 218, 5, 'PPL', 'P'),
(56816, 'Paulding', 36.0136108398438, 0.628556084687194, -90.2361068725586, -1.57491716910763, 218, 29, 'PPL', 'P'),
(61251, 'Paulding', 32.0305595397949, 0.559038725225501, -89.0374984741211, -1.55399750611284, 218, 30, 'PPL', 'P'),
(71256, 'Paulding', 39.6091690063477, 0.691310413139657, -75.2838897705078, -1.31395175020384, 218, 37, 'PPL', 'P'),
(132543, 'Paulding', 46.4013900756836, 0.8098570343229, -89.1797180175781, -1.55647970540685, 218, 27, 'PPL', 'P'),
(157056, 'Paulding', 41.1380615234375, 0.717994621471979, -84.5805587768555, -1.47620923383272, 218, 41, 'PPL', 'P'),
(56817, 'Pauldingville', 38.7747192382813, 0.676746517244396, -90.9552764892578, -1.58746904679934, 218, 29, 'PPL', 'P'),
(61252, 'Paulette', 32.9963912963867, 0.575895669398348, -88.4297180175781, -1.54338973601689, 218, 30, 'PPL', 'P'),
(89806, 'Paulette', 36.1913909912109, 0.631658933673245, -83.8899993896484, -1.4641566988454, 218, 50, 'PPL', 'P'),
(37603, 'Pauley', 37.4947204589844, 0.654406324124157, -82.5352783203125, -1.44051235573935, 218, 21, 'PPL', 'P'),
(42514, 'Paulina', 30.0261096954346, 0.524054475750325, -90.7130584716797, -1.58324154488495, 218, 22, 'PPL', 'P'),
(146011, 'Paulina', 40.976390838623, 0.715172935718013, -74.9441680908203, -1.30802248835289, 218, 37, 'PPL', 'P'),
(201379, 'Paulina', 44.1338882446289, 0.770281661575995, -119.961669921875, -2.09372611632737, 218, 43, 'PPL', 'P'),
(56818, 'Paulina Hills', 38.4608306884766, 0.671268128565993, -90.4283294677734, -1.57827208629086, 218, 29, 'PPL', 'P'),
(33582, 'Pauline', 38.9633293151855, 0.680038384088815, -95.6902770996094, -1.67011039753391, 218, 20, 'PPL', 'P'),
(82883, 'Pauline', 34.8330612182617, 0.607951606807414, -81.8724975585938, -1.42894464922848, 218, 48, 'PPL', 'P'),
(96945, 'Pauline', 32.3377799987793, 0.564400733764267, -96.0536117553711, -1.67645178356356, 218, 51, 'PPL', 'P'),
(120978, 'Pauline', 40.127498626709, 0.700356971625575, -88.0058288574219, -1.53599147450865, 218, 18, 'PPL', 'P'),
(142645, 'Pauline', 40.416389465332, 0.705399067938395, -98.3452835083008, -1.71644900102713, 218, 35, 'PPL', 'P'),
(195445, 'Pauline', 42.5708312988281, 0.743001171475605, -112.559440612793, -1.96453284289626, 218, 17, 'PPL', 'P'),
(105106, 'Paulington (historical)', 38.4761085510254, 0.671534777570138, -78.7527770996094, -1.37449525547737, 218, 53, 'PPL', 'P'),
(146012, 'Paulins Kill', 41.0580596923828, 0.71659832611245, -74.8236083984375, -1.30591832477562, 218, 37, 'PPL', 'P'),
(23787, 'Paulk', 32.3858299255371, 0.565239363191533, -83.4052810668945, -1.4556967681686, 218, 13, 'PPL', 'P'),
(89805, 'Paulks (historical)', 35.2569389343262, 0.615349668578573, -88.192497253418, -1.5392494526282, 218, 50, 'PPL', 'P'),
(117248, 'Paullina', 42.9791717529297, 0.750128056868766, -95.6877822875977, -1.67006685485009, 218, 16, 'PPL', 'P'),
(128497, 'Pauls', 46.8452796936035, 0.817604369671022, -68.0461120605469, -1.18762869863757, 218, 26, 'PPL', 'P'),
(157059, 'Pauls (historical)', 40.8461112976074, 0.712899128779303, -81.5541687011719, -1.42338876256236, 218, 41, 'PPL', 'P'),
(50280, 'Pauls Corner', 38.0405616760254, 0.663933050554615, -75.7436065673828, -1.32197532193603, 218, 25, 'PPL', 'P'),
(128492, 'Pauls Corner', 44.3800010681152, 0.774577140677211, -69.2177810668945, -1.2080781805419, 218, 26, 'PPL', 'P'),
(67640, 'Pauls Crossing', 35.4297218322754, 0.618365299038924, -80.311393737793, -1.40169824759004, 218, 33, 'PPL', 'P'),
(105107, 'Pauls Crossroads', 37.8650016784668, 0.660868950562425, -76.9105606079102, -1.34234251216268, 218, 53, 'PPL', 'P'),
(4906, 'Pauls Hill', 33.4122200012207, 0.583153249422005, -86.9297180175781, -1.51720979723698, 218, 2, 'PPL', 'P'),
(165744, 'Pauls Run', 40.0966682434082, 0.699818879927324, -75.033332824707, -1.30957870653588, 218, 45, 'PPL', 'P'),
(11104, 'Pauls Switch', 35.952220916748, 0.627484628401628, -90.8249969482422, -1.58519523986063, 218, 4, 'PPL', 'P'),
(76906, 'Pauls Valley', 34.7400016784668, 0.606327411437602, -97.2219390869141, -1.69684294224002, 218, 42, 'PPL', 'P'),
(71242, 'Paulsboro', 39.8302803039551, 0.695169533296264, -75.2408294677734, -1.31320020614422, 218, 37, 'PPL', 'P'),
(184037, 'Paulsell', 37.7183303833008, 0.658309053543613, -120.689437866211, -2.1064280631465, 218, 6, 'PPL', 'P'),
(205319, 'Paulsen Acres', 40.6458282470703, 0.709403530111492, -111.929718017578, -1.95354211023556, 218, 52, 'PPL', 'P'),
(50277, 'Paulson', 39.3219413757324, 0.686297345282719, -77.4261093139648, -1.35134053453773, 218, 25, 'PPL', 'P'),
(198735, 'Paulson', 48.896671295166, 0.853407907366047, -103.132781982422, -1.80000661233475, 218, 34, 'PPL', 'P'),
(184038, 'Paulson Place', 39.8444404602051, 0.695416674645423, -121.144439697266, -2.11436934320101, 218, 6, 'PPL', 'P'),
(28203, 'Paulton', 37.7638893127441, 0.659104206866084, -88.8038864135742, -1.54992020648393, 218, 18, 'PPL', 'P'),
(165745, 'Paulton', 40.5705604553223, 0.708089859324783, -79.5749969482422, -1.38884569901127, 218, 45, 'PPL', 'P'),
(139383, 'Paultown', 40.1605606079102, 0.700934012054768, -92.3647232055664, -1.61206853263035, 218, 29, 'PPL', 'P'),
(184041, 'Pauma Valley', 33.3033294677734, 0.581252751089097, -116.980560302734, -2.04169593811049, 218, 6, 'PPL', 'P'),
(11105, 'Paup', 33.5019416809082, 0.584719188142972, -93.942497253418, -1.63960588461787, 218, 4, 'PPL', 'P'),
(165747, 'Paupack', 41.396110534668, 0.722498426349466, -75.1966705322266, -1.31242948732475, 218, 45, 'PPL', 'P'),
(137393, 'Paupores', 46.872501373291, 0.818079477609492, -92.7641677856445, -1.61904015573195, 218, 28, 'PPL', 'P'),
(210945, 'Pauwalu', 21.0913906097412, 0.368114209964199, -156.776672363281, -2.73626912305966, 218, 15, 'PPL', 'P'),
(210947, 'Pauwela', 20.9338893890381, 0.365365295087019, -156.320007324219, -2.72829881454927, 218, 15, 'PPL', 'P'),
(113326, 'Pavia', 40.2572212219238, 0.702621058026306, -78.584716796875, -1.37156204985276, 218, 45, 'PPL', 'P'),
(132544, 'Pavilion', 42.1722183227539, 0.736044062601936, -85.4591674804688, -1.49154384854745, 218, 27, 'PPL', 'P'),
(151596, 'Pavilion', 42.8761100769043, 0.748329291289499, -78.023063659668, -1.36175935335434, 218, 40, 'PPL', 'P'),
(151597, 'Pavilion Center', 42.9091682434082, 0.748906265139665, -78.0202789306641, -1.36171075066445, 218, 40, 'PPL', 'P'),
(120979, 'Pavillion', 41.6105613708496, 0.726241299524491, -88.4749984741211, -1.54418002907037, 218, 18, 'PPL', 'P'),
(209663, 'Pavillion', 43.2447204589844, 0.754762756113831, -108.689437866211, -1.89698855290718, 218, 59, 'PPL', 'P'),
(132546, 'Pavillion Center', 42.2008285522461, 0.736543405306326, -85.4819412231445, -1.49194132534014, 218, 27, 'PPL', 'P'),
(200122, 'Pavlak (historical)', 41.848331451416, 0.730391170293107, -115.428886413574, -2.01461411982742, 218, 39, 'PPL', 'P'),
(132547, 'Pavlovic Corner', 44.5688896179199, 0.77787386779062, -85.7533264160156, -1.4966778904969, 218, 27, 'PPL', 'P'),
(23788, 'Pavo', 30.9597206115723, 0.540349060169488, -83.7380599975586, -1.46150485618995, 218, 13, 'PPL', 'P'),
(71244, 'Pavonia', 39.9508285522461, 0.697273497136454, -75.0875015258789, -1.31052412872285, 218, 37, 'PPL', 'P'),
(157060, 'Pavonia', 40.8224983215332, 0.712487004600613, -82.4361114501953, -1.43878156734691, 218, 41, 'PPL', 'P'),
(67639, 'Paw Creek', 35.2747192382813, 0.615659993424594, -80.938606262207, -1.41264517125081, 218, 33, 'PPL', 'P'),
(37604, 'Paw Paw', 37.4375, 0.653407638715377, -82.1108322143555, -1.43310437369313, 218, 21, 'PPL', 'P'),
(76901, 'Paw Paw', 35.332218170166, 0.616663539102363, -94.5133285522461, -1.64956877025586, 218, 42, 'PPL', 'P'),
(110836, 'Paw Paw', 39.5486106872559, 0.690253471082032, -80.1533279418945, -1.39893947901683, 218, 58, 'PPL', 'P'),
(120980, 'Paw Paw', 41.6888885498047, 0.727608366691056, -88.9811096191406, -1.553013334932, 218, 18, 'PPL', 'P'),
(132548, 'Paw Paw', 42.2177810668945, 0.736839282503434, -85.89111328125, -1.49908272496124, 218, 27, 'PPL', 'P'),
(139384, 'Paw Paw', 40.0911102294922, 0.699721874284618, -93.0875015258789, -1.62468339408183, 218, 29, 'PPL', 'P'),
(50278, 'Paw Paw Acres', 38.5397186279297, 0.672644982849565, -76.1438903808594, -1.32896159242364, 218, 25, 'PPL', 'P'),
(132549, 'Paw Paw Lake', 42.2122192382813, 0.736742210281701, -86.2719421386719, -1.50572944240986, 218, 27, 'PPL', 'P'),
(50279, 'Paw Paw Point', 38.5311088562012, 0.672494713985057, -76.1427764892578, -1.32894215134768, 218, 25, 'PPL', 'P'),
(210948, 'Pawaina', 19.5052795410156, 0.340431349512611, -155.860000610352, -2.72027018281101, 218, 15, 'PPL', 'P'),
(113895, 'Pawcatuck', 41.3772201538086, 0.722168727006514, -71.8341674804688, -1.25374273796322, 218, 8, 'PPL', 'P'),
(96946, 'Pawelekville', 29.0522193908691, 0.507056883382408, -97.9333267211914, -1.70925899871613, 218, 51, 'PPL', 'P'),
(11106, 'Pawheen', 35.9747200012207, 0.62787731150436, -90.2125015258789, -1.574505178087, 218, 4, 'PPL', 'P'),
(76903, 'Pawhuska', 36.667781829834, 0.639973522333554, -96.3369369506836, -1.68139674107561, 218, 42, 'PPL', 'P'),
(172385, 'Pawlet', 43.3466682434082, 0.75654208061714, -73.1766662597656, -1.27717376186595, 218, 55, 'PPL', 'P'),
(82885, 'Pawleys Island', 33.4330596923828, 0.583516970647883, -79.1216735839844, -1.38093371372875, 218, 48, 'PPL', 'P'),
(82886, 'Pawleys Plantation', 33.4252815246582, 0.583381216011316, -79.1502838134766, -1.38143305643314, 218, 48, 'PPL', 'P'),
(82887, 'Pawleys Retreat', 33.4577789306641, 0.583948402744475, -79.1399993896484, -1.38125355937567, 218, 48, 'PPL', 'P'),
(82888, 'Pawleys Woods', 33.4244384765625, 0.583366502046293, -79.1391677856445, -1.38123904514773, 218, 48, 'PPL', 'P'),
(151599, 'Pawling', 41.561939239502, 0.725392683243137, -73.6030578613281, -1.28461569921607, 218, 40, 'PPL', 'P'),
(165748, 'Pawling Station', 40.8025016784668, 0.712137997339758, -76.9274978637695, -1.34263812304368, 218, 45, 'PPL', 'P'),
(23789, 'Pawnee', 31.0611095428467, 0.542118630845305, -84.3177795410156, -1.47162287096144, 218, 13, 'PPL', 'P'),
(28204, 'Pawnee', 39.5916709899902, 0.691005015141653, -89.5802764892578, -1.56347076958442, 218, 18, 'PPL', 'P'),
(42515, 'Pawnee', 30.8902797698975, 0.539137088846907, -92.6269378662109, -1.61664504180559, 218, 22, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(76904, 'Pawnee', 36.3377799987793, 0.63421390384404, -96.8036117553711, -1.68954175295351, 218, 42, 'PPL', 'P'),
(96947, 'Pawnee', 28.6525001525879, 0.500080466590836, -98.0025024414063, -1.71046634279632, 218, 51, 'PPL', 'P'),
(113260, 'Pawnee', 41.0675010681152, 0.716763109204899, -82.0769424438477, -1.43251288561502, 218, 41, 'PPL', 'P'),
(139385, 'Pawnee', 40.5219383239746, 0.70724124304343, -94.0505599975586, -1.64149193530187, 218, 29, 'PPL', 'P'),
(193851, 'Pawnee', 40.6124992370605, 0.708821829150392, -122.033332824707, -2.12988345497321, 218, 6, 'PPL', 'P'),
(142646, 'Pawnee City', 40.1083297729492, 0.700022412013634, -96.154167175293, -1.67820680672192, 218, 35, 'PPL', 'P'),
(4905, 'Pawnee Heights', 33.6286087036133, 0.586929944742874, -86.7458267211914, -1.51400028864927, 218, 2, 'PPL', 'P'),
(28205, 'Pawnee Junction', 39.5897216796875, 0.690970993258727, -89.646110534668, -1.56461979043673, 218, 18, 'PPL', 'P'),
(50281, 'Pawnee Lake Hills', 39.666389465332, 0.692309098548437, -75.9016723632813, -1.32473409050924, 218, 25, 'PPL', 'P'),
(33597, 'Pawnee Rock', 38.2652816772461, 0.667855154471003, -98.9805603027344, -1.72753667275151, 218, 20, 'PPL', 'P'),
(33587, 'Pawnee Station', 37.7000007629395, 0.657989141317668, -94.7911071777344, -1.65441692186229, 218, 20, 'PPL', 'P'),
(142648, 'Pawnee Village', 40.0586090087891, 0.699154620972431, -98.4038925170898, -1.71747192120183, 218, 35, 'PPL', 'P'),
(50282, 'Pawpaw Hollow', 38.273609161377, 0.668000496487494, -76.6572189331055, -1.33792086580483, 218, 25, 'PPL', 'P'),
(89807, 'Pawpaw Plains', 35.8697204589844, 0.626044723779249, -84.3375015258789, -1.47196708453233, 218, 50, 'PPL', 'P'),
(169537, 'Pawtucket', 41.8786087036133, 0.730919608032406, -71.383056640625, -1.24586936851651, 218, 47, 'PPL', 'P'),
(125781, 'Pawtucketville', 42.6583290100098, 0.744528294623684, -71.3305587768555, -1.24495310794347, 218, 23, 'PPL', 'P'),
(169539, 'Pawtuxet', 41.7627792358398, 0.728898002448927, -71.3905563354492, -1.24600026288409, 218, 47, 'PPL', 'P'),
(110837, 'Pax', 37.9097213745117, 0.6616494564989, -81.2644424438477, -1.41833208544257, 218, 58, 'PPL', 'P'),
(33591, 'Paxico', 39.0694389343262, 0.681890346310856, -96.1661071777344, -1.67841519907722, 218, 20, 'PPL', 'P'),
(165756, 'Paxinos', 40.8505592346191, 0.712976759925079, -76.5808334350586, -1.33658768736313, 218, 45, 'PPL', 'P'),
(105108, 'Paxson', 39.0958290100098, 0.682350940021386, -77.8077774047852, -1.35800189937235, 218, 53, 'PPL', 'P'),
(212081, 'Paxson', 63.0897216796875, 1.10112336747739, -145.613067626953, -2.5414274640195, 218, 1, 'PPL', 'P'),
(165750, 'Paxtang', 40.2588882446289, 0.702650153061215, -76.8322219848633, -1.34097524525904, 218, 45, 'PPL', 'P'),
(165751, 'Paxtang Manor', 40.2700004577637, 0.7028440977676, -76.831672668457, -1.34096565787911, 218, 45, 'PPL', 'P'),
(17550, 'Paxton', 30.9813899993896, 0.540727262333793, -86.307502746582, -1.50635009210191, 218, 12, 'PPL', 'P'),
(23790, 'Paxton', 30.8488903045654, 0.538414706401223, -82.0730590820313, -1.43244510816528, 218, 13, 'PPL', 'P'),
(30789, 'Paxton', 39.021110534668, 0.681046856614601, -87.3886108398438, -1.52521898789928, 218, 19, 'PPL', 'P'),
(33593, 'Paxton', 38.0138893127441, 0.66346752999607, -97.591667175293, -1.70329591471934, 218, 20, 'PPL', 'P'),
(37605, 'Paxton', 37.6763916015625, 0.657577083718005, -83.4086074829102, -1.45575482508036, 218, 21, 'PPL', 'P'),
(96948, 'Paxton', 31.9577808380127, 0.557768497254074, -94.1650009155273, -1.64348930611943, 218, 51, 'PPL', 'P'),
(110838, 'Paxton', 38.4980583190918, 0.671917873292946, -81.1680603027344, -1.41664989974002, 218, 58, 'PPL', 'P'),
(120982, 'Paxton', 40.4602813720703, 0.706165126225956, -88.0952835083008, -1.53755275269771, 218, 18, 'PPL', 'P'),
(125782, 'Paxton', 42.3111114501953, 0.738468204984181, -71.9286117553711, -1.25539110151992, 218, 23, 'PPL', 'P'),
(132550, 'Paxton', 45.0544395446777, 0.786348312695361, -83.6141662597656, -1.45934250254286, 218, 27, 'PPL', 'P'),
(157062, 'Paxton', 41.0930595397949, 0.717209188687487, -81.6877822875977, -1.42572075957088, 218, 41, 'PPL', 'P'),
(165754, 'Paxton', 40.5961112976074, 0.708535805649317, -76.9375, -1.34281269325314, 218, 45, 'PPL', 'P'),
(193852, 'Paxton', 40.0380592346191, 0.698795959752625, -120.99388885498, -2.11174173531148, 218, 6, 'PPL', 'P'),
(199595, 'Paxton', 41.1241683959961, 0.717752140654727, -101.355827331543, -1.76899290301828, 218, 35, 'PPL', 'P'),
(208406, 'Paxton', 47.0508308410645, 0.821191913975468, -118.003608703613, -2.05955150111309, 218, 56, 'PPL', 'P'),
(197229, 'Paxton (historical)', 47.6311111450195, 0.831319715863957, -105.340827941895, -1.8385442843629, 218, 31, 'PPL', 'P'),
(165755, 'Paxton Acres', 40.3127784729004, 0.703590714979203, -76.791389465332, -1.34026258335133, 218, 45, 'PPL', 'P'),
(105109, 'Paxton Hills', 39.163330078125, 0.683529055908609, -78.2930603027344, -1.36647168374518, 218, 53, 'PPL', 'P'),
(165757, 'Paxton Hollow Estates', 40.2999992370605, 0.703367675237909, -76.8055572509766, -1.34050985785855, 218, 45, 'PPL', 'P'),
(178828, 'Paxton Place', 34.1722183227539, 0.59641772244239, -112.48388671875, -1.96321417868251, 218, 5, 'PPL', 'P'),
(189201, 'Paxton Springs', 35.0391693115234, 0.611548871649839, -108.066108703613, -1.88610940669615, 218, 38, 'PPL', 'P'),
(165759, 'Paxtonia', 40.3172187805176, 0.703668212966925, -76.7947235107422, -1.34032077342115, 218, 45, 'PPL', 'P'),
(165758, 'Paxtonville', 40.7702789306641, 0.711575604296561, -77.0838928222656, -1.34536773000296, 218, 45, 'PPL', 'P'),
(82889, 'Paxville', 33.7386093139648, 0.588849817572712, -80.3574981689453, -1.40250292171341, 218, 48, 'PPL', 'P'),
(56819, 'Paydown', 38.228889465332, 0.667219990551019, -91.8036117553711, -1.6022752903538, 218, 29, 'PPL', 'P'),
(56820, 'Paydown Ford (historical)', 38.2322196960449, 0.66727811404181, -91.8116683959961, -1.60241590525935, 218, 29, 'PPL', 'P'),
(195447, 'Payette', 44.0783309936523, 0.769312004623097, -116.932777404785, -2.04086196921513, 218, 17, 'PPL', 'P'),
(195449, 'Payette Heights', 44.0719413757324, 0.76920048475245, -116.913887023926, -2.04053226987218, 218, 17, 'PPL', 'P'),
(184040, 'Paymaster Landing', 33.2458305358887, 0.580249205411328, -114.688888549805, -2.00169872064692, 218, 6, 'PPL', 'P'),
(132551, 'Payment', 46.5302810668945, 0.812106606495689, -84.1402816772461, -1.4685249488234, 218, 27, 'PPL', 'P'),
(192027, 'Payment Colonia', 29.3640003204346, 0.512498487148253, -100.930999755859, -1.76157826306934, 218, 51, 'PPL', 'P'),
(11107, 'Payne', 33.1474990844727, 0.578532997825854, -92.4308319091797, -1.61322234717262, 218, 4, 'PPL', 'P'),
(23792, 'Payne', 34.1094398498535, 0.595322031390904, -84.649169921875, -1.47740672421687, 218, 13, 'PPL', 'P'),
(37606, 'Payne', 36.6636085510254, 0.639900684877741, -88.6508331298828, -1.54724892275253, 218, 21, 'PPL', 'P'),
(76910, 'Payne', 34.9061088562012, 0.609226528600262, -97.5297164916992, -1.70221467131676, 218, 42, 'PPL', 'P'),
(96949, 'Payne', 32.851390838623, 0.573364933993473, -94.2888870239258, -1.64565152660846, 218, 51, 'PPL', 'P'),
(105111, 'Payne', 36.7147216796875, 0.64079277726389, -79.9375, -1.39517257081297, 218, 53, 'PPL', 'P'),
(117249, 'Payne', 40.6697196960449, 0.709820514559171, -95.7600021362305, -1.67132732899403, 218, 16, 'PPL', 'P'),
(137395, 'Payne', 47.0961112976074, 0.821982207028949, -92.5991668701172, -1.6161603464872, 218, 28, 'PPL', 'P'),
(157065, 'Payne', 41.0774993896484, 0.716937612835326, -84.7272186279297, -1.47876893111445, 218, 41, 'PPL', 'P'),
(187178, 'Payne', 38.8016700744629, 0.677216898071931, -107.901390075684, -1.88323452429941, 218, 7, 'PPL', 'P'),
(193853, 'Payne', 40.2430610656738, 0.702373916677146, -123.091667175293, -2.14835487397789, 218, 6, 'PPL', 'P'),
(195450, 'Payne', 43.5727806091309, 0.760488485878474, -112.05249786377, -1.95568502280669, 218, 17, 'PPL', 'P'),
(151601, 'Payne Beach', 43.3313903808594, 0.756275431612996, -77.7366714477539, -1.35676086630437, 218, 40, 'PPL', 'P'),
(89808, 'Payne Cove', 35.3230590820313, 0.616503682857931, -85.8244400024414, -1.49791905672293, 218, 50, 'PPL', 'P'),
(56822, 'Payne Ford', 38.4605598449707, 0.671263401455059, -92.4524993896484, -1.61360051604741, 218, 29, 'PPL', 'P'),
(37607, 'Payne Gap', 37.1552810668945, 0.648481989121221, -82.6594390869141, -1.44267936991835, 218, 21, 'PPL', 'P'),
(23793, 'Payne Mobile Home Park', 34.1100006103516, 0.59533181850791, -84.6500015258789, -1.47742123844481, 218, 13, 'PPL', 'P'),
(105112, 'Payne Mobile Home Park', 39.2369384765625, 0.684813764818464, -78.1183319091797, -1.36342209798093, 218, 53, 'PPL', 'P'),
(189202, 'Payne Place', 34.5666694641113, 0.603302193597327, -107.394439697266, -1.87438657105179, 218, 38, 'PPL', 'P'),
(193854, 'Payne Place', 40.2333297729492, 0.702204073578626, -121.876388549805, -2.12714426063401, 218, 6, 'PPL', 'P'),
(96950, 'Payne Springs', 32.2780609130859, 0.563358439092637, -96.0666732788086, -1.67667975015287, 218, 51, 'PPL', 'P'),
(61253, 'Paynes', 33.9208297729492, 0.592030164546484, -90.0694427490234, -1.57200833140699, 218, 30, 'PPL', 'P'),
(96951, 'Paynes', 29.6002807617188, 0.516622358806727, -95.6136093139648, -1.6687722922442, 218, 51, 'PPL', 'P'),
(105113, 'Paynes Corner', 38.3816719055176, 0.669886547171488, -77.5430603027344, -1.35338171435523, 218, 53, 'PPL', 'P'),
(157063, 'Paynes Corner', 41.2369384765625, 0.71972034985835, -80.6175003051758, -1.40704081505285, 218, 41, 'PPL', 'P'),
(192029, 'Paynes Corner', 32.7255592346191, 0.571168758200539, -102.794441223145, -1.79410145209166, 218, 51, 'PPL', 'P'),
(113896, 'Paynes Corners', 41.3786087036133, 0.722192961772434, -73.0016708374023, -1.2741195155698, 218, 8, 'PPL', 'P'),
(193855, 'Paynes Creek', 40.3355598449707, 0.703988324929952, -121.913887023926, -2.1277987324719, 218, 6, 'PPL', 'P'),
(37609, 'Paynes Depot', 38.1419410705566, 0.665702454782864, -84.6236114501953, -1.47696064473428, 218, 21, 'PPL', 'P'),
(23795, 'Paynes Mill', 32.9219398498535, 0.574596246523471, -84.3208312988281, -1.47167613418324, 218, 13, 'PPL', 'P'),
(105115, 'Paynes Mill', 37.9558296203613, 0.662454197201295, -78.2877807617188, -1.36637953837147, 218, 53, 'PPL', 'P'),
(120983, 'Paynes Point', 42.0238914489746, 0.733455270285298, -89.206672668457, -1.55695015281341, 218, 18, 'PPL', 'P'),
(89809, 'Paynes Store', 36.3886108398438, 0.635101069382172, -86.2624969482422, -1.50556459273839, 218, 50, 'PPL', 'P'),
(67641, 'Paynes Tavern', 36.3416709899902, 0.634281814451837, -79.0111083984375, -1.37900398720288, 218, 33, 'PPL', 'P'),
(17551, 'Paynes Town (historical)', 29.4166698455811, 0.513417743777521, -82.2333297729492, -1.43524235941624, 218, 12, 'PPL', 'P'),
(30790, 'Paynesville', 38.6211090087891, 0.674065512975013, -85.4933319091797, -1.49214013031552, 218, 19, 'PPL', 'P'),
(56824, 'Paynesville', 39.2625007629395, 0.685259910880079, -90.9002838134766, -1.58650924354247, 218, 29, 'PPL', 'P'),
(105116, 'Paynesville', 37.3316688537598, 0.651560536762325, -81.8908309936523, -1.42926462803345, 218, 53, 'PPL', 'P'),
(110839, 'Paynesville', 37.3313903808594, 0.651555676493336, -81.8916702270508, -1.42927927541945, 218, 58, 'PPL', 'P'),
(132553, 'Paynesville', 46.523609161377, 0.811990159777026, -89.1163864135742, -1.55537436039641, 218, 27, 'PPL', 'P'),
(137397, 'Paynesville', 45.3805618286133, 0.79204022031416, -94.711669921875, -1.6530304801988, 218, 28, 'PPL', 'P'),
(151602, 'Paynesville', 42.0094413757324, 0.733203068930067, -77.8433303833008, -1.35862241590634, 218, 40, 'PPL', 'P'),
(184042, 'Paynesville', 38.8091697692871, 0.677347792439508, -119.778327941895, -2.09052619511958, 218, 6, 'PPL', 'P'),
(128493, 'Payneton', 43.1783294677734, 0.753604014723537, -70.7283325195313, -1.2344422769112, 218, 26, 'PPL', 'P'),
(264, 'Payneville', 32.6133308410645, 0.569210003218786, -88.3466720581055, -1.54194031059362, 218, 2, 'PPL', 'P'),
(37610, 'Payneville', 37.9894409179688, 0.663040825010412, -86.3130569458008, -1.50644703116558, 218, 21, 'PPL', 'P'),
(11110, 'Payneway', 35.5430603027344, 0.620343428517607, -90.5027770996094, -1.57957144258671, 218, 4, 'PPL', 'P'),
(71245, 'Paynters Crossing', 39.3063888549805, 0.686025902588613, -75.121940612793, -1.31112520418088, 218, 37, 'PPL', 'P'),
(28207, 'Payson', 39.8169403076172, 0.694936706437964, -91.2422180175781, -1.59247712122923, 218, 18, 'PPL', 'P'),
(76912, 'Payson', 35.5502815246582, 0.620469462616195, -96.8550033569336, -1.69043870560865, 218, 42, 'PPL', 'P'),
(178829, 'Payson', 34.2308311462402, 0.597440709196117, -111.324440002441, -1.94297801598149, 218, 5, 'PPL', 'P'),
(205320, 'Payson', 40.0444412231445, 0.698907346465217, -111.731391906738, -1.95008066660873, 218, 52, 'PPL', 'P'),
(128494, 'Payson Corner', 44.2513885498047, 0.772332428773411, -69.1549987792969, -1.20698242291139, 218, 26, 'PPL', 'P'),
(125784, 'Payson Park', 42.3791694641113, 0.739656041409384, -71.1666717529297, -1.24209273977467, 218, 23, 'PPL', 'P'),
(105117, 'Paytes', 38.2272186279297, 0.667190828937082, -77.8330612182617, -1.35844318516498, 218, 53, 'PPL', 'P'),
(37611, 'Payton', 37.8022193908691, 0.659773192931912, -83.2991714477539, -1.45384480594656, 218, 21, 'PPL', 'P'),
(96952, 'Payton', 30.1136093139648, 0.525581632187917, -98.3050003051758, -1.71574592649935, 218, 51, 'PPL', 'P'),
(23794, 'Payton (historical)', 33.8063888549805, 0.590032793728925, -84.466667175293, -1.47422145039508, 218, 13, 'PPL', 'P'),
(76913, 'Payton Crossing', 34.2916717529297, 0.598502578101759, -95.8913879394531, -1.67362044385064, 218, 42, 'PPL', 'P'),
(120984, 'Paytonville', 41.336669921875, 0.721460991946826, -88.4311065673828, -1.54341397078281, 218, 18, 'PPL', 'P'),
(210868, 'PÃƒÂ¤hala', 19.2052803039551, 0.335195375072433, -155.479995727539, -2.71363784643227, 218, 15, 'PPL', 'P'),
(210872, 'PÃƒÂ¤hoa', 19.4974994659424, 0.340295561586531, -154.950836181641, -2.70440227008799, 218, 15, 'PPL', 'P'),
(210894, 'PÃƒÂ¤lehua', 21.3994407653809, 0.373490699441391, -158.103057861328, -2.75941891715128, 218, 15, 'PPL', 'P'),
(210917, 'PÃƒÂ¤paÃ‚â€˜aloa', 19.978889465332, 0.348697402062053, -155.221115112305, -2.70911952732684, 218, 15, 'PPL', 'P'),
(210926, 'PÃƒÂ¤paÃ‚â€˜i (historical)', 19.6949996948242, 0.343742590853961, -154.984436035156, -2.70498869816002, 218, 15, 'PPL', 'P'),
(210928, 'PÃƒÂ¤paÃ‚â€˜ikou', 19.788890838623, 0.345381300451714, -155.095825195313, -2.70693280575578, 218, 15, 'PPL', 'P'),
(210913, 'PÃƒÂ¤pÃƒÂ¤', 19.2091693878174, 0.335263252390717, -155.866668701172, -2.72038656295064, 218, 15, 'PPL', 'P'),
(210909, 'PÃƒÂ¤pÃƒÂ¤ Bay Estates', 19.2172203063965, 0.335403767427732, -155.87971496582, -2.72061426322384, 218, 15, 'PPL', 'P'),
(210967, 'PÃƒÂ¶hÃƒÂ¤kupu', 21.3847198486328, 0.373233770975226, -157.754165649414, -2.75332959931881, 218, 15, 'PPL', 'P'),
(211039, 'PÃƒÂ¼Ã‚â€˜ÃƒÂ¶hala Village', 21.4061107635498, 0.373607112870541, -157.802505493164, -2.75417328875215, 218, 15, 'PPL', 'P'),
(211013, 'PÃƒÂ¼koÃ‚â€˜o', 21.0766696929932, 0.367857281498033, -156.795837402344, -2.73660361609257, 218, 15, 'PPL', 'P'),
(211016, 'PÃƒÂ¼lehu', 20.7800006866455, 0.362679430548647, -156.32861328125, -2.72844901683475, 218, 15, 'PPL', 'P'),
(211043, 'PÃƒÂ¼pÃƒÂ¼kea', 21.6641693115234, 0.378111084195597, -158.053604125977, -2.75855578664199, 218, 15, 'PPL', 'P'),
(208407, 'Pe Ell', 46.5705604553223, 0.812809614444443, -123.296112060547, -2.15192311036443, 218, 56, 'PPL', 'P'),
(151603, 'Pea Brook', 41.8944396972656, 0.731195910995502, -75.1483306884766, -1.31158579789141, 218, 40, 'PPL', 'P'),
(128495, 'Pea Cove', 44.9858283996582, 0.785150822311207, -68.6941680908203, -1.19893941010324, 218, 26, 'PPL', 'P'),
(187179, 'Pea Green Corner', 38.6500015258789, 0.674569782527419, -108.094436645508, -1.88660382255253, 218, 7, 'PPL', 'P'),
(50283, 'Pea Hill', 38.3083305358887, 0.668606498793541, -75.7483291625977, -1.32205774677177, 218, 25, 'PPL', 'P'),
(67642, 'Pea Hill', 36.2700004577637, 0.633030927687827, -77.5902786254883, -1.35420582955455, 218, 33, 'PPL', 'P'),
(105123, 'Pea Hill Estates', 36.5691719055176, 0.63825245447909, -77.8625030517578, -1.35895704209731, 218, 53, 'PPL', 'P'),
(105118, 'Pea Hill Shores', 36.5805587768555, 0.638451192875438, -77.8658294677734, -1.35901509900907, 218, 53, 'PPL', 'P'),
(89810, 'Pea Point (historical)', 35.2605590820313, 0.615412852075435, -89.7344436645508, -1.56616149439178, 218, 50, 'PPL', 'P'),
(4910, 'Pea Ridge', 33.1530609130859, 0.578630070047587, -86.9277801513672, -1.51717597509113, 218, 2, 'PPL', 'P'),
(11112, 'Pea Ridge', 36.4538917541504, 0.636240436275536, -94.1149978637695, -1.64261658823021, 218, 4, 'PPL', 'P'),
(56823, 'Pea Ridge', 38.1258316040039, 0.665421291550779, -91.0419387817383, -1.58898158914045, 218, 29, 'PPL', 'P'),
(67645, 'Pea Ridge', 36.1369400024414, 0.63070858463825, -80.8658294677734, -1.4113749765689, 218, 33, 'PPL', 'P'),
(89812, 'Pea Ridge', 35.2158317565918, 0.614632212980905, -87.4661102294922, -1.52657160741693, 218, 50, 'PPL', 'P'),
(110841, 'Pea Ridge', 38.413890838623, 0.670448873635658, -82.3199996948242, -1.43675503491541, 218, 58, 'PPL', 'P'),
(128496, 'Pea Ridge', 45.422779083252, 0.792777050408758, -68.5252838134766, -1.19599182340874, 218, 26, 'PPL', 'P'),
(4912, 'Pea Ridge Crossroads', 34.6383285522461, 0.604552880624255, -85.7147216796875, -1.49600411074111, 218, 2, 'PPL', 'P'),
(28209, 'Peabody', 39.877498626709, 0.695993648495589, -89.600830078125, -1.56382949738325, 218, 18, 'PPL', 'P'),
(33595, 'Peabody', 38.1694412231445, 0.666182422990324, -97.1063919067383, -1.69482626350456, 218, 20, 'PPL', 'P'),
(37614, 'Peabody', 37.1388893127441, 0.648195899041119, -83.5908279418945, -1.45893517205413, 218, 21, 'PPL', 'P'),
(89813, 'Peabody', 36.4502792358398, 0.636177385936728, -84.0758285522461, -1.46740002957895, 218, 50, 'PPL', 'P'),
(110840, 'Peabody', 39.7024993896484, 0.692939335620404, -80.7438888549805, -1.40924671138376, 218, 58, 'PPL', 'P'),
(123399, 'Peabody', 41.0858306884766, 0.717083021430845, -85.4894409179688, -1.49207221970772, 218, 19, 'PPL', 'P'),
(125785, 'Peabody', 42.5277786254883, 0.742249760574039, -70.9291687011719, -1.23794752953796, 218, 23, 'PPL', 'P'),
(187180, 'Peabodys', 39.3480606079102, 0.686753211882314, -105.926666259766, -1.8487690918941, 218, 7, 'PPL', 'P'),
(4914, 'Peace', 33.3269386291504, 0.58166480868876, -85.4280624389648, -1.49100096315923, 218, 2, 'PPL', 'P'),
(11113, 'Peace (historical)', 34.0144386291504, 0.593663947296221, -92.1638870239258, -1.60856328000358, 218, 4, 'PPL', 'P'),
(50284, 'Peace and Plenty', 39.4124984741211, 0.687877864810654, -77.2519378662109, -1.34830066931146, 218, 25, 'PPL', 'P'),
(165760, 'Peace Church', 40.2324981689453, 0.702189559350686, -76.9563903808594, -1.34314239259609, 218, 45, 'PPL', 'P'),
(169540, 'Peace Dale', 41.4511108398438, 0.723458362764385, -71.4991683959961, -1.247895900948, 218, 47, 'PPL', 'P'),
(82890, 'Peace Haven', 32.4438896179199, 0.566252695986308, -80.7422180175781, -1.40921754976983, 218, 48, 'PPL', 'P'),
(17552, 'Peace River Shores', 27.0300006866455, 0.471762508798292, -81.9627838134766, -1.43052044164548, 218, 12, 'PPL', 'P'),
(56825, 'Peace Valley', 36.874439239502, 0.643580374555903, -91.7311096191406, -1.60100988936185, 218, 29, 'PPL', 'P'),
(96953, 'Peace Valley Harbor', 28.1297206878662, 0.49095624366963, -97.8969421386719, -1.7086239679542, 218, 51, 'PPL', 'P'),
(4915, 'Peaceburg', 33.7394409179688, 0.588864331800653, -85.9105606079102, -1.49942214484217, 218, 2, 'PPL', 'P'),
(78913, 'Peacedale', 39.7449989318848, 0.693681092563019, -75.9069366455078, -1.32482596956685, 218, 45, 'PPL', 'P'),
(89814, 'Peaceful Acres', 36.4394416809082, 0.635988234920305, -86.7152786254883, -1.51346712379903, 218, 50, 'PPL', 'P'),
(105119, 'Peaceful Beach', 37.5033302307129, 0.654556592988665, -75.954719543457, -1.32565993846221, 218, 53, 'PPL', 'P'),
(105120, 'Peaceful Beach Estates', 37.4933280944824, 0.65438202277921, -75.9569396972656, -1.32569868745607, 218, 53, 'PPL', 'P'),
(197230, 'Peaceful Haven Mobile Home Park', 47.6894416809082, 0.832337775769667, -114.082778930664, -1.9911201121649, 218, 31, 'PPL', 'P'),
(184044, 'Peaceful Pines', 38.4061088562012, 0.670313052420064, -119.788330078125, -2.09070076532904, 218, 6, 'PPL', 'P'),
(105121, 'Peaceful Shores', 37.5111083984375, 0.654692347625231, -75.9494400024414, -1.32556779308849, 218, 53, 'PPL', 'P'),
(50285, 'Peaceful Valley', 39.6958312988281, 0.692822955480768, -76.8502807617188, -1.34129043037405, 218, 25, 'PPL', 'P'),
(157064, 'Peaceful Valley', 41.5466690063477, 0.725126167397047, -83.9722213745117, -1.46559174319879, 218, 41, 'PPL', 'P'),
(165761, 'Peaceful Valley', 41.0527801513672, 0.716506180738734, -79.8300018310547, -1.39329637382501, 218, 45, 'PPL', 'P'),
(184043, 'Peaceful Valley', 37.9861106872559, 0.662982701519621, -120.317779541016, -2.09994140167939, 218, 6, 'PPL', 'P'),
(194366, 'Peaceful Valley', 40.1313896179199, 0.700424882233372, -105.497222900391, -1.84127389132218, 218, 7, 'PPL', 'P'),
(137401, 'Peaceful Valley Mobile Home Park', 45.5499992370605, 0.794997460967612, -92.9499969482422, -1.62228348646551, 218, 28, 'PPL', 'P'),
(142650, 'Peaceful Valley Mobile Homes', 41.3316688537598, 0.721373706842099, -96.0680618286133, -1.67670398491879, 218, 35, 'PPL', 'P'),
(67646, 'Peach', 36.3544387817383, 0.634504654456049, -76.5369415283203, -1.33582162907557, 218, 33, 'PPL', 'P'),
(89815, 'Peach', 35.0461082458496, 0.61166997890041, -87.2241668701172, -1.5223488991925, 218, 50, 'PPL', 'P'),
(11114, 'Peach (historical)', 36.4769401550293, 0.636642706758192, -91.5236129760742, -1.5973883897535, 218, 4, 'PPL', 'P'),
(208408, 'Peach Acres', 47.2013893127441, 0.823819655023049, -122.541107177734, -2.13874578929072, 218, 56, 'PPL', 'P'),
(42516, 'Peach Bloom', 30.3783302307129, 0.530201883784069, -92.1877822875977, -1.60898033103029, 218, 22, 'PPL', 'P'),
(50286, 'Peach Blossom Farm', 38.6150016784668, 0.673958919952382, -76.539436340332, -1.33586517175939, 218, 25, 'PPL', 'P'),
(50287, 'Peach Blossom Heights', 38.7277793884277, 0.67592726231406, -76.0652770996094, -1.32758953183003, 218, 25, 'PPL', 'P'),
(78914, 'Peach Bottom', 39.7508316040039, 0.693782891895687, -76.2261123657227, -1.33039663677702, 218, 45, 'PPL', 'P'),
(105122, 'Peach Bottom', 36.5888900756836, 0.638596601470956, -81.0669403076172, -1.41488502288562, 218, 53, 'PPL', 'P'),
(50288, 'Peach Brandy Village', 39.5013885498047, 0.68942928930368, -76.975830078125, -1.34348167931897, 218, 25, 'PPL', 'P'),
(96954, 'Peach Creek', 30.538330078125, 0.532994407924098, -96.1944427490234, -1.67890974809164, 218, 51, 'PPL', 'P'),
(112657, 'Peach Creek', 37.874439239502, 0.661033667075846, -81.9850006103516, -1.4309081979002, 218, 58, 'PPL', 'P'),
(172388, 'Peach Four Corners', 44.0663909912109, 0.769103612267798, -72.0936126708984, -1.25827091076468, 218, 55, 'PPL', 'P'),
(165762, 'Peach Glen', 40.0230598449707, 0.69853417101747, -77.2302780151367, -1.34792263359473, 218, 45, 'PPL', 'P'),
(37612, 'Peach Grove', 38.8308296203613, 0.677725828156245, -84.2908325195313, -1.47115255671293, 218, 21, 'PPL', 'P'),
(4916, 'Peach Grove (historical)', 34.3888893127441, 0.600199344611275, -86.6666717529297, -1.51261877383379, 218, 2, 'PPL', 'P'),
(105125, 'Peach Grove (historical)', 38.3880615234375, 0.669998067042135, -78.8625030517578, -1.37641033461725, 218, 53, 'PPL', 'P'),
(151604, 'Peach Lake', 41.3675003051758, 0.721999083645076, -73.5783309936523, -1.28418413396142, 218, 40, 'PPL', 'P'),
(50289, 'Peach Mill Estates', 39.4847183227539, 0.689138338954589, -76.9655609130859, -1.3433024485776, 218, 25, 'PPL', 'P'),
(11118, 'Peach Orchard', 36.2786102294922, 0.633181196552334, -90.6627807617188, -1.58236403330576, 218, 4, 'PPL', 'P'),
(17553, 'Peach Orchard', 29.5499992370605, 0.515744780648519, -82.4963912963867, -1.43983364913554, 218, 12, 'PPL', 'P'),
(37613, 'Peach Orchard', 37.9419403076172, 0.66221178296307, -82.6152801513672, -1.44190865109888, 218, 21, 'PPL', 'P'),
(50290, 'Peach Orchard', 38.7452812194824, 0.676232726891092, -76.1144409179688, -1.32844760233325, 218, 25, 'PPL', 'P'),
(56826, 'Peach Orchard', 36.3655586242676, 0.634698732320489, -89.9338912963867, -1.56964251225262, 218, 29, 'PPL', 'P'),
(89816, 'Peach Orchard', 35.1722183227539, 0.613871014962333, -84.8097229003906, -1.48020890231585, 218, 50, 'PPL', 'P'),
(50291, 'Peach Orchard Heights', 39.1022186279297, 0.682462459892033, -76.9580612182617, -1.34317155421003, 218, 25, 'PPL', 'P'),
(105124, 'Peach Orchard Inn Farms', 39.2536087036133, 0.685104715167555, -78.0430603027344, -1.3621083606152, 218, 53, 'PPL', 'P'),
(178830, 'Peach Pu', 32.0608291625977, 0.559567029806746, -112.316390991211, -1.96029082675393, 218, 5, 'PPL', 'P'),
(178831, 'Peach Springs', 35.5291709899902, 0.620101014279383, -113.42472076416, -1.97963483048977, 218, 5, 'PPL', 'P'),
(205324, 'Peach Tree Condominium', 40.8916702270508, 0.713694282101773, -111.879997253418, -1.95267431919436, 218, 52, 'PPL', 'P'),
(4918, 'Peach Tree Hills', 31.2616691589355, 0.545619056492592, -85.466667175293, -1.49167474291502, 218, 2, 'PPL', 'P'),
(96955, 'Peach Tree Village', 30.9447193145752, 0.54008723814482, -94.6130599975586, -1.65130941234434, 218, 51, 'PPL', 'P'),
(82891, 'Peach Valley Fairway Estates', 35.0305595397949, 0.611398602785331, -81.9005584716797, -1.42943440455295, 218, 48, 'PPL', 'P'),
(172386, 'Peacham', 44.3288917541504, 0.773685114870089, -72.1694412231445, -1.2595943686684, 218, 55, 'PPL', 'P'),
(172387, 'Peacham Corner', 44.3400001525879, 0.773878992997447, -72.2688903808594, -1.26133008390885, 218, 55, 'PPL', 'P'),
(50292, 'Peachblossom', 38.7369384765625, 0.676087118558492, -76.0861129760742, -1.32795318647688, 218, 25, 'PPL', 'P'),
(4919, 'Peachburg', 32.1636085510254, 0.561360868537996, -85.6241683959961, -1.4944236577922, 218, 2, 'PPL', 'P'),
(67647, 'Peachland', 34.9936103820801, 0.610753718327368, -80.2647171020508, -1.40088358661259, 218, 33, 'PPL', 'P'),
(184045, 'Peachton', 39.3805618286133, 0.687320465194501, -121.660278320313, -2.12337242558213, 218, 6, 'PPL', 'P'),
(23798, 'Peachtree', 33.9419403076172, 0.592398612883297, -84.2938919067383, -1.47120595309278, 218, 13, 'PPL', 'P'),
(67648, 'Peachtree', 35.0938911437988, 0.612503947795768, -83.9427795410156, -1.46507788626646, 218, 33, 'PPL', 'P'),
(105126, 'Peachtree', 37.3383293151855, 0.651676783743907, -79.8658294677734, -1.39392168404896, 218, 53, 'PPL', 'P'),
(82892, 'Peachtree Acres', 33.9797210693359, 0.5930580115692, -81.164436340332, -1.41658664966413, 218, 48, 'PPL', 'P'),
(23799, 'Peachtree City', 33.396671295166, 0.582881873306926, -84.595832824707, -1.47647581625783, 218, 13, 'PPL', 'P'),
(23800, 'Peachtree Corners', 33.9700012207031, 0.592888368207762, -84.2216720581055, -1.46994547894885, 218, 13, 'PPL', 'P'),
(76914, 'Peachtree Crossing', 34.686939239502, 0.605401297168527, -98.3813934326172, -1.7170792380991, 218, 42, 'PPL', 'P'),
(23801, 'Peachtree Estates', 32.5652809143066, 0.56837137379152, -83.6416702270508, -1.45982253732935, 218, 13, 'PPL', 'P'),
(23802, 'Peachtree Forest', 33.9652786254883, 0.592805943372025, -84.2444381713867, -1.47034282258349, 218, 13, 'PPL', 'P'),
(82893, 'Peachtree Gardens', 35.0044403076172, 0.610942736185737, -81.9888916015625, -1.43097610850799, 218, 48, 'PPL', 'P'),
(82894, 'Peachtree Landing', 33.6944389343262, 0.588078899016161, -79.0486068725586, -1.37965845904077, 218, 48, 'PPL', 'P'),
(23804, 'Peachtree Park (historical)', 33.8438911437988, 0.590687332145839, -84.3597183227539, -1.47235484078704, 218, 13, 'PPL', 'P'),
(23805, 'Peachtree Station', 33.9791717529297, 0.593048424189276, -84.23388671875, -1.47015866499411, 218, 13, 'PPL', 'P'),
(23806, 'Peachtree Villas', 33.3958282470703, 0.582867159341903, -84.583610534668, -1.47626249705452, 218, 13, 'PPL', 'P'),
(23807, 'Peachtree Walk', 33.3861083984375, 0.582697515980465, -84.5577774047852, -1.47581162388197, 218, 13, 'PPL', 'P'),
(4920, 'Peacock', 31.7572193145752, 0.554268038317274, -87.7747192382813, -1.53195785072162, 218, 2, 'PPL', 'P'),
(105128, 'Peacock', 38.9736099243164, 0.680217814567259, -77.2536087036133, -1.3483298309254, 218, 53, 'PPL', 'P'),
(132554, 'Peacock', 44.0461082458496, 0.7687496115799, -85.8886108398438, -1.49903904911937, 218, 27, 'PPL', 'P'),
(192028, 'Peacock', 33.1822204589844, 0.579139000131901, -100.398887634277, -1.75229115455796, 218, 51, 'PPL', 'P'),
(4921, 'Peacock (historical)', 31.5972194671631, 0.551475514177244, -86.2125015258789, -1.50469200800722, 218, 2, 'PPL', 'P'),
(73853, 'Peacock Acres', 39.8594398498535, 0.695678463380578, -83.8402786254883, -1.4632889078042, 218, 41, 'PPL', 'P'),
(50293, 'Peacock Corners', 39.2550010681152, 0.685129016512502, -75.8125, -1.3231777391682, 218, 25, 'PPL', 'P'),
(67651, 'Peacock Crossroads', 35.4963912963867, 0.619528900698207, -78.0341720581055, -1.3619532314817, 218, 33, 'PPL', 'P'),
(105129, 'Peacock Hill', 38.0374984741211, 0.663879587595732, -78.6430587768555, -1.37258030949555, 218, 53, 'PPL', 'P'),
(50294, 'Peacock Manor', 38.3430595397949, 0.669212634257643, -76.523063659668, -1.33557941457443, 218, 25, 'PPL', 'P'),
(178832, 'Peacock Village', 33.6458282470703, 0.587230482471889, -112.238891601563, -1.95893820723628, 218, 5, 'PPL', 'P'),
(67649, 'Peacocks', 34.3266716003418, 0.599113440676795, -78.7997207641602, -1.37531457698674, 218, 33, 'PPL', 'P'),
(23811, 'Peacocks Crossing', 32.8702812194824, 0.573694633336425, -82.7558288574219, -1.44436168877895, 218, 13, 'PPL', 'P'),
(67650, 'Peacocks Crossroads', 35.3199996948242, 0.616450286478075, -78.4552764892578, -1.36930289030005, 218, 33, 'PPL', 'P'),
(17554, 'Peaden', 30.9083309173584, 0.539452140803863, -86.5830612182617, -1.51115949471448, 218, 12, 'PPL', 'P'),
(96956, 'Peadenville', 32.920280456543, 0.574567284646617, -98.0744400024414, -1.71172189009224, 218, 51, 'PPL', 'P'),
(71246, 'Peahala Park', 39.6019401550293, 0.691184245883015, -74.2119369506836, -1.29524264407187, 218, 37, 'PPL', 'P'),
(210951, 'Peahi', 20.9166698455811, 0.365064757358003, -156.283325195313, -2.72765859062321, 218, 15, 'PPL', 'P'),
(11115, 'Peak', 34.4883308410645, 0.60193492669368, -93.3947219848633, -1.6300454026206, 218, 4, 'PPL', 'P'),
(37617, 'Peak', 38.1752815246582, 0.666284355481046, -84.6097183227539, -1.47671816391703, 218, 21, 'PPL', 'P'),
(82895, 'Peak', 34.2405586242676, 0.597610485715609, -81.3236083984375, -1.41936472615525, 218, 48, 'PPL', 'P'),
(89819, 'Peak', 36.0636100769043, 0.629428735997385, -84.1213912963867, -1.46819524948045, 218, 50, 'PPL', 'P'),
(140675, 'Peak', 46.9322204589844, 0.819121772281122, -97.9127807617188, -1.70890040407535, 218, 34, 'PPL', 'P'),
(201380, 'Peak (historical)', 44.5472183227539, 0.777495632336802, -123.543609619141, -2.15624275765254, 218, 43, 'PPL', 'P'),
(193856, 'Peak Eight', 41.5505599975586, 0.725194078004844, -123.775001525879, -2.16028130828759, 218, 6, 'PPL', 'P'),
(89818, 'Peakland', 35.628059387207, 0.621826942402836, -84.7630615234375, -1.47939450765451, 218, 50, 'PPL', 'P'),
(105130, 'Peakland', 37.4444389343262, 0.653528745965948, -79.2055587768555, -1.38239778653802, 218, 53, 'PPL', 'P'),
(105131, 'Peaks', 37.7230606079102, 0.658391611537406, -77.3891677856445, -1.35069578323783, 218, 53, 'PPL', 'P'),
(197231, 'Peaks and Pines Park', 45.9708290100098, 0.802342326095996, -114.142501831055, -1.99216247341556, 218, 31, 'PPL', 'P'),
(128498, 'Peaks Island', 43.6569404602051, 0.761957352377707, -70.1966705322266, -1.22516302472503, 218, 26, 'PPL', 'P'),
(37615, 'Peaks Mill', 38.2983283996582, 0.668431928584086, -84.8125, -1.48025737184769, 218, 21, 'PPL', 'P'),
(105133, 'Peaks Store', 37.0505599975586, 0.6466542616651, -82.5991668701172, -1.44162742128776, 218, 53, 'PPL', 'P'),
(105134, 'Peaksville', 37.4088897705078, 0.652908296010987, -79.5455627441406, -1.38833197523699, 218, 53, 'PPL', 'P'),
(139387, 'Peaksville', 40.5069389343262, 0.706979454308275, -91.6969375610352, -1.60041347443572, 218, 29, 'PPL', 'P'),
(151606, 'Peakville', 41.9805603027344, 0.732698999114742, -75.0972213745117, -1.31069377208429, 218, 40, 'PPL', 'P'),
(105135, 'Peakwood Hills', 37.235279083252, 0.649878217901722, -79.9611129760742, -1.39558469499166, 218, 53, 'PPL', 'P'),
(165763, 'Peale', 40.9977798461914, 0.715546244323814, -78.081672668457, -1.36278227352904, 218, 45, 'PPL', 'P'),
(165764, 'Pealertown', 41.1180610656738, 0.717645547632097, -76.3630599975586, -1.33278682385537, 218, 45, 'PPL', 'P'),
(105136, 'Peales Crossroads', 38.3925018310547, 0.670075565029856, -78.8105621337891, -1.37550379458219, 218, 53, 'PPL', 'P'),
(50295, 'Pealiquor Landing', 38.8549995422363, 0.678147672872913, -75.8455581665039, -1.32375471301837, 218, 25, 'PPL', 'P'),
(11116, 'Peanut', 35.6752815246582, 0.622651124181188, -93.704719543457, -1.6354558806912, 218, 4, 'PPL', 'P'),
(165766, 'Peanut', 40.3358306884766, 0.703993052040887, -79.315559387207, -1.38431765936786, 218, 45, 'PPL', 'P'),
(193857, 'Peanut', 40.4680595397949, 0.706300880862523, -123.167503356934, -2.14967846503966, 218, 6, 'PPL', 'P'),
(146013, 'Peapack', 40.7166709899902, 0.710639969226589, -74.6569366455078, -1.30300935391692, 218, 37, 'PPL', 'P'),
(105137, 'Peapatch', 37.2838897705078, 0.650726634445994, -81.7886123657227, -1.42748057641921, 218, 53, 'PPL', 'P'),
(110842, 'Peapatch', 37.2841682434082, 0.650731494714984, -81.7897186279297, -1.42749988433711, 218, 58, 'PPL', 'P'),
(110843, 'Pear (historical)', 37.8008308410645, 0.659748958165992, -80.9694366455078, -1.41318326294906, 218, 58, 'PPL', 'P'),
(187181, 'Pear Park', 39.0702781677246, 0.681904993696852, -108.471389770508, -1.89318289570946, 218, 7, 'PPL', 'P'),
(96957, 'Pear Ridge', 29.9200000762939, 0.522202513528284, -93.9377822875977, -1.63952359294019, 218, 51, 'PPL', 'P'),
(50296, 'Pear Tree Point', 39.2227783203125, 0.684566623469304, -76.0227813720703, -1.32684784146644, 218, 25, 'PPL', 'P'),
(96958, 'Pear Valley', 31.3099994659424, 0.546462579478361, -99.4936065673828, -1.73649101928468, 218, 51, 'PPL', 'P'),
(184046, 'Pearblossom', 34.5063896179199, 0.602250111808691, -117.908889770508, -2.05789834386642, 218, 6, 'PPL', 'P'),
(4922, 'Pearce', 31.2586097717285, 0.545565660112736, -85.2261123657227, -1.48747626945651, 218, 2, 'PPL', 'P'),
(177639, 'Pearce', 31.9050006866455, 0.556847309833016, -109.819999694824, -1.91672057921385, 218, 5, 'PPL', 'P'),
(61254, 'Pearce (historical)', 32.8911094665527, 0.574058154825221, -90.3444366455078, -1.57680788032353, 218, 30, 'PPL', 'P'),
(67653, 'Pearces', 35.916389465332, 0.62685925159865, -78.3072204589844, -1.36671882509434, 218, 33, 'PPL', 'P'),
(4925, 'Pearces Mills', 34.1208305358887, 0.595520836366279, -87.836669921875, -1.53303909412419, 218, 2, 'PPL', 'P'),
(105138, 'Pearch', 37.5044403076172, 0.654575967485595, -79.2788925170898, -1.38367770175791, 218, 53, 'PPL', 'P'),
(11117, 'Pearcy', 34.4286117553711, 0.60089263202205, -93.2897186279297, -1.62821274831646, 218, 4, 'PPL', 'P'),
(184047, 'Peardale', 39.1911087036133, 0.684013884385058, -120.998893737793, -2.11182908699524, 218, 6, 'PPL', 'P'),
(82896, 'Pearidge', 34.8191719055176, 0.60770919256919, -82.7777786254883, -1.44474478450176, 218, 48, 'PPL', 'P'),
(105139, 'Pearisburg', 37.3263893127441, 0.651468391388609, -80.7352828979492, -1.40909650909828, 218, 53, 'PPL', 'P'),
(23809, 'Pearl', 34.9588890075684, 0.610147716021321, -84.1549987792969, -1.46878181071054, 218, 13, 'PPL', 'P'),
(28210, 'Pearl', 39.4597206115723, 0.688702046589006, -90.6258316040039, -1.5817191488478, 218, 18, 'PPL', 'P'),
(33598, 'Pearl', 38.8516693115234, 0.678089549382123, -97.0438919067383, -1.69373543272206, 218, 20, 'PPL', 'P'),
(37616, 'Pearl', 36.6313896179199, 0.63933835841357, -83.9466705322266, -1.46514579687425, 218, 21, 'PPL', 'P'),
(42518, 'Pearl', 30.9047203063965, 0.539389123754569, -92.620002746582, -1.61652400113405, 218, 22, 'PPL', 'P'),
(56827, 'Pearl', 37.3516693115234, 0.651909610602208, -93.4863891601563, -1.63164529664546, 218, 29, 'PPL', 'P'),
(61256, 'Pearl', 32.0019416809082, 0.558539249363057, -90.1988906860352, -1.57426762411776, 218, 30, 'PPL', 'P'),
(96959, 'Pearl', 31.4099998474121, 0.548207915388258, -98.0347213745117, -1.71102866926049, 218, 51, 'PPL', 'P'),
(132557, 'Pearl', 42.5419387817383, 0.742496901923198, -86.0927810668945, -1.50260249181595, 218, 27, 'PPL', 'P'),
(157066, 'Pearl', 40.3686103820801, 0.704565165622064, -81.7266693115234, -1.42639946617469, 218, 41, 'PPL', 'P'),
(165767, 'Pearl', 41.2752799987793, 0.72038953566126, -79.9222183227539, -1.3949058552298, 218, 45, 'PPL', 'P'),
(172390, 'Pearl', 44.6875, 0.779944009484966, -73.3272171020508, -1.27980136975548, 218, 55, 'PPL', 'P'),
(194367, 'Pearl', 40.985279083252, 0.71532806485151, -106.54638671875, -1.85958525434535, 218, 7, 'PPL', 'P'),
(195451, 'Pearl', 43.8558311462402, 0.765428649700571, -116.316390991211, -2.0301039968337, 218, 17, 'PPL', 'P'),
(208409, 'Pearl', 46.5844383239746, 0.813051828945586, -119.565277099609, -2.08680775644756, 218, 56, 'PPL', 'P'),
(132559, 'Pearl Beach', 42.6266708374023, 0.743975755276519, -82.5977783203125, -1.44160318652184, 218, 27, 'PPL', 'P'),
(89822, 'Pearl City', 35.1366691589355, 0.613250565007372, -86.6966705322266, -1.5131423513041, 218, 50, 'PPL', 'P'),
(96960, 'Pearl City', 29.3141708374023, 0.511628798604774, -97.2436065673828, -1.69722111111481, 218, 51, 'PPL', 'P'),
(120987, 'Pearl City', 42.2652816772461, 0.737668324550776, -89.8258285522461, -1.56775646156863, 218, 18, 'PPL', 'P'),
(139386, 'Pearl City', 40.5811080932617, 0.708273950335135, -92.897216796875, -1.62136229904445, 218, 29, 'PPL', 'P'),
(210952, 'Pearl City', 21.3972206115723, 0.373451950447531, -157.973327636719, -2.75715469759249, 218, 15, 'PPL', 'P'),
(17555, 'Pearl Court', 30.374439239502, 0.530133973176272, -81.6452789306641, -1.42497893604924, 218, 12, 'PPL', 'P'),
(151605, 'Pearl Creek', 42.8486099243164, 0.74784932308204, -78.0472183227539, -1.3621809317549, 218, 40, 'PPL', 'P'),
(171046, 'Pearl Creek Colony', 44.3286094665527, 0.773680188022072, -97.913330078125, -1.70890999145528, 218, 49, 'PPL', 'P'),
(50301, 'Pearl Estates', 39.6875, 0.69267754688525, -75.9861068725586, -1.32620775069844, 218, 25, 'PPL', 'P'),
(132560, 'Pearl Grange', 42.0911102294922, 0.734628459324505, -86.35888671875, -1.50724691159899, 218, 27, 'PPL', 'P'),
(61257, 'Pearl Hill', 32.788890838623, 0.572274103210977, -89.404167175293, -1.5603970822123, 218, 30, 'PPL', 'P'),
(42519, 'Pearl River', 30.3758296966553, 0.530158241231705, -89.7483291625977, -1.56640384205097, 218, 22, 'PPL', 'P'),
(61258, 'Pearl River', 32.7833290100098, 0.572177030989243, -89.227783203125, -1.55731860115022, 218, 30, 'PPL', 'P'),
(151607, 'Pearl River', 41.0588912963867, 0.716612840340391, -74.022216796875, -1.29193140273052, 218, 40, 'PPL', 'P'),
(96961, 'Pearland', 29.5633296966553, 0.515977441059251, -95.2858276367188, -1.66305142274855, 218, 51, 'PPL', 'P'),
(184048, 'Pearland', 34.5611114501953, 0.60320518795462, -118.039436340332, -2.06017681133704, 218, 6, 'PPL', 'P'),
(89820, 'Pearley (historical)', 35.292781829834, 0.615975245118632, -89.8466720581055, -1.56812024937353, 218, 50, 'PPL', 'P'),
(132561, 'Pearline', 42.9722213745117, 0.750006749881113, -85.9241714477539, -1.49965969881141, 218, 27, 'PPL', 'P'),
(61261, 'Pearlington', 30.2463893890381, 0.527899081678991, -89.6111068725586, -1.56400886128267, 218, 30, 'PPL', 'P'),
(132562, 'Pearll City', 44.9819412231445, 0.785082978282437, -84.6836090087891, -1.4780077996749, 218, 27, 'PPL', 'P'),
(144296, 'Pearls Corner', 43.3422203063965, 0.756464449471364, -71.4688873291016, -1.24736739662968, 218, 36, 'PPL', 'P'),
(105140, 'Pearly', 37.274169921875, 0.650556991084556, -82.1436080932617, -1.43367642069528, 218, 53, 'PPL', 'P'),
(37618, 'Pearman', 37.374439239502, 0.652307020815875, -86.1086120605469, -1.50287879477904, 218, 21, 'PPL', 'P'),
(197232, 'Pearmond (historical)', 48.0074996948242, 0.837888935324856, -105.857780456543, -1.84756680781998, 218, 31, 'PPL', 'P'),
(50297, 'Pearre', 39.6363906860352, 0.691785521078128, -78.3227767944336, -1.36699033436748, 218, 25, 'PPL', 'P'),
(96962, 'Pearsall', 28.891939163208, 0.504259465683875, -99.0947189331055, -1.72952911672105, 218, 51, 'PPL', 'P'),
(96963, 'Pearsall East Colonia', 28.8920001983643, 0.504260530948311, -99.0699996948242, -1.72909768462446, 218, 51, 'PPL', 'P'),
(4924, 'Pearson', 33.0247192382813, 0.576390085254722, -87.3183288574219, -1.52399233590119, 218, 2, 'PPL', 'P'),
(11119, 'Pearson', 35.440559387207, 0.618554450055347, -92.1277770996094, -1.60793304293162, 218, 4, 'PPL', 'P'),
(23810, 'Pearson', 31.2975006103516, 0.54624443329557, -82.8525009155273, -1.44604893448757, 218, 13, 'PPL', 'P'),
(61262, 'Pearson', 32.2466697692871, 0.56281056027738, -90.1230621337891, -1.57294416621405, 218, 30, 'PPL', 'P'),
(76915, 'Pearson', 35.0727806091309, 0.612135499458956, -96.9175033569336, -1.69152953639115, 218, 42, 'PPL', 'P'),
(96964, 'Pearson', 29.271110534668, 0.510877254545154, -98.8691711425781, -1.72559256515575, 218, 51, 'PPL', 'P'),
(175772, 'Pearson', 45.3641700744629, 0.791754130234059, -89.0163879394531, -1.55362905777603, 218, 57, 'PPL', 'P'),
(184050, 'Pearson', 39.061939239502, 0.681759451943279, -121.576393127441, -2.12190835277286, 218, 6, 'PPL', 'P'),
(195452, 'Pearson', 47.3544387817383, 0.826490872175425, -115.728889465332, -2.01985016084662, 218, 17, 'PPL', 'P'),
(208410, 'Pearson', 47.7122192382813, 0.832735319141389, -122.643058776855, -2.14052518037306, 218, 56, 'PPL', 'P'),
(50298, 'Pearson (historical)', 38.2930603027344, 0.668339982947451, -76.4319381713867, -1.33398897477143, 218, 25, 'PPL', 'P'),
(89821, 'Pearson (historical)', 35.7094383239746, 0.623247272791203, -85.1849975585938, -1.48675868070079, 218, 50, 'PPL', 'P'),
(4926, 'Pearson Chapel', 32.9861106872559, 0.575716238919904, -85.9824981689453, -1.50067769213809, 218, 2, 'PPL', 'P'),
(208411, 'Pearson Eddy', 47.792781829834, 0.834141401617923, -121.996673583984, -2.12924363052132, 218, 56, 'PPL', 'P'),
(14373, 'Pearson Grove', 39.228889465332, 0.684673283070962, -75.7536087036133, -1.32214989214549, 218, 10, 'PPL', 'P'),
(76916, 'Pearsonia', 36.8016700744629, 0.642310313032044, -96.4505615234375, -1.68337986398134, 218, 42, 'PPL', 'P'),
(73850, 'Pearsons (historical)', 39.5938911437988, 0.691043764135513, -83.6602783203125, -1.46014730982428, 218, 41, 'PPL', 'P'),
(96965, 'Pearsons Chapel', 31.1515502929688, 0.543697119712909, -95.5432586669922, -1.66754444182362, 218, 51, 'PPL', 'P'),
(14374, 'Pearsons Corner', 39.1538887023926, 0.683364272816161, -75.6500015258789, -1.32034160576532, 218, 10, 'PPL', 'P'),
(105141, 'Pearsons Corner', 37.6763916015625, 0.657577083718005, -77.3808288574219, -1.35055024148425, 218, 53, 'PPL', 'P'),
(171049, 'Pearsons Corner', 43.1694412231445, 0.75344888559004, -97.3180618286133, -1.69852060056872, 218, 49, 'PPL', 'P'),
(30791, 'Pearsontown', 38.4208297729492, 0.670569980886229, -86.3916702270508, -1.50781909175919, 218, 19, 'PPL', 'P'),
(184051, 'Pearsonville', 35.8097190856934, 0.624997502259603, -117.872222900391, -2.05725838625648, 218, 6, 'PPL', 'P'),
(184052, 'Peart (historical)', 38.7172203063965, 0.675742971566626, -121.758331298828, -2.12508377289861, 218, 6, 'PPL', 'P'),
(105142, 'Peary', 37.371940612793, 0.652263411553025, -76.2797164916992, -1.33133220526797, 218, 53, 'PPL', 'P'),
(137402, 'Peary', 47.371940612793, 0.826796336752458, -92.5561065673828, -1.61540880242758, 218, 28, 'PPL', 'P'),
(96966, 'Peary Place', 27.6788902282715, 0.483087767781422, -97.3244400024414, -1.69863192070228, 218, 51, 'PPL', 'P'),
(151608, 'Peas Eddy', 41.9458312988281, 0.73209286365064, -75.2313919067383, -1.3130354896308, 218, 40, 'PPL', 'P'),
(56828, 'Pease', 37.4947204589844, 0.654406324124157, -92.6324996948242, -1.61674211402733, 218, 29, 'PPL', 'P'),
(137403, 'Pease', 45.6980590820313, 0.797581592752343, -93.6477813720703, -1.63446212213044, 218, 28, 'PPL', 'P'),
(184053, 'Pease (historical)', 39.1719398498535, 0.683679324773117, -121.661109924316, -2.12338693981007, 218, 6, 'PPL', 'P'),
(128500, 'Pease Corner', 44.8022193908691, 0.781946240571515, -69.9558334350586, -1.22095962441851, 218, 26, 'PPL', 'P'),
(157067, 'Pease Mill (historical)', 41.6688919067383, 0.727259359430201, -81.1838912963867, -1.41692620270312, 218, 41, 'PPL', 'P'),
(151610, 'Peasleeville', 44.600830078125, 0.778431333985801, -73.6736068725586, -1.28584701174607, 218, 40, 'PPL', 'P'),
(42520, 'Peason', 31.413610458374, 0.548270932437552, -93.2944412231445, -1.6282951731522, 218, 22, 'PPL', 'P'),
(96967, 'Peaster', 32.871940612793, 0.57372359521328, -97.8663864135742, -1.70809066994592, 218, 51, 'PPL', 'P'),
(37619, 'Peasticks', 38.1561088562012, 0.665949729290078, -83.6988906860352, -1.46082122273813, 218, 21, 'PPL', 'P'),
(151609, 'Peat Corners', 43.3383293151855, 0.756396538863567, -76.2302780151367, -1.33046934107478, 218, 40, 'PPL', 'P'),
(105143, 'Peatross', 37.9172210693359, 0.661780350866477, -77.3852767944336, -1.35062787263003, 218, 53, 'PPL', 'P'),
(132563, 'Peatville', 43.6377792358398, 0.76162292592382, -82.817497253418, -1.4454380053335, 218, 27, 'PPL', 'P'),
(195454, 'Peavey', 42.583610534668, 0.743224211216899, -114.65193939209, -2.00105383618895, 218, 17, 'PPL', 'P'),
(4928, 'Peaveys Landing Boat Ramp', 31.6058292388916, 0.551625783041752, -88.081672668457, -1.53731519872848, 218, 2, 'PPL', 'P'),
(76917, 'Peavine', 35.889720916748, 0.626393797619131, -94.6138916015625, -1.65132392657228, 218, 42, 'PPL', 'P'),
(89824, 'Peavine', 36.0255584716797, 0.628764610200547, -84.8963928222656, -1.48172157781502, 218, 50, 'PPL', 'P'),
(192908, 'Peavine', 39.6777801513672, 0.692507903523812, -120.005561828613, -2.09449217461493, 218, 6, 'PPL', 'P'),
(190598, 'Peavine (historical)', 38.5697212219238, 0.673168626898901, -117.268890380859, -2.0467282473063, 218, 39, 'PPL', 'P'),
(4929, 'Peavy', 33.1430587768555, 0.578455499838132, -85.4541702270508, -1.49145663002175, 218, 2, 'PPL', 'P'),
(96968, 'Peavy', 31.2950000762939, 0.546200790743206, -94.8105621337891, -1.65475647490128, 218, 51, 'PPL', 'P'),
(4930, 'Pebble', 34.2863883972168, 0.598410366149015, -87.54638671875, -1.52797269646642, 218, 2, 'PPL', 'P'),
(37620, 'Pebble', 38.2688903808594, 0.667918138230783, -83.7566680908203, -1.46182962868489, 218, 21, 'PPL', 'P'),
(195453, 'Pebble', 42.7441711425781, 0.746026522473935, -111.999717712402, -1.95476383538563, 218, 17, 'PPL', 'P'),
(71247, 'Pebble Beach', 39.7652816772461, 0.694035093250917, -74.1972198486328, -1.29498578218473, 218, 37, 'PPL', 'P'),
(82897, 'Pebble Beach', 33.6549987792969, 0.587390538453403, -78.9222183227539, -1.37745256270985, 218, 48, 'PPL', 'P'),
(120988, 'Pebble Beach', 41.3394393920898, 0.721509328320611, -88.4000015258789, -1.5428710853946, 218, 18, 'PPL', 'P'),
(151611, 'Pebble Beach', 42.832218170166, 0.747563233001938, -77.7080612182617, -1.35626152359998, 218, 40, 'PPL', 'P'),
(184054, 'Pebble Beach', 36.5663909912109, 0.638203918368224, -121.945556640625, -2.12835147155614, 218, 6, 'PPL', 'P'),
(208412, 'Pebble Beach', 48.0666694641113, 0.838921642616561, -122.386108398438, -2.13604055025542, 218, 56, 'PPL', 'P'),
(96969, 'Pebble Beach Sunset Acres', 33.083610534668, 0.577417932277438, -96.4505615234375, -1.68337986398134, 218, 51, 'PPL', 'P'),
(23812, 'Pebble Brook', 34.121940612793, 0.595540210863209, -83.9763870239258, -1.46566444749655, 218, 13, 'PPL', 'P'),
(23813, 'Pebble City', 31.2474994659424, 0.545371748695864, -84.0777816772461, -1.4674341180409, 218, 13, 'PPL', 'P'),
(17556, 'Pebble Creek', 28.1480598449707, 0.491276322343143, -82.345832824707, -1.43720590808796, 218, 12, 'PPL', 'P'),
(23814, 'Pebble Creek', 33.8849983215332, 0.591404787743507, -84.1875, -1.46934906402273, 218, 13, 'PPL', 'P'),
(82898, 'Pebble Creek', 34.9297218322754, 0.609638652778952, -82.3461074829102, -1.43721070177792, 218, 48, 'PPL', 'P'),
(4931, 'Pebble Hill', 31.9388904571533, 0.557438797911122, -87.3433303833008, -1.5244286948458, 218, 2, 'PPL', 'P'),
(23815, 'Pebble Hill', 30.9172191619873, 0.539607269937361, -83.5780563354492, -1.4587122654709, 218, 13, 'PPL', 'P'),
(89826, 'Pebble Hill', 35.0991706848145, 0.612596093169485, -88.4250030517578, -1.54330744433921, 218, 50, 'PPL', 'P'),
(105144, 'Pebble Spring', 37.4302787780762, 0.653281604616789, -77.4747161865234, -1.35218888450298, 218, 53, 'PPL', 'P'),
(205330, 'Pebble Springs Estates', 40.6138916015625, 0.708846130495339, -111.852500915527, -1.95219441756592, 218, 52, 'PPL', 'P'),
(175773, 'Pebble Valley', 43.225830078125, 0.754433056770879, -89.2286071777344, -1.55733298222011, 218, 57, 'PPL', 'P'),
(23817, 'Pebblebrook', 31.4769401550293, 0.549376244158476, -83.5672225952148, -1.4585231810335, 218, 13, 'PPL', 'P'),
(82899, 'Pebblebrook', 34.9063911437988, 0.609231455448279, -81.9961090087891, -1.43110207602755, 218, 48, 'PPL', 'P'),
(105145, 'Pebblebrook', 37.6741714477539, 0.657538334724145, -77.3249969482422, -1.34957579084139, 218, 53, 'PPL', 'P'),
(23818, 'Pebblebrook Estates', 33.8205604553223, 0.590280134815166, -84.5274963378906, -1.47528311956364, 218, 13, 'PPL', 'P'),
(17557, 'Pebbledale', 27.8419399261475, 0.48593352185374, -81.9433288574219, -1.43018088860649, 218, 12, 'PPL', 'P'),
(23819, 'Pebblewood', 30.8736095428467, 0.538846138497816, -83.3088912963867, -1.454014449308, 218, 13, 'PPL', 'P'),
(37621, 'Pebworth', 37.5041694641113, 0.65457124037466, -83.7311096191406, -1.4613835492023, 218, 21, 'PPL', 'P'),
(17558, 'Pecan', 29.6838893890381, 0.518081604636523, -81.6561126708984, -1.42516802048664, 218, 12, 'PPL', 'P'),
(23820, 'Pecan', 31.6405601501465, 0.552231951795368, -84.9922180175781, -1.48339404297959, 218, 13, 'PPL', 'P'),
(61263, 'Pecan', 30.4433307647705, 0.531336357118929, -88.4291687011719, -1.54338014863697, 218, 30, 'PPL', 'P'),
(165768, 'Pecan', 41.3355598449707, 0.721441617449896, -79.8852767944336, -1.39426110392989, 218, 45, 'PPL', 'P'),
(50299, 'Pecan Acres', 38.3680610656738, 0.669648993202253, -75.6211090087891, -1.31983733621291, 218, 25, 'PPL', 'P'),
(82900, 'Pecan Acres', 34.0144386291504, 0.593663947296221, -80.4519424438477, -1.40415128527011, 218, 48, 'PPL', 'P'),
(96970, 'Pecan Acres', 32.9700012207031, 0.575435075687819, -97.4744415283203, -1.70124994121188, 218, 51, 'PPL', 'P'),
(42521, 'Pecan Bayou', 32.5694389343262, 0.568443944931225, -92.0597229003906, -1.60674527308544, 218, 22, 'PPL', 'P'),
(23821, 'Pecan City', 31.5174999237061, 0.550084145665732, -84.0699996948242, -1.46729829682531, 218, 13, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(42522, 'Pecan Cove', 30.3541698455811, 0.529780205514968, -90.9888916015625, -1.58805574118748, 218, 22, 'PPL', 'P'),
(42523, 'Pecan Creek', 30.351390838623, 0.529731702693615, -90.9944381713867, -1.58815254709311, 218, 22, 'PPL', 'P'),
(192030, 'Pecan Crossing', 32.1666717529297, 0.561414331496879, -100.834167480469, -1.75988822104157, 218, 51, 'PPL', 'P'),
(96971, 'Pecan Estates Number 5 Colonia', 26.2169990539551, 0.457572953483755, -98.1070022583008, -1.71229020866886, 218, 51, 'PPL', 'P'),
(96976, 'Pecan Gap', 33.436939239502, 0.583584681518598, -95.8463897705078, -1.67283507764517, 218, 51, 'PPL', 'P'),
(105146, 'Pecan Gardens', 36.8180618286133, 0.642596403112146, -76.0961074829102, -1.32812762352828, 218, 53, 'PPL', 'P'),
(11121, 'Pecan Grove', 34.7730598449707, 0.606904385287768, -92.206672668457, -1.60931003037324, 218, 4, 'PPL', 'P'),
(61266, 'Pecan Grove', 31.5977802276611, 0.55148530129425, -89.1372222900391, -1.55573801504326, 218, 30, 'PPL', 'P'),
(82902, 'Pecan Grove', 34.2027816772461, 0.596951153608733, -80.6680603027344, -1.40792325348005, 218, 48, 'PPL', 'P'),
(96972, 'Pecan Grove', 29.6258296966553, 0.517068271841747, -95.7313919067383, -1.67082798628964, 218, 51, 'PPL', 'P'),
(42524, 'Pecan Grove (historical)', 29.9447193145752, 0.522633945624877, -90.3463897705078, -1.57684196878549, 218, 22, 'PPL', 'P'),
(96973, 'Pecan Grove (historical)', 31.3950004577637, 0.547946126653103, -97.5950012207031, -1.70335410478915, 218, 51, 'PPL', 'P'),
(178833, 'Pecan Grove Trailer Park', 33.4877815246582, 0.584472046793812, -112.115829467773, -1.95679036781713, 218, 5, 'PPL', 'P'),
(96974, 'Pecan Heights', 33.0019416809082, 0.575992541883, -94.9419403076172, -1.65704945659984, 218, 51, 'PPL', 'P'),
(96975, 'Pecan Hill', 32.4863891601563, 0.566994452928922, -96.7855606079102, -1.68922670099656, 218, 51, 'PPL', 'P'),
(42526, 'Pecan Island', 29.646390914917, 0.517427132798636, -92.4530563354492, -1.61361023658539, 218, 22, 'PPL', 'P'),
(42527, 'Pecan Landing', 32.1025009155273, 0.560294339100446, -91.413330078125, -1.59546359007565, 218, 22, 'PPL', 'P'),
(192032, 'Pecan Mott', 31.6936092376709, 0.553157833037847, -100.441108703613, -1.75302805123159, 218, 51, 'PPL', 'P'),
(82904, 'Pecan Orchard', 34.2008285522461, 0.59691706514678, -80.6722183227539, -1.40799582461975, 218, 48, 'PPL', 'P'),
(17559, 'Pecan Park', 30.5116691589355, 0.532529087102634, -81.6227798461914, -1.42458625294651, 218, 12, 'PPL', 'P'),
(42528, 'Pecan Park', 32.4916687011719, 0.567086598302639, -93.6841735839844, -1.63509728605042, 218, 22, 'PPL', 'P'),
(96977, 'Pecan Park', 29.7077808380127, 0.518498589084202, -95.2897186279297, -1.66311933335635, 218, 51, 'PPL', 'P'),
(96979, 'Pecan Plantation', 32.360279083252, 0.564793416866999, -97.6752777099609, -1.70475519383865, 218, 51, 'PPL', 'P'),
(11123, 'Pecan Point', 35.4775009155273, 0.619199201355255, -90.0391693115234, -1.57147996024672, 218, 4, 'PPL', 'P'),
(42529, 'Pecan Ridge', 30.5502796173096, 0.533202966726965, -91.0999984741211, -1.58999492193522, 218, 22, 'PPL', 'P'),
(96980, 'Pecan Springs', 31.0141696929932, 0.54129937591497, -99.0627822875977, -1.7289717171049, 218, 51, 'PPL', 'P'),
(82905, 'Pecan Terrace', 34.7652816772461, 0.606768630651201, -82.3916702270508, -1.43800592167942, 218, 48, 'PPL', 'P'),
(96981, 'Pecan Wells', 31.5763893127441, 0.551111959398935, -98.3711090087891, -1.71689974104162, 218, 51, 'PPL', 'P'),
(42530, 'Pecaniere', 30.4841709136963, 0.532049152184688, -91.9380569458008, -1.60462180159027, 218, 22, 'PPL', 'P'),
(120989, 'Pecatonica', 42.3138885498047, 0.73851667451602, -89.3591690063477, -1.55961171600684, 218, 18, 'PPL', 'P'),
(78916, 'Pechin', 39.9630584716797, 0.697486949497824, -79.6155624389648, -1.38955370038706, 218, 45, 'PPL', 'P'),
(17560, 'Peck', 30.5397205352783, 0.533018675979532, -84.091667175293, -1.4676764657001, 218, 12, 'PPL', 'P'),
(33599, 'Peck', 37.4775009155273, 0.654105786395141, -97.371940612793, -1.69946096274962, 218, 20, 'PPL', 'P'),
(42531, 'Peck', 31.9249992370605, 0.557196350383384, -91.6611099243164, -1.59978816421177, 218, 22, 'PPL', 'P'),
(73852, 'Peck', 39.1561088562012, 0.683403021810021, -83.0163879394531, -1.44890930265637, 218, 41, 'PPL', 'P'),
(132564, 'Peck', 43.2586097717285, 0.755005170352055, -82.817497253418, -1.4454380053335, 218, 27, 'PPL', 'P'),
(195456, 'Peck', 46.4752807617188, 0.81114667008077, -116.423332214355, -2.03197047328368, 218, 17, 'PPL', 'P'),
(169541, 'Peck Corner', 41.7577781677246, 0.728810717344199, -71.3408279418945, -1.24513233868483, 218, 47, 'PPL', 'P'),
(37622, 'Peck Ford', 37.4980583190918, 0.654464580773002, -85.2238922119141, -1.48743752046265, 218, 21, 'PPL', 'P'),
(151612, 'Peck Hill', 42.9997215270996, 0.750486718088572, -75.9188919067383, -1.32503462823826, 218, 40, 'PPL', 'P'),
(105147, 'Peckerwood Level', 36.9283294677734, 0.644520936473892, -79.6383285522461, -1.3899510440217, 218, 53, 'PPL', 'P'),
(89827, 'Peckerwood Point', 35.4516716003418, 0.618748394761732, -89.8819427490234, -1.5687358390595, 218, 50, 'PPL', 'P'),
(76918, 'Peckham', 36.8869400024414, 0.643798554028208, -97.1755599975586, -1.69603347442669, 218, 42, 'PPL', 'P'),
(193142, 'Peckham', 40.3038902282715, 0.703435585845706, -104.750556945801, -1.82824211200204, 218, 7, 'PPL', 'P'),
(71248, 'Pecks Corner', 39.5066719055176, 0.689521501256424, -75.3488922119141, -1.31508625682821, 218, 37, 'PPL', 'P'),
(157069, 'Pecks Corners', 41.5838890075684, 0.725775778965945, -81.3491668701172, -1.41981080563784, 218, 41, 'PPL', 'P'),
(110844, 'Pecks Mill', 37.9280586242676, 0.6619695018829, -81.9811096191406, -1.4308402872924, 218, 58, 'PPL', 'P'),
(113897, 'Pecks Mill', 41.2227783203125, 0.719473208509191, -73.116943359375, -1.2761314006153, 218, 8, 'PPL', 'P'),
(165769, 'Pecks Pond', 41.2830581665039, 0.720525290297827, -75.0924987792969, -1.31061134724855, 218, 45, 'PPL', 'P'),
(110845, 'Pecks Run', 39.0525016784668, 0.681594735429857, -80.1791687011719, -1.39939048534743, 218, 58, 'PPL', 'P'),
(30792, 'Pecksburg', 39.688060760498, 0.692687334002256, -86.5741729736328, -1.51100436558098, 218, 19, 'PPL', 'P'),
(151616, 'Pecksport', 42.8624992370605, 0.748091737320264, -75.5677795410156, -1.31890656141193, 218, 40, 'PPL', 'P'),
(151613, 'Pecksville', 41.5191688537598, 0.724646199189588, -73.6961135864258, -1.28623982800686, 218, 40, 'PPL', 'P'),
(50300, 'Pecktonville', 39.6697196960449, 0.692367222039228, -78.0444412231445, -1.36213246222306, 218, 25, 'PPL', 'P'),
(151614, 'Pecktown', 42.7730598449707, 0.746530725447314, -75.1463928222656, -1.31155197574557, 218, 40, 'PPL', 'P'),
(165770, 'Peckville', 41.476390838623, 0.723899581977984, -75.5736083984375, -1.31900829416557, 218, 45, 'PPL', 'P'),
(151615, 'Peconic', 41.047779083252, 0.716418895634006, -72.4636077880859, -1.26472854377591, 218, 40, 'PPL', 'P'),
(187182, 'Peconic', 39.3208312988281, 0.686277970785789, -102.148330688477, -1.78282469592988, 218, 7, 'PPL', 'P'),
(189203, 'Pecos', 35.5741691589355, 0.620886380484847, -105.674438476563, -1.8443668866122, 218, 38, 'PPL', 'P'),
(192031, 'Pecos', 31.422779083252, 0.548430955129552, -103.492782592773, -1.80628980829457, 218, 51, 'PPL', 'P'),
(56829, 'Peculiar', 38.7191696166992, 0.675776993449552, -94.4583282470703, -1.64860883384094, 218, 29, 'PPL', 'P'),
(193858, 'Pecwan', 41.3441696166992, 0.721591886314403, -123.852783203125, -2.16163885465326, 218, 6, 'PPL', 'P'),
(96982, 'Pedeco', 30.1458301544189, 0.526143991941601, -94.6708297729492, -1.65231768513304, 218, 51, 'PPL', 'P'),
(195457, 'Pedee', 47.3511085510254, 0.826432748684634, -116.773887634277, -2.03808881957203, 218, 17, 'PPL', 'P'),
(201381, 'Pedee', 44.7536087036133, 0.781097824027243, -123.412780761719, -2.15395936333391, 218, 43, 'PPL', 'P'),
(67660, 'Peden', 36.4983291625977, 0.637016015363994, -81.3086090087891, -1.41910293742009, 218, 33, 'PPL', 'P'),
(96983, 'Peden', 32.9524993896484, 0.575129611110787, -97.5336074829102, -1.70228258192456, 218, 51, 'PPL', 'P'),
(61267, 'Peden (historical)', 32.8180618286133, 0.572783233032373, -88.7708282470703, -1.54934323263376, 218, 30, 'PPL', 'P'),
(37623, 'Peden Mill', 36.6811103820801, 0.640206149454773, -86.5255584716797, -1.51015588245768, 218, 21, 'PPL', 'P'),
(82908, 'Peden Oaks', 34.6783294677734, 0.605251028304019, -81.1705627441406, -1.4166935755819, 218, 48, 'PPL', 'P'),
(23824, 'Pedenville', 33.1227798461914, 0.578101565729261, -84.4963912963867, -1.47474023417543, 218, 13, 'PPL', 'P'),
(189205, 'Pedernal', 34.6355590820313, 0.60450454425047, -105.642776489258, -1.843814280686, 218, 38, 'PPL', 'P'),
(89828, 'Pedigo', 36.1011085510254, 0.630083207835272, -83.9933319091797, -1.4659601915356, 218, 50, 'PPL', 'P'),
(208413, 'Pedigo', 46.0783309936523, 0.804218589662984, -118.439170837402, -2.06715349444472, 218, 56, 'PPL', 'P'),
(105148, 'Pedlar', 37.5097198486328, 0.654668112859312, -79.2694396972656, -1.38351271892838, 218, 53, 'PPL', 'P'),
(110846, 'Pedlar', 39.666389465332, 0.692309098548437, -80.1213912963867, -1.39838207940068, 218, 58, 'PPL', 'P'),
(105149, 'Pedlar Mills', 37.5597190856934, 0.655540764169503, -79.2516708374023, -1.38320259381944, 218, 53, 'PPL', 'P'),
(184055, 'Pedley', 33.9752807617188, 0.592980513581479, -117.474998474121, -2.05032551214873, 218, 6, 'PPL', 'P'),
(11125, 'Pedlo (historical)', 36.2055587768555, 0.631906208180459, -92.9880599975586, -1.62294781199943, 218, 4, 'PPL', 'P'),
(71249, 'Pedricktown', 39.767219543457, 0.694068915396761, -75.4150009155273, -1.31624007137049, 218, 37, 'PPL', 'P'),
(11126, 'Pedro', 36.1683311462402, 0.631256463453507, -94.4038925170898, -1.64765875112206, 218, 4, 'PPL', 'P'),
(17561, 'Pedro', 28.9813899993896, 0.505820677293907, -82.120002746582, -1.43326442967464, 218, 12, 'PPL', 'P'),
(73854, 'Pedro', 38.6302795410156, 0.674225568956527, -82.6675033569336, -1.44282011798196, 218, 41, 'PPL', 'P'),
(110847, 'Pedro', 37.6627807617188, 0.65733952974877, -80.3147201538086, -1.40175630450181, 218, 58, 'PPL', 'P'),
(202475, 'Pedro', 44.4199981689453, 0.775275221777948, -102.118606567383, -1.78230591214953, 218, 49, 'PPL', 'P'),
(190600, 'Pedro (historical)', 39.1697196960449, 0.683640575779256, -117.283332824707, -2.04698031550348, 218, 39, 'PPL', 'P'),
(212082, 'Pedro Bay', 59.7872200012207, 1.04348383963551, -154.106109619141, -2.68965901029331, 218, 1, 'PPL', 'P'),
(96984, 'Pedro Campos Colonia', 26.4009990692139, 0.46078435957374, -98.9850006103516, -1.72761417073923, 218, 51, 'PPL', 'P'),
(184056, 'Pedro Valley', 37.5933303833008, 0.656127391978621, -122.496940612793, -2.1379749373132, 218, 6, 'PPL', 'P'),
(11127, 'Pee Dee', 35.6049995422363, 0.621424472183098, -92.4166717529297, -1.61297520582346, 218, 4, 'PPL', 'P'),
(67661, 'Pee Dee', 35.2675018310547, 0.615534025905033, -80.043327331543, -1.39701960618699, 218, 33, 'PPL', 'P'),
(82909, 'Pee Dee', 34.2058296203613, 0.597004350251507, -79.5391693115234, -1.38822038878732, 218, 48, 'PPL', 'P'),
(67662, 'Pee Dee (historical)', 35.0269393920898, 0.611335419288469, -79.9894409179688, -1.39607911084803, 218, 33, 'PPL', 'P'),
(82910, 'Pee Dee Crossroads', 33.8383293151855, 0.590590259924106, -79.2227783203125, -1.38269832426704, 218, 48, 'PPL', 'P'),
(37625, 'Pee Vee', 37.3069381713867, 0.651128904928651, -87.5405578613281, -1.52787096371278, 218, 21, 'PPL', 'P'),
(73856, 'Peebles', 38.9488906860352, 0.679786382470666, -83.4058303833008, -1.45570635554852, 218, 41, 'PPL', 'P'),
(175775, 'Peebles', 43.8163909912109, 0.764740289137813, -88.3763885498047, -1.54245896121591, 218, 57, 'PPL', 'P'),
(73857, 'Peebles Corner', 39.1258316040039, 0.682874584070722, -84.4902801513672, -1.47463357457377, 218, 41, 'PPL', 'P'),
(37624, 'Peedee', 36.7586097717285, 0.641558768972424, -87.6655578613281, -1.53005262527777, 218, 21, 'PPL', 'P'),
(105150, 'Peeds', 38.1005592346191, 0.664980205495235, -76.9227828979492, -1.342555831366, 218, 53, 'PPL', 'P'),
(151617, 'Peekamoose', 41.9277801513672, 0.731777811693684, -74.3797225952148, -1.29817105600652, 218, 40, 'PPL', 'P'),
(4934, 'Peeks Corner', 34.3930587768555, 0.600272115488062, -85.8730621337891, -1.49876767300429, 218, 2, 'PPL', 'P'),
(23825, 'Peeks Crossing', 33.3061103820801, 0.581301287199964, -84.5980606079102, -1.47651469840975, 218, 13, 'PPL', 'P'),
(4933, 'Peeks Hill (historical)', 33.8455581665039, 0.590716427180748, -85.9533309936523, -1.50016862889572, 218, 2, 'PPL', 'P'),
(151618, 'Peekskill', 41.2900009155273, 0.720646464127425, -73.9208297729492, -1.29016186534422, 218, 40, 'PPL', 'P'),
(23826, 'Peeksville', 33.378059387207, 0.582557034232964, -84.0047225952148, -1.46615899651097, 218, 13, 'PPL', 'P'),
(175776, 'Peeksville', 46.0980606079102, 0.804562936391931, -90.5299987792969, -1.58004655052518, 218, 57, 'PPL', 'P'),
(89830, 'Peekville (historical)', 36.1005592346191, 0.630073620455348, -85.480827331543, -1.49192188426418, 218, 50, 'PPL', 'P'),
(11128, 'Peel', 36.4322204589844, 0.635862200821717, -92.7686080932617, -1.61911765371968, 218, 4, 'PPL', 'P'),
(201382, 'Peel', 43.2588882446289, 0.755010030621045, -123.031936645508, -2.14731237956918, 218, 43, 'PPL', 'P'),
(96985, 'Peel Junction', 30.3799991607666, 0.530231012108491, -95.7099990844727, -1.67045461110481, 218, 51, 'PPL', 'P'),
(89829, 'Peeled Chestnut', 35.9630584716797, 0.62767377941805, -85.6558303833008, -1.4949762637184, 218, 50, 'PPL', 'P'),
(61268, 'Peelers', 32.4913902282715, 0.567081738033649, -91.0466690063477, -1.58906414713424, 218, 30, 'PPL', 'P'),
(96986, 'Peeltown', 32.4049987792969, 0.565573922803474, -96.3808288574219, -1.68216279936318, 218, 51, 'PPL', 'P'),
(110848, 'Peeltree', 39.1294403076172, 0.682937567830503, -80.2108306884766, -1.39994309127363, 218, 58, 'PPL', 'P'),
(187183, 'Peeples', 38.8219413757324, 0.677570699022748, -108.341110229492, -1.89090908877075, 218, 7, 'PPL', 'P'),
(82911, 'Peeples (historical)', 32.790828704834, 0.572307925356821, -81.3133316040039, -1.41918536225583, 218, 48, 'PPL', 'P'),
(178834, 'Peeples Valley', 34.2688903808594, 0.59810496815101, -112.726387023926, -1.96744660744492, 218, 5, 'PPL', 'P'),
(30793, 'Peerless', 38.9244384765625, 0.679359610905981, -86.5033264160156, -1.50976785988686, 218, 19, 'PPL', 'P'),
(96987, 'Peerless', 33.2616691589355, 0.580525641532478, -95.6999969482422, -1.67028004089535, 218, 51, 'PPL', 'P'),
(192745, 'Peerless', 39.6941719055176, 0.692793993603913, -110.910278320313, -1.93574953099274, 218, 52, 'PPL', 'P'),
(197233, 'Peerless', 48.7825012207031, 0.851415263659423, -105.830558776855, -1.84709169988151, 218, 31, 'PPL', 'P'),
(157070, 'Peerless (historical)', 40.3505592346191, 0.704250113665107, -82.7652816772461, -1.44452667160848, 218, 41, 'PPL', 'P'),
(56831, 'Peerless Park', 38.5433311462402, 0.672708033188372, -90.495002746582, -1.57943575452917, 218, 29, 'PPL', 'P'),
(56832, 'Peers', 38.6341705322266, 0.674293479564324, -91.1216735839844, -1.59037322396807, 218, 29, 'PPL', 'P'),
(184057, 'Peethill', 38.584171295166, 0.673420828254132, -121.521110534668, -2.12094348950992, 218, 6, 'PPL', 'P'),
(4935, 'Peets Corner', 34.730281829834, 0.606157768076164, -86.8775024414063, -1.51629846351195, 218, 2, 'PPL', 'P'),
(194368, 'Peetz', 40.9627799987793, 0.714935381748778, -103.111938476563, -1.79964282452984, 218, 7, 'PPL', 'P'),
(171051, 'Peever', 45.5430603027344, 0.79487635371704, -96.9544372558594, -1.692174154533, 218, 49, 'PPL', 'P'),
(171052, 'Peever Flats', 45.5238914489746, 0.794541794105099, -96.9355621337891, -1.69184472150616, 218, 49, 'PPL', 'P'),
(89831, 'Peewee', 36.2613906860352, 0.632880658823319, -84.2761077880859, -1.47089556166774, 218, 50, 'PPL', 'P'),
(110849, 'Peewee', 38.9625015258789, 0.680023936439902, -81.4916687011719, -1.42229793177986, 218, 58, 'PPL', 'P'),
(50302, 'Pegasus Estates', 39.5847206115723, 0.690883708153999, -76.2577819824219, -1.33094937586127, 218, 25, 'PPL', 'P'),
(76919, 'Peggs', 36.0808296203613, 0.629729273726401, -95.0991668701172, -1.65979357778706, 218, 42, 'PPL', 'P'),
(96988, 'Peggy', 28.7394409179688, 0.501597869200936, -98.1783294677734, -1.71353510332042, 218, 51, 'PPL', 'P'),
(28212, 'Pegram', 39.3463897705078, 0.686724050268377, -90.3969421386719, -1.57772427405463, 218, 18, 'PPL', 'P'),
(89832, 'Pegram', 36.1005592346191, 0.630073620455348, -87.0511093139648, -1.51932847504219, 218, 50, 'PPL', 'P'),
(195458, 'Pegram', 42.1427803039551, 0.735530272248633, -111.128059387207, -1.93955052765855, 218, 17, 'PPL', 'P'),
(113898, 'Pegville', 41.9730606079102, 0.732568104747165, -72.8072204589844, -1.27072571623465, 218, 8, 'PPL', 'P'),
(205334, 'Pehrson', 40.1100006103516, 0.70005157362757, -112.349998474121, -1.96087738798402, 218, 52, 'PPL', 'P'),
(128501, 'Pejepscot', 43.9599990844727, 0.767246723197741, -70.0155563354492, -1.22200198566916, 218, 26, 'PPL', 'P'),
(769, 'Pekin', 35.2066688537598, 0.614472290157446, -79.8708267211914, -1.39400890257466, 218, 33, 'PPL', 'P'),
(37626, 'Pekin', 37.8794403076172, 0.661120952180574, -83.3897171020508, -1.45542512573741, 218, 21, 'PPL', 'P'),
(117250, 'Pekin', 41.1627807617188, 0.718426053568572, -92.1594390869141, -1.60848564885781, 218, 16, 'PPL', 'P'),
(120991, 'Pekin', 40.5675010681152, 0.708036462944927, -89.6405563354492, -1.56452285137305, 218, 18, 'PPL', 'P'),
(140677, 'Pekin', 47.790828704834, 0.83410731315597, -98.3277816772461, -1.7161435364501, 218, 34, 'PPL', 'P'),
(151621, 'Pekin', 43.5466690063477, 0.760032752436934, -75.9649963378906, -1.32583930236163, 218, 40, 'PPL', 'P'),
(157072, 'Pekin', 40.4286117553711, 0.70561238714171, -80.6624984741211, -1.40782618125832, 218, 41, 'PPL', 'P'),
(11131, 'Pekin (historical)', 35.7380599975586, 0.623746815232674, -92.3625030517578, -1.61202978363648, 218, 4, 'PPL', 'P'),
(89833, 'Pekin (historical)', 36.1813888549805, 0.63148436346379, -85.7569427490234, -1.49674100741474, 218, 50, 'PPL', 'P'),
(120992, 'Pekin Heights', 40.5463905334473, 0.707668014608115, -89.6041717529297, -1.56388782061112, 218, 18, 'PPL', 'P'),
(193859, 'Pekwan (historical)', 41.3430595397949, 0.721572511817473, -123.851387023926, -2.16161448672929, 218, 6, 'PPL', 'P'),
(193860, 'Pekwuteu (historical)', 41.1847190856934, 0.718808949554298, -123.701393127441, -2.15899659937774, 218, 6, 'PPL', 'P'),
(61269, 'Pelahatchie', 32.3127784729004, 0.563964374819657, -89.7983322143555, -1.56727655994019, 218, 30, 'PPL', 'P'),
(137405, 'Pelan', 48.6436080932617, 0.848991121277178, -96.3930587768555, -1.68237625172455, 218, 28, 'PPL', 'P'),
(42532, 'Pelba', 30.3416690826416, 0.529562026042663, -91.7324981689453, -1.60103412412777, 218, 22, 'PPL', 'P'),
(67665, 'Peletier', 34.7299995422363, 0.606152841228147, -77.084716796875, -1.34538211107285, 218, 33, 'PPL', 'P'),
(4937, 'Pelham', 33.2855606079102, 0.580942625980158, -86.8099975585938, -1.5151202810457, 218, 2, 'PPL', 'P'),
(23827, 'Pelham', 31.1275005340576, 0.543277372235599, -84.1519393920898, -1.46872841433068, 218, 13, 'PPL', 'P'),
(67666, 'Pelham', 36.5099983215332, 0.637219680608358, -79.4719390869141, -1.38704700001103, 218, 33, 'PPL', 'P'),
(82912, 'Pelham', 34.8569412231445, 0.608368391518012, -82.2241668701172, -1.43508243659279, 218, 48, 'PPL', 'P'),
(89834, 'Pelham', 35.310001373291, 0.616275782847648, -85.8808288574219, -1.49890322790377, 218, 50, 'PPL', 'P'),
(96989, 'Pelham', 31.9594402313232, 0.557797459130929, -96.8050003051758, -1.68956598771943, 218, 51, 'PPL', 'P'),
(125787, 'Pelham', 42.3930587768555, 0.739898455647608, -72.404167175293, -1.26369110937326, 218, 23, 'PPL', 'P'),
(144297, 'Pelham', 42.7344398498535, 0.745856679375415, -71.3249969482422, -1.24485603572173, 218, 36, 'PPL', 'P'),
(151622, 'Pelham', 40.9097213745117, 0.71400933405873, -73.8083267211914, -1.2881983166725, 218, 40, 'PPL', 'P'),
(4938, 'Pelham Heights', 33.7322196960449, 0.588738297702065, -85.8016662597656, -1.49752157993024, 218, 2, 'PPL', 'P'),
(105164, 'Pelham Manor', 38.4986114501953, 0.671927527251897, -78.0372161865234, -1.36200636154545, 218, 53, 'PPL', 'P'),
(151623, 'Pelham Manor', 40.8952789306641, 0.713757265861554, -73.807502746582, -1.28818393560261, 218, 40, 'PPL', 'P'),
(42533, 'Pelican', 31.8822193145752, 0.556449699882267, -93.5858306884766, -1.63338087872787, 218, 22, 'PPL', 'P'),
(96990, 'Pelican', 30.3666706085205, 0.529998384987273, -95.0319366455078, -1.65862018901077, 218, 51, 'PPL', 'P'),
(193280, 'Pelican', 57.9608306884766, 1.01160733270489, -136.227493286133, -2.37761828958149, 218, 1, 'PPL', 'P'),
(17565, 'Pelican Bay', 26.2308292388916, 0.457814335747057, -81.8058319091797, -1.42778111414822, 218, 12, 'PPL', 'P'),
(96991, 'Pelican Bay', 32.9208297729492, 0.574576872026541, -97.5180587768555, -1.70201120580948, 218, 51, 'PPL', 'P'),
(201383, 'Pelican City', 42.2533302307129, 0.737459732458395, -121.796112060547, -2.12574317158452, 218, 43, 'PPL', 'P'),
(17566, 'Pelican Lake', 26.8111095428467, 0.467942137635546, -80.6105575561523, -1.40691964122325, 218, 12, 'PPL', 'P'),
(175778, 'Pelican Lake', 45.499439239502, 0.794115022540414, -89.1666717529297, -1.55625200513365, 218, 57, 'PPL', 'P'),
(105151, 'Pelican Point', 37.0372200012207, 0.646421434806799, -79.6319427490234, -1.38983959073008, 218, 53, 'PPL', 'P'),
(137408, 'Pelican Rapids', 46.5708312988281, 0.812814341555378, -96.0827789306641, -1.67696084680592, 218, 28, 'PPL', 'P'),
(117251, 'Pelican Ridge Mobile Home Community', 43.3583297729492, 0.756745612703449, -95.1125030517578, -1.66002633806633, 218, 16, 'PPL', 'P'),
(193861, 'Peligreen Place', 40.2088890075684, 0.701777501751023, -121.787216186523, -2.12558790929297, 218, 6, 'PPL', 'P'),
(82913, 'Pelion', 33.7630615234375, 0.589276589137397, -81.245002746582, -1.41799279871969, 218, 48, 'PPL', 'P'),
(132565, 'Pelkie', 46.8133316040039, 0.817046770317787, -88.6363906860352, -1.54699685455535, 218, 27, 'PPL', 'P'),
(4939, 'Pell City', 33.586109161377, 0.586188187800259, -86.2861099243164, -1.50597671691708, 218, 2, 'PPL', 'P'),
(175779, 'Pell Lake', 42.5380592346191, 0.742429191052483, -88.350830078125, -1.54201288173332, 218, 57, 'PPL', 'P'),
(117252, 'Pella', 41.4080581665039, 0.72270695186282, -92.9161071777344, -1.6216919983874, 218, 16, 'PPL', 'P'),
(175780, 'Pella', 44.7425003051758, 0.780903945899885, -88.8033294677734, -1.54991048594595, 218, 57, 'PPL', 'P'),
(195459, 'Pella', 42.4752807617188, 0.741333500000997, -113.837783813477, -1.98684414071867, 218, 17, 'PPL', 'P'),
(142651, 'Pella (historical)', 40.5522193908691, 0.707769747361756, -96.5013885498047, -1.68426696294045, 218, 35, 'PPL', 'P'),
(137425, 'Pelland', 48.5227813720703, 0.846882297167999, -93.5749969482422, -1.63319179429047, 218, 28, 'PPL', 'P'),
(151625, 'Pellets Island', 41.3805618286133, 0.722227050234387, -74.4127807617188, -1.29874802985669, 218, 40, 'PPL', 'P'),
(113170, 'Pellettown', 41.1613883972168, 0.718401752223625, -74.6750030517578, -1.30332467218999, 218, 37, 'PPL', 'P'),
(61271, 'Pellez', 33.4769401550293, 0.584282829198362, -89.3816680908203, -1.56000439910957, 218, 30, 'PPL', 'P'),
(184058, 'Pellow Place', 39.9766693115234, 0.697724503467059, -122.628608703613, -2.14027297901783, 218, 6, 'PPL', 'P'),
(132566, 'Pellston', 45.5527801513672, 0.795045997078478, -84.7838897705078, -1.4797580291433, 218, 27, 'PPL', 'P'),
(37627, 'Pellville', 37.7522201538086, 0.65890054162172, -86.813606262207, -1.51518326480548, 218, 21, 'PPL', 'P'),
(120995, 'Pellville', 40.4613914489746, 0.706184500722886, -87.9225006103516, -1.53453712223736, 218, 18, 'PPL', 'P'),
(96992, 'Pelly', 29.7250003814697, 0.518799126813217, -94.9655609130859, -1.65746171393658, 218, 51, 'PPL', 'P'),
(37628, 'Pellyton', 37.211669921875, 0.64946616030206, -85.0841674804688, -1.48499886385247, 218, 21, 'PPL', 'P'),
(184059, 'Peltier', 38.1886100769043, 0.666516982602265, -121.243057250977, -2.11609054421353, 218, 6, 'PPL', 'P'),
(140680, 'Pelto', 48.1586112976074, 0.840526330331388, -98.2275009155273, -1.7143933069817, 218, 34, 'PPL', 'P'),
(105152, 'Pelton', 38.8916702270508, 0.678787697061887, -78.3955612182617, -1.36826066220744, 218, 53, 'PPL', 'P'),
(199599, 'Pelton', 41.9208297729492, 0.731656504706031, -103.832778930664, -1.81222386383548, 218, 35, 'PPL', 'P'),
(128507, 'Pelton Hill', 44.3211097717285, 0.773549293654495, -69.8294372558594, -1.21875359492954, 218, 26, 'PPL', 'P'),
(30794, 'Pelzer', 37.9891700744629, 0.663036097899477, -87.2572174072266, -1.52292573988461, 218, 19, 'PPL', 'P'),
(82914, 'Pelzer', 34.642219543457, 0.604620791232052, -82.4561080932617, -1.43913057460776, 218, 48, 'PPL', 'P'),
(128502, 'Pemaquid', 43.9066696166992, 0.766315948396758, -69.5155563354492, -1.21327533940919, 218, 26, 'PPL', 'P'),
(128503, 'Pemaquid (historical)', 43.9066696166992, 0.766315948396758, -69.5155563354492, -1.21327533940919, 218, 26, 'PPL', 'P'),
(128504, 'Pemaquid Beach', 43.874439239502, 0.765753422195506, -69.5219421386719, -1.21338679270081, 218, 26, 'PPL', 'P'),
(128505, 'Pemaquid Harbor', 43.892219543457, 0.766063747041528, -69.5250015258789, -1.21344018908067, 218, 26, 'PPL', 'P'),
(128506, 'Pemaquid Point', 43.8405609130859, 0.765162133854481, -69.5102767944336, -1.21318319403548, 218, 26, 'PPL', 'P'),
(151626, 'Pember Corners', 43.3569412231445, 0.75672137793753, -76.5108337402344, -1.33536596221306, 218, 40, 'PPL', 'P'),
(132567, 'Pemberthy Crossing', 44.6327781677246, 0.778988933339036, -84.908332824707, -1.48192997017032, 218, 27, 'PPL', 'P'),
(71250, 'Pemberton', 39.9719390869141, 0.697641945473266, -74.6833267211914, -1.30346994762745, 218, 37, 'PPL', 'P'),
(105153, 'Pemberton', 37.6744384765625, 0.657542995256052, -78.0849990844727, -1.36284033044081, 218, 53, 'PPL', 'P'),
(110854, 'Pemberton', 37.7177810668945, 0.658299466163689, -81.2191696166992, -1.41754192554714, 218, 58, 'PPL', 'P'),
(125789, 'Pemberton', 42.3055610656738, 0.738371332499529, -70.9175033569336, -1.23774393087262, 218, 23, 'PPL', 'P'),
(137412, 'Pemberton', 44.0086097717285, 0.768095139742013, -93.7830581665039, -1.63682314759485, 218, 28, 'PPL', 'P'),
(157073, 'Pemberton', 40.2947196960449, 0.703275529864193, -84.0325012207031, -1.46664382498742, 218, 41, 'PPL', 'P'),
(165771, 'Pemberton', 40.621940612793, 0.70898661224284, -78.1686096191406, -1.36429960956011, 218, 45, 'PPL', 'P'),
(71251, 'Pemberton Heights', 39.9625015258789, 0.697477228959845, -74.6791687011719, -1.30339737648775, 218, 37, 'PPL', 'P'),
(157074, 'Pemberville', 41.410831451416, 0.722755354815632, -83.4611129760742, -1.45667121881146, 218, 41, 'PPL', 'P'),
(113899, 'Pemberwick', 41.0255584716797, 0.716031072800263, -73.6611099243164, -1.28562889885279, 218, 8, 'PPL', 'P'),
(56834, 'Pembina', 37.107780456543, 0.647652947073879, -93.1494369506836, -1.6257643711683, 218, 29, 'PPL', 'P'),
(140681, 'Pembina', 48.9663887023926, 0.854624705668104, -97.2433319091797, -1.69721631742485, 218, 34, 'PPL', 'P'),
(175782, 'Pembine', 45.6352806091309, 0.796485901700857, -87.9908294677734, -1.5357296857735, 218, 57, 'PPL', 'P'),
(50303, 'Pembray', 39.5436096191406, 0.690166185977305, -75.8888931274414, -1.32451105076795, 218, 25, 'PPL', 'P'),
(14395, 'Pembrey', 39.8055610656738, 0.694738101199671, -75.5263900756836, -1.31818417896625, 218, 10, 'PPL', 'P'),
(17567, 'Pembroke', 27.7861099243164, 0.484959104500394, -81.8052825927734, -1.4277715267683, 218, 12, 'PPL', 'P'),
(23828, 'Pembroke', 32.1358299255371, 0.560876040061547, -81.6222229003906, -1.42457653240853, 218, 13, 'PPL', 'P'),
(37630, 'Pembroke', 36.7758293151855, 0.641859306701439, -87.3555603027344, -1.52464214720717, 218, 21, 'PPL', 'P'),
(67669, 'Pembroke', 34.6800003051758, 0.605280189917956, -79.1952819824219, -1.3822184226386, 218, 33, 'PPL', 'P'),
(105156, 'Pembroke', 37.2183303833008, 0.649582407283642, -77.4316711425781, -1.35143760675947, 218, 53, 'PPL', 'P'),
(110850, 'Pembroke', 38.7247200012207, 0.675873865934204, -80.7405624389648, -1.409188654472, 218, 58, 'PPL', 'P'),
(123401, 'Pembroke', 41.1002807617188, 0.717335222786075, -87.2769393920898, -1.52326995345551, 218, 19, 'PPL', 'P'),
(125790, 'Pembroke', 42.0713882446289, 0.734284245753612, -70.8097229003906, -1.23586280703665, 218, 23, 'PPL', 'P'),
(128508, 'Pembroke', 44.9536094665527, 0.784588495847037, -67.1624984741211, -1.17220673223908, 218, 26, 'PPL', 'P'),
(144299, 'Pembroke', 43.146671295166, 0.753051475376373, -71.4580612182617, -1.24717844535034, 218, 36, 'PPL', 'P'),
(151627, 'Pembroke', 42.997501373291, 0.750447969094712, -78.4349975585938, -1.36894895619118, 218, 40, 'PPL', 'P'),
(151628, 'Pembroke Center', 42.9961090087891, 0.750423667749765, -78.3655624389648, -1.36773708473713, 218, 40, 'PPL', 'P'),
(50304, 'Pembroke Hills', 38.4166717529297, 0.670497409746525, -75.5052795410156, -1.31781573062944, 218, 25, 'PPL', 'P'),
(50305, 'Pembroke Knolls', 39.1786117553711, 0.683795771491781, -76.9097213745117, -1.34232786477669, 218, 25, 'PPL', 'P'),
(105157, 'Pembroke Manor', 36.8519401550293, 0.643187691453171, -76.1363906860352, -1.32883069805606, 218, 53, 'PPL', 'P'),
(17568, 'Pembroke Park', 25.9874992370605, 0.453567426046221, -80.1750030517578, -1.39931778104968, 218, 12, 'PPL', 'P'),
(17569, 'Pembroke Pines', 26.0027809143066, 0.453834141629392, -80.2241668701172, -1.4001758515529, 218, 12, 'PPL', 'P'),
(891, 'Pembrook', 33.4513893127441, 0.583836882873828, -81.8563919067383, -1.42866355257542, 218, 48, 'PPL', 'P'),
(50306, 'Pembrook', 39.4933280944824, 0.689288607819097, -76.2683334350586, -1.33113353345065, 218, 25, 'PPL', 'P'),
(89835, 'Pembrook Place', 36.6361083984375, 0.639420716670281, -87.4124984741211, -1.52563590576793, 218, 50, 'PPL', 'P'),
(76921, 'Pemeta', 36.0244407653809, 0.628745102545562, -96.6152801513672, -1.68625474637808, 218, 42, 'PPL', 'P'),
(165772, 'Pen Argyl', 40.8686103820801, 0.713291811882035, -75.2552795410156, -1.31345240749945, 218, 45, 'PPL', 'P'),
(50307, 'Pen Delle Manor', 39.6624984741211, 0.69224118794064, -76.7133331298828, -1.3389002432957, 218, 25, 'PPL', 'P'),
(78917, 'Pen Mar', 39.7202796936035, 0.693249660466426, -77.5069427490234, -1.3527513441252, 218, 45, 'PPL', 'P'),
(50308, 'Pen Mar Park', 39.7177810668945, 0.693206051203576, -77.5066680908203, -1.35274655043524, 218, 25, 'PPL', 'P'),
(105158, 'Pen Park', 38.0541687011719, 0.664170537944823, -78.4594421386719, -1.36937559459781, 218, 53, 'PPL', 'P'),
(189208, 'Pena Blanca', 35.5708312988281, 0.620828123836002, -106.337501525879, -1.85593951997108, 218, 38, 'PPL', 'P'),
(96993, 'Pena Number 1 Colonia', 26.4130001068115, 0.460993817193475, -98.9700012207031, -1.72735238200408, 218, 51, 'PPL', 'P'),
(96994, 'Pena Number 2 Colonia', 26.4139995574951, 0.461011260898615, -98.9700012207031, -1.72735238200408, 218, 51, 'PPL', 'P'),
(144301, 'Penacook', 43.2802810668945, 0.755383405805874, -71.6005630493164, -1.24966557149236, 218, 36, 'PPL', 'P'),
(33600, 'Penalosa', 37.7166709899902, 0.658280091666759, -98.3194427490234, -1.71599799469652, 218, 20, 'PPL', 'P'),
(61272, 'Penantly', 32.1555595397949, 0.561220386790494, -89.0527801513672, -1.55426422169601, 218, 30, 'PPL', 'P'),
(14376, 'Penarth', 39.8069381713867, 0.694762136228509, -75.5180587768555, -1.31803877037073, 218, 10, 'PPL', 'P'),
(189210, 'Penasco', 36.1694412231445, 0.631275837950437, -105.685829162598, -1.84456569158757, 218, 38, 'PPL', 'P'),
(189209, 'Penasco Blanco', 35.8672218322754, 0.626001114516399, -105.348327636719, -1.83867517873048, 218, 38, 'PPL', 'P'),
(137415, 'Penasse', 49.3677787780762, 0.861630284073612, -94.958610534668, -1.65734040694893, 218, 28, 'PPL', 'P'),
(208414, 'Penawawa', 46.7050018310547, 0.815156059101885, -117.687782287598, -2.05403929028884, 218, 56, 'PPL', 'P'),
(110851, 'Penbro (historical)', 38.651668548584, 0.674598877562328, -80.2844390869141, -1.40122780018348, 218, 58, 'PPL', 'P'),
(165774, 'Penbrook', 40.2752799987793, 0.702936243141317, -76.8483276367188, -1.3412563419121, 218, 45, 'PPL', 'P'),
(71254, 'Penbryn', 39.7625007629395, 0.693986557140051, -74.9430618286133, -1.30800318043498, 218, 37, 'PPL', 'P'),
(165776, 'Penbryn', 41.5966682434082, 0.725998818707239, -76.8763885498047, -1.34174609723656, 218, 45, 'PPL', 'P'),
(14377, 'Pencader', 39.6730613708496, 0.692425545267101, -75.7425003051758, -1.32195601401813, 218, 10, 'PPL', 'P'),
(14378, 'Pencader Farms', 39.5658302307129, 0.690554008811048, -75.7600021362305, -1.32226147859516, 218, 10, 'PPL', 'P'),
(14380, 'Pencader Village', 39.6311111450195, 0.691693375704411, -75.7491683959961, -1.32207239415776, 218, 10, 'PPL', 'P'),
(4940, 'Pence', 34.4491691589355, 0.601251426399911, -86.7588882446289, -1.51422825523858, 218, 2, 'PPL', 'P'),
(37629, 'Pence', 38.6963882446289, 0.675379383498803, -83.5327835083008, -1.45792210557547, 218, 21, 'PPL', 'P'),
(123402, 'Pence', 40.3611106872559, 0.704434271254486, -87.5113906860352, -1.52736190047041, 218, 19, 'PPL', 'P'),
(175785, 'Pence', 46.4152793884277, 0.810099448561124, -90.2713928222656, -1.57553302510971, 218, 57, 'PPL', 'P'),
(187844, 'Pence', 38.6558303833008, 0.67467151528106, -101.072219848633, -1.76404301865821, 218, 20, 'PPL', 'P'),
(110852, 'Pence Springs', 37.6780586242676, 0.657606178752914, -80.7252807617188, -1.40892193888883, 218, 58, 'PPL', 'P'),
(137416, 'Pencer', 48.6991691589355, 0.849960844809103, -95.6374969482422, -1.66918921011286, 218, 28, 'PPL', 'P'),
(11134, 'Pencil Bluff', 34.6297187805176, 0.604402611759747, -93.7341690063477, -1.63596987078159, 218, 4, 'PPL', 'P'),
(165777, 'Pencoyd', 40.0052795410156, 0.698223846171449, -75.2158279418945, -1.31276384719961, 218, 45, 'PPL', 'P'),
(208416, 'Pend Oreille Village', 48.8683280944824, 0.852913225193565, -117.364723205566, -2.04840084562893, 218, 56, 'PPL', 'P'),
(201384, 'Pendair Heights', 45.6875, 0.797397302004909, -118.842781066895, -2.07419782184409, 218, 43, 'PPL', 'P'),
(189211, 'Pendaries Village', 35.8105583190918, 0.625012149645598, -105.404167175293, -1.83964976253139, 218, 38, 'PPL', 'P'),
(23830, 'Pendarvis', 31.503059387207, 0.54983211075807, -81.7583312988281, -1.42695207210088, 218, 13, 'PPL', 'P'),
(82915, 'Pendeboro', 34.1319389343262, 0.595714714493636, -79.3119430541992, -1.38425454245002, 218, 48, 'PPL', 'P'),
(96995, 'Pendell', 31.7136096954346, 0.553506906877729, -97.5411071777344, -1.70241347629214, 218, 51, 'PPL', 'P'),
(50309, 'Pendennis Mount', 38.9983291625977, 0.680649246663852, -76.4763870239258, -1.33476475359697, 218, 25, 'PPL', 'P'),
(67671, 'Pender', 36.3102798461914, 0.63373393563658, -77.5930633544922, -1.35425443224444, 218, 33, 'PPL', 'P'),
(105159, 'Pender', 38.8705596923828, 0.678419248725074, -77.3691711425781, -1.35034677597697, 218, 53, 'PPL', 'P'),
(142652, 'Pender', 42.1141700744629, 0.735030929544243, -96.7069396972656, -1.68785450724489, 218, 35, 'PPL', 'P'),
(105160, 'Penderbrook', 38.8727798461914, 0.678457997718935, -77.3641662597656, -1.35025942429322, 218, 53, 'PPL', 'P'),
(4941, 'Pendergrass', 34.3333282470703, 0.59922962107935, -86.0833282470703, -1.50243750898642, 218, 2, 'PPL', 'P'),
(23831, 'Pendergrass', 34.1622200012207, 0.596243218811963, -83.6780624389648, -1.46045770124933, 218, 13, 'PPL', 'P'),
(4942, 'Pendergrass (historical)', 34.452220916748, 0.601304689621713, -86.101936340332, -1.50276228148135, 218, 2, 'PPL', 'P'),
(105161, 'Penderlan', 38.8641700744629, 0.678307728854427, -77.3705596923828, -1.35037101074289, 218, 53, 'PPL', 'P'),
(67673, 'Penderlea', 34.6594390869141, 0.604921328961068, -78.0500030517578, -1.3622295344448, 218, 33, 'PPL', 'P'),
(67674, 'Penders Crossroads', 35.7686080932617, 0.624279980082908, -77.7719421386719, -1.35737645599034, 218, 33, 'PPL', 'P'),
(105162, 'Penderwood', 38.8808288574219, 0.678598479466437, -77.3697204589844, -1.3503563633569, 218, 53, 'PPL', 'P'),
(78918, 'Pendle Hill', 39.9091682434082, 0.696546387579835, -75.3691711425781, -1.31544019093709, 218, 45, 'PPL', 'P'),
(11133, 'Pendleton', 33.9772186279297, 0.593014335727323, -91.3819427490234, -1.59491577783942, 218, 4, 'PPL', 'P'),
(30795, 'Pendleton', 39.997501373291, 0.698088091534882, -85.7466735839844, -1.49656177667337, 218, 19, 'PPL', 'P'),
(37631, 'Pendleton', 38.4622192382813, 0.671292363331913, -85.3036117553711, -1.48882888897417, 218, 21, 'PPL', 'P'),
(50310, 'Pendleton', 38.5550003051758, 0.672911698432736, -76.5244369506836, -1.33560338302424, 218, 25, 'PPL', 'P'),
(56839, 'Pendleton', 38.827220916748, 0.677662844396465, -91.2350006103516, -1.59235115370967, 218, 29, 'PPL', 'P'),
(67675, 'Pendleton', 36.4713897705078, 0.63654583427354, -77.1988906860352, -1.3473748213585, 218, 33, 'PPL', 'P'),
(73858, 'Pendleton', 39.1233291625977, 0.682830908228845, -84.4577789306641, -1.47406632126158, 218, 41, 'PPL', 'P'),
(82916, 'Pendleton', 34.651668548584, 0.604785707482555, -82.7838897705078, -1.44485144410341, 218, 48, 'PPL', 'P'),
(96996, 'Pendleton', 31.1949996948242, 0.544455454833309, -97.3483276367188, -1.69904883857093, 218, 51, 'PPL', 'P'),
(105163, 'Pendleton', 37.9947204589844, 0.663132970384128, -77.8983306884766, -1.35958235232126, 218, 53, 'PPL', 'P'),
(151637, 'Pendleton', 43.0869407653809, 0.752008980967662, -78.7280578613281, -1.37406382338078, 218, 40, 'PPL', 'P'),
(201385, 'Pendleton', 45.6722183227539, 0.797130586421738, -118.787498474121, -2.07323295858115, 218, 43, 'PPL', 'P'),
(144302, 'Pendleton Beach', 43.6088905334473, 0.761118722950441, -71.4447174072266, -1.24694555191301, 218, 36, 'PPL', 'P'),
(151630, 'Pendleton Center', 43.1069412231445, 0.752358054807544, -78.773063659668, -1.3748493227443, 218, 40, 'PPL', 'P'),
(4943, 'Pendley', 33.7330589294434, 0.58875294508806, -87.5119400024414, -1.52737148785034, 218, 2, 'PPL', 'P'),
(61273, 'Pendorff', 31.6530609130859, 0.552450131267672, -89.1763916015625, -1.55642164849508, 218, 30, 'PPL', 'P'),
(14381, 'Pendrew Manor', 39.7180595397949, 0.693210911472565, -75.665283203125, -1.32060832134849, 218, 10, 'PPL', 'P'),
(197234, 'Pendroy', 48.0736083984375, 0.839042749867132, -112.298057556152, -1.95997084794896, 218, 31, 'PPL', 'P'),
(190601, 'Penelas (historical)', 39.059440612793, 0.681715842680429, -117.758888244629, -2.05528032335682, 218, 39, 'PPL', 'P'),
(67676, 'Penelo', 35.9180603027344, 0.626888413212586, -77.6730575561523, -1.35565059444592, 218, 33, 'PPL', 'P'),
(67677, 'Penelope', 35.728889465332, 0.62358675925116, -81.4000015258789, -1.420698037755, 218, 33, 'PPL', 'P'),
(96997, 'Penelope', 31.8600006103516, 0.556061910338038, -96.9263916015625, -1.69168466552465, 218, 51, 'PPL', 'P'),
(151632, 'Penelope', 42.4136085510254, 0.740257116867414, -75.8955612182617, -1.32462743090759, 218, 40, 'PPL', 'P'),
(56838, 'Penermon', 36.7900009155273, 0.64210664778768, -89.8291702270508, -1.5678147847965, 218, 29, 'PPL', 'P'),
(23832, 'Penfield', 33.6672210693359, 0.587603857656718, -83.1774978637695, -1.45172120129333, 218, 13, 'PPL', 'P'),
(33601, 'Penfield', 37.1627807617188, 0.648612883488798, -95.4077835083008, -1.6651799542498, 218, 20, 'PPL', 'P'),
(120997, 'Penfield', 40.3033294677734, 0.7034257987287, -87.9466705322266, -1.53495896695403, 218, 18, 'PPL', 'P'),
(151633, 'Penfield', 43.1302795410156, 0.752765385296271, -77.475830078125, -1.35220832557894, 218, 40, 'PPL', 'P'),
(157075, 'Penfield', 41.1686096191406, 0.718527786322213, -82.1213912963867, -1.43328866444056, 218, 41, 'PPL', 'P'),
(165778, 'Penfield', 41.2083282470703, 0.71922100715396, -78.5758285522461, -1.37140692071926, 218, 45, 'PPL', 'P'),
(151634, 'Penfield Center', 43.1672210693359, 0.75341013659618, -77.4313888549805, -1.35143267991145, 218, 40, 'PPL', 'P'),
(4944, 'Penfield Heights', 33.5941696166992, 0.586328869284843, -86.7297210693359, -1.51371919199621, 218, 2, 'PPL', 'P'),
(157076, 'Penfield Junction', 41.4252815246582, 0.723007556170862, -82.1600036621094, -1.43396257735441, 218, 41, 'PPL', 'P'),
(137417, 'Pengilly', 47.3327789306641, 0.826112836458689, -93.1969375610352, -1.62659341321564, 218, 28, 'PPL', 'P'),
(105165, 'Penhook', 36.9822196960449, 0.64546149839188, -79.6283264160156, -1.38977647381225, 218, 53, 'PPL', 'P'),
(23833, 'Penia', 31.9697208404541, 0.557976889609373, -83.7002792358398, -1.46084545750405, 218, 13, 'PPL', 'P'),
(37633, 'Penick', 37.5683288574219, 0.655691033034011, -85.1502838134766, -1.4861528115528, 218, 21, 'PPL', 'P'),
(105166, 'Penicks Mill', 37.3880615234375, 0.652544774522192, -79.6147232055664, -1.38953905300107, 218, 53, 'PPL', 'P'),
(17570, 'Peniel', 29.6197204589844, 0.516961645529603, -81.6797180175781, -1.42558001150727, 218, 12, 'PPL', 'P'),
(67678, 'Peniel', 35.2363891601563, 0.614991007358766, -82.1374969482422, -1.43356976109362, 218, 33, 'PPL', 'P'),
(73859, 'Peniel', 38.8038902282715, 0.677255647065791, -82.5338897705078, -1.44048812097343, 218, 41, 'PPL', 'P'),
(96998, 'Peniel', 33.1627807617188, 0.578799713409025, -96.1266708374023, -1.67772690509349, 218, 51, 'PPL', 'P'),
(110855, 'Peniel', 38.827220916748, 0.677662844396465, -81.4677810668945, -1.42188101391121, 218, 58, 'PPL', 'P'),
(82918, 'Peniel Crossroads', 34.0886116027832, 0.594958509902108, -79.8563919067383, -1.39375696753554, 218, 48, 'PPL', 'P'),
(37634, 'Penile', 38.1069412231445, 0.665091592207827, -85.8033294677734, -1.49755060838612, 218, 21, 'PPL', 'P'),
(89836, 'Penile Hill', 35.2700004577637, 0.615577635167883, -86.0527801513672, -1.50190434413618, 218, 50, 'PPL', 'P'),
(157078, 'Peninsula', 41.2411117553711, 0.719793187314164, -81.5527801513672, -1.42336452779644, 218, 41, 'PPL', 'P'),
(171056, 'Peninsula Park', 43.9458312988281, 0.766999448690527, -97.0088882446289, -1.693124503568, 218, 49, 'PPL', 'P'),
(193281, 'Peninsula Point', 55.3833312988281, 0.966621481887378, -131.733337402344, -2.29918047231149, 218, 1, 'PPL', 'P'),
(193863, 'Peninsula Village', 40.2733306884766, 0.702902221258391, -121.129440307617, -2.11410755446585, 218, 6, 'PPL', 'P'),
(89837, 'Peninsular Estates', 35.872501373291, 0.626093259890116, -84.0250015258789, -1.46651293061985, 218, 50, 'PPL', 'P'),
(189212, 'Penistaja', 35.9686088562012, 0.627770651902702, -107.220283508301, -1.87134697214163, 218, 38, 'PPL', 'P'),
(96999, 'Penitas', 26.2302799224854, 0.457804748367132, -98.4444427490234, -1.71817965626152, 218, 51, 'PPL', 'P'),
(11136, 'Penjur', 34.9749984741211, 0.610428879253406, -90.4280624389648, -1.57826742575895, 218, 4, 'PPL', 'P'),
(105169, 'Penlan', 37.6636085510254, 0.657353977397684, -78.3675003051758, -1.36777090688298, 218, 53, 'PPL', 'P'),
(67679, 'Penland', 35.9300003051758, 0.627096805567885, -82.1122207641602, -1.43312860845905, 218, 33, 'PPL', 'P'),
(97000, 'Penland', 33.6769409179688, 0.587773501018156, -96.4538879394531, -1.68343792089311, 218, 51, 'PPL', 'P'),
(67680, 'Penley (historical)', 36.1352806091309, 0.630679622761396, -81.5580596923828, -1.42345667317015, 218, 33, 'PPL', 'P'),
(128510, 'Penley Corner', 44.0511093139648, 0.768836896684627, -70.2005615234375, -1.22523093533283, 218, 26, 'PPL', 'P'),
(165779, 'Penllyn', 40.1699981689453, 0.701098728568189, -75.2455596923828, -1.31328276413801, 218, 45, 'PPL', 'P'),
(105167, 'Penmar Estates', 37.2291717529297, 0.649771624879092, -77.5069427490234, -1.3527513441252, 218, 53, 'PPL', 'P'),
(265, 'Penn', 34.3561096191406, 0.599627231030099, -87.0833282470703, -1.51989080150636, 218, 2, 'PPL', 'P'),
(132569, 'Penn', 41.9469413757324, 0.732112238147571, -85.9358291625977, -1.49986316431869, 218, 27, 'PPL', 'P'),
(140684, 'Penn', 48.2216682434082, 0.841626881651864, -99.0886077880859, -1.7294224571194, 218, 34, 'PPL', 'P'),
(165780, 'Penn', 40.3288917541504, 0.703871944790316, -79.6413879394531, -1.39000444040156, 218, 45, 'PPL', 'P'),
(14382, 'Penn Acres', 39.6800003051758, 0.692546652517672, -75.5824966430664, -1.31916342329907, 218, 10, 'PPL', 'P'),
(105168, 'Penn Acres', 37.4927787780762, 0.654372435399286, -77.5516662597656, -1.35353191664071, 218, 53, 'PPL', 'P'),
(14383, 'Penn Acres South', 39.6741714477539, 0.692444919764031, -75.5897216796875, -1.31928952397669, 218, 10, 'PPL', 'P'),
(165781, 'Penn Allen', 40.7322196960449, 0.710911345341668, -75.3655624389648, -1.3153772071773, 218, 45, 'PPL', 'P'),
(13184, 'Penn Branch', 38.8736114501953, 0.678472511946876, -76.9574966430664, -1.34316170051399, 218, 9, 'PPL', 'P'),
(208417, 'Penn Cove Park', 48.2400016784668, 0.841946860456837, -122.671943664551, -2.14102931676741, 218, 56, 'PPL', 'P'),
(105170, 'Penn Daw', 38.7813911437988, 0.676862963963059, -77.0791702270508, -1.34528530516722, 218, 53, 'PPL', 'P'),
(105176, 'Penn Daw Village', 38.785831451416, 0.676940461950781, -77.0819396972656, -1.34533364154101, 218, 53, 'PPL', 'P'),
(165782, 'Penn Five', 40.8269386291504, 0.712564502588334, -78.2688903808594, -1.36604983902851, 218, 45, 'PPL', 'P'),
(105172, 'Penn Forest', 37.2094383239746, 0.649427211571117, -80.0066680908203, -1.3963797817351, 218, 53, 'PPL', 'P'),
(165784, 'Penn Glyn', 40.3241691589355, 0.703789519954578, -79.6894378662109, -1.39084306982883, 218, 45, 'PPL', 'P'),
(78920, 'Penn Grove', 39.8141708374023, 0.694888370064179, -76.9127807617188, -1.34238126115654, 218, 45, 'PPL', 'P'),
(165785, 'Penn Hall', 40.8608283996582, 0.713155990666441, -77.5577774047852, -1.35363857624236, 218, 45, 'PPL', 'P'),
(165786, 'Penn Haven Junction', 40.9449996948242, 0.714625056902756, -75.7472229003906, -1.32203843885387, 218, 45, 'PPL', 'P'),
(78921, 'Penn Hill', 39.7805595397949, 0.694301742255062, -76.1791687011719, -1.32957731526766, 218, 45, 'PPL', 'P'),
(105173, 'Penn Laird', 38.3855590820313, 0.669954391200257, -78.8027801513672, -1.37536797336659, 218, 53, 'PPL', 'P'),
(165789, 'Penn Lake Park', 41.1130599975586, 0.717558262527369, -75.7752838134766, -1.32252819417833, 218, 45, 'PPL', 'P'),
(105174, 'Penn Lee', 36.7897186279297, 0.642101720939664, -83.0566711425781, -1.44961237718415, 218, 53, 'PPL', 'P'),
(50311, 'Penn Manor', 38.4930610656738, 0.671830654767246, -77.043327331543, -1.34465972862716, 218, 25, 'PPL', 'P'),
(78922, 'Penn Oaks', 39.9711112976074, 0.697627497824353, -76.6544418334961, -1.33787239627299, 218, 45, 'PPL', 'P'),
(123403, 'Penn Park', 41.5441703796387, 0.725082558134197, -84.9238891601563, -1.48220147944345, 218, 19, 'PPL', 'P'),
(78923, 'Penn Pitt', 39.7891693115234, 0.694452011119569, -79.9250030517578, -1.39495445791969, 218, 45, 'PPL', 'P'),
(71255, 'Penn Place', 39.7425003051758, 0.693637483300169, -74.4691696166992, -1.29973220103753, 218, 37, 'PPL', 'P'),
(165791, 'Penn Ridge', 40.4636116027832, 0.706223249716747, -79.8127822875977, -1.39299583609599, 218, 45, 'PPL', 'P'),
(14384, 'Penn Rose', 39.7583312988281, 0.693913786263264, -75.522216796875, -1.31811134151043, 218, 10, 'PPL', 'P'),
(165792, 'Penn Rose Park', 40.0750007629395, 0.699440711052533, -76.3163909912109, -1.33197229603597, 218, 45, 'PPL', 'P'),
(165793, 'Penn Run', 40.6186103820801, 0.708928488752049, -79.0113906860352, -1.37900891405089, 218, 45, 'PPL', 'P'),
(165794, 'Penn Square', 40.1427803039551, 0.700623687208746, -75.3147201538086, -1.31448984190209, 218, 45, 'PPL', 'P'),
(165797, 'Penn Valley', 40.0183296203613, 0.698451613023678, -75.2616729736328, -1.31356399394912, 218, 45, 'PPL', 'P'),
(184060, 'Penn Valley', 39.1961097717285, 0.684101169489786, -121.190002441406, -2.11516456310251, 218, 6, 'PPL', 'P'),
(165798, 'Penn View', 40.8463897705078, 0.712903989048292, -77.4527816772461, -1.35180605509628, 218, 45, 'PPL', 'P'),
(165799, 'Penn Wood', 40.0288887023926, 0.698635903771111, -78.432502746582, -1.36890541350735, 218, 45, 'PPL', 'P'),
(78924, 'Penn Wynne', 39.9861106872559, 0.697889286559507, -75.2758331298828, -1.31381113529828, 218, 45, 'PPL', 'P'),
(151636, 'Penn Yan', 42.660831451416, 0.744571970465561, -77.0541687011719, -1.34484894622261, 218, 40, 'PPL', 'P'),
(50312, 'Pennbrook', 39.4011116027832, 0.687679126414307, -76.5094375610352, -1.33534159428908, 218, 25, 'PPL', 'P'),
(110856, 'Pennbrook (historical)', 37.9658317565918, 0.662628767410749, -81.0202789306641, -1.41407062822428, 218, 58, 'PPL', 'P'),
(50313, 'Pennbrooke', 38.8583297729492, 0.678205796363704, -76.5811080932617, -1.33659248105309, 218, 25, 'PPL', 'P'),
(78927, 'Penncraft', 39.9599990844727, 0.697433553117968, -79.913330078125, -1.3947507260963, 218, 45, 'PPL', 'P'),
(165812, 'Penndel', 40.1519393920898, 0.700783543453178, -74.9169387817383, -1.30754724725636, 218, 45, 'PPL', 'P'),
(14385, 'Penndrew Manor', 39.7180595397949, 0.693210911472565, -75.6666717529297, -1.32063255611441, 218, 10, 'PPL', 'P'),
(113206, 'Pennellville', 43.2825012207031, 0.755422154799734, -76.2708282470703, -1.33117707613447, 218, 40, 'PPL', 'P'),
(128511, 'Pennellville', 43.860279083252, 0.765506280846347, -69.9619369506836, -1.22106615086211, 218, 26, 'PPL', 'P'),
(132571, 'Pennellwood', 41.9258308410645, 0.731743789810758, -86.334716796875, -1.50682506688232, 218, 27, 'PPL', 'P'),
(78928, 'Pennersville', 39.7266693115234, 0.693361180337073, -77.4791717529297, -1.35226664880681, 218, 45, 'PPL', 'P'),
(193864, 'Penney', 40.1983299255371, 0.70159321100359, -123.100563049316, -2.14851013626944, 218, 6, 'PPL', 'P'),
(17571, 'Penney Farms', 29.9794406890869, 0.523239947930924, -81.8105621337891, -1.42786367214202, 218, 12, 'PPL', 'P'),
(105175, 'Penneys Crossroad', 38.1030616760254, 0.665023881337112, -77.6922225952148, -1.35598508747883, 218, 53, 'PPL', 'P'),
(132572, 'Pennfield', 42.3733291625977, 0.739554108918661, -85.1025009155273, -1.48531884265744, 218, 27, 'PPL', 'P'),
(67681, 'Pennfield (historical)', 35.9258308410645, 0.627024034691098, -80.059440612793, -1.3973008359981, 218, 33, 'PPL', 'P'),
(184061, 'Penngrove', 38.2997207641602, 0.668456229929033, -122.665557861328, -2.14091786347579, 218, 6, 'PPL', 'P'),
(165814, 'Pennhurst', 40.1911087036133, 0.701467176905002, -75.5749969482422, -1.31903252893149, 218, 45, 'PPL', 'P'),
(17572, 'Pennichaw', 28.7986106872559, 0.502630576492642, -81.0058288574219, -1.41381842686905, 218, 12, 'PPL', 'P'),
(23837, 'Pennick', 31.312780380249, 0.546511115589227, -81.5591735839844, -1.42347611424611, 218, 13, 'PPL', 'P'),
(89839, 'Pennine', 35.6366691589355, 0.621977211267344, -84.896110534668, -1.481716650967, 218, 50, 'PPL', 'P'),
(4945, 'Pennington', 32.2069396972656, 0.562117139708551, -88.0561065673828, -1.53686898608783, 218, 2, 'PPL', 'P'),
(11135, 'Pennington', 35.589168548584, 0.621148169220002, -91.0611114501953, -1.58931621533142, 218, 4, 'PPL', 'P'),
(14386, 'Pennington', 39.8283309936523, 0.695135511413338, -75.5147171020508, -1.31798044714286, 218, 10, 'PPL', 'P'),
(23835, 'Pennington', 32.1599998474121, 0.561297884778215, -84.0872192382813, -1.46759883455433, 218, 13, 'PPL', 'P'),
(97001, 'Pennington', 31.1911106109619, 0.544387577515026, -95.2352828979492, -1.66216925063746, 218, 51, 'PPL', 'P'),
(137419, 'Pennington', 47.4836082458496, 0.828745304617205, -94.4797210693359, -1.64898220902577, 218, 28, 'PPL', 'P'),
(146015, 'Pennington', 40.3283309936523, 0.70386215767331, -74.7911071777344, -1.30535107146343, 218, 37, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(165815, 'Pennington', 40.6949996948242, 0.71026173377277, -78.1602783203125, -1.3641542009646, 218, 45, 'PPL', 'P'),
(175787, 'Pennington', 45.5319404602051, 0.794682275852601, -90.392219543457, -1.57764184921889, 218, 57, 'PPL', 'P'),
(184062, 'Pennington', 39.2911109924316, 0.685759253584469, -121.792221069336, -2.12567526097672, 218, 6, 'PPL', 'P'),
(189213, 'Pennington', 36.3052787780762, 0.633646650531853, -103.632781982422, -1.80873325859472, 218, 38, 'PPL', 'P'),
(89838, 'Pennington Chapel', 36.3105583190918, 0.63373879590557, -83.6888885498047, -1.46064665252867, 218, 50, 'PPL', 'P'),
(105177, 'Pennington Gap', 36.7583312988281, 0.641553908703434, -83.0272216796875, -1.44909838709376, 218, 53, 'PPL', 'P'),
(120999, 'Pennington Point', 40.3938903808594, 0.705006384835662, -90.5538864135742, -1.58046346839383, 218, 18, 'PPL', 'P'),
(165816, 'Pennline', 41.7122192382813, 0.728015564021729, -80.5116729736328, -1.40519377967883, 218, 45, 'PPL', 'P'),
(14387, 'Pennock', 39.7144393920898, 0.693147727975703, -75.6875, -1.32099607760321, 218, 10, 'PPL', 'P'),
(137421, 'Pennock', 45.1488914489746, 0.78799680941012, -95.1761093139648, -1.66113647676673, 218, 28, 'PPL', 'P'),
(193282, 'Pennock Island', 55.3277816772461, 0.965651958092535, -131.629165649414, -2.2973623322353, 218, 1, 'PPL', 'P'),
(61275, 'Penns', 33.3522186279297, 0.582106027902359, -88.6358337402344, -1.54698713401737, 218, 30, 'PPL', 'P'),
(71257, 'Penns Beach', 39.6419410705566, 0.691882393562779, -75.5277786254883, -1.31820841373217, 218, 37, 'PPL', 'P'),
(165818, 'Penns Creek', 40.8597183227539, 0.713136616169511, -77.0555572509766, -1.34487318098853, 218, 45, 'PPL', 'P'),
(71258, 'Penns Grove', 39.7294387817383, 0.693409516710858, -75.4683303833008, -1.31717084617147, 218, 37, 'PPL', 'P'),
(146020, 'Penns Neck', 40.332218170166, 0.70393000170208, -74.6372222900391, -1.30266527350408, 218, 37, 'PPL', 'P'),
(165817, 'Penns Park', 40.2658309936523, 0.702771326890813, -74.9983291625977, -1.30896777738181, 218, 45, 'PPL', 'P'),
(71260, 'Pennsauken', 39.9561080932617, 0.697365642510171, -75.0583267211914, -1.31001493232243, 218, 37, 'PPL', 'P'),
(56840, 'Pennsboro', 37.327220916748, 0.65148290561655, -93.8338928222656, -1.63771037971201, 218, 29, 'PPL', 'P'),
(110857, 'Pennsboro', 39.2849998474121, 0.685652593982811, -80.9686126708984, -1.41316888187918, 218, 58, 'PPL', 'P'),
(165819, 'Pennsburg', 40.3908309936523, 0.704952988455806, -75.4925003051758, -1.31759269088814, 218, 45, 'PPL', 'P'),
(165821, 'Pennsbury Village', 40.4280586242676, 0.705602733182758, -80.100830078125, -1.39802321844379, 218, 45, 'PPL', 'P'),
(165823, 'Pennsdale', 41.2430610656738, 0.71982720919709, -76.7969436645508, -1.34035952241501, 218, 45, 'PPL', 'P'),
(165825, 'Pennside', 41.8505592346191, 0.730430052445022, -80.4013900756836, -1.40326898000097, 218, 45, 'PPL', 'P'),
(17573, 'Pennsuco', 25.8947200775146, 0.451948124234912, -80.3783264160156, -1.40286644320221, 218, 12, 'PPL', 'P'),
(71262, 'Pennsville', 39.6533317565918, 0.692081198538154, -75.5169372558594, -1.31801919613672, 218, 37, 'PPL', 'P'),
(73862, 'Pennsville', 39.5752792358398, 0.690718925061551, -81.8555603027344, -1.42864903834748, 218, 41, 'PPL', 'P'),
(165827, 'Pennsville', 40.7486114501953, 0.71119743542177, -75.5047225952148, -1.31780601009146, 218, 45, 'PPL', 'P'),
(4946, 'Pennsylvania', 30.8730602264404, 0.538836551117892, -88.0475006103516, -1.53671878380235, 218, 2, 'PPL', 'P'),
(97002, 'Pennsylvania Avenue Colonia', 26.1140003204346, 0.455775286458438, -97.6429977416992, -1.70419180211004, 218, 51, 'PPL', 'P'),
(13185, 'Pennsylvania Avenue Hights', 38.8680610656738, 0.678375639462224, -76.9583282470703, -1.34317621474193, 218, 9, 'PPL', 'P'),
(4947, 'Pennsylvania Camp (historical)', 33.6733283996582, 0.587710450679349, -87.2180633544922, -1.5222423727489, 218, 2, 'PPL', 'P'),
(165828, 'Pennsylvania Furnace', 40.7058296203613, 0.710450751631139, -78.0038909912109, -1.36142472716337, 218, 45, 'PPL', 'P'),
(105178, 'Pennsytown', 36.8758316040039, 0.64360467590085, -76.2333297729492, -1.33052260429659, 218, 53, 'PPL', 'P'),
(486, 'Penntown', 39.2700004577637, 0.685390805247657, -85.0975036621094, -1.48523162413174, 218, 19, 'PPL', 'P'),
(23836, 'Pennville', 34.5122184753418, 0.602351844562332, -85.3213882446289, -1.48913914724116, 218, 13, 'PPL', 'P'),
(78931, 'Pennville', 39.7894401550293, 0.694456738230504, -76.9983291625977, -1.3438743624217, 218, 45, 'PPL', 'P'),
(123406, 'Pennville', 40.4938888549805, 0.706751687456046, -85.1483306884766, -1.48611872309085, 218, 19, 'PPL', 'P'),
(139389, 'Pennville', 40.3627815246582, 0.704463432868423, -92.9466705322266, -1.62222542955374, 218, 29, 'PPL', 'P'),
(89840, 'Pennville (historical)', 36.2180595397949, 0.632124387652764, -86.3291702270508, -1.5067282609767, 218, 50, 'PPL', 'P'),
(14388, 'Pennwood', 39.1272201538086, 0.682898818836642, -75.5133285522461, -1.31795621237694, 218, 10, 'PPL', 'P'),
(165830, 'Pennwood', 40.2958297729492, 0.703294904361123, -76.8000030517578, -1.34041291879487, 218, 45, 'PPL', 'P'),
(165831, 'Pennwyn', 40.2941703796387, 0.703265942484268, -75.9772186279297, -1.32605262156494, 218, 45, 'PPL', 'P'),
(37636, 'Penny', 37.3591690063477, 0.652040504969785, -82.5616683959961, -1.44097294944988, 218, 21, 'PPL', 'P'),
(14389, 'Penny Acres', 39.7641716003418, 0.694015718753987, -75.5163879394531, -1.31800960875679, 218, 10, 'PPL', 'P'),
(105179, 'Penny Corner', 38.0788917541504, 0.664602036620443, -77.2369384765625, -1.34803888057631, 218, 53, 'PPL', 'P'),
(67682, 'Penny Hill', 35.7619400024414, 0.624163599943272, -77.5144424438477, -1.35288223849278, 218, 33, 'PPL', 'P'),
(71264, 'Penny Pot', 39.5719413757324, 0.690660668412705, -74.8225021362305, -1.30589901685771, 218, 37, 'PPL', 'P'),
(14390, 'Pennyhill', 39.7686080932617, 0.694093150162681, -75.5147171020508, -1.31798044714286, 218, 10, 'PPL', 'P'),
(14391, 'Pennyhill Terrace', 39.7638893127441, 0.69401079190597, -75.5083312988281, -1.31786899385124, 218, 10, 'PPL', 'P'),
(165833, 'Pennypack Woods', 40.0541687011719, 0.69907712298471, -75.0163879394531, -1.30928296249682, 218, 45, 'PPL', 'P'),
(146017, 'Pennypacker Park', 40.0316696166992, 0.698684439881978, -74.8997192382813, -1.30724670952735, 218, 37, 'PPL', 'P'),
(11137, 'Pennys', 33.878059387207, 0.591283680492935, -94.1650009155273, -1.64348930611943, 218, 4, 'PPL', 'P'),
(30798, 'Pennyville', 38.5538902282715, 0.672892323935806, -87.008056640625, -1.51857706414062, 218, 19, 'PPL', 'P'),
(105180, 'Pennyville', 37.6175003051758, 0.656549236695289, -75.8330612182617, -1.32353660012509, 218, 53, 'PPL', 'P'),
(76924, 'Peno Corner', 35.3330612182617, 0.616678253067386, -94.4669418334961, -1.64875916928448, 218, 42, 'PPL', 'P'),
(128512, 'Penobscot', 44.4644393920898, 0.776050867445434, -68.711669921875, -1.19924487468027, 218, 26, 'PPL', 'P'),
(165834, 'Penobscot', 41.166389465332, 0.718489037328352, -75.8644409179688, -1.32408427920326, 218, 45, 'PPL', 'P'),
(128513, 'Penobscot (historical)', 44.3877792358398, 0.774712895313778, -68.8002777099609, -1.20079137232528, 218, 26, 'PPL', 'P'),
(165835, 'Penoke', 41.5061111450195, 0.724418299179304, -79.0711135864258, -1.38005127530155, 218, 45, 'PPL', 'P'),
(33603, 'Penokee', 39.3511085510254, 0.686806408525088, -99.9719390869141, -1.74483949666986, 218, 20, 'PPL', 'P'),
(105181, 'Penola', 37.957218170166, 0.662478431967214, -77.3711090087891, -1.35038059812282, 218, 53, 'PPL', 'P'),
(4948, 'Penootaw (historical)', 32.9922218322754, 0.575822898521562, -87.1305618286133, -1.52071518302179, 218, 2, 'PPL', 'P'),
(165838, 'Penowa', 40.2869415283203, 0.703139775227626, -80.5033264160156, -1.4050481047672, 218, 45, 'PPL', 'P'),
(193865, 'Penoyar', 41.6674995422363, 0.727235058085254, -122.061668395996, -2.13037800398764, 218, 6, 'PPL', 'P'),
(208418, 'Penrith', 48.1522216796875, 0.840414810460741, -117.098327636719, -2.04375136583981, 218, 56, 'PPL', 'P'),
(14392, 'Penrock', 39.7916717529297, 0.694495686961447, -75.4875030517578, -1.31750547236244, 218, 10, 'PPL', 'P'),
(37637, 'Penrod', 37.1141700744629, 0.647764466944527, -86.9991683959961, -1.51842193500713, 218, 21, 'PPL', 'P'),
(11139, 'Penrose', 35.1927795410156, 0.614229875919221, -91.0508270263672, -1.58913671827395, 218, 4, 'PPL', 'P'),
(67684, 'Penrose', 35.2722206115723, 0.615616384161744, -82.6391677856445, -1.44232556896753, 218, 33, 'PPL', 'P'),
(121002, 'Penrose', 41.8875007629395, 0.73107480374493, -89.6677780151367, -1.56499795931152, 218, 18, 'PPL', 'P'),
(187184, 'Penrose', 38.4249992370605, 0.670642751763016, -105.022216796875, -1.83298347084876, 218, 7, 'PPL', 'P'),
(205344, 'Penrose', 41.6508293151855, 0.726944107736163, -112.300827026367, -1.96001918432274, 218, 52, 'PPL', 'P'),
(110862, 'Penry (historical)', 39.4863891601563, 0.689167500568525, -78.0611114501953, -1.36242341257215, 218, 58, 'PPL', 'P'),
(165836, 'Penryn', 40.2050018310547, 0.701709657722253, -76.3686065673828, -1.33288362976099, 218, 45, 'PPL', 'P'),
(184063, 'Penryn', 38.8522186279297, 0.678099136762047, -121.168327331543, -2.11478626106966, 218, 6, 'PPL', 'P'),
(17579, 'Pensacola', 30.4211101531982, 0.530948534285186, -87.2169418334961, -1.52222279851489, 218, 12, 'PPL', 'P'),
(67685, 'Pensacola', 35.8477783203125, 0.625661761214496, -82.3083267211914, -1.43655130309202, 218, 33, 'PPL', 'P'),
(76925, 'Pensacola', 36.4550018310547, 0.636259810772466, -95.1302795410156, -1.66033659633332, 218, 42, 'PPL', 'P'),
(17574, 'Pensacola Beach', 30.3333301544189, 0.529416484289091, -87.1374969482422, -1.52083622369334, 218, 12, 'PPL', 'P'),
(175788, 'Pensaukee', 44.8230590820313, 0.782309961797392, -87.9130630493164, -1.53437240572394, 218, 57, 'PPL', 'P'),
(178835, 'Pensfield Place', 33.5905609130859, 0.586265885525062, -112.205558776855, -1.95835643969615, 218, 5, 'PPL', 'P'),
(165837, 'Pensyls Mill', 40.9030609130859, 0.713893087077148, -76.4894409179688, -1.33499258702823, 218, 45, 'PPL', 'P'),
(97004, 'Pentacostal Colonia', 26.1550006866455, 0.456490877843342, -98.1100006103516, -1.71234253978428, 218, 51, 'PPL', 'P'),
(110858, 'Pentacre', 38.3902816772461, 0.670036816035995, -81.4036102294922, -1.42076102151478, 218, 58, 'PPL', 'P'),
(61276, 'Pentecost', 33.5847206115723, 0.58616395303434, -90.5286102294922, -1.58002231575926, 218, 30, 'PPL', 'P'),
(11140, 'Penters Bluff (historical)', 35.8691711425781, 0.626035136399325, -91.8483276367188, -1.60305572971124, 218, 4, 'PPL', 'P'),
(14393, 'Pentland', 39.8208312988281, 0.695004617045761, -75.6347198486328, -1.32007489018215, 218, 10, 'PPL', 'P'),
(78932, 'Pentland', 39.790828704834, 0.694480972996424, -76.8541717529297, -1.34135834098185, 218, 45, 'PPL', 'P'),
(192907, 'Pentland', 35.060001373291, 0.611912459717662, -119.355560302734, -2.08314750784536, 218, 6, 'PPL', 'P'),
(132575, 'Pentoga', 46.003059387207, 0.802904852297248, -88.4944381713867, -1.54451931579325, 218, 27, 'PPL', 'P'),
(4949, 'Penton', 33.0063896179199, 0.576070173028776, -85.4655609130859, -1.49165543499712, 218, 2, 'PPL', 'P'),
(61277, 'Penton', 34.8658294677734, 0.608523520651509, -90.2797164916992, -1.57567830054718, 218, 30, 'PPL', 'P'),
(71265, 'Penton', 39.5783309936523, 0.690772188283352, -75.4019393920898, -1.31601210478118, 218, 37, 'PPL', 'P'),
(4950, 'Pentonville', 32.815559387207, 0.572739557190496, -86.227783203125, -1.50495872359039, 218, 2, 'PPL', 'P'),
(110859, 'Pentress', 39.7102813720703, 0.693075156835998, -80.1605606079102, -1.3990657128525, 218, 58, 'PPL', 'P'),
(132576, 'Pentwater', 43.7816696166992, 0.764134286831765, -86.4330596923828, -1.50854147420488, 218, 27, 'PPL', 'P'),
(184064, 'Pentz', 39.6552810668945, 0.692115220421079, -121.582778930664, -2.12201980606448, 218, 6, 'PPL', 'P'),
(105182, 'Penvir', 37.2958297729492, 0.650935026801293, -80.878059387207, -1.41158842893027, 218, 53, 'PPL', 'P'),
(177677, 'Penvir', 36.5386085510254, 0.637719023312748, -121.483062744141, -2.12027943029211, 218, 6, 'PPL', 'P'),
(146018, 'Penwell', 40.7780609130859, 0.711711425512155, -74.9027786254883, -1.3073001059072, 218, 37, 'PPL', 'P'),
(192034, 'Penwell', 31.7397193908691, 0.553962607029756, -102.591110229492, -1.79055265678107, 218, 51, 'PPL', 'P'),
(197235, 'Penwells (historical)', 45.8416709899902, 0.800088093391298, -110.99388885498, -1.93720881011205, 218, 31, 'PPL', 'P'),
(50315, 'Penwick Village', 38.7200012207031, 0.675791507677493, -76.658332824707, -1.33794030688078, 218, 25, 'PPL', 'P'),
(50316, 'Penwood Park (historical)', 39.2138900756836, 0.684411494335807, -76.4627838134766, -1.33452733278579, 218, 25, 'PPL', 'P'),
(178836, 'Penzance', 34.9052810668945, 0.609212080951349, -110.254173278809, -1.92429833777956, 218, 5, 'PPL', 'P'),
(205335, 'Peoa', 40.7247200012207, 0.71078045097409, -111.341110229492, -1.94326896633058, 218, 52, 'PPL', 'P'),
(30799, 'Peoga', 39.3430595397949, 0.686665926777586, -86.144172668457, -1.50349944447108, 218, 19, 'PPL', 'P'),
(208419, 'Peola', 46.3091697692871, 0.808247486339083, -117.481941223145, -2.05044668597833, 218, 56, 'PPL', 'P'),
(105183, 'Peola Mills', 38.5472183227539, 0.672775877217142, -78.2463912963867, -1.36565715592578, 218, 53, 'PPL', 'P'),
(157079, 'Peoli', 40.2272186279297, 0.702097413976969, -81.438606262207, -1.42137181751079, 218, 41, 'PPL', 'P'),
(208420, 'Peone', 47.8022193908691, 0.834306118131345, -117.228057861328, -2.0460155853986, 218, 56, 'PPL', 'P'),
(37638, 'Peonia', 37.4155616760254, 0.653024742729651, -86.2191696166992, -1.50480838814686, 218, 21, 'PPL', 'P'),
(37639, 'Peoples', 37.2894401550293, 0.650823506930646, -84.0533294677734, -1.46700734647622, 218, 21, 'PPL', 'P'),
(110860, 'Peora', 39.4213905334473, 0.688033060523179, -80.3450012207031, -1.40228480882013, 218, 58, 'PPL', 'P'),
(33604, 'Peoria', 38.5847206115723, 0.673430415634056, -95.1486129760742, -1.6606565751383, 218, 20, 'PPL', 'P'),
(56842, 'Peoria', 37.7561111450195, 0.658968452229517, -90.8841705322266, -1.58622801373136, 218, 29, 'PPL', 'P'),
(61278, 'Peoria', 31.1413898468018, 0.543519786473823, -90.6808319091797, -1.58267908526272, 218, 30, 'PPL', 'P'),
(67687, 'Peoria', 36.2905616760254, 0.633389788644715, -81.8936080932617, -1.42931309756529, 218, 33, 'PPL', 'P'),
(76926, 'Peoria', 36.9152793884277, 0.644293169621663, -94.6697235107422, -1.65229837721514, 218, 42, 'PPL', 'P'),
(97003, 'Peoria', 31.9780597686768, 0.558122431362946, -97.2216720581055, -1.69683828170811, 218, 51, 'PPL', 'P'),
(117259, 'Peoria', 40.7830581665039, 0.711798644037855, -93.3747177124023, -1.62969626220169, 218, 16, 'PPL', 'P'),
(121003, 'Peoria', 40.6936111450195, 0.710237499006851, -89.5888900756836, -1.56362110502795, 218, 18, 'PPL', 'P'),
(123407, 'Peoria', 40.7186088562012, 0.710673791372433, -85.960563659668, -1.50029486273139, 218, 19, 'PPL', 'P'),
(151638, 'Peoria', 42.833610534668, 0.747587534346885, -77.9652786254883, -1.36075081424953, 218, 40, 'PPL', 'P'),
(157080, 'Peoria', 40.3138885498047, 0.703610089476134, -83.4458312988281, -1.45640450322829, 218, 41, 'PPL', 'P'),
(178839, 'Peoria', 33.5805587768555, 0.586091315315608, -112.236671447754, -1.95889945824242, 218, 5, 'PPL', 'P'),
(187185, 'Peoria', 39.6797218322754, 0.692541792248683, -104.113609313965, -1.81712527866372, 218, 7, 'PPL', 'P'),
(201386, 'Peoria', 44.4488906860352, 0.775779491330355, -123.206108093262, -2.15035224479545, 218, 43, 'PPL', 'P'),
(178837, 'Peoria Estates', 33.5838890075684, 0.586149438806399, -112.238059997559, -1.95892369300834, 218, 5, 'PPL', 'P'),
(121006, 'Peoria Heights', 40.7472190856934, 0.711173134076823, -89.5738906860352, -1.5633593162928, 218, 18, 'PPL', 'P'),
(178838, 'Peoria Polynesian Village', 33.5847206115723, 0.58616395303434, -112.252777099609, -1.95918055489547, 218, 5, 'PPL', 'P'),
(17575, 'Peoria Siding', 30.1086101531982, 0.525494380372704, -81.7697219848633, -1.42715087707626, 218, 12, 'PPL', 'P'),
(117260, 'Peosta', 42.4505615234375, 0.740902067904404, -90.8502807617188, -1.58563652565325, 218, 16, 'PPL', 'P'),
(121007, 'Peotone', 41.332218170166, 0.721383294222023, -87.7852783203125, -1.53214214146905, 218, 18, 'PPL', 'P'),
(189214, 'Pep', 33.836109161377, 0.590551510930245, -103.334999084473, -1.80353596656937, 218, 38, 'PPL', 'P'),
(192036, 'Pep', 33.8161087036133, 0.590202437090363, -102.557777404785, -1.78997088924095, 218, 51, 'PPL', 'P'),
(210954, 'Pepeekeo', 19.833610534668, 0.346161806388189, -155.107223510742, -2.70713174388921, 218, 15, 'PPL', 'P'),
(210955, 'Pepeekeo Mill', 19.850830078125, 0.346462344117204, -155.08805847168, -2.7067972508563, 218, 15, 'PPL', 'P'),
(175790, 'Pepin', 44.4411087036133, 0.775643670114761, -92.1477813720703, -1.60828218335053, 218, 57, 'PPL', 'P'),
(137423, 'Pepin Woods Mobile Home Park', 44.5444412231445, 0.777447162804962, -92.5555572509766, -1.61539921504765, 218, 28, 'PPL', 'P'),
(175794, 'Peplin', 44.7861099243164, 0.78166507733943, -89.6188888549805, -1.56414468249826, 218, 57, 'PPL', 'P'),
(14394, 'Pepper', 38.5416717529297, 0.672679071311518, -75.4775009155273, -1.31733090215299, 218, 10, 'PPL', 'P'),
(105184, 'Pepper', 37.1636085510254, 0.648627331137712, -80.5488891601563, -1.4058433246687, 218, 53, 'PPL', 'P'),
(110861, 'Pepper', 39.1886100769043, 0.683970275122208, -80.1566696166992, -1.3989978022447, 218, 58, 'PPL', 'P'),
(184065, 'Pepper Corner', 33.8516693115234, 0.590823086782406, -117.54972076416, -2.05162966213454, 218, 6, 'PPL', 'P'),
(82927, 'Pepper Hill', 32.4777793884277, 0.566844184064414, -80.6383285522461, -1.40740433654165, 218, 48, 'PPL', 'P'),
(157081, 'Pepper Pike', 41.478328704834, 0.723933404123828, -81.4638900756836, -1.42181310330341, 218, 41, 'PPL', 'P'),
(14399, 'Pepper Ridge', 39.7374992370605, 0.693550198195441, -75.709716796875, -1.32138383385792, 218, 10, 'PPL', 'P'),
(82921, 'Pepper Ridge', 34.2147216796875, 0.597159545964032, -80.7011108398438, -1.40850009417216, 218, 48, 'PPL', 'P'),
(178840, 'Pepper Ridge', 33.6430587768555, 0.587182146098104, -112.029441833496, -1.95528261916598, 218, 5, 'PPL', 'P'),
(14396, 'Pepper Ridge Mobile Home Park', 38.4961090087891, 0.67188385141002, -75.2249984741211, -1.31292390318112, 218, 10, 'PPL', 'P'),
(178841, 'Pepper Tree Mobile Home Park', 33.5299987792969, 0.58520887688841, -112.195831298828, -1.95818666317666, 218, 5, 'PPL', 'P'),
(14397, 'Pepperbox', 38.4986114501953, 0.671927527251897, -75.4400024414063, -1.3166764303151, 218, 10, 'PPL', 'P'),
(4951, 'Pepperell', 32.6352806091309, 0.569593098941594, -85.4205627441406, -1.49087006879166, 218, 2, 'PPL', 'P'),
(125792, 'Pepperell', 42.665828704834, 0.744659188991261, -71.5888900756836, -1.24946183966897, 218, 23, 'PPL', 'P'),
(82923, 'Pepperhill', 32.9336090087891, 0.574799911767835, -80.0747222900391, -1.39756755158128, 218, 48, 'PPL', 'P'),
(23839, 'Pepperidge', 33.3847198486328, 0.582673281214546, -82.033332824707, -1.43175175417548, 218, 13, 'PPL', 'P'),
(82924, 'Pepperidge', 32.9263916015625, 0.574673944248275, -80.0833282470703, -1.39771775386676, 218, 48, 'PPL', 'P'),
(205338, 'Pepperidge', 40.6208305358887, 0.70896723774591, -111.879722595215, -1.95266952550439, 218, 52, 'PPL', 'P'),
(144303, 'Peppermint Corner', 42.8675003051758, 0.748179022424991, -71.3258285522461, -1.24487054994967, 218, 36, 'PPL', 'P'),
(184066, 'Peppermint Creek', 37.9716682434082, 0.662730633322445, -120.426391601563, -2.10183703974331, 218, 6, 'PPL', 'P'),
(89841, 'Peppermint Hills', 35.7874984741211, 0.62460967942586, -83.897216796875, -1.46428266636496, 218, 50, 'PPL', 'P'),
(50317, 'Peppermint Park', 39.5299987792969, 0.68992863200807, -76.9563903808594, -1.34314239259609, 218, 25, 'PPL', 'P'),
(67689, 'Peppers', 36.0422210693359, 0.629055427391584, -82.2255630493164, -1.43510680451676, 218, 33, 'PPL', 'P'),
(11145, 'Peppers Lake', 34.7397193908691, 0.606322484589585, -91.4430618286133, -1.59598250701405, 218, 4, 'PPL', 'P'),
(11141, 'Peppers Landing', 34.7430610656738, 0.606380807817458, -91.3872222900391, -1.59500792321313, 218, 4, 'PPL', 'P'),
(14398, 'Peppers Landing', 38.476390838623, 0.671539704418154, -75.0783309936523, -1.31036407274134, 218, 10, 'PPL', 'P'),
(23840, 'Pepperton', 33.2933311462402, 0.58107824745867, -83.9449996948242, -1.46511663526032, 218, 13, 'PPL', 'P'),
(30801, 'Peppertown', 39.3988914489746, 0.687640377420446, -85.1741714477539, -1.48656972942145, 218, 19, 'PPL', 'P'),
(89842, 'Peppertown', 35.0058288574219, 0.610966970951656, -87.3902816772461, -1.52524814951322, 218, 50, 'PPL', 'P'),
(82925, 'Peppertree', 34.9341697692871, 0.609716283924728, -82.3236083984375, -1.43681801867519, 218, 48, 'PPL', 'P'),
(178842, 'Pepperwood', 33.3091697692871, 0.58135468357982, -111.903327941895, -1.95308151652503, 218, 5, 'PPL', 'P'),
(193866, 'Pepperwood', 40.4461097717285, 0.705917785139715, -123.991668701172, -2.16406286387745, 218, 6, 'PPL', 'P'),
(205342, 'Pepperwood Condominium', 41.2188911437988, 0.719405364480421, -111.962783813477, -1.95411921724378, 218, 52, 'PPL', 'P'),
(184067, 'Pepperwood Grove', 39.0580596923828, 0.681691741072564, -122.780281066895, -2.14292016114137, 218, 6, 'PPL', 'P'),
(205343, 'Pepperwood Terrace', 40.5463905334473, 0.707668014608115, -111.808326721191, -1.95142343243035, 218, 52, 'PPL', 'P'),
(56844, 'Pepsin', 37.023609161377, 0.646183880837564, -94.2416687011719, -1.64482741140914, 218, 29, 'PPL', 'P'),
(113900, 'Pequabuck', 41.672779083252, 0.727327203458971, -72.9936065673828, -1.27397876750619, 218, 8, 'PPL', 'P'),
(132578, 'Pequaming', 46.8519401550293, 0.817720616652604, -88.4002838134766, -1.54287601224261, 218, 27, 'PPL', 'P'),
(146019, 'Pequannock', 40.952220916748, 0.714751091001344, -74.2991714477539, -1.29676517326707, 218, 37, 'PPL', 'P'),
(144304, 'Pequawket', 43.9208297729492, 0.766563089745917, -71.227783203125, -1.24315933579124, 218, 36, 'PPL', 'P'),
(78933, 'Pequea', 39.8880615234375, 0.69617800582205, -76.3675003051758, -1.33286432184309, 218, 45, 'PPL', 'P'),
(146022, 'Pequest', 40.829719543457, 0.712613038699201, -74.976936340332, -1.30859440219698, 218, 37, 'PPL', 'P'),
(125794, 'Pequoig', 42.6666717529297, 0.744673902956284, -72.0124969482422, -1.25685517432919, 218, 23, 'PPL', 'P'),
(200123, 'Pequop', 41.2172203063965, 0.719376202866485, -114.588607788086, -1.99994849117852, 218, 39, 'PPL', 'P'),
(113901, 'Pequot Indian Reservation', 41.457218170166, 0.723564955787016, -71.9713897705078, -1.25613771873153, 218, 8, 'PPL', 'P'),
(137428, 'Pequot Lakes', 46.6030616760254, 0.81337686775663, -94.3091735839844, -1.64600559387539, 218, 28, 'PPL', 'P'),
(113902, 'Pequot Village', 41.3452796936035, 0.721611260811334, -72.0569381713867, -1.25763081999668, 218, 8, 'PPL', 'P'),
(4952, 'Pera', 31.1352806091309, 0.543413160161679, -86.0919418334961, -1.50258784442995, 218, 2, 'PPL', 'P'),
(105185, 'Pera', 37.6175003051758, 0.656549236695289, -79.2916717529297, -1.38390074149921, 218, 53, 'PPL', 'P'),
(184068, 'Peral', 36.4280586242676, 0.635789563102985, -119.285827636719, -2.08193044322719, 218, 6, 'PPL', 'P'),
(189215, 'Peralta', 34.8369407653809, 0.608019317678129, -106.690002441406, -1.86209182156333, 218, 38, 'PPL', 'P'),
(184069, 'Peralta Hills', 33.8444404602051, 0.590696919525764, -117.816940307617, -2.05629352299354, 218, 6, 'PPL', 'P'),
(137430, 'Perault', 47.8125, 0.834485548609789, -96.2897186279297, -1.68057262587629, 218, 28, 'PPL', 'P'),
(23842, 'Percale', 33.0894393920898, 0.577519665031079, -83.795280456543, -1.46250354159873, 218, 13, 'PPL', 'P'),
(132579, 'Perch Point', 42.6650009155273, 0.744644741342347, -82.6202774047852, -1.44199586962458, 218, 27, 'PPL', 'P'),
(151641, 'Perch River', 44.0752792358398, 0.769258741401296, -76.0083312988281, -1.32659564011121, 218, 40, 'PPL', 'P'),
(56843, 'Perche (historical)', 39.125, 0.682860069842781, -92.4055633544922, -1.6127813276961, 218, 29, 'PPL', 'P'),
(97005, 'Percilla', 31.5469398498535, 0.550597969308549, -95.3988876342773, -1.66502469195824, 218, 51, 'PPL', 'P'),
(117261, 'Percival', 40.7488899230957, 0.711202295690759, -95.8133316040039, -1.67225810379501, 218, 16, 'PPL', 'P'),
(82926, 'Percival Crossroads', 34.6555595397949, 0.604853618090352, -83.1322174072266, -1.45093090823985, 218, 48, 'PPL', 'P'),
(42534, 'Percle', 29.8683300018311, 0.521300700604156, -91.0116729736328, -1.58845335113823, 218, 22, 'PPL', 'P'),
(28215, 'Percy', 38.0163917541504, 0.663511205837947, -89.6186065673828, -1.56413975565024, 218, 18, 'PPL', 'P'),
(61279, 'Percy', 33.1088905334473, 0.577859151491037, -90.8794403076172, -1.58614545573757, 218, 30, 'PPL', 'P'),
(78935, 'Percy', 39.9324989318848, 0.696953584910508, -79.6516723632813, -1.39018393745903, 218, 45, 'PPL', 'P'),
(144305, 'Percy', 44.6230583190918, 0.778819289977598, -71.3925018310547, -1.24603421818798, 218, 36, 'PPL', 'P'),
(117262, 'Percy (historical)', 41.4816703796387, 0.723991727351701, -93.2502822875977, -1.62752445433273, 218, 16, 'PPL', 'P'),
(123408, 'Percy Junction', 40.8091697692871, 0.712254377479395, -87.2966690063477, -1.52361430018445, 218, 19, 'PPL', 'P'),
(4953, 'Perdido', 31.0074996948242, 0.54118296248582, -87.6272201538086, -1.52938350605389, 218, 2, 'PPL', 'P'),
(17576, 'Perdido Bay', 30.3327808380127, 0.529406896909166, -87.4205627441406, -1.52577665383154, 218, 12, 'PPL', 'P'),
(4954, 'Perdido Beach', 30.3405609130859, 0.529542684835247, -87.504997253418, -1.52725031402074, 218, 2, 'PPL', 'P'),
(17577, 'Perdido Heights', 30.4002799987793, 0.530584979506876, -87.4230575561523, -1.52582019651537, 218, 12, 'PPL', 'P'),
(17578, 'Perdido Key', 30.2999992370605, 0.528834750038476, -87.4274978637695, -1.52589769450309, 218, 12, 'PPL', 'P'),
(165842, 'Perdix', 40.3555603027344, 0.704337398769834, -76.9583282470703, -1.34317621474193, 218, 45, 'PPL', 'P'),
(61280, 'Perdue', 32.5144386291504, 0.567484008516306, -88.9822235107422, -1.55303277600796, 218, 30, 'PPL', 'P'),
(105186, 'Perdue (historical)', 37.350830078125, 0.651894963216212, -77.6374969482422, -1.35502994475388, 218, 53, 'PPL', 'P'),
(201387, 'Perdue (historical)', 42.936939239502, 0.749390960458059, -123.073608398438, -2.14803968886288, 218, 43, 'PPL', 'P'),
(11142, 'Perdue City', 33.2488899230957, 0.580302601791184, -92.533332824707, -1.61501132563488, 218, 4, 'PPL', 'P'),
(4955, 'Perdue Hill', 31.5138893127441, 0.550021128616438, -87.4933319091797, -1.5270467153554, 218, 2, 'PPL', 'P'),
(121010, 'Perdueville', 40.4655609130859, 0.706257271599673, -88.1791687011719, -1.53901682550698, 218, 18, 'PPL', 'P'),
(132580, 'Pere Cheney', 44.5774993896484, 0.778024136655128, -84.6377792358398, -1.4772079192415, 218, 27, 'PPL', 'P'),
(189216, 'Perea', 35.5044403076172, 0.619669382445708, -108.518333435059, -1.89400221721882, 218, 38, 'PPL', 'P'),
(198738, 'Perella', 48.901668548584, 0.853495125891747, -102.250556945801, -1.78460888070218, 218, 34, 'PPL', 'P'),
(23843, 'Perennial', 34.4536094665527, 0.601328924387632, -85.4158325195313, -1.49078751079786, 218, 13, 'PPL', 'P'),
(193867, 'Perez', 41.6763916015625, 0.727390253797778, -121.253059387207, -2.11626511442298, 218, 6, 'PPL', 'P'),
(137439, 'Perez Mobile Home Park', 44.7713890075684, 0.781408148873264, -94.1444396972656, -1.64313044516254, 218, 28, 'PPL', 'P'),
(97006, 'Perezville', 26.2241706848145, 0.457698122054988, -98.4002838134766, -1.71740893744205, 218, 51, 'PPL', 'P'),
(105187, 'Perfect Point', 36.6347198486328, 0.639396481904361, -78.5666732788086, -1.37124713105386, 218, 53, 'PPL', 'P'),
(67690, 'Perfection', 35.2458305358887, 0.615155790451215, -77.2547225952148, -1.34834927200136, 218, 33, 'PPL', 'P'),
(128517, 'Perham', 46.8441696166992, 0.817584995174091, -68.1977767944336, -1.19027574760305, 218, 26, 'PPL', 'P'),
(137433, 'Perham', 46.5944404602051, 0.813226399155041, -95.5722198486328, -1.66804990979852, 218, 28, 'PPL', 'P'),
(144306, 'Perham Corner', 42.8622207641602, 0.748086877051275, -71.716667175293, -1.2516919707658, 218, 36, 'PPL', 'P'),
(128518, 'Perham Junction', 44.9211082458496, 0.78402124253485, -70.4108276367188, -1.22890077131496, 218, 26, 'PPL', 'P'),
(178844, 'Peri-Winkle Mobile Home Park', 33.5138893127441, 0.584927713656325, -112.117782592773, -1.95682445627908, 218, 5, 'PPL', 'P'),
(192037, 'Perico', 36.2763900756836, 0.633142447558474, -102.863891601563, -1.79531358986181, 218, 51, 'PPL', 'P'),
(178843, 'Peridot', 33.3102798461914, 0.58137405807675, -110.454719543457, -1.92779853040025, 218, 5, 'PPL', 'P'),
(187186, 'Perigo (historical)', 39.8791694641113, 0.696022810109525, -105.530281066895, -1.84185086517234, 218, 7, 'PPL', 'P'),
(89843, 'Perilla (historical)', 35.8786087036133, 0.626199852912746, -85.4319381713867, -1.49106860745092, 218, 50, 'PPL', 'P'),
(73864, 'Perintown', 39.1372184753418, 0.68307332246707, -84.2358322143555, -1.47019262029801, 218, 41, 'PPL', 'P'),
(165839, 'Perkasie', 40.371940612793, 0.704623289112854, -75.2930603027344, -1.31411180618535, 218, 45, 'PPL', 'P'),
(11143, 'Perkins', 34.0766716003418, 0.59475011754681, -93.8597183227539, -1.63816111972651, 218, 4, 'PPL', 'P'),
(17580, 'Perkins', 30.4538898468018, 0.531520647866362, -84.2225036621094, -1.46995999317679, 218, 12, 'PPL', 'P'),
(23844, 'Perkins', 32.9094390869141, 0.574378067051167, -81.9530563354492, -1.43035066512599, 218, 13, 'PPL', 'P'),
(37640, 'Perkins', 36.7838897705078, 0.641999988186023, -84.0608291625977, -1.4671382408438, 218, 21, 'PPL', 'P'),
(42535, 'Perkins', 30.3930606842041, 0.530458978697802, -93.4116668701172, -1.63034114665965, 218, 22, 'PPL', 'P'),
(56846, 'Perkins', 37.0947189331055, 0.647424980484569, -89.7752838134766, -1.56687428945754, 218, 29, 'PPL', 'P'),
(76928, 'Perkins', 35.9738883972168, 0.627862797276419, -97.033332824707, -1.69355114197463, 218, 42, 'PPL', 'P'),
(110863, 'Perkins', 38.7844390869141, 0.676916160605834, -80.9261093139648, -1.41242705835754, 218, 58, 'PPL', 'P'),
(117263, 'Perkins', 43.188060760498, 0.753773857822057, -96.1852798461914, -1.67874982526819, 218, 16, 'PPL', 'P'),
(123409, 'Perkins', 40.7649993896484, 0.711483458922844, -87.3630599975586, -1.52477304157475, 218, 19, 'PPL', 'P'),
(128519, 'Perkins', 45.6127815246582, 0.796093218598125, -68.817497253418, -1.2010919100543, 218, 26, 'PPL', 'P'),
(132582, 'Perkins', 45.9777793884277, 0.802463633083649, -87.0716705322266, -1.51968733599908, 218, 27, 'PPL', 'P'),
(137436, 'Perkins', 43.7830581665039, 0.764158521597685, -91.644172668457, -1.59949255333077, 218, 28, 'PPL', 'P'),
(171058, 'Perkins', 42.8655586242676, 0.74814513370012, -98.0100021362305, -1.7105972371639, 218, 49, 'PPL', 'P'),
(184071, 'Perkins', 38.5463905334473, 0.672761429568228, -121.397216796875, -2.11878113586283, 218, 6, 'PPL', 'P'),
(195460, 'Perkins', 43.6049995422363, 0.761050812342644, -116.27278137207, -2.02934286539416, 218, 17, 'PPL', 'P'),
(112312, 'Perkins (historical)', 37.3569412231445, 0.65200162281787, -88.6505584716797, -1.54724412906256, 218, 18, 'PPL', 'P'),
(113903, 'Perkins Corner', 41.7394409179688, 0.728490671960199, -72.2600021362305, -1.26117495477536, 218, 8, 'PPL', 'P'),
(151640, 'Perkins Corner', 42.8963890075684, 0.748683225398371, -75.8808288574219, -1.32437030270434, 218, 40, 'PPL', 'P'),
(157083, 'Perkins Corners', 41.1030616760254, 0.717383758896942, -80.711669921875, -1.40868438491959, 218, 41, 'PPL', 'P'),
(151643, 'Perkins Crossing', 42.6730613708496, 0.744785422826931, -75.0088882446289, -1.30915206812924, 218, 40, 'PPL', 'P'),
(82930, 'Perkins Crossroads', 34.1047210693359, 0.595239673134193, -79.8197174072266, -1.39311687676754, 218, 48, 'PPL', 'P'),
(144307, 'Perkins Hill', 42.9627799987793, 0.749841966788664, -70.9911117553711, -1.23902863978248, 218, 36, 'PPL', 'P'),
(4956, 'Perkins Landing', 30.8411102294922, 0.538278918475143, -87.9030609130859, -1.53419783551448, 218, 2, 'PPL', 'P'),
(105188, 'Perkins Park', 37.3833312988281, 0.652462216528399, -79.1558303833008, -1.38152986233876, 218, 53, 'PPL', 'P'),
(23845, 'Perkins Place', 32.1366691589355, 0.560890687447542, -84.9936065673828, -1.48341827774551, 218, 13, 'PPL', 'P'),
(105189, 'Perkins Point', 37.961669921875, 0.662556129692017, -79.9686126708984, -1.39571558935923, 218, 53, 'PPL', 'P'),
(42537, 'Perkins South', 30.3611106872559, 0.529901346055053, -91.0650024414063, -1.58938412593921, 218, 22, 'PPL', 'P'),
(128521, 'Perkins Town', 43.3383293151855, 0.756396538863567, -70.7050018310547, -1.23403507958052, 218, 26, 'PPL', 'P'),
(42538, 'Perkins Village', 30.3672199249268, 0.530007972367197, -91.0622177124023, -1.58933552324932, 218, 22, 'PPL', 'P'),
(105190, 'Perkinson Heights', 37.3383293151855, 0.651676783743907, -77.3269424438477, -1.34960974614529, 218, 53, 'PPL', 'P'),
(61281, 'Perkinston', 30.7819404602051, 0.537246211183437, -89.1380615234375, -1.55575266242926, 218, 30, 'PPL', 'P'),
(175795, 'Perkinstown', 45.2041702270508, 0.788961606094029, -90.6147232055664, -1.58152527072044, 218, 57, 'PPL', 'P'),
(67692, 'Perkinsville', 36.2188911437988, 0.632138901880705, -81.6594390869141, -1.4252260773984, 218, 33, 'PPL', 'P'),
(105191, 'Perkinsville', 37.7444381713867, 0.658764720406126, -77.8236083984375, -1.35827820233545, 218, 53, 'PPL', 'P'),
(123410, 'Perkinsville', 40.1441688537598, 0.700647921974666, -85.8613891601563, -1.4985639411809, 218, 19, 'PPL', 'P'),
(151642, 'Perkinsville', 42.5397186279297, 0.742458152929338, -77.6286087036133, -1.35487481562038, 218, 40, 'PPL', 'P'),
(172393, 'Perkinsville', 44.2208290100098, 0.771799064186095, -72.3986129760742, -1.26359417030959, 218, 55, 'PPL', 'P'),
(178845, 'Perkinsville', 34.901668548584, 0.609149030612541, -112.190559387207, -1.95809465096099, 218, 5, 'PPL', 'P'),
(212083, 'Perkinsville', 64.5505599975586, 1.12661980596354, -165.414993286133, -2.88703626500733, 218, 1, 'PPL', 'P'),
(61282, 'Perkinsville (historical)', 33.1011085510254, 0.577723330275443, -88.8638916015625, -1.5509674945826, 218, 30, 'PPL', 'P'),
(71267, 'Perkintown', 39.7333297729492, 0.693477427318655, -75.4230575561523, -1.31638068627605, 218, 37, 'PPL', 'P'),
(165841, 'Perkiomen', 40.1308288574219, 0.700415095116366, -75.4611129760742, -1.31704487865191, 218, 45, 'PPL', 'P'),
(165849, 'Perkiomen Heights', 40.3761100769043, 0.704696059989641, -75.51611328125, -1.31800481506683, 218, 45, 'PPL', 'P'),
(165843, 'Perkiomen Junction', 40.1163902282715, 0.700163093498217, -75.4755630493164, -1.31729708000714, 218, 45, 'PPL', 'P'),
(165844, 'Perkiomen Place', 40.401668548584, 0.705142139472229, -75.5033264160156, -1.31778164216748, 218, 45, 'PPL', 'P'),
(165846, 'Perkiomenville', 40.3241691589355, 0.703789519954578, -75.4783325195313, -1.31734541638093, 218, 45, 'PPL', 'P'),
(28217, 'Perks', 37.3097190856934, 0.651177441039517, -89.0808334350586, -1.55475384386242, 218, 18, 'PPL', 'P'),
(184072, 'Perks Corner', 38.7113914489746, 0.675641238812985, -120.83805847168, -2.10902198204824, 218, 6, 'PPL', 'P'),
(17581, 'Perky', 24.6483306884766, 0.430194525634277, -81.5719375610352, -1.4236988876713, 218, 12, 'PPL', 'P'),
(11146, 'Perla', 34.3644409179688, 0.599772639625617, -92.7713928222656, -1.61916625640957, 218, 4, 'PPL', 'P'),
(97007, 'Perlas de Naranja Colonia', 26.2469997406006, 0.458096564243578, -98.2939987182617, -1.71555391258475, 218, 51, 'PPL', 'P'),
(117264, 'Perlee', 41.0838890075684, 0.717049132705973, -91.9033279418945, -1.60401566612616, 218, 16, 'PPL', 'P'),
(137437, 'Perley', 47.1777801513672, 0.823407597423386, -96.8050003051758, -1.68956598771943, 218, 28, 'PPL', 'P'),
(110864, 'Perlytown (historical)', 38.982780456543, 0.680377870548773, -79.5547180175781, -1.38849176490239, 218, 58, 'PPL', 'P'),
(197236, 'Perma', 47.3638916015625, 0.826655855004956, -114.583892822266, -1.99986619950083, 218, 31, 'PPL', 'P'),
(11147, 'Perman (historical)', 34.6030616760254, 0.60393735751731, -91.0691680908203, -1.58945683023697, 218, 4, 'PPL', 'P'),
(50318, 'Permenter', 39.3666687011719, 0.687077984377249, -77.3172225952148, -1.34944010278385, 218, 25, 'PPL', 'P'),
(37641, 'Permon', 36.8108291625977, 0.642470169276476, -83.9811096191406, -1.46574687233229, 218, 21, 'PPL', 'P'),
(4957, 'Pernell', 32.4772186279297, 0.566834396947408, -87.1763916015625, -1.5215150634552, 218, 2, 'PPL', 'P'),
(76930, 'Pernell', 34.5613899230957, 0.60321004822361, -97.5097198486328, -1.70186566405591, 218, 42, 'PPL', 'P'),
(97008, 'Pernitas Point', 28.0597190856934, 0.489734485230042, -97.9044418334961, -1.70875486232178, 218, 51, 'PPL', 'P'),
(61283, 'Perota (historical)', 32.4180603027344, 0.565801889392785, -88.9749984741211, -1.55290667533034, 218, 30, 'PPL', 'P'),
(4958, 'Perote', 31.9475002288818, 0.55758906677563, -85.7052764892578, -1.49583926106964, 218, 2, 'PPL', 'P'),
(175796, 'Perote (historical)', 45.0911102294922, 0.786988336884335, -88.8127822875977, -1.55007546877548, 218, 57, 'PPL', 'P'),
(56847, 'Perrin', 39.6602783203125, 0.692202438946779, -94.4022216796875, -1.64762958950812, 218, 29, 'PPL', 'P'),
(97009, 'Perrin', 33.0338897705078, 0.576550141236235, -98.0688934326172, -1.71162508418661, 218, 51, 'PPL', 'P'),
(105192, 'Perrin', 37.2700004577637, 0.65048422020777, -76.4244384765625, -1.33385808040385, 218, 53, 'PPL', 'P'),
(199601, 'Perrin', 41.8125, 0.729765793490129, -103.245826721191, -1.80197961522833, 218, 35, 'PPL', 'P'),
(89844, 'Perrin Hollow', 36.1463890075684, 0.630873500888753, -83.6347198486328, -1.4597012303417, 218, 50, 'PPL', 'P'),
(17582, 'Perrine', 25.6047191619873, 0.446886653425162, -80.353889465332, -1.40243993795363, 218, 12, 'PPL', 'P'),
(195461, 'Perrine', 42.6538887023926, 0.744450796635962, -114.316108703613, -1.9951924849458, 218, 17, 'PPL', 'P'),
(165847, 'Perrine Corners', 41.2886085510254, 0.720622162782478, -80.0716705322266, -1.39751428835947, 218, 45, 'PPL', 'P'),
(146023, 'Perrineville', 40.228328704834, 0.702116788473899, -74.4411087036133, -1.29924244571306, 218, 37, 'PPL', 'P'),
(50319, 'Perring Village', 39.3875007629395, 0.687441572445072, -76.5475006103516, -1.336005919823, 218, 25, 'PPL', 'P'),
(125795, 'Perrins Crossing', 41.8861083984375, 0.731050502399983, -71.3222198486328, -1.24480756618989, 218, 23, 'PPL', 'P'),
(132583, 'Perrinton', 43.1827812194824, 0.75368171244834, -84.6791687011719, -1.47793030168718, 218, 27, 'PPL', 'P'),
(208421, 'Perrinville', 47.8288917541504, 0.834771638689891, -122.340278625488, -2.13524066982201, 218, 56, 'PPL', 'P'),
(184073, 'Perris', 33.7825012207031, 0.589615875860273, -117.227783203125, -2.04601079170864, 218, 6, 'PPL', 'P'),
(132584, 'Perronville', 45.7986106872559, 0.799336549331678, -87.3530578613281, -1.52459847136529, 218, 27, 'PPL', 'P'),
(82928, 'Perrot', 34.0341682434082, 0.594008294025168, -79.5991668701172, -1.38926754372793, 218, 48, 'PPL', 'P'),
(105193, 'Perrows', 37.1072196960449, 0.647643159956873, -79.1958312988281, -1.38222801001853, 218, 53, 'PPL', 'P'),
(105195, 'Perrowville', 38.5402793884277, 0.672654769966571, -77.809440612793, -1.35803092782823, 218, 53, 'PPL', 'P'),
(11148, 'Perry', 35.0475006103516, 0.611694280245357, -92.7938919067383, -1.6195589395123, 218, 4, 'PPL', 'P'),
(17583, 'Perry', 30.1172199249268, 0.525644649237211, -83.5819396972656, -1.45878004292064, 218, 12, 'PPL', 'P'),
(23846, 'Perry', 32.4580612182617, 0.566500037072549, -83.7316665649414, -1.46139326974028, 218, 13, 'PPL', 'P'),
(28219, 'Perry', 39.7830581665039, 0.694345351517912, -90.7452774047852, -1.58380387134912, 218, 18, 'PPL', 'P'),
(33606, 'Perry', 39.0758285522461, 0.682001866181503, -95.3930587768555, -1.6649229592046, 218, 20, 'PPL', 'P'),
(42539, 'Perry', 29.9483299255371, 0.522696962674171, -92.1569366455078, -1.60844197301593, 218, 22, 'PPL', 'P'),
(56848, 'Perry', 39.4311103820801, 0.688202703884617, -91.6750030517578, -1.60003064502902, 218, 29, 'PPL', 'P'),
(61284, 'Perry', 30.7205600738525, 0.536174921345439, -89.1413879394531, -1.55581071934102, 218, 30, 'PPL', 'P'),
(67694, 'Perry', 35.3333282470703, 0.616682913599293, -81.3486099243164, -1.41980108509986, 218, 33, 'PPL', 'P'),
(76931, 'Perry', 36.2894401550293, 0.633370214410703, -97.2877807617188, -1.69799209625039, 218, 42, 'PPL', 'P'),
(82929, 'Perry', 33.6266708374023, 0.58689612259703, -81.3116683959961, -1.41915633379995, 218, 48, 'PPL', 'P'),
(97010, 'Perry', 31.4177799224854, 0.548343703314338, -96.9150009155273, -1.69148586054927, 218, 51, 'PPL', 'P'),
(110865, 'Perry', 38.9713897705078, 0.680179065573399, -78.6752777099609, -1.37314263595972, 218, 58, 'PPL', 'P'),
(117265, 'Perry', 41.8386116027832, 0.730221526931669, -94.1069412231445, -1.64247597332465, 218, 16, 'PPL', 'P'),
(128523, 'Perry', 44.9749984741211, 0.784961804452839, -67.0763931274414, -1.17070391043595, 218, 26, 'PPL', 'P'),
(132585, 'Perry', 42.8263893127441, 0.747461500248297, -84.2194366455078, -1.46990646363888, 218, 27, 'PPL', 'P'),
(151644, 'Perry', 42.7155609130859, 0.745527179769545, -78.0058288574219, -1.36145854930922, 218, 40, 'PPL', 'P'),
(157085, 'Perry', 41.7602806091309, 0.728854393186077, -81.14111328125, -1.41617958549151, 218, 41, 'PPL', 'P'),
(172392, 'Perry', 44.6961097717285, 0.780094278349474, -72.086669921875, -1.25814973693508, 218, 55, 'PPL', 'P'),
(184075, 'Perry', 37.1836090087891, 0.648976404977594, -121.705276489258, -2.12415779178759, 218, 6, 'PPL', 'P'),
(199602, 'Perry', 40.2102813720703, 0.70180180309597, -100.722503662109, -1.75793931975585, 218, 35, 'PPL', 'P'),
(201388, 'Perry', 45.3486099243164, 0.791482554381898, -118.165557861328, -2.06237804713604, 218, 43, 'PPL', 'P'),
(205345, 'Perry', 41.4650001525879, 0.72370077700261, -112.031669616699, -1.9553215013179, 218, 52, 'PPL', 'P'),
(208422, 'Perry', 46.5958290100098, 0.81325063392096, -118.227783203125, -2.06346408422858, 218, 56, 'PPL', 'P'),
(73865, 'Perry Addition', 38.9102783203125, 0.679112469556822, -82.871940612793, -1.44638822121044, 218, 41, 'PPL', 'P'),
(151647, 'Perry Center', 42.7488899230957, 0.746108880730646, -78.0061111450195, -1.36146347615723, 218, 40, 'PPL', 'P'),
(157086, 'Perry Center', 41.2097206115723, 0.719245308498907, -83.4783325195313, -1.45697175654047, 218, 41, 'PPL', 'P'),
(151645, 'Perry City', 42.4919395446777, 0.741624250613007, -76.6949996948242, -1.33858026449073, 218, 40, 'PPL', 'P'),
(128524, 'Perry Cove', 43.8397216796875, 0.765147486468486, -69.8447189331055, -1.21902031051271, 218, 26, 'PPL', 'P'),
(30803, 'Perry Crossing', 38.4427795410156, 0.670953076609037, -85.7633285522461, -1.49685246070636, 218, 19, 'PPL', 'P'),
(50320, 'Perry Hall', 39.4124984741211, 0.687877864810654, -76.4638900756836, -1.33454664070369, 218, 25, 'PPL', 'P'),
(50322, 'Perry Hall Estates', 39.5466690063477, 0.690219582357161, -76.4622192382813, -1.33451747908976, 218, 25, 'PPL', 'P'),
(50323, 'Perry Hall Manor', 39.4300003051758, 0.688183329387686, -76.456672668457, -1.33442067318413, 218, 25, 'PPL', 'P'),
(50324, 'Perry Hall Park', 39.3899993896484, 0.687485181707922, -76.4697189331055, -1.33464837345734, 218, 25, 'PPL', 'P'),
(50325, 'Perry Hall Village', 39.4019393920898, 0.687693574063221, -76.4652786254883, -1.33457087546961, 218, 25, 'PPL', 'P'),
(157088, 'Perry Heights', 40.795280456543, 0.71201196324117, -81.4736099243164, -1.42198274666485, 218, 41, 'PPL', 'P'),
(67695, 'Perry Hills', 36.0980606079102, 0.630030011192498, -79.2094421386719, -1.38246556398776, 218, 33, 'PPL', 'P'),
(82931, 'Perry Hills', 34.8388900756836, 0.608053339561055, -82.5527801513672, -1.44081782031638, 218, 48, 'PPL', 'P'),
(132586, 'Perry Lake Heights', 42.8277816772461, 0.747485801593244, -83.4011077880859, -1.45562393071278, 218, 27, 'PPL', 'P'),
(97011, 'Perry Landing', 28.9797191619873, 0.50579151567997, -95.4891662597656, -1.66660035121719, 218, 51, 'PPL', 'P'),
(30804, 'Perry Manor', 39.6752815246582, 0.692464294260961, -86.1069412231445, -1.50284963316511, 218, 19, 'PPL', 'P'),
(125796, 'Perry Manor', 42.2000007629395, 0.736528957657413, -72.5541687011719, -1.26630912988287, 218, 23, 'PPL', 'P'),
(151646, 'Perry Mills', 45.0002784729004, 0.785403023666438, -73.5066680908203, -1.28293338035547, 218, 40, 'PPL', 'P'),
(37647, 'Perry Park', 38.5480613708496, 0.672790591182165, -84.9997177124023, -1.48352493734716, 218, 21, 'PPL', 'P'),
(89846, 'Perry Park', 36.4833297729492, 0.636754226628839, -86.851936340332, -1.51585225087131, 218, 50, 'PPL', 'P'),
(187187, 'Perry Park', 39.2566719055176, 0.685158178126438, -104.991943359375, -1.83245509968849, 218, 7, 'PPL', 'P'),
(50326, 'Perry Point', 39.5541687011719, 0.690350476724738, -76.0722198486328, -1.32771070565962, 218, 25, 'PPL', 'P'),
(4961, 'Perry Store', 31.2800006866455, 0.545939002008051, -86.1572189331055, -1.50372714474429, 218, 2, 'PPL', 'P'),
(50327, 'Perry View', 39.4130592346191, 0.68788765192766, -76.4725036621094, -1.33469697614723, 218, 25, 'PPL', 'P'),
(50328, 'Perry Wright', 38.5966682434082, 0.673638941147409, -77.1522216796875, -1.3465602935391, 218, 25, 'PPL', 'P'),
(117266, 'Perry Yard', 41.8444404602051, 0.73032325968531, -94.0872192382813, -1.64213175975376, 218, 16, 'PPL', 'P'),
(201389, 'Perrydale', 45.042781829834, 0.786144847188079, -123.254440307617, -2.15119580107073, 218, 43, 'PPL', 'P'),
(201390, 'Perrydale (historical)', 42.3238906860352, 0.738691244725475, -122.938606262207, -2.14568345708843, 218, 43, 'PPL', 'P'),
(50329, 'Perryman', 39.4694404602051, 0.688871689950445, -76.204719543457, -1.3300232615922, 218, 25, 'PPL', 'P'),
(165859, 'Perryopolis', 40.0869407653809, 0.699649103407832, -79.7508316040039, -1.39191459269342, 218, 45, 'PPL', 'P'),
(50330, 'Perrys Corner', 38.935001373291, 0.679543968232442, -76.1880569458008, -1.32973244440116, 218, 25, 'PPL', 'P'),
(125797, 'Perrys Corner', 41.8433303833008, 0.73030388518838, -71.2013931274414, -1.24269874208072, 218, 23, 'PPL', 'P'),
(128526, 'Perrys Corner', 43.7002792358398, 0.762713756706317, -70.8216705322266, -1.23607133255, 218, 26, 'PPL', 'P'),
(184076, 'Perrys Corner', 32.8616714477539, 0.573544364471917, -115.379173278809, -2.01374646194427, 218, 6, 'PPL', 'P'),
(165861, 'Perrys Corners', 41.1977806091309, 0.719036916143609, -80.0788879394531, -1.39764025587903, 218, 45, 'PPL', 'P'),
(50335, 'Perrys Haven', 38.2713890075684, 0.667961747493633, -75.6105575561523, -1.31965317862354, 218, 25, 'PPL', 'P'),
(4962, 'Perrys Mill', 32.2911109924316, 0.563586205944866, -86.158332824707, -1.50374658582024, 218, 2, 'PPL', 'P'),
(117272, 'Perrys Rollin'' Homes Manor', 41.9355583190918, 0.731913566330251, -91.658332824707, -1.59973969467993, 218, 16, 'PPL', 'P'),
(123417, 'Perrysburg', 40.8977813720703, 0.713800941703431, -86.1494369506836, -1.50359132352869, 218, 19, 'PPL', 'P'),
(151649, 'Perrysburg', 42.4563903808594, 0.741003800658045, -79.0022201538086, -1.37884885806938, 218, 40, 'PPL', 'P'),
(157106, 'Perrysburg', 41.5569381713867, 0.72530539813841, -83.6272201538086, -1.45957033597412, 218, 41, 'PPL', 'P'),
(157107, 'Perrysburg Estates Mobile Home Park', 41.4952812194824, 0.724229281320936, -83.5652770996094, -1.4584892257296, 218, 41, 'PPL', 'P'),
(157108, 'Perrysburg Heights', 41.5250015258789, 0.724747998522256, -83.6338882446289, -1.45968671611376, 218, 41, 'PPL', 'P'),
(123418, 'Perrysville', 40.0513916015625, 0.69902865345287, -87.4333267211914, -1.52599942725673, 218, 19, 'PPL', 'P'),
(157112, 'Perrysville', 40.4647216796875, 0.706242624213677, -81.0947189331055, -1.41536985136207, 218, 41, 'PPL', 'P'),
(165862, 'Perrysville', 40.5347213745117, 0.707464349363751, -80.0330581665039, -1.39684037544563, 218, 45, 'PPL', 'P'),
(157113, 'Perryton', 40.1444396972656, 0.700652649085601, -82.2011108398438, -1.43468003295207, 218, 41, 'PPL', 'P'),
(192038, 'Perryton', 36.4000015258789, 0.635299874357547, -100.802223205566, -1.75933068826737, 218, 51, 'PPL', 'P'),
(11152, 'Perrytown', 33.6963882446289, 0.588112920899087, -93.5369415283203, -1.63252760191461, 218, 4, 'PPL', 'P'),
(61286, 'Perrytown', 31.3299999237061, 0.546811653318243, -91.1661071777344, -1.5911487364775, 218, 30, 'PPL', 'P'),
(67697, 'Perrytown', 36.1377792358398, 0.630723232024246, -76.804443359375, -1.34049041678259, 218, 33, 'PPL', 'P'),
(50331, 'Perryvale', 39.3952789306641, 0.687577327081639, -76.4638900756836, -1.33454664070369, 218, 25, 'PPL', 'P'),
(4964, 'Perryville', 33.021110534668, 0.576327101494941, -85.8013916015625, -1.49751678624028, 218, 2, 'PPL', 'P'),
(11153, 'Perryville', 35.0047187805176, 0.610947596454726, -92.8024978637695, -1.61970914179778, 218, 4, 'PPL', 'P'),
(37645, 'Perryville', 37.2849998474121, 0.650746008942925, -85.8983306884766, -1.4992086924808, 218, 21, 'PPL', 'P'),
(42540, 'Perryville', 32.7077789306641, 0.570858433354518, -92.0052795410156, -1.6057950572085, 218, 22, 'PPL', 'P'),
(50332, 'Perryville', 39.560001373291, 0.690452276057407, -76.0716705322266, -1.3277011182797, 218, 25, 'PPL', 'P'),
(56851, 'Perryville', 37.7241706848145, 0.658410986034336, -89.8611068725586, -1.56837218441265, 218, 29, 'PPL', 'P'),
(89847, 'Perryville', 35.6205596923828, 0.621696048035259, -88.0416717529297, -1.53661705104871, 218, 50, 'PPL', 'P'),
(97012, 'Perryville', 32.8655586242676, 0.573612208500687, -95.1575012207031, -1.66081170427179, 218, 51, 'PPL', 'P'),
(121012, 'Perryville', 42.2216682434082, 0.736907126532204, -88.9794387817383, -1.55298417331807, 218, 18, 'PPL', 'P'),
(123419, 'Perryville', 40.5911102294922, 0.70844852054459, -85.0405578613281, -1.48423773241292, 218, 19, 'PPL', 'P'),
(125799, 'Perryville', 42.0250015258789, 0.733474644782228, -71.8880615234375, -1.25468336646024, 218, 23, 'PPL', 'P'),
(146024, 'Perryville', 40.6358299255371, 0.709229026481065, -74.9697189331055, -1.30846843467742, 218, 37, 'PPL', 'P'),
(151651, 'Perryville', 43.0069389343262, 0.750612685608133, -75.7997207641602, -1.32295469942691, 218, 40, 'PPL', 'P'),
(165865, 'Perryville', 40.5127792358398, 0.707081386798998, -79.5233306884766, -1.38794395266617, 218, 45, 'PPL', 'P'),
(169542, 'Perryville', 41.3997192382813, 0.722561410109247, -71.5616683959961, -1.2489867317305, 218, 47, 'PPL', 'P'),
(178846, 'Perryville', 33.4355583190918, 0.583560579910733, -112.460563659668, -1.96280711450989, 218, 5, 'PPL', 'P'),
(73877, 'Perryville (historical)', 39.1841697692871, 0.683892777134487, -84.7949981689453, -1.47995190727066, 218, 41, 'PPL', 'P'),
(189217, 'Perryville (historical)', 36.5361099243164, 0.637675414049898, -105.226936340332, -1.83655650092527, 218, 38, 'PPL', 'P'),
(50333, 'Perrywood', 39.4797210693359, 0.689051120428889, -76.2041702270508, -1.33001367421227, 218, 25, 'PPL', 'P'),
(50334, 'Perrywood Estates', 39.098331451416, 0.682394615863263, -76.9447174072266, -1.3429386607727, 218, 25, 'PPL', 'P'),
(89848, 'Persey', 35.0208282470703, 0.611228759686811, -90.0605621337891, -1.57185333543155, 218, 50, 'PPL', 'P'),
(28222, 'Pershing', 37.8800010681152, 0.66113073929758, -88.9652786254883, -1.55273703196891, 218, 18, 'PPL', 'P'),
(56852, 'Pershing', 38.577220916748, 0.673299521266479, -91.6141662597656, -1.59896884270241, 218, 29, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(76933, 'Pershing', 36.5933303833008, 0.638674099458677, -96.2750015258789, -1.68031576398915, 218, 42, 'PPL', 'P'),
(97013, 'Pershing', 30.2591705322266, 0.528122154709798, -97.7186126708984, -1.70551153158823, 218, 51, 'PPL', 'P'),
(117273, 'Pershing', 41.2630615234375, 0.720176283036972, -93.0061111450195, -1.62326286395638, 218, 16, 'PPL', 'P'),
(123420, 'Pershing', 41.0961112976074, 0.717262451909289, -86.3188934326172, -1.50654889707728, 218, 19, 'PPL', 'P'),
(197237, 'Pershing (historical)', 45.7552795410156, 0.798580278161123, -104.548606872559, -1.82471741829932, 218, 31, 'PPL', 'P'),
(89849, 'Persia', 36.3397216796875, 0.634247792568911, -83.003059387207, -1.44867667553515, 218, 50, 'PPL', 'P'),
(117274, 'Persia', 41.5800018310547, 0.725707934937175, -95.5677795410156, -1.6679724118108, 218, 16, 'PPL', 'P'),
(151652, 'Persia', 42.3852806091309, 0.739762701011041, -78.936393737793, -1.37769997037512, 218, 40, 'PPL', 'P'),
(56853, 'Persia (historical)', 39.0405616760254, 0.681386343074559, -92.3936080932617, -1.6125726690247, 218, 29, 'PPL', 'P'),
(23847, 'Persico', 32.9152793884277, 0.57447999954189, -84.6041717529297, -1.47662135801141, 218, 13, 'PPL', 'P'),
(23848, 'Persimmon', 34.896110534668, 0.609052024969835, -83.5119400024414, -1.45755831777056, 218, 13, 'PPL', 'P'),
(37646, 'Persimmon', 36.8030586242676, 0.642334547797964, -85.6425018310547, -1.49474363659718, 218, 21, 'PPL', 'P'),
(4969, 'Persimmon Grove', 32.3180618286133, 0.564056586772401, -88.0772171020508, -1.53723743442464, 218, 2, 'PPL', 'P'),
(37648, 'Persimmon Grove', 38.8997192382813, 0.678928178809388, -84.3436126708984, -1.47207374413399, 218, 21, 'PPL', 'P'),
(50336, 'Persimmon Hills', 38.6752815246582, 0.675011001741018, -76.6022186279297, -1.33696092938991, 218, 25, 'PPL', 'P'),
(105196, 'Persimmon Point', 37.8455581665039, 0.660529597260522, -75.5444412231445, -1.3184992309232, 218, 53, 'PPL', 'P'),
(205347, 'Persimmon Tree', 40.6055603027344, 0.70870072189982, -111.79167175293, -1.95113274839736, 218, 52, 'PPL', 'P'),
(110866, 'Persinger', 38.3219413757324, 0.668844052762776, -80.7522201538086, -1.40939211997928, 218, 58, 'PPL', 'P'),
(201391, 'Persist (historical)', 42.7666702270508, 0.746419205576667, -122.606109619141, -2.13988029591509, 218, 43, 'PPL', 'P'),
(4966, 'Persons', 32.1861114501953, 0.561753618219755, -85.2591705322266, -1.48805324330668, 218, 2, 'PPL', 'P'),
(4967, 'Persons Bridge (historical)', 32.9736099243164, 0.5754980594476, -85.6069412231445, -1.49412298690513, 218, 2, 'PPL', 'P'),
(151654, 'Persons Corners', 42.7702789306641, 0.746482189336447, -78.3888931274414, -1.36814428206781, 218, 40, 'PPL', 'P'),
(97015, 'Personville', 31.5125007629395, 0.549996893850519, -96.3363876342773, -1.68138715369569, 218, 51, 'PPL', 'P'),
(97014, 'Pert', 31.9222202301025, 0.557147847562031, -95.5469436645508, -1.66760875716395, 218, 51, 'PPL', 'P'),
(14400, 'Perth', 39.8036117553711, 0.694704079316745, -75.524169921875, -1.31814542997239, 218, 10, 'PPL', 'P'),
(30814, 'Perth', 39.5930595397949, 0.691029249907572, -87.1619415283203, -1.52126286209997, 218, 19, 'PPL', 'P'),
(33608, 'Perth', 37.1747207641602, 0.648821275844097, -97.504997253418, -1.70178323922017, 218, 20, 'PPL', 'P'),
(61287, 'Perth', 31.6591701507568, 0.552556757579816, -90.8677825927734, -1.58594199023029, 218, 30, 'PPL', 'P'),
(105197, 'Perth', 37.0163917541504, 0.646057913318004, -78.9952774047852, -1.37872768423978, 218, 53, 'PPL', 'P'),
(137441, 'Perth', 44.079719543457, 0.769336239389017, -94.3586120605469, -1.64686845806857, 218, 28, 'PPL', 'P'),
(140686, 'Perth', 48.7163887023926, 0.850261382538118, -99.4574966430664, -1.73586078221272, 218, 34, 'PPL', 'P'),
(151655, 'Perth', 43.0175018310547, 0.750797042934594, -74.1944427490234, -1.29493731265289, 218, 40, 'PPL', 'P'),
(200125, 'Perth', 40.1288909912109, 0.700381272970522, -118.514167785645, -2.06846243812049, 218, 39, 'PPL', 'P'),
(146025, 'Perth Amboy', 40.5066719055176, 0.706974793776367, -74.2658309936523, -1.29618327256889, 218, 37, 'PPL', 'P'),
(146026, 'Perth Amboy Junction', 40.5980606079102, 0.708569827532243, -74.2858276367188, -1.29653227982974, 218, 37, 'PPL', 'P'),
(61288, 'Perthshire', 33.9772186279297, 0.593014335727323, -90.9122161865234, -1.58671750273972, 218, 30, 'PPL', 'P'),
(56854, 'Pertle Springs', 38.732780456543, 0.676014547418787, -93.7313919067383, -1.63592140124975, 218, 29, 'PPL', 'P'),
(33609, 'Peru', 37.0886116027832, 0.647318387461938, -96.0944366455078, -1.67716431231321, 218, 20, 'PPL', 'P'),
(56855, 'Peru', 38.1824989318848, 0.666410323000607, -94.2916717529297, -1.64570012929836, 218, 29, 'PPL', 'P'),
(67699, 'Peru', 34.5505599975586, 0.603021030365241, -77.3680572509766, -1.35032733490101, 218, 33, 'PPL', 'P'),
(110867, 'Peru', 38.8408317565918, 0.6779003983657, -79.0744400024414, -1.38010933221332, 218, 58, 'PPL', 'P'),
(121014, 'Peru', 41.3274993896484, 0.721300935965312, -89.1288909912109, -1.55559260644774, 218, 18, 'PPL', 'P'),
(123421, 'Peru', 40.7536087036133, 0.71128465394747, -86.0688934326172, -1.50218557394729, 218, 19, 'PPL', 'P'),
(125800, 'Peru', 42.438060760498, 0.7406838884321, -73.04638671875, -1.27489995492724, 218, 23, 'PPL', 'P'),
(128527, 'Peru', 44.5066719055176, 0.77678796385614, -70.4058303833008, -1.22881355278926, 218, 26, 'PPL', 'P'),
(142658, 'Peru', 40.4741706848145, 0.70640754046418, -95.7333297729492, -1.67086180843548, 218, 35, 'PPL', 'P'),
(151658, 'Peru', 43.082218170166, 0.751926556131924, -76.408332824707, -1.3335769837508, 218, 40, 'PPL', 'P'),
(157114, 'Peru', 41.1699981689453, 0.718552021088132, -82.6425018310547, -1.44238375903735, 218, 41, 'PPL', 'P'),
(165867, 'Peru', 40.8547210693359, 0.713049397643811, -77.7669372558594, -1.35728910430659, 218, 45, 'PPL', 'P'),
(172394, 'Peru', 43.2297210693359, 0.754500967378676, -72.8983306884766, -1.27231588972154, 218, 55, 'PPL', 'P'),
(175799, 'Peru', 44.5699996948242, 0.777893242287551, -89.2433319091797, -1.5575899772653, 218, 57, 'PPL', 'P'),
(165868, 'Peru Mills', 40.3763885498047, 0.70470092025863, -77.6852798461914, -1.35586391364923, 218, 45, 'PPL', 'P'),
(189218, 'Peruhill', 32.3030586242676, 0.563794731458219, -107.80638885498, -1.88157644020473, 218, 38, 'PPL', 'P'),
(165869, 'Perulack', 40.3427810668945, 0.70411435902854, -77.6405563354492, -1.35508334113373, 218, 45, 'PPL', 'P'),
(56856, 'Peruque', 38.8683280944824, 0.678380299994132, -90.6080627441406, -1.58140902373886, 218, 29, 'PPL', 'P'),
(151660, 'Peruton', 42.5483283996582, 0.742608421793845, -76.3541717529297, -1.33263169472187, 218, 40, 'PPL', 'P'),
(205350, 'Peruvian Park', 40.5972213745117, 0.708555180146247, -111.844436645508, -1.95205366950231, 218, 52, 'PPL', 'P'),
(151661, 'Peruville', 42.5502815246582, 0.742642510255798, -76.3716735839844, -1.33293715929891, 218, 40, 'PPL', 'P'),
(184078, 'Pescadero', 37.2550010681152, 0.650222431472615, -122.380279541016, -2.13593881750178, 218, 6, 'PPL', 'P'),
(97016, 'Pescadito', 27.5102806091309, 0.480144974776885, -99.2572174072266, -1.73236525012393, 218, 51, 'PPL', 'P'),
(189219, 'Pescado', 35.1058311462402, 0.612712340151067, -108.579719543457, -1.89507360692536, 218, 38, 'PPL', 'P'),
(208423, 'Peshastin', 47.5708312988281, 0.830267634075321, -120.602783203125, -2.10491565396344, 218, 56, 'PPL', 'P'),
(132589, 'Peshawbestown', 45.024169921875, 0.785820008114117, -85.600830078125, -1.49401632730348, 218, 27, 'PPL', 'P'),
(175801, 'Peshtigo', 45.0544395446777, 0.786348312695361, -87.7491683959961, -1.53151190439708, 218, 57, 'PPL', 'P'),
(28223, 'Pesotum', 39.9147186279297, 0.696643260064487, -88.2733306884766, -1.54066026221567, 218, 18, 'PPL', 'P'),
(42541, 'Pesson', 29.9486103057861, 0.522701856232674, -91.8447189331055, -1.60299274595146, 218, 22, 'PPL', 'P'),
(71266, 'Pestletown', 39.7041702270508, 0.692968497234341, -74.8191680908203, -1.30584082678789, 218, 37, 'PPL', 'P'),
(67701, 'Pet Crossroads', 35.8283309936523, 0.625322341333565, -78.5113906860352, -1.37028226779092, 218, 33, 'PPL', 'P'),
(189221, 'Petaca', 36.5083312988281, 0.637190585573449, -106.01000213623, -1.85022357732344, 218, 38, 'PPL', 'P'),
(61289, 'Petal', 31.3463897705078, 0.547097710108831, -89.2600021362305, -1.55788092761439, 218, 30, 'PPL', 'P'),
(184079, 'Petaluma', 38.2324981689453, 0.667282974310799, -122.635559082031, -2.14039428600548, 218, 6, 'PPL', 'P'),
(67700, 'Petche Gap', 35.6963882446289, 0.623019505938973, -81.6163864135742, -1.42447466649684, 218, 33, 'PPL', 'P'),
(193868, 'Pete Hoff Place', 40.2172203063965, 0.701922910346541, -122.609718322754, -2.13994327967488, 218, 6, 'PPL', 'P'),
(61290, 'Peteet', 33.3430595397949, 0.581946171657927, -90.3877792358398, -1.57756435123117, 218, 30, 'PPL', 'P'),
(117276, 'Peter', 41.3547210693359, 0.721776043903782, -95.6538925170898, -1.66947536677198, 218, 16, 'PPL', 'P'),
(37649, 'Peter Creek', 36.8450012207031, 0.643066584202599, -85.9791717529297, -1.50061963522633, 218, 21, 'PPL', 'P'),
(128529, 'Peter Dana Point', 45.211669921875, 0.789092500461606, -67.6305618286133, -1.1803759788829, 218, 26, 'PPL', 'P'),
(97017, 'Peter Gort Colonia', 26.2719993591309, 0.458532889898674, -98.0270004272461, -1.71089391330933, 218, 51, 'PPL', 'P'),
(50337, 'Peter Harmond Acres', 39.2125015258789, 0.684387259569887, -76.8033294677734, -1.34047097570663, 218, 25, 'PPL', 'P'),
(165870, 'Peter Mans Corner', 40.4850006103516, 0.706596558322549, -79.8177795410156, -1.39308305462169, 218, 45, 'PPL', 'P'),
(11157, 'Peter Pender', 35.3600006103516, 0.617148434157839, -93.9341735839844, -1.63946060918041, 218, 4, 'PPL', 'P'),
(23849, 'Peter Point Oaks', 30.7555599212646, 0.536785783920476, -81.5227813720703, -1.42284095032613, 218, 13, 'PPL', 'P'),
(151662, 'Peterboro', 42.9672203063965, 0.749919464776385, -75.6883316040039, -1.32101059183115, 218, 40, 'PPL', 'P'),
(144308, 'Peterborough', 42.8705596923828, 0.748232418804847, -71.9522171020508, -1.25580309254056, 218, 36, 'PPL', 'P'),
(4971, 'Peterman', 31.5844402313232, 0.55125247443595, -87.2594375610352, -1.52296448887847, 218, 2, 'PPL', 'P'),
(76934, 'Peterman Ridge', 36.1961097717285, 0.631741291929956, -96.2888870239258, -1.68055811164835, 218, 42, 'PPL', 'P'),
(11156, 'Peters', 34.8194389343262, 0.607713853101097, -90.478889465332, -1.57915452471806, 218, 4, 'PPL', 'P'),
(17586, 'Peters', 25.5980606079102, 0.446770439733093, -80.3544387817383, -1.40244952533355, 218, 12, 'PPL', 'P'),
(82932, 'Peters', 34.0036087036133, 0.593474929437852, -81.3041687011719, -1.41902543943237, 218, 48, 'PPL', 'P'),
(97018, 'Peters', 29.8597202301025, 0.521150431739648, -96.186393737793, -1.67876926634414, 218, 51, 'PPL', 'P'),
(132590, 'Peters', 42.7444381713867, 0.746031183005842, -82.6316680908203, -1.44219467459995, 218, 27, 'PPL', 'P'),
(140689, 'Peters', 46.3838882446289, 0.809551569745867, -99.7069396972656, -1.74021438480472, 218, 34, 'PPL', 'P'),
(184081, 'Peters', 37.9808311462402, 0.662890556145904, -121.046943664551, -2.1126677164225, 218, 6, 'PPL', 'P'),
(4972, 'Peters (historical)', 34.3652801513672, 0.599787287011613, -86.1161117553711, -1.50300968914662, 218, 2, 'PPL', 'P'),
(199605, 'Peters (historical)', 42.5055618286133, 0.741862004319323, -102.635276794434, -1.7913235087586, 218, 35, 'PPL', 'P'),
(165871, 'Peters Corner', 40.375560760498, 0.704686472609717, -75.0419387817383, -1.30972890882136, 218, 45, 'PPL', 'P'),
(178847, 'Peters Corner', 32.8758316040039, 0.573791505821077, -112.048057556152, -1.95560752481897, 218, 5, 'PPL', 'P'),
(50338, 'Peters Corners', 39.1961097717285, 0.684101169489786, -75.7891693115234, -1.32277054183753, 218, 25, 'PPL', 'P'),
(151664, 'Peters Corners', 43.165828704834, 0.753385835251233, -74.4024963378906, -1.29856853279921, 218, 40, 'PPL', 'P'),
(28225, 'Peters Creek', 37.4877815246582, 0.654285216873586, -88.2413864135742, -1.54010272944146, 218, 18, 'PPL', 'P'),
(67702, 'Peters Creek', 34.8555603027344, 0.608344289910146, -78.5263900756836, -1.37054405652608, 218, 33, 'PPL', 'P'),
(105198, 'Peters Creek', 36.5922203063965, 0.638654724961747, -80.3169403076172, -1.40179505349567, 218, 53, 'PPL', 'P'),
(212084, 'Peters Creek', 61.4111099243164, 1.07182606548349, -149.445556640625, -2.60831701585458, 218, 1, 'PPL', 'P'),
(82933, 'Peters Ferry Landing', 33.936939239502, 0.59231132777857, -79.3177795410156, -1.38435640836172, 218, 48, 'PPL', 'P'),
(56857, 'Peters Ford', 38.374439239502, 0.669760313335818, -91.2074966430664, -1.59187111892318, 218, 29, 'PPL', 'P'),
(110868, 'Peters Junction', 38.2244415283203, 0.667142359405243, -81.0486068725586, -1.41456504408065, 218, 58, 'PPL', 'P'),
(89850, 'Peters Mill', 35.9672203063965, 0.627746417136782, -83.7022171020508, -1.46087927964989, 218, 50, 'PPL', 'P'),
(97019, 'Peters Prairie', 33.5430603027344, 0.585436843477721, -95.0047225952148, -1.65814521423035, 218, 51, 'PPL', 'P'),
(165872, 'Peters Store', 40.7205581665039, 0.710707813255358, -75.6436080932617, -1.32023001931565, 218, 45, 'PPL', 'P'),
(30815, 'Peters Switch', 39.021671295166, 0.681056643731607, -85.8966674804688, -1.49917966402492, 218, 19, 'PPL', 'P'),
(205351, 'Petersboro', 41.7691688537598, 0.729009522319574, -111.980827331543, -1.95443413604268, 218, 52, 'PPL', 'P'),
(14402, 'Petersburg', 39.0491714477539, 0.681536611939067, -75.6486129760742, -1.3203173709994, 218, 10, 'PPL', 'P'),
(23850, 'Petersburg', 34.586669921875, 0.603651267437209, -84.7155609130859, -1.47856546560716, 218, 13, 'PPL', 'P'),
(30816, 'Petersburg', 38.4919395446777, 0.671811080533233, -87.2786102294922, -1.52329911506944, 218, 19, 'PPL', 'P'),
(33611, 'Petersburg', 37.7758293151855, 0.659312599221383, -94.9791717529297, -1.65769926790582, 218, 20, 'PPL', 'P'),
(37651, 'Petersburg', 38.1786117553711, 0.666342478971838, -85.6594390869141, -1.49503924747818, 218, 21, 'PPL', 'P'),
(50339, 'Petersburg', 38.6036109924316, 0.673760114977008, -75.8569412231445, -1.32395338483569, 218, 25, 'PPL', 'P'),
(56859, 'Petersburg', 39.0583305358887, 0.681696468183499, -92.8930587768555, -1.62128972790474, 218, 29, 'PPL', 'P'),
(67706, 'Petersburg', 34.9275016784668, 0.609599903785091, -77.5388870239258, -1.35330887689941, 218, 33, 'PPL', 'P'),
(76935, 'Petersburg', 33.9550018310547, 0.592626579472608, -97.5694427490234, -1.70290802530657, 218, 42, 'PPL', 'P'),
(89852, 'Petersburg', 35.3197212219238, 0.616445426209086, -86.6374969482422, -1.51210957743337, 218, 50, 'PPL', 'P'),
(105201, 'Petersburg', 37.2277793884277, 0.649747323534145, -77.4022216796875, -1.35092361666908, 218, 53, 'PPL', 'P'),
(110871, 'Petersburg', 38.9925003051758, 0.680547513910211, -79.1241683959961, -1.38097725641257, 218, 58, 'PPL', 'P'),
(117278, 'Petersburg', 41.560001373291, 0.725358861097293, -90.7938919067383, -1.58465235447242, 218, 16, 'PPL', 'P'),
(121016, 'Petersburg', 40.0116691589355, 0.698335366042096, -89.8480606079102, -1.56814448413945, 218, 18, 'PPL', 'P'),
(132591, 'Petersburg', 41.9011116027832, 0.731312357714165, -83.7149963378906, -1.46110231939119, 218, 27, 'PPL', 'P'),
(137443, 'Petersburg', 43.5302810668945, 0.75974672893586, -94.9186096191406, -1.65664225926916, 218, 28, 'PPL', 'P'),
(140690, 'Petersburg', 48.0111083984375, 0.837951919084636, -98.001106262207, -1.71044197487235, 218, 34, 'PPL', 'P'),
(142661, 'Petersburg', 41.853328704834, 0.730478388818807, -98.0783309936523, -1.71178980070004, 218, 35, 'PPL', 'P'),
(146029, 'Petersburg', 40.8794403076172, 0.713480829740404, -74.8580627441406, -1.30651966654976, 218, 37, 'PPL', 'P'),
(151665, 'Petersburg', 42.749439239502, 0.74611846811057, -73.3405609130859, -1.28003426319281, 218, 40, 'PPL', 'P'),
(157117, 'Petersburg', 40.9124984741211, 0.714057803590569, -80.5305633544922, -1.40552347902178, 218, 41, 'PPL', 'P'),
(165875, 'Petersburg', 41.4391708374023, 0.723249970409087, -80.254997253418, -1.40071394325115, 218, 45, 'PPL', 'P'),
(175804, 'Petersburg', 43.2722206115723, 0.75524272432129, -90.8375015258789, -1.58541348591196, 218, 57, 'PPL', 'P'),
(192039, 'Petersburg', 33.8694381713867, 0.591133211891346, -101.596939086914, -1.77320109701477, 218, 51, 'PPL', 'P'),
(193283, 'Petersburg', 56.8125, 0.991565181289279, -132.95556640625, -2.32051239264303, 218, 1, 'PPL', 'P'),
(201392, 'Petersburg', 45.6111106872559, 0.796064056984188, -121.076942443848, -2.11319129389281, 218, 43, 'PPL', 'P'),
(30817, 'Petersburg (historical)', 38.7669410705566, 0.676610762607829, -86.1413879394531, -1.50345084178119, 218, 19, 'PPL', 'P'),
(56861, 'Petersburg (historical)', 38.8011093139648, 0.677207110954925, -92.8022232055664, -1.61970434810782, 218, 29, 'PPL', 'P'),
(184082, 'Petersburg (historical)', 35.6025009155273, 0.621380862920248, -118.602783203125, -2.07000906892356, 218, 6, 'PPL', 'P'),
(67707, 'Petersburg Crossing', 34.954719543457, 0.610074945144534, -77.7669372558594, -1.35728910430659, 218, 33, 'PPL', 'P'),
(132592, 'Petersburg Junction', 41.8852806091309, 0.73103605475107, -83.7024993896484, -1.46088420649791, 218, 27, 'PPL', 'P'),
(151666, 'Petersburg Junction', 42.8349990844727, 0.747611769112804, -73.3258285522461, -1.27977713498956, 218, 40, 'PPL', 'P'),
(23851, 'Petersburg Station', 33.5319404602051, 0.585242765613281, -82.0972213745117, -1.43286681972389, 218, 13, 'PPL', 'P'),
(157118, 'Petersburgh', 40.5138893127441, 0.707100761295928, -81.1125030517578, -1.41568024278712, 218, 41, 'PPL', 'P'),
(82934, 'Petersfield', 33.6794395446777, 0.587817110281006, -79.2305603027344, -1.38283414548263, 218, 48, 'PPL', 'P'),
(125803, 'Petersham', 42.4874992370605, 0.741546752625285, -72.1875, -1.25990955378341, 218, 23, 'PPL', 'P'),
(4973, 'Peterson', 33.2324981689453, 0.580016511711082, -87.4236068725586, -1.52582978389529, 218, 2, 'PPL', 'P'),
(17587, 'Peterson', 30.0925006866455, 0.525213217140619, -83.2152786254883, -1.45238059997923, 218, 12, 'PPL', 'P'),
(67708, 'Peterson', 36.040828704834, 0.629031126046637, -82.335563659668, -1.4370266773466, 218, 33, 'PPL', 'P'),
(105203, 'Peterson', 36.728328704834, 0.641030264654098, -82.7975006103516, -1.44508899807265, 218, 53, 'PPL', 'P'),
(110869, 'Peterson', 38.8927803039551, 0.678807071558817, -80.5397186279297, -1.40568326868718, 218, 58, 'PPL', 'P'),
(117279, 'Peterson', 42.9180603027344, 0.749061460852189, -95.3436126708984, -1.66405996185336, 218, 16, 'PPL', 'P'),
(123423, 'Peterson', 40.813060760498, 0.712322288087192, -85.0147171020508, -1.48378672608232, 218, 19, 'PPL', 'P'),
(137445, 'Peterson', 43.7863883972168, 0.764216645088476, -91.834716796875, -1.60281817574201, 218, 28, 'PPL', 'P'),
(178848, 'Peterson', 33.3783302307129, 0.582561761343898, -111.942779541016, -1.95377007682487, 218, 5, 'PPL', 'P'),
(187845, 'Peterson', 38.0325012207031, 0.663792369070032, -101.066673278809, -1.76394621275258, 218, 20, 'PPL', 'P'),
(205354, 'Peterson', 41.1836090087891, 0.718789575057368, -112.014442443848, -1.95502083043083, 218, 52, 'PPL', 'P'),
(178849, 'Peterson (historical)', 33.3769416809082, 0.582537526577979, -111.956939697266, -1.95401721817403, 218, 5, 'PPL', 'P'),
(195462, 'Peterson (historical)', 43.2400016784668, 0.75468039785712, -112.375282287598, -1.96131867377664, 218, 17, 'PPL', 'P'),
(208424, 'Peterson Corner', 46.8238906860352, 0.81723106106522, -123.115829467773, -2.1487765855365, 218, 56, 'PPL', 'P'),
(23852, 'Peterson Hill', 31.7816696166992, 0.554694776592446, -84.8483276367188, -1.48088268207164, 218, 13, 'PPL', 'P'),
(97020, 'Peterson Landing', 29.2430591583252, 0.510387665668256, -95.2291717529297, -1.6620625910358, 218, 51, 'PPL', 'P'),
(184083, 'Peterson Mill', 37.2544403076172, 0.650212644355609, -118.477500915527, -2.06782248051055, 218, 6, 'PPL', 'P'),
(184084, 'Peterson Place', 39.8783302307129, 0.69600816272353, -122.76277923584, -2.14261469656433, 218, 6, 'PPL', 'P'),
(197238, 'Peterson Place', 45.3738899230957, 0.791923773595497, -109.455276489258, -1.91035495841829, 218, 31, 'PPL', 'P'),
(23853, 'Petersons (historical)', 30.9722194671631, 0.54056720635228, -82.0263900756836, -1.43163058034588, 218, 13, 'PPL', 'P'),
(195463, 'Petersons Crossing', 43.122501373291, 0.752629630659705, -116.875556945801, -2.03986328380635, 218, 17, 'PPL', 'P'),
(190603, 'Petersons Mill', 39.5577812194824, 0.690413527063546, -117.431671142578, -2.0495693075572, 218, 39, 'PPL', 'P'),
(110870, 'Peterstown', 37.3972206115723, 0.652704630766623, -80.7994384765625, -1.41021623517861, 218, 58, 'PPL', 'P'),
(121019, 'Peterstown', 41.4980583190918, 0.724277750852775, -89.1466674804688, -1.55590286471474, 218, 18, 'PPL', 'P'),
(4974, 'Petersville', 34.855281829834, 0.608339429641157, -87.6916732788086, -1.53050842529834, 218, 2, 'PPL', 'P'),
(30818, 'Petersville', 39.2244415283203, 0.684595651925186, -85.8199996948242, -1.49784155873521, 218, 19, 'PPL', 'P'),
(37652, 'Petersville', 38.4441719055176, 0.670977377953984, -83.4905624389648, -1.45718520890184, 218, 21, 'PPL', 'P'),
(50340, 'Petersville', 39.3463897705078, 0.686724050268377, -77.6111068725586, -1.35456935104335, 218, 25, 'PPL', 'P'),
(56862, 'Petersville', 38.5872192382813, 0.673474024896906, -90.7466735839844, -1.58382823927309, 218, 29, 'PPL', 'P'),
(67709, 'Petersville', 35.8258285522461, 0.625278665491688, -80.4150009155273, -1.40350653397021, 218, 33, 'PPL', 'P'),
(97021, 'Petersville', 29.3125, 0.511599636990838, -97.2163925170898, -1.6967461363344, 218, 51, 'PPL', 'P'),
(117282, 'Petersville', 41.9674987792969, 0.732471032525432, -90.5336074829102, -1.58010953428496, 218, 16, 'PPL', 'P'),
(121020, 'Petersville', 41.2794418334961, 0.720462173379992, -90.9383316040039, -1.58717330276028, 218, 18, 'PPL', 'P'),
(165878, 'Petersville', 40.752498626709, 0.711265279450539, -75.477783203125, -1.317335829001, 218, 45, 'PPL', 'P'),
(212085, 'Petersville', 62.4963912963867, 1.09076779873668, -150.765563964844, -2.63135548981264, 218, 1, 'PPL', 'P'),
(175805, 'Petersville (historical)', 44.538330078125, 0.777340503203305, -89.1833267211914, -1.55654268916663, 218, 57, 'PPL', 'P'),
(33612, 'Peterton', 38.6736106872559, 0.674981840127082, -95.8166732788086, -1.67231642702288, 218, 20, 'PPL', 'P'),
(61291, 'Petertown', 34.6594390869141, 0.604921328961068, -88.1324996948242, -1.53820229768758, 218, 30, 'PPL', 'P'),
(121021, 'Peterville', 40.2169418334961, 0.701918050077552, -89.9930572509766, -1.5706751529653, 218, 18, 'PPL', 'P'),
(76936, 'Petes Corner', 36.2902793884277, 0.633384861796698, -97.1033325195313, -1.6947728671247, 218, 42, 'PPL', 'P'),
(4975, 'Petes Crossroads', 33.750560760498, 0.589058409665092, -87.0013885498047, -1.51846068400099, 218, 2, 'PPL', 'P'),
(175806, 'Petes Landing', 46.0497207641602, 0.803719246958594, -90.3272171020508, -1.57650734259452, 218, 57, 'PPL', 'P'),
(209664, 'Petes Place', 41.0027809143066, 0.715633529428542, -109.024169921875, -1.90283072939049, 218, 59, 'PPL', 'P'),
(42542, 'Petetin', 30.3830604553223, 0.530284441777861, -92.0552825927734, -1.60666777509772, 218, 22, 'PPL', 'P'),
(37658, 'Peth', 37.4069404602051, 0.652874274128062, -86.4366683959961, -1.50860445796466, 218, 21, 'PPL', 'P'),
(151668, 'Peth', 42.1944389343262, 0.736431885435679, -78.6594390869141, -1.37286619983857, 218, 40, 'PPL', 'P'),
(172396, 'Peth', 43.9700012207031, 0.767421293407195, -72.668327331543, -1.26830157385241, 218, 55, 'PPL', 'P'),
(340, 'Petit Jean', 35.0905609130859, 0.612445824304977, -93.1802825927734, -1.62630272918266, 218, 4, 'PPL', 'P'),
(42543, 'Petite Place', 30.5736103057861, 0.533610164057638, -91.1997222900391, -1.59173543086564, 218, 22, 'PPL', 'P'),
(89855, 'Petlier (historical)', 36.5563888549805, 0.638029348158769, -82.5680618286133, -1.44108453589955, 218, 50, 'PPL', 'P'),
(132594, 'Petoskey', 45.3733291625977, 0.791913986478491, -84.9552764892578, -1.48274929167968, 218, 27, 'PPL', 'P'),
(37653, 'Petra', 38.6241683959961, 0.674118909354869, -84.1338882446289, -1.46841336237373, 218, 21, 'PPL', 'P'),
(67710, 'Petra Mills', 35.8405609130859, 0.625535793694935, -81.3619384765625, -1.42003371222107, 218, 33, 'PPL', 'P'),
(137447, 'Petran', 43.6566696166992, 0.761952625266772, -93.2088928222656, -1.62680207188705, 218, 28, 'PPL', 'P'),
(73879, 'Petrea', 39.0733299255371, 0.681958256918653, -82.600830078125, -1.44165644974365, 218, 41, 'PPL', 'P'),
(198739, 'Petrel', 45.9483299255371, 0.801949642993264, -102.276672363281, -1.78506468072275, 218, 34, 'PPL', 'P'),
(4976, 'Petrey', 31.8486099243164, 0.555863105362663, -86.2077789306641, -1.50460958317148, 218, 2, 'PPL', 'P'),
(37654, 'Petri', 37.9263916015625, 0.661940406847991, -86.8041687011719, -1.51501854829206, 218, 21, 'PPL', 'P'),
(209665, 'Petrie', 43.0316696166992, 0.751044317441808, -106.739723205566, -1.86295961260453, 218, 59, 'PPL', 'P'),
(151669, 'Petries Corners', 43.8041687011719, 0.764526969934497, -75.3619384765625, -1.31531395710142, 218, 40, 'PPL', 'P'),
(132596, 'Petrieville', 42.5355606079102, 0.742385581789633, -84.6213912963867, -1.47692189574042, 218, 27, 'PPL', 'P'),
(184085, 'Petro (historical)', 35.6963882446289, 0.623019505938973, -119.329437255859, -2.08269157466673, 218, 6, 'PPL', 'P'),
(37655, 'Petroleum', 36.6952781677246, 0.640453423961986, -86.2483291625977, -1.50531731823117, 218, 21, 'PPL', 'P'),
(110879, 'Petroleum', 39.1908302307129, 0.684009024116069, -81.2686080932617, -1.41840478974033, 218, 58, 'PPL', 'P'),
(123424, 'Petroleum', 40.6113891601563, 0.708802454653461, -85.1508331298828, -1.48616239893272, 218, 19, 'PPL', 'P'),
(157119, 'Petroleum', 41.2011108398438, 0.7190950396344, -80.5369415283203, -1.40563479915534, 218, 41, 'PPL', 'P'),
(184086, 'Petroleum (historical)', 36.9916687011719, 0.645626414642384, -122.136108398438, -2.13167722712543, 218, 6, 'PPL', 'P'),
(165879, 'Petroleum Center', 41.5161094665527, 0.724592802809732, -79.682502746582, -1.39072202915728, 218, 45, 'PPL', 'P'),
(28229, 'Petrolia', 38.7605590820313, 0.676499375895236, -87.7788925170898, -1.53203068817743, 218, 18, 'PPL', 'P'),
(33613, 'Petrolia', 37.7458305358887, 0.658789021751073, -95.4713897705078, -1.66629009295019, 218, 20, 'PPL', 'P'),
(97022, 'Petrolia', 34.0130615234375, 0.593639912267383, -98.2319412231445, -1.71447080496942, 218, 51, 'PPL', 'P'),
(151670, 'Petrolia', 42.0894393920898, 0.734599297710568, -78.0186080932617, -1.36168158905051, 218, 40, 'PPL', 'P'),
(165880, 'Petrolia', 41.0166702270508, 0.715875943666766, -79.7177810668945, -1.39133775200131, 218, 45, 'PPL', 'P'),
(193869, 'Petrolia', 40.3255615234375, 0.703813821299525, -124.285827636719, -2.1691969058269, 218, 6, 'PPL', 'P'),
(4977, 'Petronia', 32.2658309936523, 0.563144986731267, -86.7886123657227, -1.51474703901893, 218, 2, 'PPL', 'P'),
(97023, 'Petronila', 27.6716709136963, 0.482961766972348, -97.6355590820313, -1.7040619730069, 218, 51, 'PPL', 'P'),
(37656, 'Petros', 36.8972206115723, 0.643977984506652, -86.5966720581055, -1.51139704868371, 218, 21, 'PPL', 'P'),
(76937, 'Petros', 34.8694381713867, 0.608586504411289, -94.6086120605469, -1.65123178119856, 218, 42, 'PPL', 'P'),
(89854, 'Petros', 36.0958290100098, 0.629991062461556, -84.442497253418, -1.47379960567841, 218, 50, 'PPL', 'P'),
(23854, 'Petross', 32.1477813720703, 0.561084632153927, -82.4669418334961, -1.43931965904516, 218, 13, 'PPL', 'P'),
(169543, 'Pettaquamscutt Lake Shores', 41.4930610656738, 0.724190532327075, -71.4463882446289, -1.24697471352695, 218, 47, 'PPL', 'P'),
(50341, 'Pettebone Farms', 39.0336112976074, 0.681265036086906, -76.4247207641602, -1.33386300725187, 218, 25, 'PPL', 'P'),
(97024, 'Petteway', 31.184440612793, 0.544271164085875, -96.5377807617188, -1.68490212686043, 218, 51, 'PPL', 'P'),
(97025, 'Pettibone', 30.8497200012207, 0.53842918733965, -97.0805587768555, -1.69437539033201, 218, 51, 'PPL', 'P'),
(140696, 'Pettibone', 47.1191711425781, 0.822384677248687, -99.519172668457, -1.73693723192533, 218, 34, 'PPL', 'P'),
(11161, 'Pettigrew', 35.8177795410156, 0.625138183744186, -93.6483306884766, -1.63447170951036, 218, 4, 'PPL', 'P'),
(97026, 'Pettigrew', 33.6455612182617, 0.587225821939982, -96.019172668457, -1.67585070810552, 218, 51, 'PPL', 'P'),
(117281, 'Pettis', 42.3686103820801, 0.73947175066195, -94.9355621337891, -1.65693813646627, 218, 16, 'PPL', 'P'),
(157120, 'Pettisville', 41.5305595397949, 0.724845004164962, -84.2297210693359, -1.47008596069635, 218, 41, 'PPL', 'P'),
(37657, 'Pettit', 37.6888885498047, 0.657795196611283, -87.1319427490234, -1.52073928462966, 218, 21, 'PPL', 'P'),
(76939, 'Pettit', 35.764720916748, 0.624212136054138, -94.9652786254883, -1.65745678708857, 218, 42, 'PPL', 'P'),
(123425, 'Pettit', 40.4174995422363, 0.705418442435325, -86.7091674804688, -1.51336046419738, 218, 19, 'PPL', 'P'),
(192040, 'Pettit', 33.6969413757324, 0.588122574858038, -102.524169921875, -1.78938432801086, 218, 51, 'PPL', 'P'),
(110872, 'Pettit (historical)', 39.0208282470703, 0.681041929766584, -79.7183303833008, -1.39134733938123, 218, 58, 'PPL', 'P'),
(76938, 'Pettit Bay', 35.752498626709, 0.623998816850823, -94.9430618286133, -1.65706903083385, 218, 42, 'PPL', 'P'),
(177264, 'Pettit Heights', 40.2294387817383, 0.702136162970829, -80.6338882446289, -1.40732683855393, 218, 58, 'PPL', 'P'),
(177678, 'Pettit Place', 35.639720916748, 0.622030474489145, -118.616668701172, -2.07025141658276, 218, 6, 'PPL', 'P'),
(192041, 'Pettits', 28.9983291625977, 0.506116321464419, -103.28360748291, -1.80263901391424, 218, 51, 'PPL', 'P'),
(110873, 'Pettry', 37.4361114501953, 0.653383403949457, -80.9641723632813, -1.41309138389146, 218, 58, 'PPL', 'P'),
(110874, 'Pettry Bottom', 37.8730583190918, 0.661009565467981, -81.5016708374023, -1.42247250198932, 218, 58, 'PPL', 'P'),
(11165, 'Pettus', 34.6772193908691, 0.605231653807089, -91.9124984741211, -1.60417572210768, 218, 4, 'PPL', 'P'),
(97027, 'Pettus', 28.6177806854248, 0.499474497574302, -97.8019409179688, -1.70696588385952, 218, 51, 'PPL', 'P'),
(110875, 'Pettus', 37.9563903808594, 0.662463984318301, -81.5377807617188, -1.42310273906128, 218, 58, 'PPL', 'P'),
(4978, 'Pettusville', 34.9716682434082, 0.610370755762615, -86.9461135864258, -1.51749595389611, 218, 2, 'PPL', 'P'),
(192042, 'Petty', 33.2830581665039, 0.58089895013828, -101.980278015137, -1.77989162346332, 218, 51, 'PPL', 'P'),
(23855, 'Petty (historical)', 31.1783294677734, 0.544164504484218, -84.1680603027344, -1.46900977729985, 218, 13, 'PPL', 'P'),
(105205, 'Petty Acres', 37.3347206115723, 0.651613799984127, -79.9458312988281, -1.39531797940849, 218, 53, 'PPL', 'P'),
(175807, 'Petty Acres', 42.9461097717285, 0.749551016439573, -89.2188873291016, -1.55716333885867, 218, 57, 'PPL', 'P'),
(151671, 'Petty Corner', 42.917781829834, 0.7490566005832, -76.5077819824219, -1.33531269899126, 218, 40, 'PPL', 'P'),
(144310, 'Pettyboro', 44.2041702270508, 0.771508313574086, -71.9619369506836, -1.255972735902, 218, 36, 'PPL', 'P'),
(110876, 'Pettyjohn (historical)', 39.4666709899902, 0.68882335357666, -80.154167175293, -1.39895412640283, 218, 58, 'PPL', 'P'),
(89856, 'Pettyjohn Mill', 36.5302810668945, 0.637573681296256, -82.4477767944336, -1.43898516601224, 218, 50, 'PPL', 'P'),
(193870, 'Pettyjohn Place', 40.1736106872559, 0.701161778906997, -122.67472076416, -2.14107778629925, 218, 6, 'PPL', 'P'),
(97030, 'Pettys Chapel', 32.1228485107422, 0.560649471631808, -96.4360733032227, -1.68312699683584, 218, 51, 'PPL', 'P'),
(105206, 'Pettys Corner', 36.7724990844727, 0.641801183210648, -78.2574996948242, -1.36585103405314, 218, 53, 'PPL', 'P'),
(56865, 'Pettys Hill', 38.5480613708496, 0.672790591182165, -90.5052795410156, -1.57961511842858, 218, 29, 'PPL', 'P'),
(67711, 'Pettys Shore', 36.3641700744629, 0.634674497554569, -76.8277816772461, -1.34089774727132, 218, 33, 'PPL', 'P'),
(123426, 'Pettysville', 40.8813896179199, 0.713514851623329, -85.9816665649414, -1.50066317791015, 218, 19, 'PPL', 'P'),
(132597, 'Pettysville', 42.4752807617188, 0.741333500000997, -83.8694381713867, -1.46379783788851, 218, 27, 'PPL', 'P'),
(97029, 'Pettytown', 29.9072208404541, 0.52197947378699, -97.4591674804688, -1.70098335878677, 218, 51, 'PPL', 'P'),
(11163, 'Pettyview', 34.4049987792969, 0.60048050784336, -93.1669387817383, -1.62606983574533, 218, 4, 'PPL', 'P'),
(11164, 'Pettyville', 35.8458290100098, 0.62562773933157, -90.1194381713867, -1.57288091613816, 218, 4, 'PPL', 'P'),
(110877, 'Pettyville', 39.2119407653809, 0.684377472452881, -81.543327331543, -1.42319954496691, 218, 58, 'PPL', 'P'),
(105207, 'Petunia', 36.9422187805176, 0.644763350712116, -81.1216735839844, -1.41584029876864, 218, 53, 'PPL', 'P'),
(89857, 'Petway', 36.2150001525879, 0.632070991272908, -87.1524963378906, -1.52109801242849, 218, 50, 'PPL', 'P'),
(13186, 'Petworth', 38.9458312988281, 0.67973298609081, -77.0252838134766, -1.34434480982826, 218, 9, 'PPL', 'P'),
(189222, 'Peveler Place', 33.1450004577637, 0.578489388563004, -103.430557250977, -1.80520377120204, 218, 38, 'PPL', 'P'),
(56866, 'Pevely', 38.2833290100098, 0.668170139848932, -90.3949966430664, -1.57769031875073, 218, 29, 'PPL', 'P'),
(97031, 'Peveto', 30.1355590820313, 0.525964727910725, -93.8197174072266, -1.63746297204674, 218, 51, 'PPL', 'P'),
(42546, 'Peveto Beach', 29.7608299255371, 0.519424470326681, -93.5583267211914, -1.63290084394138, 218, 22, 'PPL', 'P'),
(110878, 'Pew Hill', 39.1822204589844, 0.683858755251561, -81.144172668457, -1.41623298187137, 218, 58, 'PPL', 'P'),
(132598, 'Pewabic', 47.1399993896484, 0.822748198737483, -88.5630569458008, -1.54571693933546, 218, 27, 'PPL', 'P'),
(132599, 'Pewamo', 43.0011100769043, 0.750510952854492, -84.8469390869141, -1.48085844730572, 218, 27, 'PPL', 'P'),
(175808, 'Pewaukee', 43.0805587768555, 0.751897594255069, -88.2611083984375, -1.54044694301235, 218, 57, 'PPL', 'P'),
(175813, 'Pewaukee West', 43.0747184753418, 0.751795661764346, -88.3308334350586, -1.54166387447247, 218, 57, 'PPL', 'P'),
(37659, 'Pewee Valley', 38.3105583190918, 0.668645380945456, -85.4875030517578, -1.49203839756187, 218, 21, 'PPL', 'P'),
(137448, 'Peyla', 47.7852783203125, 0.834010440671319, -92.3630599975586, -1.61203950417446, 218, 28, 'PPL', 'P'),
(61292, 'Peyton', 31.8374996185303, 0.555669193945792, -90.8022232055664, -1.58479776306793, 218, 30, 'PPL', 'P'),
(105208, 'Peyton', 38.1344413757324, 0.665571560415287, -79.043327331543, -1.37956631366705, 218, 53, 'PPL', 'P'),
(175811, 'Peyton', 46.6502799987793, 0.814200982955955, -92.021110534668, -1.6060713601716, 218, 57, 'PPL', 'P'),
(187188, 'Peyton', 39.0288887023926, 0.681182611251168, -104.482498168945, -1.82356360375704, 218, 7, 'PPL', 'P'),
(208425, 'Peyton', 46.6283302307129, 0.813817887233147, -117.799171447754, -2.0559833978846, 218, 56, 'PPL', 'P'),
(37660, 'Peytona', 38.1811103820801, 0.666386088234687, -85.0611114501953, -1.48459646021176, 218, 21, 'PPL', 'P'),
(89858, 'Peytona', 36.3683280944824, 0.634747068694274, -86.5147171020508, -1.50996666486223, 218, 50, 'PPL', 'P'),
(110880, 'Peytona', 38.1413917541504, 0.66569286740294, -81.6847229003906, -1.42566736319103, 218, 58, 'PPL', 'P'),
(4979, 'Peytona Points', 34.8061103820801, 0.607481225979879, -87.5552825927734, -1.52812795875797, 218, 2, 'PPL', 'P'),
(37661, 'Peytons Store', 37.4638900756836, 0.653868232425906, -84.9705581665039, -1.48301600726285, 218, 21, 'PPL', 'P'),
(37662, 'Peytonsburg', 36.6341705322266, 0.639386894524437, -85.3927764892578, -1.49038510715715, 218, 21, 'PPL', 'P'),
(105210, 'Peytonsburg', 36.8238906860352, 0.642698135865787, -79.1677780151367, -1.38173838785212, 218, 53, 'PPL', 'P'),
(89859, 'Peytonsville', 35.8183288574219, 0.62514777112411, -86.7794418334961, -1.51458698303741, 218, 50, 'PPL', 'P'),
(37663, 'Peytontown', 37.6694412231445, 0.657455776730352, -84.3313903808594, -1.47186042493067, 218, 21, 'PPL', 'P'),
(11166, 'Peytonville', 33.6936111450195, 0.588064451367247, -94.0780563354492, -1.6419718369303, 218, 4, 'PPL', 'P'),
(192043, 'Pezuna del Caballo', 31.5672206878662, 0.550951936706935, -104.697219848633, -1.827311204043, 218, 51, 'PPL', 'P'),
(67712, 'Pfafftown', 36.1525001525879, 0.630980160490411, -80.3625030517578, -1.40259027339716, 218, 33, 'PPL', 'P'),
(33614, 'Pfeifer', 38.7080612182617, 0.675583115322194, -99.165283203125, -1.73076069556716, 218, 20, 'PPL', 'P'),
(11167, 'Pfeiffer', 35.8238906860352, 0.625244843345844, -91.5877838134766, -1.59850838214993, 218, 4, 'PPL', 'P'),
(157121, 'Pfeiffer', 40.6222190856934, 0.70899147251183, -83.4977798461914, -1.4573111764214, 218, 41, 'PPL', 'P'),
(23856, 'Pfeiffer (historical)', 32.7661094665527, 0.571876493260228, -81.4369430541992, -1.4213427890549, 218, 13, 'PPL', 'P'),
(50342, 'Pfeiffer Corners', 39.1972198486328, 0.684120543986716, -76.7941665649414, -1.34031105288317, 218, 25, 'PPL', 'P'),
(137449, 'Pfingsten', 43.8055610656738, 0.764551271279444, -95.6733322143555, -1.66981465349486, 218, 28, 'PPL', 'P'),
(50343, 'Pfister Mobile Home Park', 39.1158294677734, 0.682700013861268, -76.82861328125, -1.34091226149926, 218, 25, 'PPL', 'P'),
(97032, 'Pflugerville', 30.4391708374023, 0.53126375268971, -97.6197204589844, -1.70378553688575, 218, 51, 'PPL', 'P'),
(165882, 'Pfoutz Valley', 40.5958290100098, 0.708530878801301, -77.0466690063477, -1.34471805185503, 218, 45, 'PPL', 'P'),
(128530, 'Phair', 46.6269416809082, 0.813793652467227, -67.9538879394531, -1.18601908407472, 218, 26, 'PPL', 'P'),
(146030, 'Phalanx', 40.3175010681152, 0.703673139814941, -74.1383285522461, -1.29395793516202, 218, 37, 'PPL', 'P'),
(157122, 'Phalanx', 41.2608299255371, 0.720137334306029, -80.978889465332, -1.41334824577859, 218, 41, 'PPL', 'P'),
(97033, 'Phalba', 32.4236106872559, 0.565898761877436, -95.9775009155273, -1.67512339881182, 218, 51, 'PPL', 'P'),
(97034, 'Phantom Hill', 32.6433296203613, 0.569733580689096, -99.6774978637695, -1.73970052787239, 218, 51, 'PPL', 'P'),
(157123, 'Pharisburg', 40.3452796936035, 0.70415796829139, -83.3036117553711, -1.45392230393428, 218, 41, 'PPL', 'P'),
(76940, 'Pharoah', 35.420280456543, 0.618200515946475, -96.1227798461914, -1.67765899448569, 218, 42, 'PPL', 'P'),
(28231, 'Pharoahs Gardens', 37.5927810668945, 0.656117804598696, -88.9094390869141, -1.55176244816799, 218, 18, 'PPL', 'P'),
(97035, 'Pharr', 26.1944408416748, 0.4571792384061, -98.1833267211914, -1.71362232184612, 218, 51, 'PPL', 'P'),
(67713, 'Pharrs Mill', 35.3283309936523, 0.616595695073593, -80.6180572509766, -1.40705053559083, 218, 33, 'PPL', 'P'),
(151672, 'Pharsalia', 42.5827789306641, 0.743209696988958, -75.7813873291016, -1.32263472062193, 218, 40, 'PPL', 'P'),
(97036, 'Pheasant', 28.8013896942139, 0.502679079313995, -96.2177810668945, -1.67931707858037, 218, 51, 'PPL', 'P'),
(175812, 'Pheasant Branch', 43.1041717529297, 0.752309718433759, -89.48388671875, -1.56178845072381, 218, 57, 'PPL', 'P'),
(50344, 'Pheasant Farm', 38.577220916748, 0.673299521266479, -76.998893737793, -1.34388421611773, 218, 25, 'PPL', 'P'),
(205355, 'Pheasant Hollow', 40.663330078125, 0.709708994688524, -111.852783203125, -1.95219934441394, 218, 52, 'PPL', 'P'),
(50345, 'Pheasant Ridge', 39.607780456543, 0.691286178373738, -76.3702774047852, -1.33291279137493, 218, 25, 'PPL', 'P'),
(50346, 'Pheasant Ridge Mobile Estates', 39.3594398498535, 0.686951817120606, -77.1500015258789, -1.34652154454524, 218, 25, 'PPL', 'P'),
(50349, 'Pheasant Run', 38.3180618286133, 0.668776341892061, -75.5877838134766, -1.31925570183084, 218, 25, 'PPL', 'P'),
(71269, 'Pheasant Run', 39.9930610656738, 0.69801059354716, -74.9638900756836, -1.30836670192378, 218, 37, 'PPL', 'P'),
(121023, 'Pheasant Run', 41.9324989318848, 0.731860169950395, -88.3680572509766, -1.54231355262039, 218, 18, 'PPL', 'P'),
(205358, 'Pheasant Run Estates', 41.1741714477539, 0.718624858543946, -112.050559997559, -1.95565120066085, 218, 52, 'PPL', 'P'),
(157125, 'Pheasant Run Village', 41.2061080932617, 0.7191822581601, -82.1533279418945, -1.43384606405672, 218, 41, 'PPL', 'P'),
(50350, 'Pheasantfield', 39.2402801513672, 0.684872088046336, -75.9761123657227, -1.32603331364704, 218, 25, 'PPL', 'P'),
(61293, 'Pheba', 33.584171295166, 0.586154365654415, -88.9497222900391, -1.55246552269577, 218, 30, 'PPL', 'P'),
(89860, 'Phebe (historical)', 36.3963890075684, 0.635236824018739, -83.8791732788086, -1.46396774756606, 218, 50, 'PPL', 'P'),
(4980, 'Phelan', 34.1330604553223, 0.595734288727648, -86.8172225952148, -1.51524638172332, 218, 2, 'PPL', 'P'),
(97037, 'Phelan', 30.1586093902588, 0.526367031682895, -97.3258285522461, -1.6986561554682, 218, 51, 'PPL', 'P'),
(184087, 'Phelan', 34.4261093139648, 0.600848956180173, -117.571388244629, -2.05200783100933, 218, 6, 'PPL', 'P'),
(11169, 'Phelan (historical)', 33.2822189331055, 0.580884302752285, -91.6600036621094, -1.59976885629387, 218, 4, 'PPL', 'P'),
(23858, 'Phelps', 34.6980590820313, 0.605595375032967, -84.9833297729492, -1.48323891384609, 218, 13, 'PPL', 'P'),
(37664, 'Phelps', 37.5127792358398, 0.654721509239168, -82.1502838134766, -1.43379293399297, 218, 21, 'PPL', 'P'),
(50352, 'Phelps', 38.8497200012207, 0.678055527499197, -76.8713912963867, -1.34165887871086, 218, 25, 'PPL', 'P'),
(56867, 'Phelps', 37.1897201538086, 0.649083064579252, -93.9022216796875, -1.63890294324815, 218, 29, 'PPL', 'P'),
(97038, 'Phelps', 30.6961097717285, 0.535748183070268, -95.4441680908203, -1.66581498501172, 218, 51, 'PPL', 'P'),
(121024, 'Phelps', 40.8486099243164, 0.712942738042153, -90.5747222900391, -1.58082712304068, 218, 18, 'PPL', 'P'),
(132601, 'Phelps', 45.2208290100098, 0.789252356706038, -85.2611083984375, -1.48808706545252, 218, 27, 'PPL', 'P'),
(137450, 'Phelps', 46.3802795410156, 0.809488585986087, -95.8202819824219, -1.67237941078266, 218, 28, 'PPL', 'P'),
(151674, 'Phelps', 42.9575004577637, 0.749749821414947, -77.0577774047852, -1.34491192998239, 218, 40, 'PPL', 'P'),
(175814, 'Phelps', 46.0644416809082, 0.803976175424759, -89.0875015258789, -1.55487022400206, 218, 57, 'PPL', 'P'),
(139391, 'Phelps City', 40.4033317565918, 0.705171167928111, -95.5983276367188, -1.66850557666103, 218, 29, 'PPL', 'P'),
(50353, 'Phelps Corner', 38.8055610656738, 0.677284808679728, -76.9733276367188, -1.34343800347709, 218, 25, 'PPL', 'P'),
(184088, 'Phelps Corner', 32.7222213745117, 0.571110501551694, -116.809722900391, -2.03871426295404, 218, 6, 'PPL', 'P'),
(23857, 'Phelps Estates', 32.7880592346191, 0.572259588983036, -83.8019409179688, -1.46261978858031, 218, 13, 'PPL', 'P'),
(151675, 'Phelps Junction', 42.9674987792969, 0.749924325045375, -77.086669921875, -1.3454161995348, 218, 40, 'PPL', 'P'),
(50354, 'Phelps Luck', 39.2208290100098, 0.684532601586378, -76.8188934326172, -1.34074261813782, 218, 25, 'PPL', 'P'),
(11170, 'Phenix', 34.0333290100098, 0.593993646639173, -91.7708282470703, -1.60170311019359, 218, 4, 'PPL', 'P'),
(56869, 'Phenix', 37.3786087036133, 0.652379791692661, -93.5455627441406, -1.6326780705162, 218, 29, 'PPL', 'P'),
(105212, 'Phenix', 37.079719543457, 0.647163191749414, -78.7480621337891, -1.37441296379969, 218, 53, 'PPL', 'P'),
(123427, 'Phenix', 40.5819396972656, 0.708288464563076, -85.1072235107422, -1.48540126749318, 218, 19, 'PPL', 'P'),
(169544, 'Phenix', 41.7197189331055, 0.728146458389306, -71.5330581665039, -1.24848738902611, 218, 47, 'PPL', 'P'),
(4981, 'Phenix City', 32.4708290100098, 0.566722877076761, -85.0008316040039, -1.48354437842312, 218, 2, 'PPL', 'P'),
(73880, 'Pherson', 39.6558303833008, 0.692124807801004, -83.1197204589844, -1.45071279534657, 218, 41, 'PPL', 'P'),
(110881, 'Phico', 37.9505615234375, 0.66236225156466, -82.0141677856445, -1.43141726114256, 218, 58, 'PPL', 'P'),
(17588, 'Phifer', 29.5911102294922, 0.516462302825214, -82.1880569458008, -1.43445219952082, 218, 12, 'PPL', 'P'),
(89861, 'Phiferes', 35.6652793884277, 0.622476553971734, -85.4458312988281, -1.49131108826817, 218, 50, 'PPL', 'P'),
(37665, 'Phil', 37.2152786254883, 0.64952914406184, -84.95361328125, -1.4827202632238, 218, 21, 'PPL', 'P'),
(67714, 'Phil', 34.7480583190918, 0.606468026343158, -79.2141723632813, -1.38254812198156, 218, 33, 'PPL', 'P'),
(200126, 'Phil', 40.6427803039551, 0.709350333468718, -119.468330383301, -2.08511571704898, 218, 39, 'PPL', 'P'),
(4982, 'Phil Campbell', 34.350830078125, 0.599535085656382, -87.7063903808594, -1.53076528718548, 218, 2, 'PPL', 'P'),
(14401, 'Phil Mar Estates', 38.7102813720703, 0.675621864316055, -75.0983276367188, -1.31071308000219, 218, 10, 'PPL', 'P'),
(4984, 'Philadelphia', 31.1608295440674, 0.543859073196699, -85.1074981689453, -1.48540606118314, 218, 2, 'PPL', 'P'),
(11172, 'Philadelphia', 35.8788909912109, 0.626204779760763, -90.7024993896484, -1.58305725413751, 218, 4, 'PPL', 'P'),
(28233, 'Philadelphia', 39.9238891601563, 0.696803316046, -90.1172180175781, -1.5728421671443, 218, 18, 'PPL', 'P'),
(30819, 'Philadelphia', 39.7813911437988, 0.694316256483003, -85.8455581665039, -1.4982876382178, 218, 19, 'PPL', 'P'),
(56870, 'Philadelphia', 39.8386116027832, 0.695314941891782, -91.7388916015625, -1.60114571057744, 218, 29, 'PPL', 'P'),
(61294, 'Philadelphia', 32.7713890075684, 0.571968638633945, -89.1166687011719, -1.55537928724443, 218, 30, 'PPL', 'P'),
(67716, 'Philadelphia', 34.9527816772461, 0.61004112299869, -79.727783203125, -1.39151232221076, 218, 33, 'PPL', 'P'),
(78940, 'Philadelphia', 39.952220916748, 0.697297798481401, -75.1641693115234, -1.31186223401256, 218, 45, 'PPL', 'P'),
(89864, 'Philadelphia', 36.1697196960449, 0.631280698219427, -82.6366729736328, -1.44228202628371, 218, 50, 'PPL', 'P'),
(105211, 'Philadelphia', 36.723331451416, 0.640943046128397, -76.5938873291016, -1.33681552079439, 218, 53, 'PPL', 'P'),
(151677, 'Philadelphia', 44.1544418334961, 0.770640389374829, -75.7091674804688, -1.321374246478, 218, 40, 'PPL', 'P'),
(189223, 'Philadelphia', 35.0394401550293, 0.611553598760774, -107.511108398438, -1.87642282402126, 218, 38, 'PPL', 'P'),
(82936, 'Philadelphia (historical)', 34.2400016784668, 0.59760076517763, -79.9833297729492, -1.39597245124637, 218, 48, 'PPL', 'P'),
(42545, 'Philadelphia Point', 30.1574993133545, 0.526347657185965, -91.0127792358398, -1.58847265905613, 218, 22, 'PPL', 'P'),
(50355, 'Philadelphia Station', 39.4680595397949, 0.688847588342579, -76.272216796875, -1.33120131090039, 218, 25, 'PPL', 'P'),
(67717, 'Philadelphus', 34.7588882446289, 0.606657044201527, -79.1716690063477, -1.38180629845991, 218, 33, 'PPL', 'P'),
(105214, 'Philbeck Crossroads', 36.7694396972656, 0.641747786830792, -78.5591735839844, -1.37111623668628, 218, 53, 'PPL', 'P'),
(137451, 'Philbin', 47.1599998474121, 0.823097272577365, -93.3411102294922, -1.6291097009716, 218, 28, 'PPL', 'P'),
(184089, 'Philbrick Mill', 39.082218170166, 0.68211338605215, -123.494171142578, -2.15537989345936, 218, 6, 'PPL', 'P'),
(137452, 'Philbrook', 46.2833290100098, 0.807796480008478, -94.716667175293, -1.6531176987245, 218, 28, 'PPL', 'P'),
(197240, 'Philbrook (historical)', 46.9855613708496, 0.820052746819186, -109.97306060791, -1.91939199610331, 218, 31, 'PPL', 'P'),
(117283, 'Philby', 43.0697212219238, 0.751708443238646, -95.8013916015625, -1.67204971143971, 218, 16, 'PPL', 'P'),
(23859, 'Philema', 31.7538890838623, 0.554209914826483, -84.0169372558594, -1.46637218255624, 218, 13, 'PPL', 'P'),
(82935, 'Philip', 32.8875007629395, 0.573995171065441, -79.8141708374023, -1.39302007086191, 218, 48, 'PPL', 'P'),
(202480, 'Philip', 44.0394401550293, 0.768633231440263, -101.66471862793, -1.77438407317099, 218, 49, 'PPL', 'P'),
(202481, 'Philip Junction', 43.9658317565918, 0.767348522530409, -101.660827636719, -1.77431616256319, 218, 49, 'PPL', 'P'),
(30820, 'Philip Station', 37.9816703796387, 0.662905203531899, -87.741943359375, -1.53138580371947, 218, 19, 'PPL', 'P'),
(61295, 'Philipp', 33.7574996948242, 0.589179516915664, -90.2041702270508, -1.57435976949148, 218, 30, 'PPL', 'P'),
(89865, 'Philippi', 35.9883308410645, 0.628114865473595, -85.771110534668, -1.49698828192195, 218, 50, 'PPL', 'P'),
(110882, 'Philippi', 39.1522216796875, 0.683335177781252, -80.0405578613281, -1.39697126981321, 218, 58, 'PPL', 'P'),
(17589, 'Philips', 30.2999992370605, 0.528834750038476, -81.6416702270508, -1.42491595228946, 218, 12, 'PPL', 'P'),
(146031, 'Philips Mills', 40.422779083252, 0.705510587809042, -74.1341705322266, -1.29388536402231, 218, 37, 'PPL', 'P'),
(165885, 'Philipsburg', 40.0616683959961, 0.699208017352287, -79.8813934326172, -1.39419332648015, 218, 45, 'PPL', 'P'),
(197241, 'Philipsburg', 46.332218170166, 0.808649756821739, -113.293327331543, -1.97734158247511, 218, 31, 'PPL', 'P'),
(151679, 'Philipse Manor', 41.0955581665039, 0.717252797950337, -73.8649978637695, -1.28918741470136, 218, 40, 'PPL', 'P'),
(105213, 'Phillip', 36.6819381713867, 0.640220597103686, -82.2780609130859, -1.4360230650898, 218, 53, 'PPL', 'P'),
(23860, 'Phillipi', 31.7547206878662, 0.554224429054424, -82.3872222900391, -1.43792829053364, 218, 13, 'PPL', 'P'),
(89866, 'Phillippy', 36.482780456543, 0.636744639248915, -89.376106262207, -1.55990732688784, 218, 50, 'PPL', 'P'),
(11173, 'Phillips', 35.8163909912109, 0.625113948978266, -90.5841674804688, -1.58099197271216, 218, 4, 'PPL', 'P'),
(23861, 'Phillips', 34.2277793884277, 0.597387445974315, -83.1888885498047, -1.4519200062687, 218, 13, 'PPL', 'P'),
(42547, 'Phillips', 32.5463905334473, 0.568041674448568, -93.0888900756836, -1.62470762884775, 218, 22, 'PPL', 'P'),
(76941, 'Phillips', 34.5058288574219, 0.602240324691685, -96.2194366455078, -1.6793459738782, 218, 42, 'PPL', 'P'),
(89869, 'Phillips', 35.5616683959961, 0.620668201012543, -84.2972183227539, -1.47126401000455, 218, 50, 'PPL', 'P'),
(117284, 'Phillips', 41.0538902282715, 0.716525555235664, -92.4266662597656, -1.61314964287486, 218, 16, 'PPL', 'P'),
(142665, 'Phillips', 40.8972206115723, 0.713791154586425, -98.2144393920898, -1.71416534039239, 218, 35, 'PPL', 'P'),
(165887, 'Phillips', 41.9391708374023, 0.731976616669058, -77.4836120605469, -1.35234414679453, 218, 45, 'PPL', 'P'),
(175816, 'Phillips', 45.6966705322266, 0.797557357986423, -90.4002838134766, -1.5777825972825, 218, 57, 'PPL', 'P'),
(177346, 'Phillips', 44.8230590820313, 0.782309961797392, -70.3399963378906, -1.22766453193695, 218, 26, 'PPL', 'P'),
(184090, 'Phillips', 38.8180618286133, 0.677502988152033, -120.076667785645, -2.09573320768291, 218, 6, 'PPL', 'P'),
(192044, 'Phillips', 35.6911087036133, 0.622927360565257, -101.363327026367, -1.76912379738586, 218, 51, 'PPL', 'P'),
(197242, 'Phillips', 48.0936088562012, 0.839391823707015, -108.163330078125, -1.8878062397847, 218, 31, 'PPL', 'P'),
(208426, 'Phillips', 46.5722198486328, 0.812838576321298, -122.740829467773, -2.14223160084153, 218, 56, 'PPL', 'P'),
(4985, 'Phillips (historical)', 34.0722198486328, 0.594672419822007, -86.3147201538086, -1.50647605962147, 218, 2, 'PPL', 'P'),
(42548, 'Phillips (historical)', 31.5725002288818, 0.551044082080651, -92.7416687011719, -1.61864747262922, 218, 22, 'PPL', 'P'),
(11174, 'Phillips Bayou', 34.6480598449707, 0.604722723722775, -90.6397171020508, -1.581961496507, 218, 4, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(192045, 'Phillips Camp', 36.497501373291, 0.63700156771508, -101.463607788086, -1.77087402685426, 218, 51, 'PPL', 'P'),
(128531, 'Phillips Corner', 44.8125, 0.782125671049959, -69.4427795410156, -1.21200514472728, 218, 26, 'PPL', 'P'),
(151681, 'Phillips Creek', 42.2580604553223, 0.737542290452188, -77.8938903808594, -1.35950485433354, 218, 40, 'PPL', 'P'),
(4986, 'Phillips Crossroads', 31.6166706085205, 0.551815000637202, -85.6069412231445, -1.49412298690513, 218, 2, 'PPL', 'P'),
(67720, 'Phillips Crossroads', 35.086669921875, 0.61237791369718, -77.4461135864258, -1.35168967495664, 218, 33, 'PPL', 'P'),
(4987, 'Phillips Estates', 33.3474998474121, 0.582023669645648, -86.9300003051758, -1.51721472408499, 218, 2, 'PPL', 'P'),
(23862, 'Phillips Estates', 33.5250015258789, 0.58512165836271, -82.079719543457, -1.43256135514686, 218, 13, 'PPL', 'P'),
(56871, 'Phillips Ford (historical)', 38.0613899230957, 0.664296572043411, -93.3230590820313, -1.62879464901464, 218, 29, 'PPL', 'P'),
(14403, 'Phillips Heights', 39.7666702270508, 0.694059328016837, -75.5083312988281, -1.31786899385124, 218, 10, 'PPL', 'P'),
(14407, 'Phillips Hill', 38.5688896179199, 0.67315411267096, -75.3333282470703, -1.31481461439703, 218, 10, 'PPL', 'P'),
(151682, 'Phillips Mills', 42.1519393920898, 0.735690128493065, -79.3733291625977, -1.38532593215656, 218, 40, 'PPL', 'P'),
(125804, 'Phillips Point', 42.4638900756836, 0.741134695025623, -70.8958282470703, -1.23736562883978, 218, 23, 'PPL', 'P'),
(89870, 'Phillips Subdivision', 36.1583290100098, 0.631081893244052, -85.2533264160156, -1.48795124423693, 218, 50, 'PPL', 'P'),
(33616, 'Phillips Village (historical)', 38.7611083984375, 0.67650896327516, -97.6972198486328, -1.7051381564034, 218, 20, 'PPL', 'P'),
(23863, 'Phillipsburg', 31.4394397735596, 0.548721739031075, -83.5194396972656, -1.45768921213814, 218, 13, 'PPL', 'P'),
(33617, 'Phillipsburg', 39.7561111450195, 0.693875037269404, -99.3236083984375, -1.73352399151423, 218, 20, 'PPL', 'P'),
(37666, 'Phillipsburg', 37.4563903808594, 0.653737338058329, -85.2600021362305, -1.48806775753462, 218, 21, 'PPL', 'P'),
(73881, 'Phillipsburg', 39.9044418334961, 0.69646389616507, -84.4016723632813, -1.47308707692876, 218, 41, 'PPL', 'P'),
(97040, 'Phillipsburg', 30.0947208404541, 0.525251966134479, -96.3666687011719, -1.68191565801402, 218, 51, 'PPL', 'P'),
(112418, 'Phillipsburg', 37.5538902282715, 0.655439031415862, -92.7847213745117, -1.61939888353079, 218, 29, 'PPL', 'P'),
(146032, 'Phillipsburg', 40.6936111450195, 0.710237499006851, -75.190559387207, -1.31232282772309, 218, 37, 'PPL', 'P'),
(151683, 'Phillipsburg', 41.4377784729004, 0.72322566906414, -74.3597183227539, -1.29782191558761, 218, 40, 'PPL', 'P'),
(165888, 'Phillipsburg', 40.6933288574219, 0.710232572158834, -80.2822189331055, -1.40118905118962, 218, 45, 'PPL', 'P'),
(187189, 'Phillipsburg', 39.538330078125, 0.690074040603588, -105.186393737793, -1.83584889902363, 218, 7, 'PPL', 'P'),
(169545, 'Phillipsdale', 41.8469390869141, 0.73036686894816, -71.3663864135742, -1.24557841816742, 218, 47, 'PPL', 'P'),
(151684, 'Phillipsport', 41.6391716003418, 0.726740642228881, -74.4461135864258, -1.29932979739681, 218, 40, 'PPL', 'P'),
(125805, 'Phillipston', 42.5486106872559, 0.742613348641862, -72.1333312988281, -1.25896413159643, 218, 23, 'PPL', 'P'),
(165889, 'Phillipston', 40.9741706848145, 0.715134186724152, -79.5905609130859, -1.38911734144245, 218, 45, 'PPL', 'P'),
(42549, 'Phillipston (historical)', 30.9683303833008, 0.540499329033996, -91.6866683959961, -1.60023424369436, 218, 22, 'PPL', 'P'),
(125806, 'Phillipston Four Corners', 42.5694389343262, 0.742976870130658, -72.1333312988281, -1.25896413159643, 218, 23, 'PPL', 'P'),
(28236, 'Phillipstown', 38.1419410705566, 0.665702454782864, -88.0216674804688, -1.5362679106298, 218, 18, 'PPL', 'P'),
(61296, 'Phillipstown', 33.3891716003418, 0.582750978939349, -90.2788925170898, -1.57566391947729, 218, 30, 'PPL', 'P'),
(4988, 'Phillipsville', 30.896110534668, 0.539238854890062, -87.6355590820313, -1.52952904780746, 218, 2, 'PPL', 'P'),
(132602, 'Phillipsville', 47.2797203063965, 0.825186788768641, -88.413330078125, -1.54310371251582, 218, 27, 'PPL', 'P'),
(165891, 'Phillipsville', 42.0366706848145, 0.733678310026592, -79.8850021362305, -1.39425631023993, 218, 45, 'PPL', 'P'),
(193871, 'Phillipsville', 40.209171295166, 0.70178242859904, -123.784721374512, -2.16045095164903, 218, 6, 'PPL', 'P'),
(105215, 'Phillis', 36.6058311462402, 0.638892278930982, -78.3252792358398, -1.36703401020935, 218, 53, 'PPL', 'P'),
(89871, 'Phillps Subdivision', 35.954719543457, 0.627528237664478, -85.0119400024414, -1.48373825655048, 218, 50, 'PPL', 'P'),
(151685, 'Philmont', 42.2483291625977, 0.737372447353668, -73.6536102294922, -1.28549800448521, 218, 40, 'PPL', 'P'),
(165892, 'Philmont', 40.1202812194824, 0.700231004106014, -75.038330078125, -1.30966592506158, 218, 45, 'PPL', 'P'),
(73882, 'Philo', 39.8611106872559, 0.695707624994514, -81.9069366455078, -1.42954572468651, 218, 41, 'PPL', 'P'),
(121027, 'Philo', 40.0069389343262, 0.698252808048303, -88.1580581665039, -1.53864837717017, 218, 18, 'PPL', 'P'),
(184091, 'Philo', 39.0658302307129, 0.681827362551076, -123.443893432617, -2.15450238188018, 218, 6, 'PPL', 'P'),
(23864, 'Philomath', 33.7272186279297, 0.588651012597337, -82.9913864135742, -1.44847294371176, 218, 13, 'PPL', 'P'),
(30827, 'Philomath', 39.7238883972168, 0.693312644226206, -85.0158309936523, -1.48380616715828, 218, 19, 'PPL', 'P'),
(201393, 'Philomath', 44.5402793884277, 0.77737452508623, -123.366386413574, -2.15314962920447, 218, 43, 'PPL', 'P'),
(105216, 'Philomont', 39.0561103820801, 0.681657719189638, -77.7405624389648, -1.35682877691217, 218, 53, 'PPL', 'P'),
(157126, 'Philothea', 40.4505615234375, 0.705995482864518, -84.6536102294922, -1.47748422220459, 218, 41, 'PPL', 'P'),
(37667, 'Philpot', 37.7330589294434, 0.658566115167833, -86.9888916015625, -1.51824257110771, 218, 21, 'PPL', 'P'),
(105217, 'Philpott', 36.7902793884277, 0.64211150805667, -80.0063934326172, -1.39637498804514, 218, 53, 'PPL', 'P'),
(192046, 'Philrich', 35.651668548584, 0.622239000002499, -101.456672668457, -1.77075298618272, 218, 51, 'PPL', 'P'),
(78941, 'Philson', 39.8138885498047, 0.694883443216162, -78.8902816772461, -1.3768951630937, 218, 45, 'PPL', 'P'),
(82939, 'Philson Crossroads', 34.5469398498535, 0.602957846868379, -81.8111114501953, -1.42787325952194, 218, 48, 'PPL', 'P'),
(151686, 'Philwold', 41.5763893127441, 0.725644884598368, -74.6691665649414, -1.30322280627829, 218, 40, 'PPL', 'P'),
(442, 'Phinizy', 33.610279083252, 0.586610032516928, -82.3263931274414, -1.43686662136508, 218, 13, 'PPL', 'P'),
(911, 'Phinney', 34.7277793884277, 0.606114092234287, -83.0025024414063, -1.44866695499717, 218, 48, 'PPL', 'P'),
(208427, 'Phinney', 47.6725006103516, 0.832042098309641, -122.359443664551, -2.13557516285493, 218, 56, 'PPL', 'P'),
(4989, 'Phipps', 32.9294395446777, 0.574727140891049, -87.5027770996094, -1.52721156502688, 218, 2, 'PPL', 'P'),
(105218, 'Phipps', 37.1636085510254, 0.648627331137712, -82.5769424438477, -1.44123953187499, 218, 53, 'PPL', 'P'),
(175818, 'Phipps', 46.0627784729004, 0.803947146968877, -91.413330078125, -1.59546359007565, 218, 57, 'PPL', 'P'),
(89872, 'Phipps Bend', 36.4661102294922, 0.636453688899824, -82.8111114501953, -1.44532655204188, 218, 50, 'PPL', 'P'),
(205359, 'Phipps Condominium', 40.8930587768555, 0.713718516867693, -111.88500213623, -1.95276167087811, 218, 52, 'PPL', 'P'),
(128533, 'Phippsburg', 43.8205604553223, 0.764813060014599, -69.8152770996094, -1.21850645358038, 218, 26, 'PPL', 'P'),
(194370, 'Phippsburg', 40.2322196960449, 0.702184699081696, -106.943061828613, -1.86650854107317, 218, 7, 'PPL', 'P'),
(105219, 'Phlegar', 37.2658309936523, 0.650411449330983, -80.978889465332, -1.41334824577859, 218, 53, 'PPL', 'P'),
(123431, 'Phlox', 40.4211082458496, 0.705481426195105, -85.9186096191406, -1.49956262658968, 218, 19, 'PPL', 'P'),
(175819, 'Phlox', 45.0511093139648, 0.78629018920457, -89.0141677856445, -1.55359030878217, 218, 57, 'PPL', 'P'),
(105220, 'Phoebus', 37.0213890075684, 0.646145131843704, -76.3183288574219, -1.33200611818181, 218, 53, 'PPL', 'P'),
(151687, 'Phoenicia', 42.0847206115723, 0.734516939453858, -74.3158264160156, -1.29705585730005, 218, 40, 'PPL', 'P'),
(205360, 'Phoenician Gardens', 40.6177787780762, 0.708913974524108, -111.845832824707, -1.95207803742629, 218, 52, 'PPL', 'P'),
(23865, 'Phoenix', 33.3658294677734, 0.582343581871594, -83.2777786254883, -1.45347143076173, 218, 13, 'PPL', 'P'),
(42550, 'Phoenix', 29.6458301544189, 0.51741734568163, -89.9397201538086, -1.56974424500626, 218, 22, 'PPL', 'P'),
(50357, 'Phoenix', 39.5163917541504, 0.689691144617862, -76.6163864135742, -1.33720820389712, 218, 25, 'PPL', 'P'),
(61298, 'Phoenix', 32.5811080932617, 0.568647610175589, -90.5627822875977, -1.58061873068538, 218, 30, 'PPL', 'P'),
(67721, 'Phoenix', 34.2933311462402, 0.598531539978613, -78.0586090087891, -1.36237973673028, 218, 33, 'PPL', 'P'),
(82937, 'Phoenix', 34.077220916748, 0.594759704926734, -82.1111068725586, -1.43310916738309, 218, 48, 'PPL', 'P'),
(97041, 'Phoenix', 29.3816699981689, 0.512806881202484, -98.541389465332, -1.7198716956601, 218, 51, 'PPL', 'P'),
(121029, 'Phoenix', 41.6111106872559, 0.726250886904415, -87.6347198486328, -1.52951440042147, 218, 18, 'PPL', 'P'),
(132603, 'Phoenix', 47.3888893127441, 0.827092147370538, -88.2774963378906, -1.54073296651343, 218, 27, 'PPL', 'P'),
(146035, 'Phoenix', 40.5297203063965, 0.707377064259024, -74.3413925170898, -1.29750206994069, 218, 37, 'PPL', 'P'),
(151688, 'Phoenix', 43.2311096191406, 0.754525202144596, -76.3011093139648, -1.3317055804528, 218, 40, 'PPL', 'P'),
(178850, 'Phoenix', 33.4483299255371, 0.583783486493972, -112.073333740234, -1.95604867745354, 218, 5, 'PPL', 'P'),
(201394, 'Phoenix', 42.2755584716797, 0.737847688450193, -122.816940307617, -2.14355998559326, 218, 43, 'PPL', 'P'),
(50358, 'Phoenix (historical)', 39.5108299255371, 0.689594072396129, -79.0405578613281, -1.37951797729326, 218, 25, 'PPL', 'P'),
(61297, 'Phoenix (historical)', 31.7374992370605, 0.553923858035895, -91.0583267211914, -1.58926761264152, 218, 30, 'PPL', 'P'),
(187190, 'Phoenix (historical)', 39.9286117553711, 0.696885740881738, -105.535003662109, -1.84193329000808, 218, 7, 'PPL', 'P'),
(178851, 'Phoenix Acres Trailer Park', 33.4411087036133, 0.583657452395384, -112.137222290039, -1.95716374300196, 218, 5, 'PPL', 'P'),
(184092, 'Phoenix Lake County Club Estates', 38.0113906860352, 0.66342392073322, -120.30249786377, -2.09967468609622, 218, 6, 'PPL', 'P'),
(151689, 'Phoenix Mills', 42.6666717529297, 0.744673902956284, -74.9433288574219, -1.30800784096689, 218, 40, 'PPL', 'P'),
(178852, 'Phoenix Mobile Home Park', 33.6927795410156, 0.588049937139307, -112.111106872559, -1.95670794298139, 218, 5, 'PPL', 'P'),
(17591, 'Phoenix Park', 30.371940612793, 0.530090363913421, -81.6452789306641, -1.42497893604924, 218, 12, 'PPL', 'P'),
(165893, 'Phoenix Park', 40.6824989318848, 0.710043554300466, -76.290283203125, -1.33151662917346, 218, 45, 'PPL', 'P'),
(178853, 'Phoenix West Mobile Home Park', 33.5402793884277, 0.585388307366854, -112.126388549805, -1.95697465856456, 218, 5, 'PPL', 'P'),
(4990, 'Phoenixville', 33.4558296203613, 0.58391438086155, -86.894172668457, -1.51658941386104, 218, 2, 'PPL', 'P'),
(113904, 'Phoenixville', 41.8769416809082, 0.730890512997497, -72.0863876342773, -1.25814481008707, 218, 8, 'PPL', 'P'),
(165894, 'Phoenixville', 40.1302795410156, 0.700405507736442, -75.5152816772461, -1.31799030083889, 218, 45, 'PPL', 'P'),
(197244, 'Phon (historical)', 47.5149993896484, 0.829293183432461, -106.56861114502, -1.85997314375812, 218, 31, 'PPL', 'P'),
(73883, 'Phoneton', 39.8969383239746, 0.696332935218465, -84.1352767944336, -1.46843759713965, 218, 41, 'PPL', 'P'),
(190604, 'Phonolite (historical)', 39.0780601501465, 0.682040814912446, -117.762496948242, -2.0553433071166, 218, 39, 'PPL', 'P'),
(11178, 'Phosphate (historical)', 35.8650016784668, 0.625962365522538, -91.8219375610352, -1.60259513600072, 218, 4, 'PPL', 'P'),
(89873, 'Phosphate (historical)', 36.4541702270508, 0.636245296544525, -86.4086074829102, -1.50811470264019, 218, 50, 'PPL', 'P'),
(866, 'Phroso', 36.2808303833008, 0.633219945546195, -98.817497253418, -1.7246906856526, 218, 42, 'PPL', 'P'),
(37668, 'Phyllis', 37.4425010681152, 0.653494923820104, -82.3361129760742, -1.43703626472652, 218, 21, 'PPL', 'P'),
(50359, 'Phyllis Estates', 39.1583290100098, 0.683441770803882, -76.5872192382813, -1.33669914065475, 218, 25, 'PPL', 'P'),
(50360, 'Phylpres', 39.6083297729492, 0.691295765753662, -77.3013916015625, -1.34916379982076, 218, 25, 'PPL', 'P'),
(178854, 'Pia Oik', 31.9466705322266, 0.557574585837203, -112.541107177734, -1.96421286409129, 218, 5, 'PPL', 'P'),
(175820, 'Piacenza', 44.1463890075684, 0.7704998410483, -88.7072219848633, -1.54823309393336, 218, 57, 'PPL', 'P'),
(28237, 'Piankashawtown (historical)', 38.4311103820801, 0.670749411364673, -88.095832824707, -1.53756234007763, 218, 18, 'PPL', 'P'),
(105221, 'Piankatank Shores', 37.5455589294434, 0.655293622820344, -76.4958267211914, -1.33510404031985, 218, 53, 'PPL', 'P'),
(28238, 'Piasa', 39.1158294677734, 0.682700013861268, -90.1236114501953, -1.57295375359397, 218, 18, 'PPL', 'P'),
(28239, 'Piasa Hills', 38.952220916748, 0.679844505961458, -90.2583312988281, -1.5753050585204, 218, 18, 'PPL', 'P'),
(178855, 'Piato Vaya', 32.0505599975586, 0.559387799065383, -112.157218933105, -1.95751275026281, 218, 5, 'PPL', 'P'),
(28241, 'Piatt', 39.9330596923828, 0.696963372027514, -88.5202789306641, -1.54497032212385, 218, 18, 'PPL', 'P'),
(165896, 'Piatt', 41.5508308410645, 0.725198805115779, -76.7169418334961, -1.33896322705548, 218, 45, 'PPL', 'P'),
(30821, 'Piattsville', 39.7044410705566, 0.692973224345276, -87.1258316040039, -1.520632625028, 218, 19, 'PPL', 'P'),
(711, 'Piave', 31.3941707611084, 0.547931645714676, -88.7447204589844, -1.54888756577125, 218, 30, 'PPL', 'P'),
(210959, 'PiÃ‚â€˜ihonua', 19.7158298492432, 0.34410614563227, -155.138885498047, -2.7076843498154, 218, 15, 'PPL', 'P'),
(184155, 'PiÃƒÂ±on Hills', 34.4333305358887, 0.600974990278761, -117.64582824707, -2.05330705414713, 218, 6, 'PPL', 'P'),
(178856, 'Pica', 35.457218170166, 0.618845200667356, -113.136390686035, -1.97460252129396, 218, 5, 'PPL', 'P'),
(195464, 'Picabo', 43.3058280944824, 0.75582928555138, -114.066940307617, -1.99084367604375, 218, 17, 'PPL', 'P'),
(178857, 'Picacho', 32.7161102294922, 0.571003841950036, -111.494720458984, -1.94594997059996, 218, 5, 'PPL', 'P'),
(184093, 'Picacho', 33.0230598449707, 0.576361123377867, -114.610282897949, -2.00032679321136, 218, 6, 'PPL', 'P'),
(189225, 'Picacho', 33.3516693115234, 0.582096440522434, -105.144439697266, -1.83511666288192, 218, 38, 'PPL', 'P'),
(50361, 'Picardy', 39.538890838623, 0.690083827720594, -78.5136108398438, -1.37032101678478, 218, 25, 'PPL', 'P'),
(61299, 'Picayune', 30.5252799987793, 0.532766641071869, -89.679443359375, -1.56520155797686, 218, 30, 'PPL', 'P'),
(157127, 'Piccola (historical)', 41.5188903808594, 0.724641338920599, -82.7813873291016, -1.44480776826154, 218, 41, 'PPL', 'P'),
(197245, 'Piche', 47.6086082458496, 0.830926966182198, -104.230278015137, -1.8191615316332, 218, 31, 'PPL', 'P'),
(76943, 'Picher', 36.9869384765625, 0.645543856648591, -94.8305587768555, -1.65510548216213, 218, 42, 'PPL', 'P'),
(198741, 'Pick City', 47.5113906860352, 0.829230199672681, -101.453330993652, -1.77069466295484, 218, 34, 'PPL', 'P'),
(105222, 'Pickadat Corner', 37.2852783203125, 0.650750869211914, -77.4116668701172, -1.35108846634056, 218, 53, 'PPL', 'P'),
(23866, 'Pickard', 32.9211082458496, 0.574581732295531, -84.4138870239258, -1.47330026297402, 218, 13, 'PPL', 'P'),
(123428, 'Pickard', 40.2230606079102, 0.702024842837264, -86.2613906860352, -1.50554528482048, 218, 19, 'PPL', 'P'),
(208428, 'Pickard', 46.4258308410645, 0.810283606150503, -118.425277709961, -2.06691101362747, 218, 56, 'PPL', 'P'),
(198743, 'Pickardville', 47.4711112976074, 0.828527191723927, -100.579170227051, -1.75543767938589, 218, 34, 'PPL', 'P'),
(105223, 'Pickaway', 36.7783317565918, 0.641902982543317, -79.1855621337891, -1.38204877927717, 218, 53, 'PPL', 'P'),
(110883, 'Pickaway', 37.6383285522461, 0.656912758184085, -80.5063934326172, -1.40510163430511, 218, 58, 'PPL', 'P'),
(56873, 'Pickel', 37.7963905334473, 0.659671460178271, -90.2866668701172, -1.57579960753483, 218, 29, 'PPL', 'P'),
(105224, 'Pickels', 37.6974983215332, 0.65794546547579, -77.6788864135742, -1.35575232719956, 218, 53, 'PPL', 'P'),
(205364, 'Pickelville', 41.9124984741211, 0.731511096110512, -111.387496948242, -1.94407856730196, 218, 52, 'PPL', 'P'),
(11180, 'Pickens', 35.3474998474121, 0.616930254685535, -91.8741683959961, -1.60350673604185, 218, 4, 'PPL', 'P'),
(61300, 'Pickens', 32.8836097717285, 0.573927260457644, -89.9713897705078, -1.57029698409051, 218, 30, 'PPL', 'P'),
(76944, 'Pickens', 34.3963890075684, 0.600330238978853, -95.0116729736328, -1.658266521218, 218, 42, 'PPL', 'P'),
(82940, 'Pickens', 34.8833312988281, 0.608828985228541, -82.7074966430664, -1.44351813250367, 218, 48, 'PPL', 'P'),
(97042, 'Pickens', 32.2538909912109, 0.562936594375968, -95.9225006103516, -1.67416346239691, 218, 51, 'PPL', 'P'),
(110884, 'Pickens', 38.6549987792969, 0.674657001053119, -80.2119369506836, -1.39996239919153, 218, 58, 'PPL', 'P'),
(89874, 'Pickens Acres', 36.0277786254883, 0.628803359194408, -86.9111099243164, -1.51688502474204, 218, 50, 'PPL', 'P'),
(4992, 'Pickens Landing', 31.9819393157959, 0.558190142233661, -88.0661087036133, -1.53704355629729, 218, 2, 'PPL', 'P'),
(4993, 'Pickensville', 33.2272186279297, 0.579924366337366, -88.2663879394531, -1.54053908838607, 218, 2, 'PPL', 'P'),
(82942, 'Pickensville', 34.811939239502, 0.60758295873352, -82.6016693115234, -1.44167109712964, 218, 48, 'PPL', 'P'),
(105225, 'Pickerel', 36.976390838623, 0.645359765638239, -79.4116668701172, -1.38599505138045, 218, 53, 'PPL', 'P'),
(175821, 'Pickerel', 45.3594398498535, 0.791671572240266, -88.9108276367188, -1.55178668293391, 218, 57, 'PPL', 'P'),
(11182, 'Pickering', 33.1352806091309, 0.578319745201566, -92.709716796875, -1.61808980669696, 218, 4, 'PPL', 'P'),
(42551, 'Pickering', 31.0338897705078, 0.541643556196349, -93.2705612182617, -1.6278783884416, 218, 22, 'PPL', 'P'),
(117285, 'Pickering', 41.9408302307129, 0.732005578545913, -92.8163909912109, -1.61995162261503, 218, 16, 'PPL', 'P'),
(139392, 'Pickering', 40.4508285522461, 0.706000143396425, -94.8419418334961, -1.65530415397945, 218, 29, 'PPL', 'P'),
(144311, 'Pickering', 43.252498626709, 0.754898510750398, -70.9530563354492, -1.23836444740661, 218, 36, 'PPL', 'P'),
(165897, 'Pickering', 40.1091690063477, 0.700037059399629, -75.5280609130859, -1.31821334058018, 218, 45, 'PPL', 'P'),
(73886, 'Pickerington', 39.8841705322266, 0.696110095214253, -82.7536087036133, -1.44432293978509, 218, 41, 'PPL', 'P'),
(140707, 'Pickert', 47.4416694641113, 0.828013334791596, -97.8147201538086, -1.70718892360081, 218, 34, 'PPL', 'P'),
(82943, 'Picket Post', 34.8286094665527, 0.607873909082611, -83.0491714477539, -1.44948148281657, 218, 48, 'PPL', 'P'),
(4994, 'Pickett', 31.9777793884277, 0.558117537804443, -85.626106262207, -1.49445747993805, 218, 2, 'PPL', 'P'),
(37669, 'Pickett', 37.122501373291, 0.647909875540045, -85.4755630493164, -1.49183000520658, 218, 21, 'PPL', 'P'),
(42552, 'Pickett', 32.639720916748, 0.569670596929315, -93.7886123657227, -1.63692008665853, 218, 22, 'PPL', 'P'),
(76945, 'Pickett', 34.7819404602051, 0.60705938126321, -96.7744369506836, -1.68903255655309, 218, 42, 'PPL', 'P'),
(97043, 'Pickett', 32.0125007629395, 0.55872354011049, -96.4766693115234, -1.68383553084385, 218, 51, 'PPL', 'P'),
(175822, 'Pickett', 43.9113883972168, 0.766398306653469, -88.7297210693359, -1.5486257770361, 218, 57, 'PPL', 'P'),
(50362, 'Picketts Corner', 39.4080581665039, 0.687800366822933, -77.0536117553711, -1.34483922568463, 218, 25, 'PPL', 'P'),
(23868, 'Picketts Creek', 34.0305595397949, 0.593945310265388, -84.751106262207, -1.4791858489831, 218, 13, 'PPL', 'P'),
(23869, 'Picketts Crossing', 34.0352783203125, 0.594027668522098, -84.7461090087891, -1.4790986304574, 218, 13, 'PPL', 'P'),
(23870, 'Picketts Mill', 34.0349998474121, 0.594022808253109, -84.741943359375, -1.47902592615964, 218, 13, 'PPL', 'P'),
(23871, 'Picketts Plantation', 34.0374984741211, 0.594066417515959, -84.7408294677734, -1.47900648508368, 218, 13, 'PPL', 'P'),
(17592, 'Pickettville', 30.3649997711182, 0.529969223373337, -81.7416687011719, -1.42666125490985, 218, 12, 'PPL', 'P'),
(151690, 'Pickettville', 44.6088905334473, 0.778572015470384, -74.8211135864258, -1.30587478209179, 218, 40, 'PPL', 'P'),
(132604, 'Pickford', 46.1577796936035, 0.805605231063561, -84.3636093139648, -1.47242275139484, 218, 27, 'PPL', 'P'),
(11183, 'Pickles Gap (historical)', 35.1261100769043, 0.613066274259939, -92.4005584716797, -1.61269397601235, 218, 4, 'PPL', 'P'),
(142667, 'Pickrell', 40.3786087036133, 0.704739669252491, -96.7283325195313, -1.68822788242972, 218, 35, 'PPL', 'P'),
(33620, 'Pickrell Corner', 37.6791687011719, 0.657625553249845, -96.8438873291016, -1.69024469432324, 218, 20, 'PPL', 'P'),
(157128, 'Pickrelltown', 40.2997207641602, 0.70336281496892, -83.6602783203125, -1.46014730982428, 218, 41, 'PPL', 'P'),
(11184, 'Pickren Hall', 36.4291687011719, 0.635808937599916, -92.0547180175781, -1.60665792140169, 218, 4, 'PPL', 'P'),
(110885, 'Pickshin', 37.6416702270508, 0.656971081411958, -81.2283325195313, -1.4177018483706, 218, 58, 'PPL', 'P'),
(171064, 'Pickstown', 43.0672187805176, 0.751664767396769, -98.5316696166992, -1.71970205229866, 218, 49, 'PPL', 'P'),
(97044, 'Pickton', 33.0280609130859, 0.576448408482594, -95.3927764892578, -1.66491803235659, 218, 51, 'PPL', 'P'),
(89876, 'Pickwatina Place', 35.434440612793, 0.618447657295634, -84.6311111450195, -1.47709153910186, 218, 50, 'PPL', 'P'),
(50363, 'Pickwick', 39.3736114501953, 0.687199158206848, -76.6858291625977, -1.33842020850922, 218, 25, 'PPL', 'P'),
(61301, 'Pickwick', 31.1355590820313, 0.543418020430669, -89.8375015258789, -1.56796019339202, 218, 30, 'PPL', 'P'),
(76948, 'Pickwick', 33.8675003051758, 0.591099389745502, -96.5263900756836, -1.68470332188506, 218, 42, 'PPL', 'P'),
(117286, 'Pickwick', 41.0083312988281, 0.715730401913193, -92.418327331543, -1.61300410112129, 218, 16, 'PPL', 'P'),
(137454, 'Pickwick', 43.9816703796387, 0.767624958651559, -91.4944381713867, -1.59687919335308, 218, 28, 'PPL', 'P'),
(123429, 'Pickwick Park', 41.4169387817383, 0.722861947838262, -85.7252807617188, -1.49618840148854, 218, 19, 'PPL', 'P'),
(50365, 'Picnic Woods Estates', 39.4333305358887, 0.688241452878477, -77.5833282470703, -1.3540845225669, 218, 25, 'PPL', 'P'),
(105226, 'Pico', 37.4980583190918, 0.654464580773002, -79.6949996948242, -1.39094014205056, 218, 53, 'PPL', 'P'),
(184094, 'Pico', 34.377498626709, 0.600000539635901, -118.611106872559, -2.07015434436102, 218, 6, 'PPL', 'P'),
(184095, 'Pico Rivera', 33.9830589294434, 0.593116268218046, -118.095832824707, -2.06116111567593, 218, 6, 'PPL', 'P'),
(17593, 'Picolata', 29.9147205352783, 0.522110368154567, -81.5930633544922, -1.42406760232422, 218, 12, 'PPL', 'P'),
(190605, 'Picotillo (historical)', 39.2238883972168, 0.684585997966235, -115.476112365723, -2.0154383681848, 218, 39, 'PPL', 'P'),
(11185, 'Picron', 34.714168548584, 0.605876538265052, -92.2236099243164, -1.60960564125424, 218, 4, 'PPL', 'P'),
(187191, 'Pictou', 37.6386108398438, 0.656917685032102, -104.813056945801, -1.82933294278454, 218, 7, 'PPL', 'P'),
(165899, 'Picture Rocks', 41.2797203063965, 0.720467033648981, -76.7133331298828, -1.3389002432957, 218, 45, 'PPL', 'P'),
(178858, 'Picture Rocks', 32.3458290100098, 0.564541215511768, -111.245559692383, -1.94160129485597, 218, 5, 'PPL', 'P'),
(189226, 'Picuris Pueblo', 36.2008285522461, 0.631823650186666, -105.709442138672, -1.84497781576626, 218, 38, 'PPL', 'P'),
(23872, 'Pidcock', 30.7841701507568, 0.537285126624866, -83.7077789306641, -1.46097635187163, 218, 13, 'PPL', 'P'),
(97045, 'Pidcoke', 31.2788906097412, 0.545919627511121, -97.8880615234375, -1.70846897197876, 218, 51, 'PPL', 'P'),
(23873, 'Piddleville', 32.5555610656738, 0.568201730430082, -81.959716796875, -1.43046691210757, 218, 13, 'PPL', 'P'),
(110891, 'Pie', 37.6533317565918, 0.657174613498267, -82.0258331298828, -1.4316208598079, 218, 58, 'PPL', 'P'),
(189228, 'Pie Town', 34.2983283996582, 0.598618758504313, -108.134170532227, -1.88729730970038, 218, 38, 'PPL', 'P'),
(4998, 'Piedmont', 34.7005615234375, 0.605639050874844, -86.5769424438477, -1.51105270195477, 218, 2, 'PPL', 'P'),
(17594, 'Piedmont', 28.6377792358398, 0.499823538124671, -81.4580612182617, -1.42171137054977, 218, 12, 'PPL', 'P'),
(23874, 'Piedmont', 33.0169410705566, 0.576254330618155, -84.2508316040039, -1.47045440903316, 218, 13, 'PPL', 'P'),
(33621, 'Piedmont', 37.6236114501953, 0.656655896296947, -96.3652801513672, -1.6818914232481, 218, 20, 'PPL', 'P'),
(56874, 'Piedmont', 37.1544418334961, 0.648467341735226, -90.695556640625, -1.58293608030791, 218, 29, 'PPL', 'P'),
(76946, 'Piedmont', 35.6419410705566, 0.622069223483006, -97.7461090087891, -1.70599143321666, 218, 42, 'PPL', 'P'),
(82944, 'Piedmont', 34.702220916748, 0.605668012751698, -82.4647216796875, -1.4392809100513, 218, 48, 'PPL', 'P'),
(89878, 'Piedmont', 36.0258293151855, 0.628769337311482, -83.5277786254883, -1.45783475389171, 218, 50, 'PPL', 'P'),
(97047, 'Piedmont', 32.6865005493164, 0.570487055540506, -94.9305725097656, -1.65685105109863, 218, 51, 'PPL', 'P'),
(105229, 'Piedmont', 37.6108283996582, 0.656432789976625, -78.9219436645508, -1.37744776901989, 218, 53, 'PPL', 'P'),
(110887, 'Piedmont', 39.480281829834, 0.689060907545895, -79.0480575561523, -1.37964887166084, 218, 58, 'PPL', 'P'),
(157129, 'Piedmont', 40.1883316040039, 0.701418707373162, -81.1966705322266, -1.41714924244441, 218, 41, 'PPL', 'P'),
(178859, 'Piedmont', 34.2388916015625, 0.5975813906807, -112.863609313965, -1.96984158821323, 218, 5, 'PPL', 'P'),
(184097, 'Piedmont', 37.8244400024414, 0.660161015765655, -122.230560302734, -2.13332572384019, 218, 6, 'PPL', 'P'),
(197246, 'Piedmont', 45.8358306884766, 0.799986160900575, -112.133331298828, -1.95709583239416, 218, 31, 'PPL', 'P'),
(201395, 'Piedmont', 45.5652809143066, 0.795264176550783, -122.666938781738, -2.14094196508366, 218, 43, 'PPL', 'P'),
(202483, 'Piedmont', 44.2316703796387, 0.771988281781545, -103.388610839844, -1.80447166821837, 218, 49, 'PPL', 'P'),
(208429, 'Piedmont', 48.0938911437988, 0.839396750555031, -123.790283203125, -2.16054802387076, 218, 56, 'PPL', 'P'),
(209666, 'Piedmont', 41.2161102294922, 0.719356828369554, -110.626670837402, -1.93079964663266, 218, 59, 'PPL', 'P'),
(23875, 'Piedmont (historical)', 33.2750015258789, 0.580758335232724, -83.5977783203125, -1.45905647904179, 218, 13, 'PPL', 'P'),
(187192, 'Piedmont (historical)', 37.1377792358398, 0.648176524544189, -104.551391601563, -1.82476602098921, 218, 7, 'PPL', 'P'),
(50364, 'Piedmont Acres', 39.5055618286133, 0.689502126759494, -76.8958282470703, -1.34208538395944, 218, 25, 'PPL', 'P'),
(23876, 'Piedmont Heights', 32.9913902282715, 0.575808384293621, -85.2077789306641, -1.48715629065154, 218, 13, 'PPL', 'P'),
(67725, 'Piedmont Heights', 36.0555610656738, 0.629288254249884, -79.8230590820313, -1.39317519999541, 218, 33, 'PPL', 'P'),
(105231, 'Piedmont Heights', 38.8716697692871, 0.678438623222005, -77.8583297729492, -1.35888420464149, 218, 53, 'PPL', 'P'),
(105233, 'Piedmont Mill', 37.0936088562012, 0.647405605987638, -79.8547210693359, -1.3937278059216, 218, 53, 'PPL', 'P'),
(82945, 'Piedmont Park', 34.9086112976074, 0.60927020444214, -82.3647232055664, -1.43753560743091, 218, 48, 'PPL', 'P'),
(67727, 'Piedmont Park Subdivision', 35.8277816772461, 0.625312753953641, -81.7361068725586, -1.42656418268811, 218, 33, 'PPL', 'P'),
(4997, 'Piedmont Springs', 33.9002799987793, 0.591671503326678, -85.6711120605469, -1.49524297930157, 218, 2, 'PPL', 'P'),
(82946, 'Piedmont Springs', 35.0750007629395, 0.612174248452817, -81.4027786254883, -1.42074650728683, 218, 48, 'PPL', 'P'),
(178860, 'Piedra', 32.9047203063965, 0.574295708794456, -112.984718322754, -1.97195533917042, 218, 5, 'PPL', 'P'),
(184098, 'Piedra', 36.8102798461914, 0.642460581896552, -119.38111114502, -2.08359345416989, 218, 6, 'PPL', 'P'),
(187193, 'Piedra', 37.2236099243164, 0.649674552657359, -107.340278625488, -1.87344128202286, 218, 7, 'PPL', 'P'),
(189231, 'Piedra de la Aguila', 35.5844383239746, 0.62106561122621, -107.74333190918, -1.88047588888425, 218, 38, 'PPL', 'P'),
(189229, 'Piedra Lumbre', 35.1558303833008, 0.613584991461259, -107.240280151367, -1.87169597940248, 218, 38, 'PPL', 'P'),
(184100, 'Piedra PO', 36.8227806091309, 0.642678761368857, -119.364440917969, -2.0833025038208, 218, 6, 'PPL', 'P'),
(197247, 'Piegan', 48.4347190856934, 0.845345320323887, -112.69361114502, -1.96687456044277, 218, 31, 'PPL', 'P'),
(187194, 'Pieplant Mill', 38.938060760498, 0.679597364612298, -106.558891296387, -1.85980350039668, 218, 7, 'PPL', 'P'),
(132605, 'Pier Cove', 42.5858306884766, 0.74326296021076, -86.2261123657227, -1.50492956197646, 218, 27, 'PPL', 'P'),
(61302, 'Piera', 34.5416717529297, 0.602865901231744, -89.6916732788086, -1.56541501033823, 218, 30, 'PPL', 'P'),
(181, 'Pierce', 39.1736106872559, 0.683708486387053, -79.5105590820313, -1.38772104608293, 218, 58, 'PPL', 'P'),
(17595, 'Pierce', 27.8347206115723, 0.485807521044666, -81.9716720581055, -1.43067557077898, 218, 12, 'PPL', 'P'),
(37670, 'Pierce', 37.1863899230957, 0.649024941088461, -85.607780456543, -1.49413763429113, 218, 21, 'PPL', 'P'),
(76947, 'Pierce', 35.4347190856934, 0.618452517564624, -95.7161102294922, -1.67056127070646, 218, 42, 'PPL', 'P'),
(89879, 'Pierce', 36.3511085510254, 0.634446530965258, -82.043327331543, -1.43192619122688, 218, 50, 'PPL', 'P'),
(97048, 'Pierce', 29.2388896942139, 0.51031489479147, -96.1997222900391, -1.67900189346536, 218, 51, 'PPL', 'P'),
(142668, 'Pierce', 42.1991691589355, 0.736514443429472, -97.5263900756836, -1.702156614405, 218, 35, 'PPL', 'P'),
(165901, 'Pierce', 40.2655601501465, 0.702766599779878, -79.9563903808594, -1.39550227015592, 218, 45, 'PPL', 'P'),
(189232, 'Pierce', 31.4561100006104, 0.549012689380166, -108.339721679688, -1.89088485400483, 218, 38, 'PPL', 'P'),
(193872, 'Pierce', 41.2686080932617, 0.720273088942596, -122.213607788086, -2.13302984664308, 218, 6, 'PPL', 'P'),
(194371, 'Pierce', 40.6355590820313, 0.70922429937013, -104.754722595215, -1.8283148162998, 218, 7, 'PPL', 'P'),
(195465, 'Pierce', 46.4911117553711, 0.811422973043866, -115.798057556152, -2.02105737176876, 218, 17, 'PPL', 'P'),
(198746, 'Pierce', 46.3522186279297, 0.808998830661621, -103.070831298828, -1.79892536893217, 218, 34, 'PPL', 'P'),
(208430, 'Pierce', 46.6349983215332, 0.813934267372784, -119.451110839844, -2.08481517931996, 218, 56, 'PPL', 'P'),
(73887, 'Pierce (historical)', 39.8936080932617, 0.696274811727674, -81.8836135864258, -1.42913866051389, 218, 41, 'PPL', 'P'),
(892, 'Pierce Acres', 34.9583282470703, 0.610137928904315, -81.8541717529297, -1.42862480358156, 218, 48, 'PPL', 'P'),
(144312, 'Pierce Bridge', 44.2724990844727, 0.772700877110223, -71.6316680908203, -1.25020845688057, 218, 36, 'PPL', 'P'),
(189233, 'Pierce Canyon Crossing', 32.1891708374023, 0.561807014599611, -103.977500915527, -1.81474973897137, 218, 38, 'PPL', 'P'),
(56875, 'Pierce City', 36.9458312988281, 0.644826401050924, -94, -1.64060949687467, 218, 29, 'PPL', 'P'),
(197248, 'Pierce Crossing', 48.3474998474121, 0.843823057444797, -112.488891601563, -1.96330153036626, 218, 31, 'PPL', 'P'),
(61303, 'Pierce Crossroad', 32.8941688537598, 0.574111551205077, -90.2455596923828, -1.57508215193716, 218, 30, 'PPL', 'P'),
(146036, 'Pierce Heights', 40.6630592346191, 0.709704267577589, -74.8847198486328, -1.30698492079219, 218, 37, 'PPL', 'P'),
(97049, 'Pierce Junction', 29.670280456543, 0.517844083956801, -95.396110534668, -1.6649762224264, 218, 51, 'PPL', 'P'),
(37671, 'Pierce Mill', 37.6405601501465, 0.656951706915027, -86.1999969482422, -1.50447376195589, 218, 21, 'PPL', 'P'),
(105236, 'Pierce Mill', 36.853328704834, 0.643211926219091, -80.9880599975586, -1.41350830176011, 218, 53, 'PPL', 'P'),
(184102, 'Pierce Mitchell Houses', 37.4213905334473, 0.653126475483292, -122.16667175293, -2.13221065829178, 218, 6, 'PPL', 'P'),
(105234, 'Pierce Park', 36.7416687011719, 0.641263091512398, -76.5494384765625, -1.33603974196885, 218, 53, 'PPL', 'P'),
(89880, 'Pierce Station', 36.4708290100098, 0.636536047156534, -88.9150009155273, -1.55185952038972, 218, 50, 'PPL', 'P'),
(28243, 'Pierceburg', 38.9305610656738, 0.679466470244721, -87.9077835083008, -1.53428026035022, 218, 18, 'PPL', 'P'),
(151691, 'Piercefield', 44.2319412231445, 0.77199300889248, -74.5699996948242, -1.30149201788585, 218, 40, 'PPL', 'P'),
(71270, 'Pierces', 39.0652809143066, 0.681817775171152, -74.8986129760742, -1.30722740160944, 218, 37, 'PPL', 'P'),
(61304, 'Pierces Chapel', 33.160831451416, 0.578765691526099, -89.5597229003906, -1.56311204178558, 218, 30, 'PPL', 'P'),
(97050, 'Pierces Chapel', 31.8772201538086, 0.556362448067053, -95.3813934326172, -1.66471936053927, 218, 51, 'PPL', 'P'),
(105235, 'Pierces Corner', 37.7958297729492, 0.659661673061265, -76.5441665649414, -1.33594772975319, 218, 53, 'PPL', 'P'),
(172397, 'Pierces Corner', 43.5411109924316, 0.759935746794228, -72.9544372558594, -1.27329513405436, 218, 55, 'PPL', 'P'),
(67728, 'Pierces Crossroads', 36.3588905334473, 0.634582352180852, -77.6608276367188, -1.35543714208455, 218, 33, 'PPL', 'P'),
(71271, 'Pierces Point', 39.0838890075684, 0.682142547666087, -74.9058303833008, -1.307353369129, 218, 37, 'PPL', 'P'),
(61305, 'Pierces Springs (historical)', 31.9750003814697, 0.55806903498309, -88.4897232055664, -1.54443702411556, 218, 30, 'PPL', 'P'),
(123430, 'Pierceton', 41.2002792358398, 0.719080525406459, -85.7055587768555, -1.49584418791765, 218, 19, 'PPL', 'P'),
(4999, 'Pierceton (historical)', 34.7277793884277, 0.606114092234287, -86.1972198486328, -1.50442529242405, 218, 2, 'PPL', 'P'),
(11188, 'Piercetown', 35.9663887023926, 0.627731902908841, -93.0713882446289, -1.62440216427072, 218, 4, 'PPL', 'P'),
(82947, 'Piercetown', 34.6566696166992, 0.604872992587283, -82.5927810668945, -1.44151596799614, 218, 48, 'PPL', 'P'),
(23878, 'Pierceville', 34.952220916748, 0.610031335881684, -84.3958282470703, -1.47298507785901, 218, 13, 'PPL', 'P'),
(30823, 'Pierceville', 39.1333312988281, 0.6830054784383, -85.1797180175781, -1.48666653532708, 218, 19, 'PPL', 'P'),
(67729, 'Pierceville', 36.4483299255371, 0.636143364053802, -76.2938919067383, -1.33157961293324, 218, 33, 'PPL', 'P'),
(78942, 'Pierceville', 39.7541694641113, 0.693841148544532, -76.7799987792969, -1.34006377837596, 218, 45, 'PPL', 'P'),
(117288, 'Pierceville', 40.7844390869141, 0.71182274564572, -91.8333282470703, -1.60279394097609, 218, 16, 'PPL', 'P'),
(151693, 'Pierceville', 42.8499984741211, 0.747873557847959, -75.6372222900391, -1.32011856602403, 218, 40, 'PPL', 'P'),
(175825, 'Pierceville', 43.1358299255371, 0.752862257780923, -89.1530609130859, -1.55601445116441, 218, 57, 'PPL', 'P'),
(187846, 'Pierceville', 37.8783302307129, 0.661101577683643, -100.676391601563, -1.75713451247443, 218, 20, 'PPL', 'P'),
(184103, 'Piercy', 39.9663887023926, 0.697545072988615, -123.794166564941, -2.16061580132051, 218, 6, 'PPL', 'P'),
(199606, 'Piercy Place', 42.3488883972168, 0.739127537091057, -100.332496643066, -1.75113241316767, 218, 35, 'PPL', 'P'),
(110888, 'Piercys Mill', 37.8436088562012, 0.660495575377596, -80.5738906860352, -1.40627968361331, 218, 58, 'PPL', 'P'),
(42553, 'Piermont', 31.9513893127441, 0.557656944093913, -93.2822189331055, -1.62808185394888, 218, 22, 'PPL', 'P'),
(144313, 'Piermont', 43.9697189331055, 0.767416366559179, -72.0811080932617, -1.25805266471335, 218, 36, 'PPL', 'P'),
(151694, 'Piermont', 41.0419387817383, 0.716316963143283, -73.9186096191406, -1.29012311635036, 218, 40, 'PPL', 'P'),
(14404, 'Piermont Woods', 39.6458282470703, 0.691950237591549, -75.7069396972656, -1.32133536432608, 218, 10, 'PPL', 'P'),
(56879, 'Pierpont', 38.8622207641602, 0.678273706971501, -92.3147201538086, -1.61119581474113, 218, 29, 'PPL', 'P'),
(82948, 'Pierpont', 32.8294410705566, 0.572981838270665, -80.0425033569336, -1.39700522511711, 218, 48, 'PPL', 'P'),
(110890, 'Pierpont', 37.628059387207, 0.656733527442723, -81.3913879394531, -1.42054770231146, 218, 58, 'PPL', 'P'),
(157130, 'Pierpont', 41.7491683959961, 0.728660448479692, -80.5686111450195, -1.40618753823959, 218, 41, 'PPL', 'P'),
(171066, 'Pierpont', 45.4955596923828, 0.794047311669699, -97.8308334350586, -1.70747015341193, 218, 49, 'PPL', 'P'),
(184104, 'Pierpont Bay', 34.2597198486328, 0.597944912169496, -119.268333435059, -2.08162511180821, 218, 6, 'PPL', 'P'),
(132607, 'Pierport', 44.4266700744629, 0.775391668496612, -86.2399978637695, -1.50517190963565, 218, 27, 'PPL', 'P'),
(128535, 'Pierre', 47.2324981689453, 0.824362606990289, -68.6738891601563, -1.19858547599437, 218, 26, 'PPL', 'P'),
(202484, 'Pierre', 44.3683280944824, 0.77437340885382, -100.350563049316, -1.75144773144073, 218, 49, 'PPL', 'P'),
(42554, 'Pierre Part', 29.9650001525879, 0.522987913023262, -91.2030563354492, -1.59179362093546, 218, 22, 'PPL', 'P'),
(151695, 'Pierrepont', 44.5422210693359, 0.777408413811102, -75.0122222900391, -1.30921025819906, 218, 40, 'PPL', 'P'),
(151696, 'Pierrepont Manor', 43.7350006103516, 0.763319759012364, -76.0591735839844, -1.32748300538642, 218, 40, 'PPL', 'P'),
(28245, 'Pierron', 38.7763900756836, 0.676775678858332, -89.5202789306641, -1.5624236146438, 218, 18, 'PPL', 'P'),
(17596, 'Pierson', 29.2391700744629, 0.510319788349973, -81.4658279418945, -1.42184692544926, 218, 12, 'PPL', 'P'),
(28246, 'Pierson', 39.7980613708496, 0.694607206832094, -88.5283279418945, -1.54511080387135, 218, 18, 'PPL', 'P'),
(117289, 'Pierson', 42.5441703796387, 0.742535850654141, -95.8672180175781, -1.67319859913397, 218, 16, 'PPL', 'P'),
(132608, 'Pierson', 43.3197212219238, 0.756071766368632, -85.4977798461914, -1.49221776146129, 218, 27, 'PPL', 'P'),
(14405, 'Pierson Farms', 39.8113899230957, 0.694839833953312, -75.5386123657227, -1.31839749816956, 218, 10, 'PPL', 'P'),
(30824, 'Pierson Station', 39.9033317565918, 0.696444521668139, -85.3263931274414, -1.48922649892491, 218, 19, 'PPL', 'P'),
(151698, 'Pierstown', 42.771671295166, 0.746506490681394, -74.9130630493164, -1.30747960296467, 218, 40, 'PPL', 'P'),
(137455, 'Pierz', 45.9816703796387, 0.802531543691446, -94.1044387817383, -1.64243229748277, 218, 28, 'PPL', 'P'),
(184105, 'Pieta', 38.9266700744629, 0.679398559636924, -123.054168701172, -2.14770040214, 218, 6, 'PPL', 'P'),
(125808, 'Piety Corner', 42.3902816772461, 0.739849986115769, -71.2397232055664, -1.24336772814654, 218, 23, 'PPL', 'P'),
(208432, 'Pifer', 47.2552795410156, 0.824760216941037, -118.083892822266, -2.06095272332063, 218, 56, 'PPL', 'P'),
(151699, 'Piffard', 42.8283309936523, 0.747495388973168, -77.8511123657227, -1.35875823712193, 218, 40, 'PPL', 'P'),
(37672, 'Pig', 37.1327781677246, 0.648089239439462, -86.1699981689453, -1.50395018448558, 218, 21, 'PPL', 'P'),
(30826, 'Pigeon', 38.0999984741211, 0.664970418378229, -87.0666732788086, -1.51960011747338, 218, 19, 'PPL', 'P'),
(37673, 'Pigeon', 37.4319381713867, 0.653310566493644, -82.5536117553711, -1.44083233454432, 218, 21, 'PPL', 'P'),
(42555, 'Pigeon', 30.0766696929932, 0.524936914177523, -91.2994384765625, -1.59347580663801, 218, 22, 'PPL', 'P'),
(110892, 'Pigeon', 38.5366706848145, 0.67259178620679, -81.208610534668, -1.41735763479971, 218, 58, 'PPL', 'P'),
(117290, 'Pigeon', 41.4588890075684, 0.723594117400952, -95.7838897705078, -1.67174424686268, 218, 16, 'PPL', 'P'),
(132610, 'Pigeon', 43.8300018310547, 0.764977843107048, -83.2699966430664, -1.45333560954613, 218, 27, 'PPL', 'P'),
(165902, 'Pigeon', 41.5305595397949, 0.724845004164962, -79.0513916015625, -1.37970706173066, 218, 45, 'PPL', 'P'),
(205365, 'Pigeon', 41.3325004577637, 0.72138822107004, -113.798606872559, -1.98616037410879, 218, 52, 'PPL', 'P'),
(28247, 'Pigeon (historical)', 38.3950004577637, 0.670119174292706, -88.7563934326172, -1.54909129759464, 218, 18, 'PPL', 'P'),
(82949, 'Pigeon Bay (historical)', 33.2675018310547, 0.580627440865147, -80.2372207641602, -1.40040368498416, 218, 48, 'PPL', 'P'),
(125809, 'Pigeon Cove', 42.6736106872559, 0.744795010206855, -70.6333312988281, -1.23278419281651, 218, 23, 'PPL', 'P'),
(5001, 'Pigeon Creek', 31.6574993133545, 0.55252759596588, -86.5072174072266, -1.50983577049466, 218, 2, 'PPL', 'P'),
(157132, 'Pigeon Creek', 41.1108283996582, 0.717519313796427, -81.6730575561523, -1.42546376452569, 218, 41, 'PPL', 'P'),
(175827, 'Pigeon Falls', 44.4263916015625, 0.775386808227622, -91.2102813720703, -1.59191972161308, 218, 57, 'PPL', 'P'),
(89881, 'Pigeon Forge', 35.788330078125, 0.624624193653801, -83.554443359375, -1.45830014129221, 218, 50, 'PPL', 'P'),
(11189, 'Pigeon Hill', 33.2744407653809, 0.580748548115718, -92.3566665649414, -1.61192791772479, 218, 4, 'PPL', 'P'),
(105237, 'Pigeon Hill', 37.9366683959961, 0.662119770747408, -76.9466705322266, -1.34297274923465, 218, 53, 'PPL', 'P'),
(128536, 'Pigeon Hill', 44.4441719055176, 0.775697133073644, -67.8880615234375, -1.18487019638046, 218, 26, 'PPL', 'P'),
(78944, 'Pigeon Hills (historical)', 39.8680610656738, 0.695828931982168, -76.9305572509766, -1.34269151942354, 218, 45, 'PPL', 'P'),
(192746, 'Pigeon Hollow Junction', 39.4216690063477, 0.688037920792168, -111.558326721191, -1.94706010930036, 218, 52, 'PPL', 'P'),
(50366, 'Pigeon House Corner', 38.9913902282715, 0.680528139413281, -76.70361328125, -1.33873059993426, 218, 25, 'PPL', 'P'),
(137458, 'Pigeon River', 48.0102806091309, 0.837937471435722, -89.7083282470703, -1.56570569437121, 218, 28, 'PPL', 'P'),
(89882, 'Pigeon Roost', 36.1030616760254, 0.630117296297225, -87.8080596923828, -1.5325397514198, 218, 50, 'PPL', 'P'),
(30828, 'Pigeon Roost Station', 38.6144409179688, 0.673949132835376, -85.7758331298828, -1.49707070675769, 218, 19, 'PPL', 'P'),
(14406, 'Pigeon Run', 39.625, 0.691586716102753, -75.654167175293, -1.32041431006308, 218, 10, 'PPL', 'P'),
(157134, 'Pigeon Run', 40.7488899230957, 0.711202295690759, -81.5730590820313, -1.42371846190531, 218, 41, 'PPL', 'P'),
(190607, 'Pigeon Spring (historical)', 37.420280456543, 0.653107100986362, -117.666938781738, -2.05367550248394, 218, 39, 'PPL', 'P'),
(208433, 'Pigeon Springs', 46.0533294677734, 0.803782230718374, -122.622779846191, -2.14017124626419, 218, 56, 'PPL', 'P'),
(37674, 'Pigeonroost', 37.1111106872559, 0.64771107056467, -83.8144378662109, -1.46283790147359, 218, 21, 'PPL', 'P'),
(67731, 'Pigeonroost', 36.0691719055176, 0.629525808219119, -82.2966690063477, -1.43634783758474, 218, 33, 'PPL', 'P'),
(5002, 'Pigeye', 34.297779083252, 0.598609171124389, -87.9241714477539, -1.5345662838513, 218, 2, 'PPL', 'P'),
(73889, 'Pigeye', 39.9219398498535, 0.696769294163075, -84.3119430541992, -1.47152100504974, 218, 41, 'PPL', 'P'),
(105238, 'Piggen', 37.5947189331055, 0.65615162674454, -75.720832824707, -1.32157784514334, 218, 53, 'PPL', 'P'),
(11191, 'Piggott', 36.3827781677246, 0.634999270049504, -90.190559387207, -1.57412221552224, 218, 4, 'PPL', 'P'),
(61306, 'Piggtown', 32.6497192382813, 0.569845100559743, -89.6158294677734, -1.5640912861184, 218, 30, 'PPL', 'P'),
(165903, 'Pigs Ear', 41.5633316040039, 0.725416984588084, -78.9372177124023, -1.37771435144501, 218, 45, 'PPL', 'P'),
(157133, 'Pigtown', 40.5636100769043, 0.70796855233713, -81.0536117553711, -1.41465239576441, 218, 41, 'PPL', 'P'),
(28249, 'Pike', 39.4597206115723, 0.688702046589006, -91.0350036621094, -1.5888605484689, 218, 18, 'PPL', 'P'),
(76949, 'Pike', 33.9644393920898, 0.592791295986029, -97.3249969482422, -1.69864164124026, 218, 42, 'PPL', 'P'),
(97051, 'Pike', 33.3222198486328, 0.581582450432049, -96.3027801513672, -1.6808005924656, 218, 51, 'PPL', 'P'),
(110893, 'Pike', 39.2833290100098, 0.685623432368875, -81.081672668457, -1.41514215108887, 218, 58, 'PPL', 'P'),
(123432, 'Pike', 40.1241683959961, 0.700298848134784, -86.4819412231445, -1.50939461786008, 218, 19, 'PPL', 'P'),
(144315, 'Pike', 44.0308303833008, 0.768482962575756, -72.0086135864258, -1.25678739687945, 218, 36, 'PPL', 'P'),
(151700, 'Pike', 42.5563888549805, 0.742749103278429, -78.1530609130859, -1.36402823344504, 218, 40, 'PPL', 'P'),
(184106, 'Pike', 39.4391708374023, 0.6883433853692, -120.996940612793, -2.11179499853328, 218, 6, 'PPL', 'P'),
(23879, 'Pike (historical)', 34.665828704834, 0.605032848831715, -84.3824996948242, -1.47275245073779, 218, 13, 'PPL', 'P'),
(23880, 'Pike Acres', 32.6669387817383, 0.570145638288758, -83.6488876342773, -1.45994850484891, 218, 13, 'PPL', 'P'),
(11192, 'Pike City', 34.1122207641602, 0.595370567501771, -93.5749969482422, -1.63319179429047, 218, 4, 'PPL', 'P'),
(105239, 'Pike City', 36.7311096191406, 0.641078800764964, -80.4830627441406, -1.40469443697444, 218, 53, 'PPL', 'P'),
(128537, 'Pike Corner', 43.982780456543, 0.76764433314849, -70.5175018310547, -1.23076258723303, 218, 26, 'PPL', 'P'),
(14408, 'Pike Creek', 39.7308311462402, 0.693433818055805, -75.7044372558594, -1.32129168848421, 218, 10, 'PPL', 'P'),
(14409, 'Pike Creek Valley', 39.7361106872559, 0.693525963429522, -75.6986083984375, -1.32118995573057, 218, 10, 'PPL', 'P'),
(67736, 'Pike Crossroads', 35.4908294677734, 0.619431828476473, -78.0597229003906, -1.36239917780623, 218, 33, 'PPL', 'P'),
(42556, 'Pike Fort', 30.1658306121826, 0.526493065781483, -89.7383270263672, -1.56622927184152, 218, 22, 'PPL', 'P'),
(110894, 'Pike Hill', 38.976390838623, 0.680266350678126, -82.0449981689453, -1.43195535284081, 218, 58, 'PPL', 'P'),
(11195, 'Pike Junction', 34.0349998474121, 0.594022808253109, -93.4105606079102, -1.63032183874175, 218, 4, 'PPL', 'P'),
(175831, 'Pike Lake', 43.3138885498047, 0.755969967035964, -88.3419418334961, -1.54185775259982, 218, 57, 'PPL', 'P'),
(175832, 'Pike River', 46.4599990844727, 0.810879954497599, -91.2397232055664, -1.59243357854541, 218, 57, 'PPL', 'P'),
(5004, 'Pike Road', 32.2841682434082, 0.563465032115267, -86.1030578613281, -1.50278185571536, 218, 2, 'PPL', 'P'),
(67732, 'Pike Road', 35.6827812194824, 0.622782018548766, -76.6277770996094, -1.33740700887249, 218, 33, 'PPL', 'P'),
(37676, 'Pike View', 37.3794403076172, 0.652394305920602, -85.753059387207, -1.49667322996499, 218, 21, 'PPL', 'P'),
(187195, 'Pike-San Isabel Village', 39.0519409179688, 0.681584948312852, -105.720001220703, -1.84516210651369, 218, 7, 'PPL', 'P'),
(165909, 'Pikeland', 40.1002807617188, 0.699881930266132, -75.6119384765625, -1.3196772802314, 218, 45, 'PPL', 'P'),
(151702, 'Pikes Corner', 44.2772216796875, 0.772783301945961, -75.5177764892578, -1.31803384352271, 218, 40, 'PPL', 'P'),
(165910, 'Pikes Creek', 41.3063888549805, 0.7209324876285, -76.0963897705078, -1.32813255037629, 218, 45, 'PPL', 'P'),
(172398, 'Pikes Falls', 43.0969390869141, 0.752183484598089, -72.8555603027344, -1.27156940566799, 218, 55, 'PPL', 'P'),
(30834, 'Pikes Peak', 39.1291694641113, 0.682932840719568, -86.1413879394531, -1.50345084178119, 218, 19, 'PPL', 'P'),
(42557, 'Pikes Peak', 29.9802799224854, 0.52325459531692, -90.8080596923828, -1.58489962897963, 218, 22, 'PPL', 'P'),
(165911, 'Pikes Peak', 40.598331451416, 0.708574554643178, -79.0111083984375, -1.37900398720288, 218, 45, 'PPL', 'P'),
(110896, 'Pikeside', 39.4174995422363, 0.687965149915382, -77.9894409179688, -1.36117252580814, 218, 58, 'PPL', 'P'),
(50367, 'Pikesville', 39.3741683959961, 0.687208878744826, -76.7227783203125, -1.33906509296718, 218, 25, 'PPL', 'P'),
(73894, 'Piketon', 39.0680618286133, 0.681866311282018, -83.0144424438477, -1.44887534735247, 218, 41, 'PPL', 'P'),
(61308, 'Piketown', 32.4874992370605, 0.567013827425852, -89.3661117553711, -1.55973288983643, 218, 30, 'PPL', 'P'),
(165912, 'Piketown', 40.3786087036133, 0.704739669252491, -76.7561111450195, -1.33964686050731, 218, 45, 'PPL', 'P'),
(187196, 'Pikeview', 38.9152793884277, 0.679199754661549, -104.821670532227, -1.82948327822807, 218, 7, 'PPL', 'P'),
(5006, 'Pikeville', 34.0380592346191, 0.594076204632965, -87.9511108398438, -1.53503646494175, 218, 2, 'PPL', 'P'),
(30835, 'Pikeville', 38.3219413757324, 0.668844052762776, -87.1113891601563, -1.52038055683082, 218, 19, 'PPL', 'P'),
(37677, 'Pikeville', 37.4791717529297, 0.654134948009078, -82.5188903808594, -1.44022633223827, 218, 21, 'PPL', 'P'),
(67733, 'Pikeville', 35.496940612793, 0.619538488078131, -77.9822235107422, -1.36104655828858, 218, 33, 'PPL', 'P'),
(89883, 'Pikeville', 35.6055603027344, 0.621434259300104, -85.1888885498047, -1.48682659130859, 218, 50, 'PPL', 'P'),
(151703, 'Pikeville', 42.0541687011719, 0.733983708024597, -78.0461120605469, -1.362161623837, 218, 40, 'PPL', 'P'),
(157140, 'Pikeville', 40.163330078125, 0.700982348428553, -84.6050033569336, -1.47663587223935, 218, 41, 'PPL', 'P'),
(165913, 'Pikeville', 40.3983306884766, 0.705083882823384, -75.7238922119141, -1.32163124152319, 218, 45, 'PPL', 'P'),
(175833, 'Pikeville', 42.4961090087891, 0.741697021489793, -88.0244369506836, -1.53631624700359, 218, 57, 'PPL', 'P'),
(61309, 'Pikeville (historical)', 33.8950004577637, 0.591579357952961, -88.7736129760742, -1.54939183532366, 218, 30, 'PPL', 'P'),
(212086, 'Pikmiktalik', 63.2361106872559, 1.10367833764819, -162.592498779297, -2.83777444274359, 218, 1, 'PPL', 'P'),
(97052, 'Pila Blanca', 27.8061103820801, 0.485308178340276, -98.4725036621094, -1.71866941158598, 218, 51, 'PPL', 'P'),
(17597, 'Pilaklakha (historical)', 28.6333293914795, 0.499745873689382, -81.9833297729492, -1.43087903628626, 218, 12, 'PPL', 'P'),
(67735, 'Pilands Crossroads', 36.3455581665039, 0.634349658480607, -76.8116683959961, -1.3406165174602, 218, 33, 'PPL', 'P'),
(177718, 'Pilar', 36.269718170166, 0.63302600083981, -105.787498474121, -1.84634015582189, 218, 38, 'PPL', 'P'),
(37678, 'Pilcher Landing', 37.9919395446777, 0.663084434273262, -86.0175018310547, -1.50128862129216, 218, 21, 'PPL', 'P'),
(42558, 'Pilcher Point', 32.9500007629395, 0.575086001847937, -91.1999969482422, -1.59174022455561, 218, 22, 'PPL', 'P'),
(208435, 'Pilchuck', 48.0186080932617, 0.838082813452213, -121.912498474121, -2.12777449770598, 218, 56, 'PPL', 'P'),
(212087, 'Pile Bay Village', 59.7788887023926, 1.04333843103999, -153.881942749023, -2.68574656033587, 218, 1, 'PPL', 'P'),
(42559, 'Pilette', 30.1683292388916, 0.526536675044333, -91.9991683959961, -1.60568839760684, 218, 22, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(142673, 'Pilger', 42.0086097717285, 0.733188554702126, -97.0536117553711, -1.6939050760835, 218, 35, 'PPL', 'P'),
(165914, 'Pilgerts', 40.4744415283203, 0.706412267575115, -75.6538925170898, -1.32040951637312, 218, 45, 'PPL', 'P'),
(37680, 'Pilgrim', 37.7991714477539, 0.659719996289137, -82.42138671875, -1.43852457230171, 218, 21, 'PPL', 'P'),
(56884, 'Pilgrim', 37.3574981689453, 0.652011343355849, -93.7752838134766, -1.63668745953731, 218, 29, 'PPL', 'P'),
(97053, 'Pilgrim', 29.2930603027344, 0.511260350267962, -97.5216674804688, -1.70207418956926, 218, 51, 'PPL', 'P'),
(132612, 'Pilgrim', 47.0997200012207, 0.822045190788729, -88.5169372558594, -1.54491199889598, 218, 27, 'PPL', 'P'),
(151704, 'Pilgrim Corners', 41.4613914489746, 0.72363779324283, -74.4438934326172, -1.29929104840295, 218, 40, 'PPL', 'P'),
(78945, 'Pilgrim Gardens', 39.9563903808594, 0.697370569358187, -75.3247222900391, -1.31466441211154, 218, 45, 'PPL', 'P'),
(61310, 'Pilgrim Grove', 32.2694396972656, 0.563207970491047, -89.2027816772461, -1.55688224220561, 218, 30, 'PPL', 'P'),
(125810, 'Pilgrim Heights', 42.0569381713867, 0.734032044398381, -70.1152801513672, -1.22374249459959, 218, 23, 'PPL', 'P'),
(23882, 'Pilgrim North', 33.8013916015625, 0.589945575203225, -84.7569427490234, -1.47928771489479, 218, 13, 'PPL', 'P'),
(178861, 'Pilgrim Playground', 34.9619407653809, 0.610200979243122, -111.481109619141, -1.94571241663073, 218, 5, 'PPL', 'P'),
(23883, 'Pilgrim Rest', 32.5541687011719, 0.568177429085135, -83.6727828979492, -1.46036555587562, 218, 13, 'PPL', 'P'),
(61311, 'Pilgrim Rest', 32.7244415283203, 0.571149250545555, -89.5875015258789, -1.56359687026203, 218, 30, 'PPL', 'P'),
(212088, 'Pilgrim Springs', 65.0936126708984, 1.13609786312508, -164.923889160156, -2.87846488103891, 218, 1, 'PPL', 'P'),
(165915, 'Pilgrimham', 41.2336082458496, 0.719662226367559, -79.6030578613281, -1.38933545433573, 218, 45, 'PPL', 'P'),
(151705, 'Pilgrimport', 43.0963897705078, 0.752173897218165, -76.9702835083008, -1.34338487341334, 218, 40, 'PPL', 'P'),
(11197, 'Pilgrims Rest', 36.1872215270996, 0.631586162796459, -93.9938888549805, -1.64050283727301, 218, 4, 'PPL', 'P'),
(105241, 'Pilgrims Rest', 38.7922210693359, 0.677051981821428, -77.7136077880859, -1.35635832950561, 218, 53, 'PPL', 'P'),
(61312, 'Pilgrims Rest (historical)', 33.1855583190918, 0.579197256780747, -89.5102767944336, -1.56224904443434, 218, 30, 'PPL', 'P'),
(184107, 'Pilibos Ranch', 36.6836090087891, 0.640249758717623, -120.513328552246, -2.10335437577439, 218, 6, 'PPL', 'P'),
(105242, 'Pilkinton', 37.4300003051758, 0.6532767443478, -77.841667175293, -1.35859338745046, 218, 53, 'PPL', 'P'),
(146038, 'Pill Hill', 40.7005615234375, 0.710358805994504, -74.5911102294922, -1.30186046622266, 218, 37, 'PPL', 'P'),
(137462, 'Pillager', 46.3300018310547, 0.808611074406906, -94.4738922119141, -1.64888047627213, 218, 28, 'PPL', 'P'),
(11198, 'Pillar', 34.5461082458496, 0.602943332640438, -90.7158279418945, -1.58328988125873, 218, 4, 'PPL', 'P'),
(151706, 'Pillar Point', 43.9702796936035, 0.767426153676185, -76.126106262207, -1.32865120099859, 218, 40, 'PPL', 'P'),
(184108, 'Pilliken', 38.6863899230957, 0.675204879868376, -120.353332519531, -2.10056191821338, 218, 6, 'PPL', 'P'),
(165916, 'Pillow', 40.6408309936523, 0.709316311585792, -76.8027801513672, -1.34046138832671, 218, 45, 'PPL', 'P'),
(89886, 'Pillowville', 36.1525001525879, 0.630980160490411, -88.6613922119141, -1.54743321349996, 218, 50, 'PPL', 'P'),
(137464, 'Pillsbury', 45.9333305358887, 0.801687854258109, -94.6833267211914, -1.65253579802632, 218, 28, 'PPL', 'P'),
(140700, 'Pillsbury', 47.2069396972656, 0.8239165275077, -97.790283203125, -1.70676241835224, 218, 34, 'PPL', 'P'),
(33623, 'Pillsbury Crossing', 39.1297187805176, 0.682942428099492, -96.4402770996094, -1.68320036692387, 218, 20, 'PPL', 'P'),
(165918, 'Pilltown', 40.1713905334473, 0.701123029913136, -79.0133285522461, -1.37904273619674, 218, 45, 'PPL', 'P'),
(37679, 'Pilot', 37.7491683959961, 0.658847278399919, -83.7797164916992, -1.46223189916754, 218, 21, 'PPL', 'P'),
(50368, 'Pilot', 39.7038917541504, 0.692963636965351, -76.2016677856445, -1.32996999837039, 218, 25, 'PPL', 'P'),
(67738, 'Pilot', 35.8847198486328, 0.626306512514404, -78.2652816772461, -1.36598685526873, 218, 33, 'PPL', 'P'),
(105243, 'Pilot', 37.0519409179688, 0.646678363272965, -80.3638916015625, -1.40261450816308, 218, 53, 'PPL', 'P'),
(200127, 'Pilot', 40.8183288574219, 0.712414233723827, -114.233612060547, -1.99375264690245, 218, 39, 'PPL', 'P'),
(121034, 'Pilot Center (historical)', 41.0574989318848, 0.716588538995444, -88.0758285522461, -1.53721319965872, 218, 18, 'PPL', 'P'),
(56885, 'Pilot Grove', 38.8747215270996, 0.678491886443806, -92.9113922119141, -1.62160970670972, 218, 29, 'PPL', 'P'),
(97054, 'Pilot Grove', 33.4377784729004, 0.583599328904593, -96.4244384765625, -1.68292393080272, 218, 51, 'PPL', 'P'),
(117292, 'Pilot Grove', 40.7627792358398, 0.711444709928983, -91.5366668701172, -1.59761622318476, 218, 16, 'PPL', 'P'),
(137466, 'Pilot Grove', 43.5291709899902, 0.759727354438929, -94.2275009155273, -1.64458013690192, 218, 28, 'PPL', 'P'),
(184109, 'Pilot Hill', 38.8349990844727, 0.677798599033031, -121.013328552246, -2.11208102203436, 218, 6, 'PPL', 'P'),
(30836, 'Pilot Knob', 38.2825012207031, 0.668155692200018, -86.3497161865234, -1.50708685561748, 218, 19, 'PPL', 'P'),
(56887, 'Pilot Knob', 37.6211090087891, 0.65661222045507, -90.6402816772461, -1.58197135020303, 218, 29, 'PPL', 'P'),
(89884, 'Pilot Knob', 36.2680587768555, 0.632997038962955, -82.9958267211914, -1.44855044169948, 218, 50, 'PPL', 'P'),
(112600, 'Pilot Knob', 30.163890838623, 0.526459210346126, -97.6927795410156, -1.70506065841568, 218, 51, 'PPL', 'P'),
(151707, 'Pilot Knob', 43.5158309936523, 0.759494527580629, -73.6297225952148, -1.28508108661656, 218, 40, 'PPL', 'P'),
(175835, 'Pilot Knob (historical)', 43.9874992370605, 0.7677266914052, -89.6180572509766, -1.56413016827032, 218, 57, 'PPL', 'P'),
(117294, 'Pilot Mound', 42.1644401550293, 0.73590830796537, -94.0163879394531, -1.64089552037574, 218, 16, 'PPL', 'P'),
(67739, 'Pilot Mountain', 36.3863906860352, 0.635062320388312, -80.4697189331055, -1.40446154353711, 218, 33, 'PPL', 'P'),
(89885, 'Pilot Mountain', 36.1994400024414, 0.631799415420747, -84.6605606079102, -1.47760552919224, 218, 50, 'PPL', 'P'),
(37681, 'Pilot Oak', 36.5466690063477, 0.637859704797331, -88.7222213745117, -1.54849488266852, 218, 21, 'PPL', 'P'),
(97055, 'Pilot Point', 33.3963890075684, 0.582876946458909, -96.9602813720703, -1.69227615360275, 218, 51, 'PPL', 'P'),
(212089, 'Pilot Point', 57.5641708374023, 1.00468431229317, -157.579162597656, -2.7502752198646, 218, 1, 'PPL', 'P'),
(117296, 'Pilot Rock', 42.7738914489746, 0.746545239675255, -92.8494415283203, -1.62052846330715, 218, 16, 'PPL', 'P'),
(201396, 'Pilot Rock', 45.4833297729492, 0.793833859308329, -118.828887939453, -2.07395534102684, 218, 43, 'PPL', 'P'),
(212090, 'Pilot Station', 61.9388885498047, 1.08103754021991, -162.875, -2.84270501918576, 218, 1, 'PPL', 'P'),
(37682, 'Pilot View', 37.9677810668945, 0.662662789293675, -84.0638885498047, -1.46719163722365, 218, 21, 'PPL', 'P'),
(14410, 'Pilottown', 38.7797203063965, 0.676833802349123, -75.1527786254883, -1.31166342903719, 218, 10, 'PPL', 'P'),
(42560, 'Pilottown', 29.1813907623291, 0.509311349113701, -89.2574996948242, -1.55783725177252, 218, 22, 'PPL', 'P'),
(33624, 'Pilsen', 38.4713897705078, 0.671452419313427, -97.0400009155273, -1.69366752211426, 218, 20, 'PPL', 'P'),
(175836, 'Pilsen', 44.4436111450195, 0.775687345956638, -87.7249984741211, -1.53109005968041, 218, 57, 'PPL', 'P'),
(197249, 'Piltzville', 46.8613891601563, 0.817885532903107, -113.861671447754, -1.98726105858732, 218, 31, 'PPL', 'P'),
(178862, 'Pima', 32.896110534668, 0.574145439929948, -109.826942443848, -1.91684175304345, 218, 5, 'PPL', 'P'),
(178866, 'Pimaco Two', 31.9505596160889, 0.557642463155486, -110.451942443848, -1.92775006086841, 218, 5, 'PPL', 'P'),
(30837, 'Pimento', 39.309440612793, 0.686079165810415, -87.3791732788086, -1.52505427138586, 218, 19, 'PPL', 'P'),
(50369, 'Pimlico', 39.3502807617188, 0.686791960876174, -76.6694412231445, -1.33813418500814, 218, 25, 'PPL', 'P'),
(82950, 'Pimlico', 33.0972213745117, 0.577655486246673, -79.960563659668, -1.39557510761173, 218, 48, 'PPL', 'P'),
(105244, 'Pimmit Hills', 38.9127807617188, 0.679156145398699, -77.2011108398438, -1.34741357035236, 218, 53, 'PPL', 'P'),
(5008, 'Pin Hook', 32.3574981689453, 0.564744880756132, -87.8716735839844, -1.53365002327825, 218, 2, 'PPL', 'P'),
(30838, 'Pin Hook', 39.814998626709, 0.694902817713092, -87.1272201538086, -1.52065685979392, 218, 19, 'PPL', 'P'),
(56888, 'Pin Hook', 37.6791687011719, 0.657625553249845, -90.7358322143555, -1.58363902167764, 218, 29, 'PPL', 'P'),
(67741, 'Pin Hook', 34.747501373291, 0.606458305805179, -77.7716674804688, -1.35737166230038, 218, 33, 'PPL', 'P'),
(97056, 'Pin Hook', 33.809440612793, 0.590086056950727, -95.3191680908203, -1.66363332344673, 218, 51, 'PPL', 'P'),
(97057, 'Pin Oak', 30.0852794647217, 0.525087183042031, -97.0849990844727, -1.69445288831973, 218, 51, 'PPL', 'P'),
(56890, 'Pin Oak Community', 38.9483299255371, 0.67977659535366, -91.2544403076172, -1.59269044043255, 218, 29, 'PPL', 'P'),
(76950, 'Pin Oaks Acres', 36.1288909912109, 0.630568102890749, -95.2702789306641, -1.66278004663347, 218, 42, 'PPL', 'P'),
(23885, 'Pin Point', 31.9530601501465, 0.55768610570785, -81.0924987792969, -1.41533110236821, 218, 13, 'PPL', 'P'),
(105245, 'Pinaire', 36.7216682434082, 0.640914017672516, -76.6474990844727, -1.33775122244339, 218, 53, 'PPL', 'P'),
(178864, 'Pinal', 33.3761100769043, 0.582523012350038, -110.753059387207, -1.93300554296358, 218, 5, 'PPL', 'P'),
(144316, 'Pinardville', 42.9941711425781, 0.750389845603921, -71.5077819824219, -1.24804623639154, 218, 36, 'PPL', 'P'),
(178867, 'Pinaveta', 35.2272186279297, 0.614830951377252, -112.572219848633, -1.96475588263756, 218, 5, 'PPL', 'P'),
(110895, 'Pinch', 38.4086112976074, 0.670356728261941, -81.4819412231445, -1.42212815526037, 218, 58, 'PPL', 'P'),
(123435, 'Pinch', 40.1066703796387, 0.699993450136779, -85.1463928222656, -1.486084900945, 218, 19, 'PPL', 'P'),
(50371, 'Pinch Valley Estates', 39.6097183227539, 0.691320000519582, -77.0219421386719, -1.34428648660039, 218, 25, 'PPL', 'P'),
(61313, 'Pinchback', 33.2772216796875, 0.580797084226585, -90.1930618286133, -1.57416589136412, 218, 30, 'PPL', 'P'),
(37684, 'Pinchem', 36.7027816772461, 0.640584384908591, -87.1972198486328, -1.52187858494399, 218, 21, 'PPL', 'P'),
(73896, 'Pincher (historical)', 39.1952781677246, 0.684086655261845, -82.331672668457, -1.4369587667388, 218, 41, 'PPL', 'P'),
(5009, 'Pinchona', 30.923059463501, 0.539709202428083, -87.7241668701172, -1.53107554545247, 218, 2, 'PPL', 'P'),
(73895, 'Pinchtown (historical)', 39.8327789306641, 0.695213142559114, -84.3027801513672, -1.47136108222628, 218, 41, 'PPL', 'P'),
(5010, 'Pinckard', 31.3113899230957, 0.546486847533794, -85.5530624389648, -1.49318262472423, 218, 2, 'PPL', 'P'),
(37686, 'Pinckard', 37.9772186279297, 0.662827505807096, -84.6816711425781, -1.47797397752906, 218, 21, 'PPL', 'P'),
(11200, 'Pinckney', 34.9766693115234, 0.610458040867342, -90.3052825927734, -1.57612451318782, 218, 4, 'PPL', 'P'),
(56894, 'Pinckney', 38.6786117553711, 0.675069125231809, -91.232780456543, -1.59231240471581, 218, 29, 'PPL', 'P'),
(82951, 'Pinckney', 34.8405609130859, 0.608082501174992, -81.4958267211914, -1.42237050291957, 218, 48, 'PPL', 'P'),
(132613, 'Pinckney', 42.4566688537598, 0.741008660927035, -83.9463882446289, -1.46514087002624, 218, 27, 'PPL', 'P'),
(82952, 'Pinckney Colony', 32.3172187805176, 0.564041872807378, -80.898063659668, -1.41193756934918, 218, 48, 'PPL', 'P'),
(82953, 'Pinckney Crossroad', 33.9933280944824, 0.593295498959408, -80.4947204589844, -1.40489790248172, 218, 48, 'PPL', 'P'),
(151708, 'Pinckney Heights', 40.9194412231445, 0.714178977420168, -73.8202819824219, -1.28840697534391, 218, 40, 'PPL', 'P'),
(82954, 'Pinckney Landing', 32.3422203063965, 0.564478231751988, -80.8394393920898, -1.41091438285837, 218, 48, 'PPL', 'P'),
(28252, 'Pinckneyville', 38.0802803039551, 0.664626271386363, -89.3819427490234, -1.56000919279953, 218, 18, 'PPL', 'P'),
(37685, 'Pinckneyville', 37.1872215270996, 0.649039455316402, -88.2397232055664, -1.54007370098558, 218, 21, 'PPL', 'P'),
(61314, 'Pinckneyville', 31.0158290863037, 0.541328337791824, -91.480827331543, -1.59664163938384, 218, 30, 'PPL', 'P'),
(82955, 'Pinckneyville', 34.8427810668945, 0.608121250168852, -81.4686126708984, -1.42189552813915, 218, 48, 'PPL', 'P'),
(23884, 'Pinckneyville (historical)', 33.9683303833008, 0.592859206593826, -84.2077789306641, -1.4697029981316, 218, 13, 'PPL', 'P'),
(132614, 'Pinconning', 43.8536109924316, 0.76538990070671, -83.9649963378906, -1.46546564252117, 218, 27, 'PPL', 'P'),
(11201, 'Pindall', 36.0661087036133, 0.629472345260235, -92.8811111450195, -1.62108120239139, 218, 4, 'PPL', 'P'),
(151710, 'Pindars Corners', 42.4386100769043, 0.740693475812024, -74.9641723632813, -1.3083716287718, 218, 40, 'PPL', 'P'),
(50372, 'Pindell', 38.7755584716797, 0.676761164630391, -76.6833267211914, -1.33837653266734, 218, 25, 'PPL', 'P'),
(5011, 'Pinder Hill', 34.8561096191406, 0.608353877290071, -85.8208312988281, -1.49785607296315, 218, 2, 'PPL', 'P'),
(23886, 'Pindertown (historical)', 31.7522201538086, 0.55418078650206, -83.9888916015625, -1.46588269354788, 218, 13, 'PPL', 'P'),
(165919, 'Pindleton', 40.5063896179199, 0.706969866928351, -78.8099975585938, -1.37549394088615, 218, 45, 'PPL', 'P'),
(42563, 'Pine', 30.9074993133545, 0.539437626575923, -90.0136108398438, -1.57103388076413, 218, 22, 'PPL', 'P'),
(97058, 'Pine', 32.9130592346191, 0.574441250548029, -94.9691696166992, -1.65752469769636, 218, 51, 'PPL', 'P'),
(123436, 'Pine', 41.624439239502, 0.726483514025634, -87.394172668457, -1.52531606012101, 218, 19, 'PPL', 'P'),
(151711, 'Pine', 43.2586097717285, 0.755005170352055, -75.6391677856445, -1.32015252132793, 218, 40, 'PPL', 'P'),
(165921, 'Pine', 41.610279083252, 0.726236372676474, -77.4066696166992, -1.35100124781486, 218, 45, 'PPL', 'P'),
(178868, 'Pine', 34.3844413757324, 0.600121713465499, -111.454437255859, -1.94524689607218, 218, 5, 'PPL', 'P'),
(195466, 'Pine', 43.4841690063477, 0.758941921654438, -115.311111450195, -2.01255855894004, 218, 17, 'PPL', 'P'),
(201397, 'Pine', 44.8613891601563, 0.78297894786322, -117.08805847168, -2.04357213509845, 218, 43, 'PPL', 'P'),
(105246, 'Pine (historical)', 36.9458312988281, 0.644826401050924, -82.408332824707, -1.43829673887046, 218, 53, 'PPL', 'P'),
(142676, 'Pine Acre Mobile Home Park', 40.8458290100098, 0.712894201931286, -96.6666717529297, -1.68715169903322, 218, 35, 'PPL', 'P'),
(82958, 'Pine Acres', 33.8908309936523, 0.591506587076175, -80.3138885498047, -1.40174179027387, 218, 48, 'PPL', 'P'),
(105248, 'Pine Acres', 37.2102813720703, 0.64944192553614, -80.0141677856445, -1.39651067610268, 218, 53, 'PPL', 'P'),
(146037, 'Pine Acres', 40.0419387817383, 0.69886367062334, -74.1938934326172, -1.29492772527297, 218, 37, 'PPL', 'P'),
(165922, 'Pine Acres', 40.3349990844727, 0.703978537812946, -76.7341690063477, -1.33926389794255, 218, 45, 'PPL', 'P'),
(184110, 'Pine Acres', 38.396110534668, 0.670138548789636, -120.642501831055, -2.10560887479519, 218, 6, 'PPL', 'P'),
(23887, 'Pine Acres Mobile Home Park', 33.5247192382813, 0.585116731514693, -84.5633316040039, -1.47590856294565, 218, 13, 'PPL', 'P'),
(42562, 'Pine Acres Trailer Park', 30.2169399261475, 0.527385091588605, -93.1894378662109, -1.62646251884806, 218, 22, 'PPL', 'P'),
(151712, 'Pine Aire', 40.7705612182617, 0.711580531144577, -73.2744369506836, -1.27888018233442, 218, 40, 'PPL', 'P'),
(5015, 'Pine Apple', 31.8724994659424, 0.556280056520829, -86.9911117553711, -1.51828132010157, 218, 2, 'PPL', 'P'),
(78946, 'Pine Bank', 39.7569389343262, 0.693889484918317, -80.311393737793, -1.40169824759004, 218, 45, 'PPL', 'P'),
(17598, 'Pine Barren', 30.7772197723389, 0.537163819637213, -87.3344421386719, -1.5242735657123, 218, 12, 'PPL', 'P'),
(50374, 'Pine Beach', 38.2463912963867, 0.667525455128051, -75.8352813720703, -1.32357534911895, 218, 25, 'PPL', 'P'),
(71272, 'Pine Beach', 39.9358291625977, 0.697011708401299, -74.17138671875, -1.29453490901218, 218, 37, 'PPL', 'P'),
(105250, 'Pine Beach (historical)', 36.9500007629395, 0.64489917192771, -76.3283309936523, -1.33218068839127, 218, 53, 'PPL', 'P'),
(137470, 'Pine Bend', 47.4263916015625, 0.827746685787452, -95.5908279418945, -1.66837468229345, 218, 28, 'PPL', 'P'),
(11202, 'Pine Bluff', 34.228328704834, 0.597397033354239, -92.003059387207, -1.60575630821464, 218, 4, 'PPL', 'P'),
(17600, 'Pine Bluff', 30.1241703033447, 0.525765956224864, -81.5861129760742, -1.42394629533656, 218, 12, 'PPL', 'P'),
(50373, 'Pine Bluff', 39.0238914489746, 0.681095392725468, -76.5097198486328, -1.3353465211371, 218, 25, 'PPL', 'P'),
(61316, 'Pine Bluff', 32.3819389343262, 0.565171452583736, -89.1849975585938, -1.55657185078057, 218, 30, 'PPL', 'P'),
(105251, 'Pine Bluff', 37.3138885498047, 0.651250211916304, -80.0319366455078, -1.39682080121162, 218, 53, 'PPL', 'P'),
(110897, 'Pine Bluff', 39.4180603027344, 0.687974937032388, -80.3274993896484, -1.4019793442431, 218, 58, 'PPL', 'P'),
(175838, 'Pine Bluff', 43.0608291625977, 0.751553247526122, -89.6555633544922, -1.56478477326626, 218, 57, 'PPL', 'P'),
(5016, 'Pine Bluff Estates', 34.6769409179688, 0.6052267935381, -87.7133331298828, -1.53088646101508, 218, 2, 'PPL', 'P'),
(5017, 'Pine Bluff Landing', 31.2272205352783, 0.545017814586993, -87.9813919067383, -1.53556496926007, 218, 2, 'PPL', 'P'),
(125811, 'Pine Bluffs', 41.8250007629395, 0.729983972962434, -70.9236068725586, -1.23785045731623, 218, 23, 'PPL', 'P'),
(209667, 'Pine Bluffs', 41.1819381713867, 0.718760413443431, -104.06861114502, -1.81633991245826, 218, 59, 'PPL', 'P'),
(205367, 'Pine Bluffs Summer Home Area', 41.7688903808594, 0.729004662050584, -111.659439086914, -1.9488248529967, 218, 52, 'PPL', 'P'),
(97059, 'Pine Branch', 33.4813919067383, 0.584360526923165, -95.1130599975586, -1.66003605860431, 218, 51, 'PPL', 'P'),
(113905, 'Pine Bridge', 41.4280586242676, 0.723056025702702, -73.0680618286133, -1.27527825696009, 218, 8, 'PPL', 'P'),
(137476, 'Pine Brook', 45.5869407653809, 0.79564221226752, -93.3883285522461, -1.62993381617092, 218, 28, 'PPL', 'P'),
(146040, 'Pine Brook', 40.860279083252, 0.713146403286517, -74.3408279418945, -1.29749221624466, 218, 37, 'PPL', 'P'),
(151713, 'Pine Brook', 40.9244384765625, 0.714266195945868, -73.7850036621094, -1.28779125249988, 218, 40, 'PPL', 'P'),
(82960, 'Pine Brook Forest', 34.7397193908691, 0.606322484589585, -82.3077774047852, -1.43654171571209, 218, 48, 'PPL', 'P'),
(194372, 'Pine Brook Hill', 40.0499992370605, 0.699004352107924, -105.314170837402, -1.83807903012046, 218, 7, 'PPL', 'P'),
(151715, 'Pine Bush', 41.7819404602051, 0.729232428902813, -74.290283203125, -1.29661004413357, 218, 40, 'PPL', 'P'),
(184111, 'Pine Canyon Mobile Estates', 36.1813888549805, 0.63148436346379, -121.148612976074, -2.11444218065682, 218, 6, 'PPL', 'P'),
(17601, 'Pine Castle', 28.4716701507568, 0.496924387672497, -81.3680572509766, -1.42014050498079, 218, 12, 'PPL', 'P'),
(137471, 'Pine Center', 46.2144393920898, 0.806594129355334, -93.9141693115234, -1.6391114687615, 218, 28, 'PPL', 'P'),
(105252, 'Pine Chapel Village', 37.0352783203125, 0.646387546081928, -76.3733291625977, -1.33296605459673, 218, 53, 'PPL', 'P'),
(5019, 'Pine Circle', 33.2472190856934, 0.580273440177248, -87.6875, -1.53043558784253, 218, 2, 'PPL', 'P'),
(11203, 'Pine City', 34.5827789306641, 0.603583356829412, -91.1130599975586, -1.59022288852453, 218, 4, 'PPL', 'P'),
(56895, 'Pine City', 36.3824996948242, 0.634994409780515, -90.0238876342773, -1.57121324466355, 218, 29, 'PPL', 'P'),
(137472, 'Pine City', 45.8261108398438, 0.799816517539137, -92.9683303833008, -1.62260346527048, 218, 28, 'PPL', 'P'),
(151716, 'Pine City', 42.0366706848145, 0.733678310026592, -76.8697204589844, -1.34162971709692, 218, 40, 'PPL', 'P'),
(165923, 'Pine City', 41.3050003051758, 0.72090825286258, -79.5077819824219, -1.38767257655109, 218, 45, 'PPL', 'P'),
(201398, 'Pine City', 45.5813903808594, 0.795545339782868, -119.415832519531, -2.08419945647594, 218, 43, 'PPL', 'P'),
(208437, 'Pine City', 47.2024993896484, 0.823839029519979, -117.523330688477, -2.05116906842401, 218, 56, 'PPL', 'P'),
(42564, 'Pine Cliff', 30.7827796936035, 0.537260858569433, -90.1233291625977, -1.57294882674595, 218, 22, 'PPL', 'P'),
(50388, 'Pine Cliff', 39.3952789306641, 0.687577327081639, -77.3652801513672, -1.35027886536917, 218, 25, 'PPL', 'P'),
(128540, 'Pine Cliff', 43.8308296203613, 0.764992290755961, -69.6508331298828, -1.2156363648736, 218, 26, 'PPL', 'P'),
(144317, 'Pine Cliff', 43.3411102294922, 0.756445074974434, -72.0416717529297, -1.25736437072962, 218, 36, 'PPL', 'P'),
(128538, 'Pine Corner', 44.9955596923828, 0.785320665409727, -67.295280456543, -1.17452421501967, 218, 26, 'PPL', 'P'),
(151717, 'Pine Corners', 42.7491683959961, 0.746113740999635, -77.2569427490234, -1.34838802099522, 218, 40, 'PPL', 'P'),
(42565, 'Pine Coupee', 31.3741703033447, 0.547582571874794, -92.8988876342773, -1.62139146065839, 218, 22, 'PPL', 'P'),
(50375, 'Pine Cove', 39.2388916015625, 0.684847853280417, -75.959716796875, -1.32574715698791, 218, 25, 'PPL', 'P'),
(184112, 'Pine Cove', 33.7605590820313, 0.58923291329552, -116.736938476563, -2.03744393511407, 218, 6, 'PPL', 'P'),
(205368, 'Pine Cove East', 40.6188888549805, 0.708933349021039, -111.795280456543, -1.95119573215714, 218, 52, 'PPL', 'P'),
(23888, 'Pine Creek', 33.8027801513672, 0.589969809969145, -84.6066665649414, -1.47666490069523, 218, 13, 'PPL', 'P'),
(89887, 'Pine Creek', 35.6269416809082, 0.621807434747851, -85.4366683959961, -1.49115116544471, 218, 50, 'PPL', 'P'),
(110898, 'Pine Creek', 37.7516708374023, 0.658890954241796, -82.0924987792969, -1.43278439488816, 218, 58, 'PPL', 'P'),
(132618, 'Pine Creek', 42.8277816772461, 0.747485801593244, -86.1374969482422, -1.50338293117339, 218, 27, 'PPL', 'P'),
(137477, 'Pine Creek', 43.8452796936035, 0.765244492111192, -91.4033279418945, -1.59528901986619, 218, 28, 'PPL', 'P'),
(151718, 'Pine Creek', 42.3594398498535, 0.739311694680436, -77.0425033569336, -1.34464534755728, 218, 40, 'PPL', 'P'),
(175839, 'Pine Creek', 44.1344413757324, 0.770291315534947, -91.5266723632813, -1.59744178613336, 218, 57, 'PPL', 'P'),
(195467, 'Pine Creek', 47.5486106872559, 0.829879811241579, -116.221389770508, -2.02844591273902, 218, 17, 'PPL', 'P'),
(197250, 'Pine Creek', 45.5074996948242, 0.794255704024997, -110.563331604004, -1.92969416846417, 218, 31, 'PPL', 'P'),
(201399, 'Pine Creek', 44.9488906860352, 0.784506137590326, -116.877502441406, -2.03989723911025, 218, 43, 'PPL', 'P'),
(175840, 'Pine Creek (historical)', 44.0633316040039, 0.769050215887942, -91.5299987792969, -1.59749984304512, 218, 57, 'PPL', 'P'),
(190609, 'Pine Creek (historical)', 38.7961082458496, 0.677119825850197, -116.847503662109, -2.03937366163994, 218, 39, 'PPL', 'P'),
(5020, 'Pine Crest', 33.3716697692871, 0.582445514362317, -86.9869384765625, -1.51820848264576, 218, 2, 'PPL', 'P'),
(50377, 'Pine Crest', 39.5658302307129, 0.690554008811048, -76.331672668457, -1.33223901161914, 218, 25, 'PPL', 'P'),
(56897, 'Pine Crest', 37.0919418334961, 0.647376510952729, -91.6586074829102, -1.59974448836989, 218, 29, 'PPL', 'P'),
(67742, 'Pine Crest', 35.4194412231445, 0.61818586856048, -76.6897201538086, -1.33848811911701, 218, 33, 'PPL', 'P'),
(71279, 'Pine Crest', 39.7963905334473, 0.694578045218157, -74.5813903808594, -1.30169082286122, 218, 37, 'PPL', 'P'),
(89889, 'Pine Crest', 36.2991714477539, 0.633540057509222, -82.3180618286133, -1.43672121276957, 218, 50, 'PPL', 'P'),
(97060, 'Pine Crest', 30.1200008392334, 0.525693185348078, -94.1216735839844, -1.6427331015279, 218, 51, 'PPL', 'P'),
(151719, 'Pine Crest', 43.2388916015625, 0.75466102336019, -75.6230621337891, -1.31987142467487, 218, 40, 'PPL', 'P'),
(187197, 'Pine Crest', 39.1124992370605, 0.682641890370477, -104.907783508301, -1.83098623318926, 218, 7, 'PPL', 'P'),
(50378, 'Pine Crest North', 39.1366691589355, 0.683063735087145, -76.4652786254883, -1.33457087546961, 218, 25, 'PPL', 'P'),
(50379, 'Pine Crest West', 39.1333312988281, 0.6830054784383, -76.4797210693359, -1.33482294366679, 218, 25, 'PPL', 'P'),
(5021, 'Pine Dale', 34.9622192382813, 0.610205839512112, -86.8274993896484, -1.51542574562273, 218, 2, 'PPL', 'P'),
(17602, 'Pine Dale', 27.8547191619873, 0.486156561595034, -81.9711074829102, -1.43066571708294, 218, 12, 'PPL', 'P'),
(137478, 'Pine Estates', 43.6347198486328, 0.761569529543964, -91.4966735839844, -1.59691820866305, 218, 28, 'PPL', 'P'),
(5022, 'Pine Flat', 32.6541709899902, 0.569922798284546, -86.4311065673828, -1.50850738574292, 218, 2, 'PPL', 'P'),
(61318, 'Pine Flat', 34.9741706848145, 0.610414431604492, -88.2799987792969, -1.54077664235531, 218, 30, 'PPL', 'P'),
(184113, 'Pine Flat', 35.878059387207, 0.626190265532822, -118.65055847168, -2.07084290466086, 218, 6, 'PPL', 'P'),
(165927, 'Pine Flats', 41.2405586242676, 0.719783533355212, -75.1022186279297, -1.31078099060999, 218, 45, 'PPL', 'P'),
(17603, 'Pine Forest', 30.5194396972656, 0.532664708581147, -87.3163909912109, -1.52395851375535, 218, 12, 'PPL', 'P'),
(23895, 'Pine Forest', 33.8647193908691, 0.591050853634635, -84.8452835083008, -1.48082955200789, 218, 13, 'PPL', 'P'),
(82964, 'Pine Forest', 34.0777816772461, 0.59476949204374, -81.0425033569336, -1.41445851763705, 218, 48, 'PPL', 'P'),
(97062, 'Pine Forest', 30.1811103820801, 0.526759748075141, -94.0341720581055, -1.64120591180079, 218, 51, 'PPL', 'P'),
(67746, 'Pine Forest Acres', 34.7683296203613, 0.606821827293975, -77.4922180175781, -1.35249434908001, 218, 33, 'PPL', 'P'),
(42568, 'Pine Forest South', 32.4005584716797, 0.565496424815752, -93.8513870239258, -1.63801571113099, 218, 22, 'PPL', 'P'),
(165928, 'Pine Forge', 40.2827796936035, 0.703067137508894, -75.6911087036133, -1.32105906136299, 218, 45, 'PPL', 'P'),
(67747, 'Pine Fork', 36.4436111450195, 0.636061005797091, -81.2172164916992, -1.41750783708519, 218, 33, 'PPL', 'P'),
(165929, 'Pine Furnace', 40.8536109924316, 0.71303002314688, -79.429443359375, -1.38630530964744, 218, 45, 'PPL', 'P'),
(73902, 'Pine Gap', 38.9566688537598, 0.679922137107233, -83.3141708374023, -1.45410659468171, 218, 41, 'PPL', 'P'),
(23898, 'Pine Gardens', 32.0661087036133, 0.559659175180462, -81.0602798461914, -1.41476877590404, 218, 13, 'PPL', 'P'),
(105255, 'Pine Gardens', 37.2063903808594, 0.649374014928343, -77.3727798461914, -1.35040975973675, 218, 53, 'PPL', 'P'),
(165931, 'Pine Glen', 40.5016708374023, 0.70688750867164, -77.6805572509766, -1.3557814888135, 218, 45, 'PPL', 'P'),
(208438, 'Pine Glen', 47.2213897705078, 0.824168728862931, -121.129440307617, -2.11410755446585, 218, 56, 'PPL', 'P'),
(5034, 'Pine Grove', 32.769718170166, 0.571939477020008, -85.7050018310547, -1.49583446737967, 218, 2, 'PPL', 'P'),
(11205, 'Pine Grove', 34.6083297729492, 0.604029303153945, -94.103889465332, -1.64242271010285, 218, 4, 'PPL', 'P'),
(14411, 'Pine Grove', 38.5397186279297, 0.672644982849565, -75.1166687011719, -1.31103319196522, 218, 10, 'PPL', 'P'),
(17604, 'Pine Grove', 28.2594394683838, 0.493220263491333, -81.1847229003906, -1.41694071693106, 218, 12, 'PPL', 'P'),
(23900, 'Pine Grove', 33.5694389343262, 0.585897237451168, -83.7169418334961, -1.46113627469509, 218, 13, 'PPL', 'P'),
(37688, 'Pine Grove', 38.0019416809082, 0.663259004482716, -84.3158264160156, -1.47158878249948, 218, 21, 'PPL', 'P'),
(42572, 'Pine Grove', 30.7097206115723, 0.535985737039503, -90.7538909912109, -1.58395420679265, 218, 22, 'PPL', 'P'),
(50380, 'Pine Grove', 38.3786087036133, 0.669833084212604, -75.5269393920898, -1.31819376634617, 218, 25, 'PPL', 'P'),
(61325, 'Pine Grove', 34.6641693115234, 0.60500388695486, -88.8011093139648, -1.54987173695209, 218, 30, 'PPL', 'P'),
(67757, 'Pine Grove', 34.9269409179688, 0.609590116668085, -76.9486083984375, -1.3430065713805, 218, 33, 'PPL', 'P'),
(71275, 'Pine Grove', 39.8836097717285, 0.696100308097247, -74.8802795410156, -1.30690742280447, 218, 37, 'PPL', 'P'),
(73898, 'Pine Grove', 38.6080589294434, 0.673837746122784, -82.7050018310547, -1.44347458981984, 218, 41, 'PPL', 'P'),
(82969, 'Pine Grove', 34.8877792358398, 0.608906616374317, -82.0500030517578, -1.43204270452457, 218, 48, 'PPL', 'P'),
(89894, 'Pine Grove', 35.7000007629395, 0.623082556277781, -85.4855575561523, -1.49200444225798, 218, 50, 'PPL', 'P'),
(97066, 'Pine Grove', 30.1086101531982, 0.525494380372704, -93.7577819824219, -1.63638199496028, 218, 51, 'PPL', 'P'),
(105259, 'Pine Grove', 36.7224998474121, 0.640928531900457, -82.2680587768555, -1.43584849488035, 218, 53, 'PPL', 'P'),
(110904, 'Pine Grove', 39.5, 0.68940505453776, -80.1963882446289, -1.39969102307645, 218, 58, 'PPL', 'P'),
(113907, 'Pine Grove', 41.336109161377, 0.72145120482982, -72.1855621337891, -1.25987573163756, 218, 8, 'PPL', 'P'),
(121041, 'Pine Grove', 41.3394393920898, 0.721509328320611, -88.4044418334961, -1.54294858338232, 218, 18, 'PPL', 'P'),
(125813, 'Pine Grove', 42.1611099243164, 0.735850184474579, -70.9305572509766, -1.23797176430388, 218, 23, 'PPL', 'P'),
(132619, 'Pine Grove', 42.353889465332, 0.739214822195785, -85.8627777099609, -1.49858817594682, 218, 27, 'PPL', 'P'),
(151724, 'Pine Grove', 44.774169921875, 0.781456684984131, -75.2855606079102, -1.31398091181778, 218, 40, 'PPL', 'P'),
(165937, 'Pine Grove', 41.1875, 0.718857485665165, -79.7738876342773, -1.39231699633413, 218, 45, 'PPL', 'P'),
(175842, 'Pine Grove', 44.8997192382813, 0.783647933929048, -91.6302795410156, -1.59925007251352, 218, 57, 'PPL', 'P'),
(187198, 'Pine Grove', 39.4099998474121, 0.687834255547804, -105.323333740234, -1.83823895294392, 218, 7, 'PPL', 'P'),
(190610, 'Pine Grove', 38.6783294677734, 0.675064198383793, -119.123062133789, -2.0790896492924, 218, 39, 'PPL', 'P'),
(193873, 'Pine Grove', 40.6650009155273, 0.709738156302461, -122.35221862793, -2.13544906217731, 218, 6, 'PPL', 'P'),
(197251, 'Pine Grove', 47.999439239502, 0.837748253840272, -108.680557250977, -1.89683355693174, 218, 31, 'PPL', 'P'),
(201402, 'Pine Grove', 45.6541709899902, 0.796815601043809, -121.512496948242, -2.12079315406639, 218, 43, 'PPL', 'P'),
(209922, 'Pine Grove', 45.9025001525879, 0.801149762559858, -122.658058166504, -2.14078696910821, 218, 56, 'PPL', 'P'),
(5035, 'Pine Grove (historical)', 34.2944412231445, 0.598550914475543, -85.7652816772461, -1.49688654916831, 218, 2, 'PPL', 'P'),
(61326, 'Pine Grove (historical)', 33.3008308410645, 0.581209141826247, -88.7666702270508, -1.54927066149406, 218, 30, 'PPL', 'P'),
(73899, 'Pine Grove (historical)', 39.5977783203125, 0.691111608164283, -82.5505599975586, -1.44077907132252, 218, 41, 'PPL', 'P'),
(67748, 'Pine Grove Apartments', 35.5849990844727, 0.621075398343216, -77.5877838134766, -1.35416228687073, 218, 33, 'PPL', 'P'),
(132620, 'Pine Grove Beach', 43.8219413757324, 0.764837161622464, -85.9619369506836, -1.5003188311812, 218, 27, 'PPL', 'P'),
(105260, 'Pine Grove Court', 37.0569381713867, 0.646765581798665, -76.3433303833008, -1.33244247712642, 218, 53, 'PPL', 'P'),
(50381, 'Pine Grove Estates', 38.5191688537598, 0.672286321629758, -76.7652816772461, -1.33980691648882, 218, 25, 'PPL', 'P'),
(89895, 'Pine Grove Estates', 35.9966697692871, 0.628260407227168, -84.9611129760742, -1.48285115759137, 218, 50, 'PPL', 'P'),
(165938, 'Pine Grove Furnace', 40.0333290100098, 0.698713401758832, -77.2988891601563, -1.34912012397888, 218, 45, 'PPL', 'P'),
(73900, 'Pine Grove Heights', 39.2872200012207, 0.685691342976672, -82.1266708374023, -1.43338080981428, 218, 41, 'PPL', 'P'),
(165939, 'Pine Grove Mills', 40.7336082458496, 0.710935580107588, -77.8858337402344, -1.35936423942798, 218, 45, 'PPL', 'P'),
(117299, 'Pine Grove Mobile Home Park', 41.6305618286133, 0.726590373364373, -93.602783203125, -1.63367675592498, 218, 16, 'PPL', 'P'),
(144318, 'Pine Grove Park', 42.7986106872559, 0.746976671771848, -71.1977767944336, -1.24263562516288, 218, 36, 'PPL', 'P'),
(105261, 'Pine Grove Terrace', 37.0516700744629, 0.64667363616203, -76.3388900756836, -1.3323649791387, 218, 53, 'PPL', 'P'),
(197252, 'Pine Grove Trailer Court', 45.6847190856934, 0.797348765894043, -111.037498474121, -1.93796994155159, 218, 31, 'PPL', 'P'),
(5036, 'Pine Grove Village', 33.0755615234375, 0.577277450529936, -86.5177764892578, -1.51002006124209, 218, 2, 'PPL', 'P'),
(50382, 'Pine Grove Village', 39.1500015258789, 0.683296428787391, -76.5177764892578, -1.33548713604266, 218, 25, 'PPL', 'P'),
(67749, 'Pine Hall', 36.3244400024414, 0.63398107698574, -80.0497207641602, -1.39713119263667, 218, 33, 'PPL', 'P'),
(165943, 'Pine Hall', 40.7761116027832, 0.711677403629229, -77.8852767944336, -1.35935451889, 218, 45, 'PPL', 'P'),
(23902, 'Pine Harbor', 31.5472202301025, 0.550602862867052, -81.3755569458008, -1.42027139934836, 218, 13, 'PPL', 'P'),
(67750, 'Pine Harbor', 35.1175003051758, 0.612916005395431, -81.0302810668945, -1.41424519843373, 218, 33, 'PPL', 'P'),
(89896, 'Pine Harbor Heights', 35.2702789306641, 0.615582495436873, -85.1308288574219, -1.48581325851381, 218, 50, 'PPL', 'P'),
(5037, 'Pine Haven', 30.7319393157959, 0.536373526583732, -87.7930603027344, -1.53227796268464, 218, 2, 'PPL', 'P'),
(11206, 'Pine Haven', 34.5647201538086, 0.603268171714401, -92.4894409179688, -1.61424526734732, 218, 4, 'PPL', 'P'),
(23904, 'Pine Haven', 34.2788887023926, 0.598279471781437, -83.8858337402344, -1.46408399454764, 218, 13, 'PPL', 'P'),
(50383, 'Pine Haven', 39.1494407653809, 0.683286641670385, -76.5372161865234, -1.33582642276553, 218, 25, 'PPL', 'P'),
(67751, 'Pine Haven', 35.4972190856934, 0.61954334834712, -80.1050033569336, -1.3980960558996, 218, 33, 'PPL', 'P'),
(89897, 'Pine Haven', 36.4533309936523, 0.63623064915853, -84.9375, -1.48243903341268, 218, 50, 'PPL', 'P'),
(125814, 'Pine Haven', 41.7902793884277, 0.729377970656386, -70.9522171020508, -1.23834980002062, 218, 23, 'PPL', 'P'),
(209668, 'Pine Haven', 44.357780456543, 0.774189317843468, -104.809997558594, -1.82927954640468, 218, 59, 'PPL', 'P'),
(5038, 'Pine Haven Shores', 34.8569412231445, 0.608368391518012, -87.3600006103516, -1.52471964519489, 218, 2, 'PPL', 'P'),
(105262, 'Pine Heights', 37.5183296203613, 0.654818381723819, -77.279167175293, -1.34877591040799, 218, 53, 'PPL', 'P'),
(5041, 'Pine Hill', 31.9794406890869, 0.558146532970811, -87.5880584716797, -1.52870000576012, 218, 2, 'PPL', 'P'),
(23908, 'Pine Hill', 31.4469394683838, 0.548852633398652, -83.7038879394531, -1.46090844126383, 218, 13, 'PPL', 'P'),
(37687, 'Pine Hill', 37.3294410705566, 0.65152165461041, -84.2633285522461, -1.47067252192644, 218, 21, 'PPL', 'P'),
(50384, 'Pine Hill', 39.0430603027344, 0.681429952337409, -76.9780578613281, -1.34352056147088, 218, 25, 'PPL', 'P'),
(67755, 'Pine Hill', 36.3488883972168, 0.634407781971398, -80.5897216796875, -1.4065559865764, 218, 33, 'PPL', 'P'),
(71276, 'Pine Hill', 39.7841682434082, 0.694364726014842, -74.9925003051758, -1.30886604462817, 218, 37, 'PPL', 'P'),
(82971, 'Pine Hill', 33.521110534668, 0.585053747754913, -81.0486068725586, -1.41456504408065, 218, 48, 'PPL', 'P'),
(89901, 'Pine Hill', 36.5063896179199, 0.637156696848577, -84.4711074829102, -1.4742989483828, 218, 50, 'PPL', 'P'),
(97069, 'Pine Hill', 33.0608291625977, 0.577020322326689, -95.3199996948242, -1.66364783767467, 218, 51, 'PPL', 'P'),
(105263, 'Pine Hill', 37.6483306884766, 0.65708732839354, -77.3225021362305, -1.34953224815757, 218, 53, 'PPL', 'P'),
(113909, 'Pine Hill', 41.8622207641602, 0.730633584531331, -72.8122177124023, -1.27081293476035, 218, 8, 'PPL', 'P'),
(128539, 'Pine Hill', 43.2313919067383, 0.754530128992612, -70.5977783203125, -1.23216367628253, 218, 26, 'PPL', 'P'),
(151727, 'Pine Hill', 42.1330604553223, 0.735360628887195, -74.4805603027344, -1.2999310060129, 218, 40, 'PPL', 'P'),
(157142, 'Pine Hill', 40.5666694641113, 0.708021948716986, -80.8680572509766, -1.41141385872082, 218, 41, 'PPL', 'P'),
(165945, 'Pine Hill', 40.6991691589355, 0.710334504649557, -76.2858276367188, -1.33143886486963, 218, 45, 'PPL', 'P'),
(169546, 'Pine Hill', 41.5777816772461, 0.725669185943315, -71.6277770996094, -1.25014054627278, 218, 47, 'PPL', 'P'),
(193874, 'Pine Hill', 40.764720916748, 0.711478598653855, -124.173332214355, -2.16723349031324, 218, 6, 'PPL', 'P'),
(132622, 'Pine Hill (historical)', 43.3583297729492, 0.756745612703449, -82.5405578613281, -1.44060450111307, 218, 27, 'PPL', 'P'),
(82972, 'Pine Hill Acres', 32.4477806091309, 0.566320606594105, -80.6488876342773, -1.40758862728908, 218, 48, 'PPL', 'P'),
(125815, 'Pine Hill Acres', 41.7138900756836, 0.728044725635665, -70.9472198486328, -1.23826258149492, 218, 23, 'PPL', 'P'),
(11207, 'Pine Hill Estates', 34.9105606079102, 0.609304226325065, -91.9499969482422, -1.60483019394556, 218, 4, 'PPL', 'P'),
(17605, 'Pine Hill Estates', 29.6619396209717, 0.517698508913715, -82.4563903808594, -1.43913550145578, 218, 12, 'PPL', 'P'),
(42573, 'Pine Hill Estates', 32.547779083252, 0.568065909214488, -93.8430633544922, -1.63787043569352, 218, 22, 'PPL', 'P'),
(50386, 'Pine Hill Estates', 39.3352813720703, 0.68653017214102, -77.6708297729492, -1.355611712294, 218, 25, 'PPL', 'P'),
(50387, 'Pine Hill Farms', 39.514720916748, 0.689661983003926, -76.7230606079102, -1.33907001981519, 218, 25, 'PPL', 'P'),
(82973, 'Pine Hill Landing', 32.8352813720703, 0.573083770761388, -80.3997192382813, -1.40323981838704, 218, 48, 'PPL', 'P'),
(137479, 'Pine Hill Park', 45.6194381713867, 0.796209399000679, -95.3388900756836, -1.66397753701762, 218, 28, 'PPL', 'P'),
(42574, 'Pine Hill Subdivision', 32.9794387817383, 0.575599792201241, -93.4555587768555, -1.63110720494721, 218, 22, 'PPL', 'P'),
(82974, 'Pine Hill Village', 34.7999992370605, 0.607374566378221, -82.4000015258789, -1.43815133027494, 218, 48, 'PPL', 'P'),
(17607, 'Pine Hills', 28.5575008392334, 0.498422415785667, -81.45361328125, -1.42163373940399, 218, 12, 'PPL', 'P'),
(23912, 'Pine Hills', 33.8388900756836, 0.590600047041112, -83.3419418334961, -1.45459129000011, 218, 13, 'PPL', 'P'),
(50392, 'Pine Hills', 39.5583305358887, 0.69042311444347, -75.8866729736328, -1.32447230177409, 218, 25, 'PPL', 'P'),
(89903, 'Pine Hills', 35.9249992370605, 0.627009520463157, -84.5500030517578, -1.47567593582443, 218, 50, 'PPL', 'P'),
(110902, 'Pine Hills', 37.8088912963867, 0.659889639650575, -81.2191696166992, -1.41754192554714, 218, 58, 'PPL', 'P'),
(193875, 'Pine Hills', 40.7333297729492, 0.710930719838598, -124.151107788086, -2.16684560090047, 218, 6, 'PPL', 'P'),
(151728, 'Pine Hollow', 42.6694412231445, 0.744722239330069, -76.4786071777344, -1.33480350259083, 218, 40, 'PPL', 'P'),
(201403, 'Pine Hollow', 45.2430610656738, 0.789640379276863, -121.293327331543, -2.11696792263465, 218, 43, 'PPL', 'P'),
(42575, 'Pine Hollow Estates', 32.5152816772461, 0.567498722481328, -92.1763916015625, -1.60878152605491, 218, 22, 'PPL', 'P'),
(82975, 'Pine House Crossroads', 33.735279083252, 0.588791694081921, -81.855827331543, -1.42865369887939, 218, 48, 'PPL', 'P'),
(67758, 'Pine Hurst Park', 35.6927795410156, 0.622956522179193, -78.600830078125, -1.37184327966387, 218, 33, 'PPL', 'P'),
(17609, 'Pine Island', 28.5750007629395, 0.498727847073185, -82.6527786254883, -1.44256312293676, 218, 12, 'PPL', 'P'),
(42576, 'Pine Island', 30.3497200012207, 0.529702541079679, -92.7747192382813, -1.61922431332133, 218, 22, 'PPL', 'P'),
(71278, 'Pine Island', 39.420280456543, 0.688013686026248, -75.4255599975586, -1.31642436211792, 218, 37, 'PPL', 'P'),
(82976, 'Pine Island', 33.7363891601563, 0.588811068578851, -78.9261093139648, -1.37752047331765, 218, 48, 'PPL', 'P'),
(97071, 'Pine Island', 30.0577793121338, 0.524607214834571, -96.0372161865234, -1.67616562690443, 218, 51, 'PPL', 'P'),
(125816, 'Pine Island', 42.7758293151855, 0.746579061821099, -70.8277816772461, -1.23617799215166, 218, 23, 'PPL', 'P'),
(137480, 'Pine Island', 44.2013893127441, 0.771459777463219, -92.646110534668, -1.61697966799656, 218, 28, 'PPL', 'P'),
(151729, 'Pine Island', 41.297779083252, 0.720782218763992, -74.459716796875, -1.29956721820799, 218, 40, 'PPL', 'P'),
(17610, 'Pine Island Center', 26.6133308410645, 0.464490248099126, -82.1183319091797, -1.43323526806071, 218, 12, 'PPL', 'P'),
(11208, 'Pine Island Landing', 33.2513885498047, 0.580346211054034, -92.0727767944336, -1.6069731065167, 218, 4, 'PPL', 'P'),
(17611, 'Pine Island Ridge', 26.0944404602051, 0.455433902496203, -80.274169921875, -1.40104856944212, 218, 12, 'PPL', 'P'),
(165946, 'Pine Junction', 40.8388900756836, 0.712773094680715, -76.067497253418, -1.32762828082389, 218, 45, 'PPL', 'P'),
(187199, 'Pine Junction', 39.4661102294922, 0.688813566459654, -105.395278930664, -1.8394946333979, 218, 7, 'PPL', 'P'),
(37689, 'Pine Knob', 37.4833297729492, 0.654207519148782, -86.5119400024414, -1.50991819533039, 218, 21, 'PPL', 'P'),
(175844, 'Pine Knob', 43.4019393920898, 0.757506744142994, -90.8375015258789, -1.58541348591196, 218, 57, 'PPL', 'P'),
(50389, 'Pine Knoll', 39.5611114501953, 0.690471650554337, -76.9749984741211, -1.34346716509102, 218, 25, 'PPL', 'P'),
(67766, 'Pine Knoll', 34.9811096191406, 0.610535538855064, -78.9619369506836, -1.3781457835416, 218, 33, 'PPL', 'P'),
(105264, 'Pine Knoll', 37.6119384765625, 0.656452164473556, -77.2491683959961, -1.34825233293768, 218, 53, 'PPL', 'P'),
(113138, 'Pine Knoll', 46.577220916748, 0.812925861426025, -93.7574996948242, -1.63637706811226, 218, 28, 'PPL', 'P'),
(128541, 'Pine Knoll', 46.1822204589844, 0.806031802891164, -69.0250015258789, -1.2047135428207, 218, 26, 'PPL', 'P'),
(67761, 'Pine Knoll Shores', 34.6972198486328, 0.605580727646971, -76.813606262207, -1.34065033960605, 218, 33, 'PPL', 'P'),
(50390, 'Pine Knoll Terrace', 38.4216690063477, 0.670584628272225, -75.5611114501953, -1.3187901812723, 218, 25, 'PPL', 'P'),
(50391, 'Pine Knolls', 39.0363883972168, 0.681313505618745, -77.1938934326172, -1.3472876028328, 218, 25, 'PPL', 'P'),
(67762, 'Pine Knolls', 36.1947212219238, 0.631717057164036, -80.0661087036133, -1.39741721613774, 218, 33, 'PPL', 'P'),
(11209, 'Pine Knot', 36.0283317565918, 0.628813013153359, -90.5977783203125, -1.58122952668139, 218, 4, 'PPL', 'P'),
(37690, 'Pine Knot', 36.6508293151855, 0.639677645136446, -84.438606262207, -1.47373169507062, 218, 21, 'PPL', 'P'),
(76951, 'Pine Knot Crossing', 34.2486114501953, 0.597751034042138, -95.1419372558594, -1.6605400618406, 218, 42, 'PPL', 'P'),
(82982, 'Pine Knott Forest', 34.8916702270508, 0.608974526982114, -82.3611068725586, -1.43747249051308, 218, 48, 'PPL', 'P'),
(890, 'Pine Lake', 33.9791717529297, 0.593048424189276, -80.8908309936523, -1.41181133551351, 218, 48, 'PPL', 'P'),
(23916, 'Pine Lake', 32.8074989318848, 0.572598875705912, -85.0505599975586, -1.48441230262238, 218, 13, 'PPL', 'P'),
(61329, 'Pine Lake', 32.0125007629395, 0.55872354011049, -89.9688873291016, -1.57025330824863, 218, 30, 'PPL', 'P'),
(125817, 'Pine Lake', 42.3958282470703, 0.739946792021393, -71.4541702270508, -1.24711053474254, 218, 23, 'PPL', 'P'),
(142677, 'Pine Lake', 40.7444381713867, 0.711124597965956, -96.6116714477539, -1.6861917626183, 218, 35, 'PPL', 'P'),
(175845, 'Pine Lake', 46.2561111450195, 0.807321438649035, -90.1405563354492, -1.57324949763302, 218, 57, 'PPL', 'P'),
(208439, 'Pine Lake', 47.5788917541504, 0.830408315559905, -122.044998168945, -2.13008705363855, 218, 56, 'PPL', 'P'),
(14412, 'Pine Lake Development', 38.6652793884277, 0.674836431531563, -75.2888870239258, -1.31403896872954, 218, 10, 'PPL', 'P'),
(23917, 'Pine Lake Estates', 31.0547199249268, 0.542007110974658, -84.8672180175781, -1.48121238141459, 218, 13, 'PPL', 'P'),
(73901, 'Pine Lake Estates', 39.6622200012207, 0.692236327671651, -82.5986099243164, -1.44161770074979, 218, 41, 'PPL', 'P'),
(146041, 'Pine Lake Park', 40.003059387207, 0.698185097177588, -74.2569427490234, -1.29602814343539, 218, 37, 'PPL', 'P'),
(5045, 'Pine Lake Village', 34.3369407653809, 0.599292671418158, -86.539436340332, -1.51039809695883, 218, 2, 'PPL', 'P'),
(17612, 'Pine Lakes', 28.9408302307129, 0.50511277578665, -81.4302825927734, -1.42122654207332, 218, 12, 'PPL', 'P'),
(171068, 'Pine Lakes Addition', 43.5519409179688, 0.760124764652596, -96.6352767944336, -1.68660375363894, 218, 49, 'PPL', 'P'),
(82979, 'Pine Land', 34.211669921875, 0.59710628274223, -80.6738891601563, -1.40802498623369, 218, 48, 'PPL', 'P'),
(184119, 'Pine Land', 39.1366691589355, 0.683063735087145, -120.157501220703, -2.09714401727038, 218, 6, 'PPL', 'P'),
(82980, 'Pine Land Shores', 34.2638893127441, 0.598017683046282, -82.0069427490234, -1.43129116046495, 218, 48, 'PPL', 'P'),
(82981, 'Pine Landing', 32.6027793884277, 0.569025845629407, -80.3874969482422, -1.40302649918372, 218, 48, 'PPL', 'P'),
(146042, 'Pine Lane', 40.0305595397949, 0.698665065385047, -74.6883316040039, -1.30355729931121, 218, 37, 'PPL', 'P'),
(56898, 'Pine Lawn', 38.6958312988281, 0.675369662960825, -90.2750015258789, -1.57559600886949, 218, 29, 'PPL', 'P'),
(5048, 'Pine Level', 32.0677795410156, 0.559688336794399, -86.0597229003906, -1.50202551796578, 218, 2, 'PPL', 'P'),
(17613, 'Pine Level', 27.2649993896484, 0.47586400990361, -81.991943359375, -1.43102937172979, 218, 12, 'PPL', 'P'),
(67765, 'Pine Level', 35.5130615234375, 0.619819851047298, -78.2447204589844, -1.36562799431185, 218, 33, 'PPL', 'P'),
(189234, 'Pine Lodge', 33.6230583190918, 0.586833072258222, -105.244438171387, -1.8368619655023, 218, 38, 'PPL', 'P'),
(205373, 'Pine Lodge', 40.6477813720703, 0.709437618573445, -111.656669616699, -1.94877651662292, 218, 52, 'PPL', 'P'),
(14413, 'Pine Lodge Addition', 38.5938911437988, 0.67359047161557, -75.3111114501953, -1.31442685814231, 218, 10, 'PPL', 'P'),
(17615, 'Pine Log', 29.9333305358887, 0.522435173939016, -84.6244430541992, -1.47697515896222, 218, 12, 'PPL', 'P'),
(23918, 'Pine Log', 34.3427810668945, 0.599394603908881, -84.7322235107422, -1.4788562827982, 218, 13, 'PPL', 'P'),
(67768, 'Pine Log', 34.3236083984375, 0.599059977717912, -78.725830078125, -1.37402494122887, 218, 33, 'PPL', 'P'),
(67769, 'Pine Log Village', 34.9902801513672, 0.610695594836577, -83.9577789306641, -1.46533967500161, 218, 33, 'PPL', 'P'),
(17616, 'Pine Manor', 26.5725002288818, 0.463777619480935, -81.8783264160156, -1.42904638198212, 218, 12, 'PPL', 'P'),
(165947, 'Pine Manor', 40.1808280944824, 0.701287746426557, -76.6616668701172, -1.3379984969506, 218, 45, 'PPL', 'P'),
(14414, 'Pine Manor Estates', 38.5155601501465, 0.672223337869978, -75.1344375610352, -1.31134331707416, 218, 10, 'PPL', 'P'),
(82983, 'Pine Mark', 34.2119407653809, 0.597111009853165, -80.720832824707, -1.40884430774305, 218, 48, 'PPL', 'P'),
(113910, 'Pine Meadow', 41.8763885498047, 0.730880859038545, -72.9674987792969, -1.27352310064367, 218, 8, 'PPL', 'P'),
(121045, 'Pine Meadow Estates', 41.3413887023926, 0.721543350203537, -88.413330078125, -1.54310371251582, 218, 18, 'PPL', 'P'),
(37691, 'Pine Meadows', 38.0433311462402, 0.6639813869284, -84.5327835083008, -1.47537539809541, 218, 21, 'PPL', 'P'),
(151730, 'Pine Meadows', 43.5208282470703, 0.759581746106329, -75.9105606079102, -1.32488921964274, 218, 40, 'PPL', 'P'),
(165948, 'Pine Mill', 41.785831451416, 0.72930033951061, -75.2430572509766, -1.31323908829613, 218, 45, 'PPL', 'P'),
(97072, 'Pine Mills', 32.7413902282715, 0.571445061163635, -95.2891693115234, -1.66310974597642, 218, 51, 'PPL', 'P'),
(117300, 'Pine Mills (historical)', 41.4694404602051, 0.723778274990331, -90.8708267211914, -1.58599512029403, 218, 16, 'PPL', 'P'),
(17617, 'Pine Mount', 30.1627807617188, 0.526439835849195, -82.954719543457, -1.44783298610181, 218, 12, 'PPL', 'P'),
(5053, 'Pine Mountain', 33.8088912963867, 0.590076469570802, -86.5686111450195, -1.51090729335925, 218, 2, 'PPL', 'P'),
(23921, 'Pine Mountain', 34.9402809143066, 0.609822943526386, -83.1872177124023, -1.45189084465477, 218, 13, 'PPL', 'P'),
(37692, 'Pine Mountain', 36.9486083984375, 0.644874870582763, -83.1822204589844, -1.45180362612907, 218, 21, 'PPL', 'P'),
(205371, 'Pine Mountain', 40.6263885498047, 0.709064243388616, -111.805557250977, -1.95137509605656, 218, 52, 'PPL', 'P'),
(11211, 'Pine Mountain (historical)', 35.5230598449707, 0.619994354677725, -92.5908279418945, -1.61601480473362, 218, 4, 'PPL', 'P'),
(89906, 'Pine Mountain (historical)', 36.4700012207031, 0.636521599507621, -84.1344375610352, -1.46842294975365, 218, 50, 'PPL', 'P'),
(184121, 'Pine Mountain Club', 34.8469390869141, 0.608193821308557, -119.155830383301, -2.0796615631365, 218, 6, 'PPL', 'P'),
(67770, 'Pine Mountain Lakes', 35.5833282470703, 0.621046236729279, -81.5941696166992, -1.42408691024212, 218, 33, 'PPL', 'P'),
(23922, 'Pine Mountain Valley', 32.7986106872559, 0.572443746572415, -84.8233337402344, -1.48044645628509, 218, 13, 'PPL', 'P'),
(151732, 'Pine Neck', 40.9983291625977, 0.715555831703739, -72.3424987792969, -1.26261479281871, 218, 40, 'PPL', 'P'),
(23923, 'Pine Needle Hills', 32.4277801513672, 0.565971532754223, -81.804443359375, -1.4277568793823, 218, 13, 'PPL', 'P'),
(187200, 'Pine Nook', 39.3841705322266, 0.687383448954281, -105.070831298828, -1.83383195397206, 218, 7, 'PPL', 'P'),
(105265, 'Pine Oak Heights', 37.297779083252, 0.650969048684219, -80.0386123657227, -1.39693731450931, 218, 53, 'PPL', 'P'),
(23924, 'Pine Oaks', 33.8355598449707, 0.590541923550321, -84.6875, -1.4780757102827, 218, 13, 'PPL', 'P'),
(5050, 'Pine Orchard', 31.6405601501465, 0.552231951795368, -87.1363906860352, -1.52081691577543, 218, 2, 'PPL', 'P'),
(50394, 'Pine Orchard', 39.2775001525879, 0.685521699615234, -76.8613891601563, -1.34148430850141, 218, 25, 'PPL', 'P'),
(89907, 'Pine Orchard', 35.9680595397949, 0.627761064522778, -84.6538925170898, -1.47748914905261, 218, 50, 'PPL', 'P'),
(113911, 'Pine Orchard', 41.2669410705566, 0.720243993907687, -72.7774963378906, -1.27020693245431, 218, 8, 'PPL', 'P'),
(23925, 'Pine Park', 30.851110458374, 0.538453455395084, -84.101936340332, -1.46785569644146, 218, 13, 'PPL', 'P'),
(128542, 'Pine Park', 43.5074996948242, 0.759349118985111, -70.4088897705078, -1.22886694916912, 218, 26, 'PPL', 'P'),
(197253, 'Pine Park', 48.3694381713867, 0.844205953430524, -114.183326721191, -1.99287500216521, 218, 31, 'PPL', 'P'),
(151733, 'Pine Plains', 41.9797210693359, 0.732684351728747, -73.6563873291016, -1.28554647401705, 218, 40, 'PPL', 'P'),
(23926, 'Pine Point', 34.3555603027344, 0.599617643650175, -83.7750015258789, -1.46214960748986, 218, 13, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(82985, 'Pine Point', 34.0111083984375, 0.59360582380543, -81.3536071777344, -1.41988830362556, 218, 48, 'PPL', 'P'),
(125818, 'Pine Point', 42.1208305358887, 0.735147176525825, -72.529167175293, -1.26587277093826, 218, 23, 'PPL', 'P'),
(128543, 'Pine Point', 43.5411109924316, 0.759935746794228, -70.3447189331055, -1.22774695677268, 218, 26, 'PPL', 'P'),
(137487, 'Pine Point', 46.9777793884277, 0.819916925603592, -95.3833312988281, -1.66475318268511, 218, 28, 'PPL', 'P'),
(128544, 'Pine Point Beach', 43.5424995422363, 0.759959981560148, -70.3333282470703, -1.22754815179731, 218, 26, 'PPL', 'P'),
(89908, 'Pine Point Subdivision', 36.4111099243164, 0.635493752484905, -88.1005630493164, -1.53764489807143, 218, 50, 'PPL', 'P'),
(11213, 'Pine Prairie', 33.6069412231445, 0.586551775868082, -94.1500015258789, -1.64322751738427, 218, 4, 'PPL', 'P'),
(42580, 'Pine Prairie', 30.7836093902588, 0.53727533950786, -92.4252777099609, -1.61312540810894, 218, 22, 'PPL', 'P'),
(97073, 'Pine Prairie', 30.7861099243164, 0.537318982060224, -95.5597229003906, -1.66783179690524, 218, 51, 'PPL', 'P'),
(197254, 'Pine Prairie', 48.0288887023926, 0.838262243930657, -114.704437255859, -2.001970096762, 218, 31, 'PPL', 'P'),
(125819, 'Pine Rest', 42.3888893127441, 0.739825684770822, -71.4375, -1.24681958439345, 218, 23, 'PPL', 'P'),
(592, 'Pine Ridge', 32.1202812194824, 0.560604663946468, -92.8958282470703, -1.62133806427853, 218, 22, 'PPL', 'P'),
(5054, 'Pine Ridge', 34.4394416809082, 0.601081649880418, -85.7844390869141, -1.49722090904317, 218, 2, 'PPL', 'P'),
(11214, 'Pine Ridge', 34.5858306884766, 0.603636620051213, -93.9100036621094, -1.63903876446374, 218, 4, 'PPL', 'P'),
(17619, 'Pine Ridge', 26.2302799224854, 0.457804748367132, -81.7961120605469, -1.42761147078679, 218, 12, 'PPL', 'P'),
(23928, 'Pine Ridge', 33.0227813720703, 0.576356263108878, -83.4891662597656, -1.45716084097787, 218, 13, 'PPL', 'P'),
(30839, 'Pine Ridge', 39.5791702270508, 0.690786835669348, -87.4916687011719, -1.52701768689952, 218, 19, 'PPL', 'P'),
(37693, 'Pine Ridge', 37.7638893127441, 0.659104206866084, -83.6138916015625, -1.4593377088529, 218, 21, 'PPL', 'P'),
(50393, 'Pine Ridge', 39.415828704834, 0.687935988301445, -76.5244369506836, -1.33560338302424, 218, 25, 'PPL', 'P'),
(56899, 'Pine Ridge', 36.8372192382813, 0.642930762987005, -93.1130599975586, -1.62512947356442, 218, 29, 'PPL', 'P'),
(61334, 'Pine Ridge', 31.2030601501465, 0.544596136317892, -89.4452819824219, -1.56111467096802, 218, 30, 'PPL', 'P'),
(67773, 'Pine Ridge', 36.4988899230957, 0.637025802481, -80.7174987792969, -1.40878611767323, 218, 33, 'PPL', 'P'),
(76952, 'Pine Ridge', 35.0149993896484, 0.61112702693317, -98.4441680908203, -1.71817486257155, 218, 42, 'PPL', 'P'),
(78949, 'Pine Ridge', 39.9194412231445, 0.696725684900224, -75.3724975585938, -1.31549824784885, 218, 45, 'PPL', 'P'),
(82986, 'Pine Ridge', 34.3950004577637, 0.600306004212933, -80.1630630493164, -1.39910938869438, 218, 48, 'PPL', 'P'),
(89909, 'Pine Ridge', 35.1369400024414, 0.613255292118307, -84.3116683959961, -1.47151621135978, 218, 50, 'PPL', 'P'),
(97074, 'Pine Ridge', 30.2027797698975, 0.527137950239446, -94.3502807617188, -1.64672304947306, 218, 51, 'PPL', 'P'),
(105266, 'Pine Ridge', 38.8608283996582, 0.678249405626554, -77.2422180175781, -1.34813102595003, 218, 53, 'PPL', 'P'),
(132624, 'Pine Ridge', 42.0347213745117, 0.733644288143666, -85.6355590820313, -1.49462246276758, 218, 27, 'PPL', 'P'),
(195468, 'Pine Ridge', 44.9388885498047, 0.784331567380872, -116.38166809082, -2.03124329714804, 218, 17, 'PPL', 'P'),
(199616, 'Pine Ridge', 42.4944381713867, 0.741667859875857, -103.471672058105, -1.80592135995776, 218, 35, 'PPL', 'P'),
(202488, 'Pine Ridge', 43.0255584716797, 0.75093765784015, -102.55583190918, -1.78993693393705, 218, 49, 'PPL', 'P'),
(71280, 'Pine Ridge at Crestwood', 39.9544410705566, 0.697336547475261, -74.315559387207, -1.29705119676814, 218, 37, 'PPL', 'P'),
(23930, 'Pine Ridge Country Club Estates', 34.0175018310547, 0.593717410255104, -84.008056640625, -1.46621718658079, 218, 13, 'PPL', 'P'),
(137489, 'Pine Ridge Court', 45.3972206115723, 0.79233097092617, -93.8694381713867, -1.63833076308794, 218, 28, 'PPL', 'P'),
(5055, 'Pine Ridge Estates', 31.226390838623, 0.545003333648565, -85.4499969482422, -1.49138379256593, 218, 2, 'PPL', 'P'),
(23931, 'Pine Ridge Estates', 33.6130599975586, 0.586658568627795, -85.0780563354492, -1.48489220425081, 218, 13, 'PPL', 'P'),
(117301, 'Pine Ridge Mobile Home Court', 42.4700012207031, 0.74124135462728, -91.9180603027344, -1.60427279432941, 218, 16, 'PPL', 'P'),
(23932, 'Pine Ridge Point', 34.0244407653809, 0.593838517505676, -83.9980621337891, -1.46604274952939, 218, 13, 'PPL', 'P'),
(137490, 'Pine Ridge Trailer Court', 46.3549995422363, 0.809047366772488, -94.793327331543, -1.65445567085616, 218, 28, 'PPL', 'P'),
(132625, 'Pine River', 43.9833297729492, 0.767653920528414, -83.8886108398438, -1.46413246407948, 218, 27, 'PPL', 'P'),
(137491, 'Pine River', 46.7180595397949, 0.815383959112168, -94.4038925170898, -1.64765875112206, 218, 28, 'PPL', 'P'),
(144319, 'Pine River', 43.7319412231445, 0.763266362632508, -71.0741729736328, -1.24047833152186, 218, 36, 'PPL', 'P'),
(175848, 'Pine River', 44.1522216796875, 0.770601640380968, -89.0769424438477, -1.55468593325463, 218, 57, 'PPL', 'P'),
(113912, 'Pine Rock Park', 41.2616691589355, 0.720151981692025, -73.095832824707, -1.27576295227848, 218, 8, 'PPL', 'P'),
(132627, 'Pine Run', 43.1777801513672, 0.753594427343613, -83.7141723632813, -1.4610879383213, 218, 27, 'PPL', 'P'),
(165949, 'Pine Run', 41.2377815246582, 0.719735063823373, -77.1777801513672, -1.34700637302169, 218, 45, 'PPL', 'P'),
(89911, 'Pine Spring', 35.9786109924316, 0.627945222112157, -82.8708267211914, -1.44636878013449, 218, 50, 'PPL', 'P'),
(105268, 'Pine Spring', 38.8672218322754, 0.678360992076229, -77.2061080932617, -1.34750078887806, 218, 53, 'PPL', 'P'),
(5059, 'Pine Springs', 33.9427795410156, 0.592413260269292, -88.1522216796875, -1.53854651125847, 218, 2, 'PPL', 'P'),
(37694, 'Pine Springs', 37.3519401550293, 0.651914337713142, -86.0947189331055, -1.50263631396179, 218, 21, 'PPL', 'P'),
(61335, 'Pine Springs', 32.4672203063965, 0.566659893316981, -88.7713928222656, -1.5493530863298, 218, 30, 'PPL', 'P'),
(89912, 'Pine Springs', 35.8761100769043, 0.626156243649896, -84.0774993896484, -1.46742919119289, 218, 50, 'PPL', 'P'),
(137494, 'Pine Springs', 45.035831451416, 0.786023540200426, -92.9541702270508, -1.62235632392132, 218, 28, 'PPL', 'P'),
(178869, 'Pine Springs', 35.4052810668945, 0.61793872721132, -109.279441833496, -1.90728606473614, 218, 5, 'PPL', 'P'),
(189235, 'Pine Springs', 34.9655609130859, 0.610264162739984, -106.233062744141, -1.85411671936298, 218, 38, 'PPL', 'P'),
(192048, 'Pine Springs', 31.8924999237061, 0.556629130360711, -104.815002441406, -1.82936689808843, 218, 51, 'PPL', 'P'),
(50395, 'Pine Springs Mobile Home Park', 39.2355613708496, 0.684789729789626, -75.9255599975586, -1.3251510083779, 218, 25, 'PPL', 'P'),
(123437, 'Pine Station', 41.5280609130859, 0.724801394902112, -86.3255615234375, -1.50666527721692, 218, 19, 'PPL', 'P'),
(132628, 'Pine Stump Junction', 46.5691719055176, 0.812785379678523, -85.5913925170898, -1.49385161079005, 218, 27, 'PPL', 'P'),
(165950, 'Pine Summit', 41.1777801513672, 0.718687842303726, -76.5647201538086, -1.33630645755202, 218, 45, 'PPL', 'P'),
(67776, 'Pine Swamp', 36.459171295166, 0.636332581649252, -81.10888671875, -1.41561712586929, 218, 33, 'PPL', 'P'),
(165951, 'Pine Swamp', 40.1836090087891, 0.701336282537424, -75.7858276367188, -1.32271221860966, 218, 45, 'PPL', 'P'),
(14415, 'Pine Swamp Corner', 39.6752815246582, 0.692464294260961, -75.6802825927734, -1.32087011008365, 218, 10, 'PPL', 'P'),
(178870, 'Pine Tank', 35.2419395446777, 0.615087879843418, -112.065277099609, -1.95590806254799, 218, 5, 'PPL', 'P'),
(71281, 'Pine Tavern', 39.6616706848145, 0.692226740291726, -75.2102813720703, -1.31266704129399, 218, 37, 'PPL', 'P'),
(151735, 'Pine Tavern', 42.7536087036133, 0.746191238987356, -77.9288864135742, -1.36011565032955, 218, 40, 'PPL', 'P'),
(42579, 'Pine Terrace', 32.5247192382813, 0.56766343899475, -92.1936111450195, -1.60908206378393, 218, 22, 'PPL', 'P'),
(146043, 'Pine Terrace', 40.0080604553223, 0.698272382282315, -74.1208267211914, -1.29365247058498, 218, 37, 'PPL', 'P'),
(137496, 'Pine Terrace Mobile Home Park', 45.8161087036133, 0.799641947329683, -92.966667175293, -1.6225744368146, 218, 28, 'PPL', 'P'),
(11216, 'Pine Top', 36.3244400024414, 0.63398107698574, -93.8777770996094, -1.63847630484152, 218, 4, 'PPL', 'P'),
(17620, 'Pine Top', 30.2727794647217, 0.52835967538952, -82.1813888549805, -1.43433581938118, 218, 12, 'PPL', 'P'),
(37695, 'Pine Top', 37.2724990844727, 0.65052782947062, -82.8824996948242, -1.44657251195788, 218, 21, 'PPL', 'P'),
(76953, 'Pine Top', 34.6772193908691, 0.605231653807089, -95.7416687011719, -1.67100735018905, 218, 42, 'PPL', 'P'),
(89913, 'Pine Top', 35.3030586242676, 0.616154609018049, -88.8008270263672, -1.54986681010407, 218, 50, 'PPL', 'P'),
(165952, 'Pine Top', 40.9925003051758, 0.715454098950098, -78.3308334350586, -1.36713094927303, 218, 45, 'PPL', 'P'),
(23933, 'Pine Top Hill', 33.6355590820313, 0.587051251730527, -83.8377838134766, -1.46324536512037, 218, 13, 'PPL', 'P'),
(193876, 'Pine Town', 40.3041687011719, 0.703440446114696, -120.989723205566, -2.11166903101372, 218, 6, 'PPL', 'P'),
(97076, 'Pine Trail Estates', 32.1908302307129, 0.561835976476466, -95.4533309936523, -1.66597490783518, 218, 51, 'PPL', 'P'),
(50415, 'Pine Trailer Park', 38.5122184753418, 0.672165014642105, -76.5680618286133, -1.33636478077989, 218, 25, 'PPL', 'P'),
(67778, 'Pine Tree', 35.7402801513672, 0.623785564226535, -77.7955627441406, -1.35778871332709, 218, 33, 'PPL', 'P'),
(105270, 'Pine Tree', 37.6522216796875, 0.657155239001337, -76.6091690063477, -1.33708223637756, 218, 53, 'PPL', 'P'),
(205372, 'Pine Tree', 40.6369400024414, 0.709248400977995, -111.619171142578, -1.94812204478503, 218, 52, 'PPL', 'P'),
(82988, 'Pine Tree (historical)', 34.8527793884277, 0.60829575379928, -81.5055618286133, -1.42254041259711, 218, 48, 'PPL', 'P'),
(125820, 'Pine Tree Corner', 41.6186103820801, 0.726381781271993, -70.4872207641602, -1.23023408291471, 218, 23, 'PPL', 'P'),
(14416, 'Pine Tree Corners', 39.4072189331055, 0.687785719436937, -75.6616668701172, -1.32054520443066, 218, 10, 'PPL', 'P'),
(125821, 'Pine Tree Village', 41.8263893127441, 0.730008207728354, -70.7375030517578, -1.23460233289271, 218, 23, 'PPL', 'P'),
(5060, 'Pine Tuckey', 33.4724998474121, 0.584205331210641, -85.5391693115234, -1.49294014390698, 218, 2, 'PPL', 'P'),
(23934, 'Pine Valley', 31.2011108398438, 0.544562114434967, -82.5186080932617, -1.44022140539026, 218, 13, 'PPL', 'P'),
(30840, 'Pine Valley', 38.476390838623, 0.671539704418154, -86.4502792358398, -1.50884201193389, 218, 19, 'PPL', 'P'),
(50396, 'Pine Valley', 39.1366691589355, 0.683063735087145, -76.8861083984375, -1.341915740598, 218, 25, 'PPL', 'P'),
(61336, 'Pine Valley', 34.0683288574219, 0.594604509214209, -89.5202789306641, -1.5624236146438, 218, 30, 'PPL', 'P'),
(71282, 'Pine Valley', 39.7855606079102, 0.694389027359789, -74.9755630493164, -1.30857043374717, 218, 37, 'PPL', 'P'),
(82990, 'Pine Valley', 34.0486106872559, 0.594260362222344, -81.0841674804688, -1.41518569377269, 218, 48, 'PPL', 'P'),
(97078, 'Pine Valley', 30.6602802276611, 0.535122839556803, -95.4522171020508, -1.66595546675923, 218, 51, 'PPL', 'P'),
(151741, 'Pine Valley', 40.8958282470703, 0.713766853241478, -72.6666717529297, -1.26827267855458, 218, 40, 'PPL', 'P'),
(157144, 'Pine Valley', 40.2041702270508, 0.701695143494312, -80.7675018310547, -1.40965883556245, 218, 41, 'PPL', 'P'),
(165953, 'Pine Valley', 41.9674987792969, 0.732471032525432, -79.5188903808594, -1.38786645467844, 218, 45, 'PPL', 'P'),
(184122, 'Pine Valley', 32.8213882446289, 0.572841289944137, -116.528327941895, -2.03380299442977, 218, 6, 'PPL', 'P'),
(192747, 'Pine Valley', 37.3911094665527, 0.652597971164966, -113.513328552246, -1.98118132813478, 218, 52, 'PPL', 'P'),
(194373, 'Pine Valley', 40.1916694641113, 0.701476964022008, -105.482498168945, -1.84101689627699, 218, 7, 'PPL', 'P'),
(23936, 'Pine Valley Estates', 33.8388900756836, 0.590600047041112, -84.7486114501953, -1.47914230629927, 218, 13, 'PPL', 'P'),
(82992, 'Pine Valley Estates', 33.7966690063477, 0.589863150367487, -79.0250015258789, -1.37924646802013, 218, 48, 'PPL', 'P'),
(14417, 'Pine Valley Farms', 39.5213890075684, 0.689778363143562, -75.629997253418, -1.31999246534641, 218, 10, 'PPL', 'P'),
(23937, 'Pine Valley Farms', 34.014720916748, 0.593668874144237, -84.5147171020508, -1.47506007982235, 218, 13, 'PPL', 'P'),
(14418, 'Pine Valley Mobile Home Park', 38.7249984741211, 0.675878726203193, -75.1305618286133, -1.31127567278247, 218, 10, 'PPL', 'P'),
(23938, 'Pine Valley Mobile Home Park', 33.5244407653809, 0.585111871245704, -83.8505630493164, -1.46346840486167, 218, 13, 'PPL', 'P'),
(89914, 'Pine View', 35.7305603027344, 0.623615920865097, -87.934440612793, -1.53474551459266, 218, 50, 'PPL', 'P'),
(105271, 'Pine View', 38.4477806091309, 0.671040361713764, -77.6947174072266, -1.35602863016266, 218, 53, 'PPL', 'P'),
(121048, 'Pine View', 41.8822212219238, 0.730982658371213, -88.5513916015625, -1.54551334067012, 218, 18, 'PPL', 'P'),
(165954, 'Pine View', 41.1355590820313, 0.717950945630102, -75.9483337402344, -1.32554848517059, 218, 45, 'PPL', 'P'),
(50397, 'Pine View Estates', 38.579719543457, 0.673343130529329, -76.5250015258789, -1.33561323672027, 218, 25, 'PPL', 'P'),
(105272, 'Pine View Mobile Home Park', 36.730281829834, 0.641064353116051, -77.5358276367188, -1.35325548051956, 218, 53, 'PPL', 'P'),
(205374, 'Pine View Park', 41.2686080932617, 0.720273088942596, -111.794441223145, -1.95118108477115, 218, 52, 'PPL', 'P'),
(205375, 'Pine View West', 41.2700004577637, 0.720297390287543, -111.822776794434, -1.95167563378558, 218, 52, 'PPL', 'P'),
(82994, 'Pine Village', 34.4236106872559, 0.600805346917323, -80.3611068725586, -1.40256590547319, 218, 48, 'PPL', 'P'),
(123438, 'Pine Village', 40.4502792358398, 0.705990556016501, -87.2544403076172, -1.52287727035277, 218, 19, 'PPL', 'P'),
(137497, 'Pine Village Mobile Home Park', 45.5527801513672, 0.795045997078478, -93.2347183227539, -1.62725281190154, 218, 28, 'PPL', 'P'),
(14419, 'Pine Water Farm', 38.6611099243164, 0.674763660654777, -75.1788864135742, -1.3121190958997, 218, 10, 'PPL', 'P'),
(14420, 'Pine Water Landing', 38.6563911437988, 0.674681302398066, -75.1716690063477, -1.31199312838014, 218, 10, 'PPL', 'P'),
(165955, 'Pine Waters', 40.4205589294434, 0.705471838815181, -75.7074966430664, -1.32134508486406, 218, 45, 'PPL', 'P'),
(50398, 'Pine Whiff Beach', 38.940559387207, 0.679640973875148, -76.5516662597656, -1.33607862412076, 218, 25, 'PPL', 'P'),
(184123, 'Pine Wood', 33.8141708374023, 0.590168614944519, -116.736671447754, -2.03743927458216, 218, 6, 'PPL', 'P'),
(132629, 'Pine Wood Park', 44.1611099243164, 0.770756769514465, -83.5680618286133, -1.4585378284195, 218, 27, 'PPL', 'P'),
(151737, 'Pine Woods', 42.8869400024414, 0.748518309147868, -75.5794372558594, -1.31911002691921, 218, 40, 'PPL', 'P'),
(5062, 'Pinebelt', 32.1697196960449, 0.561467528139653, -87.1786117553711, -1.52155381244906, 218, 2, 'PPL', 'P'),
(11218, 'Pinebergen', 34.1027793884277, 0.595205784409322, -91.9922180175781, -1.60556709061919, 218, 4, 'PPL', 'P'),
(67781, 'Pinebluff', 35.1097183227539, 0.612780184179837, -79.4725036621094, -1.38705685370706, 218, 33, 'PPL', 'P'),
(23939, 'Pineboro', 31.1777801513672, 0.544154917104294, -83.6727828979492, -1.46036555587562, 218, 13, 'PPL', 'P'),
(82997, 'Pinebrook', 34.8919410705566, 0.608979254093048, -82.0527801513672, -1.43209117405641, 218, 48, 'PPL', 'P'),
(151738, 'Pinebrook', 40.9627799987793, 0.714935381748778, -73.7766723632813, -1.28764584390436, 218, 40, 'PPL', 'P'),
(184124, 'Pinebrook', 38.2419395446777, 0.667447757403248, -120.329719543457, -2.10014979403469, 218, 6, 'PPL', 'P'),
(89915, 'Pinebrook Estates', 35.1669387817383, 0.613778869588616, -85.0883331298828, -1.48507156815023, 218, 50, 'PPL', 'P'),
(23940, 'Pinebrook Heights', 33.5936088562012, 0.586319082167837, -84.2936096191406, -1.47120102624477, 218, 13, 'PPL', 'P'),
(151739, 'Pinebrook Heights', 40.9530601501465, 0.714765738387339, -73.7772216796875, -1.28765543128429, 218, 40, 'PPL', 'P'),
(23941, 'Pinebrook Mobile Home Park', 33.7541694641113, 0.589121393424873, -84.7172164916992, -1.47859436090499, 218, 13, 'PPL', 'P'),
(61337, 'Pinebur', 31.1358299255371, 0.543422747541603, -89.7019424438477, -1.56559424107959, 218, 30, 'PPL', 'P'),
(67782, 'Pineburr', 35.855281829834, 0.6257927221611, -81.6041717529297, -1.42426148045158, 218, 33, 'PPL', 'P'),
(208440, 'Pinecliff', 46.8994407653809, 0.818549658699945, -121.011940002441, -2.11205678726844, 218, 56, 'PPL', 'P'),
(187201, 'Pinecliffe', 39.9319381713867, 0.696943797793502, -105.427780151367, -1.84006188671008, 218, 7, 'PPL', 'P'),
(17621, 'Pinecraft', 27.3247203826904, 0.476906337864753, -82.4913864135742, -1.43974629745179, 218, 12, 'PPL', 'P'),
(137498, 'Pinecreek', 48.978328704834, 0.854833098023403, -95.942497253418, -1.67451246965776, 218, 28, 'PPL', 'P'),
(165964, 'Pinecreek', 41.1591682434082, 0.718363003229764, -79.0588912963867, -1.37983795609824, 218, 45, 'PPL', 'P'),
(14421, 'Pinecrest', 39.7147216796875, 0.69315265482372, -75.6708297729492, -1.32070512725412, 218, 10, 'PPL', 'P'),
(17625, 'Pinecrest', 28.7744407653809, 0.502208731775973, -81.2702789306641, -1.41843395135426, 218, 12, 'PPL', 'P'),
(23942, 'Pinecrest', 33.5908317565918, 0.586270612635997, -84.1941680908203, -1.46946544416236, 218, 13, 'PPL', 'P'),
(67783, 'Pinecrest', 35.8197212219238, 0.625172072469057, -80.2930603027344, -1.40137826878507, 218, 33, 'PPL', 'P'),
(83001, 'Pinecrest', 34.9708290100098, 0.610356108376619, -82.1791687011719, -1.43429707038732, 218, 48, 'PPL', 'P'),
(89916, 'Pinecrest', 36.1561088562012, 0.631043144250191, -82.8050003051758, -1.44521989244023, 218, 50, 'PPL', 'P'),
(105274, 'Pinecrest', 38.827220916748, 0.677662844396465, -77.1569366455078, -1.34664258521678, 218, 53, 'PPL', 'P'),
(125822, 'Pinecrest', 42.2533302307129, 0.737459732458395, -71.7527770996094, -1.25232220783777, 218, 23, 'PPL', 'P'),
(184126, 'Pinecrest', 38.1886100769043, 0.666516982602265, -119.989723205566, -2.09421573849378, 218, 6, 'PPL', 'P'),
(205376, 'Pinecrest', 40.8127784729004, 0.712317361239175, -111.724166870117, -1.94995456593111, 218, 52, 'PPL', 'P'),
(172399, 'Pinecrest Acres', 43.6536102294922, 0.761899228886916, -72.9563903808594, -1.27332922251632, 218, 55, 'PPL', 'P'),
(110906, 'Pinecrest Addition', 39.0730590820313, 0.681953529807719, -80.4658279418945, -1.40439363292931, 218, 58, 'PPL', 'P'),
(23943, 'Pinecrest Estates', 33.7874984741211, 0.589703094385973, -84.7388916015625, -1.47897266293784, 218, 13, 'PPL', 'P'),
(73903, 'Pinecrest Estates', 39.9819412231445, 0.697816515682721, -82.5247192382813, -1.44032806499191, 218, 41, 'PPL', 'P'),
(23944, 'Pinecrest Forest', 33.5736083984375, 0.585970008327955, -84.3247222900391, -1.47174404479103, 218, 13, 'PPL', 'P'),
(23945, 'Pinecrest Heights', 34.3261108398438, 0.599103653559789, -83.8897171020508, -1.46415177199738, 218, 13, 'PPL', 'P'),
(23946, 'Pinecrest Hills', 33.6463890075684, 0.587240269588895, -84.3547210693359, -1.47226762226134, 218, 13, 'PPL', 'P'),
(67787, 'Pinecroft', 36.0283317565918, 0.628813013153359, -79.8391723632813, -1.39345642980652, 218, 33, 'PPL', 'P'),
(165965, 'Pinecroft', 40.5686111450195, 0.708055837441858, -78.3502807617188, -1.36747036915396, 218, 45, 'PPL', 'P'),
(184127, 'Pinecroft', 39.0763893127441, 0.682011653298509, -120.976936340332, -2.11144585811437, 218, 6, 'PPL', 'P'),
(17626, 'Pineda', 28.2369403839111, 0.492827580388601, -80.6786117553711, -1.40810741106943, 218, 12, 'PPL', 'P'),
(5064, 'Pinedale', 32.2949981689453, 0.563654049973636, -86.2386093139648, -1.50514767486973, 218, 2, 'PPL', 'P'),
(50399, 'Pinedale', 39.4083290100098, 0.687805093933868, -76.4736099243164, -1.33471628406513, 218, 25, 'PPL', 'P'),
(61340, 'Pinedale', 34.4049987792969, 0.60048050784336, -89.192497253418, -1.55670274514814, 218, 30, 'PPL', 'P'),
(89917, 'Pinedale', 35.9236106872559, 0.626985285697238, -85.1875, -1.48680235654267, 218, 50, 'PPL', 'P'),
(125823, 'Pinedale', 42.6124992370605, 0.743728414190278, -72.2375030517578, -1.26078227167263, 218, 23, 'PPL', 'P'),
(178871, 'Pinedale', 34.3074989318848, 0.598778814485827, -110.250831604004, -1.92424001455169, 218, 5, 'PPL', 'P'),
(184128, 'Pinedale', 36.8427810668945, 0.643027835208739, -119.788887023926, -2.09071048586702, 218, 6, 'PPL', 'P'),
(192946, 'Pinedale', 35.603889465332, 0.621405097686167, -108.446388244629, -1.89274653676485, 218, 38, 'PPL', 'P'),
(209669, 'Pinedale', 42.8666687011719, 0.74816450819705, -109.860282897949, -1.91742365374163, 218, 59, 'PPL', 'P'),
(5067, 'Pinedale Acres', 34.7936096191406, 0.607263046507574, -86.9930572509766, -1.51831527540547, 218, 2, 'PPL', 'P'),
(83004, 'Pinedale Acres', 34.9033317565918, 0.609178059068423, -81.9236068725586, -1.4298366750356, 218, 48, 'PPL', 'P'),
(5069, 'Pinedale Shores', 33.8383293151855, 0.590590259924106, -86.3141708374023, -1.50646647224154, 218, 2, 'PPL', 'P'),
(67788, 'Pinedell', 35.0149993896484, 0.61112702693317, -80.5947189331055, -1.4066432051021, 218, 33, 'PPL', 'P'),
(50400, 'Pinefield', 38.6497192382813, 0.674564855679403, -76.8580627441406, -1.34142625158964, 218, 25, 'PPL', 'P'),
(125824, 'Pinefield', 42.6888885498047, 0.745061659210999, -70.9027786254883, -1.23748693582743, 218, 23, 'PPL', 'P'),
(23948, 'Pinefield Crossroads', 34.4213905334473, 0.600766597923462, -83.4408264160156, -1.45631715154453, 218, 13, 'PPL', 'P'),
(23949, 'Pinegate', 33.4136085510254, 0.583177484187925, -84.591667175293, -1.47640311196007, 218, 13, 'PPL', 'P'),
(83006, 'Pineglen', 34.0394401550293, 0.59410030624083, -81.147216796875, -1.41628611193512, 218, 48, 'PPL', 'P'),
(73904, 'Pinegrove', 39.163890838623, 0.683538843025615, -81.8261108398438, -1.4281350482571, 218, 41, 'PPL', 'P'),
(197255, 'Pinegrove', 46.8802795410156, 0.818215232246059, -113.902221679688, -1.98796879364701, 218, 31, 'PPL', 'P'),
(42584, 'Pinegrove (historical)', 31.1944408416748, 0.544445701005816, -92.2361068725586, -1.60982375414752, 218, 22, 'PPL', 'P'),
(205377, 'Pinegrove Estates', 40.5991706848145, 0.708589202029173, -111.796112060547, -1.95121024638509, 218, 52, 'PPL', 'P'),
(197256, 'Pinegrove Trailer Park', 46.8816719055176, 0.818239533591006, -113.894439697266, -1.98783297243142, 218, 31, 'PPL', 'P'),
(189236, 'Pinehaven', 35.3327789306641, 0.616673326219369, -108.669723510742, -1.89664447249434, 218, 38, 'PPL', 'P'),
(83007, 'Pinehaven Acres', 34.9230613708496, 0.60952240579737, -82.3455581665039, -1.437201114398, 218, 48, 'PPL', 'P'),
(23950, 'Pinehaven Estates', 33.0444412231445, 0.576734298825614, -85.0863876342773, -1.48503761284633, 218, 13, 'PPL', 'P'),
(61343, 'Pinehaven Estates', 32.3763885498047, 0.565074580099084, -90.3194427490234, -1.57637165453698, 218, 30, 'PPL', 'P'),
(83008, 'Pinehill', 33.0411109924316, 0.576676175334823, -80.2316665649414, -1.40030674592048, 218, 48, 'PPL', 'P'),
(97079, 'Pinehill', 32.1044387817383, 0.56032816124629, -94.6050033569336, -1.65116879743878, 218, 51, 'PPL', 'P'),
(189237, 'Pinehill', 34.9991683959961, 0.610850723970074, -108.41056060791, -1.8921212265409, 218, 38, 'PPL', 'P'),
(23954, 'Pinehurst', 33.5441703796387, 0.585456217974651, -84.2108306884766, -1.4697562613534, 218, 13, 'PPL', 'P'),
(37696, 'Pinehurst', 38.0722198486328, 0.66448558990178, -84.4572219848633, -1.4740566007236, 218, 21, 'PPL', 'P'),
(50405, 'Pinehurst', 38.3838882446289, 0.669925229586321, -75.1508331298828, -1.31162947373329, 218, 25, 'PPL', 'P'),
(67791, 'Pinehurst', 35.1952781677246, 0.614273485182071, -79.4697189331055, -1.38700825101717, 218, 33, 'PPL', 'P'),
(71284, 'Pinehurst', 39.478328704834, 0.689026819083942, -74.5500030517578, -1.30114301062499, 218, 37, 'PPL', 'P'),
(73905, 'Pinehurst', 39.4072189331055, 0.687785719436937, -81.498893737793, -1.42242403245748, 218, 41, 'PPL', 'P'),
(83010, 'Pinehurst', 33.9533309936523, 0.592597417858671, -80.3388900756836, -1.40217814921848, 218, 48, 'PPL', 'P'),
(97081, 'Pinehurst', 30.1069393157959, 0.525465218758767, -93.7744369506836, -1.63667267899326, 218, 51, 'PPL', 'P'),
(105275, 'Pinehurst', 36.8455581665039, 0.643076304740578, -76.3730621337891, -1.33296139406483, 218, 53, 'PPL', 'P'),
(125825, 'Pinehurst', 42.5291709899902, 0.742274061918986, -71.2286071777344, -1.24317371686113, 218, 23, 'PPL', 'P'),
(165967, 'Pinehurst', 40.603889465332, 0.708671560285884, -80.1847229003906, -1.39948742441111, 218, 45, 'PPL', 'P'),
(175851, 'Pinehurst', 44.8583297729492, 0.782925551483364, -91.4625015258789, -1.59632179373692, 218, 57, 'PPL', 'P'),
(177383, 'Pinehurst', 42.7322196960449, 0.745817930381554, -78.9352798461914, -1.37768052929916, 218, 40, 'PPL', 'P'),
(184129, 'Pinehurst', 36.6952781677246, 0.640453423961986, -119.015556335449, -2.07721331914639, 218, 6, 'PPL', 'P'),
(195470, 'Pinehurst', 47.538890838623, 0.829710167880141, -116.236389160156, -2.02870770147417, 218, 17, 'PPL', 'P'),
(201404, 'Pinehurst', 42.1177787780762, 0.735093913304023, -122.36499786377, -2.13567210191861, 218, 43, 'PPL', 'P'),
(208441, 'Pinehurst', 47.9361114501953, 0.836642975408862, -122.204437255859, -2.13286979066157, 218, 56, 'PPL', 'P'),
(67792, 'Pinehurst Acres', 35.3147201538086, 0.616358141104358, -81.5305633544922, -1.42297677154172, 218, 33, 'PPL', 'P'),
(125826, 'Pinehurst Beach', 41.7466697692871, 0.728616839216842, -70.7102813720703, -1.23412722495424, 218, 23, 'PPL', 'P'),
(13187, 'Pinehurst Circle', 38.9708290100098, 0.680169278456393, -77.0805587768555, -1.34530953993314, 218, 9, 'PPL', 'P'),
(50406, 'Pinehurst Harbour', 39.1300010681152, 0.682947354947509, -76.4352798461914, -1.33404729799931, 218, 25, 'PPL', 'P'),
(121049, 'Pinehurst Manor', 42.1436080932617, 0.735544719897546, -88.021110534668, -1.53625819009182, 218, 18, 'PPL', 'P'),
(125827, 'Pinehurst Mobile Home Village', 41.9263916015625, 0.731753576927764, -70.7219390869141, -1.23433069046152, 218, 23, 'PPL', 'P'),
(50407, 'Pinehurst on the Bodkin', 39.1208305358887, 0.682787298965995, -76.4433288574219, -1.33418777974681, 218, 25, 'PPL', 'P'),
(151740, 'Pinehurst Resort', 44.3036117553711, 0.77324389565649, -75.9644393920898, -1.32582958182365, 218, 40, 'PPL', 'P'),
(23957, 'Pinehurst Trace', 33.8783302307129, 0.59128840760387, -83.9886093139648, -1.46587776669986, 218, 13, 'PPL', 'P'),
(17627, 'Pinehurst Village', 26.2436103820801, 0.458037408777864, -80.0947189331055, -1.39791655884213, 218, 12, 'PPL', 'P'),
(110907, 'Pineknob', 37.8430595397949, 0.660485987997671, -81.4816665649414, -1.42212336157041, 218, 58, 'PPL', 'P'),
(17628, 'Pineland', 26.6602802276611, 0.46530966947703, -82.1536102294922, -1.43385099090473, 218, 12, 'PPL', 'P'),
(23958, 'Pineland', 30.7130603790283, 0.536044026977862, -82.7655563354492, -1.44453146529844, 218, 13, 'PPL', 'P'),
(83014, 'Pineland', 32.5999984741211, 0.568977309518541, -81.1597213745117, -1.41650435798645, 218, 48, 'PPL', 'P'),
(97082, 'Pineland', 31.2477798461914, 0.545376642254367, -93.9741668701172, -1.64015862370212, 218, 51, 'PPL', 'P'),
(105277, 'Pineland', 37.2902793884277, 0.650838154316641, -77.4180603027344, -1.35120005279023, 218, 53, 'PPL', 'P'),
(89918, 'Pineland (historical)', 35.4524993896484, 0.618762842410645, -84.8880615234375, -1.4815761692195, 218, 50, 'PPL', 'P'),
(17629, 'Pineland Gardens', 30.2694396972656, 0.528301385451161, -81.57861328125, -1.42381540096899, 218, 12, 'PPL', 'P'),
(5072, 'Pineland Park', 33.3888893127441, 0.582746052091332, -86.9044418334961, -1.5167686446024, 218, 2, 'PPL', 'P'),
(83015, 'Pinelands', 33.7269401550293, 0.588646152328348, -78.9555587768555, -1.37803446340803, 218, 48, 'PPL', 'P'),
(50408, 'Pineleigh', 39.4336090087891, 0.688246313147467, -76.5550003051758, -1.33613681419058, 218, 25, 'PPL', 'P'),
(17631, 'Pinellas Park', 27.8425006866455, 0.485943308970746, -82.6997222900391, -1.44338244444613, 218, 12, 'PPL', 'P'),
(67793, 'Pinelog', 34.9972190856934, 0.610816702087149, -83.9683303833008, -1.46552383259099, 218, 33, 'PPL', 'P'),
(50409, 'Pinemore', 38.3819389343262, 0.669891207703395, -76.6944427490234, -1.33857054395275, 218, 25, 'PPL', 'P'),
(83016, 'Pineneedles', 34.1811103820801, 0.596572918154914, -79.8702774047852, -1.39399931519473, 218, 48, 'PPL', 'P'),
(5073, 'Pineola', 31.0572204589844, 0.542050753527022, -88.1116714477539, -1.53783877619878, 218, 2, 'PPL', 'P'),
(17632, 'Pineola', 28.6886100769043, 0.500710703662804, -82.273063659668, -1.4359358465641, 218, 12, 'PPL', 'P'),
(67796, 'Pineola', 36.0283317565918, 0.628813013153359, -81.8916702270508, -1.42927927541945, 218, 33, 'PPL', 'P'),
(23959, 'Pineora', 32.2866706848145, 0.563508707957145, -81.3916702270508, -1.42055262915948, 218, 13, 'PPL', 'P'),
(110908, 'Pinepoca (historical)', 37.7855606079102, 0.659482442319902, -81.1386108398438, -1.41613590964963, 218, 58, 'PPL', 'P'),
(14422, 'Pinepoint Mobile Home Park', 38.5952796936035, 0.67361470638149, -75.2180633544922, -1.31280286250958, 218, 10, 'PPL', 'P'),
(37697, 'Piner', 38.8313903808594, 0.677735615273251, -84.5358276367188, -1.47542852815916, 218, 21, 'PPL', 'P'),
(67795, 'Pineridge', 35.8705596923828, 0.626059371165244, -76.6983337402344, -1.33863845456055, 218, 33, 'PPL', 'P'),
(83017, 'Pineridge', 33.9102783203125, 0.591846006957105, -81.1047210693359, -1.41554442157153, 218, 48, 'PPL', 'P'),
(184130, 'Pineridge', 37.0633316040039, 0.646877168248339, -119.360000610352, -2.08322500583308, 218, 6, 'PPL', 'P'),
(50410, 'Pineridge Farms', 39.7097206115723, 0.693065369718992, -76.9577789306641, -1.34316662736201, 218, 25, 'PPL', 'P'),
(110909, 'Pineridge North', 39.6636085510254, 0.69226056243757, -79.9533309936523, -1.39544887377606, 218, 58, 'PPL', 'P'),
(105278, 'Pinero', 37.4922218322754, 0.654362714861307, -76.540283203125, -1.33587995230344, 218, 53, 'PPL', 'P'),
(192047, 'Pinery (historical)', 31.8924903869629, 0.556628963913143, -104.817047119141, -1.82940258444704, 218, 51, 'PPL', 'P'),
(177752, 'Pines', 39.8974990844727, 0.696342722335471, -111.552223205566, -1.94695358285676, 218, 52, 'PPL', 'P'),
(189238, 'Pines', 35.7802810668945, 0.624483711906299, -106.436393737793, -1.85766551467356, 218, 38, 'PPL', 'P'),
(208443, 'Pines', 47.5458297729492, 0.829831275130712, -122.189170837402, -2.13260334139451, 218, 56, 'PPL', 'P'),
(89921, 'Pines (historical)', 36.2838897705078, 0.633273341926051, -85.1500015258789, -1.48614788470478, 218, 50, 'PPL', 'P'),
(157146, 'Pines Cottage Area', 40.5499992370605, 0.707730998367895, -81.2347183227539, -1.41781330166222, 218, 41, 'PPL', 'P'),
(146044, 'Pines Lake', 40.9916687011719, 0.715439584722157, -74.2624969482422, -1.29612508249907, 218, 37, 'PPL', 'P'),
(50411, 'Pines of Laurel', 39.0969390869141, 0.682370314518316, -76.8166732788086, -1.34070386914396, 218, 25, 'PPL', 'P'),
(50412, 'Pines-on-Severn', 39.0202789306641, 0.68103234238666, -76.5013885498047, -1.33520111254158, 218, 25, 'PPL', 'P'),
(50413, 'Pinesburg', 39.6291694641113, 0.69165948697954, -77.8583297729492, -1.35888420464149, 218, 25, 'PPL', 'P'),
(197257, 'Pinesdale', 46.3294410705566, 0.8086012872899, -114.215827941895, -1.9934422554774, 218, 31, 'PPL', 'P'),
(17633, 'Pinesville', 29.5874996185303, 0.51639928577592, -82.5236129760742, -1.44030875707401, 218, 12, 'PPL', 'P'),
(151742, 'Pinesville', 42.1552810668945, 0.735748451720938, -75.1638870239258, -1.31185730716455, 218, 40, 'PPL', 'P'),
(112466, 'Pinet Knoll', 34.978328704834, 0.610487002744197, -78.9647216796875, -1.37819438623149, 218, 33, 'PPL', 'P'),
(165968, 'Pineton', 40.6011085510254, 0.708623024175017, -78.9019393920898, -1.37709862860098, 218, 45, 'PPL', 'P'),
(137499, 'Pinetop', 47.9058303833008, 0.836114471090536, -94.1016693115234, -1.64238396110899, 218, 28, 'PPL', 'P'),
(178872, 'Pinetop-Lakeside', 34.1425018310547, 0.595899071820097, -109.959716796875, -1.91915910266598, 218, 5, 'PPL', 'P'),
(67797, 'Pinetops', 35.788330078125, 0.624624193653801, -77.6380615234375, -1.35503979844991, 218, 33, 'PPL', 'P'),
(14423, 'Pinetown', 38.7452812194824, 0.676232726891092, -75.2241668701172, -1.31290938895318, 218, 10, 'PPL', 'P'),
(67798, 'Pinetown', 35.610279083252, 0.621516617556815, -76.8616714477539, -1.34148923534942, 218, 33, 'PPL', 'P'),
(165969, 'Pinetown', 40.1199989318848, 0.700226077257997, -76.9011077880859, -1.34217752933315, 218, 45, 'PPL', 'P'),
(11220, 'Pinetree', 35.1266708374023, 0.613076061376945, -90.9280624389648, -1.58699407201892, 218, 4, 'PPL', 'P'),
(165970, 'Pinetree', 40.1127815246582, 0.700100109738437, -79.6011123657227, -1.38930149903183, 218, 45, 'PPL', 'P'),
(89922, 'Pinetree Estates', 35.1966705322266, 0.614297786527019, -85.192497253418, -1.48688957506837, 218, 50, 'PPL', 'P'),
(17634, 'Pinetta', 30.5938892364502, 0.53396409816651, -83.3525009155273, -1.45477558074754, 218, 12, 'PPL', 'P'),
(23960, 'Pinetta', 31.5930595397949, 0.551402909748026, -83.3583297729492, -1.45487731350118, 218, 13, 'PPL', 'P'),
(105284, 'Pinetta', 36.774169921875, 0.641830344824585, -76.2383270263672, -1.33060982282229, 218, 53, 'PPL', 'P'),
(5074, 'Pinetucky', 32.7597198486328, 0.571764973389581, -87.0841674804688, -1.51990544889235, 218, 2, 'PPL', 'P'),
(23961, 'Pinetucky (historical)', 32.7966690063477, 0.572409857847544, -82.4452819824219, -1.43894162332842, 218, 13, 'PPL', 'P'),
(5076, 'Pineview', 33.5374984741211, 0.585339771255987, -86.6816711425781, -1.51288056256894, 218, 2, 'PPL', 'P'),
(23965, 'Pineview', 32.1100006103516, 0.560425233468024, -83.501106262207, -1.45736923333317, 218, 13, 'PPL', 'P'),
(61347, 'Pineview', 31.726110458374, 0.553725086350034, -88.9427795410156, -1.55234434886617, 218, 30, 'PPL', 'P'),
(67815, 'Pineview', 35.3061103820801, 0.616207872239851, -79.0897216796875, -1.38037604779649, 218, 33, 'PPL', 'P'),
(97083, 'Pineview', 32.9077796936035, 0.574349105174312, -95.1600036621094, -1.66085538011367, 218, 51, 'PPL', 'P'),
(195471, 'Pineview', 44.2863883972168, 0.772943291348448, -111.309997558594, -1.94272594778431, 218, 17, 'PPL', 'P'),
(83020, 'Pineview Acres', 33.5247192382813, 0.585116731514693, -81.7802810668945, -1.42733516782369, 218, 48, 'PPL', 'P'),
(83021, 'Pineview Estates', 33.5430603027344, 0.585436843477721, -81.9641723632813, -1.4305446764114, 218, 48, 'PPL', 'P'),
(165971, 'Pineview Estates', 40.2466697692871, 0.702436900436927, -75.4916687011719, -1.3175781766602, 218, 45, 'PPL', 'P'),
(89923, 'Pineview Heights', 35.3666687011719, 0.617264814297476, -86.230827331543, -1.50501185365414, 218, 50, 'PPL', 'P'),
(83023, 'Pineview Lakes', 34.6833305358887, 0.605338313408747, -81.1972198486328, -1.41715882982433, 218, 48, 'PPL', 'P'),
(5077, 'Pineville', 31.7425003051758, 0.554011143140622, -87.1772232055664, -1.52152957768314, 218, 2, 'PPL', 'P'),
(11221, 'Pineville', 36.1627807617188, 0.631159590968855, -92.1069412231445, -1.60756938828477, 218, 4, 'PPL', 'P'),
(17635, 'Pineville', 30.898609161377, 0.539282464152912, -87.5824966430664, -1.52860293353839, 218, 12, 'PPL', 'P'),
(23968, 'Pineville', 32.2547187805176, 0.562951042024882, -84.6202774047852, -1.47690245466446, 218, 13, 'PPL', 'P'),
(37698, 'Pineville', 36.7619400024414, 0.641616892463215, -83.6949996948242, -1.46075331213033, 218, 21, 'PPL', 'P'),
(42586, 'Pineville', 31.3222198486328, 0.546675865392163, -92.4341735839844, -1.61328067040049, 218, 22, 'PPL', 'P'),
(56901, 'Pineville', 36.5944404602051, 0.638693473955608, -94.3838882446289, -1.64730961070315, 218, 29, 'PPL', 'P'),
(61349, 'Pineville', 32.1349983215332, 0.560861525833606, -89.4027786254883, -1.56037284744638, 218, 30, 'PPL', 'P'),
(67803, 'Pineville', 35.0830612182617, 0.6123149299374, -80.8925018310547, -1.41184049712745, 218, 33, 'PPL', 'P'),
(83024, 'Pineville', 33.4280586242676, 0.583429685543155, -80.0294418334961, -1.39677725852779, 218, 48, 'PPL', 'P'),
(89925, 'Pineville', 35.0694389343262, 0.612077176231083, -85.3302764892578, -1.48929427637466, 218, 50, 'PPL', 'P'),
(105282, 'Pineville', 36.6713905334473, 0.640036506093335, -76.8211135864258, -1.34078136713168, 218, 53, 'PPL', 'P'),
(110910, 'Pineville', 37.5830612182617, 0.655948161237258, -81.5372161865234, -1.42309288536525, 218, 58, 'PPL', 'P'),
(113913, 'Pineville', 41.8827781677246, 0.730992378909192, -71.8516693115234, -1.25404820254025, 218, 8, 'PPL', 'P'),
(137500, 'Pineville', 47.5361099243164, 0.829661631769274, -92.2938919067383, -1.61083229325233, 218, 28, 'PPL', 'P'),
(151743, 'Pineville', 43.5288887023926, 0.759722427590913, -76.039436340332, -1.32713852549942, 218, 40, 'PPL', 'P'),
(165973, 'Pineville', 41.6319389343262, 0.726614408393211, -79.5055618286133, -1.38763382755723, 218, 45, 'PPL', 'P'),
(42587, 'Pineville Junction', 31.311939239502, 0.546496434913718, -92.4272232055664, -1.61315936341284, 218, 22, 'PPL', 'P'),
(71291, 'Pinewald', 39.8955612182617, 0.696308900189627, -74.1733322143555, -1.29456886431608, 218, 37, 'PPL', 'P'),
(17636, 'Pinewood', 25.8686103820801, 0.451492424082886, -80.2172164916992, -1.40005454456525, 218, 12, 'PPL', 'P'),
(23969, 'Pinewood', 33.5099983215332, 0.584859803048528, -82.144172668457, -1.43368627439131, 218, 13, 'PPL', 'P'),
(42588, 'Pinewood', 30.9633293151855, 0.540412043929269, -93.2819366455078, -1.62807692710087, 218, 22, 'PPL', 'P'),
(67806, 'Pinewood', 35.3952789306641, 0.617764157001866, -77.9194412231445, -1.35995080065807, 218, 33, 'PPL', 'P'),
(83027, 'Pinewood', 33.7402801513672, 0.588878979186648, -80.4636077880859, -1.40435488393545, 218, 48, 'PPL', 'P'),
(89926, 'Pinewood', 35.9113883972168, 0.626771966493922, -87.4697189331055, -1.52663459117671, 218, 50, 'PPL', 'P'),
(137501, 'Pinewood', 47.5972213745117, 0.830728227785851, -95.1275024414063, -1.66028812680148, 218, 28, 'PPL', 'P'),
(165974, 'Pinewood', 40.1566696166992, 0.700866101446971, -74.8211135864258, -1.30587478209179, 218, 45, 'PPL', 'P'),
(184131, 'Pinewood', 36.5738906860352, 0.638334812735801, -118.764999389648, -2.07284027547842, 218, 6, 'PPL', 'P'),
(42589, 'Pinewood Acres', 30.5930595397949, 0.533949617228083, -91.0252838134766, -1.58869090510747, 218, 22, 'PPL', 'P'),
(50414, 'Pinewood Acres', 38.6258316040039, 0.674147937810751, -76.5316696166992, -1.33572961685991, 218, 25, 'PPL', 'P'),
(193877, 'Pinewood Cove', 40.8452796936035, 0.712884614551362, -122.845283508301, -2.14405466776574, 218, 6, 'PPL', 'P'),
(67809, 'Pinewood Downs', 34.7422218322754, 0.606366160431463, -77.3633270263672, -1.35024477690722, 218, 33, 'PPL', 'P'),
(23972, 'Pinewood Estates', 31.8166694641113, 0.555305639167483, -81.6213912963867, -1.42456201818059, 218, 13, 'PPL', 'P'),
(83030, 'Pinewood Estates', 34.9377784729004, 0.609779267684508, -82.290283203125, -1.43623638429312, 218, 48, 'PPL', 'P'),
(97084, 'Pinewood Estates', 30.1641693115234, 0.526464070615115, -94.3213882446289, -1.64621877992065, 218, 51, 'PPL', 'P'),
(71285, 'Pinewood Estates Mobile Home Park', 39.7638893127441, 0.69401079190597, -74.3252792358398, -1.29722084012958, 218, 37, 'PPL', 'P'),
(67812, 'Pinewood Forest', 35.5661087036133, 0.620745699000264, -77.3827819824219, -1.35058432994621, 218, 33, 'PPL', 'P'),
(105283, 'Pinewood Gardens', 36.8413887023926, 0.643003533863792, -76.0725021362305, -1.32771563250764, 218, 53, 'PPL', 'P'),
(83031, 'Pinewood Heights', 34.1805610656738, 0.59656333077499, -80.7688903808594, -1.40968307032837, 218, 48, 'PPL', 'P'),
(17637, 'Pinewood Park', 25.8655605316162, 0.451439194150598, -80.2138900756836, -1.39999648765348, 218, 12, 'PPL', 'P'),
(83032, 'Pinewood Plantation', 33.5777816772461, 0.586042845783768, -81.9361114501953, -1.43005492108693, 218, 48, 'PPL', 'P'),
(83033, 'Pinewood South', 34.8847198486328, 0.608853219994461, -81.9861068725586, -1.4309275058181, 218, 48, 'PPL', 'P'),
(194374, 'Pinewood Springs', 40.2733306884766, 0.702902221258391, -105.356109619141, -1.83881099994607, 218, 7, 'PPL', 'P'),
(5079, 'Pinewood Terrace', 33.2874984741211, 0.580976448126002, -86.35888671875, -1.50724691159899, 218, 2, 'PPL', 'P'),
(83034, 'Pinewood Vista', 32.9219398498535, 0.574596246523471, -80.0416717529297, -1.39699071088916, 218, 48, 'PPL', 'P'),
(165975, 'Pinewoods', 40.1416702270508, 0.700604312711816, -75.0199966430664, -1.3093459462566, 218, 45, 'PPL', 'P'),
(23973, 'Pineworth by the Lake', 32.8186111450195, 0.572792820412297, -83.7666702270508, -1.46200419889434, 218, 13, 'PPL', 'P'),
(5080, 'Piney', 34.1519393920898, 0.596063788333518, -85.6263885498047, -1.49446240678606, 218, 2, 'PPL', 'P'),
(11226, 'Piney', 35.440559387207, 0.618554450055347, -93.1900024414063, -1.62647237254409, 218, 4, 'PPL', 'P'),
(37699, 'Piney', 37.3963890075684, 0.652690116538682, -87.9038925170898, -1.53421234974242, 218, 21, 'PPL', 'P'),
(67814, 'Piney', 35.8766708374023, 0.626166030766902, -81.6772232055664, -1.42553646882345, 218, 33, 'PPL', 'P'),
(76954, 'Piney', 35.8844413757324, 0.626301652245414, -94.5416717529297, -1.65006345242834, 218, 42, 'PPL', 'P'),
(89927, 'Piney', 36.0149993896484, 0.628580319453113, -84.5583267211914, -1.47582121126189, 218, 50, 'PPL', 'P'),
(110911, 'Piney', 39.5158309936523, 0.689681357500856, -80.6947174072266, -1.40838850772249, 218, 58, 'PPL', 'P'),
(89928, 'Piney Acres', 35.4863891601563, 0.619354330488752, -84.9916687011719, -1.48338445559966, 218, 50, 'PPL', 'P'),
(5081, 'Piney Bend', 34.4541702270508, 0.601338711504638, -87.9899978637695, -1.53571517154556, 218, 2, 'PPL', 'P'),
(23974, 'Piney Bluff', 31.0194396972656, 0.541391354841118, -81.538330078125, -1.42311232644121, 218, 13, 'PPL', 'P'),
(5082, 'Piney Chapel', 34.8549995422363, 0.60833450279314, -86.9336090087891, -1.51727770784477, 218, 2, 'PPL', 'P'),
(105285, 'Piney Court', 38.8241691589355, 0.677609581174663, -77.1044387817383, -1.34572632464374, 218, 53, 'PPL', 'P'),
(50416, 'Piney Creek', 39.5819396972656, 0.690835172043133, -76.6438903808594, -1.33768823868361, 218, 25, 'PPL', 'P'),
(67816, 'Piney Creek', 36.5502815246582, 0.637922755136139, -81.2888870239258, -1.4187587238492, 218, 33, 'PPL', 'P'),
(50417, 'Piney Creek (historical)', 39.702220916748, 0.692934475351415, -77.1252822875977, -1.34609011244864, 218, 25, 'PPL', 'P'),
(56905, 'Piney End Resort', 37.8816719055176, 0.661159900911516, -92.0627822875977, -1.6067986694653, 218, 29, 'PPL', 'P'),
(89929, 'Piney Flats', 36.4194412231445, 0.635639161080423, -82.3041687011719, -1.43647873195231, 218, 50, 'PPL', 'P'),
(67819, 'Piney Forest Crossroads', 34.4569396972656, 0.601387047878423, -78.8636093139648, -1.37642964253515, 218, 33, 'PPL', 'P'),
(37700, 'Piney Fork', 37.2919387817383, 0.650867116193496, -88.0041732788086, -1.53596257921082, 218, 21, 'PPL', 'P'),
(67827, 'Piney Fork', 36.4458312988281, 0.636099754790952, -79.7769393920898, -1.39237025955593, 218, 33, 'PPL', 'P'),
(157152, 'Piney Fork', 40.2547187805176, 0.702577382184428, -80.8272171020508, -1.41070106365506, 218, 41, 'PPL', 'P'),
(165976, 'Piney Fork', 40.2897186279297, 0.703188244759465, -79.9963912963867, -1.39620041783568, 218, 45, 'PPL', 'P'),
(14434, 'Piney Glade', 38.7266693115234, 0.67590788781713, -75.121940612793, -1.31112520418088, 218, 10, 'PPL', 'P'),
(67821, 'Piney Green', 35.0933303833008, 0.612494160678762, -78.4783325195313, -1.36970529394076, 218, 33, 'PPL', 'P'),
(5086, 'Piney Grove', 31.1686096191406, 0.54399486112278, -86.0508270263672, -1.50187025567423, 218, 2, 'PPL', 'P'),
(11230, 'Piney Grove', 33.9713897705078, 0.592912602973682, -93.4558334350586, -1.63111199863717, 218, 4, 'PPL', 'P'),
(14424, 'Piney Grove', 38.6311111450195, 0.674240083184467, -75.3872222900391, -1.31575524289404, 218, 10, 'PPL', 'P'),
(17638, 'Piney Grove', 30.8038902282715, 0.537629306906245, -86.1308288574219, -1.50326655103376, 218, 12, 'PPL', 'P'),
(23976, 'Piney Grove', 31.7369403839111, 0.553914104208402, -82.0188903808594, -1.4314996859783, 218, 13, 'PPL', 'P'),
(37703, 'Piney Grove', 37.1002807617188, 0.647522052706302, -84.4863891601563, -1.47456566396597, 218, 21, 'PPL', 'P'),
(50421, 'Piney Grove', 38.3022193908691, 0.668499839191883, -75.4858322143555, -1.31747631074851, 218, 25, 'PPL', 'P'),
(67825, 'Piney Grove', 34.9550018310547, 0.610079871992551, -79.8105621337891, -1.39295708710213, 218, 33, 'PPL', 'P'),
(89935, 'Piney Grove', 36.3480606079102, 0.634393334322484, -82.333610534668, -1.43699258888464, 218, 50, 'PPL', 'P'),
(97085, 'Piney Grove', 32.901668548584, 0.574242445572654, -95.1052780151367, -1.65990023738871, 218, 51, 'PPL', 'P'),
(105288, 'Piney Grove', 36.9891700744629, 0.645582805379534, -77.0416717529297, -1.34463083332933, 218, 53, 'PPL', 'P'),
(50422, 'Piney Grove (historical)', 38.2555618286133, 0.667685511109564, -75.4444427490234, -1.31675392830282, 218, 25, 'PPL', 'P'),
(50423, 'Piney Grove Estates', 38.6666717529297, 0.67486073287651, -75.8550033569336, -1.32391956268984, 218, 25, 'PPL', 'P'),
(67826, 'Piney Grove Landing', 35.6002807617188, 0.621342113926387, -76.5569381713867, -1.33617063633643, 218, 33, 'PPL', 'P'),
(14425, 'Piney Grove Manor', 38.6430587768555, 0.674448608697821, -75.3708267211914, -1.31546908623491, 218, 10, 'PPL', 'P'),
(50432, 'Piney Hill', 39.5697212219238, 0.690621919418845, -76.6586074829102, -1.33794510057075, 218, 25, 'PPL', 'P'),
(50424, 'Piney Hill Estates', 39.5041694641113, 0.689477825414547, -77.2811126708984, -1.34880986571189, 218, 25, 'PPL', 'P'),
(23977, 'Piney Hills', 33.0366706848145, 0.576598677347102, -85.085563659668, -1.48502323177644, 218, 13, 'PPL', 'P'),
(71286, 'Piney Hollow', 39.5877799987793, 0.690937104533855, -74.9277801513672, -1.30773646485181, 218, 37, 'PPL', 'P'),
(50425, 'Piney Island', 38.4088897705078, 0.670361588530931, -75.1888885498047, -1.31229366610916, 218, 25, 'PPL', 'P'),
(23978, 'Piney Knoll', 33.4036102294922, 0.583002980557497, -84.5708312988281, -1.47603945731322, 218, 13, 'PPL', 'P'),
(67830, 'Piney Mountain Estates', 35.7308311462402, 0.623620647976032, -79.7997207641602, -1.39276786950668, 218, 33, 'PPL', 'P'),
(50426, 'Piney Orchard', 39.0663909912109, 0.681837149668082, -76.7144393920898, -1.33891955121361, 218, 25, 'PPL', 'P'),
(56906, 'Piney Park', 38.3011093139648, 0.668480464694953, -90.9427795410156, -1.58725093390606, 218, 29, 'PPL', 'P'),
(67829, 'Piney Plains', 35.7455596923828, 0.623877709600251, -78.7547225952148, -1.37452921078127, 218, 33, 'PPL', 'P'),
(14426, 'Piney Point', 38.5644416809082, 0.673076481525185, -75.0861129760742, -1.31049989395693, 218, 10, 'PPL', 'P'),
(17639, 'Piney Point', 27.6338901519775, 0.482302368286444, -82.5405578613281, -1.44060450111307, 218, 12, 'PPL', 'P'),
(50428, 'Piney Point', 38.4111099243164, 0.670400337524791, -75.1819381713867, -1.3121723591215, 218, 25, 'PPL', 'P'),
(125828, 'Piney Point Beach', 41.6958312988281, 0.727729540520654, -70.7222213745117, -1.23433561730954, 218, 23, 'PPL', 'P'),
(105290, 'Piney Point Estates', 37.1480598449707, 0.648355955022633, -76.4355621337891, -1.33405222484732, 218, 53, 'PPL', 'P'),
(50429, 'Piney Point Shores', 38.1474990844727, 0.66579946042557, -76.5083312988281, -1.33532228637118, 218, 25, 'PPL', 'P'),
(97087, 'Piney Point Village', 29.7597198486328, 0.519405095829751, -95.5169372558594, -1.66708504653558, 218, 51, 'PPL', 'P'),
(50430, 'Piney Ridge', 39.2594413757324, 0.685206514500223, -75.8605575561523, -1.32401650175352, 218, 25, 'PPL', 'P'),
(67831, 'Piney Ridge', 34.9674987792969, 0.610297984885828, -78.3444366455078, -1.36736837008421, 218, 33, 'PPL', 'P'),
(83035, 'Piney Ridge', 34.8938903808594, 0.609013275975974, -82.3480606079102, -1.43724479023988, 218, 48, 'PPL', 'P'),
(132631, 'Piney Ridge', 44.0152816772461, 0.768211586460676, -86.4716720581055, -1.50921538711872, 218, 27, 'PPL', 'P'),
(50431, 'Piney Ridge Village', 39.4022216796875, 0.687698500911237, -76.9652786254883, -1.34329752172959, 218, 25, 'PPL', 'P'),
(105291, 'Piney River', 37.7050018310547, 0.658076426422395, -79.0233306884766, -1.37921730640619, 218, 53, 'PPL', 'P'),
(50437, 'Piney Run Estates', 39.4241714477539, 0.688081596634045, -77.0055618286133, -1.34400059625737, 218, 25, 'PPL', 'P'),
(50433, 'Piney Shores', 39.2366714477539, 0.684809104286556, -75.9305572509766, -1.3252382269036, 218, 25, 'PPL', 'P'),
(89936, 'Piney Shores Estates', 35.6797218322754, 0.62272862216891, -84.8180618286133, -1.48035444406942, 218, 50, 'PPL', 'P'),
(50434, 'Piney Valley Estates', 39.4272193908691, 0.68813479327682, -76.9291687011719, -1.34266728465762, 218, 25, 'PPL', 'P'),
(110912, 'Piney View', 37.836109161377, 0.660364681010018, -81.1350021362305, -1.41607292588985, 218, 58, 'PPL', 'P'),
(157147, 'Piney View', 40.5127792358398, 0.707081386798998, -81.1427764892578, -1.41620861394739, 218, 41, 'PPL', 'P'),
(67832, 'Piney Wood', 34.5661087036133, 0.603292406480321, -78.0983276367188, -1.36307295756202, 218, 33, 'PPL', 'P'),
(5087, 'Piney Woods', 33.8213882446289, 0.59029458246408, -85.4338912963867, -1.49110269591288, 218, 2, 'PPL', 'P'),
(61351, 'Piney Woods', 32.0625, 0.559596191420682, -89.9927825927734, -1.57067035927534, 218, 30, 'PPL', 'P'),
(89937, 'Piney Woods', 34.9877815246582, 0.610651985573727, -85.3163909912109, -1.48905192871546, 218, 50, 'PPL', 'P'),
(132632, 'Piney Woods', 44.0733299255371, 0.76922471951837, -84.8083267211914, -1.48018453439188, 218, 27, 'PPL', 'P'),
(23979, 'Piney Woods Manor', 33.9222183227539, 0.592054399312404, -84.8555603027344, -1.48100891590731, 218, 13, 'PPL', 'P'),
(67834, 'Pineygrove', 35.5647201538086, 0.620721464234344, -76.9869384765625, -1.34367555744632, 218, 33, 'PPL', 'P'),
(184132, 'Pinezanita', 34.1644401550293, 0.596281967805823, -116.952499389648, -2.04120618278602, 218, 6, 'PPL', 'P'),
(208444, 'Ping', 46.6641693115234, 0.814443397194179, -117.667778015137, -2.05369014986993, 218, 56, 'PPL', 'P'),
(140703, 'Pingree', 47.163330078125, 0.823155396068156, -98.9066696166992, -1.72624703699364, 218, 34, 'PPL', 'P'),
(195472, 'Pingree', 43.1166687011719, 0.752527831327036, -112.597778320313, -1.96520196212014, 218, 17, 'PPL', 'P'),
(128545, 'Pingree Center', 45.1122207641602, 0.787356785221147, -69.4483337402344, -1.21210208379096, 218, 26, 'PPL', 'P'),
(121050, 'Pingree Grove', 42.0686111450195, 0.734235776221773, -88.413330078125, -1.54310371251582, 218, 18, 'PPL', 'P'),
(125829, 'Pingryville', 42.5516700744629, 0.742666745021718, -71.5369415283203, -1.24855516647585, 218, 23, 'PPL', 'P'),
(5088, 'Pinhook', 34.4013900756836, 0.60041752408358, -87.2502822875977, -1.52280469921307, 218, 2, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(89940, 'Pinhook', 36.2797203063965, 0.633200571049265, -83.817497253418, -1.46289129785345, 218, 50, 'PPL', 'P'),
(123442, 'Pinhook', 41.5638885498047, 0.725426705126063, -86.855827331543, -1.51592016147911, 218, 19, 'PPL', 'P'),
(139393, 'Pinhook', 40.3022193908691, 0.70340642423177, -94.3302764892578, -1.64637390905415, 218, 29, 'PPL', 'P'),
(157149, 'Pinhook', 40.6822204589844, 0.710038694031476, -82.3783264160156, -1.43777302824209, 218, 41, 'PPL', 'P'),
(28261, 'Pinhook (historical)', 38.9102783203125, 0.679112469556822, -89.0341720581055, -1.55393944920108, 218, 18, 'PPL', 'P'),
(89941, 'Pinhook (historical)', 35.9019393920898, 0.626607050243419, -85.6944427490234, -1.49565017663224, 218, 50, 'PPL', 'P'),
(76955, 'Pinhook Corner', 35.5361099243164, 0.620222121529954, -94.8847198486328, -1.65605077119106, 218, 42, 'PPL', 'P'),
(444, 'Pink', 34.5913887023926, 0.603733625693919, -83.7125015258789, -1.46105877670736, 218, 13, 'PPL', 'P'),
(37701, 'Pink', 37.7794418334961, 0.65937564956019, -84.5511093139648, -1.47569524374233, 218, 21, 'PPL', 'P'),
(61352, 'Pink', 34.5555610656738, 0.603108315469969, -90.304443359375, -1.57610986580182, 218, 30, 'PPL', 'P'),
(73907, 'Pink', 38.752498626709, 0.676358694410653, -83.2638931274414, -1.45322908310253, 218, 41, 'PPL', 'P'),
(76956, 'Pink', 35.2605590820313, 0.615412852075435, -97.1194381713867, -1.69505396377776, 218, 42, 'PPL', 'P'),
(110913, 'Pink', 38.7852783203125, 0.676930807991829, -81.2202835083008, -1.4175613666231, 218, 58, 'PPL', 'P'),
(165978, 'Pink', 41.4786109924316, 0.723938330971845, -75.3352813720703, -1.31484870285898, 218, 45, 'PPL', 'P'),
(178874, 'Pink Arrow', 35.7769393920898, 0.624425388678426, -110.156669616699, -1.922596577843, 218, 5, 'PPL', 'P'),
(56911, 'Pink Hill', 39.0502815246582, 0.681555986435997, -94.1969375610352, -1.64404670573558, 218, 29, 'PPL', 'P'),
(67840, 'Pink Hill', 35.0550003051758, 0.611825174612934, -77.7466735839844, -1.35693543651383, 218, 33, 'PPL', 'P'),
(105292, 'Pinkard Court', 37.2236099243164, 0.649674552657359, -79.9719390869141, -1.395773646271, 218, 53, 'PPL', 'P'),
(73908, 'Pinkerman', 38.8383293151855, 0.677856722523822, -82.7697219848633, -1.4446041695962, 218, 41, 'PPL', 'P'),
(78950, 'Pinkerton', 39.8472213745117, 0.69546521075629, -79.2397232055664, -1.38299406830609, 218, 45, 'PPL', 'P'),
(97086, 'Pinkerton', 33.1986083984375, 0.579425023632976, -99.8413925170898, -1.74256102919925, 218, 51, 'PPL', 'P'),
(140706, 'Pinkham', 46.920280456543, 0.818913379925823, -96.9033279418945, -1.69128212872588, 218, 34, 'PPL', 'P'),
(56912, 'Pinkley (historical)', 37.5022201538086, 0.654537218491734, -90.8263931274414, -1.5852196077846, 218, 29, 'PPL', 'P'),
(67837, 'Pinkney', 35.5252799987793, 0.620033103671586, -78.0666732788086, -1.36252048479389, 218, 33, 'PPL', 'P'),
(89942, 'Pinkney', 35.1569404602051, 0.613604365958189, -87.5436096191406, -1.52792422693458, 218, 50, 'PPL', 'P'),
(5089, 'Pinkney City', 33.6272201538086, 0.586905709976954, -86.9347229003906, -1.51729714892073, 218, 2, 'PPL', 'P'),
(208445, 'Pinkney City', 48.5763893127441, 0.847817932237971, -117.876937866211, -2.05734067793416, 218, 56, 'PPL', 'P'),
(5090, 'Pinkneyville', 33.1066703796387, 0.577820402497176, -85.9591674804688, -1.50027049480742, 218, 2, 'PPL', 'P'),
(146045, 'Pinkneyville', 41.0463905334473, 0.716394660868086, -74.6927795410156, -1.30363493045698, 218, 37, 'PPL', 'P'),
(28262, 'Pinkstaff', 38.7944412231445, 0.677090730815288, -87.6691665649414, -1.53011560903755, 218, 18, 'PPL', 'P'),
(56913, 'Pinkston', 39.6469383239746, 0.691969612088479, -94.804443359375, -1.65464968214157, 218, 29, 'PPL', 'P'),
(67838, 'Pinkston', 35.0161094665527, 0.6111464014301, -80.07861328125, -1.39763546218907, 218, 33, 'PPL', 'P'),
(17640, 'Pinland', 30.0177803039551, 0.52390910044432, -83.5280609130859, -1.45783968073973, 218, 12, 'PPL', 'P'),
(157150, 'Pinn (historical)', 40.7794418334961, 0.71173552712002, -81.603889465332, -1.42425655360356, 218, 41, 'PPL', 'P'),
(11234, 'Pinnacle', 34.8255615234375, 0.607820712439837, -92.4966735839844, -1.61437150118299, 218, 4, 'PPL', 'P'),
(37702, 'Pinnacle', 37.6211090087891, 0.65661222045507, -83.817497253418, -1.46289129785345, 218, 21, 'PPL', 'P'),
(67839, 'Pinnacle', 36.3291702270508, 0.634063634979532, -80.4333267211914, -1.40382637961713, 218, 33, 'PPL', 'P'),
(89944, 'Pinnacle', 36.3499984741211, 0.634427156468328, -86.9397201538086, -1.51738436744643, 218, 50, 'PPL', 'P'),
(197258, 'Pinnacle', 48.3561096191406, 0.843973326309305, -113.652221679688, -1.98360547051703, 218, 31, 'PPL', 'P'),
(83036, 'Pinnacle Heights', 34.978889465332, 0.610496789861203, -82.0194396972656, -1.43150927335823, 218, 48, 'PPL', 'P'),
(178875, 'Pinnacle Paradise', 33.7013893127441, 0.588200206003814, -111.893890380859, -1.95291680001161, 218, 5, 'PPL', 'P'),
(178876, 'Pinnacle Peak Country Club Estates', 33.686939239502, 0.587948004648584, -111.893890380859, -1.95291680001161, 218, 5, 'PPL', 'P'),
(178877, 'Pinnacle Peak Estates I', 33.7075004577637, 0.588306865605472, -111.905563354492, -1.953120531835, 218, 5, 'PPL', 'P'),
(178878, 'Pinnacle Peak Estates II', 33.6894416809082, 0.587991680490461, -111.905563354492, -1.953120531835, 218, 5, 'PPL', 'P'),
(178879, 'Pinnacle Peak Estates III', 33.7102813720703, 0.588355401716339, -111.896667480469, -1.95296526954345, 218, 5, 'PPL', 'P'),
(178880, 'Pinnacle Peak Heights', 33.6955604553223, 0.588098473250173, -111.863891601563, -1.9523932225413, 218, 5, 'PPL', 'P'),
(178881, 'Pinnacle Peak Heights IV', 33.6988906860352, 0.588156596740964, -111.864440917969, -1.95240280992122, 218, 5, 'PPL', 'P'),
(178882, 'Pinnacle Peak Heights V-VI', 33.6916694641113, 0.588030562642376, -111.863891601563, -1.9523932225413, 218, 5, 'PPL', 'P'),
(178883, 'Pinnacle Peak Shadows', 33.6961097717285, 0.588108060630097, -111.879173278809, -1.95265993812447, 218, 5, 'PPL', 'P'),
(178884, 'Pinnacle Peak Village', 33.7000007629395, 0.588175971237895, -111.901107788086, -1.95304276753117, 218, 5, 'PPL', 'P'),
(172400, 'Pinnacle Ridge', 43.6599998474121, 0.762010748757563, -72.998893737793, -1.27407104603796, 218, 55, 'PPL', 'P'),
(11235, 'Pinnacle Springs (historical)', 35.3263893127441, 0.616561806348722, -92.3930587768555, -1.61256308164477, 218, 4, 'PPL', 'P'),
(184133, 'Pinnacles', 36.5308303833008, 0.637583268676181, -121.144172668457, -2.1143646826691, 218, 6, 'PPL', 'P'),
(132633, 'Pinnebog', 43.9352798461914, 0.766815291101148, -83.103889465332, -1.45043649238347, 218, 27, 'PPL', 'P'),
(5091, 'Pinnell', 32.7558288574219, 0.571697062781784, -85.6552810668945, -1.49496667633847, 218, 2, 'PPL', 'P'),
(194375, 'Pinneo', 40.2094383239746, 0.701787089130947, -103.438056945801, -1.80533466556961, 218, 7, 'PPL', 'P'),
(165979, 'Pinney Corners', 41.7169418334961, 0.728097988857467, -80.0213928222656, -1.39663677678029, 218, 45, 'PPL', 'P'),
(113915, 'Pinneys Corners', 41.1863899230957, 0.718838111168234, -73.523063659668, -1.2832195370146, 218, 8, 'PPL', 'P'),
(193878, 'Pinnio', 41.0741691589355, 0.716879489344535, -120.468330383301, -2.10256900956892, 218, 6, 'PPL', 'P'),
(67841, 'Pino', 36.0233306884766, 0.628725728048632, -80.5794372558594, -1.40637648951893, 218, 33, 'PPL', 'P'),
(42591, 'Pino Bayou Village', 32.459171295166, 0.566519411569479, -92.07861328125, -1.60707497242839, 218, 22, 'PPL', 'P'),
(184134, 'Pino Grande', 38.8702812194824, 0.678414388456085, -120.625, -2.10530341021816, 218, 6, 'PPL', 'P'),
(189239, 'Pino Place', 34.5702781677246, 0.603365177357107, -107.444999694824, -1.87526900947899, 218, 38, 'PPL', 'P'),
(110914, 'Pinoak', 37.4455604553223, 0.653548320199961, -81.2080612182617, -1.41734804741978, 218, 58, 'PPL', 'P'),
(67842, 'Pinoca (historical)', 35.269718170166, 0.615572708319867, -80.8916702270508, -1.41182598289951, 218, 33, 'PPL', 'P'),
(712, 'Pinola', 31.8769397735596, 0.55635755450855, -89.9619369506836, -1.57013200126098, 218, 30, 'PPL', 'P'),
(123443, 'Pinola', 41.5988883972168, 0.7260375677011, -86.7977828979492, -1.51490709500044, 218, 19, 'PPL', 'P'),
(165982, 'Pinola', 40.0374984741211, 0.698786172635619, -77.5919418334961, -1.35423485801043, 218, 45, 'PPL', 'P'),
(184136, 'Pinole', 38.0044403076172, 0.663302613745567, -122.297782897949, -2.13449897945843, 218, 6, 'PPL', 'P'),
(178886, 'Pinon', 36.100830078125, 0.630078347566283, -110.225280761719, -1.92379406822716, 218, 5, 'PPL', 'P'),
(187203, 'Pinon', 38.4333305358887, 0.670788160358534, -104.606941223145, -1.82573554478406, 218, 7, 'PPL', 'P'),
(189240, 'Pinon', 32.6180610656738, 0.569292561212579, -105.393890380859, -1.83947039863198, 218, 38, 'PPL', 'P'),
(187204, 'Pinon Acres', 37.2277793884277, 0.649747323534145, -107.816673278809, -1.8817559372622, 218, 7, 'PPL', 'P'),
(184137, 'Pinon Hills Estates', 34.4700012207031, 0.601615014467734, -117.633888244629, -2.05309866179183, 218, 6, 'PPL', 'P'),
(184138, 'Pinon Pines Estates', 34.8288917541504, 0.607878835930628, -119.041938781738, -2.07767377969886, 218, 6, 'PPL', 'P'),
(83037, 'Pinopolis', 33.226390838623, 0.579909918688452, -80.0377807617188, -1.39692280028137, 218, 48, 'PPL', 'P'),
(189242, 'Pinos Altos', 35.1630592346191, 0.613711158717901, -105.390830993652, -1.83941700225212, 218, 38, 'PPL', 'P'),
(5092, 'Pinson', 33.6888885498047, 0.587982026531509, -86.6833267211914, -1.51290945786677, 218, 2, 'PPL', 'P'),
(23980, 'Pinson', 34.3630599975586, 0.599748538017752, -85.063606262207, -1.48464000289558, 218, 13, 'PPL', 'P'),
(67843, 'Pinson', 35.5255584716797, 0.620037963940575, -80.0336074829102, -1.39684996282555, 218, 33, 'PPL', 'P'),
(89945, 'Pinson', 35.4900016784668, 0.61941738082756, -88.7205581665039, -1.54846585421264, 218, 50, 'PPL', 'P'),
(37704, 'Pinsonfork', 37.5530586242676, 0.655424517187921, -82.2638931274414, -1.43577579058259, 218, 21, 'PPL', 'P'),
(178885, 'Pinta', 35.082218170166, 0.612300215972377, -109.629997253418, -1.91340441102448, 218, 5, 'PPL', 'P'),
(189243, 'Pintada', 34.8822212219238, 0.60880961073161, -105.071670532227, -1.83384660135806, 218, 38, 'PPL', 'P'),
(50435, 'Pintail Isle', 38.3811111450195, 0.669876760054482, -75.1333312988281, -1.31132400915626, 218, 25, 'PPL', 'P'),
(5093, 'Pinthlocco (historical)', 32.8388900756836, 0.573146754521169, -86.2111129760742, -1.5046677732413, 218, 2, 'PPL', 'P'),
(5094, 'Pintlala', 32.1755599975586, 0.561569460630376, -86.3675003051758, -1.50739724704252, 218, 2, 'PPL', 'P'),
(50436, 'Pinto', 39.5697212219238, 0.690621919418845, -78.8394393920898, -1.37600779781848, 218, 25, 'PPL', 'P'),
(177744, 'Pinto', 29.2811107635498, 0.511051791465095, -100.58805847168, -1.75559280851939, 218, 51, 'PPL', 'P'),
(190613, 'Pinto (historical)', 39.4022216796875, 0.687698500911237, -115.867218017578, -2.02226444953284, 218, 39, 'PPL', 'P'),
(184139, 'Pinto Wye', 34.0208282470703, 0.593775467166868, -116.018608093262, -2.02490670480836, 218, 6, 'PPL', 'P'),
(192748, 'Pintura', 37.3408317565918, 0.651720459585785, -113.273330688477, -1.97699257521425, 218, 52, 'PPL', 'P'),
(184140, 'Pinyon Crest', 33.6086082458496, 0.586580870902992, -116.436393737793, -2.03219843987299, 218, 6, 'PPL', 'P'),
(184141, 'Pinyon Pines', 33.5894393920898, 0.58624631129105, -116.451942443848, -2.03246981598807, 218, 6, 'PPL', 'P'),
(190616, 'Pioche', 37.9297218322754, 0.661998530338782, -114.451393127441, -1.99755364356826, 218, 39, 'PPL', 'P'),
(165980, 'Piolett', 41.0566711425781, 0.716574091346531, -79.4027786254883, -1.38583992224695, 218, 45, 'PPL', 'P'),
(42592, 'Pioneer', 32.7361106872559, 0.571352915789918, -91.4333267211914, -1.5958125973365, 218, 22, 'PPL', 'P'),
(56914, 'Pioneer', 36.8358306884766, 0.642906528221086, -94.0547180175781, -1.64156450644157, 218, 29, 'PPL', 'P'),
(89946, 'Pioneer', 36.4174995422363, 0.635605272355552, -84.3141708374023, -1.47155988720166, 218, 50, 'PPL', 'P'),
(97088, 'Pioneer', 32.1113891601563, 0.560449468233943, -99.0872192382813, -1.72939822235348, 218, 51, 'PPL', 'P'),
(112214, 'Pioneer', 33.166389465332, 0.578862697168806, -87.8850021362305, -1.53388265039947, 218, 2, 'PPL', 'P'),
(117302, 'Pioneer', 42.6538887023926, 0.744450796635962, -94.392219543457, -1.64745501929866, 218, 16, 'PPL', 'P'),
(121051, 'Pioneer', 40.7827796936035, 0.711793783768866, -89.6547164916992, -1.56476999272221, 218, 18, 'PPL', 'P'),
(123444, 'Pioneer', 40.7377815246582, 0.711008417563401, -85.8955612182617, -1.49916035610702, 218, 19, 'PPL', 'P'),
(132635, 'Pioneer', 44.4674987792969, 0.77610426382529, -85.1558303833008, -1.48624961745842, 218, 27, 'PPL', 'P'),
(157151, 'Pioneer', 41.6800003051758, 0.727453237557559, -84.5530624389648, -1.47572933220428, 218, 41, 'PPL', 'P'),
(165981, 'Pioneer', 41.5311088562012, 0.724854591544887, -79.665283203125, -1.39042149142827, 218, 45, 'PPL', 'P'),
(178887, 'Pioneer', 33.6919403076172, 0.588035289753311, -113.894439697266, -1.98783297243142, 218, 5, 'PPL', 'P'),
(193879, 'Pioneer', 41.2924995422363, 0.720690073390275, -122.309173583984, -2.1346977844338, 218, 6, 'PPL', 'P'),
(197260, 'Pioneer', 46.5125007629395, 0.811796281649668, -112.965278625488, -1.97161605244754, 218, 31, 'PPL', 'P'),
(201406, 'Pioneer', 44.6480598449707, 0.779255648922208, -123.86888885498, -2.16191995130632, 218, 43, 'PPL', 'P'),
(208447, 'Pioneer', 47.2033309936523, 0.82385354374792, -122.580276489258, -2.13942942274254, 218, 56, 'PPL', 'P'),
(190619, 'Pioneer (historical)', 38.8038902282715, 0.677255647065791, -116.805557250977, -2.03864155865628, 218, 39, 'PPL', 'P'),
(178888, 'Pioneer Acres', 34.5597190856934, 0.603180886609674, -111.843063354492, -1.9520297010525, 218, 5, 'PPL', 'P'),
(205380, 'Pioneer Addition', 40.7686080932617, 0.711546442682624, -111.760833740234, -1.95059452354106, 218, 52, 'PPL', 'P'),
(50443, 'Pioneer City', 39.1230583190918, 0.68282618111791, -76.7011108398438, -1.33868692409239, 218, 25, 'PPL', 'P'),
(201405, 'Pioneer City (historical)', 44.6402816772461, 0.779119894285641, -123.862503051758, -2.1618084980147, 218, 43, 'PPL', 'P'),
(23981, 'Pioneer Crossing', 34.0844383239746, 0.594885672446295, -84.4486083984375, -1.47390626528007, 218, 13, 'PPL', 'P'),
(89947, 'Pioneer Estates', 35.9472198486328, 0.6273973432969, -86.4972229003906, -1.50966133344326, 218, 50, 'PPL', 'P'),
(142678, 'Pioneer Estates', 40.9500007629395, 0.714712342007483, -98.3450012207031, -1.71644407417911, 218, 35, 'PPL', 'P'),
(178889, 'Pioneer Estates', 33.6375007629395, 0.587085140455398, -112.170829772949, -1.95775030423205, 218, 5, 'PPL', 'P'),
(205379, 'Pioneer Estates', 40.6561088562012, 0.709582960589936, -111.945831298828, -1.95382334004667, 218, 52, 'PPL', 'P'),
(50438, 'Pioneer Hills', 39.1147193908691, 0.682680639364337, -77.3022232055664, -1.3491783140487, 218, 25, 'PPL', 'P'),
(197261, 'Pioneer Junction', 48.336109161377, 0.843624252469423, -115.517501831055, -2.01616075063048, 218, 31, 'PPL', 'P'),
(67844, 'Pioneer Mills', 35.2602806091309, 0.615407991806445, -80.5888900756836, -1.40654147234846, 218, 33, 'PPL', 'P'),
(184143, 'Pioneer Point', 35.785831451416, 0.624580584390951, -117.362503051758, -2.04836209663507, 218, 6, 'PPL', 'P'),
(50439, 'Pioneer Point Farms', 39.0758285522461, 0.682001866181503, -76.1419372558594, -1.32892750396168, 218, 25, 'PPL', 'P'),
(110915, 'Pioneer Rocks', 39.6094398498535, 0.691315140250592, -79.8863906860352, -1.39428054500585, 218, 58, 'PPL', 'P'),
(97089, 'Pioneer Town', 29.9858303070068, 0.523351467801571, -98.107780456543, -1.71230379079042, 218, 51, 'PPL', 'P'),
(23982, 'Pioneer Village', 32.9008293151855, 0.574227798186659, -85.0313873291016, -1.48407767643141, 218, 13, 'PPL', 'P'),
(37705, 'Pioneer Village', 38.0605583190918, 0.66428205781547, -85.6777801513672, -1.4953593594412, 218, 21, 'PPL', 'P'),
(89948, 'Pioneer Village', 35.7738914489746, 0.624372192035652, -84.7211074829102, -1.47866227151279, 218, 50, 'PPL', 'P'),
(178890, 'Pioneer Village II', 33.5791702270508, 0.586067080549688, -112.210563659668, -1.9584437913799, 218, 5, 'PPL', 'P'),
(23983, 'Pioneer Woods', 33.8424987792969, 0.590663030800892, -83.3283309936523, -1.45435373603087, 218, 13, 'PPL', 'P'),
(184144, 'Pioneertown', 34.1566696166992, 0.596146346327311, -116.495277404785, -2.03322615373766, 218, 6, 'PPL', 'P'),
(195473, 'Pioneerville', 43.9688911437988, 0.767401918910265, -115.845832824707, -2.02189120750606, 218, 17, 'PPL', 'P'),
(28263, 'Piopolis', 38.1836090087891, 0.666429697497538, -88.561393737793, -1.54568791087958, 218, 18, 'PPL', 'P'),
(175852, 'Pipe', 43.9141693115234, 0.766446842764335, -88.3125, -1.54134389566749, 218, 57, 'PPL', 'P'),
(97090, 'Pipe Creek', 29.7233295440674, 0.518769965199281, -98.9355621337891, -1.72675130654605, 218, 51, 'PPL', 'P'),
(50440, 'Pipe Creek (historical)', 39.5511093139648, 0.690297080344882, -77.1277770996094, -1.34613365513247, 218, 25, 'PPL', 'P'),
(50441, 'Pipe Creek Mill', 39.667781829834, 0.692333399893384, -77.102783203125, -1.34569742934591, 218, 25, 'PPL', 'P'),
(5095, 'Piper', 33.0894393920898, 0.577519665031079, -87.041389465332, -1.51915883168075, 218, 2, 'PPL', 'P'),
(33628, 'Piper', 39.1430587768555, 0.683175254957792, -94.8611068725586, -1.65563864701237, 218, 20, 'PPL', 'P'),
(56916, 'Piper', 38.3436088562012, 0.669222221637567, -94.0144424438477, -1.64086156507185, 218, 29, 'PPL', 'P'),
(76958, 'Piper', 36.1741714477539, 0.63135839594423, -98.267219543457, -1.71508652781344, 218, 42, 'PPL', 'P'),
(117304, 'Piper', 42.3650016784668, 0.73940876690217, -94.5533294677734, -1.65026691793562, 218, 16, 'PPL', 'P'),
(165983, 'Piper', 41.1847190856934, 0.718808949554298, -78.1455612182617, -1.36389733907746, 218, 45, 'PPL', 'P'),
(197262, 'Piper', 46.9900016784668, 0.820130244806907, -109.199722290039, -1.90589469622462, 218, 31, 'PPL', 'P'),
(199610, 'Piper', 41.7597198486328, 0.728844606069071, -103.258056640625, -1.8021930675897, 218, 35, 'PPL', 'P'),
(121052, 'Piper City', 40.7566719055176, 0.711338116906353, -88.1911087036133, -1.53922521786228, 218, 18, 'PPL', 'P'),
(172401, 'Piper Crossing', 43.9688911437988, 0.767401918910265, -73.165283203125, -1.27697509004863, 218, 55, 'PPL', 'P'),
(172408, 'Piper Ridge', 43.1488914489746, 0.753090224370234, -72.8869400024414, -1.27211708474617, 218, 55, 'PPL', 'P'),
(184145, 'Pipers (historical)', 39.6819381713867, 0.692580474663516, -121.480560302734, -2.12023575445023, 218, 6, 'PPL', 'P'),
(89949, 'Pipers Chapel', 36.5716705322266, 0.63829606374194, -86.4816665649414, -1.50938982417012, 218, 50, 'PPL', 'P'),
(71287, 'Pipers Corner', 39.8327789306641, 0.695213142559114, -74.7836074829102, -1.30522017709585, 218, 37, 'PPL', 'P'),
(105293, 'Pipers Gap', 36.6441688537598, 0.639561398154864, -80.8422164916992, -1.41096285239021, 218, 53, 'PPL', 'P'),
(165984, 'Pipersville', 40.4252815246582, 0.705554263650919, -75.1397171020508, -1.31143546244788, 218, 45, 'PPL', 'P'),
(175853, 'Pipersville', 43.142219543457, 0.75297377765157, -88.6500015258789, -1.54723440852458, 218, 57, 'PPL', 'P'),
(89950, 'Piperton', 35.0449981689453, 0.61165060440348, -89.6216735839844, -1.56419328518815, 218, 50, 'PPL', 'P'),
(56917, 'Pipertown (historical)', 38.9602813720703, 0.679985187446041, -93.1291732788086, -1.62541070337553, 218, 29, 'PPL', 'P'),
(110916, 'Pipestem', 37.5444412231445, 0.655274115165359, -80.9602813720703, -1.41302347328366, 218, 58, 'PPL', 'P'),
(137502, 'Pipestone', 44.000560760498, 0.767954657994511, -96.3172225952148, -1.68105266066278, 218, 28, 'PPL', 'P'),
(197263, 'Pipestone', 45.896671295166, 0.801048029806217, -112.230560302734, -1.95879279864076, 218, 31, 'PPL', 'P'),
(197264, 'Pipestone Hot Springs', 45.8941688537598, 0.80100435396434, -112.230003356934, -1.95878307810278, 218, 31, 'PPL', 'P'),
(157153, 'Pipesville', 40.3505592346191, 0.704250113665107, -82.311393737793, -1.43660483262993, 218, 41, 'PPL', 'P'),
(13189, 'Pipetown (historical)', 38.8808288574219, 0.678598479466437, -76.9833297729492, -1.34361257368654, 218, 9, 'PPL', 'P'),
(67845, 'Pipkin Place', 36.4411087036133, 0.636017329955214, -76.9408264160156, -1.3428707501649, 218, 33, 'PPL', 'P'),
(37706, 'Pippa Passes', 37.3347206115723, 0.651613799984127, -82.8741683959961, -1.44642710336236, 218, 21, 'PPL', 'P'),
(89951, 'Pippen Springs Estates', 36.189998626709, 0.631634632328298, -85.5680618286133, -1.49344441345938, 218, 50, 'PPL', 'P'),
(11236, 'Pippin (historical)', 36.4938888549805, 0.636938517376273, -94.023063659668, -1.64101203367344, 218, 4, 'PPL', 'P'),
(184146, 'Pippin Corner', 35.2988891601563, 0.616081838141263, -120.40193939209, -2.10141026817863, 218, 6, 'PPL', 'P'),
(56919, 'Pippin Place', 37.8452796936035, 0.660524736991532, -92.25, -1.61006623496477, 218, 29, 'PPL', 'P'),
(178891, 'Pipyak', 32.3136100769043, 0.563978889047598, -111.788887023926, -1.95108414570747, 218, 5, 'PPL', 'P'),
(33629, 'Piqua', 37.922779083252, 0.661877356509183, -95.5350036621094, -1.66740036480865, 218, 20, 'PPL', 'P'),
(37708, 'Piqua', 38.4661102294922, 0.67136027393971, -84.045280456543, -1.46686686472872, 218, 21, 'PPL', 'P'),
(157154, 'Piqua', 40.144718170166, 0.70065750935459, -84.2425003051758, -1.47030900043765, 218, 41, 'PPL', 'P'),
(83043, 'Pirate Cove', 33.5847206115723, 0.58616395303434, -79.0019378662109, -1.37884393122136, 218, 48, 'PPL', 'P'),
(17641, 'Pirate Harbor', 26.8024997711182, 0.467791868771039, -82.045280456543, -1.43196027968883, 218, 12, 'PPL', 'P'),
(17642, 'Pirates Cove', 24.6505603790283, 0.430233441075706, -81.5152816772461, -1.42271005595855, 218, 12, 'PPL', 'P'),
(67847, 'Pireway', 34.0269393920898, 0.593882126768526, -78.6380615234375, -1.37249309096985, 218, 33, 'PPL', 'P'),
(105295, 'Pirkey', 38.273609161377, 0.668000496487494, -78.554443359375, -1.37103367869249, 218, 53, 'PPL', 'P'),
(23984, 'Pirkle Woods', 34.2236099243164, 0.597314675097529, -84.129997253418, -1.46834545176593, 218, 13, 'PPL', 'P'),
(11237, 'Pirlte (historical)', 33.3886108398438, 0.582741191822343, -92.2286071777344, -1.60969285977994, 218, 4, 'PPL', 'P'),
(76957, 'Pirtle', 33.9888916015625, 0.593218067550714, -96.2675018310547, -1.68018486962157, 218, 42, 'PPL', 'P'),
(97091, 'Pirtle', 32.3047218322754, 0.563823759914101, -94.8552780151367, -1.65553691425873, 218, 51, 'PPL', 'P'),
(178894, 'Pirtleville', 31.3569393157959, 0.547281834408696, -109.561111450195, -1.91220212695037, 218, 5, 'PPL', 'P'),
(184147, 'Piru', 34.4152793884277, 0.600659938321804, -118.793060302734, -2.07333003080289, 218, 6, 'PPL', 'P'),
(144322, 'Piscataqua', 43.1005592346191, 0.752246668094951, -70.793327331543, -1.23557665037752, 218, 36, 'PPL', 'P'),
(50442, 'Piscataway', 38.7005615234375, 0.675452220954617, -76.9725036621094, -1.3434236224072, 218, 25, 'PPL', 'P'),
(146047, 'Piscataway', 40.4991683959961, 0.706843832829762, -74.3994369506836, -1.29851513641936, 218, 37, 'PPL', 'P'),
(50444, 'Piscataway Estates', 38.7061080932617, 0.675549026860241, -76.9944381713867, -1.3438064518139, 218, 25, 'PPL', 'P'),
(50445, 'Piscataway Hills', 38.7075004577637, 0.675573328205188, -76.9977798461914, -1.34386477504177, 218, 25, 'PPL', 'P'),
(23985, 'Piscola', 30.6900005340576, 0.535641556758124, -83.6761093139648, -1.46042361278738, 218, 13, 'PPL', 'P'),
(151744, 'Piseco', 43.4483299255371, 0.758316411693405, -74.5188903808594, -1.30059999207873, 218, 40, 'PPL', 'P'),
(97093, 'Pisek', 29.9166698455811, 0.522144390037493, -96.5827789306641, -1.6856874930659, 218, 51, 'PPL', 'P'),
(140709, 'Pisek', 48.3108291625977, 0.843183033255824, -97.7088928222656, -1.70534188822679, 218, 34, 'PPL', 'P'),
(5098, 'Pisgah', 31.9966697692871, 0.558447237147395, -86.1183319091797, -1.50304843814048, 218, 2, 'PPL', 'P'),
(11239, 'Pisgah', 35.1474990844727, 0.61343958286574, -93.2236099243164, -1.62705893377418, 218, 4, 'PPL', 'P'),
(23987, 'Pisgah', 34.7252807617188, 0.606070482971437, -84.2816696166992, -1.47099263388947, 218, 13, 'PPL', 'P'),
(28275, 'Pisgah', 39.6686096191406, 0.692347847542298, -90.1255569458008, -1.57298770889787, 218, 18, 'PPL', 'P'),
(37707, 'Pisgah', 38.0566711425781, 0.664214213786701, -84.6549987792969, -1.47750845697051, 218, 21, 'PPL', 'P'),
(42594, 'Pisgah', 32.8600006103516, 0.573515202857981, -92.6338882446289, -1.61676634879324, 218, 22, 'PPL', 'P'),
(50446, 'Pisgah', 38.5461082458496, 0.672756502720212, -77.1350021362305, -1.34625975581008, 218, 25, 'PPL', 'P'),
(56918, 'Pisgah', 38.7763900756836, 0.676775678858332, -92.649169921875, -1.61703306437642, 218, 29, 'PPL', 'P'),
(61355, 'Pisgah', 32.4697189331055, 0.566703502579831, -89.870002746582, -1.5685274467042, 218, 30, 'PPL', 'P'),
(67848, 'Pisgah', 35.5497207641602, 0.620459675499189, -79.8713912963867, -1.39401875627069, 218, 33, 'PPL', 'P'),
(73929, 'Pisgah', 39.3183288574219, 0.686234294943912, -84.3688888549805, -1.47251489676856, 218, 41, 'PPL', 'P'),
(83038, 'Pisgah', 34.1427803039551, 0.595903932089086, -80.4858322143555, -1.40474277334822, 218, 48, 'PPL', 'P'),
(89955, 'Pisgah', 36.3794403076172, 0.634941013400659, -88.7174987792969, -1.54841245783278, 218, 50, 'PPL', 'P'),
(97092, 'Pisgah', 31.7055606842041, 0.553366425130228, -94.5227813720703, -1.64973375308539, 218, 51, 'PPL', 'P'),
(105296, 'Pisgah', 37.1208305358887, 0.647880713926108, -81.5736083984375, -1.42372804928523, 218, 53, 'PPL', 'P'),
(110917, 'Pisgah', 39.644718170166, 0.691930863094619, -79.7569427490234, -1.39202125229508, 218, 58, 'PPL', 'P'),
(117305, 'Pisgah', 41.8313903808594, 0.730095492833081, -95.9252777099609, -1.67421193192874, 218, 16, 'PPL', 'P'),
(184148, 'Pisgah', 34.7597198486328, 0.606671558429468, -116.354438781738, -2.03076805605151, 218, 6, 'PPL', 'P'),
(11240, 'Pisgah (historical)', 35.246940612793, 0.615175164948145, -93.0766677856445, -1.62449430964444, 218, 4, 'PPL', 'P'),
(23986, 'Pisgah Forest', 33.7975006103516, 0.589877664595428, -84.586669921875, -1.47631589343437, 218, 13, 'PPL', 'P'),
(67852, 'Pisgah Forest', 35.2541694641113, 0.615301332204788, -82.7002792358398, -1.44339216498411, 218, 33, 'PPL', 'P'),
(89956, 'Pisgah Heights', 35.0561103820801, 0.611844549109865, -90.0952835083008, -1.5724593377376, 218, 50, 'PPL', 'P'),
(132638, 'Pisgah Heights', 44.0944404602051, 0.769593167855182, -85.2261123657227, -1.48747626945651, 218, 27, 'PPL', 'P'),
(67850, 'Pisgah Shadows', 35.2733306884766, 0.615635758658674, -82.6269378662109, -1.44211211660616, 218, 33, 'PPL', 'P'),
(67851, 'Pisgah View', 35.5688896179199, 0.620794235111131, -82.5805587768555, -1.44130264879283, 218, 33, 'PPL', 'P'),
(142686, 'Pishelville', 42.7269401550293, 0.745725785007838, -98.2119369506836, -1.71412166455051, 218, 35, 'PPL', 'P'),
(128547, 'Pishon Ferry', 44.686939239502, 0.77993422236796, -69.6286087036133, -1.21524847546083, 218, 26, 'PPL', 'P'),
(178892, 'Pisinemo', 32.0377807617188, 0.559164759324089, -112.320281982422, -1.96035873736173, 218, 5, 'PPL', 'P'),
(178893, 'Pisinimo', 32.0349998474121, 0.559116223213222, -112.314437866211, -1.96025673829198, 218, 5, 'PPL', 'P'),
(184150, 'Pismo Beach', 35.1427803039551, 0.61335722460903, -120.640281677246, -2.10557012580133, 218, 6, 'PPL', 'P'),
(37709, 'Piso', 37.6358299255371, 0.656869148921235, -82.4674987792969, -1.43932937958314, 218, 21, 'PPL', 'P'),
(121053, 'Pistakee', 42.4116706848145, 0.74022329472157, -88.1999969482422, -1.53938034699578, 218, 18, 'PPL', 'P'),
(121054, 'Pistakee Highlands', 42.4086112976074, 0.740169898341714, -88.2063903808594, -1.53949193344545, 218, 18, 'PPL', 'P'),
(61356, 'Pistol Ridge', 31.003059387207, 0.541105464498098, -89.3180618286133, -1.55889426040917, 218, 30, 'PPL', 'P'),
(201407, 'Pistol River', 42.2772216796875, 0.737876716906074, -124.393608093262, -2.17107802966288, 218, 43, 'PPL', 'P'),
(140711, 'Pitcairn', 46.4277801513672, 0.810317628033429, -96.8422164916992, -1.6902155327093, 218, 34, 'PPL', 'P'),
(151745, 'Pitcairn', 44.1811103820801, 0.771105843354347, -75.2825012207031, -1.31392751543792, 218, 40, 'PPL', 'P'),
(165985, 'Pitcairn', 40.4030609130859, 0.705166440817176, -79.7783279418945, -1.39239449432185, 218, 45, 'PPL', 'P'),
(83042, 'Pitch Landing', 33.8002815246582, 0.589926200706295, -79.0552825927734, -1.37977497233846, 218, 48, 'PPL', 'P'),
(680, 'Pitcher', 38.7502784729004, 0.676319945416792, -91.9658279418945, -1.60510649690866, 218, 29, 'PPL', 'P'),
(151747, 'Pitcher', 42.5808296203613, 0.743175675106032, -75.8652801513672, -1.32409892658926, 218, 40, 'PPL', 'P'),
(151748, 'Pitcher Hill', 43.1152801513672, 0.752503596561117, -76.146110534668, -1.3290003414175, 218, 40, 'PPL', 'P'),
(151749, 'Pitcher Springs', 42.5988883972168, 0.743490860221043, -75.8208312988281, -1.32332314776372, 218, 40, 'PPL', 'P'),
(125830, 'Pitcherville', 42.5263900756836, 0.742225525808119, -72.0313873291016, -1.25718487367215, 218, 23, 'PPL', 'P'),
(121055, 'Pitcherville (historical)', 42.3644409179688, 0.739398979785164, -90.0016708374023, -1.57082548840883, 218, 18, 'PPL', 'P'),
(73909, 'Pitchin', 39.8427810668945, 0.695387712768569, -83.7624969482422, -1.46193136143853, 218, 41, 'PPL', 'P'),
(121056, 'Pitchin', 40.6030616760254, 0.70865711263697, -87.8663864135742, -1.53355774474648, 218, 18, 'PPL', 'P'),
(184151, 'Pitco', 36.3566703796387, 0.634543603186992, -119.662780761719, -2.08850951638412, 218, 6, 'PPL', 'P'),
(165987, 'Pithole City', 41.5208282470703, 0.724675161066443, -79.5872192382813, -1.38905901821458, 218, 45, 'PPL', 'P'),
(212091, 'Pitkas Point', 62.0327796936035, 1.08267624981766, -163.287780761719, -2.84990940256665, 218, 1, 'PPL', 'P'),
(42595, 'Pitkin', 30.9361095428467, 0.539936969280312, -92.9361114501953, -1.62204113880631, 218, 22, 'PPL', 'P'),
(187205, 'Pitkin', 38.6091690063477, 0.673857120619714, -106.51611328125, -1.85905688318507, 218, 7, 'PPL', 'P'),
(11241, 'Pitkin Corner', 35.8852806091309, 0.62631629963141, -94.1747207641602, -1.64365894948087, 218, 4, 'PPL', 'P'),
(339, 'Pitman', 36.478328704834, 0.636666941524112, -90.8225021362305, -1.58515169717681, 218, 4, 'PPL', 'P'),
(37710, 'Pitman', 37.378059387207, 0.652370204312737, -85.4894409179688, -1.49207221970772, 218, 21, 'PPL', 'P'),
(71288, 'Pitman', 39.732780456543, 0.693467839938731, -75.1319427490234, -1.31129977439034, 218, 37, 'PPL', 'P'),
(165991, 'Pitman', 40.7150001525879, 0.710610807612652, -76.521110534668, -1.33554532611247, 218, 45, 'PPL', 'P'),
(105297, 'Pitmans Corner', 37.6752815246582, 0.657557709221075, -76.4147186279297, -1.33368843704242, 218, 53, 'PPL', 'P'),
(128548, 'Pitmans Corner', 44.3074989318848, 0.77331173968526, -69.2441711425781, -1.20853877425243, 218, 26, 'PPL', 'P'),
(83044, 'Pitmon Crossroad', 34.582218170166, 0.603573569712406, -80.7822189331055, -1.40991569744959, 218, 48, 'PPL', 'P'),
(89957, 'Pitner (historical)', 35.8886108398438, 0.626374423122201, -83.7547225952148, -1.46179567338099, 218, 50, 'PPL', 'P'),
(97094, 'Pitner Junction', 32.2894401550293, 0.563557044330929, -94.8683319091797, -1.65576474768998, 218, 51, 'PPL', 'P'),
(178895, 'Pitoikam', 31.8111095428467, 0.555208600235263, -111.678886413574, -1.94916427287763, 218, 5, 'PPL', 'P'),
(42596, 'Pitreville', 30.4797191619873, 0.531971454459885, -92.2613906860352, -1.61026503994014, 218, 22, 'PPL', 'P'),
(171070, 'Pitrodie (historical)', 44.5722198486328, 0.777931991281411, -97.8472213745117, -1.707756176913, 218, 49, 'PPL', 'P'),
(73910, 'Pitsburg', 39.9874992370605, 0.697913521325427, -84.4875030517578, -1.47458510504193, 218, 41, 'PPL', 'P'),
(137505, 'Pitt', 48.7174987792969, 0.850280757035049, -94.7358322143555, -1.65345219175741, 218, 28, 'PPL', 'P'),
(208448, 'Pitt', 45.7958297729492, 0.799288013220811, -121.199722290039, -2.11533420646394, 218, 56, 'PPL', 'P'),
(78951, 'Pitt Gas', 39.9799995422363, 0.69778262695785, -80.0280609130859, -1.39675315691993, 218, 45, 'PPL', 'P'),
(11246, 'Pittinger', 35.4422187805176, 0.618583411932201, -90.9863891601563, -1.5880120653456, 218, 4, 'PPL', 'P'),
(17644, 'Pittman', 28.999719619751, 0.506140589519853, -81.6419372558594, -1.42492061282137, 218, 12, 'PPL', 'P'),
(23988, 'Pittman', 33.9719390869141, 0.592922190353606, -84.1697235107422, -1.46903880575573, 218, 13, 'PPL', 'P'),
(61357, 'Pittman', 33.9494400024414, 0.592529507250874, -89.4905624389648, -1.5619049640215, 218, 30, 'PPL', 'P'),
(110918, 'Pittman', 37.9555587768555, 0.66244947009036, -80.9211120605469, -1.41233983983184, 218, 58, 'PPL', 'P'),
(11242, 'Pittman (historical)', 36.4916687011719, 0.636899768382412, -90.7111129760742, -1.58320758958105, 218, 4, 'PPL', 'P'),
(89958, 'Pittman Center', 35.7591705322266, 0.624115263569487, -83.396110534668, -1.45553671218708, 218, 50, 'PPL', 'P'),
(83045, 'Pittman Corner', 34.3622207641602, 0.599733890631757, -79.2938919067383, -1.38393949049307, 218, 48, 'PPL', 'P'),
(105298, 'Pittmantown', 36.5680618286133, 0.63823307998216, -76.8191680908203, -1.34074741182778, 218, 53, 'PPL', 'P'),
(165988, 'Pittock', 40.4869384765625, 0.706630380468393, -80.084716796875, -1.39774198863268, 218, 45, 'PPL', 'P'),
(11243, 'Pitts', 35.6744384765625, 0.622636410216166, -91.0313873291016, -1.58879743155107, 218, 4, 'PPL', 'P'),
(23991, 'Pitts', 31.9444408416748, 0.557535670395774, -83.5408325195313, -1.45806258732297, 218, 13, 'PPL', 'P'),
(37711, 'Pitts', 37.709171295166, 0.658149197299181, -83.8838882446289, -1.46405003924374, 218, 21, 'PPL', 'P'),
(61358, 'Pitts', 31.1888904571533, 0.544348828521165, -90.4124984741211, -1.57799578332776, 218, 30, 'PPL', 'P'),
(165989, 'Pitts', 41.7441711425781, 0.728573229953992, -77.2702789306641, -1.34862078127449, 218, 45, 'PPL', 'P'),
(37714, 'Pitts Point', 37.9166717529297, 0.661770763486553, -85.8261108398438, -1.49794821833687, 218, 21, 'PPL', 'P'),
(30845, 'Pittsboro', 39.8638916015625, 0.695756161105381, -86.4669418334961, -1.50913282912493, 218, 19, 'PPL', 'P'),
(61359, 'Pittsboro', 33.9402809143066, 0.592369651006442, -89.3375015258789, -1.55923354713205, 218, 30, 'PPL', 'P'),
(67854, 'Pittsboro', 35.7200012207031, 0.623431630117663, -79.1774978637695, -1.38190803121356, 218, 33, 'PPL', 'P'),
(5099, 'Pittsburg', 34.5252799987793, 0.602579811151643, -87.2058334350586, -1.52202892038753, 218, 2, 'PPL', 'P'),
(17661, 'Pittsburg', 27.6536102294922, 0.482646548567823, -81.5027770996094, -1.42249180990722, 218, 12, 'PPL', 'P'),
(23992, 'Pittsburg', 33.8805618286133, 0.591327356334812, -84.2194366455078, -1.46990646363888, 218, 13, 'PPL', 'P'),
(28267, 'Pittsburg', 37.7769393920898, 0.659331973718313, -88.8494415283203, -1.55071529322737, 218, 18, 'PPL', 'P'),
(33630, 'Pittsburg', 37.410831451416, 0.652942184735859, -94.704719543457, -1.65290917321115, 218, 20, 'PPL', 'P'),
(37712, 'Pittsburg', 37.1599998474121, 0.648564347377932, -84.1041717529297, -1.46789471175143, 218, 21, 'PPL', 'P'),
(56920, 'Pittsburg', 37.8338890075684, 0.660325932016158, -93.3002777099609, -1.62839703906389, 218, 29, 'PPL', 'P'),
(67855, 'Pittsburg', 35.8250007629395, 0.625264217842774, -80.7005615234375, -1.40849050679224, 218, 33, 'PPL', 'P'),
(76959, 'Pittsburg', 34.7130584716797, 0.605857163768121, -95.8497161865234, -1.67289313455694, 218, 42, 'PPL', 'P'),
(83046, 'Pittsburg', 33.9866714477539, 0.593179318556854, -82.0033264160156, -1.43122804354711, 218, 48, 'PPL', 'P'),
(97095, 'Pittsburg', 32.9952812194824, 0.575876294901418, -94.9655609130859, -1.65746171393658, 218, 51, 'PPL', 'P'),
(117307, 'Pittsburg', 40.7463912963867, 0.711158686427909, -91.9916687011719, -1.60555750323926, 218, 16, 'PPL', 'P'),
(123447, 'Pittsburg', 40.5927810668945, 0.708477682158526, -86.7016677856445, -1.5132295698298, 218, 19, 'PPL', 'P'),
(132639, 'Pittsburg', 42.8925018310547, 0.748615381369601, -84.2219390869141, -1.46995013948076, 218, 27, 'PPL', 'P'),
(144323, 'Pittsburg', 45.0511093139648, 0.78629018920457, -71.3919372558594, -1.24602436449195, 218, 36, 'PPL', 'P'),
(184152, 'Pittsburg', 38.0280609130859, 0.663714871082311, -121.883613586426, -2.12727036131162, 218, 6, 'PPL', 'P'),
(187207, 'Pittsburg', 38.952220916748, 0.679844505961458, -107.061943054199, -1.86858340987845, 218, 7, 'PPL', 'P'),
(192749, 'Pittsburg', 38.5052795410156, 0.672043907391534, -112.258613586426, -1.95928242080717, 218, 52, 'PPL', 'P'),
(201408, 'Pittsburg', 45.9008293151855, 0.801120600945922, -123.151107788086, -2.14939230838053, 218, 43, 'PPL', 'P'),
(89959, 'Pittsburg Landing', 35.1522216796875, 0.613522007701478, -88.3227767944336, -1.54152325956691, 218, 50, 'PPL', 'P'),
(140779, 'Pittsburgh', 48.6294403076172, 0.848743846769964, -97.1777801513672, -1.69607222342055, 218, 34, 'PPL', 'P'),
(165990, 'Pittsburgh', 40.440559387207, 0.705820912655063, -79.9961090087891, -1.39619549098767, 218, 45, 'PPL', 'P'),
(200130, 'Pittsburgh (historical)', 40.4286117553711, 0.70561238714171, -116.821388244629, -2.03891786161937, 218, 39, 'PPL', 'P'),
(157156, 'Pittsburgh Junction', 40.3319396972656, 0.70392514143309, -80.9508285522461, -1.41285849045413, 218, 41, 'PPL', 'P'),
(28268, 'Pittsfield', 39.607780456543, 0.691286178373738, -90.8050003051758, -1.58484623259977, 218, 18, 'PPL', 'P'),
(125831, 'Pittsfield', 42.4500007629395, 0.740892280787398, -73.2458267211914, -1.27838083963003, 218, 23, 'PPL', 'P'),
(128549, 'Pittsfield', 44.7825012207031, 0.781602093579649, -69.3838882446289, -1.21097729770456, 218, 26, 'PPL', 'P'),
(132640, 'Pittsfield', 42.2102813720703, 0.736708388135857, -83.7241668701172, -1.4612623753727, 218, 27, 'PPL', 'P'),
(144325, 'Pittsfield', 43.3058280944824, 0.75582928555138, -71.3247222900391, -1.24485124203177, 218, 36, 'PPL', 'P'),
(151751, 'Pittsfield', 42.6386108398438, 0.744184147631818, -75.2816696166992, -1.31391300120998, 218, 40, 'PPL', 'P'),
(157157, 'Pittsfield', 41.2369384765625, 0.71972034985835, -82.2191696166992, -1.43499521806709, 218, 41, 'PPL', 'P'),
(165993, 'Pittsfield', 41.8355598449707, 0.730168263709867, -79.3816680908203, -1.38547147391014, 218, 45, 'PPL', 'P'),
(172402, 'Pittsfield', 43.7722206115723, 0.763969370581262, -72.8133316040039, -1.27083237583631, 218, 55, 'PPL', 'P'),
(175854, 'Pittsfield', 44.5994415283203, 0.778407099219881, -88.245002746582, -1.5401658463593, 218, 57, 'PPL', 'P'),
(132642, 'Pittsford', 41.8622207641602, 0.730633584531331, -84.476936340332, -1.47440068113644, 218, 27, 'PPL', 'P'),
(151753, 'Pittsford', 43.0905609130859, 0.752072164464524, -77.5152816772461, -1.35289688587878, 218, 40, 'PPL', 'P'),
(172404, 'Pittsford', 43.7066688537598, 0.762825276576964, -73.0286102294922, -1.27458969666025, 218, 55, 'PPL', 'P'),
(128551, 'Pittston', 44.2216682434082, 0.77181371157209, -69.7561111450195, -1.2174738128677, 218, 26, 'PPL', 'P'),
(165995, 'Pittston', 41.3258285522461, 0.721271774351376, -75.7897186279297, -1.32278012921745, 218, 45, 'PPL', 'P'),
(11245, 'Pittston Junction', 35.6488914489746, 0.622190530470659, -93.7311096191406, -1.63591647440173, 218, 4, 'PPL', 'P'),
(165996, 'Pittston Junction', 41.3416709899902, 0.721548277051553, -75.7861099243164, -1.32271714545767, 218, 45, 'PPL', 'P'),
(146049, 'Pittstown', 40.5819396972656, 0.708288464563076, -74.9594421386719, -1.308289070778, 218, 37, 'PPL', 'P'),
(151755, 'Pittstown', 42.8349990844727, 0.747611769112804, -73.4855575561523, -1.28256493201866, 218, 40, 'PPL', 'P'),
(5100, 'Pittsview', 32.188060760498, 0.561787640102681, -85.163330078125, -1.486380511826, 218, 2, 'PPL', 'P'),
(50447, 'Pittsville', 38.3952789306641, 0.670124034561695, -75.413330078125, -1.31621090975655, 218, 25, 'PPL', 'P'),
(56921, 'Pittsville', 38.8505592346191, 0.678070174885192, -93.9899978637695, -1.64043492666522, 218, 29, 'PPL', 'P'),
(97096, 'Pittsville', 30.0636100769043, 0.524708980877726, -95.2427825927734, -1.66230014500504, 218, 51, 'PPL', 'P'),
(105300, 'Pittsville', 36.9816703796387, 0.645451911011956, -79.4622192382813, -1.38687735664959, 218, 53, 'PPL', 'P'),
(165999, 'Pittsville', 41.2561111450195, 0.720054976049319, -79.7408294677734, -1.39174002248396, 218, 45, 'PPL', 'P'),
(175856, 'Pittsville', 44.4391708374023, 0.775609847968917, -90.1244430541992, -1.57296826782191, 218, 57, 'PPL', 'P'),
(166000, 'Pittville', 40.0572204589844, 0.699130386206512, -75.1449966430664, -1.31152760782159, 218, 45, 'PPL', 'P'),
(193880, 'Pittville', 41.0486106872559, 0.716433409861947, -121.33332824707, -2.11766607031442, 218, 6, 'PPL', 'P'),
(121057, 'Pittwood', 40.8608283996582, 0.713155990666441, -87.7294387817383, -1.53116755766814, 218, 18, 'PPL', 'P'),
(117309, 'Pitzer', 41.3738899230957, 0.722110603515724, -94.1855621337891, -1.64384816707632, 218, 16, 'PPL', 'P'),
(200131, 'Piute', 40.6963882446289, 0.71028596853869, -117.001670837402, -2.0420643864473, 218, 39, 'PPL', 'P'),
(184153, 'Piute (historical)', 35.4000015258789, 0.617846581837604, -118.400001525879, -2.0664698609929, 218, 6, 'PPL', 'P'),
(178896, 'Pivahn-hon-kya-pi', 35.8894386291504, 0.626388870771114, -110.698890686035, -1.9320601207766, 218, 5, 'PPL', 'P'),
(33633, 'Pixley', 37.2519416809082, 0.650169035092759, -98.5133285522461, -1.71938194033563, 218, 20, 'PPL', 'P'),
(184154, 'Pixley', 35.9686088562012, 0.627770651902702, -119.290832519531, -2.08201779491094, 218, 6, 'PPL', 'P'),
(105302, 'Pizarro', 36.9377784729004, 0.644685852724395, -80.2205581665039, -1.40011286779312, 218, 53, 'PPL', 'P'),
(208449, 'Pizarro', 46.9500007629395, 0.819432097127143, -118.444999694824, -2.06725522719836, 218, 56, 'PPL', 'P'),
(184157, 'Pizona', 37.9716682434082, 0.662730633322445, -118.557220458984, -2.06921384902206, 218, 6, 'PPL', 'P'),
(144327, 'Place', 43.3525009155273, 0.756643879949808, -71.0261077880859, -1.23963943577849, 218, 36, 'PPL', 'P'),
(151768, 'Place Corners', 42.3669395446777, 0.739442589048014, -73.991943359375, -1.29140303157025, 218, 40, 'PPL', 'P'),
(97097, 'Placedo', 28.6911106109619, 0.500754346215167, -96.8277816772461, -1.68996359767018, 218, 51, 'PPL', 'P'),
(184156, 'Placentia', 33.8722190856934, 0.591181748002212, -117.869438171387, -2.05720978356658, 218, 6, 'PPL', 'P'),
(201409, 'Placer', 42.6322212219238, 0.744072627761171, -123.314170837402, -2.15223829547944, 218, 43, 'PPL', 'P'),
(200132, 'Placerites', 40.6716690063477, 0.709854536442097, -118.672782897949, -2.07123079407363, 218, 39, 'PPL', 'P'),
(184159, 'Placerville', 38.7297210693359, 0.675961151038931, -120.797500610352, -2.10831411383049, 218, 6, 'PPL', 'P'),
(187211, 'Placerville', 38.0166702270508, 0.663516066106936, -108.052780151367, -1.88587677957493, 218, 7, 'PPL', 'P'),
(195474, 'Placerville', 43.9433288574219, 0.76695577284865, -115.946113586426, -2.02364143697446, 218, 17, 'PPL', 'P'),
(169547, 'Places Corner', 41.6247215270996, 0.72648844087365, -71.5124969482422, -1.24812852806922, 218, 47, 'PPL', 'P'),
(97098, 'Placid', 31.3252792358398, 0.546729261772019, -99.1841735839844, -1.73109039491011, 218, 51, 'PPL', 'P'),
(42598, 'Placid (historical)', 32.7625007629395, 0.571813509500448, -93.3930587768555, -1.63001637416472, 218, 22, 'PPL', 'P'),
(17645, 'Placid Lakes', 27.2411098480225, 0.475447058745444, -81.4072189331055, -1.42082400527456, 218, 12, 'PPL', 'P'),
(73911, 'Placid Meadows', 39.1011085510254, 0.682443085395102, -84.6097183227539, -1.47671816391703, 218, 41, 'PPL', 'P'),
(17646, 'Placida', 26.8319396972656, 0.468305692413856, -82.2649993896484, -1.43579509850049, 218, 12, 'PPL', 'P'),
(187208, 'Placita', 39.1322212219238, 0.682986103941369, -107.262222290039, -1.87207894196723, 218, 7, 'PPL', 'P'),
(192947, 'Placitas', 32.6650009155273, 0.570111816142914, -107.168060302734, -1.87043550525855, 218, 38, 'PPL', 'P'),
(189247, 'Placitas Homesteads', 35.3080596923828, 0.616241894122776, -106.489723205566, -1.85859628947454, 218, 38, 'PPL', 'P'),
(56922, 'Plad', 37.7486114501953, 0.65883755786194, -92.9752807617188, -1.62272477225813, 218, 29, 'PPL', 'P'),
(89960, 'Plada Heights', 35.0713882446289, 0.612111198114009, -86.5694427490234, -1.51092180758719, 218, 50, 'PPL', 'P'),
(144328, 'Plaice Cove', 42.9469413757324, 0.749565530667514, -70.7891693115234, -1.23550407923781, 218, 36, 'PPL', 'P'),
(713, 'Plain', 32.2316703796387, 0.562548771542225, -90.1616668701172, -1.57361794596984, 218, 30, 'PPL', 'P'),
(97099, 'Plain', 31.4514102935791, 0.548930664018592, -95.1100692749023, -1.65998386064694, 218, 51, 'PPL', 'P'),
(125833, 'Plain', 42.4833297729492, 0.741473981748499, -71.3722229003906, -1.24568028407911, 218, 23, 'PPL', 'P'),
(157159, 'Plain', 40.8283309936523, 0.712588803933282, -81.3158264160156, -1.41922890493965, 218, 41, 'PPL', 'P'),
(175858, 'Plain', 43.2788887023926, 0.755359104460927, -90.0436096191406, -1.57155745823444, 218, 57, 'PPL', 'P'),
(208450, 'Plain', 47.7627792358398, 0.833617757568586, -120.656112670898, -2.10584642876443, 218, 56, 'PPL', 'P'),
(189248, 'Plain (historical)', 34.836669921875, 0.608014590567195, -103.547500610352, -1.80724481786147, 218, 38, 'PPL', 'P'),
(157160, 'Plain City', 40.1074981689453, 0.700007897785693, -83.2675018310547, -1.45329206686231, 218, 41, 'PPL', 'P'),
(205384, 'Plain City', 41.2980613708496, 0.720787145612009, -112.08528137207, -1.95625720296689, 218, 52, 'PPL', 'P'),
(42599, 'Plain Dealing', 32.9049987792969, 0.574300569063445, -93.6966705322266, -1.6353153989437, 218, 22, 'PPL', 'P'),
(89961, 'Plain Grove', 36.5194396972656, 0.637384463700806, -85.2291717529297, -1.48752966583637, 218, 50, 'PPL', 'P'),
(166001, 'Plain Grove', 41.0541687011719, 0.716530415504653, -80.1430587768555, -1.39876024827547, 218, 45, 'PPL', 'P'),
(5101, 'Plain View', 33.5744400024414, 0.585984522555896, -86.7713928222656, -1.51444650128991, 218, 2, 'PPL', 'P'),
(11287, 'Plain View', 34.3013916015625, 0.598672221463197, -92.1041717529297, -1.60752105191098, 218, 4, 'PPL', 'P'),
(67857, 'Plain View', 35.2483291625977, 0.615199399714065, -78.5555572509766, -1.37105311976845, 218, 33, 'PPL', 'P'),
(105308, 'Plain View', 37.4958305358887, 0.654425698621087, -76.6680603027344, -1.33811008340028, 218, 53, 'PPL', 'P'),
(42600, 'Plaincourtville', 29.9891700744629, 0.52340975773993, -91.0586090087891, -1.58927253948954, 218, 22, 'PPL', 'P'),
(151757, 'Plainedge', 40.7172203063965, 0.710649556606513, -73.4841690063477, -1.28254069725274, 218, 40, 'PPL', 'P'),
(11247, 'Plainfield', 33.047779083252, 0.57679255547446, -93.3186111450195, -1.62871701786887, 218, 4, 'PPL', 'P'),
(23994, 'Plainfield', 32.2886085510254, 0.563542530102989, -83.1122207641602, -1.45058190097899, 218, 13, 'PPL', 'P'),
(50449, 'Plainfield', 38.3847198486328, 0.669939743814262, -75.5136108398438, -1.31796113922495, 218, 25, 'PPL', 'P'),
(89962, 'Plainfield', 35.769718170166, 0.624299354579838, -83.9588928222656, -1.46535911607757, 218, 50, 'PPL', 'P'),
(113916, 'Plainfield', 41.6763916015625, 0.727390253797778, -71.9155578613281, -1.25516326808867, 218, 8, 'PPL', 'P'),
(117310, 'Plainfield', 42.8474998474121, 0.747829948585109, -92.5369415283203, -1.61507430939466, 218, 16, 'PPL', 'P'),
(121059, 'Plainfield', 41.6269416809082, 0.726527189867511, -88.2038879394531, -1.53944825760357, 218, 18, 'PPL', 'P'),
(123449, 'Plainfield', 41.7080612182617, 0.727942992882024, -86.4766693115234, -1.50930260564442, 218, 19, 'PPL', 'P'),
(125835, 'Plainfield', 41.2750015258789, 0.72038467539227, -69.9833297729492, -1.22143952604694, 218, 23, 'PPL', 'P'),
(132644, 'Plainfield', 42.496940612793, 0.741711535717734, -84.1074981689453, -1.4679527686632, 218, 27, 'PPL', 'P'),
(144329, 'Plainfield', 43.5341682434082, 0.759814572964629, -72.3566665649414, -1.26286206732592, 218, 36, 'PPL', 'P'),
(146050, 'Plainfield', 40.6336097717285, 0.709190277487204, -74.4077835083008, -1.29866081133099, 218, 37, 'PPL', 'P'),
(157165, 'Plainfield', 40.2094383239746, 0.701787089130947, -81.7197189331055, -1.42627815918704, 218, 41, 'PPL', 'P'),
(166004, 'Plainfield', 40.1697196960449, 0.7010938682992, -76.7647171020508, -1.33979706279279, 218, 45, 'PPL', 'P'),
(172406, 'Plainfield', 44.2780609130859, 0.772797949331956, -72.4269409179688, -1.26408858616596, 218, 55, 'PPL', 'P'),
(175860, 'Plainfield', 44.2138900756836, 0.771677956935524, -89.4922180175781, -1.56193385931933, 218, 57, 'PPL', 'P'),
(184160, 'Plainfield', 38.5908317565918, 0.673537075235714, -121.795829772949, -2.1257382447365, 218, 6, 'PPL', 'P'),
(151758, 'Plainfield Center', 42.8402786254883, 0.747703914486521, -75.1747207641602, -1.31204639160194, 218, 40, 'PPL', 'P'),
(105304, 'Plainfield Heights', 39.1358299255371, 0.68304908770115, -78.1930618286133, -1.3647263811248, 218, 53, 'PPL', 'P'),
(89963, 'Plainfield Subdivision', 35.0722198486328, 0.61212571234195, -86.5658264160156, -1.51085869066936, 218, 50, 'PPL', 'P'),
(17647, 'Plains', 27.4091701507568, 0.478380264370057, -81.184440612793, -1.41693579008304, 218, 12, 'PPL', 'P'),
(23995, 'Plains', 32.0338897705078, 0.559096848716292, -84.3927764892578, -1.47293181463721, 218, 13, 'PPL', 'P'),
(42601, 'Plains', 30.6900005340576, 0.535641556758124, -91.2055587768555, -1.59183729677734, 218, 22, 'PPL', 'P'),
(132647, 'Plains', 46.3255615234375, 0.808533576419185, -87.4047164916992, -1.52550008455234, 218, 27, 'PPL', 'P'),
(146052, 'Plains', 41.1405601501465, 0.718038230734829, -74.7022171020508, -1.3037996469704, 218, 37, 'PPL', 'P'),
(166006, 'Plains', 41.2752799987793, 0.72038953566126, -75.8505630493164, -1.32384206470212, 218, 45, 'PPL', 'P'),
(187848, 'Plains', 37.2602806091309, 0.650314576846332, -100.592216491699, -1.75566537965909, 218, 20, 'PPL', 'P'),
(192050, 'Plains', 33.1886100769043, 0.579250520002548, -102.827499389648, -1.79467842594182, 218, 51, 'PPL', 'P'),
(197265, 'Plains', 47.4602813720703, 0.828338173865559, -114.881942749023, -2.00506815205808, 218, 31, 'PPL', 'P'),
(184161, 'Plains (historical)', 37.023609161377, 0.646183880837564, -120.34806060791, -2.10046990599772, 218, 6, 'PPL', 'P'),
(192051, 'Plains Assembly', 33.8866691589355, 0.591433949357443, -101.338890075684, -1.76869729213728, 218, 51, 'PPL', 'P'),
(192052, 'Plains Junction', 34.5580596923828, 0.603151924732819, -100.436111450195, -1.75294083270589, 218, 51, 'PPL', 'P'),
(105306, 'Plains Mill', 38.646671295166, 0.674511659036628, -78.7194366455078, -1.37391335477919, 218, 53, 'PPL', 'P'),
(146053, 'Plainsboro', 40.3333282470703, 0.70394937619901, -74.600830078125, -1.3020301095841, 218, 37, 'PPL', 'P'),
(146054, 'Plainsboro Center', 40.3316688537598, 0.703920414322155, -74.5950012207031, -1.30192837683046, 218, 37, 'PPL', 'P'),
(184162, 'Plainsburg', 37.2330589294434, 0.649839468907862, -120.323333740234, -2.10003834074307, 218, 6, 'PPL', 'P'),
(157166, 'Plainsburg (historical)', 40.6502799987793, 0.709481227836295, -81.6066665649414, -1.4243050231354, 218, 41, 'PPL', 'P'),
(166008, 'Plainsville', 41.2902793884277, 0.720651324396415, -75.8499984741211, -1.32383221100609, 218, 45, 'PPL', 'P'),
(5104, 'Plainview', 34.4830589294434, 0.601842914478018, -85.820556640625, -1.49785127927319, 218, 2, 'PPL', 'P'),
(11251, 'Plainview', 34.9894409179688, 0.610680947450582, -93.2972183227539, -1.62834364268404, 218, 4, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(23998, 'Plainview', 34.8777809143066, 0.608732112743889, -84.9444427490234, -1.48256020724228, 218, 13, 'PPL', 'P'),
(28272, 'Plainview', 39.1591682434082, 0.683456418189877, -89.9897232055664, -1.57061696289548, 218, 18, 'PPL', 'P'),
(42603, 'Plainview', 30.7513904571533, 0.53671301304369, -89.9688873291016, -1.57025330824863, 218, 22, 'PPL', 'P'),
(56925, 'Plainview', 36.6650009155273, 0.639924986222687, -94.2958297729492, -1.64577270043806, 218, 29, 'PPL', 'P'),
(61360, 'Plainview', 32.2041702270508, 0.562068803334766, -90.154167175293, -1.57348705160226, 218, 30, 'PPL', 'P'),
(73912, 'Plainview', 39.6788902282715, 0.692527278020742, -81.1055603027344, -1.41555906895752, 218, 41, 'PPL', 'P'),
(76963, 'Plainview', 36.8411102294922, 0.642998673594802, -99.2408294677734, -1.73207922662286, 218, 42, 'PPL', 'P'),
(78952, 'Plainview', 39.9261093139648, 0.696842065039861, -77.164436340332, -1.34677347958436, 218, 45, 'PPL', 'P'),
(89965, 'Plainview', 35.6997184753418, 0.623077629429764, -86.3450012207031, -1.50700456393979, 218, 50, 'PPL', 'P'),
(105307, 'Plainview', 37.3241691589355, 0.651429642394748, -80.0272216796875, -1.39673850953393, 218, 53, 'PPL', 'P'),
(117311, 'Plainview', 41.6683311462402, 0.727249572313195, -90.7825012207031, -1.58445354949704, 218, 16, 'PPL', 'P'),
(137506, 'Plainview', 44.1650009155273, 0.770824680122262, -92.17138671875, -1.60869417437116, 218, 28, 'PPL', 'P'),
(142679, 'Plainview', 42.3497200012207, 0.739142051318998, -97.7916717529297, -1.70678665311816, 218, 35, 'PPL', 'P'),
(151760, 'Plainview', 40.7763900756836, 0.711682263898219, -73.4677810668945, -1.28225467375166, 218, 40, 'PPL', 'P'),
(184163, 'Plainview', 36.1441688537598, 0.630834751894893, -119.133056640625, -2.0792640863438, 218, 6, 'PPL', 'P'),
(187209, 'Plainview', 39.8936080932617, 0.696274811727674, -105.275833129883, -1.83740991089658, 218, 7, 'PPL', 'P'),
(192053, 'Plainview', 34.1847190856934, 0.596635901914695, -101.706390380859, -1.77511138246469, 218, 51, 'PPL', 'P'),
(202491, 'Plainview', 44.6022186279297, 0.778455568751721, -102.161109924316, -1.78304773567118, 218, 49, 'PPL', 'P'),
(201410, 'Plainview (historical)', 45.6061096191406, 0.795976771879461, -122.873611450195, -2.14454908362211, 218, 43, 'PPL', 'P'),
(171073, 'Plainview Colony', 45.5816688537598, 0.795550200051858, -99.0061111450195, -1.72798261907604, 218, 49, 'PPL', 'P'),
(50450, 'Plainview Gardens', 38.5008316040039, 0.671966276245758, -76.7897186279297, -1.3402334217374, 218, 25, 'PPL', 'P'),
(83047, 'Plainview Heights', 34.8205604553223, 0.607733427335109, -82.4716720581055, -1.43940221703895, 218, 48, 'PPL', 'P'),
(89966, 'Plainview Heights', 35.350830078125, 0.616988378176326, -86.1936111450195, -1.50436230866427, 218, 50, 'PPL', 'P'),
(23999, 'Plainville', 34.4049987792969, 0.60048050784336, -85.0372161865234, -1.48417940918505, 218, 13, 'PPL', 'P'),
(28273, 'Plainville', 39.785831451416, 0.694393754470724, -91.1852798461914, -1.59148336266847, 218, 18, 'PPL', 'P'),
(30847, 'Plainville', 38.8061103820801, 0.677294396059652, -87.1522216796875, -1.52109321873853, 218, 19, 'PPL', 'P'),
(33635, 'Plainville', 39.2347183227539, 0.684775015824603, -99.2977828979492, -1.73307325149973, 218, 20, 'PPL', 'P'),
(73913, 'Plainville', 39.1419410705566, 0.683155747302807, -84.3600006103516, -1.47235976763506, 218, 41, 'PPL', 'P'),
(113918, 'Plainville', 41.6744384765625, 0.727356165335825, -72.8586120605469, -1.27162266888979, 218, 8, 'PPL', 'P'),
(125840, 'Plainville', 42.0041694641113, 0.733111056714405, -71.3333282470703, -1.24500144431725, 218, 23, 'PPL', 'P'),
(146056, 'Plainville', 40.4661102294922, 0.706266858979597, -74.682502746582, -1.30345556655756, 218, 37, 'PPL', 'P'),
(151761, 'Plainville', 43.1591682434082, 0.753269588269651, -76.4475021362305, -1.33426061720262, 218, 40, 'PPL', 'P'),
(166009, 'Plainville', 40.2658309936523, 0.702771326890813, -76.5755615234375, -1.33649567514747, 218, 45, 'PPL', 'P'),
(175863, 'Plainville', 43.7088890075684, 0.762864025570825, -89.8125, -1.56752383444741, 218, 57, 'PPL', 'P'),
(125841, 'Plainville (historical)', 42.2125015258789, 0.736747137129717, -72.5749969482422, -1.26667265137166, 218, 23, 'PPL', 'P'),
(132648, 'Plainwell', 42.439998626709, 0.740717710577944, -85.6488876342773, -1.4948550898888, 218, 27, 'PPL', 'P'),
(61361, 'Plairs', 33.5422210693359, 0.585422196091725, -88.8597183227539, -1.55089465712679, 218, 30, 'PPL', 'P'),
(42604, 'Plaisance', 30.6122207641602, 0.534284043681969, -92.126106262207, -1.60790388131768, 218, 22, 'PPL', 'P'),
(128553, 'Plaisted', 47.0977783203125, 0.822011302063858, -68.5908279418945, -1.19713578425499, 218, 26, 'PPL', 'P'),
(144331, 'Plaistow', 42.8363914489746, 0.747636070457751, -71.0952835083008, -1.24084677985867, 218, 36, 'PPL', 'P'),
(171075, 'Plana', 45.5191688537598, 0.794459369269361, -98.3088912963867, -1.71581383710715, 218, 49, 'PPL', 'P'),
(184168, 'Planada', 37.290828704834, 0.650847741696566, -120.317497253418, -2.09993647483138, 218, 6, 'PPL', 'P'),
(151762, 'Plandome', 40.8066711425781, 0.712210768216545, -73.7038879394531, -1.2863755160644, 218, 40, 'PPL', 'P'),
(151763, 'Plandome Heights', 40.8025016784668, 0.712137997339758, -73.704719543457, -1.28639003029234, 218, 40, 'PPL', 'P'),
(151764, 'Plandome Manor', 40.8161087036133, 0.712375484729966, -73.6977767944336, -1.28626885646274, 218, 40, 'PPL', 'P'),
(166010, 'Plane Bank', 40.4091682434082, 0.705273033839807, -78.629997253418, -1.37235234290624, 218, 45, 'PPL', 'P'),
(166011, 'Planebrook', 40.0394401550293, 0.69882006136049, -75.5741729736328, -1.31901814786161, 218, 45, 'PPL', 'P'),
(192054, 'Planeport', 31.8261108398438, 0.555470422259931, -106.434173583984, -1.8576267656797, 218, 51, 'PPL', 'P'),
(178897, 'Planet', 34.247501373291, 0.597731659545208, -113.964172363281, -1.98905003704959, 218, 5, 'PPL', 'P'),
(37713, 'Plank', 37.0761108398438, 0.647100207989633, -83.6469421386719, -1.45991454954501, 218, 21, 'PPL', 'P'),
(166012, 'Plank', 41.5711097717285, 0.725552739224651, -77.2463912963867, -1.34820386340584, 218, 45, 'PPL', 'P'),
(171076, 'Plankinton', 43.7155609130859, 0.762980472289488, -98.4847183227539, -1.71888259763124, 218, 49, 'PPL', 'P'),
(157167, 'Plankton', 40.9577789306641, 0.71484809664405, -83.0938873291016, -1.45026192217402, 218, 41, 'PPL', 'P'),
(157168, 'Planktown', 40.9575004577637, 0.714843236375061, -82.5858306884766, -1.44139466100849, 218, 41, 'PPL', 'P'),
(5105, 'Plano', 34.1141700744629, 0.595404589384697, -85.7275009155273, -1.49622715048241, 218, 2, 'PPL', 'P'),
(30848, 'Plano', 39.4991683959961, 0.689390540309819, -86.603889465332, -1.51152301620328, 218, 19, 'PPL', 'P'),
(37717, 'Plano', 36.8802795410156, 0.643682307046626, -86.418327331543, -1.50828434600163, 218, 21, 'PPL', 'P'),
(56926, 'Plano', 37.1927795410156, 0.649136460959108, -93.5508270263672, -1.6327699495738, 218, 29, 'PPL', 'P'),
(73914, 'Plano', 39.4908294677734, 0.689244998556246, -83.2866668701172, -1.45362655989523, 218, 41, 'PPL', 'P'),
(97106, 'Plano', 33.019718170166, 0.576302800149994, -96.6986083984375, -1.68770909864938, 218, 51, 'PPL', 'P'),
(117313, 'Plano', 40.7555618286133, 0.711318742409423, -93.04638671875, -1.62396580532611, 218, 16, 'PPL', 'P'),
(121061, 'Plano', 41.6627807617188, 0.727152699828543, -88.5369415283203, -1.54526113931489, 218, 18, 'PPL', 'P'),
(171079, 'Plano', 43.8061103820801, 0.764560858659369, -97.9222183227539, -1.70906512058878, 218, 49, 'PPL', 'P'),
(184164, 'Plano', 36.0436096191406, 0.629079662157503, -119.007499694824, -2.07707270424083, 218, 6, 'PPL', 'P'),
(195475, 'Plano', 43.8911094665527, 0.766044372544597, -111.890830993652, -1.95286340363175, 218, 17, 'PPL', 'P'),
(11252, 'Plant', 35.7236099243164, 0.623494613877444, -92.4602813720703, -1.61373633726301, 218, 4, 'PPL', 'P'),
(89967, 'Plant', 36.0163917541504, 0.62860462079806, -87.9124984741211, -1.5343625520279, 218, 50, 'PPL', 'P'),
(5106, 'Plant City', 32.8530616760254, 0.57339409560741, -85.1908264160156, -1.48686041345443, 218, 2, 'PPL', 'P'),
(17648, 'Plant City', 28.0183296203613, 0.489012102784358, -82.1130599975586, -1.43314325584504, 218, 12, 'PPL', 'P'),
(17651, 'Plantation', 27.0677795410156, 0.472421874194682, -82.3730621337891, -1.43768114918449, 218, 12, 'PPL', 'P'),
(37715, 'Plantation', 38.2833290100098, 0.668170139848932, -85.5911102294922, -1.49384668394204, 218, 21, 'PPL', 'P'),
(61362, 'Plantation', 33.0972213745117, 0.577655486246673, -89.5091705322266, -1.56222973651644, 218, 30, 'PPL', 'P'),
(17652, 'Plantation Acres', 26.1433296203613, 0.456287179309464, -80.3063888549805, -1.40161089590629, 218, 12, 'PPL', 'P'),
(42605, 'Plantation Acres', 29.8055591583252, 0.520205142710724, -90.8102798461914, -1.58493837797349, 218, 22, 'PPL', 'P'),
(67859, 'Plantation Acres', 35.9233283996582, 0.626980358849221, -79.0941696166992, -1.38045367894226, 218, 33, 'PPL', 'P'),
(24000, 'Plantation Acres Mobile Home Park', 33.3858299255371, 0.582692655711476, -82.1222229003906, -1.4333031786685, 218, 13, 'PPL', 'P'),
(105309, 'Plantation Court', 37.3305587768555, 0.651541162265395, -79.9400024414063, -1.39521624665484, 218, 53, 'PPL', 'P'),
(24002, 'Plantation Estates', 33.9311103820801, 0.592209595024929, -84.855827331543, -1.48101357643922, 218, 13, 'PPL', 'P'),
(73915, 'Plantation Estates', 38.439998626709, 0.670904540498171, -82.3652801513672, -1.43754532796889, 218, 41, 'PPL', 'P'),
(24003, 'Plantation Estates Mobile Home Park', 33.7891693115234, 0.58973225599991, -84.688606262207, -1.4780950182006, 218, 13, 'PPL', 'P'),
(17653, 'Plantation Gardens', 26.1294403076172, 0.45604476507124, -80.2377777099609, -1.40041340552213, 218, 12, 'PPL', 'P'),
(105310, 'Plantation Heights', 37.2919387817383, 0.650867116193496, -76.7113876342773, -1.3388662879918, 218, 53, 'PPL', 'P'),
(89968, 'Plantation Hills', 36.002498626709, 0.628362139980809, -83.8977813720703, -1.46429252006099, 218, 50, 'PPL', 'P'),
(17654, 'Plantation Island', 25.8436107635498, 0.45105609842779, -81.3661117553711, -1.42010654967689, 218, 12, 'PPL', 'P'),
(17655, 'Plantation Isles', 26.1019401550293, 0.45556479686378, -80.2283325195313, -1.40024855585066, 218, 12, 'PPL', 'P'),
(17656, 'Plantation Key', 24.9844398498535, 0.436060737146422, -80.5611114501953, -1.40605664387201, 218, 12, 'PPL', 'P'),
(17657, 'Plantation Key Colony', 24.996940612793, 0.436278916618726, -80.5416717529297, -1.40571735714914, 218, 12, 'PPL', 'P'),
(24005, 'Plantation Manor', 32.9419403076172, 0.574945320363354, -85.0486068725586, -1.48437821416042, 218, 13, 'PPL', 'P'),
(17658, 'Plantation Mobile Home Park', 26.7027797698975, 0.466051426419645, -80.1324996948242, -1.39857595752803, 218, 12, 'PPL', 'P'),
(24006, 'Plantation North', 34.0277786254883, 0.593896774154521, -84.4047164916992, -1.47314020699251, 218, 13, 'PPL', 'P'),
(24007, 'Plantation Oaks', 30.7525005340576, 0.53673238754062, -81.5227813720703, -1.42284095032613, 218, 13, 'PPL', 'P'),
(97107, 'Plantation Oaks North Colonia', 26.3250007629395, 0.459457938903313, -98.2600021362305, -1.71496056029388, 218, 51, 'PPL', 'P'),
(17659, 'Plantation Park', 26.1186103820801, 0.455855747212872, -80.2272186279297, -1.4002291147747, 218, 12, 'PPL', 'P'),
(14427, 'Plantation Park II Mobile Home Park', 38.5136108398438, 0.672189315987052, -75.1105575561523, -1.31092653236356, 218, 10, 'PPL', 'P'),
(105311, 'Plantation Pines Estates', 38.6833305358887, 0.67515148348852, -77.4438934326172, -1.35165092596278, 218, 53, 'PPL', 'P'),
(24008, 'Plantation Place', 34.0052795410156, 0.593504091051789, -84.4000015258789, -1.47305791531483, 218, 13, 'PPL', 'P'),
(24009, 'Plantation Point', 30.9452800750732, 0.540097025261826, -81.7411117553711, -1.42665153437187, 218, 13, 'PPL', 'P'),
(83049, 'Plantation Point', 33.7266693115234, 0.588641425217413, -78.8763885498047, -1.37665268227645, 218, 48, 'PPL', 'P'),
(83050, 'Plantation Ridge', 32.9550018310547, 0.575173286952664, -80.1536102294922, -1.39894440586485, 218, 48, 'PPL', 'P'),
(24010, 'Plantation Subdivision', 33.420280456543, 0.583293930906589, -84.6847229003906, -1.47802724075086, 218, 13, 'PPL', 'P'),
(83051, 'Plantation Subdivision', 33.5155601501465, 0.584956875270261, -80.9055633544922, -1.41206846371676, 218, 48, 'PPL', 'P'),
(24011, 'Plantation Walk', 34.0908317565918, 0.594997258895969, -84.647216796875, -1.47737263575492, 218, 13, 'PPL', 'P'),
(67861, 'Plantation Walk', 35.3283309936523, 0.616595695073593, -82.4749984741211, -1.43946027395071, 218, 33, 'PPL', 'P'),
(42606, 'Plantation Way', 30.6055603027344, 0.534167796700387, -91.0561065673828, -1.58922886364766, 218, 22, 'PPL', 'P'),
(24012, 'Plantation Woods', 33.939998626709, 0.592364724158426, -84.0666732788086, -1.46724023991355, 218, 13, 'PPL', 'P'),
(184166, 'Plantel (historical)', 36.9661102294922, 0.645180335159795, -121.530830383301, -2.12111313287136, 218, 6, 'PPL', 'P'),
(24013, 'Planter', 34.1194381713867, 0.595496535021332, -83.3405609130859, -1.45456718839224, 218, 13, 'PPL', 'P'),
(132650, 'Planter', 46.5111083984375, 0.811771980304721, -89.9736099243164, -1.57033573308437, 218, 27, 'PPL', 'P'),
(67864, 'Planters Walk', 35.5758285522461, 0.620915342361702, -77.3422164916992, -1.34987632857041, 218, 33, 'PPL', 'P'),
(50451, 'Planters Wharf', 38.4269409179688, 0.670676640487887, -76.4861068725586, -1.33493439695841, 218, 25, 'PPL', 'P'),
(5109, 'Plantersville', 33.3697204589844, 0.582411492479391, -86.2358322143555, -1.5050992053379, 218, 2, 'PPL', 'P'),
(11254, 'Plantersville', 33.7669410705566, 0.589344300008112, -91.8805618286133, -1.60361832249152, 218, 4, 'PPL', 'P'),
(61364, 'Plantersville', 34.2133293151855, 0.597135244619085, -88.664436340332, -1.54748634356371, 218, 30, 'PPL', 'P'),
(83052, 'Plantersville', 33.5552787780762, 0.585650096102009, -79.2155609130859, -1.38257235674748, 218, 48, 'PPL', 'P'),
(97108, 'Plantersville', 30.3327808380127, 0.529406896909166, -95.8616714477539, -1.67310179322835, 218, 51, 'PPL', 'P'),
(105312, 'Plantersville', 36.9258308410645, 0.644477327211042, -78.4419403076172, -1.36907013002077, 218, 53, 'PPL', 'P'),
(42607, 'Plantersville (historical)', 32.8833312988281, 0.573922400188654, -91.7777786254883, -1.60182441718125, 218, 22, 'PPL', 'P'),
(61365, 'Plantersville (historical)', 33.1972198486328, 0.579400788867056, -88.3249969482422, -1.54156200856077, 218, 30, 'PPL', 'P'),
(73916, 'Plants', 38.913330078125, 0.679165732778623, -81.9049987792969, -1.42951190254067, 218, 41, 'PPL', 'P'),
(151765, 'Plants Corner', 42.7044410705566, 0.745333101905105, -78.418327331543, -1.36865800584208, 218, 40, 'PPL', 'P'),
(178898, 'Plantsite', 33.0563888549805, 0.576942824338967, -109.331939697266, -1.90820232530918, 218, 5, 'PPL', 'P'),
(73917, 'Plantsville', 39.452220916748, 0.688571152221429, -81.8758316040039, -1.4290028392983, 218, 41, 'PPL', 'P'),
(113920, 'Plantsville', 41.583610534668, 0.725770918696956, -72.8927764892578, -1.27221895065786, 218, 8, 'PPL', 'P'),
(151766, 'Plantz Corners', 43.6661109924316, 0.762117408359221, -75.9116668701172, -1.32490852756064, 218, 40, 'PPL', 'P'),
(73918, 'Plantz Subdivision', 38.8444404602051, 0.67796338212548, -82.2180633544922, -1.43497591014918, 218, 41, 'PPL', 'P'),
(42608, 'Plaquemine', 30.288890838623, 0.528640871911119, -91.2341690063477, -1.59233663948173, 218, 22, 'PPL', 'P'),
(192055, 'Plaska', 34.6058311462402, 0.603985693891095, -100.646392822266, -1.75661093500412, 218, 51, 'PPL', 'P'),
(184167, 'Plaskett', 35.9166717529297, 0.626864178446666, -121.467781066895, -2.12001271470894, 218, 6, 'PPL', 'P'),
(184169, 'Plasse', 38.6372184753418, 0.674346676207098, -120.125556945801, -2.09658648449617, 218, 6, 'PPL', 'P'),
(184170, 'Plaster City', 32.7924995422363, 0.572337086970757, -115.857780456543, -2.02209973301941, 218, 6, 'PPL', 'P'),
(105313, 'Plasterco', 36.8605613708496, 0.64333816005476, -81.7908325195313, -1.42751932541307, 218, 53, 'PPL', 'P'),
(151767, 'Plasterville', 42.586109161377, 0.743267820479749, -75.522216796875, -1.31811134151043, 218, 40, 'PPL', 'P'),
(187210, 'Plastic', 39.8608283996582, 0.695702698146498, -105.228057861328, -1.83657607515928, 218, 7, 'PPL', 'P'),
(175864, 'Plat', 43.2077789306641, 0.754118004813923, -88.2808303833008, -1.54079115658325, 218, 57, 'PPL', 'P'),
(11255, 'Plata', 34.4524993896484, 0.601309549890702, -93.5466690063477, -1.6326973784341, 218, 4, 'PPL', 'P'),
(192056, 'Plata', 29.8761100769043, 0.521436488530236, -104.017219543457, -1.81544295980312, 218, 51, 'PPL', 'P'),
(56927, 'Platanus (historical)', 36.5344390869141, 0.637646252435961, -90.2644424438477, -1.57541171812206, 218, 29, 'PPL', 'P'),
(42610, 'Platation Acres', 30.3830604553223, 0.530284441777861, -90.9930572509766, -1.58812844548524, 218, 22, 'PPL', 'P'),
(166013, 'Platea', 41.9502792358398, 0.732170494796416, -80.3283309936523, -1.40199385847104, 218, 45, 'PPL', 'P'),
(267, 'Plateau', 30.7361106872559, 0.536446330750032, -88.0638885498047, -1.53700480730343, 218, 2, 'PPL', 'P'),
(67865, 'Plateau', 35.5933303833008, 0.621220806938734, -81.35888671875, -1.41998044899927, 218, 33, 'PPL', 'P'),
(89969, 'Plateau', 36.0827789306641, 0.629763295609327, -85.1113891601563, -1.48547397179094, 218, 50, 'PPL', 'P'),
(157169, 'Plateau Acres', 40.0108299255371, 0.6983207186561, -83.7091674804688, -1.46100058663755, 218, 41, 'PPL', 'P'),
(187212, 'Plateau City', 39.2372207641602, 0.68481869166648, -107.981109619141, -1.88462589281092, 218, 7, 'PPL', 'P'),
(73919, 'Platform', 38.5583305358887, 0.672969821923527, -82.3513870239258, -1.43730284715164, 218, 41, 'PPL', 'P'),
(193881, 'Platina', 40.3597183227539, 0.704409969909539, -122.893608093262, -2.14489809088297, 218, 6, 'PPL', 'P'),
(190620, 'Platina (historical)', 35.8022193908691, 0.624866607892025, -115.578887939453, -2.01723214033702, 218, 39, 'PPL', 'P'),
(212092, 'Platinum', 59.0130615234375, 1.02997222526597, -161.816390991211, -2.82422880649112, 218, 1, 'PPL', 'P'),
(194376, 'Platner', 40.1552810668945, 0.700841866681051, -103.066940307617, -1.79885745832438, 218, 7, 'PPL', 'P'),
(37716, 'Plato', 37.232780456543, 0.649834608638872, -84.4177780151367, -1.47336817358182, 218, 21, 'PPL', 'P'),
(56928, 'Plato', 37.5036087036133, 0.654561453257654, -92.2247161865234, -1.60962494917214, 218, 29, 'PPL', 'P'),
(89970, 'Plato', 36.1930618286133, 0.631688095287181, -82.1875, -1.43444247898284, 218, 50, 'PPL', 'P'),
(105314, 'Plato', 36.7963905334473, 0.642218167658327, -79.0486068725586, -1.37965845904077, 218, 53, 'PPL', 'P'),
(117314, 'Plato', 41.7380599975586, 0.728466570352334, -91.3083267211914, -1.59363093577151, 218, 16, 'PPL', 'P'),
(123450, 'Plato', 41.642219543457, 0.726793838871655, -85.331672668457, -1.48931864429863, 218, 19, 'PPL', 'P'),
(137509, 'Plato', 44.7744407653809, 0.781461412095066, -94.0397186279297, -1.64130271770642, 218, 28, 'PPL', 'P'),
(151769, 'Plato', 42.351390838623, 0.739171212932935, -78.67138671875, -1.37307472535193, 218, 40, 'PPL', 'P'),
(121062, 'Plato Center', 42.026668548584, 0.733503739817137, -88.4300003051758, -1.54339466286491, 218, 18, 'PPL', 'P'),
(121063, 'Plato Corners', 41.9869384765625, 0.732810319248308, -88.4049987792969, -1.5429583039203, 218, 18, 'PPL', 'P'),
(200134, 'Platora', 41.663890838623, 0.727172074325474, -117.75666809082, -2.05524157436296, 218, 39, 'PPL', 'P'),
(187213, 'Platoro', 37.3519401550293, 0.651914337713142, -106.532218933105, -1.85933797983813, 218, 7, 'PPL', 'P'),
(56929, 'Platow', 37.1977806091309, 0.649223746063835, -90.7061080932617, -1.58312023789729, 218, 29, 'PPL', 'P'),
(17660, 'Platt', 27.0916690826416, 0.472838825352848, -82.0019378662109, -1.43120380878119, 218, 12, 'PPL', 'P'),
(97109, 'Platt', 31.4147205352783, 0.548290306934482, -94.6080627441406, -1.65122219381864, 218, 51, 'PPL', 'P'),
(83053, 'Platt Spring', 33.625560760498, 0.586876748100099, -78.9655609130859, -1.37820903361749, 218, 48, 'PPL', 'P'),
(137511, 'Platte', 46.1055603027344, 0.804693830759508, -94.0819396972656, -1.64203961438004, 218, 28, 'PPL', 'P'),
(171082, 'Platte', 43.3869400024414, 0.757244955407839, -98.8441696166992, -1.72515620621114, 218, 49, 'PPL', 'P'),
(142682, 'Platte Center', 41.5374984741211, 0.724966111415534, -97.4880599975586, -1.70148762833917, 218, 35, 'PPL', 'P'),
(56930, 'Platte City', 39.3702812194824, 0.687141034716057, -94.7822189331055, -1.6542617927288, 218, 29, 'PPL', 'P'),
(151770, 'Platte Clove', 42.1344413757324, 0.73538473049506, -74.0891723632813, -1.29309999781685, 218, 40, 'PPL', 'P'),
(171083, 'Platte Colony', 43.4697189331055, 0.758689720299207, -99.1255569458008, -1.73006734157736, 218, 49, 'PPL', 'P'),
(56932, 'Platte Gardens', 39.3027801513672, 0.685962918828833, -94.6858291625977, -1.65257947386819, 218, 29, 'PPL', 'P'),
(56933, 'Platte River', 39.5502815246582, 0.690282632695969, -94.695556640625, -1.65274925038769, 218, 29, 'PPL', 'P'),
(187214, 'Platte Springs', 39.0636100769043, 0.681788613557215, -105.358062744141, -1.83884508840803, 218, 7, 'PPL', 'P'),
(142688, 'Platte Valley Trailer Court', 41.1158294677734, 0.717606598901154, -98.0013885498047, -1.71044690172036, 218, 35, 'PPL', 'P'),
(56934, 'Platte Woods', 39.2291717529297, 0.684678209918979, -94.6477813720703, -1.65191541465038, 218, 29, 'PPL', 'P'),
(151771, 'Plattekill', 41.6175003051758, 0.726362406775062, -74.0763931274414, -1.29287695807555, 218, 40, 'PPL', 'P'),
(151773, 'Platten', 43.3172187805176, 0.756028090526755, -78.3105621337891, -1.36677714832222, 218, 40, 'PPL', 'P'),
(42612, 'Plattenville', 29.9886093139648, 0.523399970622924, -91.0219421386719, -1.58863258187959, 218, 22, 'PPL', 'P'),
(76964, 'Platter', 33.9069404602051, 0.59178775030826, -96.5347213745117, -1.68484873048058, 218, 42, 'PPL', 'P'),
(117318, 'Platteville', 40.6399993896484, 0.709301797357851, -94.5563888549805, -1.65032031431548, 218, 16, 'PPL', 'P'),
(175865, 'Platteville', 42.7341690063477, 0.74585195226448, -90.4783325195313, -1.57914480418008, 218, 57, 'PPL', 'P'),
(194377, 'Platteville', 40.2150001525879, 0.701884161352681, -104.822219848633, -1.82949286560799, 218, 7, 'PPL', 'P'),
(142694, 'Plattford (historical)', 41.0499992370605, 0.716457644627867, -96.2083282470703, -1.67915209575084, 218, 35, 'PPL', 'P'),
(56938, 'Plattin', 38.1311111450195, 0.665513436924496, -90.4113922119141, -1.57797647540986, 218, 29, 'PPL', 'P'),
(113921, 'Platts Knoll', 41.485279083252, 0.724054711111481, -72.8786087036133, -1.27197167615065, 218, 8, 'PPL', 'P'),
(113922, 'Platts Mills', 41.5144386291504, 0.724563641195796, -73.0524978637695, -1.2750066145289, 218, 8, 'PPL', 'P'),
(30852, 'Plattsburg', 38.7194404602051, 0.675781720560487, -86.0897216796875, -1.50254909543609, 218, 19, 'PPL', 'P'),
(56939, 'Plattsburg', 39.565559387207, 0.690549281700113, -94.4477767944336, -1.64842467625156, 218, 29, 'PPL', 'P'),
(61366, 'Plattsburg', 32.9413909912109, 0.574935732983429, -89.192497253418, -1.55670274514814, 218, 30, 'PPL', 'P'),
(73920, 'Plattsburg', 39.896110534668, 0.696318487569551, -83.6116714477539, -1.45929895985904, 218, 41, 'PPL', 'P'),
(151778, 'Plattsburgh', 44.6994400024414, 0.780152401840265, -73.4533309936523, -1.28200247239643, 218, 40, 'PPL', 'P'),
(142695, 'Plattsmouth', 41.0113906860352, 0.71578379829305, -95.8819427490234, -1.67345559417916, 218, 35, 'PPL', 'P'),
(157170, 'Plattston (historical)', 41.5299987792969, 0.724835217047956, -84.0327835083008, -1.46664875183544, 218, 41, 'PPL', 'P'),
(113923, 'Plattsville', 41.2227783203125, 0.719473208509191, -73.2566680908203, -1.27857005722548, 218, 8, 'PPL', 'P'),
(157171, 'Plattsville', 40.2322196960449, 0.702184699081696, -84.0774993896484, -1.46742919119289, 218, 41, 'PPL', 'P'),
(166036, 'Plattsville', 40.6922187805176, 0.710213197661903, -78.7461090087891, -1.37437887533774, 218, 45, 'PPL', 'P'),
(121065, 'Plattville', 41.5316696166992, 0.724864378661893, -88.3813934326172, -1.54254631289966, 218, 18, 'PPL', 'P'),
(42613, 'Plaucheville', 30.9652805328369, 0.540446099101708, -91.9816665649414, -1.60538293302981, 218, 22, 'PPL', 'P'),
(184173, 'Playa del Rey', 33.9488906860352, 0.59251991987095, -118.444717407227, -2.06725030035034, 218, 6, 'PPL', 'P'),
(184172, 'Playa Vista', 33.9727783203125, 0.592936837739602, -118.426666259766, -2.06693524839339, 218, 6, 'PPL', 'P'),
(189249, 'Playas', 31.9166698455811, 0.55705097507738, -108.533058166504, -1.89425921226401, 218, 38, 'PPL', 'P'),
(83055, 'Playcards', 34.0544395446777, 0.594362094975985, -79.0061111450195, -1.37891676867718, 218, 48, 'PPL', 'P'),
(76965, 'Player', 36.0961112976074, 0.629995989309572, -96.602783203125, -1.68603663348481, 218, 42, 'PPL', 'P'),
(195476, 'Player Place', 42.0200004577637, 0.733387359677501, -114.816673278809, -2.0039289849018, 218, 17, 'PPL', 'P'),
(17662, 'Playland Estates', 26.0322208404541, 0.45434796527221, -80.2041702270508, -1.39982684429204, 218, 12, 'PPL', 'P'),
(17663, 'Playland Isles', 26.0611095428467, 0.454852168245589, -80.2044372558594, -1.39983150482395, 218, 12, 'PPL', 'P'),
(17664, 'Playland Village', 26.0738906860352, 0.455075241276397, -80.2249984741211, -1.40019036578084, 218, 12, 'PPL', 'P'),
(195477, 'Plaza', 43.9113883972168, 0.766398306653469, -116.431938171387, -2.03212067556916, 218, 17, 'PPL', 'P'),
(198750, 'Plaza', 48.0258293151855, 0.838208847550801, -101.960563659668, -1.77954754305049, 218, 34, 'PPL', 'P'),
(208451, 'Plaza', 47.3202781677246, 0.825894656986384, -117.382781982422, -2.04871603074394, 218, 56, 'PPL', 'P'),
(192057, 'Plaza Bernal Colonia', 31.5849990844727, 0.551262228263442, -106.268997192383, -1.85474389379969, 218, 51, 'PPL', 'P'),
(189251, 'Plaza Blanca', 36.252498626709, 0.632725463110794, -106.27555847168, -1.85485840972656, 218, 38, 'PPL', 'P'),
(193233, 'Plaza Condominiums', 40.4891700744629, 0.706669329199335, -111.956108093262, -1.95400270394609, 218, 52, 'PPL', 'P'),
(5110, 'Plaza Mobile Home Park', 33.5886116027832, 0.586231863642137, -86.6511077880859, -1.5123471314026, 218, 2, 'PPL', 'P'),
(146057, 'Plaza Park', 40.0677795410156, 0.699314676953945, -74.8758316040039, -1.3068297916587, 218, 37, 'PPL', 'P'),
(178899, 'Plaza Trailer Inn', 33.4505615234375, 0.583822435224915, -112.003059387207, -1.95482215861351, 218, 5, 'PPL', 'P'),
(28274, 'Pleak', 39.5955581665039, 0.691072859170422, -88.9383316040039, -1.5522667177204, 218, 18, 'PPL', 'P'),
(97110, 'Pleak', 29.4888896942139, 0.514678217921456, -95.807502746582, -1.67215637104137, 218, 51, 'PPL', 'P'),
(67866, 'Plear', 34.5958290100098, 0.603811123681641, -77.7958297729492, -1.357793373859, 218, 33, 'PPL', 'P'),
(30849, 'Pleasant', 38.8708305358887, 0.678423975836009, -85.1838912963867, -1.48673937278289, 218, 19, 'PPL', 'P'),
(67867, 'Pleasant (historical)', 35.5402793884277, 0.620294892406741, -81.2891693115234, -1.41876365069722, 218, 33, 'PPL', 'P'),
(83054, 'Pleasant (historical)', 34.1855583190918, 0.59665054930069, -81.0430603027344, -1.41446823817503, 218, 48, 'PPL', 'P'),
(89972, 'Pleasant (historical)', 36.4844398498535, 0.636773601125769, -83.8319396972656, -1.46314336605062, 218, 50, 'PPL', 'P'),
(24016, 'Pleasant Acres', 33.9269409179688, 0.592136824148142, -84.1205596923828, -1.46818073525251, 218, 13, 'PPL', 'P'),
(30851, 'Pleasant Acres', 39.8911094665527, 0.696231202464824, -86.102783203125, -1.5027770620254, 218, 19, 'PPL', 'P'),
(50452, 'Pleasant Acres', 38.3758316040039, 0.669784614680765, -75.5500030517578, -1.31859630314494, 218, 25, 'PPL', 'P'),
(113924, 'Pleasant Acres', 41.4308280944824, 0.723104362076487, -73.4480590820313, -1.28191046018077, 218, 8, 'PPL', 'P'),
(137513, 'Pleasant Acres Mobile Home Park', 43.7188911437988, 0.763038595780279, -92.7044372558594, -1.61799766132324, 218, 28, 'PPL', 'P'),
(137514, 'Pleasant Beach', 45.7780609130859, 0.798977888111871, -94.7350006103516, -1.65343767752947, 218, 28, 'PPL', 'P'),
(157172, 'Pleasant Bend', 41.1802787780762, 0.718731451566576, -84.1900024414063, -1.4693927398646, 218, 41, 'PPL', 'P'),
(24017, 'Pleasant Brook', 34.2174987792969, 0.597208015495871, -83.8291702270508, -1.46309502967684, 218, 13, 'PPL', 'P'),
(151779, 'Pleasant Brook', 42.7163887023926, 0.745541627418459, -74.7638931274414, -1.30487609668301, 218, 40, 'PPL', 'P'),
(73921, 'Pleasant City', 39.9036102294922, 0.696449381937129, -81.5455627441406, -1.42323856027688, 218, 41, 'PPL', 'P'),
(117320, 'Pleasant Corner', 41.1041717529297, 0.717403133393872, -92.6777801513672, -1.61753240708081, 218, 16, 'PPL', 'P'),
(73922, 'Pleasant Corners', 39.8438911437988, 0.695407087265499, -83.1269378662109, -1.45083876286613, 218, 41, 'PPL', 'P'),
(166015, 'Pleasant Corners', 40.6833305358887, 0.710058068528406, -75.6908264160156, -1.32105413451497, 218, 45, 'PPL', 'P'),
(50454, 'Pleasant Cove', 39.3680610656738, 0.687102285722196, -75.8397216796875, -1.32365284710667, 218, 25, 'PPL', 'P'),
(105315, 'Pleasant Cove Village', 37.5352783203125, 0.6551141923419, -75.9327774047852, -1.32527697589746, 218, 53, 'PPL', 'P'),
(117321, 'Pleasant Creek', 42.1994400024414, 0.736519170540407, -90.3824996948242, -1.57747220585745, 218, 16, 'PPL', 'P'),
(110924, 'Pleasant Creek (historical)', 39.2466697692871, 0.684983607916983, -80.024169921875, -1.39668524631213, 218, 58, 'PPL', 'P'),
(50455, 'Pleasant Dale', 39.6141700744629, 0.691397698244385, -77.0672225952148, -1.34507677965387, 218, 25, 'PPL', 'P'),
(83067, 'Pleasant Dale', 34.7255592346191, 0.606075343240426, -80.6894378662109, -1.40829636234877, 218, 48, 'PPL', 'P'),
(142698, 'Pleasant Dale', 40.7919387817383, 0.711953640013298, -96.9319381713867, -1.69178147143027, 218, 35, 'PPL', 'P'),
(50456, 'Pleasant Estates', 39.4541702270508, 0.688605174104355, -77.3036117553711, -1.34920254881462, 218, 25, 'PPL', 'P'),
(89973, 'Pleasant Exchange (historical)', 35.7666702270508, 0.624246157937064, -88.279167175293, -1.54076212812736, 218, 50, 'PPL', 'P'),
(83056, 'Pleasant Farm', 32.4097213745117, 0.565656347639212, -80.7699966430664, -1.40970237824628, 218, 48, 'PPL', 'P'),
(192063, 'Pleasant Farms', 31.6757698059082, 0.552846476216903, -102.372192382813, -1.78673181956514, 218, 51, 'PPL', 'P'),
(5113, 'Pleasant Field', 33.6666717529297, 0.587594270276794, -87.3022232055664, -1.52371123924813, 218, 2, 'PPL', 'P'),
(50457, 'Pleasant Fields', 39.1536102294922, 0.683359412547171, -77.2708282470703, -1.34863036865442, 218, 25, 'PPL', 'P'),
(5114, 'Pleasant Gap', 33.9874992370605, 0.593193766205767, -85.5199966430664, -1.49260551771601, 218, 2, 'PPL', 'P'),
(56940, 'Pleasant Gap', 38.172779083252, 0.666240679639169, -94.1819381713867, -1.64378491700043, 218, 29, 'PPL', 'P'),
(105316, 'Pleasant Gap', 36.7027816772461, 0.640584384908591, -79.445556640625, -1.38658653945855, 218, 53, 'PPL', 'P'),
(166016, 'Pleasant Gap', 40.8680610656738, 0.713282224502111, -77.746940612793, -1.35694009704574, 218, 45, 'PPL', 'P'),
(67869, 'Pleasant Garden', 35.9619407653809, 0.627654271763066, -79.7624969482422, -1.39211819135876, 218, 33, 'PPL', 'P'),
(89974, 'Pleasant Garden', 36.1338882446289, 0.630655321416449, -82.3108291625977, -1.4365949789339, 218, 50, 'PPL', 'P'),
(30854, 'Pleasant Gardens', 39.5513916015625, 0.690302007192899, -86.9644393920898, -1.51781579954302, 218, 19, 'PPL', 'P'),
(67870, 'Pleasant Gardens', 35.6888885498047, 0.622888611571396, -82.0783309936523, -1.43253712038094, 218, 33, 'PPL', 'P'),
(56942, 'Pleasant Green', 38.8061103820801, 0.677294396059652, -92.9625015258789, -1.62250173251684, 218, 29, 'PPL', 'P'),
(105317, 'Pleasant Green', 37.6188888549805, 0.656573471461209, -77.813606262207, -1.35810363212599, 218, 53, 'PPL', 'P'),
(205388, 'Pleasant Green Acres Subdivision', 40.7027816772461, 0.710397554988364, -112.092498779297, -1.95638317048646, 218, 52, 'PPL', 'P'),
(205389, 'Pleasant Green Acres Subdivision 3-9', 40.7008285522461, 0.710363466526411, -112.088890075684, -1.95632018672667, 218, 52, 'PPL', 'P'),
(37718, 'Pleasant Green Hill', 36.9291687011719, 0.644535583859887, -87.5272216796875, -1.52763820343351, 218, 21, 'PPL', 'P'),
(5125, 'Pleasant Grove', 33.7999992370605, 0.589921273858278, -87.3730621337891, -1.5249476117842, 218, 2, 'PPL', 'P'),
(11261, 'Pleasant Grove', 35.3869400024414, 0.617618615248293, -91.2861099243164, -1.59324317951679, 218, 4, 'PPL', 'P'),
(17669, 'Pleasant Grove', 30.9688892364502, 0.540509082861489, -86.3547210693359, -1.50717420730123, 218, 12, 'PPL', 'P'),
(24023, 'Pleasant Grove', 34.8294410705566, 0.607888423310552, -84.9419403076172, -1.48251653140041, 218, 13, 'PPL', 'P'),
(28285, 'Pleasant Grove', 37.4408302307129, 0.653465762206168, -89.0297164916992, -1.55386168489725, 218, 18, 'PPL', 'P'),
(33636, 'Pleasant Grove', 38.8555603027344, 0.67815745998992, -95.2694396972656, -1.66276539924747, 218, 20, 'PPL', 'P'),
(37719, 'Pleasant Grove', 37.7516708374023, 0.658890954241796, -85.1725006103516, -1.48654056780751, 218, 21, 'PPL', 'P'),
(42615, 'Pleasant Grove', 32.5686111450195, 0.568429497282311, -93.9030609130859, -1.63891759063414, 218, 22, 'PPL', 'P'),
(50461, 'Pleasant Grove', 39.172779083252, 0.683693972159113, -76.8722229003906, -1.3416733929388, 218, 25, 'PPL', 'P'),
(56945, 'Pleasant Grove', 36.7377815246582, 0.641195247483628, -90.8288879394531, -1.58526315046842, 218, 29, 'PPL', 'P'),
(61369, 'Pleasant Grove', 31.7094402313232, 0.553434136000943, -88.9227828979492, -1.55199534160532, 218, 30, 'PPL', 'P'),
(67879, 'Pleasant Grove', 35.9247207641602, 0.627004660194168, -76.5905609130859, -1.33675746388262, 218, 33, 'PPL', 'P'),
(76966, 'Pleasant Grove', 35.2247200012207, 0.614787342114402, -96.7372207641602, -1.68838301156322, 218, 42, 'PPL', 'P'),
(83059, 'Pleasant Grove', 33.9916687011719, 0.593266537082554, -80.0461120605469, -1.39706820887689, 218, 48, 'PPL', 'P'),
(89983, 'Pleasant Grove', 36.5999984741211, 0.638790479598314, -86.2252807617188, -1.50491504774852, 218, 50, 'PPL', 'P'),
(97117, 'Pleasant Grove', 32.9258308410645, 0.574664157131269, -95.398063659668, -1.66501031088836, 218, 51, 'PPL', 'P'),
(105322, 'Pleasant Grove', 36.5444412231445, 0.637820822645416, -79.3944396972656, -1.38569438049338, 218, 53, 'PPL', 'P'),
(117323, 'Pleasant Grove', 42.389720916748, 0.739840198998763, -90.9261093139648, -1.58695998355697, 218, 16, 'PPL', 'P'),
(137515, 'Pleasant Grove', 43.8691711425781, 0.765661476558871, -92.3855590820313, -1.6124321872772, 218, 28, 'PPL', 'P'),
(146064, 'Pleasant Grove', 40.7797203063965, 0.711740387389009, -74.8511123657227, -1.3063983595621, 218, 37, 'PPL', 'P'),
(157173, 'Pleasant Grove', 40.1502799987793, 0.700754581576324, -80.8424987792969, -1.41096777923823, 218, 41, 'PPL', 'P'),
(166020, 'Pleasant Grove', 40.1197204589844, 0.700221216989008, -76.7441711425781, -1.33943846815201, 218, 45, 'PPL', 'P'),
(184176, 'Pleasant Grove', 38.8238906860352, 0.677604720905674, -121.482780456543, -2.1202745034441, 218, 6, 'PPL', 'P'),
(205391, 'Pleasant Grove', 40.3641700744629, 0.704487667634342, -111.737777709961, -1.95019211990035, 218, 52, 'PPL', 'P'),
(78954, 'Pleasant Grove (historical)', 39.8152809143066, 0.694907744561109, -76.4700012207031, -1.33465330030535, 218, 45, 'PPL', 'P'),
(97118, 'Pleasant Grove (historical)', 30.3826999664307, 0.530278150059786, -97.3154067993164, -1.69847426156575, 218, 51, 'PPL', 'P'),
(184177, 'Pleasant Grove (historical)', 36.0805587768555, 0.629724546615466, -119.169166564941, -2.07989432341577, 218, 6, 'PPL', 'P'),
(5126, 'Pleasant Grove Estates', 33.4900016784668, 0.584510795787673, -86.9591674804688, -1.51772378732736, 218, 2, 'PPL', 'P'),
(50462, 'Pleasant Grove Estates', 38.5541687011719, 0.672897184204795, -77.1708297729492, -1.34688506603403, 218, 25, 'PPL', 'P'),
(89985, 'Pleasant Grove Subdivision', 35.0688896179199, 0.612067588851159, -86.5966720581055, -1.51139704868371, 218, 50, 'PPL', 'P'),
(166021, 'Pleasant Hall', 40.0530586242676, 0.69905774848778, -77.654167175293, -1.35532089510297, 218, 45, 'PPL', 'P'),
(50463, 'Pleasant Heights', 39.4530601501465, 0.688585799607425, -77.309440612793, -1.34930428156826, 218, 25, 'PPL', 'P'),
(105323, 'Pleasant Heights', 36.8588905334473, 0.643308998440824, -81.7350006103516, -1.42654487477021, 218, 53, 'PPL', 'P'),
(157174, 'Pleasant Heights', 40.6322212219238, 0.709166042721284, -80.5891723632813, -1.40654639919648, 218, 41, 'PPL', 'P'),
(5140, 'Pleasant Hill', 34.2188911437988, 0.597232316840818, -87.4430618286133, -1.52616933693428, 218, 2, 'PPL', 'P'),
(11277, 'Pleasant Hill', 34.8891716003418, 0.608930917719264, -93.5377807617188, -1.6325422493006, 218, 4, 'PPL', 'P'),
(14428, 'Pleasant Hill', 39.7405586242676, 0.693603594575297, -75.727783203125, -1.32169915213099, 218, 10, 'PPL', 'P'),
(24030, 'Pleasant Hill', 34.8941688537598, 0.609018136244964, -83.9863891601563, -1.465839017706, 218, 13, 'PPL', 'P'),
(30853, 'Pleasant Hill', 39.8661117553711, 0.695794910099242, -85.6872177124023, -1.49552407595462, 218, 19, 'PPL', 'P'),
(37722, 'Pleasant Hill', 36.9072189331055, 0.644152488137079, -87.3686065673828, -1.52486984748037, 218, 21, 'PPL', 'P'),
(42620, 'Pleasant Hill', 31.8197193145752, 0.555358869099771, -93.5141677856445, -1.63213012512191, 218, 22, 'PPL', 'P'),
(50465, 'Pleasant Hill', 39.670280456543, 0.692377009156234, -75.9024963378906, -1.32474847157913, 218, 25, 'PPL', 'P'),
(56946, 'Pleasant Hill', 38.7874984741211, 0.67696955698569, -94.269172668457, -1.64530744619562, 218, 29, 'PPL', 'P'),
(61374, 'Pleasant Hill', 34.5319404602051, 0.602696058133225, -88.9444427490234, -1.55237337732206, 218, 30, 'PPL', 'P'),
(67887, 'Pleasant Hill', 36.2572212219238, 0.632807887946532, -80.8836135864258, -1.41168536799395, 218, 33, 'PPL', 'P'),
(76967, 'Pleasant Hill', 33.7688903808594, 0.589378321891038, -94.6641693115234, -1.65220143815146, 218, 42, 'PPL', 'P'),
(83063, 'Pleasant Hill', 34.6197204589844, 0.60422810812932, -80.6849975585938, -1.40821886436105, 218, 48, 'PPL', 'P'),
(90001, 'Pleasant Hill', 35.850830078125, 0.625715024436297, -83.6263885498047, -1.45955582174618, 218, 50, 'PPL', 'P'),
(105325, 'Pleasant Hill', 37.1866683959961, 0.64902980135745, -81.7466735839844, -1.4267486065936, 218, 53, 'PPL', 'P'),
(110922, 'Pleasant Hill', 39.186939239502, 0.683941113508272, -81.591667175293, -1.42404323440024, 218, 58, 'PPL', 'P'),
(117328, 'Pleasant Hill', 41.5838890075684, 0.725775778965945, -93.5197219848633, -1.63222706418559, 218, 16, 'PPL', 'P'),
(121066, 'Pleasant Hill', 40.6130599975586, 0.708831616267398, -88.746940612793, -1.54892631476511, 218, 18, 'PPL', 'P'),
(128556, 'Pleasant Hill', 43.8730583190918, 0.765729320587641, -70.0663909912109, -1.22288921778632, 218, 26, 'PPL', 'P'),
(146059, 'Pleasant Hill', 40.8108291625977, 0.712283339356249, -74.6961135864258, -1.3036931205268, 218, 37, 'PPL', 'P'),
(151780, 'Pleasant Hill', 42.2069396972656, 0.736650064907984, -75.7866668701172, -1.32272686599565, 218, 40, 'PPL', 'P'),
(157177, 'Pleasant Hill', 40.0516700744629, 0.69903351372186, -84.3444366455078, -1.47208812520387, 218, 41, 'PPL', 'P'),
(166029, 'Pleasant Hill', 40.336109161377, 0.703997912309877, -76.4419403076172, -1.33416354498089, 218, 45, 'PPL', 'P'),
(184178, 'Pleasant Hill', 37.9480590820313, 0.662318575722782, -122.059722900391, -2.13034404868374, 218, 6, 'PPL', 'P'),
(189254, 'Pleasant Hill', 34.5202789306641, 0.602492526046915, -103.073333740234, -1.79896904477405, 218, 38, 'PPL', 'P'),
(192058, 'Pleasant Hill', 33.0222206115723, 0.576346475991872, -102.663330078125, -1.79181313092501, 218, 51, 'PPL', 'P'),
(199611, 'Pleasant Hill', 41.480281829834, 0.723967492585781, -100.078056335449, -1.74669159204996, 218, 35, 'PPL', 'P'),
(201411, 'Pleasant Hill', 43.9661102294922, 0.767353382799398, -122.930557250977, -2.14554297534093, 218, 43, 'PPL', 'P'),
(208453, 'Pleasant Hill', 47.6155586242676, 0.831048273169851, -121.908332824707, -2.12770179340822, 218, 56, 'PPL', 'P'),
(24032, 'Pleasant Hill (historical)', 30.7208309173584, 0.536179648456374, -84.1666717529297, -1.46898554253393, 218, 13, 'PPL', 'P'),
(42621, 'Pleasant Hill (historical)', 31.8291702270508, 0.555523818639787, -92.5694427490234, -1.61564156270685, 218, 22, 'PPL', 'P'),
(90002, 'Pleasant Hill (historical)', 35.961109161377, 0.627639757535125, -83.4225006103516, -1.45599730589761, 218, 50, 'PPL', 'P'),
(117329, 'Pleasant Hill (historical)', 40.7269401550293, 0.710819199967951, -91.9577789306641, -1.60496601516116, 218, 16, 'PPL', 'P'),
(121067, 'Pleasant Hill (historical)', 42.2649993896484, 0.737663397702759, -90.2352828979492, -1.57490278803774, 218, 18, 'PPL', 'P'),
(83064, 'Pleasant Hill Landing', 33.2449989318848, 0.580234691183387, -79.521110534668, -1.3879052036723, 218, 48, 'PPL', 'P'),
(137517, 'Pleasant Hill Manor', 44.2044410705566, 0.77151304068502, -93.8152770996094, -1.63738547405902, 218, 28, 'PPL', 'P'),
(14429, 'Pleasant Hills', 39.711109161377, 0.693089604484912, -75.6236114501953, -1.31988101205479, 218, 10, 'PPL', 'P'),
(24034, 'Pleasant Hills', 33.8211097717285, 0.59028972219509, -84.725830078125, -1.47874469634853, 218, 13, 'PPL', 'P'),
(42622, 'Pleasant Hills', 30.5352802276611, 0.532941177991811, -91.1122207641602, -1.59020824113854, 218, 22, 'PPL', 'P'),
(50466, 'Pleasant Hills', 39.4794387817383, 0.689046193580872, -76.3944396972656, -1.33333450293355, 218, 25, 'PPL', 'P'),
(73926, 'Pleasant Hills', 39.2358283996582, 0.684794390321533, -84.5250015258789, -1.47523957687982, 218, 41, 'PPL', 'P'),
(83065, 'Pleasant Hills', 32.9683303833008, 0.575405914073883, -80.0633316040039, -1.3973687466059, 218, 48, 'PPL', 'P'),
(90004, 'Pleasant Hills', 35.5902786254883, 0.621167543716932, -87.1022186279297, -1.52022050084931, 218, 50, 'PPL', 'P'),
(125843, 'Pleasant Hills', 42.4555587768555, 0.740989286430105, -71.0138931274414, -1.23942624973323, 218, 23, 'PPL', 'P'),
(166032, 'Pleasant Hills', 40.3194389343262, 0.703706961960785, -76.807502746582, -1.34054381316244, 218, 45, 'PPL', 'P'),
(37723, 'Pleasant Home', 38.5013885498047, 0.671975996783737, -84.9136123657227, -1.48202211554403, 218, 21, 'PPL', 'P'),
(157178, 'Pleasant Home', 40.9155616760254, 0.714111266549453, -82.1091690063477, -1.43307534523725, 218, 41, 'PPL', 'P'),
(201412, 'Pleasant Home', 45.464168548584, 0.793499432854442, -122.33528137207, -2.13515345129631, 218, 43, 'PPL', 'P'),
(11280, 'Pleasant Home (historical)', 34.0930595397949, 0.595036141047884, -93.6272201538086, -1.63410326117355, 218, 4, 'PPL', 'P'),
(56948, 'Pleasant Hope', 37.4630584716797, 0.653853718197965, -93.2724990844727, -1.62791221058744, 218, 29, 'PPL', 'P'),
(128557, 'Pleasant Island', 44.9977798461914, 0.785359414403588, -70.8372192382813, -1.23634270866508, 218, 26, 'PPL', 'P'),
(123451, 'Pleasant Lake', 41.5752792358398, 0.725625510101437, -85.01611328125, -1.48381109400629, 218, 19, 'PPL', 'P'),
(125844, 'Pleasant Lake', 41.7138900756836, 0.728044725635665, -70.0827789306641, -1.2231752412874, 218, 23, 'PPL', 'P'),
(132652, 'Pleasant Lake', 42.3800010681152, 0.739670555637325, -84.3491668701172, -1.47217068319767, 218, 27, 'PPL', 'P'),
(137519, 'Pleasant Lake', 45.4977798461914, 0.794086060663559, -94.2863922119141, -1.64560798392464, 218, 28, 'PPL', 'P'),
(140714, 'Pleasant Lake', 48.3613891601563, 0.844065471683022, -99.8016662597656, -1.74186767520944, 218, 34, 'PPL', 'P'),
(83066, 'Pleasant Lane', 33.915828704834, 0.591942879441757, -81.9905624389648, -1.43100527012193, 218, 48, 'PPL', 'P'),
(105326, 'Pleasant Manor', 37.0169410705566, 0.646067500697928, -76.366943359375, -1.33285460130511, 218, 53, 'PPL', 'P'),
(71296, 'Pleasant Mills', 39.639720916748, 0.691843644568918, -74.6616668701172, -1.30309191191071, 218, 37, 'PPL', 'P'),
(123452, 'Pleasant Mills', 40.7777786254883, 0.711706498664138, -84.8422164916992, -1.48077602246998, 218, 19, 'PPL', 'P'),
(28279, 'Pleasant Mound', 38.8630599975586, 0.678288354357497, -89.290283203125, -1.55840943193272, 218, 18, 'PPL', 'P'),
(56949, 'Pleasant Mount', 38.3763885498047, 0.669794335218744, -92.5224990844727, -1.61482224119749, 218, 29, 'PPL', 'P'),
(166034, 'Pleasant Mount', 41.7397193908691, 0.728495532229189, -75.4347229003906, -1.31658428494138, 218, 45, 'PPL', 'P'),
(50467, 'Pleasant Oaks', 39.4505615234375, 0.688542190344575, -77.3236083984375, -1.34955155607547, 218, 25, 'PPL', 'P'),
(197266, 'Pleasant Park Mobile Home Court', 47.478328704834, 0.828653159243488, -111.306938171387, -1.94267255140445, 218, 31, 'PPL', 'P'),
(73927, 'Pleasant Plain', 39.2794418334961, 0.685555588340105, -84.1122207641602, -1.46803519349894, 218, 41, 'PPL', 'P'),
(83069, 'Pleasant Plain', 34.6161117553711, 0.60416512436954, -80.5680618286133, -1.40617795085967, 218, 48, 'PPL', 'P'),
(117330, 'Pleasant Plain', 41.1472206115723, 0.718154477716411, -91.85888671875, -1.60324002045868, 218, 16, 'PPL', 'P'),
(123453, 'Pleasant Plain', 40.6966705322266, 0.710290895386707, -85.545280456543, -1.49304680350863, 218, 19, 'PPL', 'P'),
(5141, 'Pleasant Plains', 31.3041706085205, 0.54636084672472, -85.2297210693359, -1.48753925321629, 218, 2, 'PPL', 'P'),
(11281, 'Pleasant Plains', 35.5499992370605, 0.620464535768179, -91.626106262207, -1.59917723505771, 218, 4, 'PPL', 'P'),
(28281, 'Pleasant Plains', 39.8727798461914, 0.695911290238878, -89.9211120605469, -1.56941947251133, 218, 18, 'PPL', 'P'),
(50468, 'Pleasant Plains', 39.0083312988281, 0.680823816873307, -76.4441680908203, -1.3342024271328, 218, 25, 'PPL', 'P'),
(67891, 'Pleasant Plains', 36.3494415283203, 0.634417435930349, -76.9805603027344, -1.34356423731276, 218, 33, 'PPL', 'P'),
(146062, 'Pleasant Plains', 40.0033302307129, 0.698189824288523, -74.2138900756836, -1.29527673253382, 218, 37, 'PPL', 'P'),
(151782, 'Pleasant Plains', 40.5238914489746, 0.707275331505383, -74.2161102294922, -1.29531548152768, 218, 40, 'PPL', 'P'),
(963, 'Pleasant Point', 35.1430587768555, 0.613362084878019, -87.3724975585938, -1.52493775808817, 218, 50, 'PPL', 'P'),
(83070, 'Pleasant Point', 32.4724998474121, 0.566752038690698, -80.6791687011719, -1.40811713160741, 218, 48, 'PPL', 'P'),
(97126, 'Pleasant Point', 32.4858283996582, 0.566984665811916, -97.1972198486328, -1.69641151014343, 218, 51, 'PPL', 'P'),
(105328, 'Pleasant Point', 37.1752815246582, 0.648831062961103, -76.7808303833008, -1.3400782926039, 218, 53, 'PPL', 'P'),
(128559, 'Pleasant Point', 44.957218170166, 0.784651479606817, -67.0427780151367, -1.1701172160478, 218, 26, 'PPL', 'P'),
(175869, 'Pleasant Point', 43.8372192382813, 0.765103810626608, -88.9361114501953, -1.55222796872654, 218, 57, 'PPL', 'P'),
(151783, 'Pleasant Point Crossing', 43.4986114501953, 0.759193989851614, -76.334716796875, -1.33229214168289, 218, 40, 'PPL', 'P'),
(128560, 'Pleasant Pond', 45.2566719055176, 0.789877933246098, -69.9422225952148, -1.22072207044927, 218, 26, 'PPL', 'P'),
(117331, 'Pleasant Prairie', 41.5244407653809, 0.72473821140525, -90.871940612793, -1.58601456136999, 218, 16, 'PPL', 'P'),
(175870, 'Pleasant Prairie', 42.5530586242676, 0.742690979787638, -87.9333267211914, -1.5347260735167, 218, 57, 'PPL', 'P'),
(197267, 'Pleasant Prairie', 48.5922203063965, 0.848094235201066, -105.081939697266, -1.83402583209942, 218, 31, 'PPL', 'P'),
(50469, 'Pleasant Prospect At Glen Elyn', 39.5402793884277, 0.690108062486514, -76.5019378662109, -1.33521069992151, 218, 25, 'PPL', 'P'),
(139396, 'Pleasant Retreat', 40.3672218322754, 0.704540930856144, -92.2169418334961, -1.6094892611146, 218, 29, 'PPL', 'P'),
(24035, 'Pleasant Retreat (historical)', 34.5763893127441, 0.603471836958765, -83.8375015258789, -1.46324043827236, 218, 13, 'PPL', 'P'),
(5147, 'Pleasant Ridge', 31.6644401550293, 0.552648736505965, -86.054443359375, -1.50193337259206, 218, 2, 'PPL', 'P'),
(11284, 'Pleasant Ridge', 36.4816703796387, 0.636725264751985, -93.6438903808594, -1.63439421152264, 218, 4, 'PPL', 'P'),
(17670, 'Pleasant Ridge', 30.6927795410156, 0.535690059579477, -86.1741714477539, -1.50402302194139, 218, 12, 'PPL', 'P'),
(28282, 'Pleasant Ridge', 38.7224998474121, 0.675835116940343, -89.977783203125, -1.57040857054018, 218, 18, 'PPL', 'P'),
(37724, 'Pleasant Ridge', 37.598331451416, 0.656214677083348, -86.9872207641602, -1.51821340949377, 218, 21, 'PPL', 'P'),
(50470, 'Pleasant Ridge', 39.4694404602051, 0.688871689950445, -77.3011093139648, -1.34915887297274, 218, 25, 'PPL', 'P'),
(61377, 'Pleasant Ridge', 34.5688896179199, 0.603340942591187, -88.836669921875, -1.55049238664413, 218, 30, 'PPL', 'P'),
(67893, 'Pleasant Ridge', 36.3194389343262, 0.633893791881012, -80.8877792358398, -1.41175807229171, 218, 33, 'PPL', 'P'),
(78955, 'Pleasant Ridge', 39.9280586242676, 0.696876086922787, -78.107780456543, -1.36323794039155, 218, 45, 'PPL', 'P'),
(90007, 'Pleasant Ridge', 36.0825004577637, 0.629758435340337, -85.3794403076172, -1.49015234687788, 218, 50, 'PPL', 'P'),
(97128, 'Pleasant Ridge', 32.1044387817383, 0.56032816124629, -94.334716796875, -1.64645140704187, 218, 51, 'PPL', 'P'),
(105329, 'Pleasant Ridge', 38.8444404602051, 0.67796338212548, -77.2099990844727, -1.34756869948586, 218, 53, 'PPL', 'P'),
(123455, 'Pleasant Ridge', 40.482780456543, 0.706557809328688, -84.9794387817383, -1.48317100323829, 218, 19, 'PPL', 'P'),
(132654, 'Pleasant Ridge', 42.4711112976074, 0.741260729124211, -83.142219543457, -1.4511054784493, 218, 27, 'PPL', 'P'),
(139397, 'Pleasant Ridge', 40.1705589294434, 0.701108515685195, -94.0141677856445, -1.64085677138188, 218, 29, 'PPL', 'P'),
(151784, 'Pleasant Ridge', 41.6474990844727, 0.726885984245372, -73.6486129760742, -1.28541078595952, 218, 40, 'PPL', 'P'),
(157179, 'Pleasant Ridge', 40.2319412231445, 0.702179838812707, -83.3105621337891, -1.45404361092193, 218, 41, 'PPL', 'P'),
(175873, 'Pleasant Ridge', 43.0547218322754, 0.751446654503491, -90.0733337402344, -1.57207624201479, 218, 57, 'PPL', 'P'),
(61378, 'Pleasant Ridge (historical)', 33.0625, 0.577049483940625, -89.716667175293, -1.56585123612478, 218, 30, 'PPL', 'P'),
(121068, 'Pleasant Ridge (historical)', 40.6930618286133, 0.710227911626926, -90.3566665649414, -1.5770213326849, 218, 18, 'PPL', 'P'),
(151785, 'Pleasant Ridge Corners', 44.6541709899902, 0.779362308523865, -73.4966735839844, -1.28275894330407, 218, 40, 'PPL', 'P'),
(50471, 'Pleasant Run', 39.5380592346191, 0.690069313492653, -76.8097229003906, -1.34058256215631, 218, 25, 'PPL', 'P'),
(73930, 'Pleasant Run', 39.2997207641602, 0.685909522448977, -84.563606262207, -1.47591335663561, 218, 41, 'PPL', 'P'),
(97129, 'Pleasant Run', 32.6005592346191, 0.568987096635547, -96.8788909912109, -1.6908556234773, 218, 51, 'PPL', 'P'),
(110928, 'Pleasant Run', 39.0441703796387, 0.681449326834339, -79.7236099243164, -1.39143948475495, 218, 58, 'PPL', 'P'),
(146063, 'Pleasant Run', 40.5613899230957, 0.70792980334327, -74.793327331543, -1.30538982045729, 218, 37, 'PPL', 'P'),
(166035, 'Pleasant Run', 40.348331451416, 0.704211231513192, -75.5419387817383, -1.31845555508133, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(73931, 'Pleasant Run Farm', 39.3030586242676, 0.685967779097822, -84.5480575561523, -1.47564198052053, 218, 41, 'PPL', 'P'),
(90011, 'Pleasant Shade', 36.378059387207, 0.634916911792793, -85.9497222900391, -1.50010564513594, 218, 50, 'PPL', 'P'),
(105335, 'Pleasant Shade', 36.7511100769043, 0.641427874604846, -77.647216796875, -1.35519958811531, 218, 53, 'PPL', 'P'),
(5148, 'Pleasant Site', 34.5419387817383, 0.602870561763652, -88.0652770996094, -1.53702904206935, 218, 2, 'PPL', 'P'),
(50473, 'Pleasant Springs', 38.690559387207, 0.675277650745162, -76.9019393920898, -1.34219204356109, 218, 25, 'PPL', 'P'),
(97130, 'Pleasant Springs', 31.3147201538086, 0.546544971024585, -95.9013900756836, -1.67379501406009, 218, 51, 'PPL', 'P'),
(137523, 'Pleasant Terrace Mobile Home Park', 45.077220916748, 0.78674592264611, -94.1805572509766, -1.64376081539256, 218, 28, 'PPL', 'P'),
(78956, 'Pleasant Union', 39.7636108398438, 0.694005931636981, -78.8702774047852, -1.37654602267479, 218, 45, 'PPL', 'P'),
(166040, 'Pleasant Unity', 40.2394409179688, 0.702310733180284, -79.4511108398438, -1.38668347852223, 218, 45, 'PPL', 'P'),
(90008, 'Pleasant Vale', 36.2552795410156, 0.632773999221661, -82.6972198486328, -1.44333876860425, 218, 50, 'PPL', 'P'),
(110925, 'Pleasant Vale', 39.1652793884277, 0.683563077791535, -79.6322174072266, -1.38984438442005, 218, 58, 'PPL', 'P'),
(128562, 'Pleasant Vale Corner', 44.9286117553711, 0.784152203481455, -69.3038864135742, -1.20958100234503, 218, 26, 'PPL', 'P'),
(5149, 'Pleasant Valley', 33.6130599975586, 0.586658568627795, -86.2536087036133, -1.50540946360489, 218, 2, 'PPL', 'P'),
(11294, 'Pleasant Valley', 34.8983306884766, 0.609090773963696, -94.0166702270508, -1.64090044722376, 218, 4, 'PPL', 'P'),
(24038, 'Pleasant Valley', 34.5744400024414, 0.603437815075839, -84.4588928222656, -1.47408576233754, 218, 13, 'PPL', 'P'),
(37726, 'Pleasant Valley', 37.4672203063965, 0.653926355916697, -82.5047225952148, -1.43997905773106, 218, 21, 'PPL', 'P'),
(42623, 'Pleasant Valley', 32.5608291625977, 0.568293676066717, -92.3894424438477, -1.61249996472694, 218, 22, 'PPL', 'P'),
(50478, 'Pleasant Valley', 39.392219543457, 0.687523930701783, -77.6588897705078, -1.35540331993871, 218, 25, 'PPL', 'P'),
(56956, 'Pleasant Valley', 37.1547203063965, 0.648472202004215, -94.3422164916992, -1.64658230140944, 218, 29, 'PPL', 'P'),
(67894, 'Pleasant Valley', 35.1105613708496, 0.61279489814486, -84.0163879394531, -1.46636259517631, 218, 33, 'PPL', 'P'),
(76968, 'Pleasant Valley', 35.9894409179688, 0.628134239970525, -97.3002777099609, -1.69821020914367, 218, 42, 'PPL', 'P'),
(83072, 'Pleasant Valley', 35.0016708374023, 0.610894399811952, -80.855827331543, -1.41120040635945, 218, 48, 'PPL', 'P'),
(90016, 'Pleasant Valley', 36.4077796936035, 0.635435628994114, -89.0405578613281, -1.5540509024927, 218, 50, 'PPL', 'P'),
(105333, 'Pleasant Valley', 38.3847198486328, 0.669939743814262, -78.8974990844727, -1.37702113061326, 218, 53, 'PPL', 'P'),
(113928, 'Pleasant Valley', 41.9122200012207, 0.731506235841523, -72.9883270263672, -1.27388662213247, 218, 8, 'PPL', 'P'),
(117357, 'Pleasant Valley', 41.5697212219238, 0.725528504458731, -90.4230575561523, -1.5781800740752, 218, 16, 'PPL', 'P'),
(121070, 'Pleasant Valley', 42.225830078125, 0.736979764250936, -90.0269393920898, -1.57126650788535, 218, 18, 'PPL', 'P'),
(123456, 'Pleasant Valley', 41.6941719055176, 0.7277005786438, -86.0744400024414, -1.50228237985292, 218, 19, 'PPL', 'P'),
(125845, 'Pleasant Valley', 42.3555603027344, 0.739243983809721, -71.7694396972656, -1.25261302502881, 218, 23, 'PPL', 'P'),
(132657, 'Pleasant Valley', 43.5097198486328, 0.759387867978971, -84.5880584716797, -1.47634012820029, 218, 27, 'PPL', 'P'),
(137524, 'Pleasant Valley', 46.538330078125, 0.812247088243191, -92.3847198486328, -1.6124175398912, 218, 28, 'PPL', 'P'),
(140717, 'Pleasant Valley', 48.3694381713867, 0.844205953430524, -97.8641662597656, -1.70805192095205, 218, 34, 'PPL', 'P'),
(142704, 'Pleasant Valley', 42.6127815246582, 0.743733341038295, -97.4263916015625, -1.70041131178462, 218, 35, 'PPL', 'P'),
(146071, 'Pleasant Valley', 40.7486114501953, 0.71119743542177, -74.6316680908203, -1.3025683344404, 218, 37, 'PPL', 'P'),
(151790, 'Pleasant Valley', 41.8261108398438, 0.730003347459364, -75.0258331298828, -1.3094478121683, 218, 40, 'PPL', 'P'),
(157181, 'Pleasant Valley', 41.3594398498535, 0.721858402160493, -81.6877822875977, -1.42572075957088, 218, 41, 'PPL', 'P'),
(166044, 'Pleasant Valley', 40.3788909912109, 0.704744596100508, -79.6738891601563, -1.39057169371375, 218, 45, 'PPL', 'P'),
(172409, 'Pleasant Valley', 44.5924987792969, 0.778285925390283, -72.8630599975586, -1.27170030003557, 218, 55, 'PPL', 'P'),
(175875, 'Pleasant Valley', 43.7211112976074, 0.76307734477414, -91.1733322143555, -1.59127483715512, 218, 57, 'PPL', 'P'),
(177266, 'Pleasant Valley', 40.0688896179199, 0.699334051450875, -80.6811065673828, -1.40815095375325, 218, 58, 'PPL', 'P'),
(184179, 'Pleasant Valley', 38.6830596923828, 0.675146756377585, -120.66194152832, -2.10594816151807, 218, 6, 'PPL', 'P'),
(192061, 'Pleasant Valley', 35.2580604553223, 0.615369242812585, -101.830558776855, -1.77727852980174, 218, 51, 'PPL', 'P'),
(195478, 'Pleasant Valley', 43.4447212219238, 0.758253427933625, -116.246109008789, -2.02887734483561, 218, 17, 'PPL', 'P'),
(200135, 'Pleasant Valley', 40.7180595397949, 0.710664203992508, -115.516670227051, -2.01614623640254, 218, 39, 'PPL', 'P'),
(201415, 'Pleasant Valley', 45.3655586242676, 0.791778364999978, -123.802780151367, -2.16076613676404, 218, 43, 'PPL', 'P'),
(208455, 'Pleasant Valley', 48.9066696166992, 0.853582410996474, -122.703330993652, -2.14157712900364, 218, 56, 'PPL', 'P'),
(212093, 'Pleasant Valley', 64.8813934326172, 1.132393938681, -146.868606567383, -2.563340752417, 218, 1, 'PPL', 'P'),
(5150, 'Pleasant Valley (historical)', 33.8694381713867, 0.591133211891346, -85.8222198486328, -1.49788030772907, 218, 2, 'PPL', 'P'),
(33640, 'Pleasant Valley (historical)', 37.1124992370605, 0.64773530533059, -96.9686126708984, -1.69242156219827, 218, 20, 'PPL', 'P'),
(90015, 'Pleasant Valley (historical)', 35.0608291625977, 0.611926907366575, -87.7486114501953, -1.5315021838591, 218, 50, 'PPL', 'P'),
(157185, 'Pleasant Valley (historical)', 40.4902801513672, 0.706688703696265, -82.352783203125, -1.43732721507561, 218, 41, 'PPL', 'P'),
(189255, 'Pleasant Valley (historical)', 35.0424995422363, 0.61160699514063, -103.331108093262, -1.80346805596158, 218, 38, 'PPL', 'P'),
(190622, 'Pleasant Valley (historical)', 39.6833305358887, 0.692604776008463, -114.066673278809, -1.99083901551185, 218, 39, 'PPL', 'P'),
(197269, 'Pleasant Valley (historical)', 48.0569381713867, 0.838751799518041, -105.580558776855, -1.84272837675153, 218, 31, 'PPL', 'P'),
(197270, 'Pleasant Valley Colony', 47.3569412231445, 0.826534548017303, -111.08332824707, -1.938769821985, 218, 31, 'PPL', 'P'),
(97138, 'Pleasant Valley Crossing', 30.000280380249, 0.523603669156802, -98.1994400024414, -1.71390355165723, 218, 51, 'PPL', 'P'),
(146067, 'Pleasant Valley Crossroads', 40.3452796936035, 0.70415796829139, -74.1952819824219, -1.29495196003889, 218, 37, 'PPL', 'P'),
(73934, 'Pleasant Valley Estates', 38.8422203063965, 0.677924633131619, -82.2455596923828, -1.43545581177761, 218, 41, 'PPL', 'P'),
(166045, 'Pleasant Valley Estates', 40.9566688537598, 0.71482872214712, -75.5063934326172, -1.31783517170539, 218, 45, 'PPL', 'P'),
(205395, 'Pleasant Valley Estates', 41.1569404602051, 0.718324121077849, -111.951942443848, -1.95392999964833, 218, 52, 'PPL', 'P'),
(73935, 'Pleasant Valley Estates Mobile Home Park', 39.8944396972656, 0.696289325955615, -83.92138671875, -1.46470451108163, 218, 41, 'PPL', 'P'),
(117334, 'Pleasant Valley Mobile Home Park', 41.5805587768555, 0.725717655475154, -93.5277786254883, -1.63236767909115, 218, 16, 'PPL', 'P'),
(137526, 'Pleasant Valley Mobile Home Park', 43.6955604553223, 0.762631398449606, -92.3958282470703, -1.61261141801856, 218, 28, 'PPL', 'P'),
(184181, 'Pleasant Valley Mobile Home Park', 34.1561088562012, 0.596136559210305, -119.175277709961, -2.08000098301743, 218, 6, 'PPL', 'P'),
(195481, 'Pleasant Valley Place', 42.5405616760254, 0.74247286689436, -116.836387634277, -2.03917965035453, 218, 17, 'PPL', 'P'),
(97134, 'Pleasant Valley Ranch Colonia', 26.2399997711182, 0.45797439172857, -98.4069976806641, -1.71752611653001, 218, 51, 'PPL', 'P'),
(171097, 'Pleasant Vally Development', 45.5188903808594, 0.794454509000372, -98.5794372558594, -1.72053575487791, 218, 49, 'PPL', 'P'),
(5152, 'Pleasant View', 34.2347183227539, 0.597508553224886, -86.7655563354492, -1.51434463537821, 218, 2, 'PPL', 'P'),
(11297, 'Pleasant View', 35.4836082458496, 0.619305794377885, -94.0175018310547, -1.6409149614517, 218, 4, 'PPL', 'P'),
(24039, 'Pleasant View', 34.2425003051758, 0.59764437444048, -83.9072189331055, -1.46445723657441, 218, 13, 'PPL', 'P'),
(30863, 'Pleasant View', 39.663330078125, 0.692255702168581, -85.9416732788086, -1.49996516338844, 218, 19, 'PPL', 'P'),
(37727, 'Pleasant View', 36.6777801513672, 0.640148025963982, -84.1286087036133, -1.46832121700001, 218, 21, 'PPL', 'P'),
(50481, 'Pleasant View', 39.2219390869141, 0.684551976083309, -76.7819366455078, -1.3400976005218, 218, 25, 'PPL', 'P'),
(67895, 'Pleasant View', 35.8891716003418, 0.626384210239207, -76.2330627441406, -1.33051794376468, 218, 33, 'PPL', 'P'),
(83074, 'Pleasant View', 34.9336090087891, 0.609706496807722, -82.6880569458008, -1.44317884578079, 218, 48, 'PPL', 'P'),
(90024, 'Pleasant view', 36.1836090087891, 0.631523112457651, -83.4277801513672, -1.45608945127133, 218, 50, 'PPL', 'P'),
(105334, 'Pleasant View', 37.6061096191406, 0.656350431719915, -79.2441711425781, -1.38307169945187, 218, 53, 'PPL', 'P'),
(110934, 'Pleasant View', 39.2097206115723, 0.684338723459021, -81.57861328125, -1.42381540096899, 218, 58, 'PPL', 'P'),
(121072, 'Pleasant View', 40.1030616760254, 0.699930466376999, -90.4647216796875, -1.57890725021084, 218, 18, 'PPL', 'P'),
(132658, 'Pleasant View', 45.5072212219238, 0.794250843756008, -84.914436340332, -1.48203649661392, 218, 27, 'PPL', 'P'),
(157186, 'Pleasant View', 40.8311080932617, 0.712637273465121, -81.341667175293, -1.41967991127026, 218, 41, 'PPL', 'P'),
(166050, 'Pleasant View', 40.4566688537598, 0.706102075887148, -77.491943359375, -1.35248955539005, 218, 45, 'PPL', 'P'),
(184182, 'Pleasant View', 35.8055610656738, 0.624924931119898, -118.639999389648, -2.07065861391343, 218, 6, 'PPL', 'P'),
(187216, 'Pleasant View', 37.5894393920898, 0.656059481370823, -108.764442443848, -1.89829762974101, 218, 7, 'PPL', 'P'),
(195479, 'Pleasant View', 47.686939239502, 0.83229409992779, -117.011390686035, -2.04223402980874, 218, 17, 'PPL', 'P'),
(197271, 'Pleasant View', 47.0361099243164, 0.820934985509302, -104.929443359375, -1.83136426890599, 218, 31, 'PPL', 'P'),
(205400, 'Pleasant View', 40.2608299255371, 0.702684041786086, -111.655281066895, -1.948752281857, 218, 52, 'PPL', 'P'),
(83075, 'Pleasant View (historical)', 34.1211090087891, 0.595525696635268, -79.9658279418945, -1.39566698666934, 218, 48, 'PPL', 'P'),
(117342, 'Pleasant View (historical)', 40.8252792358398, 0.71253554071148, -92.3791732788086, -1.61232073398558, 218, 16, 'PPL', 'P'),
(166051, 'Pleasant View Acres', 40.2566719055176, 0.702611470646381, -75.5800018310547, -1.31911988061525, 218, 45, 'PPL', 'P'),
(50482, 'Pleasant View Estates', 39.5902786254883, 0.690980713796706, -77.7680587768555, -1.3573086785406, 218, 25, 'PPL', 'P'),
(90023, 'Pleasant View Estates', 35.8605613708496, 0.625884867534817, -85.0130615234375, -1.48375783078449, 218, 50, 'PPL', 'P'),
(166052, 'Pleasant View Heights', 40.0905609130859, 0.699712286904694, -80.0819396972656, -1.39769351910084, 218, 45, 'PPL', 'P'),
(166053, 'Pleasant View Lake', 40.9174995422363, 0.714145088695296, -75.4602813720703, -1.31703036442397, 218, 45, 'PPL', 'P'),
(194378, 'Pleasant View Ridge', 40.1166687011719, 0.700167953767206, -105.055000305176, -1.83355565100897, 218, 7, 'PPL', 'P'),
(166054, 'Pleasant View Summit', 41.2122192382813, 0.719288917761757, -75.6638870239258, -1.32058395342452, 218, 45, 'PPL', 'P'),
(30857, 'Pleasant View Village', 39.333610534668, 0.686501010527083, -85.9736099243164, -1.50052256300459, 218, 19, 'PPL', 'P'),
(50483, 'Pleasant Walk', 39.5397186279297, 0.690098275369508, -77.5863876342773, -1.35413791894675, 218, 25, 'PPL', 'P'),
(110936, 'Pleasantdale', 39.5022201538086, 0.689443803531621, -79.6841735839844, -1.39075119077122, 218, 58, 'PPL', 'P'),
(128563, 'Pleasantdale', 43.6330604553223, 0.76154056766711, -70.269172668457, -1.22642842571699, 218, 26, 'PPL', 'P'),
(146068, 'Pleasantdale', 40.8102798461914, 0.712273751976325, -74.2608337402344, -1.29609605404319, 218, 37, 'PPL', 'P'),
(151792, 'Pleasantdale', 42.7963905334473, 0.746937922777987, -73.6672210693359, -1.28573555845445, 218, 40, 'PPL', 'P'),
(209671, 'Pleasantdale', 44.0761108398438, 0.769273255629237, -105.718887329102, -1.84514266543774, 218, 59, 'PPL', 'P'),
(820, 'Pleasanton', 39.2405586242676, 0.684876948315326, -82.0933303833008, -1.4327989091161, 218, 41, 'PPL', 'P'),
(33652, 'Pleasanton', 38.1777801513672, 0.666327964743897, -94.7111129760742, -1.65302075966082, 218, 20, 'PPL', 'P'),
(97135, 'Pleasanton', 28.9669399261475, 0.505568475938676, -98.4783325195313, -1.71877114433962, 218, 51, 'PPL', 'P'),
(117354, 'Pleasanton', 40.5805587768555, 0.708264362955211, -93.7436065673828, -1.63613458729501, 218, 16, 'PPL', 'P'),
(132660, 'Pleasanton', 44.4736099243164, 0.776210923426947, -86.1208267211914, -1.5030919808243, 218, 27, 'PPL', 'P'),
(142708, 'Pleasanton', 40.9674987792969, 0.715017740005488, -99.0861129760742, -1.72937891443557, 218, 35, 'PPL', 'P'),
(184183, 'Pleasanton', 37.6624984741211, 0.657334602900754, -121.873611450195, -2.12709579110217, 218, 6, 'PPL', 'P'),
(187217, 'Pleasanton', 38.3650016784668, 0.669595596822397, -105.747222900391, -1.84563721445216, 218, 7, 'PPL', 'P'),
(189256, 'Pleasanton', 33.2722206115723, 0.580709799121857, -108.872222900391, -1.90017875357699, 218, 38, 'PPL', 'P'),
(14430, 'Pleasanton Acres', 39.2000007629395, 0.684169080097583, -75.5041732788086, -1.31779642271153, 218, 10, 'PPL', 'P'),
(110937, 'Pleasants', 39.3238906860352, 0.686331367165645, -81.1805572509766, -1.4168680126333, 218, 58, 'PPL', 'P'),
(151793, 'Pleasantside', 41.2775001525879, 0.72042828465512, -73.8963928222656, -1.28973536009564, 218, 40, 'PPL', 'P'),
(146069, 'Pleasantview', 40.4775009155273, 0.706465663954971, -74.6558303833008, -1.30299004599902, 218, 37, 'PPL', 'P'),
(195480, 'Pleasantview', 42.1561088562012, 0.735762899369851, -112.336936950684, -1.96064942139471, 218, 17, 'PPL', 'P'),
(90025, 'Pleasantview Acres', 36.1791687011719, 0.63144561446993, -83.4333267211914, -1.45618625717696, 218, 50, 'PPL', 'P'),
(14431, 'Pleasantville', 39.663890838623, 0.692265489285587, -75.6263885498047, -1.31992948158663, 218, 10, 'PPL', 'P'),
(30861, 'Pleasantville', 38.9669418334961, 0.680101434427623, -87.2502822875977, -1.52280469921307, 218, 19, 'PPL', 'P'),
(50486, 'Pleasantville', 39.3397216796875, 0.686607670128741, -77.7380599975586, -1.35678510107029, 218, 25, 'PPL', 'P'),
(67898, 'Pleasantville', 36.3772201538086, 0.634902264406798, -79.8377838134766, -1.3934321950406, 218, 33, 'PPL', 'P'),
(73944, 'Pleasantville', 39.8097190856934, 0.694810672339376, -82.522216796875, -1.44028438915004, 218, 41, 'PPL', 'P'),
(90026, 'Pleasantville', 35.6669387817383, 0.622505515848588, -87.6983337402344, -1.53062467227992, 218, 50, 'PPL', 'P'),
(117355, 'Pleasantville', 41.3858299255371, 0.722318995871022, -93.269172668457, -1.62785415367568, 218, 16, 'PPL', 'P'),
(146070, 'Pleasantville', 40.7330589294434, 0.710925992727663, -74.4880599975586, -1.30006190038048, 218, 37, 'PPL', 'P'),
(151795, 'Pleasantville', 41.1327781677246, 0.717902409519235, -73.7930603027344, -1.28793186740544, 218, 40, 'PPL', 'P'),
(166057, 'Pleasantville', 41.5922203063965, 0.725921187561463, -79.579719543457, -1.388928123847, 218, 45, 'PPL', 'P'),
(175878, 'Pleasantville', 44.4536094665527, 0.775861849587065, -91.3047180175781, -1.59356795201173, 218, 57, 'PPL', 'P'),
(157196, 'Pleasantville (historical)', 40.2333297729492, 0.702204073578626, -81.9638900756836, -1.43053974956338, 218, 41, 'PPL', 'P'),
(205399, 'Pleasure Acres', 40.6230583190918, 0.709006119897825, -111.879173278809, -1.95265993812447, 218, 52, 'PPL', 'P'),
(113926, 'Pleasure Beach', 41.310001373291, 0.720995537967307, -72.1458282470703, -1.25918224448971, 218, 8, 'PPL', 'P'),
(11299, 'Pleasure Heights', 36.2361106872559, 0.63243943960972, -94.0152816772461, -1.64087621245784, 218, 4, 'PPL', 'P'),
(30862, 'Pleasure Valley', 39.4008293151855, 0.68767419956629, -85.708610534668, -1.49589745113945, 218, 19, 'PPL', 'P'),
(110939, 'Pleasure Valley', 39.105281829834, 0.682515922850916, -79.8444366455078, -1.39354830886413, 218, 58, 'PPL', 'P'),
(37730, 'Pleasureville', 38.4780616760254, 0.671568866032091, -83.6036071777344, -1.45915821179543, 218, 21, 'PPL', 'P'),
(112523, 'Pleasureville', 39.996940612793, 0.698078304417876, -76.7069396972656, -1.33878865684603, 218, 45, 'PPL', 'P'),
(177743, 'Pledger', 32.7588882446289, 0.57175045916164, -100.287780761719, -1.75035197381022, 218, 51, 'PPL', 'P'),
(192062, 'Plemons', 35.8008308410645, 0.624842373126105, -101.308609008789, -1.76816878781896, 218, 51, 'PPL', 'P'),
(24042, 'Plentitude (historical)', 32.9683303833008, 0.575405914073883, -83.6416702270508, -1.45982253732935, 218, 13, 'PPL', 'P'),
(202499, 'Plenty Bears', 43.2730598449707, 0.755257371707286, -101.841667175293, -1.7774724079291, 218, 49, 'PPL', 'P'),
(197272, 'Plentywood', 48.7747192382813, 0.851279442443828, -104.561943054199, -1.82495017857859, 218, 31, 'PPL', 'P'),
(11300, 'Pless (historical)', 35.4041709899902, 0.61791935271439, -93.2649993896484, -1.62778131621987, 218, 4, 'PPL', 'P'),
(117356, 'Plessis', 43.2336082458496, 0.754568811407446, -95.5477828979492, -1.66762340454994, 218, 16, 'PPL', 'P'),
(151796, 'Plessis', 44.2702789306641, 0.772662128116362, -75.8547210693359, -1.32391463584183, 218, 40, 'PPL', 'P'),
(5153, 'Pletcher', 32.7027816772461, 0.570771214828818, -86.7850036621094, -1.51468405525915, 218, 2, 'PPL', 'P'),
(151797, 'Pletchers Corners', 43.1202812194824, 0.752590881665844, -78.9974975585938, -1.37876643323364, 218, 40, 'PPL', 'P'),
(42624, 'Plettenberg', 30.8777809143066, 0.538918942664116, -91.4922180175781, -1.59684044435922, 218, 22, 'PPL', 'P'),
(5154, 'Plevna', 34.961669921875, 0.610196252132187, -86.4166717529297, -1.5082554507038, 218, 2, 'PPL', 'P'),
(33653, 'Plevna', 37.9722213745117, 0.662740287281396, -98.3083267211914, -1.71580398341111, 218, 20, 'PPL', 'P'),
(56959, 'Plevna', 39.9736099243164, 0.697671107087203, -92.0861129760742, -1.60720586679597, 218, 29, 'PPL', 'P'),
(123463, 'Plevna', 40.535831451416, 0.707483723860681, -85.9761123657227, -1.50056623884647, 218, 19, 'PPL', 'P'),
(197273, 'Plevna', 46.4180603027344, 0.810147984671991, -104.519996643066, -1.82421807559493, 218, 31, 'PPL', 'P'),
(201416, 'Plevna (historical)', 42.1375007629395, 0.735438126874916, -121.912498474121, -2.12777449770598, 218, 43, 'PPL', 'P'),
(56958, 'Plew', 37.1927795410156, 0.649136460959108, -94.0366668701172, -1.64124945448462, 218, 29, 'PPL', 'P'),
(184184, 'Pleyto', 35.860279083252, 0.6258799406868, -120.992500305176, -2.11171750054556, 218, 6, 'PPL', 'P'),
(184186, 'Pleyto (historical)', 35.8611106872559, 0.625894454914741, -120.996109008789, -2.11178048430534, 218, 6, 'PPL', 'P'),
(125846, 'Plimoth Commons Mobile Home Park', 41.8583297729492, 0.730565673923534, -70.5588912963867, -1.23148496967872, 218, 23, 'PPL', 'P'),
(125847, 'Plimptonville', 42.1597213745117, 0.735825949708659, -71.2375030517578, -1.24332897915268, 218, 23, 'PPL', 'P'),
(110940, 'Pliny', 38.6202812194824, 0.674051065326099, -81.9875030517578, -1.43095187374207, 218, 58, 'PPL', 'P'),
(157197, 'Pliny (historical)', 41.2152786254883, 0.719342314141613, -81.9036102294922, -1.42948766777475, 218, 41, 'PPL', 'P'),
(178900, 'Plomosa', 33.6341705322266, 0.587027016964607, -114.117218017578, -1.99172118762293, 218, 5, 'PPL', 'P'),
(67899, 'Plott Farm Addition', 35.5119400024414, 0.619800276813286, -82.8516693115234, -1.44603442025963, 218, 33, 'PPL', 'P'),
(42625, 'Ploup', 30.7049999237061, 0.535903345493278, -91.482780456543, -1.5966757278458, 218, 22, 'PPL', 'P'),
(128564, 'Plourde Mill', 47.1655616760254, 0.823194344799098, -68.6166687011719, -1.19758679058559, 218, 26, 'PPL', 'P'),
(97137, 'Plover', 32.5913887023926, 0.568827040654033, -97.4852828979492, -1.70143915880733, 218, 51, 'PPL', 'P'),
(117358, 'Plover', 42.8783302307129, 0.74836804028336, -94.6202774047852, -1.6514353798639, 218, 16, 'PPL', 'P'),
(175879, 'Plover', 44.4563903808594, 0.775910385697932, -89.5438919067383, -1.56283573882249, 218, 57, 'PPL', 'P'),
(125848, 'Plowed Neck', 41.7416687011719, 0.728529554112114, -70.4416732788086, -1.22943912932932, 218, 23, 'PPL', 'P'),
(24043, 'Plowshare (historical)', 33.5986099243164, 0.586406367272564, -85.1380615234375, -1.48593949234948, 218, 13, 'PPL', 'P'),
(166060, 'Plowville', 40.214168548584, 0.70186964712474, -75.9094390869141, -1.32486964540873, 218, 45, 'PPL', 'P'),
(97139, 'Pluck', 31.0111103057861, 0.541245979535114, -94.7433319091797, -1.65358308612499, 218, 51, 'PPL', 'P'),
(146072, 'Pluckemin', 40.6455612182617, 0.709398869579585, -74.6394424438477, -1.30270402249794, 218, 37, 'PPL', 'P'),
(157199, 'Pluggys Town (historical)', 40.2999992370605, 0.703367675237909, -83.0666732788086, -1.4497869473936, 218, 41, 'PPL', 'P'),
(175883, 'Plugtown', 43.2224998474121, 0.754374933280088, -90.7483291625977, -1.58385713457092, 218, 57, 'PPL', 'P'),
(37731, 'Plum', 38.1788902282715, 0.666347339240827, -84.0313873291016, -1.46662438391147, 218, 21, 'PPL', 'P'),
(97140, 'Plum', 29.9347190856934, 0.522459408704936, -96.9672164916992, -1.6923971942743, 218, 51, 'PPL', 'P'),
(166061, 'Plum', 40.5002784729004, 0.706863207326693, -79.7497177124023, -1.39189515161746, 218, 45, 'PPL', 'P'),
(113927, 'Plum Bank Beach', 41.2680587768555, 0.720263501562672, -72.3927764892578, -1.26349230439789, 218, 8, 'PPL', 'P'),
(11302, 'Plum Bayou (historical)', 34.4666709899902, 0.601556890976943, -92.0555572509766, -1.60667256878768, 218, 4, 'PPL', 'P'),
(169548, 'Plum Beach', 41.524169921875, 0.724733484294315, -71.416389465332, -1.24645113605664, 218, 47, 'PPL', 'P'),
(83078, 'Plum Branch', 33.8486099243164, 0.59076969040255, -82.2600021362305, -1.43570787997479, 218, 48, 'PPL', 'P'),
(175884, 'Plum City', 44.6291694641113, 0.778925949579256, -92.1922225952148, -1.60905782901801, 218, 57, 'PPL', 'P'),
(166062, 'Plum Corner', 41.5319404602051, 0.724869105772828, -79.8649978637695, -1.39390716982102, 218, 45, 'PPL', 'P'),
(90027, 'Plum Creek', 35.9411087036133, 0.627290683695243, -84.1358337402344, -1.46844731767763, 218, 50, 'PPL', 'P'),
(97141, 'Plum Creek', 31.5980606079102, 0.551490194852753, -95.9852828979492, -1.67525922002742, 218, 51, 'PPL', 'P'),
(105336, 'Plum Creek', 36.8111114501953, 0.642475096124493, -81.7413864135742, -1.42665632806183, 218, 53, 'PPL', 'P'),
(56960, 'Plum Ford', 38.2775001525879, 0.668068407095291, -90.9972229003906, -1.588201149783, 218, 29, 'PPL', 'P'),
(61380, 'Plum Grove', 33.3097190856934, 0.581364270959744, -88.4402770996094, -1.54357402676432, 218, 30, 'PPL', 'P'),
(97143, 'Plum Grove', 30.2144393920898, 0.527341449036242, -95.0947189331055, -1.65971594664128, 218, 51, 'PPL', 'P'),
(28286, 'Plum Hill', 38.3627815246582, 0.669556847828536, -89.5086135864258, -1.56222001597846, 218, 18, 'PPL', 'P'),
(125849, 'Plum Island', 42.8125, 0.747219086010072, -70.8138885498047, -1.2359355113344, 218, 23, 'PPL', 'P'),
(24044, 'Plum Nelly', 34.7922210693359, 0.607238811741654, -85.4861068725586, -1.4920140296379, 218, 13, 'PPL', 'P'),
(17671, 'Plum Orchard', 30.1513900756836, 0.526241030873821, -84.148063659668, -1.468660770039, 218, 12, 'PPL', 'P'),
(24045, 'Plum Orchard', 33.5972213745117, 0.586382132506644, -83.9633331298828, -1.46543661406529, 218, 13, 'PPL', 'P'),
(110941, 'Plum Orchard', 38.7052803039551, 0.675534579211328, -81.6269378662109, -1.42465882408622, 218, 58, 'PPL', 'P'),
(42626, 'Plum Orchard Landing', 32.4141693115234, 0.565733978784988, -93.376106262207, -1.62972049696761, 218, 22, 'PPL', 'P'),
(50487, 'Plum Point', 38.6141700744629, 0.673944405724441, -76.5124969482422, -1.33539499066894, 218, 25, 'PPL', 'P'),
(61379, 'Plum Point', 34.9794387817383, 0.610506377241127, -89.954719543457, -1.57000603374142, 218, 30, 'PPL', 'P'),
(105337, 'Plum Point', 37.5163917541504, 0.654784559577975, -76.8138885498047, -1.34065526645406, 218, 53, 'PPL', 'P'),
(169549, 'Plum Point', 41.5305595397949, 0.724845004164962, -71.4227828979492, -1.24656272250631, 218, 47, 'PPL', 'P'),
(67900, 'Plum Point Estates', 34.7363891601563, 0.606264361098794, -77.4836120605469, -1.35234414679453, 218, 33, 'PPL', 'P'),
(14432, 'Plum Run', 39.7347183227539, 0.693501662084575, -75.7027816772461, -1.32126279318638, 218, 10, 'PPL', 'P'),
(78962, 'Plum Run', 39.7655601501465, 0.694039953519907, -78.1180572509766, -1.36341730429097, 218, 45, 'PPL', 'P'),
(110942, 'Plum Run', 39.3747215270996, 0.687218532703778, -80.9997177124023, -1.41371176726739, 218, 58, 'PPL', 'P'),
(5156, 'Plum Springs', 33.6236114501953, 0.586842726217174, -86.0250015258789, -1.50141951565973, 218, 2, 'PPL', 'P'),
(37732, 'Plum Springs', 37.0183296203613, 0.646091735463848, -86.3813934326172, -1.50763972785978, 218, 21, 'PPL', 'P'),
(105338, 'Plum Tree', 38.0125007629395, 0.66344329523015, -77.772216796875, -1.35738124968031, 218, 53, 'PPL', 'P'),
(123464, 'Plum Tree', 40.7422218322754, 0.711085915551123, -85.3925018310547, -1.49038031346719, 218, 19, 'PPL', 'P'),
(205401, 'Plum Tree Condominium', 40.8536109924316, 0.71303002314688, -111.892501831055, -1.95289256524569, 218, 52, 'PPL', 'P'),
(201417, 'Plum Trees', 42.8141708374023, 0.747248247624009, -124.355560302734, -2.17041397044507, 218, 43, 'PPL', 'P'),
(56961, 'Plum Valley', 37.3600006103516, 0.652055019197726, -92.0824966430664, -1.60714274987813, 218, 29, 'PPL', 'P'),
(184187, 'Plum Valley', 39.4486083984375, 0.688508101882621, -120.959716796875, -2.11114532038536, 218, 6, 'PPL', 'P'),
(202501, 'Pluma', 44.3586082458496, 0.774203765492382, -103.737777709961, -1.8105657797408, 218, 49, 'PPL', 'P'),
(184188, 'Plumas', 39.7566719055176, 0.69388482438641, -120.082221984863, -2.09583014674658, 218, 6, 'PPL', 'P'),
(184190, 'Plumas Eureka (historical)', 39.7588882446289, 0.693923506801243, -120.706672668457, -2.10672886719163, 218, 6, 'PPL', 'P'),
(184191, 'Plumas Lake', 39.0208282470703, 0.681041929766584, -121.556938171387, -2.12156879973387, 218, 6, 'PPL', 'P'),
(208456, 'Plumb', 46.9283294677734, 0.819053861673325, -122.855003356934, -2.14422431112718, 218, 56, 'PPL', 'P'),
(184192, 'Plumbago', 39.452220916748, 0.688571152221429, -120.816673278809, -2.10864874002146, 218, 6, 'PPL', 'P'),
(113205, 'Plumbrook', 44.8355598449707, 0.782528141269697, -74.9072189331055, -1.30737760389492, 218, 40, 'PPL', 'P'),
(194379, 'Plumbs', 40.0877799987793, 0.699663750793827, -105.043327331543, -1.83335191918557, 218, 7, 'PPL', 'P'),
(157200, 'Plumbs Cross Roads (historical)', 41.0086097717285, 0.715735262182183, -84.3899993896484, -1.47288334510537, 218, 41, 'PPL', 'P'),
(146073, 'Plumbsock', 41.2186088562012, 0.719400437632404, -74.6711120605469, -1.30325676158219, 218, 37, 'PPL', 'P'),
(166064, 'Plumbsock', 40.0250015258789, 0.698568059742341, -80.2541732788086, -1.40069956218126, 218, 45, 'PPL', 'P'),
(125850, 'Plumbush', 42.7972183227539, 0.746952370426901, -70.8291702270508, -1.23620222691758, 218, 23, 'PPL', 'P'),
(113332, 'Plumer', 41.4991683959961, 0.724297125349706, -79.6419372558594, -1.39001402778148, 218, 45, 'PPL', 'P'),
(11303, 'Plumerville', 35.1599998474121, 0.613657762338045, -92.6405563354492, -1.61688272893288, 218, 4, 'PPL', 'P'),
(28288, 'Plumfield', 37.8913917541504, 0.661329544272954, -89.0066680908203, -1.55345941441459, 218, 18, 'PPL', 'P'),
(83076, 'Plumfield Landing', 34.5011100769043, 0.602157966434974, -79.8249969482422, -1.39320902214125, 218, 48, 'PPL', 'P'),
(50488, 'Plumgar', 39.1749992370605, 0.683732721152973, -77.2347183227539, -1.34800013158245, 218, 25, 'PPL', 'P'),
(11304, 'Plumlee (historical)', 36.0541687011719, 0.629263952904937, -93.2819366455078, -1.62807692710087, 218, 4, 'PPL', 'P'),
(17672, 'Plummer', 30.4436092376709, 0.531341217387918, -81.8077774047852, -1.42781506945212, 218, 12, 'PPL', 'P'),
(30864, 'Plummer', 38.9816703796387, 0.680358496051843, -86.9725036621094, -1.51795654760663, 218, 19, 'PPL', 'P'),
(56962, 'Plummer', 38.5613899230957, 0.673023218303383, -92.3225021362305, -1.61133163595672, 218, 29, 'PPL', 'P'),
(78960, 'Plummer', 39.8705596923828, 0.695872541245018, -79.8655624389648, -1.39391702351705, 218, 45, 'PPL', 'P'),
(137530, 'Plummer', 47.9113883972168, 0.836211476733242, -96.041389465332, -1.67623846436024, 218, 28, 'PPL', 'P'),
(195482, 'Plummer', 47.3352813720703, 0.826156512300566, -116.887496948242, -2.04007167616165, 218, 17, 'PPL', 'P'),
(125854, 'Plummer Corner', 42.1222190856934, 0.735171411291745, -71.648063659668, -1.2504946135397, 218, 23, 'PPL', 'P'),
(128567, 'Plummer Corner', 44.7802810668945, 0.781563344585789, -69.2880630493164, -1.20930483253999, 218, 26, 'PPL', 'P'),
(97144, 'Plummer Crossing', 29.1261100769043, 0.508346519140279, -97.9691696166992, -1.70988457525619, 218, 51, 'PPL', 'P'),
(195483, 'Plummer Junction', 47.3400001525879, 0.826238870557277, -116.868606567383, -2.0397419768187, 218, 17, 'PPL', 'P'),
(128565, 'Plummer Landing', 44.059440612793, 0.768982305280145, -70.6836090087891, -1.23366170439569, 218, 26, 'PPL', 'P'),
(128566, 'Plummer Mill', 43.9836082458496, 0.767658780797403, -70.1013870239258, -1.22350001378233, 218, 26, 'PPL', 'P'),
(175887, 'Plummer Point', 44.0875015258789, 0.769472060604611, -88.6291732788086, -1.54687088703579, 218, 57, 'PPL', 'P'),
(17673, 'Plummers', 30.1894397735596, 0.526905123381146, -81.6316680908203, -1.42474138208001, 218, 12, 'PPL', 'P'),
(37737, 'Plummers Landing', 38.3188896179199, 0.668790789540975, -83.5611114501953, -1.45841652143184, 218, 21, 'PPL', 'P'),
(37733, 'Plummers Mill', 38.3005599975586, 0.668470877315029, -83.5697174072266, -1.45856672371732, 218, 21, 'PPL', 'P'),
(97145, 'Plumosa Village Colonia', 26.1660003662109, 0.456682858468423, -98.1320037841797, -1.71272656761347, 218, 51, 'PPL', 'P'),
(78961, 'Plumsock', 39.9724998474121, 0.697651732590272, -75.4630584716797, -1.31707883395581, 218, 45, 'PPL', 'P'),
(166068, 'Plumsteadville', 40.3872184753418, 0.704889938116999, -75.1469421386719, -1.31156156312549, 218, 45, 'PPL', 'P'),
(67901, 'Plumtree', 36.0269393920898, 0.628788711808412, -82.008056640625, -1.43131060154091, 218, 33, 'PPL', 'P'),
(184193, 'Plumtree (historical)', 38.5724983215332, 0.673217096430741, -121.610000610352, -2.12249491400295, 218, 6, 'PPL', 'P'),
(50489, 'Plumtree Estates', 39.4977798461914, 0.6893663055439, -76.3433303833008, -1.33244247712642, 218, 25, 'PPL', 'P'),
(37734, 'Plumville', 38.601390838623, 0.673721365983147, -83.6744384765625, -1.46039445117344, 218, 21, 'PPL', 'P'),
(166069, 'Plumville', 40.7930603027344, 0.71197321424731, -79.1808319091797, -1.38196622128337, 218, 45, 'PPL', 'P'),
(61381, 'Plumville (historical)', 32.6680603027344, 0.57016521252277, -90.3083267211914, -1.57617764325157, 218, 30, 'PPL', 'P'),
(157201, 'Plumwood', 40.0080604553223, 0.698272382282315, -83.4155578613281, -1.45587613206802, 218, 41, 'PPL', 'P'),
(83077, 'Plunket (historical)', 33.6763916015625, 0.587763913638232, -81.6161117553711, -1.42446987280687, 218, 48, 'PPL', 'P'),
(24046, 'Plunket Town', 33.6519393920898, 0.587337142073547, -84.3944396972656, -1.47296084309309, 218, 13, 'PPL', 'P'),
(166071, 'Plunkett', 41.4383316040039, 0.723235323023091, -76.7249984741211, -1.33910384196104, 218, 45, 'PPL', 'P'),
(11306, 'Plunketts', 34.9097213745117, 0.60928957893907, -91.4061126708984, -1.59533762255609, 218, 4, 'PPL', 'P'),
(105339, 'Plunkettsville', 38.1511116027832, 0.665862510764378, -79.0941696166992, -1.38045367894226, 218, 53, 'PPL', 'P'),
(76974, 'Plunketville', 34.4141693115234, 0.600640563824874, -94.4883270263672, -1.64913241131125, 218, 42, 'PPL', 'P'),
(201418, 'Plush', 42.4116706848145, 0.74022329472157, -119.902778625488, -2.09269826930465, 218, 43, 'PPL', 'P'),
(37735, 'Plutarch', 37.8397216796875, 0.660427731348826, -83.0880584716797, -1.45016018942038, 218, 21, 'PPL', 'P'),
(151798, 'Plutarch', 41.7780609130859, 0.729164718032098, -74.0274963378906, -1.29202354810424, 218, 40, 'PPL', 'P'),
(182, 'Pluto', 37.7102813720703, 0.658168571796112, -80.9925003051758, -1.41358579974783, 218, 58, 'PPL', 'P'),
(61382, 'Pluto', 33.0533294677734, 0.576889427959111, -90.3811111450195, -1.57744797109153, 218, 30, 'PPL', 'P'),
(208457, 'Pluvius', 46.5483283996582, 0.812421591873619, -123.407783508301, -2.15387214480821, 218, 56, 'PPL', 'P'),
(67905, 'Plyer', 35.3711090087891, 0.617342312285197, -80.2825012207031, -1.40119397803764, 218, 33, 'PPL', 'P'),
(50490, 'Plyers Mill Estates', 39.0275001525879, 0.681158376485248, -77.0511093139648, -1.34479554984276, 218, 25, 'PPL', 'P'),
(187856, 'Plymell', 37.8097190856934, 0.659904087299489, -100.869438171387, -1.76050381072755, 218, 20, 'PPL', 'P'),
(14433, 'Plymouth', 39.0311088562012, 0.681221360245028, -75.5619430541992, -1.31880469550024, 218, 10, 'PPL', 'P'),
(17674, 'Plymouth', 28.6919403076172, 0.500768827153595, -81.5475006103516, -1.42327238242272, 218, 12, 'PPL', 'P'),
(33660, 'Plymouth', 38.413890838623, 0.670448873635658, -96.3319396972656, -1.68130952254991, 218, 20, 'PPL', 'P'),
(56963, 'Plymouth', 39.5966682434082, 0.691092233667353, -93.7016677856445, -1.6354026174694, 218, 29, 'PPL', 'P'),
(67902, 'Plymouth', 35.8666687011719, 0.625991460557447, -76.748893737793, -1.33952089298774, 218, 33, 'PPL', 'P'),
(105340, 'Plymouth', 37.0002784729004, 0.645776683506891, -78.1647186279297, -1.36423169895232, 218, 53, 'PPL', 'P'),
(110944, 'Plymouth', 38.5158309936523, 0.672228064980913, -81.8450012207031, -1.42846474760005, 218, 58, 'PPL', 'P'),
(113929, 'Plymouth', 41.6719398498535, 0.727312556072975, -73.0533294677734, -1.27502112875684, 218, 8, 'PPL', 'P'),
(117363, 'Plymouth', 43.2458305358887, 0.754782130610761, -93.1227798461914, -1.62529911692586, 218, 16, 'PPL', 'P'),
(121075, 'Plymouth', 40.2916717529297, 0.703222333221418, -90.9188919067383, -1.58683401603741, 218, 18, 'PPL', 'P'),
(123467, 'Plymouth', 41.3436088562012, 0.721582099197397, -86.3097229003906, -1.50638884109577, 218, 19, 'PPL', 'P'),
(125851, 'Plymouth', 41.9583282470703, 0.732310976543918, -70.6677780151367, -1.2333854014326, 218, 23, 'PPL', 'P'),
(128568, 'Plymouth', 44.767219543457, 0.781335377996478, -69.2108306884766, -1.20795687355425, 218, 26, 'PPL', 'P'),
(132663, 'Plymouth', 42.3713912963867, 0.739520286772817, -83.4702835083008, -1.45683127479297, 218, 27, 'PPL', 'P'),
(137532, 'Plymouth', 45.0105590820313, 0.785582454144882, -93.4552764892578, -1.6311022780992, 218, 28, 'PPL', 'P'),
(142716, 'Plymouth', 40.3030586242676, 0.703421071617765, -96.9886093139648, -1.69277056945913, 218, 35, 'PPL', 'P'),
(144333, 'Plymouth', 43.7569389343262, 0.763702654998091, -71.688606262207, -1.25120221544134, 218, 36, 'PPL', 'P'),
(151799, 'Plymouth', 42.6169395446777, 0.743805912178, -75.602783203125, -1.319517490566, 218, 40, 'PPL', 'P'),
(157203, 'Plymouth', 40.9955596923828, 0.715507495329954, -82.6672210693359, -1.44281519113394, 218, 41, 'PPL', 'P'),
(166072, 'Plymouth', 41.2402801513672, 0.719778673086223, -75.9449996948242, -1.32549029510077, 218, 45, 'PPL', 'P'),
(172410, 'Plymouth', 43.535831451416, 0.759843601420511, -72.7219390869141, -1.26923727550141, 218, 55, 'PPL', 'P'),
(175888, 'Plymouth', 43.7486114501953, 0.763557312981599, -87.976936340332, -1.53548720495624, 218, 57, 'PPL', 'P'),
(184194, 'Plymouth', 38.4819412231445, 0.671636576902806, -120.843612670898, -2.10911892111192, 218, 6, 'PPL', 'P'),
(205402, 'Plymouth', 41.875560760498, 0.730866411389631, -112.143333435059, -1.95727040260362, 218, 52, 'PPL', 'P'),
(208458, 'Plymouth', 45.9347190856934, 0.801712089024028, -119.349166870117, -2.08303592139568, 218, 56, 'PPL', 'P'),
(61383, 'Plymouth (historical)', 33.5230598449707, 0.585087769637839, -88.5016708374023, -1.54464554962892, 218, 30, 'PPL', 'P'),
(117361, 'Plymouth (historical)', 42.7322196960449, 0.745817930381554, -96.2083282470703, -1.67915209575084, 218, 16, 'PPL', 'P'),
(157204, 'Plymouth Center', 41.8369407653809, 0.730192365317732, -80.7541732788086, -1.40942620844123, 218, 41, 'PPL', 'P'),
(24048, 'Plymouth Colony', 33.8597183227539, 0.590963568529908, -84.2958297729492, -1.47123977523863, 218, 13, 'PPL', 'P'),
(105341, 'Plymouth Colony', 37.336109161377, 0.651638034750047, -79.9583282470703, -1.39553609230176, 218, 53, 'PPL', 'P'),
(117364, 'Plymouth Junction', 43.2275009155273, 0.754462218384815, -93.1305618286133, -1.62543493814145, 218, 16, 'PPL', 'P'),
(166074, 'Plymouth Junction', 41.2447204589844, 0.719856171073944, -75.9269409179688, -1.32517510998576, 218, 45, 'PPL', 'P'),
(166075, 'Plymouth Meeting', 40.1022186279297, 0.699915752411976, -75.2747192382813, -1.31379169422233, 218, 45, 'PPL', 'P'),
(125853, 'Plymouth Mobile Estates', 41.9513893127441, 0.732189869293346, -70.6988906860352, -1.23392841997887, 218, 23, 'PPL', 'P'),
(105343, 'Plymouth Park', 36.8194389343262, 0.642620438140984, -76.2516708374023, -1.33084271625961, 218, 53, 'PPL', 'P'),
(172411, 'Plymouth Union', 43.5299987792969, 0.759741802087843, -72.7391662597656, -1.26953794638848, 218, 55, 'PPL', 'P'),
(205403, 'Plymouth View', 40.6619415283203, 0.709684759922605, -111.936668395996, -1.95366341722321, 218, 52, 'PPL', 'P'),
(37736, 'Plymouth Village', 38.2386093139648, 0.667389633912457, -85.648063659668, -1.49484070881891, 218, 21, 'PPL', 'P'),
(125856, 'Plympton', 41.9527816772461, 0.732214170638293, -70.8150024414063, -1.23595495241036, 218, 23, 'PPL', 'P'),
(166079, 'Plymptonville', 41.0458297729492, 0.71638487375108, -78.4458312988281, -1.36913804062857, 218, 45, 'PPL', 'P'),
(166080, 'Plymtonville', 41.035831451416, 0.716210370120653, -78.4397201538086, -1.36903138102691, 218, 45, 'PPL', 'P'),
(73819, 'PO', 39.2999992370605, 0.685914382717966, -84.5638885498047, -1.47591828348362, 218, 41, 'PPL', 'P'),
(24047, 'Po Biddy Crossroads', 32.6902809143066, 0.570553035356513, -84.4719390869141, -1.47431346261074, 218, 13, 'PPL', 'P'),
(28289, 'Poag', 38.7969398498535, 0.677134340078138, -90.0388870239258, -1.5714750333987, 218, 18, 'PPL', 'P'),
(11307, 'Poage Addition', 34.9500007629395, 0.609992586887824, -91.9641723632813, -1.60507760161083, 218, 4, 'PPL', 'P'),
(105344, 'Poages Mill', 37.1980590820313, 0.649228606332825, -80.0566711425781, -1.39725249962432, 218, 53, 'PPL', 'P'),
(105345, 'Poages Mill Estates', 37.211109161377, 0.649456373185054, -80.0783309936523, -1.39763053534106, 218, 53, 'PPL', 'P'),
(61384, 'Poagville', 34.6827812194824, 0.605328726028822, -89.8625030517578, -1.56839655233663, 218, 30, 'PPL', 'P'),
(5157, 'Poarch', 31.1172199249268, 0.543097941757155, -87.5294418334961, -1.52767695242737, 218, 2, 'PPL', 'P'),
(105350, 'Poarch Store', 36.836669921875, 0.642921175607081, -77.727783203125, -1.35660573717088, 218, 53, 'PPL', 'P'),
(73945, 'Poast Town', 39.5472183227539, 0.690229169737085, -84.3833312988281, -1.47276696496573, 218, 41, 'PPL', 'P'),
(73946, 'Poast Town Heights', 39.583610534668, 0.690864333657069, -84.3833312988281, -1.47276696496573, 218, 41, 'PPL', 'P'),
(110943, 'Poca', 38.4722213745117, 0.671466933541368, -81.8144378662109, -1.4279313164337, 218, 58, 'PPL', 'P'),
(5158, 'Pocahontas', 33.8727798461914, 0.591191535119219, -87.4830627441406, -1.52686748461404, 218, 2, 'PPL', 'P'),
(11308, 'Pocahontas', 36.2613906860352, 0.632880658823319, -90.9711074829102, -1.58774534976243, 218, 4, 'PPL', 'P'),
(28290, 'Pocahontas', 38.8277816772461, 0.677672631513471, -89.5400009155273, -1.56276782821469, 218, 18, 'PPL', 'P'),
(56964, 'Pocahontas', 37.5011100769043, 0.654517843994804, -89.6388931274414, -1.56449382291717, 218, 29, 'PPL', 'P'),
(61385, 'Pocahontas', 32.4741706848145, 0.566781200304634, -90.2861099243164, -1.57578988699685, 218, 30, 'PPL', 'P'),
(78964, 'Pocahontas', 39.7411117553711, 0.693613248534249, -78.958610534668, -1.37808772662984, 218, 45, 'PPL', 'P'),
(90030, 'Pocahontas', 35.6372184753418, 0.621986798647268, -86.045280456543, -1.5017734497686, 218, 50, 'PPL', 'P'),
(105347, 'Pocahontas', 37.3036117553711, 0.651070848016887, -81.3397216796875, -1.41964595596636, 218, 53, 'PPL', 'P'),
(117366, 'Pocahontas', 42.7355613708496, 0.745876253609427, -94.6688919067383, -1.6522838629872, 218, 16, 'PPL', 'P'),
(201419, 'Pocahontas (historical)', 44.8144416809082, 0.78215955977483, -117.97110748291, -2.0589842478009, 218, 43, 'PPL', 'P'),
(105348, 'Pocahontas Acres', 37.4055595397949, 0.652850172520196, -77.5788879394531, -1.35400702457918, 218, 53, 'PPL', 'P'),
(208459, 'Pocahontas Bay', 48.0288887023926, 0.838262243930657, -117.372779846191, -2.04854146053448, 218, 56, 'PPL', 'P'),
(105349, 'Pocahontas Village', 36.8377799987793, 0.642940550104011, -76.1430587768555, -1.32894707819569, 218, 53, 'PPL', 'P'),
(83079, 'Pocalla Springs', 33.8716697692871, 0.591172160622288, -80.3544387817383, -1.40244952533355, 218, 48, 'PPL', 'P'),
(151801, 'Pocantico Hills', 41.0944404602051, 0.717233290295352, -73.8363876342773, -1.28868807199697, 218, 40, 'PPL', 'P'),
(76970, 'Pocasset', 35.1936111450195, 0.614244390147162, -97.9522171020508, -1.70958869805908, 218, 42, 'PPL', 'P'),
(125858, 'Pocasset', 41.6861114501953, 0.727559897159216, -70.6166687011719, -1.23249337562548, 218, 23, 'PPL', 'P'),
(169550, 'Pocasset', 41.7552795410156, 0.728767108081349, -71.4411087036133, -1.24688256815323, 218, 47, 'PPL', 'P'),
(169551, 'Pocasset Heights', 41.6300010681152, 0.726580586247367, -71.251106262207, -1.24356639996386, 218, 47, 'PPL', 'P'),
(125859, 'Pocasset Station', 41.6933288574219, 0.727685864678777, -70.6158294677734, -1.23247872823948, 218, 23, 'PPL', 'P'),
(110946, 'Pocatalico', 38.4902801513672, 0.671782118656379, -81.6474990844727, -1.4250176850431, 218, 58, 'PPL', 'P'),
(24049, 'Pocataligo', 34.1997184753418, 0.59689769064985, -83.2847213745117, -1.45359260459133, 218, 13, 'PPL', 'P'),
(195484, 'Pocatello', 42.8713912963867, 0.748246933032788, -112.444717407227, -1.96253054523068, 218, 17, 'PPL', 'P'),
(105351, 'Pocket', 36.7813911437988, 0.641956378923173, -83.0427780151367, -1.4493698963669, 218, 53, 'PPL', 'P'),
(56965, 'Pocohontas Crossing', 36.6852798461914, 0.640278920331559, -91.6866683959961, -1.60023424369436, 218, 29, 'PPL', 'P'),
(76972, 'Pocola', 35.2311096191406, 0.614898861985049, -94.477783203125, -1.64894838687993, 218, 42, 'PPL', 'P'),
(125860, 'Pocomo', 41.3138885498047, 0.721063381996077, -70.0208282470703, -1.22209399788483, 218, 23, 'PPL', 'P'),
(67904, 'Pocomoke', 36.0802803039551, 0.629719686346477, -78.5405578613281, -1.37079133103329, 218, 33, 'PPL', 'P'),
(50491, 'Pocomoke City', 38.0755615234375, 0.664543913129652, -75.5683288574219, -1.31891614879186, 218, 25, 'PPL', 'P'),
(195485, 'Pocono', 47.2466697692871, 0.82460994807653, -116.047782897949, -2.02541590120878, 218, 17, 'PPL', 'P'),
(166081, 'Pocono Country Place', 41.190559387207, 0.718910882045021, -75.3625030517578, -1.31532381079745, 218, 45, 'PPL', 'P'),
(166082, 'Pocono Farms East', 41.1597213745117, 0.718372657188716, -75.3475036621094, -1.31506202206229, 218, 45, 'PPL', 'P'),
(166083, 'Pocono Heights', 41.0844383239746, 0.717058720085898, -75.129997253418, -1.31126581908644, 218, 45, 'PPL', 'P'),
(166084, 'Pocono Lake', 41.105281829834, 0.717422507890803, -75.4763870239258, -1.31731146107703, 218, 45, 'PPL', 'P'),
(166085, 'Pocono Laurel Lake', 41.0213890075684, 0.715958301923477, -75.2808303833008, -1.31389835382398, 218, 45, 'PPL', 'P'),
(166086, 'Pocono Manor', 41.0999984741211, 0.717330295938059, -75.3591690063477, -1.31526562072763, 218, 45, 'PPL', 'P'),
(166089, 'Pocono Mountain Lake Estates', 41.1311111450195, 0.717873314484326, -74.9899978637695, -1.30882236878629, 218, 45, 'PPL', 'P'),
(166090, 'Pocono Mountain Woodland Lakes', 41.3222198486328, 0.721208790591595, -74.8883285522461, -1.30704790455197, 218, 45, 'PPL', 'P'),
(166091, 'Pocono Pines', 41.1066703796387, 0.717446742656722, -75.454719543457, -1.31693329220224, 218, 45, 'PPL', 'P'),
(166092, 'Pocono Playhouse', 41.1749992370605, 0.71863930619286, -75.274169921875, -1.3137821068424, 218, 45, 'PPL', 'P'),
(166093, 'Pocono Springs', 41.2744407653809, 0.720374888275264, -75.4116668701172, -1.31618188130067, 218, 45, 'PPL', 'P'),
(166094, 'Pocono Summit', 41.1111106872559, 0.717524240644444, -75.3866729736328, -1.31574565551412, 218, 45, 'PPL', 'P'),
(166095, 'Pocono Summit Estates', 41.1222190856934, 0.717718118771801, -75.3802795410156, -1.31563406906444, 218, 45, 'PPL', 'P'),
(78963, 'Pocopson', 39.9002799987793, 0.696391258446338, -75.626106262207, -1.31992455473861, 218, 45, 'PPL', 'P'),
(17675, 'Pocotalaco (historical)', 29.9166698455811, 0.522144390037493, -81.5500030517578, -1.4233160582646, 218, 12, 'PPL', 'P'),
(83080, 'Pocotaligo', 32.6369400024414, 0.569622060818449, -80.8636093139648, -1.41133622757504, 218, 48, 'PPL', 'P'),
(50492, 'Podickery Point', 39.0330581665039, 0.681255382127954, -76.408332824707, -1.3335769837508, 218, 25, 'PPL', 'P'),
(97146, 'Podo', 29.1122207641602, 0.508104104902054, -95.9008331298828, -1.67378529352211, 218, 51, 'PPL', 'P'),
(113931, 'Podunk', 41.3222198486328, 0.721208790591595, -72.6522216796875, -1.26802047719935, 218, 8, 'PPL', 'P'),
(132667, 'Podunk', 42.6088905334473, 0.743665430430498, -85.3583297729492, -1.48978389854107, 218, 27, 'PPL', 'P'),
(151802, 'Podunk', 42.524169921875, 0.742186776814259, -76.6630630493164, -1.33802286487458, 218, 40, 'PPL', 'P'),
(172413, 'Podunk', 43.0086097717285, 0.750641847222069, -72.8591690063477, -1.27163238942777, 218, 55, 'PPL', 'P'),
(97147, 'Poe', 31.4577808380127, 0.549041850994103, -94.6050033569336, -1.65116879743878, 218, 51, 'PPL', 'P'),
(110949, 'Poe', 38.2519416809082, 0.667622327612702, -80.9661102294922, -1.4131252060373, 218, 58, 'PPL', 'P'),
(123465, 'Poe', 40.9358291625977, 0.714465000921242, -85.0869369506836, -1.48504720022625, 218, 19, 'PPL', 'P'),
(157207, 'Poe', 41.0916709899902, 0.717184953921567, -81.8258285522461, -1.42813012140908, 218, 41, 'PPL', 'P'),
(184198, 'Poe', 39.7444381713867, 0.693671305446013, -121.470283508301, -2.12005639055082, 218, 6, 'PPL', 'P'),
(11309, 'Poe (historical)', 35.6622200012207, 0.622423157591878, -92.2680587768555, -1.61038142007978, 218, 4, 'PPL', 'P'),
(184196, 'Poe (historical)', 34.7966690063477, 0.60731644288743, -116.515830993652, -2.03358488153649, 218, 6, 'PPL', 'P'),
(73947, 'Poe Valley (historical)', 39.2966690063477, 0.685856259227175, -82.7777786254883, -1.44474478450176, 218, 41, 'PPL', 'P'),
(151803, 'Poestenkill', 42.6902809143066, 0.745085960555946, -73.5650024414063, -1.28395150684021, 218, 40, 'PPL', 'P'),
(105352, 'Poetown', 37.2827796936035, 0.650707259949064, -82.1086120605469, -1.43306562469927, 218, 53, 'PPL', 'P'),
(24050, 'Poetry', 34.2944412231445, 0.598550914475543, -85.3930587768555, -1.49039003400517, 218, 13, 'PPL', 'P'),
(97148, 'Poetry', 32.8256797790527, 0.572916191349795, -96.245491027832, -1.67980070863433, 218, 51, 'PPL', 'P'),
(105353, 'Poff', 36.9377784729004, 0.644685852724395, -80.3133316040039, -1.40173206973589, 218, 53, 'PPL', 'P'),
(184197, 'Poffenbergers Landing', 38.9388885498047, 0.679611812261212, -121.828056335449, -2.12630070435873, 218, 6, 'PPL', 'P'),
(90031, 'Poga', 36.2455596923828, 0.632604355860223, -81.9583282470703, -1.43044267734165, 218, 50, 'PPL', 'P'),
(5160, 'Pogo', 34.5572204589844, 0.603137277346823, -88.1138916015625, -1.53787752519265, 218, 2, 'PPL', 'P'),
(190623, 'Pogonip', 39.2180595397949, 0.684484265212594, -115.484443664551, -2.01558377678032, 218, 39, 'PPL', 'P'),
(166097, 'Pogue', 40.2105598449707, 0.701806663364959, -77.9283294677734, -1.36010592979157, 218, 45, 'PPL', 'P'),
(132668, 'Pogy', 43.7988891601563, 0.764434824560781, -85.3444366455078, -1.48954141772382, 218, 27, 'PPL', 'P'),
(28291, 'Pohaten (historical)', 38.4372215270996, 0.670856070966331, -87.746940612793, -1.53147302224517, 218, 18, 'PPL', 'P'),
(105354, 'Pohick', 38.7099990844727, 0.675616937468038, -77.1969375610352, -1.34734073289654, 218, 53, 'PPL', 'P'),
(110948, 'Pohick', 39.3777809143066, 0.687271929083634, -81.4816665649414, -1.42212336157041, 218, 58, 'PPL', 'P'),
(105355, 'Pohick Estates', 38.7172203063965, 0.675742971566626, -77.2030563354492, -1.34744752565626, 218, 53, 'PPL', 'P'),
(105356, 'Pohick Hills', 38.7508316040039, 0.676329599375744, -77.2263870239258, -1.34785472298693, 218, 53, 'PPL', 'P'),
(105357, 'Pohick Park', 38.8105583190918, 0.677372027205428, -77.2938919067383, -1.34903290545318, 218, 53, 'PPL', 'P'),
(56966, 'Pohlman Mill', 38.4605598449707, 0.671263401455059, -90.9649963378906, -1.58763869016078, 218, 29, 'PPL', 'P'),
(50494, 'Pohlman Point', 39.0766716003418, 0.682016580146526, -76.5194396972656, -1.33551616449854, 218, 25, 'PPL', 'P'),
(210971, 'Pohoiki', 19.4608306884766, 0.339655570687071, -154.846939086914, -2.70258892370175, 218, 15, 'PPL', 'P'),
(50495, 'Poignant Acres', 39.4777793884277, 0.689017231704017, -77.0683288574219, -1.34509608757177, 218, 25, 'PPL', 'P'),
(17676, 'Poinciana', 28.1399993896484, 0.49113564085856, -81.458610534668, -1.42172095792969, 218, 12, 'PPL', 'P'),
(17677, 'Poinciana Park', 27.6111106872559, 0.481904791625209, -80.4019393920898, -1.4032785673809, 218, 12, 'PPL', 'P'),
(17678, 'Poinciana Place', 28.1572208404541, 0.491436211877089, -81.4850006103516, -1.42218155164022, 218, 12, 'PPL', 'P'),
(17679, 'Poincianna Place', 26.6213893890381, 0.464630896294196, -80.1619415283203, -1.39908981446036, 218, 12, 'PPL', 'P'),
(11311, 'Poindexter', 35.3675003051758, 0.617279328525417, -90.4175033569336, -1.57808313501152, 218, 4, 'PPL', 'P'),
(37738, 'Poindexter', 38.436939239502, 0.670851144118314, -84.3083267211914, -1.47145788813191, 218, 21, 'PPL', 'P'),
(67906, 'Poindexter', 36.2305603027344, 0.632342567125068, -80.5880584716797, -1.40652695812052, 218, 33, 'PPL', 'P'),
(105358, 'Poindexter', 38.0013885498047, 0.663249350523765, -78.1449966430664, -1.36388748538142, 218, 53, 'PPL', 'P'),
(105359, 'Poindexters', 37.6911087036133, 0.657833945605143, -77.4397201538086, -1.35157808850697, 218, 53, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(83081, 'Poinsett', 34.857780456543, 0.608383038904007, -82.4391708374023, -1.43883496372676, 218, 48, 'PPL', 'P'),
(17680, 'Poinsettia Park', 28.0458297729492, 0.489492070991818, -81.6861114501953, -1.42569159795695, 218, 12, 'PPL', 'P'),
(90039, 'Poinsettia Subdivision', 36.1527786254883, 0.6309850207594, -85.4694366455078, -1.49172307928881, 218, 50, 'PPL', 'P'),
(42627, 'Point', 32.660831451416, 0.570039045266128, -92.2774963378906, -1.6105461365932, 218, 22, 'PPL', 'P'),
(97154, 'Point', 32.9313888549805, 0.574761162773975, -95.8711090087891, -1.67326650974177, 218, 51, 'PPL', 'P'),
(166098, 'Point', 40.0774993896484, 0.699484320315383, -78.6005630493164, -1.37183861913197, 218, 45, 'PPL', 'P'),
(56967, 'Point (historical)', 38.3941688537598, 0.670104660064765, -90.3419418334961, -1.57676433763971, 218, 29, 'PPL', 'P'),
(71297, 'Point Airy', 39.6763916015625, 0.692483668757892, -75.3197174072266, -1.31457706042779, 218, 37, 'PPL', 'P'),
(184199, 'Point Arena', 38.9088897705078, 0.679088234790902, -123.691940307617, -2.15883161654821, 218, 6, 'PPL', 'P'),
(151804, 'Point Au Roche', 44.7833290100098, 0.781616541228563, -73.3916702270508, -1.28092628899993, 218, 40, 'PPL', 'P'),
(17681, 'Point Baker', 30.6900005340576, 0.535641556758124, -87.0536117553711, -1.51937215088407, 218, 12, 'PPL', 'P'),
(193284, 'Point Baker', 56.3527793884277, 0.983541542978061, -133.621109008789, -2.33212830236963, 218, 1, 'PPL', 'P'),
(42628, 'Point Barre', 29.4255599975586, 0.513572906200532, -90.567497253418, -1.58070102236306, 218, 22, 'PPL', 'P'),
(42629, 'Point Blue', 30.6269397735596, 0.534540938858621, -92.3022232055664, -1.61097770184785, 218, 22, 'PPL', 'P'),
(14435, 'Point Breeze', 39.3769416809082, 0.687257281697639, -75.665283203125, -1.32060832134849, 218, 10, 'PPL', 'P'),
(42630, 'Point Breeze', 31.0547199249268, 0.542007110974658, -91.5736083984375, -1.59826097448467, 218, 22, 'PPL', 'P'),
(146075, 'Point Breeze', 40.5061111450195, 0.706965006659361, -74.9647216796875, -1.30838121615172, 218, 37, 'PPL', 'P'),
(151805, 'Point Breeze', 43.3699989318848, 0.756949277947813, -78.190559387207, -1.36468270528292, 218, 40, 'PPL', 'P'),
(166101, 'Point Breeze', 40.7550010681152, 0.711308955292417, -76.5550003051758, -1.33613681419058, 218, 45, 'PPL', 'P'),
(17682, 'Point Brittany', 27.7147197723389, 0.483713111294886, -82.7027816772461, -1.44343584082598, 218, 12, 'PPL', 'P'),
(67907, 'Point Caswell', 34.4680595397949, 0.601581125742863, -78.1600036621094, -1.36414940727463, 218, 33, 'PPL', 'P'),
(11313, 'Point Cedar', 34.3274993896484, 0.599127888325709, -93.3072204589844, -1.62851821289349, 218, 4, 'PPL', 'P'),
(42631, 'Point Celeste', 29.5980606079102, 0.516583609812867, -89.8480606079102, -1.56814448413945, 218, 22, 'PPL', 'P'),
(5161, 'Point Clear', 30.4738903045654, 0.531869721706244, -87.9191665649414, -1.53447893216754, 218, 2, 'PPL', 'P'),
(11314, 'Point Comfort', 33.459171295166, 0.583972704089422, -91.1655578613281, -1.59113914909758, 218, 4, 'PPL', 'P'),
(83083, 'Point Comfort', 32.1624984741211, 0.561341494041065, -80.7827835083008, -1.40992555114562, 218, 48, 'PPL', 'P'),
(97149, 'Point Comfort', 28.6794395446777, 0.50055064768129, -96.5599975585938, -1.68528988311515, 218, 51, 'PPL', 'P'),
(175893, 'Point Comfort', 43.9336090087891, 0.766786129487211, -88.4738922119141, -1.54416072115247, 218, 57, 'PPL', 'P'),
(83084, 'Point Comfort Woods', 32.1661109924316, 0.561404544379873, -80.7847213745117, -1.40995937329147, 218, 48, 'PPL', 'P'),
(30866, 'Point Commerce', 39.1252784729004, 0.682864930111771, -86.9652786254883, -1.51783044692902, 218, 19, 'PPL', 'P'),
(137535, 'Point Douglas', 44.7511100769043, 0.781054214764393, -92.8177795410156, -1.61997585738095, 218, 28, 'PPL', 'P'),
(184200, 'Point Dume Mobile Home Park', 34.014720916748, 0.593668874144237, -118.813888549805, -2.07369355229168, 218, 6, 'PPL', 'P'),
(105360, 'Point Elizabeth', 36.8444404602051, 0.643056797085593, -76.3947219848633, -1.33333942978156, 218, 53, 'PPL', 'P'),
(97150, 'Point Enterprise', 31.6588897705078, 0.552551864021313, -96.4252777099609, -1.68293857818872, 218, 51, 'PPL', 'P'),
(50496, 'Point Field Landing on the Severn', 39.0847206115723, 0.682157061894028, -76.6163864135742, -1.33720820389712, 218, 25, 'PPL', 'P'),
(61386, 'Point Harbor', 33.5888900756836, 0.586236723911126, -88.4966735839844, -1.54455833110322, 218, 30, 'PPL', 'P'),
(67909, 'Point Harbor', 36.0786094665527, 0.62969052473254, -75.7949981689453, -1.32287227459117, 218, 33, 'PPL', 'P'),
(90033, 'Point Harbor', 35.7874984741211, 0.62460967942586, -84.2236099243164, -1.46997930109469, 218, 50, 'PPL', 'P'),
(105361, 'Point Harbor', 36.8436088562012, 0.643042282857652, -76.51611328125, -1.33545810758677, 218, 53, 'PPL', 'P'),
(166102, 'Point Hill', 41.401668548584, 0.722595431992172, -79.8213882446289, -1.39314603838147, 218, 45, 'PPL', 'P'),
(212096, 'Point Hope', 68.3477783203125, 1.19289376811265, -166.808059692383, -2.91134986049532, 218, 1, 'PPL', 'P'),
(30865, 'Point Idalawn', 39.2605590820313, 0.685226022155208, -86.3688888549805, -1.50742148180844, 218, 19, 'PPL', 'P'),
(125861, 'Point Independence', 41.7416687011719, 0.728529554112114, -70.6500015258789, -1.2330751431656, 218, 23, 'PPL', 'P'),
(73948, 'Point Isabel', 38.8944396972656, 0.678836033435672, -84.1316680908203, -1.46837461337987, 218, 41, 'PPL', 'P'),
(123466, 'Point Isabel', 40.4216690063477, 0.705491213312111, -85.8244400024414, -1.49791905672293, 218, 19, 'PPL', 'P'),
(169552, 'Point Judith', 41.3652801513672, 0.721960334651216, -71.4872207641602, -1.24768737543465, 218, 47, 'PPL', 'P'),
(132669, 'Point Lakeview', 42.6558303833008, 0.744484685360833, -82.779167175293, -1.44476901926768, 218, 27, 'PPL', 'P'),
(212094, 'Point Lay', 69.7574996948242, 1.21749804763362, -163.051116943359, -2.84577883971593, 218, 1, 'PPL', 'P'),
(37741, 'Point Leavell', 37.5933303833008, 0.656127391978621, -84.4961090087891, -1.47473530732741, 218, 21, 'PPL', 'P'),
(97151, 'Point Loma', 28.1111106872559, 0.490631437885181, -97.8630599975586, -1.70803261303415, 218, 51, 'PPL', 'P'),
(105362, 'Point Lookout', 37.3544387817383, 0.651957946975993, -76.4361114501953, -1.33406181222725, 218, 53, 'PPL', 'P'),
(110950, 'Point Lookout', 39.4513893127441, 0.688556637993488, -81.0800018310547, -1.41511298947494, 218, 58, 'PPL', 'P'),
(151806, 'Point Lookout', 40.5922203063965, 0.70846789504152, -73.5811080932617, -1.28423260349326, 218, 40, 'PPL', 'P'),
(166103, 'Point Lookout', 40.1163902282715, 0.700163093498217, -80.2619400024414, -1.40083511708075, 218, 45, 'PPL', 'P'),
(212095, 'Point MacKenzie', 61.3597183227539, 1.07092911282835, -149.978332519531, -2.6176157091167, 218, 1, 'PPL', 'P'),
(78968, 'Point Marion', 39.7388916015625, 0.693574499540388, -79.8988876342773, -1.39449865789912, 218, 45, 'PPL', 'P'),
(193882, 'Point McCloud', 40.9238891601563, 0.714256608565944, -122.242500305176, -2.13353411619549, 218, 6, 'PPL', 'P'),
(132670, 'Point Mills', 47.0950012207031, 0.821962832532018, -88.4705581665039, -1.54410253108265, 218, 27, 'PPL', 'P'),
(177267, 'Point Mills', 40.0825004577637, 0.69957160542011, -80.5811080932617, -1.40640565113287, 218, 58, 'PPL', 'P'),
(132671, 'Point Nipigon', 45.7083282470703, 0.797760823493705, -84.5666732788086, -1.47596688617352, 218, 27, 'PPL', 'P'),
(24051, 'Point North', 33.1891708374023, 0.579260307119554, -85.0277786254883, -1.48401469267163, 218, 13, 'PPL', 'P'),
(17685, 'Point O''Rocks', 27.2452793121338, 0.47551982962223, -82.5355606079102, -1.44051728258736, 218, 12, 'PPL', 'P'),
(105364, 'Point O''Woods', 38.8741683959961, 0.678482232484855, -78.1358337402344, -1.36372756255797, 218, 53, 'PPL', 'P'),
(113932, 'Point O''Woods', 41.2930603027344, 0.720699860507281, -72.254997253418, -1.2610876030916, 218, 8, 'PPL', 'P'),
(151813, 'Point o''Woods', 40.6513900756836, 0.709500602333226, -73.1291732788086, -1.27634485297667, 218, 40, 'PPL', 'P'),
(50499, 'Point of Homewood', 39.2383308410645, 0.684838066163411, -76.9019393920898, -1.34219204356109, 218, 25, 'PPL', 'P'),
(125863, 'Point of Pines', 42.439998626709, 0.740717710577944, -70.966667175293, -1.23860200137585, 218, 23, 'PPL', 'P'),
(172414, 'Point of Pines', 43.6227798461914, 0.761361137188666, -73.2311096191406, -1.27812397774289, 218, 55, 'PPL', 'P'),
(178901, 'Point of Pines', 33.3658294677734, 0.582343581871594, -109.750831604004, -1.91551336829172, 218, 5, 'PPL', 'P'),
(50500, 'Point of Rocks', 39.2758293151855, 0.685492538001298, -77.539436340332, -1.35331846427934, 218, 25, 'PPL', 'P'),
(178902, 'Point of Rocks', 32.9938888549805, 0.575851993556471, -112.757217407227, -1.96798469914317, 218, 5, 'PPL', 'P'),
(199619, 'Point of Rocks', 41.2102813720703, 0.719255095615913, -103.245559692383, -1.80197495469642, 218, 35, 'PPL', 'P'),
(200136, 'Point of Rocks', 41.7772216796875, 0.729150070646103, -115.794166564941, -2.02098946116096, 218, 39, 'PPL', 'P'),
(209673, 'Point of Rocks', 41.6802787780762, 0.727458097826548, -108.785003662109, -1.8986564906979, 218, 59, 'PPL', 'P'),
(50501, 'Point of Rocks Estates', 39.2772216796875, 0.685516839346245, -77.5316696166992, -1.35318290937985, 218, 25, 'PPL', 'P'),
(189257, 'Point of Sands', 32.746940612793, 0.571541933648287, -106.195281982422, -1.85345732067707, 218, 38, 'PPL', 'P'),
(50502, 'Point of View', 38.5802803039551, 0.673352917646335, -76.2736129760742, -1.33122567882437, 218, 25, 'PPL', 'P'),
(71298, 'Point of Woods', 39.9094390869141, 0.69655111469077, -74.9577789306641, -1.30826004232212, 218, 37, 'PPL', 'P'),
(83085, 'Point Park Estates', 32.7366714477539, 0.571362702906924, -80.1066665649414, -1.39812508435548, 218, 48, 'PPL', 'P'),
(151807, 'Point Peninsula', 44.0058288574219, 0.768046603631146, -76.2194366455078, -1.33028012347933, 218, 40, 'PPL', 'P'),
(11315, 'Point Peter', 35.9555587768555, 0.627542885050473, -92.9091720581055, -1.62157095771586, 218, 4, 'PPL', 'P'),
(24052, 'Point Peter', 33.9958305358887, 0.593339174801286, -83.0133285522461, -1.44885590627651, 218, 13, 'PPL', 'P'),
(166104, 'Point Phillip', 40.7963905334473, 0.712031337738101, -75.4158325195313, -1.31625458559843, 218, 45, 'PPL', 'P'),
(42632, 'Point Place', 31.6966705322266, 0.553211262707217, -93.0208282470703, -1.62351972584352, 218, 22, 'PPL', 'P'),
(157208, 'Point Place', 41.7188911437988, 0.728132010740393, -83.4794387817383, -1.45699106445838, 218, 41, 'PPL', 'P'),
(17683, 'Point Pleasant', 29.3594398498535, 0.512418891921174, -81.8091735839844, -1.4278394373761, 218, 12, 'PPL', 'P'),
(28293, 'Point Pleasant', 39.1555595397949, 0.683393434430097, -88.0777816772461, -1.53724728812068, 218, 18, 'PPL', 'P'),
(37739, 'Point Pleasant', 37.4511108398438, 0.653645192684612, -87.1005630493164, -1.52019160555148, 218, 21, 'PPL', 'P'),
(42634, 'Point Pleasant', 32.771671295166, 0.571973565481961, -91.9524993896484, -1.60487386978744, 218, 22, 'PPL', 'P'),
(50497, 'Point Pleasant', 39.1786117553711, 0.683795771491781, -76.5877838134766, -1.33670899435078, 218, 25, 'PPL', 'P'),
(56968, 'Point Pleasant', 36.4524993896484, 0.636216134930589, -89.5744400024414, -1.56336890367272, 218, 29, 'PPL', 'P'),
(73949, 'Point Pleasant', 38.8944396972656, 0.678836033435672, -84.23388671875, -1.47015866499411, 218, 41, 'PPL', 'P'),
(90036, 'Point Pleasant', 35.3891716003418, 0.617657563979235, -88.1891708374023, -1.53919139571644, 218, 50, 'PPL', 'P'),
(105365, 'Point Pleasant', 37.1241683959961, 0.647938970574954, -81.0169372558594, -1.41401230499641, 218, 53, 'PPL', 'P'),
(110951, 'Point Pleasant', 38.8444404602051, 0.67796338212548, -82.1372222900391, -1.43356496740366, 218, 58, 'PPL', 'P'),
(146077, 'Point Pleasant', 40.922779083252, 0.714237234069013, -74.6580581665039, -1.30302892815093, 218, 37, 'PPL', 'P'),
(151809, 'Point Pleasant', 42.2383308410645, 0.73719794372324, -79.4947204589844, -1.38744460996178, 218, 40, 'PPL', 'P'),
(166105, 'Point Pleasant', 40.4225006103516, 0.705505727540052, -75.0666732788086, -1.31016060723406, 218, 45, 'PPL', 'P'),
(184201, 'Point Pleasant', 38.3316688537598, 0.669013829282269, -121.462783813477, -2.11992549618324, 218, 6, 'PPL', 'P'),
(42635, 'Point Pleasant (historical)', 29.413330078125, 0.513359453839162, -89.5999984741211, -1.56381498315531, 218, 22, 'PPL', 'P'),
(73950, 'Point Pleasant (historical)', 39.4372215270996, 0.688309363486274, -82.5091705322266, -1.44005668887684, 218, 41, 'PPL', 'P'),
(83086, 'Point Pleasant (historical)', 32.7516708374023, 0.571624491642079, -80.1486129760742, -1.39885718733915, 218, 48, 'PPL', 'P'),
(146078, 'Point Pleasant Beach', 40.0911102294922, 0.699721874284618, -74.0483322143555, -1.29238720275109, 218, 37, 'PPL', 'P'),
(56969, 'Point Rest', 37.8161087036133, 0.660015607170136, -89.7125015258789, -1.56577853182702, 218, 29, 'PPL', 'P'),
(184202, 'Point Reyes (historical)', 38.0863914489746, 0.664732930988021, -122.952781677246, -2.1459308647537, 218, 6, 'PPL', 'P'),
(184203, 'Point Reyes Station', 38.0691719055176, 0.664432393259005, -122.80583190918, -2.1433661074659, 218, 6, 'PPL', 'P'),
(184204, 'Point Richmond', 37.9241714477539, 0.66190165785413, -122.388061523438, -2.13607463871737, 218, 6, 'PPL', 'P'),
(208460, 'Point Roberts', 48.9855613708496, 0.854959331859073, -123.076667785645, -2.14809308524274, 218, 56, 'PPL', 'P'),
(73951, 'Point Rock', 39.1413917541504, 0.683146159922883, -82.2966690063477, -1.43634783758474, 218, 41, 'PPL', 'P'),
(151810, 'Point Rock', 43.3805618286133, 0.757133635274274, -75.5475006103516, -1.31855262730306, 218, 40, 'PPL', 'P'),
(90037, 'Point Seven', 36.1852798461914, 0.631552274071587, -83.4480590820313, -1.4564433853802, 218, 50, 'PPL', 'P'),
(125862, 'Point Shirley', 42.3597183227539, 0.739316554949426, -70.970832824707, -1.23867470567361, 218, 23, 'PPL', 'P'),
(50498, 'Point Somerset', 39.0675010681152, 0.681856524165012, -76.5569381713867, -1.33617063633643, 218, 25, 'PPL', 'P'),
(151811, 'Point Stockholm', 42.1199989318848, 0.735132662297884, -79.3177795410156, -1.38435640836172, 218, 40, 'PPL', 'P'),
(201420, 'Point Terrace', 44.0113906860352, 0.768143675852879, -123.910003662109, -2.16263754006204, 218, 43, 'PPL', 'P'),
(105366, 'Point Truth', 36.7813911437988, 0.641956378923173, -82.3494415283203, -1.43726889184774, 218, 53, 'PPL', 'P'),
(97152, 'Point Venture', 30.3791694641113, 0.530216531170064, -97.9958267211914, -1.71034982949863, 218, 51, 'PPL', 'P'),
(166106, 'Point View', 40.4894409179688, 0.70667405631027, -78.241943359375, -1.36557952478001, 218, 45, 'PPL', 'P'),
(24058, 'Point View Landing', 34.3097190856934, 0.598817563479688, -83.8861083984375, -1.4640887882376, 218, 13, 'PPL', 'P'),
(151812, 'Point Vivian', 44.3161087036133, 0.773462008549768, -75.9502792358398, -1.32558244047449, 218, 40, 'PPL', 'P'),
(17684, 'Point Washington', 30.3700008392334, 0.530056508478064, -86.1149978637695, -1.50299024807066, 218, 12, 'PPL', 'P'),
(208461, 'Point White', 47.5922203063965, 0.830640942681123, -122.564720153809, -2.13915791346941, 218, 56, 'PPL', 'P'),
(42636, 'Point-Aux-Chenes', 29.4974994659424, 0.514828486785963, -90.5533294677734, -1.58045374785585, 218, 22, 'PPL', 'P'),
(50503, 'Point-O-Woods', 39.038330078125, 0.681347394343616, -76.4741668701172, -1.33472600460311, 218, 25, 'PPL', 'P'),
(97153, 'Pointblank', 30.7455596923828, 0.536611247000535, -95.2125015258789, -1.66177164068671, 218, 51, 'PPL', 'P'),
(42639, 'Pointe a la Hache', 29.5761108398438, 0.516200514090059, -89.7916717529297, -1.56716031295861, 218, 22, 'PPL', 'P'),
(132674, 'Pointe aux Barques', 44.063060760498, 0.769045488777008, -82.9583282470703, -1.44789596986159, 218, 27, 'PPL', 'P'),
(132675, 'Pointe aux Chenes', 42.6108283996582, 0.743699252576342, -82.539436340332, -1.44058492687905, 218, 27, 'PPL', 'P'),
(132678, 'Pointe aux Peaux', 41.9449996948242, 0.732078349422699, -83.2541732788086, -1.45305943974109, 218, 27, 'PPL', 'P'),
(132673, 'Pointe Aux Pins', 45.7324981689453, 0.798182668210374, -84.477783203125, -1.47441546168049, 218, 27, 'PPL', 'P'),
(132676, 'Pointe aux Tremble', 42.6213912963867, 0.743883609902803, -82.5711135864258, -1.44113779912135, 218, 27, 'PPL', 'P'),
(24053, 'Pointe Bleue', 33.6855583190918, 0.587923903040719, -84.2302780151367, -1.47009568123433, 218, 13, 'PPL', 'P'),
(42637, 'Pointe Claire', 30.437780380249, 0.531239484634277, -91.9580612182617, -1.60497094200917, 218, 22, 'PPL', 'P'),
(42640, 'Pointe Coupee', 30.7341709136963, 0.536412475314674, -91.4330596923828, -1.59580793680459, 218, 22, 'PPL', 'P'),
(24055, 'Pointe South', 31.8205604553223, 0.55537354977528, -81.6074981689453, -1.42431953736334, 218, 13, 'PPL', 'P'),
(24056, 'Pointe South Place', 33.5224990844727, 0.585077982520833, -84.4211120605469, -1.47342636365164, 218, 13, 'PPL', 'P'),
(37740, 'Pointer', 37.1327781677246, 0.648089239439462, -84.767219543457, -1.47946707879421, 218, 21, 'PPL', 'P'),
(24057, 'Pointer Ridge', 33.5699996948242, 0.585907024568174, -84.4913864135742, -1.47465288249167, 218, 13, 'PPL', 'P'),
(71299, 'Pointers', 39.5938911437988, 0.691043764135513, -75.445556640625, -1.31677336937878, 218, 37, 'PPL', 'P'),
(105368, 'Pointers Landing', 37.7511100769043, 0.65888116712479, -77.0880584716797, -1.34544043430072, 218, 53, 'PPL', 'P'),
(110952, 'Points', 39.439998626709, 0.688357833018114, -78.6105575561523, -1.37201305618337, 218, 58, 'PPL', 'P'),
(56970, 'Points (historical)', 39.1022186279297, 0.682462459892033, -92.1552810668945, -1.6084130777181, 218, 29, 'PPL', 'P'),
(83088, 'Points North', 34.9647216796875, 0.610249515353989, -82.4194412231445, -1.43849061699781, 218, 48, 'PPL', 'P'),
(157209, 'Pointview', 40.9444389343262, 0.71461526978575, -80.8974990844727, -1.41192771565315, 218, 41, 'PPL', 'P'),
(146081, 'Pointville', 40.0036087036133, 0.698194684557512, -74.6033325195313, -1.30207378542598, 218, 37, 'PPL', 'P'),
(210973, 'Poipu', 21.8763904571533, 0.381815041929193, -159.453887939453, -2.78299534964953, 218, 15, 'PPL', 'P'),
(192945, 'Pojoaque', 35.8927803039551, 0.626447193998987, -106.022499084473, -1.85044169021672, 218, 38, 'PPL', 'P'),
(132677, 'Pokagon', 41.9124984741211, 0.731511096110512, -86.1763916015625, -1.50406177093526, 218, 27, 'PPL', 'P'),
(166108, 'Poke Run', 40.4902801513672, 0.706688703696265, -79.5969390869141, -1.38922866157602, 218, 45, 'PPL', 'P'),
(175894, 'Pokegama', 46.6469383239746, 0.814142659728082, -92.146110534668, -1.60825302173659, 218, 57, 'PPL', 'P'),
(201421, 'Pokegama (historical)', 42.0361099243164, 0.733668522909586, -122.216667175293, -2.13308324302294, 218, 43, 'PPL', 'P'),
(200137, 'Poker Brown', 40.535831451416, 0.707483723860681, -118.419166564941, -2.06680435402581, 218, 39, 'PPL', 'P'),
(184205, 'Poker Flat', 39.6933288574219, 0.692779279638891, -120.844436645508, -2.1091333021818, 218, 6, 'PPL', 'P'),
(184206, 'Pokerville (historical)', 38.4805603027344, 0.671612475294941, -120.858329772949, -2.10937578299905, 218, 6, 'PPL', 'P'),
(151814, 'Pokeville', 42.5900001525879, 0.743335731087546, -76.1338882446289, -1.32878702221418, 218, 40, 'PPL', 'P'),
(210976, 'Pokii', 21.982780456543, 0.383671897709737, -159.720825195313, -2.78765428366052, 218, 15, 'PPL', 'P'),
(178903, 'Polacca', 35.836669921875, 0.625467883087138, -110.380828857422, -1.92650889464238, 218, 5, 'PPL', 'P'),
(30868, 'Poland', 39.4441719055176, 0.688430670473927, -86.9508285522461, -1.51757824557379, 218, 19, 'PPL', 'P'),
(42641, 'Poland', 31.1669406890869, 0.543965732798357, -92.2755584716797, -1.61051231444736, 218, 22, 'PPL', 'P'),
(128571, 'Poland', 44.0605583190918, 0.76900181293513, -70.394172668457, -1.22861008728198, 218, 26, 'PPL', 'P'),
(140723, 'Poland', 48.1977806091309, 0.841209963783212, -97.2180633544922, -1.69677529794833, 218, 34, 'PPL', 'P'),
(151815, 'Poland', 43.2255592346191, 0.754428329659944, -75.0616683959961, -1.3100732555503, 218, 40, 'PPL', 'P'),
(157210, 'Poland', 41.024169921875, 0.716006838034344, -80.6149978637695, -1.40699713921097, 218, 41, 'PPL', 'P'),
(175895, 'Poland', 44.4436111450195, 0.775687345956638, -87.8261108398438, -1.53285480337676, 218, 57, 'PPL', 'P'),
(151816, 'Poland Center', 42.1352806091309, 0.735399377881055, -79.1241683959961, -1.38097725641257, 218, 40, 'PPL', 'P'),
(157211, 'Poland Center', 41.0238914489746, 0.716001977765354, -80.567497253418, -1.40616809716363, 218, 41, 'PPL', 'P'),
(178904, 'Poland Junction', 34.4508285522461, 0.601280388276766, -112.268608093262, -1.95945685785857, 218, 5, 'PPL', 'P'),
(128572, 'Poland Spring', 44.0277786254883, 0.768429699353954, -70.3600006103516, -1.22801367235585, 218, 26, 'PPL', 'P'),
(110953, 'Polandale', 39.1741714477539, 0.683718273504059, -81.5699996948242, -1.42366506552545, 218, 58, 'PPL', 'P'),
(128573, 'Polands Corner', 44.4716682434082, 0.776177034702076, -69.2600021362305, -1.20881507721553, 218, 26, 'PPL', 'P'),
(175896, 'Polar', 45.1686096191406, 0.788340956401986, -88.9899978637695, -1.5531684640655, 218, 57, 'PPL', 'P'),
(192065, 'Polar', 33.0331993103027, 0.576538090432303, -100.988708496094, -1.76258547059361, 218, 51, 'PPL', 'P'),
(110954, 'Polard', 39.521671295166, 0.689783289991579, -80.8483276367188, -1.41106951199187, 218, 58, 'PPL', 'P'),
(184207, 'Polaris', 39.339168548584, 0.686598016169789, -120.134719848633, -2.09674640731963, 218, 6, 'PPL', 'P'),
(197274, 'Polaris', 45.3697204589844, 0.79185100271871, -113.118606567383, -1.97429212986891, 218, 31, 'PPL', 'P'),
(205404, 'Polaris Gardens', 40.6541709899902, 0.709549138444092, -112.022216796875, -1.95515651848836, 218, 52, 'PPL', 'P'),
(205405, 'Polaris Gardens Condominium', 40.7755584716797, 0.711667749670278, -111.881942749023, -1.95270827449825, 218, 52, 'PPL', 'P'),
(132679, 'Polaski', 45.2336082458496, 0.789475396447332, -83.658332824707, -1.46011335452039, 218, 27, 'PPL', 'P'),
(175898, 'Pole Cat Crossing', 45.6419410705566, 0.796602148682439, -92.5288925170898, -1.61493382764716, 218, 57, 'PPL', 'P'),
(67910, 'Pole Creek', 35.565559387207, 0.620736111620339, -82.7074966430664, -1.44351813250367, 218, 33, 'PPL', 'P'),
(184208, 'Pole Garden', 39.2197189331055, 0.684513227089448, -122.636390686035, -2.14040880023342, 218, 6, 'PPL', 'P'),
(105369, 'Pole Green', 37.6369400024414, 0.656888523418165, -77.3369369506836, -1.34978418319669, 218, 53, 'PPL', 'P'),
(71300, 'Pole Tavern', 39.6166687011719, 0.691441307507235, -75.2294387817383, -1.31300140116884, 218, 37, 'PPL', 'P'),
(197275, 'Polebridge', 48.7652816772461, 0.851114725930407, -114.284172058105, -1.99463508532964, 218, 31, 'PPL', 'P'),
(90040, 'Polecat', 35.9566688537598, 0.627562259547403, -87.8805618286133, -1.53380515241175, 218, 50, 'PPL', 'P'),
(83089, 'Polecat Bay (historical)', 33.9449996948242, 0.592452009263153, -79.0777816772461, -1.38016765544119, 218, 48, 'PPL', 'P'),
(83090, 'Polecat Landing', 34.0844383239746, 0.594885672446295, -79.2491683959961, -1.38315891797757, 218, 48, 'PPL', 'P'),
(112519, 'Polen', 39.8672218322754, 0.695814284596172, -80.5041732788086, -1.40506288531125, 218, 45, 'PPL', 'P'),
(117381, 'Polen', 40.8849983215332, 0.71357783538311, -94.3958282470703, -1.64751800305844, 218, 16, 'PPL', 'P'),
(184209, 'Poleta', 37.3613891601563, 0.652079253963646, -118.32527923584, -2.06516571100709, 218, 6, 'PPL', 'P'),
(105370, 'Poletown', 36.9638900756836, 0.645141586165935, -80.9169387817383, -1.41226700237602, 218, 53, 'PPL', 'P'),
(42642, 'Poley', 30.3380603790283, 0.529499042282883, -90.79638671875, -1.58469589715624, 218, 22, 'PPL', 'P'),
(67914, 'Poley Bridge Crossing (historical)', 34.1586112976074, 0.596180235052182, -78.6822204589844, -1.37326380978932, 218, 33, 'PPL', 'P'),
(146082, 'Polhemustown', 40.1505584716797, 0.700759441845313, -74.5480575561523, -1.3011090553211, 218, 37, 'PPL', 'P'),
(189259, 'Polich Place', 35.360279083252, 0.617153294426829, -108.491111755371, -1.89352710928035, 218, 38, 'PPL', 'P'),
(37742, 'Polin', 37.8191719055176, 0.66006907012902, -85.2088928222656, -1.4871757317275, 218, 21, 'PPL', 'P'),
(110957, 'Poling', 38.6888885498047, 0.675248489131226, -80.4361114501953, -1.40387498230702, 218, 58, 'PPL', 'P'),
(123470, 'Poling', 40.5325012207031, 0.70742560036989, -85.0533294677734, -1.48446063899616, 218, 19, 'PPL', 'P'),
(110955, 'Poling Run (historical)', 38.8633308410645, 0.678293081468432, -81.0644378662109, -1.41484134704375, 218, 58, 'PPL', 'P'),
(5163, 'Polk', 32.2722206115723, 0.563256506601914, -86.8886108398438, -1.51649234163931, 218, 2, 'PPL', 'P'),
(33661, 'Polk', 37.5433311462402, 0.655254740668429, -94.7416687011719, -1.65355405766911, 218, 20, 'PPL', 'P'),
(56971, 'Polk', 37.7291717529297, 0.658498271139064, -93.2991714477539, -1.62837773114599, 218, 29, 'PPL', 'P'),
(90041, 'Polk', 36.3080596923828, 0.63369518664272, -89.1177825927734, -1.55539872832039, 218, 50, 'PPL', 'P'),
(110956, 'Polk', 39.0511093139648, 0.681570434084911, -81.79638671875, -1.42761626447675, 218, 58, 'PPL', 'P'),
(112505, 'Polk', 36.6083297729492, 0.638935888193832, -97.4538879394531, -1.70089121341305, 218, 42, 'PPL', 'P'),
(121077, 'Polk', 41.3116683959961, 0.721024633002216, -87.6083297729492, -1.52905380671094, 218, 18, 'PPL', 'P'),
(142720, 'Polk', 41.0766716003418, 0.716923165186413, -97.7836074829102, -1.70664590505455, 218, 35, 'PPL', 'P'),
(157213, 'Polk', 40.9444389343262, 0.71461526978575, -82.2155609130859, -1.43493223430731, 218, 41, 'PPL', 'P'),
(166110, 'Polk', 41.3669395446777, 0.72198929652807, -79.929443359375, -1.39503195590741, 218, 45, 'PPL', 'P'),
(184214, 'Polk', 38.5322189331055, 0.672514088481987, -121.407783508301, -2.11896555976832, 218, 6, 'PPL', 'P'),
(17686, 'Polk City', 28.1822204589844, 0.491872537532185, -81.8241729736328, -1.42810122611125, 218, 12, 'PPL', 'P'),
(117370, 'Polk City', 41.7713890075684, 0.729048271313434, -93.7127838134766, -1.63559662875481, 218, 16, 'PPL', 'P'),
(117371, 'Polk City Junction', 41.8025016784668, 0.729591289859702, -93.6977767944336, -1.6353347068616, 218, 16, 'PPL', 'P'),
(110958, 'Polk Gap', 37.6766700744629, 0.657581943986995, -81.4227828979492, -1.42109564770574, 218, 58, 'PPL', 'P'),
(193285, 'Polk Inlet', 55.3497200012207, 0.966034854078261, -132.545837402344, -2.31336127248395, 218, 1, 'PPL', 'P'),
(632, 'Polk Landing', 38.2649993896484, 0.667850227622986, -75.720832824707, -1.32157784514334, 218, 25, 'PPL', 'P'),
(50504, 'Polk Road', 38.2605590820313, 0.667772729635265, -75.7458267211914, -1.32201407092989, 218, 25, 'PPL', 'P'),
(193883, 'Polk Springs', 40.1172218322754, 0.700177607726158, -121.664169311523, -2.12344033618993, 218, 6, 'PPL', 'P'),
(166111, 'Polk Valley', 40.5699996948242, 0.708080072207777, -75.304443359375, -1.31431047800267, 218, 45, 'PPL', 'P'),
(83094, 'Polk Village', 32.4430618286133, 0.566238248337394, -80.7013931274414, -1.40850502102018, 218, 48, 'PPL', 'P'),
(67912, 'Polkadot', 35.4541702270508, 0.618792004024582, -81.254997253418, -1.41816723577109, 218, 33, 'PPL', 'P'),
(73952, 'Polkadotte', 38.584171295166, 0.673420828254132, -82.3741683959961, -1.43770045710239, 218, 41, 'PPL', 'P'),
(192066, 'Polkinghorn Addition Colonia', 31.9200000762939, 0.557109098568171, -106.591003417969, -1.86036396264808, 218, 51, 'PPL', 'P'),
(37743, 'Polksville', 38.1383285522461, 0.665639404444057, -83.654167175293, -1.46004065022263, 218, 21, 'PPL', 'P'),
(67913, 'Polkton', 35.0074996948242, 0.610996132565593, -80.2011108398438, -1.39977344791219, 218, 33, 'PPL', 'P'),
(78971, 'Polktown', 39.7597198486328, 0.693938021029184, -77.6308288574219, -1.35491356461424, 218, 45, 'PPL', 'P'),
(146083, 'Polktown', 40.6713905334473, 0.709849676173108, -74.9458312988281, -1.30805151680877, 218, 37, 'PPL', 'P'),
(770, 'Polkville', 35.4174995422363, 0.618151979835608, -81.6430587768555, -1.42494018705538, 218, 33, 'PPL', 'P'),
(37744, 'Polkville', 36.9724998474121, 0.645291855030442, -86.2708282470703, -1.50571000133391, 218, 21, 'PPL', 'P'),
(61387, 'Polkville', 32.1936111450195, 0.561884512587333, -89.692497253418, -1.56542939140811, 218, 30, 'PPL', 'P'),
(146084, 'Polkville', 40.9386100769043, 0.714513537032109, -75.0516662597656, -1.30989868534085, 218, 37, 'PPL', 'P'),
(151819, 'Polkville', 43.0933303833008, 0.752120500838309, -76.0316696166992, -1.32700297059994, 218, 40, 'PPL', 'P'),
(166115, 'Polkville', 41.2344398498535, 0.7196767405955, -76.4333267211914, -1.33401320953735, 218, 45, 'PPL', 'P'),
(269, 'Polkville (historical)', 33.7200012207031, 0.588525045077777, -85.9652786254883, -1.50037715440908, 218, 2, 'PPL', 'P'),
(342, 'Pollard', 36.4308280944824, 0.63583789947677, -90.2683334350586, -1.57547962872986, 218, 4, 'PPL', 'P'),
(5164, 'Pollard', 31.0269393920898, 0.541522249208696, -87.1736068725586, -1.5214664607653, 218, 2, 'PPL', 'P'),
(33662, 'Pollard', 38.4497184753418, 0.671074183859608, -98.2102813720703, -1.71409276925268, 218, 20, 'PPL', 'P'),
(37745, 'Pollard', 37.8066711425781, 0.659850890656715, -84.5100021362305, -1.47497778814466, 218, 21, 'PPL', 'P'),
(90043, 'Pollard', 36.2761116027832, 0.633137587289484, -87.6780624389648, -1.53027087132911, 218, 50, 'PPL', 'P'),
(208462, 'Pollard', 48.7280616760254, 0.85046511436151, -118.665557861328, -2.07110469339602, 218, 56, 'PPL', 'P'),
(90044, 'Pollard (historical)', 35.8694381713867, 0.626039796931232, -85.6102828979492, -1.49418131013301, 218, 50, 'PPL', 'P'),
(193884, 'Pollard Flat', 40.9958305358887, 0.715512222440889, -122.417221069336, -2.13658356880169, 218, 6, 'PPL', 'P'),
(24060, 'Pollards Corner', 33.6208305358887, 0.586794190106307, -82.2752838134766, -1.43597459555796, 218, 13, 'PPL', 'P'),
(105371, 'Pollards Corner', 37.7897186279297, 0.659555013459607, -77.1849975585938, -1.34713234054125, 218, 53, 'PPL', 'P'),
(90045, 'Pollards Mill', 35.047779083252, 0.611699140514346, -88.0977783203125, -1.53759629538153, 218, 50, 'PPL', 'P'),
(175901, 'Polley', 45.1411094665527, 0.787860988194526, -90.8069381713867, -1.58488005474562, 218, 57, 'PPL', 'P'),
(42644, 'Pollock', 31.5255603790283, 0.550224827150316, -92.4069366455078, -1.61280529614592, 218, 22, 'PPL', 'P'),
(139401, 'Pollock', 40.3591690063477, 0.704400382529615, -93.084716796875, -1.62463479139194, 218, 29, 'PPL', 'P'),
(193885, 'Pollock', 40.9166717529297, 0.714130641046383, -122.384719848633, -2.1360163154895, 218, 6, 'PPL', 'P'),
(195486, 'Pollock', 45.3125, 0.790852317309931, -116.358062744141, -2.0308313061274, 218, 17, 'PPL', 'P'),
(202504, 'Pollock', 45.9013900756836, 0.801130388062928, -100.288063049316, -1.75035690065824, 218, 49, 'PPL', 'P'),
(61388, 'Pollock (historical)', 33.4361114501953, 0.583570233869684, -90.6041717529297, -1.58134111313107, 218, 30, 'PPL', 'P'),
(184211, 'Pollock Pines', 38.7613906860352, 0.676513890123177, -120.585563659668, -2.10461511623443, 218, 6, 'PPL', 'P'),
(67916, 'Pollocks', 35.1116714477539, 0.61281427264179, -77.394172668457, -1.35078313492158, 218, 33, 'PPL', 'P'),
(67915, 'Pollocksville', 35.0058288574219, 0.610966970951656, -77.2213897705078, -1.34776750446123, 218, 33, 'PPL', 'P'),
(42645, 'Pollockville', 31.5450000762939, 0.550564113873192, -92.896110534668, -1.62134299112655, 218, 22, 'PPL', 'P'),
(97156, 'Pollok', 31.4463901519775, 0.548843046018728, -94.871940612793, -1.65582773144976, 218, 51, 'PPL', 'P'),
(132682, 'Pollok', 42.6150016784668, 0.743772090032156, -84.3391723632813, -1.47199624614627, 218, 27, 'PPL', 'P'),
(37746, 'Polly', 37.2008285522461, 0.64927694270661, -82.8266677856445, -1.44559806131502, 218, 21, 'PPL', 'P'),
(189260, 'Polly', 33.5752792358398, 0.585999169941891, -105.957221984863, -1.84930238990239, 218, 38, 'PPL', 'P'),
(83091, 'Polly Landing', 33.5091705322266, 0.584845355399614, -80.4272232055664, -1.40371985317352, 218, 48, 'PPL', 'P'),
(17688, 'Polly Town', 30.4388904571533, 0.531258859131207, -81.5952835083008, -1.42410635131808, 218, 12, 'PPL', 'P'),
(144335, 'Pollys Crossing', 43.7080612182617, 0.762849577921911, -71.1305618286133, -1.2414625027027, 218, 36, 'PPL', 'P'),
(56980, 'Polo', 39.5522193908691, 0.690316454841813, -94.0405578613281, -1.64131736509241, 218, 29, 'PPL', 'P'),
(121078, 'Polo', 41.9861106872559, 0.732795871599394, -89.5791702270508, -1.56345146166651, 218, 18, 'PPL', 'P'),
(157215, 'Polo', 40.1822204589844, 0.701312047771504, -84.355827331543, -1.47228693017925, 218, 41, 'PPL', 'P'),
(171109, 'Polo', 44.7794418334961, 0.781548697199793, -99.1091690063477, -1.72978131807628, 218, 49, 'PPL', 'P'),
(11326, 'Polo (historical)', 36.4794387817383, 0.636686316021042, -93.5500030517578, -1.63275556850392, 218, 4, 'PPL', 'P'),
(50505, 'Polo Club Estates', 39.0752792358398, 0.681992278801579, -77.2708282470703, -1.34863036865442, 218, 25, 'PPL', 'P'),
(178905, 'Polo Village', 32.2397193908691, 0.562689253289727, -110.94750213623, -1.93639920914066, 218, 5, 'PPL', 'P'),
(184212, 'Poloma (historical)', 35.4599990844727, 0.618893736778223, -120.626388549805, -2.10532764498408, 218, 6, 'PPL', 'P'),
(175902, 'Polonia', 44.5699996948242, 0.777893242287551, -89.4130630493164, -1.56055234450385, 218, 57, 'PPL', 'P'),
(125864, 'Polpis', 41.2983283996582, 0.720791806143916, -70.0133285522461, -1.22196310351725, 218, 23, 'PPL', 'P'),
(37747, 'Polsgrove', 38.3480606079102, 0.66929991936237, -84.8850021362305, -1.48152277283964, 218, 21, 'PPL', 'P'),
(121079, 'Polsgrove', 42.1683311462402, 0.735976218573167, -90.0236129760742, -1.57120845097359, 218, 18, 'PPL', 'P'),
(197276, 'Polson', 47.6936111450195, 0.832410546646454, -114.162216186523, -1.9925065538284, 218, 31, 'PPL', 'P'),
(83092, 'Polson Crossroads', 34.2955589294434, 0.598570422130528, -80.0224990844727, -1.3966560846982, 218, 48, 'PPL', 'P'),
(11325, 'Poluca (historical)', 36.2930603027344, 0.633433397907565, -90.913330078125, -1.58673694381567, 218, 4, 'PPL', 'P'),
(189261, 'Polvadera', 34.204719543457, 0.596984975754577, -106.921112060547, -1.86612544535036, 218, 38, 'PPL', 'P'),
(178906, 'Polvo', 32.186939239502, 0.561768065868669, -110.90860748291, -1.9357203693788, 218, 5, 'PPL', 'P'),
(192067, 'Polvo', 29.4349994659424, 0.513737656003467, -104.193328857422, -1.81851664717523, 218, 51, 'PPL', 'P'),
(56981, 'Pom-o-sa Heights', 38.1744384765625, 0.666269641516024, -93.3958282470703, -1.6300647105385, 218, 29, 'PPL', 'P'),
(184213, 'Pomar (historical)', 37.2411117553711, 0.649980017234391, -121.776672363281, -2.12540388486164, 218, 6, 'PPL', 'P'),
(83093, 'Pomaria', 34.2683296203613, 0.598095181034004, -81.4199981689453, -1.42104704501585, 218, 48, 'PPL', 'P'),
(113933, 'Pomeraug', 41.5261116027832, 0.724767373019187, -73.2113876342773, -1.277779764172, 218, 8, 'PPL', 'P'),
(178907, 'Pomerene', 31.999439239502, 0.558495573521179, -110.28556060791, -1.92484615001579, 218, 5, 'PPL', 'P'),
(33663, 'Pomeroy', 39.1683311462402, 0.683616341013337, -94.7611083984375, -1.65389334439199, 218, 20, 'PPL', 'P'),
(73953, 'Pomeroy', 39.0275001525879, 0.681158376485248, -82.0338897705078, -1.43176147471346, 218, 41, 'PPL', 'P'),
(78974, 'Pomeroy', 39.964168548584, 0.697506323994754, -75.8869400024414, -1.324476962306, 218, 45, 'PPL', 'P'),
(117379, 'Pomeroy', 42.5511093139648, 0.742656957904712, -94.6836090087891, -1.65254072487433, 218, 16, 'PPL', 'P'),
(132683, 'Pomeroy', 42.1936111450195, 0.736417437786765, -85.4822235107422, -1.49194625218816, 218, 27, 'PPL', 'P'),
(192068, 'Pomeroy', 35.4425010681152, 0.618588338780218, -101.505561828613, -1.77160626299598, 218, 51, 'PPL', 'P'),
(208464, 'Pomeroy', 46.4749984741211, 0.811141743232754, -117.601669311523, -2.05253633532766, 218, 56, 'PPL', 'P'),
(193886, 'Pomeroy (historical)', 41.6180610656738, 0.726372193892068, -122.192497253418, -2.13266139830627, 218, 6, 'PPL', 'P'),
(78972, 'Pomeroy Heights', 39.9702796936035, 0.697612983596412, -75.8861083984375, -1.32446244807806, 218, 45, 'PPL', 'P'),
(37748, 'Pomeroyton', 37.8711090087891, 0.660975543585055, -83.5216674804688, -1.45772809429006, 218, 21, 'PPL', 'P'),
(50510, 'Pomfret', 38.577220916748, 0.673299521266479, -77.0308303833008, -1.34444161573388, 218, 25, 'PPL', 'P'),
(113934, 'Pomfret', 41.8974990844727, 0.731249307375358, -71.9630584716797, -1.25599231013601, 218, 8, 'PPL', 'P'),
(172415, 'Pomfret', 43.704719543457, 0.762791254694038, -72.5163879394531, -1.26564973119696, 218, 55, 'PPL', 'P'),
(113935, 'Pomfret Center', 41.8872184753418, 0.731069876896914, -71.9625015258789, -1.25598258959803, 218, 8, 'PPL', 'P'),
(50506, 'Pomfret Estates', 38.5750007629395, 0.673260772272618, -77.033332824707, -1.34448529157576, 218, 25, 'PPL', 'P'),
(113936, 'Pomfret Landing', 41.8494415283203, 0.730410544790037, -71.936393737793, -1.25552692273552, 218, 8, 'PPL', 'P'),
(184215, 'Pomins', 39.0666694641113, 0.681842009937071, -120.125831604004, -2.09659127818613, 218, 6, 'PPL', 'P'),
(184216, 'Pomo', 39.3066711425781, 0.68603082943663, -123.094718933105, -2.14840813719969, 218, 6, 'PPL', 'P'),
(24061, 'Pomona', 33.3191719055176, 0.581529253789275, -84.2838897705078, -1.47103138288333, 218, 13, 'PPL', 'P'),
(28295, 'Pomona', 37.628059387207, 0.656733527442723, -89.336669921875, -1.5592190329041, 218, 18, 'PPL', 'P'),
(33665, 'Pomona', 38.5958290100098, 0.673624293761414, -95.4533309936523, -1.66597490783518, 218, 20, 'PPL', 'P'),
(50507, 'Pomona', 39.1622200012207, 0.683509681411679, -76.1097183227539, -1.32836517749751, 218, 25, 'PPL', 'P'),
(56982, 'Pomona', 36.8672218322754, 0.643454407036342, -91.9141693115234, -1.60420488372161, 218, 29, 'PPL', 'P'),
(67917, 'Pomona', 36.060001373291, 0.629365752237605, -79.8561096191406, -1.39375204068752, 218, 33, 'PPL', 'P'),
(71301, 'Pomona', 39.478328704834, 0.689026819083942, -74.5755615234375, -1.30158909010758, 218, 37, 'PPL', 'P'),
(90047, 'Pomona', 36.0336112976074, 0.628905158527076, -87.3477783203125, -1.52450632599158, 218, 50, 'PPL', 'P'),
(97157, 'Pomona', 32.0116691589355, 0.558709025882549, -95.2797164916992, -1.66294476314689, 218, 51, 'PPL', 'P'),
(105373, 'Pomona', 39.2805595397949, 0.68557509599509, -77.670280456543, -1.35560212491408, 218, 53, 'PPL', 'P'),
(132684, 'Pomona', 44.4708290100098, 0.776162387316081, -85.8797225952148, -1.49888391998587, 218, 27, 'PPL', 'P'),
(151821, 'Pomona', 41.1669387817383, 0.718498624708276, -74.0436096191406, -1.29230477791535, 218, 40, 'PPL', 'P'),
(184217, 'Pomona', 34.0552787780762, 0.59437674236198, -117.751388549805, -2.05514942898924, 218, 6, 'PPL', 'P'),
(193259, 'Pomona', 46.690559387207, 0.814903990904709, -120.486106872559, -2.10287926783592, 218, 56, 'PPL', 'P'),
(50508, 'Pomona Heights', 38.311939239502, 0.668669482553321, -75.2177810668945, -1.31279793566156, 218, 25, 'PPL', 'P'),
(151822, 'Pomona Heights', 41.1661109924316, 0.718484177059363, -74.0691680908203, -1.29275085739794, 218, 40, 'PPL', 'P'),
(208463, 'Pomona Heights', 46.6575012207031, 0.814327017054543, -120.481391906738, -2.10279697615823, 218, 56, 'PPL', 'P'),
(184218, 'Pomona Islander Mobile Home Park', 34.0463905334473, 0.594221613228483, -117.815559387207, -2.05626942138568, 218, 6, 'PPL', 'P'),
(17689, 'Pomona Park', 29.5, 0.514872129338327, -81.591667175293, -1.42404323440024, 218, 12, 'PPL', 'P'),
(90048, 'Pomona Road', 36.0166702270508, 0.62860948106705, -85.1319427490234, -1.48583269958977, 218, 50, 'PPL', 'P'),
(50509, 'Pomonkey', 38.607780456543, 0.673832885853794, -77.0719375610352, -1.34515907133155, 218, 25, 'PPL', 'P'),
(50511, 'Pomonkey Landing', 38.6338882446289, 0.674288552716307, -77.0980606079102, -1.34561500451017, 218, 25, 'PPL', 'P'),
(67918, 'Pomouk Indian Village (historical)', 35.4705581665039, 0.619078027525656, -76.8141708374023, -1.34066019330208, 218, 33, 'PPL', 'P'),
(37749, 'Pomp', 37.9594383239746, 0.662517180961075, -83.2813873291016, -1.45353441452151, 218, 21, 'PPL', 'P'),
(17690, 'Pompano Beach', 26.2374992370605, 0.457930749176207, -80.125, -1.39844506316046, 218, 12, 'PPL', 'P'),
(17691, 'Pompano Beach Highlands', 26.2824993133545, 0.458716148671185, -80.1072235107422, -1.39813480489346, 218, 12, 'PPL', 'P'),
(17692, 'Pompano Isles', 26.2169399261475, 0.457571921508832, -80.1013870239258, -1.39803293898177, 218, 12, 'PPL', 'P'),
(17693, 'Pompano Park', 26.1988906860352, 0.457256902841389, -80.208610534668, -1.39990434227977, 218, 12, 'PPL', 'P'),
(172417, 'Pompanoosuc', 43.7555618286133, 0.763678619969253, -72.2313919067383, -1.26067561207097, 218, 55, 'PPL', 'P'),
(132685, 'Pompeii', 43.1838912963867, 0.753701086945271, -84.600830078125, -1.47656303478353, 218, 27, 'PPL', 'P'),
(151823, 'Pompey', 42.8988914489746, 0.748726901240248, -76.0163879394531, -1.32673625501677, 218, 40, 'PPL', 'P'),
(151824, 'Pompey Center', 42.9230613708496, 0.749148745956917, -75.9508285522461, -1.32559202785441, 218, 40, 'PPL', 'P'),
(197277, 'Pompeys Pillar', 45.9913902282715, 0.802701187052884, -107.951393127441, -1.88410724218863, 218, 31, 'PPL', 'P'),
(146086, 'Pompton', 40.9913902282715, 0.715434724453167, -74.2799987792969, -1.2964305470761, 218, 37, 'PPL', 'P'),
(146087, 'Pompton Junction', 41.0036087036133, 0.715647977077456, -74.3005599975586, -1.29678940803299, 218, 37, 'PPL', 'P'),
(146088, 'Pompton Lakes', 41.0052795410156, 0.715677138691392, -74.2911071777344, -1.29662442520346, 218, 37, 'PPL', 'P'),
(146090, 'Pompton Plains', 40.9680595397949, 0.715027527122494, -74.2961120605469, -1.29671177688721, 218, 37, 'PPL', 'P'),
(137541, 'Pomroy', 47.8175010681152, 0.834572833714516, -93.9927825927734, -1.64048352935511, 218, 28, 'PPL', 'P'),
(169553, 'Ponaganset (historical)', 41.7930603027344, 0.729426506767253, -71.6736068725586, -1.25094042670618, 218, 47, 'PPL', 'P'),
(125865, 'Ponakin Mill', 42.4811096191406, 0.741435232754638, -71.6875, -1.25118290752344, 218, 23, 'PPL', 'P'),
(11327, 'Ponca', 36.024169921875, 0.628740375434627, -93.3644409179688, -1.62951689830227, 218, 4, 'PPL', 'P'),
(142723, 'Ponca', 42.7119407653809, 0.745463996272683, -98.0741729736328, -1.71171722956033, 218, 35, 'PPL', 'P'),
(184220, 'Ponca', 36.0419387817383, 0.629050500543567, -119.01611328125, -2.07722303968436, 218, 6, 'PPL', 'P'),
(76975, 'Ponca City', 36.7069396972656, 0.640656956048296, -97.0852813720703, -1.69445781516775, 218, 42, 'PPL', 'P'),
(17696, 'Ponce de Leon', 30.7227802276611, 0.5362136703393, -85.9375, -1.49989232593263, 218, 12, 'PPL', 'P'),
(56983, 'Ponce de Leon', 36.8758316040039, 0.64360467590085, -93.3513870239258, -1.62928906487102, 218, 29, 'PPL', 'P'),
(17694, 'Ponce Inlet', 29.0961093902588, 0.507822908380456, -80.9372177124023, -1.41262093648489, 218, 12, 'PPL', 'P'),
(128575, 'Ponce Landing', 43.6894416809082, 0.762524605689894, -70.1686096191406, -1.22467326940057, 218, 26, 'PPL', 'P'),
(17695, 'Ponce Park (historical)', 29.0799999237061, 0.50754174514837, -80.9216690063477, -1.41234956036981, 218, 12, 'PPL', 'P'),
(187218, 'Poncha Springs', 38.5127792358398, 0.672174801759111, -106.076667785645, -1.8513871124037, 218, 7, 'PPL', 'P'),
(42646, 'Ponchatoula', 30.4386100769043, 0.531253965572704, -90.4413909912109, -1.57850005288017, 218, 22, 'PPL', 'P'),
(151825, 'Ponck Hockie', 41.9247207641602, 0.731724415313828, -73.9733276367188, -1.29107812591726, 218, 40, 'PPL', 'P'),
(28297, 'Pond', 37.4449996948242, 0.653538533082955, -88.8327789306641, -1.55042447603634, 218, 18, 'PPL', 'P'),
(56985, 'Pond', 38.5802803039551, 0.673352917646335, -90.6561126708984, -1.58224765316613, 218, 29, 'PPL', 'P'),
(90049, 'Pond', 36.1047210693359, 0.63014625817408, -87.4288864135742, -1.52592192926901, 218, 50, 'PPL', 'P'),
(184219, 'Pond', 35.7177810668945, 0.623392881123803, -119.327781677246, -2.08266267936891, 218, 6, 'PPL', 'P'),
(11329, 'Pond (historical)', 36.3777809143066, 0.634912051523804, -94.3902816772461, -1.64742119715282, 218, 4, 'PPL', 'P'),
(14436, 'Pond Acres', 38.5538902282715, 0.672892323935806, -75.0688934326172, -1.31019935622792, 218, 10, 'PPL', 'P'),
(78973, 'Pond Bank', 39.8727798461914, 0.695911290238878, -77.5416717529297, -1.35335747958931, 218, 45, 'PPL', 'P'),
(90050, 'Pond Branch', 35.9541702270508, 0.627518650284553, -88.2369384765625, -1.54002509829569, 218, 50, 'PPL', 'P'),
(128576, 'Pond Cove', 43.5963897705078, 0.760900543478136, -70.2291717529297, -1.22573027803722, 218, 26, 'PPL', 'P'),
(17697, 'Pond Creek', 30.7919406890869, 0.537420748103378, -86.3874969482422, -1.50774625430338, 218, 12, 'PPL', 'P'),
(76977, 'Pond Creek', 36.6691703796387, 0.639997757099474, -97.8008270263672, -1.70694644278356, 218, 42, 'PPL', 'P'),
(110959, 'Pond Creek', 39.0941696166992, 0.682321978144531, -81.7433319091797, -1.42669028336573, 218, 58, 'PPL', 'P'),
(166116, 'Pond Creek', 41.0444412231445, 0.716360638985161, -75.8452835083008, -1.3237499193284, 218, 45, 'PPL', 'P'),
(30871, 'Pond Creek Mills', 38.5777816772461, 0.673309308383485, -87.2863922119141, -1.52343493628504, 218, 19, 'PPL', 'P'),
(151827, 'Pond Eddy', 41.4402809143066, 0.723269344906017, -74.8236083984375, -1.30591832477562, 218, 40, 'PPL', 'P'),
(166117, 'Pond Eddy', 41.4311103820801, 0.723109288924503, -74.8233337402344, -1.30591353108565, 218, 45, 'PPL', 'P'),
(110961, 'Pond Fork', 38.3258285522461, 0.668911896791546, -81.3108291625977, -1.41914168641395, 218, 58, 'PPL', 'P'),
(24063, 'Pond Fork (historical)', 34.2069396972656, 0.597023724748437, -83.695556640625, -1.46076303266831, 218, 13, 'PPL', 'P'),
(110960, 'Pond Gap', 38.2780609130859, 0.668078194212297, -81.2788925170898, -1.4185842867978, 218, 58, 'PPL', 'P'),
(105374, 'Pond Gap (historical)', 38.1002807617188, 0.664975345226245, -79.3152770996094, -1.38431273251984, 218, 53, 'PPL', 'P'),
(90051, 'Pond Grove', 35.8669395446777, 0.625996187668382, -84.6675033569336, -1.47772670302184, 218, 50, 'PPL', 'P'),
(90052, 'Pond Hill', 35.5516700744629, 0.620493697382115, -84.6149978637695, -1.47681030929075, 218, 50, 'PPL', 'P'),
(166118, 'Pond Hill', 41.1261100769043, 0.717786029379598, -76.1033325195313, -1.32825372420589, 218, 45, 'PPL', 'P'),
(113938, 'Pond Meadow', 41.3274993896484, 0.721300935965312, -72.4683303833008, -1.26481096861164, 218, 8, 'PPL', 'P'),
(73954, 'Pond Run', 38.6636085510254, 0.674807269917627, -83.1266708374023, -1.45083410233422, 218, 41, 'PPL', 'P'),
(151828, 'Pond Settlement', 44.2602806091309, 0.772487624485935, -75.2225036621094, -1.3128803604973, 218, 40, 'PPL', 'P'),
(24062, 'Pond Spring', 34.8222198486328, 0.607762389211964, -85.3255615234375, -1.48921198469697, 218, 13, 'PPL', 'P'),
(97159, 'Pond Springs', 30.4502792358398, 0.531457630817068, -97.7850036621094, -1.70667027297852, 218, 51, 'PPL', 'P'),
(83095, 'Pond Town', 32.916389465332, 0.57449937403882, -81.1358337402344, -1.4160874401178, 218, 48, 'PPL', 'P'),
(50512, 'Pond View Acres', 38.8219413757324, 0.677570699022748, -76.6691665649414, -1.33812939131818, 218, 25, 'PPL', 'P'),
(125867, 'Pond Village', 42.0305595397949, 0.733571650424934, -70.0944366455078, -1.22337870679468, 218, 23, 'PPL', 'P'),
(110962, 'Pondco', 37.8980598449707, 0.661445924412591, -81.6719436645508, -1.42544432344973, 218, 58, 'PPL', 'P'),
(56990, 'Ponder', 36.5838890075684, 0.638509316366229, -90.9888916015625, -1.58805574118748, 218, 29, 'PPL', 'P'),
(97158, 'Ponder', 33.1827812194824, 0.579148787248907, -97.2869415283203, -1.69797744886439, 218, 51, 'PPL', 'P'),
(50513, 'Ponder Cove', 38.8988914489746, 0.678913731160475, -76.5202789306641, -1.33553081188453, 218, 25, 'PPL', 'P'),
(197278, 'Pondera Colony', 48.2605590820313, 0.842305654834697, -112.391670227051, -1.96160469727772, 218, 31, 'PPL', 'P'),
(195487, 'Ponderay', 48.3055610656738, 0.843091087619189, -116.532783508301, -2.0338807587336, 218, 17, 'PPL', 'P'),
(24066, 'Ponderosa', 32.1955604553223, 0.561918534470258, -82.2544403076172, -1.43561080775306, 218, 13, 'PPL', 'P'),
(37750, 'Ponderosa', 37.3405609130859, 0.65171573247485, -86.1961135864258, -1.50440598450615, 218, 21, 'PPL', 'P'),
(83097, 'Ponderosa', 34.7502784729004, 0.606506775337019, -82.2300033569336, -1.43518430250448, 218, 48, 'PPL', 'P'),
(90053, 'Ponderosa', 35.8777809143066, 0.626185405263832, -84.5352783203125, -1.47541894077923, 218, 50, 'PPL', 'P'),
(105375, 'Ponderosa', 36.5588912963867, 0.638073024000646, -78.4175033569336, -1.3686436247722, 218, 53, 'PPL', 'P'),
(110963, 'Ponderosa', 39.3380584716797, 0.686578641672859, -81.4272232055664, -1.42117314569347, 218, 58, 'PPL', 'P'),
(184221, 'Ponderosa', 36.1055603027344, 0.630160905560075, -118.527221679688, -2.06869027155175, 218, 6, 'PPL', 'P'),
(189264, 'Ponderosa', 35.6599998474121, 0.622384408598017, -106.666938781738, -1.86168928476456, 218, 38, 'PPL', 'P'),
(184222, 'Ponderosa Basin', 37.4661102294922, 0.653906981419767, -119.734718322754, -2.08976506368004, 218, 6, 'PPL', 'P'),
(187219, 'Ponderosa East', 39.5461082458496, 0.690209795240155, -104.669998168945, -1.82683609610453, 218, 7, 'PPL', 'P'),
(24067, 'Ponderosa Estates', 33.8888893127441, 0.591472698351304, -84.835563659668, -1.48065990864646, 218, 13, 'PPL', 'P'),
(50514, 'Ponderosa Estates', 38.273609161377, 0.668000496487494, -76.5883331298828, -1.33671858173071, 218, 25, 'PPL', 'P'),
(205412, 'Ponderosa Estates', 40.6122207641602, 0.708816968881402, -111.861938476563, -1.95235913407935, 218, 52, 'PPL', 'P'),
(184224, 'Ponderosa Fairway Estates', 39.3277816772461, 0.686399277773442, -120.162498474121, -2.09723123579608, 218, 6, 'PPL', 'P'),
(83099, 'Ponderosa Gardens', 34.910831451416, 0.609308953436, -81.850830078125, -1.42856648035369, 218, 48, 'PPL', 'P'),
(83100, 'Ponderosa Heights', 34.2369384765625, 0.597547302218747, -82.2013931274414, -1.43468495980009, 218, 48, 'PPL', 'P'),
(189265, 'Ponderosa Heights', 33.3444404602051, 0.581970273265792, -105.683059692383, -1.84451735521379, 218, 38, 'PPL', 'P'),
(205407, 'Ponderosa Hill', 40.6502799987793, 0.709481227836295, -111.964721679688, -1.95415303938962, 218, 52, 'PPL', 'P'),
(90056, 'Ponderosa Hills', 36.045280456543, 0.62910882377144, -84.0336074829102, -1.46666313290533, 218, 50, 'PPL', 'P'),
(187220, 'Ponderosa Hills', 39.5447196960449, 0.690185560474235, -104.731391906738, -1.82790761896913, 218, 7, 'PPL', 'P'),
(192069, 'Ponderosa Mobile Home Colonia', 31.9249992370605, 0.557196350383384, -106.613998413086, -1.86076530102436, 218, 51, 'PPL', 'P'),
(24069, 'Ponderosa Mobile Home Park', 33.4672203063965, 0.584113185836924, -84.6505584716797, -1.47743095898279, 218, 13, 'PPL', 'P'),
(197279, 'Ponderosa Mobile Home Park', 46.3041687011719, 0.808160201234356, -114.047218322754, -1.99049946247286, 218, 31, 'PPL', 'P'),
(184227, 'Ponderosa Palisades', 39.3152809143066, 0.686181098301137, -120.191673278809, -2.0977404321965, 218, 6, 'PPL', 'P'),
(105376, 'Ponderosa Park', 37.2041702270508, 0.649335265934482, -80.0116729736328, -1.39646713341885, 218, 53, 'PPL', 'P'),
(178908, 'Ponderosa Park', 34.4713897705078, 0.601639249233654, -112.486671447754, -1.9632627813724, 218, 5, 'PPL', 'P'),
(184228, 'Ponderosa Park', 38.1861114501953, 0.666473373339415, -120.367782592773, -2.10081411956861, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(187221, 'Ponderosa Park', 39.4083290100098, 0.687805093933868, -104.65055847168, -1.82649680938166, 218, 7, 'PPL', 'P'),
(117380, 'Ponderosa Park Mobile Home Park', 41.5161094665527, 0.724592802809732, -90.6347198486328, -1.5818742779813, 218, 16, 'PPL', 'P'),
(189266, 'Ponderosa Pine', 34.9769401550293, 0.610462767978277, -106.323608398438, -1.85569703915383, 218, 38, 'PPL', 'P'),
(24070, 'Ponderosa Pines', 33.5933303833008, 0.586314221898847, -84.4927825927734, -1.47467725041565, 218, 13, 'PPL', 'P'),
(178909, 'Ponderosa Spring Subdivision', 34.2708282470703, 0.598138790296854, -110.883331298828, -1.93527921674423, 218, 5, 'PPL', 'P'),
(197280, 'Ponderosa Trailer Court', 45.6763916015625, 0.797203423877552, -111.072219848633, -1.93857594385764, 218, 31, 'PPL', 'P'),
(142726, 'Ponderosa Village Mobile Home Park', 41.3211097717285, 0.721189416094665, -95.9394378662109, -1.6744590732779, 218, 35, 'PPL', 'P'),
(5166, 'Ponders', 32.7102813720703, 0.570902109196395, -85.774169921875, -1.49704167830181, 218, 2, 'PPL', 'P'),
(11330, 'Ponders', 36.0008316040039, 0.6283330449459, -90.8969421386719, -1.5864509203146, 218, 4, 'PPL', 'P'),
(90057, 'Ponders', 35.7619400024414, 0.624163599943272, -84.5558319091797, -1.47577766857807, 218, 50, 'PPL', 'P'),
(208466, 'Ponders Corner', 47.1413917541504, 0.82277250008243, -122.525001525879, -2.13846469263766, 218, 56, 'PPL', 'P'),
(56987, 'Pondfork', 36.7000007629395, 0.640535848797724, -92.709716796875, -1.61808980669696, 218, 29, 'PPL', 'P'),
(110964, 'Pondlick', 38.7136116027832, 0.675679987806846, -82.1116714477539, -1.43311902107912, 218, 58, 'PPL', 'P'),
(205409, 'Pondoray Park', 40.6222190856934, 0.70899147251183, -111.831108093262, -1.95182104238109, 218, 52, 'PPL', 'P'),
(193887, 'Pondosa', 41.1994400024414, 0.719065878020463, -121.687782287598, -2.12385246036862, 218, 6, 'PPL', 'P'),
(201423, 'Pondosa', 45.0080604553223, 0.785538844882032, -117.641670227051, -2.05323448300742, 218, 43, 'PPL', 'P'),
(50515, 'Ponds Edge', 39.6991691589355, 0.692881212129613, -75.9247207641602, -1.3251363609919, 218, 25, 'PPL', 'P'),
(113939, 'Pondside', 41.538330078125, 0.724980625643475, -72.8625030517578, -1.27169057949759, 218, 8, 'PPL', 'P'),
(14437, 'Pondside Acres', 38.8566703796387, 0.67817683448685, -75.4038925170898, -1.31604619324313, 218, 10, 'PPL', 'P'),
(37752, 'Pondsville', 36.9944381713867, 0.645674751016169, -86.165283203125, -1.5038678928079, 218, 21, 'PPL', 'P'),
(50516, 'Pondsville', 39.6205596923828, 0.691509218115032, -77.5880584716797, -1.35416708056069, 218, 25, 'PPL', 'P'),
(125868, 'Pondsville', 41.685001373291, 0.727540522662286, -70.4208297729492, -1.22907534152441, 218, 23, 'PPL', 'P'),
(50517, 'Pondtown', 39.2138900756836, 0.684411494335807, -75.913330078125, -1.32493755601653, 218, 25, 'PPL', 'P'),
(105377, 'Pondtown', 36.9272193908691, 0.644501561976961, -82.0983276367188, -1.4328861276418, 218, 53, 'PPL', 'P'),
(5167, 'Pondville', 32.9049987792969, 0.574300569063445, -87.3111114501953, -1.52386636838163, 218, 2, 'PPL', 'P'),
(90058, 'Pondville', 36.5855598449707, 0.638538477980165, -86.3513870239258, -1.50711601723141, 218, 50, 'PPL', 'P'),
(125871, 'Pondville', 42.1958312988281, 0.736456186780626, -71.8219375610352, -1.25352928560185, 218, 23, 'PPL', 'P'),
(97162, 'Pone', 32.038330078125, 0.559174346704013, -94.8847198486328, -1.65605077119106, 218, 51, 'PPL', 'P'),
(121081, 'Ponemah', 40.8205604553223, 0.712453182454769, -90.7055587768555, -1.58311065051737, 218, 18, 'PPL', 'P'),
(137544, 'Ponemah', 48.0205612182617, 0.838116901914166, -94.9136123657227, -1.65655504074346, 218, 28, 'PPL', 'P'),
(144336, 'Ponemah', 42.8169403076172, 0.747296583997794, -71.6055603027344, -1.24975279001806, 218, 36, 'PPL', 'P'),
(123471, 'Poneto', 40.6569404602051, 0.709597474817877, -85.2216720581055, -1.48739877146879, 218, 19, 'PPL', 'P'),
(37751, 'Pongo', 37.2224998474121, 0.649655178160428, -84.3230590820313, -1.47171501633515, 218, 21, 'PPL', 'P'),
(175903, 'Poniatowski', 44.9949989318848, 0.785310878292721, -89.9933319091797, -1.57067994665526, 218, 57, 'PPL', 'P'),
(125872, 'Ponkapoag', 42.1916694641113, 0.736383549061894, -71.1180572509766, -1.24124425665137, 218, 23, 'PPL', 'P'),
(83101, 'Ponpon', 32.7616691589355, 0.571798995272507, -80.4349975585938, -1.40385554123106, 218, 48, 'PPL', 'P'),
(151829, 'Ponquogue', 40.8563919067383, 0.713078559257747, -72.5055618286133, -1.26546077991762, 218, 40, 'PPL', 'P'),
(105378, 'Pons', 37.0002784729004, 0.645776683506891, -76.7919387817383, -1.34027217073126, 218, 53, 'PPL', 'P'),
(113940, 'Ponset', 41.4650001525879, 0.72370077700261, -72.5566711425781, -1.26635280572474, 218, 8, 'PPL', 'P'),
(137545, 'Ponsford', 46.9700012207031, 0.819781170967025, -95.3836135864258, -1.66475810953313, 218, 28, 'PPL', 'P'),
(137546, 'Ponsford Landing', 47.3313903808594, 0.826088601692769, -95.454719543457, -1.6659991426011, 218, 28, 'PPL', 'P'),
(132686, 'Ponshewaing', 45.4211082458496, 0.792747888794822, -84.8033294677734, -1.48009731586618, 218, 27, 'PPL', 'P'),
(166119, 'Pont', 41.851390838623, 0.730444566672963, -80.3058319091797, -1.40160117536831, 218, 45, 'PPL', 'P'),
(42651, 'Pont Brulee (historical)', 30.3611106872559, 0.529901346055053, -91.9638900756836, -1.60507267476282, 218, 22, 'PPL', 'P'),
(42647, 'Pont Des Mouton', 30.2719402313232, 0.528345028003524, -91.9833297729492, -1.60541196148569, 218, 22, 'PPL', 'P'),
(97160, 'Ponta', 31.8983497619629, 0.556731229299002, -95.0767288208008, -1.65940195994876, 218, 51, 'PPL', 'P'),
(42648, 'Pontchartrain Beach', 30.0330600738525, 0.524175782737978, -90.0619430541992, -1.57187743703941, 218, 22, 'PPL', 'P'),
(132687, 'Pontchartrain Shores', 46.0294418334961, 0.803365312849722, -84.591667175293, -1.47640311196007, 218, 27, 'PPL', 'P'),
(17699, 'Ponte Vedra', 30.2272205352783, 0.52756452206705, -81.3802795410156, -1.4203538241841, 218, 12, 'PPL', 'P'),
(17698, 'Ponte Vedra Beach', 30.2394409179688, 0.527777807980851, -81.3858337402344, -1.42045076324778, 218, 12, 'PPL', 'P'),
(24071, 'Pontevedra', 33.6519393920898, 0.587337142073547, -84.5802764892578, -1.4762043069847, 218, 13, 'PPL', 'P'),
(30873, 'Pontiac', 39.5902786254883, 0.690980713796706, -87.1186065673828, -1.52050652435039, 218, 19, 'PPL', 'P'),
(33667, 'Pontiac', 37.8175010681152, 0.660039908515083, -96.7158279418945, -1.68800963637839, 218, 20, 'PPL', 'P'),
(56988, 'Pontiac', 36.5155601501465, 0.637316752830091, -92.6036071777344, -1.61623784447492, 218, 29, 'PPL', 'P'),
(83102, 'Pontiac', 34.1283302307129, 0.595651730733856, -80.8550033569336, -1.41118602528956, 218, 48, 'PPL', 'P'),
(121082, 'Pontiac', 40.8808288574219, 0.713505064506323, -88.6297225952148, -1.54688047441571, 218, 18, 'PPL', 'P'),
(132688, 'Pontiac', 42.6388893127441, 0.744189007900807, -83.2911071777344, -1.45370405788295, 218, 27, 'PPL', 'P'),
(151830, 'Pontiac', 42.6238899230957, 0.743927219165653, -78.9694366455078, -1.37827667790918, 218, 40, 'PPL', 'P'),
(157219, 'Pontiac', 41.1888885498047, 0.718881720431084, -82.7249984741211, -1.4438235970807, 218, 41, 'PPL', 'P'),
(169554, 'Pontiac', 41.7311096191406, 0.728345263364681, -71.4791717529297, -1.24754689368715, 218, 47, 'PPL', 'P'),
(11331, 'Pontoon', 35.1119384765625, 0.612818933173698, -93.0102767944336, -1.62333556825414, 218, 4, 'PPL', 'P'),
(28299, 'Pontoon Beach', 38.7316703796387, 0.675995172921857, -90.0802764892578, -1.57219741584439, 218, 18, 'PPL', 'P'),
(121084, 'Pontoosuc', 40.6288909912109, 0.709107919230493, -91.2052764892578, -1.59183236992932, 218, 18, 'PPL', 'P'),
(125873, 'Pontoosuc', 42.4791717529297, 0.741401410608794, -73.2458267211914, -1.27838083963003, 218, 23, 'PPL', 'P'),
(125874, 'Pontoosuc Gardens', 42.4944381713867, 0.741667859875857, -73.2375030517578, -1.27823556419257, 218, 23, 'PPL', 'P'),
(137548, 'Pontoria', 46.8633308410645, 0.817919421627978, -94.3363876342773, -1.6464805686558, 218, 28, 'PPL', 'P'),
(61389, 'Pontotoc', 34.2477798461914, 0.597736519814197, -88.9986114501953, -1.55331879950903, 218, 30, 'PPL', 'P'),
(76980, 'Pontotoc', 34.4886093139648, 0.601939786962669, -96.6255569458008, -1.6864341102775, 218, 42, 'PPL', 'P'),
(97161, 'Pontotoc', 30.9091701507568, 0.539466788189859, -98.9797210693359, -1.72752202536551, 218, 51, 'PPL', 'P'),
(113941, 'Ponus', 41.1266708374023, 0.717795816496604, -73.5202789306641, -1.2831709343247, 218, 8, 'PPL', 'P'),
(123472, 'Pony', 40.4447212219238, 0.705893550373795, -85.0947189331055, -1.48518302144185, 218, 19, 'PPL', 'P'),
(157216, 'Pony', 41.023609161377, 0.715997050917338, -81.3833312988281, -1.4204070874059, 218, 41, 'PPL', 'P'),
(197281, 'Pony', 45.6586112976074, 0.79689309903153, -111.893608093262, -1.95291187316359, 218, 31, 'PPL', 'P'),
(205410, 'Pony Acres Estates', 41.1794395446777, 0.718716804180581, -112.059997558594, -1.95581591717427, 218, 52, 'PPL', 'P'),
(178910, 'Pony Acres Mobile Home Park', 33.413330078125, 0.583172623918935, -111.905281066895, -1.95311560498698, 218, 5, 'PPL', 'P'),
(190624, 'Pony Springs', 38.3188896179199, 0.668790789540975, -114.605827331543, -2.00024902890753, 218, 39, 'PPL', 'P'),
(37753, 'Ponza', 36.7200012207031, 0.640884922637607, -83.6425018310547, -1.45983705155729, 218, 21, 'PPL', 'P'),
(67921, 'Ponzer', 35.5875015258789, 0.621119074185093, -76.495002746582, -1.33508965924996, 218, 33, 'PPL', 'P'),
(144337, 'Poocham', 42.9505615234375, 0.749628714164376, -72.477783203125, -1.26497595144117, 218, 36, 'PPL', 'P'),
(50519, 'Pooks Hill', 39.0138893127441, 0.680920822516013, -77.1063919067383, -1.34576041310569, 218, 25, 'PPL', 'P'),
(110965, 'Pool', 38.1636085510254, 0.666080623657655, -80.8644409179688, -1.41135074180298, 218, 58, 'PPL', 'P'),
(11333, 'Pool (historical)', 33.894718170166, 0.591574431104945, -92.2283325195313, -1.60968806608998, 218, 4, 'PPL', 'P'),
(67922, 'Pool (historical)', 35.5411109924316, 0.620309406634682, -80.3372192382813, -1.40214898760454, 218, 33, 'PPL', 'P'),
(37754, 'Poole', 37.6402816772461, 0.656946846646038, -87.644172668457, -1.529679383251, 218, 21, 'PPL', 'P'),
(42652, 'Poole', 32.2863883972168, 0.563503781109128, -93.491943359375, -1.63174223570914, 218, 22, 'PPL', 'P'),
(50518, 'Poole', 39.6411094665527, 0.691867879334838, -76.2561111450195, -1.33092021424733, 218, 25, 'PPL', 'P'),
(76979, 'Poole', 35.6088905334473, 0.621492382790895, -97.2263870239258, -1.6969205733858, 218, 42, 'PPL', 'P'),
(97163, 'Poole', 32.9497184753418, 0.57508107499992, -95.6669387817383, -1.66970306704519, 218, 51, 'PPL', 'P'),
(142727, 'Poole', 40.9797210693359, 0.715231059208804, -98.9694366455078, -1.72734252830804, 218, 35, 'PPL', 'P'),
(192070, 'Poole Colonia', 31.6410007476807, 0.552239641673015, -106.276000976563, -1.85486613289372, 218, 51, 'PPL', 'P'),
(56991, 'Poole Ford', 36.5736083984375, 0.638329885887785, -94.4169387817383, -1.64788645139526, 218, 29, 'PPL', 'P'),
(24072, 'Pooler', 32.1152801513672, 0.56051737884174, -81.2472229003906, -1.41803154771355, 218, 13, 'PPL', 'P'),
(137549, 'Poolers Mobile Home Park', 43.8919410705566, 0.766058886772538, -92.8386077880859, -1.62033937886975, 218, 28, 'PPL', 'P'),
(105379, 'Pooles', 36.9316711425781, 0.644579259701764, -76.2394409179688, -1.33062926389824, 218, 53, 'PPL', 'P'),
(5169, 'Pooles Crossroad', 33.1163902282715, 0.577990045858614, -85.4588928222656, -1.49153905485748, 218, 2, 'PPL', 'P'),
(24073, 'Pooles Mobile Home Park', 33.5744400024414, 0.585984522555896, -84.2736129760742, -1.47085201898391, 218, 13, 'PPL', 'P'),
(50520, 'Poolesville', 39.1458282470703, 0.683223591331577, -77.4172210693359, -1.35118540540424, 218, 25, 'PPL', 'P'),
(105380, 'Poolesville', 37.0924987792969, 0.647386231490708, -76.7244415283203, -1.33909412142306, 218, 53, 'PPL', 'P'),
(67923, 'Pooletown', 35.5905609130859, 0.621172470564949, -80.2430572509766, -1.40050555089585, 218, 33, 'PPL', 'P'),
(76981, 'Pooleville', 34.4194412231445, 0.600732576040536, -97.3994369506836, -1.69994086437805, 218, 42, 'PPL', 'P'),
(166121, 'Pools Corner', 40.3136100769043, 0.703605229207144, -75.105827331543, -1.31084397436977, 218, 45, 'PPL', 'P'),
(5170, 'Pools Crossroads', 32.7486114501953, 0.571571095262223, -86.7194366455078, -1.51353969493874, 218, 2, 'PPL', 'P'),
(128577, 'Pools Landing', 43.9411087036133, 0.766917023854789, -69.5902786254883, -1.214579489395, 218, 26, 'PPL', 'P'),
(105381, 'Pools Mill', 36.6563911437988, 0.63977471735818, -78.7033309936523, -1.37363225812613, 218, 53, 'PPL', 'P'),
(151831, 'Poolsburg', 42.4366683959961, 0.740659587087153, -73.7716674804688, -1.28755849222061, 218, 40, 'PPL', 'P'),
(61391, 'Poolville', 34.4674987792969, 0.601571338625857, -89.120002746582, -1.55543747731425, 218, 30, 'PPL', 'P'),
(97164, 'Poolville', 32.9749984741211, 0.575522294213519, -97.857780456543, -1.70794046766043, 218, 51, 'PPL', 'P'),
(151832, 'Poolville', 42.7755584716797, 0.746574334710164, -75.5069427490234, -1.31784475908532, 218, 40, 'PPL', 'P'),
(67924, 'Poolville (historical)', 36.2377815246582, 0.632468601223656, -76.1324996948242, -1.32876278744826, 218, 33, 'PPL', 'P'),
(90059, 'Poor', 35.0363883972168, 0.611500335538972, -88.8936080932617, -1.5514861452049, 218, 50, 'PPL', 'P'),
(105382, 'Poor Farm', 37.1388893127441, 0.648195899041119, -76.4572219848633, -1.33443026056406, 218, 53, 'PPL', 'P'),
(56992, 'Poor Farm (historical)', 37.0999984741211, 0.647517125858285, -89.5274963378906, -1.56254958216336, 218, 29, 'PPL', 'P'),
(137550, 'Poor Farm Landing', 44.3288917541504, 0.773685114870089, -94.2408294677734, -1.64481276402314, 218, 28, 'PPL', 'P'),
(67925, 'Poor Town', 36.2802810668945, 0.633210358166271, -77.0255584716797, -1.34434960351822, 218, 33, 'PPL', 'P'),
(97166, 'Poorboy Landing', 33.2249984741211, 0.579885617343505, -94.3019409179688, -1.64587936003972, 218, 51, 'PPL', 'P'),
(105383, 'Poorhouse Corner', 38.0283317565918, 0.663719598193246, -77.2708282470703, -1.34863036865442, 218, 53, 'PPL', 'P'),
(212097, 'Poorman', 64.0994415283203, 1.11874630335878, -155.543884277344, -2.71475291198069, 218, 1, 'PPL', 'P'),
(166120, 'Poorman Side', 41.0636100769043, 0.716695198597102, -77.9233322143555, -1.36001871126587, 218, 45, 'PPL', 'P'),
(128578, 'Poors Mill', 44.4280586242676, 0.775415903262532, -69.100830078125, -1.20603700072441, 218, 26, 'PPL', 'P'),
(113942, 'Pootatuck Park', 41.4291687011719, 0.723075400199632, -73.2602767944336, -1.27863304098526, 218, 8, 'PPL', 'P'),
(30872, 'Popcorn', 38.975830078125, 0.68025656356112, -86.6569366455078, -1.51244886415624, 218, 19, 'PPL', 'P'),
(5173, 'Pope', 32.0627784729004, 0.559601051689671, -87.6244430541992, -1.52933503652205, 218, 2, 'PPL', 'P'),
(37755, 'Pope', 36.7625007629395, 0.641626679580221, -86.3397216796875, -1.50691241856608, 218, 21, 'PPL', 'P'),
(61392, 'Pope', 34.2150001525879, 0.597164406233021, -89.9477767944336, -1.56988485991182, 218, 30, 'PPL', 'P'),
(90060, 'Pope', 35.6186103820801, 0.621662026152333, -87.9894409179688, -1.53570545100758, 218, 50, 'PPL', 'P'),
(105384, 'Pope', 36.7194404602051, 0.6408751355206, -77.1672210693359, -1.34682208227425, 218, 53, 'PPL', 'P'),
(151833, 'Pope', 42.209171295166, 0.736689013638926, -79.004997253418, -1.37889732760122, 218, 40, 'PPL', 'P'),
(192909, 'Pope', 33.3658294677734, 0.582343581871594, -115.721939086914, -2.01972885385897, 218, 6, 'PPL', 'P'),
(125875, 'Pope Beach', 41.6319389343262, 0.726614408393211, -70.8791732788086, -1.23707494480679, 218, 23, 'PPL', 'P'),
(97165, 'Pope City', 32.684440612793, 0.57045110286579, -94.3066711425781, -1.64596191803351, 218, 51, 'PPL', 'P'),
(67926, 'Pope Crossing', 34.5661087036133, 0.603292406480321, -78.9980621337891, -1.37877628692968, 218, 33, 'PPL', 'P'),
(83103, 'Pope Crossroads', 33.7016716003418, 0.588205132851831, -79.3038864135742, -1.38411392754447, 218, 48, 'PPL', 'P'),
(24074, 'Pope Hills Estate', 33.2747192382813, 0.580753408384707, -84.647216796875, -1.47737263575492, 218, 13, 'PPL', 'P'),
(151834, 'Pope Mills', 44.4847183227539, 0.776404801554305, -75.5811080932617, -1.31913918853315, 218, 40, 'PPL', 'P'),
(184230, 'Pope Valley', 38.6152801513672, 0.673963780221372, -122.426666259766, -2.13674841847316, 218, 6, 'PPL', 'P'),
(117387, 'Popejoy', 42.5938911437988, 0.743403641695343, -93.4258270263672, -1.63058828800881, 218, 16, 'PPL', 'P'),
(157217, 'Popes Corners', 41.3869400024414, 0.722338370367953, -81.1722183227539, -1.41672247087972, 218, 41, 'PPL', 'P'),
(50521, 'Popes Creek', 38.3988914489746, 0.670187084900503, -76.9913864135742, -1.3437531885921, 218, 25, 'PPL', 'P'),
(67927, 'Popes Crossroads', 36.0847206115723, 0.629797184334198, -78.4974975585938, -1.37003978697367, 218, 33, 'PPL', 'P'),
(151835, 'Popes Ravine', 42.1183280944824, 0.735103500683948, -75.8697204589844, -1.32417642457698, 218, 40, 'PPL', 'P'),
(61393, 'Popetown', 30.7069396972656, 0.535937200928636, -88.5625, -1.54570721879748, 218, 30, 'PPL', 'P'),
(128579, 'Popeville', 43.7844390869141, 0.76418262320555, -70.4197235107422, -1.22905603360651, 218, 26, 'PPL', 'P'),
(97167, 'Popeye Lake Colonia', 28.6679992675781, 0.500350977178561, -99.8190002441406, -1.74217021030928, 218, 51, 'PPL', 'P'),
(128580, 'Popham Beach', 43.7519416809082, 0.76361543647239, -69.7850036621094, -1.21797808242011, 218, 26, 'PPL', 'P'),
(11336, 'Poping', 35.4527816772461, 0.618767769258662, -93.8894424438477, -1.63867990350685, 218, 4, 'PPL', 'P'),
(37756, 'Poplar', 38.4419403076172, 0.670938429223042, -83.1530609130859, -1.45129469604475, 218, 21, 'PPL', 'P'),
(50522, 'Poplar', 39.3541717529297, 0.686859871483971, -76.4527816772461, -1.33435276257634, 218, 25, 'PPL', 'P'),
(67928, 'Poplar', 36.0724983215332, 0.629583865130882, -82.3433303833008, -1.43716223224608, 218, 33, 'PPL', 'P'),
(90061, 'Poplar', 36.0466690063477, 0.629133058537359, -84.3102798461914, -1.47149197659386, 218, 50, 'PPL', 'P'),
(105385, 'Poplar', 38.0141716003418, 0.663472456844086, -77.4122161865234, -1.35109805372048, 218, 53, 'PPL', 'P'),
(117383, 'Poplar', 41.6883316040039, 0.727598646153077, -95.0933303833008, -1.65969171187536, 218, 16, 'PPL', 'P'),
(137552, 'Poplar', 46.586669921875, 0.813090777676528, -94.6963882446289, -1.65276376461563, 218, 28, 'PPL', 'P'),
(175904, 'Poplar', 46.5838890075684, 0.813042241565662, -91.7988891601563, -1.60219286551806, 218, 57, 'PPL', 'P'),
(184231, 'Poplar', 36.0533294677734, 0.629249305518941, -119.142219543457, -2.07942400916726, 218, 6, 'PPL', 'P'),
(195488, 'Poplar', 43.6202812194824, 0.761317527925816, -111.684997558594, -1.94927093247929, 218, 17, 'PPL', 'P'),
(197283, 'Poplar', 48.1130599975586, 0.839731310166972, -105.197776794434, -1.83604757084095, 218, 31, 'PPL', 'P'),
(151836, 'Poplar Beach', 42.7261085510254, 0.745711270779897, -76.7613906860352, -1.33973900588102, 218, 40, 'PPL', 'P'),
(56993, 'Poplar Bluff', 36.7569389343262, 0.641529607358487, -90.3927764892578, -1.57765156975687, 218, 29, 'PPL', 'P'),
(67929, 'Poplar Branch', 36.2799987792969, 0.633205431318254, -75.8930587768555, -1.32458375506571, 218, 33, 'PPL', 'P'),
(166122, 'Poplar Bridge', 41.0727806091309, 0.716855254578616, -75.1147232055664, -1.31099923666132, 218, 45, 'PPL', 'P'),
(121086, 'Poplar City', 40.2472190856934, 0.702446487816851, -89.9397201538086, -1.56974424500626, 218, 18, 'PPL', 'P'),
(11335, 'Poplar Corner', 35.9308280944824, 0.627111253216799, -90.1772232055664, -1.57388945524297, 218, 4, 'PPL', 'P'),
(37757, 'Poplar Corner', 37.6083297729492, 0.656389180713775, -85.1486129760742, -1.48612364993886, 218, 21, 'PPL', 'P'),
(90062, 'Poplar Corner', 35.6597213745117, 0.622379548329027, -89.0991668701172, -1.5550738226674, 218, 50, 'PPL', 'P'),
(83105, 'Poplar Cove', 34.6425018310547, 0.604625718080069, -82.8788909912109, -1.4465095281981, 218, 48, 'PPL', 'P'),
(5175, 'Poplar Creek', 34.7955589294434, 0.6072970683905, -87.1247177124023, -1.52061318395204, 218, 2, 'PPL', 'P'),
(61394, 'Poplar Creek', 33.3519401550293, 0.582101167633369, -89.5555572509766, -1.56303933748782, 218, 30, 'PPL', 'P'),
(90063, 'Poplar Creek', 35.6761093139648, 0.622665571830102, -87.2091674804688, -1.52208711045735, 218, 50, 'PPL', 'P'),
(5176, 'Poplar Creek (historical)', 34.6124992370605, 0.604102074030732, -87.5416717529297, -1.52789040478874, 218, 2, 'PPL', 'P'),
(24075, 'Poplar Crossroads', 32.704719543457, 0.570805036974662, -84.3986129760742, -1.47303368054891, 218, 13, 'PPL', 'P'),
(90064, 'Poplar Estates', 36.1333312988281, 0.63064560087847, -85.4416732788086, -1.49123851712847, 218, 50, 'PPL', 'P'),
(37758, 'Poplar Flat', 38.5944404602051, 0.673600058995494, -83.5236129760742, -1.45776204959395, 218, 21, 'PPL', 'P'),
(105386, 'Poplar Flats', 37.7472190856934, 0.658813256516993, -78.9255599975586, -1.37751088593773, 218, 53, 'PPL', 'P'),
(105388, 'Poplar Forest', 37.7297210693359, 0.658507858518988, -77.8380584716797, -1.35853040369068, 218, 53, 'PPL', 'P'),
(83106, 'Poplar Forks', 33.9330596923828, 0.592243616907854, -79.0341720581055, -1.37940652400164, 218, 48, 'PPL', 'P'),
(166125, 'Poplar Gardens', 40.2924995422363, 0.703236780870332, -76.8050003051758, -1.34050013732057, 218, 45, 'PPL', 'P'),
(11338, 'Poplar Grove', 34.935001373291, 0.609730798152669, -90.817497253418, -1.58506434549305, 218, 4, 'PPL', 'P'),
(24076, 'Poplar Grove', 34.5141716003418, 0.602385933024285, -83.1155624389648, -1.45064022420687, 218, 13, 'PPL', 'P'),
(37761, 'Poplar Grove', 38.6580581665039, 0.674710397432975, -84.8411102294922, -1.48075671455208, 218, 21, 'PPL', 'P'),
(42653, 'Poplar Grove', 30.5361099243164, 0.532955658930238, -91.9986114501953, -1.60567867706886, 218, 22, 'PPL', 'P'),
(50523, 'Poplar Grove', 39.6369400024414, 0.691795108458052, -76.2677764892578, -1.33112381291267, 218, 25, 'PPL', 'P'),
(67933, 'Poplar Grove', 36.1977806091309, 0.631770453543892, -81.7088928222656, -1.4260892079077, 218, 33, 'PPL', 'P'),
(73955, 'Poplar Grove', 39.0438919067383, 0.68144446656535, -83.3050003051758, -1.4539465387002, 218, 41, 'PPL', 'P'),
(90070, 'Poplar Grove', 36.464168548584, 0.636419800174952, -82.5861129760742, -1.44139958785651, 218, 50, 'PPL', 'P'),
(105389, 'Poplar Grove', 37.5849990844727, 0.655981983383102, -77.0386123657227, -1.34457743694948, 218, 53, 'PPL', 'P'),
(121088, 'Poplar Grove', 41.4577789306641, 0.723574742904022, -90.4563903808594, -1.57876184161532, 218, 18, 'PPL', 'P'),
(123473, 'Poplar Grove', 40.5555610656738, 0.707828070589629, -86.3472213745117, -1.50704331293365, 218, 19, 'PPL', 'P'),
(166124, 'Poplar Grove', 40.2319412231445, 0.702179838812707, -76.3158264160156, -1.33196244233994, 218, 45, 'PPL', 'P'),
(42654, 'Poplar Grove Plantation', 30.4897193908691, 0.532145991379826, -91.2072219848633, -1.59186632523322, 218, 22, 'PPL', 'P'),
(105390, 'Poplar Halls', 36.8511085510254, 0.64317317722523, -76.2169418334961, -1.33023658079551, 218, 53, 'PPL', 'P'),
(17700, 'Poplar Head', 30.7180595397949, 0.536131278793076, -85.6474990844727, -1.49483085512288, 218, 12, 'PPL', 'P'),
(105391, 'Poplar Heights', 38.8872184753418, 0.678709999337084, -77.1963882446289, -1.34733114551662, 218, 53, 'PPL', 'P'),
(37762, 'Poplar Highlands', 38.545280456543, 0.672742055071298, -82.7547225952148, -1.44434238086105, 218, 21, 'PPL', 'P'),
(24077, 'Poplar Hill', 31.9908294677734, 0.558345304656672, -83.1011123657227, -1.45038802285163, 218, 13, 'PPL', 'P'),
(50524, 'Poplar Hill', 38.6222190856934, 0.674084887471943, -76.7413864135742, -1.33938986546211, 218, 25, 'PPL', 'P'),
(83108, 'Poplar Hill', 33.7266693115234, 0.588641425217413, -79.4494400024414, -1.38665431690829, 218, 48, 'PPL', 'P'),
(90072, 'Poplar Hill', 35.4022216796875, 0.617885330831464, -84.6352767944336, -1.47716424339962, 218, 50, 'PPL', 'P'),
(105392, 'Poplar Hill', 37.2174987792969, 0.649567893055701, -80.7391662597656, -1.40916428654803, 218, 53, 'PPL', 'P'),
(67934, 'Poplar Hill (historical)', 34.9461097717285, 0.609924676280027, -80.2027816772461, -1.39980260952612, 218, 33, 'PPL', 'P'),
(37763, 'Poplar Hills', 38.1775016784668, 0.666323104474907, -85.6930618286133, -1.49562607502437, 218, 21, 'PPL', 'P'),
(90073, 'Poplar Hills', 36.0291709899902, 0.628827660539355, -86.9375, -1.51734561845257, 218, 50, 'PPL', 'P'),
(50526, 'Poplar Knob', 39.6091690063477, 0.691310413139657, -77.4216690063477, -1.35126303655001, 218, 25, 'PPL', 'P'),
(105393, 'Poplar Landing', 37.764720916748, 0.659118721094025, -77.0824966430664, -1.34534336207899, 218, 53, 'PPL', 'P'),
(37764, 'Poplar Level', 37.9199981689453, 0.661828820398317, -85.6391677856445, -1.49468544652736, 218, 21, 'PPL', 'P'),
(50527, 'Poplar Neck', 38.4083290100098, 0.670351801413924, -75.3874969482422, -1.315760036584, 218, 25, 'PPL', 'P'),
(37765, 'Poplar Plains', 38.3608283996582, 0.669522759366583, -83.6744384765625, -1.46039445117344, 218, 21, 'PPL', 'P'),
(5178, 'Poplar Point', 34.728328704834, 0.606123679614211, -87.1374969482422, -1.52083622369334, 218, 2, 'PPL', 'P'),
(50529, 'Poplar Point', 39.5499992370605, 0.690277705847952, -76.029167175293, -1.32695929475806, 218, 25, 'PPL', 'P'),
(110966, 'Poplar Point Estates', 38.4505615234375, 0.671088897824631, -81.7780609130859, -1.42729641882983, 218, 58, 'PPL', 'P'),
(5177, 'Poplar Ridge', 34.5872192382813, 0.603660854817133, -86.3647232055664, -1.50734877751069, 218, 2, 'PPL', 'P'),
(11339, 'Poplar Ridge', 35.829719543457, 0.625346576099485, -90.4044418334961, -1.57785516842221, 218, 4, 'PPL', 'P'),
(28303, 'Poplar Ridge', 37.7002792358398, 0.657994001586657, -89.3705596923828, -1.55981052098221, 218, 18, 'PPL', 'P'),
(50530, 'Poplar Ridge', 39.1300010681152, 0.682947354947509, -76.4647216796875, -1.33456115493164, 218, 25, 'PPL', 'P'),
(90074, 'Poplar Ridge', 36.207218170166, 0.631935170057313, -89.2452774047852, -1.5576239325692, 218, 50, 'PPL', 'P'),
(105394, 'Poplar Ridge', 39.0869407653809, 0.682195810887888, -78.2947235107422, -1.36650071220107, 218, 53, 'PPL', 'P'),
(151837, 'Poplar Ridge', 42.7383308410645, 0.745924589983212, -76.6183319091797, -1.33724215920102, 218, 40, 'PPL', 'P'),
(157218, 'Poplar Ridge', 40.0752792358398, 0.699445571321522, -84.5455627441406, -1.47559843783671, 218, 41, 'PPL', 'P'),
(128581, 'Poplar Ripps', 45.6988906860352, 0.797596106980284, -69.8705596923828, -1.21947131684332, 218, 26, 'PPL', 'P'),
(83109, 'Poplar Spring', 33.4858283996582, 0.584437958331859, -80.9477767944336, -1.41280522723233, 218, 48, 'PPL', 'P'),
(5180, 'Poplar Springs', 34.0325012207031, 0.593979198990259, -87.396110534668, -1.52534988226686, 218, 2, 'PPL', 'P'),
(24080, 'Poplar Springs', 33.811939239502, 0.590129666213577, -83.4013900756836, -1.4556288575608, 218, 13, 'PPL', 'P'),
(50534, 'Poplar Springs', 39.3433303833008, 0.686670653888521, -77.0966720581055, -1.34559076974425, 218, 25, 'PPL', 'P'),
(61400, 'Poplar Springs', 34.3633308410645, 0.599753265128687, -88.8949966430664, -1.55151037997082, 218, 30, 'PPL', 'P'),
(67939, 'Poplar Springs', 36.3111114501953, 0.633748449864521, -80.8327789306641, -1.41079813587679, 218, 33, 'PPL', 'P'),
(83111, 'Poplar Springs', 34.8658294677734, 0.608523520651509, -82.0527801513672, -1.43209117405641, 218, 48, 'PPL', 'P'),
(90080, 'Poplar Springs', 35.7827796936035, 0.624527321169149, -88.1958312988281, -1.53930764269802, 218, 50, 'PPL', 'P'),
(5181, 'Poplar Springs (historical)', 32.0391693115234, 0.559188994090009, -85.2750015258789, -1.48832954626978, 218, 2, 'PPL', 'P'),
(5182, 'Poplar Springs Branch', 34.7969398498535, 0.607321169998365, -87.2555618286133, -1.52289684458679, 218, 2, 'PPL', 'P'),
(83112, 'Poplar Springs Ridge', 34.6991691589355, 0.605614749529897, -83.0305633544922, -1.44915671032164, 218, 48, 'PPL', 'P'),
(67941, 'Poplar Tent', 35.4291687011719, 0.618355645079972, -80.6602783203125, -1.40778743226445, 218, 33, 'PPL', 'P'),
(50531, 'Poplar Thicket', 39.3333282470703, 0.686496083679067, -77.4908294677734, -1.35247011431409, 218, 25, 'PPL', 'P'),
(90081, 'Poplar Top', 35.6136093139648, 0.621574741047605, -87.1430587768555, -1.52093329591507, 218, 50, 'PPL', 'P'),
(50532, 'Poplar Woods', 38.5847206115723, 0.673430415634056, -76.533332824707, -1.33575864531579, 218, 25, 'PPL', 'P'),
(50533, 'Poplars', 38.6725006103516, 0.674962465630152, -76.5511093139648, -1.33606890358278, 218, 25, 'PPL', 'P'),
(78976, 'Poplars', 39.9886093139648, 0.697932895822357, -76.8055572509766, -1.34050985785855, 218, 45, 'PPL', 'P'),
(197284, 'Poplars Trailer Court', 48.5333290100098, 0.84706638817835, -109.699996948242, -1.91462613617456, 218, 31, 'PPL', 'P'),
(37766, 'Poplarville', 37.024169921875, 0.64619366795457, -84.4377822875977, -1.47371731400073, 218, 21, 'PPL', 'P'),
(61401, 'Poplarville', 30.8400001525879, 0.538259543978212, -89.5341720581055, -1.56266609546105, 218, 30, 'PPL', 'P'),
(90086, 'Poplins Crossroads', 35.5800018310547, 0.620988179817516, -86.5841674804688, -1.51117880263238, 218, 50, 'PPL', 'P'),
(83113, 'Poppenheim Crossing', 32.9683303833008, 0.575405914073883, -80.0019378662109, -1.39629722374131, 218, 48, 'PPL', 'P'),
(132690, 'Popple', 43.771110534668, 0.763949996084332, -83.0961074829102, -1.45030067116788, 218, 27, 'PPL', 'P'),
(137556, 'Popple Creek', 45.6619415283203, 0.796951222522321, -94.024169921875, -1.64103134159134, 218, 28, 'PPL', 'P'),
(175906, 'Popple River', 45.791389465332, 0.79921051523309, -88.6849975585938, -1.54784520452059, 218, 57, 'PPL', 'P'),
(125876, 'Popponesset', 41.5733299255371, 0.725591488218512, -70.4636077880859, -1.22982195873602, 218, 23, 'PPL', 'P'),
(125877, 'Popponesset Beach', 41.5736083984375, 0.725596348487501, -70.4625015258789, -1.22980265081812, 218, 23, 'PPL', 'P'),
(125878, 'Popponesset Island', 41.584171295166, 0.725780705813962, -70.459716796875, -1.22975404812822, 218, 23, 'PPL', 'P'),
(17701, 'Pops Hammock Seminole Village', 25.6777801513672, 0.448161808244605, -80.7533264160156, -1.40941142789718, 218, 12, 'PPL', 'P'),
(61402, 'Popsons (historical)', 34.0050010681152, 0.593499230782799, -90.466667175293, -1.57894120551474, 218, 30, 'PPL', 'P'),
(24081, 'Popwellville', 31.3158302307129, 0.546564345521515, -81.7452774047852, -1.42672423866963, 218, 13, 'PPL', 'P'),
(113943, 'Poquetanuck', 41.4863891601563, 0.724074085608412, -72.0408325195313, -1.25734972334362, 218, 8, 'PPL', 'P'),
(113944, 'Poquonock', 41.9047203063965, 0.731375341473946, -72.6791687011719, -1.26849079144786, 218, 8, 'PPL', 'P'),
(113945, 'Poquonock Bridge', 41.3450012207031, 0.721606400542344, -72.0252838134766, -1.25707834722854, 218, 8, 'PPL', 'P'),
(105395, 'Poquoson', 37.1222190856934, 0.647904948692028, -76.3461074829102, -1.33249094665826, 218, 53, 'PPL', 'P'),
(105398, 'Poquoson River Estates', 37.1513900756836, 0.648414078513424, -76.4052810668945, -1.333523720529, 218, 53, 'PPL', 'P'),
(105396, 'Poquoson Shores', 37.1541709899902, 0.648462614624291, -76.4061126708984, -1.33353823475694, 218, 53, 'PPL', 'P'),
(151839, 'Poquott', 40.9508285522461, 0.714726789656397, -73.0844421386719, -1.27556414730311, 218, 40, 'PPL', 'P'),
(151840, 'Porcaville', 44.6833305358887, 0.77987123860818, -74.1869430541992, -1.29480641828531, 218, 40, 'PPL', 'P'),
(83114, 'Porcher Bluff', 32.8583297729492, 0.573486041244045, -79.7641677856445, -1.39214735297269, 218, 48, 'PPL', 'P'),
(71309, 'Porches Mill', 39.7002792358398, 0.692900586626544, -75.3330612182617, -1.31480995386512, 218, 37, 'PPL', 'P'),
(71302, 'Porchtown', 39.5944404602051, 0.691053351515437, -75.0833282470703, -1.31045129126704, 218, 37, 'PPL', 'P'),
(97168, 'Porciones Center Colonia', 26.2150001525879, 0.457538066073475, -98.1620025634766, -1.71325014508378, 218, 51, 'PPL', 'P'),
(175908, 'Porcupine', 44.5838890075684, 0.778135656525775, -92.0955581665039, -1.60737071646745, 218, 57, 'PPL', 'P'),
(198758, 'Porcupine', 46.2188911437988, 0.806671827080138, -101.098327636719, -1.76449868552072, 218, 34, 'PPL', 'P'),
(202506, 'Porcupine', 43.2397193908691, 0.754675471009103, -102.330558776855, -1.78600517606171, 218, 49, 'PPL', 'P'),
(197285, 'Porcupine (historical)', 46.2897186279297, 0.807907999879125, -106.659721374512, -1.861563317245, 218, 31, 'PPL', 'P'),
(97169, 'Porfirio', 26.4019393920898, 0.460800771303958, -97.6072235107422, -1.70356742399247, 218, 51, 'PPL', 'P'),
(132691, 'Pori', 46.6797218322754, 0.814714839888286, -88.9599990844727, -1.55264488659519, 218, 27, 'PPL', 'P'),
(166126, 'Porkey', 41.6119384765625, 0.726265334553329, -79.1658325195313, -1.38170443254822, 218, 45, 'PPL', 'P'),
(184239, 'Porphyry', 33.8758316040039, 0.59124479834102, -117.538887023926, -2.05144057769714, 218, 6, 'PPL', 'P'),
(868, 'Port', 35.2044410705566, 0.614433408005531, -99.3069381713867, -1.73323304116514, 218, 42, 'PPL', 'P'),
(97170, 'Port Acres', 29.9016704559326, 0.521882601302338, -94.0319366455078, -1.64116689649082, 218, 51, 'PPL', 'P'),
(193287, 'Port Alexander', 56.2497215270996, 0.981742843977821, -134.644439697266, -2.34998879222024, 218, 1, 'PPL', 'P'),
(193288, 'Port Alice', 55.8263893127441, 0.97435430300756, -133.602783203125, -2.33180845672271, 218, 1, 'PPL', 'P'),
(166145, 'Port Allegany', 41.8108291625977, 0.729736631876193, -78.2799987792969, -1.36624371715587, 218, 45, 'PPL', 'P'),
(42655, 'Port Allen', 30.451940536499, 0.531486625983436, -91.2099990844727, -1.59191479476506, 218, 22, 'PPL', 'P'),
(210983, 'Port Allen', 21.9061107635498, 0.382333759130513, -159.589172363281, -2.785356508272, 218, 15, 'PPL', 'P'),
(117384, 'Port Allen (historical)', 41.3377799987793, 0.721480366443756, -91.3530578613281, -1.59441164144507, 218, 16, 'PPL', 'P'),
(42656, 'Port Allen Landing', 30.4527797698975, 0.531501273369432, -91.2002792358398, -1.59174515140362, 218, 22, 'PPL', 'P'),
(212098, 'Port Alsworth', 60.2024993896484, 1.05073183227924, -154.312774658203, -2.69326599567371, 218, 1, 'PPL', 'P'),
(97171, 'Port Alto', 28.6597194671631, 0.500206467399911, -96.4130630493164, -1.68272539214346, 218, 51, 'PPL', 'P'),
(110967, 'Port Amherst', 38.3097190856934, 0.668630733559461, -81.5569381713867, -1.42343709893614, 218, 58, 'PPL', 'P'),
(61403, 'Port Anderson (historical)', 33.5258293151855, 0.585136106011624, -91.2016677856445, -1.59176938616954, 218, 30, 'PPL', 'P'),
(175909, 'Port Andrew', 43.207218170166, 0.754108217696917, -90.5672225952148, -1.5806962286731, 218, 57, 'PPL', 'P'),
(208468, 'Port Angeles', 48.1183280944824, 0.839823255803607, -123.429443359375, -2.15425018052494, 218, 56, 'PPL', 'P'),
(166128, 'Port Ann', 40.8241691589355, 0.71251616621455, -77.1483306884766, -1.3464923829313, 218, 45, 'PPL', 'P'),
(97172, 'Port Aransas', 27.833610534668, 0.485788146547735, -97.0608291625977, -1.69403104360306, 218, 51, 'PPL', 'P'),
(193289, 'Port Armstrong', 56.2969398498535, 0.982566959177146, -134.661666870117, -2.35028946310731, 218, 1, 'PPL', 'P'),
(97173, 'Port Arthur', 29.898609161377, 0.521829171632968, -93.9286117553711, -1.63936353695868, 218, 51, 'PPL', 'P'),
(175910, 'Port Arthur', 45.4291687011719, 0.792888570279405, -91.1619415283203, -1.59107603217974, 218, 57, 'PPL', 'P'),
(208469, 'Port Arthur (historical)', 48.2147216796875, 0.841505641243238, -122.714996337891, -2.14178072766898, 218, 56, 'PPL', 'P'),
(212099, 'Port Ashton', 60.0574989318848, 1.04820109687437, -148.052215576172, -2.58399862667663, 218, 1, 'PPL', 'P'),
(132692, 'Port Austin', 44.0461082458496, 0.7687496115799, -82.9941711425781, -1.44852154640165, 218, 27, 'PPL', 'P'),
(166129, 'Port Barnett', 41.1563911437988, 0.718314533697925, -79.0511093139648, -1.37970213488264, 218, 45, 'PPL', 'P'),
(42657, 'Port Barre', 30.5599994659424, 0.533372610088403, -91.9538879394531, -1.60489810455336, 218, 22, 'PPL', 'P'),
(121090, 'Port Barrington', 42.2425003051758, 0.737270714600027, -88.2019424438477, -1.53941430229968, 218, 18, 'PPL', 'P'),
(83115, 'Port Bass', 34.5133285522461, 0.602371219059262, -83.0666732788086, -1.4497869473936, 218, 48, 'PPL', 'P'),
(151841, 'Port Ben', 41.749439239502, 0.728665175590626, -74.3488922119141, -1.29763296430827, 218, 40, 'PPL', 'P'),
(5183, 'Port Birmingham', 33.5663909912109, 0.585844040808394, -87.1066665649414, -1.52029813199509, 218, 2, 'PPL', 'P'),
(208470, 'Port Blakely', 47.5974998474121, 0.83073308805484, -122.508888244629, -2.13818346282655, 218, 56, 'PPL', 'P'),
(166130, 'Port Blanchard', 41.3030586242676, 0.720874364137709, -75.8288879394531, -1.32346376266928, 218, 45, 'PPL', 'P'),
(17702, 'Port Boca Grande', 26.7202796936035, 0.466356857707163, -82.2594375610352, -1.43569802627876, 218, 12, 'PPL', 'P'),
(97174, 'Port Bolivar', 29.3805599212646, 0.512787506705554, -94.7641677856445, -1.65394674077184, 218, 51, 'PPL', 'P'),
(42658, 'Port Boliver', 32.4255599975586, 0.565932783760362, -93.3477783203125, -1.62922608111124, 218, 22, 'PPL', 'P'),
(166131, 'Port Bowkley', 41.273609161377, 0.720360374047323, -75.8600006103516, -1.32400678121554, 218, 45, 'PPL', 'P'),
(97175, 'Port Brownsville', 25.9444408416748, 0.452815915276114, -97.4044418334961, -1.70002821606181, 218, 51, 'PPL', 'P'),
(121091, 'Port Byron', 41.6063919067383, 0.726168528647705, -90.3352813720703, -1.57664809065813, 218, 18, 'PPL', 'P'),
(151842, 'Port Byron', 43.0344390869141, 0.751092653815593, -76.6241683959961, -1.33734402511271, 218, 40, 'PPL', 'P'),
(166132, 'Port Carbon', 40.6963882446289, 0.71028596853869, -76.1691665649414, -1.32940274505821, 218, 45, 'PPL', 'P'),
(137560, 'Port Cargill', 44.788330078125, 0.78170382633329, -93.3308334350586, -1.62893033707218, 218, 28, 'PPL', 'P'),
(17703, 'Port Charlotte', 26.975830078125, 0.4708170533218, -82.0908279418945, -1.43275523327422, 218, 12, 'PPL', 'P'),
(50535, 'Port Cherry Gardens Farm', 39.2830581665039, 0.68561870525794, -76.4338912963867, -1.33402306323339, 218, 25, 'PPL', 'P'),
(151843, 'Port Chester', 41.0016708374023, 0.715614154931612, -73.6661071777344, -1.28571611737849, 218, 40, 'PPL', 'P'),
(184232, 'Port Chicago (historical)', 38.0461082458496, 0.66402985646024, -122.019721984863, -2.12964590100398, 218, 6, 'PPL', 'P'),
(193290, 'Port Chilkoot', 59.228889465332, 1.03373913346983, -135.437774658203, -2.36383509935978, 218, 1, 'PPL', 'P'),
(212100, 'Port Clarence', 65.2622222900391, 1.13904065612962, -166.845825195313, -2.91200899286511, 218, 1, 'PPL', 'P'),
(157220, 'Port Clinton', 41.5119400024414, 0.724520031932945, -82.9377822875977, -1.44753737522081, 218, 41, 'PPL', 'P'),
(166134, 'Port Clinton', 40.582218170166, 0.708293324832065, -76.0247192382813, -1.32688166361228, 218, 45, 'PPL', 'P'),
(128582, 'Port Clyde', 43.9272193908691, 0.766674609616564, -69.2533264160156, -1.20869856391784, 218, 26, 'PPL', 'P'),
(146091, 'Port Colden', 40.7630615234375, 0.711449636777, -74.9541702270508, -1.30819705856234, 218, 37, 'PPL', 'P'),
(105399, 'Port Conway', 38.1772193908691, 0.666318177626891, -77.186393737793, -1.34715670846522, 218, 53, 'PPL', 'P'),
(184233, 'Port Costa', 38.0463905334473, 0.664034783308257, -122.182220458984, -2.13248203440685, 218, 6, 'PPL', 'P'),
(151844, 'Port Crane', 42.1641693115234, 0.735903580854435, -75.8338928222656, -1.32355111435303, 218, 40, 'PPL', 'P'),
(132694, 'Port Crescent', 44.0019416809082, 0.767978759602376, -83.0552825927734, -1.44958814241823, 218, 27, 'PPL', 'P'),
(208471, 'Port Crescent', 48.1622200012207, 0.840589314091169, -123.731391906738, -2.15952017684805, 218, 56, 'PPL', 'P'),
(50536, 'Port Deposit', 39.6047210693359, 0.691232781993882, -76.1155624389648, -1.32846717656726, 218, 25, 'PPL', 'P'),
(151845, 'Port Dickinson', 42.1333312988281, 0.73536535599813, -75.8966674804688, -1.32464673882549, 218, 40, 'PPL', 'P'),
(208472, 'Port Discovery', 48.0155601501465, 0.838029616809439, -122.860557556152, -2.14432125019086, 218, 56, 'PPL', 'P'),
(132695, 'Port Dolomite', 45.9847183227539, 0.80258474033422, -84.2750015258789, -1.47087625374983, 218, 27, 'PPL', 'P'),
(151846, 'Port Douglass', 44.4858283996582, 0.776424176051236, -73.418327331543, -1.28139154324237, 218, 40, 'PPL', 'P'),
(42659, 'Port Eads', 29.0163898468018, 0.506431539868944, -89.1616668701172, -1.55616465344989, 218, 22, 'PPL', 'P'),
(175911, 'Port Edwards', 44.350830078125, 0.774068010855815, -89.8652801513672, -1.56844502186847, 218, 57, 'PPL', 'P'),
(71303, 'Port Elizabeth', 39.3133316040039, 0.686147076418212, -74.9813919067383, -1.30867216650081, 218, 37, 'PPL', 'P'),
(140727, 'Port Emma (historical)', 46.0166702270508, 0.803142406266483, -98.1544418334961, -1.71311818545177, 218, 34, 'PPL', 'P'),
(17704, 'Port Everglades', 26.0966701507568, 0.455472817937632, -80.1275024414063, -1.39848873900233, 218, 12, 'PPL', 'P'),
(17705, 'Port Everglades Junction', 26.0799999237061, 0.455181867588541, -80.1688919067383, -1.39921112144802, 218, 12, 'PPL', 'P'),
(151847, 'Port Ewen', 41.9052810668945, 0.731385128590952, -73.9766693115234, -1.29113644914513, 218, 40, 'PPL', 'P'),
(42660, 'Port Fourchon', 29.1055603027344, 0.507987857920472, -90.1944427490234, -1.57418999297198, 218, 22, 'PPL', 'P'),
(30875, 'Port Fulton', 38.2819404602051, 0.668145905083012, -85.7202835083008, -1.49610118296284, 218, 19, 'PPL', 'P'),
(208473, 'Port Gamble', 47.8544387817383, 0.835217518435397, -122.582496643066, -2.13946817173641, 218, 56, 'PPL', 'P'),
(61404, 'Port Gibson', 31.9608306884766, 0.557821727186362, -90.98388671875, -1.58796838950373, 218, 30, 'PPL', 'P'),
(151848, 'Port Gibson', 43.0344390869141, 0.751092653815593, -77.1577835083008, -1.34665736576083, 218, 40, 'PPL', 'P'),
(212112, 'Port Graham', 59.351390838623, 1.03587718577197, -151.829727172852, -2.64992864157096, 218, 1, 'PPL', 'P'),
(166136, 'Port Griffith', 41.3108291625977, 0.721009985616221, -75.8108291625977, -1.32314857755426, 218, 45, 'PPL', 'P'),
(208474, 'Port Hadlock', 48.0319404602051, 0.838315507152459, -122.756942749023, -2.14251283065264, 218, 56, 'PPL', 'P'),
(97176, 'Port Harlingen', 26.1988906860352, 0.457256902841389, -97.6011123657227, -1.70346076439081, 218, 51, 'PPL', 'P'),
(83122, 'Port Harrelson (historical)', 33.6800003051758, 0.587826897398012, -79.1194381713867, -1.38089469841878, 218, 48, 'PPL', 'P'),
(105400, 'Port Haywood', 37.3858299255371, 0.652505825791249, -76.317497253418, -1.33199160395387, 218, 53, 'PPL', 'P'),
(212102, 'Port Heiden', 56.9491691589355, 0.993950508098635, -158.626937866211, -2.76856234812185, 218, 1, 'PPL', 'P'),
(50537, 'Port Heights', 39.625560760498, 0.691596503219759, -76.1236114501953, -1.32860765831476, 218, 25, 'PPL', 'P'),
(151849, 'Port Henry', 44.0483283996582, 0.76878836057376, -73.4602813720703, -1.28212377938408, 218, 40, 'PPL', 'P'),
(50538, 'Port Herman', 39.5019416809082, 0.689438943262631, -75.9024963378906, -1.32474847157913, 218, 25, 'PPL', 'P'),
(42661, 'Port Hickey', 30.6608295440674, 0.535132426936728, -91.290283203125, -1.59331601697261, 218, 22, 'PPL', 'P'),
(42662, 'Port Hickey Landing', 30.6569404602051, 0.535064549618444, -91.2922210693359, -1.59334983911845, 218, 22, 'PPL', 'P'),
(193291, 'Port Higgins', 55.4500007629395, 0.967785083546661, -131.816665649414, -2.30063482458278, 218, 1, 'PPL', 'P'),
(83116, 'Port Hill', 33.7161102294922, 0.58845713446998, -79.2925033569336, -1.38391525572715, 218, 48, 'PPL', 'P'),
(83117, 'Port Hill Landing', 33.7174987792969, 0.588481369235899, -79.2874984741211, -1.38382790404339, 218, 48, 'PPL', 'P'),
(212103, 'Port Hobron', 57.1605606079102, 0.997639984893804, -153.156387329102, -2.67308322935255, 218, 1, 'PPL', 'P'),
(157221, 'Port Homer', 40.5438919067383, 0.707624405345265, -80.6402816772461, -1.4074384250036, 218, 41, 'PPL', 'P'),
(132696, 'Port Hope', 43.9408302307129, 0.7669121635858, -82.7127838134766, -1.44361041103544, 218, 27, 'PPL', 'P'),
(42663, 'Port Hudson', 30.6780605316162, 0.535433164402825, -91.2694396972656, -1.5929522291677, 218, 22, 'PPL', 'P'),
(56996, 'Port Hudson', 38.4538917541504, 0.671147021315422, -91.2538909912109, -1.59268085305262, 218, 29, 'PPL', 'P'),
(184234, 'Port Hueneme', 34.1477813720703, 0.595991217193814, -119.19416809082, -2.08033068236038, 218, 6, 'PPL', 'P'),
(132697, 'Port Huron', 42.9708290100098, 0.749982448536166, -82.4250030517578, -1.43858768921955, 218, 27, 'PPL', 'P'),
(97177, 'Port Ingleside', 27.8233299255371, 0.485608716069291, -97.1949996948242, -1.69637276114957, 218, 51, 'PPL', 'P'),
(17706, 'Port Inglis', 28.9941692352295, 0.506043717035201, -82.7611083984375, -1.44445383415267, 218, 12, 'PPL', 'P'),
(132700, 'Port Inland', 45.9708290100098, 0.802342326095996, -85.8722229003906, -1.49875302561829, 218, 27, 'PPL', 'P'),
(97178, 'Port Isabel', 26.0730590820313, 0.455060727048456, -97.2083282470703, -1.69660538827078, 218, 51, 'PPL', 'P'),
(151850, 'Port Ivory', 40.6408309936523, 0.709316311585792, -74.1805572509766, -1.29469496499369, 218, 40, 'PPL', 'P'),
(28302, 'Port Jackson', 38.8636093139648, 0.678297941737421, -87.7783279418945, -1.5320208344814, 218, 18, 'PPL', 'P'),
(42664, 'Port Jackson (historical)', 30.6972198486328, 0.535767557567198, -91.3166732788086, -1.59377661068314, 218, 22, 'PPL', 'P'),
(151851, 'Port Jefferson', 40.9463882446289, 0.714649291668676, -73.0697174072266, -1.27530715225792, 218, 40, 'PPL', 'P'),
(157222, 'Port Jefferson', 40.3286094665527, 0.703867017942299, -84.0944366455078, -1.46772480207389, 218, 41, 'PPL', 'P'),
(151852, 'Port Jefferson Station', 40.9252815246582, 0.714280909910891, -73.0477828979492, -1.27492432285122, 218, 40, 'PPL', 'P'),
(166137, 'Port Jenkins', 41.0825004577637, 0.717024897940054, -75.7713928222656, -1.32246028357053, 218, 45, 'PPL', 'P'),
(151853, 'Port Jervis', 41.375, 0.722129978012654, -74.6930618286133, -1.303639857305, 218, 40, 'PPL', 'P'),
(146092, 'Port Johnson', 40.6522216796875, 0.709515116561167, -74.1166687011719, -1.29357989944528, 218, 37, 'PPL', 'P'),
(208475, 'Port Kelley', 46.0255584716797, 0.80329753539998, -118.936943054199, -2.07584125855278, 218, 56, 'PPL', 'P'),
(151855, 'Port Kent', 44.5280609130859, 0.777161272461942, -73.4075012207031, -1.28120259196303, 218, 40, 'PPL', 'P'),
(193889, 'Port Kenyon', 40.5952796936035, 0.708521291421376, -124.278610229492, -2.16907093830734, 218, 6, 'PPL', 'P'),
(17707, 'Port La Belle', 26.7561092376709, 0.466982201220627, -81.4052810668945, -1.42079018312871, 218, 12, 'PPL', 'P'),
(17708, 'Port Laudania', 26.0597190856934, 0.454827900190155, -80.1311111450195, -1.39855172276211, 218, 12, 'PPL', 'P'),
(97179, 'Port Lavaca', 28.6147193908691, 0.499421067904933, -96.6258316040039, -1.68643890396746, 218, 51, 'PPL', 'P'),
(393, 'Port Leon', 30.1308307647705, 0.525882203206446, -84.1949996948242, -1.4694799583903, 218, 12, 'PPL', 'P'),
(151856, 'Port Leyden', 43.5830612182617, 0.760667916356918, -75.3455581665039, -1.3150280667584, 218, 40, 'PPL', 'P'),
(212104, 'Port Lions', 57.8675003051758, 1.00997841022414, -152.882217407227, -2.66829806150589, 218, 1, 'PPL', 'P'),
(17709, 'Port Lonesome', 28.273889541626, 0.493472464846564, -82.091667175293, -1.43276988066022, 218, 12, 'PPL', 'P'),
(117385, 'Port Louisa', 41.2391700744629, 0.719759298589293, -91.1311111450195, -1.59053794048149, 218, 16, 'PPL', 'P'),
(208476, 'Port Ludlow', 47.9255599975586, 0.836458817819483, -122.682220458984, -2.14120868066683, 218, 56, 'PPL', 'P'),
(208477, 'Port Madison', 47.7027816772461, 0.832570602627967, -122.523063659668, -2.13843087049182, 218, 56, 'PPL', 'P'),
(14438, 'Port Mahon', 39.1852798461914, 0.683912151631417, -75.4013900756836, -1.31600251740126, 218, 10, 'PPL', 'P'),
(97180, 'Port Mansfield', 26.5544395446777, 0.46346240107641, -97.4247207641602, -1.70038215017068, 218, 51, 'PPL', 'P'),
(166138, 'Port Matilda', 40.7994384765625, 0.712084534380875, -78.054443359375, -1.36230703243252, 218, 45, 'PPL', 'P'),
(17710, 'Port Mayaca', 26.9861106872559, 0.470996483800245, -80.6063919067383, -1.40684693692549, 218, 12, 'PPL', 'P'),
(146093, 'Port Mercer', 40.3041687011719, 0.703440446114696, -74.6852798461914, -1.3035040360894, 218, 37, 'PPL', 'P'),
(123474, 'Port Mitchell', 41.3619384765625, 0.721902011423343, -85.4388885498047, -1.49118991443858, 218, 19, 'PPL', 'P'),
(212105, 'Port Moller', 55.9886093139648, 0.97718557614145, -160.576934814453, -2.80259621527252, 218, 1, 'PPL', 'P'),
(146094, 'Port Monmouth', 40.4300003051758, 0.70563662190763, -74.0988922119141, -1.29326964117828, 218, 37, 'PPL', 'P'),
(97181, 'Port Morris', 29.0963897705078, 0.507827801938959, -95.20361328125, -1.66161651155321, 218, 51, 'PPL', 'P'),
(146095, 'Port Morris', 40.9049987792969, 0.713926909222992, -74.6852798461914, -1.3035040360894, 218, 37, 'PPL', 'P'),
(151857, 'Port Morris', 40.8013916015625, 0.712118622842828, -73.9100036621094, -1.28997291406488, 218, 40, 'PPL', 'P'),
(146096, 'Port Murray', 40.7855606079102, 0.711842319879732, -74.916389465332, -1.30753765987644, 218, 37, 'PPL', 'P'),
(97182, 'Port Neches', 29.9911098480225, 0.523443613175288, -93.9583282470703, -1.63988218758097, 218, 51, 'PPL', 'P'),
(42665, 'Port Nickel', 29.8575000762939, 0.521111682745787, -89.9625015258789, -1.57014185495701, 218, 22, 'PPL', 'P'),
(212106, 'Port Nikiski', 60.6833305358887, 1.05912391892727, -151.378890991211, -2.64206006581421, 218, 1, 'PPL', 'P'),
(105401, 'Port Norfolk', 36.848331451416, 0.64312470769339, -76.335563659668, -1.33230692222694, 218, 53, 'PPL', 'P'),
(71304, 'Port Norris', 39.2458305358887, 0.684968960530988, -75.0355606079102, -1.30961758868779, 218, 37, 'PPL', 'P'),
(212107, 'Port O''Brien', 57.7319412231445, 1.00761245791171, -153.316665649414, -2.67588061376157, 218, 1, 'PPL', 'P'),
(97183, 'Port O''Connor', 28.4480590820313, 0.496512296783321, -96.4055633544922, -1.68259449777588, 218, 51, 'PPL', 'P'),
(42671, 'Port of Iberia', 29.9419403076172, 0.522585442803524, -91.841667175293, -1.60293948272966, 218, 22, 'PPL', 'P'),
(208478, 'Port Of Kennewick', 46.2130584716797, 0.806570027747469, -119.099998474121, -2.07868711249364, 218, 56, 'PPL', 'P'),
(17721, 'Port of Miami', 25.774169921875, 0.449844127105208, -80.1711120605469, -1.39924987044188, 218, 12, 'PPL', 'P'),
(37767, 'Port Oliver Ford', 36.8938903808594, 0.643919861015861, -86.1380615234375, -1.50339278486943, 218, 21, 'PPL', 'P'),
(132701, 'Port Oneida', 44.9477806091309, 0.784486763093396, -85.945556640625, -1.50003294083818, 218, 27, 'PPL', 'P'),
(151858, 'Port Ontario', 43.5666694641113, 0.760381826276816, -76.1883316040039, -1.32973723809112, 218, 40, 'PPL', 'P'),
(17711, 'Port Orange', 29.1380596160889, 0.508555077943146, -80.9958267211914, -1.41364385665959, 218, 12, 'PPL', 'P'),
(151859, 'Port Orange', 41.4866714477539, 0.724079012456428, -74.5755615234375, -1.30158909010758, 218, 40, 'PPL', 'P'),
(208479, 'Port Orchard', 47.5405616760254, 0.829739329494077, -122.63500213623, -2.1403845654675, 218, 56, 'PPL', 'P'),
(184235, 'Port Orford', 34.4702796936035, 0.601619874736724, -120.227500915527, -2.09836574242045, 218, 6, 'PPL', 'P'),
(201424, 'Port Orford', 42.7458305358887, 0.74605548435079, -124.496109008789, -2.17286700812514, 218, 43, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(14439, 'Port Penn', 39.5166702270508, 0.689696004886851, -75.5769424438477, -1.31906648423539, 218, 10, 'PPL', 'P'),
(166140, 'Port Perry', 40.3908309936523, 0.704952988455806, -79.8497161865234, -1.39364045423784, 218, 45, 'PPL', 'P'),
(193292, 'Port Protection', 56.3172187805176, 0.982920893286018, -133.598052978516, -2.33172589872891, 218, 1, 'PPL', 'P'),
(166141, 'Port Providence', 40.128059387207, 0.700366758742581, -75.4930572509766, -1.31760241142612, 218, 45, 'PPL', 'P'),
(146097, 'Port Reading', 40.5652809143066, 0.707997713951067, -74.2608337402344, -1.29609605404319, 218, 37, 'PPL', 'P'),
(50539, 'Port Republic', 38.5008316040039, 0.671966276245758, -76.5297164916992, -1.33569552839796, 218, 25, 'PPL', 'P'),
(71305, 'Port Republic', 39.5205612182617, 0.689763915494648, -74.4861068725586, -1.30002781191852, 218, 37, 'PPL', 'P'),
(105402, 'Port Republic', 38.2961082458496, 0.668393179590226, -78.8108291625977, -1.37550845511409, 218, 53, 'PPL', 'P'),
(17712, 'Port Richey', 28.271390914917, 0.493428855583714, -82.7197189331055, -1.44373145170698, 218, 12, 'PPL', 'P'),
(78977, 'Port Richmond', 39.9766693115234, 0.697724503467059, -75.1005630493164, -1.31075209531216, 218, 45, 'PPL', 'P'),
(105403, 'Port Richmond', 37.5516700744629, 0.655400282422002, -76.8111114501953, -1.34060679692222, 218, 53, 'PPL', 'P'),
(151860, 'Port Richmond', 40.6330604553223, 0.70918069010728, -74.1369400024414, -1.2939337003961, 218, 40, 'PPL', 'P'),
(5184, 'Port Royal', 32.6413917541504, 0.569699758543252, -87.7458267211914, -1.53145358116921, 218, 2, 'PPL', 'P'),
(17713, 'Port Royal', 26.110559463501, 0.455715232175856, -81.793327331543, -1.42756286809689, 218, 12, 'PPL', 'P'),
(24082, 'Port Royal', 31.9036102294922, 0.556823041777582, -81.2958297729492, -1.4188798976788, 218, 13, 'PPL', 'P'),
(37768, 'Port Royal', 38.5552787780762, 0.672916558701725, -85.0802764892578, -1.48493095324467, 218, 21, 'PPL', 'P'),
(83118, 'Port Royal', 32.3788909912109, 0.565118255940961, -80.6927795410156, -1.40835468557664, 218, 48, 'PPL', 'P'),
(90083, 'Port Royal', 36.5536117553711, 0.63798087862693, -87.1419372558594, -1.52091372168106, 218, 50, 'PPL', 'P'),
(105404, 'Port Royal', 38.1716690063477, 0.666221305142239, -77.1913909912109, -1.34724392699092, 218, 53, 'PPL', 'P'),
(166143, 'Port Royal', 40.1686096191406, 0.701074493802269, -79.7677764892578, -1.39221033673247, 218, 45, 'PPL', 'P'),
(105405, 'Port Royal Cross Roads', 38.163330078125, 0.666075763388666, -77.1999969482422, -1.3473941292764, 218, 53, 'PPL', 'P'),
(83119, 'Port Royal Landing', 32.3963890075684, 0.565423653938966, -80.6811065673828, -1.40815095375325, 218, 48, 'PPL', 'P'),
(83120, 'Port Royal Plantation', 32.2205581665039, 0.56235482683584, -80.6725006103516, -1.40800075146777, 218, 48, 'PPL', 'P'),
(212108, 'Port Safety', 64.4516677856445, 1.12489381126106, -164.825561523438, -2.87674874003247, 218, 1, 'PPL', 'P'),
(17714, 'Port Saint Joe', 29.8116703033447, 0.520311802312382, -85.3030624389648, -1.48881930159424, 218, 12, 'PPL', 'P'),
(17715, 'Port Saint John', 28.4766693115234, 0.497011639487711, -80.7888870239258, -1.41003207758923, 218, 12, 'PPL', 'P'),
(17716, 'Port Saint Lucie', 27.2936096191406, 0.476363352607999, -80.3505630493164, -1.40238188104187, 218, 12, 'PPL', 'P'),
(17717, 'Port Salerno', 27.1438903808594, 0.473750258946414, -80.2008285522461, -1.39976852106417, 218, 12, 'PPL', 'P'),
(212109, 'Port San Juan', 60.0508308410645, 1.04808471673473, -148.067504882813, -2.58426547541786, 218, 1, 'PPL', 'P'),
(184236, 'Port San Luis', 35.1749992370605, 0.6139195510732, -120.754173278809, -2.10755790923897, 218, 6, 'PPL', 'P'),
(132702, 'Port Sanilac', 43.4308280944824, 0.758010947116373, -82.5425033569336, -1.44063845641696, 218, 27, 'PPL', 'P'),
(83121, 'Port Santorini', 34.7097206115723, 0.605798907119276, -82.9719390869141, -1.44813352383083, 218, 48, 'PPL', 'P'),
(90084, 'Port Serena', 35.1838912963867, 0.614074746785724, -85.1711120605469, -1.48651633304159, 218, 50, 'PPL', 'P'),
(17718, 'Port Sewall', 27.1858291625977, 0.474482228772022, -80.1897201538086, -1.39957464293681, 218, 12, 'PPL', 'P'),
(132703, 'Port Sheldon', 42.8994407653809, 0.748736488620172, -86.1997222900391, -1.50446896826593, 218, 27, 'PPL', 'P'),
(208480, 'Port Stanley', 48.5405616760254, 0.84719262201402, -122.870559692383, -2.14449582040031, 218, 56, 'PPL', 'P'),
(97184, 'Port Sullivan', 30.8658294677734, 0.538710350571735, -96.6952819824219, -1.68765104173761, 218, 51, 'PPL', 'P'),
(97185, 'Port Sullivan (historical)', 30.8832092285156, 0.539013684619896, -96.7029266357422, -1.68778446610822, 218, 51, 'PPL', 'P'),
(42666, 'Port Sulphur', 29.4802799224854, 0.514527949056948, -89.6938934326172, -1.56545375933209, 218, 22, 'PPL', 'P'),
(17719, 'Port Sutton', 27.9063892364502, 0.487058374519162, -82.4208297729492, -1.43851485176373, 218, 12, 'PPL', 'P'),
(17720, 'Port Tampa', 27.8633308410645, 0.486306863749056, -82.5269393920898, -1.44036681398578, 218, 12, 'PPL', 'P'),
(50540, 'Port Tobacco', 38.5136108398438, 0.672189315987052, -77.0186080932617, -1.34422829653057, 218, 25, 'PPL', 'P'),
(50542, 'Port Tobacco Hills', 38.5027809143066, 0.672000298128684, -77.0530624389648, -1.34482963830471, 218, 25, 'PPL', 'P'),
(50541, 'Port Tobacco Lakes', 38.5011100769043, 0.671971136514747, -77.0344390869141, -1.34450459949366, 218, 25, 'PPL', 'P'),
(50543, 'Port Tobacco Riviera', 38.5108299255371, 0.672140779876185, -77.0299987792969, -1.34442710150594, 218, 25, 'PPL', 'P'),
(208481, 'Port Townsend', 48.1172218322754, 0.839803947885704, -122.759170532227, -2.14255171280455, 218, 56, 'PPL', 'P'),
(166153, 'Port Trevorton', 40.707218170166, 0.710474986397058, -76.8663864135742, -1.34157152702711, 218, 45, 'PPL', 'P'),
(67943, 'Port Trinitie', 36.1997184753418, 0.631804275689736, -75.7647171020508, -1.32234377027284, 218, 33, 'PPL', 'P'),
(73956, 'Port Union', 39.3327789306641, 0.686486496299142, -84.4633331298828, -1.47416326032526, 218, 41, 'PPL', 'P'),
(42667, 'Port Union (historical)', 32.6644401550293, 0.570102029025908, -92.14111328125, -1.60816580321089, 218, 22, 'PPL', 'P'),
(42668, 'Port Vincent', 30.333610534668, 0.529421377847594, -90.8494415283203, -1.58562187826726, 218, 22, 'PPL', 'P'),
(166146, 'Port Vue', 40.3358306884766, 0.703993052040887, -79.870002746582, -1.39399452150477, 218, 45, 'PPL', 'P'),
(212110, 'Port Wakefield', 58.0491714477539, 1.01314916981799, -153.052505493164, -2.67127014928242, 218, 1, 'PPL', 'P'),
(146098, 'Port Warren', 40.6947212219238, 0.710256873503781, -75.1408309936523, -1.31145490352384, 218, 37, 'PPL', 'P'),
(151861, 'Port Washington', 40.8255615234375, 0.712540467559497, -73.6986083984375, -1.28628337069068, 218, 40, 'PPL', 'P'),
(157223, 'Port Washington', 40.3280601501465, 0.703857430562375, -81.5208282470703, -1.42280686186417, 218, 41, 'PPL', 'P'),
(175914, 'Port Washington', 43.3872184753418, 0.757249815676829, -87.8755569458008, -1.533717800728, 218, 57, 'PPL', 'P'),
(151862, 'Port Washington North', 40.8447189331055, 0.712874827434356, -73.7022171020508, -1.28634635445046, 218, 40, 'PPL', 'P'),
(184237, 'Port Watsonvile', 36.8941688537598, 0.64392472128485, -121.834716796875, -2.12641695134031, 218, 6, 'PPL', 'P'),
(184238, 'Port Watsonville (historical)', 36.8747215270996, 0.64358530140392, -121.823890686035, -2.12622800006097, 218, 6, 'PPL', 'P'),
(24083, 'Port Wentworth', 32.1488914489746, 0.561104006650858, -81.163330078125, -1.41656734174623, 218, 13, 'PPL', 'P'),
(24084, 'Port Wentworth Junction', 32.1436080932617, 0.561011794698114, -81.1922225952148, -1.41707161129863, 218, 13, 'PPL', 'P'),
(73957, 'Port William', 39.5519409179688, 0.690311594572823, -83.7863922119141, -1.46234841246523, 218, 41, 'PPL', 'P'),
(212111, 'Port William', 58.4922218322754, 1.02088185778012, -152.582778930664, -2.66307187418272, 218, 1, 'PPL', 'P'),
(33668, 'Port Williams', 39.4563903808594, 0.688643923098216, -95.0325012207031, -1.6586300427068, 218, 20, 'PPL', 'P'),
(208482, 'Port Williams', 48.0969390869141, 0.839449947197806, -123.044441223145, -2.14753062562051, 218, 56, 'PPL', 'P'),
(175917, 'Port Wing', 46.7747192382813, 0.816372857403942, -91.3863906860352, -1.59499340898519, 218, 57, 'PPL', 'P'),
(146099, 'Port-au-Peck', 40.314998626709, 0.703629463973064, -74.0083312988281, -1.29168905507132, 218, 37, 'PPL', 'P'),
(105407, 'Porta Bello', 37.3011093139648, 0.65102717217501, -76.6474990844727, -1.33775122244339, 218, 53, 'PPL', 'P'),
(42670, 'Portage', 30.4122200012207, 0.530793371862175, -91.8613891601563, -1.60328369630056, 218, 22, 'PPL', 'P'),
(121093, 'Portage', 42.3827781677246, 0.739719025169164, -90.4563903808594, -1.57876184161532, 218, 18, 'PPL', 'P'),
(123475, 'Portage', 41.5758285522461, 0.725635097481362, -87.1761093139648, -1.52151013660718, 218, 19, 'PPL', 'P'),
(128583, 'Portage', 46.7630615234375, 0.81616939189666, -68.4763870239258, -1.19513841343743, 218, 26, 'PPL', 'P'),
(132705, 'Portage', 42.2011108398438, 0.736548332154343, -85.5800018310547, -1.49365280581468, 218, 27, 'PPL', 'P'),
(157224, 'Portage', 41.3266716003418, 0.721286488316399, -83.6508331298828, -1.45998246015281, 218, 41, 'PPL', 'P'),
(166148, 'Portage', 40.3886108398438, 0.704914239461946, -78.6725006103516, -1.37309416642788, 218, 45, 'PPL', 'P'),
(175919, 'Portage', 43.5391693115234, 0.759901858069357, -89.4625015258789, -1.56141520869704, 218, 57, 'PPL', 'P'),
(197286, 'Portage', 47.6527786254883, 0.831697884738748, -111.123893737793, -1.9394778233608, 218, 31, 'PPL', 'P'),
(205416, 'Portage', 41.9755592346191, 0.732611714010015, -112.206390380859, -1.95837095392409, 218, 52, 'PPL', 'P'),
(208484, 'Portage', 48.584171295166, 0.847953753453565, -121.389167785645, -2.11864065411533, 218, 56, 'PPL', 'P'),
(157225, 'Portage Center', 41.1241683959961, 0.717752140654727, -83.7272186279297, -1.4613156385945, 218, 41, 'PPL', 'P'),
(212113, 'Portage Creek', 58.9061088562012, 1.0281055490789, -157.717498779297, -2.75268964170887, 218, 1, 'PPL', 'P'),
(56995, 'Portage Des Sioux', 38.9249992370605, 0.679369398022987, -90.341667175293, -1.57675954394975, 218, 29, 'PPL', 'P'),
(132706, 'Portage Entry', 46.9822196960449, 0.819994423591313, -88.440559387207, -1.54357895361234, 218, 27, 'PPL', 'P'),
(157227, 'Portage Lakes', 41.0072212219238, 0.715711027416263, -81.5272216796875, -1.42291844831385, 218, 41, 'PPL', 'P'),
(56998, 'Portageville', 36.4252815246582, 0.635741093571146, -89.6994400024414, -1.56555056523771, 218, 29, 'PPL', 'P'),
(151864, 'Portageville', 42.5697212219238, 0.742981796978675, -78.040283203125, -1.36205989108336, 218, 40, 'PPL', 'P'),
(189267, 'Portair', 34.4052810668945, 0.600485434691377, -103.301391601563, -1.80294940533928, 218, 38, 'PPL', 'P'),
(24085, 'Portal', 32.5380592346191, 0.56789626585305, -81.932502746582, -1.42999193732715, 218, 13, 'PPL', 'P'),
(142728, 'Portal', 41.1763916015625, 0.718663607537807, -96.0805587768555, -1.67692209781206, 218, 35, 'PPL', 'P'),
(178911, 'Portal', 31.913610458374, 0.556997578697523, -109.140830993652, -1.90486684920191, 218, 5, 'PPL', 'P'),
(197287, 'Portal', 46.3375015258789, 0.808741968774483, -112.117500305176, -1.95681952943106, 218, 31, 'PPL', 'P'),
(198760, 'Portal', 48.9958305358887, 0.855138562600435, -102.549171447754, -1.78982068695547, 218, 34, 'PPL', 'P'),
(193888, 'Portal Inn', 40.7358283996582, 0.710974329101448, -122.318328857422, -2.13485757409921, 218, 6, 'PPL', 'P'),
(189268, 'Portales', 34.1861114501953, 0.596660203259642, -103.333892822266, -1.80351665865147, 218, 38, 'PPL', 'P'),
(5186, 'Porter', 33.6230583190918, 0.586833072258222, -87.0547180175781, -1.51939145880197, 218, 2, 'PPL', 'P'),
(14440, 'Porter', 39.6002807617188, 0.69115528400616, -75.6902770996094, -1.32104454713505, 218, 10, 'PPL', 'P'),
(24086, 'Porter', 32.4127807617188, 0.565709744019068, -83.3997192382813, -1.45559969594687, 218, 13, 'PPL', 'P'),
(37769, 'Porter', 38.3819389343262, 0.669891207703395, -84.6052780151367, -1.47664066592931, 218, 21, 'PPL', 'P'),
(56999, 'Porter', 36.980281829834, 0.645427676246036, -89.4775009155273, -1.56167699743219, 218, 29, 'PPL', 'P'),
(67945, 'Porter', 35.2691688537598, 0.615563120939942, -80.1691665649414, -1.39921591513798, 218, 33, 'PPL', 'P'),
(73958, 'Porter', 38.9283294677734, 0.679427521513778, -82.2825012207031, -1.43610056307752, 218, 41, 'PPL', 'P'),
(76982, 'Porter', 35.8708305358887, 0.626064098276179, -95.522216796875, -1.6671771919093, 218, 42, 'PPL', 'P'),
(90085, 'Porter', 35.9841690063477, 0.628042227754863, -87.2774963378906, -1.52327967399348, 218, 50, 'PPL', 'P'),
(97186, 'Porter', 30.1022205352783, 0.525382860502057, -95.2294387817383, -1.66206725156771, 218, 51, 'PPL', 'P'),
(110968, 'Porter', 38.4833297729492, 0.671660811668726, -81.2561111450195, -1.41818667684705, 218, 58, 'PPL', 'P'),
(123478, 'Porter', 41.6155586242676, 0.726328518050191, -87.0741729736328, -1.51973101184095, 218, 19, 'PPL', 'P'),
(128585, 'Porter', 43.7958297729492, 0.764381428180924, -70.9330596923828, -1.23801544014576, 218, 26, 'PPL', 'P'),
(132710, 'Porter', 43.5186080932617, 0.759542997112469, -84.4663925170898, -1.47421665670512, 218, 27, 'PPL', 'P'),
(137563, 'Porter', 44.6363906860352, 0.779051983677844, -96.165283203125, -1.67840081800733, 218, 28, 'PPL', 'P'),
(151865, 'Porter', 43.2936096191406, 0.755616032927092, -73.2780609130859, -1.27894343241031, 218, 40, 'PPL', 'P'),
(166154, 'Porter', 40.9338912963867, 0.714431178775398, -79.1688919067383, -1.38175782892807, 218, 45, 'PPL', 'P'),
(184240, 'Porter', 38.3941688537598, 0.670104660064765, -120.424171447754, -2.10179829074945, 218, 6, 'PPL', 'P'),
(189270, 'Porter', 35.8188896179199, 0.625157558241116, -106.786392211914, -1.86377414042393, 218, 38, 'PPL', 'P'),
(208485, 'Porter', 46.9391708374023, 0.819243079268775, -123.309440612793, -2.15215573748565, 218, 56, 'PPL', 'P'),
(151866, 'Porter Center', 43.249439239502, 0.754845114370541, -78.9577789306641, -1.3780732124019, 218, 40, 'PPL', 'P'),
(151867, 'Porter Corner', 42.5475006103516, 0.742593974144932, -77.0350036621094, -1.3445144531897, 218, 40, 'PPL', 'P'),
(151868, 'Porter Corners', 43.1483306884766, 0.753080437253228, -73.8869400024414, -1.28957037726611, 218, 40, 'PPL', 'P'),
(90087, 'Porter Court', 36.3224983215332, 0.633947188260868, -88.3244400024414, -1.54155228802279, 218, 50, 'PPL', 'P'),
(201425, 'Porter Creek', 43.1111106872559, 0.75243082568433, -123.52082824707, -2.15584514770179, 218, 43, 'PPL', 'P'),
(123482, 'Porter Crossroads', 41.399169921875, 0.722551822729322, -87.1616668701172, -1.52125806841001, 218, 19, 'PPL', 'P'),
(90088, 'Porter Gap', 35.9152793884277, 0.626839877101719, -89.4972229003906, -1.56202121100309, 218, 50, 'PPL', 'P'),
(97187, 'Porter Heights', 30.1516704559326, 0.526245924432324, -95.3216705322266, -1.66367699928861, 218, 51, 'PPL', 'P'),
(76983, 'Porter Hill', 34.7825012207031, 0.607069168380216, -98.3863906860352, -1.7171664566248, 218, 42, 'PPL', 'P'),
(37770, 'Porter Junction', 37.4719390869141, 0.654008714173408, -82.8294372558594, -1.4456463976888, 218, 21, 'PPL', 'P'),
(67946, 'Porter Junction', 35.526668548584, 0.620057338437506, -77.0852813720703, -1.34539196476888, 218, 33, 'PPL', 'P'),
(128586, 'Porter Landing', 43.8444404602051, 0.765229844725197, -70.0999984741211, -1.22347577901641, 218, 26, 'PPL', 'P'),
(50544, 'Porter Mill Estates', 38.4180603027344, 0.670521644512444, -75.7375030517578, -1.32186879549243, 218, 25, 'PPL', 'P'),
(42672, 'Porter Place', 32.0188903808594, 0.558835059981137, -93.709716796875, -1.6355430992169, 218, 22, 'PPL', 'P'),
(24087, 'Porter Springs', 34.628059387207, 0.604373649882893, -83.9483337402344, -1.46517482533014, 218, 13, 'PPL', 'P'),
(97188, 'Porter Springs', 31.2705593109131, 0.545774218915603, -95.60888671875, -1.66868986740847, 218, 51, 'PPL', 'P'),
(14441, 'Porter Square', 39.5900001525879, 0.690975853527716, -75.7233276367188, -1.32162138782716, 218, 10, 'PPL', 'P'),
(73960, 'Porterbrook', 38.8283309936523, 0.677682218893395, -82.283332824707, -1.43611507730546, 218, 41, 'PPL', 'P'),
(24088, 'Porterdale', 33.5750007629395, 0.585994309672902, -83.8938903808594, -1.4642246094532, 218, 13, 'PPL', 'P'),
(24089, 'Porterfield', 34.1080589294434, 0.595297929783039, -83.1636123657227, -1.45147885363413, 218, 13, 'PPL', 'P'),
(73961, 'Porterfield', 39.2833290100098, 0.685623432368875, -81.6558303833008, -1.42516309363862, 218, 41, 'PPL', 'P'),
(90089, 'Porterfield', 35.8797187805176, 0.626219227409676, -86.1616668701172, -1.50380477589006, 218, 50, 'PPL', 'P'),
(121095, 'Porterfield', 41.084171295166, 0.71705405955399, -89.1619415283203, -1.55616944713985, 218, 18, 'PPL', 'P'),
(128588, 'Porterfield', 43.8761100769043, 0.765782583809442, -70.913330078125, -1.23767109341681, 218, 26, 'PPL', 'P'),
(175923, 'Porterfield', 45.1544418334961, 0.788093681894772, -87.7944412231445, -1.53230206429251, 218, 57, 'PPL', 'P'),
(24090, 'Porters', 33.6961097717285, 0.588108060630097, -82.6888885498047, -1.44319336000873, 218, 13, 'PPL', 'P'),
(90091, 'Porters', 35.5238914489746, 0.620008868905666, -87.1563873291016, -1.52116592303629, 218, 50, 'PPL', 'P'),
(105410, 'Porters', 38.1936111450195, 0.666604267706992, -77.7916717529297, -1.35772080271929, 218, 53, 'PPL', 'P'),
(175925, 'Porters', 42.5286102294922, 0.74226427480198, -88.9591674804688, -1.55263037236725, 218, 57, 'PPL', 'P'),
(50552, 'Porters (historical)', 39.5374984741211, 0.690059526375647, -78.8805618286133, -1.37672551973226, 218, 25, 'PPL', 'P'),
(90090, 'Porters (historical)', 36.2991714477539, 0.633540057509222, -88.2413864135742, -1.54010272944146, 218, 50, 'PPL', 'P'),
(61405, 'Porters Chapel', 32.2936096191406, 0.563629815207716, -90.8613891601563, -1.58583040378061, 218, 30, 'PPL', 'P'),
(197288, 'Porters Corner', 46.2519416809082, 0.807248667772249, -113.331108093262, -1.97800098116101, 218, 31, 'PPL', 'P'),
(157232, 'Porters Corners', 40.9877815246582, 0.715371740693387, -80.6338882446289, -1.40732683855393, 218, 41, 'PPL', 'P'),
(166161, 'Porters Corners', 41.5050010681152, 0.724398924682374, -80.2577819824219, -1.40076254594104, 218, 45, 'PPL', 'P'),
(90092, 'Porters Creek', 35.1305618286133, 0.613143971984742, -88.8566665649414, -1.55084139390499, 218, 50, 'PPL', 'P'),
(105409, 'Porters Crossroads', 36.8644409179688, 0.643405870925476, -80.9824981689453, -1.41341122953837, 218, 53, 'PPL', 'P'),
(42673, 'Porters Curve', 30.958890914917, 0.540334579231061, -90.3169403076172, -1.5763279786951, 218, 22, 'PPL', 'P'),
(110969, 'Porters Falls', 39.579719543457, 0.690796423049272, -80.7763900756836, -1.40981396469595, 218, 58, 'PPL', 'P'),
(90093, 'Porters Grove', 35.8325004577637, 0.625395112210351, -89.0022201538086, -1.55338178326881, 218, 50, 'PPL', 'P'),
(166162, 'Porters Mill', 40.1897201538086, 0.701442942139082, -75.6469421386719, -1.32028820938547, 218, 45, 'PPL', 'P'),
(50545, 'Porters Park', 39.2550010681152, 0.685129016512502, -76.4063873291016, -1.3335430284469, 218, 25, 'PPL', 'P'),
(50546, 'Porters Pride', 38.8147201538086, 0.67744466492416, -76.2458267211914, -1.33074071718986, 218, 25, 'PPL', 'P'),
(24094, 'Porters Ridge', 33.3527793884277, 0.582115815019365, -84.4686126708984, -1.47425540569898, 218, 13, 'PPL', 'P'),
(42675, 'Porters River Landing', 30.3619403839111, 0.52991582699348, -89.7319412231445, -1.5661178185499, 218, 22, 'PPL', 'P'),
(78978, 'Porters Sideling', 39.8252792358398, 0.695082248191537, -76.8949966430664, -1.3420708697315, 218, 45, 'PPL', 'P'),
(11341, 'Porters Store (historical)', 35.8591690063477, 0.62586056618987, -94.0041732788086, -1.64068233433048, 218, 4, 'PPL', 'P'),
(37771, 'Portersburg', 37.1705589294434, 0.648748638125365, -83.9258270263672, -1.46478200906935, 218, 21, 'PPL', 'P'),
(50547, 'Porterstown', 39.4658317565918, 0.688808706190664, -77.7133331298828, -1.35635353581565, 218, 25, 'PPL', 'P'),
(5187, 'Portersville', 34.3211097717285, 0.599016368455062, -85.8208312988281, -1.49785607296315, 218, 2, 'PPL', 'P'),
(73965, 'Portersville', 39.6747207641602, 0.692454507143955, -82.0311126708984, -1.43171300518162, 218, 41, 'PPL', 'P'),
(110974, 'Portersville', 38.3352813720703, 0.669076879621076, -82.1305618286133, -1.43344872042208, 218, 58, 'PPL', 'P'),
(112321, 'Portersville', 38.499439239502, 0.671941974900811, -86.9783325195313, -1.51805828036028, 218, 19, 'PPL', 'P'),
(166164, 'Portersville', 40.922779083252, 0.714237234069013, -80.1425018310547, -1.39875052773749, 218, 45, 'PPL', 'P'),
(61406, 'Porterton', 34.2880592346191, 0.598439527762951, -89.4513931274414, -1.56122133056968, 218, 30, 'PPL', 'P'),
(71307, 'Portertown', 39.6136093139648, 0.691387911127379, -75.3533325195313, -1.31516375481593, 218, 37, 'PPL', 'P'),
(28307, 'Porterville', 39.0897216796875, 0.682244346998755, -87.8013916015625, -1.53242337128016, 218, 18, 'PPL', 'P'),
(33669, 'Porterville', 37.7180595397949, 0.658304326432679, -95.0686111450195, -1.65926027977877, 218, 20, 'PPL', 'P'),
(42674, 'Porterville', 32.9458312988281, 0.575013230971151, -93.4577789306641, -1.63114595394107, 218, 22, 'PPL', 'P'),
(61407, 'Porterville', 32.6877784729004, 0.570509359514636, -88.4722213745117, -1.54413155953853, 218, 30, 'PPL', 'P'),
(151870, 'Porterville', 42.7902793884277, 0.74683126317633, -78.5538864135742, -1.37102395815451, 218, 40, 'PPL', 'P'),
(184246, 'Porterville', 36.0652809143066, 0.629457897611322, -119.015830993652, -2.07721811283635, 218, 6, 'PPL', 'P'),
(205417, 'Porterville', 40.9813919067383, 0.71526022082274, -111.67749786377, -1.94914003811171, 218, 52, 'PPL', 'P'),
(201426, 'Porterville (historical)', 44.7958297729492, 0.781834720700868, -118.394172668457, -2.06636812823926, 218, 43, 'PPL', 'P'),
(110970, 'Porterwood', 39.0697212219238, 0.681895273158873, -79.6983337402344, -1.39099833212038, 218, 58, 'PPL', 'P'),
(184241, 'Portex (historical)', 36.1455612182617, 0.63085905323984, -119.026107788086, -2.07739747673576, 218, 6, 'PPL', 'P'),
(195489, 'Porthill', 48.9983291625977, 0.855182171863285, -116.496940612793, -2.03325518219354, 218, 17, 'PPL', 'P'),
(11342, 'Portia', 36.0863914489746, 0.629826345948134, -91.0672225952148, -1.58942287493307, 218, 4, 'PPL', 'P'),
(57001, 'Portia', 37.9083290100098, 0.661625155153953, -94.0747222900391, -1.64191364686048, 218, 29, 'PPL', 'P'),
(184242, 'Portico Mobile Home and Garden Park', 35.0969390869141, 0.612557144438543, -120.600280761719, -2.10487197812157, 218, 6, 'PPL', 'P'),
(33670, 'Portis', 39.5636100769043, 0.690515259817187, -98.6930618286133, -1.72251887778364, 218, 20, 'PPL', 'P'),
(5188, 'Portland', 32.1544418334961, 0.561200879135509, -87.1686096191406, -1.5213792422396, 218, 2, 'PPL', 'P'),
(11343, 'Portland', 33.2377815246582, 0.580108723663826, -91.5113906860352, -1.59717507055019, 218, 4, 'PPL', 'P'),
(17723, 'Portland', 30.5122203826904, 0.532538707772072, -86.1958312988281, -1.50440105765813, 218, 12, 'PPL', 'P'),
(24091, 'Portland', 34.0572204589844, 0.594410631086852, -85.0363922119141, -1.48416502811516, 218, 13, 'PPL', 'P'),
(33671, 'Portland', 37.0777816772461, 0.64712936960357, -97.3119430541992, -1.698413807809, 218, 20, 'PPL', 'P'),
(37774, 'Portland', 38.7480583190918, 0.676281196422932, -84.4477767944336, -1.47389175105213, 218, 21, 'PPL', 'P'),
(57002, 'Portland', 38.7108306884766, 0.675631451695979, -91.7174987792969, -1.60077233539261, 218, 29, 'PPL', 'P'),
(73962, 'Portland', 39.0033302307129, 0.68073653176858, -81.7713928222656, -1.42718003869019, 218, 41, 'PPL', 'P'),
(90094, 'Portland', 36.5816688537598, 0.638470567372368, -86.5163879394531, -1.50999582647617, 218, 50, 'PPL', 'P'),
(97189, 'Portland', 27.8769397735596, 0.486544384428777, -97.3236083984375, -1.69861740647434, 218, 51, 'PPL', 'P'),
(113946, 'Portland', 41.5727806091309, 0.725581900838587, -72.64111328125, -1.26782659907199, 218, 8, 'PPL', 'P'),
(117388, 'Portland', 43.1286087036133, 0.752736223682335, -93.1233291625977, -1.62530870430578, 218, 16, 'PPL', 'P'),
(121096, 'Portland', 41.6624984741211, 0.727147772980527, -89.9800033569336, -1.57044731953404, 218, 18, 'PPL', 'P'),
(123481, 'Portland', 40.434440612793, 0.705714119895351, -84.977783203125, -1.48314210794046, 218, 19, 'PPL', 'P'),
(128589, 'Portland', 43.6613883972168, 0.762034983523483, -70.2558288574219, -1.22619553227966, 218, 26, 'PPL', 'P'),
(132714, 'Portland', 42.8691711425781, 0.748208184038928, -84.9030609130859, -1.48183795795465, 218, 27, 'PPL', 'P'),
(140730, 'Portland', 47.4983291625977, 0.82900223308337, -97.370002746582, -1.69942714060378, 218, 34, 'PPL', 'P'),
(151872, 'Portland', 42.5227813720703, 0.742162542048339, -76.5244369506836, -1.33560338302424, 218, 40, 'PPL', 'P'),
(175927, 'Portland', 43.7688903808594, 0.763911247090471, -90.8580627441406, -1.58577234686885, 218, 57, 'PPL', 'P'),
(177411, 'Portland', 40.9230613708496, 0.71424216091703, -75.0969390869141, -1.31068884523627, 218, 45, 'PPL', 'P'),
(187223, 'Portland', 38.0813903808594, 0.664645645883293, -107.700828552246, -1.87973406536261, 218, 7, 'PPL', 'P'),
(201427, 'Portland', 45.523609161377, 0.794536867257083, -122.675003051758, -2.14108271314727, 218, 43, 'PPL', 'P'),
(201428, 'Portland Heights', 45.5058288574219, 0.794226542411061, -122.701942443848, -2.14155289423772, 218, 43, 'PPL', 'P'),
(140731, 'Portland Junction', 47.5613899230957, 0.830102850982873, -97.3688888549805, -1.69940769952782, 218, 34, 'PPL', 'P'),
(50548, 'Portland Manor', 38.7980613708496, 0.67715391431215, -76.6361083984375, -1.33755241746801, 218, 25, 'PPL', 'P'),
(489, 'Portland Mills', 39.7780609130859, 0.694258132992212, -87.0091705322266, -1.51859650521658, 218, 19, 'PPL', 'P'),
(166166, 'Portland Mills', 41.378059387207, 0.72218337439251, -78.8344421386719, -1.37592057929278, 218, 45, 'PPL', 'P'),
(50549, 'Portland Station (historical)', 39.0936088562012, 0.682312191027525, -76.7655563354492, -1.33981171017878, 218, 25, 'PPL', 'P'),
(151874, 'Portlandville', 42.5302810668945, 0.742293436415916, -74.9674987792969, -1.30842968568356, 218, 40, 'PPL', 'P'),
(105411, 'Portlock', 36.7849998474121, 0.642019362682953, -76.2777786254883, -1.33129838312213, 218, 53, 'PPL', 'P'),
(210982, 'Portlock', 21.2786102294922, 0.371381808753185, -157.710830688477, -2.75257326156923, 218, 15, 'PPL', 'P'),
(195490, 'Portneuf', 42.7949981689453, 0.74691362143304, -112.362777709961, -1.96110042772531, 218, 17, 'PPL', 'P'),
(50550, 'Portneys Overlook', 38.1194381713867, 0.665309705101105, -76.3597183227539, -1.3327285006275, 218, 25, 'PPL', 'P'),
(110972, 'Porto Rico', 39.1819381713867, 0.683853828403544, -80.7630615234375, -1.40958133757473, 218, 58, 'PPL', 'P'),
(105412, 'Portobago', 38.148609161377, 0.665818834922501, -77.1291732788086, -1.34615802305644, 218, 53, 'PPL', 'P'),
(50551, 'Portobello', 38.1755599975586, 0.666289215750036, -76.45361328125, -1.33436727680428, 218, 25, 'PPL', 'P'),
(184243, 'Portola', 39.8105583190918, 0.694825319725371, -120.468063354492, -2.10256434903701, 218, 6, 'PPL', 'P'),
(184244, 'Portola Heights Mobile Home Park', 36.9199981689453, 0.644375527878373, -121.76277923584, -2.12516140404439, 218, 6, 'PPL', 'P'),
(184245, 'Portola Hills', 33.6791687011719, 0.587812383170071, -117.630279541016, -2.05303567803205, 218, 6, 'PPL', 'P'),
(184247, 'Portola Valley', 37.3841705322266, 0.652476863914394, -122.234169006348, -2.13338870759997, 218, 6, 'PPL', 'P'),
(37775, 'Portsmouth', 37.5313911437988, 0.65504634831313, -83.3152770996094, -1.45412590259962, 218, 21, 'PPL', 'P'),
(67950, 'Portsmouth', 35.0694389343262, 0.612077176231083, -76.0641708374023, -1.32757022391212, 218, 33, 'PPL', 'P'),
(73963, 'Portsmouth', 38.7316703796387, 0.675995172921857, -82.9977798461914, -1.44858453016143, 218, 41, 'PPL', 'P'),
(105413, 'Portsmouth', 36.8352813720703, 0.642896940841161, -76.2986068725586, -1.33166190461092, 218, 53, 'PPL', 'P'),
(117392, 'Portsmouth', 41.6502799987793, 0.726934520356239, -95.5183334350586, -1.66710941445956, 218, 16, 'PPL', 'P'),
(144338, 'Portsmouth', 43.0716705322266, 0.751742465121572, -70.7630615234375, -1.2350484123753, 218, 36, 'PPL', 'P'),
(169555, 'Portsmouth', 41.6022186279297, 0.726095691191891, -71.2508316040039, -1.2435616062739, 218, 47, 'PPL', 'P'),
(105414, 'Portsmouth Heights', 36.8208312988281, 0.642644739485931, -76.3691711425781, -1.33289348345703, 218, 53, 'PPL', 'P'),
(144339, 'Portsmouth Mobile Homes', 43.0205612182617, 0.75085043931445, -70.795280456543, -1.23561073883947, 218, 36, 'PPL', 'P'),
(169556, 'Portsmouth Park', 41.6183280944824, 0.726376854423976, -71.2413864135742, -1.24339675660242, 218, 47, 'PPL', 'P'),
(144340, 'Portsmouth Plains', 43.0569381713867, 0.751485336918325, -70.7802810668945, -1.23534895010431, 218, 36, 'PPL', 'P'),
(67948, 'Portsmouth Village', 35.0683288574219, 0.612057801734153, -76.0638885498047, -1.32756529706411, 218, 33, 'PPL', 'P'),
(14442, 'Portsville', 38.561939239502, 0.673032805683307, -75.6302795410156, -1.31999739219443, 218, 10, 'PPL', 'P'),
(184248, 'Portuguese Bend', 33.7397193908691, 0.588869192069642, -118.368606567383, -2.06592191559861, 218, 6, 'PPL', 'P'),
(28304, 'Portuguese Hill', 39.7558288574219, 0.693870110421387, -90.2152786254883, -1.57455364761883, 218, 18, 'PPL', 'P'),
(151875, 'Portville', 42.0386085510254, 0.733712132172436, -78.3411102294922, -1.36731031317245, 218, 40, 'PPL', 'P'),
(76985, 'Porum', 35.3561096191406, 0.617080523550042, -95.2652816772461, -1.66269282810777, 218, 42, 'PPL', 'P'),
(192071, 'Porvenir', 30.4184494018555, 0.530902095413678, -104.843887329102, -1.82987103448279, 218, 51, 'PPL', 'P'),
(24092, 'Posco (historical)', 34.0752792358398, 0.594725816201863, -85.0247192382813, -1.48396129629177, 218, 13, 'PPL', 'P'),
(121097, 'Posen', 41.6316719055176, 0.726609747861303, -87.6813888549805, -1.53032892824087, 218, 18, 'PPL', 'P'),
(132718, 'Posen', 45.2619400024414, 0.789969878882733, -83.6988906860352, -1.46082122273813, 218, 27, 'PPL', 'P'),
(11345, 'Posey', 34.9552803039551, 0.61008473226154, -91.1161117553711, -1.59027615174634, 218, 4, 'PPL', 'P'),
(28306, 'Posey', 38.5369415283203, 0.672596513317725, -89.3525009155273, -1.5594953358672, 218, 18, 'PPL', 'P'),
(110973, 'Posey', 37.8036117553711, 0.659797494276859, -81.4327774047852, -1.42127008475714, 218, 58, 'PPL', 'P'),
(184250, 'Posey', 35.8047218322754, 0.624910283733902, -118.681938171387, -2.07139058373904, 218, 6, 'PPL', 'P'),
(192072, 'Posey', 33.4824981689453, 0.584379834841068, -101.709716796875, -1.77516943937645, 218, 51, 'PPL', 'P'),
(5189, 'Posey (historical)', 34.9352798461914, 0.609735658421658, -87.4486083984375, -1.5262661428399, 218, 2, 'PPL', 'P'),
(76987, 'Posey (historical)', 35.9500007629395, 0.627445879407767, -95.9361114501953, -1.67440101636614, 218, 42, 'PPL', 'P'),
(11346, 'Posey Hollow', 34.6541709899902, 0.604829383324432, -94.0533294677734, -1.64154027167565, 218, 4, 'PPL', 'P'),
(5190, 'Posey Mill', 34.3241691589355, 0.599069764834918, -87.5819396972656, -1.52859321300041, 218, 2, 'PPL', 'P'),
(5192, 'Poseys Crossroads', 32.9366683959961, 0.574853308147691, -86.8330612182617, -1.51552281784447, 218, 2, 'PPL', 'P'),
(30884, 'Poseyville', 38.1699981689453, 0.666192143528302, -87.7830581665039, -1.53210339247519, 218, 19, 'PPL', 'P'),
(132720, 'Poseyville', 43.5397186279297, 0.759911445449281, -84.2494430541992, -1.47043017426724, 218, 27, 'PPL', 'P'),
(175930, 'Poskin', 45.4091682434082, 0.792539496439523, -91.9613876342773, -1.60502899892094, 218, 57, 'PPL', 'P'),
(184251, 'Poso Park', 35.8108291625977, 0.625016876756533, -118.633888244629, -2.07055195431177, 218, 6, 'PPL', 'P'),
(208486, 'Possession', 47.917781829834, 0.836323063182916, -122.375, -2.13584667212806, 218, 56, 'PPL', 'P'),
(24093, 'Possie (historical)', 33.8113899230957, 0.590120078833652, -82.6438903808594, -1.44240799380327, 218, 13, 'PPL', 'P'),
(17722, 'Possum Bluff', 29.5380592346191, 0.51553638829322, -81.6927795410156, -1.42580797809658, 218, 12, 'PPL', 'P'),
(61408, 'Possum Corner', 31.3516693115234, 0.547189855482548, -91.2997207641602, -1.59348073348603, 218, 30, 'PPL', 'P'),
(83123, 'Possum Corner', 32.6841697692871, 0.570446375754855, -80.9761123657227, -1.41329977624676, 218, 48, 'PPL', 'P'),
(11347, 'Possum Grape', 35.475830078125, 0.619170039741318, -91.4111099243164, -1.59542484108179, 218, 4, 'PPL', 'P'),
(166168, 'Possum Hollow', 40.8555603027344, 0.713064045029806, -80.3372192382813, -1.40214898760454, 218, 45, 'PPL', 'P'),
(83124, 'Possum Town', 33.3886108398438, 0.582741191822343, -80.3469390869141, -1.40231863096598, 218, 48, 'PPL', 'P'),
(5196, 'Possum Trot', 33.8708305358887, 0.591157513236293, -85.7519378662109, -1.49665365573098, 218, 2, 'PPL', 'P'),
(37776, 'Possum Trot', 37.0055618286133, 0.645868895459635, -88.4305572509766, -1.54340438340289, 218, 21, 'PPL', 'P'),
(57004, 'Possum Trot', 36.9786109924316, 0.6453985146321, -93.4288864135742, -1.63064168438867, 218, 29, 'PPL', 'P'),
(61411, 'Possum Trot', 34.3022193908691, 0.59868666911211, -89.0844421386719, -1.5548168276222, 218, 30, 'PPL', 'P'),
(112624, 'Possum Trot', 38.4700012207031, 0.671428184547507, -79.5325012207031, -1.38810400864768, 218, 53, 'PPL', 'P'),
(139412, 'Possum Walk', 40.4944381713867, 0.70676127483597, -95.0841674804688, -1.6595317890519, 218, 29, 'PPL', 'P'),
(61409, 'Possumneck', 33.1411094665527, 0.578421477955207, -89.7416687011719, -1.56628759506939, 218, 30, 'PPL', 'P'),
(146100, 'Possumtown', 40.5544395446777, 0.707808496355616, -74.491943359375, -1.30012967783022, 218, 37, 'PPL', 'P'),
(67951, 'Possumtrot', 35.9027786254883, 0.626621697629415, -82.4286117553711, -1.43865067297933, 218, 33, 'PPL', 'P'),
(37777, 'Post', 37.4730606079102, 0.65402828840742, -86.4755630493164, -1.50928329772652, 218, 21, 'PPL', 'P'),
(192073, 'Post', 33.1908302307129, 0.579289268996409, -101.377777099609, -1.76937599874109, 218, 51, 'PPL', 'P'),
(201429, 'Post', 44.1624984741211, 0.770781004280385, -120.488891601563, -2.10292787052581, 218, 43, 'PPL', 'P'),
(146101, 'Post Corner', 40.2827796936035, 0.703067137508894, -74.6374969482422, -1.30267006719405, 218, 37, 'PPL', 'P'),
(151877, 'Post Creek', 42.2350006103516, 0.737139820232449, -76.9602813720703, -1.34321030320389, 218, 40, 'PPL', 'P'),
(197289, 'Post Creek', 47.399169921875, 0.827271577848982, -114.095832824707, -1.99134794559616, 218, 31, 'PPL', 'P'),
(195491, 'Post Falls', 47.7180595397949, 0.832837251632112, -116.950561523438, -2.04117236064018, 218, 17, 'PPL', 'P'),
(83127, 'Post Foot Landing', 33.5097198486328, 0.584854942779538, -79.3011093139648, -1.38406545801263, 218, 48, 'PPL', 'P'),
(24095, 'Post Harbor', 33.9044418334961, 0.59174414104541, -84.4516677856445, -1.47395966165993, 218, 13, 'PPL', 'P'),
(125879, 'Post Island', 42.2625007629395, 0.737619788439909, -70.9744415283203, -1.23873768943339, 218, 23, 'PPL', 'P'),
(175932, 'Post Lake', 45.4408302307129, 0.793092102365714, -89.0802764892578, -1.55474412332444, 218, 57, 'PPL', 'P'),
(172418, 'Post Mills', 43.8855590820313, 0.765947500059946, -72.2611083984375, -1.26119426269326, 218, 55, 'PPL', 'P'),
(5193, 'Post Oak', 33.7944412231445, 0.589824268215572, -85.8625030517578, -1.49858338225685, 218, 2, 'PPL', 'P'),
(11350, 'Post Oak', 35.5722198486328, 0.620852358601921, -92.1769409179688, -1.60879111343484, 218, 4, 'PPL', 'P'),
(24096, 'Post Oak', 34.8952789306641, 0.609037510741894, -85.2008285522461, -1.48703498366389, 218, 13, 'PPL', 'P'),
(28308, 'Post Oak', 39.0902786254883, 0.682254067536734, -88.9091720581055, -1.55175778763608, 218, 18, 'PPL', 'P'),
(57005, 'Post Oak', 38.5688896179199, 0.67315411267096, -93.7508316040039, -1.63626068797262, 218, 29, 'PPL', 'P'),
(76988, 'Post Oak', 34.0711097717285, 0.594653045325076, -97.42138671875, -1.70032396010086, 218, 42, 'PPL', 'P'),
(90096, 'Post Oak', 36.2172203063965, 0.632109740266768, -85.4800033569336, -1.4919075031943, 218, 50, 'PPL', 'P'),
(97195, 'Post Oak', 33.7158317565918, 0.58845227420099, -95.3233337402344, -1.66370602774449, 218, 51, 'PPL', 'P'),
(105417, 'Post Oak', 38.1661109924316, 0.666124299499533, -77.6636123657227, -1.35548574477444, 218, 53, 'PPL', 'P'),
(97196, 'Post Oak Bend', 32.6383285522461, 0.569646295584368, -96.3047180175781, -1.68083441461144, 218, 51, 'PPL', 'P'),
(97197, 'Post Oak Bend City', 32.6319389343262, 0.569534775713721, -96.3133316040039, -1.68098475005498, 218, 51, 'PPL', 'P'),
(90098, 'Post Oak Estates', 36.2180595397949, 0.632124387652764, -85.4716720581055, -1.49176209459878, 218, 50, 'PPL', 'P'),
(90097, 'Post Oak Farms', 35.8555603027344, 0.62579758243009, -84.6347198486328, -1.47715452286164, 218, 50, 'PPL', 'P'),
(97198, 'Post Oak Point', 29.9288806915283, 0.522357509503727, -96.5271987915039, -1.68471743663883, 218, 51, 'PPL', 'P'),
(97200, 'Post Oaks Colonia', 26.2919998168945, 0.458881963738556, -98.1900024414063, -1.71373883514381, 218, 51, 'PPL', 'P'),
(24097, 'Post River', 33.9041709899902, 0.591739413934475, -84.4508285522461, -1.47394501427393, 218, 13, 'PPL', 'P'),
(73967, 'Post Town', 39.7808303833008, 0.694306469365996, -84.3116683959961, -1.47151621135978, 218, 41, 'PPL', 'P'),
(137566, 'Post Town', 44.0905609130859, 0.769525456984467, -92.6386108398438, -1.61684877362898, 218, 28, 'PPL', 'P'),
(57007, 'Postal', 38.8974990844727, 0.678889429815528, -93.0830612182617, -1.62460589609411, 218, 29, 'PPL', 'P'),
(157233, 'Postboy', 40.2269401550293, 0.702092553707979, -81.5844421386719, -1.42391713372263, 218, 41, 'PPL', 'P'),
(24098, 'Postell', 32.9155616760254, 0.574484926389906, -83.5266723632813, -1.45781544597381, 218, 13, 'PPL', 'P'),
(67952, 'Postell', 35.0827789306641, 0.612310003089383, -84.2416687011719, -1.4702944862097, 218, 33, 'PPL', 'P'),
(11349, 'Postelle', 34.5699996948242, 0.603360317088118, -91.0227813720703, -1.58864722926559, 218, 4, 'PPL', 'P'),
(90100, 'Postelle', 35.0441703796387, 0.611636156754566, -84.404167175293, -1.47313061961258, 218, 50, 'PPL', 'P'),
(112259, 'Postil', 30.478609085083, 0.531952079962955, -86.4850006103516, -1.50944801423994, 218, 12, 'PPL', 'P'),
(14443, 'Postles Corner', 39.1347198486328, 0.683029713204219, -75.4483337402344, -1.31682183891062, 218, 10, 'PPL', 'P'),
(5194, 'Postoak', 32.0008316040039, 0.558519874866126, -85.8199996948242, -1.49784155873521, 218, 2, 'PPL', 'P'),
(90099, 'Postoak', 35.8733291625977, 0.626107707539029, -84.6308288574219, -1.47708661225384, 218, 50, 'PPL', 'P'),
(97199, 'Postoak', 33.4569396972656, 0.58393375535848, -98.1427764892578, -1.71291458678643, 218, 51, 'PPL', 'P'),
(73968, 'Poston', 39.3788909912109, 0.687291303580564, -82.085563659668, -1.43266335421661, 218, 41, 'PPL', 'P'),
(83125, 'Poston', 33.8736114501953, 0.591206049347159, -79.4263916015625, -1.38625204642564, 218, 48, 'PPL', 'P'),
(178912, 'Poston', 33.9905586242676, 0.593247162585623, -114.395561218262, -1.9965791929254, 218, 5, 'PPL', 'P'),
(83126, 'Poston Crossroads', 33.9044418334961, 0.59174414104541, -79.5480575561523, -1.38837551792081, 218, 48, 'PPL', 'P'),
(184252, 'Posts', 36.228328704834, 0.632303618394126, -121.763328552246, -2.12517099142431, 218, 6, 'PPL', 'P'),
(197290, 'Posts Trailer Court', 48.399169921875, 0.844724870368926, -115.539436340332, -2.01654358003718, 218, 31, 'PPL', 'P'),
(117394, 'Postville', 43.0847206115723, 0.751970231973801, -91.5680618286133, -1.59816416857904, 218, 16, 'PPL', 'P'),
(146108, 'Postville', 41.0883293151855, 0.717126630693695, -74.4158325195313, -1.29880129307849, 218, 37, 'PPL', 'P'),
(175931, 'Postville', 42.7991714477539, 0.746986458888854, -89.7527770996094, -1.56648147319675, 218, 57, 'PPL', 'P'),
(24099, 'Postwoods', 33.8758316040039, 0.59124479834102, -84.4527816772461, -1.47397910273588, 218, 13, 'PPL', 'P'),
(189271, 'Pot Creek', 36.2750015258789, 0.633118212792554, -105.572219848633, -1.84258283499795, 218, 38, 'PPL', 'P'),
(67953, 'Pot Neck', 35.2299995422363, 0.614879487488119, -77.7102813720703, -1.35630027259384, 218, 33, 'PPL', 'P'),
(14444, 'Pot Nets West', 38.624439239502, 0.674123636465804, -75.1750030517578, -1.31205131844996, 218, 10, 'PPL', 'P'),
(50570, 'Pot Spring', 39.4472198486328, 0.688483867116702, -76.5980606079102, -1.3368883582502, 218, 25, 'PPL', 'P'),
(5195, 'Potash', 33.2772216796875, 0.580797084226585, -85.3525009155273, -1.48968216578743, 218, 2, 'PPL', 'P'),
(42676, 'Potash', 29.4927806854248, 0.514746128529253, -89.7055587768555, -1.56565735799743, 218, 22, 'PPL', 'P'),
(144342, 'Potash Corner', 42.8138885498047, 0.747243320775992, -71.4086074829102, -1.24631531484104, 218, 36, 'PPL', 'P'),
(11351, 'Potash Sulphur Springs (historical)', 34.4749984741211, 0.601702232993434, -92.9630584716797, -1.62251145305482, 218, 4, 'PPL', 'P'),
(202507, 'Potato Creek', 43.5344390869141, 0.759819300075564, -101.989723205566, -1.7800564731348, 218, 49, 'PPL', 'P'),
(71308, 'Potato Island', 39.0833282470703, 0.682132760549081, -74.8625030517578, -1.30659716453748, 218, 37, 'PPL', 'P'),
(30885, 'Potato Mound', 39.4080581665039, 0.687800366822933, -86.5422210693359, -1.51044669964872, 218, 19, 'PPL', 'P'),
(178913, 'Potato Patch', 34.4300003051758, 0.60091686678797, -112.413330078125, -1.96198273299446, 218, 5, 'PPL', 'P'),
(189272, 'Potato Patch', 33.7552795410156, 0.589140767921803, -108.907783508301, -1.90079940326903, 218, 38, 'PPL', 'P'),
(90101, 'Potatoe', 36.1208305358887, 0.630427421406165, -89.2350006103516, -1.55744456866978, 218, 50, 'PPL', 'P'),
(123483, 'Potawatomi Inn', 41.7038917541504, 0.727870222005238, -85.0224990844727, -1.48392254729791, 218, 19, 'PPL', 'P'),
(123484, 'Potawatomi Park', 41.3233299255371, 0.721228165088526, -85.7586135864258, -1.49677016902867, 218, 19, 'PPL', 'P'),
(123485, 'Potawatomi Point', 40.7477798461914, 0.711182921193829, -86.3083267211914, -1.50636447317179, 218, 19, 'PPL', 'P'),
(76989, 'Poteau', 35.0536117553711, 0.611800939847015, -94.6233291625977, -1.6514886430857, 218, 42, 'PPL', 'P'),
(67954, 'Potecasi', 36.3630599975586, 0.634655123057639, -77.2394409179688, -1.34808255641819, 218, 33, 'PPL', 'P'),
(97201, 'Poteet', 29.0402793884277, 0.506848491027109, -98.5677795410156, -1.72033228937063, 218, 51, 'PPL', 'P'),
(90102, 'Poteet (historical)', 36.3680610656738, 0.634742408162366, -85.1777801513672, -1.48663271318123, 218, 50, 'PPL', 'P'),
(67955, 'Poteskeet Village', 36.1619415283203, 0.63114494358286, -75.7436065673828, -1.32197532193603, 218, 33, 'PPL', 'P'),
(97202, 'Poth', 29.0694408416748, 0.507357454400937, -98.081672668457, -1.71184812392791, 218, 51, 'PPL', 'P'),
(189273, 'Pothook', 31.9747200012207, 0.558064141424587, -108.494438171387, -1.89358516619211, 218, 38, 'PPL', 'P'),
(61413, 'Poticaw Landing', 30.5116691589355, 0.532529087102634, -88.6188888549805, -1.54669138997832, 218, 30, 'PPL', 'P'),
(195492, 'Potlatch', 46.9216690063477, 0.818937614691743, -116.897216796875, -2.04024131952309, 218, 17, 'PPL', 'P'),
(208487, 'Potlatch', 47.3763885498047, 0.826873967898233, -123.148063659668, -2.14933917831678, 218, 56, 'PPL', 'P'),
(195493, 'Potlatch Junction', 46.9294395446777, 0.819073236170255, -116.932502746582, -2.04085717552517, 218, 17, 'PPL', 'P'),
(61412, 'Potlockney', 34.1749992370605, 0.596466258553257, -89.3736114501953, -1.55986378420401, 218, 30, 'PPL', 'P'),
(50554, 'Potomac', 39.0180587768555, 0.680993593392799, -77.2088928222656, -1.34754939156795, 218, 25, 'PPL', 'P'),
(121098, 'Potomac', 40.3050003051758, 0.703454960342637, -87.8005599975586, -1.53240885705222, 218, 18, 'PPL', 'P'),
(177268, 'Potomac', 40.1527786254883, 0.700798190839174, -80.5294418334961, -1.40550390478777, 218, 58, 'PPL', 'P'),
(197291, 'Potomac', 46.8816719055176, 0.818239533591006, -113.57861328125, -1.98232076160717, 218, 31, 'PPL', 'P'),
(105418, 'Potomac Beach', 38.2702789306641, 0.667942372996703, -76.9861068725586, -1.34366104321838, 218, 53, 'PPL', 'P'),
(50555, 'Potomac Chase', 39.0916709899902, 0.682278368881681, -77.2627792358398, -1.34848988690691, 218, 25, 'PPL', 'P'),
(50556, 'Potomac Chase Estates', 39.0777816772461, 0.682035954643456, -77.2763900756836, -1.34872744087615, 218, 25, 'PPL', 'P'),
(13191, 'Potomac City (historical)', 38.8597183227539, 0.678230031129624, -76.9986114501953, -1.34387928926971, 218, 9, 'PPL', 'P'),
(50557, 'Potomac Crest', 39.4533309936523, 0.688590526718359, -77.751106262207, -1.35701280134349, 218, 25, 'PPL', 'P'),
(50558, 'Potomac Estates', 39.438060760498, 0.68832401087227, -77.184440612793, -1.34712262000327, 218, 25, 'PPL', 'P'),
(50559, 'Potomac Falls', 39.0133285522461, 0.680911035399007, -77.230827331543, -1.34793222097465, 218, 25, 'PPL', 'P'),
(105419, 'Potomac Falls', 39.0499992370605, 0.68155105958798, -77.4011077880859, -1.35090417559313, 218, 53, 'PPL', 'P'),
(105420, 'Potomac Farms', 39.0644416809082, 0.681803127785156, -77.4555587768555, -1.35185452462812, 218, 53, 'PPL', 'P'),
(50560, 'Potomac Gateway', 39.2905616760254, 0.685749666204545, -77.5397186279297, -1.35332339112735, 218, 25, 'PPL', 'P'),
(50561, 'Potomac Grove', 39.1061096191406, 0.68253037049983, -77.2538909912109, -1.34833475777342, 218, 25, 'PPL', 'P'),
(13192, 'Potomac Heights', 38.9275016784668, 0.679413073864865, -77.1080627441406, -1.34578957471963, 218, 9, 'PPL', 'P'),
(50562, 'Potomac Heights', 38.6086082458496, 0.673847333502708, -77.1408309936523, -1.34636148856372, 218, 25, 'PPL', 'P'),
(105421, 'Potomac Hills', 38.9302787780762, 0.679461543396704, -77.1536102294922, -1.34658452830502, 218, 53, 'PPL', 'P'),
(50564, 'Potomac Hunt Acres', 39.0347213745117, 0.681284410583836, -77.2402801513672, -1.34809720380418, 218, 25, 'PPL', 'P'),
(50565, 'Potomac Manor', 39.6555595397949, 0.692120080690069, -77.6952819824219, -1.35603848385869, 218, 25, 'PPL', 'P'),
(50566, 'Potomac Manors', 39.0169410705566, 0.680974085737815, -77.2213897705078, -1.34776750446123, 218, 25, 'PPL', 'P'),
(105423, 'Potomac Mills', 38.1627807617188, 0.666066176008742, -76.942497253418, -1.34289991177884, 218, 53, 'PPL', 'P'),
(50567, 'Potomac Overlook', 39.3113899230957, 0.686113187693341, -77.5427780151367, -1.35337678750721, 218, 25, 'PPL', 'P'),
(50568, 'Potomac Park', 39.6116714477539, 0.691354088981535, -78.8061065673828, -1.37542603027836, 218, 25, 'PPL', 'P'),
(50569, 'Potomac Park Estate', 39.1019401550293, 0.682457599623043, -77.3502807617188, -1.35001707663402, 218, 25, 'PPL', 'P'),
(50572, 'Potomac Shores', 38.1994400024414, 0.666706000460633, -76.5647201538086, -1.33630645755202, 218, 25, 'PPL', 'P'),
(50573, 'Potomac Valley Farms', 39.4775009155273, 0.689012371435028, -77.7844390869141, -1.35759456888362, 218, 25, 'PPL', 'P'),
(50574, 'Potomac View', 38.2833290100098, 0.668170139848932, -76.8958282470703, -1.34208538395944, 218, 25, 'PPL', 'P'),
(50575, 'Potomac Village', 39.2811088562012, 0.685584683375014, -77.5338897705078, -1.35322165837371, 218, 25, 'PPL', 'P'),
(50576, 'Potomac Vista', 38.785831451416, 0.676940461950781, -77.0111083984375, -1.34409740216299, 218, 25, 'PPL', 'P'),
(50577, 'Potomac Vistas', 39.392219543457, 0.687523930701783, -77.7152786254883, -1.35638749111954, 218, 25, 'PPL', 'P'),
(50579, 'Potomac Woodlands', 39.5463905334473, 0.690214722088171, -77.8600006103516, -1.35891336625543, 218, 25, 'PPL', 'P'),
(50580, 'Potomac Woods', 39.0627784729004, 0.681774099329274, -77.1705627441406, -1.34688040550212, 218, 25, 'PPL', 'P'),
(190625, 'Potomic (historical)', 38.3311080932617, 0.669004042165263, -117.246673583984, -2.04634049105159, 218, 39, 'PPL', 'P'),
(57008, 'Potosi', 37.9363899230957, 0.662114910478418, -90.7877807617188, -1.58454569487076, 218, 29, 'PPL', 'P'),
(78979, 'Potosi', 39.8205604553223, 0.694999889934826, -76.6733322143555, -1.33820209561594, 218, 45, 'PPL', 'P'),
(97203, 'Potosi', 32.3291702270508, 0.564250464899759, -99.6561126708984, -1.73932728584562, 218, 51, 'PPL', 'P'),
(175933, 'Potosi', 42.6894416809082, 0.745071313169951, -90.7119369506836, -1.58322197065093, 218, 57, 'PPL', 'P'),
(117395, 'Potosia', 42.6636085510254, 0.7446204399974, -96.3716735839844, -1.68200300969777, 218, 16, 'PPL', 'P'),
(169558, 'Potowomut', 41.663890838623, 0.727172074325474, -71.4225006103516, -1.24655779565829, 218, 47, 'PPL', 'P'),
(184253, 'Potrero', 32.6047210693359, 0.569059734354278, -116.61222076416, -2.03526720039709, 218, 6, 'PPL', 'P'),
(189274, 'Potrero', 35.9897193908691, 0.628139100239515, -105.933059692383, -1.84888067834377, 218, 38, 'PPL', 'P'),
(189275, 'Potrillo', 31.8016700744629, 0.555043850432328, -106.992218017578, -1.86736647841834, 218, 38, 'PPL', 'P'),
(14445, 'Pots Nets North Mobile Home Park', 38.6347198486328, 0.674303066944248, -75.1549987792969, -1.31170217803105, 218, 10, 'PPL', 'P'),
(73969, 'Potsdam', 39.9633293151855, 0.697491676608759, -84.4175033569336, -1.47336337989186, 218, 41, 'PPL', 'P'),
(137567, 'Potsdam', 44.1655616760254, 0.770834467239268, -92.3388900756836, -1.61161765945779, 218, 28, 'PPL', 'P'),
(151878, 'Potsdam', 44.6697196960449, 0.779633684638945, -74.9816665649414, -1.30867696019077, 218, 40, 'PPL', 'P'),
(123486, 'Pottawattamie Park', 41.7224998474121, 0.728194994500173, -86.866943359375, -1.51611417276452, 218, 19, 'PPL', 'P'),
(5197, 'Potter', 32.4311103820801, 0.566029656245014, -87.1080627441406, -1.52032249991906, 218, 2, 'PPL', 'P'),
(11352, 'Potter', 34.5536117553711, 0.603074293587043, -94.3388900756836, -1.64652424449768, 218, 4, 'PPL', 'P'),
(24100, 'Potter', 30.6466693878174, 0.534885285587568, -82.9333267211914, -1.44745961091698, 218, 13, 'PPL', 'P'),
(33677, 'Potter', 39.4258308410645, 0.6881105585109, -95.1416702270508, -1.6605354013087, 218, 20, 'PPL', 'P'),
(76992, 'Potter', 36.9566688537598, 0.645015552067347, -94.8644409179688, -1.65569683708219, 218, 42, 'PPL', 'P'),
(117397, 'Potter', 41.9599990844727, 0.732340138157854, -92.6750030517578, -1.61748393754897, 218, 16, 'PPL', 'P'),
(151880, 'Potter', 42.7041702270508, 0.745328374794171, -77.2069396972656, -1.347515303106, 218, 40, 'PPL', 'P'),
(175936, 'Potter', 44.1205596923828, 0.770049034454777, -88.0991668701172, -1.53762053014745, 218, 57, 'PPL', 'P'),
(199620, 'Potter', 41.2174987792969, 0.719381063135474, -103.315277099609, -1.80319175299848, 218, 35, 'PPL', 'P'),
(166169, 'Potter Brook', 41.913330078125, 0.731525610338453, -77.6036071777344, -1.35443845667577, 218, 45, 'PPL', 'P'),
(151881, 'Potter Hill', 42.8452796936035, 0.747791199591249, -73.3947219848633, -1.28097955222173, 218, 40, 'PPL', 'P'),
(169559, 'Potter Hill', 41.4136085510254, 0.722803824347471, -71.7994384765625, -1.25313660249912, 218, 47, 'PPL', 'P'),
(212114, 'Potter Hill', 61.0833282470703, 1.06610519598783, -149.816665649414, -2.61479408994176, 218, 1, 'PPL', 'P'),
(151882, 'Potter Hollow', 42.4249992370605, 0.740455921842789, -74.2236099243164, -1.29544637589526, 218, 40, 'PPL', 'P'),
(11356, 'Potter Junction', 34.5505599975586, 0.603021030365241, -94.3058319091797, -1.64594727064752, 218, 4, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(175937, 'Potter Lake', 42.8216705322266, 0.747379141991586, -88.3488922119141, -1.54197905958748, 218, 57, 'PPL', 'P'),
(201430, 'Potter Mill (historical)', 42.0541687011719, 0.733983708024597, -122.248611450195, -2.13364077579715, 218, 43, 'PPL', 'P'),
(144343, 'Potter Place', 43.4352798461914, 0.758088644841176, -71.8580627441406, -1.25415978898993, 218, 36, 'PPL', 'P'),
(178914, 'Potter Place', 34.8111114501953, 0.607568511084606, -109.654998779297, -1.91384076996909, 218, 5, 'PPL', 'P'),
(195494, 'Potter Place', 45.3077812194824, 0.79076995905322, -116.439720153809, -2.03225649678476, 218, 17, 'PPL', 'P'),
(184264, 'Potter Valley', 39.3222198486328, 0.686302205551709, -123.111938476563, -2.14870867492871, 218, 6, 'PPL', 'P'),
(146102, 'Potters', 40.5936088562012, 0.70849212980744, -74.3616714477539, -1.29785600404956, 218, 37, 'PPL', 'P'),
(67958, 'Potters Curve', 34.3052787780762, 0.598740065491966, -78.8066711425781, -1.37543588397439, 218, 33, 'PPL', 'P'),
(37778, 'Potters Fork', 37.1824989318848, 0.648957030480664, -82.6733322143555, -1.4429218507356, 218, 21, 'PPL', 'P'),
(67956, 'Potters Hill', 34.9686088562012, 0.610317359382759, -77.710563659668, -1.35630519944186, 218, 33, 'PPL', 'P'),
(50581, 'Potters Landing', 38.8316688537598, 0.67774047554224, -75.8547210693359, -1.32391463584183, 218, 25, 'PPL', 'P'),
(166173, 'Potters Mills', 40.7958297729492, 0.712021550621095, -77.6255569458008, -1.35482155239858, 218, 45, 'PPL', 'P'),
(157234, 'Pottersburg', 40.2661094665527, 0.702776187159803, -83.5008316040039, -1.45736443964321, 218, 41, 'PPL', 'P'),
(166174, 'Pottersdale', 41.165828704834, 0.718479250211346, -78.0627822875977, -1.36245257418609, 218, 45, 'PPL', 'P'),
(146103, 'Potterstown', 40.642219543457, 0.709340546351712, -74.7988891601563, -1.30548689267902, 218, 37, 'PPL', 'P'),
(30886, 'Pottersville', 39.207218170166, 0.684295047617143, -86.8141708374023, -1.51519311850151, 218, 19, 'PPL', 'P'),
(57010, 'Pottersville', 36.6958312988281, 0.640463077920938, -92.0311126708984, -1.60624593038105, 218, 29, 'PPL', 'P'),
(113364, 'Pottersville', 44.538890838623, 0.777350290320311, -72.4530563354492, -1.26454438618653, 218, 55, 'PPL', 'P'),
(125880, 'Pottersville', 41.75, 0.728674962707633, -71.1416702270508, -1.24165638083006, 218, 23, 'PPL', 'P'),
(146104, 'Pottersville', 40.7136116027832, 0.710586572846733, -74.7222213745117, -1.30414878738931, 218, 37, 'PPL', 'P'),
(151884, 'Pottersville', 43.7311096191406, 0.763251848404567, -73.8197174072266, -1.28839712164788, 218, 40, 'PPL', 'P'),
(169560, 'Pottersville', 41.5250015258789, 0.724747998522256, -71.1333312988281, -1.24151083907649, 218, 47, 'PPL', 'P'),
(37779, 'Pottertown', 36.6213912963867, 0.639163854783143, -88.1911087036133, -1.53922521786228, 218, 21, 'PPL', 'P'),
(67957, 'Pottertown', 36.351390838623, 0.634451457813275, -81.6727828979492, -1.42545897083573, 218, 33, 'PPL', 'P'),
(30887, 'Pottertown (historical)', 39.8308296203613, 0.695179120676188, -87.2622222900391, -1.52301309156837, 218, 19, 'PPL', 'P'),
(24101, 'Potterville', 32.5144386291504, 0.567484008516306, -84.1175003051758, -1.46812733887265, 218, 13, 'PPL', 'P'),
(132721, 'Potterville', 42.6291694641113, 0.744019364539369, -84.7388916015625, -1.47897266293784, 218, 27, 'PPL', 'P'),
(151885, 'Potterville', 41.8319396972656, 0.730105080213005, -74.3777770996094, -1.29813710070262, 218, 40, 'PPL', 'P'),
(166175, 'Potterville', 41.8805618286133, 0.730953696494359, -76.2355575561523, -1.3305614864485, 218, 45, 'PPL', 'P'),
(169561, 'Potterville', 41.7186088562012, 0.728127083892376, -71.6699981689453, -1.2508774429464, 218, 47, 'PPL', 'P'),
(157235, 'Pottery Addition', 40.4022216796875, 0.705151793431181, -80.6252822875977, -1.40717663626844, 218, 41, 'PPL', 'P'),
(105424, 'Pottomoi', 37.6763916015625, 0.657577083718005, -77.3997192382813, -1.35087994082721, 218, 53, 'PPL', 'P'),
(57009, 'Potts', 38.4741706848145, 0.671500955424294, -91.7836074829102, -1.60192614993489, 218, 29, 'PPL', 'P'),
(190626, 'Potts (historical)', 39.086109161377, 0.682181296659948, -116.639999389648, -2.03575202887354, 218, 39, 'PPL', 'P'),
(61414, 'Potts Camp', 34.646110534668, 0.604688701839849, -89.3052825927734, -1.55867122066787, 218, 30, 'PPL', 'P'),
(105425, 'Potts Creek', 37.6202812194824, 0.656597772806156, -80.1877822875977, -1.39954082079097, 218, 53, 'PPL', 'P'),
(166176, 'Potts Grove', 40.9936103820801, 0.715473473447028, -76.789436340332, -1.34022849488938, 218, 45, 'PPL', 'P'),
(50585, 'Potts Point', 38.5616683959961, 0.673028078572372, -76.6688919067383, -1.33812459762822, 218, 25, 'PPL', 'P'),
(197292, 'Potts Trailer Court', 45.7761116027832, 0.798943866228946, -111.176109313965, -1.94038915708582, 218, 31, 'PPL', 'P'),
(97204, 'Pottsboro', 33.7591705322266, 0.5892086785296, -96.6691665649414, -1.68719524171704, 218, 51, 'PPL', 'P'),
(166177, 'Pottsgrove', 40.264720916748, 0.702751952393883, -75.6122207641602, -1.31968220707942, 218, 45, 'PPL', 'P'),
(121099, 'Pottstown', 40.7180595397949, 0.710664203992508, -89.6602783203125, -1.56486706494394, 218, 18, 'PPL', 'P'),
(166178, 'Pottstown', 40.2452812194824, 0.702412665671007, -75.6500015258789, -1.32034160576532, 218, 45, 'PPL', 'P'),
(166179, 'Pottstown Landing', 40.2363891601563, 0.702257469958483, -75.665283203125, -1.32060832134849, 218, 45, 'PPL', 'P'),
(11354, 'Pottsville', 35.2480583190918, 0.61519467260313, -93.0488891601563, -1.62400948116799, 218, 4, 'PPL', 'P'),
(28309, 'Pottsville', 37.4219398498535, 0.653136062863216, -89.3574981689453, -1.5595825543929, 218, 18, 'PPL', 'P'),
(37781, 'Pottsville', 36.8549995422363, 0.643241087833027, -88.7291717529297, -1.54861618965617, 218, 21, 'PPL', 'P'),
(90103, 'Pottsville', 35.6377792358398, 0.621996585764274, -86.8252792358398, -1.51538699662887, 218, 50, 'PPL', 'P'),
(97205, 'Pottsville', 31.673059463501, 0.552799171818041, -98.3252792358398, -1.71609986060822, 218, 51, 'PPL', 'P'),
(166181, 'Pottsville', 40.6855583190918, 0.710096950680322, -76.1958312988281, -1.3298681324587, 218, 45, 'PPL', 'P'),
(195495, 'Pottsville (historical)', 47.4666709899902, 0.828449693736206, -115.705276489258, -2.01943803666793, 218, 17, 'PPL', 'P'),
(33678, 'Potwin', 37.9388885498047, 0.662158519741268, -97.0194396972656, -1.69330866115738, 218, 20, 'PPL', 'P'),
(184265, 'Potwisha', 36.5175018310547, 0.637350641554962, -118.798889160156, -2.07343176355653, 218, 6, 'PPL', 'P'),
(17724, 'Pouchers Corner', 30.3141708374023, 0.529082091124717, -82.8213882446289, -1.4455059159413, 218, 12, 'PPL', 'P'),
(194380, 'Poudre Park', 40.6861114501953, 0.710106604639273, -105.304168701172, -1.83790445991101, 218, 7, 'PPL', 'P'),
(42677, 'Poufette', 29.9430599212646, 0.522604983748022, -91.9308319091797, -1.60449570091265, 218, 22, 'PPL', 'P'),
(11355, 'Poughkeepsie', 36.0766716003418, 0.629656702586696, -91.4791717529297, -1.59661274408602, 218, 4, 'PPL', 'P'),
(151886, 'Poughkeepsie', 41.7002792358398, 0.72780717166643, -73.92138671875, -1.29017158588219, 218, 40, 'PPL', 'P'),
(151889, 'Poughquag', 41.6088905334473, 0.726212137910555, -73.6822204589844, -1.2859973471896, 218, 40, 'PPL', 'P'),
(24102, 'Poulan', 31.5127792358398, 0.550001754119508, -83.7877807617188, -1.46237264723115, 218, 13, 'PPL', 'P'),
(208488, 'Poulsbo', 47.7361106872559, 0.833152303589068, -122.645278930664, -2.14056392936692, 218, 56, 'PPL', 'P'),
(105427, 'Poulson', 37.8758316040039, 0.661057968420793, -75.644172668457, -1.32023987301168, 218, 53, 'PPL', 'P'),
(172419, 'Poultney', 43.5169410705566, 0.759513902077559, -73.2366714477539, -1.27822104996463, 218, 55, 'PPL', 'P'),
(73970, 'Poulton', 39.6074981689453, 0.691281251525721, -81.1213912963867, -1.41583537192062, 218, 41, 'PPL', 'P'),
(105426, 'Pound', 37.1236114501953, 0.647929250036975, -82.6013870239258, -1.44166617028163, 218, 53, 'PPL', 'P'),
(175939, 'Pound', 45.0941696166992, 0.787041733264191, -88.0338897705078, -1.53648122983312, 218, 57, 'PPL', 'P'),
(151890, 'Pound Ridge', 41.208610534668, 0.719225934001977, -73.5752792358398, -1.28413087073962, 218, 40, 'PPL', 'P'),
(105428, 'Pounding Mill', 37.0752792358398, 0.647085693761693, -81.7088928222656, -1.4260892079077, 218, 53, 'PPL', 'P'),
(189276, 'Pounds (historical)', 36.6897201538086, 0.64035641831928, -107.082778930664, -1.8689470645253, 218, 38, 'PPL', 'P'),
(123487, 'Poundstone Corner', 40.6266708374023, 0.709069170236633, -86.3361129760742, -1.5068494348063, 218, 19, 'PPL', 'P'),
(37782, 'Poverty', 37.5708312988281, 0.655734708875888, -87.3211135864258, -1.52404093859108, 218, 21, 'PPL', 'P'),
(83128, 'Poverty Hill', 33.563060760498, 0.585785917317603, -82.0116729736328, -1.43137371845874, 218, 48, 'PPL', 'P'),
(184267, 'Poverty Hill', 39.622501373291, 0.691543106839903, -121.005828857422, -2.11195012766678, 218, 6, 'PPL', 'P'),
(121100, 'Poverty Ridge', 40.4619407653809, 0.70619408810281, -90.3408279418945, -1.57674489656375, 218, 18, 'PPL', 'P'),
(194381, 'Powars', 40.040828704834, 0.69884429612641, -104.807502746582, -1.82923600372086, 218, 7, 'PPL', 'P'),
(184266, 'Poway', 32.9627799987793, 0.575309041589231, -117.035003662109, -2.04264615398743, 218, 6, 'PPL', 'P'),
(184270, 'Poway Grove (historical)', 32.939998626709, 0.574911431638482, -117.063331604004, -2.0431405698438, 218, 6, 'PPL', 'P'),
(184268, 'Poway Grove Park', 32.9408302307129, 0.574925945866423, -117.064437866211, -2.04315987776171, 218, 6, 'PPL', 'P'),
(105429, 'Powcan', 37.7822189331055, 0.65942411909203, -76.9430618286133, -1.34290976547487, 218, 53, 'PPL', 'P'),
(90104, 'Powder Branch', 36.2750015258789, 0.633118212792554, -82.2583312988281, -1.43567871836085, 218, 50, 'PPL', 'P'),
(24103, 'Powder Creek Crossing', 33.9152793884277, 0.591933292061833, -84.7474975585938, -1.47912286522332, 218, 13, 'PPL', 'P'),
(24104, 'Powder Mill', 33.9333305358887, 0.592248344018789, -84.7249984741211, -1.47873018212058, 218, 13, 'PPL', 'P'),
(37783, 'Powder Mill', 37.3469390869141, 0.651827052608415, -85.7133331298828, -1.49597987597519, 218, 21, 'PPL', 'P'),
(50583, 'Powder Mill Addition', 39.5047187805176, 0.689487412794471, -76.4211120605469, -1.33380002349209, 218, 25, 'PPL', 'P'),
(50584, 'Powder Mill Estates', 39.0355606079102, 0.681299057969831, -76.9452819824219, -1.34294851446873, 218, 25, 'PPL', 'P'),
(205419, 'Powder Mountain West', 41.3805618286133, 0.722227050234387, -111.783058166504, -1.95098241295383, 218, 52, 'PPL', 'P'),
(24107, 'Powder Ridge', 33.8433303833008, 0.590677545028833, -84.7225036621094, -1.47868663943676, 218, 13, 'PPL', 'P'),
(205420, 'Powder Ridge Condominiums', 40.5913887023926, 0.708453380813579, -111.630561828613, -1.9483208497604, 218, 52, 'PPL', 'P'),
(209674, 'Powder River', 43.0322189331055, 0.751053904821732, -106.986671447754, -1.86726967251271, 218, 59, 'PPL', 'P'),
(24105, 'Powder Springs', 33.8594398498535, 0.590958708260918, -84.6838912963867, -1.47801272652292, 218, 13, 'PPL', 'P'),
(90105, 'Powder Springs', 36.2536087036133, 0.632744837607725, -83.6697235107422, -1.46031215949576, 218, 50, 'PPL', 'P'),
(90106, 'Powder Springs (historical)', 35.9233283996582, 0.626980358849221, -83.5411071777344, -1.45806738101293, 218, 50, 'PPL', 'P'),
(24106, 'Powder Springs Chase', 33.8600006103516, 0.590968495377924, -84.7138900756836, -1.47853630399323, 218, 13, 'PPL', 'P'),
(166183, 'Powder Valley', 40.4661102294922, 0.706266858979597, -75.5247192382813, -1.31815501735231, 218, 45, 'PPL', 'P'),
(194382, 'Powder Wash', 40.9458312988281, 0.714639571130697, -108.310829162598, -1.89038058445242, 218, 7, 'PPL', 'P'),
(187224, 'Powderhorn', 38.2769393920898, 0.668058619978285, -107.095283508301, -1.86916531057663, 218, 7, 'PPL', 'P'),
(67959, 'Powderhorn Mountain', 36.1636085510254, 0.631174038617769, -81.5061111450195, -1.42254999997704, 218, 33, 'PPL', 'P'),
(73971, 'Powderlick', 39.4599990844727, 0.688706906857996, -83.7130584716797, -1.46106849724534, 218, 41, 'PPL', 'P'),
(5198, 'Powderly', 33.4683303833008, 0.584132560333854, -86.8713912963867, -1.51619180391029, 218, 2, 'PPL', 'P'),
(37784, 'Powderly', 37.2369384765625, 0.649907179778577, -87.1591720581055, -1.52121452572618, 218, 21, 'PPL', 'P'),
(97206, 'Powderly', 33.8111114501953, 0.590115218564663, -95.524169921875, -1.66721128037125, 218, 51, 'PPL', 'P'),
(5199, 'Powderly Hills', 33.4644393920898, 0.584064649726057, -86.8638916015625, -1.51606090954272, 218, 2, 'PPL', 'P'),
(83131, 'Powderville', 34.7916717529297, 0.60722922436173, -82.4930572509766, -1.43977545906572, 218, 48, 'PPL', 'P'),
(197294, 'Powderville', 45.7588882446289, 0.798643261920903, -105.114723205566, -1.83459801225962, 218, 31, 'PPL', 'P'),
(57011, 'Powe', 36.6591682434082, 0.639823186890019, -90.0966720581055, -1.57248357250352, 218, 29, 'PPL', 'P'),
(5201, 'Powell', 34.9777793884277, 0.610477415364273, -87.2536087036133, -1.52286275612483, 218, 2, 'PPL', 'P'),
(11357, 'Powell', 36.2374992370605, 0.63246367437564, -92.8166732788086, -1.61995654946305, 218, 4, 'PPL', 'P'),
(17725, 'Powell', 28.4922199249268, 0.497283048892304, -82.4286117553711, -1.43865067297933, 218, 12, 'PPL', 'P'),
(24108, 'Powell', 32.4513893127441, 0.566383590353885, -83.2444381713867, -1.45288953006355, 218, 13, 'PPL', 'P'),
(42678, 'Powell', 30.7391700744629, 0.536499727129888, -91.329719543457, -1.59400431095634, 218, 22, 'PPL', 'P'),
(57012, 'Powell', 36.6227798461914, 0.639188089549063, -94.1805572509766, -1.64376081539256, 218, 29, 'PPL', 'P'),
(61415, 'Powell', 34.4850006103516, 0.601876803202889, -90.5263900756836, -1.5799835667654, 218, 30, 'PPL', 'P'),
(76994, 'Powell', 33.9550018310547, 0.592626579472608, -96.8622207641602, -1.69056467312821, 218, 42, 'PPL', 'P'),
(90107, 'Powell', 36.0316696166992, 0.628871269802205, -84.0280609130859, -1.4665663269997, 218, 50, 'PPL', 'P'),
(97208, 'Powell', 32.1175003051758, 0.560556127835601, -96.3236083984375, -1.6811641139544, 218, 51, 'PPL', 'P'),
(110975, 'Powell', 39.4052810668945, 0.687751897291094, -80.1244430541992, -1.39843534262248, 218, 58, 'PPL', 'P'),
(140735, 'Powell', 47.9197196960449, 0.83635688532876, -97.1774978637695, -1.69606729657253, 218, 34, 'PPL', 'P'),
(142734, 'Powell', 40.2208290100098, 0.701985894106322, -97.2844390869141, -1.69793377302252, 218, 35, 'PPL', 'P'),
(157237, 'Powell', 40.1577796936035, 0.700885475943901, -83.0752792358398, -1.44993714967908, 218, 41, 'PPL', 'P'),
(166185, 'Powell', 41.5233306884766, 0.72471883690832, -75.5899963378906, -1.31929431766665, 218, 45, 'PPL', 'P'),
(175942, 'Powell', 46.0886116027832, 0.804398020141428, -89.9583282470703, -1.5700690175012, 218, 57, 'PPL', 'P'),
(178915, 'Powell', 34.7372207641602, 0.606278875326735, -114.376106262207, -1.99623963988642, 218, 5, 'PPL', 'P'),
(193255, 'Powell', 48.7052803039551, 0.850067504410761, -118.019721984863, -2.0598327309242, 218, 56, 'PPL', 'P'),
(202508, 'Powell', 44.0441703796387, 0.768715789434056, -101.490280151367, -1.77133954741281, 218, 49, 'PPL', 'P'),
(209675, 'Powell', 44.7538909912109, 0.781102750875259, -108.75666809082, -1.89816194168347, 218, 59, 'PPL', 'P'),
(24110, 'Powell (historical)', 33.0369415283203, 0.576603404458037, -84.1655578613281, -1.46896610145797, 218, 13, 'PPL', 'P'),
(105430, 'Powell (historical)', 36.5491714477539, 0.637903380639208, -79.5036087036133, -1.38759973909527, 218, 53, 'PPL', 'P'),
(201431, 'Powell Butte', 44.2477798461914, 0.77226944501363, -121.016387939453, -2.11213441841421, 218, 43, 'PPL', 'P'),
(90108, 'Powell Chapel', 35.2319412231445, 0.61491337621299, -86.9791717529297, -1.51807292774627, 218, 50, 'PPL', 'P'),
(105431, 'Powell Corner', 37.8908309936523, 0.661319757155948, -78.5988922119141, -1.37180945751803, 218, 53, 'PPL', 'P'),
(110976, 'Powell Creek', 38.0133285522461, 0.663457742879064, -81.8255615234375, -1.42812546087717, 218, 58, 'PPL', 'P'),
(97209, 'Powell Crossing', 32.6177787780762, 0.569287634364562, -97.9049987792969, -1.70876458285976, 218, 51, 'PPL', 'P'),
(67960, 'Powell Crossroads', 36.3419418334961, 0.634286541562772, -76.6569366455078, -1.33791593895681, 218, 33, 'PPL', 'P'),
(90109, 'Powell Heights', 36.0391693115234, 0.629002164169782, -84.0302810668945, -1.46660507599356, 218, 50, 'PPL', 'P'),
(195496, 'Powell Junction', 46.5791702270508, 0.812959883308951, -114.717781066895, -2.00220299019932, 218, 17, 'PPL', 'P'),
(42682, 'Powell Park', 31.1538906097412, 0.543737965946128, -93.2547225952148, -1.62760195232045, 218, 22, 'PPL', 'P'),
(97210, 'Powell Point', 29.4791698455811, 0.514508574560018, -96.0224990844727, -1.67590876501729, 218, 51, 'PPL', 'P'),
(42679, 'Powell Ridge', 30.6049995422363, 0.534158009583381, -91.9113922119141, -1.60415641418977, 218, 22, 'PPL', 'P'),
(24112, 'Powell Station', 34.0061111450195, 0.59351860527973, -84.5224990844727, -1.47519590103794, 218, 13, 'PPL', 'P'),
(37786, 'Powell Valley', 37.8650016784668, 0.660868950562425, -83.9477767944336, -1.46516510479216, 218, 21, 'PPL', 'P'),
(90110, 'Powell Valley', 36.5055618286133, 0.637142249199664, -83.7916717529297, -1.46244055783895, 218, 50, 'PPL', 'P'),
(201432, 'Powell Valley', 45.4866714477539, 0.793892182536202, -122.392219543457, -2.13614720985708, 218, 43, 'PPL', 'P'),
(201433, 'Powellhurst', 45.5041694641113, 0.794197580534206, -122.536392211914, -2.13866349761304, 218, 43, 'PPL', 'P'),
(105432, 'Powells Corner', 36.813060760498, 0.642509118007419, -76.0980606079102, -1.32816171199023, 218, 53, 'PPL', 'P'),
(67961, 'Powells Crossing', 34.3338890075684, 0.599239408196356, -78.8605575561523, -1.37637637931335, 218, 33, 'PPL', 'P'),
(5203, 'Powells Crossroads', 34.5338897705078, 0.60273008001615, -85.8886108398438, -1.49903904911937, 218, 2, 'PPL', 'P'),
(90111, 'Powells Crossroads', 35.1894416809082, 0.614171619270376, -85.4858322143555, -1.49200923594794, 218, 50, 'PPL', 'P'),
(105433, 'Powells Crossroads', 36.832218170166, 0.642843477882278, -76.1408309936523, -1.32890819604378, 218, 53, 'PPL', 'P'),
(105434, 'Powells Grove', 39.089168548584, 0.682234693039804, -77.7830581665039, -1.35757046727576, 218, 53, 'PPL', 'P'),
(67962, 'Powells Point', 36.1572189331055, 0.631062518747122, -75.8591690063477, -1.3239922669876, 218, 33, 'PPL', 'P'),
(90112, 'Powells River (historical)', 36.3747215270996, 0.634858655143948, -83.9694366455078, -1.46554314050889, 218, 50, 'PPL', 'P'),
(105435, 'Powells Store', 37.5305595397949, 0.655031834085189, -79.413330078125, -1.38602407983633, 218, 53, 'PPL', 'P'),
(166186, 'Powells Valley', 40.4333305358887, 0.705694745398421, -76.9333267211914, -1.34273985579732, 218, 45, 'PPL', 'P'),
(67963, 'Powellsville', 36.2255592346191, 0.632255282020341, -76.9333267211914, -1.34273985579732, 218, 33, 'PPL', 'P'),
(73972, 'Powellsville', 38.6666717529297, 0.67486073287651, -82.7836074829102, -1.4448465172554, 218, 41, 'PPL', 'P'),
(105436, 'Powellton', 36.6666717529297, 0.639954147836624, -77.7925033569336, -1.35773531694723, 218, 53, 'PPL', 'P'),
(110977, 'Powellton', 38.0988883972168, 0.664951043881298, -81.3241729736328, -1.41937457985128, 218, 58, 'PPL', 'P'),
(121102, 'Powellton', 40.535831451416, 0.707483723860681, -91.2686080932617, -1.59293771493976, 218, 18, 'PPL', 'P'),
(184271, 'Powellton', 39.9288902282715, 0.696890601150728, -121.571388244629, -2.1218210010891, 218, 6, 'PPL', 'P'),
(24113, 'Powelltown', 31.4094390869141, 0.548198128271252, -83.7847213745117, -1.4623192508513, 218, 13, 'PPL', 'P'),
(67964, 'Powelltown', 35.1327781677246, 0.613182654399575, -82.8099975585938, -1.44530711096593, 218, 33, 'PPL', 'P'),
(5204, 'Powellville', 33.9083290100098, 0.59181198507418, -87.0994415283203, -1.52017203131747, 218, 2, 'PPL', 'P'),
(50586, 'Powellville', 38.3286094665527, 0.668960432902413, -75.3758316040039, -1.31555643791867, 218, 25, 'PPL', 'P'),
(57013, 'Powellville', 37.8894386291504, 0.661295455811001, -92.0144424438477, -1.60595498003196, 218, 29, 'PPL', 'P'),
(14446, 'Powelton', 38.8869400024414, 0.678705139068094, -75.5755615234375, -1.31904238262753, 218, 10, 'PPL', 'P'),
(24114, 'Powelton', 33.4286117553711, 0.583439339502107, -82.8708267211914, -1.44636878013449, 218, 13, 'PPL', 'P'),
(166187, 'Powelton', 40.2216682434082, 0.702000541492317, -78.1738891601563, -1.36439175493383, 218, 45, 'PPL', 'P'),
(140736, 'Power', 46.5555610656738, 0.812547825709288, -97.2377777099609, -1.69711937836117, 218, 34, 'PPL', 'P'),
(177270, 'Power', 40.211109161377, 0.701816250744884, -80.6594390869141, -1.40777278487846, 218, 58, 'PPL', 'P'),
(197296, 'Power', 47.7158317565918, 0.832798369480196, -111.686111450195, -1.94929037355525, 218, 31, 'PPL', 'P'),
(201434, 'Power City', 45.9119415283203, 0.801314545652307, -119.302780151367, -2.0822263204243, 218, 43, 'PPL', 'P'),
(24115, 'Power Place', 32.1358299255371, 0.560876040061547, -84.9983291625977, -1.48350070258124, 218, 13, 'PPL', 'P'),
(197298, 'Power Plant (historical)', 47.7402801513672, 0.833225074465854, -108.902496337891, -1.90070712473726, 218, 31, 'PPL', 'P'),
(5205, 'Powers', 32.9655609130859, 0.575357577700098, -87.6558303833008, -1.52988284875828, 218, 2, 'PPL', 'P'),
(11359, 'Powers', 33.666389465332, 0.587589343428777, -93.7255630493164, -1.63581966849611, 218, 4, 'PPL', 'P'),
(61417, 'Powers', 31.6977806091309, 0.553230637204147, -89.0686111450195, -1.55454052465911, 218, 30, 'PPL', 'P'),
(67965, 'Powers', 34.6922187805176, 0.605493442542244, -78.9886093139648, -1.37861130410015, 218, 33, 'PPL', 'P'),
(76995, 'Powers', 35.4497184753418, 0.618714306299779, -97.9519424438477, -1.70958390436912, 218, 42, 'PPL', 'P'),
(90113, 'Powers', 35.2374992370605, 0.615010381855696, -89.4136123657227, -1.56056193188378, 218, 50, 'PPL', 'P'),
(123488, 'Powers', 40.3219413757324, 0.703750637802663, -85.0924987792969, -1.48514427244799, 218, 19, 'PPL', 'P'),
(132724, 'Powers', 45.689998626709, 0.797440911267759, -87.5258331298828, -1.52761396866759, 218, 27, 'PPL', 'P'),
(157238, 'Powers', 41.6780586242676, 0.727419348832687, -84.248893737793, -1.47042058688732, 218, 41, 'PPL', 'P'),
(197297, 'Powers', 45.7966690063477, 0.799302660606807, -111.158058166504, -1.94007410512886, 218, 31, 'PPL', 'P'),
(201435, 'Powers', 42.8836097717285, 0.748460185657077, -124.071937561035, -2.16546381976889, 218, 43, 'PPL', 'P'),
(208489, 'Powers', 46.5380592346191, 0.812242361132256, -118.151390075684, -2.06213077262883, 218, 56, 'PPL', 'P'),
(110978, 'Powers (historical)', 39.0961112976074, 0.682355866869402, -81.6575012207031, -1.42519225525256, 218, 58, 'PPL', 'P'),
(128591, 'Powers Corner', 46.6733283996582, 0.814603253438612, -67.8469390869141, -1.18415247446669, 218, 26, 'PPL', 'P'),
(151892, 'Powers Corner', 42.8594398498535, 0.748038340940408, -76.6647186279297, -1.3380517601724, 218, 40, 'PPL', 'P'),
(24116, 'Powers Ferry Vantage', 33.9025001525879, 0.591710252320539, -84.4491729736328, -1.4739161189761, 218, 13, 'PPL', 'P'),
(175943, 'Powers Lake', 42.5536117553711, 0.742700633746589, -88.2944412231445, -1.54102871055248, 218, 57, 'PPL', 'P'),
(198762, 'Powers Lake', 48.5627784729004, 0.847580378268736, -102.647499084473, -1.79153682796191, 218, 34, 'PPL', 'P'),
(24117, 'Powers Lane', 33.8813896179199, 0.591341803983726, -84.3977813720703, -1.47301916632096, 218, 13, 'PPL', 'P'),
(83130, 'Powers Shop (historical)', 34.6416702270508, 0.604611203852128, -82.1500015258789, -1.43378800714495, 218, 48, 'PPL', 'P'),
(37787, 'Powersburg', 36.7041702270508, 0.640608619674511, -84.9652786254883, -1.48292386188913, 218, 21, 'PPL', 'P'),
(57014, 'Powersite', 36.6555595397949, 0.639760203130239, -93.1211090087891, -1.62526995531192, 218, 29, 'PPL', 'P'),
(24118, 'Powersville', 32.603889465332, 0.569045220126338, -83.7927780151367, -1.46245986575685, 218, 13, 'PPL', 'P'),
(37788, 'Powersville', 38.6566696166992, 0.674686162667056, -84.1122207641602, -1.46803519349894, 218, 21, 'PPL', 'P'),
(117398, 'Powersville', 42.9363899230957, 0.749381373078135, -92.6869430541992, -1.61769232990427, 218, 16, 'PPL', 'P'),
(139403, 'Powersville', 40.5491714477539, 0.707716550718982, -93.3000030517578, -1.62839224537393, 218, 29, 'PPL', 'P'),
(121103, 'Powerton', 40.5380592346191, 0.707522606012597, -89.6788864135742, -1.56519183743888, 218, 18, 'PPL', 'P'),
(146105, 'Powerville', 40.9213905334473, 0.714212999303094, -74.4272232055664, -1.29900009805386, 218, 37, 'PPL', 'P'),
(5206, 'Powes Landing', 31.8158302307129, 0.555290991781487, -88.1816711425781, -1.53906050134886, 218, 2, 'PPL', 'P'),
(5207, 'Powhatan', 33.5905609130859, 0.586265885525062, -87.1086120605469, -1.52033208729899, 218, 2, 'PPL', 'P'),
(11362, 'Powhatan', 36.082218170166, 0.629753508492321, -91.1183319091797, -1.5903149007402, 218, 4, 'PPL', 'P'),
(42680, 'Powhatan', 31.8727798461914, 0.556284950079332, -93.2011108398438, -1.62666625067145, 218, 22, 'PPL', 'P'),
(50592, 'Powhatan', 39.3227806091309, 0.686311992668715, -76.7286071777344, -1.33916682572082, 218, 25, 'PPL', 'P'),
(67966, 'Powhatan', 35.6136093139648, 0.621574741047605, -78.4177780151367, -1.36864841846216, 218, 33, 'PPL', 'P'),
(105439, 'Powhatan', 37.5419387817383, 0.655230439323482, -77.9191665649414, -1.35994600696811, 218, 53, 'PPL', 'P'),
(110982, 'Powhatan', 37.4005584716797, 0.652762887415469, -81.4205627441406, -1.42105689871188, 218, 58, 'PPL', 'P'),
(50587, 'Powhatan Beach', 39.1380615234375, 0.683088036432092, -76.5650024414063, -1.33631138440004, 218, 25, 'PPL', 'P'),
(50588, 'Powhatan Hill', 39.3222198486328, 0.686302205551709, -76.7161102294922, -1.33894871282754, 218, 25, 'PPL', 'P'),
(105442, 'Powhatan Place', 37.1322212219238, 0.648079518901483, -76.4052810668945, -1.333523720529, 218, 53, 'PPL', 'P'),
(73973, 'Powhatan Point', 39.8600006103516, 0.695688250497584, -80.815559387207, -1.41049759814777, 218, 41, 'PPL', 'P'),
(50589, 'Powhatan Village', 39.1333312988281, 0.6830054784383, -76.5725021362305, -1.33644227876761, 218, 25, 'PPL', 'P'),
(33680, 'Powhattan', 39.7616691589355, 0.69397204291211, -95.6297225952148, -1.66905352205532, 218, 20, 'PPL', 'P'),
(157239, 'Powhattan', 40.0422210693359, 0.698868597471357, -83.6900024414063, -1.46066609360463, 218, 41, 'PPL', 'P'),
(5208, 'Powledge', 32.6269416809082, 0.569447557188021, -85.1544418334961, -1.4862253826925, 218, 2, 'PPL', 'P'),
(123489, 'Powley Corners', 40.4769401550293, 0.706455876837965, -87.5266723632813, -1.52762861605358, 218, 19, 'PPL', 'P'),
(151893, 'Powley Place', 43.311939239502, 0.755935945153038, -74.6533279418945, -1.30294637015714, 218, 40, 'PPL', 'P'),
(172421, 'Pownal', 42.7655601501465, 0.746399831079737, -73.2363891601563, -1.27821612311661, 218, 55, 'PPL', 'P'),
(197299, 'Pownal', 47.4124984741211, 0.827504204970201, -110.193893432617, -1.92324625599093, 218, 31, 'PPL', 'P'),
(128592, 'Pownal Center', 43.892219543457, 0.766063747041528, -70.1858291625977, -1.22497380712958, 218, 26, 'PPL', 'P'),
(172422, 'Pownal Center', 42.7963905334473, 0.746937922777987, -73.2236099243164, -1.27799308337532, 218, 55, 'PPL', 'P'),
(144344, 'Powwow River', 42.9091682434082, 0.748906265139665, -71.01611328125, -1.23946499872709, 218, 36, 'PPL', 'P'),
(166188, 'Powys', 41.3477783203125, 0.721654870074184, -77.0927810668945, -1.34552285913646, 218, 45, 'PPL', 'P'),
(175944, 'Poy Sippi', 44.1372184753418, 0.770339785066786, -88.9952774047852, -1.55326060943922, 218, 57, 'PPL', 'P'),
(42681, 'Poydras', 29.8691692352295, 0.521315347990151, -89.8888931274414, -1.56885714604716, 218, 22, 'PPL', 'P'),
(11360, 'Poyen', 34.3241691589355, 0.599069764834918, -92.6397171020508, -1.61686808154689, 218, 4, 'PPL', 'P'),
(17726, 'Poyner', 28.3022193908691, 0.49396691399245, -81.8563919067383, -1.42866355257542, 218, 12, 'PPL', 'P'),
(11361, 'Poyner (historical)', 35.6119384765625, 0.621545579433669, -93.3705596923828, -1.62962369106198, 218, 4, 'PPL', 'P'),
(67967, 'Poyners Hill (historical)', 36.2738914489746, 0.633098838295624, -75.79638671875, -1.32289650935709, 218, 33, 'PPL', 'P'),
(110979, 'Poynette', 39.3338890075684, 0.686505870796073, -81.1361083984375, -1.41609223380776, 218, 58, 'PPL', 'P'),
(175946, 'Poynette', 43.3902816772461, 0.757303278635712, -89.4027786254883, -1.56037284744638, 218, 57, 'PPL', 'P'),
(57015, 'Poynor', 36.5202789306641, 0.637399111086802, -90.9069366455078, -1.586625357366, 218, 29, 'PPL', 'P'),
(97211, 'Poynor', 32.0741691589355, 0.559799856665046, -95.5980606079102, -1.66850091612912, 218, 51, 'PPL', 'P'),
(166189, 'Poyntelle', 41.8205604553223, 0.729906474974713, -75.420280456543, -1.31633221674421, 218, 45, 'PPL', 'P'),
(175948, 'Poysippi', 44.0999984741211, 0.769690173497888, -89.9000015258789, -1.56905102417451, 218, 57, 'PPL', 'P'),
(105443, 'Poythress Estates', 36.5652809143066, 0.638184543871293, -77.8694381713867, -1.35907808276885, 218, 53, 'PPL', 'P'),
(157240, 'Poznan', 41.519718170166, 0.724655786569512, -81.6338882446289, -1.42478013107387, 218, 41, 'PPL', 'P'),
(178916, 'Pozo', 33.2769393920898, 0.580792157378568, -111.840560913086, -1.95198602521063, 218, 5, 'PPL', 'P'),
(184272, 'Pozo', 35.3036117553711, 0.616164262977001, -120.375556945801, -2.10094980762615, 218, 6, 'PPL', 'P'),
(175950, 'Praag', 44.378059387207, 0.77454325195234, -91.7505569458008, -1.60134930924278, 218, 57, 'PPL', 'P'),
(5209, 'Praco', 33.6136093139648, 0.586668156007719, -87.1125030517578, -1.52039999790678, 218, 2, 'PPL', 'P'),
(178917, 'Prado del Sol', 33.3147201538086, 0.581451556064472, -111.949996948242, -1.95389604434443, 218, 5, 'PPL', 'P'),
(192075, 'Prado Verde', 31.889720916748, 0.556580627539358, -106.613059997559, -1.86074892258366, 218, 51, 'PPL', 'P'),
(192076, 'Prado Verde Addition Number 1 Colonia', 31.8880004882813, 0.556550600398067, -106.612998962402, -1.86074785731922, 218, 51, 'PPL', 'P'),
(97212, 'Praesel', 30.6308307647705, 0.534608849466418, -97.0097198486328, -1.69313901779594, 218, 51, 'PPL', 'P'),
(11363, 'Prague', 34.2866706848145, 0.598415292997031, -92.2805633544922, -1.61059966613111, 218, 4, 'PPL', 'P'),
(76996, 'Prague', 35.4866714477539, 0.619359257336769, -96.6847229003906, -1.68746675099018, 218, 42, 'PPL', 'P'),
(142735, 'Prague', 41.3102798461914, 0.721000398236297, -96.8080596923828, -1.68961938409929, 218, 35, 'PPL', 'P'),
(97213, 'Praha', 29.6680603027344, 0.51780533496294, -97.0669403076172, -1.69413770320472, 218, 51, 'PPL', 'P'),
(5210, 'Prairie', 32.1538887023926, 0.561191225176558, -87.4400024414063, -1.52611594055442, 218, 2, 'PPL', 'P'),
(28310, 'Prairie', 38.1730613708496, 0.666245606487186, -89.9430618286133, -1.56980256823413, 218, 18, 'PPL', 'P'),
(30888, 'Prairie', 37.9213905334473, 0.661853121743264, -87.9819412231445, -1.53557455664, 218, 19, 'PPL', 'P'),
(112442, 'Prairie', 33.7966690063477, 0.589863150367487, -88.6675033569336, -1.54753987310162, 218, 30, 'PPL', 'P'),
(128594, 'Prairie', 45.4086112976074, 0.792529775901544, -69.0644378662109, -1.20540183680443, 218, 26, 'PPL', 'P'),
(177356, 'Prairie', 42.9847183227539, 0.75022486277439, -85.0341720581055, -1.4841262791213, 218, 27, 'PPL', 'P'),
(195498, 'Prairie', 43.5050010681152, 0.759305509722261, -115.573059082031, -2.01713040758338, 218, 17, 'PPL', 'P'),
(208490, 'Prairie', 48.6027793884277, 0.8482785259485, -122.233329772949, -2.13337406021398, 218, 56, 'PPL', 'P'),
(5211, 'Prairie Bluff', 32.1341705322266, 0.560847078184692, -87.4036102294922, -1.52548077663444, 218, 2, 'PPL', 'P'),
(11365, 'Prairie Center', 34.7811088562012, 0.607044867035269, -91.7022171020508, -1.60050561980944, 218, 4, 'PPL', 'P'),
(121105, 'Prairie Center', 41.4688911437988, 0.723768687610407, -88.934440612793, -1.5521988071126, 218, 18, 'PPL', 'P'),
(142736, 'Prairie Center', 40.8588905334473, 0.713122168520597, -99.0547180175781, -1.72883096904129, 218, 35, 'PPL', 'P'),
(208491, 'Prairie Center', 48.2080612182617, 0.841389394261656, -122.684997558594, -2.14125715019867, 218, 56, 'PPL', 'P'),
(33682, 'Prairie Center (historical)', 38.8622207641602, 0.678273706971501, -95.0194396972656, -1.65840207611749, 218, 20, 'PPL', 'P'),
(30889, 'Prairie City', 39.4455604553223, 0.688454905239847, -87.1133270263672, -1.52041437897667, 218, 19, 'PPL', 'P'),
(57017, 'Prairie City', 38.0788917541504, 0.664602036620443, -94.1744384765625, -1.64365402263285, 218, 29, 'PPL', 'P'),
(117403, 'Prairie City', 41.5994415283203, 0.726047221660051, -93.2350006103516, -1.62725773874956, 218, 16, 'PPL', 'P'),
(121106, 'Prairie City', 40.6211090087891, 0.708972098014899, -90.4619369506836, -1.57885864752095, 218, 18, 'PPL', 'P'),
(184274, 'Prairie City', 38.642219543457, 0.674433961311825, -121.154716491699, -2.11454870710042, 218, 6, 'PPL', 'P'),
(201436, 'Prairie City', 44.4633293151855, 0.776031492948503, -118.708892822266, -2.0718610311456, 218, 43, 'PPL', 'P'),
(202509, 'Prairie City', 45.5297203063965, 0.79464352685874, -102.803886413574, -1.79426630176314, 218, 49, 'PPL', 'P'),
(175951, 'Prairie Corners', 42.535831451416, 0.742390308900568, -90.533332824707, -1.580104740595, 218, 57, 'PPL', 'P'),
(11368, 'Prairie Creek', 35.0522193908691, 0.611776638502068, -94.3499984741211, -1.64671812262504, 218, 4, 'PPL', 'P'),
(30890, 'Prairie Creek', 39.2750015258789, 0.685478090352384, -87.4972229003906, -1.5271146259632, 218, 19, 'PPL', 'P'),
(90114, 'Prairie Creek', 35.1952781677246, 0.614273485182071, -85.1372222900391, -1.48592484496349, 218, 50, 'PPL', 'P'),
(197301, 'Prairie Dale (historical)', 45.6972198486328, 0.797566945366347, -104.502777099609, -1.82391753786591, 218, 31, 'PPL', 'P'),
(112596, 'Prairie Dell', 30.8838901519775, 0.53902556897626, -97.5800018310547, -1.703092316054, 218, 51, 'PPL', 'P'),
(175957, 'Prairie du Chien', 43.0516700744629, 0.75139339128169, -91.14111328125, -1.59071251069095, 218, 57, 'PPL', 'P'),
(28314, 'Prairie du Rocher', 38.0830612182617, 0.66467480749723, -90.095832824707, -1.57246892511752, 218, 18, 'PPL', 'P'),
(175960, 'Prairie du Sac', 43.2869415283203, 0.755499652787456, -89.7238922119141, -1.5659773368024, 218, 57, 'PPL', 'P'),
(197302, 'Prairie Elk (historical)', 47.7833290100098, 0.833976418788393, -105.862503051758, -1.84764923265572, 218, 31, 'PPL', 'P'),
(175952, 'Prairie Farm', 45.2372207641602, 0.78953844678614, -91.9813919067383, -1.60537813933985, 218, 57, 'PPL', 'P'),
(11371, 'Prairie Grove', 33.4225006103516, 0.583332679900449, -91.7624969482422, -1.60155770159807, 218, 4, 'PPL', 'P'),
(97215, 'Prairie Grove', 31.5708293914795, 0.551014920466715, -96.4227828979492, -1.68289503550489, 218, 51, 'PPL', 'P'),
(117405, 'Prairie Grove', 40.8791694641113, 0.713476102629469, -91.2522201538086, -1.59265169143869, 218, 16, 'PPL', 'P'),
(121113, 'Prairie Grove', 42.2786102294922, 0.737900951671994, -88.2608337402344, -1.54044214932239, 218, 18, 'PPL', 'P'),
(28312, 'Prairie Hall', 39.7547187805176, 0.693850735924457, -88.7855606079102, -1.54960036083701, 218, 18, 'PPL', 'P'),
(57018, 'Prairie Hill', 39.5186080932617, 0.689729827032695, -92.7377777099609, -1.61857956202143, 218, 29, 'PPL', 'P'),
(76997, 'Prairie Hill', 34.5938911437988, 0.603777301535797, -99.5438919067383, -1.73736866402192, 218, 42, 'PPL', 'P'),
(97217, 'Prairie Hill', 30.2486095428467, 0.527937830672851, -96.3769378662109, -1.68209488875538, 218, 51, 'PPL', 'P'),
(61418, 'Prairie Hill (historical)', 33.4055595397949, 0.583037002440423, -88.5861129760742, -1.54611934297617, 218, 30, 'PPL', 'P'),
(57019, 'Prairie Home', 38.813060760498, 0.677415703047305, -92.5902786254883, -1.6160052173537, 218, 29, 'PPL', 'P'),
(142741, 'Prairie Home', 40.8647193908691, 0.713223901274238, -96.5205612182617, -1.68460158913142, 218, 35, 'PPL', 'P'),
(42683, 'Prairie Home (historical)', 31.8113899230957, 0.555213493793766, -92.6333312988281, -1.61675662825527, 218, 22, 'PPL', 'P'),
(17728, 'Prairie Junction', 27.913330078125, 0.487179515059247, -81.9836120605469, -1.43088396313428, 218, 12, 'PPL', 'P'),
(198766, 'Prairie Junction', 47.9913902282715, 0.83760777209277, -101.902221679688, -1.77852928340769, 218, 34, 'PPL', 'P'),
(11372, 'Prairie Landing', 34.0802803039551, 0.59481310130659, -91.1883316040039, -1.59153662589027, 218, 4, 'PPL', 'P'),
(42684, 'Prairie Laurent', 30.4850006103516, 0.532063633123116, -92.0411071777344, -1.60642036743245, 218, 22, 'PPL', 'P'),
(97218, 'Prairie Lea', 29.7322196960449, 0.518925127622292, -97.7533264160156, -1.70611740073622, 218, 51, 'PPL', 'P'),
(197303, 'Prairie Mobile Village', 46.6311111450195, 0.813866423344014, -111.933326721191, -1.95360509399534, 218, 31, 'PPL', 'P'),
(61419, 'Prairie Mount (historical)', 34.0472183227539, 0.594236060877397, -88.8249969482422, -1.55028865482074, 218, 30, 'PPL', 'P'),
(97219, 'Prairie Mountain', 30.5605602264404, 0.533382397205409, -98.8791732788086, -1.72576713536521, 218, 51, 'PPL', 'P'),
(90116, 'Prairie Peninsula', 35.1930618286133, 0.614234802767238, -85.1474990844727, -1.48610420886291, 218, 50, 'PPL', 'P'),
(199622, 'Prairie Pines Retirement Community', 42.8319396972656, 0.747558372732948, -103.005828857422, -1.7977908623078, 218, 35, 'PPL', 'P'),
(90115, 'Prairie Plains', 35.3436088562012, 0.616862344077738, -85.9661102294922, -1.50039166863702, 218, 50, 'PPL', 'P'),
(61420, 'Prairie Point', 33.1472206115723, 0.578528137556865, -88.3936080932617, -1.54275949894492, 218, 30, 'PPL', 'P'),
(97226, 'Prairie Point', 33.4952812194824, 0.58460294116139, -97.4741668701172, -1.70124514752192, 218, 51, 'PPL', 'P'),
(137571, 'Prairie Portage', 48.0508308410645, 0.838645206495411, -91.438606262207, -1.59590474271022, 218, 28, 'PPL', 'P'),
(171119, 'Prairie Queen (historical)', 44.1319389343262, 0.770247639693069, -97.0072174072266, -1.69309534195406, 218, 49, 'PPL', 'P'),
(57021, 'Prairie Ridge', 39.5552787780762, 0.690369851221669, -94.133056640625, -1.64293177334522, 218, 29, 'PPL', 'P'),
(208492, 'Prairie Ridge', 47.1377792358398, 0.822709449743622, -122.147499084473, -2.13187603210081, 218, 56, 'PPL', 'P'),
(42685, 'Prairie Ronde', 30.5766696929932, 0.533663560437494, -92.1883316040039, -1.60898991841021, 218, 22, 'PPL', 'P'),
(140738, 'Prairie Rose', 46.8175010681152, 0.817119541194573, -96.8352813720703, -1.69009449203776, 218, 34, 'PPL', 'P'),
(121114, 'Prairie Shores', 41.8408317565918, 0.73026027592553, -87.6166687011719, -1.52919934846451, 218, 18, 'PPL', 'P'),
(11373, 'Prairie Union', 34.2388916015625, 0.5975813906807, -91.2986068725586, -1.59346129241007, 218, 4, 'PPL', 'P'),
(97222, 'Prairie Valley', 31.8769397735596, 0.55635755450855, -97.3280563354492, -1.69869503762012, 218, 51, 'PPL', 'P'),
(505, 'Prairie View', 39.8325004577637, 0.695208282290125, -99.5722198486328, -1.73786307987829, 218, 20, 'PPL', 'P'),
(11374, 'Prairie View', 35.3344383239746, 0.616702288096224, -93.5177764892578, -1.63219310888169, 218, 4, 'PPL', 'P'),
(97223, 'Prairie View', 30.0930595397949, 0.525222970968111, -95.9875030517578, -1.67529796902128, 218, 51, 'PPL', 'P'),
(121116, 'Prairie View', 42.1991691589355, 0.736514443429472, -87.9555587768555, -1.53511409608752, 218, 18, 'PPL', 'P'),
(117407, 'Prairie View Acres Mobile Home Park', 42.4833297729492, 0.741473981748499, -92.220832824707, -1.6095571717224, 218, 16, 'PPL', 'P'),
(142743, 'Prairie View Estates', 40.6994400024414, 0.710339231760492, -99.0811080932617, -1.72929156275182, 218, 35, 'PPL', 'P'),
(175956, 'Prairie View Heights', 43.2174987792969, 0.754287648175361, -89.2130584716797, -1.55706160610503, 218, 57, 'PPL', 'P'),
(171120, 'Prairie Villa Mobile Court', 44.3291702270508, 0.773689975139078, -98.2527770996094, -1.71483445961627, 218, 49, 'PPL', 'P'),
(33685, 'Prairie Village', 38.9916687011719, 0.68053299968227, -94.6333312988281, -1.65166321329515, 218, 20, 'PPL', 'P'),
(37789, 'Prairie Village', 38.1130599975586, 0.665198384967539, -85.8363876342773, -1.49812758223629, 218, 21, 'PPL', 'P'),
(171121, 'Prairie Village', 44.0061111450195, 0.768051530479163, -97.1672210693359, -1.69588793267312, 218, 49, 'PPL', 'P'),
(117408, 'Prairie Village Mobile Home Park', 41.5200004577637, 0.724660713417529, -93.9194412231445, -1.63920348097716, 218, 16, 'PPL', 'P'),
(171122, 'Prairie Wood Village Addition', 45.5111083984375, 0.794318687784778, -98.4263916015625, -1.71786460430456, 218, 49, 'PPL', 'P'),
(117415, 'Prairiebell', 41.6144409179688, 0.726309010395206, -93.3097229003906, -1.62856188873537, 218, 16, 'PPL', 'P'),
(117416, 'Prairieburg', 42.2383308410645, 0.73719794372324, -91.4222183227539, -1.59561871920914, 218, 16, 'PPL', 'P'),
(42687, 'Prairieland', 30.1100006103516, 0.525518648428137, -93.2130584716797, -1.6268747761848, 218, 22, 'PPL', 'P'),
(112320, 'Prairieton', 39.3699989318848, 0.68713610786804, -87.4744415283203, -1.52671701601245, 218, 19, 'PPL', 'P'),
(28318, 'Prairietown', 38.9663887023926, 0.680091780468671, -89.9219436645508, -1.56943398673927, 218, 18, 'PPL', 'P'),
(110980, 'Prairietown', 38.3466682434082, 0.669275618017424, -82.1752777099609, -1.43422915977952, 218, 58, 'PPL', 'P'),
(189277, 'Prairieview', 33.0966682434082, 0.577645832287721, -103.196937561035, -1.80112633841507, 218, 38, 'PPL', 'P'),
(57032, 'Prairieview (historical)', 38.9025001525879, 0.678976714920255, -91.1941680908203, -1.59163849180197, 218, 29, 'PPL', 'P'),
(121118, 'Prairieview Estates', 41.9397201538086, 0.731986204048983, -89.1388931274414, -1.5557671766572, 218, 18, 'PPL', 'P'),
(5213, 'Prairieville', 32.5099983215332, 0.567406510528585, -87.6944427490234, -1.53055676167213, 218, 2, 'PPL', 'P'),
(42686, 'Prairieville', 30.3027801513672, 0.528883286149343, -90.9719390869141, -1.58775986399037, 218, 22, 'PPL', 'P'),
(97224, 'Prairieville', 32.4797210693359, 0.566878072789286, -96.102783203125, -1.67730998722483, 218, 51, 'PPL', 'P'),
(121119, 'Prairieville', 41.8413887023926, 0.730269996463508, -89.6119384765625, -1.56402337551061, 218, 18, 'PPL', 'P'),
(132726, 'Prairieville', 42.5047187805176, 0.741847290354301, -85.4550018310547, -1.49147114424969, 218, 27, 'PPL', 'P'),
(137573, 'Prairieville', 44.2838897705078, 0.772899682085597, -93.1919403076172, -1.62650619468994, 218, 28, 'PPL', 'P'),
(61421, 'Praise Acres', 34.1972198486328, 0.596854081386999, -88.8188934326172, -1.55018212837714, 218, 30, 'PPL', 'P'),
(97225, 'Pralle Colonia', 26.382999420166, 0.460470206433652, -98.1449966430664, -1.71295333578029, 218, 51, 'PPL', 'P'),
(146106, 'Prallsville', 40.4116706848145, 0.705316709681684, -74.9869384765625, -1.30876897240644, 218, 37, 'PPL', 'P'),
(57034, 'Prankford', 39.4930610656738, 0.689283947287189, -91.3188934326172, -1.593815359677, 218, 29, 'PPL', 'P'),
(37790, 'Prater', 38.3388900756836, 0.669139863380857, -83.1519393920898, -1.45127512181074, 218, 21, 'PPL', 'P'),
(57035, 'Prater', 38.4494400024414, 0.671069323590619, -90.7597198486328, -1.58405593954629, 218, 29, 'PPL', 'P'),
(105445, 'Prater', 37.2130584716797, 0.64949039506798, -82.1969375610352, -1.43460719549626, 218, 53, 'PPL', 'P'),
(24119, 'Prater Mill', 34.8952789306641, 0.609037510741894, -84.9199981689453, -1.48213356883565, 218, 13, 'PPL', 'P'),
(24120, 'Pratersville', 34.6272201538086, 0.604359002496897, -84.9552764892578, -1.48274929167968, 218, 13, 'PPL', 'P'),
(24121, 'Prather', 33.8013916015625, 0.589945575203225, -82.8002777099609, -1.44513746760449, 218, 13, 'PPL', 'P'),
(30894, 'Prather', 39.378059387207, 0.687276789352623, -86.4552764892578, -1.50892923045959, 218, 19, 'PPL', 'P'),
(184275, 'Prather', 37.0374984741211, 0.646426295075789, -119.513061523438, -2.08589642272253, 218, 6, 'PPL', 'P'),
(57038, 'Prathersville', 39.3125, 0.686132562190271, -94.272216796875, -1.64536057625937, 218, 29, 'PPL', 'P'),
(50590, 'Prathertown', 39.1969413757324, 0.684115683717727, -77.1988906860352, -1.3473748213585, 218, 25, 'PPL', 'P'),
(11392, 'Pratt', 36.288330078125, 0.633350839913772, -90.2658309936523, -1.57543595288798, 218, 4, 'PPL', 'P'),
(33693, 'Pratt', 37.6438903808594, 0.657009830405818, -98.7372207641602, -1.72328959660311, 218, 20, 'PPL', 'P'),
(37791, 'Pratt', 37.6150016784668, 0.656505627432439, -87.5688934326172, -1.52836551272721, 218, 21, 'PPL', 'P'),
(42688, 'Pratt', 32.4913902282715, 0.567081738033649, -92.9891662597656, -1.62296711991733, 218, 22, 'PPL', 'P'),
(50591, 'Pratt', 39.690559387207, 0.692730943265106, -78.5066680908203, -1.37019984295519, 218, 25, 'PPL', 'P'),
(57037, 'Pratt', 36.5299987792969, 0.63756875444824, -90.8311080932617, -1.58530189946229, 218, 29, 'PPL', 'P'),
(110981, 'Pratt', 38.2099990844727, 0.666890291208067, -81.3841705322266, -1.4204217347919, 218, 58, 'PPL', 'P'),
(137575, 'Pratt', 44.0224990844727, 0.768337553980237, -93.1591720581055, -1.62593428084584, 218, 28, 'PPL', 'P'),
(144345, 'Pratt', 42.7836112976074, 0.746714883036693, -71.7636108398438, -1.25251129227517, 218, 36, 'PPL', 'P'),
(121120, 'Pratt (historical)', 41.6911087036133, 0.727647115684916, -89.9972229003906, -1.57074785726306, 218, 18, 'PPL', 'P'),
(5214, 'Pratt City', 33.5400009155273, 0.585383447097865, -86.8688888549805, -1.51614812806842, 218, 2, 'PPL', 'P'),
(125882, 'Pratt Corner', 42.4174995422363, 0.740325027475211, -72.4749984741211, -1.26492734875128, 218, 23, 'PPL', 'P'),
(128595, 'Pratt Corner', 44.1583290100098, 0.770708233403599, -70.4408264160156, -1.22942434878527, 218, 26, 'PPL', 'P'),
(151894, 'Pratt Corners', 42.6875, 0.745037424445079, -76.1691665649414, -1.32940274505821, 218, 40, 'PPL', 'P'),
(125881, 'Pratt Junction', 42.4686088562012, 0.741217053282334, -71.7416687011719, -1.25212832971041, 218, 23, 'PPL', 'P'),
(175963, 'Pratt Junction', 45.4824981689453, 0.793819345080388, -89.164436340332, -1.55621298982368, 218, 57, 'PPL', 'P'),
(184277, 'Pratt Place', 39.9130592346191, 0.696614298187632, -123.720558166504, -2.15933109241065, 218, 6, 'PPL', 'P'),
(151895, 'Prattham', 43.4561080932617, 0.758452166329972, -76.1802825927734, -1.32959675634362, 218, 40, 'PPL', 'P'),
(184276, 'Pratton', 36.7466697692871, 0.641350376617125, -119.898612976074, -2.09262556500689, 218, 6, 'PPL', 'P'),
(714, 'Pratts', 34.4799995422363, 0.601789518098162, -88.5852813720703, -1.54610482874823, 218, 30, 'PPL', 'P'),
(5216, 'Pratts', 31.8308296203613, 0.555552780516642, -85.5097198486328, -1.49242615381659, 218, 2, 'PPL', 'P'),
(105446, 'Pratts', 38.3474998474121, 0.669290132245364, -78.2702789306641, -1.36607407379443, 218, 53, 'PPL', 'P'),
(151896, 'Pratts', 42.9213905334473, 0.74911958434298, -75.5905609130859, -1.31930417136268, 218, 40, 'PPL', 'P'),
(157242, 'Pratts', 40.9225006103516, 0.714232373800024, -83.5044403076172, -1.45742742340299, 218, 41, 'PPL', 'P'),
(113948, 'Pratts Corner', 41.5580596923828, 0.725324972372422, -72.853889465332, -1.27154024405406, 218, 8, 'PPL', 'P'),
(125883, 'Pratts Corner', 42.017219543457, 0.733338823566634, -71.0950012207031, -1.24084185301066, 218, 23, 'PPL', 'P'),
(73975, 'Pratts Fork', 39.1922187805176, 0.684033258881989, -82.017219543457, -1.43147052436437, 218, 41, 'PPL', 'P'),
(151897, 'Pratts Hollow', 42.922779083252, 0.7491438191089, -75.6030578613281, -1.31952228425596, 218, 40, 'PPL', 'P'),
(24122, 'Prattsburg', 32.7125015258789, 0.570940858190256, -84.357780456543, -1.4723210186412, 218, 13, 'PPL', 'P'),
(30895, 'Prattsburg', 39.1616706848145, 0.683500094031755, -85.1880569458008, -1.48681207708065, 218, 19, 'PPL', 'P'),
(151898, 'Prattsburg', 42.5238914489746, 0.742181916545269, -77.2891693115234, -1.34895048061744, 218, 40, 'PPL', 'P'),
(11393, 'Prattsville', 34.3147201538086, 0.598904848584415, -92.5533294677734, -1.61536033289574, 218, 4, 'PPL', 'P'),
(73979, 'Prattsville', 39.2386093139648, 0.6848429264324, -82.3913879394531, -1.4380009948314, 218, 41, 'PPL', 'P'),
(151900, 'Prattsville', 42.3147201538086, 0.738531188743961, -74.4333267211914, -1.29910662449747, 218, 40, 'PPL', 'P'),
(192751, 'Prattsville', 38.774169921875, 0.676736929864471, -112.013893127441, -1.9550112430509, 218, 52, 'PPL', 'P'),
(5217, 'Prattville', 32.4638900756836, 0.56660176982619, -86.459716796875, -1.50900672844731, 218, 2, 'PPL', 'P'),
(77001, 'Prattville', 36.1044387817383, 0.630141331326063, -96.1183319091797, -1.67758136333991, 218, 42, 'PPL', 'P'),
(97227, 'Prattville', 33.4238891601563, 0.583356914666369, -95.5891723632813, -1.66834578699563, 218, 51, 'PPL', 'P'),
(125884, 'Prattville', 41.9388885498047, 0.731971689821042, -71.0805587768555, -1.24058978481348, 218, 23, 'PPL', 'P'),
(132728, 'Prattville', 41.7822189331055, 0.729237289171803, -84.3997192382813, -1.47305298846681, 218, 27, 'PPL', 'P'),
(166190, 'Prattville', 41.8466682434082, 0.730362141837225, -76.1319427490234, -1.32875306691028, 218, 45, 'PPL', 'P'),
(193890, 'Prattville', 40.2088890075684, 0.701777501751023, -121.155563354492, -2.11456348764447, 218, 6, 'PPL', 'P'),
(5218, 'Prattville Junction', 32.4672203063965, 0.566659893316981, -86.3427810668945, -1.50696581494593, 218, 2, 'PPL', 'P'),
(201437, 'Pratum', 44.959171295166, 0.78468556806877, -122.877502441406, -2.14461699422991, 218, 43, 'PPL', 'P'),
(157243, 'Pravo', 40.5191688537598, 0.707192906669645, -80.8327789306641, -1.41079813587679, 218, 41, 'PPL', 'P'),
(97228, 'Praxedis Saldivar Colonia', 25.9629993438721, 0.453139822243695, -97.4400024414063, -1.70064886575385, 218, 51, 'PPL', 'P'),
(175964, 'Pray', 44.3733291625977, 0.774460693958547, -90.4972229003906, -1.57947450352303, 218, 57, 'PPL', 'P'),
(197304, 'Pray', 45.3802795410156, 0.792035293466144, -110.68083190918, -1.93174493566159, 218, 31, 'PPL', 'P'),
(151902, 'Pre-emption', 42.8777809143066, 0.748358452903436, -77.0166702270508, -1.34419447438472, 218, 40, 'PPL', 'P'),
(37794, 'Preachersville', 37.5272216796875, 0.654973577436344, -84.5338897705078, -1.47539470601332, 218, 21, 'PPL', 'P'),
(146107, 'Preakness', 40.9302787780762, 0.714368128436591, -74.2280578613281, -1.29552400704104, 218, 37, 'PPL', 'P'),
(97229, 'Preble', 32.7808303833008, 0.572133421726393, -97.9611129760742, -1.70974396035064, 218, 51, 'PPL', 'P'),
(123496, 'Preble', 40.832218170166, 0.712656647962051, -85.0147171020508, -1.48378672608232, 218, 19, 'PPL', 'P'),
(151903, 'Preble', 42.735279083252, 0.74587132676141, -76.1486129760742, -1.32904401725937, 218, 40, 'PPL', 'P'),
(175965, 'Preble', 44.497501373291, 0.776627907874627, -87.9697189331055, -1.53536123743668, 218, 57, 'PPL', 'P'),
(200140, 'Preble', 40.9766693115234, 0.715177795987002, -117.397216796875, -2.04896796578306, 218, 39, 'PPL', 'P'),
(128596, 'Preble Corner', 45.0455589294434, 0.786193316719919, -69.2141723632813, -1.20801519678212, 218, 26, 'PPL', 'P'),
(142810, 'Precept', 40.0677795410156, 0.699314676953945, -99.732780456543, -1.74066539113533, 218, 35, 'PPL', 'P'),
(57039, 'Precinct', 37.5519409179688, 0.655405009532937, -90.0202789306641, -1.57115026090377, 218, 29, 'PPL', 'P'),
(125885, 'Precinct', 41.8555603027344, 0.730517337549749, -70.9805603027344, -1.2388444821931, 218, 23, 'PPL', 'P'),
(137577, 'Predmore', 43.938060760498, 0.766863827212015, -92.32861328125, -1.61143829555838, 218, 28, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(117417, 'Predonia (historical)', 42.0550003051758, 0.733998222252538, -92.8041687011719, -1.61973830341172, 218, 16, 'PPL', 'P'),
(121121, 'Preemption', 41.3127784729004, 0.721044007499147, -90.5844421386719, -1.58099676640212, 218, 18, 'PPL', 'P'),
(50593, 'Preference Estates', 38.4861106872559, 0.671709347779592, -76.9933319091797, -1.343787143896, 218, 25, 'PPL', 'P'),
(83132, 'Pregnall', 33.1561088562012, 0.578683266690362, -80.4647216796875, -1.40437432501141, 218, 48, 'PPL', 'P'),
(97231, 'Preiss Heights', 29.7402801513672, 0.519065809106875, -98.1188888549805, -1.71249766891778, 218, 51, 'PPL', 'P'),
(166191, 'Preisser Crossing', 40.5516700744629, 0.707760159981832, -78.8150024414063, -1.37558129256991, 218, 45, 'PPL', 'P'),
(183, 'Premier', 37.4222183227539, 0.653140923132206, -81.6438903808594, -1.42495470128332, 218, 58, 'PPL', 'P'),
(37792, 'Premier', 36.5955581665039, 0.638712981610592, -83.7638931274414, -1.4619557293625, 218, 21, 'PPL', 'P'),
(105447, 'Premier', 37.1152801513672, 0.647783841441457, -81.8694381713867, -1.42889125284862, 218, 53, 'PPL', 'P'),
(97230, 'Premont', 27.360279083252, 0.477526954267282, -98.1233291625977, -1.7125751669055, 218, 51, 'PPL', 'P'),
(184278, 'Prenda', 33.9213905334473, 0.59203995166349, -117.387496948242, -2.04879832242162, 218, 6, 'PPL', 'P'),
(151910, 'Prendergast Point', 42.1922187805176, 0.736393136441818, -79.4486083984375, -1.38663980268035, 218, 40, 'PPL', 'P'),
(110983, 'Prenter', 38.0144386291504, 0.663477117375994, -81.6272201538086, -1.42466375093423, 218, 58, 'PPL', 'P'),
(28341, 'Prentice', 39.8569412231445, 0.695634854117728, -90.0436096191406, -1.57155745823444, 218, 18, 'PPL', 'P'),
(175967, 'Prentice', 45.5461082458496, 0.794929550359815, -90.2863922119141, -1.57579481384487, 218, 57, 'PPL', 'P'),
(157244, 'Prentice (historical)', 41.6158294677734, 0.726333245161126, -83.5227813720703, -1.45774753536601, 218, 41, 'PPL', 'P'),
(125886, 'Prentice Corner', 42.1094398498535, 0.73494837155045, -71.6961135864258, -1.25133324296697, 218, 23, 'PPL', 'P'),
(24130, 'Prentiss', 31.7938899993896, 0.554908062506247, -82.3958282470703, -1.43807849281912, 218, 13, 'PPL', 'P'),
(37793, 'Prentiss', 37.3347206115723, 0.651613799984127, -86.8405609130859, -1.51565371221204, 218, 21, 'PPL', 'P'),
(61422, 'Prentiss', 31.5983295440674, 0.551494888674175, -89.866943359375, -1.56847405032435, 218, 30, 'PPL', 'P'),
(67969, 'Prentiss', 35.1211090087891, 0.612978989155211, -83.3791732788086, -1.45524110130609, 218, 33, 'PPL', 'P'),
(77002, 'Prentiss', 35.3638916015625, 0.617216344765636, -99.8052825927734, -1.74193079212728, 218, 42, 'PPL', 'P'),
(128597, 'Prentiss', 45.4916687011719, 0.793979401061902, -68.0822219848633, -1.18825893570953, 218, 26, 'PPL', 'P'),
(157245, 'Prentiss', 41.1525001525879, 0.718246623090128, -84.0183334350586, -1.46639655048021, 218, 41, 'PPL', 'P'),
(61423, 'Prentiss (historical)', 33.7333297729492, 0.588757672198995, -91.1388931274414, -1.59067376169708, 218, 30, 'PPL', 'P'),
(105448, 'Prentiss Park', 36.8227806091309, 0.642678761368857, -76.3169403076172, -1.33198188341589, 218, 53, 'PPL', 'P'),
(166192, 'Prentisvale', 41.9333305358887, 0.731874684178336, -78.4391708374023, -1.36902179364699, 218, 45, 'PPL', 'P'),
(105449, 'Presbyterian Point', 36.5483283996582, 0.637888666674186, -78.3422164916992, -1.36732962109035, 218, 53, 'PPL', 'P'),
(90117, 'Presbytery Camp', 36.560001373291, 0.638092398497577, -82.1069412231445, -1.43303646308533, 218, 50, 'PPL', 'P'),
(5219, 'Prescott', 33.5683288574219, 0.585877862954238, -86.4458312988281, -1.50876438078812, 218, 2, 'PPL', 'P'),
(11394, 'Prescott', 33.8025016784668, 0.589964949700155, -93.3808288574219, -1.62980292180335, 218, 4, 'PPL', 'P'),
(30896, 'Prescott', 39.4791717529297, 0.689041533048964, -85.7083282470703, -1.49589252429144, 218, 19, 'PPL', 'P'),
(33692, 'Prescott', 38.0636100769043, 0.664335321037272, -94.6952819824219, -1.65274445669772, 218, 20, 'PPL', 'P'),
(67970, 'Prescott', 35.2463912963867, 0.615165577568221, -76.8525009155273, -1.34132917936791, 218, 33, 'PPL', 'P'),
(112420, 'Prescott', 37.436939239502, 0.653397851598371, -91.92138671875, -1.60433085124117, 218, 29, 'PPL', 'P'),
(117418, 'Prescott', 41.0230598449707, 0.715987463537413, -94.6133270263672, -1.65131407287624, 218, 16, 'PPL', 'P'),
(132729, 'Prescott', 44.1919403076172, 0.771294861212716, -83.9308319091797, -1.4648693607531, 218, 27, 'PPL', 'P'),
(166193, 'Prescott', 40.351390838623, 0.704264627893048, -76.3547210693359, -1.3326412821018, 218, 45, 'PPL', 'P'),
(175970, 'Prescott', 44.7488899230957, 0.781015465770532, -92.8019409179688, -1.6196994212598, 218, 57, 'PPL', 'P'),
(178918, 'Prescott', 34.5400009155273, 0.602836739617808, -112.467781066895, -1.96293308202945, 218, 5, 'PPL', 'P'),
(201438, 'Prescott', 46.0491714477539, 0.80370965957867, -122.886108398438, -2.14476719651539, 218, 43, 'PPL', 'P'),
(208493, 'Prescott', 46.2997207641602, 0.80808257008858, -118.313888549805, -2.06496690603171, 218, 56, 'PPL', 'P'),
(24123, 'Prescott (historical)', 30.9897193908691, 0.540872637639798, -81.9588928222656, -1.43045253103768, 218, 13, 'PPL', 'P'),
(125887, 'Prescott (historical)', 42.3916702270508, 0.739874220881688, -72.345832824707, -1.26267298288853, 218, 23, 'PPL', 'P'),
(125889, 'Prescott Center', 42.3916702270508, 0.739874220881688, -72.3455581665039, -1.26266818919857, 218, 23, 'PPL', 'P'),
(144346, 'Prescott Corner', 42.9444389343262, 0.749521854825637, -70.9349975585938, -1.2380492622916, 218, 36, 'PPL', 'P'),
(178919, 'Prescott Valley', 34.6100006103516, 0.604058464767882, -112.315002441406, -1.96026659198801, 218, 5, 'PPL', 'P'),
(166194, 'Prescottville', 41.086109161377, 0.717087881699834, -78.8605575561523, -1.37637637931335, 218, 45, 'PPL', 'P'),
(166195, 'Preserve', 41.0897216796875, 0.717150932038642, -75.5819396972656, -1.31915370276109, 218, 45, 'PPL', 'P'),
(177374, 'Presho', 42.0855598449707, 0.734531586839853, -77.1549987792969, -1.34660876307094, 218, 40, 'PPL', 'P'),
(202513, 'Presho', 43.9097213745117, 0.76636921161856, -100.058326721191, -1.74634724532101, 218, 49, 'PPL', 'P'),
(166196, 'President', 41.4577789306641, 0.723574742904022, -79.5583267211914, -1.38855474866217, 218, 45, 'PPL', 'P'),
(71310, 'Presidential Lake Estates', 39.916389465332, 0.696672421678423, -74.5652770996094, -1.30140959305011, 218, 37, 'PPL', 'P'),
(71311, 'Presidential Lakes Estates', 39.9136085510254, 0.696623885567556, -74.5650024414063, -1.30140479936015, 218, 37, 'PPL', 'P'),
(50594, 'Presidential Park', 39.4555587768555, 0.688629408870275, -76.9913864135742, -1.3437531885921, 218, 25, 'PPL', 'P'),
(192077, 'Presidio', 29.5605602264404, 0.515929104685466, -104.371673583984, -1.82162934985732, 218, 51, 'PPL', 'P'),
(24125, 'Presley', 34.9094390869141, 0.609284652091053, -83.725830078125, -1.46129140382858, 218, 13, 'PPL', 'P'),
(11398, 'Presley Junction', 35.1786117553711, 0.613982601412008, -90.1872177124023, -1.57406389229437, 218, 4, 'PPL', 'P'),
(90118, 'Presley Ridge', 35.4388885498047, 0.61852528844141, -88.2458267211914, -1.54018022742918, 218, 50, 'PPL', 'P'),
(105450, 'Presque Isle', 37.3555603027344, 0.651977521210005, -77.2686080932617, -1.34859161966055, 218, 53, 'PPL', 'P'),
(128600, 'Presque Isle', 46.6811103820801, 0.814739074654206, -68.0163879394531, -1.18710991485722, 218, 26, 'PPL', 'P'),
(132730, 'Presque Isle', 45.3041687011719, 0.790706908714412, -83.476936340332, -1.4569473886165, 218, 27, 'PPL', 'P'),
(175972, 'Presque Isle', 46.2472190856934, 0.807166242936511, -89.7291717529297, -1.56606948217612, 218, 57, 'PPL', 'P'),
(157246, 'Presque Isle (historical)', 41.5366706848145, 0.72495166376662, -83.7122192382813, -1.46105384985935, 218, 41, 'PPL', 'P'),
(128601, 'Presque Isle Junction', 46.7083282470703, 0.815214116013648, -68.0277786254883, -1.18730871983259, 218, 26, 'PPL', 'P'),
(42691, 'Presquille', 29.5636100769043, 0.515982334617754, -90.646110534668, -1.58207308295667, 218, 22, 'PPL', 'P'),
(37795, 'Press', 37.5275001525879, 0.654978437705333, -83.2716674804688, -1.45336477116007, 218, 21, 'PPL', 'P'),
(197305, 'Presserville (historical)', 47.8327789306641, 0.83483948271866, -105.488327026367, -1.84111862903063, 218, 31, 'PPL', 'P'),
(184280, 'Presswood', 39.1683311462402, 0.683616341013337, -123.204719543457, -2.15032801002953, 218, 6, 'PPL', 'P'),
(105452, 'Prestige Manor', 38.6327781677246, 0.674269178219377, -77.3913879394531, -1.35073453223169, 218, 53, 'PPL', 'P'),
(50595, 'Prestige Village', 39.6133308410645, 0.691383050858389, -75.9308319091797, -1.32524302059356, 218, 25, 'PPL', 'P'),
(166198, 'Presto', 40.3736114501953, 0.704652450726791, -80.1180572509766, -1.39832388933086, 218, 45, 'PPL', 'P'),
(5220, 'Preston', 34.5258293151855, 0.602589398531567, -86.1725006103516, -1.50399386032746, 218, 2, 'PPL', 'P'),
(11395, 'Preston', 35.0255584716797, 0.611311317680604, -92.4222183227539, -1.61307201172909, 218, 4, 'PPL', 'P'),
(24126, 'Preston', 32.0658302307129, 0.559654314911473, -84.5374984741211, -1.4754576897731, 218, 13, 'PPL', 'P'),
(28343, 'Preston', 38.1061096191406, 0.665077077979886, -89.8600006103516, -1.56835287649475, 218, 18, 'PPL', 'P'),
(30897, 'Preston', 39.5066719055176, 0.689521501256424, -87.371940612793, -1.52492803755019, 218, 19, 'PPL', 'P'),
(33694, 'Preston', 37.7588882446289, 0.659016921761357, -98.5527801513672, -1.72007050063547, 218, 20, 'PPL', 'P'),
(37796, 'Preston', 38.0855598449707, 0.66471841676008, -83.7533264160156, -1.46177130545701, 218, 21, 'PPL', 'P'),
(42692, 'Preston', 32.2555618286133, 0.562965755989905, -93.8772201538086, -1.63846658430354, 218, 22, 'PPL', 'P'),
(50596, 'Preston', 38.7125015258789, 0.675660613309916, -75.9102783203125, -1.32488429279472, 218, 25, 'PPL', 'P'),
(57041, 'Preston', 37.2791709899902, 0.650644276189284, -94.3888931274414, -1.6473969623869, 218, 29, 'PPL', 'P'),
(61427, 'Preston', 32.8824996948242, 0.573907885960713, -88.8288879394531, -1.55035656542854, 218, 30, 'PPL', 'P'),
(77003, 'Preston', 35.7113914489746, 0.623281361253155, -95.9913864135742, -1.67536574647102, 218, 42, 'PPL', 'P'),
(97232, 'Preston', 33.8822212219238, 0.591356318211667, -96.6327819824219, -1.68656021095512, 218, 51, 'PPL', 'P'),
(105451, 'Preston', 36.6580581665039, 0.639803812393089, -79.9800033569336, -1.39591439433461, 218, 53, 'PPL', 'P'),
(110985, 'Preston', 39.435001373291, 0.688270614492414, -79.6858291625977, -1.39078008606904, 218, 58, 'PPL', 'P'),
(117420, 'Preston', 42.0502815246582, 0.733915863995827, -90.4138870239258, -1.57802001809368, 218, 16, 'PPL', 'P'),
(137579, 'Preston', 43.670280456543, 0.762190179236007, -92.0830612182617, -1.60715260357417, 218, 28, 'PPL', 'P'),
(140741, 'Preston', 47.3122215270996, 0.825754042080828, -97.2183303833008, -1.69677995848024, 218, 34, 'PPL', 'P'),
(142806, 'Preston', 40.0344390869141, 0.698732776255763, -95.5169372558594, -1.66708504653558, 218, 35, 'PPL', 'P'),
(151905, 'Preston', 42.5338897705078, 0.742356420175697, -75.6236114501953, -1.31988101205479, 218, 40, 'PPL', 'P'),
(166200, 'Preston', 41.6927795410156, 0.727676277298853, -78.8513870239258, -1.37621632333184, 218, 45, 'PPL', 'P'),
(175974, 'Preston', 42.9749984741211, 0.750055219412952, -90.5469436645508, -1.58034229456423, 218, 57, 'PPL', 'P'),
(184281, 'Preston', 38.8352813720703, 0.677803525881048, -123.016387939453, -2.1470410034541, 218, 6, 'PPL', 'P'),
(190627, 'Preston', 38.9136085510254, 0.679170593047613, -115.059722900391, -2.00817100104414, 218, 39, 'PPL', 'P'),
(195499, 'Preston', 42.0963897705078, 0.734720604698221, -111.875831604004, -1.9526016148966, 218, 17, 'PPL', 'P'),
(197306, 'Preston', 46.7438888549805, 0.815834765705691, -111.357498168945, -1.94355498983165, 218, 31, 'PPL', 'P'),
(202516, 'Preston', 44.357780456543, 0.774189317843468, -103.887222290039, -1.81317407971243, 218, 49, 'PPL', 'P'),
(208494, 'Preston', 47.5238914489746, 0.829448379144986, -121.925827026367, -2.12800712482719, 218, 56, 'PPL', 'P'),
(90119, 'Preston (historical)', 36.1141700744629, 0.630311174424583, -83.9122161865234, -1.46454445510011, 218, 50, 'PPL', 'P'),
(187225, 'Preston (historical)', 39.4958305358887, 0.689332283660974, -106.020561218262, -1.85040786807088, 218, 7, 'PPL', 'P'),
(73977, 'Preston Addition', 38.8880615234375, 0.678724713302106, -82.9608306884766, -1.44793964570347, 218, 41, 'PPL', 'P'),
(151906, 'Preston Center', 42.5077781677246, 0.741900686734157, -75.5983276367188, -1.31943972626217, 218, 40, 'PPL', 'P'),
(113953, 'Preston City', 41.5288887023926, 0.724815842551026, -71.9744415283203, -1.25619098195333, 218, 8, 'PPL', 'P'),
(166201, 'Preston Corner', 41.8205604553223, 0.729906474974713, -75.370002746582, -1.31545470516503, 218, 45, 'PPL', 'P'),
(132733, 'Preston Corners', 42.6994400024414, 0.745245816800378, -82.9958267211914, -1.44855044169948, 218, 27, 'PPL', 'P'),
(105453, 'Preston Estates', 37.3152809143066, 0.651274513261251, -79.9469375610352, -1.39533728732639, 218, 53, 'PPL', 'P'),
(11396, 'Preston Ferry', 34.5347213745117, 0.602744594244091, -91.3036117553711, -1.59354864409383, 218, 4, 'PPL', 'P'),
(105454, 'Preston Forest', 37.2880592346191, 0.650799405322781, -80.4027786254883, -1.40329321476689, 218, 53, 'PPL', 'P'),
(121125, 'Preston Heights', 41.4916687011719, 0.724166230982128, -88.081672668457, -1.53731519872848, 218, 18, 'PPL', 'P'),
(105456, 'Preston Hills', 36.6436080932617, 0.639551611037858, -82.0988922119141, -1.43289598133783, 218, 53, 'PPL', 'P'),
(178920, 'Preston Hills', 33.5847206115723, 0.58616395303434, -111.866668701172, -1.95244169207314, 218, 5, 'PPL', 'P'),
(151907, 'Preston Hollow', 42.4444389343262, 0.740795208565665, -74.2083282470703, -1.29517966031209, 218, 40, 'PPL', 'P'),
(137581, 'Preston Mobile Home Park', 43.670280456543, 0.762190179236007, -92.0830612182617, -1.60715260357417, 218, 28, 'PPL', 'P'),
(166202, 'Preston Park', 41.8811111450195, 0.730963283874283, -75.3563919067383, -1.31521715119579, 218, 45, 'PPL', 'P'),
(11397, 'Preston Place', 34.4755592346191, 0.60171202011044, -90.6436080932617, -1.5820294071148, 218, 4, 'PPL', 'P'),
(105457, 'Preston Place', 37.3288917541504, 0.651512067230486, -77.4449996948242, -1.35167023388069, 218, 53, 'PPL', 'P'),
(50597, 'Preston Point', 38.3680610656738, 0.669648993202253, -76.4766693115234, -1.33476968044499, 218, 25, 'PPL', 'P'),
(73978, 'Preston Subdivision', 38.8233299255371, 0.677594933788668, -82.2291717529297, -1.43516978827654, 218, 41, 'PPL', 'P'),
(90121, 'Preston Woods', 36.540828704834, 0.637757772306608, -82.4899978637695, -1.43972206268587, 218, 50, 'PPL', 'P'),
(37797, 'Prestonia', 38.1947212219238, 0.666623642203923, -85.726936340332, -1.49621729678637, 218, 21, 'PPL', 'P'),
(57044, 'Prestonia', 36.5125007629395, 0.637263356450235, -92.3499984741211, -1.61181153758515, 218, 29, 'PPL', 'P'),
(37799, 'Prestonsburg', 37.6655616760254, 0.657388065859637, -82.7716674804688, -1.4446381249001, 218, 21, 'PPL', 'P'),
(37798, 'Prestonville', 38.6797218322754, 0.675088499728739, -85.1902770996094, -1.48685082607451, 218, 21, 'PPL', 'P'),
(67972, 'Prestonville', 36.4575004577637, 0.636303420035316, -80.0983276367188, -1.39797954260191, 218, 33, 'PPL', 'P'),
(5223, 'Prestwick', 31.4527797698975, 0.548954565889375, -87.9661102294922, -1.5352982536769, 218, 2, 'PPL', 'P'),
(83133, 'Prestwick', 33.6361083984375, 0.587060839110451, -78.9652786254883, -1.37820410676947, 218, 48, 'PPL', 'P'),
(105458, 'Prestwould', 36.6530609130859, 0.639716593867389, -78.5666732788086, -1.37124713105386, 218, 53, 'PPL', 'P'),
(24129, 'Pretoria', 31.5041694641113, 0.549851485255, -84.3172225952148, -1.47161315042346, 218, 13, 'PPL', 'P'),
(17727, 'Pretty Bayou', 30.1963901519775, 0.527026430368799, -85.6966705322266, -1.49568905878415, 218, 12, 'PPL', 'P'),
(128605, 'Pretty Marsh', 44.3402786254883, 0.773883853266436, -68.3997192382813, -1.19380030814772, 218, 26, 'PPL', 'P'),
(33695, 'Pretty Prairie', 37.7799987792969, 0.659385370098169, -98.0194396972656, -1.71076195367732, 218, 20, 'PPL', 'P'),
(13193, 'Pretty Prospect (historical)', 38.9208297729492, 0.679296627146201, -77.0458297729492, -1.34470340446904, 218, 9, 'PPL', 'P'),
(50598, 'Prettyboy', 39.6058311462402, 0.691252156490812, -76.7205581665039, -1.33902634397332, 218, 25, 'PPL', 'P'),
(50599, 'Prettyboy Garth', 39.6047210693359, 0.691232781993882, -76.7152786254883, -1.3389341985996, 218, 25, 'PPL', 'P'),
(50600, 'Prettyboy Trails', 39.6597213745117, 0.692192718408801, -76.7888870239258, -1.34021890750945, 218, 25, 'PPL', 'P'),
(57045, 'Prettyman', 38.6266708374023, 0.674162585196746, -94.4313888549805, -1.64813865275049, 218, 29, 'PPL', 'P'),
(112377, 'Prevost', 29.8413906097412, 0.520830519513702, -91.6013870239258, -1.59874580296111, 218, 22, 'PPL', 'P'),
(208495, 'Prevost', 48.6841697692871, 0.849699056073948, -123.209999084473, -2.15042015540325, 218, 56, 'PPL', 'P'),
(184282, 'Prewit (historical)', 36.1599998474121, 0.631111054857988, -119.021942138672, -2.07732477243801, 218, 6, 'PPL', 'P'),
(37800, 'Prewitt', 38.0280609130859, 0.663714871082311, -83.9811096191406, -1.46574687233229, 218, 21, 'PPL', 'P'),
(189279, 'Prewitt', 35.3627815246582, 0.617196970268706, -108.043327331543, -1.8857117967454, 218, 38, 'PPL', 'P'),
(137583, 'Priam', 45.0683288574219, 0.786590726933586, -95.1405563354492, -1.66051596023274, 218, 28, 'PPL', 'P'),
(105459, 'Pribble', 37.396110534668, 0.652685256269693, -76.3758316040039, -1.33300973043861, 218, 53, 'PPL', 'P'),
(11399, 'Price', 34.4625015258789, 0.601484120100157, -92.9333267211914, -1.62199253611642, 218, 4, 'PPL', 'P'),
(24141, 'Price', 34.3863906860352, 0.600155735348425, -83.9211120605469, -1.46469971739167, 218, 13, 'PPL', 'P'),
(37801, 'Price', 37.4025001525879, 0.65279677614034, -82.7422180175781, -1.44412413480971, 218, 21, 'PPL', 'P'),
(50601, 'Price', 39.0974998474121, 0.682380101635322, -75.9591674804688, -1.32573756960799, 218, 25, 'PPL', 'P'),
(67973, 'Price', 36.538890838623, 0.637723950160764, -79.9150009155273, -1.39477988771024, 218, 33, 'PPL', 'P'),
(77004, 'Price', 36.1355590820313, 0.630684483030385, -96.0680618286133, -1.67670398491879, 218, 42, 'PPL', 'P'),
(97234, 'Price', 32.1338882446289, 0.560842151336675, -94.9427795410156, -1.65706410398583, 218, 51, 'PPL', 'P'),
(110987, 'Price', 38.1438903808594, 0.66573647666579, -82.1269378662109, -1.43338547034619, 218, 58, 'PPL', 'P'),
(132734, 'Price', 42.9288902282715, 0.749250478710558, -84.4836120605469, -1.47451719443413, 218, 27, 'PPL', 'P'),
(175977, 'Price', 44.5816688537598, 0.778096907531914, -91.054443359375, -1.58919983519178, 218, 57, 'PPL', 'P'),
(178921, 'Price', 33.0955581665039, 0.577626457790791, -111.231666564941, -1.94135881403872, 218, 5, 'PPL', 'P'),
(192752, 'Price', 39.5994415283203, 0.691140636620165, -110.809997558594, -1.93399930152434, 218, 52, 'PPL', 'P'),
(198770, 'Price', 47.0858306884766, 0.821802776550504, -100.941108703613, -1.76175469749156, 218, 34, 'PPL', 'P'),
(83135, 'Price (historical)', 34.475830078125, 0.601716747221375, -82.866943359375, -1.44630100268474, 218, 48, 'PPL', 'P'),
(67974, 'Price Creek', 35.8661117553711, 0.625981740019469, -82.3838882446289, -1.43787010046383, 218, 33, 'PPL', 'P'),
(42693, 'Price Crossing', 31.1655597686768, 0.543941631190492, -92.8041687011719, -1.61973830341172, 218, 22, 'PPL', 'P'),
(83140, 'Price Crossroads', 34.167781829834, 0.596340291033696, -79.6880569458008, -1.39081896822096, 218, 48, 'PPL', 'P'),
(73981, 'Price Hill', 39.1100006103516, 0.682598281107627, -84.5758285522461, -1.47612667583892, 218, 41, 'PPL', 'P'),
(105460, 'Price Hill', 36.7602806091309, 0.64158793058636, -81.7563934326172, -1.42691824995504, 218, 53, 'PPL', 'P'),
(110990, 'Price Hill', 39.6041717529297, 0.691223194613957, -79.9966735839844, -1.3962053446837, 218, 58, 'PPL', 'P'),
(151909, 'Price Home', 42.1094398498535, 0.73494837155045, -76.2136077880859, -1.33017839072569, 218, 40, 'PPL', 'P'),
(57047, 'Price Landing', 37.0369415283203, 0.64641657453781, -89.3783264160156, -1.5599460758817, 218, 29, 'PPL', 'P'),
(83136, 'Price Landing', 33.2744407653809, 0.580748548115718, -79.5813903808594, -1.38895728546094, 218, 48, 'PPL', 'P'),
(105461, 'Price Mill', 36.8127784729004, 0.642504191159402, -77.9222183227539, -1.35999927018991, 218, 53, 'PPL', 'P'),
(11400, 'Price Place', 36.4944381713867, 0.636948104756197, -92.6063919067383, -1.61628644716481, 218, 4, 'PPL', 'P'),
(61429, 'Pricedale', 31.2902793884277, 0.546118399196982, -90.2947235107422, -1.57594022244038, 218, 30, 'PPL', 'P'),
(166205, 'Pricedale', 40.1313896179199, 0.700424882233372, -79.8444366455078, -1.39354830886413, 218, 45, 'PPL', 'P'),
(5225, 'Prices', 33.8902816772461, 0.591496999696251, -85.6958312988281, -1.49567441139816, 218, 2, 'PPL', 'P'),
(97235, 'Prices', 31.899169921875, 0.556745543789861, -95.4272232055664, -1.66551924097267, 218, 51, 'PPL', 'P'),
(57046, 'Prices Branch', 38.9511108398438, 0.679825131464527, -91.3375015258789, -1.59414013217193, 218, 29, 'PPL', 'P'),
(14448, 'Prices Corner', 39.7369384765625, 0.693540411078435, -75.6224975585938, -1.31986157097883, 218, 10, 'PPL', 'P'),
(105462, 'Prices Fork', 37.2097206115723, 0.649432138419134, -80.4902801513672, -1.404820404494, 218, 53, 'PPL', 'P'),
(83137, 'Prices Landing', 32.9772186279297, 0.57556104320738, -80.4180603027344, -1.40355993035006, 218, 48, 'PPL', 'P'),
(37802, 'Prices Mill', 36.6813888549805, 0.640211009723762, -86.7300033569336, -1.51372411884423, 218, 21, 'PPL', 'P'),
(105463, 'Prices Store', 37.478328704834, 0.654120234044055, -79.1180572509766, -1.38087059681091, 218, 53, 'PPL', 'P'),
(83138, 'Prices Store (historical)', 34.9891700744629, 0.610676220339647, -82.7574996948242, -1.44439085039289, 218, 48, 'PPL', 'P'),
(37804, 'Pricetown', 37.9922218322754, 0.663089361121278, -84.373893737793, -1.47260224845231, 218, 21, 'PPL', 'P'),
(67977, 'Pricetown', 35.1708297729492, 0.613846780196414, -77.8969421386719, -1.35955811755534, 218, 33, 'PPL', 'P'),
(110993, 'Pricetown', 39.0491714477539, 0.681536611939067, -80.5250015258789, -1.40542640680004, 218, 58, 'PPL', 'P'),
(157247, 'Pricetown', 41.1341705322266, 0.717926710864182, -80.966667175293, -1.41313492657528, 218, 41, 'PPL', 'P'),
(166206, 'Pricetown', 40.4266700744629, 0.705578498416839, -75.8222198486328, -1.32334738252964, 218, 45, 'PPL', 'P'),
(42694, 'Pricetown (historical)', 29.913610458374, 0.522090993657637, -90.2099990844727, -1.57446150224512, 218, 22, 'PPL', 'P'),
(5226, 'Priceville', 34.5250015258789, 0.602574950882653, -86.8947219848633, -1.51659900124097, 218, 2, 'PPL', 'P'),
(37805, 'Priceville', 37.3741683959961, 0.65230229370494, -85.9872207641602, -1.50076011697383, 218, 21, 'PPL', 'P'),
(50602, 'Priceville', 39.5449981689453, 0.690190420743225, -76.6694412231445, -1.33813418500814, 218, 25, 'PPL', 'P'),
(61430, 'Priceville', 34.2574996948242, 0.597906163175635, -88.6622161865234, -1.54744759456984, 218, 30, 'PPL', 'P'),
(83139, 'Priceville', 33.9986114501953, 0.593387710912152, -81.4094390869141, -1.42086275426842, 218, 48, 'PPL', 'P'),
(166207, 'Priceville', 41.8105583190918, 0.729731904765258, -75.1936111450195, -1.31237609094489, 218, 45, 'PPL', 'P'),
(5227, 'Prichard', 30.7386093139648, 0.536489940012882, -88.0788879394531, -1.53726659603858, 218, 2, 'PPL', 'P'),
(42695, 'Prichard', 31.7994403839111, 0.555004934990899, -91.8775024414063, -1.60356492611167, 218, 22, 'PPL', 'P'),
(61431, 'Prichard', 34.6994400024414, 0.605619476640832, -90.2441711425781, -1.57505791717124, 218, 30, 'PPL', 'P'),
(110992, 'Prichard', 38.2400016784668, 0.667413935257404, -82.5986099243164, -1.44161770074979, 218, 58, 'PPL', 'P'),
(166208, 'Prichard', 41.2550010681152, 0.720035601552388, -76.1347198486328, -1.32880153644212, 218, 45, 'PPL', 'P'),
(195500, 'Prichard', 47.6563911437988, 0.831760935077556, -115.975280761719, -2.02415050021683, 218, 17, 'PPL', 'P'),
(37806, 'Prichard Place', 37.8844413757324, 0.661208237285301, -85.9716720581055, -1.50048874085875, 218, 21, 'PPL', 'P'),
(187226, 'Prichett', 37.3716697692871, 0.65225868444209, -102.860000610352, -1.79524567925401, 218, 7, 'PPL', 'P'),
(5228, 'Prickettville', 33.8291702270508, 0.590430403679674, -85.8638916015625, -1.49860761702277, 218, 2, 'PPL', 'P'),
(97236, 'Priddy', 31.6752796173096, 0.552837920811901, -98.5086135864258, -1.71929964865795, 218, 51, 'PPL', 'P'),
(37807, 'Pride', 37.5583305358887, 0.655516529403584, -87.8908309936523, -1.53398438315311, 218, 21, 'PPL', 'P'),
(42696, 'Pride', 30.6936092376709, 0.535704540517904, -90.9780578613281, -1.58786665675009, 218, 22, 'PPL', 'P'),
(73988, 'Pride', 39.2336082458496, 0.684755641327673, -82.8958282470703, -1.4468051390791, 218, 41, 'PPL', 'P'),
(128603, 'Pride', 46.3505592346191, 0.808969868784767, -68.273063659668, -1.1915897512849, 218, 26, 'PPL', 'P'),
(192079, 'Pride', 32.9372215270996, 0.574862962106643, -102.077217102051, -1.78158352970385, 218, 51, 'PPL', 'P'),
(24131, 'Pride (historical)', 33.4261093139648, 0.58339566366023, -82.904167175293, -1.44695068083267, 218, 13, 'PPL', 'P'),
(83141, 'Pride (historical)', 34.6138916015625, 0.604126375375679, -81.4316711425781, -1.42125077683924, 218, 48, 'PPL', 'P'),
(5229, 'Pride Landing', 34.732780456543, 0.606201377339014, -87.8172225952148, -1.53269967424326, 218, 2, 'PPL', 'P'),
(128604, 'Prides Corner', 43.7136116027832, 0.762946450406563, -70.3341674804688, -1.2275627991833, 218, 26, 'PPL', 'P'),
(125888, 'Prides Crossing', 42.5597190856934, 0.74280722676922, -70.8249969482422, -1.23612938946176, 218, 23, 'PPL', 'P'),
(24132, 'Pridgen', 31.6966705322266, 0.553211262707217, -82.9230575561523, -1.44728038017562, 218, 13, 'PPL', 'P'),
(42697, 'Prien', 30.1816692352295, 0.526769501902634, -93.2736129760742, -1.6279316516634, 218, 22, 'PPL', 'P'),
(132735, 'Pries Landing', 45.6855583190918, 0.797363413280038, -84.5369415283203, -1.47544796923512, 218, 27, 'PPL', 'P'),
(184283, 'Priest', 37.8141708374023, 0.659981785024292, -120.271667480469, -2.09913659439797, 218, 6, 'PPL', 'P'),
(208496, 'Priest Point', 48.0369415283203, 0.838402792257186, -122.249717712402, -2.13366008371505, 218, 56, 'PPL', 'P'),
(195501, 'Priest River', 48.1808280944824, 0.840914086586104, -116.908332824707, -2.0404353308085, 218, 17, 'PPL', 'P'),
(50603, 'Priestford Hills', 39.5744400024414, 0.690704277675555, -76.2600021362305, -1.33098812485513, 218, 25, 'PPL', 'P'),
(110994, 'Priestley', 38.2602806091309, 0.667767869366275, -81.8369369506836, -1.42832399953644, 218, 58, 'PPL', 'P'),
(90123, 'Prigmore', 35.6111106872559, 0.621531131784755, -84.5680618286133, -1.47599112093944, 218, 50, 'PPL', 'P'),
(105465, 'Prilliman', 36.8738899230957, 0.643570787175979, -80.0077819824219, -1.39639922281106, 218, 53, 'PPL', 'P'),
(11402, 'Prim', 35.6938896179199, 0.622975896676123, -92.1083297729492, -1.60759362305068, 218, 4, 'PPL', 'P'),
(105466, 'Prim', 38.2486114501953, 0.667564204121911, -77.0702819824219, -1.34513017603372, 218, 53, 'PPL', 'P'),
(90124, 'Prima Estates', 36.1791687011719, 0.63144561446993, -83.4011077880859, -1.45562393071278, 218, 50, 'PPL', 'P'),
(97237, 'Primavera Colonia Number 1', 26.2369995117188, 0.457922027323637, -98.1389999389648, -1.71284867354945, 218, 51, 'PPL', 'P'),
(97238, 'Primavera Number 2 Colonia', 26.2329998016357, 0.457852219213563, -98.1389999389648, -1.71284867354945, 218, 51, 'PPL', 'P'),
(137584, 'Prime Village of Wells Mobile Home Park', 43.750560760498, 0.763591334864525, -93.7291717529297, -1.63588265225589, 218, 28, 'PPL', 'P'),
(200141, 'Primeaux', 40.6488914489746, 0.709456993070376, -116.300827026367, -2.02983235440251, 218, 39, 'PPL', 'P'),
(14447, 'Primehook Beach', 38.8555603027344, 0.67815745998992, -75.2430572509766, -1.31323908829613, 218, 10, 'PPL', 'P'),
(97239, 'Primera', 26.2255592346191, 0.457722356820908, -97.7577819824219, -1.70619516504005, 218, 51, 'PPL', 'P'),
(189280, 'Primera Agua', 35.0833282470703, 0.612319590469308, -106.377220153809, -1.85663274080283, 218, 38, 'PPL', 'P'),
(184284, 'Primero (historical)', 36.6025009155273, 0.638834155440191, -119.284439086914, -2.08190620846127, 218, 6, 'PPL', 'P'),
(187227, 'Primero (historical)', 37.1425018310547, 0.648258949379927, -104.741111755371, -1.82807726233056, 218, 7, 'PPL', 'P'),
(117422, 'Primghar', 43.0869407653809, 0.752008980967662, -95.6269378662109, -1.66900491936542, 218, 16, 'PPL', 'P'),
(5235, 'Primitive Ridge', 33.1002807617188, 0.577708882626529, -87.126106262207, -1.52063741871796, 218, 2, 'PPL', 'P'),
(190628, 'Primm', 35.6127815246582, 0.621560293398692, -115.389442443848, -2.01392569268563, 218, 39, 'PPL', 'P'),
(90126, 'Primm Springs', 35.8208312988281, 0.625191446965988, -87.25, -1.52279977236505, 218, 50, 'PPL', 'P'),
(78981, 'Primos', 39.920280456543, 0.69674033228622, -75.3069381713867, -1.3143540206865, 218, 45, 'PPL', 'P'),
(24133, 'Primrose', 33.1433296203613, 0.578460226949067, -84.741943359375, -1.47902592615964, 218, 13, 'PPL', 'P'),
(37808, 'Primrose', 37.6022186279297, 0.656282521112118, -83.6086120605469, -1.45924556347918, 218, 21, 'PPL', 'P'),
(97240, 'Primrose', 32.4332618713379, 0.566067206816384, -95.6038970947266, -1.66860278204082, 218, 51, 'PPL', 'P'),
(117423, 'Primrose', 40.6755599975586, 0.709922447049894, -91.6380615234375, -1.59938589372912, 218, 16, 'PPL', 'P'),
(142807, 'Primrose', 41.6230583190918, 0.726459412417768, -98.2377777099609, -1.71457267088111, 218, 35, 'PPL', 'P'),
(157248, 'Primrose', 41.6802787780762, 0.727458097826548, -84.4369430541992, -1.47370266661473, 218, 41, 'PPL', 'P'),
(166210, 'Primrose', 40.3555603027344, 0.704337398769834, -80.2680587768555, -1.40094190984046, 218, 45, 'PPL', 'P'),
(169562, 'Primrose', 41.9541702270508, 0.732238405404213, -71.5569381713867, -1.24890417373671, 218, 47, 'PPL', 'P'),
(175980, 'Primrose', 42.9013900756836, 0.748770510503098, -89.6622161865234, -1.56490088708979, 218, 57, 'PPL', 'P'),
(197307, 'Primrose', 46.9272193908691, 0.819034487176394, -114.165832519531, -1.99256967074623, 218, 31, 'PPL', 'P'),
(212115, 'Primrose', 60.3783302307129, 1.05380065938237, -149.322784423828, -2.6061742364415, 218, 1, 'PPL', 'P'),
(50604, 'Primrose Acres', 38.958610534668, 0.679956025832105, -76.5041732788086, -1.33524971523148, 218, 25, 'PPL', 'P'),
(50605, 'Primrose Garth', 39.1952781677246, 0.684086655261845, -76.0583267211914, -1.32746822484237, 218, 25, 'PPL', 'P'),
(90125, 'Primroy (historical)', 36.3680610656738, 0.634742408162366, -84.0347213745117, -1.46668257398128, 218, 50, 'PPL', 'P'),
(83142, 'Primus', 34.6811103820801, 0.605299564414886, -80.6391677856445, -1.40741898392764, 218, 48, 'PPL', 'P'),
(110995, 'Prince', 37.8588905334473, 0.660762290960767, -81.0538864135742, -1.41465718945437, 218, 58, 'PPL', 'P'),
(190629, 'Prince', 37.9000015258789, 0.661479813137462, -114.473327636719, -1.99793647297496, 218, 39, 'PPL', 'P'),
(61432, 'Prince Chapel', 32.9041709899902, 0.574286121414532, -88.9063873291016, -1.55170918494619, 218, 30, 'PPL', 'P'),
(121124, 'Prince Crossing', 41.9049987792969, 0.731380201742935, -88.184440612793, -1.53910883772264, 218, 18, 'PPL', 'P'),
(5230, 'Prince Crossroads', 32.5205612182617, 0.567590867855045, -85.2216720581055, -1.48739877146879, 218, 2, 'PPL', 'P'),
(50606, 'Prince Frederick', 38.5402793884277, 0.672654769966571, -76.584716796875, -1.33665546481287, 218, 25, 'PPL', 'P'),
(105468, 'Prince George', 37.2202796936035, 0.649616429166568, -77.288330078125, -1.34893583323145, 218, 53, 'PPL', 'P'),
(14449, 'Prince George Acres', 38.545280456543, 0.672742055071298, -75.2319412231445, -1.31304507701072, 218, 10, 'PPL', 'P'),
(123498, 'Prince William', 40.4422187805176, 0.705849874531918, -86.5730590820313, -1.51098492450503, 218, 19, 'PPL', 'P'),
(11403, 'Princedale', 35.2638893127441, 0.615470975566226, -90.6469421386719, -1.58208759718461, 218, 4, 'PPL', 'P'),
(105471, 'Princedale', 38.6611099243164, 0.674763660654777, -77.3850021362305, -1.35062307894007, 218, 53, 'PPL', 'P'),
(151911, 'Princes Bay', 40.5288887023926, 0.707362550031083, -74.1980590820313, -1.29500042957073, 218, 40, 'PPL', 'P'),
(30898, 'Princes Lakes', 39.3536109924316, 0.686850084366965, -86.0980606079102, -1.50269463718966, 218, 19, 'PPL', 'P'),
(37809, 'Princess', 38.3875007629395, 0.669988279925129, -82.7458267211914, -1.44418711856949, 218, 21, 'PPL', 'P'),
(50608, 'Princess Anne', 38.2027816772461, 0.666764323688506, -75.6927795410156, -1.32108822297693, 218, 25, 'PPL', 'P'),
(105472, 'Princess Anne', 36.7513885498047, 0.641432734873836, -76.0533294677734, -1.32738100631667, 218, 53, 'PPL', 'P'),
(105473, 'Princess Anne Plaza', 36.8316688537598, 0.642833890502354, -76.0899963378906, -1.32802096392662, 218, 53, 'PPL', 'P'),
(146109, 'Princessville', 40.2924995422363, 0.703236780870332, -74.7080612182617, -1.30390164604015, 218, 37, 'PPL', 'P'),
(5231, 'Princeton', 34.8433303833008, 0.608130837548777, -86.2430572509766, -1.50522530601551, 218, 2, 'PPL', 'P'),
(11404, 'Princeton', 33.9816703796387, 0.593092033452126, -92.6244430541992, -1.61660149912177, 218, 4, 'PPL', 'P'),
(17729, 'Princeton', 25.5380592346191, 0.445723218213447, -80.4091720581055, -1.40340480121657, 218, 12, 'PPL', 'P'),
(24134, 'Princeton', 33.9194412231445, 0.592005929780565, -83.3877792358398, -1.45539130359157, 218, 13, 'PPL', 'P'),
(30899, 'Princeton', 38.355281829834, 0.669425953460958, -87.567497253418, -1.52834114480323, 218, 19, 'PPL', 'P'),
(33696, 'Princeton', 38.4888916015625, 0.671757883890459, -95.2750015258789, -1.66286247146921, 218, 20, 'PPL', 'P'),
(37810, 'Princeton', 37.1091690063477, 0.647677181839799, -87.8819427490234, -1.53382925401962, 218, 21, 'PPL', 'P'),
(42698, 'Princeton', 32.589168548584, 0.568788291660172, -93.5149993896484, -1.63214463934985, 218, 22, 'PPL', 'P'),
(67979, 'Princeton', 35.4658317565918, 0.618995536110891, -78.1608276367188, -1.36416378834452, 218, 33, 'PPL', 'P'),
(73982, 'Princeton', 39.3883285522461, 0.687456020093986, -84.4538879394531, -1.47399841065379, 218, 41, 'PPL', 'P'),
(83143, 'Princeton', 34.496940612793, 0.602085195558188, -82.2872161865234, -1.43618285475521, 218, 48, 'PPL', 'P'),
(90127, 'Princeton', 36.3574981689453, 0.634558050835905, -82.3666687011719, -1.43756956273481, 218, 50, 'PPL', 'P'),
(97241, 'Princeton', 33.1800003051758, 0.579100251138041, -96.4977798461914, -1.68420397918067, 218, 51, 'PPL', 'P'),
(110996, 'Princeton', 37.3661117553711, 0.652161678799384, -81.102783203125, -1.41551059942568, 218, 58, 'PPL', 'P'),
(117424, 'Princeton', 41.6747207641602, 0.727361092183842, -90.3402786254883, -1.57673530918383, 218, 16, 'PPL', 'P'),
(121126, 'Princeton', 41.3680610656738, 0.722008870762083, -89.4647216796875, -1.5614539576909, 218, 18, 'PPL', 'P'),
(125890, 'Princeton', 42.4486083984375, 0.740867979442451, -71.8777770996094, -1.25450386940276, 218, 23, 'PPL', 'P'),
(128606, 'Princeton', 45.223331451416, 0.789296032547915, -67.5727767944336, -1.17936743977809, 218, 26, 'PPL', 'P'),
(132736, 'Princeton', 46.288890838623, 0.807893552230211, -87.4749984741211, -1.52672673655043, 218, 27, 'PPL', 'P'),
(137585, 'Princeton', 45.5699996948242, 0.795346534807494, -93.5813903808594, -1.63330338074015, 218, 28, 'PPL', 'P'),
(139405, 'Princeton', 40.4008293151855, 0.705127492086234, -93.5802764892578, -1.63328393966419, 218, 29, 'PPL', 'P'),
(142808, 'Princeton', 40.5736083984375, 0.708143055967558, -96.7044372558594, -1.68781083140302, 218, 35, 'PPL', 'P'),
(146110, 'Princeton', 40.3486099243164, 0.704216091782181, -74.6594390869141, -1.3030530297588, 218, 37, 'PPL', 'P'),
(166213, 'Princeton', 40.9638900756836, 0.714954756245708, -80.2316665649414, -1.40030674592048, 218, 45, 'PPL', 'P'),
(175982, 'Princeton', 43.850830078125, 0.765341364595844, -89.1216735839844, -1.55546663892818, 218, 57, 'PPL', 'P'),
(184286, 'Princeton', 37.5050010681152, 0.654585754602601, -122.485832214355, -2.13778105918584, 218, 6, 'PPL', 'P'),
(187228, 'Princeton', 38.9933280944824, 0.680561961559125, -106.219436645508, -1.85387889907763, 218, 7, 'PPL', 'P'),
(195502, 'Princeton', 46.9141693115234, 0.818806720324165, -116.833061218262, -2.03912159344276, 218, 17, 'PPL', 'P'),
(197308, 'Princeton', 46.4169387817383, 0.810128410437979, -113.16471862793, -1.97509693715033, 218, 31, 'PPL', 'P'),
(24135, 'Princeton (historical)', 33.7208290100098, 0.58853949272669, -83.9277801513672, -1.4648160975313, 218, 13, 'PPL', 'P'),
(61433, 'Princeton (historical)', 33.0508308410645, 0.576845818696261, -91.1194381713867, -1.5903342086581, 218, 30, 'PPL', 'P'),
(190630, 'Princeton (historical)', 37.8916702270508, 0.661334404541943, -114.484169006348, -1.99812569057041, 218, 39, 'PPL', 'P'),
(201439, 'Princeton (historical)', 43.2466697692871, 0.754796777996757, -118.576667785645, -2.06955326890299, 218, 43, 'PPL', 'P'),
(24136, 'Princeton Chase', 33.5230598449707, 0.585087769637839, -84.4544372558594, -1.47400799803371, 218, 13, 'PPL', 'P'),
(146111, 'Princeton Colonial Park', 40.3019409179688, 0.703401563962781, -74.6194381713867, -1.30235488207903, 218, 37, 'PPL', 'P'),
(14450, 'Princeton Estates', 39.8216705322266, 0.695019264431756, -75.4611129760742, -1.31704487865191, 218, 10, 'PPL', 'P'),
(146112, 'Princeton Estates', 40.2980613708496, 0.703333853092065, -74.6127777099609, -1.30223863509745, 218, 37, 'PPL', 'P'),
(146113, 'Princeton Ivy East', 40.2999992370605, 0.703367675237909, -74.6066665649414, -1.3021319754958, 218, 37, 'PPL', 'P'),
(146114, 'Princeton Junction', 40.3172187805176, 0.703668212966925, -74.6202774047852, -1.30236952946503, 218, 37, 'PPL', 'P'),
(24137, 'Princeton Lakes', 33.9838905334473, 0.593130782445987, -84.4166717529297, -1.47334886566392, 218, 13, 'PPL', 'P'),
(146115, 'Princeton Meadows', 40.3316688537598, 0.703920414322155, -74.5641708374023, -1.30139028513221, 218, 37, 'PPL', 'P'),
(112551, 'Princeton Place', 33.8547210693359, 0.590876350004208, -78.6624984741211, -1.37291959621843, 218, 48, 'PPL', 'P'),
(125891, 'Princeton Station', 42.4480590820313, 0.740858392062527, -71.9250030517578, -1.25532811776014, 218, 23, 'PPL', 'P'),
(125892, 'Princeton Village', 42.6305618286133, 0.744043665884316, -71.3563919067383, -1.24540398111602, 218, 23, 'PPL', 'P'),
(24138, 'Princeton Walk', 33.976390838623, 0.59299988807841, -84.4236068725586, -1.47346990633546, 218, 13, 'PPL', 'P'),
(14451, 'Princeton Wood II', 39.6399993896484, 0.691848504837908, -75.6602783203125, -1.32052096966474, 218, 10, 'PPL', 'P'),
(151912, 'Princetown', 42.7788887023926, 0.746632458200955, -74.0650024414063, -1.29267815310018, 218, 40, 'PPL', 'P'),
(105474, 'Princeview Point', 36.7972183227539, 0.642232615307241, -76.6244430541992, -1.33734881880268, 218, 53, 'PPL', 'P'),
(67980, 'Princeville', 35.8894386291504, 0.626388870771114, -77.5325012207031, -1.35319742360779, 218, 33, 'PPL', 'P'),
(83144, 'Princeville', 34.0805587768555, 0.594817961575579, -78.9377822875977, -1.37772420514104, 218, 48, 'PPL', 'P'),
(121128, 'Princeville', 40.9297218322754, 0.714358407898612, -89.7574996948242, -1.56656389803249, 218, 18, 'PPL', 'P'),
(210985, 'Princeville', 22.2236099243164, 0.387875164858209, -159.485275268555, -2.78354316188576, 218, 15, 'PPL', 'P'),
(110997, 'Princewick', 37.6599998474121, 0.657290993637903, -81.2180633544922, -1.41752261762924, 218, 58, 'PPL', 'P'),
(50609, 'Principio', 39.6505584716797, 0.692032795585341, -76.038330078125, -1.32711921758152, 218, 25, 'PPL', 'P'),
(50626, 'Principio Furnace', 39.5750007629395, 0.690714064792561, -76.0391693115234, -1.32713386496751, 218, 25, 'PPL', 'P'),
(50610, 'Principio Heights', 39.6536102294922, 0.692086058807143, -76.0461120605469, -1.32725503879711, 218, 25, 'PPL', 'P'),
(208497, 'Prindle', 45.5855598449707, 0.795618110659655, -122.154998779297, -2.13200692646838, 218, 56, 'PPL', 'P'),
(172424, 'Prindle Corners', 44.3013916015625, 0.77320514666263, -73.1622161865234, -1.27692156051072, 218, 55, 'PPL', 'P'),
(201440, 'Prineville', 44.2999992370605, 0.773180845317683, -120.83332824707, -2.10893942405445, 218, 43, 'PPL', 'P'),
(24139, 'Pringle', 32.7999992370605, 0.572467981338335, -82.6347198486328, -1.44224793782175, 218, 13, 'PPL', 'P'),
(166211, 'Pringle', 41.2780609130859, 0.720438071772126, -75.8974990844727, -1.32466125305343, 218, 45, 'PPL', 'P'),
(192080, 'Pringle', 35.9491691589355, 0.627431365179826, -101.455833435059, -1.77073833879672, 218, 51, 'PPL', 'P'),
(202517, 'Pringle', 43.6086082458496, 0.761113796102424, -103.593330383301, -1.80804469829488, 218, 49, 'PPL', 'P'),
(83145, 'Pringle Bend', 32.8477783203125, 0.573301883654666, -80.5880584716797, -1.40652695812052, 218, 48, 'PPL', 'P'),
(73983, 'Pringle Corners', 39.1630592346191, 0.683524328797674, -84.0933303833008, -1.46770549415598, 218, 41, 'PPL', 'P'),
(83148, 'Pringle Heights', 33.4333305358887, 0.583521697758818, -79.279167175293, -1.38368249544787, 218, 48, 'PPL', 'P'),
(83146, 'Pringletown', 33.1436080932617, 0.578465087218057, -80.3061065673828, -1.40160596905827, 218, 48, 'PPL', 'P'),
(137588, 'Prinsburg', 44.9338912963867, 0.784244348855171, -95.1872177124023, -1.66133035489409, 218, 28, 'PPL', 'P'),
(37811, 'Printer', 37.5297203063965, 0.655017186699194, -82.7463912963867, -1.44419697226553, 218, 21, 'PPL', 'P'),
(83147, 'Prioleau', 33.3641700744629, 0.582314619994739, -80.1958312988281, -1.39968130253847, 218, 48, 'PPL', 'P'),
(24140, 'Prior', 34.0144386291504, 0.593663947296221, -85.3788909912109, -1.49014275949796, 218, 13, 'PPL', 'P'),
(57048, 'Prior', 37.0022201538086, 0.645810572231763, -92.3013916015625, -1.61096318761991, 218, 29, 'PPL', 'P'),
(137590, 'Prior Lake', 44.7133293151855, 0.780394816078489, -93.4225006103516, -1.63053023109705, 218, 28, 'PPL', 'P'),
(177348, 'Pripet', 44.3686103820801, 0.774378335701837, -68.8705596923828, -1.20201802432337, 218, 26, 'PPL', 'P'),
(61434, 'Priscilla', 33.5158309936523, 0.584961602381196, -90.9830627441406, -1.58795400843384, 218, 30, 'PPL', 'P'),
(125894, 'Priscilla Beach', 41.9319381713867, 0.731850382833389, -70.5666732788086, -1.23162079089431, 218, 23, 'PPL', 'P'),
(61435, 'Prismatic', 32.5916709899902, 0.568831967502049, -88.7383270263672, -1.54877597932158, 218, 30, 'PPL', 'P'),
(197309, 'Prison Farm', 46.3847198486328, 0.809566083973808, -112.731109619141, -1.96752903228065, 218, 31, 'PPL', 'P'),
(77007, 'Pritchard', 34.084171295166, 0.594881011914387, -96.1469421386719, -1.6780807060443, 218, 42, 'PPL', 'P'),
(83152, 'Pritchard', 32.2438888549805, 0.562762024166514, -81.0019378662109, -1.41375051626125, 218, 48, 'PPL', 'P'),
(157249, 'Pritchard', 41.1341705322266, 0.717926710864182, -81.0083312988281, -1.41386210271093, 218, 41, 'PPL', 'P'),
(166214, 'Pritchard (historical)', 41.9863891601563, 0.732800731868383, -77.1577835083008, -1.34665736576083, 218, 45, 'PPL', 'P'),
(83149, 'Pritchard Creek', 34.538330078125, 0.602807578003872, -82.7600021362305, -1.44443452623476, 218, 48, 'PPL', 'P'),
(166215, 'Pritchards Corner', 41.2794418334961, 0.720462173379992, -80.4836120605469, -1.40470402435436, 218, 45, 'PPL', 'P'),
(190633, 'Pritchards Station', 38.7775001525879, 0.676795053355262, -116.175003051758, -2.02763631176763, 218, 39, 'PPL', 'P'),
(37812, 'Pritchardsville', 36.9722213745117, 0.645286994761453, -85.9372177124023, -1.49988739908461, 218, 21, 'PPL', 'P'),
(83150, 'Pritchardville', 32.2377815246582, 0.562655431143883, -80.9644393920898, -1.41309604442336, 218, 48, 'PPL', 'P'),
(97242, 'Pritchett', 32.6616706848145, 0.570053692652123, -95.0183334350586, -1.65838276819959, 218, 51, 'PPL', 'P'),
(187229, 'Pritchett', 37.3702812194824, 0.65223444967617, -102.859169006348, -1.79523116502607, 218, 7, 'PPL', 'P'),
(24142, 'Pritchetts', 31.3638896942139, 0.547403141396349, -83.9558334350586, -1.46530571969771, 218, 13, 'PPL', 'P'),
(166216, 'Prittstown', 40.098331451416, 0.699847908383206, -79.554443359375, -1.38848697121243, 218, 45, 'PPL', 'P'),
(83151, 'Privateer', 33.8330612182617, 0.590498314287471, -80.414436340332, -1.40349668027417, 218, 48, 'PPL', 'P'),
(37813, 'Privett', 37.4019393920898, 0.652786989023334, -83.9005584716797, -1.46434098959283, 218, 21, 'PPL', 'P'),
(83159, 'Privetts', 33.9688911437988, 0.592868993710832, -79.0027770996094, -1.37885857860736, 218, 48, 'PPL', 'P'),
(184287, 'Prize (historical)', 39.0566711425781, 0.681667506306644, -122.014717102051, -2.12955854932022, 218, 6, 'PPL', 'P'),
(193891, 'Proberta', 40.0816688537598, 0.699557091192169, -122.169441223145, -2.13225899466556, 218, 6, 'PPL', 'P'),
(90129, 'Probst', 35.1811103820801, 0.614026210674858, -84.4847183227539, -1.47453650235204, 218, 50, 'PPL', 'P'),
(14452, 'Probst Mobile Home Park', 39.1122207641602, 0.682637030101487, -75.6361083984375, -1.32009912494807, 218, 10, 'PPL', 'P'),
(117426, 'Probstei', 41.5813903808594, 0.725732169703095, -90.6624984741211, -1.58235910645775, 218, 16, 'PPL', 'P'),
(11406, 'Process City', 34.021110534668, 0.593780394014884, -94.3652801513672, -1.64698483820821, 218, 4, 'PPL', 'P'),
(110999, 'Procious', 38.4955596923828, 0.671874264030096, -81.2077789306641, -1.41734312057177, 218, 58, 'PPL', 'P'),
(5236, 'Proctor', 34.714168548584, 0.605876538265052, -87.0566711425781, -1.51942554726392, 218, 2, 'PPL', 'P'),
(11407, 'Proctor', 35.0950012207031, 0.612523322292699, -90.3733291625977, -1.57731214987594, 218, 4, 'PPL', 'P'),
(37814, 'Proctor', 37.5699996948242, 0.655720194647947, -83.7138900756836, -1.46108301147328, 218, 21, 'PPL', 'P'),
(57049, 'Proctor', 38.2550010681152, 0.667675723992558, -92.9355621337891, -1.62203155142639, 218, 29, 'PPL', 'P'),
(67981, 'Proctor', 35.473331451416, 0.619126430478468, -83.7263870239258, -1.46130112436656, 218, 33, 'PPL', 'P'),
(77008, 'Proctor', 35.9661102294922, 0.627727042639852, -94.7772216796875, -1.6541745742031, 218, 42, 'PPL', 'P'),
(97243, 'Proctor', 31.9872207641602, 0.558282320896891, -98.429443359375, -1.71791786752636, 218, 51, 'PPL', 'P'),
(110998, 'Proctor', 39.711669921875, 0.693099391601918, -80.8238906860352, -1.41064300674329, 218, 58, 'PPL', 'P'),
(121130, 'Proctor', 40.4122200012207, 0.705326297061608, -88.4016723632813, -1.54290024700853, 218, 18, 'PPL', 'P'),
(125895, 'Proctor', 42.5347213745117, 0.742370934403638, -70.9527816772461, -1.23835965371665, 218, 23, 'PPL', 'P'),
(137599, 'Proctor', 46.7472190856934, 0.815892889196482, -92.2252807617188, -1.60963480286818, 218, 28, 'PPL', 'P'),
(166217, 'Proctor', 41.4199981689453, 0.722915344218118, -76.8077774047852, -1.34054860685241, 218, 45, 'PPL', 'P'),
(172425, 'Proctor', 43.6605606079102, 0.762020535874569, -73.0361099243164, -1.27472059102783, 218, 55, 'PPL', 'P'),
(194383, 'Proctor', 40.8069381713867, 0.712215428748452, -102.951110839844, -1.7968358527409, 218, 7, 'PPL', 'P'),
(197310, 'Proctor', 47.8925018310547, 0.835881843969317, -114.304443359375, -1.99498888628046, 218, 31, 'PPL', 'P'),
(200142, 'Proctor', 40.8933296203613, 0.713723243978628, -114.275001525879, -1.99447502934813, 218, 39, 'PPL', 'P'),
(157250, 'Proctor (historical)', 40.0516700744629, 0.69903351372186, -83.9713897705078, -1.46557722897085, 218, 41, 'PPL', 'P'),
(90130, 'Proctor City', 36.4205589294434, 0.635658668735408, -89.4463882446289, -1.56113397888593, 218, 50, 'PPL', 'P'),
(67982, 'Proctors Corner', 36.2552795410156, 0.632773999221661, -76.9880599975586, -1.34369513168033, 218, 33, 'PPL', 'P'),
(125896, 'Proctors corner', 42.2550010681152, 0.737488894072332, -71.9652786254883, -1.25603105912987, 218, 23, 'PPL', 'P'),
(128608, 'Proctors Corner', 44.3033294677734, 0.773238968808474, -69.2891693115234, -1.2093241404579, 218, 26, 'PPL', 'P'),
(50611, 'Proctors Seat', 39.6411094665527, 0.691867879334838, -76.0319366455078, -1.32700763113184, 218, 25, 'PPL', 'P'),
(172427, 'Proctorsville', 43.3822212219238, 0.757162597151128, -72.6388931274414, -1.26778785007813, 218, 55, 'PPL', 'P'),
(57050, 'Proctorville', 39.6691703796387, 0.692357634659304, -93.7774963378906, -1.63672607537312, 218, 29, 'PPL', 'P'),
(67983, 'Proctorville', 34.476390838623, 0.601726534338381, -79.0366668701172, -1.37945006668547, 218, 33, 'PPL', 'P'),
(73984, 'Proctorville', 38.436939239502, 0.670851144118314, -82.3772201538086, -1.43775372032419, 218, 41, 'PPL', 'P'),
(208498, 'Proebstel', 45.6688919067383, 0.797072529509974, -122.480560302734, -2.13768904697018, 218, 56, 'PPL', 'P'),
(105482, 'Proffit', 38.1086082458496, 0.665120687242736, -78.4244384765625, -1.36876466544374, 218, 53, 'PPL', 'P'),
(97244, 'Proffitt', 33.1919403076172, 0.579308643493339, -98.8727798461914, -1.72565554891553, 218, 51, 'PPL', 'P'),
(97245, 'Proffitt Crossing', 33.2313919067383, 0.579997203793179, -98.8838882446289, -1.72584942704289, 218, 51, 'PPL', 'P'),
(50612, 'Profit Acres', 39.3005599975586, 0.685924169834972, -77.5083312988281, -1.35277557889112, 218, 25, 'PPL', 'P'),
(97246, 'Progreso', 26.0919399261475, 0.455390259943839, -97.9569396972656, -1.70967112289482, 218, 51, 'PPL', 'P'),
(97247, 'Progreso Lakes', 26.0713901519775, 0.455031598724033, -97.958610534668, -1.70970028450876, 218, 51, 'PPL', 'P'),
(61438, 'Progress', 31.0461101531982, 0.541856842110151, -90.3266677856445, -1.57649775521459, 218, 30, 'PPL', 'P'),
(67984, 'Progress', 35.8824996948242, 0.626267763520543, -79.9469375610352, -1.39533728732639, 218, 33, 'PPL', 'P'),
(105475, 'Progress', 36.917781829834, 0.64433684546354, -79.6755599975586, -1.39060085532768, 218, 53, 'PPL', 'P'),
(123500, 'Progress', 40.1202812194824, 0.700231004106014, -85.442497253418, -1.49125289819836, 218, 19, 'PPL', 'P'),
(151914, 'Progress', 43.0430603027344, 0.751243122417182, -74.2975006103516, -1.29673601165313, 218, 40, 'PPL', 'P'),
(166218, 'Progress', 40.2849998474121, 0.703105886502755, -76.831672668457, -1.34096565787911, 218, 45, 'PPL', 'P'),
(177745, 'Progress', 34.2827796936035, 0.598347382389234, -102.809440612793, -1.79436324082681, 218, 51, 'PPL', 'P'),
(184289, 'Progress', 39.0633316040039, 0.681783753288226, -121.800003051758, -2.12581108219232, 218, 6, 'PPL', 'P'),
(201442, 'Progress', 45.457218170166, 0.793378125866789, -122.780830383301, -2.14292974852129, 218, 43, 'PPL', 'P'),
(205429, 'Progress', 40.7277793884277, 0.710833847353947, -112.079170227051, -1.95615054336524, 218, 52, 'PPL', 'P'),
(111000, 'Progress (historical)', 38.7591705322266, 0.676475141129317, -80.8661117553711, -1.41137990341692, 218, 58, 'PPL', 'P'),
(17730, 'Progress Village', 27.8999996185303, 0.486946854648515, -82.3647232055664, -1.43753560743091, 218, 12, 'PPL', 'P'),
(189281, 'Progresso', 34.478889465332, 0.601770143601231, -105.881393432617, -1.84797893199867, 218, 38, 'PPL', 'P'),
(139406, 'Prohibition City', 40.4230613708496, 0.705515514657058, -94.4047164916992, -1.64767313219194, 218, 29, 'PPL', 'P'),
(193892, 'Project City (historical)', 40.6800003051758, 0.709999945037615, -122.350830078125, -2.13542482741139, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(117427, 'Prole', 41.4091682434082, 0.72272632635975, -93.726936340332, -1.63584363694592, 218, 16, 'PPL', 'P'),
(90131, 'Promise', 36.2097206115723, 0.631978845899191, -87.3313903808594, -1.5242203024905, 218, 50, 'PPL', 'P'),
(201441, 'Promise', 45.8416709899902, 0.800088093391298, -117.543060302734, -2.05151341515296, 218, 43, 'PPL', 'P'),
(202520, 'Promise', 45.3327789306641, 0.791206251418802, -100.603332519531, -1.7558593909445, 218, 49, 'PPL', 'P'),
(117428, 'Promise City', 40.747501373291, 0.711178060924839, -93.1469421386719, -1.62572082848447, 218, 16, 'PPL', 'P'),
(11411, 'Promised Land', 35.6347198486328, 0.621943189384418, -90.5805587768555, -1.58092898895238, 218, 4, 'PPL', 'P'),
(42700, 'Promised Land', 29.795280456543, 0.520025745521794, -90.0044403076172, -1.57087382478262, 218, 22, 'PPL', 'P'),
(83153, 'Promised Land', 34.1283302307129, 0.595651730733856, -82.2397232055664, -1.43535394586592, 218, 48, 'PPL', 'P'),
(90132, 'Promised Land', 35.9530601501465, 0.627499275787623, -83.293327331543, -1.45374280687681, 218, 50, 'PPL', 'P'),
(128609, 'Promised Land', 44.0677795410156, 0.769127847033718, -70.4391708374023, -1.22939545348744, 218, 26, 'PPL', 'P'),
(166219, 'Promised Land', 41.309440612793, 0.720985750850301, -75.210563659668, -1.312671968142, 218, 45, 'PPL', 'P'),
(61439, 'Promised Land (historical)', 33.8444404602051, 0.590696919525764, -90.5250015258789, -1.57995933199948, 218, 30, 'PPL', 'P'),
(157251, 'Promised Land Subdivision', 41.4986114501953, 0.724287404811727, -84.4258270263672, -1.47350865532932, 218, 41, 'PPL', 'P'),
(205428, 'Promontory (historical)', 41.6186103820801, 0.726381781271993, -112.547500610352, -1.96432445054096, 218, 52, 'PPL', 'P'),
(166220, 'Prompton', 41.5827789306641, 0.725756404469015, -75.3255615234375, -1.31467905949754, 218, 45, 'PPL', 'P'),
(139407, 'Pronax (historical)', 40.3886108398438, 0.704914239461946, -92.3608322143555, -1.61200062202255, 218, 29, 'PPL', 'P'),
(5237, 'Pronto', 31.7572193145752, 0.554268038317274, -85.817497253418, -1.49779788289333, 218, 2, 'PPL', 'P'),
(189282, 'Pronto', 32.1241683959961, 0.560672507975237, -107.0625, -1.86859313041643, 218, 38, 'PPL', 'P'),
(200143, 'Pronto', 40.9283294677734, 0.714334106553665, -118.059722900391, -2.06053087860397, 218, 39, 'PPL', 'P'),
(205430, 'Property Consultants Condominium', 41.0813903808594, 0.717005523443123, -111.97306060791, -1.9542985811432, 218, 52, 'PPL', 'P'),
(121131, 'Prophetstown', 41.6713905334473, 0.727302968693051, -89.9361114501953, -1.56968126124648, 218, 18, 'PPL', 'P'),
(67985, 'Propst Crossroads', 35.6272201538086, 0.621812295016841, -81.3758316040039, -1.42027619303833, 218, 33, 'PPL', 'P'),
(111006, 'Propstburg', 38.600830078125, 0.673711578866141, -79.2594375610352, -1.38333814871893, 218, 58, 'PPL', 'P'),
(137595, 'Prosit', 46.9980583190918, 0.820270859712464, -92.6175003051758, -1.61648032529217, 218, 28, 'PPL', 'P'),
(5238, 'Prospect', 33.9324989318848, 0.592233829790848, -87.4458312988281, -1.52621767330806, 218, 2, 'PPL', 'P'),
(24144, 'Prospect', 33.4088897705078, 0.583095125931214, -83.7611083984375, -1.46190712667261, 218, 13, 'PPL', 'P'),
(30900, 'Prospect', 38.5780601501465, 0.673314168652474, -86.6141662597656, -1.51170238010269, 218, 19, 'PPL', 'P'),
(33700, 'Prospect', 37.8069381713867, 0.659855551188622, -96.7888870239258, -1.68928475790832, 218, 20, 'PPL', 'P'),
(37815, 'Prospect', 38.3450012207031, 0.669246522982514, -85.6155624389648, -1.49427345550672, 218, 21, 'PPL', 'P'),
(42702, 'Prospect', 29.985559463501, 0.523346740690636, -90.3874969482422, -1.57755942438315, 218, 22, 'PPL', 'P'),
(50613, 'Prospect', 39.6902809143066, 0.692726082996116, -76.3030624389648, -1.33173966891475, 218, 25, 'PPL', 'P'),
(61441, 'Prospect', 32.5522193908691, 0.568143407202209, -89.2688903808594, -1.55803605674789, 218, 30, 'PPL', 'P'),
(67987, 'Prospect', 34.7330589294434, 0.606206237608004, -79.2300033569336, -1.38282442494465, 218, 33, 'PPL', 'P'),
(71312, 'Prospect', 39.7936096191406, 0.694529509107291, -75.3688888549805, -1.31543526408907, 218, 37, 'PPL', 'P'),
(90140, 'Prospect', 35.3675003051758, 0.617279328525417, -84.4197235107422, -1.47340212888572, 218, 50, 'PPL', 'P'),
(97250, 'Prospect', 32.8937301635742, 0.574103894616943, -95.8111114501953, -1.67221935480115, 218, 51, 'PPL', 'P'),
(105476, 'Prospect', 37.3027801513672, 0.651056333788946, -78.559440612793, -1.37112089721819, 218, 53, 'PPL', 'P'),
(113951, 'Prospect', 41.5022201538086, 0.724350388571507, -72.9791717529297, -1.27372683246706, 218, 8, 'PPL', 'P'),
(121133, 'Prospect', 40.3194389343262, 0.703706961960785, -88.2127838134766, -1.53960351989513, 218, 18, 'PPL', 'P'),
(128610, 'Prospect', 44.5530586242676, 0.777597564827524, -68.8652801513672, -1.20192587894966, 218, 26, 'PPL', 'P'),
(151915, 'Prospect', 43.3041687011719, 0.755800323674526, -75.1524963378906, -1.31165850218917, 218, 40, 'PPL', 'P'),
(157252, 'Prospect', 40.4502792358398, 0.705990556016501, -83.188606262207, -1.45191507942069, 218, 41, 'PPL', 'P'),
(166228, 'Prospect', 40.9044418334961, 0.713917188685013, -80.0466690063477, -1.39707792941486, 218, 45, 'PPL', 'P'),
(175985, 'Prospect', 42.9444389343262, 0.749521854825637, -88.1588897705078, -1.53866289139811, 218, 57, 'PPL', 'P'),
(201443, 'Prospect', 42.7511100769043, 0.746147629724506, -122.487777709961, -2.13781501448974, 218, 43, 'PPL', 'P'),
(61442, 'Prospect (historical)', 33.8574981689453, 0.590924819536047, -88.9513931274414, -1.55249468430971, 218, 30, 'PPL', 'P'),
(190631, 'Prospect (historical)', 39.4550018310547, 0.688619688332296, -116.01611328125, -2.02486316212453, 218, 39, 'PPL', 'P'),
(50614, 'Prospect Bay', 38.9180603027344, 0.679248290772416, -76.2027816772461, -1.32998943944635, 218, 25, 'PPL', 'P'),
(83154, 'Prospect Crossroads', 33.8311080932617, 0.590464225825518, -79.5550003051758, -1.38849669175041, 218, 48, 'PPL', 'P'),
(128611, 'Prospect Ferry', 44.5669403076172, 0.777839845907694, -68.8058319091797, -1.20088831138896, 218, 26, 'PPL', 'P'),
(139408, 'Prospect Grove', 40.5263900756836, 0.707318940768233, -91.9819412231445, -1.60538772671977, 218, 29, 'PPL', 'P'),
(128612, 'Prospect Harbor', 44.4088897705078, 0.77508134365059, -68.0266723632813, -1.18728941191469, 218, 26, 'PPL', 'P'),
(50615, 'Prospect Heights', 39.5633316040039, 0.690510399548198, -76.3119430541992, -1.33189466489019, 218, 25, 'PPL', 'P'),
(121134, 'Prospect Heights', 42.0952796936035, 0.734701230201291, -87.9375, -1.53479891097251, 218, 18, 'PPL', 'P'),
(146118, 'Prospect Heights', 40.2480583190918, 0.702461135202846, -74.7644424438477, -1.30488568406294, 218, 37, 'PPL', 'P'),
(151916, 'Prospect Heights', 42.6172218322754, 0.743810839026016, -73.7399978637695, -1.28700575313636, 218, 40, 'PPL', 'P'),
(187230, 'Prospect Heights', 38.4263916015625, 0.670667053107963, -105.236938476563, -1.83673107113472, 218, 7, 'PPL', 'P'),
(57051, 'Prospect Hill', 38.7374992370605, 0.676096905675498, -90.2191696166992, -1.57462155822663, 218, 29, 'PPL', 'P'),
(67988, 'Prospect Hill', 36.2491683959961, 0.632667339620004, -79.1911087036133, -1.38214558518279, 218, 33, 'PPL', 'P'),
(73986, 'Prospect Hill', 39.1152801513672, 0.682690426481343, -84.5063934326172, -1.47491480438488, 218, 41, 'PPL', 'P'),
(125897, 'Prospect Hill', 41.9438896179199, 0.732058974925769, -70.8236083984375, -1.23610515469584, 218, 23, 'PPL', 'P'),
(151917, 'Prospect Hill', 41.458610534668, 0.723589257131963, -74.6388931274414, -1.30269443511802, 218, 40, 'PPL', 'P'),
(172428, 'Prospect Hill', 43.6569404602051, 0.761957352377707, -72.9741668701172, -1.27363948078331, 218, 55, 'PPL', 'P'),
(73987, 'Prospect Hill (historical)', 38.899169921875, 0.678918591429464, -82.2444381713867, -1.4354362375436, 218, 41, 'PPL', 'P'),
(90141, 'Prospect Hill (historical)', 35.8027801513672, 0.624876395009031, -86.0352783203125, -1.50159887955915, 218, 50, 'PPL', 'P'),
(50616, 'Prospect Hills', 39.3638916015625, 0.68702951484541, -76.8944396972656, -1.34206114919352, 218, 25, 'PPL', 'P'),
(105477, 'Prospect Hills', 37.2397193908691, 0.649955715889444, -79.9625015258789, -1.39560892975758, 218, 53, 'PPL', 'P'),
(33698, 'Prospect Park', 37.6277809143066, 0.656728667173733, -97.4208297729492, -1.70031423956288, 218, 20, 'PPL', 'P'),
(146120, 'Prospect Park', 40.936939239502, 0.714484375418173, -74.1747207641602, -1.294593099082, 218, 37, 'PPL', 'P'),
(166224, 'Prospect Park', 40.6652793884277, 0.70974301657145, -75.2752838134766, -1.31380154791836, 218, 45, 'PPL', 'P'),
(146122, 'Prospect Plains', 40.3238906860352, 0.703784659685589, -74.4713897705078, -1.29977095003139, 218, 37, 'PPL', 'P'),
(37816, 'Prospect PO', 38.3563919067383, 0.669445327957889, -85.6113891601563, -1.49420061805091, 218, 21, 'PPL', 'P'),
(146123, 'Prospect Point', 40.9630584716797, 0.714940242017767, -74.6275024414063, -1.30249563014265, 218, 37, 'PPL', 'P'),
(105478, 'Prospect Valley', 37.2366714477539, 0.649902519246669, -79.9663925170898, -1.39567684036537, 218, 53, 'PPL', 'P'),
(111001, 'Prospect Valley', 39.4002799987793, 0.687664612186366, -80.3422164916992, -1.40223620613024, 218, 58, 'PPL', 'P'),
(194384, 'Prospect Valley', 40.0736083984375, 0.699416409707586, -104.414436340332, -1.82237570075281, 218, 7, 'PPL', 'P'),
(50618, 'Prospect View', 39.3811111450195, 0.687330052574425, -77.1769409179688, -1.34699172563569, 218, 25, 'PPL', 'P'),
(105479, 'Prospectdale', 37.2780609130859, 0.650624901692353, -80.7433319091797, -1.40923699084578, 218, 53, 'PPL', 'P'),
(205433, 'Prospector Hills', 40.6138916015625, 0.708846130495339, -111.787498474121, -1.95105991094155, 218, 52, 'PPL', 'P'),
(125898, 'Prospectville', 42.3958282470703, 0.739946792021393, -71.2638931274414, -1.24378957286321, 218, 23, 'PPL', 'P'),
(166226, 'Prospectville', 40.211669921875, 0.70182603786189, -75.1861114501953, -1.31224519657732, 218, 45, 'PPL', 'P'),
(67989, 'Prosper', 34.2519416809082, 0.597809157532929, -78.251106262207, -1.36573944760347, 218, 33, 'PPL', 'P'),
(97251, 'Prosper', 33.2361106872559, 0.58007956204989, -96.8008270263672, -1.68949315026362, 218, 51, 'PPL', 'P'),
(132737, 'Prosper', 44.2427787780762, 0.772182159908903, -85.0330581665039, -1.48410683804535, 218, 27, 'PPL', 'P'),
(137596, 'Prosper', 43.5077781677246, 0.7593539792541, -91.8694381713867, -1.60342417804806, 218, 28, 'PPL', 'P'),
(140746, 'Prosper', 46.9630584716797, 0.819659997137427, -97.0194396972656, -1.69330866115738, 218, 34, 'PPL', 'P'),
(172429, 'Prosper', 43.649169921875, 0.761821730899195, -72.5608291625977, -1.26642537686445, 218, 55, 'PPL', 'P'),
(201444, 'Prosper', 43.1474990844727, 0.753065923025287, -124.372497558594, -2.17070958132607, 218, 43, 'PPL', 'P'),
(57052, 'Prosperine', 37.792781829834, 0.65960847641849, -92.76611328125, -1.61907411103585, 218, 29, 'PPL', 'P'),
(558, 'Prosperity', 37.3216705322266, 0.651386033131898, -86.317497253418, -1.50652452915331, 218, 21, 'PPL', 'P'),
(11415, 'Prosperity', 35.1566696166992, 0.613599638847254, -93.165283203125, -1.6260409404475, 218, 4, 'PPL', 'P'),
(17731, 'Prosperity', 30.8516693115234, 0.538463209222576, -85.9469375610352, -1.50005704244605, 218, 12, 'PPL', 'P'),
(24145, 'Prosperity', 31.2105598449707, 0.54472703068547, -81.9372177124023, -1.43007422900484, 218, 13, 'PPL', 'P'),
(57053, 'Prosperity', 37.1263885498047, 0.647977719568815, -94.4205627441406, -1.64794970147115, 218, 29, 'PPL', 'P'),
(83155, 'Prosperity', 34.209171295166, 0.59706267347938, -81.533332824707, -1.42302510791551, 218, 48, 'PPL', 'P'),
(90144, 'Prosperity', 35.980281829834, 0.627974383726093, -86.0588912963867, -1.50201100373784, 218, 50, 'PPL', 'P'),
(111002, 'Prosperity', 37.8363914489746, 0.660369607858035, -81.2019424438477, -1.41724125466007, 218, 58, 'PPL', 'P'),
(123501, 'Prosperity', 40.1791687011719, 0.701258784549703, -85.6719436645508, -1.49525749352951, 218, 19, 'PPL', 'P'),
(166227, 'Prosperity', 40.0469398498535, 0.698950955728067, -80.2949981689453, -1.40141209093091, 218, 45, 'PPL', 'P'),
(184290, 'Prospero', 35.4711112976074, 0.619087681484608, -119.125831604004, -2.07913798566619, 218, 6, 'PPL', 'P'),
(146124, 'Prospertown', 40.1286087036133, 0.700376346122505, -74.4700012207031, -1.29974671526547, 218, 37, 'PPL', 'P'),
(142809, 'Prosser', 40.6872215270996, 0.710125979136203, -98.5763931274414, -1.72048262481416, 218, 35, 'PPL', 'P'),
(208499, 'Prosser', 46.2069396972656, 0.806463234987757, -119.767776489258, -2.0903420375302, 218, 56, 'PPL', 'P'),
(184292, 'Prosser (historical)', 39.3702812194824, 0.687141034716057, -120.124168395996, -2.09656224973025, 218, 6, 'PPL', 'P'),
(184293, 'Prosser Lake Heights', 39.351390838623, 0.686811335373105, -120.180557250977, -2.09754642091109, 218, 6, 'PPL', 'P'),
(184294, 'Prosser Lakeview Estates', 39.3630599975586, 0.687015000617469, -120.169998168945, -2.09736213016365, 218, 6, 'PPL', 'P'),
(71313, 'Prossers Mills', 39.7541694641113, 0.693841148544532, -75.0583267211914, -1.31001493232243, 218, 37, 'PPL', 'P'),
(33702, 'Protection', 37.2013893127441, 0.649286729823616, -99.4836120605469, -1.73631658223328, 218, 20, 'PPL', 'P'),
(151922, 'Protection', 42.6086082458496, 0.743660503582481, -78.4944381713867, -1.36998639059382, 218, 40, 'PPL', 'P'),
(57054, 'Protem', 36.5288887023926, 0.63754937995131, -92.8586120605469, -1.62068851928866, 218, 29, 'PPL', 'P'),
(37817, 'Protemus', 36.5533294677734, 0.637975951778913, -88.4791717529297, -1.54425286652619, 218, 21, 'PPL', 'P'),
(90152, 'Protemus', 36.4027786254883, 0.635348343889386, -89.2358322143555, -1.55745908289773, 218, 50, 'PPL', 'P'),
(184295, 'Prothero Mobile Home Park', 33.6180610656738, 0.586745853732522, -117.698059082031, -2.05421865418826, 218, 6, 'PPL', 'P'),
(11416, 'Protho Junction', 34.7675018310547, 0.606807379645062, -92.1986083984375, -1.60916928230963, 218, 4, 'PPL', 'P'),
(117429, 'Protivin', 43.2161102294922, 0.754263413409441, -92.0908279418945, -1.60728815847365, 218, 16, 'PPL', 'P'),
(157254, 'Prout (historical)', 41.351390838623, 0.721717920412991, -82.6999969482422, -1.44338723813609, 218, 41, 'PPL', 'P'),
(128614, 'Prouts Neck', 43.5333290100098, 0.759799925578634, -70.3150024414063, -1.22722830615039, 218, 26, 'PPL', 'P'),
(28345, 'Prouty', 39.6822204589844, 0.692585401511533, -89.9286117553711, -1.5695503668789, 218, 18, 'PPL', 'P'),
(42703, 'Provencal', 31.6527805328369, 0.552445237709169, -93.2019424438477, -1.62668076489939, 218, 22, 'PPL', 'P'),
(77009, 'Provence', 34.1511116027832, 0.596049340684605, -97.0205612182617, -1.69332823539139, 218, 42, 'PPL', 'P'),
(5245, 'Providence', 33.7219390869141, 0.588558867223621, -87.3338928222656, -1.52426397833238, 218, 2, 'PPL', 'P'),
(11417, 'Providence', 35.3702812194824, 0.617327864636283, -91.6761093139648, -1.60004995294693, 218, 4, 'PPL', 'P'),
(17733, 'Providence', 30.0038890838623, 0.523666652916582, -82.5475006103516, -1.44072567494266, 218, 12, 'PPL', 'P'),
(24146, 'Providence', 30.860559463501, 0.538618371645587, -84.2897186279297, -1.47113311563697, 218, 13, 'PPL', 'P'),
(30901, 'Providence', 39.4908294677734, 0.689244998556246, -86.1766662597656, -1.50406656462522, 218, 19, 'PPL', 'P'),
(37821, 'Providence', 37.3974990844727, 0.652709491035613, -87.7627792358398, -1.53174945836632, 218, 21, 'PPL', 'P'),
(50621, 'Providence', 38.7702789306641, 0.676669019256674, -75.9661102294922, -1.32585874343758, 218, 25, 'PPL', 'P'),
(57056, 'Providence', 36.5163917541504, 0.637331267058032, -89.9716720581055, -1.57030191093852, 218, 29, 'PPL', 'P'),
(61445, 'Providence', 31.4305591583252, 0.548566743055632, -89.3611068725586, -1.55964553815268, 218, 30, 'PPL', 'P'),
(67994, 'Providence', 36.4736099243164, 0.636584583267401, -79.8288879394531, -1.39327693274905, 218, 33, 'PPL', 'P'),
(83158, 'Providence', 33.3925018310547, 0.58280910243014, -80.5422210693359, -1.40572694452906, 218, 48, 'PPL', 'P'),
(90150, 'Providence', 36.3355598449707, 0.634175154850179, -86.1527786254883, -1.50364964675657, 218, 50, 'PPL', 'P'),
(105481, 'Providence', 36.9372215270996, 0.644676132186416, -78.8197174072266, -1.37566358424759, 218, 53, 'PPL', 'P'),
(111003, 'Providence', 38.8083305358887, 0.677333145053513, -81.841667175293, -1.42840655753023, 218, 58, 'PPL', 'P'),
(121136, 'Providence', 41.2780609130859, 0.720438071772126, -89.5924987792969, -1.56368408878773, 218, 18, 'PPL', 'P'),
(137597, 'Providence', 44.8344383239746, 0.782508567035685, -96.1127777099609, -1.67748442427623, 218, 28, 'PPL', 'P'),
(157255, 'Providence', 41.4183311462402, 0.722886249183209, -83.8730621337891, -1.4638610879644, 218, 41, 'PPL', 'P'),
(166230, 'Providence', 41.4338912963867, 0.72315782503537, -75.6616668701172, -1.32054520443066, 218, 45, 'PPL', 'P'),
(169563, 'Providence', 41.8238906860352, 0.729964598465503, -71.413330078125, -1.24639773967678, 218, 47, 'PPL', 'P'),
(192081, 'Providence', 34.2569389343262, 0.597896376058629, -101.520561218262, -1.77186805173113, 218, 51, 'PPL', 'P'),
(205435, 'Providence', 41.7063903808594, 0.727913831268088, -111.816390991211, -1.95156418049396, 218, 52, 'PPL', 'P'),
(208500, 'Providence', 46.9122200012207, 0.81877269844124, -118.733612060547, -2.07229246324219, 218, 56, 'PPL', 'P'),
(11418, 'Providence (historical)', 34.9805603027344, 0.610525951475139, -92.5152816772461, -1.61469627367793, 218, 4, 'PPL', 'P'),
(50622, 'Providence (historical)', 38.9988899230957, 0.680659033780858, -76.4608306884766, -1.33449324432384, 218, 25, 'PPL', 'P'),
(67995, 'Providence (historical)', 35.1011085510254, 0.612629915315329, -80.7186126708984, -1.40880555874919, 218, 33, 'PPL', 'P'),
(184296, 'Providence (historical)', 39.2588882446289, 0.685196860541271, -121.036392211914, -2.11248355883312, 218, 6, 'PPL', 'P'),
(105483, 'Providence Church', 36.7838897705078, 0.641999988186023, -76.6333312988281, -1.33750394793617, 218, 53, 'PPL', 'P'),
(50623, 'Providence Cove', 38.9988899230957, 0.680659033780858, -76.4608306884766, -1.33449324432384, 218, 25, 'PPL', 'P'),
(105484, 'Providence Forge', 37.4416694641113, 0.653480409592164, -77.0438919067383, -1.3446695823232, 218, 53, 'PPL', 'P'),
(166229, 'Providence Forge', 40.1800003051758, 0.701273298777644, -75.5233306884766, -1.31813078258639, 218, 45, 'PPL', 'P'),
(105485, 'Providence Junction', 36.7833290100098, 0.641990201069017, -76.2583312988281, -1.33095896324119, 218, 53, 'PPL', 'P'),
(50624, 'Providence Landing', 38.7636108398438, 0.676552639117038, -75.9761123657227, -1.32603331364704, 218, 25, 'PPL', 'P'),
(67997, 'Providence Mill', 35.5819396972656, 0.62102200196336, -81.1958312988281, -1.41713459505841, 218, 33, 'PPL', 'P'),
(68000, 'Providence Woods', 35.0499992370605, 0.611737889508207, -80.7436065673828, -1.40924178453575, 218, 33, 'PPL', 'P'),
(157257, 'Provident', 40.0947189331055, 0.699784858044398, -80.9091720581055, -1.41213144747654, 218, 41, 'PPL', 'P'),
(97254, 'Provident City', 29.2824993133545, 0.511076026231015, -96.6319427490234, -1.68654556356912, 218, 51, 'PPL', 'P'),
(50625, 'Provinces', 39.1372184753418, 0.68307332246707, -76.7297210693359, -1.33918626679678, 218, 25, 'PPL', 'P'),
(125899, 'Provincetown', 42.0583305358887, 0.734056345743328, -70.1791687011719, -1.224857560148, 218, 23, 'PPL', 'P'),
(341, 'Provo', 34.0374984741211, 0.594066417515959, -94.1074981689453, -1.64248569386263, 218, 4, 'PPL', 'P'),
(37823, 'Provo', 37.2330589294434, 0.649839468907862, -86.8283309936523, -1.51544025985067, 218, 21, 'PPL', 'P'),
(202522, 'Provo', 43.1911087036133, 0.753827054464831, -103.824440002441, -1.81207832208191, 218, 49, 'PPL', 'P'),
(205436, 'Provo', 40.2338905334473, 0.702213860695633, -111.657783508301, -1.94879595769887, 218, 52, 'PPL', 'P'),
(201445, 'Provolt', 42.2874984741211, 0.738056080805491, -123.22917175293, -2.15075478159422, 218, 43, 'PPL', 'P'),
(105488, 'Provost', 37.6055603027344, 0.65634084433999, -77.9830627441406, -1.36106120567458, 218, 53, 'PPL', 'P'),
(187231, 'Prowers', 38.0819396972656, 0.664655233263218, -102.767219543457, -1.79362634415319, 218, 7, 'PPL', 'P'),
(30902, 'Prowsville', 38.6800003051758, 0.675093359997729, -86.2016677856445, -1.50450292356983, 218, 19, 'PPL', 'P'),
(205437, 'Prowswood Plaza Condominium', 40.663890838623, 0.70971878180553, -111.862503051758, -1.95236898777538, 218, 52, 'PPL', 'P'),
(68005, 'Proximity', 36.0924987792969, 0.629932938970765, -79.7774963378906, -1.39237998009391, 218, 33, 'PPL', 'P'),
(37822, 'Pruden', 36.5905609130859, 0.638625763084892, -83.8913879394531, -1.46418093361132, 218, 21, 'PPL', 'P'),
(90151, 'Pruden', 36.586109161377, 0.638548065360089, -83.9011077880859, -1.46435057697276, 218, 50, 'PPL', 'P'),
(111004, 'Prudence', 37.9366683959961, 0.662119770747408, -81.1338882446289, -1.4160534848139, 218, 58, 'PPL', 'P'),
(169566, 'Prudence Park', 41.6041717529297, 0.726129779653844, -71.3302764892578, -1.24494818109545, 218, 47, 'PPL', 'P'),
(132738, 'Prudenville', 44.2983283996582, 0.773151683703746, -84.6519393920898, -1.47745506059065, 218, 27, 'PPL', 'P'),
(212116, 'Prudhoe Bay', 70.2922210693359, 1.22683069619964, -148.66943359375, -2.594771113286, 218, 1, 'PPL', 'P'),
(42705, 'Prudhomme', 30.4722194671631, 0.531840560092308, -92.3249969482422, -1.61137517864054, 218, 22, 'PPL', 'P'),
(77010, 'Prue', 36.2380599975586, 0.632473461492646, -96.3163909912109, -1.68103814643484, 218, 42, 'PPL', 'P'),
(28346, 'Pruett', 39.0647201538086, 0.681807988054146, -88.9108276367188, -1.55178668293391, 218, 18, 'PPL', 'P'),
(97255, 'Pruett', 32.8916702270508, 0.574067941942227, -94.357780456543, -1.64685394384063, 218, 51, 'PPL', 'P'),
(11419, 'Pruitt', 36.0622215270996, 0.629404501231466, -93.1366729736328, -1.62554159774311, 218, 4, 'PPL', 'P'),
(24148, 'Pruitt', 34.4263916015625, 0.600853883028189, -83.4391708374023, -1.45628825624671, 218, 13, 'PPL', 'P'),
(97256, 'Pruitt', 32.5675010681152, 0.568410122785381, -95.64111328125, -1.66925232703069, 218, 51, 'PPL', 'P'),
(77011, 'Pruitt City', 34.4199981689453, 0.600742296578515, -97.5100021362305, -1.70187059090393, 218, 42, 'PPL', 'P'),
(97257, 'Pruitt Lake', 32.9516716003418, 0.575115163461873, -94.5025024414063, -1.64937981897652, 218, 51, 'PPL', 'P'),
(5246, 'Pruitton', 34.9902801513672, 0.610695594836577, -87.6094436645508, -1.5290732477869, 218, 2, 'PPL', 'P'),
(184298, 'Prunedale', 36.7758293151855, 0.641859306701439, -121.668609619141, -2.12351783417765, 218, 6, 'PPL', 'P'),
(111005, 'Prunty', 39.1072196960449, 0.68254974499676, -81.0055618286133, -1.41381376633714, 218, 58, 'PPL', 'P'),
(111007, 'Pruntytown', 39.3338890075684, 0.686505870796073, -80.0769424438477, -1.39760630057514, 218, 58, 'PPL', 'P'),
(117432, 'Prussia', 41.3738899230957, 0.722110603515724, -94.5061111450195, -1.6494428027363, 218, 16, 'PPL', 'P'),
(151919, 'Prussian Settlement', 43.4524993896484, 0.758389182570192, -75.5077819824219, -1.31785940647131, 218, 40, 'PPL', 'P'),
(11420, 'Pryor', 35.1749992370605, 0.6139195510732, -91.5486068725586, -1.59782461554006, 218, 4, 'PPL', 'P'),
(77012, 'Pryor', 36.3083305358887, 0.633699913753655, -95.3166732788086, -1.66358978076291, 218, 42, 'PPL', 'P'),
(187233, 'Pryor', 37.5080604553223, 0.654639150982457, -104.713607788086, -1.82759722754408, 218, 7, 'PPL', 'P'),
(197311, 'Pryor', 45.4297218322754, 0.792898224238357, -108.532501220703, -1.89424949172603, 218, 31, 'PPL', 'P'),
(11421, 'Pryor Ridge (historical)', 34.3344383239746, 0.59924899557628, -94.216667175293, -1.64439105246453, 218, 4, 'PPL', 'P'),
(37825, 'Pryorsburg', 36.6866683959961, 0.640303155097479, -88.7141723632813, -1.54835440092102, 218, 21, 'PPL', 'P'),
(28348, 'Pryortown', 37.1902809143066, 0.649092851696258, -89.1486129760742, -1.55593682001864, 218, 18, 'PPL', 'P'),
(37824, 'Pryse', 37.6586112976074, 0.657266758871984, -83.8755569458008, -1.46390463064822, 218, 21, 'PPL', 'P'),
(212117, 'Ptarmigan', 61.1886100769043, 1.06794271056096, -145.621673583984, -2.54157766630498, 218, 1, 'PPL', 'P'),
(210986, 'Pua Loke', 21.9722194671631, 0.38348757367279, -159.375823974609, -2.78163287643585, 218, 15, 'PPL', 'P'),
(210990, 'PuaÃ‚â€˜ÃƒÂ¤kala', 19.7900009155273, 0.345400674948644, -155.334716796875, -2.71110225075841, 218, 15, 'PPL', 'P'),
(210996, 'Puako', 19.9750003814697, 0.34862952474377, -155.843887329102, -2.71998895299989, 218, 15, 'PPL', 'P'),
(210997, 'Pualaa', 19.4716701507568, 0.339844754993007, -154.836395263672, -2.70240489927043, 218, 15, 'PPL', 'P'),
(211047, 'PuÃ‚â€˜uanahulu', 19.8186092376709, 0.345899984363521, -155.846389770508, -2.72003262884177, 218, 15, 'PPL', 'P'),
(211050, 'PuÃ‚â€˜uÃ‚â€˜eo', 19.7336101531982, 0.344416470478292, -155.092224121094, -2.70686995515405, 218, 15, 'PPL', 'P'),
(211058, 'PuÃ‚â€˜uiki', 20.7049999237061, 0.361370420293845, -156.002212524414, -2.72275224894696, 218, 15, 'PPL', 'P'),
(211071, 'PuÃ‚â€˜uloa', 21.3500003814697, 0.372627801958692, -157.949996948242, -2.75674750026182, 218, 15, 'PPL', 'P'),
(211077, 'PuÃ‚â€˜unui', 21.3369407653809, 0.372399868658895, -157.850830078125, -2.75501671186938, 218, 15, 'PPL', 'P'),
(211085, 'PuÃ‚â€˜uwai', 21.9022197723389, 0.382265848522716, -160.19416809082, -2.79591567567805, 218, 15, 'PPL', 'P'),
(105489, 'Public Fork', 36.8277816772461, 0.642766046473584, -78.6463928222656, -1.37263849956537, 218, 53, 'PPL', 'P'),
(50627, 'Public Landing', 38.1488914489746, 0.665823761770517, -75.2877807617188, -1.31401966081164, 218, 25, 'PPL', 'P'),
(105490, 'Public Landing', 36.5688896179199, 0.638247527631074, -75.9938888549805, -1.32634357191403, 218, 53, 'PPL', 'P'),
(144347, 'Puckershire', 43.3561096191406, 0.756706863709589, -72.3161087036133, -1.26215419910818, 218, 36, 'PPL', 'P'),
(151920, 'Puckerville', 42.7866706848145, 0.746768279416549, -75.8758316040039, -1.32428308417864, 218, 40, 'PPL', 'P'),
(42704, 'Puckett', 30.5683307647705, 0.533518018683922, -91.0480575561523, -1.58908838190016, 218, 22, 'PPL', 'P'),
(61446, 'Puckett', 32.0808296203613, 0.559916103646628, -89.7758331298828, -1.56688387683746, 218, 30, 'PPL', 'P'),
(11422, 'Puckett (historical)', 36.3536109924316, 0.634490206807136, -94.043327331543, -1.6413657014662, 218, 4, 'PPL', 'P'),
(105491, 'Pucketts Store', 37.0333290100098, 0.646353524199002, -81.6044387817383, -1.42426614098348, 218, 53, 'PPL', 'P'),
(42706, 'Puckettville', 32.622501373291, 0.5693700592003, -91.942497253418, -1.60469929957799, 218, 22, 'PPL', 'P'),
(175986, 'Pucketville', 44.5694389343262, 0.777883455170544, -92.5391693115234, -1.61511319154658, 218, 57, 'PPL', 'P'),
(151921, 'Pudding Hollow', 43.7972183227539, 0.764405662946844, -74.0119400024414, -1.2917520388311, 218, 40, 'PPL', 'P'),
(144348, 'Puddle Dock (historical)', 43.0752792358398, 0.751805448881352, -70.7558288574219, -1.23492217853963, 218, 36, 'PPL', 'P'),
(113954, 'Puddle Town', 41.8666687011719, 0.730711215677107, -72.958610534668, -1.27336797151018, 218, 8, 'PPL', 'P'),
(121138, 'Puder', 41.2449989318848, 0.719861031342934, -87.6066665649414, -1.52902477825506, 218, 18, 'PPL', 'P'),
(189284, 'Pueblito', 36.0747184753418, 0.629622614124743, -106.076667785645, -1.8513871124037, 218, 38, 'PPL', 'P'),
(189285, 'Pueblitos', 34.6230583190918, 0.604286364778165, -106.777221679688, -1.86361408444242, 218, 38, 'PPL', 'P'),
(30903, 'Pueblo', 37.8261108398438, 0.660190177379591, -87.1102828979492, -1.52036124891292, 218, 19, 'PPL', 'P'),
(37826, 'Pueblo', 36.8097190856934, 0.642450794779546, -84.7083282470703, -1.47843923177149, 218, 21, 'PPL', 'P'),
(97258, 'Pueblo', 32.4987602233887, 0.5672103687143, -99.1210174560547, -1.72998811253493, 218, 51, 'PPL', 'P'),
(187234, 'Pueblo', 38.2544403076172, 0.667665936875552, -104.608612060547, -1.82576470639799, 218, 7, 'PPL', 'P'),
(190632, 'Pueblo (historical)', 39.0088882446289, 0.680833537411286, -117.211669921875, -2.04572956189752, 218, 39, 'PPL', 'P'),
(184305, 'Pueblo de Figueroa (historical)', 36.978889465332, 0.645403374901089, -122.029441833496, -2.12981554436541, 218, 6, 'PPL', 'P'),
(184306, 'Pueblo del Sol Mobile Park', 33.7136116027832, 0.58841352520713, -116.243606567383, -2.02883366899373, 218, 6, 'PPL', 'P'),
(97259, 'Pueblo East Colonia', 27.6749992370605, 0.483019857173625, -99.1900024414063, -1.73119212766375, 218, 51, 'PPL', 'P'),
(178923, 'Pueblo Gardens', 32.1961097717285, 0.561928121850183, -110.938606262207, -1.93624394684911, 218, 5, 'PPL', 'P'),
(192084, 'Pueblo Nuevo', 30.1216697692871, 0.525722313672501, -104.660278320313, -1.82666645274309, 218, 51, 'PPL', 'P'),
(97260, 'Pueblo Nuevo Colonia', 27.4939994812012, 0.479860815488573, -99.3099975585938, -1.73328643754499, 218, 51, 'PPL', 'P'),
(189288, 'Pueblo of Sandia Village', 35.2550010681152, 0.615315846432729, -106.57250213623, -1.86004105436591, 218, 38, 'PPL', 'P'),
(189287, 'Pueblo Pintado', 35.9772186279297, 0.62792092076721, -107.672782897949, -1.87924457635426, 218, 38, 'PPL', 'P'),
(178922, 'Pueblo Sereno Mobile Home Park', 33.4533309936523, 0.5838707715987, -111.901672363281, -1.9530526212272, 218, 5, 'PPL', 'P'),
(192082, 'Pueblo Vitoria', 30.9663906097412, 0.540465473598639, -103.776107788086, -1.81123476580663, 218, 51, 'PPL', 'P'),
(187236, 'Pueblo West', 38.3499984741211, 0.669333741508214, -104.722221374512, -1.82774756298761, 218, 7, 'PPL', 'P'),
(192083, 'Puente', 35.4455604553223, 0.618641735160074, -101.885276794434, -1.77823353936864, 218, 51, 'PPL', 'P'),
(184308, 'Puente Junction', 34.0141716003418, 0.593659286764313, -117.959442138672, -2.05878064913557, 218, 6, 'PPL', 'P'),
(97261, 'Puerta Blanca Colonia', 26.2819995880127, 0.458707426818615, -98.4400024414063, -1.7181021582738, 218, 51, 'PPL', 'P'),
(97262, 'Puerta del Sol Colonia', 26.4029998779297, 0.460819280273534, -98.1419982910156, -1.71290100466487, 218, 51, 'PPL', 'P'),
(189290, 'Puertecito', 34.4480590820313, 0.601232051902981, -107.392219543457, -1.87434782205793, 218, 38, 'PPL', 'P'),
(189291, 'Puerto (historical)', 34.922779083252, 0.609517478949353, -103.53556060791, -1.80703642550617, 218, 38, 'PPL', 'P'),
(189292, 'Puerto De Luna', 34.8319396972656, 0.607932032573402, -104.620826721191, -1.82597789244325, 218, 38, 'PPL', 'P'),
(97263, 'Puerto Rico', 26.649169921875, 0.465115758060159, -98.3452835083008, -1.71644900102713, 218, 51, 'PPL', 'P'),
(178924, 'Puertocito', 31.6097202301025, 0.551693693649549, -111.496391296387, -1.9459791322139, 218, 5, 'PPL', 'P'),
(189293, 'Puertocito', 35.9172210693359, 0.626873765826591, -105.301391601563, -1.83785599037917, 218, 38, 'PPL', 'P'),
(189294, 'Puesta Del Sol', 35.3063888549805, 0.61621273250884, -106.452781677246, -1.85795153817464, 218, 38, 'PPL', 'P'),
(97264, 'Puesta del Sol Colonia', 26.2259998321533, 0.457730046698556, -97.9700012207031, -1.70989908948413, 218, 51, 'PPL', 'P'),
(208501, 'Puget', 47.146671295166, 0.822864645456146, -122.792503356934, -2.14313348034468, 218, 56, 'PPL', 'P'),
(11423, 'Pugh', 33.2394409179688, 0.580137685540681, -91.9619369506836, -1.60503858630086, 218, 4, 'PPL', 'P'),
(111008, 'Pugh', 38.6580581665039, 0.674710397432975, -80.399169921875, -1.40323023100711, 218, 58, 'PPL', 'P'),
(105492, 'Pughs', 36.7511100769043, 0.641427874604846, -82.9916687011719, -1.44847787055978, 218, 53, 'PPL', 'P'),
(105498, 'Pughsville', 36.8477783203125, 0.643115053734439, -76.4436111450195, -1.33419270659482, 218, 53, 'PPL', 'P'),
(166231, 'Pughtown', 40.1666717529297, 0.701040671656425, -75.6658325195313, -1.32061790872842, 218, 45, 'PPL', 'P'),
(211009, 'Puhi', 21.9686107635498, 0.38342458991301, -159.399444580078, -2.78204513377259, 218, 15, 'PPL', 'P'),
(42707, 'Pujo', 30.7933292388916, 0.537444982869298, -93.4027786254883, -1.63018601752615, 218, 22, 'PPL', 'P'),
(211010, 'Pukaauhuhu', 20.6352806091309, 0.360153588702275, -156.150283813477, -2.72533658046877, 218, 15, 'PPL', 'P'),
(211011, 'Pukalani', 20.836669921875, 0.363668495287988, -156.336669921875, -2.7285896317403, 218, 15, 'PPL', 'P'),
(171130, 'Pukwana', 43.7780609130859, 0.764071303071985, -99.1811065673828, -1.7310368653722, 218, 49, 'PPL', 'P'),
(175991, 'Pukwana Beach', 43.9277801513672, 0.76668439673357, -88.3169403076172, -1.54142139365521, 218, 57, 'PPL', 'P'),
(11424, 'Pulaski', 34.7683296203613, 0.606821827293975, -92.3097229003906, -1.61110859621543, 218, 4, 'PPL', 'P'),
(24149, 'Pulaski', 32.3899993896484, 0.565312134068319, -81.9569396972656, -1.43041844257573, 218, 13, 'PPL', 'P'),
(37828, 'Pulaski', 37.2088890075684, 0.649417624191193, -84.6388931274414, -1.47722736031745, 218, 21, 'PPL', 'P'),
(57057, 'Pulaski', 36.6138916015625, 0.639032960415565, -90.7466735839844, -1.58382823927309, 218, 29, 'PPL', 'P'),
(61447, 'Pulaski', 32.2719383239746, 0.563251579753897, -89.6022186279297, -1.56385373214917, 218, 30, 'PPL', 'P'),
(77013, 'Pulaski', 35.8136100769043, 0.6250654128674, -96.4394378662109, -1.68318571953788, 218, 42, 'PPL', 'P'),
(90153, 'Pulaski', 35.1997184753418, 0.614350983169793, -87.0308303833008, -1.51897454093332, 218, 50, 'PPL', 'P'),
(105493, 'Pulaski', 37.047779083252, 0.646605725554233, -80.7799987792969, -1.40987694845573, 218, 53, 'PPL', 'P'),
(117434, 'Pulaski', 40.6969413757324, 0.710295622497641, -92.273063659668, -1.61046877176353, 218, 16, 'PPL', 'P'),
(121139, 'Pulaski', 40.2024993896484, 0.701665981880376, -90.9411087036133, -1.58722177229212, 218, 18, 'PPL', 'P'),
(123502, 'Pulaski', 40.9752807617188, 0.715153561221082, -86.658332824707, -1.51247323208022, 218, 19, 'PPL', 'P'),
(132739, 'Pulaski', 42.1150016784668, 0.735045443772184, -84.6425018310547, -1.47729034407723, 218, 27, 'PPL', 'P'),
(151923, 'Pulaski', 43.5669403076172, 0.760386553387751, -76.128059387207, -1.32868528946054, 218, 40, 'PPL', 'P'),
(157258, 'Pulaski', 41.5105590820313, 0.72449593032508, -84.5077819824219, -1.4749390391508, 218, 41, 'PPL', 'P'),
(166232, 'Pulaski', 41.1133308410645, 0.717562989638304, -80.432502746582, -1.40381199854724, 218, 45, 'PPL', 'P'),
(175987, 'Pulaski', 44.6722183227539, 0.779677293901795, -88.2425003051758, -1.54012217051742, 218, 57, 'PPL', 'P'),
(11426, 'Pulaski Heights', 34.7569389343262, 0.606623022318601, -92.3166732788086, -1.61122990320308, 218, 4, 'PPL', 'P'),
(137600, 'Pulaski Mobile Home Park', 45.1719398498535, 0.788399079892777, -93.8744430541992, -1.6384181147717, 218, 28, 'PPL', 'P'),
(157260, 'Pulaskiville', 40.5338897705078, 0.70744983513581, -82.7102813720703, -1.44356673519356, 218, 41, 'PPL', 'P'),
(113014, 'Pulcifer', 44.8441696166992, 0.782678410134205, -88.3600006103516, -1.54217293771483, 218, 57, 'PPL', 'P'),
(184309, 'Pulga', 39.8030586242676, 0.694694425357794, -121.44750213623, -2.11965878060007, 218, 6, 'PPL', 'P'),
(146125, 'Pulis Mills', 41.0302810668945, 0.716113497636001, -74.1766662597656, -1.2946270543859, 218, 37, 'PPL', 'P'),
(5247, 'Pull Tight', 34.021110534668, 0.593780394014884, -87.7847213745117, -1.53213242093107, 218, 2, 'PPL', 'P'),
(5248, 'Pull Tight (historical)', 34.023609161377, 0.593824003277735, -86.0194396972656, -1.501322443438, 218, 2, 'PPL', 'P'),
(61448, 'Pullen', 34.1549987792969, 0.596117184713374, -90.6586074829102, -1.58229119584995, 218, 30, 'PPL', 'P'),
(166235, 'Pullen', 40.4913902282715, 0.706708078193196, -75.3005599975586, -1.31424270055293, 218, 45, 'PPL', 'P'),
(105495, 'Pullens', 36.9347190856934, 0.644632456344539, -79.498893737793, -1.38751744741759, 218, 53, 'PPL', 'P'),
(146126, 'Pullentown', 40.1722183227539, 0.70113747756205, -74.5480575561523, -1.3011090553211, 218, 37, 'PPL', 'P'),
(105496, 'Pullers Corner', 38.1572189331055, 0.665969103787008, -77.3424987792969, -1.34988125541843, 218, 53, 'PPL', 'P'),
(105497, 'Pulleys Crossroads', 36.8708305358887, 0.643517390796123, -76.9641723632813, -1.34327821381168, 218, 53, 'PPL', 'P'),
(37830, 'Pulliam', 37.8458290100098, 0.660534324371456, -85.1497192382813, -1.48614295785677, 218, 21, 'PPL', 'P'),
(194385, 'Pulliam', 40.3205604553223, 0.703726536194798, -104.943328857422, -1.83160661656519, 218, 7, 'PPL', 'P'),
(11428, 'Pullman', 34.1144409179688, 0.595409316495631, -94.3163909912109, -1.64613156139495, 218, 4, 'PPL', 'P'),
(111009, 'Pullman', 39.1872215270996, 0.683946040356288, -80.9499969482422, -1.41284397622619, 218, 58, 'PPL', 'P'),
(121140, 'Pullman', 41.6927795410156, 0.727676277298853, -87.605827331543, -1.52901013086906, 218, 18, 'PPL', 'P'),
(132742, 'Pullman', 42.4836082458496, 0.741478842017488, -86.0913925170898, -1.50257825705003, 218, 27, 'PPL', 'P'),
(192085, 'Pullman', 35.1961097717285, 0.614287999410012, -101.706108093262, -1.77510645561667, 218, 51, 'PPL', 'P'),
(208503, 'Pullman', 46.7313919067383, 0.815616652812414, -117.178611755371, -2.04515258804736, 218, 56, 'PPL', 'P'),
(208502, 'Pullman Junction', 46.714168548584, 0.815316048504371, -117.160003662109, -2.04482781555242, 218, 56, 'PPL', 'P'),
(105499, 'Pullontown', 36.6222190856934, 0.639178302432057, -82.3133316040039, -1.43663865477577, 218, 53, 'PPL', 'P'),
(5250, 'Pulltight', 34.1866683959961, 0.596669923797621, -86.0708312988281, -1.50221939609314, 218, 2, 'PPL', 'P'),
(57059, 'Pulltight', 36.7825012207031, 0.641975753420103, -89.3191680908203, -1.55891356832707, 218, 29, 'PPL', 'P'),
(175990, 'Pulp', 45.8730583190918, 0.800635905627527, -88.1055603027344, -1.53773211659713, 218, 57, 'PPL', 'P'),
(128615, 'Pulpit Harbor', 44.1586112976074, 0.770713160251615, -68.8841705322266, -1.20225557829261, 218, 26, 'PPL', 'P'),
(42708, 'Pulpwood Spur', 32.0766716003418, 0.559843532506923, -92.1055603027344, -1.6075452866769, 218, 22, 'PPL', 'P'),
(151924, 'Pulteney', 42.5250015258789, 0.7422012910422, -77.1675033569336, -1.34682700912227, 218, 40, 'PPL', 'P'),
(187237, 'Pultney', 38.1622200012207, 0.666056388891736, -104.047218322754, -1.81596653727343, 218, 7, 'PPL', 'P'),
(151926, 'Pultneyville', 43.2797203063965, 0.755373618688868, -77.186393737793, -1.34715670846522, 218, 40, 'PPL', 'P'),
(211022, 'Pulu (historical)', 19.5625, 0.341430034921391, -155.102493286133, -2.70704918589542, 218, 15, 'PPL', 'P'),
(151927, 'Pulvers', 42.2802810668945, 0.737930113285931, -73.6486129760742, -1.28541078595952, 218, 40, 'PPL', 'P'),
(151928, 'Pulvers Corners', 41.9766693115234, 0.732631088506945, -73.5849990844727, -1.28430051410106, 218, 40, 'PPL', 'P'),
(11429, 'Pump Springs (historical)', 34.0016708374023, 0.593441107292008, -93.8266677856445, -1.63758427903439, 218, 4, 'PPL', 'P'),
(50630, 'Pumphrey', 39.2172203063965, 0.684469617826598, -76.6374969482422, -1.33757665223393, 218, 25, 'PPL', 'P'),
(192086, 'Pumphrey', 32.0386085510254, 0.559179206973003, -100.038063049316, -1.74599357752825, 218, 51, 'PPL', 'P'),
(24151, 'Pumpkin', 33.9286117553711, 0.592165985762078, -84.8952789306641, -1.48170213673906, 218, 13, 'PPL', 'P'),
(97265, 'Pumpkin', 30.5472297668457, 0.533149736794677, -95.2839584350586, -1.6630187990252, 218, 51, 'PPL', 'P'),
(11431, 'Pumpkin Bend', 35.2963905334473, 0.616038228878413, -91.1022186279297, -1.59003367092908, 218, 4, 'PPL', 'P'),
(5253, 'Pumpkin Center', 33.6394386291504, 0.587118962601242, -87.1544418334961, -1.52113196773239, 218, 2, 'PPL', 'P'),
(17734, 'Pumpkin Center', 28.7180595397949, 0.501224693753189, -81.8294372558594, -1.42819310516886, 218, 12, 'PPL', 'P'),
(30905, 'Pumpkin Center', 38.7041702270508, 0.675515204714397, -85.9505615234375, -1.50012029252194, 218, 19, 'PPL', 'P'),
(37829, 'Pumpkin Center', 37.1241683959961, 0.647938970574954, -87.8477783203125, -1.53323297225155, 218, 21, 'PPL', 'P'),
(42709, 'Pumpkin Center', 30.454719543457, 0.531535128804789, -90.5419387817383, -1.58025494288048, 218, 22, 'PPL', 'P'),
(50628, 'Pumpkin Center', 39.6216697692871, 0.691528592611962, -78.565559387207, -1.3712276899779, 218, 25, 'PPL', 'P'),
(61449, 'Pumpkin Center', 34.5313911437988, 0.6026864707533, -89.0344390869141, -1.55394410973298, 218, 30, 'PPL', 'P'),
(68008, 'Pumpkin Center', 35.7108306884766, 0.623271574136149, -81.7005615234375, -1.42594379931218, 218, 33, 'PPL', 'P'),
(77015, 'Pumpkin Center', 35.6819381713867, 0.622767304583743, -95.7841720581055, -1.67174917371069, 218, 42, 'PPL', 'P'),
(90156, 'Pumpkin Center', 35.8105583190918, 0.625012149645598, -84.0758285522461, -1.46740002957895, 218, 50, 'PPL', 'P'),
(105500, 'Pumpkin Center', 37.2275009155273, 0.649742463265156, -81.0086135864258, -1.41386702955894, 218, 53, 'PPL', 'P'),
(139409, 'Pumpkin Center', 40.2002792358398, 0.701627232886515, -94.8675003051758, -1.65575023346204, 218, 29, 'PPL', 'P'),
(171135, 'Pumpkin Center', 43.5433311462402, 0.759974495788089, -97.0883331298828, -1.69451107838955, 218, 49, 'PPL', 'P'),
(178925, 'Pumpkin Center', 35.4147186279297, 0.618103443724742, -111.915283203125, -1.95329017519644, 218, 5, 'PPL', 'P'),
(193893, 'Pumpkin Center', 41.1100006103516, 0.717504866147513, -121.105560302734, -2.11369076975526, 218, 6, 'PPL', 'P'),
(151929, 'Pumpkin Hill', 43.0969390869141, 0.752183484598089, -78.0663909912109, -1.36251555794587, 218, 40, 'PPL', 'P'),
(172430, 'Pumpkin Hill (historical)', 44.422779083252, 0.775323757888815, -72.0774993896484, -1.25798968095357, 218, 55, 'PPL', 'P'),
(151931, 'Pumpkin Hollow', 43.350830078125, 0.756614718335872, -74.2622222900391, -1.29612028880911, 218, 40, 'PPL', 'P'),
(151932, 'Pumpkin Hook', 43.0180587768555, 0.750806763472573, -73.2975006103516, -1.27928271913319, 218, 40, 'PPL', 'P'),
(24152, 'Pumpkintown', 31.8819408416748, 0.556444839613278, -84.7947235107422, -1.4799471135807, 218, 13, 'PPL', 'P'),
(68009, 'Pumpkintown', 35.2538909912109, 0.615296471935798, -83.2822189331055, -1.45354892874945, 218, 33, 'PPL', 'P'),
(83160, 'Pumpkintown', 35.0027809143066, 0.610913774308882, -82.6530609130859, -1.44256804978478, 218, 48, 'PPL', 'P'),
(90157, 'Pumpkintown', 36.5872192382813, 0.63856743985702, -85.9108276367188, -1.49942680537408, 218, 50, 'PPL', 'P'),
(111010, 'Pumpkintown', 38.8927803039551, 0.678807071558817, -80.0244369506836, -1.39668990684404, 218, 58, 'PPL', 'P'),
(146127, 'Pumptown', 40.563060760498, 0.707958964957206, -74.3736114501953, -1.29806439640486, 218, 37, 'PPL', 'P'),
(192087, 'Pumpville', 29.9433307647705, 0.522609710858957, -101.73722076416, -1.77564947416294, 218, 51, 'PPL', 'P'),
(211027, 'Punahou', 21.2999992370605, 0.371755117358987, -157.83332824707, -2.75471124729235, 218, 15, 'PPL', 'P'),
(211029, 'PunaluÃ‚â€˜u', 19.1391696929932, 0.334041527240643, -155.507217407227, -2.71411295437074, 218, 15, 'PPL', 'P'),
(211031, 'PunaluÃ‚â€˜u', 21.5925006866455, 0.376860230721101, -157.896667480469, -2.75581672546084, 218, 15, 'PPL', 'P'),
(211032, 'Punaluu', 21.5738906860352, 0.376535424936652, -157.878616333008, -2.75550167350388, 218, 15, 'PPL', 'P'),
(211034, 'Punaluu Kahawai', 19.2508296966553, 0.335990361947336, -155.609176635742, -2.71589247861113, 218, 15, 'PPL', 'P'),
(37831, 'Puncheon', 37.3016700744629, 0.651036959292016, -82.789436340332, -1.44494825000904, 218, 21, 'PPL', 'P'),
(90158, 'Puncheon Camp', 36.3147201538086, 0.633811433624302, -83.5391693115234, -1.45803355886709, 218, 50, 'PPL', 'P'),
(83161, 'Puncheon Creek', 33.4430618286133, 0.583691540857337, -79.5108337402344, -1.38772583977289, 218, 48, 'PPL', 'P'),
(50629, 'Puncheon Landing', 38.0763893127441, 0.664558360778566, -75.6072235107422, -1.31959498855372, 218, 25, 'PPL', 'P'),
(68010, 'Pungo', 35.6366691589355, 0.621977211267344, -76.6122207641602, -1.33713549959936, 218, 33, 'PPL', 'P'),
(105501, 'Pungo', 36.723331451416, 0.640943046128397, -76.0180587768555, -1.3267654166307, 218, 53, 'PPL', 'P'),
(105503, 'Pungo Ferry', 36.6152801513672, 0.639057195181485, -76.0466690063477, -1.32726475933509, 218, 53, 'PPL', 'P'),
(105502, 'Pungoteague', 37.6302795410156, 0.656772276436583, -75.8138885498047, -1.32320197393412, 218, 53, 'PPL', 'P'),
(33703, 'Punkin Center', 38.0138893127441, 0.66346752999607, -97.7750015258789, -1.70649570276907, 218, 20, 'PPL', 'P'),
(42710, 'Punkin Center', 32.3002815246582, 0.56374626192638, -92.7008285522461, -1.61793467756346, 218, 22, 'PPL', 'P'),
(57061, 'Punkin Center', 39.2008285522461, 0.684183527746496, -92.5088882446289, -1.61458468722825, 218, 29, 'PPL', 'P'),
(178926, 'Punkin Center', 33.8722190856934, 0.591181748002212, -111.3125, -1.94276962362619, 218, 5, 'PPL', 'P'),
(187238, 'Punkin Center', 38.8519401550293, 0.678094276493057, -103.699996948242, -1.8099063810549, 218, 7, 'PPL', 'P'),
(192088, 'Punkin Center', 32.8502807617188, 0.573345559496543, -102.04972076416, -1.78110362807542, 218, 51, 'PPL', 'P'),
(195503, 'Punkin Corner', 43.3133316040039, 0.755960246497985, -114.909172058105, -2.00554339315461, 218, 17, 'PPL', 'P'),
(151933, 'Punkshire Corners', 42.600830078125, 0.743524748945914, -78.4472198486328, -1.36916227539449, 218, 40, 'PPL', 'P'),
(184312, 'Punta', 34.3624992370605, 0.599738750900746, -119.445831298828, -2.08472303394625, 218, 6, 'PPL', 'P'),
(189295, 'Punta de Agua', 34.5999984741211, 0.603883894558427, -106.283332824707, -1.8549940977841, 218, 38, 'PPL', 'P'),
(17735, 'Punta Gorda', 26.9294395446777, 0.470007385771389, -82.0455627441406, -1.43196520653685, 218, 12, 'PPL', 'P'),
(17736, 'Punta Gorda Beach', 26.923059463501, 0.46989603234831, -82.3600006103516, -1.43745318259517, 218, 12, 'PPL', 'P'),
(17737, 'Punta Gorda Isles', 26.9172191619873, 0.469794099857587, -82.07861328125, -1.43254204722896, 218, 12, 'PPL', 'P'),
(17738, 'Punta Rassa', 26.4874992370605, 0.462294072306193, -82.0124969482422, -1.43138809952863, 218, 12, 'PPL', 'P'),
(166236, 'Punxsutawney', 40.9436111450195, 0.714600822136836, -78.9711074829102, -1.37830583952311, 218, 45, 'PPL', 'P'),
(211041, 'Puopelu', 20.0166702270508, 0.349356800747957, -155.683334350586, -2.71718677490091, 218, 15, 'PPL', 'P'),
(137602, 'Puposky', 47.6777801513672, 0.832134243683358, -94.9069366455078, -1.65643852744577, 218, 28, 'PPL', 'P'),
(30906, 'Purcell', 38.5955581665039, 0.673619566650479, -87.519172668457, -1.52749772168601, 218, 19, 'PPL', 'P'),
(33710, 'Purcell', 39.6805610656738, 0.692556439634678, -95.3305587768555, -1.66383212842211, 218, 20, 'PPL', 'P'),
(57062, 'Purcell', 37.2422218322754, 0.649999391731321, -94.4349975585938, -1.64820163651027, 218, 29, 'PPL', 'P'),
(77016, 'Purcell', 35.0136108398438, 0.61110279216725, -97.3608322143555, -1.69926708462226, 218, 42, 'PPL', 'P'),
(78986, 'Purcell', 39.788330078125, 0.694437363733574, -78.3675003051758, -1.36777090688298, 218, 45, 'PPL', 'P'),
(105505, 'Purcell', 36.7961082458496, 0.642213240810311, -82.995002746582, -1.44853606062959, 218, 53, 'PPL', 'P'),
(194386, 'Purcell', 40.6383285522461, 0.709272635743915, -104.601112365723, -1.82563381203042, 218, 7, 'PPL', 'P'),
(24153, 'Purcell Valley', 33.9691696166992, 0.592873853979822, -84.0583267211914, -1.46709456500192, 218, 13, 'PPL', 'P'),
(105506, 'Purcellville', 39.1366691589355, 0.683063735087145, -77.7149963378906, -1.35638256427153, 218, 53, 'PPL', 'P'),
(151934, 'Purchase', 41.040828704834, 0.716297588646353, -73.7149963378906, -1.28656939419175, 218, 40, 'PPL', 'P'),
(166238, 'Purchase Line', 40.7363891601563, 0.710984116218454, -78.9291687011719, -1.37757386969751, 218, 45, 'PPL', 'P'),
(57068, 'Purdin', 39.9519386291504, 0.697292871633384, -93.1655578613281, -1.62604573413746, 218, 29, 'PPL', 'P'),
(97269, 'Purdon', 31.9488906860352, 0.557613334831063, -96.6163864135742, -1.68627405429599, 218, 51, 'PPL', 'P'),
(90159, 'Purdons (historical)', 35.3908309936523, 0.61768652585609, -85.6530609130859, -1.49492792734461, 218, 50, 'PPL', 'P'),
(50631, 'Purdum', 39.2844390869141, 0.685642806865805, -77.2405624389648, -1.3481021306522, 218, 25, 'PPL', 'P'),
(199634, 'Purdum', 42.064998626709, 0.734172725882965, -100.258056640625, -1.74983319002987, 218, 35, 'PPL', 'P'),
(11435, 'Purdy', 36.0913887023926, 0.629913564473834, -93.5736083984375, -1.63316755952455, 218, 4, 'PPL', 'P'),
(37832, 'Purdy', 37.1513900756836, 0.648414078513424, -85.1849975585938, -1.48675868070079, 218, 21, 'PPL', 'P'),
(57063, 'Purdy', 36.8172187805176, 0.642581689147123, -93.9205627441406, -1.63922305521117, 218, 29, 'PPL', 'P'),
(77017, 'Purdy', 34.7158317565918, 0.605905566720934, -97.5872192382813, -1.70321828357356, 218, 42, 'PPL', 'P'),
(90160, 'Purdy', 35.2266693115234, 0.614821363997328, -88.5305633544922, -1.54514981918132, 218, 50, 'PPL', 'P'),
(105507, 'Purdy', 36.8222198486328, 0.642668974251851, -77.5883331298828, -1.35417187425065, 218, 53, 'PPL', 'P'),
(111011, 'Purdy', 38.9438896179199, 0.679699097365939, -81.1350021362305, -1.41607292588985, 218, 58, 'PPL', 'P'),
(117435, 'Purdy', 41.1605606079102, 0.718387304574711, -93.2330627441406, -1.62722391660371, 218, 16, 'PPL', 'P'),
(175992, 'Purdy', 43.5169410705566, 0.759513902077559, -91.0480575561523, -1.58908838190016, 218, 57, 'PPL', 'P'),
(208504, 'Purdy', 47.3891716003418, 0.827097074218555, -122.624168395996, -2.14019548103011, 218, 56, 'PPL', 'P'),
(125901, 'Purdy Corner', 42.0063896179199, 0.733149805708265, -71.2491683959961, -1.24353257781802, 218, 23, 'PPL', 'P'),
(73991, 'Purdy Corners', 38.8666687011719, 0.678351338117277, -82.8633270263672, -1.44623788576691, 218, 41, 'PPL', 'P'),
(30907, 'Purdy Hill', 39.5066719055176, 0.689521501256424, -87.208610534668, -1.52207738991937, 218, 19, 'PPL', 'P'),
(151935, 'Purdys', 41.3258285522461, 0.721271774351376, -73.6555633544922, -1.28553209294717, 218, 40, 'PPL', 'P'),
(151936, 'Purdys Grove', 40.9925003051758, 0.715454098950098, -73.666389465332, -1.28572104422651, 218, 40, 'PPL', 'P'),
(177367, 'Purdys Mill', 44.8083305358887, 0.782052900173173, -73.6711120605469, -1.28580346906225, 218, 40, 'PPL', 'P'),
(175994, 'Pureair', 46.7902793884277, 0.816644433256103, -90.8472213745117, -1.5855831292734, 218, 57, 'PPL', 'P'),
(28352, 'Pureton', 38.7305603027344, 0.675975798424927, -88.2244415283203, -1.53980698540241, 218, 18, 'PPL', 'P'),
(197312, 'Purewater (historical)', 47.2222213745117, 0.824183243090872, -106.233329772949, -1.85412137989488, 218, 31, 'PPL', 'P'),
(128616, 'Purgatory', 44.2155609130859, 0.77170711854946, -69.934440612793, -1.22058624923368, 218, 26, 'PPL', 'P'),
(169567, 'Purgatory', 41.4838905334473, 0.724030476345562, -71.2761077880859, -1.24400275890847, 218, 47, 'PPL', 'P'),
(111015, 'Purgitsville', 39.2391700744629, 0.684852713549406, -78.92138671875, -1.37743804848191, 218, 58, 'PPL', 'P'),
(184320, 'Purisima (historical)', 37.4041709899902, 0.652825937754277, -122.412498474121, -2.13650114396595, 218, 6, 'PPL', 'P'),
(73989, 'Puritan', 39.1586112976074, 0.683446697651899, -82.4891662597656, -1.43970754845793, 218, 41, 'PPL', 'P'),
(166240, 'Puritan', 40.3655586242676, 0.704511902400262, -78.6438903808594, -1.37259482372349, 218, 45, 'PPL', 'P'),
(194387, 'Puritan', 40.0849990844727, 0.699615214682961, -104.998611450195, -1.83257147982813, 218, 7, 'PPL', 'P'),
(111012, 'Puritan Mines', 37.7033309936523, 0.658047264808459, -82.1624984741211, -1.43400612003823, 218, 58, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(157262, 'Purity', 40.2002792358398, 0.701627232886515, -82.3386077880859, -1.43707980741035, 218, 41, 'PPL', 'P'),
(90161, 'Purkey Estates', 36.167781829834, 0.631246876073583, -83.4166717529297, -1.45589557314397, 218, 50, 'PPL', 'P'),
(105508, 'Purkins Corner', 38.2572212219238, 0.667714472986419, -77.1655578613281, -1.34679305381837, 218, 53, 'PPL', 'P'),
(68011, 'Purlear', 36.1819381713867, 0.631493950843715, -81.2844390869141, -1.41868109270342, 218, 33, 'PPL', 'P'),
(68014, 'Purley', 36.4747200012207, 0.636603957764331, -79.357780456543, -1.38505455604148, 218, 33, 'PPL', 'P'),
(97270, 'Purley', 33.0911102294922, 0.577548826645015, -95.2619400024414, -1.6626345048799, 218, 51, 'PPL', 'P'),
(151937, 'Purling', 42.2841682434082, 0.7379979573147, -74.0058288574219, -1.29164537922944, 218, 40, 'PPL', 'P'),
(57065, 'Purman', 36.5227813720703, 0.637442786928679, -90.7466735839844, -1.58382823927309, 218, 29, 'PPL', 'P'),
(97271, 'Purmela', 31.4836101531982, 0.549492657587626, -97.9619369506836, -1.70975834142052, 218, 51, 'PPL', 'P'),
(771, 'Purnell', 36.0119400024414, 0.628526923073257, -78.5536117553711, -1.37101916446455, 218, 33, 'PPL', 'P'),
(61450, 'Purnell', 33.4530601501465, 0.583866044487765, -90.4377822875977, -1.57843706912039, 218, 30, 'PPL', 'P'),
(166244, 'Purple Brook (historical)', 41.9786109924316, 0.732664977231817, -77.5319366455078, -1.35318756991176, 218, 45, 'PPL', 'P'),
(209676, 'Purple Sage', 41.5508308410645, 0.725198805115779, -109.323333740234, -1.9080521230237, 218, 59, 'PPL', 'P'),
(178927, 'Purple Sage Mobile Home Park', 33.5391693115234, 0.585368932869924, -112.198608398438, -1.9582351327085, 218, 5, 'PPL', 'P'),
(208505, 'Purrington', 46.6636085510254, 0.814433610077173, -117.764999389648, -2.05538698295848, 218, 56, 'PPL', 'P'),
(73990, 'Pursell (historical)', 39.440559387207, 0.68836762013512, -82.5999984741211, -1.44164193551571, 218, 41, 'PPL', 'P'),
(111013, 'Pursglove', 39.6674995422363, 0.692328473045367, -80.0263900756836, -1.39672399530599, 218, 58, 'PPL', 'P'),
(90162, 'Pursley', 36.0719413757324, 0.629574144592904, -87.8802795410156, -1.53380022556373, 218, 50, 'PPL', 'P'),
(97272, 'Pursley', 31.9177799224854, 0.55707034957431, -96.5436096191406, -1.68500385961407, 218, 51, 'PPL', 'P'),
(111014, 'Pursley', 39.5366706848145, 0.690045078726733, -80.9563903808594, -1.41295556267586, 218, 58, 'PPL', 'P'),
(97273, 'Purves', 32.0033302307129, 0.558563484128976, -98.2699966430664, -1.71513499734528, 218, 51, 'PPL', 'P'),
(57066, 'Purvis', 38.163890838623, 0.666085550505672, -92.8172225952148, -1.61996613684298, 218, 29, 'PPL', 'P'),
(61451, 'Purvis', 31.1430606842041, 0.54354894808776, -89.4097213745117, -1.56049402127598, 218, 30, 'PPL', 'P'),
(68012, 'Purvis', 34.5886116027832, 0.60368515616208, -79.2636108398438, -1.38341098617474, 218, 33, 'PPL', 'P'),
(24154, 'Purvis (historical)', 32.0013885498047, 0.558529595404105, -81.975830078125, -1.43074814191868, 218, 13, 'PPL', 'P'),
(42711, 'Purvis (historical)', 30.6650009155273, 0.535205231103028, -91.7825012207031, -1.60190684201698, 218, 22, 'PPL', 'P'),
(17739, 'Purvis Still', 30.4280605316162, 0.531069841272839, -82.7605590820313, -1.44444424677274, 218, 12, 'PPL', 'P'),
(11433, 'Puryear', 34.7902793884277, 0.607204923016783, -94.4261093139648, -1.64804650737677, 218, 4, 'PPL', 'P'),
(90163, 'Puryear', 36.4441719055176, 0.636070792914098, -88.3344421386719, -1.54172685823225, 218, 50, 'PPL', 'P'),
(105509, 'Puryear Corner', 36.6130599975586, 0.639018446187624, -78.5888900756836, -1.37163488730857, 218, 53, 'PPL', 'P'),
(5254, 'Puryearville (historical)', 31.5472202301025, 0.550602862867052, -87.1900024414063, -1.52175261742443, 218, 2, 'PPL', 'P'),
(83163, 'Purysburgh', 32.2972183227539, 0.563692798967496, -81.1194381713867, -1.41580128345867, 218, 48, 'PPL', 'P'),
(83162, 'Purysburgh Landing', 32.3038902282715, 0.56380924568616, -81.1222229003906, -1.41584988614856, 218, 48, 'PPL', 'P'),
(14459, 'Pusey Crossroads', 38.5580596923828, 0.672965094812592, -75.4097213745117, -1.31614792599677, 218, 10, 'PPL', 'P'),
(14453, 'Pusey Development', 38.5475006103516, 0.672780804065159, -75.5800018310547, -1.31911988061525, 218, 10, 'PPL', 'P'),
(50633, 'Pusey Landing', 39.0736083984375, 0.681963117187643, -76.0961074829102, -1.32812762352828, 218, 25, 'PPL', 'P'),
(78988, 'Puseyville', 39.8494415283203, 0.695503959750151, -76.1122207641602, -1.32840885333939, 218, 45, 'PPL', 'P'),
(11434, 'Push', 36.0102806091309, 0.628497961196403, -92.779167175293, -1.61930194446711, 218, 4, 'PPL', 'P'),
(128617, 'Pushaw', 44.9625015258789, 0.784743691559561, -68.7130584716797, -1.19926910944619, 218, 26, 'PPL', 'P'),
(50632, 'Pushaw (historical)', 38.6894416809082, 0.675258143090178, -76.5666732788086, -1.33634054601397, 218, 25, 'PPL', 'P'),
(184321, 'Pushawalla Palms', 33.8241691589355, 0.590343118574946, -116.280830383301, -2.02948334714166, 218, 6, 'PPL', 'P'),
(157267, 'Pusheta Town (historical)', 40.5680618286133, 0.708046250061933, -84.2297210693359, -1.47008596069635, 218, 41, 'PPL', 'P'),
(5255, 'Pushmataha', 32.1933288574219, 0.561879585739316, -88.3533325195313, -1.5420565575752, 218, 2, 'PPL', 'P'),
(61452, 'Pushmataha Landing', 34.1366691589355, 0.595797272487429, -90.8600006103516, -1.58580616901469, 218, 30, 'PPL', 'P'),
(157264, 'Put-in-Bay', 41.6541709899902, 0.727002430964036, -82.8208312988281, -1.44549619540332, 218, 41, 'PPL', 'P'),
(5256, 'Putnam', 32.0224990844727, 0.558898043740918, -88.0313873291016, -1.53643755399124, 218, 2, 'PPL', 'P'),
(24155, 'Putnam', 32.2586097717285, 0.563018952632679, -84.4180603027344, -1.47337310042984, 218, 13, 'PPL', 'P'),
(33705, 'Putnam', 37.9688911437988, 0.662682163790605, -97.3874969482422, -1.69973247202276, 218, 20, 'PPL', 'P'),
(50659, 'Putnam', 39.5652809143066, 0.690544421431123, -76.460563659668, -1.33448858379193, 218, 25, 'PPL', 'P'),
(68013, 'Putnam', 35.4444389343262, 0.618622160926062, -79.4702835083008, -1.3870181047132, 218, 33, 'PPL', 'P'),
(73993, 'Putnam', 39.9222183227539, 0.696774154432064, -82.008056640625, -1.43131060154091, 218, 41, 'PPL', 'P'),
(77019, 'Putnam', 35.8555603027344, 0.62579758243009, -98.9680633544922, -1.72731855985823, 218, 42, 'PPL', 'P'),
(97274, 'Putnam', 32.3708305358887, 0.564977574456378, -99.1922225952148, -1.73123087665761, 218, 51, 'PPL', 'P'),
(105515, 'Putnam', 37.0219383239746, 0.646154719223628, -81.9655609130859, -1.43056891117732, 218, 53, 'PPL', 'P'),
(113959, 'Putnam', 41.9150009155273, 0.73155477195239, -71.9094390869141, -1.25505647532896, 218, 8, 'PPL', 'P'),
(121142, 'Putnam', 41.185001373291, 0.718813876402314, -89.3963928222656, -1.56026139415476, 218, 18, 'PPL', 'P'),
(151938, 'Putnam', 43.7466697692871, 0.763523424256728, -73.3974990844727, -1.28102802175357, 218, 40, 'PPL', 'P'),
(201446, 'Putnam (historical)', 44.7847213745117, 0.78164084257351, -123.283332824707, -2.15170007062314, 218, 43, 'PPL', 'P'),
(17741, 'Putnam Hall', 29.7363891601563, 0.518997898499078, -81.9594421386719, -1.43046211841761, 218, 12, 'PPL', 'P'),
(113955, 'Putnam Heights', 41.892219543457, 0.731157162001641, -71.8686065673828, -1.25434381342125, 218, 8, 'PPL', 'P'),
(50634, 'Putnam Hill', 39.5577812194824, 0.690413527063546, -76.4458312988281, -1.33423145558868, 218, 25, 'PPL', 'P'),
(151940, 'Putnam Lake', 41.4619407653809, 0.723647380622754, -73.5466690063477, -1.28363152803523, 218, 40, 'PPL', 'P'),
(151941, 'Putnam Station', 43.7341690063477, 0.763305244784423, -73.3752822875977, -1.28064026549886, 218, 40, 'PPL', 'P'),
(151942, 'Putnam Valley', 41.3358306884766, 0.72144634456083, -73.8744430541992, -1.28935226437283, 218, 40, 'PPL', 'P'),
(50635, 'Putnam View Estates', 39.5636100769043, 0.690515259817187, -76.4477767944336, -1.33426541089258, 218, 25, 'PPL', 'P'),
(50636, 'Putnam Village', 39.5677795410156, 0.690588030693973, -76.4580612182617, -1.33444490795005, 218, 25, 'PPL', 'P'),
(30909, 'Putnamville', 39.5741691589355, 0.69069955056462, -86.8652801513672, -1.51608514430864, 218, 19, 'PPL', 'P'),
(125902, 'Putnamville', 42.586109161377, 0.743267820479749, -70.9375, -1.23809293813348, 218, 23, 'PPL', 'P'),
(166242, 'Putnamville', 41.9288902282715, 0.731797186190614, -79.1952819824219, -1.3822184226386, 218, 45, 'PPL', 'P'),
(172431, 'Putnamville', 44.3416709899902, 0.773908154611383, -72.5663909912109, -1.26652244908618, 218, 55, 'PPL', 'P'),
(24157, 'Putney', 31.4699993133545, 0.549255103618391, -84.1177825927734, -1.46813226572067, 218, 13, 'PPL', 'P'),
(37833, 'Putney', 36.9052810668945, 0.644118665991235, -83.2263870239258, -1.45257447810659, 218, 21, 'PPL', 'P'),
(111016, 'Putney', 38.2963905334473, 0.668398106438242, -81.3730621337891, -1.42022785666454, 218, 58, 'PPL', 'P'),
(113957, 'Putney', 41.2350006103516, 0.719686527712506, -73.1122207641602, -1.27604897577956, 218, 8, 'PPL', 'P'),
(171136, 'Putney', 45.5602798461914, 0.795176891446056, -98.1750030517578, -1.71347704640865, 218, 49, 'PPL', 'P'),
(172432, 'Putney', 42.9747200012207, 0.750050359143963, -72.522216796875, -1.2657514639506, 218, 55, 'PPL', 'P'),
(105510, 'Putneys Mill', 37.605281829834, 0.656335984071001, -77.0933303833008, -1.34553244651638, 218, 53, 'PPL', 'P'),
(166243, 'Putneyville', 40.9466705322266, 0.714654218516692, -79.3177795410156, -1.38435640836172, 218, 45, 'PPL', 'P'),
(166245, 'Puttstown', 40.2247200012207, 0.702053804714119, -78.2347183227539, -1.36545342410239, 218, 45, 'PPL', 'P'),
(50637, 'Putty Hill', 39.3766708374023, 0.687252554586704, -76.5063934326172, -1.33528846422534, 218, 25, 'PPL', 'P'),
(211068, 'Puukolii', 20.934440612793, 0.365374915756457, -156.676940917969, -2.73452848097118, 218, 15, 'PPL', 'P'),
(211075, 'Puunene', 20.8636093139648, 0.364138676378442, -156.453063964844, -2.73062109101982, 218, 15, 'PPL', 'P'),
(211076, 'Puunoa', 20.8822193145752, 0.364463482162891, -156.685836791992, -2.73468374326273, 218, 15, 'PPL', 'P'),
(211079, 'Puuohala Village', 20.8994407653809, 0.36476405318142, -156.511672973633, -2.73164401119452, 218, 15, 'PPL', 'P'),
(211083, 'Puupehu', 22.2166690826416, 0.387754024318124, -159.483337402344, -2.78350933973992, 218, 15, 'PPL', 'P'),
(57067, 'Puxico', 36.9497184753418, 0.644894245079694, -90.158332824707, -1.57355975590002, 218, 29, 'PPL', 'P'),
(208506, 'Puyallup', 47.1855583190918, 0.823543352059953, -122.29167175293, -2.13439231985677, 218, 56, 'PPL', 'P'),
(208507, 'Puyallup River Junction', 47.0063896179199, 0.820416268307982, -122.191940307617, -2.13265167776829, 218, 56, 'PPL', 'P'),
(189296, 'Puye', 35.9716682434082, 0.627824048282558, -106.229721069336, -1.8540583961351, 218, 38, 'PPL', 'P'),
(166246, 'Puzzletown', 40.3769416809082, 0.704710574217582, -78.4899978637695, -1.36990889260609, 218, 45, 'PPL', 'P'),
(11436, 'Pyatt', 36.2458305358887, 0.632609082971158, -92.8447189331055, -1.62044603847141, 218, 4, 'PPL', 'P'),
(68015, 'Pyatte', 36.0127792358398, 0.628541570459253, -81.9691696166992, -1.4306318949371, 218, 33, 'PPL', 'P'),
(28353, 'Pyatts', 38.003059387207, 0.663278512137701, -89.3711090087891, -1.55982010836214, 218, 18, 'PPL', 'P'),
(90165, 'Pyburn', 35.0911102294922, 0.612455411684902, -88.2541732788086, -1.54032590234081, 218, 50, 'PPL', 'P'),
(30910, 'Pyeattville', 37.9419403076172, 0.66221178296307, -87.2519378662109, -1.5228335945109, 218, 19, 'PPL', 'P'),
(195504, 'Pyke', 43.9594383239746, 0.767236936080735, -111.723327636719, -1.94993991854512, 218, 17, 'PPL', 'P'),
(61454, 'Pyland', 33.8838882446289, 0.591385413246576, -89.1074981689453, -1.55521923126291, 218, 30, 'PPL', 'P'),
(24158, 'Pyles Marsh', 31.2427806854248, 0.545289390439154, -81.5608291625977, -1.42350500954394, 218, 13, 'PPL', 'P'),
(166247, 'Pyles Mills', 40.874439239502, 0.713393544635676, -80.1774978637695, -1.3993613237335, 218, 45, 'PPL', 'P'),
(50638, 'Pylesville', 39.6897201538086, 0.69271629587911, -76.3733291625977, -1.33296605459673, 218, 25, 'PPL', 'P'),
(50639, 'Pylesville Heights', 39.7011108398438, 0.692915100854485, -76.3683319091797, -1.33287883607103, 218, 25, 'PPL', 'P'),
(57070, 'Pyletown', 36.7247200012207, 0.640967280894317, -90.0186080932617, -1.57112109928983, 218, 29, 'PPL', 'P'),
(105511, 'Pyletown', 39.1055603027344, 0.682520783119905, -78.043327331543, -1.36211302114711, 218, 53, 'PPL', 'P'),
(24159, 'Pyne', 33.0338897705078, 0.576550141236235, -85.126106262207, -1.48573083367808, 218, 13, 'PPL', 'P'),
(192091, 'Pyote', 31.5347194671631, 0.550384683394748, -103.125831604004, -1.79988530534709, 218, 51, 'PPL', 'P'),
(28354, 'Pyramid', 38.334171295166, 0.669057505124146, -89.227783203125, -1.55731860115022, 218, 18, 'PPL', 'P'),
(37834, 'Pyramid', 37.5647201538086, 0.655628049274231, -82.8688888549805, -1.44633495798864, 218, 21, 'PPL', 'P'),
(200145, 'Pyramid', 40.0750007629395, 0.699440711052533, -119.700828552246, -2.08917357560193, 218, 39, 'PPL', 'P'),
(190634, 'Pyramid (historical)', 39.8641700744629, 0.695761021374371, -119.617500305176, -2.08771922333064, 218, 39, 'PPL', 'P'),
(77021, 'Pyramid Corners', 36.8016700744629, 0.642310313032044, -95.1430587768555, -1.66055963607462, 218, 42, 'PPL', 'P'),
(151945, 'Pyrites', 44.514720916748, 0.776928445603642, -75.1861114501953, -1.31224519657732, 218, 40, 'PPL', 'P'),
(5257, 'Pyriton', 33.3630599975586, 0.582295245497809, -85.8338928222656, -1.49808403955246, 218, 2, 'PPL', 'P'),
(57069, 'Pyrmont', 38.5088882446289, 0.672106891151314, -93.0194396972656, -1.6234954910776, 218, 29, 'PPL', 'P'),
(73996, 'Pyrmont', 39.811939239502, 0.694849421333236, -84.4608306884766, -1.47411958448339, 218, 41, 'PPL', 'P'),
(123504, 'Pyrmont', 40.4674987792969, 0.706291093745517, -86.6797180175781, -1.51284647410699, 218, 19, 'PPL', 'P'),
(73994, 'Pyro', 38.9241714477539, 0.679354950374074, -82.5325012207031, -1.44046388620751, 218, 41, 'PPL', 'P'),
(5258, 'Pyron', 32.702220916748, 0.570761427711812, -86.4938888549805, -1.50960314337344, 218, 2, 'PPL', 'P'),
(166249, 'Pyrra', 40.7208290100098, 0.710712540366293, -79.4258270263672, -1.3862421927296, 218, 45, 'PPL', 'P'),
(208508, 'Pysht', 48.1986083984375, 0.841224411432125, -124.11499786377, -2.16621536382851, 218, 56, 'PPL', 'P'),
(151946, 'Quackenkill', 42.7694396972656, 0.746467541950452, -73.5194396972656, -1.28315628693871, 218, 40, 'PPL', 'P'),
(205443, 'Quad', 40.7708282470703, 0.711585191676485, -111.757499694824, -1.95053633347124, 218, 52, 'PPL', 'P'),
(113958, 'Quaddick', 41.9383316040039, 0.731961969283063, -71.8211135864258, -1.25351490453196, 218, 8, 'PPL', 'P'),
(42712, 'Quadrate', 31.336389541626, 0.54692317318889, -92.7080612182617, -1.61806091139913, 218, 22, 'PPL', 'P'),
(42713, 'Quaid', 31.6755599975586, 0.552842814370405, -91.8125, -1.60243041948729, 218, 22, 'PPL', 'P'),
(37835, 'Quail', 37.327220916748, 0.65148290561655, -84.454719543457, -1.47401292488173, 218, 21, 'PPL', 'P'),
(57073, 'Quail', 36.8950004577637, 0.643939235512791, -93.5152816772461, -1.63214956619787, 218, 29, 'PPL', 'P'),
(105512, 'Quail', 37.9297218322754, 0.661998530338782, -78.0336074829102, -1.36194337778567, 218, 53, 'PPL', 'P'),
(184323, 'Quail', 36.0097198486328, 0.628488174079397, -119.30249786377, -2.08222139357628, 218, 6, 'PPL', 'P'),
(192089, 'Quail', 34.9097213745117, 0.60928957893907, -100.398063659668, -1.75227677348807, 218, 51, 'PPL', 'P'),
(83164, 'Quail Arbor', 32.9866714477539, 0.57572602603691, -80.1861114501953, -1.39951165917703, 218, 48, 'PPL', 'P'),
(178928, 'Quail Country Place', 33.6513900756836, 0.587327554693623, -112.069999694824, -1.95599048738372, 218, 5, 'PPL', 'P'),
(205444, 'Quail Cove', 40.999439239502, 0.715575206200669, -111.895561218262, -1.95294596162554, 218, 52, 'PPL', 'P'),
(24160, 'Quail Creek', 33.4908294677734, 0.584525243436587, -82.1305618286133, -1.43344872042208, 218, 13, 'PPL', 'P'),
(83166, 'Quail Creek', 33.9625015258789, 0.592757473840185, -80.8755569458008, -1.41154475308839, 218, 48, 'PPL', 'P'),
(90171, 'Quail Creek', 36.4625015258789, 0.636390705140043, -82.5180587768555, -1.44021181801033, 218, 50, 'PPL', 'P'),
(50640, 'Quail Creek Acres', 39.396110534668, 0.68759184130958, -77.017219543457, -1.34420406176465, 218, 25, 'PPL', 'P'),
(42714, 'Quail Creek Estates', 32.5847206115723, 0.568710660514396, -91.9694366455078, -1.60516948066844, 218, 22, 'PPL', 'P'),
(73995, 'Quail Creek Trailer Park', 38.8474998474121, 0.678016778505336, -82.3086090087891, -1.43655622994004, 218, 41, 'PPL', 'P'),
(105513, 'Quail Crossing', 37.2958297729492, 0.650935026801293, -80.1191711425781, -1.39834333040682, 218, 53, 'PPL', 'P'),
(83168, 'Quail Haven', 34.8230590820313, 0.607777036597959, -82.4958267211914, -1.43982379543951, 218, 48, 'PPL', 'P'),
(50641, 'Quail Hill', 39.1669387817383, 0.68359203966839, -77.0072174072266, -1.34402949155519, 218, 25, 'PPL', 'P'),
(50642, 'Quail Hills', 39.6694412231445, 0.692362361770239, -76.4875030517578, -1.33495876488238, 218, 25, 'PPL', 'P'),
(83169, 'Quail Hills', 33.9730606079102, 0.592941764587619, -80.8808288574219, -1.41163676530406, 218, 48, 'PPL', 'P'),
(24163, 'Quail Hollow', 33.3847198486328, 0.582673281214546, -82.0930633544922, -1.43279424858419, 218, 13, 'PPL', 'P'),
(42715, 'Quail Hollow', 30.3597202301025, 0.52987707799962, -91.0761108398438, -1.58957800406657, 218, 22, 'PPL', 'P'),
(50643, 'Quail Hollow', 38.809440612793, 0.677352519550443, -76.2266693115234, -1.330406357315, 218, 25, 'PPL', 'P'),
(83175, 'Quail Hollow', 34.9366683959961, 0.609759893187578, -81.8499984741211, -1.42855196612575, 218, 48, 'PPL', 'P'),
(90167, 'Quail Hollow', 36.2183303833008, 0.632129114763698, -83.3758316040039, -1.45518277807821, 218, 50, 'PPL', 'P'),
(184324, 'Quail Hollow', 37.9908294677734, 0.663065059776331, -120.363891601563, -2.10074620896082, 218, 6, 'PPL', 'P'),
(24165, 'Quail Hollow Mobile Home Park', 33.3369407653809, 0.581839378898214, -84.7536087036133, -1.47922952482497, 218, 13, 'PPL', 'P'),
(178929, 'Quail Lane', 33.5833282470703, 0.586139651689393, -112.194999694824, -1.95817214894872, 218, 5, 'PPL', 'P'),
(24166, 'Quail Meadow', 32.5980606079102, 0.568943487372697, -83.7011108398438, -1.46085997173199, 218, 13, 'PPL', 'P'),
(184325, 'Quail Meadows', 36.5327796936035, 0.637617290559107, -121.868606567383, -2.12700843941842, 218, 6, 'PPL', 'P'),
(192090, 'Quail Mesa Colonia', 31.6200008392334, 0.551873124127993, -106.224998474121, -1.85397597129937, 218, 51, 'PPL', 'P'),
(105514, 'Quail Oaks', 37.3913917541504, 0.652602898012982, -77.429443359375, -1.35139872460755, 218, 53, 'PPL', 'P'),
(184326, 'Quail Oaks', 38.1805610656738, 0.666376500854763, -120.837783813477, -2.10901718835828, 218, 6, 'PPL', 'P'),
(178930, 'Quail Place', 33.3463897705078, 0.582004295148718, -111.872222900391, -1.95253863113682, 218, 5, 'PPL', 'P'),
(14454, 'Quail Ridge', 39.7638893127441, 0.69401079190597, -75.6722183227539, -1.32072936202004, 218, 10, 'PPL', 'P'),
(42717, 'Quail Ridge', 30.357780456543, 0.529843222564262, -91.0763931274414, -1.58958293091459, 218, 22, 'PPL', 'P'),
(50647, 'Quail Ridge', 38.3491706848145, 0.669319293859301, -75.5036087036133, -1.3177865690155, 218, 25, 'PPL', 'P'),
(68027, 'Quail Ridge', 35.4583282470703, 0.618864575164286, -82.1986083984375, -1.4346363571102, 218, 33, 'PPL', 'P'),
(83179, 'Quail Ridge', 35.0194396972656, 0.611204524920891, -81.9697189331055, -1.43064148231702, 218, 48, 'PPL', 'P'),
(90169, 'Quail Ridge', 35.9319381713867, 0.627130627713729, -86.5347213745117, -1.51031580528114, 218, 50, 'PPL', 'P'),
(184327, 'Quail Ridge Ranch', 37.9888916015625, 0.663031237630487, -120.347221374512, -2.10045525861173, 218, 6, 'PPL', 'P'),
(68033, 'Quail Roost', 36.1941719055176, 0.631707469784112, -78.9077835083008, -1.37720062767073, 218, 33, 'PPL', 'P'),
(24171, 'Quail Run', 33.8675003051758, 0.591099389745502, -84.8499984741211, -1.48091184368558, 218, 13, 'PPL', 'P'),
(50651, 'Quail Run', 39.1086082458496, 0.68257397976268, -77.269172668457, -1.34860147335659, 218, 25, 'PPL', 'P'),
(83182, 'Quail Run', 34.8952789306641, 0.609037510741894, -81.0449981689453, -1.41450206032087, 218, 48, 'PPL', 'P'),
(205452, 'Quail Run', 40.9986114501953, 0.715560758551755, -111.895561218262, -1.95294596162554, 218, 52, 'PPL', 'P'),
(24172, 'Quail Run East', 33.8713912963867, 0.591167300353299, -84.8424987792969, -1.480780949318, 218, 13, 'PPL', 'P'),
(24174, 'Quail Run North', 32.6083297729492, 0.569122718114059, -83.6933288574219, -1.4607241505164, 218, 13, 'PPL', 'P'),
(11438, 'Quail Valley', 35.7563896179199, 0.62406672745862, -91.5902786254883, -1.59855192483376, 218, 4, 'PPL', 'P'),
(24176, 'Quail Valley', 33.5955581665039, 0.586353104050763, -83.7405624389648, -1.46154853203183, 218, 13, 'PPL', 'P'),
(50652, 'Quail Valley', 39.1611099243164, 0.683490306914749, -77.188606262207, -1.34719532430103, 218, 25, 'PPL', 'P'),
(184328, 'Quail Valley', 33.7069396972656, 0.588297078488466, -117.244171142578, -2.04629681520971, 218, 6, 'PPL', 'P'),
(192884, 'Quail Valley', 33.6283302307129, 0.586925084473884, -111.97917175293, -1.95440524074485, 218, 5, 'PPL', 'P'),
(205455, 'Quail Valley Subdivision Number 3', 40.5944404602051, 0.708506644035381, -111.819717407227, -1.95162223740572, 218, 52, 'PPL', 'P'),
(105516, 'Quail Walk', 37.6744384765625, 0.657542995256052, -77.4916687011719, -1.35248476170009, 218, 53, 'PPL', 'P'),
(205457, 'Quailbrook East Condominium', 40.6694412231445, 0.709815654290182, -111.861106872559, -1.9523446198514, 218, 52, 'PPL', 'P'),
(24177, 'Quails Nest', 33.8713912963867, 0.591167300353299, -84.6236114501953, -1.47696064473428, 218, 13, 'PPL', 'P'),
(50653, 'Quails Nest', 39.5544395446777, 0.690355203835673, -75.9024963378906, -1.32474847157913, 218, 25, 'PPL', 'P'),
(205458, 'Quailstone', 40.6650009155273, 0.709738156302461, -111.945281982422, -1.95381375266675, 218, 52, 'PPL', 'P'),
(24178, 'Quailwood', 33.9786109924316, 0.59303863707227, -83.4402770996094, -1.45630756416461, 218, 13, 'PPL', 'P'),
(50655, 'Quaint Acres', 39.0461082458496, 0.681483148980183, -76.9972229003906, -1.34385505450379, 218, 25, 'PPL', 'P'),
(125903, 'Quaise', 41.2938919067383, 0.720714374735222, -70.0361099243164, -1.222360713468, 218, 23, 'PPL', 'P'),
(166250, 'Quakake', 40.8516693115234, 0.712996134422009, -76.0363922119141, -1.32708539543567, 218, 45, 'PPL', 'P'),
(30911, 'Quaker', 39.8558311462402, 0.695615479620798, -87.5280609130859, -1.5276528508195, 218, 19, 'PPL', 'P'),
(33708, 'Quaker', 37.1316719055176, 0.648069931521559, -94.7583312988281, -1.65384487486015, 218, 20, 'PPL', 'P'),
(57071, 'Quaker', 37.7811088562012, 0.659404744595099, -91.0019378662109, -1.58828344146068, 218, 29, 'PPL', 'P'),
(111018, 'Quaker', 38.0522193908691, 0.664136516061898, -82.4277801513672, -1.43863615875139, 218, 58, 'PPL', 'P'),
(28355, 'Quaker (historical)', 39.8611106872559, 0.695707624994514, -87.5602798461914, -1.52821517728367, 218, 18, 'PPL', 'P'),
(73997, 'Quaker City', 39.9700012207031, 0.697608123327422, -81.2994384765625, -1.41894288143858, 218, 41, 'PPL', 'P'),
(144349, 'Quaker City', 43.2713890075684, 0.755228210093349, -72.3327789306641, -1.26244514945727, 218, 36, 'PPL', 'P'),
(166251, 'Quaker City', 40.6594390869141, 0.709641084080727, -75.8791732788086, -1.32434140740651, 218, 45, 'PPL', 'P'),
(113960, 'Quaker Farms', 41.4275016784668, 0.723046305164723, -73.1561126708984, -1.27681503406712, 218, 8, 'PPL', 'P'),
(68036, 'Quaker Gap', 36.3555603027344, 0.634524228690061, -80.2880630493164, -1.40129105025937, 218, 33, 'PPL', 'P'),
(146128, 'Quaker Gardens', 40.2513885498047, 0.702519258693637, -74.6838912963867, -1.30347980132348, 218, 37, 'PPL', 'P'),
(123505, 'Quaker Haven Park', 41.3669395446777, 0.72198929652807, -85.7605590820313, -1.49680412433257, 218, 19, 'PPL', 'P'),
(14455, 'Quaker Hill', 39.7972183227539, 0.694592492867071, -75.6930618286133, -1.32109314982494, 218, 10, 'PPL', 'P'),
(113961, 'Quaker Hill', 41.4033317565918, 0.722624460448054, -72.1063919067383, -1.25849395050598, 218, 8, 'PPL', 'P'),
(151948, 'Quaker Hill', 41.5794410705566, 0.725698147820169, -73.543327331543, -1.28357320480736, 218, 40, 'PPL', 'P'),
(184330, 'Quaker Hill (historical)', 39.2625007629395, 0.685259910880079, -120.905563354492, -2.11020016451449, 218, 6, 'PPL', 'P'),
(50657, 'Quaker Hills', 39.5827789306641, 0.690849819429128, -76.1394424438477, -1.32888396127786, 218, 25, 'PPL', 'P'),
(166252, 'Quaker Hills', 40.0152816772461, 0.698398416380903, -76.3380584716797, -1.33235046491076, 218, 45, 'PPL', 'P'),
(184331, 'Quaker Meadow', 36.110279083252, 0.630243263816786, -118.553611755371, -2.06915086526228, 218, 6, 'PPL', 'P'),
(50658, 'Quaker Neck Landing', 39.1300010681152, 0.682947354947509, -76.0969390869141, -1.32814213775622, 218, 25, 'PPL', 'P'),
(151947, 'Quaker Ridge', 40.9708290100098, 0.715075863496279, -73.7805633544922, -1.28771375451216, 218, 40, 'PPL', 'P'),
(151949, 'Quaker Settlement', 42.7550010681152, 0.746215540332303, -75.8394393920898, -1.32364792025865, 218, 40, 'PPL', 'P'),
(151950, 'Quaker Springs', 43.0394401550293, 0.75117993892032, -73.6433334350586, -1.2853186405858, 218, 40, 'PPL', 'P'),
(151951, 'Quaker Street', 42.7347183227539, 0.745861539644404, -74.1866683959961, -1.29480162459535, 218, 40, 'PPL', 'P'),
(166253, 'Quaker Village', 40.1372184753418, 0.700526614987013, -76.8199996948242, -1.34076192605572, 218, 45, 'PPL', 'P'),
(14456, 'Quakers Heights', 38.7550010681152, 0.67640237025253, -75.1591720581055, -1.31177501548686, 218, 10, 'PPL', 'P'),
(14457, 'Quakertown', 38.7552795410156, 0.676407230521519, -75.1597213745117, -1.31178460286679, 218, 10, 'PPL', 'P'),
(113962, 'Quakertown', 41.4099998474121, 0.722740840587691, -72.0047225952148, -1.25671948627166, 218, 8, 'PPL', 'P'),
(132744, 'Quakertown', 42.4861106872559, 0.741522517859366, -83.3777770996094, -1.45521673338211, 218, 27, 'PPL', 'P'),
(146129, 'Quakertown', 40.565559387207, 0.708002574220056, -74.9419403076172, -1.30798360620097, 218, 37, 'PPL', 'P'),
(166254, 'Quakertown', 40.4416694641113, 0.705840287151993, -75.3419418334961, -1.31496494984056, 218, 45, 'PPL', 'P'),
(33709, 'Quakervale (historical)', 37.0825004577637, 0.64721172786028, -94.7225036621094, -1.65321956463619, 218, 20, 'PPL', 'P'),
(73998, 'Qualey', 39.3547210693359, 0.686869458863896, -81.7586135864258, -1.4269569989489, 218, 41, 'PPL', 'P'),
(190636, 'Qualeys Camp', 38.3083305358887, 0.668606498793541, -118.526672363281, -2.06868068417183, 218, 39, 'PPL', 'P'),
(24179, 'Quality', 31.0405597686768, 0.541759969625499, -84.0736083984375, -1.46736128058509, 218, 13, 'PPL', 'P'),
(37836, 'Quality', 37.0755615234375, 0.647090620609709, -86.8466720581055, -1.5157603718137, 218, 21, 'PPL', 'P'),
(184332, 'Quality', 35.7838897705078, 0.624546695666079, -119.118606567383, -2.07901188498857, 218, 6, 'PPL', 'P'),
(90173, 'Quality Estates', 36.1458282470703, 0.630863713771747, -85.5861129760742, -1.49375946541634, 218, 50, 'PPL', 'P'),
(151952, 'Quality Hill', 43.0669403076172, 0.751659907127779, -75.7752838134766, -1.32252819417833, 218, 40, 'PPL', 'P'),
(68040, 'Qualla', 35.4352798461914, 0.61846230468163, -83.3230590820313, -1.45426172381521, 218, 33, 'PPL', 'P'),
(105518, 'Qualla Farms', 37.4152793884277, 0.653019815881634, -77.5852813720703, -1.35411861102885, 218, 53, 'PPL', 'P'),
(77022, 'Qualls', 35.7202796936035, 0.623436490386653, -95.0327835083008, -1.65863496955482, 218, 42, 'PPL', 'P'),
(90172, 'Qualls (historical)', 36.2861099243164, 0.633312090919912, -85.1972198486328, -1.48697199990411, 218, 50, 'PPL', 'P'),
(137603, 'Quamba', 45.9155616760254, 0.801377729149169, -93.1730575561523, -1.62617662850504, 218, 28, 'PPL', 'P'),
(97275, 'Quanah', 34.297779083252, 0.598609171124389, -99.7399978637695, -1.74079135865489, 218, 51, 'PPL', 'P'),
(117439, 'Quandahl', 43.4500007629395, 0.758345573307342, -91.6063919067383, -1.59883315464487, 218, 16, 'PPL', 'P'),
(132745, 'Quanicassee', 43.5833282470703, 0.760672576888826, -83.6808319091797, -1.46050603762312, 218, 27, 'PPL', 'P'),
(125904, 'Quansoo', 41.3499984741211, 0.721693619068044, -70.6624984741211, -1.23329325605888, 218, 23, 'PPL', 'P'),
(50660, 'Quantico', 38.3741683959961, 0.669755586224883, -75.7427825927734, -1.32196094086614, 218, 25, 'PPL', 'P'),
(105517, 'Quantico', 38.5222206115723, 0.67233958485156, -77.2938919067383, -1.34903290545318, 218, 53, 'PPL', 'P'),
(77024, 'Quapaw', 36.9544410705566, 0.644976669915432, -94.7877807617188, -1.65435886495053, 218, 42, 'PPL', 'P'),
(83183, 'Quarantine', 33.2294387817383, 0.579963115331226, -79.2044372558594, -1.38237821230401, 218, 48, 'PPL', 'P'),
(42720, 'Quarantine (historical)', 29.3658294677734, 0.512530411791821, -89.5244369506836, -1.5624961857835, 218, 22, 'PPL', 'P'),
(11439, 'Quarles', 35.1011085510254, 0.612629915315329, -90.2452774047852, -1.57507722508914, 218, 4, 'PPL', 'P'),
(57072, 'Quarles', 38.4708290100098, 0.671442632196421, -93.7536087036133, -1.63630915750446, 218, 29, 'PPL', 'P'),
(111019, 'Quarrier', 38.0502815246582, 0.664102693916054, -81.432502746582, -1.42126529106718, 218, 58, 'PPL', 'P'),
(97276, 'Quarry', 30.3075103759766, 0.528965844143136, -96.5101776123047, -1.68442036101924, 218, 51, 'PPL', 'P'),
(117440, 'Quarry', 42.017219543457, 0.733338823566634, -92.8050003051758, -1.61975281763966, 218, 16, 'PPL', 'P'),
(73999, 'Quarry (historical)', 39.5919418334961, 0.691009742252587, -81.220832824707, -1.41757095400302, 218, 41, 'PPL', 'P'),
(166256, 'Quarry Glen', 41.8058280944824, 0.729649346771465, -76.4638900756836, -1.33454664070369, 218, 45, 'PPL', 'P'),
(11440, 'Quarry Heights', 35.1100006103516, 0.612785111027853, -93.6963882446289, -1.63531047209568, 218, 4, 'PPL', 'P'),
(151953, 'Quarry Heights', 41.0691719055176, 0.716792270818835, -73.7513885498047, -1.28720455811174, 218, 40, 'PPL', 'P'),
(57074, 'Quarry Town', 37.9297218322754, 0.661998530338782, -90.0025024414063, -1.57084000263677, 218, 29, 'PPL', 'P'),
(50661, 'Quarry View', 39.5577812194824, 0.690413527063546, -77.2980575561523, -1.34910560975094, 218, 25, 'PPL', 'P'),
(14458, 'Quarryville', 39.7791709899902, 0.694277507489142, -75.4875030517578, -1.31750547236244, 218, 10, 'PPL', 'P'),
(78989, 'Quarryville', 39.8969383239746, 0.696332935218465, -76.1638870239258, -1.32931059968449, 218, 45, 'PPL', 'P'),
(113963, 'Quarryville', 41.8644409179688, 0.730672333525192, -72.4216690063477, -1.2639965739503, 218, 8, 'PPL', 'P'),
(146130, 'Quarryville', 41.2563896179199, 0.720059836318308, -74.5800018310547, -1.3016665880953, 218, 37, 'PPL', 'P'),
(151954, 'Quarryville', 42.1197204589844, 0.735127802028895, -73.9875030517578, -1.29132553358253, 218, 40, 'PPL', 'P'),
(90174, 'Quarryville (historical)', 36.3647193908691, 0.634684084934493, -83.1630630493164, -1.45146926625421, 218, 50, 'PPL', 'P'),
(189297, 'Quarteles', 35.9919395446777, 0.628177849233375, -106.013061523438, -1.8502769737033, 218, 38, 'PPL', 'P'),
(50662, 'Quarterfield Farms', 39.1227798461914, 0.682821320848921, -76.664436340332, -1.33804683332439, 218, 25, 'PPL', 'P'),
(184333, 'Quartz', 37.9280586242676, 0.6619695018829, -120.419723510742, -2.10172065960368, 218, 6, 'PPL', 'P'),
(197313, 'Quartz', 47.0519409179688, 0.821211288472398, -114.768333435059, -2.00308529546847, 218, 31, 'PPL', 'P'),
(184334, 'Quartz (historical)', 39.5327796936035, 0.689977168118936, -121.497222900391, -2.12052657164127, 218, 6, 'PPL', 'P'),
(184335, 'Quartz Hill', 34.6452789306641, 0.604674187611908, -118.217216491699, -2.06327966032309, 218, 6, 'PPL', 'P'),
(201447, 'Quartz Mountain', 42.3224983215332, 0.738666943380528, -120.814437866211, -2.10860972471149, 218, 43, 'PPL', 'P'),
(190638, 'Quartz Mountain (historical)', 39.0458297729492, 0.681478288711194, -117.965560913086, -2.05888744189528, 218, 39, 'PPL', 'P'),
(195505, 'Quartzburg', 43.961109161377, 0.767266097694671, -115.987503051758, -2.02436381942014, 218, 17, 'PPL', 'P'),
(33711, 'Quartzite', 39.021110534668, 0.681046856614601, -98.0944366455078, -1.71207089735309, 218, 20, 'PPL', 'P'),
(178931, 'Quartzsite', 33.663890838623, 0.587545734165927, -114.22917175293, -1.99367514891473, 218, 5, 'PPL', 'P'),
(187239, 'Quartzville (historical)', 39.3450012207031, 0.686699815502458, -106.076667785645, -1.8513871124037, 218, 7, 'PPL', 'P'),
(121145, 'Quashquema (historical)', 40.5499992370605, 0.707730998367895, -91.3863906860352, -1.59499340898519, 218, 18, 'PPL', 'P'),
(117441, 'Quasqueton', 42.3944396972656, 0.739922557255473, -91.7608337402344, -1.60152867314219, 218, 16, 'PPL', 'P'),
(197314, 'Quast', 46.3274993896484, 0.808567398565029, -114.102783203125, -1.99146925258381, 218, 31, 'PPL', 'P'),
(28357, 'Quatoga Bluff', 38.9275016784668, 0.679413073864865, -90.2483291625977, -1.57513048831095, 218, 18, 'PPL', 'P'),
(77027, 'Quay', 36.1594390869141, 0.631101267740982, -96.710563659668, -1.68791775732078, 218, 42, 'PPL', 'P'),
(189298, 'Quay', 34.9338912963867, 0.609711423655738, -103.76000213623, -1.81095366915357, 218, 38, 'PPL', 'P'),
(61459, 'Quay (historical)', 33.3163909912109, 0.581480717678408, -90.8955612182617, -1.58642681870674, 218, 30, 'PPL', 'P'),
(97277, 'Que Pasa Acres Colonia', 26.2549991607666, 0.458236180463725, -98.3610000610352, -1.71672330661941, 218, 51, 'PPL', 'P'),
(209677, 'Quealy', 41.538330078125, 0.724980625643475, -109.221939086914, -1.90628245247934, 218, 59, 'PPL', 'P'),
(42721, 'Quebec', 32.4266700744629, 0.565952158257292, -91.3027801513672, -1.59353412986588, 218, 22, 'PPL', 'P'),
(68042, 'Quebec', 35.1399993896484, 0.613308688498163, -82.8758316040039, -1.44645613181824, 218, 33, 'PPL', 'P'),
(105519, 'Quebec', 36.7594413757324, 0.641573283200365, -81.503059387207, -1.42249673675523, 218, 53, 'PPL', 'P'),
(113964, 'Quebec', 41.7991714477539, 0.729533166368911, -71.8883285522461, -1.25468802699214, 218, 8, 'PPL', 'P'),
(192092, 'Quebec', 30.5105590820313, 0.532509712605704, -104.399169921875, -1.82210925148575, 218, 51, 'PPL', 'P'),
(197315, 'Quebec', 45.7266693115234, 0.798080935456733, -109.65860748291, -1.91390375372887, 218, 31, 'PPL', 'P'),
(24180, 'Quebec (historical)', 34.7077789306641, 0.605765018394405, -83.9972229003906, -1.4660281021434, 218, 13, 'PPL', 'P'),
(144350, 'Quebec Junction', 44.3491706848145, 0.774039048978961, -71.5524978637695, -1.24882667574899, 218, 36, 'PPL', 'P'),
(90175, 'Quebeck', 35.8166694641113, 0.625118809247256, -85.5669403076172, -1.49342483922537, 218, 50, 'PPL', 'P'),
(172434, 'Quechee', 43.646110534668, 0.761768334519339, -72.4188919067383, -1.26394810441846, 218, 55, 'PPL', 'P'),
(166257, 'Quecreek', 40.0897216796875, 0.699697639518698, -79.0794372558594, -1.38019655073902, 218, 45, 'PPL', 'P'),
(151955, 'Queechy', 42.4047203063965, 0.740101987733917, -73.4216690063477, -1.28144986647024, 218, 40, 'PPL', 'P'),
(166259, 'Queen', 41.625560760498, 0.726503088259646, -79.3636093139648, -1.38515628879512, 218, 45, 'PPL', 'P'),
(189300, 'Queen', 32.1908302307129, 0.561835976476466, -104.745277404785, -1.82814996662832, 218, 38, 'PPL', 'P'),
(197316, 'Queen', 46.2513885498047, 0.807239013813297, -111.964172363281, -1.9541434520097, 218, 31, 'PPL', 'P'),
(74000, 'Queen Acres', 39.394718170166, 0.687567539964633, -84.6397171020508, -1.47724174138734, 218, 41, 'PPL', 'P'),
(50663, 'Queen Anne', 38.9208297729492, 0.679296627146201, -75.9555587768555, -1.3256745858482, 218, 25, 'PPL', 'P'),
(208509, 'Queen Anne', 47.6361083984375, 0.831406934389657, -122.36499786377, -2.13567210191861, 218, 56, 'PPL', 'P'),
(50664, 'Queen Anne Colony', 38.9077796936035, 0.679068860293972, -76.3627777099609, -1.33278189700735, 218, 25, 'PPL', 'P'),
(50665, 'Queen Anne Estates', 38.8875007629395, 0.6787149261851, -76.7080612182617, -1.33880823108004, 218, 25, 'PPL', 'P'),
(50666, 'Queen Anne Hill', 38.7394409179688, 0.676130794400369, -76.5572204589844, -1.33617556318444, 218, 25, 'PPL', 'P'),
(50667, 'Queen Anne Knolls', 38.8916702270508, 0.678787697061887, -76.7122192382813, -1.33888080221974, 218, 25, 'PPL', 'P'),
(50668, 'Queen Anne Woods', 38.9147186279297, 0.679189967544543, -76.1769409179688, -1.32953843311575, 218, 25, 'PPL', 'P'),
(50670, 'Queen Annes Acres', 38.910831451416, 0.679122123515774, -76.1813888549805, -1.32961606426152, 218, 25, 'PPL', 'P'),
(50672, 'Queen Annes Estates', 38.9049987792969, 0.679020324183105, -76.1763916015625, -1.32952884573582, 218, 25, 'PPL', 'P'),
(50673, 'Queen Annes on Wye', 38.9083290100098, 0.679078447673896, -76.1733322143555, -1.32947544935597, 218, 25, 'PPL', 'P'),
(105520, 'Queen Charlotte', 38.0583305358887, 0.664243175663555, -78.5033264160156, -1.37014151972731, 218, 53, 'PPL', 'P'),
(97278, 'Queen City', 33.148609161377, 0.578552372322784, -94.1500015258789, -1.64322751738427, 218, 51, 'PPL', 'P'),
(139411, 'Queen City', 40.4091682434082, 0.705273033839807, -92.567497253418, -1.61560760740295, 218, 29, 'PPL', 'P'),
(166260, 'Queen City', 40.9150009155273, 0.714101479432447, -76.4361114501953, -1.33406181222725, 218, 45, 'PPL', 'P'),
(184336, 'Queen City', 39.6647186279297, 0.692279936934501, -120.939170837402, -2.11078672574458, 218, 6, 'PPL', 'P'),
(117442, 'Queen City (historical)', 41.0052795410156, 0.715677138691392, -94.709716796875, -1.65299639173685, 218, 16, 'PPL', 'P'),
(200146, 'Queen City (historical)', 41.5308303833008, 0.724849731275897, -117.420829772949, -2.04938008996175, 218, 39, 'PPL', 'P'),
(172435, 'Queen City Park', 44.4433288574219, 0.775682419108621, -73.2205581665039, -1.27793982015352, 218, 55, 'PPL', 'P'),
(178932, 'Queen Creek', 33.2486114501953, 0.580297741522195, -111.633613586426, -1.94837411298221, 218, 5, 'PPL', 'P'),
(166261, 'Queen Junction', 40.9691696166992, 0.715046901619425, -79.9291687011719, -1.39502716221745, 218, 45, 'PPL', 'P'),
(111020, 'Queen Shoals', 38.4711112976074, 0.671447559044438, -81.283332824707, -1.41866178478552, 218, 58, 'PPL', 'P'),
(50674, 'Queen Tree Landing', 38.4219398498535, 0.67058935538316, -76.623893737793, -1.33733923142275, 218, 25, 'PPL', 'P'),
(178933, 'Queen Valley', 33.2986106872559, 0.581170392832387, -111.288887023926, -1.9423574994475, 218, 5, 'PPL', 'P'),
(37837, 'Queendale', 37.0111083984375, 0.64596570136526, -83.5311126708984, -1.45789294396153, 218, 21, 'PPL', 'P'),
(37838, 'Queens', 38.6336097717285, 0.674283692447318, -83.4388885498047, -1.45628332939869, 218, 21, 'PPL', 'P'),
(111021, 'Queens', 38.8569412231445, 0.678181561597785, -80.1369400024414, -1.39865345551576, 218, 58, 'PPL', 'P'),
(68044, 'Queens Acres', 35.9324989318848, 0.627140414830735, -81.5102767944336, -1.4226227042748, 218, 33, 'PPL', 'P'),
(50675, 'Queens Chapel Manor', 38.958610534668, 0.679956025832105, -76.9613876342773, -1.34322961112179, 218, 25, 'PPL', 'P'),
(17742, 'Queens Cove', 27.5138893127441, 0.480207958536665, -80.3166732788086, -1.40179039296376, 218, 12, 'PPL', 'P'),
(61455, 'Queens Hill', 32.3941688537598, 0.565384904945105, -90.5272216796875, -1.57999808099334, 218, 30, 'PPL', 'P'),
(105521, 'Queens Lake', 37.2902793884277, 0.650838154316641, -76.6580581665039, -1.33793551319082, 218, 53, 'PPL', 'P'),
(24181, 'Queens Lake Estates', 33.7902793884277, 0.58975163049684, -84.5430603027344, -1.47555476199483, 218, 13, 'PPL', 'P'),
(17743, 'Queens Park', 27.1063899993896, 0.473095753819013, -80.2750015258789, -1.40106308367006, 218, 12, 'PPL', 'P'),
(197317, 'Queens Point', 46.5688896179199, 0.812780452830507, -107.976112365723, -1.88453867428522, 218, 31, 'PPL', 'P'),
(14460, 'Queens Quest', 38.4841690063477, 0.671675459054721, -75.0533294677734, -1.30992771379673, 218, 10, 'PPL', 'P'),
(166262, 'Queens Run', 41.1816711425781, 0.718755752911523, -77.476936340332, -1.35222763349684, 218, 45, 'PPL', 'P'),
(151958, 'Queens Village', 40.7266693115234, 0.710814472857016, -73.741943359375, -1.28703970844026, 218, 40, 'PPL', 'P'),
(178934, 'Queens Well', 32.2675018310547, 0.563174148345203, -111.632781982422, -1.94835959875426, 218, 5, 'PPL', 'P'),
(50676, 'Queensberry', 38.563060760498, 0.673052379917319, -76.5722198486328, -1.3364373519196, 218, 25, 'PPL', 'P'),
(157269, 'Queensboro', 40.5180587768555, 0.707173532172714, -81.2216720581055, -1.41758560138902, 218, 41, 'PPL', 'P'),
(83184, 'Queensborough', 32.7238883972168, 0.571139596586603, -79.9702835083008, -1.39574475097317, 218, 48, 'PPL', 'P'),
(151960, 'Queensbury', 43.3772201538086, 0.757075312046401, -73.6136093139648, -1.28479985680545, 218, 40, 'PPL', 'P'),
(24182, 'Queensland', 31.7988891601563, 0.554995314321461, -83.2363891601563, -1.45274904831604, 218, 13, 'PPL', 'P'),
(50677, 'Queensland', 38.7930603027344, 0.677066629207423, -76.7916717529297, -1.34026751019935, 218, 25, 'PPL', 'P'),
(5262, 'Queenstown', 33.5880584716797, 0.586222209683185, -86.6211090087891, -1.51182355393229, 218, 2, 'PPL', 'P'),
(50679, 'Queenstown', 38.9905586242676, 0.68051362518534, -76.1580581665039, -1.32920886693085, 218, 25, 'PPL', 'P'),
(105522, 'Queenstown', 37.6802787780762, 0.657644927746775, -76.4877777099609, -1.33496355857235, 218, 53, 'PPL', 'P'),
(166263, 'Queenstown', 41.0063896179199, 0.715696513188322, -79.6322174072266, -1.38984438442005, 218, 45, 'PPL', 'P'),
(175995, 'Queenstown', 45.3519401550293, 0.791540677872689, -90.2880630493164, -1.5758239754588, 218, 57, 'PPL', 'P'),
(50680, 'Queenstown Mobile Home Park', 38.9625015258789, 0.680023936439902, -76.10888671875, -1.32835066326957, 218, 25, 'PPL', 'P'),
(30912, 'Queensville', 39.0511093139648, 0.681570434084911, -85.6772232055664, -1.49534963890322, 218, 19, 'PPL', 'P'),
(208510, 'Queets', 47.5397186279297, 0.829724615529054, -124.331108093262, -2.16998719888039, 218, 56, 'PPL', 'P'),
(189301, 'Quemado', 34.3438911437988, 0.599413978405811, -108.495002746582, -1.89359501988815, 218, 38, 'PPL', 'P'),
(192093, 'Quemado', 28.9477806091309, 0.505234082774303, -100.623611450195, -1.75621332505337, 218, 51, 'PPL', 'P'),
(33712, 'Quenemo', 38.579719543457, 0.673343130529329, -95.5266723632813, -1.66725495621313, 218, 20, 'PPL', 'P'),
(61458, 'Quentin', 31.5061092376709, 0.549885340690358, -90.7463912963867, -1.58382331242507, 218, 30, 'PPL', 'P'),
(166266, 'Quentin', 40.2794418334961, 0.703008880860048, -76.438606262207, -1.33410535491107, 218, 45, 'PPL', 'P'),
(121146, 'Quentin Corners', 42.166389465332, 0.735942329848295, -88.0630569458008, -1.53699029307549, 218, 18, 'PPL', 'P'),
(78992, 'Queonemysing (historical)', 39.839168548584, 0.695324662429761, -75.595832824707, -1.31939618357834, 218, 45, 'PPL', 'P'),
(57076, 'Quercus', 36.6313896179199, 0.63933835841357, -90.2494430541992, -1.5751499293869, 218, 29, 'PPL', 'P'),
(90176, 'Quercus', 35.4402809143066, 0.618549589786357, -87.4297180175781, -1.52593644349695, 218, 50, 'PPL', 'P'),
(30913, 'Quercus Grove', 38.853328704834, 0.678118511258977, -84.9227828979492, -1.48218217152555, 218, 19, 'PPL', 'P'),
(187240, 'Querida', 38.1261100769043, 0.665426151819769, -105.333892822266, -1.83842324369136, 218, 7, 'PPL', 'P'),
(68049, 'Querys Dixons (historical)', 35.2897186279297, 0.615921782159749, -80.7311096191406, -1.40902367164247, 218, 33, 'PPL', 'P'),
(97280, 'Quesada Colonia', 26.2819995880127, 0.458707426818615, -98.5820007324219, -1.72058049598422, 218, 51, 'PPL', 'P'),
(189302, 'Questa', 36.7038917541504, 0.640603759405521, -105.594436645508, -1.84297059125267, 218, 38, 'PPL', 'P'),
(42722, 'Quick', 30.5552806854248, 0.533290251831693, -91.5788879394531, -1.59835311985838, 218, 22, 'PPL', 'P'),
(68052, 'Quick', 36.4052810668945, 0.635392019731264, -79.4966735839844, -1.38747869842373, 218, 33, 'PPL', 'P'),
(111022, 'Quick', 38.372501373291, 0.669726491189974, -81.4022216796875, -1.42073678674886, 218, 58, 'PPL', 'P'),
(117443, 'Quick', 41.2900009155273, 0.720646464127425, -95.6699981689453, -1.66975646342504, 218, 16, 'PPL', 'P'),
(199636, 'Quick', 40.4391708374023, 0.705796677889143, -100.647216796875, -1.75662531607401, 218, 35, 'PPL', 'P'),
(57077, 'Quick City', 38.5811080932617, 0.673367365295249, -94.0286102294922, -1.64110883957906, 218, 29, 'PPL', 'P'),
(83185, 'Quick Crossroads', 34.7169418334961, 0.605924941217864, -79.7399978637695, -1.39172550825602, 218, 48, 'PPL', 'P'),
(105525, 'Quicks Mill', 38.2122192382813, 0.666929040201927, -79.0294418334961, -1.37932396600785, 218, 53, 'PPL', 'P'),
(37839, 'Quicksand', 37.5288887023926, 0.655002672471253, -83.3450012207031, -1.45464468637996, 218, 21, 'PPL', 'P'),
(97279, 'Quicksand', 30.8826293945313, 0.539003564607753, -93.713508605957, -1.63560927876999, 218, 51, 'PPL', 'P'),
(105523, 'Quicksburg', 38.6930618286133, 0.67532132658704, -78.6791687011719, -1.37321054656752, 218, 53, 'PPL', 'P'),
(157270, 'Quickstep', 40.6599998474121, 0.709650871197733, -83.8388900756836, -1.46326467303828, 218, 41, 'PPL', 'P'),
(166265, 'Quicktown', 41.3663902282715, 0.721979709148146, -75.4538879394531, -1.3169187779743, 218, 45, 'PPL', 'P'),
(169568, 'Quidnessett', 41.6272201538086, 0.7265320501365, -71.4538879394531, -1.24710560789452, 218, 47, 'PPL', 'P'),
(125905, 'Quidnet', 41.3041687011719, 0.720893738634639, -69.9805603027344, -1.22139118967315, 218, 23, 'PPL', 'P'),
(169569, 'Quidnick', 41.6963882446289, 0.727739261058633, -71.5374984741211, -1.24856488701383, 218, 47, 'PPL', 'P'),
(50682, 'Quiet Acres', 38.4836082458496, 0.671665671937715, -76.7319412231445, -1.33922501579064, 218, 25, 'PPL', 'P'),
(83187, 'Quiet Acres', 34.9458312988281, 0.609919816011037, -81.0947189331055, -1.41536985136207, 218, 48, 'PPL', 'P'),
(105524, 'Quiet Cove', 37.3072204589844, 0.651133831776668, -76.4869384765625, -1.33494891118635, 218, 53, 'PPL', 'P'),
(111027, 'Quiet Dale', 39.0133285522461, 0.680911035399007, -80.4100036621094, -1.40341931544451, 218, 58, 'PPL', 'P'),
(78993, 'Quiet Dell', 39.8013916015625, 0.694665330322885, -80.5122222900391, -1.40520336705875, 218, 45, 'PPL', 'P'),
(111023, 'Quiet Dell', 39.2191696166992, 0.684503639709524, -80.2938919067383, -1.40139278301301, 218, 58, 'PPL', 'P'),
(50683, 'Quiet Inheritance', 39.5808296203613, 0.690815797546202, -76.4961090087891, -1.33510896716787, 218, 25, 'PPL', 'P'),
(50684, 'Quiet Meadows', 38.5691719055176, 0.673159039518977, -76.6166687011719, -1.33721313074514, 218, 25, 'PPL', 'P'),
(24183, 'Quiet Place in the Woods', 34.3433303833008, 0.599404191288805, -83.7874984741211, -1.46236772038314, 218, 13, 'PPL', 'P'),
(97281, 'Quiet Village Number 2 Colonia', 26.1720008850098, 0.45678758727829, -98.0780029296875, -1.71178407490369, 218, 51, 'PPL', 'P'),
(197318, 'Quietus', 45.0963897705078, 0.787080482258051, -106.282501220703, -1.85497958355616, 218, 31, 'PPL', 'P'),
(166267, 'Quiggleville', 41.3283309936523, 0.721315450193253, -77.1111068725586, -1.34584270478338, 218, 45, 'PPL', 'P'),
(42726, 'Quigley', 32.8547210693359, 0.573423057484264, -92.3047180175781, -1.61102124453167, 218, 22, 'PPL', 'P'),
(195506, 'Quigley', 42.7383308410645, 0.745924589983212, -113.06916809082, -1.97342926567573, 218, 17, 'PPL', 'P'),
(197320, 'Quigley', 46.6736106872559, 0.814608180286628, -112.593612670898, -1.96512925782238, 218, 31, 'PPL', 'P'),
(205460, 'Quigley Crossing', 41.8669395446777, 0.730715942788042, -111.980278015137, -1.95442454866276, 218, 52, 'PPL', 'P'),
(151964, 'Quigley Park', 42.1363906860352, 0.735418752377986, -79.396110534668, -1.38572354210731, 218, 40, 'PPL', 'P'),
(97282, 'Quihi', 29.3913898468018, 0.512976524563922, -99.0297164916992, -1.72839461009668, 218, 51, 'PPL', 'P'),
(178935, 'Quijotoa', 32.1272201538086, 0.560725771197039, -112.137496948242, -1.95716853669192, 218, 5, 'PPL', 'P'),
(208511, 'Quilcene', 47.8224983215332, 0.834660052240216, -122.874443054199, -2.14456359785005, 218, 56, 'PPL', 'P'),
(117444, 'Quilhart (historical)', 41.7186088562012, 0.728127083892376, -93.5325012207031, -1.63245010392689, 218, 16, 'PPL', 'P'),
(24184, 'Quill', 34.6427803039551, 0.604630578349058, -84.3002777099609, -1.4713174063844, 218, 13, 'PPL', 'P'),
(208512, 'Quillayute', 47.9433288574219, 0.836768942928423, -124.541107177734, -2.17365237433061, 218, 56, 'PPL', 'P'),
(14461, 'Quillens Point', 38.5863914489746, 0.673459577247992, -75.0730590820313, -1.31027206052568, 218, 10, 'PPL', 'P'),
(42723, 'Quimby', 32.235279083252, 0.562611755302006, -91.2163925170898, -1.59202638121474, 218, 22, 'PPL', 'P'),
(117445, 'Quimby', 42.6302795410156, 0.7440387390363, -95.6416702270508, -1.66926204756867, 218, 16, 'PPL', 'P'),
(128618, 'Quimby', 46.9622192382813, 0.819645349751431, -68.6086120605469, -1.19744617568003, 218, 26, 'PPL', 'P'),
(187241, 'Quimby', 39.8733291625977, 0.695920877618803, -104.943328857422, -1.83160661656519, 218, 7, 'PPL', 'P'),
(125906, 'Quinapoxet', 42.3777809143066, 0.739631806643464, -71.8513870239258, -1.25404327569223, 218, 23, 'PPL', 'P'),
(208513, 'Quinault', 47.4672203063965, 0.82845928111613, -123.844169616699, -2.16148851920973, 218, 56, 'PPL', 'P'),
(17744, 'Quinavista', 30.3283290863037, 0.529329199184363, -87.3563919067383, -1.52465666143511, 218, 12, 'PPL', 'P'),
(83188, 'Quinby', 34.2363891601563, 0.597537714838823, -79.7347183227539, -1.39163336288231, 218, 48, 'PPL', 'P'),
(105526, 'Quinby', 37.5536117553711, 0.655434171146873, -75.7341690063477, -1.32181060542261, 218, 53, 'PPL', 'P'),
(187853, 'Quinby', 37.9883308410645, 0.663021450513481, -100.928329467773, -1.76153165775026, 218, 20, 'PPL', 'P'),
(83189, 'Quinby Forest', 34.2266693115234, 0.597368071477385, -79.7297210693359, -1.39154614435661, 218, 48, 'PPL', 'P'),
(50685, 'Quince Orchard', 39.1177787780762, 0.682734035744193, -77.2527770996094, -1.34831531669746, 218, 25, 'PPL', 'P'),
(50686, 'Quince Orchard Knolls', 39.1055603027344, 0.682520783119905, -77.2505569458008, -1.3482765677036, 218, 25, 'PPL', 'P'),
(50687, 'Quince Orchard Manor', 39.1286087036133, 0.682923053602562, -77.2527770996094, -1.34831531669746, 218, 25, 'PPL', 'P'),
(50688, 'Quince Orchard Valley', 39.1347198486328, 0.683029713204219, -77.2547225952148, -1.34834927200136, 218, 25, 'PPL', 'P'),
(50689, 'Quince View Meadows', 38.7013893127441, 0.675466668603531, -76.595832824707, -1.33684947609829, 218, 25, 'PPL', 'P'),
(151962, 'Quincetree Landing', 41.0291709899902, 0.716094123139071, -72.0133285522461, -1.25686968855714, 218, 40, 'PPL', 'P'),
(17745, 'Quincy', 30.5869407653809, 0.53384282446837, -84.5833282470703, -1.4762575702065, 218, 12, 'PPL', 'P'),
(28358, 'Quincy', 39.9355583190918, 0.697006981290364, -91.4097213745117, -1.59540060631587, 218, 18, 'PPL', 'P'),
(30914, 'Quincy', 39.4536094665527, 0.688595386987349, -86.7125015258789, -1.51341865426719, 218, 19, 'PPL', 'P'),
(33713, 'Quincy', 37.8819389343262, 0.661164561443424, -95.9925003051758, -1.67538518754698, 218, 20, 'PPL', 'P'),
(37840, 'Quincy', 38.6238899230957, 0.674114049085879, -83.1308288574219, -1.45090667347393, 218, 21, 'PPL', 'P'),
(57081, 'Quincy', 38.0083312988281, 0.663370524353364, -93.4722213745117, -1.63139802213825, 218, 29, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(61460, 'Quincy', 33.9097213745117, 0.591836286419127, -88.366943359375, -1.54229411154443, 218, 30, 'PPL', 'P'),
(78994, 'Quincy', 39.8033294677734, 0.694699152468729, -77.5747222900391, -1.35393432028142, 218, 45, 'PPL', 'P'),
(90177, 'Quincy', 35.8338890075684, 0.625419346976271, -89.0811080932617, -1.55475863755239, 218, 50, 'PPL', 'P'),
(117446, 'Quincy', 41.0402793884277, 0.716288001266429, -94.7900009155273, -1.65439761394439, 218, 16, 'PPL', 'P'),
(125907, 'Quincy', 42.2527809143066, 0.737450145078471, -71.0027770996094, -1.23923223844781, 218, 23, 'PPL', 'P'),
(132746, 'Quincy', 41.9441719055176, 0.732063901773786, -84.8838882446289, -1.48150333176368, 218, 27, 'PPL', 'P'),
(144351, 'Quincy', 43.7874984741211, 0.764236019585406, -71.7750015258789, -1.25271009725054, 218, 36, 'PPL', 'P'),
(157271, 'Quincy', 40.2991714477539, 0.703353227588996, -83.9688873291016, -1.46553355312897, 218, 41, 'PPL', 'P'),
(184338, 'Quincy', 39.936939239502, 0.697031082898229, -120.946113586426, -2.11090789957418, 218, 6, 'PPL', 'P'),
(201448, 'Quincy', 46.1438903808594, 0.805362816825336, -123.158889770508, -2.14952812959613, 218, 43, 'PPL', 'P'),
(208514, 'Quincy', 47.2344398498535, 0.82439649571516, -119.851387023926, -2.09180131664951, 218, 56, 'PPL', 'P'),
(175996, 'Quincy (historical)', 43.8763885498047, 0.765787444078432, -89.9561080932617, -1.57003026850734, 218, 57, 'PPL', 'P'),
(125908, 'Quincy Center', 42.2458305358887, 0.737328838090818, -71.0083312988281, -1.23932917751149, 218, 23, 'PPL', 'P'),
(166268, 'Quincy Hollow', 40.1536102294922, 0.700812705067115, -74.8625030517578, -1.30659716453748, 218, 45, 'PPL', 'P'),
(28359, 'Quincy Junction', 39.4511108398438, 0.688551777724499, -91.0250015258789, -1.58868597825945, 218, 18, 'PPL', 'P'),
(184339, 'Quincy Junction', 39.9633293151855, 0.697491676608759, -120.897216796875, -2.11005448960286, 218, 6, 'PPL', 'P'),
(132747, 'Quincy Mill', 47.1480598449707, 0.822888880222066, -88.458610534668, -1.5438940055693, 218, 27, 'PPL', 'P'),
(125909, 'Quincy Neck', 42.2411117553711, 0.737246479834107, -70.970832824707, -1.23867470567361, 218, 23, 'PPL', 'P'),
(125910, 'Quincy Point', 42.2458305358887, 0.737328838090818, -70.9833297729492, -1.23889281856688, 218, 23, 'PPL', 'P'),
(113965, 'Quinebaug', 42.023609161377, 0.733450343437281, -71.9502792358398, -1.25576927039472, 218, 8, 'PPL', 'P'),
(68054, 'Quinerly', 35.3638916015625, 0.617216344765636, -77.3708267211914, -1.3503756712748, 218, 33, 'PPL', 'P'),
(201449, 'Quines Creek', 42.7791709899902, 0.746637385048972, -123.270561218262, -2.1514771640399, 218, 43, 'PPL', 'P'),
(97283, 'Quiney', 32.5233306884766, 0.56763920422883, -94.420280456543, -1.64794477462313, 218, 51, 'PPL', 'P'),
(212118, 'Quinhagak', 59.7488899230957, 1.04281485356968, -161.915832519531, -2.82596438857353, 218, 1, 'PPL', 'P'),
(97284, 'Quinif', 30.8769397735596, 0.538904261988607, -96.9775009155273, -1.69257669133177, 218, 51, 'PPL', 'P'),
(17746, 'Quinlan', 30.4172191619873, 0.530880623677389, -81.5994415283203, -1.42417892245778, 218, 12, 'PPL', 'P'),
(77028, 'Quinlan', 36.4544410705566, 0.63625002365546, -99.0449981689453, -1.72866132567985, 218, 42, 'PPL', 'P'),
(97285, 'Quinlan', 32.9102783203125, 0.574392714437162, -96.1352767944336, -1.67787710737897, 218, 51, 'PPL', 'P'),
(11441, 'Quinlan (historical)', 35.1180610656738, 0.612925792512437, -91.0908279418945, -1.58983486595371, 218, 4, 'PPL', 'P'),
(166269, 'Quinlan Corners', 41.3269386291504, 0.721291148848306, -75.5638885498047, -1.31883865080414, 218, 45, 'PPL', 'P'),
(68053, 'Quinland', 35.4161109924316, 0.618127745069689, -83.0102767944336, -1.44880264305471, 218, 33, 'PPL', 'P'),
(111025, 'Quinland', 38.0166702270508, 0.663516066106936, -81.7702789306641, -1.42716059761424, 218, 58, 'PPL', 'P'),
(166270, 'Quinlantown', 41.5958290100098, 0.725984171321244, -76.6316680908203, -1.33747491948029, 218, 45, 'PPL', 'P'),
(178936, 'Quinlin', 32.2561111450195, 0.562975343369829, -111.605827331543, -1.9478891513477, 218, 5, 'PPL', 'P'),
(61461, 'Quinlivan', 31.1916694641113, 0.544397331342518, -90.4972229003906, -1.57947450352303, 218, 30, 'PPL', 'P'),
(11442, 'Quinn', 33.2816696166992, 0.580874715372361, -92.6144409179688, -1.61642692891231, 218, 4, 'PPL', 'P'),
(37841, 'Quinn', 37.2933311462402, 0.650891417538443, -87.8363876342773, -1.53303416727617, 218, 21, 'PPL', 'P'),
(50690, 'Quinn', 39.5069389343262, 0.689526161788331, -76.533332824707, -1.33575864531579, 218, 25, 'PPL', 'P'),
(97286, 'Quinn', 30.3824996948242, 0.530274654660855, -94.0344390869141, -1.6412105723327, 218, 51, 'PPL', 'P'),
(139414, 'Quinn', 40.4072189331055, 0.705239011956881, -93.1686096191406, -1.62609899735926, 218, 29, 'PPL', 'P'),
(197321, 'Quinn', 45.6941719055176, 0.797513748723573, -112.740829467773, -1.96769867564209, 218, 31, 'PPL', 'P'),
(202526, 'Quinn', 43.9880599975586, 0.767736478522206, -102.125831604004, -1.78243201282715, 218, 49, 'PPL', 'P'),
(24185, 'Quinn (historical)', 31.7916698455811, 0.554869313512387, -82.5519409179688, -1.44080317293039, 218, 13, 'PPL', 'P'),
(57078, 'Quinn (historical)', 36.9755592346191, 0.645345251410299, -94.0391693115234, -1.64129313032649, 218, 29, 'PPL', 'P'),
(37842, 'Quinn Landing', 37.6416702270508, 0.656971081411958, -87.4966735839844, -1.52710503858327, 218, 21, 'PPL', 'P'),
(24186, 'Quinn Ridge', 33.8213882446289, 0.59029458246408, -84.0508270263672, -1.46696367063434, 218, 13, 'PPL', 'P'),
(200147, 'Quinn River Crossing', 41.5766716003418, 0.725649811446384, -118.434173583984, -2.06706627591902, 218, 39, 'PPL', 'P'),
(132750, 'Quinnesec', 45.8063888549805, 0.799472303968245, -87.9883270263672, -1.53568600993162, 218, 27, 'PPL', 'P'),
(151963, 'Quinneville', 42.2491683959961, 0.737387094739663, -75.774169921875, -1.32250875310237, 218, 40, 'PPL', 'P'),
(175998, 'Quinney', 44.0144386291504, 0.768196872495654, -88.3072204589844, -1.54125175029378, 218, 57, 'PPL', 'P'),
(111026, 'Quinnimont', 37.8544387817383, 0.660684593235964, -81.0447235107422, -1.41449726663091, 218, 58, 'PPL', 'P'),
(113966, 'Quinnipiac', 41.4333305358887, 0.723148037918364, -72.8344421386719, -1.27120082417312, 218, 8, 'PPL', 'P'),
(197322, 'Quinns', 47.3247184753418, 0.825972154974105, -114.800827026367, -2.0036524156226, 218, 31, 'PPL', 'P'),
(166271, 'Quinns Corner', 41.3163909912109, 0.721107057837954, -74.8463897705078, -1.30631593472636, 218, 45, 'PPL', 'P'),
(83191, 'Quinns Crossroad', 33.9891700744629, 0.593222927819704, -80.3452835083008, -1.40228973566815, 218, 48, 'PPL', 'P'),
(5267, 'Quinns Landing', 31.937219619751, 0.557409636297186, -88.1166687011719, -1.53792599472448, 218, 2, 'PPL', 'P'),
(68055, 'Quinns Store', 34.8888893127441, 0.608925990871247, -77.732780456543, -1.35669295569658, 218, 33, 'PPL', 'P'),
(169570, 'Quinnville', 41.9324989318848, 0.731860169950395, -71.4338912963867, -1.24675660063367, 218, 47, 'PPL', 'P'),
(105527, 'Quinque', 38.25, 0.667588438887831, -78.398063659668, -1.36830433804932, 218, 53, 'PPL', 'P'),
(61462, 'Quins Station (historical)', 31.2016696929932, 0.544571868262459, -90.4463882446289, -1.57858727140587, 218, 30, 'PPL', 'P'),
(5263, 'Quinsey', 32.9494400024414, 0.575076214730931, -86.4644393920898, -1.50908915328305, 218, 2, 'PPL', 'P'),
(125912, 'Quinsigamond Village', 42.2291717529297, 0.737038087478808, -71.7972183227539, -1.25309785350526, 218, 23, 'PPL', 'P'),
(78996, 'Quinsonia', 39.8363914489746, 0.695276192897922, -77.6025009155273, -1.35441914875787, 218, 45, 'PPL', 'P'),
(144352, 'Quint', 43.9972190856934, 0.767896334766638, -71.133056640625, -1.24150604538652, 218, 36, 'PPL', 'P'),
(97288, 'Quintana', 28.3466701507568, 0.494742726107504, -97.1449966430664, -1.69550004326035, 218, 51, 'PPL', 'P'),
(97289, 'Quintana Beach', 28.923059463501, 0.504802617388197, -95.3163909912109, -1.66358485391489, 218, 51, 'PPL', 'P'),
(187854, 'Quinter', 39.0694389343262, 0.681890346310856, -100.231941223145, -1.7493773900093, 218, 20, 'PPL', 'P'),
(17752, 'Quintette', 30.666109085083, 0.535224572310444, -87.3127822875977, -1.52389552999557, 218, 12, 'PPL', 'P'),
(184340, 'Quintette', 38.9150009155273, 0.67919489439256, -120.686111450195, -2.10637000623474, 218, 6, 'PPL', 'P'),
(5264, 'Quinton', 33.6719398498535, 0.587686215913429, -87.0666732788086, -1.51960011747338, 218, 2, 'PPL', 'P'),
(37843, 'Quinton', 36.9527816772461, 0.644947708038577, -84.6266708374023, -1.47701404111414, 218, 21, 'PPL', 'P'),
(42724, 'Quinton', 30.8222198486328, 0.537949219132191, -91.7050018310547, -1.60055422249933, 218, 22, 'PPL', 'P'),
(71314, 'Quinton', 39.5458297729492, 0.690204934971165, -75.4127807617188, -1.31620132237663, 218, 37, 'PPL', 'P'),
(77030, 'Quinton', 35.1227798461914, 0.613008150769148, -95.3708267211914, -1.66453493663378, 218, 42, 'PPL', 'P'),
(105528, 'Quinton', 37.5336112976074, 0.655085097306991, -77.1213912963867, -1.34602220184085, 218, 53, 'PPL', 'P'),
(197323, 'Quintonkon', 48.0263900756836, 0.838218634667807, -113.706108093262, -1.98454596585599, 218, 31, 'PPL', 'P'),
(5265, 'Quintown', 33.6363906860352, 0.587065765958468, -87.091667175293, -1.52003634325993, 218, 2, 'PPL', 'P'),
(144353, 'Quinttown', 43.8658294677734, 0.765603153330998, -72.0558319091797, -1.25761151207878, 218, 36, 'PPL', 'P'),
(111028, 'Quinwood', 38.0574989318848, 0.664228661435614, -80.7069396972656, -1.4086018269258, 218, 58, 'PPL', 'P'),
(105529, 'Quioccasin', 37.6072196960449, 0.656369806216845, -77.5791702270508, -1.35401195142719, 218, 53, 'PPL', 'P'),
(151966, 'Quioque', 40.8197212219238, 0.712438535068774, -72.6294403076172, -1.2676228672486, 218, 40, 'PPL', 'P'),
(137607, 'Quiring', 47.8824996948242, 0.835707273759863, -94.6994400024414, -1.65281702783743, 218, 28, 'PPL', 'P'),
(125913, 'Quissett', 41.5433311462402, 0.725067910748202, -70.6500015258789, -1.2330751431656, 218, 23, 'PPL', 'P'),
(192094, 'Quitaque', 34.3661117553711, 0.599801801239554, -101.056671142578, -1.76377164254313, 218, 51, 'PPL', 'P'),
(11443, 'Quitman', 35.3841705322266, 0.617570278874508, -92.2155609130859, -1.60946515950674, 218, 4, 'PPL', 'P'),
(24187, 'Quitman', 30.7847194671631, 0.53729471400479, -83.5599975585938, -1.45839708035588, 218, 13, 'PPL', 'P'),
(42725, 'Quitman', 32.3486099243164, 0.564589751622635, -92.7213897705078, -1.61829353852035, 218, 22, 'PPL', 'P'),
(61463, 'Quitman', 32.0400009155273, 0.55920350831795, -88.7280578613281, -1.54859674858021, 218, 30, 'PPL', 'P'),
(97290, 'Quitman', 32.7958297729492, 0.572395210461548, -95.4508285522461, -1.66593123199331, 218, 51, 'PPL', 'P'),
(139413, 'Quitman', 40.3733291625977, 0.704647523878774, -95.0763931274414, -1.65939610099436, 218, 29, 'PPL', 'P'),
(166272, 'Quitman', 40.9063911437988, 0.713951210567939, -76.5650024414063, -1.33631138440004, 218, 45, 'PPL', 'P'),
(125914, 'Quitnesset', 41.6563911437988, 0.727041179957896, -69.9625015258789, -1.22107600455814, 218, 23, 'PPL', 'P'),
(61465, 'Quito', 33.4386100769043, 0.583613843132534, -90.3011093139648, -1.576051675732, 218, 30, 'PPL', 'P'),
(90178, 'Quito', 35.4130592346191, 0.618074481847887, -89.934440612793, -1.56965209963254, 218, 50, 'PPL', 'P'),
(184341, 'Quito (historical)', 37.9366683959961, 0.662119770747408, -121.474998474121, -2.1201386822285, 218, 6, 'PPL', 'P'),
(68056, 'Quitsna', 35.9697189331055, 0.627790026399632, -77.067497253418, -1.34508157334383, 218, 33, 'PPL', 'P'),
(61466, 'Quiver (historical)', 33.6580581665039, 0.587443934833259, -90.5002822875977, -1.57952789990288, 218, 30, 'PPL', 'P'),
(121147, 'Quiver Beach', 40.3300018310547, 0.703891319287246, -90.0472183227539, -1.57162044199422, 218, 18, 'PPL', 'P'),
(178937, 'Quivero', 35.5325012207031, 0.620159137770174, -112.190002441406, -1.95808493042302, 218, 5, 'PPL', 'P'),
(57079, 'Qulin', 36.5958290100098, 0.638717708721527, -90.2472229003906, -1.57511118039304, 218, 29, 'PPL', 'P'),
(132751, 'Qumby', 42.610279083252, 0.743689665196418, -85.227783203125, -1.48750543107045, 218, 27, 'PPL', 'P'),
(128619, 'Quoddy', 44.9294395446777, 0.784166651130368, -67.0308303833008, -1.16990869053445, 218, 26, 'PPL', 'P'),
(61467, 'Quofaloma', 33.1047210693359, 0.57778638061425, -90.3461074829102, -1.57683704193747, 218, 30, 'PPL', 'P'),
(151965, 'Quogue', 40.8230590820313, 0.712496791717619, -72.6100006103516, -1.26728358052573, 218, 40, 'PPL', 'P'),
(169571, 'Quonochontaug', 41.3355598449707, 0.721441617449896, -71.7088928222656, -1.25155628270826, 218, 47, 'PPL', 'P'),
(169572, 'Quonochontaug Beach', 41.3316688537598, 0.721373706842099, -71.7222213745117, -1.25178890982948, 218, 47, 'PPL', 'P'),
(57080, 'Quote', 39.5391693115234, 0.690088687989584, -93.6830596923828, -1.63507784497447, 218, 29, 'PPL', 'P'),
(205462, 'R and M Acres', 40.6347198486328, 0.709209651984134, -111.931938171387, -1.95358085922942, 218, 52, 'PPL', 'P'),
(97297, 'R and R Colonia', 27.9479999542236, 0.487784618548427, -97.9550018310547, -1.70963730074898, 218, 51, 'PPL', 'P'),
(97291, 'R C Babb Colonia', 26.1299991607666, 0.456054518898732, -97.9729995727539, -1.70995142059955, 218, 51, 'PPL', 'P'),
(97292, 'R C Babb Colonia Number 2', 26.1280002593994, 0.456019631488452, -97.9720001220703, -1.70993397689441, 218, 51, 'PPL', 'P'),
(97293, 'R C Babb Colonia Number 3 and 4', 26.1310005187988, 0.456071995893386, -97.9759979248047, -1.71000375171497, 218, 51, 'PPL', 'P'),
(97294, 'R C W Colonia', 26.3390007019043, 0.459702283933327, -98.2030029296875, -1.71396573646868, 218, 51, 'PPL', 'P'),
(208515, 'R Corner', 48.0941696166992, 0.839401610824021, -123.273612976074, -2.1515304272617, 218, 56, 'PPL', 'P'),
(193894, 'R Flourney', 41.211109161377, 0.719269543264827, -120.525833129883, -2.10357262182572, 218, 6, 'PPL', 'P'),
(97295, 'R Ruiz Colonia', 26.2280006408691, 0.457764967398349, -98.3740005493164, -1.71695020794428, 218, 51, 'PPL', 'P'),
(97296, 'R S W incorporated Number 1 Colonia', 26.2250003814697, 0.457712602993416, -98.1600036621094, -1.7132152576735, 218, 51, 'PPL', 'P'),
(90179, 'R T Estates', 35.7341690063477, 0.623678904624877, -86.4097213745117, -1.50813414371615, 218, 50, 'PPL', 'P'),
(192095, 'R W Jones Colonia', 31.9969997406006, 0.558452996233252, -106.59700012207, -1.86046862487892, 218, 51, 'PPL', 'P'),
(142812, 'R-Villa Courts', 40.7000007629395, 0.710349018877498, -99.1152801513672, -1.72988797767794, 218, 35, 'PPL', 'P'),
(157272, 'Raab Corners', 41.6577796936035, 0.727065414723816, -83.8183288574219, -1.46290581208139, 218, 41, 'PPL', 'P'),
(30915, 'Raab Crossroads', 39.4877815246582, 0.689191801913472, -86.991943359375, -1.51829583432951, 218, 19, 'PPL', 'P'),
(105530, 'Rabat', 36.9769401550293, 0.645369353018164, -78.9488906860352, -1.3779180832684, 218, 53, 'PPL', 'P'),
(5266, 'Rabb', 31.4388904571533, 0.548712151651151, -86.8805618286133, -1.51635185989181, 218, 2, 'PPL', 'P'),
(97299, 'Rabb', 27.8002796173096, 0.485206412297121, -97.75, -1.70605934382446, 218, 51, 'PPL', 'P'),
(97300, 'Rabb Road Colonia', 26.19700050354, 0.457223912933386, -97.8379974365234, -1.70759518882511, 218, 51, 'PPL', 'P'),
(132752, 'Rabbit Bay', 47.0636100769043, 0.821414953716762, -88.3552780151367, -1.5420905128791, 218, 27, 'PPL', 'P'),
(90180, 'Rabbit Bluff (historical)', 35.9075012207031, 0.626704122465153, -85.9913864135742, -1.50083282127159, 218, 50, 'PPL', 'P'),
(68057, 'Rabbit Corner', 36.2438888549805, 0.632575194246287, -76.3222198486328, -1.33207402878961, 218, 33, 'PPL', 'P'),
(37844, 'Rabbit Hash', 38.9413909912109, 0.679655488103089, -84.8472213745117, -1.48086337415374, 218, 21, 'PPL', 'P'),
(24189, 'Rabbit Hill', 31.9061107635498, 0.556866684329946, -81.2694396972656, -1.41841930396827, 218, 13, 'PPL', 'P'),
(177269, 'Rabbit Hill', 40.2919387817383, 0.703226993753326, -80.6016693115234, -1.40676451208976, 218, 58, 'PPL', 'P'),
(97301, 'Rabbit Patch Colonia Number 1', 26.2709999084473, 0.458515446193534, -98.2990036010742, -1.71564126426851, 218, 51, 'PPL', 'P'),
(97302, 'Rabbit Patch Colonia Number 2', 26.2709999084473, 0.458515446193534, -98.2979965209961, -1.71562368740531, 218, 51, 'PPL', 'P'),
(11445, 'Rabbit Ridge', 35.3972206115723, 0.617798045726737, -92.4633331298828, -1.61378960048481, 218, 4, 'PPL', 'P'),
(37845, 'Rabbit Ridge', 37.2919387817383, 0.650867116193496, -87.6930618286133, -1.53053266006426, 218, 21, 'PPL', 'P'),
(50691, 'Rabbit Run', 39.5686111450195, 0.690602544921914, -77.1972198486328, -1.34734565974456, 218, 25, 'PPL', 'P'),
(105531, 'Rabbit Run', 37.2350006103516, 0.649873357632733, -77.482780456543, -1.35232963256659, 218, 53, 'PPL', 'P'),
(5269, 'Rabbit Town', 34.2797203063965, 0.598293986009378, -86.2583312988281, -1.50549188844063, 218, 2, 'PPL', 'P'),
(37846, 'Rabbit Town', 37.9058303833008, 0.661581545891103, -84.0152816772461, -1.46634328725841, 218, 21, 'PPL', 'P'),
(50692, 'Rabbit Town', 38.4891700744629, 0.671762744159448, -75.8319396972656, -1.32351702589108, 218, 25, 'PPL', 'P'),
(24190, 'Rabbitown', 34.3141708374023, 0.598895261204491, -83.7794418334961, -1.46222710547758, 218, 13, 'PPL', 'P'),
(5271, 'Rabbittown', 34.2638893127441, 0.598017683046282, -87.4955596923828, -1.52708559750732, 218, 2, 'PPL', 'P'),
(30916, 'Rabbitville', 38.7686080932617, 0.676639857642738, -86.4738922119141, -1.50925413611258, 218, 19, 'PPL', 'P'),
(57082, 'Rabbitville', 38.0719413757324, 0.66448072963279, -90.7386093139648, -1.58368749120948, 218, 29, 'PPL', 'P'),
(5272, 'Rabbityard', 32.4541702270508, 0.566432126464752, -87.5208282470703, -1.52752661698383, 218, 2, 'PPL', 'P'),
(97303, 'Rabbs Prairie', 29.9633293151855, 0.522958751409326, -96.8902816772461, -1.69105442845268, 218, 51, 'PPL', 'P'),
(11444, 'Rabell (historical)', 34.149169921875, 0.596015451959733, -93.6091690063477, -1.6337882092166, 218, 4, 'PPL', 'P'),
(123510, 'Raber', 41.0858306884766, 0.717083021430845, -85.4327774047852, -1.49108325483692, 218, 19, 'PPL', 'P'),
(132756, 'Raber', 46.089168548584, 0.804407740679407, -84.0713882446289, -1.46732253159123, 218, 27, 'PPL', 'P'),
(166273, 'Raberts Corner', 40.6913909912109, 0.71019875001299, -75.779167175293, -1.32259597162807, 218, 45, 'PPL', 'P'),
(83193, 'Rabon Crossroads', 34.3013916015625, 0.598672221463197, -80.741943359375, -1.40921275607986, 218, 48, 'PPL', 'P'),
(68058, 'Rabontown', 34.1730613708496, 0.596432436407413, -78.1777801513672, -1.36445966554163, 218, 33, 'PPL', 'P'),
(77032, 'Rabornville', 36.2052803039551, 0.631901347911469, -96.3272171020508, -1.68122709771418, 218, 42, 'PPL', 'P'),
(5273, 'Rabun', 31.0266704559326, 0.541517555387274, -87.7249984741211, -1.53109005968041, 218, 2, 'PPL', 'P'),
(24192, 'Raby Woods', 32.9933280944824, 0.575842206439465, -85.1041717529297, -1.48534800427138, 218, 13, 'PPL', 'P'),
(30917, 'Raccoon', 39.8561096191406, 0.695620339889787, -86.8963928222656, -1.5166281628549, 218, 19, 'PPL', 'P'),
(37847, 'Raccoon', 37.4902801513672, 0.654328826136436, -82.4400024414063, -1.4388494779547, 218, 21, 'PPL', 'P'),
(97304, 'Raccoon Bend', 30.0116691589355, 0.523802440842663, -96.1327819824219, -1.67783356469514, 218, 51, 'PPL', 'P'),
(24193, 'Raccoon Bluff', 31.4658298492432, 0.549182332741604, -81.2352828979492, -1.41782315535825, 218, 13, 'PPL', 'P'),
(105532, 'Raccoon Ford', 38.3630599975586, 0.669561708097525, -77.9416732788086, -1.36033882322889, 218, 53, 'PPL', 'P'),
(74001, 'Raccoon Island', 38.7194404602051, 0.675781720560487, -82.1961135864258, -1.43459281442637, 218, 41, 'PPL', 'P'),
(90181, 'Raccoon Valley', 36.2294387817383, 0.632322992891056, -83.8419418334961, -1.46331793626008, 218, 50, 'PPL', 'P'),
(42727, 'Raccourci (historical)', 30.7869396209717, 0.537333462998651, -91.5863876342773, -1.59848401422596, 218, 22, 'PPL', 'P'),
(11446, 'Race (historical)', 36.3911094665527, 0.635144678645022, -94.2880630493164, -1.64563714553858, 218, 4, 'PPL', 'P'),
(37848, 'Raceland', 38.5400009155273, 0.672649909697581, -82.7286071777344, -1.44388658084048, 218, 21, 'PPL', 'P'),
(42729, 'Raceland', 29.7272205352783, 0.518837875807078, -90.5988922119141, -1.58124896775735, 218, 22, 'PPL', 'P'),
(37849, 'Raceland Junction', 38.5483283996582, 0.672795251714072, -82.7630615234375, -1.44448792261462, 218, 21, 'PPL', 'P'),
(42728, 'Raceland Junction', 29.7477798461914, 0.519196703474452, -90.5730590820313, -1.5807980945848, 218, 22, 'PPL', 'P'),
(24194, 'Racepond', 31.0027809143066, 0.541100604229109, -82.1297225952148, -1.43343407303608, 218, 13, 'PPL', 'P'),
(197324, 'Racetrack', 46.2788887023926, 0.807718982020757, -112.747779846191, -1.96781998262975, 218, 31, 'PPL', 'P'),
(151967, 'Raceville', 43.4661102294922, 0.758626736539427, -73.271110534668, -1.27882212542266, 218, 40, 'PPL', 'P'),
(105533, 'Raceway Farms', 38.7275009155273, 0.67592240204507, -77.1811065673828, -1.34706442993345, 218, 53, 'PPL', 'P'),
(97305, 'Rachal', 26.889720916748, 0.469314164939641, -98.1350021362305, -1.71277889872889, 218, 51, 'PPL', 'P'),
(111033, 'Rachel', 39.5183296203613, 0.689724966763706, -80.3038864135742, -1.40156722006441, 218, 58, 'PPL', 'P'),
(190640, 'Rachel', 37.644718170166, 0.657024278054732, -115.742782592773, -2.02009264166388, 218, 39, 'PPL', 'P'),
(90182, 'Rachel Estates', 36.2613906860352, 0.632880658823319, -85.4877777099609, -1.49204319125184, 218, 50, 'PPL', 'P'),
(166275, 'Rachelwood', 40.2922210693359, 0.703231920601343, -79.0969390869141, -1.38050201531605, 218, 45, 'PPL', 'P'),
(184343, 'Racimo', 34.0625, 0.594502776460568, -117.610557556152, -2.05269146446115, 218, 6, 'PPL', 'P'),
(819, 'Racine', 38.9711112976074, 0.680174205304409, -81.914436340332, -1.42967661905409, 218, 41, 'PPL', 'P'),
(57085, 'Racine', 36.896110534668, 0.643958610009721, -94.5272216796875, -1.64981125107311, 218, 29, 'PPL', 'P'),
(111029, 'Racine', 38.1419410705566, 0.665702454782864, -81.6605606079102, -1.42524565163241, 218, 58, 'PPL', 'P'),
(117448, 'Racine', 42.4702796936035, 0.74124621489627, -93.3291702270508, -1.6289013086163, 218, 16, 'PPL', 'P'),
(137610, 'Racine', 43.7761116027832, 0.764037281189059, -92.482780456543, -1.61412902036574, 218, 28, 'PPL', 'P'),
(175999, 'Racine', 42.7261085510254, 0.745711270779897, -87.7827835083008, -1.53209859878523, 218, 57, 'PPL', 'P'),
(197325, 'Racine Ford (historical)', 47.4791717529297, 0.828667873208511, -112.586112976074, -1.96499836345481, 218, 31, 'PPL', 'P'),
(125915, 'Racing Beach', 41.5541687011719, 0.725257061764625, -70.6549987792969, -1.2331623616913, 218, 23, 'PPL', 'P'),
(184346, 'Rackerby', 39.4397201538086, 0.688352972749124, -121.340278625488, -2.11778737730207, 218, 6, 'PPL', 'P'),
(57083, 'Racket', 38.2933311462402, 0.668344710058386, -93.491943359375, -1.63174223570914, 218, 29, 'PPL', 'P'),
(111030, 'Racket', 39.0441703796387, 0.681449326834339, -80.9372177124023, -1.41262093648489, 218, 58, 'PPL', 'P'),
(11447, 'Racket Ridge (historical)', 35.5466690063477, 0.620406412277388, -92.6458282470703, -1.61697474114854, 218, 4, 'PPL', 'P'),
(199637, 'Rackett', 41.6666717529297, 0.72722061043634, -102.205558776855, -1.78382351449672, 218, 35, 'PPL', 'P'),
(105534, 'Rackettown', 36.8633308410645, 0.643386496428545, -80.8291702270508, -1.41073515211701, 218, 53, 'PPL', 'P'),
(83195, 'Rackley', 34.6800003051758, 0.605280189917956, -82.9027786254883, -1.44692644606675, 218, 48, 'PPL', 'P'),
(132754, 'Raco', 46.375560760498, 0.809406227729376, -84.7227783203125, -1.47869143312672, 218, 27, 'PPL', 'P'),
(184344, 'Raco', 36.8005599975586, 0.642290938535114, -119.978057861328, -2.09401213982844, 218, 6, 'PPL', 'P'),
(57084, 'Racola', 38.0325012207031, 0.663792369070032, -90.7566680908203, -1.58400267632449, 218, 29, 'PPL', 'P'),
(97306, 'Racquet Club Colonia', 26.3040008544922, 0.459091421358291, -98.2160034179688, -1.71419263779356, 218, 51, 'PPL', 'P'),
(205465, 'Racquet Club Drive Condo', 40.6180610656738, 0.708918901372125, -111.790283203125, -1.95110851363144, 218, 52, 'PPL', 'P'),
(205464, 'Racquet Club Row', 40.6177787780762, 0.708913974524108, -111.791107177734, -1.95112289470133, 218, 52, 'PPL', 'P'),
(105537, 'Racume', 36.7480583190918, 0.641374611383045, -77.7222213745117, -1.35650866494914, 218, 53, 'PPL', 'P'),
(111031, 'Racy', 39.1386108398438, 0.683097623812017, -81.2380599975586, -1.41787162489009, 218, 58, 'PPL', 'P'),
(132755, 'Racy', 43.1949996948242, 0.753894965072628, -84.3061065673828, -1.47141913913804, 218, 27, 'PPL', 'P'),
(111032, 'Rada', 39.2738914489746, 0.685458715855453, -78.9136123657227, -1.37730236042437, 218, 58, 'PPL', 'P'),
(192096, 'Radar Base', 28.8583297729492, 0.503672871164272, -100.529716491699, -1.75457454887659, 218, 51, 'PPL', 'P'),
(146131, 'Radburn', 40.9425010681152, 0.714581447639906, -74.116943359375, -1.29358469313524, 218, 37, 'PPL', 'P'),
(37850, 'Radcliff', 37.8402786254883, 0.660437451886805, -85.9491729736328, -1.50009605775602, 218, 21, 'PPL', 'P'),
(74002, 'Radcliff', 39.1408309936523, 0.683136372805877, -82.3769378662109, -1.43774879347617, 218, 41, 'PPL', 'P'),
(105536, 'Radcliff', 36.6477813720703, 0.639624448493672, -78.1549987792969, -1.36406205559088, 218, 53, 'PPL', 'P'),
(111034, 'Radcliff', 39.5233306884766, 0.689812251868433, -80.0872192382813, -1.39778566447455, 218, 58, 'PPL', 'P'),
(50693, 'Radcliffe', 38.6091690063477, 0.673857120619714, -76.6152801513672, -1.33718889597922, 218, 25, 'PPL', 'P'),
(117449, 'Radcliffe', 42.3152809143066, 0.738540975860967, -93.4341735839844, -1.63073396292044, 218, 16, 'PPL', 'P'),
(50695, 'Radcliffe Estates', 38.5063896179199, 0.672063281888464, -76.9636077880859, -1.34326836011565, 218, 25, 'PPL', 'P'),
(125916, 'Raddin Station', 42.4597206115723, 0.741061924148836, -70.9791717529297, -1.23882024742718, 218, 23, 'PPL', 'P'),
(28362, 'Raddle', 37.7788887023926, 0.659365995601239, -89.586669921875, -1.56358235603409, 218, 18, 'PPL', 'P'),
(166276, 'Radebaugh', 40.3127784729004, 0.703590714979203, -79.5788879394531, -1.38891360961906, 218, 45, 'PPL', 'P'),
(184345, 'Radec', 33.464168548584, 0.584059922615123, -116.913063049316, -2.04051788880229, 218, 6, 'PPL', 'P'),
(57086, 'Rader', 37.4602813720703, 0.653805248666126, -92.7188873291016, -1.61824986267847, 218, 29, 'PPL', 'P'),
(90183, 'Rader', 36.1708297729492, 0.631300072716357, -82.9319381713867, -1.44743537615106, 218, 50, 'PPL', 'P'),
(166277, 'Rader', 41.1686096191406, 0.718527786322213, -79.2561111450195, -1.38328009180716, 218, 45, 'PPL', 'P'),
(197326, 'Radersburg', 46.1958312988281, 0.806269356860399, -111.63111114502, -1.94833043714033, 218, 31, 'PPL', 'P'),
(209678, 'Raderville', 42.9055595397949, 0.748843281379884, -107.378059387207, -1.87410068070877, 218, 59, 'PPL', 'P'),
(266, 'Radford', 32.589168548584, 0.568788291660172, -87.1999969482422, -1.52192705447583, 218, 2, 'PPL', 'P'),
(28363, 'Radford', 39.5774993896484, 0.690757674055411, -89.0344390869141, -1.55394410973298, 218, 18, 'PPL', 'P'),
(105544, 'Radford', 37.1380615234375, 0.648181451392206, -79.6180572509766, -1.38959724307089, 218, 53, 'PPL', 'P'),
(68059, 'Radford Crossroads', 35.5200004577637, 0.619940958297869, -78.1144409179688, -1.36335418737314, 218, 33, 'PPL', 'P'),
(105541, 'Radiant', 38.3133316040039, 0.668693783898268, -78.2074966430664, -1.36497831616392, 218, 53, 'PPL', 'P'),
(50694, 'Radiant Valley', 38.9363899230957, 0.679568202998362, -76.8927764892578, -1.34203212073764, 218, 25, 'PPL', 'P'),
(57087, 'Radical', 36.6227798461914, 0.639188089549063, -93.4188919067383, -1.63046724733727, 218, 29, 'PPL', 'P'),
(117450, 'Radio City Mobile Home Park', 41.6269416809082, 0.726527189867511, -93.5999984741211, -1.63362815323508, 218, 16, 'PPL', 'P'),
(97307, 'Radio Junction', 31.0766696929932, 0.542390206697466, -98.168327331543, -1.71336053311096, 218, 51, 'PPL', 'P'),
(24195, 'Radio Springs', 34.2219390869141, 0.597285513483592, -85.2427825927734, -1.48776721980561, 218, 13, 'PPL', 'P'),
(123506, 'Radioville', 41.1597213745117, 0.718372657188716, -86.89111328125, -1.51653601748119, 218, 19, 'PPL', 'P'),
(176002, 'Radisson', 45.7688903808594, 0.798817832130358, -91.2211074829102, -1.59210867289242, 218, 57, 'PPL', 'P'),
(33715, 'Radium', 38.1741714477539, 0.666264980984116, -98.8930587768555, -1.7260094830244, 218, 20, 'PPL', 'P'),
(97308, 'Radium', 32.8291702270508, 0.57297711115973, -99.995002746582, -1.74524203346863, 218, 51, 'PPL', 'P'),
(105542, 'Radium', 36.7316703796387, 0.64108858788197, -77.6286087036133, -1.35487481562038, 218, 53, 'PPL', 'P'),
(137613, 'Radium', 48.2294387817383, 0.841762503130376, -96.6133270263672, -1.68622065791613, 218, 28, 'PPL', 'P'),
(178938, 'Radium', 33.4502792358398, 0.583817508376898, -110.823890686035, -1.93424178234159, 218, 5, 'PPL', 'P'),
(24196, 'Radium Gardens', 31.5319404602051, 0.550336180573395, -84.1258316040039, -1.46827274746817, 218, 13, 'PPL', 'P'),
(24197, 'Radium Springs', 31.5261096954346, 0.55023441453024, -84.1355590820313, -1.46844252398766, 218, 13, 'PPL', 'P'),
(189303, 'Radium Springs', 32.5011100769043, 0.567251381395087, -106.92749786377, -1.86623689864198, 218, 38, 'PPL', 'P'),
(507, 'Radley', 37.4844398498535, 0.654226893645713, -94.7600021362305, -1.65387403647408, 218, 20, 'PPL', 'P'),
(121149, 'Radley', 41.6377792358398, 0.726716340883934, -88.9411087036133, -1.55231518725224, 218, 18, 'PPL', 'P'),
(123507, 'Radley', 40.4363899230957, 0.705748141778277, -85.7336120605469, -1.49633381008406, 218, 19, 'PPL', 'P'),
(90184, 'Radmoor', 35.0133285522461, 0.611097865319234, -85.1747207641602, -1.48657931680138, 218, 50, 'PPL', 'P'),
(90185, 'Radnor', 36.105281829834, 0.630156045291086, -86.7422180175781, -1.51393730488949, 218, 50, 'PPL', 'P'),
(111035, 'Radnor', 38.0794410705566, 0.664611624000368, -82.456672668457, -1.43914042830379, 218, 58, 'PPL', 'P'),
(123508, 'Radnor', 40.5094413757324, 0.707023130150152, -86.6350021362305, -1.51206603474954, 218, 19, 'PPL', 'P'),
(157280, 'Radnor', 40.3841705322266, 0.704836741474224, -83.1508331298828, -1.45125581389284, 218, 41, 'PPL', 'P'),
(166278, 'Radnor', 40.0461082458496, 0.698936441500126, -75.3602828979492, -1.31528506180359, 218, 45, 'PPL', 'P'),
(184347, 'Radnor', 35.8302803039551, 0.625356363216491, -119.260833740234, -2.08149421744063, 218, 6, 'PPL', 'P'),
(197327, 'Radnor', 48.6100006103516, 0.848404560047088, -114.659721374512, -2.00118965740455, 218, 31, 'PPL', 'P'),
(83194, 'Radnor (historical)', 32.6513900756836, 0.569874262173679, -80.6861114501953, -1.408238305437, 218, 48, 'PPL', 'P'),
(14462, 'Radnor Green', 39.8083305358887, 0.694786437573456, -75.4730606079102, -1.31725340416527, 218, 10, 'PPL', 'P'),
(105543, 'Radnor Heights', 38.8888893127441, 0.67873916095102, -77.0733337402344, -1.34518343925553, 218, 53, 'PPL', 'P'),
(166279, 'Radnor Station', 40.0397186279297, 0.698824921629479, -75.3688888549805, -1.31543526408907, 218, 45, 'PPL', 'P'),
(74003, 'Rado (historical)', 39.6991691589355, 0.692881212129613, -81.3824996948242, -1.42039257317796, 218, 41, 'PPL', 'P'),
(28364, 'Radom', 38.2819404602051, 0.668145905083012, -89.1922225952148, -1.55669795145818, 218, 18, 'PPL', 'P'),
(176005, 'Radspur', 46.1786117553711, 0.805968819131384, -91.3166732788086, -1.59377661068314, 218, 57, 'PPL', 'P'),
(184348, 'Radum', 37.670280456543, 0.657470424116347, -121.858062744141, -2.12682441498709, 218, 6, 'PPL', 'P'),
(121151, 'Radville', 40.4819412231445, 0.706543161942693, -89.8352813720703, -1.56792144439816, 218, 18, 'PPL', 'P'),
(11448, 'Radway (historical)', 33.8855590820313, 0.591414574860513, -92.2444381713867, -1.60996916274304, 218, 4, 'PPL', 'P'),
(208516, 'Raeco', 47.3833312988281, 0.826995141727832, -122.406669616699, -2.13639941121231, 218, 56, 'PPL', 'P'),
(68060, 'Raeford', 34.9808311462402, 0.610530678586074, -79.2244415283203, -1.38272735272292, 218, 33, 'PPL', 'P'),
(68062, 'Raemon', 34.6375007629395, 0.604538432975341, -79.3488922119141, -1.38489942690799, 218, 33, 'PPL', 'P'),
(24198, 'Raes (historical)', 33.499439239502, 0.584675512301094, -82.0572204589844, -1.43216867204413, 218, 13, 'PPL', 'P'),
(142819, 'Raeville', 41.8963890075684, 0.731229932878427, -98.0536117553711, -1.71135836860344, 218, 35, 'PPL', 'P'),
(97309, 'Rafael Pena Colonia', 26.3010005950928, 0.459039056953357, -98.640998840332, -1.7216102072197, 218, 51, 'PPL', 'P'),
(184349, 'Rafael Village', 38.0688896179199, 0.664427466410989, -122.548606872559, -2.1388766836583, 218, 6, 'PPL', 'P'),
(28365, 'Rafetown', 38.8580589294434, 0.67820106925277, -88.0022201538086, -1.53592849074887, 218, 18, 'PPL', 'P'),
(177681, 'Raffetto', 38.8636093139648, 0.678297941737421, -120.440277099609, -2.10207938740251, 218, 6, 'PPL', 'P'),
(61469, 'Rafn', 31.625560760498, 0.551970163060213, -90.2911071777344, -1.57587710552255, 218, 30, 'PPL', 'P'),
(195507, 'Raft River', 42.5972213745117, 0.743461765186134, -113.235282897949, -1.97632851599644, 218, 17, 'PPL', 'P'),
(90186, 'Rafter', 35.3925018310547, 0.617715687470026, -84.1783294677734, -1.46918900804121, 218, 50, 'PPL', 'P'),
(209679, 'Rafter J Ranch', 43.4261093139648, 0.757928588859663, -110.798332214355, -1.933795702859, 218, 59, 'PPL', 'P'),
(57088, 'Raftville (historical)', 37.4575004577637, 0.653756712555259, -91.9899978637695, -1.60552834162533, 218, 29, 'PPL', 'P'),
(11449, 'Ragan', 34.292781829834, 0.598521952598689, -90.8594436645508, -1.58579644847671, 218, 4, 'PPL', 'P'),
(142813, 'Ragan', 40.3102798461914, 0.703547105716353, -99.289436340332, -1.7329275765881, 218, 35, 'PPL', 'P'),
(5275, 'Ragan Chapel', 33.7508316040039, 0.589063136776027, -86.0441665649414, -1.50175400869265, 218, 2, 'PPL', 'P'),
(184350, 'Ragby', 37.6119384765625, 0.656452164473556, -120.134170532227, -2.0967368199397, 218, 6, 'PPL', 'P'),
(166280, 'Rager Summit', 40.6902809143066, 0.710179375516059, -77.352783203125, -1.3500607524759, 218, 45, 'PPL', 'P'),
(157275, 'Ragersville', 40.4524993896484, 0.706029305010362, -81.6263885498047, -1.42464923670629, 218, 41, 'PPL', 'P'),
(105545, 'Ragged Point Beach', 38.148609161377, 0.665818834922501, -76.6166687011719, -1.33721313074514, 218, 53, 'PPL', 'P'),
(202529, 'Ragged Top (historical)', 44.3597183227539, 0.774223139989312, -103.885276794434, -1.81314012440853, 218, 49, 'PPL', 'P'),
(11450, 'Raggio', 34.832218170166, 0.607936892842392, -90.6050033569336, -1.58135562735901, 218, 4, 'PPL', 'P'),
(200150, 'Raglan', 40.9094390869141, 0.714004407210713, -117.969169616699, -2.05895042565506, 218, 39, 'PPL', 'P'),
(5274, 'Ragland', 33.7444381713867, 0.588951550326353, -86.1558303833008, -1.50370290997837, 218, 2, 'PPL', 'P'),
(37852, 'Ragland', 37.1636085510254, 0.648627331137712, -88.8883285522461, -1.55139399983118, 218, 21, 'PPL', 'P'),
(61468, 'Ragland', 31.2188892364502, 0.544872405991474, -89.1736068725586, -1.55637304580519, 218, 30, 'PPL', 'P'),
(111036, 'Ragland', 37.7024993896484, 0.658032750580518, -82.1275024414063, -1.43339532404222, 218, 58, 'PPL', 'P'),
(189304, 'Ragland', 34.8224983215332, 0.607767249480953, -103.741668701172, -1.8106336903486, 218, 38, 'PPL', 'P'),
(197328, 'Ragland Bench (historical)', 47.7849998474121, 0.834005580402329, -109.429168701172, -1.90989929155578, 218, 31, 'PPL', 'P'),
(30919, 'Raglesville', 38.8033294677734, 0.677245859948785, -86.9613876342773, -1.51776253632122, 218, 19, 'PPL', 'P'),
(42730, 'Ragley', 30.5125007629395, 0.532543601330575, -93.2322235107422, -1.62720926921772, 218, 22, 'PPL', 'P'),
(208517, 'Ragnar', 47.4411087036133, 0.828003547674591, -121.706672668457, -2.12418215971157, 218, 56, 'PPL', 'P'),
(11451, 'Rago', 36.4505615234375, 0.636182312784745, -94.1958312988281, -1.64402739781768, 218, 4, 'PPL', 'P'),
(33716, 'Rago', 37.4527816772461, 0.653674354298549, -98.0813903808594, -1.71184319707989, 218, 20, 'PPL', 'P'),
(194388, 'Rago', 40.0019416809082, 0.698165589522603, -103.415000915527, -1.8049322619289, 218, 7, 'PPL', 'P'),
(11452, 'Ragsdale', 34.9402809143066, 0.609822943526386, -92.8949966430664, -1.62132355005059, 218, 4, 'PPL', 'P'),
(30920, 'Ragsdale', 38.7458305358887, 0.676242314271016, -87.3249969482422, -1.52410871604083, 218, 19, 'PPL', 'P'),
(90187, 'Ragsdale', 35.5016708374023, 0.619621046071923, -86.0158309936523, -1.50125945967822, 218, 50, 'PPL', 'P'),
(11453, 'Ragtown', 34.5402793884277, 0.602841599886797, -91.1100006103516, -1.59016949214468, 218, 4, 'PPL', 'P'),
(97311, 'Ragtown', 33.839168548584, 0.590604907310101, -95.7474975585938, -1.67110908294269, 218, 51, 'PPL', 'P'),
(111037, 'Ragtown', 39.6483306884766, 0.691993913433426, -80.2652816772461, -1.40089344030862, 218, 58, 'PPL', 'P'),
(184351, 'Ragtown', 34.6650009155273, 0.605018401182801, -116.151107788086, -2.02721926074093, 218, 6, 'PPL', 'P'),
(121152, 'Ragtown (historical)', 40.4491691589355, 0.705971181519571, -90.8099975585938, -1.58493345112547, 218, 18, 'PPL', 'P'),
(190641, 'Ragtown (historical)', 39.5038909912109, 0.689472965145557, -118.915832519531, -2.07547281021596, 218, 39, 'PPL', 'P'),
(30921, 'Rahm', 37.8691711425781, 0.660941721439211, -87.6144409179688, -1.5291604663126, 218, 19, 'PPL', 'P'),
(208518, 'Rahm', 47.3197212219238, 0.825884936448405, -117.175277709961, -2.04509439797754, 218, 56, 'PPL', 'P'),
(24200, 'Rahns', 32.3141708374023, 0.563988676164604, -81.2813873291016, -1.41862782948162, 218, 13, 'PPL', 'P'),
(166281, 'Rahns', 40.209171295166, 0.70178242859904, -75.4533309936523, -1.31690905743632, 218, 45, 'PPL', 'P'),
(146132, 'Rahway', 40.6080589294434, 0.70874433116267, -74.2780609130859, -1.29639672493026, 218, 37, 'PPL', 'P'),
(24205, 'Raiders Ridge', 33.667781829834, 0.587613644773724, -84.2013931274414, -1.46959154483998, 218, 13, 'PPL', 'P'),
(74004, 'Raiders Run', 39.2163887023926, 0.684455103598657, -84.3691711425781, -1.47251982361657, 218, 41, 'PPL', 'P'),
(17751, 'Raiford', 30.0636100769043, 0.524708980877726, -82.2366714477539, -1.43530068264412, 218, 12, 'PPL', 'P'),
(77033, 'Raiford', 35.2677803039551, 0.615538886174023, -95.7866668701172, -1.67179271639452, 218, 42, 'PPL', 'P'),
(57089, 'Rail', 37.2997207641602, 0.65100293740909, -92.3047180175781, -1.61102124453167, 218, 29, 'PPL', 'P'),
(184352, 'Rail Road Flat', 38.3433303833008, 0.669217361368578, -120.511108398438, -2.10331562678053, 218, 6, 'PPL', 'P'),
(78997, 'Railroad', 39.7605590820313, 0.693952668415179, -76.6986083984375, -1.33864324825051, 218, 45, 'PPL', 'P'),
(197329, 'Railroad Summer Home Area', 44.6561088562012, 0.779396130669709, -111.145278930664, -1.93985106538757, 218, 31, 'PPL', 'P'),
(37853, 'Railton', 36.9816703796387, 0.645451911011956, -86.1205596923828, -1.5030873202924, 218, 21, 'PPL', 'P'),
(5281, 'Raimund', 33.3677787780762, 0.58237760375452, -86.9613876342773, -1.51776253632122, 218, 2, 'PPL', 'P'),
(37854, 'Rain', 36.7205581665039, 0.640894643175585, -83.9449996948242, -1.46511663526032, 218, 21, 'PPL', 'P'),
(68064, 'Rain Forest', 35.0572204589844, 0.611863923606795, -80.7027816772461, -1.4085292557861, 218, 33, 'PPL', 'P'),
(189305, 'Rain Place', 35.2802810668945, 0.615757065646327, -103.065826416016, -1.79883801724842, 218, 38, 'PPL', 'P'),
(157276, 'Rain Rock', 40.1927795410156, 0.701496338518938, -82.2897186279297, -1.43622653059708, 218, 41, 'PPL', 'P'),
(24201, 'Rain Tree', 33.3730583190918, 0.582469749128236, -82.0702819824219, -1.43239663863344, 218, 13, 'PPL', 'P'),
(5276, 'Rainbow', 34.752498626709, 0.60654552433088, -86.7363891601563, -1.51383557213585, 218, 2, 'PPL', 'P'),
(74006, 'Rainbow', 39.4944381713867, 0.689307982316027, -81.4655609130859, -1.42184226491735, 218, 41, 'PPL', 'P'),
(97312, 'Rainbow', 32.2652816772461, 0.563135399351343, -97.7138900756836, -1.70542910675249, 218, 51, 'PPL', 'P'),
(113967, 'Rainbow', 41.9180603027344, 0.731608168332246, -72.6930618286133, -1.26873327226511, 218, 8, 'PPL', 'P'),
(184355, 'Rainbow', 33.4102783203125, 0.583119360697134, -117.146942138672, -2.04459984896311, 218, 6, 'PPL', 'P'),
(192753, 'Rainbow', 39.8438911437988, 0.695407087265499, -109.184722900391, -1.90563290748947, 218, 52, 'PPL', 'P'),
(197330, 'Rainbow', 47.538330078125, 0.829700380763134, -111.199172973633, -1.94079169388459, 218, 31, 'PPL', 'P'),
(201450, 'Rainbow', 44.1669387817383, 0.770858502268106, -122.235557556152, -2.13341294236589, 218, 43, 'PPL', 'P'),
(176006, 'Rainbow Beach', 44.1566696166992, 0.770679271526744, -88.4449996948242, -1.54365645160006, 218, 57, 'PPL', 'P'),
(33717, 'Rainbow Bend', 37.1749992370605, 0.648826136113087, -97.1305618286133, -1.69524810822123, 218, 20, 'PPL', 'P'),
(132757, 'Rainbow Bend', 44.1286087036133, 0.770189516202278, -84.9216690063477, -1.48216273044959, 218, 27, 'PPL', 'P'),
(184356, 'Rainbow Canyon Village', 33.4569396972656, 0.58393375535848, -117.114166259766, -2.04402780196096, 218, 6, 'PPL', 'P'),
(5277, 'Rainbow City', 33.954719543457, 0.592621652624591, -86.0419387817383, -1.50171512654073, 218, 2, 'PPL', 'P'),
(192754, 'Rainbow City', 37.0622215270996, 0.646857793751409, -110.764717102051, -1.93320900847086, 218, 52, 'PPL', 'P'),
(24202, 'Rainbow Estates', 33.8461112976074, 0.5907260811397, -84.0611114501953, -1.46714316769181, 218, 13, 'PPL', 'P'),
(50696, 'Rainbow Estates', 39.3733291625977, 0.687194231358831, -77.0583267211914, -1.34492151736232, 218, 25, 'PPL', 'P'),
(17753, 'Rainbow Falls', 29.1030597686768, 0.507944215368109, -82.4388885498047, -1.43883003687875, 218, 12, 'PPL', 'P'),
(83198, 'Rainbow Falls', 33.9041709899902, 0.591739413934475, -80.4094390869141, -1.40340946174847, 218, 48, 'PPL', 'P'),
(105547, 'Rainbow Forest', 37.3505592346191, 0.651890236105277, -79.2588882446289, -1.383328561339, 218, 53, 'PPL', 'P'),
(199638, 'Rainbow Fountain Park', 40.0491714477539, 0.69898990445901, -101.532501220703, -1.77207644408643, 218, 35, 'PPL', 'P'),
(30924, 'Rainbow Highlands', 39.8899993896484, 0.696211827967894, -85.9816665649414, -1.50066317791015, 218, 19, 'PPL', 'P'),
(121153, 'Rainbow Hills', 41.9194412231445, 0.731632269940111, -88.370002746582, -1.54234750792429, 218, 18, 'PPL', 'P'),
(128620, 'Rainbow Home Court Mobile Home Park', 44.833610534668, 0.782494119386771, -68.8183288574219, -1.20110642428224, 218, 26, 'PPL', 'P'),
(17754, 'Rainbow Homes', 26.4416694641113, 0.461494191872787, -80.0952835083008, -1.39792641253816, 218, 12, 'PPL', 'P'),
(11455, 'Rainbow Island', 35.4477806091309, 0.618680484153935, -91.8666687011719, -1.60337584167427, 218, 4, 'PPL', 'P'),
(151968, 'Rainbow Lake', 44.4669418334961, 0.776094543287311, -74.1733322143555, -1.29456886431608, 218, 40, 'PPL', 'P'),
(17755, 'Rainbow Lakes', 26.5469398498535, 0.463331506708833, -80.1350021362305, -1.39861963336991, 218, 12, 'PPL', 'P'),
(17756, 'Rainbow Lakes Estates', 29.1458301544189, 0.508690699421658, -82.4994430541992, -1.43988691235734, 218, 12, 'PPL', 'P'),
(5279, 'Rainbow Mountain Heights', 34.7477798461914, 0.606463166074169, -86.7144393920898, -1.51345247641304, 218, 2, 'PPL', 'P'),
(17757, 'Rainbow Park', 29.1666698455811, 0.509054420647535, -82.3744430541992, -1.43770525079235, 218, 12, 'PPL', 'P'),
(151969, 'Rainbow Shores', 43.6138916015625, 0.761206008055168, -76.1980590820313, -1.32990701461061, 218, 40, 'PPL', 'P'),
(68065, 'Rainbow Springs', 35.0941696166992, 0.612508808064758, -83.565559387207, -1.45849415257762, 218, 33, 'PPL', 'P'),
(137615, 'Rainbow Terrace Mobile Home Park', 43.6172218322754, 0.76126413154596, -93.357780456543, -1.62940065132069, 218, 28, 'PPL', 'P'),
(142814, 'Rainbow Trailer Court', 41.7816696166992, 0.729227701791879, -99.1327819824219, -1.73019344225497, 218, 35, 'PPL', 'P'),
(178939, 'Rainbow Valley', 33.2319412231445, 0.580006791173104, -112.386390686035, -1.961512551904, 218, 5, 'PPL', 'P'),
(24203, 'Rainbow Village', 34.297779083252, 0.598609171124389, -83.7927780151367, -1.46245986575685, 218, 13, 'PPL', 'P'),
(184358, 'Rainbow Wells', 35.204719543457, 0.61443826827452, -115.650833129883, -2.01848782079099, 218, 6, 'PPL', 'P'),
(197331, 'Rainbows End Mobile Home Park', 48.186939239502, 0.841020746187761, -114.397216796875, -1.99660808822323, 218, 31, 'PPL', 'P'),
(111039, 'Rainelle', 37.9686088562012, 0.662677236942589, -80.767219543457, -1.40965390871444, 218, 58, 'PPL', 'P'),
(24204, 'Raines', 31.8908290863037, 0.556599968746775, -83.8644409179688, -1.46371061936281, 218, 13, 'PPL', 'P'),
(90189, 'Raines', 35.0347213745117, 0.611471240504063, -90.0519409179688, -1.57170286682996, 218, 50, 'PPL', 'P'),
(71316, 'Raines Corner', 39.7119407653809, 0.693104118712853, -75.4499969482422, -1.3168508673665, 218, 37, 'PPL', 'P'),
(105549, 'Raines Corner', 38.1930618286133, 0.666594680327068, -77.3333282470703, -1.34972119943691, 218, 53, 'PPL', 'P'),
(111038, 'Raines Corner', 37.5186080932617, 0.654823241992809, -80.6175003051758, -1.40704081505285, 218, 58, 'PPL', 'P'),
(184357, 'Raines Houses', 37.4225006103516, 0.653145849980222, -122.16056060791, -2.13210399869012, 218, 6, 'PPL', 'P'),
(105550, 'Raines Tavern', 37.3666687011719, 0.652171399337362, -78.375, -1.36790180125056, 218, 53, 'PPL', 'P'),
(61470, 'Rainey', 31.521110534668, 0.550147162715026, -89.3505630493164, -1.55946151372136, 218, 30, 'PPL', 'P'),
(157277, 'Raineys (historical)', 41.1427803039551, 0.71807697972869, -83.3438873291016, -1.45462524530401, 218, 41, 'PPL', 'P'),
(166282, 'Raineytown', 40.0402793884277, 0.698834708746485, -79.644172668457, -1.39005304309145, 218, 45, 'PPL', 'P'),
(201451, 'Rainier', 46.089168548584, 0.804407740679407, -122.934722900391, -2.14561567963869, 218, 43, 'PPL', 'P'),
(208519, 'Rainier', 46.8883285522461, 0.81835571399356, -122.687217712402, -2.14129589919253, 218, 56, 'PPL', 'P'),
(208520, 'Rainier Beach', 47.5169410705566, 0.829327072157333, -122.256942749023, -2.13378618439267, 218, 56, 'PPL', 'P'),
(105551, 'Rainier Estates', 37.6683311462402, 0.657436402233422, -77.2997207641602, -1.34913463820682, 218, 53, 'PPL', 'P'),
(208521, 'Rainier Valley', 47.5555610656738, 0.830001118229232, -122.288612365723, -2.13433892347691, 218, 56, 'PPL', 'P'),
(201452, 'Rainrock', 44.0738906860352, 0.769234506635376, -123.851387023926, -2.16161448672929, 218, 43, 'PPL', 'P'),
(83199, 'Rains', 34.0974998474121, 0.595113639035605, -79.3158264160156, -1.38432231989977, 218, 48, 'PPL', 'P'),
(5280, 'Rains (historical)', 34.2597198486328, 0.597944912169496, -86.0861129760742, -1.50248611167631, 218, 2, 'PPL', 'P'),
(68066, 'Rains Crossroads', 35.5149993896484, 0.619853673193142, -78.1447219848633, -1.36388269169146, 218, 33, 'PPL', 'P'),
(24206, 'Rains Landing', 30.9972190856934, 0.541003532007376, -81.9069366455078, -1.42954572468651, 218, 13, 'PPL', 'P'),
(74007, 'Rainsboro', 39.2200012207031, 0.684518153937465, -83.4222183227539, -1.4559923790496, 218, 41, 'PPL', 'P'),
(78999, 'Rainsburg', 39.8941688537598, 0.69628459884468, -78.5163879394531, -1.37036948631662, 218, 45, 'PPL', 'P'),
(5285, 'Rainsville', 34.4941711425781, 0.602036859184403, -85.8477783203125, -1.49832638721166, 218, 2, 'PPL', 'P'),
(123511, 'Rainsville', 40.415828704834, 0.705389280821389, -87.315559387207, -1.52394399952741, 218, 19, 'PPL', 'P'),
(189306, 'Rainsville', 35.9786109924316, 0.627945222112157, -105.208610534668, -1.83623665527835, 218, 38, 'PPL', 'P'),
(105552, 'Rainswood', 37.9169387817383, 0.661775424018461, -76.5488891601563, -1.33603015458892, 218, 53, 'PPL', 'P'),
(30922, 'Raintown', 39.8783302307129, 0.69600816272353, -86.5100021362305, -1.50988437318455, 218, 19, 'PPL', 'P'),
(111040, 'Raintown', 38.1772193908691, 0.666318177626891, -80.2305603027344, -1.40028743800257, 218, 58, 'PPL', 'P'),
(50697, 'Raintree', 39.0433311462402, 0.681434679448344, -76.5027770996094, -1.3352253473075, 218, 25, 'PPL', 'P'),
(68067, 'Raintree', 34.8141708374023, 0.607621907464462, -77.4580612182617, -1.35189820047, 218, 33, 'PPL', 'P'),
(83201, 'Raintree', 34.9155616760254, 0.609391511429793, -81.9863891601563, -1.43093243266612, 218, 48, 'PPL', 'P'),
(105554, 'Raintree', 38.7133293151855, 0.675675060958829, -77.4316711425781, -1.35143760675947, 218, 53, 'PPL', 'P'),
(176007, 'Raintree', 43.1966705322266, 0.753924126686565, -89.2877807617188, -1.55836575609084, 218, 57, 'PPL', 'P'),
(178940, 'Raintree', 33.336109161377, 0.581824864670274, -111.90860748291, -1.95317366189875, 218, 5, 'PPL', 'P'),
(205466, 'Raintree', 41.1536102294922, 0.718265997587058, -111.91194152832, -1.95323185196856, 218, 52, 'PPL', 'P'),
(83202, 'Raintree Acres', 34.1216697692871, 0.595535483752274, -81.1519393920898, -1.41636853677085, 218, 48, 'PPL', 'P'),
(24208, 'Raintree East', 34.2291717529297, 0.597411747319262, -83.9158325195313, -1.46460757201795, 218, 13, 'PPL', 'P'),
(205468, 'Raintree Equestrian Community Condo', 40.5777816772461, 0.708215893423371, -111.823333740234, -1.95168535432356, 218, 52, 'PPL', 'P'),
(50698, 'Raintree Estates', 39.1994400024414, 0.684159292980577, -76.9991683959961, -1.34388900980769, 218, 25, 'PPL', 'P'),
(68069, 'Raintree Estates', 35.9833297729492, 0.628027580368868, -80.4297180175781, -1.40376339585734, 218, 33, 'PPL', 'P'),
(90191, 'Raintree Forest', 36.0036087036133, 0.628381514477739, -86.7174987792969, -1.51350587279289, 218, 50, 'PPL', 'P'),
(178941, 'Raintree Luxury Homes', 33.3313903808594, 0.581742506413563, -111.929443359375, -1.9535373165456, 218, 5, 'PPL', 'P'),
(14463, 'Raintree Village', 39.6541709899902, 0.692095845924149, -75.6805572509766, -1.32087490377361, 218, 10, 'PPL', 'P'),
(24209, 'Raintree West', 34.235279083252, 0.597518340341892, -83.9150009155273, -1.46459305779001, 218, 13, 'PPL', 'P'),
(77036, 'Rainy (historical)', 35.1444396972656, 0.613386186485884, -98.9541702270508, -1.72707607904098, 218, 42, 'PPL', 'P'),
(90192, 'Rainy (historical)', 35.6819381713867, 0.622767304583743, -85.0180587768555, -1.48384504931019, 218, 50, 'PPL', 'P'),
(132758, 'Rainy Beach', 45.4505615234375, 0.793261945464234, -84.2152786254883, -1.46983389249918, 218, 27, 'PPL', 'P'),
(137616, 'Rainy Junction', 47.4986114501953, 0.829007159931387, -92.5449981689453, -1.61521492430022, 218, 28, 'PPL', 'P'),
(200151, 'Raiser City (historical)', 41.1150016784668, 0.717592151252241, -119.273330688477, -2.08171233033391, 218, 39, 'PPL', 'P'),
(97314, 'Raisin', 28.7419395446777, 0.501641478463786, -97.1194381713867, -1.69505396377776, 218, 51, 'PPL', 'P'),
(132759, 'Raisin Center', 41.9288902282715, 0.731797186190614, -83.9533309936523, -1.46526204385584, 218, 27, 'PPL', 'P'),
(184362, 'Raisin City', 36.6025009155273, 0.638834155440191, -119.903060913086, -2.09270319615267, 218, 6, 'PPL', 'P'),
(117452, 'Rake', 43.4838905334473, 0.758937061385448, -93.9186096191406, -1.63918896674922, 218, 16, 'PPL', 'P'),
(157278, 'Raker Corners', 41.5302810668945, 0.724840143895973, -83.9844436645508, -1.4658050624021, 218, 41, 'PPL', 'P'),
(105556, 'Raketown', 36.8199996948242, 0.64263022525799, -80.9594421386719, -1.41300882589766, 218, 53, 'PPL', 'P'),
(125917, 'Rakeville', 42.0255584716797, 0.733484365320207, -71.4652786254883, -1.2473044128699, 218, 23, 'PPL', 'P'),
(185, 'Raleigh', 37.7566719055176, 0.658978239346523, -81.1744384765625, -1.41676121987359, 218, 58, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(17758, 'Raleigh', 29.4413890838623, 0.513849175874114, -82.4663925170898, -1.43931007166523, 218, 12, 'PPL', 'P'),
(24210, 'Raleigh', 32.9366683959961, 0.574853308147691, -84.6363906860352, -1.47718368447558, 218, 13, 'PPL', 'P'),
(28366, 'Raleigh', 37.8269386291504, 0.660204625028505, -88.5319366455078, -1.54517378763114, 218, 18, 'PPL', 'P'),
(30923, 'Raleigh', 39.7438888549805, 0.693661718066088, -85.3638916015625, -1.4898809707628, 218, 19, 'PPL', 'P'),
(37855, 'Raleigh', 37.7277793884277, 0.658473969794117, -88.059440612793, -1.53692717615765, 218, 21, 'PPL', 'P'),
(61472, 'Raleigh', 32.0333290100098, 0.559087061599286, -89.522216796875, -1.56245743678964, 218, 30, 'PPL', 'P'),
(68070, 'Raleigh', 35.7719383239746, 0.624338103573699, -78.6388931274414, -1.37250760519779, 218, 33, 'PPL', 'P'),
(90193, 'Raleigh', 35.2058296203613, 0.61445764277145, -89.9136123657227, -1.56928857814375, 218, 50, 'PPL', 'P'),
(97315, 'Raleigh', 32.0088882446289, 0.558660489771683, -96.6986083984375, -1.68770909864938, 218, 51, 'PPL', 'P'),
(117453, 'Raleigh', 43.3394393920898, 0.756415913360498, -94.8686065673828, -1.65576954137995, 218, 16, 'PPL', 'P'),
(198776, 'Raleigh', 46.357780456543, 0.809095902883355, -101.306106567383, -1.76812511197708, 218, 34, 'PPL', 'P'),
(105557, 'Raleigh Court', 37.2605590820313, 0.650319437115321, -79.9841690063477, -1.39598709863237, 218, 53, 'PPL', 'P'),
(105558, 'Raleigh Heights', 36.7872200012207, 0.642058111676814, -76.2838897705078, -1.33140504272378, 218, 53, 'PPL', 'P'),
(190643, 'Raleigh Heights', 39.5902786254883, 0.690980713796706, -119.839721679688, -2.09159771798418, 218, 39, 'PPL', 'P'),
(201453, 'Raleigh Hills', 45.4808311462402, 0.793790250045479, -122.760833740234, -2.14258074126044, 218, 43, 'PPL', 'P'),
(105559, 'Raleigh Place', 36.8083305358887, 0.642426560013626, -76.4072189331055, -1.33355754267484, 218, 53, 'PPL', 'P'),
(105560, 'Raleigh Terrace', 37.0041694641113, 0.645844594114688, -76.3680572509766, -1.33287404238107, 218, 53, 'PPL', 'P'),
(37857, 'Raley Ford', 36.8597183227539, 0.643323446089738, -86.267219543457, -1.50564701757412, 218, 21, 'PPL', 'P'),
(5283, 'Raley Forest Hill', 31.0111103057861, 0.541245979535114, -87.5111083984375, -1.5273569736224, 218, 2, 'PPL', 'P'),
(57092, 'Ralls', 39.6836090087891, 0.692609636277453, -91.4013900756836, -1.59525519772035, 218, 29, 'PPL', 'P'),
(192970, 'Ralls', 33.6741714477539, 0.587725164644371, -101.387222290039, -1.76954084841257, 218, 51, 'PPL', 'P'),
(11458, 'Rally Hill', 36.160831451416, 0.631125569085929, -92.9524993896484, -1.62232716230738, 218, 4, 'PPL', 'P'),
(90194, 'Rally Hill', 35.6686096191406, 0.622534677462525, -86.8311080932617, -1.51548872938251, 218, 50, 'PPL', 'P'),
(151970, 'Ralmar Park', 42.8872184753418, 0.748523169416857, -73.9138870239258, -1.29004069151462, 218, 40, 'PPL', 'P'),
(5284, 'Ralph', 33.0419387817383, 0.576690622983737, -87.7688903808594, -1.53185611796798, 218, 2, 'PPL', 'P'),
(11459, 'Ralph', 36.1719398498535, 0.631319447213287, -92.6741714477539, -1.61746942332103, 218, 4, 'PPL', 'P'),
(37856, 'Ralph', 37.6180610656738, 0.656559023812295, -86.8375015258789, -1.51560031583219, 218, 21, 'PPL', 'P'),
(50699, 'Ralph', 38.5069389343262, 0.672072869268388, -75.8305587768555, -1.32349292428321, 218, 25, 'PPL', 'P'),
(77037, 'Ralph', 35.5088882446289, 0.619747013591484, -99.0116729736328, -1.72807969129778, 218, 42, 'PPL', 'P'),
(79001, 'Ralph', 39.9283294677734, 0.696880814033722, -79.8905563354492, -1.3943532493036, 218, 45, 'PPL', 'P'),
(111042, 'Ralph', 38.4772186279297, 0.671554152067068, -80.3688888549805, -1.40270172668878, 218, 58, 'PPL', 'P'),
(132761, 'Ralph', 46.1086082458496, 0.804747027402283, -87.7836074829102, -1.53211297985511, 218, 27, 'PPL', 'P'),
(184359, 'Ralph', 37.9655609130859, 0.662624040299814, -120.269996643066, -2.09910743278404, 218, 6, 'PPL', 'P'),
(202533, 'Ralph', 45.776668548584, 0.798953586766924, -103.065559387207, -1.79883335671651, 218, 49, 'PPL', 'P'),
(157279, 'Ralph (historical)', 40.1313896179199, 0.700424882233372, -82.7808303833008, -1.44479804772356, 218, 41, 'PPL', 'P'),
(184360, 'Ralph Leggett Place', 39.8591690063477, 0.695673736269643, -123.401107788086, -2.15375563151052, 218, 6, 'PPL', 'P'),
(14464, 'Ralphs', 38.5008316040039, 0.671966276245758, -75.6366729736328, -1.3201089786441, 218, 10, 'PPL', 'P'),
(166284, 'Ralphton', 40.1136093139648, 0.70011455738735, -79.0205612182617, -1.37916897003241, 218, 45, 'PPL', 'P'),
(57091, 'Ralphwhite Ford (historical)', 37.8333282470703, 0.660316144899152, -92.8663864135742, -1.6208242073462, 218, 29, 'PPL', 'P'),
(965, 'Ralston', 36.3266716003418, 0.634020025716682, -88.8000030517578, -1.54985242903419, 218, 50, 'PPL', 'P'),
(50700, 'Ralston', 39.3708305358887, 0.687150622095981, -76.726936340332, -1.33913766410688, 218, 25, 'PPL', 'P'),
(61473, 'Ralston', 31.2386093139648, 0.545216586272854, -89.2416687011719, -1.55756094880942, 218, 30, 'PPL', 'P'),
(77038, 'Ralston', 36.5038909912109, 0.637113087585727, -96.7319412231445, -1.6882908661895, 218, 42, 'PPL', 'P'),
(117454, 'Ralston', 42.0416717529297, 0.733765595131319, -94.6327819824219, -1.65165362591523, 218, 16, 'PPL', 'P'),
(142815, 'Ralston', 41.2052803039551, 0.719167810511186, -96.0422210693359, -1.67625297858818, 218, 35, 'PPL', 'P'),
(146134, 'Ralston', 40.771110534668, 0.711590118524502, -74.6255569458008, -1.30246167483875, 218, 37, 'PPL', 'P'),
(166285, 'Ralston', 41.5063896179199, 0.724423159448294, -76.9544372558594, -1.34310830413414, 218, 45, 'PPL', 'P'),
(190644, 'Ralston', 37.5561103820801, 0.655477780409723, -117.15193939209, -2.04468706748881, 218, 39, 'PPL', 'P'),
(198778, 'Ralston', 48.2486114501953, 0.842097129321344, -101.475830078125, -1.77108734605758, 218, 34, 'PPL', 'P'),
(208522, 'Ralston', 46.9838905334473, 0.82002358520525, -118.341667175293, -2.06545173450816, 218, 56, 'PPL', 'P'),
(209680, 'Ralston', 44.7161102294922, 0.780443352189356, -108.863891601563, -1.90003334498147, 218, 59, 'PPL', 'P'),
(184361, 'Ralston (historical)', 39.0050010681152, 0.680765693382516, -120.675003051758, -2.10617612810738, 218, 6, 'PPL', 'P'),
(172437, 'Ralston Corner', 44.4291687011719, 0.775435277759462, -71.8341674804688, -1.25374273796322, 218, 55, 'PPL', 'P'),
(111044, 'Ralumco', 37.910831451416, 0.66166883099583, -81.9761123657227, -1.4307530687667, 218, 58, 'PPL', 'P'),
(79002, 'Ram', 39.851390838623, 0.695537981633076, -77.4608306884766, -1.35194653684378, 218, 45, 'PPL', 'P'),
(68073, 'Rama', 35.1775016784668, 0.613963226915077, -80.7694396972656, -1.4096926577083, 218, 33, 'PPL', 'P'),
(184364, 'Ramada', 39.5555610656738, 0.690374778069685, -121.709999084473, -2.12424021662333, 218, 6, 'PPL', 'P'),
(111043, 'Ramage', 37.9841690063477, 0.662948812794749, -81.8255615234375, -1.42812546087717, 218, 58, 'PPL', 'P'),
(5287, 'Ramah', 31.6122207641602, 0.551737336201913, -87.1374969482422, -1.52083622369334, 218, 2, 'PPL', 'P'),
(42731, 'Ramah', 30.4022197723389, 0.530618834942234, -91.5072174072266, -1.59710223309437, 218, 22, 'PPL', 'P'),
(90195, 'Ramah', 35.077220916748, 0.612212997446677, -87.329719543457, -1.52419114087656, 218, 50, 'PPL', 'P'),
(187242, 'Ramah', 39.1216697692871, 0.68280194635199, -104.165283203125, -1.81802715816688, 218, 7, 'PPL', 'P'),
(189307, 'Ramah', 35.1330604553223, 0.613187581247592, -108.491111755371, -1.89352710928035, 218, 38, 'PPL', 'P'),
(184363, 'Ramal', 38.2213897705078, 0.667089096183441, -122.393608093262, -2.136171444623, 218, 6, 'PPL', 'P'),
(205477, 'Ramanee', 40.6180610656738, 0.708918901372125, -111.886108398438, -1.95278097879601, 218, 52, 'PPL', 'P'),
(151971, 'Ramapo', 41.1411094665527, 0.718047818114753, -74.1688919067383, -1.29449136632836, 218, 40, 'PPL', 'P'),
(208523, 'Ramapo', 48.1216697692871, 0.83988157903148, -123.681671142578, -2.15865238580685, 218, 56, 'PPL', 'P'),
(42732, 'Rambin', 31.9516696929932, 0.557661837652417, -93.4541702270508, -1.63108297018129, 218, 22, 'PPL', 'P'),
(24211, 'Ramble Hills', 33.9797210693359, 0.5930580115692, -83.4641723632813, -1.45672461519131, 218, 13, 'PPL', 'P'),
(105561, 'Ramble Ridge', 37.1963882446289, 0.649199444718888, -80.4036102294922, -1.40330772899483, 218, 53, 'PPL', 'P'),
(209681, 'Rambler (historical)', 41.1586112976074, 0.718353282691785, -107.00611114502, -1.86760895923559, 218, 59, 'PPL', 'P'),
(178942, 'Rambler Mobile Park', 33.413890838623, 0.583182411035941, -111.630828857422, -1.94832551029231, 218, 5, 'PPL', 'P'),
(14465, 'Rambleton Acres', 39.6622200012207, 0.692236327671651, -75.6177825927734, -1.31977927930115, 218, 10, 'PPL', 'P'),
(50701, 'Ramblewood', 39.3627815246582, 0.687010140348479, -76.5872192382813, -1.33669914065475, 218, 25, 'PPL', 'P'),
(71317, 'Ramblewood', 39.9286117553711, 0.696885740881738, -74.9441680908203, -1.30802248835289, 218, 37, 'PPL', 'P'),
(105562, 'Ramblewood', 37.1922187805176, 0.649126673842102, -77.4097213745117, -1.35105451103666, 218, 53, 'PPL', 'P'),
(123512, 'Ramblewood', 41.5455589294434, 0.725106792900117, -85.220832824707, -1.4873841240828, 218, 19, 'PPL', 'P'),
(177412, 'Ramblewood', 40.1474990844727, 0.700706045465457, -76.8280563354492, -1.34090254096128, 218, 45, 'PPL', 'P'),
(68075, 'Ramblewood Apartments', 35.2730598449707, 0.615631031547739, -81.5508270263672, -1.42333043933448, 218, 33, 'PPL', 'P'),
(5288, 'Ramblewood Shores', 34.7855606079102, 0.607122564760073, -87.3141708374023, -1.52391976476149, 218, 2, 'PPL', 'P'),
(68076, 'Rambling Acres', 35.8283309936523, 0.625322341333565, -81.5555572509766, -1.42341299732828, 218, 33, 'PPL', 'P'),
(90197, 'Rambling Acres', 35.7130584716797, 0.623310456288065, -84.0283279418945, -1.46657098753161, 218, 50, 'PPL', 'P'),
(90198, 'Rambling Hills', 36.207218170166, 0.631935170057313, -83.3758316040039, -1.45518277807821, 218, 50, 'PPL', 'P'),
(42733, 'Rambling Oaks', 30.5766696929932, 0.533663560437494, -91.0436096191406, -1.58901075075438, 218, 22, 'PPL', 'P'),
(178943, 'Rambling Rons Mobile Home Park', 33.5261116027832, 0.58514103285964, -112.164169311523, -1.95763405725047, 218, 5, 'PPL', 'P'),
(24213, 'Rambling Woods', 33.9777793884277, 0.593024122844329, -84.057502746582, -1.46708018393203, 218, 13, 'PPL', 'P'),
(17759, 'Rambo', 30.9966697692871, 0.540993944627451, -85.4038925170898, -1.49057911844257, 218, 12, 'PPL', 'P'),
(97316, 'Rambo', 32.917781829834, 0.574523675383767, -94.0911102294922, -1.64219967036156, 218, 51, 'PPL', 'P'),
(112792, 'Rambo', 36.2688903808594, 0.633011553190896, -96.8891677856445, -1.69103498737672, 218, 42, 'PPL', 'P'),
(97317, 'Rambo Estates Colonia', 26.3169994354248, 0.459318289393652, -98.0849990844727, -1.71190618083967, 218, 51, 'PPL', 'P'),
(11461, 'Rambo Riviera', 36.3083305358887, 0.633699913753655, -93.904167175293, -1.63893689855205, 218, 4, 'PPL', 'P'),
(197332, 'Ramburg (historical)', 48.3569412231445, 0.843987840537246, -109.057777404785, -1.90341729062058, 218, 31, 'PPL', 'P'),
(137618, 'Rambush Estates II', 44.1027793884277, 0.769738709608755, -94.2272186279297, -1.64457521005391, 218, 28, 'PPL', 'P'),
(5290, 'Ramer', 32.0502815246582, 0.559382938796394, -86.2213897705078, -1.50484713714072, 218, 2, 'PPL', 'P'),
(90199, 'Ramer', 35.0694389343262, 0.612077176231083, -88.6222229003906, -1.54674958004814, 218, 50, 'PPL', 'P'),
(117455, 'Ramessa (historical)', 41.8138885498047, 0.729790028256049, -90.4069366455078, -1.57789871110603, 218, 16, 'PPL', 'P'),
(37858, 'Ramey', 38.1791687011719, 0.666352199509816, -83.5719375610352, -1.45860547271118, 218, 21, 'PPL', 'P'),
(137619, 'Ramey', 45.8352813720703, 0.799976573520651, -93.9375, -1.63951866609217, 218, 28, 'PPL', 'P'),
(166287, 'Ramey', 40.7980613708496, 0.712060499352037, -78.3974990844727, -1.36829448435329, 218, 45, 'PPL', 'P'),
(195508, 'Ramey', 44.0027809143066, 0.767993406988372, -116.936943054199, -2.04093467351289, 218, 17, 'PPL', 'P'),
(105563, 'Ramey Fork', 38.0294418334961, 0.663738972690176, -76.8625030517578, -1.34150374957736, 218, 53, 'PPL', 'P'),
(24214, 'Ramhurst', 34.6980590820313, 0.605595375032967, -84.730827331543, -1.47883191487423, 218, 13, 'PPL', 'P'),
(97323, 'Ramireno', 27.0066699981689, 0.471355311467619, -99.3844375610352, -1.73458566068279, 218, 51, 'PPL', 'P'),
(97318, 'Ramirez', 27.3452796936035, 0.477265165532128, -98.4094390869141, -1.71756872710745, 218, 51, 'PPL', 'P'),
(184365, 'Ramirez', 39.2675018310547, 0.685347195984806, -121.537780761719, -2.12123443985901, 218, 6, 'PPL', 'P'),
(97319, 'Ramirez Colonia', 26.2290000915527, 0.457782411103489, -98.3560028076172, -1.71663608809371, 218, 51, 'PPL', 'P'),
(97320, 'Ramirez Colonia Number 2', 26.2299995422363, 0.457799854808629, -98.3560028076172, -1.71663608809371, 218, 51, 'PPL', 'P'),
(97321, 'Ramirez Colonia Number 3', 26.2310009002686, 0.457817331803283, -98.3560028076172, -1.71663608809371, 218, 51, 'PPL', 'P'),
(97322, 'Ramirez Colonia Number 4', 26.2310009002686, 0.457817331803283, -98.3560028076172, -1.71663608809371, 218, 51, 'PPL', 'P'),
(97324, 'Ramirez Estates Colonia', 26.2450008392334, 0.458061676833298, -98.3619995117188, -1.71674075032455, 218, 51, 'PPL', 'P'),
(71318, 'Rammel Mill', 39.4691696166992, 0.68886696283951, -75.2425003051758, -1.31322936775816, 218, 37, 'PPL', 'P'),
(189308, 'Ramon', 34.232780456543, 0.597474731079042, -104.899436950684, -1.83084055827763, 218, 38, 'PPL', 'P'),
(97325, 'Ramon Leal Colonia', 26.3169994354248, 0.459318289393652, -98.3109970092773, -1.71585058873019, 218, 51, 'PPL', 'P'),
(33718, 'Ramona', 38.5972213745117, 0.673648595106361, -97.0616683959961, -1.69404569098906, 218, 20, 'PPL', 'P'),
(77039, 'Ramona', 36.5302810668945, 0.637573681296256, -95.9233322143555, -1.67417797662485, 218, 42, 'PPL', 'P'),
(132762, 'Ramona', 43.6041717529297, 0.76103636469373, -85.8019409179688, -1.4975263736202, 218, 27, 'PPL', 'P'),
(171141, 'Ramona', 44.1194381713867, 0.770029460220765, -97.2161102294922, -1.69674120948638, 218, 49, 'PPL', 'P'),
(184368, 'Ramona', 38.5475006103516, 0.672780804065159, -121.407783508301, -2.11896555976832, 218, 6, 'PPL', 'P'),
(50702, 'Ramona Beach', 39.2291717529297, 0.684678209918979, -76.4002838134766, -1.3334365020033, 218, 25, 'PPL', 'P'),
(151973, 'Ramona Beach', 43.5400009155273, 0.759916372297298, -76.2219390869141, -1.33032379932121, 218, 40, 'PPL', 'P'),
(184367, 'Ramona Bowl', 33.7197189331055, 0.58852011822976, -116.949440002441, -2.04115278640617, 218, 6, 'PPL', 'P'),
(97326, 'Ramona Colonia', 26.2740001678467, 0.458567810598467, -98.4380035400391, -1.71806727086352, 218, 51, 'PPL', 'P'),
(132764, 'Ramona Park', 42.1897201538086, 0.736349527178968, -85.5411071777344, -1.49297396605282, 218, 27, 'PPL', 'P'),
(42734, 'Ramos', 29.6769409179688, 0.517960330938383, -91.1386108398438, -1.59066883484907, 218, 22, 'PPL', 'P'),
(97327, 'Ramos Addition Number 1 Colonia', 26.42799949646, 0.46125560592863, -99.0279998779297, -1.72836464953442, 218, 51, 'PPL', 'P'),
(97328, 'Ramos Colonia', 26.4270000457764, 0.46123816222349, -99.0250015258789, -1.728312318419, 218, 51, 'PPL', 'P'),
(97329, 'Ramosville Colonia', 26.1280002593994, 0.456019631488452, -98.004997253418, -1.71050988548014, 218, 51, 'PPL', 'P'),
(105564, 'Ramoth', 38.4219398498535, 0.67058935538316, -77.4697189331055, -1.35210166597728, 218, 53, 'PPL', 'P'),
(111045, 'Ramp', 37.7502784729004, 0.658866652896849, -80.8230590820313, -1.41062849251535, 218, 58, 'PPL', 'P'),
(184371, 'Rampart', 39.1647186279297, 0.683553290674529, -120.177223205566, -2.09748823084127, 218, 6, 'PPL', 'P'),
(212119, 'Rampart', 65.504997253418, 1.14327787858199, -150.169998168945, -2.62096090576195, 218, 1, 'PPL', 'P'),
(166289, 'Rampart Ridge', 40.0633316040039, 0.699237045808169, -75.3499984741211, -1.31510556474612, 218, 45, 'PPL', 'P'),
(151974, 'Rampasture', 40.8519401550293, 0.713000861532944, -72.5288925170898, -1.2658679772483, 218, 40, 'PPL', 'P'),
(42735, 'Ramsay', 30.5255603790283, 0.532771534630372, -90.1258316040039, -1.57299250258783, 218, 22, 'PPL', 'P'),
(132765, 'Ramsay', 46.4702796936035, 0.811059384976043, -89.9963912963867, -1.57073334303512, 218, 27, 'PPL', 'P'),
(197334, 'Ramsay', 46.0058288574219, 0.802953188671033, -112.685279846191, -1.96672915184725, 218, 31, 'PPL', 'P'),
(166290, 'Ramsay Terrace', 40.1563911437988, 0.700861241177981, -79.540283203125, -1.38823982986327, 218, 45, 'PPL', 'P'),
(166291, 'Ramsaytown', 41.0805587768555, 0.716991009215182, -79.0669403076172, -1.37997843784574, 218, 45, 'PPL', 'P'),
(189310, 'Ramsdale Place', 33.8022193908691, 0.589960022852139, -105.722778320313, -1.84521057604553, 218, 38, 'PPL', 'P'),
(192097, 'Ramsdell', 35.1916694641113, 0.614210501422291, -100.440559387207, -1.75301846385166, 218, 51, 'PPL', 'P'),
(195509, 'Ramsdell', 47.3527793884277, 0.826461910298571, -116.675559997559, -2.03637267856558, 218, 17, 'PPL', 'P'),
(68077, 'Ramseur', 35.7333297729492, 0.623664257238882, -79.6527786254883, -1.39020324537693, 218, 33, 'PPL', 'P'),
(5291, 'Ramsey', 33.9922218322754, 0.593276191041505, -86.149169921875, -1.50358666299678, 218, 2, 'PPL', 'P'),
(11460, 'Ramsey', 33.8741683959961, 0.591215769885138, -92.5536117553711, -1.61536525974375, 218, 4, 'PPL', 'P'),
(28368, 'Ramsey', 39.1444396972656, 0.683199356565658, -89.1086120605469, -1.55523867233887, 218, 18, 'PPL', 'P'),
(30925, 'Ramsey', 38.3236083984375, 0.668873147797685, -86.1547164916992, -1.50368346890241, 218, 19, 'PPL', 'P'),
(68078, 'Ramsey', 35.5827789306641, 0.621036649349355, -81.5625, -1.42353417115788, 218, 33, 'PPL', 'P'),
(90202, 'Ramsey', 35.9772186279297, 0.62792092076721, -83.8444366455078, -1.4633614789439, 218, 50, 'PPL', 'P'),
(97330, 'Ramsey', 29.6536102294922, 0.51755313360771, -96.4011077880859, -1.68251673347205, 218, 51, 'PPL', 'P'),
(105566, 'Ramsey', 36.939998626709, 0.644724601718256, -82.5950012207031, -1.44155471699001, 218, 53, 'PPL', 'P'),
(111046, 'Ramsey', 38.1697196960449, 0.666187283259313, -81.0308303833008, -1.41425478581366, 218, 58, 'PPL', 'P'),
(137621, 'Ramsey', 43.7097206115723, 0.762878539798766, -92.9694366455078, -1.62262277318838, 218, 28, 'PPL', 'P'),
(140749, 'Ramsey', 48.1583290100098, 0.840521403483372, -99.0880584716797, -1.72941286973947, 218, 34, 'PPL', 'P'),
(146135, 'Ramsey', 41.0572204589844, 0.716583678726455, -74.1413879394531, -1.29401133154187, 218, 37, 'PPL', 'P'),
(157286, 'Ramsey', 40.1927795410156, 0.701496338518938, -80.833610534668, -1.41081265010473, 218, 41, 'PPL', 'P'),
(166292, 'Ramsey', 41.2844390869141, 0.720549391905692, -77.3247222900391, -1.34957099715143, 218, 45, 'PPL', 'P'),
(178944, 'Ramsey', 31.4458293914795, 0.548833258901722, -110.310829162598, -1.92528716949231, 218, 5, 'PPL', 'P'),
(193895, 'Ramsey', 41.2822189331055, 0.720510642911831, -120.507217407227, -2.10324771617273, 218, 6, 'PPL', 'P'),
(195510, 'Ramsey', 47.8644409179688, 0.835392088644852, -116.807220458984, -2.03867058711216, 218, 17, 'PPL', 'P'),
(105567, 'Ramsey (historical)', 37.0916709899902, 0.647371783841794, -82.3822174072266, -1.43784093884989, 218, 53, 'PPL', 'P'),
(190645, 'Ramsey (historical)', 39.4563903808594, 0.688643923098216, -119.389999389648, -2.08374858330339, 218, 39, 'PPL', 'P'),
(197333, 'Ramsey (historical)', 48.4249992370605, 0.845175676962449, -114.344436645508, -1.99568690080217, 218, 31, 'PPL', 'P'),
(121157, 'Ramsey Acres', 41.9394416809082, 0.731981343779993, -89.1194381713867, -1.55542762361821, 218, 18, 'PPL', 'P'),
(17760, 'Ramsey Beach', 30.4463901519775, 0.531389753498785, -87.3511123657227, -1.52456451606139, 218, 12, 'PPL', 'P'),
(172436, 'Ramsey Corner', 44.5705604553223, 0.777903029404557, -72.1111068725586, -1.25857624218366, 218, 55, 'PPL', 'P'),
(184373, 'Ramsey Crossing', 38.9983291625977, 0.680649246663852, -120.553329467773, -2.10405252345415, 218, 6, 'PPL', 'P'),
(105568, 'Ramsey Flats', 37.204719543457, 0.649344853314407, -82.4516677856445, -1.43905307662004, 218, 53, 'PPL', 'P'),
(83204, 'Ramsey Grove', 33.4780616760254, 0.584302403432374, -79.290283203125, -1.38387650673329, 218, 48, 'PPL', 'P'),
(37859, 'Ramsey Island', 36.8111114501953, 0.642475096124493, -84.9824981689453, -1.48322439961815, 218, 21, 'PPL', 'P'),
(61474, 'Ramsey Springs', 30.7705593109131, 0.537047572655631, -88.9147186279297, -1.55185459354171, 218, 30, 'PPL', 'P'),
(190647, 'Ramsey Station', 39.3883285522461, 0.687456020093986, -119.30638885498, -2.08228930418408, 218, 39, 'PPL', 'P'),
(146137, 'Ramseysburg', 40.8833312988281, 0.7135487403482, -75.0597229003906, -1.3100393002464, 218, 37, 'PPL', 'P'),
(68079, 'Ramseytown', 36.000560760498, 0.628328317834965, -82.3574981689453, -1.4374095067533, 218, 33, 'PPL', 'P'),
(105569, 'Ramsgate', 37.5338897705078, 0.65508995757598, -77.5994415283203, -1.35436575237801, 218, 53, 'PPL', 'P'),
(50704, 'Ramsgate News', 39.2400016784668, 0.684867227777347, -76.7083282470703, -1.33881289161195, 218, 25, 'PPL', 'P'),
(137624, 'Ramshaw', 47.4275016784668, 0.827766060284383, -92.5811080932617, -1.61584516137219, 218, 28, 'PPL', 'P'),
(146138, 'Ramtown', 40.1208305358887, 0.700240591485938, -74.144172668457, -1.29405993423177, 218, 37, 'PPL', 'P'),
(184374, 'Rana', 34.0894393920898, 0.594972957551022, -117.31916809082, -2.04760575888548, 218, 6, 'PPL', 'P'),
(5294, 'Ranburne', 33.5227813720703, 0.585082909368849, -85.3447189331055, -1.48954634457183, 218, 2, 'PPL', 'P'),
(211087, 'Ranch Camp', 21.0969390869141, 0.368211049159337, -157.017776489258, -2.74047718389809, 218, 15, 'PPL', 'P'),
(184375, 'Ranch House Estates', 38.4063911437988, 0.670317979268081, -120.618057250977, -2.10518223638856, 218, 6, 'PPL', 'P'),
(111047, 'Ranch Lake Estates', 38.4741706848145, 0.671500955424294, -81.883056640625, -1.42912893997591, 218, 58, 'PPL', 'P'),
(166293, 'Ranch Lands', 41.1644401550293, 0.718455015445426, -74.9524993896484, -1.30816789694841, 218, 45, 'PPL', 'P'),
(197335, 'Rancher (historical)', 46.2638893127441, 0.807457193285602, -107.402221679688, -1.87452239226738, 218, 31, 'PPL', 'P'),
(209682, 'Ranchester', 44.9088897705078, 0.783807989910562, -107.162780761719, -1.87034335988483, 218, 59, 'PPL', 'P'),
(97335, 'Ranchette Estates', 26.4822196960449, 0.462201926932476, -97.8236083984375, -1.70734405273431, 218, 51, 'PPL', 'P'),
(97332, 'Ranchette Estates Colonia', 26.4829998016357, 0.462215542343549, -97.822998046875, -1.70733340008995, 218, 51, 'PPL', 'P'),
(209683, 'Ranchettes', 41.2186088562012, 0.719400437632404, -104.78971862793, -1.82892561229581, 218, 59, 'PPL', 'P'),
(184378, 'Ranchita', 33.2099990844727, 0.57962382860835, -116.515830993652, -2.03358488153649, 218, 6, 'PPL', 'P'),
(97333, 'Ranchito', 26.0252799987793, 0.454226824732125, -97.629997253418, -1.70396490078516, 218, 51, 'PPL', 'P'),
(189312, 'Ranchito', 36.4041709899902, 0.635372645234333, -105.597221374512, -1.84301919394256, 218, 38, 'PPL', 'P'),
(97334, 'Ranchito San Jose Colonia', 26.9209995269775, 0.469860079673594, -99.2679977416992, -1.73255340245495, 218, 51, 'PPL', 'P'),
(189313, 'Ranchitos', 36.0280609130859, 0.628808286042424, -106.063331604004, -1.85115435212443, 218, 38, 'PPL', 'P'),
(97368, 'Ranchitos 359 East Colonia', 27.4899997711182, 0.4797910073785, -99.3669967651367, -1.73428126137019, 218, 51, 'PPL', 'P'),
(97337, 'Ranchitos del Norte Colonia', 26.4029998779297, 0.460819280273534, -98.8710021972656, -1.72562452308883, 218, 51, 'PPL', 'P'),
(97336, 'Ranchitos Las Lomas', 27.6566696166992, 0.482699944947679, -99.1980590820313, -1.73133274256931, 218, 51, 'PPL', 'P'),
(97338, 'Ranchitos las Lomas Colonia', 27.621000289917, 0.48207739775336, -99.2369995117188, -1.7320123812795, 218, 51, 'PPL', 'P'),
(97339, 'Ranchitos las Lomas Number 2 Colonia', 27.636999130249, 0.482356630193655, -99.2320022583008, -1.7319251627538, 218, 51, 'PPL', 'P'),
(97340, 'Ranchitos los Arcos Colonia', 27.6149997711182, 0.481972668943492, -99.2109985351563, -1.73155857862975, 218, 51, 'PPL', 'P'),
(97341, 'Ranchitos los Centenarios Colonia', 27.6119995117188, 0.481920304538559, -99.2129974365234, -1.73159346604003, 218, 51, 'PPL', 'P'),
(97342, 'Ranchitos los Fresnos Colonia', 27.617000579834, 0.482007589643286, -99.2080001831055, -1.73150624751433, 218, 51, 'PPL', 'P'),
(97343, 'Ranchitos los Mesquites Colonia', 27.6219997406006, 0.4820948414585, -99.2030029296875, -1.73141902898863, 218, 51, 'PPL', 'P'),
(97344, 'Ranchitos los Nopalitos Colonia', 27.6200008392334, 0.48205995404822, -99.2050018310547, -1.73145391639891, 218, 51, 'PPL', 'P'),
(97345, 'Ranchitos los Veteranos Colonia', 27.4449996948242, 0.479005607883522, -99.0179977416992, -1.72819007932496, 218, 51, 'PPL', 'P'),
(83205, 'Ranchland Ranchettes', 33.9866714477539, 0.593179318556854, -80.320556640625, -1.4018581704135, 218, 48, 'PPL', 'P'),
(50705, 'Ranchleigh', 39.3758316040039, 0.687237907200708, -76.6744384765625, -1.33822140353384, 218, 25, 'PPL', 'P'),
(184380, 'Rancho Adolfo Mobile Home Estates', 34.2244415283203, 0.59732918932547, -119.012496948242, -2.07715992276653, 218, 6, 'PPL', 'P'),
(97346, 'Rancho Alegre', 27.7413902282715, 0.484178598563919, -98.0944366455078, -1.71207089735309, 218, 51, 'PPL', 'P'),
(97347, 'Rancho Banquete', 27.8097190856934, 0.485371162100056, -97.8333282470703, -1.70751369609575, 218, 51, 'PPL', 'P'),
(184382, 'Rancho Bernardo', 33.0186080932617, 0.576283425653064, -117.059997558594, -2.04308237977398, 218, 6, 'PPL', 'P'),
(184384, 'Rancho Calaveras', 38.1708297729492, 0.666206657756243, -120.845558166504, -2.10915287641581, 218, 6, 'PPL', 'P'),
(184385, 'Rancho Calevero Mobile Home Park', 33.1794395446777, 0.579090464021035, -117.276390075684, -2.04685914167388, 218, 6, 'PPL', 'P'),
(184386, 'Rancho Carlsbad Trailer Park', 33.1500015258789, 0.578576673667731, -117.290557861328, -2.04710641618109, 218, 6, 'PPL', 'P'),
(184387, 'Rancho Casitas Mobile Home Park', 33.7083282470703, 0.588321313254386, -116.247222900391, -2.02889678591157, 218, 6, 'PPL', 'P'),
(97348, 'Rancho Chaparral Colonia', 26.2900009155273, 0.458847076328276, -98.2990036010742, -1.71564126426851, 218, 51, 'PPL', 'P'),
(97349, 'Rancho Chico', 28.0252799987793, 0.489133409772011, -97.4966735839844, -1.70163796378271, 218, 51, 'PPL', 'P'),
(97350, 'Rancho Chico Addition Colonia', 28.0270004272461, 0.489163436913302, -97.4980010986328, -1.70166113328419, 218, 51, 'PPL', 'P'),
(97351, 'Rancho Colonia', 26.3059997558594, 0.459126308768571, -98.5559997558594, -1.72012669333447, 218, 51, 'PPL', 'P'),
(184388, 'Rancho Cordova', 38.589168548584, 0.673508046779832, -121.301666259766, -2.11711346438823, 218, 6, 'PPL', 'P'),
(184390, 'Rancho Cucamonga', 34.1063919067383, 0.59526883474813, -117.592216491699, -2.05237135249813, 218, 6, 'PPL', 'P'),
(178953, 'Rancho de Arboleda', 33.4569396972656, 0.58393375535848, -111.780563354492, -1.95093887027001, 218, 5, 'PPL', 'P'),
(178954, 'Rancho de Chandler', 33.288890838623, 0.581000749470948, -111.819442749023, -1.95161744371576, 218, 5, 'PPL', 'P'),
(97360, 'Rancho de la Parita', 28.0192108154297, 0.489027482539653, -98.2188186645508, -1.71424177311567, 218, 51, 'PPL', 'P'),
(184423, 'Rancho del Arroyo Mobile Home Park', 35.0969390869141, 0.612557144438543, -120.59806060791, -2.10483322912771, 218, 6, 'PPL', 'P'),
(184424, 'Rancho del Avion Capistrano Mobile Home Park', 33.4877815246582, 0.584472046793812, -117.669166564941, -2.05371438463585, 218, 6, 'PPL', 'P'),
(177680, 'Rancho Del Campo', 32.6016693115234, 0.569006471132477, -116.468330383301, -2.03275583948915, 218, 6, 'PPL', 'P'),
(178945, 'Rancho Del Escondido', 33.8666687011719, 0.591084875517561, -111.292778015137, -1.9424254100553, 218, 5, 'PPL', 'P'),
(184425, 'Rancho del Rey', 32.6408309936523, 0.569689971426246, -117.013893127441, -2.04227770565062, 218, 6, 'PPL', 'P'),
(184426, 'Rancho del Sol', 38.7202796936035, 0.675796367946483, -120.651672363281, -2.10576893077671, 218, 6, 'PPL', 'P'),
(184393, 'Rancho Dos Palmas', 33.4986114501953, 0.584661064652181, -115.830276489258, -2.02161969823293, 218, 6, 'PPL', 'P'),
(178946, 'Rancho Encanto', 33.6361083984375, 0.587060839110451, -112.130561828613, -1.95704749602038, 218, 5, 'PPL', 'P'),
(97352, 'Rancho Escondido Colonia', 26.2059993743896, 0.457380972858674, -98.129997253418, -1.71269154704514, 218, 51, 'PPL', 'P'),
(97353, 'Rancho Grande Colonia', 26.1450004577637, 0.456316340923401, -97.5989990234375, -1.70342387960971, 218, 51, 'PPL', 'P'),
(189314, 'Rancho Grande Estates', 33.6855583190918, 0.587923903040719, -108.861389160156, -1.89998966913959, 218, 38, 'PPL', 'P'),
(97354, 'Rancho Grande Estates Colonia', 26.2859992980957, 0.458777234928688, -98.2949981689453, -1.71557135628989, 218, 51, 'PPL', 'P'),
(178947, 'Rancho Hermoso', 33.457218170166, 0.583938615627469, -112.011108398438, -1.95496264036101, 218, 5, 'PPL', 'P'),
(184429, 'Rancho las Perris', 33.8097190856934, 0.590090917219716, -117.213607788086, -2.04576338404337, 218, 6, 'PPL', 'P'),
(184400, 'Rancho Llano Seco', 39.6083297729492, 0.691295765753662, -121.951942443848, -2.12846292484776, 218, 6, 'PPL', 'P'),
(184401, 'Rancho Loma Rica', 39.3088912963867, 0.68606957843049, -121.353057861328, -2.11801041704336, 218, 6, 'PPL', 'P'),
(184402, 'Rancho Mirage', 33.7397193908691, 0.588869192069642, -116.41194152832, -2.03177166830831, 218, 6, 'PPL', 'P'),
(192098, 'Rancho Miraval Estates Colonia', 31.6159992218018, 0.551803282728406, -106.241996765137, -1.8542726474448, 218, 51, 'PPL', 'P'),
(178948, 'Rancho Mobile Estates', 33.4752807617188, 0.584253867321508, -112.011108398438, -1.95496264036101, 218, 5, 'PPL', 'P'),
(184403, 'Rancho Murieta', 38.5019416809082, 0.671985650742688, -121.093612670898, -2.1134822442419, 218, 6, 'PPL', 'P'),
(97355, 'Rancho Nuevo Colonia', 26.3120002746582, 0.459231037578438, -98.0940017700195, -1.71206330734399, 218, 51, 'PPL', 'P'),
(184404, 'Rancho Palos Verdes', 33.7444381713867, 0.588951550326353, -118.386108398438, -2.06622738017565, 218, 6, 'PPL', 'P'),
(184405, 'Rancho Penasquitos', 32.9594383239746, 0.575250718361358, -117.114440917969, -2.04403259565093, 218, 6, 'PPL', 'P'),
(184406, 'Rancho Poquitos', 37.9836082458496, 0.662939025677743, -120.283332824707, -2.09934019306331, 218, 6, 'PPL', 'P'),
(184408, 'Rancho Rinconada', 37.314998626709, 0.651269586413234, -122.001937866211, -2.12933550957893, 218, 6, 'PPL', 'P'),
(178957, 'Rancho Rio Vista Mobile Home Park', 33.4236106872559, 0.583352054397379, -111.967498779297, -1.95420150892146, 218, 5, 'PPL', 'P'),
(178949, 'Rancho San Carlos', 33.5999984741211, 0.586430602038484, -112.017219543457, -1.95506929996266, 218, 5, 'PPL', 'P'),
(184409, 'Rancho San Diego', 32.7472190856934, 0.571546793917276, -116.934440612793, -2.04089099767101, 218, 6, 'PPL', 'P'),
(184410, 'Rancho San Luis Rey Trailer Park', 33.2322196960449, 0.580011651442093, -117.332496643066, -2.0478383860067, 218, 6, 'PPL', 'P'),
(184411, 'Rancho Santa Clarita', 34.439998626709, 0.601091370418397, -118.531112670898, -2.06875818215955, 218, 6, 'PPL', 'P'),
(178950, 'Rancho Santa Fe', 33.6369400024414, 0.587075353338392, -111.991943359375, -1.95462814732809, 218, 5, 'PPL', 'P'),
(184412, 'Rancho Santa Fe', 33.0202789306641, 0.576312587267, -117.201942443848, -2.04555978537803, 218, 6, 'PPL', 'P'),
(184413, 'Rancho Santa Margarita', 33.6408309936523, 0.587143263946189, -117.60221862793, -2.05254592270758, 218, 6, 'PPL', 'P'),
(184415, 'Rancho Seco', 35.2830581665039, 0.615805535178167, -117.988891601563, -2.05929463922595, 218, 6, 'PPL', 'P'),
(184416, 'Rancho Sonora Estates', 37.9933280944824, 0.663108669039182, -120.402778625488, -2.10142491556462, 218, 6, 'PPL', 'P'),
(178951, 'Rancho Tempe Family and Adult Mobile Home Park', 33.3838882446289, 0.582658766986605, -111.957778930664, -1.95403186556002, 218, 5, 'PPL', 'P'),
(184418, 'Rancho Tierra Grande', 36.5280609130859, 0.637534932302396, -121.802780151367, -2.12585955172415, 218, 6, 'PPL', 'P'),
(184419, 'Rancho Trabuco', 33.6597213745117, 0.587472963289141, -117.613609313965, -2.05274472768296, 218, 6, 'PPL', 'P'),
(189315, 'Rancho Valle', 35.9855613708496, 0.62806652909981, -106.008613586426, -1.85019934255752, 218, 38, 'PPL', 'P'),
(97356, 'Rancho Viejo', 26.0391693115234, 0.454469238970349, -97.5561065673828, -1.70267526502729, 218, 51, 'PPL', 'P'),
(97357, 'Rancho Viejo Number 1 Colonia', 26.4130001068115, 0.460993817193475, -98.9160003662109, -1.7264098892943, 218, 51, 'PPL', 'P'),
(97358, 'Rancho Viejo Number 2 Colonia', 26.4139995574951, 0.461011260898615, -98.9160003662109, -1.7264098892943, 218, 51, 'PPL', 'P'),
(97359, 'Rancho Viejo Number 3 Colonia', 26.4160003662109, 0.461046181598409, -98.9160003662109, -1.7264098892943, 218, 51, 'PPL', 'P'),
(184420, 'Rancho Vista', 34.6211090087891, 0.60425234289524, -118.218063354492, -2.06329444086714, 218, 6, 'PPL', 'P'),
(178952, 'Rancho Vista Estates', 34.5230598449707, 0.602541062157782, -112.508613586426, -1.96364574393716, 218, 5, 'PPL', 'P'),
(184421, 'Rancho Vista Mobile Home Park', 38.3202781677246, 0.668815024306894, -122.488891601563, -2.1378344555657, 218, 6, 'PPL', 'P'),
(189317, 'Ranchos de Taos', 36.3586082458496, 0.634577425332836, -105.60888671875, -1.8432227926079, 218, 38, 'PPL', 'P'),
(184430, 'Ranchos del Oro', 34.4502792358398, 0.601270800896841, -117.162780761719, -2.04487628508426, 218, 6, 'PPL', 'P'),
(189318, 'Ranchos des Placitas', 35.3052787780762, 0.61619335801191, -106.464172363281, -1.85815034315001, 218, 38, 'PPL', 'P'),
(97361, 'Ranchos Penitas West', 27.6738891601563, 0.483000482676695, -99.6105575561523, -1.73853219910217, 218, 51, 'PPL', 'P'),
(97362, 'Ranchos Penitas West Colonia', 27.6749992370605, 0.483019857173625, -99.6029968261719, -1.73840023947016, 218, 51, 'PPL', 'P'),
(192949, 'Ranchvale', 34.4925003051758, 0.602007697570466, -103.318328857422, -1.80324501622028, 218, 38, 'PPL', 'P'),
(146139, 'Rancocas', 40.0105590820313, 0.698315991545165, -74.8672180175781, -1.30667945621516, 218, 37, 'PPL', 'P'),
(71319, 'Rancocas Heights', 39.9822196960449, 0.69782137595171, -74.8480606079102, -1.3063450963403, 218, 37, 'PPL', 'P'),
(71320, 'Rancocas Woods', 39.9888916015625, 0.697937822670374, -74.8605575561523, -1.30656320923358, 218, 37, 'PPL', 'P'),
(97363, 'Rand', 32.538890838623, 0.567910780080991, -96.1761093139648, -1.67858976928667, 218, 51, 'PPL', 'P'),
(111048, 'Rand', 38.2825012207031, 0.668155692200018, -81.5625, -1.42353417115788, 218, 58, 'PPL', 'P'),
(144354, 'Rand', 42.7361106872559, 0.745885840989351, -72.0425033569336, -1.25737888495756, 218, 36, 'PPL', 'P'),
(166294, 'Rand', 40.9313888549805, 0.714387502933521, -77.0966720581055, -1.34559076974425, 218, 45, 'PPL', 'P'),
(184431, 'Rand', 35.4219398498535, 0.61822947782333, -117.691673278809, -2.05410720089664, 218, 6, 'PPL', 'P'),
(194389, 'Rand', 40.4538917541504, 0.706053606355309, -106.18083190918, -1.85320511932184, 218, 7, 'PPL', 'P'),
(201454, 'Rand', 42.5963897705078, 0.743447250958193, -123.584999084473, -2.15696514009823, 218, 43, 'PPL', 'P'),
(111049, 'Rand (historical)', 38.5063896179199, 0.672063281888464, -81.2461090087891, -1.4180121066376, 218, 58, 'PPL', 'P'),
(190648, 'Rand (historical)', 38.7758293151855, 0.676765891741326, -118.673332214355, -2.07124038145356, 218, 39, 'PPL', 'P'),
(128621, 'Rand Landing', 46.5783309936523, 0.812945235922955, -68.6894378662109, -1.19885685210945, 218, 26, 'PPL', 'P'),
(97364, 'Randado', 27.0802803039551, 0.472640053666987, -98.878059387207, -1.72574769428925, 218, 51, 'PPL', 'P'),
(50706, 'Randalia', 39.5194396972656, 0.689744341260636, -75.8722229003906, -1.32422010041886, 218, 25, 'PPL', 'P'),
(117457, 'Randalia', 42.8630599975586, 0.74810152443727, -91.8855590820313, -1.60370554101722, 218, 16, 'PPL', 'P'),
(11462, 'Randall', 34.0233306884766, 0.593819143008745, -92.0411071777344, -1.60642036743245, 218, 4, 'PPL', 'P'),
(24216, 'Randall', 32.0661087036133, 0.559659175180462, -84.7194366455078, -1.47863310989885, 218, 13, 'PPL', 'P'),
(30926, 'Randall', 39.7747192382813, 0.694199809764339, -87.5224990844727, -1.52755577859777, 218, 19, 'PPL', 'P'),
(33719, 'Randall', 39.6425018310547, 0.691892180679785, -98.0444412231445, -1.71119831262193, 218, 20, 'PPL', 'P'),
(111050, 'Randall', 39.6599998474121, 0.69219757867779, -79.9941711425781, -1.39616166884182, 218, 58, 'PPL', 'P'),
(117458, 'Randall', 42.2383308410645, 0.73719794372324, -93.6005630493164, -1.63363800693111, 218, 16, 'PPL', 'P'),
(137625, 'Randall', 46.0911102294922, 0.804441629404278, -94.5033264160156, -1.64939420004641, 218, 28, 'PPL', 'P'),
(151975, 'Randall', 42.9113883972168, 0.748945014133525, -74.4449996948242, -1.29931035632086, 218, 40, 'PPL', 'P'),
(157283, 'Randall', 41.4249992370605, 0.723002629322846, -81.5266723632813, -1.42290886093392, 218, 41, 'PPL', 'P'),
(176008, 'Randall', 45.6958312988281, 0.797542710600428, -92.8349990844727, -1.62027639510997, 218, 57, 'PPL', 'P'),
(184432, 'Randall', 38.3450012207031, 0.669246522982514, -121.534172058105, -2.12117145609923, 218, 6, 'PPL', 'P'),
(187243, 'Randall', 38.0955581665039, 0.664892920390507, -103.579170227051, -1.80779755694572, 218, 7, 'PPL', 'P'),
(42738, 'Randall (historical)', 30.7841701507568, 0.537285126624866, -91.7011108398438, -1.60048631189154, 218, 22, 'PPL', 'P'),
(151976, 'Randall Corner', 43.2122192382813, 0.754195502801644, -73.7986068725586, -1.28802867331106, 218, 40, 'PPL', 'P'),
(151977, 'Randall Crossing', 42.6161117553711, 0.743791464529086, -76.9441680908203, -1.34292907339277, 218, 40, 'PPL', 'P'),
(50707, 'Randall Ridge', 39.374439239502, 0.687213605855761, -76.8008270263672, -1.34042729986475, 218, 25, 'PPL', 'P'),
(74008, 'Randall Terrace', 39.3280601501465, 0.686404138042432, -83.0152816772461, -1.44888999473847, 218, 41, 'PPL', 'P'),
(61476, 'Randalls Bluff (historical)', 33.0638885498047, 0.577073718706545, -88.9055633544922, -1.5516948038763, 218, 30, 'PPL', 'P'),
(50708, 'Randallstown', 39.3672218322754, 0.6870876383362, -76.7955627441406, -1.34033542080715, 218, 25, 'PPL', 'P'),
(151978, 'Randallsville', 42.7949981689453, 0.74691362143304, -75.5672225952148, -1.31889684087395, 218, 40, 'PPL', 'P'),
(151979, 'Randelville', 41.3427810668945, 0.721567651548484, -74.3488922119141, -1.29763296430827, 218, 40, 'PPL', 'P'),
(157284, 'Randle', 40.3133316040039, 0.703600368938155, -81.9333267211914, -1.43000631839704, 218, 41, 'PPL', 'P'),
(208524, 'Randle', 46.5352783203125, 0.81219382502139, -121.955833435059, -2.12853083545556, 218, 56, 'PPL', 'P'),
(50709, 'Randle Cliff Beach', 38.6650009155273, 0.674831571262574, -76.5308303833008, -1.33571496947391, 218, 25, 'PPL', 'P'),
(13194, 'Randle Highlands', 38.8702812194824, 0.678414388456085, -76.966667175293, -1.34332175649551, 218, 9, 'PPL', 'P'),
(68081, 'Randleman', 35.8177795410156, 0.625138183744186, -79.8033294677734, -1.39283085326646, 218, 33, 'PPL', 'P'),
(57093, 'Randles', 37.1377792358398, 0.648176524544189, -89.7675018310547, -1.56673846824194, 218, 29, 'PPL', 'P'),
(77040, 'Randlett', 34.1772193908691, 0.596505007547117, -98.4633331298828, -1.71850935560447, 218, 42, 'PPL', 'P'),
(205475, 'Randlett', 40.232780456543, 0.702194486198702, -109.806938171387, -1.91649261262454, 218, 52, 'PPL', 'P'),
(57094, 'Randol', 36.7869415283203, 0.642053251407824, -90.129997253418, -1.57306520688559, 218, 29, 'PPL', 'P'),
(5293, 'Randolph', 32.8994407653809, 0.574203563420739, -86.9108276367188, -1.51688009789402, 218, 2, 'PPL', 'P'),
(33720, 'Randolph', 39.4305610656738, 0.688193116504692, -96.7597198486328, -1.68877569466595, 218, 20, 'PPL', 'P'),
(37860, 'Randolph', 36.9708290100098, 0.645262693416506, -85.710563659668, -1.49593153960141, 218, 21, 'PPL', 'P'),
(42736, 'Randolph', 32.9863891601563, 0.575721099188894, -92.6902770996094, -1.61775051997408, 218, 22, 'PPL', 'P'),
(57096, 'Randolph', 39.1577796936035, 0.683432183423958, -94.4952774047852, -1.6492537182989, 218, 29, 'PPL', 'P'),
(61477, 'Randolph', 34.1813888549805, 0.596577778423904, -89.168327331543, -1.55628090043147, 218, 30, 'PPL', 'P'),
(90204, 'Randolph', 35.5163917541504, 0.619877974538089, -89.8886108398438, -1.56885221919914, 218, 50, 'PPL', 'P'),
(97365, 'Randolph', 33.4838905334473, 0.584404136186015, -96.2522201538086, -1.6799181540384, 218, 51, 'PPL', 'P'),
(105570, 'Randolph', 36.8933296203613, 0.643910073898855, -78.6977767944336, -1.37353531906245, 218, 53, 'PPL', 'P'),
(117459, 'Randolph', 40.8730583190918, 0.713369443027811, -95.5661087036133, -1.66794325019686, 218, 16, 'PPL', 'P'),
(121159, 'Randolph', 40.3761100769043, 0.704696059989641, -88.9802780151367, -1.55299882070406, 218, 18, 'PPL', 'P'),
(123516, 'Randolph', 40.2661094665527, 0.702776187159803, -84.975830078125, -1.48310801947851, 218, 19, 'PPL', 'P'),
(125918, 'Randolph', 42.1624984741211, 0.735874419240498, -71.0416717529297, -1.23991107820967, 218, 23, 'PPL', 'P'),
(128622, 'Randolph', 44.230281829834, 0.771964047015625, -69.767219543457, -1.21766769099506, 218, 26, 'PPL', 'P'),
(137627, 'Randolph', 44.5261116027832, 0.777127250579016, -93.0197219848633, -1.62350041792562, 218, 28, 'PPL', 'P'),
(142818, 'Randolph', 42.3786087036133, 0.739646254292378, -97.3566665649414, -1.69919438032451, 218, 35, 'PPL', 'P'),
(144355, 'Randolph', 44.3752784729004, 0.774494715841473, -71.2802810668945, -1.24407559636429, 218, 36, 'PPL', 'P'),
(151981, 'Randolph', 42.1619415283203, 0.735864698702519, -78.9755630493164, -1.37838360382694, 218, 40, 'PPL', 'P'),
(157285, 'Randolph', 41.0327796936035, 0.716157106898851, -81.2486114501953, -1.41805578247947, 218, 41, 'PPL', 'P'),
(166295, 'Randolph', 40.1505584716797, 0.700759441845313, -79.0025024414063, -1.3788537849174, 218, 45, 'PPL', 'P'),
(171145, 'Randolph', 45.2427787780762, 0.789635452428846, -98.2094421386719, -1.71407812186669, 218, 49, 'PPL', 'P'),
(172438, 'Randolph', 43.9249992370605, 0.766635860622704, -72.666389465332, -1.26826775170657, 218, 55, 'PPL', 'P'),
(176010, 'Randolph', 43.5391693115234, 0.759901858069357, -89.0066680908203, -1.55345941441459, 218, 57, 'PPL', 'P'),
(178956, 'Randolph', 32.9169387817383, 0.574508961418744, -111.514167785645, -1.94628939048089, 218, 5, 'PPL', 'P'),
(184433, 'Randolph', 39.579719543457, 0.690796423049272, -120.369720458984, -2.10084794171446, 218, 6, 'PPL', 'P'),
(201455, 'Randolph', 43.1680603027344, 0.753424783982175, -124.355278015137, -2.17040904359705, 218, 43, 'PPL', 'P'),
(205476, 'Randolph', 41.665828704834, 0.727205896471318, -111.18138885498, -1.94048130245954, 218, 52, 'PPL', 'P'),
(61478, 'Randolph (historical)', 33.3383293151855, 0.581863613664134, -90.851936340332, -1.58566542095108, 218, 30, 'PPL', 'P'),
(97366, 'Randolph Barnett Number 1 Colonia', 26.2549991607666, 0.458236180463725, -98.3529968261719, -1.71658362382023, 218, 51, 'PPL', 'P'),
(97367, 'Randolph Barnett Number 2 Colonia', 26.2549991607666, 0.458236180463725, -98.3529968261719, -1.71658362382023, 218, 51, 'PPL', 'P'),
(172439, 'Randolph Center', 43.9408302307129, 0.7669121635858, -72.6080627441406, -1.26724975837988, 218, 55, 'PPL', 'P'),
(105571, 'Randolph Corner', 39.0288887023926, 0.681182611251168, -77.8288879394531, -1.35837034770916, 218, 53, 'PPL', 'P'),
(144356, 'Randolph Hill', 44.3880615234375, 0.774717822161795, -71.2788925170898, -1.24405136159837, 218, 36, 'PPL', 'P'),
(50710, 'Randolph Hills', 39.0505599975586, 0.681560846704986, -77.0950012207031, -1.34556160813032, 218, 25, 'PPL', 'P'),
(74009, 'Randolph Landing', 39.1258316040039, 0.682874584070722, -81.7477798461914, -1.4267679145115, 218, 41, 'PPL', 'P'),
(79003, 'Randolph Park', 39.9402809143066, 0.697089406126102, -76.7050018310547, -1.33875483470018, 218, 45, 'PPL', 'P'),
(105572, 'Randolph Ridge', 37.651668548584, 0.657145585042385, -77.477783203125, -1.35224241404089, 218, 53, 'PPL', 'P'),
(57098, 'Randolph Springs', 39.4238891601563, 0.688076669786029, -92.6050033569336, -1.61626221239889, 218, 29, 'PPL', 'P'),
(50711, 'Randolph Village', 38.8894386291504, 0.678748748330944, -76.8630599975586, -1.34151347011534, 218, 25, 'PPL', 'P'),
(146141, 'Randolphville', 40.5394401550293, 0.707546707620462, -74.4522171020508, -1.29943632384042, 218, 37, 'PPL', 'P'),
(50712, 'Random Heights', 39.6072196960449, 0.691276391256732, -76.9416732788086, -1.34288553070895, 218, 25, 'PPL', 'P'),
(105573, 'Random Hills', 38.857780456543, 0.67819620898378, -77.3447189331055, -1.34992000441229, 218, 53, 'PPL', 'P'),
(176013, 'Random Lake', 43.5522193908691, 0.760129624921586, -87.961669921875, -1.53522075568918, 218, 57, 'PPL', 'P'),
(68085, 'Random Woods', 35.8652801513672, 0.625967225791528, -80.2886123657227, -1.40130063763929, 218, 33, 'PPL', 'P'),
(117460, 'Rands', 42.3250007629395, 0.738710619222405, -94.57861328125, -1.65070820372825, 218, 16, 'PPL', 'P'),
(128624, 'Rands', 46.7194404602051, 0.815408060720033, -68.0344390869141, -1.18742496681418, 218, 26, 'PPL', 'P'),
(195511, 'Rands', 43.3444404602051, 0.756503198465225, -114.651672363281, -2.00104917565705, 218, 17, 'PPL', 'P'),
(184434, 'Randsburg', 35.3686103820801, 0.617298703022347, -117.657218933105, -2.0535058591225, 218, 6, 'PPL', 'P'),
(132767, 'Randville', 45.9916687011719, 0.802706047321873, -88.0569381713867, -1.53688350031577, 218, 27, 'PPL', 'P'),
(37861, 'Randy', 37.2936096191406, 0.650896277807432, -84.5036087036133, -1.47486620169499, 218, 21, 'PPL', 'P'),
(97369, 'Randy Ley Colonia', 26.2399997711182, 0.45797439172857, -98.2750015258789, -1.71522234902904, 218, 51, 'PPL', 'P'),
(166297, 'Randy Run', 40.2566719055176, 0.702611470646381, -75.6066665649414, -1.31958526801574, 218, 45, 'PPL', 'P'),
(684, 'Raney', 37.9519386291504, 0.662386286593498, -93.7286071777344, -1.63587279855985, 218, 29, 'PPL', 'P'),
(5297, 'Range', 31.3125, 0.546506222030724, -87.2355575561523, -1.52254770416788, 218, 2, 'PPL', 'P'),
(74011, 'Range', 39.7319412231445, 0.693453192552735, -83.4247207641602, -1.45603605489147, 218, 41, 'PPL', 'P'),
(90205, 'Range', 36.3688888549805, 0.63475685581128, -82.2652816772461, -1.43580002534851, 218, 50, 'PPL', 'P'),
(176015, 'Range', 45.3955612182617, 0.792302009049315, -92.2844390869141, -1.6106673104228, 218, 57, 'PPL', 'P'),
(191012, 'Range', 36.5438919067383, 0.637811235265492, -101.082778930664, -1.76422730940564, 218, 42, 'PPL', 'P'),
(201456, 'Range', 44.8930587768555, 0.783531686947466, -118.967498779297, -2.07637455656107, 218, 43, 'PPL', 'P'),
(105574, 'Range Corner', 38.0719413757324, 0.66448072963279, -77.3127822875977, -1.34936260479613, 218, 53, 'PPL', 'P'),
(123515, 'Range Line', 41.2694396972656, 0.720287603170537, -87.2761077880859, -1.52325543922757, 218, 19, 'PPL', 'P'),
(105575, 'Rangeley', 36.6961097717285, 0.640467938189927, -79.9627838134766, -1.39561385660559, 218, 53, 'PPL', 'P'),
(128625, 'Rangeley', 44.9663887023926, 0.784811535588331, -70.6433334350586, -1.23295876302597, 218, 26, 'PPL', 'P'),
(198780, 'Rangeley', 48.042781829834, 0.838504724747909, -100.490562438965, -1.75389118174088, 218, 34, 'PPL', 'P'),
(176016, 'Rangeline', 44.7436103820801, 0.780923320396815, -89.9638900756836, -1.57016608972293, 218, 57, 'PPL', 'P'),
(194390, 'Rangely', 40.0875015258789, 0.699658890524838, -108.804168701172, -1.89899098373081, 218, 7, 'PPL', 'P'),
(11465, 'Ranger', 35.121940612793, 0.612993503383152, -93.3430633544922, -1.62914378943355, 218, 4, 'PPL', 'P'),
(24218, 'Ranger', 34.5011100769043, 0.602157966434974, -84.709716796875, -1.47846346653741, 218, 13, 'PPL', 'P'),
(30928, 'Ranger', 38.0958290100098, 0.664897647501442, -86.6855621337891, -1.51294847317674, 218, 19, 'PPL', 'P'),
(57100, 'Ranger', 37.5583305358887, 0.655516529403584, -91.7313919067383, -1.60101481620986, 218, 29, 'PPL', 'P'),
(97370, 'Ranger', 32.4697189331055, 0.566703502579831, -98.6786117553711, -1.72226667642841, 218, 51, 'PPL', 'P'),
(111052, 'Ranger', 38.1205596923828, 0.665329279335117, -82.1855621337891, -1.434408656837, 218, 58, 'PPL', 'P'),
(37862, 'Rangers Landing', 37.6674995422363, 0.657421888005481, -87.4580612182617, -1.52643112566943, 218, 21, 'PPL', 'P'),
(50713, 'Rangers Woods', 39.2877807617188, 0.685701130093678, -77.3180618286133, -1.34945475016985, 218, 25, 'PPL', 'P'),
(97371, 'Rangerville', 26.0894393920898, 0.455346617391476, -97.7483291625977, -1.70603018221052, 218, 51, 'PPL', 'P'),
(97372, 'Rangerville Colonia', 26.0909996032715, 0.455373848213622, -97.7509994506836, -1.7060767875296, 218, 51, 'PPL', 'P'),
(97373, 'Rangerville Estates Colonia', 26.0900001525879, 0.455356404508482, -97.7470016479492, -1.70600701270904, 218, 51, 'PPL', 'P'),
(166298, 'Ranges Corners', 41.9183311462402, 0.731612895443181, -79.7436065673828, -1.3917884920158, 218, 45, 'PPL', 'P'),
(68088, 'Rangewood', 35.7063903808594, 0.623194076148428, -78.6463928222656, -1.37263849956537, 218, 33, 'PPL', 'P'),
(137630, 'Ranier', 48.6130599975586, 0.848457956426944, -93.3486099243164, -1.62924059533918, 218, 28, 'PPL', 'P'),
(57101, 'Ranken', 38.5347213745117, 0.672557764323864, -90.5119400024414, -1.57973136541017, 218, 29, 'PPL', 'P'),
(37864, 'Rankin', 37.7825012207031, 0.659429045940046, -87.5772171020508, -1.52851078816467, 218, 21, 'PPL', 'P'),
(61479, 'Rankin', 32.2863883972168, 0.563503781109128, -89.9069366455078, -1.56917206484606, 218, 30, 'PPL', 'P'),
(68090, 'Rankin', 36.1169395446777, 0.630359510798368, -79.7638931274414, -1.39214255928273, 218, 33, 'PPL', 'P'),
(77042, 'Rankin', 35.624439239502, 0.621763758905974, -99.9241714477539, -1.74400579409061, 218, 42, 'PPL', 'P'),
(90207, 'Rankin', 36.0522193908691, 0.629229931022011, -83.2152786254883, -1.45238059997923, 218, 50, 'PPL', 'P'),
(121161, 'Rankin', 40.4650001525879, 0.706247484482667, -87.8963928222656, -1.53408145537485, 218, 18, 'PPL', 'P'),
(132768, 'Rankin', 42.9144401550293, 0.748998277355327, -83.7505569458008, -1.46172296908323, 218, 27, 'PPL', 'P'),
(139419, 'Rankin', 40.0672187805176, 0.699304889836939, -94.9175033569336, -1.65662295135126, 218, 29, 'PPL', 'P'),
(166299, 'Rankin', 40.4124984741211, 0.705331157330597, -79.8794403076172, -1.39415923801819, 218, 45, 'PPL', 'P'),
(176017, 'Rankin', 44.5961112976074, 0.77834897572909, -87.5033264160156, -1.5272211524068, 218, 57, 'PPL', 'P'),
(178959, 'Rankin', 32.1427803039551, 0.5609973470492, -110.837501525879, -1.93447933631083, 218, 5, 'PPL', 'P'),
(192100, 'Rankin', 31.2224998474121, 0.544935423040768, -101.9375, -1.77914500625172, 218, 51, 'PPL', 'P'),
(11467, 'Rankin (historical)', 33.7125015258789, 0.588394150710199, -94.147216796875, -1.64317891469438, 218, 4, 'PPL', 'P'),
(184435, 'Rankin (historical)', 38.9305610656738, 0.679466470244721, -123.117782592773, -2.14881067399846, 218, 6, 'PPL', 'P'),
(97374, 'Rankin Colonia', 26.2940006256104, 0.458916884438349, -98.0490036010742, -1.71127794113852, 218, 51, 'PPL', 'P'),
(90208, 'Rankin Cove', 35.038330078125, 0.611534224263843, -85.579719543457, -1.49364787896666, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(195512, 'Rankin Mill', 45.2663917541504, 0.790047576607536, -116.544723510742, -2.0340891510889, 218, 17, 'PPL', 'P'),
(197336, 'Rankin Place', 45.2616691589355, 0.789965151771798, -109.491668701172, -1.91099012233827, 218, 31, 'PPL', 'P'),
(166301, 'Rankins Corners', 40.1691703796387, 0.701084280919275, -79.8133316040039, -1.39300542347592, 218, 45, 'PPL', 'P'),
(128628, 'Rankins Mill', 43.8791694641113, 0.765835980189299, -70.772216796875, -1.2352082020407, 218, 26, 'PPL', 'P'),
(68091, 'Ranlo', 35.2861099243164, 0.615858798399968, -81.1305618286133, -1.41599542790213, 218, 33, 'PPL', 'P'),
(184436, 'Rannells (historical)', 33.4891700744629, 0.584496281559732, -114.708061218262, -2.00203334683789, 218, 6, 'PPL', 'P'),
(166302, 'Ranshaw', 40.785831451416, 0.711847046990667, -76.5183334350586, -1.33549685658064, 218, 45, 'PPL', 'P'),
(33721, 'Ransom', 38.6361083984375, 0.674327301710168, -99.9333267211914, -1.74416558375602, 218, 20, 'PPL', 'P'),
(37865, 'Ransom', 37.5663909912109, 0.655657210888167, -82.1883316040039, -1.43445699321078, 218, 21, 'PPL', 'P'),
(74013, 'Ransom', 39.7441711425781, 0.693666644914105, -84.5808334350586, -1.47621402752268, 218, 41, 'PPL', 'P'),
(121162, 'Ransom', 41.1561088562012, 0.718309606849908, -88.6494369506836, -1.54722455482855, 218, 18, 'PPL', 'P'),
(132769, 'Ransom', 41.7752799987793, 0.729116181921232, -84.5341720581055, -1.47539963286133, 218, 27, 'PPL', 'P'),
(137632, 'Ransom', 43.5438919067383, 0.759984282905095, -95.7938919067383, -1.67191881707213, 218, 28, 'PPL', 'P'),
(166303, 'Ransom', 41.3941688537598, 0.722464537624595, -75.8222198486328, -1.32334738252964, 218, 45, 'PPL', 'P'),
(192101, 'Ransom Canyon', 33.5333290100098, 0.585267000379201, -101.679168701172, -1.77463627452622, 218, 51, 'PPL', 'P'),
(140753, 'Ransom City (historical)', 46.0952796936035, 0.804514400281064, -97.3850021362305, -1.69968892933893, 218, 34, 'PPL', 'P'),
(90210, 'Ransom Stand', 35.0311088562012, 0.611408190165255, -87.961669921875, -1.53522075568918, 218, 50, 'PPL', 'P'),
(137633, 'Ransom Trailer Court', 43.5052795410156, 0.75931036999125, -92.9438934326172, -1.6221769600219, 218, 28, 'PPL', 'P'),
(172441, 'Ransomvale', 43.6575012207031, 0.761967139494713, -73.1319427490234, -1.27639318935045, 218, 55, 'PPL', 'P'),
(33722, 'Ransomville', 38.5063896179199, 0.672063281888464, -95.4255599975586, -1.66549021251679, 218, 20, 'PPL', 'P'),
(68093, 'Ransomville', 35.452220916748, 0.618757982141656, -76.6855621337891, -1.33841554797731, 218, 33, 'PPL', 'P'),
(151982, 'Ransomville', 43.2386093139648, 0.754656096512173, -78.9100036621094, -1.37723937666459, 218, 40, 'PPL', 'P'),
(111054, 'Ranson', 39.2949981689453, 0.685827097613239, -77.8608322143555, -1.35892788048337, 218, 58, 'PPL', 'P'),
(105576, 'Ransons', 37.6366691589355, 0.65688379630723, -78.5116729736328, -1.37028719463894, 218, 53, 'PPL', 'P'),
(33723, 'Rantoul', 38.5486106872559, 0.672800178562089, -95.0999984741211, -1.659808092015, 218, 20, 'PPL', 'P'),
(121163, 'Rantoul', 40.3083305358887, 0.703513083833428, -88.1558303833008, -1.53860949501825, 218, 18, 'PPL', 'P'),
(83206, 'Rantowles', 32.7827796936035, 0.572167443609319, -80.1488876342773, -1.39886198102911, 218, 48, 'PPL', 'P'),
(176019, 'Rantz', 45.8316688537598, 0.799913523181843, -89.7294387817383, -1.56607414270802, 218, 57, 'PPL', 'P'),
(137635, 'Ranum', 47.4555587768555, 0.828255749029821, -96.1313934326172, -1.67780932992922, 218, 28, 'PPL', 'P'),
(24219, 'Raoul', 34.4494400024414, 0.601256153510846, -83.5944366455078, -1.45899815581392, 218, 13, 'PPL', 'P'),
(121165, 'Rapatee', 40.7150001525879, 0.710610807612652, -90.1580581665039, -1.57355496221006, 218, 18, 'PPL', 'P'),
(197337, 'Rapelje', 45.9719390869141, 0.802361700592926, -109.254440307617, -1.90684970579153, 218, 31, 'PPL', 'P'),
(184437, 'Rapetti (historical)', 36.9550018310547, 0.644986457032438, -122.056106567383, -2.1302809317659, 218, 6, 'PPL', 'P'),
(105577, 'Raphine', 37.9372215270996, 0.662129424706359, -79.2330627441406, -1.38287782132451, 218, 53, 'PPL', 'P'),
(132771, 'Rapid City', 44.8344383239746, 0.782508567035685, -85.2825012207031, -1.48846044063735, 218, 27, 'PPL', 'P'),
(202535, 'Rapid City', 44.0805587768555, 0.769350886775012, -103.230560302734, -1.80171316596127, 218, 49, 'PPL', 'P'),
(132772, 'Rapid River', 45.9269409179688, 0.801576334387462, -86.9669418334961, -1.5178594753849, 218, 27, 'PPL', 'P'),
(202538, 'Rapid Valley', 44.0625, 0.769035701660001, -103.14582824707, -1.80023431260795, 218, 49, 'PPL', 'P'),
(42739, 'Rapidan', 30.0705604553223, 0.524830287865379, -90.8908309936523, -1.58634426071294, 218, 22, 'PPL', 'P'),
(105578, 'Rapidan', 38.3125, 0.668679269670328, -78.0661087036133, -1.36251063109785, 218, 53, 'PPL', 'P'),
(137636, 'Rapidan', 44.0944404602051, 0.769593167855182, -94.0683288574219, -1.64180206041081, 218, 28, 'PPL', 'P'),
(105580, 'Rapidan Woods', 37.6902809143066, 0.65781949795623, -77.4333267211914, -1.3514665020573, 218, 53, 'PPL', 'P'),
(42740, 'Rapides', 31.3633308410645, 0.547393387568857, -92.586669921875, -1.61594223359392, 218, 22, 'PPL', 'P'),
(151983, 'Rapids', 43.098331451416, 0.752207785943036, -78.64111328125, -1.37254635419165, 218, 40, 'PPL', 'P'),
(121166, 'Rapids City', 41.5816688537598, 0.725737029972084, -90.3433303833008, -1.57678857240563, 218, 18, 'PPL', 'P'),
(111053, 'Rapp', 37.8097190856934, 0.659904087299489, -82.2694396972656, -1.43587259648821, 218, 58, 'PPL', 'P'),
(105582, 'Rapppahannock Corner', 38.1749992370605, 0.66627942863303, -77.267219543457, -1.34856738489464, 218, 53, 'PPL', 'P'),
(166306, 'Rapps Corner', 40.0819396972656, 0.699561818303104, -75.6069412231445, -1.3195900617057, 218, 45, 'PPL', 'P'),
(105583, 'Rapps Mill', 37.670280456543, 0.657470424116347, -79.6341705322266, -1.389878472882, 218, 53, 'PPL', 'P'),
(74014, 'Rappsburg', 38.6163902282715, 0.673983154718302, -82.4055633544922, -1.43824840249667, 218, 41, 'PPL', 'P'),
(132774, 'Rapson', 43.8561096191406, 0.76543350996956, -82.8824996948242, -1.44657251195788, 218, 27, 'PPL', 'P'),
(30929, 'Rapture', 38.1522216796875, 0.665881885261308, -87.8419418334961, -1.53313110633985, 218, 19, 'PPL', 'P'),
(151984, 'Raquette Lake', 43.813060760498, 0.764682165647022, -74.6577835083008, -1.30302413446097, 218, 40, 'PPL', 'P'),
(151985, 'Raquette River', 44.9511108398438, 0.784544886584187, -74.7941665649414, -1.30540446784328, 218, 40, 'PPL', 'P'),
(74015, 'Rarden', 38.9222183227539, 0.679320861912121, -83.2425003051758, -1.4528557079177, 218, 41, 'PPL', 'P'),
(470, 'Rardin', 39.6041717529297, 0.691223194613957, -88.1016693115234, -1.53766420598933, 218, 18, 'PPL', 'P'),
(178958, 'Rare Metals', 36.1494407653809, 0.630926764110555, -111.135559082031, -1.93968142202613, 218, 5, 'PPL', 'P'),
(166310, 'Raricks', 40.9008293151855, 0.713854138346205, -76.2341690063477, -1.33053725168258, 218, 45, 'PPL', 'P'),
(121167, 'Raritan', 40.6958312988281, 0.710276248000711, -90.8272171020508, -1.58523398885449, 218, 18, 'PPL', 'P'),
(146142, 'Raritan', 40.5694389343262, 0.708070285090771, -74.6333312988281, -1.30259736289629, 218, 37, 'PPL', 'P'),
(146143, 'Raritan Gardens', 40.4863891601563, 0.706620793088468, -74.4191665649414, -1.29885948314831, 218, 37, 'PPL', 'P'),
(146144, 'Raritan Manor', 40.5363883972168, 0.70749344439866, -74.3369369506836, -1.29742430563686, 218, 37, 'PPL', 'P'),
(50714, 'Rarjem Acres', 39.7136116027832, 0.693133280326789, -76.9080581665039, -1.34229883632081, 218, 25, 'PPL', 'P'),
(61481, 'Ras', 32.0494384765625, 0.559368224831371, -89.1352767944336, -1.55570405973936, 218, 30, 'PPL', 'P'),
(105584, 'Rasawek (historical)', 37.7508316040039, 0.6588763068558, -78.1699981689453, -1.36432384432603, 218, 53, 'PPL', 'P'),
(151986, 'Rasbach Corner', 43.1061096191406, 0.752343540579603, -74.7422180175781, -1.30449779465017, 218, 40, 'PPL', 'P'),
(90209, 'Rascal Town', 35.0072212219238, 0.610991272296603, -87.4422225952148, -1.52615468954828, 218, 50, 'PPL', 'P'),
(5296, 'Rash', 34.8738899230957, 0.608664202136092, -85.8949966430664, -1.49915050241099, 218, 2, 'PPL', 'P'),
(166307, 'Rasler Run', 40.0074996948242, 0.698262595165309, -79.477783203125, -1.38714899908078, 218, 45, 'PPL', 'P'),
(166308, 'Rasleytown', 40.8147201538086, 0.712351249964046, -75.2663879394531, -1.31364628562681, 218, 45, 'PPL', 'P'),
(132775, 'Rasmus', 44.6300010681152, 0.778940463807197, -84.7750015258789, -1.4796029000098, 218, 27, 'PPL', 'P'),
(105585, 'Rasnake', 37.0402793884277, 0.646474831186656, -82.1097183227539, -1.43308493261717, 218, 53, 'PPL', 'P'),
(178960, 'Raso', 32.3394393920898, 0.564429695641121, -109.752502441406, -1.91554252990565, 218, 5, 'PPL', 'P'),
(11469, 'Raspberry', 35.6863899230957, 0.622845002308546, -92.9347229003906, -1.62201690404039, 218, 4, 'PPL', 'P'),
(200153, 'Raspberry Creek (historical)', 40.790828704834, 0.711934265516367, -118.019996643066, -2.05983752461416, 218, 39, 'PPL', 'P'),
(137638, 'Rassat', 45.1522216796875, 0.788054932900911, -93.9916687011719, -1.64046408827915, 218, 28, 'PPL', 'P'),
(166309, 'Rasselas', 41.6072196960449, 0.726182976296618, -78.6194381713867, -1.37216805215881, 218, 45, 'PPL', 'P'),
(189319, 'Rastus Place', 33.0125007629395, 0.576176832630434, -108.422782897949, -1.89233454574421, 218, 38, 'PPL', 'P'),
(57103, 'Rat', 37.372501373291, 0.652273198670031, -91.2275009155273, -1.59222025934209, 218, 29, 'PPL', 'P'),
(97375, 'Ratamosa', 26.2033290863037, 0.457334367539597, -97.8452835083008, -1.70772235476716, 218, 51, 'PPL', 'P'),
(97376, 'Ratamosa Colonia', 26.2099990844727, 0.457450780968747, -97.8479995727539, -1.70776975903456, 218, 51, 'PPL', 'P'),
(74017, 'Ratchford', 39.1208305358887, 0.682787298965995, -82.5058288574219, -1.43999836564896, 218, 41, 'PPL', 'P'),
(11471, 'Ratcliff', 35.3083305358887, 0.616246621233711, -93.8833312988281, -1.6385732439052, 218, 4, 'PPL', 'P'),
(97378, 'Ratcliff', 26.2819404602051, 0.458706394843692, -98.6263885498047, -1.72135520954533, 218, 51, 'PPL', 'P'),
(24220, 'Ratcliff (historical)', 34.7400016784668, 0.606327411437602, -84.5625, -1.47589404871771, 218, 13, 'PPL', 'P'),
(57102, 'Ratcliff Ford', 37.0561103820801, 0.646751134149751, -91.6841735839844, -1.60019070101054, 218, 29, 'PPL', 'P'),
(74018, 'Ratcliffburg', 39.2627792358398, 0.685264771149068, -82.6813888549805, -1.44306246564115, 218, 41, 'PPL', 'P'),
(132776, 'Rathbone', 43.3358306884766, 0.756352929600717, -84.4297180175781, -1.47357656593712, 218, 27, 'PPL', 'P'),
(151987, 'Rathbone', 42.1338882446289, 0.735375076536108, -77.3213882446289, -1.34951280708161, 218, 40, 'PPL', 'P'),
(157288, 'Rathbone', 40.1963882446289, 0.701559322278718, -83.1452789306641, -1.45115887482916, 218, 41, 'PPL', 'P'),
(117461, 'Rathbun', 40.8011093139648, 0.712113695994811, -92.8886108398438, -1.62121209675897, 218, 16, 'PPL', 'P'),
(166313, 'Rathbun', 41.4850006103516, 0.724049850842492, -78.438606262207, -1.36901193995096, 218, 45, 'PPL', 'P'),
(193153, 'Rathdrum', 47.8125, 0.834485548609789, -116.895561218262, -2.04021242422526, 218, 17, 'PPL', 'P'),
(90211, 'Rather', 35.0627784729004, 0.611960929249501, -89.3030624389648, -1.55863247167401, 218, 50, 'PPL', 'P'),
(166311, 'Rathmel', 41.0944404602051, 0.717233290295352, -78.8399963378906, -1.37601751835646, 218, 45, 'PPL', 'P'),
(97379, 'Ratibor', 31.0872192382813, 0.542574330997331, -97.2122192382813, -1.69667329887858, 218, 51, 'PPL', 'P'),
(11470, 'Ratio', 34.2611083984375, 0.597969146935416, -90.9319381713867, -1.58706171631061, 218, 4, 'PPL', 'P'),
(97380, 'Ratler', 31.3811092376709, 0.547703679125365, -98.7688903808594, -1.72384233568735, 218, 51, 'PPL', 'P'),
(17761, 'Ratliff', 30.5074996948242, 0.532456316225848, -81.8002777099609, -1.42768417508455, 218, 12, 'PPL', 'P'),
(37867, 'Ratliff', 37.3413887023926, 0.651730180123763, -82.4266662597656, -1.43861671767543, 218, 21, 'PPL', 'P'),
(42742, 'Ratliff', 29.9441699981689, 0.522624358244952, -91.0236129760742, -1.58866174349353, 218, 22, 'PPL', 'P'),
(61483, 'Ratliff', 32.5708312988281, 0.568468246276172, -89.7983322143555, -1.56727655994019, 218, 30, 'PPL', 'P'),
(77046, 'Ratliff City', 34.4488906860352, 0.601246566130922, -97.5091705322266, -1.70185607667599, 218, 42, 'PPL', 'P'),
(61484, 'Ratliff Landing', 32.9324989318848, 0.574780537270905, -90.7624969482422, -1.58410440907813, 218, 30, 'PPL', 'P'),
(117462, 'Ratna (historical)', 43.3277816772461, 0.756212447853215, -93.5555572509766, -1.6328525075676, 218, 16, 'PPL', 'P'),
(189320, 'Raton', 36.9033317565918, 0.644084644108309, -104.438606262207, -1.82279754546948, 218, 38, 'PPL', 'P'),
(157289, 'Ratsville', 41.4716682434082, 0.723817157142246, -84.0763931274414, -1.46740988327498, 218, 41, 'PPL', 'P'),
(42743, 'Rattan', 31.3472194671631, 0.547112191047258, -93.5277786254883, -1.63236767909115, 218, 22, 'PPL', 'P'),
(77045, 'Rattan', 34.2002792358398, 0.596907477766856, -95.4127807617188, -1.6652671727755, 218, 42, 'PPL', 'P'),
(97381, 'Rattan', 33.4152793884277, 0.583206645801861, -95.7816696166992, -1.67170549786882, 218, 51, 'PPL', 'P'),
(166312, 'Rattigan', 40.9008293151855, 0.713854138346205, -79.7074966430664, -1.39115825494384, 218, 45, 'PPL', 'P'),
(50715, 'Rattle Ridge', 39.336109161377, 0.686544619789933, -77.2113876342773, -1.34759293425178, 218, 25, 'PPL', 'P'),
(132777, 'Rattle Run', 42.8663902282715, 0.748159647928061, -82.5997161865234, -1.44163700866769, 218, 27, 'PPL', 'P'),
(17762, 'Rattlesnake', 27.8891696929932, 0.486757836790147, -82.5244369506836, -1.4403231381439, 218, 12, 'PPL', 'P'),
(189321, 'Rattlesnake', 36.7552795410156, 0.641500645481633, -108.801391601563, -1.89894251419897, 218, 38, 'PPL', 'P'),
(197338, 'Rattlesnake', 48.0980606079102, 0.839469521431818, -109.048057556152, -1.90324764725914, 218, 31, 'PPL', 'P'),
(97382, 'Rattlesnake Bead', 30.2463893890381, 0.527899081678991, -94.5472183227539, -1.65016025833397, 218, 51, 'PPL', 'P'),
(17763, 'Rattlesnake Bend', 30.0936107635498, 0.525232591637549, -81.8302764892578, -1.42820775255486, 218, 12, 'PPL', 'P'),
(68094, 'Rattlesnake Lodge', 35.6683311462402, 0.622529817193535, -82.4558334350586, -1.4391257809178, 218, 33, 'PPL', 'P'),
(184438, 'Ratto Landing', 38.2319412231445, 0.66727325377282, -122.288330078125, -2.1343339966289, 218, 6, 'PPL', 'P'),
(97383, 'Rau-con Drive-In Number 2 Colonia', 26.4069995880127, 0.460889088383608, -98.9749984741211, -1.72743960052978, 218, 51, 'PPL', 'P'),
(123517, 'Raub', 40.7299995422363, 0.710872596347807, -87.4916687011719, -1.52701768689952, 218, 19, 'PPL', 'P'),
(198782, 'Raub', 47.7463912963867, 0.833331734067512, -102.042778015137, -1.78098245424582, 218, 34, 'PPL', 'P'),
(79005, 'Raubenstine', 39.7341690063477, 0.69349207470465, -76.9963912963867, -1.34384054027585, 218, 45, 'PPL', 'P'),
(166315, 'Raubs Mills', 40.7244415283203, 0.710775590705101, -77.267219543457, -1.34856738489464, 218, 45, 'PPL', 'P'),
(166316, 'Raubsville', 40.6355590820313, 0.70922429937013, -75.1933288574219, -1.31237116409688, 218, 45, 'PPL', 'P'),
(137639, 'Rauch', 47.9588890075684, 0.837040518780584, -93.1455612182617, -1.62569672687661, 218, 28, 'PPL', 'P'),
(166317, 'Rauchtown', 41.1227798461914, 0.717727905888807, -77.2363891601563, -1.34802929319638, 218, 45, 'PPL', 'P'),
(90213, 'Raulstontown', 35.0202789306641, 0.611219172306887, -85.7061080932617, -1.49585377529758, 218, 50, 'PPL', 'P'),
(28372, 'Raum', 37.4627799987793, 0.653848857928976, -88.5208282470703, -1.54497990950378, 218, 18, 'PPL', 'P'),
(11472, 'Raum (historical)', 36.458610534668, 0.636322794532246, -93.3461074829102, -1.6291969194973, 218, 4, 'PPL', 'P'),
(90212, 'Raus', 35.3955612182617, 0.617769083849882, -86.3291702270508, -1.5067282609767, 218, 50, 'PPL', 'P'),
(166318, 'Rausch Creek', 40.6119384765625, 0.708812042033386, -76.4266662597656, -1.33389696255577, 218, 45, 'PPL', 'P'),
(166319, 'Rauschs', 40.6644401550293, 0.709728369185455, -75.9927825927734, -1.32632426399613, 218, 45, 'PPL', 'P'),
(171148, 'Rauville', 44.9797210693359, 0.785044229288577, -97.1055603027344, -1.69481174927662, 218, 49, 'PPL', 'P'),
(197339, 'Ravalli', 47.2772216796875, 0.825143179505791, -114.179718017578, -1.99281201840543, 218, 31, 'PPL', 'P'),
(11473, 'Ravanna', 33.0652809143066, 0.577098020051492, -94.0408325195313, -1.64132215878238, 218, 4, 'PPL', 'P'),
(139415, 'Ravanna', 40.4550018310547, 0.706072980852239, -93.4652786254883, -1.63127684830865, 218, 29, 'PPL', 'P'),
(187857, 'Ravanna', 38.1597213745117, 0.666012779628886, -100.381942749023, -1.75199541051891, 218, 20, 'PPL', 'P'),
(28373, 'Raven', 39.8038902282715, 0.694708939585735, -87.5461120605469, -1.52796790277646, 218, 18, 'PPL', 'P'),
(37868, 'Raven', 37.4027786254883, 0.65280163640933, -82.8063888549805, -1.44524412720615, 218, 21, 'PPL', 'P'),
(105586, 'Raven', 37.0869407653809, 0.647289225848002, -81.8552780151367, -1.42864411149946, 218, 53, 'PPL', 'P'),
(142820, 'Raven', 42.2755584716797, 0.737847688450193, -99.8655624389648, -1.74298287391592, 218, 35, 'PPL', 'P'),
(90214, 'Raven Branch', 35.851390838623, 0.625724811553303, -83.100830078125, -1.45038309600362, 218, 50, 'PPL', 'P'),
(90215, 'Raven Hill', 36.3972206115723, 0.63525133824668, -83.4725036621094, -1.45687002378683, 218, 50, 'PPL', 'P'),
(166320, 'Raven Hill', 40.1824989318848, 0.701316908040494, -76.9311065673828, -1.34270110680346, 218, 45, 'PPL', 'P'),
(111055, 'Raven Rock', 39.4394416809082, 0.688348112480135, -81.1508331298828, -1.41634922885295, 218, 58, 'PPL', 'P'),
(146147, 'Raven Rock', 40.410831451416, 0.705302062295688, -75.0336074829102, -1.30958350022584, 218, 37, 'PPL', 'P'),
(111056, 'Raven Rocks', 39.4444389343262, 0.688435331005835, -78.6800003051758, -1.37322506079546, 218, 58, 'PPL', 'P'),
(50717, 'Raven Run', 39.5750007629395, 0.690714064792561, -76.913330078125, -1.34239084853647, 218, 25, 'PPL', 'P'),
(105598, 'Raven Run', 37.6333312988281, 0.656825539658385, -77.3177795410156, -1.34944982332183, 218, 53, 'PPL', 'P'),
(166321, 'Raven Run', 40.8161087036133, 0.712375484729966, -76.2538909912109, -1.33088146525347, 218, 45, 'PPL', 'P'),
(151989, 'Ravena', 42.4683303833008, 0.741212193013344, -73.8166732788086, -1.28834399158413, 218, 40, 'PPL', 'P'),
(42744, 'Ravencamp', 31.4722194671631, 0.549293852612251, -92.6791687011719, -1.61755664184673, 218, 22, 'PPL', 'P'),
(111057, 'Ravencliff', 37.6980590820313, 0.657955252592796, -81.4813919067383, -1.42211856788044, 218, 58, 'PPL', 'P'),
(193897, 'Ravendale', 40.7986106872559, 0.712070086731961, -120.364166259766, -2.10075100265078, 218, 6, 'PPL', 'P'),
(11474, 'Ravenden', 36.2333297729492, 0.632390903498853, -91.2516708374023, -1.59264210405876, 218, 4, 'PPL', 'P'),
(11475, 'Ravenden Springs', 36.3163909912109, 0.633840595238238, -91.2225036621094, -1.59213304081639, 218, 4, 'PPL', 'P'),
(83207, 'Ravenel', 32.7630615234375, 0.571823296617454, -80.2502822875977, -1.40063165157347, 218, 48, 'PPL', 'P'),
(24221, 'Ravenel (historical)', 34.0569381713867, 0.594405704238835, -85.0699996948242, -1.48475158934525, 218, 13, 'PPL', 'P'),
(50716, 'Ravenhurst', 39.478328704834, 0.689026819083942, -76.5330581665039, -1.33575385162583, 218, 25, 'PPL', 'P'),
(37869, 'Ravenna', 37.684440612793, 0.657717565465507, -83.9530563354492, -1.46525725016587, 218, 21, 'PPL', 'P'),
(97384, 'Ravenna', 33.672779083252, 0.587700863299424, -96.2413864135742, -1.67972906960101, 218, 51, 'PPL', 'P'),
(132778, 'Ravenna', 43.1894416809082, 0.753797959429922, -85.9369430541992, -1.49988260539465, 218, 27, 'PPL', 'P'),
(142821, 'Ravenna', 41.0261116027832, 0.716040726759215, -98.9122161865234, -1.72634384289926, 218, 35, 'PPL', 'P'),
(157290, 'Ravenna', 41.1575012207031, 0.718333908194855, -81.2422180175781, -1.4179441960298, 218, 41, 'PPL', 'P'),
(184439, 'Ravenna', 34.4386100769043, 0.601067135652478, -118.22444152832, -2.06340576100071, 218, 6, 'PPL', 'P'),
(197341, 'Ravenna', 46.7144393920898, 0.815320775615306, -113.530563354492, -1.98148213217991, 218, 31, 'PPL', 'P'),
(208525, 'Ravenna', 47.6758308410645, 0.832100221800432, -122.29638671875, -2.13447461153445, 218, 56, 'PPL', 'P'),
(17764, 'Ravenna Park', 28.7902793884277, 0.502485167897123, -81.3083267211914, -1.41909801057208, 218, 12, 'PPL', 'P'),
(105587, 'Ravens Nest', 36.7244415283203, 0.640962420625328, -82.2491683959961, -1.4355187955374, 218, 53, 'PPL', 'P'),
(90216, 'Ravenscroft', 35.9772186279297, 0.62792092076721, -85.295280456543, -1.48868348037865, 218, 50, 'PPL', 'P'),
(208526, 'Ravensdale', 47.3525009155273, 0.826457050029581, -121.982498168945, -2.12899622285605, 218, 56, 'PPL', 'P'),
(111058, 'Ravenseye', 38.0038909912109, 0.663293026365642, -80.896110534668, -1.41190348088723, 218, 58, 'PPL', 'P'),
(68095, 'Ravensford', 35.5108299255371, 0.619780902316355, -83.2955627441406, -1.45378182218678, 218, 33, 'PPL', 'P'),
(50719, 'Ravenshead', 38.5808296203613, 0.673362505026259, -76.6138916015625, -1.3371646612133, 218, 25, 'PPL', 'P'),
(30930, 'Ravenswood', 39.8880615234375, 0.69617800582205, -86.1311111450195, -1.50327147788177, 218, 19, 'PPL', 'P'),
(42745, 'Ravenswood', 30.6719398498535, 0.535326338353599, -91.6894378662109, -1.60028258006814, 218, 22, 'PPL', 'P'),
(68096, 'Ravenswood', 34.978889465332, 0.610496789861203, -77.2344436645508, -1.34799533789249, 218, 33, 'PPL', 'P'),
(111059, 'Ravenswood', 38.9480590820313, 0.679771868242726, -81.7611083984375, -1.42700054163272, 218, 58, 'PPL', 'P'),
(184440, 'Ravenswood', 37.476390838623, 0.654086411898211, -122.134170532227, -2.13164340497959, 218, 6, 'PPL', 'P'),
(190649, 'Ravenswood (historical)', 39.7811088562012, 0.694311329634986, -117.262222290039, -2.04661186716667, 218, 39, 'PPL', 'P'),
(105588, 'Ravensworth', 38.8038902282715, 0.677255647065791, -77.220832824707, -1.34775778392325, 218, 53, 'PPL', 'P'),
(105589, 'Ravensworth Grove', 38.8177795410156, 0.677498061304016, -77.2147216796875, -1.34765112432159, 218, 53, 'PPL', 'P'),
(105590, 'Ravensworth Park', 38.8133316040039, 0.67742043015824, -77.2141723632813, -1.34764153694167, 218, 53, 'PPL', 'P'),
(68099, 'Ravenwood', 35.9055595397949, 0.626670233740281, -79.9613876342773, -1.39558948868162, 218, 33, 'PPL', 'P'),
(83209, 'Ravenwood', 34.9099998474121, 0.609294439208059, -80.9333267211914, -1.4125530258771, 218, 48, 'PPL', 'P'),
(105592, 'Ravenwood', 38.7213897705078, 0.675815742443413, -77.3930587768555, -1.35076369384562, 218, 53, 'PPL', 'P'),
(139417, 'Ravenwood', 40.3522186279297, 0.704279075541962, -94.6736068725586, -1.65236615466488, 218, 29, 'PPL', 'P'),
(42746, 'Ravenwood (historical)', 29.6611099243164, 0.517684027975287, -90.5272216796875, -1.57999808099334, 218, 22, 'PPL', 'P'),
(50720, 'Ravenwood Estates', 39.4019393920898, 0.687693574063221, -77.1919403076172, -1.34725351437084, 218, 25, 'PPL', 'P'),
(105593, 'Ravenwood Estates', 39.3019409179688, 0.685948271442837, -78.1394424438477, -1.36379054631775, 218, 53, 'PPL', 'P'),
(24222, 'Ravenwood Park', 33.7333297729492, 0.588757672198995, -82.7177810668945, -1.44369762956114, 218, 13, 'PPL', 'P'),
(77047, 'Ravia', 34.2416687011719, 0.59762986021254, -96.751106262207, -1.68862535922242, 218, 42, 'PPL', 'P'),
(123518, 'Ravinamy', 40.4619407653809, 0.70619408810281, -86.8977813720703, -1.51665239762082, 218, 19, 'PPL', 'P'),
(61485, 'Ravine', 33.2136116027832, 0.579686878947158, -88.366943359375, -1.54229411154443, 218, 30, 'PPL', 'P'),
(166322, 'Ravine', 40.5744400024414, 0.708157570195499, -76.404167175293, -1.33350427945304, 218, 45, 'PPL', 'P'),
(121174, 'Ravinia', 42.1636085510254, 0.735893793737429, -87.7869415283203, -1.53217116992493, 218, 18, 'PPL', 'P'),
(171151, 'Ravinia', 43.1366691589355, 0.752876905166918, -98.4263916015625, -1.71786460430456, 218, 49, 'PPL', 'P'),
(123519, 'Ravinia Oaks', 41.564998626709, 0.725446079622993, -84.9011077880859, -1.4818038694927, 218, 19, 'PPL', 'P'),
(121176, 'Rawalts', 40.5533294677734, 0.707789121858686, -89.9797210693359, -1.57044239268603, 218, 18, 'PPL', 'P'),
(61487, 'Rawhide', 32.4661102294922, 0.566640518820051, -90.6277770996094, -1.5817531041517, 218, 30, 'PPL', 'P'),
(105594, 'Rawhide', 36.8555603027344, 0.643250874950033, -82.9111099243164, -1.44707185466227, 218, 53, 'PPL', 'P'),
(184442, 'Rawhide', 37.9630584716797, 0.662580364457937, -120.448890686035, -2.10222972284605, 218, 6, 'PPL', 'P'),
(190651, 'Rawhide', 39.0166702270508, 0.68096935862688, -118.390281677246, -2.06630021763146, 218, 39, 'PPL', 'P'),
(61486, 'Rawhide (historical)', 30.6527805328369, 0.534991945189226, -89.1377792358398, -1.55574773558124, 218, 30, 'PPL', 'P'),
(111060, 'Rawl', 37.6497192382813, 0.657111563159459, -82.2197189331055, -1.43500480544701, 218, 58, 'PPL', 'P'),
(105595, 'Rawley Springs', 38.5052795410156, 0.672043907391534, -79.0566711425781, -1.37979920710438, 218, 53, 'PPL', 'P'),
(50721, 'Rawlings', 39.5344390869141, 0.690006129995791, -78.8836135864258, -1.37677878295406, 218, 25, 'PPL', 'P'),
(105596, 'Rawlings', 36.9483299255371, 0.644870010313774, -77.779167175293, -1.35750255666796, 218, 53, 'PPL', 'P'),
(50722, 'Rawlings Heights', 39.538890838623, 0.690083827720594, -78.8866729736328, -1.37683217933392, 218, 25, 'PPL', 'P'),
(5299, 'Rawlingsville (historical)', 34.461109161377, 0.60145981875521, -85.6986083984375, -1.49572288093, 218, 2, 'PPL', 'P'),
(97385, 'Rawlins', 32.8380584716797, 0.573132240293228, -96.7363891601563, -1.68836849733528, 218, 51, 'PPL', 'P'),
(209684, 'Rawlins', 41.7911109924316, 0.729392484884327, -107.238059997559, -1.87165723040862, 218, 59, 'PPL', 'P'),
(11476, 'Rawlinson', 34.9291687011719, 0.609628998820001, -90.5897216796875, -1.58108891177583, 218, 4, 'PPL', 'P'),
(83211, 'Rawlinson Acres', 34.9555587768555, 0.61008959253053, -81.0791702270508, -1.41509847524699, 218, 48, 'PPL', 'P'),
(83212, 'Rawlinson Woods', 34.9597206115723, 0.610162230249262, -81.0944366455078, -1.41536492451406, 218, 48, 'PPL', 'P'),
(79006, 'Rawlinsville', 39.8822212219238, 0.696076073331327, -76.269172668457, -1.33114818083664, 218, 45, 'PPL', 'P'),
(5298, 'Rawls', 31.4530601501465, 0.548959459447878, -86.4811096191406, -1.50938010363214, 218, 2, 'PPL', 'P'),
(11477, 'Rawls', 33.0105590820313, 0.576142943905562, -91.8550033569336, -1.60317224300894, 218, 4, 'PPL', 'P'),
(17765, 'Rawls', 30.548059463501, 0.533164217733105, -82.9783325195313, -1.4482451102805, 218, 12, 'PPL', 'P'),
(68104, 'Rawls', 35.5369415283203, 0.620236635757895, -78.815559387207, -1.37559101310789, 218, 33, 'PPL', 'P'),
(17766, 'Rawls Park', 28.0588893890381, 0.489720004291615, -81.9044418334961, -1.42950218200269, 218, 12, 'PPL', 'P'),
(61488, 'Rawls Springs', 31.3805599212646, 0.547694091745441, -89.3713912963867, -1.55982503521015, 218, 30, 'PPL', 'P'),
(61489, 'Raworth', 32.3630599975586, 0.564841952977865, -89.5644378662109, -1.56319433346327, 218, 30, 'PPL', 'P'),
(113968, 'Rawson', 41.8069381713867, 0.729668721268396, -72.0697174072266, -1.25785385973797, 218, 8, 'PPL', 'P'),
(151990, 'Rawson', 42.3213882446289, 0.738647568883598, -78.3088912963867, -1.36674798670828, 218, 40, 'PPL', 'P'),
(157292, 'Rawson', 40.9588890075684, 0.71486747114098, -83.7841720581055, -1.46230966347137, 218, 41, 'PPL', 'P'),
(193896, 'Rawson', 40.1177787780762, 0.700187328264137, -122.193328857422, -2.13267591253421, 218, 6, 'PPL', 'P'),
(198783, 'Rawson', 47.8194389343262, 0.83460665586036, -103.540283203125, -1.80711885034191, 218, 34, 'PPL', 'P'),
(121178, 'Rawson Bridge', 42.2422218322754, 0.737265854331037, -88.2149963378906, -1.53964213573093, 218, 18, 'PPL', 'P'),
(132782, 'Rawsonville', 42.2152786254883, 0.736795606661557, -83.5516662597656, -1.45825167176037, 218, 27, 'PPL', 'P'),
(172442, 'Rawsonville', 43.1458282470703, 0.75303676141135, -72.8408279418945, -1.27131227746474, 218, 55, 'PPL', 'P'),
(5300, 'Ray', 32.8872184753418, 0.573990244217424, -86.0377807617188, -1.50164255540103, 218, 2, 'PPL', 'P'),
(33724, 'Ray', 38.1744384765625, 0.666269641516024, -98.9672164916992, -1.72730377931418, 218, 20, 'PPL', 'P'),
(74021, 'Ray', 39.2036094665527, 0.684232063857363, -82.6836090087891, -1.44310121463501, 218, 41, 'PPL', 'P'),
(97386, 'Ray', 33.8138885498047, 0.590163688096502, -96.5569381713867, -1.68523648673529, 218, 51, 'PPL', 'P'),
(105597, 'Ray', 36.9361114501953, 0.644656757689486, -79.3111114501953, -1.38424002822208, 218, 53, 'PPL', 'P'),
(113048, 'Ray', 40.2061080932617, 0.701728965640156, -90.4755630493164, -1.57909646780629, 218, 18, 'PPL', 'P'),
(123520, 'Ray', 40.4541702270508, 0.706058466624298, -86.5252838134766, -1.51015108876772, 218, 19, 'PPL', 'P'),
(132780, 'Ray', 41.7597198486328, 0.728844606069071, -84.871940612793, -1.48129480625033, 218, 27, 'PPL', 'P'),
(137641, 'Ray', 48.410831451416, 0.844928402455235, -93.2102813720703, -1.62682630665296, 218, 28, 'PPL', 'P'),
(151991, 'Ray', 42.9333305358887, 0.749327976698279, -78.2975006103516, -1.3665491817329, 218, 40, 'PPL', 'P'),
(178961, 'Ray', 33.1833305358887, 0.579158374628832, -110.996940612793, -1.93726207333385, 218, 5, 'PPL', 'P'),
(198785, 'Ray', 48.3444404602051, 0.843769661064941, -103.16471862793, -1.8005640119509, 218, 34, 'PPL', 'P'),
(90218, 'Ray (historical)', 36.3644409179688, 0.634679224665504, -83.9488906860352, -1.46518454586811, 218, 50, 'PPL', 'P'),
(151992, 'Ray Brook', 44.2999992370605, 0.773180845317683, -74.0858306884766, -1.29304167458897, 218, 40, 'PPL', 'P'),
(132781, 'Ray Center', 42.7616691589355, 0.74633192047194, -82.9013900756836, -1.44690221130083, 218, 27, 'PPL', 'P'),
(24224, 'Ray City', 31.0744400024414, 0.542351291256037, -83.1994400024414, -1.45210416385808, 218, 13, 'PPL', 'P'),
(128629, 'Ray Corner', 44.5122184753418, 0.776884769761765, -69.1827774047852, -1.20746725138784, 218, 26, 'PPL', 'P'),
(178962, 'Ray Junction', 33.1069412231445, 0.577825129608111, -110.962501525879, -1.93666099787582, 218, 5, 'PPL', 'P'),
(50723, 'Ray Park Heights', 38.3702812194824, 0.669687742196113, -75.6333312988281, -1.32005065541623, 218, 25, 'PPL', 'P'),
(178963, 'Ray Place', 35.8224983215332, 0.625220542000897, -114.003059387207, -1.98972874365339, 218, 5, 'PPL', 'P'),
(97387, 'Ray Point', 28.5138893127441, 0.497661251056608, -98.0880584716797, -1.71195957721953, 218, 51, 'PPL', 'P'),
(11478, 'Ray Station (historical)', 34.2236099243164, 0.597314675097529, -91.8194427490234, -1.60255159331689, 218, 4, 'PPL', 'P'),
(50724, 'Ray-Mar Estates', 39.4605598449707, 0.688716693975002, -77.0430603027344, -1.34465506809525, 218, 25, 'PPL', 'P'),
(192948, 'Rayado', 36.3686103820801, 0.63475199554229, -104.926391601563, -1.83131100568419, 218, 38, 'PPL', 'P'),
(112284, 'Raybon', 31.2627792358398, 0.545638430989522, -81.9722213745117, -1.4306851581589, 218, 13, 'PPL', 'P'),
(57106, 'Rayborn', 37.3044395446777, 0.651085295665801, -92.3574981689453, -1.61194243195273, 218, 29, 'PPL', 'P'),
(5301, 'Rayburn', 34.3488883972168, 0.599501196931511, -86.2675018310547, -1.50565194442214, 218, 2, 'PPL', 'P'),
(97388, 'Rayburn', 30.413330078125, 0.530812746359105, -94.9241714477539, -1.6567393314909, 218, 51, 'PPL', 'P'),
(111061, 'Rayburn', 38.8727798461914, 0.678457997718935, -82.0266723632813, -1.4316355071939, 218, 58, 'PPL', 'P'),
(50725, 'Raydan Retreat', 39.4436111450195, 0.688420883356921, -77.0569381713867, -1.3448972825964, 218, 25, 'PPL', 'P'),
(37870, 'Raydure', 36.6522216796875, 0.639701946481393, -85.4791717529297, -1.49189298896636, 218, 21, 'PPL', 'P'),
(83215, 'Rayflin', 33.7538909912109, 0.589116533155883, -81.4252777099609, -1.42113919038957, 218, 48, 'PPL', 'P'),
(77049, 'Rayford', 34.434440612793, 0.600994364775691, -97.0944366455078, -1.69461760483315, 218, 42, 'PPL', 'P'),
(97389, 'Rayford', 30.1272201538086, 0.525819186157152, -95.4277801513672, -1.66552896151065, 218, 51, 'PPL', 'P'),
(97390, 'Rayland', 34.0644416809082, 0.59453666518544, -99.4813919067383, -1.73627783323942, 218, 51, 'PPL', 'P'),
(157293, 'Rayland', 40.1824989318848, 0.701316908040494, -80.6913909912109, -1.40833045081072, 218, 41, 'PPL', 'P'),
(24228, 'Rayle', 33.7897186279297, 0.589741843379834, -82.9000015258789, -1.44687797653491, 218, 13, 'PPL', 'P'),
(117464, 'Raymar', 42.4552803039551, 0.740984426161115, -92.2399978637695, -1.60989166475531, 218, 16, 'PPL', 'P'),
(184443, 'Raymer', 34.2147216796875, 0.597159545964032, -118.46443939209, -2.06759451392124, 218, 6, 'PPL', 'P'),
(194391, 'Raymer', 40.6080589294434, 0.70874433116267, -103.841941833496, -1.81238378665894, 218, 7, 'PPL', 'P'),
(151993, 'Raymertown', 42.8138885498047, 0.747243320775992, -73.5350036621094, -1.2834279293699, 218, 40, 'PPL', 'P'),
(166324, 'Raymilton', 41.3355598449707, 0.721441617449896, -79.9761123657227, -1.39584648372681, 218, 45, 'PPL', 'P'),
(24225, 'Raymond', 33.3386116027832, 0.581868540512151, -84.7147216796875, -1.47855081822117, 218, 13, 'PPL', 'P'),
(28376, 'Raymond', 39.3194389343262, 0.686253669440842, -89.5719375610352, -1.56332522783084, 218, 18, 'PPL', 'P'),
(30933, 'Raymond', 39.4716682434082, 0.68891057210236, -84.8494415283203, -1.4809021231476, 218, 19, 'PPL', 'P'),
(33725, 'Raymond', 38.2769393920898, 0.668058619978285, -98.4155578613281, -1.71767551986716, 218, 20, 'PPL', 'P'),
(37872, 'Raymond', 37.9388885498047, 0.662158519741268, -86.3652801513672, -1.50735849804866, 218, 21, 'PPL', 'P'),
(42747, 'Raymond', 30.3497200012207, 0.529702541079679, -92.7055587768555, -1.61801723555726, 218, 22, 'PPL', 'P'),
(61490, 'Raymond', 32.2591705322266, 0.563028739749685, -90.4225006103516, -1.57817035353722, 218, 30, 'PPL', 'P'),
(97391, 'Raymond', 33.878059387207, 0.591283680492935, -98.396110534668, -1.71733609998623, 218, 51, 'PPL', 'P'),
(117465, 'Raymond', 42.4688911437988, 0.74122198013035, -92.2194366455078, -1.60953280379843, 218, 16, 'PPL', 'P'),
(128630, 'Raymond', 43.9013900756836, 0.766223803023041, -70.470832824707, -1.22994805941363, 218, 26, 'PPL', 'P'),
(137642, 'Raymond', 45.0158309936523, 0.785674466360544, -95.2383270263672, -1.66222238070121, 218, 28, 'PPL', 'P'),
(142823, 'Raymond', 40.9569396972656, 0.714833449258055, -96.7825012207031, -1.6891733046167, 218, 35, 'PPL', 'P'),
(144358, 'Raymond', 43.0361099243164, 0.751121815429529, -71.1838912963867, -1.24239327750368, 218, 36, 'PPL', 'P'),
(151994, 'Raymond', 43.1069412231445, 0.752358054807544, -78.6675033569336, -1.37300694790218, 218, 40, 'PPL', 'P'),
(157294, 'Raymond', 40.3347206115723, 0.703973677543957, -83.4658279418945, -1.45675351048914, 218, 41, 'PPL', 'P'),
(166325, 'Raymond', 41.8597183227539, 0.730589908689454, -77.8622207641602, -1.35895211524929, 218, 45, 'PPL', 'P'),
(171154, 'Raymond', 44.9124984741211, 0.783870973670342, -97.938606262207, -1.70935114408985, 218, 49, 'PPL', 'P'),
(176020, 'Raymond', 42.8008308410645, 0.747015420765708, -88.0124969482422, -1.53610785464829, 218, 57, 'PPL', 'P'),
(184444, 'Raymond', 37.2172203063965, 0.649563032786711, -119.904441833496, -2.09272729776053, 218, 6, 'PPL', 'P'),
(194392, 'Raymond', 40.1549987792969, 0.700836939833034, -105.463890075684, -1.84069212378205, 218, 7, 'PPL', 'P'),
(195513, 'Raymond', 42.2747192382813, 0.737833041064197, -111.058059692383, -1.93832880250848, 218, 17, 'PPL', 'P'),
(208527, 'Raymond', 46.6866683959961, 0.814836080296912, -123.731666564941, -2.15952497053801, 218, 56, 'PPL', 'P'),
(209880, 'Raymond', 48.8763885498047, 0.853053906678148, -104.579719543457, -1.82526043684559, 218, 31, 'PPL', 'P'),
(11479, 'Raymond (historical)', 34.6333312988281, 0.604465662098555, -91.1044387817383, -1.59007241992294, 218, 4, 'PPL', 'P'),
(111062, 'Raymond City', 38.4822196960449, 0.671641437171795, -81.8186111450195, -1.42800415388952, 218, 58, 'PPL', 'P'),
(37871, 'Raymond Hill', 38.291389465332, 0.668310821333515, -85.2666702270508, -1.48818413767426, 218, 21, 'PPL', 'P'),
(184445, 'Raymond Hill', 34.1241683959961, 0.595579093015124, -118.147216796875, -2.06205793517302, 218, 6, 'PPL', 'P'),
(105601, 'Raymonds Fork', 38.0766716003418, 0.664563287626583, -77.3252792358398, -1.34958071768941, 218, 53, 'PPL', 'P'),
(57107, 'Raymondville', 37.3397216796875, 0.651701085088854, -91.8338928222656, -1.60280379467212, 218, 29, 'PPL', 'P'),
(97392, 'Raymondville', 26.4811096191406, 0.462182552435546, -97.7827835083008, -1.70663152398466, 218, 51, 'PPL', 'P'),
(151995, 'Raymondville', 44.8380584716797, 0.782571750532547, -74.9783325195313, -1.30861877012096, 218, 40, 'PPL', 'P'),
(97393, 'Raymondville Tract Number 1 Colonia', 26.4570007324219, 0.461761772983313, -97.8259963989258, -1.70738573120537, 218, 51, 'PPL', 'P'),
(57108, 'Raymore', 38.8019409179688, 0.677221625182866, -94.4524993896484, -1.6485071010873, 218, 29, 'PPL', 'P'),
(176022, 'Raymore', 43.997501373291, 0.767901261614655, -90.6191711425781, -1.58160290186622, 218, 57, 'PPL', 'P'),
(42748, 'Rayne', 30.2347202301025, 0.527695416434627, -92.2683334350586, -1.61038621376974, 218, 22, 'PPL', 'P'),
(166326, 'Rayne', 40.7380599975586, 0.711013277832391, -79.0302810668945, -1.37933861339385, 218, 45, 'PPL', 'P'),
(83213, 'Raynell', 34.8869400024414, 0.608891968988321, -81.9441680908203, -1.43019553599249, 218, 48, 'PPL', 'P'),
(97394, 'Rayner Junction', 29.5533294677734, 0.51580290413931, -96.32861328125, -1.68125146563815, 218, 51, 'PPL', 'P'),
(197342, 'Raynesford', 47.2700004577637, 0.825017145407203, -110.72917175293, -1.93258862509492, 218, 31, 'PPL', 'P'),
(68105, 'Raynham', 34.5741691589355, 0.603433087964904, -79.1952819824219, -1.3822184226386, 218, 33, 'PPL', 'P'),
(113969, 'Raynham', 41.2747192382813, 0.720379748544254, -72.8969421386719, -1.27229165495562, 218, 8, 'PPL', 'P'),
(125920, 'Raynham', 41.9486083984375, 0.73214133318248, -71.0736083984375, -1.24046847782583, 218, 23, 'PPL', 'P'),
(125921, 'Raynham Center', 41.9236106872559, 0.731705040816897, -71.0527801513672, -1.24010495633703, 218, 23, 'PPL', 'P'),
(68106, 'Raynor', 36.0083312988281, 0.628463939313477, -78.2847213745117, -1.36632614199161, 218, 33, 'PPL', 'P'),
(105599, 'Raynor', 36.9480590820313, 0.644865283202839, -76.7830581665039, -1.34011717475581, 218, 53, 'PPL', 'P'),
(50726, 'Raynor Heights', 39.2266693115234, 0.684634534077101, -76.6602783203125, -1.33797426218468, 218, 25, 'PPL', 'P'),
(121179, 'Raynor Park', 41.5511093139648, 0.725203665384769, -88.0944366455078, -1.53753797215366, 218, 18, 'PPL', 'P'),
(68108, 'Raynor Town', 35.3950004577637, 0.617759296732876, -78.14111328125, -1.36381970793168, 218, 33, 'PPL', 'P'),
(184446, 'Rayo', 36.4500007629395, 0.636172525667739, -119.187217712402, -2.08020937537272, 218, 6, 'PPL', 'P'),
(90219, 'Rayon City', 36.2700004577637, 0.633030927687827, -86.6650009155273, -1.51258961221985, 218, 50, 'PPL', 'P'),
(90220, 'Rayon Terrace', 36.3430595397949, 0.634306049217757, -82.1930618286133, -1.43453955120457, 218, 50, 'PPL', 'P'),
(105600, 'Rayon Terrace', 37.7649993896484, 0.659123581363014, -79.9963912963867, -1.39620041783568, 218, 53, 'PPL', 'P'),
(90221, 'Rays', 36.2197189331055, 0.632153349529618, -85.3269424438477, -1.48923608630484, 218, 50, 'PPL', 'P'),
(68107, 'Rays Beach', 36.3772201538086, 0.634902264406798, -76.8402786254883, -1.34111586016459, 218, 33, 'PPL', 'P'),
(151996, 'Rays Corners', 42.269718170166, 0.73774575595947, -79.0458297729492, -1.37960998950893, 218, 40, 'PPL', 'P'),
(157296, 'Rays Corners', 41.2372207641602, 0.719725276706367, -80.7658309936523, -1.40962967394852, 218, 41, 'PPL', 'P'),
(30935, 'Rays Crossing', 39.5544395446777, 0.690355203835673, -85.6691665649414, -1.49520902399767, 218, 19, 'PPL', 'P'),
(5302, 'Rays Crossroads', 33.250560760498, 0.580331763405121, -85.896110534668, -1.49916994348694, 218, 2, 'PPL', 'P'),
(50727, 'Rays Point', 38.7566719055176, 0.676431531866466, -76.2194366455078, -1.33028012347933, 218, 25, 'PPL', 'P'),
(111063, 'Raysal', 37.3430595397949, 0.6517593417377, -81.7825012207031, -1.42737391681755, 218, 58, 'PPL', 'P'),
(24226, 'Raysville', 33.6188888549805, 0.586760301381436, -82.4819412231445, -1.43958144778031, 218, 13, 'PPL', 'P'),
(30934, 'Raysville', 39.7961082458496, 0.694573118370141, -85.5124969482422, -1.49247462334843, 218, 19, 'PPL', 'P'),
(90222, 'Raysville', 35.3302803039551, 0.616629716956519, -86.3163909912109, -1.5065052212354, 218, 50, 'PPL', 'P'),
(24227, 'Raytown', 33.5691719055176, 0.585892576919261, -82.7525024414063, -1.44430363186718, 218, 13, 'PPL', 'P'),
(57110, 'Raytown', 39.0086097717285, 0.680828677142296, -94.4633331298828, -1.6486961855247, 218, 29, 'PPL', 'P'),
(61491, 'Raytown', 32.6891708374023, 0.570533660859583, -89.7986068725586, -1.56728135363016, 218, 30, 'PPL', 'P'),
(42749, 'Rayville', 32.4772186279297, 0.566834396947408, -91.7547225952148, -1.60142201354054, 218, 22, 'PPL', 'P'),
(50728, 'Rayville', 39.649169921875, 0.692008560819422, -76.7011108398438, -1.33868692409239, 218, 25, 'PPL', 'P'),
(57111, 'Rayville', 39.348331451416, 0.686757938993249, -94.0627822875977, -1.64170525450518, 218, 29, 'PPL', 'P'),
(121180, 'Rayville', 40.3066711425781, 0.703484121956573, -87.658332824707, -1.52992652460016, 218, 18, 'PPL', 'P'),
(128632, 'Rayville', 44.1030616760254, 0.769743636456772, -70.5541687011719, -1.23140254484298, 218, 26, 'PPL', 'P'),
(151997, 'Rayville', 42.464168548584, 0.741139555294612, -73.5388870239258, -1.28349570681964, 218, 40, 'PPL', 'P'),
(208528, 'Rayville', 47.0444412231445, 0.82108039410482, -123.316108703613, -2.15227211762529, 218, 56, 'PPL', 'P'),
(37873, 'Raywick', 37.5602798461914, 0.655550551286509, -85.4305572509766, -1.49104450584306, 218, 21, 'PPL', 'P'),
(97396, 'Raywood', 30.0416698455811, 0.524326051602486, -94.6719436645508, -1.652337126209, 218, 51, 'PPL', 'P'),
(111064, 'Raywood', 38.3683280944824, 0.66965365373416, -79.9341735839844, -1.3951145139012, 218, 58, 'PPL', 'P'),
(97395, 'Razor', 33.8819389343262, 0.59135139136365, -95.6408309936523, -1.66924740018267, 218, 51, 'PPL', 'P'),
(128633, 'Razorville', 44.2763900756836, 0.77276878771802, -69.3974990844727, -1.2112148516738, 218, 26, 'PPL', 'P'),
(83214, 'Razorville (historical)', 33.1769409179688, 0.579046854758185, -79.8083267211914, -1.39291807179216, 218, 48, 'PPL', 'P'),
(139418, 'Rea', 40.061939239502, 0.699212744463222, -94.7644424438477, -1.6539515344618, 218, 29, 'PPL', 'P'),
(166328, 'Rea', 40.2772216796875, 0.702970131866188, -80.3974990844727, -1.40320106939317, 218, 45, 'PPL', 'P'),
(195514, 'Rea', 44.4697189331055, 0.77614301281915, -111.434440612793, -1.94489788881132, 218, 17, 'PPL', 'P'),
(11481, 'Rea Valley', 36.2211112976074, 0.632177650874565, -92.5411071777344, -1.61514701369242, 218, 4, 'PPL', 'P'),
(128634, 'Reach', 44.2491683959961, 0.77229367977955, -68.6241683959961, -1.19771768495317, 218, 26, 'PPL', 'P'),
(111065, 'Read', 38.9530601501465, 0.679859153347453, -79.8430633544922, -1.39352434041432, 218, 58, 'PPL', 'P'),
(187244, 'Read', 38.7661094665527, 0.676596248379888, -107.975563049316, -1.8845290869053, 218, 7, 'PPL', 'P'),
(192755, 'Read', 38.5724983215332, 0.673217096430741, -112.984169006348, -1.9719457517905, 218, 52, 'PPL', 'P'),
(90223, 'Read Hill', 35.8963890075684, 0.626510177758768, -83.0791702270508, -1.45000506028688, 218, 50, 'PPL', 'P'),
(151998, 'Readburn', 42.0111083984375, 0.733232163964976, -75.1744384765625, -1.31204146475393, 218, 40, 'PPL', 'P'),
(132784, 'Reade', 46.0597190856934, 0.803893750589021, -87.5616683959961, -1.52823941204959, 218, 27, 'PPL', 'P'),
(11482, 'Reader', 33.7519416809082, 0.589082511272958, -93.1050033569336, -1.62498885865886, 218, 4, 'PPL', 'P'),
(28377, 'Reader', 39.3055610656738, 0.6860114549397, -90.0408325195313, -1.5715089887026, 218, 18, 'PPL', 'P'),
(111066, 'Reader', 39.5688896179199, 0.690607405190904, -80.7330627441406, -1.40905776010442, 218, 58, 'PPL', 'P'),
(128635, 'Readfield', 44.3877792358398, 0.774712895313778, -69.9672164916992, -1.22115829623583, 218, 26, 'PPL', 'P'),
(176023, 'Readfield', 44.2724990844727, 0.772700877110223, -88.7697219848633, -1.54932392471586, 218, 57, 'PPL', 'P'),
(128636, 'Readfield Depot', 44.3791694641113, 0.77456262644927, -69.9402770996094, -1.22068811514537, 218, 26, 'PPL', 'P'),
(42750, 'Readheimer', 32.1152801513672, 0.56051737884174, -92.9872207641602, -1.62293316461343, 218, 22, 'PPL', 'P'),
(33727, 'Reading', 38.5194396972656, 0.672291048740693, -95.9583282470703, -1.67478877262086, 218, 20, 'PPL', 'P'),
(57112, 'Reading', 39.4913902282715, 0.689254785673252, -91.1322174072266, -1.59055724839939, 218, 29, 'PPL', 'P'),
(121181, 'Reading', 41.0666694641113, 0.716748594976958, -88.8541717529297, -1.55079785122116, 218, 18, 'PPL', 'P'),
(125923, 'Reading', 42.5255584716797, 0.742211011580178, -71.095832824707, -1.2408563672386, 218, 23, 'PPL', 'P'),
(132785, 'Reading', 41.8394393920898, 0.730235974580583, -84.7480621337891, -1.47913271891935, 218, 27, 'PPL', 'P'),
(137645, 'Reading', 43.7036094665527, 0.762771880197108, -95.7127838134766, -1.6705032137947, 218, 28, 'PPL', 'P'),
(157297, 'Reading', 40.8349990844727, 0.712705184072918, -81.0313873291016, -1.41426450635164, 218, 41, 'PPL', 'P'),
(166330, 'Reading', 40.3355598449707, 0.703988324929952, -75.9272232055664, -1.32518003683378, 218, 45, 'PPL', 'P'),
(151999, 'Reading Center', 42.4302787780762, 0.740548067216506, -76.9330596923828, -1.34273519526542, 218, 40, 'PPL', 'P'),
(125924, 'Reading Highlands', 42.5250015258789, 0.7422012910422, -71.1125030517578, -1.24114731758769, 218, 23, 'PPL', 'P'),
(166331, 'Reading Number Three', 40.0877799987793, 0.699663750793827, -78.9611129760742, -1.37813140247171, 218, 45, 'PPL', 'P'),
(146148, 'Readingsburg', 40.6819381713867, 0.710033767183459, -74.8772201538086, -1.30685402642461, 218, 37, 'PPL', 'P'),
(146149, 'Readington', 40.5686111450195, 0.708055837441858, -74.7380599975586, -1.30442522351046, 218, 37, 'PPL', 'P'),
(11483, 'Readland', 33.065559387207, 0.577102880320481, -91.2133331298828, -1.59197298483488, 218, 4, 'PPL', 'P'),
(117468, 'Readlyn', 42.702220916748, 0.745294352911245, -92.2252807617188, -1.60963480286818, 218, 16, 'PPL', 'P'),
(68109, 'Reads Chapel', 35.3108291625977, 0.616290230496561, -76.7463912963867, -1.33947721714587, 218, 33, 'PPL', 'P'),
(137646, 'Reads Landing', 44.4022216796875, 0.774964963510954, -92.0788879394531, -1.60707976611835, 218, 28, 'PPL', 'P'),
(5303, 'Reads Mill', 33.8730583190918, 0.591196395388208, -85.9016723632813, -1.49926701570868, 218, 2, 'PPL', 'P'),
(172443, 'Readsboro', 42.771671295166, 0.746506490681394, -72.9477767944336, -1.27317888707278, 218, 55, 'PPL', 'P'),
(172444, 'Readsboro Falls', 42.8033294677734, 0.747059030028559, -72.9752807617188, -1.27365892185927, 218, 55, 'PPL', 'P'),
(176028, 'Readstown', 43.4494400024414, 0.758335786190336, -90.7591705322266, -1.58404635216637, 218, 57, 'PPL', 'P'),
(57113, 'Readsville', 38.8044395446777, 0.677265234445716, -91.7188873291016, -1.60079657015853, 218, 29, 'PPL', 'P'),
(105602, 'Readus', 38.8558311462402, 0.678162187100854, -78.5911102294922, -1.37167363630244, 218, 53, 'PPL', 'P'),
(125926, 'Readville', 42.2402801513672, 0.737231965606166, -71.1374969482422, -1.24158354337424, 218, 23, 'PPL', 'P'),
(125927, 'Readville Manor', 42.2291717529297, 0.737038087478808, -71.1444396972656, -1.24170471720384, 218, 23, 'PPL', 'P'),
(37874, 'Ready', 37.3716697692871, 0.65225868444209, -86.4713897705078, -1.50921046027071, 218, 21, 'PPL', 'P'),
(68110, 'Ready Branch', 36.1402816772461, 0.630766907866123, -81.3541717529297, -1.41989815732159, 218, 33, 'PPL', 'P'),
(5304, 'Ready Crossing', 34.9327812194824, 0.609692049158808, -86.7291717529297, -1.51370960461629, 218, 2, 'PPL', 'P'),
(90224, 'Readyville', 35.8280601501465, 0.62531761422263, -86.1747207641602, -1.50403260932132, 218, 50, 'PPL', 'P'),
(77050, 'Reagan', 34.3488883972168, 0.599501196931511, -96.7213897705078, -1.68810670860012, 218, 42, 'PPL', 'P'),
(90226, 'Reagan', 35.5513916015625, 0.620488837113126, -84.5141677856445, -1.47505049244242, 218, 50, 'PPL', 'P'),
(97404, 'Reagan', 31.2180595397949, 0.544857925053047, -96.7822189331055, -1.68916837776868, 218, 51, 'PPL', 'P'),
(123521, 'Reagan', 40.1919403076172, 0.701481691132942, -86.5094375610352, -1.50987451948852, 218, 19, 'PPL', 'P'),
(97397, 'Reagan Wells', 29.538610458374, 0.515546008962658, -99.836669921875, -1.74247860436351, 218, 51, 'PPL', 'P'),
(90227, 'Reagantown', 35.8408317565918, 0.62554052080587, -83.5108337402344, -1.45753900985266, 218, 50, 'PPL', 'P'),
(166334, 'Reagantown', 40.1394386291504, 0.700565363980873, -79.6488876342773, -1.39013533476914, 218, 45, 'PPL', 'P'),
(105603, 'Reager', 38.8422203063965, 0.677924633131619, -78.123893737793, -1.36351917020267, 218, 53, 'PPL', 'P'),
(187859, 'Reager', 39.8269386291504, 0.695111210068391, -100.095832824707, -1.74700185031695, 218, 20, 'PPL', 'P'),
(97398, 'Reagor Springs', 32.3286094665527, 0.564240677782753, -96.7605590820313, -1.68879034205195, 218, 51, 'PPL', 'P'),
(97400, 'Realitos', 27.4444408416748, 0.478995854056029, -98.5280609130859, -1.71963906853888, 218, 51, 'PPL', 'P'),
(97401, 'Realitos Colonia', 27.4459991455078, 0.479023051588662, -98.5309982299805, -1.71969033438986, 218, 51, 'PPL', 'P'),
(111067, 'Ream', 37.3497200012207, 0.651875588719282, -81.5500030517578, -1.4233160582646, 218, 58, 'PPL', 'P'),
(111068, 'Reamer', 38.475830078125, 0.671529917301148, -81.3711090087891, -1.42019376820259, 218, 58, 'PPL', 'P'),
(11484, 'Reamey', 35.6644401550293, 0.622461906585738, -91.3091735839844, -1.59364571631556, 218, 4, 'PPL', 'P'),
(17768, 'Reams', 30.4858303070068, 0.532078114061543, -83.6275024414063, -1.45957526282214, 218, 12, 'PPL', 'P'),
(77051, 'Reams', 35.065559387207, 0.612009465360368, -95.6997222900391, -1.67027524720539, 218, 42, 'PPL', 'P'),
(105604, 'Reams', 37.1005592346191, 0.647526912975291, -77.4066696166992, -1.35100124781486, 218, 53, 'PPL', 'P'),
(166333, 'Reamstown', 40.2113914489746, 0.7018211775929, -76.1236114501953, -1.32860765831476, 218, 45, 'PPL', 'P'),
(33729, 'Reamsville', 39.9300003051758, 0.696909975647658, -98.8666687011719, -1.72554888931388, 218, 20, 'PPL', 'P'),
(208529, 'Reardan', 47.6697196960449, 0.831993562198774, -117.876670837402, -2.05733601740225, 218, 56, 'PPL', 'P'),
(28378, 'Reardon', 39.1158294677734, 0.682700013861268, -90.5749969482422, -1.58083191673064, 218, 18, 'PPL', 'P'),
(42751, 'Rearwood (historical)', 30.1694393157959, 0.526556049541264, -90.9577789306641, -1.58751272264121, 218, 22, 'PPL', 'P'),
(117469, 'Reasnor', 41.5783309936523, 0.725678773323239, -93.023063659668, -1.62355874115349, 218, 16, 'PPL', 'P'),
(197343, 'Reasville (historical)', 45.6719398498535, 0.797125726152748, -111.123329162598, -1.93946796966476, 218, 31, 'PPL', 'P'),
(178964, 'Reata Pass', 33.7333297729492, 0.588757672198995, -111.844169616699, -1.95204900897041, 218, 5, 'PPL', 'P'),
(5305, 'Reaves', 33.9749984741211, 0.592975586733463, -85.790283203125, -1.49732290811292, 218, 2, 'PPL', 'P'),
(146151, 'Reaville', 40.478328704834, 0.706480111603885, -74.8169403076172, -1.30580194463598, 218, 37, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(17767, 'Reavills Corner', 28.562780380249, 0.498514561159383, -81.6941680908203, -1.4258322128625, 218, 12, 'PPL', 'P'),
(97402, 'Reavilon', 33.1569404602051, 0.578697780918302, -96.0966720581055, -1.67720332762318, 218, 51, 'PPL', 'P'),
(105605, 'Reavistown', 36.6399993896484, 0.639488627278078, -80.9669418334961, -1.41313972026524, 218, 53, 'PPL', 'P'),
(68111, 'Reb Kee', 34.6138916015625, 0.604126375375679, -78.1852798461914, -1.36459055990921, 218, 33, 'PPL', 'P'),
(68112, 'Reba', 35.6738891601563, 0.622626822836241, -77.6394424438477, -1.35506390005777, 218, 33, 'PPL', 'P'),
(105606, 'Reba', 37.4124984741211, 0.652971279770768, -79.6372222900391, -1.3899317361038, 218, 53, 'PPL', 'P'),
(50729, 'Reba L Anthony Estates', 39.2077789306641, 0.684304834734149, -76.0513916015625, -1.32734718417083, 218, 25, 'PPL', 'P'),
(50732, 'Rebas Retreat', 39.5313911437988, 0.689952933353017, -76.9625015258789, -1.34324905219775, 218, 25, 'PPL', 'P'),
(24229, 'Rebecca', 31.8063907623291, 0.555126241978552, -83.4869384765625, -1.45712195882595, 218, 13, 'PPL', 'P'),
(97403, 'Rebecca', 31.4069404602051, 0.548154519008402, -94.045280456543, -1.64139978992815, 218, 51, 'PPL', 'P'),
(195515, 'Rebecca', 44.2408294677734, 0.772148138025977, -116.856941223145, -2.03953837815336, 218, 17, 'PPL', 'P'),
(54, 'Rebecca Colonia', 26.2040004730225, 0.457346085448394, -97.9329986572266, -1.70925327291979, 218, 51, 'PPL', 'P'),
(24230, 'Rebecca Lake Estates', 33.5611114501953, 0.585751895434677, -84.4986114501953, -1.47477898316929, 218, 13, 'PPL', 'P'),
(205484, 'Rebecca Meadows Condo', 40.6227798461914, 0.709001259628836, -111.946388244629, -1.95383306058465, 218, 52, 'PPL', 'P'),
(42752, 'Rebecca Plantation', 29.6916694641113, 0.518217392562603, -90.8127822875977, -1.58498205381537, 218, 22, 'PPL', 'P'),
(50730, 'Rebecca Ridge', 39.5369415283203, 0.690049805837668, -76.9625015258789, -1.34324905219775, 218, 25, 'PPL', 'P'),
(90228, 'Rebel Acres', 35.1994400024414, 0.614346122900803, -87.0155563354492, -1.5187079585082, 218, 50, 'PPL', 'P'),
(68113, 'Rebel City', 35.0825004577637, 0.612305142820394, -78.5488891601563, -1.37093673962881, 218, 33, 'PPL', 'P'),
(200155, 'Rebel Creek (historical)', 41.6055603027344, 0.726154014419764, -117.764442443848, -2.0553772624205, 218, 39, 'PPL', 'P'),
(24231, 'Rebel Hill', 33.9902801513672, 0.593242302316634, -83.4677810668945, -1.4567875989511, 218, 13, 'PPL', 'P'),
(24232, 'Rebel Trail', 33.6922187805176, 0.5880401500223, -84.6972198486328, -1.47824535364414, 218, 13, 'PPL', 'P'),
(152003, 'Reber', 44.3236083984375, 0.773592902917345, -73.4800033569336, -1.28246799295498, 218, 40, 'PPL', 'P'),
(166335, 'Rebersburg', 40.9444389343262, 0.71461526978575, -77.4452819824219, -1.3516751607287, 218, 45, 'PPL', 'P'),
(24233, 'Rebie', 32.4619407653809, 0.566567747943264, -83.1761093139648, -1.45169696652741, 218, 13, 'PPL', 'P'),
(166336, 'Rebuck', 40.7222213745117, 0.71073684171124, -76.7358322143555, -1.33929292639843, 218, 45, 'PPL', 'P'),
(189322, 'Recheulos', 36.0527801513672, 0.629239718139017, -106.338333129883, -1.85595403419902, 218, 38, 'PPL', 'P'),
(50731, 'Reckford', 39.478889465332, 0.689036606200948, -76.4280624389648, -1.33392133047974, 218, 25, 'PPL', 'P'),
(42753, 'Recknor (historical)', 31.4977798461914, 0.549739965384353, -93.6236114501953, -1.63404027741377, 218, 22, 'PPL', 'P'),
(195516, 'Reclamation Village', 43.3355598449707, 0.756348202489782, -115.487777709961, -2.01564196685014, 218, 17, 'PPL', 'P'),
(193268, 'Recluse', 44.7411117553711, 0.780879711133965, -105.707496643066, -1.84494386046236, 218, 59, 'PPL', 'P'),
(14466, 'Records Estates', 38.5138893127441, 0.672194176256041, -75.585563659668, -1.31921695283698, 218, 10, 'PPL', 'P'),
(24234, 'Recovery', 30.7563896179199, 0.536800264858903, -84.7375030517578, -1.47894842817192, 218, 13, 'PPL', 'P'),
(50738, 'Recovery', 39.0536117553711, 0.681614109926788, -76.1402816772461, -1.32889860866385, 218, 25, 'PPL', 'P'),
(201457, 'Recreation (historical)', 42.4744415283203, 0.741318852615002, -122.087783813477, -2.1308338040082, 218, 43, 'PPL', 'P'),
(11485, 'Rector', 36.2630615234375, 0.632909820437255, -90.2925033569336, -1.57590147344652, 218, 4, 'PPL', 'P'),
(57114, 'Rector', 37.4069404602051, 0.652874274128062, -91.5094375610352, -1.59714098208823, 218, 29, 'PPL', 'P'),
(152001, 'Rector', 43.7555618286133, 0.763678619969253, -75.6772232055664, -1.32081671370379, 218, 40, 'PPL', 'P'),
(166337, 'Rector', 40.1966705322266, 0.701564249126735, -79.2388916015625, -1.38297955407815, 218, 45, 'PPL', 'P'),
(184448, 'Rector', 36.3052787780762, 0.633646650531853, -119.241943359375, -2.08116451809768, 218, 6, 'PPL', 'P'),
(152002, 'Rectors', 42.8622207641602, 0.748086877051275, -74.0169372558594, -1.2918392573568, 218, 40, 'PPL', 'P'),
(105607, 'Rectortown', 38.9211082458496, 0.67930148741519, -77.8616714477539, -1.35894252786937, 218, 53, 'PPL', 'P'),
(37875, 'Rectorville', 38.5763893127441, 0.673285007038538, -83.646110534668, -1.45990003531707, 218, 21, 'PPL', 'P'),
(28380, 'Rectorville (historical)', 37.9216690063477, 0.661857982012253, -88.4577789306641, -1.54387949134136, 218, 18, 'PPL', 'P'),
(184449, 'Red Apple', 38.1788902282715, 0.666347339240827, -120.380561828613, -2.10103715930991, 218, 6, 'PPL', 'P'),
(5306, 'Red Apple (historical)', 34.1824989318848, 0.596597152920834, -86.2005615234375, -1.50448361565192, 218, 2, 'PPL', 'P'),
(105608, 'Red Apple Orchard', 37.7038917541504, 0.658057051925465, -78.779167175293, -1.3749558491879, 218, 53, 'PPL', 'P'),
(37876, 'Red Ash', 36.6163902282715, 0.639076569678416, -84.121940612793, -1.46820483686037, 218, 21, 'PPL', 'P'),
(90230, 'Red Ash', 36.3133316040039, 0.633787198858382, -84.2366714477539, -1.470207267684, 218, 50, 'PPL', 'P'),
(105609, 'Red Ash', 37.1133308410645, 0.647749819558531, -81.8711090087891, -1.42892041446256, 218, 53, 'PPL', 'P'),
(111069, 'Red Ash (historical)', 37.9613914489746, 0.662551269423028, -81.039436340332, -1.41440498809914, 218, 58, 'PPL', 'P'),
(5307, 'Red Bank', 34.767219543457, 0.606802452797045, -87.370002746582, -1.52489421540435, 218, 2, 'PPL', 'P'),
(11486, 'Red Bank', 36.1961097717285, 0.631741291929956, -93.2666702270508, -1.6278104778338, 218, 4, 'PPL', 'P'),
(30936, 'Red Bank', 37.9713897705078, 0.662725773053455, -87.6258316040039, -1.52935927128797, 218, 19, 'PPL', 'P'),
(57115, 'Red Bank', 36.9383316040039, 0.644695506683346, -92.8105621337891, -1.61984988986139, 218, 29, 'PPL', 'P'),
(74025, 'Red Bank', 39.1355590820313, 0.683044360590215, -84.3997192382813, -1.47305298846681, 218, 41, 'PPL', 'P'),
(83216, 'Red Bank', 33.9319381713867, 0.592224042673842, -81.2386093139648, -1.41788121227002, 218, 48, 'PPL', 'P'),
(90232, 'Red Bank', 35.1122207641602, 0.612823860021714, -85.2941665649414, -1.48866403930269, 218, 50, 'PPL', 'P'),
(97405, 'Red Bank', 33.5254096984863, 0.585128782318626, -94.2425765991211, -1.64484325721762, 218, 51, 'PPL', 'P'),
(105612, 'Red Bank', 37.4444389343262, 0.653528745965948, -75.8422164916992, -1.32369638979049, 218, 53, 'PPL', 'P'),
(146152, 'Red Bank', 40.3469390869141, 0.704186930168245, -74.0647201538086, -1.29267322625216, 218, 37, 'PPL', 'P'),
(166338, 'Red Bank', 40.9508285522461, 0.714726789656397, -77.0538864135742, -1.3448440193746, 218, 45, 'PPL', 'P'),
(193898, 'Red Bank', 40.0994415283203, 0.699867282880136, -122.44416809082, -2.13705388305019, 218, 6, 'PPL', 'P'),
(83217, 'Red Bank (historical)', 33.0299987792969, 0.576482230628438, -80.6277770996094, -1.40722017895227, 218, 48, 'PPL', 'P'),
(83219, 'Red Bank Landing', 32.9516716003418, 0.575115163461873, -79.9319381713867, -1.39507549859123, 218, 48, 'PPL', 'P'),
(61493, 'Red Banks', 34.8280601501465, 0.607864321702687, -89.5644378662109, -1.56319433346327, 218, 30, 'PPL', 'P'),
(68115, 'Red Banks', 34.7027816772461, 0.605677799868705, -79.251106262207, -1.38319274012341, 218, 33, 'PPL', 'P'),
(176026, 'Red Banks', 44.2769393920898, 0.772778375097944, -88.8586120605469, -1.55087534920889, 218, 57, 'PPL', 'P'),
(105613, 'Red Banks (historical)', 38.7986106872559, 0.677163501692075, -78.5961074829102, -1.37176085482814, 218, 53, 'PPL', 'P'),
(166339, 'Red Barn', 40.5244407653809, 0.707284918885307, -79.1591720581055, -1.38158818556664, 218, 45, 'PPL', 'P'),
(97406, 'Red Barn Colonia', 26.2390003204346, 0.45795694802343, -98.1480026245117, -1.71300580005377, 218, 51, 'PPL', 'P'),
(5308, 'Red Bay', 34.4397201538086, 0.601086510149408, -88.1408309936523, -1.5383477062831, 218, 2, 'PPL', 'P'),
(128638, 'Red Beach', 45.1202812194824, 0.787497466705731, -67.147216796875, -1.17194001665591, 218, 26, 'PPL', 'P'),
(128639, 'Red Beach Landing', 45.1322212219238, 0.787705859061029, -67.6963882446289, -1.18152486657716, 218, 26, 'PPL', 'P'),
(24235, 'Red Belt', 34.8772201538086, 0.608722325626883, -85.2591705322266, -1.48805324330668, 218, 13, 'PPL', 'P'),
(77052, 'Red Bird', 35.8855590820313, 0.626321159900399, -95.5886077880859, -1.66833593329959, 218, 42, 'PPL', 'P'),
(97407, 'Red Bird Addition', 32.6686096191406, 0.570174799902695, -96.918327331543, -1.69154391746103, 218, 51, 'PPL', 'P'),
(11487, 'Red Bluff', 33.6458282470703, 0.587230482471889, -93.9580612182617, -1.63987752704906, 218, 4, 'PPL', 'P'),
(24237, 'Red Bluff', 31.0508308410645, 0.541939233656375, -81.6958312988281, -1.42586124131839, 218, 13, 'PPL', 'P'),
(83218, 'Red Bluff', 34.6111106872559, 0.604077839264812, -79.5058288574219, -1.38763848808913, 218, 48, 'PPL', 'P'),
(189323, 'Red Bluff', 32.0738906860352, 0.559794996396056, -104.03971862793, -1.81583564290585, 218, 38, 'PPL', 'P'),
(192103, 'Red Bluff', 31.8947200775146, 0.556667879354572, -103.916938781738, -1.81369273033472, 218, 51, 'PPL', 'P'),
(193899, 'Red Bluff', 40.1786117553711, 0.701249064011724, -122.234718322754, -2.1333982949799, 218, 6, 'PPL', 'P'),
(197344, 'Red Bluff', 45.5886116027832, 0.795671373881456, -111.647216796875, -1.94861153379339, 218, 31, 'PPL', 'P'),
(11488, 'Red Bluff (historical)', 34.4811096191406, 0.601808892595092, -92.1500015258789, -1.60832093234439, 218, 4, 'PPL', 'P'),
(192104, 'Red Bluff Crossing', 32.9897193908691, 0.575779222679685, -100.359443664551, -1.75160272741617, 218, 51, 'PPL', 'P'),
(83222, 'Red Bluff Crossroads', 33.9047203063965, 0.591749001314399, -78.8408279418945, -1.3760320325844, 218, 48, 'PPL', 'P'),
(83220, 'Red Bluff Estates', 32.4902801513672, 0.567062363536719, -80.6813888549805, -1.40815588060127, 218, 48, 'PPL', 'P'),
(24238, 'Red Bluff Landing', 32.9174995422363, 0.57451874853575, -81.6563873291016, -1.4251728141766, 218, 13, 'PPL', 'P'),
(83221, 'Red Bluff Landing', 32.871940612793, 0.57372359521328, -81.4511108398438, -1.42159006356212, 218, 48, 'PPL', 'P'),
(90233, 'Red Boiling Springs', 36.5333290100098, 0.637626877939031, -85.8499984741211, -1.49836513620552, 218, 50, 'PPL', 'P'),
(97412, 'Red Branch', 31.0680599212646, 0.542239937832958, -95.4058303833008, -1.66514586578784, 218, 51, 'PPL', 'P'),
(57116, 'Red Bridge', 38.9269409179688, 0.679403286747859, -94.5755615234375, -1.65065494050645, 218, 29, 'PPL', 'P'),
(79008, 'Red Bridge', 39.9625015258789, 0.697477228959845, -77.6399993896484, -1.35507362059575, 218, 45, 'PPL', 'P'),
(125928, 'Red Bridge', 42.1749992370605, 0.736092598712803, -72.4108276367188, -1.26380735635485, 218, 23, 'PPL', 'P'),
(68116, 'Red Brush', 36.4761085510254, 0.636628192530251, -80.6949996948242, -1.4083934345705, 218, 33, 'PPL', 'P'),
(28381, 'Red Bud', 38.211669921875, 0.666919452822003, -89.9941711425781, -1.57069459404126, 218, 18, 'PPL', 'P'),
(90234, 'Red Bud', 36.0380592346191, 0.628982789672852, -86.9483337402344, -1.51753470288997, 218, 50, 'PPL', 'P'),
(28382, 'Red Bud (historical)', 37.7758293151855, 0.659312599221383, -88.4052810668945, -1.54296323076832, 218, 18, 'PPL', 'P'),
(61494, 'Red Bud (historical)', 32.7577781677246, 0.57173108466471, -88.897216796875, -1.55154912896468, 218, 30, 'PPL', 'P'),
(68122, 'Red Bug', 33.9808311462402, 0.593077386066131, -78.3744430541992, -1.36789208071258, 218, 33, 'PPL', 'P'),
(152004, 'Red Bunch Corners', 43.0763893127441, 0.751824823378283, -74.2597198486328, -1.29607661296723, 218, 40, 'PPL', 'P'),
(30937, 'Red Bush', 37.9383316040039, 0.66214879920329, -87.2719421386719, -1.52318273492981, 218, 19, 'PPL', 'P'),
(209685, 'Red Butte', 42.8061103820801, 0.747107566139425, -106.433609008789, -1.85761691198367, 218, 59, 'PPL', 'P'),
(200156, 'Red Butte (historical)', 41.107780456543, 0.717466117153653, -118.582496643066, -2.06965500165663, 218, 39, 'PPL', 'P'),
(209686, 'Red Buttes', 41.1824989318848, 0.718770200560437, -105.594169616699, -1.84296593072076, 218, 59, 'PPL', 'P'),
(209687, 'Red Buttes Village', 42.8080596923828, 0.747141588022351, -106.42138671875, -1.85740359278035, 218, 59, 'PPL', 'P'),
(111070, 'Red Campbell', 37.8544387817383, 0.660684593235964, -81.9327774047852, -1.42999673101712, 218, 58, 'PPL', 'P'),
(176027, 'Red Cedar', 44.6891708374023, 0.779973171098902, -91.8841705322266, -1.6036813062513, 218, 57, 'PPL', 'P'),
(166340, 'Red Cedar Hill', 40.1541709899902, 0.700822492184121, -74.8483276367188, -1.30634975687221, 218, 45, 'PPL', 'P'),
(594, 'Red Chute', 32.5558280944824, 0.56820639096199, -93.6130599975586, -1.63385611982439, 218, 22, 'PPL', 'P'),
(24239, 'Red Clay', 34.9847183227539, 0.610598522614844, -84.9461135864258, -1.48258936885622, 218, 13, 'PPL', 'P'),
(176030, 'Red Cliff', 46.8555603027344, 0.817783800149466, -90.7877807617188, -1.58454569487076, 218, 57, 'PPL', 'P'),
(187245, 'Red Cliff', 39.5122184753418, 0.689618307162048, -106.367500305176, -1.85646309744139, 218, 7, 'PPL', 'P'),
(142827, 'Red Cloud', 40.0888900756836, 0.699683125290757, -98.519172668457, -1.71948393940538, 218, 35, 'PPL', 'P'),
(152006, 'Red Creek', 43.2472190856934, 0.754806365376681, -76.7238922119141, -1.33908453404314, 218, 40, 'PPL', 'P'),
(37877, 'Red Cross', 36.9786109924316, 0.6453985146321, -86.0858306884766, -1.50248118482829, 218, 21, 'PPL', 'P'),
(68117, 'Red Cross', 35.267219543457, 0.615529099057017, -80.355827331543, -1.40247376009947, 218, 33, 'PPL', 'P'),
(166346, 'Red Cross', 40.711109161377, 0.710542897004855, -76.7863922119141, -1.34017536482563, 218, 45, 'PPL', 'P'),
(209688, 'Red Desert', 41.6536102294922, 0.72699264384703, -108.121109008789, -1.88706934311107, 218, 59, 'PPL', 'P'),
(212120, 'Red Devil', 61.7611083984375, 1.07793469123386, -157.3125, -2.74562107954358, 218, 1, 'PPL', 'P'),
(74026, 'Red Diamond', 39.2538909912109, 0.685109642015571, -82.4291687011719, -1.43866039351731, 218, 41, 'PPL', 'P'),
(42754, 'Red Dirt (historical)', 31.5072193145752, 0.549904715187288, -93.0352783203125, -1.62377192719875, 218, 22, 'PPL', 'P'),
(184451, 'Red Dog', 39.2166709899902, 0.684460030446674, -120.898330688477, -2.11007393067882, 218, 6, 'PPL', 'P'),
(212121, 'Red Dog Mine', 68.0755615234375, 1.18814268872795, -162.856109619141, -2.84237531984281, 218, 1, 'PPL', 'P'),
(5310, 'Red Eagle', 33.0844383239746, 0.577432379926351, -87.1322174072266, -1.52074407831962, 218, 2, 'PPL', 'P'),
(202540, 'Red Elm', 45.0552787780762, 0.786362960081357, -101.78360748291, -1.77645907513432, 218, 49, 'PPL', 'P'),
(152007, 'Red Falls', 42.309440612793, 0.738439043370245, -74.39111328125, -1.2983698609819, 218, 40, 'PPL', 'P'),
(194393, 'Red Feather Lakes', 40.8025016784668, 0.712137997339758, -105.591110229492, -1.8429125343409, 218, 7, 'PPL', 'P'),
(184452, 'Red Fir', 36.6055603027344, 0.638887551820047, -118.765281677246, -2.07284520232644, 218, 6, 'PPL', 'P'),
(42755, 'Red Fish', 31.0013904571533, 0.541076336173675, -91.8724975585938, -1.60347757442791, 218, 22, 'PPL', 'P'),
(97413, 'Red Fish Cove', 29.0994396209717, 0.507881031871247, -95.1080627441406, -1.65994884007861, 218, 51, 'PPL', 'P'),
(11490, 'Red Fork', 33.9363899230957, 0.592301740398645, -91.2699966430664, -1.59296194970568, 218, 4, 'PPL', 'P'),
(77055, 'Red Fork', 36.1058311462402, 0.63016563267101, -96.0247192382813, -1.67594751401115, 218, 42, 'PPL', 'P'),
(24240, 'Red Fox', 33.8838882446289, 0.591385413246576, -83.341667175293, -1.45458649631014, 218, 13, 'PPL', 'P'),
(105614, 'Red Fox Forest', 38.8127784729004, 0.677410776199289, -77.2558288574219, -1.34836857991926, 218, 53, 'PPL', 'P'),
(50733, 'Red Fox Meadow', 39.4230613708496, 0.688062222137115, -77.0327835083008, -1.34447570419584, 218, 25, 'PPL', 'P'),
(11491, 'Red Gate', 34.6463890075684, 0.604693562108839, -92.4441680908203, -1.61345510745189, 218, 4, 'PPL', 'P'),
(97414, 'Red Gate', 26.4963893890381, 0.462449234729203, -98.1336135864258, -1.71275466396297, 218, 51, 'PPL', 'P'),
(24241, 'Red Gate Estates', 33.5283317565918, 0.585179781853501, -84.4291687011719, -1.47356697855719, 218, 13, 'PPL', 'P'),
(42756, 'Red Gum', 31.6800003051758, 0.552920312358126, -91.5341720581055, -1.59757268050093, 218, 22, 'PPL', 'P'),
(11492, 'Red Gum Farm', 34.9638900756836, 0.610235001126048, -90.4800033569336, -1.57917396579401, 218, 4, 'PPL', 'P'),
(17769, 'Red Head', 30.4863891601563, 0.532087867889035, -85.8419418334961, -1.49822452129996, 218, 12, 'PPL', 'P'),
(5313, 'Red Hill', 33.8419418334961, 0.590653310262913, -86.9250030517578, -1.51712750555929, 218, 2, 'PPL', 'P'),
(11494, 'Red Hill', 33.7433280944824, 0.588932175829422, -93.0244369506836, -1.6235827096033, 218, 4, 'PPL', 'P'),
(24242, 'Red Hill', 34.435001373291, 0.601004151892697, -83.2605590820313, -1.45317089303271, 218, 13, 'PPL', 'P'),
(30938, 'Red Hill', 38.9333305358887, 0.679514806618506, -86.5977783203125, -1.51141635660162, 218, 19, 'PPL', 'P'),
(37880, 'Red Hill', 37.8555603027344, 0.660704167469976, -85.9674987792969, -1.50041590340294, 218, 21, 'PPL', 'P'),
(50736, 'Red Hill', 39.4680595397949, 0.688847588342579, -77.6975021362305, -1.35607723285255, 218, 25, 'PPL', 'P'),
(68121, 'Red Hill', 35.1477813720703, 0.613444509713757, -78.3894424438477, -1.36815386944773, 218, 33, 'PPL', 'P'),
(77054, 'Red Hill', 35.3472213745117, 0.616925394416545, -94.9402770996094, -1.65702042814396, 218, 42, 'PPL', 'P'),
(83229, 'Red Hill', 34.7577781677246, 0.606637669704596, -81.4972229003906, -1.42239487084354, 218, 48, 'PPL', 'P'),
(90242, 'Red Hill', 36.3097190856934, 0.633724148519574, -88.7074966430664, -1.54823788762333, 218, 50, 'PPL', 'P'),
(97417, 'Red Hill', 31.4872207641602, 0.54955567463692, -96.5127792358398, -1.68446576791582, 218, 51, 'PPL', 'P'),
(105618, 'Red Hill', 36.9208297729492, 0.644390042106314, -80.8477783203125, -1.41105992461194, 218, 53, 'PPL', 'P'),
(111071, 'Red Hill', 39.2477798461914, 0.685002982413914, -81.4741668701172, -1.42199246720283, 218, 58, 'PPL', 'P'),
(146154, 'Red Hill', 40.3841705322266, 0.704836741474224, -74.1316680908203, -1.29384168818043, 218, 37, 'PPL', 'P'),
(166342, 'Red Hill', 40.3727798461914, 0.70463793649885, -75.4813919067383, -1.31739881276078, 218, 45, 'PPL', 'P'),
(189324, 'Red Hill', 34.2186088562012, 0.597227389992801, -108.871673583984, -1.90016916619706, 218, 38, 'PPL', 'P'),
(11495, 'Red Hill (historical)', 34.1233291625977, 0.595564445629129, -94.2180633544922, -1.6444154203885, 218, 4, 'PPL', 'P'),
(50737, 'Red Hill Acres', 39.7183303833008, 0.6932156385835, -76.1961135864258, -1.32987305930671, 218, 25, 'PPL', 'P'),
(50739, 'Red Hill Estates', 39.7130584716797, 0.693123626367838, -76.1880569458008, -1.32973244440116, 218, 25, 'PPL', 'P'),
(14467, 'Red Hill Manor', 38.7613906860352, 0.676513890123177, -75.2061080932617, -1.31259420383817, 218, 10, 'PPL', 'P'),
(105619, 'Red Hill Mobile Home Park', 37.2611083984375, 0.650329024495246, -77.3513870239258, -1.35003638455192, 218, 53, 'PPL', 'P'),
(105620, 'Red Hill Village', 37.127498626709, 0.647997094065745, -76.5116729736328, -1.33538060959905, 218, 53, 'PPL', 'P'),
(152008, 'Red Hook', 41.9949989318848, 0.732951000732891, -73.8758316040039, -1.28937649913875, 218, 40, 'PPL', 'P'),
(152010, 'Red Hook Mills', 42.0099983215332, 0.733212789468046, -73.8716735839844, -1.28930392799905, 218, 40, 'PPL', 'P'),
(166344, 'Red Hot', 40.6630592346191, 0.709704267577589, -79.8361129760742, -1.39340303342666, 218, 45, 'PPL', 'P'),
(111074, 'Red House', 38.5391693115234, 0.67263539546964, -81.8969421386719, -1.42937128763511, 218, 58, 'PPL', 'P'),
(152012, 'Red House', 42.1122207641602, 0.734996907661317, -78.8022232055664, -1.37535825282861, 218, 40, 'PPL', 'P'),
(200158, 'Red House', 40.996940612793, 0.715531596937819, -117.247222900391, -2.04635007843151, 218, 39, 'PPL', 'P'),
(111072, 'Red Jacket', 37.6483306884766, 0.65708732839354, -82.1402816772461, -1.43361836378351, 218, 58, 'PPL', 'P'),
(111073, 'Red Knob', 38.7247200012207, 0.675873865934204, -81.5130615234375, -1.42267130696469, 218, 58, 'PPL', 'P'),
(97418, 'Red Lake', 31.670560836792, 0.552755562555191, -95.9552764892578, -1.67473550939905, 218, 51, 'PPL', 'P'),
(137648, 'Red Lake', 47.8763885498047, 0.835600614158205, -95.0166702270508, -1.6583537397437, 218, 28, 'PPL', 'P'),
(178965, 'Red Lake', 36.3224983215332, 0.633947188260868, -110.948608398438, -1.93641851705857, 218, 5, 'PPL', 'P'),
(189325, 'Red Lake (historical)', 33.9377784729004, 0.592325975164565, -103.440002441406, -1.80536862087351, 218, 38, 'PPL', 'P'),
(137650, 'Red Lake Falls', 47.8822212219238, 0.835702413490873, -96.2738876342773, -1.68029632291319, 218, 28, 'PPL', 'P'),
(192756, 'Red Lake Village', 37.1972198486328, 0.649213958946829, -109.323059082031, -1.90804732933374, 218, 52, 'PPL', 'P'),
(105621, 'Red Lane', 37.5466690063477, 0.655312997317274, -77.8497161865234, -1.35873386919796, 218, 53, 'PPL', 'P'),
(209689, 'Red Lane', 43.6786117553711, 0.762335587831526, -108.205276489258, -1.88853834276836, 218, 59, 'PPL', 'P'),
(11497, 'Red Leaf', 33.2722206115723, 0.580709799121857, -91.1963882446289, -1.59167724079583, 218, 4, 'PPL', 'P'),
(166345, 'Red Ledge Manor Estates', 41.1533317565918, 0.718261137318069, -75.216667175293, -1.31277849458561, 218, 45, 'PPL', 'P'),
(5317, 'Red Level', 32.1341705322266, 0.560847078184692, -86.2233276367188, -1.50488095928656, 218, 2, 'PPL', 'P'),
(17770, 'Red Level', 28.9694404602051, 0.50561211849104, -82.6363906860352, -1.44227709943569, 218, 12, 'PPL', 'P'),
(97419, 'Red Level', 32.3400001525879, 0.564439482758127, -94.9677810668945, -1.65750046293044, 218, 51, 'PPL', 'P'),
(61496, 'Red Lick', 31.7922191619873, 0.554878900892311, -90.9791717529297, -1.58788609782604, 218, 30, 'PPL', 'P'),
(97420, 'Red Lick', 33.4647216796875, 0.584069576574074, -94.1708297729492, -1.64359103887307, 218, 51, 'PPL', 'P'),
(11500, 'Red Line', 35.7147216796875, 0.623339484743947, -90.0911102294922, -1.57238650028178, 218, 4, 'PPL', 'P'),
(117472, 'Red Line', 41.7172203063965, 0.728102849126456, -95.1508331298828, -1.66069532413216, 218, 16, 'PPL', 'P'),
(363, 'Red Lion', 39.6083297729492, 0.691295765753662, -75.6641693115234, -1.32058888027254, 218, 10, 'PPL', 'P'),
(74028, 'Red Lion', 39.4913902282715, 0.689254785673252, -84.2497177124023, -1.47043496795721, 218, 41, 'PPL', 'P'),
(146155, 'Red Lion', 40.4436111450195, 0.705874175876865, -74.470832824707, -1.29976122949341, 218, 37, 'PPL', 'P'),
(166347, 'Red Lion', 40.4805603027344, 0.706519060334827, -75.6163864135742, -1.31975491137718, 218, 45, 'PPL', 'P'),
(194394, 'Red Lion', 40.8916702270508, 0.713694282101773, -102.676391601563, -1.79204109751432, 218, 7, 'PPL', 'P'),
(50740, 'Red Lion Inn Estates', 39.3375015258789, 0.68656892113488, -77.0138931274414, -1.34414600485289, 218, 25, 'PPL', 'P'),
(197345, 'Red Lodge', 45.1858291625977, 0.788641494131001, -109.246109008789, -1.90670429719601, 218, 31, 'PPL', 'P'),
(178966, 'Red Mesa', 36.9963912963867, 0.645708839478122, -109.36833190918, -1.90883748922916, 218, 5, 'PPL', 'P'),
(146156, 'Red Mill', 40.7191696166992, 0.710683578489439, -74.9211120605469, -1.30762008471218, 218, 37, 'PPL', 'P'),
(152014, 'Red Mill', 43.4183311462402, 0.757792834223096, -76.1430587768555, -1.32894707819569, 218, 40, 'PPL', 'P'),
(166350, 'Red Mill', 41.1549987792969, 0.718290232352978, -78.8222198486328, -1.37570726008947, 218, 45, 'PPL', 'P'),
(189327, 'Red Mill', 34.295280456543, 0.598565561861539, -106.749443054199, -1.86312925596597, 218, 38, 'PPL', 'P'),
(14468, 'Red Mill Farms', 38.7488899230957, 0.676295710650872, -75.2061080932617, -1.31259420383817, 218, 10, 'PPL', 'P'),
(105623, 'Red Mills', 37.639720916748, 0.656937059529032, -79.5608291625977, -1.38859842450405, 218, 53, 'PPL', 'P'),
(152018, 'Red Mills', 41.628059387207, 0.726546697522496, -74.2727813720703, -1.29630457955654, 218, 40, 'PPL', 'P'),
(176031, 'Red Mound', 43.4724998474121, 0.758738256410074, -91.1447219848633, -1.59077549445073, 218, 57, 'PPL', 'P'),
(68124, 'Red Mountain', 36.2249984741211, 0.632245494903335, -78.9038925170898, -1.37713271706293, 218, 33, 'PPL', 'P'),
(184453, 'Red Mountain', 35.3583297729492, 0.617119272543903, -117.615829467773, -2.05278347667682, 218, 6, 'PPL', 'P'),
(187246, 'Red Mountain', 37.9036102294922, 0.661542796897242, -107.701942443848, -1.87975350643857, 218, 7, 'PPL', 'P'),
(197346, 'Red Mountain (historical)', 45.7944412231445, 0.799263778454891, -112.485000610352, -1.96323361975847, 218, 31, 'PPL', 'P'),
(192105, 'Red Mud', 33.4266700744629, 0.583405450777236, -100.998893737793, -1.76276323659637, 218, 51, 'PPL', 'P'),
(11501, 'Red Neck (historical)', 33.521671295166, 0.585063534871919, -91.8655624389648, -1.60335653375637, 218, 4, 'PPL', 'P'),
(5318, 'Red Oak', 31.139720916748, 0.5434906581494, -86.460563659668, -1.50902150899136, 218, 2, 'PPL', 'P'),
(11502, 'Red Oak', 34.420280456543, 0.600747223426532, -93.021110534668, -1.62352465269154, 218, 4, 'PPL', 'P'),
(24245, 'Red Oak', 33.3499984741211, 0.582067278908498, -85.2622222900391, -1.48810650652848, 218, 13, 'PPL', 'P'),
(42757, 'Red Oak', 30.4655609130859, 0.53172434640024, -91.067497253418, -1.58942766862304, 218, 22, 'PPL', 'P'),
(57117, 'Red Oak', 37.2286109924316, 0.649761837762086, -94.0111083984375, -1.64080337500203, 218, 29, 'PPL', 'P'),
(68126, 'Red Oak', 35.5722198486328, 0.620852358601921, -77.4236068725586, -1.35129685869586, 218, 33, 'PPL', 'P'),
(77056, 'Red Oak', 34.9508285522461, 0.610007034536737, -95.0800018310547, -1.65945908475414, 218, 42, 'PPL', 'P'),
(83230, 'Red Oak', 32.4144401550293, 0.565738705895922, -80.658332824707, -1.40775347696056, 218, 48, 'PPL', 'P'),
(90243, 'Red Oak', 35.2438888549805, 0.615121901726344, -86.8088912963867, -1.5151009731278, 218, 50, 'PPL', 'P'),
(97421, 'Red Oak', 32.5175018310547, 0.567537471475189, -96.8041687011719, -1.68955147349149, 218, 51, 'PPL', 'P'),
(117471, 'Red Oak', 41.0097198486328, 0.715754636679113, -95.2252807617188, -1.66199468042801, 218, 16, 'PPL', 'P'),
(121183, 'Red Oak', 42.392219543457, 0.739883808261613, -89.6716690063477, -1.56506586991932, 218, 18, 'PPL', 'P'),
(132789, 'Red Oak', 44.7097206115723, 0.780331832318709, -84.2922210693359, -1.47117679147885, 218, 27, 'PPL', 'P'),
(166351, 'Red Oak', 41.4402809143066, 0.723269344906017, -75.4866714477539, -1.3174909581345, 218, 45, 'PPL', 'P'),
(83237, 'Red Oak Corner', 32.9638900756836, 0.575328416086161, -80.4466705322266, -1.40405927305445, 218, 48, 'PPL', 'P'),
(71323, 'Red Oak Grove', 39.8352813720703, 0.695256818400991, -74.4097213745117, -1.29869463347683, 218, 37, 'PPL', 'P'),
(50743, 'Red Oak Hills', 39.4702796936035, 0.68888633733644, -76.9000015258789, -1.34215822141525, 218, 25, 'PPL', 'P'),
(50741, 'Red Oak Hills West', 39.4724998474121, 0.688925086330301, -76.9141693115234, -1.34240549592246, 218, 25, 'PPL', 'P'),
(105624, 'Red Oak Hollow', 36.726390838623, 0.640996442508254, -79.1961135864258, -1.38223293686654, 218, 53, 'PPL', 'P'),
(83231, 'Red Oaks', 34.9213905334473, 0.609493244183434, -81.0930633544922, -1.41534095606425, 218, 48, 'PPL', 'P'),
(152019, 'Red Oaks Mill', 41.6555595397949, 0.727026665729955, -73.8752822875977, -1.28936691175883, 218, 40, 'PPL', 'P'),
(33730, 'Red Onion', 37.5869407653809, 0.656015872107974, -94.6458282470703, -1.65188132618843, 218, 20, 'PPL', 'P'),
(57119, 'Red Onion', 35.9961090087891, 0.628250620110162, -90.3422164916992, -1.57676913132967, 218, 29, 'PPL', 'P'),
(24246, 'Red Ore (historical)', 34.0280609130859, 0.593901701002538, -85.0408325195313, -1.48424252610289, 218, 13, 'PPL', 'P'),
(132790, 'Red Park', 44.3519401550293, 0.774087385352745, -86.2427825927734, -1.50522051232555, 218, 27, 'PPL', 'P'),
(50742, 'Red Point', 39.5233306884766, 0.689812251868433, -75.978889465332, -1.32608178317888, 218, 25, 'PPL', 'P'),
(57120, 'Red Point', 37.6474990844727, 0.657072814165599, -91.1488876342773, -1.59084819874848, 218, 29, 'PPL', 'P'),
(192757, 'Red Point', 39.4283294677734, 0.68815416777375, -112.034721374512, -1.9553747645397, 218, 52, 'PPL', 'P'),
(83232, 'Red Point (historical)', 34.6402816772461, 0.604586969086208, -81.4458312988281, -1.4214979181884, 218, 48, 'PPL', 'P'),
(184454, 'Red Point (historical)', 39.1472206115723, 0.683247892676524, -120.700561523438, -2.10662220758997, 218, 6, 'PPL', 'P'),
(97422, 'Red Ranger', 31.0063896179199, 0.541163587988889, -97.1800003051758, -1.69611097241441, 218, 51, 'PPL', 'P'),
(83233, 'Red River', 34.9608306884766, 0.610181604746192, -80.9655609130859, -1.41311561865738, 218, 48, 'PPL', 'P'),
(157299, 'Red River', 40.0800018310547, 0.69952799615726, -84.4486083984375, -1.47390626528007, 218, 41, 'PPL', 'P'),
(176032, 'Red River', 44.8250007629395, 0.782343850522264, -88.7044372558594, -1.54818449124347, 218, 57, 'PPL', 'P'),
(189326, 'Red River', 36.7080612182617, 0.640676530282308, -105.405563354492, -1.83967413045537, 218, 38, 'PPL', 'P'),
(97423, 'Red River City', 33.8027801513672, 0.589969809969145, -96.5305633544922, -1.68477615934087, 218, 51, 'PPL', 'P'),
(90246, 'Red River Estates', 36.5244407653809, 0.637471748805534, -87.2375030517578, -1.52258165947178, 218, 50, 'PPL', 'P'),
(195517, 'Red River Hot Springs', 45.7877807617188, 0.799147531473309, -115.199172973633, -2.01060486396436, 218, 17, 'PPL', 'P'),
(42758, 'Red River Landing', 30.9591693878174, 0.540339439500051, -91.6650009155273, -1.59985607481957, 218, 22, 'PPL', 'P'),
(5320, 'Red Rock', 34.6977806091309, 0.605590514763977, -87.8638916015625, -1.53351420206266, 218, 2, 'PPL', 'P'),
(11509, 'Red Rock', 35.9144401550293, 0.626825229715724, -93.1352767944336, -1.62551722981914, 218, 4, 'PPL', 'P'),
(24253, 'Red Rock', 33.9794387817383, 0.593053084721184, -84.7161102294922, -1.47857505298709, 218, 13, 'PPL', 'P'),
(77060, 'Red Rock', 36.459171295166, 0.636332581649252, -97.1786117553711, -1.69608673764849, 218, 42, 'PPL', 'P'),
(97425, 'Red Rock', 29.9594402313232, 0.522890874091042, -97.4458312988281, -1.70075059850749, 218, 51, 'PPL', 'P'),
(111075, 'Red Rock', 39.0119400024414, 0.680886800633087, -80.2763900756836, -1.40108731843598, 218, 58, 'PPL', 'P'),
(137653, 'Red Rock', 47.9208297729492, 0.836376259825691, -89.7383270263672, -1.56622927184152, 218, 28, 'PPL', 'P'),
(152021, 'Red Rock', 42.3569412231445, 0.739268085417586, -73.5108337402344, -1.28300608465323, 218, 40, 'PPL', 'P'),
(166353, 'Red Rock', 41.9658317565918, 0.732441937490522, -78.5530624389648, -1.37100957708462, 218, 45, 'PPL', 'P'),
(176034, 'Red Rock', 42.6425018310547, 0.744252058239615, -90.0475006103516, -1.57162536884224, 218, 57, 'PPL', 'P'),
(178969, 'Red Rock', 34.8255615234375, 0.607820712439837, -111.815826416016, -1.95155432679792, 218, 5, 'PPL', 'P'),
(189328, 'Red Rock', 35.4541702270508, 0.618792004024582, -108.755279541016, -1.89813770691755, 218, 38, 'PPL', 'P'),
(197347, 'Red Rock', 44.9005584716797, 0.783662581315044, -112.818061828613, -1.96904663462784, 218, 31, 'PPL', 'P'),
(128642, 'Red Rock Corner', 44.4055595397949, 0.775023220159799, -68.345832824707, -1.19285981280875, 218, 26, 'PPL', 'P'),
(24248, 'Red Rock Hills', 33.9669418334961, 0.592834971827906, -84.7188873291016, -1.47862352251893, 218, 13, 'PPL', 'P'),
(195518, 'Red Rock Junction', 42.3544387817383, 0.739224409575709, -112.049171447754, -1.95562696589493, 218, 17, 'PPL', 'P'),
(197348, 'Red Rock Point', 48.6952781677246, 0.849892934201306, -113.815277099609, -1.98645132445789, 218, 31, 'PPL', 'P'),
(90244, 'Red Row', 35.5261116027832, 0.620047617899527, -87.1936111450195, -1.52181560118421, 218, 50, 'PPL', 'P'),
(166354, 'Red Run', 40.1841697692871, 0.70134606965443, -76.0824966430664, -1.32789006955904, 218, 45, 'PPL', 'P'),
(202542, 'Red Scaffold', 44.7669410705566, 0.781330517727489, -101.843330383301, -1.77750143638498, 218, 49, 'PPL', 'P'),
(202543, 'Red Shirt', 43.6674995422363, 0.762141643125141, -102.898330688477, -1.79591466531984, 218, 49, 'PPL', 'P'),
(111076, 'Red Spring', 37.8686103820801, 0.660931934322205, -80.916389465332, -1.4122574149961, 218, 58, 'PPL', 'P'),
(5321, 'Red Springs', 32.0297203063965, 0.559024077839506, -88.271110534668, -1.54062151322181, 218, 2, 'PPL', 'P'),
(11510, 'Red Springs', 33.9022216796875, 0.591705392051549, -93.0641708374023, -1.62427619675116, 218, 4, 'PPL', 'P'),
(68129, 'Red Springs', 34.814998626709, 0.607636355113376, -79.1833267211914, -1.3820097639672, 218, 33, 'PPL', 'P'),
(97431, 'Red Springs', 33.6127815246582, 0.586653708358805, -99.4116668701172, -1.73506090177931, 218, 51, 'PPL', 'P'),
(5322, 'Red Star', 33.7125015258789, 0.588394150710199, -87.1213912963867, -1.52055512704028, 218, 2, 'PPL', 'P'),
(11511, 'Red Star', 35.8666687011719, 0.625991460557447, -93.5305633544922, -1.63241628178104, 218, 4, 'PPL', 'P'),
(83234, 'Red Star', 34.0263900756836, 0.593872539388601, -81.466667175293, -1.42186157283525, 218, 48, 'PPL', 'P'),
(68131, 'Red Star Camp', 34.4544410705566, 0.601343438615573, -78.1497192382813, -1.36396991021716, 218, 33, 'PPL', 'P'),
(24249, 'Red Stone', 34.0602798461914, 0.594464027466708, -83.5083312988281, -1.45749533401078, 218, 13, 'PPL', 'P'),
(24250, 'Red Store Crossroads', 31.4044399261475, 0.548110876456038, -84.2761077880859, -1.47089556166774, 218, 13, 'PPL', 'P'),
(90245, 'Red Sulphur Springs', 35.0069389343262, 0.610986345448587, -88.2375030517578, -1.54003495199172, 218, 50, 'PPL', 'P'),
(28384, 'Red Top', 38.371940612793, 0.669716704072968, -88.0261077880859, -1.53634540861752, 218, 18, 'PPL', 'P'),
(57121, 'Red Top', 37.2997207641602, 0.65100293740909, -93.0102767944336, -1.62333556825414, 218, 29, 'PPL', 'P'),
(61497, 'Red Top', 30.9691696166992, 0.540513976419992, -89.4772186279297, -1.56167207058418, 218, 30, 'PPL', 'P'),
(83235, 'Red Top', 32.8025016784668, 0.572511657180212, -80.1227798461914, -1.3984063141666, 218, 48, 'PPL', 'P'),
(90247, 'Red Top', 36.5480613708496, 0.637884006142278, -87.6658325195313, -1.53005741896774, 218, 50, 'PPL', 'P'),
(97428, 'Red Top', 33.2255592346191, 0.579895404460511, -98.5683288574219, -1.72034187675055, 218, 51, 'PPL', 'P'),
(105626, 'Red Top', 36.7861099243164, 0.642038737179883, -76.5877838134766, -1.33670899435078, 218, 53, 'PPL', 'P'),
(197349, 'Red Top', 47.4124984741211, 0.827504204970201, -104.811111450195, -1.82929898748064, 218, 31, 'PPL', 'P'),
(190654, 'Red Top (historical)', 39.4602813720703, 0.688711833706013, -118.109443664551, -2.06139866964517, 218, 39, 'PPL', 'P'),
(83236, 'Red Town (historical)', 34.5916709899902, 0.603738552541936, -81.5680618286133, -1.42363124337961, 218, 48, 'PPL', 'P'),
(125, 'Red Valley', 37.1349983215332, 0.648127988433322, -79.8616714477539, -1.39384911290925, 218, 53, 'PPL', 'P'),
(146157, 'Red Valley', 40.1616706848145, 0.700953386551698, -74.470832824707, -1.29976122949341, 218, 37, 'PPL', 'P'),
(90248, 'Red Walnut', 35.4691696166992, 0.619053792759736, -88.1769409179688, -1.53897794335507, 218, 50, 'PPL', 'P'),
(111078, 'Red Warrior', 38.0547218322754, 0.664180191903775, -81.4580612182617, -1.42171137054977, 218, 58, 'PPL', 'P'),
(205486, 'Red Wash', 40.1986083984375, 0.701598071272579, -109.308609008789, -1.9077951279785, 218, 52, 'PPL', 'P'),
(199639, 'Red Willow', 40.2252807617188, 0.702063591831125, -100.496940612793, -1.75400250187445, 218, 35, 'PPL', 'P'),
(5323, 'Red Wine', 33.6177787780762, 0.586740926884505, -86.960563659668, -1.51774815525134, 218, 2, 'PPL', 'P'),
(11512, 'Red Wing', 34.0461082458496, 0.594216686380467, -94.2427825927734, -1.64484685248509, 218, 4, 'PPL', 'P'),
(137655, 'Red Wing', 44.5625, 0.777762347919973, -92.5336074829102, -1.61501611932484, 218, 28, 'PPL', 'P'),
(187247, 'Red Wing', 37.7361106872559, 0.658619378389635, -105.289436340332, -1.83764733170776, 218, 7, 'PPL', 'P'),
(68132, 'Redallia', 35.4847183227539, 0.619325168874816, -77.3766708374023, -1.35047767034455, 218, 33, 'PPL', 'P'),
(24252, 'Redan', 33.7452812194824, 0.588966264291376, -84.1316680908203, -1.46837461337987, 218, 13, 'PPL', 'P'),
(105627, 'Redart', 37.4700012207031, 0.653974892027564, -76.3019409179688, -1.33172009468074, 218, 53, 'PPL', 'P'),
(97429, 'Redbank', 33.5258293151855, 0.585136106011624, -94.2586135864258, -1.64512315544819, 218, 51, 'PPL', 'P'),
(184455, 'Redbanks', 36.4222183227539, 0.635687630612262, -119.143333435059, -2.07944345024322, 218, 6, 'PPL', 'P'),
(17771, 'Redbay', 30.5922203063965, 0.533934969842087, -85.9449996948242, -1.5000232203002, 218, 12, 'PPL', 'P'),
(37881, 'Redbird', 36.7619400024414, 0.641616892463215, -84.2200012207031, -1.46991631733491, 218, 21, 'PPL', 'P'),
(57122, 'Redbird', 38.1816711425781, 0.666395875351694, -91.5702819824219, -1.5982029175729, 218, 29, 'PPL', 'P'),
(111079, 'Redbird', 37.7894401550293, 0.659550153190618, -81.4402770996094, -1.42140097912472, 218, 58, 'PPL', 'P'),
(142829, 'Redbird', 42.7616691589355, 0.74633192047194, -98.4422225952148, -1.71814090726766, 218, 35, 'PPL', 'P'),
(152022, 'Redbird', 42.230281829834, 0.737057461975739, -79.2994384765625, -1.38403629639869, 218, 40, 'PPL', 'P'),
(157300, 'Redbird', 41.8236083984375, 0.729959671617487, -81.0766677856445, -1.41505479940512, 218, 41, 'PPL', 'P'),
(166357, 'Redbird', 40.3772201538086, 0.704715434486571, -78.6622161865234, -1.37291466937041, 218, 45, 'PPL', 'P'),
(209690, 'Redbird', 43.2425003051758, 0.75472400711997, -104.28556060791, -1.82012639489613, 218, 59, 'PPL', 'P'),
(11520, 'Redbird (historical)', 34.5208282470703, 0.602502113426839, -93.8052825927734, -1.63721103700762, 218, 4, 'PPL', 'P'),
(77062, 'Redbird Smith', 35.5661087036133, 0.620745699000264, -95.0202789306641, -1.65841672350348, 218, 42, 'PPL', 'P'),
(24254, 'Redbone', 32.9900016784668, 0.575784149527701, -84.0975036621094, -1.4677783316118, 218, 13, 'PPL', 'P'),
(61498, 'Redbone', 32.2174987792969, 0.562301430455984, -90.8908309936523, -1.58634426071294, 218, 30, 'PPL', 'P'),
(24255, 'Redbone Crossroads', 32.8691711425781, 0.573675258839495, -84.2555618286133, -1.47053696702696, 218, 13, 'PPL', 'P'),
(50744, 'Redbridge', 39.1319389343262, 0.682981177093353, -76.6986083984375, -1.33864324825051, 218, 25, 'PPL', 'P'),
(5324, 'Redbud', 34.0666694641113, 0.594575547337355, -86.2583312988281, -1.50549188844063, 218, 2, 'PPL', 'P'),
(24256, 'Redbud', 34.5327796936035, 0.60271070551922, -84.8163909912109, -1.48032528245549, 218, 13, 'PPL', 'P'),
(37882, 'Redbud', 36.8597183227539, 0.643323446089738, -83.1688919067383, -1.45157099900785, 218, 21, 'PPL', 'P'),
(184456, 'Redbud Park (historical)', 38.5194396972656, 0.672291048740693, -122.136108398438, -2.13167722712543, 218, 6, 'PPL', 'P'),
(68133, 'Redbug', 34.3083305358887, 0.598793328713768, -78.6122207641602, -1.37204208463925, 218, 33, 'PPL', 'P'),
(37883, 'Redbush', 37.9397201538086, 0.662173033969209, -82.9491729736328, -1.44773618019619, 218, 21, 'PPL', 'P'),
(74029, 'Redbush', 39.2747192382813, 0.685473163504367, -81.7005615234375, -1.42594379931218, 218, 41, 'PPL', 'P'),
(137657, 'Redby', 47.8786087036133, 0.835639363152066, -94.9127807617188, -1.65654052651552, 218, 28, 'PPL', 'P'),
(166358, 'Redclyffe', 41.394718170166, 0.722474125004519, -79.1524963378906, -1.38147167226895, 218, 45, 'PPL', 'P'),
(193900, 'Redcrest', 40.4005584716797, 0.705122764975299, -123.948890686035, -2.16331624666585, 218, 6, 'PPL', 'P'),
(68134, 'Redcross', 35.8822212219238, 0.626262903251554, -79.6961135864258, -1.39095958312652, 218, 33, 'PPL', 'P'),
(30943, 'Redcuff Corner', 39.1549987792969, 0.683383647313091, -87.147216796875, -1.52100586705478, 218, 19, 'PPL', 'P'),
(57123, 'Redd', 36.8477783203125, 0.643115053734439, -90.0605621337891, -1.57185333543155, 218, 29, 'PPL', 'P'),
(208530, 'Redd', 46.3472213745117, 0.808911612135921, -118.756942749023, -2.07269966057286, 218, 56, 'PPL', 'P'),
(42760, 'Reddell', 30.6738891601563, 0.535360360236525, -92.4261093139648, -1.61313992233688, 218, 22, 'PPL', 'P'),
(178970, 'Reddells Ranch Acres', 34.5722198486328, 0.603399066081978, -111.862503051758, -1.95236898777538, 218, 5, 'PPL', 'P'),
(14470, 'Redden', 38.7413902282715, 0.676164816283295, -75.4175033569336, -1.31628374721237, 218, 10, 'PPL', 'P'),
(77063, 'Redden', 34.5063896179199, 0.602250111808691, -95.8444366455078, -1.67280098918322, 218, 42, 'PPL', 'P'),
(90249, 'Redden (historical)', 35.9855613708496, 0.62806652909981, -87.4416732788086, -1.52614510216836, 218, 50, 'PPL', 'P'),
(14471, 'Redden Crossroads', 38.7391700744629, 0.676126067289434, -75.4233322143555, -1.31638547996601, 218, 10, 'PPL', 'P'),
(17772, 'Reddick', 29.3663902282715, 0.512540198908827, -82.1975021362305, -1.43461704919229, 218, 12, 'PPL', 'P'),
(121184, 'Reddick', 41.0972213745117, 0.717281826406219, -88.2505569458008, -1.54026278542297, 218, 18, 'PPL', 'P'),
(11513, 'Redding', 35.6800003051758, 0.622733482437899, -93.7769393920898, -1.63671635483514, 218, 4, 'PPL', 'P'),
(24257, 'Redding', 32.5897216796875, 0.568797945619124, -83.5955581665039, -1.45901773004793, 218, 13, 'PPL', 'P'),
(30939, 'Redding', 38.7744407653809, 0.676741656975406, -86.5038909912109, -1.50977771358289, 218, 19, 'PPL', 'P'),
(61499, 'Redding', 33.7224998474121, 0.588568654340627, -89.5130615234375, -1.56229764712424, 218, 30, 'PPL', 'P'),
(113970, 'Redding', 41.3025016784668, 0.72086464359973, -73.3838882446289, -1.28079046778434, 218, 8, 'PPL', 'P'),
(117476, 'Redding', 40.6047210693359, 0.708686074513825, -94.3874969482422, -1.64737259446293, 218, 16, 'PPL', 'P'),
(128640, 'Redding', 44.4111099243164, 0.775120092644451, -70.5111083984375, -1.23065100078336, 218, 26, 'PPL', 'P'),
(193901, 'Redding', 40.586669921875, 0.708371022556868, -122.390556335449, -2.13611818140119, 218, 6, 'PPL', 'P'),
(68135, 'Redding Hills', 35.7236099243164, 0.623494613877444, -79.8363876342773, -1.39340782711663, 218, 33, 'PPL', 'P'),
(113971, 'Redding Ridge', 41.3138885498047, 0.721063381996077, -73.350830078125, -1.28021349393417, 218, 8, 'PPL', 'P'),
(30941, 'Reddington', 39.0325012207031, 0.681245661589975, -85.8327789306641, -1.49806459847651, 218, 19, 'PPL', 'P'),
(28385, 'Reddish', 39.1377792358398, 0.683083109584076, -90.5766677856445, -1.58086107834458, 218, 18, 'PPL', 'P'),
(61500, 'Reddochs', 31.7069396972656, 0.553390493448579, -89.4097213745117, -1.56049402127598, 218, 30, 'PPL', 'P'),
(5325, 'Reddock Springs', 31.8216705322266, 0.55539292427221, -86.6916732788086, -1.5130551327784, 218, 2, 'PPL', 'P'),
(166359, 'Redds Mill', 40.146110534668, 0.700681810699537, -79.9780578613281, -1.39588043903071, 218, 45, 'PPL', 'P'),
(33732, 'Redel', 38.8305587768555, 0.67772110104531, -94.6333312988281, -1.65166321329515, 218, 20, 'PPL', 'P'),
(105629, 'Redeye', 36.9049987792969, 0.644113739143219, -79.4763870239258, -1.3871246311568, 218, 53, 'PPL', 'P'),
(11514, 'Redfern', 34.9933280944824, 0.610748791479352, -90.8352813720703, -1.5853747369181, 218, 4, 'PPL', 'P'),
(202545, 'Redfern', 44.002498626709, 0.767988480140355, -103.644439697266, -1.808936724102, 218, 49, 'PPL', 'P'),
(11515, 'Redfield', 34.4449996948242, 0.601178655523125, -92.1830596923828, -1.60889790619455, 218, 4, 'PPL', 'P'),
(24259, 'Redfield', 33.9555587768555, 0.592636300010586, -84.3452835083008, -1.47210290574792, 218, 13, 'PPL', 'P'),
(33733, 'Redfield', 37.836669921875, 0.660374468127024, -94.8808288574219, -1.65598286058326, 218, 20, 'PPL', 'P'),
(74030, 'Redfield', 39.788330078125, 0.694437363733574, -82.1686096191406, -1.43411277963989, 218, 41, 'PPL', 'P'),
(97430, 'Redfield', 31.6794395446777, 0.55291052524112, -94.6647186279297, -1.65221102553138, 218, 51, 'PPL', 'P'),
(117477, 'Redfield', 41.5894393920898, 0.725872651450597, -94.1958312988281, -1.64402739781768, 218, 16, 'PPL', 'P'),
(152023, 'Redfield', 43.5330581665039, 0.759795198467699, -75.8219375610352, -1.32334245568162, 218, 40, 'PPL', 'P'),
(171160, 'Redfield', 44.8758316040039, 0.783231016060396, -98.5183334350586, -1.71946929201939, 218, 49, 'PPL', 'P'),
(137658, 'Redfield Court Mobile Home Park', 45.3855590820313, 0.79212743883986, -92.7494430541992, -1.61878316068676, 218, 28, 'PPL', 'P'),
(57124, 'Redford', 37.3199996948242, 0.651356871517962, -90.8983306884766, -1.58647515508052, 218, 29, 'PPL', 'P'),
(132792, 'Redford', 42.3833312988281, 0.739728679128115, -83.2966690063477, -1.45380113010468, 218, 27, 'PPL', 'P'),
(152025, 'Redford', 44.6083297729492, 0.778562228353378, -73.8047180175781, -1.28813533291272, 218, 40, 'PPL', 'P'),
(192106, 'Redford', 29.4497203826904, 0.513994584469633, -104.188888549805, -1.81843914918751, 218, 51, 'PPL', 'P'),
(37885, 'Redfox', 37.2147216796875, 0.649519423523861, -82.9438934326172, -1.44764403482247, 218, 21, 'PPL', 'P'),
(50749, 'Redgate', 38.4375, 0.67086093123532, -76.8000030517578, -1.34041291879487, 218, 25, 'PPL', 'P'),
(125929, 'Redgate Corner', 41.6041717529297, 0.726129779653844, -70.9444427490234, -1.23821411196308, 218, 23, 'PPL', 'P'),
(121185, 'Redgate Ridge', 41.9563903808594, 0.732277154398074, -88.3330612182617, -1.54170275662438, 218, 18, 'PPL', 'P'),
(176036, 'Redgranite', 44.0419387817383, 0.768676840703113, -89.0983276367188, -1.5550591752814, 218, 57, 'PPL', 'P'),
(157301, 'Redhaw', 40.8974990844727, 0.713796014855414, -82.1563873291016, -1.43389946043657, 218, 41, 'PPL', 'P'),
(50746, 'Redhill', 38.5661087036133, 0.673105576560094, -77.1291732788086, -1.34615802305644, 218, 25, 'PPL', 'P'),
(61501, 'Redhill', 31.1297206878662, 0.543316121229459, -89.0641708374023, -1.55446302667139, 218, 30, 'PPL', 'P'),
(50747, 'Redhill Estates', 38.5663909912109, 0.67311050340811, -77.1311111450195, -1.34619184520228, 218, 25, 'PPL', 'P'),
(37884, 'Redhouse', 37.832218170166, 0.660296770402221, -84.272216796875, -1.47082765105994, 218, 21, 'PPL', 'P'),
(50748, 'Redhouse', 39.3086090087891, 0.686064651582474, -79.4541702270508, -1.38673687490209, 218, 25, 'PPL', 'P'),
(593, 'Redich', 30.416109085083, 0.530861249180459, -92.5644378662109, -1.6155542110231, 218, 22, 'PPL', 'P'),
(202546, 'Redig', 45.271110534668, 0.790129934864247, -103.547782897949, -1.80724974470949, 218, 49, 'PPL', 'P'),
(57125, 'Redings Mill', 37.021671295166, 0.64615005869172, -94.5219421386719, -1.64971910569939, 218, 29, 'PPL', 'P'),
(113336, 'Redington', 40.6380615234375, 0.709267975212007, -75.288330078125, -1.31402924819156, 218, 45, 'PPL', 'P'),
(128641, 'Redington', 44.9844398498535, 0.785126587545287, -70.4358291625977, -1.22933713025957, 218, 26, 'PPL', 'P'),
(178971, 'Redington', 32.4275016784668, 0.565966672485233, -110.492500305176, -1.92845792908616, 218, 5, 'PPL', 'P'),
(199643, 'Redington', 41.5838890075684, 0.725775778965945, -103.272499084473, -1.80244513578688, 218, 35, 'PPL', 'P'),
(17773, 'Redington Beach', 27.8083305358887, 0.485346927334136, -82.811393737793, -1.4453314788899, 218, 12, 'PPL', 'P'),
(17774, 'Redington Shores', 27.8258304595947, 0.485652358621655, -82.8291702270508, -1.4456417371569, 218, 12, 'PPL', 'P'),
(105630, 'Rediviva', 38.6847190856934, 0.67517571825444, -78.2022171020508, -1.3648861707902, 218, 53, 'PPL', 'P'),
(123522, 'Redkey', 40.3488883972168, 0.704220952051171, -85.1500015258789, -1.48614788470478, 218, 19, 'PPL', 'P'),
(11516, 'Redland', 33.8066711425781, 0.590037720576942, -93.2774963378906, -1.62799942911314, 218, 4, 'PPL', 'P'),
(17775, 'Redland', 25.5280609130859, 0.44554871458302, -80.4905624389648, -1.40482533134201, 218, 12, 'PPL', 'P'),
(24258, 'Redland', 31.639720916748, 0.552217304409372, -81.9544372558594, -1.43037476673385, 218, 13, 'PPL', 'P'),
(42762, 'Redland', 30.5677795410156, 0.533508398014484, -92.398063659668, -1.61265043332853, 218, 22, 'PPL', 'P'),
(50750, 'Redland', 39.1452789306641, 0.683214003951653, -77.1444396972656, -1.3464244723235, 218, 25, 'PPL', 'P'),
(68136, 'Redland', 35.9877815246582, 0.628105278093671, -80.4727783203125, -1.40451493991697, 218, 33, 'PPL', 'P'),
(77066, 'Redland', 33.9099998474121, 0.591841146688116, -94.6736068725586, -1.65236615466488, 218, 42, 'PPL', 'P'),
(97435, 'Redland', 32.3766708374023, 0.565079506947101, -95.4983291625977, -1.66676027404065, 218, 51, 'PPL', 'P'),
(105631, 'Redland', 37.9538917541504, 0.66242037505545, -78.5297164916992, -1.37060211343784, 218, 53, 'PPL', 'P'),
(201458, 'Redland', 45.3436088562012, 0.791395269277171, -122.491668701172, -2.13788292509754, 218, 43, 'PPL', 'P'),
(166360, 'Redland Village', 40.1716690063477, 0.701127890182126, -76.8066711425781, -1.3405292989345, 218, 45, 'PPL', 'P'),
(184457, 'Redlands', 34.0555610656738, 0.594381669209997, -117.181671142578, -2.04520598442721, 218, 6, 'PPL', 'P'),
(187248, 'Redlands', 39.0788917541504, 0.682055329140387, -108.63500213623, -1.8960384701883, 218, 7, 'PPL', 'P'),
(97436, 'Redlawn', 31.6858291625977, 0.553022045111767, -95.0961074829102, -1.6597401814072, 218, 51, 'PPL', 'P'),
(105632, 'Redlawn', 36.6319389343262, 0.639347945793495, -78.2425003051758, -1.36558924531799, 218, 53, 'PPL', 'P'),
(57126, 'Redman', 39.8655586242676, 0.69578525614029, -92.336669921875, -1.61157891046393, 218, 29, 'PPL', 'P'),
(132794, 'Redman', 43.9291687011719, 0.76670863149949, -82.8341674804688, -1.4457289556826, 218, 27, 'PPL', 'P'),
(184459, 'Redman', 34.7638893127441, 0.606744329306254, -117.968887329102, -2.05894549880704, 218, 6, 'PPL', 'P'),
(117478, 'Redman (historical)', 41.9691696166992, 0.732500194139368, -92.2991714477539, -1.61092443862605, 218, 16, 'PPL', 'P'),
(152026, 'Redman Corners', 43.2461090087891, 0.754786990879751, -77.9641723632813, -1.36073150633163, 218, 40, 'PPL', 'P'),
(11521, 'Redman Point', 35.2405586242676, 0.615063778235552, -90.1130599975586, -1.57276959600459, 218, 4, 'PPL', 'P'),
(187249, 'Redmesa', 37.0944404602051, 0.647420120215579, -108.169723510742, -1.88791782623437, 218, 7, 'PPL', 'P'),
(28386, 'Redmon', 39.6452789306641, 0.691940650211625, -87.8616714477539, -1.5334754530688, 218, 18, 'PPL', 'P'),
(68138, 'Redmon', 35.7955589294434, 0.624750360910443, -82.7172164916992, -1.4436877758651, 218, 33, 'PPL', 'P'),
(123523, 'Redmon Park', 41.378059387207, 0.72218337439251, -85.7794418334961, -1.49713369051747, 218, 19, 'PPL', 'P'),
(111080, 'Redmond', 38.8041687011719, 0.677260507334781, -82.1341705322266, -1.43351170418186, 218, 58, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(166361, 'Redmond', 41.0833282470703, 0.717039345588967, -80.0352783203125, -1.39687912443949, 218, 45, 'PPL', 'P'),
(192758, 'Redmond', 39.0061111450195, 0.680785067879446, -111.861106872559, -1.9523446198514, 218, 52, 'PPL', 'P'),
(194395, 'Redmond', 40.478889465332, 0.706489898720891, -105.040283203125, -1.83329878912183, 218, 7, 'PPL', 'P'),
(201459, 'Redmond', 44.2727813720703, 0.77270580395824, -121.172782897949, -2.11486402537349, 218, 43, 'PPL', 'P'),
(208531, 'Redmond', 47.6741714477539, 0.832071259923577, -122.120277404785, -2.13140092416234, 218, 56, 'PPL', 'P'),
(152027, 'Redmond Corner', 43.4644393920898, 0.75859757492549, -75.3902816772461, -1.3158086392739, 218, 40, 'PPL', 'P'),
(57127, 'Redmondville', 37.625560760498, 0.656689918179873, -90.9691696166992, -1.58771152761659, 218, 29, 'PPL', 'P'),
(5327, 'Redmont Park', 33.503059387207, 0.584738695797956, -86.7752838134766, -1.51451441189771, 218, 2, 'PPL', 'P'),
(42764, 'Redoak', 31.9461097717285, 0.557564798720197, -93.272216796875, -1.62790728373943, 218, 22, 'PPL', 'P'),
(74031, 'Redoak', 38.8063888549805, 0.677299256328642, -83.7922210693359, -1.46245014521888, 218, 41, 'PPL', 'P'),
(208532, 'Redondo', 47.3486099243164, 0.826389139421784, -122.322219848633, -2.134925484707, 218, 56, 'PPL', 'P'),
(184460, 'Redondo Beach', 33.8491706848145, 0.590779477519556, -118.387496948242, -2.06625161494157, 218, 6, 'PPL', 'P'),
(184461, 'Redondo Junction', 34.0158309936523, 0.593688248641168, -118.226387023926, -2.0634397163046, 218, 6, 'PPL', 'P'),
(137659, 'Redore', 47.4436111450195, 0.828047223516468, -92.8988876342773, -1.62139146065839, 218, 28, 'PPL', 'P'),
(202547, 'Redowl', 44.6977806091309, 0.78012343996341, -102.552780151367, -1.78988367071525, 218, 49, 'PPL', 'P'),
(132795, 'Redridge', 47.1505584716797, 0.822932489484916, -88.7622222900391, -1.54919303034828, 218, 27, 'PPL', 'P'),
(189329, 'Redrock', 32.6861114501953, 0.570480264479727, -108.737503051758, -1.89782744865056, 218, 38, 'PPL', 'P'),
(184462, 'Redrock (historical)', 35.3452796936035, 0.616891505691674, -117.969436645508, -2.05895508618697, 218, 6, 'PPL', 'P'),
(111081, 'Redrock Crossing', 39.6897201538086, 0.69271629587911, -78.1519393920898, -1.36400865921102, 218, 58, 'PPL', 'P'),
(30942, 'Reds Corner', 39.6011085510254, 0.691169731655074, -85.9716720581055, -1.50048874085875, 218, 19, 'PPL', 'P'),
(194396, 'Reds Place', 40.7305603027344, 0.710882383464813, -105.871109008789, -1.8477994349412, 218, 7, 'PPL', 'P'),
(146158, 'Redshaw Corner', 40.3566703796387, 0.704356773266765, -74.3552780151367, -1.29774441759989, 218, 37, 'PPL', 'P'),
(111082, 'Redstar', 37.9352798461914, 0.662095535981488, -81.1466674804688, -1.41627652455519, 218, 58, 'PPL', 'P'),
(132796, 'Redstone', 43.4813919067383, 0.758893452122598, -84.4688873291016, -1.47426019938894, 218, 27, 'PPL', 'P'),
(144360, 'Redstone', 44.014720916748, 0.76820179934367, -71.1016693115234, -1.24095823315029, 218, 36, 'PPL', 'P'),
(166362, 'Redstone', 40.0747184753418, 0.699435784204516, -79.8038864135742, -1.39284057380444, 218, 45, 'PPL', 'P'),
(187250, 'Redstone', 39.1808280944824, 0.683834453906614, -107.239166259766, -1.87167653832652, 218, 7, 'PPL', 'P'),
(189330, 'Redstone', 32.9391708374023, 0.574896983989569, -108.196937561035, -1.88839280101479, 218, 38, 'PPL', 'P'),
(197350, 'Redstone', 48.8216705322266, 0.852098897111246, -104.94361114502, -1.83161154341321, 218, 31, 'PPL', 'P'),
(5328, 'Redstone Park', 34.5972213745117, 0.603835425026588, -86.5663909912109, -1.51086854436539, 218, 2, 'PPL', 'P'),
(172447, 'Redstone Park', 44.4491691589355, 0.775784351599344, -73.2302780151367, -1.27810946351495, 218, 55, 'PPL', 'P'),
(57128, 'Redtop', 37.5036087036133, 0.654561453257654, -93.1438903808594, -1.62566756526267, 218, 29, 'PPL', 'P'),
(137661, 'Redtop', 46.1761093139648, 0.805925143289507, -93.397216796875, -1.63008894530442, 218, 28, 'PPL', 'P'),
(5329, 'Redtown', 31.1377792358398, 0.543456769424529, -87.6324996948242, -1.52947565142761, 218, 2, 'PPL', 'P'),
(74032, 'Redtown', 39.4658317565918, 0.688808706190664, -82.0933303833008, -1.4327989091161, 218, 41, 'PPL', 'P'),
(97439, 'Redtown', 31.4155597686768, 0.548304954320478, -94.9388885498047, -1.65699619337804, 218, 51, 'PPL', 'P'),
(166364, 'Reduction', 40.1836090087891, 0.701336282537424, -79.771110534668, -1.39226852680229, 218, 45, 'PPL', 'P'),
(199645, 'Redus', 41.999439239502, 0.733028498720612, -103.870826721191, -1.8128879230533, 218, 35, 'PPL', 'P'),
(192925, 'Redvale', 38.1749992370605, 0.66627942863303, -108.41667175293, -1.89222788614256, 218, 7, 'PPL', 'P'),
(61502, 'Redwater', 32.7666702270508, 0.571886280377234, -89.5366668701172, -1.56270963814487, 218, 30, 'PPL', 'P'),
(97437, 'Redwater', 33.3580589294434, 0.582207960393081, -94.2541732788086, -1.64504565746047, 218, 51, 'PPL', 'P'),
(197351, 'Redwater (historical)', 47.5305595397949, 0.829564759284622, -105.406387329102, -1.83968851152525, 218, 31, 'PPL', 'P'),
(193902, 'Redway', 40.1202812194824, 0.700231004106014, -123.822219848633, -2.16110542348692, 218, 6, 'PPL', 'P'),
(24260, 'Redwine', 33.5125007629395, 0.584903478890405, -84.8133316040039, -1.48027188607563, 218, 13, 'PPL', 'P'),
(37886, 'Redwine', 38.0161094665527, 0.66350627898993, -83.227783203125, -1.45259884603056, 218, 21, 'PPL', 'P'),
(90251, 'Redwine', 36.0941696166992, 0.629962100584701, -83.1930618286133, -1.45199284372452, 218, 50, 'PPL', 'P'),
(42763, 'Redwine (historical)', 32.4555587768555, 0.566456361230672, -92.7069396972656, -1.61804133716512, 218, 22, 'PPL', 'P'),
(33735, 'Redwing', 38.5219383239746, 0.672334658003543, -98.6641693115234, -1.72201460823123, 218, 20, 'PPL', 'P'),
(42765, 'Redwing', 32.8008308410645, 0.572482495566276, -91.4925003051758, -1.59684537120723, 218, 22, 'PPL', 'P'),
(111083, 'Redwing', 38.1775016784668, 0.666323104474907, -82.2347183227539, -1.43526659418216, 218, 58, 'PPL', 'P'),
(61503, 'Redwood', 32.4775009155273, 0.566839323795425, -90.8036117553711, -1.58482199783385, 218, 30, 'PPL', 'P'),
(68139, 'Redwood', 36.0469398498535, 0.629137785648294, -78.7716674804688, -1.37482495482033, 218, 33, 'PPL', 'P'),
(97438, 'Redwood', 29.8099994659424, 0.520282640698446, -97.9111099243164, -1.70887124246142, 218, 51, 'PPL', 'P'),
(105633, 'Redwood', 37.019718170166, 0.646115970229767, -79.8122177124023, -1.39298598239996, 218, 53, 'PPL', 'P'),
(152029, 'Redwood', 40.9977798461914, 0.715546244323814, -72.3138885498047, -1.26211545011432, 218, 40, 'PPL', 'P'),
(201460, 'Redwood', 42.4222183227539, 0.740407385731922, -123.386108398438, -2.15349384277536, 218, 43, 'PPL', 'P'),
(205487, 'Redwood', 40.7133293151855, 0.710581645998716, -111.938331604004, -1.95369244567909, 218, 52, 'PPL', 'P'),
(184463, 'Redwood City', 37.485279083252, 0.654241541031708, -122.235282897949, -2.13340814867593, 218, 6, 'PPL', 'P'),
(184465, 'Redwood Corral', 35.9824981689453, 0.628013066140927, -118.661666870117, -2.07103678278822, 218, 6, 'PPL', 'P'),
(184466, 'Redwood Estates', 37.1563911437988, 0.648501363618151, -121.985557556152, -2.12904961923591, 218, 6, 'PPL', 'P'),
(137662, 'Redwood Falls', 44.5394401550293, 0.777359877700235, -95.1166687011719, -1.66009904236409, 218, 28, 'PPL', 'P'),
(178972, 'Redwood Gardens Mobile Home Park', 33.4124984741211, 0.583158109690994, -111.879440307617, -1.95266459865638, 218, 5, 'PPL', 'P'),
(184467, 'Redwood Grove', 37.1575012207031, 0.648520738115082, -122.133056640625, -2.13162396390363, 218, 6, 'PPL', 'P'),
(184468, 'Redwood Junction', 37.4772186279297, 0.654100859547125, -122.220283508301, -2.13314635994077, 218, 6, 'PPL', 'P'),
(184470, 'Redwood Lodge', 37.107780456543, 0.647652947073879, -121.94361114502, -2.12831751625224, 218, 6, 'PPL', 'P'),
(199646, 'Redwood Mobile Court', 42.8294410705566, 0.747514763470098, -102.999443054199, -1.79767940901618, 218, 35, 'PPL', 'P'),
(184472, 'Redwood Park', 37.4347190856934, 0.65335910260451, -122.320281982422, -2.13489166256116, 218, 6, 'PPL', 'P'),
(184473, 'Redwood Shores', 37.5319404602051, 0.655055935693054, -122.246940612793, -2.13361161418321, 218, 6, 'PPL', 'P'),
(184474, 'Redwood Terrace', 37.3147201538086, 0.651264726144245, -122.293891906738, -2.13443106885063, 218, 6, 'PPL', 'P'),
(184476, 'Redwood Valley', 39.2655601501465, 0.685313307259935, -123.203330993652, -2.15030377526361, 218, 6, 'PPL', 'P'),
(205489, 'Redwood Villa', 40.6558303833008, 0.709578100320947, -111.940826416016, -1.95373598836292, 218, 52, 'PPL', 'P'),
(68140, 'Redwood Village', 35.5811080932617, 0.621007487735419, -82.5186080932617, -1.44022140539026, 218, 33, 'PPL', 'P'),
(205491, 'Redwood Village Condominium', 40.6919403076172, 0.710208337392914, -111.941673278809, -1.95375076890697, 218, 52, 'PPL', 'P'),
(193903, 'Redwoods', 40.5963897705078, 0.708540665918307, -121.934440612793, -2.12815746027073, 218, 6, 'PPL', 'P'),
(171169, 'Ree Heights', 44.5186080932617, 0.776996289632412, -99.1997222900391, -1.73136177102519, 218, 49, 'PPL', 'P'),
(33734, 'Reece', 37.7988891601563, 0.659715069441121, -96.4461135864258, -1.68330223283557, 218, 20, 'PPL', 'P'),
(5330, 'Reece City', 34.0722198486328, 0.594672419822007, -86.033332824707, -1.50156492425525, 218, 2, 'PPL', 'P'),
(50751, 'Reece Heights', 39.1211090087891, 0.682792159234984, -76.7125015258789, -1.33888572906776, 218, 25, 'PPL', 'P'),
(117479, 'Reeceville', 42.1266708374023, 0.735249109016548, -90.2983322143555, -1.57600320620017, 218, 16, 'PPL', 'P'),
(166366, 'Reeceville', 40.0277786254883, 0.698616529274181, -75.7958297729492, -1.32288678881911, 218, 45, 'PPL', 'P'),
(11523, 'Reed', 34.0927810668945, 0.595031280778895, -93.8516693115234, -1.638020637979, 218, 4, 'PPL', 'P'),
(24262, 'Reed', 34.2252807617188, 0.597343836711465, -83.92138671875, -1.46470451108163, 218, 13, 'PPL', 'P'),
(37887, 'Reed', 37.8511085510254, 0.660626469745173, -87.3541717529297, -1.52461791244125, 218, 21, 'PPL', 'P'),
(77067, 'Reed', 34.9005584716797, 0.609129656115611, -99.6952819824219, -1.74001091929744, 218, 42, 'PPL', 'P'),
(128643, 'Reed', 45.7236099243164, 0.798027539076877, -68.1427764892578, -1.18931581118813, 218, 26, 'PPL', 'P'),
(166365, 'Reed', 40.8697204589844, 0.713311186378966, -76.5944366455078, -1.33682510817431, 218, 45, 'PPL', 'P'),
(176043, 'Reed', 43.3761100769043, 0.757055937549471, -91.0388870239258, -1.58892832591865, 218, 57, 'PPL', 'P'),
(184477, 'Reed', 37.9049987792969, 0.661567031663162, -122.499443054199, -2.13801861315507, 218, 6, 'PPL', 'P'),
(201461, 'Reed', 44.1780586242676, 0.771052580132546, -123.843063354492, -2.16146921129182, 218, 43, 'PPL', 'P'),
(11524, 'Reed (historical)', 36.0736083984375, 0.629603239627813, -91.4263916015625, -1.59569155666496, 218, 4, 'PPL', 'P'),
(132798, 'Reed City', 43.875, 0.765763209312512, -85.5100021362305, -1.49243108066461, 218, 27, 'PPL', 'P'),
(152032, 'Reed Corners', 42.8363914489746, 0.747636070457751, -77.2147216796875, -1.34765112432159, 218, 40, 'PPL', 'P'),
(24263, 'Reed Creek', 34.4458312988281, 0.601193169751066, -82.9250030517578, -1.44731433547952, 218, 13, 'PPL', 'P'),
(105635, 'Reed Creek Village', 36.7666702270508, 0.641699450457007, -79.9186096191406, -1.39484287147002, 218, 53, 'PPL', 'P'),
(71325, 'Reed Crossing', 39.7980613708496, 0.694607206832094, -74.9327774047852, -1.30782368337751, 218, 37, 'PPL', 'P'),
(121186, 'Reed Crossing', 41.273609161377, 0.720360374047323, -88.831672668457, -1.55040516811843, 218, 18, 'PPL', 'P'),
(105636, 'Reed Junction', 36.9313888549805, 0.644574332853748, -80.7522201538086, -1.40939211997928, 218, 53, 'PPL', 'P'),
(209691, 'Reed Place', 42.2680587768555, 0.737716794082615, -105.724998474121, -1.84524932503939, 218, 59, 'PPL', 'P'),
(197352, 'Reed Point', 45.7094383239746, 0.797780197990635, -109.541389465332, -1.91185791337947, 218, 31, 'PPL', 'P'),
(11527, 'Reed Settlement (historical)', 33.5875015258789, 0.586212489145206, -91.7861099243164, -1.60196982577676, 218, 4, 'PPL', 'P'),
(123524, 'Reed Station', 40.2150001525879, 0.701884161352681, -85.5180587768555, -1.49257169557016, 218, 19, 'PPL', 'P'),
(197353, 'Reed Trailer Court', 45.7366714477539, 0.798255505666187, -111.061111450195, -1.93838206573028, 218, 31, 'PPL', 'P'),
(5331, 'Reedbrake (historical)', 34.1611099243164, 0.596223844315032, -86.3144378662109, -1.50647113277345, 218, 2, 'PPL', 'P'),
(166368, 'Reeder', 40.353328704834, 0.704298450038892, -74.9811096191406, -1.3086672396528, 218, 45, 'PPL', 'P'),
(198789, 'Reeder', 46.1058311462402, 0.804698557870443, -102.944999694824, -1.79672919313924, 218, 34, 'PPL', 'P'),
(77069, 'Reeder Ford', 35.5788917541504, 0.620968805320585, -94.5194396972656, -1.64967542985752, 218, 42, 'PPL', 'P'),
(197354, 'Reeder Place', 45.0497207641602, 0.786265954438651, -112.001106262207, -1.95478807015155, 218, 31, 'PPL', 'P'),
(166369, 'Reeders', 41.0188903808594, 0.715914692660627, -75.3363876342773, -1.31486801077688, 218, 45, 'PPL', 'P'),
(90254, 'Reeders Crossing', 36.0652809143066, 0.629457897611322, -87.2766723632813, -1.5232652929236, 218, 50, 'PPL', 'P'),
(200159, 'Reederville', 41.1552810668945, 0.718295159200994, -119.964172363281, -2.09376979216924, 218, 39, 'PPL', 'P'),
(77070, 'Reeding', 35.790828704834, 0.624667802916651, -97.7697219848633, -1.70640355739535, 218, 42, 'PPL', 'P'),
(184479, 'Reedley', 36.5963897705078, 0.638727495838533, -119.449440002441, -2.08478601770603, 218, 6, 'PPL', 'P'),
(446, 'Reeds', 34.2269401550293, 0.59737279858832, -83.0777816772461, -1.44998082552096, 218, 13, 'PPL', 'P'),
(57130, 'Reeds', 37.1161117553711, 0.647798355669398, -94.1655578613281, -1.64349902665741, 218, 29, 'PPL', 'P'),
(74034, 'Reeds', 38.7827796936035, 0.676887198728979, -83.9094390869141, -1.46449598556827, 218, 41, 'PPL', 'P'),
(105637, 'Reeds', 37.3377799987793, 0.651667196363983, -78.404167175293, -1.36841086449292, 218, 53, 'PPL', 'P'),
(121188, 'Reeds', 40.9172210693359, 0.714140228426307, -90.8252792358398, -1.58520016670864, 218, 18, 'PPL', 'P'),
(128645, 'Reeds', 44.8866691589355, 0.783420167076819, -70.4108276367188, -1.22890077131496, 218, 26, 'PPL', 'P'),
(74033, 'Reeds (historical)', 39.4130592346191, 0.68788765192766, -82.6444396972656, -1.44241758118319, 218, 41, 'PPL', 'P'),
(184478, 'Reeds (historical)', 35.1791687011719, 0.613992321949986, -120.591110229492, -2.10471192214005, 218, 6, 'PPL', 'P'),
(71324, 'Reeds Beach', 39.1169395446777, 0.682719388358198, -74.8913879394531, -1.30710130093183, 218, 37, 'PPL', 'P'),
(125930, 'Reeds Corner', 42.2216682434082, 0.736907126532204, -70.8083267211914, -1.23583843911267, 218, 23, 'PPL', 'P'),
(166370, 'Reeds Corners', 41.9794387817383, 0.73267942488073, -80.1094436645508, -1.39817355388732, 218, 45, 'PPL', 'P'),
(559, 'Reeds Crossing', 37.7391700744629, 0.658672774769491, -84.2225036621094, -1.46995999317679, 218, 21, 'PPL', 'P'),
(121189, 'Reeds Crossing (historical)', 42.2013893127441, 0.736553192423332, -88.7986068725586, -1.54982806111021, 218, 18, 'PPL', 'P'),
(68142, 'Reeds Crossroads', 35.8447189331055, 0.62560836483464, -80.3327789306641, -1.40207148961682, 218, 33, 'PPL', 'P'),
(5332, 'Reeds Ferry', 33.663890838623, 0.587545734165927, -87.1197204589844, -1.52052596542634, 218, 2, 'PPL', 'P'),
(144361, 'Reeds Ferry', 42.8830604553223, 0.748450598277152, -71.4763870239258, -1.24749829099726, 218, 36, 'PPL', 'P'),
(166372, 'Reeds Furnace', 41.334171295166, 0.721417382683976, -80.004997253418, -1.39635062012116, 218, 45, 'PPL', 'P'),
(166371, 'Reeds Gap', 40.434440612793, 0.705714119895351, -77.6113891601563, -1.35457427789136, 218, 45, 'PPL', 'P'),
(157303, 'Reeds Mill', 40.3600006103516, 0.704414896757556, -80.7486114501953, -1.4093291362195, 218, 41, 'PPL', 'P'),
(157307, 'Reeds Run', 40.5297203063965, 0.707377064259024, -81.4283294677734, -1.42119245361137, 218, 41, 'PPL', 'P'),
(97440, 'Reeds Settlement', 33.7036094665527, 0.588238954997675, -94.9263916015625, -1.65677808048476, 218, 51, 'PPL', 'P'),
(57129, 'Reeds Spring', 36.7497215270996, 0.641403639838927, -93.3777770996094, -1.62974965858154, 218, 29, 'PPL', 'P'),
(28387, 'Reeds Station', 37.7777786254883, 0.659346621104308, -89.1608276367188, -1.5561500060639, 218, 18, 'PPL', 'P'),
(50761, 'Reeds Village', 39.6519393920898, 0.692056897193207, -76.8966674804688, -1.34210003134543, 218, 25, 'PPL', 'P'),
(157304, 'Reedsburg', 40.8086090087891, 0.712244590362389, -82.1069412231445, -1.43303646308533, 218, 41, 'PPL', 'P'),
(176038, 'Reedsburg', 43.5325012207031, 0.75978547792972, -90.0025024414063, -1.57084000263677, 218, 57, 'PPL', 'P'),
(111084, 'Reedson', 39.3525009155273, 0.686830709870035, -77.8016662597656, -1.35789523977069, 218, 58, 'PPL', 'P'),
(201462, 'Reedsport', 43.7024993896484, 0.762752505700178, -124.095558166504, -2.16587607710563, 218, 43, 'PPL', 'P'),
(33736, 'Reedsville', 39.7691688537598, 0.694102937279687, -96.5386123657227, -1.68491664108837, 218, 20, 'PPL', 'P'),
(74035, 'Reedsville', 39.1213912963867, 0.682797086083001, -81.7477798461914, -1.4267679145115, 218, 41, 'PPL', 'P'),
(111085, 'Reedsville', 39.5105590820313, 0.689589345285194, -79.7986068725586, -1.39274842843072, 218, 58, 'PPL', 'P'),
(166373, 'Reedsville', 40.663890838623, 0.70971878180553, -77.5961074829102, -1.35430756230819, 218, 45, 'PPL', 'P'),
(176041, 'Reedsville', 44.1536102294922, 0.770625875146888, -87.956672668457, -1.53513353716348, 218, 57, 'PPL', 'P'),
(5333, 'Reedtown', 34.4966697692871, 0.602080468447253, -87.7416687011719, -1.53138101002951, 218, 2, 'PPL', 'P'),
(61504, 'Reedtown', 32.0758285522461, 0.5598288185419, -90.6427764892578, -1.58201489288686, 218, 30, 'PPL', 'P'),
(105639, 'Reedtown', 36.8777809143066, 0.643638697783776, -76.1322174072266, -1.32875786060024, 218, 53, 'PPL', 'P'),
(157305, 'Reedtown', 41.1519393920898, 0.718236835973121, -82.8472213745117, -1.44595678911385, 218, 41, 'PPL', 'P'),
(157306, 'Reedurban', 40.7944412231445, 0.711997315855175, -81.4369430541992, -1.4213427890549, 218, 41, 'PPL', 'P'),
(11529, 'Reedville', 33.9302787780762, 0.592195080796988, -91.5183334350586, -1.59729624437978, 218, 4, 'PPL', 'P'),
(37888, 'Reedville', 38.2511100769043, 0.667607813384761, -82.9102783203125, -1.44705734043433, 218, 21, 'PPL', 'P'),
(97441, 'Reedville', 29.8794403076172, 0.521494612021027, -97.8461074829102, -1.70773673583704, 218, 51, 'PPL', 'P'),
(105640, 'Reedville', 37.8419418334961, 0.660466480342687, -76.2761077880859, -1.33126922150819, 218, 53, 'PPL', 'P'),
(152033, 'Reedville', 44.101390838623, 0.769714474842835, -75.6547164916992, -1.320423897443, 218, 40, 'PPL', 'P'),
(172448, 'Reedville', 43.2619400024414, 0.755063293842846, -72.658332824707, -1.26812713680101, 218, 55, 'PPL', 'P'),
(201463, 'Reedville', 45.4977798461914, 0.794086060663559, -122.901107788086, -2.14502898525055, 218, 43, 'PPL', 'P'),
(30944, 'Reedville Station', 39.7061080932617, 0.693002319380185, -85.8191680908203, -1.49782704450727, 218, 19, 'PPL', 'P'),
(111086, 'Reedy', 38.8994407653809, 0.678923318540399, -81.4250030517578, -1.4211343966996, 218, 58, 'PPL', 'P'),
(68143, 'Reedy Creek', 35.9197196960449, 0.626917375089441, -80.3338928222656, -1.40209093069278, 218, 33, 'PPL', 'P'),
(83238, 'Reedy Creek Springs (historical)', 34.4283294677734, 0.600887705174033, -79.5616683959961, -1.38861307189005, 218, 48, 'PPL', 'P'),
(105642, 'Reedy Mill', 37.9063911437988, 0.661591333008109, -77.3013916015625, -1.34916379982076, 218, 53, 'PPL', 'P'),
(83239, 'Reedy River (historical)', 34.5069389343262, 0.602259699188615, -82.220832824707, -1.43502424652297, 218, 48, 'PPL', 'P'),
(37889, 'Reedyville', 37.1913909912109, 0.649112226193188, -86.4316711425781, -1.50851723943896, 218, 21, 'PPL', 'P'),
(111087, 'Reedyville', 38.8102798461914, 0.677367166936439, -81.4411087036133, -1.42141549335266, 218, 58, 'PPL', 'P'),
(184480, 'Reef Station', 35.901668548584, 0.626602323132484, -120.053886413574, -2.09533559773216, 218, 6, 'PPL', 'P'),
(184481, 'Reefer City (historical)', 35.0058288574219, 0.610966970951656, -118.184173583984, -2.06270295278903, 218, 6, 'PPL', 'P'),
(71328, 'Reega', 39.4324989318848, 0.688226938650536, -74.6611099243164, -1.30308219137274, 218, 37, 'PPL', 'P'),
(105643, 'Reekes Mill', 36.8224983215332, 0.64267383452084, -78.2830581665039, -1.36629711353573, 218, 53, 'PPL', 'P'),
(166374, 'Reels Corners', 40.0580596923828, 0.699145033592507, -78.8280563354492, -1.37580912600116, 218, 45, 'PPL', 'P'),
(50752, 'Reels Mill', 39.3611106872559, 0.686980978734543, -77.3688888549805, -1.35034184912895, 218, 25, 'PPL', 'P'),
(68145, 'Reelsboro', 35.1338882446289, 0.613202028896505, -76.9136123657227, -1.34239577538449, 218, 33, 'PPL', 'P'),
(30945, 'Reelsville', 39.5574989318848, 0.690408600215529, -86.9669418334961, -1.5178594753849, 218, 19, 'PPL', 'P'),
(5334, 'Reeltown', 32.6036109924316, 0.569040359857348, -85.8052825927734, -1.49758469684807, 218, 2, 'PPL', 'P'),
(132800, 'Reeman', 43.4449996948242, 0.758258288202614, -86.0086135864258, -1.50113349215866, 218, 27, 'PPL', 'P'),
(68147, 'Reepsville', 35.5105590820313, 0.619776175205421, -81.3505630493164, -1.41983517356181, 218, 33, 'PPL', 'P'),
(28388, 'Rees', 39.6355590820313, 0.691771006850187, -90.0924987792969, -1.5724107350477, 218, 18, 'PPL', 'P'),
(208533, 'Rees Corner', 47.878059387207, 0.835629775772141, -122.10888671875, -2.13120211918696, 218, 56, 'PPL', 'P'),
(79012, 'Rees Mill', 39.9119415283203, 0.696594790532647, -80.2233276367188, -1.4001612041669, 218, 45, 'PPL', 'P'),
(11530, 'Reese', 34.8972206115723, 0.609071399466765, -90.4466705322266, -1.57859219825389, 218, 4, 'PPL', 'P'),
(24265, 'Reese', 33.3447189331055, 0.581975133534781, -82.5788879394531, -1.44127348717889, 218, 13, 'PPL', 'P'),
(50753, 'Reese', 39.542781829834, 0.690151738328391, -76.9380569458008, -1.34282241379112, 218, 25, 'PPL', 'P'),
(61505, 'Reese', 34.415828704834, 0.600669525701729, -88.894172668457, -1.55149599890093, 218, 30, 'PPL', 'P'),
(68148, 'Reese', 36.3255615234375, 0.634000651219752, -81.8247222900391, -1.42811081349118, 218, 33, 'PPL', 'P'),
(74036, 'Reese', 39.8661117553711, 0.695794910099242, -82.9527816772461, -1.44779916395597, 218, 41, 'PPL', 'P'),
(97443, 'Reese', 30.2011108398438, 0.527108821915023, -93.7513885498047, -1.6362704085106, 218, 51, 'PPL', 'P'),
(132801, 'Reese', 43.4505615234375, 0.758355360424348, -83.6963882446289, -1.46077754689625, 218, 27, 'PPL', 'P'),
(166375, 'Reese', 40.434440612793, 0.705714119895351, -78.3024978637695, -1.3666364002586, 218, 45, 'PPL', 'P'),
(208534, 'Reese', 46.0719413757324, 0.804107069792337, -118.780281066895, -2.07310699106159, 218, 56, 'PPL', 'P'),
(197355, 'Reese Creek (historical)', 45.8638916015625, 0.800475916225041, -111.08332824707, -1.938769821985, 218, 31, 'PPL', 'P'),
(61506, 'Reese Landing', 34.2191696166992, 0.597237177109807, -90.8877792358398, -1.58629099749114, 218, 30, 'PPL', 'P'),
(50754, 'Reese Manor', 39.5308303833008, 0.689943146236011, -76.9330596923828, -1.34273519526542, 218, 25, 'PPL', 'P'),
(190655, 'Reese River', 38.9977798461914, 0.680639659283928, -117.469169616699, -2.05022377939509, 218, 39, 'PPL', 'P'),
(192107, 'Reese Village', 33.5947189331055, 0.586338456664767, -102.021667480469, -1.78061400590901, 218, 51, 'PPL', 'P'),
(24266, 'Reeseburg', 34.1313896179199, 0.595705127113712, -85.1783294677734, -1.48664230056116, 218, 13, 'PPL', 'P'),
(105644, 'Reesedale', 37.2291717529297, 0.649771624879092, -80.2991714477539, -1.40148492838673, 218, 53, 'PPL', 'P'),
(166383, 'Reesedale', 40.9305610656738, 0.714373055284607, -79.4688873291016, -1.38699373678922, 218, 45, 'PPL', 'P'),
(166376, 'Reesers Summit', 40.2011108398438, 0.701641747114456, -76.8658294677734, -1.34156180648913, 218, 45, 'PPL', 'P'),
(50755, 'Reeses Corner', 39.1744384765625, 0.683722934035967, -76.1972198486328, -1.32989236722462, 218, 25, 'PPL', 'P'),
(111088, 'Reeses Mill', 39.4305610656738, 0.688193116504692, -78.8550033569336, -1.37627944024967, 218, 58, 'PPL', 'P'),
(90256, 'Reesetown', 35.0616683959961, 0.611941554752571, -84.3530578613281, -1.47223859380546, 218, 50, 'PPL', 'P'),
(176046, 'Reeseville', 43.3050003051758, 0.755814837902467, -88.8447189331055, -1.55063286839163, 218, 57, 'PPL', 'P'),
(74037, 'Reesville', 39.4822196960449, 0.689094729691739, -83.6769409179688, -1.46043812701532, 218, 41, 'PPL', 'P'),
(117480, 'Reeve', 42.6722183227539, 0.744770708861908, -93.2602767944336, -1.62769889138413, 218, 16, 'PPL', 'P'),
(176045, 'Reeve', 45.2386093139648, 0.78956268155206, -92.1258316040039, -1.60789908762772, 218, 57, 'PPL', 'P'),
(11533, 'Reeves', 35.9136085510254, 0.626810715487783, -93.4986114501953, -1.63185861584878, 218, 4, 'PPL', 'P'),
(24267, 'Reeves', 34.4613914489746, 0.601464745603226, -85.0127792358398, -1.48375290393647, 218, 13, 'PPL', 'P'),
(42766, 'Reeves', 30.5208301544189, 0.53268897663658, -93.0475006103516, -1.62398524640207, 218, 22, 'PPL', 'P'),
(68149, 'Reeves', 34.0538902282715, 0.594352507596061, -78.6005630493164, -1.37183861913197, 218, 33, 'PPL', 'P'),
(90255, 'Reeves', 36.3136100769043, 0.633792059127371, -82.4244384765625, -1.43857783552351, 218, 50, 'PPL', 'P'),
(140762, 'Reeves', 46.8630599975586, 0.817914694517043, -98.5822219848633, -1.7205843575678, 218, 34, 'PPL', 'P'),
(11532, 'Reeves (historical)', 33.3105583190918, 0.58137891834574, -91.3600006103516, -1.59453281527466, 218, 4, 'PPL', 'P'),
(105649, 'Reeves (historical)', 37.0980606079102, 0.647483303712441, -77.3583297729492, -1.35015755838152, 218, 53, 'PPL', 'P'),
(209692, 'Reeves Corner', 44.5213890075684, 0.777044825743278, -107.864166259766, -1.88258484615149, 218, 59, 'PPL', 'P'),
(14473, 'Reeves Crossing', 38.9833297729492, 0.680387457928697, -75.5783309936523, -1.31909071900131, 218, 10, 'PPL', 'P'),
(152034, 'Reeves Park', 40.9716682434082, 0.715090510882275, -72.7127838134766, -1.269077485836, 218, 40, 'PPL', 'P'),
(184483, 'Reeves Place', 35.1650009155273, 0.613745047442772, -120.308891296387, -2.0997862725459, 218, 6, 'PPL', 'P'),
(166377, 'Reevesdale', 40.7816696166992, 0.711774409271935, -76.0122222900391, -1.32666355071901, 218, 45, 'PPL', 'P'),
(28389, 'Reevesville', 37.3430595397949, 0.6517593417377, -88.7197189331055, -1.54845120682664, 218, 18, 'PPL', 'P'),
(83244, 'Reevesville', 33.2055587768555, 0.579546330620629, -80.648063659668, -1.40757424621919, 218, 48, 'PPL', 'P'),
(146160, 'Reevytown', 40.2405586242676, 0.702330240835269, -74.1052780151367, -1.2933810944699, 218, 37, 'PPL', 'P'),
(5336, 'Reform', 33.3783302307129, 0.582561761343898, -88.0152816772461, -1.53615645733818, 218, 2, 'PPL', 'P'),
(11534, 'Reform', 34.7897186279297, 0.607195135899777, -92.8333282470703, -1.62024723349603, 218, 4, 'PPL', 'P'),
(57133, 'Reform', 38.7652816772461, 0.676581800730974, -91.7788925170898, -1.6018438582572, 218, 29, 'PPL', 'P'),
(61507, 'Reform', 33.4305610656738, 0.583473361385033, -89.1547164916992, -1.55604334646224, 218, 30, 'PPL', 'P'),
(157308, 'Reform', 40.1366691589355, 0.700517027607089, -82.2502822875977, -1.43553823661335, 218, 41, 'PPL', 'P'),
(79013, 'Refton', 39.9472198486328, 0.697210513376673, -76.2330627441406, -1.33051794376468, 218, 45, 'PPL', 'P'),
(5337, 'Refuge', 33.6500015258789, 0.587303319927703, -86.1172180175781, -1.50302899706452, 218, 2, 'PPL', 'P'),
(61508, 'Refuge', 33.3036117553711, 0.581257677937114, -91.1363906860352, -1.59063008585521, 218, 30, 'PPL', 'P'),
(97444, 'Refuge', 31.5011100769043, 0.549798088875144, -95.4008331298828, -1.66505864726214, 218, 51, 'PPL', 'P'),
(24268, 'Refuge (historical)', 30.9888896942139, 0.540858156701371, -81.7300033569336, -1.42645765624451, 218, 13, 'PPL', 'P'),
(193294, 'Refuge Cove', 55.4069404602051, 0.967033539487041, -131.741668701172, -2.29932588090701, 218, 1, 'PPL', 'P'),
(68150, 'Refuge Mission', 35.3849983215332, 0.617584726523422, -79.956672668457, -1.39550719700394, 218, 33, 'PPL', 'P'),
(97445, 'Refugio', 28.3050003051758, 0.494015450103317, -97.2750015258789, -1.6977690565091, 218, 51, 'PPL', 'P'),
(57131, 'Regal', 39.4674987792969, 0.688837801225573, -93.8144378662109, -1.63737082667302, 218, 29, 'PPL', 'P'),
(68151, 'Regal', 35.121940612793, 0.612993503383152, -84.0033264160156, -1.466134628587, 218, 33, 'PPL', 'P'),
(137666, 'Regal', 45.4072189331055, 0.792505474556597, -94.8452835083008, -1.65536247720733, 218, 28, 'PPL', 'P'),
(208535, 'Regal', 46.9902801513672, 0.820135105075897, -120.465827941895, -2.10252533372704, 218, 56, 'PPL', 'P'),
(50756, 'Regal Estastes', 38.7422218322754, 0.676179330511236, -76.6722183227539, -1.33818265453998, 218, 25, 'PPL', 'P'),
(97447, 'Regal Estates Colonia', 26.2549991607666, 0.458236180463725, -98.3649978637695, -1.71679308143997, 218, 51, 'PPL', 'P'),
(17776, 'Regal Park', 29.2552795410156, 0.510600951582058, -82.163330078125, -1.43402063426617, 218, 12, 'PPL', 'P'),
(68152, 'Regan', 34.0169410705566, 0.593707623138098, -78.5658264160156, -1.37123235050981, 218, 33, 'PPL', 'P'),
(198792, 'Regan', 47.1580581665039, 0.823063383852493, -100.527778625488, -1.75454072673075, 218, 34, 'PPL', 'P'),
(190661, 'Regan (historical)', 39.7847213745117, 0.694374379973793, -114.175559997559, -1.99273944726573, 218, 39, 'PPL', 'P'),
(166378, 'Regan Junction', 40.5430603027344, 0.707609891117324, -78.8522186279297, -1.37623083755978, 218, 45, 'PPL', 'P'),
(61509, 'Reganton', 32.1416702270508, 0.56097797255227, -90.7486114501953, -1.58386206141893, 218, 30, 'PPL', 'P'),
(97448, 'Regency', 31.420280456543, 0.548387345866702, -98.8505630493164, -1.72526779266082, 218, 51, 'PPL', 'P'),
(97449, 'Regency Acres Number 2 Colonia', 26.3589992523193, 0.460051324483696, -98.2600021362305, -1.71496056029388, 218, 51, 'PPL', 'P'),
(50757, 'Regency Estates', 39.0480613708496, 0.681517237442136, -77.170280456543, -1.34687547865411, 218, 25, 'PPL', 'P'),
(142830, 'Regency II Mobile Home Park', 41.4222183227539, 0.722954093211979, -96.4991683959961, -1.68422821394659, 218, 35, 'PPL', 'P'),
(50758, 'Regency Manor Mobile Home Park', 38.7388916015625, 0.676121207020445, -76.6511077880859, -1.33781420620317, 218, 25, 'PPL', 'P'),
(117482, 'Regency Manor Mobile Home Park', 41.5208282470703, 0.724675161066443, -93.5888900756836, -1.63343427510772, 218, 16, 'PPL', 'P'),
(117483, 'Regency of Iowa Mobile Home Park', 41.226390838623, 0.719536258847998, -95.8722229003906, -1.67328595081772, 218, 16, 'PPL', 'P'),
(117484, 'Regency of Sioux City', 42.4861106872559, 0.741522517859366, -96.3541717529297, -1.68169754512074, 218, 16, 'PPL', 'P'),
(83240, 'Regency Park', 34.5186080932617, 0.602463364432979, -82.7125015258789, -1.44360548418742, 218, 48, 'PPL', 'P'),
(166379, 'Regency Park', 40.4824981689453, 0.706552882480671, -79.7758331298828, -1.39235095163803, 218, 45, 'PPL', 'P'),
(83241, 'Regency Square', 33.9036102294922, 0.591729626817469, -81.216667175293, -1.41749824970527, 218, 48, 'PPL', 'P'),
(97450, 'Regency Village Colonia', 27.6270008087158, 0.482182126563227, -99.2279968261719, -1.73185525477518, 218, 51, 'PPL', 'P'),
(24271, 'Regency Woods', 33.9413909912109, 0.592389025503373, -84.0763931274414, -1.46740988327498, 218, 13, 'PPL', 'P'),
(83242, 'Regency Woods', 34.5208282470703, 0.602502113426839, -82.7161102294922, -1.4436684679472, 218, 48, 'PPL', 'P'),
(105645, 'Regent', 37.5880584716797, 0.656035379762958, -76.4419403076172, -1.33416354498089, 218, 53, 'PPL', 'P'),
(198794, 'Regent', 46.4216690063477, 0.810210968431771, -102.555282592773, -1.78992734655712, 218, 34, 'PPL', 'P'),
(111089, 'Reger', 38.9819412231445, 0.680363223162778, -80.1911087036133, -1.39959887770273, 218, 58, 'PPL', 'P'),
(139420, 'Reger', 40.1438903808594, 0.700643061705677, -93.192497253418, -1.62651591522792, 218, 29, 'PPL', 'P'),
(42768, 'Reggio', 29.8311100006104, 0.520651089035258, -89.7544403076172, -1.56651050165263, 218, 22, 'PPL', 'P'),
(57132, 'Regina', 38.3263893127441, 0.668921683908552, -90.5919418334961, -1.5811276607697, 218, 29, 'PPL', 'P'),
(105646, 'Regina', 37.8038902282715, 0.659802354545848, -76.4177780151367, -1.33374183342227, 218, 53, 'PPL', 'P'),
(176047, 'Regina', 44.894718170166, 0.783560648824321, -89.0216674804688, -1.55372120314974, 218, 57, 'PPL', 'P'),
(189332, 'Regina', 36.1841697692871, 0.631532899574657, -106.956108093262, -1.86673624134637, 218, 38, 'PPL', 'P'),
(195519, 'Regina', 43.3902816772461, 0.757303278635712, -115.991111755371, -2.02442680317993, 218, 17, 'PPL', 'P'),
(197356, 'Regina (historical)', 47.9283294677734, 0.836507154193268, -107.984718322754, -1.8846888765707, 218, 31, 'PPL', 'P'),
(74038, 'Regina Heights', 39.814998626709, 0.694902817713092, -84.2716674804688, -1.47081806368001, 218, 41, 'PPL', 'P'),
(184486, 'Regina Heights', 39.1483306884766, 0.683267267173455, -123.172500610352, -2.14976568356536, 218, 6, 'PPL', 'P'),
(97451, 'Regino Ramirez Colonia', 26.488000869751, 0.462302827448276, -98.9339981079102, -1.72672400914487, 218, 51, 'PPL', 'P'),
(83243, 'Region Town (historical)', 33.4452781677246, 0.583730223272171, -80.0299987792969, -1.39678697906577, 218, 48, 'PPL', 'P'),
(24272, 'Register', 32.3669395446777, 0.564909663848581, -81.8841705322266, -1.42914838105187, 218, 13, 'PPL', 'P'),
(68154, 'Register', 34.851390838623, 0.60827151903336, -77.959716796875, -1.3606537420278, 218, 33, 'PPL', 'P'),
(166381, 'Register', 41.1966705322266, 0.719017541646678, -76.2716674804688, -1.33119172352047, 218, 45, 'PPL', 'P'),
(11535, 'Register (historical)', 33.5741691589355, 0.585979795444961, -93.4561080932617, -1.63111679232714, 218, 4, 'PPL', 'P'),
(83246, 'Register Crossroads', 34.271671295166, 0.598153504261876, -80.083610534668, -1.39772268071477, 218, 48, 'PPL', 'P'),
(117485, 'Registry Park', 43.1458282470703, 0.75303676141135, -93.2555618286133, -1.62761659970645, 218, 16, 'PPL', 'P'),
(192956, 'Regnier', 36.9938888549805, 0.645665163636244, -102.856666564941, -1.79518748918419, 218, 42, 'PPL', 'P'),
(30947, 'Rego', 38.4850006103516, 0.671689973282662, -86.3177795410156, -1.50652945600132, 218, 19, 'PPL', 'P'),
(152035, 'Rego Park', 40.726390838623, 0.710809612588027, -73.8530578613281, -1.28897902234606, 218, 40, 'PPL', 'P'),
(90258, 'Regret (historical)', 35.6319389343262, 0.621894653273551, -84.6069412231445, -1.47666969438519, 218, 50, 'PPL', 'P'),
(50759, 'Regwood', 39.4691696166992, 0.68886696283951, -76.4494400024414, -1.33429443934846, 218, 25, 'PPL', 'P'),
(97452, 'Rehburg', 30.2544403076172, 0.528039596716006, -96.5622177124023, -1.68532863210901, 218, 51, 'PPL', 'P'),
(74039, 'Rehm', 39.0638885498047, 0.681793473826205, -82.9611129760742, -1.44794457255149, 218, 41, 'PPL', 'P'),
(177742, 'Rehm', 35.9663887023926, 0.627731902908841, -102.644172668457, -1.79147877105015, 218, 51, 'PPL', 'P'),
(11536, 'Rehms Corner', 35.0869407653809, 0.612382640808115, -92.7988891601563, -1.619646158038, 218, 4, 'PPL', 'P'),
(5344, 'Rehobeth', 31.1227798461914, 0.543194980689374, -85.4527816772461, -1.49143239525583, 218, 2, 'PPL', 'P'),
(24273, 'Rehobeth', 32.6408309936523, 0.569689971426246, -84.8838882446289, -1.48150333176368, 218, 13, 'PPL', 'P'),
(50760, 'Rehobeth', 38.038890838623, 0.663903888940679, -75.663330078125, -1.32057423288654, 218, 25, 'PPL', 'P'),
(68155, 'Rehobeth', 35.3638916015625, 0.617216344765636, -81.6563873291016, -1.4251728141766, 218, 33, 'PPL', 'P'),
(83245, 'Rehobeth', 33.9650001525879, 0.592801083103035, -79.2397232055664, -1.38299406830609, 218, 48, 'PPL', 'P'),
(5345, 'Rehoboth', 32.1955604553223, 0.561918534470258, -87.3813934326172, -1.52509302037972, 218, 2, 'PPL', 'P'),
(24274, 'Rehoboth', 33.8241691589355, 0.590343118574946, -84.2647171020508, -1.47069675669236, 218, 13, 'PPL', 'P'),
(30948, 'Rehoboth', 38.0825004577637, 0.664665020380224, -86.023063659668, -1.50138569351389, 218, 19, 'PPL', 'P'),
(68156, 'Rehoboth', 36.3433303833008, 0.634310776328691, -77.3763885498047, -1.35047274349653, 218, 33, 'PPL', 'P'),
(90259, 'Rehoboth', 36.0322189331055, 0.628880857182129, -89.2555618286133, -1.55780342962667, 218, 50, 'PPL', 'P'),
(105647, 'Rehoboth', 36.9197196960449, 0.644370667609384, -78.3550033569336, -1.3675527939897, 218, 53, 'PPL', 'P'),
(125931, 'Rehoboth', 41.8402786254883, 0.730250621966578, -71.25, -1.24354709204596, 218, 23, 'PPL', 'P'),
(157309, 'Rehoboth', 41.2180595397949, 0.71939085025248, -83.3958282470703, -1.45553178533907, 218, 41, 'PPL', 'P'),
(189333, 'Rehoboth', 35.5288887023926, 0.620096087431366, -108.654167175293, -1.89637296322121, 218, 38, 'PPL', 'P'),
(24275, 'Rehoboth (historical)', 33.771671295166, 0.589426858001905, -83.4833297729492, -1.45705897506617, 218, 13, 'PPL', 'P'),
(14474, 'Rehoboth Beach', 38.7208290100098, 0.675805955326407, -75.0763931274414, -1.3103302505955, 218, 10, 'PPL', 'P'),
(14475, 'Rehoboth Manor', 38.7066688537598, 0.675558813977247, -75.0908279418945, -1.31058218563462, 218, 10, 'PPL', 'P'),
(14476, 'Rehoboth Shores Mobile Home Park', 38.6305618286133, 0.674230495804543, -75.1366729736328, -1.31138233238413, 218, 10, 'PPL', 'P'),
(166382, 'Rehrersburg', 40.4575004577637, 0.706116590115089, -76.2447204589844, -1.33072140927196, 218, 45, 'PPL', 'P'),
(176048, 'Reich Mobile Home Park', 43.8125, 0.764672378530016, -88.9480590820313, -1.55243649423989, 218, 57, 'PPL', 'P'),
(77072, 'Reichert', 34.8630599975586, 0.608475184277724, -94.7477798461914, -1.65366071727077, 218, 42, 'PPL', 'P'),
(50762, 'Reichs Ford Estates', 39.3819389343262, 0.687344500223339, -77.3652801513672, -1.35027886536917, 218, 25, 'PPL', 'P'),
(5346, 'Reid', 34.7491683959961, 0.606487400840089, -87.0386123657227, -1.51911036214891, 218, 2, 'PPL', 'P'),
(50763, 'Reid', 39.7122192382813, 0.693108978981842, -77.679443359375, -1.35576204773754, 218, 25, 'PPL', 'P'),
(61511, 'Reid', 34.0022201538086, 0.593450694671933, -89.1952819824219, -1.55675134783804, 218, 30, 'PPL', 'P'),
(68157, 'Reid', 35.1158294677734, 0.612886843781494, -82.9030609130859, -1.44693137291477, 218, 33, 'PPL', 'P'),
(111090, 'Reid', 38.4013900756836, 0.670230694163353, -82.3883285522461, -1.43794759845155, 218, 58, 'PPL', 'P'),
(90260, 'Reid Camp', 35.7791709899902, 0.624464337409369, -84.7516708374023, -1.47919570267913, 218, 50, 'PPL', 'P'),
(172449, 'Reid Hollow', 42.8102798461914, 0.747180337016212, -72.7191696166992, -1.26918893912762, 218, 55, 'PPL', 'P'),
(97453, 'Reid Hope King', 25.9219398498535, 0.452423198883868, -97.4136123657227, -1.70018827204332, 218, 51, 'PPL', 'P'),
(97454, 'Reid Hope King Colonia', 25.9190006256104, 0.452371899743371, -97.4140014648438, -1.7001950631041, 218, 51, 'PPL', 'P'),
(5347, 'Reid Settlement', 31.2458305358887, 0.545342620371442, -88.0988922119141, -1.53761573645749, 218, 2, 'PPL', 'P'),
(37890, 'Reid Village', 38.0491714477539, 0.664083319419123, -83.9775009155273, -1.4656838885725, 218, 21, 'PPL', 'P'),
(37891, 'Reidland', 37.0175018310547, 0.646077287814934, -88.5313873291016, -1.54516420025121, 218, 21, 'PPL', 'P'),
(5348, 'Reids', 33.8866691589355, 0.591433949357443, -86.8483276367188, -1.51578926711153, 218, 2, 'PPL', 'P'),
(24276, 'Reids', 32.7180595397949, 0.571037863832962, -83.5672225952148, -1.4585231810335, 218, 13, 'PPL', 'P'),
(42769, 'Reids', 30.8541698455811, 0.53850685177494, -92.8930587768555, -1.62128972790474, 218, 22, 'PPL', 'P'),
(157310, 'Reids (historical)', 41.1941719055176, 0.718973932383828, -84.5536117553711, -1.47573891958421, 218, 41, 'PPL', 'P'),
(24277, 'Reids Crossroads', 33.4091682434082, 0.583099986200204, -83.4266662597656, -1.45607001019537, 218, 13, 'PPL', 'P'),
(50764, 'Reids Grove', 38.5336112976074, 0.672538389826934, -75.8277816772461, -1.32344445475137, 218, 25, 'PPL', 'P'),
(24278, 'Reidsboro', 33.1375007629395, 0.578358494195426, -84.3836135864258, -1.47277189181375, 218, 13, 'PPL', 'P'),
(166384, 'Reidsburg', 41.1505584716797, 0.718212734365256, -79.4033279418945, -1.38584950962687, 218, 45, 'PPL', 'P'),
(24279, 'Reidsville', 32.086669921875, 0.56001803613735, -82.1180572509766, -1.43323047437074, 218, 13, 'PPL', 'P'),
(68169, 'Reidsville', 36.3547210693359, 0.634509581304066, -79.6647186279297, -1.39041163773223, 218, 33, 'PPL', 'P'),
(152036, 'Reidsville', 42.5666694641113, 0.742928533756873, -74.0244369506836, -1.29197015172438, 218, 40, 'PPL', 'P'),
(90263, 'Reidtown', 35.9805603027344, 0.627979243995083, -83.2797164916992, -1.45350525290757, 218, 50, 'PPL', 'P'),
(83247, 'Reidville', 34.8627815246582, 0.608470324008734, -82.1144409179688, -1.43316735745291, 218, 48, 'PPL', 'P'),
(83248, 'Reidville Acres', 34.8655586242676, 0.608518793540574, -82.0877838134766, -1.43270210321047, 218, 48, 'PPL', 'P'),
(123525, 'Reiffsburg', 40.6558303833008, 0.709578100320947, -85.1519393920898, -1.48618170685063, 218, 19, 'PPL', 'P'),
(166385, 'Reiffton', 40.3197212219238, 0.703711888808802, -75.873893737793, -1.32424926203279, 218, 45, 'PPL', 'P'),
(176050, 'Reifs Mills', 44.1822204589844, 0.771125217851278, -87.7991714477539, -1.5323846222863, 218, 57, 'PPL', 'P'),
(176051, 'Reighmoor', 44.0574989318848, 0.768948416555274, -88.6736068725586, -1.54764639954522, 218, 57, 'PPL', 'P'),
(166386, 'Reightown', 40.6022186279297, 0.708642398671948, -78.333610534668, -1.36717941880487, 218, 45, 'PPL', 'P'),
(140764, 'Reiles Acres', 46.9230613708496, 0.81896191603669, -96.8649978637695, -1.69061314266005, 218, 34, 'PPL', 'P'),
(42770, 'Reiley', 30.7436103820801, 0.536577225117609, -90.9691696166992, -1.58771152761659, 218, 22, 'PPL', 'P'),
(121190, 'Reilly', 40.415828704834, 0.705389280821389, -87.8544387817383, -1.53334921923313, 218, 18, 'PPL', 'P'),
(166387, 'Reilly', 41.0919418334961, 0.717189681032502, -75.8816680908203, -1.32438495009033, 218, 45, 'PPL', 'P'),
(184487, 'Reilly (historical)', 36.0069389343262, 0.62843963796853, -117.368057250977, -2.04845903569875, 218, 6, 'PPL', 'P'),
(187251, 'Reilly Canyon', 37.2544403076172, 0.650212644355609, -104.709442138672, -1.82752452324632, 218, 7, 'PPL', 'P'),
(184488, 'Reilly Heights', 39.1097183227539, 0.68259335425961, -123.514717102051, -2.15573848810014, 218, 6, 'PPL', 'P'),
(117486, 'Reilly Settlement', 43.1555595397949, 0.75320660450987, -92.1805572509766, -1.60885423035267, 218, 16, 'PPL', 'P'),
(97455, 'Reilly Springs', 33.0058288574219, 0.57606038591177, -95.5449981689453, -1.66757480186005, 218, 51, 'PPL', 'P'),
(166392, 'Reillys', 40.6302795410156, 0.709132153996413, -78.6697235107422, -1.37304569689604, 218, 45, 'PPL', 'P'),
(74041, 'Reily', 39.4336090087891, 0.688246313147467, -84.7611083984375, -1.47936041919255, 218, 41, 'PPL', 'P'),
(28390, 'Reily Lake', 37.9791717529297, 0.662861594269049, -89.9208297729492, -1.56941454566331, 218, 18, 'PPL', 'P'),
(208536, 'Reiman', 47.2249984741211, 0.824231712622711, -118.68083190918, -2.07137127582113, 218, 56, 'PPL', 'P'),
(42774, 'Reimer Crossing', 30.7430591583252, 0.536567604448171, -90.9216690063477, -1.58688248556925, 218, 22, 'PPL', 'P'),
(79014, 'Reimold', 39.7580604553223, 0.693909059152329, -76.6191711425781, -1.33725680658701, 218, 45, 'PPL', 'P'),
(97456, 'Reina Colonia', 26.2749996185303, 0.458585254303607, -98.4390029907227, -1.71808471456866, 218, 51, 'PPL', 'P'),
(97457, 'Reina del Sol Mobile Home Estates Colonia', 26.2360000610352, 0.457904583618497, -98.0619964599609, -1.71150470930534, 218, 51, 'PPL', 'P'),
(117487, 'Reinbeck', 42.3236083984375, 0.738686317877458, -92.5991668701172, -1.6161603464872, 218, 16, 'PPL', 'P'),
(205494, 'Reindeer Hills', 40.6197204589844, 0.70894786324898, -111.797782897949, -1.95123940799902, 218, 52, 'PPL', 'P'),
(74043, 'Reinersville', 39.6866683959961, 0.692663032657309, -81.6611099243164, -1.42525523901234, 218, 41, 'PPL', 'P'),
(166389, 'Reinerton', 40.5922203063965, 0.70846789504152, -76.5327835083008, -1.33574905793587, 218, 45, 'PPL', 'P'),
(97458, 'Reinhardt', 32.8349990844727, 0.573078843913372, -96.6888885498047, -1.68753945528794, 218, 51, 'PPL', 'P'),
(166390, 'Reinholds', 40.2666702270508, 0.702785974276809, -76.1158294677734, -1.32847183709917, 218, 45, 'PPL', 'P'),
(166391, 'Reinoeldville', 40.357780456543, 0.704376147763695, -76.4225006103516, -1.33382425825801, 218, 45, 'PPL', 'P'),
(42771, 'Reisor', 32.4113883972168, 0.565685442674121, -93.850830078125, -1.63800599059301, 218, 22, 'PPL', 'P'),
(166393, 'Reissing', 40.3427810668945, 0.70411435902854, -80.1991729736328, -1.39973962576634, 218, 45, 'PPL', 'P'),
(197357, 'Reistad Trailer Court', 45.6583290100098, 0.796888172183513, -110.994438171387, -1.93721839749197, 218, 31, 'PPL', 'P'),
(50765, 'Reisterstown', 39.4694404602051, 0.688871689950445, -76.829719543457, -1.34093156941716, 218, 25, 'PPL', 'P'),
(166396, 'Reistville', 40.327220916748, 0.703842783176379, -76.3030624389648, -1.33173966891475, 218, 45, 'PPL', 'P'),
(208537, 'Reiter', 47.8413887023926, 0.834989751583168, -121.629722595215, -2.12283912757384, 218, 56, 'PPL', 'P'),
(166395, 'Reitz', 40.1375007629395, 0.70053154183503, -78.8111114501953, -1.37551338196211, 218, 45, 'PPL', 'P'),
(97459, 'Rek Hill', 29.9322204589844, 0.522415799442086, -96.6399993896484, -1.68668617847468, 218, 51, 'PPL', 'P'),
(24280, 'Reka', 32.1391716003418, 0.560934363289419, -81.6774978637695, -1.42554126251341, 218, 13, 'PPL', 'P'),
(184489, 'Reka (historical)', 36.6888885498047, 0.640341904091339, -119.550827026367, -2.08655555509233, 218, 6, 'PPL', 'P'),
(97460, 'Reklaw', 31.8624992370605, 0.556105519600888, -94.9875030517578, -1.65784467650134, 218, 51, 'PPL', 'P'),
(193904, 'Rekwoi (historical)', 41.5416717529297, 0.725038948871347, -124.050003051758, -2.16508099036219, 218, 6, 'PPL', 'P'),
(97461, 'Relampago', 26.0847206115723, 0.455264259134765, -97.918327331543, -1.70899720998098, 218, 51, 'PPL', 'P'),
(17777, 'Relay', 29.3080596923828, 0.511522139003116, -81.2705612182617, -1.41843887820228, 218, 12, 'PPL', 'P'),
(24281, 'Relay', 34.0988883972168, 0.595137873801525, -85.1916732788086, -1.48687519399848, 218, 13, 'PPL', 'P'),
(50771, 'Relay', 39.2277793884277, 0.684653908574032, -76.7033309936523, -1.33872567308625, 218, 25, 'PPL', 'P'),
(79017, 'Relay', 39.9247207641602, 0.696817830273941, -76.6488876342773, -1.33777545720931, 218, 45, 'PPL', 'P'),
(50766, 'Relda Square', 39.1355590820313, 0.683044360590215, -77.2466735839844, -1.34820879025386, 218, 25, 'PPL', 'P'),
(24282, 'Relee', 31.7608299255371, 0.554331055366568, -82.9330596923828, -1.44745495038508, 218, 13, 'PPL', 'P'),
(11537, 'Relfs Bluff', 33.8011093139648, 0.589940648355208, -91.8427810668945, -1.60295892380562, 218, 4, 'PPL', 'P'),
(14477, 'Reliance', 38.6352806091309, 0.674312854061254, -75.706672668457, -1.32133070379418, 218, 10, 'PPL', 'P'),
(90265, 'Reliance', 35.186939239502, 0.614127943428499, -84.4991683959961, -1.47478870370727, 218, 50, 'PPL', 'P'),
(97462, 'Reliance', 30.7430591583252, 0.536567604448171, -96.2388916015625, -1.67968552691718, 218, 51, 'PPL', 'P'),
(105650, 'Reliance', 39.003059387207, 0.680731804657645, -78.2458267211914, -1.36564730222975, 218, 53, 'PPL', 'P'),
(166397, 'Reliance', 40.3141708374023, 0.70361501632415, -75.3394393920898, -1.31492127399868, 218, 45, 'PPL', 'P'),
(171170, 'Reliance', 43.8788909912109, 0.765831119920309, -99.602783203125, -1.73839651104464, 218, 49, 'PPL', 'P'),
(208538, 'Reliance', 46.7727813720703, 0.816339035258098, -122.264717102051, -2.13392187245021, 218, 56, 'PPL', 'P'),
(209693, 'Reliance', 41.6691703796387, 0.72726421969919, -109.196388244629, -1.90583650615481, 218, 59, 'PPL', 'P'),
(205495, 'Relico', 41.2152786254883, 0.719342314141613, -112.009170532227, -1.95492881821516, 218, 52, 'PPL', 'P'),
(37892, 'Relief', 37.9447212219238, 0.662260319073937, -82.9952774047852, -1.44854085431956, 218, 21, 'PPL', 'P'),
(68160, 'Relief', 36.0341682434082, 0.628914879065055, -82.2936096191406, -1.43629444120488, 218, 33, 'PPL', 'P'),
(74044, 'Relief', 39.5888900756836, 0.690956479030786, -81.688606262207, -1.42573514064077, 218, 41, 'PPL', 'P'),
(184490, 'Relief', 39.3613891601563, 0.686985839003532, -120.859718322754, -2.10940001776497, 218, 6, 'PPL', 'P'),
(208539, 'Relief', 46.4533309936523, 0.810763574357963, -118.084716796875, -2.06096710439052, 218, 56, 'PPL', 'P'),
(157314, 'Relief (historical)', 41.0727806091309, 0.716855254578616, -82.7997207641602, -1.44512774706651, 218, 41, 'PPL', 'P'),
(152037, 'Relius', 42.920280456543, 0.74910020984605, -76.6586074829102, -1.33794510057075, 218, 40, 'PPL', 'P'),
(37893, 'Rella', 36.8344383239746, 0.642882226876139, -83.633056640625, -1.45967220188581, 218, 21, 'PPL', 'P'),
(142831, 'Rellers Park', 41.3824996948242, 0.722260872380231, -96.3000030517578, -1.68075212293376, 218, 35, 'PPL', 'P'),
(5349, 'Rembert', 32.2177810668945, 0.562306357304001, -87.8697204589844, -1.5336159348163, 218, 2, 'PPL', 'P'),
(83249, 'Rembert', 34.0955581665039, 0.595079750310734, -80.5336074829102, -1.40557660908553, 218, 48, 'PPL', 'P'),
(57134, 'Rembert (historical)', 37.2430610656738, 0.650014039117316, -92.5475006103516, -1.6152586001421, 218, 29, 'PPL', 'P'),
(117488, 'Rembrandt', 42.8255615234375, 0.747447052599383, -95.1661071777344, -1.66096190655727, 218, 16, 'PPL', 'P'),
(166398, 'Rembrant', 40.6952781677246, 0.71026659404176, -79.0091705322266, -1.37897016505703, 218, 45, 'PPL', 'P'),
(166399, 'Remeos Mobile Home Park', 40.2119407653809, 0.701830764972825, -76.8652801513672, -1.3415522191092, 218, 45, 'PPL', 'P'),
(137671, 'Remer', 47.0561103820801, 0.821284059349184, -93.9158325195313, -1.63914049721738, 218, 28, 'PPL', 'P'),
(24284, 'Remerton', 30.8438892364502, 0.538327421296496, -83.3105621337891, -1.45404361092193, 218, 13, 'PPL', 'P'),
(128646, 'Remick Corners', 43.1019401550293, 0.752270769702816, -70.7436065673828, -1.23470885933631, 218, 26, 'PPL', 'P'),
(117489, 'Remicker (historical)', 42.4772186279297, 0.741367322146841, -93.7013931274414, -1.63539782377944, 218, 16, 'PPL', 'P'),
(184491, 'Remillard (historical)', 37.6713905334473, 0.657489798613278, -121.852500915527, -2.12672734276536, 218, 6, 'PPL', 'P'),
(157311, 'Reminderville', 41.3458290100098, 0.721620848191258, -81.3952789306641, -1.42061561291926, 218, 41, 'PPL', 'P'),
(74045, 'Remington', 39.2280616760254, 0.684658835422048, -84.3213882446289, -1.47168585472122, 218, 41, 'PPL', 'P'),
(77079, 'Remington', 36.6444396972656, 0.639566125265799, -96.720832824707, -1.68809698806215, 218, 42, 'PPL', 'P'),
(105651, 'Remington', 38.5336112976074, 0.672538389826934, -77.8086090087891, -1.35801641360029, 218, 53, 'PPL', 'P'),
(123526, 'Remington', 40.7608299255371, 0.711410688046058, -87.1508331298828, -1.52106898397261, 218, 19, 'PPL', 'P'),
(152038, 'Remington Corners', 44.1233291625977, 0.770097370828562, -75.3625030517578, -1.31532381079745, 218, 40, 'PPL', 'P'),
(50767, 'Remington Farms', 39.1811103820801, 0.683839380754631, -76.17138671875, -1.32944149405207, 218, 25, 'PPL', 'P'),
(184492, 'Remington Hill (historical)', 39.2786102294922, 0.685541074112164, -120.792778015137, -2.10823168899476, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(205497, 'Remington Place', 40.6763916015625, 0.709936961277835, -111.948890686035, -1.95387673642653, 218, 52, 'PPL', 'P'),
(5350, 'Remlap', 33.8166694641113, 0.590212224207369, -86.600830078125, -1.51146961982342, 218, 2, 'PPL', 'P'),
(17778, 'Remlap', 27.8319396972656, 0.485758984933799, -82.3819427490234, -1.43783614515993, 218, 12, 'PPL', 'P'),
(83250, 'Remleys (historical)', 32.8541717529297, 0.57341347010434, -79.9033279418945, -1.39457615588684, 218, 48, 'PPL', 'P'),
(83251, 'Remleys Point', 32.8097190856934, 0.572637624699773, -79.8938903808594, -1.39441143937342, 218, 48, 'PPL', 'P'),
(105652, 'Remlik', 37.6613883972168, 0.657315228403823, -76.6191711425781, -1.33725680658701, 218, 53, 'PPL', 'P'),
(11539, 'Remmel', 35.5469398498535, 0.620411139388323, -91.1630630493164, -1.59109560641375, 218, 4, 'PPL', 'P'),
(184493, 'Remnoy', 36.3397216796875, 0.634247792568911, -119.553329467773, -2.08659923093421, 218, 6, 'PPL', 'P'),
(105653, 'Remo', 37.8158302307129, 0.660010746901147, -76.3530578613281, -1.33261225364592, 218, 53, 'PPL', 'P'),
(42772, 'Remolina Landing', 32.1100006103516, 0.560425233468024, -91.4019393920898, -1.59526478510027, 218, 22, 'PPL', 'P'),
(97463, 'Remolino', 26.3866691589355, 0.460534255457868, -98.9072189331055, -1.72625662437356, 218, 51, 'PPL', 'P'),
(201464, 'Remote', 43.0061111450195, 0.750598237959219, -123.891387939453, -2.16231263440905, 218, 43, 'PPL', 'P'),
(74046, 'Rempel', 38.9361114501953, 0.679563342729372, -82.521110534668, -1.44026508123213, 218, 41, 'PPL', 'P'),
(50768, 'Remsberg Acres', 39.4324989318848, 0.688226938650536, -77.5397186279297, -1.35332339112735, 218, 25, 'PPL', 'P'),
(50769, 'Remsburg Heights', 39.4533309936523, 0.688590526718359, -77.3116683959961, -1.34934316372018, 218, 25, 'PPL', 'P'),
(113208, 'Remsen', 43.3269386291504, 0.756197733888193, -75.1872177124023, -1.31226450449522, 218, 40, 'PPL', 'P'),
(117490, 'Remsen', 42.8147201538086, 0.747257835003933, -95.9730606079102, -1.6750459008241, 218, 16, 'PPL', 'P'),
(157313, 'Remsen Corners', 41.1886100769043, 0.718876860162095, -81.741943359375, -1.42666604859981, 218, 41, 'PPL', 'P'),
(146159, 'Remsen Mill', 40.1980590820313, 0.701588483892655, -74.0702819824219, -1.29277029847389, 218, 37, 'PPL', 'P'),
(152040, 'Remsenburg', 40.8074989318848, 0.712225215865458, -72.7091674804688, -1.26901436891817, 218, 40, 'PPL', 'P'),
(71326, 'Remsterville', 39.5597190856934, 0.69044734920939, -75.3377838134766, -1.31489237870086, 218, 37, 'PPL', 'P'),
(97464, 'Remuda RV Park Colonia', 26.1730003356934, 0.45680503098343, -98.0869979858398, -1.71194106824995, 218, 51, 'PPL', 'P'),
(24285, 'Remus', 33.9861106872559, 0.593169531439848, -84.8930587768555, -1.4816633877452, 218, 13, 'PPL', 'P'),
(61513, 'Remus', 32.8686103820801, 0.573665471722489, -89.3436126708984, -1.5593402067337, 218, 30, 'PPL', 'P'),
(132802, 'Remus', 43.5966682434082, 0.760905403747126, -85.1447219848633, -1.48605573933107, 218, 27, 'PPL', 'P'),
(111091, 'Remus (historical)', 39.160831451416, 0.683485446645759, -81.6911087036133, -1.42577881648265, 218, 58, 'PPL', 'P'),
(137674, 'Remus Trailer Lots', 44.7247200012207, 0.780593621053864, -94.4855575561523, -1.64908407493747, 218, 28, 'PPL', 'P'),
(42773, 'Remy', 30.0205593109131, 0.523957603265673, -90.7411117553711, -1.58373116705136, 218, 22, 'PPL', 'P'),
(77073, 'Remy', 35.4563903808594, 0.618830753018442, -94.5338897705078, -1.64992763121275, 218, 42, 'PPL', 'P'),
(90266, 'Remy', 36.4858283996582, 0.636797835891689, -84.0522232055664, -1.46698803855832, 218, 50, 'PPL', 'P'),
(68161, 'Ren', 35.8080596923828, 0.624968540382748, -76.7763900756836, -1.34000079461618, 218, 33, 'PPL', 'P'),
(11540, 'Rena', 35.4869384765625, 0.619363917868676, -94.3574981689453, -1.64684901699262, 218, 4, 'PPL', 'P'),
(68162, 'Rena', 36.1872215270996, 0.631586162796459, -80.8097229003906, -1.41039573223608, 218, 33, 'PPL', 'P'),
(208540, 'Rena', 48.0894393920898, 0.839319052830228, -123.185562133789, -2.14999365015467, 218, 56, 'PPL', 'P'),
(61514, 'Rena Lara', 34.1497192382813, 0.596025039339658, -90.7802810668945, -1.58441480050318, 218, 30, 'PPL', 'P'),
(178973, 'Renaissance', 33.3516693115234, 0.582096440522434, -111.923606872559, -1.9534354506339, 218, 5, 'PPL', 'P'),
(37894, 'Renaker', 38.4627799987793, 0.671302150448919, -84.4255599975586, -1.47350399479741, 218, 21, 'PPL', 'P'),
(105654, 'Renan', 36.9747200012207, 0.645330604024303, -79.1941680908203, -1.38219898156265, 218, 53, 'PPL', 'P'),
(97465, 'Renarae Colonia Number 1', 26.3010005950928, 0.459039056953357, -98.1139984130859, -1.71241231460484, 218, 51, 'PPL', 'P'),
(28391, 'Renault', 38.1536102294922, 0.665906120027228, -90.1338882446289, -1.57313311749339, 218, 18, 'PPL', 'P'),
(152041, 'Renchans', 42.4402809143066, 0.74072263742596, -77.3252792358398, -1.34958071768941, 218, 40, 'PPL', 'P'),
(189334, 'Rencona', 35.3025016784668, 0.61614488848007, -105.662780761719, -1.84416342110491, 218, 38, 'PPL', 'P'),
(28392, 'Rend City', 38.0269393920898, 0.663695296848299, -88.9847183227539, -1.55307631869178, 218, 18, 'PPL', 'P'),
(5351, 'Rendalia', 33.3175010681152, 0.581500092175338, -86.1572189331055, -1.50372714474429, 218, 2, 'PPL', 'P'),
(184494, 'Rendalia', 33.8902816772461, 0.591496999696251, -118.133056640625, -2.06181079382386, 218, 6, 'PPL', 'P'),
(74047, 'Rendcomb Junction', 39.1300010681152, 0.682947354947509, -84.4072189331055, -1.47318388283439, 218, 41, 'PPL', 'P'),
(11541, 'Rendezvous', 33.5099983215332, 0.584859803048528, -92.8311080932617, -1.62020848450217, 218, 4, 'PPL', 'P'),
(209694, 'Rendezvous', 41.0530586242676, 0.716511041007723, -109.952217102051, -1.9190282082984, 218, 59, 'PPL', 'P'),
(68163, 'Rendleman (historical)', 35.582218170166, 0.621026862232349, -80.3897171020508, -1.40306524817758, 218, 33, 'PPL', 'P'),
(97466, 'Rendon', 32.5761108398438, 0.568560391649889, -97.2411117553711, -1.69717756843099, 218, 51, 'PPL', 'P'),
(74048, 'Rendville', 39.6194381713867, 0.69148964388102, -82.0911102294922, -1.43276016012224, 218, 41, 'PPL', 'P'),
(166400, 'Rene Mont', 40.6780586242676, 0.709966056312744, -75.9669418334961, -1.32587325766552, 218, 45, 'PPL', 'P'),
(90267, 'Renegade', 35.8847198486328, 0.626306512514404, -84.8583297729492, -1.4810572522811, 218, 50, 'PPL', 'P'),
(83252, 'Renfrew', 34.9797210693359, 0.610511304089144, -82.460563659668, -1.43920833891159, 218, 48, 'PPL', 'P'),
(125937, 'Renfrew', 42.6377792358398, 0.744169633403877, -73.1130599975586, -1.27606362316555, 218, 23, 'PPL', 'P'),
(166401, 'Renfrew', 40.8066711425781, 0.712210768216545, -79.9649963378906, -1.3956524724414, 218, 45, 'PPL', 'P'),
(195520, 'Renfrew', 47.1441688537598, 0.822820969614269, -116.4375, -2.0322177477909, 218, 17, 'PPL', 'P'),
(57135, 'Renfro', 38.8613891601563, 0.678259192743561, -92.5072174072266, -1.61455552561432, 218, 29, 'PPL', 'P'),
(37896, 'Renfro Valley', 37.3877792358398, 0.652539847674175, -84.331672668457, -1.47186535177869, 218, 21, 'PPL', 'P'),
(5352, 'Renfroe', 33.4311103820801, 0.583482948764957, -86.2016677856445, -1.50450292356983, 218, 2, 'PPL', 'P'),
(24288, 'Renfroe', 32.2324981689453, 0.562563219191139, -84.7125015258789, -1.47851206922731, 218, 13, 'PPL', 'P'),
(61515, 'Renfroe', 32.8594398498535, 0.573505415740975, -89.4511108398438, -1.56121640372166, 218, 30, 'PPL', 'P'),
(5353, 'Renfroe Valley', 33.6963882446289, 0.588112920899087, -87.9027786254883, -1.53419290866647, 218, 2, 'PPL', 'P'),
(37895, 'Renfrow', 37.4166717529297, 0.653044117226581, -86.6922225952148, -1.51306472015832, 218, 21, 'PPL', 'P'),
(77074, 'Renfrow', 36.9255599975586, 0.644472600100107, -97.6555633544922, -1.70441111342581, 218, 42, 'PPL', 'P'),
(37897, 'Renick', 38.0583305358887, 0.664243175663555, -84.206672668457, -1.46968369021369, 218, 21, 'PPL', 'P'),
(57136, 'Renick', 39.3427810668945, 0.686661066508597, -92.4136123657227, -1.61292180944361, 218, 29, 'PPL', 'P'),
(74049, 'Renick', 39.2983283996582, 0.68588522110403, -82.9538879394531, -1.44781847187387, 218, 41, 'PPL', 'P'),
(74050, 'Renick Junction', 39.313060760498, 0.686142349307277, -82.9336090087891, -1.447464537765, 218, 41, 'PPL', 'P'),
(111092, 'Renicks Valley', 38.0544395446777, 0.664175265055758, -80.3033294677734, -1.40155749952643, 218, 58, 'PPL', 'P'),
(152042, 'Reniff', 42.1163902282715, 0.735069678538104, -76.54638671875, -1.33598647874705, 218, 40, 'PPL', 'P'),
(50770, 'Renix (historical)', 39.5583305358887, 0.69042311444347, -78.8619384765625, -1.37640048092122, 218, 25, 'PPL', 'P'),
(50772, 'Renn Branch Estates', 39.3699989318848, 0.68713610786804, -77.4824981689453, -1.35232470571857, 218, 25, 'PPL', 'P'),
(967, 'Rennbore', 35.9294395446777, 0.627087018450879, -84.1211090087891, -1.46819032263243, 218, 50, 'PPL', 'P'),
(123527, 'Renner', 40.4722213745117, 0.706373518581255, -85.4313888549805, -1.491059020071, 218, 19, 'PPL', 'P'),
(171173, 'Renner', 43.6455612182617, 0.761758747139414, -96.7280578613281, -1.68822308873976, 218, 49, 'PPL', 'P'),
(171174, 'Renner Corner', 43.6452789306641, 0.761753820291398, -96.7111129760742, -1.68792734470071, 218, 49, 'PPL', 'P'),
(166402, 'Rennerdale', 40.3983306884766, 0.705083882823384, -80.1416702270508, -1.39873601350955, 218, 45, 'PPL', 'P'),
(68164, 'Rennert', 34.8141708374023, 0.607621907464462, -79.0811080932617, -1.38022571235295, 218, 33, 'PPL', 'P'),
(28393, 'Rennerville', 39.4566688537598, 0.688648783367205, -88.8072204589844, -1.54997839655375, 218, 18, 'PPL', 'P'),
(83254, 'Rennie (historical)', 33.5786094665527, 0.586057293432682, -81.8063888549805, -1.4277908346862, 218, 48, 'PPL', 'P'),
(166403, 'Renningers', 40.6500015258789, 0.709476367567306, -76.1486129760742, -1.32904401725937, 218, 45, 'PPL', 'P'),
(83253, 'Renno', 34.4727783203125, 0.601663483999574, -81.769172668457, -1.42714128969633, 218, 48, 'PPL', 'P'),
(200160, 'Rennox', 40.6980590820313, 0.710315130152626, -116.879173278809, -2.03992640072419, 218, 39, 'PPL', 'P'),
(166404, 'Rennyson', 40.0644416809082, 0.699256420305099, -75.456672668457, -1.31696738066419, 218, 45, 'PPL', 'P'),
(13196, 'Reno', 38.9527816772461, 0.679854293078463, -77.07861328125, -1.34527558462924, 218, 9, 'PPL', 'P'),
(24286, 'Reno', 30.773609161377, 0.537100802587919, -84.2922210693359, -1.47117679147885, 218, 13, 'PPL', 'P'),
(28394, 'Reno', 38.9749984741211, 0.680242049333179, -89.5138931274414, -1.56231216135218, 218, 18, 'PPL', 'P'),
(30949, 'Reno', 39.7102813720703, 0.693075156835998, -86.670280456543, -1.51268175759357, 218, 19, 'PPL', 'P'),
(33738, 'Reno', 39.0511093139648, 0.681570434084911, -95.1197204589844, -1.66015230558589, 218, 20, 'PPL', 'P'),
(74051, 'Reno', 39.3727798461914, 0.687184643978907, -81.3958282470703, -1.42062520029918, 218, 41, 'PPL', 'P'),
(97468, 'Reno', 32.9441719055176, 0.574984269094296, -97.5769424438477, -1.70303891967414, 218, 51, 'PPL', 'P'),
(132803, 'Reno', 43.0750007629395, 0.751800588612363, -85.8386077880859, -1.49816633123015, 218, 27, 'PPL', 'P'),
(137677, 'Reno', 47.4180603027344, 0.827601277191934, -91.9502792358398, -1.60483512079358, 218, 28, 'PPL', 'P'),
(166405, 'Reno', 41.4097213745117, 0.722735980318701, -79.7525024414063, -1.39194375430736, 218, 45, 'PPL', 'P'),
(190658, 'Reno', 39.5297203063965, 0.68992377173908, -119.812782287598, -2.09112753689372, 218, 39, 'PPL', 'P'),
(202548, 'Reno', 43.9147186279297, 0.76645643014426, -103.616943359375, -1.80845682247357, 218, 49, 'PPL', 'P'),
(157315, 'Reno Beach', 41.663330078125, 0.727162287208468, -83.2694396972656, -1.45332588900816, 218, 41, 'PPL', 'P'),
(184495, 'Reno Junction', 39.7919387817383, 0.694500347493354, -120.098892211914, -2.09612109709568, 218, 6, 'PPL', 'P'),
(190660, 'Reno-Stead', 39.6580581665039, 0.692163689952919, -119.876106262207, -2.09223274874611, 218, 39, 'PPL', 'P'),
(157316, 'Renollet (historical)', 41.2455596923828, 0.71987081845994, -84.4961090087891, -1.47473530732741, 218, 41, 'PPL', 'P'),
(61516, 'Renova', 33.7786102294922, 0.589547965252476, -90.7213897705078, -1.58338695348046, 218, 30, 'PPL', 'P'),
(137679, 'Renova', 43.7386093139648, 0.763382742772145, -92.7655563354492, -1.61906439049787, 218, 28, 'PPL', 'P'),
(197358, 'Renova', 45.815559387207, 0.799632359949758, -112.126937866211, -1.95698424594449, 218, 31, 'PPL', 'P'),
(97470, 'Renova (historical)', 31.2066802978516, 0.544659319814754, -94.8212127685547, -1.65494236354537, 218, 51, 'PPL', 'P'),
(184496, 'Renoville', 35.5527801513672, 0.620513071879045, -116.188331604004, -2.02786893888885, 218, 6, 'PPL', 'P'),
(166406, 'Renovo', 41.3263893127441, 0.721281561468382, -77.751106262207, -1.35701280134349, 218, 45, 'PPL', 'P'),
(74052, 'Renrock', 39.7580604553223, 0.693909059152329, -81.6727828979492, -1.42545897083573, 218, 41, 'PPL', 'P'),
(111094, 'Rensford', 38.3138885498047, 0.668703504436247, -81.4811096191406, -1.42211364103243, 218, 58, 'PPL', 'P'),
(28395, 'Renshaw', 37.3544387817383, 0.651957946975993, -88.6783294677734, -1.54772882438096, 218, 18, 'PPL', 'P'),
(61517, 'Renshaw', 32.9205589294434, 0.574572144915606, -90.3791732788086, -1.57741414894569, 218, 30, 'PPL', 'P'),
(184497, 'Renshaw Place', 35.1722183227539, 0.613871014962333, -120.261672973633, -2.09896215734657, 218, 6, 'PPL', 'P'),
(208543, 'Renslow', 46.957218170166, 0.819558064646704, -120.305000305176, -2.0997183619381, 218, 56, 'PPL', 'P'),
(5354, 'Renson', 31.5538902282715, 0.550719276296203, -87.2838897705078, -1.52339126044316, 218, 2, 'PPL', 'P'),
(57137, 'Rensselaer', 39.6705589294434, 0.692381869425224, -91.5444412231445, -1.5977519112423, 218, 29, 'PPL', 'P'),
(123528, 'Rensselaer', 40.9366683959961, 0.714479648307238, -87.1508331298828, -1.52106898397261, 218, 19, 'PPL', 'P'),
(152043, 'Rensselaer', 42.6425018310547, 0.744252058239615, -73.7433319091797, -1.28706394320618, 218, 40, 'PPL', 'P'),
(152045, 'Rensselaer Falls', 44.5919418334961, 0.778276204852304, -75.3194427490234, -1.31457226673783, 218, 40, 'PPL', 'P'),
(152047, 'Rensselaerville', 42.5161094665527, 0.742046095329675, -74.1383285522461, -1.29395793516202, 218, 40, 'PPL', 'P'),
(68166, 'Renston', 35.5088882446289, 0.619747013591484, -77.456672668457, -1.35187396570408, 218, 33, 'PPL', 'P'),
(28396, 'Rentchler', 38.4913902282715, 0.671801493153309, -89.8730621337891, -1.56858084308406, 218, 18, 'PPL', 'P'),
(77078, 'Rentiesville', 35.5213890075684, 0.619965193063789, -95.4947204589844, -1.66669729028087, 218, 42, 'PPL', 'P'),
(166408, 'Renton', 40.5016708374023, 0.70688750867164, -79.7266693115234, -1.3914928811348, 218, 45, 'PPL', 'P'),
(208541, 'Renton', 47.4830589294434, 0.82873571723728, -122.215827941895, -2.13306859563694, 218, 56, 'PPL', 'P'),
(166409, 'Renton Junction', 40.4902801513672, 0.706688703696265, -79.7405624389648, -1.39173536195206, 218, 45, 'PPL', 'P'),
(211088, 'Renton Village', 21.3447208404541, 0.372535656584975, -158.037780761719, -2.75827961683694, 218, 15, 'PPL', 'P'),
(24287, 'Rentz', 32.3833312988281, 0.565195753928682, -82.9913864135742, -1.44847294371176, 218, 13, 'PPL', 'P'),
(137680, 'Renville', 44.7891693115234, 0.781718473719286, -95.2113876342773, -1.66175219961075, 218, 28, 'PPL', 'P'),
(198796, 'Renville', 48.7630615234375, 0.851075976936546, -101.29972076416, -1.76801365868546, 218, 34, 'PPL', 'P'),
(117492, 'Renwick', 42.8280601501465, 0.747490661862233, -93.980827331543, -1.6402748706837, 218, 16, 'PPL', 'P'),
(152049, 'Renwick', 42.4661102294922, 0.741173444019483, -76.5, -1.33517687777566, 218, 40, 'PPL', 'P'),
(24290, 'Reo', 34.7152786254883, 0.605895912761982, -85.1080627441406, -1.48541591487917, 218, 13, 'PPL', 'P'),
(30950, 'Reo', 37.9013900756836, 0.661504047903382, -87.1094436645508, -1.52034660152693, 218, 19, 'PPL', 'P'),
(50773, 'Reo Vista Plaza', 38.8186111450195, 0.677512575531957, -76.6944427490234, -1.33857054395275, 218, 25, 'PPL', 'P'),
(105655, 'Repass', 36.9888916015625, 0.645577945110544, -81.8055572509766, -1.42777632045826, 218, 53, 'PPL', 'P'),
(71327, 'Repaupo', 39.7997207641602, 0.694636168708948, -75.2991714477539, -1.31421846578701, 218, 37, 'PPL', 'P'),
(111095, 'Replete', 38.7005615234375, 0.675452220954617, -80.4641723632813, -1.40436473763148, 218, 58, 'PPL', 'P'),
(171175, 'Reppert Addition', 43.5736083984375, 0.760502933527388, -96.7944412231445, -1.689381696972, 218, 49, 'PPL', 'P'),
(5355, 'Repton', 31.4088897705078, 0.548188540891328, -87.2391662597656, -1.52261068792766, 218, 2, 'PPL', 'P'),
(37898, 'Repton', 37.3886108398438, 0.652554361902116, -88.0169372558594, -1.53618535263601, 218, 21, 'PPL', 'P'),
(105656, 'Repton Mills', 38.3224983215332, 0.668853773300755, -78.2555618286133, -1.3658172119073, 218, 53, 'PPL', 'P'),
(5356, 'Republic', 33.6011085510254, 0.586449976535414, -86.8908309936523, -1.51653109063317, 218, 2, 'PPL', 'P'),
(33742, 'Republic', 39.9236106872559, 0.696798455777011, -97.8213882446289, -1.70730530374045, 218, 20, 'PPL', 'P'),
(37899, 'Republic', 37.372501373291, 0.652273198670031, -82.3630599975586, -1.43750657897503, 218, 21, 'PPL', 'P'),
(57138, 'Republic', 37.1199989318848, 0.647866199698168, -93.4800033569336, -1.63153384335384, 218, 29, 'PPL', 'P'),
(79015, 'Republic', 39.9625015258789, 0.697477228959845, -79.8769378662109, -1.39411556217631, 218, 45, 'PPL', 'P'),
(111096, 'Republic', 38.0091705322266, 0.663385171739359, -81.3927764892578, -1.42057193707738, 218, 58, 'PPL', 'P'),
(117493, 'Republic', 42.9511108398438, 0.7496383015443, -92.397216796875, -1.61263565278448, 218, 16, 'PPL', 'P'),
(132804, 'Republic', 46.4066696166992, 0.809949179696616, -87.9755630493164, -1.53546323650643, 218, 27, 'PPL', 'P'),
(157321, 'Republic', 41.121940612793, 0.717713258502812, -83.0158309936523, -1.44889958211839, 218, 41, 'PPL', 'P'),
(208542, 'Republic', 48.6483306884766, 0.849073546112916, -118.736671447754, -2.07234585962205, 218, 56, 'PPL', 'P'),
(197359, 'Republic (historical)', 46.4036102294922, 0.80989578331676, -108.536666870117, -1.89432219602379, 218, 31, 'PPL', 'P'),
(11542, 'Republican', 35.2813911437988, 0.615776440143258, -92.4250030517578, -1.61312061441898, 218, 4, 'PPL', 'P'),
(68167, 'Republican', 36.082218170166, 0.629753508492321, -77.0602798461914, -1.34495560582427, 218, 33, 'PPL', 'P'),
(142832, 'Republican City', 40.0997200012207, 0.699872143149126, -99.2200012207031, -1.73171570513406, 218, 35, 'PPL', 'P'),
(105657, 'Republican Grove', 36.9449996948242, 0.644811886822983, -79.0441665649414, -1.37958096105304, 218, 53, 'PPL', 'P'),
(177427, 'Requa', 44.586669921875, 0.778184192636642, -91.1447219848633, -1.59077549445073, 218, 57, 'PPL', 'P'),
(193905, 'Requa', 41.5469398498535, 0.725130894507982, -124.065277099609, -2.1653475727873, 218, 6, 'PPL', 'P'),
(17779, 'Rerdell', 28.5672206878662, 0.498592059147105, -82.1563873291016, -1.43389946043657, 218, 12, 'PPL', 'P'),
(24289, 'Resaca', 34.5802803039551, 0.603539747566562, -84.9433288574219, -1.48254076616632, 218, 13, 'PPL', 'P'),
(68168, 'Resaca', 35.0699996948242, 0.612086963348089, -77.7583312988281, -1.35713890202111, 218, 33, 'PPL', 'P'),
(157317, 'Resaca', 40.0494384765625, 0.698994564990918, -83.3880615234375, -1.45539623043958, 218, 41, 'PPL', 'P'),
(57140, 'Rescue', 37.1916694641113, 0.649117086462178, -93.9786071777344, -1.64023612168984, 218, 29, 'PPL', 'P'),
(105658, 'Rescue', 36.9958305358887, 0.645699052361115, -76.5608291625977, -1.33623854694422, 218, 53, 'PPL', 'P'),
(142834, 'Rescue (historical)', 41.3444404602051, 0.721596613425338, -96.8694381713867, -1.69069064064777, 218, 35, 'PPL', 'P'),
(61518, 'Rescue Landing', 34.2361106872559, 0.597532854569833, -90.8291702270508, -1.58526807731644, 218, 30, 'PPL', 'P'),
(5357, 'Rescueville', 31.6991691589355, 0.553254871970067, -88.2652816772461, -1.54051978046817, 218, 2, 'PPL', 'P'),
(176056, 'Reseburg', 44.9152793884277, 0.783919509781209, -90.7600021362305, -1.58406086639431, 218, 57, 'PPL', 'P'),
(184498, 'Reseda', 34.2011108398438, 0.596921991994796, -118.53556060791, -2.06883581330532, 218, 6, 'PPL', 'P'),
(190662, 'Reservation (historical)', 39.0541687011719, 0.681623830464767, -118.902496337891, -2.07524004993669, 218, 39, 'PPL', 'P'),
(33745, 'Reserve', 39.9772186279297, 0.697734090846983, -95.5616683959961, -1.66786575220914, 218, 20, 'PPL', 'P'),
(42775, 'Reserve', 30.0536098480225, 0.524534443957785, -90.5516662597656, -1.58042471939997, 218, 22, 'PPL', 'P'),
(176054, 'Reserve', 45.8813896179199, 0.800781314223046, -91.3863906860352, -1.59499340898519, 218, 57, 'PPL', 'P'),
(189335, 'Reserve', 33.7130584716797, 0.588403871248178, -108.757217407227, -1.89817152906339, 218, 38, 'PPL', 'P'),
(197360, 'Reserve', 48.6055603027344, 0.848327062059367, -104.459167480469, -1.82315640642637, 218, 31, 'PPL', 'P'),
(125933, 'Reservoir', 42.3347206115723, 0.738880262583843, -71.1488876342773, -1.24178234834962, 218, 23, 'PPL', 'P'),
(166411, 'Reservoir', 40.4066696166992, 0.705229424576956, -78.3805618286133, -1.36799887347229, 218, 45, 'PPL', 'P'),
(166413, 'Reservoir Heights', 40.5374984741211, 0.70751281889559, -76.9327774047852, -1.3427302684174, 218, 45, 'PPL', 'P'),
(166412, 'Reservoir Hill', 40.185001373291, 0.701360583882371, -76.9749984741211, -1.34346716509102, 218, 45, 'PPL', 'P'),
(50783, 'Reservoir Ridge', 39.3988914489746, 0.687640377420446, -76.870002746582, -1.34163464394494, 218, 25, 'PPL', 'P'),
(50774, 'Resh Mill Farms', 39.6594390869141, 0.692187791560784, -76.8038864135742, -1.34048069624461, 218, 25, 'PPL', 'P'),
(166414, 'Resica Falls', 41.1113891601563, 0.717529100913433, -75.0950012207031, -1.31065502309043, 218, 45, 'PPL', 'P'),
(74054, 'Residence Park', 39.7550010681152, 0.693855662772473, -84.2622222900391, -1.47065321400854, 218, 41, 'PPL', 'P'),
(152050, 'Residence Park', 40.9011116027832, 0.713859065194222, -73.7838897705078, -1.28777181142392, 218, 40, 'PPL', 'P'),
(166415, 'Resler', 40.7816696166992, 0.711774409271935, -76.7583312988281, -1.33968560950117, 218, 45, 'PPL', 'P'),
(152051, 'Resort', 43.226390838623, 0.754442843887885, -76.9241714477539, -1.34258006613192, 218, 40, 'PPL', 'P'),
(17780, 'Resota Beach', 30.3033294677734, 0.528892873529267, -85.5936126708984, -1.49389035978392, 218, 12, 'PPL', 'P'),
(50775, 'Resourceful Acres', 39.4272193908691, 0.68813479327682, -77.2094421386719, -1.34755897894788, 218, 25, 'PPL', 'P'),
(24291, 'Resseaus Crossroads', 33.2011108398438, 0.579468699474853, -83.434440612793, -1.45620569825291, 218, 13, 'PPL', 'P'),
(33746, 'Rest', 37.6530609130859, 0.657169886387332, -95.6602783203125, -1.6695868200636, 218, 20, 'PPL', 'P'),
(105659, 'Rest', 39.2902793884277, 0.685744739356528, -78.0830612182617, -1.36280650829496, 218, 53, 'PPL', 'P'),
(11543, 'Rest (historical)', 33.8788909912109, 0.591298194720876, -91.9002838134766, -1.60396253606242, 218, 4, 'PPL', 'P'),
(24292, 'Rest (historical)', 33.3919410705566, 0.582799315313134, -84.4697189331055, -1.47427471361688, 218, 13, 'PPL', 'P'),
(90268, 'Rest (historical)', 36.3105583190918, 0.63373879590557, -86.9822235107422, -1.51812619096807, 218, 50, 'PPL', 'P'),
(24294, 'Rest Haven', 32.9505615234375, 0.575095788964943, -84.1952819824219, -1.46948488523832, 218, 13, 'PPL', 'P'),
(50776, 'Rest Haven', 38.7780609130859, 0.676804840472268, -76.5400009155273, -1.33587502545543, 218, 25, 'PPL', 'P'),
(68170, 'Rest Haven', 35.4269409179688, 0.618316762928057, -76.7311096191406, -1.3392105015627, 218, 33, 'PPL', 'P'),
(97471, 'Restful Valley Ranch Colonia', 26.2399997711182, 0.45797439172857, -98.4039993286133, -1.71747378541459, 218, 51, 'PPL', 'P'),
(121191, 'Resthaven', 41.2619400024414, 0.72015670880296, -88.1361083984375, -1.53826528144736, 218, 18, 'PPL', 'P'),
(105660, 'Reston', 38.9686088562012, 0.680130529462532, -77.3413925170898, -1.34986194750052, 218, 53, 'PPL', 'P'),
(201465, 'Reston', 43.1302795410156, 0.752765385296271, -123.61888885498, -2.15755662817633, 218, 43, 'PPL', 'P'),
(152052, 'Result', 42.3569412231445, 0.739268085417586, -73.9483337402344, -1.2906419001307, 218, 40, 'PPL', 'P'),
(187252, 'Resurrection Mill', 39.235279083252, 0.684784802941609, -106.276390075684, -1.8548729239545, 218, 7, 'PPL', 'P'),
(445, 'Retreat', 31.7027797698975, 0.553317889019361, -81.4141693115234, -1.42094531226221, 218, 13, 'PPL', 'P'),
(30953, 'Retreat', 38.8244400024414, 0.677614308285598, -85.8533325195313, -1.49842332627534, 218, 19, 'PPL', 'P'),
(42776, 'Retreat', 30.9719390869141, 0.540562312793777, -91.4850006103516, -1.59671447683966, 218, 22, 'PPL', 'P'),
(61519, 'Retreat', 33.8647193908691, 0.591050853634635, -89.4580612182617, -1.56133771070932, 218, 30, 'PPL', 'P'),
(68171, 'Retreat', 35.4505615234375, 0.618729020264801, -82.9091720581055, -1.44703803251642, 218, 33, 'PPL', 'P'),
(71329, 'Retreat', 39.916389465332, 0.696672421678423, -74.7130584716797, -1.30398886456585, 218, 37, 'PPL', 'P'),
(83255, 'Retreat', 34.6277809143066, 0.604368789613903, -83.0569381713867, -1.44961703771606, 218, 48, 'PPL', 'P'),
(97473, 'Retreat', 32.0338897705078, 0.559096848716292, -96.4741668701172, -1.68379185500198, 218, 51, 'PPL', 'P'),
(176055, 'Retreat', 43.4455604553223, 0.75826807531962, -91.0805587768555, -1.58965563521235, 218, 57, 'PPL', 'P'),
(50777, 'Retreat Farms', 39.5561103820801, 0.69038436544961, -76.663330078125, -1.33802752540648, 218, 25, 'PPL', 'P'),
(50778, 'Retreat Grove (historical)', 39.4708290100098, 0.688895924716364, -77.3819427490234, -1.35056968256021, 218, 25, 'PPL', 'P'),
(77081, 'Retrop', 35.1597213745117, 0.613652902069056, -99.3594436645508, -1.73414943489623, 218, 42, 'PPL', 'P'),
(208544, 'Retsil', 47.5461082458496, 0.829836135399701, -122.610000610352, -2.13994820652289, 218, 56, 'PPL', 'P'),
(152053, 'Retsof', 42.8352813720703, 0.747616695960821, -77.8791732788086, -1.3592479924464, 218, 40, 'PPL', 'P'),
(11544, 'Retta', 35.5166702270508, 0.619882834807078, -92.9488906860352, -1.6222641785476, 218, 4, 'PPL', 'P'),
(97474, 'Retta', 32.5522193908691, 0.568143407202209, -97.2352828979492, -1.69707583567735, 218, 51, 'PPL', 'P'),
(166416, 'Retta', 41.7291717529297, 0.728311441218837, -76.0583267211914, -1.32746822484237, 218, 45, 'PPL', 'P'),
(83256, 'Return', 34.639720916748, 0.604577181969202, -82.9955596923828, -1.44854578116757, 218, 48, 'PPL', 'P'),
(105661, 'Retz', 37.4288902282715, 0.653257369850869, -76.353889465332, -1.33262676787386, 218, 53, 'PPL', 'P'),
(201466, 'Reuben', 46.0088882446289, 0.803006585050889, -122.876106262207, -2.14459262630594, 218, 43, 'PPL', 'P'),
(83257, 'Reuben (historical)', 34.3536109924316, 0.599583621767249, -81.4747161865234, -1.42200205458275, 218, 48, 'PPL', 'P'),
(195521, 'Reubens', 46.3222198486328, 0.808475253191312, -116.54167175293, -2.03403588786709, 218, 17, 'PPL', 'P'),
(90273, 'Reubensville', 36.5913887023926, 0.638640210733806, -86.5924987792969, -1.5113242112279, 218, 50, 'PPL', 'P'),
(5359, 'Reubenville', 33.3694381713867, 0.582406565631374, -86.2380599975586, -1.50513808748981, 218, 2, 'PPL', 'P'),
(17781, 'Reunion', 28.2800006866455, 0.493579124448221, -81.6083297729492, -1.42433405159128, 218, 12, 'PPL', 'P'),
(105663, 'Reusens', 37.4580612182617, 0.653766499672265, -79.1883316040039, -1.38209711565095, 218, 53, 'PPL', 'P'),
(42777, 'Reussite', 29.7008304595947, 0.518377282096549, -89.9861068725586, -1.57055384597764, 218, 22, 'PPL', 'P'),
(197361, 'Reuter (historical)', 48.8227806091309, 0.852118271608176, -114.338890075684, -1.99559009489655, 218, 31, 'PPL', 'P'),
(105662, 'Reva', 38.4938888549805, 0.671845102416159, -78.1336135864258, -1.36368881356411, 218, 53, 'PPL', 'P'),
(202549, 'Reva', 45.545280456543, 0.794915102710901, -103.083892822266, -1.79915333552149, 218, 49, 'PPL', 'P'),
(42778, 'Reveille', 30.271390914917, 0.5283354406236, -91.1875, -1.59152211166233, 218, 22, 'PPL', 'P'),
(190663, 'Reveille (historical)', 38.0305595397949, 0.663758480345161, -116.170280456543, -2.0275538869319, 218, 39, 'PPL', 'P'),
(11545, 'Revel', 35.2299995422363, 0.614879487488119, -91.2813873291016, -1.59316075468106, 218, 4, 'PPL', 'P'),
(50779, 'Revell', 39.042781829834, 0.68142509206842, -76.5216674804688, -1.33555504665045, 218, 25, 'PPL', 'P'),
(50780, 'Revell Downs', 39.0277786254883, 0.681163236754237, -76.4372177124023, -1.33408112014515, 218, 25, 'PPL', 'P'),
(37900, 'Revelo', 36.6833305358887, 0.640244898448633, -84.4705581665039, -1.47428936100288, 218, 21, 'PPL', 'P'),
(74053, 'Revenge', 39.603328704834, 0.691208480648935, -82.6519393920898, -1.44254847555077, 218, 41, 'PPL', 'P'),
(189336, 'Reventon', 33.7949981689453, 0.589833988753551, -105.639442443848, -1.84375609061619, 218, 38, 'PPL', 'P'),
(105666, 'Revercombs Corner', 38.5525016784668, 0.672868089169886, -78.2366714477539, -1.36548751256434, 218, 53, 'PPL', 'P'),
(68172, 'Revere', 35.9025001525879, 0.626616837360425, -82.7033309936523, -1.44344542820591, 218, 33, 'PPL', 'P'),
(113079, 'Revere', 42.4083290100098, 0.740164971493698, -71.0124969482422, -1.23940188180925, 218, 23, 'PPL', 'P'),
(137683, 'Revere', 44.2238883972168, 0.771852460565951, -95.3641662597656, -1.6644186896522, 218, 28, 'PPL', 'P'),
(139421, 'Revere', 40.4949989318848, 0.706771061952976, -91.6774978637695, -1.60007418771285, 218, 29, 'PPL', 'P'),
(140766, 'Revere', 47.3555603027344, 0.826510446409437, -98.3283309936523, -1.71615312383002, 218, 34, 'PPL', 'P'),
(166417, 'Revere', 40.5152816772461, 0.707125062640875, -75.1613922119141, -1.31181376448072, 218, 45, 'PPL', 'P'),
(208545, 'Revere', 47.0813903808594, 0.821725278562783, -117.929168701172, -2.05825227797529, 218, 56, 'PPL', 'P'),
(24295, 'Revere (historical)', 33.0275001525879, 0.576438621365588, -84.1761093139648, -1.46915025904735, 218, 13, 'PPL', 'P'),
(50781, 'Revere Park', 39.4022216796875, 0.687698500911237, -76.5236129760742, -1.33558900195435, 218, 25, 'PPL', 'P'),
(71330, 'Revere Run', 39.7755584716797, 0.694214457150334, -75.0386123657227, -1.30967085190959, 218, 37, 'PPL', 'P'),
(195522, 'Reverse', 43.0258293151855, 0.750942384951085, -115.605827331543, -2.01770232142748, 218, 17, 'PPL', 'P'),
(11546, 'Revilee', 35.160831451416, 0.613672276565986, -93.7777786254883, -1.63673100222113, 218, 4, 'PPL', 'P'),
(171176, 'Revillo', 45.0166702270508, 0.785689113746539, -96.5708312988281, -1.68547896755254, 218, 49, 'PPL', 'P'),
(90270, 'Revilo', 35.1394386291504, 0.613298901381157, -87.2686080932617, -1.52312454485999, 218, 50, 'PPL', 'P'),
(90271, 'Revilo (historical)', 35.9205589294434, 0.626932022475436, -83.6177825927734, -1.4594056194607, 218, 50, 'PPL', 'P'),
(105664, 'Revis', 37.6705589294434, 0.657475284385337, -76.6555633544922, -1.337891970507, 218, 53, 'PPL', 'P'),
(105665, 'Revistown (historical)', 36.7083282470703, 0.640681190814215, -77.7761077880859, -1.3574491602881, 218, 53, 'PPL', 'P'),
(112419, 'Revisville', 36.8830604553223, 0.643730843157492, -93.6477813720703, -1.63446212213044, 218, 29, 'PPL', 'P'),
(61520, 'Revive', 32.7594413757324, 0.571760113120592, -89.7641677856445, -1.56668027817212, 218, 30, 'PPL', 'P'),
(166418, 'Revloc', 40.4922218322754, 0.706722592421137, -78.7644424438477, -1.37469885414271, 218, 45, 'PPL', 'P'),
(68173, 'Revolution', 36.1019401550293, 0.630097722063213, -79.7783279418945, -1.39239449432185, 218, 33, 'PPL', 'P'),
(111097, 'Revore', 38.9747200012207, 0.68023718906419, -80.9994430541992, -1.41370697357743, 218, 58, 'PPL', 'P'),
(166419, 'Rew', 41.9013900756836, 0.731317217983155, -78.539436340332, -1.37077175679928, 218, 45, 'PPL', 'P'),
(166420, 'Reward', 40.5552787780762, 0.707823143741612, -77.07861328125, -1.34527558462924, 218, 45, 'PPL', 'P'),
(184501, 'Reward', 36.747501373291, 0.641364890845066, -118.054168701172, -2.06043393954029, 218, 6, 'PPL', 'P'),
(50782, 'Rewastico', 38.4061088562012, 0.670313052420064, -75.7652816772461, -1.32235362396888, 218, 25, 'PPL', 'P'),
(176057, 'Rewey', 42.8427810668945, 0.747747590328399, -90.3952789306641, -1.57769524559875, 218, 57, 'PPL', 'P'),
(11547, 'Rex', 35.6025009155273, 0.621380862920248, -92.7058334350586, -1.61802202924722, 218, 4, 'PPL', 'P'),
(17782, 'Rex', 29.6299991607666, 0.517141042718534, -82.0975036621094, -1.43287174657191, 218, 12, 'PPL', 'P'),
(24296, 'Rex', 33.5919418334961, 0.586289987132928, -84.2699966430664, -1.47078890206608, 218, 13, 'PPL', 'P'),
(37902, 'Rex', 37.2227783203125, 0.649660038429418, -85.7855606079102, -1.49724048327718, 218, 21, 'PPL', 'P'),
(57141, 'Rex', 37.5361099243164, 0.655128706569841, -93.248893737793, -1.62750021956681, 218, 29, 'PPL', 'P'),
(68174, 'Rex', 34.8569412231445, 0.608368391518012, -79.0494384765625, -1.37967297326871, 218, 33, 'PPL', 'P'),
(184500, 'Rex', 34.9452781677246, 0.609910162052086, -120.376106262207, -2.10095939500608, 218, 6, 'PPL', 'P'),
(194397, 'Rex', 40.788890838623, 0.711900443370523, -105.177780151367, -1.8356985635801, 218, 7, 'PPL', 'P'),
(57142, 'Rex City', 37.0536117553711, 0.646707524886901, -94.4686126708984, -1.64878833089841, 218, 29, 'PPL', 'P'),
(61521, 'Rexburg', 33.4311103820801, 0.583482948764957, -90.8438873291016, -1.58552493920358, 218, 30, 'PPL', 'P'),
(105667, 'Rexburg', 37.9363899230957, 0.662114910478418, -76.9872207641602, -1.34368048429434, 218, 53, 'PPL', 'P'),
(195523, 'Rexburg', 43.8261108398438, 0.764909932499251, -111.788887023926, -1.95108414570747, 218, 17, 'PPL', 'P'),
(117494, 'Rexfield', 41.0816688537598, 0.717010383712113, -92.9522171020508, -1.62232223545937, 218, 16, 'PPL', 'P'),
(61522, 'Rexford', 32.0424995422363, 0.5592471175808, -90.0747222900391, -1.57210047678071, 218, 30, 'PPL', 'P'),
(152054, 'Rexford', 42.8530616760254, 0.747927020806843, -73.8883285522461, -1.28959461203203, 218, 40, 'PPL', 'P'),
(157318, 'Rexford', 40.3163909912109, 0.703653765318011, -80.9475021362305, -1.41280043354237, 218, 41, 'PPL', 'P'),
(166421, 'Rexford', 41.7511100769043, 0.728694337204563, -77.5038909912109, -1.3526980809034, 218, 45, 'PPL', 'P'),
(187866, 'Rexford', 39.4716682434082, 0.68891057210236, -100.743057250977, -1.75829804755469, 218, 20, 'PPL', 'P'),
(197362, 'Rexford', 48.8994407653809, 0.853456243739832, -115.171112060547, -2.01011510863989, 218, 31, 'PPL', 'P'),
(90272, 'Rexford (historical)', 36.3694381713867, 0.634766443191204, -82.1661071777344, -1.43406910379801, 218, 50, 'PPL', 'P'),
(187253, 'Rexford (historical)', 39.5338897705078, 0.689996542615867, -105.895278930664, -1.84822127965787, 218, 7, 'PPL', 'P'),
(125935, 'Rexhame', 42.1138916015625, 0.735026069275254, -70.6750030517578, -1.23351150211021, 218, 23, 'PPL', 'P'),
(166424, 'Rexis', 40.4863891601563, 0.706620793088468, -78.9225006103516, -1.37745748955787, 218, 45, 'PPL', 'P'),
(152055, 'Rexleigh', 43.1352806091309, 0.752852670400999, -73.3552780151367, -1.28029112507995, 218, 40, 'PPL', 'P'),
(166422, 'Rexmont', 40.2772216796875, 0.702970131866188, -76.3827819824219, -1.33313103742626, 218, 45, 'PPL', 'P'),
(77082, 'Rexroat', 34.2163887023926, 0.597188640998941, -97.4044418334961, -1.70002821606181, 218, 42, 'PPL', 'P'),
(37903, 'Rexton', 38.5686111450195, 0.673149252401971, -83.1222229003906, -1.45075647118845, 218, 21, 'PPL', 'P'),
(132808, 'Rexton', 46.1586112976074, 0.805619745291502, -85.2399978637695, -1.48771861711571, 218, 27, 'PPL', 'P'),
(166423, 'Rextown', 40.75, 0.711221670187689, -75.6377792358398, -1.32012828656201, 218, 45, 'PPL', 'P'),
(30954, 'Rexville', 38.9524993896484, 0.679849366230447, -85.336669921875, -1.48940586282433, 218, 19, 'PPL', 'P'),
(37904, 'Rexville', 37.8236083984375, 0.660146501537714, -83.3711090087891, -1.45510035324248, 218, 21, 'PPL', 'P'),
(97475, 'Rexville', 29.726110458374, 0.518818501310148, -96.2130584716797, -1.67923465374463, 218, 51, 'PPL', 'P'),
(152056, 'Rexville', 42.084171295166, 0.734507352073933, -77.6624984741211, -1.35546630369849, 218, 40, 'PPL', 'P'),
(208546, 'Rexville', 48.3655586242676, 0.844138242559808, -122.424438476563, -2.13670953632125, 218, 56, 'PPL', 'P'),
(14478, 'Reybold', 39.5922203063965, 0.691014602521577, -75.6305618286133, -1.32000231904245, 218, 10, 'PPL', 'P'),
(11552, 'Reydell', 34.1572189331055, 0.596155933707235, -91.567497253418, -1.59815431488301, 218, 4, 'PPL', 'P'),
(77083, 'Reydon', 35.6536102294922, 0.62227288872737, -99.9186096191406, -1.74390872186888, 218, 42, 'PPL', 'P'),
(152057, 'Reydon Shores', 41.0466690063477, 0.716399521137076, -72.3994369506836, -1.26360855137947, 218, 40, 'PPL', 'P'),
(97476, 'Reyes', 27.8388900756836, 0.485880291921452, -98.4272232055664, -1.7178791185325, 218, 51, 'PPL', 'P'),
(184502, 'Reyes Place', 39.8461112976074, 0.69544583625936, -123.406669616699, -2.15385270373225, 218, 6, 'PPL', 'P'),
(178974, 'Reymert', 33.2297210693359, 0.579968042179243, -111.208610534668, -1.94095641039801, 218, 5, 'PPL', 'P'),
(97477, 'Reyna Colonia', 26.3950004577637, 0.460679664053387, -98.8280029296875, -1.72487404429365, 218, 51, 'PPL', 'P'),
(152058, 'Reynales Basin', 43.2066688537598, 0.754098630316992, -78.54638671875, -1.37089306378693, 218, 40, 'PPL', 'P'),
(97478, 'Reynard', 31.4102802276611, 0.548212808946761, -95.6544418334961, -1.66948495415191, 218, 51, 'PPL', 'P'),
(200161, 'Reynard', 40.503059387207, 0.70691174343756, -119.638610839844, -2.08808767166745, 218, 39, 'PPL', 'P'),
(57143, 'Reynard (historical)', 38.1636085510254, 0.666080623657655, -94.1361083984375, -1.64298503656702, 218, 29, 'PPL', 'P'),
(105668, 'Reynard Woods', 38.103328704834, 0.66502854186902, -78.5513916015625, -1.37098041547069, 218, 53, 'PPL', 'P'),
(11549, 'Reyno', 36.3627815246582, 0.634650262788649, -90.7536087036133, -1.58394927994463, 218, 4, 'PPL', 'P'),
(83258, 'Reynold', 33.3666687011719, 0.582358229257589, -81.3305587768555, -1.4194860331429, 218, 48, 'PPL', 'P'),
(68175, 'Reynolda', 36.1252784729004, 0.630505052551941, -80.2855606079102, -1.40124737441749, 218, 33, 'PPL', 'P'),
(68176, 'Reynolda Park', 36.1199989318848, 0.630412907178224, -80.2869415283203, -1.40127147602536, 218, 33, 'PPL', 'P'),
(5360, 'Reynolds', 34.6330604553223, 0.60446093498762, -87.1727828979492, -1.52145207969542, 218, 2, 'PPL', 'P'),
(11551, 'Reynolds', 35.9819412231445, 0.628003345602948, -93.5994415283203, -1.6336184326971, 218, 4, 'PPL', 'P'),
(24297, 'Reynolds', 32.5597190856934, 0.568274301569787, -84.0963897705078, -1.46775889053584, 218, 13, 'PPL', 'P'),
(42780, 'Reynolds', 31.2166690826416, 0.544833656997614, -92.227783203125, -1.60967847871005, 218, 22, 'PPL', 'P'),
(50784, 'Reynolds', 39.5091705322266, 0.689565110519274, -79.0280609130859, -1.37929986439999, 218, 25, 'PPL', 'P'),
(57145, 'Reynolds', 37.4008293151855, 0.652767614526404, -91.0733337402344, -1.58952953453473, 218, 29, 'PPL', 'P'),
(77084, 'Reynolds', 34.6652793884277, 0.60502326145179, -95.9308319091797, -1.67430887099242, 218, 42, 'PPL', 'P'),
(90274, 'Reynolds', 35.894718170166, 0.626481016144831, -86.4499969482422, -1.50883708508588, 218, 50, 'PPL', 'P'),
(121192, 'Reynolds', 41.329719543457, 0.721339684959173, -90.670280456543, -1.58249492767334, 218, 18, 'PPL', 'P'),
(123529, 'Reynolds', 40.749439239502, 0.711211883070683, -86.8716735839844, -1.51619673075831, 218, 19, 'PPL', 'P'),
(140769, 'Reynolds', 47.6722183227539, 0.832037171461624, -97.1063919067383, -1.69482626350456, 218, 34, 'PPL', 'P'),
(142836, 'Reynolds', 40.0597190856934, 0.699173995469362, -97.3352813720703, -1.69882113829773, 218, 35, 'PPL', 'P'),
(152059, 'Reynolds', 42.8902816772461, 0.74857663237574, -73.6630630493164, -1.28566298731475, 218, 40, 'PPL', 'P'),
(157319, 'Reynolds', 41.6558303833008, 0.72703139284089, -81.3772201538086, -1.42030042780425, 218, 41, 'PPL', 'P'),
(166425, 'Reynolds', 40.7408294677734, 0.711061614206176, -75.9744415283203, -1.3260041520331, 218, 45, 'PPL', 'P'),
(184503, 'Reynolds', 38.1483306884766, 0.665813974653511, -122.881942749023, -2.14469449221763, 218, 6, 'PPL', 'P'),
(192109, 'Reynolds', 32.8427810668945, 0.573214665128966, -100.234718322754, -1.74942585954114, 218, 51, 'PPL', 'P'),
(195524, 'Reynolds', 43.2013893127441, 0.754006484943275, -116.74333190918, -2.03755552156374, 218, 17, 'PPL', 'P'),
(205500, 'Reynolds', 40.7077789306641, 0.710484773514064, -112.096939086914, -1.95646066847418, 218, 52, 'PPL', 'P'),
(184505, 'Reynolds (historical)', 36.2277793884277, 0.632294031014202, -119.072776794434, -2.07821200455517, 218, 6, 'PPL', 'P'),
(208547, 'Reynolds (historical)', 46.5494384765625, 0.812440966370549, -123.340278625488, -2.15269396234196, 218, 56, 'PPL', 'P'),
(113973, 'Reynolds Bridge', 41.6572189331055, 0.72705562760681, -73.0802764892578, -1.27549144300535, 218, 8, 'PPL', 'P'),
(197363, 'Reynolds City', 46.8211097717285, 0.817182524954353, -113.286109924316, -1.97721561495555, 218, 31, 'PPL', 'P'),
(105669, 'Reynolds Corner', 37.9019393920898, 0.661513635283306, -76.545280456543, -1.33596717082914, 218, 53, 'PPL', 'P'),
(128647, 'Reynolds Corner', 44.6597213745117, 0.779459181008517, -69.3605575561523, -1.21057010037389, 218, 26, 'PPL', 'P'),
(152060, 'Reynolds Corner', 44.0902786254883, 0.76952053013645, -76.0427780151367, -1.32719684872729, 218, 40, 'PPL', 'P'),
(152061, 'Reynolds Corners', 43.252498626709, 0.754898510750398, -73.6419372558594, -1.28529427266182, 218, 40, 'PPL', 'P'),
(157320, 'Reynolds Corners', 41.6533317565918, 0.72698778357804, -83.6647186279297, -1.46022480781201, 218, 41, 'PPL', 'P'),
(97481, 'Reynolds Crossing', 33.0355606079102, 0.576579302850172, -99.3227767944336, -1.73350947728629, 218, 51, 'PPL', 'P'),
(68177, 'Reynolds Crossroads', 35.0683288574219, 0.612057801734153, -78.4327774047852, -1.36891020719731, 218, 33, 'PPL', 'P'),
(24298, 'Reynolds Estates', 33.7008285522461, 0.588190418886808, -84.7388916015625, -1.47897266293784, 218, 13, 'PPL', 'P'),
(57147, 'Reynolds Ford', 37.4277801513672, 0.653237995353939, -89.8361129760742, -1.5679359586261, 218, 29, 'PPL', 'P'),
(166426, 'Reynolds Heights', 41.3450012207031, 0.721606400542344, -80.3944396972656, -1.40314767301332, 218, 45, 'PPL', 'P'),
(5361, 'Reynolds Mill', 33.355281829834, 0.582159490861242, -86.2158279418945, -1.50475006491899, 218, 2, 'PPL', 'P'),
(14479, 'Reynolds Mill', 38.813060760498, 0.677415703047305, -75.3444366455078, -1.31500849252438, 218, 10, 'PPL', 'P'),
(79018, 'Reynolds Mill', 39.8950004577637, 0.696299113072621, -76.7427825927734, -1.33941423338609, 218, 45, 'PPL', 'P'),
(105670, 'Reynolds Mill', 36.6363906860352, 0.639425643518298, -80.1286087036133, -1.39850804692024, 218, 53, 'PPL', 'P'),
(184506, 'Reynolds Place (historical)', 39.6738891601563, 0.692439992916014, -122.711669921875, -2.14172267075721, 218, 6, 'PPL', 'P'),
(157322, 'Reynolds Road Cottage Area', 40.1288909912109, 0.700381272970522, -81.1730575561523, -1.41673711826572, 218, 41, 'PPL', 'P'),
(178975, 'Reynolds Trailer Court', 33.413890838623, 0.583182411035941, -111.89582824707, -1.95295062215745, 218, 5, 'PPL', 'P'),
(197364, 'Reynolds Trailer Court', 46.6116714477539, 0.813527136621138, -112.063888549805, -1.95588382778207, 218, 31, 'PPL', 'P'),
(28397, 'Reynoldsburg', 37.5152816772461, 0.654765185081045, -88.7758331298828, -1.54943058431752, 218, 18, 'PPL', 'P'),
(74055, 'Reynoldsburg', 39.954719543457, 0.697341407744251, -82.8122177124023, -1.44534585995979, 218, 41, 'PPL', 'P'),
(90275, 'Reynoldsburg (historical)', 36.0833282470703, 0.629772882989251, -87.9402770996094, -1.53484738050435, 218, 50, 'PPL', 'P'),
(166427, 'Reynoldsdale', 40.1474990844727, 0.700706045465457, -78.5577774047852, -1.37109186876231, 218, 45, 'PPL', 'P'),
(68178, 'Reynoldson', 36.5280609130859, 0.637534932302396, -76.7925033569336, -1.34028202442729, 218, 33, 'PPL', 'P'),
(152062, 'Reynoldston', 44.7430610656738, 0.780913733016891, -74.4499969482422, -1.29939757484656, 218, 40, 'PPL', 'P'),
(166428, 'Reynoldstown', 41.9036102294922, 0.731355966977015, -77.8861083984375, -1.35936903311794, 218, 45, 'PPL', 'P'),
(24299, 'Reynoldsville', 30.8569393157959, 0.538555188148725, -84.7780609130859, -1.47965629638966, 218, 13, 'PPL', 'P'),
(28398, 'Reynoldsville', 37.3672218322754, 0.652181053296314, -89.3949966430664, -1.56023702623079, 218, 18, 'PPL', 'P'),
(37905, 'Reynoldsville', 38.1902809143066, 0.666546144216201, -83.8236083984375, -1.46299795745511, 218, 21, 'PPL', 'P'),
(111098, 'Reynoldsville', 39.288330078125, 0.685710717473602, -80.4349975585938, -1.40385554123106, 218, 58, 'PPL', 'P'),
(152063, 'Reynoldsville', 42.4669418334961, 0.741187958247424, -76.7705612182617, -1.33989906186254, 218, 40, 'PPL', 'P'),
(166429, 'Reynoldsville', 41.0969390869141, 0.717276899558203, -78.8888931274414, -1.37687092832778, 218, 45, 'PPL', 'P'),
(198799, 'Rhame', 46.2324981689453, 0.806909314470345, -103.654998779297, -1.80912101484943, 218, 34, 'PPL', 'P'),
(68181, 'Rhamkatte', 35.7480583190918, 0.623921318863102, -78.6736068725586, -1.37311347434579, 218, 33, 'PPL', 'P'),
(166431, 'Rhawnhurst', 40.0616683959961, 0.699208017352287, -75.0561065673828, -1.30997618332857, 218, 45, 'PPL', 'P'),
(11554, 'Rhea', 36.0141716003418, 0.6285658718042, -94.4027786254883, -1.6476393100461, 218, 4, 'PPL', 'P'),
(37906, 'Rhea', 36.8988914489746, 0.644007146120588, -83.2538909912109, -1.45305451289308, 218, 21, 'PPL', 'P'),
(77085, 'Rhea', 35.8416709899902, 0.625555168191865, -99.2344436645508, -1.73196777333124, 218, 42, 'PPL', 'P'),
(192110, 'Rhea', 34.6711082458496, 0.605124994205431, -102.948608398438, -1.79679217689902, 218, 51, 'PPL', 'P'),
(5362, 'Rhea (historical)', 34.0222206115723, 0.593799768511815, -86.1194381713867, -1.50306774605838, 218, 2, 'PPL', 'P'),
(97479, 'Rhea Mills', 33.2622184753418, 0.580535228912403, -96.732780456543, -1.6883055135755, 218, 51, 'PPL', 'P'),
(90277, 'Rhea Springs (historical)', 35.6758308410645, 0.622660711561113, -84.82861328125, -1.4805386016588, 218, 50, 'PPL', 'P'),
(68182, 'Rheasville', 36.4102783203125, 0.635479238256964, -77.7005615234375, -1.35613062923241, 218, 33, 'PPL', 'P'),
(964, 'Rheatown', 36.2311096191406, 0.632352154504993, -82.6958312988281, -1.44331453383833, 218, 50, 'PPL', 'P'),
(37907, 'Rheber', 37.2591705322266, 0.650295202349402, -85.0219421386719, -1.48391282675993, 218, 21, 'PPL', 'P'),
(184508, 'Rheem', 37.8608283996582, 0.660796113106611, -122.126106262207, -2.13150265691598, 218, 6, 'PPL', 'P'),
(184509, 'Rheem Valley', 37.8600006103516, 0.660781665457698, -122.122779846191, -2.13144460000421, 218, 6, 'PPL', 'P'),
(166432, 'Rheems', 40.1300010681152, 0.700400647467452, -76.5708312988281, -1.33641311715368, 218, 45, 'PPL', 'P'),
(152064, 'Rheims', 42.4008293151855, 0.74003407712612, -77.2541732788086, -1.34833968462143, 218, 40, 'PPL', 'P'),
(68183, 'Rhems', 35.0724983215332, 0.612130572610939, -77.1783294677734, -1.34701596040161, 218, 33, 'PPL', 'P'),
(83259, 'Rhems', 33.5927810668945, 0.586304634518923, -79.4413909912109, -1.38651383516079, 218, 48, 'PPL', 'P'),
(83260, 'Rheuark Landing', 33.7305603027344, 0.58870933582521, -79.0425033569336, -1.37955193259716, 218, 48, 'PPL', 'P'),
(24300, 'Rhine', 31.9894409179688, 0.558321069890752, -83.2002792358398, -1.45211881124408, 218, 13, 'PPL', 'P'),
(176059, 'Rhine', 43.8627815246582, 0.765549956688224, -87.956672668457, -1.53513353716348, 218, 57, 'PPL', 'P'),
(152065, 'Rhinebeck', 41.9266700744629, 0.731758437196754, -73.9130630493164, -1.29002631044473, 218, 40, 'PPL', 'P'),
(152067, 'Rhinecliff', 41.9194412231445, 0.731632269940111, -73.9516677856445, -1.29070009020052, 218, 40, 'PPL', 'P'),
(5363, 'Rhinehart', 34.3702812194824, 0.59987457211634, -85.5536117553711, -1.49319221210415, 218, 2, 'PPL', 'P'),
(42781, 'Rhinehart', 31.6375007629395, 0.552178555415511, -92.0066680908203, -1.60581929197442, 218, 22, 'PPL', 'P'),
(57148, 'Rhineland', 38.7174987792969, 0.675747831835616, -91.517219543457, -1.59727680330383, 218, 29, 'PPL', 'P'),
(97480, 'Rhineland', 33.5297203063965, 0.585204016619421, -99.6547164916992, -1.73930291792164, 218, 51, 'PPL', 'P'),
(176061, 'Rhinelander', 45.6366691589355, 0.796510136466777, -89.4119415283203, -1.56053277026984, 218, 57, 'PPL', 'P'),
(152068, 'Rhinelander Gardens (historical)', 40.735279083252, 0.710964741721524, -73.9994430541992, -1.29153392593783, 218, 40, 'PPL', 'P'),
(5364, 'Rhoades', 31.2625007629395, 0.545633570720533, -86.1619415283203, -1.50380956958002, 218, 2, 'PPL', 'P'),
(90278, 'Rhoades Hill (historical)', 35.0930595397949, 0.612489433567827, -87.5411071777344, -1.52788055109271, 218, 50, 'PPL', 'P'),
(105671, 'Rhoadesville', 38.2733306884766, 0.667995636218504, -77.9286117553711, -1.36011085663958, 218, 53, 'PPL', 'P'),
(166433, 'Rhoads', 41.0097198486328, 0.715754636679113, -77.8766708374023, -1.35920431660452, 218, 45, 'PPL', 'P'),
(74056, 'Rhoads (historical)', 39.6836090087891, 0.692609636277453, -82.9561080932617, -1.44785722086773, 218, 41, 'PPL', 'P'),
(50785, 'Rhod-Ayr', 39.4655609130859, 0.688803979079729, -77.2733306884766, -1.34867404449629, 218, 25, 'PPL', 'P'),
(37908, 'Rhoda', 37.1558303833008, 0.648491576501145, -86.2252807617188, -1.50491504774852, 218, 21, 'PPL', 'P'),
(111100, 'Rhoda', 38.9797210693359, 0.680324474168917, -81.1222229003906, -1.41584988614856, 218, 58, 'PPL', 'P'),
(97482, 'Rhode Island', 31.8152809143066, 0.555281404401563, -96.2311096191406, -1.67954970570159, 218, 51, 'PPL', 'P'),
(152069, 'Rhode Island', 42.6788902282715, 0.744887155580572, -75.8000030517578, -1.32295962627492, 218, 40, 'PPL', 'P'),
(169573, 'Rhode Island and Providence Plantations', 41.7502784729004, 0.728679822976622, -71.5002822875977, -1.24791534202396, 218, 47, 'ADM1', 'A'),
(172450, 'Rhode Island Corner', 44.3611106872559, 0.774247441334259, -73.0744400024414, -1.27538957709366, 218, 55, 'PPL', 'P'),
(37909, 'Rhodelia', 38.0069389343262, 0.663346223008417, -86.4205627441406, -1.5083233613116, 218, 21, 'PPL', 'P'),
(90279, 'Rhodelia (historical)', 36.3486099243164, 0.634402921702408, -83.8994369506836, -1.46432141535882, 218, 50, 'PPL', 'P'),
(111099, 'Rhodell', 37.6086082458496, 0.656394040982765, -81.3058319091797, -1.41905446788825, 218, 58, 'PPL', 'P'),
(210, 'Rhodes', 31.5780601501465, 0.551141121012871, -86.6916732788086, -1.5130551327784, 218, 2, 'PPL', 'P'),
(30955, 'Rhodes', 39.6094398498535, 0.691315140250592, -87.4130630493164, -1.52564575946397, 218, 19, 'PPL', 'P'),
(42782, 'Rhodes', 30.3061103820801, 0.528941409640134, -91.1213912963867, -1.59036829712005, 218, 22, 'PPL', 'P'),
(61523, 'Rhodes', 31.4319400787354, 0.548590844663498, -88.9655609130859, -1.55274195881692, 218, 30, 'PPL', 'P'),
(68184, 'Rhodes', 36.170280456543, 0.631290485336433, -77.1244430541992, -1.34607546506265, 218, 33, 'PPL', 'P'),
(105672, 'Rhodes', 36.7661094665527, 0.641689663340001, -76.7919387817383, -1.34027217073126, 218, 53, 'PPL', 'P'),
(117495, 'Rhodes', 41.9255599975586, 0.731739062699823, -93.1861114501953, -1.6264044619363, 218, 16, 'PPL', 'P'),
(132810, 'Rhodes', 43.901668548584, 0.766228663292031, -84.1761093139648, -1.46915025904735, 218, 27, 'PPL', 'P'),
(197365, 'Rhodes', 48.2791709899902, 0.84263049390866, -114.473327636719, -1.99793647297496, 218, 31, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(157323, 'Rhodes (historical)', 40.7705612182617, 0.711580531144577, -81.5550003051758, -1.4234032767903, 218, 41, 'PPL', 'P'),
(190665, 'Rhodes (historical)', 38.2783317565918, 0.668082921323232, -118.09610748291, -2.0611659093659, 218, 39, 'PPL', 'P'),
(83262, 'Rhodes Crossroads', 34.0055618286133, 0.593509017899805, -80.1738891601563, -1.39929833997372, 218, 48, 'PPL', 'P'),
(50786, 'Rhodes Point', 37.9741706848145, 0.662774309164322, -76.041389465332, -1.32717261396137, 218, 25, 'PPL', 'P'),
(90280, 'Rhodes Town', 35.5097198486328, 0.619761527819425, -88.4572219848633, -1.54386977080338, 218, 50, 'PPL', 'P'),
(50787, 'Rhodesdale', 38.5761108398438, 0.673280146769548, -75.8363876342773, -1.32359465703685, 218, 25, 'PPL', 'P'),
(208549, 'Rhodesia Beach', 46.6138916015625, 0.813565885614998, -123.955833435059, -2.16343742049545, 218, 56, 'PPL', 'P'),
(5365, 'Rhodesville', 34.8722190856934, 0.608635040522156, -87.8705596923828, -1.5336305822023, 218, 2, 'PPL', 'P'),
(68185, 'Rhodhiss', 35.7738914489746, 0.624372192035652, -81.4313888549805, -1.42124584999122, 218, 33, 'PPL', 'P'),
(68186, 'Rhodo', 35.2174987792969, 0.614661308015814, -83.7522201538086, -1.46175199753911, 218, 33, 'PPL', 'P'),
(201467, 'Rhododendron', 45.329719543457, 0.791152855038946, -121.910003662109, -2.12773095502215, 218, 43, 'PPL', 'P'),
(208548, 'Rhododendron Park', 47.1519393920898, 0.822956591092781, -122.159721374512, -2.13208935130412, 218, 56, 'PPL', 'P'),
(97483, 'Rhome', 33.0533294677734, 0.576889427959111, -97.4716720581055, -1.7012016048381, 218, 51, 'PPL', 'P'),
(187254, 'Rhone', 39.1266708374023, 0.682889231456718, -108.677780151367, -1.8967850873999, 218, 7, 'PPL', 'P'),
(97484, 'Rhonesboro', 32.7544403076172, 0.571672828015864, -95.1405563354492, -1.66051596023274, 218, 51, 'PPL', 'P'),
(68187, 'Rhoney', 35.625560760498, 0.621783333139986, -81.3327789306641, -1.41952478213676, 218, 33, 'PPL', 'P'),
(105673, 'Rhoton Mill', 36.7155609130859, 0.640807424649885, -82.6605606079102, -1.44269894415236, 218, 53, 'PPL', 'P'),
(5366, 'Rhump', 31.3938903808594, 0.547926752156173, -86.5888900756836, -1.51126122746812, 218, 2, 'PPL', 'P'),
(90281, 'Rhyan Springs', 36.4633293151855, 0.636405152788957, -85.2377777099609, -1.48767986812185, 218, 50, 'PPL', 'P'),
(42783, 'Rhymes', 32.3788909912109, 0.565118255940961, -91.8988876342773, -1.60393816813844, 218, 22, 'PPL', 'P'),
(11556, 'Rhyne', 36.3580589294434, 0.634567837952911, -90.1394424438477, -1.57323005655707, 218, 4, 'PPL', 'P'),
(68188, 'Rhyne', 35.2938919067383, 0.615994619615562, -80.9736099243164, -1.41325610040488, 218, 33, 'PPL', 'P'),
(68189, 'Rhyne Crossroad', 34.5552787780762, 0.603103388621952, -78.0088882446289, -1.36151194568907, 218, 33, 'PPL', 'P'),
(190667, 'Rhyolite', 36.9038887023926, 0.644094364646288, -116.828330993652, -2.03903903544897, 218, 39, 'PPL', 'P'),
(57149, 'Rhyse', 37.5691719055176, 0.655705746999034, -91.6861114501953, -1.60022452315638, 218, 29, 'PPL', 'P'),
(125936, 'Rial Side', 42.5499992370605, 0.742637583407782, -70.8958282470703, -1.23736562883978, 218, 23, 'PPL', 'P'),
(74057, 'Rialto', 39.3255615234375, 0.686360528779582, -84.4519424438477, -1.47396445534989, 218, 41, 'PPL', 'P'),
(90282, 'Rialto', 35.6238899230957, 0.62175417152605, -89.6072235107422, -1.56394108383292, 218, 50, 'PPL', 'P'),
(184510, 'Rialto', 34.1063919067383, 0.59526883474813, -117.369438171387, -2.04848313730661, 218, 6, 'PPL', 'P'),
(176063, 'Rib Falls', 44.9711112976074, 0.784893960424069, -89.9036102294922, -1.56911400793429, 218, 57, 'PPL', 'P'),
(176065, 'Rib Lake', 45.3175010681152, 0.790939602414658, -90.2083282470703, -1.57443234063118, 218, 57, 'PPL', 'P'),
(176068, 'Rib Mountain', 44.9127807617188, 0.783875900518359, -89.6752777099609, -1.5651288536791, 218, 57, 'PPL', 'P'),
(17783, 'Ribault Manor', 30.3950004577637, 0.53049283413316, -81.7033309936523, -1.42599213568596, 218, 12, 'PPL', 'P'),
(37910, 'Ribbon', 36.8802795410156, 0.643682307046626, -85.2402801513672, -1.48772354396373, 218, 21, 'PPL', 'P'),
(105674, 'Ribbon', 38.0466690063477, 0.664039643577246, -77.9563903808594, -1.36059568511603, 218, 53, 'PPL', 'P'),
(184511, 'Ribbonwood', 33.5702781677246, 0.585911884837164, -116.498062133789, -2.03327475642755, 218, 6, 'PPL', 'P'),
(189337, 'Ribera', 35.3736114501953, 0.617385988127074, -105.448059082031, -1.84041582081895, 218, 38, 'PPL', 'P'),
(184512, 'Ribier', 35.2527809143066, 0.615277097438868, -118.878608703613, -2.07482313206804, 218, 6, 'PPL', 'P'),
(157324, 'Riblet (historical)', 40.7583312988281, 0.711367078783208, -82.6986083984375, -1.44336300337017, 218, 41, 'PPL', 'P'),
(166434, 'Ribold', 40.7986106872559, 0.712070086731961, -79.9955596923828, -1.39618590360774, 218, 45, 'PPL', 'P'),
(37911, 'Ribolt', 38.5750007629395, 0.673260772272618, -83.5197219848633, -1.45769413898616, 218, 21, 'PPL', 'P'),
(166435, 'Ribot', 40.586109161377, 0.708361235439862, -78.0272216796875, -1.36183192449405, 218, 45, 'PPL', 'P'),
(152070, 'Ricard', 43.4980583190918, 0.759184335892662, -75.9216690063477, -1.3250830977701, 218, 40, 'PPL', 'P'),
(97485, 'Ricardo', 27.4211101531982, 0.478588656725356, -97.850830078125, -1.70781916067278, 218, 51, 'PPL', 'P'),
(184513, 'Ricardo', 35.3738899230957, 0.617390848396064, -117.988327026367, -2.05928478552992, 218, 6, 'PPL', 'P'),
(189338, 'Ricardo (historical)', 34.3905601501465, 0.600228506225212, -104.384719848633, -1.82185705013052, 218, 38, 'PPL', 'P'),
(184514, 'Riccas Corner', 38.4233283996582, 0.670613590149079, -122.78694152832, -2.14303640812295, 218, 6, 'PPL', 'P'),
(197366, 'Ricci Trailer Terraces', 45.0166702270508, 0.785689113746539, -109.933326721191, -1.91869850895545, 218, 31, 'PPL', 'P'),
(5368, 'Rice', 34.3183288574219, 0.598967832344195, -86.5336074829102, -1.51029636420519, 218, 2, 'PPL', 'P'),
(33747, 'Rice', 39.5722198486328, 0.690665528681695, -97.5552825927734, -1.70266088395741, 218, 20, 'PPL', 'P'),
(50788, 'Rice', 39.3330612182617, 0.686491423147159, -77.6327819824219, -1.35494765307619, 218, 25, 'PPL', 'P'),
(97486, 'Rice', 32.2436103820801, 0.562757163897524, -96.4983291625977, -1.68421356656059, 218, 51, 'PPL', 'P'),
(105675, 'Rice', 37.2750015258789, 0.650571505312497, -78.2916717529297, -1.36644744897926, 218, 53, 'PPL', 'P'),
(121194, 'Rice', 42.339168548584, 0.738957893729619, -90.3944396972656, -1.57768059821275, 218, 18, 'PPL', 'P'),
(137688, 'Rice', 45.7519416809082, 0.798522021512277, -94.2200012207031, -1.64444924253435, 218, 28, 'PPL', 'P'),
(157325, 'Rice', 41.1508293151855, 0.718217461476191, -84.2944412231445, -1.47121554047271, 218, 41, 'PPL', 'P'),
(184515, 'Rice', 34.083610534668, 0.594871224797381, -114.848892211914, -2.00449131136597, 218, 6, 'PPL', 'P'),
(208550, 'Rice', 48.4288902282715, 0.845243587570246, -118.169166564941, -2.06244103089583, 218, 56, 'PPL', 'P'),
(97487, 'Rice Addition Colonia', 26.0949993133545, 0.455443656323695, -97.9530029296875, -1.7096024133387, 218, 51, 'PPL', 'P'),
(90283, 'Rice Bend', 35.9722213745117, 0.62783370224151, -82.5558319091797, -1.44087108353818, 218, 50, 'PPL', 'P'),
(169574, 'Rice City', 41.7138900756836, 0.728044725635665, -71.7541732788086, -1.25234657576175, 218, 47, 'PPL', 'P'),
(128648, 'Rice Corner', 44.9247207641602, 0.784084292873658, -69.7519378662109, -1.21740097541189, 218, 26, 'PPL', 'P'),
(17784, 'Rice Creek', 29.7027797698975, 0.518411303979474, -81.6641693115234, -1.42530863539219, 218, 12, 'PPL', 'P'),
(132811, 'Rice Creek', 42.3344383239746, 0.738875335735827, -84.82861328125, -1.4805386016588, 218, 27, 'PPL', 'P'),
(5369, 'Rice Creek Landing', 31.0152797698975, 0.5413187504119, -87.879997253418, -1.53379529871572, 218, 2, 'PPL', 'P'),
(83263, 'Rice Crossroads', 33.6622200012207, 0.587516572551991, -79.245002746582, -1.38308621367981, 218, 48, 'PPL', 'P'),
(184516, 'Rice Fork Summer Homes', 39.3997192382813, 0.68765482506936, -122.949440002441, -2.14587254152583, 218, 6, 'PPL', 'P'),
(152071, 'Rice Grove', 42.851390838623, 0.747897859192906, -76.2566680908203, -1.33092993478531, 218, 40, 'PPL', 'P'),
(201468, 'Rice Hill', 43.538890838623, 0.759896997800367, -123.288887023926, -2.15179700968682, 218, 43, 'PPL', 'P'),
(83264, 'Rice Hope', 33.0902786254883, 0.577534312417074, -79.9330596923828, -1.39509507282525, 218, 48, 'PPL', 'P'),
(137692, 'Rice Lake', 45.0141716003418, 0.785645504483689, -94.144172668457, -1.64312578463063, 218, 28, 'PPL', 'P'),
(176070, 'Rice Lake', 45.5061111450195, 0.794231469259078, -91.7380599975586, -1.6011311963495, 218, 57, 'PPL', 'P'),
(68190, 'Rice Mill', 35.9161109924316, 0.62685439132966, -82.6666717529297, -1.44280560375402, 218, 33, 'PPL', 'P'),
(152072, 'Rice Mill', 43.2338905334473, 0.754573738255462, -76.8583297729492, -1.34143091212155, 218, 40, 'PPL', 'P'),
(197367, 'Rice Motel and Trailer Court', 45.8694381713867, 0.800572722130665, -112.093887329102, -1.95640740525237, 218, 31, 'PPL', 'P'),
(24301, 'Rice Springs Estates', 34.2666702270508, 0.598066219157149, -85.2527770996094, -1.48794165685701, 218, 13, 'PPL', 'P'),
(125938, 'Rice Square', 42.2458305358887, 0.737328838090818, -71.7888870239258, -1.25295244490974, 218, 23, 'PPL', 'P'),
(97488, 'Rice Tracts Colonia', 26.0580005645752, 0.454797906338378, -97.6259994506836, -1.7038951259646, 218, 51, 'PPL', 'P'),
(24302, 'Riceboro', 31.735279083252, 0.553885109042034, -81.4336090087891, -1.42128459898509, 218, 13, 'PPL', 'P'),
(37912, 'Ricedale', 38.9422187805176, 0.679669935752003, -84.581672668457, -1.47622867490867, 218, 21, 'PPL', 'P'),
(68191, 'Ricefield', 34.3658294677734, 0.599796874391537, -78.396110534668, -1.36827024958737, 218, 33, 'PPL', 'P'),
(137697, 'Riceford', 43.5761108398438, 0.760546609369265, -91.7266693115234, -1.60093239137412, 218, 28, 'PPL', 'P'),
(83265, 'Ricelan Creek', 34.788890838623, 0.607180688250863, -82.271110534668, -1.43590175810215, 218, 48, 'PPL', 'P'),
(17785, 'Riceland', 29.610559463501, 0.516801755995658, -82.3938903808594, -1.43804467067328, 218, 12, 'PPL', 'P'),
(157327, 'Riceland', 40.7963905334473, 0.712031337738101, -81.7655563354492, -1.4270781727785, 218, 41, 'PPL', 'P'),
(152073, 'Rices', 43.9174995422363, 0.766504966255126, -75.9702835083008, -1.3259315808934, 218, 40, 'PPL', 'P'),
(57150, 'Rices Corner', 39.2013893127441, 0.684193314863502, -91.5647201538086, -1.59810584535117, 218, 29, 'PPL', 'P'),
(97489, 'Rices Crossing', 30.4794406890869, 0.531966594190896, -97.4580612182617, -1.70096405086886, 218, 51, 'PPL', 'P'),
(184517, 'Rices Junction', 37.1527786254883, 0.648438313279344, -122.133056640625, -2.13162396390363, 218, 6, 'PPL', 'P'),
(79019, 'Rices Landing', 39.9452781677246, 0.697176624651802, -79.9958267211914, -1.39619056413965, 218, 45, 'PPL', 'P'),
(157328, 'Rices Mills', 41.4911117553711, 0.72415651044415, -80.7375030517578, -1.40913525809214, 218, 41, 'PPL', 'P'),
(172451, 'Rices Mills', 43.8247184753418, 0.764885631154304, -72.2863922119141, -1.26163554848589, 218, 55, 'PPL', 'P'),
(184518, 'Riceton', 39.4494400024414, 0.688522616110562, -121.72444152832, -2.12449228482051, 218, 6, 'PPL', 'P'),
(37913, 'Ricetown', 37.3899993896484, 0.652578596668035, -83.6227798461914, -1.4594928379864, 218, 21, 'PPL', 'P'),
(83266, 'Ricetown', 32.5169410705566, 0.567527684358183, -80.9669418334961, -1.41313972026524, 218, 48, 'PPL', 'P'),
(11557, 'Riceville', 35.1230583190918, 0.613013011038137, -90.225830078125, -1.57473780520821, 218, 4, 'PPL', 'P'),
(30956, 'Riceville', 38.3244400024414, 0.668887662025626, -86.6655578613281, -1.51259933275783, 218, 19, 'PPL', 'P'),
(37915, 'Riceville', 37.7344398498535, 0.658590216775699, -82.9244384765625, -1.44730448178349, 218, 21, 'PPL', 'P'),
(42784, 'Riceville', 30.0761108398438, 0.52492716035003, -92.5141677856445, -1.61467683260197, 218, 22, 'PPL', 'P'),
(61527, 'Riceville', 30.6061096191406, 0.534177384080312, -89.2958297729492, -1.55850623783834, 218, 30, 'PPL', 'P'),
(68192, 'Riceville', 35.6324996948242, 0.621904440390557, -82.4702835083008, -1.43937798227303, 218, 33, 'PPL', 'P'),
(90284, 'Riceville', 35.3847198486328, 0.617579866254432, -84.6930618286133, -1.47817278250443, 218, 50, 'PPL', 'P'),
(105676, 'Riceville', 36.8911094665527, 0.643871324904994, -79.1691665649414, -1.38176262261804, 218, 53, 'PPL', 'P'),
(117497, 'Riceville', 43.3638916015625, 0.756842684925183, -92.5538864135742, -1.61537005343372, 218, 16, 'PPL', 'P'),
(152075, 'Riceville', 43.0936088562012, 0.752125361107298, -74.2822189331055, -1.29646929606996, 218, 40, 'PPL', 'P'),
(166437, 'Riceville', 41.7775001525879, 0.729154930915092, -79.8030624389648, -1.39282619273455, 218, 45, 'PPL', 'P'),
(197368, 'Riceville', 47.2147216796875, 0.824052348723294, -110.932777404785, -1.93614221409547, 218, 31, 'PPL', 'P'),
(61524, 'Riceville (historical)', 30.7930603027344, 0.537440289047877, -89.7611083984375, -1.56662688179227, 218, 30, 'PPL', 'P'),
(74058, 'Riceville (historical)', 39.9063911437988, 0.696497918047995, -83.8041687011719, -1.46265867073223, 218, 41, 'PPL', 'P'),
(117498, 'Riceville (historical)', 43.3849983215332, 0.757211066682968, -92.5630569458008, -1.61553010941523, 218, 16, 'PPL', 'P'),
(11558, 'Rich', 34.7644386291504, 0.606753916686178, -91.1372222900391, -1.59064460008315, 218, 4, 'PPL', 'P'),
(61525, 'Rich', 34.4161109924316, 0.600674452549745, -90.4447174072266, -1.57855810979193, 218, 30, 'PPL', 'P'),
(90285, 'Rich', 35.3872184753418, 0.617623475517282, -87.1236114501953, -1.52059387603414, 218, 50, 'PPL', 'P'),
(184519, 'Rich', 34.976390838623, 0.610453180598353, -117.726669311523, -2.05471799689265, 218, 6, 'PPL', 'P'),
(205504, 'Rich Acres', 41.2261085510254, 0.719531331999982, -112.041107177734, -1.95548621783132, 218, 52, 'PPL', 'P'),
(17786, 'Rich Bay', 30.6044406890869, 0.534148255755889, -84.3919372558594, -1.47291716725121, 218, 12, 'PPL', 'P'),
(90286, 'Rich Creek', 35.5672187805176, 0.620765073497194, -86.7002792358398, -1.51320533506388, 218, 50, 'PPL', 'P'),
(105677, 'Rich Creek', 37.3822212219238, 0.652442842031469, -80.8227767944336, -1.41062356566733, 218, 53, 'PPL', 'P'),
(57151, 'Rich Fountain', 38.3958282470703, 0.67013362194162, -91.8797225952148, -1.60360367510553, 218, 29, 'PPL', 'P'),
(184520, 'Rich Gulch', 38.3302803039551, 0.668989594516349, -120.629997253418, -2.10539062874386, 218, 6, 'PPL', 'P'),
(57152, 'Rich Hill', 38.0963897705078, 0.664907434618448, -94.3608322143555, -1.64690720706243, 218, 29, 'PPL', 'P'),
(68193, 'Rich Hill', 36.4730606079102, 0.636574995887477, -80.9902801513672, -1.41354705075397, 218, 33, 'PPL', 'P'),
(157329, 'Rich Hill', 40.3211097717285, 0.703736123574722, -82.7272186279297, -1.44386234607456, 218, 41, 'PPL', 'P'),
(166439, 'Rich Hill', 40.2166709899902, 0.701913322966617, -80.2319412231445, -1.40031153961044, 218, 45, 'PPL', 'P'),
(74059, 'Rich Hill (historical)', 39.9091682434082, 0.696546387579835, -81.7519378662109, -1.42684048565121, 218, 41, 'PPL', 'P'),
(83267, 'Rich Hill Crossroads', 34.6561088562012, 0.604863205470277, -80.6527786254883, -1.40765653789688, 218, 48, 'PPL', 'P'),
(11559, 'Rich Mountain', 34.690559387207, 0.605464480665389, -94.3369369506836, -1.64649015603573, 218, 4, 'PPL', 'P'),
(68194, 'Rich Mountain', 35.3222198486328, 0.616489035471936, -83.0461120605469, -1.44942808643672, 218, 33, 'PPL', 'P'),
(105678, 'Rich Neck', 37.9749984741211, 0.662788756813236, -76.6605606079102, -1.3379791890327, 218, 53, 'PPL', 'P'),
(105679, 'Rich Neck Heights', 37.2566719055176, 0.650251593086551, -76.7313919067383, -1.33921542841071, 218, 53, 'PPL', 'P'),
(105680, 'Rich Patch', 37.7266693115234, 0.658454595297186, -79.9194412231445, -1.39485738569796, 218, 53, 'PPL', 'P'),
(37916, 'Rich Pond', 36.8941688537598, 0.64392472128485, -86.5094375610352, -1.50987451948852, 218, 21, 'PPL', 'P'),
(68195, 'Rich Square', 36.2738914489746, 0.633098838295624, -77.2847213745117, -1.34887284947167, 218, 33, 'PPL', 'P'),
(74061, 'Rich Valley', 39.6794395446777, 0.692536865400666, -81.6036071777344, -1.42425162675554, 218, 41, 'PPL', 'P'),
(137700, 'Rich Valley', 44.7461090087891, 0.780966929659665, -93.0436096191406, -1.62391733579427, 218, 28, 'PPL', 'P'),
(166440, 'Rich Valley', 41.5352783203125, 0.724927362421673, -78.3225021362305, -1.36698554067751, 218, 45, 'PPL', 'P'),
(42786, 'Richard', 29.8280601501465, 0.52059785910297, -91.5969390869141, -1.59866817181534, 218, 22, 'PPL', 'P'),
(111101, 'Richard', 39.6066703796387, 0.691266803876807, -79.9066696166992, -1.39463447911472, 218, 58, 'PPL', 'P'),
(117499, 'Richard', 42.4277801513672, 0.740504457953656, -94.5294418334961, -1.64985000006697, 218, 16, 'PPL', 'P'),
(90287, 'Richard City', 34.9941711425781, 0.610763505444374, -85.7249984741211, -1.49618347464053, 218, 50, 'PPL', 'P'),
(14480, 'Richard Heights', 38.6749992370605, 0.675006074893001, -75.6388931274414, -1.32014772763796, 218, 10, 'PPL', 'P'),
(57154, 'Richards', 37.9072189331055, 0.661605780657023, -94.5569381713867, -1.6503299016954, 218, 29, 'PPL', 'P'),
(97490, 'Richards', 30.5375003814697, 0.532979926985671, -95.8391723632813, -1.67270911012561, 218, 51, 'PPL', 'P'),
(121197, 'Richards', 41.1786117553711, 0.718702356531667, -88.8361129760742, -1.55048266610615, 218, 18, 'PPL', 'P'),
(137702, 'Richards', 46.836109161377, 0.817444313689508, -95.9119415283203, -1.67397917164947, 218, 28, 'PPL', 'P'),
(157330, 'Richards (historical)', 41.663330078125, 0.727162287208468, -83.6530609130859, -1.46002134230472, 218, 41, 'PPL', 'P'),
(113977, 'Richards Corner', 41.1705589294434, 0.718561808205138, -73.4955596923828, -1.28273950222811, 218, 8, 'PPL', 'P'),
(5370, 'Richards Crossroads', 31.7369403839111, 0.553914104208402, -85.2644424438477, -1.48814525552234, 218, 2, 'PPL', 'P'),
(121198, 'Richards Park', 41.336669921875, 0.721460991946826, -88.4241714477539, -1.54329293011127, 218, 18, 'PPL', 'P'),
(197369, 'Richards Trailer Court', 46.5416717529297, 0.812305411471064, -110.911109924316, -1.93576404522068, 218, 31, 'PPL', 'P'),
(50790, 'Richardsmere', 39.6891708374023, 0.692706708499186, -76.1266708374023, -1.32866105469462, 218, 25, 'PPL', 'P'),
(5371, 'Richardson', 34.2005615234375, 0.596912404614872, -85.7425003051758, -1.49648893921756, 218, 2, 'PPL', 'P'),
(11561, 'Richardson', 34.2180595397949, 0.597217802612877, -91.7380599975586, -1.6011311963495, 218, 4, 'PPL', 'P'),
(24303, 'Richardson', 33.5919418334961, 0.586289987132928, -84.1374969482422, -1.46847634613351, 218, 13, 'PPL', 'P'),
(33750, 'Richardson', 39.2666702270508, 0.685332681756865, -94.9000015258789, -1.65631748677423, 218, 20, 'PPL', 'P'),
(37917, 'Richardson', 37.9438896179199, 0.662245804845996, -82.6425018310547, -1.44238375903735, 218, 21, 'PPL', 'P'),
(42787, 'Richardson', 30.8544406890869, 0.538511578885875, -90.2130584716797, -1.57451489862497, 218, 22, 'PPL', 'P'),
(61526, 'Richardson', 30.5599994659424, 0.533372610088403, -89.6672210693359, -1.56498823877354, 218, 30, 'PPL', 'P'),
(68197, 'Richardson', 34.5563888549805, 0.603122763118882, -78.8361129760742, -1.37594974090672, 218, 33, 'PPL', 'P'),
(97491, 'Richardson', 32.9480590820313, 0.575052113123066, -96.7294387817383, -1.68824719034763, 218, 51, 'PPL', 'P'),
(105682, 'Richardson', 36.5611114501953, 0.638111772994507, -78.4463882446289, -1.36914776116655, 218, 53, 'PPL', 'P'),
(111102, 'Richardson', 38.8652801513672, 0.678327103351358, -81.2366714477539, -1.41784739012417, 218, 58, 'PPL', 'P'),
(113400, 'Richardson', 45.3191719055176, 0.790968764028594, -92.1997222900391, -1.60918872338559, 218, 57, 'PPL', 'P'),
(121199, 'Richardson', 41.9663887023926, 0.732451658028501, -88.585563659668, -1.54610975559624, 218, 18, 'PPL', 'P'),
(193262, 'Richardson', 48.4516716003418, 0.845641197520995, -122.897499084473, -2.14496600149076, 218, 56, 'PPL', 'P'),
(90288, 'Richardson (historical)', 35.146671295166, 0.613425135216827, -87.3463897705078, -1.52448209122566, 218, 50, 'PPL', 'P'),
(105683, 'Richardson (historical)', 37.5608291625977, 0.655560138666434, -77.1205596923828, -1.34600768761291, 218, 53, 'PPL', 'P'),
(144362, 'Richardson (historical)', 42.8411102294922, 0.747718428714462, -71.6769409179688, -1.250998616776, 218, 36, 'PPL', 'P'),
(209695, 'Richardson Acres', 42.898609161377, 0.748721974392231, -106.342216491699, -1.85602181164876, 218, 59, 'PPL', 'P'),
(125939, 'Richardson Corners', 42.1511116027832, 0.735675680844151, -71.9255599975586, -1.25533783829812, 218, 23, 'PPL', 'P'),
(90289, 'Richardson Cove', 35.8158302307129, 0.62510416186126, -83.4336090087891, -1.45619118402497, 218, 50, 'PPL', 'P'),
(83268, 'Richardson Crossroads', 32.9130592346191, 0.574441250548029, -81.2194366455078, -1.41754658607905, 218, 48, 'PPL', 'P'),
(14481, 'Richardson Estates', 39.1138916015625, 0.682666191715424, -75.5166702270508, -1.31801453560481, 218, 10, 'PPL', 'P'),
(24304, 'Richardson Estates', 32.6872215270996, 0.570499638976657, -83.6188888549805, -1.4594249273786, 218, 13, 'PPL', 'P'),
(42788, 'Richardson Landing', 30.7608299255371, 0.536877762846625, -89.8313903808594, -1.56785353379036, 218, 22, 'PPL', 'P'),
(83269, 'Richardson Landing', 33.3083305358887, 0.581340036193825, -79.9766693115234, -1.39585620426479, 218, 48, 'PPL', 'P'),
(50791, 'Richardson Mews', 39.2299995422363, 0.684692657567892, -76.7013931274414, -1.3386918509404, 218, 25, 'PPL', 'P'),
(14482, 'Richardson Park', 39.7319412231445, 0.693453192552735, -75.5861129760742, -1.31922654021691, 218, 10, 'PPL', 'P'),
(50792, 'Richardson Ridge', 39.6291694641113, 0.69165948697954, -77.0694427490234, -1.34511552864773, 218, 25, 'PPL', 'P'),
(184521, 'Richardson Springs', 39.8400001525879, 0.695339176657702, -121.775833129883, -2.12538923747565, 218, 6, 'PPL', 'P'),
(90290, 'Richardsons', 35.5113906860352, 0.619790689433361, -89.9400024414063, -1.56974917185428, 218, 50, 'PPL', 'P'),
(132813, 'Richardsons Mill', 46.0191688537598, 0.803186015529333, -86.3863906860352, -1.50772694638548, 218, 27, 'PPL', 'P'),
(37918, 'Richardsville', 37.1047210693359, 0.647599550694023, -86.470832824707, -1.50920073973273, 218, 21, 'PPL', 'P'),
(77087, 'Richardsville', 35.478328704834, 0.619213649004169, -95.6805572509766, -1.66994075417248, 218, 42, 'PPL', 'P'),
(105684, 'Richardsville', 38.4000015258789, 0.670206459397433, -77.7291717529297, -1.3566299719368, 218, 53, 'PPL', 'P'),
(152076, 'Richardsville', 41.4636116027832, 0.72367654223669, -73.7755584716797, -1.28762640282841, 218, 40, 'PPL', 'P'),
(166443, 'Richardsville', 41.2400016784668, 0.719773812817234, -79.0124969482422, -1.3790282219688, 218, 45, 'PPL', 'P'),
(105685, 'Richardsville South', 38.389720916748, 0.670027028918989, -77.732780456543, -1.35669295569658, 218, 53, 'PPL', 'P'),
(198803, 'Richardton', 46.8838882446289, 0.818278216005839, -102.315277099609, -1.78573846047854, 218, 34, 'PPL', 'P'),
(105686, 'Richart Heights', 37.2350006103516, 0.649873357632733, -79.996940612793, -1.39621000521561, 218, 53, 'PPL', 'P'),
(166441, 'Richarts Grove', 41.2536087036133, 0.720011300207441, -76.491943359375, -1.33503626287011, 218, 45, 'PPL', 'P'),
(166442, 'Richboro', 40.2150001525879, 0.701884161352681, -75.0111083984375, -1.30919081712311, 218, 45, 'PPL', 'P'),
(5372, 'Richburg', 31.3966693878174, 0.547975254977526, -85.9608306884766, -1.5002995232633, 218, 2, 'PPL', 'P'),
(61530, 'Richburg', 31.274169921875, 0.545837235964897, -89.3530578613281, -1.55950505640518, 218, 30, 'PPL', 'P'),
(83270, 'Richburg', 34.7158317565918, 0.605905566720934, -81.0197219848633, -1.4140609076863, 218, 48, 'PPL', 'P'),
(152077, 'Richburg', 42.0883293151855, 0.734579923213638, -78.1536102294922, -1.36403782082496, 218, 40, 'PPL', 'P'),
(137705, 'Richdale', 46.5547218322754, 0.812533178323293, -95.4747161865234, -1.66634814986196, 218, 28, 'PPL', 'P'),
(197370, 'Richel Lodge', 45.0819396972656, 0.786828280902821, -109.374717712402, -1.90894894252078, 218, 31, 'PPL', 'P'),
(37919, 'Richelieu', 37.0058288574219, 0.645873555991543, -86.6927795410156, -1.5130744406963, 218, 21, 'PPL', 'P'),
(61529, 'Richey', 33.0299987792969, 0.576482230628438, -90.732780456543, -1.58358575845584, 218, 30, 'PPL', 'P'),
(157331, 'Richey', 40.8941688537598, 0.713737891364623, -84.648063659668, -1.47738741629897, 218, 41, 'PPL', 'P'),
(197371, 'Richey', 47.6438903808594, 0.831542755605251, -105.074440002441, -1.83389493773184, 218, 31, 'PPL', 'P'),
(123531, 'Richey Park', 40.6686096191406, 0.709801140062241, -86.7591705322266, -1.51423318208659, 218, 19, 'PPL', 'P'),
(197372, 'Richey Trailer Court', 47.6411094665527, 0.831494219494385, -105.073333740234, -1.83387562981394, 218, 31, 'PPL', 'P'),
(5373, 'Richeytown', 33.5666694641113, 0.585848901077383, -85.966667175293, -1.500401389175, 218, 2, 'PPL', 'P'),
(166448, 'Richeyville', 40.0533294677734, 0.699062475598714, -80.0022201538086, -1.39630215058932, 218, 45, 'PPL', 'P'),
(24305, 'Richfield', 32.040828704834, 0.559217955966863, -81.1327819824219, -1.41603417689599, 218, 13, 'PPL', 'P'),
(28400, 'Richfield', 39.8152809143066, 0.694907744561109, -91.1163864135742, -1.5902809454363, 218, 18, 'PPL', 'P'),
(68198, 'Richfield', 35.4700012207031, 0.619068306987677, -80.258056640625, -1.40076733963101, 218, 33, 'PPL', 'P'),
(117501, 'Richfield', 42.9502792358398, 0.749623787316359, -92.0625, -1.60679374261728, 218, 16, 'PPL', 'P'),
(137706, 'Richfield', 44.8833312988281, 0.783361910427974, -93.2827835083008, -1.62809170764492, 218, 28, 'PPL', 'P'),
(142839, 'Richfield', 41.1083297729492, 0.717475704533577, -96.0749969482422, -1.67682502559033, 218, 35, 'PPL', 'P'),
(146161, 'Richfield', 40.8688888549805, 0.713296672151025, -74.1730575561523, -1.29456407062612, 218, 37, 'PPL', 'P'),
(152078, 'Richfield', 42.8572196960449, 0.747999591946547, -75.054443359375, -1.30994715487269, 218, 40, 'PPL', 'P'),
(157332, 'Richfield', 41.2397193908691, 0.719768885969217, -81.6383285522461, -1.42485762906159, 218, 41, 'PPL', 'P'),
(166444, 'Richfield', 40.6886100769043, 0.710150213902123, -77.1130599975586, -1.34587679324533, 218, 45, 'PPL', 'P'),
(176073, 'Richfield', 43.2561111450195, 0.754961561089205, -88.1938934326172, -1.53927382055217, 218, 57, 'PPL', 'P'),
(184522, 'Richfield', 39.9749984741211, 0.697695341853122, -122.175559997559, -2.13236578742527, 218, 6, 'PPL', 'P'),
(187255, 'Richfield', 37.2777786254883, 0.650619974844337, -105.944442749023, -1.84907935016109, 218, 7, 'PPL', 'P'),
(187860, 'Richfield', 37.2661094665527, 0.650416309599973, -101.781936645508, -1.77642991352038, 218, 20, 'PPL', 'P'),
(192759, 'Richfield', 38.7724990844727, 0.676707768250535, -112.08332824707, -1.95622311450494, 218, 52, 'PPL', 'P'),
(195525, 'Richfield', 43.0486106872559, 0.751339994901834, -114.154716491699, -1.99237565946082, 218, 17, 'PPL', 'P'),
(132814, 'Richfield Center', 43.0927810668945, 0.752110913458384, -83.5183334350586, -1.45766990422024, 218, 27, 'PPL', 'P'),
(157333, 'Richfield Center', 41.6855583190918, 0.727550243200265, -83.817497253418, -1.46289129785345, 218, 41, 'PPL', 'P'),
(157334, 'Richfield Heights', 41.2038917541504, 0.719143575745266, -81.6305618286133, -1.4247220741621, 218, 41, 'PPL', 'P'),
(171182, 'Richfield Heights', 45.5119400024414, 0.794333202012719, -98.538330078125, -1.71981829928024, 218, 49, 'PPL', 'P'),
(152079, 'Richfield Springs', 42.853328704834, 0.74793168133875, -74.9858322143555, -1.30874966448853, 218, 40, 'PPL', 'P'),
(184523, 'Richfields', 33.8672218322754, 0.591094529476512, -117.824996948242, -2.0564341378991, 218, 6, 'PPL', 'P'),
(152081, 'Richford', 42.3555603027344, 0.739243983809721, -76.2011108398438, -1.32996027783241, 218, 40, 'PPL', 'P'),
(172452, 'Richford', 44.996940612793, 0.785344767017592, -72.6716690063477, -1.26835989708028, 218, 55, 'PPL', 'P'),
(176077, 'Richford', 44.023609161377, 0.768356928477168, -89.4352798461914, -1.56094010075857, 218, 57, 'PPL', 'P'),
(111103, 'Richford (historical)', 39.0186080932617, 0.681003180772724, -79.5733337402344, -1.38881667055538, 218, 58, 'PPL', 'P'),
(184524, 'Richgrove', 35.7966690063477, 0.624769735407374, -119.106941223145, -2.07880828632323, 218, 6, 'PPL', 'P'),
(57155, 'Richie', 39.660831451416, 0.692212092905731, -94.813606262207, -1.65480960496503, 218, 29, 'PPL', 'P'),
(5374, 'Richland', 31.732780456543, 0.553841499779184, -85.727783203125, -1.49623207733042, 218, 2, 'PPL', 'P'),
(17787, 'Richland', 28.2827796936035, 0.493627627269574, -82.1430587768555, -1.43366683331535, 218, 12, 'PPL', 'P'),
(24306, 'Richland', 32.0877799987793, 0.560037410634281, -84.6675033569336, -1.47772670302184, 218, 13, 'PPL', 'P'),
(28402, 'Richland', 39.8458290100098, 0.695440909411343, -89.8580627441406, -1.56831905434891, 218, 18, 'PPL', 'P'),
(30957, 'Richland', 39.497501373291, 0.68936144527491, -85.3949966430664, -1.49042385615101, 218, 19, 'PPL', 'P'),
(33751, 'Richland', 38.8836097717285, 0.678647015577303, -95.539436340332, -1.66747772963832, 218, 20, 'PPL', 'P'),
(37920, 'Richland', 37.2772216796875, 0.650610254306358, -87.5947189331055, -1.52881625274171, 218, 21, 'PPL', 'P'),
(42791, 'Richland', 31.836389541626, 0.555649819448862, -91.4511108398438, -1.59612298876155, 218, 22, 'PPL', 'P'),
(57156, 'Richland', 37.8569412231445, 0.660728269077841, -92.404167175293, -1.61275695977213, 218, 29, 'PPL', 'P'),
(61533, 'Richland', 32.9741706848145, 0.575507846564606, -89.9863891601563, -1.57055877282566, 218, 30, 'PPL', 'P'),
(68199, 'Richland', 36.079719543457, 0.629709899229471, -81.5983276367188, -1.42415948138183, 218, 33, 'PPL', 'P'),
(71331, 'Richland', 39.4916687011719, 0.689259645942242, -74.8711090087891, -1.30674736682296, 218, 37, 'PPL', 'P'),
(74067, 'Richland', 39.186939239502, 0.683941113508272, -82.5975036621094, -1.44159839283188, 218, 41, 'PPL', 'P'),
(77088, 'Richland', 35.5800018310547, 0.620988179817516, -97.804443359375, -1.7070095597014, 218, 42, 'PPL', 'P'),
(83274, 'Richland', 34.6777801513672, 0.605241440924095, -83.0255584716797, -1.44906935863788, 218, 48, 'PPL', 'P'),
(90292, 'Richland', 36.1375007629395, 0.630718371755256, -83.6655578613281, -1.460239455198, 218, 50, 'PPL', 'P'),
(97494, 'Richland', 32.9541702270508, 0.575158772724723, -95.8255615234375, -1.67247155615638, 218, 51, 'PPL', 'P'),
(117500, 'Richland', 41.1855583190918, 0.718823596940293, -91.9927825927734, -1.60557694431522, 218, 16, 'PPL', 'P'),
(132817, 'Richland', 42.3761100769043, 0.739602645029527, -85.4550018310547, -1.49147114424969, 218, 27, 'PPL', 'P'),
(142840, 'Richland', 41.4355583190918, 0.723186920070279, -97.2122192382813, -1.69667329887858, 218, 35, 'PPL', 'P'),
(152083, 'Richland', 43.5694389343262, 0.760430162650601, -76.0480575561523, -1.32728899410101, 218, 40, 'PPL', 'P'),
(166446, 'Richland', 40.3591690063477, 0.704400382529615, -76.2586135864258, -1.33096389008921, 218, 45, 'PPL', 'P'),
(171184, 'Richland', 42.7594413757324, 0.746293038320025, -96.6524963378906, -1.68690429136795, 218, 49, 'PPL', 'P'),
(184525, 'Richland', 33.1541709899902, 0.578649444544518, -117.140281677246, -2.04448360198153, 218, 6, 'PPL', 'P'),
(189339, 'Richland', 33.8216705322266, 0.590299509312096, -103.265281677246, -1.80231916826732, 218, 38, 'PPL', 'P'),
(197373, 'Richland', 48.8208312988281, 0.85208424972525, -106.050559997559, -1.85093144554119, 218, 31, 'PPL', 'P'),
(201469, 'Richland', 44.7691688537598, 0.781369399879404, -117.167503356934, -2.04495870992, 218, 43, 'PPL', 'P'),
(208551, 'Richland', 46.285831451416, 0.807840155850355, -119.283332824707, -2.08188690054337, 218, 56, 'PPL', 'P'),
(42792, 'Richland (historical)', 31.166109085083, 0.543951218570416, -92.3144378662109, -1.61119088789311, 218, 22, 'PPL', 'P'),
(90293, 'Richland (historical)', 35.3063888549805, 0.61621273250884, -86.9394378662109, -1.51737944059841, 218, 50, 'PPL', 'P'),
(157338, 'Richland (historical)', 40.809440612793, 0.71225910459033, -82.6286087036133, -1.4421412782201, 218, 41, 'PPL', 'P'),
(184526, 'Richland (historical)', 39.3974990844727, 0.687616076075499, -121.644996643066, -2.12310570999896, 218, 6, 'PPL', 'P'),
(123532, 'Richland Center', 41.1563911437988, 0.718314533697925, -86.2705612182617, -1.505705340802, 218, 19, 'PPL', 'P'),
(166447, 'Richland Center', 40.4313888549805, 0.705660856673549, -75.2977828979492, -1.31419423102109, 218, 45, 'PPL', 'P'),
(176079, 'Richland Center', 43.3347206115723, 0.756333555103787, -90.3866729736328, -1.57754504331327, 218, 57, 'PPL', 'P'),
(30958, 'Richland City', 37.9452781677246, 0.662270039611916, -87.1677780151367, -1.52136472801166, 218, 19, 'PPL', 'P'),
(157339, 'Richland Cottage Area', 40.646671295166, 0.709418244076515, -82.352783203125, -1.43732721507561, 218, 41, 'PPL', 'P'),
(90294, 'Richland Crest', 35.1991691589355, 0.614341395789869, -85.2058334350586, -1.48712233534764, 218, 50, 'PPL', 'P'),
(97495, 'Richland Hills', 32.8158302307129, 0.57274428430143, -97.227783203125, -1.69694494130977, 218, 51, 'PPL', 'P'),
(105687, 'Richland Hills', 37.3650016784668, 0.652142304302453, -79.2247161865234, -1.38273214641288, 218, 53, 'PPL', 'P'),
(132818, 'Richland Junction', 42.4011116027832, 0.740039003974137, -85.496940612793, -1.4922031140753, 218, 27, 'PPL', 'P'),
(208552, 'Richland Junction', 46.2324981689453, 0.806909314470345, -119.226112365723, -2.08088821513459, 218, 56, 'PPL', 'P'),
(97496, 'Richland Springs', 31.2694396972656, 0.545754677971104, -98.9447174072266, -1.72691109621145, 218, 51, 'PPL', 'P'),
(90295, 'Richland Trace Subdivision', 35.2102813720703, 0.614535340496254, -87.1083297729492, -1.52032716045097, 218, 50, 'PPL', 'P'),
(208553, 'Richland Y', 46.2369384765625, 0.806986812458067, -119.231941223145, -2.08098994788823, 218, 56, 'PPL', 'P'),
(68202, 'Richlands', 34.899169921875, 0.609105421349691, -77.5469436645508, -1.35344949180497, 218, 33, 'PPL', 'P'),
(105690, 'Richlands', 37.0930595397949, 0.647396018607714, -81.7938919067383, -1.42757272179293, 218, 53, 'PPL', 'P'),
(111104, 'Richlands', 37.8661117553711, 0.660888325059355, -80.4833297729492, -1.40469909750634, 218, 58, 'PPL', 'P'),
(166455, 'Richlandtown', 40.4700012207031, 0.706334769587394, -75.3208312988281, -1.31459650150375, 218, 45, 'PPL', 'P'),
(37921, 'Richlawn', 38.2547187805176, 0.667670797144542, -85.6394424438477, -1.49469024021732, 218, 21, 'PPL', 'P'),
(17796, 'Richloam', 28.5011100769043, 0.497438211315314, -82.1130599975586, -1.43314325584504, 218, 12, 'PPL', 'P'),
(50793, 'Richlyn Manor', 39.4169387817383, 0.687955362798376, -76.442497253418, -1.33417326551887, 218, 25, 'PPL', 'P'),
(71332, 'Richmantown', 39.6272201538086, 0.691625465096614, -75.2938919067383, -1.31412632041329, 218, 37, 'PPL', 'P'),
(5381, 'Richmond', 32.1138916015625, 0.560493144075821, -87.0550003051758, -1.51939638564999, 218, 2, 'PPL', 'P'),
(11575, 'Richmond', 33.6375007629395, 0.587085140455398, -94.2072219848633, -1.64422620279305, 218, 4, 'PPL', 'P'),
(30961, 'Richmond', 39.8288917541504, 0.695145298530344, -84.8902816772461, -1.48161491821336, 218, 19, 'PPL', 'P'),
(33764, 'Richmond', 38.4027786254883, 0.670254928929273, -95.2536087036133, -1.66248909628438, 218, 20, 'PPL', 'P'),
(37922, 'Richmond', 37.7477798461914, 0.658823043633999, -84.2947235107422, -1.47122046732073, 218, 21, 'PPL', 'P'),
(42794, 'Richmond', 32.3877792358398, 0.565273385074458, -91.1819381713867, -1.5914250394406, 218, 22, 'PPL', 'P'),
(57166, 'Richmond', 39.2786102294922, 0.685541074112164, -93.9766693115234, -1.640202299544, 218, 29, 'PPL', 'P'),
(61535, 'Richmond', 34.1913909912109, 0.596752348633358, -88.5566711425781, -1.54560548604384, 218, 30, 'PPL', 'P'),
(77092, 'Richmond', 36.1908302307129, 0.631649146556239, -99.0519409179688, -1.72878249950945, 218, 42, 'PPL', 'P'),
(83275, 'Richmond', 33.0752792358398, 0.577272523681919, -79.8788909912109, -1.39414965063827, 218, 48, 'PPL', 'P'),
(90296, 'Richmond', 35.3855590820313, 0.617594513640428, -86.5919418334961, -1.51131449068992, 218, 50, 'PPL', 'P'),
(97497, 'Richmond', 29.5819396972656, 0.5163022468437, -95.7605590820313, -1.671337049532, 218, 51, 'PPL', 'P'),
(105688, 'Richmond', 37.5536117553711, 0.655434171146873, -77.460563659668, -1.35194187631187, 218, 53, 'PPLA', 'P'),
(117522, 'Richmond', 41.4497184753418, 0.723434061419438, -91.6972198486328, -1.60041840128374, 218, 16, 'PPL', 'P'),
(121204, 'Richmond', 40.3608283996582, 0.704429344406469, -89.3688888549805, -1.55978135936827, 218, 18, 'PPL', 'P'),
(125940, 'Richmond', 42.3730583190918, 0.739549381807726, -73.3680572509766, -1.28051416482124, 218, 23, 'PPL', 'P'),
(128649, 'Richmond', 44.0872192382813, 0.769467133756594, -69.7994384765625, -1.21823001745923, 218, 26, 'PPL', 'P'),
(132829, 'Richmond', 42.8091697692871, 0.747160962519281, -82.7558288574219, -1.44436168877895, 218, 27, 'PPL', 'P'),
(137709, 'Richmond', 45.4541702270508, 0.793324929224015, -94.5180587768555, -1.64965132824965, 218, 28, 'PPL', 'P'),
(144363, 'Richmond', 42.7547187805176, 0.746210613484287, -72.272216796875, -1.26138814082062, 218, 36, 'PPL', 'P'),
(157349, 'Richmond', 40.4333305358887, 0.705694745398421, -80.7719421386719, -1.40973633355017, 218, 41, 'PPL', 'P'),
(166457, 'Richmond', 40.8455581665039, 0.712889474820351, -75.1427764892578, -1.31148885882773, 218, 45, 'PPL', 'P'),
(171195, 'Richmond', 45.5227813720703, 0.794522419608169, -98.6186065673828, -1.72121938832973, 218, 49, 'PPL', 'P'),
(172454, 'Richmond', 44.4052810668945, 0.77501835989081, -72.9933319091797, -1.27397397381622, 218, 55, 'PPL', 'P'),
(176084, 'Richmond', 42.7147216796875, 0.74551253238355, -88.7491683959961, -1.54896519691703, 218, 57, 'PPL', 'P'),
(184527, 'Richmond', 37.9358291625977, 0.662105123361412, -122.346672058105, -2.13535225627169, 218, 6, 'PPL', 'P'),
(201470, 'Richmond', 44.7311096191406, 0.780705140924511, -119.991111755371, -2.0942399732597, 218, 43, 'PPL', 'P'),
(205507, 'Richmond', 41.922779083252, 0.731690526588957, -111.812782287598, -1.95150119673418, 218, 52, 'PPL', 'P'),
(61536, 'Richmond (historical)', 32.2186088562012, 0.562320804952915, -90.1833267211914, -1.57399598168657, 218, 30, 'PPL', 'P'),
(113357, 'Richmond (historical)', 41.7700004577637, 0.729024036547515, -71.6230621337891, -1.25005825459509, 218, 47, 'PPL', 'P'),
(105689, 'Richmond Beach', 37.9147186279297, 0.6617366750246, -76.8380584716797, -1.34107711117073, 218, 53, 'PPL', 'P'),
(208554, 'Richmond Beach', 47.769718170166, 0.833738864819158, -122.388893127441, -2.13608915294531, 218, 56, 'PPL', 'P'),
(152086, 'Richmond Center', 42.8080596923828, 0.747141588022351, -77.5330581665039, -1.35320714414577, 218, 40, 'PPL', 'P'),
(157350, 'Richmond Center', 41.6802787780762, 0.727458097826548, -80.5686111450195, -1.40618753823959, 218, 41, 'PPL', 'P'),
(128650, 'Richmond Corner', 44.103328704834, 0.769748296988679, -69.89111328125, -1.21983004464215, 218, 26, 'PPL', 'P'),
(74066, 'Richmond Dale', 39.2019386291504, 0.684202902243427, -82.8138885498047, -1.44537502157372, 218, 41, 'PPL', 'P'),
(79025, 'Richmond Furnace', 39.9630584716797, 0.697486949497824, -77.9008331298828, -1.35962602816313, 218, 45, 'PPL', 'P'),
(125941, 'Richmond Furnace', 42.3611106872559, 0.739340856294373, -73.3811111450195, -1.2807419982525, 218, 23, 'PPL', 'P'),
(17788, 'Richmond Heights', 25.6311092376709, 0.447347247135691, -80.3691711425781, -1.4027066535368, 218, 12, 'PPL', 'P'),
(57167, 'Richmond Heights', 38.6286087036133, 0.67419640734259, -90.3194427490234, -1.57637165453698, 218, 29, 'PPL', 'P'),
(105692, 'Richmond Heights', 37.4636116027832, 0.653863372156917, -77.3983306884766, -1.35085570606129, 218, 53, 'PPL', 'P'),
(157351, 'Richmond Heights', 41.5527801513672, 0.725232826998705, -81.5102767944336, -1.4226227042748, 218, 41, 'PPL', 'P'),
(171196, 'Richmond Heights', 45.5052795410156, 0.794216955031137, -98.5725021362305, -1.72041471420637, 218, 49, 'PPL', 'P'),
(208555, 'Richmond Highlands', 47.7613906860352, 0.833593522802667, -122.345001220703, -2.13532309465775, 218, 56, 'PPL', 'P'),
(24309, 'Richmond Hill', 31.938060760498, 0.557424316972695, -81.3036117553711, -1.41901571889439, 218, 13, 'PPL', 'P'),
(68206, 'Richmond Hill', 36.2449989318848, 0.632594568743217, -80.6108322143555, -1.40692443491321, 218, 33, 'PPL', 'P'),
(83276, 'Richmond Hill', 33.5563888549805, 0.585669470598939, -79.0794372558594, -1.38019655073902, 218, 48, 'PPL', 'P'),
(152094, 'Richmond Hill', 40.6997184753418, 0.710344092029481, -73.831672668457, -1.28860578031928, 218, 40, 'PPL', 'P'),
(5375, 'Richmond Hills', 34.7277793884277, 0.606114092234287, -87.7169418334961, -1.53094944477486, 218, 2, 'PPL', 'P'),
(24310, 'Richmond Hills', 33.4186096191406, 0.583264769292652, -82.0425033569336, -1.43191181015699, 218, 13, 'PPL', 'P'),
(83277, 'Richmond Hills', 34.9219398498535, 0.609502831563358, -82.4636077880859, -1.43926146897534, 218, 48, 'PPL', 'P'),
(171197, 'Richmond Lake Heights Development', 45.538890838623, 0.794803582840254, -98.5791702270508, -1.720531094346, 218, 49, 'PPL', 'P'),
(68207, 'Richmond Mill', 34.8205604553223, 0.607733427335109, -79.5283279418945, -1.38803117119187, 218, 33, 'PPL', 'P'),
(128651, 'Richmond Mill', 44.3908309936523, 0.77476615853558, -70.0697174072266, -1.22294727469809, 218, 26, 'PPL', 'P'),
(68208, 'Richmond Park Extension', 34.9519386291504, 0.610026409033668, -79.7544403076172, -1.3919775764532, 218, 33, 'PPL', 'P'),
(152088, 'Richmond Valley', 40.5200004577637, 0.707207420897586, -74.2297210693359, -1.29555303549692, 218, 40, 'PPL', 'P'),
(17789, 'Richmond West', 25.6100006103516, 0.446978832088392, -80.4297180175781, -1.40376339585734, 218, 12, 'PPL', 'P'),
(166461, 'Richmondale', 41.6372184753418, 0.726706553766928, -75.4819412231445, -1.31740840014071, 218, 45, 'PPL', 'P'),
(132828, 'Richmondville', 43.5733299255371, 0.760498073258398, -82.5936126708984, -1.44153048222409, 218, 27, 'PPL', 'P'),
(152090, 'Richmondville', 42.6341705322266, 0.744106649644097, -74.5644378662109, -1.30139494566412, 218, 40, 'PPL', 'P'),
(128653, 'Richs Corner', 44.4594383239746, 0.775963582340706, -68.466667175293, -1.19496877007599, 218, 26, 'PPL', 'P'),
(152092, 'Richs Corners', 43.2305603027344, 0.754515614764671, -78.1494369506836, -1.36396498336915, 218, 40, 'PPL', 'P'),
(33767, 'Richter', 38.6116714477539, 0.673900796461591, -95.3783264160156, -1.66466583100136, 218, 20, 'PPL', 'P'),
(17790, 'Richter Crossroads', 30.836669921875, 0.538201420487421, -85.5022201538086, -1.49229525944901, 218, 12, 'PPL', 'P'),
(83278, 'Richtex', 34.1833305358887, 0.596611667148775, -81.1819381713867, -1.41689211424116, 218, 48, 'PPL', 'P'),
(61538, 'Richton', 31.3491706848145, 0.547146246219698, -88.9400024414063, -1.55229587933433, 218, 30, 'PPL', 'P'),
(121206, 'Richton Park', 41.4844398498535, 0.724040063725486, -87.7033309936523, -1.53071189080562, 218, 18, 'PPL', 'P'),
(205508, 'Richton Ranchettes', 41.2144393920898, 0.719327666755618, -112.051940917969, -1.95567530226871, 218, 52, 'PPL', 'P'),
(5377, 'Richtown', 33.1133308410645, 0.577936649478758, -87.1347198486328, -1.5207877541615, 218, 2, 'PPL', 'P'),
(105694, 'Richtown', 37.7547187805176, 0.65894415088457, -76.460563659668, -1.33448858379193, 218, 53, 'PPL', 'P'),
(128654, 'Richtown', 44.2472190856934, 0.772259657896624, -68.3777770996094, -1.19341734558296, 218, 26, 'PPL', 'P'),
(166462, 'Richvale', 40.2805595397949, 0.703028388515033, -77.7752838134766, -1.35743477921822, 218, 45, 'PPL', 'P'),
(184529, 'Richvale', 39.4938888549805, 0.689298394936102, -121.743606567383, -2.12482677785342, 218, 6, 'PPL', 'P'),
(123543, 'Richvalley', 40.7849998474121, 0.711832532762726, -85.920280456543, -1.49959178820361, 218, 19, 'PPL', 'P'),
(28405, 'Richview', 38.3783302307129, 0.669828223943615, -89.1800003051758, -1.55648463225487, 218, 18, 'PPL', 'P'),
(5378, 'Richville', 32.814998626709, 0.572729770073489, -86.3183288574219, -1.50653904338125, 218, 2, 'PPL', 'P'),
(57171, 'Richville', 39.9897193908691, 0.697952270319288, -95.0475006103516, -1.65889183144195, 218, 29, 'PPL', 'P'),
(77093, 'Richville', 34.9377784729004, 0.609779267684508, -95.6741714477539, -1.66982930088086, 218, 42, 'PPL', 'P'),
(90297, 'Richville', 36.5622215270996, 0.638131147491437, -85.605827331543, -1.49410354582918, 218, 50, 'PPL', 'P'),
(128655, 'Richville', 43.7852783203125, 0.764197270591546, -70.5661087036133, -1.23161093719828, 218, 26, 'PPL', 'P'),
(132830, 'Richville', 43.4091682434082, 0.757632911399636, -83.6772232055664, -1.46044305386334, 218, 27, 'PPL', 'P'),
(137712, 'Richville', 46.5066719055176, 0.811694548896027, -95.6252822875977, -1.66897602406759, 218, 28, 'PPL', 'P'),
(152093, 'Richville', 44.4172210693359, 0.775226752246109, -75.392219543457, -1.31584246141974, 218, 40, 'PPL', 'P'),
(157355, 'Richville', 40.7511100769043, 0.71124104468462, -81.4780578613281, -1.42206037781063, 218, 41, 'PPL', 'P'),
(172457, 'Richville', 43.1558303833008, 0.753211331620805, -73.0522232055664, -1.27500182083894, 218, 55, 'PPL', 'P'),
(178976, 'Richville', 34.2861099243164, 0.598405505880025, -109.354721069336, -1.90859993525993, 218, 5, 'PPL', 'P'),
(205509, 'Richville', 41.0088882446289, 0.715740122451172, -111.689437866211, -1.94934843046701, 218, 52, 'PPL', 'P'),
(24311, 'Richwood', 32.0416717529297, 0.559232669931886, -83.7863922119141, -1.46234841246523, 218, 13, 'PPL', 'P'),
(37923, 'Richwood', 38.9205589294434, 0.679291900035266, -84.625, -1.4769848795002, 218, 21, 'PPL', 'P'),
(42795, 'Richwood', 32.4486083984375, 0.566335054243018, -92.084716796875, -1.607181498872, 218, 22, 'PPL', 'P'),
(71333, 'Richwood', 39.7224998474121, 0.693288409460286, -75.1658325195313, -1.31189126246845, 218, 37, 'PPL', 'P'),
(83279, 'Richwood', 33.9311103820801, 0.592209595024929, -80.2988891601563, -1.40148000153871, 218, 48, 'PPL', 'P'),
(97498, 'Richwood', 29.0558300018311, 0.507119900431702, -95.4097213745117, -1.66521377639564, 218, 51, 'PPL', 'P'),
(111105, 'Richwood', 38.2247200012207, 0.667147219674232, -80.533332824707, -1.40557181539556, 218, 58, 'PPL', 'P'),
(137714, 'Richwood', 46.9747200012207, 0.819863529223736, -95.8225021362305, -1.67241815977652, 218, 28, 'PPL', 'P'),
(157356, 'Richwood', 40.4263916015625, 0.705573638147849, -83.2969436645508, -1.45380592379464, 218, 41, 'PPL', 'P'),
(176088, 'Richwood', 43.2413902282715, 0.75470463262304, -88.7830581665039, -1.54955668499513, 218, 57, 'PPL', 'P'),
(111106, 'Richwood (historical)', 39.5813903808594, 0.690825584663208, -80.0494384765625, -1.39712626578865, 218, 58, 'PPL', 'P'),
(11577, 'Richwoods', 36.1425018310547, 0.630805656859984, -91.0116729736328, -1.58845335113823, 218, 4, 'PPL', 'P'),
(28409, 'Richwoods', 38.9580612182617, 0.67994643845218, -87.5541687011719, -1.52810851768202, 218, 18, 'PPL', 'P'),
(57173, 'Richwoods', 38.1602783203125, 0.666022500166864, -90.8280563354492, -1.58524863624048, 218, 29, 'PPL', 'P'),
(90298, 'Richwoods', 36.0063896179199, 0.628430050588606, -89.5061111450195, -1.56217634013658, 218, 50, 'PPL', 'P'),
(50794, 'Richwynn Hill', 39.5538902282715, 0.690345616455749, -76.920280456543, -1.34251215552412, 218, 25, 'PPL', 'P'),
(105695, 'Rickahock', 37.7105598449707, 0.658173432065101, -76.9722213745117, -1.34341869555918, 218, 53, 'PPL', 'P'),
(112491, 'Rickard Acres', 39.5550003051758, 0.690364990952679, -84.3661117553711, -1.47246642723672, 218, 41, 'PPL', 'P'),
(195526, 'Rickard Crossing', 42.2588882446289, 0.737556738101101, -116.681671142578, -2.03647933816724, 218, 17, 'PPL', 'P'),
(117523, 'Rickardsville', 42.5833282470703, 0.743219284368882, -90.8838882446289, -1.58622308688334, 218, 16, 'PPL', 'P'),
(97500, 'Rickels', 33.1833305358887, 0.579158374628832, -97.82861328125, -1.70743140441807, 218, 51, 'PPL', 'P'),
(166463, 'Rickenbach', 40.4261093139648, 0.705568711299833, -75.9613876342773, -1.32577631860185, 218, 45, 'PPL', 'P'),
(83292, 'Rickenbaker Subdivision', 33.5116691589355, 0.584888964662464, -80.8291702270508, -1.41073515211701, 218, 48, 'PPL', 'P'),
(97499, 'Ricker (historical)', 31.7002792358398, 0.553274246466997, -98.9199981689453, -1.72647966411486, 218, 51, 'PPL', 'P'),
(176090, 'Ricker Bay', 44.1311111450195, 0.770233192044156, -88.4705581665039, -1.54410253108265, 218, 57, 'PPL', 'P'),
(172458, 'Ricker Mills', 44.2386093139648, 0.772109389032116, -72.2397232055664, -1.26082102066649, 218, 55, 'PPL', 'P'),
(11583, 'Rickert (historical)', 36.0372200012207, 0.628968142286856, -94.3430633544922, -1.6465970819535, 218, 4, 'PPL', 'P'),
(117524, 'Ricketts', 42.1269416809082, 0.735253836127483, -95.5747222900391, -1.6680935856404, 218, 16, 'PPL', 'P'),
(166464, 'Ricketts', 41.3911094665527, 0.722411141244739, -76.2780609130859, -1.33130330997014, 218, 45, 'PPL', 'P'),
(50795, 'Ricketts Ridge', 39.4930610656738, 0.689283947287189, -76.897216796875, -1.34210961872536, 218, 25, 'PPL', 'P'),
(5379, 'Rickey', 33.2522201538086, 0.580360725281975, -87.1286087036133, -1.52068109455984, 218, 2, 'PPL', 'P'),
(90299, 'Rickman', 36.2625007629395, 0.632900033320249, -85.3755569458008, -1.49008456942814, 218, 50, 'PPL', 'P'),
(201471, 'Rickreall', 44.9308280944824, 0.784190885896288, -123.22721862793, -2.15072069313226, 218, 43, 'PPL', 'P'),
(5380, 'Ricks (historical)', 34.0588912963867, 0.594439792700788, -85.6836090087891, -1.49546109219484, 218, 2, 'PPL', 'P'),
(24312, 'Ricks Place', 31.7622203826904, 0.554355323422001, -85.0994415283203, -1.48526544627758, 218, 13, 'PPL', 'P'),
(97501, 'Ricky Colonia', 26.2870006561279, 0.458794711923342, -98.0070037841797, -1.71054490604848, 218, 51, 'PPL', 'P'),
(14483, 'Ricland Heights', 38.6738891601563, 0.674986700396071, -75.6386108398438, -1.32014280078995, 218, 10, 'PPL', 'P'),
(24313, 'Rico', 33.5811080932617, 0.586100902695532, -84.7688903808594, -1.47949624040815, 218, 13, 'PPL', 'P'),
(68210, 'Rico', 34.4386100769043, 0.601067135652478, -78.6241683959961, -1.3722506101526, 218, 33, 'PPL', 'P'),
(166465, 'Rico', 40.5499992370605, 0.707730998367895, -79.0202789306641, -1.37916404318439, 218, 45, 'PPL', 'P'),
(184530, 'Rico', 32.8066711425781, 0.572584428056998, -115.396667480469, -2.01405179336325, 218, 6, 'PPL', 'P'),
(187256, 'Rico', 37.6927795410156, 0.65786310721908, -108.029716491699, -1.88547424277617, 218, 7, 'PPL', 'P'),
(42796, 'Ricohoc', 29.7075004577637, 0.518493695525699, -91.3833312988281, -1.59494001260534, 218, 22, 'PPL', 'P'),
(11584, 'Ricusky', 34.4791717529297, 0.601775070449248, -91.5411071777344, -1.59769372117248, 218, 4, 'PPL', 'P'),
(68211, 'Riddick Crossroads', 36.4461097717285, 0.636104615059942, -76.8697204589844, -1.34162971709692, 218, 33, 'PPL', 'P'),
(68212, 'Riddicks Landing', 36.5311088562012, 0.63758812894517, -76.9258270263672, -1.34260896142975, 218, 33, 'PPL', 'P'),
(68213, 'Riddicksville', 36.5272216796875, 0.6375202849164, -76.9391708374023, -1.34284185486707, 218, 33, 'PPL', 'P'),
(5382, 'Riddle', 32.6547203063965, 0.56993238566447, -86.2486114501953, -1.50532224507919, 218, 2, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(30963, 'Riddle', 38.250560760498, 0.667598226004837, -86.4305572509766, -1.508497798363, 218, 19, 'PPL', 'P'),
(42797, 'Riddle', 30.7194404602051, 0.536155380400941, -91.3097229003906, -1.59365530369548, 218, 22, 'PPL', 'P'),
(68214, 'Riddle', 36.2900009155273, 0.633380001527709, -76.0444412231445, -1.32722587718318, 218, 33, 'PPL', 'P'),
(195527, 'Riddle', 42.186939239502, 0.736300991068102, -116.109443664551, -2.02649208460528, 218, 17, 'PPL', 'P'),
(201472, 'Riddle', 42.9511108398438, 0.7496383015443, -123.363059997559, -2.15309157229271, 218, 43, 'PPL', 'P'),
(111107, 'Riddle (historical)', 39.1952781677246, 0.684086655261845, -80.9797210693359, -1.41336276000654, 218, 58, 'PPL', 'P'),
(166466, 'Riddle Crossroads', 41.2002792358398, 0.719080525406459, -79.8444366455078, -1.39354830886413, 218, 45, 'PPL', 'P'),
(28411, 'Riddle Hill', 39.7866706848145, 0.694408401856719, -89.7644424438477, -1.56668507186209, 218, 18, 'PPL', 'P'),
(90300, 'Riddles Store', 35.6091690063477, 0.621497243059884, -84.5422210693359, -1.47554011460883, 218, 50, 'PPL', 'P'),
(166467, 'Riddlesburg', 40.1619415283203, 0.700958113662633, -78.2547225952148, -1.3658025645213, 218, 45, 'PPL', 'P'),
(71334, 'Riddleton', 39.5944404602051, 0.691053351515437, -75.3530578613281, -1.31515896112597, 218, 37, 'PPL', 'P'),
(90303, 'Riddleton', 36.3213882446289, 0.633927813763938, -86.0180587768555, -1.50129834183013, 218, 50, 'PPL', 'P'),
(24314, 'Riddleville', 32.9066696166992, 0.574329730677382, -82.6658325195313, -1.44279095636802, 218, 13, 'PPL', 'P'),
(28412, 'Riddleville', 38.8519401550293, 0.678094276493057, -87.6513900756836, -1.52980535077056, 218, 18, 'PPL', 'P'),
(79026, 'Riddlewood', 39.9055595397949, 0.696483403820055, -75.4327774047852, -1.31655032963748, 218, 45, 'PPL', 'P'),
(42798, 'Rideau Settlement', 30.6836109161377, 0.535530036887476, -91.9033279418945, -1.60401566612616, 218, 22, 'PPL', 'P'),
(50796, 'Riden', 39.0741691589355, 0.681972904304649, -76.7013931274414, -1.3386918509404, 218, 25, 'PPL', 'P'),
(90301, 'Ridenour', 36.226390838623, 0.632269796248282, -83.9527816772461, -1.46525245647591, 218, 50, 'PPL', 'P'),
(17791, 'Rideout', 30.0847206115723, 0.525077429214538, -81.811393737793, -1.42787818636996, 218, 12, 'PPL', 'P'),
(5383, 'Rideout Village', 34.750560760498, 0.606511702185036, -86.6688919067383, -1.51265752282765, 218, 2, 'PPL', 'P'),
(112659, 'Rider', 39.1725006103516, 0.683689111890123, -80.3708267211914, -1.40273554883463, 218, 58, 'PPL', 'P'),
(117525, 'Rider', 41.6441688537598, 0.726827860754581, -93.7694396972656, -1.63658546046756, 218, 16, 'PPL', 'P'),
(198809, 'Rider', 46.9141693115234, 0.818806720324165, -103.636940002441, -1.80880582973442, 218, 34, 'PPL', 'P'),
(152111, 'Riders', 42.4727783203125, 0.74128982415912, -73.5436096191406, -1.28357813165538, 218, 40, 'PPL', 'P'),
(37924, 'Riders Mill', 37.4105606079102, 0.652937457624924, -85.9991683959961, -1.50096864248718, 218, 21, 'PPL', 'P'),
(152095, 'Riders Mills', 42.4808311462402, 0.741430372485649, -73.5644378662109, -1.28394165314417, 218, 40, 'PPL', 'P'),
(197376, 'Riders Trailer Court', 45.8619384765625, 0.800441827763088, -111.322776794434, -1.94294898752561, 218, 31, 'PPL', 'P'),
(111108, 'Ridersville', 39.6238899230957, 0.691567341605823, -78.1908264160156, -1.36468736581483, 218, 58, 'PPL', 'P'),
(123544, 'Ridertown', 40.4355583190918, 0.705733627550336, -85.2063903808594, -1.48713205588562, 218, 19, 'PPL', 'P'),
(50797, 'Ridervale', 39.4147186279297, 0.687916613804515, -76.6355590820313, -1.33754283008809, 218, 25, 'PPL', 'P'),
(5386, 'Riderville', 32.6772193908691, 0.570325068767202, -86.9313888549805, -1.51723895885091, 218, 2, 'PPL', 'P'),
(97502, 'Riderville', 32.1930618286133, 0.561874925207408, -94.3813934326172, -1.64726606801932, 218, 51, 'PPL', 'P'),
(5384, 'Riderwood', 32.1286087036133, 0.560750005962959, -88.3277816772461, -1.54161061125066, 218, 2, 'PPL', 'P'),
(50798, 'Riderwood', 39.4091682434082, 0.687819741319863, -76.6488876342773, -1.33777545720931, 218, 25, 'PPL', 'P'),
(50799, 'Riderwood Hills', 39.4116706848145, 0.687863417161741, -76.6222229003906, -1.33731006980882, 218, 25, 'PPL', 'P'),
(5385, 'Ridge', 33.0080604553223, 0.576099334642712, -88.1486129760742, -1.53848352749869, 218, 2, 'PPL', 'P'),
(11585, 'Ridge', 35.7472190856934, 0.623906671477106, -90.6869430541992, -1.58278574486438, 218, 4, 'PPL', 'P'),
(42800, 'Ridge', 30.1588897705078, 0.526371925241398, -92.1761093139648, -1.6087765992069, 218, 22, 'PPL', 'P'),
(50800, 'Ridge', 38.1191711425781, 0.665305044569197, -76.3741683959961, -1.33298070198273, 218, 25, 'PPL', 'P'),
(97504, 'Ridge', 31.1452808380127, 0.54358769708162, -96.3216705322266, -1.68113029180855, 218, 51, 'PPL', 'P'),
(128656, 'Ridge', 44.8408317565918, 0.782620153485359, -67.0158309936523, -1.1696469017993, 218, 26, 'PPL', 'P'),
(137716, 'Ridge', 47.622501373291, 0.831169446999449, -92.0358276367188, -1.60632822205873, 218, 28, 'PPL', 'P'),
(152097, 'Ridge', 40.8938903808594, 0.713733031095634, -72.8963928222656, -1.2722820675757, 218, 40, 'PPL', 'P'),
(184531, 'Ridge', 39.336669921875, 0.686554406906939, -123.300003051758, -2.15199102097223, 218, 6, 'PPL', 'P'),
(197375, 'Ridge', 45.0469398498535, 0.786217418327784, -105.019721984863, -1.83293992816494, 218, 31, 'PPL', 'P'),
(61544, 'Ridge (historical)', 33.9874992370605, 0.593193766205767, -89.0083312988281, -1.55348844287047, 218, 30, 'PPL', 'P'),
(74073, 'Ridge (historical)', 39.3972206115723, 0.68761121580651, -84.2102813720703, -1.46974667397348, 218, 41, 'PPL', 'P'),
(166468, 'Ridge Acres', 40.336669921875, 0.704007699426883, -76.8324966430664, -1.340980038949, 218, 45, 'PPL', 'P'),
(90302, 'Ridge Bay', 35.1741714477539, 0.613905103424286, -85.1566696166992, -1.48626426484442, 218, 50, 'PPL', 'P'),
(24317, 'Ridge Corners', 33.8027801513672, 0.589969809969145, -84.8583297729492, -1.4810572522811, 218, 13, 'PPL', 'P'),
(50801, 'Ridge Crest Estates', 39.4297218322754, 0.688178469118697, -77.5005569458008, -1.35263989083358, 218, 25, 'PPL', 'P'),
(24315, 'Ridge Crossing', 33.4855613708496, 0.584433297799952, -82.1297225952148, -1.43343407303608, 218, 13, 'PPL', 'P'),
(166469, 'Ridge Estates', 40.2599983215332, 0.702669527558145, -75.5999984741211, -1.3194688878761, 218, 45, 'PPL', 'P'),
(28413, 'Ridge Farm', 39.8955612182617, 0.696308900189627, -87.6519393920898, -1.52981493815048, 218, 18, 'PPL', 'P'),
(111109, 'Ridge Farms', 39.5644416809082, 0.690529774045128, -80.1141662597656, -1.39825597872306, 218, 58, 'PPL', 'P'),
(5400, 'Ridge Grove', 32.6577796936035, 0.569985782044326, -85.5180587768555, -1.49257169557016, 218, 2, 'PPL', 'P'),
(50802, 'Ridge Grove', 39.3802795410156, 0.687315538346484, -76.5266723632813, -1.33564239833421, 218, 25, 'PPL', 'P'),
(17792, 'Ridge Harbor', 26.9902801513672, 0.471069254677031, -81.954719543457, -1.43037969358187, 218, 12, 'PPL', 'P'),
(90327, 'Ridge Lake North', 35.1433296203613, 0.613366811988954, -85.1927795410156, -1.48689450191639, 218, 50, 'PPL', 'P'),
(17793, 'Ridge Manor', 28.5072193145752, 0.497544837627458, -82.1705627441406, -1.43414686810184, 218, 12, 'PPL', 'P'),
(152098, 'Ridge Mills', 43.2402801513672, 0.75468525812611, -75.4383316040039, -1.31664726870116, 218, 40, 'PPL', 'P'),
(24316, 'Ridge Point', 33.4808311462402, 0.584350739806159, -82.1277770996094, -1.43340011773218, 218, 13, 'PPL', 'P'),
(57176, 'Ridge Prairie', 38.9555587768555, 0.679902762610303, -93.0680618286133, -1.62434410735896, 218, 29, 'PPL', 'P'),
(205514, 'Ridge Road', 40.6505584716797, 0.709486088105285, -111.812217712402, -1.95149134303814, 218, 52, 'PPL', 'P'),
(97505, 'Ridge Road Colonia', 26.1800003051758, 0.456927203498438, -98.2030029296875, -1.71396573646868, 218, 51, 'PPL', 'P'),
(83280, 'Ridge Road Crossroads', 34.0027809143066, 0.593460481788939, -81.4722213745117, -1.42195851189893, 218, 48, 'PPL', 'P'),
(83281, 'Ridge Spring', 33.8452796936035, 0.590711566911759, -81.6619415283203, -1.42526975324028, 218, 48, 'PPL', 'P'),
(166470, 'Ridge Valley', 40.377498626709, 0.704720294755561, -75.3775024414063, -1.3155855995326, 218, 45, 'PPL', 'P'),
(166471, 'Ridge View', 40.1408309936523, 0.70058966532582, -79.5466690063477, -1.38835128315489, 218, 45, 'PPL', 'P'),
(184532, 'Ridge View', 39.228889465332, 0.684673283070962, -121.076667785645, -2.11318650020285, 218, 6, 'PPL', 'P'),
(105696, 'Ridge Wood Estates', 38.6433296203613, 0.674453335808756, -77.4783325195313, -1.35225200142081, 218, 53, 'PPL', 'P'),
(17794, 'Ridge Wood Heights', 27.2869396209717, 0.476246939178849, -82.5133285522461, -1.44012926001654, 218, 12, 'PPL', 'P'),
(113975, 'Ridgebury', 41.3605613708496, 0.721877976394505, -73.5247192382813, -1.28324843231243, 218, 8, 'PPL', 'P'),
(152099, 'Ridgebury', 41.3863906860352, 0.722328782988028, -74.4538879394531, -1.29946548545435, 218, 40, 'PPL', 'P'),
(166472, 'Ridgebury', 41.973331451416, 0.7325728318581, -76.7219390869141, -1.33905044558118, 218, 45, 'PPL', 'P'),
(11586, 'Ridgecrest', 35.0188903808594, 0.611194937540967, -92.0694427490234, -1.60691491644688, 218, 4, 'PPL', 'P'),
(17795, 'Ridgecrest', 27.8969402313232, 0.486893458268659, -82.8036117553711, -1.44519565767431, 218, 12, 'PPL', 'P'),
(24318, 'Ridgecrest', 33.5566711425781, 0.585674397446956, -84.232780456543, -1.47013935707621, 218, 13, 'PPL', 'P'),
(42802, 'Ridgecrest', 32.4719390869141, 0.566742251573692, -92.1858291625977, -1.60894624256834, 218, 22, 'PPL', 'P'),
(68217, 'Ridgecrest', 35.6205596923828, 0.621696048035259, -82.2827835083008, -1.43610548992554, 218, 33, 'PPL', 'P'),
(83284, 'Ridgecrest', 34.1741714477539, 0.596451810904343, -79.8247222900391, -1.39320422845129, 218, 48, 'PPL', 'P'),
(97506, 'Ridgecrest', 30.1658306121826, 0.526493065781483, -93.7480621337891, -1.63621235159884, 218, 51, 'PPL', 'P'),
(105697, 'Ridgecrest', 36.6661109924316, 0.639944360719618, -79.4097213745117, -1.38596109607655, 218, 53, 'PPL', 'P'),
(121208, 'Ridgecrest', 41.3994407653809, 0.722556549840257, -88.3977813720703, -1.54283233640074, 218, 18, 'PPL', 'P'),
(184533, 'Ridgecrest', 35.622501373291, 0.62172993676013, -117.669998168945, -2.05372889886379, 218, 6, 'PPL', 'P'),
(208556, 'Ridgecrest', 47.747501373291, 0.833351108564442, -122.316673278809, -2.13482867880138, 218, 56, 'PPL', 'P'),
(184534, 'Ridgecrest Estates', 33.4013900756836, 0.582964231563637, -117.206108093262, -2.04563248967579, 218, 6, 'PPL', 'P'),
(50803, 'Ridgecroft', 39.5591697692871, 0.690437761829466, -76.4036102294922, -1.33349455891506, 218, 25, 'PPL', 'P'),
(24319, 'Ridgedale', 34.1652793884277, 0.596296615191819, -85.1666717529297, -1.48643883505387, 218, 13, 'PPL', 'P'),
(37925, 'Ridgedale', 37.2605590820313, 0.650319437115321, -86.267219543457, -1.50564701757412, 218, 21, 'PPL', 'P'),
(57178, 'Ridgedale', 36.5038909912109, 0.637113087585727, -93.2236099243164, -1.62705893377418, 218, 29, 'PPL', 'P'),
(90308, 'Ridgedale', 35.9841690063477, 0.628042227754863, -84.0286102294922, -1.46657591437963, 218, 50, 'PPL', 'P'),
(105699, 'Ridgedale', 36.940559387207, 0.644734388835262, -81.5738906860352, -1.42373297613325, 218, 53, 'PPL', 'P'),
(111111, 'Ridgedale', 39.5469398498535, 0.690224309468096, -79.9358291625977, -1.39514340919903, 218, 58, 'PPL', 'P'),
(195528, 'Ridgedale', 42.0230598449707, 0.733440756057357, -112.47917175293, -1.96313188700482, 218, 17, 'PPL', 'P'),
(146162, 'Ridgedale Park', 40.7666702270508, 0.71151262053678, -74.4122161865234, -1.29873817616065, 218, 37, 'PPL', 'P'),
(24320, 'Ridgefield', 33.3816719055176, 0.582620084571771, -84.5597229003906, -1.47584557918587, 218, 13, 'PPL', 'P'),
(50804, 'Ridgefield', 39.1375007629395, 0.683078249315086, -76.7377777099609, -1.33932688170233, 218, 25, 'PPL', 'P'),
(79027, 'Ridgefield', 39.9238891601563, 0.696803316046, -76.7263870239258, -1.33912807672696, 218, 45, 'PPL', 'P'),
(90311, 'Ridgefield', 35.874439239502, 0.62612708203596, -86.4591674804688, -1.50899714106739, 218, 50, 'PPL', 'P'),
(113976, 'Ridgefield', 41.2813911437988, 0.720496195262918, -73.4986114501953, -1.28279276544991, 218, 8, 'PPL', 'P'),
(121209, 'Ridgefield', 42.2683296203613, 0.73772152119355, -88.3613891601563, -1.54219717248075, 218, 18, 'PPL', 'P'),
(146163, 'Ridgefield', 40.834171295166, 0.712690736424004, -74.0091705322266, -1.29170370245732, 218, 37, 'PPL', 'P'),
(208557, 'Ridgefield', 45.8152809143066, 0.799627499680769, -122.741386413574, -2.1422413213795, 218, 56, 'PPL', 'P'),
(146164, 'Ridgefield Park', 40.8569412231445, 0.713088146637671, -74.0219421386719, -1.29192660904056, 218, 37, 'PPL', 'P'),
(90313, 'Ridgefields', 36.545280456543, 0.637835470031411, -82.6022186279297, -1.44168068450957, 218, 50, 'PPL', 'P'),
(178977, 'Ridgegate', 33.6150016784668, 0.586692457352666, -112.062217712402, -1.95585466616813, 218, 5, 'PPL', 'P'),
(192111, 'Ridgeheights', 31.9533290863037, 0.557690799529271, -102.062217712402, -1.7813217409687, 218, 51, 'PPL', 'P'),
(24322, 'Ridgelake', 33.4027786254883, 0.582988466329556, -84.5813903808594, -1.47622374806066, 218, 13, 'PPL', 'P'),
(61539, 'Ridgeland', 32.4283294677734, 0.565981120134147, -90.1322174072266, -1.57310395587945, 218, 30, 'PPL', 'P'),
(74068, 'Ridgeland', 39.0136108398438, 0.680915962247024, -82.5224990844727, -1.44028931599805, 218, 41, 'PPL', 'P'),
(83285, 'Ridgeland', 32.4805603027344, 0.566892720175281, -80.9805603027344, -1.41337740739253, 218, 48, 'PPL', 'P'),
(152100, 'Ridgeland', 43.0908317565918, 0.752076891575459, -77.6105575561523, -1.35455976366342, 218, 40, 'PPL', 'P'),
(166474, 'Ridgeland', 40.2638893127441, 0.702737438165942, -76.966667175293, -1.34332175649551, 218, 45, 'PPL', 'P'),
(176091, 'Ridgeland', 45.2036094665527, 0.788951818977023, -91.8952789306641, -1.60387518437866, 218, 57, 'PPL', 'P'),
(205520, 'Ridgeland Downs Condominium', 40.7102813720703, 0.710528449355942, -111.975280761719, -1.95433733013706, 218, 52, 'PPL', 'P'),
(83286, 'Ridgeland Estates', 34.6949996948242, 0.60554197865311, -83.0305633544922, -1.44915671032164, 218, 48, 'PPL', 'P'),
(50805, 'Ridgeland Farm Estates', 39.0894393920898, 0.682239420150738, -77.3111114501953, -1.3493334431822, 218, 25, 'PPL', 'P'),
(202553, 'Ridgeland Heights', 44.0827789306641, 0.769389635768873, -103.362503051758, -1.80401600135586, 218, 49, 'PPL', 'P'),
(193174, 'Ridgelawn', 47.7919387817383, 0.834126687652901, -104.085830688477, -1.81664045018727, 218, 31, 'PPL', 'P'),
(105701, 'Ridgelea', 38.5155601501465, 0.672223337869978, -77.970832824707, -1.36084775331321, 218, 53, 'PPL', 'P'),
(152101, 'Ridgelea Heights', 43.2011108398438, 0.754001624674286, -78.6752777099609, -1.37314263595972, 218, 40, 'PPL', 'P'),
(50806, 'Ridgeleigh', 39.3950004577637, 0.687572466812649, -76.5608291625977, -1.33623854694422, 218, 25, 'PPL', 'P'),
(111112, 'Ridgeley', 39.6413917541504, 0.691872806182855, -78.7747192382813, -1.37487821804213, 218, 58, 'PPL', 'P'),
(28415, 'Ridgely', 39.8313903808594, 0.695188907793194, -89.6338882446289, -1.56440647123341, 218, 18, 'PPL', 'P'),
(50807, 'Ridgely', 38.9477806091309, 0.679767007973736, -75.8847198486328, -1.32443821331214, 218, 25, 'PPL', 'P'),
(57179, 'Ridgely', 39.4555587768555, 0.688629408870275, -94.6383285522461, -1.65175043182085, 218, 29, 'PPL', 'P'),
(90314, 'Ridgely', 36.2633285522461, 0.632914480969163, -89.4877777099609, -1.56185636133161, 218, 50, 'PPL', 'P'),
(50808, 'Ridgely Acres', 38.9191703796387, 0.679267665269346, -75.8625030517578, -1.32405045705742, 218, 25, 'PPL', 'P'),
(50809, 'Ridgely Estates', 39.4174995422363, 0.687965149915382, -77.1269378662109, -1.34611900774647, 218, 25, 'PPL', 'P'),
(50810, 'Ridgely Park', 39.3933296203613, 0.687543305198713, -76.9261093139648, -1.34261388827776, 218, 25, 'PPL', 'P'),
(50811, 'Ridgemar', 39.3763885498047, 0.687247627738687, -76.9113922119141, -1.34235702639062, 218, 25, 'PPL', 'P'),
(184535, 'Ridgemark', 36.8125, 0.642499330890413, -121.364723205566, -2.1182140157087, 218, 6, 'PPL', 'P'),
(30967, 'Ridgemede', 39.1519393920898, 0.683330250933235, -86.503059387207, -1.50976319935495, 218, 19, 'PPL', 'P'),
(50813, 'Ridgemont', 39.5138893127441, 0.689647468775985, -76.9130630493164, -1.34238618800456, 218, 25, 'PPL', 'P'),
(166475, 'Ridgemont', 40.8280601501465, 0.712584076822347, -77.9488906860352, -1.36046479074846, 218, 45, 'PPL', 'P'),
(30964, 'Ridgeport', 39.0455589294434, 0.681473561600259, -86.8036117553711, -1.51500882775408, 218, 19, 'PPL', 'P'),
(117526, 'Ridgeport', 42.1769409179688, 0.736126487437674, -93.9172210693359, -1.6391647319833, 218, 16, 'PPL', 'P'),
(90315, 'Ridgepost (historical)', 36.3472213745117, 0.634378686936488, -86.8744430541992, -1.5162450671321, 218, 50, 'PPL', 'P'),
(90316, 'Ridgeside', 35.0325012207031, 0.611432491510202, -85.2525024414063, -1.48793686316704, 218, 50, 'PPL', 'P'),
(33770, 'Ridgeton', 38.4674987792969, 0.67138450870563, -95.7680587768555, -1.67146794389958, 218, 20, 'PPL', 'P'),
(157362, 'Ridgeton', 40.8997192382813, 0.713834763849275, -82.9449996948242, -1.44766334274037, 218, 41, 'PPL', 'P'),
(37926, 'Ridgetop', 37.9069404602051, 0.661600920388033, -85.6211090087891, -1.49437026141235, 218, 21, 'PPL', 'P'),
(90317, 'Ridgetop', 36.3950004577637, 0.63521258925282, -86.7794418334961, -1.51458698303741, 218, 50, 'PPL', 'P'),
(176093, 'Ridgetop', 45.9297218322754, 0.801624870498328, -88.2699966430664, -1.54060207214585, 218, 57, 'PPL', 'P'),
(50818, 'Ridgeview', 39.5858306884766, 0.69090308265093, -76.3947219848633, -1.33333942978156, 218, 25, 'PPL', 'P'),
(83287, 'Ridgeview', 34.6652793884277, 0.60502326145179, -82.9216690063477, -1.4472561454097, 218, 48, 'PPL', 'P'),
(90318, 'Ridgeview', 36.2013893127441, 0.631833437303672, -83.3383331298828, -1.45452830624033, 218, 50, 'PPL', 'P'),
(105702, 'Ridgeview', 38.788890838623, 0.676993858330637, -77.1050033569336, -1.34573617833977, 218, 53, 'PPL', 'P'),
(111114, 'Ridgeview', 37.8433303833008, 0.660490715108606, -82.0163879394531, -1.43145601013642, 218, 58, 'PPL', 'P'),
(123545, 'Ridgeview', 40.7613906860352, 0.711420475163064, -86.0755615234375, -1.50230195408693, 218, 19, 'PPL', 'P'),
(166476, 'Ridgeview', 40.3097190856934, 0.703537318599347, -76.8125, -1.34063103168814, 218, 45, 'PPL', 'P'),
(202555, 'Ridgeview', 45.0849990844727, 0.786881677282677, -100.800003051758, -1.75929193927351, 218, 49, 'PPL', 'P'),
(68222, 'Ridgeview Acres', 35.9966697692871, 0.628260407227168, -80.1933288574219, -1.39963762669659, 218, 33, 'PPL', 'P'),
(50819, 'Ridgeview Estates', 39.5086097717285, 0.689555323402268, -77.040283203125, -1.34460659856341, 218, 25, 'PPL', 'P'),
(24323, 'Ridgeview Forest', 33.9044418334961, 0.59174414104541, -84.3625030517578, -1.47240344347694, 218, 13, 'PPL', 'P'),
(24324, 'Ridgeview Heights', 33.7936096191406, 0.589809753987631, -84.8541717529297, -1.48098468114139, 218, 13, 'PPL', 'P'),
(37927, 'Ridgeview Heights', 38.976390838623, 0.680266350678126, -84.5861129760742, -1.47630617289639, 218, 21, 'PPL', 'P'),
(90319, 'Ridgeview Heights', 36.1022186279297, 0.630102582332203, -83.8402786254883, -1.4632889078042, 218, 50, 'PPL', 'P'),
(117527, 'Ridgeview Park', 41.5924987792969, 0.725926047830453, -90.605827331543, -1.58137000842889, 218, 16, 'PPL', 'P'),
(184536, 'Ridgeview Village', 38.6694412231445, 0.674909069250295, -121.083610534668, -2.11330767403245, 218, 6, 'PPL', 'P'),
(5392, 'Ridgeville', 34.0555610656738, 0.594381669209997, -86.1022186279297, -1.50276720832937, 218, 2, 'PPL', 'P'),
(24326, 'Ridgeville', 31.4061107635498, 0.548140038069974, -81.4016723632813, -1.42072719936893, 218, 13, 'PPL', 'P'),
(50820, 'Ridgeville', 39.3650016784668, 0.68704888934234, -77.1658325195313, -1.34679784750833, 218, 25, 'PPL', 'P'),
(68224, 'Ridgeville', 36.3002815246582, 0.633559432006153, -79.1808319091797, -1.38196622128337, 218, 33, 'PPL', 'P'),
(74069, 'Ridgeville', 39.5286102294922, 0.68990439724215, -84.1769409179688, -1.46916477327529, 218, 41, 'PPL', 'P'),
(83288, 'Ridgeville', 33.0955581665039, 0.577626457790791, -80.315559387207, -1.4017709518878, 218, 48, 'PPL', 'P'),
(90320, 'Ridgeville', 35.2733306884766, 0.615635758658674, -86.3000030517578, -1.50621919773433, 218, 50, 'PPL', 'P'),
(111115, 'Ridgeville', 39.348331451416, 0.686757938993249, -78.9908294677734, -1.37865005309401, 218, 58, 'PPL', 'P'),
(121212, 'Ridgeville', 40.7136116027832, 0.710586572846733, -88.0677795410156, -1.53707271791122, 218, 18, 'PPL', 'P'),
(123546, 'Ridgeville', 40.2891693115234, 0.703178657379541, -85.0288925170898, -1.48403413374759, 218, 19, 'PPL', 'P'),
(132831, 'Ridgeville', 41.7572212219238, 0.728800996806221, -84.0216674804688, -1.46645474055003, 218, 27, 'PPL', 'P'),
(166477, 'Ridgeville', 40.9686088562012, 0.715037114502419, -76.5652770996094, -1.33631617809, 218, 45, 'PPL', 'P'),
(193906, 'Ridgeville', 40.8647193908691, 0.713223901274238, -122.801940917969, -2.1432981968581, 218, 6, 'PPL', 'P'),
(157363, 'Ridgeville Corners', 41.4377784729004, 0.72322566906414, -84.2574996948242, -1.4705707891728, 218, 41, 'PPL', 'P'),
(11587, 'Ridgeway', 36.3177795410156, 0.633864830004158, -93.2044372558594, -1.62672430758321, 218, 4, 'PPL', 'P'),
(24329, 'Ridgeway', 33.586669921875, 0.586197974917265, -83.788330078125, -1.46238223461108, 218, 13, 'PPL', 'P'),
(37928, 'Ridgeway', 36.8974990844727, 0.643982844775641, -83.1255569458008, -1.45081466125827, 218, 21, 'PPL', 'P'),
(50822, 'Ridgeway', 39.274169921875, 0.685463576124443, -76.7624969482422, -1.33975831379893, 218, 25, 'PPL', 'P'),
(68225, 'Ridgeway', 36.4355583190918, 0.635920457470563, -78.2369384765625, -1.36549217309625, 218, 33, 'PPL', 'P'),
(83289, 'Ridgeway', 34.3074989318848, 0.598778814485827, -80.960563659668, -1.41302840013168, 218, 48, 'PPL', 'P'),
(97507, 'Ridgeway', 33.1802787780762, 0.57910511140703, -95.769172668457, -1.67148738497554, 218, 51, 'PPL', 'P'),
(105705, 'Ridgeway', 36.9891700744629, 0.645582805379534, -79.482780456543, -1.38723621760648, 218, 53, 'PPL', 'P'),
(111116, 'Ridgeway', 39.2972183227539, 0.685865846607099, -78.0719375610352, -1.36261236385149, 218, 58, 'PPL', 'P'),
(113979, 'Ridgeway', 41.0666694641113, 0.716748594976958, -73.5561065673828, -1.28379624454865, 218, 8, 'PPL', 'P'),
(117528, 'Ridgeway', 43.297779083252, 0.755688803803879, -91.9875030517578, -1.60548479894151, 218, 16, 'PPL', 'P'),
(123547, 'Ridgeway', 40.4891700744629, 0.706669329199335, -86.2955627441406, -1.50614169974661, 218, 19, 'PPL', 'P'),
(132832, 'Ridgeway', 41.9938888549805, 0.732931626235961, -83.8627777099609, -1.46368159090693, 218, 27, 'PPL', 'P'),
(137718, 'Ridgeway', 43.9119415283203, 0.76640796061242, -91.5599975585938, -1.59802342051543, 218, 28, 'PPL', 'P'),
(139423, 'Ridgeway', 40.378059387207, 0.704730081872567, -93.9366683959961, -1.63950415186423, 218, 29, 'PPL', 'P'),
(146167, 'Ridgeway', 40.0313911437988, 0.698679579612988, -74.2844390869141, -1.29650804506382, 218, 37, 'PPL', 'P'),
(152103, 'Ridgeway', 41.0027809143066, 0.715633529428542, -73.7633285522461, -1.28741295046704, 218, 40, 'PPL', 'P'),
(157365, 'Ridgeway', 40.5138893127441, 0.707100761295928, -83.5727767944336, -1.45862012009718, 218, 41, 'PPL', 'P'),
(176095, 'Ridgeway', 43.0022201538086, 0.750530327351422, -89.9902801513672, -1.57062668343346, 218, 57, 'PPL', 'P'),
(197378, 'Ridgeway', 45.485279083252, 0.793867881191255, -104.511390686035, -1.82406787330945, 218, 31, 'PPL', 'P'),
(212122, 'Ridgeway', 60.5319404602051, 1.05648166365175, -151.08528137207, -2.63693561124468, 218, 1, 'PPL', 'P'),
(50823, 'Ridgeway Manor', 39.2224998474121, 0.684561763200315, -76.6494369506836, -1.33778504458923, 218, 25, 'PPL', 'P'),
(50824, 'Ridgeways', 39.3413887023926, 0.68663676516365, -76.9875030517578, -1.34368541114236, 218, 25, 'PPL', 'P'),
(5393, 'Ridgewood', 33.7013893127441, 0.588200206003814, -86.6497192382813, -1.51232289663668, 218, 2, 'PPL', 'P'),
(14484, 'Ridgewood', 39.7666702270508, 0.694059328016837, -75.5124969482422, -1.317941698149, 218, 10, 'PPL', 'P'),
(17798, 'Ridgewood', 27.8911094665527, 0.486791692225505, -81.9138870239258, -1.42966703167416, 218, 12, 'PPL', 'P'),
(24333, 'Ridgewood', 33.4702796936035, 0.58416658221678, -82.0722198486328, -1.43243046077928, 218, 13, 'PPL', 'P'),
(30965, 'Ridgewood', 39.603328704834, 0.691208480648935, -86.3594436645508, -1.50725663213697, 218, 19, 'PPL', 'P'),
(42803, 'Ridgewood', 30.5052795410156, 0.532417567231987, -91.0319366455078, -1.58880701893099, 218, 22, 'PPL', 'P'),
(50825, 'Ridgewood', 38.3397216796875, 0.669154377608798, -76.7597198486328, -1.33970984426709, 218, 25, 'PPL', 'P'),
(83290, 'Ridgewood', 34.7036094665527, 0.605692247517618, -82.9147186279297, -1.44713483842205, 218, 48, 'PPL', 'P'),
(90324, 'Ridgewood', 36.2527809143066, 0.632730389958811, -83.2622222900391, -1.45319992148859, 218, 50, 'PPL', 'P'),
(113981, 'Ridgewood', 41.3125, 0.721039147230157, -72.1047210693359, -1.25846478889204, 218, 8, 'PPL', 'P'),
(121213, 'Ridgewood', 41.5355606079102, 0.72493228926969, -88.040283203125, -1.53659281628279, 218, 18, 'PPL', 'P'),
(146168, 'Ridgewood', 40.9791717529297, 0.715221471828879, -74.116943359375, -1.29358469313524, 218, 37, 'PPL', 'P'),
(152106, 'Ridgewood', 40.7000007629395, 0.710349018877498, -73.9061126708984, -1.28990500345708, 218, 40, 'PPL', 'P'),
(166479, 'Ridgewood', 41.2772216796875, 0.720423424386131, -75.8130569458008, -1.32318745970618, 218, 45, 'PPL', 'P'),
(184537, 'Ridgewood', 39.2158317565918, 0.684445383060678, -120.09139251709, -2.0959902027281, 218, 6, 'PPL', 'P'),
(187257, 'Ridgewood', 39.9658317565918, 0.697535352450636, -105.423057556152, -1.83997946187435, 218, 7, 'PPL', 'P'),
(68230, 'Ridgewood Acres', 35.8588905334473, 0.625855705920881, -80.2091674804688, -1.39991406281774, 218, 33, 'PPL', 'P'),
(90325, 'Ridgewood Acres', 35.0527801513672, 0.611786425619074, -85.2447204589844, -1.48780104195145, 218, 50, 'PPL', 'P'),
(157366, 'Ridgewood Acres', 40.0188903808594, 0.698461400140684, -81.6344375610352, -1.42478971845379, 218, 41, 'PPL', 'P'),
(5396, 'Ridgewood Estates', 33.5944404602051, 0.586333596395778, -86.5180587768555, -1.51002498809011, 218, 2, 'PPL', 'P'),
(24335, 'Ridgewood Estates', 34.1722183227539, 0.59641772244239, -85.1624984741211, -1.48636599759806, 218, 13, 'PPL', 'P'),
(50827, 'Ridgewood Estates', 39.392219543457, 0.687523930701783, -77.1402816772461, -1.3463519011838, 218, 25, 'PPL', 'P'),
(90326, 'Ridgewood Estates', 36.2341690063477, 0.632405550884849, -85.4916687011719, -1.49211110185963, 218, 50, 'PPL', 'P'),
(105706, 'Ridgewood Farm', 37.2649993896484, 0.650396935103043, -80.0388870239258, -1.39694210819927, 218, 53, 'PPL', 'P'),
(74071, 'Ridgewood Heights', 39.7466697692871, 0.693710254176955, -84.2699966430664, -1.47078890206608, 218, 41, 'PPL', 'P'),
(105707, 'Ridgewood Heights', 37.2861099243164, 0.650765383439855, -80.0166702270508, -1.39655435194455, 218, 53, 'PPL', 'P'),
(146169, 'Ridgewood Junction', 40.9694404602051, 0.71505162873036, -74.1269378662109, -1.29375913018664, 218, 37, 'PPL', 'P'),
(50828, 'Ridgewood Mobile Home Park', 39.1652793884277, 0.683563077791535, -76.7125015258789, -1.33888572906776, 218, 25, 'PPL', 'P'),
(105708, 'Ridgewood Mobile Home Park', 38.1133308410645, 0.665203112078474, -78.4508285522461, -1.36922525915427, 218, 53, 'PPL', 'P'),
(199648, 'Ridgewood Mobile Home Park', 41.232780456543, 0.719647778718645, -103.641670227051, -1.80888838772822, 218, 35, 'PPL', 'P'),
(205528, 'Ridgewood of Maple Hills Condominiums', 40.8666687011719, 0.713257923157164, -111.849166870117, -1.95213622749611, 218, 52, 'PPL', 'P'),
(24337, 'Ridgewood Park', 33.9541702270508, 0.592612065244667, -84.616943359375, -1.47684426459465, 218, 13, 'PPL', 'P'),
(105709, 'Ridgewood Park', 37.2874984741211, 0.650789618205775, -80.0188903808594, -1.39659310093842, 218, 53, 'PPL', 'P'),
(184538, 'Ridgewood Park', 39.3308296203613, 0.686452474416217, -123.340278625488, -2.15269396234196, 218, 6, 'PPL', 'P'),
(24338, 'Ridgewood Plantation', 31.249439239502, 0.545405604131222, -81.5152816772461, -1.42271005595855, 218, 13, 'PPL', 'P'),
(197377, 'Ridgewood Terrace', 48.2305603027344, 0.841782077364388, -114.281936645508, -1.99459607001968, 218, 31, 'PPL', 'P'),
(193907, 'Ridgewoods Heights', 40.7355613708496, 0.710969668569541, -124.147216796875, -2.16677769029268, 218, 6, 'PPL', 'P'),
(30966, 'Ridgleville', 38.5666694641113, 0.6731153636771, -87.4274978637695, -1.52589769450309, 218, 19, 'PPL', 'P'),
(57180, 'Ridgley', 36.6972198486328, 0.640487312686858, -94.0199966430664, -1.64095850413552, 218, 29, 'PPL', 'P'),
(28416, 'Ridgway', 37.7991714477539, 0.659719996289137, -88.2611083984375, -1.54044694301235, 218, 18, 'PPL', 'P'),
(166480, 'Ridgway', 41.420280456543, 0.722920271066135, -78.728889465332, -1.37407833760872, 218, 45, 'PPL', 'P'),
(187258, 'Ridgway', 38.1527786254883, 0.665891605799287, -107.761108398438, -1.88078614715125, 218, 7, 'PPL', 'P'),
(5398, 'Ridgway Mill', 34.9352798461914, 0.609735658421658, -87.1922225952148, -1.52179136641829, 218, 2, 'PPL', 'P'),
(50829, 'Riding Acres', 38.9152793884277, 0.679199754661549, -75.815559387207, -1.32323113554806, 218, 25, 'PPL', 'P'),
(50830, 'Riding Woods', 39.1108283996582, 0.68261272875654, -76.4899978637695, -1.33500230756621, 218, 25, 'PPL', 'P'),
(97508, 'Ridings', 33.6994400024414, 0.588166184120889, -96.1841735839844, -1.67873051735028, 218, 51, 'PPL', 'P'),
(105710, 'Ridings Mill', 39.0294418334961, 0.681192265210119, -78.2416687011719, -1.36557473109004, 218, 53, 'PPL', 'P'),
(24339, 'Ridley', 33.3011093139648, 0.581214002095237, -85.2002792358398, -1.48702539628396, 218, 13, 'PPL', 'P'),
(77095, 'Ridley', 34.7036094665527, 0.605692247517618, -98.3777770996094, -1.71701612118126, 218, 42, 'PPL', 'P'),
(90328, 'Ridley', 35.5516700744629, 0.620493697382115, -87.1911087036133, -1.52177192534234, 218, 50, 'PPL', 'P'),
(117529, 'Ridley', 43.0647201538086, 0.751621158133919, -91.5083312988281, -1.59712167417033, 218, 16, 'PPL', 'P'),
(79028, 'Ridley Park', 39.8811111450195, 0.696056698834397, -75.3241729736328, -1.31465482473162, 218, 45, 'PPL', 'P'),
(128657, 'Ridlonville', 44.5552787780762, 0.777636313821385, -70.5400009155273, -1.23115527033577, 218, 26, 'PPL', 'P'),
(121214, 'Ridott', 42.2963905334473, 0.738211276518016, -89.4752807617188, -1.56163824843833, 218, 18, 'PPL', 'P'),
(121215, 'Ridott Corners', 42.2752799987793, 0.737842828181203, -89.4755630493164, -1.56164317528635, 218, 18, 'PPL', 'P'),
(117530, 'Ridotto', 42.8294410705566, 0.747514763470098, -94.6766662597656, -1.65241955104474, 218, 16, 'PPL', 'P'),
(97509, 'Ridout', 29.0822200775146, 0.507580494142231, -98.14111328125, -1.71288555833055, 218, 51, 'PPL', 'P'),
(208558, 'Ridpath', 46.5888900756836, 0.813129526670389, -117.89778137207, -2.05770446573906, 218, 56, 'PPL', 'P'),
(74072, 'Ridpath (historical)', 39.8266716003418, 0.695106549536484, -83.0902786254883, -1.45019893841424, 218, 41, 'PPL', 'P'),
(197379, 'Riebeling', 47.5044403076172, 0.829108892685028, -112.148063659668, -1.95735296059741, 218, 31, 'PPL', 'P'),
(197381, 'Riedel (historical)', 47.9833297729492, 0.837467090608187, -109.356666564941, -1.90863389056382, 218, 31, 'PPL', 'P'),
(50831, 'Riedel Estates', 39.0202789306641, 0.68103234238666, -76.6847229003906, -1.33840090059131, 218, 25, 'PPL', 'P'),
(197380, 'Rieder', 46.2677803039551, 0.807525103893399, -112.098609924316, -1.95648983008811, 218, 31, 'PPL', 'P'),
(146171, 'Riegel Ridge', 40.6097183227539, 0.708773293039525, -75.1202774047852, -1.311096175725, 218, 37, 'PPL', 'P'),
(146172, 'Riegelsville', 40.5944404602051, 0.708506644035381, -75.1875, -1.31226943134324, 218, 37, 'PPL', 'P'),
(166483, 'Riegelsville', 40.5941696166992, 0.708501916924446, -75.1958312988281, -1.31241483993876, 218, 45, 'PPL', 'P'),
(68231, 'Riegelwood', 34.3397216796875, 0.599341207529024, -78.2255630493164, -1.36529363443699, 218, 33, 'PPL', 'P'),
(184539, 'Riego', 38.7513885498047, 0.676339319913722, -121.483612060547, -2.12028901767204, 218, 6, 'PPL', 'P'),
(28418, 'Riehl', 38.9358291625977, 0.679558415881356, -90.2738876342773, -1.57557656779353, 218, 18, 'PPL', 'P'),
(166485, 'Rienze', 41.6519393920898, 0.726963482233093, -76.3363876342773, -1.33232130329682, 218, 45, 'PPL', 'P'),
(61542, 'Rienzi', 34.7658309936523, 0.606778218031125, -88.5266723632813, -1.54508190857353, 218, 30, 'PPL', 'P'),
(42805, 'Rienzi Plantation', 29.8138904571533, 0.520350551306243, -90.8102798461914, -1.58493837797349, 218, 22, 'PPL', 'P'),
(190668, 'Riepetown', 39.2644386291504, 0.685293733025923, -115.010833740234, -2.00731772423087, 218, 39, 'PPL', 'P'),
(97511, 'Riesel', 31.4747200012207, 0.549337495164615, -96.9230575561523, -1.69162647545483, 218, 51, 'PPL', 'P'),
(201473, 'Rieth', 45.6611099243164, 0.79693670829438, -118.870277404785, -2.07467772347252, 218, 43, 'PPL', 'P'),
(166486, 'Rife', 40.5483283996582, 0.707701836753959, -76.8808288574219, -1.34182359522428, 218, 45, 'PPL', 'P'),
(111118, 'Riffe', 37.6766700744629, 0.657581943986995, -80.686393737793, -1.40824323228502, 218, 58, 'PPL', 'P'),
(208559, 'Riffe (historical)', 46.5141716003418, 0.811825443263604, -122.369171142578, -2.13574493937442, 218, 56, 'PPL', 'P'),
(28419, 'Riffle', 38.8052787780762, 0.677279881831711, -88.5641708374023, -1.54573638041141, 218, 18, 'PPL', 'P'),
(187259, 'Rifle', 39.5347213745117, 0.690011056843808, -107.782501220703, -1.88115952233608, 218, 7, 'PPL', 'P'),
(111119, 'Rift', 37.2847213745117, 0.650741148673935, -81.6719436645508, -1.42544432344973, 218, 58, 'PPL', 'P'),
(152107, 'Rifton', 41.8375015258789, 0.730202152434739, -74.0377807617188, -1.29220304516171, 218, 40, 'PPL', 'P'),
(208560, 'Rifton', 46.600830078125, 0.813337919025688, -118.339996337891, -2.06542257289422, 218, 56, 'PPL', 'P'),
(111120, 'Rig', 39.038890838623, 0.681357181460623, -79.0458297729492, -1.37960998950893, 218, 58, 'PPL', 'P'),
(33772, 'Riga', 38.9505615234375, 0.679815544084603, -99.6500015258789, -1.73922062624396, 218, 20, 'PPL', 'P'),
(132834, 'Riga', 41.8091697692871, 0.729707669999338, -83.8249969482422, -1.46302219222102, 218, 27, 'PPL', 'P'),
(152108, 'Riga', 43.0694389343262, 0.751703516390629, -77.8841705322266, -1.3593352109721, 218, 40, 'PPL', 'P'),
(198811, 'Riga', 48.2938919067383, 0.842887422374825, -100.706939697266, -1.75766767732467, 218, 34, 'PPL', 'P'),
(57181, 'Riga (historical)', 36.5513916015625, 0.637942129633069, -90.6494369506836, -1.58213113986844, 218, 29, 'PPL', 'P'),
(195529, 'Rigby', 43.6725006103516, 0.762228928229868, -111.914169311523, -1.95327073412048, 218, 17, 'PPL', 'P'),
(128658, 'Rigby (historical)', 43.6030616760254, 0.7610169901968, -70.2922210693359, -1.22683069619964, 218, 26, 'PPL', 'P'),
(5399, 'Rigdom', 34.646110534668, 0.604688701839849, -87.3622207641602, -1.52475839418875, 218, 2, 'PPL', 'P'),
(123549, 'Rigdon', 40.3788909912109, 0.704744596100508, -85.7863922119141, -1.49725499750512, 218, 19, 'PPL', 'P'),
(61543, 'Riggins', 34.0505599975586, 0.59429438410527, -88.2527770996094, -1.54030153441684, 218, 30, 'PPL', 'P'),
(195530, 'Riggins', 45.4222183227539, 0.792767263291752, -116.314437866211, -2.03006990837175, 218, 17, 'PPL', 'P'),
(50832, 'Riggins Corner', 38.413330078125, 0.670439086518652, -76.1841735839844, -1.32966466695142, 218, 25, 'PPL', 'P'),
(195531, 'Riggins Hot Springs', 45.4169387817383, 0.792675117918035, -116.170829772949, -2.02756347431182, 218, 17, 'PPL', 'P'),
(166487, 'Riggles Gap', 40.5800018310547, 0.708254642417232, -78.3841705322266, -1.36806185723207, 218, 45, 'PPL', 'P'),
(11588, 'Riggs', 35.7705612182617, 0.624314068544861, -90.9544372558594, -1.58745439941334, 218, 4, 'PPL', 'P'),
(57182, 'Riggs', 39.1711082458496, 0.683664810545176, -92.3452835083008, -1.61172924590747, 218, 29, 'PPL', 'P'),
(117531, 'Riggs', 42.0050010681152, 0.733125570942346, -90.5299987792969, -1.58004655052518, 218, 16, 'PPL', 'P'),
(157367, 'Riggs', 41.8044395446777, 0.729625112005546, -80.5388870239258, -1.40566875445924, 218, 41, 'PPL', 'P'),
(166488, 'Riggs', 41.8380584716797, 0.730211872972717, -76.5763931274414, -1.33651018937541, 218, 45, 'PPL', 'P'),
(105711, 'Riggs (historical)', 36.7616691589355, 0.64161216535228, -82.649169921875, -1.44250013917698, 218, 53, 'PPL', 'P'),
(90329, 'Riggs Crossroads', 35.7133293151855, 0.623315183398999, -86.6977767944336, -1.513161659222, 218, 50, 'PPL', 'P'),
(97510, 'Riggs Ford', 31.2177791595459, 0.544853031494544, -97.6544418334961, -1.7043915391918, 218, 51, 'PPL', 'P'),
(13197, 'Riggs Park', 38.9541702270508, 0.679878527844383, -76.9944381713867, -1.3438064518139, 218, 9, 'PPL', 'P'),
(157368, 'Riggs Subdivision', 41.4772186279297, 0.723914029626898, -84.4261093139648, -1.47351358217734, 218, 41, 'PPL', 'P'),
(28420, 'Riggston', 39.6952781677246, 0.692813301521816, -90.4230575561523, -1.5781800740752, 218, 18, 'PPL', 'P'),
(132836, 'Riggsville', 45.5699996948242, 0.795346534807494, -84.6105575561523, -1.47673281130303, 218, 27, 'PPL', 'P'),
(152110, 'Riggsville', 41.871940612793, 0.730803227892769, -74.3391723632813, -1.29746332094683, 218, 40, 'PPL', 'P'),
(37929, 'Rightangle', 37.894718170166, 0.661387601184718, -84.0286102294922, -1.46657591437963, 218, 21, 'PPL', 'P'),
(208561, 'Rignall', 47.1652793884277, 0.823189417951081, -122.92138671875, -2.14538291935942, 218, 56, 'PPL', 'P'),
(152112, 'Rigney Bluff', 43.2730598449707, 0.755257371707286, -77.6350021362305, -1.35498640207005, 218, 40, 'PPL', 'P'),
(42807, 'Rigolets', 30.148609161377, 0.526192494762954, -89.642219543457, -1.56455187982893, 218, 22, 'PPL', 'P'),
(74074, 'Rigrish Addition', 38.7780609130859, 0.676804840472268, -82.8544387817383, -1.44608275663341, 218, 41, 'PPL', 'P'),
(77101, 'Rigsby', 36.2061080932617, 0.631915795560383, -96.3619384765625, -1.68183310002022, 218, 42, 'PPL', 'P'),
(166489, 'Riker', 40.9458312988281, 0.714639571130697, -78.940559387207, -1.37777267467288, 218, 45, 'PPL', 'P'),
(5401, 'Riley', 31.726110458374, 0.553725086350034, -87.126106262207, -1.52063741871796, 218, 2, 'PPL', 'P'),
(11589, 'Riley', 33.3630599975586, 0.582295245497809, -91.7163925170898, -1.60075302747471, 218, 4, 'PPL', 'P'),
(30972, 'Riley', 39.3899993896484, 0.687485181707922, -87.3000030517578, -1.52367249025427, 218, 19, 'PPL', 'P'),
(33773, 'Riley', 39.2988891601563, 0.685895008221036, -96.8305587768555, -1.69001206720202, 218, 20, 'PPL', 'P'),
(37930, 'Riley', 37.559440612793, 0.655535903900514, -85.0988922119141, -1.48525585889766, 218, 21, 'PPL', 'P'),
(68232, 'Riley', 35.9313888549805, 0.627121040333805, -78.3533325195313, -1.36752363237576, 218, 33, 'PPL', 'P'),
(83293, 'Riley', 33.622501373291, 0.586823351720243, -80.7997207641602, -1.41022116202662, 218, 48, 'PPL', 'P'),
(90330, 'Riley', 36.5411109924316, 0.637762699154625, -83.4319381713867, -1.45616202241104, 218, 50, 'PPL', 'P'),
(111121, 'Riley', 37.8152809143066, 0.660001159521223, -81.1611099243164, -1.41652859275237, 218, 58, 'PPL', 'P'),
(121217, 'Riley', 42.1913909912109, 0.736378688792905, -88.6324996948242, -1.54692894394755, 218, 18, 'PPL', 'P'),
(128660, 'Riley', 44.5050010681152, 0.776758802242204, -70.2472229003906, -1.22604532999418, 218, 26, 'PPL', 'P'),
(132837, 'Riley', 42.9150009155273, 0.749008064472333, -84.6805572509766, -1.4779545364531, 218, 27, 'PPL', 'P'),
(137719, 'Riley', 47.3630599975586, 0.826641340777015, -92.9297180175781, -1.62192955235664, 218, 28, 'PPL', 'P'),
(176099, 'Riley', 43.0233306884766, 0.750898775688235, -89.6224975585938, -1.56420766625804, 218, 57, 'PPL', 'P'),
(189340, 'Riley', 34.3805618286133, 0.600054002594784, -107.22917175293, -1.87150210127512, 218, 38, 'PPL', 'P'),
(201474, 'Riley', 43.5416717529297, 0.759945533911234, -119.502777099609, -2.08571692566506, 218, 43, 'PPL', 'P'),
(132838, 'Riley Center', 42.9408302307129, 0.749458871065856, -82.841667175293, -1.44585985005017, 218, 27, 'PPL', 'P'),
(152113, 'Riley Cove', 43.0133285522461, 0.75072420547878, -73.7649993896484, -1.28744211208097, 218, 40, 'PPL', 'P'),
(11590, 'Riley Creek (historical)', 35.0555610656738, 0.61183496172994, -93.4875030517578, -1.63166473772142, 218, 4, 'PPL', 'P'),
(90331, 'Riley Creek (historical)', 35.4683303833008, 0.619039145373741, -86.2169418334961, -1.50476950599494, 218, 50, 'PPL', 'P'),
(83294, 'Riley Estates', 34.8166694641113, 0.607665516727312, -82.4513931274414, -1.43904828293008, 218, 48, 'PPL', 'P'),
(68233, 'Riley Hill', 35.8586082458496, 0.625850779072864, -78.420280456543, -1.36869209430404, 218, 33, 'PPL', 'P'),
(189341, 'Riley Place', 34.8111114501953, 0.607568511084606, -106.335830688477, -1.85591035835714, 218, 38, 'PPL', 'P'),
(30969, 'Riley Village', 39.5063896179199, 0.689516574408407, -85.7680587768555, -1.49693501870015, 218, 19, 'PPL', 'P'),
(178978, 'Rileys El Encinar', 31.4897193908691, 0.54959928389977, -109.988891601563, -1.9196682990664, 218, 5, 'PPL', 'P'),
(57183, 'Rileysburg', 39.1866683959961, 0.683936386397337, -92.3899993896484, -1.61250968526492, 218, 29, 'PPL', 'P'),
(123548, 'Rileysburg', 40.1041717529297, 0.699949840873929, -87.5258331298828, -1.52761396866759, 218, 19, 'PPL', 'P'),
(28421, 'Rileyville', 37.8505592346191, 0.660616882365249, -88.6727828979492, -1.54763201847533, 218, 18, 'PPL', 'P'),
(37931, 'Rileyville', 36.8972206115723, 0.643977984506652, -83.0658264160156, -1.44977216684955, 218, 21, 'PPL', 'P'),
(105713, 'Rileyville', 38.7649993896484, 0.676576873882958, -78.3883285522461, -1.36813442837177, 218, 53, 'PPL', 'P'),
(146173, 'Rileyville', 40.4249992370605, 0.705549336802902, -74.7922210693359, -1.30537051253939, 218, 37, 'PPL', 'P'),
(166490, 'Rileyville', 41.7155609130859, 0.728073887249602, -75.2297210693359, -1.31300632801686, 218, 45, 'PPL', 'P'),
(42808, 'Rilla', 32.4152793884277, 0.565753353281918, -92.100830078125, -1.60746272868311, 218, 22, 'PPL', 'P'),
(178979, 'Rillito', 32.4147186279297, 0.565743566164912, -111.155563354492, -1.94003056244504, 218, 5, 'PPL', 'P'),
(166491, 'Rillton', 40.2891693115234, 0.703178657379541, -79.7313919067383, -1.39157530597054, 218, 45, 'PPL', 'P'),
(144365, 'Rim Junction', 44.2830581665039, 0.772885167857656, -71.0500030517578, -1.24005648680519, 218, 36, 'PPL', 'P'),
(197384, 'Rim Rock Colony', 48.8958282470703, 0.853393193401024, -112.094436645508, -1.9564169926323, 218, 31, 'PPL', 'P'),
(57184, 'Rimby', 37.7599983215332, 0.659036296258287, -93.2363891601563, -1.62728197351548, 218, 29, 'PPL', 'P'),
(111122, 'Rimel', 38.1233291625977, 0.665377615708902, -79.9516677856445, -1.39541984532018, 218, 58, 'PPL', 'P'),
(68234, 'Rimer', 35.4747200012207, 0.619150665244388, -80.4836120605469, -1.40470402435436, 218, 33, 'PPL', 'P'),
(157370, 'Rimer', 40.8844413757324, 0.713568114845131, -84.2113876342773, -1.46976598189138, 218, 41, 'PPL', 'P'),
(166492, 'Rimer', 40.9361114501953, 0.714469927769259, -79.5255584716797, -1.38798283481808, 218, 45, 'PPL', 'P'),
(166493, 'Rimersburg', 41.041389465332, 0.716307375763359, -79.5033264160156, -1.38759481224726, 218, 45, 'PPL', 'P'),
(184540, 'Rimforest', 34.2297210693359, 0.597421334699186, -117.224166870117, -2.0459476747908, 218, 6, 'PPL', 'P'),
(83295, 'Rimini', 33.6691703796387, 0.587637879539644, -80.5005569458008, -1.40499976839341, 218, 48, 'PPL', 'P'),
(197382, 'Rimini', 46.4880599975586, 0.811369709822065, -112.245826721191, -1.95905924790782, 218, 31, 'PPL', 'P'),
(184541, 'Rimlon', 33.8375015258789, 0.590575812275192, -116.442497253418, -2.0323049663166, 218, 6, 'PPL', 'P'),
(178980, 'Rimmy Jims', 35.1100006103516, 0.612785111027853, -111.030281066895, -1.93784397403203, 218, 5, 'PPL', 'P'),
(178981, 'Rimrock', 34.6505584716797, 0.604766332985625, -111.745002746582, -1.95031822057796, 218, 5, 'PPL', 'P'),
(184542, 'Rimrock', 34.1980590820313, 0.596868728772995, -116.553611755371, -2.03424428022239, 218, 6, 'PPL', 'P'),
(197383, 'Rimrock', 45.8022193908691, 0.799399533091458, -108.702217102051, -1.89721159264848, 218, 31, 'PPL', 'P'),
(208562, 'Rimrock', 46.6644401550293, 0.814448124305114, -121.123893737793, -2.11401074856023, 218, 56, 'PPL', 'P'),
(28422, 'Rinard', 38.5705604553223, 0.673183274284897, -88.4655609130859, -1.54401531255695, 218, 18, 'PPL', 'P'),
(117533, 'Rinard', 42.3397216796875, 0.738967547688571, -94.4883270263672, -1.64913241131125, 218, 16, 'PPL', 'P'),
(74075, 'Rinard Mills', 39.5847206115723, 0.690883708153999, -81.1552810668945, -1.41642685999873, 218, 41, 'PPL', 'P'),
(193908, 'Rinckel', 41.1333312988281, 0.717912063478186, -122.074172973633, -2.13059625003897, 218, 6, 'PPL', 'P'),
(24340, 'Rincon', 32.2958297729492, 0.563668564201577, -81.2355575561523, -1.41782794904822, 218, 13, 'PPL', 'P'),
(30971, 'Rincon', 39.1025009155273, 0.682467386740049, -86.9902801513672, -1.51826680587363, 218, 19, 'PPL', 'P'),
(97512, 'Rincon', 26.5141696929932, 0.462759559575225, -98.5924987792969, -1.72076372146722, 218, 51, 'PPL', 'P'),
(178982, 'Rincon', 32.0761108398438, 0.559833745389917, -111.917221069336, -1.95332399734228, 218, 5, 'PPL', 'P'),
(184545, 'Rincon', 34.3741683959961, 0.59994241614511, -119.475830078125, -2.08524661141656, 218, 6, 'PPL', 'P'),
(189343, 'Rincon', 32.672779083252, 0.570247570779481, -107.064170837402, -1.86862229203037, 218, 38, 'PPL', 'P'),
(184557, 'Rinconada', 37.2275009155273, 0.649742463265156, -121.966667175293, -2.12871991989295, 218, 6, 'PPL', 'P'),
(189344, 'Rinconada', 36.2183303833008, 0.632129114763698, -105.872779846191, -1.84782859655514, 218, 38, 'PPL', 'P'),
(137720, 'Rindal', 47.499439239502, 0.829021607580301, -96.1311111450195, -1.67780440308121, 218, 28, 'PPL', 'P'),
(144366, 'Rindge', 42.7511100769043, 0.746147629724506, -72.0102767944336, -1.25681642533533, 218, 36, 'PPL', 'P'),
(57185, 'Rinehart', 37.9561080932617, 0.662459057470284, -94.4983291625977, -1.64930698152071, 218, 29, 'PPL', 'P'),
(111123, 'Rinehart', 39.4238891601563, 0.688076669786029, -80.5166702270508, -1.40528099820453, 218, 58, 'PPL', 'P'),
(157371, 'Rineharts (historical)', 40.6005592346191, 0.708613436795093, -84.0322189331055, -1.46663889813941, 218, 41, 'PPL', 'P'),
(37932, 'Rineltown', 37.6594390869141, 0.657281206520897, -85.1561126708984, -1.48625454430644, 218, 21, 'PPL', 'P'),
(112529, 'Rinely', 39.8016700744629, 0.694670190591874, -76.5975036621094, -1.33687863771222, 218, 45, 'PPL', 'P'),
(105714, 'Riner', 37.0663909912109, 0.646930564628195, -80.4408264160156, -1.4039572739847, 218, 53, 'PPL', 'P'),
(209696, 'Riner', 41.735279083252, 0.728418034241467, -107.550003051758, -1.87710166378312, 218, 59, 'PPL', 'P'),
(37933, 'Rineyville', 37.749439239502, 0.658852005510853, -85.9700012207031, -1.50045957924481, 218, 21, 'PPL', 'P'),
(176100, 'Ring', 43.9091682434082, 0.766359557659608, -88.6402816772461, -1.54706476516315, 218, 57, 'PPL', 'P'),
(128664, 'Ring Hill', 44.1388893127441, 0.770368946680722, -69.8963928222656, -1.21992219001587, 218, 26, 'PPL', 'P'),
(189345, 'Ring Place', 36.7722206115723, 0.641796322941659, -105.120559692383, -1.83469987817132, 218, 38, 'PPL', 'P'),
(166503, 'Ringdale', 41.452220916748, 0.723477737261316, -76.4458312988281, -1.33423145558868, 218, 45, 'PPL', 'P'),
(137721, 'Ringe', 44.1080589294434, 0.769830854982472, -92.399169921875, -1.61266974124643, 218, 28, 'PPL', 'P'),
(33776, 'Ringer', 38.5344390869141, 0.672552837475848, -94.908332824707, -1.65646289536975, 218, 20, 'PPL', 'P'),
(166495, 'Ringertown', 40.4183311462402, 0.705432956663266, -79.585563659668, -1.38903012291675, 218, 45, 'PPL', 'P'),
(5403, 'Ringgold', 34.3338890075684, 0.599239408196356, -85.5477828979492, -1.49309047935051, 218, 2, 'PPL', 'P'),
(24341, 'Ringgold', 34.915828704834, 0.6093961719617, -85.1091690063477, -1.48543522279708, 218, 13, 'PPL', 'P'),
(37934, 'Ringgold', 37.1080589294434, 0.647657807342869, -84.6536102294922, -1.47748422220459, 218, 21, 'PPL', 'P'),
(42809, 'Ringgold', 32.3283309936523, 0.564235817513764, -93.2797164916992, -1.62803817810701, 218, 22, 'PPL', 'P'),
(50833, 'Ringgold', 39.7094383239746, 0.693060442870976, -77.5669403076172, -1.35379849906582, 218, 25, 'PPL', 'P'),
(74076, 'Ringgold', 39.5902786254883, 0.690980713796706, -81.9797210693359, -1.43081605252648, 218, 41, 'PPL', 'P'),
(90332, 'Ringgold', 36.5938911437988, 0.638683886575683, -87.4180603027344, -1.52573297798967, 218, 50, 'PPL', 'P'),
(97513, 'Ringgold', 33.8202781677246, 0.59027520796715, -97.9433288574219, -1.70943356892559, 218, 51, 'PPL', 'P'),
(105715, 'Ringgold', 36.6080589294434, 0.638931161082897, -79.2955627441406, -1.383968652107, 218, 53, 'PPL', 'P'),
(111127, 'Ringgold', 39.5633316040039, 0.690510399548198, -79.9433288574219, -1.39527430356661, 218, 58, 'PPL', 'P'),
(166496, 'Ringgold', 40.9947204589844, 0.715492847943958, -79.1680603027344, -1.38174331470013, 218, 45, 'PPL', 'P'),
(199651, 'Ringgold', 41.5086097717285, 0.724461908442155, -100.791107177734, -1.75913667698195, 218, 35, 'PPL', 'P'),
(117534, 'Ringgold (historical)', 40.5838890075684, 0.708322486446002, -94.1916732788086, -1.64395482667797, 218, 16, 'PPL', 'P'),
(166498, 'Ringing Hills', 40.2700004577637, 0.7028440977676, -75.6066665649414, -1.31958526801574, 218, 45, 'PPL', 'P'),
(166499, 'Ringing Rock Gardens', 40.2633285522461, 0.702727651048936, -75.6233291625977, -1.31987608520678, 218, 45, 'PPL', 'P'),
(166500, 'Ringlands', 40.0263900756836, 0.698592294508261, -80.230827331543, -1.40029209853448, 218, 45, 'PPL', 'P'),
(176101, 'Ringle', 44.8911094665527, 0.783497665064541, -89.4255599975586, -1.56077045739713, 218, 57, 'PPL', 'P'),
(77096, 'Ringling', 34.1783294677734, 0.596524382044048, -97.5922164916992, -1.70330550209926, 218, 42, 'PPL', 'P'),
(197385, 'Ringling', 46.271671295166, 0.807593014501196, -110.80638885498, -1.93393631776456, 218, 31, 'PPL', 'P'),
(33777, 'Ringo', 37.5094413757324, 0.654663252590322, -94.7611083984375, -1.65389334439199, 218, 20, 'PPL', 'P'),
(208563, 'Ringo', 46.8716697692871, 0.818064963381551, -117.060829162598, -2.04309689400193, 218, 56, 'PPL', 'P'),
(137722, 'Ringo Mobile Home Park', 44.6736106872559, 0.779701595246742, -94.2294387817383, -1.64461395904777, 218, 28, 'PPL', 'P'),
(139425, 'Ringo Point', 40.1830596923828, 0.7013266951575, -92.8311080932617, -1.62020848450217, 218, 29, 'PPL', 'P'),
(146174, 'Ringoes', 40.4288902282715, 0.705617247410699, -74.8680572509766, -1.30669410360116, 218, 37, 'PPL', 'P'),
(77097, 'Ringold', 34.2150001525879, 0.597164406233021, -95.125, -1.66024445095961, 218, 42, 'PPL', 'P'),
(57186, 'Rings', 37.172779083252, 0.648787387119226, -90.5699996948242, -1.58074469820494, 218, 29, 'PPL', 'P'),
(144368, 'Rings Corner', 43.3138885498047, 0.755969967035964, -71.3616714477539, -1.24549612648973, 218, 36, 'PPL', 'P'),
(125943, 'Rings Island', 42.8166694641113, 0.747291856886859, -70.8666687011719, -1.23685669875546, 218, 23, 'PPL', 'P'),
(117536, 'Ringsted', 43.2947196960449, 0.755635407424022, -94.5113906860352, -1.64953494811002, 218, 16, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(57187, 'Rington', 35.9977798461914, 0.628279781724098, -90.1852798461914, -1.57403007014853, 218, 29, 'PPL', 'P'),
(166502, 'Ringtown', 40.8586082458496, 0.71311724167258, -76.2300033569336, -1.33046454738482, 218, 45, 'PPL', 'P'),
(125944, 'Ringville', 42.3694381713867, 0.739486198310864, -72.9102783203125, -1.27252441523489, 218, 23, 'PPL', 'P'),
(30973, 'Ringwald', 38.7836112976074, 0.67690171295692, -85.3827819824219, -1.49021067010575, 218, 19, 'PPL', 'P'),
(42810, 'Ringwood', 31.9838905334473, 0.5582241974061, -92.523063659668, -1.61483209489352, 218, 22, 'PPL', 'P'),
(68235, 'Ringwood', 36.211109161377, 0.63200308066511, -77.8475036621094, -1.35869525336215, 218, 33, 'PPL', 'P'),
(77098, 'Ringwood', 36.3794403076172, 0.634941013400659, -98.245002746582, -1.71469877155873, 218, 42, 'PPL', 'P'),
(121219, 'Ringwood', 42.392219543457, 0.739883808261613, -88.2969436645508, -1.54107238639436, 218, 18, 'PPL', 'P'),
(146175, 'Ringwood', 41.1133308410645, 0.717562989638304, -74.2458267211914, -1.29583413214998, 218, 37, 'PPL', 'P'),
(105716, 'Rinkerton', 38.7558288574219, 0.676416817901444, -78.6697235107422, -1.37304569689604, 218, 53, 'PPL', 'P'),
(194398, 'Rinn', 40.1388893127441, 0.700555776600949, -104.998329162598, -1.83256655298011, 218, 7, 'PPL', 'P'),
(90337, 'Rinnie', 36.148609161377, 0.630912249882614, -85.0344390869141, -1.48413093965321, 218, 50, 'PPL', 'P'),
(17799, 'Rio', 27.2191696166992, 0.475064129470204, -80.2394409179688, -1.40044243397802, 218, 12, 'PPL', 'P'),
(24342, 'Rio', 33.2799987792969, 0.580845553758424, -84.3819427490234, -1.47274273019981, 218, 13, 'PPL', 'P'),
(37935, 'Rio', 37.3188896179199, 0.651337497021031, -85.771110534668, -1.49698828192195, 218, 21, 'PPL', 'P'),
(42811, 'Rio', 30.6927795410156, 0.535690059579477, -89.8899993896484, -1.56887645396506, 218, 22, 'PPL', 'P'),
(61545, 'Rio', 32.6138916015625, 0.569219790335792, -88.8755569458008, -1.55117109324794, 218, 30, 'PPL', 'P'),
(105717, 'Rio', 38.0761108398438, 0.664553500509577, -78.4613876342773, -1.3694095499017, 218, 53, 'PPL', 'P'),
(111124, 'Rio', 39.1383285522461, 0.683092696964, -78.670280456543, -1.37305541743402, 218, 58, 'PPL', 'P'),
(121220, 'Rio', 41.1091690063477, 0.717490351919572, -90.3997192382813, -1.57777274358647, 218, 18, 'PPL', 'P'),
(176110, 'Rio', 43.4477806091309, 0.758306824313481, -89.2397232055664, -1.55752699350552, 218, 57, 'PPL', 'P'),
(192760, 'Rio', 39.9958305358887, 0.698058929920945, -111.426391601563, -1.94475740706382, 218, 52, 'PPL', 'P'),
(187260, 'Rio Blanco', 39.7377815246582, 0.693555125043458, -107.944717407227, -1.88399072889094, 218, 7, 'PPL', 'P'),
(97514, 'Rio Bravo', 27.3638896942139, 0.477589971316576, -99.4797210693359, -1.73624867162549, 218, 51, 'PPL', 'P'),
(184563, 'Rio Bravo', 35.3980598449707, 0.617812693112732, -119.290000915527, -2.082003280683, 218, 6, 'PPL', 'P'),
(97515, 'Rio Bravo Annex Colonia', 27.363000869751, 0.477574458403227, -99.4960021972656, -1.7365328309138, 218, 51, 'PPL', 'P'),
(192112, 'Rio Bravo Colonia', 29.3320007324219, 0.51193998897815, -100.914001464844, -1.7612815869239, 218, 51, 'PPL', 'P'),
(189347, 'Rio Chiquito', 36.002498626709, 0.628362139980809, -105.904167175293, -1.84837640879137, 218, 38, 'PPL', 'P'),
(176103, 'Rio Creek', 44.589168548584, 0.778227801899492, -87.5411071777344, -1.52788055109271, 218, 57, 'PPL', 'P'),
(184567, 'Rio Del Mar', 36.9683303833008, 0.645219084153656, -121.899169921875, -2.12754187058476, 218, 6, 'PPL', 'P'),
(193909, 'Rio Dell', 40.499439239502, 0.706848559940697, -124.105278015137, -2.16604572046707, 218, 6, 'PPL', 'P'),
(189348, 'Rio En Medio', 35.8250007629395, 0.625264217842774, -105.903060913086, -1.84835710087346, 218, 38, 'PPL', 'P'),
(97517, 'Rio Frio', 29.6358299255371, 0.517242808761688, -99.7363891601563, -1.74072837489511, 218, 51, 'PPL', 'P'),
(71335, 'Rio Grande', 39.0144386291504, 0.680930409895937, -74.8819427490234, -1.30693645126035, 218, 37, 'PPL', 'P'),
(74077, 'Rio Grande', 38.8794403076172, 0.678574244700517, -82.3805618286133, -1.43781204355206, 218, 41, 'PPL', 'P'),
(97518, 'Rio Grande City', 26.3794403076172, 0.460408088201226, -98.8199996948242, -1.72473436149447, 218, 51, 'PPL', 'P'),
(189349, 'Rio Grande Estates', 34.6558303833008, 0.604858345201287, -106.711936950684, -1.86247465097003, 218, 38, 'PPL', 'P'),
(192113, 'Rio Grande Village', 29.1829891204834, 0.509339245726119, -102.961563110352, -1.79701827927557, 218, 51, 'PPL', 'P'),
(105718, 'Rio Heights', 38.0508308410645, 0.664112281295978, -78.459716796875, -1.36938038828777, 218, 53, 'PPL', 'P'),
(97519, 'Rio Hondo', 26.2350006103516, 0.457887139913357, -97.581672668457, -1.70312147766794, 218, 51, 'PPL', 'P'),
(184569, 'Rio Hondo', 33.9749984741211, 0.592975586733463, -118.123611450195, -2.06164594415238, 218, 6, 'PPL', 'P'),
(184571, 'Rio Linda', 38.6911087036133, 0.675287238125087, -121.44750213623, -2.11965878060007, 218, 6, 'PPL', 'P'),
(189350, 'Rio Lucio', 36.1955604553223, 0.631731704550031, -105.724998474121, -1.84524932503939, 218, 38, 'PPL', 'P'),
(184572, 'Rio Nido', 38.521110534668, 0.672320210354629, -122.975830078125, -2.14633313523636, 218, 6, 'PPL', 'P'),
(184573, 'Rio Oso', 38.961109161377, 0.679999635094955, -121.543327331543, -2.12133124576464, 218, 6, 'PPL', 'P'),
(177746, 'Rio Pasado Estates Colonia', 31.5869998931885, 0.551297148963236, -106.246002197266, -1.85434255542342, 218, 51, 'PPL', 'P'),
(189351, 'Rio Pueblo', 36.1852798461914, 0.631552274071587, -105.638061523438, -1.84373198900832, 218, 38, 'PPL', 'P'),
(189353, 'Rio Puerco', 34.7930603027344, 0.60725345912765, -106.993057250977, -1.86738112580433, 218, 38, 'PPL', 'P'),
(24343, 'Rio Ranch', 33.523609161377, 0.585097357017763, -84.0425033569336, -1.46681839519688, 218, 13, 'PPL', 'P'),
(189355, 'Rio Rancho', 35.2333297729492, 0.61493761097891, -106.663887023926, -1.86163602154276, 218, 38, 'PPL', 'P'),
(189356, 'Rio Rancho Estates', 35.2386093139648, 0.615029756352627, -106.66667175293, -1.86168462423265, 218, 38, 'PPL', 'P'),
(192114, 'Rio Rancho Estates Colonia', 31.6639995574951, 0.552641046628317, -106.267997741699, -1.85472645009455, 218, 51, 'PPL', 'P'),
(97520, 'Rio Rico', 26.0558300018311, 0.454760022871872, -97.8897171020508, -1.70849786727659, 218, 51, 'PPL', 'P'),
(178986, 'Rio Rico', 31.4713897705078, 0.549279371673824, -110.975830078125, -1.93689362499704, 218, 5, 'PPL', 'P'),
(178983, 'Rio Verde', 33.7224998474121, 0.588568654340627, -111.675003051758, -1.94909649542789, 218, 5, 'PPL', 'P'),
(178984, 'Rio Verde Estates', 33.7236099243164, 0.588588028837557, -111.675559997559, -1.94910621596587, 218, 5, 'PPL', 'P'),
(11592, 'Rio Vista', 35.2905616760254, 0.615936496124772, -91.470832824707, -1.59646720233244, 218, 4, 'PPL', 'P'),
(17800, 'Rio Vista', 27.8497200012207, 0.48606930977982, -82.6391677856445, -1.44232556896753, 218, 12, 'PPL', 'P'),
(24344, 'Rio Vista', 31.9291706085205, 0.557269154549684, -81.0880584716797, -1.41525360438049, 218, 13, 'PPL', 'P'),
(37936, 'Rio Vista', 36.8438911437988, 0.643047209705669, -83.3594436645508, -1.45489675457714, 218, 21, 'PPL', 'P'),
(50834, 'Rio Vista', 38.7777786254883, 0.676799913624252, -76.2108306884766, -1.33012992119385, 218, 25, 'PPL', 'P'),
(90334, 'Rio Vista', 35.7763900756836, 0.624415801298502, -84.1666717529297, -1.46898554253393, 218, 50, 'PPL', 'P'),
(97521, 'Rio Vista', 32.2333297729492, 0.56257773341908, -97.3741683959961, -1.69949984490154, 218, 51, 'PPL', 'P'),
(105719, 'Rio Vista', 37.5688896179199, 0.655700820151017, -77.523063659668, -1.35303270709437, 218, 53, 'PPL', 'P'),
(125945, 'Rio Vista', 42.5430603027344, 0.74251647615721, -71.3055572509766, -1.24451674899886, 218, 23, 'PPL', 'P'),
(184575, 'Rio Vista', 38.1558303833008, 0.665944869021089, -121.690277099609, -2.12389600305244, 218, 6, 'PPL', 'P'),
(192115, 'Rio Vista Addition Colonia', 31.6550006866455, 0.55248398670303, -106.292999267578, -1.85516280903916, 218, 51, 'PPL', 'P'),
(17801, 'Rio Vista Isles', 26.110279083252, 0.455710338617353, -80.1230621337891, -1.39841124101461, 218, 12, 'PPL', 'P'),
(184576, 'Rio Vista Junction', 38.2061080932617, 0.66682238060027, -121.874168395996, -2.12710551164015, 218, 6, 'PPL', 'P'),
(17802, 'Riomar', 27.6447200775146, 0.482491386144813, -80.3563919067383, -1.40248361379551, 218, 12, 'PPL', 'P'),
(97522, 'Riomedina', 29.4394397735596, 0.513815153991188, -98.8838882446289, -1.72584942704289, 218, 51, 'PPL', 'P'),
(83296, 'Rion', 34.3069381713867, 0.598769027368821, -81.1252822875977, -1.41590328252842, 218, 48, 'PPL', 'P'),
(178985, 'Riordan', 35.1925010681152, 0.614225015650232, -111.736389160156, -1.95016788513443, 218, 5, 'PPL', 'P'),
(97523, 'Rios', 27.4513893127441, 0.479117127754169, -98.2647171020508, -1.71504285197157, 218, 51, 'PPL', 'P'),
(190669, 'Rioville (historical)', 36.1502799987793, 0.63094141149655, -114.398612976074, -1.9966324561472, 218, 39, 'PPL', 'P'),
(90335, 'Riovista', 36.3347206115723, 0.634160507464184, -82.2616729736328, -1.43573704158873, 218, 50, 'PPL', 'P'),
(209697, 'Riovista', 41.5522193908691, 0.725223039881699, -109.512222290039, -1.91134885013711, 218, 59, 'PPL', 'P'),
(105720, 'Rip Rap', 36.577220916748, 0.638392936226592, -78.7413864135742, -1.374296450502, 218, 53, 'PPL', 'P'),
(208564, 'Riparia', 46.5786094665527, 0.812950096191945, -118.085830688477, -2.06098654546648, 218, 56, 'PPL', 'P'),
(152117, 'Riparius', 43.6616706848145, 0.7620399103715, -73.8974990844727, -1.28975466801354, 218, 40, 'PPL', 'P'),
(50835, 'Ripkins Corner', 39.4894409179688, 0.689220763790327, -76.2119369506836, -1.33014922911176, 218, 25, 'PPL', 'P'),
(5404, 'Ripley', 34.7619400024414, 0.606710307423328, -87.1208267211914, -1.52054527334425, 218, 2, 'PPL', 'P'),
(24346, 'Ripley', 32.7249984741211, 0.571158971083533, -83.4172210693359, -1.4559051605239, 218, 13, 'PPL', 'P'),
(50836, 'Ripley', 38.5447196960449, 0.672732267954292, -77.07861328125, -1.34527558462924, 218, 25, 'PPL', 'P'),
(57188, 'Ripley', 39.1341705322266, 0.683020125824295, -94.3144378662109, -1.646097472933, 218, 29, 'PPL', 'P'),
(61546, 'Ripley', 34.7297210693359, 0.606147980959158, -88.9505615234375, -1.55248017008177, 218, 30, 'PPL', 'P'),
(74078, 'Ripley', 38.7455596923828, 0.676237587160081, -83.8450012207031, -1.46337133263993, 218, 41, 'PPL', 'P'),
(77099, 'Ripley', 36.0177803039551, 0.62862885556398, -96.9052810668945, -1.69131621718783, 218, 42, 'PPL', 'P'),
(90336, 'Ripley', 35.7452812194824, 0.623872849331262, -89.5297164916992, -1.56258833115722, 218, 50, 'PPL', 'P'),
(111125, 'Ripley', 38.8186111450195, 0.677512575531957, -81.7108306884766, -1.42612303005354, 218, 58, 'PPL', 'P'),
(113050, 'Ripley', 40.0227813720703, 0.698529310748481, -90.6386108398438, -1.5819421885891, 218, 18, 'PPL', 'P'),
(123550, 'Ripley', 41.1005592346191, 0.717340083055065, -86.6602783203125, -1.51250718738411, 218, 19, 'PPL', 'P'),
(128662, 'Ripley', 44.5213890075684, 0.777044825743278, -67.7975006103516, -1.1832896102735, 218, 26, 'PPL', 'P'),
(132841, 'Ripley', 47.1266708374023, 0.822515571616264, -88.5536117553711, -1.54555208966398, 218, 27, 'PPL', 'P'),
(152114, 'Ripley', 42.2669410705566, 0.73769728642763, -79.7108306884766, -1.39121644501365, 218, 40, 'PPL', 'P'),
(184578, 'Ripley', 33.5252799987793, 0.585126518631699, -114.655281066895, -2.00111215941683, 218, 6, 'PPL', 'P'),
(190670, 'Ripley', 35.7980613708496, 0.62479403675232, -115.600830078125, -2.01761510290177, 218, 39, 'PPL', 'P'),
(197386, 'Ripley', 48.3847198486328, 0.844472669013695, -115.451110839844, -2.01500200924019, 218, 31, 'PPL', 'P'),
(11593, 'Ripley (historical)', 33.8375015258789, 0.590575812275192, -92.091667175293, -1.60730280585965, 218, 4, 'PPL', 'P'),
(111126, 'Ripley Landing', 38.8908309936523, 0.678773049675891, -81.8461074829102, -1.42848405551795, 218, 58, 'PPL', 'P'),
(50837, 'Ripling Waters', 38.5291709899902, 0.672460891839213, -76.1519393920898, -1.32910207417114, 218, 25, 'PPL', 'P'),
(176105, 'Riplinger', 44.8250007629395, 0.782343850522264, -90.4030609130859, -1.57783106681434, 218, 57, 'PPL', 'P'),
(176106, 'Ripon', 43.8422203063965, 0.765191095731336, -88.8358306884766, -1.55047773925814, 218, 57, 'PPL', 'P'),
(184579, 'Ripon', 37.7416687011719, 0.658716384032341, -121.123329162598, -2.1140008948642, 218, 6, 'PPL', 'P'),
(57190, 'Rippee (historical)', 36.8699989318848, 0.643502876568182, -92.4655609130859, -1.61382848263672, 218, 29, 'PPL', 'P'),
(184580, 'Ripperdan', 36.851390838623, 0.643178104073246, -120.055000305176, -2.09535503880811, 218, 6, 'PPL', 'P'),
(117538, 'Rippey', 41.9338912963867, 0.731884471295342, -94.2011108398438, -1.64411954319139, 218, 16, 'PPL', 'P'),
(166506, 'Ripple', 41.3041687011719, 0.720893738634639, -76.2425003051758, -1.3306826602781, 218, 45, 'PPL', 'P'),
(166505, 'Ripple (historical)', 41.297779083252, 0.720782218763992, -76.2399978637695, -1.33063898443622, 218, 45, 'PPL', 'P'),
(68236, 'Ripple City', 35.6155586242676, 0.621608762930531, -77.3666687011719, -1.35030310013509, 218, 33, 'PPL', 'P'),
(201475, 'Ripplebrook', 45.0825004577637, 0.786838068019827, -122.042221069336, -2.13003858410671, 218, 43, 'PPL', 'P'),
(105721, 'Ripplemead', 37.3369407653809, 0.651652548977988, -80.686393737793, -1.40824323228502, 218, 53, 'PPL', 'P'),
(152116, 'Rippleton', 42.9119415283203, 0.748954668092477, -75.8686065673828, -1.32415698350102, 218, 40, 'PPL', 'P'),
(166507, 'Rippletown', 41.1230583190918, 0.717732766157797, -75.9375, -1.32535940073319, 218, 45, 'PPL', 'P'),
(50838, 'Rippling Estates', 39.1322212219238, 0.682986103941369, -76.6313934326172, -1.33747012579033, 218, 25, 'PPL', 'P'),
(50839, 'Rippling Ridge', 39.1838912963867, 0.683887916865498, -76.6191711425781, -1.33725680658701, 218, 25, 'PPL', 'P'),
(111128, 'Rippon', 39.2183303833008, 0.684488992323528, -77.9055633544922, -1.35970858615693, 218, 58, 'PPL', 'P'),
(172459, 'Ripton', 43.9736099243164, 0.767484277166976, -73.0344390869141, -1.27469142941389, 218, 55, 'PPL', 'P'),
(195532, 'Ririe', 43.6319389343262, 0.761520993433098, -111.77278137207, -1.95080304905441, 218, 17, 'PPL', 'P'),
(208565, 'Risbeck', 46.8638916015625, 0.817929208744984, -117.312782287598, -2.04749430559386, 218, 56, 'PPL', 'P'),
(57191, 'Risco', 36.5533294677734, 0.637975951778913, -89.8177795410156, -1.56761597982112, 218, 29, 'PPL', 'P'),
(50840, 'Riser Place', 38.8108291625977, 0.677376754316363, -76.0566711425781, -1.32743932954455, 218, 25, 'PPL', 'P'),
(5405, 'Risers', 33.2958297729492, 0.58112185672152, -86.2402801513672, -1.50517683648367, 218, 2, 'PPL', 'P'),
(33778, 'Rishel', 38.6297187805176, 0.67421578183952, -97.0138931274414, -1.69321185525175, 218, 20, 'PPL', 'P'),
(166508, 'Rishelieu', 40.0038909912109, 0.698199611405529, -76.7249984741211, -1.33910384196104, 218, 45, 'PPL', 'P'),
(11596, 'Risher', 35.7466697692871, 0.623897084097182, -90.9736099243164, -1.58778902560431, 218, 4, 'PPL', 'P'),
(121223, 'Rising', 40.1572189331055, 0.700875688826895, -88.333610534668, -1.5417123440043, 218, 18, 'PPL', 'P'),
(166510, 'Rising', 41.9647216796875, 0.732422562993592, -77.1175003051758, -1.34595429123305, 218, 45, 'PPL', 'P'),
(198813, 'Rising', 48.336109161377, 0.843624252469423, -100.955276489258, -1.76200197199877, 218, 34, 'PPL', 'P'),
(142853, 'Rising City', 41.1994400024414, 0.719065878020463, -97.2958297729492, -1.69813257799789, 218, 35, 'PPL', 'P'),
(113982, 'Rising Corner', 42.035831451416, 0.733663662640596, -72.7125015258789, -1.26907255898799, 218, 8, 'PPL', 'P'),
(24347, 'Rising Fawn', 34.7599983215332, 0.606676418698457, -85.5311126708984, -1.49279952900142, 218, 13, 'PPL', 'P'),
(195533, 'Rising River', 43.3238906860352, 0.756144537245418, -112.330833435059, -1.9605428949511, 218, 17, 'PPL', 'P'),
(97524, 'Rising Star', 32.0958290100098, 0.560177892381783, -98.9633331298828, -1.72723600186444, 218, 51, 'PPL', 'P'),
(14485, 'Rising Sun', 39.1002807617188, 0.682428637746189, -75.5158309936523, -1.31799988821881, 218, 10, 'PPL', 'P'),
(28424, 'Rising Sun', 38.0002784729004, 0.663229976026835, -88.0280609130859, -1.53637949707948, 218, 18, 'PPL', 'P'),
(30977, 'Rising Sun', 38.9494400024414, 0.679795969850591, -84.853889465332, -1.48097975429337, 218, 19, 'PPL', 'P'),
(50843, 'Rising Sun', 39.6977806091309, 0.692856977363694, -76.0630569458008, -1.32755078283617, 218, 25, 'PPL', 'P'),
(61547, 'Rising Sun', 33.458610534668, 0.583962916972416, -90.208610534668, -1.5744372674792, 218, 30, 'PPL', 'P'),
(117539, 'Rising Sun', 41.5933303833008, 0.725940562058394, -93.4813919067383, -1.63155807811976, 218, 16, 'PPL', 'P'),
(166509, 'Rising Sun', 40.702220916748, 0.710387767871358, -75.5966720581055, -1.31941083096434, 218, 45, 'PPL', 'P'),
(176109, 'Rising Sun', 43.4180603027344, 0.757788107112161, -90.9580612182617, -1.58751764948923, 218, 57, 'PPL', 'P'),
(197387, 'Rising Sun', 48.6963882446289, 0.849912308698236, -113.516937255859, -1.98124431189456, 218, 31, 'PPL', 'P'),
(14486, 'Rising Sun Mobile Home Park', 39.0969390869141, 0.682370314518316, -75.5116729736328, -1.31792731707911, 218, 10, 'PPL', 'P'),
(125946, 'Risingdale', 42.2486114501953, 0.737377374201684, -73.3555603027344, -1.28029605192796, 218, 23, 'PPL', 'P'),
(157375, 'Risingsun', 41.2694396972656, 0.720287603170537, -83.4250030517578, -1.45604098173949, 218, 41, 'PPL', 'P'),
(152118, 'Risingville', 42.2191696166992, 0.736863517269354, -77.3152770996094, -1.34940614747996, 218, 40, 'PPL', 'P'),
(121224, 'Risk', 40.6708297729492, 0.709839889056102, -88.4052810668945, -1.54296323076832, 218, 18, 'PPL', 'P'),
(157377, 'Risley (historical)', 41.1361083984375, 0.717960533010026, -82.0444412231445, -1.43194563230284, 218, 41, 'PPL', 'P'),
(166511, 'Rismiller', 40.8397216796875, 0.712787608908656, -75.3158264160156, -1.31450914981999, 218, 45, 'PPL', 'P'),
(37937, 'Risner', 37.586669921875, 0.656011144997039, -82.8402786254883, -1.44583561528425, 218, 21, 'PPL', 'P'),
(11594, 'Rison', 33.9583282470703, 0.592684636384371, -92.1900024414063, -1.60901908002415, 218, 4, 'PPL', 'P'),
(50844, 'Rison', 38.5488891601563, 0.672805038831078, -77.1774978637695, -1.34700144617367, 218, 25, 'PPL', 'P'),
(50845, 'Rison Acres', 38.5444412231445, 0.672727407685302, -77.1741714477539, -1.3469433892619, 218, 25, 'PPL', 'P'),
(123551, 'Risse', 40.2750015258789, 0.702931382872327, -86.4869384765625, -1.50948183638578, 218, 19, 'PPL', 'P'),
(57192, 'Ristine', 36.6488914489746, 0.639643822990602, -89.5480575561523, -1.56290844312025, 218, 29, 'PPL', 'P'),
(42812, 'Rita', 29.6477794647217, 0.517451367564555, -90.5338897705078, -1.58011446113297, 218, 22, 'PPL', 'P'),
(97525, 'Rita', 30.6866703033447, 0.535583433267333, -96.6086120605469, -1.68613836623845, 218, 51, 'PPL', 'P'),
(112660, 'Rita', 37.7702789306641, 0.659215726736731, -81.9322204589844, -1.42998701047914, 218, 58, 'PPL', 'P'),
(166512, 'Rita', 41.1222190856934, 0.717718118771801, -75.8816680908203, -1.32438495009033, 218, 45, 'PPL', 'P'),
(17803, 'Rital', 28.5222206115723, 0.497806659652127, -82.2177810668945, -1.43497098330117, 218, 12, 'PPL', 'P'),
(24348, 'Ritch', 31.5397205352783, 0.550471968499475, -82.1063919067383, -1.43302687570541, 218, 13, 'PPL', 'P'),
(187864, 'Ritchal', 38.0325012207031, 0.663792369070032, -101.027778625488, -1.76326737299072, 218, 20, 'PPL', 'P'),
(57193, 'Ritchey', 36.9441719055176, 0.644797439174069, -94.1847229003906, -1.64383351969032, 218, 29, 'PPL', 'P'),
(152119, 'Ritchfield Junction', 42.9449996948242, 0.749531641942643, -75.2463912963867, -1.31329727836595, 218, 40, 'PPL', 'P'),
(11597, 'Ritchie', 33.2861099243164, 0.580952213360082, -92.5416717529297, -1.61515686738846, 218, 4, 'PPL', 'P'),
(30978, 'Ritchie', 37.9597206115723, 0.662522107809092, -87.0388870239258, -1.51911515583887, 218, 19, 'PPL', 'P'),
(37938, 'Ritchie', 37.3113899230957, 0.651206602653454, -83.083610534668, -1.4500825582746, 218, 21, 'PPL', 'P'),
(50846, 'Ritchie', 38.8705596923828, 0.678419248725074, -76.855827331543, -1.34138723627967, 218, 25, 'PPL', 'P'),
(90338, 'Ritchie', 36.4791717529297, 0.636681655489134, -83.4700012207031, -1.45682634794496, 218, 50, 'PPL', 'P'),
(97526, 'Ritchie', 31.4791698455811, 0.549415159599904, -97.2263870239258, -1.6969205733858, 218, 51, 'PPL', 'P'),
(121225, 'Ritchie', 41.2550010681152, 0.720035601552388, -88.1052780151367, -1.53772718974911, 218, 18, 'PPL', 'P'),
(166513, 'Ritchie', 41.2986106872559, 0.720796732991933, -77.6094436645508, -1.35454032258746, 218, 45, 'PPL', 'P'),
(42813, 'Ritchie (historical)', 30.4513893127441, 0.531477005313999, -92.466667175293, -1.61384779055463, 218, 22, 'PPL', 'P'),
(208566, 'Ritell', 47.0355606079102, 0.820925398129378, -119.084999084473, -2.07842532375848, 218, 56, 'PPL', 'P'),
(205533, 'Riter', 40.7519416809082, 0.711255558912561, -112.07527923584, -1.95608263275744, 218, 52, 'PPL', 'P'),
(166516, 'Riterville', 41.7694396972656, 0.729014249430509, -78.6622161865234, -1.37291466937041, 218, 45, 'PPL', 'P'),
(37939, 'Ritner', 36.7924995422363, 0.64215025705053, -84.6311111450195, -1.47709153910186, 218, 21, 'PPL', 'P'),
(74079, 'Riton (historical)', 39.3527793884277, 0.686835570139025, -82.9697189331055, -1.44809477483697, 218, 41, 'PPL', 'P'),
(90339, 'Ritta', 36.0572204589844, 0.629317216126738, -83.866943359375, -1.46375429520469, 218, 50, 'PPL', 'P'),
(166514, 'Rittenhouse', 41.2552795410156, 0.720040461821378, -76.2350006103516, -1.33055176591052, 218, 45, 'PPL', 'P'),
(178987, 'Rittenhouse', 33.2566719055176, 0.580438423006778, -111.634437561035, -1.94838849405209, 218, 5, 'PPL', 'P'),
(166515, 'Rittenhouse Town', 40.0333290100098, 0.698713401758832, -75.1949996948242, -1.31240032571081, 218, 45, 'PPL', 'P'),
(74080, 'Rittenours', 39.2163887023926, 0.684455103598657, -82.8427810668945, -1.44587929112613, 218, 41, 'PPL', 'P'),
(50847, 'Ritter', 39.4638900756836, 0.688774817465793, -77.1202774047852, -1.34600276076489, 218, 25, 'PPL', 'P'),
(57194, 'Ritter', 37.2636108398438, 0.650372700337123, -93.3836135864258, -1.62985152449324, 218, 29, 'PPL', 'P'),
(83297, 'Ritter', 32.7894401550293, 0.572283690590901, -80.6305618286133, -1.40726878164216, 218, 48, 'PPL', 'P'),
(117540, 'Ritter', 43.2441711425781, 0.754753168733907, -95.8225021362305, -1.67241815977652, 218, 16, 'PPL', 'P'),
(201476, 'Ritter', 44.8925018310547, 0.783521966409487, -119.142501831055, -2.07942893601528, 218, 43, 'PPL', 'P'),
(111130, 'Ritters', 39.4236106872559, 0.688071809517039, -78.7249984741211, -1.37401042700093, 218, 58, 'PPL', 'P'),
(157378, 'Ritters (historical)', 41.7027816772461, 0.727850847508308, -84.2699966430664, -1.47078890206608, 218, 41, 'PPL', 'P'),
(166538, 'Ritters Crossroads', 41.2050018310547, 0.719162950242197, -76.5858306884766, -1.33667490588883, 218, 45, 'PPL', 'P'),
(157379, 'Rittman', 40.9780616760254, 0.715202097331949, -81.7822189331055, -1.42736898996953, 218, 41, 'PPL', 'P'),
(77100, 'Ritts Junction', 35.7411117553711, 0.623800078454476, -96.5119400024414, -1.68445112052983, 218, 42, 'PPL', 'P'),
(11598, 'Ritz', 34.753059387207, 0.606555311447886, -94.2361068725586, -1.6447303391874, 218, 4, 'PPL', 'P'),
(195534, 'Ritz', 48.7788887023926, 0.851352213320615, -116.368606567383, -2.03101533055873, 218, 17, 'PPL', 'P'),
(50848, 'Ritz Estates', 39.3461112976074, 0.686719189999388, -77.102783203125, -1.34569742934591, 218, 25, 'PPL', 'P'),
(166518, 'Ritzie Village', 40.3944396972656, 0.705015972215587, -76.7822189331055, -1.34010252736982, 218, 45, 'PPL', 'P'),
(208576, 'Ritzville', 47.127498626709, 0.822530019265178, -118.378890991211, -2.06610141265608, 218, 56, 'PPL', 'P'),
(50849, 'Riva', 38.9519386291504, 0.679839579113441, -76.5783309936523, -1.33654401152125, 218, 25, 'PPL', 'P'),
(50850, 'Riva Farms', 38.9513893127441, 0.679829991733517, -76.5908279418945, -1.33676212441453, 218, 25, 'PPL', 'P'),
(50851, 'Riva Trace', 38.9663887023926, 0.680091780468671, -76.5669403076172, -1.33634520654588, 218, 25, 'PPL', 'P'),
(50852, 'Riva Woods', 38.9711112976074, 0.680174205304409, -76.5788879394531, -1.33655373205923, 218, 25, 'PPL', 'P'),
(189357, 'Rivajana', 35.3380584716797, 0.616765471593086, -106.535278320313, -1.85939137621799, 218, 38, 'PPL', 'P'),
(198814, 'Rival', 48.901668548584, 0.853495125891747, -102.611389160156, -1.79090659088995, 218, 34, 'PPL', 'P'),
(90340, 'Rival (historical)', 36.3869400024414, 0.635071907768236, -86.5066680908203, -1.50982618311473, 218, 50, 'PPL', 'P'),
(112338, 'Rivals', 38.0974998474121, 0.664926809115379, -85.304443359375, -1.48884340320211, 218, 21, 'PPL', 'P'),
(105722, 'Rivanna', 38.1247215270996, 0.665401917053849, -78.4611129760742, -1.36940475621174, 218, 53, 'PPL', 'P'),
(123552, 'Rivare', 40.8122215270996, 0.712307640701196, -84.8413925170898, -1.4807616414001, 218, 19, 'PPL', 'P'),
(50853, 'Rive Gauche Estates', 39.0741691589355, 0.681972904304649, -77.3111114501953, -1.3493334431822, 218, 25, 'PPL', 'P'),
(83298, 'Rivelon', 33.4727783203125, 0.58421019147963, -80.8986129760742, -1.4119471567291, 218, 48, 'PPL', 'P'),
(50854, 'Rivendell', 39.077220916748, 0.68202616752645, -76.5722198486328, -1.3364373519196, 218, 25, 'PPL', 'P'),
(205534, 'Rivendell Condominium', 40.6450004577637, 0.709389082462578, -111.866111755371, -1.95243197153516, 218, 52, 'PPL', 'P'),
(121226, 'River', 41.1591682434082, 0.718363003229764, -87.5933303833008, -1.52879201797579, 218, 18, 'PPL', 'P'),
(123553, 'River', 40.7541694641113, 0.711294441064476, -85.5069427490234, -1.49237768428475, 218, 19, 'PPL', 'P'),
(68237, 'River Acres', 35.4972190856934, 0.61954334834712, -76.9927825927734, -1.34377755651607, 218, 33, 'PPL', 'P'),
(57196, 'River aux Vases', 37.8722190856934, 0.660994918081986, -90.1127777099609, -1.57276466915657, 218, 29, 'PPL', 'P'),
(71336, 'River Bank', 39.9336090087891, 0.696972959407438, -74.1575012207031, -1.29429256135298, 218, 37, 'PPL', 'P'),
(5406, 'River Bend', 34.0391693115234, 0.594095579129895, -86.7136077880859, -1.5134379621851, 218, 2, 'PPL', 'P'),
(24349, 'River Bend', 31.4433307647705, 0.548789649638872, -84.1358337402344, -1.46844731767763, 218, 13, 'PPL', 'P'),
(42815, 'River Bend', 29.8813896179199, 0.521528633903953, -89.8927764892578, -1.5689249234969, 218, 22, 'PPL', 'P'),
(57195, 'River Bend', 39.1788902282715, 0.68380063176077, -94.3947219848633, -1.64749869514054, 218, 29, 'PPL', 'P'),
(68238, 'River Bend', 35.0688896179199, 0.612067588851159, -77.147216796875, -1.34647294185534, 218, 33, 'PPL', 'P'),
(111131, 'River Bend', 38.351390838623, 0.669358042853161, -81.8486099243164, -1.42852773135983, 218, 58, 'PPL', 'P'),
(5407, 'River Bend (historical)', 32.8013916015625, 0.572492282683282, -85.8727798461914, -1.49876274615627, 218, 2, 'PPL', 'P'),
(97527, 'River Bend Colonia', 26.3419990539551, 0.459754615048748, -98.1849975585938, -1.71365148346005, 218, 51, 'PPL', 'P'),
(50856, 'River Bend Estates', 38.978889465332, 0.680309959940976, -76.166389465332, -1.32935427552637, 218, 25, 'PPL', 'P'),
(90341, 'River Bend Estates', 35.2569389343262, 0.615349668578573, -84.7138900756836, -1.47853630399323, 218, 50, 'PPL', 'P'),
(105725, 'River Bend Estates', 38.6572189331055, 0.67469575004698, -77.2438888549805, -1.34816018756396, 218, 53, 'PPL', 'P'),
(137725, 'River Bend Mobile Home Park', 45.3444404602051, 0.791409783505111, -92.9749984741211, -1.62271984541012, 218, 28, 'PPL', 'P'),
(74081, 'River Bend Subdivision', 38.8758316040039, 0.678511260940737, -82.1430587768555, -1.43366683331535, 218, 41, 'PPL', 'P'),
(24350, 'River Bluff', 33.9708290100098, 0.592902815856676, -84.272216796875, -1.47082765105994, 218, 13, 'PPL', 'P'),
(37940, 'River Bluff', 38.3705596923828, 0.669692602465103, -85.6116714477539, -1.49420554489893, 218, 21, 'PPL', 'P'),
(171198, 'River Bluff Addition', 43.7333297729492, 0.763290597398428, -98.0652770996094, -1.71156196726878, 218, 49, 'PPL', 'P'),
(14487, 'River Breeze', 38.6236114501953, 0.67410918881689, -75.1927795410156, -1.31236157671695, 218, 10, 'PPL', 'P'),
(24351, 'River Bridge', 33.9113883972168, 0.591865381454036, -84.0516662597656, -1.46697831802034, 218, 13, 'PPL', 'P'),
(24352, 'River Chase', 33.9216690063477, 0.59204481193248, -84.4277801513672, -1.47354274379127, 218, 13, 'PPL', 'P'),
(105726, 'River Cliff', 37.6575012207031, 0.657247384375053, -77.8647232055664, -1.35899579109117, 218, 53, 'PPL', 'P'),
(50857, 'River Club Estates', 38.9061088562012, 0.679039698680036, -76.5299987792969, -1.33570045524597, 218, 25, 'PPL', 'P'),
(24353, 'River Colony', 33.9722213745117, 0.592927117201623, -84.0447235107422, -1.46685714419074, 218, 13, 'PPL', 'P'),
(157380, 'River Corners', 41.1063919067383, 0.717441882387733, -82.0947189331055, -1.43282314388202, 218, 41, 'PPL', 'P'),
(24355, 'River Cove', 33.6291694641113, 0.58693973185988, -83.7716674804688, -1.46209141742004, 218, 13, 'PPL', 'P'),
(97528, 'River Creek Acres', 28.2983303070068, 0.493899036674167, -98.0469436645508, -1.71124198846381, 218, 51, 'PPL', 'P'),
(97529, 'River Crest Estates', 31.4257297515869, 0.548482454007131, -94.6675109863281, -1.65225976137933, 218, 51, 'PPL', 'P'),
(50858, 'River Edge', 39.1547203063965, 0.683378787044102, -76.0572204589844, -1.32744891692447, 218, 25, 'PPL', 'P'),
(83300, 'River Edge', 34.8791694641113, 0.608756347509809, -82.0130615234375, -1.43139795322466, 218, 48, 'PPL', 'P'),
(105727, 'River Edge', 37.2599983215332, 0.650309649998315, -79.8730621337891, -1.39404791788463, 218, 53, 'PPL', 'P'),
(146177, 'River Edge', 40.9286117553711, 0.714339033401682, -74.040283203125, -1.29224672100358, 218, 37, 'PPL', 'P'),
(157381, 'River Edge', 41.420280456543, 0.722920271066135, -81.8505630493164, -1.42856181982178, 218, 41, 'PPL', 'P'),
(50859, 'River Estates', 39.0855598449707, 0.682171709280023, -76.1258316040039, -1.32864640730862, 218, 25, 'PPL', 'P'),
(5435, 'River Falls', 31.3527793884277, 0.547209229979478, -86.5391693115234, -1.51039343642692, 218, 2, 'PPL', 'P'),
(83301, 'River Falls', 35.1238899230957, 0.613027525266078, -82.5419387817383, -1.44062860272093, 218, 48, 'PPL', 'P'),
(176111, 'River Falls', 44.8613891601563, 0.78297894786322, -92.6236114501953, -1.61658698489383, 218, 57, 'PPL', 'P'),
(24356, 'River Farms', 33.8583297729492, 0.590939333763988, -83.3377838134766, -1.4545187188604, 218, 13, 'PPL', 'P'),
(50860, 'River Farms', 39.3069381713867, 0.686035489968537, -77.0652770996094, -1.34504282434997, 218, 25, 'PPL', 'P'),
(17804, 'River Forest', 29.0130596160889, 0.506373416378153, -81.3919372558594, -1.42055728969138, 218, 12, 'PPL', 'P'),
(24357, 'River Forest', 33.5175018310547, 0.584990763995133, -84.5236129760742, -1.4752153421139, 218, 13, 'PPL', 'P'),
(83302, 'River Forest', 35.0222206115723, 0.611253061031758, -82.01611328125, -1.43145121644646, 218, 48, 'PPL', 'P'),
(121227, 'River Forest', 41.8977813720703, 0.731254234223374, -87.8138885498047, -1.53264148417344, 218, 18, 'PPL', 'P'),
(123554, 'River Forest', 40.1097183227539, 0.700046646779553, -85.7272186279297, -1.49622222363439, 218, 19, 'PPL', 'P'),
(105728, 'River Forest Shores', 36.8344383239746, 0.642882226876139, -76.2024993896484, -1.32998451259833, 218, 53, 'PPL', 'P'),
(11600, 'River Front', 35.2627792358398, 0.615451601069295, -90.6666717529297, -1.58243194391356, 218, 4, 'PPL', 'P'),
(184581, 'River Garden (historical)', 39.8452796936035, 0.695431322031419, -123.419166564941, -2.15407081662553, 218, 6, 'PPL', 'P'),
(113983, 'River Glen', 41.7447204589844, 0.728582817333916, -72.8630599975586, -1.27170030003557, 218, 8, 'PPL', 'P'),
(121230, 'River Grange Lakes', 41.9627799987793, 0.732388674268721, -88.3274993896484, -1.54160568440265, 218, 18, 'PPL', 'P'),
(121231, 'River Grove', 41.9258308410645, 0.731743789810758, -87.8358306884766, -1.53302444673819, 218, 18, 'PPL', 'P'),
(68240, 'River Haven', 35.3152809143066, 0.616367928221364, -80.0858306884766, -1.39776142970863, 218, 33, 'PPL', 'P'),
(123555, 'River Haven', 41.0774993896484, 0.716937612835326, -85.0541687011719, -1.48447528638216, 218, 19, 'PPL', 'P'),
(90344, 'River Heights', 35.6355590820313, 0.621957836770413, -87.0372161865234, -1.51908599422494, 218, 50, 'PPL', 'P'),
(205537, 'River Heights', 41.7216682434082, 0.728180480272232, -111.820556640625, -1.95163688479172, 218, 52, 'PPL', 'P'),
(90346, 'River Hill', 35.8227806091309, 0.625225468848913, -85.4341735839844, -1.49110762276089, 218, 50, 'PPL', 'P'),
(97530, 'River Hill', 32.2295112609863, 0.562511087812801, -94.2200317382813, -1.64444977516656, 218, 51, 'PPL', 'P'),
(166519, 'River Hill', 40.2044410705566, 0.701699870605247, -79.9111099243164, -1.39471197710244, 218, 45, 'PPL', 'P'),
(24358, 'River Hill East', 33.9194412231445, 0.592005929780565, -83.3591690063477, -1.45489196088718, 218, 13, 'PPL', 'P'),
(24359, 'River Hills', 33.6769409179688, 0.587773501018156, -84.2863922119141, -1.47107505872521, 218, 13, 'PPL', 'P'),
(68242, 'River Hills', 35.5888900756836, 0.621143308951013, -77.3111114501953, -1.3493334431822, 218, 33, 'PPL', 'P'),
(90369, 'River Hills', 35.0911102294922, 0.612455411684902, -85.2850036621094, -1.48850411647923, 218, 50, 'PPL', 'P'),
(97531, 'River Hills', 30.3388900756836, 0.52951352322131, -97.8491668701172, -1.7077901322169, 218, 51, 'PPL', 'P'),
(176114, 'River Hills', 43.1741714477539, 0.753531443583833, -87.9241714477539, -1.5345662838513, 218, 57, 'PPL', 'P'),
(83303, 'River Hills Plantation', 35.1066703796387, 0.612726987537062, -81.0638885498047, -1.41483175966382, 218, 48, 'PPL', 'P'),
(50861, 'River Island', 39.1355590820313, 0.683044360590215, -76.8219375610352, -1.34079574820157, 218, 25, 'PPL', 'P'),
(50862, 'River Isle Estates', 38.3472213745117, 0.669285271976375, -75.6588897705078, -1.32049673489882, 218, 25, 'PPL', 'P'),
(105729, 'River Jack', 37.1300010681152, 0.648040769907622, -81.5508270263672, -1.42333043933448, 218, 53, 'PPL', 'P'),
(17805, 'River Junction', 30.6855602264404, 0.535564058770402, -84.8413925170898, -1.4807616414001, 218, 12, 'PPL', 'P'),
(117541, 'River Junction', 41.4905586242676, 0.724146856485198, -91.4966735839844, -1.59691820866305, 218, 16, 'PPL', 'P'),
(137727, 'River Junction', 43.8461112976074, 0.765259006339133, -91.2972183227539, -1.59343705764415, 218, 28, 'PPL', 'P'),
(205538, 'River Meadow', 40.6655616760254, 0.709747943419467, -111.910827636719, -1.95321241089261, 218, 52, 'PPL', 'P'),
(189358, 'River Mill', 33.2933311462402, 0.58107824745867, -104.754722595215, -1.8283148162998, 218, 38, 'PPL', 'P'),
(50863, 'River Mills', 39.2750015258789, 0.685478090352384, -76.8130569458008, -1.34064075222612, 218, 25, 'PPL', 'P'),
(68244, 'River Neck', 35.9474983215332, 0.62740220356589, -76.2813873291016, -1.33136136688191, 218, 33, 'PPL', 'P'),
(24360, 'River North', 33.5780601501465, 0.586047706052758, -83.9124984741211, -1.46454938194813, 218, 13, 'PPL', 'P'),
(24361, 'River Oak', 33.8886108398438, 0.591467838082314, -84.0686111450195, -1.46727406205939, 218, 13, 'PPL', 'P'),
(83304, 'River Oak Ranchettes', 35.0894393920898, 0.612426250070965, -82.0166702270508, -1.43146093698444, 218, 48, 'PPL', 'P'),
(24364, 'River Oaks', 34.1083297729492, 0.595302656893974, -84.4599990844727, -1.47410507025544, 218, 13, 'PPL', 'P'),
(42818, 'River Oaks', 32.5563888549805, 0.568216178078996, -92.1158294677734, -1.60772451741826, 218, 22, 'PPL', 'P'),
(83305, 'River Oaks', 35.0994415283203, 0.61260082028042, -82.0036087036133, -1.43123297039513, 218, 48, 'PPL', 'P'),
(90348, 'River Oaks', 35.1175003051758, 0.612916005395431, -85.1391677856445, -1.48595880026739, 218, 50, 'PPL', 'P'),
(97533, 'River Oaks', 32.7769393920898, 0.572065511118596, -97.394172668457, -1.69984898532045, 218, 51, 'PPL', 'P'),
(105732, 'River Oaks', 36.8688888549805, 0.643483502071251, -76.2188873291016, -1.33027053609941, 218, 53, 'PPL', 'P'),
(123556, 'River Oaks', 41.711669921875, 0.728005976641805, -85.404167175293, -1.49058391213253, 218, 19, 'PPL', 'P'),
(184582, 'River Oaks', 36.8997192382813, 0.644021593769502, -121.593330383301, -2.12220396365386, 218, 6, 'PPL', 'P'),
(24365, 'River Oaks at Harrietts Bluff', 30.871940612793, 0.538817010173393, -81.586669921875, -1.42395601587454, 218, 13, 'PPL', 'P'),
(83306, 'River Oaks Estates', 33.4619407653809, 0.584021040463207, -79.1505584716797, -1.3814378501231, 218, 48, 'PPL', 'P'),
(97534, 'River Oaks Number 2 Colonia', 28.3080005645752, 0.494067814508251, -97.7669982910156, -1.70635601996989, 218, 51, 'PPL', 'P'),
(5410, 'River Park', 30.4505596160889, 0.531462524375571, -87.8119430541992, -1.53260752886954, 218, 2, 'PPL', 'P'),
(17806, 'River Park', 27.3138904571533, 0.476717320006385, -80.3475036621094, -1.40232848466201, 218, 12, 'PPL', 'P'),
(105734, 'River Park', 36.8441696166992, 0.643052069974658, -76.345832824707, -1.3324861529683, 218, 53, 'PPL', 'P'),
(50864, 'River Park Estates', 39.3402786254883, 0.68661739066672, -76.9499969482422, -1.34303080614641, 218, 25, 'PPL', 'P'),
(83307, 'River Pines', 35.0097198486328, 0.611034881559453, -81.0869369506836, -1.41523403014648, 218, 48, 'PPL', 'P'),
(125947, 'River Pines', 42.5638885498047, 0.742879997646006, -71.2888870239258, -1.24422579864977, 218, 23, 'PPL', 'P'),
(184583, 'River Pines', 38.5463905334473, 0.672761429568228, -120.743057250977, -2.10736389795355, 218, 6, 'PPL', 'P'),
(24366, 'River Place', 34.2227783203125, 0.597300160869588, -85.2222213745117, -1.48740835884872, 218, 13, 'PPL', 'P'),
(50865, 'River Plantations', 39.3569412231445, 0.686908207857756, -77.0449981689453, -1.3446888902411, 218, 25, 'PPL', 'P'),
(24367, 'River Point', 34.3555603027344, 0.599617643650175, -83.8291702270508, -1.46309502967684, 218, 13, 'PPL', 'P'),
(137728, 'River Point', 43.9391708374023, 0.766883201708945, -93.245002746582, -1.62743230895901, 218, 28, 'PPL', 'P'),
(169576, 'River Point', 41.7169418334961, 0.728097988857467, -71.5177764892578, -1.24822067344294, 218, 47, 'PPL', 'P'),
(132842, 'River Raisin', 42.1180610656738, 0.73509884015204, -83.9791717529297, -1.46571305018644, 218, 27, 'PPL', 'P'),
(83308, 'River Reach', 32.4044418334961, 0.565564202265495, -80.7680587768555, -1.40966855610043, 218, 48, 'PPL', 'P'),
(90350, 'River Rest', 36.014720916748, 0.628575459184124, -86.8930587768555, -1.51656997278508, 218, 50, 'PPL', 'P'),
(5411, 'River Ridge', 31.7136096954346, 0.553506906877729, -87.3130569458008, -1.52390032368553, 218, 2, 'PPL', 'P'),
(24368, 'River Ridge', 34.2297210693359, 0.597421334699186, -85.2163925170898, -1.48730662609508, 218, 13, 'PPL', 'P'),
(30979, 'River Ridge', 38.3786087036133, 0.669833084212604, -85.6455612182617, -1.49479703297703, 218, 19, 'PPL', 'P'),
(37941, 'River Ridge', 36.8769416809082, 0.64362405039778, -83.1716690063477, -1.45161946853969, 218, 21, 'PPL', 'P'),
(42821, 'River Ridge', 29.9599990844727, 0.522900627918535, -90.2155609130859, -1.57455857446685, 218, 22, 'PPL', 'P'),
(50866, 'River Ridge Estates', 38.7863883972168, 0.676950182488759, -77.003059387207, -1.34395692041549, 218, 25, 'PPL', 'P'),
(68245, 'River Ridge Run', 36.1566696166992, 0.631052931367198, -80.4208297729492, -1.40360826672385, 218, 33, 'PPL', 'P'),
(68246, 'River Road', 35.5066719055176, 0.619708331176651, -76.9911117553711, -1.34374839490214, 218, 33, 'PPL', 'P'),
(201477, 'River Road', 44.084171295166, 0.76941393711382, -123.132499694824, -2.1490675358856, 218, 43, 'PPL', 'P'),
(208567, 'River Road', 48.0688896179199, 0.838960391610422, -123.127502441406, -2.1489803173599, 218, 56, 'PPL', 'P'),
(97535, 'River Road Colonia', 26.1299991607666, 0.456054518898732, -98.056999206543, -1.71141749077964, 218, 51, 'PPL', 'P'),
(105735, 'River Road Estates', 37.2341690063477, 0.649858843404792, -77.4369430541992, -1.35152961897513, 218, 53, 'PPL', 'P'),
(184584, 'River Road Estates', 36.9980583190918, 0.645737934513031, -119.984718322754, -2.09412838681002, 218, 6, 'PPL', 'P'),
(105736, 'River Road Hills', 37.5758285522461, 0.655821927401589, -77.5536117553711, -1.3535658719446, 218, 53, 'PPL', 'P'),
(68247, 'River Road Minor', 35.6549987792969, 0.622297123493289, -77.4252777099609, -1.35132602030979, 218, 33, 'PPL', 'P'),
(105737, 'River Road Terrace', 37.2374992370605, 0.649916966895583, -77.434440612793, -1.35148594313325, 218, 53, 'PPL', 'P'),
(132843, 'River Rouge', 42.2733306884766, 0.737808806298277, -83.1344375610352, -1.45096965723371, 218, 27, 'PPL', 'P'),
(24371, 'River Run', 34.4269409179688, 0.600863470408114, -83.8052825927734, -1.46267811180819, 218, 13, 'PPL', 'P'),
(117542, 'River Sioux', 41.8058280944824, 0.729649346771465, -96.0461120605469, -1.67632088919598, 218, 16, 'PPL', 'P'),
(50867, 'River Springs', 38.2461090087891, 0.667520528280034, -76.7777786254883, -1.3400250293821, 218, 25, 'PPL', 'P'),
(97536, 'River Spur', 28.6605606079102, 0.50022114807542, -99.8027801513672, -1.7418871162854, 218, 51, 'PPL', 'P'),
(157382, 'River Styx', 41.0569381713867, 0.716578751878438, -81.8000030517578, -1.42767938139458, 218, 41, 'PPL', 'P'),
(13198, 'River Terrace', 38.8919410705566, 0.678792424172822, -76.9577789306641, -1.34316662736201, 218, 9, 'PPL', 'P'),
(97537, 'River Terrace', 30.0997200012207, 0.525339217949693, -95.1458282470703, -1.6606079724484, 218, 51, 'PPL', 'P'),
(105739, 'River Terrace', 37.0622215270996, 0.646857793751409, -76.3450012207031, -1.33247163874036, 218, 53, 'PPL', 'P'),
(137729, 'River Terrace Mobile Home Park', 45.3222198486328, 0.791021960671369, -93.8222198486328, -1.63750664788862, 218, 28, 'PPL', 'P'),
(24372, 'River Trace', 33.0177803039551, 0.57626897800415, -85.1477813720703, -1.48610913571092, 218, 13, 'PPL', 'P'),
(146179, 'River Vale', 40.9952812194824, 0.715502635060964, -74.0124969482422, -1.29176175936908, 218, 37, 'PPL', 'P'),
(137730, 'River Valley', 48.0202789306641, 0.83811197506615, -95.7819366455078, -1.67171015840072, 218, 28, 'PPL', 'P'),
(166520, 'River Valley', 40.5461082458496, 0.707663087760098, -79.8216705322266, -1.39315096522949, 218, 45, 'PPL', 'P'),
(24373, 'River Valley Estates', 33.5636100769043, 0.585795504697527, -84.3988876342773, -1.47303847423887, 218, 13, 'PPL', 'P'),
(50868, 'River View', 38.3252792358398, 0.668902309411622, -76.4291687011719, -1.33394063839765, 218, 25, 'PPL', 'P'),
(90353, 'River View', 36.5416717529297, 0.637772486271631, -83.6327819824219, -1.45966740819585, 218, 50, 'PPL', 'P'),
(105740, 'River View', 38.9455604553223, 0.679728258979876, -78.2138900756836, -1.3650899026136, 218, 53, 'PPL', 'P'),
(166523, 'River View', 40.2119407653809, 0.701830764972825, -79.9602813720703, -1.39557018076372, 218, 45, 'PPL', 'P'),
(169577, 'River View', 41.711109161377, 0.727996189524799, -71.3705596923828, -1.24565125562323, 218, 47, 'PPL', 'P'),
(68248, 'River View (historical)', 35.5113906860352, 0.619790689433361, -80.9502792358398, -1.4128489030742, 218, 33, 'PPL', 'P'),
(205545, 'River View Heights', 40.6411094665527, 0.709321171854782, -111.933059692383, -1.95360043346343, 218, 52, 'PPL', 'P'),
(105741, 'River View Park', 37.2275009155273, 0.649742463265156, -77.4619369506836, -1.35196584476169, 218, 53, 'PPL', 'P'),
(166524, 'River View Park', 40.3925018310547, 0.704982150069743, -75.9591674804688, -1.32573756960799, 218, 45, 'PPL', 'P'),
(14488, 'River Village II Mobile Home Park', 38.6124992370605, 0.673915244110505, -75.1999969482422, -1.31248754423651, 218, 10, 'PPL', 'P'),
(14489, 'River Village Mobile Home Park', 38.6169395446777, 0.673992742098226, -75.1966705322266, -1.31242948732475, 218, 10, 'PPL', 'P'),
(117543, 'River Vista Trailer Park', 41.6097183227539, 0.726226585559468, -94.0094375610352, -1.64077421338809, 218, 16, 'PPL', 'P'),
(24375, 'River West', 32.5166702270508, 0.567522957247248, -83.5502777099609, -1.45822743699445, 218, 13, 'PPL', 'P'),
(50869, 'River Wood Hills', 39.3794403076172, 0.687300890960489, -77.0819396972656, -1.34533364154101, 218, 25, 'PPL', 'P'),
(14490, 'River-view Acres', 38.5641708374023, 0.67307175441425, -75.6341705322266, -1.32006530280223, 218, 10, 'PPL', 'P'),
(97538, 'Rivera Colonia', 26.4120006561279, 0.460976373488335, -98.9700012207031, -1.72735238200408, 218, 51, 'PPL', 'P'),
(113984, 'Riverbank', 41.1047210693359, 0.717412720773796, -73.5869369506836, -1.2843343362469, 218, 8, 'PPL', 'P'),
(152120, 'Riverbank', 43.605281829834, 0.761055739190661, -73.725830078125, -1.28675847862915, 218, 40, 'PPL', 'P'),
(184585, 'Riverbank', 37.7361106872559, 0.658619378389635, -120.934440612793, -2.11070416775079, 218, 6, 'PPL', 'P'),
(24378, 'Riverbend', 33.5958290100098, 0.586357831161697, -83.8152770996094, -1.46285254885959, 218, 13, 'PPL', 'P'),
(68251, 'Riverbend', 35.4291687011719, 0.618355645079972, -82.1697235107422, -1.43413222071585, 218, 33, 'PPL', 'P'),
(83310, 'Riverbend', 32.8869400024414, 0.573985383948435, -80.0716705322266, -1.39751428835947, 218, 48, 'PPL', 'P'),
(90354, 'Riverbend', 35.8952789306641, 0.626490803261837, -83.9763870239258, -1.46566444749655, 218, 50, 'PPL', 'P'),
(105742, 'Riverbend', 36.7936096191406, 0.642169631547461, -76.4111099243164, -1.33362545328264, 218, 53, 'PPL', 'P'),
(184586, 'Riverbend', 36.7569389343262, 0.641529607358487, -119.510276794434, -2.08584782003264, 218, 6, 'PPL', 'P'),
(197388, 'Riverbend', 47.1519393920898, 0.822956591092781, -114.832221984863, -2.00420036101688, 218, 31, 'PPL', 'P'),
(208568, 'Riverbend', 47.4666709899902, 0.828449693736206, -121.749168395996, -2.12492385007516, 218, 56, 'PPL', 'P'),
(68253, 'Riverbend Acres', 35.2527809143066, 0.615277097438868, -81.5924987792969, -1.42405774862818, 218, 33, 'PPL', 'P'),
(24380, 'Riverbend East', 33.9152793884277, 0.591933292061833, -83.3675003051758, -1.45503736948269, 218, 13, 'PPL', 'P'),
(90356, 'Riverbend Estates', 35.8861083984375, 0.626330747280323, -84.4611129760742, -1.4741245113314, 218, 50, 'PPL', 'P'),
(137732, 'Riverbend Estates', 44.1699981689453, 0.770911898647962, -94.0250015258789, -1.64104585581928, 218, 28, 'PPL', 'P'),
(24381, 'Riverbend Farms', 33.5180587768555, 0.585000484533111, -83.9027786254883, -1.46437973858669, 218, 13, 'PPL', 'P'),
(137733, 'Riverbend Mobile Home Park', 45.2583312988281, 0.789906895122952, -93.5522232055664, -1.63279431749778, 218, 28, 'PPL', 'P'),
(205549, 'Riverbend Trailer Park', 40.3763885498047, 0.70470092025863, -111.555000305176, -1.9470020523886, 218, 52, 'PPL', 'P'),
(97539, 'Riverby', 33.8441696166992, 0.590692192414829, -95.929443359375, -1.6742846362265, 218, 51, 'PPL', 'P'),
(24383, 'Riverchase', 33.6722183227539, 0.587691076182418, -84.2444381713867, -1.47034282258349, 218, 13, 'PPL', 'P'),
(105743, 'Rivercliff', 36.8308296203613, 0.642819243116358, -76.5422210693359, -1.33591377444929, 218, 53, 'PPL', 'P'),
(113985, 'Rivercliff', 41.1947212219238, 0.718983519763753, -73.1047210693359, -1.27591808141198, 218, 8, 'PPL', 'P'),
(11605, 'Rivercliff Estates', 36.3383293151855, 0.634223491223964, -93.9875030517578, -1.64039138398139, 218, 4, 'PPL', 'P'),
(24384, 'Rivercrest', 33.0088882446289, 0.576113782291626, -85.154167175293, -1.48622058900254, 218, 13, 'PPL', 'P'),
(105744, 'Rivercrest', 38.9219398498535, 0.679316001643131, -77.1194381713867, -1.34598811337889, 218, 53, 'PPL', 'P'),
(144369, 'Rivercrest', 43.726390838623, 0.763169490147857, -72.2713928222656, -1.26137375975073, 218, 36, 'PPL', 'P'),
(117544, 'Rivercrest Estates', 41.6800003051758, 0.727453237557559, -90.3430633544922, -1.57678391187372, 218, 16, 'PPL', 'P'),
(71337, 'Rivercrest Manor', 39.9833297729492, 0.697840750448641, -74.2041702270508, -1.29510708917238, 218, 37, 'PPL', 'P'),
(5416, 'Riverdale', 34.560001373291, 0.60318581345769, -85.5808334350586, -1.49366732004262, 218, 2, 'PPL', 'P'),
(11606, 'Riverdale', 35.4236106872559, 0.618258639437266, -94.103889465332, -1.64242271010285, 218, 4, 'PPL', 'P'),
(14492, 'Riverdale', 38.5938911437988, 0.67359047161557, -75.1916732788086, -1.31234226879905, 218, 10, 'PPL', 'P'),
(17808, 'Riverdale', 29.8213901519775, 0.52048144567382, -81.5519409179688, -1.42334988041044, 218, 12, 'PPL', 'P'),
(24386, 'Riverdale', 31.5138893127441, 0.550021128616438, -84.1586074829102, -1.46884479447032, 218, 13, 'PPL', 'P'),
(33781, 'Riverdale', 37.3899993896484, 0.652578596668035, -97.3722229003906, -1.69946588959764, 218, 20, 'PPL', 'P'),
(50870, 'Riverdale', 39.0991706848145, 0.682409263249258, -76.5361099243164, -1.33580711484763, 218, 25, 'PPL', 'P'),
(57197, 'Riverdale', 36.9952812194824, 0.645689464981191, -93.2897186279297, -1.62821274831646, 218, 29, 'PPL', 'P'),
(61548, 'Riverdale', 33.834171295166, 0.590517688784401, -89.8247222900391, -1.56773715365072, 218, 30, 'PPL', 'P'),
(68257, 'Riverdale', 35.6155586242676, 0.621608762930531, -77.3897171020508, -1.35070537061775, 218, 33, 'PPL', 'P'),
(74084, 'Riverdale', 39.0086097717285, 0.680828677142296, -83.0630569458008, -1.44972383047577, 218, 41, 'PPL', 'P'),
(83314, 'Riverdale', 35.0208282470703, 0.611228759686811, -82.0283279418945, -1.43166440249172, 218, 48, 'PPL', 'P'),
(90358, 'Riverdale', 35.964168548584, 0.627693153914981, -83.7636108398438, -1.46195080251449, 218, 50, 'PPL', 'P'),
(97540, 'Riverdale', 28.672779083252, 0.500434400699708, -97.543327331543, -1.702452225286, 218, 51, 'PPL', 'P'),
(105751, 'Riverdale', 36.5511093139648, 0.637937202785052, -76.9599990844727, -1.34320537635587, 218, 53, 'PPL', 'P'),
(113986, 'Riverdale', 41.5613899230957, 0.725383095863213, -72.5833282470703, -1.26681805996718, 218, 8, 'PPL', 'P'),
(117545, 'Riverdale', 41.5444412231445, 0.725087285245132, -90.4580612182617, -1.57879100322926, 218, 16, 'PPL', 'P'),
(121234, 'Riverdale', 42.4199981689453, 0.740368636738062, -89.0294418334961, -1.55385689120728, 218, 18, 'PPL', 'P'),
(125951, 'Riverdale', 42.1383285522461, 0.73545257452383, -71.6397171020508, -1.25034893862808, 218, 23, 'PPL', 'P'),
(132845, 'Riverdale', 43.3855590820313, 0.757220853799974, -84.835563659668, -1.48065990864646, 218, 27, 'PPL', 'P'),
(142854, 'Riverdale', 40.7844390869141, 0.71182274564572, -99.1619415283203, -1.73070237233929, 218, 35, 'PPL', 'P'),
(144370, 'Riverdale', 43.0319404602051, 0.751049044552743, -71.6455612182617, -1.25045093769783, 218, 36, 'PPL', 'P'),
(146181, 'Riverdale', 40.9938888549805, 0.715478333716017, -74.3038864135742, -1.29684746494475, 218, 37, 'PPL', 'P'),
(152122, 'Riverdale', 43.2102813720703, 0.7541616806558, -75.4327774047852, -1.31655032963748, 218, 40, 'PPL', 'P'),
(184589, 'Riverdale', 39.8877792358398, 0.696173078974033, -123.746391296387, -2.1597819655832, 218, 6, 'PPL', 'P'),
(187263, 'Riverdale', 38.0586090087891, 0.664248035932545, -103.316108703613, -1.80320626722642, 218, 7, 'PPL', 'P'),
(195536, 'Riverdale', 42.1613883972168, 0.735855044743568, -111.836936950684, -1.95192277513474, 218, 17, 'PPL', 'P'),
(197389, 'Riverdale', 47.3466682434082, 0.826355250696913, -111.591941833496, -1.9476468036885, 218, 31, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(198815, 'Riverdale', 47.497501373291, 0.828987785434457, -101.370826721191, -1.76925469175344, 218, 34, 'PPL', 'P'),
(201478, 'Riverdale', 45.4508285522461, 0.793266605996142, -122.660003662109, -2.14082092441211, 218, 43, 'PPL', 'P'),
(205550, 'Riverdale', 41.1769409179688, 0.718673194917731, -112.003059387207, -1.95482215861351, 218, 52, 'PPL', 'P'),
(157385, 'Riverdale (historical)', 41.4922218322754, 0.72417588494108, -83.6833267211914, -1.46054958030694, 218, 41, 'PPL', 'P'),
(24387, 'Riverdale Acres', 33.5325012207031, 0.585252552730287, -84.4141693115234, -1.47330518982204, 218, 13, 'PPL', 'P'),
(111132, 'Riverdale Acres', 38.3936080932617, 0.670094872947759, -81.8091735839844, -1.4278394373761, 218, 58, 'PPL', 'P'),
(14493, 'Riverdale Estates Mobile Home Park', 39.0347213745117, 0.681284410583836, -75.5833282470703, -1.31917793752701, 218, 10, 'PPL', 'P'),
(50871, 'Riverdale Forest', 39.0986099243164, 0.682399476132252, -76.5458297729492, -1.33597675820907, 218, 25, 'PPL', 'P'),
(50872, 'Riverdale Gardens', 38.9686088562012, 0.680130529462532, -76.9136123657227, -1.34239577538449, 218, 25, 'PPL', 'P'),
(50873, 'Riverdale Heights', 38.9638900756836, 0.680048171205821, -76.915283203125, -1.34242493699842, 218, 25, 'PPL', 'P'),
(50874, 'Riverdale Hills', 38.9633293151855, 0.680038384088815, -76.9094390869141, -1.34232293792867, 218, 25, 'PPL', 'P'),
(198816, 'Riverdale Junction', 47.4988899230957, 0.829012020200376, -101.17472076416, -1.76583199712047, 218, 34, 'PPL', 'P'),
(105752, 'Riverdale Mobile Home Park', 37.2555618286133, 0.650232218589621, -77.3680572509766, -1.35032733490101, 218, 53, 'PPL', 'P'),
(50875, 'Riverdale Park', 38.9633293151855, 0.680038384088815, -76.9319381713867, -1.3427156210314, 218, 25, 'PPL', 'P'),
(184590, 'Riverdale Park', 37.6094398498535, 0.656408555210706, -121.050827026367, -2.11273549387224, 218, 6, 'PPL', 'P'),
(125952, 'Riverdale Station', 42.6416702270508, 0.744237544011674, -70.6722183227539, -1.23346289942032, 218, 23, 'PPL', 'P'),
(83315, 'Riverdowns', 34.9005584716797, 0.609129656115611, -82.2719421386719, -1.43591627233009, 218, 48, 'PPL', 'P'),
(14494, 'Riveredge Park', 39.6888885498047, 0.692701781651169, -75.5486068725586, -1.31857193522096, 218, 10, 'PPL', 'P'),
(152123, 'Riveredge Trailer Park', 41.2486114501953, 0.719924081681741, -73.9591674804688, -1.2908309845681, 218, 40, 'PPL', 'P'),
(97541, 'Rivereno Colonia', 26.3059997558594, 0.459126308768571, -98.6399993896484, -1.72159276351456, 218, 51, 'PPL', 'P'),
(117547, 'Riverforest Trailer Park', 42.4652786254883, 0.741158929791543, -92.3000030517578, -1.61093895285399, 218, 16, 'PPL', 'P'),
(24388, 'Rivergate', 33.9797210693359, 0.5930580115692, -84.304443359375, -1.47139011068216, 218, 13, 'PPL', 'P'),
(105753, 'Rivergate', 37.139720916748, 0.64821041326906, -76.3858337402344, -1.33318430064806, 218, 53, 'PPL', 'P'),
(152124, 'Rivergate', 44.1886100769043, 0.771236737721925, -75.7838897705078, -1.32267839646381, 218, 40, 'PPL', 'P'),
(201479, 'Rivergrove', 45.3913917541504, 0.792229238172529, -122.732223510742, -2.14208139855605, 218, 43, 'PPL', 'P'),
(24389, 'Riverhaven Estates', 33.899169921875, 0.591652128829748, -83.459716796875, -1.45664685088748, 218, 13, 'PPL', 'P'),
(152125, 'Riverhead', 40.9169387817383, 0.714135301578291, -72.6624984741211, -1.26819984109877, 218, 40, 'PPL', 'P'),
(24390, 'Riverhill', 33.9577789306641, 0.592675049004447, -84.4100036621094, -1.47323248552428, 218, 13, 'PPL', 'P'),
(105755, 'Riverhill', 36.7566719055176, 0.64152494682658, -80.9341735839844, -1.41256780642115, 218, 53, 'PPL', 'P'),
(144371, 'Riverhill', 43.2491683959961, 0.754840387259607, -71.620002746582, -1.25000485821524, 218, 36, 'PPL', 'P'),
(184591, 'Riverkern', 35.7897186279297, 0.62464842841972, -118.446113586426, -2.06727466827432, 218, 6, 'PPL', 'P'),
(111134, 'Riverlake', 38.3675003051758, 0.669639206085247, -81.8511123657227, -1.42857140720171, 218, 58, 'PPL', 'P'),
(17809, 'Riverland', 26.0936107635498, 0.455419421557776, -80.1869430541992, -1.39952617340497, 218, 12, 'PPL', 'P'),
(42824, 'Riverland', 30.3527793884277, 0.529755937459535, -91.1319427490234, -1.59055245470943, 218, 22, 'PPL', 'P'),
(83316, 'Riverland', 32.7077789306641, 0.570858433354518, -79.9638900756836, -1.3956331645235, 218, 48, 'PPL', 'P'),
(132846, 'Riverland', 45.7966690063477, 0.799302660606807, -87.2266693115234, -1.52239257503438, 218, 27, 'PPL', 'P'),
(105756, 'Riverland Court', 37.2747192382813, 0.650566578464481, -80.0530624389648, -1.39718951586454, 218, 53, 'PPL', 'P'),
(42825, 'Riverland Heights', 30.0744400024414, 0.524897998736094, -90.4902801513672, -1.57935332969343, 218, 22, 'PPL', 'P'),
(24391, 'Riverland Terrace', 32.4216690063477, 0.565864873152565, -84.954719543457, -1.4827395711417, 218, 13, 'PPL', 'P'),
(83317, 'Riverland Terrace', 32.7619400024414, 0.571803722383442, -79.9902801513672, -1.39609375823403, 218, 48, 'PPL', 'P'),
(157388, 'Riverlea', 40.0819396972656, 0.699561818303104, -83.0252838134766, -1.44906456494792, 218, 41, 'PPL', 'P'),
(105757, 'Riverlee', 37.2750015258789, 0.650571505312497, -80.0555572509766, -1.39723305854836, 218, 53, 'PPL', 'P'),
(113987, 'Rivermead Mobile Home Park', 41.7344398498535, 0.728403386855472, -72.6352767944336, -1.2677247331603, 218, 8, 'PPL', 'P'),
(57198, 'Rivermines', 37.848331451416, 0.660578000213334, -90.5311126708984, -1.58006599160114, 218, 29, 'PPL', 'P'),
(24393, 'Rivermist', 33.8655586242676, 0.59106550102063, -84.0749969482422, -1.46738551535101, 218, 13, 'PPL', 'P'),
(5421, 'Rivermont', 34.8327789306641, 0.607946679959398, -87.5983276367188, -1.52887923650149, 218, 2, 'PPL', 'P'),
(24394, 'Rivermont', 34.2097206115723, 0.597072260859304, -85.2477798461914, -1.48785443833131, 218, 13, 'PPL', 'P'),
(68258, 'Rivermont', 35.2394409179688, 0.615044270580568, -77.5991668701172, -1.35436095868805, 218, 33, 'PPL', 'P'),
(90360, 'Rivermont', 35.101390838623, 0.612634842163346, -85.2724990844727, -1.4882858704279, 218, 50, 'PPL', 'P'),
(105762, 'Rivermont', 37.2602806091309, 0.650314576846332, -79.9277801513672, -1.39500292745153, 218, 53, 'PPL', 'P'),
(125953, 'Rivermoor', 42.1749992370605, 0.736092598712803, -70.716667175293, -1.23423867824586, 218, 23, 'PPL', 'P'),
(176116, 'Rivermoor', 44.0727806091309, 0.769215132138446, -88.6861114501953, -1.54786464559655, 218, 57, 'PPL', 'P'),
(57199, 'Riverpark', 37.0977783203125, 0.647478376864425, -93.2830581665039, -1.62809650133488, 218, 29, 'PPL', 'P'),
(83318, 'Riverpoint', 32.7369384765625, 0.571367363438832, -79.9627838134766, -1.39561385660559, 218, 48, 'PPL', 'P'),
(24395, 'Riverridge', 33.0508308410645, 0.576845818696261, -85.170280456543, -1.48650181881365, 218, 13, 'PPL', 'P'),
(105763, 'Riverrun', 38.0580596923828, 0.66423844855262, -78.4544372558594, -1.36928824291405, 218, 53, 'PPL', 'P'),
(83319, 'Rivers (historical)', 34.7150001525879, 0.605891052492993, -80.0566711425781, -1.39725249962432, 218, 48, 'PPL', 'P'),
(50876, 'Rivers Edge', 39.2625007629395, 0.685259910880079, -75.8602828979492, -1.32401170806356, 218, 25, 'PPL', 'P'),
(83320, 'Rivers Edge', 32.4944381713867, 0.567134934676424, -80.6408309936523, -1.40744801238352, 218, 48, 'PPL', 'P'),
(105765, 'Rivers Edge', 37.2763900756836, 0.650595740078417, -77.2013931274414, -1.34741849720037, 218, 53, 'PPL', 'P'),
(197397, 'Rivers Edge Mobile Home Park', 48.4105606079102, 0.8449236753443, -115.513893127441, -2.0160977668707, 218, 31, 'PPL', 'P'),
(14495, 'Rivers End', 39.6375007629395, 0.691804895575058, -75.6588897705078, -1.32049673489882, 218, 10, 'PPL', 'P'),
(24396, 'Rivers End', 31.9866695404053, 0.558272700227453, -81.1155624389648, -1.41573363916698, 218, 13, 'PPL', 'P'),
(128665, 'Rivers End', 44.8105583190918, 0.782091782325088, -67.6463928222656, -1.18065228184599, 218, 26, 'PPL', 'P'),
(105766, 'Rivers Mill', 36.7511100769043, 0.641427874604846, -77.311393737793, -1.34933837003021, 218, 53, 'PPL', 'P'),
(90362, 'Riversburg', 35.269718170166, 0.615572708319867, -87.0438919067383, -1.51920250752263, 218, 50, 'PPL', 'P'),
(201480, 'Riversdale', 43.2655601501465, 0.755126477339708, -123.420280456543, -2.15409025770149, 218, 43, 'PPL', 'P'),
(50877, 'Rivershore', 39.4397201538086, 0.688352972749124, -76.2677764892578, -1.33112381291267, 218, 25, 'PPL', 'P'),
(197390, 'Rivershore Mobile Home Park', 47.4722213745117, 0.828546566220858, -111.309722900391, -1.94272115409435, 218, 31, 'PPL', 'P'),
(5426, 'Riverside', 33.6061096191406, 0.586537261640142, -86.2044372558594, -1.50455125994361, 218, 2, 'PPL', 'P'),
(11610, 'Riverside', 35.2936096191406, 0.615989692767546, -91.2411117553711, -1.59245781331133, 218, 4, 'PPL', 'P'),
(14496, 'Riverside', 39.7958297729492, 0.694568258101151, -75.466667175293, -1.31714181771559, 218, 10, 'PPL', 'P'),
(17811, 'Riverside', 28.9950008392334, 0.506058231263142, -81.3633270263672, -1.42005794698699, 218, 12, 'PPL', 'P'),
(24403, 'Riverside', 33.0444412231445, 0.576734298825614, -85.129997253418, -1.48579874428587, 218, 13, 'PPL', 'P'),
(33783, 'Riverside', 37.6150016784668, 0.656505627432439, -97.3219375610352, -1.6985882448604, 218, 20, 'PPL', 'P'),
(37942, 'Riverside', 37.1588897705078, 0.648544972881001, -86.5436096191406, -1.51047093441464, 218, 21, 'PPL', 'P'),
(50881, 'Riverside', 38.7700004577637, 0.676664158987685, -76.2077789306641, -1.33007665797205, 218, 25, 'PPL', 'P'),
(57210, 'Riverside', 36.0424995422363, 0.629060287660573, -90.3372192382813, -1.57668191280397, 218, 29, 'PPL', 'P'),
(61550, 'Riverside', 34.5097198486328, 0.602308235299482, -89.3625030517578, -1.55966990607665, 218, 30, 'PPL', 'P'),
(68262, 'Riverside', 35.9119415283203, 0.626781620452874, -82.3466720581055, -1.43722055547396, 218, 33, 'PPL', 'P'),
(74087, 'Riverside', 39.7797203063965, 0.694287094869066, -84.1241683959961, -1.46824371901229, 218, 41, 'PPL', 'P'),
(83322, 'Riverside', 34.771110534668, 0.606870363404842, -80.8411102294922, -1.41094354447231, 218, 48, 'PPL', 'P'),
(90367, 'Riverside', 36.4863891601563, 0.636807623008695, -82.1972198486328, -1.43461212234428, 218, 50, 'PPL', 'P'),
(97543, 'Riverside', 30.8527793884277, 0.538482583719506, -95.4033279418945, -1.66510218994597, 218, 51, 'PPL', 'P'),
(105773, 'Riverside', 38.9013900756836, 0.678957340423325, -78.2138900756836, -1.3650899026136, 218, 53, 'PPL', 'P'),
(111139, 'Riverside', 39.2783317565918, 0.685536213843175, -81.5583267211914, -1.42346133370206, 218, 58, 'PPL', 'P'),
(113990, 'Riverside', 41.3880615234375, 0.722357944601965, -73.1730575561523, -1.27711077810617, 218, 8, 'PPL', 'P'),
(117549, 'Riverside', 42.5188903808594, 0.742094631440542, -96.4819412231445, -1.68392754305952, 218, 16, 'PPL', 'P'),
(121236, 'Riverside', 41.8349990844727, 0.730158476592861, -87.8227767944336, -1.53279661330694, 218, 18, 'PPL', 'P'),
(123559, 'Riverside', 40.6963882446289, 0.71028596853869, -85.0852813720703, -1.48501830492843, 218, 19, 'PPL', 'P'),
(125956, 'Riverside', 42.5361099243164, 0.742395169169557, -71.3041687011719, -1.24449251423294, 218, 23, 'PPL', 'P'),
(128666, 'Riverside', 44.3980598449707, 0.774892325792222, -69.7102813720703, -1.2166739324343, 218, 26, 'PPL', 'P'),
(132848, 'Riverside', 42.5588912963867, 0.742792779120306, -82.6302795410156, -1.44217043983403, 218, 27, 'PPL', 'P'),
(137735, 'Riverside', 46.7099990844727, 0.815243277627585, -92.2038879394531, -1.60926142768335, 218, 28, 'PPL', 'P'),
(140776, 'Riverside', 46.8861083984375, 0.8183169649997, -96.9000015258789, -1.69122407181412, 218, 34, 'PPL', 'P'),
(142856, 'Riverside', 41.0994415283203, 0.71732057540008, -96.3552780151367, -1.68171685303864, 218, 35, 'PPL', 'P'),
(144372, 'Riverside', 42.8824996948242, 0.748440811160146, -70.8238906860352, -1.23611008154386, 218, 36, 'PPL', 'P'),
(146185, 'Riverside', 40.9355583190918, 0.714460273810307, -74.1519393920898, -1.29419548913125, 218, 37, 'PPL', 'P'),
(152130, 'Riverside', 40.8811111450195, 0.71350999135434, -72.6783294677734, -1.26847614406186, 218, 40, 'PPL', 'P'),
(166528, 'Riverside', 40.9552803039551, 0.7148044873812, -76.6291732788086, -1.33743137679647, 218, 45, 'PPL', 'P'),
(169578, 'Riverside', 41.767219543457, 0.728975500436648, -71.3652801513672, -1.24555911024951, 218, 47, 'PPL', 'P'),
(171199, 'Riverside', 43.7227783203125, 0.763106439809049, -97.9480590820313, -1.70951612691938, 218, 49, 'PPL', 'P'),
(172462, 'Riverside', 43.7591705322266, 0.763741603729033, -72.7238922119141, -1.26927136396336, 218, 55, 'PPL', 'P'),
(176118, 'Riverside', 42.5938911437988, 0.743403641695343, -90.0224990844727, -1.57118900989763, 218, 57, 'PPL', 'P'),
(178988, 'Riverside', 33.105281829834, 0.577796167731256, -110.957221984863, -1.9365688525021, 218, 5, 'PPL', 'P'),
(189363, 'Riverside', 36.9824981689453, 0.64546635866087, -107.874717712402, -1.88276900374087, 218, 38, 'PPL', 'P'),
(190672, 'Riverside', 36.7361106872559, 0.641166085869692, -114.219718933105, -1.9935101660852, 218, 39, 'PPL', 'P'),
(193911, 'Riverside', 40.8638916015625, 0.713209453625324, -123.969436645508, -2.16367484130663, 218, 6, 'PPL', 'P'),
(194399, 'Riverside', 40.1755599975586, 0.701195800789923, -105.436668395996, -1.84021701584358, 218, 7, 'PPL', 'P'),
(195539, 'Riverside', 46.4955596923828, 0.811500604189642, -116.29638671875, -2.02975485641479, 218, 17, 'PPL', 'P'),
(197393, 'Riverside', 46.2747192382813, 0.80764621114397, -114.157218933105, -1.9924193353027, 218, 31, 'PPL', 'P'),
(201482, 'Riverside', 43.5416717529297, 0.759945533911234, -118.158058166504, -2.06224715276847, 218, 43, 'PPL', 'P'),
(205553, 'Riverside', 41.797779083252, 0.729508865023964, -111.930000305176, -1.95354703708358, 218, 52, 'PPL', 'P'),
(208570, 'Riverside', 48.1141700744629, 0.839750684663903, -122.000831604004, -2.12931620166102, 218, 56, 'PPL', 'P'),
(209698, 'Riverside', 41.2174987792969, 0.719381063135474, -106.778327941895, -1.86363339236032, 218, 59, 'PPL', 'P'),
(57202, 'Riverside (historical)', 37.2383308410645, 0.649931481123524, -90.7702789306641, -1.58424023029373, 218, 29, 'PPL', 'P'),
(90368, 'Riverside (historical)', 36.038890838623, 0.628997303900793, -89.1063919067383, -1.55519992334501, 218, 50, 'PPL', 'P'),
(111140, 'Riverside (historical)', 39.5769386291504, 0.690747886938405, -78.8233337402344, -1.37572670116543, 218, 58, 'PPL', 'P'),
(142857, 'Riverside (historical)', 41.8805618286133, 0.730953696494359, -96.1486129760742, -1.67810986765824, 218, 35, 'PPL', 'P'),
(171200, 'Riverside (historical)', 43.0194396972656, 0.750830865080438, -97.0055618286133, -1.69306644665623, 218, 49, 'PPL', 'P'),
(195540, 'Riverside (historical)', 48.1788902282715, 0.84088026444026, -116.755561828613, -2.03776897392511, 218, 17, 'PPL', 'P'),
(197395, 'Riverside (historical)', 48.2622184753418, 0.842334616711552, -106.737503051758, -1.86292086361067, 218, 31, 'PPL', 'P'),
(200162, 'Riverside (historical)', 41.7272186279297, 0.728277352756884, -114.808326721191, -2.00378330999018, 218, 39, 'PPL', 'P'),
(17812, 'Riverside Acres', 28.6358299255371, 0.499789516241745, -81.4155578613281, -1.42096954702813, 218, 12, 'PPL', 'P'),
(178989, 'Riverside Acres', 33.8452796936035, 0.590711566911759, -111.303886413574, -1.94261928818265, 218, 5, 'PPL', 'P'),
(192116, 'Riverside Acres Colonia', 28.617000579834, 0.499460882163229, -100.444000244141, -1.75307851813424, 218, 51, 'PPL', 'P'),
(37943, 'Riverside Beach', 38.327220916748, 0.668936198136493, -85.6452789306641, -1.49479210612902, 218, 21, 'PPL', 'P'),
(171201, 'Riverside Colony', 44.4863891601563, 0.776433963168242, -98.1388931274414, -1.71284680933669, 218, 49, 'PPL', 'P'),
(97544, 'Riverside Crest', 30.0163898468018, 0.523884832388887, -95.2369384765625, -1.66219814593529, 218, 51, 'PPL', 'P'),
(5428, 'Riverside Estates', 33.6438903808594, 0.587196660326045, -87.0625, -1.51952728001756, 218, 2, 'PPL', 'P'),
(24407, 'Riverside Estates', 33.6097183227539, 0.586600245399922, -83.904167175293, -1.46440397335261, 218, 13, 'PPL', 'P'),
(50882, 'Riverside Estates', 39.1761093139648, 0.683752095649903, -76.8902816772461, -1.34198857805381, 218, 25, 'PPL', 'P'),
(105775, 'Riverside Estates', 37.2783317565918, 0.650629628803288, -80.102783203125, -1.39805730690574, 218, 53, 'PPL', 'P'),
(97545, 'Riverside Estates Colonia', 26.2339992523193, 0.457869662918703, -98.4100036621094, -1.71757858080349, 218, 51, 'PPL', 'P'),
(83323, 'Riverside Forest', 34.0391693115234, 0.594095579129895, -81.0800018310547, -1.41511298947494, 218, 48, 'PPL', 'P'),
(37949, 'Riverside Gardens', 38.1922187805176, 0.666579966362045, -85.8724975585938, -1.49875781930825, 218, 21, 'PPL', 'P'),
(105776, 'Riverside Gardens', 38.725830078125, 0.675893240431134, -77.0644378662109, -1.34502817696397, 218, 53, 'PPL', 'P'),
(184596, 'Riverside Grove', 37.1738891601563, 0.648806761616156, -122.142219543457, -2.13178388672709, 218, 6, 'PPL', 'P'),
(137736, 'Riverside Heights', 43.6647186279297, 0.762093107014274, -94.1102828979492, -1.64253429655252, 218, 28, 'PPL', 'P'),
(57203, 'Riverside Inn', 36.5672187805176, 0.638218366017137, -94.4283294677734, -1.64808525637063, 218, 29, 'PPL', 'P'),
(61551, 'Riverside Junction', 32.9313888549805, 0.574761162773975, -90.8727798461914, -1.58602920875599, 218, 30, 'PPL', 'P'),
(152131, 'Riverside Junction', 42.0808296203613, 0.734449028846061, -78.6419372558594, -1.37256073526154, 218, 40, 'PPL', 'P'),
(184597, 'Riverside Junction', 33.985279083252, 0.593155017211907, -117.360282897949, -2.04832334764121, 218, 6, 'PPL', 'P'),
(152132, 'Riverside Manors', 43.1855583190918, 0.75373018198018, -79.0466690063477, -1.37962463689492, 218, 40, 'PPL', 'P'),
(142858, 'Riverside Mobile Home Court', 40.6986083984375, 0.710324717532551, -99.1111068725586, -1.72981514022213, 218, 35, 'PPL', 'P'),
(121237, 'Riverside Mobile Home Estates', 41.774169921875, 0.729096807424301, -89.7416687011719, -1.56628759506939, 218, 18, 'PPL', 'P'),
(111141, 'Riverside Mobile Home Park', 38.4980583190918, 0.671917873292946, -81.8441696166992, -1.42845023337211, 218, 58, 'PPL', 'P'),
(24412, 'Riverside Park', 33.4777793884277, 0.584297476584358, -83.942497253418, -1.46507295941844, 218, 13, 'PPL', 'P'),
(90370, 'Riverside Park', 35.0688896179199, 0.612067588851159, -85.2675018310547, -1.4881986519022, 218, 50, 'PPL', 'P'),
(142860, 'Riverside Park', 40.7874984741211, 0.711876142025576, -97.0508270263672, -1.69385647339361, 218, 35, 'PPL', 'P'),
(146186, 'Riverside Park', 40.038330078125, 0.69880068686356, -74.9749984741211, -1.30856058005114, 218, 37, 'PPL', 'P'),
(152133, 'Riverside Park', 41.9152793884277, 0.731559632221379, -74.0769424438477, -1.29288654545548, 218, 40, 'PPL', 'P'),
(157389, 'Riverside Park', 40.3794403076172, 0.704754183480432, -81.4030609130859, -1.42075143413485, 218, 41, 'PPL', 'P'),
(193912, 'Riverside Park', 40.4952812194824, 0.706775988800993, -123.991668701172, -2.16406286387745, 218, 6, 'PPL', 'P'),
(200163, 'Riverside Park (historical)', 41.9708290100098, 0.732529156016222, -114.626670837402, -2.00061281671244, 218, 39, 'PPL', 'P'),
(24413, 'Riverside Station', 33.6725006103516, 0.587696003030435, -84.2611083984375, -1.47063377293258, 218, 13, 'PPL', 'P'),
(74088, 'Riverside Terrace', 38.4580612182617, 0.671219792192209, -82.3222198486328, -1.43679378390927, 218, 41, 'PPL', 'P'),
(97546, 'Riverside Terrace', 29.7083301544189, 0.518508176464126, -95.3566665649414, -1.66428779528462, 218, 51, 'PPL', 'P'),
(137737, 'Riverside Terrace Mobile Court', 44.5152816772461, 0.776938232720648, -92.8958282470703, -1.62133806427853, 218, 28, 'PPL', 'P'),
(197400, 'Riverside Trailer Court', 48.3611106872559, 0.844060611414032, -107.873611450195, -1.88274969582296, 218, 31, 'PPL', 'P'),
(50885, 'Riverside Village of Church Creek', 39.4736099243164, 0.688944460827231, -76.2355575561523, -1.3305614864485, 218, 25, 'PPL', 'P'),
(24414, 'Riversong', 33.9755592346191, 0.592985373850469, -84.2994384765625, -1.47130275899841, 218, 13, 'PPL', 'P'),
(121239, 'Riverstream', 42.3380584716797, 0.738938519232689, -88.2577819824219, -1.54038888610059, 218, 18, 'PPL', 'P'),
(113991, 'Riversville', 41.0611114501953, 0.716651589334252, -73.6755599975586, -1.28588110020802, 218, 8, 'PPL', 'P'),
(5429, 'Riverton', 34.8805618286133, 0.608780648854756, -88.0766677856445, -1.53722784704472, 218, 2, 'PPL', 'P'),
(28426, 'Riverton', 39.8441696166992, 0.695411947534488, -89.539436340332, -1.56275797451866, 218, 18, 'PPL', 'P'),
(30980, 'Riverton', 39.0202789306641, 0.68103234238666, -87.5677795410156, -1.52834607165125, 218, 19, 'PPL', 'P'),
(33786, 'Riverton', 37.0750007629395, 0.647080833492703, -94.7044372558594, -1.65290424636313, 218, 20, 'PPL', 'P'),
(42826, 'Riverton', 32.1605606079102, 0.561307671895221, -92.0961074829102, -1.60738030384737, 218, 22, 'PPL', 'P'),
(50887, 'Riverton', 38.5111083984375, 0.672145640145175, -75.7547225952148, -1.32216933322144, 218, 25, 'PPL', 'P'),
(57204, 'Riverton', 36.6483306884766, 0.639634035873596, -91.2013931274414, -1.59176459247958, 218, 29, 'PPL', 'P'),
(61552, 'Riverton', 34.1930618286133, 0.596781510247295, -90.5791702270508, -1.58090475418646, 218, 30, 'PPL', 'P'),
(90371, 'Riverton', 36.4502792358398, 0.636177385936728, -85.0872192382813, -1.48505212707427, 218, 50, 'PPL', 'P'),
(105777, 'Riverton', 38.9463882446289, 0.679742706628789, -78.1997222900391, -1.36484262810638, 218, 53, 'PPL', 'P'),
(111142, 'Riverton', 38.7438888549805, 0.676208425546145, -79.4361114501953, -1.38642168978708, 218, 58, 'PPL', 'P'),
(113992, 'Riverton', 41.9627799987793, 0.732388674268721, -73.017219543457, -1.27439089168488, 218, 8, 'PPL', 'P'),
(117552, 'Riverton', 40.686939239502, 0.710121052288187, -95.5683288574219, -1.66798199919072, 218, 16, 'PPL', 'P'),
(128667, 'Riverton', 43.6994400024414, 0.762699109320321, -70.3166732788086, -1.22725746776433, 218, 26, 'PPL', 'P'),
(137739, 'Riverton', 46.4599990844727, 0.810879954497599, -94.0516662597656, -1.64151124321977, 218, 28, 'PPL', 'P'),
(142863, 'Riverton', 40.0894393920898, 0.699692712670682, -98.7586135864258, -1.72366297178794, 218, 35, 'PPL', 'P'),
(144373, 'Riverton', 44.4455604553223, 0.775721367839564, -71.5294418334961, -1.24842427210828, 218, 36, 'PPL', 'P'),
(146190, 'Riverton', 40.0113906860352, 0.698330505773106, -75.0152816772461, -1.30926365457892, 218, 37, 'PPL', 'P'),
(166531, 'Riverton', 40.8277816772461, 0.712579216553357, -75.0863876342773, -1.3105046876469, 218, 45, 'PPL', 'P'),
(184598, 'Riverton', 38.771110534668, 0.676683533484615, -120.448333740234, -2.10222000230807, 218, 6, 'PPL', 'P'),
(192117, 'Riverton', 31.7533302307129, 0.554200160998991, -103.771110534668, -1.81114754728093, 218, 51, 'PPL', 'P'),
(201483, 'Riverton', 43.1575012207031, 0.753240493234742, -124.273330688477, -2.16897879293363, 218, 43, 'PPL', 'P'),
(205561, 'Riverton', 40.5219383239746, 0.70724124304343, -111.938331604004, -1.95369244567909, 218, 52, 'PPL', 'P'),
(208571, 'Riverton', 47.4844398498535, 0.828759818845146, -122.293327331543, -2.1344212151546, 218, 56, 'PPL', 'P'),
(209699, 'Riverton', 43.0250015258789, 0.750927937302171, -108.379440307617, -1.89157807483658, 218, 59, 'PPL', 'P'),
(50888, 'Riverton Acres', 38.5047187805176, 0.672034120274528, -75.7430572509766, -1.32196573455611, 218, 25, 'PPL', 'P'),
(208572, 'Riverton Heights', 47.4691696166992, 0.828493302999056, -122.300277709961, -2.13454252214225, 218, 56, 'PPL', 'P'),
(105778, 'Riverton Junction', 38.9416694641113, 0.679660348372078, -78.1894378662109, -1.36466313104891, 218, 53, 'PPL', 'P'),
(61553, 'Riverton Landing', 33.8197212219238, 0.590265487429171, -91.0208282470703, -1.58861314080364, 218, 30, 'PPL', 'P'),
(205567, 'Riverton Siding', 40.526668548584, 0.707323801037222, -111.90389251709, -1.95309137022106, 218, 52, 'PPL', 'P'),
(24415, 'Rivertown', 33.6155586242676, 0.586702177890645, -84.7375030517578, -1.47894842817192, 218, 13, 'PPL', 'P'),
(90373, 'Rivertrace', 35.8519401550293, 0.625734398933227, -83.9613876342773, -1.46540265876139, 218, 50, 'PPL', 'P'),
(24416, 'Riverturn', 30.9897193908691, 0.540872637639798, -84.9475021362305, -1.48261360362214, 218, 13, 'PPL', 'P'),
(11611, 'Rivervale', 35.6738891601563, 0.622626822836241, -90.3399963378906, -1.57673038233581, 218, 4, 'PPL', 'P'),
(30981, 'Rivervale', 38.7688903808594, 0.676644784490754, -86.398063659668, -1.50793067820887, 218, 19, 'PPL', 'P'),
(146192, 'Rivervale', 41.0094413757324, 0.715749776410124, -74.0116729736328, -1.29174737829919, 218, 37, 'PPL', 'P'),
(5431, 'Riverview', 33.2197189331055, 0.579793471969788, -87.5283279418945, -1.52765751135141, 218, 2, 'PPL', 'P'),
(11613, 'Riverview', 35.7419395446777, 0.623814526103389, -91.6558303833008, -1.59969601883805, 218, 4, 'PPL', 'P'),
(14499, 'Riverview', 38.5825004577637, 0.673391666640195, -75.2750015258789, -1.31379662107034, 218, 10, 'PPL', 'P'),
(24418, 'Riverview', 33.0522193908691, 0.576870053462181, -85.1624984741211, -1.48636599759806, 218, 13, 'PPL', 'P'),
(30983, 'Riverview', 39.2002792358398, 0.684173940366572, -87.583610534668, -1.52862237461435, 218, 19, 'PPL', 'P'),
(33787, 'Riverview', 37.7758293151855, 0.659312599221383, -97.3497161865234, -1.69907307333685, 218, 20, 'PPL', 'P'),
(37945, 'Riverview', 37.0294418334961, 0.646285680170233, -88.5344390869141, -1.54521746347301, 218, 21, 'PPL', 'P'),
(42827, 'Riverview', 30.461109161377, 0.531646648675437, -90.9958267211914, -1.58817678185903, 218, 22, 'PPL', 'P'),
(50890, 'Riverview', 39.1450004577637, 0.683209143682664, -76.0644378662109, -1.32757488444403, 218, 25, 'PPL', 'P'),
(57206, 'Riverview', 38.7477798461914, 0.676276336153942, -90.2113876342773, -1.57448573701104, 218, 29, 'PPL', 'P'),
(61554, 'Riverview', 34.2836112976074, 0.598361896617175, -90.248893737793, -1.57514034200698, 218, 30, 'PPL', 'P'),
(68264, 'Riverview', 34.1875, 0.596684438025561, -78.5583267211914, -1.37110145614223, 218, 33, 'PPL', 'P'),
(83326, 'Riverview', 35.002498626709, 0.610908847460865, -80.9800033569336, -1.41336768685455, 218, 48, 'PPL', 'P'),
(105781, 'Riverview', 36.9352798461914, 0.644642243461545, -82.4819412231445, -1.43958144778031, 218, 53, 'PPL', 'P'),
(111143, 'Riverview', 38.3347206115723, 0.66906709250407, -81.5966720581055, -1.424130586084, 218, 58, 'PPL', 'P'),
(112256, 'Riverview', 30.5424995422363, 0.533067178800885, -87.1966705322266, -1.52186899756407, 218, 12, 'PPL', 'P'),
(112568, 'Riverview', 36.122501373291, 0.630456583020102, -82.4444427490234, -1.43892697594242, 218, 50, 'PPL', 'P'),
(125958, 'Riverview', 42.3722190856934, 0.73953473442173, -71.2444381713867, -1.24345001982423, 218, 23, 'PPL', 'P'),
(132852, 'Riverview', 42.1741714477539, 0.736078151063889, -83.179443359375, -1.45175515659723, 218, 27, 'PPL', 'P'),
(142864, 'Riverview', 42.7291717529297, 0.74576473373878, -99.5891723632813, -1.7381589570754, 218, 35, 'PPL', 'P'),
(152134, 'Riverview', 44.5827789306641, 0.778116282028845, -73.9069366455078, -1.28991938452696, 218, 40, 'PPL', 'P'),
(157390, 'Riverview', 40.0577812194824, 0.699140173323518, -80.7352828979492, -1.40909650909828, 218, 41, 'PPL', 'P'),
(166536, 'Riverview', 40.1933288574219, 0.701505925898862, -79.9158325195313, -1.39479440193818, 218, 45, 'PPL', 'P'),
(176119, 'Riverview', 46.6763916015625, 0.814656716397495, -92.1849975585938, -1.6089317283404, 218, 57, 'PPL', 'P'),
(187265, 'Riverview', 39.3974990844727, 0.687616076075499, -105.267501831055, -1.83726450230106, 218, 7, 'PPL', 'P'),
(193913, 'Riverview', 40.922779083252, 0.714237234069013, -122.401672363281, -2.13631219268661, 218, 6, 'PPL', 'P'),
(197401, 'Riverview', 47.6741714477539, 0.832071259923577, -104.174438476563, -1.81818694783228, 218, 31, 'PPL', 'P'),
(208574, 'Riverview', 46.2458305358887, 0.807142008170591, -119.16667175293, -2.07985078073195, 218, 56, 'PPL', 'P'),
(5432, 'Riverview (historical)', 34.6547203063965, 0.604838970704357, -87.0875015258789, -1.51996363896217, 218, 2, 'PPL', 'P'),
(50891, 'Riverview (historical)', 39.2574996948242, 0.685172625775352, -76.540283203125, -1.33587995230344, 218, 25, 'PPL', 'P'),
(184601, 'Riverview (historical)', 36.8519401550293, 0.643187691453171, -119.856109619141, -2.09188374148525, 218, 6, 'PPL', 'P'),
(201484, 'Riverview (historical)', 45.6641693115234, 0.796990104674236, -122.819442749023, -2.14360366143513, 218, 43, 'PPL', 'P'),
(30984, 'Riverview Acres', 39.2422218322754, 0.684905976771208, -85.9211120605469, -1.49960630243155, 218, 19, 'PPL', 'P'),
(205568, 'Riverview Acres', 40.6463890075684, 0.709413317228498, -111.906387329102, -1.95313491290489, 218, 52, 'PPL', 'P'),
(197402, 'Riverview Colony', 48.1772193908691, 0.840851102826323, -111.030563354492, -1.93784890088005, 218, 31, 'PPL', 'P'),
(37946, 'Riverview Estates', 37.7566719055176, 0.658978239346523, -84.8694381713867, -1.48125113040845, 218, 21, 'PPL', 'P'),
(50892, 'Riverview Estates', 38.7400016784668, 0.676140581517375, -77.0250015258789, -1.34433988298024, 218, 25, 'PPL', 'P'),
(61555, 'Riverview Estates', 30.8708305358887, 0.538797635676463, -88.7750015258789, -1.54941607008958, 218, 30, 'PPL', 'P'),
(71338, 'Riverview Estates', 39.9602813720703, 0.697438479965984, -74.2233276367188, -1.29544144904724, 218, 37, 'PPL', 'P'),
(74092, 'Riverview Estates', 38.4416694641113, 0.670933702112107, -82.3569412231445, -1.43739978621532, 218, 41, 'PPL', 'P'),
(105782, 'Riverview Estates', 38.7083282470703, 0.675587775854102, -77.3958282470703, -1.35081203021941, 218, 53, 'PPL', 'P'),
(184602, 'Riverview Farms', 32.8450012207031, 0.573253414122826, -116.931106567383, -2.04083280760119, 218, 6, 'PPL', 'P'),
(14500, 'Riverview Gardens', 39.8197212219238, 0.69498524254883, -75.460563659668, -1.31703529127199, 218, 10, 'PPL', 'P'),
(186, 'Riverview Heights', 39.0758285522461, 0.682001866181503, -80.4672164916992, -1.40441786769523, 218, 58, 'PPL', 'P'),
(74093, 'Riverview Heights', 39.0525016784668, 0.681594735429857, -84.4030609130859, -1.47311131169468, 218, 41, 'PPL', 'P'),
(105784, 'Riverview Landing', 37.5658302307129, 0.655647423771161, -76.9541702270508, -1.34310364360223, 218, 53, 'PPL', 'P'),
(125959, 'Riverview Landing', 42.6277809143066, 0.74399512977345, -70.6888885498047, -1.23375384976941, 218, 23, 'PPL', 'P'),
(50894, 'Riverview Manor', 38.9980583190918, 0.680644519552917, -76.5088882446289, -1.33533200690916, 218, 25, 'PPL', 'P'),
(146193, 'Riverview Manor', 40.5152816772461, 0.707125062640875, -74.4749984741211, -1.29983393379117, 218, 37, 'PPL', 'P'),
(113993, 'Riverview Mobile Home Estates', 41.5113906860352, 0.724510444553021, -73.054443359375, -1.2750405698328, 218, 8, 'PPL', 'P'),
(83327, 'Riverview Park', 35.0283317565918, 0.611359720633416, -81.8433303833008, -1.42843558598611, 218, 48, 'PPL', 'P'),
(137741, 'Riverview Park', 45.5638885498047, 0.795239875205836, -94.2305603027344, -1.64463353328178, 218, 28, 'PPL', 'P'),
(157392, 'Riverview Park Subdivision', 41.0833282470703, 0.717039345588967, -84.7091674804688, -1.47845387915749, 218, 41, 'PPL', 'P'),
(157393, 'Riverview Trailer Court', 41.4244384765625, 0.722992842205839, -83.834716796875, -1.46319183558246, 218, 41, 'PPL', 'P'),
(197403, 'Riverview Trailer Park', 47.1949996948242, 0.823708135152402, -114.885276794434, -2.0051263421279, 218, 31, 'PPL', 'P'),
(50895, 'Riverview Village', 38.6055603027344, 0.673794136859934, -77.1661071777344, -1.34680264119829, 218, 25, 'PPL', 'P'),
(105785, 'Riverville', 37.5250015258789, 0.654934828442483, -78.8969421386719, -1.37701141007528, 218, 53, 'PPL', 'P'),
(83329, 'Riverwind', 32.3941688537598, 0.565384904945105, -80.6833267211914, -1.40818970274711, 218, 48, 'PPL', 'P'),
(125960, 'Riverwind Estates', 42.0894393920898, 0.734599297710568, -70.8547210693359, -1.23664817324211, 218, 23, 'PPL', 'P'),
(5433, 'Riverwood', 33.4130592346191, 0.583167896808001, -86.7380599975586, -1.51386473374978, 218, 2, 'PPL', 'P'),
(24425, 'Riverwood', 33.1236114501953, 0.578116079957202, -85.0602798461914, -1.48458194598382, 218, 13, 'PPL', 'P'),
(37947, 'Riverwood', 38.2830581665039, 0.668165412737997, -85.6616668701172, -1.49507812963009, 218, 21, 'PPL', 'P'),
(50898, 'Riverwood', 39.0722198486328, 0.681938882421723, -77.3041687011719, -1.3492122693526, 218, 25, 'PPL', 'P'),
(90380, 'Riverwood', 35.9333305358887, 0.627154929058676, -86.3211135864258, -1.50658764607114, 218, 50, 'PPL', 'P'),
(105787, 'Riverwood', 38.704719543457, 0.675524792094322, -77.0955581665039, -1.3455713286683, 218, 53, 'PPL', 'P'),
(123560, 'Riverwood', 40.1005592346191, 0.699886790535121, -85.9680633544922, -1.50042575709897, 218, 19, 'PPL', 'P'),
(201485, 'Riverwood', 45.4441719055176, 0.793150425593587, -122.662498474121, -2.14086446709593, 218, 43, 'PPL', 'P'),
(205570, 'Riverwood', 40.6124992370605, 0.708821829150392, -111.847778320313, -1.95211199273019, 218, 52, 'PPL', 'P'),
(176122, 'Riverwood Estates', 42.9005584716797, 0.748755996275157, -89.2149963378906, -1.55709542825087, 218, 57, 'PPL', 'P'),
(50899, 'Riverwood Farms', 38.4066696166992, 0.67032283953707, -76.6208267211914, -1.33728570188484, 218, 25, 'PPL', 'P'),
(50900, 'Riverwood Park', 39.311939239502, 0.686122775073265, -76.4444427490234, -1.33420722082276, 218, 25, 'PPL', 'P'),
(121242, 'Riverwoods', 42.1674995422363, 0.735961704345226, -87.8969421386719, -1.53409104275477, 218, 18, 'PPL', 'P'),
(50901, 'Rives', 38.9313888549805, 0.679480917893634, -76.9569396972656, -1.34315197997601, 218, 25, 'PPL', 'P'),
(57207, 'Rives', 36.0936088562012, 0.629952313467695, -90.0133285522461, -1.57102895391612, 218, 29, 'PPL', 'P'),
(90381, 'Rives', 36.3555603027344, 0.634524228690061, -89.0480575561523, -1.55418179686027, 218, 50, 'PPL', 'P'),
(132854, 'Rives Junction', 42.3858299255371, 0.739772288390966, -84.461669921875, -1.47413423186938, 218, 27, 'PPL', 'P'),
(111144, 'Rivesville', 39.5297203063965, 0.68992377173908, -80.116943359375, -1.3983044482549, 218, 58, 'PPL', 'P'),
(97547, 'Riviera', 27.2983303070068, 0.476445744154224, -97.8147201538086, -1.70718892360081, 218, 51, 'PPL', 'P'),
(178990, 'Riviera', 35.100830078125, 0.61262505504634, -114.620559692383, -2.00050615711078, 218, 5, 'PPL', 'P'),
(184603, 'Riviera', 34.0577812194824, 0.594420418203858, -118.500556945801, -2.06822488415126, 218, 6, 'PPL', 'P'),
(184604, 'Riviera (historical)', 39.3016700744629, 0.685943544331902, -121.661392211914, -2.12339186665809, 218, 6, 'PPL', 'P'),
(17815, 'Riviera Beach', 26.7749996185303, 0.467311900563579, -80.0583267211914, -1.39728139492215, 218, 12, 'PPL', 'P'),
(50902, 'Riviera Beach', 39.1666717529297, 0.683587379136482, -76.5083312988281, -1.33532228637118, 218, 25, 'PPL', 'P'),
(97548, 'Riviera Beach', 27.2887706756592, 0.47627889711193, -97.6667709350586, -1.70460672260787, 218, 51, 'PPL', 'P'),
(146194, 'Riviera Beach', 40.0977783203125, 0.699838254424255, -74.1005630493164, -1.29329880279222, 218, 37, 'PPL', 'P'),
(205571, 'Riviera Condo', 40.6158294677734, 0.708879952641183, -111.823608398438, -1.95169014801352, 218, 52, 'PPL', 'P'),
(184605, 'Riviera Estates', 38.9808311462402, 0.680343848665847, -122.743057250977, -2.14227048299344, 218, 6, 'PPL', 'P'),
(205572, 'Riviera Heights', 40.6202812194824, 0.708957650365986, -111.819717407227, -1.95162223740572, 218, 52, 'PPL', 'P'),
(50903, 'Riviera Isle', 39.1386108398438, 0.683097623812017, -76.5208282470703, -1.33554039926446, 218, 25, 'PPL', 'P'),
(17816, 'Riviera Lagoons', 26.8824996948242, 0.469188130841053, -82.003059387207, -1.43122338301521, 218, 12, 'PPL', 'P'),
(178991, 'Riviera Mobile Home Park', 33.4541702270508, 0.583885418984695, -111.908889770508, -1.95317858874676, 218, 5, 'PPL', 'P'),
(184606, 'Riviera Mobile Home Park', 33.0622215270996, 0.577044623671636, -117.298889160156, -2.04725182477661, 218, 6, 'PPL', 'P'),
(71339, 'Riviera on the Barnegat', 39.8491706848145, 0.695499232639216, -74.1750030517578, -1.29459802593002, 218, 37, 'PPL', 'P'),
(146195, 'Riviera on the Bay', 40.0022201538086, 0.698170449791592, -74.1291732788086, -1.29379814549661, 218, 37, 'PPL', 'P'),
(74094, 'Riviera Park', 39.1019401550293, 0.682457599623043, -83.023063659668, -1.44902581595406, 218, 41, 'PPL', 'P'),
(184607, 'Riviera Shores', 32.7844390869141, 0.572196405486174, -117.238609313965, -2.04619974298798, 218, 6, 'PPL', 'P'),
(184609, 'Riviera West', 38.9891700744629, 0.68048939041942, -122.747222900391, -2.1423431872912, 218, 6, 'PPL', 'P'),
(24426, 'Rivoli (historical)', 32.8766708374023, 0.573806153207072, -83.7147216796875, -1.46109752570122, 218, 13, 'PPL', 'P'),
(24427, 'Rivoli Plantation', 32.9049987792969, 0.574300569063445, -83.7513885498047, -1.46173748331117, 218, 13, 'PPL', 'P'),
(74095, 'Rix Mills', 39.9241714477539, 0.696808242894017, -81.7463912963867, -1.42674367974558, 218, 41, 'PPL', 'P'),
(11614, 'Rixey', 34.8158302307129, 0.607650869341317, -92.1688919067383, -1.60865063168734, 218, 4, 'PPL', 'P'),
(105789, 'Rixey', 38.0788917541504, 0.664602036620443, -77.3824996948242, -1.35057940309819, 218, 53, 'PPL', 'P'),
(105790, 'Rixeyville', 38.579719543457, 0.673343130529329, -77.9791717529297, -1.36099329506678, 218, 53, 'PPL', 'P'),
(17817, 'Rixford', 30.3530597686768, 0.529760831018038, -82.9641723632813, -1.44799796893134, 218, 12, 'PPL', 'P'),
(166537, 'Rixford', 41.9261093139648, 0.731748650079748, -78.4944381713867, -1.36998639059382, 218, 45, 'PPL', 'P'),
(200164, 'Rixies', 40.6977806091309, 0.710310269883637, -116.550559997559, -2.03419101700059, 218, 39, 'PPL', 'P'),
(105791, 'Rixlew', 38.7608299255371, 0.676504103006171, -77.5061111450195, -1.35273682989726, 218, 53, 'PPL', 'P'),
(61556, 'Rixwood', 33.6105613708496, 0.586614959364945, -90.3486099243164, -1.57688071777935, 218, 30, 'PPL', 'P'),
(97298, 'RLDS Colonia', 26.2889995574951, 0.458829599333622, -98.2620010375977, -1.71499544770416, 218, 51, 'PPL', 'P'),
(17818, 'Ro-Len Lake Gardens', 25.9775009155273, 0.453392922415793, -80.165283203125, -1.39914813768824, 218, 12, 'PPL', 'P'),
(17819, 'Roach', 30.1111106872559, 0.525538022925067, -83.7247161865234, -1.46127196275262, 218, 12, 'PPL', 'P'),
(57209, 'Roach', 37.9938888549805, 0.663118456156188, -92.8361129760742, -1.62029583618593, 218, 29, 'PPL', 'P'),
(97549, 'Roach', 33.0694389343262, 0.577170591191197, -94.2716674804688, -1.64535098887945, 218, 51, 'PPL', 'P'),
(190673, 'Roach', 35.6408309936523, 0.622049848986076, -115.358329772949, -2.01338267413937, 218, 39, 'PPL', 'P'),
(199654, 'Roach', 42.0222206115723, 0.733426108671361, -103.933609008789, -1.81398368068381, 218, 35, 'PPL', 'P'),
(30985, 'Roachdale', 39.8488883972168, 0.695494305791199, -86.8022232055664, -1.51498459298816, 218, 19, 'PPL', 'P'),
(28427, 'Roaches', 38.3250007629395, 0.668897449142632, -89.0761108398438, -1.55467141902668, 218, 18, 'PPL', 'P'),
(105792, 'Roaches Corner', 37.3908309936523, 0.652593110895976, -77.0530624389648, -1.34482963830471, 218, 53, 'PPL', 'P'),
(74096, 'Roachester', 39.3566703796387, 0.686903480746822, -84.0969390869141, -1.46776847791576, 218, 41, 'PPL', 'P'),
(157394, 'Roachton', 41.5222206115723, 0.72469946241139, -83.6624984741211, -1.46018605881815, 218, 41, 'PPL', 'P'),
(28428, 'Roachtown', 38.4630584716797, 0.671307010717909, -90.0408325195313, -1.5715089887026, 218, 18, 'PPL', 'P'),
(37948, 'Roachville', 37.2405586242676, 0.649970363275439, -85.4236068725586, -1.4909231988554, 218, 21, 'PPL', 'P'),
(74097, 'Road Fork', 39.6672210693359, 0.692323612776378, -81.309440612793, -1.41911745164803, 218, 41, 'PPL', 'P'),
(37950, 'Road Junction', 37.3541717529297, 0.651953286444085, -82.3858337402344, -1.43790405576772, 218, 21, 'PPL', 'P'),
(178992, 'Road Junction Windmill', 34.0102806091309, 0.593591376156516, -111.955001831055, -1.95398339602818, 218, 5, 'PPL', 'P'),
(55, 'Road Runner Colonia Number 2', 26.1599998474121, 0.456578129658556, -98.1019973754883, -1.71220285698511, 218, 51, 'PPL', 'P'),
(184610, 'Roadamite (historical)', 34.8438911437988, 0.608140624665783, -120.324996948242, -2.10006736919896, 218, 6, 'PPL', 'P'),
(30986, 'Roadman Corner', 39.4741706848145, 0.688954247944237, -87.0338897705078, -1.51902793731317, 218, 19, 'PPL', 'P'),
(178993, 'Roadrunner Mobile Home Park', 33.4013900756836, 0.582964231563637, -112.074996948242, -1.95607770590942, 218, 5, 'PPL', 'P'),
(57211, 'Roads', 39.4666709899902, 0.68882335357666, -93.7011108398438, -1.63539289693142, 218, 29, 'PPL', 'P'),
(74098, 'Roads', 39.0811080932617, 0.68209401155522, -82.5380630493164, -1.44056095842924, 218, 41, 'PPL', 'P'),
(184611, 'Roads End', 35.9266700744629, 0.627038682077094, -118.498329162598, -2.06818600199934, 218, 6, 'PPL', 'P'),
(201486, 'Roads End', 45.0063896179199, 0.785509683268095, -124.005828857422, -2.16431000522661, 218, 43, 'PPL', 'P'),
(61558, 'Roadside', 32.788890838623, 0.572274103210977, -90.3319396972656, -1.57658976743025, 218, 30, 'PPL', 'P'),
(79033, 'Roadside', 39.7633285522461, 0.694001004788964, -77.5319366455078, -1.35318756991176, 218, 45, 'PPL', 'P'),
(71340, 'Roadstown', 39.4408302307129, 0.688372347246055, -75.3186111450195, -1.31455775250989, 218, 37, 'PPL', 'P'),
(152135, 'Roah Hook', 42.4838905334473, 0.741483768865505, -73.7897186279297, -1.28787354417757, 218, 40, 'PPL', 'P'),
(157395, 'Roaming Shores', 41.6430587768555, 0.726808486257651, -80.8236083984375, -1.41063807989528, 218, 41, 'PPL', 'P'),
(17820, 'Roan', 28.5527801513672, 0.498340024239442, -81.682502746582, -1.42562861419717, 218, 12, 'PPL', 'P'),
(137742, 'Roan', 48.1500015258789, 0.840376061466881, -96.7430572509766, -1.68848487747492, 218, 28, 'PPL', 'P'),
(90383, 'Roan Hill', 36.3050003051758, 0.633641790262863, -82.345832824707, -1.43720590808796, 218, 50, 'PPL', 'P'),
(90384, 'Roan Mountain', 36.1961097717285, 0.631741291929956, -82.070556640625, -1.4324014323234, 218, 50, 'PPL', 'P'),
(97550, 'Roane', 32.1738891601563, 0.56154029901644, -96.379997253418, -1.68214828513524, 218, 51, 'PPL', 'P'),
(105793, 'Roane', 37.4480590820313, 0.653591929462811, -76.7055587768555, -1.33876455523816, 218, 53, 'PPL', 'P'),
(105794, 'Roanes', 37.3691711425781, 0.65221507517924, -76.5066680908203, -1.3352932579153, 218, 53, 'PPL', 'P'),
(123564, 'Roann', 40.9116706848145, 0.714043355941655, -85.9244384765625, -1.49966435934332, 218, 19, 'PPL', 'P'),
(68267, 'Roanoac (historical)', 35.9436111450195, 0.62733435953712, -75.7091674804688, -1.321374246478, 218, 33, 'PPL', 'P'),
(157397, 'Roanoake', 40.4097213745117, 0.705282687798758, -81.3525009155273, -1.41986899570765, 218, 41, 'PPL', 'P'),
(5436, 'Roanoke', 33.1511116027832, 0.578596048164661, -85.3722229003906, -1.49002637935832, 218, 2, 'PPL', 'P'),
(37951, 'Roanoke', 37.6769409179688, 0.657586671097929, -85.7058334350586, -1.49584898160761, 218, 21, 'PPL', 'P'),
(42829, 'Roanoke', 30.2366695404053, 0.527729438317553, -92.746940612793, -1.61873948484488, 218, 22, 'PPL', 'P'),
(57212, 'Roanoke', 39.3169403076172, 0.686210060177992, -92.688606262207, -1.61772135836015, 218, 29, 'PPL', 'P'),
(97551, 'Roanoke', 33.0038909912109, 0.576026563765926, -97.2255630493164, -1.69690619231591, 218, 51, 'PPL', 'P'),
(105795, 'Roanoke', 37.2708282470703, 0.650498667856684, -79.9416732788086, -1.39524540826878, 218, 53, 'PPL', 'P'),
(111145, 'Roanoke', 38.9316711425781, 0.679485844741651, -80.4930572509766, -1.40486887402584, 218, 58, 'PPL', 'P'),
(121244, 'Roanoke', 40.7961082458496, 0.712026410890084, -89.1972198486328, -1.55678516998388, 218, 18, 'PPL', 'P'),
(123561, 'Roanoke', 40.9625015258789, 0.714930521479788, -85.3733291625977, -1.49004568727622, 218, 19, 'PPL', 'P'),
(152136, 'Roanoke', 42.9436111450195, 0.749507407176723, -78.0522232055664, -1.36226828343866, 218, 40, 'PPL', 'P'),
(208575, 'Roanoke', 47.5947189331055, 0.830684551943973, -122.241668701172, -2.13351960196755, 218, 56, 'PPL', 'P'),
(24429, 'Roanoke (historical)', 32.0313911437988, 0.559053239453442, -85.0527801513672, -1.48445105161624, 218, 13, 'PPL', 'P'),
(5437, 'Roanoke Junction', 32.6794395446777, 0.570363817761063, -85.370002746582, -1.48998763036446, 218, 2, 'PPL', 'P'),
(152137, 'Roanoke Landing', 40.9766693115234, 0.715177795987002, -72.708610534668, -1.26900464838019, 218, 40, 'PPL', 'P'),
(68268, 'Roanoke Rapids', 36.4613914489746, 0.636371330643113, -77.6544418334961, -1.35532568879293, 218, 33, 'PPL', 'P'),
(105798, 'Roanoke Red Sulphur Springs', 37.392219543457, 0.652617345661896, -80.1091690063477, -1.39816876019736, 218, 53, 'PPL', 'P'),
(123562, 'Roanoke Station', 40.9519386291504, 0.714746164153327, -85.3641662597656, -1.48988576445276, 218, 19, 'PPL', 'P'),
(97552, 'Roans Prairie', 30.5841693878174, 0.533794454805072, -95.9436111450195, -1.67453191073372, 218, 51, 'PPL', 'P'),
(197404, 'Roanwood', 48.9413909912109, 0.854188413302522, -106.497222900391, -1.85872718384212, 218, 31, 'PPL', 'P'),
(166539, 'Roaring Branch', 41.565559387207, 0.725455866739999, -76.9530563354492, -1.34308420252627, 218, 45, 'PPL', 'P'),
(132856, 'Roaring Brook', 45.4286117553711, 0.792878849741426, -84.9458312988281, -1.4825844420082, 218, 27, 'PPL', 'P'),
(166540, 'Roaring Brook', 41.2563896179199, 0.720059836318308, -76.1202774047852, -1.32854946824495, 218, 45, 'PPL', 'P'),
(125961, 'Roaring Brook Camp', 42.4813919067383, 0.741440159602655, -72.6688919067383, -1.26831142754844, 218, 23, 'PPL', 'P'),
(68272, 'Roaring Creek', 36.0636100769043, 0.629428735997385, -82.0127792358398, -1.43139302637664, 218, 33, 'PPL', 'P'),
(166543, 'Roaring Creek', 40.9322204589844, 0.714402017161462, -76.5236129760742, -1.33558900195435, 218, 45, 'PPL', 'P'),
(111147, 'Roaring Creek Junction', 38.9408302307129, 0.679645700986083, -79.9599990844727, -1.3955652539157, 218, 58, 'PPL', 'P'),
(105800, 'Roaring Fork', 36.9691696166992, 0.645233731539651, -82.7344436645508, -1.44398844675217, 218, 53, 'PPL', 'P'),
(68274, 'Roaring Gap', 36.4027786254883, 0.635348343889386, -80.9855575561523, -1.41346462591823, 218, 33, 'PPL', 'P'),
(68275, 'Roaring River', 36.2063903808594, 0.6319207224084, -81.0038909912109, -1.4137846047232, 218, 33, 'PPL', 'P'),
(37952, 'Roaring Spring', 36.7255592346191, 0.640981928280313, -87.7069396972656, -1.5307748745654, 218, 21, 'PPL', 'P'),
(166544, 'Roaring Spring', 40.3358306884766, 0.703993052040887, -78.39111328125, -1.36818303106167, 218, 45, 'PPL', 'P'),
(90387, 'Roaring Springs', 36.2963905334473, 0.633491521398356, -82.7774963378906, -1.44473985765374, 218, 50, 'PPL', 'P'),
(192118, 'Roaring Springs', 33.8994407653809, 0.591656855940683, -100.856666564941, -1.76028090414431, 218, 51, 'PPL', 'P'),
(11618, 'Roark', 33.3616714477539, 0.582271010731889, -91.8199996948242, -1.60256131385487, 218, 4, 'PPL', 'P'),
(37953, 'Roark', 37.0224990844727, 0.646164506340634, -83.5152816772461, -1.45761664099844, 218, 21, 'PPL', 'P'),
(90386, 'Roark Cove', 35.246940612793, 0.615175164948145, -85.9302825927734, -1.49976635841307, 218, 50, 'PPL', 'P'),
(11620, 'Rob Roy', 34.2811088562012, 0.598318220775298, -91.8969421386719, -1.60390421283454, 218, 4, 'PPL', 'P'),
(37954, 'Rob Roy', 37.3869400024414, 0.652525200288179, -86.7983322143555, -1.51491668238036, 218, 21, 'PPL', 'P'),
(123563, 'Rob Roy', 40.2366714477539, 0.702262396806499, -87.2433319091797, -1.52268339222542, 218, 19, 'PPL', 'P'),
(184612, 'Rob Roy Junction', 36.9708290100098, 0.645262693416506, -121.873062133789, -2.12708620372225, 218, 6, 'PPL', 'P'),
(5438, 'Roba', 32.2438888549805, 0.562762024166514, -85.5941696166992, -1.49390008032189, 218, 2, 'PPL', 'P'),
(112476, 'Robanna', 39.6852798461914, 0.692638797891389, -75.0183334350586, -1.30931691780072, 218, 37, 'PPL', 'P'),
(37955, 'Robards', 37.6738891601563, 0.657533407876128, -87.5466690063477, -1.52797762331444, 218, 21, 'PPL', 'P'),
(97553, 'Robards', 29.5363903045654, 0.515507259968798, -98.538330078125, -1.71981829928024, 218, 51, 'PPL', 'P'),
(83330, 'Robat', 34.7972183227539, 0.607326030267355, -81.5033264160156, -1.42250139728714, 218, 48, 'PPL', 'P'),
(166546, 'Robb', 40.392219543457, 0.704977223221726, -79.0380630493164, -1.37947443460944, 218, 45, 'PPL', 'P'),
(194400, 'Robb', 40.1025009155273, 0.699920679259993, -102.371391296387, -1.78671783796941, 218, 7, 'PPL', 'P'),
(205573, 'Robbe', 40.5611114501953, 0.70792494307428, -112.069717407227, -1.95598556053571, 218, 52, 'PPL', 'P'),
(193914, 'Robbers Creek', 40.3702812194824, 0.704594327236, -121.003890991211, -2.11191630552094, 218, 6, 'PPL', 'P'),
(178994, 'Robbers Roost', 35.6605606079102, 0.622394195715023, -113.152221679688, -1.97487882425706, 218, 5, 'PPL', 'P'),
(97554, 'Robberson', 26.6511096954346, 0.465149613495516, -98.5877838134766, -1.72068142978954, 218, 51, 'PPL', 'P'),
(137743, 'Robbin', 48.5727806091309, 0.84775494847819, -97.142219543457, -1.69545157372851, 218, 28, 'PPL', 'P'),
(14501, 'Robbins', 38.7619400024414, 0.676523477503101, -75.4219436645508, -1.31636124520009, 218, 10, 'PPL', 'P'),
(50904, 'Robbins', 38.375560760498, 0.66977988756983, -76.0758285522461, -1.32777368941941, 218, 25, 'PPL', 'P'),
(57218, 'Robbins', 38.9063911437988, 0.679044625528052, -93.8077774047852, -1.63725457969144, 218, 29, 'PPL', 'P'),
(68276, 'Robbins', 35.4338912963867, 0.61843806991571, -79.5872192382813, -1.38905901821458, 218, 33, 'PPL', 'P'),
(90388, 'Robbins', 36.353328704834, 0.634485279959119, -84.5894393920898, -1.47636422980816, 218, 50, 'PPL', 'P'),
(97555, 'Robbins', 31.2552795410156, 0.545507536621945, -96.1224975585938, -1.67765406763767, 218, 51, 'PPL', 'P'),
(121246, 'Robbins', 41.6438903808594, 0.726823000485591, -87.70361328125, -1.53071681765364, 218, 18, 'PPL', 'P'),
(132857, 'Robbins', 46.3819389343262, 0.809517547862942, -89.2255630493164, -1.55727985215636, 218, 27, 'PPL', 'P'),
(166547, 'Robbins', 40.2961082458496, 0.703299764630112, -79.7830581665039, -1.39247705231564, 218, 45, 'PPL', 'P'),
(184613, 'Robbins', 38.8702812194824, 0.678414388456085, -121.705276489258, -2.12415779178759, 218, 6, 'PPL', 'P'),
(74099, 'Robbins (historical)', 39.0380592346191, 0.681342667232682, -82.8783264160156, -1.44649967450206, 218, 41, 'PPL', 'P'),
(83332, 'Robbins (historical)', 33.1508293151855, 0.578591121316645, -81.6552810668945, -1.4251535062587, 218, 48, 'PPL', 'P'),
(105801, 'Robbins (historical)', 36.8036117553711, 0.642344201756915, -82.9625015258789, -1.44796880731741, 218, 53, 'PPL', 'P'),
(105802, 'Robbins Corner', 36.894718170166, 0.643934308664775, -76.1438903808594, -1.32896159242364, 218, 53, 'PPL', 'P'),
(5439, 'Robbins Crossroads', 33.7344398498535, 0.588777046695925, -86.9955596923828, -1.51835895124735, 218, 2, 'PPL', 'P'),
(50905, 'Robbins Landing', 38.3769416809082, 0.669803989177695, -76.0583267211914, -1.32746822484237, 218, 25, 'PPL', 'P'),
(83333, 'Robbins Neck', 34.4655609130859, 0.601537516480013, -79.8022232055664, -1.39281154534856, 218, 48, 'PPL', 'P'),
(152138, 'Robbins Rest', 40.6433296203613, 0.709359920848642, -73.1650009155273, -1.27697016320062, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(137744, 'Robbinsdale', 45.0322189331055, 0.785960489861618, -93.3383331298828, -1.62906123143976, 218, 28, 'PPL', 'P'),
(128668, 'Robbinston', 45.0780601501465, 0.786760570032106, -67.1100006103516, -1.17129047166604, 218, 26, 'PPL', 'P'),
(68277, 'Robbinsville', 35.3227806091309, 0.616498822588942, -83.807502746582, -1.46271686080205, 218, 33, 'PPL', 'P'),
(146196, 'Robbinsville', 40.2144393920898, 0.701874374235675, -74.6197204589844, -1.30235980892705, 218, 37, 'PPL', 'P'),
(28429, 'Robbs', 37.4588890075684, 0.653780947321179, -88.6997222900391, -1.54810219956579, 218, 18, 'PPL', 'P'),
(61559, 'Robbs', 34.101390838623, 0.595181549643402, -89.2069396972656, -1.55695481334532, 218, 30, 'PPL', 'P'),
(208577, 'Robe', 48.0974998474121, 0.839459734314812, -121.812217712402, -2.12602426823758, 218, 56, 'PPL', 'P'),
(24430, 'Robealou Acres', 34.2224998474121, 0.597295300600598, -85.2302780151367, -1.48754897375427, 218, 13, 'PPL', 'P'),
(121247, 'Robein', 40.6883316040039, 0.710145353633134, -89.5111083984375, -1.56226355866228, 218, 18, 'PPL', 'P'),
(42830, 'Robeline', 31.6902809143066, 0.55309974283657, -93.304443359375, -1.62846974336165, 218, 22, 'PPL', 'P'),
(24433, 'Rober (historical)', 34.5213890075684, 0.602511900543846, -84.5269393920898, -1.47527339902566, 218, 13, 'PPL', 'P'),
(68278, 'Roberdell', 34.9713897705078, 0.610365895493626, -79.745002746582, -1.39181285993978, 218, 33, 'PPL', 'P'),
(68279, 'Roberdo', 35.3133316040039, 0.616333906338439, -79.9499969482422, -1.39539068370624, 218, 33, 'PPL', 'P'),
(197405, 'Robere (historical)', 48.3255615234375, 0.843440161459071, -112.551109313965, -1.96438743430074, 218, 31, 'PPL', 'P'),
(5440, 'Roberson Beach', 34.7652816772461, 0.606768630651201, -87.2866668701172, -1.523439729975, 218, 2, 'PPL', 'P'),
(189364, 'Roberson Place', 33.4775009155273, 0.584292616315368, -106.151107788086, -1.85268633554149, 218, 38, 'PPL', 'P'),
(68280, 'Robersonville', 35.8250007629395, 0.625264217842774, -77.2494430541992, -1.34825712662764, 218, 33, 'PPL', 'P'),
(42831, 'Robert', 30.5061092376709, 0.532432048170415, -90.3408279418945, -1.57674489656375, 218, 22, 'PPL', 'P'),
(184614, 'Robert (historical)', 37.6769409179688, 0.657586671097929, -122.155563354492, -2.13201678016442, 218, 6, 'PPL', 'P'),
(113994, 'Robert Hutt Congregate Housing', 41.4958305358887, 0.72423886870086, -73.0749969482422, -1.27539929763163, 218, 8, 'PPL', 'P'),
(192119, 'Robert Lee', 31.892219543457, 0.556624236802208, -100.484443664551, -1.75378438898117, 218, 51, 'PPL', 'P'),
(24431, 'Robert M Hitch Village', 32.0730590820313, 0.559780482168115, -81.0827789306641, -1.41516145900677, 218, 13, 'PPL', 'P'),
(5441, 'Roberta', 33.0958290100098, 0.577631184901726, -86.8069381713867, -1.51506688466584, 218, 2, 'PPL', 'P'),
(24432, 'Roberta', 32.7216682434082, 0.571100847592742, -84.0133285522461, -1.46630919879646, 218, 13, 'PPL', 'P'),
(37957, 'Roberta', 38.1105613708496, 0.665154775704689, -86.4377822875977, -1.50862389904062, 218, 21, 'PPL', 'P'),
(77105, 'Roberta', 33.9263916015625, 0.592127236768218, -96.3022232055664, -1.68079087192762, 218, 42, 'PPL', 'P'),
(90389, 'Roberta', 36.5466690063477, 0.637859704797331, -84.5416717529297, -1.47553052722891, 218, 50, 'PPL', 'P'),
(187266, 'Roberta', 37.9963912963867, 0.663162131998065, -103.675277709961, -1.80947494895831, 218, 7, 'PPL', 'P'),
(68282, 'Roberta Mill', 35.3572196960449, 0.617099898046973, -80.6361083984375, -1.40736558754779, 218, 33, 'PPL', 'P'),
(42833, 'Robertdale (historical)', 32.9022216796875, 0.574252099531606, -91.1447219848633, -1.59077549445073, 218, 22, 'PPL', 'P'),
(5442, 'Roberts', 31.0816707611084, 0.542477491802193, -86.8888931274414, -1.51649726848733, 218, 2, 'PPL', 'P'),
(50907, 'Roberts', 39.1172218322754, 0.682724315206215, -75.9186096191406, -1.32502970139024, 218, 25, 'PPL', 'P'),
(61560, 'Roberts', 32.2291717529297, 0.562505162279375, -89.2294387817383, -1.55734749644805, 218, 30, 'PPL', 'P'),
(74100, 'Roberts', 39.8769416809082, 0.69598392795761, -82.0894393920898, -1.4327309985083, 218, 41, 'PPL', 'P'),
(79034, 'Roberts', 39.978889465332, 0.697763252460919, -79.0897216796875, -1.38037604779649, 218, 45, 'PPL', 'P'),
(90391, 'Roberts', 36.1138916015625, 0.630306314155594, -85.6900024414063, -1.49557267864452, 218, 50, 'PPL', 'P'),
(111149, 'Roberts', 39.3783302307129, 0.687281516463558, -80.6686096191406, -1.40793284085997, 218, 58, 'PPL', 'P'),
(117556, 'Roberts', 42.4269409179688, 0.74048981056766, -94.1741714477539, -1.64364936210094, 218, 16, 'PPL', 'P'),
(121250, 'Roberts', 40.6127815246582, 0.708826755998408, -88.1833267211914, -1.53908939664669, 218, 18, 'PPL', 'P'),
(123565, 'Roberts', 40.3161087036133, 0.703648838469994, -87.1022186279297, -1.52022050084931, 218, 19, 'PPL', 'P'),
(128670, 'Roberts', 46.788890838623, 0.816620198490183, -67.958610534668, -1.18610150891046, 218, 26, 'PPL', 'P'),
(176123, 'Roberts', 44.9838905334473, 0.785117000165363, -92.5558319091797, -1.61540400873761, 218, 57, 'PPL', 'P'),
(195541, 'Roberts', 43.7202796936035, 0.763062830546199, -112.125556945801, -1.95696014433662, 218, 17, 'PPL', 'P'),
(197406, 'Roberts', 45.3597183227539, 0.791676432509256, -109.166938781738, -1.90532251606442, 218, 31, 'PPL', 'P'),
(201487, 'Roberts', 44.0813903808594, 0.769365401002953, -120.683609008789, -2.10632633039286, 218, 43, 'PPL', 'P'),
(11622, 'Roberts (historical)', 33.2816696166992, 0.580874715372361, -93.8838882446289, -1.63858296444317, 218, 4, 'PPL', 'P'),
(74102, 'Roberts (historical)', 39.8549995422363, 0.695600965392857, -82.0650024414063, -1.43230449325972, 218, 41, 'PPL', 'P'),
(128672, 'Roberts Corner', 43.6933288574219, 0.762592449718664, -70.961669921875, -1.23851478285015, 218, 26, 'PPL', 'P'),
(132858, 'Roberts Corner', 46.3033294677734, 0.80814555384836, -85.4886093139648, -1.49205770547978, 218, 27, 'PPL', 'P'),
(152139, 'Roberts Corner', 43.8163909912109, 0.764740289137813, -76.1205596923828, -1.32855439509296, 218, 40, 'PPL', 'P'),
(42834, 'Roberts Cove', 30.2752799987793, 0.528403317941884, -92.3022232055664, -1.61097770184785, 218, 22, 'PPL', 'P'),
(5443, 'Roberts Crossroads', 31.600830078125, 0.551538531226538, -85.5288925170898, -1.49276078000756, 218, 2, 'PPL', 'P'),
(24437, 'Roberts Crossroads', 34.1338882446289, 0.595748736376562, -83.9352798461914, -1.46494699189888, 218, 13, 'PPL', 'P'),
(152140, 'Roberts Hill', 42.3952789306641, 0.739937204641469, -73.8372192382813, -1.28870258622491, 218, 40, 'PPL', 'P'),
(132859, 'Roberts Landing', 42.6597213745117, 0.744552595968631, -82.5158309936523, -1.44017293585842, 218, 27, 'PPL', 'P'),
(105803, 'Roberts Mill', 36.774169921875, 0.641830344824585, -81.4388885498047, -1.4213767443588, 218, 53, 'PPL', 'P'),
(142867, 'Roberts Mobile Home Court', 40.9861106872559, 0.715342579079451, -95.8944396972656, -1.67367370707244, 218, 35, 'PPL', 'P'),
(193915, 'Roberts Place', 40.0411109924316, 0.698849222974426, -121.856391906738, -2.12679525337315, 218, 6, 'PPL', 'P'),
(50910, 'Roberts Retreat', 39.4052810668945, 0.687751897291094, -77.4894409179688, -1.35244587954817, 218, 25, 'PPL', 'P'),
(5444, 'Roberts Subdivision', 34.1777801513672, 0.596514794664123, -85.7227783203125, -1.49614472564667, 218, 2, 'PPL', 'P'),
(111151, 'Robertsburg', 38.6552810668945, 0.674661927901136, -81.9513931274414, -1.43032163667011, 218, 58, 'PPL', 'P'),
(157398, 'Robertsburg', 40.4241714477539, 0.705534889153989, -83.1619415283203, -1.45144969202019, 218, 41, 'PPL', 'P'),
(5445, 'Robertsdale', 30.5536098480225, 0.533261090217756, -87.7119369506836, -1.5308620930911, 218, 2, 'PPL', 'P'),
(123566, 'Robertsdale', 41.6830596923828, 0.727506633937415, -87.508056640625, -1.52730371040059, 218, 19, 'PPL', 'P'),
(166548, 'Robertsdale', 40.1841697692871, 0.70134606965443, -78.1155624389648, -1.36337376160715, 218, 45, 'PPL', 'P'),
(57220, 'Robertson', 38.7641716003418, 0.676562426234044, -90.3819427490234, -1.57746248531947, 218, 29, 'PPL', 'P'),
(90392, 'Robertson', 35.2655601501465, 0.615500137180162, -88.7186126708984, -1.54843189890874, 218, 50, 'PPL', 'P'),
(117557, 'Robertson', 42.5063896179199, 0.741876451968237, -93.1272201538086, -1.62537661491358, 218, 16, 'PPL', 'P'),
(192121, 'Robertson', 33.5641708374023, 0.585805291814533, -101.513328552246, -1.77174181789546, 218, 51, 'PPL', 'P'),
(209700, 'Robertson', 41.1852798461914, 0.718818736671304, -110.412498474121, -1.92706163372663, 218, 59, 'PPL', 'P'),
(14502, 'Robertson Landing', 38.8052787780762, 0.677279881831711, -75.2433319091797, -1.3132438819861, 218, 10, 'PPL', 'P'),
(105806, 'Robertson Place', 37.2316703796387, 0.649815234141942, -77.4552764892578, -1.3518495977801, 218, 53, 'PPL', 'P'),
(189365, 'Robertson Wells', 33.6994400024414, 0.588166184120889, -103.921669006348, -1.81377528832851, 218, 38, 'PPL', 'P'),
(105807, 'Robertsons (historical)', 37.2891693115234, 0.650818779819711, -79.6063919067383, -1.38939364440555, 218, 53, 'PPL', 'P'),
(24434, 'Robertstown', 34.7099990844727, 0.605803767388265, -83.7408294677734, -1.46155319256374, 218, 13, 'PPL', 'P'),
(11624, 'Robertsville', 35.3677787780762, 0.617284188794406, -92.7900009155273, -1.61949102890451, 218, 4, 'PPL', 'P'),
(24435, 'Robertsville', 34.8827781677246, 0.608819331269589, -85.29638671875, -1.48870278829655, 218, 13, 'PPL', 'P'),
(57221, 'Robertsville', 38.4147186279297, 0.670463321284572, -90.8138885498047, -1.58500136173327, 218, 29, 'PPL', 'P'),
(90394, 'Robertsville', 36.0136108398438, 0.628556084687194, -84.2744369506836, -1.4708664000538, 218, 50, 'PPL', 'P'),
(113995, 'Robertsville', 41.978889465332, 0.732669837500806, -73.0444412231445, -1.27486599962335, 218, 8, 'PPL', 'P'),
(146197, 'Robertsville', 40.3461112976074, 0.704172482519331, -74.288330078125, -1.29657595567162, 218, 37, 'PPL', 'P'),
(157399, 'Robertsville', 40.7630615234375, 0.711449636777, -81.1897201538086, -1.41702793545676, 218, 41, 'PPL', 'P'),
(166549, 'Robertsville', 40.9625015258789, 0.714930521479788, -78.904167175293, -1.3771375107529, 218, 45, 'PPL', 'P'),
(184615, 'Robertsville', 37.2633285522461, 0.650367773489106, -121.875282287598, -2.12712495271611, 218, 6, 'PPL', 'P'),
(61561, 'Robertsville (historical)', 34.2466697692871, 0.597717145317267, -90.7838897705078, -1.58447778426296, 218, 30, 'PPL', 'P'),
(83334, 'Robertville', 32.5863914489746, 0.568739822128333, -81.1986083984375, -1.41718306459025, 218, 48, 'PPL', 'P'),
(166550, 'Robeson Crossing', 40.2761116027832, 0.702950757369258, -75.8477783203125, -1.32379346201223, 218, 45, 'PPL', 'P'),
(166551, 'Robeson Extension', 40.4669418334961, 0.706281373207538, -78.1999969482422, -1.36484742179634, 218, 45, 'PPL', 'P'),
(166553, 'Robesonia', 40.3516693115234, 0.704269488162037, -76.1347198486328, -1.32880153644212, 218, 45, 'PPL', 'P'),
(111150, 'Robey', 39.3624992370605, 0.687005213500463, -80.3763885498047, -1.40283262105636, 218, 58, 'PPL', 'P'),
(50911, 'Robeys Farmlets', 39.0930595397949, 0.682302603647601, -76.8838882446289, -1.34187699160414, 218, 25, 'PPL', 'P'),
(105808, 'Robeys Mill', 38.8147201538086, 0.67744466492416, -77.3663864135742, -1.35029817328708, 218, 53, 'PPL', 'P'),
(13199, 'Robeyville (historical)', 38.9472198486328, 0.67975722085673, -77.0902786254883, -1.34547918329458, 218, 9, 'PPL', 'P'),
(57222, 'Robidoux', 38.0522193908691, 0.664136516061898, -90.7683334350586, -1.58420627498983, 218, 29, 'PPL', 'P'),
(50912, 'Robie Manor', 38.5997200012207, 0.673692204369211, -77.0152816772461, -1.34417023961881, 218, 25, 'PPL', 'P'),
(42835, 'Robin', 30.4477806091309, 0.531414021554218, -91.9238891601563, -1.60437452708305, 218, 22, 'PPL', 'P'),
(195542, 'Robin', 42.577220916748, 0.743112691346252, -112.245826721191, -1.95905924790782, 218, 17, 'PPL', 'P'),
(50913, 'Robin Acres', 39.6233291625977, 0.691557554488817, -76.070556640625, -1.32768167720374, 218, 25, 'PPL', 'P'),
(79035, 'Robin Heights', 39.8974990844727, 0.696342722335471, -76.6930618286133, -1.33854644234489, 218, 45, 'PPL', 'P'),
(125962, 'Robin Hill', 42.3605613708496, 0.739331268914448, -71.5963897705078, -1.24959273403655, 218, 23, 'PPL', 'P'),
(83335, 'Robin Hill Farm', 33.5544395446777, 0.585635448716013, -80.9288864135742, -1.41247552788938, 218, 48, 'PPL', 'P'),
(83336, 'Robin Hood', 33.5697212219238, 0.585902164299185, -79.0205612182617, -1.37916897003241, 218, 48, 'PPL', 'P'),
(50914, 'Robin Hood Hill', 39.0277786254883, 0.681163236754237, -76.5361099243164, -1.33580711484763, 218, 25, 'PPL', 'P'),
(166555, 'Robin Hood Lakes', 40.9677810668945, 0.715022666853505, -75.5330581665039, -1.31830055910588, 218, 45, 'PPL', 'P'),
(50915, 'Robin Hood Manor', 39.5369415283203, 0.690049805837668, -76.1425018310547, -1.32893735765772, 218, 25, 'PPL', 'P'),
(105809, 'Robin Hood Park', 37.2702789306641, 0.650489080476759, -80.0824966430664, -1.39770323963881, 218, 53, 'PPL', 'P'),
(42836, 'Robin Hood Subdivision', 32.9958305358887, 0.575885882281342, -93.4702835083008, -1.63136419999241, 218, 22, 'PPL', 'P'),
(68284, 'Robin Lake Estates', 35.2849998474121, 0.615839423903038, -78.0102767944336, -1.36153618045499, 218, 33, 'PPL', 'P'),
(50916, 'Robin Meadows', 39.3699989318848, 0.68713610786804, -77.4305572509766, -1.35141816568351, 218, 25, 'PPL', 'P'),
(105810, 'Robin Ridge', 37.6522216796875, 0.657155239001337, -77.3677825927734, -1.35032254121105, 218, 53, 'PPL', 'P'),
(50917, 'Robindale', 39.0633316040039, 0.681783753288226, -77.0936126708984, -1.3455373733644, 218, 25, 'PPL', 'P'),
(166556, 'Robindale (historical)', 40.4008293151855, 0.705127492086234, -79.0369415283203, -1.37945486037543, 218, 45, 'PPL', 'P'),
(166557, 'Robindale Heights', 40.4263916015625, 0.705573638147849, -79.0250015258789, -1.37924646802013, 218, 45, 'PPL', 'P'),
(50918, 'Robindell Heights', 39.4127807617188, 0.687882791658671, -77.1458282470703, -1.34644870708942, 218, 25, 'PPL', 'P'),
(68289, 'Robinet (historical)', 36.1402816772461, 0.630766907866123, -81.1744384765625, -1.41676121987359, 218, 33, 'PPL', 'P'),
(111152, 'Robinette', 37.7849998474121, 0.659472655202896, -81.7938919067383, -1.42757272179293, 218, 58, 'PPL', 'P'),
(201488, 'Robinette', 44.7527809143066, 0.781083376378329, -117.029441833496, -2.0425490817657, 218, 43, 'PPL', 'P'),
(97558, 'Robinette Colonia', 26.1319999694824, 0.456089439598526, -98.1380004882813, -1.71283122984431, 218, 51, 'PPL', 'P'),
(128673, 'Robinhood', 43.8530616760254, 0.765380313326786, -69.7375030517578, -1.21714904037277, 218, 26, 'PPL', 'P'),
(105811, 'Robinhood Forest', 36.8647193908691, 0.643410731194465, -76.063606262207, -1.32756037021609, 218, 53, 'PPL', 'P'),
(74103, 'Robins', 39.9552803039551, 0.697351194861257, -81.5133285522461, -1.4226759674966, 218, 41, 'PPL', 'P'),
(117558, 'Robins', 42.0711097717285, 0.734279385484623, -91.6666717529297, -1.59988523643351, 218, 16, 'PPL', 'P'),
(24438, 'Robins Forest West', 32.598331451416, 0.568948214483631, -83.6786117553711, -1.46046728862926, 218, 13, 'PPL', 'P'),
(68287, 'Robins Nest', 35.8905601501465, 0.626408445005127, -79.9505615234375, -1.39540053740228, 218, 33, 'PPL', 'P'),
(205576, 'Robins Roost', 41.2999992370605, 0.720820967757853, -111.823608398438, -1.95169014801352, 218, 52, 'PPL', 'P'),
(11625, 'Robinson', 36.1691703796387, 0.631271110839502, -94.3586120605469, -1.64686845806857, 218, 4, 'PPL', 'P'),
(24440, 'Robinson', 33.5852813720703, 0.586173740151346, -82.9922180175781, -1.4484874579397, 218, 13, 'PPL', 'P'),
(28430, 'Robinson', 39.0052795410156, 0.680770553651505, -87.7391662597656, -1.53133733418763, 218, 18, 'PPL', 'P'),
(33788, 'Robinson', 39.8166694641113, 0.694931979327029, -95.4102783203125, -1.66522349693362, 218, 20, 'PPL', 'P'),
(37959, 'Robinson', 38.4911117553711, 0.67179663288432, -84.3483276367188, -1.47215603581167, 218, 21, 'PPL', 'P'),
(42841, 'Robinson', 32.9888916015625, 0.575764775030771, -91.8899993896484, -1.60378303900495, 218, 22, 'PPL', 'P'),
(50919, 'Robinson', 39.0788917541504, 0.682055329140387, -76.5533294677734, -1.33610765257664, 218, 25, 'PPL', 'P'),
(83337, 'Robinson', 34.7341690063477, 0.606225612104934, -79.9333267211914, -1.39509973335715, 218, 48, 'PPL', 'P'),
(97559, 'Robinson', 31.4675006866455, 0.549211494355541, -97.1144409179688, -1.69496674525206, 218, 51, 'PPL', 'P'),
(113367, 'Robinson', 43.8591690063477, 0.765486906349416, -72.8727798461914, -1.27186994339701, 218, 55, 'PPL', 'P'),
(117559, 'Robinson', 42.3419418334961, 0.739006296682431, -91.57861328125, -1.59834832616842, 218, 16, 'PPL', 'P'),
(128674, 'Robinson', 46.473331451416, 0.811112648197845, -67.8408279418945, -1.18404581486503, 218, 26, 'PPL', 'P'),
(132860, 'Robinson', 42.9866714477539, 0.750258951236343, -86.0841674804688, -1.50245215637241, 218, 27, 'PPL', 'P'),
(137747, 'Robinson', 47.8594398498535, 0.835304803540124, -92.0416717529297, -1.60643022112848, 218, 28, 'PPL', 'P'),
(140778, 'Robinson', 47.1427803039551, 0.822796734848349, -99.7808303833008, -1.74150402056259, 218, 34, 'PPL', 'P'),
(152141, 'Robinson', 44.8227806091309, 0.782305101528403, -73.6158294677734, -1.28483860579931, 218, 40, 'PPL', 'P'),
(166560, 'Robinson', 40.4502792358398, 0.705990556016501, -80.3369369506836, -1.40214406075652, 218, 45, 'PPL', 'P'),
(197407, 'Robinson', 46.4738883972168, 0.811122368735823, -110.667503356934, -1.93151230854037, 218, 31, 'PPL', 'P'),
(208579, 'Robinson', 46.2991714477539, 0.808072982708655, -118.292778015137, -2.0645984576949, 218, 56, 'PPL', 'P'),
(209701, 'Robinson', 41.6272201538086, 0.7265320501365, -108.328330993652, -1.89068604902945, 218, 59, 'PPL', 'P'),
(5446, 'Robinson (historical)', 32.3686103820801, 0.564938825462517, -88.0144424438477, -1.53614180995219, 218, 2, 'PPL', 'P'),
(30988, 'Robinson (historical)', 39.8377799987793, 0.695300427663841, -86.029167175293, -1.50149221995749, 218, 19, 'PPL', 'P'),
(90395, 'Robinson (historical)', 35.6788902282715, 0.622714107940969, -86.1727828979492, -1.50399878717547, 218, 50, 'PPL', 'P'),
(184616, 'Robinson (historical)', 36.4022216796875, 0.635338623351408, -119.841667175293, -2.09163167328807, 218, 6, 'PPL', 'P'),
(190675, 'Robinson (historical)', 39.420280456543, 0.688013686026248, -114.529716491699, -1.9989206441558, 218, 39, 'PPL', 'P'),
(192122, 'Robinson Arms Landing', 31.9638900756836, 0.557875123566218, -103.961669921875, -1.81447343600827, 218, 51, 'PPL', 'P'),
(195543, 'Robinson Bar', 44.246940612793, 0.772254797627635, -114.676109313965, -2.00147568090562, 218, 17, 'PPL', 'P'),
(97560, 'Robinson Colonia', 26.4090003967285, 0.460924009083401, -98.9850006103516, -1.72761417073923, 218, 51, 'PPL', 'P'),
(50920, 'Robinson Corner', 39.2897186279297, 0.685734952239522, -76.0138931274414, -1.32669271233294, 218, 25, 'PPL', 'P'),
(77106, 'Robinson Corner', 34.0852813720703, 0.594900386411317, -96.6011123657227, -1.68600747187087, 218, 42, 'PPL', 'P'),
(128675, 'Robinson Corner', 44.0758285522461, 0.76926832878122, -70.1155624389648, -1.2237474214476, 218, 26, 'PPL', 'P'),
(144375, 'Robinson Corner', 43.5341682434082, 0.759814572964629, -71.9730606079102, -1.25616688034546, 218, 36, 'PPL', 'P'),
(152142, 'Robinson Corners', 42.7036094665527, 0.745318587677165, -75.2041702270508, -1.31256038169233, 218, 40, 'PPL', 'P'),
(37960, 'Robinson Creek', 37.3869400024414, 0.652525200288179, -82.5374984741211, -1.44055110473321, 218, 21, 'PPL', 'P'),
(83338, 'Robinson Crossroad', 34.5205612182617, 0.602497452894932, -80.6452789306641, -1.4075256435293, 218, 48, 'PPL', 'P'),
(5448, 'Robinson Crossroads', 32.1513900756836, 0.561147615913708, -86.2300033569336, -1.50499747258425, 218, 2, 'PPL', 'P'),
(90397, 'Robinson Crossroads', 35.9491691589355, 0.627431365179826, -84.1588897705078, -1.46884972131834, 218, 50, 'PPL', 'P'),
(125969, 'Robinson Crusoe Camp', 42.0930595397949, 0.734662481207431, -72.0955581665039, -1.25830486606858, 218, 23, 'PPL', 'P'),
(61562, 'Robinson Gin', 34.7866706848145, 0.607141939257003, -90.0247192382813, -1.57122775889149, 218, 30, 'PPL', 'P'),
(17826, 'Robinson Heights', 29.6149997711182, 0.516879253983379, -82.3052825927734, -1.43649817302827, 218, 12, 'PPL', 'P'),
(68291, 'Robinson Heights', 35.5344390869141, 0.620192959916018, -77.3944396972656, -1.35078779545349, 218, 33, 'PPL', 'P'),
(14503, 'Robinson Landing', 38.6930618286133, 0.67532132658704, -75.1419372558594, -1.31147421144174, 218, 10, 'PPL', 'P'),
(90398, 'Robinson Mill', 35.7227783203125, 0.623480099649503, -84.3225021362305, -1.47170529579717, 218, 50, 'PPL', 'P'),
(184617, 'Robinson Mills', 39.4949989318848, 0.689317769433033, -121.319717407227, -2.11742851634518, 218, 6, 'PPL', 'P'),
(42837, 'Robinson Place', 32.4461097717285, 0.566291444980168, -92.0988922119141, -1.60742890653726, 218, 22, 'PPL', 'P'),
(194401, 'Robinson Place', 40.4058303833008, 0.705214777190961, -108.985282897949, -1.90215202278668, 218, 7, 'PPL', 'P'),
(184618, 'Robinson Ranch', 33.6527786254883, 0.587351789459542, -117.569442749023, -2.05197387570543, 218, 6, 'PPL', 'P'),
(5449, 'Robinson Springs', 32.5116691589355, 0.567435672142521, -86.3766708374023, -1.50755730302404, 218, 2, 'PPL', 'P'),
(61563, 'Robinson Springs', 32.4972190856934, 0.56718347078729, -90.2333297729492, -1.57486869957579, 218, 30, 'PPL', 'P'),
(178995, 'Robinson Trail Crossing', 34.3594398498535, 0.59968535452089, -110.089996337891, -1.92143290960469, 218, 5, 'PPL', 'P'),
(24441, 'Robinson Wood Estates', 33.410831451416, 0.583129014656085, -84.5563888549805, -1.47578738911605, 218, 13, 'PPL', 'P'),
(5450, 'Robinsons', 32.3300018310547, 0.5642649791277, -86.5591735839844, -1.51074257684583, 218, 2, 'PPL', 'P'),
(24442, 'Robinsons Bend Estates', 33.3833312988281, 0.582649046448626, -84.5347213745117, -1.47540922024126, 218, 13, 'PPL', 'P'),
(90399, 'Robinsons Chapel', 36.0222206115723, 0.628706353551701, -87.4358291625977, -1.52604310309861, 218, 50, 'PPL', 'P'),
(184619, 'Robinsons Corner', 39.3644409179688, 0.687039102225334, -121.606941223145, -2.12244151762309, 218, 6, 'PPL', 'P'),
(61564, 'Robinsons Junction', 31.5744400024414, 0.551077937516009, -88.5591735839844, -1.54564916188571, 218, 30, 'PPL', 'P'),
(50921, 'Robinsons Promise', 39.1344413757324, 0.68302485293523, -76.8433303833008, -1.34116912338639, 218, 25, 'PPL', 'P'),
(197408, 'Robinsons Trailer Park', 45.1958312988281, 0.788816064340456, -109.247222900391, -1.90672373827197, 218, 31, 'PPL', 'P'),
(5451, 'Robinsonville', 31.0611095428467, 0.542118630845305, -87.4383316040039, -1.52608677894048, 218, 2, 'PPL', 'P'),
(14504, 'Robinsonville', 38.7136116027832, 0.675679987806846, -75.192497253418, -1.31235664986894, 218, 10, 'PPL', 'P'),
(61565, 'Robinsonville', 34.8172187805176, 0.607675104107237, -90.3161087036133, -1.57631346446716, 218, 30, 'PPL', 'P'),
(79036, 'Robinsonville', 39.815559387207, 0.694912604830099, -78.3391723632813, -1.36727649102661, 218, 45, 'PPL', 'P'),
(125963, 'Robinsonville', 42.0125007629395, 0.733256465309923, -71.2666702270508, -1.24383804239505, 218, 23, 'PPL', 'P'),
(201489, 'Robinsonville', 44.7138900756836, 0.780404603195495, -118.483612060547, -2.06792914011221, 218, 43, 'PPL', 'P'),
(146201, 'Robinsville', 40.2063903808594, 0.701733892488173, -74.4783325195313, -1.29989212386098, 218, 37, 'PPL', 'P'),
(17823, 'Robinswood', 29.6175003051758, 0.516922896535743, -82.3811111450195, -1.43782163093199, 218, 12, 'PPL', 'P'),
(37961, 'Robinswood', 38.2844390869141, 0.668189514345862, -85.6502838134766, -1.49487945781277, 218, 21, 'PPL', 'P'),
(208580, 'Robinswood', 47.5944404602051, 0.830679691674984, -122.138610839844, -2.13172090296731, 218, 56, 'PPL', 'P'),
(146198, 'Robinvale', 40.5430603027344, 0.707609891117324, -74.3522186279297, -1.29769102122003, 218, 37, 'PPL', 'P'),
(5452, 'Robinwood', 33.6150016784668, 0.586692457352666, -86.748893737793, -1.51405381818718, 218, 2, 'PPL', 'P'),
(42838, 'Robinwood', 30.4750003814697, 0.531889096203175, -90.5055618286133, -1.5796200452766, 218, 22, 'PPL', 'P'),
(50924, 'Robinwood', 39.625, 0.691586716102753, -77.6624984741211, -1.35546630369849, 218, 25, 'PPL', 'P'),
(61566, 'Robinwood', 31.4819393157959, 0.549463495973689, -90.0883331298828, -1.57233803074994, 218, 30, 'PPL', 'P'),
(105814, 'Robinwood', 37.5125007629395, 0.654716648970178, -77.3552780151367, -1.35010429515972, 218, 53, 'PPL', 'P'),
(112314, 'Robinwood', 37.5774993896484, 0.655851089015525, -88.9091720581055, -1.55175778763608, 218, 18, 'PPL', 'P'),
(152147, 'Robinwood', 44.0433311462402, 0.76870114204806, -74.7480621337891, -1.30459979371992, 218, 40, 'PPL', 'P'),
(201490, 'Robinwood', 45.3927803039551, 0.792253472938449, -122.64582824707, -2.14057351674684, 218, 43, 'PPL', 'P'),
(83339, 'Robinwood Estates', 34.7619400024414, 0.606710307423328, -80.7519378662109, -1.40938719313127, 218, 48, 'PPL', 'P'),
(105816, 'Robious', 37.5219383239746, 0.6548813654836, -77.6125030517578, -1.35459371896732, 218, 53, 'PPL', 'P'),
(90400, 'Robison', 35.9949989318848, 0.628231245613231, -88.2319412231445, -1.53993787976999, 218, 50, 'PPL', 'P'),
(205581, 'Robison Acres', 40.6647186279297, 0.709733229454444, -111.915832519531, -1.95329976257636, 218, 52, 'PPL', 'P'),
(117560, 'Robison-Whitaker Acres', 41.9258308410645, 0.731743789810758, -93.4349975585938, -1.63074834399032, 218, 16, 'PPL', 'P'),
(5454, 'Robjohn', 32.2138900756836, 0.562238446696204, -88.1272201538086, -1.53811015231386, 218, 2, 'PPL', 'P'),
(184620, 'Robla', 38.6613883972168, 0.674768520923766, -121.445556640625, -2.11962482529617, 218, 6, 'PPL', 'P'),
(184621, 'Roblar', 38.3213882446289, 0.668834398803825, -122.757781982422, -2.14252747803863, 218, 6, 'PPL', 'P'),
(184623, 'Roble', 39.6644401550293, 0.692275076665511, -121.805000305176, -2.12589830071802, 218, 6, 'PPL', 'P'),
(123567, 'Roble Woods', 41.5222206115723, 0.72469946241139, -87.054443359375, -1.51938666511201, 218, 19, 'PPL', 'P'),
(57223, 'Roblee', 39.3794403076172, 0.687300890960489, -90.9413909912109, -1.58722669914014, 218, 29, 'PPL', 'P'),
(50925, 'Roblee Acres', 38.8158302307129, 0.67746403942109, -76.8111114501953, -1.34060679692222, 218, 25, 'PPL', 'P'),
(184624, 'Robles Del Rio', 36.4700012207031, 0.636521599507621, -121.732223510742, -2.1246281060361, 218, 6, 'PPL', 'P'),
(178996, 'Robles Junction', 32.077220916748, 0.559853119886847, -111.311111450195, -1.94274538886027, 218, 5, 'PPL', 'P'),
(97561, 'Robles Ranch Colonia', 26.1599998474121, 0.456578129658556, -97.8440017700195, -1.707699984214, 218, 51, 'PPL', 'P'),
(105817, 'Robley', 37.8466682434082, 0.660548971757452, -76.5805587768555, -1.33658289367317, 218, 53, 'PPL', 'P'),
(166563, 'Roboda', 40.1772193908691, 0.701224762666777, -75.540283203125, -1.3184266597835, 218, 45, 'PPL', 'P'),
(189366, 'Robsart', 33.7363891601563, 0.588811068578851, -105.832496643066, -1.84712552202735, 218, 38, 'PPL', 'P'),
(14505, 'Robscott Manor', 39.6569404602051, 0.692144182297934, -75.7472229003906, -1.32203843885387, 218, 10, 'PPL', 'P'),
(50926, 'Robshire Manor', 38.579719543457, 0.673343130529329, -76.6041717529297, -1.33699501785186, 218, 25, 'PPL', 'P'),
(42839, 'Robson', 32.3616714477539, 0.564817718211946, -93.6427764892578, -1.63437477044669, 218, 22, 'PPL', 'P'),
(111154, 'Robson', 38.1016693115234, 0.664999579992165, -81.2438888549805, -1.41797335764374, 218, 58, 'PPL', 'P'),
(97562, 'Robstown', 27.7900009155273, 0.485027015108191, -97.6686096191406, -1.70463881369901, 218, 51, 'PPL', 'P'),
(74104, 'Robtown', 39.7169418334961, 0.69319140381758, -83.0599975585938, -1.44967043409591, 218, 41, 'PPL', 'P'),
(28432, 'Roby', 39.7391700744629, 0.693579359809378, -89.399169921875, -1.5603098636866, 218, 18, 'PPL', 'P'),
(57224, 'Roby', 37.5155601501465, 0.654770045350034, -92.1388931274414, -1.60812705421703, 218, 29, 'PPL', 'P'),
(90401, 'Roby', 35.4652786254883, 0.61898588215194, -88.4008331298828, -1.54288559962254, 218, 50, 'PPL', 'P'),
(144374, 'Roby', 43.2886085510254, 0.755528747822365, -71.8863906860352, -1.2546542048463, 218, 36, 'PPL', 'P'),
(192123, 'Roby', 32.7447204589844, 0.571503184654426, -100.377220153809, -1.75191298568317, 218, 51, 'PPL', 'P'),
(128676, 'Robyville', 44.9408302307129, 0.784365456105743, -68.9700012207031, -1.20375360640578, 218, 26, 'PPL', 'P'),
(157401, 'Robyville', 40.2069396972656, 0.701743479868097, -80.8794403076172, -1.41161253053814, 218, 41, 'PPL', 'P'),
(142868, 'Roca', 40.6575012207031, 0.709607261934883, -96.6577835083008, -1.68699656989972, 218, 35, 'PPL', 'P'),
(97563, 'Roch', 32.0238914489746, 0.558922345085865, -98.454719543457, -1.71835902016093, 218, 51, 'PPL', 'P'),
(105818, 'Rochambeau Village', 37.2136116027832, 0.649500049026931, -76.5777816772461, -1.33653442414133, 218, 53, 'PPL', 'P'),
(61567, 'Rochdale', 34.0994415283203, 0.595147527760477, -90.8502807617188, -1.58563652565325, 218, 30, 'PPL', 'P'),
(112806, 'Rochdale', 35.6049995422363, 0.621424472183098, -77.4994430541992, -1.35262044975763, 218, 33, 'PPL', 'P'),
(125964, 'Rochdale', 42.1944389343262, 0.736431885435679, -71.9063873291016, -1.25500321210715, 218, 23, 'PPL', 'P'),
(152143, 'Rochdale', 41.7183303833008, 0.728122223623387, -73.8530578613281, -1.28897902234606, 218, 40, 'PPL', 'P'),
(184625, 'Roche', 36.0730590820313, 0.629593652247889, -119.010559082031, -2.07712610062069, 218, 6, 'PPL', 'P'),
(176125, 'Roche a Cri (historical)', 44.0536117553711, 0.768880572526504, -89.8333282470703, -1.5678873559362, 218, 57, 'PPL', 'P'),
(208581, 'Roche Harbor', 48.6100006103516, 0.848404560047088, -123.147499084473, -2.14932932462075, 218, 56, 'PPL', 'P'),
(17824, 'Rochelle', 29.5963897705078, 0.51655444819893, -82.2177810668945, -1.43497098330117, 218, 12, 'PPL', 'P'),
(24443, 'Rochelle', 31.9508304595947, 0.557647190266421, -83.4563903808594, -1.45658879397572, 218, 13, 'PPL', 'P'),
(42840, 'Rochelle', 31.7900009155273, 0.554840185187964, -92.3694381713867, -1.61215082430803, 218, 22, 'PPL', 'P'),
(97564, 'Rochelle', 31.2244396209717, 0.544969278476126, -99.2108306884766, -1.73155564915255, 218, 51, 'PPL', 'P'),
(105819, 'Rochelle', 38.2902793884277, 0.668291446836585, -78.2727813720703, -1.36611774963631, 218, 53, 'PPL', 'P'),
(121252, 'Rochelle', 41.9238891601563, 0.731709901085887, -89.0686111450195, -1.55454052465911, 218, 18, 'PPL', 'P'),
(152144, 'Rochelle Heights', 40.9255599975586, 0.71428577017988, -73.7819366455078, -1.28773772296197, 218, 40, 'PPL', 'P'),
(50930, 'Rochelle Meadows', 39.5213890075684, 0.689778363143562, -76.4222183227539, -1.33381933140999, 218, 25, 'PPL', 'P'),
(146199, 'Rochelle Park', 40.9072189331055, 0.713965658216852, -74.0755615234375, -1.29286244384761, 218, 37, 'PPL', 'P'),
(152145, 'Rochelle Park', 40.917781829834, 0.714150015543313, -73.7861099243164, -1.28781056041779, 218, 40, 'PPL', 'P'),
(11628, 'Rochelle Riviera', 36.1541709899902, 0.631009322104347, -94.0177764892578, -1.64091975514166, 218, 4, 'PPL', 'P'),
(57225, 'Rocheport', 38.9799995422363, 0.680329334437906, -92.5638885498047, -1.61554462364317, 218, 29, 'PPL', 'P'),
(137748, 'Rochert', 46.8600006103516, 0.817861298137187, -95.6875, -1.67006192800207, 218, 28, 'PPL', 'P'),
(166567, 'Rocherty', 40.3022193908691, 0.70340642423177, -76.4494400024414, -1.33429443934846, 218, 45, 'PPL', 'P'),
(28434, 'Rochester', 38.3455581665039, 0.669256243520493, -87.8280563354492, -1.53288875868065, 218, 18, 'PPL', 'P'),
(37962, 'Rochester', 37.2125015258789, 0.649480674530001, -86.8930587768555, -1.51656997278508, 218, 21, 'PPL', 'P'),
(57226, 'Rochester', 39.9122200012207, 0.696599650801636, -94.684440612793, -1.65255523910227, 218, 29, 'PPL', 'P'),
(97565, 'Rochester', 33.3158302307129, 0.581470930561402, -99.8555603027344, -1.74280830370646, 218, 51, 'PPL', 'P'),
(117561, 'Rochester', 41.6738891601563, 0.727346577955901, -91.158332824707, -1.59101304841996, 218, 16, 'PPL', 'P'),
(123568, 'Rochester', 41.0647201538086, 0.716714573094032, -86.2158279418945, -1.50475006491899, 218, 19, 'PPL', 'P'),
(125965, 'Rochester', 41.7316703796387, 0.728355050481687, -70.820556640625, -1.23605189147404, 218, 23, 'PPL', 'P'),
(132862, 'Rochester', 42.6805610656738, 0.744916317194508, -83.1338882446289, -1.45096006985378, 218, 27, 'PPL', 'P'),
(137749, 'Rochester', 44.021671295166, 0.768323106331324, -92.4697189331055, -1.61390105377643, 218, 28, 'PPL', 'P'),
(144380, 'Rochester', 43.3044395446777, 0.755805050785461, -70.9761123657227, -1.23876685104732, 218, 36, 'PPL', 'P'),
(152146, 'Rochester', 43.1547203063965, 0.753191957123875, -77.6158294677734, -1.35465177587908, 218, 40, 'PPL', 'P'),
(157402, 'Rochester', 41.1263885498047, 0.717790889648588, -82.3052825927734, -1.43649817302827, 218, 41, 'PPL', 'P'),
(166564, 'Rochester', 40.702220916748, 0.710387767871358, -80.2866668701172, -1.4012666823354, 218, 45, 'PPL', 'P'),
(172463, 'Rochester', 43.874439239502, 0.765753422195506, -72.8083267211914, -1.27074502415256, 218, 55, 'PPL', 'P'),
(176126, 'Rochester', 42.7413902282715, 0.745977986363068, -88.2241668701172, -1.53980219171245, 218, 57, 'PPL', 'P'),
(184627, 'Rochester', 34.0916709899902, 0.595011906281964, -117.546669006348, -2.05157639891274, 218, 6, 'PPL', 'P'),
(197409, 'Rochester', 45.6127815246582, 0.796093218598125, -112.504997253418, -1.96358262701932, 218, 31, 'PPL', 'P'),
(200165, 'Rochester', 40.288890838623, 0.703173797110552, -118.166389465332, -2.06239256136399, 218, 39, 'PPL', 'P'),
(208582, 'Rochester', 46.8219413757324, 0.817197039182294, -123.095001220703, -2.14841306404771, 218, 56, 'PPL', 'P'),
(200166, 'Rochester Heights (historical)', 40.2849998474121, 0.703105886502755, -118.157783508301, -2.06224235907851, 218, 39, 'PPL', 'P'),
(132863, 'Rochester Hills', 42.6583290100098, 0.744528294623684, -83.1500015258789, -1.4512412996649, 218, 27, 'PPL', 'P'),
(152148, 'Rochester Junction', 42.9838905334473, 0.750210415125477, -77.5933303833008, -1.35425909277635, 218, 40, 'PPL', 'P'),
(166565, 'Rochester Mills', 40.8186111450195, 0.712419160571843, -78.9858322143555, -1.37856283456831, 218, 45, 'PPL', 'P'),
(202565, 'Rochford', 44.124439239502, 0.770116745325492, -103.719169616699, -1.81024100724587, 218, 49, 'PPL', 'P'),
(189367, 'Rociada', 35.832218170166, 0.625390185362335, -105.420280456543, -1.83993099234251, 218, 38, 'PPL', 'P'),
(11629, 'Rock', 36.271671295166, 0.633060089301763, -93.8661117553711, -1.63827270617618, 218, 4, 'PPL', 'P'),
(28436, 'Rock', 37.4127807617188, 0.652976206618784, -88.6194381713867, -1.54670097735824, 218, 18, 'PPL', 'P'),
(33791, 'Rock', 37.4402809143066, 0.653456174826244, -97.0061111450195, -1.69307603403616, 218, 20, 'PPL', 'P'),
(42842, 'Rock', 31.436939239502, 0.548678096478711, -92.7344436645508, -1.61852137195161, 218, 22, 'PPL', 'P'),
(50927, 'Rock', 39.6252784729004, 0.691591576371743, -76.1402816772461, -1.32889860866385, 218, 25, 'PPL', 'P'),
(57228, 'Rock', 38.0472183227539, 0.66404923095717, -94.5088882446289, -1.64949127226814, 218, 29, 'PPL', 'P'),
(111155, 'Rock', 37.3677787780762, 0.652190773834293, -81.2222213745117, -1.41759518876894, 218, 58, 'PPL', 'P'),
(125967, 'Rock', 41.8416709899902, 0.730274923311525, -70.8619384765625, -1.23677414076167, 218, 23, 'PPL', 'P'),
(132866, 'Rock', 46.0688896179199, 0.804053806570535, -87.1658325195313, -1.52133077270776, 218, 27, 'PPL', 'P'),
(157404, 'Rock', 40.3050003051758, 0.703454960342637, -81.3622207641602, -1.42003863906909, 218, 41, 'PPL', 'P'),
(42843, 'Rock (historical)', 31.1944408416748, 0.544445701005816, -93.5763931274414, -1.63321616221445, 218, 22, 'PPL', 'P'),
(50928, 'Rock Acres', 39.607780456543, 0.691286178373738, -76.3986129760742, -1.33340734038936, 218, 25, 'PPL', 'P'),
(24456, 'Rock and Shoals', 33.8899993896484, 0.591492072848234, -83.3311080932617, -1.45440220556271, 218, 13, 'PPL', 'P'),
(50929, 'Rock Anna', 39.1444396972656, 0.683199356565658, -76.5122222900391, -1.33539019697898, 218, 25, 'PPL', 'P'),
(152151, 'Rock Beach', 43.2452812194824, 0.754772543230837, -77.5824966430664, -1.35407000833896, 218, 40, 'PPL', 'P'),
(17825, 'Rock Bluff', 30.5433292388916, 0.533081659739312, -84.9127807617188, -1.48200760131609, 218, 12, 'PPL', 'P'),
(83342, 'Rock Bluff', 33.6055603027344, 0.586527674260217, -79.8130569458008, -1.39300062978595, 218, 48, 'PPL', 'P'),
(142869, 'Rock Bluff (historical)', 40.9288902282715, 0.714343893670671, -95.8536071777344, -1.67296104516473, 218, 35, 'PPL', 'P'),
(24444, 'Rock Branch', 34.2397193908691, 0.597595838329614, -82.8000030517578, -1.44513267391453, 218, 13, 'PPL', 'P'),
(61568, 'Rock Branch', 32.5449981689453, 0.568017373103621, -89.0852813720703, -1.5548314750082, 218, 30, 'PPL', 'P'),
(112658, 'Rock Branch', 38.4474983215332, 0.671035434865748, -81.8177795410156, -1.42798963966158, 218, 58, 'PPL', 'P'),
(83343, 'Rock Branch North', 34.2027816772461, 0.596951153608733, -80.8158264160156, -1.41050225867968, 218, 48, 'PPL', 'P'),
(24445, 'Rock Bridge', 33.771110534668, 0.589417070884899, -84.0513916015625, -1.46697352433038, 218, 13, 'PPL', 'P'),
(90402, 'Rock Bridge', 36.5138893127441, 0.637287591216155, -86.3833312988281, -1.50767355000562, 218, 50, 'PPL', 'P'),
(189368, 'Rock Cabin', 31.7230606079102, 0.553671856417746, -108.869438171387, -1.90013015088709, 218, 38, 'PPL', 'P'),
(111156, 'Rock Camp', 37.4980583190918, 0.654464580773002, -80.6069412231445, -1.40685652430542, 218, 58, 'PPL', 'P'),
(157405, 'Rock Camp', 40.6938896179199, 0.71024235927584, -80.6627807617188, -1.40783110810633, 218, 41, 'PPL', 'P'),
(189369, 'Rock Canyon', 33.2236099243164, 0.579861382577585, -107.208892822266, -1.87114816716625, 218, 38, 'PPL', 'P'),
(157406, 'Rock Canyon Park', 40.4563903808594, 0.706097215618159, -81.1647186279297, -1.41659157651215, 218, 41, 'PPL', 'P'),
(90405, 'Rock Castle', 36.0263900756836, 0.628779124428488, -85.6733322143555, -1.49528172829543, 218, 50, 'PPL', 'P'),
(111157, 'Rock Cave', 38.836669921875, 0.677827760646968, -80.3427810668945, -1.40224605982627, 218, 58, 'PPL', 'P'),
(24446, 'Rock Chapel', 33.7574996948242, 0.589179516915664, -84.0780563354492, -1.46743891173087, 218, 13, 'PPL', 'P'),
(50931, 'Rock Chapel Estates', 39.500560760498, 0.689414841654766, -77.355827331543, -1.35011388253964, 218, 25, 'PPL', 'P'),
(5456, 'Rock City', 33.9844398498535, 0.593140369825911, -87.708610534668, -1.53080403617934, 218, 2, 'PPL', 'P'),
(24447, 'Rock City', 34.9741706848145, 0.610414431604492, -85.3511123657227, -1.48965793102151, 218, 13, 'PPL', 'P'),
(90404, 'Rock City', 36.5675010681152, 0.638223292865154, -82.4358291625977, -1.43877664049889, 218, 50, 'PPL', 'P'),
(121253, 'Rock City', 42.413330078125, 0.740252256598425, -89.4680633544922, -1.56151228091877, 218, 18, 'PPL', 'P'),
(152154, 'Rock City', 41.9702796936035, 0.732519568636298, -73.8213882446289, -1.28842628326181, 218, 40, 'PPL', 'P'),
(184628, 'Rock City', 37.8497200012207, 0.660602234979253, -121.934440612793, -2.12815746027073, 218, 6, 'PPL', 'P'),
(152155, 'Rock City Falls', 43.061939239502, 0.751572622023052, -73.9175033569336, -1.29010380843245, 218, 40, 'PPL', 'P'),
(111158, 'Rock Cliff', 37.9636116027832, 0.662590018416889, -80.6241683959961, -1.40715719519249, 218, 58, 'PPL', 'P'),
(42844, 'Rock Corner', 32.6416702270508, 0.569704618812241, -92.5374984741211, -1.61508402993264, 218, 22, 'PPL', 'P'),
(5460, 'Rock Creek', 34.1949996948242, 0.596815332393139, -87.3894424438477, -1.52523350212722, 218, 2, 'PPL', 'P'),
(17828, 'Rock Creek', 30.9619407653809, 0.540387809163349, -86.7788925170898, -1.51457739565749, 218, 12, 'PPL', 'P'),
(33792, 'Rock Creek', 39.2458305358887, 0.684968960530988, -95.5369415283203, -1.66743418695449, 218, 20, 'PPL', 'P'),
(37963, 'Rock Creek', 37.4319381713867, 0.653310566493644, -86.1580581665039, -1.50374179213028, 218, 21, 'PPL', 'P'),
(57230, 'Rock Creek', 38.4397201538086, 0.670899680229181, -90.4974975585938, -1.57947929721299, 218, 29, 'PPL', 'P'),
(61570, 'Rock Creek', 32.561939239502, 0.568313050563648, -89.0269393920898, -1.55381321536541, 218, 30, 'PPL', 'P'),
(68295, 'Rock Creek', 35.9744415283203, 0.62787245123537, -79.4658279418945, -1.38694034040937, 218, 33, 'PPL', 'P'),
(77107, 'Rock Creek', 34.8400001525879, 0.608072714057985, -96.1269378662109, -1.67773156562539, 218, 42, 'PPL', 'P'),
(83344, 'Rock Creek', 34.4124984741211, 0.600611402210938, -81.3544387817383, -1.4199028178535, 218, 48, 'PPL', 'P'),
(90406, 'Rock Creek', 36.1588897705078, 0.631091680361058, -82.4036102294922, -1.43821431403472, 218, 50, 'PPL', 'P'),
(111160, 'Rock Creek', 37.8505592346191, 0.660616882365249, -81.4519424438477, -1.42160457779006, 218, 58, 'PPL', 'P'),
(117563, 'Rock Creek', 43.2350006103516, 0.754593112752393, -92.9186096191406, -1.62173567422928, 218, 16, 'PPL', 'P'),
(121254, 'Rock Creek', 40.0458297729492, 0.698931581231137, -91.3994369506836, -1.59522110925839, 218, 18, 'PPL', 'P'),
(137753, 'Rock Creek', 45.7574996948242, 0.798619027154983, -92.9622192382813, -1.62249680566882, 218, 28, 'PPL', 'P'),
(157407, 'Rock Creek', 41.6602783203125, 0.727109023986666, -80.8608322143555, -1.4112877580432, 218, 41, 'PPL', 'P'),
(184629, 'Rock Creek', 39.9027786254883, 0.696434867709188, -121.351936340332, -2.11799084280935, 218, 6, 'PPL', 'P'),
(192124, 'Rock Creek', 34.4633293151855, 0.60149856774907, -101.434440612793, -1.77036496361189, 218, 51, 'PPL', 'P'),
(195544, 'Rock Creek', 42.4322204589844, 0.740581955941377, -114.304718017578, -1.99499367997042, 218, 17, 'PPL', 'P'),
(201492, 'Rock Creek', 45.5727806091309, 0.79539507091836, -120.296112060547, -2.0995632328046, 218, 43, 'PPL', 'P'),
(11630, 'Rock Creek (historical)', 34.3083305358887, 0.598793328713768, -93.5369415283203, -1.63252760191461, 218, 4, 'PPL', 'P'),
(209702, 'Rock Creek (historical)', 41.8416709899902, 0.730274923311525, -105.865562438965, -1.84770262903557, 218, 59, 'PPL', 'P'),
(83345, 'Rock Creek Acres', 34.5402793884277, 0.602841599886797, -82.79638671875, -1.44506955699669, 218, 48, 'PPL', 'P'),
(184630, 'Rock Creek Camp', 39.9266700744629, 0.696851852156867, -121.315002441406, -2.1173462246675, 218, 6, 'PPL', 'P'),
(123571, 'Rock Creek Center', 40.7855606079102, 0.711842319879732, -85.3925018310547, -1.49038031346719, 218, 19, 'PPL', 'P'),
(24448, 'Rock Creek Estates', 34.0852813720703, 0.594900386411317, -83.9833297729492, -1.46578562132615, 218, 13, 'PPL', 'P'),
(50932, 'Rock Creek Estates', 39.1572189331055, 0.683422396306952, -76.5055618286133, -1.3352739499974, 218, 25, 'PPL', 'P'),
(50934, 'Rock Creek Forest', 38.9908294677734, 0.680518352296275, -77.0566711425781, -1.34489262206449, 218, 25, 'PPL', 'P'),
(13200, 'Rock Creek Gardens', 38.9886093139648, 0.680479603302414, -77.0458297729492, -1.34470340446904, 218, 9, 'PPL', 'P'),
(50935, 'Rock Creek Gardens', 38.9930610656738, 0.680557301027217, -77.0472183227539, -1.34472763923496, 218, 25, 'PPL', 'P'),
(50936, 'Rock Creek Hills', 39.014720916748, 0.680935336743954, -77.0711135864258, -1.34514469026167, 218, 25, 'PPL', 'P'),
(57231, 'Rock Creek Junction', 39.1136093139648, 0.682661264867407, -94.4794387817383, -1.64897728217775, 218, 29, 'PPL', 'P'),
(50937, 'Rock Creek Knolls', 38.9972190856934, 0.680629872166922, -77.0658264160156, -1.34505241172989, 218, 25, 'PPL', 'P'),
(50938, 'Rock Creek Landing', 39.1366691589355, 0.683063735087145, -76.5272216796875, -1.33565198571413, 218, 25, 'PPL', 'P'),
(50939, 'Rock Creek Palisades', 39.0355606079102, 0.681299057969831, -77.0769424438477, -1.34524642301531, 218, 25, 'PPL', 'P'),
(5461, 'Rock Creek Park', 31.2583293914795, 0.545560766554233, -85.4416732788086, -1.49123851712847, 218, 2, 'PPL', 'P'),
(50940, 'Rock Creek Park', 39.1458282470703, 0.683223591331577, -76.4911117553711, -1.33502174864216, 218, 25, 'PPL', 'P'),
(187267, 'Rock Creek Pprk', 38.7024993896484, 0.675486043100461, -104.838607788086, -1.82977888910907, 218, 7, 'PPL', 'P'),
(50941, 'Rock Creek Village', 39.0811080932617, 0.68209401155522, -77.102783203125, -1.34569742934591, 218, 25, 'PPL', 'P'),
(184631, 'Rock Crest', 39.9269409179688, 0.696856579267802, -121.315559387207, -2.11735594520548, 218, 6, 'PPL', 'P'),
(97567, 'Rock Crossing', 33.9811096191406, 0.59308224633512, -99.1488876342773, -1.73047453890803, 218, 51, 'PPL', 'P'),
(178997, 'Rock Crossing', 36.7261085510254, 0.640991515660237, -113.341110229492, -1.97817555137046, 218, 5, 'PPL', 'P'),
(187268, 'Rock Crossing', 37.7700004577637, 0.659210866467742, -104.123611450195, -1.81729984887318, 218, 7, 'PPL', 'P'),
(197410, 'Rock Crossing', 48.4925003051758, 0.846353792849672, -104.346939086914, -1.82119765144462, 218, 31, 'PPL', 'P'),
(157408, 'Rock Cut', 40.0677795410156, 0.699314676953945, -81.9766693115234, -1.43076278930468, 218, 41, 'PPL', 'P'),
(137755, 'Rock Dell', 43.9208297729492, 0.766563089745917, -92.6383285522461, -1.61684384678097, 218, 28, 'PPL', 'P'),
(176131, 'Rock Elm', 44.7366714477539, 0.780802213146244, -92.2163925170898, -1.60947967373468, 218, 57, 'PPL', 'P'),
(105820, 'Rock Enon', 39.2041702270508, 0.684241850974369, -78.4086074829102, -1.36848836248065, 218, 53, 'PPL', 'P'),
(105821, 'Rock Enon Springs', 39.2119407653809, 0.684377472452881, -78.3866729736328, -1.36810553307395, 218, 53, 'PPL', 'P'),
(117565, 'Rock Falls', 43.2075004577637, 0.754113144544933, -93.0844421386719, -1.62462999770198, 218, 16, 'PPL', 'P'),
(121257, 'Rock Falls', 41.7797203063965, 0.729193679908953, -89.6888885498047, -1.56536640764833, 218, 18, 'PPL', 'P'),
(176133, 'Rock Falls', 44.7186088562012, 0.780486961452206, -91.6897201538086, -1.60028750691616, 218, 57, 'PPL', 'P'),
(24449, 'Rock Falls Estates', 33.9361114501953, 0.592296880129656, -84.7922210693359, -1.47990343773882, 218, 13, 'PPL', 'P'),
(166570, 'Rock Falls Park', 41.0374984741211, 0.716239465155562, -80.0327835083008, -1.39683558175567, 218, 45, 'PPL', 'P'),
(5462, 'Rock Fence', 33.0361099243164, 0.576588890230096, -85.438606262207, -1.49118498759056, 218, 2, 'PPL', 'P'),
(24450, 'Rock Fence Crossroads', 33.0261116027832, 0.576414386599669, -81.5780563354492, -1.42380568043101, 218, 13, 'PPL', 'P'),
(57233, 'Rock Ford', 38.3230590820313, 0.668863560417761, -91.2563934326172, -1.5927245288945, 218, 29, 'PPL', 'P'),
(111161, 'Rock Forge', 39.6049995422363, 0.691237642262871, -79.9175033569336, -1.39482356355211, 218, 58, 'PPL', 'P'),
(152158, 'Rock Glen', 42.6858291625977, 0.745008262831143, -78.1191711425781, -1.36343674536693, 218, 40, 'PPL', 'P'),
(166568, 'Rock Glen', 40.9652786254883, 0.714978991011628, -76.1847229003906, -1.32967425433134, 218, 45, 'PPL', 'P'),
(121258, 'Rock Grove', 42.4630584716797, 0.741120180797682, -89.5119400024414, -1.56227807289022, 218, 18, 'PPL', 'P'),
(50943, 'Rock Hall', 39.1380615234375, 0.683088036432092, -76.2352828979492, -1.33055669275854, 218, 25, 'PPL', 'P'),
(105822, 'Rock Hall', 39.1683311462402, 0.683616341013337, -78.0605621337891, -1.36241382519223, 218, 53, 'PPL', 'P'),
(17829, 'Rock Harbor', 25.0763893127441, 0.437665558019303, -80.460563659668, -1.4043017538717, 218, 12, 'PPL', 'P'),
(125968, 'Rock Harbor', 41.7972183227539, 0.729499077906958, -70.0041732788086, -1.22180331385184, 218, 23, 'PPL', 'P'),
(132868, 'Rock Harbor Lodge', 48.1458282470703, 0.840303224011067, -88.4836120605469, -1.54433036451391, 218, 27, 'PPL', 'P'),
(37964, 'Rock Haven', 37.9469413757324, 0.662299068067797, -86.0547180175781, -1.50193816628203, 218, 21, 'PPL', 'P'),
(90407, 'Rock Haven', 36.3413887023926, 0.63427688760382, -83.3872222900391, -1.45538158305359, 218, 50, 'PPL', 'P'),
(184632, 'Rock Haven', 37.1258316040039, 0.647967999030836, -119.318328857422, -2.08249769653938, 218, 6, 'PPL', 'P'),
(198819, 'Rock Haven', 46.8733291625977, 0.818093925258406, -100.888610839844, -1.76083843691852, 218, 34, 'PPL', 'P'),
(184633, 'Rock Haven (historical)', 32.9963912963867, 0.575895669398348, -116.967781066895, -2.0414728983692, 218, 6, 'PPL', 'P'),
(157410, 'Rock Haven Park', 40.0563888549805, 0.699115871978571, -82.2294387817383, -1.43517444880845, 218, 41, 'PPL', 'P'),
(5463, 'Rock Hill', 31.1163902282715, 0.543083460818727, -86.9991683959961, -1.51842193500713, 218, 2, 'PPL', 'P'),
(11632, 'Rock Hill', 36.0297203063965, 0.628837247919279, -90.5216674804688, -1.57990114192966, 218, 4, 'PPL', 'P'),
(17830, 'Rock Hill', 30.6005592346191, 0.53408051159566, -86.1061096191406, -1.50283511893716, 218, 12, 'PPL', 'P'),
(24451, 'Rock Hill', 31.3280601501465, 0.546777797882885, -85.0316696166992, -1.48408260327943, 218, 13, 'PPL', 'P'),
(30991, 'Rock Hill', 37.9449996948242, 0.662265179342926, -87.0400009155273, -1.51913459691483, 218, 19, 'PPL', 'P'),
(42845, 'Rock Hill', 31.4469394683838, 0.548852633398652, -92.5708312988281, -1.61566579747277, 218, 22, 'PPL', 'P'),
(57232, 'Rock Hill', 38.6074981689453, 0.673827959005778, -90.3783264160156, -1.57739936840164, 218, 29, 'PPL', 'P'),
(61573, 'Rock Hill', 32.1861114501953, 0.561753618219755, -89.9222183227539, -1.56943878042923, 218, 30, 'PPL', 'P'),
(83348, 'Rock Hill', 34.9247207641602, 0.609551367674225, -81.0252838134766, -1.41415797990803, 218, 48, 'PPL', 'P'),
(90410, 'Rock Hill', 36.4097213745117, 0.635469517718985, -82.2724990844727, -1.43592599286807, 218, 50, 'PPL', 'P'),
(97568, 'Rock Hill', 31.9727802276611, 0.558030285989229, -95.0227813720703, -1.65846039934536, 218, 51, 'PPL', 'P'),
(105824, 'Rock Hill', 39.0658302307129, 0.681827362551076, -77.82861328125, -1.3583655540192, 218, 53, 'PPL', 'P'),
(152156, 'Rock Hill', 41.6258316040039, 0.726507815370581, -74.5980606079102, -1.30198177321031, 218, 40, 'PPL', 'P'),
(157409, 'Rock Hill', 40.1388893127441, 0.700555776600949, -81.1052780151367, -1.41555414210951, 218, 41, 'PPL', 'P'),
(166569, 'Rock Hill', 40.4049987792969, 0.70520026296302, -75.3000030517578, -1.31423298001495, 218, 45, 'PPL', 'P'),
(50944, 'Rock Hill Beach', 39.1500015258789, 0.683296428787391, -76.5188903808594, -1.33550657711861, 218, 25, 'PPL', 'P'),
(90412, 'Rock House', 36.3688888549805, 0.63475685581128, -86.1013870239258, -1.50275269410143, 218, 50, 'PPL', 'P'),
(200170, 'Rock House', 41.9841690063477, 0.732761982874523, -115.661392211914, -2.01867211153843, 218, 39, 'PPL', 'P'),
(195545, 'Rock House Place', 42.172779083252, 0.736053849718942, -114.780563354492, -2.00329874782984, 218, 17, 'PPL', 'P'),
(17832, 'Rock Island', 26.1122207641602, 0.455744227342224, -81.3444366455078, -1.41972824764404, 218, 12, 'PPL', 'P'),
(77111, 'Rock Island', 35.1822204589844, 0.614045585171788, -94.4736099243164, -1.64887554942411, 218, 42, 'PPL', 'P'),
(90413, 'Rock Island', 35.7922210693359, 0.624692104261598, -85.6133270263672, -1.49423444019675, 218, 50, 'PPL', 'P'),
(97572, 'Rock Island', 30.1725006103516, 0.526609479210633, -96.125, -1.67769774347955, 218, 51, 'PPL', 'P'),
(121260, 'Rock Island', 41.5094413757324, 0.724476422670095, -90.57861328125, -1.58089503364848, 218, 18, 'PPL', 'P'),
(125970, 'Rock Island', 42.2622184753418, 0.737614861591892, -70.9625015258789, -1.23852929707809, 218, 23, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(208583, 'Rock Island', 47.3772201538086, 0.826888482126174, -120.142776489258, -2.09688702222518, 218, 56, 'PPL', 'P'),
(17833, 'Rock Island Village', 26.1602802276611, 0.456583023217059, -80.1744384765625, -1.39930792735364, 218, 12, 'PPL', 'P'),
(140782, 'Rock Lake', 48.7902793884277, 0.851551018295989, -99.2458267211914, -1.73216644514856, 218, 34, 'PPL', 'P'),
(111162, 'Rock Lake Village', 38.3472213745117, 0.669285271976375, -81.7411117553711, -1.42665153437187, 218, 58, 'PPL', 'P'),
(113996, 'Rock Landing', 41.496940612793, 0.724258243197791, -72.5208282470703, -1.26572722918468, 218, 8, 'PPL', 'P'),
(125971, 'Rock Landing', 41.564998626709, 0.725446079622993, -70.4694366455078, -1.22992369148966, 218, 23, 'PPL', 'P'),
(172465, 'Rock Landing', 44.1988906860352, 0.771416168200369, -73.315559387207, -1.2795979042482, 218, 55, 'PPL', 'P'),
(152157, 'Rock Ledge Beach', 43.3694381713867, 0.756939490830807, -78.2211074829102, -1.36521587013316, 218, 40, 'PPL', 'P'),
(90414, 'Rock Ledge Estates', 35.1297187805176, 0.613129258019719, -85.0766677856445, -1.48486796948489, 218, 50, 'PPL', 'P'),
(37965, 'Rock Lick', 37.6522216796875, 0.657155239001337, -83.3119430541992, -1.4540677125298, 218, 21, 'PPL', 'P'),
(14506, 'Rock Manor', 39.7694396972656, 0.694107664390622, -75.5458297729492, -1.31852346568912, 218, 10, 'PPL', 'P'),
(50948, 'Rock Manor', 39.6549987792969, 0.692110293573063, -76.2544403076172, -1.3308910526334, 218, 25, 'PPL', 'P'),
(74107, 'Rock Mill', 39.749439239502, 0.69375859055074, -82.7125015258789, -1.44360548418742, 218, 41, 'PPL', 'P'),
(146202, 'Rock Mill', 40.4375, 0.705767516275207, -74.7433319091797, -1.30451723572612, 218, 37, 'PPL', 'P'),
(5465, 'Rock Mills', 33.1597213745117, 0.578746317029169, -85.2874984741211, -1.48854765916305, 218, 2, 'PPL', 'P'),
(74108, 'Rock Mills', 39.4430618286133, 0.688411295976997, -83.4091720581055, -1.4557646787764, 218, 41, 'PPL', 'P'),
(105826, 'Rock Mills', 38.6549987792969, 0.674657001053119, -78.1297225952148, -1.36362090295631, 218, 53, 'PPL', 'P'),
(111163, 'Rock Oak', 39.1483306884766, 0.683267267173455, -78.7361068725586, -1.37420430512828, 218, 58, 'PPL', 'P'),
(50945, 'Rock Point', 38.2719383239746, 0.667971334873557, -76.8411102294922, -1.34113037439253, 218, 25, 'PPL', 'P'),
(166571, 'Rock Point', 40.8594398498535, 0.713131755900521, -80.3133316040039, -1.40173206973589, 218, 45, 'PPL', 'P'),
(178998, 'Rock Point', 36.7180595397949, 0.640851033912735, -109.625282287598, -1.9133221193468, 218, 5, 'PPL', 'P'),
(139426, 'Rock Port', 40.4111099243164, 0.705306922564678, -95.5166702270508, -1.66708038600368, 218, 29, 'PPL', 'P'),
(57234, 'Rock Prairie', 37.4830589294434, 0.654202792037847, -93.2024993896484, -1.62669048543737, 218, 29, 'PPL', 'P'),
(117567, 'Rock Rapids', 43.4272193908691, 0.757947963356593, -96.1755599975586, -1.67858018190675, 218, 16, 'PPL', 'P'),
(113997, 'Rock Raymond', 41.290828704834, 0.720660911776339, -73.2747192382813, -1.27888510918244, 218, 8, 'PPL', 'P'),
(68299, 'Rock Rest', 34.9544410705566, 0.610070084875545, -80.4836120605469, -1.40470402435436, 218, 33, 'PPL', 'P'),
(17834, 'Rock Ridge', 28.3022193908691, 0.49396691399245, -81.9372177124023, -1.43007422900484, 218, 12, 'PPL', 'P'),
(68300, 'Rock Ridge', 35.7019386291504, 0.623116378423625, -78.067497253418, -1.36253486586377, 218, 33, 'PPL', 'P'),
(113998, 'Rock Ridge', 41.0349998474121, 0.716195855892712, -73.6463928222656, -1.28537203696565, 218, 8, 'PPL', 'P'),
(152159, 'Rock Rift', 42.0922203063965, 0.734647833821435, -75.1922225952148, -1.31235185617897, 218, 40, 'PPL', 'P'),
(132867, 'Rock River', 46.4638900756836, 0.810947865105396, -86.9130630493164, -1.51691911320399, 218, 27, 'PPL', 'P'),
(209703, 'Rock River', 41.7413902282715, 0.728524693843125, -105.974166870117, -1.84959813394144, 218, 59, 'PPL', 'P'),
(5467, 'Rock Run', 34.0277786254883, 0.593896774154521, -85.4952774047852, -1.49217408561941, 218, 2, 'PPL', 'P'),
(50947, 'Rock Run', 39.6080589294434, 0.691291038642727, -76.1433334350586, -1.32895187188566, 218, 25, 'PPL', 'P'),
(105828, 'Rock Run', 36.7188911437988, 0.640865548140676, -79.9680633544922, -1.39570600197931, 218, 53, 'PPL', 'P'),
(50949, 'Rock Run Estates', 39.6269416809082, 0.691620604827624, -76.1286087036133, -1.32869487684046, 218, 25, 'PPL', 'P'),
(121263, 'Rock Run Park', 41.480281829834, 0.723967492585781, -88.1791687011719, -1.53901682550698, 218, 18, 'PPL', 'P'),
(5468, 'Rock Spring', 33.9366683959961, 0.592306600667635, -85.9105606079102, -1.49942214484217, 218, 2, 'PPL', 'P'),
(24452, 'Rock Spring', 34.8241691589355, 0.60779641109489, -85.2427825927734, -1.48776721980561, 218, 13, 'PPL', 'P'),
(37966, 'Rock Spring', 37.4949989318848, 0.654411184393146, -87.8775024414063, -1.53375175603189, 218, 21, 'PPL', 'P'),
(50950, 'Rock Spring', 39.5727806091309, 0.690675315798701, -76.3852767944336, -1.33317458011009, 218, 25, 'PPL', 'P'),
(68301, 'Rock Spring', 35.6324996948242, 0.621904440390557, -77.4452819824219, -1.3516751607287, 218, 33, 'PPL', 'P'),
(5472, 'Rock Springs', 31.9713897705078, 0.558006017933796, -86.9908294677734, -1.51827639325355, 218, 2, 'PPL', 'P'),
(11636, 'Rock Springs', 35.9447212219238, 0.62735373403405, -92.5352783203125, -1.61504528093878, 218, 4, 'PPL', 'P'),
(24455, 'Rock Springs', 32.0730590820313, 0.559780482168115, -82.4147186279297, -1.43840819216208, 218, 13, 'PPL', 'P'),
(37968, 'Rock Springs', 37.725830078125, 0.658439947911191, -87.6547164916992, -1.52986340768232, 218, 21, 'PPL', 'P'),
(50951, 'Rock Springs', 39.7150001525879, 0.693157515092709, -76.1588897705078, -1.32922338115879, 218, 25, 'PPL', 'P'),
(57236, 'Rock Springs', 37.7563896179199, 0.658973312498506, -90.4833297729492, -1.57923202270578, 218, 29, 'PPL', 'P'),
(68303, 'Rock Springs', 35.3955612182617, 0.617769083849882, -82.1308288574219, -1.43345338095398, 218, 33, 'PPL', 'P'),
(74109, 'Rock Springs', 39.060001373291, 0.681725629797435, -82.01611328125, -1.43145121644646, 218, 41, 'PPL', 'P'),
(90419, 'Rock Springs', 36.4652786254883, 0.636439174671883, -82.5541687011719, -1.4408420550823, 218, 50, 'PPL', 'P'),
(97575, 'Rock Springs', 32.7911109924316, 0.572312852204838, -94.5350036621094, -1.64994707228871, 218, 51, 'PPL', 'P'),
(176135, 'Rock Springs', 43.4925003051758, 0.759087330249956, -89.9188919067383, -1.56938072351747, 218, 57, 'PPL', 'P'),
(178999, 'Rock Springs', 34.0488891601563, 0.594265222491333, -112.14778137207, -1.95734803374939, 218, 5, 'PPL', 'P'),
(189370, 'Rock Springs', 35.6094398498535, 0.621501970170819, -108.82861328125, -1.89941762213744, 218, 38, 'PPL', 'P'),
(197411, 'Rock Springs', 46.8169403076172, 0.817109754077567, -106.246391296387, -1.85434934648419, 218, 31, 'PPL', 'P'),
(209704, 'Rock Springs', 41.5875015258789, 0.725838829304753, -109.202217102051, -1.90593823890845, 218, 59, 'PPL', 'P'),
(184634, 'Rock Springs (historical)', 35.4219398498535, 0.61822947782333, -118.741668701172, -2.07243307814775, 218, 6, 'PPL', 'P'),
(152160, 'Rock Stream', 42.4711112976074, 0.741260729124211, -76.9277801513672, -1.3426430498917, 218, 40, 'PPL', 'P'),
(152161, 'Rock Tavern', 41.4661102294922, 0.72372015149954, -74.1916732788086, -1.29488897627911, 218, 40, 'PPL', 'P'),
(90420, 'Rock Town', 36.1383285522461, 0.63073281940417, -83.4511108398438, -1.456496648602, 218, 50, 'PPL', 'P'),
(117568, 'Rock Valley', 43.2052803039551, 0.754074395551073, -96.2947235107422, -1.68065997756004, 218, 16, 'PPL', 'P'),
(125972, 'Rock Valley', 42.1938896179199, 0.736422298055755, -72.6763916015625, -1.26844232191602, 218, 23, 'PPL', 'P'),
(152162, 'Rock Valley', 41.8894386291504, 0.731108625890774, -75.084716796875, -1.31047552603296, 218, 40, 'PPL', 'P'),
(111164, 'Rock View', 37.6177787780762, 0.656554096964278, -81.5391693115234, -1.4231269738272, 218, 58, 'PPL', 'P'),
(189371, 'Rock Wall', 36.1766700744629, 0.63140200520708, -105.620277404785, -1.84342159758327, 218, 38, 'PPL', 'P'),
(817, 'Rock Way', 39.9275016784668, 0.696866366384808, -83.8786087036133, -1.46395789387002, 218, 41, 'PPL', 'P'),
(24457, 'Rockalo', 33.3758316040039, 0.582518152081048, -85.2058334350586, -1.48712233534764, 218, 13, 'PPL', 'P'),
(50952, 'Rockawalking Acres', 38.378059387207, 0.66982349683268, -75.6830596923828, -1.32091857961549, 218, 25, 'PPL', 'P'),
(633, 'Rockawalking Estates', 38.3638916015625, 0.669576222325466, -75.6774978637695, -1.32082150739375, 218, 25, 'PPL', 'P'),
(50953, 'Rockawalking Village', 38.3916702270508, 0.670061050801915, -75.6716690063477, -1.32071977464011, 218, 25, 'PPL', 'P'),
(105829, 'Rockaway', 37.851390838623, 0.66063139659319, -78.2641677856445, -1.36596741419278, 218, 53, 'PPL', 'P'),
(146203, 'Rockaway', 40.9011116027832, 0.713859065194222, -74.5147171020508, -1.30052715462291, 218, 37, 'PPL', 'P'),
(157411, 'Rockaway', 41.0830612182617, 0.71703468505706, -83.0541687011719, -1.44956870134227, 218, 41, 'PPL', 'P'),
(117574, 'Rockaway (historical)', 42.1030616760254, 0.734837051416885, -90.4122161865234, -1.57799085647975, 218, 16, 'PPL', 'P'),
(50954, 'Rockaway Beach', 39.2947196960449, 0.685822237344249, -76.3994369506836, -1.33342172145925, 218, 25, 'PPL', 'P'),
(57239, 'Rockaway Beach', 36.6991691589355, 0.640521334569783, -93.1597213745117, -1.62594386822577, 218, 29, 'PPL', 'P'),
(176140, 'Rockaway Beach', 44.0463905334473, 0.768754538427916, -88.5097198486328, -1.54478603137642, 218, 57, 'PPL', 'P'),
(184635, 'Rockaway Beach', 37.6086082458496, 0.656394040982765, -122.494171142578, -2.13792660093941, 218, 6, 'PPL', 'P'),
(195546, 'Rockaway Beach', 47.7886085510254, 0.83406856416211, -116.698890686035, -2.03677987589626, 218, 17, 'PPL', 'P'),
(201495, 'Rockaway Beach', 45.6136093139648, 0.796107666247038, -123.941673278809, -2.16319027914629, 218, 43, 'PPL', 'P'),
(208585, 'Rockaway Beach', 48.2055587768555, 0.841345718419778, -122.535278320313, -2.13864405653708, 218, 56, 'PPL', 'P'),
(192125, 'Rockaway Country Sites Colonia', 28.6669998168945, 0.500333533473421, -100.434997558594, -1.75292139162993, 218, 51, 'PPL', 'P'),
(152163, 'Rockaway Park', 40.5800018310547, 0.708254642417232, -73.836669921875, -1.28869299884498, 218, 40, 'PPL', 'P'),
(152164, 'Rockaway Point', 40.5605583190918, 0.707915289115329, -73.9155578613281, -1.29006985312855, 218, 40, 'PPL', 'P'),
(146204, 'Rockaway Valley', 40.9280586242676, 0.71432937944273, -74.4447174072266, -1.29930542947284, 218, 37, 'PPL', 'P'),
(24458, 'Rockbridge', 33.8122215270996, 0.590134593061593, -84.1074981689453, -1.4679527686632, 218, 13, 'PPL', 'P'),
(28440, 'Rockbridge', 39.2691688537598, 0.685376291019716, -90.2041702270508, -1.57435976949148, 218, 18, 'PPL', 'P'),
(37969, 'Rockbridge', 36.7838897705078, 0.641999988186023, -85.6841735839844, -1.49547094589088, 218, 21, 'PPL', 'P'),
(57240, 'Rockbridge', 36.7894401550293, 0.642096860670674, -92.4088897705078, -1.61283938460787, 218, 29, 'PPL', 'P'),
(74110, 'Rockbridge', 39.579719543457, 0.690796423049272, -82.522216796875, -1.44028438915004, 218, 41, 'PPL', 'P'),
(176141, 'Rockbridge', 43.4483299255371, 0.758316411693405, -90.3638916015625, -1.57714743336252, 218, 57, 'PPL', 'P'),
(24459, 'Rockbrook', 33.4902801513672, 0.584515656056662, -82.0311126708984, -1.43171300518162, 218, 13, 'PPL', 'P'),
(105831, 'Rockbrook', 38.0497207641602, 0.664092906799048, -78.4688873291016, -1.36954044426928, 218, 53, 'PPL', 'P'),
(50955, 'Rockbrook Trailer Park', 39.6375007629395, 0.691804895575058, -76.8324966430664, -1.340980038949, 218, 25, 'PPL', 'P'),
(50956, 'Rockburn Commons', 39.2066688537598, 0.684285460237219, -76.7333297729492, -1.33924925055656, 218, 25, 'PPL', 'P'),
(37970, 'Rockcastle', 36.8997192382813, 0.644021593769502, -87.9872207641602, -1.53566670201372, 218, 21, 'PPL', 'P'),
(37974, 'Rockcastle Shores', 36.8836097717285, 0.643740430537417, -87.977783203125, -1.53550198550029, 218, 21, 'PPL', 'P'),
(201493, 'Rockcreek', 45.5502815246582, 0.795002387815628, -122.875831604004, -2.14458783261597, 218, 43, 'PPL', 'P'),
(50957, 'Rockcrest', 39.0755615234375, 0.681997205649596, -77.1308288574219, -1.34618691835427, 218, 25, 'PPL', 'P'),
(5476, 'Rockcut', 32.5133285522461, 0.567464634019376, -87.841667175293, -1.53312631264989, 218, 2, 'PPL', 'P'),
(5474, 'Rockdale', 33.3758316040039, 0.582518152081048, -85.4833297729492, -1.49196556010606, 218, 2, 'PPL', 'P'),
(17835, 'Rockdale', 25.6286106109619, 0.447303637872841, -80.3411102294922, -1.40221689821234, 218, 12, 'PPL', 'P'),
(24460, 'Rockdale', 33.7869415283203, 0.589693373847994, -84.4349975585938, -1.47366871131083, 218, 13, 'PPL', 'P'),
(30992, 'Rockdale', 39.3169403076172, 0.686210060177992, -84.8469390869141, -1.48085844730572, 218, 19, 'PPL', 'P'),
(37973, 'Rockdale', 38.4091682434082, 0.67036644879992, -84.6847229003906, -1.47802724075086, 218, 21, 'PPL', 'P'),
(50959, 'Rockdale', 39.7011108398438, 0.692915100854485, -77.8441696166992, -1.35863706329233, 218, 25, 'PPL', 'P'),
(68304, 'Rockdale', 35.4824981689453, 0.619286419880955, -81.508056640625, -1.42258395528093, 218, 33, 'PPL', 'P'),
(74111, 'Rockdale', 39.4324989318848, 0.688226938650536, -84.4552764892578, -1.47402264541971, 218, 41, 'PPL', 'P'),
(90424, 'Rockdale', 35.4711112976074, 0.619087681484608, -87.2563934326172, -1.52291135881473, 218, 50, 'PPL', 'P'),
(97577, 'Rockdale', 33.1130599975586, 0.577931922367823, -95.6372222900391, -1.66918441642289, 218, 51, 'PPL', 'P'),
(117575, 'Rockdale', 42.464168548584, 0.741139555294612, -90.6783294677734, -1.58263540942084, 218, 16, 'PPL', 'P'),
(121265, 'Rockdale', 41.5061111450195, 0.724418299179304, -88.1144409179688, -1.53788711257257, 218, 18, 'PPL', 'P'),
(125980, 'Rockdale', 41.651668548584, 0.726958755122158, -70.9599990844727, -1.23848562123621, 218, 23, 'PPL', 'P'),
(152165, 'Rockdale', 42.378059387207, 0.739636666912453, -75.4080581665039, -1.31611889754089, 218, 40, 'PPL', 'P'),
(166577, 'Rockdale', 40.1083297729492, 0.700022412013634, -74.8816680908203, -1.30693165757039, 218, 45, 'PPL', 'P'),
(176143, 'Rockdale', 42.9719390869141, 0.750001823033096, -89.0308303833008, -1.5538811259732, 218, 57, 'PPL', 'P'),
(177271, 'Rockdale', 40.3047218322754, 0.703450100073647, -80.5802764892578, -1.40639113690493, 218, 58, 'PPL', 'P'),
(187269, 'Rockdale', 38.9913902282715, 0.680528139413281, -106.411109924316, -1.85722422888094, 218, 7, 'PPL', 'P'),
(208584, 'Rockdale', 47.3925018310547, 0.827155197709346, -121.453056335449, -2.11975571966375, 218, 56, 'PPL', 'P'),
(166576, 'Rockdale Acres', 41.7669410705566, 0.728970640167659, -79.9238891601563, -1.39493501684373, 218, 45, 'PPL', 'P'),
(121266, 'Rockdale Junction', 41.5641708374023, 0.72543163197408, -88.1066665649414, -1.53775142451503, 218, 18, 'PPL', 'P'),
(50960, 'Rockdale Manor', 39.5308303833008, 0.689943146236011, -76.4086074829102, -1.33358177744076, 218, 25, 'PPL', 'P'),
(125973, 'Rockdale Mills', 42.2911109924316, 0.738119131144299, -73.3766708374023, -1.28066450026478, 218, 23, 'PPL', 'P'),
(105833, 'Rockdell', 36.8905601501465, 0.64386173752507, -81.9538879394531, -1.43036517935393, 218, 53, 'PPL', 'P'),
(209705, 'Rockeagle', 42.0027809143066, 0.733086821948485, -104.581108093262, -1.82528467161151, 218, 59, 'PPL', 'P'),
(121267, 'Rockefeller', 42.2686080932617, 0.737726381462539, -87.9986114501953, -1.53586550698909, 218, 18, 'PPL', 'P'),
(146207, 'Rockefellows Mills', 40.519718170166, 0.707202494049569, -74.8211135864258, -1.30587478209179, 218, 37, 'PPL', 'P'),
(197412, 'Rocker', 46.0033302307129, 0.802909579408183, -112.605278015137, -1.96533285648772, 218, 31, 'PPL', 'P'),
(202567, 'Rockerville', 43.9580612182617, 0.767212901051897, -103.358062744141, -1.80393850336814, 218, 49, 'PPL', 'P'),
(97578, 'Rockett', 32.4697189331055, 0.566703502579831, -96.7636108398438, -1.68884360527375, 218, 51, 'PPL', 'P'),
(105834, 'Rocketts', 37.5213890075684, 0.654871778103675, -77.3899993896484, -1.35071029746577, 218, 53, 'PPL', 'P'),
(79039, 'Rockey', 39.8988914489746, 0.696367023680418, -76.5180587768555, -1.33549206289067, 218, 45, 'PPL', 'P'),
(37977, 'Rockfield', 36.9102783203125, 0.644205884516935, -86.5644378662109, -1.51083445590344, 218, 21, 'PPL', 'P'),
(42846, 'Rockfield', 32.290828704834, 0.563581279096849, -92.7249984741211, -1.61835652228013, 218, 22, 'PPL', 'P'),
(123581, 'Rockfield', 40.6411094665527, 0.709321171854782, -86.5738906860352, -1.51099943873297, 218, 19, 'PPL', 'P'),
(176145, 'Rockfield', 43.2574996948242, 0.754985795855125, -88.126106262207, -1.53809071123791, 218, 57, 'PPL', 'P'),
(68305, 'Rockfish', 34.9925003051758, 0.610734343830438, -79.0663909912109, -1.37996885046581, 218, 33, 'PPL', 'P'),
(105835, 'Rockfish', 37.8011093139648, 0.659753818434981, -78.7558288574219, -1.37454851869918, 218, 53, 'PPL', 'P'),
(5475, 'Rockford', 32.8894386291504, 0.574028993211285, -86.2197189331055, -1.50481797552678, 218, 2, 'PPL', 'P'),
(57241, 'Rockford', 39.3463897705078, 0.686724050268377, -92.9141693115234, -1.62165817624156, 218, 29, 'PPL', 'P'),
(68308, 'Rockford', 36.2683296203613, 0.63300176607389, -80.6488876342773, -1.40758862728908, 218, 33, 'PPL', 'P'),
(90422, 'Rockford', 35.8274993896484, 0.625307827105624, -83.9408264160156, -1.4650437978045, 218, 50, 'PPL', 'P'),
(97579, 'Rockford', 33.4877815246582, 0.584472046793812, -95.4505615234375, -1.6659265714614, 218, 51, 'PPL', 'P'),
(111165, 'Rockford', 39.1363906860352, 0.683058874818156, -80.3324966430664, -1.4020665627688, 218, 58, 'PPL', 'P'),
(117576, 'Rockford', 43.0522193908691, 0.751402978661614, -92.9483337402344, -1.62225445800963, 218, 16, 'PPL', 'P'),
(121268, 'Rockford', 42.271110534668, 0.737770057304417, -89.0938873291016, -1.55498167729368, 218, 18, 'PPL', 'P'),
(123573, 'Rockford', 40.7599983215332, 0.711396173818117, -85.313606262207, -1.48900332602557, 218, 19, 'PPL', 'P'),
(132870, 'Rockford', 43.1199989318848, 0.752585954817827, -85.5599975585938, -1.49330366539577, 218, 27, 'PPL', 'P'),
(137758, 'Rockford', 45.0883293151855, 0.786939800773468, -93.7341690063477, -1.63596987078159, 218, 28, 'PPL', 'P'),
(142879, 'Rockford', 40.2516708374023, 0.702524185541654, -96.5999984741211, -1.68598803079491, 218, 35, 'PPL', 'P'),
(157413, 'Rockford', 40.4769401550293, 0.706455876837965, -81.3086090087891, -1.41910293742009, 218, 41, 'PPL', 'P'),
(195547, 'Rockford', 43.1897201538086, 0.753802819698912, -112.533889770508, -1.96408689657173, 218, 17, 'PPL', 'P'),
(201494, 'Rockford', 45.6791687011719, 0.797251893409391, -121.553329467773, -2.12150581597409, 218, 43, 'PPL', 'P'),
(208586, 'Rockford', 47.452220916748, 0.828197492380976, -117.129722595215, -2.0442993112341, 218, 56, 'PPL', 'P'),
(33801, 'Rockford (historical)', 37.7583312988281, 0.659007201223378, -95.0500030517578, -1.65893550728383, 218, 20, 'PPL', 'P'),
(57242, 'Rockford (historical)', 38.5644416809082, 0.673076481525185, -94.2377777099609, -1.64475950080134, 218, 29, 'PPL', 'P'),
(197413, 'Rockford (historical)', 46.9402809143066, 0.819262453765705, -109.615280151367, -1.91314754913735, 218, 31, 'PPL', 'P'),
(195549, 'Rockford Bay', 47.5052795410156, 0.829123540071023, -116.877502441406, -2.03989723911025, 218, 17, 'PPL', 'P'),
(57243, 'Rockford Beach', 38.4219398498535, 0.67058935538316, -90.5899963378906, -1.5810937054658, 218, 29, 'PPL', 'P'),
(166580, 'Rockford Heights', 40.3349990844727, 0.703978537812946, -76.7699966430664, -1.3398892081665, 218, 45, 'PPL', 'P'),
(137759, 'Rockford Riverview Estates', 45.0833282470703, 0.786852515668741, -93.7416687011719, -1.63610076514917, 218, 28, 'PPL', 'P'),
(83350, 'Rockgate', 34.098331451416, 0.595128153263546, -81.038330078125, -1.41438568018123, 218, 48, 'PPL', 'P'),
(171210, 'Rockham', 44.9038887023926, 0.783720704805835, -98.8244400024414, -1.7248118594822, 218, 49, 'PPL', 'P'),
(61574, 'Rockhill', 34.714168548584, 0.605876538265052, -89.7391662597656, -1.56624391922752, 218, 30, 'PPL', 'P'),
(97580, 'Rockhill', 33.2038917541504, 0.57951723558572, -96.8022232055664, -1.68951751818759, 218, 51, 'PPL', 'P'),
(166581, 'Rockhill', 40.2416687011719, 0.702349615332199, -77.9000015258789, -1.35961151393519, 218, 45, 'PPL', 'P'),
(50966, 'Rockhill Beach', 39.1438903808594, 0.683189769185733, -76.5236129760742, -1.33558900195435, 218, 25, 'PPL', 'P'),
(166583, 'Rockhill Station', 40.4058303833008, 0.705214777190961, -75.3072204589844, -1.31435894753451, 218, 45, 'PPL', 'P'),
(37975, 'Rockholds', 36.8286094665527, 0.642780494122498, -84.1163864135742, -1.46810789779669, 218, 21, 'PPL', 'P'),
(11638, 'Rockhouse', 36.2819404602051, 0.633239320043125, -93.6727828979492, -1.63489848107505, 218, 4, 'PPL', 'P'),
(37976, 'Rockhouse', 37.3269386291504, 0.651477978768533, -82.4524993896484, -1.43906759084798, 218, 21, 'PPL', 'P'),
(97581, 'Rockhouse', 29.9570598602295, 0.522849328778037, -96.5559005737305, -1.68521837723988, 218, 51, 'PPL', 'P'),
(105837, 'Rockhouse', 37.038330078125, 0.64644080930373, -81.6836090087891, -1.42564792211507, 218, 53, 'PPL', 'P'),
(74112, 'Rockhouse (historical)', 39.4938888549805, 0.689298394936102, -82.6149978637695, -1.44190372425086, 218, 41, 'PPL', 'P'),
(5477, 'Rockhouse Landing', 34.5625, 0.60322942272054, -86.845832824707, -1.51574572442771, 218, 2, 'PPL', 'P'),
(152166, 'Rockhurst', 43.4738883972168, 0.758762491175994, -73.6358337402344, -1.28518774621822, 218, 40, 'PPL', 'P'),
(184636, 'Rocking K', 37.3611106872559, 0.652074393694656, -118.480003356934, -2.06786615635243, 218, 6, 'PPL', 'P'),
(24462, 'Rockingham', 31.547779083252, 0.550612616694545, -82.4166717529297, -1.43844228062403, 218, 13, 'PPL', 'P'),
(57246, 'Rockingham', 39.3566703796387, 0.686903480746822, -93.7822189331055, -1.63680850020885, 218, 29, 'PPL', 'P'),
(68313, 'Rockingham', 34.9391708374023, 0.609803569029455, -79.774169921875, -1.39232192318215, 218, 33, 'PPL', 'P'),
(144377, 'Rockingham', 43.0499992370605, 0.751364229667753, -70.9333267211914, -1.23802010067766, 218, 36, 'PPL', 'P'),
(146208, 'Rockingham', 40.3977813720703, 0.705074295443459, -74.6194381713867, -1.30235488207903, 218, 37, 'PPL', 'P'),
(172466, 'Rockingham', 43.1875, 0.753764070705051, -72.4894409179688, -1.26517941694846, 218, 55, 'PPL', 'P'),
(117579, 'Rockingham (historical)', 41.4824981689453, 0.724006175000615, -90.6333312988281, -1.58185004321538, 218, 16, 'PPL', 'P'),
(105839, 'Rockingham Court', 37.214168548584, 0.64950976956491, -79.9222183227539, -1.3949058552298, 218, 53, 'PPL', 'P'),
(14507, 'Rockland', 39.7961082458496, 0.694573118370141, -75.5725021362305, -1.31898898624767, 218, 10, 'PPL', 'P'),
(33803, 'Rockland', 38.4286117553711, 0.670705802101823, -96.6436080932617, -1.68674916223446, 218, 20, 'PPL', 'P'),
(37978, 'Rockland', 37.0897216796875, 0.647337761958869, -86.5838928222656, -1.51117400894242, 218, 21, 'PPL', 'P'),
(50963, 'Rockland', 39.0724983215332, 0.681943742690712, -77.1266708374023, -1.34611434721456, 218, 25, 'PPL', 'P'),
(74113, 'Rockland', 39.2811088562012, 0.685584683375014, -81.6061096191406, -1.42429530259742, 218, 41, 'PPL', 'P'),
(83351, 'Rockland', 32.6124992370605, 0.569195488990845, -80.2027816772461, -1.39980260952612, 218, 48, 'PPL', 'P'),
(90425, 'Rockland', 36.3011093139648, 0.633573879655067, -86.6419372558594, -1.51218707542109, 218, 50, 'PPL', 'P'),
(97582, 'Rockland', 31.0149993896484, 0.541313856853397, -94.3813934326172, -1.64726606801932, 218, 51, 'PPL', 'P'),
(105840, 'Rockland', 38.9894409179688, 0.680494117530355, -78.1413879394531, -1.36382450162164, 218, 53, 'PPL', 'P'),
(111166, 'Rockland', 38.9441719055176, 0.679704024213956, -78.6927795410156, -1.37344810053675, 218, 58, 'PPL', 'P'),
(113103, 'Rockland', 44.1036109924316, 0.769753223836696, -69.1094436645508, -1.20618733616795, 218, 26, 'PPL', 'P'),
(113999, 'Rockland', 41.4116706848145, 0.722770002201627, -72.6563873291016, -1.26809318149711, 218, 8, 'PPL', 'P'),
(125974, 'Rockland', 42.1305618286133, 0.735317019624345, -70.9166717529297, -1.23772941664468, 218, 23, 'PPL', 'P'),
(132872, 'Rockland', 46.7380599975586, 0.81573303295205, -89.179443359375, -1.55647491171689, 218, 27, 'PPL', 'P'),
(152167, 'Rockland', 41.9452781677246, 0.732083209691689, -74.913330078125, -1.30748426349658, 218, 40, 'PPL', 'P'),
(166585, 'Rockland', 41.2772216796875, 0.720423424386131, -79.7491683959961, -1.39188556423754, 218, 45, 'PPL', 'P'),
(176146, 'Rockland', 43.9063911437988, 0.766311088127769, -90.9191665649414, -1.58683880972737, 218, 57, 'PPL', 'P'),
(193916, 'Rockland', 41.9811096191406, 0.732708586494667, -123.960563659668, -2.16351997848924, 218, 6, 'PPL', 'P'),
(194402, 'Rockland', 40.5105590820313, 0.707042637805137, -102.719436645508, -1.79279237525783, 218, 7, 'PPL', 'P'),
(195548, 'Rockland', 42.5733299255371, 0.743044780738455, -112.876388549805, -1.97006462795452, 218, 17, 'PPL', 'P'),
(169579, 'Rockland (historical)', 41.7869415283203, 0.729319714007541, -71.6672210693359, -1.25082897341456, 218, 47, 'PPL', 'P'),
(201496, 'Rockland (historical)', 43.2686080932617, 0.755179673982483, -123.070831298828, -2.14799121933104, 218, 43, 'PPL', 'P'),
(50964, 'Rockland Estates', 39.5783309936523, 0.690772188283352, -77.0455627441406, -1.34469874393713, 218, 25, 'PPL', 'P'),
(152169, 'Rockland Lake', 41.1383285522461, 0.717999282003886, -73.9375, -1.29045281569331, 218, 40, 'PPL', 'P'),
(50965, 'Rockland Run', 39.3877792358398, 0.687446432714061, -76.6750030517578, -1.33823125722987, 218, 25, 'PPL', 'P'),
(14508, 'Rockland Woods', 39.7963905334473, 0.694578045218157, -75.57861328125, -1.31909564584933, 218, 10, 'PPL', 'P'),
(30994, 'Rocklane', 39.6097183227539, 0.691320000519582, -86.0124969482422, -1.5012012696084, 218, 19, 'PPL', 'P'),
(24463, 'Rocklane Estates', 33.6377792358398, 0.587090000724387, -84.3236083984375, -1.47172460371508, 218, 13, 'PPL', 'P'),
(5478, 'Rockledge', 34.089168548584, 0.594968230440087, -86.1127777099609, -1.5029514990768, 218, 2, 'PPL', 'P'),
(17836, 'Rockledge', 28.3505592346191, 0.494810603425788, -80.7255630493164, -1.40892686573685, 218, 12, 'PPL', 'P'),
(24464, 'Rockledge', 32.4427795410156, 0.566233321489377, -82.6977767944336, -1.44334848914223, 218, 13, 'PPL', 'P'),
(90426, 'Rockledge', 35.1477813720703, 0.613444509713757, -85.9674987792969, -1.50041590340294, 218, 50, 'PPL', 'P'),
(166588, 'Rockledge', 40.0811080932617, 0.699547304075163, -75.0899963378906, -1.31056767140668, 218, 45, 'PPL', 'P'),
(179000, 'Rockledge', 34.9680595397949, 0.610307772002834, -111.470001220703, -1.94551853850337, 218, 5, 'PPL', 'P'),
(192126, 'Rockledge', 35.1752815246582, 0.613924477921217, -100.818893432617, -1.75962163861646, 218, 51, 'PPL', 'P'),
(157414, 'Rockledge Farms', 41.5769386291504, 0.725654471978292, -83.6047210693359, -1.45917765287139, 218, 41, 'PPL', 'P'),
(146209, 'Rockleigh', 41.0002784729004, 0.715589853586664, -73.9308319091797, -1.29033643555367, 218, 37, 'PPL', 'P'),
(111169, 'Rocklick', 39.8730583190918, 0.695916150507868, -80.5272216796875, -1.40546515579391, 218, 58, 'PPL', 'P'),
(184637, 'Rocklin', 38.790828704834, 0.677027680476481, -121.234718322754, -2.11594500245995, 218, 6, 'PPL', 'P'),
(166590, 'Rocklyn', 40.0774993896484, 0.699484320315383, -75.852783203125, -1.32388081369598, 218, 45, 'PPL', 'P'),
(208587, 'Rocklyn', 47.6297187805176, 0.83129541451901, -118.268608093262, -2.06417661297823, 218, 56, 'PPL', 'P'),
(117580, 'Rocklyn Mobile Home', 41.6158294677734, 0.726333245161126, -93.7088928222656, -1.63552871814702, 218, 16, 'PPL', 'P'),
(24465, 'Rockmart', 34.002498626709, 0.593455554940922, -85.0416717529297, -1.48425717348888, 218, 13, 'PPL', 'P'),
(166591, 'Rockmere', 41.4313888549805, 0.723114149193493, -79.6594390869141, -1.39031949235852, 218, 45, 'PPL', 'P'),
(24466, 'Rockmill (historical)', 32.8633308410645, 0.573573326348772, -83.8361129760742, -1.46321620350644, 218, 13, 'PPL', 'P'),
(176149, 'Rockmont', 46.5858306884766, 0.813076130290533, -91.9086074829102, -1.60410781149988, 218, 57, 'PPL', 'P'),
(97583, 'Rockne', 29.9955596923828, 0.523521277610578, -97.4308319091797, -1.70048880977234, 218, 51, 'PPL', 'P'),
(11639, 'Rockport', 34.3875007629395, 0.600175109845355, -92.8252792358398, -1.62010675174853, 218, 4, 'PPL', 'P'),
(28442, 'Rockport', 39.538890838623, 0.690083827720594, -91.0086135864258, -1.58839995475837, 218, 18, 'PPL', 'P'),
(30998, 'Rockport', 37.8830604553223, 0.661184135677436, -87.0494384765625, -1.51929931342825, 218, 19, 'PPL', 'P'),
(37979, 'Rockport', 37.3338890075684, 0.651599285756186, -86.9961090087891, -1.51836853862727, 218, 21, 'PPL', 'P'),
(61575, 'Rockport', 31.7947196960449, 0.554922543444675, -90.1566696166992, -1.57353072744414, 218, 30, 'PPL', 'P'),
(90427, 'Rockport', 35.9419403076172, 0.627305197923184, -88.0175018310547, -1.53619520633204, 218, 50, 'PPL', 'P'),
(97588, 'Rockport', 28.0202808380127, 0.489046157956797, -97.0541687011719, -1.69391479662148, 218, 51, 'PPL', 'P'),
(111172, 'Rockport', 39.0741691589355, 0.681972904304649, -81.5533294677734, -1.42337411517636, 218, 58, 'PPL', 'P'),
(125976, 'Rockport', 42.6555595397949, 0.744479958249899, -70.6208267211914, -1.23256594676518, 218, 23, 'PPL', 'P'),
(128678, 'Rockport', 44.184440612793, 0.771163966845138, -69.0766677856445, -1.2056152891658, 218, 26, 'PPL', 'P'),
(132873, 'Rockport', 45.2038917541504, 0.788956745825039, -83.3855590820313, -1.45535255459771, 218, 27, 'PPL', 'P'),
(146212, 'Rockport', 40.8236083984375, 0.712506379097544, -74.8772201538086, -1.30685402642461, 218, 37, 'PPL', 'P'),
(157416, 'Rockport', 41.4655609130859, 0.723710564119616, -81.8388900756836, -1.42835808799839, 218, 41, 'PPL', 'P'),
(166592, 'Rockport', 40.9650001525879, 0.714974130742638, -75.7636108398438, -1.32232446235494, 218, 45, 'PPL', 'P'),
(184638, 'Rockport', 39.7388916015625, 0.693574499540388, -123.815002441406, -2.16097945596736, 218, 6, 'PPL', 'P'),
(194403, 'Rockport', 40.898609161377, 0.713815389352345, -104.796112060547, -1.82903719874548, 218, 7, 'PPL', 'P'),
(208589, 'Rockport', 48.4858283996582, 0.846237346131009, -121.596389770508, -2.12225736003371, 218, 56, 'PPL', 'P'),
(61576, 'Rockport (historical)', 33.1722183227539, 0.578964429922447, -89.7708282470703, -1.56679652515371, 218, 30, 'PPL', 'P'),
(74114, 'Rockport (historical)', 39.6866683959961, 0.692663032657309, -80.8666687011719, -1.4113896239549, 218, 41, 'PPL', 'P'),
(171212, 'Rockport Colony', 43.5819396972656, 0.760648342122906, -97.8386077880859, -1.70760584146947, 218, 49, 'PPL', 'P'),
(197414, 'Rockport Colony', 48.0669403076172, 0.838926369727496, -112.474998474121, -1.96305904954901, 218, 31, 'PPL', 'P'),
(30996, 'Rockport Junction', 38.1072196960449, 0.665096452476817, -87.0066680908203, -1.5185528293747, 218, 19, 'PPL', 'P'),
(90428, 'Rockquarry (historical)', 35.4341697692871, 0.6184429301847, -87.3688888549805, -1.52487477432839, 218, 50, 'PPL', 'P'),
(24467, 'Rockridge', 33.3052787780762, 0.581286772972023, -85.1338882446289, -1.48586665489367, 218, 13, 'PPL', 'P'),
(111171, 'Rockridge', 37.3766708374023, 0.652345969546817, -81.8269424438477, -1.42814956248504, 218, 58, 'PPL', 'P'),
(50967, 'Rockridge Forest', 39.6497192382813, 0.692018148199346, -76.383056640625, -1.33313583111623, 218, 25, 'PPL', 'P'),
(197415, 'Rocks Trailer Court', 46.7491683959961, 0.815926911079408, -114.077781677246, -1.9910328936392, 218, 31, 'PPL', 'P'),
(125978, 'Rocks Village', 42.8097190856934, 0.747170549899206, -71.0027770996094, -1.23923223844781, 218, 23, 'PPL', 'P'),
(79048, 'Rocks Works', 39.8372192382813, 0.695290640546835, -79.896110534668, -1.39445018836728, 218, 45, 'PPL', 'P'),
(111173, 'Rocksdale', 38.8447189331055, 0.677968242394469, -81.2183303833008, -1.41752727816115, 218, 58, 'PPL', 'P'),
(24468, 'Rockspray', 33.3777809143066, 0.582552173963974, -84.5469436645508, -1.47562253944457, 218, 13, 'PPL', 'P'),
(166593, 'Rockspring', 40.7088890075684, 0.710504148010995, -77.9677810668945, -1.36079449009141, 218, 45, 'PPL', 'P'),
(17837, 'Rocksprings', 29.1172199249268, 0.508191356717268, -82.3836135864258, -1.43786530677386, 218, 12, 'PPL', 'P'),
(90429, 'Rocksprings', 35.9563903808594, 0.627557399278414, -86.5969390869141, -1.51140170921562, 218, 50, 'PPL', 'P'),
(192127, 'Rocksprings', 30.0155601501465, 0.52387035145046, -100.205001831055, -1.74890720891885, 218, 51, 'PPL', 'P'),
(42847, 'Rockthrow', 32.524169921875, 0.567653851614826, -92.1861114501953, -1.60895116941635, 218, 22, 'PPL', 'P'),
(83352, 'Rockton', 34.3472213745117, 0.599472101896602, -81.0875015258789, -1.41524388384251, 218, 48, 'PPL', 'P'),
(111176, 'Rockton', 38.6194381713867, 0.674036351361076, -80.8563919067383, -1.41121026005548, 218, 58, 'PPL', 'P'),
(117581, 'Rockton', 42.0530586242676, 0.733964333527666, -92.8369369506836, -1.62031021725581, 218, 16, 'PPL', 'P'),
(121270, 'Rockton', 42.4524993896484, 0.740935890050248, -89.0722198486328, -1.55460350841889, 218, 18, 'PPL', 'P'),
(152171, 'Rockton', 42.9533309936523, 0.749677050538161, -74.1725006103516, -1.29455435008814, 218, 40, 'PPL', 'P'),
(166594, 'Rockton', 41.0755615234375, 0.716903790689482, -78.6533279418945, -1.37275954023691, 218, 45, 'PPL', 'P'),
(176150, 'Rockton', 43.6411094665527, 0.761681049414611, -90.6016693115234, -1.58129743728919, 218, 57, 'PPL', 'P'),
(105841, 'Rocktown', 36.7122192382813, 0.640749101422012, -82.1402816772461, -1.43361836378351, 218, 53, 'PPL', 'P'),
(146213, 'Rocktown', 40.4058303833008, 0.705214777190961, -74.8616714477539, -1.30658265030954, 218, 37, 'PPL', 'P'),
(166595, 'Rocktown', 40.1738891601563, 0.701166639175986, -79.5933303833008, -1.38916567781624, 218, 45, 'PPL', 'P'),
(184639, 'Rocktram', 38.2574996948242, 0.667719333255408, -122.279441833496, -2.1341788674954, 218, 6, 'PPL', 'P'),
(37980, 'Rockvale', 37.6324996948242, 0.656811025430444, -86.5766677856445, -1.51104790826481, 218, 21, 'PPL', 'P'),
(83353, 'Rockvale', 34.7708282470703, 0.606865436556825, -82.4233322143555, -1.43855852760561, 218, 48, 'PPL', 'P'),
(90430, 'Rockvale', 35.7572212219238, 0.624081241686561, -86.5313873291016, -1.51025761521132, 218, 50, 'PPL', 'P'),
(187270, 'Rockvale', 38.1194381713867, 0.665309705101105, -105.163887023926, -1.83545608276285, 218, 7, 'PPL', 'P'),
(197416, 'Rockvale', 45.5224990844727, 0.794517492760152, -108.861106872559, -1.89998474229157, 218, 31, 'PPL', 'P'),
(57247, 'Rockview', 37.202220916748, 0.649301244051557, -89.6394424438477, -1.56450341029709, 218, 29, 'PPL', 'P'),
(68312, 'Rockview', 35.7852783203125, 0.624570930431999, -82.4297180175781, -1.43866998089723, 218, 33, 'PPL', 'P'),
(132874, 'Rockview', 46.0858306884766, 0.804349484030561, -84.3627777099609, -1.4724082371669, 218, 27, 'PPL', 'P'),
(50968, 'Rockview Beach', 39.1430587768555, 0.683175254957792, -76.5152816772461, -1.33544359335883, 218, 25, 'PPL', 'P'),
(5479, 'Rockville', 31.4200000762939, 0.548382452308199, -87.8424987792969, -1.53314082687783, 218, 2, 'PPL', 'P'),
(24469, 'Rockville', 33.3274993896484, 0.581674595805766, -83.2188873291016, -1.45244358373901, 218, 13, 'PPL', 'P'),
(30997, 'Rockville', 39.7625007629395, 0.693986557140051, -87.2291717529297, -1.52243625087626, 218, 19, 'PPL', 'P'),
(50969, 'Rockville', 39.0838890075684, 0.682142547666087, -77.1530609130859, -1.34657494092509, 218, 25, 'PPL', 'P'),
(57248, 'Rockville', 38.0713882446289, 0.664471075673839, -94.0794372558594, -1.64199593853817, 218, 29, 'PPL', 'P'),
(83354, 'Rockville', 32.6005592346191, 0.568987096635547, -80.1949996948242, -1.39966678831053, 218, 48, 'PPL', 'P'),
(90431, 'Rockville', 35.6002807617188, 0.621342113926387, -84.3683319091797, -1.47250517623058, 218, 50, 'PPL', 'P'),
(105842, 'Rockville', 37.725830078125, 0.658439947911191, -77.6786117553711, -1.3557475335096, 218, 53, 'PPL', 'P'),
(111175, 'Rockville', 39.6213912963867, 0.691523732342973, -79.7050018310547, -1.39111471226001, 218, 58, 'PPL', 'P'),
(114000, 'Rockville', 41.8666687011719, 0.730711215677107, -72.4499969482422, -1.26449098980667, 218, 8, 'PPL', 'P'),
(117582, 'Rockville', 42.4186096191406, 0.740344401972142, -91.1419372558594, -1.59072689176083, 218, 16, 'PPL', 'P'),
(125979, 'Rockville', 42.1405601501465, 0.735491523254772, -71.3597183227539, -1.24546203802778, 218, 23, 'PPL', 'P'),
(128680, 'Rockville', 44.1547203063965, 0.770645249643818, -69.116943359375, -1.20631823053552, 218, 26, 'PPL', 'P'),
(137763, 'Rockville', 45.4719390869141, 0.793635054332954, -94.3405609130859, -1.64655340611162, 218, 28, 'PPL', 'P'),
(142883, 'Rockville', 41.1183280944824, 0.717650208164004, -98.8313903808594, -1.72493316646985, 218, 35, 'PPL', 'P'),
(152173, 'Rockville', 41.4844398498535, 0.724040063725486, -74.4161071777344, -1.29880608676845, 218, 40, 'PPL', 'P'),
(157417, 'Rockville', 40.689998626709, 0.710174448668043, -81.5100021362305, -1.42261791058483, 218, 41, 'PPL', 'P'),
(166605, 'Rockville', 40.7844390869141, 0.71182274564572, -75.4980621337891, -1.31768976310987, 218, 45, 'PPL', 'P'),
(169580, 'Rockville', 41.519718170166, 0.724655786569512, -71.7616729736328, -1.25247747012932, 218, 47, 'PPL', 'P'),
(172468, 'Rockville', 44.2455596923828, 0.77223069601977, -73.0647201538086, -1.27521993373222, 218, 55, 'PPL', 'P'),
(176152, 'Rockville', 43.9199981689453, 0.766548575517977, -87.9977798461914, -1.53585099276115, 218, 57, 'PPL', 'P'),
(184640, 'Rockville', 38.2441711425781, 0.66748670613419, -122.121109008789, -2.13141543839028, 218, 6, 'PPL', 'P'),
(192761, 'Rockville', 37.1611099243164, 0.648583721874862, -113.037498474121, -1.97287652659148, 218, 52, 'PPL', 'P'),
(195551, 'Rockville', 43.3427810668945, 0.75647423658837, -117.000282287598, -2.04204015168138, 218, 17, 'PPL', 'P'),
(152174, 'Rockville Centre', 40.6586112976074, 0.709626636431814, -73.6416702270508, -1.28528961212992, 218, 40, 'PPL', 'P'),
(97584, 'Rockwall', 32.9311103820801, 0.574756302504985, -96.4594421386719, -1.68353485995679, 218, 51, 'PPL', 'P'),
(11640, 'Rockwell', 34.464168548584, 0.601513215135066, -93.1336135864258, -1.62548820136325, 218, 4, 'PPL', 'P'),
(17838, 'Rockwell', 28.2941703796387, 0.493826432244949, -80.6747207641602, -1.40803950046163, 218, 12, 'PPL', 'P'),
(50970, 'Rockwell', 39.2772216796875, 0.685516839346245, -76.7763900756836, -1.34000079461618, 218, 25, 'PPL', 'P'),
(68317, 'Rockwell', 35.5511093139648, 0.620483910265109, -80.4066696166992, -1.40336112537469, 218, 33, 'PPL', 'P'),
(97586, 'Rockwell', 33.5911102294922, 0.586275472904987, -95.5494384765625, -1.66765229984777, 218, 51, 'PPL', 'P'),
(117583, 'Rockwell', 42.985279083252, 0.750234649891396, -93.1916732788086, -1.62650153415803, 218, 16, 'PPL', 'P'),
(187867, 'Rockwell', 39.8333282470703, 0.695222729939038, -100.08332824707, -1.74678360426562, 218, 20, 'PPL', 'P'),
(208588, 'Rockwell', 47.1474990844727, 0.82287909310506, -118.009437561035, -2.05965323386673, 218, 56, 'PPL', 'P'),
(157418, 'Rockwell (historical)', 41.6166687011719, 0.726347892547121, -83.503059387207, -1.45740332179512, 218, 41, 'PPL', 'P'),
(117584, 'Rockwell City', 42.3952789306641, 0.739937204641469, -94.6336135864258, -1.65166814014317, 218, 16, 'PPL', 'P'),
(24470, 'Rockwell Estates', 33.0286102294922, 0.576457995862519, -85.0761108398438, -1.48485824894691, 218, 13, 'PPL', 'P'),
(152175, 'Rockwells Mills', 42.4486083984375, 0.740867979442451, -75.3902816772461, -1.3158086392739, 218, 40, 'PPL', 'P'),
(5480, 'Rockwest', 31.999719619751, 0.558500467079682, -87.3716735839844, -1.52492337701828, 218, 2, 'PPL', 'P'),
(5481, 'Rockwood', 34.4550018310547, 0.601353225732579, -87.7847213745117, -1.53213242093107, 218, 2, 'PPL', 'P'),
(28443, 'Rockwood', 37.8405609130859, 0.660442378734821, -89.7005615234375, -1.56557013947173, 218, 18, 'PPL', 'P'),
(37981, 'Rockwood', 38.0555610656738, 0.66419483928977, -84.4563903808594, -1.47404208649566, 218, 21, 'PPL', 'P'),
(71345, 'Rockwood', 39.6944389343262, 0.692798654135821, -74.6916732788086, -1.30361562253908, 218, 37, 'PPL', 'P'),
(74116, 'Rockwood', 38.4308280944824, 0.670744484516657, -82.4388885498047, -1.43883003687875, 218, 41, 'PPL', 'P'),
(90433, 'Rockwood', 35.8655586242676, 0.625972086060517, -84.6849975585938, -1.47803203444082, 218, 50, 'PPL', 'P'),
(97587, 'Rockwood', 31.5008296966553, 0.549793195316641, -99.3730621337891, -1.73438712202352, 218, 51, 'PPL', 'P'),
(128681, 'Rockwood', 45.6777801513672, 0.797227658643471, -69.7413864135742, -1.21721681782251, 218, 26, 'PPL', 'P'),
(132875, 'Rockwood', 42.0708312988281, 0.734274525215633, -83.2466735839844, -1.45292854537352, 218, 27, 'PPL', 'P'),
(144379, 'Rockwood', 42.7941703796387, 0.746899173784127, -72.1816711425781, -1.25980782102977, 218, 36, 'PPL', 'P'),
(152176, 'Rockwood', 43.0580596923828, 0.751504911152337, -74.5044403076172, -1.3003477907235, 218, 40, 'PPL', 'P'),
(166606, 'Rockwood', 40.3802795410156, 0.704768830866427, -76.4513931274414, -1.33432852781042, 218, 45, 'PPL', 'P'),
(176153, 'Rockwood', 44.1680603027344, 0.770878076502118, -87.7055587768555, -1.53075077295754, 218, 57, 'PPL', 'P'),
(184641, 'Rockwood', 33.0488891601563, 0.57681192997139, -115.511940002441, -2.01606367840875, 218, 6, 'PPL', 'P'),
(187271, 'Rockwood', 37.4908294677734, 0.65433841351636, -107.801391601563, -1.88148922167903, 218, 7, 'PPL', 'P'),
(201497, 'Rockwood', 45.5191688537598, 0.794459369269361, -122.475830078125, -2.13760648897639, 218, 43, 'PPL', 'P'),
(50971, 'Rockwood Beach', 39.1591682434082, 0.683456418189877, -76.4847183227539, -1.33491016219249, 218, 25, 'PPL', 'P'),
(137767, 'Rockwood Estates', 45.7305603027344, 0.79814884606453, -94.1922225952148, -1.6439644140579, 218, 28, 'PPL', 'P'),
(90432, 'Rockwood Hill', 36.1283302307129, 0.630558315773743, -82.8605575561523, -1.44618954939312, 218, 50, 'PPL', 'P'),
(14509, 'Rockwood Hills', 39.7794418334961, 0.694282234600077, -75.5277786254883, -1.31820841373217, 218, 10, 'PPL', 'P'),
(157419, 'Rockwood Park', 40.5027809143066, 0.70690688316857, -81.1577835083008, -1.4164705358406, 218, 41, 'PPL', 'P'),
(79045, 'Rockwood Station', 39.910831451416, 0.696575416035717, -79.1605606079102, -1.38161242033256, 218, 45, 'PPL', 'P'),
(14510, 'Rockwood Woods', 39.7738914489746, 0.694185362115425, -75.5255584716797, -1.31816966473831, 218, 10, 'PPL', 'P'),
(11641, 'Rocky', 34.5916709899902, 0.603738552541936, -94.3691711425781, -1.64705274881601, 218, 4, 'PPL', 'P'),
(77116, 'Rocky', 35.1569404602051, 0.613604365958189, -99.0599975585938, -1.72892311441501, 218, 42, 'PPL', 'P'),
(187272, 'Rocky', 39.8608283996582, 0.695702698146498, -105.246940612793, -1.83690564134418, 218, 7, 'PPL', 'P'),
(50973, 'Rocky Acres', 39.0569381713867, 0.681672166838552, -76.9116668701172, -1.34236182008059, 218, 25, 'PPL', 'P'),
(105843, 'Rocky Bar', 38.3436088562012, 0.669222221637567, -78.7019424438477, -1.37360802336021, 218, 53, 'PPL', 'P'),
(195550, 'Rocky Bar', 43.6891708374023, 0.762519878578959, -115.289169311523, -2.01217559637529, 218, 17, 'PPL', 'P'),
(83355, 'Rocky Bluff Crossroads', 33.9794387817383, 0.593053084721184, -80.2980575561523, -1.40146548731077, 218, 48, 'PPL', 'P'),
(83356, 'Rocky Bottom', 35.0458297729492, 0.611665118631421, -82.8024978637695, -1.44517621659835, 218, 48, 'PPL', 'P'),
(197417, 'Rocky Boy', 48.2561111450195, 0.842228023688922, -109.787498474121, -1.91615332590166, 218, 31, 'PPL', 'P'),
(5482, 'Rocky Branch', 33.3238906860352, 0.581611612045985, -85.3952789306641, -1.49042878299903, 218, 2, 'PPL', 'P'),
(42848, 'Rocky Branch', 32.6786117553711, 0.570349370112149, -92.2030563354492, -1.60924691345541, 218, 22, 'PPL', 'P'),
(61577, 'Rocky Branch', 31.3138904571533, 0.546530490086158, -89.6324996948242, -1.5643822364675, 218, 30, 'PPL', 'P'),
(90434, 'Rocky Branch', 35.7408294677734, 0.623795151606459, -83.8411102294922, -1.46330342203214, 218, 50, 'PPL', 'P'),
(97589, 'Rocky Branch', 33.1113891601563, 0.577902760753887, -94.6977767944336, -1.65278799938155, 218, 51, 'PPL', 'P'),
(169581, 'Rocky Brook', 41.4536094665527, 0.723501972027235, -71.5038909912109, -1.24797832578374, 218, 47, 'PPL', 'P'),
(50975, 'Rocky Brook Park', 39.0511093139648, 0.681570434084911, -76.9972229003906, -1.34385505450379, 218, 25, 'PPL', 'P'),
(208590, 'Rocky Butte', 48.0561103820801, 0.838737351869128, -119.690277099609, -2.08898941801255, 218, 56, 'PPL', 'P'),
(11643, 'Rocky Comfort', 33.7050018310547, 0.588263256342622, -94.4055633544922, -1.64768791273599, 218, 4, 'PPL', 'P'),
(57250, 'Rocky Comfort', 36.7463912963867, 0.641345516348136, -94.0902786254883, -1.64218515613362, 218, 29, 'PPL', 'P'),
(11644, 'Rocky Comfort (historical)', 36.4658317565918, 0.636448828630834, -94.3011093139648, -1.64586484581178, 218, 4, 'PPL', 'P'),
(176154, 'Rocky Corners', 44.714168548584, 0.780409463464485, -89.607780456543, -1.5639508043709, 218, 57, 'PPL', 'P'),
(17839, 'Rocky Creek', 28.0041694641113, 0.488764961435199, -82.579719543457, -1.44128800140683, 218, 12, 'PPL', 'P'),
(24472, 'Rocky Creek', 33.4324989318848, 0.583507183530877, -83.8036117553711, -1.46264895019425, 218, 13, 'PPL', 'P'),
(97591, 'Rocky Creek', 30.2533302307129, 0.528020222219076, -98.5266723632813, -1.71961483377296, 218, 51, 'PPL', 'P'),
(24473, 'Rocky Creek (historical)', 34.4711112976074, 0.601634388964664, -85.067497253418, -1.48470791350338, 218, 13, 'PPL', 'P'),
(137770, 'Rocky Creek Estates', 44.0550003051758, 0.768904807292424, -92.4494400024414, -1.61354711966756, 218, 28, 'PPL', 'P'),
(90435, 'Rocky Creek Subdivision', 36.3908309936523, 0.635139818376033, -86.2522201538086, -1.50538522883897, 218, 50, 'PPL', 'P'),
(197418, 'Rocky Creek Trailer Court', 45.6847190856934, 0.797348765894043, -111.002777099609, -1.93736393924555, 218, 31, 'PPL', 'P'),
(68319, 'Rocky Cross', 35.8630599975586, 0.625928476797667, -78.2222213745117, -1.36523531120911, 218, 33, 'PPL', 'P'),
(197419, 'Rocky Crossing', 48.2661094665527, 0.842402527319349, -110.06916809082, -1.9210693881159, 218, 31, 'PPL', 'P'),
(209707, 'Rocky Crossing', 42.1047210693359, 0.73486601329374, -108.329437255859, -1.89070535694736, 218, 59, 'PPL', 'P'),
(172469, 'Rocky Dale', 44.1291694641113, 0.770199303319284, -73.0494384765625, -1.27495321814905, 218, 55, 'PPL', 'P'),
(24474, 'Rocky Face', 34.8050003051758, 0.607461851482949, -85.0274963378906, -1.48400976582361, 218, 13, 'PPL', 'P'),
(24475, 'Rocky Ford', 32.663330078125, 0.570082654528978, -81.829719543457, -1.42819803201688, 218, 13, 'PPL', 'P'),
(33806, 'Rocky Ford', 37.8172187805176, 0.660034981667067, -96.0508270263672, -1.67640318087366, 218, 20, 'PPL', 'P'),
(61578, 'Rocky Ford', 34.3708305358887, 0.599884159496264, -89.1133270263672, -1.55532096401656, 218, 30, 'PPL', 'P'),
(68320, 'Rocky Ford', 36.1997184753418, 0.631804275689736, -78.3436126708984, -1.36735398901433, 218, 33, 'PPL', 'P'),
(77121, 'Rocky Ford', 36.1758308410645, 0.631387357821084, -94.9108276367188, -1.65650643805357, 218, 42, 'PPL', 'P'),
(111177, 'Rocky Ford', 38.954719543457, 0.679888115224307, -80.2877807617188, -1.40128612341135, 218, 58, 'PPL', 'P'),
(123574, 'Rocky Ford', 40.3997192382813, 0.705108117589303, -87.3280563354492, -1.52416211242068, 218, 19, 'PPL', 'P'),
(187273, 'Rocky Ford', 38.0525016784668, 0.664141442909914, -103.719718933105, -1.81025059462579, 218, 7, 'PPL', 'P'),
(202569, 'Rocky Ford', 43.2863883972168, 0.755489998828504, -103.597778320313, -1.80812232944065, 218, 49, 'PPL', 'P'),
(57251, 'Rocky Ford (historical)', 38.035831451416, 0.663850492560823, -94.1944427490234, -1.64400316305176, 218, 29, 'PPL', 'P'),
(166607, 'Rocky Forest', 41.6344413757324, 0.726658084235088, -76.1977767944336, -1.3299020877626, 218, 45, 'PPL', 'P'),
(50974, 'Rocky Forge', 39.7183303833008, 0.6932156385835, -77.6052780151367, -1.35446761828971, 218, 25, 'PPL', 'P'),
(90437, 'Rocky Fork', 36.0349998474121, 0.628929393292996, -82.5522232055664, -1.4408080997784, 218, 50, 'PPL', 'P'),
(111178, 'Rocky Fork', 38.4552803039551, 0.671171256081342, -81.7227783203125, -1.42633155556689, 218, 58, 'PPL', 'P'),
(157420, 'Rocky Fork', 40.1627807617188, 0.700972761048628, -82.291389465332, -1.43625569221102, 218, 41, 'PPL', 'P'),
(105844, 'Rocky Gap', 37.2422218322754, 0.649999391731321, -81.1074981689453, -1.41559289110337, 218, 53, 'PPL', 'P'),
(24476, 'Rocky Gap (historical)', 34.9736099243164, 0.610404644487486, -84.2355575561523, -1.47018782660805, 218, 13, 'PPL', 'P'),
(114001, 'Rocky Glen', 41.4324989318848, 0.723133523690423, -73.2713928222656, -1.27882705227068, 218, 8, 'PPL', 'P'),
(50976, 'Rocky Gorge Estates', 39.1108283996582, 0.68261272875654, -76.8858337402344, -1.34191094690804, 218, 25, 'PPL', 'P'),
(50977, 'Rocky Gorge Meadows', 39.1416702270508, 0.683151020191873, -76.9686126708984, -1.3433557117994, 218, 25, 'PPL', 'P'),
(90438, 'Rocky Grove', 35.7666702270508, 0.624246157937064, -83.2880630493164, -1.4536509278192, 218, 50, 'PPL', 'P'),
(166608, 'Rocky Grove', 41.4049987792969, 0.722653555482963, -79.8322219848633, -1.39333512281887, 218, 45, 'PPL', 'P'),
(5485, 'Rocky Head', 31.5680599212646, 0.55096658409293, -85.7686080932617, -1.49694460608007, 218, 2, 'PPL', 'P'),
(5486, 'Rocky Hill', 34.6794395446777, 0.60527040280095, -87.3444366455078, -1.5244480027637, 218, 2, 'PPL', 'P'),
(11645, 'Rocky Hill', 35.7372207641602, 0.623732167846679, -92.581672668457, -1.61585501506822, 218, 4, 'PPL', 'P'),
(24477, 'Rocky Hill', 30.7024993896484, 0.535859702940915, -84.2102813720703, -1.46974667397348, 218, 13, 'PPL', 'P'),
(37983, 'Rocky Hill', 37.0688896179199, 0.646974173891046, -86.1363906860352, -1.50336362325549, 218, 21, 'PPL', 'P'),
(61579, 'Rocky Hill', 33.5252799987793, 0.585126518631699, -88.8000030517578, -1.54985242903419, 218, 30, 'PPL', 'P'),
(68321, 'Rocky Hill', 35.2158317565918, 0.614632212980905, -82.7544403076172, -1.44433745401303, 218, 33, 'PPL', 'P'),
(74117, 'Rocky Hill', 38.9888916015625, 0.680484530150431, -82.5449981689453, -1.44068199910079, 218, 41, 'PPL', 'P'),
(79047, 'Rocky Hill', 39.976390838623, 0.697719643198069, -75.5361099243164, -1.31835382232769, 218, 45, 'PPL', 'P'),
(90439, 'Rocky Hill', 35.9027786254883, 0.626621697629415, -84.0213928222656, -1.46644994686007, 218, 50, 'PPL', 'P'),
(97593, 'Rocky Hill', 30.2244396209717, 0.527515985956183, -98.793327331543, -1.72426884093593, 218, 51, 'PPL', 'P'),
(114003, 'Rocky Hill', 41.6647186279297, 0.727186521974387, -72.6397171020508, -1.26780223114802, 218, 8, 'PPL', 'P'),
(125981, 'Rocky Hill', 42.1522216796875, 0.735695055341081, -71.4877777099609, -1.24769709597263, 218, 23, 'PPL', 'P'),
(146214, 'Rocky Hill', 40.3997192382813, 0.705108117589303, -74.6347198486328, -1.30262159766221, 218, 37, 'PPL', 'P'),
(152179, 'Rocky Hill', 41.2294387817383, 0.719589455490773, -74.3536071777344, -1.29771525598595, 218, 40, 'PPL', 'P'),
(184643, 'Rocky Hill', 38.1455612182617, 0.665765638279726, -120.466110229492, -2.10253026057506, 218, 6, 'PPL', 'P'),
(5487, 'Rocky Hill (historical)', 34.6852798461914, 0.605372335291672, -87.3633270263672, -1.52477770210665, 218, 2, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(24478, 'Rocky Hills', 33.7855606079102, 0.589669272240129, -84.6763916015625, -1.47788183215534, 218, 13, 'PPL', 'P'),
(5488, 'Rocky Hollow', 33.7813911437988, 0.589596501363343, -87.084716796875, -1.51991503627228, 218, 2, 'PPL', 'P'),
(50978, 'Rocky Hook', 38.4838905334473, 0.671670598785732, -75.9277801513672, -1.32518975737176, 218, 25, 'PPL', 'P'),
(179001, 'Rocky Junction', 33.4775009155273, 0.584292616315368, -110.248329162598, -1.92419633870981, 218, 5, 'PPL', 'P'),
(68323, 'Rocky Knoll', 36.023609161377, 0.628730588317621, -79.8027801513672, -1.39282126588654, 218, 33, 'PPL', 'P'),
(68324, 'Rocky Meadow (historical)', 35.728328704834, 0.623576972134154, -80.1477813720703, -1.39884267311121, 218, 33, 'PPL', 'P'),
(972, 'Rocky Mound', 36.6074981689453, 0.638921373965891, -86.1658325195313, -1.50387748018782, 218, 50, 'PPL', 'P'),
(11648, 'Rocky Mound', 33.2605590820313, 0.580506267035548, -93.8255615234375, -1.63756497111649, 218, 4, 'PPL', 'P'),
(97594, 'Rocky Mound', 33.0188903808594, 0.576288352501081, -95.0219421386719, -1.65844575195937, 218, 51, 'PPL', 'P'),
(5489, 'Rocky Mount', 32.9908294677734, 0.575798597176615, -86.7169418334961, -1.51349615225492, 218, 2, 'PPL', 'P'),
(24479, 'Rocky Mount', 33.1652793884277, 0.578843322671875, -84.6733322143555, -1.47782843577548, 218, 13, 'PPL', 'P'),
(42849, 'Rocky Mount', 32.8144416809082, 0.572720049535511, -93.6291732788086, -1.6341373496355, 218, 22, 'PPL', 'P'),
(57254, 'Rocky Mount', 38.2722206115723, 0.667976261721574, -92.7194366455078, -1.6182594500584, 218, 29, 'PPL', 'P'),
(68327, 'Rocky Mount', 35.938060760498, 0.627237487052468, -77.7908325195313, -1.3577061553333, 218, 33, 'PPL', 'P'),
(105846, 'Rocky Mount', 36.997501373291, 0.645728213975052, -79.892219543457, -1.39438227775949, 218, 53, 'PPL', 'P'),
(61580, 'Rocky Mount (historical)', 32.7027816772461, 0.570771214828818, -88.5794372558594, -1.54600282967848, 218, 30, 'PPL', 'P'),
(77118, 'Rocky Mountain', 35.8052787780762, 0.624920004271881, -94.767219543457, -1.65400000399364, 218, 42, 'PPL', 'P'),
(197420, 'Rocky Mountain Trailer Park', 45.0319404602051, 0.785955629592629, -110.705001831055, -1.93216678037826, 218, 31, 'PPL', 'P'),
(125982, 'Rocky Neck', 42.6055603027344, 0.743607306939707, -70.658332824707, -1.23322055176112, 218, 23, 'PPL', 'P'),
(125983, 'Rocky Nook', 41.9874992370605, 0.732820106365314, -70.7008285522461, -1.23396224212471, 218, 23, 'PPL', 'P'),
(125984, 'Rocky Nook Park', 41.9936103820801, 0.732926765966971, -70.7013931274414, -1.23397209582074, 218, 23, 'PPL', 'P'),
(125985, 'Rocky Nook Point', 41.9986114501953, 0.733014051071699, -70.7074966430664, -1.23407862226435, 218, 23, 'PPL', 'P'),
(24480, 'Rocky Plains', 33.4972190856934, 0.584636763307234, -83.918327331543, -1.46465111470177, 218, 13, 'PPL', 'P'),
(5490, 'Rocky Point', 34.5283317565918, 0.602633074373444, -86.8058319091797, -1.51504757674794, 218, 2, 'PPL', 'P'),
(17840, 'Rocky Point', 29.5941696166992, 0.51651569920507, -82.3388900756836, -1.43708473425836, 218, 12, 'PPL', 'P'),
(61581, 'Rocky Point', 33.1686096191406, 0.578901446162666, -89.6999969482422, -1.56556028577569, 218, 30, 'PPL', 'P'),
(68326, 'Rocky Point', 34.435001373291, 0.601004151892697, -77.8880615234375, -1.3594031215799, 218, 33, 'PPL', 'P'),
(77120, 'Rocky Point', 36.0283317565918, 0.628813013153359, -95.3277816772461, -1.66378365889027, 218, 42, 'PPL', 'P'),
(90441, 'Rocky Point', 36.1380615234375, 0.630728158872262, -85.376106262207, -1.49009415680806, 218, 50, 'PPL', 'P'),
(105848, 'Rocky Point', 37.5794410705566, 0.655884977740396, -79.6119384765625, -1.38949045031117, 218, 53, 'PPL', 'P'),
(152178, 'Rocky Point', 40.9524993896484, 0.714755951270333, -72.9258270263672, -1.27279579134997, 218, 40, 'PPL', 'P'),
(169582, 'Rocky Point', 41.6972198486328, 0.727753775286574, -71.3697204589844, -1.24563660823724, 218, 47, 'PPL', 'P'),
(179002, 'Rocky Point', 32.5336112976074, 0.567818634707274, -112.847503662109, -1.96956049156017, 218, 5, 'PPL', 'P'),
(195552, 'Rocky Point', 47.3558311462402, 0.826515173520372, -116.745277404785, -2.03758947686764, 218, 17, 'PPL', 'P'),
(197421, 'Rocky Point', 47.7350006103516, 0.833132929092138, -114.178611755371, -1.99279271048753, 218, 31, 'PPL', 'P'),
(201498, 'Rocky Point', 42.4808311462402, 0.741430372485649, -122.083061218262, -2.13075137917247, 218, 43, 'PPL', 'P'),
(208592, 'Rocky Point', 47.5930595397949, 0.830655590067119, -122.667221069336, -2.14094689193167, 218, 56, 'PPL', 'P'),
(90443, 'Rocky Point (historical)', 35.1283302307129, 0.613105023253799, -89.7452774047852, -1.56635057882917, 218, 50, 'PPL', 'P'),
(197422, 'Rocky Point (historical)', 47.5999984741211, 0.83077669731769, -108.4375, -1.89259140763135, 218, 31, 'PPL', 'P'),
(97595, 'Rocky Point Center', 32.8458290100098, 0.57326786177174, -95.783332824707, -1.6717345263247, 218, 51, 'PPL', 'P'),
(5493, 'Rocky Ridge', 33.4966697692871, 0.584627175927309, -86.2838897705078, -1.50593796792322, 218, 2, 'PPL', 'P'),
(50979, 'Rocky Ridge', 39.6049995422363, 0.691237642262871, -77.3177795410156, -1.34944982332183, 218, 25, 'PPL', 'P'),
(90444, 'Rocky Ridge', 36.4433288574219, 0.636056078949075, -85.1927795410156, -1.48689450191639, 218, 50, 'PPL', 'P'),
(157421, 'Rocky Ridge', 41.5333290100098, 0.724893340538747, -83.2125015258789, -1.45233213044739, 218, 41, 'PPL', 'P'),
(166609, 'Rocky Ridge', 40.3952789306641, 0.705030619601582, -75.3247222900391, -1.31466441211154, 218, 45, 'PPL', 'P'),
(192762, 'Rocky Ridge', 39.9249992370605, 0.696822690542931, -111.826393127441, -1.95173875070341, 218, 52, 'PPL', 'P'),
(208593, 'Rocky Ridge', 47.0200004577637, 0.820653822277217, -122.367782592773, -2.1357207046085, 218, 56, 'PPL', 'P'),
(50980, 'Rocky Ridge Estates', 39.6074981689453, 0.691281251525721, -77.3027801513672, -1.34918803458668, 218, 25, 'PPL', 'P'),
(57255, 'Rocky Ridge Ranch', 37.9302787780762, 0.662008250876761, -90.2383270263672, -1.57495591810149, 218, 29, 'PPL', 'P'),
(30999, 'Rocky Ripple', 39.8480606079102, 0.695479858142285, -86.1725006103516, -1.50399386032746, 218, 19, 'PPL', 'P'),
(68328, 'Rocky River', 35.3061103820801, 0.616207872239851, -80.5980606079102, -1.40670152832997, 218, 33, 'PPL', 'P'),
(157422, 'Rocky River', 41.4755592346191, 0.723885067750043, -81.8394393920898, -1.42836767537831, 218, 41, 'PPL', 'P'),
(83357, 'Rocky River (historical)', 34.1691703796387, 0.596364525799616, -82.6263885498047, -1.44210252922623, 218, 48, 'PPL', 'P'),
(50981, 'Rocky Road Park', 39.2355613708496, 0.684789729789626, -77.1661071777344, -1.34680264119829, 218, 25, 'PPL', 'P'),
(112632, 'Rocky Run', 37.0755615234375, 0.647090620609709, -77.6847229003906, -1.35585419311126, 218, 53, 'PPL', 'P'),
(176155, 'Rocky Run', 44.5444412231445, 0.777447162804962, -89.6402816772461, -1.56451805768309, 218, 57, 'PPL', 'P'),
(24481, 'Rocky Shoals Estates', 33.3791694641113, 0.582576408729894, -84.6397171020508, -1.47724174138734, 218, 13, 'PPL', 'P'),
(90445, 'Rocky Spring', 35.4888916015625, 0.619398006330629, -84.3377838134766, -1.47197201138035, 218, 50, 'PPL', 'P'),
(5495, 'Rocky Springs', 34.9577789306641, 0.61012834152439, -85.7533264160156, -1.4966778904969, 218, 2, 'PPL', 'P'),
(24487, 'Rocky Springs', 34.0913887023926, 0.595006979433948, -84.4794387817383, -1.47444435697832, 218, 13, 'PPL', 'P'),
(50982, 'Rocky Springs', 39.4477806091309, 0.688493654233708, -77.45361328125, -1.35182056932422, 218, 25, 'PPL', 'P'),
(61582, 'Rocky Springs', 32.0886116027832, 0.560051924862222, -90.8150024414063, -1.58502080280923, 218, 30, 'PPL', 'P'),
(68331, 'Rocky Springs', 35.9513893127441, 0.627470114173687, -81.1016693115234, -1.41549115834973, 218, 33, 'PPL', 'P'),
(90446, 'Rocky Springs', 36.4469413757324, 0.636119129287883, -82.3694381713867, -1.4376178991086, 218, 50, 'PPL', 'P'),
(97596, 'Rocky Springs', 31.3233299255371, 0.546695239889093, -94.5952835083008, -1.65099915407734, 218, 51, 'PPL', 'P'),
(90447, 'Rocky Summit (historical)', 36.288890838623, 0.633360627030778, -83.3063888549805, -1.45397077346612, 218, 50, 'PPL', 'P'),
(90450, 'Rocky Valley', 36.059440612793, 0.629355965120599, -83.5472183227539, -1.45817404061459, 218, 50, 'PPL', 'P'),
(166610, 'Rocky Valley', 40.5016708374023, 0.70688750867164, -75.3675003051758, -1.31541102932315, 218, 45, 'PPL', 'P'),
(90448, 'Rocky Waters', 35.8355598449707, 0.625448508590208, -83.9816665649414, -1.46575659287026, 218, 50, 'PPL', 'P'),
(37984, 'Rockybranch', 36.7350006103516, 0.641146711372761, -84.7333297729492, -1.4788755907161, 218, 21, 'PPL', 'P'),
(105851, 'Rockydale', 37.3125, 0.651225977150384, -79.9266662597656, -1.39498348637557, 218, 53, 'PPL', 'P'),
(202571, 'Rockyford', 43.4972190856934, 0.759169688506667, -102.501670837402, -1.78899164490812, 218, 49, 'PPL', 'P'),
(68332, 'Rockyhock', 36.1808280944824, 0.631474576346784, -76.6930618286133, -1.33854644234489, 218, 33, 'PPL', 'P'),
(209708, 'Rockypoint', 44.9072189331055, 0.783778828296626, -105.095001220703, -1.83425379868873, 218, 59, 'PPL', 'P'),
(144381, 'Rockywold', 43.774169921875, 0.764003392464188, -71.5438919067383, -1.24867647346351, 218, 36, 'PPL', 'P'),
(105853, 'Roda', 36.9677810668945, 0.645209496773732, -82.8330612182617, -1.44570964776469, 218, 53, 'PPL', 'P'),
(68333, 'Rodanthe', 35.5933303833008, 0.621220806938734, -75.4683303833008, -1.31717084617147, 218, 33, 'PPL', 'P'),
(189374, 'Rodarte', 36.1519393920898, 0.630970373373405, -105.672218322754, -1.84432813761834, 218, 38, 'PPL', 'P'),
(37985, 'Rodburn', 38.1980590820313, 0.666681898852768, -83.4108276367188, -1.45579357407422, 218, 21, 'PPL', 'P'),
(5497, 'Roddams Trailer Park', 33.6599998474121, 0.58747782355813, -86.5494384765625, -1.51057266716828, 218, 2, 'PPL', 'P'),
(105852, 'Rodden', 36.8319396972656, 0.642838617613289, -79.0783309936523, -1.38017724282111, 218, 53, 'PPL', 'P'),
(121275, 'Rodden', 42.3280601501465, 0.738764015602262, -90.3202819824219, -1.57638630192297, 218, 18, 'PPL', 'P'),
(24482, 'Roddenberry', 30.8769397735596, 0.538904261988607, -84.2600021362305, -1.47061446501468, 218, 13, 'PPL', 'P'),
(24483, 'Roddenberry (historical)', 30.673059463501, 0.535345879298098, -83.9358291625977, -1.4649565792788, 218, 13, 'PPL', 'P'),
(83358, 'Roddey', 34.8708305358887, 0.608610805756236, -80.9369430541992, -1.41261614279493, 218, 48, 'PPL', 'P'),
(24484, 'Roddy', 32.3525009155273, 0.564657662230432, -83.2505569458008, -1.45299632282326, 218, 13, 'PPL', 'P'),
(90449, 'Roddy', 35.771671295166, 0.624333443041791, -84.7738876342773, -1.47958345893385, 218, 50, 'PPL', 'P'),
(97597, 'Roddy', 32.4172210693359, 0.565787242006789, -96.0355606079102, -1.6761367316066, 218, 51, 'PPL', 'P'),
(50983, 'Roddy (historical)', 39.6405601501465, 0.691858291954914, -77.4022216796875, -1.35092361666908, 218, 25, 'PPL', 'P'),
(176156, 'Rodell', 44.7200012207031, 0.780511262797153, -91.1880569458008, -1.59153183220031, 218, 57, 'PPL', 'P'),
(42850, 'Rodemacher', 31.4183292388916, 0.548353290694263, -92.7222213745117, -1.61830805274829, 218, 22, 'PPL', 'P'),
(37986, 'Rodemer', 36.7191696166992, 0.640870408409666, -86.2294387817383, -1.50498761888822, 218, 21, 'PPL', 'P'),
(90451, 'Rodemer', 35.8955612182617, 0.626495730109854, -87.4197235107422, -1.52576200644555, 218, 50, 'PPL', 'P'),
(111179, 'Rodemer', 39.4155616760254, 0.687931327769538, -79.5933303833008, -1.38916567781624, 218, 58, 'PPL', 'P'),
(28445, 'Rodemich', 38.4408302307129, 0.670919054726111, -90.1377792358398, -1.57320102810118, 218, 18, 'PPL', 'P'),
(208594, 'Rodena Beach', 48.2191696166992, 0.841583272389014, -122.629722595215, -2.14029242009378, 218, 56, 'PPL', 'P'),
(5498, 'Rodentown', 34.2344398498535, 0.597503692955897, -86.0169372558594, -1.50127876759612, 218, 2, 'PPL', 'P'),
(184644, 'Rodeo', 38.0330581665039, 0.663802089608011, -122.265830993652, -2.13394131352616, 218, 6, 'PPL', 'P'),
(189372, 'Rodeo', 31.8352794647217, 0.555630444951931, -109.030563354492, -1.90294231584016, 218, 38, 'PPL', 'P'),
(111181, 'Roderfield', 37.4502792358398, 0.653630678456671, -81.7058334350586, -1.42603581152784, 218, 58, 'PPL', 'P'),
(24485, 'Roderick (historical)', 31.7916698455811, 0.554869313512387, -81.8272171020508, -1.428154356175, 218, 13, 'PPL', 'P'),
(190678, 'Roderick (historical)', 39.5888900756836, 0.690956479030786, -119.372222900391, -2.08343832503639, 218, 39, 'PPL', 'P'),
(111180, 'Rodes (historical)', 37.7727813720703, 0.659259402578608, -81.1374969482422, -1.41611646857368, 218, 58, 'PPL', 'P'),
(42854, 'Rodessa', 32.9711112976074, 0.57545445018475, -93.9947204589844, -1.64051735150095, 218, 22, 'PPL', 'P'),
(189373, 'Rodey', 32.6566696166992, 0.569966407547396, -107.135276794434, -1.86986332509834, 218, 38, 'PPL', 'P'),
(152180, 'Rodger Corner', 43.1619415283203, 0.753317991222463, -76.158332824707, -1.32921366062081, 218, 40, 'PPL', 'P'),
(57256, 'Rodger Ford (historical)', 37.9594383239746, 0.662517180961075, -92.8322219848633, -1.62022792557813, 218, 29, 'PPL', 'P'),
(24486, 'Rodgers', 34.202220916748, 0.596941366491727, -84.8277816772461, -1.48052408743086, 218, 13, 'PPL', 'P'),
(83362, 'Rodgers', 33.5544395446777, 0.585635448716013, -80.2588882446289, -1.40078185385895, 218, 48, 'PPL', 'P'),
(61583, 'Rodgers (historical)', 33.7433280944824, 0.588932175829422, -88.6438903808594, -1.54712774892293, 218, 30, 'PPL', 'P'),
(184646, 'Rodgers Crossing', 36.8619384765625, 0.643362195083598, -119.120002746582, -2.07903625291255, 218, 6, 'PPL', 'P'),
(184647, 'Rodgers Flat', 39.9597206115723, 0.697428692848978, -121.277778625488, -2.11669654651957, 218, 6, 'PPL', 'P'),
(50984, 'Rodgers Forge', 39.3777809143066, 0.687271929083634, -76.6138916015625, -1.3371646612133, 218, 25, 'PPL', 'P'),
(97598, 'Rodgers Lake Estates Colonia', 26.3360004425049, 0.459649919528394, -98.2060012817383, -1.7140180675841, 218, 51, 'PPL', 'P'),
(90453, 'Rodgers Ridge Subdivision', 35.8875007629395, 0.62635504862527, -84.4000015258789, -1.47305791531483, 218, 50, 'PPL', 'P'),
(97599, 'Rodgers Road Colonia', 26.32200050354, 0.459405574498379, -98.0879974365234, -1.71195851195509, 218, 51, 'PPL', 'P'),
(28446, 'Rodgersville', 37.6766700744629, 0.657581943986995, -88.7697219848633, -1.54932392471586, 218, 18, 'PPL', 'P'),
(166613, 'Rodi', 40.4661102294922, 0.706266858979597, -79.8261108398438, -1.39322846321721, 218, 45, 'PPL', 'P'),
(187868, 'Rodkey', 38.0177803039551, 0.663535440603867, -100.957221984863, -1.76203592730267, 218, 20, 'PPL', 'P'),
(17841, 'Rodman', 29.5380592346191, 0.51553638829322, -81.7563934326172, -1.42691824995504, 218, 12, 'PPL', 'P'),
(83359, 'Rodman', 34.7686080932617, 0.606826687562965, -81.0883331298828, -1.41525839807045, 218, 48, 'PPL', 'P'),
(117585, 'Rodman', 43.0286102294922, 0.750990921061952, -94.5308303833008, -1.64987423483289, 218, 16, 'PPL', 'P'),
(152181, 'Rodman', 43.8511085510254, 0.765346224864833, -75.9411087036133, -1.32542238449297, 218, 40, 'PPL', 'P'),
(166611, 'Rodman', 40.3411102294922, 0.704085197414604, -78.4005584716797, -1.36834788073314, 218, 45, 'PPL', 'P'),
(169583, 'Rodman Crossing (historical)', 41.4388885498047, 0.72324504356107, -71.4872207641602, -1.24768737543465, 218, 47, 'PPL', 'P'),
(68334, 'Rodmans Quarter', 35.5461082458496, 0.620396625160382, -76.7802810668945, -1.34006870522397, 218, 33, 'PPL', 'P'),
(208595, 'Rodna', 47.2955589294434, 0.825463224889791, -117.798889160156, -2.05597847103658, 218, 56, 'PPL', 'P'),
(11649, 'Rodney', 36.2427787780762, 0.632555819749356, -92.1611099243164, -1.60851481047174, 218, 4, 'PPL', 'P'),
(61584, 'Rodney', 31.8611106872559, 0.556081284834968, -91.1997222900391, -1.59173543086564, 218, 30, 'PPL', 'P'),
(74118, 'Rodney', 38.8491706848145, 0.678045940119272, -82.3041687011719, -1.43647873195231, 218, 41, 'PPL', 'P'),
(97600, 'Rodney', 31.8216705322266, 0.55539292427221, -96.6113891601563, -1.68618683577029, 218, 51, 'PPL', 'P'),
(117586, 'Rodney', 42.2055587768555, 0.736625963300119, -95.9522171020508, -1.6746821130192, 218, 16, 'PPL', 'P'),
(132878, 'Rodney', 43.6736106872559, 0.762248302726798, -85.3283309936523, -1.48926032107076, 218, 27, 'PPL', 'P'),
(166612, 'Rodney', 40.1525001525879, 0.700793330570184, -79.4166717529297, -1.3860824030642, 218, 45, 'PPL', 'P'),
(176157, 'Rodney (historical)', 43.985279083252, 0.76768794241134, -89.1283264160156, -1.55558275275171, 218, 57, 'PPL', 'P'),
(14512, 'Rodney Village', 39.1319389343262, 0.682981177093353, -75.5327835083008, -1.31829576541592, 218, 10, 'PPL', 'P'),
(50985, 'Rodo Beach', 38.0791702270508, 0.664606896889433, -76.3319396972656, -1.33224367215105, 218, 25, 'PPL', 'P'),
(105854, 'Rodophil', 37.3686103820801, 0.652205288062234, -78.1586074829102, -1.36412503935066, 218, 53, 'PPL', 'P'),
(14513, 'Rodric Village', 39.1313896179199, 0.682971589713429, -75.5180587768555, -1.31803877037073, 218, 10, 'PPL', 'P'),
(97601, 'Rodriguez Addition Colonia', 27.4650001525879, 0.479354681723404, -98.9710006713867, -1.72736982570922, 218, 51, 'PPL', 'P'),
(97602, 'Rodriguez Colonia', 26.2880001068115, 0.458812155628482, -98.1360015869141, -1.71279634243403, 218, 51, 'PPL', 'P'),
(97603, 'Rodriguez Colonia Number 2', 26.2870006561279, 0.458794711923342, -98.1360015869141, -1.71279634243403, 218, 51, 'PPL', 'P'),
(97604, 'Rodriguez Number 1 Colonia', 26.3579998016357, 0.460033880778556, -98.7770004272461, -1.72398388269929, 218, 51, 'PPL', 'P'),
(97605, 'Rodriguez Number 2 Colonia', 26.3570003509521, 0.460016437073416, -98.7760009765625, -1.72396643899415, 218, 51, 'PPL', 'P'),
(97606, 'Rodriguez Street Colonia', 26.2360000610352, 0.457904583618497, -98.1559982299805, -1.71314534969489, 218, 51, 'PPL', 'P'),
(42851, 'Rodriquez', 29.8325004577637, 0.520675357090692, -91.5677795410156, -1.59815924173102, 218, 22, 'PPL', 'P'),
(68335, 'Roduco', 36.461669921875, 0.636376190912102, -76.8127822875977, -1.34063595853616, 218, 33, 'PPL', 'P'),
(11650, 'Roe', 34.6333312988281, 0.604465662098555, -91.3850021362305, -1.59496917421927, 218, 4, 'PPL', 'P'),
(50986, 'Roe', 39.0627784729004, 0.681774099329274, -75.9250030517578, -1.32514128783992, 218, 25, 'PPL', 'P'),
(68336, 'Roe', 34.9922218322754, 0.610729483561449, -76.3091735839844, -1.33184632851641, 218, 33, 'PPL', 'P'),
(90452, 'Roe', 36.1824989318848, 0.631503737960721, -83.3036117553711, -1.45392230393428, 218, 50, 'PPL', 'P'),
(187274, 'Roe', 38.5377807617188, 0.672611160703721, -107.94416809082, -1.88398114151102, 218, 7, 'PPL', 'P'),
(157425, 'Roe Corners', 40.1930618286133, 0.701501265366955, -84.727783203125, -1.47877878481048, 218, 41, 'PPL', 'P'),
(90454, 'Roe Junction', 36.1738891601563, 0.631353469096213, -83.3072204589844, -1.45398528769406, 218, 50, 'PPL', 'P'),
(5499, 'Roe Landing', 32.6044387817383, 0.569054807506262, -87.8397216796875, -1.53309235734599, 218, 2, 'PPL', 'P'),
(152183, 'Roe Park', 41.3063888549805, 0.7209324876285, -73.8838882446289, -1.28951711404431, 218, 40, 'PPL', 'P'),
(146216, 'Roebling', 40.1158294677734, 0.700153306381211, -74.7866668701172, -1.30527357347571, 218, 37, 'PPL', 'P'),
(5501, 'Roebuck', 33.2772216796875, 0.580797084226585, -86.8724975585938, -1.5162111118282, 218, 2, 'PPL', 'P'),
(61585, 'Roebuck', 33.4447212219238, 0.583720502734192, -90.2344436645508, -1.57488814065175, 218, 30, 'PPL', 'P'),
(83360, 'Roebuck', 34.8794403076172, 0.608761074620744, -81.9663925170898, -1.43058342540526, 218, 48, 'PPL', 'P'),
(105855, 'Roebuck', 36.7738914489746, 0.641825484555595, -82.1133270263672, -1.43314791637695, 218, 53, 'PPL', 'P'),
(5502, 'Roebuck Crest Estates', 33.5963897705078, 0.586367618278703, -86.7016677856445, -1.5132295698298, 218, 2, 'PPL', 'P'),
(5503, 'Roebuck Forest', 33.5830612182617, 0.586134991157485, -86.6813888549805, -1.51287563572093, 218, 2, 'PPL', 'P'),
(5504, 'Roebuck Gardens', 33.610279083252, 0.586610032516928, -86.6983337402344, -1.51317137975998, 218, 2, 'PPL', 'P'),
(5505, 'Roebuck Park', 33.605281829834, 0.586522813991228, -86.6949996948242, -1.51311318969016, 218, 2, 'PPL', 'P'),
(5506, 'Roebuck Plaza', 33.5875015258789, 0.586212489145206, -86.6600036621094, -1.51250239369415, 218, 2, 'PPL', 'P'),
(5507, 'Roebuck Springs', 33.5769386291504, 0.586028131818746, -86.70361328125, -1.5132635251337, 218, 2, 'PPL', 'P'),
(5508, 'Roebuck Terrace', 33.5800018310547, 0.586081594777629, -86.7225036621094, -1.51359322447665, 218, 2, 'PPL', 'P'),
(97607, 'Roeder', 33.0854187011719, 0.577449490736355, -94.862922668457, -1.65567033862934, 218, 51, 'PPL', 'P'),
(166614, 'Roeders', 40.5666694641113, 0.708021948716986, -76.195556640625, -1.32986333876874, 218, 45, 'PPL', 'P'),
(166615, 'Roedersville', 40.586109161377, 0.708361235439862, -76.3249969482422, -1.33212249832145, 218, 45, 'PPL', 'P'),
(33807, 'Roeland Park', 39.0374984741211, 0.681332880115676, -94.6319427490234, -1.65163897852923, 218, 20, 'PPL', 'P'),
(50987, 'Roelkeys Knoll', 39.3416709899902, 0.686641692011667, -77.665283203125, -1.35551490638838, 218, 25, 'PPL', 'P'),
(90382, 'RoEllen', 36.023609161377, 0.628730588317621, -89.2813873291016, -1.55825416964117, 218, 50, 'PPL', 'P'),
(166616, 'Roelofs', 40.2169418334961, 0.701918050077552, -74.8619384765625, -1.30658731084144, 218, 45, 'PPL', 'P'),
(117587, 'Roelyn', 42.4136085510254, 0.740257116867414, -94.3572235107422, -1.64684422330265, 218, 16, 'PPL', 'P'),
(166617, 'Roemersville', 41.2847213745117, 0.720554318753708, -75.2497177124023, -1.31335533527772, 218, 45, 'PPL', 'P'),
(152184, 'Roessleville', 42.6949996948242, 0.745168318812657, -73.807502746582, -1.28818393560261, 218, 40, 'PPL', 'P'),
(14514, 'Roesville', 38.9977798461914, 0.680639659283928, -75.5286102294922, -1.31822292796011, 218, 10, 'PPL', 'P'),
(5509, 'Roeton', 31.5974998474121, 0.551480407735747, -85.834716796875, -1.49809842062235, 218, 2, 'PPL', 'P'),
(105856, 'Roetown', 36.6430587768555, 0.639542023657934, -81.8274993896484, -1.42815928302302, 218, 53, 'PPL', 'P'),
(17842, 'Roeville', 30.6766700744629, 0.535408896347392, -86.9936065673828, -1.51832486278539, 218, 12, 'PPL', 'P'),
(543, 'Roff', 37.6602783203125, 0.657295853906893, -86.4230575561523, -1.50836690399542, 218, 21, 'PPL', 'P'),
(77122, 'Roff', 34.627498626709, 0.604363862765887, -96.8405609130859, -1.69018663741148, 218, 42, 'PPL', 'P'),
(11651, 'Roff (historical)', 34.3463897705078, 0.599457587668661, -94.4336090087891, -1.64817740174435, 218, 4, 'PPL', 'P'),
(975, 'Rogana', 36.4449996948242, 0.636085240563011, -86.333610534668, -1.50680575896442, 218, 50, 'PPL', 'P'),
(83361, 'Rogansville (historical)', 34.7655601501465, 0.60677349092019, -81.7249984741211, -1.42637030456076, 218, 48, 'PPL', 'P'),
(97608, 'Roganville', 30.7999992370605, 0.537561396298448, -93.9033279418945, -1.63892225116605, 218, 51, 'PPL', 'P'),
(874, 'Rogers', 36.9169387817383, 0.644322131498517, -95.1975021362305, -1.66150985195156, 218, 42, 'PPL', 'P'),
(5511, 'Rogers', 34.3413887023926, 0.599370302563934, -86.0913925170898, -1.50257825705003, 218, 2, 'PPL', 'P'),
(11652, 'Rogers', 36.3319396972656, 0.634111971353317, -94.1183319091797, -1.64267477830003, 218, 4, 'PPL', 'P'),
(24491, 'Rogers', 32.8191719055176, 0.572802607529303, -82.0738906860352, -1.43245962239322, 218, 13, 'PPL', 'P'),
(31000, 'Rogers', 38.538330078125, 0.672620748083645, -87.2238922119141, -1.52234410550254, 218, 19, 'PPL', 'P'),
(33809, 'Rogers', 37.1469383239746, 0.648336380788621, -96.2788925170898, -1.68038367459695, 218, 20, 'PPL', 'P'),
(37987, 'Rogers', 37.7438888549805, 0.658755133026202, -83.6355590820313, -1.45971587772769, 218, 21, 'PPL', 'P'),
(42853, 'Rogers', 32.9313888549805, 0.574761162773975, -91.975830078125, -1.60528106711811, 218, 22, 'PPL', 'P'),
(90455, 'Rogers', 35.9947204589844, 0.628226385344242, -84.7641677856445, -1.47941381557241, 218, 50, 'PPL', 'P'),
(97611, 'Rogers', 32.1741714477539, 0.561545225864456, -99.6849975585938, -1.73983142223997, 218, 51, 'PPL', 'P'),
(105857, 'Rogers', 37.0916709899902, 0.647371783841794, -80.3902816772461, -1.40307510187361, 218, 53, 'PPL', 'P'),
(114004, 'Rogers', 41.8402786254883, 0.730250621966578, -71.9066696166992, -1.25500813895517, 218, 8, 'PPL', 'P'),
(117588, 'Rogers', 42.1966705322266, 0.736470834166622, -91.57861328125, -1.59834832616842, 218, 16, 'PPL', 'P'),
(137773, 'Rogers', 44.2605590820313, 0.772492484754924, -93.5783309936523, -1.63324998436029, 218, 28, 'PPL', 'P'),
(140801, 'Rogers', 47.0727806091309, 0.821575009698275, -98.1991729736328, -1.71389889112532, 218, 34, 'PPL', 'P'),
(142886, 'Rogers', 41.4652786254883, 0.723705637271599, -96.9147186279297, -1.69148093370125, 218, 35, 'PPL', 'P'),
(152185, 'Rogers', 44.4580612182617, 0.775939547311868, -73.6069412231445, -1.28468347666581, 218, 40, 'PPL', 'P'),
(157424, 'Rogers', 40.791389465332, 0.711944052633373, -80.6263885498047, -1.40719594418635, 218, 41, 'PPL', 'P'),
(189375, 'Rogers', 33.9816703796387, 0.593092033452126, -103.230003356934, -1.80170344542329, 218, 38, 'PPL', 'P'),
(197423, 'Rogers', 47.5433311462402, 0.829787665867862, -110.995559692383, -1.93723797172598, 218, 31, 'PPL', 'P'),
(24489, 'Rogers (historical)', 34.8494415283203, 0.608237497150434, -84.0955581665039, -1.4677443763079, 218, 13, 'PPL', 'P'),
(50988, 'Rogers (historical)', 39.4130592346191, 0.68788765192766, -76.688606262207, -1.33846867804105, 218, 25, 'PPL', 'P'),
(24490, 'Rogers Acres', 32.7563896179199, 0.57170684989879, -83.7847213745117, -1.4623192508513, 218, 13, 'PPL', 'P'),
(132879, 'Rogers City', 45.4213905334473, 0.792752815642838, -83.8183288574219, -1.46290581208139, 218, 27, 'PPL', 'P'),
(105858, 'Rogers Corner', 36.7200012207031, 0.640884922637607, -78.4180603027344, -1.36865334531018, 218, 53, 'PPL', 'P'),
(132881, 'Rogers Corner', 42.2388916015625, 0.737207730840246, -83.9741668701172, -1.46562569850269, 218, 27, 'PPL', 'P'),
(14529, 'Rogers Corners', 39.711109161377, 0.693089604484912, -75.5472183227539, -1.31854770045504, 218, 10, 'PPL', 'P'),
(90456, 'Rogers Creek', 35.5027809143066, 0.619640420568854, -84.6916732788086, -1.47814854773851, 218, 50, 'PPL', 'P'),
(144382, 'Rogers Crossing', 44.0816688537598, 0.769370261271943, -71.2441711425781, -1.24344535929232, 218, 36, 'PPL', 'P'),
(68337, 'Rogers Crossroads', 35.785831451416, 0.624580584390951, -78.2172164916992, -1.36514795952536, 218, 33, 'PPL', 'P'),
(83367, 'Rogers Crossroads', 34.2658309936523, 0.598051571771154, -79.8880615234375, -1.39430970661978, 218, 48, 'PPL', 'P'),
(14515, 'Rogers Development', 38.7008285522461, 0.675456881486525, -75.3644409179688, -1.31535763294329, 218, 10, 'PPL', 'P'),
(37988, 'Rogers Gap', 38.3044395446777, 0.668538588185744, -84.5361099243164, -1.47543345500718, 218, 21, 'PPL', 'P'),
(14517, 'Rogers Haven', 38.5597190856934, 0.672994056689447, -75.0944366455078, -1.3106451693944, 218, 10, 'PPL', 'P'),
(24492, 'Rogers Heights', 33.5605583190918, 0.585742241475726, -83.920280456543, -1.46468520316373, 218, 13, 'PPL', 'P'),
(50989, 'Rogers Heights', 38.9486083984375, 0.67978145562265, -76.9222183227539, -1.34254597766997, 218, 25, 'PPL', 'P'),
(97612, 'Rogers Hill', 31.7311096191406, 0.553812338165248, -97.1986083984375, -1.69643574490935, 218, 51, 'PPL', 'P'),
(132882, 'Rogers Location', 46.1061096191406, 0.804703418139433, -88.584716796875, -1.54609497505219, 218, 27, 'PPL', 'P'),
(14518, 'Rogers Manor', 39.6736106872559, 0.692435132647025, -75.561393737793, -1.31879510812031, 218, 10, 'PPL', 'P'),
(187275, 'Rogers Mesa', 38.7791709899902, 0.676824214969199, -107.792503356934, -1.88133409254553, 218, 7, 'PPL', 'P'),
(24493, 'Rogers Mill', 34.5036087036133, 0.602201575697824, -83.6777801513672, -1.46045277440132, 218, 13, 'PPL', 'P'),
(50990, 'Rogers Mill', 38.4936103820801, 0.67184024214717, -76.9313888549805, -1.34270603365148, 218, 25, 'PPL', 'P'),
(79049, 'Rogers Mill', 39.9922218322754, 0.697995946161165, -79.4111099243164, -1.38598533084247, 218, 45, 'PPL', 'P'),
(205588, 'Rogers Mini Warehouse Condo', 40.6444396972656, 0.709379295345572, -111.894721984863, -1.95293131423955, 218, 52, 'PPL', 'P'),
(212123, 'Rogers Park', 61.1980590820313, 1.06810762681146, -149.849166870117, -2.61536134325395, 218, 1, 'PPL', 'P'),
(90457, 'Rogers Springs', 35.0499992370605, 0.611737889508207, -88.9755630493164, -1.55291652902638, 218, 50, 'PPL', 'P'),
(166618, 'Rogers Stop', 40.1272201538086, 0.700352111356585, -79.9227828979492, -1.39491570892583, 218, 45, 'PPL', 'P'),
(83364, 'Rogers Valley Heights', 34.8683280944824, 0.608567129914359, -82.3258285522461, -1.43685676766905, 218, 48, 'PPL', 'P'),
(208596, 'Rogersburg', 46.0783309936523, 0.804218589662984, -116.978607177734, -2.04166184964854, 218, 56, 'PPL', 'P'),
(97613, 'Rogerslacy', 26.2769393920898, 0.458619109738965, -97.8772201538086, -1.70827975438331, 218, 51, 'PPL', 'P'),
(195553, 'Rogerson', 42.2180595397949, 0.736844142772423, -114.593330383301, -2.00003091601425, 218, 17, 'PPL', 'P'),
(166620, 'Rogerstown', 40.0013885498047, 0.698155935563652, -79.6266708374023, -1.38974757851442, 218, 45, 'PPL', 'P'),
(5512, 'Rogersville', 34.8255615234375, 0.607820712439837, -87.2947235107422, -1.52358034488055, 218, 2, 'PPL', 'P'),
(37989, 'Rogersville', 37.8202781677246, 0.660088378046923, -85.9288864135742, -1.49974199048909, 218, 21, 'PPL', 'P'),
(57257, 'Rogersville', 37.1169395446777, 0.647812803318311, -93.0555572509766, -1.62412586130762, 218, 29, 'PPL', 'P'),
(68338, 'Rogersville', 36.5149993896484, 0.637306965713085, -78.9672164916992, -1.37823792891532, 218, 33, 'PPL', 'P'),
(79050, 'Rogersville', 39.8811111450195, 0.696056698834397, -80.273063659668, -1.40102926152422, 218, 45, 'PPL', 'P'),
(90458, 'Rogersville', 36.4072189331055, 0.635425841877108, -83.0055618286133, -1.44872035137703, 218, 50, 'PPL', 'P'),
(117589, 'Rogersville', 42.1086082458496, 0.73493385732251, -92.2313919067383, -1.60974146246983, 218, 16, 'PPL', 'P'),
(123575, 'Rogersville', 40.0355606079102, 0.698752350489775, -85.3294372558594, -1.48927962898866, 218, 19, 'PPL', 'P'),
(132884, 'Rogersville', 43.1227798461914, 0.752634490928694, -83.5769424438477, -1.45869282439494, 218, 27, 'PPL', 'P'),
(152186, 'Rogersville', 42.514720916748, 0.742021860563755, -77.6711120605469, -1.35561663914202, 218, 40, 'PPL', 'P'),
(176158, 'Rogersville', 43.7491683959961, 0.763567033519578, -88.6322174072266, -1.54692401709954, 218, 57, 'PPL', 'P'),
(125986, 'Rogersville (historical)', 42.6577796936035, 0.744518707243759, -71.7555618286133, -1.25237081052766, 218, 23, 'PPL', 'P'),
(166619, 'Rogertown', 41.8227806091309, 0.729945223968573, -79.1044387817383, -1.38063290968363, 218, 45, 'PPL', 'P'),
(24495, 'Rogerville', 31.1602802276611, 0.543849485816775, -84.1113891601563, -1.46802067927099, 218, 13, 'PPL', 'P'),
(184648, 'Rogerville', 39.6113891601563, 0.691349162133518, -121.221389770508, -2.11571237533873, 218, 6, 'PPL', 'P'),
(194404, 'Roggen', 40.1674995422363, 0.701055119305339, -104.371673583984, -1.82162934985732, 218, 7, 'PPL', 'P'),
(42855, 'Rogillioville', 30.9249992370605, 0.539743057863441, -91.2311096191406, -1.59228324310187, 218, 22, 'PPL', 'P'),
(50991, 'Rognel Heights', 39.2938919067383, 0.685807789695336, -76.6861114501953, -1.33842513535723, 218, 25, 'PPL', 'P'),
(176159, 'Rogneys (historical)', 44.1933288574219, 0.771319095978635, -91.0583267211914, -1.58926761264152, 218, 57, 'PPL', 'P'),
(201499, 'Rogue Elk', 42.6624984741211, 0.74460106550047, -122.758331298828, -2.14253706541856, 218, 43, 'PPL', 'P'),
(201500, 'Rogue River', 42.4361114501953, 0.740649866549174, -123.170829772949, -2.14973652195142, 218, 43, 'PPL', 'P'),
(184649, 'Rohnert Park', 38.3397216796875, 0.669154377608798, -122.699996948242, -2.14151893893382, 218, 6, 'PPL', 'P'),
(193917, 'Rohnerville', 40.5672187805176, 0.708031536096911, -124.134437561035, -2.16655465055138, 218, 6, 'PPL', 'P'),
(105859, 'Rohoic Farms', 37.2083282470703, 0.649407837074187, -77.4844436645508, -1.35235866102247, 218, 53, 'PPL', 'P'),
(111182, 'Rohr', 39.5872192382813, 0.690927317416849, -79.8172225952148, -1.39307333408371, 218, 58, 'PPL', 'P'),
(111183, 'Rohrbough', 38.9819412231445, 0.680363223162778, -80.4933319091797, -1.4048736677158, 218, 58, 'PPL', 'P'),
(28447, 'Rohrer', 39.5294418334961, 0.689918911470091, -89.959716796875, -1.57009325226712, 218, 18, 'PPL', 'P'),
(166621, 'Rohrerstown', 40.0527801513672, 0.69905288821879, -76.3602828979492, -1.33273835432353, 218, 45, 'PPL', 'P'),
(50994, 'Rohrersville', 39.4333305358887, 0.688241452878477, -77.6630630493164, -1.35547615739452, 218, 25, 'PPL', 'P'),
(50992, 'Rohrersville Station', 39.4311103820801, 0.688202703884617, -77.6780624389648, -1.35573794612967, 218, 25, 'PPL', 'P'),
(142889, 'Rohrs', 40.3927803039551, 0.704987010338732, -95.9322204589844, -1.67433310575834, 218, 35, 'PPL', 'P'),
(166622, 'Rohrsburg', 41.1333312988281, 0.717912063478186, -76.4225006103516, -1.33382425825801, 218, 45, 'PPL', 'P'),
(140789, 'Rohrville', 48.1425018310547, 0.840245167099303, -98.6597213745117, -1.72193697708546, 218, 34, 'PPL', 'P'),
(74119, 'Rohs Hill', 39.1297187805176, 0.682942428099492, -84.522216796875, -1.47519097418992, 218, 41, 'PPL', 'P'),
(11655, 'Rohwer', 33.7608299255371, 0.589237640406455, -91.2755584716797, -1.59305902192741, 218, 4, 'PPL', 'P'),
(142890, 'Rokeby', 40.7119407653809, 0.710557411232796, -96.7358322143555, -1.6883587767973, 218, 35, 'PPL', 'P'),
(74120, 'Rokeby Lock', 39.7319412231445, 0.693453192552735, -81.9052810668945, -1.42951682938868, 218, 41, 'PPL', 'P'),
(11656, 'Rokey', 35.8594398498535, 0.625865293300805, -90.2747192382813, -1.57559108202148, 218, 4, 'PPL', 'P'),
(50993, 'Rol-Park Trailer Village', 39.1230583190918, 0.68282618111791, -76.6361083984375, -1.33755241746801, 218, 25, 'PPL', 'P'),
(37990, 'Rolan', 36.6519393920898, 0.639697019633377, -85.033332824707, -1.48411163173531, 218, 21, 'PPL', 'P'),
(5513, 'Roland', 31.1347198486328, 0.543403373044673, -85.4372177124023, -1.49116075282464, 218, 2, 'PPL', 'P'),
(11657, 'Roland', 34.9005584716797, 0.609129656115611, -92.4980621337891, -1.61439573594891, 218, 4, 'PPL', 'P'),
(24496, 'Roland', 32.8594398498535, 0.573505415740975, -84.4158325195313, -1.47333421827792, 218, 13, 'PPL', 'P'),
(28448, 'Roland', 37.9300003051758, 0.662003390607771, -88.2633285522461, -1.54048569200621, 218, 18, 'PPL', 'P'),
(31005, 'Roland', 38.5952796936035, 0.67361470638149, -86.6819381713867, -1.51288522310085, 218, 19, 'PPL', 'P'),
(33810, 'Roland', 37.2661094665527, 0.650416309599973, -97.4572219848633, -1.70094940348287, 218, 20, 'PPL', 'P'),
(77125, 'Roland', 35.4211082458496, 0.618214963595389, -94.5144424438477, -1.64958821133182, 218, 42, 'PPL', 'P'),
(97614, 'Roland', 33.2783317565918, 0.580816458723515, -96.649169921875, -1.68684623445619, 218, 51, 'PPL', 'P'),
(117590, 'Roland', 42.166389465332, 0.735942329848295, -93.5016708374023, -1.63191201222863, 218, 16, 'PPL', 'P'),
(137776, 'Roland', 47.9441719055176, 0.836783656893445, -95.7786102294922, -1.67165210148896, 218, 28, 'PPL', 'P'),
(195554, 'Roland', 47.3800010681152, 0.826937018237041, -115.668060302734, -2.01878849167806, 218, 17, 'PPL', 'P'),
(37991, 'Roland Landing', 37.5908317565918, 0.656083782715771, -87.4349975585938, -1.52602858887066, 218, 21, 'PPL', 'P'),
(50997, 'Roland Park', 39.3544387817383, 0.686864532015879, -76.6344375610352, -1.33752325585408, 218, 25, 'PPL', 'P'),
(105862, 'Roland Park', 36.8963890075684, 0.643963470278711, -76.2630615234375, -1.33104152123499, 218, 53, 'PPL', 'P'),
(144383, 'Roland Park', 43.7322196960449, 0.763271222901498, -71.1999969482422, -1.24267437415674, 218, 36, 'PPL', 'P'),
(51036, 'Roland Terrace', 39.2191696166992, 0.684503639709524, -76.6011123657227, -1.336941621472, 218, 25, 'PPL', 'P'),
(105860, 'Roland Terrace', 37.3011093139648, 0.65102717217501, -80.0186080932617, -1.3965881740904, 218, 53, 'PPL', 'P'),
(184650, 'Rolands', 38.5108299255371, 0.672140779876185, -122.979438781738, -2.14639611899614, 218, 6, 'PPL', 'P'),
(105861, 'Rolands Mill', 37.329719543457, 0.6515265148794, -77.1816711425781, -1.34707428362948, 218, 53, 'PPL', 'P'),
(74121, 'Rolandus', 38.9638900756836, 0.680048171205821, -81.8249969482422, -1.42811560718114, 218, 41, 'PPL', 'P'),
(50998, 'Rolee Estates', 38.7380599975586, 0.676106692792504, -76.9430618286133, -1.34290976547487, 218, 25, 'PPL', 'P'),
(166623, 'Roler', 40.0127792358398, 0.698354740539026, -76.9225006103516, -1.34255090451798, 218, 45, 'PPL', 'P'),
(179003, 'Roles Inn of America', 33.5447196960449, 0.585465805354575, -112.166938781738, -1.95768239362425, 218, 5, 'PPL', 'P'),
(68340, 'Rolesville', 35.9230613708496, 0.626975698317313, -78.4577789306641, -1.36934656614192, 218, 33, 'PPL', 'P'),
(140790, 'Rolette', 48.660831451416, 0.849291725585221, -99.8411102294922, -1.74255610235123, 218, 34, 'PPL', 'P'),
(111184, 'Rolfe', 37.417781829834, 0.653063491723512, -81.4013900756836, -1.42072227252091, 218, 58, 'PPL', 'P'),
(117592, 'Rolfe', 42.8127784729004, 0.747223946279062, -94.5266723632813, -1.64980166369319, 218, 16, 'PPL', 'P'),
(166624, 'Rolfe', 41.497501373291, 0.724268030314797, -78.6888885498047, -1.37338018992896, 218, 45, 'PPL', 'P'),
(117593, 'Rolfe (historical)', 42.8375015258789, 0.747655444954682, -94.476936340332, -1.64893360633588, 218, 16, 'PPL', 'P'),
(11659, 'Rolfe Junction', 33.1236114501953, 0.578116079957202, -91.8724975585938, -1.60347757442791, 218, 4, 'PPL', 'P'),
(184651, 'Rolinda', 36.735279083252, 0.641151571641751, -119.960830688477, -2.09371146894137, 218, 6, 'PPL', 'P'),
(77127, 'Roll', 35.7791709899902, 0.624464337409369, -99.7111129760742, -1.74028722226054, 218, 42, 'PPL', 'P'),
(123576, 'Roll', 40.5522193908691, 0.707769747361756, -85.3902816772461, -1.49034156447333, 218, 19, 'PPL', 'P'),
(179004, 'Roll', 32.7516708374023, 0.571624491642079, -113.988327026367, -1.98947161545014, 218, 5, 'PPL', 'P'),
(11660, 'Rolla', 34.2080612182617, 0.59704329898245, -92.7305603027344, -1.61845359450186, 218, 4, 'PPL', 'P'),
(57258, 'Rolla', 37.9513893127441, 0.662376699213573, -91.771110534668, -1.60170803704161, 218, 29, 'PPL', 'P'),
(140793, 'Rolla', 48.857780456543, 0.852729134183213, -99.6175003051758, -1.73865337293177, 218, 34, 'PPL', 'P'),
(187276, 'Rolla', 39.8691711425781, 0.695848306479098, -104.890830993652, -1.83069035599215, 218, 7, 'PPL', 'P'),
(192128, 'Rolla', 34.8052787780762, 0.607466711751938, -100.310279846191, -1.75074465691295, 218, 51, 'PPL', 'P'),
(193059, 'Rolla', 37.1199989318848, 0.647866199698168, -101.63166809082, -1.77380723247887, 218, 20, 'PPL', 'P'),
(137777, 'Rollag', 46.7400016784668, 0.815766921676922, -96.2377777099609, -1.67966608584123, 218, 28, 'PPL', 'P'),
(132885, 'Rolland Center', 43.524169921875, 0.759640069334202, -84.9961090087891, -1.48346195358738, 218, 27, 'PPL', 'P'),
(50999, 'Roller', 39.6969413757324, 0.692842329977698, -76.8069381713867, -1.34053395946641, 218, 25, 'PPL', 'P'),
(157426, 'Rollersville', 41.3408317565918, 0.721533629665558, -83.3783264160156, -1.45522632076204, 218, 41, 'PPL', 'P'),
(51000, 'Rolles Beach', 38.7733306884766, 0.676722282478476, -76.2508316040039, -1.33082806887362, 218, 25, 'PPL', 'P'),
(17843, 'Rollestown (historical)', 29.6333293914795, 0.517199166209325, -81.5999984741211, -1.42418864299576, 218, 12, 'PPL', 'P'),
(33811, 'Rollin', 37.6341705322266, 0.65684018704438, -95.355827331543, -1.66427314789862, 218, 20, 'PPL', 'P'),
(132887, 'Rollin', 41.9119415283203, 0.731501375572534, -84.3236083984375, -1.47172460371508, 218, 27, 'PPL', 'P'),
(179005, 'Rollin W Mobile Home Ranch', 33.6463890075684, 0.587240269588895, -112.040832519531, -1.95548142414135, 218, 5, 'PPL', 'P'),
(24497, 'Rolling Acres', 31.5013904571533, 0.549802982433647, -84.2341690063477, -1.47016359184213, 218, 13, 'PPL', 'P'),
(31001, 'Rolling Acres', 38.0666694641113, 0.664388717417128, -87.2708282470703, -1.52316329385385, 218, 19, 'PPL', 'P'),
(42856, 'Rolling Acres', 30.5972194671631, 0.534022221657301, -91.1302795410156, -1.59052342625355, 218, 22, 'PPL', 'P'),
(51005, 'Rolling Acres', 38.4922218322754, 0.67181600738125, -76.732780456543, -1.33923966317663, 218, 25, 'PPL', 'P'),
(68341, 'Rolling Acres', 36.0080604553223, 0.628459212202542, -80.1841735839844, -1.39947783703119, 218, 33, 'PPL', 'P'),
(90460, 'Rolling Acres', 36.4472198486328, 0.636123989556872, -86.6750030517578, -1.51276418242931, 218, 50, 'PPL', 'P'),
(176160, 'Rolling Acres', 42.9002799987793, 0.748751136006168, -89.2186126708984, -1.55715854516871, 218, 57, 'PPL', 'P'),
(97615, 'Rolling Acres Colonia', 27.9729995727539, 0.488220944203523, -97.8889999389648, -1.70848535041946, 218, 51, 'PPL', 'P'),
(97616, 'Rolling Acres Estates Colonia', 27.94700050354, 0.487767174843287, -97.9860000610352, -1.71017832192443, 218, 51, 'PPL', 'P'),
(90464, 'Rolling Brook', 35.1847190856934, 0.614089194434638, -84.8127822875977, -1.48026229869571, 218, 50, 'PPL', 'P'),
(51006, 'Rolling Carroll Estates', 39.3888893127441, 0.687465807210992, -77.0650024414063, -1.34503803066001, 218, 25, 'PPL', 'P'),
(51007, 'Rolling Falls Estates', 39.6597213745117, 0.692192718408801, -76.8144378662109, -1.34066485383399, 218, 25, 'PPL', 'P'),
(37992, 'Rolling Fields', 38.2677803039551, 0.667898763733852, -85.6716690063477, -1.49525269983955, 218, 21, 'PPL', 'P'),
(90465, 'Rolling Fields', 35.6080589294434, 0.621477868562954, -87.0591735839844, -1.5194692231058, 218, 50, 'PPL', 'P'),
(105863, 'Rolling Fields', 39.1719398498535, 0.683679324773117, -78.1386108398438, -1.36377603208981, 218, 53, 'PPL', 'P'),
(61587, 'Rolling Fork', 32.9063911437988, 0.574324870408392, -90.878059387207, -1.5861213541297, 218, 30, 'PPL', 'P'),
(51008, 'Rolling Glen Farms', 38.7866706848145, 0.676955109336776, -76.8033294677734, -1.34047097570663, 218, 25, 'PPL', 'P'),
(28449, 'Rolling Green', 39.4633293151855, 0.688765030348787, -88.3349990844727, -1.54173657877022, 218, 18, 'PPL', 'P'),
(51010, 'Rolling Green', 39.577220916748, 0.690752813786422, -76.248893737793, -1.33079424672777, 218, 25, 'PPL', 'P'),
(68343, 'Rolling Green', 35.6119384765625, 0.621545579433669, -82.5044403076172, -1.43997413088304, 218, 33, 'PPL', 'P'),
(121278, 'Rolling Greens Mobile Home Park', 41.9377784729004, 0.731952315324111, -89.1052780151367, -1.55518048226905, 218, 18, 'PPL', 'P'),
(176161, 'Rolling Ground', 43.3294410705566, 0.75624140973007, -90.7402801513672, -1.58371665282342, 218, 57, 'PPL', 'P'),
(24498, 'Rolling Groves', 31.5963897705078, 0.551461033238817, -84.1083297729492, -1.46796728289114, 218, 13, 'PPL', 'P'),
(51011, 'Rolling Heights', 39.3161087036133, 0.686195545950051, -76.7588882446289, -1.33969533003915, 218, 25, 'PPL', 'P'),
(166625, 'Rolling Hill Acres', 40.5272216796875, 0.707333454996174, -75.1699981689453, -1.3119639667662, 218, 45, 'PPL', 'P'),
(123577, 'Rolling Hill Estates', 41.4772186279297, 0.723914029626898, -87.4005584716797, -1.52542751341263, 218, 19, 'PPL', 'P'),
(5517, 'Rolling Hills', 32.4449996948242, 0.566272070483238, -85.0244369506836, -1.48395636944376, 218, 2, 'PPL', 'P'),
(11669, 'Rolling Hills', 34.9588890075684, 0.610147716021321, -92.1055603027344, -1.6075452866769, 218, 4, 'PPL', 'P'),
(14519, 'Rolling Hills', 39.7180595397949, 0.693210911472565, -75.6500015258789, -1.32034160576532, 218, 10, 'PPL', 'P'),
(17845, 'Rolling Hills', 27.8233299255371, 0.485608716069291, -81.9688873291016, -1.43062696808908, 218, 12, 'PPL', 'P'),
(33812, 'Rolling Hills', 37.6861114501953, 0.657746727079443, -97.4472198486328, -1.70077483327341, 218, 20, 'PPL', 'P'),
(37994, 'Rolling Hills', 38.2825012207031, 0.668155692200018, -85.5744400024414, -1.49355573359295, 218, 21, 'PPL', 'P'),
(51016, 'Rolling Hills', 38.2216682434082, 0.667093956452431, -75.4655609130859, -1.31712250979769, 218, 25, 'PPL', 'P'),
(68345, 'Rolling Hills', 35.0219383239746, 0.611248134183741, -80.5744400024414, -1.40628927099323, 218, 33, 'PPL', 'P'),
(74123, 'Rolling Hills', 39.2880592346191, 0.685705990362667, -82.144172668457, -1.43368627439131, 218, 41, 'PPL', 'P'),
(90468, 'Rolling Hills', 35.4411087036133, 0.618564037435271, -86.8152770996094, -1.51521242641942, 218, 50, 'PPL', 'P'),
(97622, 'Rolling Hills', 30.1672992706299, 0.526518698706975, -96.0200119018555, -1.67586535549152, 218, 51, 'PPL', 'P'),
(105867, 'Rolling Hills', 37.2861099243164, 0.650765383439855, -80.1033325195313, -1.39806689428567, 218, 53, 'PPL', 'P'),
(111186, 'Rolling Hills', 39.3333282470703, 0.686496083679067, -81.4413909912109, -1.42142042020068, 218, 58, 'PPL', 'P'),
(123578, 'Rolling Hills', 41.0272216796875, 0.716060101256145, -85.2680587768555, -1.48820837244018, 218, 19, 'PPL', 'P'),
(184654, 'Rolling Hills', 37.9438896179199, 0.662245804845996, -120.425003051758, -2.10181280497739, 218, 6, 'PPL', 'P'),
(209709, 'Rolling Hills', 42.9027786254883, 0.748794745269018, -105.843612670898, -1.84731953331277, 218, 59, 'PPL', 'P'),
(179006, 'Rolling Hills Country Club Estates', 32.2011108398438, 0.56201540695491, -110.811393737793, -1.93402366944831, 218, 5, 'PPL', 'P'),
(83365, 'Rolling Hills Estates', 34.7183303833008, 0.605949175983784, -81.2236099243164, -1.41761942353486, 218, 48, 'PPL', 'P'),
(184655, 'Rolling Hills Estates', 33.7877807617188, 0.58970802123399, -118.357223510742, -2.06572324378129, 218, 6, 'PPL', 'P'),
(117595, 'Rolling Hills Mobile Home Park', 41.913330078125, 0.731525610338453, -93.397216796875, -1.63008894530442, 218, 16, 'PPL', 'P'),
(51019, 'Rolling Knolls', 39.1794395446777, 0.683810219140695, -77.1208267211914, -1.34601234814481, 218, 25, 'PPL', 'P'),
(205595, 'Rolling Knolls', 40.6263885498047, 0.709064243388616, -111.830558776855, -1.95181145500117, 218, 52, 'PPL', 'P'),
(74124, 'Rolling Knolls Estate', 39.2075004577637, 0.68429997446516, -84.4222183227539, -1.47344567156954, 218, 41, 'PPL', 'P'),
(14520, 'Rolling Meadows', 39.5766716003418, 0.690743226406498, -75.6838912963867, -1.32093309384343, 218, 10, 'PPL', 'P'),
(24501, 'Rolling Meadows', 33.4130592346191, 0.583167896808001, -82.0805587768555, -1.43257600253286, 218, 13, 'PPL', 'P'),
(51020, 'Rolling Meadows', 38.3580589294434, 0.669474422992798, -75.6763916015625, -1.32080219947585, 218, 25, 'PPL', 'P'),
(68347, 'Rolling Meadows', 35.5825004577637, 0.621031789080366, -77.2972183227539, -1.34909096236494, 218, 33, 'PPL', 'P'),
(90471, 'Rolling Meadows', 36.2180595397949, 0.632124387652764, -85.5208282470703, -1.49262003194395, 218, 50, 'PPL', 'P'),
(97617, 'Rolling Meadows', 32.4152793884277, 0.565753353281918, -94.8097229003906, -1.65474182751528, 218, 51, 'PPL', 'P'),
(111188, 'Rolling Meadows', 38.4430618286133, 0.670958003457054, -81.9058303833008, -1.42952641676861, 218, 58, 'PPL', 'P'),
(121279, 'Rolling Meadows', 42.084171295166, 0.734507352073933, -88.0130615234375, -1.53611770834432, 218, 18, 'PPL', 'P'),
(152187, 'Rolling Meadows', 41.9230613708496, 0.731695453436973, -74.0533294677734, -1.29247442127679, 218, 40, 'PPL', 'P'),
(24502, 'Rolling Meadows Estates', 33.4119415283203, 0.583148389153016, -84.4891662597656, -1.47461413349781, 218, 13, 'PPL', 'P'),
(14521, 'Rolling Park', 39.7874984741211, 0.694422849505633, -75.470832824707, -1.31721452201335, 218, 10, 'PPL', 'P'),
(51021, 'Rolling Park', 39.3516693115234, 0.686816195642094, -76.7688903808594, -1.3398699002486, 218, 25, 'PPL', 'P'),
(68348, 'Rolling Park', 35.7833290100098, 0.624536908549073, -80.3202819824219, -1.40185337672354, 218, 33, 'PPL', 'P'),
(123579, 'Rolling Prairie', 41.6708297729492, 0.727293181576045, -86.6158294677734, -1.51173140855857, 218, 19, 'PPL', 'P'),
(176162, 'Rolling Prairie', 43.459171295166, 0.758505629288855, -88.7341690063477, -1.54870340818187, 218, 57, 'PPL', 'P'),
(17846, 'Rolling Ranches', 29.0658302307129, 0.507294437351643, -82.3441696166992, -1.43717687963208, 218, 12, 'PPL', 'P'),
(14522, 'Rolling Ridge', 39.7638893127441, 0.69401079190597, -75.6777801513672, -1.32082643424177, 218, 10, 'PPL', 'P'),
(24503, 'Rolling Ridge', 33.9386100769043, 0.592340489392506, -84.1116714477539, -1.46802560611901, 218, 13, 'PPL', 'P'),
(31003, 'Rolling Ridge', 39.5447196960449, 0.690185560474235, -85.7780609130859, -1.4971095889096, 218, 19, 'PPL', 'P'),
(51025, 'Rolling Ridge', 39.3055610656738, 0.6860114549397, -76.8038864135742, -1.34048069624461, 218, 25, 'PPL', 'P'),
(51026, 'Rolling Road Farms', 39.3202781677246, 0.686268316826838, -76.7497177124023, -1.33953527405763, 218, 25, 'PPL', 'P'),
(166626, 'Rolling Stone', 41.0558280944824, 0.716559377381508, -78.1538925170898, -1.36404274767298, 218, 45, 'PPL', 'P'),
(74125, 'Rolling Terrace Mobile Home Park', 39.9513893127441, 0.69728328425346, -83.8691711425781, -1.4637931773566, 218, 41, 'PPL', 'P'),
(51027, 'Rolling View', 38.9530601501465, 0.679859153347453, -76.8536071777344, -1.34134848728581, 218, 25, 'PPL', 'P'),
(24504, 'Rolling View Estates', 33.7519416809082, 0.589082511272958, -84.9436111450195, -1.48254569301434, 218, 13, 'PPL', 'P'),
(105868, 'Rolling Woods', 37.2949981689453, 0.650920512573352, -80.0141677856445, -1.39651067610268, 218, 53, 'PPL', 'P'),
(208597, 'Rollingbay', 47.6647186279297, 0.831906277094047, -122.508888244629, -2.13818346282655, 218, 56, 'PPL', 'P'),
(68352, 'Rollingreen', 36.0313911437988, 0.628866409533215, -80.3783264160156, -1.40286644320221, 218, 33, 'PPL', 'P'),
(137779, 'Rollingstone', 44.0977783203125, 0.769651424504028, -91.8166732788086, -1.60250325694311, 218, 28, 'PPL', 'P'),
(37993, 'Rollington', 38.3194389343262, 0.668800376920899, -85.4974975585938, -1.49221283461327, 218, 21, 'PPL', 'P'),
(24506, 'Rollingwood', 34.2872200012207, 0.598424880376955, -85.2544403076172, -1.48797068531289, 218, 13, 'PPL', 'P'),
(51028, 'Rollingwood', 38.9833297729492, 0.680387457928697, -77.0688934326172, -1.3451059412678, 218, 25, 'PPL', 'P'),
(68354, 'Rollingwood', 35.5738906860352, 0.620881520215858, -77.4052810668945, -1.35097701304894, 218, 33, 'PPL', 'P'),
(83366, 'Rollingwood', 34.0099983215332, 0.593586449308499, -81.2786102294922, -1.41857935994978, 218, 48, 'PPL', 'P'),
(90474, 'Rollingwood', 35.0519409179688, 0.611771778233078, -85.2236099243164, -1.48743259361464, 218, 50, 'PPL', 'P'),
(97618, 'Rollingwood', 30.2766704559326, 0.528427585997317, -97.7908325195313, -1.70677200573216, 218, 51, 'PPL', 'P'),
(105869, 'Rollingwood', 38.7361106872559, 0.676072670909578, -77.206672668457, -1.34751064257409, 218, 53, 'PPL', 'P'),
(184656, 'Rollingwood', 37.9652786254883, 0.662619113451798, -122.328887939453, -2.13504186484664, 218, 6, 'PPL', 'P'),
(68358, 'Rollingwood Estates', 35.2922210693359, 0.615965458001626, -78.0297164916992, -1.36187546717787, 218, 33, 'PPL', 'P'),
(24507, 'Rollingwood Mobile Home Park', 34.1263885498047, 0.595617842008985, -84.2577819824219, -1.47057571602082, 218, 13, 'PPL', 'P'),
(5526, 'Rollins', 32.9461097717285, 0.57501809124014, -85.4252777099609, -1.49095236046934, 218, 2, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(24508, 'Rollins', 33.8658294677734, 0.591070228131565, -84.9022216796875, -1.48182331056866, 218, 13, 'PPL', 'P'),
(68360, 'Rollins', 35.7894401550293, 0.624643568150731, -82.6636123657227, -1.44275220737416, 218, 33, 'PPL', 'P'),
(111190, 'Rollins', 38.8052787780762, 0.677279881831711, -81.9502792358398, -1.43030219559415, 218, 58, 'PPL', 'P'),
(137783, 'Rollins', 47.2566719055176, 0.824784518285984, -91.8450012207031, -1.60299767279948, 218, 28, 'PPL', 'P'),
(177328, 'Rollins', 42.3794403076172, 0.739660768520318, -88.0627822875977, -1.53698549938552, 218, 18, 'PPL', 'P'),
(197424, 'Rollins', 47.9061088562012, 0.836119331359525, -114.19750213623, -1.99312240983048, 218, 31, 'PPL', 'P'),
(5527, 'Rollins (historical)', 34.1819381713867, 0.596587365803828, -86.0963897705078, -1.50266547557573, 218, 2, 'PPL', 'P'),
(68361, 'Rollins (historical)', 35.6594390869141, 0.622374621481011, -81.7830581665039, -1.42738363735553, 218, 33, 'PPL', 'P'),
(111191, 'Rollins Branch', 37.7227783203125, 0.658386684689389, -81.5963897705078, -1.42412565923598, 218, 58, 'PPL', 'P'),
(17847, 'Rollins Corner', 30.436939239502, 0.531224803958768, -85.2216720581055, -1.48739877146879, 218, 12, 'PPL', 'P'),
(105870, 'Rollins Fork', 38.1847190856934, 0.666449071994468, -77.0625, -1.34499435481813, 218, 53, 'PPL', 'P'),
(128685, 'Rollins Mill', 45.0519409179688, 0.786304703432511, -69.0302810668945, -1.20480568819441, 218, 26, 'PPL', 'P'),
(128682, 'Rollins Mills', 44.7294387817383, 0.780675979310574, -69.146110534668, -1.20682729377789, 218, 26, 'PPL', 'P'),
(51029, 'Rollins Park', 39.0602798461914, 0.681730490066424, -77.1305618286133, -1.34618225782236, 218, 25, 'PPL', 'P'),
(90475, 'Rollins Subdivision', 36.1355590820313, 0.630684483030385, -82.8138885498047, -1.44537502157372, 218, 50, 'PPL', 'P'),
(51030, 'Rollins View Green', 39.3733291625977, 0.687194231358831, -76.5319366455078, -1.33573427739182, 218, 25, 'PPL', 'P'),
(144384, 'Rollinsford', 43.2361106872559, 0.754612487249323, -70.8208312988281, -1.236056685164, 218, 36, 'PPL', 'P'),
(144385, 'Rollinsford Station', 43.2294387817383, 0.754496040530659, -70.8433303833008, -1.23644936826674, 218, 36, 'PPL', 'P'),
(11663, 'Rollinson (historical)', 34.9249992370605, 0.609556227943214, -90.6277770996094, -1.5817531041517, 218, 4, 'PPL', 'P'),
(187277, 'Rollinsville', 39.9172210693359, 0.696686935906364, -105.500556945801, -1.841332081392, 218, 7, 'PPL', 'P'),
(121280, 'Rollo', 41.6730613708496, 0.727332130306987, -88.8861083984375, -1.55135525083732, 218, 18, 'PPL', 'P'),
(97619, 'Rollover', 29.5058307647705, 0.514973895381482, -94.5066680908203, -1.64945252327428, 218, 51, 'PPL', 'P'),
(111192, 'Rollyson', 38.7833290100098, 0.676896786108903, -80.64111328125, -1.40745293923154, 218, 58, 'PPL', 'P'),
(51031, 'Rolph Landing', 38.8988914489746, 0.678913731160475, -75.9463882446289, -1.32551452986669, 218, 25, 'PPL', 'P'),
(51032, 'Rolphs', 39.1741714477539, 0.683718273504059, -76.0363922119141, -1.32708539543567, 218, 25, 'PPL', 'P'),
(24509, 'Rolston', 34.6736106872559, 0.605168670047309, -84.3444366455078, -1.47208812520387, 218, 13, 'PPL', 'P'),
(184657, 'Roma', 38.1430587768555, 0.665721962437849, -121.23722076416, -2.11598867830183, 218, 6, 'PPL', 'P'),
(97620, 'Roma Creek', 26.4241695404053, 0.461188760585269, -99.0227813720703, -1.72827356942514, 218, 51, 'PPL', 'P'),
(97621, 'Roma Creek Number 1, 2 and 3 Colonia', 26.4200000762939, 0.461115989708482, -99.0179977416992, -1.72819007932496, 218, 51, 'PPL', 'P'),
(97625, 'Roma-Los Saenz', 26.4047203063965, 0.460849307414825, -99.0155563354492, -1.72814746874752, 218, 51, 'PPL', 'P'),
(105871, 'Roman', 38.2825012207031, 0.668155692200018, -79.0152816772461, -1.37907682465869, 218, 53, 'PPL', 'P'),
(83368, 'Roman Acres', 34.2541694641113, 0.597848039684844, -82.1833267211914, -1.43436964152703, 218, 48, 'PPL', 'P'),
(97623, 'Roman Forest', 30.1788902282715, 0.526720999081281, -95.1622161865234, -1.66089399594948, 218, 51, 'PPL', 'P'),
(11664, 'Romance', 35.2408294677734, 0.615068505346487, -92.0511093139648, -1.60659493764191, 218, 4, 'PPL', 'P'),
(57263, 'Romance', 36.7169418334961, 0.64083152625775, -92.5025024414063, -1.61447323393663, 218, 29, 'PPL', 'P'),
(111199, 'Romance', 38.5972213745117, 0.673648595106361, -81.5988922119141, -1.42416933507786, 218, 58, 'PPL', 'P'),
(176164, 'Romance', 43.5522193908691, 0.760129624921586, -91.1447219848633, -1.59077549445073, 218, 57, 'PPL', 'P'),
(51033, 'Romancoke', 38.8811111450195, 0.678603406314453, -76.336669921875, -1.33232623014484, 218, 25, 'PPL', 'P'),
(105872, 'Romancoke', 37.5733299255371, 0.655778318138738, -76.850830078125, -1.34130001775397, 218, 53, 'PPL', 'P'),
(51034, 'Romancoke on the Bay', 38.8769416809082, 0.678530635437667, -76.3383331298828, -1.33235525860072, 218, 25, 'PPL', 'P'),
(79051, 'Romania', 39.7933311462402, 0.694524648838301, -79.0449981689453, -1.37959547528098, 218, 45, 'PPL', 'P'),
(190679, 'Romano (historical)', 39.936939239502, 0.697031082898229, -116.075561523438, -2.02590072968523, 218, 39, 'PPL', 'P'),
(79052, 'Romansville', 39.9519386291504, 0.697292871633384, -75.7411117553711, -1.32193177925221, 218, 45, 'PPL', 'P'),
(5529, 'Romar Beach', 30.2605590820313, 0.528146389475718, -87.6222229003906, -1.52929628752819, 218, 2, 'PPL', 'P'),
(51035, 'Romar Estates', 38.9513893127441, 0.679829991733517, -76.5147171020508, -1.3354337396628, 218, 25, 'PPL', 'P'),
(97624, 'Romayor', 30.4511108398438, 0.531472145045009, -94.8430633544922, -1.65532372821347, 218, 51, 'PPL', 'P'),
(57260, 'Rombauer', 36.8430595397949, 0.643032695477728, -90.2799987792969, -1.57568322739519, 218, 29, 'PPL', 'P'),
(152188, 'Rombout Ridge', 41.6624984741211, 0.727147772980527, -73.8663864135742, -1.28921164946728, 218, 40, 'PPL', 'P'),
(121281, 'Rombury Oaks', 41.8747215270996, 0.730851764003636, -88.4677810668945, -1.54405406155081, 218, 18, 'PPL', 'P'),
(490, 'Rome', 37.9233283996582, 0.661886943889108, -86.5236129760742, -1.51012192715378, 218, 19, 'PPL', 'P'),
(5530, 'Rome', 31.1416702270508, 0.543524680032326, -86.6688919067383, -1.51265752282765, 218, 2, 'PPL', 'P'),
(24510, 'Rome', 34.2569389343262, 0.597896376058629, -85.1647186279297, -1.48640474659192, 218, 13, 'PPL', 'P'),
(33813, 'Rome', 37.1613883972168, 0.648588582143852, -97.1425018310547, -1.69545650057652, 218, 20, 'PPL', 'P'),
(37995, 'Rome', 37.7211112976074, 0.65835758965448, -87.1808319091797, -1.52159256144292, 218, 21, 'PPL', 'P'),
(42857, 'Rome', 30.3769397735596, 0.530177615728635, -90.5505599975586, -1.58040541148207, 218, 22, 'PPL', 'P'),
(57261, 'Rome', 36.8413887023926, 0.643003533863792, -92.7733306884766, -1.61920007855541, 218, 29, 'PPL', 'P'),
(61594, 'Rome', 33.1044387817383, 0.577781453766233, -89.2399978637695, -1.55753178719548, 218, 30, 'PPL', 'P'),
(83369, 'Rome', 33.6477813720703, 0.587264570933842, -79.438606262207, -1.3864652324709, 218, 48, 'PPL', 'P'),
(90476, 'Rome', 36.2619400024414, 0.632890246203243, -86.0716705322266, -1.50223404347913, 218, 50, 'PPL', 'P'),
(117596, 'Rome', 40.9813919067383, 0.71526022082274, -91.6822204589844, -1.60015661254858, 218, 16, 'PPL', 'P'),
(121282, 'Rome', 40.8830604553223, 0.713544013237266, -89.5025024414063, -1.5621133563768, 218, 18, 'PPL', 'P'),
(128683, 'Rome', 44.5849990844727, 0.778155031022705, -69.8697204589844, -1.21945666945732, 218, 26, 'PPL', 'P'),
(152190, 'Rome', 43.2127799987793, 0.75420528991865, -75.4561080932617, -1.31695752696816, 218, 40, 'PPL', 'P'),
(157430, 'Rome', 40.9263916015625, 0.714300284407821, -82.5302810668945, -1.44042513721365, 218, 41, 'PPL', 'P'),
(166627, 'Rome', 41.8583297729492, 0.730565673923534, -76.3411102294922, -1.33240372813256, 218, 45, 'PPL', 'P'),
(176165, 'Rome', 42.980281829834, 0.750147431365696, -88.6311111450195, -1.54690470918163, 218, 57, 'PPL', 'P'),
(201501, 'Rome', 42.839168548584, 0.747684539989591, -117.627220153809, -2.05298228165219, 218, 43, 'PPL', 'P'),
(132889, 'Rome Center', 41.9436111450195, 0.73205411465678, -84.1877822875977, -1.46935399087074, 218, 27, 'PPL', 'P'),
(123580, 'Rome City', 41.4961090087891, 0.72424372896985, -85.3766708374023, -1.4901040105041, 218, 19, 'PPL', 'P'),
(11665, 'Rome City (historical)', 36.3944396972656, 0.635202802135813, -94.6005630493164, -1.65109129945106, 218, 4, 'PPL', 'P'),
(128684, 'Rome Corner', 44.5722198486328, 0.777931991281411, -69.9038925170898, -1.22005308438344, 218, 26, 'PPL', 'P'),
(17848, 'Romeo', 29.2061100006104, 0.509742781210294, -82.436393737793, -1.43878649419492, 218, 12, 'PPL', 'P'),
(61595, 'Romeo', 33.0250015258789, 0.576395012102738, -90.5652770996094, -1.5806622733692, 218, 30, 'PPL', 'P'),
(90477, 'Romeo', 36.2911109924316, 0.633399376024639, -82.9358291625977, -1.44750328675886, 218, 50, 'PPL', 'P'),
(121283, 'Romeo', 41.6405601501465, 0.726764876994801, -88.0583267211914, -1.53690773508169, 218, 18, 'PPL', 'P'),
(132891, 'Romeo', 42.8027801513672, 0.747049442648634, -83.0130615234375, -1.4488512457446, 218, 27, 'PPL', 'P'),
(187278, 'Romeo', 37.1722183227539, 0.64877760000222, -105.984718322754, -1.84978229153082, 218, 7, 'PPL', 'P'),
(121284, 'Romeoville', 41.6474990844727, 0.726885984245372, -88.0894393920898, -1.53745075362796, 218, 18, 'PPL', 'P'),
(42858, 'Romero', 30.0791702270508, 0.524980556729887, -91.898063659668, -1.60392378706856, 218, 22, 'PPL', 'P'),
(189376, 'Romero', 35.5361099243164, 0.620222121529954, -105.223892211914, -1.83650337086152, 218, 38, 'PPL', 'P'),
(192129, 'Romero', 35.7275009155273, 0.623562524485241, -102.93083190918, -1.79648191863203, 218, 51, 'PPL', 'P'),
(189378, 'Romero Place', 34.6436080932617, 0.604645025997972, -106.296112060547, -1.8552171375254, 218, 38, 'PPL', 'P'),
(189380, 'Romeroville', 35.5227813720703, 0.619989494408736, -105.244171142578, -1.83685730497039, 218, 38, 'PPL', 'P'),
(42859, 'Romeville', 30.062219619751, 0.524684712822292, -90.8466720581055, -1.58557354189347, 218, 22, 'PPL', 'P'),
(114005, 'Romford', 41.6752815246582, 0.727370879300848, -73.291389465332, -1.27917605953153, 218, 8, 'PPL', 'P'),
(77128, 'Romia', 33.8380584716797, 0.590585532813171, -96.1697235107422, -1.67847831599505, 218, 42, 'PPL', 'P'),
(5531, 'Romine', 34.8611106872559, 0.608441162394798, -87.2666702270508, -1.52309072271414, 218, 2, 'PPL', 'P'),
(37996, 'Romine', 37.2355613708496, 0.649883144749739, -85.3502807617188, -1.48964341679357, 218, 21, 'PPL', 'P'),
(123584, 'Romine Corner', 40.1419410705566, 0.700609039822751, -87.4330596923828, -1.52599476672482, 218, 19, 'PPL', 'P'),
(111193, 'Romines Mills', 39.1697196960449, 0.683640575779256, -80.2644424438477, -1.40087879292263, 218, 58, 'PPL', 'P'),
(68362, 'Rominger', 36.2261085510254, 0.632264869400265, -81.8386077880859, -1.42835316115037, 218, 33, 'PPL', 'P'),
(187279, 'Romley (historical)', 38.6749992370605, 0.675006074893001, -106.369438171387, -1.85649691958723, 218, 7, 'PPL', 'P'),
(97626, 'Romney', 32.2413902282715, 0.562718414903664, -98.9574966430664, -1.72713413595274, 218, 51, 'PPL', 'P'),
(111194, 'Romney', 39.3419418334961, 0.686646419122602, -78.7569427490234, -1.37456795977513, 218, 58, 'PPL', 'P'),
(123582, 'Romney', 40.249439239502, 0.702485236810712, -86.904167175293, -1.51676385091244, 218, 19, 'PPL', 'P'),
(166631, 'Romney', 40.0455589294434, 0.698926854120202, -79.4027786254883, -1.38583992224695, 218, 45, 'PPL', 'P'),
(97627, 'Romo Colonia', 26.2150001525879, 0.457538066073475, -98.161003112793, -1.71323270137864, 218, 51, 'PPL', 'P'),
(74130, 'Romohr Acres', 39.1383285522461, 0.683092696964, -84.2897186279297, -1.47113311563697, 218, 41, 'PPL', 'P'),
(166632, 'Romola', 41.0569381713867, 0.716578751878438, -77.6894378662109, -1.35593648478894, 218, 45, 'PPL', 'P'),
(184658, 'Romoland', 33.7458305358887, 0.5889758516713, -117.174171447754, -2.04507509005964, 218, 6, 'PPL', 'P'),
(31004, 'Romona', 39.327220916748, 0.686389490656436, -86.7300033569336, -1.51372411884423, 218, 19, 'PPL', 'P'),
(111196, 'Romont', 38.1813888549805, 0.666390948503677, -81.1041717529297, -1.4155348341916, 218, 58, 'PPL', 'P'),
(197425, 'Romsett Summer Home Area', 44.7433280944824, 0.780918393548799, -111.23999786377, -1.94150422263424, 218, 31, 'PPL', 'P'),
(5532, 'Romulus', 33.1474990844727, 0.578532997825854, -87.7519378662109, -1.53156024077087, 218, 2, 'PPL', 'P'),
(77129, 'Romulus', 35.1163902282715, 0.612896630898501, -96.9230575561523, -1.69162647545483, 218, 42, 'PPL', 'P'),
(132892, 'Romulus', 42.2222213745117, 0.736916780491155, -83.3966674804688, -1.45554643272506, 218, 27, 'PPL', 'P'),
(152192, 'Romulus', 42.7522201538086, 0.746167004221437, -76.8338928222656, -1.34100440687297, 218, 40, 'PPL', 'P'),
(5533, 'Romulus Acres', 33.1361083984375, 0.578334192850479, -87.7455596923828, -1.5314489206373, 218, 2, 'PPL', 'P'),
(77130, 'Ron', 34.7922210693359, 0.607238811741654, -99.8594436645508, -1.7428760811562, 218, 42, 'PPL', 'P'),
(33814, 'Ronald', 37.7916717529297, 0.65958910192156, -94.8041687011719, -1.65464488845161, 218, 20, 'PPL', 'P'),
(137785, 'Ronald', 46.4472198486328, 0.810656914756305, -93.0550003051758, -1.62411614076965, 218, 28, 'PPL', 'P'),
(208604, 'Ronald', 47.7491683959961, 0.833380203599351, -122.338607788086, -2.13521150820808, 218, 56, 'PPL', 'P'),
(51037, 'Ronalee Hills', 39.2519416809082, 0.685075620132646, -77.1930618286133, -1.34727308860486, 218, 25, 'PPL', 'P'),
(197426, 'Ronan', 47.5288887023926, 0.829535597670686, -114.100563049316, -1.99143050358995, 218, 31, 'PPL', 'P'),
(208599, 'Ronan', 46.3638916015625, 0.809202562485013, -117.92138671875, -2.0581164567597, 218, 56, 'PPL', 'P'),
(111197, 'Ronceverte', 37.7497215270996, 0.65885693235887, -80.4630584716797, -1.40434529655553, 218, 58, 'PPL', 'P'),
(79053, 'Ronco', 39.8697204589844, 0.695857893859022, -79.9205627441406, -1.39487695993197, 218, 45, 'PPL', 'P'),
(68363, 'Ronda', 36.2183303833008, 0.632129114763698, -80.9413909912109, -1.41269377394071, 218, 33, 'PPL', 'P'),
(111198, 'Ronda', 38.167781829834, 0.666153461113469, -81.4475021362305, -1.42152707980234, 218, 58, 'PPL', 'P'),
(184659, 'Ronda (historical)', 38.7780609130859, 0.676804840472268, -121.85888671875, -2.12683879605698, 218, 6, 'PPL', 'P'),
(11667, 'Rondo', 33.4444389343262, 0.583715575886175, -93.9775009155273, -1.64021681377194, 218, 4, 'PPL', 'P'),
(57262, 'Rondo', 37.7661094665527, 0.659142955859945, -93.4497222900391, -1.63100533903552, 218, 29, 'PPL', 'P'),
(105875, 'Rondo', 36.8283309936523, 0.642775633853508, -79.5319366455078, -1.38809415495165, 218, 53, 'PPL', 'P'),
(132895, 'Rondo', 45.3166694641113, 0.790925088186717, -84.6244430541992, -1.47697515896222, 218, 27, 'PPL', 'P'),
(121285, 'Rondout', 42.2799987792969, 0.737925186437914, -87.8952789306641, -1.53406201429889, 218, 18, 'PPL', 'P'),
(152194, 'Rondout', 41.9205589294434, 0.731651777595096, -73.9855575561523, -1.29129157827863, 218, 40, 'PPL', 'P'),
(11668, 'Rone', 34.0697212219238, 0.594628810559157, -92.1277770996094, -1.60793304293162, 218, 4, 'PPL', 'P'),
(177272, 'Roneys Point', 40.0736083984375, 0.699416409707586, -80.5999984741211, -1.40673535047582, 218, 58, 'PPL', 'P'),
(90478, 'Roneys Store', 36.3891716003418, 0.635110856499179, -89.2941665649414, -1.55847720938246, 218, 50, 'PPL', 'P'),
(105873, 'Ronk', 37.4058303833008, 0.652854899631131, -80.6402816772461, -1.4074384250036, 218, 53, 'PPL', 'P'),
(152195, 'Ronkonkoma', 40.8152809143066, 0.712361037081052, -73.1127777099609, -1.27605869631754, 218, 40, 'PPL', 'P'),
(166634, 'Ronks', 40.0261116027832, 0.698587434239272, -76.1688919067383, -1.32939795136824, 218, 45, 'PPL', 'P'),
(137786, 'Ronneby', 45.6813888549805, 0.797290642403252, -93.8644409179688, -1.63824354456224, 218, 28, 'PPL', 'P'),
(208600, 'Rony', 46.9438896179199, 0.819325437525485, -123.350830078125, -2.15287811993134, 218, 56, 'PPL', 'P'),
(17849, 'Rood', 26.9488906860352, 0.470346872231347, -80.1972198486328, -1.39970553730439, 218, 12, 'PPL', 'P'),
(28452, 'Roodhouse', 39.4838905334473, 0.689123891305675, -90.3713912963867, -1.5772783277301, 218, 18, 'PPL', 'P'),
(166633, 'Rook', 40.4141693115234, 0.705360318944534, -80.0691680908203, -1.3974706125176, 218, 45, 'PPL', 'P'),
(57264, 'Rookins', 37.8388900756836, 0.660413217120885, -93.7572174072266, -1.63637214126424, 218, 29, 'PPL', 'P'),
(68364, 'Rooks', 34.4963912963867, 0.602075608178263, -78.144172668457, -1.36387310431154, 218, 33, 'PPL', 'P'),
(121286, 'Rooks Creek', 40.8805618286133, 0.713500403974416, -88.7002792358398, -1.54811192010377, 218, 18, 'PPL', 'P'),
(195555, 'Rookstool Corner', 43.7783317565918, 0.76407603018292, -116.852500915527, -2.03946088016564, 218, 17, 'PPL', 'P'),
(37998, 'Rooney', 38.4150009155273, 0.670468248132588, -83.1908264160156, -1.45195382841455, 218, 21, 'PPL', 'P'),
(192130, 'Rooneys Place', 29.0955600738525, 0.507813321000531, -103.068328857422, -1.7988816930903, 218, 51, 'PPL', 'P'),
(51039, 'Roop Mill', 39.5900001525879, 0.690975853527716, -77.0313873291016, -1.34445133627186, 218, 25, 'PPL', 'P'),
(24511, 'Roopville', 33.4563903808594, 0.583924167978556, -85.1308288574219, -1.48581325851381, 218, 13, 'PPL', 'P'),
(5534, 'Roosevelt', 33.4394416809082, 0.583628357360475, -86.9330596923828, -1.51726812046485, 218, 2, 'PPL', 'P'),
(11670, 'Roosevelt', 35.5163917541504, 0.619877974538089, -91.6691665649414, -1.59992877911733, 218, 4, 'PPL', 'P'),
(24512, 'Roosevelt', 34.7030601501465, 0.605682660137694, -84.5505599975586, -1.47568565636241, 218, 13, 'PPL', 'P'),
(37997, 'Roosevelt', 37.4061088562012, 0.652859759900121, -83.366943359375, -1.45502764894472, 218, 21, 'PPL', 'P'),
(42860, 'Roosevelt', 32.5719413757324, 0.568487620773102, -91.1822204589844, -1.59142996628861, 218, 22, 'PPL', 'P'),
(57265, 'Roosevelt', 36.8305587768555, 0.642814516005424, -92.1233291625977, -1.60785541178584, 218, 29, 'PPL', 'P'),
(77131, 'Roosevelt', 34.8486099243164, 0.608222982922493, -99.0213928222656, -1.72824933465922, 218, 42, 'PPL', 'P'),
(132896, 'Roosevelt', 43.3491706848145, 0.756585756459017, -84.1902770996094, -1.46939753355457, 218, 27, 'PPL', 'P'),
(137793, 'Roosevelt', 48.8036117553711, 0.851783711996235, -95.0966720581055, -1.65975003510323, 218, 28, 'PPL', 'P'),
(146217, 'Roosevelt', 40.2200012207031, 0.701971446457408, -74.4736099243164, -1.29980969902525, 218, 37, 'PPL', 'P'),
(152196, 'Roosevelt', 40.6786117553711, 0.709975710271696, -73.5894393920898, -1.28437801208878, 218, 40, 'PPL', 'P'),
(176167, 'Roosevelt', 45.6719398498535, 0.797125726152748, -89.3147201538086, -1.5588359371813, 218, 57, 'PPL', 'P'),
(179007, 'Roosevelt', 33.6674995422363, 0.587608717925708, -111.133613586426, -1.93964746672223, 218, 5, 'PPL', 'P'),
(184661, 'Roosevelt', 33.8647193908691, 0.591050853634635, -118.302780151367, -2.06477302790435, 218, 6, 'PPL', 'P'),
(192132, 'Roosevelt', 33.5813903808594, 0.586105829543549, -101.673889160156, -1.7745441291525, 218, 51, 'PPL', 'P'),
(205601, 'Roosevelt', 40.2994384765625, 0.703357888120903, -109.988059997559, -1.91965378483846, 218, 52, 'PPL', 'P'),
(208603, 'Roosevelt', 48.7586097717285, 0.850998279211743, -122.450561523438, -2.13716546949987, 218, 56, 'PPL', 'P'),
(152197, 'Roosevelt Beach', 43.3074989318848, 0.755858447165317, -78.8586120605469, -1.37634242400945, 218, 40, 'PPL', 'P'),
(71341, 'Roosevelt City', 39.938060760498, 0.697050657132241, -74.3894424438477, -1.29834069936796, 218, 37, 'PPL', 'P'),
(97628, 'Roosevelt Colonia', 27.9720001220703, 0.488203500498383, -97.4029998779297, -1.70000304918951, 218, 51, 'PPL', 'P'),
(152198, 'Roosevelt Corners', 43.3044395446777, 0.755805050785461, -76.2408294677734, -1.33065349866416, 218, 40, 'PPL', 'P'),
(105874, 'Roosevelt Gardens', 36.9219398498535, 0.644409416603245, -76.2130584716797, -1.33016880334577, 218, 53, 'PPL', 'P'),
(51038, 'Roosevelt Heights', 38.5402793884277, 0.672654769966571, -76.9361114501953, -1.34278845848722, 218, 25, 'PPL', 'P'),
(179008, 'Roosevelt Lake Estates', 33.6222190856934, 0.586818424872227, -111.002777099609, -1.93736393924555, 218, 5, 'PPL', 'P'),
(179009, 'Roosevelt Lake Gardens East', 33.8188896179199, 0.59025097320123, -111.269721984863, -1.94202300641458, 218, 5, 'PPL', 'P'),
(179010, 'Roosevelt Lake Gardens West', 33.8505592346191, 0.590803712285476, -111.305557250977, -1.94264844979659, 218, 5, 'PPL', 'P'),
(71342, 'Roosevelt Park', 39.378059387207, 0.687276789352623, -75.0252838134766, -1.30943822478837, 218, 37, 'PPL', 'P'),
(132897, 'Roosevelt Park', 43.1963882446289, 0.753919199838548, -86.272216796875, -1.50573423609982, 218, 27, 'PPL', 'P'),
(179011, 'Roosevelt Resort', 33.601390838623, 0.586454903383431, -110.999168395996, -1.93730095548577, 218, 5, 'PPL', 'P'),
(97629, 'Roosevelt School Colonia', 26.1660003662109, 0.456682858468423, -97.9820022583008, -1.71010854710387, 218, 51, 'PPL', 'P'),
(5535, 'Roosevelt-Cairo Village', 33.4461097717285, 0.583744737500112, -86.918327331543, -1.5170109922616, 218, 2, 'PPL', 'P'),
(152199, 'Rooseveltown', 44.9727783203125, 0.784923055458978, -74.7313919067383, -1.30430884337083, 218, 40, 'PPL', 'P'),
(24514, 'Roosterville', 33.4033317565918, 0.582998120288508, -85.1838912963867, -1.48673937278289, 218, 13, 'PPL', 'P'),
(57266, 'Roosterville', 39.295280456543, 0.685832024461255, -94.436393737793, -1.64822600443424, 218, 29, 'PPL', 'P'),
(125987, 'Roosterville', 42.0791702270508, 0.734420066969206, -73.0730590820313, -1.27536547548579, 218, 23, 'PPL', 'P'),
(197428, 'Roosville', 48.9991683959961, 0.855196819249281, -115.055557250977, -2.00809829674638, 218, 31, 'PPL', 'P'),
(190680, 'Root Camp (historical)', 35.7830581665039, 0.624532181438138, -115.539436340332, -2.01654358003718, 218, 39, 'PPL', 'P'),
(152200, 'Root Center', 42.8230590820313, 0.747403376757506, -74.4761123657227, -1.29985337486712, 218, 40, 'PPL', 'P'),
(28454, 'Roots', 38.0177803039551, 0.663535440603867, -89.9722213745117, -1.57031149831845, 218, 18, 'PPL', 'P'),
(132899, 'Roots', 42.3355598449707, 0.738894909969839, -84.3222198486328, -1.47170036894916, 218, 27, 'PPL', 'P'),
(166635, 'Roots', 40.6133308410645, 0.708836343378333, -78.3613891601563, -1.36766424728132, 218, 45, 'PPL', 'P'),
(157432, 'Rootstown', 41.0988883972168, 0.717310921441128, -81.2427825927734, -1.41795404972583, 218, 41, 'PPL', 'P'),
(152202, 'Rootville', 42.4569396972656, 0.74101338803797, -75.2713928222656, -1.31373363731056, 218, 40, 'PPL', 'P'),
(166636, 'Rootville', 41.7747192382813, 0.729106394804225, -79.8711090087891, -1.39401382942267, 218, 45, 'PPL', 'P'),
(125988, 'Rooty Plain', 42.7027816772461, 0.745304140028251, -70.9513931274414, -1.23833541895073, 218, 23, 'PPL', 'P'),
(5536, 'Roper', 33.6063919067383, 0.586542188488158, -86.5802764892578, -1.51111089202459, 218, 2, 'PPL', 'P'),
(24515, 'Roper', 31.811939239502, 0.55522308117369, -82.6516723632813, -1.44254381501886, 218, 13, 'PPL', 'P'),
(33816, 'Roper', 37.6611099243164, 0.657310368134834, -95.7324981689453, -1.67084729420754, 218, 20, 'PPL', 'P'),
(37999, 'Roper', 36.6147193908691, 0.639047408064479, -88.8061065673828, -1.54995895547779, 218, 21, 'PPL', 'P'),
(68365, 'Roper', 35.8777809143066, 0.626185405263832, -76.6155624389648, -1.33719382282723, 218, 33, 'PPL', 'P'),
(205602, 'Roper', 40.7138900756836, 0.710591433115722, -111.907218933105, -1.95314942713283, 218, 52, 'PPL', 'P'),
(68366, 'Roper (historical)', 35.1572189331055, 0.613609226227179, -80.164436340332, -1.39913335714419, 218, 33, 'PPL', 'P'),
(68367, 'Roper Springs', 36.4266700744629, 0.635765328337065, -77.8733291625977, -1.35914599337665, 218, 33, 'PPL', 'P'),
(24516, 'Ropers Crossroads', 33.5072212219238, 0.584811333516688, -82.1413879394531, -1.43363767170142, 218, 13, 'PPL', 'P'),
(83371, 'Ropers Crossroads', 33.6816711425781, 0.587856059011949, -81.9850006103516, -1.4309081979002, 218, 48, 'PPL', 'P'),
(192133, 'Ropesville', 33.413330078125, 0.583172623918935, -102.15389251709, -1.78292176815162, 218, 51, 'PPL', 'P'),
(128687, 'Roque Bluffs', 44.6127815246582, 0.778639926078181, -67.4802780151367, -1.17775303152528, 218, 26, 'PPL', 'P'),
(117599, 'Rorbeck', 41.5480613708496, 0.725150468741995, -95.1333312988281, -1.66038985955512, 218, 16, 'PPL', 'P'),
(111201, 'Rorer', 38.0250015258789, 0.663661474702455, -80.2772216796875, -1.40110183266392, 218, 58, 'PPL', 'P'),
(105876, 'Rorer Mines (historical)', 37.2311096191406, 0.649805447024936, -79.9572219848633, -1.39551678438386, 218, 53, 'PPL', 'P'),
(5537, 'Rorex (historical)', 34.6861114501953, 0.605386849519613, -85.8777770996094, -1.49884996468197, 218, 2, 'PPL', 'P'),
(42862, 'Rork', 30.4394397735596, 0.531268446511132, -92.4111099243164, -1.61287813360173, 218, 22, 'PPL', 'P'),
(5539, 'Rosa', 33.9905586242676, 0.593247162585623, -86.5133285522461, -1.50994243009631, 218, 2, 'PPL', 'P'),
(11672, 'Rosa', 35.7694396972656, 0.624294494310849, -89.8497161865234, -1.56817337943728, 218, 4, 'PPL', 'P'),
(42863, 'Rosa', 30.7549991607666, 0.53677599680347, -92.0072174072266, -1.60582887935434, 218, 22, 'PPL', 'P'),
(105877, 'Rosa', 36.8525009155273, 0.643197478570177, -79.0016708374023, -1.37883927068946, 218, 53, 'PPL', 'P'),
(83372, 'Rosa (historical)', 34.023609161377, 0.593824003277735, -82.085563659668, -1.43266335421661, 218, 48, 'PPL', 'P'),
(189382, 'Rosa (historical)', 36.9905586242676, 0.645607040145453, -107.413063049316, -1.87471160986283, 218, 38, 'PPL', 'P'),
(83373, 'Rosa Lees Crossroads', 34.3591690063477, 0.599680627409955, -80.0061111450195, -1.39637006119712, 218, 48, 'PPL', 'P'),
(97633, 'Rosa Linda Colonia', 26.2320003509521, 0.457834775508423, -98.254997253418, -1.71487320861013, 218, 51, 'PPL', 'P'),
(33817, 'Rosaco', 39.5788917541504, 0.690781975400358, -97.6277770996094, -1.7039261517913, 218, 20, 'PPL', 'P'),
(33818, 'Rosalia', 37.8152809143066, 0.660001159521223, -96.6194381713867, -1.68632731751779, 218, 20, 'PPL', 'P'),
(208605, 'Rosalia', 47.2361106872559, 0.824425657329096, -117.36888885498, -2.04847354992669, 218, 56, 'PPL', 'P'),
(5538, 'Rosalie', 34.6997184753418, 0.605624336909821, -85.7686080932617, -1.49694460608007, 218, 2, 'PPL', 'P'),
(97630, 'Rosalie', 33.476390838623, 0.584273241818438, -95.1780624389648, -1.66117056522868, 218, 51, 'PPL', 'P'),
(142892, 'Rosalie', 42.0563888549805, 0.734022457018457, -96.5122222900391, -1.68445604737784, 218, 35, 'PPL', 'P'),
(17850, 'Rosalind Heights', 28.7744407653809, 0.502208731775973, -81.2658309936523, -1.41835632020849, 218, 12, 'PPL', 'P'),
(105886, 'Rosalind Hills', 37.2586097717285, 0.650285415232395, -79.9952774047852, -1.39618097675973, 218, 53, 'PPL', 'P'),
(97631, 'Rosalito Colonia', 26.2919998168945, 0.458881963738556, -98.036003112793, -1.71105103981365, 218, 51, 'PPL', 'P'),
(24517, 'Rosamond', 33.0013885498047, 0.575982887924049, -85.1572189331055, -1.48627385222434, 218, 13, 'PPL', 'P'),
(28455, 'Rosamond', 39.3797187805176, 0.687305751229478, -89.1602783203125, -1.55614041868397, 218, 18, 'PPL', 'P'),
(184662, 'Rosamond', 34.8641700744629, 0.608494558774654, -118.162498474121, -2.06232465075619, 218, 6, 'PPL', 'P'),
(97632, 'Rosanky', 29.9291706085205, 0.522362569509798, -97.293327331543, -1.69808890215601, 218, 51, 'PPL', 'P'),
(189383, 'Rosario', 35.480281829834, 0.619247737466122, -106.226936340332, -1.85400979344521, 218, 38, 'PPL', 'P'),
(208606, 'Rosario', 48.6488914489746, 0.849083333229922, -122.874717712402, -2.14456839154002, 218, 56, 'PPL', 'P'),
(208607, 'Rosario Beach', 48.4197196960449, 0.845083531588732, -122.663063049316, -2.14087432079197, 218, 56, 'PPL', 'P'),
(42864, 'Rosaryville', 30.422779083252, 0.530977662609609, -90.5194396972656, -1.57986225977774, 218, 22, 'PPL', 'P'),
(51040, 'Rosaryville', 38.7566719055176, 0.676431531866466, -76.8099975585938, -1.34058735584627, 218, 25, 'PPL', 'P'),
(51041, 'Rosaryville Estates', 38.7588882446289, 0.6764702142813, -76.8055572509766, -1.34050985785855, 218, 25, 'PPL', 'P'),
(166637, 'Rosas', 41.4413909912109, 0.723288719402947, -74.809440612793, -1.3056710502684, 218, 45, 'PPL', 'P'),
(57267, 'Rosati', 38.0269393920898, 0.663695296848299, -91.5308303833008, -1.59751435727306, 218, 29, 'PPL', 'P'),
(11673, 'Rosboro', 34.2874984741211, 0.598429740645945, -93.5083312988281, -1.63202825921022, 218, 4, 'PPL', 'P'),
(208608, 'Rosburg', 46.3311080932617, 0.808630382324809, -123.637222290039, -2.15787660698131, 218, 56, 'PPL', 'P'),
(137794, 'Rosby', 47.4099998474121, 0.827460595707351, -94.8063888549805, -1.65468363744547, 218, 28, 'PPL', 'P'),
(111200, 'Rosbys Rock', 39.8413887023926, 0.695363411423622, -80.7122192382813, -1.40869397229952, 218, 58, 'PPL', 'P'),
(24518, 'Roscoe', 33.4947204589844, 0.584593154044384, -84.8222198486328, -1.48042701520913, 218, 13, 'PPL', 'P'),
(33820, 'Roscoe', 39.4808311462402, 0.689070494925819, -99.769172668457, -1.74130055505531, 218, 20, 'PPL', 'P'),
(38000, 'Roscoe', 38.0338897705078, 0.663816603835952, -83.0947189331055, -1.45027643640196, 218, 21, 'PPL', 'P'),
(57268, 'Roscoe', 37.9727783203125, 0.662750007819375, -93.8119430541992, -1.6373272839892, 218, 29, 'PPL', 'P'),
(117600, 'Roscoe', 41.023609161377, 0.715997050917338, -91.2597198486328, -1.59278258580626, 218, 16, 'PPL', 'P'),
(121288, 'Roscoe', 42.413330078125, 0.740252256598425, -89.0091705322266, -1.55350309025647, 218, 18, 'PPL', 'P'),
(137796, 'Roscoe', 45.4338912963867, 0.792970995115143, -94.6394424438477, -1.65176987289681, 218, 28, 'PPL', 'P'),
(152203, 'Roscoe', 41.9330596923828, 0.731869957067401, -74.9138870239258, -1.30749398403456, 218, 40, 'PPL', 'P'),
(157434, 'Roscoe', 40.2772216796875, 0.702970131866188, -81.8794403076172, -1.42906582305808, 218, 41, 'PPL', 'P'),
(166638, 'Roscoe', 40.0794410705566, 0.699518209040254, -79.8658294677734, -1.39392168404896, 218, 45, 'PPL', 'P'),
(171216, 'Roscoe', 45.4486083984375, 0.793227857002281, -99.3383331298828, -1.73378098655942, 218, 49, 'PPL', 'P'),
(192134, 'Roscoe', 32.4458312988281, 0.566286584711179, -100.538330078125, -1.75472488432013, 218, 51, 'PPL', 'P'),
(197429, 'Roscoe', 45.3497200012207, 0.791501928878828, -109.495826721191, -1.91106269347798, 218, 31, 'PPL', 'P'),
(199656, 'Roscoe', 41.1305618286133, 0.717863727104401, -101.58528137207, -1.77299763150749, 218, 35, 'PPL', 'P'),
(61596, 'Roscoe (historical)', 32.4508285522461, 0.566373803236879, -89.0130615234375, -1.55357100086426, 218, 30, 'PPL', 'P'),
(137797, 'Roscoe Center', 44.2611083984375, 0.772502072134849, -92.726936340332, -1.61839034442598, 218, 28, 'PPL', 'P'),
(132900, 'Roscommon', 44.4983291625977, 0.77664235552354, -84.5919418334961, -1.47640790565004, 218, 27, 'PPL', 'P'),
(17851, 'Rose', 30.3491706848145, 0.529692953699754, -84.1336135864258, -1.46840856868376, 218, 12, 'PPL', 'P'),
(24519, 'Rose', 32.9824981689453, 0.575653188581097, -82.6566696166992, -1.44263103354456, 218, 13, 'PPL', 'P'),
(33822, 'Rose', 37.7930603027344, 0.65961333668748, -95.6861114501953, -1.67003769323615, 218, 20, 'PPL', 'P'),
(77132, 'Rose', 36.2194404602051, 0.632148489260629, -95.0294418334961, -1.65857664632694, 218, 42, 'PPL', 'P'),
(117602, 'Rose', 42.5819396972656, 0.743195049602963, -90.6991729736328, -1.58299919722575, 218, 16, 'PPL', 'P'),
(142893, 'Rose', 42.1805610656738, 0.736189670934536, -99.5252838134766, -1.73704389152698, 218, 35, 'PPL', 'P'),
(152204, 'Rose', 43.1536102294922, 0.753172582626944, -76.8788909912109, -1.34178977307844, 218, 40, 'PPL', 'P'),
(195557, 'Rose', 42.6036109924316, 0.743573285056781, -111.53694152832, -1.94668686727359, 218, 17, 'PPL', 'P'),
(184663, 'Rose (historical)', 38.1205596923828, 0.665329279335117, -122.48999786377, -2.1378537634836, 218, 6, 'PPL', 'P'),
(74134, 'Rose Addition', 39.9213905334473, 0.69675970678315, -81.4338912963867, -1.4212895258331, 218, 41, 'PPL', 'P'),
(68368, 'Rose Bay', 35.4605598449707, 0.618903523895229, -76.3838882446289, -1.33315034534417, 218, 33, 'PPL', 'P'),
(42865, 'Rose Bluff', 30.2222194671631, 0.527477236962322, -93.3083267211914, -1.6285375208114, 218, 22, 'PPL', 'P'),
(11676, 'Rose Bud', 35.3313903808594, 0.616649091453449, -92.0811080932617, -1.60711851511221, 218, 4, 'PPL', 'P'),
(11675, 'Rose City', 34.7580604553223, 0.606642596552613, -92.2074966430664, -1.60932441144313, 218, 4, 'PPL', 'P'),
(97638, 'Rose City', 30.1025009155273, 0.52538775406056, -94.0516662597656, -1.64151124321977, 218, 51, 'PPL', 'P'),
(132903, 'Rose City', 44.4213905334473, 0.775299523122895, -84.1166687011719, -1.46811282464471, 218, 27, 'PPL', 'P'),
(137800, 'Rose City', 46.0774993896484, 0.804204075435043, -95.166389465332, -1.66096683340529, 218, 28, 'PPL', 'P'),
(132905, 'Rose Corners', 42.7394409179688, 0.745943964480142, -83.6666717529297, -1.46025889627396, 218, 27, 'PPL', 'P'),
(83374, 'Rose Creek', 34.1402816772461, 0.595860322826236, -80.9005584716797, -1.411981112033, 218, 48, 'PPL', 'P'),
(90482, 'Rose Creek', 35.2052803039551, 0.614448055391526, -88.6969375610352, -1.54805359687589, 218, 50, 'PPL', 'P'),
(137801, 'Rose Creek', 43.6036109924316, 0.761026577576724, -92.831672668457, -1.62021833819821, 218, 28, 'PPL', 'P'),
(200171, 'Rose Creek', 40.8899993896484, 0.713665120487837, -117.894172668457, -2.05764148197928, 218, 39, 'PPL', 'P'),
(179021, 'Rose Creek Lodge', 33.834171295166, 0.590517688784401, -110.977500915527, -1.93692278661097, 218, 5, 'PPL', 'P'),
(197430, 'Rose Crossing', 48.2550010681152, 0.842208649191991, -114.27555847168, -1.99448474988611, 218, 31, 'PPL', 'P'),
(38001, 'Rose Crossroads', 36.975830078125, 0.645349978521233, -85.1205596923828, -1.48563402777245, 218, 21, 'PPL', 'P'),
(74131, 'Rose Farm', 39.7358283996582, 0.693521036581505, -82.0780563354492, -1.43253232669098, 218, 41, 'PPL', 'P'),
(24520, 'Rose Garden', 33.832218170166, 0.590483600322448, -83.9658279418945, -1.46548015674911, 218, 13, 'PPL', 'P'),
(166640, 'Rose Garden', 40.1533317565918, 0.700807844798125, -77.0116729736328, -1.34410725585902, 218, 45, 'PPL', 'P'),
(90479, 'Rose Garden Estates', 36.1588897705078, 0.631091680361058, -85.5772171020508, -1.49360420312479, 218, 50, 'PPL', 'P'),
(74132, 'Rose Garden Mobile Home Park', 39.9658317565918, 0.697535352450636, -83.8444366455078, -1.4633614789439, 218, 41, 'PPL', 'P'),
(179012, 'Rose Garden Place', 33.6680603027344, 0.587618505042714, -112.115280151367, -1.9567807804372, 218, 5, 'PPL', 'P'),
(179013, 'Rose Garden Place III', 33.6699981689453, 0.587652327188558, -112.110282897949, -1.9566935619115, 218, 5, 'PPL', 'P'),
(83381, 'Rose Gardens', 33.9680595397949, 0.592854479482891, -81.1416702270508, -1.41618930602949, 218, 48, 'PPL', 'P'),
(166641, 'Rose Gardens', 41.4099998474121, 0.722740840587691, -79.6722183227539, -1.39054253209981, 218, 45, 'PPL', 'P'),
(166642, 'Rose Glen', 40.4036102294922, 0.7051760281971, -77.084716796875, -1.34538211107285, 218, 45, 'PPL', 'P'),
(152205, 'Rose Grove', 40.9575004577637, 0.714843236375061, -72.3927764892578, -1.26349230439789, 218, 40, 'PPL', 'P'),
(51042, 'Rose Haven', 38.7255592346191, 0.675888513320199, -76.5391693115234, -1.33586051122749, 218, 25, 'PPL', 'P'),
(5541, 'Rose Hill', 33.5488891601563, 0.585538576231362, -86.6641693115234, -1.51257509799191, 218, 2, 'PPL', 'P'),
(11679, 'Rose Hill', 33.8863906860352, 0.591429089088454, -91.6994400024414, -1.6004571502776, 218, 4, 'PPL', 'P'),
(24525, 'Rose Hill', 33.0322189331055, 0.576520979622299, -84.3333282470703, -1.47189424707651, 218, 13, 'PPL', 'P'),
(28457, 'Rose Hill', 39.1036109924316, 0.68248676123698, -88.147216796875, -1.53845915957472, 218, 18, 'PPL', 'P'),
(33824, 'Rose Hill', 37.5583305358887, 0.655516529403584, -97.1347198486328, -1.69532067936093, 218, 20, 'PPL', 'P'),
(38002, 'Rose Hill', 38.3358306884766, 0.669086467001001, -83.2344436645508, -1.45271509301215, 218, 21, 'PPL', 'P'),
(42866, 'Rose Hill', 29.9169406890869, 0.522149117148428, -92.128059387207, -1.60793796977963, 218, 22, 'PPL', 'P'),
(51043, 'Rose Hill', 38.5561103820801, 0.672931072929666, -76.5691680908203, -1.3363840886978, 218, 25, 'PPL', 'P'),
(57270, 'Rose Hill', 38.6327781677246, 0.674269178219377, -94.0688934326172, -1.64181191410684, 218, 29, 'PPL', 'P'),
(61598, 'Rose Hill', 32.3588905334473, 0.564769182101079, -90.8069381713867, -1.58488005474562, 218, 30, 'PPL', 'P'),
(68370, 'Rose Hill', 36.5186080932617, 0.637369949472865, -78.3080596923828, -1.36673347248034, 218, 33, 'PPL', 'P'),
(83378, 'Rose Hill', 34.1366691589355, 0.595797272487429, -80.335563659668, -1.40212009230671, 218, 48, 'PPL', 'P'),
(90480, 'Rose Hill', 36.3066711425781, 0.6336709518768, -83.7602767944336, -1.46189261244467, 218, 50, 'PPL', 'P'),
(97636, 'Rose Hill', 30.5811100006104, 0.533741058425216, -95.0936126708984, -1.65969663872338, 218, 51, 'PPL', 'P'),
(105881, 'Rose Hill', 38.7163887023926, 0.675728457338685, -78.1255569458008, -1.36354819865855, 218, 53, 'PPL', 'P'),
(111202, 'Rose Hill', 39.4105606079102, 0.68784404266481, -77.8280563354492, -1.35835583348122, 218, 58, 'PPL', 'P'),
(117604, 'Rose Hill', 41.3219413757324, 0.721203930322606, -92.4619369506836, -1.61376523256083, 218, 16, 'PPL', 'P'),
(152207, 'Rose Hill', 42.8494415283203, 0.747863837309981, -76.9100036621094, -1.34233279162471, 218, 40, 'PPL', 'P'),
(157435, 'Rose Hill', 40.3086090087891, 0.703517944102417, -84.7255630493164, -1.47874003581662, 218, 41, 'PPL', 'P'),
(208609, 'Rose Hill', 47.6761093139648, 0.832105082069421, -122.167778015137, -2.13222996620968, 218, 56, 'PPL', 'P'),
(42867, 'Rose Hill (historical)', 30.562219619751, 0.533411359082264, -91.3119430541992, -1.59369405268934, 218, 22, 'PPL', 'P'),
(90481, 'Rose Hill (historical)', 36.6074981689453, 0.638921373965891, -87.6208267211914, -1.52927191960422, 218, 50, 'PPL', 'P'),
(197431, 'Rose Hill (historical)', 48.3555603027344, 0.843963738929381, -106.566108703613, -1.85992946791624, 218, 31, 'PPL', 'P'),
(97637, 'Rose Hill Acres', 30.1980590820313, 0.527055558693222, -94.1947174072266, -1.64400795674172, 218, 51, 'PPL', 'P'),
(51044, 'Rose Hill Estates', 39.0108299255371, 0.680867426136157, -77.1575012207031, -1.34665243891281, 218, 25, 'PPL', 'P'),
(105883, 'Rose Hill Estates', 38.4361114501953, 0.670836696469401, -78.045280456543, -1.36214710960906, 218, 53, 'PPL', 'P'),
(105884, 'Rose Hill Farms', 38.7775001525879, 0.676795053355262, -77.1133270263672, -1.34588145377724, 218, 53, 'PPL', 'P'),
(14523, 'Rose Hill Gardens', 39.7069396972656, 0.693016833608126, -75.5538864135742, -1.31866408059468, 218, 10, 'PPL', 'P'),
(24526, 'Rose Hill Heights', 32.4961090087891, 0.56716409629036, -84.9738922119141, -1.48307419733267, 218, 13, 'PPL', 'P'),
(132906, 'Rose Island', 43.7827796936035, 0.764153661328695, -83.4313888549805, -1.45615243503111, 218, 27, 'PPL', 'P'),
(28458, 'Rose Lake', 38.6399993896484, 0.674395212317965, -90.1072235107422, -1.5726677300929, 218, 18, 'PPL', 'P'),
(195558, 'Rose Lake', 47.538890838623, 0.829710167880141, -116.470832824707, -2.03279951533103, 218, 17, 'PPL', 'P'),
(179014, 'Rose Lane Trailer Park', 33.4486083984375, 0.583788346762962, -112.125, -1.95695042379864, 218, 5, 'PPL', 'P'),
(74136, 'Rose Lawn', 39.5294418334961, 0.689918911470091, -84.3755569458008, -1.47263127690819, 218, 41, 'PPL', 'P'),
(176170, 'Rose Lawn', 44.601390838623, 0.778441121102807, -88.3249969482422, -1.54156200856077, 218, 57, 'PPL', 'P'),
(201502, 'Rose Lodge', 45.0105590820313, 0.785582454144882, -123.879173278809, -2.16209944836379, 218, 43, 'PPL', 'P'),
(68372, 'Rose Manor', 35.526668548584, 0.620057338437506, -78.3691711425781, -1.36780006849691, 218, 33, 'PPL', 'P'),
(51045, 'Rose Mary Estates', 39.2816696166992, 0.68559447049202, -76.9588928222656, -1.34318606843797, 218, 25, 'PPL', 'P'),
(5544, 'Rose Park', 34.860279083252, 0.608426648166857, -87.6719436645508, -1.53016407856939, 218, 2, 'PPL', 'P'),
(205606, 'Rose Park', 40.7902793884277, 0.711924678136443, -111.923057556152, -1.95342586325398, 218, 52, 'PPL', 'P'),
(11681, 'Rose Place', 35.2386093139648, 0.615029756352627, -90.595832824707, -1.58119557137749, 218, 4, 'PPL', 'P'),
(184665, 'Rose Place', 39.165828704834, 0.683572665171459, -122.816673278809, -2.14355532506135, 218, 6, 'PPL', 'P'),
(166643, 'Rose Point', 40.9700012207031, 0.715061415847365, -80.1866683959961, -1.39952137971501, 218, 45, 'PPL', 'P'),
(208611, 'Rose Point', 47.4186096191406, 0.827610864571858, -122.867218017578, -2.14443749717244, 218, 56, 'PPL', 'P'),
(208612, 'Rose Springs', 46.2752799987793, 0.807655998260976, -117.553329467773, -2.05169264589432, 218, 56, 'PPL', 'P'),
(38003, 'Rose Terrace', 37.8950004577637, 0.661392528032734, -85.9772186279297, -1.50058554676437, 218, 21, 'PPL', 'P'),
(137805, 'Rose Terrace Mobile Home Park', 45.6722183227539, 0.797130586421738, -94.8222198486328, -1.65495994040856, 218, 28, 'PPL', 'P'),
(179015, 'Rose Terrace Trailer Park', 33.514720916748, 0.584942227884266, -112.154998779297, -1.95747400126895, 218, 5, 'PPL', 'P'),
(79054, 'Rose Tree', 39.9341697692871, 0.696982746524444, -75.3905563354492, -1.31581343296386, 218, 45, 'PPL', 'P'),
(166644, 'Rose Valley', 40.1652793884277, 0.701016370311478, -75.2072219848633, -1.31261364491413, 218, 45, 'PPL', 'P'),
(190681, 'Rose Valley', 37.938060760498, 0.662144072092355, -114.251670837402, -1.99406783201746, 218, 39, 'PPL', 'P'),
(208613, 'Rose Valley', 46.0977783203125, 0.804558009543914, -122.82527923584, -2.14370552734683, 218, 56, 'PPL', 'P'),
(14524, 'Rose Valley Estates', 39.4047203063965, 0.687742110174087, -75.716667175293, -1.32150514084558, 218, 10, 'PPL', 'P'),
(179016, 'Rose Well Camp', 35.7419395446777, 0.623814526103389, -112.871940612793, -1.96998699680874, 218, 5, 'PPL', 'P'),
(61599, 'Roseacres', 34.3955612182617, 0.600315791329939, -90.4499969482422, -1.57865025516565, 218, 30, 'PPL', 'P'),
(105887, 'Roseann', 37.3558311462402, 0.651982248320939, -82.0511093139648, -1.43206201244247, 218, 53, 'PPL', 'P'),
(166646, 'Roseann', 40.7102813720703, 0.710528449355942, -77.5899963378906, -1.35420090270653, 218, 45, 'PPL', 'P'),
(137806, 'Roseau', 48.8461112976074, 0.852525468938849, -95.7624969482422, -1.67137087167785, 218, 28, 'PPL', 'P'),
(42868, 'Rosebank', 30.923059463501, 0.539709202428083, -91.4413909912109, -1.59595334540011, 218, 22, 'PPL', 'P'),
(152210, 'Rosebank', 40.6138916015625, 0.708846130495339, -74.0666732788086, -1.29270731471411, 218, 40, 'PPL', 'P'),
(68373, 'Rosebank Park', 35.5366706848145, 0.62023190864696, -82.541389465332, -1.44061901534101, 218, 33, 'PPL', 'P'),
(139427, 'Roseberry', 40.4377784729004, 0.705772376544196, -95.0405578613281, -1.65877065761236, 218, 29, 'PPL', 'P'),
(193146, 'Roseberry', 44.7308311462402, 0.780700280655521, -116.048889160156, -2.02543520912668, 218, 17, 'PPL', 'P'),
(61600, 'Rosebloom', 33.8761100769043, 0.591249658610009, -89.9519424438477, -1.56995756420958, 218, 30, 'PPL', 'P'),
(152211, 'Roseboom', 42.7416687011719, 0.745982846632058, -74.7769393920898, -1.30510379695621, 218, 40, 'PPL', 'P'),
(5561, 'Roseboro', 34.9841690063477, 0.61058893523492, -86.4024963378906, -1.50800804303853, 218, 2, 'PPL', 'P'),
(68374, 'Roseboro', 34.9527816772461, 0.61004112299869, -78.5088882446289, -1.37023859194905, 218, 33, 'PPL', 'P'),
(166647, 'Roseboro', 40.8624992370605, 0.713185152280377, -78.9719390869141, -1.37832035375105, 218, 45, 'PPL', 'P'),
(68375, 'Roseborough', 36.0347213745117, 0.628924533024006, -81.8091735839844, -1.4278394373761, 218, 33, 'PPL', 'P'),
(5545, 'Rosebud', 31.9411106109619, 0.557477546904983, -87.1369400024414, -1.52082650315536, 218, 2, 'PPL', 'P'),
(24527, 'Rosebud', 33.7986106872559, 0.589897039092358, -83.966667175293, -1.46549480413511, 218, 13, 'PPL', 'P'),
(28460, 'Rosebud', 37.2783317565918, 0.650629628803288, -88.5838928222656, -1.54608059398231, 218, 18, 'PPL', 'P'),
(57272, 'Rosebud', 38.3872184753418, 0.669983353077112, -91.4008331298828, -1.59524547718237, 218, 29, 'PPL', 'P'),
(61601, 'Rosebud', 32.649169921875, 0.569835513179819, -89.3919372558594, -1.56018362985093, 218, 30, 'PPL', 'P'),
(68378, 'Rosebud', 35.7666702270508, 0.624246157937064, -77.857780456543, -1.35887461726157, 218, 33, 'PPL', 'P'),
(97639, 'Rosebud', 31.0727806091309, 0.542322329379183, -96.9783325195313, -1.69259120555971, 218, 51, 'PPL', 'P'),
(111203, 'Rosebud', 39.3675003051758, 0.68709249860519, -80.4124984741211, -1.40346285812833, 218, 58, 'PPL', 'P'),
(123585, 'Rosebud', 41.0269393920898, 0.716055174408129, -87.1999969482422, -1.52192705447583, 218, 19, 'PPL', 'P'),
(166648, 'Rosebud', 40.7541694641113, 0.711294441064476, -78.5416717529297, -1.37081077210925, 218, 45, 'PPL', 'P'),
(179017, 'Rosebud', 34.000560760498, 0.593421732795078, -109.266670227051, -1.9070631581529, 218, 5, 'PPL', 'P'),
(189384, 'Rosebud', 35.8411102294922, 0.625545381074859, -103.444999694824, -1.80545583939921, 218, 38, 'PPL', 'P'),
(197432, 'Rosebud', 46.2744407653809, 0.807641350874981, -106.44416809082, -1.8578012027311, 218, 31, 'PPL', 'P'),
(202574, 'Rosebud', 43.232780456543, 0.754554363758532, -100.853057861328, -1.76021792038453, 218, 49, 'PPL', 'P'),
(200173, 'Rosebud (historical)', 40.8002815246582, 0.712099248345898, -118.660827636719, -2.07102213540222, 218, 39, 'PPL', 'P'),
(189385, 'Rosebud Farms', 35.8127784729004, 0.625050898639459, -103.424171447754, -1.80509231791042, 218, 38, 'PPL', 'P'),
(38004, 'Roseburg', 37.3300018310547, 0.651531441727416, -86.0794372558594, -1.50236959837862, 218, 21, 'PPL', 'P'),
(123586, 'Roseburg', 40.5219383239746, 0.70724124304343, -85.7294387817383, -1.49626097262825, 218, 19, 'PPL', 'P'),
(132910, 'Roseburg', 43.189998626709, 0.753807679967901, -82.7438888549805, -1.44415329642365, 218, 27, 'PPL', 'P'),
(166650, 'Roseburg', 40.4411087036133, 0.705830500034987, -77.3327789306641, -1.34971161205699, 218, 45, 'PPL', 'P'),
(201503, 'Roseburg', 43.2166709899902, 0.754273200526447, -123.340560913086, -2.15269888918997, 218, 43, 'PPL', 'P'),
(132911, 'Rosebush', 43.6991691589355, 0.762694382209387, -84.7677764892578, -1.47947679933219, 218, 27, 'PPL', 'P'),
(121290, 'Rosecrans', 42.4652786254883, 0.741158929791543, -87.9524993896484, -1.53506069970767, 218, 18, 'PPL', 'P'),
(166651, 'Rosecrans', 41.0558280944824, 0.716559377381508, -77.3116683959961, -1.34934316372018, 218, 45, 'PPL', 'P'),
(176172, 'Rosecrans', 44.276668548584, 0.772773647987009, -87.8269424438477, -1.5328693176047, 218, 57, 'PPL', 'P'),
(152213, 'Rosecrans Park', 42.5302810668945, 0.742293436415916, -73.6074981689453, -1.28469319720379, 218, 40, 'PPL', 'P'),
(105888, 'Rosecrest', 37.2144393920898, 0.649514496675845, -80.0255584716797, -1.39670948107805, 218, 53, 'PPL', 'P'),
(51046, 'Rosecroft', 38.1622200012207, 0.666056388891736, -76.4358291625977, -1.33405688537923, 218, 25, 'PPL', 'P'),
(51047, 'Rosecroft Park', 38.795280456543, 0.677105378201284, -76.9722213745117, -1.34341869555918, 218, 25, 'PPL', 'P'),
(5546, 'Rosedale', 33.4836082458496, 0.584399209337999, -86.7941665649414, -1.5148439780826, 218, 2, 'PPL', 'P'),
(11682, 'Rosedale', 34.7208290100098, 0.605992785246634, -92.3727798461914, -1.6122091475359, 218, 4, 'PPL', 'P'),
(13201, 'Rosedale', 38.8972206115723, 0.678884569546538, -76.9791717529297, -1.34354000254684, 218, 9, 'PPL', 'P'),
(17852, 'Rosedale', 30.6552791595459, 0.535035554452076, -84.8086090087891, -1.48018946123989, 218, 12, 'PPL', 'P'),
(24528, 'Rosedale', 34.4383316040039, 0.601062275383488, -85.1080627441406, -1.48541591487917, 218, 13, 'PPL', 'P'),
(28462, 'Rosedale', 38.8827781677246, 0.678632501349362, -90.0824966430664, -1.57223616483825, 218, 18, 'PPL', 'P'),
(31009, 'Rosedale', 39.6227798461914, 0.691547967108892, -87.283332824707, -1.52338153990518, 218, 19, 'PPL', 'P'),
(42870, 'Rosedale', 30.4411106109619, 0.531297608125068, -91.4519424438477, -1.59613750298949, 218, 22, 'PPL', 'P'),
(51048, 'Rosedale', 39.3199996948242, 0.686263456557848, -76.5158309936523, -1.33545318073876, 218, 25, 'PPL', 'P'),
(77135, 'Rosedale', 34.9183311462402, 0.609439847803578, -97.1836090087891, -1.69617395617419, 218, 42, 'PPL', 'P'),
(83380, 'Rosedale', 34.8852806091309, 0.608863007111467, -82.3241729736328, -1.43682787237122, 218, 48, 'PPL', 'P'),
(90484, 'Rosedale', 36.1719398498535, 0.631319447213287, -84.3488922119141, -1.4721658895077, 218, 50, 'PPL', 'P'),
(97640, 'Rosedale', 30.1347198486328, 0.52595008052473, -94.164436340332, -1.64347945242339, 218, 51, 'PPL', 'P'),
(105889, 'Rosedale', 36.959171295166, 0.645059227909224, -81.9313888549805, -1.4299724962512, 218, 53, 'PPL', 'P'),
(111206, 'Rosedale', 39.6866683959961, 0.692663032657309, -79.9652786254883, -1.39565739928942, 218, 58, 'PPL', 'P'),
(112441, 'Rosedale', 33.853328704834, 0.590852048659261, -91.0277786254883, -1.58873444779129, 218, 30, 'PPL', 'P'),
(132912, 'Rosedale', 46.3761100769043, 0.809415815109301, -84.3219375610352, -1.47169544210114, 218, 27, 'PPL', 'P'),
(142895, 'Rosedale', 40.7130584716797, 0.710576918887781, -98.4730606079102, -1.71867913212396, 218, 35, 'PPL', 'P'),
(146219, 'Rosedale', 40.3380584716797, 0.704031934192802, -74.7222213745117, -1.30414878738931, 218, 37, 'PPL', 'P'),
(152216, 'Rosedale', 40.9933280944824, 0.715468546599011, -73.7433319091797, -1.28706394320618, 218, 40, 'PPL', 'P'),
(157438, 'Rosedale', 40.0780601501465, 0.699494107432389, -83.4550018310547, -1.4565645592098, 218, 41, 'PPL', 'P'),
(166653, 'Rosedale', 40.4688911437988, 0.706315395090464, -75.3905563354492, -1.31581343296386, 218, 45, 'PPL', 'P'),
(184666, 'Rosedale', 35.3836097717285, 0.617560491757502, -119.144439697266, -2.07946275816112, 218, 6, 'PPL', 'P'),
(194405, 'Rosedale', 40.3852806091309, 0.704856115971155, -104.698059082031, -1.827325851429, 218, 7, 'PPL', 'P'),
(201504, 'Rosedale', 44.8547210693359, 0.782862567723584, -123.060279846191, -2.14780706174166, 218, 43, 'PPL', 'P'),
(205609, 'Rosedale', 40.9422187805176, 0.714576520791889, -111.879440307617, -1.95266459865638, 218, 52, 'PPL', 'P'),
(208614, 'Rosedale', 47.3316688537598, 0.826093461961758, -122.651107788086, -2.14066566212056, 218, 56, 'PPL', 'P'),
(11684, 'Rosedale (historical)', 33.9769401550293, 0.593009475458334, -94.0416717529297, -1.64133680616837, 218, 4, 'PPL', 'P'),
(142896, 'Rosedale (historical)', 42.8866691589355, 0.748513582036933, -98.5833282470703, -1.72060366548571, 218, 35, 'PPL', 'P'),
(189386, 'Rosedale (historical)', 33.8069381713867, 0.590042381108849, -107.404167175293, -1.87455634757128, 218, 38, 'PPL', 'P'),
(97641, 'Rosedale Acres', 30.1502799987793, 0.526221656376891, -94.186393737793, -1.64386268130426, 218, 51, 'PPL', 'P'),
(179018, 'Rosedale Heights', 34.9091682434082, 0.609279924980118, -110.152778625488, -1.9225286672352, 218, 5, 'PPL', 'P'),
(97642, 'Rosedale Heights Colonia', 26.1560001373291, 0.456508321548482, -98.0169982910156, -1.71071934309988, 218, 51, 'PPL', 'P'),
(31010, 'Rosedale Hills', 39.6936111450195, 0.692784206486907, -86.1313934326172, -1.50327640472979, 218, 19, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(51051, 'Rosedale Park', 39.0261116027832, 0.681134141719328, -76.8969421386719, -1.34210482503539, 218, 25, 'PPL', 'P'),
(51052, 'Rosedale Terrace', 39.3141708374023, 0.686161723804207, -76.5108337402344, -1.33536596221306, 218, 25, 'PPL', 'P'),
(146220, 'Rosedale Village', 40.7680587768555, 0.7115368553027, -74.3958282470703, -1.29845215265958, 218, 37, 'PPL', 'P'),
(42871, 'Rosefield', 31.8908290863037, 0.556599968746775, -91.9986114501953, -1.60567867706886, 218, 22, 'PPL', 'P'),
(38005, 'Rosefork', 37.7008285522461, 0.658003588966581, -83.3344421386719, -1.45446039563253, 218, 21, 'PPL', 'P'),
(166654, 'Rosegarden', 40.1477813720703, 0.700710972313474, -77.0113906860352, -1.34410232901101, 218, 45, 'PPL', 'P'),
(14525, 'Rosegate', 39.7097206115723, 0.693065369718992, -75.5472183227539, -1.31854770045504, 218, 10, 'PPL', 'P'),
(24530, 'Rosegate Manor', 33.5766716003418, 0.586023471286838, -84.6102828979492, -1.47672801761306, 218, 13, 'PPL', 'P'),
(166655, 'Roseglen', 40.0472183227539, 0.698955815997057, -75.2563934326172, -1.31347184857541, 218, 45, 'PPL', 'P'),
(198828, 'Roseglen', 47.7513885498047, 0.833418952593212, -101.835830688477, -1.7773705420174, 218, 34, 'PPL', 'P'),
(5550, 'Rosehill', 33.9811096191406, 0.59308224633512, -87.3869400024414, -1.52518982628534, 218, 2, 'PPL', 'P'),
(77136, 'Rosehill', 35.5086097717285, 0.619742153322495, -99.7169418334961, -1.74038895501418, 218, 42, 'PPL', 'P'),
(205611, 'Rosehill', 41.2872200012207, 0.720597928016559, -112.079170227051, -1.95615054336524, 218, 52, 'PPL', 'P'),
(208615, 'Rosehilla', 47.3458290100098, 0.826340603310918, -122.46639251709, -2.13744177246296, 218, 56, 'PPL', 'P'),
(83383, 'Roseida', 32.4530601501465, 0.566412751967821, -80.7375030517578, -1.40913525809214, 218, 48, 'PPL', 'P'),
(11685, 'Roseland', 35.8463897705078, 0.625637526448576, -90.1011123657227, -1.57256107049124, 218, 4, 'PPL', 'P'),
(17853, 'Roseland', 27.8355598449707, 0.485822168430661, -80.4933319091797, -1.4048736677158, 218, 12, 'PPL', 'P'),
(24531, 'Roseland', 33.7158317565918, 0.58845227420099, -84.3788909912109, -1.47268946697801, 218, 13, 'PPL', 'P'),
(33826, 'Roseland', 37.2811088562012, 0.650678098335128, -94.8502807617188, -1.65544969573303, 218, 20, 'PPL', 'P'),
(42872, 'Roseland', 30.764720916748, 0.536945673454422, -90.5116729736328, -1.57972670487826, 218, 22, 'PPL', 'P'),
(57273, 'Roseland', 38.3933296203613, 0.67009001267877, -93.5422210693359, -1.63261974728832, 218, 29, 'PPL', 'P'),
(68382, 'Roseland', 35.1349983215332, 0.613221403393436, -79.5094375610352, -1.38770147184891, 218, 33, 'PPL', 'P'),
(83384, 'Roseland', 33.5433311462402, 0.585441570588656, -81.6747207641602, -1.42549279298157, 218, 48, 'PPL', 'P'),
(105891, 'Roseland', 37.747501373291, 0.658818183365009, -78.9761123657227, -1.37839319120687, 218, 53, 'PPL', 'P'),
(123587, 'Roseland', 41.7161102294922, 0.728083474629526, -86.2525024414063, -1.50539015568699, 218, 19, 'PPL', 'P'),
(137811, 'Roseland', 44.9425010681152, 0.784394617719679, -95.1052780151367, -1.65990023738871, 218, 28, 'PPL', 'P'),
(142897, 'Roseland', 40.4702796936035, 0.706339629856383, -98.5588912963867, -1.72017716023713, 218, 35, 'PPL', 'P'),
(146221, 'Roseland', 40.8205604553223, 0.712453182454769, -74.2941665649414, -1.29667782158331, 218, 37, 'PPL', 'P'),
(152217, 'Roseland', 43.1813888549805, 0.753657411103393, -77.3866729736328, -1.350652240554, 218, 40, 'PPL', 'P'),
(157439, 'Roseland', 40.7886085510254, 0.711895516522507, -82.5427780151367, -1.44064325010693, 218, 41, 'PPL', 'P'),
(184667, 'Roseland', 38.4222183227539, 0.670594215652149, -122.726936340332, -2.14198912002427, 218, 6, 'PPL', 'P'),
(17854, 'Roseland Park', 28.7961101531982, 0.502586933940278, -81.2466735839844, -1.41802196033363, 218, 12, 'PPL', 'P'),
(114006, 'Roseland Park', 41.9502792358398, 0.732170494796416, -71.956672668457, -1.25588085684439, 218, 8, 'PPL', 'P'),
(152218, 'Roseland Park', 42.872501373291, 0.748266307529719, -77.2513885498047, -1.34829108193154, 218, 40, 'PPL', 'P'),
(823, 'Roselawn', 39.1949996948242, 0.684081794992855, -84.4625015258789, -1.47414874609732, 218, 41, 'PPL', 'P'),
(123588, 'Roselawn', 41.1416702270508, 0.718057605231759, -87.3147201538086, -1.52392935214141, 218, 19, 'PPL', 'P'),
(61603, 'Rosella', 31.6072196960449, 0.551650051097185, -90.1283264160156, -1.57303604527165, 218, 30, 'PPL', 'P'),
(5552, 'Roselle', 33.1855583190918, 0.579197256780747, -86.0497207641602, -1.50185094775633, 218, 2, 'PPL', 'P'),
(57274, 'Roselle', 37.5994415283203, 0.656234051580278, -90.5258331298828, -1.57997384622742, 218, 29, 'PPL', 'P'),
(117605, 'Roselle', 42.0002784729004, 0.733043146106608, -94.915283203125, -1.6565842023574, 218, 16, 'PPL', 'P'),
(121293, 'Roselle', 41.9847183227539, 0.732771570254447, -88.079719543457, -1.53728111026652, 218, 18, 'PPL', 'P'),
(146223, 'Roselle', 40.6641693115234, 0.70972364207452, -74.2636108398438, -1.29614452357502, 218, 37, 'PPL', 'P'),
(146224, 'Roselle Park', 40.6644401550293, 0.709728369185455, -74.2647171020508, -1.29616383149293, 218, 37, 'PPL', 'P'),
(14526, 'Roselle Terrace', 39.7388916015625, 0.693574499540388, -75.6138916015625, -1.31971136869335, 218, 10, 'PPL', 'P'),
(157440, 'Roselms', 41.0194396972656, 0.715924280040551, -84.4191665649414, -1.47339240834774, 218, 41, 'PPL', 'P'),
(83385, 'Roseman Heights', 34.7769393920898, 0.606972096158483, -82.3969421386719, -1.43809793389508, 218, 48, 'PPL', 'P'),
(90486, 'Rosemark', 35.3624992370605, 0.617192043420689, -89.772216796875, -1.56682075991963, 218, 50, 'PPL', 'P'),
(5553, 'Rosemary', 32.6477813720703, 0.569811278413899, -87.5749969482422, -1.52847203917081, 218, 2, 'PPL', 'P'),
(61604, 'Rosemary', 32.0880584716797, 0.56004227090327, -90.2597198486328, -1.57532929328632, 218, 30, 'PPL', 'P'),
(68383, 'Rosemary', 36.4511108398438, 0.636191900164669, -77.6797180175781, -1.3557668414275, 218, 33, 'PPL', 'P'),
(128689, 'Rosemary', 43.1577796936035, 0.753245353503731, -70.7897186279297, -1.23551366661774, 218, 26, 'PPL', 'P'),
(184668, 'Rosemary', 34.9455604553223, 0.609915088900102, -120.393608093262, -2.10126485958311, 218, 6, 'PPL', 'P'),
(83386, 'Rosemary (historical)', 33.353328704834, 0.582125402399289, -81.2480621337891, -1.41804619509955, 218, 48, 'PPL', 'P'),
(17855, 'Rosemary Beach', 30.2833309173584, 0.528543832978899, -86.0305633544922, -1.50151658788147, 218, 12, 'PPL', 'P'),
(132913, 'Rosemary Beach', 41.9819412231445, 0.732723100722607, -86.563606262207, -1.51081994167549, 218, 27, 'PPL', 'P'),
(51053, 'Rosemary Hills', 38.997501373291, 0.680634799014939, -77.0438919067383, -1.3446695823232, 218, 25, 'PPL', 'P'),
(68384, 'Rosemead', 36.1800003051758, 0.631460128697871, -76.8663864135742, -1.34157152702711, 218, 33, 'PPL', 'P'),
(184669, 'Rosemead', 34.0805587768555, 0.594817961575579, -118.071937561035, -2.06074406464923, 218, 6, 'PPL', 'P'),
(5557, 'Rosemont', 33.4577789306641, 0.583948402744475, -86.8850021362305, -1.51642935787953, 218, 2, 'PPL', 'P'),
(17856, 'Rosemont', 28.600830078125, 0.499178653666708, -81.434440612793, -1.42129911321303, 218, 12, 'PPL', 'P'),
(24533, 'Rosemont', 33.410831451416, 0.583129014656085, -84.5736083984375, -1.47608792684506, 218, 13, 'PPL', 'P'),
(51057, 'Rosemont', 39.1277809143066, 0.682908605953648, -77.1888885498047, -1.34720025114904, 218, 25, 'PPL', 'P'),
(68385, 'Rosemont', 36.047779083252, 0.62915243303429, -80.2427825927734, -1.40050075720589, 218, 33, 'PPL', 'P'),
(83388, 'Rosemont', 33.3933296203613, 0.582823550079053, -79.2838897705078, -1.38376492028361, 218, 48, 'PPL', 'P'),
(105897, 'Rosemont', 36.839168548584, 0.642964784869931, -76.1033325195313, -1.32825372420589, 218, 53, 'PPL', 'P'),
(111208, 'Rosemont', 39.2686080932617, 0.685366503902709, -80.1630630493164, -1.39910938869438, 218, 58, 'PPL', 'P'),
(121294, 'Rosemont', 41.9952812194824, 0.732955927580908, -87.8844375610352, -1.53387279670344, 218, 18, 'PPL', 'P'),
(125989, 'Rosemont', 42.8036117553711, 0.747063956876575, -71.1116714477539, -1.24113280335975, 218, 23, 'PPL', 'P'),
(128690, 'Rosemont', 43.6708297729492, 0.762199766615932, -70.3013916015625, -1.22699075218116, 218, 26, 'PPL', 'P'),
(142899, 'Rosemont', 40.2869415283203, 0.703139775227626, -98.3638916015625, -1.71677377352206, 218, 35, 'PPL', 'P'),
(146228, 'Rosemont', 40.2391700744629, 0.702306006069349, -74.6944427490234, -1.30366395891286, 218, 37, 'PPL', 'P'),
(157441, 'Rosemont', 41.0633316040039, 0.716690338328112, -80.8866729736328, -1.41173876437381, 218, 41, 'PPL', 'P'),
(166656, 'Rosemont', 40.0255584716797, 0.69857778028032, -75.3241729736328, -1.31465482473162, 218, 45, 'PPL', 'P'),
(184671, 'Rosemont', 33.0008316040039, 0.57597316738607, -116.924171447754, -2.04071176692965, 218, 6, 'PPL', 'P'),
(187281, 'Rosemont', 38.7422218322754, 0.676179330511236, -104.956390380859, -1.8318345831545, 218, 7, 'PPL', 'P'),
(201505, 'Rosemont', 45.3694381713867, 0.791846075870694, -122.645278930664, -2.14056392936692, 218, 43, 'PPL', 'P'),
(179019, 'Rosemont Camp', 31.8250007629395, 0.555451047763001, -110.734169006348, -1.93267584362062, 218, 5, 'PPL', 'P'),
(179020, 'Rosemont Junction', 31.8341693878174, 0.555611070455001, -110.732223510742, -1.93264188831673, 218, 5, 'PPL', 'P'),
(152219, 'Rosemont Park', 42.6566696166992, 0.744499332746829, -73.7119369506836, -1.2865159978119, 218, 40, 'PPL', 'P'),
(74138, 'Rosemoor', 39.6277809143066, 0.69163525221362, -83.6669387817383, -1.46026355680587, 218, 41, 'PPL', 'P'),
(74137, 'Rosemount', 38.7861099243164, 0.67694532221977, -82.9791717529297, -1.4482597576665, 218, 41, 'PPL', 'P'),
(79058, 'Rosemount', 39.9474983215332, 0.697215373645663, -76.6975021362305, -1.33862394033261, 218, 45, 'PPL', 'P'),
(137813, 'Rosemount', 44.7394409179688, 0.780850549520029, -93.1255569458008, -1.6253475864577, 218, 28, 'PPL', 'P'),
(137815, 'Rosen', 45.1536102294922, 0.788079167666831, -96.4011077880859, -1.68251673347205, 218, 28, 'PPL', 'P'),
(105898, 'Rosena', 38.1152801513672, 0.6652371339614, -78.3472213745117, -1.36741697277411, 218, 53, 'PPL', 'P'),
(11686, 'Rosenbaum', 35.1344413757324, 0.613211682855457, -90.8472213745117, -1.5855831292734, 218, 4, 'PPL', 'P'),
(97643, 'Rosenberg', 29.5569400787354, 0.515865921188604, -95.8083267211914, -1.67217075211125, 218, 51, 'PPL', 'P'),
(105899, 'Rosenberger', 39.202220916748, 0.684207829091443, -78.3186111450195, -1.36691763006972, 218, 53, 'PPL', 'P'),
(142900, 'Rosenburg', 41.6319389343262, 0.726614408393211, -97.7536087036133, -1.70612232758424, 218, 35, 'PPL', 'P'),
(117607, 'Rosendale', 42.2133293151855, 0.736761584778631, -93.7180633544922, -1.63568877412853, 218, 16, 'PPL', 'P'),
(137816, 'Rosendale', 45.0405616760254, 0.786106098194219, -94.7063903808594, -1.65293833482508, 218, 28, 'PPL', 'P'),
(139428, 'Rosendale', 40.0444412231445, 0.698907346465217, -94.820556640625, -1.65493091195268, 218, 29, 'PPL', 'P'),
(152243, 'Rosendale', 41.8438911437988, 0.730313672305386, -74.0824966430664, -1.29298348451916, 218, 40, 'PPL', 'P'),
(176173, 'Rosendale', 43.8077812194824, 0.764590020273305, -88.6747207641602, -1.54766584062118, 218, 57, 'PPL', 'P'),
(176174, 'Rosendale Center', 43.8516693115234, 0.765356011981839, -88.7202835083008, -1.54846106052267, 218, 57, 'PPL', 'P'),
(111209, 'Rosendorf', 39.0738906860352, 0.681968044035659, -79.6222229003906, -1.38966994736865, 218, 58, 'PPL', 'P'),
(61605, 'Roseneath', 33.0677795410156, 0.577141629314342, -90.4283294677734, -1.57827208629086, 218, 30, 'PPL', 'P'),
(68388, 'Roseneath', 36.0747184753418, 0.629622614124743, -77.4786071777344, -1.35225679511078, 218, 33, 'PPL', 'P'),
(192135, 'Rosenfeld', 30.1033306121826, 0.525402234998987, -102.751670837402, -1.79335496803811, 218, 51, 'PPL', 'P'),
(166658, 'Rosengrant', 41.5063896179199, 0.724423159448294, -75.9858322143555, -1.32620295700848, 218, 45, 'PPL', 'P'),
(71344, 'Rosenhayn', 39.4780616760254, 0.689022158552034, -75.1316680908203, -1.31129498070038, 218, 37, 'PPL', 'P'),
(97644, 'Rosenthal', 31.4172191619873, 0.548333916197332, -97.0991668701172, -1.69470016282694, 218, 51, 'PPL', 'P'),
(42873, 'Rosepine', 30.9197196960449, 0.539650912489724, -93.2822189331055, -1.62808185394888, 218, 22, 'PPL', 'P'),
(137818, 'Roseport', 44.7758293151855, 0.781485646860986, -93.0494384765625, -1.62401906854791, 218, 28, 'PPL', 'P'),
(166659, 'Roses', 41.4544410705566, 0.723516486255176, -79.1566696166992, -1.38154450972476, 218, 45, 'PPL', 'P'),
(105900, 'Roses Mill', 37.7013893127441, 0.658013376083587, -78.9966735839844, -1.37875205216376, 218, 53, 'PPL', 'P'),
(152221, 'Roses Point', 41.4577789306641, 0.723574742904022, -74.6047210693359, -1.3020980201919, 218, 40, 'PPL', 'P'),
(190682, 'Roses Well (historical)', 36.6952781677246, 0.640453423961986, -116.586669921875, -2.03482125407256, 218, 39, 'PPL', 'P'),
(105902, 'Rosespout', 37.7555618286133, 0.658958864849593, -77.0908279418945, -1.3454887706745, 218, 53, 'PPL', 'P'),
(166660, 'Roseto', 40.8805618286133, 0.713500403974416, -75.2149963378906, -1.31274933297167, 218, 45, 'PPL', 'P'),
(152222, 'Roseton', 41.5583305358887, 0.725329699483357, -73.9844436645508, -1.29127213720267, 218, 40, 'PPL', 'P'),
(11687, 'Rosetta', 35.7088890075684, 0.623237685411278, -93.3444366455078, -1.62916775788336, 218, 4, 'PPL', 'P'),
(38010, 'Rosetta', 37.7966690063477, 0.65967632044726, -86.273063659668, -1.50574901664387, 218, 21, 'PPL', 'P'),
(61607, 'Rosetta', 31.3163890838623, 0.546574099349008, -91.100830078125, -1.59000943616316, 218, 30, 'PPL', 'P'),
(117608, 'Rosetta (historical)', 41.4097213745117, 0.722735980318701, -92.3630599975586, -1.61203950417446, 218, 16, 'PPL', 'P'),
(205613, 'Rosette', 41.8186111450195, 0.729872453091787, -113.412216186523, -1.97941658443844, 218, 52, 'PPL', 'P'),
(187282, 'Rosevale', 39.060001373291, 0.681725629797435, -108.579719543457, -1.89507360692536, 218, 7, 'PPL', 'P'),
(11688, 'Roseville', 35.3824996948242, 0.617541117260571, -93.7752838134766, -1.63668745953731, 218, 4, 'PPL', 'P'),
(38007, 'Roseville', 37.7172203063965, 0.658289679046683, -86.754997253418, -1.51416034463078, 218, 21, 'PPL', 'P'),
(57275, 'Roseville', 37.2644386291504, 0.650387147986036, -93.2649993896484, -1.62778131621987, 218, 29, 'PPL', 'P'),
(68390, 'Roseville', 36.3547210693359, 0.634509581304066, -79.0419387817383, -1.37954207890113, 218, 33, 'PPL', 'P'),
(74141, 'Roseville', 39.8072204589844, 0.694767063076526, -82.0713882446289, -1.43241594655134, 218, 41, 'PPL', 'P'),
(90488, 'Roseville', 35.4577789306641, 0.618854987784362, -86.3016662597656, -1.50624822619021, 218, 50, 'PPL', 'P'),
(105901, 'Roseville', 38.4650001525879, 0.67134089944278, -77.5041732788086, -1.35270300775142, 218, 53, 'PPL', 'P'),
(117609, 'Roseville', 43.0091705322266, 0.750651634339075, -92.8097229003906, -1.6198352424754, 218, 16, 'PPL', 'P'),
(121295, 'Roseville', 40.7322196960449, 0.710911345341668, -90.664436340332, -1.58239292860359, 218, 18, 'PPL', 'P'),
(132914, 'Roseville', 42.4972190856934, 0.741716395986723, -82.9372177124023, -1.44752752152478, 218, 27, 'PPL', 'P'),
(137819, 'Roseville', 45.0061111450195, 0.785504822999106, -93.1563873291016, -1.62588567815595, 218, 28, 'PPL', 'P'),
(140806, 'Roseville', 47.4402809143066, 0.827989100025677, -97.3886108398438, -1.69975191309871, 218, 34, 'PPL', 'P'),
(146230, 'Roseville', 40.9575004577637, 0.714843236375061, -74.6919403076172, -1.30362028307099, 218, 37, 'PPL', 'P'),
(166670, 'Roseville', 41.1777801513672, 0.718687842303726, -79.1463928222656, -1.38136514582534, 218, 45, 'PPL', 'P'),
(184673, 'Roseville', 32.7280616760254, 0.571212434042417, -117.231391906738, -2.04607377546842, 218, 6, 'PPL', 'P'),
(111210, 'Roseville (historical)', 37.9280586242676, 0.6619695018829, -81.2616729736328, -1.41828374906878, 218, 58, 'PPL', 'P'),
(111211, 'Roseville Addition', 38.3930587768555, 0.670085285567835, -81.8552780151367, -1.42864411149946, 218, 58, 'PPL', 'P'),
(193080, 'Roseville Colonia', 31.6319999694824, 0.552082548458214, -106.255996704102, -1.85451699247482, 218, 51, 'PPL', 'P'),
(51058, 'Roseville Heights', 39.6058311462402, 0.691252156490812, -76.9158325195313, -1.34243452437835, 218, 25, 'PPL', 'P'),
(14527, 'Roseville Park', 39.6994400024414, 0.692885939240548, -75.7133331298828, -1.32144695077576, 218, 10, 'PPL', 'P'),
(97645, 'Rosevine', 31.420280456543, 0.548387345866702, -93.9749984741211, -1.64017313793006, 218, 51, 'PPL', 'P'),
(105904, 'Rosewell', 37.3308296203613, 0.65154588937633, -76.5897216796875, -1.33674281649663, 218, 53, 'PPL', 'P'),
(51059, 'Rosewick', 38.563060760498, 0.673052379917319, -76.9805603027344, -1.34356423731276, 218, 25, 'PPL', 'P'),
(17857, 'Rosewood', 29.2388896942139, 0.51031489479147, -82.9322204589844, -1.44744030299908, 218, 12, 'PPL', 'P'),
(31011, 'Rosewood', 38.0380592346191, 0.663889374712738, -85.9291687011719, -1.49974691733711, 218, 19, 'PPL', 'P'),
(38008, 'Rosewood', 37.086669921875, 0.647284498737067, -87.0894393920898, -1.51999746110802, 218, 21, 'PPL', 'P'),
(42874, 'Rosewood', 30.9977798461914, 0.541013319124382, -91.8833312988281, -1.60366665886531, 218, 22, 'PPL', 'P'),
(51060, 'Rosewood', 38.517219543457, 0.672252299746832, -76.5374984741211, -1.33583134961355, 218, 25, 'PPL', 'P'),
(68391, 'Rosewood', 35.413330078125, 0.618079208958822, -78.0711135864258, -1.36259798278161, 218, 33, 'PPL', 'P'),
(83392, 'Rosewood', 34.9124984741211, 0.609338048470909, -81.852783203125, -1.42860056881564, 218, 48, 'PPL', 'P'),
(97646, 'Rosewood', 32.7502784729004, 0.571600190297132, -95.0808334350586, -1.65947359898208, 218, 51, 'PPL', 'P'),
(137823, 'Rosewood', 48.1894416809082, 0.841064422029639, -96.2900009155273, -1.68057755272431, 218, 28, 'PPL', 'P'),
(139429, 'Rosewood', 40.4249992370605, 0.705549336802902, -92.9227828979492, -1.62180851168509, 218, 29, 'PPL', 'P'),
(157443, 'Rosewood', 40.2188911437988, 0.701952071960478, -83.9608306884766, -1.46539293822341, 218, 41, 'PPL', 'P'),
(176177, 'Rosewood', 42.6758308410645, 0.744833759200716, -88.1686096191406, -1.53883253475955, 218, 57, 'PPL', 'P'),
(193919, 'Rosewood', 40.7680587768555, 0.7115368553027, -124.164436340332, -2.16707822802169, 218, 6, 'PPL', 'P'),
(201506, 'Rosewood', 45.3980598449707, 0.792345618312165, -122.731941223145, -2.14207647170803, 218, 43, 'PPL', 'P'),
(51061, 'Rosewood Estates', 39.189998626709, 0.683994509888128, -77.1522216796875, -1.3465602935391, 218, 25, 'PPL', 'P'),
(51062, 'Rosewood Forest', 38.4083290100098, 0.670351801413924, -75.5194396972656, -1.3180628719786, 218, 25, 'PPL', 'P'),
(28465, 'Rosewood Heights', 38.8877792358398, 0.67871978645409, -90.084716796875, -1.57227491383211, 218, 18, 'PPL', 'P'),
(205615, 'Rosewood Manor Condominium', 41.1624984741211, 0.718421126720555, -112.030563354492, -1.95530219339999, 218, 52, 'PPL', 'P'),
(105903, 'Rosewood Park', 37.2527809143066, 0.650183682478754, -79.9097213745117, -1.39468774233652, 218, 53, 'PPL', 'P'),
(166666, 'Rosewood Park', 40.2058296203613, 0.701724105371167, -75.1138916015625, -1.31098472243338, 218, 45, 'PPL', 'P'),
(195559, 'Roseworth', 42.3669395446777, 0.739442589048014, -114.92138671875, -2.00575657919987, 218, 17, 'PPL', 'P'),
(97647, 'Rosharon', 29.3519401550293, 0.512287997553596, -95.4599990844727, -1.66609128797482, 218, 51, 'PPL', 'P'),
(171227, 'Rosholt', 45.8666687011719, 0.80052438575688, -96.7311096191406, -1.68827635196156, 218, 49, 'PPL', 'P'),
(176178, 'Rosholt', 44.6277809143066, 0.778901714813336, -89.3086090087891, -1.55872927757964, 218, 57, 'PPL', 'P'),
(28466, 'Rosiclare', 37.4236106872559, 0.653165224477153, -88.3461074829102, -1.54193045689758, 218, 18, 'PPL', 'P'),
(112244, 'Rosie', 35.6683311462402, 0.622529817193535, -91.538330078125, -1.59764525164064, 218, 4, 'PPL', 'P'),
(24536, 'Rosier', 32.9780616760254, 0.575575757172403, -82.2427825927734, -1.43540734224578, 218, 13, 'PPL', 'P'),
(152223, 'Rosiere', 44.1213912963867, 0.770063548682718, -76.241943359375, -1.33067293974012, 218, 40, 'PPL', 'P'),
(176180, 'Rosiere', 44.6755599975586, 0.779735617129667, -87.6119384765625, -1.52911679047072, 218, 57, 'PPL', 'P'),
(68394, 'Rosin Hill', 35.2083282470703, 0.614501252034301, -78.414436340332, -1.36859009523429, 218, 33, 'PPL', 'P'),
(111212, 'Rosina (historical)', 38.401668548584, 0.670235554432343, -81.2805633544922, -1.41861344841174, 218, 58, 'PPL', 'P'),
(68395, 'Rosindale', 34.4408302307129, 0.601105884646338, -78.5272216796875, -1.37055857075402, 218, 33, 'PPL', 'P'),
(11691, 'Rosine', 35.0374984741211, 0.611519710035902, -90.8041687011719, -1.58483171837183, 218, 4, 'PPL', 'P'),
(38009, 'Rosine', 37.4502792358398, 0.653630678456671, -86.7413864135742, -1.51392279066155, 218, 21, 'PPL', 'P'),
(5560, 'Rosinton', 30.6183300018311, 0.534390669994113, -87.6936111450195, -1.53054224744419, 218, 2, 'PPL', 'P'),
(83396, 'Rosinville', 33.2544403076172, 0.580399474275836, -80.5277786254883, -1.40547487633188, 218, 48, 'PPL', 'P'),
(97649, 'Rosita', 26.3994407653809, 0.460757162041108, -98.9274978637695, -1.72661055848244, 218, 51, 'PPL', 'P'),
(187283, 'Rosita', 38.0972213745117, 0.664921948846389, -105.335563659668, -1.83845240530529, 218, 7, 'PPL', 'P'),
(192136, 'Rosita Gardens Colonia', 28.6089992523193, 0.499321232653568, -100.426002502441, -1.75276439828367, 218, 51, 'PPL', 'P'),
(192137, 'Rosita North', 28.6533298492432, 0.500094947529264, -100.422500610352, -1.75270327873665, 218, 51, 'PPL', 'P'),
(192139, 'Rosita South', 28.6224994659424, 0.499556855831013, -100.424171447754, -1.75273244035059, 218, 51, 'PPL', 'P'),
(192138, 'Rosita Valley Colonia', 28.6180000305176, 0.499478325868369, -100.429000854492, -1.75281672939909, 218, 51, 'PPL', 'P'),
(68396, 'Roslin', 34.9261093139648, 0.609575602440144, -78.9461135864258, -1.37786961373656, 218, 33, 'PPL', 'P'),
(90491, 'Roslin', 36.2230606079102, 0.632211672757491, -84.9258270263672, -1.48223530158929, 218, 50, 'PPL', 'P'),
(125990, 'Roslindale', 42.2911109924316, 0.738119131144299, -71.125, -1.24136543048097, 218, 23, 'PPL', 'P'),
(28468, 'Roslyn', 39.2294387817383, 0.684682870450886, -88.378059387207, -1.54248812282984, 218, 18, 'PPL', 'P'),
(51065, 'Roslyn', 39.3741683959961, 0.687208878744826, -76.7388916015625, -1.33934632277829, 218, 25, 'PPL', 'P'),
(152224, 'Roslyn', 40.7997207641602, 0.712089461228892, -73.6513900756836, -1.28545925549135, 218, 40, 'PPL', 'P'),
(166667, 'Roslyn', 40.1316719055176, 0.700429809081388, -75.1380615234375, -1.31140656715005, 218, 45, 'PPL', 'P'),
(171229, 'Roslyn', 45.4952812194824, 0.794042451400709, -97.4905624389648, -1.70153130418105, 218, 49, 'PPL', 'P'),
(208616, 'Roslyn', 47.2236099243164, 0.824207477856791, -120.991943359375, -2.11170778000758, 218, 56, 'PPL', 'P'),
(152225, 'Roslyn Estates', 40.7941703796387, 0.71199258874424, -73.6608276367188, -1.28562397200478, 218, 40, 'PPL', 'P'),
(152226, 'Roslyn Harbor', 40.8163909912109, 0.712380411577983, -73.6374969482422, -1.2852167746741, 218, 40, 'PPL', 'P'),
(152227, 'Roslyn Heights', 40.7886085510254, 0.711895516522507, -73.6477813720703, -1.28539627173157, 218, 40, 'PPL', 'P'),
(166668, 'Roslyn Heights', 40.0999984741211, 0.699877003418115, -75.1800003051758, -1.31213853697566, 218, 45, 'PPL', 'P'),
(105905, 'Roslyn Hills', 37.5761108398438, 0.655826854249605, -77.5661087036133, -1.35378398483788, 218, 53, 'PPL', 'P'),
(51063, 'Roslyn Station', 39.3772201538086, 0.687262141966628, -76.7444381713867, -1.33944312868391, 218, 25, 'PPL', 'P'),
(68397, 'Rosman', 35.1436080932617, 0.613371672257943, -82.8213882446289, -1.4455059159413, 218, 33, 'PPL', 'P'),
(105906, 'Rosney', 37.5091705322266, 0.654658525479387, -78.4255599975586, -1.36878423967775, 218, 53, 'PPL', 'P'),
(200174, 'Rosny', 40.6124992370605, 0.708821829150392, -116.837501525879, -2.03919909143049, 218, 39, 'PPL', 'P'),
(11692, 'Ross', 35.4550018310547, 0.618806518252523, -93.253059387207, -1.62757292386457, 218, 4, 'PPL', 'P'),
(14528, 'Ross', 38.6566696166992, 0.674686162667056, -75.6213912963867, -1.31984226306093, 218, 10, 'PPL', 'P'),
(24537, 'Ross', 34.0458297729492, 0.594211826111477, -83.0666732788086, -1.4497869473936, 218, 13, 'PPL', 'P'),
(38011, 'Ross', 39.0202789306641, 0.68103234238666, -84.3330612182617, -1.47188958654461, 218, 21, 'PPL', 'P'),
(74139, 'Ross', 39.3122215270996, 0.686127701921281, -84.6505584716797, -1.47743095898279, 218, 41, 'PPL', 'P'),
(97651, 'Ross', 31.7183303833008, 0.553589298423954, -97.1188888549805, -1.69504437639783, 218, 51, 'PPL', 'P'),
(111213, 'Ross', 39.496940612793, 0.689351658157904, -80.6994400024414, -1.40847093255822, 218, 58, 'PPL', 'P'),
(113117, 'Ross', 42.7825012207031, 0.746695508539763, -85.6944427490234, -1.49565017663224, 218, 27, 'PPL', 'P'),
(117610, 'Ross', 41.774169921875, 0.729096807424301, -94.9186096191406, -1.65664225926916, 218, 16, 'PPL', 'P'),
(123589, 'Ross', 41.526668548584, 0.724777093557165, -87.3747177124023, -1.52497650708203, 218, 19, 'PPL', 'P'),
(137828, 'Ross', 48.9061088562012, 0.853572623879468, -95.9199981689453, -1.67411978655503, 218, 28, 'PPL', 'P'),
(176182, 'Ross', 43.5411109924316, 0.759935746794228, -90.753059387207, -1.58393969256471, 218, 57, 'PPL', 'P'),
(184675, 'Ross', 38.458610534668, 0.671229379572133, -122.884719848633, -2.14474296174947, 218, 6, 'PPL', 'P'),
(198833, 'Ross', 48.3111114501953, 0.843187960103841, -102.546112060547, -1.78976729057561, 218, 34, 'PPL', 'P'),
(209710, 'Ross', 43.4461097717285, 0.758277662699545, -105.886108398438, -1.84806122367635, 218, 59, 'PPL', 'P'),
(57276, 'Ross (historical)', 36.8161087036133, 0.642562314650193, -91.2866668701172, -1.59325290005477, 218, 29, 'PPL', 'P'),
(208617, 'Ross (historical)', 47.6480598449707, 0.831615526482038, -122.361106872559, -2.13560419131081, 218, 56, 'PPL', 'P'),
(51064, 'Ross Acres', 38.5763893127441, 0.673285007038538, -76.2436065673828, -1.330701968196, 218, 25, 'PPL', 'P'),
(57277, 'Ross Bridge', 37.665828704834, 0.657392726391544, -92.0483322143555, -1.60654646811007, 218, 29, 'PPL', 'P'),
(192140, 'Ross City', 32.0964508056641, 0.560188744763225, -101.30615234375, -1.76812591092541, 218, 51, 'PPL', 'P'),
(166669, 'Ross Common', 40.8650016784668, 0.713228828122255, -75.3063888549805, -1.31434443330657, 218, 45, 'PPL', 'P'),
(128692, 'Ross Corner', 43.5855598449707, 0.760711525619768, -70.8016662597656, -1.23572219213109, 218, 26, 'PPL', 'P'),
(146236, 'Ross Corner', 41.1199989318848, 0.717679369777941, -74.7130584716797, -1.30398886456585, 218, 37, 'PPL', 'P'),
(184676, 'Ross Corner', 32.7813911437988, 0.5721432088434, -114.58943939209, -1.99996300540646, 218, 6, 'PPL', 'P'),
(152228, 'Ross Corners', 42.0675010681152, 0.734216401724842, -76.100830078125, -1.32821004836401, 218, 40, 'PPL', 'P'),
(51066, 'Ross Cove', 39.0905609130859, 0.682258994384751, -76.5119400024414, -1.33538527013096, 218, 25, 'PPL', 'P'),
(38012, 'Ross Crossing', 36.9613914489746, 0.645097976903085, -88.8899993896484, -1.55142316144512, 218, 21, 'PPL', 'P'),
(61608, 'Ross Crossing', 34.8180618286133, 0.607689818072259, -88.7286071777344, -1.54860633596014, 218, 30, 'PPL', 'P'),
(176181, 'Ross Crossing', 42.8291702270508, 0.747510036359163, -89.5522232055664, -1.562981147418, 218, 57, 'PPL', 'P'),
(51077, 'Ross Farm Woods', 38.8250007629395, 0.677624095402604, -75.9172210693359, -1.32500546662432, 218, 25, 'PPL', 'P'),
(197434, 'Ross Fork', 47.077220916748, 0.821652507685997, -109.692222595215, -1.91449044811702, 218, 31, 'PPL', 'P'),
(68398, 'Ross Grove', 35.3172187805176, 0.616401750367208, -81.5247192382813, -1.42287477247197, 218, 33, 'PPL', 'P'),
(197435, 'Ross Hall', 47.2094383239746, 0.82396013677055, -107.936943054199, -1.8838550408334, 218, 31, 'PPL', 'P'),
(5562, 'Ross Heights', 31.2191696166992, 0.544877299549977, -85.4288864135742, -1.49101534422912, 218, 2, 'PPL', 'P'),
(152229, 'Ross Mills', 42.1599998474121, 0.735830809977648, -79.2225036621094, -1.38269353057707, 218, 40, 'PPL', 'P'),
(189388, 'Ross Place', 32.0719413757324, 0.559760974513131, -103.725830078125, -1.81035725422745, 218, 38, 'PPL', 'P'),
(17858, 'Ross Prairie', 29.0744400024414, 0.507444706216151, -82.2472229003906, -1.4354848402335, 218, 12, 'PPL', 'P'),
(51067, 'Ross Run Estates', 39.6430587768555, 0.691901901217764, -76.9283294677734, -1.34265263727162, 218, 25, 'PPL', 'P'),
(68399, 'Ross Store', 36.3402786254883, 0.63425751310689, -80.2202835083008, -1.40010807410316, 218, 33, 'PPL', 'P'),
(51068, 'Ross Valley Farms', 39.5722198486328, 0.690665528681695, -76.658332824707, -1.33794030688078, 218, 25, 'PPL', 'P'),
(11693, 'Ross Van Ness', 33.110279083252, 0.577883386256956, -91.3486099243164, -1.59433401029929, 218, 4, 'PPL', 'P'),
(51069, 'Ross Woods', 38.4538917541504, 0.671147021315422, -76.5458297729492, -1.33597675820907, 218, 25, 'PPL', 'P'),
(90492, 'Rossboro', 35.1749992370605, 0.6139195510732, -87.2597198486328, -1.52296941572649, 218, 50, 'PPL', 'P'),
(31012, 'Rossburg', 39.3258285522461, 0.686365189311489, -85.3261108398438, -1.4892215720769, 218, 19, 'PPL', 'P'),
(137831, 'Rossburg', 46.5352783203125, 0.81219382502139, -93.579719543457, -1.63327421912621, 218, 28, 'PPL', 'P'),
(152230, 'Rossburg', 42.4972190856934, 0.741716395986723, -78.0702819824219, -1.36258346855367, 218, 40, 'PPL', 'P'),
(157445, 'Rossburg', 40.2788887023926, 0.702999226901097, -84.6374969482422, -1.47720299239348, 218, 41, 'PPL', 'P'),
(74144, 'Rosseau', 39.5736083984375, 0.690689763447614, -81.9469375610352, -1.43024387236628, 218, 41, 'PPL', 'P'),
(68400, 'Rosser', 35.5552787780762, 0.620556681141895, -79.0913925170898, -1.38040520941042, 218, 33, 'PPL', 'P'),
(90493, 'Rosser', 36.0308303833008, 0.628856622416209, -88.3536071777344, -1.54206135126516, 218, 50, 'PPL', 'P'),
(97652, 'Rosser', 32.4625015258789, 0.56657753506027, -96.4530563354492, -1.68342340666517, 218, 51, 'PPL', 'P'),
(117613, 'Rosserdale', 41.4027786254883, 0.722614806489103, -94.4141693115234, -1.64783811502147, 218, 16, 'PPL', 'P'),
(152231, 'Rosses', 42.5194396972656, 0.742104218820466, -77.8916702270508, -1.35946610533968, 218, 40, 'PPL', 'P'),
(157446, 'Rossford', 41.6097183227539, 0.726226585559468, -83.5644378662109, -1.45847457834361, 218, 41, 'PPL', 'P'),
(166674, 'Rossford', 40.7513885498047, 0.711245904953609, -79.538330078125, -1.38820574140132, 218, 45, 'PPL', 'P'),
(184677, 'Rossi', 36.2955589294434, 0.633477007170415, -119.831672668457, -2.09145723623667, 218, 6, 'PPL', 'P'),
(117614, 'Rossie', 43.0133285522461, 0.75072420547878, -95.1883316040039, -1.66134979597004, 218, 16, 'PPL', 'P'),
(152232, 'Rossie', 44.3786087036133, 0.774552839332264, -75.6552810668945, -1.32043375113904, 218, 40, 'PPL', 'P'),
(42876, 'Rossignol', 30.1180591583252, 0.525659296623207, -92.9966735839844, -1.62309814744296, 218, 22, 'PPL', 'P'),
(24538, 'Rossignol Hill', 32.0952796936035, 0.560168305001858, -81.1486129760742, -1.41631047985909, 218, 13, 'PPL', 'P'),
(38017, 'Rossington', 37.144718170166, 0.64829763179476, -88.8288879394531, -1.55035656542854, 218, 21, 'PPL', 'P'),
(166675, 'Rossiter', 40.8944396972656, 0.713742618475558, -78.9313888549805, -1.37761261869137, 218, 45, 'PPL', 'P'),
(38013, 'Rossland', 36.9261093139648, 0.644482187480031, -83.9886093139648, -1.46587776669986, 218, 21, 'PPL', 'P'),
(166676, 'Rossland', 40.8711090087891, 0.713335421144885, -75.397216796875, -1.31592967994544, 218, 45, 'PPL', 'P'),
(5563, 'Rossland City', 33.6797218322754, 0.587822037129023, -87.7813873291016, -1.53207423086125, 218, 2, 'PPL', 'P'),
(38014, 'Rosslyn', 37.8405609130859, 0.660442378734821, -83.8122177124023, -1.46279915247973, 218, 21, 'PPL', 'P'),
(97653, 'Rosslyn', 29.8352794647217, 0.520723859912045, -95.4791717529297, -1.66642591416579, 218, 51, 'PPL', 'P'),
(105907, 'Rosslyn', 38.896671295166, 0.678874982166614, -77.0727767944336, -1.34517371871755, 218, 53, 'PPL', 'P'),
(166677, 'Rosslyn Farms', 40.4255599975586, 0.705559123919908, -80.0941696166992, -1.39790697146221, 218, 45, 'PPL', 'P'),
(152234, 'Rossman', 42.3313903808594, 0.738822139093053, -73.7441711425781, -1.28707859059218, 218, 40, 'PPL', 'P'),
(166679, 'Rossmere', 40.0561103820801, 0.699111011709581, -76.2972183227539, -1.331637669845, 218, 45, 'PPL', 'P'),
(51070, 'Rossmoor', 39.1036109924316, 0.68248676123698, -77.0713882446289, -1.34514948395163, 218, 25, 'PPL', 'P'),
(146231, 'Rossmoor', 40.3363914489746, 0.704002839157893, -74.4738922119141, -1.29981462587326, 218, 37, 'PPL', 'P'),
(184678, 'Rossmoor', 33.7855606079102, 0.589669272240129, -118.084167480469, -2.0609575170106, 218, 6, 'PPL', 'P'),
(111214, 'Rossmore', 37.8091697692871, 0.659894499919565, -81.9813919067383, -1.43084521414042, 218, 58, 'PPL', 'P'),
(74145, 'Rossmoyne', 39.2136116027832, 0.684406634066818, -84.3869400024414, -1.47282994872551, 218, 41, 'PPL', 'P'),
(166681, 'Rossmoyne', 40.8247184753418, 0.712525753594474, -79.1277770996094, -1.38104024017235, 218, 45, 'PPL', 'P'),
(166682, 'Rossmoyne Manor', 40.2108306884766, 0.701811390475894, -76.9511108398438, -1.34305024722237, 218, 45, 'PPL', 'P'),
(38015, 'Rosspoint', 36.8822212219238, 0.643716195771497, -83.289436340332, -1.45367489626901, 218, 21, 'PPL', 'P'),
(11696, 'Rosston', 33.5924987792969, 0.586299707670906, -93.2763900756836, -1.62798012119524, 218, 4, 'PPL', 'P'),
(77137, 'Rosston', 36.8133316040039, 0.642513845118354, -99.9336090087891, -1.74417051060404, 218, 42, 'PPL', 'P'),
(97654, 'Rosston', 33.4833297729492, 0.584394349069009, -97.4419403076172, -1.7006826878997, 218, 51, 'PPL', 'P'),
(123592, 'Rosston', 40.0486106872559, 0.698980117342004, -86.2891693115234, -1.50603011329693, 218, 19, 'PPL', 'P'),
(166683, 'Rosston', 40.7508316040039, 0.71123618441563, -79.5516662597656, -1.38843850168059, 218, 45, 'PPL', 'P'),
(31013, 'Rosstown', 39.1091690063477, 0.682583766879686, -85.929443359375, -1.49975171102707, 218, 19, 'PPL', 'P'),
(105908, 'Rosstown', 38.8666687011719, 0.678351338117277, -77.8455581665039, -1.35866129805825, 218, 53, 'PPL', 'P'),
(152235, 'Rosstown', 42.024169921875, 0.733460130554287, -76.8413925170898, -1.34113530124055, 218, 40, 'PPL', 'P'),
(90503, 'Rossview', 36.5605583190918, 0.638102119035555, -87.2350006103516, -1.5225379836299, 218, 50, 'PPL', 'P'),
(24541, 'Rossville', 34.9830589294434, 0.610569560737989, -85.2861099243164, -1.48852342439713, 218, 13, 'PPL', 'P'),
(33829, 'Rossville', 39.1361083984375, 0.683053947970139, -95.9513931274414, -1.67466773194931, 218, 20, 'PPL', 'P'),
(51071, 'Rossville', 39.3383293151855, 0.686583368783794, -76.4800033569336, -1.33482787051481, 218, 25, 'PPL', 'P'),
(57278, 'Rossville', 36.7330589294434, 0.64111282264789, -90.2463912963867, -1.5750966661651, 218, 29, 'PPL', 'P'),
(77138, 'Rossville', 35.5938911437988, 0.62123059405574, -96.9986114501953, -1.69294513966858, 218, 42, 'PPL', 'P'),
(83397, 'Rossville', 34.603328704834, 0.603942018049218, -80.9927825927734, -1.41359072659585, 218, 48, 'PPL', 'P'),
(90495, 'Rossville', 35.0483283996582, 0.611708727894271, -89.5425033569336, -1.56281150405657, 218, 50, 'PPL', 'P'),
(97655, 'Rossville', 29.0911102294922, 0.507735656565242, -98.6802825927734, -1.72229583804234, 218, 51, 'PPL', 'P'),
(117615, 'Rossville', 43.1894416809082, 0.753797959429922, -91.3755569458008, -1.5948043245478, 218, 16, 'PPL', 'P'),
(121298, 'Rossville', 40.3791694641113, 0.704749456369497, -87.6686096191406, -1.53010588849958, 218, 18, 'PPL', 'P'),
(123593, 'Rossville', 40.4169387817383, 0.705408655318319, -86.5947189331055, -1.51136296022176, 218, 19, 'PPL', 'P'),
(152237, 'Rossville', 40.5555610656738, 0.707828070589629, -74.2138900756836, -1.29527673253382, 218, 40, 'PPL', 'P'),
(157448, 'Rossville', 40.1569404602051, 0.700870828557906, -84.2391662597656, -1.47025081036783, 218, 41, 'PPL', 'P'),
(90496, 'Rossville Junction', 35.0416717529297, 0.611592547491716, -89.5436096191406, -1.56283081197447, 218, 50, 'PPL', 'P'),
(121299, 'Rossville Junction', 40.357780456543, 0.704376147763695, -87.6436080932617, -1.52966952955497, 218, 18, 'PPL', 'P'),
(90497, 'Rosswood', 35.982780456543, 0.628017992988943, -86.5536117553711, -1.51064550462409, 218, 50, 'PPL', 'P'),
(51073, 'Rosswood Estates', 39.3722190856934, 0.687174856861901, -77.2386093139648, -1.34806804219025, 218, 25, 'PPL', 'P'),
(42877, 'Rost', 29.9511108398438, 0.522745498785038, -90.3605575561523, -1.5770892432927, 218, 22, 'PPL', 'P'),
(137832, 'Rost', 43.6452789306641, 0.761753820291398, -95.2944412231445, -1.66320175819208, 218, 28, 'PPL', 'P'),
(176184, 'Rostok', 44.5016708374023, 0.776700678751413, -87.5013885498047, -1.52718733026096, 218, 57, 'PPL', 'P'),
(5564, 'Roswell', 34.2075004577637, 0.597033511865444, -86.5366668701172, -1.51034976058504, 218, 2, 'PPL', 'P'),
(24539, 'Roswell', 34.0230598449707, 0.59381441589781, -84.3616714477539, -1.472388929249, 218, 13, 'PPL', 'P'),
(157449, 'Roswell', 40.475830078125, 0.706436502341035, -81.3497161865234, -1.41982039301776, 218, 41, 'PPL', 'P'),
(171231, 'Roswell', 44.0072212219238, 0.768070904976093, -97.695556640625, -1.70510912794752, 218, 49, 'PPL', 'P'),
(187284, 'Roswell', 38.8736114501953, 0.678472511946876, -104.818893432617, -1.82943480869623, 218, 7, 'PPL', 'P'),
(189387, 'Roswell', 33.3941688537598, 0.582838197465049, -104.522499084473, -1.82426175143681, 218, 38, 'PPL', 'P'),
(195560, 'Roswell', 43.7491683959961, 0.763567033519578, -116.960830688477, -2.04135159138154, 218, 17, 'PPL', 'P'),
(137834, 'Rosy', 47.6580581665039, 0.831790030112465, -94.3058319091797, -1.64594727064752, 218, 28, 'PPL', 'P'),
(132917, 'Rosy Mound', 43.0299987792969, 0.751015155827871, -86.2227783203125, -1.50487137190664, 218, 27, 'PPL', 'P'),
(83398, 'Rotalata', 33.7261085510254, 0.588631638100407, -81.8433303833008, -1.42843558598611, 218, 48, 'PPL', 'P'),
(11695, 'Rotan', 35.625, 0.62177354602298, -89.991943359375, -1.57065571188934, 218, 4, 'PPL', 'P'),
(192141, 'Rotan', 32.8519401550293, 0.573374521373398, -100.465278625488, -1.75344989594825, 218, 51, 'PPL', 'P'),
(184679, 'Rotavele', 39.684440612793, 0.692624150505394, -121.999168395996, -2.12928717320514, 218, 6, 'PPL', 'P'),
(166686, 'Rote', 41.0788917541504, 0.716961914180273, -77.4205627441406, -1.35124372863211, 218, 45, 'PPL', 'P'),
(68401, 'Roten', 36.4713897705078, 0.63654583427354, -81.6175003051758, -1.42449410757279, 218, 33, 'PPL', 'P'),
(28471, 'Roth', 37.1002807617188, 0.647522052706302, -89.3072204589844, -1.55870504281372, 218, 18, 'PPL', 'P'),
(105909, 'Roth', 37.2447204589844, 0.650043000994171, -81.9730606079102, -1.4306998055449, 218, 53, 'PPL', 'P'),
(198836, 'Roth', 48.9077796936035, 0.853601785493405, -100.802223205566, -1.75933068826737, 218, 34, 'PPL', 'P'),
(97656, 'Roth Estates Colonia', 27.9409999847412, 0.48766244603342, -97.9660034179688, -1.70982931466357, 218, 51, 'PPL', 'P'),
(123594, 'Roth Park', 40.6863899230957, 0.710111464908262, -86.7491683959961, -1.51405861187714, 218, 19, 'PPL', 'P'),
(195561, 'Rothas', 43.8875007629395, 0.765981388784817, -113.53556060791, -1.98156935070561, 218, 17, 'PPL', 'P'),
(132918, 'Rothbury', 43.5072212219238, 0.759344258716121, -86.3475036621094, -1.50704823978167, 218, 27, 'PPL', 'P'),
(90499, 'Rotherwood', 36.5486106872559, 0.637893593522202, -82.6147232055664, -1.4418989305609, 218, 50, 'PPL', 'P'),
(97657, 'Rotherwood', 30.0830593109131, 0.52504843404817, -95.4963912963867, -1.6667264518948, 218, 51, 'PPL', 'P'),
(105910, 'Rotherwood', 38.4366683959961, 0.670846417007379, -78.0286102294922, -1.36185615925997, 218, 53, 'PPL', 'P'),
(90500, 'Rotherwood Heights', 36.5569381713867, 0.638038935538693, -82.620002746582, -1.44199107593461, 218, 50, 'PPL', 'P'),
(90501, 'Rotherwood Hills', 36.5441703796387, 0.637816095534481, -82.6202774047852, -1.44199586962458, 218, 50, 'PPL', 'P'),
(197436, 'Rothiemay', 46.5466690063477, 0.812392629996764, -109.261672973633, -1.9069759396272, 218, 31, 'PPL', 'P'),
(137835, 'Rothman', 47.7661094665527, 0.833675881059378, -91.9641723632813, -1.60507760161083, 218, 28, 'PPL', 'P'),
(79059, 'Rothruck', 39.9925003051758, 0.698000806430154, -79.7649993896484, -1.39216186720063, 218, 45, 'PPL', 'P'),
(137836, 'Rothsay', 46.4749984741211, 0.811141743232754, -96.2802810668945, -1.68040790936287, 218, 28, 'PPL', 'P'),
(176185, 'Rothschild', 44.8872184753418, 0.783429754456743, -89.620002746582, -1.56416412357422, 218, 57, 'PPL', 'P'),
(166687, 'Rothsville', 40.1511116027832, 0.700769095804265, -76.2513885498047, -1.3308377894116, 218, 45, 'PPL', 'P'),
(57279, 'Rothville', 39.6533317565918, 0.692081198538154, -93.0638885498047, -1.62427126990314, 218, 29, 'PPL', 'P'),
(38016, 'Rothwell', 37.9588890075684, 0.662507593581151, -83.6961135864258, -1.46077275320629, 218, 21, 'PPL', 'P'),
(90502, 'Rothwood', 35.9166717529297, 0.626864178446666, -84.0175018310547, -1.46638203625227, 218, 50, 'PPL', 'P'),
(17859, 'Rotonda', 26.8833293914795, 0.469202611779481, -82.290283203125, -1.43623638429312, 218, 12, 'PPL', 'P'),
(11697, 'Rottaken', 34.5730590820313, 0.603413713467974, -92.2108306884766, -1.60938260151295, 218, 4, 'PPL', 'P'),
(152238, 'Rotterdam', 42.7869415283203, 0.746773006527484, -73.9713897705078, -1.29104430377141, 218, 40, 'PPL', 'P'),
(152239, 'Rotterdam Junction', 42.874439239502, 0.748300129675563, -74.0469436645508, -1.29236296798517, 218, 40, 'PPL', 'P'),
(17860, 'Rotunda-West', 26.8575000762939, 0.468751805185958, -82.2949981689453, -1.4363186759708, 218, 12, 'PPL', 'P'),
(202577, 'Roubaix', 44.2758293151855, 0.772759000601014, -103.665832519531, -1.80931009928683, 218, 49, 'PPL', 'P'),
(57280, 'Roubidoux', 37.4225006103516, 0.653145849980222, -92.1477813720703, -1.60828218335053, 218, 29, 'PPL', 'P'),
(68402, 'Rougemont', 36.2183303833008, 0.632129114763698, -78.9266662597656, -1.37753019385563, 218, 33, 'PPL', 'P'),
(152241, 'Rough and Ready', 42.1074981689453, 0.734914482825579, -77.6524963378906, -1.35529173348903, 218, 40, 'PPL', 'P'),
(166688, 'Rough and Ready', 40.6794395446777, 0.709990157920609, -76.628059387207, -1.33741193572051, 218, 45, 'PPL', 'P'),
(184680, 'Rough and Ready', 39.230281829834, 0.684697584415909, -121.13500213623, -2.11420462668759, 218, 6, 'PPL', 'P'),
(11699, 'Rough and Ready (historical)', 33.6097183227539, 0.586600245399922, -91.7872161865234, -1.60198913369467, 218, 4, 'PPL', 'P'),
(192142, 'Rough Canyon Colonia', 29.5779991149902, 0.516233470708549, -100.972999572754, -1.76231129815938, 218, 51, 'PPL', 'P'),
(105911, 'Rough Creek', 37.1199989318848, 0.647866199698168, -78.7583312988281, -1.37459219454105, 218, 53, 'PPL', 'P'),
(97658, 'Rough Creek Crossing', 31.1299991607666, 0.543320981498449, -98.5447235107422, -1.71992988572992, 218, 51, 'PPL', 'P'),
(61609, 'Rough Edge', 34.2558288574219, 0.597877001561699, -88.9755630493164, -1.55291652902638, 218, 30, 'PPL', 'P'),
(11698, 'Rough Edge (historical)', 34.2458305358887, 0.597702497931272, -94.0061111450195, -1.64071615647633, 218, 4, 'PPL', 'P'),
(90504, 'Rough Point', 36.360279083252, 0.634606586946772, -85.7363891601563, -1.4963822796159, 218, 50, 'PPL', 'P'),
(179022, 'Rough Rock', 36.4072189331055, 0.635425841877108, -109.872222900391, -1.91763204609693, 218, 5, 'PPL', 'P'),
(111215, 'Rough Run', 38.8952789306641, 0.678850680821667, -79.120002746582, -1.38090455211481, 218, 58, 'PPL', 'P'),
(117616, 'Rough Woods Hill', 42.3608283996582, 0.739335929446356, -93.208610534668, -1.62679714503903, 218, 16, 'PPL', 'P'),
(68403, 'Roughedge', 34.899169921875, 0.609105421349691, -80.623893737793, -1.40715240150253, 218, 33, 'PPL', 'P'),
(42878, 'Rougon', 30.6088905334473, 0.534225920191178, -91.3741683959961, -1.59478008978188, 218, 22, 'PPL', 'P'),
(166691, 'Roulette', 41.7799987792969, 0.729198540177942, -78.154167175293, -1.36404754136294, 218, 45, 'PPL', 'P'),
(132919, 'Roulo', 42.189998626709, 0.736354387447958, -83.4833297729492, -1.45705897506617, 218, 27, 'PPL', 'P'),
(51074, 'Round Acres', 39.5369415283203, 0.690049805837668, -76.4494400024414, -1.33429443934846, 218, 25, 'PPL', 'P'),
(51075, 'Round Bay', 39.061939239502, 0.681759451943279, -76.5374984741211, -1.33583134961355, 218, 25, 'PPL', 'P'),
(51076, 'Round Bay View', 39.0605583190918, 0.681735350335414, -76.5447235107422, -1.33595745029116, 218, 25, 'PPL', 'P'),
(114007, 'Round Beach', 41.0788917541504, 0.716961914180273, -73.3963928222656, -1.28100871383567, 218, 8, 'PPL', 'P'),
(105912, 'Round Bottom', 37.2544403076172, 0.650212644355609, -81.0558319091797, -1.41469114475827, 218, 53, 'PPL', 'P'),
(111216, 'Round Bottom', 39.6997184753418, 0.692890799509538, -80.4358291625977, -1.403870055459, 218, 58, 'PPL', 'P'),
(112490, 'Round Bottom', 39.7350006103516, 0.693506588932591, -80.9694366455078, -1.41318326294906, 218, 41, 'PPL', 'P'),
(57284, 'Round Bottom Ford (historical)', 38.0299987792969, 0.663748693228155, -93.3377838134766, -1.62905164405983, 218, 29, 'PPL', 'P'),
(197437, 'Round Butte', 47.5297203063965, 0.829550111898627, -114.261672973633, -1.99424240222691, 218, 31, 'PPL', 'P'),
(57283, 'Round Grove', 37.2666702270508, 0.650426096716979, -93.9049987792969, -1.63895141277999, 218, 29, 'PPL', 'P'),
(121300, 'Round Grove', 41.7849998474121, 0.72928582528267, -89.871940612793, -1.56856126885005, 218, 18, 'PPL', 'P'),
(123595, 'Round Grove', 40.5902786254883, 0.708434006316649, -87.0302810668945, -1.51896495355339, 218, 19, 'PPL', 'P'),
(166690, 'Round Head', 40.5086097717285, 0.707008615922211, -76.3099975585938, -1.3318607095863, 218, 45, 'PPL', 'P'),
(11700, 'Round Hill', 34.1322212219238, 0.595719641341653, -92.7941665649414, -1.61956373320226, 218, 4, 'PPL', 'P'),
(38018, 'Round Hill', 37.6788902282715, 0.657620692980855, -84.4161071777344, -1.47333901196788, 218, 21, 'PPL', 'P'),
(51078, 'Round Hill', 39.4355583190918, 0.688280335030392, -77.5002822875977, -1.35263509714362, 218, 25, 'PPL', 'P'),
(105915, 'Round Hill', 38.5597190856934, 0.672994056689447, -78.158332824707, -1.3641202456607, 218, 53, 'PPL', 'P'),
(190683, 'Round Hill', 38.9913902282715, 0.680528139413281, -119.939437866211, -2.09333809375654, 218, 39, 'PPL', 'P'),
(105916, 'Round Hill Park', 37.2969398498535, 0.650954401298223, -79.9494400024414, -1.39538096316827, 218, 53, 'PPL', 'P'),
(105917, 'Round Hill Terrace', 37.3036117553711, 0.651070848016887, -79.9522171020508, -1.39542943270011, 218, 53, 'PPL', 'P'),
(97659, 'Round House (historical)', 32.0190582275391, 0.558837989458336, -96.1556625366211, -1.6782329057006, 218, 51, 'PPL', 'P'),
(28472, 'Round Knob', 37.2472190856934, 0.650086610257021, -88.7375030517578, -1.54876159825169, 218, 18, 'PPL', 'P'),
(166692, 'Round Knob', 40.1497192382813, 0.700744794459318, -78.1927795410156, -1.36472145427678, 218, 45, 'PPL', 'P'),
(17861, 'Round Lake', 30.6513900756836, 0.534967677133793, -85.3888931274414, -1.49031732970741, 218, 12, 'PPL', 'P'),
(61610, 'Round Lake', 34.0533294677734, 0.594342720479055, -90.852783203125, -1.58568020149513, 218, 30, 'PPL', 'P'),
(121302, 'Round Lake', 42.353328704834, 0.739205035078779, -88.0933303833008, -1.53751866423576, 218, 18, 'PPL', 'P'),
(137839, 'Round Lake', 43.5405616760254, 0.759926159414304, -95.4680633544922, -1.66623203603843, 218, 28, 'PPL', 'P'),
(152242, 'Round Lake', 42.9386100769043, 0.749420122071996, -73.790283203125, -1.2878833978736, 218, 40, 'PPL', 'P'),
(121303, 'Round Lake Beach', 42.3716697692871, 0.739525147041806, -88.0899963378906, -1.53746047416594, 218, 18, 'PPL', 'P'),
(121304, 'Round Lake Heights', 42.3800010681152, 0.739670555637325, -88.1041717529297, -1.53770788183121, 218, 18, 'PPL', 'P'),
(121305, 'Round Lake Park', 42.3569412231445, 0.739268085417586, -88.0766677856445, -1.53722784704472, 218, 18, 'PPL', 'P'),
(97660, 'Round Mott', 29.228889465332, 0.510140357871529, -96.4591674804688, -1.68353006626682, 218, 51, 'PPL', 'P'),
(5565, 'Round Mountain', 34.2155609130859, 0.597174193350027, -85.6838912963867, -1.49546601904286, 218, 2, 'PPL', 'P'),
(11701, 'Round Mountain', 35.0252799987793, 0.611306457411614, -92.4472198486328, -1.6135083706737, 218, 4, 'PPL', 'P'),
(97662, 'Round Mountain', 30.5753993988037, 0.533641389621419, -97.9415512084961, -1.70940254309889, 218, 51, 'PPL', 'P'),
(128694, 'Round Mountain', 45.2641716003418, 0.790008827613675, -70.6399993896484, -1.23290057295615, 218, 26, 'PPL', 'P'),
(190684, 'Round Mountain', 38.711109161377, 0.675636311964969, -117.066673278809, -2.04319889307168, 218, 39, 'PPL', 'P'),
(193920, 'Round Mountain', 40.7941703796387, 0.71199258874424, -121.940826416016, -2.12826891356235, 218, 6, 'PPL', 'P'),
(83399, 'Round O', 32.936939239502, 0.574858035258626, -80.5411071777344, -1.4057075034531, 218, 48, 'PPL', 'P'),
(24542, 'Round Oak', 33.1108283996582, 0.577892973636881, -83.6152801513672, -1.45936194361882, 218, 13, 'PPL', 'P'),
(42879, 'Round Oak', 30.3641700744629, 0.529954742434909, -91.0005569458008, -1.58825933985282, 218, 22, 'PPL', 'P'),
(68405, 'Round Peak', 36.5133285522461, 0.637277804099149, -80.7866668701172, -1.40999332859537, 218, 33, 'PPL', 'P'),
(11702, 'Round Pond', 35.0625, 0.611956068980512, -90.6194381713867, -1.58160756239813, 218, 4, 'PPL', 'P'),
(90505, 'Round Pond', 36.4566688537598, 0.636288905807375, -87.3777770996094, -1.52502990346188, 218, 50, 'PPL', 'P'),
(128695, 'Round Pond', 43.9477806091309, 0.767033470573453, -69.461669921875, -1.21233484407023, 218, 26, 'PPL', 'P'),
(28473, 'Round Prairie', 38.457218170166, 0.671205078227186, -88.5391693115234, -1.5453000214668, 218, 18, 'PPL', 'P'),
(97664, 'Round Prairie', 31.2958297729492, 0.546215271681633, -96.3641662597656, -1.68187198217214, 218, 51, 'PPL', 'P'),
(137843, 'Round Prairie', 45.9044418334961, 0.801183651284729, -94.8852767944336, -1.65606049172904, 218, 28, 'PPL', 'P'),
(197438, 'Round Prairie', 48.4011116027832, 0.844758759093797, -114.43083190918, -1.99719478261137, 218, 31, 'PPL', 'P'),
(201507, 'Round Prairie', 43.0883293151855, 0.752033215733581, -123.36833190918, -2.15318358450837, 218, 43, 'PPL', 'P'),
(973, 'Round Rock', 36.2649993896484, 0.632943642583099, -84.2636108398438, -1.47067744877446, 218, 50, 'PPL', 'P'),
(97665, 'Round Rock', 30.5080604553223, 0.532466103342854, -97.6786117553711, -1.70481338390846, 218, 51, 'PPL', 'P'),
(179023, 'Round Rock', 36.5130615234375, 0.637273143567241, -109.472778320313, -1.91066042299532, 218, 5, 'PPL', 'P'),
(57288, 'Round Spring', 37.2805595397949, 0.650668510955203, -91.4111099243164, -1.59542484108179, 218, 29, 'PPL', 'P'),
(97666, 'Round Timber', 33.4358291625977, 0.583565307021668, -99.0702819824219, -1.72910261147248, 218, 51, 'PPL', 'P'),
(79060, 'Round Top', 39.7958297729492, 0.694568258101151, -77.2313919067383, -1.34794207467068, 218, 45, 'PPL', 'P'),
(90506, 'Round Top', 36.0047187805176, 0.628400888974669, -86.0447235107422, -1.50176372923063, 218, 50, 'PPL', 'P'),
(97667, 'Round Top', 30.0650005340576, 0.524733248933159, -96.6958312988281, -1.68766062911754, 218, 51, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(105918, 'Round Top', 37.0286102294922, 0.646271165942292, -82.5166702270508, -1.44018758324441, 218, 53, 'PPL', 'P'),
(146232, 'Round Top', 40.6197204589844, 0.70894786324898, -74.545280456543, -1.30106058578926, 218, 37, 'PPL', 'P'),
(152244, 'Round Top', 42.2688903808594, 0.737731308310556, -74.0277786254883, -1.29202847495225, 218, 40, 'PPL', 'P'),
(169584, 'Round Top', 41.9997215270996, 0.733033425568629, -71.7008285522461, -1.25141553464465, 218, 47, 'PPL', 'P'),
(11704, 'Round Top (historical)', 36.4844398498535, 0.636773601125769, -94.48388671875, -1.64905491332353, 218, 4, 'PPL', 'P'),
(166693, 'Round Top Manor', 40.2024993896484, 0.701665981880376, -76.6983337402344, -1.33863845456055, 218, 45, 'PPL', 'P'),
(142901, 'Round Valley', 41.5683288574219, 0.725504203113784, -99.519172668457, -1.73693723192533, 218, 35, 'PPL', 'P'),
(184681, 'Round Valley', 37.4194412231445, 0.653092453600366, -118.586669921875, -2.06972783911245, 218, 6, 'PPL', 'P'),
(193921, 'Round Valley (historical)', 40.1158294677734, 0.700153306381211, -120.966667175293, -2.11126662737301, 218, 6, 'PPL', 'P'),
(51079, 'Round View', 38.9986114501953, 0.680654173511869, -76.4633331298828, -1.33453692016572, 218, 25, 'PPL', 'P'),
(61612, 'Roundaway', 33.5847206115723, 0.58616395303434, -90.6061096191406, -1.58137493527691, 218, 30, 'PPL', 'P'),
(157450, 'Roundhead', 40.559440612793, 0.707895781460344, -83.8352813720703, -1.4632016892785, 218, 41, 'PPL', 'P'),
(5566, 'Roundhill', 31.8924999237061, 0.556629130360711, -87.711669921875, -1.5308574325592, 218, 2, 'PPL', 'P'),
(38019, 'Roundhill', 37.2369384765625, 0.649907179778577, -86.4308319091797, -1.50850259205296, 218, 21, 'PPL', 'P'),
(68408, 'Roundhill', 35.4311103820801, 0.618389533804844, -83.5250015258789, -1.45778628435987, 218, 33, 'PPL', 'P'),
(199659, 'Rounds Place', 41.6011085510254, 0.726076316694961, -101.605560302734, -1.77335156561636, 218, 35, 'PPL', 'P'),
(38020, 'Roundstone', 37.4383316040039, 0.653422152943318, -84.3147201538086, -1.47156947458158, 218, 21, 'PPL', 'P'),
(105920, 'Roundstone', 36.8899993896484, 0.643851950408064, -82.7125015258789, -1.44360548418742, 218, 53, 'PPL', 'P'),
(24543, 'Roundtop', 34.6036109924316, 0.603946944897235, -84.5661087036133, -1.47595703247749, 218, 13, 'PPL', 'P'),
(166695, 'Roundtop', 41.7069396972656, 0.727923418648012, -77.2525024414063, -1.3483105230075, 218, 45, 'PPL', 'P'),
(111219, 'Roundtop (historical)', 39.6736106872559, 0.692435132647025, -78.230827331543, -1.36538551349459, 218, 58, 'PPL', 'P'),
(189389, 'Roundtop (historical)', 34.4927787780762, 0.602012557839456, -106.106109619141, -1.85190096933603, 218, 38, 'PPL', 'P'),
(166696, 'Roundtown', 40.0177803039551, 0.698442025643753, -76.7558288574219, -1.33964193365929, 218, 45, 'PPL', 'P'),
(51080, 'Roundtree', 39.3530616760254, 0.686840496987041, -77.5458297729492, -1.35343005072901, 218, 25, 'PPL', 'P'),
(24544, 'Roundtree Estates', 33.5541687011719, 0.585630721605079, -84.4000015258789, -1.47305791531483, 218, 13, 'PPL', 'P'),
(192143, 'Roundup', 33.7622184753418, 0.589261875172374, -102.096672058105, -1.78192308274284, 218, 51, 'PPL', 'P'),
(197439, 'Roundup', 46.4452781677246, 0.810623026031434, -108.541107177734, -1.89439969401151, 218, 31, 'PPL', 'P'),
(187285, 'Roundup Junction', 37.482780456543, 0.654197931768858, -108.161666870117, -1.88777721132881, 218, 7, 'PPL', 'P'),
(179024, 'Roundy Crossing', 34.2958297729492, 0.598575149241463, -110.092498779297, -1.92147658544657, 218, 5, 'PPL', 'P'),
(144387, 'Roundys Corner', 43.0522193908691, 0.751402978661614, -72.2961120605469, -1.26180519184733, 218, 36, 'PPL', 'P'),
(61613, 'Rounsaville', 31.1686096191406, 0.54399486112278, -88.4569396972656, -1.54386484395536, 218, 30, 'PPL', 'P'),
(68406, 'Rountree', 35.480281829834, 0.619247737466122, -77.4802780151367, -1.35228595672471, 218, 33, 'PPL', 'P'),
(105919, 'Rourkes Gap', 37.1277809143066, 0.648002020913762, -81.6233291625977, -1.42459584032644, 218, 53, 'PPL', 'P'),
(51081, 'Rousby Hall', 38.3252792358398, 0.668902309411622, -76.4472198486328, -1.3342556903546, 218, 25, 'PPL', 'P'),
(157452, 'Rousculp', 40.665828704834, 0.709752603951374, -84.0849990844727, -1.46756008556047, 218, 41, 'PPL', 'P'),
(61614, 'Rouse', 31.1069393157959, 0.542918511278711, -89.64111328125, -1.56453257191103, 218, 30, 'PPL', 'P'),
(83400, 'Rouse', 32.8852806091309, 0.57395642207158, -81.2755584716797, -1.41852609672798, 218, 48, 'PPL', 'P'),
(176188, 'Rouse', 46.3563919067383, 0.809071668117435, -90.4655609130859, -1.57892189759684, 218, 57, 'PPL', 'P'),
(187286, 'Rouse', 37.4908294677734, 0.65433841351636, -104.711112976074, -1.82755368486025, 218, 7, 'PPL', 'P'),
(195562, 'Rouse', 43.2266693115234, 0.754447704156874, -112.478332519531, -1.96311723961883, 218, 17, 'PPL', 'P'),
(189390, 'Rouse Place', 33.4466705322266, 0.583754524617118, -107.61888885498, -1.87830394785724, 218, 38, 'PPL', 'P'),
(57289, 'Rousertown', 37.7030601501465, 0.658042537697524, -94.2347183227539, -1.64470610442148, 218, 29, 'PPL', 'P'),
(152245, 'Rouses Point', 44.9938888549805, 0.785291503795791, -73.3652801513672, -1.2804656952894, 218, 40, 'PPL', 'P'),
(166697, 'Rouseville', 41.4688911437988, 0.723768687610407, -79.6911087036133, -1.39087223144276, 218, 45, 'PPL', 'P'),
(38021, 'Rousseau', 37.5930595397949, 0.656122664867686, -83.2297210693359, -1.45263266817641, 218, 21, 'PPL', 'P'),
(42880, 'Rousseau', 29.7633304595947, 0.519468112879045, -90.7225036621094, -1.58340639455642, 218, 22, 'PPL', 'P'),
(132920, 'Rousseau', 46.7094383239746, 0.815233490510579, -88.9697189331055, -1.55281452995663, 218, 27, 'PPL', 'P'),
(202578, 'Rousseau', 44.3163909912109, 0.773466935397784, -100.071113586426, -1.74657041822036, 218, 49, 'PPL', 'P'),
(24552, 'Rousseau Spring (historical)', 33.6005592346191, 0.58644038915549, -82.4269409179688, -1.43862151136539, 218, 13, 'PPL', 'P'),
(184683, 'Routier (historical)', 38.5800018310547, 0.673348057377345, -121.320281982422, -2.11743837004121, 218, 6, 'PPL', 'P'),
(42881, 'Routon', 31.701940536499, 0.553303241633366, -92.0524978637695, -1.60661917240782, 218, 22, 'PPL', 'P'),
(90508, 'Routon', 36.2294387817383, 0.632322992891056, -88.3722229003906, -1.54238625691815, 218, 50, 'PPL', 'P'),
(24545, 'Routons Crossroads', 32.8933296203613, 0.574096903819082, -84.6324996948242, -1.47711577386778, 218, 13, 'PPL', 'P'),
(38022, 'Routt', 38.1341705322266, 0.665566833304352, -85.466667175293, -1.49167474291502, 218, 21, 'PPL', 'P'),
(17862, 'Roux Quarters', 27.8936100006104, 0.486835334777868, -81.7724990844727, -1.4271993466081, 218, 12, 'PPL', 'P'),
(111217, 'Rouzer', 38.4661102294922, 0.67136027393971, -81.1922225952148, -1.41707161129863, 218, 58, 'PPL', 'P'),
(79061, 'Rouzerville', 39.7366714477539, 0.693535750546528, -77.5352783203125, -1.35324589313963, 218, 45, 'PPL', 'P'),
(184684, 'Rovana', 37.4127807617188, 0.652976206618784, -118.614440917969, -2.07021253443084, 218, 6, 'PPL', 'P'),
(24546, 'Rovena Acres', 33.6819381713867, 0.587860719543856, -84.2774963378906, -1.47091979643365, 218, 13, 'PPL', 'P'),
(11706, 'Rover', 34.9463882446289, 0.609929536549016, -93.4052810668945, -1.63022969336803, 218, 4, 'PPL', 'P'),
(24547, 'Rover', 33.2063903808594, 0.57956084484857, -84.3349990844727, -1.47192340869045, 218, 13, 'PPL', 'P'),
(57290, 'Rover', 36.7216682434082, 0.640914017672516, -91.6208267211914, -1.59908508968399, 218, 29, 'PPL', 'P'),
(68407, 'Rover', 35.4061088562012, 0.617953174860234, -77.0069427490234, -1.34402469786523, 218, 33, 'PPL', 'P'),
(90509, 'Rover', 35.6730613708496, 0.622612375187328, -86.5966720581055, -1.51139704868371, 218, 50, 'PPL', 'P'),
(111218, 'Rover', 39.0144386291504, 0.680930409895937, -81.4272232055664, -1.42117314569347, 218, 58, 'PPL', 'P'),
(195563, 'Rover', 47.2033309936523, 0.82385354374792, -116.57527923584, -2.03462244909718, 218, 17, 'PPL', 'P'),
(51082, 'Rover (historical)', 39.3013916015625, 0.685938684062913, -76.9983291625977, -1.3438743624217, 218, 25, 'PPL', 'P'),
(51083, 'Rover Mill Estates', 39.2916717529297, 0.685769040701475, -77.0027770996094, -1.34395199356747, 218, 25, 'PPL', 'P'),
(77141, 'Row', 36.2786102294922, 0.633181196552334, -94.6902770996094, -1.65265710501397, 218, 42, 'PPL', 'P'),
(68409, 'Rowan', 34.5127792358398, 0.602361631679338, -78.2713928222656, -1.36609351487039, 218, 33, 'PPL', 'P'),
(117621, 'Rowan', 42.7408294677734, 0.745968199246062, -93.5524978637695, -1.63279911118774, 218, 16, 'PPL', 'P'),
(208618, 'Rowan', 48.274169921875, 0.842543208803933, -121.851387023926, -2.1267079016894, 218, 56, 'PPL', 'P'),
(193295, 'Rowan Bay', 56.6538887023926, 0.988796891915168, -134.251113891602, -2.34312396187834, 218, 1, 'PPL', 'P'),
(152246, 'Rowan Corners', 42.9844398498535, 0.750220002505401, -75.8169403076172, -1.32325523715592, 218, 40, 'PPL', 'P'),
(68411, 'Rowan Mills', 35.6480598449707, 0.622176016242718, -80.5055618286133, -1.40508712007717, 218, 33, 'PPL', 'P'),
(68412, 'Rowan Mills (historical)', 35.7386093139648, 0.623756402612598, -80.7033309936523, -1.40853884316602, 218, 33, 'PPL', 'P'),
(105921, 'Rowanta', 37.0422210693359, 0.646508719911527, -77.4447174072266, -1.35166530703267, 218, 53, 'PPL', 'P'),
(114008, 'Rowayton', 41.0638885498047, 0.716700058866091, -73.4369430541992, -1.28171644889536, 218, 8, 'PPL', 'P'),
(97668, 'Rowden', 32.2038917541504, 0.562063943065777, -99.3436126708984, -1.73387313193314, 218, 51, 'PPL', 'P'),
(157453, 'Rowdyville (historical)', 40.0952796936035, 0.699794645161405, -84.3430633544922, -1.47206415675406, 218, 41, 'PPL', 'P'),
(105922, 'Rowe', 37.1361083984375, 0.648147362930253, -82.0327835083008, -1.43174216679555, 218, 53, 'PPL', 'P'),
(121306, 'Rowe', 40.9322204589844, 0.714402017161462, -88.6697235107422, -1.54757862209548, 218, 18, 'PPL', 'P'),
(125991, 'Rowe', 42.6933288574219, 0.74513915719872, -72.9000015258789, -1.27234505133548, 218, 23, 'PPL', 'P'),
(189391, 'Rowe', 35.4916687011719, 0.619446475862469, -105.67472076416, -1.84437181346021, 218, 38, 'PPL', 'P'),
(128697, 'Rowe Corner', 44.0533294677734, 0.768875645678488, -70.2272186279297, -1.22569618957527, 218, 26, 'PPL', 'P'),
(105923, 'Rowe Crossroads', 36.8491706848145, 0.643139355079386, -81.1600036621094, -1.41650928483446, 218, 53, 'PPL', 'P'),
(205623, 'Rowe Hills Condominium', 40.5999984741211, 0.708603649678087, -111.792778015137, -1.95115205631527, 218, 52, 'PPL', 'P'),
(11707, 'Rowell', 33.8861083984375, 0.591424162240437, -92.0183334350586, -1.60602289063976, 218, 4, 'PPL', 'P'),
(83401, 'Rowell', 34.7938919067383, 0.607267973355591, -80.9208297729492, -1.41233491298382, 218, 48, 'PPL', 'P'),
(121307, 'Rowell', 40.0719413757324, 0.699387314672677, -89.0294418334961, -1.55385689120728, 218, 18, 'PPL', 'P'),
(5567, 'Rowells Crossroads', 32.6861114501953, 0.570480264479727, -85.5772171020508, -1.49360420312479, 218, 2, 'PPL', 'P'),
(184685, 'Rowen', 35.2408294677734, 0.615068505346487, -118.575828552246, -2.069538621517, 218, 6, 'PPL', 'P'),
(24549, 'Rowena', 31.3808307647705, 0.547698818856376, -84.7130584716797, -1.47852178976529, 218, 13, 'PPL', 'P'),
(38023, 'Rowena', 36.8777809143066, 0.643638697783776, -85.1063919067383, -1.48538675326524, 218, 21, 'PPL', 'P'),
(57291, 'Rowena', 39.3258285522461, 0.686365189311489, -92.057502746582, -1.60670652409158, 218, 29, 'PPL', 'P'),
(137845, 'Rowena', 44.389720916748, 0.774746784038649, -95.1519393920898, -1.66071463205006, 218, 28, 'PPL', 'P'),
(166699, 'Rowena', 40.1188888549805, 0.700206702761067, -78.9238891601563, -1.37748172432379, 218, 45, 'PPL', 'P'),
(171235, 'Rowena', 43.5202789306641, 0.759572158726405, -96.5555572509766, -1.68521238512743, 218, 49, 'PPL', 'P'),
(192144, 'Rowena', 31.6469402313232, 0.552343305218446, -100.045829772949, -1.74612913242773, 218, 51, 'PPL', 'P'),
(194407, 'Rowena', 40.0769386291504, 0.699474533198377, -105.388893127441, -1.83938318010628, 218, 7, 'PPL', 'P'),
(201508, 'Rowena', 45.6725006103516, 0.797135513269755, -121.267219543457, -2.11651225577214, 218, 43, 'PPL', 'P'),
(166700, 'Rowenna', 40.0652809143066, 0.699271067691095, -76.6116714477539, -1.33712591221944, 218, 45, 'PPL', 'P'),
(157454, 'Rowenton', 41.6802787780762, 0.727458097826548, -80.7227783203125, -1.40887826304695, 218, 41, 'PPL', 'P'),
(184686, 'Rowes (historical)', 39.4808311462402, 0.689070494925819, -123.405830383301, -2.15383805634625, 218, 6, 'PPL', 'P'),
(68415, 'Rowes Corner', 35.1722183227539, 0.613871014962333, -77.0052795410156, -1.34399566940935, 218, 33, 'PPL', 'P'),
(132921, 'Rowes Corner', 42.1916694641113, 0.736383549061894, -84.0327835083008, -1.46664875183544, 218, 27, 'PPL', 'P'),
(144389, 'Rowes Corner', 42.875560760498, 0.748319703909575, -71.0258331298828, -1.23963464208852, 218, 36, 'PPL', 'P'),
(105924, 'Rowes Haven', 37.2983283996582, 0.650978636064143, -76.4377822875977, -1.33409097384118, 218, 53, 'PPL', 'P'),
(42882, 'Rowes Landing', 30.9233303070068, 0.539713929539018, -91.561393737793, -1.5980477884394, 218, 22, 'PPL', 'P'),
(166701, 'Rowes Run', 40.0094413757324, 0.698296483890181, -79.8172225952148, -1.39307333408371, 218, 45, 'PPL', 'P'),
(83402, 'Rowesville', 33.3697204589844, 0.582411492479391, -80.8372192382813, -1.41087563386451, 218, 48, 'PPL', 'P'),
(24550, 'Rowland', 32.4363899230957, 0.56612180161873, -83.1686096191406, -1.45156607215983, 218, 13, 'PPL', 'P'),
(38024, 'Rowland', 37.5227813720703, 0.654896079448622, -84.6316680908203, -1.47710125963984, 218, 21, 'PPL', 'P'),
(57292, 'Rowland', 37.5986099243164, 0.656219537352337, -93.8158264160156, -1.63739506143894, 218, 29, 'PPL', 'P'),
(68414, 'Rowland', 34.5363883972168, 0.602773689279, -79.2916717529297, -1.38390074149921, 218, 33, 'PPL', 'P'),
(83403, 'Rowland', 33.5483283996582, 0.585528789114356, -80.2263870239258, -1.40021460054676, 218, 48, 'PPL', 'P'),
(90510, 'Rowland', 35.7458305358887, 0.623882436711186, -85.6827774047852, -1.4954465779669, 218, 50, 'PPL', 'P'),
(97669, 'Rowland', 33.9461097717285, 0.592471383760083, -97.6875, -1.70496851304196, 218, 51, 'PPL', 'P'),
(137846, 'Rowland', 44.860279083252, 0.78295957336629, -93.4252777099609, -1.63057870062889, 218, 28, 'PPL', 'P'),
(166702, 'Rowland', 41.4711112976074, 0.723807436604268, -75.0425033569336, -1.30973876251739, 218, 45, 'PPL', 'P'),
(184687, 'Rowland', 34.0016708374023, 0.593441107292008, -117.928886413574, -2.05824735112728, 218, 6, 'PPL', 'P'),
(200176, 'Rowland', 41.9366683959961, 0.731932940827181, -115.677780151367, -2.0189581350395, 218, 39, 'PPL', 'P'),
(74154, 'Rowland (historical)', 39.7444381713867, 0.693671305446013, -81.7716674804688, -1.42718483238016, 218, 41, 'PPL', 'P'),
(90511, 'Rowland Estates', 35.9263916015625, 0.627033821808104, -86.3861083984375, -1.50772201953746, 218, 50, 'PPL', 'P'),
(184688, 'Rowland Heights', 33.9761085510254, 0.592994961230393, -117.904441833496, -2.05782071272065, 218, 6, 'PPL', 'P'),
(51084, 'Rowland Hill', 39.7138900756836, 0.693138140595779, -77.4775009155273, -1.35223748719287, 218, 25, 'PPL', 'P'),
(146233, 'Rowland Mills', 40.5566711425781, 0.707847445086559, -74.8541717529297, -1.30645175594196, 218, 37, 'PPL', 'P'),
(24551, 'Rowland Spring', 34.2194404602051, 0.597241904220742, -84.7399978637695, -1.47899197085574, 218, 13, 'PPL', 'P'),
(61615, 'Rowlands', 30.6944408416748, 0.535719054745845, -89.4719390869141, -1.56157992521046, 218, 30, 'PPL', 'P'),
(51085, 'Rowlandsville', 39.6611099243164, 0.69221695317472, -76.147216796875, -1.3290196493354, 218, 25, 'PPL', 'P'),
(51086, 'Rowlandsville Heights', 39.6611099243164, 0.69221695317472, -76.1333312988281, -1.3287773016762, 218, 25, 'PPL', 'P'),
(38025, 'Rowlandtown', 37.0916709899902, 0.647371783841794, -88.6333312988281, -1.54694345817549, 218, 21, 'PPL', 'P'),
(111220, 'Rowlesburg', 39.348331451416, 0.686757938993249, -79.6711120605469, -1.39052322418191, 218, 58, 'PPL', 'P'),
(74146, 'Rowlesville', 39.0097198486328, 0.680848051639227, -82.2841720581055, -1.43612972469146, 218, 41, 'PPL', 'P'),
(97670, 'Rowlett', 32.9027786254883, 0.574261820069585, -96.563606262207, -1.68535286687493, 218, 51, 'PPL', 'P'),
(11710, 'Rowlett (historical)', 35.3141708374023, 0.616348553724434, -92.304443359375, -1.61101645084171, 218, 4, 'PPL', 'P'),
(38027, 'Rowletts', 37.2408294677734, 0.649975090386374, -85.894172668457, -1.4991361213411, 218, 21, 'PPL', 'P'),
(117618, 'Rowley', 42.3699989318848, 0.73949598542787, -91.8438873291016, -1.60297823172352, 218, 16, 'PPL', 'P'),
(125993, 'Rowley', 42.7166709899902, 0.745546554266475, -70.8791732788086, -1.23707494480679, 218, 23, 'PPL', 'P'),
(197440, 'Rowley', 45.726390838623, 0.798076075187743, -107.774719238281, -1.88102370112048, 218, 31, 'PPL', 'P'),
(113072, 'Rowley Shore', 42.6761093139648, 0.744838619469705, -70.6616668701172, -1.23327874183094, 218, 23, 'PPL', 'P'),
(176189, 'Rowleys Bay', 45.2197189331055, 0.789232982209108, -87.0352783203125, -1.51905217207909, 218, 57, 'PPL', 'P'),
(192763, 'Rowleys Trailer Park', 37.8763885498047, 0.661067688958772, -109.341667175293, -1.90837210182867, 218, 52, 'PPL', 'P'),
(179025, 'Rowood', 32.3683280944824, 0.564933898614501, -112.845283508301, -1.96952174256631, 218, 5, 'PPL', 'P'),
(157457, 'Rowsburg', 40.8586082458496, 0.71311724167258, -82.1558303833008, -1.43388973989859, 218, 41, 'PPL', 'P'),
(166703, 'Rowtown', 40.7580604553223, 0.711362351672273, -80.4697189331055, -1.40446154353711, 218, 45, 'PPL', 'P'),
(190687, 'Rox', 36.8808288574219, 0.64369189442655, -114.666389465332, -2.00130603754418, 218, 39, 'PPL', 'P'),
(74147, 'Roxabell', 39.3847198486328, 0.687393036334205, -83.1877822875977, -1.4519006983508, 218, 41, 'PPL', 'P'),
(111221, 'Roxalana', 38.6930618286133, 0.67532132658704, -81.2622222900391, -1.41829333644871, 218, 58, 'PPL', 'P'),
(111222, 'Roxalia', 37.6022186279297, 0.656282521112118, -80.3499984741211, -1.40237202734583, 218, 58, 'PPL', 'P'),
(5569, 'Roxana', 32.1830596923828, 0.561700354997954, -86.2716674804688, -1.5057246487199, 218, 2, 'PPL', 'P'),
(14530, 'Roxana', 38.4963912963867, 0.671888778258037, -75.1699981689453, -1.3119639667662, 218, 10, 'PPL', 'P'),
(24553, 'Roxana', 33.9991683959961, 0.593397431450131, -84.7627792358398, -1.47938958080649, 218, 13, 'PPL', 'P'),
(28475, 'Roxana', 38.848331451416, 0.678031292733277, -90.0761108398438, -1.57212471154663, 218, 18, 'PPL', 'P'),
(38026, 'Roxana', 37.1111106872559, 0.64771107056467, -82.9499969482422, -1.44775056126607, 218, 21, 'PPL', 'P'),
(42883, 'Roxana', 31.1186103820801, 0.543122209812588, -92.2586135864258, -1.6102165704083, 218, 22, 'PPL', 'P'),
(68417, 'Roxana', 35.8844413757324, 0.626301652245414, -79.9430618286133, -1.3952696430347, 218, 33, 'PPL', 'P'),
(77143, 'Roxana', 36.101390838623, 0.630088134683289, -97.6569366455078, -1.70443508187562, 218, 42, 'PPL', 'P'),
(74148, 'Roxanna', 39.5825004577637, 0.690844959160139, -84.01611328125, -1.46635780148635, 218, 41, 'PPL', 'P'),
(68418, 'Roxboro', 36.3936080932617, 0.635188287907873, -78.9830627441406, -1.37851449819452, 218, 33, 'PPL', 'P'),
(208619, 'Roxboro', 46.9524993896484, 0.819475706389993, -118.853332519531, -2.07438197943347, 218, 56, 'PPL', 'P'),
(113339, 'Roxborough', 40.0380592346191, 0.698795959752625, -75.2227783203125, -1.31288515418726, 218, 45, 'PPL', 'P'),
(205621, 'Roxborough', 40.6730613708496, 0.709878837787044, -111.961387634277, -1.9540948493198, 218, 52, 'PPL', 'P'),
(187287, 'Roxborough Park', 39.4738883972168, 0.68894932109622, -105.084716796875, -1.83407430163126, 218, 7, 'PPL', 'P'),
(146234, 'Roxburg', 40.7799987792969, 0.711745247657999, -75.0999984741211, -1.31074224161613, 218, 37, 'PPL', 'P'),
(33833, 'Roxbury', 38.5508308410645, 0.67283892755595, -97.4300003051758, -1.7004742955444, 218, 20, 'PPL', 'P'),
(51099, 'Roxbury', 39.2625007629395, 0.685259910880079, -77.0491714477539, -1.34476172769691, 218, 25, 'PPL', 'P'),
(74149, 'Roxbury', 39.5227813720703, 0.689802664488509, -81.7483291625977, -1.42677750189143, 218, 41, 'PPL', 'P'),
(105925, 'Roxbury', 37.4647216796875, 0.653882746653847, -77.14111328125, -1.34636641541174, 218, 53, 'PPL', 'P'),
(114010, 'Roxbury', 41.5563888549805, 0.725295810758486, -73.3091735839844, -1.27948645095658, 218, 8, 'PPL', 'P'),
(121308, 'Roxbury', 41.7005615234375, 0.727812098514447, -89.039436340332, -1.55403132825868, 218, 18, 'PPL', 'P'),
(125994, 'Roxbury', 42.3250007629395, 0.738710619222405, -71.095832824707, -1.2408563672386, 218, 23, 'PPL', 'P'),
(128698, 'Roxbury', 44.6697196960449, 0.779633684638945, -70.5938873291016, -1.23209576567473, 218, 26, 'PPL', 'P'),
(166706, 'Roxbury', 40.110279083252, 0.700056433896559, -77.6622161865234, -1.35546137685047, 218, 45, 'PPL', 'P'),
(172470, 'Roxbury', 44.0941696166992, 0.769588440744247, -72.7333297729492, -1.26943608047678, 218, 55, 'PPL', 'P'),
(176190, 'Roxbury', 43.249439239502, 0.754845114370541, -89.6752777099609, -1.5651288536791, 218, 57, 'PPL', 'P'),
(177391, 'Roxbury', 42.2838897705078, 0.737993097045711, -74.5652770996094, -1.30140959305011, 218, 40, 'PPL', 'P'),
(144390, 'Roxbury Center', 42.9555587768555, 0.749715932690076, -72.206672668457, -1.26024417997438, 218, 36, 'PPL', 'P'),
(125995, 'Roxbury Crossing', 42.3305587768555, 0.738807624865112, -71.091667175293, -1.24078366294084, 218, 23, 'PPL', 'P'),
(114011, 'Roxbury Falls', 41.5083312988281, 0.724457048173165, -73.3111114501953, -1.27952027310242, 218, 8, 'PPL', 'P'),
(51088, 'Roxbury Hill', 39.5544395446777, 0.690355203835673, -77.6944427490234, -1.35602383647269, 218, 25, 'PPL', 'P'),
(51089, 'Roxbury Mills', 39.2580604553223, 0.685182412892358, -77.0536117553711, -1.34483922568463, 218, 25, 'PPL', 'P'),
(114012, 'Roxbury Station', 41.5574989318848, 0.725315185255416, -73.331672668457, -1.27987913405931, 218, 8, 'PPL', 'P'),
(14531, 'Roxford', 38.5499992370605, 0.672824413328009, -75.1305618286133, -1.31127567278247, 218, 10, 'PPL', 'P'),
(61621, 'Roxie', 31.5044403076172, 0.549856212365935, -91.0688934326172, -1.58945203654701, 218, 30, 'PPL', 'P'),
(117619, 'Roxie', 42.8480606079102, 0.747839735702115, -92.4175033569336, -1.6129897200514, 218, 16, 'PPL', 'P'),
(57293, 'Roxie (historical)', 36.7291717529297, 0.64104497861912, -90.5061111450195, -1.57962963265653, 218, 29, 'PPL', 'P'),
(68420, 'Roxobel', 36.2027816772461, 0.631857738648619, -77.2455596923828, -1.3481893491779, 218, 33, 'PPL', 'P'),
(11711, 'Roxton', 36.0369415283203, 0.628963282017867, -93.7980575561523, -1.63708493633, 218, 4, 'PPL', 'P'),
(97671, 'Roxton', 33.5461082458496, 0.585490040120495, -95.7255630493164, -1.67072625353599, 218, 51, 'PPL', 'P'),
(11713, 'Roy', 34.0083312988281, 0.59355735427359, -93.6969375610352, -1.63532005947561, 218, 4, 'PPL', 'P'),
(17863, 'Roy', 29.6172199249268, 0.51691800297724, -81.4888916015625, -1.42224946224802, 218, 12, 'PPL', 'P'),
(24554, 'Roy', 34.6549987792969, 0.604843830973346, -84.3533325195313, -1.47224338749542, 218, 13, 'PPL', 'P'),
(42884, 'Roy', 32.2238883972168, 0.562412950326632, -93.1519393920898, -1.62580804701017, 218, 22, 'PPL', 'P'),
(57294, 'Roy', 36.8902816772461, 0.64385687725608, -92.8036117553711, -1.61972858287374, 218, 29, 'PPL', 'P'),
(61616, 'Roy', 32.1805610656738, 0.561656745735103, -88.7088928222656, -1.5482622555473, 218, 30, 'PPL', 'P'),
(90512, 'Roy', 35.5130615234375, 0.619819851047298, -88.7869415283203, -1.54962446244488, 218, 50, 'PPL', 'P'),
(189392, 'Roy', 35.9438896179199, 0.627339219806109, -104.195556640625, -1.81855552932715, 218, 38, 'PPL', 'P'),
(192145, 'Roy', 34.4663887023926, 0.601551964128927, -102.213333129883, -1.78395920255426, 218, 51, 'PPL', 'P'),
(194408, 'Roy', 40.1097183227539, 0.700046646779553, -104.565002441406, -1.82500357495845, 218, 7, 'PPL', 'P'),
(195565, 'Roy', 42.3638916015625, 0.739389392405239, -112.830276489258, -1.9692598206731, 218, 17, 'PPL', 'P'),
(197441, 'Roy', 47.3313903808594, 0.826088601692769, -108.959167480469, -1.90169622276611, 218, 31, 'PPL', 'P'),
(205622, 'Roy', 41.1616706848145, 0.718406679071641, -112.02555847168, -1.95521484171624, 218, 52, 'PPL', 'P'),
(208621, 'Roy', 47.0044403076172, 0.820382246425056, -122.538612365723, -2.1387022466069, 218, 56, 'PPL', 'P'),
(137847, 'Roy Lake', 47.3252792358398, 0.825981942091111, -95.5513916015625, -1.66768638830972, 218, 28, 'PPL', 'P'),
(195564, 'Roy Summit', 42.3175010681152, 0.738579724854828, -112.801391601563, -1.96875568427875, 218, 17, 'PPL', 'P'),
(5570, 'Roy Webb', 33.920280456543, 0.59202057716656, -85.7272186279297, -1.49622222363439, 218, 2, 'PPL', 'P'),
(197442, 'Roy-Winifred Junction', 47.0888900756836, 0.821856172930361, -109.433891296387, -1.90998171639151, 218, 31, 'PPL', 'P'),
(5571, 'Royal', 34.0719413757324, 0.594667559553017, -86.5022201538086, -1.50974855196896, 218, 2, 'PPL', 'P'),
(11715, 'Royal', 34.5113906860352, 0.602337396913418, -93.2408294677734, -1.6273594715032, 218, 4, 'PPL', 'P'),
(17864, 'Royal', 28.8941707611084, 0.504298414414817, -82.0952835083008, -1.43283299757805, 218, 12, 'PPL', 'P'),
(24555, 'Royal', 32.4455604553223, 0.566281857600244, -83.3788909912109, -1.45523617445807, 218, 13, 'PPL', 'P'),
(38028, 'Royal', 37.4408302307129, 0.653465762206168, -86.0952835083008, -1.50264616765782, 218, 21, 'PPL', 'P'),
(42885, 'Royal', 31.9858303070068, 0.558258052841458, -92.4480590820313, -1.61352301805969, 218, 22, 'PPL', 'P'),
(57295, 'Royal', 38.128059387207, 0.665460173702694, -91.579719543457, -1.59836763408632, 218, 29, 'PPL', 'P'),
(68423, 'Royal', 36.0149993896484, 0.628580319453113, -78.3583297729492, -1.36761085090146, 218, 33, 'PPL', 'P'),
(74150, 'Royal', 39.3058280944824, 0.686016115471607, -82.5730590820313, -1.44117175442525, 218, 41, 'PPL', 'P'),
(111223, 'Royal', 37.8527793884277, 0.66065563135911, -81.0680618286133, -1.41490459711964, 218, 58, 'PPL', 'P'),
(117620, 'Royal', 43.065559387207, 0.751635805519914, -95.2836074829102, -1.66301267375469, 218, 16, 'PPL', 'P'),
(121309, 'Royal', 40.1927795410156, 0.701496338518938, -87.9727783203125, -1.53541463381654, 218, 18, 'PPL', 'P'),
(142902, 'Royal', 42.332218170166, 0.738836586741966, -98.1255569458008, -1.71261404905741, 218, 35, 'PPL', 'P'),
(166707, 'Royal', 41.6669387817383, 0.727225270968248, -75.6177825927734, -1.31977927930115, 218, 45, 'PPL', 'P'),
(192764, 'Royal', 39.7461090087891, 0.693700467059949, -110.879440307617, -1.93521130613643, 218, 52, 'PPL', 'P'),
(201509, 'Royal', 43.8250007629395, 0.76489055800232, -123.129722595215, -2.14901906635376, 218, 43, 'PPL', 'P'),
(51090, 'Royal Acres', 38.7350006103516, 0.676053296412648, -76.1858291625977, -1.32969356224924, 218, 25, 'PPL', 'P'),
(68424, 'Royal Acres', 35.2811088562012, 0.615771513295241, -77.4916687011719, -1.35248476170009, 218, 33, 'PPL', 'P'),
(83404, 'Royal Acres', 34.6902809143066, 0.6054596203964, -82.8769378662109, -1.44647543973614, 218, 48, 'PPL', 'P'),
(105926, 'Royal Acres', 38.0138893127441, 0.66346752999607, -78.3827819824219, -1.36803762246615, 218, 53, 'PPL', 'P'),
(121310, 'Royal Acres Trailer Park', 40.5166702270508, 0.707149297406795, -88.9763870239258, -1.55293091009626, 218, 18, 'PPL', 'P'),
(51092, 'Royal Beach', 39.1063919067383, 0.682535297347846, -76.5427780151367, -1.33592349498727, 218, 25, 'PPL', 'P'),
(90513, 'Royal Blue', 36.3822212219238, 0.634989549511525, -84.2605590820313, -1.47062418555266, 218, 50, 'PPL', 'P'),
(123597, 'Royal Center', 40.8644409179688, 0.713219041005249, -86.4997177124023, -1.50970487612708, 218, 19, 'PPL', 'P'),
(105927, 'Royal City', 37.2597198486328, 0.650304789729326, -82.100830078125, -1.43292980348367, 218, 53, 'PPL', 'P'),
(208622, 'Royal City', 46.9011116027832, 0.818578820313882, -119.629440307617, -2.08792761568594, 218, 56, 'PPL', 'P'),
(128700, 'Royal Corner', 44.0186080932617, 0.76826964337244, -70.2394409179688, -1.22590950877858, 218, 26, 'PPL', 'P'),
(90514, 'Royal Court', 35.8763885498047, 0.626161103918885, -86.4822235107422, -1.5093995447081, 218, 50, 'PPL', 'P'),
(179026, 'Royal Estates West', 33.6083297729492, 0.586576010634002, -112.188888549805, -1.95806548934706, 218, 5, 'PPL', 'P'),
(97678, 'Royal Forest', 29.8476600646973, 0.520939942144991, -98.0869827270508, -1.71194080193384, 218, 51, 'PPL', 'P'),
(211090, 'Royal Gardens', 19.3588905334473, 0.337876379341816, -155.039443969727, -2.705948767733, 218, 15, 'PPL', 'P'),
(179027, 'Royal Glen Mobile Home Park', 33.5430603027344, 0.585436843477721, -112.15193939209, -1.9574206048891, 218, 5, 'PPL', 'P'),
(14532, 'Royal Grant', 39.1122207641602, 0.682637030101487, -75.5261077880859, -1.31817925211823, 218, 10, 'PPL', 'P'),
(17865, 'Royal Harbor', 26.1049995422363, 0.455618193243636, -81.7900009155273, -1.42750481118513, 218, 12, 'PPL', 'P'),
(28476, 'Royal Heights', 38.5441703796387, 0.672722680574368, -90.0136108398438, -1.57103388076413, 218, 18, 'PPL', 'P'),
(51093, 'Royal Heights', 39.4724998474121, 0.688925086330301, -76.2736129760742, -1.33122567882437, 218, 25, 'PPL', 'P'),
(128701, 'Royal Junction', 43.7994384765625, 0.764444411940705, -70.2225036621094, -1.22561389789758, 218, 26, 'PPL', 'P'),
(28477, 'Royal Lake', 39.110279083252, 0.682603141376616, -89.9613876342773, -1.57012241388105, 218, 18, 'PPL', 'P'),
(28478, 'Royal Lake Resort', 38.565559387207, 0.673095989180169, -89.3933334350586, -1.56020799777491, 218, 18, 'PPL', 'P'),
(205627, 'Royal Meadows', 40.6538887023926, 0.709544211596076, -111.950828552246, -1.95391055857237, 218, 52, 'PPL', 'P'),
(51096, 'Royal Oak', 38.3497200012207, 0.669328881239225, -75.7930603027344, -1.32283845244532, 218, 25, 'PPL', 'P'),
(57296, 'Royal Oak', 36.7338905334473, 0.641127336875831, -91.4722213745117, -1.59649143709836, 218, 29, 'PPL', 'P'),
(90515, 'Royal Oak', 35.2000007629395, 0.614355910017809, -84.8008270263672, -1.4800536400243, 218, 50, 'PPL', 'P'),
(132923, 'Royal Oak', 42.4894409179688, 0.741580641350157, -83.1447219848633, -1.45114915429118, 218, 27, 'PPL', 'P'),
(132924, 'Royal Oak Beach', 45.4919395446777, 0.793984128172836, -84.5777816772461, -1.47616076430088, 218, 27, 'PPL', 'P'),
(17866, 'Royal Oak Hills', 26.3452796936035, 0.459811873012184, -80.1005630493164, -1.39801855791188, 218, 12, 'PPL', 'P'),
(24556, 'Royal Oaks', 33.6563911437988, 0.58741483979835, -84.2230606079102, -1.46996971371477, 218, 13, 'PPL', 'P'),
(68431, 'Royal Oaks', 35.4605598449707, 0.618903523895229, -80.6072235107422, -1.40686145115343, 218, 33, 'PPL', 'P'),
(83405, 'Royal Oaks', 34.7722206115723, 0.606889737901772, -82.3797225952148, -1.43779739616607, 218, 48, 'PPL', 'P'),
(90517, 'Royal Oaks', 35.6366691589355, 0.621977211267344, -87.0461120605469, -1.51924125651649, 218, 50, 'PPL', 'P'),
(123598, 'Royal Oaks', 41.1266708374023, 0.717795816496604, -85.0747222900391, -1.48483401418099, 218, 19, 'PPL', 'P'),
(105929, 'Royal Oaks Estates', 37.8708305358887, 0.660970683316066, -78.0327835083008, -1.36192899671578, 218, 53, 'PPL', 'P'),
(17867, 'Royal Palm Beach', 26.7080593109131, 0.466143571793361, -80.230827331543, -1.40029209853448, 218, 12, 'PPL', 'P'),
(17868, 'Royal Palm Estates', 26.6813907623291, 0.465678117813843, -80.1252822875977, -1.39844999000847, 218, 12, 'PPL', 'P'),
(17869, 'Royal Palm Hammock', 25.9938907623291, 0.453678979206382, -81.5919418334961, -1.42404802809021, 218, 12, 'PPL', 'P'),
(17870, 'Royal Palm Isles', 26.1688899993896, 0.456733292081566, -80.1688919067383, -1.39921112144802, 218, 12, 'PPL', 'P'),
(179028, 'Royal Palm Travel Trailer and Mobile Home Park', 33.5699996948242, 0.585907024568174, -112.101669311523, -1.95654322646797, 218, 5, 'PPL', 'P'),
(179029, 'Royal Palm Village', 33.4124984741211, 0.583158109690994, -111.746673583984, -1.9503473821919, 218, 5, 'PPL', 'P'),
(97672, 'Royal Palms Estates Colonia', 26.2070007324219, 0.457398449853327, -98.3779983520508, -1.71701998276484, 218, 51, 'PPL', 'P'),
(17871, 'Royal Palms Park', 26.1519393920898, 0.456437448173972, -80.1838912963867, -1.39947291018317, 218, 12, 'PPL', 'P'),
(42888, 'Royal Pines', 32.514720916748, 0.567488935364323, -92.2138900756836, -1.6094359978928, 218, 22, 'PPL', 'P'),
(68428, 'Royal Pines', 35.4749984741211, 0.619155525513377, -82.51611328125, -1.44017786270643, 218, 33, 'PPL', 'P'),
(90520, 'Royal Pines', 36.4555587768555, 0.636269531310445, -82.4727783203125, -1.43942152495685, 218, 50, 'PPL', 'P'),
(83407, 'Royal Pines Country Club Estates', 32.4638900756836, 0.56660176982619, -80.6369400024414, -1.40738010177573, 218, 48, 'PPL', 'P'),
(83408, 'Royal Pines Estates', 34.1049995422363, 0.595244533403183, -80.851936340332, -1.41113249575165, 218, 48, 'PPL', 'P'),
(17872, 'Royal Poinciana Park', 27.6122207641602, 0.481924166122139, -80.4016723632813, -1.40327390684899, 218, 12, 'PPL', 'P'),
(74151, 'Royal Springs Estates', 39.5786094665527, 0.690777048552342, -84.2422180175781, -1.47030407358963, 218, 41, 'PPL', 'P'),
(17873, 'Royal Terrace', 30.3736095428467, 0.530119492237844, -81.6916732788086, -1.42578867017868, 218, 12, 'PPL', 'P'),
(105930, 'Royal View Estates', 38.8919410705566, 0.678792424172822, -78.2847213745117, -1.36632614199161, 218, 53, 'PPL', 'P'),
(51098, 'Royale Glen', 38.9247207641602, 0.679364537753998, -76.6513900756836, -1.33781913305118, 218, 25, 'PPL', 'P'),
(17874, 'Royals Crossroads', 30.9755592346191, 0.540625496290639, -85.9977798461914, -1.50094440772126, 218, 12, 'PPL', 'P'),
(125996, 'Royalston', 42.6775016784668, 0.744862920814652, -72.1883316040039, -1.25992406801135, 218, 23, 'PPL', 'P'),
(28479, 'Royalton', 37.8769416809082, 0.661077342917724, -89.1144409179688, -1.55534040509251, 218, 18, 'PPL', 'P'),
(31016, 'Royalton', 39.9269409179688, 0.696856579267802, -86.3383331298828, -1.50688818380016, 218, 19, 'PPL', 'P'),
(38029, 'Royalton', 37.6749992370605, 0.657552782373058, -83.0219421386719, -1.44900624172005, 218, 21, 'PPL', 'P'),
(74152, 'Royalton', 39.7275009155273, 0.693375694565014, -82.7666702270508, -1.4445509063744, 218, 41, 'PPL', 'P'),
(137848, 'Royalton', 45.8300018310547, 0.799884428146934, -94.293327331543, -1.64572902459618, 218, 28, 'PPL', 'P'),
(166708, 'Royalton', 40.1872215270996, 0.701399332876232, -76.7302780151367, -1.33919598733476, 218, 45, 'PPL', 'P'),
(172472, 'Royalton', 43.8158302307129, 0.764730502020807, -72.5461120605469, -1.26616851497731, 218, 55, 'PPL', 'P'),
(176192, 'Royalton', 44.4127807617188, 0.775149254258387, -88.8627777099609, -1.55094805350665, 218, 57, 'PPL', 'P'),
(152249, 'Royalton Center', 43.1636085510254, 0.753347086257372, -78.5386123657227, -1.37075737572939, 218, 40, 'PPL', 'P'),
(192146, 'Royalty', 31.3722190856934, 0.547548516702354, -102.866668701172, -1.79536205939365, 218, 51, 'PPL', 'P'),
(90521, 'Royalty Acres', 36.5069389343262, 0.637166284228502, -87.2472229003906, -1.52275130283321, 218, 50, 'PPL', 'P'),
(97673, 'Royalty House Number 2 and 3 Colonia', 26.1679992675781, 0.456717745878703, -98.1119995117188, -1.71237742719456, 218, 51, 'PPL', 'P'),
(61617, 'Royce', 31.062219619751, 0.542138005342236, -88.8052825927734, -1.5499445744079, 218, 30, 'PPL', 'P'),
(189393, 'Royce', 36.4869384765625, 0.636817210388619, -103.312782287598, -1.80314821031466, 218, 38, 'PPL', 'P'),
(146237, 'Royce Valley', 40.5352783203125, 0.70747406990173, -74.6122207641602, -1.30222891455947, 218, 37, 'PPL', 'P'),
(97674, 'Royder', 30.5275001525879, 0.53280539006573, -96.3047180175781, -1.68083441461144, 218, 51, 'PPL', 'P'),
(166710, 'Royer', 40.4219398498535, 0.705495940423046, -78.2736129760742, -1.36613226386425, 218, 45, 'PPL', 'P'),
(166711, 'Royersford', 40.1841697692871, 0.70134606965443, -75.538330078125, -1.31839257132155, 218, 45, 'PPL', 'P'),
(74153, 'Royersville', 38.6105613708496, 0.673881421964661, -82.6772232055664, -1.44298976134339, 218, 41, 'PPL', 'P'),
(123599, 'Royerton', 40.2636108398438, 0.702732577896953, -85.3655624389648, -1.48991013237674, 218, 19, 'PPL', 'P'),
(38030, 'Royrader', 37.2636108398438, 0.650372700337123, -83.9430618286133, -1.46508281311447, 218, 21, 'PPL', 'P'),
(146238, 'Roys', 41.1705589294434, 0.718561808205138, -74.6580581665039, -1.30302892815093, 218, 37, 'PPL', 'P'),
(5574, 'Royse (historical)', 34.190559387207, 0.596737834405418, -86.0708312988281, -1.50221939609314, 218, 2, 'PPL', 'P'),
(97675, 'Royse City', 32.9749984741211, 0.575522294213519, -96.3322219848633, -1.68131444939793, 218, 51, 'PPL', 'P'),
(17875, 'Royster', 27.8880596160889, 0.486738462293217, -81.9458312988281, -1.43022456444837, 218, 12, 'PPL', 'P'),
(24557, 'Royston', 34.2869415283203, 0.598420020107966, -83.1102828979492, -1.45054807883315, 218, 13, 'PPL', 'P'),
(177357, 'Royston', 45.1594390869141, 0.788180900420472, -83.8930587768555, -1.46421009522525, 218, 27, 'PPL', 'P'),
(192147, 'Royston', 32.8116683959961, 0.572671646582698, -100.298057556152, -1.75053133770964, 218, 51, 'PPL', 'P'),
(190688, 'Royston (historical)', 38.3191719055176, 0.668795716388991, -117.508331298828, -2.05090727968886, 218, 39, 'PPL', 'P'),
(197443, 'Royston (historical)', 45.7527809143066, 0.798536668898272, -112.519439697266, -1.9638346952165, 218, 31, 'PPL', 'P'),
(51100, 'Royston Shores', 39.2222213745117, 0.684556902931325, -76.029167175293, -1.32695929475806, 218, 25, 'PPL', 'P'),
(166713, 'Roystone', 41.7222213745117, 0.728190134231184, -78.970832824707, -1.37830104583315, 218, 45, 'PPL', 'P'),
(166716, 'Roytown', 40.1005592346191, 0.699886790535121, -79.1338882446289, -1.38114689977401, 218, 45, 'PPL', 'P'),
(38031, 'Royville', 37.0666694641113, 0.646935424897185, -85.105827331543, -1.4853768995692, 218, 21, 'PPL', 'P'),
(105933, 'Royville', 38.9736099243164, 0.680217814567259, -77.5322189331055, -1.35319249675978, 218, 53, 'PPL', 'P'),
(123600, 'Royville', 41.1997184753418, 0.719070738289453, -85.133056640625, -1.48585214066573, 218, 19, 'PPL', 'P'),
(208623, 'Roza', 46.7838897705078, 0.816532913385456, -120.453330993652, -2.10230722083377, 218, 56, 'PPL', 'P'),
(33834, 'Rozel', 38.1958312988281, 0.666643016700853, -99.4027786254883, -1.73490577264581, 218, 20, 'PPL', 'P'),
(205631, 'Rozel', 41.586109161377, 0.725814527959806, -112.64582824707, -1.96604059154741, 218, 52, 'PPL', 'P'),
(90522, 'Rozells Mill', 35.0191688537598, 0.611199797809957, -86.5252838134766, -1.51015108876772, 218, 50, 'PPL', 'P'),
(176194, 'Rozellville', 44.7433280944824, 0.780918393548799, -90.0244369506836, -1.57122283204347, 218, 57, 'PPL', 'P'),
(209711, 'Rozet', 44.2780609130859, 0.772797949331956, -105.205558776855, -1.83618339205655, 218, 59, 'PPL', 'P'),
(121311, 'Rozetta', 40.9416694641113, 0.714566933411965, -90.8636093139648, -1.58586915277447, 218, 18, 'PPL', 'P'),
(68430, 'Rozier Siding', 34.7550010681152, 0.606589200172757, -78.976936340332, -1.37840757227675, 218, 33, 'PPL', 'P'),
(97676, 'Roznov', 29.9841709136963, 0.523322505924717, -96.7080612182617, -1.68787408147891, 218, 51, 'PPL', 'P'),
(97677, 'Rozypal Estates Colonia', 28.0520000457764, 0.489599762568398, -97.9369964599609, -1.70932304774035, 218, 51, 'PPL', 'P'),
(28480, 'Ruark', 38.5916709899902, 0.673551722621709, -87.8311080932617, -1.53294202190246, 218, 18, 'PPL', 'P'),
(105932, 'Ruark', 37.5441703796387, 0.655269388054424, -76.3422164916992, -1.33242303605047, 218, 53, 'PPL', 'P'),
(24558, 'Ruark (historical)', 31.6230602264404, 0.551926520507849, -84.0372161865234, -1.46672611666511, 218, 13, 'PPL', 'P'),
(152251, 'Ruback Camp', 43.0250015258789, 0.750927937302171, -74.0666732788086, -1.29270731471411, 218, 40, 'PPL', 'P'),
(192148, 'Rubboard Crossing', 29.6983299255371, 0.518333639544185, -101.00666809082, -1.76289892465391, 218, 51, 'PPL', 'P'),
(176195, 'Rube', 44.0516700744629, 0.768846683801633, -87.8013916015625, -1.53242337128016, 218, 57, 'PPL', 'P'),
(117622, 'Rubens Siding', 42.8208312988281, 0.747364494605591, -94.579719543457, -1.65072751164615, 218, 16, 'PPL', 'P'),
(105934, 'Rubermont', 37.0625, 0.646862654020398, -78.2063903808594, -1.36495900824602, 218, 53, 'PPL', 'P'),
(38032, 'Rubert Ford', 37.235279083252, 0.649878217901722, -84.9669418334961, -1.48295289034501, 218, 21, 'PPL', 'P'),
(51101, 'Rubert Manor', 39.045280456543, 0.68146870133127, -76.5094375610352, -1.33534159428908, 218, 25, 'PPL', 'P'),
(166714, 'Rubicam', 40.1333312988281, 0.700458770958243, -75.1155624389648, -1.31101388404732, 218, 45, 'PPL', 'P'),
(11716, 'Rubicon', 34.6311111450195, 0.604426913104694, -92.76611328125, -1.61907411103585, 218, 4, 'PPL', 'P'),
(176196, 'Rubicon', 43.3402786254883, 0.756430560746493, -88.4574966430664, -1.54387456449334, 218, 57, 'PPL', 'P'),
(195566, 'Rubicon', 44.9822196960449, 0.785087838551427, -116.367782592773, -2.03100094948884, 218, 17, 'PPL', 'P'),
(184693, 'Rubicon Properties', 39.0138893127441, 0.680920822516013, -120.116668701172, -2.09643135536267, 218, 6, 'PPL', 'P'),
(184694, 'Rubicon Springs (historical)', 39.0175018310547, 0.680983872854821, -120.247779846191, -2.09871967652932, 218, 6, 'PPL', 'P'),
(184695, 'Rubidoux', 33.9961090087891, 0.593344035070275, -117.404716491699, -2.04909886015064, 218, 6, 'PPL', 'P'),
(11717, 'Rubie', 34.5986099243164, 0.603859659792507, -93.5244369506836, -1.63230935586327, 218, 4, 'PPL', 'P'),
(117623, 'Rubio', 41.2211112976074, 0.719444113474282, -91.9375, -1.60461208105229, 218, 16, 'PPL', 'P'),
(11718, 'Ruble', 34.5999984741211, 0.603883894558427, -93.5205612182617, -1.63224171157159, 218, 4, 'PPL', 'P'),
(57301, 'Ruble', 37.1483306884766, 0.648360682133568, -90.896110534668, -1.58643640608666, 218, 29, 'PPL', 'P'),
(61618, 'Ruble', 30.7733306884766, 0.537095942318929, -88.8708267211914, -1.55108853525415, 218, 30, 'PPL', 'P'),
(117624, 'Ruble', 42.8080596923828, 0.747141588022351, -96.4094390869141, -1.68266214206757, 218, 16, 'PPL', 'P'),
(79063, 'Ruble Mill', 39.7816696166992, 0.694321116751992, -79.795280456543, -1.39269037151896, 218, 45, 'PPL', 'P'),
(17876, 'Rubonia', 27.5786094665527, 0.481337538313022, -82.5527801513672, -1.44081782031638, 218, 12, 'PPL', 'P'),
(77142, 'Rubottom', 33.9402809143066, 0.592369651006442, -97.456672668457, -1.70093981610294, 218, 42, 'PPL', 'P'),
(42889, 'Ruby', 31.1891708374023, 0.544353722079668, -92.2486114501953, -1.61004200019885, 218, 22, 'PPL', 'P'),
(61620, 'Ruby', 33.6947212219238, 0.588083825864178, -90.227783203125, -1.57477189367017, 218, 30, 'PPL', 'P'),
(83409, 'Ruby', 34.7449989318848, 0.606414629963302, -80.1830596923828, -1.39945839595523, 218, 48, 'PPL', 'P'),
(105935, 'Ruby', 38.5041694641113, 0.672024532894603, -77.5158309936523, -1.3529064732587, 218, 53, 'PPL', 'P'),
(121313, 'Ruby', 42.3158302307129, 0.738550563240892, -89.0708312988281, -1.55457927365297, 218, 18, 'PPL', 'P'),
(132929, 'Ruby', 43.0422210693359, 0.751228475031187, -82.6074981689453, -1.44177282988328, 218, 27, 'PPL', 'P'),
(142904, 'Ruby', 40.8313903808594, 0.712642200313138, -97.0766677856445, -1.69430747972421, 218, 35, 'PPL', 'P'),
(152252, 'Ruby', 42.0180587768555, 0.733353470952629, -74.0152816772461, -1.29181036205898, 218, 40, 'PPL', 'P'),
(176197, 'Ruby', 45.1772193908691, 0.788491225266494, -90.9880599975586, -1.58804122695954, 218, 57, 'PPL', 'P'),
(179030, 'Ruby', 31.461109161377, 0.54909994119538, -111.236938476563, -1.94145082625438, 218, 5, 'PPL', 'P'),
(187288, 'Ruby', 38.8661117553711, 0.678341617579298, -107.095001220703, -1.86916038372862, 218, 7, 'PPL', 'P'),
(195567, 'Ruby', 42.5038909912109, 0.741832842705387, -113.821937561035, -1.98656757143947, 218, 17, 'PPL', 'P'),
(197444, 'Ruby', 45.3283309936523, 0.791128620273026, -112.085563659668, -1.95626212981491, 218, 31, 'PPL', 'P'),
(208627, 'Ruby', 46.3761100769043, 0.809415815109301, -119.282218933105, -2.08186745946741, 218, 56, 'PPL', 'P'),
(212124, 'Ruby', 64.7394409179688, 1.12991639991889, -155.486938476563, -2.71375902026187, 218, 1, 'PPL', 'P'),
(5575, 'Ruby (historical)', 33.7486114501953, 0.589024387782166, -87.1755599975586, -1.52150054922726, 218, 2, 'PPL', 'P'),
(74155, 'Ruby (historical)', 38.6786117553711, 0.675069125231809, -82.333610534668, -1.43699258888464, 218, 41, 'PPL', 'P'),
(187289, 'Ruby (historical)', 39.0208282470703, 0.681041929766584, -106.608612060547, -1.86067129143788, 218, 7, 'PPL', 'P'),
(208626, 'Ruby (historical)', 48.7374992370605, 0.850629830874931, -121.061111450195, -2.11291499092972, 218, 56, 'PPL', 'P'),
(68432, 'Ruby City', 35.3772201538086, 0.617448971886855, -83.1183319091797, -1.45068856058065, 218, 33, 'PPL', 'P'),
(152253, 'Ruby Corner', 44.452220916748, 0.775837614821146, -75.5966720581055, -1.31941083096434, 218, 40, 'PPL', 'P'),
(90524, 'Ruby Falls', 35.0188903808594, 0.611194937540967, -85.3394393920898, -1.48945419919812, 218, 50, 'PPL', 'P'),
(197445, 'Ruby Gulch (historical)', 47.1119384765625, 0.822258443413017, -109.29638671875, -1.90758180877519, 218, 31, 'PPL', 'P'),
(190691, 'Ruby Hill', 39.5047187805176, 0.689487412794471, -115.985282897949, -2.02432507042628, 218, 39, 'PPL', 'P'),
(190690, 'Ruby Hill (historical)', 39.6666717529297, 0.692314025396454, -114.633331298828, -2.00072906369402, 218, 39, 'PPL', 'P'),
(137851, 'Ruby Junction', 47.435001373291, 0.82789695465196, -92.9191665649414, -1.62174539476726, 218, 28, 'PPL', 'P'),
(200177, 'Ruby Valley', 40.360279083252, 0.704419757026545, -115.446670532227, -2.01492451125247, 218, 39, 'PPL', 'P'),
(68433, 'Rubyatt', 35.2152786254883, 0.614622559021954, -79.7311096191406, -1.39157037912253, 218, 33, 'PPL', 'P'),
(176199, 'Rubys Corner', 45.1788902282715, 0.78852038688043, -87.7397232055664, -1.53134705472561, 218, 57, 'PPL', 'P'),
(74156, 'Rubyville', 38.8250007629395, 0.677624095402604, -82.9300003051758, -1.44740155400522, 218, 41, 'PPL', 'P'),
(201510, 'Ruch', 42.2366714477539, 0.737168981846386, -123.041107177734, -2.14747243555069, 218, 43, 'PPL', 'P'),
(166715, 'Ruchsville', 40.6527786254883, 0.709524837099145, -75.5455627441406, -1.31851880515722, 218, 45, 'PPL', 'P'),
(57298, 'Rucker', 39.2313919067383, 0.684716958912839, -92.413330078125, -1.61291688259559, 218, 29, 'PPL', 'P'),
(90523, 'Rucker', 35.752498626709, 0.623998816850823, -86.3877792358398, -1.5077511811514, 218, 50, 'PPL', 'P'),
(97679, 'Rucker', 32.1650009155273, 0.561385169882943, -98.6025009155273, -1.72093829167668, 218, 51, 'PPL', 'P'),
(184696, 'Rucker', 37.0541687011719, 0.64671724542488, -121.591110229492, -2.12216521466, 218, 6, 'PPL', 'P'),
(83410, 'Rucker Court', 34.4791717529297, 0.601775070449248, -82.7022171020508, -1.44342598712995, 218, 48, 'PPL', 'P'),
(83411, 'Ruckers Crossroads', 34.6402816772461, 0.604586969086208, -81.1419372558594, -1.4161939665614, 218, 48, 'PPL', 'P'),
(11719, 'Ruckers Grove (historical)', 36.0583305358887, 0.629336590623669, -94.1222229003906, -1.64274268890782, 218, 4, 'PPL', 'P'),
(24559, 'Ruckersville', 34.1647186279297, 0.596286828074813, -82.788330078125, -1.44492894209114, 218, 13, 'PPL', 'P'),
(105936, 'Ruckersville', 38.2330589294434, 0.667292761427805, -78.3694381713867, -1.36780472902882, 218, 53, 'PPL', 'P'),
(38034, 'Ruckerville', 37.9336090087891, 0.662066374367552, -84.0944366455078, -1.46772480207389, 218, 21, 'PPL', 'P'),
(111224, 'Ruckman', 39.232780456543, 0.684741193678759, -78.6930618286133, -1.37345302738477, 218, 58, 'PPL', 'P'),
(61622, 'Rucks', 34.0833282470703, 0.594866297949364, -90.5466690063477, -1.58033750087427, 218, 30, 'PPL', 'P'),
(152254, 'Rudco', 41.6500015258789, 0.726929660087249, -73.9416732788086, -1.29052565314912, 218, 40, 'PPL', 'P'),
(11720, 'Rudd', 36.2136116027832, 0.632046756506988, -93.4858322143555, -1.63163557610748, 218, 4, 'PPL', 'P'),
(68434, 'Rudd', 36.165828704834, 0.631212787611629, -79.7430572509766, -1.39177890463588, 218, 33, 'PPL', 'P'),
(117625, 'Rudd', 43.1261100769043, 0.752692614419485, -92.9055633544922, -1.62150797395608, 218, 16, 'PPL', 'P'),
(5576, 'Rudd (historical)', 33.8027801513672, 0.589969809969145, -85.8902816772461, -1.4990682107333, 218, 2, 'PPL', 'P'),
(83412, 'Ruddell (historical)', 32.8486099243164, 0.573316397882607, -81.4069366455078, -1.42081907842654, 218, 48, 'PPL', 'P'),
(11721, 'Ruddell Hill', 35.7758293151855, 0.624406014181496, -91.6797180175781, -1.60011293670671, 218, 4, 'PPL', 'P'),
(11723, 'Ruddells (historical)', 35.9286117553711, 0.627072570801965, -92.091667175293, -1.60730280585965, 218, 4, 'PPL', 'P'),
(38033, 'Ruddels Mills', 38.3041687011719, 0.668533861074809, -84.2380599975586, -1.47023150244992, 218, 21, 'PPL', 'P'),
(24560, 'Rudden', 33.4383316040039, 0.583608982863545, -83.333610534668, -1.45444588140459, 218, 13, 'PPL', 'P'),
(90527, 'Rudderville', 35.8405609130859, 0.625535793694935, -86.7411117553711, -1.51391799697158, 218, 50, 'PPL', 'P'),
(111225, 'Ruddle', 38.7125015258789, 0.675660613309916, -79.3086090087891, -1.38419635238021, 218, 58, 'PPL', 'P'),
(42890, 'Ruddock', 30.2041702270508, 0.527162218294879, -90.4250030517578, -1.57821402937909, 218, 22, 'PPL', 'P'),
(132930, 'Rudds Mill', 42.7677803039551, 0.746438580073597, -83.2183303833008, -1.45243386320103, 218, 27, 'PPL', 'P'),
(171237, 'Rudebusch Corner', 45.4283294677734, 0.79287392289341, -97.154167175293, -1.69566009924186, 218, 49, 'PPL', 'P'),
(105938, 'Rudee Heights', 36.8269386291504, 0.642751332508561, -75.976936340332, -1.32604769471693, 218, 53, 'PPL', 'P'),
(209712, 'Rudefeha (historical)', 41.1888885498047, 0.718881720431084, -107.070281982422, -1.86872895163202, 218, 59, 'PPL', 'P'),
(28481, 'Rudement', 37.6363906860352, 0.656878936038241, -88.4902801513672, -1.54444674465354, 218, 18, 'PPL', 'P'),
(24561, 'Ruden', 34.476390838623, 0.601726534338381, -84.4397201538086, -1.47375113614657, 218, 13, 'PPL', 'P'),
(166723, 'Rudes Corner', 41.7513885498047, 0.728699197473552, -75.3502807617188, -1.31511049159413, 218, 45, 'PPL', 'P'),
(152255, 'Rudeston', 43.4361114501953, 0.758103159069117, -74.5097198486328, -1.30043993609721, 218, 40, 'PPL', 'P'),
(146239, 'Rudeville', 41.1494407653809, 0.718193226710271, -74.5449981689453, -1.30105565894124, 218, 37, 'PPL', 'P'),
(193154, 'Rudo', 46.4891700744629, 0.811389084318995, -116.011390686035, -2.0247807372888, 218, 17, 'PPL', 'P'),
(90525, 'Rudolph', 35.7036094665527, 0.623145540037562, -89.2505569458008, -1.55771607794292, 218, 50, 'PPL', 'P'),
(97680, 'Rudolph', 26.6852798461914, 0.465745995132126, -97.7686080932617, -1.70638411631939, 218, 51, 'PPL', 'P'),
(157456, 'Rudolph', 41.297779083252, 0.720782218763992, -83.6699981689453, -1.46031695318572, 218, 41, 'PPL', 'P'),
(171238, 'Rudolph', 45.3480606079102, 0.791472967001974, -98.5358276367188, -1.71977462343837, 218, 49, 'PPL', 'P'),
(176201, 'Rudolph', 44.4961090087891, 0.77660360652968, -89.807502746582, -1.56743661592171, 218, 57, 'PPL', 'P'),
(90526, 'Rudolphtown', 36.5277786254883, 0.637530005454379, -87.2755584716797, -1.52324585184764, 218, 50, 'PPL', 'P'),
(11724, 'Rudy', 35.5277786254883, 0.620076712934436, -94.2705612182617, -1.64533168096154, 218, 4, 'PPL', 'P'),
(142905, 'Rudy', 40.0644416809082, 0.699256420305099, -97.054443359375, -1.69391959031144, 218, 35, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(195568, 'Rudy', 43.6566696166992, 0.761952625266772, -111.832496643066, -1.95184527714701, 218, 17, 'PPL', 'P'),
(61624, 'Rudyard', 34.3349990844727, 0.599258782693286, -90.5366668701172, -1.58016293066481, 218, 30, 'PPL', 'P'),
(132931, 'Rudyard', 46.2324981689453, 0.806909314470345, -84.6002807617188, -1.47655344740361, 218, 27, 'PPL', 'P'),
(197446, 'Rudyard', 48.560001373291, 0.847531908736896, -110.553329467773, -1.92951959825472, 218, 31, 'PPL', 'P'),
(105939, 'Rue', 37.7872200012207, 0.659511404196757, -75.6063919067383, -1.31958047432578, 218, 53, 'PPL', 'P'),
(187290, 'Ruedi (historical)', 39.3663902282715, 0.687073124108259, -106.797500610352, -1.86396801855129, 218, 7, 'PPL', 'P'),
(33835, 'Ruella', 37.0805587768555, 0.647177839135409, -98.1833267211914, -1.71362232184612, 218, 20, 'PPL', 'P'),
(57299, 'Rueter', 36.6083297729492, 0.638935888193832, -92.8688888549805, -1.62086788318808, 218, 29, 'PPL', 'P'),
(77144, 'Rufe', 34.1236114501953, 0.595569372477145, -95.1438903808594, -1.66057415030256, 218, 42, 'PPL', 'P'),
(105940, 'Ruff', 37.4099998474121, 0.652927670507918, -76.3127822875977, -1.33190931227619, 218, 53, 'PPL', 'P'),
(208628, 'Ruff', 47.1697196960449, 0.823266915938803, -118.997222900391, -2.07689334034141, 218, 56, 'PPL', 'P'),
(79064, 'Ruff Creek', 39.9588890075684, 0.697414178621037, -80.1747207641602, -1.39931285420166, 218, 45, 'PPL', 'P'),
(68435, 'Ruffin', 36.4469413757324, 0.636119129287883, -79.5441665649414, -1.38830760731302, 218, 33, 'PPL', 'P'),
(83413, 'Ruffin', 33.0044403076172, 0.57603615114585, -80.8158264160156, -1.41050225867968, 218, 48, 'PPL', 'P'),
(11726, 'Ruffin (historical)', 35.6708297729492, 0.622573426456385, -90.5716705322266, -1.58077385981888, 218, 4, 'PPL', 'P'),
(121315, 'Ruffled Feathers Golf Community', 41.6591682434082, 0.727089649489736, -87.9599990844727, -1.53519159407525, 218, 18, 'PPL', 'P'),
(5577, 'Ruffner', 33.5494384765625, 0.585548163611286, -86.704719543457, -1.5132828330516, 218, 2, 'PPL', 'P'),
(166717, 'Ruffs Dale', 40.1749992370605, 0.701186013672916, -79.6083297729492, -1.38942746655139, 218, 45, 'PPL', 'P'),
(38036, 'Rufus', 37.2344398498535, 0.649863570515727, -87.8838882446289, -1.53386320932351, 218, 21, 'PPL', 'P'),
(61623, 'Rufus', 32.1780586242676, 0.561613069893226, -89.7805633544922, -1.56696643483125, 218, 30, 'PPL', 'P'),
(68437, 'Rufus', 35.9986114501953, 0.628294295952039, -81.6413879394531, -1.42491102544145, 218, 33, 'PPL', 'P'),
(201512, 'Rufus', 45.6949996948242, 0.797528196372487, -120.734718322754, -2.10721835619998, 218, 43, 'PPL', 'P'),
(31014, 'Rugby', 39.3091697692871, 0.68607443869948, -85.7147216796875, -1.49600411074111, 218, 19, 'PPL', 'P'),
(68438, 'Rugby', 35.3652801513672, 0.617240579531556, -82.5205612182617, -1.44025549385221, 218, 33, 'PPL', 'P'),
(90530, 'Rugby', 36.360279083252, 0.634606586946772, -84.7008285522461, -1.47830833740392, 218, 50, 'PPL', 'P'),
(97681, 'Rugby', 33.4955596923828, 0.584607801430379, -95.2669372558594, -1.6627217234056, 218, 51, 'PPL', 'P'),
(105943, 'Rugby', 37.2869415283203, 0.650779897667796, -79.9563903808594, -1.39550227015592, 218, 53, 'PPL', 'P'),
(121316, 'Rugby', 40.9119415283203, 0.71404808305259, -88.4902801513672, -1.54444674465354, 218, 18, 'PPL', 'P'),
(140812, 'Rugby', 48.3688888549805, 0.844196366050599, -99.9958267211914, -1.74525641453852, 218, 34, 'PPL', 'P'),
(187291, 'Rugby', 37.4700012207031, 0.653974892027564, -104.664436340332, -1.8267390238828, 218, 7, 'PPL', 'P'),
(157464, 'Rugby (historical)', 41.3794403076172, 0.722207476000375, -82.3172225952148, -1.43670656538357, 218, 41, 'PPL', 'P'),
(51102, 'Rugby Hall', 39.0402793884277, 0.681381416226542, -76.5322189331055, -1.33573920423983, 218, 25, 'PPL', 'P'),
(51103, 'Rugby Hall Estates', 39.0424995422363, 0.681420165220403, -76.5272216796875, -1.33565198571413, 218, 25, 'PPL', 'P'),
(176204, 'Rugby Junction', 43.2919387817383, 0.755586871313156, -88.2186126708984, -1.53970525264877, 218, 57, 'PPL', 'P'),
(97682, 'Rugeley', 28.9602794647217, 0.505452228957094, -95.8227767944336, -1.67242295346648, 218, 51, 'PPL', 'P'),
(184697, 'Rugg (historical)', 36.7316703796387, 0.64108858788197, -120.004173278809, -2.09446793984901, 218, 6, 'PPL', 'P'),
(68439, 'Ruggles', 36.2788887023926, 0.633186056821324, -77.5977783203125, -1.35433672392213, 218, 33, 'PPL', 'P'),
(157458, 'Ruggles', 41.0294418334961, 0.716098850250006, -82.3925018310547, -1.43802043590736, 218, 41, 'PPL', 'P'),
(166719, 'Ruggles', 41.3883285522461, 0.722362605133872, -76.0561065673828, -1.32742947584851, 218, 45, 'PPL', 'P'),
(157459, 'Ruggles Beach', 41.3819389343262, 0.722251085263225, -82.4752807617188, -1.43946520079873, 218, 41, 'PPL', 'P'),
(201511, 'Ruggs', 45.2636108398438, 0.789999040496669, -119.685562133789, -2.08890712633487, 218, 43, 'PPL', 'P'),
(38035, 'Rugless', 38.4894409179688, 0.671767471270383, -83.210563659668, -1.45229830830155, 218, 21, 'PPL', 'P'),
(51104, 'Ruhl', 39.7077789306641, 0.693031480994121, -76.7344436645508, -1.33926869163251, 218, 25, 'PPL', 'P'),
(192149, 'Ruidosa', 29.982780456543, 0.523298237869283, -104.678886413574, -1.82699122523803, 218, 51, 'PPL', 'P'),
(189394, 'Ruidoso', 33.3316688537598, 0.581747366682552, -105.672500610352, -1.84433306446635, 218, 38, 'PPL', 'P'),
(189395, 'Ruidoso Downs', 33.3288917541504, 0.581698897150713, -105.603889465332, -1.8431355740822, 218, 38, 'PPL', 'P'),
(128702, 'Ruin Corner', 43.7574996948242, 0.763712442115097, -70.6930618286133, -1.23382668722523, 218, 26, 'PPL', 'P'),
(11727, 'Rule', 36.2777786254883, 0.633166682324393, -93.459716796875, -1.63117977608692, 218, 4, 'PPL', 'P'),
(97683, 'Rule', 33.184440612793, 0.579177749125762, -99.8933334350586, -1.74346756923431, 218, 51, 'PPL', 'P'),
(90529, 'Rule (historical)', 36.3133316040039, 0.633787198858382, -83.9219436645508, -1.46471423161961, 218, 50, 'PPL', 'P'),
(166720, 'Rule Corners', 41.1527786254883, 0.718251483359117, -75.9641723632813, -1.32582492129174, 218, 45, 'PPL', 'P'),
(187878, 'Ruleton', 39.3394393920898, 0.686602743280724, -101.888893127441, -1.77829665628648, 218, 20, 'PPL', 'P'),
(61625, 'Ruleville', 33.725830078125, 0.588626777831418, -90.5513916015625, -1.58041992571001, 218, 30, 'PPL', 'P'),
(97684, 'Ruliff', 30.273889541626, 0.52837904988645, -93.7324981689453, -1.63594070916765, 218, 51, 'PPL', 'P'),
(187292, 'Rulison', 39.4972190856934, 0.689356518426893, -107.940002441406, -1.88390843721326, 218, 7, 'PPL', 'P'),
(142906, 'Rulo', 40.0519409179688, 0.699038240832795, -95.4266662597656, -1.66550952043469, 218, 35, 'PPL', 'P'),
(208629, 'Rulo', 46.1744384765625, 0.80589598167557, -118.501388549805, -2.0682393983792, 218, 56, 'PPL', 'P'),
(71346, 'Rulon Road', 39.7597198486328, 0.693938021029184, -75.2969436645508, -1.3141795836351, 218, 37, 'PPL', 'P'),
(57300, 'Rum Branch', 37.1575012207031, 0.648520738115082, -89.8525009155273, -1.56822198212717, 218, 29, 'PPL', 'P'),
(24562, 'Rum Bridge Estates', 33.5111083984375, 0.584879177545458, -84.2630615234375, -1.47066786139453, 218, 13, 'PPL', 'P'),
(42891, 'Rum Center', 32.9900016784668, 0.575784149527701, -92.6516723632813, -1.61707674021829, 218, 22, 'PPL', 'P'),
(111226, 'Rum Junction', 37.8158302307129, 0.660010746901147, -81.9355621337891, -1.43004533370701, 218, 58, 'PPL', 'P'),
(51105, 'Rum Ridge Estates', 38.4197196960449, 0.670550606389299, -75.5447235107422, -1.31850415777122, 218, 25, 'PPL', 'P'),
(28483, 'Ruma', 38.1349983215332, 0.665581280953266, -89.9977798461914, -1.57075757780104, 218, 18, 'PPL', 'P'),
(166721, 'Rumbels', 41.0308303833008, 0.716123085015926, -75.9850006103516, -1.32618844278054, 218, 45, 'PPL', 'P'),
(31015, 'Rumble', 38.4358291625977, 0.670831769621384, -87.3427810668945, -1.52441910746588, 218, 19, 'PPL', 'P'),
(111227, 'Rumble', 38.1833305358887, 0.666424837228548, -81.6994400024414, -1.42592422507817, 218, 58, 'PPL', 'P'),
(197448, 'Rumble Creek (historical)', 47.5622215270996, 0.830117365210814, -109.498611450195, -1.91111129616787, 218, 31, 'PPL', 'P'),
(51106, 'Rumbley', 38.0933303833008, 0.664854038238592, -75.8586120605469, -1.32398254644962, 218, 25, 'PPL', 'P'),
(132933, 'Rumely', 46.348331451416, 0.808930986632852, -87.0330581665039, -1.51901342308523, 218, 27, 'PPL', 'P'),
(105944, 'Rumford', 37.7247200012207, 0.658420573414261, -77.0897216796875, -1.3454694627566, 218, 53, 'PPL', 'P'),
(128703, 'Rumford', 44.5536117553711, 0.777607218786476, -70.5513916015625, -1.23135407531114, 218, 26, 'PPL', 'P'),
(169585, 'Rumford', 41.8452796936035, 0.730337907071305, -71.3525009155273, -1.24533607050822, 218, 47, 'PPL', 'P'),
(202583, 'Rumford', 43.1266708374023, 0.752702401536491, -103.69750213623, -1.80986283837108, 218, 49, 'PPL', 'P'),
(128704, 'Rumford Center', 44.5130615234375, 0.776899483726787, -70.6191711425781, -1.23253705146735, 218, 26, 'PPL', 'P'),
(128705, 'Rumford Corner', 44.4947204589844, 0.77657937176376, -70.6736068725586, -1.23348713418624, 218, 26, 'PPL', 'P'),
(128706, 'Rumford Junction', 44.0541687011719, 0.768890293064483, -70.2502822875977, -1.22609872637403, 218, 26, 'PPL', 'P'),
(128707, 'Rumford Point', 44.500560760498, 0.776681304254483, -70.6716690063477, -1.2334533120404, 218, 26, 'PPL', 'P'),
(11728, 'Rumley', 35.788890838623, 0.624633980770807, -92.5136108398438, -1.61466711206399, 218, 4, 'PPL', 'P'),
(97685, 'Rumley', 31.172779083252, 0.544067631999566, -98.0677795410156, -1.71160564311066, 218, 51, 'PPL', 'P'),
(157461, 'Rumley', 40.4136085510254, 0.705350531827528, -84.2433319091797, -1.47032351466559, 218, 41, 'PPL', 'P'),
(166722, 'Rummel', 40.2177810668945, 0.701932697463547, -78.8083267211914, -1.37546477927222, 218, 45, 'PPL', 'P'),
(166724, 'Rummerfield', 41.7438888549805, 0.728568303105975, -76.3069381713867, -1.33180731320644, 218, 45, 'PPL', 'P'),
(144392, 'Rumney', 43.8052787780762, 0.764546344431428, -71.8130569458008, -1.25337428962641, 218, 36, 'PPL', 'P'),
(144393, 'Rumney Depot', 43.7933311462402, 0.764337818918074, -71.8052825927734, -1.25323860156887, 218, 36, 'PPL', 'P'),
(121317, 'Rumpler', 40.1133308410645, 0.700109697118361, -87.9211120605469, -1.53451288747144, 218, 18, 'PPL', 'P'),
(171239, 'Rumpus Ridge', 43.5805587768555, 0.760624240515041, -97.1883316040039, -1.69625638100993, 218, 49, 'PPL', 'P'),
(38037, 'Rumsey', 37.5319404602051, 0.655055935693054, -87.258056640625, -1.52294038727061, 218, 21, 'PPL', 'P'),
(142909, 'Rumsey', 41.146671295166, 0.718144890336487, -95.9933319091797, -1.67539970177492, 218, 35, 'PPL', 'P'),
(184698, 'Rumsey', 38.8883285522461, 0.678729373834014, -122.236389160156, -2.13342745659383, 218, 6, 'PPL', 'P'),
(197447, 'Rumsey', 46.2919387817383, 0.807946748872986, -113.251106262207, -1.97660468580148, 218, 31, 'PPL', 'P'),
(152256, 'Rumsey Ridge', 43.1661109924316, 0.753390762099249, -79.0175018310547, -1.37911557365255, 218, 40, 'PPL', 'P'),
(57302, 'Rumsey Spur (historical)', 36.9500007629395, 0.64489917192771, -89.2561111450195, -1.5578130170066, 218, 29, 'PPL', 'P'),
(146241, 'Rumson', 40.371940612793, 0.704623289112854, -73.9994430541992, -1.29153392593783, 218, 37, 'PPL', 'P'),
(111228, 'Runa', 38.1427803039551, 0.66571710216886, -80.8513870239258, -1.41112290837172, 218, 58, 'PPL', 'P'),
(97686, 'Runaway Bay', 33.167781829834, 0.578886998513753, -97.878059387207, -1.70829440176931, 218, 51, 'PPL', 'P'),
(105945, 'Runaway Village', 37.3566703796387, 0.651996895706935, -79.9069366455078, -1.39463913964662, 218, 53, 'PPL', 'P'),
(51107, 'Rundelac Farm', 38.9488906860352, 0.679786382470666, -76.5180587768555, -1.33549206289067, 218, 25, 'PPL', 'P'),
(166725, 'Rundell', 41.7586097717285, 0.72882523157214, -80.2844390869141, -1.40122780018348, 218, 45, 'PPL', 'P'),
(97689, 'Runge', 28.8830604553223, 0.504104502997946, -97.7127838134766, -1.70540979883459, 218, 51, 'PPL', 'P'),
(68440, 'Runion', 35.8858299255371, 0.626325887011334, -82.7733306884766, -1.44466715335598, 218, 33, 'PPL', 'P'),
(111229, 'Runkle (historical)', 39.0355606079102, 0.681299057969831, -81.7750015258789, -1.42724302244997, 218, 58, 'PPL', 'P'),
(97687, 'Runn', 26.077449798584, 0.455137359508823, -98.0603485107422, -1.71147594716557, 218, 51, 'PPL', 'P'),
(97688, 'Runn Colonia', 26.0790004730225, 0.455164423883401, -98.0749969482422, -1.71173161063022, 218, 51, 'PPL', 'P'),
(117627, 'Runnells', 41.5111083984375, 0.724505517705004, -93.3572235107422, -1.62939093078271, 218, 16, 'PPL', 'P'),
(61626, 'Runnelstown', 31.375560760498, 0.547606839930227, -89.1116714477539, -1.55529206871873, 218, 30, 'PPL', 'P'),
(71350, 'Runnemede', 39.8522186279297, 0.69555242928199, -75.0683288574219, -1.31018950253188, 218, 37, 'PPL', 'P'),
(51108, 'Running Brook', 39.232780456543, 0.684741193678759, -76.8602828979492, -1.3414650005835, 218, 25, 'PPL', 'P'),
(51109, 'Running Brook Acres', 39.226390838623, 0.684629673808112, -77.2624969482422, -1.3484849600589, 218, 25, 'PPL', 'P'),
(51110, 'Running Brook Park', 39.6172218322754, 0.691450961466186, -76.0763931274414, -1.32778354311544, 218, 25, 'PPL', 'P'),
(105946, 'Running Deer', 37.9930610656738, 0.663104008507274, -78.3652801513672, -1.36773215788912, 218, 53, 'PPL', 'P'),
(11729, 'Running Lake (historical)', 36.2994384765625, 0.63354471804113, -90.897216796875, -1.58645571400456, 218, 4, 'PPL', 'P'),
(184699, 'Running Springs', 34.2077789306641, 0.597038372134433, -117.108329772949, -2.04392593604927, 218, 6, 'PPL', 'P'),
(105947, 'Running Still', 37.7841682434082, 0.659458140974955, -77.9286117553711, -1.36011085663958, 218, 53, 'PPL', 'P'),
(14540, 'Runnymeade', 39.771671295166, 0.694146613121564, -75.6916732788086, -1.32106891505902, 218, 10, 'PPL', 'P'),
(24563, 'Runnymeade', 30.9605598449707, 0.540363707555484, -81.7099990844727, -1.4261085158256, 218, 13, 'PPL', 'P'),
(83414, 'Runnymeade', 33.9597206115723, 0.592708937729318, -80.3391723632813, -1.40218307606649, 218, 48, 'PPL', 'P'),
(184700, 'Runnymeade (historical)', 37.4677810668945, 0.653936143033703, -122.133888244629, -2.13163847813157, 218, 6, 'PPL', 'P'),
(51111, 'Runnymeade Estates', 39.2874984741211, 0.685696203245661, -76.0313873291016, -1.32699804375192, 218, 25, 'PPL', 'P'),
(51112, 'Runnymeade Summit', 39.6525001525879, 0.692066684310213, -77.101936340332, -1.34568264880186, 218, 25, 'PPL', 'P'),
(17877, 'Runnymede', 28.2811107635498, 0.493598498945152, -81.2441711425781, -1.41797828449175, 218, 12, 'PPL', 'P'),
(33840, 'Runnymede', 37.3563919067383, 0.651992035437945, -97.929443359375, -1.70919122126639, 218, 20, 'PPL', 'P'),
(61629, 'Runnymede', 33.4966697692871, 0.584627175927309, -90.3105621337891, -1.57621665856153, 218, 30, 'PPL', 'P'),
(83415, 'Runnymede', 32.8822212219238, 0.573903025691724, -80.0963897705078, -1.39794572045607, 218, 48, 'PPL', 'P'),
(105950, 'Runnymede', 37.0344390869141, 0.646372898695933, -76.8516693115234, -1.34131466513997, 218, 53, 'PPL', 'P'),
(123601, 'Runnymede', 41.3022193908691, 0.720859716751713, -86.8583297729492, -1.51596383732098, 218, 19, 'PPL', 'P'),
(184701, 'Runnymede Poultry Colony (historical)', 34.2138900756836, 0.597145031736091, -118.523887634277, -2.06863208148193, 218, 6, 'PPL', 'P'),
(166726, 'Runville', 40.9644393920898, 0.714964343625632, -77.8402786254883, -1.35856915268454, 218, 45, 'PPL', 'P'),
(31017, 'Runyantown', 38.4894409179688, 0.671767471270383, -85.6147232055664, -1.49425880812073, 218, 19, 'PPL', 'P'),
(17878, 'Runyon', 26.7325000762939, 0.466570143620965, -80.6669387817383, -1.40790367924604, 218, 12, 'PPL', 'P'),
(146243, 'Runyon', 40.4341697692871, 0.705709392784416, -74.3324966430664, -1.29734680764914, 218, 37, 'PPL', 'P'),
(74157, 'Rupels', 39.2519416809082, 0.685075620132646, -82.8705596923828, -1.44636411960258, 218, 41, 'PPL', 'P'),
(11731, 'Rupert', 35.6341705322266, 0.621933602004494, -92.6908264160156, -1.61776010735401, 218, 4, 'PPL', 'P'),
(24564, 'Rupert', 32.4402809143066, 0.566189712226527, -84.2799987792969, -1.47096347227553, 218, 13, 'PPL', 'P'),
(74158, 'Rupert', 39.8824996948242, 0.696080933600316, -83.3533325195313, -1.45479009497548, 218, 41, 'PPL', 'P'),
(111231, 'Rupert', 37.9630584716797, 0.662580364457937, -80.6897201538086, -1.40830128919679, 218, 58, 'PPL', 'P'),
(166727, 'Rupert', 40.9791717529297, 0.715221471828879, -76.4744415283203, -1.33473079829307, 218, 45, 'PPL', 'P'),
(172474, 'Rupert', 43.2597198486328, 0.755024544848986, -73.2233276367188, -1.2779881565273, 218, 55, 'PPL', 'P'),
(195569, 'Rupert', 42.6191711425781, 0.743844860908942, -113.676391601563, -1.9840273152337, 218, 17, 'PPL', 'P'),
(42892, 'Ruple', 32.8505592346191, 0.573350419765532, -93.1641693115234, -1.62602149937154, 218, 22, 'PPL', 'P'),
(90531, 'Ruppe (historical)', 36.040828704834, 0.629031126046637, -84.6333312988281, -1.47713028809572, 218, 50, 'PPL', 'P'),
(90532, 'Ruppertown', 35.4238891601563, 0.618263499706255, -87.5941696166992, -1.52880666536178, 218, 50, 'PPL', 'P'),
(190692, 'Ruppes Place', 38.7541694641113, 0.676387856024589, -115.059722900391, -2.00817100104414, 218, 39, 'PPL', 'P'),
(208630, 'Rupple', 46.4044418334961, 0.809910297544701, -120.629997253418, -2.10539062874386, 218, 56, 'PPL', 'P'),
(166728, 'Ruppletown', 40.5608291625977, 0.707920016226264, -75.1163864135742, -1.31102826511721, 218, 45, 'PPL', 'P'),
(166729, 'Ruppsville', 40.5802803039551, 0.708259502686221, -75.600830078125, -1.31948340210404, 218, 45, 'PPL', 'P'),
(5579, 'Rural', 31.8641700744629, 0.556134681214824, -87.7386093139648, -1.53132761364965, 218, 2, 'PPL', 'P'),
(38038, 'Rural', 37.7044410705566, 0.658066639305389, -82.3574981689453, -1.4374095067533, 218, 21, 'PPL', 'P'),
(74159, 'Rural', 38.7783317565918, 0.676809567583203, -84.0894393920898, -1.46763758354819, 218, 41, 'PPL', 'P'),
(105951, 'Rural', 36.9272193908691, 0.644501561976961, -82.3625030517578, -1.43749685843705, 218, 53, 'PPL', 'P'),
(123602, 'Rural', 40.1066703796387, 0.699993450136779, -84.9661102294922, -1.48293837611707, 218, 19, 'PPL', 'P'),
(176205, 'Rural', 44.313060760498, 0.773408811906993, -89.1530609130859, -1.55601445116441, 218, 57, 'PPL', 'P'),
(201513, 'Rural Dell', 45.149169921875, 0.78800166967911, -122.650001525879, -2.14064635420266, 218, 43, 'PPL', 'P'),
(152257, 'Rural Grove', 42.8480606079102, 0.747839735702115, -74.4413909912109, -1.29924737256108, 218, 40, 'PPL', 'P'),
(68443, 'Rural Hall', 36.2402801513672, 0.632512210486506, -80.2936096191406, -1.40138785616499, 218, 33, 'PPL', 'P'),
(28485, 'Rural Hill', 37.9605598449707, 0.662536755195087, -88.6511077880859, -1.54725371644249, 218, 18, 'PPL', 'P'),
(61627, 'Rural Hill', 33.0761108398438, 0.57728703790986, -89.2988891601563, -1.5585596342182, 218, 30, 'PPL', 'P'),
(90533, 'Rural Hill', 36.1166687011719, 0.630354783687433, -86.4791717529297, -1.5093462814863, 218, 50, 'PPL', 'P'),
(152258, 'Rural Hill', 43.7941703796387, 0.76435246630407, -76.1736068725586, -1.32948024304593, 218, 40, 'PPL', 'P'),
(57303, 'Rural Home (historical)', 38.5719413757324, 0.673207375892762, -94.3730621337891, -1.6471206594238, 218, 29, 'PPL', 'P'),
(105952, 'Rural Retreat', 36.8936080932617, 0.643914934167844, -81.2761077880859, -1.41853568410791, 218, 53, 'PPL', 'P'),
(166730, 'Rural Ridge', 40.5855598449707, 0.708351648059938, -79.8288879394531, -1.39327693274905, 218, 45, 'PPL', 'P'),
(97691, 'Rural Shade', 32.0499992370605, 0.559378011948377, -96.1391677856445, -1.67794501798676, 218, 51, 'PPL', 'P'),
(90535, 'Rural Vale', 35.3116683959961, 0.616304877882557, -84.3597183227539, -1.47235484078704, 218, 50, 'PPL', 'P'),
(166732, 'Rural Valley', 40.186939239502, 0.701394406028215, -80.3488922119141, -1.40235271942793, 218, 45, 'PPL', 'P'),
(74160, 'Ruraldale', 39.7819404602051, 0.694325843862927, -81.8438873291016, -1.42844530652409, 218, 41, 'PPL', 'P'),
(111230, 'Ruraldale', 39.0669403076172, 0.681846737048006, -80.2319412231445, -1.40031153961044, 218, 58, 'PPL', 'P'),
(24565, 'Ruralvale', 34.8822212219238, 0.60880961073161, -84.8638916015625, -1.48115432450283, 218, 13, 'PPL', 'P'),
(125999, 'Ruralville', 42.3899993896484, 0.739845059267752, -71.8766708374023, -1.25448456148486, 218, 23, 'PPL', 'P'),
(105953, 'Ruritan', 37.4811096191406, 0.654168770154922, -79.1311111450195, -1.38109843024217, 218, 53, 'PPL', 'P'),
(11732, 'Rush', 36.1330604553223, 0.630640873767535, -92.5708312988281, -1.61566579747277, 218, 4, 'PPL', 'P'),
(38039, 'Rush', 38.3352813720703, 0.669076879621076, -82.7816696166992, -1.44481269510955, 218, 21, 'PPL', 'P'),
(51113, 'Rush', 39.6636085510254, 0.69226056243757, -78.6113891601563, -1.37202757041131, 218, 25, 'PPL', 'P'),
(113209, 'Rush', 42.9958305358887, 0.750418807480775, -77.6458282470703, -1.35517535334939, 218, 40, 'PPL', 'P'),
(157463, 'Rush', 40.3105583190918, 0.703551965985343, -81.3680572509766, -1.42014050498079, 218, 41, 'PPL', 'P'),
(166735, 'Rush', 41.7833290100098, 0.729256663668733, -76.0466690063477, -1.32726475933509, 218, 45, 'PPL', 'P'),
(187293, 'Rush', 38.8400001525879, 0.677885884137759, -104.091667175293, -1.81674231609897, 218, 7, 'PPL', 'P'),
(51114, 'Rush Acres', 38.398609161377, 0.670182158052486, -75.4572219848633, -1.31697696804412, 218, 25, 'PPL', 'P'),
(97692, 'Rush Addition Colonia', 27.2259998321533, 0.475183339218499, -98.1230010986328, -1.71256944110916, 218, 51, 'PPL', 'P'),
(33838, 'Rush Center', 38.4652786254883, 0.671345759711769, -99.3097229003906, -1.73328164385503, 218, 20, 'PPL', 'P'),
(137854, 'Rush City', 45.6855583190918, 0.797363413280038, -92.9652786254883, -1.62255020204868, 218, 28, 'PPL', 'P'),
(97693, 'Rush Colonia', 26.246000289917, 0.458079120538438, -98.2740020751953, -1.7152049053239, 218, 51, 'PPL', 'P'),
(105954, 'Rush Corner', 36.6958312988281, 0.640463077920938, -82.1916732788086, -1.43451531643865, 218, 53, 'PPL', 'P'),
(31019, 'Rush Creek Valley', 38.6952781677246, 0.675360009001873, -86.1705627441406, -1.50396003818161, 218, 19, 'PPL', 'P'),
(79065, 'Rush Crossroads', 39.8061103820801, 0.694747688579595, -80.2591705322266, -1.40078678070696, 218, 45, 'PPL', 'P'),
(57304, 'Rush Hill', 39.2099990844727, 0.68434358372801, -91.7213897705078, -1.60084024600041, 218, 29, 'PPL', 'P'),
(176206, 'Rush Lake', 43.9238891601563, 0.766616486125773, -88.8391723632813, -1.55053606248601, 218, 57, 'PPL', 'P'),
(51115, 'Rush Manor', 39.6263885498047, 0.691610950868673, -76.4388885498047, -1.33411028175909, 218, 25, 'PPL', 'P'),
(137857, 'Rush Meadows Mobile Home Park', 45.6777801513672, 0.797227658643471, -92.9583282470703, -1.62242889506103, 218, 28, 'PPL', 'P'),
(179031, 'Rush Place Windmill', 34.2761116027832, 0.598231002249598, -112.610000610352, -1.96541528132346, 218, 5, 'PPL', 'P'),
(137858, 'Rush Point', 45.6586112976074, 0.79689309903153, -93.103889465332, -1.62496941758291, 218, 28, 'PPL', 'P'),
(137859, 'Rush River', 44.4672203063965, 0.7760994035563, -94.0505599975586, -1.64149193530187, 218, 28, 'PPL', 'P'),
(157465, 'Rush Road (historical)', 41.6213912963867, 0.726430317382859, -81.4580612182617, -1.42171137054977, 218, 41, 'PPL', 'P'),
(152259, 'Rush Run', 42.2458305358887, 0.737328838090818, -76.7574996948242, -1.33967109527323, 218, 40, 'PPL', 'P'),
(157466, 'Rush Run', 40.2316703796387, 0.702175111701772, -80.6805572509766, -1.40814136637333, 218, 41, 'PPL', 'P'),
(111232, 'Rush Run (historical)', 37.9644393920898, 0.662604466065802, -81.0658264160156, -1.41486558180967, 218, 58, 'PPL', 'P'),
(77145, 'Rush Springs', 34.7825012207031, 0.607069168380216, -97.956672668457, -1.70966646236292, 218, 42, 'PPL', 'P'),
(205643, 'Rush Valley', 40.3630599975586, 0.704468293137412, -112.449722290039, -1.96261789691444, 218, 52, 'PPL', 'P'),
(166740, 'Rushboro', 41.7324981689453, 0.7283694981306, -76.0355606079102, -1.32707088120773, 218, 45, 'PPL', 'P'),
(137860, 'Rushford', 43.8083305358887, 0.764599607653229, -91.7527770996094, -1.60138805823664, 218, 28, 'PPL', 'P'),
(152261, 'Rushford', 42.392219543457, 0.739883808261613, -78.2538909912109, -1.36578805029336, 218, 40, 'PPL', 'P'),
(137861, 'Rushford Village', 43.8066711425781, 0.764570645776375, -91.791389465332, -1.60206197115048, 218, 28, 'PPL', 'P'),
(11733, 'Rushing', 35.735279083252, 0.623698279121807, -92.2644424438477, -1.61031830316195, 218, 4, 'PPL', 'P'),
(61628, 'Rushing', 31.1305599212646, 0.543330768615455, -90.1769409179688, -1.57388452839495, 218, 30, 'PPL', 'P'),
(90536, 'Rushing (historical)', 36.6616706848145, 0.639866862731897, -88.0361099243164, -1.53651997882698, 218, 50, 'PPL', 'P'),
(166741, 'Rushland', 40.2574996948242, 0.702625918295295, -75.0311126708984, -1.30953995754201, 218, 45, 'PPL', 'P'),
(105955, 'Rushmere', 37.0666694641113, 0.646935424897185, -76.6766662597656, -1.33826028568576, 218, 53, 'PPL', 'P'),
(105959, 'Rushmere Shores', 37.0955581665039, 0.647439627870564, -76.6594390869141, -1.33795961479869, 218, 53, 'PPL', 'P'),
(137864, 'Rushmore', 43.6194381713867, 0.761302813960793, -95.8002777099609, -1.67203027036375, 218, 28, 'PPL', 'P'),
(157470, 'Rushmore', 40.8741683959961, 0.713388817524741, -84.2533264160156, -1.47049795171699, 218, 41, 'PPL', 'P'),
(57306, 'Rushs Ridge', 36.9288902282715, 0.644530723590898, -89.1791687011719, -1.55647011802692, 218, 29, 'PPL', 'P'),
(157471, 'Rushsylvania', 40.4613914489746, 0.706184500722886, -83.6699981689453, -1.46031695318572, 218, 41, 'PPL', 'P'),
(132935, 'Rushton', 42.4519386291504, 0.740926102933242, -83.6961135864258, -1.46077275320629, 218, 27, 'PPL', 'P'),
(74164, 'Rushtown', 38.8327789306641, 0.677759850039171, -83.0199966430664, -1.44897228641615, 218, 41, 'PPL', 'P'),
(166742, 'Rushtown', 40.917781829834, 0.714150015543313, -76.629997253418, -1.33744575786636, 218, 45, 'PPL', 'P'),
(31020, 'Rushville', 39.6091690063477, 0.691310413139657, -85.4463882446289, -1.49132080880615, 218, 19, 'PPL', 'P'),
(51116, 'Rushville', 39.0702781677246, 0.681904993696852, -77.3277816772461, -1.34962439353129, 218, 25, 'PPL', 'P'),
(57307, 'Rushville', 39.586669921875, 0.690917730036925, -95.0258331298828, -1.65851366256716, 218, 29, 'PPL', 'P'),
(74166, 'Rushville', 39.1238899230957, 0.682840695345851, -81.7602767944336, -1.42698602740478, 218, 41, 'PPL', 'P'),
(83416, 'Rushville', 34.0133285522461, 0.593644572799291, -82.166389465332, -1.43407403064603, 218, 48, 'PPL', 'P'),
(105956, 'Rushville', 38.4316711425781, 0.670759198481679, -78.9794387817383, -1.37845124811863, 218, 53, 'PPL', 'P'),
(111234, 'Rushville', 38.7005615234375, 0.675452220954617, -81.3391723632813, -1.41963636858644, 218, 58, 'PPL', 'P'),
(117629, 'Rushville', 41.7602806091309, 0.728854393186077, -92.945556640625, -1.62220598847779, 218, 16, 'PPL', 'P'),
(121320, 'Rushville', 40.1211090087891, 0.700245451754928, -90.5630569458008, -1.58062352437534, 218, 18, 'PPL', 'P'),
(152263, 'Rushville', 42.7599983215332, 0.746302758858003, -77.2266693115234, -1.34785964983495, 218, 40, 'PPL', 'P'),
(166743, 'Rushville', 41.7825012207031, 0.729242216019819, -76.1224975585938, -1.32858821723881, 218, 45, 'PPL', 'P'),
(199661, 'Rushville', 42.7183303833008, 0.74557551614333, -102.463607788086, -1.7883273193742, 218, 35, 'PPL', 'P'),
(24568, 'Rushwood', 33.9880599975586, 0.593203553322773, -83.4697189331055, -1.45682142109694, 218, 13, 'PPL', 'P'),
(90538, 'Rushy Springs', 36.1238899230957, 0.630480817786021, -83.3613891601563, -1.45493070988104, 218, 50, 'PPL', 'P'),
(31022, 'Rusk', 38.5572204589844, 0.672950447426597, -86.7569427490234, -1.51419429993468, 218, 19, 'PPL', 'P'),
(97694, 'Rusk', 31.7958297729492, 0.554941917941605, -95.1500015258789, -1.66068080990422, 218, 51, 'PPL', 'P'),
(111233, 'Rusk', 39.1549987792969, 0.683383647313091, -81.2541732788086, -1.41815285470121, 218, 58, 'PPL', 'P'),
(117630, 'Rusk', 42.6666717529297, 0.744673902956284, -94.7363891601563, -1.65346191229539, 218, 16, 'PPL', 'P'),
(132936, 'Rusk', 42.9575004577637, 0.749749821414947, -86.0124969482422, -1.5012012696084, 218, 27, 'PPL', 'P'),
(176209, 'Rusk', 44.9077796936035, 0.783788615413632, -91.8338928222656, -1.60280379467212, 218, 57, 'PPL', 'P'),
(68444, 'Rusk (historical)', 36.2897186279297, 0.633375074679692, -80.7624969482422, -1.4095714838787, 218, 33, 'PPL', 'P'),
(17879, 'Ruskin', 27.7205600738525, 0.483815043785609, -82.4333267211914, -1.43873296465701, 218, 12, 'PPL', 'P'),
(24566, 'Ruskin', 31.1511096954346, 0.543689429835261, -82.4449996948242, -1.4389366964804, 218, 13, 'PPL', 'P'),
(57308, 'Ruskin', 38.922779083252, 0.679330649029127, -94.5136108398438, -1.64957369710388, 218, 29, 'PPL', 'P'),
(68445, 'Ruskin', 34.7097206115723, 0.605798907119276, -78.6747207641602, -1.37313291542174, 218, 33, 'PPL', 'P'),
(90539, 'Ruskin', 36.160831451416, 0.631125569085929, -87.519172668457, -1.52749772168601, 218, 50, 'PPL', 'P'),
(137867, 'Ruskin', 44.2675018310547, 0.772613658584523, -93.1616668701172, -1.62597782352967, 218, 28, 'PPL', 'P'),
(142910, 'Ruskin', 40.1438903808594, 0.700643061705677, -97.8688888549805, -1.70813434578779, 218, 35, 'PPL', 'P'),
(57309, 'Ruskin Heights', 38.9213905334473, 0.679306414263207, -94.504997253418, -1.64942336166034, 218, 29, 'PPL', 'P'),
(171243, 'Ruskin Park', 44.0055618286133, 0.768041943099238, -98.0961074829102, -1.71210005896703, 218, 49, 'PPL', 'P'),
(61630, 'Ruslor Junction', 34.9575004577637, 0.610123481255401, -88.5277786254883, -1.54510121649143, 218, 30, 'PPL', 'P'),
(198840, 'Ruso', 47.8383293151855, 0.834936355203312, -100.933059692383, -1.76161421574406, 218, 34, 'PPL', 'P'),
(57310, 'Russ', 37.5838890075684, 0.655962608886172, -92.5858306884766, -1.61592758620792, 218, 29, 'PPL', 'P'),
(184702, 'Russ', 34.4397201538086, 0.601086510149408, -118.313888549805, -2.06496690603171, 218, 6, 'PPL', 'P'),
(152264, 'Russ Mills', 43.3672218322754, 0.756900808415974, -76.2413864135742, -1.33066321920214, 218, 40, 'PPL', 'P'),
(193922, 'Russ Place', 40.1458282470703, 0.70067688385152, -123.277778625488, -2.15160313155946, 218, 6, 'PPL', 'P'),
(68446, 'Russaw (historical)', 36.184440612793, 0.631537626685592, -81.0897216796875, -1.41528263283637, 218, 33, 'PPL', 'P'),
(5580, 'Russell', 31.0561103820801, 0.542031379030092, -88.2319412231445, -1.53993787976999, 218, 2, 'PPL', 'P'),
(11734, 'Russell', 35.3624992370605, 0.617192043420689, -91.5074996948242, -1.59710715994239, 218, 4, 'PPL', 'P'),
(17880, 'Russell', 30.0561103820801, 0.524578086510148, -81.7474975585938, -1.42676298766349, 218, 12, 'PPL', 'P'),
(24567, 'Russell', 33.9786109924316, 0.59303863707227, -83.7002792358398, -1.46084545750405, 218, 13, 'PPL', 'P'),
(33842, 'Russell', 38.8952789306641, 0.678850680821667, -98.8594436645508, -1.72542278863626, 218, 20, 'PPL', 'P'),
(38040, 'Russell', 38.517219543457, 0.672252299746832, -82.6977767944336, -1.44334848914223, 218, 21, 'PPL', 'P'),
(57311, 'Russell', 37.7166709899902, 0.658280091666759, -92.6355590820313, -1.61679551040718, 218, 29, 'PPL', 'P'),
(61631, 'Russell', 32.4036102294922, 0.565549688037554, -88.5938873291016, -1.54625503103371, 218, 30, 'PPL', 'P'),
(77147, 'Russell', 34.7680587768555, 0.60681710018304, -99.6669387817383, -1.73951623712496, 218, 42, 'PPL', 'P'),
(97696, 'Russell', 31.3772201538086, 0.547635801807082, -95.8499984741211, -1.67289806140495, 218, 51, 'PPL', 'P'),
(105958, 'Russell', 36.6855583190918, 0.640283780600548, -76.5880584716797, -1.33671378804075, 218, 53, 'PPL', 'P'),
(117631, 'Russell', 40.9819412231445, 0.715269808202664, -93.1983337402344, -1.62661778113961, 218, 16, 'PPL', 'P'),
(121322, 'Russell', 42.4905586242676, 0.741600149005141, -87.9124984741211, -1.5343625520279, 218, 18, 'PPL', 'P'),
(126000, 'Russell', 42.1897201538086, 0.736349527178968, -72.8597183227539, -1.2716419768077, 218, 23, 'PPL', 'P'),
(137868, 'Russell', 44.3191719055176, 0.773515471508651, -95.9513931274414, -1.67466773194931, 218, 28, 'PPL', 'P'),
(144395, 'Russell', 42.9172210693359, 0.749046813466194, -71.8452835083008, -1.25393674924863, 218, 36, 'PPL', 'P'),
(152265, 'Russell', 44.4294395446777, 0.775440004870397, -75.1502838134766, -1.31161988635337, 218, 40, 'PPL', 'P'),
(157472, 'Russell', 40.5161094665527, 0.707139510289789, -82.835563659668, -1.44575332360657, 218, 41, 'PPL', 'P'),
(166744, 'Russell', 41.9413909912109, 0.732015365662919, -79.1352767944336, -1.38117113453993, 218, 45, 'PPL', 'P'),
(176213, 'Russell', 44.4280586242676, 0.775415903262532, -91.4783325195313, -1.59659809670002, 218, 57, 'PPL', 'P'),
(184703, 'Russell', 38.2388916015625, 0.667394560760473, -122.094718933105, -2.13095484467975, 218, 6, 'PPL', 'P'),
(187294, 'Russell', 37.5552787780762, 0.655463266181782, -105.287216186523, -1.8376085827139, 218, 7, 'PPL', 'P'),
(198842, 'Russell', 48.6713905334473, 0.849476016332654, -100.901107788086, -1.76105654981179, 218, 34, 'PPL', 'P'),
(208631, 'Russell', 46.1338882446289, 0.805188246615882, -118.345001220703, -2.06550992457798, 218, 56, 'PPL', 'P'),
(83417, 'Russell (historical)', 34.9091682434082, 0.609279924980118, -83.1727828979492, -1.45163890961564, 218, 48, 'PPL', 'P'),
(197449, 'Russell (historical)', 48.0638885498047, 0.838873106505694, -111.0625, -1.9384063004962, 218, 31, 'PPL', 'P'),
(157473, 'Russell Center', 41.4625015258789, 0.72365716773976, -81.3408279418945, -1.41966526388426, 218, 41, 'PPL', 'P'),
(166745, 'Russell City', 41.5713882446289, 0.72555759949364, -78.9088897705078, -1.37721993558863, 218, 45, 'PPL', 'P'),
(184704, 'Russell City', 37.6527786254883, 0.657164959539315, -122.132499694824, -2.13161424336565, 218, 6, 'PPL', 'P'),
(38042, 'Russell Corner', 38.4513893127441, 0.671103345473545, -85.4116668701172, -1.4907148065001, 218, 21, 'PPL', 'P'),
(105960, 'Russell Corner', 36.7777786254883, 0.641893328584365, -78.2502822875977, -1.36572506653358, 218, 53, 'PPL', 'P'),
(128709, 'Russell Corner', 45.0175018310547, 0.78570362797448, -69.2461090087891, -1.20857259639828, 218, 26, 'PPL', 'P'),
(97697, 'Russell Crossing', 30.6722202301025, 0.535331231912102, -97.7502822875977, -1.70606427067247, 218, 51, 'PPL', 'P'),
(128710, 'Russell Crossing', 46.6558303833008, 0.814297855440607, -68.7333297729492, -1.19962291039701, 218, 26, 'PPL', 'P'),
(90541, 'Russell Crossroad', 36.0997200012207, 0.630058973069353, -82.9274978637695, -1.44735787816334, 218, 50, 'PPL', 'P'),
(90540, 'Russell Crossroads', 35.6130599975586, 0.621565153667681, -88.5683288574219, -1.54580895155112, 218, 50, 'PPL', 'P'),
(90542, 'Russell Fork', 36.4588890075684, 0.636327654801236, -84.0519409179688, -1.4669831117103, 218, 50, 'PPL', 'P'),
(152266, 'Russell Gardens', 40.7811088562012, 0.711764622154929, -73.7249984741211, -1.28674396440121, 218, 40, 'PPL', 'P'),
(24569, 'Russell Glen', 32.5875015258789, 0.568759196625263, -83.6405563354492, -1.45980309625339, 218, 13, 'PPL', 'P'),
(187295, 'Russell Gulch', 39.7786102294922, 0.694267720372136, -105.536392211914, -1.841957524774, 218, 7, 'PPL', 'P'),
(5582, 'Russell Heights', 33.5533294677734, 0.585616074219083, -86.5602798461914, -1.51076188476373, 218, 2, 'PPL', 'P'),
(38045, 'Russell Heights', 38.5327796936035, 0.672523875598993, -82.7058334350586, -1.44348910404778, 218, 21, 'PPL', 'P'),
(83420, 'Russell Hill', 33.4677810668945, 0.58412297295393, -81.8361129760742, -1.42830961846655, 218, 48, 'PPL', 'P'),
(90543, 'Russell Hill', 36.4316711425781, 0.635852613441793, -85.897216796875, -1.49918925140485, 218, 50, 'PPL', 'P'),
(31023, 'Russell Lake', 39.9486083984375, 0.697234748142593, -86.3016662597656, -1.50624822619021, 218, 19, 'PPL', 'P'),
(83418, 'Russell Lake Landing', 33.0622215270996, 0.577044623671636, -80.4569396972656, -1.40423850379581, 218, 48, 'PPL', 'P'),
(208632, 'Russell Landing', 45.6061096191406, 0.795976771879461, -122.582778930664, -2.13947309858442, 218, 56, 'PPL', 'P'),
(90548, 'Russell Mill', 36.4469413757324, 0.636119129287883, -83.8644409179688, -1.46371061936281, 218, 50, 'PPL', 'P'),
(205640, 'Russell Park', 40.5927810668945, 0.708477682158526, -111.79638671875, -1.95121504007505, 218, 52, 'PPL', 'P'),
(24570, 'Russell Plantation', 34.0269393920898, 0.593882126768526, -84.4966735839844, -1.47474516102344, 218, 13, 'PPL', 'P'),
(105962, 'Russell Point', 36.813060760498, 0.642509118007419, -76.6158294677734, -1.33719848335914, 218, 53, 'PPL', 'P'),
(90544, 'Russell Shack Ridge', 35.8716697692871, 0.626078745662175, -84.977783203125, -1.48314210794046, 218, 50, 'PPL', 'P'),
(38044, 'Russell Springs', 37.0561103820801, 0.646751134149751, -85.0886077880859, -1.48507636184019, 218, 21, 'PPL', 'P'),
(187873, 'Russell Springs', 38.913330078125, 0.679165732778623, -101.181106567383, -1.76594345041209, 218, 20, 'PPL', 'P'),
(5584, 'Russell Village', 34.5622215270996, 0.603224562451551, -86.9911117553711, -1.51828132010157, 218, 2, 'PPL', 'P'),
(111239, 'Russelldale', 39.2924995422363, 0.685783488350389, -78.9302825927734, -1.37759331077346, 218, 58, 'PPL', 'P'),
(74168, 'Russells', 39.9230613708496, 0.696788868397087, -82.0322189331055, -1.43173231309952, 218, 41, 'PPL', 'P'),
(68448, 'Russells Creek', 34.1372184753418, 0.595806859867353, -78.1166687011719, -1.36339306952505, 218, 33, 'PPL', 'P'),
(126002, 'Russells Mills', 41.5722198486328, 0.725572113721581, -71.0069427490234, -1.23930494274557, 218, 23, 'PPL', 'P'),
(157475, 'Russells Point', 40.4711112976074, 0.706354144084324, -83.8927764892578, -1.46420516837724, 218, 41, 'PPL', 'P'),
(166747, 'Russellton', 40.6113891601563, 0.708802454653461, -79.8372192382813, -1.39342234134457, 218, 45, 'PPL', 'P'),
(97698, 'Russelltown', 26.0825004577637, 0.455225510140904, -97.581672668457, -1.70312147766794, 218, 51, 'PPL', 'P'),
(5585, 'Russellville', 34.5077781677246, 0.60227434657461, -87.7286071777344, -1.5311530434402, 218, 2, 'PPL', 'P'),
(11737, 'Russellville', 35.2783317565918, 0.615723043763402, -93.1336135864258, -1.62548820136325, 218, 4, 'PPL', 'P'),
(24571, 'Russellville', 32.9025001525879, 0.574256959800595, -83.9913864135742, -1.4659262362317, 218, 13, 'PPL', 'P'),
(31025, 'Russellville', 39.8583297729492, 0.695659088883648, -86.98388671875, -1.51815521942395, 218, 19, 'PPL', 'P'),
(38052, 'Russellville', 36.8452796936035, 0.643071444471589, -86.8872222900391, -1.51646810687339, 218, 21, 'PPL', 'P'),
(42894, 'Russellville', 32.665828704834, 0.570126263791828, -93.0286102294922, -1.62365554705912, 218, 22, 'PPL', 'P'),
(57316, 'Russellville', 39.4066696166992, 0.687776132057013, -93.8300018310547, -1.63764246910421, 218, 29, 'PPL', 'P'),
(61632, 'Russellville', 32.540828704834, 0.567944602226835, -90.6527786254883, -1.58218946309631, 218, 30, 'PPL', 'P'),
(68450, 'Russellville', 34.9833297729492, 0.610574287848924, -80.1386108398438, -1.39868261712969, 218, 33, 'PPL', 'P'),
(74169, 'Russellville', 38.8663902282715, 0.678346477848288, -83.7869415283203, -1.46235799984516, 218, 41, 'PPL', 'P'),
(77148, 'Russellville', 35.151668548584, 0.613512353742527, -95.4349975585938, -1.66565492903021, 218, 42, 'PPL', 'P'),
(83424, 'Russellville', 33.3969383239746, 0.582886533838834, -79.9719390869141, -1.395773646271, 218, 48, 'PPL', 'P'),
(90545, 'Russellville', 36.2586097717285, 0.632832122712452, -83.1952819824219, -1.45203159271838, 218, 50, 'PPL', 'P'),
(111235, 'Russellville', 38.0763893127441, 0.664558360778566, -80.8925018310547, -1.41184049712745, 218, 58, 'PPL', 'P'),
(121323, 'Russellville', 42.3280601501465, 0.738764015602262, -88.7836074829102, -1.54956627237506, 218, 18, 'PPL', 'P'),
(126004, 'Russellville', 42.4099998474121, 0.740194133107634, -72.5652770996094, -1.26650300801022, 218, 23, 'PPL', 'P'),
(132937, 'Russellville', 43.0916709899902, 0.752091538961454, -83.5583267211914, -1.45836791874195, 218, 27, 'PPL', 'P'),
(166749, 'Russellville', 40.3052787780762, 0.703459820611626, -78.23388671875, -1.36543890987445, 218, 45, 'PPL', 'P'),
(172476, 'Russellville', 43.3819389343262, 0.757157670303112, -72.8419418334961, -1.2713317185407, 218, 55, 'PPL', 'P'),
(192150, 'Russellville', 33.920280456543, 0.59202057716656, -100.689170837402, -1.75735755221573, 218, 51, 'PPL', 'P'),
(201514, 'Russellville', 45.5191688537598, 0.794459369269361, -122.556671142578, -2.13901743172191, 218, 43, 'PPL', 'P'),
(117633, 'Russellville (historical)', 40.7827796936035, 0.711793783768866, -91.6452789306641, -1.59951186124868, 218, 16, 'PPL', 'P'),
(105963, 'Russellwood', 37.3236083984375, 0.651419855277742, -79.1855621337891, -1.38204877927717, 218, 53, 'PPL', 'P'),
(123603, 'Russels Point', 41.5538902282715, 0.725252201495636, -84.9241714477539, -1.48220640629147, 218, 19, 'PPL', 'P'),
(111236, 'Russet', 38.8730583190918, 0.678462857987924, -81.0566711425781, -1.41470579214426, 218, 58, 'PPL', 'P'),
(5586, 'Russet Woods', 33.329719543457, 0.581713344799626, -86.8866729736328, -1.51645851949346, 218, 2, 'PPL', 'P'),
(112501, 'Russett', 34.189998626709, 0.596728047288411, -96.8047180175781, -1.68956106087142, 218, 42, 'PPL', 'P'),
(146242, 'Russia', 41.0405616760254, 0.716292928114445, -74.5330581665039, -1.30084726658594, 218, 37, 'PPL', 'P'),
(152268, 'Russia', 43.2586097717285, 0.755005170352055, -75.0824966430664, -1.3104367770391, 218, 40, 'PPL', 'P'),
(157476, 'Russia', 40.2344398498535, 0.702223448075557, -84.4094390869141, -1.47322263182825, 218, 41, 'PPL', 'P'),
(212125, 'Russian Mission', 61.7849998474121, 1.07835167568154, -161.320281982422, -2.81557007083895, 218, 1, 'PPL', 'P'),
(184705, 'Russian River Terrace', 38.5047187805176, 0.672034120274528, -122.925559997559, -2.14545575681523, 218, 6, 'PPL', 'P'),
(114014, 'Russian Village', 41.4461097717285, 0.723371077659658, -73.2527770996094, -1.27850214661769, 218, 8, 'PPL', 'P'),
(211091, 'Russian Village', 20.9063892364502, 0.364885326879559, -156.424713134766, -2.73012627568928, 218, 15, 'PPL', 'P'),
(123604, 'Russiaville', 40.4174995422363, 0.705418442435325, -86.2713928222656, -1.50571985502994, 218, 19, 'PPL', 'P'),
(68449, 'Russtown', 33.957218170166, 0.592665261887441, -78.4316711425781, -1.36889089927941, 218, 33, 'PPL', 'P'),
(172477, 'Russtown', 43.6169395446777, 0.761259204697943, -72.3555603027344, -1.26284275940802, 218, 55, 'PPL', 'P'),
(61633, 'Russum', 31.8772201538086, 0.556362448067053, -91.0113906860352, -1.58844842429021, 218, 30, 'PPL', 'P'),
(28496, 'Rust', 38.002498626709, 0.663268725020695, -88.7611083984375, -1.54917358927233, 218, 18, 'PPL', 'P'),
(132938, 'Rust', 44.9866714477539, 0.78516553627623, -83.9486083984375, -1.4651796190201, 218, 27, 'PPL', 'P'),
(105964, 'Rust Hollow', 36.6980590820313, 0.640501960072853, -82.0644378662109, -1.43229463956369, 218, 53, 'PPL', 'P'),
(137871, 'Rustad', 46.7333297729492, 0.815650474958258, -96.7444381713867, -1.68850897908278, 218, 28, 'PPL', 'P'),
(105965, 'Rustburg', 37.276668548584, 0.650600600347406, -79.1011123657227, -1.38057485277186, 218, 53, 'PPL', 'P'),
(132940, 'Rustford', 43.5125007629395, 0.759436404089838, -85.3427810668945, -1.48951252242599, 218, 27, 'PPL', 'P'),
(105966, 'Rustic', 37.291389465332, 0.650857528813572, -76.9338912963867, -1.34274970949336, 218, 53, 'PPL', 'P'),
(194409, 'Rustic', 40.5802803039551, 0.708259502686221, -105.699440002441, -1.84480324555681, 218, 7, 'PPL', 'P'),
(51117, 'Rustic Acres', 38.3097190856934, 0.668630733559461, -75.5541687011719, -1.3186690074427, 218, 25, 'PPL', 'P'),
(90546, 'Rustic Acres', 36.1541709899902, 0.631009322104347, -82.7897186279297, -1.44495317685706, 218, 50, 'PPL', 'P'),
(121324, 'Rustic Acres', 41.5027809143066, 0.724360175688513, -90.2705612182617, -1.57551851088177, 218, 18, 'PPL', 'P'),
(83421, 'Rustic Estates', 34.7611083984375, 0.606695793195387, -82.3091735839844, -1.43656608363607, 218, 48, 'PPL', 'P'),
(31026, 'Rustic Hills', 37.9555587768555, 0.66244947009036, -87.3675003051758, -1.52485053956247, 218, 19, 'PPL', 'P'),
(51118, 'Rustic Hills', 38.4880599975586, 0.671743369662518, -76.7286071777344, -1.33916682572082, 218, 25, 'PPL', 'P'),
(166750, 'Rustic Hills', 40.3183288574219, 0.703687587463855, -76.8133316040039, -1.34064554591609, 218, 45, 'PPL', 'P'),
(51119, 'Rustic Knolls', 38.8261108398438, 0.677643469899534, -76.6672210693359, -1.33809543601428, 218, 25, 'PPL', 'P'),
(117634, 'Rustic Ridge Mobile Home Park', 41.5694389343262, 0.725523577610715, -90.6236114501953, -1.58168039985394, 218, 16, 'PPL', 'P'),
(90547, 'Rustic Villa', 35.1541709899902, 0.613556029584404, -85.3269424438477, -1.48923608630484, 218, 50, 'PPL', 'P'),
(197450, 'Rustle (historical)', 47.1925010681152, 0.823664525889552, -109.206939697266, -1.90602066374418, 218, 31, 'PPL', 'P'),
(42898, 'Ruston', 32.5230598449707, 0.567634477117895, -92.6377792358398, -1.61683425940104, 218, 22, 'PPL', 'P'),
(208633, 'Ruston', 47.2994384765625, 0.825530935760506, -122.506942749023, -2.13814950752265, 218, 56, 'PPL', 'P'),
(51120, 'Rusty Acres', 39.1111106872559, 0.682617655604557, -76.9477767944336, -1.34299205715255, 218, 25, 'PPL', 'P'),
(5587, 'Rutan', 31.4394397735596, 0.548721739031075, -88.1894378662109, -1.53919605624834, 218, 2, 'PPL', 'P'),
(79067, 'Rutan', 39.8950004577637, 0.696299113072621, -80.3399963378906, -1.40219745713638, 218, 45, 'PPL', 'P'),
(97699, 'Rutersville', 29.9475002288818, 0.522682481735744, -96.7969436645508, -1.68942537281388, 218, 51, 'PPL', 'P'),
(146245, 'Rutgers', 40.4880599975586, 0.706649954702405, -74.4111099243164, -1.29871886824275, 218, 37, 'PPL', 'P'),
(5588, 'Ruth', 34.3641700744629, 0.599767912514682, -86.5566711425781, -1.51069890100395, 218, 2, 'PPL', 'P'),
(11739, 'Ruth', 36.3699989318848, 0.63477623030821, -92.1361083984375, -1.60807845152713, 218, 4, 'PPL', 'P'),
(38047, 'Ruth', 37.0750007629395, 0.647080833492703, -84.524169921875, -1.47522506265188, 218, 21, 'PPL', 'P'),
(42895, 'Ruth', 30.2377796173096, 0.527748812814483, -91.8816680908203, -1.60363763040943, 218, 22, 'PPL', 'P'),
(61634, 'Ruth', 31.3813896179199, 0.547708572683868, -90.3163909912109, -1.57631839131518, 218, 30, 'PPL', 'P'),
(68451, 'Ruth', 35.3819389343262, 0.617531330143565, -81.9472198486328, -1.43024879921429, 218, 33, 'PPL', 'P'),
(105969, 'Ruth', 38.3941688537598, 0.670104660064765, -78.3141708374023, -1.366840132082, 218, 53, 'PPL', 'P'),
(111237, 'Ruth', 38.3102798461914, 0.668640520676467, -81.7283325195313, -1.42642849463057, 218, 58, 'PPL', 'P'),
(132941, 'Ruth', 43.7152786254883, 0.762975545441472, -82.7402801513672, -1.44409031266387, 218, 27, 'PPL', 'P'),
(157478, 'Ruth', 40.6083297729492, 0.708749058273605, -83.1777801513672, -1.45172612814134, 218, 41, 'PPL', 'P'),
(190693, 'Ruth', 39.2783317565918, 0.685536213843175, -114.988327026367, -2.00692490797009, 218, 39, 'PPL', 'P'),
(193923, 'Ruth', 40.269718170166, 0.702839170919583, -123.320281982422, -2.1523449550811, 218, 6, 'PPL', 'P'),
(208635, 'Ruth', 46.6072196960449, 0.813449438896335, -123.118606567383, -2.14882505506834, 218, 56, 'PPL', 'P'),
(24572, 'Ruth (historical)', 33.4477806091309, 0.583773899114048, -83.1338882446289, -1.45096006985378, 218, 13, 'PPL', 'P'),
(111238, 'Ruth (historical)', 37.3380584716797, 0.651672056632972, -81.341667175293, -1.41967991127026, 218, 58, 'PPL', 'P'),
(190694, 'Ruth (historical)', 39.2572212219238, 0.685167765506362, -114.979438781738, -2.00676977883659, 218, 39, 'PPL', 'P'),
(14533, 'Ruth Harbor', 38.6622200012207, 0.674783035151707, -75.5541687011719, -1.3186690074427, 218, 10, 'PPL', 'P'),
(111242, 'Ruthbelle', 39.5074996948242, 0.689535948905338, -79.6433334350586, -1.39003839570546, 218, 58, 'PPL', 'P'),
(14534, 'Ruthby', 39.6855583190918, 0.692643658160378, -75.7024993896484, -1.32125786633836, 218, 10, 'PPL', 'P'),
(77149, 'Ruthdale', 36.814998626709, 0.642542940153263, -95.7372207641602, -1.67092971904328, 218, 42, 'PPL', 'P'),
(111240, 'Ruthdale', 38.3197212219238, 0.668805303768916, -81.7230606079102, -1.42633648241491, 218, 58, 'PPL', 'P'),
(51121, 'Ruthed Estates', 39.6847190856934, 0.692629010774383, -77.1875, -1.34717601638312, 218, 25, 'PPL', 'P'),
(105967, 'Ruther Glen', 37.9286117553711, 0.661979155841852, -77.4561080932617, -1.35186411200804, 218, 53, 'PPL', 'P'),
(5589, 'Rutherford', 32.1888885498047, 0.561802087751595, -85.3180618286133, -1.4890810903294, 218, 2, 'PPL', 'P'),
(11740, 'Rutherford', 35.7227783203125, 0.623480099649503, -91.5386123657227, -1.59765017848866, 218, 4, 'PPL', 'P'),
(14535, 'Rutherford', 39.6888885498047, 0.692701781651169, -75.6805572509766, -1.32087490377361, 218, 10, 'PPL', 'P'),
(38048, 'Rutherford', 36.8847198486328, 0.643759805034347, -83.0369415283203, -1.4492680304552, 218, 21, 'PPL', 'P'),
(90549, 'Rutherford', 36.127498626709, 0.630543801545802, -88.9858322143555, -1.55309575976774, 218, 50, 'PPL', 'P'),
(105968, 'Rutherford', 38.8288917541504, 0.677692006010401, -77.2605590820313, -1.34845113791305, 218, 53, 'PPL', 'P'),
(111241, 'Rutherford', 39.1505584716797, 0.68330614932537, -81.1708297729492, -1.41669823611381, 218, 58, 'PPL', 'P'),
(121325, 'Rutherford', 40.0247192382813, 0.698563132894325, -88.0524978637695, -1.53680600232805, 218, 18, 'PPL', 'P'),
(146244, 'Rutherford', 40.8263893127441, 0.71255491520841, -74.1072235107422, -1.2934150497738, 218, 37, 'PPL', 'P'),
(166751, 'Rutherford', 40.2688903808594, 0.702824723270669, -76.7683334350586, -1.33986017971062, 218, 45, 'PPL', 'P'),
(184706, 'Rutherford', 38.458610534668, 0.671229379572133, -122.42138671875, -2.13665627309944, 218, 6, 'PPL', 'P'),
(24573, 'Rutherford (historical)', 33.8499984741211, 0.59079392516847, -83.3033294677734, -1.45391737708626, 218, 13, 'PPL', 'P'),
(61635, 'Rutherford (historical)', 32.9422187805176, 0.574950180632343, -89.7472229003906, -1.56638453413307, 218, 30, 'PPL', 'P'),
(68452, 'Rutherford College', 35.7483291625977, 0.623926045974036, -81.5227813720703, -1.42284095032613, 218, 33, 'PPL', 'P'),
(166767, 'Rutherford Gardens', 40.2638893127441, 0.702737438165942, -76.7938919067383, -1.34030625919321, 218, 45, 'PPL', 'P'),
(51122, 'Rutherford Green', 39.3377799987793, 0.68657378140387, -76.7483291625977, -1.33951103929171, 218, 25, 'PPL', 'P'),
(166752, 'Rutherford Heights', 40.267219543457, 0.702795561656733, -76.7733306884766, -1.33994739823632, 218, 45, 'PPL', 'P'),
(97700, 'Rutherford-Harding Addition Colonia', 26.0799999237061, 0.455181867588541, -97.2559967041016, -1.69743735979533, 218, 51, 'PPL', 'P'),
(68454, 'Rutherfordton', 35.3691711425781, 0.617308490139353, -81.9569396972656, -1.43041844257573, 218, 33, 'PPL', 'P'),
(189396, 'Rutheron', 36.7186088562012, 0.64086062129266, -106.611106872559, -1.8607148341217, 218, 38, 'PPL', 'P'),
(68456, 'Rutherwood', 36.2244415283203, 0.632235774365356, -81.5988922119141, -1.42416933507786, 218, 33, 'PPL', 'P'),
(166753, 'Ruthfred Acres', 40.3180618286133, 0.703682926931947, -80.0561065673828, -1.39724264592829, 218, 45, 'PPL', 'P'),
(17881, 'Ruthland', 29.6505603790283, 0.517499903675422, -82.2680587768555, -1.43584849488035, 218, 12, 'PPL', 'P'),
(90551, 'Ruthledge Hill', 35.3086090087891, 0.616251481502701, -85.9411087036133, -1.49995530969241, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(51123, 'Ruthsburg', 39.003059387207, 0.680731804657645, -75.9583282470703, -1.32572292222199, 218, 25, 'PPL', 'P'),
(977, 'Ruthton', 36.5475006103516, 0.637874219025272, -82.1269378662109, -1.43338547034619, 218, 50, 'PPL', 'P'),
(38049, 'Ruthton', 37.732780456543, 0.658561254898844, -84.4336090087891, -1.47364447654492, 218, 21, 'PPL', 'P'),
(137872, 'Ruthton', 44.1766700744629, 0.771028345366626, -96.1036071777344, -1.67732436829472, 218, 28, 'PPL', 'P'),
(199665, 'Ruthton', 41.3111114501953, 0.721014912464238, -102.010276794434, -1.78041520093363, 218, 35, 'PPL', 'P'),
(117635, 'Ruthven', 43.1291694641113, 0.752746010799341, -94.8988876342773, -1.65629804569827, 218, 16, 'PPL', 'P'),
(184707, 'Ruthven', 32.9524993896484, 0.575129611110787, -115.010559082031, -2.00731293054091, 218, 6, 'PPL', 'P'),
(97701, 'Ruthven Colonia Number 2', 26.2929992675781, 0.458899407443696, -98.0690002441406, -1.71162694839938, 218, 51, 'PPL', 'P'),
(97702, 'Ruthven Number 1 Colonia', 26.2950000762939, 0.45893432814349, -98.0770034790039, -1.71176663119855, 218, 51, 'PPL', 'P'),
(90552, 'Ruthville', 36.4386100769043, 0.635973720692364, -88.7969436645508, -1.54979903265433, 218, 50, 'PPL', 'P'),
(105970, 'Ruthville', 37.3672218322754, 0.652181053296314, -77.041389465332, -1.34462590648132, 218, 53, 'PPL', 'P'),
(198849, 'Ruthville', 48.3716697692871, 0.844244902161466, -101.298332214355, -1.76798942391954, 218, 34, 'PPL', 'P'),
(17882, 'Rutland', 28.8527793884277, 0.50357599867962, -82.2136077880859, -1.43489814584535, 218, 12, 'PPL', 'P'),
(24574, 'Rutland', 32.7408294677734, 0.571435274046629, -83.6547164916992, -1.46005023760255, 218, 13, 'PPL', 'P'),
(38050, 'Rutland', 38.4447212219238, 0.670986965333908, -84.4508285522461, -1.47394501427393, 218, 21, 'PPL', 'P'),
(51124, 'Rutland', 38.9722213745117, 0.68019357980134, -76.6399993896484, -1.33762032807581, 218, 25, 'PPL', 'P'),
(74171, 'Rutland', 39.045280456543, 0.68146870133127, -82.1305618286133, -1.43344872042208, 218, 41, 'PPL', 'P'),
(97703, 'Rutland', 31.1875, 0.544324560465732, -94.7938919067383, -1.65446552455219, 218, 51, 'PPL', 'P'),
(117636, 'Rutland', 42.7591705322266, 0.74628831120909, -94.2975006103516, -1.645801862052, 218, 16, 'PPL', 'P'),
(121326, 'Rutland', 40.9841690063477, 0.715308690354579, -89.0416717529297, -1.55407034356865, 218, 18, 'PPL', 'P'),
(123605, 'Rutland', 41.2444381713867, 0.719851244225928, -86.3572235107422, -1.50721788314311, 218, 19, 'PPL', 'P'),
(126005, 'Rutland', 42.3694381713867, 0.739486198310864, -71.9486083984375, -1.25574010878078, 218, 23, 'PPL', 'P'),
(140819, 'Rutland', 46.0530586242676, 0.803777503607439, -97.5086135864258, -1.70184635613801, 218, 34, 'PPL', 'P'),
(171244, 'Rutland', 44.0894393920898, 0.769505882750455, -96.9669418334961, -1.69239240058433, 218, 49, 'PPL', 'P'),
(172478, 'Rutland', 43.6105613708496, 0.761147884564378, -72.9730606079102, -1.27362017286541, 218, 55, 'PPL', 'P'),
(176217, 'Rutland', 42.8788909912109, 0.748377827400366, -89.3499984741211, -1.55945166002532, 218, 57, 'PPL', 'P'),
(152271, 'Rutland Center', 43.9544410705566, 0.767149717555035, -75.8072204589844, -1.32308559379448, 218, 40, 'PPL', 'P'),
(51125, 'Rutland Estates', 38.9594383239746, 0.679970473481018, -76.6397171020508, -1.33761540122779, 218, 25, 'PPL', 'P'),
(5590, 'Rutledge', 31.7302799224854, 0.553797857226821, -86.3097229003906, -1.50638884109577, 218, 2, 'PPL', 'P'),
(17883, 'Rutledge', 29.6816692352295, 0.518042855642662, -82.4100036621094, -1.43832590048439, 218, 12, 'PPL', 'P'),
(24575, 'Rutledge', 33.6258316040039, 0.586881475211034, -83.6125030517578, -1.45931347408698, 218, 13, 'PPL', 'P'),
(51126, 'Rutledge', 39.5569381713867, 0.690398813098523, -76.4963912963867, -1.33511389401588, 218, 25, 'PPL', 'P'),
(79068, 'Rutledge', 39.901668548584, 0.696415493212257, -75.3288879394531, -1.3147371164093, 218, 45, 'PPL', 'P'),
(90553, 'Rutledge', 36.2808303833008, 0.633219945546195, -83.5149993896484, -1.45761171415042, 218, 50, 'PPL', 'P'),
(111243, 'Rutledge', 38.3641700744629, 0.669581082594456, -81.5405578613281, -1.42315120859312, 218, 58, 'PPL', 'P'),
(117639, 'Rutledge', 41.0611114501953, 0.716651589334252, -92.4211120605469, -1.61305270381118, 218, 16, 'PPL', 'P'),
(137875, 'Rutledge', 46.2644386291504, 0.807466780665526, -92.8672180175781, -1.62083872157414, 218, 28, 'PPL', 'P'),
(139430, 'Rutledge', 40.3136100769043, 0.703605229207144, -92.0880584716797, -1.60723982209987, 218, 29, 'PPL', 'P'),
(176219, 'Rutledge', 42.5547218322754, 0.74272000824352, -90.6336135864258, -1.5818549700634, 218, 57, 'PPL', 'P'),
(201515, 'Rutledge', 45.3380584716797, 0.791298396792519, -120.646110534668, -2.10567185855497, 218, 43, 'PPL', 'P'),
(90554, 'Rutledge Falls', 35.420280456543, 0.618200515946475, -86.1361083984375, -1.50335869640747, 218, 50, 'PPL', 'P'),
(5591, 'Rutledge Heights', 34.7463912963867, 0.606438931308249, -86.6413879394531, -1.51217748804116, 218, 2, 'PPL', 'P'),
(5592, 'Rutledge Springs', 33.461109161377, 0.584006526235267, -86.9475021362305, -1.51752018866202, 218, 2, 'PPL', 'P'),
(166755, 'Rutledgedale', 41.7102813720703, 0.727981741875885, -75.1791687011719, -1.31212402274772, 218, 45, 'PPL', 'P'),
(152273, 'Rutsonville', 41.6705589294434, 0.72728845446511, -74.2516708374023, -1.29593613121973, 218, 40, 'PPL', 'P'),
(189397, 'Rutter', 32.0213890075684, 0.558878669243987, -106.874443054199, -1.86531091753096, 218, 38, 'PPL', 'P'),
(5593, 'Rutthven', 31.8533306121826, 0.555945496908888, -87.0297164916992, -1.51895509985736, 218, 2, 'PPL', 'P'),
(208637, 'Ruxby', 46.5752792358398, 0.812891972701154, -118.489723205566, -2.06803579971386, 218, 56, 'PPL', 'P'),
(51127, 'Ruxton', 39.4000015258789, 0.687659751917377, -76.6449966430664, -1.33770754660151, 218, 25, 'PPL', 'P'),
(105974, 'Ruxton', 37.2208290100098, 0.649626016546492, -79.9902801513672, -1.39609375823403, 218, 53, 'PPL', 'P'),
(187296, 'Ruxton', 37.7480583190918, 0.658827903902988, -103.146110534668, -1.80023923945596, 218, 7, 'PPL', 'P'),
(105972, 'Ruxton (historical)', 36.875560760498, 0.643599948789915, -76.2505569458008, -1.33082327518366, 218, 53, 'PPL', 'P'),
(51128, 'Ruxton Hills', 39.3958282470703, 0.687586914461563, -76.6586074829102, -1.33794510057075, 218, 25, 'PPL', 'P'),
(51129, 'Ruxton Ridge', 39.4080581665039, 0.687800366822933, -76.64111328125, -1.33763976915177, 218, 25, 'PPL', 'P'),
(189398, 'Ruyle Place', 33.8497200012207, 0.59078906489948, -108.920280456543, -1.90101751616231, 218, 38, 'PPL', 'P'),
(90555, 'Ryall Springs', 35.0047187805176, 0.610947596454726, -85.1152801513672, -1.48554188239874, 218, 50, 'PPL', 'P'),
(5594, 'Ryan', 33.167781829834, 0.578886998513753, -86.8666687011719, -1.51610937907456, 218, 2, 'PPL', 'P'),
(11741, 'Ryan', 34.5436096191406, 0.602899723377588, -91.8274993896484, -1.60269220822245, 218, 4, 'PPL', 'P'),
(38051, 'Ryan', 38.3699989318848, 0.669682815348097, -83.482780456543, -1.45704938768625, 218, 21, 'PPL', 'P'),
(77151, 'Ryan', 34.0200004577637, 0.593761019517954, -97.9572219848633, -1.70967604974284, 218, 42, 'PPL', 'P'),
(105973, 'Ryan', 39.0149993896484, 0.680940197012943, -77.4933319091797, -1.35251379015597, 218, 53, 'PPL', 'P'),
(111244, 'Ryan', 38.6425018310547, 0.674438888159842, -81.4730606079102, -1.42197315928493, 218, 58, 'PPL', 'P'),
(117640, 'Ryan', 42.351390838623, 0.739171212932935, -91.4813919067383, -1.59665149307988, 218, 16, 'PPL', 'P'),
(121330, 'Ryan', 40.0502815246582, 0.69900927895594, -87.8061065673828, -1.53250566295785, 218, 18, 'PPL', 'P'),
(132943, 'Ryan', 43.4736099243164, 0.758757630907004, -84.3694381713867, -1.47252448414848, 218, 27, 'PPL', 'P'),
(137877, 'Ryan', 44.4238891601563, 0.775343132385745, -92.7152786254883, -1.61818687891869, 218, 28, 'PPL', 'P'),
(157479, 'Ryan', 41.6452789306641, 0.726847235251511, -83.4947204589844, -1.45725778004155, 218, 41, 'PPL', 'P'),
(179032, 'Ryan', 36.6883316040039, 0.640332183553361, -112.348609924316, -1.9608531532181, 218, 5, 'PPL', 'P'),
(184708, 'Ryan', 36.3230590820313, 0.633956975377874, -116.670562744141, -2.03628546003988, 218, 6, 'PPL', 'P'),
(192971, 'Ryan', 30.4300003051758, 0.531103696708197, -104.298332214355, -1.82034930147937, 218, 51, 'PPL', 'P'),
(208636, 'Ryan', 48.8141708374023, 0.851968002743668, -117.966110229492, -2.0588970292752, 218, 56, 'PPL', 'P'),
(5604, 'Ryan Crossroads', 34.3419418334961, 0.599379956522885, -86.6102828979492, -1.51163460265295, 218, 2, 'PPL', 'P'),
(209713, 'Ryan Park', 41.3213882446289, 0.721194276363655, -106.508331298828, -1.85892106196948, 218, 59, 'PPL', 'P'),
(137878, 'Ryan Village', 47.3588905334473, 0.826568569900229, -94.2888870239258, -1.64565152660846, 218, 28, 'PPL', 'P'),
(166757, 'Ryans Corner', 40.2627792358398, 0.702718063669012, -74.9697189331055, -1.30846843467742, 218, 45, 'PPL', 'P'),
(176221, 'Ryans Corner', 44.5133285522461, 0.776904144258695, -87.607780456543, -1.52904421933102, 218, 57, 'PPL', 'P'),
(111245, 'Ryanville', 39.3144416809082, 0.686166450915142, -80.2213897705078, -1.40012738202106, 218, 58, 'PPL', 'P'),
(42896, 'Rycade', 30.2625007629395, 0.528180278200589, -91.6030578613281, -1.59877496457505, 218, 22, 'PPL', 'P'),
(51130, 'Ryceville', 38.4355583190918, 0.670827042510449, -76.8308334350586, -1.34095101049312, 218, 25, 'PPL', 'P'),
(24576, 'Rydal', 34.3352813720703, 0.599263709541303, -84.7155609130859, -1.47856546560716, 218, 13, 'PPL', 'P'),
(33848, 'Rydal', 39.8133316040039, 0.694873722678183, -97.7111129760742, -1.70538063722065, 218, 20, 'PPL', 'P'),
(166758, 'Rydal', 40.1063919067383, 0.69998858986779, -75.10888671875, -1.31089737074963, 218, 45, 'PPL', 'P'),
(166759, 'Rydal East', 40.1066703796387, 0.699993450136779, -75.1133270263672, -1.31097486873735, 218, 45, 'PPL', 'P'),
(166760, 'Rydal Park', 40.1116714477539, 0.700080735241506, -75.1100006103516, -1.31091681182559, 218, 45, 'PPL', 'P'),
(166761, 'Ryde', 40.4355583190918, 0.705733627550336, -77.7591705322266, -1.35715354940711, 218, 45, 'PPL', 'P'),
(184709, 'Ryde', 38.2386093139648, 0.667389633912457, -121.559440612793, -2.12161247557575, 218, 6, 'PPL', 'P'),
(57320, 'Ryder', 39.3047218322754, 0.685996807553704, -92.4375, -1.61333872731226, 218, 29, 'PPL', 'P'),
(198845, 'Ryder', 47.9174995422363, 0.8363181363349, -101.67749786377, -1.77460711291228, 218, 34, 'PPL', 'P'),
(144396, 'Ryder Corner', 43.4052810668945, 0.757565067370867, -72.1283264160156, -1.25887677991267, 218, 36, 'PPL', 'P'),
(208638, 'Ryderwood', 46.3766708374023, 0.809425602226307, -123.042503356934, -2.14749680347467, 218, 56, 'PPL', 'P'),
(11742, 'Rye', 33.7461090087891, 0.588980711940289, -91.9977798461914, -1.60566416284092, 218, 4, 'PPL', 'P'),
(17884, 'Rye', 27.5141696929932, 0.480212852095168, -82.3680572509766, -1.43759379750073, 218, 12, 'PPL', 'P'),
(79070, 'Rye', 39.878059387207, 0.696003435612595, -76.663330078125, -1.33802752540648, 218, 45, 'PPL', 'P'),
(97705, 'Rye', 30.7291698455811, 0.536325190209947, -96.4899978637695, -1.68406815796507, 218, 51, 'PPL', 'P'),
(144397, 'Rye', 43.0133285522461, 0.75072420547878, -70.7713928222656, -1.23519382097082, 218, 36, 'PPL', 'P'),
(152274, 'Rye', 40.9805603027344, 0.715245706594799, -73.6841735839844, -1.28603143565156, 218, 40, 'PPL', 'P'),
(179033, 'Rye', 34.1094398498535, 0.595322031390904, -111.353057861328, -1.94347749184393, 218, 5, 'PPL', 'P'),
(187297, 'Rye', 37.9236106872559, 0.661891870737124, -104.929718017578, -1.83136906259596, 218, 7, 'PPL', 'P'),
(208640, 'Rye', 46.8691711425781, 0.818021354118701, -120.116668701172, -2.09643135536267, 218, 56, 'PPL', 'P'),
(61636, 'Rye (historical)', 33.771671295166, 0.589426858001905, -88.3208312988281, -1.54148930426301, 218, 30, 'PPL', 'P'),
(144398, 'Rye Beach', 42.9766693115234, 0.750084381026889, -70.76611328125, -1.2351016755971, 218, 36, 'PPL', 'P'),
(157480, 'Rye beach', 41.4088897705078, 0.72272146609076, -82.5833282470703, -1.44135098516661, 218, 41, 'PPL', 'P'),
(152275, 'Rye Brook', 41.0191688537598, 0.715919552929616, -73.6838912963867, -1.28602650880354, 218, 40, 'PPL', 'P'),
(105975, 'Rye Cove', 36.7252807617188, 0.640977068011323, -82.6963882446289, -1.44332425437631, 218, 53, 'PPL', 'P'),
(126007, 'Rye Hill', 42.086109161377, 0.734541174219777, -70.908332824707, -1.23758387489111, 218, 23, 'PPL', 'P'),
(144399, 'Rye North Beach', 43.0127792358398, 0.750714618098856, -70.7358322143555, -1.23457317127877, 218, 36, 'PPL', 'P'),
(200179, 'Rye Patch', 40.4474983215332, 0.705942019905634, -118.288612365723, -2.06452575339714, 218, 39, 'PPL', 'P'),
(201516, 'Rye Valley', 44.4638900756836, 0.776041280065509, -117.476387023926, -2.05034974691465, 218, 43, 'PPL', 'P'),
(197451, 'Ryegate', 46.2972183227539, 0.808038894246702, -109.258056640625, -1.90691282270936, 218, 31, 'PPL', 'P'),
(172482, 'Ryegate Corner', 44.2083282470703, 0.77158088471379, -72.1041717529297, -1.25845520151211, 218, 55, 'PPL', 'P'),
(166763, 'Ryeland', 40.3519401550293, 0.704274215272972, -76.1791687011719, -1.32957731526766, 218, 45, 'PPL', 'P'),
(166764, 'Ryers', 40.0636100769043, 0.699241906077159, -75.0875015258789, -1.31052412872285, 218, 45, 'PPL', 'P'),
(79071, 'Ryerson Station', 39.8925018310547, 0.696255503809771, -80.4749984741211, -1.40455368891083, 218, 45, 'PPL', 'P'),
(68460, 'Ryes', 35.4322204589844, 0.618408908301774, -79.0008316040039, -1.37882462330346, 218, 33, 'PPL', 'P'),
(11743, 'Ryker', 35.8880615234375, 0.626364835742277, -93.4733276367188, -1.63141733005615, 218, 4, 'PPL', 'P'),
(5595, 'Ryland', 34.769718170166, 0.606846062059895, -86.480827331543, -1.50937517678413, 218, 2, 'PPL', 'P'),
(38053, 'Ryland', 38.9386100769043, 0.679606951992222, -84.4691696166992, -1.47426512623696, 218, 21, 'PPL', 'P'),
(68457, 'Ryland', 36.2769393920898, 0.633152034938398, -76.6236114501953, -1.33733430457474, 218, 33, 'PPL', 'P'),
(105977, 'Ryland Corner', 38.0386085510254, 0.663898962092663, -77.5175018310547, -1.35293563487264, 218, 53, 'PPL', 'P'),
(38055, 'Ryland Heights', 38.9575004577637, 0.679936651335174, -84.4630584716797, -1.4741584666353, 218, 21, 'PPL', 'P'),
(38054, 'Ryle', 38.795280456543, 0.677105378201284, -84.716667175293, -1.47858477352507, 218, 21, 'PPL', 'P'),
(97707, 'Rylie', 32.690559387207, 0.570557895625503, -96.6372222900391, -1.68663770894284, 218, 51, 'PPL', 'P'),
(111246, 'Rymer', 39.540828704834, 0.690117649866438, -80.4402770996094, -1.40394768660478, 218, 58, 'PPL', 'P'),
(97706, 'Rymers', 28.8561096191406, 0.503634122170411, -95.9413909912109, -1.67449316173986, 218, 51, 'PPL', 'P'),
(90560, 'Rymers (historical)', 35.1319389343262, 0.61316800701358, -84.4305572509766, -1.47359121332311, 218, 50, 'PPL', 'P'),
(68458, 'Rymers Ferry', 35.4449996948242, 0.618631948043068, -83.8697204589844, -1.46380276473653, 218, 33, 'PPL', 'P'),
(166765, 'Rynd Farm', 41.4824981689453, 0.724006175000615, -79.6949996948242, -1.39094014205056, 218, 45, 'PPL', 'P'),
(200181, 'Ryndon', 40.9419403076172, 0.7145716605229, -115.594718933105, -2.01750844330012, 218, 39, 'PPL', 'P'),
(42897, 'Rynella', 29.9463901519775, 0.522663107238813, -91.8758316040039, -1.60353576449773, 218, 22, 'PPL', 'P'),
(152278, 'Rynex Corners', 42.8213882446289, 0.74737421514357, -74.0716705322266, -1.29279453323981, 218, 40, 'PPL', 'P'),
(24577, 'Ryo', 34.4538917541504, 0.601333851235649, -84.6738891601563, -1.47783815631346, 218, 13, 'PPL', 'P'),
(57321, 'Ryors', 38.4824981689453, 0.671646297440785, -91.6980590820313, -1.60043304866973, 218, 29, 'PPL', 'P'),
(166766, 'Ryot', 40.1458282470703, 0.70067688385152, -78.6369400024414, -1.37247351673584, 218, 45, 'PPL', 'P'),
(187875, 'Ryus', 37.4977798461914, 0.654459720504013, -101.107780456543, -1.76466366835025, 218, 20, 'PPL', 'P'),
(97709, 'S and C Colonia', 26.3640003204346, 0.460138609588423, -97.7900009155273, -1.70675749150422, 218, 51, 'PPL', 'P'),
(179034, 'S C Townhouse Mobile Home Estates', 33.5769386291504, 0.586028131818746, -112.270561218262, -1.95949094632052, 218, 5, 'PPL', 'P'),
(90556, 'S E Miller Subdivision', 36.3188896179199, 0.633884204501088, -82.3722229003906, -1.43766650179849, 218, 50, 'PPL', 'P'),
(192151, 'S N Junction', 31.4213905334473, 0.548406720363632, -100.462501525879, -1.75340142641641, 218, 51, 'PPL', 'P'),
(97708, 'S Truman Phelps Colonia', 26.875560760498, 0.469067023590482, -99.3019409179688, -1.73314582263944, 218, 51, 'PPL', 'P'),
(152279, 'Sabael', 43.728328704834, 0.763203312293701, -74.3061065673828, -1.29688621393861, 218, 40, 'PPL', 'P'),
(17887, 'Sabal Palms Estates', 26.2058296203613, 0.457378010091961, -80.2111129760742, -1.39994801812164, 218, 12, 'PPL', 'P'),
(97712, 'Sabanno', 32.1852798461914, 0.561739103991814, -99.0902786254883, -1.72945161873333, 218, 51, 'PPL', 'P'),
(14536, 'Sabarto East', 39.2105598449707, 0.684353370845016, -75.5691680908203, -1.31893079617785, 218, 10, 'PPL', 'P'),
(97713, 'Sabathany', 32.9047203063965, 0.574295708794456, -97.6122207641602, -1.70365464251817, 218, 51, 'PPL', 'P'),
(152280, 'Sabattis', 44.0808296203613, 0.769355613885947, -74.7030563354492, -1.3038142943564, 218, 40, 'PPL', 'P'),
(128711, 'Sabattus', 44.1197204589844, 0.770034387068781, -70.1080627441406, -1.22361652708002, 218, 26, 'PPL', 'P'),
(144401, 'Sabattus Heights', 43.3650016784668, 0.756862059422113, -71.4024963378906, -1.24620865523939, 218, 36, 'PPL', 'P'),
(152281, 'Sabbath Day Point', 43.6674995422363, 0.762141643125141, -73.5144424438477, -1.28306906841301, 218, 40, 'PPL', 'P'),
(33849, 'Sabetha', 39.9022216796875, 0.696425147171209, -95.8005599975586, -1.67203519721177, 218, 20, 'PPL', 'P'),
(51131, 'Sabillasville', 39.7000007629395, 0.692895726357554, -77.456672668457, -1.35187396570408, 218, 25, 'PPL', 'P'),
(137879, 'Sabin', 46.7797203063965, 0.816460142508669, -96.6527786254883, -1.68690921821597, 218, 28, 'PPL', 'P'),
(176220, 'Sabin', 43.4302787780762, 0.758001359736449, -90.5686111450195, -1.58072046343902, 218, 57, 'PPL', 'P'),
(74172, 'Sabina', 39.4886093139648, 0.689206249562386, -83.6369400024414, -1.45973997933556, 218, 41, 'PPL', 'P'),
(121331, 'Sabina', 40.3472213745117, 0.704191857016262, -88.6505584716797, -1.54724412906256, 218, 18, 'PPL', 'P'),
(97714, 'Sabinal', 29.3172206878662, 0.511682028537062, -99.4661102294922, -1.73601111765625, 218, 51, 'PPL', 'P'),
(189401, 'Sabinal', 34.4936103820801, 0.602027072067397, -106.806938171387, -1.86413273506471, 218, 38, 'PPL', 'P'),
(97716, 'Sabine', 29.7197208404541, 0.5187069814395, -93.8713912963867, -1.6383648515499, 218, 51, 'PPL', 'P'),
(111247, 'Sabine', 37.6786117553711, 0.657615832711866, -81.5016708374023, -1.42247250198932, 218, 58, 'PPL', 'P'),
(97717, 'Sabine Pass', 29.7333297729492, 0.518944502119222, -93.894172668457, -1.63876246150065, 218, 51, 'PPL', 'P'),
(97718, 'Sabinetown', 31.4027805328369, 0.548081914579183, -93.7083282470703, -1.63551886445098, 218, 51, 'PPL', 'P'),
(61637, 'Sabino', 34.2041702270508, 0.596975388374653, -90.4072189331055, -1.57790363795405, 218, 30, 'PPL', 'P'),
(128713, 'Sabino', 43.8547210693359, 0.765409275203641, -69.8636093139648, -1.21935000985566, 218, 26, 'PPL', 'P'),
(189402, 'Sabino', 35.9905586242676, 0.62815374762551, -103.958892822266, -1.81442496647644, 218, 38, 'PPL', 'P'),
(189403, 'Sabinoso', 35.6988906860352, 0.623063181780851, -104.407501220703, -1.82225466008127, 218, 38, 'PPL', 'P'),
(166769, 'Sabinsville', 41.8677787780762, 0.730730590174038, -77.5255584716797, -1.35307624977819, 218, 45, 'PPL', 'P'),
(61638, 'Sable', 32.2011108398438, 0.56201540695491, -88.6877822875977, -1.54789380721049, 218, 30, 'PPL', 'P'),
(187298, 'Sable', 39.7663917541504, 0.694054467747848, -104.830558776855, -1.82963840736157, 218, 7, 'PPL', 'P'),
(42900, 'Sable Chase', 30.350830078125, 0.529721915576609, -91.1347198486328, -1.59060092424127, 218, 22, 'PPL', 'P'),
(51132, 'Sable Woods', 39.5097198486328, 0.689574697899198, -76.3261108398438, -1.33214193939741, 218, 25, 'PPL', 'P'),
(184710, 'Sablon', 34.1747207641602, 0.596461398284267, -114.993606567383, -2.0070170533438, 218, 6, 'PPL', 'P'),
(105978, 'Sabot', 37.6130599975586, 0.656471738707568, -77.7472229003906, -1.35694502389375, 218, 53, 'PPL', 'P'),
(61639, 'Sabougla', 33.7758293151855, 0.589499429141609, -89.4641723632813, -1.56144437031097, 218, 30, 'PPL', 'P'),
(197452, 'Sabra (historical)', 46.0938911437988, 0.804490165515145, -106.437782287598, -1.85768974943948, 218, 31, 'PPL', 'P'),
(111248, 'Sabraton', 39.6294403076172, 0.691664214090474, -79.9286117553711, -1.39501744167947, 218, 58, 'PPL', 'P'),
(184711, 'Sabre City', 38.7222213745117, 0.675830256671354, -121.354721069336, -2.11803944549925, 218, 6, 'PPL', 'P'),
(184712, 'Sabre Springs', 32.9533309936523, 0.575144125338728, -117.093612670898, -2.04366907416213, 218, 6, 'PPL', 'P'),
(51133, 'Sabrina Park', 39.0952796936035, 0.682341352641461, -76.5725021362305, -1.33644227876761, 218, 25, 'PPL', 'P'),
(57322, 'Sabula', 37.4047203063965, 0.652835525134201, -90.6961135864258, -1.58294580084589, 218, 29, 'PPL', 'P'),
(117641, 'Sabula', 42.0711097717285, 0.734279385484623, -90.1738891601563, -1.57383126517315, 218, 16, 'PPL', 'P'),
(166770, 'Sabula', 41.1563911437988, 0.718314533697925, -78.6688919067383, -1.3730311826681, 218, 45, 'PPL', 'P'),
(90557, 'Sac (historical)', 36.5141716003418, 0.637292518064171, -82.3722229003906, -1.43766650179849, 218, 50, 'PPL', 'P'),
(132944, 'Sac Bay', 45.6500015258789, 0.796742830167022, -86.6916732788086, -1.5130551327784, 218, 27, 'PPL', 'P'),
(117642, 'Sac City', 42.4222183227539, 0.740407385731922, -94.9894409179688, -1.65787849864718, 218, 16, 'PPL', 'P'),
(117643, 'Sac City Junction (historical)', 42.2680587768555, 0.737716794082615, -95.0727767944336, -1.65933298407653, 218, 16, 'PPL', 'P'),
(184713, 'Sacanap', 37.8933296203613, 0.661363366418798, -122.074996948242, -2.13061063110886, 218, 6, 'PPL', 'P'),
(152282, 'Sacandaga Park', 43.2161102294922, 0.754263413409441, -74.1897201538086, -1.29485488781715, 218, 40, 'PPL', 'P'),
(179035, 'Sacate', 33.1772193908691, 0.579051715027174, -112.080001831055, -1.95616505759318, 218, 5, 'PPL', 'P'),
(184714, 'Sacate', 34.4722213745117, 0.601653763461595, -120.292503356934, -2.09950024904482, 218, 6, 'PPL', 'P'),
(179036, 'Sacaton', 33.0766716003418, 0.577296825026866, -111.738609313965, -1.95020663412829, 218, 5, 'PPL', 'P'),
(179037, 'Sacaton Flats', 33.0699996948242, 0.577180378308203, -111.667778015137, -1.94897039475027, 218, 5, 'PPL', 'P'),
(114015, 'Sachem Head', 41.2458305358887, 0.719875545570875, -72.7041702270508, -1.26892715039247, 218, 8, 'PPL', 'P'),
(144402, 'Sachem Village', 43.6830596923828, 0.762413218977301, -72.2861099243164, -1.26163062163787, 218, 36, 'PPL', 'P'),
(97719, 'Sachse', 32.9761085510254, 0.57554166871045, -96.5950012207031, -1.68590081226921, 218, 51, 'PPL', 'P'),
(169586, 'Sachuest', 41.480281829834, 0.723967492585781, -71.241943359375, -1.2434064771404, 218, 47, 'PPL', 'P'),
(51134, 'Sackertown', 37.9722213745117, 0.662740287281396, -75.8430633544922, -1.32371117033454, 218, 25, 'PPL', 'P'),
(152283, 'Sackets Harbor', 43.9461097717285, 0.767004308959516, -76.1194381713867, -1.32853482085895, 218, 40, 'PPL', 'P'),
(38056, 'Sackett', 37.2024993896484, 0.649306104320546, -82.8852767944336, -1.44662098148972, 218, 21, 'PPL', 'P'),
(166771, 'Sackett', 41.5313911437988, 0.724859518392903, -78.9038925170898, -1.37713271706293, 218, 45, 'PPL', 'P'),
(152284, 'Sacketts Harbor', 42.7963905334473, 0.746937922777987, -77.7211074829102, -1.35648922387318, 218, 40, 'PPL', 'P'),
(42901, 'Sacksonia', 32.4663887023926, 0.56664537908904, -91.601936340332, -1.59875539034104, 218, 22, 'PPL', 'P'),
(79072, 'Sackville', 39.8877792358398, 0.696173078974033, -75.383056640625, -1.31568253859628, 218, 45, 'PPL', 'P'),
(24578, 'Sackville (historical)', 32.0255584716797, 0.558951440120774, -81.0922164916992, -1.4153261755202, 218, 13, 'PPL', 'P'),
(277, 'Saco', 31.9549999237061, 0.557719961143207, -85.8208312988281, -1.49785607296315, 218, 2, 'PPL', 'P'),
(57323, 'Saco', 37.3655586242676, 0.652152024840432, -90.4391708374023, -1.57846130388631, 218, 29, 'PPL', 'P'),
(128714, 'Saco', 43.5008316040039, 0.759232738845474, -70.4433288574219, -1.22946802462715, 218, 26, 'PPL', 'P'),
(137881, 'Saco', 44.0044403076172, 0.768022368865226, -93.26611328125, -1.62780075729582, 218, 28, 'PPL', 'P'),
(166774, 'Saco', 41.8108291625977, 0.729736631876193, -76.5352783203125, -1.33579260061969, 218, 45, 'PPL', 'P'),
(184716, 'Saco', 35.4444389343262, 0.618622160926062, -119.09139251709, -2.07853691020816, 218, 6, 'PPL', 'P'),
(197453, 'Saco', 48.457218170166, 0.845738003426619, -107.341941833496, -1.87347031047875, 218, 31, 'PPL', 'P'),
(24579, 'Saco (historical)', 31.1849994659424, 0.544280917913368, -84.083610534668, -1.46753585079455, 218, 13, 'PPL', 'P'),
(126008, 'Saconesset Hills', 41.5777816772461, 0.725669185943315, -70.6402816772461, -1.23290549980417, 218, 23, 'PPL', 'P'),
(68459, 'Saconon', 35.3402786254883, 0.616804220586947, -82.350830078125, -1.43729312661366, 218, 33, 'PPL', 'P'),
(28490, 'Sacramento', 38.0316696166992, 0.663777854842091, -88.3375015258789, -1.5417802546121, 218, 18, 'PPL', 'P'),
(38057, 'Sacramento', 37.415828704834, 0.653029403261559, -87.2655563354492, -1.52307128163819, 218, 21, 'PPL', 'P'),
(142913, 'Sacramento', 40.4088897705078, 0.705268173570817, -99.2747192382813, -1.73267071470097, 218, 35, 'PPL', 'P'),
(166773, 'Sacramento', 40.6344413757324, 0.709204791715145, -76.5891723632813, -1.3367332291167, 218, 45, 'PPL', 'P'),
(184715, 'Sacramento', 38.5816688537598, 0.673377152412254, -121.49333190918, -2.12045866103347, 218, 6, 'PPL', 'P'),
(187299, 'Sacramento', 39.2213897705078, 0.684542388703384, -106.106941223145, -1.85191548356397, 218, 7, 'PPL', 'P'),
(189404, 'Sacramento', 32.7924995422363, 0.572337086970757, -105.559997558594, -1.84236951579464, 218, 38, 'PPL', 'P'),
(184718, 'Sacramento Landing', 38.1497192382813, 0.665838209419431, -122.905281066895, -2.14510182270636, 218, 6, 'PPL', 'P'),
(77153, 'Sacred Heart', 35.0011100769043, 0.610884612694946, -96.8091735839844, -1.68963882517525, 218, 42, 'PPL', 'P'),
(137882, 'Sacred Heart', 44.7869415283203, 0.781679591567371, -95.3513870239258, -1.6641956499109, 218, 28, 'PPL', 'P'),
(97720, 'Sacul', 31.8247203826904, 0.555446154204498, -94.9186096191406, -1.65664225926916, 218, 51, 'PPL', 'P'),
(57324, 'Sacville', 37.3938903808594, 0.652646507275833, -93.4288864135742, -1.63064168438867, 218, 29, 'PPL', 'P'),
(11744, 'Saddle', 36.3549995422363, 0.634514441573055, -91.6386108398438, -1.59939548110904, 218, 4, 'PPL', 'P'),
(179038, 'Saddle', 33.1577796936035, 0.578712428304298, -113.079437255859, -1.97360849641709, 218, 5, 'PPL', 'P'),
(24580, 'Saddle Acres', 33.4208297729492, 0.583303518286513, -83.8397216796875, -1.46327918726622, 218, 13, 'PPL', 'P'),
(146249, 'Saddle Brook', 40.8988914489746, 0.713820316200361, -74.0930633544922, -1.29316790842464, 218, 37, 'PPL', 'P'),
(197454, 'Saddle Butte', 48.5227813720703, 0.846882297167999, -109.644721984863, -1.91366140606968, 218, 31, 'PPL', 'P'),
(24581, 'Saddle Club Estates', 33.8594398498535, 0.590958708260918, -83.9963912963867, -1.46601358791546, 218, 13, 'PPL', 'P'),
(5597, 'Saddle Hill', 31.4552803039551, 0.548998208441739, -86.1305618286133, -1.50326189050185, 218, 2, 'PPL', 'P'),
(184719, 'Saddle Junction', 33.7738914489746, 0.589465606995765, -116.673332214355, -2.03633379641367, 218, 6, 'PPL', 'P'),
(68461, 'Saddle Mountain', 36.5074996948242, 0.637176071345508, -80.9388885498047, -1.41265009809883, 218, 33, 'PPL', 'P'),
(17888, 'Saddle Oak Club', 29.1269397735596, 0.508361000078706, -82.2130584716797, -1.43488855846543, 218, 12, 'PPL', 'P'),
(51135, 'Saddle Ridge', 39.0152816772461, 0.68094512386096, -76.6913909912109, -1.33851728073095, 218, 25, 'PPL', 'P'),
(24583, 'Saddle Ridge Estates', 34.2574996948242, 0.597906163175635, -84.8438873291016, -1.48080518408392, 218, 13, 'PPL', 'P'),
(146248, 'Saddle River', 41.0316696166992, 0.716137732401921, -74.1025009155273, -1.29333262493806, 218, 37, 'PPL', 'P'),
(211092, 'Saddle Road Junction', 19.9391708374023, 0.348004181230306, -155.690277099609, -2.71730794873051, 218, 15, 'PPL', 'P'),
(152289, 'Saddle Rock', 40.7941703796387, 0.71199258874424, -73.748893737793, -1.28716101542791, 218, 40, 'PPL', 'P'),
(152285, 'Saddle Rock Estates', 40.7936096191406, 0.711982801627234, -73.7422180175781, -1.28704450213022, 218, 40, 'PPL', 'P'),
(24584, 'Saddle Up Estates', 33.9841690063477, 0.593135642714976, -84.8680572509766, -1.48122702880059, 218, 13, 'PPL', 'P'),
(24585, 'Saddleback Estates', 33.9394416809082, 0.592355003620447, -83.9308319091797, -1.4648693607531, 218, 13, 'PPL', 'P'),
(24586, 'Saddleback Ridge', 33.7769393920898, 0.58951880363854, -84.5824966430664, -1.47624305597856, 218, 13, 'PPL', 'P'),
(24587, 'Saddlecreek', 32.4130592346191, 0.565714604288057, -81.8405609130859, -1.42838724961233, 218, 13, 'PPL', 'P'),
(179039, 'Saddlehorn Ranch', 33.6411094665527, 0.587148124215178, -112.187782287598, -1.95804618142916, 218, 5, 'PPL', 'P'),
(105979, 'Saddlers Crossroads', 36.9047203063965, 0.644108878874229, -76.9477767944336, -1.34299205715255, 218, 53, 'PPL', 'P'),
(209714, 'Saddlestring', 44.4550018310547, 0.775886150932012, -106.896667480469, -1.86569880694373, 218, 59, 'PPL', 'P'),
(68462, 'Saddletree', 34.7174987792969, 0.605934661755843, -79.0330581665039, -1.37938708292569, 218, 33, 'PPL', 'P'),
(24588, 'Saddlewood', 34.0013885498047, 0.593436180443992, -83.9430618286133, -1.46508281311447, 218, 13, 'PPL', 'P'),
(42902, 'Sadie', 32.9891700744629, 0.57576963529976, -92.230827331543, -1.6097316087738, 218, 22, 'PPL', 'P'),
(77155, 'Sadie', 35.3877792358398, 0.617633262634288, -94.853889465332, -1.65551267949281, 218, 42, 'PPL', 'P'),
(90558, 'Sadie', 36.4324989318848, 0.635867061090706, -82.0552825927734, -1.43213484989829, 218, 50, 'PPL', 'P'),
(197455, 'Sadie (historical)', 46.3333282470703, 0.80866913131867, -106.093063354492, -1.85167326906283, 218, 31, 'PPL', 'P'),
(38059, 'Sadieville', 38.3891716003418, 0.670017441539065, -84.5374984741211, -1.4754576897731, 218, 21, 'PPL', 'P'),
(38058, 'Sadler', 37.357780456543, 0.652016270203865, -86.3341674804688, -1.5068154795024, 218, 21, 'PPL', 'P'),
(57326, 'Sadler', 39.4386100769043, 0.688333598252194, -94.9416732788086, -1.65704479606793, 218, 29, 'PPL', 'P'),
(68465, 'Sadler', 36.4086112976074, 0.635450143222055, -79.6172180175781, -1.38958259568489, 218, 33, 'PPL', 'P'),
(90559, 'Sadler', 36.2236099243164, 0.632221260137415, -85.7361068725586, -1.49637735276789, 218, 50, 'PPL', 'P'),
(97721, 'Sadler', 33.6824989318848, 0.587870506660862, -96.8480606079102, -1.69031753177905, 218, 51, 'PPL', 'P'),
(83425, 'Sadler (historical)', 34.4430618286133, 0.601144833377281, -82.8327789306641, -1.44570472091668, 218, 48, 'PPL', 'P'),
(105981, 'Sadler Heights', 36.7649993896484, 0.641670288843071, -76.5913925170898, -1.33677197811057, 218, 53, 'PPL', 'P'),
(166775, 'Sadlers Corner', 41.3972206115723, 0.722517800846397, -79.6247177124023, -1.38971349005247, 218, 45, 'PPL', 'P'),
(24589, 'Sadlers Cove', 30.8675003051758, 0.538739512185672, -81.6180572509766, -1.42450382811077, 218, 13, 'PPL', 'P'),
(24590, 'Sadlers Landing', 30.8711109161377, 0.538802529234966, -81.6083297729492, -1.42433405159128, 218, 13, 'PPL', 'P'),
(90561, 'Sadlersville', 36.6100006103516, 0.638965049807768, -87.1180572509766, -1.52049693697046, 218, 50, 'PPL', 'P'),
(28491, 'Sadorus', 39.9669418334961, 0.697554726947566, -88.3463897705078, -1.5419353837456, 218, 18, 'PPL', 'P'),
(42903, 'Sadou', 30.2372207641602, 0.527739058986991, -92.1427764892578, -1.60819483166677, 218, 22, 'PPL', 'P'),
(79073, 'Sadsbury Meeting House', 39.9708290100098, 0.697622570976336, -75.9911117553711, -1.32629510238219, 218, 45, 'PPL', 'P'),
(79076, 'Sadsburyville', 39.9816703796387, 0.697811788571786, -75.8916702270508, -1.32455952029979, 218, 45, 'PPL', 'P'),
(51136, 'Saefern', 39.0125007629395, 0.680896587750093, -76.5458297729492, -1.33597675820907, 218, 25, 'PPL', 'P'),
(166777, 'Saegers', 41.1891708374023, 0.718886647279101, -76.8294372558594, -1.34092664256914, 218, 45, 'PPL', 'P'),
(166778, 'Saegersville', 40.7005615234375, 0.710358805994504, -75.6900024414063, -1.32103975344509, 218, 45, 'PPL', 'P'),
(166779, 'Saegertown', 41.7188911437988, 0.728132010740393, -80.1477813720703, -1.39884267311121, 218, 45, 'PPL', 'P'),
(57327, 'Safe', 38.0883293151855, 0.664766753133865, -91.6519393920898, -1.59962810823026, 218, 29, 'PPL', 'P'),
(68466, 'Safe', 34.7472190856934, 0.606453378957163, -78.0597229003906, -1.36239917780623, 218, 33, 'PPL', 'P'),
(79077, 'Safe Harbor', 39.9300003051758, 0.696909975647658, -76.3797225952148, -1.33307764104641, 218, 45, 'PPL', 'P'),
(17889, 'Safety Harbor', 27.9905605316162, 0.488527440755477, -82.6933288574219, -1.44327085799645, 218, 12, 'PPL', 'P'),
(11745, 'Saffell', 35.9197196960449, 0.626917375089441, -91.2900009155273, -1.59331109012459, 218, 4, 'PPL', 'P'),
(24591, 'Saffold', 31.1200008392334, 0.543146477868021, -85.033332824707, -1.48411163173531, 218, 13, 'PPL', 'P'),
(5600, 'Safford', 32.2877807617188, 0.563528082454075, -87.3713912963867, -1.52491845017027, 218, 2, 'PPL', 'P'),
(179040, 'Safford', 32.8338890075684, 0.573059469416441, -109.706939697266, -1.91474731000416, 218, 5, 'PPL', 'P'),
(33851, 'Saffordville', 38.4000015258789, 0.670206459397433, -96.3925018310547, -1.68236653118657, 218, 20, 'PPL', 'P'),
(90562, 'Safley', 35.6158294677734, 0.621613490041466, -85.7088928222656, -1.49590237798747, 218, 50, 'PPL', 'P'),
(121333, 'Sag Bridge', 41.6883316040039, 0.727598646153077, -87.9330596923828, -1.53472141298479, 218, 18, 'PPL', 'P'),
(152286, 'Sag Harbor', 40.9977798461914, 0.715546244323814, -72.2930603027344, -1.26175192862552, 218, 40, 'PPL', 'P'),
(17890, 'Saga Bay', 25.5791702270508, 0.446440740390142, -80.3186111450195, -1.4018242151096, 218, 12, 'PPL', 'P'),
(137884, 'Saga Hill', 44.954719543457, 0.784607870343967, -93.6397171020508, -1.63432137406683, 218, 28, 'PPL', 'P'),
(24592, 'Sagamore', 34.3461112976074, 0.599452727399671, -83.8166732788086, -1.46287691678356, 218, 13, 'PPL', 'P'),
(126009, 'Sagamore', 41.7700004577637, 0.729024036547515, -70.5288925170898, -1.23096139220841, 218, 23, 'PPL', 'P'),
(152287, 'Sagamore', 43.7644386291504, 0.763833549365668, -74.6286087036133, -1.30251493806055, 218, 40, 'PPL', 'P'),
(166782, 'Sagamore', 40.0325012207031, 0.698698954109919, -79.398063659668, -1.38575763056926, 218, 45, 'PPL', 'P'),
(126010, 'Sagamore Beach', 41.7983283996582, 0.729518452403888, -70.5294418334961, -1.23097097958833, 218, 23, 'PPL', 'P'),
(166783, 'Sagamore Estates', 41.3686103820801, 0.722018458142007, -74.9038925170898, -1.30731954698316, 218, 45, 'PPL', 'P'),
(51137, 'Sagamore Forest', 39.4702796936035, 0.68888633733644, -76.7980575561523, -1.34037896349097, 218, 25, 'PPL', 'P'),
(144403, 'Sagamore Grove', 43.0538902282715, 0.75143214027555, -70.7480621337891, -1.23478662364014, 218, 36, 'PPL', 'P'),
(126011, 'Sagamore Highlands', 41.8066711425781, 0.729664060736488, -70.5361099243164, -1.23108735972797, 218, 23, 'PPL', 'P'),
(24593, 'Sagamore Hills', 33.9236106872559, 0.592078700657351, -83.482780456543, -1.45704938768625, 218, 13, 'PPL', 'P'),
(157481, 'Sagamore Hills', 41.3116683959961, 0.721024633002216, -81.5683288574219, -1.42363590391152, 218, 41, 'PPL', 'P'),
(51138, 'Sagamore Village', 39.4694404602051, 0.688871689950445, -76.804443359375, -1.34049041678259, 218, 25, 'PPL', 'P'),
(128717, 'Sagamore Village', 43.6769409179688, 0.762306426217589, -70.3216705322266, -1.22734468629003, 218, 26, 'PPL', 'P'),
(132945, 'Saganing', 43.9288902282715, 0.766703771230501, -83.9102783203125, -1.46451063295427, 218, 27, 'PPL', 'P'),
(152288, 'Sagaponack', 40.9252815246582, 0.714280909910891, -72.2786102294922, -1.26149972727029, 218, 40, 'PPL', 'P'),
(11746, 'Sage', 36.0458297729492, 0.629118411151364, -91.8161087036133, -1.60249340324707, 218, 4, 'PPL', 'P'),
(184721, 'Sage', 33.5816688537598, 0.586110689812538, -116.93138885498, -2.04083773444921, 218, 6, 'PPL', 'P'),
(200183, 'Sage', 40.7702789306641, 0.711575604296561, -114.545829772949, -1.99920187396691, 218, 39, 'PPL', 'P'),
(209715, 'Sage', 41.8136100769043, 0.729785167987059, -110.957496643066, -1.93657364619206, 218, 59, 'PPL', 'P'),
(90563, 'Sage (historical)', 35.0741691589355, 0.612159734224876, -87.9124984741211, -1.5343625520279, 218, 50, 'PPL', 'P'),
(184722, 'Sage (historical)', 35.0688896179199, 0.612067588851159, -118.178611755371, -2.0626058805673, 218, 6, 'PPL', 'P'),
(197456, 'Sage Creek Colony', 48.9294395446777, 0.853979821210142, -110.973609924316, -1.93685487600318, 218, 31, 'PPL', 'P'),
(205648, 'Sage Creek Junction', 41.7713890075684, 0.729048271313434, -111.120277404785, -1.93941470644296, 218, 52, 'PPL', 'P'),
(205646, 'Sage Crest Subdivision Number 4', 40.5786094665527, 0.708230341072285, -111.823608398438, -1.95169014801352, 218, 52, 'PPL', 'P'),
(205647, 'Sage Crest Subdivision Number 5', 40.5702781677246, 0.708084932476767, -111.85417175293, -1.95222357917986, 218, 52, 'PPL', 'P'),
(193924, 'Sage Hen', 41.1108283996582, 0.717519313796427, -120.476936340332, -2.1027192118544, 218, 6, 'PPL', 'P'),
(57328, 'Sage Hill', 36.9247207641602, 0.644457952714111, -93.6836090087891, -1.63508743235439, 218, 29, 'PPL', 'P'),
(195570, 'Sage Junction', 43.8308296203613, 0.764992290755961, -112.194442749023, -1.95816242841074, 218, 17, 'PPL', 'P'),
(77157, 'Sageeyah', 36.3711090087891, 0.63479560480514, -95.6527786254883, -1.66945592569603, 218, 42, 'PPL', 'P'),
(51139, 'Sagefield', 39.1833305358887, 0.683878129748491, -75.8858337402344, -1.32445765438809, 218, 25, 'PPL', 'P'),
(90564, 'Sagefield', 35.9419403076172, 0.627305197923184, -86.5444412231445, -1.51048544864258, 218, 50, 'PPL', 'P'),
(184723, 'Sageland', 35.4799995422363, 0.619242810618105, -118.211669921875, -2.06318285441747, 218, 6, 'PPL', 'P'),
(208641, 'Sagemoor', 46.3988914489746, 0.80981342506005, -119.060562133789, -2.0779988185099, 218, 56, 'PPL', 'P'),
(192765, 'Sagers', 38.9644393920898, 0.680057758585746, -109.598892211914, -1.91286152563627, 218, 52, 'PPL', 'P'),
(97722, 'Sagerton', 33.0769386291504, 0.577301485558774, -99.9552764892578, -1.74454867947883, 218, 51, 'PPL', 'P'),
(152290, 'Sages Crossing', 42.5852813720703, 0.743253372830835, -75.3352813720703, -1.31484870285898, 218, 40, 'PPL', 'P'),
(152291, 'Sagetown', 42.026668548584, 0.733503739817137, -76.9574966430664, -1.34316170051399, 218, 40, 'PPL', 'P'),
(117655, 'Sageville', 42.5527801513672, 0.742686119518648, -90.7088928222656, -1.58316884058719, 218, 16, 'PPL', 'P'),
(179041, 'Sagewood', 33.3880615234375, 0.582731604442418, -111.836112976074, -1.95190839406485, 218, 5, 'PPL', 'P'),
(5602, 'Saginaw', 33.2161102294922, 0.579730488210008, -86.7919387817383, -1.51480509593069, 218, 2, 'PPL', 'P'),
(11754, 'Saginaw', 34.3002815246582, 0.598652846966266, -92.9361114501953, -1.62204113880631, 218, 4, 'PPL', 'P'),
(24595, 'Saginaw', 31.5158290863037, 0.550054984051796, -82.6697235107422, -1.44285886697582, 218, 13, 'PPL', 'P'),
(57329, 'Saginaw', 37.0238914489746, 0.646188807685581, -94.4680633544922, -1.64877874351849, 218, 29, 'PPL', 'P'),
(97723, 'Saginaw', 32.8600006103516, 0.573515202857981, -97.3636093139648, -1.6993155541541, 218, 51, 'PPL', 'P'),
(132947, 'Saginaw', 43.4194412231445, 0.757812208720026, -83.9508285522461, -1.46521836801396, 218, 27, 'PPL', 'P'),
(137885, 'Saginaw', 46.8591690063477, 0.817846783909246, -92.4441680908203, -1.61345510745189, 218, 28, 'PPL', 'P'),
(166784, 'Saginaw', 40.064998626709, 0.699266140843078, -76.6730575561523, -1.33819730192598, 218, 45, 'PPL', 'P'),
(179042, 'Saginaw', 31.4291706085205, 0.548542508289713, -109.882781982422, -1.91781633684436, 218, 5, 'PPL', 'P'),
(201517, 'Saginaw', 43.8327789306641, 0.765026312638887, -123.044166564941, -2.14752583193055, 218, 43, 'PPL', 'P'),
(208643, 'Saginaw', 46.9724998474121, 0.819824780229875, -123.385559082031, -2.15348425539544, 218, 56, 'PPL', 'P'),
(209868, 'Sagle', 48.2024993896484, 0.841292322039922, -116.546669006348, -2.03412310639279, 218, 17, 'PPL', 'P'),
(61640, 'Sago', 33.0319404602051, 0.57651611935331, -90.9119415283203, -1.58671270904976, 218, 30, 'PPL', 'P'),
(105980, 'Sago', 36.8886108398438, 0.643827715642144, -79.6413879394531, -1.39000444040156, 218, 53, 'PPL', 'P'),
(111249, 'Sago', 38.9141693115234, 0.679180380164619, -80.2302780151367, -1.40028251115456, 218, 58, 'PPL', 'P'),
(132951, 'Sagola', 46.0902786254883, 0.804427115176337, -88.0774993896484, -1.53724236127266, 218, 27, 'PPL', 'P'),
(166785, 'Sagon', 40.8041687011719, 0.712167092374667, -76.4952774047852, -1.33509445293992, 218, 45, 'PPL', 'P'),
(57330, 'Sagrada', 38.2216682434082, 0.667093956452431, -93.0530624389648, -1.6240823186238, 218, 29, 'PPL', 'P'),
(187300, 'Saguache', 38.0875015258789, 0.664752305484951, -106.141387939453, -1.85251669218006, 218, 7, 'PPL', 'P'),
(212126, 'Sagwon', 69.3730621337891, 1.21078834642522, -148.700561523438, -2.59531439814838, 218, 1, 'PPL', 'P'),
(208642, 'Sahalee', 47.6349983215332, 0.831387559892727, -122.054168701172, -2.13024710962006, 218, 56, 'PPL', 'P'),
(197457, 'Sahara (historical)', 46.7444381713867, 0.815844353085616, -109.146392822266, -1.90496392142364, 218, 31, 'PPL', 'P'),
(179043, 'Sahara Mobile Home Park', 33.5374984741211, 0.585339771255987, -112.14778137207, -1.95734803374939, 218, 5, 'PPL', 'P'),
(205650, 'Sahara Village', 41.1005592346191, 0.717340083055065, -111.972503662109, -1.95428886060522, 218, 52, 'PPL', 'P'),
(184725, 'Sahl Court', 39.2341690063477, 0.684765428444679, -121.067497253418, -2.11302644422134, 218, 6, 'PPL', 'P'),
(179044, 'Sahuarita', 31.9575004577637, 0.557763603695571, -110.955001831055, -1.93653010350824, 218, 5, 'PPL', 'P'),
(179045, 'Sahuarita Heights', 31.9500007629395, 0.557632709327994, -110.92472076416, -1.93600159918992, 218, 5, 'PPL', 'P'),
(121334, 'Saidora', 40.1049995422363, 0.699964288522843, -90.1447219848633, -1.57332220193078, 218, 18, 'PPL', 'P'),
(14537, 'Saienni Farms', 39.6425018310547, 0.691892180679785, -75.6222229003906, -1.31985677728887, 218, 10, 'PPL', 'P'),
(42904, 'Sailes', 32.4252815246582, 0.565927923491373, -93.1080627441406, -1.62504225503872, 218, 22, 'PPL', 'P'),
(28493, 'Sailor Springs', 38.7638893127441, 0.676557499386027, -88.3630599975586, -1.54222633409469, 218, 18, 'PPL', 'P'),
(90565, 'Sailors Rest (historical)', 36.3441696166992, 0.634325423714687, -87.5388870239258, -1.52784180209885, 218, 50, 'PPL', 'P'),
(51140, 'Sailors Retreat', 38.6805610656738, 0.675103147114735, -76.1083297729492, -1.32834094273159, 218, 25, 'PPL', 'P'),
(128718, 'Saint Agatha', 47.2430610656738, 0.824546964316749, -68.3141708374023, -1.19230720688256, 218, 26, 'PPL', 'P'),
(57331, 'Saint Albans', 38.5791702270508, 0.673333543149405, -90.7750015258789, -1.58432265512946, 218, 29, 'PPL', 'P'),
(79078, 'Saint Albans', 39.9886093139648, 0.697932895822357, -75.3902816772461, -1.3158086392739, 218, 45, 'PPL', 'P'),
(111250, 'Saint Albans', 38.3855590820313, 0.669954391200257, -81.8363876342773, -1.42831441215651, 218, 58, 'PPL', 'P'),
(128720, 'Saint Albans', 44.9099998474121, 0.783827364407492, -69.4105606079102, -1.21144281826311, 218, 26, 'PPL', 'P'),
(152292, 'Saint Albans', 40.6983299255371, 0.710319857263561, -73.7611083984375, -1.28737420147318, 218, 40, 'PPL', 'P'),
(172484, 'Saint Albans', 44.8108291625977, 0.782096509436023, -73.083610534668, -1.27554963307517, 218, 55, 'PPL', 'P'),
(172485, 'Saint Albans Bay', 44.8077812194824, 0.782043312793248, -73.1397171020508, -1.27652887740799, 218, 55, 'PPL', 'P'),
(42905, 'Saint Amant', 30.2244396209717, 0.527515985956183, -90.8688888549805, -1.58596129814819, 218, 22, 'PPL', 'P'),
(17891, 'Saint Andrew', 30.1736106872559, 0.526628853707564, -85.6994400024414, -1.49573739515794, 218, 12, 'PPL', 'P'),
(152293, 'Saint Andrew', 41.5691719055176, 0.725518917078807, -74.1458282470703, -1.29408882952959, 218, 40, 'PPL', 'P'),
(24596, 'Saint Andrews', 33.9625015258789, 0.592757473840185, -84.2975006103516, -1.47126893685256, 218, 13, 'PPL', 'P'),
(83427, 'Saint Andrews', 34.045280456543, 0.594202238731553, -81.1294403076172, -1.41597585366812, 218, 48, 'PPL', 'P'),
(90566, 'Saint Andrews', 35.211109161377, 0.614549788145167, -85.8925018310547, -1.49910695972716, 218, 50, 'PPL', 'P'),
(208644, 'Saint Andrews', 47.6997184753418, 0.832517139669084, -119.425277709961, -2.08436430614741, 218, 56, 'PPL', 'P'),
(157484, 'Saint Andrews (historical)', 41.1041717529297, 0.717403133393872, -84.4266662597656, -1.47352330271532, 218, 41, 'PPL', 'P'),
(24598, 'Saint Andrews Country Club Estates', 33.5852813720703, 0.586173740151346, -84.870002746582, -1.48126098410449, 218, 13, 'PPL', 'P'),
(51141, 'Saint Andrews Estates', 38.2922210693359, 0.668325335561456, -76.5494384765625, -1.33603974196885, 218, 25, 'PPL', 'P'),
(205652, 'Saint Andrews Park Condo', 40.6666717529297, 0.709767317916397, -111.991111755371, -1.95461363310015, 218, 52, 'PPL', 'P'),
(24599, 'Saint Andrews Square', 33.4072189331055, 0.583065964317278, -84.584716796875, -1.47628180497242, 218, 13, 'PPL', 'P'),
(184727, 'Saint Andrews Village', 38.6974983215332, 0.675398757995734, -121.080001831055, -2.11324469027267, 218, 6, 'PPL', 'P'),
(57332, 'Saint Ann', 38.7272186279297, 0.675917475197054, -90.383056640625, -1.57748192639543, 218, 29, 'PPL', 'P'),
(61641, 'Saint Ann', 32.7827796936035, 0.572167443609319, -89.6602783203125, -1.56486706494394, 218, 30, 'PPL', 'P'),
(187302, 'Saint Ann Highlands', 39.9869384765625, 0.697903734208421, -105.455558776855, -1.84054671518653, 218, 7, 'PPL', 'P'),
(137887, 'Saint Anna', 45.6616706848145, 0.796946495411386, -94.4749984741211, -1.64889978419003, 218, 28, 'PPL', 'P'),
(176222, 'Saint Anna', 43.8933296203613, 0.766083121538458, -88.1213912963867, -1.53800841956022, 218, 57, 'PPL', 'P'),
(51142, 'Saint Anne', 39.6291694641113, 0.69165948697954, -76.334716796875, -1.33229214168289, 218, 25, 'PPL', 'P'),
(121336, 'Saint Anne', 41.0250015258789, 0.716021352262285, -87.7138900756836, -1.53089618155306, 218, 18, 'PPL', 'P'),
(121337, 'Saint Anne Woods', 41.0374984741211, 0.716239465155562, -87.625, -1.52934475706003, 218, 18, 'PPL', 'P'),
(57333, 'Saint Annie', 37.5719413757324, 0.655754083372819, -92.2738876342773, -1.61048315283342, 218, 29, 'PPL', 'P'),
(117646, 'Saint Ansgar', 43.3783302307129, 0.757094686543331, -92.9186096191406, -1.62173567422928, 218, 16, 'PPL', 'P'),
(31028, 'Saint Anthony', 38.3144416809082, 0.668713158395199, -86.8266677856445, -1.51541123139479, 218, 19, 'PPL', 'P'),
(51143, 'Saint Anthony', 39.6763916015625, 0.692483668757892, -77.3563919067383, -1.35012373623568, 218, 25, 'PPL', 'P'),
(57334, 'Saint Anthony', 38.1555595397949, 0.665940141910154, -92.2738876342773, -1.61048315283342, 218, 29, 'PPL', 'P'),
(117648, 'Saint Anthony', 42.1222190856934, 0.735171411291745, -93.1947174072266, -1.62655466422178, 218, 16, 'PPL', 'P'),
(132953, 'Saint Anthony', 41.7991714477539, 0.729533166368911, -83.6558303833008, -1.46006967867851, 218, 27, 'PPL', 'P'),
(137889, 'Saint Anthony', 45.6866683959961, 0.797382787776968, -94.6119384765625, -1.65128983811032, 218, 28, 'PPL', 'P'),
(176223, 'Saint Anthony', 43.4425010681152, 0.758214678939764, -88.341667175293, -1.54185295890986, 218, 57, 'PPL', 'P'),
(195571, 'Saint Anthony', 43.9663887023926, 0.767358243068388, -111.68138885498, -1.94920794871951, 218, 17, 'PPL', 'P'),
(198850, 'Saint Anthony', 46.6169395446777, 0.813619082257773, -100.912780761719, -1.76126028163518, 218, 34, 'PPL', 'P'),
(57335, 'Saint Aubert', 38.6500015258789, 0.674569782527419, -91.8563919067383, -1.60319647777486, 218, 29, 'PPL', 'P'),
(51144, 'Saint Aubins Heights', 38.7833290100098, 0.676896786108903, -76.0722198486328, -1.32771070565962, 218, 25, 'PPL', 'P'),
(137892, 'Saint Augusta', 45.4786109924316, 0.793751501051618, -94.1538925170898, -1.64329542799207, 218, 28, 'PPL', 'P'),
(17892, 'Saint Augustine', 29.8944396972656, 0.521756400756182, -81.3147201538086, -1.41920959702175, 218, 12, 'PPL', 'P'),
(51145, 'Saint Augustine', 39.4941711425781, 0.689303321784119, -75.8091735839844, -1.32311968225644, 218, 25, 'PPL', 'P'),
(121339, 'Saint Augustine', 40.7183303833008, 0.710668931103443, -90.4108276367188, -1.57796662171383, 218, 18, 'PPL', 'P'),
(166786, 'Saint Augustine', 40.6130599975586, 0.708831616267398, -78.57861328125, -1.37145552340916, 218, 45, 'PPL', 'P'),
(17893, 'Saint Augustine Beach', 29.8502807617188, 0.520985681936713, -81.2655563354492, -1.41835152651853, 218, 12, 'PPL', 'P'),
(17894, 'Saint Augustine Shores', 29.8105602264404, 0.520292427815452, -81.3105621337891, -1.41913702588205, 218, 12, 'PPL', 'P'),
(33852, 'Saint Benedict', 39.8872184753418, 0.696163291857027, -96.0986099243164, -1.67723714976902, 218, 20, 'PPL', 'P'),
(42906, 'Saint Benedict', 30.5266704559326, 0.532790909127303, -90.1125030517578, -1.57275987546661, 218, 22, 'PPL', 'P'),
(117649, 'Saint Benedict', 43.0380592346191, 0.751155837312455, -94.0641708374023, -1.6417294892711, 218, 16, 'PPL', 'P'),
(137894, 'Saint Benedict', 44.5880584716797, 0.778208427402561, -93.6136093139648, -1.63386570720432, 218, 28, 'PPL', 'P'),
(140826, 'Saint Benedict', 46.7244415283203, 0.815495345824761, -96.8411102294922, -1.6901962247914, 218, 34, 'PPL', 'P'),
(166787, 'Saint Benedict', 40.627498626709, 0.709083617885546, -78.7297210693359, -1.37409285183666, 218, 45, 'PPL', 'P'),
(42907, 'Saint Bernard', 29.8669395446777, 0.521276432548722, -89.8586120605469, -1.56832864172883, 218, 22, 'PPL', 'P'),
(74173, 'Saint Bernard', 39.1669387817383, 0.68359203966839, -84.4986114501953, -1.47477898316929, 218, 41, 'PPL', 'P'),
(142915, 'Saint Bernard', 41.7219390869141, 0.728185207383167, -97.6286087036133, -1.70394066601924, 218, 35, 'PPL', 'P'),
(193925, 'Saint Bernard', 40.2599983215332, 0.702669527558145, -121.370826721191, -2.1183205421523, 218, 6, 'PPL', 'P'),
(42908, 'Saint Bernard Grove', 29.9225006103516, 0.522246156080648, -89.9122161865234, -1.56926421021977, 218, 22, 'PPL', 'P'),
(31029, 'Saint Bernice', 39.709171295166, 0.693055782339068, -87.5213928222656, -1.52753647067987, 218, 19, 'PPL', 'P'),
(90567, 'Saint Bethlehem', 36.5719413757324, 0.638300790852875, -87.3000030517578, -1.52367249025427, 218, 50, 'PPL', 'P'),
(166788, 'Saint Boniface', 40.6666717529297, 0.709767317916397, -78.6811065673828, -1.37324436871336, 218, 45, 'PPL', 'P'),
(137895, 'Saint Bonifacius', 44.9055595397949, 0.783749866419771, -93.7472229003906, -1.63619770421284, 218, 28, 'PPL', 'P'),
(105984, 'Saint Brides', 36.6063919067383, 0.638902066047988, -76.1977767944336, -1.3299020877626, 218, 53, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(33853, 'Saint Bridget', 39.9661102294922, 0.697540212719625, -96.2636108398438, -1.68011695901378, 218, 20, 'PPL', 'P'),
(38060, 'Saint Catharine', 37.708610534668, 0.658139410182175, -85.2577819824219, -1.48802900854076, 218, 21, 'PPL', 'P'),
(57337, 'Saint Catharine', 39.7958297729492, 0.694568258101151, -92.9936065673828, -1.62304461790505, 218, 29, 'PPL', 'P'),
(17895, 'Saint Catherine', 28.6100006103516, 0.499338709648222, -82.1383285522461, -1.43358427532156, 218, 12, 'PPL', 'P'),
(51146, 'Saint Catherine', 38.252498626709, 0.667632048150681, -76.7986068725586, -1.34038855087089, 218, 25, 'PPL', 'P'),
(61642, 'Saint Catherine', 31.545280456543, 0.550569007431695, -91.3680572509766, -1.59467343018022, 218, 30, 'PPL', 'P'),
(176224, 'Saint Catherines Bay', 44.0833282470703, 0.769399223148797, -88.3244400024414, -1.54155228802279, 218, 57, 'PPL', 'P'),
(11748, 'Saint Charles', 34.3716697692871, 0.59989880688226, -91.1363906860352, -1.59063008585521, 218, 4, 'PPL', 'P'),
(24600, 'Saint Charles', 33.2686080932617, 0.58064674878305, -84.7758331298828, -1.47961741423774, 218, 13, 'PPL', 'P'),
(38061, 'Saint Charles', 37.1861114501953, 0.649020080819472, -87.5558319091797, -1.5281375461379, 218, 21, 'PPL', 'P'),
(42910, 'Saint Charles', 29.753059387207, 0.519288848848169, -90.720832824707, -1.58337723294249, 218, 22, 'PPL', 'P'),
(51147, 'Saint Charles', 38.6030616760254, 0.673750527597084, -76.9388885498047, -1.34283692801906, 218, 25, 'PPL', 'P'),
(57338, 'Saint Charles', 38.7838897705078, 0.676906573225909, -90.4811096191406, -1.57919327371192, 218, 29, 'PPL', 'P'),
(74174, 'Saint Charles', 39.3913917541504, 0.687509483052869, -84.7425003051758, -1.47903564669762, 218, 41, 'PPL', 'P'),
(83429, 'Saint Charles', 34.0663909912109, 0.594570687068366, -80.2183303833008, -1.4000739856412, 218, 48, 'PPL', 'P'),
(105982, 'Saint Charles', 36.8016700744629, 0.642310313032044, -83.057502746582, -1.44962689141209, 218, 53, 'PPL', 'P'),
(117650, 'Saint Charles', 41.288330078125, 0.720617302513489, -93.8091735839844, -1.63727894761542, 218, 16, 'PPL', 'P'),
(121340, 'Saint Charles', 41.9141693115234, 0.731540257724449, -88.3086090087891, -1.5412759850597, 218, 18, 'PPL', 'P'),
(132954, 'Saint Charles', 43.2969398498535, 0.755674156417883, -84.1405563354492, -1.46852974251336, 218, 27, 'PPL', 'P'),
(137897, 'Saint Charles', 43.9694404602051, 0.767411506290189, -92.0641708374023, -1.60682290423122, 218, 28, 'PPL', 'P'),
(142917, 'Saint Charles', 41.7933311462402, 0.729431233878188, -96.7486114501953, -1.68858181653859, 218, 35, 'PPL', 'P'),
(166789, 'Saint Charles', 40.9952812194824, 0.715502635060964, -79.39111328125, -1.38563632358161, 218, 45, 'PPL', 'P'),
(171246, 'Saint Charles', 43.0869407653809, 0.752008980967662, -99.0950012207031, -1.72953404356907, 218, 49, 'PPL', 'P'),
(187303, 'Saint Charles', 38.1388893127441, 0.665649191561063, -104.620826721191, -1.82597789244325, 218, 7, 'PPL', 'P'),
(195572, 'Saint Charles', 42.1138916015625, 0.735026069275254, -111.388061523438, -1.944088420998, 218, 17, 'PPL', 'P'),
(166790, 'Saint Charles Furnace', 41.0194396972656, 0.715924280040551, -79.3880615234375, -1.38558306035981, 218, 45, 'PPL', 'P'),
(5606, 'Saint Clair', 32.3233299255371, 0.564148532409036, -86.6166687011719, -1.51174605594457, 218, 2, 'PPL', 'P'),
(24601, 'Saint Clair', 33.1508293151855, 0.578591121316645, -82.2180633544922, -1.43497591014918, 218, 13, 'PPL', 'P'),
(42912, 'Saint Clair', 29.8697204589844, 0.521324968659589, -89.9688873291016, -1.57025330824863, 218, 22, 'PPL', 'P'),
(57341, 'Saint Clair', 38.3452796936035, 0.669251383251504, -90.980827331543, -1.58791499312387, 218, 29, 'PPL', 'P'),
(90569, 'Saint Clair', 35.7336082458496, 0.623669117507871, -84.8083267211914, -1.48018453439188, 218, 50, 'PPL', 'P'),
(105983, 'Saint Clair', 37.2380599975586, 0.649926754012589, -81.3194427490234, -1.41929202185749, 218, 53, 'PPL', 'P'),
(137900, 'Saint Clair', 44.0819396972656, 0.769374988382878, -93.8574981689453, -1.63812237073264, 218, 28, 'PPL', 'P'),
(166794, 'Saint Clair', 40.2686080932617, 0.702819796422653, -79.5486068725586, -1.38838510530074, 218, 45, 'PPL', 'P'),
(190696, 'Saint Clair', 39.4363899230957, 0.688294849258333, -118.808891296387, -2.07360633376598, 218, 39, 'PPL', 'P'),
(193264, 'Saint Clair', 47.024169921875, 0.820726593154003, -122.72306060791, -2.14192147573259, 218, 56, 'PPL', 'P'),
(74175, 'Saint Clair (historical)', 39.8616714477539, 0.69571741211152, -81.7013931274414, -1.42595831354012, 218, 41, 'PPL', 'P'),
(197458, 'Saint Clair (historical)', 47.2808303833008, 0.825206163265571, -111.680557250977, -1.94919343449157, 218, 31, 'PPL', 'P'),
(97724, 'Saint Clair Acres Colonia', 26.2709999084473, 0.458515446193534, -98.5550003051758, -1.72010924962933, 218, 51, 'PPL', 'P'),
(24602, 'Saint Clair Estates', 31.1972198486328, 0.54449420382717, -81.3816680908203, -1.42037805895002, 218, 13, 'PPL', 'P'),
(5608, 'Saint Clair Forest', 33.6138916015625, 0.586673082855735, -86.4791717529297, -1.5093462814863, 218, 2, 'PPL', 'P'),
(132958, 'Saint Clair Haven', 42.5833282470703, 0.743219284368882, -82.790283203125, -1.44496303055309, 218, 27, 'PPL', 'P'),
(137901, 'Saint Clair Junction', 47.4705581665039, 0.828517537764976, -92.8444366455078, -1.62044111162339, 218, 28, 'PPL', 'P'),
(5609, 'Saint Clair Shores', 33.4958305358887, 0.584612528541314, -86.3036117553711, -1.50628218149411, 218, 2, 'PPL', 'P'),
(5610, 'Saint Clair Springs', 33.7630615234375, 0.589276589137397, -86.4030609130859, -1.50801789673457, 218, 2, 'PPL', 'P'),
(190697, 'Saint Clair Station (historical)', 39.4777793884277, 0.689017231704017, -118.845558166504, -2.07424629137593, 218, 39, 'PPL', 'P'),
(5611, 'Saint Clair Store', 34.836669921875, 0.608014590567195, -86.4122161865234, -1.50817768639997, 218, 2, 'PPL', 'P'),
(11750, 'Saint Claire', 35.2186088562012, 0.614680682512745, -90.1186065673828, -1.57286640191022, 218, 4, 'PPL', 'P'),
(42918, 'Saint Claire', 32.3325004577637, 0.56430858839055, -92.5141677856445, -1.61467683260197, 218, 22, 'PPL', 'P'),
(97725, 'Saint Claire Fisher Colonia', 26.2770004272461, 0.458620175003401, -98.5550003051758, -1.72010924962933, 218, 51, 'PPL', 'P'),
(157486, 'Saint Clairsville', 40.0805587768555, 0.699537716695239, -80.9002838134766, -1.41197631834304, 218, 41, 'PPL', 'P'),
(166797, 'Saint Clairsville', 40.1566696166992, 0.700866101446971, -78.5102767944336, -1.37026282671497, 218, 45, 'PPL', 'P'),
(111251, 'Saint Clara', 39.121940612793, 0.682806673462925, -80.6875, -1.40826254020292, 218, 58, 'PPL', 'P'),
(42913, 'Saint Claude Heights', 29.9622192382813, 0.522939376912395, -89.9941711425781, -1.57069459404126, 218, 22, 'PPL', 'P'),
(57343, 'Saint Clement', 39.2833290100098, 0.685623432368875, -91.2091674804688, -1.59190028053712, 218, 29, 'PPL', 'P'),
(51148, 'Saint Clement Shores', 38.2799987792969, 0.668112016358141, -76.7050018310547, -1.33875483470018, 218, 25, 'PPL', 'P'),
(33855, 'Saint Clere', 39.3691711425781, 0.687121660219126, -96.0555572509766, -1.67648573886745, 218, 20, 'PPL', 'P'),
(17896, 'Saint Cloud', 28.2486095428467, 0.493031245632965, -81.2813873291016, -1.41862782948162, 218, 12, 'PPL', 'P'),
(57345, 'Saint Cloud', 39.292781829834, 0.685788415198405, -94.0180587768555, -1.64092468198968, 218, 29, 'PPL', 'P'),
(111252, 'Saint Cloud', 39.7019386291504, 0.692929548503398, -80.4011077880859, -1.40326405315296, 218, 58, 'PPL', 'P'),
(137903, 'Saint Cloud', 45.5608291625977, 0.79518647882598, -94.1622161865234, -1.64344070342953, 218, 28, 'PPL', 'P'),
(146252, 'Saint Cloud', 40.7750015258789, 0.711658029132299, -74.274169921875, -1.29632881432246, 218, 37, 'PPL', 'P'),
(176225, 'Saint Cloud', 43.8227806091309, 0.76485180900846, -88.1669387817383, -1.53880337314561, 218, 57, 'PPL', 'P'),
(208645, 'Saint Cloud', 45.6030616760254, 0.795923575236687, -122.109718322754, -2.1312166334149, 218, 56, 'PPL', 'P'),
(31033, 'Saint Croix', 38.2238883972168, 0.667132705446291, -86.5863876342773, -1.51121755162624, 218, 19, 'PPL', 'P'),
(176228, 'Saint Croix Falls', 45.4099998474121, 0.792554010667464, -92.6394424438477, -1.61686328785692, 218, 57, 'PPL', 'P'),
(128722, 'Saint Croix Junction', 45.1488914489746, 0.78799680941012, -67.2938919067383, -1.17449998025375, 218, 26, 'PPL', 'P'),
(121342, 'Saint David', 40.4933280944824, 0.70674190033904, -90.0486068725586, -1.57164467676014, 218, 18, 'PPL', 'P'),
(128723, 'Saint David', 47.3394393920898, 0.826229083440271, -68.2319412231445, -1.19087202937112, 218, 26, 'PPL', 'P'),
(179046, 'Saint David', 31.9041690826416, 0.556832795605075, -110.213607788086, -1.92359033640376, 218, 5, 'PPL', 'P'),
(166799, 'Saint Davids', 40.040828704834, 0.69884429612641, -75.3788909912109, -1.31560983429852, 218, 45, 'PPL', 'P'),
(42914, 'Saint Delphine', 30.3436107635498, 0.529595914767535, -91.2563934326172, -1.5927245288945, 218, 22, 'PPL', 'P'),
(38062, 'Saint Denis', 38.2002792358398, 0.666720647846629, -85.8330612182617, -1.49806952532452, 218, 21, 'PPL', 'P'),
(51149, 'Saint Denis', 39.2224998474121, 0.684561763200315, -76.7050018310547, -1.33875483470018, 218, 25, 'PPL', 'P'),
(142919, 'Saint Deroin (historical)', 40.2722206115723, 0.70288284676146, -95.5597229003906, -1.66783179690524, 218, 35, 'PPL', 'P'),
(42915, 'Saint Dizier', 30.6972198486328, 0.535767557567198, -91.4219436645508, -1.59561392551918, 218, 22, 'PPL', 'P'),
(117654, 'Saint Donatus', 42.3608283996582, 0.739335929446356, -90.5391693115234, -1.58020660650669, 218, 16, 'PPL', 'P'),
(113148, 'Saint Edward', 41.5699996948242, 0.725533364727721, -97.8655624389648, -1.70807628887603, 218, 35, 'PPL', 'P'),
(97726, 'Saint Elijah Village', 31.2222194671631, 0.544930529482265, -97.7874984741211, -1.70671381566234, 218, 51, 'PPL', 'P'),
(57346, 'Saint Elizabeth', 38.2558288574219, 0.667690171641472, -92.2677764892578, -1.61037649323176, 218, 29, 'PPL', 'P'),
(5612, 'Saint Elmo', 30.5033302307129, 0.532383545349062, -88.2541732788086, -1.54032590234081, 218, 2, 'PPL', 'P'),
(28497, 'Saint Elmo', 39.0272216796875, 0.681153516216259, -88.8480606079102, -1.55069119161951, 218, 18, 'PPL', 'P'),
(38063, 'Saint Elmo', 36.7024993896484, 0.640579458060574, -87.3927764892578, -1.52529169219704, 218, 21, 'PPL', 'P'),
(42917, 'Saint Elmo', 30.0224990844727, 0.523991458701031, -90.7347183227539, -1.58361958060168, 218, 22, 'PPL', 'P'),
(61643, 'Saint Elmo', 31.9950008392334, 0.558418108822972, -90.8102798461914, -1.58493837797349, 218, 30, 'PPL', 'P'),
(90570, 'Saint Elmo', 34.9966697692871, 0.610807114707224, -85.3300018310547, -1.48928948268469, 218, 50, 'PPL', 'P'),
(97727, 'Saint Elmo', 31.937780380249, 0.557419423414192, -96.1816711425781, -1.6786868415084, 218, 51, 'PPL', 'P'),
(105985, 'Saint Elmo', 38.8311080932617, 0.677730688425234, -77.0561065673828, -1.34488276836846, 218, 53, 'PPL', 'P'),
(132961, 'Saint Elmo', 43.583610534668, 0.760677503736842, -84.4700012207031, -1.4742796404649, 218, 27, 'PPL', 'P'),
(152295, 'Saint Elmo', 41.5886116027832, 0.725858203801683, -74.1419372558594, -1.2940209189218, 218, 40, 'PPL', 'P'),
(184728, 'Saint Elmo (historical)', 35.3008308410645, 0.616115726866134, -117.610000610352, -2.05268174392318, 218, 6, 'PPL', 'P'),
(187304, 'Saint Elmo (historical)', 38.704719543457, 0.675524792094322, -106.347503662109, -1.85611409018054, 218, 7, 'PPL', 'P'),
(190698, 'Saint Elmo (historical)', 38.4655609130859, 0.671350686559786, -117.182220458984, -2.04521557180714, 218, 39, 'PPL', 'P'),
(5613, 'Saint Florian', 34.8733291625977, 0.608654415019086, -87.6233291625977, -1.52931559544609, 218, 2, 'PPL', 'P'),
(11751, 'Saint Francis', 36.4533309936523, 0.63623064915853, -90.1452789306641, -1.57333192246876, 218, 4, 'PPL', 'P'),
(17897, 'Saint Francis', 29.0358295440674, 0.50677082659182, -81.4197235107422, -1.42104225132589, 218, 12, 'PPL', 'P'),
(38064, 'Saint Francis', 37.6263885498047, 0.656704365828786, -85.4277801513672, -1.49099603631122, 218, 21, 'PPL', 'P'),
(128724, 'Saint Francis', 47.1711082458496, 0.823291150704722, -68.8902816772461, -1.20236223789427, 218, 26, 'PPL', 'P'),
(137907, 'Saint Francis', 45.7599983215332, 0.798662636417833, -94.584716796875, -1.65081473017185, 218, 28, 'PPL', 'P'),
(176231, 'Saint Francis', 42.9674987792969, 0.749924325045375, -87.8775024414063, -1.53375175603189, 218, 57, 'PPL', 'P'),
(187876, 'Saint Francis', 39.7722206115723, 0.694156200501489, -101.799438476563, -1.77673537809742, 218, 20, 'PPL', 'P'),
(192152, 'Saint Francis', 35.2616691589355, 0.615432226572365, -101.622497558594, -1.77364717649736, 218, 51, 'PPL', 'P'),
(202585, 'Saint Francis', 43.1444396972656, 0.753012526645431, -100.904716491699, -1.76111953357157, 218, 49, 'PPL', 'P'),
(11752, 'Saint Francis (historical)', 35.2700004577637, 0.615577635167883, -90.583610534668, -1.58098225217418, 218, 4, 'PPL', 'P'),
(61644, 'Saint Francis Island Landing', 34.6866683959961, 0.605396570057592, -90.5411071777344, -1.58024042865254, 218, 30, 'PPL', 'P'),
(28499, 'Saint Francisville', 38.5911102294922, 0.673541935504703, -87.6466674804688, -1.52972292593482, 218, 18, 'PPL', 'P'),
(42919, 'Saint Francisville', 30.7797203063965, 0.537207462189576, -91.3763885498047, -1.59481883877574, 218, 22, 'PPL', 'P'),
(139431, 'Saint Francisville', 40.4583282470703, 0.706131037764003, -91.5688934326172, -1.59817868280698, 218, 29, 'PPL', 'P'),
(42920, 'Saint Gabriel', 30.2574996948242, 0.528092993095862, -91.0991668701172, -1.58998040770728, 218, 22, 'PPL', 'P'),
(42921, 'Saint Genevieve', 31.5263900756836, 0.550239308088743, -91.5255584716797, -1.5974223450574, 218, 22, 'PPL', 'P'),
(14538, 'Saint George', 38.4988899230957, 0.671932387520887, -75.5849990844727, -1.31920709914095, 218, 10, 'PPL', 'P'),
(17898, 'Saint George', 28.0561103820801, 0.489671501470262, -82.7280578613281, -1.44387699346055, 218, 12, 'PPL', 'P'),
(24603, 'Saint George', 30.5208301544189, 0.53268897663658, -82.0377807617188, -1.43182938532125, 218, 13, 'PPL', 'P'),
(33857, 'Saint George', 39.1911087036133, 0.684013884385058, -96.4199981689453, -1.682846432815, 218, 20, 'PPL', 'P'),
(57354, 'Saint George', 37.3808288574219, 0.652418540686522, -92.4419403076172, -1.61341622529998, 218, 29, 'PPL', 'P'),
(83430, 'Saint George', 33.1858291625977, 0.579201983891682, -80.5758285522461, -1.40631350575915, 218, 48, 'PPL', 'P'),
(105986, 'Saint George', 38.2677803039551, 0.667898763733852, -78.5527801513672, -1.37100465023661, 218, 53, 'PPL', 'P'),
(111253, 'Saint George', 39.1666717529297, 0.683587379136482, -79.7024993896484, -1.39107103641814, 218, 58, 'PPL', 'P'),
(121343, 'Saint George', 41.1925010681152, 0.718944770769892, -87.7755584716797, -1.53197249810761, 218, 18, 'PPL', 'P'),
(128725, 'Saint George', 44.0163917541504, 0.768230960957607, -69.1994400024414, -1.20775806857888, 218, 26, 'PPL', 'P'),
(137910, 'Saint George', 44.3894386291504, 0.774741857190632, -94.5322189331055, -1.64989846959881, 218, 28, 'PPL', 'P'),
(152296, 'Saint George', 40.6444396972656, 0.709379295345572, -74.0805587768555, -1.29294966237331, 218, 40, 'PPL', 'P'),
(166800, 'Saint George', 41.2519416809082, 0.719982205172532, -79.7938919067383, -1.39266613675304, 218, 45, 'PPL', 'P'),
(192766, 'Saint George', 37.1041717529297, 0.647589963314099, -113.58332824707, -1.98240305328486, 218, 52, 'PPL', 'P'),
(212127, 'Saint George', 56.5999984741211, 0.98785632999718, -169.54167175293, -2.95906039142409, 218, 1, 'PPL', 'P'),
(140827, 'Saint George (historical)', 46.3777809143066, 0.809444976723237, -98.7355575561523, -1.72326056814722, 218, 34, 'PPL', 'P'),
(51150, 'Saint George Beach', 38.1527786254883, 0.665891605799287, -76.5097198486328, -1.3353465211371, 218, 25, 'PPL', 'P'),
(51151, 'Saint George Island', 38.1199989318848, 0.665319492218111, -76.48388671875, -1.33489564796455, 218, 25, 'PPL', 'P'),
(51152, 'Saint George Park', 38.1588897705078, 0.665998265400945, -76.5183334350586, -1.33549685658064, 218, 25, 'PPL', 'P'),
(14539, 'Saint Georges', 39.5550003051758, 0.690364990952679, -75.6505584716797, -1.3203513263033, 218, 10, 'PPL', 'P'),
(51153, 'Saint Georges', 39.4661102294922, 0.688813566459654, -76.8080596923828, -1.34055353370042, 218, 25, 'PPL', 'P'),
(14542, 'Saint Georges Heights', 39.5638885498047, 0.690520120086176, -75.6522216796875, -1.32038035475918, 218, 10, 'PPL', 'P'),
(105987, 'Saint Georges Hundred', 37.2472190856934, 0.650086610257021, -76.7772216796875, -1.34001530884412, 218, 53, 'PPL', 'P'),
(176233, 'Saint Germain', 45.901668548584, 0.801135248331917, -89.4872207641602, -1.56184664079363, 218, 57, 'PPL', 'P'),
(198852, 'Saint Gertrude', 46.2844390869141, 0.807815854505408, -101.328887939453, -1.76852272192783, 218, 34, 'PPL', 'P'),
(97728, 'Saint Hedwig', 29.4141693115234, 0.513374101225158, -98.1997222900391, -1.71390847850525, 218, 51, 'PPL', 'P'),
(132962, 'Saint Helen', 44.3636093139648, 0.774291050597109, -84.4102783203125, -1.47323727921424, 218, 27, 'PPL', 'P'),
(51154, 'Saint Helena', 39.2599983215332, 0.685216235038202, -76.5255584716797, -1.33562295725825, 218, 25, 'PPL', 'P'),
(68468, 'Saint Helena', 34.5163917541504, 0.602424682018145, -77.9158325195313, -1.35988781689829, 218, 33, 'PPL', 'P'),
(105988, 'Saint Helena', 36.8277816772461, 0.642766046473584, -76.2888870239258, -1.33149226124948, 218, 53, 'PPL', 'P'),
(142920, 'Saint Helena', 42.8097190856934, 0.747170549899206, -97.2486114501953, -1.69730846279857, 218, 35, 'PPL', 'P'),
(184731, 'Saint Helena', 38.5052795410156, 0.672043907391534, -122.469169616699, -2.1374902419948, 218, 6, 'PPL', 'P'),
(38065, 'Saint Helens', 37.5827789306641, 0.655943234389242, -83.647216796875, -1.45991934323497, 218, 21, 'PPL', 'P'),
(201518, 'Saint Helens', 45.8641700744629, 0.80048077649403, -122.805282592773, -2.14335652008598, 218, 43, 'PPL', 'P'),
(208646, 'Saint Helens', 46.3444404602051, 0.808863076025055, -122.527496337891, -2.13850823532149, 218, 56, 'PPL', 'P'),
(31030, 'Saint Henry', 38.2174987792969, 0.667021185575644, -86.9286117553711, -1.51719048931907, 218, 19, 'PPL', 'P'),
(137912, 'Saint Henry', 44.3841705322266, 0.774649911553998, -93.788330078125, -1.63691515981051, 218, 28, 'PPL', 'P'),
(157487, 'Saint Henry', 40.4174995422363, 0.705418442435325, -84.6397171020508, -1.47724174138734, 218, 41, 'PPL', 'P'),
(137913, 'Saint Hilaire', 48.0138893127441, 0.838000455195503, -96.2144393920898, -1.6792587553525, 218, 28, 'PPL', 'P'),
(208647, 'Saint Hubert (historical)', 47.5988883972168, 0.83075732282076, -119.747222900391, -2.08998330973137, 218, 56, 'PPL', 'P'),
(132963, 'Saint Huberts', 43.5424995422363, 0.759959981560148, -86.0849990844727, -1.50246667060035, 218, 27, 'PPL', 'P'),
(152297, 'Saint Huberts', 44.1572189331055, 0.770688858906668, -73.7736129760742, -1.28759244752451, 218, 40, 'PPL', 'P'),
(132964, 'Saint Ignace', 45.8686103820801, 0.800558274481752, -84.727783203125, -1.47877878481048, 218, 27, 'PPL', 'P'),
(197459, 'Saint Ignatius', 47.3199996948242, 0.825889796717395, -114.093063354492, -1.99129960922237, 218, 31, 'PPL', 'P'),
(51155, 'Saint Inigoes Shores', 38.1527786254883, 0.665891605799287, -76.4233322143555, -1.33383877248595, 218, 25, 'PPL', 'P'),
(5614, 'Saint Ives', 33.4300003051758, 0.583463574268027, -86.2502822875977, -1.50535140669313, 218, 2, 'PPL', 'P'),
(28500, 'Saint Jacob', 38.7138900756836, 0.675684848075835, -89.7680587768555, -1.56674818877992, 218, 18, 'PPL', 'P'),
(74177, 'Saint Jacobs', 39.2000007629395, 0.684169080097583, -84.6041717529297, -1.47662135801141, 218, 41, 'PPL', 'P'),
(132967, 'Saint Jacques', 45.8952789306641, 0.80102372846127, -86.7425003051758, -1.5139422317375, 218, 27, 'PPL', 'P'),
(11756, 'Saint James', 35.8383293151855, 0.625496844963992, -91.9177780151367, -1.60426786748139, 218, 4, 'PPL', 'P'),
(28502, 'Saint James', 38.9544410705566, 0.679883254955318, -88.8511123657227, -1.55074445484131, 218, 18, 'PPL', 'P'),
(31031, 'Saint James', 38.1766700744629, 0.666308590246966, -87.5774993896484, -1.52851571501269, 218, 19, 'PPL', 'P'),
(42924, 'Saint James', 29.9816703796387, 0.523278863372353, -90.831672668457, -1.58531175315832, 218, 22, 'PPL', 'P'),
(51157, 'Saint James', 39.5625, 0.690495885320257, -77.7583312988281, -1.35713890202111, 218, 25, 'PPL', 'P'),
(57355, 'Saint James', 37.9972190856934, 0.663176579646979, -91.6141662597656, -1.59896884270241, 218, 29, 'PPL', 'P'),
(68469, 'Saint James', 33.9291687011719, 0.592175706300057, -78.1166687011719, -1.36339306952505, 218, 33, 'PPL', 'P'),
(90571, 'Saint James', 36.0283317565918, 0.628813013153359, -82.9530563354492, -1.44780395764593, 218, 50, 'PPL', 'P'),
(97729, 'Saint James', 29.5669403076172, 0.516040458108545, -97.6044387817383, -1.70351882130258, 218, 51, 'PPL', 'P'),
(132968, 'Saint James', 45.7511100769043, 0.798507507284336, -85.5155563354492, -1.49252801972829, 218, 27, 'PPL', 'P'),
(137915, 'Saint James', 43.9824981689453, 0.767639406300473, -94.6266708374023, -1.65154696631357, 218, 28, 'PPL', 'P'),
(142921, 'Saint James', 42.7380599975586, 0.745919862872277, -97.1505584716797, -1.69559711548208, 218, 35, 'PPL', 'P'),
(152298, 'Saint James', 40.8788909912109, 0.713471242360479, -73.1572189331055, -1.27683434198502, 218, 40, 'PPL', 'P'),
(157488, 'Saint James', 40.6619415283203, 0.709684759922605, -82.8291702270508, -1.4456417371569, 218, 41, 'PPL', 'P'),
(17899, 'Saint James City', 26.4972190856934, 0.462463715667631, -82.07861328125, -1.43254204722896, 218, 12, 'PPL', 'P'),
(137916, 'Saint James Place', 43.9813919067383, 0.76762009838257, -94.6416702270508, -1.65180875504873, 218, 28, 'PPL', 'P'),
(42927, 'Saint James Plantation', 29.9980602264404, 0.523564920162941, -90.7516708374023, -1.58391545779879, 218, 22, 'PPL', 'P'),
(51158, 'Saint James Village', 39.5811080932617, 0.690820657815192, -77.732780456543, -1.35669295569658, 218, 25, 'PPL', 'P'),
(51159, 'Saint Jerome Shores', 38.1291694641113, 0.665479548199625, -76.3333282470703, -1.33226790691697, 218, 25, 'PPL', 'P'),
(51160, 'Saint Jeromes Landing', 38.1338882446289, 0.665561906456335, -76.3547210693359, -1.3326412821018, 218, 25, 'PPL', 'P'),
(97730, 'Saint Jo', 33.6947212219238, 0.588083825864178, -97.522216796875, -1.70208377694919, 218, 51, 'PPL', 'P'),
(11757, 'Saint Joe', 36.0299987792969, 0.628842108188268, -92.804443359375, -1.61974309710168, 218, 4, 'PPL', 'P'),
(28503, 'Saint Joe', 38.232780456543, 0.667287901158816, -90.1536102294922, -1.57347733106428, 218, 18, 'PPL', 'P'),
(33859, 'Saint Joe', 37.7488899230957, 0.658842418130929, -97.7316665649414, -1.70573936501948, 218, 20, 'PPL', 'P'),
(42928, 'Saint Joe', 30.3444404602051, 0.529610395705962, -89.7561111450195, -1.56653966326657, 218, 22, 'PPL', 'P'),
(111255, 'Saint Joe', 39.4886093139648, 0.689206249562386, -79.6324996948242, -1.38984931126806, 218, 58, 'PPL', 'P'),
(123606, 'Saint Joe', 41.3152809143066, 0.721087683341024, -84.9013900756836, -1.48180879634072, 218, 19, 'PPL', 'P'),
(140828, 'Saint Joe', 48.5136108398438, 0.846722241186485, -98.9269409179688, -1.72660083794446, 218, 34, 'PPL', 'P'),
(157489, 'Saint Joe', 40.0202789306641, 0.698485634906603, -80.8041687011719, -1.4102987931724, 218, 41, 'PPL', 'P'),
(166801, 'Saint Joe', 40.9044418334961, 0.713917188685013, -79.7738876342773, -1.39231699633413, 218, 45, 'PPL', 'P'),
(195573, 'Saint Joe', 47.3111114501953, 0.825734667583897, -116.351936340332, -2.03072438020964, 218, 17, 'PPL', 'P'),
(17900, 'Saint Joe Beach', 29.9019393920898, 0.521887295123759, -85.3622207641602, -1.48985180914886, 218, 12, 'PPL', 'P'),
(33860, 'Saint John', 38.0022201538086, 0.663263864751706, -98.7597198486328, -1.72368227970584, 218, 20, 'PPL', 'P'),
(38066, 'Saint John', 37.6983299255371, 0.657959979703731, -85.9663925170898, -1.50039659548503, 218, 21, 'PPL', 'P'),
(42930, 'Saint John', 31.7561092376709, 0.554248663820344, -91.4330596923828, -1.59580793680459, 218, 22, 'PPL', 'P'),
(68470, 'Saint John', 36.3061103820801, 0.633661164759794, -77.086669921875, -1.3454161995348, 218, 33, 'PPL', 'P'),
(90573, 'Saint John', 35.4391708374023, 0.618530215289427, -89.2844390869141, -1.55830743286297, 218, 50, 'PPL', 'P'),
(97731, 'Saint John', 29.6311092376709, 0.517160417215464, -96.9530563354492, -1.69215005292514, 218, 51, 'PPL', 'P'),
(123607, 'Saint John', 41.4500007629395, 0.723438988267455, -87.4700012207031, -1.52663951802473, 218, 19, 'PPL', 'P'),
(128728, 'Saint John', 47.2083282470703, 0.82394076227362, -68.8077774047852, -1.20092226669286, 218, 26, 'PPL', 'P'),
(139432, 'Saint John', 40.5400009155273, 0.707556494737468, -93.1888885498047, -1.62645293146814, 218, 29, 'PPL', 'P'),
(140829, 'Saint John', 48.9444389343262, 0.854241609945296, -99.710563659668, -1.74027763488061, 218, 34, 'PPL', 'P'),
(176234, 'Saint John', 44.1688919067383, 0.770892590730059, -88.2038879394531, -1.53944825760357, 218, 57, 'PPL', 'P'),
(205653, 'Saint John', 40.355281829834, 0.704332538500845, -112.452217102051, -1.96266143959826, 218, 52, 'PPL', 'P'),
(208649, 'Saint John', 47.0916709899902, 0.821904709041227, -117.580833435059, -2.05217268068081, 218, 56, 'PPL', 'P'),
(157490, 'Saint John (historical)', 40.1316719055176, 0.700429809081388, -84.5991668701172, -1.47653400632765, 218, 41, 'PPL', 'P'),
(193299, 'Saint John Harbor', 56.4397201538086, 0.98505894558816, -132.963607788086, -2.32065274123247, 218, 1, 'PPL', 'P'),
(28504, 'Saint Johns', 38.0308303833008, 0.663763207456096, -89.2408294677734, -1.55754630142343, 218, 18, 'PPL', 'P'),
(57360, 'Saint Johns', 38.7133293151855, 0.675675060958829, -90.3430633544922, -1.57678391187372, 218, 29, 'PPL', 'P'),
(68472, 'Saint Johns', 35.374439239502, 0.617400435775988, -77.3600006103516, -1.35018671999546, 218, 33, 'PPL', 'P'),
(83432, 'Saint Johns', 33.1205596923828, 0.5780628167354, -80.0691680908203, -1.3974706125176, 218, 48, 'PPL', 'P'),
(90574, 'Saint Johns', 35.9741706848145, 0.627867724124435, -86.2547225952148, -1.50542890468085, 218, 50, 'PPL', 'P'),
(112351, 'Saint Johns', 36.9663887023926, 0.645185195428785, -88.6719436645508, -1.54761737108934, 218, 21, 'PPL', 'P'),
(123609, 'Saint Johns', 41.3086090087891, 0.72097123662236, -85.1136093139648, -1.4855127207848, 218, 19, 'PPL', 'P'),
(132970, 'Saint Johns', 43.0011100769043, 0.750510952854492, -84.5591735839844, -1.47583599180594, 218, 27, 'PPL', 'P'),
(157492, 'Saint Johns', 40.4075012207031, 0.705243938804897, -84.4738922119141, -1.4743475510727, 218, 41, 'PPL', 'P'),
(166802, 'Saint Johns', 41.0280609130859, 0.716074748642141, -76.0063934326172, -1.32656181796536, 218, 45, 'PPL', 'P'),
(179047, 'Saint Johns', 34.5058288574219, 0.602240324691685, -109.360282897949, -1.90869700748166, 218, 5, 'PPL', 'P'),
(184733, 'Saint Johns', 36.3847198486328, 0.635033158774375, -119.097503662109, -2.07864356980981, 218, 6, 'PPL', 'P'),
(195574, 'Saint Johns', 42.2138900756836, 0.736771371895637, -112.291107177734, -1.9598495409613, 218, 17, 'PPL', 'P'),
(197460, 'Saint Johns', 48.7991714477539, 0.851706214008514, -110.006393432617, -1.91997376364344, 218, 31, 'PPL', 'P'),
(201519, 'Saint Johns', 45.5902786254883, 0.795700468916365, -122.753326416016, -2.1424497137348, 218, 43, 'PPL', 'P'),
(157493, 'Saint Johns (historical)', 40.6458282470703, 0.709403530111492, -82.3477783203125, -1.43723986339186, 218, 41, 'PPL', 'P'),
(97732, 'Saint Johns Colony', 29.9708309173584, 0.523089679066417, -97.5580596923828, -1.70270935348925, 218, 51, 'PPL', 'P'),
(51161, 'Saint Johns Creek', 38.3458290100098, 0.669260970631428, -76.4447174072266, -1.33421201451273, 218, 25, 'PPL', 'P'),
(83433, 'Saint Johns Crossroads', 33.7750015258789, 0.589484981492696, -79.4966735839844, -1.38747869842373, 218, 48, 'PPL', 'P'),
(51162, 'Saint Johns Green', 39.2922210693359, 0.685778628081399, -76.8377838134766, -1.34107231748077, 218, 25, 'PPL', 'P'),
(137919, 'Saint Johns Landing Camp', 45.9874992370605, 0.802633276445087, -92.5266723632813, -1.6148950786533, 218, 28, 'PPL', 'P'),
(51164, 'Saint Johns Manor', 39.2683296203613, 0.68536164363372, -76.8247222900391, -1.34084435089146, 218, 25, 'PPL', 'P'),
(179048, 'Saint Johns Mission', 33.2902793884277, 0.581024984236868, -112.172500610352, -1.95777946584598, 218, 5, 'PPL', 'P'),
(17903, 'Saint Johns Park', 29.422779083252, 0.513524370089665, -81.4313888549805, -1.42124584999122, 218, 12, 'PPL', 'P'),
(17904, 'Saint Johns River Estates', 28.8391704559326, 0.503338477999898, -81.3358306884766, -1.41957804535856, 218, 12, 'PPL', 'P'),
(142923, 'Saint Johns Trailer Court', 42.2691688537598, 0.737736168579545, -96.8647232055664, -1.69060834897009, 218, 35, 'PPL', 'P'),
(51165, 'Saint Johns Village', 39.2691688537598, 0.685376291019716, -76.8302764892578, -1.34094128995514, 218, 25, 'PPL', 'P'),
(51166, 'Saint Johns Vista', 39.5316696166992, 0.689957793622006, -75.8949966430664, -1.32461757721155, 218, 25, 'PPL', 'P'),
(51168, 'Saint Johns Woods', 38.3477783203125, 0.669294992514354, -76.4416732788086, -1.33415888444898, 218, 25, 'PPL', 'P'),
(152299, 'Saint Johnsburg', 43.0886116027832, 0.752038142581598, -78.8899993896484, -1.37689023624568, 218, 40, 'PPL', 'P'),
(172489, 'Saint Johnsbury', 44.4191703796387, 0.775260774129034, -72.0155563354492, -1.25690857070905, 218, 55, 'PPL', 'P'),
(172490, 'Saint Johnsbury Center', 44.4566688537598, 0.775915245966921, -72.01611328125, -1.25691829124703, 218, 55, 'PPL', 'P'),
(14543, 'Saint Johnstown', 38.8050003051758, 0.677275021562722, -75.5758285522461, -1.31904704315943, 218, 10, 'PPL', 'P'),
(152300, 'Saint Johnsville', 42.9980583190918, 0.75045768963269, -74.6833267211914, -1.30346994762745, 218, 40, 'PPL', 'P'),
(152302, 'Saint Josen', 41.7813911437988, 0.729222841522889, -74.208610534668, -1.29518458716011, 218, 40, 'PPL', 'P'),
(17905, 'Saint Joseph', 28.375560760498, 0.495246962370397, -82.2869415283203, -1.43617806106524, 218, 12, 'PPL', 'P'),
(31034, 'Saint Joseph', 38.0661087036133, 0.664378930300122, -87.6469421386719, -1.52972771962478, 218, 19, 'PPL', 'P'),
(33862, 'Saint Joseph', 39.5097198486328, 0.689574697899198, -97.4058303833008, -1.70005245082773, 218, 20, 'PPL', 'P'),
(38068, 'Saint Joseph', 37.5219383239746, 0.6548813654836, -85.3897171020508, -1.4903317107773, 218, 21, 'PPL', 'P'),
(42932, 'Saint Joseph', 31.9183292388916, 0.557079936954234, -91.2333297729492, -1.59232199209573, 218, 22, 'PPL', 'P'),
(57362, 'Saint Joseph', 39.7686080932617, 0.694093150162681, -94.8463897705078, -1.65538178512523, 218, 29, 'PPL', 'P'),
(90575, 'Saint Joseph', 35.0361099243164, 0.611495475269983, -87.5066680908203, -1.52727947563467, 218, 50, 'PPL', 'P'),
(111256, 'Saint Joseph', 39.730281829834, 0.693424230675881, -80.7133331298828, -1.40871341337548, 218, 58, 'PPL', 'P'),
(117657, 'Saint Joseph', 42.913330078125, 0.748978902858397, -94.226936340332, -1.64457028320589, 218, 16, 'PPL', 'P'),
(121344, 'Saint Joseph', 40.1116714477539, 0.700080735241506, -88.0416717529297, -1.53661705104871, 218, 18, 'PPL', 'P'),
(132972, 'Saint Joseph', 42.1097183227539, 0.73495323181944, -86.4800033569336, -1.50936079571424, 218, 27, 'PPL', 'P'),
(137921, 'Saint Joseph', 45.564998626709, 0.795259249702766, -94.3180618286133, -1.64616072300889, 218, 28, 'PPL', 'P'),
(157495, 'Saint Joseph', 41.0272216796875, 0.716060101256145, -81.2994384765625, -1.41894288143858, 218, 41, 'PPL', 'P'),
(166803, 'Saint Joseph', 41.9277801513672, 0.731777811693684, -75.9927825927734, -1.32632426399613, 218, 45, 'PPL', 'P'),
(176235, 'Saint Joseph', 43.7855606079102, 0.764202197439562, -91.0416717529297, -1.58897692860854, 218, 57, 'PPL', 'P'),
(201520, 'Saint Joseph', 45.2383308410645, 0.78955782128307, -123.143608093262, -2.14926141401295, 218, 43, 'PPL', 'P'),
(190699, 'Saint Joseph (historical)', 36.5727806091309, 0.638315438238871, -114.448890686035, -1.99750996772639, 218, 39, 'PPL', 'P'),
(137922, 'Saint Joseph Mobile Home Park', 45.5699996948242, 0.795346534807494, -94.3208312988281, -1.64620905938267, 218, 28, 'PPL', 'P'),
(179049, 'Saint Joseph Youth Camp', 34.9458312988281, 0.609919816011037, -111.492218017578, -1.94590629475808, 218, 5, 'PPL', 'P'),
(17906, 'Saint Josephs', 28.8111095428467, 0.502848722675433, -81.3227767944336, -1.41935021192731, 218, 12, 'PPL', 'P'),
(137926, 'Saint Josephs', 44.6605606079102, 0.779473828394513, -93.5630569458008, -1.63298340193517, 218, 28, 'PPL', 'P'),
(152303, 'Saint Josephs', 41.5900001525879, 0.725882438567603, -74.710563659668, -1.30394532188203, 218, 40, 'PPL', 'P'),
(31035, 'Saint Josephs Shrine', 38.1680603027344, 0.666158321382458, -86.7977828979492, -1.51490709500044, 218, 19, 'PPL', 'P'),
(105989, 'Saint Josephs Villa', 37.6313896179199, 0.656791650933514, -77.461669921875, -1.35196118422978, 218, 53, 'PPL', 'P'),
(146253, 'Saint Josephs Village', 41.0058288574219, 0.715686726071316, -73.9352798461914, -1.29041406669945, 218, 37, 'PPL', 'P'),
(105990, 'Saint Joy', 37.5386085510254, 0.655172315832691, -78.647216796875, -1.37265288063526, 218, 53, 'PPL', 'P'),
(83434, 'Saint Julian', 33.4144401550293, 0.583191998415866, -80.3602828979492, -1.4025515244033, 218, 48, 'PPL', 'P'),
(137927, 'Saint Kilian', 43.7902793884277, 0.764284555696273, -95.8708267211914, -1.67326158289375, 218, 28, 'PPL', 'P'),
(176238, 'Saint Kilian', 43.5430603027344, 0.759969768677154, -88.3613891601563, -1.54219717248075, 218, 57, 'PPL', 'P'),
(42933, 'Saint Landry', 30.8441696166992, 0.538332314854999, -92.2577819824219, -1.61020205618036, 218, 22, 'PPL', 'P'),
(152304, 'Saint Lawrence', 44.1772193908691, 0.77103793274655, -76.1680603027344, -1.3293834371403, 218, 40, 'PPL', 'P'),
(166805, 'Saint Lawrence', 40.6986083984375, 0.710324717532551, -78.6255569458008, -1.37227484491852, 218, 45, 'PPL', 'P'),
(171248, 'Saint Lawrence', 44.5177803039551, 0.776981841983498, -98.9375, -1.72678512869189, 218, 49, 'PPL', 'P'),
(176239, 'Saint Lawrence', 43.3697204589844, 0.756944417678824, -88.3327789306641, -1.54169782977636, 218, 57, 'PPL', 'P'),
(192153, 'Saint Lawrence', 31.7024993896484, 0.553312995460858, -101.537498474121, -1.77216366261213, 218, 51, 'PPL', 'P'),
(74178, 'Saint Lawrence Corners', 39.1105613708496, 0.682608068224633, -84.5725021362305, -1.47606861892716, 218, 41, 'PPL', 'P'),
(152306, 'Saint Lawrence Park', 44.3097190856934, 0.773350488679121, -75.9633331298828, -1.32581027390574, 218, 40, 'PPL', 'P'),
(17907, 'Saint Leo', 28.3369407653809, 0.494572916298498, -82.2586135864258, -1.43568364520887, 218, 12, 'PPL', 'P'),
(33863, 'Saint Leo', 37.5291709899902, 0.655007599319269, -98.4100036621094, -1.71757858080349, 218, 20, 'PPL', 'P'),
(111257, 'Saint Leo', 39.6427803039551, 0.691897040948775, -80.3611068725586, -1.40256590547319, 218, 58, 'PPL', 'P'),
(137929, 'Saint Leo', 44.7172203063965, 0.780462726686286, -96.0519409179688, -1.67642262194962, 218, 28, 'PPL', 'P'),
(31036, 'Saint Leon', 39.2919387817383, 0.685773701233383, -84.9580612182617, -1.48279789436957, 218, 19, 'PPL', 'P'),
(51169, 'Saint Leonard', 38.4741706848145, 0.671500955424294, -76.5066680908203, -1.3352932579153, 218, 25, 'PPL', 'P'),
(166807, 'Saint Leonard', 40.2013893127441, 0.701646607383446, -74.9591674804688, -1.30828427708804, 218, 45, 'PPL', 'P'),
(51170, 'Saint Leonard (historical)', 38.4472198486328, 0.671030574596759, -76.4875030517578, -1.33495876488238, 218, 25, 'PPL', 'P'),
(51171, 'Saint Leonard Shores', 38.436939239502, 0.670851144118314, -76.4908294677734, -1.33501682179415, 218, 25, 'PPL', 'P'),
(68474, 'Saint Lewis', 35.7813911437988, 0.624503086403229, -77.7033309936523, -1.35617896560619, 218, 33, 'PPL', 'P'),
(28505, 'Saint Libory', 38.3624992370605, 0.669551920980519, -89.709716796875, -1.56572992913713, 218, 18, 'PPL', 'P'),
(142925, 'Saint Libory', 41.0819396972656, 0.717015110823048, -98.3550033569336, -1.71661864438857, 218, 35, 'PPL', 'P'),
(24604, 'Saint Louis', 32.4652786254883, 0.56662600459211, -83.866943359375, -1.46375429520469, 218, 13, 'PPL', 'P'),
(42936, 'Saint Louis', 30.8052806854248, 0.537653574961678, -92.1744384765625, -1.60874743759296, 218, 22, 'PPL', 'P'),
(57364, 'Saint Louis', 38.6272201538086, 0.67417217257667, -90.1977767944336, -1.5742481830418, 218, 29, 'PPL', 'P'),
(77158, 'Saint Louis', 35.0741691589355, 0.612159734224876, -96.852783203125, -1.69039995661479, 218, 42, 'PPL', 'P'),
(105991, 'Saint Louis', 39.0013885498047, 0.680702643043708, -77.7930603027344, -1.35774503748521, 218, 53, 'PPL', 'P'),
(132976, 'Saint Louis', 43.4083290100098, 0.757618264013641, -84.6066665649414, -1.47666490069523, 218, 27, 'PPL', 'P'),
(184734, 'Saint Louis', 39.6986083984375, 0.692871425012607, -120.923889160156, -2.11052001016141, 218, 6, 'PPL', 'P'),
(201521, 'Saint Louis', 45.1227798461914, 0.787541075968581, -122.941108703613, -2.14572713293031, 218, 43, 'PPL', 'P'),
(31037, 'Saint Louis Crossing', 39.3188896179199, 0.686244082060918, -85.8466720581055, -1.49830707929376, 218, 19, 'PPL', 'P'),
(211093, 'Saint Louis Heights', 21.3030605316162, 0.371808547028356, -157.806945800781, -2.75425078673987, 218, 15, 'PPL', 'P'),
(137932, 'Saint Louis Park', 44.9483299255371, 0.78449635047332, -93.3477783203125, -1.62922608111124, 218, 28, 'PPL', 'P'),
(42937, 'Saint Louis Plantation', 30.2658290863037, 0.528238368401867, -91.2155609130859, -1.59201186698679, 218, 22, 'PPL', 'P'),
(157497, 'Saint Louisville', 40.172779083252, 0.701147264679056, -82.4188919067383, -1.43848102961789, 218, 41, 'PPL', 'P'),
(117658, 'Saint Lucas', 43.0663909912109, 0.751650319747855, -91.9333267211914, -1.60453924359647, 218, 16, 'PPL', 'P'),
(17908, 'Saint Lucie', 27.4891700744629, 0.479776526440072, -80.3399963378906, -1.40219745713638, 218, 12, 'PPL', 'P'),
(105992, 'Saint Luke', 38.9033317565918, 0.678991229148196, -78.5808334350586, -1.37149427240302, 218, 53, 'PPL', 'P'),
(31038, 'Saint Magdalen', 38.9577789306641, 0.679941511604164, -85.3913879394531, -1.49036087239123, 218, 19, 'PPL', 'P'),
(42938, 'Saint Malo', 29.8777809143066, 0.521465650144173, -89.5969390869141, -1.56376158677545, 218, 22, 'PPL', 'P'),
(51172, 'Saint Margarets', 39.0208282470703, 0.681041929766584, -76.4630584716797, -1.33453212647575, 218, 25, 'PPL', 'P'),
(51173, 'Saint Margarets Farm', 39.0166702270508, 0.68096935862688, -76.466667175293, -1.33459511023553, 218, 25, 'PPL', 'P'),
(51174, 'Saint Margarets Grove', 38.2597198486328, 0.667758082249269, -76.6069412231445, -1.33704335422564, 218, 25, 'PPL', 'P'),
(197461, 'Saint Marie', 48.4022216796875, 0.844778133590727, -106.532218933105, -1.85933797983813, 218, 31, 'PPL', 'P'),
(195575, 'Saint Maries', 47.3144416809082, 0.825792791074688, -116.561668395996, -2.03438489512795, 218, 17, 'PPL', 'P'),
(17911, 'Saint Marks', 30.1608295440674, 0.526405780676756, -84.2063903808594, -1.46967876336568, 218, 12, 'PPL', 'P'),
(24605, 'Saint Marks', 33.1252784729004, 0.578145174992111, -84.8211135864258, -1.48040770729123, 218, 13, 'PPL', 'P'),
(31039, 'Saint Marks', 38.3055610656738, 0.668558162419756, -86.8180618286133, -1.51526102910931, 218, 19, 'PPL', 'P'),
(33864, 'Saint Marks', 37.7358283996582, 0.658614451541618, -97.5619430541992, -1.70277713093899, 218, 20, 'PPL', 'P'),
(51175, 'Saint Martin', 38.371940612793, 0.669716704072968, -75.2483291625977, -1.3133311005118, 218, 25, 'PPL', 'P'),
(68475, 'Saint Martin', 35.2636108398438, 0.615466115297236, -80.273063659668, -1.40102926152422, 218, 33, 'PPL', 'P'),
(74179, 'Saint Martin', 39.2144393920898, 0.684421081715731, -83.8933334350586, -1.46421488891522, 218, 41, 'PPL', 'P'),
(137934, 'Saint Martin', 45.5019416809082, 0.794158698382291, -94.6686096191406, -1.65227893613918, 218, 28, 'PPL', 'P'),
(57367, 'Saint Martins', 38.5941696166992, 0.673595331884559, -92.3369369506836, -1.61158357099584, 218, 29, 'PPL', 'P'),
(166808, 'Saint Martins', 40.0677795410156, 0.699314676953945, -75.1972198486328, -1.31243907470467, 218, 45, 'PPL', 'P'),
(176242, 'Saint Martins', 42.9022216796875, 0.748785024731039, -88.0563888549805, -1.53687391293585, 218, 57, 'PPL', 'P'),
(51176, 'Saint Martins by the Bay', 38.4047203063965, 0.670288817654144, -75.1688919067383, -1.3119446588483, 218, 25, 'PPL', 'P'),
(208650, 'Saint Martins Hot Springs', 45.7277793884277, 0.798100309953663, -121.795562744141, -2.12573358420459, 218, 56, 'PPL', 'P'),
(42940, 'Saint Martinville', 30.125, 0.525780437163292, -91.8333282470703, -1.60279394097609, 218, 22, 'PPL', 'P'),
(38069, 'Saint Mary', 37.5805587768555, 0.655904485395381, -85.3463897705078, -1.48957550618577, 218, 21, 'PPL', 'P'),
(57368, 'Saint Mary', 37.8788909912109, 0.661111364800649, -89.9491729736328, -1.56990922783579, 218, 29, 'PPL', 'P'),
(121346, 'Saint Mary', 40.3461112976074, 0.704172482519331, -90.9338912963867, -1.58709580477256, 218, 18, 'PPL', 'P'),
(137937, 'Saint Mary', 44.0283317565918, 0.768439353312905, -93.6016693115234, -1.63365731484902, 218, 28, 'PPL', 'P'),
(142928, 'Saint Mary', 40.4241714477539, 0.705534889153989, -96.2897186279297, -1.68057262587629, 218, 35, 'PPL', 'P'),
(197462, 'Saint Mary', 48.7438888549805, 0.850741350745578, -113.428611755371, -1.97970274109757, 218, 31, 'PPL', 'P'),
(31040, 'Saint Mary-of-the-Woods', 39.5108299255371, 0.689594072396129, -87.4672164916992, -1.52659091533483, 218, 19, 'PPL', 'P'),
(24606, 'Saint Marys', 30.7302799224854, 0.536344564706877, -81.5466690063477, -1.42325786819478, 218, 13, 'PPL', 'P'),
(31042, 'Saint Marys', 39.3477783203125, 0.686748285034297, -85.10888671875, -1.48543029594906, 218, 19, 'PPL', 'P'),
(33867, 'Saint Marys', 37.7066688537598, 0.658105521457304, -97.6397171020508, -1.7041345441466, 218, 20, 'PPL', 'P'),
(90577, 'Saint Marys', 35.0349998474121, 0.611476100773052, -87.4188919067383, -1.52574749221761, 218, 50, 'PPL', 'P'),
(111258, 'Saint Marys', 39.3916702270508, 0.687514343321858, -81.2052764892578, -1.41729944472989, 218, 58, 'PPL', 'P'),
(117659, 'Saint Marys', 41.3080596923828, 0.720961649242436, -93.7294387817383, -1.6358873127878, 218, 16, 'PPL', 'P'),
(157498, 'Saint Marys', 40.5422210693359, 0.707595243731328, -84.3894424438477, -1.47287362456739, 218, 41, 'PPL', 'P'),
(166809, 'Saint Marys', 41.4277801513672, 0.723051165433712, -78.5611114501953, -1.37115005883213, 218, 45, 'PPL', 'P'),
(176243, 'Saint Marys', 43.7980613708496, 0.764420376911867, -90.6872177124023, -1.58279053855434, 218, 57, 'PPL', 'P'),
(187305, 'Saint Marys', 39.8166694641113, 0.694931979327029, -105.646942138672, -1.84388698498376, 218, 7, 'PPL', 'P'),
(212129, 'Saint Marys', 62.0530586242676, 1.08303018392653, -163.165832519531, -2.84778100422346, 218, 1, 'PPL', 'P'),
(51177, 'Saint Marys Beach', 38.4119415283203, 0.670414851752732, -76.6111068725586, -1.3371160585234, 218, 25, 'PPL', 'P'),
(24607, 'Saint Marys Hills', 32.4511108398438, 0.566378730084896, -84.9347229003906, -1.48239056388084, 218, 13, 'PPL', 'P'),
(137939, 'Saint Marys Point', 44.9144401550293, 0.783904862395214, -92.7655563354492, -1.61906439049787, 218, 28, 'PPL', 'P'),
(51179, 'Saint Marys River Estates', 38.1963882446289, 0.666652737238832, -76.4608306884766, -1.33449324432384, 218, 25, 'PPL', 'P'),
(166810, 'Saint Marys Seminary', 40.0416717529297, 0.698859010091432, -75.3411102294922, -1.31495043561262, 218, 45, 'PPL', 'P'),
(137941, 'Saint Mathias', 46.2227783203125, 0.806739671108907, -94.2508316040039, -1.6449873342326, 218, 28, 'PPL', 'P'),
(11758, 'Saint Matthews', 33.4033317565918, 0.582998120288508, -93.1750030517578, -1.62621058380894, 218, 4, 'PPL', 'P'),
(38070, 'Saint Matthews', 38.2527809143066, 0.667636974998698, -85.6558303833008, -1.4949762637184, 218, 21, 'PPL', 'P'),
(83436, 'Saint Matthews', 33.6647186279297, 0.587560181814841, -80.7780609130859, -1.40984312630989, 218, 48, 'PPL', 'P'),
(31043, 'Saint Maurice', 39.3661117553711, 0.68706826383927, -85.3344421386719, -1.48936698067242, 218, 19, 'PPL', 'P'),
(42942, 'Saint Maurice', 31.7594394683838, 0.554306787311135, -92.9588928222656, -1.62243874875706, 218, 22, 'PPL', 'P'),
(31044, 'Saint Meinrad', 38.1711082458496, 0.666211518025233, -86.8091735839844, -1.51510589997581, 218, 19, 'PPL', 'P'),
(113341, 'Saint Michael', 40.3369407653809, 0.704012426537818, -78.771110534668, -1.37481523428235, 218, 45, 'PPL', 'P'),
(137943, 'Saint Michael', 45.2099990844727, 0.78906333884767, -93.6647186279297, -1.63475773301144, 218, 28, 'PPL', 'P'),
(140833, 'Saint Michael', 47.9850006103516, 0.837496252222123, -98.8716735839844, -1.72563624099763, 218, 34, 'PPL', 'P'),
(142929, 'Saint Michael', 41.023609161377, 0.715997050917338, -98.7474975585938, -1.72346896050252, 218, 35, 'PPL', 'P'),
(212128, 'Saint Michael', 63.4780616760254, 1.10790117903067, -162.039169311523, -2.82811702168264, 218, 1, 'PPL', 'P'),
(51180, 'Saint Michaels', 38.7849998474121, 0.67692594772284, -76.2247161865234, -1.33037226885305, 218, 25, 'PPL', 'P'),
(176244, 'Saint Michaels', 43.5133285522461, 0.759450851738752, -88.1605606079102, -1.53869205301205, 218, 57, 'PPL', 'P'),
(179050, 'Saint Michaels', 35.644718170166, 0.622117693014845, -109.095001220703, -1.9040669687685, 218, 5, 'PPL', 'P'),
(28506, 'Saint Morgan', 38.6622200012207, 0.674783035151707, -89.6875, -1.56534217288241, 218, 18, 'PPL', 'P'),
(176245, 'Saint Nazianz', 44.0080604553223, 0.768085552362088, -87.9222183227539, -1.53453219538934, 218, 57, 'PPL', 'P'),
(17913, 'Saint Nicholas', 30.3052806854248, 0.528926928701707, -81.6358337402344, -1.42481408637777, 218, 12, 'PPL', 'P'),
(132978, 'Saint Nicholas', 45.9855613708496, 0.802599454299243, -87.2266693115234, -1.52239257503438, 218, 27, 'PPL', 'P'),
(137945, 'Saint Nicholas', 45.3808288574219, 0.792044880846068, -94.436393737793, -1.64822600443424, 218, 28, 'PPL', 'P'),
(166812, 'Saint Nicholas', 40.8044395446777, 0.712171819485602, -76.1780624389648, -1.32955800734976, 218, 45, 'PPL', 'P'),
(157500, 'Saint Nicholas (historical)', 41.0141716003418, 0.715832334403916, -83.3397216796875, -1.45455254100625, 218, 41, 'PPL', 'P'),
(117661, 'Saint Olaf', 42.9286117553711, 0.749245618441568, -91.3861083984375, -1.59498848213718, 218, 16, 'PPL', 'P'),
(31045, 'Saint Omer', 39.4355583190918, 0.688280335030392, -85.595832824707, -1.49392910877778, 218, 19, 'PPL', 'P'),
(202587, 'Saint Onge', 44.5466690063477, 0.777486044956877, -103.720558166504, -1.81026524201179, 218, 49, 'PPL', 'P'),
(157501, 'Saint Paris', 40.1283302307129, 0.700371485853516, -83.959716796875, -1.46537349714746, 218, 41, 'PPL', 'P'),
(137947, 'Saint Patrick', 44.5947189331055, 0.778324674384143, -93.5019378662109, -1.63191667276054, 218, 28, 'PPL', 'P'),
(139433, 'Saint Patrick', 40.2644386291504, 0.702747025545866, -91.6275024414063, -1.59920160298168, 218, 29, 'PPL', 'P'),
(157502, 'Saint Patrick', 40.3708305358887, 0.704603914615924, -84.2874984741211, -1.47109436664311, 218, 41, 'PPL', 'P'),
(33869, 'Saint Pats', 39.4777793884277, 0.689017231704017, -95.1213912963867, -1.66018146719983, 218, 20, 'PPL', 'P'),
(11759, 'Saint Paul', 35.8241691589355, 0.625249703614833, -93.7638931274414, -1.63648865456194, 218, 4, 'PPL', 'P'),
(28507, 'Saint Paul', 38.8527793884277, 0.678108923879053, -88.9533309936523, -1.55252850645555, 218, 18, 'PPL', 'P'),
(31046, 'Saint Paul', 39.4280586242676, 0.688149440662815, -85.6283264160156, -1.49449622893191, 218, 19, 'PPL', 'P'),
(33871, 'Saint Paul', 37.6624984741211, 0.657334602900754, -97.7519378662109, -1.7060931659703, 218, 20, 'PPL', 'P'),
(38072, 'Saint Paul', 38.6708297729492, 0.674933304016215, -83.0872192382813, -1.45014554203438, 218, 21, 'PPL', 'P'),
(57371, 'Saint Paul', 38.8613891601563, 0.678259192743561, -90.7416687011719, -1.58374088758934, 218, 29, 'PPL', 'P'),
(61645, 'Saint Paul', 31.0750007629395, 0.542361078373043, -89.8138885498047, -1.56754806921333, 218, 30, 'PPL', 'P'),
(74180, 'Saint Paul', 39.7472190856934, 0.693719841556879, -82.9127807617188, -1.4471010162762, 218, 41, 'PPL', 'P'),
(79079, 'Saint Paul', 39.7755584716797, 0.694214457150334, -79.1063919067383, -1.38066699814558, 218, 45, 'PPL', 'P'),
(83437, 'Saint Paul', 33.5780601501465, 0.586047706052758, -80.3949966430664, -1.4031573935513, 218, 48, 'PPL', 'P'),
(90578, 'Saint Paul', 35.4930610656738, 0.619470777207416, -89.9438934326172, -1.56981708246207, 218, 50, 'PPL', 'P'),
(97737, 'Saint Paul', 30.1086101531982, 0.525494380372704, -96.1286087036133, -1.67776072723933, 218, 51, 'PPL', 'P'),
(105993, 'Saint Paul', 36.9052810668945, 0.644118665991235, -82.3111114501953, -1.43659990578191, 218, 53, 'PPL', 'P'),
(117662, 'Saint Paul', 40.7694396972656, 0.711560956910565, -91.5169372558594, -1.59727187645581, 218, 16, 'PPL', 'P'),
(137948, 'Saint Paul', 44.9444389343262, 0.784428439865523, -93.0930633544922, -1.62478046630357, 218, 28, 'PPL', 'P'),
(142930, 'Saint Paul', 41.2147216796875, 0.719332593603635, -98.4577789306641, -1.71841241654079, 218, 35, 'PPL', 'P'),
(201522, 'Saint Paul', 45.2113914489746, 0.789087640192617, -122.975563049316, -2.14632847470445, 218, 43, 'PPL', 'P'),
(212130, 'Saint Paul', 57.1222190856934, 0.996970799090894, -170.274993896484, -2.9718592773069, 218, 1, 'PPL', 'P'),
(137949, 'Saint Paul Church', 46.7849998474121, 0.816552287882386, -92.2113876342773, -1.60939232205092, 218, 28, 'PPL', 'P'),
(97740, 'Saint Paul Estates Colonia', 28.0799999237061, 0.490088452628427, -97.5670013427734, -1.70286541472913, 218, 51, 'PPL', 'P'),
(83438, 'Saint Paul Forks', 33.8891716003418, 0.59147762519932, -79.0363922119141, -1.3794452729955, 218, 48, 'PPL', 'P'),
(97738, 'Saint Paul Number 1 Colonia', 28.0799999237061, 0.490088452628427, -97.5719985961914, -1.70295263325483, 218, 51, 'PPL', 'P'),
(137950, 'Saint Paul Park', 44.8422203063965, 0.782644388251279, -92.9911117553711, -1.62300107522123, 218, 28, 'PPL', 'P'),
(51181, 'Saint Pauls', 39.7108306884766, 0.693084744215923, -76.790283203125, -1.34024327543343, 218, 25, 'PPL', 'P'),
(68479, 'Saint Pauls', 34.8063888549805, 0.607486086248868, -78.9713897705078, -1.37831076637113, 218, 33, 'PPL', 'P'),
(83439, 'Saint Pauls', 33.5758285522461, 0.586008757321815, -79.1858291625977, -1.38205343980907, 218, 48, 'PPL', 'P'),
(17914, 'Saint Pete Beach', 27.7250003814697, 0.483892541773331, -82.7413864135742, -1.44410962058177, 218, 12, 'PPL', 'P'),
(17915, 'Saint Peter', 30.485559463501, 0.532073386950608, -84.2291717529297, -1.47007637331643, 218, 12, 'PPL', 'P'),
(28508, 'Saint Peter', 38.8680610656738, 0.678375639462224, -88.853889465332, -1.55079292437315, 218, 18, 'PPL', 'P'),
(31047, 'Saint Peter', 39.3216705322266, 0.686292618171785, -85.0316696166992, -1.48408260327943, 218, 19, 'PPL', 'P'),
(137953, 'Saint Peter', 44.3236083984375, 0.773592902917345, -93.9577789306641, -1.63987260020104, 218, 28, 'PPL', 'P'),
(157503, 'Saint Peter', 40.4502792358398, 0.705990556016501, -84.7461090087891, -1.4790986304574, 218, 41, 'PPL', 'P'),
(176247, 'Saint Peter', 43.8363914489746, 0.765089362977695, -88.3413925170898, -1.5418481652199, 218, 57, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(187877, 'Saint Peter', 39.1897201538086, 0.683989649619139, -100.088890075684, -1.74688067648736, 218, 20, 'PPL', 'P'),
(197463, 'Saint Peter', 47.3025016784668, 0.82558439871939, -111.917221069336, -1.95332399734228, 218, 31, 'PPL', 'P'),
(57372, 'Saint Peters', 38.8002815246582, 0.677192663306011, -90.6263885498047, -1.58172886938578, 218, 29, 'PPL', 'P'),
(90579, 'Saint Peters', 35.6172218322754, 0.621637791386413, -89.3872222900391, -1.56010133817325, 218, 50, 'PPL', 'P'),
(166813, 'Saint Peters', 40.1800003051758, 0.701273298777644, -75.7311096191406, -1.32175720904275, 218, 45, 'PPL', 'P'),
(51182, 'Saint Peters Key', 38.170280456543, 0.666197070376319, -76.4166717529297, -1.33372252550437, 218, 25, 'PPL', 'P'),
(17916, 'Saint Petersburg', 27.7705593109131, 0.484687695095801, -82.679443359375, -1.44302851033726, 218, 12, 'PPL', 'P'),
(166814, 'Saint Petersburg', 41.1616706848145, 0.718406679071641, -79.6530609130859, -1.39020817222495, 218, 45, 'PPL', 'P'),
(194410, 'Saint Petersburg', 40.5555610656738, 0.707828070589629, -102.816673278809, -1.79448947466248, 218, 7, 'PPL', 'P'),
(31048, 'Saint Philip', 37.9869384765625, 0.662997149168534, -87.7158279418945, -1.5309300036989, 218, 19, 'PPL', 'P'),
(197464, 'Saint Phillip', 46.8316688537598, 0.817366815701787, -104.144996643066, -1.81767309089995, 218, 31, 'PPL', 'P'),
(83440, 'Saint Phillips', 34.3013916015625, 0.598672221463197, -81.5105590820313, -1.42262763112281, 218, 48, 'PPL', 'P'),
(152308, 'Saint Regis', 44.9972190856934, 0.785349627286582, -74.6513900756836, -1.3029125480113, 218, 40, 'PPL', 'P'),
(197465, 'Saint Regis', 47.2994384765625, 0.825530935760506, -115.101669311523, -2.0089031040278, 218, 31, 'PPL', 'P'),
(152309, 'Saint Regis Falls', 44.6738891601563, 0.779706455515731, -74.545280456543, -1.30106058578926, 218, 40, 'PPL', 'P'),
(38073, 'Saint Regis Park', 38.2266693115234, 0.667181241557158, -85.6166687011719, -1.49429276342463, 218, 21, 'PPL', 'P'),
(113210, 'Saint Remy', 41.8824996948242, 0.730987518640203, -74.0216674804688, -1.2919218153506, 218, 40, 'PPL', 'P'),
(42944, 'Saint Rest', 32.3488883972168, 0.564594611891624, -92.6222229003906, -1.61656275012791, 218, 22, 'PPL', 'P'),
(57374, 'Saint Robert', 37.8280601501465, 0.660224199262517, -92.1774978637695, -1.60880083397282, 218, 29, 'PPL', 'P'),
(172492, 'Saint Rocks', 44.850830078125, 0.782794657115787, -72.9447174072266, -1.27312549069292, 218, 55, 'PPL', 'P'),
(137955, 'Saint Rosa', 45.7305603027344, 0.79814884606453, -94.7155609130859, -1.6530983908066, 218, 28, 'PPL', 'P'),
(157504, 'Saint Rosa', 40.4075012207031, 0.705243938804897, -84.5166702270508, -1.4750941682843, 218, 41, 'PPL', 'P'),
(42945, 'Saint Rosalie', 29.663610458374, 0.517727670527651, -89.9694366455078, -1.57026289562855, 218, 22, 'PPL', 'P'),
(28509, 'Saint Rose', 38.6841697692871, 0.675166130874515, -89.554443359375, -1.56301989641187, 218, 18, 'PPL', 'P'),
(42946, 'Saint Rose', 29.9466705322266, 0.522668000797316, -90.3230590820313, -1.57643477145481, 218, 22, 'PPL', 'P'),
(176248, 'Saint Rose', 42.6238899230957, 0.743927219165653, -90.434440612793, -1.57837874589252, 218, 57, 'PPL', 'P'),
(42947, 'Saint Rose Plantation', 29.8286094665527, 0.520607446482895, -90.9211120605469, -1.58687276503127, 218, 22, 'PPL', 'P'),
(11760, 'Saint Scholastica', 35.3036117553711, 0.616164262977001, -93.4638900756836, -1.63125261354273, 218, 4, 'PPL', 'P'),
(117663, 'Saint Sebald', 42.7383308410645, 0.745924589983212, -91.5458297729492, -1.59777614600822, 218, 16, 'PPL', 'P'),
(24610, 'Saint Simon Mills', 31.170560836792, 0.544028916295219, -81.4075012207031, -1.42082893212257, 218, 13, 'PPL', 'P'),
(24611, 'Saint Simons', 31.1350002288818, 0.543408266603176, -81.3902816772461, -1.42052839439356, 218, 13, 'PPL', 'P'),
(24612, 'Saint Simons Heights', 31.1591701507568, 0.543830111319845, -81.3858337402344, -1.42045076324778, 218, 13, 'PPL', 'P'),
(24613, 'Saint Simons Island', 31.1502799987793, 0.543674948896834, -81.3697204589844, -1.42016953343667, 218, 13, 'PPL', 'P'),
(51183, 'Saint Stephen', 38.1872215270996, 0.666492747836345, -75.8402786254883, -1.32366256764465, 218, 25, 'PPL', 'P'),
(83441, 'Saint Stephen', 33.4041709899902, 0.583012767674503, -79.9219436645508, -1.39490106153983, 218, 48, 'PPL', 'P'),
(137957, 'Saint Stephen', 45.7027816772461, 0.797664017588081, -94.274169921875, -1.64539466472132, 218, 28, 'PPL', 'P'),
(5615, 'Saint Stephens', 31.5402793884277, 0.550481722326967, -88.0552825927734, -1.53685460501795, 218, 2, 'PPL', 'P'),
(105994, 'Saint Stephens', 38.6958312988281, 0.675369662960825, -77.6686096191406, -1.35557296330014, 218, 53, 'PPL', 'P'),
(142933, 'Saint Stephens', 40.2536087036133, 0.702558007687498, -98.2558288574219, -1.71488772283807, 218, 35, 'PPL', 'P'),
(157505, 'Saint Stephens', 41.0227813720703, 0.715982603268424, -82.9583282470703, -1.44789596986159, 218, 41, 'PPL', 'P'),
(209716, 'Saint Stephens', 42.9838905334473, 0.750210415125477, -108.415832519531, -1.89221323875656, 218, 59, 'PPL', 'P'),
(51184, 'Saint Stephens Estates', 39.0397186279297, 0.681371629109536, -76.6655578613281, -1.3380664075584, 218, 25, 'PPL', 'P'),
(42948, 'Saint Tammany', 30.3938903808594, 0.530473459636229, -89.8949966430664, -1.56896367249076, 218, 22, 'PPL', 'P'),
(42949, 'Saint Tammany Corner', 30.4269409179688, 0.531050300328341, -89.8855590820313, -1.56879895597734, 218, 22, 'PPL', 'P'),
(17917, 'Saint Teresa', 29.9305591583252, 0.522386804275717, -84.4541702270508, -1.4740033375018, 218, 12, 'PPL', 'P'),
(193300, 'Saint Terese', 58.4722213745117, 1.02053278394023, -134.7802734375, -2.35235953822263, 218, 1, 'PPL', 'P'),
(11761, 'Saint Thomas', 35.4419403076172, 0.618578551663212, -90.1427764892578, -1.57328824662688, 218, 4, 'PPL', 'P'),
(28511, 'Saint Thomas', 38.7619400024414, 0.676523477503101, -90.116943359375, -1.57283737345433, 218, 18, 'PPL', 'P'),
(31049, 'Saint Thomas', 38.586109161377, 0.673454650399976, -87.5622177124023, -1.52824899942952, 218, 19, 'PPL', 'P'),
(42952, 'Saint Thomas', 29.8933296203613, 0.521737026259252, -91.0066680908203, -1.58836599945448, 218, 22, 'PPL', 'P'),
(57375, 'Saint Thomas', 38.3683280944824, 0.66965365373416, -92.216667175293, -1.60948446742464, 218, 29, 'PPL', 'P'),
(79080, 'Saint Thomas', 39.9174995422363, 0.696691796175353, -77.7980575561523, -1.35783225601091, 218, 45, 'PPL', 'P'),
(137959, 'Saint Thomas', 44.4977798461914, 0.776632768143616, -93.7572174072266, -1.63637214126424, 218, 28, 'PPL', 'P'),
(140835, 'Saint Thomas', 48.6191711425781, 0.848564616028602, -97.4461135864258, -1.70075552535551, 218, 34, 'PPL', 'P'),
(11762, 'Saint Thomas (historical)', 35.4322204589844, 0.618408908301774, -90.1716690063477, -1.57379251617929, 218, 4, 'PPL', 'P'),
(187306, 'Saint Thomas (historical)', 37.1344413757324, 0.648118267895344, -104.556938171387, -1.82486282689484, 218, 7, 'PPL', 'P'),
(190700, 'Saint Thomas (historical)', 36.4658317565918, 0.636448828630834, -114.369438171387, -1.99612325974678, 218, 39, 'PPL', 'P'),
(90580, 'Saint Truitt', 35.0244407653809, 0.611291810025619, -87.3711090087891, -1.52491352332225, 218, 50, 'PPL', 'P'),
(208651, 'Saint Urban', 46.5180587768555, 0.811893287292374, -122.885276794434, -2.14475268228745, 218, 56, 'PPL', 'P'),
(113207, 'Saint Vencent de Paul Camp', 42.6552810668945, 0.744475097980909, -79.0611114501953, -1.3798767050921, 218, 40, 'PPL', 'P'),
(11764, 'Saint Vincent', 35.3011093139648, 0.616120587135123, -92.7313919067383, -1.61846810872981, 218, 4, 'PPL', 'P'),
(38074, 'Saint Vincent', 37.704719543457, 0.658071499574378, -87.8399963378906, -1.53309715103595, 218, 21, 'PPL', 'P'),
(137960, 'Saint Vincent', 48.9677810668945, 0.854649007013051, -97.2247161865234, -1.69689141177186, 218, 28, 'PPL', 'P'),
(184736, 'Saint Vincent', 38.0297203063965, 0.663743832959165, -122.533332824707, -2.13861010123318, 218, 6, 'PPL', 'P'),
(137961, 'Saint Vincent Junction', 48.9736099243164, 0.854750739766692, -97.1986083984375, -1.69643574490935, 218, 28, 'PPL', 'P'),
(166816, 'Saint Vincent Shaft', 40.2838897705078, 0.703086512005824, -79.4000015258789, -1.38579145271511, 218, 45, 'PPL', 'P'),
(146254, 'Saint Vladimirs', 40.1147193908691, 0.700133931884281, -74.39111328125, -1.2983698609819, 218, 37, 'PPL', 'P'),
(189405, 'Saint Vrain', 34.4161109924316, 0.600674452549745, -103.489166259766, -1.80622669137674, 218, 38, 'PPL', 'P'),
(194411, 'Saint Vrains', 40.0369415283203, 0.69877645209764, -104.954170227051, -1.83179583416064, 218, 7, 'PPL', 'P'),
(31050, 'Saint Wendel', 38.1055603027344, 0.665067490599962, -87.6972198486328, -1.53060523120397, 218, 19, 'PPL', 'P'),
(137964, 'Saint Wendel', 45.6661109924316, 0.797023993399107, -94.3775024414063, -1.64719815741153, 218, 28, 'PPL', 'P'),
(197466, 'Saint Xavier', 45.461109161377, 0.793446036474586, -107.72110748291, -1.88008799947148, 218, 31, 'PPL', 'P'),
(57376, 'Sainte Genevieve', 37.9813919067383, 0.66290034326291, -90.0416717529297, -1.5715236360886, 218, 29, 'PPL', 'P'),
(28512, 'Sainte Marie', 38.9322204589844, 0.679495432121575, -88.0233306884766, -1.53629693908568, 218, 18, 'PPL', 'P'),
(5616, 'Saints Crossroads', 34.5488891601563, 0.602991868751305, -87.5888900756836, -1.52871451998806, 218, 2, 'PPL', 'P'),
(187307, 'Saints John', 39.5716705322266, 0.69065594130177, -105.88111114502, -1.84797400515065, 218, 7, 'PPL', 'P'),
(197467, 'Saints Rest (historical)', 45.6958312988281, 0.797542710600428, -106.698608398438, -1.86224202384881, 218, 31, 'PPL', 'P'),
(152311, 'Saintsville', 43.0819396972656, 0.751921695862934, -75.9638900756836, -1.32581999444372, 218, 40, 'PPL', 'P'),
(90581, 'Sainville', 35.5097198486328, 0.619761527819425, -85.9127807617188, -1.49946089383603, 218, 50, 'PPL', 'P'),
(189406, 'Saiz Place', 34.6522216796875, 0.604795361441507, -106.326393127441, -1.85574564184372, 218, 38, 'PPL', 'P'),
(169587, 'Sakonnet', 41.4625015258789, 0.72365716773976, -71.1949996948242, -1.24258715563104, 218, 47, 'PPL', 'P'),
(5617, 'Saks', 33.6986083984375, 0.588151669892948, -85.8397216796875, -1.4981857723061, 218, 2, 'PPL', 'P'),
(90582, 'Sal City', 35.0558280944824, 0.611839622261848, -86.0491714477539, -1.5018413603764, 218, 50, 'PPL', 'P'),
(152312, 'Sala', 43.4358291625977, 0.758098232221101, -76.3313903808594, -1.33223408477112, 218, 40, 'PPL', 'P'),
(24614, 'Salacoa', 34.3905601501465, 0.600228506225212, -84.6113891601563, -1.47674732553097, 218, 13, 'PPL', 'P'),
(97739, 'Salado', 30.9469394683838, 0.540125987138681, -97.538330078125, -1.7023650067603, 218, 51, 'PPL', 'P'),
(112245, 'Salado', 35.6911087036133, 0.622927360565257, -91.5955581665039, -1.59864407020747, 218, 4, 'PPL', 'P'),
(179051, 'Salado', 34.4336090087891, 0.60097985054775, -109.410003662109, -1.90956479852286, 218, 5, 'PPL', 'P'),
(189407, 'Salado', 34.5877799987793, 0.603670641934139, -104.411109924316, -1.82231764384105, 218, 38, 'PPL', 'P'),
(97741, 'Salado Junction', 29.4502792358398, 0.514004338297125, -98.4175033569336, -1.71770947517106, 218, 51, 'PPL', 'P'),
(83442, 'Salak', 34.1580581665039, 0.596170581093231, -82.2072219848633, -1.43478669255373, 218, 48, 'PPL', 'P'),
(152313, 'Salamanca', 42.1577796936035, 0.735792060983788, -78.7152786254883, -1.37384078363949, 218, 40, 'PPL', 'P'),
(123613, 'Salamonia', 40.3819389343262, 0.704797792743282, -84.8652801513672, -1.48117855926875, 218, 19, 'PPL', 'P'),
(97753, 'Salas Colonia', 26.2859992980957, 0.458777234928688, -98.3089981079102, -1.71581570131991, 218, 51, 'PPL', 'P'),
(97742, 'Salazar Heights Colonia', 28.3850002288818, 0.495411712173332, -97.7900009155273, -1.70675749150422, 218, 51, 'PPL', 'P'),
(57380, 'Salcedo', 36.8888893127441, 0.643832575911134, -89.6833267211914, -1.5652693354266, 218, 29, 'PPL', 'P'),
(5623, 'Salco', 30.9666690826416, 0.540470333867628, -88.0347213745117, -1.53649574406106, 218, 2, 'PPL', 'P'),
(79082, 'Salco', 39.9008293151855, 0.696400845826262, -78.9408264160156, -1.37777733520479, 218, 45, 'PPL', 'P'),
(97743, 'Saldivar Colonia', 25.9109992980957, 0.45223225023371, -97.3889999389648, -1.69975870415949, 218, 51, 'PPL', 'P'),
(205654, 'Salduro', 40.7350006103516, 0.710959881452535, -113.855560302734, -1.98715439898567, 218, 52, 'PPL', 'P'),
(24632, 'Sale City', 31.2641696929932, 0.545662699044955, -84.0213928222656, -1.46644994686007, 218, 13, 'PPL', 'P'),
(90583, 'Sale Creek', 35.3822212219238, 0.617536256991582, -85.10888671875, -1.48543029594906, 218, 50, 'PPL', 'P'),
(5621, 'Salem', 34.9388885498047, 0.609798642181439, -87.1147232055664, -1.52043874690064, 218, 2, 'PPL', 'P'),
(11769, 'Salem', 34.6288909912109, 0.604388164110834, -92.5580596923828, -1.61544289088953, 218, 4, 'PPL', 'P'),
(17918, 'Salem', 29.8866691589355, 0.52162077927767, -83.4130630493164, -1.45583258938419, 218, 12, 'PPL', 'P'),
(24619, 'Salem', 32.7586097717285, 0.571745598892651, -84.1877822875977, -1.46935399087074, 218, 13, 'PPL', 'P'),
(33873, 'Salem', 39.8716697692871, 0.695891915741948, -98.4841690063477, -1.71887301025132, 218, 20, 'PPL', 'P'),
(38077, 'Salem', 37.811939239502, 0.65994283629335, -83.333610534668, -1.45444588140459, 218, 21, 'PPL', 'P'),
(51185, 'Salem', 38.5158309936523, 0.672228064980913, -75.9127807617188, -1.3249279686366, 218, 25, 'PPL', 'P'),
(61649, 'Salem', 31.2297191619873, 0.545061423849843, -90.1172180175781, -1.5728421671443, 218, 30, 'PPL', 'P'),
(68488, 'Salem', 36.5380592346191, 0.637709435932823, -80.6013870239258, -1.40675958524174, 218, 33, 'PPL', 'P'),
(71348, 'Salem', 39.5716705322266, 0.69065594130177, -75.4674987792969, -1.31715633194353, 218, 37, 'PPL', 'P'),
(77161, 'Salem', 35.3838882446289, 0.617565352026491, -95.9283294677734, -1.67426519515055, 218, 42, 'PPL', 'P'),
(83446, 'Salem', 34.889720916748, 0.608940505099188, -82.9766693115234, -1.44821608182462, 218, 48, 'PPL', 'P'),
(90589, 'Salem', 35.4361114501953, 0.618476818909571, -89.7363891601563, -1.56619544969568, 218, 50, 'PPL', 'P'),
(97750, 'Salem', 32.8252792358398, 0.572909200551934, -95.6186065673828, -1.6688595107699, 218, 51, 'PPL', 'P'),
(105997, 'Salem', 36.7894401550293, 0.642096860670674, -76.125, -1.32863189308068, 218, 53, 'PPL', 'P'),
(111261, 'Salem', 39.2827796936035, 0.685613844988951, -80.5591735839844, -1.40602282172617, 218, 58, 'PPL', 'P'),
(114016, 'Salem', 41.4902801513672, 0.724141996216209, -72.2758331298828, -1.26145125773845, 218, 8, 'PPL', 'P'),
(117664, 'Salem', 40.8527793884277, 0.713015508918939, -91.620002746582, -1.5990707086141, 218, 16, 'PPL', 'P'),
(121348, 'Salem', 42.3444404602051, 0.739049905945282, -89.7788925170898, -1.56693727321732, 218, 18, 'PPL', 'P'),
(123616, 'Salem', 40.3102798461914, 0.703547105716353, -84.8433303833008, -1.48079546354594, 218, 19, 'PPL', 'P'),
(126012, 'Salem', 42.5194396972656, 0.742104218820466, -70.897216796875, -1.2373898636057, 218, 23, 'PPL', 'P'),
(128730, 'Salem', 44.9005584716797, 0.783662581315044, -70.2786102294922, -1.22659314223041, 218, 26, 'PPL', 'P'),
(132979, 'Salem', 42.4061088562012, 0.740126222499837, -83.5800018310547, -1.45874622077479, 218, 27, 'PPL', 'P'),
(139434, 'Salem', 40.0288887023926, 0.698635903771111, -91.9141693115234, -1.60420488372161, 218, 29, 'PPL', 'P'),
(142936, 'Salem', 40.0755615234375, 0.699450498169539, -95.7205581665039, -1.67063890185224, 218, 35, 'PPL', 'P'),
(144404, 'Salem', 42.788330078125, 0.746797241293404, -71.2013931274414, -1.24269874208072, 218, 36, 'PPL', 'P'),
(152316, 'Salem', 43.1722183227539, 0.75349735512188, -73.3280563354492, -1.27981601714148, 218, 40, 'PPL', 'P'),
(157506, 'Salem', 40.9008293151855, 0.713854138346205, -80.8569412231445, -1.4112198474354, 218, 41, 'PPL', 'P'),
(166819, 'Salem', 40.8122215270996, 0.712307640701196, -76.9013900756836, -1.34218245618117, 218, 45, 'PPL', 'P'),
(171251, 'Salem', 43.7241706848145, 0.763130741153996, -97.3886108398438, -1.69975191309871, 218, 49, 'PPL', 'P'),
(176250, 'Salem', 44.6230583190918, 0.778819289977598, -92.3572235107422, -1.61193763826277, 218, 57, 'PPL', 'P'),
(189408, 'Salem', 32.7075004577637, 0.570853573085529, -107.212501525879, -1.87121115092603, 218, 38, 'PPL', 'P'),
(193235, 'Salem', 40.0530586242676, 0.69905774848778, -111.672782897949, -1.94905774643403, 218, 52, 'PPL', 'P'),
(195576, 'Salem', 43.8766708374023, 0.765792370926448, -111.772216796875, -1.95079319535838, 218, 17, 'PPL', 'P'),
(197468, 'Salem', 47.5372200012207, 0.829681006266204, -111.039436340332, -1.93800376369744, 218, 31, 'PPL', 'P'),
(201525, 'Salem', 44.9430618286133, 0.784404404836685, -123.033889770508, -2.14734646803113, 218, 43, 'PPL', 'P'),
(11770, 'Salem (historical)', 35.0786094665527, 0.612237232212597, -92.5111083984375, -1.61462343622211, 218, 4, 'PPL', 'P'),
(24621, 'Salem (historical)', 34.7658309936523, 0.606778218031125, -85.2600021362305, -1.48806775753462, 218, 13, 'PPL', 'P'),
(61650, 'Salem (historical)', 33.9297218322754, 0.592185360259009, -88.897216796875, -1.55154912896468, 218, 30, 'PPL', 'P'),
(449, 'Salem Branch', 33.5722198486328, 0.585945773562035, -83.9850006103516, -1.46581478294008, 218, 13, 'PPL', 'P'),
(74183, 'Salem Center', 39.0527801513672, 0.681599595698847, -82.2738876342773, -1.43595022763399, 218, 41, 'PPL', 'P'),
(123617, 'Salem Center', 41.5849990844727, 0.725795153462875, -85.1397171020508, -1.48596838764731, 218, 19, 'PPL', 'P'),
(152317, 'Salem Center', 41.3291702270508, 0.721330097579249, -73.5986099243164, -1.2845380680703, 218, 40, 'PPL', 'P'),
(139435, 'Salem Coffey P O and Station', 40.1047210693359, 0.699959428253853, -94.0063934326172, -1.64072108332434, 218, 29, 'PPL', 'P'),
(5622, 'Salem Corner', 34.7008285522461, 0.605643711406751, -86.8783264160156, -1.51631284458184, 218, 2, 'PPL', 'P'),
(152318, 'Salem Corner', 42.9544410705566, 0.749696425035091, -75.9580612182617, -1.32571826169008, 218, 40, 'PPL', 'P'),
(137966, 'Salem Corners', 43.9858283996582, 0.767697529791264, -92.607780456543, -1.61631068193073, 218, 28, 'PPL', 'P'),
(24623, 'Salem Cove', 33.6036109924316, 0.586493652377291, -83.9716720581055, -1.46558215581886, 218, 13, 'PPL', 'P'),
(83452, 'Salem Crossroads', 33.9544410705566, 0.592616792355602, -79.1277770996094, -1.38104024017235, 218, 48, 'PPL', 'P'),
(144405, 'Salem Depot', 42.7866706848145, 0.746768279416549, -71.226936340332, -1.24314455524719, 218, 36, 'PPL', 'P'),
(83448, 'Salem Estates', 34.899169921875, 0.609105421349691, -81.9747161865234, -1.43072870084272, 218, 48, 'PPL', 'P'),
(105998, 'Salem Heights', 37.2911109924316, 0.650852668544582, -80.0608291625977, -1.39732507076402, 218, 53, 'PPL', 'P'),
(123618, 'Salem Heights', 41.5747184753418, 0.725615722984431, -86.621940612793, -1.51183806816023, 218, 19, 'PPL', 'P'),
(157507, 'Salem Heights', 40.9008293151855, 0.713854138346205, -80.89111328125, -1.41181626236153, 218, 41, 'PPL', 'P'),
(146255, 'Salem Hill', 40.1583290100098, 0.700895063323825, -74.2122192382813, -1.29524757091989, 218, 37, 'PPL', 'P'),
(24624, 'Salem Meadows', 33.577220916748, 0.586033058666762, -83.970832824707, -1.46556750843287, 218, 13, 'PPL', 'P'),
(126013, 'Salem Neck', 42.5333290100098, 0.742346633058691, -70.8680572509766, -1.23688093352138, 218, 23, 'PPL', 'P'),
(176251, 'Salem Oaks', 42.5586090087891, 0.742787852272289, -88.0922164916992, -1.5374992231598, 218, 57, 'PPL', 'P'),
(24625, 'Salem Place', 33.6049995422363, 0.586517887143211, -83.9716720581055, -1.46558215581886, 218, 13, 'PPL', 'P'),
(83449, 'Salem Plantation', 32.4236106872559, 0.565898761877436, -80.7061080932617, -1.40858731269786, 218, 48, 'PPL', 'P'),
(24626, 'Salem Ridge', 33.5683288574219, 0.585877862954238, -83.977783203125, -1.46568881542052, 218, 13, 'PPL', 'P'),
(201523, 'Salem Station (historical)', 44.9394416809082, 0.784341221339823, -123.041389465332, -2.14747736239871, 218, 43, 'PPL', 'P'),
(14544, 'Salem Village', 39.6666717529297, 0.692314025396454, -75.7005615234375, -1.32122404419252, 218, 10, 'PPL', 'P'),
(24627, 'Salem Village', 33.601390838623, 0.586454903383431, -83.9747161865234, -1.46563528588261, 218, 13, 'PPL', 'P'),
(106001, 'Salem Village Trailer Park', 37.2797203063965, 0.650653863569208, -80.0286102294922, -1.39676274429985, 218, 53, 'PPL', 'P'),
(24628, 'Salem West', 33.6847190856934, 0.587909255654723, -84.1933288574219, -1.46945079677637, 218, 13, 'PPL', 'P'),
(14545, 'Salem Woods', 39.6444396972656, 0.691926002825629, -75.6972198486328, -1.32116572096465, 218, 10, 'PPL', 'P'),
(24630, 'Salem Woods', 33.9361114501953, 0.592296880129656, -84.4847183227539, -1.47453650235204, 218, 13, 'PPL', 'P'),
(106002, 'Salem Woods', 37.3802795410156, 0.652408953306597, -77.478889465332, -1.35226172195879, 218, 53, 'PPL', 'P'),
(68494, 'Salemburg', 35.0152816772461, 0.611131953781187, -78.5033264160156, -1.37014151972731, 218, 33, 'PPL', 'P'),
(68495, 'Salemfork', 36.3944396972656, 0.635202802135813, -80.7872161865234, -1.41000291597529, 218, 33, 'PPL', 'P'),
(33878, 'Salemsborg', 38.6952781677246, 0.675360009001873, -97.6858291625977, -1.70493935142802, 218, 20, 'PPL', 'P'),
(201524, 'Salemtowne', 44.9777793884277, 0.785010340563706, -123.072219848633, -2.14801545409696, 218, 43, 'PPL', 'P'),
(166825, 'Salemville', 40.1483306884766, 0.700720559693398, -78.4330596923828, -1.36891513404533, 218, 45, 'PPL', 'P'),
(106005, 'Sales Corner', 38.1827812194824, 0.666415249848624, -77.304443359375, -1.34921706304256, 218, 53, 'PPL', 'P'),
(68498, 'Sales Ford', 35.127498626709, 0.613090509025858, -83.98388671875, -1.46579534186412, 218, 33, 'PPL', 'P'),
(209717, 'Sales Place', 44.189998626709, 0.771260972487844, -108.53556060791, -1.89430288810589, 218, 59, 'PPL', 'P'),
(74190, 'Salesville', 39.973331451416, 0.697666246818213, -81.3369369506836, -1.41959735327647, 218, 41, 'PPL', 'P'),
(97751, 'Salesville', 32.9122200012207, 0.574426603162033, -98.0877838134766, -1.71195478352957, 218, 51, 'PPL', 'P'),
(166826, 'Salford', 40.2958297729492, 0.703294904361123, -75.454719543457, -1.31693329220224, 218, 45, 'PPL', 'P'),
(166828, 'Salfordville', 40.2933311462402, 0.703251295098273, -75.4333267211914, -1.31655991701741, 218, 45, 'PPL', 'P'),
(137969, 'Salida', 45.3566703796387, 0.791623235866481, -93.8191680908203, -1.63745338466682, 218, 28, 'PPL', 'P'),
(166829, 'Salida', 40.3452796936035, 0.70415796829139, -80.0102767944336, -1.39644276549488, 218, 45, 'PPL', 'P'),
(177397, 'Salida', 41.702220916748, 0.727841060391301, -81.3594436645508, -1.41999016953725, 218, 41, 'PPL', 'P'),
(184737, 'Salida', 37.7058296203613, 0.658090874071309, -121.083892822266, -2.11331260088046, 218, 6, 'PPL', 'P'),
(187308, 'Salida', 38.5347213745117, 0.672557764323864, -105.998329162598, -1.85001984550005, 218, 7, 'PPL', 'P'),
(157517, 'Salida Beach', 41.7075004577637, 0.727933205765018, -81.3680572509766, -1.42014050498079, 218, 41, 'PPL', 'P'),
(97752, 'Salida del Sol Estates Colonia', 26.3239994049072, 0.459440461908659, -98.4400024414063, -1.7181021582738, 218, 51, 'PPL', 'P'),
(31053, 'Salina', 38.1527786254883, 0.665891605799287, -85.9100036621094, -1.49941242430419, 218, 19, 'PPL', 'P'),
(33879, 'Salina', 38.8402786254883, 0.677890744406748, -97.6111068725586, -1.70363520144221, 218, 20, 'PPL', 'P'),
(71352, 'Salina', 39.7730598449707, 0.694170847887484, -75.1244430541992, -1.31116888002276, 218, 37, 'PPL', 'P'),
(77162, 'Salina', 36.292781829834, 0.633428537638575, -95.1530609130859, -1.66073420628407, 218, 42, 'PPL', 'P'),
(113342, 'Salina', 40.521671295166, 0.707236582511522, -79.4983291625977, -1.38750759372156, 218, 45, 'PPL', 'P'),
(117666, 'Salina', 41.0458297729492, 0.71638487375108, -91.8330612182617, -1.60278928044418, 218, 16, 'PPL', 'P'),
(121351, 'Salina', 42.0469398498535, 0.733857540767954, -88.4947204589844, -1.54452424264126, 218, 18, 'PPL', 'P'),
(177640, 'Salina', 36.0222206115723, 0.628706353551701, -109.866668701172, -1.91753510703325, 218, 5, 'PPL', 'P'),
(192767, 'Salina', 38.9577789306641, 0.679941511604164, -111.859169006348, -1.95231079770556, 218, 52, 'PPL', 'P'),
(194412, 'Salina', 40.0505599975586, 0.69901413922493, -105.371940612793, -1.83908730290917, 218, 7, 'PPL', 'P'),
(184738, 'Salinas', 36.6777801513672, 0.640148025963982, -121.654441833496, -2.12327055967043, 218, 6, 'PPL', 'P'),
(189409, 'Salinas', 33.2350006103516, 0.58006018755296, -106.059722900391, -1.85109136836465, 218, 38, 'PPL', 'P'),
(97757, 'Salinas Colonia', 27.886999130249, 0.48671995332364, -98.0910034179688, -1.71201097622857, 218, 51, 'PPL', 'P'),
(97755, 'Salinas-Hinojosa Colonia', 26.298999786377, 0.459004136253563, -97.9860000610352, -1.71017832192443, 218, 51, 'PPL', 'P'),
(11776, 'Saline', 33.8733291625977, 0.591201122499143, -92.2669372558594, -1.61036184584577, 218, 4, 'PPL', 'P'),
(28518, 'Saline', 37.6452789306641, 0.657034065171738, -88.6958312988281, -1.54803428895799, 218, 18, 'PPL', 'P'),
(42953, 'Saline', 32.1644401550293, 0.561375382765937, -92.9741668701172, -1.62270533118218, 218, 22, 'PPL', 'P'),
(97756, 'Saline', 30.7222194671631, 0.536203883222294, -99.5530624389648, -1.73752872000343, 218, 51, 'PPL', 'P'),
(132982, 'Saline', 42.1666717529297, 0.735947256696312, -83.7816696166992, -1.4622659876295, 218, 27, 'PPL', 'P'),
(139437, 'Saline', 40.5269393920898, 0.707328528148157, -93.727783203125, -1.63585841748997, 218, 29, 'PPL', 'P'),
(205656, 'Saline', 41.214168548584, 0.719322939644683, -112.471939086914, -1.96300565316916, 218, 52, 'PPL', 'P'),
(11775, 'Saline (historical)', 34.3347206115723, 0.599253922424297, -94.0244369506836, -1.64103600212325, 218, 4, 'PPL', 'P'),
(28519, 'Saline City', 37.8236083984375, 0.660146501537714, -88.4355621337891, -1.54349173508664, 218, 18, 'PPL', 'P'),
(31054, 'Saline City', 39.3652801513672, 0.687053749611329, -87.1322174072266, -1.52074407831962, 218, 19, 'PPL', 'P'),
(57384, 'Saline City', 39.1402816772461, 0.683126785425953, -92.9430618286133, -1.62216244579396, 218, 29, 'PPL', 'P'),
(57386, 'Saline Junction', 37.788890838623, 0.659540565810693, -89.8866729736328, -1.56881839705329, 218, 29, 'PPL', 'P'),
(28521, 'Saline Landing', 37.5699996948242, 0.655720194647947, -88.1302795410156, -1.53816354869372, 218, 18, 'PPL', 'P'),
(11778, 'Saline River (historical)', 34.1208305358887, 0.595520836366279, -92.4055633544922, -1.6127813276961, 218, 4, 'PPL', 'P'),
(28522, 'Saline Valley Store (historical)', 37.6733283996582, 0.657523620759122, -88.498893737793, -1.54459708009708, 218, 18, 'PPL', 'P'),
(97758, 'Salineno', 26.5161094665527, 0.462793415010582, -99.1119384765625, -1.72982965445007, 218, 51, 'PPL', 'P'),
(157519, 'Salineville', 40.622501373291, 0.708996399359846, -80.8380584716797, -1.41089028125051, 218, 41, 'PPL', 'P'),
(57392, 'Saling', 39.3133316040039, 0.686147076418212, -92.158332824707, -1.6084663409399, 218, 29, 'PPL', 'P'),
(28524, 'Salisbury', 39.889720916748, 0.696206967698904, -89.7980575561523, -1.56727176625023, 218, 18, 'PPL', 'P'),
(51186, 'Salisbury', 38.3605613708496, 0.669518098834675, -75.5997161865234, -1.31946396102809, 218, 25, 'PPL', 'P'),
(57393, 'Salisbury', 39.4238891601563, 0.688076669786029, -92.8013916015625, -1.61968983387988, 218, 29, 'PPL', 'P'),
(68496, 'Salisbury', 35.6708297729492, 0.622573426456385, -80.4744415283203, -1.40454396837285, 218, 33, 'PPL', 'P'),
(79084, 'Salisbury', 39.7527809143066, 0.693816913778613, -79.0811080932617, -1.38022571235295, 218, 45, 'PPL', 'P'),
(106004, 'Salisbury', 37.6074981689453, 0.656374666485834, -79.7825012207031, -1.39246733177766, 218, 53, 'PPL', 'P'),
(114018, 'Salisbury', 41.9833297729492, 0.732747335488527, -73.4216690063477, -1.28144986647024, 218, 8, 'PPL', 'P'),
(126016, 'Salisbury', 42.8416709899902, 0.747728215831468, -70.8611068725586, -1.23675962653373, 218, 23, 'PPL', 'P'),
(132985, 'Salisbury', 46.4749984741211, 0.811141743232754, -87.6769409179688, -1.53025129709509, 218, 27, 'PPL', 'P'),
(144407, 'Salisbury', 43.3800010681152, 0.757123848157268, -71.7174987792969, -1.25170648499374, 218, 36, 'PPL', 'P'),
(152322, 'Salisbury', 40.7455596923828, 0.711144172199968, -73.5605621337891, -1.28387400885248, 218, 40, 'PPL', 'P'),
(172493, 'Salisbury', 43.8963890075684, 0.766136517918314, -73.1002807617188, -1.27584058342426, 218, 55, 'PPL', 'P'),
(83450, 'Salisbury Acres', 32.9874992370605, 0.575740473685824, -80.195556640625, -1.39967650884851, 218, 48, 'PPL', 'P'),
(126015, 'Salisbury Beach', 42.8430595397949, 0.747752450597388, -70.8180618286133, -1.23600834879022, 218, 23, 'PPL', 'P'),
(152323, 'Salisbury Center', 43.1425018310547, 0.752978704499587, -74.7869415283203, -1.30527836716567, 218, 40, 'PPL', 'P'),
(126017, 'Salisbury Heights', 42.2938919067383, 0.738167667255165, -71.845832824707, -1.25394633662856, 218, 23, 'PPL', 'P'),
(144408, 'Salisbury Heights', 43.3911094665527, 0.757317726284626, -71.7447204589844, -1.25218159293221, 218, 36, 'PPL', 'P'),
(166830, 'Salisbury Heights', 40.0338897705078, 0.698723188875838, -76.0113906860352, -1.32664903649106, 218, 45, 'PPL', 'P'),
(79085, 'Salisbury Junction', 39.8255615234375, 0.695087175039553, -79.0327835083008, -1.37938228923572, 218, 45, 'PPL', 'P'),
(152324, 'Salisbury Mills', 41.4305610656738, 0.723099701544579, -74.1194381713867, -1.29362823581906, 218, 40, 'PPL', 'P'),
(126020, 'Salisbury Plains', 42.8694381713867, 0.748212844570835, -70.8833312988281, -1.2371475159465, 218, 23, 'PPL', 'P'),
(126018, 'Salisbury Point', 42.8416709899902, 0.747728215831468, -70.9124984741211, -1.23765657918887, 218, 23, 'PPL', 'P'),
(172494, 'Salisbury Station', 43.9180603027344, 0.766514753372132, -73.1613922119141, -1.27690717944084, 218, 55, 'PPL', 'P'),
(201526, 'Salishan', 44.8916702270508, 0.783507452181546, -124.032501220703, -2.16477552578516, 218, 43, 'PPL', 'P'),
(208652, 'Salishan', 47.2174987792969, 0.824100818255134, -122.406112670898, -2.13638969067433, 218, 56, 'PPL', 'P'),
(201527, 'Salishan Beach', 44.9166717529297, 0.783943811126156, -124.027778625488, -2.16469310094942, 218, 43, 'PPL', 'P'),
(5624, 'Salitpa', 31.6294403076172, 0.552037873930928, -88.0199966430664, -1.53623874901586, 218, 2, 'PPL', 'P'),
(189410, 'Salitre', 35.3499984741211, 0.616973863948385, -104.66667175293, -1.82677803919277, 218, 38, 'PPL', 'P'),
(42954, 'Salix', 29.9261093139648, 0.522309139840428, -90.3091735839844, -1.57619242379562, 218, 22, 'PPL', 'P'),
(117667, 'Salix', 42.3083305358887, 0.738419668873314, -96.2874984741211, -1.68053387688243, 218, 16, 'PPL', 'P'),
(166832, 'Salix', 40.2999992370605, 0.703367675237909, -78.7655563354492, -1.37471829521867, 218, 45, 'PPL', 'P'),
(83451, 'Salkehatchie', 32.7061080932617, 0.570829271740582, -80.8133316040039, -1.41045871599586, 218, 48, 'PPL', 'P'),
(208653, 'Salkum', 46.5322189331055, 0.812140428641533, -122.624717712402, -2.14020506841003, 218, 56, 'PPL', 'P'),
(166833, 'Salladasburg', 41.2772216796875, 0.720423424386131, -77.2261123657227, -1.34784992929697, 218, 45, 'PPL', 'P'),
(24631, 'Sallee Heights', 34.2305603027344, 0.597435982085182, -83.920280456543, -1.46468520316373, 218, 13, 'PPL', 'P'),
(38078, 'Salleetown', 37.4563903808594, 0.653737338058329, -85.2111129760742, -1.48721448072136, 218, 21, 'PPL', 'P'),
(83453, 'Salley', 33.565559387207, 0.585829526580453, -81.3036117553711, -1.41901571889439, 218, 48, 'PPL', 'P'),
(61651, 'Sallis', 33.0222206115723, 0.576346475991872, -89.7652816772461, -1.56669971924808, 218, 30, 'PPL', 'P'),
(77165, 'Sallisaw', 35.4602813720703, 0.618898663626239, -94.7872161865234, -1.6543490112545, 218, 42, 'PPL', 'P'),
(166835, 'Sally Ann', 40.4722213745117, 0.706373518581255, -75.726936340332, -1.32168437158694, 218, 45, 'PPL', 'P'),
(71353, 'Sally Marshall Crossing', 39.0013885498047, 0.680702643043708, -74.892219543457, -1.30711581515977, 218, 37, 'PPL', 'P'),
(33882, 'Sallyards', 37.8213882446289, 0.660107752543853, -96.5069427490234, -1.68436390200413, 218, 20, 'PPL', 'P'),
(184739, 'Salminas Resort', 38.8758316040039, 0.678511260940737, -122.727500915527, -2.14199897372031, 218, 6, 'PPL', 'P'),
(176254, 'Salmo', 46.7813911437988, 0.816489304122606, -90.8649978637695, -1.58589338754039, 218, 57, 'PPL', 'P'),
(97759, 'Salmon', 31.5727806091309, 0.551048975639154, -95.4980621337891, -1.66675561350874, 218, 51, 'PPL', 'P'),
(195577, 'Salmon', 45.1758308410645, 0.788466990500574, -113.894996643066, -1.9878426929694, 218, 17, 'PPL', 'P'),
(114020, 'Salmon Brook', 41.9563903808594, 0.732277154398074, -72.7958297729492, -1.27052691125928, 218, 8, 'PPL', 'P'),
(97760, 'Salmon Colonia', 26.3950004577637, 0.460679664053387, -98.8430023193359, -1.7251358330288, 218, 51, 'PPL', 'P'),
(184740, 'Salmon Creek', 38.3505592346191, 0.669343528625221, -123.061111450195, -2.1478215759696, 218, 6, 'PPL', 'P'),
(208654, 'Salmon Creek', 45.7108306884766, 0.797804499335582, -122.64778137207, -2.1406076052088, 218, 56, 'PPL', 'P'),
(128731, 'Salmon Falls', 43.5961112976074, 0.760895683209147, -70.5541687011719, -1.23140254484298, 218, 26, 'PPL', 'P'),
(184741, 'Salmon Falls (historical)', 38.7580604553223, 0.676455766632386, -121.057220458984, -2.11284708032192, 218, 6, 'PPL', 'P'),
(197469, 'Salmon Prairie', 47.6300010681152, 0.831300341367027, -113.784439086914, -1.98591309960158, 218, 31, 'PPL', 'P'),
(132986, 'Salmon Trout', 47.1105613708496, 0.822234408384179, -88.7402801513672, -1.54881006778353, 218, 27, 'PPL', 'P'),
(38079, 'Salmons', 36.7783317565918, 0.641902982543317, -86.5630569458008, -1.51081035429557, 218, 21, 'PPL', 'P'),
(137970, 'Salo Corner', 47.6611099243164, 0.831843293334267, -92.2777786254883, -1.61055106344122, 218, 28, 'PPL', 'P'),
(137972, 'Salol', 48.8661117553711, 0.852874542778731, -95.570556640625, -1.66802088134264, 218, 28, 'PPL', 'P'),
(38080, 'Saloma', 37.4119415283203, 0.652961559232789, -85.3927764892578, -1.49038510715715, 218, 21, 'PPL', 'P'),
(179052, 'Salome', 33.7811088562012, 0.589591574515326, -113.613891601563, -1.9829364844512, 218, 5, 'PPL', 'P'),
(97761, 'Salona', 33.5472183227539, 0.585509414617425, -97.7474975585938, -1.70601566798258, 218, 51, 'PPL', 'P'),
(166836, 'Salona', 41.084171295166, 0.71705405955399, -77.4633331298828, -1.35199021268566, 218, 45, 'PPL', 'P'),
(176255, 'Salona', 44.7455596923828, 0.780957342279741, -87.3563919067383, -1.52465666143511, 218, 57, 'PPL', 'P'),
(106006, 'Salona Village', 38.9391708374023, 0.679616739109228, -77.1688919067383, -1.34685124388819, 218, 53, 'PPL', 'P'),
(51187, 'Salopha', 39.3527793884277, 0.686835570139025, -76.9458312988281, -1.34295810184866, 218, 25, 'PPL', 'P'),
(157520, 'Salow Corners', 41.2136116027832, 0.719313219106704, -80.5488891601563, -1.4058433246687, 218, 41, 'PPL', 'P'),
(42957, 'Salsburg', 30.0913906097412, 0.525193842643688, -90.9158325195313, -1.58678061965755, 218, 22, 'PPL', 'P'),
(184742, 'Salsbury (historical)', 38.6144409179688, 0.673949132835376, -121.251388549805, -2.11623595280904, 218, 6, 'PPL', 'P'),
(128732, 'Salsbury Cove', 44.4305610656738, 0.775459579104409, -68.2841720581055, -1.19178362941225, 218, 26, 'PPL', 'P'),
(42956, 'Salt (historical)', 31.8436107635498, 0.55577585354745, -92.4000015258789, -1.61268425547437, 218, 22, 'PPL', 'P'),
(193301, 'Salt Chuck', 55.6263885498047, 0.970863631187766, -132.553604125977, -2.31349682738343, 218, 1, 'PPL', 'P'),
(83454, 'Salt Creek', 32.4491691589355, 0.566344841360025, -80.7291717529297, -1.40898984949663, 218, 48, 'PPL', 'P'),
(106007, 'Salt Creek', 37.5066719055176, 0.654614916216537, -79.2213897705078, -1.38267408950112, 218, 53, 'PPL', 'P'),
(187309, 'Salt Creek', 38.2416687011719, 0.667443030292313, -104.574996948242, -1.82517801200985, 218, 7, 'PPL', 'P'),
(197470, 'Salt Creek (historical)', 47.4519386291504, 0.828192565532959, -109.47917175293, -1.910772009445, 218, 31, 'PPL', 'P'),
(209718, 'Salt Creek (historical)', 43.3488883972168, 0.756580829611001, -106.32527923584, -1.85572620076777, 218, 59, 'PPL', 'P'),
(192154, 'Salt Flat', 31.7436103820801, 0.554030517637553, -105.092216491699, -1.83420519599884, 218, 51, 'PPL', 'P'),
(77169, 'Salt Fork', 36.6349983215332, 0.639401342173351, -97.5886077880859, -1.70324251833948, 218, 42, 'PPL', 'P'),
(97762, 'Salt Gap', 31.3036098480225, 0.546351059607714, -99.5988922119141, -1.73832860043684, 218, 51, 'PPL', 'P'),
(51188, 'Salt Grass Cove', 38.3694381713867, 0.669673028231091, -75.1399993896484, -1.31144038929589, 218, 25, 'PPL', 'P'),
(111262, 'Salt Hill', 38.7775001525879, 0.676795053355262, -81.6852798461914, -1.42567708372901, 218, 58, 'PPL', 'P'),
(189411, 'Salt Lake', 34.4533309936523, 0.601324064118643, -108.769172668457, -1.8983801877348, 218, 38, 'PPL', 'P'),
(205657, 'Salt Lake City', 40.7608299255371, 0.711410688046058, -111.890281677246, -1.95285381625183, 218, 52, 'PPL', 'P'),
(205660, 'Salt Lake View Addition', 40.6344413757324, 0.709204791715145, -112.060279846191, -1.95582084402228, 218, 52, 'PPL', 'P'),
(38081, 'Salt Lick', 38.1199989318848, 0.665319492218111, -83.6147232055664, -1.45935222308084, 218, 21, 'PPL', 'P'),
(90590, 'Salt Lick', 35.9261093139648, 0.627028894960088, -87.5497207641602, -1.52803088653624, 218, 50, 'PPL', 'P'),
(111263, 'Salt Lick', 39.392219543457, 0.687523930701783, -79.5972213745117, -1.38923358842404, 218, 58, 'PPL', 'P'),
(83455, 'Salt Marsh Cove', 33.4680595397949, 0.58412783322292, -79.1052780151367, -1.38064755706962, 218, 48, 'PPL', 'P'),
(152329, 'Salt Point', 41.8066711425781, 0.729664060736488, -73.7936096191406, -1.28794145478536, 218, 40, 'PPL', 'P'),
(38082, 'Salt River', 37.9791717529297, 0.662861594269049, -85.7125015258789, -1.49596536174725, 218, 21, 'PPL', 'P'),
(57406, 'Salt River', 39.5827789306641, 0.690849819429128, -91.3052825927734, -1.59357780570776, 218, 29, 'PPL', 'P'),
(179053, 'Salt River', 33.4666709899902, 0.584103598457, -111.863327026367, -1.95238336884527, 218, 5, 'PPL', 'P'),
(111265, 'Salt Rock', 38.3230590820313, 0.668863560417761, -82.2211074829102, -1.43502904021293, 218, 58, 'PPL', 'P'),
(157524, 'Salt Run', 40.2491683959961, 0.702480509699777, -80.663330078125, -1.40784069548626, 218, 41, 'PPL', 'P'),
(17919, 'Salt Springs', 29.350830078125, 0.512268623056666, -81.7352828979492, -1.42654980161823, 218, 12, 'PPL', 'P'),
(57404, 'Salt Springs', 39.1122207641602, 0.682637030101487, -93.3472213745117, -1.62921636057326, 218, 29, 'PPL', 'P'),
(152326, 'Salt Springville', 42.8591690063477, 0.748033613829473, -74.7461090087891, -1.30456570525796, 218, 40, 'PPL', 'P'),
(111264, 'Salt Sulphur Springs', 37.5702781677246, 0.655725054916937, -80.5583267211914, -1.40600804118212, 218, 58, 'PPL', 'P'),
(5626, 'Salt Well', 32.4569396972656, 0.566480462838537, -87.9311065673828, -1.53468732452284, 218, 2, 'PPL', 'P'),
(190702, 'Salt Wells', 39.3752784729004, 0.687228253241757, -118.581939697266, -2.06964528111865, 218, 39, 'PPL', 'P'),
(209719, 'Salt Wells', 41.6547203063965, 0.72701201834396, -108.985282897949, -1.90215202278668, 218, 59, 'PPL', 'P'),
(74196, 'Saltair', 38.9263916015625, 0.679393699367934, -84.142219543457, -1.46855877096925, 218, 41, 'PPL', 'P'),
(201528, 'Saltair (historical)', 45.6044387817383, 0.795947610265525, -123.944442749023, -2.16323861552007, 218, 43, 'PPL', 'P'),
(68499, 'Saltaire', 36.1688919067383, 0.631266250570513, -75.753059387207, -1.32214030476556, 218, 33, 'PPL', 'P'),
(152327, 'Saltaire', 40.6361083984375, 0.709233886750054, -73.1972198486328, -1.27753248966479, 218, 40, 'PPL', 'P'),
(184744, 'Saltdale', 35.3591690063477, 0.617133919929898, -117.886672973633, -2.05751058761171, 218, 6, 'PPL', 'P'),
(5625, 'Salter', 31.5463905334473, 0.550588381928625, -86.7819366455078, -1.51463052572123, 218, 2, 'PPL', 'P'),
(24633, 'Salter', 31.1452808380127, 0.54358769708162, -81.7908325195313, -1.42751932541307, 218, 13, 'PPL', 'P'),
(33888, 'Salter', 37.6138916015625, 0.656486252935509, -97.0444412231445, -1.69374502010199, 218, 20, 'PPL', 'P'),
(97763, 'Salter', 31.0344390869141, 0.541653143576273, -96.745002746582, -1.68851883277881, 218, 51, 'PPL', 'P'),
(166837, 'Salter', 40.2750015258789, 0.702931382872327, -78.1336135864258, -1.36368881356411, 218, 45, 'PPL', 'P'),
(68500, 'Salter Path', 34.6883316040039, 0.605425598513474, -76.8863906860352, -1.34192066744602, 218, 33, 'PPL', 'P'),
(83456, 'Salters', 33.598331451416, 0.586401507003575, -79.8516693115234, -1.3936745426998, 218, 48, 'PPL', 'P'),
(83457, 'Salters Depot', 33.5958290100098, 0.586357831161697, -79.8533325195313, -1.39370357115568, 218, 48, 'PPL', 'P'),
(197471, 'Saltese', 47.4102783203125, 0.82746545597634, -115.508613586426, -2.01600562149699, 218, 31, 'PPL', 'P'),
(11788, 'Saltillo', 35.0275001525879, 0.611345206405475, -92.3263931274414, -1.61139954656452, 218, 4, 'PPL', 'P'),
(31059, 'Saltillo', 38.6650009155273, 0.674831571262574, -86.2891693115234, -1.50603011329693, 218, 19, 'PPL', 'P'),
(61652, 'Saltillo', 34.3763885498047, 0.59998116513897, -88.6816711425781, -1.54778714760883, 218, 30, 'PPL', 'P'),
(90591, 'Saltillo', 35.3777809143066, 0.617458759003861, -88.2094421386719, -1.53954519666725, 218, 50, 'PPL', 'P'),
(97764, 'Saltillo', 33.184440612793, 0.579177749125762, -95.3261108398438, -1.66375449727633, 218, 51, 'PPL', 'P'),
(113163, 'Saltillo', 40.7000007629395, 0.710349018877498, -96.6822204589844, -1.6874230751483, 218, 35, 'PPL', 'P'),
(157526, 'Saltillo', 40.5208282470703, 0.707221868546499, -81.8477783203125, -1.42851321713189, 218, 41, 'PPL', 'P'),
(166838, 'Saltillo', 40.2105598449707, 0.701806663364959, -78.0069427490234, -1.36147799038518, 218, 45, 'PPL', 'P'),
(192155, 'Saltlick Mill', 30.7413902282715, 0.536538476123749, -103.627777099609, -1.80864590691096, 218, 51, 'PPL', 'P'),
(184745, 'Salton', 33.4738883972168, 0.584229565976561, -115.883888244629, -2.02255539988193, 218, 6, 'PPL', 'P'),
(184746, 'Salton City', 33.2986106872559, 0.581170392832387, -115.955276489258, -2.02380135979792, 218, 6, 'PPL', 'P'),
(184747, 'Salton Sea Beach', 33.375, 0.582503637853107, -116.011108398438, -2.02477581044078, 218, 6, 'PPL', 'P'),
(111266, 'Saltpetre', 38.0819396972656, 0.664655233263218, -82.5475006103516, -1.44072567494266, 218, 58, 'PPL', 'P'),
(166841, 'Saltsburg', 40.4863891601563, 0.706620793088468, -79.4516677856445, -1.38669319906021, 218, 45, 'PPL', 'P'),
(184749, 'Saltus', 34.5377807617188, 0.602797990623947, -115.689170837402, -2.01915694001488, 218, 6, 'PPL', 'P'),
(113204, 'Saltvale', 42.7838897705078, 0.746719743305682, -78.1100006103516, -1.36327668938542, 218, 40, 'PPL', 'P'),
(106013, 'Saltville', 36.8813896179199, 0.643701681543556, -81.7622222900391, -1.42701998270868, 218, 53, 'PPL', 'P'),
(111267, 'Saltwell', 39.3638916015625, 0.68702951484541, -80.2713928222656, -1.40100009991028, 218, 58, 'PPL', 'P'),
(51189, 'Saltworks on the Severn', 39.0052795410156, 0.680770553651505, -76.5458297729492, -1.33597675820907, 218, 25, 'PPL', 'P'),
(97765, 'Salty', 30.5933303833008, 0.533954344339017, -97.1324996948242, -1.69528193036707, 218, 51, 'PPL', 'P'),
(195578, 'Salubria', 44.5636100769043, 0.777781722416903, -116.665283203125, -2.03619331466617, 218, 17, 'PPL', 'P'),
(24634, 'Salubrity (historical)', 34.4222183227539, 0.600781045572376, -83.2186126708984, -1.45243879004905, 218, 13, 'PPL', 'P'),
(83458, 'Saluca', 34.2341690063477, 0.597498965844962, -82.0619430541992, -1.43225109687987, 218, 48, 'PPL', 'P'),
(31060, 'Saluda', 38.6505584716797, 0.674579503065398, -85.4850006103516, -1.49199472172, 218, 19, 'PPL', 'P'),
(68503, 'Saluda', 35.2361106872559, 0.614986147089777, -82.3494415283203, -1.43726889184774, 218, 33, 'PPL', 'P'),
(83459, 'Saluda', 34.0013885498047, 0.593436180443992, -81.772216796875, -1.42719441976008, 218, 48, 'PPL', 'P'),
(106009, 'Saluda', 37.6058311462402, 0.656345571450925, -76.5952835083008, -1.33683988871836, 218, 53, 'PPL', 'P'),
(121354, 'Saluda', 40.871940612793, 0.713349935372826, -90.394172668457, -1.57767593768084, 218, 18, 'PPL', 'P'),
(83462, 'Saluda Hills', 34.0108299255371, 0.59360096353644, -81.1055603027344, -1.41555906895752, 218, 48, 'PPL', 'P'),
(166844, 'Salunga', 40.100830078125, 0.699891517646056, -76.4250030517578, -1.33386793409989, 218, 45, 'PPL', 'P'),
(11789, 'Salus', 35.7308311462402, 0.623620647976032, -93.4058303833008, -1.63023928074796, 218, 4, 'PPL', 'P'),
(166843, 'Saluvia', 40.0052795410156, 0.698223846171449, -78.1036071777344, -1.36316510293574, 218, 45, 'PPL', 'P'),
(132987, 'Salva', 45.8877792358398, 0.800892834093693, -87.2044372558594, -1.52200455246355, 218, 27, 'PPL', 'P'),
(184748, 'Salvador', 38.3408317565918, 0.669173752105728, -122.319717407227, -2.13488180886513, 218, 6, 'PPL', 'P'),
(83464, 'Salvesbarg Landing', 32.4749984741211, 0.566795647953548, -80.8499984741211, -1.4110986736058, 218, 48, 'PPL', 'P'),
(106011, 'Salvia', 37.9491691589355, 0.662337950219713, -77.133056640625, -1.34622580050618, 218, 53, 'PPL', 'P'),
(184750, 'Salvia', 33.872501373291, 0.591186674850229, -116.500831604004, -2.03332309280133, 218, 6, 'PPL', 'P'),
(38083, 'Salvisa', 37.9166717529297, 0.661770763486553, -84.857780456543, -1.48104766490117, 218, 21, 'PPL', 'P'),
(17921, 'Salvista', 26.6827793121338, 0.465702352579762, -81.8680572509766, -1.42886715124076, 218, 12, 'PPL', 'P'),
(68502, 'Salvo', 35.5400009155273, 0.620290032137751, -75.4733276367188, -1.31725806469717, 218, 33, 'PPL', 'P'),
(193926, 'Salyer', 40.8902816772461, 0.713670047335854, -123.58332824707, -2.15693597848429, 218, 6, 'PPL', 'P'),
(38084, 'Salyersville', 37.752498626709, 0.658905401890709, -83.0688934326172, -1.44982569638746, 218, 21, 'PPL', 'P'),
(106012, 'Sam', 37.2397193908691, 0.649955715889444, -81.3411102294922, -1.41967019073228, 218, 53, 'PPL', 'P'),
(195580, 'Sam', 43.7191696166992, 0.763043456049269, -111.303062438965, -1.94260490711277, 218, 17, 'PPL', 'P'),
(97766, 'Sam Fordyce', 26.2488899230957, 0.458129554151581, -98.5286102294922, -1.7196486559188, 218, 51, 'PPL', 'P'),
(97767, 'Sam Houston', 30.3250007629395, 0.529271108983086, -94.8083267211914, -1.65471745959131, 218, 51, 'PPL', 'P'),
(51190, 'Sam Owings Place', 38.7150001525879, 0.675704222572766, -76.5536117553711, -1.33611257942466, 218, 25, 'PPL', 'P'),
(97768, 'Sam Rayburn', 31.0638904571533, 0.542167166956172, -94.0356521606445, -1.64123174446337, 218, 51, 'PPL', 'P'),
(51191, 'Sam Rice Manor', 39.1480598449707, 0.68326254006252, -77.0038909912109, -1.34397143464343, 218, 25, 'PPL', 'P'),
(211094, 'Sam Sing Village', 20.8713893890381, 0.364274464304522, -156.446105957031, -2.73049965087411, 218, 15, 'PPL', 'P'),
(205661, 'Samak', 40.6175003051758, 0.708909114255119, -111.21305847168, -1.94103404154378, 218, 52, 'PPL', 'P'),
(5629, 'Samantha', 33.4222183227539, 0.583327753052432, -87.6052780151367, -1.52900054348914, 218, 2, 'PPL', 'P'),
(74199, 'Samantha', 39.2833290100098, 0.685623432368875, -83.5919418334961, -1.45895461313009, 218, 41, 'PPL', 'P'),
(68504, 'Samarcand', 35.2994384765625, 0.616091425521187, -79.6847229003906, -1.39076077815114, 218, 33, 'PPL', 'P'),
(5628, 'Samaria', 32.8188896179199, 0.572797680681286, -86.6319427490234, -1.51201263836969, 218, 2, 'PPL', 'P'),
(31062, 'Samaria', 39.4038887023926, 0.687727595946147, -86.186393737793, -1.50423634114471, 218, 19, 'PPL', 'P'),
(38085, 'Samaria', 38.4199981689453, 0.670555466658288, -82.9452819824219, -1.44766826958839, 218, 21, 'PPL', 'P'),
(68505, 'Samaria', 35.8597183227539, 0.625870153569794, -78.1786117553711, -1.36447417976957, 218, 33, 'PPL', 'P'),
(83465, 'Samaria', 33.8252792358398, 0.590362493071877, -81.477783203125, -1.42205558412066, 218, 48, 'PPL', 'P'),
(90592, 'Samaria', 36.1100006103516, 0.630238403547797, -85.5622177124023, -1.49334241438963, 218, 50, 'PPL', 'P'),
(97769, 'Samaria', 32.1263809204102, 0.560711123811044, -96.1538162231445, -1.67820068145141, 218, 51, 'PPL', 'P'),
(111268, 'Samaria', 39.4483299255371, 0.688503241613632, -80.0577774047852, -1.39727180754222, 218, 58, 'PPL', 'P'),
(132988, 'Samaria', 41.8080596923828, 0.729688295502408, -83.5783309936523, -1.45871705916086, 218, 27, 'PPL', 'P'),
(195579, 'Samaria', 42.1177787780762, 0.735093913304023, -112.336112976074, -1.96063504032482, 218, 17, 'PPL', 'P'),
(106014, 'Samary Forest', 37.6619415283203, 0.657324882362775, -77.6588897705078, -1.35540331993871, 218, 53, 'PPL', 'P'),
(42958, 'Sambo', 30.7038898468018, 0.535883970996348, -91.8283309936523, -1.60270672245039, 218, 22, 'PPL', 'P'),
(90593, 'Samburg', 36.3808288574219, 0.634965248166578, -89.3547210693359, -1.55953408486106, 218, 50, 'PPL', 'P'),
(57407, 'Samford', 36.0741691589355, 0.629613026744819, -89.9141693115234, -1.56929829868173, 218, 29, 'PPL', 'P'),
(51192, 'Samhill Estates', 39.3497200012207, 0.686782173759168, -77.1911087036133, -1.3472390001429, 218, 25, 'PPL', 'P'),
(208655, 'Samish', 48.6111106872559, 0.848423934544018, -122.434440612793, -2.1368841065307, 218, 56, 'PPL', 'P'),
(208656, 'Samish Island', 48.5761108398438, 0.847813071968981, -122.53971862793, -2.1387215545248, 218, 56, 'PPL', 'P'),
(208657, 'Sammamish', 47.6419410705566, 0.831508733722325, -122.079170227051, -2.13068346856467, 218, 56, 'PPL', 'P'),
(152328, 'Sammonsville', 42.9883308410645, 0.750287913113198, -74.4338912963867, -1.2991164781935, 218, 40, 'PPL', 'P'),
(97770, 'Sammy Martinez Colonia', 26.4300003051758, 0.461290526628423, -98.754997253418, -1.7235998548701, 218, 51, 'PPL', 'P'),
(192156, 'Samnorwood', 35.0522193908691, 0.611776638502068, -100.280281066895, -1.75022107944264, 218, 51, 'PPL', 'P'),
(57408, 'Samoa', 37.2744407653809, 0.650561718195491, -91.9124984741211, -1.60417572210768, 218, 29, 'PPL', 'P'),
(117670, 'Samoa', 42.0777816772461, 0.734395832203286, -90.1966705322266, -1.5742288751239, 218, 16, 'PPL', 'P'),
(193927, 'Samoa', 40.8188896179199, 0.712424020840833, -124.185279846191, -2.1674420158266, 218, 6, 'PPL', 'P'),
(57409, 'Samos', 36.8680610656738, 0.643469054422338, -89.2763900756836, -1.55816695111547, 218, 29, 'PPL', 'P'),
(106015, 'Samos', 37.7005615234375, 0.657998928434674, -76.6383285522461, -1.33759116646187, 218, 53, 'PPL', 'P'),
(5630, 'Samoset', 33.7363891601563, 0.588811068578851, -87.1275024414063, -1.52066178664194, 218, 2, 'PPL', 'P'),
(17922, 'Samoset', 27.4691696166992, 0.47942745260019, -82.5416717529297, -1.44062394218902, 218, 12, 'PPL', 'P'),
(144410, 'Samoset', 43.5677795410156, 0.760401200773747, -71.3377838134766, -1.24507920862108, 218, 36, 'PPL', 'P'),
(112311, 'Samoth', 37.3327789306641, 0.651579911259256, -88.7874984741211, -1.54963418298285, 218, 18, 'PPL', 'P'),
(83467, 'Sampit', 33.3638916015625, 0.58230975972575, -79.4588928222656, -1.38681929973782, 218, 48, 'PPL', 'P'),
(38086, 'Sample', 37.9044418334961, 0.661557311125183, -86.4811096191406, -1.50938010363214, 218, 21, 'PPL', 'P'),
(97771, 'Sample', 29.2186107635498, 0.509960960682598, -97.523063659668, -1.70209855749324, 218, 51, 'PPL', 'P'),
(166845, 'Sample', 40.5794410705566, 0.708244855300226, -79.9683303833008, -1.39571066251122, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(187310, 'Sample', 38.4722213745117, 0.671466933541368, -105.355003356934, -1.83879169202817, 218, 7, 'PPL', 'P'),
(166846, 'Sample Run', 40.6605606079102, 0.709660658314739, -79.0233306884766, -1.37921730640619, 218, 45, 'PPL', 'P'),
(11790, 'Samples', 34.3461112976074, 0.599452727399671, -92.1405563354492, -1.60815608267291, 218, 4, 'PPL', 'P'),
(197472, 'Samples Crossing', 47.273609161377, 0.825080129166983, -109.719436645508, -1.91496542289743, 218, 31, 'PPL', 'P'),
(51193, 'Samples Manor', 39.371940612793, 0.687169996592911, -77.7202835083008, -1.3564748428033, 218, 25, 'PPL', 'P'),
(74198, 'Sampleville', 39.7427787780762, 0.693642343569158, -84.5763931274414, -1.47613652953496, 218, 41, 'PPL', 'P'),
(209720, 'Sampo (historical)', 41.9019393920898, 0.731326805363079, -106.491943359375, -1.8586350384684, 218, 59, 'PPL', 'P'),
(57412, 'Sampsel', 39.8138885498047, 0.694883443216162, -93.7083282470703, -1.63551886445098, 218, 29, 'PPL', 'P'),
(17924, 'Sampson', 30.0644397735596, 0.524723461816153, -81.5019378662109, -1.42247716252122, 218, 12, 'PPL', 'P'),
(38087, 'Sampson', 36.726390838623, 0.640996442508254, -83.2794418334961, -1.45350045921761, 218, 21, 'PPL', 'P'),
(57411, 'Sampson', 37.4416694641113, 0.653480409592164, -92.8422164916992, -1.62040236262953, 218, 29, 'PPL', 'P'),
(83468, 'Sampson', 34.8727798461914, 0.608644827639162, -82.4097213745117, -1.43832097363638, 218, 48, 'PPL', 'P'),
(90594, 'Sampson', 35.6758308410645, 0.622660711561113, -85.272216796875, -1.48828094357988, 218, 50, 'PPL', 'P'),
(106016, 'Sampson', 38.1738891601563, 0.6662600541361, -78.8477783203125, -1.37615333957206, 218, 53, 'PPL', 'P'),
(152330, 'Sampson', 42.7291717529297, 0.74576473373878, -76.9005584716797, -1.34216794195323, 218, 40, 'PPL', 'P'),
(166848, 'Sampson', 40.1738891601563, 0.701166639175986, -79.883056640625, -1.39422235493603, 218, 45, 'PPL', 'P'),
(176256, 'Sampson', 44.7649993896484, 0.781296629002617, -88.1861114501953, -1.53913799933658, 218, 57, 'PPL', 'P'),
(195581, 'Sampson', 45.5177803039551, 0.794435134503441, -116.007499694824, -2.024712826681, 218, 17, 'PPL', 'P'),
(208658, 'Sampson', 47.0419387817383, 0.821036718262943, -124.163887023926, -2.16706864064177, 218, 56, 'PPL', 'P'),
(157525, 'Sampson (historical)', 40.0047187805176, 0.698214059054443, -84.5983276367188, -1.47651935894166, 218, 41, 'PPL', 'P'),
(83469, 'Sampson Landing', 33.7980613708496, 0.589887451712434, -79.2566680908203, -1.38328981234514, 218, 48, 'PPL', 'P'),
(126021, 'Sampsons Corner', 41.8499984741211, 0.730420265328016, -70.9458312988281, -1.238238346729, 218, 23, 'PPL', 'P'),
(146256, 'Samptown', 40.5813903808594, 0.708278877183152, -74.4305572509766, -1.29905828812368, 218, 37, 'PPL', 'P'),
(42959, 'Sampusand', 31.4883308410645, 0.54957504913385, -92.9127807617188, -1.62163394147564, 218, 22, 'PPL', 'P'),
(51194, 'Sams Creek', 39.4991683959961, 0.689390540309819, -77.1161117553711, -1.34593005646713, 218, 25, 'PPL', 'P'),
(77171, 'Sams Point', 35.1938896179199, 0.614249250416152, -95.6933288574219, -1.67016366075572, 218, 42, 'PPL', 'P'),
(201529, 'Sams Valley', 42.4916687011719, 0.741619523502072, -122.974166870117, -2.14630410678047, 218, 43, 'PPL', 'P'),
(5631, 'Samson', 31.1127796173096, 0.543020443769433, -86.0461120605469, -1.50178796399655, 218, 2, 'PPL', 'P'),
(152331, 'Samsondale', 41.208610534668, 0.719225934001977, -73.9775009155273, -1.29115096337307, 218, 40, 'PPL', 'P'),
(152332, 'Samsonville', 41.8875007629395, 0.73107480374493, -74.2944412231445, -1.29668261527328, 218, 40, 'PPL', 'P'),
(172496, 'Samsonville', 44.9236106872559, 0.784064918376727, -72.7330627441406, -1.26943141994488, 218, 55, 'PPL', 'P'),
(42960, 'Samstown', 30.1350002288818, 0.525954974083233, -91.1591720581055, -1.59102769580596, 218, 22, 'PPL', 'P'),
(17926, 'Samsula', 29.0258293151855, 0.506596289671879, -81.0505599975586, -1.4145991325426, 218, 12, 'PPL', 'P'),
(28526, 'Samsville', 38.4897193908691, 0.671772331539373, -88.057502746582, -1.53689335401181, 218, 18, 'PPL', 'P'),
(42961, 'Samtown', 31.2716693878174, 0.545793593412533, -92.436393737793, -1.61331941939436, 218, 22, 'PPL', 'P'),
(57413, 'Samtown', 38.0366706848145, 0.663865139946819, -92.4238891601563, -1.61310117334302, 218, 29, 'PPL', 'P'),
(90595, 'Samuel (historical)', 36.4927787780762, 0.636919142879342, -82.4513931274414, -1.43904828293008, 218, 50, 'PPL', 'P'),
(121355, 'Samuel A Rothermel Houses', 41.8863906860352, 0.731055429248, -87.7997207641602, -1.53239420966623, 218, 18, 'PPL', 'P'),
(38088, 'Samuels', 37.8827781677246, 0.661179208829419, -85.533332824707, -1.49283827799528, 218, 21, 'PPL', 'P'),
(42962, 'Samuels', 30.7138900756836, 0.536058507916289, -91.5400009155273, -1.59767441325458, 218, 22, 'PPL', 'P'),
(195582, 'Samuels', 48.4294395446777, 0.84525317495017, -116.492782592773, -2.03318261105383, 218, 17, 'PPL', 'P'),
(106017, 'Samuels Corner', 38.1722183227539, 0.666230892522163, -77.2577819824219, -1.34840266838121, 218, 53, 'PPL', 'P'),
(121356, 'Samuelson Corners', 42.2958297729492, 0.738201489401009, -89.0288925170898, -1.55384730382736, 218, 18, 'PPL', 'P'),
(189413, 'San Acacia', 34.2552795410156, 0.597867414181775, -106.898887634277, -1.86573755593759, 218, 38, 'PPL', 'P'),
(187311, 'San Acacio', 37.2138900756836, 0.649504909295921, -105.563888549805, -1.84243742640243, 218, 7, 'PPL', 'P'),
(179054, 'San Agustin', 31.6022205352783, 0.551562799281971, -111.894172668457, -1.95292172685962, 218, 5, 'PPL', 'P'),
(192157, 'San Agustin Colonia', 31.6660003662109, 0.552675967328111, -106.273002624512, -1.8548138017783, 218, 51, 'PPL', 'P'),
(184751, 'San Andreas', 38.1961097717285, 0.666647876969842, -120.679443359375, -2.1062536260951, 218, 6, 'PPL', 'P'),
(192158, 'San Angelo', 31.4636096954346, 0.549143583747744, -100.436668395996, -1.75295055324386, 218, 51, 'PPL', 'P'),
(97772, 'San Angelo Junction', 31.7761096954346, 0.554597737660226, -99.3675003051758, -1.73429004980179, 218, 51, 'PPL', 'P'),
(184753, 'San Anselmo', 37.9747200012207, 0.662783896544246, -122.560562133789, -2.13908534232971, 218, 6, 'PPL', 'P'),
(17931, 'San Antonio', 28.3358306884766, 0.494553541801568, -82.2747192382813, -1.43596474186193, 218, 12, 'PPL', 'P'),
(57414, 'San Antonio', 39.7769393920898, 0.6942385587582, -94.6833267211914, -1.65253579802632, 218, 29, 'PPL', 'P'),
(97773, 'San Antonio', 29.4238891601563, 0.513543744586596, -98.4933319091797, -1.71903293307478, 218, 51, 'PPL', 'P'),
(184758, 'San Antonio', 38.1838912963867, 0.666434624345554, -122.590278625488, -2.139603992952, 218, 6, 'PPL', 'P'),
(187312, 'San Antonio', 37.0208282470703, 0.646135344726698, -106.027496337891, -1.85052890874242, 218, 7, 'PPL', 'P'),
(189416, 'San Antonio', 33.917781829834, 0.59197696790371, -106.865280151367, -1.8651509947075, 218, 38, 'PPL', 'P'),
(189417, 'San Antonio (historical)', 36.8613891601563, 0.643352607703674, -106.148887634277, -1.85264758654763, 218, 38, 'PPL', 'P'),
(190704, 'San Antonio (historical)', 38.461109161377, 0.671272988834983, -117.292778015137, -2.04714516517496, 218, 39, 'PPL', 'P'),
(184760, 'San Antonio Heights', 34.1555595397949, 0.596126971830381, -117.655563354492, -2.05347696382467, 218, 6, 'PPL', 'P'),
(97774, 'San Antonio Prairie', 30.457799911499, 0.531588891369295, -96.7829971313477, -1.68918195989024, 218, 51, 'PPL', 'P'),
(97775, 'San Antonio Viejo', 26.9552803039551, 0.470458392101994, -98.8324966430664, -1.72495247438775, 218, 51, 'PPL', 'P'),
(189423, 'San Antonito', 33.8927803039551, 0.591540608959101, -106.873893737793, -1.86530133015104, 218, 38, 'PPL', 'P'),
(184763, 'San Ardo', 36.0205612182617, 0.628677391674847, -120.904167175293, -2.11017579659051, 218, 6, 'PPL', 'P'),
(189420, 'San Augustin', 35.4577789306641, 0.618854987784362, -105.145278930664, -1.83513131026791, 218, 38, 'PPL', 'P'),
(97776, 'San Augustine', 31.5297203063965, 0.550297431579534, -94.105827331543, -1.64245653224869, 218, 51, 'PPL', 'P'),
(184765, 'San Augustine', 34.4594383239746, 0.601430657141273, -120.357223510742, -2.10062982882118, 218, 6, 'PPL', 'P'),
(24635, 'San Barnard (historical)', 31.5699996948242, 0.551000439528288, -83.8597183227539, -1.46362819452707, 218, 13, 'PPL', 'P'),
(97778, 'San Benito', 26.1322193145752, 0.456093267892593, -97.6308288574219, -1.70397941501311, 218, 51, 'PPL', 'P'),
(184766, 'San Benito', 36.5097198486328, 0.637214820339368, -121.080833435059, -2.11325920450061, 218, 6, 'PPL', 'P'),
(184770, 'San Bernardino', 34.1083297729492, 0.595302656893974, -117.288887023926, -2.04707725456716, 218, 6, 'PPL', 'P'),
(17932, 'San Blas', 30.0891704559326, 0.525155093649828, -85.6100006103516, -1.49417638328499, 218, 12, 'PPL', 'P'),
(184776, 'San Bruno', 37.6305618286133, 0.6567772032846, -122.410003662109, -2.13645760128213, 218, 6, 'PPL', 'P'),
(17933, 'San Buenaventura (historical)', 29.7000007629395, 0.518362801158121, -81.466667175293, -1.42186157283525, 218, 12, 'PPL', 'P'),
(112591, 'San Carlos', 26.6791706085205, 0.465639368819982, -98.8533325195313, -1.7253161290346, 218, 51, 'PPL', 'P'),
(179056, 'San Carlos', 33.3458290100098, 0.581994508031712, -111.849998474121, -1.95215074172405, 218, 5, 'PPL', 'P'),
(184777, 'San Carlos', 37.5072212219238, 0.654624503596462, -122.259437561035, -2.13382972707649, 218, 6, 'PPL', 'P'),
(97780, 'San Carlos Acres Colonia', 26.2940006256104, 0.458916884438349, -98.0559997558594, -1.7114000470745, 218, 51, 'PPL', 'P'),
(17934, 'San Carlos Chacatos (historical)', 30.3500003814697, 0.529707434638182, -85.6833267211914, -1.49545616534683, 218, 12, 'PPL', 'P'),
(97781, 'San Carlos Farms Colonia', 26.3020000457764, 0.459056500658497, -98.0719985961914, -1.7116792795148, 218, 51, 'PPL', 'P'),
(97782, 'San Carlos Number 1 Colonia', 27.4899997711182, 0.4797910073785, -99.3730010986328, -1.73438605675909, 218, 51, 'PPL', 'P'),
(97783, 'San Carlos Number 2 Colonia', 27.4899997711182, 0.4797910073785, -99.3679962158203, -1.73429870507533, 218, 51, 'PPL', 'P'),
(17935, 'San Carlos Park', 26.4669399261475, 0.461935244638818, -81.8016662597656, -1.42770840985047, 218, 12, 'PPL', 'P'),
(184779, 'San Clemente', 33.4269409179688, 0.583410177888171, -117.611106872559, -2.05270105184108, 218, 6, 'PPL', 'P'),
(189422, 'San Cristobal', 36.5963897705078, 0.638727495838533, -105.638893127441, -1.84374650323626, 218, 38, 'PPL', 'P'),
(208660, 'San de Fuca', 48.235279083252, 0.841864435621099, -122.721939086914, -2.14190190149857, 218, 56, 'PPL', 'P'),
(97784, 'San Diego', 27.7636108398438, 0.484566421397662, -98.2386093139648, -1.71458718510905, 218, 51, 'PPL', 'P'),
(184780, 'San Diego', 32.7152786254883, 0.570989327722095, -117.156387329102, -2.04476469863459, 218, 6, 'PPL', 'P'),
(184781, 'San Diego Country Estates', 33.0066719055176, 0.576075099876793, -116.782783508301, -2.03824408186358, 218, 6, 'PPL', 'P'),
(17936, 'San Diego Salamototo (historical)', 30.0499992370605, 0.524471426908491, -81.6333312988281, -1.42477041053589, 218, 12, 'PPL', 'P'),
(184784, 'San Dimas', 34.1066703796387, 0.595273695017119, -117.80583190918, -2.05609964486618, 218, 6, 'PPL', 'P'),
(179057, 'San Dionysio (historical)', 32.7513885498047, 0.571619564794063, -114.566673278809, -1.99956566177182, 218, 5, 'PPL', 'P'),
(192159, 'San Elizario', 31.5849990844727, 0.551262228263442, -106.272216796875, -1.85480008649869, 218, 51, 'PPL', 'P'),
(184786, 'San Emidio', 35.0944404602051, 0.612513535175693, -119.303611755371, -2.08224083465224, 218, 6, 'PPL', 'P'),
(97785, 'San Felipe', 29.7927799224854, 0.51998210296943, -96.1005630493164, -1.67727123823097, 218, 51, 'PPL', 'P'),
(184789, 'San Felipe', 36.9708290100098, 0.645262693416506, -121.418060302734, -2.11914492366774, 218, 6, 'PPL', 'P'),
(189425, 'San Felipe Pueblo', 35.4338912963867, 0.61843806991571, -106.446113586426, -1.857835158035, 218, 38, 'PPL', 'P'),
(184790, 'San Fernando', 34.2819404602051, 0.598332735003239, -118.438056945801, -2.06713405336876, 218, 6, 'PPL', 'P'),
(97786, 'San Fernando Colonia', 26.4050006866455, 0.460854200973328, -98.8359985351563, -1.72501359393477, 218, 51, 'PPL', 'P'),
(189428, 'San Fidel', 35.082218170166, 0.612300215972377, -107.598609924316, -1.87795001374837, 218, 38, 'PPL', 'P'),
(184792, 'San Francisco', 37.7750015258789, 0.659298151572469, -122.418327331543, -2.13660287671959, 218, 6, 'PPL', 'P'),
(189429, 'San Francisco', 34.3958282470703, 0.600320451861847, -106.838607788086, -1.86468547414896, 218, 38, 'PPL', 'P'),
(192160, 'San Francisco', 29.8933296203613, 0.521737026259252, -102.403610229492, -1.78728016443358, 218, 51, 'PPL', 'P'),
(205662, 'San Francisco Condo', 40.6536102294922, 0.709539351327086, -111.931671142578, -1.95357619869751, 218, 52, 'PPL', 'P'),
(17938, 'San Francisco de Oconi (historical)', 30.1000003814697, 0.525344111508196, -83.9499969482422, -1.46520385378602, 218, 12, 'PPL', 'P'),
(189430, 'San Francisco Plaza', 33.6933288574219, 0.588059524519231, -108.765556335449, -1.89831707081697, 218, 38, 'PPL', 'P'),
(17937, 'San Francisco Potano (historical)', 29.8833293914795, 0.521562489339311, -82.5666732788086, -1.44106030113363, 218, 12, 'PPL', 'P'),
(97787, 'San Gabriel', 30.6941699981689, 0.53571432763491, -97.1958312988281, -1.69638727537751, 218, 51, 'PPL', 'P'),
(179058, 'San Gabriel', 33.6494407653809, 0.587293532810697, -112.153060913086, -1.95744017912311, 218, 5, 'PPL', 'P'),
(184798, 'San Gabriel', 34.0961112976074, 0.595089404269686, -118.105003356934, -2.06132117165745, 218, 6, 'PPL', 'P'),
(97788, 'San Geronimo', 29.6227798461914, 0.517015041909459, -98.7936096191406, -1.72427376778395, 218, 51, 'PPL', 'P'),
(184802, 'San Geronimo', 38.0133285522461, 0.663457742879064, -122.662780761719, -2.14086939394395, 218, 6, 'PPL', 'P'),
(189432, 'San Geronimo', 34.334171295166, 0.599244335044373, -106.872497558594, -1.86527696222706, 218, 38, 'PPL', 'P'),
(184806, 'San Gregorio', 37.327220916748, 0.65148290561655, -122.385559082031, -2.13603096287549, 218, 6, 'PPL', 'P'),
(198856, 'San Haven', 48.8347206115723, 0.852326663963475, -100.038612365723, -1.74600316490817, 218, 34, 'PPL', 'P'),
(184807, 'San Ignacio', 33.3047218322754, 0.581277052434044, -116.517501831055, -2.03361404315043, 218, 6, 'PPL', 'P'),
(189434, 'San Ignacio', 35.771110534668, 0.624323655924785, -105.353889465332, -1.83877225095221, 218, 38, 'PPL', 'P'),
(97789, 'San Ignacio Viejo Unit 2 Colonia', 27.0170001983643, 0.471535607473417, -99.4069976806641, -1.73497940904995, 218, 51, 'PPL', 'P'),
(189435, 'San Ildefonso Pueblo', 35.8919410705566, 0.626432546612992, -106.117782592773, -1.85210470115942, 218, 38, 'PPL', 'P'),
(187313, 'San Isabel', 37.9874992370605, 0.663006936285541, -105.053886413574, -1.83353620993301, 218, 7, 'PPL', 'P'),
(97790, 'San Isidro', 26.7163906097412, 0.46628898038888, -98.45361328125, -1.71833971224303, 218, 51, 'PPL', 'P'),
(31063, 'San Jacinto', 38.9563903808594, 0.679917276838244, -85.4972229003906, -1.49220804092331, 218, 19, 'PPL', 'P'),
(97791, 'San Jacinto', 30.621940612793, 0.534453687043407, -95.720832824707, -1.6706436955422, 218, 51, 'PPL', 'P'),
(184808, 'San Jacinto', 33.7838897705078, 0.589640110626193, -116.957778930664, -2.04129832815974, 218, 6, 'PPL', 'P'),
(200185, 'San Jacinto', 41.8686103820801, 0.730745104401978, -114.675559997559, -2.0014660935257, 218, 39, 'PPL', 'P'),
(184811, 'San Joaquin', 36.6066703796387, 0.638906926316977, -120.188056945801, -2.09767731527866, 218, 6, 'PPL', 'P'),
(184814, 'San Joaquin Hills', 33.6116714477539, 0.586634333861875, -117.835830688477, -2.05662322233649, 218, 6, 'PPL', 'P'),
(184816, 'San Joaquin River Club', 37.6808280944824, 0.657654515126699, -121.271942138672, -2.11659468060788, 218, 6, 'PPL', 'P'),
(184815, 'San Joaquin River Estates', 36.8638916015625, 0.643396283545551, -119.816108703613, -2.09118559380549, 218, 6, 'PPL', 'P'),
(189437, 'San Jon', 35.1074981689453, 0.612741435185976, -103.328056335449, -1.80341479273978, 218, 38, 'PPL', 'P'),
(17939, 'San Jose', 30.2425003051758, 0.527831204360707, -81.6161117553711, -1.42446987280687, 218, 12, 'PPL', 'P'),
(121357, 'San Jose', 40.3055610656738, 0.703464747459643, -89.602783203125, -1.5638635858452, 218, 18, 'PPL', 'P'),
(179061, 'San Jose', 32.8199996948242, 0.572817055178217, -109.59139251709, -1.91273063126869, 218, 5, 'PPL', 'P'),
(184818, 'San Jose', 37.3394393920898, 0.651696158240838, -121.893890380859, -2.12744972521104, 218, 6, 'PPL', 'P'),
(189441, 'San Jose', 35.3972206115723, 0.617798045726737, -105.47444152832, -1.84087628137143, 218, 38, 'PPL', 'P'),
(192161, 'San Jose', 31.7211093902588, 0.553637801245307, -106.362503051758, -1.85637587891569, 218, 51, 'PPL', 'P'),
(97795, 'San Jose Colonia', 26.3939990997314, 0.460662187058733, -98.8410034179688, -1.72510094561852, 218, 51, 'PPL', 'P'),
(17940, 'San Jose Forest', 30.2513904571533, 0.527986366783718, -81.6291732788086, -1.42469783939619, 218, 12, 'PPL', 'P'),
(184822, 'San Jose Mobile Home Park', 37.4166717529297, 0.653044117226581, -121.95832824707, -2.12857437813938, 218, 6, 'PPL', 'P'),
(97797, 'San Juan', 27.766939163208, 0.484624511598939, -97.5386123657227, -1.70236993360832, 218, 51, 'PPL', 'P'),
(189444, 'San Juan', 36.0519409179688, 0.629225070753022, -106.068328857422, -1.85124157065013, 218, 38, 'PPL', 'P'),
(190706, 'San Juan (historical)', 39.1061096191406, 0.68253037049983, -117.243057250977, -2.04627737413375, 218, 39, 'PPL', 'P'),
(184825, 'San Juan Bautista', 36.8455581665039, 0.643076304740578, -121.53694152832, -2.12121979247302, 218, 6, 'PPL', 'P'),
(184829, 'San Juan Capistrano', 33.5016708374023, 0.584714461032037, -117.661666870117, -2.05358349026828, 218, 6, 'PPL', 'P'),
(97798, 'San Juan Colonia', 26.4160003662109, 0.461046181598409, -98.9440002441406, -1.72689857935433, 218, 51, 'PPL', 'P'),
(17942, 'San Juan de Guacara (historical)', 30.1833305358887, 0.526798497069002, -83.9333267211914, -1.46491290343693, 218, 12, 'PPL', 'P'),
(97799, 'San Juan East Colonia', 26.1800003051758, 0.456927203498438, -98.1389999389648, -1.71284867354945, 218, 51, 'PPL', 'P'),
(184830, 'San Juan Hot Springs', 33.5908317565918, 0.586270612635997, -117.508613586426, -2.05091220653687, 218, 6, 'PPL', 'P'),
(17941, 'San Juan Ospalaga (historical)', 30.5083293914795, 0.532470797164275, -83.7333297729492, -1.46142229819616, 218, 12, 'PPL', 'P'),
(189446, 'San Juan Pueblo', 36.0527801513672, 0.629239718139017, -106.069999694824, -1.85127073226406, 218, 38, 'PPL', 'P'),
(97800, 'San Juan South Estates Colonia', 26.1760005950928, 0.456857395388364, -98.1600036621094, -1.7132152576735, 218, 51, 'PPL', 'P'),
(184834, 'San Lawrence Terrace', 35.7458305358887, 0.623882436711186, -120.682502746582, -2.10630702247496, 218, 6, 'PPL', 'P'),
(184835, 'San Leandro', 37.7249984741211, 0.65842543368325, -122.154998779297, -2.13200692646838, 218, 6, 'PPL', 'P'),
(97803, 'San Leanna', 30.1455593109131, 0.526139264830666, -97.8177795410156, -1.70724231998067, 218, 51, 'PPL', 'P'),
(97801, 'San Leon', 29.483060836792, 0.514576485167815, -94.9219436645508, -1.65670044933898, 218, 51, 'PPL', 'P'),
(184839, 'San Lorenzo', 37.6811103820801, 0.657659441974716, -122.123329162598, -2.13145418738414, 218, 6, 'PPL', 'P'),
(189449, 'San Lorenzo', 36.0486106872559, 0.629166947262231, -106.284721374512, -1.85501833255002, 218, 38, 'PPL', 'P'),
(17943, 'San Lorenzo Ibitachuco (historical)', 30.3666706085205, 0.529998384987273, -83.8000030517578, -1.46258596643447, 218, 12, 'PPL', 'P'),
(184843, 'San Lorenzo Park', 37.1961097717285, 0.649194584449899, -122.144439697266, -2.13182263572095, 218, 6, 'PPL', 'P'),
(184845, 'San Lucas', 36.1288909912109, 0.630568102890749, -121.019439697266, -2.11218768163601, 218, 6, 'PPL', 'P'),
(179063, 'San Lucy Village', 32.9638900756836, 0.575328416086161, -112.717216491699, -1.9672865514634, 218, 5, 'PPL', 'P'),
(179066, 'San Luis', 32.4869384765625, 0.567004040308846, -114.781387329102, -2.00331312889972, 218, 5, 'PPL', 'P'),
(187315, 'San Luis', 37.2008285522461, 0.64927694270661, -105.423332214355, -1.83998425556431, 218, 7, 'PPL', 'P'),
(189450, 'San Luis', 35.6824989318848, 0.622777091700749, -107.050003051758, -1.86837501752315, 218, 38, 'PPL', 'P'),
(17944, 'San Luis Apalache (historical)', 30.2999992370605, 0.528834750038476, -83.9833297729492, -1.46578562132615, 218, 12, 'PPL', 'P'),
(184846, 'San Luis Obispo', 35.2827796936035, 0.615800674909177, -120.65860748291, -2.10588997144825, 218, 6, 'PPL', 'P'),
(184848, 'San Luis Rey', 33.2319412231445, 0.580006791173104, -117.322776794434, -2.04766874264526, 218, 6, 'PPL', 'P'),
(184849, 'San Luis Rey Heights', 33.3188896179199, 0.581524326941258, -117.20832824707, -2.04567123866965, 218, 6, 'PPL', 'P'),
(57, 'San Manuel', 26.5641708374023, 0.46363224417493, -98.1208267211914, -1.71253149106362, 218, 51, 'PPL', 'P'),
(179070, 'San Manuel', 32.5997200012207, 0.568972449249551, -110.630279541016, -1.93086263039244, 218, 5, 'PPL', 'P'),
(51195, 'San Mar', 39.5508308410645, 0.690292220075893, -77.6447219848633, -1.35515604543149, 218, 25, 'PPL', 'P'),
(189451, 'San Marcial', 33.7000007629395, 0.588175971237895, -106.986671447754, -1.86726967251271, 218, 38, 'PPL', 'P'),
(17945, 'San Marco', 30.3116703033447, 0.529038448572354, -81.6600036621094, -1.42523593109444, 218, 12, 'PPL', 'P'),
(83470, 'San Marco Estates', 33.9736099243164, 0.592951351967543, -80.8533325195313, -1.41115686367562, 218, 48, 'PPL', 'P'),
(97802, 'San Marcos', 29.8830604553223, 0.521557795517889, -97.9411087036133, -1.70939481993173, 218, 51, 'PPL', 'P'),
(184851, 'San Marcos', 33.1433296203613, 0.578460226949067, -117.165283203125, -2.04491996092614, 218, 6, 'PPL', 'P'),
(17946, 'San Marcos (historical)', 30.1833305358887, 0.526798497069002, -84.216667175293, -1.46985812726509, 218, 12, 'PPL', 'P'),
(74200, 'San Margherita', 39.9944381713867, 0.698034628575998, -83.086669921875, -1.45013595465446, 218, 41, 'PPL', 'P'),
(201530, 'San Marine', 44.353889465332, 0.774121407235671, -124.092781066895, -2.16582760757379, 218, 43, 'PPL', 'P'),
(184854, 'San Marino', 34.1213912963867, 0.595530623483285, -118.105560302734, -2.06133089219543, 218, 6, 'PPL', 'P'),
(184855, 'San Martin', 37.0849990844727, 0.647255337123131, -121.609169006348, -2.12248039977501, 218, 6, 'PPL', 'P'),
(192162, 'San Martine', 31.1577796936035, 0.543805843264411, -104.069717407227, -1.81635922037616, 218, 51, 'PPL', 'P'),
(17948, 'San Mateo', 29.6063899993896, 0.516728985118871, -81.584716796875, -1.42392192741259, 218, 12, 'PPL', 'P'),
(83471, 'San Mateo', 34.5219383239746, 0.60252148792377, -82.7222213745117, -1.44377512754886, 218, 48, 'PPL', 'P'),
(184857, 'San Mateo', 37.563060760498, 0.655599087397376, -122.324440002441, -2.13496423370086, 218, 6, 'PPL', 'P'),
(189453, 'San Mateo', 35.3313903808594, 0.616649091453449, -107.642501831055, -1.87871607203593, 218, 38, 'PPL', 'P'),
(184859, 'San Mateo Park', 37.5666694641113, 0.655662071157156, -122.344169616699, -2.13530858042981, 218, 6, 'PPL', 'P'),
(179069, 'San Miguel', 31.6127796173096, 0.551747090029405, -111.781387329102, -1.95095325133989, 218, 5, 'PPL', 'P'),
(184861, 'San Miguel', 35.752498626709, 0.623998816850823, -120.695281982422, -2.10653006221625, 218, 6, 'PPL', 'P'),
(187317, 'San Miguel', 37.9469413757324, 0.662299068067797, -107.83528137207, -1.88208070975714, 218, 7, 'PPL', 'P'),
(189459, 'San Miguel', 35.9130592346191, 0.626801128107859, -106.913063049316, -1.86598496360286, 218, 38, 'PPL', 'P'),
(83472, 'San Miguel De Gualdape (historical)', 33.3277816772461, 0.581679522653782, -79.2611083984375, -1.38336731033286, 218, 48, 'PPL', 'P'),
(17949, 'San Nicolas Palica (historical)', 30.2666702270508, 0.528253049077376, -81.6166687011719, -1.42447959334485, 218, 12, 'PPL', 'P'),
(17950, 'San Nicolas Tolentino (historical)', 29.8500003814697, 0.52098078837821, -81.5500030517578, -1.4233160582646, 218, 12, 'PPL', 'P'),
(184866, 'San Onofre', 33.3811111450195, 0.582610297454765, -117.572219848633, -2.05202234523727, 218, 6, 'PPL', 'P'),
(17951, 'San Pablo', 30.295280456543, 0.528752391781766, -81.4377822875977, -1.4213574364409, 218, 12, 'PPL', 'P'),
(97804, 'San Pablo', 27.6194400787354, 0.482050166931214, -98.8088912963867, -1.72454048336712, 218, 51, 'PPL', 'P'),
(184868, 'San Pablo', 37.9622192382813, 0.662565717071942, -122.344436645508, -2.13531324096172, 218, 6, 'PPL', 'P'),
(187319, 'San Pablo', 37.149169921875, 0.648375329519563, -105.396392822266, -1.83951407447385, 218, 7, 'PPL', 'P'),
(189473, 'San Pablo', 35.9449996948242, 0.62735859430304, -106.91056060791, -1.86594128776098, 218, 38, 'PPL', 'P'),
(17952, 'San Pablo Patali (historical)', 30.3666706085205, 0.529998384987273, -81.5166702270508, -1.42273429072447, 218, 12, 'PPL', 'P'),
(184871, 'San Pasqual', 33.0916709899902, 0.577558613762021, -116.953056335449, -2.041215903324, 218, 6, 'PPL', 'P'),
(97805, 'San Patricio', 27.9541702270508, 0.487892310125007, -97.7716674804688, -1.70643751269925, 218, 51, 'PPL', 'P'),
(177719, 'San Patricio', 33.4088897705078, 0.583095125931214, -105.326393127441, -1.83829234932378, 218, 38, 'PPL', 'P'),
(192163, 'San Paulo Colonia', 31.603889465332, 0.551591927606394, -106.250556945801, -1.85442205078195, 218, 51, 'PPL', 'P'),
(97809, 'San Pedro', 27.788330078125, 0.484997853494254, -97.6780624389648, -1.70480379652854, 218, 51, 'PPL', 'P'),
(179071, 'San Pedro', 32.0833282470703, 0.559959712909478, -111.487503051758, -1.9458240030804, 218, 5, 'PPL', 'P'),
(184873, 'San Pedro', 33.7358283996582, 0.588801281461845, -118.291389465332, -2.06457422292898, 218, 6, 'PPL', 'P'),
(187320, 'San Pedro', 37.1597213745117, 0.648559487108942, -105.40193939209, -1.83961088037948, 218, 7, 'PPL', 'P'),
(189476, 'San Pedro', 33.9102783203125, 0.591846006957105, -106.841667175293, -1.86473887052881, 218, 38, 'PPL', 'P'),
(190707, 'San Pedro (historical)', 39.121940612793, 0.682806673462925, -114.303886413574, -1.99497916574248, 218, 39, 'PPL', 'P'),
(97810, 'San Pedro Colonia', 25.9810009002686, 0.453454008673297, -97.5979995727539, -1.70340643590457, 218, 51, 'PPL', 'P'),
(189482, 'San Pedro Creek', 35.2197189331055, 0.614700057009675, -106.301666259766, -1.85531407658908, 218, 38, 'PPL', 'P'),
(184875, 'San Pedro Hill', 33.7461090087891, 0.588980711940289, -118.33528137207, -2.06534028121654, 218, 6, 'PPL', 'P'),
(17953, 'San Pedro Junction', 30.0108299255371, 0.523787793456667, -83.2149963378906, -1.45237567313122, 218, 12, 'PPL', 'P'),
(189478, 'San Pedro Overlook', 35.2236099243164, 0.614767967617472, -106.278327941895, -1.85490674610035, 218, 38, 'PPL', 'P'),
(17954, 'San Pedro Poturiba (historical)', 30.1333293914795, 0.525925812469296, -83.0833282470703, -1.45007763142659, 218, 12, 'PPL', 'P'),
(190708, 'San Pedros', 38.6647186279297, 0.674826644414557, -116.923332214355, -2.04069711954366, 218, 39, 'PPL', 'P'),
(97811, 'San Perlita', 26.5008296966553, 0.462526732716925, -97.6394424438477, -1.70412975045664, 218, 51, 'PPL', 'P'),
(97812, 'San Petronilla Number 3 Colonia', 27.8889999389648, 0.486754874023434, -98.1070022583008, -1.71229020866886, 218, 51, 'PPL', 'P'),
(123622, 'San Pierre', 41.2036094665527, 0.71913864889725, -86.8919372558594, -1.51655039855107, 218, 19, 'PPL', 'P'),
(184876, 'San Quentin', 37.9413909912109, 0.662202195583146, -122.48388671875, -2.13774710388194, 218, 6, 'PPL', 'P'),
(179072, 'San Rafael', 31.7372207641602, 0.553918997766905, -112.023612976074, -1.95518088641234, 218, 5, 'PPL', 'P'),
(184878, 'San Rafael', 37.9736099243164, 0.662764522047316, -122.529998779297, -2.13855191116336, 218, 6, 'PPL', 'P'),
(189480, 'San Rafael', 35.4919395446777, 0.619451202973404, -104.455833435059, -1.82309821635655, 218, 38, 'PPL', 'P'),
(97813, 'San Ramon', 27.9327793121338, 0.487518968229691, -99.3872222900391, -1.73463426337268, 218, 51, 'PPL', 'P'),
(184879, 'San Ramon', 37.7799987792969, 0.659385370098169, -121.976936340332, -2.12889915063432, 218, 6, 'PPL', 'P'),
(189481, 'San Ramon', 35.5463905334473, 0.620401552008398, -104.416938781738, -1.82241937659469, 218, 38, 'PPL', 'P'),
(184883, 'San Ramon Village', 37.7213897705078, 0.65836244992347, -121.928886413574, -2.12806052120705, 218, 6, 'PPL', 'P'),
(152334, 'San Remo', 40.8819389343262, 0.713524439003254, -73.2211074829102, -1.27794940753344, 218, 40, 'PPL', 'P'),
(97814, 'San Roman', 26.7527809143066, 0.46692411101935, -98.8413925170898, -1.7251077366793, 218, 51, 'PPL', 'P'),
(97815, 'San Saba', 31.1955604553223, 0.544465241950315, -98.7177810668945, -1.72295030988023, 218, 51, 'PPL', 'P'),
(184884, 'San Sevaine (historical)', 34.0658302307129, 0.59456089995136, -117.463333129883, -2.05012191348339, 218, 6, 'PPL', 'P'),
(184887, 'San Simeon', 35.6438903808594, 0.622103245365932, -121.189720153809, -2.11515963625449, 218, 6, 'PPL', 'P'),
(179076, 'San Simon', 32.2677803039551, 0.563179008614193, -109.226936340332, -1.90636967100504, 218, 5, 'PPL', 'P'),
(5632, 'San Souci Beach', 30.3886108398438, 0.530381314262513, -88.2583312988281, -1.54039847348051, 218, 2, 'PPL', 'P'),
(17955, 'San Souci Estates', 25.8841705322266, 0.451763999935047, -80.1580581665039, -1.39902203701062, 218, 12, 'PPL', 'P'),
(179077, 'San Tan Mobile Village', 33.3033294677734, 0.581252751089097, -111.790283203125, -1.95110851363144, 218, 5, 'PPL', 'P'),
(184888, 'San Tomas', 37.2688903808594, 0.65046484571084, -121.97444152832, -2.12885560795049, 218, 6, 'PPL', 'P'),
(74201, 'San Toy', 39.6561088562012, 0.692129668069993, -82.0358276367188, -1.4317952968593, 218, 41, 'PPL', 'P'),
(179078, 'San Vicente', 32.0116691589355, 0.558709025882549, -111.636390686035, -1.94842258251404, 218, 5, 'PPL', 'P'),
(192164, 'San Vicente Crossing', 29.1299991607666, 0.508414396458562, -103.014442443848, -1.79794119775134, 218, 51, 'PPL', 'P'),
(97817, 'San Vicente Estates Colonia', 26.2259998321533, 0.457730046698556, -97.5250015258789, -1.70213237963908, 218, 51, 'PPL', 'P'),
(179080, 'San Xavier', 31.9736099243164, 0.558044766927656, -111.094436645508, -1.93896370011236, 218, 5, 'PPL', 'P'),
(97818, 'San Ygnacio', 27.0422191619873, 0.47197576142258, -99.4397201538086, -1.73555052394572, 218, 51, 'PPL', 'P'),
(184893, 'San Ysidro', 33.2552795410156, 0.580414121661831, -116.565559387207, -2.03445280573575, 218, 6, 'PPL', 'P'),
(189484, 'San Ysidro', 35.5633316040039, 0.620697229468424, -106.769996643066, -1.8634879837648, 218, 38, 'PPL', 'P'),
(192165, 'San Ysidro Colonia', 31.632999420166, 0.552099992163354, -106.267997741699, -1.85472645009455, 218, 51, 'PPL', 'P'),
(51196, 'San-Di-Gan', 39.4422187805176, 0.688396582011974, -77.4736099243164, -1.35216957658508, 218, 25, 'PPL', 'P'),
(212131, 'Sanak', 54.4780616760254, 0.950821546351183, -162.817504882813, -2.84170154008702, 218, 1, 'PPL', 'P'),
(51197, 'Sanandrews', 39.4249992370605, 0.688096044282959, -77.2805633544922, -1.34880027833196, 218, 25, 'PPL', 'P'),
(166849, 'Sanatoga', 40.2449989318848, 0.70240773882299, -75.5955581665039, -1.31939138988838, 218, 45, 'PPL', 'P'),
(202589, 'Sanator', 43.6966705322266, 0.762650772946536, -103.605278015137, -1.80825322380823, 218, 49, 'PPL', 'P'),
(61653, 'Sanatorium', 31.898609161377, 0.556735756672855, -89.7774963378906, -1.56691290529334, 218, 30, 'PPL', 'P'),
(17956, 'Sanborn', 30.0716705322266, 0.524849662362309, -84.6044387817383, -1.47662601854331, 218, 12, 'PPL', 'P'),
(117671, 'Sanborn', 43.1816711425781, 0.75366233795141, -95.6552810668945, -1.6694996015379, 218, 16, 'PPL', 'P'),
(137974, 'Sanborn', 44.2097206115723, 0.771605186058737, -95.1283264160156, -1.66030250787137, 218, 28, 'PPL', 'P'),
(140839, 'Sanborn', 46.9422187805176, 0.819296275911549, -98.2238922119141, -1.71433032322192, 218, 34, 'PPL', 'P'),
(144411, 'Sanborn', 42.939998626709, 0.749444356837915, -70.8933334350586, -1.23732208615595, 218, 36, 'PPL', 'P'),
(152335, 'Sanborn', 43.1366691589355, 0.752876905166918, -78.8850021362305, -1.37680301771998, 218, 40, 'PPL', 'P'),
(166850, 'Sanborn', 40.9011116027832, 0.713859065194222, -78.3974990844727, -1.36829448435329, 218, 45, 'PPL', 'P'),
(176258, 'Sanborn', 46.4330596923828, 0.810409773407145, -90.9086074829102, -1.58665451897994, 218, 57, 'PPL', 'P'),
(184897, 'Sanborn', 35.000560760498, 0.610875025315021, -118.105560302734, -2.06133089219543, 218, 6, 'PPL', 'P'),
(199666, 'Sanborn', 40.0536117553711, 0.699067402446731, -102.019721984863, -1.78058005060511, 218, 35, 'PPL', 'P'),
(200187, 'Sanborn (historical)', 40.2924995422363, 0.703236780870332, -118.34806060791, -2.06556332095783, 218, 39, 'PPL', 'P'),
(128733, 'Sanborn Corner', 44.8786087036133, 0.783279485592236, -69.334716796875, -1.21011909404329, 218, 26, 'PPL', 'P'),
(144412, 'Sanborn Corners', 42.935001373291, 0.749357138312215, -70.8916702270508, -1.23729305770007, 218, 36, 'PPL', 'P'),
(144413, 'Sanbornton', 43.4891700744629, 0.759029206759165, -71.5827789306641, -1.24935518006731, 218, 36, 'PPL', 'P'),
(144415, 'Sanbornville', 43.5541687011719, 0.760163646804511, -71.0313873291016, -1.2397315811522, 218, 36, 'PPL', 'P'),
(106018, 'Sanburne Park', 37.5208282470703, 0.654861990986669, -77.3375015258789, -1.34979403689273, 218, 53, 'PPL', 'P'),
(17957, 'Sancassa', 26.9341697692871, 0.470089943765182, -82.3019409179688, -1.4364398498004, 218, 12, 'PPL', 'P'),
(179079, 'Sanchez', 32.8694381713867, 0.573679919371403, -109.542221069336, -1.91187242760742, 218, 5, 'PPL', 'P'),
(189486, 'Sanchez', 35.6272201538086, 0.621812295016841, -104.422782897949, -1.82252137566444, 218, 38, 'PPL', 'P'),
(97819, 'Sanchez Addition Colonia', 27.7399997711182, 0.484154330508485, -98.0869979858398, -1.71194106824995, 218, 51, 'PPL', 'P'),
(192166, 'Sanchez Colonia', 31.507999420166, 0.549918330598361, -106.166999816895, -1.85296370376903, 218, 51, 'PPL', 'P'),
(189488, 'Sanchez Place', 34.625560760498, 0.604330040620043, -106.291938781738, -1.85514430006958, 218, 38, 'PPL', 'P'),
(97820, 'Sanchez Ranch Colonia', 26.0960006713867, 0.455461133318349, -98.2249984741211, -1.71434963113982, 218, 51, 'PPL', 'P'),
(111269, 'Sancho (historical)', 39.4324989318848, 0.688226938650536, -80.9277801513672, -1.41245621997147, 218, 58, 'PPL', 'P'),
(192167, 'Sanco', 32.0083312988281, 0.558650769233704, -100.523612976074, -1.75446802243299, 218, 51, 'PPL', 'P'),
(97821, 'Sanctuary', 32.9086112976074, 0.574363619402253, -97.5838928222656, -1.7031602266618, 218, 51, 'PPL', 'P'),
(192168, 'Sand', 32.7041702270508, 0.570795449594738, -102.171943664551, -1.78323682010857, 218, 51, 'PPL', 'P'),
(117672, 'Sand Bar Beach Resort and Trailer Court', 43.4874992370605, 0.759000045145229, -95.0541687011719, -1.65900821158159, 218, 16, 'PPL', 'P'),
(28527, 'Sand Barrens', 38.5900001525879, 0.673522561007773, -87.6938934326172, -1.5305471742922, 218, 18, 'PPL', 'P'),
(176260, 'Sand Bay', 46.9458312988281, 0.819359326250357, -90.8908309936523, -1.58634426071294, 218, 57, 'PPL', 'P'),
(128734, 'Sand Beach', 44.5958290100098, 0.778344048881074, -68.5697174072266, -1.19676733591817, 218, 26, 'PPL', 'P'),
(157527, 'Sand Beach', 41.6097183227539, 0.726226585559468, -83.095832824707, -1.45029587747792, 218, 41, 'PPL', 'P'),
(166851, 'Sand Beach', 40.3086090087891, 0.703517944102417, -76.6686096191406, -1.3381196707802, 218, 45, 'PPL', 'P'),
(24636, 'Sand Bed', 32.4566688537598, 0.566475735727602, -83.6183319091797, -1.45941520684062, 218, 13, 'PPL', 'P'),
(872, 'Sand Bluff', 34.127498626709, 0.595637216505915, -95.7991714477539, -1.67201096244585, 218, 42, 'PPL', 'P'),
(146257, 'Sand Brook', 40.4691696166992, 0.706320255359453, -74.9172210693359, -1.30755217410438, 218, 37, 'PPL', 'P'),
(33889, 'Sand Burr Hill', 37.5705604553223, 0.655729981764953, -97.3125, -1.69842352834698, 218, 20, 'PPL', 'P'),
(184898, 'Sand Canyon', 35.3074989318848, 0.61623210700577, -118.427780151367, -2.06695468946935, 218, 6, 'PPL', 'P'),
(184899, 'Sand City', 36.6172218322754, 0.639091083906356, -121.847221374512, -2.12663519739164, 218, 6, 'PPL', 'P'),
(189489, 'Sand Corner', 35.0980606079102, 0.612576718672555, -108.328330993652, -1.89068604902945, 218, 38, 'PPL', 'P'),
(197473, 'Sand Coulee', 47.3994407653809, 0.827276304959917, -111.166938781738, -1.94022910110431, 218, 31, 'PPL', 'P'),
(33890, 'Sand Creek', 38.0333290100098, 0.663806816718946, -97.3694381713867, -1.69941728690775, 218, 20, 'PPL', 'P'),
(77172, 'Sand Creek', 36.8402786254883, 0.642984159366861, -98.0194396972656, -1.71076195367732, 218, 42, 'PPL', 'P'),
(132991, 'Sand Creek', 41.8258285522461, 0.729998420611347, -84.1016693115234, -1.46785103590956, 218, 27, 'PPL', 'P'),
(176261, 'Sand Creek', 45.1669387817383, 0.788311794788049, -91.6861114501953, -1.60022452315638, 218, 57, 'PPL', 'P'),
(197474, 'Sand Creek (historical)', 47.8405609130859, 0.834975303934254, -105.661666870117, -1.84414398002896, 218, 31, 'PPL', 'P'),
(209721, 'Sand Creek Crossing', 44.413890838623, 0.775168628755318, -104.095558166504, -1.81681022670677, 218, 59, 'PPL', 'P'),
(5634, 'Sand Cut', 31.3180599212646, 0.546603260962944, -87.1208267211914, -1.52054527334425, 218, 2, 'PPL', 'P'),
(17959, 'Sand Cut', 26.9130592346191, 0.469721495428369, -80.6125030517578, -1.40695359652715, 218, 12, 'PPL', 'P'),
(68508, 'Sand Dollar Shores', 36.1555595397949, 0.631033556870267, -75.7416687011719, -1.32194149979019, 218, 33, 'PPL', 'P'),
(209722, 'Sand Draw', 42.7605590820313, 0.746312545975009, -108.18083190918, -1.88811170436173, 218, 59, 'PPL', 'P'),
(14546, 'Sand Dunes Village', 38.7566719055176, 0.676431531866466, -75.1805572509766, -1.31214825751364, 218, 10, 'PPL', 'P'),
(97826, 'Sand Flat', 32.4873085021973, 0.56701049847449, -95.280517578125, -1.66295874474261, 218, 51, 'PPL', 'P'),
(97824, 'Sand Flats', 31.548059463501, 0.550617510253048, -95.8111114501953, -1.67221935480115, 218, 51, 'PPL', 'P'),
(74203, 'Sand Fork', 38.7088890075684, 0.675597562971108, -82.3886108398438, -1.43795252529956, 218, 41, 'PPL', 'P'),
(111271, 'Sand Fork', 38.913890838623, 0.67917551989563, -80.75, -1.40935337098542, 218, 58, 'PPL', 'P'),
(11791, 'Sand Gap', 35.7208290100098, 0.623446077766577, -93.095832824707, -1.62482880267735, 218, 4, 'PPL', 'P'),
(11792, 'Sand Hill', 35.0086097717285, 0.611015507062523, -91.4347229003906, -1.59583696526048, 218, 4, 'PPL', 'P'),
(14547, 'Sand Hill', 38.7319412231445, 0.675999900032792, -75.3605575561523, -1.31528985549355, 218, 10, 'PPL', 'P'),
(17960, 'Sand Hill', 30.8369407653809, 0.538206147598356, -86.190559387207, -1.50430904544247, 218, 12, 'PPL', 'P'),
(24639, 'Sand Hill', 31.1111106872559, 0.542991315445011, -82.539436340332, -1.44058492687905, 218, 13, 'PPL', 'P'),
(38091, 'Sand Hill', 37.1049995422363, 0.647604410963013, -86.3858337402344, -1.5077172258475, 218, 21, 'PPL', 'P'),
(61657, 'Sand Hill', 32.4874992370605, 0.567013827425852, -89.8802795410156, -1.56870681060362, 218, 30, 'PPL', 'P'),
(68509, 'Sand Hill', 35.5525016784668, 0.620508211610056, -82.6308288574219, -1.44218002721396, 218, 33, 'PPL', 'P'),
(97825, 'Sand Hill', 32.771671295166, 0.571973565481961, -94.8401794433594, -1.65527339446886, 218, 51, 'PPL', 'P'),
(111273, 'Sand Hill', 39.3708305358887, 0.687150622095981, -81.4902801513672, -1.42227369701394, 218, 58, 'PPL', 'P'),
(139441, 'Sand Hill', 40.3113899230957, 0.703566480213284, -92.1277770996094, -1.60793304293162, 218, 29, 'PPL', 'P'),
(152338, 'Sand Hill', 42.3786087036133, 0.739646254292378, -75.2624969482422, -1.31357837501901, 218, 40, 'PPL', 'P'),
(157528, 'Sand Hill', 41.3613891601563, 0.721892424043419, -82.7555618286133, -1.44435702824704, 218, 41, 'PPL', 'P'),
(166852, 'Sand Hill', 40.3594398498535, 0.70440510964055, -76.4319381713867, -1.33398897477143, 218, 45, 'PPL', 'P'),
(184900, 'Sand Hill', 37.9736099243164, 0.662764522047316, -121.694442749023, -2.1239687073502, 218, 6, 'PPL', 'P'),
(61658, 'Sand Hill (historical)', 33.1972198486328, 0.579400788867056, -89.6416702270508, -1.56454229244901, 218, 30, 'PPL', 'P'),
(51198, 'Sand Hill Acres', 39.3047218322754, 0.685996807553704, -76.9311065673828, -1.34270110680346, 218, 25, 'PPL', 'P'),
(190709, 'Sand Hill Station (historical)', 39.2869415283203, 0.685686482707683, -118.422782897949, -2.06686747094365, 218, 39, 'PPL', 'P'),
(171258, 'Sand Hill Subdivision', 43.7027816772461, 0.762757432548194, -98.0458297729492, -1.71122254738785, 218, 49, 'PPL', 'P'),
(126022, 'Sand Hills', 42.2097206115723, 0.736698601018851, -70.7255630493164, -1.23439394053741, 218, 23, 'PPL', 'P'),
(146260, 'Sand Hills', 41.1919403076172, 0.718934983652886, -74.5091705322266, -1.30043034871729, 218, 37, 'PPL', 'P'),
(195583, 'Sand Hollow', 43.8077812194824, 0.764590020273305, -116.748062133789, -2.03763807955754, 218, 17, 'PPL', 'P'),
(97827, 'Sand Lake', 32.4294395446777, 0.566000494631077, -96.4925003051758, -1.68411183380695, 218, 51, 'PPL', 'P'),
(132993, 'Sand Lake', 43.2919387817383, 0.755586871313156, -85.5177764892578, -1.49256676872215, 218, 27, 'PPL', 'P'),
(152339, 'Sand Lake', 42.6372184753418, 0.744159846286871, -73.5411071777344, -1.2835344558135, 218, 40, 'PPL', 'P'),
(176263, 'Sand Lake', 45.3683280944824, 0.791826701373763, -92.5583267211914, -1.61544755142144, 218, 57, 'PPL', 'P'),
(5636, 'Sand Landing', 30.9236106872559, 0.539718823097521, -87.9649963378906, -1.53527881260095, 218, 2, 'PPL', 'P'),
(38092, 'Sand Lick', 38.2427787780762, 0.667462404789243, -84.7180633544922, -1.47860914144904, 218, 21, 'PPL', 'P'),
(5637, 'Sand Lick (historical)', 34.5972213745117, 0.603835425026588, -87.7936096191406, -1.53228755006457, 218, 2, 'PPL', 'P'),
(179083, 'Sand Mill', 34.0777816772461, 0.59476949204374, -112.74333190918, -1.96774235148397, 218, 5, 'PPL', 'P'),
(5638, 'Sand Mountain', 32.8547210693359, 0.573423057484264, -86.9124984741211, -1.51690925950796, 218, 2, 'PPL', 'P'),
(90596, 'Sand Mountain (historical)', 35.1027793884277, 0.612659076929265, -88.2180633544922, -1.53969566526884, 218, 50, 'PPL', 'P'),
(200188, 'Sand Pass', 40.2616691589355, 0.702698689172081, -119.778327941895, -2.09052619511958, 218, 39, 'PPL', 'P'),
(79088, 'Sand Patch', 39.7980613708496, 0.694607206832094, -78.9730606079102, -1.37833992798507, 218, 45, 'PPL', 'P'),
(61659, 'Sand Point', 32.0880584716797, 0.56004227090327, -89.460563659668, -1.56138138655119, 218, 30, 'PPL', 'P'),
(77173, 'Sand Point', 33.9644393920898, 0.592791295986029, -96.5622177124023, -1.68532863210901, 218, 42, 'PPL', 'P'),
(152341, 'Sand Point', 42.8338890075684, 0.747592394615874, -77.70361328125, -1.35618389245421, 218, 40, 'PPL', 'P'),
(212132, 'Sand Point', 55.3397216796875, 0.965860350447834, -160.497222900391, -2.80120497991906, 218, 1, 'PPL', 'P'),
(176266, 'Sand Prairie', 43.2052803039551, 0.754074395551073, -90.6113891601563, -1.58146708065063, 218, 57, 'PPL', 'P'),
(485, 'Sand Ridge', 37.9025001525879, 0.661523422400312, -87.1686096191406, -1.5213792422396, 218, 19, 'PPL', 'P'),
(11793, 'Sand Ridge', 35.2930603027344, 0.615980105387621, -93.5791702270508, -1.63326463174629, 218, 4, 'PPL', 'P'),
(24640, 'Sand Ridge', 33.3888893127441, 0.582746052091332, -82.1105575561523, -1.43309958000317, 218, 13, 'PPL', 'P'),
(83474, 'Sand Ridge', 33.8163909912109, 0.59020736393838, -79.0919418334961, -1.38041479679035, 218, 48, 'PPL', 'P'),
(90597, 'Sand Ridge', 35.6791687011719, 0.622718968209958, -88.4797210693359, -1.54426245390611, 218, 50, 'PPL', 'P'),
(97829, 'Sand Ridge', 29.4180603027344, 0.513442011832955, -96.2519378662109, -1.67991322719039, 218, 51, 'PPL', 'P'),
(111274, 'Sand Ridge', 38.8016700744629, 0.677216898071931, -81.0669403076172, -1.41488502288562, 218, 58, 'PPL', 'P'),
(121359, 'Sand Ridge', 41.4238891601563, 0.722983254825915, -88.3263931274414, -1.54158637648474, 218, 18, 'PPL', 'P'),
(152342, 'Sand Ridge', 43.2558288574219, 0.754956634241189, -76.2305603027344, -1.3304742679228, 218, 40, 'PPL', 'P'),
(132994, 'Sand River', 46.4905586242676, 0.811413319084915, -87.1155624389648, -1.52045339428664, 218, 27, 'PPL', 'P'),
(5639, 'Sand Rock', 34.2427787780762, 0.59764923470947, -85.7686080932617, -1.49694460608007, 218, 2, 'PPL', 'P'),
(74204, 'Sand Run', 39.5149993896484, 0.689666843272915, -82.2375030517578, -1.43531519687206, 218, 41, 'PPL', 'P'),
(111275, 'Sand Run', 38.9230613708496, 0.679335575877143, -80.1244430541992, -1.39843534262248, 218, 58, 'PPL', 'P'),
(74205, 'Sand Run Junction', 39.5177803039551, 0.689715379383782, -82.2613906860352, -1.43573211474071, 218, 41, 'PPL', 'P'),
(33891, 'Sand Spring', 38.9069404602051, 0.679054212907976, -97.2836074829102, -1.69791925879458, 218, 20, 'PPL', 'P'),
(51199, 'Sand Spring', 39.6725006103516, 0.692415758150095, -79.459716796875, -1.38683368080771, 218, 25, 'PPL', 'P'),
(166853, 'Sand Spring', 41.0622215270996, 0.716670963831182, -75.9641723632813, -1.32582492129174, 218, 45, 'PPL', 'P'),
(5640, 'Sand Spring (historical)', 34.9194412231445, 0.609459222300508, -86.8447189331055, -1.51572628335175, 218, 2, 'PPL', 'P'),
(24641, 'Sand Springs', 34.3227806091309, 0.599045530068998, -85.1725006103516, -1.48654056780751, 218, 13, 'PPL', 'P'),
(38094, 'Sand Springs', 37.2969398498535, 0.650954401298223, -84.3591690063477, -1.47234525340712, 218, 21, 'PPL', 'P'),
(77174, 'Sand Springs', 36.139720916748, 0.630757120749117, -96.1086120605469, -1.67741171997847, 218, 42, 'PPL', 'P'),
(90599, 'Sand Springs', 36.1300010681152, 0.630587477387679, -85.3405609130859, -1.48947377343213, 218, 50, 'PPL', 'P'),
(117674, 'Sand Springs', 42.3175010681152, 0.738579724854828, -91.1891708374023, -1.59155127327627, 218, 16, 'PPL', 'P'),
(179082, 'Sand Springs', 35.7188911437988, 0.623412255620733, -110.932502746582, -1.93613742040551, 218, 5, 'PPL', 'P'),
(189490, 'Sand Springs', 35.4722213745117, 0.619107055981538, -103.282783508301, -1.80262463284435, 218, 38, 'PPL', 'P'),
(192169, 'Sand Springs', 32.2825012207031, 0.563435937080358, -101.350563049316, -1.76890102396068, 218, 51, 'PPL', 'P'),
(197475, 'Sand Springs', 47.100830078125, 0.822064565285659, -107.485000610352, -1.87596715715875, 218, 31, 'PPL', 'P'),
(190710, 'Sand Springs (historical)', 39.2752799987793, 0.685482950621373, -118.412216186523, -2.06668304703816, 218, 39, 'PPL', 'P'),
(42963, 'Sand Spur', 31.579439163208, 0.551165189331223, -92.413330078125, -1.61291688259559, 218, 22, 'PPL', 'P'),
(90598, 'Sand Switch', 35.2216682434082, 0.614734078892601, -85.8783264160156, -1.49885955206189, 218, 50, 'PPL', 'P'),
(42964, 'Sandager', 29.9572200775146, 0.522852125097181, -91.7222213745117, -1.60085476022835, 218, 22, 'PPL', 'P'),
(17961, 'Sandalfoot Cove', 26.3388900756836, 0.459700353141537, -80.1877822875977, -1.39954082079097, 218, 12, 'PPL', 'P'),
(57415, 'Sandals', 39.4605598449707, 0.688716693975002, -94.083610534668, -1.64206877599398, 218, 29, 'PPL', 'P'),
(51204, 'Sandalwood', 39.1561088562012, 0.683403021810021, -76.70361328125, -1.33873059993426, 218, 25, 'PPL', 'P'),
(112262, 'Sandalwood', 30.3174991607666, 0.529140181325995, -81.5177764892578, -1.42275359864237, 218, 12, 'PPL', 'P'),
(179084, 'Sandalwood', 33.6283302307129, 0.586925084473884, -111.997779846191, -1.95473001323979, 218, 5, 'PPL', 'P'),
(90600, 'Sandalwood Village', 35.1936111450195, 0.614244390147162, -85.2127838134766, -1.4872436423353, 218, 50, 'PPL', 'P'),
(184902, 'Sandberg', 34.7411117553711, 0.606346785934532, -118.708610534668, -2.07185610429758, 218, 6, 'PPL', 'P'),
(31067, 'Sandborn', 38.8963890075684, 0.678870055318597, -87.1866683959961, -1.52169442735462, 218, 19, 'PPL', 'P'),
(106021, 'Sandbridge Beach', 36.7458305358887, 0.64133572923113, -75.9444427490234, -1.32548057456279, 218, 53, 'PPL', 'P'),
(28530, 'Sandburn', 37.5091705322266, 0.654658525479387, -88.8422164916992, -1.55058919254976, 218, 18, 'PPL', 'P'),
(157529, 'Sandburr Corners', 41.610279083252, 0.726236372676474, -83.7377777099609, -1.46149992934194, 218, 41, 'PPL', 'P'),
(38095, 'Sandclift', 36.6241683959961, 0.639212324314982, -84.9911117553711, -1.48337473506168, 218, 21, 'PPL', 'P'),
(31068, 'Sandcut', 39.5647201538086, 0.690534634314117, -87.3236083984375, -1.52408448127491, 218, 19, 'PPL', 'P'),
(38096, 'Sandefur Crossing', 37.415828704834, 0.653029403261559, -86.8324966430664, -1.51551296414843, 218, 21, 'PPL', 'P'),
(42965, 'Sandel', 31.3808307647705, 0.547698818856376, -93.436393737793, -1.6307727119143, 218, 22, 'PPL', 'P'),
(68511, 'Sanderling', 36.2158317565918, 0.632085505500849, -75.7677764892578, -1.3223971666527, 218, 33, 'PPL', 'P'),
(11797, 'Sanders', 33.4805603027344, 0.584346012695224, -93.3572235107422, -1.62939093078271, 218, 4, 'PPL', 'P'),
(24643, 'Sanders', 32.8241691589355, 0.572889826055003, -83.5997161865234, -1.45909030118763, 218, 13, 'PPL', 'P'),
(31069, 'Sanders', 39.079719543457, 0.6820697767893, -86.5133285522461, -1.50994243009631, 218, 19, 'PPL', 'P'),
(38097, 'Sanders', 38.6552810668945, 0.674661927901136, -84.9472198486328, -1.48260867677412, 218, 21, 'PPL', 'P'),
(77176, 'Sanders', 36.8147201538086, 0.642538079884273, -95.4494400024414, -1.66590699722739, 218, 42, 'PPL', 'P'),
(179085, 'Sanders', 35.2163887023926, 0.614641933518884, -109.333061218262, -1.90822189954319, 218, 5, 'PPL', 'P'),
(184903, 'Sanders', 39.2027816772461, 0.684217616208449, -121.660827636719, -2.12338201296205, 218, 6, 'PPL', 'P'),
(195585, 'Sanders', 47.1063919067383, 0.822161637507393, -116.795280456543, -2.03846219475686, 218, 17, 'PPL', 'P'),
(197476, 'Sanders', 46.291389465332, 0.807937161493061, -107.09610748291, -1.86917969164652, 218, 31, 'PPL', 'P'),
(11796, 'Sanders (historical)', 34.3375015258789, 0.599302458535164, -93.0416717529297, -1.62388351364843, 218, 4, 'PPL', 'P'),
(83475, 'Sanders (historical)', 32.9644393920898, 0.575338003466086, -81.2986068725586, -1.41892836721064, 218, 48, 'PPL', 'P'),
(17962, 'Sanders Beach', 30.3994407653809, 0.530570332120881, -87.2380599975586, -1.52259138000975, 218, 12, 'PPL', 'P'),
(83476, 'Sanders Corner', 34.0027809143066, 0.593460481788939, -80.5408325195313, -1.40570270976314, 218, 48, 'PPL', 'P'),
(90601, 'Sanders Crossing', 35.2816696166992, 0.615781300412247, -85.7480621337891, -1.49658601143929, 218, 50, 'PPL', 'P'),
(5641, 'Sanders Hill', 31.7052803039551, 0.553361531571725, -86.0363922119141, -1.50161832063511, 218, 2, 'PPL', 'P'),
(17963, 'Sanders Park', 26.2544403076172, 0.458226426636233, -80.1327819824219, -1.39858088437605, 218, 12, 'PPL', 'P'),
(51200, 'Sanders Park', 39.1474990844727, 0.683252752945514, -76.5019378662109, -1.33521069992151, 218, 25, 'PPL', 'P'),
(74206, 'Sanders Subdivision', 38.8013916015625, 0.677212037802941, -82.227783203125, -1.43514555351062, 218, 41, 'PPL', 'P'),
(83477, 'Sanders Subdivision', 33.9091682434082, 0.591826632460175, -80.4124984741211, -1.40346285812833, 218, 48, 'PPL', 'P'),
(126023, 'Sandersdale', 42.0694389343262, 0.734250223870686, -72.0124969482422, -1.25685517432919, 218, 23, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(17964, 'Sanderson', 30.2519397735596, 0.527995954163642, -82.273063659668, -1.4359358465641, 218, 12, 'PPL', 'P'),
(111276, 'Sanderson', 38.3644409179688, 0.669585809705391, -81.3683319091797, -1.42014529867075, 218, 58, 'PPL', 'P'),
(192170, 'Sanderson', 30.142219543457, 0.526080974892307, -102.393608093262, -1.78710559422413, 218, 51, 'PPL', 'P'),
(172497, 'Sanderson Corner', 44.6711082458496, 0.779657919404864, -72.9741668701172, -1.27363948078331, 218, 55, 'PPL', 'P'),
(128737, 'Sanderson Corners', 44.4288902282715, 0.775430417490472, -70.0530624389648, -1.22265659066511, 218, 26, 'PPL', 'P'),
(24644, 'Sandersville', 32.9813919067383, 0.575633880663194, -82.8102798461914, -1.44531203781394, 218, 13, 'PPL', 'P'),
(28531, 'Sandersville', 39.6116714477539, 0.691354088981535, -89.1597213745117, -1.55613069814599, 218, 18, 'PPL', 'P'),
(38098, 'Sandersville', 38.0875015258789, 0.664752305484951, -84.5197219848633, -1.4751474315061, 218, 21, 'PPL', 'P'),
(61661, 'Sandersville', 31.7863903045654, 0.55477716813867, -89.0322189331055, -1.55390536073912, 218, 30, 'PPL', 'P'),
(17965, 'Sandestin', 30.3797206878662, 0.530226151839502, -86.3302764892578, -1.5067475688946, 218, 12, 'PPL', 'P'),
(5642, 'Sandfield', 31.9058303833008, 0.556861790771443, -85.8077774047852, -1.4976282395319, 218, 2, 'PPL', 'P'),
(24645, 'Sandfly', 31.9894409179688, 0.558321069890752, -81.0763931274414, -1.41505000571516, 218, 13, 'PPL', 'P'),
(31070, 'Sandford', 39.545280456543, 0.690195347591241, -87.5305633544922, -1.52769652666138, 218, 19, 'PPL', 'P'),
(152343, 'Sandfordville', 44.7319412231445, 0.780719655152452, -74.8997192382813, -1.30724670952735, 218, 40, 'PPL', 'P'),
(5643, 'Sandfort', 32.3380584716797, 0.564405594033256, -85.2233276367188, -1.48742766676662, 218, 2, 'PPL', 'P'),
(38099, 'Sandgap', 37.4861106872559, 0.654256055259649, -84.0905609130859, -1.4676571577822, 218, 21, 'PPL', 'P'),
(172498, 'Sandgate', 43.1480598449707, 0.753075710142293, -73.1994400024414, -1.27757123865865, 218, 55, 'PPL', 'P'),
(51201, 'Sandgates', 38.4127807617188, 0.670429499138728, -76.6155624389648, -1.33719382282723, 218, 25, 'PPL', 'P'),
(74207, 'Sandhill', 39.3788909912109, 0.687291303580564, -81.3877792358398, -1.42048471855168, 218, 41, 'PPL', 'P'),
(90604, 'Sandhill', 36.0219383239746, 0.628701426703685, -86.5422210693359, -1.51044669964872, 218, 50, 'PPL', 'P'),
(111278, 'Sandhill', 39.2533302307129, 0.685099854898565, -81.2644424438477, -1.41833208544257, 218, 58, 'PPL', 'P'),
(166855, 'Sandhill', 40.9447212219238, 0.714620196633767, -75.307502746582, -1.31436387438253, 218, 45, 'PPL', 'P'),
(192171, 'Sandhill', 33.9933280944824, 0.593295498959408, -101.47917175293, -1.77114566928545, 218, 51, 'PPL', 'P'),
(128735, 'Sandhill Corner', 44.3097190856934, 0.773350488679121, -69.458610534668, -1.21228144769037, 218, 26, 'PPL', 'P'),
(97831, 'Sandia', 28.0222206115723, 0.489080013392155, -97.8791732788086, -1.70831384284526, 218, 51, 'PPL', 'P'),
(184904, 'Sandia', 32.8855590820313, 0.573961282340569, -115.404998779297, -2.01419720195877, 218, 6, 'PPL', 'P'),
(189491, 'Sandia', 34.8252792358398, 0.60781578559182, -106.83805847168, -1.86467588676903, 218, 38, 'PPL', 'P'),
(97832, 'Sandia Gardens Colonia', 28.0219993591309, 0.489076151808574, -97.8740005493164, -1.70822356168431, 218, 51, 'PPL', 'P'),
(189492, 'Sandia Heights', 35.1769409179688, 0.613953439798071, -106.490829467773, -1.85861559739245, 218, 38, 'PPL', 'P'),
(189493, 'Sandia Knolls', 35.163890838623, 0.613725672945842, -106.310829162598, -1.85547399941254, 218, 38, 'PPL', 'P'),
(97833, 'Sandia Mobile Home Park Colonia', 28.0270004272461, 0.489163436913302, -97.818000793457, -1.70724618156425, 218, 51, 'PPL', 'P'),
(189494, 'Sandia Park', 35.167781829834, 0.613793583553639, -106.36499786377, -1.85641942159951, 218, 38, 'PPL', 'P'),
(189495, 'Sandia Pueblo', 35.2558288574219, 0.615330294081642, -106.571388244629, -1.86002161328995, 218, 38, 'PPL', 'P'),
(189497, 'Sandia Vista', 35.0847206115723, 0.612343891814255, -106.52278137207, -1.85917326332471, 218, 38, 'PPL', 'P'),
(106030, 'Sandidges', 37.663890838623, 0.6573589042457, -79.1399993896484, -1.38125355937567, 218, 53, 'PPL', 'P'),
(11798, 'Sandiff', 35.6477813720703, 0.622171155973729, -92.2230606079102, -1.60959605387432, 218, 4, 'PPL', 'P'),
(126028, 'Sandisfield', 42.1124992370605, 0.735001767930307, -73.1436080932617, -1.27659678801579, 218, 23, 'PPL', 'P'),
(97834, 'Sandjack', 30.639440536499, 0.534759118330926, -93.7074966430664, -1.63550435022304, 218, 51, 'PPL', 'P'),
(201531, 'Sandlake', 45.3033294677734, 0.790692261328417, -123.922218322754, -2.1628507261073, 218, 43, 'PPL', 'P'),
(83479, 'Sandlewood', 33.5505599975586, 0.585567737845298, -81.9138870239258, -1.42966703167416, 218, 48, 'PPL', 'P'),
(90603, 'Sandlick', 36.3963890075684, 0.635236824018739, -83.6819381713867, -1.46052534554102, 218, 50, 'PPL', 'P'),
(111277, 'Sandlick', 37.339168548584, 0.651691431129903, -81.2202835083008, -1.4175613666231, 218, 58, 'PPL', 'P'),
(192172, 'Sandlin', 33.2331886291504, 0.580028562515015, -100.114921569824, -1.74733501176932, 218, 51, 'PPL', 'P'),
(28532, 'Sandoval', 38.6155586242676, 0.673968640490361, -89.1141662597656, -1.55533561140255, 218, 18, 'PPL', 'P'),
(97836, 'Sandoval', 30.6399993896484, 0.534768872158418, -97.290283203125, -1.69803577209227, 218, 51, 'PPL', 'P'),
(97835, 'Sandow', 30.5644397735596, 0.533450108076125, -97.0725021362305, -1.69423477542645, 218, 51, 'PPL', 'P'),
(144416, 'Sandown', 42.9286117553711, 0.749245618441568, -71.1875, -1.24245626126346, 218, 36, 'PPL', 'P'),
(187321, 'Sandown', 39.7724990844727, 0.694161060770478, -104.900833129883, -1.8308649262016, 218, 7, 'PPL', 'P'),
(24646, 'Sandown Creek', 33.3891716003418, 0.582750978939349, -84.5552825927734, -1.47576808119814, 218, 13, 'PPL', 'P'),
(184905, 'Sandoz', 38.3480606079102, 0.66929991936237, -120.429443359375, -2.10189030296511, 218, 6, 'PPL', 'P'),
(184906, 'Sandpiper Mobile Home Park', 34.4091682434082, 0.600553278720147, -119.540000915527, -2.08636660381299, 218, 6, 'PPL', 'P'),
(195584, 'Sandpoint', 48.276668548584, 0.842586818066783, -116.552223205566, -2.03422004545647, 218, 17, 'PPL', 'P'),
(42966, 'Sandra', 33.0033302307129, 0.57601677664892, -94.0127792358398, -1.64083253661596, 218, 22, 'PPL', 'P'),
(205665, 'Sandra Way', 40.6122207641602, 0.708816968881402, -111.883613586426, -1.95273743611219, 218, 52, 'PPL', 'P'),
(51202, 'Sandridge', 39.1330604553223, 0.683000751327365, -76.7344436645508, -1.33926869163251, 218, 25, 'PPL', 'P'),
(83481, 'Sandridge', 34.2458305358887, 0.597702497931272, -79.720832824707, -1.39139101522311, 218, 48, 'PPL', 'P'),
(142946, 'Sandridge', 42.5563888549805, 0.742749103278429, -99.9491729736328, -1.74444215303522, 218, 35, 'PPL', 'P'),
(79090, 'Sandrock', 39.7449989318848, 0.693681092563019, -80.4000015258789, -1.40324474523505, 218, 45, 'PPL', 'P'),
(68516, 'Sands', 36.2508316040039, 0.632696368075885, -81.6483306884766, -1.42503219927104, 218, 33, 'PPL', 'P'),
(121361, 'Sands', 41.7511100769043, 0.728694337204563, -89.8619384765625, -1.56838669864059, 218, 18, 'PPL', 'P'),
(132995, 'Sands', 46.4208297729492, 0.810196321045776, -87.4066696166992, -1.52553417301429, 218, 27, 'PPL', 'P'),
(184907, 'Sands', 35.0152816772461, 0.611131953781187, -115.941940307617, -2.02356859951865, 218, 6, 'PPL', 'P'),
(189499, 'Sands', 35.4049987792969, 0.617933800363304, -105.490829467773, -1.8411623048725, 218, 38, 'PPL', 'P'),
(195586, 'Sands (historical)', 43.4888916015625, 0.759024346490176, -116.913887023926, -2.04053226987218, 218, 17, 'PPL', 'P'),
(146261, 'Sands Point', 40.3263893127441, 0.703828268948439, -74.0036087036133, -1.29160663023558, 218, 37, 'PPL', 'P'),
(152344, 'Sands Point', 40.8516693115234, 0.712996134422009, -73.7191696166992, -1.28664223164757, 218, 40, 'PPL', 'P'),
(142947, 'Sands Trailer Park', 41.0699996948242, 0.716806718467749, -95.9233322143555, -1.67417797662485, 218, 35, 'PPL', 'P'),
(184908, 'Sandspur (historical)', 36.399169921875, 0.635285360129606, -119.03360748291, -2.07752837110334, 218, 6, 'PPL', 'P'),
(106022, 'Sandston', 37.5233306884766, 0.654905666828547, -77.3161087036133, -1.3494206617079, 218, 53, 'PPL', 'P'),
(106023, 'Sandston Highland', 37.526668548584, 0.654963923477392, -77.3066711425781, -1.34925594519448, 218, 53, 'PPL', 'P'),
(57416, 'Sandstone', 37.7586097717285, 0.659012061492367, -94.2008285522461, -1.64411461634338, 218, 29, 'PPL', 'P'),
(111279, 'Sandstone', 37.7708282470703, 0.659225314116655, -80.8916702270508, -1.41182598289951, 218, 58, 'PPL', 'P'),
(132997, 'Sandstone', 42.2519416809082, 0.737435497692476, -84.5177764892578, -1.4751134762022, 218, 27, 'PPL', 'P'),
(137981, 'Sandstone', 46.1311111450195, 0.805139777084042, -92.8672180175781, -1.62083872157414, 218, 28, 'PPL', 'P'),
(74208, 'Sandstone (historical)', 39.7144393920898, 0.693147727975703, -82.5436096191406, -1.44065776433487, 218, 41, 'PPL', 'P'),
(176267, 'Sandstone Bluff', 43.8172187805176, 0.764754736786726, -88.9669418334961, -1.55276606042479, 218, 57, 'PPL', 'P'),
(74209, 'Sandstone Canyon', 39.9944381713867, 0.698034628575998, -82.5074996948242, -1.4400275272629, 218, 41, 'PPL', 'P'),
(51203, 'Sandtop', 38.607780456543, 0.673832885853794, -75.9030609130859, -1.32475832527516, 218, 25, 'PPL', 'P'),
(5645, 'Sandtown', 33.5900001525879, 0.586256098408056, -87.491943359375, -1.52702248058948, 218, 2, 'PPL', 'P'),
(11799, 'Sandtown', 35.9047203063965, 0.626655586354286, -91.6350021362305, -1.59933249734926, 218, 4, 'PPL', 'P'),
(14550, 'Sandtown', 39.0333290100098, 0.681260109238889, -75.7191696166992, -1.32154881668745, 218, 10, 'PPL', 'P'),
(24648, 'Sandtown', 33.836109161377, 0.590551510930245, -82.6877822875977, -1.44317405209083, 218, 13, 'PPL', 'P'),
(61662, 'Sandtown', 32.7947196960449, 0.572375835964618, -89.0016708374023, -1.55337219588889, 218, 30, 'PPL', 'P'),
(71354, 'Sandtown', 39.9069404602051, 0.69650750542792, -74.7886123657227, -1.30530752877961, 218, 37, 'PPL', 'P'),
(11800, 'Sandtown (historical)', 35.0897216796875, 0.612431176918982, -92.7111129760742, -1.61811417462093, 218, 4, 'PPL', 'P'),
(24649, 'Sandtown (historical)', 33.7163887023926, 0.588461994738969, -84.602783203125, -1.47659712324549, 218, 13, 'PPL', 'P'),
(166856, 'Sandts Eddy', 40.7569389343262, 0.711342777438261, -75.1916732788086, -1.31234226879905, 218, 45, 'PPL', 'P'),
(11801, 'Sandtuck (historical)', 33.4847183227539, 0.584418583834929, -92.1094436645508, -1.60761306412664, 218, 4, 'PPL', 'P'),
(97837, 'Sandune', 30.1241703033447, 0.525765956224864, -94.774169921875, -1.6541213109813, 218, 51, 'PPL', 'P'),
(5646, 'Sandusky', 33.5497207641602, 0.585553090459303, -86.9002838134766, -1.5166960734627, 218, 2, 'PPL', 'P'),
(28534, 'Sandusky', 37.2024993896484, 0.649306104320546, -89.272216796875, -1.55809411365965, 218, 18, 'PPL', 'P'),
(31071, 'Sandusky', 39.4194412231445, 0.687999038640253, -85.4780578613281, -1.4918735478904, 218, 19, 'PPL', 'P'),
(97838, 'Sandusky', 33.7661094665527, 0.589329785780171, -96.8919372558594, -1.69108332375051, 218, 51, 'PPL', 'P'),
(111280, 'Sandusky', 39.5555610656738, 0.690374778069685, -80.8591690063477, -1.41125872958732, 218, 58, 'PPL', 'P'),
(117675, 'Sandusky', 40.4644393920898, 0.706237697365661, -91.3872222900391, -1.59500792321313, 218, 16, 'PPL', 'P'),
(132999, 'Sandusky', 43.420280456543, 0.757826856106021, -82.829719543457, -1.44565132453682, 218, 27, 'PPL', 'P'),
(152347, 'Sandusky', 42.4958305358887, 0.741692161220804, -78.3847198486328, -1.36807144461199, 218, 40, 'PPL', 'P'),
(157530, 'Sandusky', 41.4488906860352, 0.723419613770525, -82.7080612182617, -1.4435279861997, 218, 41, 'PPL', 'P'),
(176268, 'Sandusky', 43.3952789306641, 0.757390497161412, -90.1519393920898, -1.57344816945034, 218, 57, 'PPL', 'P'),
(117676, 'Sandusky Mobile Home Villa', 40.4650001525879, 0.706247484482667, -91.3916702270508, -1.59508555435891, 218, 16, 'PPL', 'P'),
(106024, 'Sandusky Park', 37.4552803039551, 0.653717963561399, -79.0972213745117, -1.38050694216406, 218, 53, 'PPL', 'P'),
(179086, 'Sandwash Mill', 31.4822196960449, 0.549468389532192, -111.415283203125, -1.94456352893647, 218, 5, 'PPL', 'P'),
(121362, 'Sandwich', 41.6458282470703, 0.726856822631435, -88.6216735839844, -1.54673999266821, 218, 18, 'PPL', 'P'),
(126025, 'Sandwich', 41.7588882446289, 0.72883009184113, -70.4944381713867, -1.23036005043427, 218, 23, 'PPL', 'P'),
(144418, 'Sandwich', 43.7902793884277, 0.764284555696273, -71.4116668701172, -1.2463687112209, 218, 36, 'PPL', 'P'),
(144419, 'Sandwich Landing', 43.7849998474121, 0.764192410322556, -71.4713897705078, -1.24741107247156, 218, 36, 'PPL', 'P'),
(83483, 'Sandwood Hills', 34.2125015258789, 0.597120796970171, -80.7383270263672, -1.40914963916203, 218, 48, 'PPL', 'P'),
(11802, 'Sandy', 35.7658309936523, 0.624231510551069, -90.4358291625977, -1.57840298065844, 218, 4, 'PPL', 'P'),
(17966, 'Sandy', 27.2733306884766, 0.476009418499128, -82.1158294677734, -1.43319159221883, 218, 12, 'PPL', 'P'),
(24650, 'Sandy', 33.2350006103516, 0.58006018755296, -83.8763885498047, -1.46391914487616, 218, 13, 'PPL', 'P'),
(38100, 'Sandy', 37.3077812194824, 0.651143618893674, -87.2683334350586, -1.52311975117003, 218, 21, 'PPL', 'P'),
(77177, 'Sandy', 34.8125, 0.607592745850526, -99.9644393920898, -1.74470860230229, 218, 42, 'PPL', 'P'),
(83484, 'Sandy', 32.814998626709, 0.572729770073489, -80.083610534668, -1.39772268071477, 218, 48, 'PPL', 'P'),
(90606, 'Sandy', 36.396671295166, 0.635241750866756, -81.7900009155273, -1.42750481118513, 218, 50, 'PPL', 'P'),
(97840, 'Sandy', 31.6843795776367, 0.552996745081411, -96.6415786743164, -1.68671374219196, 218, 51, 'PPL', 'P'),
(111282, 'Sandy', 39.6352806091309, 0.691766146581197, -80.1949996948242, -1.39966678831053, 218, 58, 'PPL', 'P'),
(166857, 'Sandy', 41.107780456543, 0.717466117153653, -78.7713928222656, -1.37482016113036, 218, 45, 'PPL', 'P'),
(201532, 'Sandy', 45.3974990844727, 0.792335831195159, -122.260276794434, -2.13384437446248, 218, 43, 'PPL', 'P'),
(111283, 'Sandy (historical)', 39.269718170166, 0.68538587839964, -79.9622192382813, -1.39560400290956, 218, 58, 'PPL', 'P'),
(106025, 'Sandy Acres', 37.2999992370605, 0.651007797678079, -79.2744369506836, -1.38359993745408, 218, 53, 'PPL', 'P'),
(192173, 'Sandy Acres', 31.951940536499, 0.557666564763351, -102.076393127441, -1.78156914863396, 218, 51, 'PPL', 'P'),
(205668, 'Sandy Acres', 40.5838890075684, 0.708322486446002, -111.890830993652, -1.95286340363175, 218, 52, 'PPL', 'P'),
(152345, 'Sandy Bay', 43.2052803039551, 0.754074395551073, -76.083610534668, -1.327909510635, 218, 40, 'PPL', 'P'),
(61663, 'Sandy Bayou', 33.8541717529297, 0.590866762624283, -90.581672668457, -1.58094843002833, 218, 30, 'PPL', 'P'),
(14548, 'Sandy Beach', 38.5752792358398, 0.673265632541607, -75.2602767944336, -1.31353962602515, 218, 10, 'PPL', 'P'),
(114021, 'Sandy Beach', 41.6944389343262, 0.727705239175708, -73.2200012207031, -1.27793009961554, 218, 8, 'PPL', 'P'),
(123623, 'Sandy Beach', 40.6644401550293, 0.709728369185455, -86.7533264160156, -1.51413118301684, 218, 19, 'PPL', 'P'),
(126027, 'Sandy Beach', 42.3388900756836, 0.73895303346063, -71.9444427490234, -1.25566740448302, 218, 23, 'PPL', 'P'),
(128736, 'Sandy Beach', 44.9213905334473, 0.784026169382867, -68.8069381713867, -1.20090761930686, 218, 26, 'PPL', 'P'),
(133002, 'Sandy Beach', 41.8080596923828, 0.729688295502408, -85.5305633544922, -1.49278994162149, 218, 27, 'PPL', 'P'),
(152346, 'Sandy Beach', 43.0563888549805, 0.7514757495384, -78.9599990844727, -1.37811196139576, 218, 40, 'PPL', 'P'),
(157536, 'Sandy Beach', 40.5486106872559, 0.707706763601975, -84.4499969482422, -1.47393050004599, 218, 41, 'PPL', 'P'),
(11803, 'Sandy Bend', 33.1330604553223, 0.578280996207705, -92.4047164916992, -1.61276654715205, 218, 4, 'PPL', 'P'),
(208661, 'Sandy Bend', 46.2408294677734, 0.807054723065864, -122.912780761719, -2.14523271707394, 218, 56, 'PPL', 'P'),
(97841, 'Sandy Bluff Colonia', 27.9759998321533, 0.488273308608456, -97.8889999389648, -1.70848535041946, 218, 51, 'PPL', 'P'),
(24651, 'Sandy Bottom', 31.1908302307129, 0.544382683956523, -82.7569427490234, -1.44438112985491, 218, 13, 'PPL', 'P'),
(51206, 'Sandy Bottom', 39.1930618286133, 0.684047972847011, -76.184440612793, -1.32966932748332, 218, 25, 'PPL', 'P'),
(68513, 'Sandy Bottom', 35.8633308410645, 0.625933203908602, -82.7688903808594, -1.44458965536826, 218, 33, 'PPL', 'P'),
(106028, 'Sandy Bottom', 36.8716697692871, 0.643532038182118, -76.5449981689453, -1.33596224398113, 218, 53, 'PPL', 'P'),
(106029, 'Sandy Bottom (historical)', 37.5544395446777, 0.655448618795787, -76.3188934326172, -1.33201597187785, 218, 53, 'PPL', 'P'),
(68515, 'Sandy Bottoms', 34.7802810668945, 0.607030419386356, -79.5116729736328, -1.38774048715888, 218, 33, 'PPL', 'P'),
(14549, 'Sandy Brae', 38.7374992370605, 0.676096905675498, -75.1486129760742, -1.31159072473943, 218, 10, 'PPL', 'P'),
(90607, 'Sandy Bridge (historical)', 36.0336112976074, 0.628905158527076, -88.2755584716797, -1.54069914436758, 218, 50, 'PPL', 'P'),
(128738, 'Sandy Brook', 43.5472183227539, 0.760042339816858, -70.4886093139648, -1.23025831768063, 218, 26, 'PPL', 'P'),
(205669, 'Sandy City', 40.5916709899902, 0.708458307661596, -111.883331298828, -1.95273250926417, 218, 52, 'PPL', 'P'),
(97842, 'Sandy Colonia', 26.4869995117188, 0.462285350453623, -97.8450012207031, -1.70771742791914, 218, 51, 'PPL', 'P'),
(157537, 'Sandy Corners', 40.0800018310547, 0.69952799615726, -83.158332824707, -1.45138670826041, 218, 41, 'PPL', 'P'),
(24654, 'Sandy Creek', 33.6758308410645, 0.587754126521226, -83.5302810668945, -1.45787842973359, 218, 13, 'PPL', 'P'),
(68517, 'Sandy Creek', 34.2869415283203, 0.598420020107966, -78.1511077880859, -1.36399414498308, 218, 33, 'PPL', 'P'),
(128739, 'Sandy Creek', 44.021671295166, 0.768323106331324, -70.7083282470703, -1.23409313649229, 218, 26, 'PPL', 'P'),
(152348, 'Sandy Creek', 43.6441688537598, 0.761734445794467, -76.0863876342773, -1.32795798016684, 218, 40, 'PPL', 'P'),
(166858, 'Sandy Creek', 40.4752807617188, 0.706426914961111, -79.8486099243164, -1.39362114631994, 218, 45, 'PPL', 'P'),
(61664, 'Sandy Creek Subdivision', 34.9922218322754, 0.610729483561449, -88.2572174072266, -1.54037903240456, 218, 30, 'PPL', 'P'),
(24656, 'Sandy Cross', 33.9430618286133, 0.592418187117309, -83.0666732788086, -1.4497869473936, 218, 13, 'PPL', 'P'),
(68522, 'Sandy Cross', 36.353328704834, 0.634485279959119, -79.7458267211914, -1.39182724100966, 218, 33, 'PPL', 'P'),
(83486, 'Sandy Flat', 34.9938888549805, 0.610758578596358, -82.3450012207031, -1.43719139386002, 218, 48, 'PPL', 'P'),
(14551, 'Sandy Fork', 38.5538902282715, 0.672892323935806, -75.5325012207031, -1.31829083856791, 218, 10, 'PPL', 'P'),
(97844, 'Sandy Fork', 29.6847190856934, 0.51809608557495, -97.4169387817383, -1.70024632895509, 218, 51, 'PPL', 'P'),
(106031, 'Sandy Fork', 36.6147193908691, 0.639047408064479, -78.6094436645508, -1.37199361510741, 218, 53, 'PPL', 'P'),
(38101, 'Sandy Furnace', 38.2480583190918, 0.66755455016296, -82.7538909912109, -1.4443278666331, 218, 21, 'PPL', 'P'),
(38102, 'Sandy Gap', 37.146110534668, 0.648321933139707, -84.353889465332, -1.4722531080334, 218, 21, 'PPL', 'P'),
(68524, 'Sandy Grove', 34.9477806091309, 0.609953837893963, -79.0994415283203, -1.38054569115793, 218, 33, 'PPL', 'P'),
(184909, 'Sandy Gulch', 38.3802795410156, 0.669862245826541, -120.531669616699, -2.10367448773741, 218, 6, 'PPL', 'P'),
(152350, 'Sandy Harbour Beach', 43.3522186279297, 0.756638953101792, -77.8944396972656, -1.35951444171346, 218, 40, 'PPL', 'P'),
(205673, 'Sandy Heights South', 40.564998626709, 0.70799278710305, -111.880279541016, -1.95267924604237, 218, 52, 'PPL', 'P'),
(205674, 'Sandy Highlands', 40.5994415283203, 0.708593929140108, -111.859718322754, -1.95232038508548, 218, 52, 'PPL', 'P'),
(24657, 'Sandy Hill', 33.8627815246582, 0.591017031488791, -82.6986083984375, -1.44336300337017, 218, 13, 'PPL', 'P'),
(42967, 'Sandy Hill', 31.0288906097412, 0.541556304381135, -93.2225036621094, -1.62703962585628, 218, 22, 'PPL', 'P'),
(51208, 'Sandy Hill', 39.2999992370605, 0.685914382717966, -76.9322204589844, -1.34272054787942, 218, 25, 'PPL', 'P'),
(68525, 'Sandy Hill', 33.9691696166992, 0.592873853979822, -78.2291717529297, -1.36535661819677, 218, 33, 'PPL', 'P'),
(97843, 'Sandy Hill', 30.2777805328369, 0.528446960494247, -96.3255615234375, -1.68119820241635, 218, 51, 'PPL', 'P'),
(126029, 'Sandy Hill', 42.1541709899902, 0.735729077224007, -72.6069412231445, -1.26723018414587, 218, 23, 'PPL', 'P'),
(157538, 'Sandy Hill', 40.2919387817383, 0.703226993753326, -83.147216796875, -1.451192696975, 218, 41, 'PPL', 'P'),
(79089, 'Sandy Hill (historical)', 39.9099998474121, 0.696560901807776, -79.7736129760742, -1.39231220264417, 218, 45, 'PPL', 'P'),
(51209, 'Sandy Hill Acres', 39.0222206115723, 0.681066231111531, -76.7886123657227, -1.34021411381949, 218, 25, 'PPL', 'P'),
(157539, 'Sandy Hills Estates', 40.6813888549805, 0.710024179803535, -81.149169921875, -1.41632020039707, 218, 41, 'PPL', 'P'),
(166860, 'Sandy Hollow', 41.0080604553223, 0.715725674802259, -79.5508270263672, -1.3884238542946, 218, 45, 'PPL', 'P'),
(31072, 'Sandy Hook', 38.5683288574219, 0.673144325553954, -87.2177810668945, -1.52223744590088, 218, 19, 'PPL', 'P'),
(38103, 'Sandy Hook', 38.0863914489746, 0.664732930988021, -83.1263885498047, -1.45082917548621, 218, 21, 'PPL', 'P'),
(51210, 'Sandy Hook', 39.3258285522461, 0.686365189311489, -77.7108306884766, -1.35630985997377, 218, 25, 'PPL', 'P'),
(57417, 'Sandy Hook', 38.7483291625977, 0.676285923533866, -92.408332824707, -1.61282966406989, 218, 29, 'PPL', 'P'),
(61665, 'Sandy Hook', 31.0361099243164, 0.541682305190209, -89.8047180175781, -1.56738801323181, 218, 30, 'PPL', 'P'),
(79091, 'Sandy Hook', 39.9949989318848, 0.698044415693004, -77.7780609130859, -1.35748324875006, 218, 45, 'PPL', 'P'),
(90608, 'Sandy Hook', 35.4833297729492, 0.619300934108896, -87.2375030517578, -1.52258165947178, 218, 50, 'PPL', 'P'),
(106032, 'Sandy Hook', 37.752498626709, 0.658905401890709, -77.9127807617188, -1.35983455367649, 218, 53, 'PPL', 'P'),
(114023, 'Sandy Hook', 41.4199981689453, 0.722915344218118, -73.2825012207031, -1.27902093039803, 218, 8, 'PPL', 'P'),
(176269, 'Sandy Hook', 42.5433311462402, 0.742521203268145, -90.6100006103516, -1.58144284588471, 218, 57, 'PPL', 'P'),
(111284, 'Sandy Huff', 37.4780616760254, 0.654115573512147, -81.7752838134766, -1.42724794929799, 218, 58, 'PPL', 'P'),
(184910, 'Sandy Korner', 33.642219543457, 0.587167498712109, -116.180282592773, -2.02772845714135, 218, 6, 'PPL', 'P'),
(166861, 'Sandy Lake', 41.3486099243164, 0.721669384302125, -80.0824966430664, -1.39770323963881, 218, 45, 'PPL', 'P'),
(11804, 'Sandy Land', 33.3347206115723, 0.581800629904354, -92.7011108398438, -1.61793960441148, 218, 4, 'PPL', 'P'),
(14552, 'Sandy Landing', 38.5708312988281, 0.673188001395832, -75.1791687011719, -1.31212402274772, 218, 10, 'PPL', 'P'),
(68526, 'Sandy Landing', 35.4861106872559, 0.619349470219763, -76.688606262207, -1.33846867804105, 218, 33, 'PPL', 'P'),
(90609, 'Sandy Lane', 35.2911109924316, 0.615946083504696, -84.2861099243164, -1.47107013187719, 218, 50, 'PPL', 'P'),
(106033, 'Sandy Level', 36.5686111450195, 0.638242667362084, -79.7194366455078, -1.39136664729913, 218, 53, 'PPL', 'P'),
(51211, 'Sandy Level Estates', 38.5644416809082, 0.673076481525185, -76.8166732788086, -1.34070386914396, 218, 25, 'PPL', 'P'),
(166864, 'Sandy Lick', 40.7125015258789, 0.710567198349802, -79.7294387817383, -1.39154121750859, 218, 45, 'PPL', 'P'),
(190712, 'Sandy Mill', 35.8041687011719, 0.624900629774951, -115.60417175293, -2.01767342612965, 218, 39, 'PPL', 'P'),
(68527, 'Sandy Mush', 35.2891693115234, 0.615912194779825, -81.8447189331055, -1.42845982075203, 218, 33, 'PPL', 'P'),
(51212, 'Sandy Oaks', 39.1366691589355, 0.683063735087145, -76.5661087036133, -1.33633069231794, 218, 25, 'PPL', 'P'),
(106034, 'Sandy Pines', 36.7963905334473, 0.642218167658327, -76.4011077880859, -1.33345088307318, 218, 53, 'PPL', 'P'),
(68530, 'Sandy Plain', 36.061939239502, 0.629399574383449, -78.6966705322266, -1.37351601114455, 218, 33, 'PPL', 'P'),
(24658, 'Sandy Plains', 34.0130615234375, 0.593639912267383, -84.4955596923828, -1.47472571994749, 218, 13, 'PPL', 'P'),
(68532, 'Sandy Plains', 35.2438888549805, 0.615121901726344, -82.0897216796875, -1.43273592535632, 218, 33, 'PPL', 'P'),
(79092, 'Sandy Plains', 39.9977798461914, 0.698092951803871, -80.0294418334961, -1.39677725852779, 218, 45, 'PPL', 'P'),
(5647, 'Sandy Point', 31.7919406890869, 0.554874040623322, -85.2699966430664, -1.48824219458602, 218, 2, 'PPL', 'P'),
(17967, 'Sandy Point', 29.9088897705078, 0.522008602111413, -82.8655624389648, -1.44627690107688, 218, 12, 'PPL', 'P'),
(24659, 'Sandy Point', 32.7688903808594, 0.571925029371095, -83.9397201538086, -1.4650244898866, 218, 13, 'PPL', 'P'),
(51213, 'Sandy Point', 38.3349990844727, 0.66907195277306, -75.6616668701172, -1.32054520443066, 218, 25, 'PPL', 'P'),
(90610, 'Sandy Point', 36.0461082458496, 0.629123271420353, -88.1680603027344, -1.53882294737962, 218, 50, 'PPL', 'P'),
(97845, 'Sandy Point', 29.3852806091309, 0.512869898251778, -95.480827331543, -1.66645480946362, 218, 51, 'PPL', 'P'),
(106036, 'Sandy Point', 38.0605583190918, 0.66428205781547, -76.5336074829102, -1.33576343900575, 218, 53, 'PPL', 'P'),
(114022, 'Sandy Point', 41.348331451416, 0.721664524033135, -72.184440612793, -1.25985615740355, 218, 8, 'PPL', 'P'),
(128740, 'Sandy Point', 44.514720916748, 0.776928445603642, -68.8133316040039, -1.20101920575654, 218, 26, 'PPL', 'P'),
(166865, 'Sandy Point', 41.1647186279297, 0.718459875714416, -79.7633285522461, -1.3921327055867, 218, 45, 'PPL', 'P'),
(152351, 'Sandy Pond', 43.6358299255371, 0.761588904040895, -76.184440612793, -1.32966932748332, 218, 40, 'PPL', 'P'),
(127, 'Sandy Ridge', 37.2374992370605, 0.649916966895583, -77.5005569458008, -1.35263989083358, 218, 53, 'PPL', 'P'),
(5649, 'Sandy Ridge', 32.0244407653809, 0.558931932465789, -86.4519424438477, -1.50887104038977, 218, 2, 'PPL', 'P'),
(61666, 'Sandy Ridge', 33.7125015258789, 0.588394150710199, -90.2188873291016, -1.57461663137862, 218, 30, 'PPL', 'P'),
(68535, 'Sandy Ridge', 36.4988899230957, 0.637025802481, -80.1044387817383, -1.39808620220357, 218, 33, 'PPL', 'P'),
(90611, 'Sandy Ridge', 35.9561080932617, 0.627552472430397, -83.3763885498047, -1.45519249861619, 218, 50, 'PPL', 'P'),
(146262, 'Sandy Ridge', 40.4230613708496, 0.705515514657058, -74.9527816772461, -1.30817282379642, 218, 37, 'PPL', 'P'),
(166866, 'Sandy Ridge', 40.8147201538086, 0.712351249964046, -78.2358322143555, -1.36547286517835, 218, 45, 'PPL', 'P'),
(97846, 'Sandy Ridge Colonia', 26.3719997406006, 0.460278225808571, -98.1179962158203, -1.7124820894254, 218, 51, 'PPL', 'P'),
(24660, 'Sandy Ridge Estates', 33.5013885498047, 0.58470953418402, -84.565559387207, -1.47594744509756, 218, 13, 'PPL', 'P'),
(68536, 'Sandy Ridge Terrace', 35.6450004577637, 0.622122619862862, -80.4124984741211, -1.40346285812833, 218, 33, 'PPL', 'P'),
(83487, 'Sandy River', 34.6563911437988, 0.604868132318293, -81.3269424438477, -1.41942291622507, 218, 48, 'PPL', 'P'),
(106037, 'Sandy River', 36.7230606079102, 0.640938319017463, -79.6516723632813, -1.39018393745903, 218, 53, 'PPL', 'P'),
(128741, 'Sandy River', 44.7261085510254, 0.780617855819783, -69.8861083984375, -1.2197426929584, 218, 26, 'PPL', 'P'),
(24662, 'Sandy Run', 33.2297210693359, 0.579968042179243, -83.1283264160156, -1.45086299763205, 218, 13, 'PPL', 'P'),
(83489, 'Sandy Run', 33.3227806091309, 0.581592237549055, -80.7158279418945, -1.4087569560593, 218, 48, 'PPL', 'P'),
(166868, 'Sandy Run', 41.0194396972656, 0.715924280040551, -75.8572235107422, -1.3239583116837, 218, 45, 'PPL', 'P'),
(83490, 'Sandy Run (historical)', 33.1305618286133, 0.578237386944855, -80.1705627441406, -1.39924028306195, 218, 48, 'PPL', 'P'),
(51223, 'Sandy Run Estates', 39.5566711425781, 0.690394152566616, -77.3938903808594, -1.35077820807356, 218, 25, 'PPL', 'P'),
(51214, 'Sandy Spring', 39.1494407653809, 0.683286641670385, -77.0272216796875, -1.3443786319741, 218, 25, 'PPL', 'P'),
(51215, 'Sandy Spring Estates', 39.1027793884277, 0.682472247009039, -76.896110534668, -1.34209031080745, 218, 25, 'PPL', 'P'),
(51216, 'Sandy Spring Meadow', 39.1511116027832, 0.683315803284321, -77.0252838134766, -1.34434480982826, 218, 25, 'PPL', 'P'),
(5651, 'Sandy Springs', 34.0730590820313, 0.594687067208002, -85.498893737793, -1.49223720253725, 218, 2, 'PPL', 'P'),
(24663, 'Sandy Springs', 33.9241714477539, 0.592088487774357, -84.3786087036133, -1.47268454013, 218, 13, 'PPL', 'P'),
(61667, 'Sandy Springs', 34.4327812194824, 0.600965402898836, -88.375, -1.54243472644999, 218, 30, 'PPL', 'P'),
(68539, 'Sandy Springs', 35.2027816772461, 0.614404446128676, -81.9711074829102, -1.43066571708294, 218, 33, 'PPL', 'P'),
(74213, 'Sandy Springs', 38.6111106872559, 0.673891009344585, -83.2969436645508, -1.45380592379464, 218, 41, 'PPL', 'P'),
(83491, 'Sandy Springs', 34.5952796936035, 0.603801536301716, -82.75, -1.44425995602531, 218, 48, 'PPL', 'P'),
(90612, 'Sandy Springs', 36.4477806091309, 0.636133776673878, -87.0108337402344, -1.51862553367246, 218, 50, 'PPL', 'P'),
(205676, 'Sandy Station Original Town', 40.5902786254883, 0.708434006316649, -111.880561828613, -1.95268417289039, 218, 52, 'PPL', 'P'),
(205677, 'Sandy Station Place', 40.5877799987793, 0.708390397053799, -111.884719848633, -1.95275674403009, 218, 52, 'PPL', 'P'),
(111286, 'Sandy Summit', 38.899169921875, 0.678918591429464, -81.5077819824219, -1.42257916159097, 218, 58, 'PPL', 'P'),
(166869, 'Sandy Valley', 41.1300010681152, 0.717853939987395, -78.8866729736328, -1.37683217933392, 218, 45, 'PPL', 'P'),
(190713, 'Sandy Valley', 35.8169403076172, 0.625123536358191, -115.631393432617, -2.01814853406812, 218, 39, 'PPL', 'P'),
(106042, 'Sandybottom', 37.4130592346191, 0.652981066887774, -77.0447235107422, -1.34468409655114, 218, 53, 'PPL', 'P'),
(68541, 'Sandyfield', 34.3763885498047, 0.59998116513897, -78.2972183227539, -1.36654425488489, 218, 33, 'PPL', 'P'),
(184911, 'Sandyland', 34.4047203063965, 0.600475647574371, -119.545562744141, -2.08646367603472, 218, 6, 'PPL', 'P'),
(51217, 'Sandyland Beach', 38.2305603027344, 0.667249152164955, -76.6577835083008, -1.33793071950086, 218, 25, 'PPL', 'P'),
(184912, 'Sandyland Cove', 34.396671295166, 0.600335165826869, -119.530281066895, -2.08619696045155, 218, 6, 'PPL', 'P'),
(68540, 'Sandymush', 35.6725006103516, 0.622602588070322, -82.811393737793, -1.4453314788899, 218, 33, 'PPL', 'P'),
(31073, 'Sandytown', 39.6819381713867, 0.692580474663516, -87.4461135864258, -1.52622260015608, 218, 19, 'PPL', 'P'),
(51218, 'Sandyville', 39.5247192382813, 0.689836486634353, -76.9255599975586, -1.34260430089784, 218, 25, 'PPL', 'P'),
(111287, 'Sandyville', 38.9058303833008, 0.679034838411046, -81.6608276367188, -1.42525031216432, 218, 58, 'PPL', 'P'),
(117678, 'Sandyville', 41.3708305358887, 0.722057207135867, -93.3861083984375, -1.62989506717706, 218, 16, 'PPL', 'P'),
(157542, 'Sandyville', 40.6402816772461, 0.709306724205868, -81.3724975585938, -1.42021800296851, 218, 41, 'PPL', 'P'),
(166872, 'Sandyville', 41.1430587768555, 0.718081839997679, -75.0358276367188, -1.3096222492197, 218, 45, 'PPL', 'P'),
(188, 'Sanford', 39.5194396972656, 0.689744341260636, -80.1272201538086, -1.39848381215432, 218, 58, 'PPL', 'P'),
(5650, 'Sanford', 31.298059463501, 0.546254187123062, -86.3891677856445, -1.50777541591732, 218, 2, 'PPL', 'P'),
(17979, 'Sanford', 28.8002796173096, 0.502659704817064, -81.2733306884766, -1.41848721457607, 218, 12, 'PPL', 'P'),
(24664, 'Sanford', 31.9794406890869, 0.558146532970811, -84.9436111450195, -1.48254569301434, 218, 13, 'PPL', 'P'),
(33892, 'Sanford', 38.1805610656738, 0.666376500854763, -99.3138885498047, -1.73335434815279, 218, 20, 'PPL', 'P'),
(51219, 'Sanford', 39.0191688537598, 0.68101296788973, -77.0416717529297, -1.34463083332933, 218, 25, 'PPL', 'P'),
(61668, 'Sanford', 31.4866695404053, 0.549546053967482, -89.4269409179688, -1.560794559005, 218, 30, 'PPL', 'P'),
(68542, 'Sanford', 35.4797210693359, 0.619237950349115, -79.1805572509766, -1.38196142759341, 218, 33, 'PPL', 'P'),
(90613, 'Sanford', 35.3416709899902, 0.616828521931894, -84.7202835083008, -1.4786478904429, 218, 50, 'PPL', 'P'),
(106039, 'Sanford', 37.9249992370605, 0.661916105503044, -75.6647186279297, -1.32059846765246, 218, 53, 'PPL', 'P'),
(128743, 'Sanford', 43.4391708374023, 0.758156555448973, -70.7747192382813, -1.23525187788258, 218, 26, 'PPL', 'P'),
(133003, 'Sanford', 43.672779083252, 0.762233788498857, -84.3805618286133, -1.47271862859195, 218, 27, 'PPL', 'P'),
(152353, 'Sanford', 42.1022186279297, 0.734822337451863, -75.48388671875, -1.31744235544461, 218, 40, 'PPL', 'P'),
(166873, 'Sanford', 41.7694396972656, 0.729014249430509, -79.5361099243164, -1.38816699240746, 218, 45, 'PPL', 'P'),
(187322, 'Sanford', 37.2583312988281, 0.650280554963406, -105.904167175293, -1.84837640879137, 218, 7, 'PPL', 'P'),
(192174, 'Sanford', 35.7019386291504, 0.623116378423625, -101.534172058105, -1.77210560570037, 218, 51, 'PPL', 'P'),
(17969, 'Sanford Farms', 28.8283290863037, 0.503149260404448, -81.3411102294922, -1.41967019073228, 218, 12, 'PPL', 'P'),
(90614, 'Sanford Hill', 35.4347190856934, 0.618452517564624, -88.6530609130859, -1.54728780490444, 218, 50, 'PPL', 'P'),
(106040, 'Sanford Hill', 37.2980613708496, 0.650973975532235, -79.970832824707, -1.3957543383531, 218, 53, 'PPL', 'P'),
(5652, 'Sanford Springs', 34.0180587768555, 0.593727130793083, -85.5733337402344, -1.49353642567504, 218, 2, 'PPL', 'P'),
(42968, 'Sanfords Camp (historical)', 30.7591705322266, 0.53684880096977, -90.0569381713867, -1.57179008535566, 218, 22, 'PPL', 'P'),
(38104, 'Sanfordtown', 39.0258293151855, 0.681129214871312, -84.5369415283203, -1.47544796923512, 218, 21, 'PPL', 'P'),
(114024, 'Sanfordtown', 41.2947196960449, 0.720728822384136, -73.3627777099609, -1.28042201944752, 218, 8, 'PPL', 'P'),
(121364, 'Sanfordville (historical)', 41.9277801513672, 0.731777811693684, -89.6319427490234, -1.56437251592952, 218, 18, 'PPL', 'P'),
(28536, 'Sangamon', 39.8666687011719, 0.695804630637221, -88.855827331543, -1.55082674651899, 218, 18, 'PPL', 'P'),
(83493, 'Sangaree', 33.0352783203125, 0.576574376002155, -80.128059387207, -1.39849845954031, 218, 48, 'PPL', 'P'),
(97847, 'Sanger', 33.3630599975586, 0.582295245497809, -97.1736068725586, -1.69599938596474, 218, 51, 'PPL', 'P'),
(111290, 'Sanger', 37.9563903808594, 0.662463984318301, -81.1130599975586, -1.4156899633251, 218, 58, 'PPL', 'P'),
(184914, 'Sanger', 36.7080612182617, 0.640676530282308, -119.555000305176, -2.08662839254814, 218, 6, 'PPL', 'P'),
(198858, 'Sanger', 47.1797218322754, 0.823441486148258, -100.995002746582, -1.76269532598857, 218, 34, 'PPL', 'P'),
(152355, 'Sangerfield', 42.913890838623, 0.748988689975403, -75.3794403076172, -1.31561942167845, 218, 40, 'PPL', 'P'),
(106041, 'Sangerville', 38.3886108398438, 0.670007654422059, -79.083610534668, -1.38026938819483, 218, 53, 'PPL', 'P'),
(128745, 'Sangerville', 45.1647186279297, 0.788273045794189, -69.3569412231445, -1.21050698345606, 218, 26, 'PPL', 'P'),
(90615, 'Sango', 36.5063896179199, 0.637156696848577, -87.220832824707, -1.52229070912268, 218, 50, 'PPL', 'P'),
(166874, 'Sangree', 40.3549995422363, 0.704327611652828, -76.8011093139648, -1.34043222671277, 218, 45, 'PPL', 'P'),
(83494, 'Sangster Village', 32.4172210693359, 0.565787242006789, -80.663330078125, -1.40784069548626, 218, 48, 'PPL', 'P'),
(17970, 'Sanibel', 26.4486103057861, 0.461615332412872, -82.0224990844727, -1.43156266973808, 218, 12, 'PPL', 'P'),
(5653, 'Sanie', 33.6602783203125, 0.58748268382712, -86.478889465332, -1.50934135463828, 218, 2, 'PPL', 'P'),
(198859, 'Sanish', 47.9738883972168, 0.837302307515738, -102.545562744141, -1.78975770319569, 218, 34, 'PPL', 'P'),
(152356, 'Sanitaria Springs', 42.1599998474121, 0.735830809977648, -75.7655563354492, -1.32235841765884, 218, 40, 'PPL', 'P'),
(184915, 'Sanitarium', 38.5449981689453, 0.672737128223281, -122.47444152832, -2.13758225421047, 218, 6, 'PPL', 'P'),
(57419, 'Sank', 37.1716690063477, 0.648768012622296, -90.0136108398438, -1.57103388076413, 218, 29, 'PPL', 'P'),
(166875, 'Sankertown', 40.4700012207031, 0.706334769587394, -78.5924987792969, -1.37169787106835, 218, 45, 'PPL', 'P'),
(184918, 'Sankey', 38.7783317565918, 0.676809567583203, -121.498062133789, -2.12054121902727, 218, 6, 'PPL', 'P'),
(57420, 'Sankey (historical)', 37.9769401550293, 0.662822645538107, -91.3436126708984, -1.59424679177359, 218, 29, 'PPL', 'P'),
(121367, 'Sankoty', 40.7594413757324, 0.711386453280138, -89.5650024414063, -1.5632041871593, 218, 18, 'PPL', 'P'),
(17971, 'Sanlando Springs', 28.6833305358887, 0.500618558289087, -81.3819427490234, -1.42038285263998, 218, 12, 'PPL', 'P'),
(17972, 'Sanlanta', 28.797779083252, 0.502616062264701, -81.2649993896484, -1.41834180598055, 218, 12, 'PPL', 'P'),
(51220, 'Sanner Estates', 39.3777809143066, 0.687271929083634, -77.0188903808594, -1.34423322337859, 218, 25, 'PPL', 'P'),
(38105, 'Sano', 37.1083297729492, 0.647662534453804, -85.1036071777344, -1.48533815057534, 218, 21, 'PPL', 'P'),
(200190, 'Sano', 40.3416709899902, 0.70409498453161, -119.682777404785, -2.08885852364498, 218, 39, 'PPL', 'P'),
(179087, 'Sanokai Village', 33.2333297729492, 0.580031025939023, -111.670829772949, -1.94902365797208, 218, 5, 'PPL', 'P'),
(111288, 'Sanoma', 38.9644393920898, 0.680057758585746, -81.3247222900391, -1.4193841672312, 218, 58, 'PPL', 'P'),
(189501, 'Sanostee', 36.4247207641602, 0.63573130645414, -108.873611450195, -1.90020298834291, 218, 38, 'PPL', 'P'),
(184919, 'Sans (historical)', 35.973331451416, 0.62785307673844, -121.338333129883, -2.11775342199817, 218, 6, 'PPL', 'P'),
(77179, 'Sans Bois', 35.1305618286133, 0.613143971984742, -95.1558303833008, -1.66078254265786, 218, 42, 'PPL', 'P'),
(106043, 'Sans Facon', 38.8849983215332, 0.678671250343223, -78.2177810668945, -1.36515781322139, 218, 53, 'PPL', 'P'),
(17973, 'Sans Pareil', 30.2830600738525, 0.528539105867964, -81.4944381713867, -1.42234626815365, 218, 12, 'PPL', 'P'),
(11805, 'Sans Souci', 35.6530609130859, 0.622263301347445, -89.9494400024414, -1.5699138883677, 218, 4, 'PPL', 'P'),
(17974, 'Sans Souci', 26.9850006103516, 0.470977109303314, -81.9677810668945, -1.43060766017118, 218, 12, 'PPL', 'P'),
(68543, 'Sans Souci', 35.916389465332, 0.62685925159865, -76.8188934326172, -1.34074261813782, 218, 33, 'PPL', 'P'),
(83495, 'Sans Souci', 34.8777809143066, 0.608732112743889, -82.4241714477539, -1.43857317499161, 218, 48, 'PPL', 'P'),
(133006, 'Sans Souci', 42.5791702270508, 0.743146713229178, -82.5641708374023, -1.44101662529175, 218, 27, 'PPL', 'P'),
(133007, 'Sans Souci Beach', 41.8305587768555, 0.73008097860514, -84.9700012207031, -1.48300628672487, 218, 27, 'PPL', 'P'),
(83496, 'Sans Souci Heights', 34.896110534668, 0.609052024969835, -82.4180603027344, -1.43846651538995, 218, 48, 'PPL', 'P'),
(202591, 'Sansarc', 44.5066719055176, 0.77678796385614, -101.034439086914, -1.7633836199723, 218, 49, 'PPL', 'P'),
(83497, 'Sansbury Crossroads', 34.0605583190918, 0.594468887735697, -79.9233322143555, -1.39492529630575, 218, 48, 'PPL', 'P'),
(97848, 'Sansom Park', 32.8058280944824, 0.572569714091976, -97.4027786254883, -1.69999918760593, 218, 51, 'PPL', 'P'),
(195587, 'Santa', 47.1502799987793, 0.822927629215927, -116.448059082031, -2.03240203853833, 218, 17, 'PPL', 'P'),
(97849, 'Santa Amalia Colonia', 26.0960006713867, 0.455461133318349, -97.9729995727539, -1.70995142059955, 218, 51, 'PPL', 'P'),
(184921, 'Santa Ana', 33.7455596923828, 0.588971124560365, -117.866943359375, -2.05716624088276, 218, 6, 'PPL', 'P'),
(189502, 'Santa Ana', 35.4791717529297, 0.619228362969191, -105.294998168945, -1.8377444039295, 218, 38, 'PPL', 'P'),
(184924, 'Santa Ana Heights', 33.6525001525879, 0.587346929190553, -117.894721984863, -2.05765106935921, 218, 6, 'PPL', 'P'),
(189504, 'Santa Ana Pueblo', 35.4288902282715, 0.618350784810983, -106.61833190918, -1.86084093479932, 218, 38, 'PPL', 'P'),
(184927, 'Santa Anita', 34.1455612182617, 0.595952468199953, -118.048889160156, -2.06034179416657, 218, 6, 'PPL', 'P'),
(97851, 'Santa Anna', 26.6677799224854, 0.465440563844608, -98.5641708374023, -1.72026930561085, 218, 51, 'PPL', 'P'),
(184928, 'Santa Barbara', 34.4208297729492, 0.600756810806456, -119.697219848633, -2.08911059184215, 218, 6, 'PPL', 'P'),
(17975, 'Santa Barbara Shores', 26.2202796936035, 0.457630211447191, -80.1005630493164, -1.39801855791188, 218, 12, 'PPL', 'P'),
(97852, 'Santa Catarina', 26.6550006866455, 0.465217524103313, -98.5772171020508, -1.72049700588405, 218, 51, 'PPL', 'P'),
(17976, 'Santa Clara', 30.583610534668, 0.533784700977579, -84.5622177124023, -1.47588912186969, 218, 12, 'PPL', 'P'),
(97853, 'Santa Clara', 29.5116691589355, 0.515075794582691, -98.1211090087891, -1.71253641791164, 218, 51, 'PPL', 'P'),
(152357, 'Santa Clara', 44.6336097717285, 0.779003447566977, -74.4577789306641, -1.29953339606215, 218, 40, 'PPL', 'P'),
(184930, 'Santa Clara', 37.3541717529297, 0.651953286444085, -121.954170227051, -2.12850180699968, 218, 6, 'PPL', 'P'),
(189508, 'Santa Clara', 32.7794418334961, 0.572109186960474, -108.149719238281, -1.88756868581546, 218, 38, 'PPL', 'P'),
(192770, 'Santa Clara', 37.1330604553223, 0.648094166287478, -113.653327941895, -1.98362477843493, 218, 52, 'PPL', 'P'),
(201533, 'Santa Clara', 44.1036109924316, 0.769753223836696, -123.129997253418, -2.14902386004372, 218, 43, 'PPL', 'P'),
(189509, 'Santa Clara Pueblo', 35.9655609130859, 0.627717455259928, -106.08805847168, -1.85158591737907, 218, 38, 'PPL', 'P'),
(184934, 'Santa Clarita', 34.3916702270508, 0.600247880722142, -118.54167175293, -2.06894247290698, 218, 6, 'PPL', 'P'),
(24665, 'Santa Claus', 32.1713905334473, 0.56149668975359, -82.331672668457, -1.4369587667388, 218, 13, 'PPL', 'P'),
(31074, 'Santa Claus', 38.1199989318848, 0.665319492218111, -86.9141693115234, -1.5169384211219, 218, 19, 'PPL', 'P'),
(179088, 'Santa Claus', 35.336669921875, 0.616741236827166, -114.215560913086, -1.99343759494549, 218, 5, 'PPL', 'P'),
(97855, 'Santa Cruz', 26.3541698455811, 0.459967035435195, -98.7680587768555, -1.72382782145941, 218, 51, 'PPL', 'P'),
(179090, 'Santa Cruz', 33.2280616760254, 0.579939080302388, -112.165832519531, -1.95766308570635, 218, 5, 'PPL', 'P'),
(184935, 'Santa Cruz', 36.9741706848145, 0.645321016644379, -122.029716491699, -2.12982033805537, 218, 6, 'PPL', 'P'),
(189510, 'Santa Cruz', 35.9922218322754, 0.628182776081392, -106.046669006348, -1.85086353493339, 218, 38, 'PPL', 'P'),
(97856, 'Santa Cruz Estates Colonia', 26.3419990539551, 0.459754615048748, -98.1190032958984, -1.7124996662886, 218, 51, 'PPL', 'P'),
(97857, 'Santa Cruz Number 2 Colonia', 26.363000869751, 0.460121165883283, -98.7710037231445, -1.72387922046845, 218, 51, 'PPL', 'P'),
(97858, 'Santa Cruz Orange Gardens Colonia', 26.3659992218018, 0.460173496998703, -98.1480026245117, -1.71300580005377, 218, 51, 'PPL', 'P'),
(97859, 'Santa Elena', 26.7597198486328, 0.467045218269921, -98.4861068725586, -1.71890683239716, 218, 51, 'PPL', 'P'),
(83498, 'Santa Elena (historical)', 32.3063888549805, 0.56385285494901, -80.6755599975586, -1.40805414784763, 218, 48, 'PPL', 'P'),
(97860, 'Santa Elena Colonia', 26.2469997406006, 0.458096564243578, -97.6320037841797, -1.7039999213535, 218, 51, 'PPL', 'P'),
(192175, 'Santa Elena Crossing', 29.1213893890381, 0.508264127594054, -103.523612976074, -1.80682789999282, 218, 51, 'PPL', 'P'),
(17977, 'Santa Fe', 29.8833293914795, 0.521562489339311, -82.4305572509766, -1.43868462828323, 218, 12, 'PPL', 'P'),
(38106, 'Santa Fe', 38.5711097717285, 0.673192861664821, -84.1216735839844, -1.46820017632847, 218, 21, 'PPL', 'P'),
(57421, 'Santa Fe', 39.3688888549805, 0.68711673337111, -91.8188934326172, -1.60254200593697, 218, 29, 'PPL', 'P'),
(77181, 'Santa Fe', 34.4197196960449, 0.600737436309526, -97.6922225952148, -1.7050509378777, 218, 42, 'PPL', 'P'),
(90616, 'Santa Fe', 35.7350006103516, 0.623693418852818, -87.128059387207, -1.52067150717992, 218, 50, 'PPL', 'P'),
(97861, 'Santa Fe', 29.3777809143066, 0.512739003884201, -95.1055603027344, -1.65990516423673, 218, 51, 'PPL', 'P'),
(123624, 'Santa Fe', 40.6530609130859, 0.709529763947162, -85.9861068725586, -1.50074067589787, 218, 19, 'PPL', 'P'),
(157543, 'Santa Fe', 40.4913902282715, 0.706708078193196, -83.9941711425781, -1.4659748389216, 218, 41, 'PPL', 'P'),
(189512, 'Santa Fe', 35.686939239502, 0.62285458968847, -105.937217712402, -1.84895324948348, 218, 38, 'PPL', 'P'),
(51221, 'Santa Fe Acres', 38.4119415283203, 0.670414851752732, -75.603889465332, -1.3195367984839, 218, 25, 'PPL', 'P'),
(17978, 'Santa Fe Beach', 29.7511100769043, 0.519254826965243, -82.0980606079102, -1.43288146710989, 218, 12, 'PPL', 'P'),
(184937, 'Santa Fe Springs', 33.9472198486328, 0.592490758257014, -118.084442138672, -2.06096231070056, 218, 6, 'PPL', 'P'),
(189515, 'Santa Gertrudis (historical)', 35.9638900756836, 0.627688293645991, -105.331939697266, -1.8383891552294, 218, 38, 'PPL', 'P'),
(179092, 'Santa Grande Mobile Home Park', 33.5158309936523, 0.584961602381196, -112.15389251709, -1.95745469335105, 218, 5, 'PPL', 'P'),
(179093, 'Santa Lucia', 32.0672187805176, 0.559678549677393, -111.948890686035, -1.95387673642653, 218, 5, 'PPL', 'P'),
(97862, 'Santa Margarita', 26.4922199249268, 0.462376463852417, -99.0924987792969, -1.72949036772719, 218, 51, 'PPL', 'P'),
(184942, 'Santa Margarita', 35.3899993896484, 0.617672011628149, -120.608062744141, -2.10500779933716, 218, 6, 'PPL', 'P'),
(184944, 'Santa Margarita Groves', 33.4908294677734, 0.584525243436587, -117.28556060791, -2.04701919765539, 218, 6, 'PPL', 'P'),
(17980, 'Santa Maria', 30.9494400024414, 0.540169629691044, -86.8352813720703, -1.51556156683833, 218, 12, 'PPL', 'P'),
(97863, 'Santa Maria', 26.0783290863037, 0.455152705974604, -97.8491668701172, -1.7077901322169, 218, 51, 'PPL', 'P'),
(179095, 'Santa Maria', 33.422779083252, 0.583337540169439, -112.203330993652, -1.95831755754423, 218, 5, 'PPL', 'P'),
(184947, 'Santa Maria', 34.9530601501465, 0.61004598326768, -120.434722900391, -2.10198244833883, 218, 6, 'PPL', 'P'),
(187324, 'Santa Maria', 39.4497184753418, 0.688527476379552, -105.632781982422, -1.8436398436346, 218, 7, 'PPL', 'P'),
(192176, 'Santa Martina Colonia', 31.6189994812012, 0.551855647133339, -106.246002197266, -1.85434255542342, 218, 51, 'PPL', 'P'),
(97864, 'Santa Monica', 26.3619403839111, 0.460102656913707, -97.585563659668, -1.70318938827573, 218, 51, 'PPL', 'P'),
(184948, 'Santa Monica', 34.0194396972656, 0.593751232400948, -118.490280151367, -2.06804552025184, 218, 6, 'PPL', 'P'),
(184949, 'Santa Nella', 38.4972190856934, 0.67190322590695, -122.965560913086, -2.14615390449499, 218, 6, 'PPL', 'P'),
(184950, 'Santa Nella Village', 37.0977783203125, 0.647478376864425, -121.015830993652, -2.11212469787623, 218, 6, 'PPL', 'P'),
(184951, 'Santa Paula', 34.3541717529297, 0.599593408884255, -119.058326721191, -2.07795980319993, 218, 6, 'PPL', 'P'),
(184954, 'Santa Rita', 36.7238883972168, 0.640952766666376, -121.654998779297, -2.12328028020841, 218, 6, 'PPL', 'P'),
(192177, 'Santa Rita', 31.2233295440674, 0.544949903979196, -101.656669616699, -1.77424359142348, 218, 51, 'PPL', 'P'),
(197478, 'Santa Rita', 48.7005615234375, 0.84998514615405, -112.31916809082, -1.96033929628577, 218, 31, 'PPL', 'P'),
(189516, 'Santa Rita (historical)', 32.8036117553711, 0.572531031677142, -108.060279846191, -1.88600767394251, 218, 38, 'PPL', 'P'),
(184956, 'Santa Rita Park', 37.0475006103516, 0.646600865285244, -120.594169616699, -2.10476531851991, 218, 6, 'PPL', 'P'),
(184957, 'Santa Rita Peak', 36.3466682434082, 0.634369032977537, -120.600563049316, -2.10487690496958, 218, 6, 'PPL', 'P'),
(57422, 'Santa Rosa', 39.9797210693359, 0.69777776668886, -94.2052764892578, -1.64419224748915, 218, 29, 'PPL', 'P'),
(61669, 'Santa Rosa', 30.4294395446777, 0.531093909591191, -89.6477813720703, -1.56464895205067, 218, 30, 'PPL', 'P'),
(97865, 'Santa Rosa', 26.2563896179199, 0.458260448519159, -97.8247222900391, -1.70736349381027, 218, 51, 'PPL', 'P'),
(179096, 'Santa Rosa', 32.3236083984375, 0.564153392678026, -112.040557861328, -1.95547663045139, 218, 5, 'PPL', 'P'),
(184960, 'Santa Rosa', 38.440559387207, 0.670914327615177, -122.713333129883, -2.14175169921309, 218, 6, 'PPL', 'P'),
(189517, 'Santa Rosa', 34.9386100769043, 0.609793781912449, -104.681938171387, -1.82704448845983, 218, 38, 'PPL', 'P'),
(97866, 'Santa Rosa Annex Colonia', 26.238000869751, 0.45793950431829, -97.822998046875, -1.70733340008995, 218, 51, 'PPL', 'P'),
(17981, 'Santa Rosa Beach', 30.3958301544189, 0.530507315071587, -86.228889465332, -1.5049780315083, 218, 12, 'PPL', 'P'),
(97867, 'Santa Rosa Colonia', 26.3519992828369, 0.459929151968689, -98.7689971923828, -1.72384419990012, 218, 51, 'PPL', 'P'),
(97868, 'Santa Rosa Number 12 Colonia', 26.2490005493164, 0.458131484943371, -97.8259963989258, -1.70738573120537, 218, 51, 'PPL', 'P'),
(97869, 'Santa Rosa Number 14 Colonia', 26.2469997406006, 0.458096564243578, -97.8209991455078, -1.70729851267967, 218, 51, 'PPL', 'P'),
(97870, 'Santa Rosa Number 5 Colonia', 26.257999420166, 0.458288544868659, -97.8209991455078, -1.70729851267967, 218, 51, 'PPL', 'P'),
(97871, 'Santa Rosa Number 6 Colonia', 26.2299995422363, 0.457799854808629, -97.8270034790039, -1.70740330806857, 218, 51, 'PPL', 'P'),
(97872, 'Santa Rosa Number 9 Colonia', 26.2600002288818, 0.458323465568453, -97.8339996337891, -1.70752541400455, 218, 51, 'PPL', 'P'),
(184962, 'Santa Rosa Ranch Estates', 33.7791709899902, 0.589557752369482, -117.352783203125, -2.04819245327363, 218, 6, 'PPL', 'P'),
(184963, 'Santa Rosa South', 33.5130615234375, 0.584913266007411, -117.326393127441, -2.0477318595631, 218, 6, 'PPL', 'P'),
(184964, 'Santa Rosa West', 33.5449981689453, 0.585470665623565, -117.307777404785, -2.04740695391011, 218, 6, 'PPL', 'P'),
(184965, 'Santa Susana', 34.271671295166, 0.598153504261876, -118.708061218262, -2.07184651691766, 218, 6, 'PPL', 'P'),
(184966, 'Santa Susana Knolls', 34.2622184753418, 0.597988521432346, -118.672782897949, -2.07123079407363, 218, 6, 'PPL', 'P'),
(189523, 'Santa Teresa', 31.8558292388916, 0.555989106171738, -106.638610839844, -1.86119486890819, 218, 38, 'PPL', 'P'),
(184968, 'Santa Venetia', 37.9986114501953, 0.663200880991926, -122.524169921875, -2.13845017840972, 218, 6, 'PPL', 'P'),
(184969, 'Santa Ynez', 34.6144409179688, 0.604135962755603, -120.078887939453, -2.09577195667677, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(184973, 'Santa Ysabel', 33.1091690063477, 0.577864011760026, -116.672218322754, -2.03631435533771, 218, 6, 'PPL', 'P'),
(184972, 'Santa Ysabel (historical)', 33.8672218322754, 0.591094529476512, -117.885276794434, -2.05748621968773, 218, 6, 'PPL', 'P'),
(111289, 'Santafee', 37.7277793884277, 0.658473969794117, -80.6944427490234, -1.40838371403252, 218, 58, 'PPL', 'P'),
(24666, 'Santaluca', 34.7869415283203, 0.607146666367938, -84.4347229003906, -1.47366391762087, 218, 13, 'PPL', 'P'),
(179097, 'Santan', 33.1758308410645, 0.579027480261254, -111.798606872559, -1.95125378906891, 218, 5, 'PPL', 'P'),
(189521, 'Santana Place', 33.4327812194824, 0.583512110378893, -107.801391601563, -1.88148922167903, 218, 38, 'PPL', 'P'),
(192771, 'Santaquin', 39.9755592346191, 0.697705128970128, -111.784439086914, -1.95100651456169, 218, 52, 'PPL', 'P'),
(61670, 'Santee', 31.5541706085205, 0.550724169854706, -89.7222213745117, -1.56594817518846, 218, 30, 'PPL', 'P'),
(83500, 'Santee', 33.4749984741211, 0.584248940473491, -80.4866714477539, -1.40475742073422, 218, 48, 'PPL', 'P'),
(142948, 'Santee', 42.8411102294922, 0.747718428714462, -97.8505630493164, -1.70781450014087, 218, 35, 'PPL', 'P'),
(184974, 'Santee', 32.8383293151855, 0.573136967404163, -116.97306060791, -2.04156504374291, 218, 6, 'PPL', 'P'),
(83501, 'Santee (historical)', 33.454719543457, 0.583895006364619, -79.9047164916992, -1.39460039065276, 218, 48, 'PPL', 'P'),
(106044, 'Santee (historical)', 38.2186088562012, 0.667040560072575, -77.3611068725586, -1.35020602791336, 218, 53, 'PPL', 'P'),
(83502, 'Santee Circle', 33.2436103820801, 0.580210456417467, -79.9644393920898, -1.39564275190342, 218, 48, 'PPL', 'P'),
(68544, 'Santeetlah', 35.3561096191406, 0.617080523550042, -83.8383331298828, -1.4632549525003, 218, 33, 'PPL', 'P'),
(97873, 'Santel Colonia', 26.3759994506836, 0.460348033918644, -98.8830032348633, -1.72583398070857, 218, 51, 'PPL', 'P'),
(57423, 'Santiago', 38.4269409179688, 0.670676640487887, -93.456672668457, -1.63112664602317, 218, 29, 'PPL', 'P'),
(111293, 'Santiago', 39.3697204589844, 0.687131247599051, -80.2016677856445, -1.39978316845017, 218, 58, 'PPL', 'P'),
(117677, 'Santiago', 41.7099990844727, 0.727976815027868, -93.3747177124023, -1.62969626220169, 218, 16, 'PPL', 'P'),
(133008, 'Santiago', 44.1127815246582, 0.76991327981821, -83.7005615234375, -1.46085038435207, 218, 27, 'PPL', 'P'),
(137987, 'Santiago', 45.5391693115234, 0.794808443109243, -93.8197174072266, -1.63746297204674, 218, 28, 'PPL', 'P'),
(166877, 'Santiago', 40.4341697692871, 0.705709392784416, -80.2708282470703, -1.40099024621425, 218, 45, 'PPL', 'P'),
(179098, 'Santiago', 33.6208305358887, 0.586794190106307, -111.973609924316, -1.95430816852312, 218, 5, 'PPL', 'P'),
(42969, 'Santiago (historical)', 31.4419403076172, 0.548765381583439, -92.6041717529297, -1.61624769817095, 218, 22, 'PPL', 'P'),
(184976, 'Santiago Villa Mobile Home Park', 37.4161109924316, 0.653034330109575, -122.070281982422, -2.13052833943117, 218, 6, 'PPL', 'P'),
(42970, 'Santiague', 29.9847202301025, 0.523332093304641, -91.904167175293, -1.60403031351216, 218, 22, 'PPL', 'P'),
(201534, 'Santiam City (historical)', 44.7333297729492, 0.780743889918371, -123.034721374512, -2.14736098225907, 218, 43, 'PPL', 'P'),
(201535, 'Santiam Terrace', 44.4430618286133, 0.775677758576714, -122.809997558594, -2.14343881176366, 218, 43, 'PPL', 'P'),
(111291, 'Santifee (historical)', 37.728328704834, 0.658483557174041, -80.692497253418, -1.40834975872862, 218, 58, 'PPL', 'P'),
(192772, 'Santio Crossing', 39.7377815246582, 0.693555125043458, -109.583061218262, -1.91258522267318, 218, 52, 'PPL', 'P'),
(97874, 'Santo', 32.6030616760254, 0.569030772477424, -98.2149963378906, -1.71417506093036, 218, 51, 'PPL', 'P'),
(51222, 'Santo Domingo', 38.5113906860352, 0.672150566993191, -75.7230606079102, -1.32161672729525, 218, 25, 'PPL', 'P'),
(189524, 'Santo Domingo Pueblo', 35.514720916748, 0.619848812924152, -106.365280151367, -1.85642434844753, 218, 38, 'PPL', 'P'),
(189528, 'Santo Nino', 36.0027809143066, 0.628367066828825, -106.062782287598, -1.8511447647445, 218, 38, 'PPL', 'P'),
(97875, 'Santo Tomas', 27.7438907623291, 0.484222241116282, -99.751106262207, -1.74098523678225, 218, 51, 'PPL', 'P'),
(179099, 'Santo Tomas', 33.5483283996582, 0.585528789114356, -111.915832519531, -1.95329976257636, 218, 5, 'PPL', 'P'),
(189529, 'Santo Tomas', 32.1816711425781, 0.561676120232034, -106.745559692383, -1.86306147851623, 218, 38, 'PPL', 'P'),
(17984, 'Santos', 29.1088905334473, 0.508045981411263, -82.0930633544922, -1.43279424858419, 218, 12, 'PPL', 'P'),
(111292, 'Santown', 38.8205604553223, 0.677546597414883, -82.0119400024414, -1.43137837899065, 218, 58, 'PPL', 'P'),
(83503, 'Santuc', 34.6344413757324, 0.604485036595485, -81.5227813720703, -1.42284095032613, 218, 48, 'PPL', 'P'),
(5654, 'Santuck', 32.6327781677246, 0.569549423099717, -86.1297225952148, -1.50324724311585, 218, 2, 'PPL', 'P'),
(126030, 'Santuit', 41.6375007629395, 0.726711480614944, -70.4511108398438, -1.22960384584274, 218, 23, 'PPL', 'P'),
(139443, 'Santuzza', 40.2058296203613, 0.701724105371167, -91.5341720581055, -1.59757268050093, 218, 29, 'PPL', 'P'),
(106045, 'Sanville', 36.7197189331055, 0.64087999578959, -80.059440612793, -1.3973008359981, 218, 53, 'PPL', 'P'),
(61671, 'Sapa', 33.5475006103516, 0.585514341465442, -89.2019424438477, -1.55686759481962, 218, 30, 'PPL', 'P'),
(179100, 'Sapano Vaya', 31.5969390869141, 0.551470620618741, -111.662216186523, -1.94887332252854, 218, 5, 'PPL', 'P'),
(189531, 'Sapello', 35.7727813720703, 0.624352817538722, -105.252777099609, -1.83700750725587, 218, 38, 'PPL', 'P'),
(448, 'Sapelo Island', 31.3972206115723, 0.547984875646964, -81.2788925170898, -1.4185842867978, 218, 13, 'PPL', 'P'),
(192922, 'Sapinero', 38.4594383239746, 0.671243827221047, -107.301666259766, -1.87276736910902, 218, 7, 'PPL', 'P'),
(97876, 'Sapoak', 32.454719543457, 0.566441713844676, -98.2474975585938, -1.71474231424255, 218, 51, 'PPL', 'P'),
(208662, 'Sapolil', 46.1205596923828, 0.804955619494663, -118.236671447754, -2.06361921336208, 218, 56, 'PPL', 'P'),
(68545, 'Sapona', 35.8105583190918, 0.625012149645598, -80.317497253418, -1.40180477403365, 218, 33, 'PPL', 'P'),
(68546, 'Sapona Lakes', 35.7886085510254, 0.62462905392279, -80.3252792358398, -1.40194059524924, 218, 33, 'PPL', 'P'),
(128747, 'Saponac', 45.1708297729492, 0.788379705395846, -68.3186111450195, -1.19238470487028, 218, 26, 'PPL', 'P'),
(17985, 'Sapp', 30.1472206115723, 0.526168259997035, -82.1858291625977, -1.4344133173689, 218, 12, 'PPL', 'P'),
(57424, 'Sapp', 38.8250007629395, 0.677624095402604, -92.3516693115234, -1.61184069919909, 218, 29, 'PPL', 'P'),
(68547, 'Sapphire', 35.1069412231445, 0.612731714647997, -83.003059387207, -1.44867667553515, 218, 33, 'PPL', 'P'),
(197479, 'Sapphire Village', 46.8891716003418, 0.818370427958583, -110.250556945801, -1.92423522086173, 218, 31, 'PPL', 'P'),
(208663, 'Sappho', 48.0702781677246, 0.838984626376341, -124.278060913086, -2.16906135092742, 218, 56, 'PPL', 'P'),
(57425, 'Sappington', 38.5369415283203, 0.672596513317725, -90.3797225952148, -1.57742373632561, 218, 29, 'PPL', 'P'),
(197480, 'Sappington', 45.7949981689453, 0.79927349899287, -111.766670227051, -1.95069638945275, 218, 31, 'PPL', 'P'),
(5655, 'Sapps', 33.2208290100098, 0.579812846466719, -88.1691665649414, -1.53884225529753, 218, 2, 'PPL', 'P'),
(83504, 'Sapps Crossroads', 34.8088912963867, 0.607529762090746, -80.6313934326172, -1.4072832958701, 218, 48, 'PPL', 'P'),
(24667, 'Sapps Still', 31.7158298492432, 0.55354565587159, -82.9375, -1.4475324483728, 218, 13, 'PPL', 'P'),
(24668, 'Sappville', 31.2544403076172, 0.545492889235949, -82.5422210693359, -1.44063352956895, 218, 13, 'PPL', 'P'),
(77183, 'Sapulpa', 35.9986114501953, 0.628294295952039, -96.1138916015625, -1.67750386535219, 218, 42, 'PPL', 'P'),
(208664, 'Sara', 45.7516708374023, 0.798517294401342, -122.711936950684, -2.14172733128912, 218, 56, 'PPL', 'P'),
(24669, 'Sara Lake Estates', 33.9422187805176, 0.592403473152286, -84.290283203125, -1.471142969333, 218, 13, 'PPL', 'P'),
(192178, 'Saragosa', 31.023889541626, 0.541469019276408, -103.661109924316, -1.80922767445109, 218, 51, 'PPL', 'P'),
(5656, 'Saragossa', 33.8988914489746, 0.591647268560758, -87.399169921875, -1.52540327864671, 218, 2, 'PPL', 'P'),
(24670, 'Sarah', 34.6674995422363, 0.605062010445651, -84.0358276367188, -1.46670188189919, 218, 13, 'PPL', 'P'),
(38107, 'Sarah', 38.061939239502, 0.664306159423336, -82.960563659668, -1.44793498517156, 218, 21, 'PPL', 'P'),
(42971, 'Sarah', 29.7700004577637, 0.519584526308195, -90.0299987792969, -1.57131990426521, 218, 22, 'PPL', 'P'),
(61674, 'Sarah', 34.5694389343262, 0.603350529971111, -90.2102813720703, -1.57446642909313, 218, 30, 'PPL', 'P'),
(106046, 'Sarah', 37.3886108398438, 0.652554361902116, -76.2822189331055, -1.33137588110985, 218, 53, 'PPL', 'P'),
(111294, 'Sarah', 38.3300018310547, 0.66898473424736, -82.2577819824219, -1.43566913098093, 218, 58, 'PPL', 'P'),
(111297, 'Sarah Ann', 37.711109161377, 0.658183019445025, -81.9875030517578, -1.43095187374207, 218, 58, 'PPL', 'P'),
(166878, 'Sarah Furnace', 41.0080604553223, 0.715725674802259, -79.5977783203125, -1.38924330896201, 218, 45, 'PPL', 'P'),
(42972, 'Sarah Plantation', 29.4819393157959, 0.514556910933803, -90.57861328125, -1.58089503364848, 218, 22, 'PPL', 'P'),
(74210, 'Sarahsville', 39.8072204589844, 0.694767063076526, -81.4680633544922, -1.42188594075923, 218, 41, 'PPL', 'P'),
(5657, 'Saraland', 30.8205604553223, 0.537920257255336, -88.070556640625, -1.53712118744306, 218, 2, 'PPL', 'P'),
(24673, 'Saranac', 33.5849990844727, 0.586168813303329, -84.4322204589844, -1.473620241779, 218, 13, 'PPL', 'P'),
(42973, 'Saranac', 32.0091705322266, 0.558665416619699, -91.352783203125, -1.5944068477551, 218, 22, 'PPL', 'P'),
(133009, 'Saranac', 42.9294395446777, 0.749260066090482, -85.2130584716797, -1.48724843602526, 218, 27, 'PPL', 'P'),
(152360, 'Saranac', 44.6513900756836, 0.779313772412999, -73.7438888549805, -1.28707366374416, 218, 40, 'PPL', 'P'),
(24671, 'Saranac Estates', 33.5852813720703, 0.586173740151346, -84.4361114501953, -1.47368815238679, 218, 13, 'PPL', 'P'),
(152361, 'Saranac Inn', 44.3461112976074, 0.773985652599104, -74.3180618286133, -1.29709487261002, 218, 40, 'PPL', 'P'),
(152362, 'Saranac Lake', 44.3294410705566, 0.773694702250013, -74.1316680908203, -1.29384168818043, 218, 40, 'PPL', 'P'),
(184977, 'Saranap', 37.8849983215332, 0.66121795782328, -122.074996948242, -2.13061063110886, 218, 6, 'PPL', 'P'),
(17990, 'Sarasota', 27.336109161377, 0.477105109550614, -82.5308303833008, -1.44043472459357, 218, 12, 'PPL', 'P'),
(17991, 'Sarasota Colony', 27.0049991607666, 0.471326149853683, -81.054443359375, -1.41466690999235, 218, 12, 'PPL', 'P'),
(18000, 'Sarasota Heights', 27.312780380249, 0.476697945509454, -82.5297164916992, -1.44041528351761, 218, 12, 'PPL', 'P'),
(17994, 'Sarasota Springs', 27.3086109161377, 0.476625174632668, -82.4797210693359, -1.43954269878645, 218, 12, 'PPL', 'P'),
(11806, 'Sarassa', 34.1230583190918, 0.595559718518194, -91.6650009155273, -1.59985607481957, 218, 4, 'PPL', 'P'),
(5658, 'Saratoga', 34.2527809143066, 0.597823804918925, -86.1927795410156, -1.50434779443633, 218, 2, 'PPL', 'P'),
(11807, 'Saratoga', 33.7516708374023, 0.589077784162023, -93.9024963378906, -1.63890773693811, 218, 4, 'PPL', 'P'),
(17995, 'Saratoga', 29.5319404602051, 0.515429595533508, -81.6838912963867, -1.42565284896309, 218, 12, 'PPL', 'P'),
(38110, 'Saratoga', 37.060001373291, 0.646819044757548, -87.9974975585938, -1.53584606591313, 218, 21, 'PPL', 'P'),
(57426, 'Saratoga', 36.541389465332, 0.637767559423614, -94.5563888549805, -1.65032031431548, 218, 29, 'PPL', 'P'),
(61672, 'Saratoga', 31.7969398498535, 0.554961292438535, -89.6774978637695, -1.56516760267296, 218, 30, 'PPL', 'P'),
(68548, 'Saratoga', 35.6536102294922, 0.62227288872737, -77.7758331298828, -1.35744436659814, 218, 33, 'PPL', 'P'),
(97877, 'Saratoga', 30.2838897705078, 0.528553586806391, -94.529167175293, -1.64984520637701, 218, 51, 'PPL', 'P'),
(106047, 'Saratoga', 39.0830612182617, 0.682128100017173, -78.0597229003906, -1.36239917780623, 218, 53, 'PPL', 'P'),
(117679, 'Saratoga', 43.3713912963867, 0.75697357929276, -92.4058303833008, -1.61278598822801, 218, 16, 'PPL', 'P'),
(121369, 'Saratoga', 41.459171295166, 0.723599044248969, -88.4313888549805, -1.54341889763083, 218, 18, 'PPL', 'P'),
(123625, 'Saratoga', 40.2369384765625, 0.702267057338407, -84.918327331543, -1.48210440722172, 218, 19, 'PPL', 'P'),
(137989, 'Saratoga', 43.8919410705566, 0.766058886772538, -92.0697174072266, -1.60691971013684, 218, 28, 'PPL', 'P'),
(184978, 'Saratoga', 37.2638893127441, 0.650377560606112, -122.021942138672, -2.12968464999784, 218, 6, 'PPL', 'P'),
(208665, 'Saratoga', 48.0736083984375, 0.839042749867132, -122.464996337891, -2.13741740453899, 218, 56, 'PPL', 'P'),
(209723, 'Saratoga', 41.4550018310547, 0.723526273372182, -106.80583190918, -1.86411342714681, 218, 59, 'PPL', 'P'),
(157544, 'Saratoga (historical)', 40.7655601501465, 0.71149324603985, -80.7422180175781, -1.40921754976983, 218, 41, 'PPL', 'P'),
(184979, 'Saratoga Acres', 38.0013885498047, 0.663249350523765, -120.392776489258, -2.10125034535517, 218, 6, 'PPL', 'P'),
(121370, 'Saratoga Center', 41.1116714477539, 0.71753402776145, -89.5919418334961, -1.56367436824975, 218, 18, 'PPL', 'P'),
(5659, 'Saratoga Estates', 33.2563896179199, 0.580433496158762, -87.6366729736328, -1.52954848888342, 218, 2, 'PPL', 'P'),
(152364, 'Saratoga Lake', 43.0511093139648, 0.751383604164684, -73.7219390869141, -1.28669056802135, 218, 40, 'PPL', 'P'),
(106048, 'Saratoga Place', 36.7216682434082, 0.640914017672516, -76.595832824707, -1.33684947609829, 218, 53, 'PPL', 'P'),
(205680, 'Saratoga Resort', 40.3488883972168, 0.704220952051171, -111.904998779297, -1.95311067813897, 218, 52, 'PPL', 'P'),
(208666, 'Saratoga Shores', 48.1366691589355, 0.840143367766635, -122.510276794434, -2.13820769759247, 218, 56, 'PPL', 'P'),
(90618, 'Saratoga Springs', 35.7155609130859, 0.623354132129942, -85.2452774047852, -1.48781076248943, 218, 50, 'PPL', 'P'),
(152365, 'Saratoga Springs', 43.0830612182617, 0.751941270096946, -73.7850036621094, -1.28779125249988, 218, 40, 'PPL', 'P'),
(184980, 'Saratoga Springs', 39.1752815246582, 0.68373764800099, -122.979721069336, -2.14640104584415, 218, 6, 'PPL', 'P'),
(205681, 'Saratoga Springs', 40.3491706848145, 0.704225878899187, -111.90389251709, -1.95309137022106, 218, 52, 'PPL', 'P'),
(140842, 'Saratoga Springs (historical)', 46.5547218322754, 0.812533178323293, -98.4963912963867, -1.71908632945463, 218, 34, 'PPL', 'P'),
(83505, 'Saratt', 34.8958282470703, 0.609047098121818, -81.540283203125, -1.42314641490316, 218, 48, 'PPL', 'P'),
(51224, 'Sarawoods', 39.4308280944824, 0.6881977770366, -76.8036117553711, -1.34047590255465, 218, 25, 'PPL', 'P'),
(199667, 'Sarben', 41.1650009155273, 0.718464802562432, -101.306671142578, -1.76813496567311, 218, 35, 'PPL', 'P'),
(97878, 'Sarber', 32.8169403076172, 0.572763658798361, -94.4622192382813, -1.64867674444874, 218, 51, 'PPL', 'P'),
(187325, 'Sarcillo', 37.125560760498, 0.647963271919901, -104.758888244629, -1.82838752059756, 218, 7, 'PPL', 'P'),
(97879, 'Sarco', 28.5113201141357, 0.497616410081754, -97.4019165039063, -1.69998414074577, 218, 51, 'PPL', 'P'),
(57427, 'Sarcoxie', 37.0691719055176, 0.646979100739062, -94.1163864135742, -1.64264082299613, 218, 29, 'PPL', 'P'),
(5660, 'Sardine', 31.1311092376709, 0.543340355995379, -87.3666687011719, -1.52483602533453, 218, 2, 'PPL', 'P'),
(42978, 'Sardine Point Settlement (historical)', 30.3374996185303, 0.529489255165877, -91.2099990844727, -1.59191479476506, 218, 22, 'PPL', 'P'),
(31076, 'Sardinia', 39.1538887023926, 0.683364272816161, -85.6311111450195, -1.4945448316218, 218, 19, 'PPL', 'P'),
(74211, 'Sardinia', 39.0077781677246, 0.680814162914355, -83.8086090087891, -1.46273616871995, 218, 41, 'PPL', 'P'),
(83506, 'Sardinia', 33.834171295166, 0.590517688784401, -80.0830612182617, -1.39771309333485, 218, 48, 'PPL', 'P'),
(152368, 'Sardinia', 42.5411109924316, 0.742482454274285, -78.5083312988281, -1.37022887141107, 218, 40, 'PPL', 'P'),
(5667, 'Sardis', 33.7966690063477, 0.589863150367487, -87.1488876342773, -1.52103502866871, 218, 2, 'PPL', 'P'),
(11809, 'Sardis', 34.5316696166992, 0.60269133102229, -92.4077835083008, -1.61282007668997, 218, 4, 'PPL', 'P'),
(24675, 'Sardis', 32.7963905334473, 0.572404997578554, -84.6388931274414, -1.47722736031745, 218, 13, 'PPL', 'P'),
(38109, 'Sardis', 37.0455589294434, 0.646566976560372, -84.6961135864258, -1.47822604572623, 218, 21, 'PPL', 'P'),
(42976, 'Sardis', 31.8447208404541, 0.55579522804438, -92.7072219848633, -1.61804626401314, 218, 22, 'PPL', 'P'),
(61673, 'Sardis', 34.436939239502, 0.601037974038541, -89.9158325195313, -1.56932732713761, 218, 30, 'PPL', 'P'),
(74212, 'Sardis', 39.6227798461914, 0.691547967108892, -80.9127807617188, -1.41219443123632, 218, 41, 'PPL', 'P'),
(77185, 'Sardis', 34.665828704834, 0.605032848831715, -95.4094390869141, -1.66520884954762, 218, 42, 'PPL', 'P'),
(83508, 'Sardis', 34.6713905334473, 0.605129921053448, -81.6333312988281, -1.42477041053589, 218, 48, 'PPL', 'P'),
(90619, 'Sardis', 35.4422187805176, 0.618583411932201, -88.2936096191406, -1.54101419632454, 218, 50, 'PPL', 'P'),
(106049, 'Sardis', 37.6213912963867, 0.656617147303086, -79.1130599975586, -1.38078337828521, 218, 53, 'PPL', 'P'),
(111295, 'Sardis', 39.3375015258789, 0.68656892113488, -80.4180603027344, -1.40355993035006, 218, 58, 'PPL', 'P'),
(166879, 'Sardis', 40.4916687011719, 0.706712938462185, -79.6919403076172, -1.3908867456707, 218, 45, 'PPL', 'P'),
(192179, 'Sardis', 32.7555618286133, 0.571692402249876, -100.495559692383, -1.75397840026658, 218, 51, 'PPL', 'P'),
(11810, 'Sardis (historical)', 33.5505599975586, 0.585567737845298, -93.5555572509766, -1.6328525075676, 218, 4, 'PPL', 'P'),
(68549, 'Sardis (historical)', 35.8677787780762, 0.626010835054378, -81.4741668701172, -1.42199246720283, 218, 33, 'PPL', 'P'),
(5668, 'Sardis City', 34.1741714477539, 0.596451810904343, -86.1227798461914, -1.50312606928626, 218, 2, 'PPL', 'P'),
(24677, 'Sardis Estates', 34.089168548584, 0.594968230440087, -83.9066696166992, -1.46444764919449, 218, 13, 'PPL', 'P'),
(24678, 'Sardis Heights', 34.3761100769043, 0.599976304869981, -83.904167175293, -1.46440397335261, 218, 13, 'PPL', 'P'),
(24679, 'Sardis Shores', 34.3472213745117, 0.599472101896602, -83.9130630493164, -1.46455923564416, 218, 13, 'PPL', 'P'),
(5669, 'Sardis Springs', 34.8363914489746, 0.608009730298205, -86.8852767944336, -1.51643415156949, 218, 2, 'PPL', 'P'),
(24680, 'Sardum (historical)', 33.753059387207, 0.589102018927942, -84.0133285522461, -1.46630919879646, 218, 13, 'PPL', 'P'),
(68555, 'Sarecta', 34.978889465332, 0.610496789861203, -77.857780456543, -1.35887461726157, 218, 33, 'PPL', 'P'),
(68556, 'Sarem', 36.4833297729492, 0.636754226628839, -76.7919387817383, -1.34027217073126, 218, 33, 'PPL', 'P'),
(42977, 'Sarepta', 32.8927803039551, 0.574087316439157, -93.4483337402344, -1.6309811042696, 218, 22, 'PPL', 'P'),
(61675, 'Sarepta', 34.124439239502, 0.595583820126059, -89.2874984741211, -1.55836082924283, 218, 30, 'PPL', 'P'),
(146263, 'Sarepta', 40.8566703796387, 0.713083419526736, -75.0299987792969, -1.30952051646606, 218, 37, 'PPL', 'P'),
(61676, 'Sarepta (historical)', 31.8730602264404, 0.556289843637835, -90.7666702270508, -1.58417724653395, 218, 30, 'PPL', 'P'),
(137991, 'Sargeant', 43.8052787780762, 0.764546344431428, -92.8019409179688, -1.6196994212598, 218, 28, 'PPL', 'P'),
(17996, 'Sargent', 30.5738906860352, 0.533615057616141, -82.429443359375, -1.43866518720727, 218, 12, 'PPL', 'P'),
(24681, 'Sargent', 33.4322204589844, 0.583502323261887, -84.8694381713867, -1.48125113040845, 218, 13, 'PPL', 'P'),
(57430, 'Sargent', 37.086669921875, 0.647284498737067, -92.0269393920898, -1.60617309292524, 218, 29, 'PPL', 'P'),
(97888, 'Sargent', 32.7369384765625, 0.571367363438832, -96.7794418334961, -1.68911990823684, 218, 51, 'PPL', 'P'),
(142952, 'Sargent', 41.6405601501465, 0.726764876994801, -99.3708267211914, -1.73434810671355, 218, 35, 'PPL', 'P'),
(184981, 'Sargent', 36.9194412231445, 0.644365807340395, -121.546943664551, -2.12139436268247, 218, 6, 'PPL', 'P'),
(144421, 'Sargent (historical)', 43.0563888549805, 0.7514757495384, -71.6511077880859, -1.25054774360345, 218, 36, 'PPL', 'P'),
(144422, 'Sargent Corners', 42.8613891601563, 0.748072362823334, -71.043327331543, -1.2399399735075, 218, 36, 'PPL', 'P'),
(74214, 'Sargents', 39.0033302307129, 0.68073653176858, -83.023063659668, -1.44902581595406, 218, 41, 'PPL', 'P'),
(187326, 'Sargents', 38.4041709899902, 0.67027923027422, -106.414436340332, -1.8572822857927, 218, 7, 'PPL', 'P'),
(128748, 'Sargentville', 44.3013916015625, 0.77320514666263, -68.6730575561523, -1.19857096176643, 218, 26, 'PPL', 'P'),
(195588, 'Sarilda', 44.110279083252, 0.769869603976333, -111.573059082031, -1.94731723750361, 218, 17, 'PPL', 'P'),
(97884, 'Sarita', 27.2213897705078, 0.475102878464065, -97.7888870239258, -1.70673805042826, 218, 51, 'PPL', 'P'),
(140846, 'Sarles', 48.9458312988281, 0.854265911290243, -98.9955596923828, -1.72779846148667, 218, 34, 'PPL', 'P'),
(152370, 'Sarles Corners', 41.1841697692871, 0.718799362174373, -73.5697174072266, -1.28403379851789, 218, 40, 'PPL', 'P'),
(97885, 'Saron', 31.0356197357178, 0.541673749785208, -95.2638931274414, -1.66266859334185, 218, 51, 'PPL', 'P'),
(176271, 'Sarona', 45.711109161377, 0.797809359604572, -91.8063888549805, -1.60232375988564, 218, 57, 'PPL', 'P'),
(142954, 'Saronville', 40.6011085510254, 0.708623024175017, -97.9380569458008, -1.70934155670993, 218, 35, 'PPL', 'P'),
(42980, 'Sarpy (historical)', 30.000560760498, 0.523608562715305, -90.4075012207031, -1.57790856480206, 218, 22, 'PPL', 'P'),
(197481, 'Sarpy (historical)', 45.7958297729492, 0.799288013220811, -106.952217102051, -1.86666833073857, 218, 31, 'PPL', 'P'),
(90621, 'Sartain Springs', 35.2847213745117, 0.615834563634049, -85.7805633544922, -1.49715326475148, 218, 50, 'PPL', 'P'),
(137994, 'Sartell', 45.6216697692871, 0.796248347731622, -94.206672668457, -1.64421661541313, 218, 28, 'PPL', 'P'),
(61677, 'Sartinville', 31.326940536499, 0.546758256938387, -90.1161117553711, -1.57282285922639, 218, 30, 'PPL', 'P'),
(111296, 'Sarton', 37.5825004577637, 0.655938374120252, -80.6402816772461, -1.4074384250036, 218, 58, 'PPL', 'P'),
(83510, 'Sartor Town', 34.5175018310547, 0.602444056515076, -81.5411071777344, -1.42316079597305, 218, 48, 'PPL', 'P'),
(42979, 'Sartori (historical)', 31.0194396972656, 0.541391354841118, -92.3908309936523, -1.61252419949286, 218, 22, 'PPL', 'P'),
(142956, 'Sartoria', 40.978328704834, 0.715206757863857, -99.2136077880859, -1.73160411868439, 218, 35, 'PPL', 'P'),
(166880, 'Sartwell', 41.8797187805176, 0.730938982529336, -78.3499984741211, -1.36746544230595, 218, 45, 'PPL', 'P'),
(166881, 'Sarver', 40.7313919067383, 0.710896897692754, -79.7461090087891, -1.39183216785768, 218, 45, 'PPL', 'P'),
(166882, 'Sarversville', 40.7194404602051, 0.710688305600374, -79.7558288574219, -1.39200181121912, 218, 45, 'PPL', 'P'),
(83511, 'Sarvis Crossroads', 34.0411109924316, 0.594129467854767, -78.9672164916992, -1.37823792891532, 218, 48, 'PPL', 'P'),
(57432, 'Sarvis Point', 37.105281829834, 0.647609337811029, -92.8388900756836, -1.62034430571777, 218, 29, 'PPL', 'P'),
(179101, 'Sasabe', 31.4886093139648, 0.549579909402839, -111.541389465332, -1.94676449841936, 218, 5, 'PPL', 'P'),
(77186, 'Sasakwa', 34.9486083984375, 0.609968285542877, -96.5250015258789, -1.68467908711914, 218, 42, 'PPL', 'P'),
(97886, 'Sash', 33.7472190856934, 0.58900008643722, -95.9111099243164, -1.67396465742153, 218, 51, 'PPL', 'P'),
(97887, 'Saspamco', 29.2341709136963, 0.510232536534759, -98.2955627441406, -1.71558120998593, 218, 51, 'PPL', 'P'),
(31078, 'Sassafras', 38.1883316040039, 0.666512122333276, -86.6902770996094, -1.51303076485442, 218, 19, 'PPL', 'P'),
(38111, 'Sassafras', 37.2205581665039, 0.649621289435557, -83.0552825927734, -1.44958814241823, 218, 21, 'PPL', 'P'),
(51225, 'Sassafras', 39.3730583190918, 0.687189504247896, -75.8027801513672, -1.32300809580676, 218, 25, 'PPL', 'P'),
(106050, 'Sassafras', 37.4066696166992, 0.652869547017127, -76.6069412231445, -1.33704335422564, 218, 53, 'PPL', 'P'),
(111298, 'Sassafras', 38.9341697692871, 0.679529454004501, -82.0130615234375, -1.43139795322466, 218, 58, 'PPL', 'P'),
(11811, 'Sassafras (historical)', 34.3866691589355, 0.600160595617415, -91.329719543457, -1.59400431095634, 218, 4, 'PPL', 'P'),
(14553, 'Sassafras Landing', 38.4988899230957, 0.671932387520887, -75.0830612182617, -1.31044663073513, 218, 10, 'PPL', 'P'),
(24682, 'Sassafrass Hills', 33.0777816772461, 0.577316199523797, -85.0461120605469, -1.4843346714766, 218, 13, 'PPL', 'P'),
(166883, 'Sassamansville', 40.3419418334961, 0.704099711642545, -75.5725021362305, -1.31898898624767, 218, 45, 'PPL', 'P'),
(24683, 'Sasser', 31.7197208404541, 0.553613566479387, -84.3472213745117, -1.47213672789377, 218, 13, 'PPL', 'P'),
(38112, 'Sasser', 37.0713882446289, 0.647017783153895, -83.89111328125, -1.46417613992136, 218, 21, 'PPL', 'P'),
(68559, 'Sassers Mill', 35.1372184753418, 0.613260152387296, -77.4449996948242, -1.35167023388069, 218, 33, 'PPL', 'P'),
(106051, 'Sassin (historical)', 37.1583290100098, 0.648535185763995, -80.8013916015625, -1.41025032364056, 218, 53, 'PPL', 'P'),
(187327, 'Satank', 39.413890838623, 0.687902166155601, -107.227783203125, -1.8714778665092, 218, 7, 'PPL', 'P'),
(126031, 'Satans Kingdom', 42.7125015258789, 0.745473783389689, -72.4805603027344, -1.26502442097301, 218, 23, 'PPL', 'P'),
(172500, 'Satans Kingdom', 43.8763885498047, 0.765787444078432, -73.0647201538086, -1.27521993373222, 218, 55, 'PPL', 'P'),
(187880, 'Satanta', 37.4372215270996, 0.653402778446388, -100.971672058105, -1.7622881286579, 218, 20, 'PPL', 'P'),
(61678, 'Satartia', 32.6708297729492, 0.570213548896555, -90.5441665649414, -1.58029382503239, 218, 30, 'PPL', 'P'),
(189532, 'Satathite Place', 33.9080581665039, 0.591807257963245, -107.732780456543, -1.88029173129487, 218, 38, 'PPL', 'P'),
(17997, 'Satellite Beach', 28.1758308410645, 0.491761017661538, -80.5902786254883, -1.40656570711438, 218, 12, 'PPL', 'P'),
(184983, 'Saticoy', 34.2830581665039, 0.598352242658224, -119.148887634277, -2.0795403893069, 218, 6, 'PPL', 'P'),
(24684, 'Satilla', 31.7872200012207, 0.554791649077097, -82.5680618286133, -1.44108453589955, 218, 13, 'PPL', 'P'),
(24686, 'Satilla Shores', 31.125560760498, 0.543243516800241, -81.5561065673828, -1.4234225847082, 218, 13, 'PPL', 'P'),
(97893, 'Satin', 31.3463897705078, 0.547097710108831, -97.0313873291016, -1.69351718667073, 218, 51, 'PPL', 'P'),
(28542, 'Sato', 37.9088897705078, 0.661634942270959, -89.4305572509766, -1.56085767592283, 218, 18, 'PPL', 'P'),
(83513, 'Sato', 33.3216705322266, 0.581572863052125, -81.1277770996094, -1.41594682521224, 218, 48, 'PPL', 'P'),
(24687, 'Satolah', 34.9902801513672, 0.610695594836577, -83.1930618286133, -1.45199284372452, 218, 13, 'PPL', 'P'),
(208667, 'Satsop', 47.0033302307129, 0.820362871928126, -123.482223510742, -2.155171367946, 218, 56, 'PPL', 'P'),
(5671, 'Satsuma', 30.8530597686768, 0.53848747727801, -88.0561065673828, -1.53686898608783, 218, 2, 'PPL', 'P'),
(17998, 'Satsuma', 29.5547199249268, 0.515827172194743, -81.6561126708984, -1.42516802048664, 218, 12, 'PPL', 'P'),
(42981, 'Satsuma', 30.5025005340576, 0.532369064410634, -90.8002777099609, -1.58476380776404, 218, 22, 'PPL', 'P'),
(97889, 'Satsuma', 29.9030609130859, 0.521906869357772, -95.6030578613281, -1.66858813465482, 218, 51, 'PPL', 'P'),
(17999, 'Satsuma Heights', 30.5855598449707, 0.533818722860505, -87.2688903808594, -1.523129471708, 218, 12, 'PPL', 'P'),
(166884, 'Satterfield', 41.4902801513672, 0.724141996216209, -76.4088897705078, -1.33358670428878, 218, 45, 'PPL', 'P'),
(90622, 'Satterfield (historical)', 35.7574996948242, 0.62408610195555, -86.9841690063477, -1.51816014627197, 218, 50, 'PPL', 'P'),
(111299, 'Satterfield (historical)', 39.542781829834, 0.690151738328391, -80.3899993896484, -1.4030701750256, 218, 58, 'PPL', 'P'),
(68560, 'Satterwhite', 36.3863906860352, 0.635062320388312, -78.6866683959961, -1.3733414409351, 218, 33, 'PPL', 'P'),
(77187, 'Satterwhite', 34.5647201538086, 0.603268171714401, -97.4047164916992, -1.70003300975177, 218, 42, 'PPL', 'P'),
(111300, 'Sattes', 38.3913917541504, 0.670056190532926, -81.8186111450195, -1.42800415388952, 218, 58, 'PPL', 'P'),
(97890, 'Sattler', 29.8477802276611, 0.520942039384349, -98.1752777099609, -1.71348184009862, 218, 51, 'PPL', 'P'),
(184984, 'Sattley', 39.6161117553711, 0.691431586969256, -120.426109313965, -2.1018321128953, 218, 6, 'PPL', 'P'),
(117681, 'Sattre', 43.392219543457, 0.757337100781556, -91.6394424438477, -1.59940999533698, 218, 16, 'PPL', 'P'),
(126032, 'Satucket', 42.021671295166, 0.733416521291437, -70.9494400024414, -1.23830133048878, 218, 23, 'PPL', 'P'),
(11812, 'Satuma', 34.9025001525879, 0.609163544840482, -92.8591690063477, -1.62069823982664, 218, 4, 'PPL', 'P'),
(97892, 'Saturn', 29.5986099243164, 0.516593197192791, -97.3433303833008, -1.69896162004523, 218, 51, 'PPL', 'P'),
(123626, 'Saturn', 41.0347213745117, 0.716190995623723, -85.3555603027344, -1.48973556216728, 218, 19, 'PPL', 'P'),
(208668, 'Satus', 46.2702789306641, 0.807568713156249, -120.149169921875, -2.09699860867486, 218, 56, 'PPL', 'P'),
(51226, 'Satyr Hill Estates', 39.4091682434082, 0.687819741319863, -76.5472183227539, -1.33600099297499, 218, 25, 'PPL', 'P'),
(113119, 'Sauble', 44.0341682434082, 0.768541219224601, -85.9991683959961, -1.50096864248718, 218, 27, 'PPL', 'P'),
(58, 'Sauceda Colonia', 26.3560009002686, 0.459998993368276, -98.1480026245117, -1.71300580005377, 218, 51, 'PPL', 'P'),
(184986, 'Saucelito', 35.9791717529297, 0.627955009229163, -119.177780151367, -2.0800446588593, 218, 6, 'PPL', 'P'),
(5672, 'Saucer', 31.8227806091309, 0.55541229876914, -86.835563659668, -1.51556649368634, 218, 2, 'PPL', 'P'),
(61679, 'Saucier', 30.6355590820313, 0.534691374170697, -89.1350021362305, -1.5556992660494, 218, 30, 'PPL', 'P'),
(166885, 'Saucon', 40.6194381713867, 0.708942936400963, -75.3369369506836, -1.31487759815681, 218, 45, 'PPL', 'P'),
(166886, 'Saucon Valley', 40.5472183227539, 0.707682462257028, -75.4297180175781, -1.31649693325763, 218, 45, 'PPL', 'P'),
(166887, 'Saucon Valley Terrace', 40.582218170166, 0.708293324832065, -75.370002746582, -1.31545470516503, 218, 45, 'PPL', 'P'),
(166888, 'Saucona', 40.5566711425781, 0.707847445086559, -75.341667175293, -1.3149601561506, 218, 45, 'PPL', 'P'),
(117682, 'Saude', 43.1980590820313, 0.753948361452485, -92.1611099243164, -1.60851481047174, 218, 16, 'PPL', 'P'),
(61680, 'Sauer', 31.101390838623, 0.542821672083573, -89.8300018310547, -1.56782929902444, 218, 30, 'PPL', 'P'),
(121373, 'Sauganash', 41.9900016784668, 0.732863782207191, -87.7422180175781, -1.53139059740943, 218, 18, 'PPL', 'P'),
(114025, 'Saugatuck', 41.122501373291, 0.717723045619818, -73.3705596923828, -1.28055784066312, 218, 8, 'PPL', 'P'),
(133011, 'Saugatuck', 42.6549987792969, 0.744470171132893, -86.2019424438477, -1.50450771725979, 218, 27, 'PPL', 'P'),
(114026, 'Saugatuck Shores', 41.0972213745117, 0.717281826406219, -73.3711090087891, -1.28056742804304, 218, 8, 'PPL', 'P'),
(152372, 'Saugerties', 42.0774993896484, 0.73439090535527, -73.9533309936523, -1.2907291186564, 218, 40, 'PPL', 'P'),
(28543, 'Sauget', 38.5963897705078, 0.67363408087842, -90.1847229003906, -1.57402034961055, 218, 18, 'PPL', 'P'),
(42982, 'Saughy (historical)', 31.5194396972656, 0.55011800110109, -91.5272216796875, -1.59745137351328, 218, 22, 'PPL', 'P'),
(126033, 'Saugus', 42.4647216796875, 0.741149209253564, -71.0105590820313, -1.23936805966341, 218, 23, 'PPL', 'P'),
(184988, 'Saugus', 34.4113883972168, 0.600592027714007, -118.539169311523, -2.0688987970651, 218, 6, 'PPL', 'P'),
(197482, 'Saugus', 46.6916694641113, 0.814923365401639, -105.491668701172, -1.8411769522585, 218, 31, 'PPL', 'P'),
(13203, 'Sauis Addition (historical)', 38.9500007629395, 0.679805756967597, -77.0305633544922, -1.34443695520198, 218, 9, 'PPL', 'P'),
(208669, 'Sauk', 48.4749984741211, 0.84604832827264, -121.625282287598, -2.12276162958612, 218, 56, 'PPL', 'P'),
(137996, 'Sauk Centre', 45.7374992370605, 0.798269953315101, -94.9522171020508, -1.65722882049925, 218, 28, 'PPL', 'P'),
(176273, 'Sauk City', 43.2708282470703, 0.755218422976343, -89.7219390869141, -1.56594324834045, 218, 57, 'PPL', 'P'),
(137999, 'Sauk Rapids', 45.5919418334961, 0.795729497372247, -94.1658325195313, -1.64350382034737, 218, 28, 'PPL', 'P'),
(176276, 'Sauk Trail Beach', 43.5286102294922, 0.759717567321923, -87.7944412231445, -1.53230206429251, 218, 57, 'PPL', 'P'),
(121374, 'Sauk Village', 41.4883308410645, 0.724107974333283, -87.567497253418, -1.52834114480323, 218, 18, 'PPL', 'P'),
(61681, 'Saukum', 31.2311096191406, 0.545085691905276, -91.1847229003906, -1.59147364213049, 218, 30, 'PPL', 'P'),
(176277, 'Saukville', 43.3816719055176, 0.757153009771204, -87.940559387207, -1.53485230735237, 218, 57, 'PPL', 'P'),
(38113, 'Saul', 37.2724990844727, 0.65052782947062, -83.4955596923828, -1.45727242742754, 218, 21, 'PPL', 'P'),
(11813, 'Saulsburg', 34.9700012207031, 0.610341660727706, -91.2161102294922, -1.59202145436672, 218, 4, 'PPL', 'P'),
(166889, 'Saulsburg', 40.6205596923828, 0.708962510634975, -77.8949966430664, -1.35952416225144, 218, 45, 'PPL', 'P'),
(51227, 'Saulsbury', 38.8980598449707, 0.678899216932534, -76.0238876342773, -1.32686714938434, 218, 25, 'PPL', 'P'),
(90624, 'Saulsbury', 36.1722183227539, 0.631324307482277, -86.1241683959961, -1.50315030405218, 218, 50, 'PPL', 'P'),
(111301, 'Saulsbury', 39.122501373291, 0.682816460579931, -81.5436096191406, -1.42320447181492, 218, 58, 'PPL', 'P'),
(14554, 'Saulsbury Switch', 38.7016716003418, 0.675471595451547, -75.3436126708984, -1.3149941114545, 218, 10, 'PPL', 'P'),
(68561, 'Saulston', 35.439998626709, 0.618544662938341, -77.898063659668, -1.35957769178935, 218, 33, 'PPL', 'P'),
(111302, 'Saulsville', 37.6427803039551, 0.656990455908888, -81.4569396972656, -1.42169179631576, 218, 58, 'PPL', 'P'),
(133014, 'Sault Ste. Marie', 46.4952812194824, 0.811495743920652, -84.3452835083008, -1.47210290574792, 218, 27, 'PPL', 'P'),
(138002, 'Saum', 47.9747200012207, 0.837316821743679, -94.6766662597656, -1.65241955104474, 218, 28, 'PPL', 'P'),
(106052, 'Saumsville', 38.9355583190918, 0.679553688770421, -78.4994430541992, -1.37007374227757, 218, 53, 'PPL', 'P'),
(18001, 'Saunders', 30.4291706085205, 0.531089215769769, -85.4250030517578, -1.49094756677938, 218, 12, 'PPL', 'P'),
(24689, 'Saunders', 32.2119407653809, 0.562204424813278, -83.0622177124023, -1.44970918308977, 218, 13, 'PPL', 'P'),
(28544, 'Saunders', 39.8519401550293, 0.695547569013001, -89.3072204589844, -1.55870504281372, 218, 18, 'PPL', 'P'),
(51230, 'Saunders', 39.1555595397949, 0.683393434430097, -76.6305618286133, -1.33745561156239, 218, 25, 'PPL', 'P'),
(57433, 'Saunders', 36.8722190856934, 0.643541625562042, -93.105827331543, -1.62500323972875, 218, 29, 'PPL', 'P'),
(68563, 'Saunders', 34.9902801513672, 0.610695594836577, -79.2399978637695, -1.38299886199605, 218, 33, 'PPL', 'P'),
(106053, 'Saunders', 36.6399993896484, 0.639488627278078, -76.5758285522461, -1.33650033567938, 218, 53, 'PPL', 'P'),
(111303, 'Saunders', 37.7997207641602, 0.659729583669062, -81.6725006103516, -1.42545404398771, 218, 58, 'PPL', 'P'),
(142958, 'Saunders', 41.586109161377, 0.725814527959806, -98.8880615234375, -1.7259222644987, 218, 35, 'PPL', 'P'),
(176280, 'Saunders', 46.6386108398438, 0.813997317711591, -92.10888671875, -1.60760334358866, 218, 57, 'PPL', 'P'),
(187328, 'Saunders', 38.7602806091309, 0.676494515626247, -108.009437561035, -1.8851203086673, 218, 7, 'PPL', 'P'),
(187881, 'Saunders', 37.4711112976074, 0.653994266524494, -102.038887023926, -1.78091454363802, 218, 20, 'PPL', 'P'),
(111304, 'Saunders Addition', 38.454719543457, 0.671161468964336, -81.8758316040039, -1.4290028392983, 218, 58, 'PPL', 'P'),
(201536, 'Saunders Lake', 43.5250015258789, 0.759654583562143, -124.215278625488, -2.16796559329691, 218, 43, 'PPL', 'P'),
(193930, 'Saunders Place', 40.0505599975586, 0.69901413922493, -122.54638671875, -2.13883793466444, 218, 6, 'PPL', 'P'),
(51228, 'Saunders Point', 38.8875007629395, 0.6787149261851, -76.4925003051758, -1.33504598340808, 218, 25, 'PPL', 'P'),
(114027, 'Saunders Point', 41.3408317565918, 0.721533629665558, -72.1861114501953, -1.25988531901749, 218, 8, 'PPL', 'P'),
(169594, 'Saunderstown', 41.5077781677246, 0.724447394214214, -71.4250030517578, -1.24660147150017, 218, 47, 'PPL', 'P'),
(74215, 'Saundersville', 38.6599998474121, 0.674744286157847, -82.3563919067383, -1.43739019883539, 218, 41, 'PPL', 'P'),
(90625, 'Saundersville', 36.3258285522461, 0.634005311751659, -86.5644378662109, -1.51083445590344, 218, 50, 'PPL', 'P'),
(126035, 'Saundersville', 42.1813888549805, 0.73620411858345, -71.704719543457, -1.25148344525245, 218, 23, 'PPL', 'P'),
(169588, 'Saundersville', 41.815559387207, 0.729819189869985, -71.5747222900391, -1.24921456516176, 218, 47, 'PPL', 'P'),
(121375, 'Saunemin', 40.8930587768555, 0.713718516867693, -88.4052810668945, -1.54296323076832, 218, 18, 'PPL', 'P'),
(97894, 'Sauney Stand', 30.0933303833008, 0.525227698079046, -96.2225036621094, -1.67939950341611, 218, 51, 'PPL', 'P'),
(68564, 'Saunook', 35.4516716003418, 0.618748394761732, -83.0447235107422, -1.4494038516708, 218, 33, 'PPL', 'P'),
(176281, 'Sauntry', 46.374439239502, 0.809386653495364, -91.8225021362305, -1.60260498969675, 218, 57, 'PPL', 'P'),
(152374, 'Sauquoit', 43.0041694641113, 0.750564349234348, -75.2602767944336, -1.31353962602515, 218, 40, 'PPL', 'P'),
(184991, 'Sausalito', 37.8591690063477, 0.660767151229757, -122.484169006348, -2.13775203072996, 218, 6, 'PPL', 'P'),
(5673, 'Sauta (historical)', 34.5708312988281, 0.603374831316059, -86.0875015258789, -1.50251034644223, 218, 2, 'PPL', 'P'),
(24688, 'Sautee', 34.684440612793, 0.605357687905677, -83.6808319091797, -1.46050603762312, 218, 13, 'PPL', 'P'),
(192180, 'Sauz Creek Colonia', 28.7660007476807, 0.502061425678178, -100.484001159668, -1.75377666581401, 218, 51, 'PPL', 'P'),
(38115, 'Savage', 36.6927795410156, 0.640409814699136, -85.0477828979492, -1.48436383309054, 218, 21, 'PPL', 'P'),
(51229, 'Savage', 39.1377792358398, 0.683083109584076, -76.8241729736328, -1.34083476351154, 218, 25, 'PPL', 'P'),
(61682, 'Savage', 34.6297187805176, 0.604402611759747, -90.2230606079102, -1.57468946883443, 218, 30, 'PPL', 'P'),
(68567, 'Savage', 36.4850006103516, 0.636783388242775, -76.5911102294922, -1.33676705126255, 218, 33, 'PPL', 'P'),
(112528, 'Savage', 39.7733306884766, 0.694175574998419, -79.2050018310547, -1.38238806600004, 218, 45, 'PPL', 'P'),
(138003, 'Savage', 44.7791709899902, 0.781543970088858, -93.3361129760742, -1.6290224824459, 218, 28, 'PPL', 'P'),
(192181, 'Savage', 33.5927810668945, 0.586304634518923, -101.432502746582, -1.77033114146605, 218, 51, 'PPL', 'P'),
(197484, 'Savage', 47.4536094665527, 0.828221727146895, -104.342216491699, -1.82111522660888, 218, 31, 'PPL', 'P'),
(28545, 'Savage (historical)', 39.7813911437988, 0.694316256483003, -90.2108306884766, -1.57447601647306, 218, 18, 'PPL', 'P'),
(38114, 'Savage Branch', 38.3441696166992, 0.669232008754573, -82.5980606079102, -1.44160811336986, 218, 21, 'PPL', 'P'),
(42983, 'Savage Fork', 31.0319404602051, 0.541609534313423, -93.3533325195313, -1.62932302017491, 218, 22, 'PPL', 'P'),
(106054, 'Savage Town', 37.5519409179688, 0.655405009532937, -75.8016662597656, -1.32298865473081, 218, 53, 'PPL', 'P'),
(68568, 'Savages Crossroads', 36.5019416809082, 0.637079065702802, -76.8111114501953, -1.34060679692222, 218, 33, 'PPL', 'P'),
(209724, 'Savageton', 43.8658294677734, 0.765603153330998, -105.78694152832, -1.84633043528391, 218, 59, 'PPL', 'P'),
(74216, 'Savageville', 39.1388893127441, 0.683102484081006, -82.7191696166992, -1.44372186432706, 218, 41, 'PPL', 'P'),
(106055, 'Savageville', 37.6808280944824, 0.657654515126699, -75.7572174072266, -1.32221287590527, 218, 53, 'PPL', 'P'),
(144424, 'Savageville', 44.211669921875, 0.771639207941663, -71.894172668457, -1.25479002606189, 218, 36, 'PPL', 'P'),
(31077, 'Savah', 38.0177803039551, 0.663535440603867, -87.9786071777344, -1.53551636657018, 218, 19, 'PPL', 'P'),
(166890, 'Savan', 40.8216705322266, 0.7124725569517, -78.9974975585938, -1.37876643323364, 218, 45, 'PPL', 'P'),
(77189, 'Savanna', 34.8288917541504, 0.607878835930628, -95.8436126708984, -1.67278660811333, 218, 42, 'PPL', 'P'),
(121377, 'Savanna', 42.0944404602051, 0.734686582815296, -90.1566696166992, -1.57353072744414, 218, 18, 'PPL', 'P'),
(112552, 'Savanna Creek', 33.2866706848145, 0.580962000477088, -79.7574996948242, -1.39203097283306, 218, 48, 'PPL', 'P'),
(24692, 'Savanna Place', 34.0916709899902, 0.595011906281964, -84.5697174072266, -1.47602001623727, 218, 13, 'PPL', 'P'),
(83514, 'Savanna Town (historical)', 33.4249992370605, 0.583376289163299, -81.9097213745117, -1.4295943273764, 218, 48, 'PPL', 'P'),
(24690, 'Savannah', 32.0833282470703, 0.559959712909478, -81.0999984741211, -1.41546199673579, 218, 13, 'PPL', 'P'),
(57436, 'Savannah', 39.9416694641113, 0.697113640892022, -94.8300018310547, -1.65509576162416, 218, 29, 'PPL', 'P'),
(61683, 'Savannah', 30.7394409179688, 0.536504454240823, -89.4908294677734, -1.56190962455341, 218, 30, 'PPL', 'P'),
(68570, 'Savannah', 35.3411102294922, 0.616818734814887, -77.51611328125, -1.35291140010672, 218, 33, 'PPL', 'P'),
(90626, 'Savannah', 35.2247200012207, 0.614787342114402, -88.2491683959961, -1.54023855065705, 218, 50, 'PPL', 'P'),
(117683, 'Savannah', 40.6241683959961, 0.709025494394755, -92.4541702270508, -1.61362967766135, 218, 16, 'PPL', 'P'),
(152375, 'Savannah', 43.0672187805176, 0.751664767396769, -76.7600021362305, -1.3397147711151, 218, 40, 'PPL', 'P'),
(157545, 'Savannah', 40.9652786254883, 0.714978991011628, -82.3652801513672, -1.43754532796889, 218, 41, 'PPL', 'P'),
(97895, 'Savannah (historical)', 33.5361099243164, 0.585315536490068, -94.8450012207031, -1.65535755035931, 218, 51, 'PPL', 'P'),
(184992, 'Savannah (historical)', 34.0766716003418, 0.59475011754681, -118.0625, -2.06057934813581, 218, 6, 'PPL', 'P'),
(90627, 'Savannah Bay', 35.1588897705078, 0.613638387841115, -85.0586090087891, -1.48455278436988, 218, 50, 'PPL', 'P'),
(24691, 'Savannah Beach', 31.9936103820801, 0.558393840767538, -80.8486099243164, -1.41107443883988, 218, 13, 'PPL', 'P'),
(61684, 'Savannah Grove', 32.3450012207031, 0.564526767862855, -88.7444381713867, -1.54888263892323, 218, 30, 'PPL', 'P'),
(83515, 'Savannah Grove', 34.1500015258789, 0.596029966187674, -79.8294372558594, -1.39328652012897, 218, 48, 'PPL', 'P'),
(90628, 'Savannah Hills', 35.1575012207031, 0.613614153075195, -85.0652770996094, -1.48466916450952, 218, 50, 'PPL', 'P'),
(90629, 'Savannah Peninsula', 35.163890838623, 0.613725672945842, -85.0841674804688, -1.48499886385247, 218, 50, 'PPL', 'P'),
(14555, 'Savannah Place', 38.7638893127441, 0.676557499386027, -75.1616668701172, -1.31181855817069, 218, 10, 'PPL', 'P'),
(106056, 'Savedge', 37.1336097717285, 0.648103753667403, -77.0194396972656, -1.34424281075851, 218, 53, 'PPL', 'P'),
(193931, 'Savercool Place', 40.1897201538086, 0.701442942139082, -121.691940307617, -2.12392503150832, 218, 6, 'PPL', 'P'),
(57434, 'Saverton', 39.6463890075684, 0.691960024708555, -91.2680587768555, -1.59292812755984, 218, 29, 'PPL', 'P'),
(209725, 'Savery', 41.0250015258789, 0.716021352262285, -107.449172973633, -1.8753418469348, 218, 59, 'PPL', 'P'),
(79093, 'Saverys Mill', 39.8830604553223, 0.696090720717322, -75.6436080932617, -1.32023001931565, 218, 45, 'PPL', 'P'),
(5674, 'Saville', 31.8772201538086, 0.556362448067053, -86.3311080932617, -1.50676208312254, 218, 2, 'PPL', 'P'),
(166891, 'Saville', 40.4383316040039, 0.705782030503148, -77.396110534668, -1.35081695706742, 218, 45, 'PPL', 'P'),
(152377, 'Savilton', 41.5830612182617, 0.725761331317031, -74.0688934326172, -1.29274606370797, 218, 40, 'PPL', 'P'),
(126036, 'Savin Hill', 42.3125, 0.738492439750101, -71.0583267211914, -1.24020176224266, 218, 23, 'PPL', 'P'),
(114028, 'Savin Rock', 41.2597198486328, 0.720117959809099, -72.9458312988281, -1.27314493176888, 218, 8, 'PPL', 'P'),
(42984, 'Savoie', 29.6452808380127, 0.517407758301705, -90.6872177124023, -1.58279053855434, 218, 22, 'PPL', 'P'),
(74217, 'Savona', 39.9894409179688, 0.697947410050298, -84.6616668701172, -1.47762483711015, 218, 41, 'PPL', 'P'),
(152378, 'Savona', 42.2886085510254, 0.738075455302422, -77.2186126708984, -1.34771903492939, 218, 40, 'PPL', 'P'),
(33896, 'Savonburg', 37.749439239502, 0.658852005510853, -95.1438903808594, -1.66057415030256, 218, 20, 'PPL', 'P'),
(212133, 'Savonoski', 58.7172203063965, 1.02480882196549, -156.863891601563, -2.73779138593875, 218, 1, 'PPL', 'P'),
(212134, 'Savoonga', 63.6941719055176, 1.11167301408255, -170.478897094727, -2.97541805947157, 218, 1, 'PPL', 'P'),
(11814, 'Savoy', 36.1055603027344, 0.630160905560075, -94.3324966430664, -1.64641265804801, 218, 4, 'PPL', 'P'),
(38117, 'Savoy', 36.7224998474121, 0.640928531900457, -84.1566696166992, -1.46881097232448, 218, 21, 'PPL', 'P'),
(42985, 'Savoy', 30.5072193145752, 0.532451422667345, -92.3194427490234, -1.61127823957686, 218, 22, 'PPL', 'P'),
(61686, 'Savoy', 32.2705612182617, 0.563227544725059, -88.7697219848633, -1.54932392471586, 218, 30, 'PPL', 'P'),
(97896, 'Savoy', 33.5991706848145, 0.58641615438957, -96.3663864135742, -1.681910731166, 218, 51, 'PPL', 'P'),
(121379, 'Savoy', 40.0547218322754, 0.699086776943662, -88.2516708374023, -1.54028222649893, 218, 18, 'PPL', 'P'),
(126037, 'Savoy', 42.5666694641113, 0.742928533756873, -73.029167175293, -1.27459941719823, 218, 23, 'PPL', 'P'),
(197485, 'Savoy', 48.4741706848145, 0.846033880623727, -108.543060302734, -1.89443378247347, 218, 31, 'PPL', 'P'),
(202592, 'Savoy', 44.3525009155273, 0.774097172469752, -103.93083190918, -1.81393521115197, 218, 49, 'PPL', 'P'),
(176282, 'Savoy (historical)', 44.523609161377, 0.777083574737139, -92.0408325195313, -1.60641557374249, 218, 57, 'PPL', 'P'),
(126038, 'Savoy Center', 42.6069412231445, 0.743631408547572, -73.0430603027344, -1.27484189801548, 218, 23, 'PPL', 'P'),
(38116, 'Savoyard', 37.1119384765625, 0.647725518213584, -85.7411117553711, -1.49646470445164, 218, 21, 'PPL', 'P'),
(166893, 'Saw Creek', 41.1124992370605, 0.717548475410363, -75.0511093139648, -1.30988896480287, 218, 45, 'PPL', 'P'),
(11815, 'Saw Mill', 35.2880592346191, 0.615892820282894, -94.3847198486328, -1.64732412493109, 218, 4, 'PPL', 'P'),
(83517, 'Saw Mill', 33.1161117553711, 0.577985185589625, -79.9030609130859, -1.39457149535494, 218, 48, 'PPL', 'P'),
(166894, 'Saw Mill Valley', 40.185001373291, 0.701360583882371, -75.1566696166992, -1.31173133964499, 218, 45, 'PPL', 'P'),
(138006, 'Sawbill Landing', 47.7152786254883, 0.832788715521245, -91.2677764892578, -1.59292320071182, 218, 28, 'PPL', 'P'),
(18002, 'Sawdust', 30.548059463501, 0.533164217733105, -84.6769409179688, -1.47789141953526, 218, 12, 'PPL', 'P'),
(24694, 'Sawdust', 33.4188919067383, 0.583269696140669, -82.3322219848633, -1.43696835411873, 218, 13, 'PPL', 'P'),
(90630, 'Sawdust', 35.6680603027344, 0.6225250900826, -87.1900024414063, -1.52175261742443, 218, 50, 'PPL', 'P'),
(152380, 'Sawens', 42.9277801513672, 0.749231104213627, -78.3544387817383, -1.36754294029367, 218, 40, 'PPL', 'P'),
(18003, 'Sawgrass', 30.1924991607666, 0.526958519761002, -81.3708267211914, -1.42018884135457, 218, 12, 'PPL', 'P'),
(24695, 'Sawhatchee', 31.2766704559326, 0.54588087851726, -85.0277786254883, -1.48401469267163, 218, 13, 'PPL', 'P'),
(152379, 'Sawkill', 41.9855613708496, 0.73278628421947, -74.0311126708984, -1.29208666502207, 218, 40, 'PPL', 'P'),
(11816, 'Sawmill', 33.1583290100098, 0.578722015684222, -92.2552795410156, -1.61015838033849, 218, 4, 'PPL', 'P'),
(179103, 'Sawmill', 33.6180610656738, 0.586745853732522, -110.39582824707, -1.92677068337754, 218, 5, 'PPL', 'P'),
(106057, 'Sawmill Corner', 37.2400016784668, 0.64996064273746, -76.6005630493164, -1.33693203409208, 218, 53, 'PPL', 'P'),
(184993, 'Sawmill Flat', 36.9694404602051, 0.645238458650586, -119.016387939453, -2.07722783337433, 218, 6, 'PPL', 'P'),
(5675, 'Sawmill Town', 33.1758308410645, 0.579027480261254, -86.961669921875, -1.51776746316924, 218, 2, 'PPL', 'P'),
(24696, 'Sawmill Trace', 33.3913917541504, 0.582789727933209, -84.5513916015625, -1.47570017059035, 218, 13, 'PPL', 'P'),
(68574, 'Sawmills', 35.8247184753418, 0.625259290994757, -81.4747161865234, -1.42200205458275, 218, 33, 'PPL', 'P'),
(187329, 'Sawpit', 37.9952812194824, 0.663142757501134, -108.001106262207, -1.88497490007178, 218, 7, 'PPL', 'P'),
(128749, 'Sawpit Corner', 44.3072204589844, 0.773306879416271, -69.3008270263672, -1.20952760596518, 218, 26, 'PPL', 'P'),
(184994, 'Sawtelle', 34.0305595397949, 0.593945310265388, -118.462501525879, -2.06756069177539, 218, 6, 'PPL', 'P'),
(195589, 'Sawtooth City', 43.896671295166, 0.766141444766331, -114.83943939209, -2.00432632853644, 218, 17, 'PPL', 'P'),
(166895, 'Sawtown', 41.3691711425781, 0.722028245259013, -79.5749969482422, -1.38884569901127, 218, 45, 'PPL', 'P'),
(33898, 'Sawyer', 37.4972190856934, 0.654449933387007, -98.6819381713867, -1.72232473334017, 218, 20, 'PPL', 'P'),
(38118, 'Sawyer', 36.9000015258789, 0.644026520617519, -84.3516693115234, -1.47221435903954, 218, 21, 'PPL', 'P'),
(57437, 'Sawyer', 37.4677810668945, 0.653936143033703, -89.644172668457, -1.56458596829089, 218, 29, 'PPL', 'P'),
(61687, 'Sawyer', 33.5252799987793, 0.585126518631699, -89.7363891601563, -1.56619544969568, 218, 30, 'PPL', 'P'),
(77192, 'Sawyer', 34.0136108398438, 0.593649499647307, -95.3713912963867, -1.66454479032981, 218, 42, 'PPL', 'P'),
(117684, 'Sawyer', 40.6963882446289, 0.71028596853869, -91.3550033569336, -1.59444559674896, 218, 16, 'PPL', 'P'),
(133016, 'Sawyer', 41.8852806091309, 0.73103605475107, -86.5894393920898, -1.51127081484804, 218, 27, 'PPL', 'P'),
(138007, 'Sawyer', 46.6713905334473, 0.814569431292767, -92.633056640625, -1.6167518345653, 218, 28, 'PPL', 'P'),
(152383, 'Sawyer', 43.3394393920898, 0.756415913360498, -78.1608276367188, -1.36416378834452, 218, 40, 'PPL', 'P'),
(189533, 'Sawyer', 35.1791687011719, 0.613992321949986, -108.247779846191, -1.88928016629, 218, 38, 'PPL', 'P'),
(195590, 'Sawyer', 48.1444396972656, 0.840278989245147, -116.754722595215, -2.03775432653912, 218, 17, 'PPL', 'P'),
(198862, 'Sawyer', 48.0897216796875, 0.839323979678245, -101.053329467773, -1.76371331931526, 218, 34, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(208670, 'Sawyer', 46.4566688537598, 0.810821831006808, -120.360282897949, -2.10068322520104, 218, 56, 'PPL', 'P'),
(142961, 'Sawyer (historical)', 40.5944404602051, 0.708506644035381, -97.522216796875, -1.70208377694919, 218, 35, 'PPL', 'P'),
(166896, 'Sawyer City', 41.9441719055176, 0.732063901773786, -78.5911102294922, -1.37167363630244, 218, 45, 'PPL', 'P'),
(128750, 'Sawyer Corner', 46.7680587768555, 0.81625661042236, -67.9408264160156, -1.18579111748541, 218, 26, 'PPL', 'P'),
(83519, 'Sawyerdale', 33.5911102294922, 0.586275472904987, -81.2311096191406, -1.41775031790244, 218, 48, 'PPL', 'P'),
(144425, 'Sawyers', 43.1808280944824, 0.753647623986387, -70.8897171020508, -1.23725896923812, 218, 36, 'PPL', 'P'),
(193932, 'Sawyers Bar', 41.2975006103516, 0.720777358495003, -123.129173278809, -2.14900947897383, 218, 6, 'PPL', 'P'),
(152384, 'Sawyers Corner', 42.9724998474121, 0.750011610150102, -76.5880584716797, -1.33671378804075, 218, 40, 'PPL', 'P'),
(184995, 'Sawyers Crossing (historical)', 36.957218170166, 0.645025139447271, -121.520561218262, -2.12093390213, 218, 6, 'PPL', 'P'),
(90632, 'Sawyers Mill', 36.0363883972168, 0.628953628058915, -88.1919403076172, -1.53923973209022, 218, 50, 'PPL', 'P'),
(144426, 'Sawyers River', 44.0897216796875, 0.769510809598472, -71.3511123657227, -1.2453118357423, 218, 36, 'PPL', 'P'),
(197486, 'Sawyers Trailer Park', 47.0625, 0.821395579219831, -109.42749786377, -1.90987012994184, 218, 31, 'PPL', 'P'),
(5676, 'Sawyerville', 32.7516708374023, 0.571624491642079, -87.7294387817383, -1.53116755766814, 218, 2, 'PPL', 'P'),
(28546, 'Sawyerville', 39.0783309936523, 0.682045542023381, -89.8072204589844, -1.56743168907369, 218, 18, 'PPL', 'P'),
(157546, 'Sawyerwood', 41.0377807617188, 0.716244392003579, -81.4411087036133, -1.42141549335266, 218, 41, 'PPL', 'P'),
(138008, 'Sax', 47.211669921875, 0.823999085501493, -92.602783203125, -1.61622346340503, 218, 28, 'PPL', 'P'),
(68575, 'Saxapahaw', 35.9472198486328, 0.6273973432969, -79.3222198486328, -1.38443390634944, 218, 33, 'PPL', 'P'),
(208671, 'Saxby', 47.4902801513672, 0.828861751335868, -117.047218322754, -2.04285934003269, 218, 56, 'PPL', 'P'),
(106058, 'Saxe', 36.9297218322754, 0.644545237818839, -78.6636123657227, -1.37293903729439, 218, 53, 'PPL', 'P'),
(152385, 'Saxe Corner', 43.7597198486328, 0.763751191108957, -76.1080627441406, -1.32833628219968, 218, 40, 'PPL', 'P'),
(97897, 'Saxet', 31.9658298492432, 0.557908979001576, -94.2986068725586, -1.6458211699699, 218, 51, 'PPL', 'P'),
(176284, 'Saxeville', 44.1761093139648, 0.77101855824962, -89.1144409179688, -1.55534040509251, 218, 57, 'PPL', 'P'),
(106059, 'Saxis', 37.9238891601563, 0.661896731006114, -75.7222213745117, -1.32160207990926, 218, 53, 'PPL', 'P'),
(190, 'Saxman', 38.2097206115723, 0.666885430939077, -80.5972213745117, -1.40668688094398, 218, 58, 'PPL', 'P'),
(33899, 'Saxman', 38.2805595397949, 0.668121803475147, -98.1255569458008, -1.71261404905741, 218, 20, 'PPL', 'P'),
(193302, 'Saxman', 55.3183288574219, 0.965486975263005, -131.595825195313, -2.29678043153711, 218, 1, 'PPL', 'P'),
(24697, 'Saxon', 33.9861106872559, 0.593169531439848, -82.892219543457, -1.44674215531932, 218, 13, 'PPL', 'P'),
(61688, 'Saxon', 31.1230602264404, 0.543199874247877, -89.8341674804688, -1.5679020033222, 218, 30, 'PPL', 'P'),
(74219, 'Saxon', 38.9311103820801, 0.679476057624645, -81.8455581665039, -1.42847446813803, 218, 41, 'PPL', 'P'),
(83520, 'Saxon', 34.961109161377, 0.610186465015181, -81.9674987792969, -1.43060273332316, 218, 48, 'PPL', 'P'),
(111305, 'Saxon', 37.7980613708496, 0.659700621792207, -81.4150009155273, -1.42095982649015, 218, 58, 'PPL', 'P'),
(117685, 'Saxon', 40.753059387207, 0.711275066567545, -93.4569396972656, -1.63113130655508, 218, 16, 'PPL', 'P'),
(176293, 'Saxon', 46.4933280944824, 0.8114616554587, -90.4141693115234, -1.5780249449417, 218, 57, 'PPL', 'P'),
(184996, 'Saxon', 38.4666709899902, 0.671370061056716, -121.655281066895, -2.12328520705643, 218, 6, 'PPL', 'P'),
(208672, 'Saxon', 48.6877784729004, 0.849762039833729, -122.1875, -2.13257417978057, 218, 56, 'PPL', 'P'),
(121381, 'Saxon (historical)', 40.9150009155273, 0.714101479432447, -88.2513885498047, -1.54027729965092, 218, 18, 'PPL', 'P'),
(166897, 'Saxonburg', 40.7538909912109, 0.711289580795486, -79.8102798461914, -1.39295216025411, 218, 45, 'PPL', 'P'),
(42986, 'Saxonholm', 29.9252796173096, 0.522294658902001, -89.9236068725586, -1.56946301519515, 218, 22, 'PPL', 'P'),
(126040, 'Saxonville', 42.3263893127441, 0.738734853988325, -71.4000015258789, -1.24616511255556, 218, 23, 'PPL', 'P'),
(83521, 'Saxony Forest', 34.7708282470703, 0.606865436556825, -82.9625015258789, -1.44796880731741, 218, 48, 'PPL', 'P'),
(18004, 'Saxton', 30.0116691589355, 0.523802440842663, -82.083610534668, -1.43262926575466, 218, 12, 'PPL', 'P'),
(38119, 'Saxton', 36.6336097717285, 0.639377107407431, -84.1100006103516, -1.46799644450508, 218, 21, 'PPL', 'P'),
(57438, 'Saxton', 39.7224998474121, 0.693288409460286, -94.7588882446289, -1.65385459539812, 218, 29, 'PPL', 'P'),
(152386, 'Saxton', 42.1577796936035, 0.735792060983788, -73.9947204589844, -1.29145150110209, 218, 40, 'PPL', 'P'),
(166899, 'Saxton', 40.2152786254883, 0.70188902162167, -78.2447204589844, -1.36562799431185, 218, 45, 'PPL', 'P'),
(187330, 'Saxton', 38.7683296203613, 0.676634997373748, -107.970832824707, -1.88444652891151, 218, 7, 'PPL', 'P'),
(146265, 'Saxton Falls', 40.889720916748, 0.713660260218848, -74.79638671875, -1.30544321683715, 218, 37, 'PPL', 'P'),
(172501, 'Saxtons River', 43.1377792358398, 0.752896279663849, -72.5102767944336, -1.26554307159531, 218, 55, 'PPL', 'P'),
(18005, 'Saybrook', 29.7755603790283, 0.519681565240415, -81.3349990844727, -1.41956353113062, 218, 12, 'PPL', 'P'),
(51231, 'Saybrook', 39.1394386291504, 0.68311207146093, -76.8802795410156, -1.34181400784436, 218, 25, 'PPL', 'P'),
(121382, 'Saybrook', 40.4266700744629, 0.705578498416839, -88.5261077880859, -1.54507205487749, 218, 18, 'PPL', 'P'),
(157547, 'Saybrook', 41.8274993896484, 0.730027582225284, -80.871940612793, -1.41148163617056, 218, 41, 'PPL', 'P'),
(166901, 'Saybrook', 41.7230606079102, 0.728204781617179, -79.0522232055664, -1.3797215759586, 218, 45, 'PPL', 'P'),
(171263, 'Saybrook (historical)', 42.9388885498047, 0.749424982340985, -97.1430587768555, -1.6954662211145, 218, 49, 'PPL', 'P'),
(114029, 'Saybrook Manor', 41.2852783203125, 0.720564039291687, -72.3994369506836, -1.26360855137947, 218, 8, 'PPL', 'P'),
(114030, 'Saybrook Point', 41.2838897705078, 0.720539804525767, -72.3544387817383, -1.26282318517401, 218, 8, 'PPL', 'P'),
(157549, 'Saybrook-on-the-lake', 41.8727798461914, 0.730817875278765, -80.8869400024414, -1.41174342490571, 218, 41, 'PPL', 'P'),
(51232, 'Saybrooke', 39.1124992370605, 0.682641890370477, -76.4711074829102, -1.33467260822326, 218, 25, 'PPL', 'P'),
(97898, 'Sayers', 29.3738899230957, 0.512671093276404, -98.2886123657227, -1.71545990299827, 218, 51, 'PPL', 'P'),
(51233, 'Sayers Forest', 38.9305610656738, 0.679466470244721, -76.1708297729492, -1.32943177351409, 218, 25, 'PPL', 'P'),
(97899, 'Sayersville', 30.2316703796387, 0.527642186502339, -97.3269424438477, -1.69867559654416, 218, 51, 'PPL', 'P'),
(106060, 'Sayersville', 37.1827812194824, 0.648961957328681, -81.6180572509766, -1.42450382811077, 218, 53, 'PPL', 'P'),
(146266, 'Sayerwood South', 40.3972206115723, 0.705064508326453, -74.3249969482422, -1.29721591328156, 218, 37, 'PPL', 'P'),
(197487, 'Sayle', 45.2269401550293, 0.789359016307696, -105.995002746582, -1.84996178858829, 218, 31, 'PPL', 'P'),
(824, 'Sayler Park', 39.1124992370605, 0.682641890370477, -84.6891708374023, -1.47810487189663, 218, 41, 'PPL', 'P'),
(169589, 'Sayles Bleachery', 41.8950004577637, 0.731205698112508, -71.4147186279297, -1.2464219744427, 218, 47, 'PPL', 'P'),
(68576, 'Sayles Village', 35.5722198486328, 0.620852358601921, -82.5158309936523, -1.44017293585842, 218, 33, 'PPL', 'P'),
(169590, 'Saylesville', 41.898609161377, 0.731268681872288, -71.4136123657227, -1.2464026665248, 218, 47, 'PPL', 'P'),
(176288, 'Saylesville', 42.9494400024414, 0.749609139930364, -88.3202819824219, -1.54147971688309, 218, 57, 'PPL', 'P'),
(169591, 'Saylesville Highlands', 41.8908309936523, 0.731132927235721, -71.42138671875, -1.24653835458234, 218, 47, 'PPL', 'P'),
(112352, 'Saylor', 36.899169921875, 0.644012006389578, -83.4622192382813, -1.45669052672936, 218, 21, 'PPL', 'P'),
(117692, 'Saylor', 41.6661109924316, 0.727210823319334, -93.5963897705078, -1.6335651694753, 218, 16, 'PPL', 'P'),
(117686, 'Saylor Station', 41.6805610656738, 0.727463024674565, -93.5955581665039, -1.63355065524736, 218, 16, 'PPL', 'P'),
(83522, 'Saylors Crossroads', 34.3988914489746, 0.60037391482073, -82.5061111450195, -1.44000329249698, 218, 48, 'PPL', 'P'),
(166902, 'Saylorsburg', 40.8955612182617, 0.71376219270957, -75.3238906860352, -1.3146498978836, 218, 45, 'PPL', 'P'),
(166903, 'Saylorsville', 41.0405616760254, 0.716292928114445, -75.6938934326172, -1.32110766405288, 218, 45, 'PPL', 'P'),
(117688, 'Saylorville', 41.6786117553711, 0.727429002791639, -93.6294403076172, -1.63414201016741, 218, 16, 'PPL', 'P'),
(176289, 'Sayner', 45.9861106872559, 0.802609041679167, -89.5325012207031, -1.56263693384711, 218, 57, 'PPL', 'P'),
(197488, 'Saypo', 47.8088912963867, 0.834422564850008, -112.565277099609, -1.96463470880796, 218, 31, 'PPL', 'P'),
(5677, 'Sayre', 33.7122192382813, 0.588389223862183, -86.9744415283203, -1.51799036975248, 218, 2, 'PPL', 'P'),
(11817, 'Sayre', 33.7519416809082, 0.589082511272958, -93.0919418334961, -1.62476089206955, 218, 4, 'PPL', 'P'),
(74218, 'Sayre', 39.684440612793, 0.692624150505394, -82.0588912963867, -1.43219783365807, 218, 41, 'PPL', 'P'),
(77190, 'Sayre', 35.2911109924316, 0.615946083504696, -99.6397171020508, -1.73904112918649, 218, 42, 'PPL', 'P'),
(166904, 'Sayre', 41.978889465332, 0.732669837500806, -76.5158309936523, -1.33545318073876, 218, 45, 'PPL', 'P'),
(187883, 'Sayre', 37.688060760498, 0.657780748962369, -100.173889160156, -1.74836419037258, 218, 20, 'PPL', 'P'),
(146267, 'Sayre Woods', 40.461109161377, 0.70617957387487, -74.2916717529297, -1.29663427889949, 218, 37, 'PPL', 'P'),
(5678, 'Sayreton', 33.5616683959961, 0.585761615972656, -86.829719543457, -1.51546449461659, 218, 2, 'PPL', 'P'),
(146268, 'Sayreville', 40.459171295166, 0.706145751729025, -74.3613891601563, -1.29785107720155, 218, 37, 'PPL', 'P'),
(146269, 'Sayreville Junction', 40.4652786254883, 0.706252344751656, -74.3308334350586, -1.29731777919326, 218, 37, 'PPL', 'P'),
(146270, 'Sayreville Station', 40.4727783203125, 0.706383239119233, -74.3541717529297, -1.29772510968199, 218, 37, 'PPL', 'P'),
(152387, 'Sayville', 40.7358283996582, 0.710974329101448, -73.0824966430664, -1.27553019199921, 218, 40, 'PPL', 'P'),
(128751, 'Saywards Corner', 43.3622207641602, 0.756813523311246, -70.6691665649414, -1.23340963619852, 218, 26, 'PPL', 'P'),
(193933, 'Scaath', 41.514720916748, 0.724568568043812, -123.968330383301, -2.16365553338872, 218, 6, 'PPL', 'P'),
(166906, 'Scab Hill', 40.3224983215332, 0.703760358340642, -79.7169418334961, -1.39132310461531, 218, 45, 'PPL', 'P'),
(51234, 'Scaggsville', 39.1450004577637, 0.683209143682664, -76.9005584716797, -1.34216794195323, 218, 25, 'PPL', 'P'),
(90633, 'Scaife', 34.9972190856934, 0.610816702087149, -90.0327835083008, -1.5713685069551, 218, 50, 'PPL', 'P'),
(11818, 'Scaife (historical)', 33.1483306884766, 0.578547512053795, -91.190559387207, -1.59157550804219, 218, 4, 'PPL', 'P'),
(38120, 'Scale', 36.9055595397949, 0.644123526260225, -88.3597183227539, -1.54216801086682, 218, 21, 'PPL', 'P'),
(184997, 'Scales', 39.598331451416, 0.691121262123234, -120.991386413574, -2.1116980594696, 218, 6, 'PPL', 'P'),
(121383, 'Scales Mound', 42.475830078125, 0.741343087380921, -90.2527770996094, -1.57520811945672, 218, 18, 'PPL', 'P'),
(31079, 'Scalesville', 38.2024993896484, 0.666759396840489, -87.2061080932617, -1.52203371407749, 218, 19, 'PPL', 'P'),
(68577, 'Scalesville', 36.2361106872559, 0.63243943960972, -79.8447189331055, -1.39355323571214, 218, 33, 'PPL', 'P'),
(38121, 'Scalf', 36.9183311462402, 0.644346432843464, -83.7002792358398, -1.46084545750405, 218, 21, 'PPL', 'P'),
(97900, 'Scallorn', 31.329439163208, 0.546801866201237, -98.4738922119141, -1.7186936463519, 218, 51, 'PPL', 'P'),
(166907, 'Scalp Level', 40.2497215270996, 0.702490163658728, -78.8491668701172, -1.37617757433798, 218, 45, 'PPL', 'P'),
(68578, 'Scaly Mountain', 35.0116691589355, 0.611068903442379, -83.3163909912109, -1.45414534367557, 218, 33, 'PPL', 'P'),
(166909, 'Scammells Corner', 40.2363891601563, 0.702257469958483, -74.852783203125, -1.30642752117604, 218, 45, 'PPL', 'P'),
(33900, 'Scammon', 37.2775001525879, 0.650615114575347, -94.8247222900391, -1.65500361625044, 218, 20, 'PPL', 'P'),
(212135, 'Scammon Bay', 61.8427810668945, 1.07936014820732, -165.581665039063, -2.88994523586603, 218, 1, 'PPL', 'P'),
(208673, 'Scammon Landing', 47.0397186279297, 0.820997969269083, -120.022499084473, -2.09478778549593, 218, 56, 'PPL', 'P'),
(33902, 'Scandia', 39.7944412231445, 0.694544023335232, -97.783332824707, -1.70664111136459, 218, 20, 'PPL', 'P'),
(138010, 'Scandia', 45.2536087036133, 0.789824470287214, -92.8055572509766, -1.61976253817764, 218, 28, 'PPL', 'P'),
(166910, 'Scandia', 41.9127807617188, 0.731516022958529, -79.0355606079102, -1.37943075876756, 218, 45, 'PPL', 'P'),
(208674, 'Scandia', 47.7166709899902, 0.832813016866192, -122.656669616699, -2.14076273434229, 218, 56, 'PPL', 'P'),
(205683, 'Scandia Village', 40.6041717529297, 0.708676487133901, -111.806106567383, -1.95138468343649, 218, 52, 'PPL', 'P'),
(205684, 'Scandia Village Condominium', 40.6041717529297, 0.708676487133901, -111.805557250977, -1.95137509605656, 218, 52, 'PPL', 'P'),
(176290, 'Scandinavia', 44.461669921875, 0.776002531071649, -89.149169921875, -1.55594654055661, 218, 57, 'PPL', 'P'),
(90634, 'Scandlyn', 36.0099983215332, 0.628493034348386, -84.3847198486328, -1.47279119973165, 218, 50, 'PPL', 'P'),
(166911, 'Scanlin', 41.0658302307129, 0.716733947590963, -76.1138916015625, -1.32843801495333, 218, 45, 'PPL', 'P'),
(18006, 'Scanlon', 30.1302795410156, 0.525872582537009, -83.896110534668, -1.46426335844706, 218, 12, 'PPL', 'P'),
(138013, 'Scanlon', 46.7066688537598, 0.815185154136794, -92.4280624389648, -1.61317401079884, 218, 28, 'PPL', 'P'),
(61689, 'Scanlon (historical)', 32.4694404602051, 0.566698642310841, -89.1333312988281, -1.55567010443546, 218, 30, 'PPL', 'P'),
(83524, 'Scanlonville', 32.8116683959961, 0.572671646582698, -79.8977813720703, -1.39447934998122, 218, 48, 'PPL', 'P'),
(5679, 'Scant City', 34.3622207641602, 0.599733890631757, -86.4236068725586, -1.50837649137535, 218, 2, 'PPL', 'P'),
(114032, 'Scantic', 41.896110534668, 0.731225072609438, -72.5530624389648, -1.26628982196496, 218, 8, 'PPL', 'P'),
(201537, 'Scappoose', 45.7544403076172, 0.798565630775127, -122.876388549805, -2.14459755315395, 218, 43, 'PPL', 'P'),
(11819, 'Scarb (historical)', 35.8586082458496, 0.625850779072864, -90.8736114501953, -1.58604372298393, 218, 4, 'PPL', 'P'),
(24698, 'Scarboro', 32.7130584716797, 0.570950578728235, -81.8755569458008, -1.42899804560834, 218, 13, 'PPL', 'P'),
(51236, 'Scarboro', 39.646110534668, 0.691955164439566, -76.2955627441406, -1.33160877454717, 218, 25, 'PPL', 'P'),
(90635, 'Scarboro', 35.9830589294434, 0.628022853257933, -84.2225036621094, -1.46995999317679, 218, 50, 'PPL', 'P'),
(121385, 'Scarboro', 41.7813911437988, 0.729222841522889, -89.0341720581055, -1.55393944920108, 218, 18, 'PPL', 'P'),
(51237, 'Scarboro Landing', 38.0691719055176, 0.664432393259005, -75.366943359375, -1.31540130878517, 218, 25, 'PPL', 'P'),
(68579, 'Scarborough', 35.5780601501465, 0.620954291092644, -77.3450012207031, -1.3499249312603, 218, 33, 'PPL', 'P'),
(128752, 'Scarborough', 43.5780601501465, 0.760580631252191, -70.3222198486328, -1.22735427366995, 218, 26, 'PPL', 'P'),
(152388, 'Scarborough', 41.1358299255371, 0.717955672741036, -73.85888671875, -1.2890807550997, 218, 40, 'PPL', 'P'),
(169592, 'Scarborough Hills', 41.3886108398438, 0.722367531981889, -71.477783203125, -1.24752265892123, 218, 47, 'PPL', 'P'),
(111306, 'Scarbro', 37.9530601501465, 0.66240586082751, -81.1658325195313, -1.41661101758811, 218, 58, 'PPL', 'P'),
(24699, 'Scarbrough Cross Roads', 33.6305618286133, 0.586964033204827, -84.2188873291016, -1.46989687625896, 218, 13, 'PPL', 'P'),
(5680, 'Scarce Grease', 34.9705581665039, 0.610351381265685, -87.1324996948242, -1.52074900516764, 218, 2, 'PPL', 'P'),
(24700, 'Scarecorn', 34.5061111450195, 0.602245251539701, -84.6016693115234, -1.47657768216953, 218, 13, 'PPL', 'P'),
(193934, 'Scarface', 41.4116706848145, 0.722770002201627, -121.293891906738, -2.11697777633069, 218, 6, 'PPL', 'P'),
(51238, 'Scarff', 39.5333290100098, 0.689986755498861, -76.4483337402344, -1.33427513143056, 218, 25, 'PPL', 'P'),
(166912, 'Scarlan Hill', 40.4038887023926, 0.70518088846609, -78.6322174072266, -1.3723910919001, 218, 45, 'PPL', 'P'),
(24701, 'Scarlet', 30.9338893890381, 0.539898220286452, -81.7638931274414, -1.42704914432262, 218, 13, 'PPL', 'P'),
(31080, 'Scarlet', 38.6577796936035, 0.674705537163986, -86.6675033569336, -1.51263328806173, 218, 19, 'PPL', 'P'),
(111307, 'Scarlet', 37.7758293151855, 0.659312599221383, -82.147216796875, -1.43373940445506, 218, 58, 'PPL', 'P'),
(123627, 'Scarlet Oaks', 40.6955604553223, 0.710271520889776, -86.7541732788086, -1.51414596356089, 218, 19, 'PPL', 'P'),
(5685, 'Scarlet Town', 33.6044387817383, 0.586508100026205, -86.8916702270508, -1.51654573801916, 218, 2, 'PPL', 'P'),
(166913, 'Scarlets Mill', 40.2269401550293, 0.702092553707979, -75.8505630493164, -1.32384206470212, 218, 45, 'PPL', 'P'),
(42987, 'Scarsdale', 29.8449993133545, 0.520893503273483, -89.977783203125, -1.57040857054018, 218, 22, 'PPL', 'P'),
(152389, 'Scarsdale', 41.0050010681152, 0.715672278422402, -73.7850036621094, -1.28779125249988, 218, 40, 'PPL', 'P'),
(152390, 'Scarsdale Downs', 40.9838905334473, 0.71530383008559, -73.7827835083008, -1.28775250350602, 218, 40, 'PPL', 'P'),
(152391, 'Scarsdale Park', 40.9833297729492, 0.715294042968584, -73.7936096191406, -1.28794145478536, 218, 40, 'PPL', 'P'),
(117690, 'Scarville', 43.4705581665039, 0.758704367685203, -93.6175003051758, -1.63393361781211, 218, 16, 'PPL', 'P'),
(111308, 'Scary', 38.4372215270996, 0.670856070966331, -81.8552780151367, -1.42864411149946, 218, 58, 'PPL', 'P'),
(144427, 'Scates Corner', 44.3791694641113, 0.77456262644927, -71.2552795410156, -1.24363923741968, 218, 36, 'PPL', 'P'),
(97901, 'Scatter Branch', 33.2397193908691, 0.580142545809671, -95.9683303833008, -1.67496334283031, 218, 51, 'PPL', 'P'),
(90636, 'Scattersville', 36.5908317565918, 0.638630490195827, -86.5677795410156, -1.51089277913131, 218, 50, 'PPL', 'P'),
(106061, 'Scattersville', 39.2200012207031, 0.684518153937465, -77.5494384765625, -1.35349303448879, 218, 53, 'PPL', 'P'),
(166914, 'Scattertown', 41.2483291625977, 0.719919154833725, -78.5247192382813, -1.37051489491214, 218, 45, 'PPL', 'P'),
(57439, 'Scearces', 39.5813903808594, 0.690825584663208, -94.5083312988281, -1.64948155173016, 218, 29, 'PPL', 'P'),
(166915, 'Scenery Hill', 40.0858306884766, 0.699629728910901, -80.070556640625, -1.39749484728352, 218, 45, 'PPL', 'P'),
(202596, 'Scenic', 43.7797203063965, 0.764100264948839, -102.554443359375, -1.78991269917113, 218, 49, 'PPL', 'P'),
(184998, 'Scenic Brook', 37.9925003051758, 0.663094221390268, -120.332778930664, -2.10020319041455, 218, 6, 'PPL', 'P'),
(278, 'Scenic Heights', 34.0544395446777, 0.594362094975985, -86.0338897705078, -1.50157464479323, 218, 2, 'PPL', 'P'),
(90637, 'Scenic Heights', 35.1977806091309, 0.614317161023949, -86.0986099243164, -1.50270422456959, 218, 50, 'PPL', 'P'),
(184999, 'Scenic Heights', 38.0166702270508, 0.663516066106936, -120.255561828613, -2.09885549774491, 218, 6, 'PPL', 'P'),
(31081, 'Scenic Hill', 38.6783294677734, 0.675064198383793, -86.8938903808594, -1.51658448701303, 218, 19, 'PPL', 'P'),
(24702, 'Scenic Hills', 34.9230613708496, 0.60952240579737, -85.1594390869141, -1.4863126012182, 218, 13, 'PPL', 'P'),
(106062, 'Scenic Hills', 37.207218170166, 0.649388462577257, -80.0224990844727, -1.3966560846982, 218, 53, 'PPL', 'P'),
(111309, 'Scenic Hills', 39.2666702270508, 0.685332681756865, -81.4816665649414, -1.42212336157041, 218, 58, 'PPL', 'P'),
(24703, 'Scenic Mountain', 33.8408317565918, 0.590633935765983, -84.0747222900391, -1.46738072166105, 218, 13, 'PPL', 'P'),
(97902, 'Scenic Oaks', 29.7105598449707, 0.518547091905555, -98.6755599975586, -1.72221341320661, 218, 51, 'PPL', 'P'),
(90638, 'Scenic Point Estates', 35.7972183227539, 0.624779322787298, -84.1361083984375, -1.46845211136759, 218, 50, 'PPL', 'P'),
(185000, 'Scenic Valley Ranchos', 38.1175003051758, 0.665275882955261, -120.862777709961, -2.10945341414483, 218, 6, 'PPL', 'P'),
(51239, 'Scenic View', 39.6252784729004, 0.691591576371743, -76.3511123657227, -1.33257829834202, 218, 25, 'PPL', 'P'),
(185001, 'Scenic View', 37.9977798461914, 0.663186366763985, -120.331108093262, -2.10017402880061, 218, 6, 'PPL', 'P'),
(117691, 'Scenic View Mobile Home Park', 40.5583305358887, 0.707876406963413, -91.4277801513672, -1.59571579143088, 218, 16, 'PPL', 'P'),
(90640, 'Scenic Woods', 36.5386085510254, 0.637719023312748, -82.4691696166992, -1.43935854119707, 218, 50, 'PPL', 'P'),
(97903, 'Scenic Woods', 29.860559463501, 0.521165079125644, -95.3005599975586, -1.6633085509518, 218, 51, 'PPL', 'P'),
(11820, 'Schaal', 33.8261108398438, 0.590377007299818, -93.9608306884766, -1.63992586342285, 218, 4, 'PPL', 'P'),
(11821, 'Schaberg', 35.7272186279297, 0.623557597637224, -94.1694412231445, -1.64356680410715, 218, 4, 'PPL', 'P'),
(166916, 'Schades Corner', 40.2297210693359, 0.702141089818846, -75.6672210693359, -1.32064214349434, 218, 45, 'PPL', 'P'),
(121386, 'Schaeferville', 40.547779083252, 0.707692249374035, -89.6311111450195, -1.56435800170158, 218, 18, 'PPL', 'P'),
(202595, 'Schaeferville', 44.1213912963867, 0.770063548682718, -103.294998168945, -1.80283781888961, 218, 49, 'PPL', 'P'),
(166917, 'Schaefferstown', 40.2983283996582, 0.703338513623973, -76.2947235107422, -1.33159412716118, 218, 45, 'PPL', 'P'),
(198865, 'Schafer', 47.7994384765625, 0.834257582020478, -103.186111450195, -1.80093738713573, 218, 34, 'PPL', 'P'),
(33905, 'Schaffer', 38.4713897705078, 0.671452419313427, -99.0883331298828, -1.72941766342943, 218, 20, 'PPL', 'P'),
(133017, 'Schaffer', 45.7611083984375, 0.798682010914764, -87.2986068725586, -1.5236481223303, 218, 27, 'PPL', 'P'),
(152393, 'Schaghticoke', 42.9000015258789, 0.748746275737178, -73.5858306884766, -1.284315028329, 218, 40, 'PPL', 'P'),
(152399, 'Schaghticoke Hill', 42.8786087036133, 0.748372900552349, -73.6061096191406, -1.28466896243787, 218, 40, 'PPL', 'P'),
(146272, 'Schalks', 40.3424987792969, 0.704109432180524, -74.5922164916992, -1.30187977414057, 218, 37, 'PPL', 'P'),
(18007, 'Schall Circle', 26.7152805328369, 0.466269605891949, -80.1152801513672, -1.39827541979902, 218, 12, 'PPL', 'P'),
(117693, 'Schaller', 42.4997215270996, 0.741760071828601, -95.2927780151367, -1.6631727297362, 218, 16, 'PPL', 'P'),
(61691, 'Schamberville', 32.4741706848145, 0.566781200304634, -88.8636093139648, -1.55096256773459, 218, 30, 'PPL', 'P'),
(121387, 'Schapville', 42.3969383239746, 0.739966166518323, -90.2052764892578, -1.57437907740938, 218, 18, 'PPL', 'P'),
(192182, 'Scharbauer City', 32.023609161377, 0.558917418237848, -102.430000305176, -1.78774075814411, 218, 51, 'PPL', 'P'),
(97904, 'Schattel', 28.9530601501465, 0.50532622814802, -98.857780456543, -1.72539376018038, 218, 51, 'PPL', 'P'),
(24708, 'Schatulga', 32.5138893127441, 0.567474421136382, -84.8705596923828, -1.48127070464247, 218, 13, 'PPL', 'P'),
(74220, 'Schauers Acres', 39.8763885498047, 0.695974273998659, -84.0244369506836, -1.46650307692381, 218, 41, 'PPL', 'P'),
(121388, 'Schaufel Corners', 42.480281829834, 0.741420785105725, -87.9719390869141, -1.53539998643054, 218, 18, 'PPL', 'P'),
(121389, 'Schaumburg', 42.0333290100098, 0.733619986798719, -88.0833282470703, -1.5373440940263, 218, 18, 'PPL', 'P'),
(138015, 'Schechs Mill', 43.6674995422363, 0.762141643125141, -91.5808334350586, -1.59838707516228, 218, 28, 'PPL', 'P'),
(185002, 'Scheelite', 37.378059387207, 0.652370204312737, -118.675827026367, -2.07128392413738, 218, 6, 'PPL', 'P'),
(198867, 'Schefield', 46.6747207641602, 0.814627554783558, -102.85417175293, -1.79514394650037, 218, 34, 'PPL', 'P'),
(166918, 'Scheidy', 40.6930618286133, 0.710227911626926, -75.5616683959961, -1.31879990181027, 218, 45, 'PPL', 'P'),
(51240, 'Schell', 39.3419418334961, 0.686646419122602, -79.2600021362305, -1.38334800241496, 218, 25, 'PPL', 'P'),
(57440, 'Schell City', 38.0200004577637, 0.663574189597727, -94.1155624389648, -1.64262644192624, 218, 29, 'PPL', 'P'),
(71356, 'Schellenger Landing', 38.9486083984375, 0.67978145562265, -74.9055633544922, -1.3073487085971, 218, 37, 'PPL', 'P'),
(28547, 'Scheller', 38.1863899230957, 0.666478233608404, -89.0950012207031, -1.55500111836964, 218, 18, 'PPL', 'P'),
(166919, 'Schellsburg', 40.0488891601563, 0.698984977610993, -78.6444396972656, -1.37260441110342, 218, 45, 'PPL', 'P'),
(185003, 'Schellville', 38.2461090087891, 0.667520528280034, -122.438606262207, -2.13695681082846, 218, 6, 'PPL', 'P'),
(74221, 'Schenck', 39.3586082458496, 0.686937302892666, -84.5422210693359, -1.47554011460883, 218, 41, 'PPL', 'P'),
(106063, 'Schenck Estates', 37.3316688537598, 0.651560536762325, -76.7122192382813, -1.33888080221974, 218, 53, 'PPL', 'P'),
(152395, 'Schenectady', 42.8141708374023, 0.747248247624009, -73.9400024414063, -1.29049649153518, 218, 40, 'PPL', 'P'),
(152398, 'Schenevus', 42.5488891601563, 0.742618208910851, -74.8213882446289, -1.30587957578176, 218, 40, 'PPL', 'P'),
(166921, 'Schenley', 40.684440612793, 0.710077443025337, -79.6619415283203, -1.39036316820039, 218, 45, 'PPL', 'P'),
(166922, 'Schenley Heights', 40.4513893127441, 0.706009930513432, -79.9591674804688, -1.39555073968776, 218, 45, 'PPL', 'P'),
(152400, 'Schepps Corners', 43.1152801513672, 0.752503596561117, -76.0036087036133, -1.32651321527547, 218, 40, 'PPL', 'P'),
(71355, 'Schepps Valley', 39.4786109924316, 0.689031745931958, -75.35888671875, -1.31526069387961, 218, 37, 'PPL', 'P'),
(166923, 'Scherersville', 40.6286087036133, 0.709102992382477, -75.5100021362305, -1.31789815546517, 218, 45, 'PPL', 'P'),
(123628, 'Schererville', 41.478889465332, 0.723943191240834, -87.454719543457, -1.52637280244156, 218, 19, 'PPL', 'P'),
(152401, 'Schermerhorn Landing', 44.4127807617188, 0.775149254258387, -75.7908325195313, -1.32279957029341, 218, 40, 'PPL', 'P'),
(111310, 'Scherr', 39.1930618286133, 0.684047972847011, -79.170280456543, -1.38178206369399, 218, 58, 'PPL', 'P'),
(97906, 'Schertz', 29.5519409179688, 0.51577866937339, -98.2694396972656, -1.7151252768073, 218, 51, 'PPL', 'P'),
(176297, 'Schey Acres', 43.1411094665527, 0.75295440315464, -89.2041702270508, -1.55690647697153, 218, 57, 'PPL', 'P'),
(121391, 'Schick', 41.9516716003418, 0.732194796141363, -88.1641693115234, -1.53875503677183, 218, 18, 'PPL', 'P'),
(97905, 'Schicke Point Community', 28.6408290863037, 0.499876768056959, -96.3555603027344, -1.68172177988666, 218, 51, 'PPL', 'P'),
(195591, 'Schiller', 42.8797187805176, 0.74839227504928, -112.657501220703, -1.9662443233708, 218, 17, 'PPL', 'P'),
(121392, 'Schiller Park', 41.9558296203613, 0.732267367281068, -87.8708267211914, -1.5336352427342, 218, 18, 'PPL', 'P'),
(111311, 'Schilling', 38.7658309936523, 0.676591388110898, -81.320556640625, -1.41931146293345, 218, 58, 'PPL', 'P'),
(185004, 'Schilling', 36.4088897705078, 0.635455003491044, -119.912780761719, -2.09287283951411, 218, 6, 'PPL', 'P'),
(197489, 'Schilling', 46.964168548584, 0.819679371634357, -114.200828552246, -1.99318046674224, 218, 31, 'PPL', 'P'),
(61692, 'Schlater', 33.6405601501465, 0.587138536835254, -90.3480606079102, -1.57687113039942, 218, 30, 'PPL', 'P'),
(57441, 'Schlatitz', 37.1708297729492, 0.6487533652363, -89.9875030517578, -1.57057821390162, 218, 29, 'PPL', 'P'),
(24704, 'Schlatterville', 31.1719398498535, 0.544052984613571, -82.1999969482422, -1.43466059187612, 218, 13, 'PPL', 'P'),
(77193, 'Schlegel', 36.0074996948242, 0.628449425085536, -96.6783294677734, -1.6873551645405, 218, 42, 'PPL', 'P'),
(157550, 'Schlegels Grove', 41.3919410705566, 0.72242565547268, -83.0875015258789, -1.4501504688824, 218, 41, 'PPL', 'P'),
(166926, 'Schlemville', 40.4711112976074, 0.706354144084324, -75.8866729736328, -1.32447230177409, 218, 45, 'PPL', 'P'),
(117694, 'Schleswig', 42.1652793884277, 0.735922955351365, -95.4366683959961, -1.66568409064415, 218, 16, 'PPL', 'P'),
(5686, 'Schley', 32.7930603027344, 0.572346874087763, -86.370002746582, -1.5074409228844, 218, 2, 'PPL', 'P'),
(24705, 'Schley', 31.235279083252, 0.545158462782063, -83.8272171020508, -1.46306094121489, 218, 13, 'PPL', 'P'),
(31082, 'Schley', 38.0455589294434, 0.664020269080316, -86.871940612793, -1.51620139129022, 218, 19, 'PPL', 'P'),
(38122, 'Schley', 36.6861114501953, 0.6402934345595, -86.9199981689453, -1.51704015387554, 218, 21, 'PPL', 'P'),
(61693, 'Schley', 31.7872200012207, 0.554791649077097, -90.0941696166992, -1.57243989666164, 218, 30, 'PPL', 'P'),
(68580, 'Schley', 36.1525001525879, 0.630980160490411, -79.0616683959961, -1.37988642563008, 218, 33, 'PPL', 'P'),
(74222, 'Schley', 39.4427795410156, 0.68840636912898, -81.2552795410156, -1.41817216261911, 218, 41, 'PPL', 'P'),
(106064, 'Schley', 37.3894386291504, 0.652568809551029, -76.4552764892578, -1.33439630526016, 218, 53, 'PPL', 'P'),
(117695, 'Schley', 43.3033294677734, 0.75578567628853, -92.2188873291016, -1.6095232164185, 218, 16, 'PPL', 'P'),
(138016, 'Schley', 47.3688888549805, 0.826743073530656, -94.4158325195313, -1.64786714347735, 218, 28, 'PPL', 'P'),
(197490, 'Schley', 47.103328704834, 0.822108174548509, -114.053062438965, -1.99060146154261, 218, 31, 'PPL', 'P'),
(200192, 'Schley (historical)', 40.5597190856934, 0.707900641729333, -115.306938171387, -2.01248572148423, 218, 39, 'PPL', 'P'),
(166924, 'Schlichter', 40.3683280944824, 0.704560238774047, -75.333610534668, -1.31481954124504, 218, 45, 'PPL', 'P'),
(208675, 'Schlomer', 46.6974983215332, 0.81502509815528, -118.921943664551, -2.07557946981762, 218, 56, 'PPL', 'P'),
(68581, 'Schlosstown (historical)', 36.2361106872559, 0.63243943960972, -78.1722183227539, -1.3643625933199, 218, 33, 'PPL', 'P'),
(57442, 'Schluersburg', 38.6305618286133, 0.674230495804543, -90.8597183227539, -1.58580124216668, 218, 29, 'PPL', 'P'),
(166925, 'Schlusser', 40.2416687011719, 0.702349615332199, -77.1772232055664, -1.34699665248371, 218, 45, 'PPL', 'P'),
(198869, 'Schmidt', 46.6736106872559, 0.814608180286628, -100.781669616699, -1.75897196046853, 218, 34, 'PPL', 'P'),
(208676, 'Schmidt (historical)', 48.273609161377, 0.842533421686926, -117.984718322754, -2.05922180177014, 218, 56, 'PPL', 'P'),
(133018, 'Schmidt Corner', 47.1558303833008, 0.823024501700578, -88.6427764892578, -1.54710830784697, 218, 27, 'PPL', 'P'),
(176296, 'Schmidt Corner', 44.6030616760254, 0.778470282716743, -89.1224975585938, -1.55548101999807, 218, 57, 'PPL', 'P'),
(171267, 'Schmidt Landing', 45.3797187805176, 0.792025506349138, -96.5605621337891, -1.68529973681118, 218, 49, 'PPL', 'P'),
(57443, 'Schmitt Ford', 38.3636093139648, 0.66957129547745, -91.1783294677734, -1.59136205568082, 218, 29, 'PPL', 'P'),
(176298, 'Schnappsville', 44.973331451416, 0.78493270941793, -90.0250015258789, -1.57123268573951, 218, 57, 'PPL', 'P'),
(166928, 'Schnecksville', 40.667781829834, 0.709786692413327, -75.6074981689453, -1.31959978224368, 218, 45, 'PPL', 'P'),
(123629, 'Schneider', 41.186939239502, 0.718847698548158, -87.4483337402344, -1.52626134914994, 218, 19, 'PPL', 'P'),
(106065, 'Schneider Crossroads', 38.8813896179199, 0.678608266583443, -77.4858322143555, -1.35238289578839, 218, 53, 'PPL', 'P'),
(208677, 'Schneiders Prairie', 47.079719543457, 0.821696116948847, -123.018058776855, -2.14707016506804, 218, 56, 'PPL', 'P'),
(51241, 'Schneiders Trailer Haven', 39.1902809143066, 0.683999436736145, -77.2436065673828, -1.34815526071595, 218, 25, 'PPL', 'P'),
(166927, 'Schneidersville', 40.6311111450195, 0.709146668224354, -75.7752838134766, -1.32252819417833, 218, 45, 'PPL', 'P'),
(28548, 'Schnell', 38.6358299255371, 0.674322441441178, -88.2494430541992, -1.54024334434702, 218, 18, 'PPL', 'P'),
(31083, 'Schnellville', 38.3411102294922, 0.669178612374717, -86.7561111450195, -1.51417978570674, 218, 19, 'PPL', 'P'),
(176299, 'Schneyville', 42.5169410705566, 0.742060609557616, -89.6394424438477, -1.56450341029709, 218, 57, 'PPL', 'P'),
(195593, 'Schnoors', 48.6897201538086, 0.8497959285586, -116.338607788086, -2.03049175308842, 218, 17, 'PPL', 'P'),
(38123, 'Schochoh', 36.7227783203125, 0.640933392169446, -86.7911071777344, -1.51479058170275, 218, 21, 'PPL', 'P'),
(152402, 'Schodack Center', 42.5544395446777, 0.742715081395503, -73.6769409179688, -1.28590520181589, 218, 40, 'PPL', 'P'),
(152406, 'Schodack Landing', 42.4794387817383, 0.741406071140702, -73.7699966430664, -1.28752933060667, 218, 40, 'PPL', 'P'),
(195592, 'Schodde', 42.6072196960449, 0.743636268816562, -113.990280151367, -1.9895057039121, 218, 17, 'PPL', 'P'),
(157551, 'Schoenbrunn', 40.4638900756836, 0.706228109985736, -81.4111099243164, -1.42089191588235, 218, 41, 'PPL', 'P'),
(33906, 'Schoenchen', 38.7133293151855, 0.675675060958829, -99.3319396972656, -1.73366940010974, 218, 20, 'PPL', 'P'),
(166930, 'Schoeneck', 40.7552795410156, 0.711313815561406, -75.3086090087891, -1.31438318230043, 218, 45, 'PPL', 'P'),
(166931, 'Schoenersville', 40.663330078125, 0.709708994688524, -75.4250030517578, -1.31641464157994, 218, 45, 'PPL', 'P'),
(179104, 'Schoens Crossing', 34.4097213745117, 0.600562932679098, -110.116111755371, -1.92188870962526, 218, 5, 'PPL', 'P'),
(24707, 'Schoer Estates', 30.8866691589355, 0.539074071797613, -83.269172668457, -1.45332122847625, 218, 13, 'PPL', 'P'),
(200193, 'Schoer Place', 41.4816703796387, 0.723991727351701, -114.927223205566, -2.00585844511157, 218, 39, 'PPL', 'P'),
(166932, 'Schofer', 40.5386085510254, 0.707532193392521, -75.7152786254883, -1.32148090607966, 218, 45, 'PPL', 'P'),
(166933, 'Schoffner Corner', 41.3097190856934, 0.720990611119291, -78.9280624389648, -1.3775545617796, 218, 45, 'PPL', 'P'),
(57444, 'Schofield', 37.5522193908691, 0.655409869801926, -93.2063903808594, -1.62675839604517, 218, 29, 'PPL', 'P'),
(83525, 'Schofield', 33.1324996948242, 0.578271209090699, -81.1999969482422, -1.41720729935617, 218, 48, 'PPL', 'P'),
(176301, 'Schofield', 44.9097213745117, 0.783822504138503, -89.6044387817383, -1.56389248114303, 218, 57, 'PPL', 'P'),
(166934, 'Schofield Corners', 41.4197196960449, 0.722910483949129, -80.1561126708984, -1.39898808170672, 218, 45, 'PPL', 'P'),
(152404, 'Schoharie', 42.665828704834, 0.744659188991261, -74.3099975585938, -1.29695412454641, 218, 40, 'PPL', 'P'),
(152407, 'Schoharie Junction', 42.7224998474121, 0.745648287020116, -74.3252792358398, -1.29722084012958, 218, 40, 'PPL', 'P'),
(51242, 'Scholar Woods', 39.4286117553711, 0.688159094621767, -76.2880630493164, -1.3314778801796, 218, 25, 'PPL', 'P'),
(152409, 'Scholes', 42.3519401550293, 0.739180800312859, -77.9208297729492, -1.35997503542399, 218, 40, 'PPL', 'P'),
(106066, 'Scholfield', 37.1027793884277, 0.647565661969152, -78.3249969482422, -1.36702908336134, 218, 53, 'PPL', 'P'),
(166935, 'Schollard', 41.1394386291504, 0.718018656500817, -80.2144393920898, -1.40000607503341, 218, 45, 'PPL', 'P'),
(189534, 'Scholle', 34.4275016784668, 0.60087325752512, -106.416107177734, -1.85731144740664, 218, 38, 'PPL', 'P'),
(201538, 'Scholls', 45.4083290100098, 0.792524849053528, -122.921112060547, -2.14537812566945, 218, 43, 'PPL', 'P'),
(38124, 'Schollsville', 37.9883308410645, 0.663021450513481, -84.0408325195313, -1.46678923358294, 218, 21, 'PPL', 'P'),
(57445, 'Scholten', 36.8497200012207, 0.64314894245931, -93.6294403076172, -1.63414201016741, 218, 29, 'PPL', 'P'),
(193176, 'Scholtztown', 47.0377807617188, 0.820964147123239, -110.226112365723, -1.9238085824551, 218, 31, 'PPL', 'P'),
(133019, 'Schomberg', 44.9213905334473, 0.784026169382867, -85.7738876342773, -1.49703675145379, 218, 27, 'PPL', 'P'),
(189535, 'Schomberg', 36.6388893127441, 0.639469252781148, -104.498893737793, -1.82384976041617, 218, 38, 'PPL', 'P'),
(152410, 'Schonowe', 42.810001373291, 0.747175476747222, -73.9944381713867, -1.29144657425407, 218, 40, 'PPL', 'P'),
(128755, 'Schoodic', 45.4355583190918, 0.793000090150052, -68.9594421386719, -1.20356931565834, 218, 26, 'PPL', 'P'),
(57446, 'School', 36.9650001525879, 0.645160960662865, -93.4672164916992, -1.63131067045449, 218, 29, 'PPL', 'P'),
(51243, 'School Gardens', 39.1616706848145, 0.683500094031755, -76.5163879394531, -1.33546290127674, 218, 25, 'PPL', 'P'),
(97907, 'School Heights Addition Number 2 Colonia', 27.878999710083, 0.486580337103493, -98.620002746582, -1.72124375625371, 218, 51, 'PPL', 'P'),
(176303, 'School Hill', 43.9500007629395, 0.767072219567313, -87.8938903808594, -1.53403777953297, 218, 57, 'PPL', 'P'),
(111313, 'School House (historical)', 38.877498626709, 0.678540355975646, -81.873893737793, -1.42896901715245, 218, 58, 'PPL', 'P'),
(166936, 'School Side Manor', 40.0766716003418, 0.699469872666469, -75.3499984741211, -1.31510556474612, 218, 45, 'PPL', 'P'),
(211095, 'School Village', 20.9055595397949, 0.364870845941132, -156.37028503418, -2.72917632612845, 218, 15, 'PPL', 'P'),
(133020, 'Schoolcraft', 42.1141700744629, 0.735030929544243, -85.6377792358398, -1.49466121176144, 218, 27, 'PPL', 'P'),
(31086, 'Schooler Point Landing', 38.1580581665039, 0.665983751173004, -86.3413925170898, -1.50694158018001, 218, 19, 'PPL', 'P'),
(97908, 'Schoolerville', 31.6163902282715, 0.551810107078699, -98.1827774047852, -1.71361273446619, 218, 51, 'PPL', 'P'),
(11822, 'Schooley', 33.8152809143066, 0.590187989441449, -93.852783203125, -1.63804007905496, 218, 4, 'PPL', 'P'),
(74223, 'Schooley', 39.2655601501465, 0.685313307259935, -82.870002746582, -1.4463543990646, 218, 41, 'PPL', 'P'),
(146273, 'Schooleys Mountain', 40.7991714477539, 0.712079873848967, -74.8141708374023, -1.30575360826219, 218, 37, 'PPL', 'P'),
(106067, 'Schoolfield', 36.5636100769043, 0.638155382257357, -79.4274978637695, -1.38627135434354, 218, 53, 'PPL', 'P'),
(90641, 'Schoolfield (historical)', 35.6672210693359, 0.622510442696605, -85.2091674804688, -1.48718052541746, 218, 50, 'PPL', 'P'),
(68584, 'Schoolhouse Landing', 35.4094390869141, 0.618011298351025, -76.5994415283203, -1.33691245985807, 218, 33, 'PPL', 'P'),
(97909, 'Schoolland', 29.3335990905762, 0.511967885590569, -97.6642913818359, -1.70456344624016, 218, 51, 'PPL', 'P'),
(77194, 'Schoolton', 35.3916702270508, 0.617701173242085, -96.4583282470703, -1.68351541888083, 218, 42, 'PPL', 'P'),
(14557, 'Schoolview', 39.1541709899902, 0.683369199664177, -75.5027770996094, -1.31777205478756, 218, 10, 'PPL', 'P'),
(68585, 'Schooner Ridge', 36.1661109924316, 0.631217714459646, -75.751106262207, -1.32210621630361, 218, 33, 'PPL', 'P'),
(114033, 'Schoonhoven Park', 41.1441688537598, 0.718101214494609, -73.2283325195313, -1.27807550821106, 218, 8, 'PPL', 'P'),
(208679, 'Schoonover', 47.2316703796387, 0.824348159341375, -118.580276489258, -2.06961625266277, 218, 56, 'PPL', 'P'),
(126041, 'Schoosett', 42.1041717529297, 0.734856425913816, -70.7986068725586, -1.23566879575123, 218, 23, 'PPL', 'P'),
(28553, 'Schoper', 39.3380584716797, 0.686578641672859, -89.7841720581055, -1.56702941859103, 218, 18, 'PPL', 'P'),
(195594, 'Schow', 42.5869407653809, 0.74328233470769, -113.710563659668, -1.98462373015982, 218, 17, 'PPL', 'P'),
(166937, 'Schracktown', 41.0272216796875, 0.716060101256145, -77.3322219848633, -1.34970189151901, 218, 45, 'PPL', 'P'),
(74224, 'Schrader', 39.3080596923828, 0.686055064202549, -82.914436340332, -1.44712991157403, 218, 41, 'PPL', 'P'),
(111315, 'Schrader', 38.4150009155273, 0.670468248132588, -81.4227828979492, -1.42109564770574, 218, 58, 'PPL', 'P'),
(106068, 'Schrader Woods', 37.6311111450195, 0.656786790664524, -77.4291687011719, -1.35139393091759, 218, 53, 'PPL', 'P'),
(208678, 'Schrag', 47.0733299255371, 0.8215845970782, -118.853057861328, -2.07437718574351, 218, 56, 'PPL', 'P'),
(28549, 'Schram City', 39.1641693115234, 0.683543703294605, -89.4636077880859, -1.56143451661494, 218, 18, 'PPL', 'P'),
(194413, 'Schramm', 40.1138916015625, 0.700119484235367, -102.605560302734, -1.7908048581363, 218, 7, 'PPL', 'P'),
(42988, 'Schriever', 29.7419395446777, 0.51909477098373, -90.8102798461914, -1.58493837797349, 218, 22, 'PPL', 'P'),
(90642, 'Schroder (historical)', 35.9288902282715, 0.627077431070954, -83.4205627441406, -1.45596348375177, 218, 50, 'PPL', 'P'),
(28550, 'Schrodts Station', 38.3824996948242, 0.669900994820401, -87.8249969482422, -1.5328353623008, 218, 18, 'PPL', 'P'),
(97910, 'Schroeder', 28.8152809143066, 0.502921526841733, -97.2241668701172, -1.69688182439194, 218, 51, 'PPL', 'P'),
(138018, 'Schroeder', 47.5444412231445, 0.829807040364792, -90.8916702270508, -1.58635890809894, 218, 28, 'PPL', 'P'),
(97911, 'Schroeder Colonia', 26.1389999389648, 0.456211612113533, -98.0540008544922, -1.71136515966422, 218, 51, 'PPL', 'P'),
(152412, 'Schroon Falls', 43.899169921875, 0.766185054029181, -73.7491683959961, -1.28716580911788, 218, 40, 'PPL', 'P'),
(152413, 'Schroon Lake', 43.8386116027832, 0.765128111971555, -73.7613906860352, -1.28737912832119, 218, 40, 'PPL', 'P'),
(121395, 'Schrum', 41.6011085510254, 0.726076316694961, -87.5488891601563, -1.5280163723083, 218, 18, 'PPL', 'P'),
(57449, 'Schubert', 38.5175018310547, 0.672257226594849, -92.0494384765625, -1.60656577602797, 218, 29, 'PPL', 'P'),
(166938, 'Schubert', 40.497501373291, 0.706814737794853, -76.2211074829102, -1.33030928509327, 218, 45, 'PPL', 'P'),
(197491, 'Schubring Trailer Court', 48.5583305358887, 0.84750274712296, -109.647216796875, -1.9137049487535, 218, 31, 'PPL', 'P'),
(179105, 'Schuchk', 32.1211090087891, 0.560619111595381, -111.682502746582, -1.94922738979547, 218, 5, 'PPL', 'P'),
(179106, 'Schuchuli', 32.2222213745117, 0.562383855291722, -112.6875, -1.96676790084111, 218, 5, 'PPL', 'P'),
(97912, 'Schuerbach Acres Colonia', 26.2859992980957, 0.458777234928688, -98.3479995727539, -1.71649640529453, 218, 51, 'PPL', 'P'),
(57447, 'Schuermann Heights', 38.7227783203125, 0.675839977209333, -90.3652801513672, -1.57717166812844, 218, 29, 'PPL', 'P'),
(11823, 'Schug', 35.9658317565918, 0.627722182370863, -90.4419403076172, -1.57850964026009, 218, 4, 'PPL', 'P'),
(97913, 'Schulenburg', 29.6816692352295, 0.518042855642662, -96.9027786254883, -1.69127254134596, 218, 51, 'PPL', 'P'),
(5687, 'Schuler (historical)', 34.0186080932617, 0.593736718173007, -86.2869415283203, -1.50599123114502, 218, 2, 'PPL', 'P'),
(28551, 'Schuline', 38.0894393920898, 0.664786127630795, -89.7788925170898, -1.56693727321732, 218, 18, 'PPL', 'P'),
(57448, 'Schult', 36.2052803039551, 0.631901347911469, -89.7200012207031, -1.5659094261946, 218, 29, 'PPL', 'P'),
(33907, 'Schulte', 37.6230583190918, 0.656646242337995, -97.4711074829102, -1.70119175114206, 218, 20, 'PPL', 'P'),
(77195, 'Schulter', 35.5144386291504, 0.619843886076136, -95.9563903808594, -1.67475495047501, 218, 42, 'PPL', 'P'),
(14558, 'Schultie Crossroads', 38.9952812194824, 0.680596050021078, -75.7352828979492, -1.32183004649857, 218, 10, 'PPL', 'P'),
(5688, 'Schultys Landing', 31.9391708374023, 0.557443691469625, -88.1011123657227, -1.53765448545135, 218, 2, 'PPL', 'P'),
(111316, 'Schultz', 39.3199996948242, 0.686263456557848, -81.2402801513672, -1.41791037388395, 218, 58, 'PPL', 'P'),
(133024, 'Schultz', 42.5805587768555, 0.743170947995097, -85.3463897705078, -1.48957550618577, 218, 27, 'PPL', 'P'),
(176304, 'Schultz', 42.689998626709, 0.745081033707929, -89.6025009155273, -1.56385865899719, 218, 57, 'PPL', 'P'),
(83526, 'Schultz Hill', 33.4836082458496, 0.584399209337999, -81.9477767944336, -1.43025851975227, 218, 48, 'PPL', 'P'),
(138020, 'Schultz Trailer Park', 45.8044395446777, 0.799438282085319, -96.498893737793, -1.68422342025662, 218, 28, 'PPL', 'P'),
(152415, 'Schultzville', 41.877498626709, 0.730900233535476, -73.804443359375, -1.28813053922276, 218, 40, 'PPL', 'P'),
(166947, 'Schultzville', 41.4822196960449, 0.724001314731625, -75.7658309936523, -1.3223632113488, 218, 45, 'PPL', 'P'),
(192184, 'Schuman Estates Colonia', 31.9179992675781, 0.557074177868377, -106.611000061035, -1.86071296990894, 218, 51, 'PPL', 'P'),
(97914, 'Schumannsville', 29.6450004577637, 0.517402864743202, -98.0763931274414, -1.71175597855419, 218, 51, 'PPL', 'P'),
(157553, 'Schumm', 40.7563896179199, 0.711333190058336, -84.7275009155273, -1.47877385796246, 218, 41, 'PPL', 'P'),
(57450, 'Schundler', 38.0063896179199, 0.663336635628492, -91.5963897705078, -1.59865858443541, 218, 29, 'PPL', 'P'),
(97915, 'Schunior''s Colonia', 26.3120002746582, 0.459231037578438, -98.1220016479492, -1.71255199740402, 218, 51, 'PPL', 'P'),
(190715, 'Schurz', 38.9508285522461, 0.67982020461651, -118.810279846191, -2.0736305685319, 218, 39, 'PPL', 'P'),
(5689, 'Schuster', 31.8638896942139, 0.556129787656321, -87.0469436645508, -1.51925577074443, 218, 2, 'PPL', 'P'),
(166940, 'Schuster Heights', 40.689998626709, 0.710174448668043, -79.706672668457, -1.39114387387395, 218, 45, 'PPL', 'P'),
(197492, 'Schusters Place', 44.8741683959961, 0.783201987604514, -111.544441223145, -1.94681776164116, 218, 31, 'PPL', 'P'),
(106069, 'Schuyler', 37.7922210693359, 0.659598689301484, -78.6986083984375, -1.3735498332904, 218, 53, 'PPL', 'P'),
(142967, 'Schuyler', 41.4472198486328, 0.723390452156588, -97.0591735839844, -1.69400214830523, 218, 35, 'PPL', 'P'),
(166941, 'Schuyler', 41.0938911437988, 0.717223702915428, -76.7352828979492, -1.33928333901851, 218, 45, 'PPL', 'P'),
(152417, 'Schuyler Falls', 44.6286087036133, 0.77891616246225, -73.5583267211914, -1.28383499354252, 218, 40, 'PPL', 'P'),
(51244, 'Schuyler Hills', 38.6619415283203, 0.674778174882718, -77.0319366455078, -1.34446092365179, 218, 25, 'PPL', 'P'),
(152419, 'Schuyler Lake', 42.7802810668945, 0.746656759545902, -75.0283279418945, -1.30949135485212, 218, 40, 'PPL', 'P'),
(152421, 'Schuylerville', 43.0999984741211, 0.752236880977945, -73.5822219848633, -1.28425204456922, 218, 40, 'PPL', 'P'),
(166943, 'Schuylkill Haven', 40.6305618286133, 0.70913708084443, -76.17138671875, -1.32944149405207, 218, 45, 'PPL', 'P'),
(97916, 'Schwab City', 30.5925006866455, 0.53393986340059, -94.8311080932617, -1.65511506954206, 218, 51, 'PPL', 'P'),
(208680, 'Schwana', 46.8241691589355, 0.817235921334209, -119.92472076416, -2.0930812318694, 218, 56, 'PPL', 'P'),
(97917, 'Schwartz Colonia', 26.3400001525879, 0.459719727638467, -97.431999206543, -1.70050918295468, 218, 51, 'PPL', 'P'),
(185005, 'Schwaub (historical)', 36.5055618286133, 0.637142249199664, -116.722778320313, -2.03719679376491, 218, 6, 'PPL', 'P'),
(190717, 'Schweer Housing Area', 38.545280456543, 0.672742055071298, -118.672500610352, -2.07122586722562, 218, 39, 'PPL', 'P'),
(79095, 'Schweibinzville', 39.9005584716797, 0.696396118715327, -79.3108291625977, -1.38423510137407, 218, 45, 'PPL', 'P'),
(38125, 'Schweizer', 36.6708297729492, 0.640026718976328, -86.6338882446289, -1.51204659367359, 218, 21, 'PPL', 'P'),
(166948, 'Schwenksville', 40.2561111450195, 0.702601683529375, -75.4641723632813, -1.31709827503177, 218, 45, 'PPL', 'P'),
(121397, 'Schwer', 40.6605606079102, 0.709660658314739, -87.7880630493164, -1.53219074415894, 218, 18, 'PPL', 'P'),
(97918, 'Schwertner', 30.8152809143066, 0.53782811188162, -97.5138931274414, -1.70193850151172, 218, 51, 'PPL', 'P'),
(97919, 'Science Hall', 30.8663806915283, 0.538719971241173, -94.1172027587891, -1.64265507090796, 218, 51, 'PPL', 'P'),
(38126, 'Science Hill', 37.1769409179688, 0.648860024837958, -84.6358337402344, -1.4771739639376, 218, 21, 'PPL', 'P'),
(157554, 'Science Hill', 40.2286109924316, 0.702121715321916, -80.9649963378906, -1.41310576496134, 218, 41, 'PPL', 'P'),
(157555, 'Scienceville', 41.1136093139648, 0.717567849907294, -80.616943359375, -1.40703109451487, 218, 41, 'PPL', 'P'),
(51245, 'Scientists Cliffs', 38.5175018310547, 0.672257226594849, -76.5136108398438, -1.3354144317449, 218, 25, 'PPL', 'P'),
(133027, 'Scio', 42.3255615234375, 0.738720406339412, -83.8394393920898, -1.4632742604182, 218, 27, 'PPL', 'P'),
(152422, 'Scio', 42.1713905334473, 0.736029614953023, -77.978889465332, -1.36098836821876, 218, 40, 'PPL', 'P'),
(157556, 'Scio', 40.3958282470703, 0.705040206981506, -81.0849990844727, -1.41520020800064, 218, 41, 'PPL', 'P'),
(201539, 'Scio', 44.7050018310547, 0.780249474061998, -122.84806060791, -2.14410313729758, 218, 43, 'PPL', 'P'),
(117696, 'Sciola', 41.0338897705078, 0.716176481395782, -94.9852828979492, -1.65780592750748, 218, 16, 'PPL', 'P'),
(152424, 'Sciola', 44.8958282470703, 0.783580023321251, -73.5497207641602, -1.28368479125703, 218, 40, 'PPL', 'P'),
(121398, 'Sciota', 40.5608291625977, 0.707920016226264, -90.7516708374023, -1.58391545779879, 218, 18, 'PPL', 'P'),
(166950, 'Sciota', 40.9294395446777, 0.714353481050595, -75.3163909912109, -1.31451900351603, 218, 45, 'PPL', 'P'),
(166951, 'Sciotavale', 41.5511093139648, 0.725203665384769, -76.2380599975586, -1.33060516229038, 218, 45, 'PPL', 'P'),
(157557, 'Scioto', 40.2802810668945, 0.703023528246044, -83.1408309936523, -1.45108124368338, 218, 41, 'PPL', 'P'),
(74226, 'Scioto Furnace', 38.7986106872559, 0.677163501692075, -82.7649993896484, -1.44452174476046, 218, 41, 'PPL', 'P'),
(121400, 'Scioto Mills', 42.3563919067383, 0.739258498037662, -89.6686096191406, -1.56501247353946, 218, 18, 'PPL', 'P'),
(157558, 'Scioto Village', 40.1930618286133, 0.701501265366955, -83.1427764892578, -1.45111519898728, 218, 41, 'PPL', 'P'),
(74231, 'Sciotodale', 38.7547187805176, 0.676397443404513, -82.8688888549805, -1.44633495798864, 218, 41, 'PPL', 'P'),
(74232, 'Sciotoville', 38.7580604553223, 0.676455766632386, -82.8913879394531, -1.44672764109138, 218, 41, 'PPL', 'P'),
(185006, 'Sciots Camp', 38.7861099243164, 0.67694532221977, -120.152496337891, -2.09705666558662, 218, 6, 'PPL', 'P'),
(11824, 'Scipio', 33.396110534668, 0.58287208618992, -91.7938919067383, -1.60210564699236, 218, 4, 'PPL', 'P'),
(31085, 'Scipio', 39.0791702270508, 0.682060189409376, -85.7174987792969, -1.49605258027295, 218, 19, 'PPL', 'P'),
(33908, 'Scipio', 38.3683280944824, 0.66965365373416, -95.2174987792969, -1.66185885921241, 218, 20, 'PPL', 'P'),
(77197, 'Scipio', 35.0547218322754, 0.611820314343945, -95.9563903808594, -1.67475495047501, 218, 42, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(157560, 'Scipio', 41.0988883972168, 0.717310921441128, -82.958610534668, -1.44790089670961, 218, 41, 'PPL', 'P'),
(192773, 'Scipio', 39.2449989318848, 0.684954446303047, -112.103332519531, -1.95657225492385, 218, 52, 'PPL', 'P'),
(152425, 'Scipio Center', 42.7836112976074, 0.746714883036693, -76.559440612793, -1.3362143121783, 218, 40, 'PPL', 'P'),
(152427, 'Scipioville', 42.7819404602051, 0.746685721422757, -76.6252822875977, -1.33736346618867, 218, 40, 'PPL', 'P'),
(61694, 'Sciples Mill', 32.8669395446777, 0.573636310108552, -88.7261123657227, -1.54856279327632, 218, 30, 'PPL', 'P'),
(123632, 'Scircleville', 40.2874984741211, 0.703149495765605, -86.3000030517578, -1.50621919773433, 218, 19, 'PPL', 'P'),
(97920, 'Scissors', 26.139440536499, 0.456219301991181, -98.0536117553711, -1.71135836860344, 218, 51, 'PPL', 'P'),
(185007, 'Scissors Crossing', 33.0963897705078, 0.577640972018732, -116.47444152832, -2.03286249909081, 218, 6, 'PPL', 'P'),
(114034, 'Scitico', 41.9847183227539, 0.732771570254447, -72.51611328125, -1.265644937507, 218, 8, 'PPL', 'P'),
(126042, 'Scituate', 42.1958312988281, 0.736456186780626, -70.7263870239258, -1.2344083216073, 218, 23, 'PPL', 'P'),
(128756, 'Scituate', 43.1683311462402, 0.75342951109311, -70.6786117553711, -1.23357448586999, 218, 26, 'PPL', 'P'),
(126043, 'Scituate Center', 42.2041702270508, 0.736601728534199, -70.7611083984375, -1.23501432391335, 218, 23, 'PPL', 'P'),
(126044, 'Scituate Station', 42.1930618286133, 0.736407850406841, -70.7416687011719, -1.23467503719047, 218, 23, 'PPL', 'P'),
(197493, 'Sciuchetti Place', 45.9430618286133, 0.801857697356628, -112.772499084473, -1.96825141472634, 218, 31, 'PPL', 'P'),
(97921, 'Scobee', 30.6455593109131, 0.534865911090638, -98.3158264160156, -1.71593487777869, 218, 51, 'PPL', 'P'),
(57451, 'Scobeville', 36.1852798461914, 0.631552274071587, -90.0744400024414, -1.57209554993269, 218, 29, 'PPL', 'P'),
(61695, 'Scobey', 33.9413909912109, 0.592389025503373, -89.8658294677734, -1.56845460924839, 218, 30, 'PPL', 'P'),
(197494, 'Scobey', 48.7924995422363, 0.85158976728985, -105.420280456543, -1.83993099234251, 218, 31, 'PPL', 'P'),
(146274, 'Scobeyville', 40.2969398498535, 0.703314278858053, -74.1436080932617, -1.29405008053573, 218, 37, 'PPL', 'P'),
(11825, 'Scoby (historical)', 33.7297210693359, 0.588694688439215, -92.084716796875, -1.607181498872, 218, 4, 'PPL', 'P'),
(97922, 'Scofield', 30.353609085083, 0.529770418397962, -96.4397201538086, -1.68319064638589, 218, 51, 'PPL', 'P'),
(133029, 'Scofield', 42.0213890075684, 0.73341159444342, -83.4819412231445, -1.45703474030025, 218, 27, 'PPL', 'P'),
(192774, 'Scofield', 39.7241706848145, 0.693317571074223, -111.160003662109, -1.94010806043276, 218, 52, 'PPL', 'P'),
(24709, 'Scoggins Ridge', 33.898609161377, 0.591642341712742, -84.8777770996094, -1.48139667216203, 218, 13, 'PPL', 'P'),
(18008, 'Sconiers Mill', 30.6794395446777, 0.535457232721176, -86.1638870239258, -1.50384352488392, 218, 12, 'PPL', 'P'),
(79096, 'Sconnelltown', 39.9361114501953, 0.697016635249316, -75.6255569458008, -1.31991496735869, 218, 45, 'PPL', 'P'),
(152428, 'Sconondoa', 43.0958290100098, 0.752164110101159, -75.623893737793, -1.31988593890281, 218, 40, 'PPL', 'P'),
(61696, 'Scooba', 32.8280601501465, 0.5729577366628, -88.4763870239258, -1.54420426383629, 218, 30, 'PPL', 'P'),
(90643, 'Scoot Mill', 36.1505584716797, 0.63094627176554, -83.1322174072266, -1.45093090823985, 218, 50, 'PPL', 'P'),
(24710, 'Scooterville', 31.3819408416748, 0.547718193353306, -83.6900024414063, -1.46066609360463, 218, 13, 'PPL', 'P'),
(198872, 'Scoria Point', 46.9311103820801, 0.819102397784191, -103.485000610352, -1.80615398707898, 218, 34, 'PPL', 'P'),
(126046, 'Scorton Shores', 41.7416687011719, 0.728529554112114, -70.4124984741211, -1.2289299329289, 218, 23, 'PPL', 'P'),
(200194, 'Scossa', 40.7400016784668, 0.711047166557262, -118.595558166504, -2.06988296824594, 218, 39, 'PPL', 'P'),
(71357, 'Scotch Bonnet', 39.0683288574219, 0.681870971813926, -74.788330078125, -1.30530260193159, 218, 37, 'PPL', 'P'),
(152435, 'Scotch Bush', 42.8574981689453, 0.748004452215537, -74.1958312988281, -1.29496154741881, 218, 40, 'PPL', 'P'),
(152429, 'Scotch Church', 42.8716697692871, 0.748251793301778, -74.1355590820313, -1.29390959878823, 218, 40, 'PPL', 'P'),
(197495, 'Scotch Coulee (historical)', 45.163890838623, 0.788258598145275, -109.212501525879, -1.90611773596592, 218, 31, 'PPL', 'P'),
(117697, 'Scotch Grove', 42.172779083252, 0.736053849718942, -91.1074981689453, -1.5901258163028, 218, 16, 'PPL', 'P'),
(111317, 'Scotch Hill', 39.3741683959961, 0.687208878744826, -79.8661117553711, -1.39392661089697, 218, 58, 'PPL', 'P'),
(152430, 'Scotch Hill', 42.6730613708496, 0.744785422826931, -75.0650024414063, -1.31013144562012, 218, 40, 'PPL', 'P'),
(166952, 'Scotch Hill', 41.3266716003418, 0.721286488316399, -79.2655563354492, -1.38344494147864, 218, 45, 'PPL', 'P'),
(166953, 'Scotch Hollow', 40.8697204589844, 0.713311186378966, -78.3024978637695, -1.3666364002586, 218, 45, 'PPL', 'P'),
(146275, 'Scotch Plains', 40.6552810668945, 0.709568512941023, -74.3902816772461, -1.29835534675395, 218, 37, 'PPL', 'P'),
(51246, 'Scotch Point', 38.3355598449707, 0.669081739890066, -76.5116729736328, -1.33538060959905, 218, 25, 'PPL', 'P'),
(83527, 'Scotch Range Estates', 33.0163917541504, 0.57624474323823, -80.2847213745117, -1.4012327270315, 218, 48, 'PPL', 'P'),
(117699, 'Scotch Ridge', 41.4724998474121, 0.723831671370187, -93.5583267211914, -1.63290084394138, 218, 16, 'PPL', 'P'),
(157562, 'Scotch Ridge', 41.4025001525879, 0.722609946220113, -83.523063659668, -1.45775246221403, 218, 41, 'PPL', 'P'),
(152431, 'Scotchbrush', 43.0716705322266, 0.751742465121572, -74.5741729736328, -1.30156485534166, 218, 40, 'PPL', 'P'),
(51247, 'Scotchmans Glen', 39.4541702270508, 0.688605174104355, -75.8952789306641, -1.32462250405957, 218, 25, 'PPL', 'P'),
(31087, 'Scotchtown', 39.0750007629395, 0.68198741853259, -87.2977828979492, -1.52363374126041, 218, 19, 'PPL', 'P'),
(106071, 'Scotchtown', 37.8441696166992, 0.660505362494602, -77.5869369506836, -1.35414750632668, 218, 53, 'PPL', 'P'),
(152432, 'Scotchtown', 41.4813919067383, 0.723986867082712, -74.3605575561523, -1.29783656297361, 218, 40, 'PPL', 'P'),
(51248, 'Scotchtown Hills', 39.103328704834, 0.682481834388963, -76.8861083984375, -1.341915740598, 218, 25, 'PPL', 'P'),
(24713, 'Scotchville', 30.7688903808594, 0.537018444331208, -81.6175003051758, -1.42449410757279, 218, 13, 'PPL', 'P'),
(197496, 'Scotchville (historical)', 48.2999992370605, 0.842994015397456, -115.306938171387, -2.01248572148423, 218, 31, 'PPL', 'P'),
(106075, 'Scotfield', 36.8016700744629, 0.642310313032044, -76.4119415283203, -1.33363996751058, 218, 53, 'PPL', 'P'),
(11826, 'Scotia', 35.3311080932617, 0.616644164605433, -93.2922210693359, -1.62825642415834, 218, 4, 'PPL', 'P'),
(57452, 'Scotia', 38.0277786254883, 0.663709944234294, -91.2136077880859, -1.59197777852484, 218, 29, 'PPL', 'P'),
(68590, 'Scotia', 35.8594398498535, 0.625865293300805, -76.2174987792969, -1.33024630133349, 218, 33, 'PPL', 'P'),
(83528, 'Scotia', 32.6808280944824, 0.570388052526983, -81.2436065673828, -1.41796843079572, 218, 48, 'PPL', 'P'),
(142970, 'Scotia', 41.4663887023926, 0.72372501176853, -98.7027816772461, -1.72268852114508, 218, 35, 'PPL', 'P'),
(152433, 'Scotia', 42.8263893127441, 0.747461500248297, -73.9647216796875, -1.29092792363178, 218, 40, 'PPL', 'P'),
(166954, 'Scotia', 40.7997207641602, 0.712089461228892, -77.9463882446289, -1.36042111490658, 218, 45, 'PPL', 'P'),
(193936, 'Scotia', 40.4824981689453, 0.706552882480671, -124.099716186523, -2.16594864824534, 218, 6, 'PPL', 'P'),
(208681, 'Scotia', 48.1063919067383, 0.839614930027336, -117.153060913086, -2.04470664172282, 218, 56, 'PPL', 'P'),
(142972, 'Scotia Junction', 41.4552803039551, 0.723531133641172, -98.7172164916992, -1.7229404561842, 218, 35, 'PPL', 'P'),
(5690, 'Scotland', 31.6666698455811, 0.552687651947394, -87.273063659668, -1.52320230916382, 218, 2, 'PPL', 'P'),
(11828, 'Scotland', 35.5275001525879, 0.620071852665447, -92.6116714477539, -1.61637859253853, 218, 4, 'PPL', 'P'),
(18009, 'Scotland', 30.5763893127441, 0.533658666878991, -84.4302825927734, -1.47358641963315, 218, 12, 'PPL', 'P'),
(24711, 'Scotland', 32.0486106872559, 0.559353777182457, -82.8172225952148, -1.44543321164354, 218, 13, 'PPL', 'P'),
(31088, 'Scotland', 38.9127807617188, 0.679156145398699, -86.9038925170898, -1.51675905722248, 218, 19, 'PPL', 'P'),
(51250, 'Scotland', 38.0888900756836, 0.664776540250871, -76.3622207641602, -1.33277217646938, 218, 25, 'PPL', 'P'),
(57456, 'Scotland', 37.0830612182617, 0.647221514977287, -94.3769378662109, -1.64718830371549, 218, 29, 'PPL', 'P'),
(61697, 'Scotland', 32.7052803039551, 0.570814824091668, -90.2211074829102, -1.57465538037248, 218, 30, 'PPL', 'P'),
(79097, 'Scotland', 39.9686088562012, 0.697583821982475, -77.5875015258789, -1.35415736002271, 218, 45, 'PPL', 'P'),
(97923, 'Scotland', 33.6599998474121, 0.58747782355813, -98.4702835083008, -1.71863066259212, 218, 51, 'PPL', 'P'),
(106072, 'Scotland', 37.1836090087891, 0.648976404977594, -76.7866668701172, -1.34018015851559, 218, 53, 'PPL', 'P'),
(114035, 'Scotland', 41.6983299255371, 0.727773149783504, -72.0819396972656, -1.25806717894129, 218, 8, 'PPL', 'P'),
(126047, 'Scotland', 41.9722213745117, 0.73255345736117, -71.0069427490234, -1.23930494274557, 218, 23, 'PPL', 'P'),
(128758, 'Scotland', 43.7905616760254, 0.76428948254429, -70.3561096191406, -1.22794576174806, 218, 26, 'PPL', 'P'),
(144428, 'Scotland', 42.7572212219238, 0.746254289326164, -72.3580627441406, -1.2628864352499, 218, 36, 'PPL', 'P'),
(157563, 'Scotland', 41.5224990844727, 0.724704322680379, -81.3616714477539, -1.42002905168917, 218, 41, 'PPL', 'P'),
(171270, 'Scotland', 43.1497192382813, 0.753104672019147, -97.7172164916992, -1.70548716366425, 218, 49, 'PPL', 'P'),
(185008, 'Scotland', 34.2422218322754, 0.597639514171491, -117.497222900391, -2.0507134015615, 218, 6, 'PPL', 'P'),
(42989, 'Scotland (historical)', 31.5422191619873, 0.550515577762325, -91.4963912963867, -1.59691328181503, 218, 22, 'PPL', 'P'),
(51251, 'Scotland Beach', 38.0713882446289, 0.664471075673839, -76.3300018310547, -1.3322098500052, 218, 25, 'PPL', 'P'),
(126048, 'Scotland Estates', 41.9599990844727, 0.732340138157854, -71.0077819824219, -1.23931959013157, 218, 23, 'PPL', 'P'),
(61699, 'Scotland Fork', 32.7130584716797, 0.570950578728235, -90.2238922119141, -1.57470398306237, 218, 30, 'PPL', 'P'),
(106073, 'Scotland Landing', 37.6886100769043, 0.657790336342293, -76.9674987792969, -1.34333627072345, 218, 53, 'PPL', 'P'),
(68588, 'Scotland Neck', 36.1294403076172, 0.630577690270673, -77.4205627441406, -1.35124372863211, 218, 33, 'PPL', 'P'),
(42991, 'Scotlandville', 30.5202808380127, 0.532679389256656, -91.1786117553711, -1.59136698252883, 218, 22, 'PPL', 'P'),
(166955, 'Scotrun', 41.0658302307129, 0.716733947590963, -75.3202819824219, -1.31458691412382, 218, 45, 'PPL', 'P'),
(51252, 'Scots Fancy', 39.5297203063965, 0.68992377173908, -76.3152770996094, -1.33195285496001, 218, 25, 'PPL', 'P'),
(51253, 'Scotsdale', 39.5041694641113, 0.689477825414547, -76.970832824707, -1.34339446079327, 218, 25, 'PPL', 'P'),
(57454, 'Scotsdale', 38.3988914489746, 0.670187084900503, -90.5872192382813, -1.58104523593396, 218, 29, 'PPL', 'P'),
(11829, 'Scott', 34.6963882446289, 0.60556621341903, -92.0961074829102, -1.60738030384737, 218, 4, 'PPL', 'P'),
(24712, 'Scott', 32.5516700744629, 0.568133819822285, -82.6669387817383, -1.44281026428592, 218, 13, 'PPL', 'P'),
(42992, 'Scott', 30.235559463501, 0.527710063820622, -92.0944366455078, -1.60735114223343, 218, 22, 'PPL', 'P'),
(57455, 'Scott', 38.6188888549805, 0.674026763981152, -92.2769393920898, -1.61053641605522, 218, 29, 'PPL', 'P'),
(61698, 'Scott', 33.5916709899902, 0.586285260021993, -91.0741729736328, -1.58954418192073, 218, 30, 'PPL', 'P'),
(77198, 'Scott', 35.3766708374023, 0.61743938450693, -98.2361068725586, -1.71454350926718, 218, 42, 'PPL', 'P'),
(83530, 'Scott', 34.5344390869141, 0.602739667396075, -79.6922225952148, -1.39089167251872, 218, 48, 'PPL', 'P'),
(90645, 'Scott', 35.6547203063965, 0.6222922632243, -84.751106262207, -1.4791858489831, 218, 50, 'PPL', 'P'),
(97924, 'Scott', 32.5944404602051, 0.568880303875834, -96.0219421386719, -1.67589904447931, 218, 51, 'PPL', 'P'),
(117700, 'Scott', 42.7019386291504, 0.745289426063228, -91.7652816772461, -1.60160630428797, 218, 16, 'PPL', 'P'),
(123633, 'Scott', 41.7336082458496, 0.728388872627531, -85.5569381713867, -1.49325026901591, 218, 19, 'PPL', 'P'),
(138022, 'Scott', 47.4497184753418, 0.828153816539098, -92.7694396972656, -1.61913216794762, 218, 28, 'PPL', 'P'),
(144429, 'Scott', 44.4122200012207, 0.775139467141381, -71.6374969482422, -1.25031018963422, 218, 36, 'PPL', 'P'),
(152434, 'Scott', 42.7294387817383, 0.745769394270688, -76.2436065673828, -1.330701968196, 218, 40, 'PPL', 'P'),
(157564, 'Scott', 40.9897193908691, 0.715405562839231, -84.5833282470703, -1.4762575702065, 218, 41, 'PPL', 'P'),
(166956, 'Scott', 41.5694389343262, 0.725523577610715, -75.6324996948242, -1.32003614118829, 218, 45, 'PPL', 'P'),
(208682, 'Scott', 46.5074996948242, 0.811708996544941, -118.604721069336, -2.0700428910694, 218, 56, 'PPL', 'P'),
(74234, 'Scott (historical)', 39.8080596923828, 0.694781710462521, -81.6130599975586, -1.42441660958507, 218, 41, 'PPL', 'P'),
(111318, 'Scott (historical)', 39.2413902282715, 0.684891462543267, -81.6808319091797, -1.42559945258323, 218, 58, 'PPL', 'P'),
(51254, 'Scott Acres', 39.1730613708496, 0.683698899007129, -76.9219436645508, -1.34254118398, 218, 25, 'PPL', 'P'),
(106074, 'Scott Addition', 36.7202796936035, 0.640889782906596, -81.9416732788086, -1.43015199330867, 218, 53, 'PPL', 'P'),
(193935, 'Scott Bar', 41.7419395446777, 0.728534281223049, -123.003059387207, -2.14680837633288, 218, 6, 'PPL', 'P'),
(166957, 'Scott Center', 41.9388885498047, 0.731971689821042, -75.3952789306641, -1.3158958577996, 218, 45, 'PPL', 'P'),
(13204, 'Scott Circle', 38.9091682434082, 0.679093095059892, -77.0361099243164, -1.3445337611076, 218, 9, 'PPL', 'P'),
(5691, 'Scott City', 33.5469398498535, 0.585504554348436, -86.579719543457, -1.51110117148661, 218, 2, 'PPL', 'P'),
(31089, 'Scott City', 39.1938896179199, 0.684062420495925, -87.4649963378906, -1.52655216634097, 218, 19, 'PPL', 'P'),
(57457, 'Scott City', 37.2166709899902, 0.649553445406787, -89.5244369506836, -1.5624961857835, 218, 29, 'PPL', 'P'),
(187892, 'Scott City', 38.4824981689453, 0.671646297440785, -100.906669616699, -1.76115362203353, 218, 20, 'PPL', 'P'),
(123634, 'Scott Corner', 40.0919418334961, 0.699736388512559, -85.1269378662109, -1.48574534790602, 218, 19, 'PPL', 'P'),
(126050, 'Scott Corners', 42.1819381713867, 0.736213705963374, -72.5061111450195, -1.26547036729755, 218, 23, 'PPL', 'P'),
(157565, 'Scott Corners', 40.0744400024414, 0.699430923935527, -82.6055603027344, -1.44173900773744, 218, 41, 'PPL', 'P'),
(5692, 'Scott Crest Subdivision', 33.2758293151855, 0.580772782881638, -86.9466705322266, -1.51750567443408, 218, 2, 'PPL', 'P'),
(97925, 'Scott Crossing', 33.0774993896484, 0.57731127267578, -99.543327331543, -1.73735881032589, 218, 51, 'PPL', 'P'),
(111319, 'Scott Depot', 38.4416694641113, 0.670933702112107, -81.9169387817383, -1.42972029489597, 218, 58, 'PPL', 'P'),
(57459, 'Scott Ford', 37.9780616760254, 0.662842219772119, -91.4555587768555, -1.59620061990733, 218, 29, 'PPL', 'P'),
(166958, 'Scott Haven', 40.2555618286133, 0.702592096149451, -79.789436340332, -1.39258837244921, 218, 45, 'PPL', 'P'),
(90648, 'Scott Hill', 35.9058303833008, 0.626674960851216, -88.4805603027344, -1.54427710129211, 218, 50, 'PPL', 'P'),
(126049, 'Scott Hill Acres', 42.0680618286133, 0.734226188841848, -71.470832824707, -1.24740135193358, 218, 23, 'PPL', 'P'),
(90647, 'Scott Hills', 35.7063903808594, 0.623194076148428, -84.0277786254883, -1.46656140015169, 218, 50, 'PPL', 'P'),
(138024, 'Scott Junction', 47.4083290100098, 0.827431434093414, -91.6102828979492, -1.59890106525267, 218, 28, 'PPL', 'P'),
(18010, 'Scott Lake', 25.9411106109619, 0.452757791785323, -80.2322235107422, -1.40031646645846, 218, 12, 'PPL', 'P'),
(133030, 'Scott Lake', 46.0219383239746, 0.803234351903118, -88.5766677856445, -1.54595449330469, 218, 27, 'PPL', 'P'),
(42993, 'Scott Landing', 32.4341697692871, 0.56608305262487, -91.4872207641602, -1.59675322583352, 218, 22, 'PPL', 'P'),
(68592, 'Scott Park', 36.077220916748, 0.62966628996662, -79.7652816772461, -1.39216679404865, 218, 33, 'PPL', 'P'),
(193937, 'Scott Place', 40.2066688537598, 0.701738752757162, -124.032218933105, -2.16477059893714, 218, 6, 'PPL', 'P'),
(177273, 'Scott Run', 40.2997207641602, 0.70336281496892, -80.5325012207031, -1.40555730116762, 218, 58, 'PPL', 'P'),
(11832, 'Scott Valley', 34.7299995422363, 0.606152841228147, -90.7677764892578, -1.58419655445185, 218, 4, 'PPL', 'P'),
(111321, 'Scott Village', 38.4441719055176, 0.670977377953984, -81.9102783203125, -1.42960404791438, 218, 58, 'PPL', 'P'),
(24714, 'Scottdale', 33.7897186279297, 0.589741843379834, -84.2641677856445, -1.47068716931244, 218, 13, 'PPL', 'P'),
(133034, 'Scottdale', 42.0419387817383, 0.733770255663227, -86.4352798461914, -1.50858022319874, 218, 27, 'PPL', 'P'),
(166964, 'Scottdale', 40.1002807617188, 0.699881930266132, -79.5872192382813, -1.38905901821458, 218, 45, 'PPL', 'P'),
(205690, 'Scottish Heights', 40.5950012207031, 0.708516431152387, -111.801666259766, -1.95130718544876, 218, 52, 'PPL', 'P'),
(5693, 'Scottland', 32.0263900756836, 0.558965954348715, -85.7063903808594, -1.49585870214559, 218, 2, 'PPL', 'P'),
(28554, 'Scottland', 39.8044395446777, 0.694718526965659, -87.6050033569336, -1.52899574979918, 218, 18, 'PPL', 'P'),
(208683, 'Scotton Corner', 45.7666702270508, 0.798779083136497, -122.535827636719, -2.138653643917, 218, 56, 'PPL', 'P'),
(38128, 'Scottown', 37.3230590820313, 0.651410267897818, -86.9652786254883, -1.51783044692902, 218, 21, 'PPL', 'P'),
(51255, 'Scottown', 38.961669921875, 0.680009422211961, -76.0944366455078, -1.32809846191434, 218, 25, 'PPL', 'P'),
(74236, 'Scottown', 38.5502815246582, 0.672829340176025, -82.3888931274414, -1.43795745214758, 218, 41, 'PPL', 'P'),
(5694, 'Scottrock', 33.2511100769043, 0.580341350785045, -86.8233337402344, -1.51535304132497, 218, 2, 'PPL', 'P'),
(28555, 'Scotts', 39.8452796936035, 0.695431322031419, -87.6627807617188, -1.53000415574594, 218, 18, 'PPL', 'P'),
(68594, 'Scotts', 35.6813888549805, 0.622757717203819, -78.0166702270508, -1.36164776690467, 218, 33, 'PPL', 'P'),
(133031, 'Scotts', 42.1958312988281, 0.736456186780626, -85.4130630493164, -1.49073917442408, 218, 27, 'PPL', 'P'),
(185009, 'Scotts', 39.8463897705078, 0.695450696528349, -120.09139251709, -2.0959902027281, 218, 6, 'PPL', 'P'),
(14559, 'Scotts Corner', 38.7808303833008, 0.676853176846053, -75.6675033569336, -1.32064707034235, 218, 10, 'PPL', 'P'),
(24715, 'Scotts Corner', 32.9005584716797, 0.574223071075724, -82.1766662597656, -1.43425339454544, 218, 13, 'PPL', 'P'),
(57461, 'Scotts Corner', 39.1627807617188, 0.683519468528685, -91.6477813720703, -1.59955553709055, 218, 29, 'PPL', 'P'),
(106079, 'Scotts Corner', 37.8833312988281, 0.661188862788371, -76.6066665649414, -1.33703856053568, 218, 53, 'PPL', 'P'),
(138026, 'Scotts Corner', 46.5980606079102, 0.813289582651903, -92.4286117553711, -1.61318359817876, 218, 28, 'PPL', 'P'),
(152437, 'Scotts Corner', 41.5255584716797, 0.724757719060235, -74.2011108398438, -1.29505369279253, 218, 40, 'PPL', 'P'),
(185010, 'Scotts Corner', 37.5888900756836, 0.656049893990899, -121.870002746582, -2.12703280734239, 218, 6, 'PPL', 'P'),
(192185, 'Scotts Corner', 32.8088912963867, 0.572623177050859, -100.59944152832, -1.75579148033671, 218, 51, 'PPL', 'P'),
(152438, 'Scotts Corners', 41.1891708374023, 0.718886647279101, -73.5511093139648, -1.28370902602295, 218, 40, 'PPL', 'P'),
(24716, 'Scotts Cove', 34.2191696166992, 0.597237177109807, -83.9397201538086, -1.4650244898866, 218, 13, 'PPL', 'P'),
(157568, 'Scotts Crossing', 40.8177795410156, 0.712404646343902, -84.2727813720703, -1.47083750475597, 218, 41, 'PPL', 'P'),
(166966, 'Scotts Crossing', 41.9355583190918, 0.731913566330251, -79.5952835083008, -1.38919976627819, 218, 45, 'PPL', 'P'),
(192186, 'Scotts Crossing', 30.9383296966553, 0.539975718274173, -104.906669616699, -1.8309667921133, 218, 51, 'PPL', 'P'),
(106085, 'Scotts Crossroad', 36.815559387207, 0.642552727270269, -78.4044418334961, -1.36841565818289, 218, 53, 'PPL', 'P'),
(68596, 'Scotts Crossroads', 35.7947196960449, 0.624735713524448, -77.5369415283203, -1.35327492159551, 218, 33, 'PPL', 'P'),
(18011, 'Scotts Ferry', 30.295280456543, 0.528752391781766, -85.1316680908203, -1.48582790589981, 218, 12, 'PPL', 'P'),
(185011, 'Scotts Flat', 39.2833290100098, 0.685623432368875, -120.912498474121, -2.11032120518603, 218, 6, 'PPL', 'P'),
(106080, 'Scotts Fork', 37.3180618286133, 0.651323049372118, -77.8905563354492, -1.35944666426372, 218, 53, 'PPL', 'P'),
(68597, 'Scotts Hill', 34.3211097717285, 0.599016368455062, -77.76611328125, -1.3572747232367, 218, 33, 'PPL', 'P'),
(90650, 'Scotts Hill', 35.5149993896484, 0.619853673193142, -88.2452774047852, -1.54017064004926, 218, 50, 'PPL', 'P'),
(176312, 'Scotts Junction', 43.9647216796875, 0.767329148033479, -90.6691665649414, -1.58247548659738, 218, 57, 'PPL', 'P'),
(51256, 'Scotts Level', 39.3661117553711, 0.68706826383927, -76.7583312988281, -1.33968560950117, 218, 25, 'PPL', 'P'),
(51257, 'Scotts Manor', 39.0791702270508, 0.682060189409376, -76.6963882446289, -1.33860449925665, 218, 25, 'PPL', 'P'),
(24717, 'Scotts Mill', 33.9777793884277, 0.593024122844329, -84.2016677856445, -1.46959633852994, 218, 13, 'PPL', 'P'),
(90652, 'Scotts Mill', 35.4997215270996, 0.619587024188998, -87.1483306884766, -1.52102530813073, 218, 50, 'PPL', 'P'),
(121404, 'Scotts Mill', 40.0838890075684, 0.69959584018603, -90.7050018310547, -1.58310092997939, 218, 18, 'PPL', 'P'),
(201540, 'Scotts Mills', 45.0430603027344, 0.786149707457069, -122.667221069336, -2.14094689193167, 218, 43, 'PPL', 'P'),
(51258, 'Scotts Ridge', 39.6086082458496, 0.691300626022651, -76.8319396972656, -1.34097031841102, 218, 25, 'PPL', 'P'),
(68599, 'Scotts Store', 35.0947189331055, 0.612518395444682, -76.8797225952148, -1.34180428730638, 218, 33, 'PPL', 'P'),
(185012, 'Scotts Valley', 37.0511093139648, 0.646663849045024, -122.013610839844, -2.12953924140232, 218, 6, 'PPL', 'P'),
(199669, 'Scottsbluff', 41.8666687011719, 0.730711215677107, -103.66667175293, -1.80932474667282, 218, 35, 'PPL', 'P'),
(5695, 'Scottsboro', 34.6722183227539, 0.605144368702362, -86.0341720581055, -1.50157957164125, 218, 2, 'PPL', 'P'),
(24718, 'Scottsboro', 33.0247192382813, 0.576390085254722, -83.2347183227539, -1.45271988670211, 218, 13, 'PPL', 'P'),
(90651, 'Scottsboro', 36.2105598449707, 0.631993493285186, -86.9277801513672, -1.51717597509113, 218, 50, 'PPL', 'P'),
(5696, 'Scottsboro Crossroads', 31.6991691589355, 0.553254871970067, -85.2119369506836, -1.48722886179125, 218, 2, 'PPL', 'P'),
(31094, 'Scottsburg', 38.6855583190918, 0.675190365640435, -85.7702789306641, -1.49697376769401, 218, 19, 'PPL', 'P'),
(38129, 'Scottsburg', 37.0786094665527, 0.647143817252483, -87.8213882446289, -1.53277237854102, 218, 21, 'PPL', 'P'),
(106081, 'Scottsburg', 36.7572212219238, 0.641534534206504, -78.7900009155273, -1.3751449336253, 218, 53, 'PPL', 'P'),
(121405, 'Scottsburg', 40.5538902282715, 0.707798908975692, -90.5936126708984, -1.58115682238363, 218, 18, 'PPL', 'P'),
(152439, 'Scottsburg', 42.6641693115234, 0.744630227114406, -77.7144393920898, -1.35637284373355, 218, 40, 'PPL', 'P'),
(201541, 'Scottsburg', 43.6541709899902, 0.761909016003922, -123.815559387207, -2.16098917650534, 218, 43, 'PPL', 'P'),
(179107, 'Scottsdale', 33.5091705322266, 0.584845355399614, -111.898330688477, -1.95299429799933, 218, 5, 'PPL', 'P'),
(179108, 'Scottsdale Mobile Home Park', 33.4533309936523, 0.5838707715987, -111.915832519531, -1.95329976257636, 218, 5, 'PPL', 'P'),
(14560, 'Scottsdale Park Mobile Home Park', 38.5011100769043, 0.671971136514747, -75.5502777099609, -1.3186010968349, 218, 10, 'PPL', 'P'),
(179109, 'Scottsdale Ranch', 33.5750007629395, 0.585994309672902, -111.857498168945, -1.95228163609162, 218, 5, 'PPL', 'P'),
(179110, 'Scottsdale Trailer Corral', 33.4841690063477, 0.584408996455005, -111.924438476563, -1.95344996486184, 218, 5, 'PPL', 'P'),
(18012, 'Scottsmoor', 28.7666702270508, 0.502073110297461, -80.8783264160156, -1.41159308946218, 218, 12, 'PPL', 'P'),
(5699, 'Scottsville', 33.0330581665039, 0.576535627008294, -87.1999969482422, -1.52192705447583, 218, 2, 'PPL', 'P'),
(11837, 'Scottsville', 35.4486083984375, 0.618694931802848, -93.04638671875, -1.62396580532611, 218, 4, 'PPL', 'P'),
(28556, 'Scottsville', 38.3291702270508, 0.668970220019419, -88.1722183227539, -1.53889551851933, 218, 18, 'PPL', 'P'),
(31095, 'Scottsville', 38.4019393920898, 0.670240281543277, -85.9091720581055, -1.49939791007625, 218, 19, 'PPL', 'P'),
(33912, 'Scottsville', 39.5436096191406, 0.690166185977305, -97.9527816772461, -1.70959855175512, 218, 20, 'PPL', 'P'),
(38130, 'Scottsville', 36.7533302307129, 0.641466623598707, -86.190559387207, -1.50430904544247, 218, 21, 'PPL', 'P'),
(42994, 'Scottsville', 32.9372215270996, 0.574862962106643, -92.7666702270508, -1.61908383157383, 218, 22, 'PPL', 'P'),
(83532, 'Scottsville', 33.9566688537598, 0.592655674507517, -80.1669387817383, -1.39917703298606, 218, 48, 'PPL', 'P'),
(97926, 'Scottsville', 32.5402793884277, 0.567935014846911, -94.2380599975586, -1.64476442764936, 218, 51, 'PPL', 'P'),
(106082, 'Scottsville', 37.7986106872559, 0.659710209172131, -78.4958267211914, -1.37001062535974, 218, 53, 'PPL', 'P'),
(152440, 'Scottsville', 43.0258293151855, 0.750942384951085, -77.7455596923828, -1.35691599543787, 218, 40, 'PPL', 'P'),
(166968, 'Scottsville', 41.5961112976074, 0.72598909816926, -76.0966720581055, -1.32813747722431, 218, 45, 'PPL', 'P'),
(172502, 'Scottsville', 43.3925018310547, 0.757342027629572, -73.0083312988281, -1.27423576255138, 218, 55, 'PPL', 'P'),
(185013, 'Scottsville', 38.3347206115723, 0.66906709250407, -120.754722595215, -2.10756749661889, 218, 6, 'PPL', 'P'),
(106084, 'Scottswood', 36.7044410705566, 0.640613346785446, -76.982780456543, -1.34360298630662, 218, 53, 'PPL', 'P'),
(28557, 'Scottville', 39.480281829834, 0.689060907545895, -90.1047210693359, -1.57262405425102, 218, 18, 'PPL', 'P'),
(68601, 'Scottville', 36.480281829834, 0.636701029986065, -81.3077774047852, -1.41908842319215, 218, 33, 'PPL', 'P'),
(133032, 'Scottville', 43.954719543457, 0.767154577824024, -86.2799987792969, -1.50587005731542, 218, 27, 'PPL', 'P'),
(193938, 'Scotty Place', 41.1241683959961, 0.717752140654727, -120.872779846191, -2.10962798435429, 218, 6, 'PPL', 'P'),
(190718, 'Scottys Junction', 37.2988891601563, 0.650988423181149, -117.051940917969, -2.04294176486843, 218, 39, 'PPL', 'P'),
(24719, 'Scoutland', 34.3416709899902, 0.59937522941195, -83.8744430541992, -1.46388518957227, 218, 13, 'PPL', 'P'),
(51259, 'Scouts Knoll', 39.4702796936035, 0.68888633733644, -77.3138885498047, -1.34938191271404, 218, 25, 'PPL', 'P'),
(121406, 'Scovel', 40.9116706848145, 0.714043355941655, -88.3983306884766, -1.54284192378066, 218, 18, 'PPL', 'P'),
(185014, 'Scovern Hot Springs (historical)', 35.6213912963867, 0.6217105622632, -118.473327636719, -2.06774964305473, 218, 6, 'PPL', 'P'),
(114037, 'Scovill Landing', 41.4891700744629, 0.724122621719278, -72.4655609130859, -1.26476263223786, 218, 8, 'PPL', 'P'),
(38131, 'Scoville', 37.4538917541504, 0.653693728795479, -83.7200012207031, -1.46118967107494, 218, 21, 'PPL', 'P'),
(199670, 'Scoville', 42.0155601501465, 0.733309861689779, -103.917503356934, -1.81370258403075, 218, 35, 'PPL', 'P'),
(209867, 'Scoville', 43.4805603027344, 0.758878937894657, -112.995277404785, -1.97213962991785, 218, 17, 'PPL', 'P'),
(193303, 'Scow Bay', 56.7702789306641, 0.990828284615654, -132.96028137207, -2.32059468432071, 218, 1, 'PPL', 'P'),
(71358, 'Scow Landing', 39.5980606079102, 0.6911165350123, -74.3399963378906, -1.29747770201672, 218, 37, 'PPL', 'P'),
(106088, 'Scrabble', 38.5819396972656, 0.673381879523189, -78.1597213745117, -1.36414448042662, 218, 53, 'PPL', 'P'),
(111322, 'Scrabble', 39.4836082458496, 0.689118964457658, -77.8327789306641, -1.35843825831696, 218, 58, 'PPL', 'P'),
(5701, 'Scranton', 31.1927795410156, 0.544416705839448, -85.8419418334961, -1.49822452129996, 218, 2, 'PPL', 'P'),
(11839, 'Scranton', 35.3611106872559, 0.61716780865477, -93.5355606079102, -1.63250350030674, 218, 4, 'PPL', 'P'),
(33913, 'Scranton', 38.7816696166992, 0.676867824232049, -95.7383270263672, -1.67094902696118, 218, 20, 'PPL', 'P'),
(38132, 'Scranton', 37.9872207641602, 0.663002076016551, -83.5216674804688, -1.45772809429006, 218, 21, 'PPL', 'P'),
(68603, 'Scranton', 35.496940612793, 0.619538488078131, -76.4516677856445, -1.33433332150038, 218, 33, 'PPL', 'P'),
(83533, 'Scranton', 33.9174995422363, 0.591972041055693, -79.7441711425781, -1.39179834571184, 218, 48, 'PPL', 'P'),
(97927, 'Scranton', 32.3050003051758, 0.56382862018309, -99.1066665649414, -1.72973764223441, 218, 51, 'PPL', 'P'),
(117714, 'Scranton', 42.0224990844727, 0.733430968940351, -94.5449981689453, -1.65012150934011, 218, 16, 'PPL', 'P'),
(138027, 'Scranton', 47.4258308410645, 0.827736898670446, -92.9488906860352, -1.6222641785476, 218, 28, 'PPL', 'P'),
(166970, 'Scranton', 41.4088897705078, 0.72272146609076, -75.6627807617188, -1.32056464550662, 218, 45, 'PPL', 'P'),
(177392, 'Scranton', 42.7405586242676, 0.745963472135127, -78.8344421386719, -1.37592057929278, 218, 40, 'PPL', 'P'),
(185015, 'Scranton', 36.4519386291504, 0.636206347813583, -116.502777099609, -2.03335704810523, 218, 6, 'PPL', 'P'),
(198876, 'Scranton', 46.1480598449707, 0.805435587702123, -103.142501831055, -1.80017625569618, 218, 34, 'PPL', 'P'),
(166969, 'Scranton Corners', 41.6308288574219, 0.726595033896281, -76.0841674804688, -1.32791923117298, 218, 45, 'PPL', 'P'),
(14561, 'Scrap Tavern Crossroads', 39.0061111450195, 0.680785067879446, -75.5280609130859, -1.31821334058018, 218, 10, 'PPL', 'P'),
(77199, 'Scraper', 36.0894393920898, 0.629879542590909, -94.8502807617188, -1.65544969573303, 218, 42, 'PPL', 'P'),
(200196, 'Scraper Springs', 41.3377799987793, 0.721480366443756, -116.680282592773, -2.03645510340132, 218, 39, 'PPL', 'P'),
(121407, 'Scraper-Moecherville', 41.7463912963867, 0.728611978947852, -88.2808303833008, -1.54079115658325, 218, 18, 'PPL', 'P'),
(71374, 'Scrapetown', 39.9477806091309, 0.697220300493679, -74.692497253418, -1.30363000360897, 218, 37, 'PPL', 'P'),
(97928, 'Scrapping Valley', 31.1536102294922, 0.543733072387625, -93.8583297729492, -1.63813688496059, 218, 51, 'PPL', 'P'),
(146277, 'Scrappy Corner', 40.7619400024414, 0.711430062542988, -74.8486099243164, -1.30635468372023, 218, 37, 'PPL', 'P'),
(5702, 'Scratch Ankle', 31.6625003814697, 0.552614881070607, -87.4375, -1.52607226471254, 218, 2, 'PPL', 'P'),
(5703, 'Scratch Hill', 32.4447212219238, 0.566267210214249, -88.2644424438477, -1.54050513308217, 218, 2, 'PPL', 'P'),
(71359, 'Scratch Ridge', 39.9691696166992, 0.697593609099481, -74.7333297729492, -1.30434266551667, 218, 37, 'PPL', 'P'),
(5705, 'Screamer', 31.7255592346191, 0.553715465680596, -85.1755599975586, -1.48659396418737, 218, 2, 'PPL', 'P'),
(90653, 'Screamer', 35.4438896179199, 0.618612573546138, -87.1597213745117, -1.52122411310611, 218, 50, 'PPL', 'P'),
(106086, 'Screamersville', 37.3294410705566, 0.65152165461041, -77.3313903808594, -1.34968737729107, 218, 53, 'PPL', 'P'),
(11838, 'Screeton', 34.7813911437988, 0.607049793883286, -91.6672210693359, -1.59989482381343, 218, 4, 'PPL', 'P'),
(24720, 'Screven', 31.4861106872559, 0.549536300139989, -82.017219543457, -1.43147052436437, 218, 13, 'PPL', 'P'),
(24722, 'Screven Fork', 31.7730598449707, 0.554544507727938, -81.4913864135742, -1.42229300493184, 218, 13, 'PPL', 'P'),
(152441, 'Scriba', 43.4652786254883, 0.758612222311486, -76.4308319091797, -1.33396966685353, 218, 40, 'PPL', 'P'),
(90654, 'Scribner', 35.5016708374023, 0.619621046071923, -86.9461135864258, -1.51749595389611, 218, 50, 'PPL', 'P'),
(138028, 'Scribner', 47.5344390869141, 0.829632470155337, -95.0122222900391, -1.65827610859793, 218, 28, 'PPL', 'P'),
(142978, 'Scribner', 41.6666717529297, 0.72722061043634, -96.6655578613281, -1.68713225795726, 218, 35, 'PPL', 'P'),
(208684, 'Scribner', 47.5558280944824, 0.830005778761139, -117.500282287598, -2.05076679794135, 218, 56, 'PPL', 'P'),
(152443, 'Scribner Corners', 43.0541687011719, 0.75143700054454, -75.6327819824219, -1.32004106803631, 218, 40, 'PPL', 'P'),
(144430, 'Scribners Corner', 43.3683280944824, 0.756920116333877, -71.7961120605469, -1.25307854558735, 218, 36, 'PPL', 'P'),
(128759, 'Scribners Mill', 44.0858306884766, 0.769442898990675, -70.6066665649414, -1.23231880541602, 218, 26, 'PPL', 'P'),
(185016, 'Scripps Ranch', 32.9022216796875, 0.574252099531606, -117.098892211914, -2.04376121953585, 218, 6, 'PPL', 'P'),
(57463, 'Scrivner', 38.454719543457, 0.671161468964336, -92.3794403076172, -1.61232539451748, 218, 29, 'PPL', 'P'),
(97929, 'Scroggins', 32.9736099243164, 0.5754980594476, -95.184440612793, -1.66128188536225, 218, 51, 'PPL', 'P'),
(157569, 'Scroggsfield', 40.5777816772461, 0.708215893423371, -80.9611129760742, -1.4130379875116, 218, 41, 'PPL', 'P'),
(11840, 'Scrouge Out (historical)', 33.5788917541504, 0.586062220280699, -91.7825012207031, -1.60190684201698, 218, 4, 'PPL', 'P'),
(5706, 'Scrougeout', 34.1808280944824, 0.596567991306898, -85.8691711425781, -1.49869976239649, 218, 2, 'PPL', 'P'),
(74238, 'Scrub Ridge', 38.8669395446777, 0.678356065228212, -83.3930587768555, -1.45548344896528, 218, 41, 'PPL', 'P'),
(57462, 'Scruggs', 38.5622215270996, 0.673037732531324, -92.2822189331055, -1.61062856142894, 218, 29, 'PPL', 'P'),
(106087, 'Scruggs', 37.079719543457, 0.647163191749414, -79.6619415283203, -1.39036316820039, 218, 53, 'PPL', 'P'),
(5707, 'Scruggs Landing', 31.896390914917, 0.556697040968508, -88.1305618286133, -1.53816847554174, 218, 2, 'PPL', 'P'),
(24723, 'Scrutchins', 31.8641700744629, 0.556134681214824, -84.1966705322266, -1.46950912000424, 218, 13, 'PPL', 'P'),
(157570, 'Scudder', 40.5747184753418, 0.708162430464488, -84.7463912963867, -1.47910355730541, 218, 41, 'PPL', 'P'),
(146278, 'Scudders Falls', 40.2591705322266, 0.702655079909231, -74.8372192382813, -1.30615587874485, 218, 37, 'PPL', 'P'),
(38133, 'Scuddy', 37.2036094665527, 0.649325478817476, -83.083610534668, -1.4500825582746, 218, 21, 'PPL', 'P'),
(106093, 'Scuffleburg', 38.9419403076172, 0.679665075483013, -77.9541702270508, -1.36055693612217, 218, 53, 'PPL', 'P'),
(68605, 'Scuffleton', 35.4566688537598, 0.618835613287432, -77.4883270263672, -1.35242643847221, 218, 33, 'PPL', 'P'),
(24724, 'Scuffletown', 33.5277786254883, 0.585170127894549, -82.4752807617188, -1.43946520079873, 218, 13, 'PPL', 'P'),
(38135, 'Scuffletown', 37.872501373291, 0.660999844930002, -85.6486129760742, -1.49485029619883, 218, 21, 'PPL', 'P'),
(106089, 'Scuffletown', 38.2586097717285, 0.667738707752339, -78.2986068725586, -1.36656848965081, 218, 53, 'PPL', 'P'),
(71360, 'Scull Landing', 39.3655586242676, 0.687058609880319, -74.7141723632813, -1.30400830564181, 218, 37, 'PPL', 'P'),
(24725, 'Scull Shoals (historical)', 33.728328704834, 0.588670387094268, -83.2927780151367, -1.45373321949688, 218, 13, 'PPL', 'P'),
(77200, 'Scullin', 34.5186080932617, 0.602463364432979, -96.8622207641602, -1.69056467312821, 218, 42, 'PPL', 'P'),
(79099, 'Scullton', 39.9477806091309, 0.697220300493679, -79.3130569458008, -1.38427398352598, 218, 45, 'PPL', 'P'),
(71361, 'Scullville', 39.3349990844727, 0.686525245293003, -74.6433334350586, -1.30277193310574, 218, 37, 'PPL', 'P'),
(68604, 'Scuppernong', 35.9019393920898, 0.626607050243419, -76.4522171020508, -1.3343429088803, 218, 33, 'PPL', 'P'),
(97931, 'Scurlock', 28.6805591583252, 0.500570188625788, -97.3125, -1.69842352834698, 218, 51, 'PPL', 'P'),
(83535, 'Scurry', 34.2013893127441, 0.596926852263786, -81.8888931274414, -1.42923080588761, 218, 48, 'PPL', 'P'),
(97932, 'Scurry', 32.5186080932617, 0.567556779393092, -96.3805618286133, -1.68215813883127, 218, 51, 'PPL', 'P'),
(152446, 'Scuttlehole', 40.9352798461914, 0.714455413541318, -72.3405609130859, -1.26258097067287, 218, 40, 'PPL', 'P'),
(5708, 'Scyrene', 31.7555599212646, 0.554239076440419, -87.6477813720703, -1.52974236701078, 218, 2, 'PPL', 'P'),
(38136, 'Scythia', 37.8219413757324, 0.660117406502804, -86.9052810668945, -1.5167832919884, 218, 21, 'PPL', 'P'),
(38137, 'Se Ree', 37.6833305358887, 0.657698190968577, -86.3797225952148, -1.50761056624584, 218, 21, 'PPL', 'P'),
(208685, 'Sea Acre', 48.6525001525879, 0.849146316989702, -122.755561828613, -2.14248872904477, 218, 56, 'PPL', 'P'),
(14562, 'Sea Air Mobile Home Park', 38.7155609130859, 0.675714009689772, -75.1125030517578, -1.31096048766746, 218, 10, 'PPL', 'P'),
(185017, 'Sea Aire Mobile Home Park', 33.0597190856934, 0.577000947829759, -117.298057556152, -2.04723731054867, 218, 6, 'PPL', 'P'),
(114038, 'Sea Bluff', 41.2538909912109, 0.720016227055458, -72.9652786254883, -1.27348435164981, 218, 8, 'PPL', 'P'),
(68607, 'Sea Breeze', 34.063060760498, 0.594512563577575, -77.8916702270508, -1.35946610533968, 218, 33, 'PPL', 'P'),
(71362, 'Sea Breeze', 39.3211097717285, 0.686282831054779, -75.320556640625, -1.31459170781379, 218, 37, 'PPL', 'P'),
(97933, 'Sea Breeze', 29.7188892364502, 0.518692467211559, -94.3744430541992, -1.64714476103167, 218, 51, 'PPL', 'P'),
(152444, 'Sea Breeze', 43.2305603027344, 0.754515614764671, -77.5425033569336, -1.35337199381725, 218, 40, 'PPL', 'P'),
(146279, 'Sea Bright', 40.3613891601563, 0.704439131523475, -73.9744415283203, -1.29109756699322, 218, 37, 'PPL', 'P'),
(152445, 'Sea Cliff', 40.8488883972168, 0.712947598311142, -73.6452789306641, -1.2853525958897, 218, 40, 'PPL', 'P'),
(185021, 'Sea Cliff', 34.3444404602051, 0.599423565785735, -119.417221069336, -2.08422369124186, 218, 6, 'PPL', 'P'),
(14563, 'Sea Colony', 38.5286102294922, 0.672451104722207, -75.0552825927734, -1.30996180225868, 218, 10, 'PPL', 'P'),
(14564, 'Sea Colony East', 38.5286102294922, 0.672451104722207, -75.0552825927734, -1.30996180225868, 218, 10, 'PPL', 'P'),
(14565, 'Sea Del Estates', 38.5652809143066, 0.67309112891118, -75.0586090087891, -1.31001985917045, 218, 10, 'PPL', 'P'),
(14566, 'Sea Dunes', 38.4791717529297, 0.671588240529021, -75.0519409179688, -1.30990347903081, 218, 10, 'PPL', 'P'),
(14567, 'Sea Farers Village', 38.6300010681152, 0.674220708687537, -75.1738891601563, -1.312031877374, 218, 10, 'PPL', 'P'),
(146281, 'Sea Girt', 40.1319389343262, 0.700434469613296, -74.0350036621094, -1.29215457562987, 218, 37, 'PPL', 'P'),
(68608, 'Sea Hawk', 36.1536102294922, 0.630999534987341, -75.7461090087891, -1.32201899777791, 218, 33, 'PPL', 'P'),
(24726, 'Sea Island', 31.1833305358887, 0.544251789588945, -81.3499984741211, -1.41982531986578, 218, 13, 'PPL', 'P'),
(97934, 'Sea Isle', 29.1427803039551, 0.50863746948937, -95.043327331543, -1.65881899398614, 218, 51, 'PPL', 'P'),
(71363, 'Sea Isle City', 39.1533317565918, 0.683354552278182, -74.6933288574219, -1.30364451783691, 218, 37, 'PPL', 'P'),
(51260, 'Sea Isle Mobile Home Park', 38.3358306884766, 0.669086467001001, -75.1105575561523, -1.31092653236356, 218, 25, 'PPL', 'P'),
(106090, 'Sea Lock', 38.8675003051758, 0.678365852345218, -78.1372222900391, -1.36375179732389, 218, 53, 'PPL', 'P'),
(83536, 'Sea Pines', 32.1333312988281, 0.560832430798697, -80.7949981689453, -1.41013873719089, 218, 48, 'PPL', 'P'),
(83537, 'Sea Pines Circle', 32.1597213745117, 0.561293024509226, -80.7561111450195, -1.40946003058708, 218, 48, 'PPL', 'P'),
(83538, 'Sea Pines Plantation', 32.1336097717285, 0.560837291067686, -80.7727813720703, -1.40975098093617, 218, 48, 'PPL', 'P'),
(185022, 'Sea Ranch', 38.7152786254883, 0.675709082841755, -123.453330993652, -2.1546670983936, 218, 6, 'PPL', 'P'),
(18013, 'Sea Ranch Lakes', 26.202220916748, 0.45731502633218, -80.0941696166992, -1.39790697146221, 218, 12, 'PPL', 'P'),
(68610, 'Sea Ridge', 36.1877784729004, 0.631595883334437, -75.7541732788086, -1.32215974584152, 218, 33, 'PPL', 'P'),
(79098, 'Sea Right', 39.9550018310547, 0.697346334592267, -79.8050003051758, -1.3928600148804, 218, 45, 'PPL', 'P'),
(14568, 'Sea Spray Village', 38.7394409179688, 0.676130794400369, -75.1991729736328, -1.31247316316663, 218, 10, 'PPL', 'P'),
(68611, 'Sea Trail Plantation', 33.9000015258789, 0.591666643057689, -78.4997177124023, -1.37007853596753, 218, 33, 'PPL', 'P'),
(126051, 'Sea View', 42.1394386291504, 0.73547194902076, -70.7138900756836, -1.23419020871402, 218, 23, 'PPL', 'P'),
(211096, 'Sea View', 19.6069393157959, 0.342205647299363, -155.967498779297, -2.72214637979897, 218, 15, 'PPL', 'P'),
(208687, 'Seabeck', 47.639720916748, 0.831469984728465, -122.827217102051, -2.14373934949267, 218, 56, 'PPL', 'P'),
(5709, 'Seaboard', 31.3211097717285, 0.546656490895232, -88.188606262207, -1.5391815420204, 218, 2, 'PPL', 'P'),
(68612, 'Seaboard', 36.4900016784668, 0.636870673347503, -77.4416732788086, -1.35161217696892, 218, 33, 'PPL', 'P'),
(106091, 'Seaboard', 37.1402816772461, 0.648220200386066, -81.7825012207031, -1.42737391681755, 218, 53, 'PPL', 'P'),
(208688, 'Seabold', 47.7008285522461, 0.832536514166014, -122.556106567383, -2.13900757802588, 218, 56, 'PPL', 'P'),
(51261, 'Seaborne Estates', 39.1152801513672, 0.682690426481343, -76.5236129760742, -1.33558900195435, 218, 25, 'PPL', 'P'),
(14569, 'Seabreak', 38.5536117553711, 0.672887463666816, -75.0583267211914, -1.31001493232243, 218, 10, 'PPL', 'P'),
(14570, 'Seabreeze', 38.6958312988281, 0.675369662960825, -75.0819396972656, -1.31042705650112, 218, 10, 'PPL', 'P'),
(18014, 'Seabreeze', 29.2325000762939, 0.510203374920823, -81.0138931274414, -1.41395917493266, 218, 12, 'PPL', 'P'),
(51262, 'Seabreeze', 38.5661087036133, 0.673105576560094, -76.2641677856445, -1.33106082915289, 218, 25, 'PPL', 'P'),
(83539, 'Seabreeze', 33.5858306884766, 0.58618332753127, -79.0163879394531, -1.37909613257659, 218, 48, 'PPL', 'P'),
(51263, 'Seabright', 38.378059387207, 0.66982349683268, -75.1366729736328, -1.31138233238413, 218, 25, 'PPL', 'P'),
(185023, 'Seabright', 36.9661102294922, 0.645180335159795, -122.00666809082, -2.12941806757272, 218, 6, 'PPL', 'P'),
(24727, 'Seabrook', 31.7433300018311, 0.55402562407905, -81.3288879394531, -1.41945687152896, 218, 13, 'PPL', 'P'),
(42995, 'Seabrook', 30.0316696166992, 0.524151514682545, -90.0133285522461, -1.57102895391612, 218, 22, 'PPL', 'P'),
(51264, 'Seabrook', 38.9677810668945, 0.680116081813618, -76.8452835083008, -1.34120321184835, 218, 25, 'PPL', 'P'),
(71365, 'Seabrook', 39.5016708374023, 0.689434216151697, -75.2194366455078, -1.31282683095939, 218, 37, 'PPL', 'P'),
(83541, 'Seabrook', 32.5261116027832, 0.567687740339697, -80.4075012207031, -1.40337563960263, 218, 48, 'PPL', 'P'),
(97935, 'Seabrook', 29.5638904571533, 0.515987228176257, -95.0252838134766, -1.65850407518724, 218, 51, 'PPL', 'P'),
(126052, 'Seabrook', 41.5827789306641, 0.725756404469015, -70.5, -1.230457122656, 218, 23, 'PPL', 'P'),
(144431, 'Seabrook', 42.894718170166, 0.748654063784434, -70.8716735839844, -1.23694405043922, 218, 36, 'PPL', 'P'),
(51265, 'Seabrook Acres', 38.975830078125, 0.68025656356112, -76.8413925170898, -1.34113530124055, 218, 25, 'PPL', 'P'),
(144432, 'Seabrook Beach', 42.8866691589355, 0.748513582036933, -70.8161087036133, -1.23597426032827, 218, 36, 'PPL', 'P'),
(71366, 'Seabrook Farms', 39.5008316040039, 0.689419568765701, -75.2183303833008, -1.31280752304149, 218, 37, 'PPL', 'P'),
(83542, 'Seabrook Island', 32.5769386291504, 0.568574839298802, -80.1708297729492, -1.39924494359386, 218, 48, 'PPL', 'P'),
(83543, 'Seabrook Landing', 32.2591705322266, 0.563028739749685, -80.7408294677734, -1.40919331500391, 218, 48, 'PPL', 'P'),
(144433, 'Seabrook Station', 42.8875007629395, 0.748528096264873, -70.8605575561523, -1.23675003915381, 218, 36, 'PPL', 'P'),
(195595, 'Seaburg', 45.4761085510254, 0.793707825209741, -116.029998779297, -2.02510550978373, 218, 17, 'PPL', 'P'),
(128760, 'Seabury', 43.1233291625977, 0.752644078308618, -70.6516723632813, -1.23310430477954, 218, 26, 'PPL', 'P'),
(5711, 'Seacliff', 30.5450000762939, 0.533110821353249, -87.9027786254883, -1.53419290866647, 218, 2, 'PPL', 'P'),
(185024, 'Seacliff (historical)', 36.9741706848145, 0.645321016644379, -121.91471862793, -2.12781324669984, 218, 6, 'PPL', 'P'),
(106092, 'Seacock Corner', 36.8574981689453, 0.643284697095877, -76.9255599975586, -1.34260430089784, 218, 53, 'PPL', 'P'),
(18015, 'Seacoll', 28.9391708374023, 0.505083813909796, -82.394172668457, -1.4380495975213, 218, 12, 'PPL', 'P'),
(18016, 'Seacrest', 30.2833309173584, 0.528543832978899, -86.0416717529297, -1.50171046600882, 218, 12, 'PPL', 'P'),
(144435, 'Seacrest Village', 43.0883293151855, 0.752033215733581, -70.7802810668945, -1.23534895010431, 218, 36, 'PPL', 'P'),
(83544, 'Seacroft', 33.6108283996582, 0.586619619896852, -78.9958267211914, -1.37873727161971, 218, 48, 'PPL', 'P'),
(97936, 'Seadrift', 28.4150009155273, 0.495935322933155, -96.7133331298828, -1.68796609369457, 218, 51, 'PPL', 'P'),
(123640, 'Seafield', 40.7563896179199, 0.711333190058336, -86.9866714477539, -1.51820382211385, 218, 19, 'PPL', 'P'),
(14571, 'Seaford', 38.6411094665527, 0.674414586814895, -75.6113891601563, -1.31966769285148, 218, 10, 'PPL', 'P'),
(106094, 'Seaford', 37.1980590820313, 0.649228606332825, -76.4333267211914, -1.33401320953735, 218, 53, 'PPL', 'P'),
(152449, 'Seaford', 40.665828704834, 0.709752603951374, -73.4886093139648, -1.28261819524046, 218, 40, 'PPL', 'P'),
(24728, 'Seaford (historical)', 30.9608306884766, 0.540368434666419, -83.2222213745117, -1.45250177380883, 218, 13, 'PPL', 'P'),
(14572, 'Seaford Heights', 38.6500015258789, 0.674569782527419, -75.6083297729492, -1.31961429647162, 218, 10, 'PPL', 'P'),
(106095, 'Seaford Shores', 37.1925010681152, 0.649131600690119, -76.4219436645508, -1.33381453772003, 218, 53, 'PPL', 'P'),
(68616, 'Seaforth', 35.7400016784668, 0.623780703957545, -79.0316696166992, -1.37936284815977, 218, 33, 'PPL', 'P'),
(138029, 'Seaforth', 44.4772186279297, 0.776273907186728, -95.3261108398438, -1.66375449727633, 218, 28, 'PPL', 'P'),
(68618, 'Seagate', 34.209171295166, 0.59706267347938, -77.8438873291016, -1.35863213644432, 218, 33, 'PPL', 'P'),
(152447, 'Seagate', 40.5758285522461, 0.708181804961418, -74.0097198486328, -1.29171328983724, 218, 40, 'PPL', 'P'),
(152448, 'Seager', 42.0616683959961, 0.734114602392174, -74.5449981689453, -1.30105565894124, 218, 40, 'PPL', 'P'),
(18017, 'Seaglades', 30.3247203826904, 0.529266215424583, -87.3827819824219, -1.52511725514564, 218, 12, 'PPL', 'P'),
(68619, 'Seagles Store (historical)', 35.5400009155273, 0.620290032137751, -81.4008331298828, -1.42071255198294, 218, 33, 'PPL', 'P'),
(97937, 'Seagoville', 32.6394386291504, 0.569665670081299, -96.5380630493164, -1.68490705370845, 218, 51, 'PPL', 'P'),
(157571, 'Seagrave', 40.0066719055176, 0.698248147516396, -83.0341720581055, -1.44921969408142, 218, 41, 'PPL', 'P'),
(24729, 'Seagraves', 34.0958290100098, 0.595084477421669, -83.3574981689453, -1.45486279927324, 218, 13, 'PPL', 'P'),
(192188, 'Seagraves', 32.9441719055176, 0.574984269094296, -102.564437866211, -1.79008713622253, 218, 51, 'PPL', 'P'),
(68620, 'Seagrove', 35.5402793884277, 0.620294892406741, -79.7733306884766, -1.39230727579615, 218, 33, 'PPL', 'P'),
(18018, 'Seagrove Beach', 30.3183307647705, 0.529154695553936, -86.1302795410156, -1.50325696365383, 218, 12, 'PPL', 'P'),
(185030, 'Seahaven', 38.1111106872559, 0.665164363084614, -122.869438171387, -2.1444762461663, 218, 6, 'PPL', 'P'),
(208689, 'Seahaven (historical)', 46.6877784729004, 0.814855454793842, -123.821388244629, -2.16109090925898, 218, 56, 'PPL', 'P'),
(208690, 'Seahurst', 47.4694404602051, 0.828498030109991, -122.360832214355, -2.13559939762085, 218, 56, 'PPL', 'P'),
(79111, 'Seal', 39.9030609130859, 0.696439794557205, -75.5911102294922, -1.31931375874261, 218, 45, 'PPL', 'P'),
(157572, 'Seal', 40.8769416809082, 0.713437220477553, -83.1505584716797, -1.45125102020287, 218, 41, 'PPL', 'P'),
(185027, 'Seal Beach', 33.7413902282715, 0.588898353683578, -118.103889465332, -2.06130173058149, 218, 6, 'PPL', 'P'),
(128761, 'Seal Cove', 44.285831451416, 0.772933570810469, -68.399169921875, -1.19379072076779, 218, 26, 'PPL', 'P'),
(185029, 'Seal Cove', 37.5191688537598, 0.654833029109815, -122.511672973633, -2.13823206551644, 218, 6, 'PPL', 'P'),
(128762, 'Seal Harbor', 44.3030586242676, 0.773234241697539, -68.2408294677734, -1.19102715850462, 218, 26, 'PPL', 'P'),
(201542, 'Seal Rock', 44.4991683959961, 0.776657002909536, -124.082778930664, -2.16565303736434, 218, 43, 'PPL', 'P'),
(208691, 'Seal Rock', 47.7138900756836, 0.832764480755325, -122.884437561035, -2.14473803490145, 218, 56, 'PPL', 'P'),
(128763, 'Sealand', 44.5074996948242, 0.776802411505054, -67.5461120605469, -1.17890205237759, 218, 26, 'PPL', 'P'),
(5710, 'Seale', 32.2972183227539, 0.563692798967496, -85.1688919067383, -1.48647758404773, 218, 2, 'PPL', 'P'),
(42997, 'Seale', 30.5616703033447, 0.53340177170234, -93.4358291625977, -1.63076285821827, 218, 22, 'PPL', 'P'),
(97939, 'Seale', 31.3129806518555, 0.546514610988158, -96.3727264404297, -1.68202138550929, 218, 51, 'PPL', 'P'),
(68621, 'Sealevel', 34.8622207641602, 0.608460536891728, -76.3880615234375, -1.33322318279998, 218, 33, 'PPL', 'P'),
(74240, 'Sealover (historical)', 39.8722190856934, 0.695901503121872, -81.9658279418945, -1.43057357170923, 218, 41, 'PPL', 'P'),
(24730, 'Seals', 30.8727798461914, 0.538831657559389, -81.7041702270508, -1.42600678307196, 218, 13, 'PPL', 'P'),
(90656, 'Seals (historical)', 35.7416687011719, 0.623809798992454, -85.1805572509766, -1.48668118271307, 218, 50, 'PPL', 'P'),
(106096, 'Sealston', 38.2613906860352, 0.667787243863205, -77.3322219848633, -1.34970189151901, 218, 53, 'PPL', 'P'),
(77201, 'Sealy', 34.9563903808594, 0.610104106758471, -96.503059387207, -1.68429612455438, 218, 42, 'PPL', 'P'),
(97940, 'Sealy', 29.7805595397949, 0.519768817055629, -96.1569366455078, -1.6782551430957, 218, 51, 'PPL', 'P'),
(5712, 'Sealy Springs', 31.0366706848145, 0.541692092307215, -85.3088912963867, -1.48892103434788, 218, 2, 'PPL', 'P'),
(189536, 'Seama', 35.0397186279297, 0.611558459029763, -107.524169921875, -1.87665079061057, 218, 38, 'PPL', 'P'),
(74241, 'Seaman', 38.9419403076172, 0.679665075483013, -83.5725021362305, -1.45861532640722, 218, 41, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(97941, 'Seaman', 30.3658294677734, 0.529983704311764, -95.0358276367188, -1.65868809961856, 218, 51, 'PPL', 'P'),
(111323, 'Seaman', 38.9033317565918, 0.678991229148196, -81.460563659668, -1.42175504639165, 218, 58, 'PPL', 'P'),
(166973, 'Seamentown', 40.7097206115723, 0.710518662238936, -78.929443359375, -1.37757866338747, 218, 45, 'PPL', 'P'),
(157573, 'Seamersville', 40.9322204589844, 0.714402017161462, -84.4169387817383, -1.47335352619582, 218, 41, 'PPL', 'P'),
(166974, 'Seanor', 40.2119407653809, 0.701830764972825, -78.8986129760742, -1.37704057168922, 218, 45, 'PPL', 'P'),
(208692, 'Seaport (historical)', 46.5963897705078, 0.813260421037966, -123.953056335449, -2.16338895096361, 218, 56, 'PPL', 'P'),
(190721, 'Searchlight', 35.4652786254883, 0.61898588215194, -114.918891906738, -2.00571303651605, 218, 39, 'PPL', 'P'),
(5713, 'Searcy', 31.9152793884277, 0.557026707021946, -86.6052780151367, -1.5115472509692, 218, 2, 'PPL', 'P'),
(11841, 'Searcy', 35.250560760498, 0.615238348445007, -91.7361068725586, -1.60109710788755, 218, 4, 'PPL', 'P'),
(42998, 'Searcy', 31.7049999237061, 0.553356638013222, -92.2280578613281, -1.60968327240002, 218, 22, 'PPL', 'P'),
(31096, 'Searcy Crossroads', 38.8466682434082, 0.678002264277395, -84.8580627441406, -1.48105259174919, 218, 19, 'PPL', 'P'),
(61701, 'Searcy Town', 34.8175010681152, 0.607680030955253, -88.4936065673828, -1.54450480156531, 218, 30, 'PPL', 'P'),
(5714, 'Searight', 31.4708309173584, 0.549269617846332, -86.3933334350586, -1.50784812021508, 218, 2, 'PPL', 'P'),
(79100, 'Searights', 39.9447212219238, 0.697166904113823, -79.8138885498047, -1.39301514401389, 218, 45, 'PPL', 'P'),
(152450, 'Searingtown', 40.7747192382813, 0.711653102284282, -73.6561126708984, -1.28554168032709, 218, 40, 'PPL', 'P'),
(5715, 'Searles', 33.3241691589355, 0.581616472314975, -87.3216705322266, -1.52405065912906, 218, 2, 'PPL', 'P'),
(138031, 'Searles', 44.2286109924316, 0.771934885401689, -94.434440612793, -1.64819191597229, 218, 28, 'PPL', 'P'),
(185031, 'Searles', 35.4838905334473, 0.619310721225902, -117.634437561035, -2.05310824917175, 218, 6, 'PPL', 'P'),
(185032, 'Searles Valley', 35.7675018310547, 0.624260672165005, -117.403060913086, -2.04906996485281, 218, 6, 'PPL', 'P'),
(201543, 'Searose Beach', 44.2324981689453, 0.772002729430459, -124.107223510742, -2.16607967577097, 218, 43, 'PPL', 'P'),
(18019, 'Sears', 26.646390914917, 0.465067255238806, -81.3758316040039, -1.42027619303833, 218, 12, 'PPL', 'P'),
(133035, 'Sears', 43.8983306884766, 0.766170406643185, -85.1847229003906, -1.48675388701083, 218, 27, 'PPL', 'P'),
(187886, 'Sears', 37.7625007629395, 0.659079972100164, -100.105560302734, -1.74717162683645, 218, 20, 'PPL', 'P'),
(199671, 'Sears', 41.8933296203613, 0.731176536498571, -104.004997253418, -1.8152296405998, 218, 35, 'PPL', 'P'),
(197497, 'Sears (historical)', 47.5424995422363, 0.829773151639921, -104.291938781738, -1.8202377150297, 218, 31, 'PPL', 'P'),
(152451, 'Sears Corners', 41.4286117553711, 0.723065679661653, -73.5777816772461, -1.2841745465815, 218, 40, 'PPL', 'P'),
(185033, 'Sears Point', 38.1511116027832, 0.665862510764378, -122.446670532227, -2.13709755889207, 218, 6, 'PPL', 'P'),
(117716, 'Searsboro', 41.5805587768555, 0.725717655475154, -92.7033309936523, -1.61797835340534, 218, 16, 'PPL', 'P'),
(152452, 'Searsburg', 42.5308303833008, 0.742303023795841, -76.7361068725586, -1.3392977200884, 218, 40, 'PPL', 'P'),
(172503, 'Searsburg', 42.8902816772461, 0.74857663237574, -72.9527816772461, -1.27326623875654, 218, 55, 'PPL', 'P'),
(128764, 'Searsmont', 44.3616714477539, 0.774257228451265, -69.195556640625, -1.20769029112913, 218, 26, 'PPL', 'P'),
(128766, 'Searsport', 44.4583282470703, 0.775944207843776, -68.9247207641602, -1.2029633133523, 218, 26, 'PPL', 'P'),
(126053, 'Searsville', 42.4008293151855, 0.74003407712612, -72.7458267211914, -1.26965419337006, 218, 23, 'PPL', 'P'),
(152453, 'Searsville', 41.5636100769043, 0.725421844857074, -74.307502746582, -1.29691058186259, 218, 40, 'PPL', 'P'),
(185034, 'Searsville (historical)', 37.4025001525879, 0.65279677614034, -122.244171142578, -2.13356327780943, 218, 6, 'PPL', 'P'),
(18020, 'Seascape', 30.3758296966553, 0.530158241231705, -86.3716735839844, -1.50747008449834, 218, 12, 'PPL', 'P'),
(5716, 'Seasha', 32.3963890075684, 0.565423653938966, -85.7416687011719, -1.49647442498962, 218, 2, 'PPL', 'P'),
(51270, 'Seashore Beach', 38.3347206115723, 0.66906709250407, -76.4105606079102, -1.33361586590271, 218, 25, 'PPL', 'P'),
(18021, 'Seaside', 30.3208293914795, 0.529198304816786, -86.1416702270508, -1.50345576862921, 218, 12, 'PPL', 'P'),
(68623, 'Seaside', 33.8894386291504, 0.591482285731228, -78.4855575561523, -1.36983139461837, 218, 33, 'PPL', 'P'),
(83545, 'Seaside', 32.7113914489746, 0.570921483693326, -79.9416732788086, -1.39524540826878, 218, 48, 'PPL', 'P'),
(114040, 'Seaside', 41.3038902282715, 0.72088887836565, -72.133056640625, -1.25895933790647, 218, 8, 'PPL', 'P'),
(152454, 'Seaside', 40.5830612182617, 0.708308038797088, -73.82861328125, -1.28855238393943, 218, 40, 'PPL', 'P'),
(185035, 'Seaside', 36.6111106872559, 0.638984424304699, -121.850563049316, -2.12669352061951, 218, 6, 'PPL', 'P'),
(201544, 'Seaside', 45.9933280944824, 0.802735009198728, -123.92138671875, -2.16283621187936, 218, 43, 'PPL', 'P'),
(83550, 'Seaside Farms Estates', 32.8111114501953, 0.57266192604472, -79.8252792358398, -1.39321394898927, 218, 48, 'PPL', 'P'),
(71367, 'Seaside Heights', 39.9441719055176, 0.697157316733899, -74.0733337402344, -1.2928235616957, 218, 37, 'PPL', 'P'),
(71368, 'Seaside Heights Harbor', 39.9647216796875, 0.697515977953705, -74.1283264160156, -1.29378336495256, 218, 37, 'PPL', 'P'),
(71370, 'Seaside Park', 39.9266700744629, 0.696851852156867, -74.0774993896484, -1.29289626599346, 218, 37, 'PPL', 'P'),
(14574, 'Seaside Villas', 38.480281829834, 0.671607615025951, -75.0516662597656, -1.30989868534085, 218, 10, 'PPL', 'P'),
(51266, 'Seat Pleasant', 38.896110534668, 0.678865195049608, -76.9069366455078, -1.34227926208679, 218, 25, 'PPL', 'P'),
(208686, 'SeaTac', 47.4538917541504, 0.828226653994912, -122.320556640625, -2.13489645625112, 218, 56, 'PPL', 'P'),
(106098, 'Seatack', 36.8413887023926, 0.643003533863792, -75.9966735839844, -1.32639217460393, 218, 53, 'PPL', 'P'),
(11845, 'Seaton', 34.601390838623, 0.603908195903374, -91.8111114501953, -1.60240618472137, 218, 4, 'PPL', 'P'),
(57464, 'Seaton', 37.8077812194824, 0.659870265153645, -91.6022186279297, -1.59876031718906, 218, 29, 'PPL', 'P'),
(83546, 'Seaton', 33.1175003051758, 0.578009420355544, -80.0097198486328, -1.3964330449569, 218, 48, 'PPL', 'P'),
(90655, 'Seaton', 35.7319412231445, 0.623640022472962, -83.8708267211914, -1.46382207265443, 218, 50, 'PPL', 'P'),
(97942, 'Seaton', 31.0575008392334, 0.542055647085525, -97.2158279418945, -1.69673628263836, 218, 51, 'PPL', 'P'),
(121408, 'Seaton', 41.1022186279297, 0.717369044931919, -90.8013916015625, -1.58478324883999, 218, 18, 'PPL', 'P'),
(90657, 'Seaton Spring', 35.8113899230957, 0.625026663873539, -83.4958267211914, -1.45727708795945, 218, 50, 'PPL', 'P'),
(90658, 'Seaton Subdivision', 36.3261108398438, 0.634010238599676, -82.3816680908203, -1.43783135146997, 218, 50, 'PPL', 'P'),
(208693, 'Seatons Grove', 48.0238914489746, 0.838175025404957, -118.949996948242, -2.07606909198403, 218, 56, 'PPL', 'P'),
(38140, 'Seatonville', 38.1308288574219, 0.665508510076479, -85.5177764892578, -1.49256676872215, 218, 21, 'PPL', 'P'),
(121409, 'Seatonville', 41.3647193908691, 0.72195054753421, -89.2763900756836, -1.55816695111547, 218, 18, 'PPL', 'P'),
(14575, 'Seatowne', 38.4813919067383, 0.671626989522882, -75.0533294677734, -1.30992771379673, 218, 10, 'PPL', 'P'),
(208694, 'Seattle', 47.6063919067383, 0.830888283767364, -122.330833435059, -2.13507582015054, 218, 56, 'PPL', 'P'),
(208696, 'Seattle Heights', 47.8105583190918, 0.834451659884918, -122.322776794434, -2.13493520524498, 218, 56, 'PPL', 'P'),
(128768, 'Seavey Island', 43.0808296203613, 0.751902321366004, -70.7350006103516, -1.23455865705083, 218, 26, 'PPL', 'P'),
(128776, 'Seaveys Corner', 44.5247192382813, 0.77710294923407, -70.0341720581055, -1.22232689132215, 218, 26, 'PPL', 'P'),
(51267, 'Seaview', 38.5661087036133, 0.673105576560094, -76.2583312988281, -1.33095896324119, 218, 25, 'PPL', 'P'),
(106097, 'Seaview', 37.2616691589355, 0.650338811612252, -75.9461135864258, -1.32550973617673, 218, 53, 'PPL', 'P'),
(152455, 'Seaview', 40.6469383239746, 0.709422904608423, -73.1494369506836, -1.27669852076943, 218, 40, 'PPL', 'P'),
(185036, 'Seaview', 38.5455589294434, 0.672746915340287, -123.226936340332, -2.15071576628425, 218, 6, 'PPL', 'P'),
(208695, 'Seaview', 46.3347206115723, 0.808693432663617, -124.053329467773, -2.16513904727395, 218, 56, 'PPL', 'P'),
(114041, 'Seaview Beach', 41.2730598449707, 0.720350786667399, -72.5844421386719, -1.26683750104314, 218, 8, 'PPL', 'P'),
(71372, 'Seaview Park', 39.4422187805176, 0.688396582011974, -74.477783203125, -1.29988253648106, 218, 37, 'PPL', 'P'),
(38138, 'Seaville', 37.8833312988281, 0.661188862788371, -85.0388870239258, -1.48420857079899, 218, 21, 'PPL', 'P'),
(71373, 'Seaville', 39.2083282470703, 0.684314422114074, -74.7044372558594, -1.30383839596426, 218, 37, 'PPL', 'P'),
(128769, 'Seawall', 44.2527809143066, 0.772356730118357, -68.2955627441406, -1.19198243438763, 218, 26, 'PPL', 'P'),
(128770, 'Seaward Mills', 44.4025001525879, 0.774969823779943, -69.6369400024414, -1.21539388405635, 218, 26, 'PPL', 'P'),
(169595, 'Seaweed Beach', 41.3708305358887, 0.722057207135867, -71.4902801513672, -1.24774077181451, 218, 47, 'PPL', 'P'),
(51268, 'Seawilde', 38.5333290100098, 0.672533462978917, -76.1975021362305, -1.32989729407263, 218, 25, 'PPL', 'P'),
(97943, 'Seawillow', 29.8230590820313, 0.520510573998243, -97.6052780151367, -1.70353346868857, 218, 51, 'PPL', 'P'),
(74243, 'Seawright (historical)', 39.898609161377, 0.696362096832401, -81.8522186279297, -1.42859071511961, 218, 41, 'PPL', 'P'),
(11848, 'Seba', 36.3727798461914, 0.634824766419077, -94.2936096191406, -1.6457339514442, 218, 4, 'PPL', 'P'),
(179111, 'Seba Dalkai', 35.499439239502, 0.619582097340981, -110.447776794434, -1.92767735657065, 218, 5, 'PPL', 'P'),
(128771, 'Sebago Center', 43.8919410705566, 0.766058886772538, -70.6988906860352, -1.23392841997887, 218, 26, 'PPL', 'P'),
(128772, 'Sebago Lake', 43.7608299255371, 0.763770565605888, -70.5261077880859, -1.23091278951851, 218, 26, 'PPL', 'P'),
(128774, 'Sebasco', 43.7816696166992, 0.764134286831765, -69.8683319091797, -1.2194324346914, 218, 26, 'PPL', 'P'),
(128775, 'Sebasco Estates', 43.7666702270508, 0.76387249809661, -69.8600006103516, -1.21928702609588, 218, 26, 'PPL', 'P'),
(18022, 'Sebastian', 27.8161106109619, 0.485482715260217, -80.470832824707, -1.40448098461307, 218, 12, 'PPL', 'P'),
(38139, 'Sebastian', 37.3608283996582, 0.65206946684664, -83.6202774047852, -1.45944916214452, 218, 21, 'PPL', 'P'),
(97944, 'Sebastian', 26.3425006866455, 0.459763370190831, -97.7900009155273, -1.70675749150422, 218, 51, 'PPL', 'P'),
(157574, 'Sebastian', 40.4441719055176, 0.705883962993871, -84.5166702270508, -1.4750941682843, 218, 41, 'PPL', 'P'),
(38142, 'Sebastians Branch', 37.4358291625977, 0.653378477101441, -83.4733276367188, -1.45688440485672, 218, 21, 'PPL', 'P'),
(28559, 'Sebastopol', 38.711109161377, 0.675636311964969, -89.6005630493164, -1.56382483685134, 218, 18, 'PPL', 'P'),
(42999, 'Sebastopol', 29.8675003051758, 0.521286219665729, -89.8727798461914, -1.56857591623604, 218, 22, 'PPL', 'P'),
(61702, 'Sebastopol', 32.5727806091309, 0.568502268159098, -89.3349990844727, -1.55918987129017, 218, 30, 'PPL', 'P'),
(97945, 'Sebastopol', 30.9094390869141, 0.53947148201128, -95.2494430541992, -1.66241639198662, 218, 51, 'PPL', 'P'),
(166976, 'Sebastopol', 41.3069381713867, 0.720942075008424, -75.8000030517578, -1.32295962627492, 218, 45, 'PPL', 'P'),
(185038, 'Sebastopol', 38.4022216796875, 0.670245208391294, -122.822776794434, -2.14366185150495, 218, 6, 'PPL', 'P'),
(128777, 'Sebec', 45.2713890075684, 0.790134795133236, -69.1172180175781, -1.20632302422549, 218, 26, 'PPL', 'P'),
(128778, 'Sebec Corners', 45.2297210693359, 0.789407552418563, -69.1022186279297, -1.20606123549033, 218, 26, 'PPL', 'P'),
(128779, 'Sebec Lake', 45.2997207641602, 0.790629277568636, -69.3388900756836, -1.2101919314991, 218, 26, 'PPL', 'P'),
(138033, 'Sebeka', 46.6300010681152, 0.813847048847083, -95.0886077880859, -1.65960928703962, 218, 28, 'PPL', 'P'),
(133036, 'Sebewa Corners', 42.7994384765625, 0.746991119420762, -84.9558334350586, -1.48275901221766, 218, 27, 'PPL', 'P'),
(133037, 'Sebewaing', 43.7322196960449, 0.763271222901498, -83.4511108398438, -1.456496648602, 218, 27, 'PPL', 'P'),
(133039, 'Sebille Manor', 42.6611099243164, 0.74457683073455, -82.8122177124023, -1.44534585995979, 218, 27, 'PPL', 'P'),
(128781, 'Seboeis', 45.3630599975586, 0.791734755737128, -68.711669921875, -1.19924487468027, 218, 26, 'PPL', 'P'),
(128782, 'Seboomook', 45.8805618286133, 0.800766866574132, -69.7255630493164, -1.21694064801747, 218, 26, 'PPL', 'P'),
(24732, 'Seborn', 33.8886108398438, 0.591467838082314, -84.398063659668, -1.47302409316898, 218, 13, 'PPL', 'P'),
(90659, 'Sebowisha', 36.1380615234375, 0.630728158872262, -85.8688888549805, -1.49869483554847, 218, 50, 'PPL', 'P'),
(192950, 'Seboyeta', 35.2011108398438, 0.61437528451474, -107.388610839844, -1.87428483829815, 218, 38, 'PPL', 'P'),
(38141, 'Sebree', 37.6069412231445, 0.656364945947856, -87.5286102294922, -1.52766243819943, 218, 21, 'PPL', 'P'),
(57465, 'Sebree', 39.1269416809082, 0.682893958567653, -92.5308303833008, -1.61496764979301, 218, 29, 'PPL', 'P'),
(195596, 'Sebree', 43.1858291625977, 0.753734909091115, -115.78971862793, -2.02091183001518, 218, 17, 'PPL', 'P'),
(106099, 'Sebrell', 36.7836112976074, 0.641995127917033, -77.1277770996094, -1.34613365513247, 218, 53, 'PPL', 'P'),
(18023, 'Sebring', 27.4952793121338, 0.479883152752216, -81.4411087036133, -1.42141549335266, 218, 12, 'PPL', 'P'),
(51269, 'Sebring', 39.2011108398438, 0.684188454594513, -76.8666687011719, -1.34157645387512, 218, 25, 'PPL', 'P'),
(157575, 'Sebring', 40.922779083252, 0.714237234069013, -81.019172668457, -1.41405132030638, 218, 41, 'PPL', 'P'),
(166975, 'Sebring', 41.5950012207031, 0.72596972367233, -77.1102828979492, -1.34582832371349, 218, 45, 'PPL', 'P'),
(18024, 'Sebring Shores', 27.5316696166992, 0.480518283382687, -81.4749984741211, -1.42200698143077, 218, 12, 'PPL', 'P'),
(79101, 'Secane', 39.913890838623, 0.696628812415573, -75.3024978637695, -1.31427652269877, 218, 45, 'PPL', 'P'),
(146283, 'Secaucus', 40.7894401550293, 0.711910030750448, -74.0569381713867, -1.29253740503657, 218, 37, 'PPL', 'P'),
(68624, 'Secession', 33.9327812194824, 0.592238756638865, -78.295280456543, -1.36651043273904, 218, 33, 'PPL', 'P'),
(83548, 'Secessionville', 32.7055587768555, 0.570819684360657, -79.9394378662109, -1.39520639295881, 218, 48, 'PPL', 'P'),
(83549, 'Secessionville Acres', 32.7005615234375, 0.570732465834957, -79.9522171020508, -1.39542943270011, 218, 48, 'PPL', 'P'),
(176313, 'Sechlerville', 44.3727798461914, 0.774451106578623, -91.0308303833008, -1.58878771101309, 218, 57, 'PPL', 'P'),
(79102, 'Sechrist Mill', 39.8627815246582, 0.695736786608451, -76.5908279418945, -1.33676212441453, 218, 45, 'PPL', 'P'),
(57466, 'Seckman', 38.4022216796875, 0.670245208391294, -90.4333267211914, -1.57835930481656, 218, 29, 'PPL', 'P'),
(97946, 'Seclusion', 29.3005599975586, 0.511391244635539, -96.695556640625, -1.68765583542757, 218, 51, 'PPL', 'P'),
(38143, 'Seco', 37.1719398498535, 0.64877273973323, -82.7322235107422, -1.44394969775831, 218, 21, 'PPL', 'P'),
(192189, 'Seco Mines', 28.7472190856934, 0.501733623837503, -100.496940612793, -1.75400250187445, 218, 51, 'PPL', 'P'),
(111324, 'Secoal', 37.9794387817383, 0.662866254800957, -81.8083267211914, -1.42782465683205, 218, 58, 'PPL', 'P'),
(126054, 'Second Cliff', 42.1916694641113, 0.736383549061894, -70.7183303833008, -1.23426770670174, 218, 23, 'PPL', 'P'),
(97947, 'Second Corinth', 30.1430606842041, 0.526095655567816, -96.1172180175781, -1.67756192226396, 218, 51, 'PPL', 'P'),
(97949, 'Second Crossing', 29.5149993896484, 0.515133918073482, -99.6969375610352, -1.74003981459527, 218, 51, 'PPL', 'P'),
(185039, 'Second Garrotte', 37.8250007629395, 0.660170802882661, -120.196388244629, -2.09782272387418, 218, 6, 'PPL', 'P'),
(43000, 'Second Lake (historical)', 30.6605606079102, 0.535127733115306, -91.7930603027344, -1.60209113276442, 218, 22, 'PPL', 'P'),
(179112, 'Second Mesa', 35.7933311462402, 0.624711478758528, -110.504440307617, -1.92866632144146, 218, 5, 'PPL', 'P'),
(152456, 'Second Milo', 42.6147193908691, 0.743767163184139, -77.0388870239258, -1.34458223063944, 218, 40, 'PPL', 'P'),
(97950, 'Second Rancho Chico Additio Colonia', 28.0249996185303, 0.489128516213508, -97.4980010986328, -1.70166113328419, 218, 51, 'PPL', 'P'),
(97951, 'Second Roosevelt Colonia', 27.9710006713867, 0.488186056793243, -97.4010009765625, -1.69996816177923, 218, 51, 'PPL', 'P'),
(111326, 'Secondcreek', 37.6652793884277, 0.65738313901162, -80.4541702270508, -1.40419016742203, 218, 58, 'PPL', 'P'),
(126055, 'Seconsett Island', 41.5661087036133, 0.725465454119924, -70.5122222900391, -1.23067044185932, 218, 23, 'PPL', 'P'),
(121410, 'Secor', 40.7419395446777, 0.711080988703106, -89.1352767944336, -1.55570405973936, 218, 18, 'PPL', 'P'),
(117717, 'Secor (historical)', 42.3111114501953, 0.738468204984181, -93.0716705322266, -1.62440709111874, 218, 16, 'PPL', 'P'),
(152457, 'Secor Gardens', 40.9944381713867, 0.715487921095942, -73.7613906860352, -1.28737912832119, 218, 40, 'PPL', 'P'),
(157577, 'Secor Woods', 41.5741691589355, 0.725606135604507, -83.603889465332, -1.45916313864345, 218, 41, 'PPL', 'P'),
(133041, 'Secord', 44.0152816772461, 0.768211586460676, -84.3477783203125, -1.47214644843175, 218, 27, 'PPL', 'P'),
(18031, 'Secotan', 30.1761093139648, 0.526672462970414, -83.6344375610352, -1.45969630349368, 218, 12, 'PPL', 'P'),
(11849, 'Secrest (historical)', 34.4819412231445, 0.601823406823033, -91.9550018310547, -1.60491754562932, 218, 4, 'PPL', 'P'),
(200197, 'Secret (historical)', 40.827220916748, 0.712569429436351, -115.20832824707, -2.01076465362976, 218, 39, 'PPL', 'P'),
(185040, 'Secret Canyon (historical)', 39.1875, 0.683950900625278, -120.584716796875, -2.10460033569038, 218, 6, 'PPL', 'P'),
(185041, 'Secret Town', 39.1572189331055, 0.683422396306952, -120.876670837402, -2.10969589496208, 218, 6, 'PPL', 'P'),
(51271, 'Secretary', 38.6091690063477, 0.673857120619714, -75.9477767944336, -1.32553876463261, 218, 25, 'PPL', 'P'),
(5719, 'Section', 34.5788917541504, 0.603515512800642, -85.9866714477539, -1.50075052959391, 218, 2, 'PPL', 'P'),
(138035, 'Section Thirty', 47.9102783203125, 0.836192102236312, -91.7802810668945, -1.60186809302312, 218, 28, 'PPL', 'P'),
(111327, 'Sector', 39.2280616760254, 0.684658835422048, -78.8561096191406, -1.37629874816758, 218, 58, 'PPL', 'P'),
(179113, 'Secundino', 31.6938896179199, 0.55316272659635, -111.442222595215, -1.94503371002692, 218, 5, 'PPL', 'P'),
(43001, 'Security', 31.5341701507568, 0.550375096014823, -91.8163909912109, -1.60249833009509, 218, 22, 'PPL', 'P'),
(51272, 'Security', 39.6511116027832, 0.692042449544293, -77.6911087036133, -1.35596564640288, 218, 25, 'PPL', 'P'),
(97952, 'Security', 30.3277797698975, 0.529319611804439, -95.2391662597656, -1.6622370280872, 218, 51, 'PPL', 'P'),
(187331, 'Security', 38.7583312988281, 0.676460493743321, -104.742500305176, -1.82810149709648, 218, 7, 'PPL', 'P'),
(179114, 'Security Acres', 34.5508308410645, 0.603025757476176, -111.863891601563, -1.9523932225413, 218, 5, 'PPL', 'P'),
(38144, 'Sedalia', 36.6411094665527, 0.639508001775008, -88.6052780151367, -1.54645383600908, 218, 21, 'PPL', 'P'),
(57471, 'Sedalia', 38.7044410705566, 0.675519931825332, -93.2280578613281, -1.62713656491996, 218, 29, 'PPL', 'P'),
(68638, 'Sedalia', 36.0672187805176, 0.629491719757166, -79.6208267211914, -1.38964557944467, 218, 33, 'PPL', 'P'),
(83551, 'Sedalia', 34.603889465332, 0.603951805166224, -81.7247161865234, -1.42636537771274, 218, 48, 'PPL', 'P'),
(97953, 'Sedalia', 33.3960494995117, 0.582871020925484, -96.4777374267578, -1.68385417297149, 218, 51, 'PPL', 'P'),
(106100, 'Sedalia', 37.4874992370605, 0.654280290025569, -79.440559387207, -1.38649932093285, 218, 53, 'PPL', 'P'),
(111328, 'Sedalia', 39.3597183227539, 0.686956677389596, -80.5788879394531, -1.40636690213901, 218, 58, 'PPL', 'P'),
(123637, 'Sedalia', 40.4155616760254, 0.705384620289481, -86.5147171020508, -1.50996666486223, 218, 19, 'PPL', 'P'),
(187332, 'Sedalia', 39.436939239502, 0.688304436638258, -104.959167480469, -1.83188305268634, 218, 7, 'PPL', 'P'),
(344, 'Sedalia (historical)', 36.2786102294922, 0.633181196552334, -93.9019393920898, -1.63889801640013, 218, 4, 'PPL', 'P'),
(74245, 'Sedamsville', 39.0933303833008, 0.682307330758535, -84.5730590820313, -1.47607833946514, 218, 41, 'PPL', 'P'),
(33915, 'Sedan', 37.1266708374023, 0.647982646416831, -96.1866683959961, -1.6787740600341, 218, 20, 'PPL', 'P'),
(74246, 'Sedan', 38.9474983215332, 0.67976208112572, -83.1183319091797, -1.45068856058065, 218, 41, 'PPL', 'P'),
(77203, 'Sedan', 34.9716682434082, 0.610370755762615, -98.7605590820313, -1.72369692709183, 218, 42, 'PPL', 'P'),
(111329, 'Sedan', 39.2350006103516, 0.68477994267262, -78.5736083984375, -1.3713681717254, 218, 58, 'PPL', 'P'),
(117718, 'Sedan', 40.6569404602051, 0.709597474817877, -92.8333282470703, -1.62024723349603, 218, 16, 'PPL', 'P'),
(123638, 'Sedan', 41.4363899230957, 0.72320143429822, -85.0994415283203, -1.48526544627758, 218, 19, 'PPL', 'P'),
(138036, 'Sedan', 45.5755615234375, 0.795443607029227, -95.2477798461914, -1.66238736353074, 218, 28, 'PPL', 'P'),
(142980, 'Sedan', 40.3424987792969, 0.704109432180524, -97.8969421386719, -1.7086239679542, 218, 35, 'PPL', 'P'),
(189539, 'Sedan', 36.1444396972656, 0.630839479005828, -103.129997253418, -1.79995800964485, 218, 38, 'PPL', 'P'),
(197498, 'Sedan', 45.9588890075684, 0.802133933740697, -110.850280761719, -1.93470237605212, 218, 31, 'PPL', 'P'),
(57468, 'Sedan (historical)', 36.857780456543, 0.643289623943894, -92.3091735839844, -1.6110990088355, 218, 29, 'PPL', 'P'),
(185042, 'Sedco Hills', 33.6416702270508, 0.587157911332184, -117.290000915527, -2.04709669564312, 218, 6, 'PPL', 'P'),
(5723, 'Seddon', 33.5922203063965, 0.586294847401917, -86.2275009155273, -1.50495379674238, 218, 2, 'PPL', 'P'),
(68625, 'Sedge Garden', 36.0886116027832, 0.629865094941995, -80.1391677856445, -1.39869233766767, 218, 33, 'PPL', 'P'),
(68626, 'Sedge-Town', 36.0305595397949, 0.628851895305274, -79.8683319091797, -1.39396535989083, 218, 33, 'PPL', 'P'),
(5721, 'Sedgefield', 32.2394409179688, 0.562684393020738, -87.3613891601563, -1.52474387996081, 218, 2, 'PPL', 'P'),
(24734, 'Sedgefield', 33.5116691589355, 0.584888964662464, -82.1333312988281, -1.43349705679586, 218, 13, 'PPL', 'P'),
(68628, 'Sedgefield', 35.5791702270508, 0.620973665589575, -77.3949966430664, -1.35079751599147, 218, 33, 'PPL', 'P'),
(106102, 'Sedgefield', 37.0438919067383, 0.646537881525463, -76.459716796875, -1.33447380324788, 218, 53, 'PPL', 'P'),
(68633, 'Sedgefield Apartments', 35.2758293151855, 0.615679367921524, -81.554443359375, -1.42339355625232, 218, 33, 'PPL', 'P'),
(68636, 'Sedges Garden (historical)', 36.1894416809082, 0.631624911790319, -80.2194366455078, -1.40009329355911, 218, 33, 'PPL', 'P'),
(187333, 'Sedgewick (historical)', 38.2791709899902, 0.668097568709227, -106.147216796875, -1.8526184249337, 218, 7, 'PPL', 'P'),
(57469, 'Sedgewickville', 37.5161094665527, 0.654779632729959, -89.9069366455078, -1.56917206484606, 218, 29, 'PPL', 'P'),
(14576, 'Sedgley Farms', 39.7649993896484, 0.694030166402901, -75.623893737793, -1.31988593890281, 218, 10, 'PPL', 'P'),
(11850, 'Sedgwick', 35.9777793884277, 0.627930707884216, -90.8638916015625, -1.58587407962249, 218, 4, 'PPL', 'P'),
(33917, 'Sedgwick', 37.9166717529297, 0.661770763486553, -97.4222183227539, -1.7003384743288, 218, 20, 'PPL', 'P'),
(79103, 'Sedgwick', 39.7938919067383, 0.694534435955307, -77.2316665649414, -1.34794686836065, 218, 45, 'PPL', 'P'),
(128785, 'Sedgwick', 44.3036117553711, 0.77324389565649, -68.6166687011719, -1.19758679058559, 218, 26, 'PPL', 'P'),
(139447, 'Sedgwick', 40.0083312988281, 0.69827710939325, -92.9052810668945, -1.62150304710806, 218, 29, 'PPL', 'P'),
(176316, 'Sedgwick', 46.4669418334961, 0.811001128327198, -90.6052780151367, -1.58136042104897, 218, 57, 'PPL', 'P'),
(194414, 'Sedgwick', 40.9363899230957, 0.714474788038248, -102.525001525879, -1.7893988422388, 218, 7, 'PPL', 'P'),
(138038, 'Sedil', 44.7533302307129, 0.781092963758253, -92.9730606079102, -1.62268602326427, 218, 28, 'PPL', 'P'),
(189540, 'Sedillo', 35.0997200012207, 0.612605680549409, -106.294998168945, -1.85519769644944, 218, 38, 'PPL', 'P'),
(106104, 'Sedley', 36.7758293151855, 0.641859306701439, -76.9844436645508, -1.3436320147625, 218, 53, 'PPL', 'P'),
(123639, 'Sedley', 41.4886093139648, 0.724112834602272, -87.1575012207031, -1.52118536411225, 218, 19, 'PPL', 'P'),
(179115, 'Sedona', 34.8697204589844, 0.608591431259306, -111.760276794434, -1.95058480300308, 218, 5, 'PPL', 'P'),
(208697, 'Sedro-Woolley', 48.5038909912109, 0.846552597825047, -122.236106872559, -2.13342252974582, 218, 56, 'PPL', 'P'),
(97954, 'Sedwick', 32.6030616760254, 0.569030772477424, -99.2041702270508, -1.73143940217097, 218, 51, 'PPL', 'P'),
(166977, 'Sedwicks Mill', 41.1647186279297, 0.718459875714416, -79.7850036621094, -1.39251100761954, 218, 45, 'PPL', 'P'),
(179116, 'See Canyon Summer Homes', 34.3244400024414, 0.599074491945853, -111.004997253418, -1.93740268823941, 218, 5, 'PPL', 'P'),
(57470, 'Seebarger', 38.8583297729492, 0.678205796363704, -90.543327331543, -1.5802791776464, 218, 29, 'PPL', 'P'),
(90660, 'Seeber Flats', 36.1686096191406, 0.631261323722496, -84.2158279418945, -1.4698434798791, 218, 50, 'PPL', 'P'),
(111331, 'Seebert', 38.1288909912109, 0.665474687930635, -80.1777801513672, -1.39936625058152, 218, 58, 'PPL', 'P'),
(57472, 'Seeburger', 38.8652801513672, 0.678327103351358, -90.5105590820313, -1.5797072638023, 218, 29, 'PPL', 'P'),
(166978, 'Seeger Place', 40.6966705322266, 0.710290895386707, -77.7680587768555, -1.3573086785406, 218, 45, 'PPL', 'P'),
(28560, 'Seehorn', 39.7552795410156, 0.693860523041463, -91.2611083984375, -1.59280682057218, 218, 18, 'PPL', 'P'),
(126056, 'Seekonk', 41.8083305358887, 0.729693022613343, -71.3375015258789, -1.24507428177307, 218, 23, 'PPL', 'P'),
(71375, 'Seeley', 39.4819412231445, 0.689089869422749, -75.258056640625, -1.31350087703129, 218, 37, 'PPL', 'P'),
(176315, 'Seeley', 46.1211090087891, 0.804965206874588, -91.3611068725586, -1.59455212319257, 218, 57, 'PPL', 'P'),
(185043, 'Seeley', 32.7930603027344, 0.572346874087763, -115.690277099609, -2.01917624793278, 218, 6, 'PPL', 'P'),
(152458, 'Seeley Creek', 42.0144386291504, 0.733290287455767, -76.8927764892578, -1.34203212073764, 218, 40, 'PPL', 'P'),
(197499, 'Seeley Lake', 47.1794395446777, 0.823436559300241, -113.483612060547, -1.98066267751249, 218, 31, 'PPL', 'P'),
(74247, 'Seeleyburg (historical)', 39.7208290100098, 0.69325924784635, -81.6688919067383, -1.42539106022793, 218, 41, 'PPL', 'P'),
(97955, 'Seeligson', 27.4088897705078, 0.478375370811554, -98.1155624389648, -1.71243961200601, 218, 51, 'PPL', 'P'),
(209726, 'Seely', 44.8077812194824, 0.782043312793248, -104.620002746582, -1.82596351137337, 218, 59, 'PPL', 'P'),
(31097, 'Seelyville', 39.4919395446777, 0.689264373053177, -87.267219543457, -1.52310031009407, 218, 19, 'PPL', 'P'),
(166981, 'Seelyville', 41.5774993896484, 0.725664259095298, -75.2813873291016, -1.31390807436196, 218, 45, 'PPL', 'P'),
(111330, 'Seemly (historical)', 38.8741683959961, 0.678482232484855, -79.1427764892578, -1.38130202890751, 218, 58, 'PPL', 'P'),
(166979, 'Seemsville', 40.7222213745117, 0.71073684171124, -75.458610534668, -1.31700120281003, 218, 45, 'PPL', 'P'),
(14577, 'Seeneytown', 39.1997184753418, 0.684164153249566, -75.6661071777344, -1.32062270241838, 218, 10, 'PPL', 'P'),
(68640, 'Seeshore', 35.1527786254883, 0.613531728239457, -82.70361328125, -1.44345035505392, 218, 33, 'PPL', 'P'),
(133043, 'Seewhy', 46.3527793884277, 0.809008617778628, -85.0947189331055, -1.48518302144185, 218, 27, 'PPL', 'P'),
(18025, 'Seffner', 27.9833297729492, 0.488401240209321, -82.2758331298828, -1.43598418293789, 218, 12, 'PPL', 'P'),
(28561, 'Sefton', 39.0708312988281, 0.681914647655803, -88.9555587768555, -1.55256738860747, 218, 18, 'PPL', 'P'),
(68639, 'Sega Lake', 35.2188911437988, 0.614685609360761, -82.7630615234375, -1.44448792261462, 218, 33, 'PPL', 'P'),
(38145, 'Segal', 37.2055587768555, 0.649359500700402, -86.3850021362305, -1.50770271161956, 218, 21, 'PPL', 'P'),
(83555, 'Segars', 34.3838882446289, 0.600112059506548, -80.1319427490234, -1.39856623699006, 218, 48, 'PPL', 'P'),
(97959, 'Seger', 30.9211101531982, 0.539675180545158, -96.6230621337891, -1.68639056759368, 218, 51, 'PPL', 'P'),
(166980, 'Seger', 40.3650016784668, 0.704502181862283, -79.2855606079102, -1.38379408189755, 218, 45, 'PPL', 'P'),
(97956, 'Segno', 30.576940536499, 0.533668287548429, -94.6861114501953, -1.65258440071621, 218, 51, 'PPL', 'P'),
(74248, 'Sego', 39.8472213745117, 0.69546521075629, -82.2077789306641, -1.43479641309171, 218, 41, 'PPL', 'P'),
(192775, 'Sego', 39.0330581665039, 0.681255382127954, -109.702499389648, -1.91466981201643, 218, 52, 'PPL', 'P'),
(97957, 'Segovia', 30.4191703796387, 0.530914678849828, -99.6699981689453, -1.73956963350482, 218, 51, 'PPL', 'P'),
(126058, 'Segreganset', 41.836669921875, 0.730187638206798, -71.1138916015625, -1.24117155235361, 218, 23, 'PPL', 'P'),
(97958, 'Seguin', 29.5686092376709, 0.516069586432968, -97.9644393920898, -1.7098020172624, 218, 51, 'PPL', 'P'),
(187887, 'Seguin', 39.3375015258789, 0.68656892113488, -100.594436645508, -1.75570412865295, 218, 20, 'PPL', 'P'),
(187334, 'Segundo', 37.1252784729004, 0.647958345071884, -104.754997253418, -1.82831960998976, 218, 7, 'PPL', 'P'),
(11851, 'Segur', 34.3561096191406, 0.599627231030099, -93.5036087036133, -1.63194583437448, 218, 4, 'PPL', 'P'),
(43003, 'Segura', 30.038330078125, 0.524267761664127, -91.857780456543, -1.60322071254077, 218, 22, 'PPL', 'P'),
(185044, 'Seguro', 35.4186096191406, 0.618171354332539, -119.020278930664, -2.07729574398212, 218, 6, 'PPL', 'P'),
(133044, 'Segwun', 42.9238891601563, 0.74916319360583, -85.3427810668945, -1.48951252242599, 218, 27, 'PPL', 'P'),
(179117, 'Sehili', 36.2797203063965, 0.633200571049265, -109.167221069336, -1.90532744291244, 218, 5, 'PPL', 'P'),
(5722, 'Sehoya', 32.978328704834, 0.57558041770431, -86.4847183227539, -1.50944308739192, 218, 2, 'PPL', 'P'),
(193939, 'Seiad Valley', 41.8405609130859, 0.730255548814595, -123.191390991211, -2.15009538290831, 218, 6, 'PPL', 'P'),
(166982, 'Seiberlingville', 40.6088905334473, 0.708758845390611, -75.7352828979492, -1.32183004649857, 218, 45, 'PPL', 'P'),
(43002, 'Seibert', 30.7183303833008, 0.53613600590401, -91.538330078125, -1.59764525164064, 218, 22, 'PPL', 'P'),
(187335, 'Seibert', 39.2991714477539, 0.685899935069052, -102.868606567383, -1.79539588153949, 218, 7, 'PPL', 'P'),
(166983, 'Seidersville', 40.5877799987793, 0.708390397053799, -75.3850021362305, -1.31571649390018, 218, 45, 'PPL', 'P'),
(133045, 'Seidlers', 43.6827812194824, 0.762408358708312, -84.0877838134766, -1.46760868825036, 218, 27, 'PPL', 'P'),
(152459, 'Seifert Corners', 43.2252807617188, 0.754423469390955, -75.5366668701172, -1.31836354286566, 218, 40, 'PPL', 'P'),
(117719, 'Seigel', 42.8400001525879, 0.747699054217532, -92.355827331543, -1.61191327033879, 218, 16, 'PPL', 'P'),
(185045, 'Seigler Springs', 38.874439239502, 0.67848695959579, -122.6875, -2.14130082604054, 218, 6, 'PPL', 'P'),
(83556, 'Seiglers Crossroads', 33.644718170166, 0.587211107974959, -81.6572189331055, -1.42518732840454, 218, 48, 'PPL', 'P'),
(83557, 'Seigling', 33.0441703796387, 0.576729571714679, -81.3152770996094, -1.41921931755973, 218, 48, 'PPL', 'P'),
(77205, 'Seiling', 36.1480598449707, 0.63090266250269, -98.9238891601563, -1.72654757472265, 218, 42, 'PPL', 'P'),
(166984, 'Seiple', 40.6427803039551, 0.709350333468718, -75.5194396972656, -1.3180628719786, 218, 45, 'PPL', 'P'),
(166985, 'Seipstown', 40.5902786254883, 0.708434006316649, -75.6800003051758, -1.32086518323563, 218, 45, 'PPL', 'P'),
(166986, 'Seisholtzville', 40.4697189331055, 0.706329842739377, -75.6044387817383, -1.31954638586382, 218, 45, 'PPL', 'P'),
(38146, 'Seitz', 37.6958312988281, 0.657916370440881, -83.1697235107422, -1.45158551323579, 218, 21, 'PPL', 'P'),
(157578, 'Seitz', 40.9186096191406, 0.714164463192227, -84.1763916015625, -1.46915518589537, 218, 41, 'PPL', 'P'),
(79104, 'Seitzland', 39.7852783203125, 0.694384100511772, -76.7233276367188, -1.3390746803471, 218, 45, 'PPL', 'P'),
(79105, 'Seitzville', 39.8300018310547, 0.695164673027275, -76.7622222900391, -1.33975352010896, 218, 45, 'PPL', 'P'),
(83558, 'Seivern', 33.7150001525879, 0.588437759973049, -81.4100036621094, -1.42087260796445, 218, 48, 'PPL', 'P'),
(97960, 'Sejita', 27.3033294677734, 0.476532995969437, -98.4394378662109, -1.71809230457776, 218, 51, 'PPL', 'P'),
(74249, 'Sekitan', 39.1425018310547, 0.683165534419814, -84.7227783203125, -1.47869143312672, 218, 41, 'PPL', 'P'),
(208698, 'Sekiu', 48.2625007629395, 0.842339543559569, -124.300003051758, -2.16944431349217, 218, 56, 'PPL', 'P'),
(208699, 'Selah', 46.6541709899902, 0.814268893563752, -120.52889251709, -2.10362601820557, 218, 56, 'PPL', 'P'),
(51273, 'Selassie Villa', 38.8277816772461, 0.677672631513471, -76.5102767944336, -1.33535624167508, 218, 25, 'PPL', 'P'),
(212136, 'Selawik', 66.603889465332, 1.16245716580441, -160.006942749023, -2.79264797702053, 218, 1, 'PPL', 'P'),
(185046, 'Selby', 38.0566711425781, 0.664214213786701, -122.242782592773, -2.13353904304351, 218, 6, 'PPL', 'P'),
(195597, 'Selby', 43.3438911437988, 0.756493611085301, -114.709716796875, -2.00206224213571, 218, 17, 'PPL', 'P'),
(202603, 'Selby', 45.5063896179199, 0.794236329528067, -100.031669616699, -1.74588199107858, 218, 49, 'PPL', 'P'),
(90661, 'Selby (historical)', 36.2291717529297, 0.632318332359149, -85.4766693115234, -1.49184931312448, 218, 50, 'PPL', 'P'),
(51274, 'Selby Beach', 38.9069404602051, 0.679054212907976, -76.5163879394531, -1.33546290127674, 218, 25, 'PPL', 'P'),
(51275, 'Selby Grove', 39.1141700744629, 0.682671051984413, -76.570556640625, -1.33640832346371, 218, 25, 'PPL', 'P'),
(51276, 'Selby-on-the-Bay', 38.9161109924316, 0.67921426888949, -76.5227813720703, -1.33557448772641, 218, 25, 'PPL', 'P'),
(51282, 'Selbys Landing', 38.7511100769043, 0.676334459644733, -76.6994400024414, -1.33865776247845, 218, 25, 'PPL', 'P'),
(51277, 'Selbysport', 39.6863899230957, 0.692658172388319, -79.3805618286133, -1.38545216599223, 218, 25, 'PPL', 'P'),
(14578, 'Selbyville', 38.4602813720703, 0.671258541186069, -75.2211074829102, -1.31285599257333, 218, 10, 'PPL', 'P'),
(111332, 'Selbyville', 38.7538909912109, 0.6763829957556, -80.2366714477539, -1.40039409760423, 218, 58, 'PPL', 'P'),
(97961, 'Selden', 32.1438903808594, 0.56101672154613, -98.1063919067383, -1.7122795560245, 218, 51, 'PPL', 'P'),
(106105, 'Selden', 37.3561096191406, 0.651987108589929, -76.4694366455078, -1.33464344660932, 218, 53, 'PPL', 'P'),
(128787, 'Selden', 45.7724990844727, 0.798880815890138, -67.9075012207031, -1.18520948310334, 218, 26, 'PPL', 'P'),
(152460, 'Selden', 40.8663902282715, 0.713253062888174, -73.0361099243164, -1.27472059102783, 218, 40, 'PPL', 'P'),
(187888, 'Selden', 39.540828704834, 0.690117649866438, -100.567222595215, -1.75522915387254, 218, 20, 'PPL', 'P'),
(166987, 'Seldersville', 40.5038909912109, 0.7069262576655, -78.8633270263672, -1.37642471568714, 218, 45, 'PPL', 'P'),
(212137, 'Seldovia', 59.438060760498, 1.03738986127114, -151.711395263672, -2.64786336014561, 218, 1, 'PPL', 'P'),
(212138, 'Seldovia Village', 59.4780616760254, 1.0380880089509, -151.651947021484, -2.64682579258491, 218, 1, 'PPL', 'P'),
(166989, 'Selea', 40.1558303833008, 0.700851454060975, -77.991943359375, -1.36121620165002, 218, 45, 'PPL', 'P'),
(38148, 'Select', 37.3597183227539, 0.652050092349709, -86.745002746582, -1.51398590757938, 218, 21, 'PPL', 'P'),
(117727, 'Selection', 40.9638900756836, 0.714954756245708, -92.7830581665039, -1.61936985507491, 218, 16, 'PPL', 'P'),
(11852, 'Self', 36.3980598449707, 0.635265985632676, -93.1080627441406, -1.62504225503872, 218, 4, 'PPL', 'P'),
(5725, 'Self Creek', 33.7819404602051, 0.589606088743267, -86.7505569458008, -1.51408284664306, 218, 2, 'PPL', 'P'),
(61704, 'Self Creek', 33.4652786254883, 0.584079297112053, -89.0111083984375, -1.55353691240231, 218, 30, 'PPL', 'P'),
(189541, 'Self Place', 36.9738883972168, 0.645316089796362, -107.508613586426, -1.87637928133744, 218, 38, 'PPL', 'P'),
(198878, 'Selfridge', 46.041389465332, 0.803573838363076, -100.92472076416, -1.76146867399048, 218, 34, 'PPL', 'P'),
(97962, 'Selfs', 33.6922187805176, 0.5880401500223, -95.9141693115234, -1.67401805380139, 218, 51, 'PPL', 'P'),
(5726, 'Selfville', 33.8302803039551, 0.590449778176604, -86.6680603027344, -1.51264300859971, 218, 2, 'PPL', 'P'),
(18026, 'Selhaven', 26.9269409179688, 0.469963776508539, -80.0888900756836, -1.39781482608849, 218, 12, 'PPL', 'P'),
(68641, 'Selica', 35.2000007629395, 0.614355910017809, -82.7783279418945, -1.44475437188168, 218, 33, 'PPL', 'P'),
(74250, 'Selig', 38.7402801513672, 0.676145441786365, -83.3533325195313, -1.45479009497548, 218, 41, 'PPL', 'P'),
(57473, 'Seligman', 36.5224990844727, 0.637437860080663, -93.9394378662109, -1.63955248823802, 218, 29, 'PPL', 'P'),
(179118, 'Seligman', 35.3255615234375, 0.616547358699808, -112.876670837402, -1.97006955480254, 218, 5, 'PPL', 'P'),
(190722, 'Seligman (historical)', 39.2611083984375, 0.685235609535132, -115.555557250977, -2.01682494300635, 218, 39, 'PPL', 'P'),
(166988, 'Selinsgrove', 40.7988891601563, 0.712074947000951, -76.8625030517578, -1.34150374957736, 218, 45, 'PPL', 'P'),
(166990, 'Selinsgrove Junction', 40.8016700744629, 0.712123483111817, -76.8394393920898, -1.3411012127786, 218, 45, 'PPL', 'P'),
(57474, 'Selkirk', 36.7238883972168, 0.640952766666376, -89.454719543457, -1.56127938748144, 218, 29, 'PPL', 'P'),
(133046, 'Selkirk', 44.313060760498, 0.773408811906993, -84.0672225952148, -1.46724982729347, 218, 27, 'PPL', 'P'),
(152462, 'Selkirk', 43.5741691589355, 0.760512720644394, -76.2030563354492, -1.32999423313631, 218, 40, 'PPL', 'P'),
(166991, 'Selkirk', 41.6872215270996, 0.727579271656147, -79.5805587768555, -1.388942771233, 218, 45, 'PPL', 'P'),
(187889, 'Selkirk', 38.473331451416, 0.671486308038298, -101.543060302734, -1.77226073483386, 218, 20, 'PPL', 'P'),
(90662, 'Selkirk (historical)', 35.9027786254883, 0.626621697629415, -84.3541717529297, -1.47225803488142, 218, 50, 'PPL', 'P'),
(111333, 'Sell', 39.2649993896484, 0.685303520142929, -79.5869369506836, -1.38905409136656, 218, 58, 'PPL', 'P'),
(38147, 'Sellars', 37.7916717529297, 0.65958910192156, -83.3380584716797, -1.45452351255036, 218, 21, 'PPL', 'P'),
(83559, 'Sellars Heights', 33.9236106872559, 0.592078700657351, -80.4027786254883, -1.40329321476689, 218, 48, 'PPL', 'P'),
(195598, 'Selle', 48.3569412231445, 0.843987840537246, -116.488609313965, -2.03310977359802, 218, 17, 'PPL', 'P'),
(208700, 'Selleck', 47.3758316040039, 0.826864247360255, -121.867218017578, -2.1269842046525, 218, 56, 'PPL', 'P'),
(114042, 'Selleck Four Corners (historical)', 41.295280456543, 0.720738609501142, -73.3958282470703, -1.28099886013964, 218, 8, 'PPL', 'P'),
(114043, 'Sellecks Corners', 41.1852798461914, 0.718818736671304, -73.5344390869141, -1.28341807567386, 218, 8, 'PPL', 'P'),
(5727, 'Sellers', 32.0561103820801, 0.559484671550035, -86.3030624389648, -1.50627259411418, 218, 2, 'PPL', 'P'),
(43004, 'Sellers', 29.9988899230957, 0.523579401101369, -90.4266662597656, -1.57824305783498, 218, 22, 'PPL', 'P'),
(61703, 'Sellers', 30.5913906097412, 0.53392048890366, -89.3574981689453, -1.5595825543929, 218, 30, 'PPL', 'P'),
(83560, 'Sellers', 34.2836112976074, 0.598361896617175, -79.4730606079102, -1.38706657424504, 218, 48, 'PPL', 'P'),
(121412, 'Sellers', 40.1863899230957, 0.701384818648291, -88.1047210693359, -1.53771746921113, 218, 18, 'PPL', 'P'),
(139446, 'Sellers', 40.0663909912109, 0.699290442188025, -91.6733322143555, -1.60000148341509, 218, 29, 'PPL', 'P'),
(111338, 'Sellers (historical)', 38.8730583190918, 0.678462857987924, -80.1927795410156, -1.39962803931667, 218, 58, 'PPL', 'P'),
(11854, 'Sellers Addition', 34.9647216796875, 0.610249515353989, -91.9449996948242, -1.60474297541986, 218, 4, 'PPL', 'P'),
(5728, 'Sellers Crossroads', 31.9569396972656, 0.557753816578565, -85.7552795410156, -1.49671197895885, 218, 2, 'PPL', 'P'),
(5729, 'Sellers Landing', 31.8633308410645, 0.556120033828829, -88.1408309936523, -1.5383477062831, 218, 2, 'PPL', 'P'),
(11855, 'Sellers Store', 36.3416709899902, 0.634281814451837, -91.4097213745117, -1.59540060631587, 218, 4, 'PPL', 'P'),
(31098, 'Sellersburg', 38.3980598449707, 0.670172570672562, -85.754997253418, -1.49670705211084, 218, 19, 'PPL', 'P'),
(5730, 'Sellersville', 31.1297206878662, 0.543316121229459, -86.0041732788086, -1.50105599417094, 218, 2, 'PPL', 'P'),
(18027, 'Sellersville', 30.9916706085205, 0.540906692812237, -86.9280624389648, -1.51718090193915, 218, 12, 'PPL', 'P'),
(166992, 'Sellersville', 40.353889465332, 0.704308237155898, -75.3052825927734, -1.31432512538867, 218, 45, 'PPL', 'P'),
(51278, 'Sellman', 39.2083282470703, 0.684314422114074, -77.3786087036133, -1.35051149249039, 218, 25, 'PPL', 'P'),
(51279, 'Sellman Estates', 39.035831451416, 0.681303785080766, -76.9352798461914, -1.34277394425928, 218, 25, 'PPL', 'P'),
(11856, 'Sellmeyer (historical)', 36.2902793884277, 0.633384861796698, -90.5869369506836, -1.58104030908594, 218, 4, 'PPL', 'P'),
(24736, 'Sells', 34.0669403076172, 0.59458027444829, -83.7227783203125, -1.46123814060678, 218, 13, 'PPL', 'P'),
(179119, 'Sells', 31.9119396209717, 0.556968417083587, -111.880561828613, -1.95268417289039, 218, 5, 'PPL', 'P'),
(201545, 'Sellwood', 45.4647216796875, 0.793509086813394, -122.651390075684, -2.14067058896858, 218, 43, 'PPL', 'P'),
(5731, 'Selma', 32.4072189331055, 0.565612671797334, -87.021110534668, -1.51880489757188, 218, 2, 'PPL', 'P'),
(11857, 'Selma', 33.6972198486328, 0.588127435127028, -91.567497253418, -1.59815431488301, 218, 4, 'PPL', 'P'),
(33923, 'Selma', 38.1347198486328, 0.665576420684276, -95.1230621337891, -1.66021062881376, 218, 20, 'PPL', 'P'),
(43005, 'Selma', 31.7411098480225, 0.553986875085189, -92.3869400024414, -1.61245628888506, 218, 22, 'PPL', 'P'),
(57475, 'Selma', 38.1497192382813, 0.665838209419431, -90.3413925170898, -1.57675475025979, 218, 29, 'PPL', 'P'),
(61705, 'Selma', 31.601390838623, 0.551548318343544, -91.2788925170898, -1.59311721199723, 218, 30, 'PPL', 'P'),
(68643, 'Selma', 35.5363883972168, 0.620226981798944, -78.2847213745117, -1.36632614199161, 218, 33, 'PPL', 'P'),
(74251, 'Selma', 39.7866706848145, 0.694408401856719, -83.708610534668, -1.46099086609957, 218, 41, 'PPL', 'P'),
(83561, 'Selma', 34.4452781677246, 0.601183515792114, -79.3747177124023, -1.38535016692248, 218, 48, 'PPL', 'P'),
(97964, 'Selma', 33.4874992370605, 0.584467119945796, -97.8883285522461, -1.70847363251067, 218, 51, 'PPL', 'P'),
(106107, 'Selma', 38.1622200012207, 0.666056388891736, -79.0752792358398, -1.38012397959931, 218, 53, 'PPL', 'P'),
(117721, 'Selma', 40.8702812194824, 0.713320973495971, -92.1530609130859, -1.60837432872424, 218, 16, 'PPL', 'P'),
(123641, 'Selma', 40.1916694641113, 0.701476964022008, -85.2688903808594, -1.48822288666812, 218, 19, 'PPL', 'P'),
(133047, 'Selma', 46.3622207641602, 0.809173400871076, -87.1819381713867, -1.52161186936082, 218, 27, 'PPL', 'P'),
(185047, 'Selma', 36.5708312988281, 0.638281416355945, -119.611106872559, -2.08760763688097, 218, 6, 'PPL', 'P'),
(194416, 'Selma', 40.7713890075684, 0.711594978793491, -103.030563354492, -1.7982225607205, 218, 7, 'PPL', 'P'),
(201546, 'Selma', 42.2791709899902, 0.737910738789, -123.614723205566, -2.15748392387857, 218, 43, 'PPL', 'P'),
(28563, 'Selma (historical)', 38.4258308410645, 0.670657265990957, -87.7480621337891, -1.53149259647918, 218, 18, 'PPL', 'P'),
(197500, 'Selma (historical)', 48.2133293151855, 0.841481339898291, -111.128890991211, -1.9395650418865, 218, 31, 'PPL', 'P'),
(18028, 'Selman', 30.5358295440674, 0.532950765371735, -85.0286102294922, -1.48402920689957, 218, 12, 'PPL', 'P'),
(77207, 'Selman', 36.8019409179688, 0.642315040142979, -99.4905624389648, -1.73643788922094, 218, 42, 'PPL', 'P'),
(97965, 'Selman', 31.2536106109619, 0.545478408297522, -99.100830078125, -1.72963577632271, 218, 51, 'PPL', 'P'),
(97966, 'Selman City', 32.189998626709, 0.561821462248525, -94.961669921875, -1.65739380332879, 218, 51, 'PPL', 'P'),
(28564, 'Selmaville', 38.6069412231445, 0.673818238467799, -88.9952774047852, -1.55326060943922, 218, 18, 'PPL', 'P'),
(90665, 'Selmer', 35.1699981689453, 0.613832265968473, -88.5922164916992, -1.54622586941977, 218, 50, 'PPL', 'P'),
(197501, 'Selmes', 45.3919410705566, 0.792238825552453, -109.131393432617, -1.90470213268849, 218, 31, 'PPL', 'P'),
(5732, 'Selmont', 32.3950004577637, 0.565399419173046, -87.0083312988281, -1.51858185783059, 218, 2, 'PPL', 'P'),
(57476, 'Selmore', 36.9680595397949, 0.645214357042721, -93.2300033569336, -1.62717052022386, 218, 29, 'PPL', 'P'),
(83562, 'Seloc', 33.8811111450195, 0.591336943714737, -80.0086135864258, -1.396413737039, 218, 48, 'PPL', 'P'),
(5733, 'Seloca', 33.7986106872559, 0.589897039092358, -86.8211135864258, -1.51531429233111, 218, 2, 'PPL', 'P'),
(61706, 'Sels Prairie', 31.938060760498, 0.557424316972695, -88.6308288574219, -1.54689978233362, 218, 30, 'PPL', 'P'),
(57477, 'Selsa', 39.0513916015625, 0.681575360932927, -94.3419418334961, -1.64657750771948, 218, 29, 'PPL', 'P'),
(208701, 'Seltice', 47.1555595397949, 0.823019774589643, -117.086112976074, -2.04353817979455, 218, 56, 'PPL', 'P'),
(166994, 'Seltzer', 40.6952781677246, 0.71026659404176, -76.2341690063477, -1.33053725168258, 218, 45, 'PPL', 'P'),
(31099, 'Selvin', 38.2041702270508, 0.666788558454426, -87.1061096191406, -1.52028841145711, 218, 19, 'PPL', 'P'),
(68645, 'Selwin', 36.3347206115723, 0.634160507464184, -76.5872192382813, -1.33669914065475, 218, 33, 'PPL', 'P'),
(83563, 'Selwood Shores', 34.0938911437988, 0.595050655275825, -81.227783203125, -1.41769226099068, 218, 48, 'PPL', 'P'),
(111334, 'Selwyn', 37.8586082458496, 0.660757364112751, -82.3786087036133, -1.43777795509011, 218, 58, 'PPL', 'P'),
(185048, 'Selwyn (historical)', 32.8636093139648, 0.573578186617761, -117.190826416016, -2.04536577409262, 218, 6, 'PPL', 'P'),
(140853, 'Selz', 47.8572196960449, 0.835266054546264, -99.8913879394531, -1.74343361393041, 218, 34, 'PPL', 'P'),
(5734, 'Seman', 32.7324981689453, 0.571289865451111, -86.1122207641602, -1.50294177853882, 218, 2, 'PPL', 'P'),
(152463, 'Semans Corner', 42.6627807617188, 0.744605992348487, -77.3861083984375, -1.35064238685797, 218, 40, 'PPL', 'P'),
(208702, 'Semiahmoo', 48.9891700744629, 0.855022315618853, -122.771942138672, -2.14277461938779, 218, 56, 'PPL', 'P'),
(28565, 'Seminary', 38.583610534668, 0.673411041137126, -88.1263885498047, -1.53809563808592, 218, 18, 'PPL', 'P'),
(61707, 'Seminary', 31.562219619751, 0.550864651602207, -89.4974975585938, -1.56202600469305, 218, 30, 'PPL', 'P'),
(106108, 'Seminary', 36.8105583190918, 0.642465442165541, -82.833610534668, -1.44571923514462, 218, 53, 'PPL', 'P'),
(97967, 'Seminary Estates Colonia', 26.3780002593994, 0.460382954618438, -98.1660003662109, -1.71331991990434, 218, 51, 'PPL', 'P'),
(51280, 'Seminary Overlook', 39.4277801513672, 0.688144580393826, -76.6519393920898, -1.33782872043111, 218, 25, 'PPL', 'P'),
(97968, 'Seminary South Colonia', 26.3799991607666, 0.460417842028718, -98.1620025634766, -1.71325014508378, 218, 51, 'PPL', 'P'),
(51281, 'Seminary Springs', 39.4238891601563, 0.688076669786029, -76.6624984741211, -1.33801301117854, 218, 25, 'PPL', 'P'),
(176318, 'Seminary Springs', 43.1086082458496, 0.752387149842453, -89.2486114501953, -1.55768212263902, 218, 57, 'PPL', 'P'),
(106109, 'Seminary Valley', 38.8183288574219, 0.67750764868394, -77.1177825927734, -1.34595921808107, 218, 53, 'PPL', 'P'),
(38149, 'Seminary Village', 38.2555618286133, 0.667685511109564, -85.6691665649414, -1.49520902399767, 218, 21, 'PPL', 'P'),
(97969, 'Seminary Village Colonia', 26.3680000305176, 0.460208417698497, -98.1640014648438, -1.71328503249406, 218, 51, 'PPL', 'P'),
(209727, 'Seminoe Dam', 42.1566696166992, 0.735772686486857, -106.913330078125, -1.86598962413477, 218, 59, 'PPL', 'P'),
(5735, 'Seminole', 30.5149993896484, 0.532587210593425, -87.4738922119141, -1.52670742863253, 218, 2, 'PPL', 'P'),
(68647, 'Seminole', 35.439998626709, 0.618544662938341, -79.0369415283203, -1.37945486037543, 218, 33, 'PPL', 'P'),
(77208, 'Seminole', 35.2244415283203, 0.614782481845413, -96.670280456543, -1.687214682793, 218, 42, 'PPL', 'P'),
(111336, 'Seminole', 37.5550003051758, 0.655458405912793, -80.8419418334961, -1.41095805870025, 218, 58, 'PPL', 'P'),
(112264, 'Seminole', 30.478889465332, 0.531956973521458, -86.4100036621094, -1.50813907056417, 218, 12, 'PPL', 'P'),
(166996, 'Seminole', 40.954719543457, 0.714794700264194, -79.3430633544922, -1.38479769415435, 218, 45, 'PPL', 'P'),
(192190, 'Seminole', 32.7188911437988, 0.571052378060903, -102.644439697266, -1.79148343158206, 218, 51, 'PPL', 'P'),
(18032, 'Seminole Grove', 29.5136108398438, 0.515109683307562, -81.6761093139648, -1.42551702774749, 218, 12, 'PPL', 'P'),
(5736, 'Seminole Heights', 31.2416706085205, 0.545270015942223, -85.2397232055664, -1.48771382342575, 218, 2, 'PPL', 'P'),
(18033, 'Seminole Hills', 30.3702793121338, 0.530061368747053, -85.9319381713867, -1.49979525371089, 218, 12, 'PPL', 'P'),
(185050, 'Seminole Hot Springs', 34.1072196960449, 0.595283282397043, -118.78971862793, -2.07327170757501, 218, 6, 'PPL', 'P'),
(18034, 'Seminole Manor', 26.5833301544189, 0.463966637339303, -80.1005630493164, -1.39801855791188, 218, 12, 'PPL', 'P'),
(106111, 'Seminole Ridge', 37.3436088562012, 0.651768929117624, -79.1972198486328, -1.38225224478445, 218, 53, 'PPL', 'P'),
(18035, 'Seminole Shores', 27.1813907623291, 0.474404764073814, -80.1658325195313, -1.39915772506816, 218, 12, 'PPL', 'P'),
(18036, 'Seminole Springs', 28.8452796936035, 0.503445104312042, -81.5283279418945, -1.42293775623175, 218, 12, 'PPL', 'P'),
(185051, 'Seminole Springs Trailer Park', 34.1100006103516, 0.59533181850791, -118.790832519531, -2.07329114865097, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(90663, 'Seminole Subdivision', 35.8561096191406, 0.625807169810014, -85.0777816772461, -1.48488741056085, 218, 50, 'PPL', 'P'),
(24738, 'Seminole Valley', 33.6836090087891, 0.587889881157793, -84.7861099243164, -1.47979677813716, 218, 13, 'PPL', 'P'),
(185052, 'Semitropic', 35.6019401550293, 0.621371075803242, -119.507499694824, -2.0857993505008, 218, 6, 'PPL', 'P'),
(38150, 'Semiway', 37.473331451416, 0.654033015518355, -87.2411117553711, -1.52264464323156, 218, 21, 'PPL', 'P'),
(5737, 'Semmes', 30.7780609130859, 0.537178500312722, -88.2591705322266, -1.54041312086651, 218, 2, 'PPL', 'P'),
(68648, 'Semora', 36.4983291625977, 0.637016015363994, -79.149169921875, -1.38141361535718, 218, 33, 'PPL', 'P'),
(187336, 'Semper', 39.8561096191406, 0.695620339889787, -105.064170837402, -1.83371570699048, 218, 7, 'PPL', 'P'),
(157587, 'Semples', 41.0872192382813, 0.717107256196764, -82.3041687011719, -1.43647873195231, 218, 41, 'PPL', 'P'),
(152464, 'Sempronius', 42.7294387817383, 0.745769394270688, -76.315559387207, -1.33195778180803, 218, 40, 'PPL', 'P'),
(97970, 'Sempronius (historical)', 30.0701103210449, 0.524822431540163, -96.2802200317383, -1.68040684409843, 218, 51, 'PPL', 'P'),
(189542, 'Sena', 35.2983283996582, 0.616072051024257, -105.392219543457, -1.83944123701804, 218, 38, 'PPL', 'P'),
(97971, 'Senate', 33.1741714477539, 0.5789985183844, -98.2938919067383, -1.71555204837199, 218, 51, 'PPL', 'P'),
(57478, 'Senate Grove (historical)', 38.5755615234375, 0.673270559389624, -91.3277816772461, -1.59397048881049, 218, 29, 'PPL', 'P'),
(13205, 'Senate Heights', 38.9152793884277, 0.679199754661549, -77.0897216796875, -1.3454694627566, 218, 9, 'PPL', 'P'),
(57479, 'Senath', 36.1341705322266, 0.630660248264465, -90.1597213745117, -1.57358399066594, 218, 29, 'PPL', 'P'),
(61708, 'Senatobia', 34.6175003051758, 0.604189359135459, -89.9686126708984, -1.57024851455867, 218, 30, 'PPL', 'P'),
(61709, 'Senatobia Lakes', 34.6208305358887, 0.60424748262625, -89.8752822875977, -1.56861959207792, 218, 30, 'PPL', 'P'),
(97972, 'Sendero Colonia', 26.2520008087158, 0.458183849348305, -98.2770004272461, -1.71525723643932, 218, 51, 'PPL', 'P'),
(195599, 'Seneacquoteen', 48.151668548584, 0.84040515650179, -116.754440307617, -2.0377493996911, 218, 17, 'PPL', 'P'),
(18037, 'Seneca', 28.8658294677734, 0.503803765531849, -81.6013870239258, -1.42421287776168, 218, 12, 'PPL', 'P'),
(33920, 'Seneca', 39.834171295166, 0.695237443904061, -96.0638885498047, -1.67663114746297, 218, 20, 'PPL', 'P'),
(51284, 'Seneca', 39.0786094665527, 0.68205040229237, -77.3394393920898, -1.34982785903857, 218, 25, 'PPL', 'P'),
(57480, 'Seneca', 36.8413887023926, 0.643003533863792, -94.6108322143555, -1.65127053019242, 218, 29, 'PPL', 'P'),
(61710, 'Seneca', 31.0391693115234, 0.541735701570065, -89.4394378662109, -1.56101267189827, 218, 30, 'PPL', 'P'),
(83564, 'Seneca', 34.6855583190918, 0.605377195560662, -82.9533309936523, -1.44780875133589, 218, 48, 'PPL', 'P'),
(106113, 'Seneca', 37.0930595397949, 0.647396018607714, -79.1263885498047, -1.38101600540643, 218, 53, 'PPL', 'P'),
(117722, 'Seneca', 43.2991714477539, 0.755713105148826, -94.3838882446289, -1.64730961070315, 218, 16, 'PPL', 'P'),
(121414, 'Seneca', 41.3111114501953, 0.721014912464238, -88.6097183227539, -1.5465313339968, 218, 18, 'PPL', 'P'),
(133050, 'Seneca', 41.7874984741211, 0.72932943454552, -84.1766662597656, -1.46915997958533, 218, 27, 'PPL', 'P'),
(166995, 'Seneca', 41.3786087036133, 0.722192961772434, -79.7041702270508, -1.39110019803207, 218, 45, 'PPL', 'P'),
(171275, 'Seneca', 45.0616683959961, 0.786474479952004, -99.5116729736328, -1.73680633755775, 218, 49, 'PPL', 'P'),
(176319, 'Seneca', 43.2649993896484, 0.755116690222702, -90.9583282470703, -1.58752231002114, 218, 57, 'PPL', 'P'),
(179120, 'Seneca', 33.7566719055176, 0.58916506926675, -110.512222290039, -1.92880214265705, 218, 5, 'PPL', 'P'),
(189543, 'Seneca', 36.6283302307129, 0.639284962033714, -103.126106262207, -1.79989009903706, 218, 38, 'PPL', 'P'),
(193940, 'Seneca', 40.1105613708496, 0.700061360744576, -121.083610534668, -2.11330767403245, 218, 6, 'PPL', 'P'),
(199673, 'Seneca', 42.0433311462402, 0.733794557008174, -100.832496643066, -1.75985905942764, 218, 35, 'PPL', 'P'),
(201547, 'Seneca', 44.1347198486328, 0.770296175803936, -118.970558166504, -2.07642795294092, 218, 43, 'PPL', 'P'),
(152466, 'Seneca Castle', 42.8869400024414, 0.748518309147868, -77.0963897705078, -1.34558584289624, 218, 40, 'PPL', 'P'),
(152468, 'Seneca Falls', 42.9105606079102, 0.748930566484612, -76.7969436645508, -1.34035952241501, 218, 40, 'PPL', 'P'),
(38151, 'Seneca Gardens', 38.228889465332, 0.667219990551019, -85.6774978637695, -1.49535443259319, 218, 21, 'PPL', 'P'),
(152470, 'Seneca Heights', 42.0688896179199, 0.734240636490762, -78.4269409179688, -1.36880834128562, 218, 40, 'PPL', 'P'),
(51285, 'Seneca Highlands', 39.1055603027344, 0.682520783119905, -77.2911071777344, -1.34898430276329, 218, 25, 'PPL', 'P'),
(152471, 'Seneca Hill', 43.4008293151855, 0.757487369646064, -76.4705581665039, -1.33466302084333, 218, 40, 'PPL', 'P'),
(152472, 'Seneca Knolls', 43.1199989318848, 0.752585954817827, -76.2866668701172, -1.33145351225562, 218, 40, 'PPL', 'P'),
(74256, 'Seneca Lake Estates', 39.922779083252, 0.69678394154907, -81.3883285522461, -1.4204943059316, 218, 41, 'PPL', 'P'),
(83565, 'Seneca Landing', 34.644718170166, 0.604664400494902, -82.9147186279297, -1.44713483842205, 218, 48, 'PPL', 'P'),
(152473, 'Seneca Mills', 42.6611099243164, 0.74457683073455, -77.0055618286133, -1.34400059625737, 218, 40, 'PPL', 'P'),
(51286, 'Seneca Overlook', 39.2608299255371, 0.685230749266143, -77.1522216796875, -1.3465602935391, 218, 25, 'PPL', 'P'),
(51288, 'Seneca Park', 39.1708297729492, 0.683659950276187, -77.2319412231445, -1.34795166205061, 218, 25, 'PPL', 'P'),
(111339, 'Seneca Rocks', 38.8347206115723, 0.677793738764042, -79.3763885498047, -1.38537932853642, 218, 58, 'PPL', 'P'),
(51289, 'Seneca Upland', 39.2472190856934, 0.684993195296908, -77.1569366455078, -1.34664258521678, 218, 25, 'PPL', 'P'),
(74254, 'Senecaville', 39.9341697692871, 0.696982746524444, -81.4625015258789, -1.42178886853749, 218, 41, 'PPL', 'P'),
(24739, 'Seney', 34.0847206115723, 0.594890599294311, -85.1211090087891, -1.48564361515238, 218, 13, 'PPL', 'P'),
(57482, 'Seney', 39.8474998474121, 0.695470071025279, -92.5813903808594, -1.6158500882202, 218, 29, 'PPL', 'P'),
(117724, 'Seney', 42.8527793884277, 0.747922093958826, -96.1305618286133, -1.67779481570128, 218, 16, 'PPL', 'P'),
(133054, 'Seney', 46.3455581665039, 0.80888258368004, -85.9452819824219, -1.50002814714822, 218, 27, 'PPL', 'P'),
(90666, 'Sengtown', 36.6133308410645, 0.639023173298559, -86.4375, -1.5086189721926, 218, 50, 'PPL', 'P'),
(74255, 'Senior', 39.3858299255371, 0.687412410831136, -84.0894393920898, -1.46763758354819, 218, 41, 'PPL', 'P'),
(152477, 'Sennett', 42.9947204589844, 0.750399432983845, -76.5330581665039, -1.33575385162583, 218, 40, 'PPL', 'P'),
(128788, 'Sennetts Corner', 44.4883308410645, 0.776467851893113, -69.4422225952148, -1.2119954241893, 218, 26, 'PPL', 'P'),
(24740, 'Senoia', 33.3022193908691, 0.581233376592167, -84.5538864135742, -1.47574371327417, 218, 13, 'PPL', 'P'),
(106114, 'Senora', 37.6763916015625, 0.657577083718005, -76.5213928222656, -1.33555025296049, 218, 53, 'PPL', 'P'),
(189544, 'Senorito', 35.9780616760254, 0.627935634732232, -106.914169311523, -1.86600427152076, 218, 38, 'PPL', 'P'),
(11858, 'Sensation (historical)', 34.8708305358887, 0.608610805756236, -94.273063659668, -1.64537535680342, 218, 4, 'PPL', 'P'),
(106115, 'Senseny Heights', 39.1694412231445, 0.683635715510267, -78.1319427490234, -1.36365965195017, 218, 53, 'PPL', 'P'),
(43006, 'Sentell', 32.6480598449707, 0.569816138682888, -93.7975006103516, -1.63707521579203, 218, 22, 'PPL', 'P'),
(68650, 'Senter', 35.3555603027344, 0.617070936170118, -78.7938919067383, -1.3752128442331, 218, 33, 'PPL', 'P'),
(133053, 'Senter', 47.1055603027344, 0.822147123279452, -88.4355621337891, -1.54349173508664, 218, 27, 'PPL', 'P'),
(97973, 'Senterfitt', 31.1977806091309, 0.544503990944176, -98.4369430541992, -1.71804876189394, 218, 51, 'PPL', 'P'),
(97974, 'Senterfitt (historical)', 31.2000694274902, 0.544543938360527, -98.4424591064453, -1.71814503516735, 218, 51, 'PPL', 'P'),
(90667, 'Sentertown', 36.0505599975586, 0.629200969145156, -83.8300018310547, -1.46310954390478, 218, 50, 'PPL', 'P'),
(57483, 'Sentinel', 37.7936096191406, 0.659622924067404, -93.2955627441406, -1.62831474738621, 218, 29, 'PPL', 'P'),
(77211, 'Sentinel', 35.1577796936035, 0.613619013344185, -99.1750030517578, -1.7309303389286, 218, 42, 'PPL', 'P'),
(157581, 'Sentinel', 41.6347198486328, 0.726662944504078, -80.7216720581055, -1.40885895512905, 218, 41, 'PPL', 'P'),
(179121, 'Sentinel', 32.8580589294434, 0.57348131413311, -113.212501525879, -1.97593090604569, 218, 5, 'PPL', 'P'),
(185053, 'Sentinel (historical)', 36.964168548584, 0.645146446434924, -119.491943359375, -2.08552784122767, 218, 6, 'PPL', 'P'),
(198880, 'Sentinel Butte', 46.9183311462402, 0.818879358042897, -103.838333129883, -1.81232080289916, 218, 34, 'PPL', 'P'),
(90668, 'Sentinel Heights', 35.502498626709, 0.619635493720837, -84.998893737793, -1.48351055627728, 218, 50, 'PPL', 'P'),
(152476, 'Sentinel Heights', 42.9500007629395, 0.74961892704737, -76.1152801513672, -1.32846224971925, 218, 40, 'PPL', 'P'),
(177686, 'Sentous', 34.0263900756836, 0.593872539388601, -118.371109008789, -2.06596559144049, 218, 6, 'PPL', 'P'),
(18038, 'Senyah', 29.3400001525879, 0.512079605198297, -81.4925003051758, -1.4223124460078, 218, 12, 'PPL', 'P'),
(208703, 'Seola Beach', 47.4936103820801, 0.82891987482666, -122.366668701172, -2.13570126353254, 218, 56, 'PPL', 'P'),
(57484, 'Seopus', 37.3988914489746, 0.65273379238056, -89.9205627441406, -1.5694098851314, 218, 29, 'PPL', 'P'),
(189545, 'Separ', 32.2008285522461, 0.562010480106893, -108.421669006348, -1.89231510466826, 218, 38, 'PPL', 'P'),
(121416, 'Sepo', 40.3436088562012, 0.704128806677454, -90.1191711425781, -1.57287625560625, 218, 18, 'PPL', 'P'),
(106116, 'Septa', 37.0083312988281, 0.64591723183342, -76.6986083984375, -1.33864324825051, 218, 53, 'PPL', 'P'),
(185055, 'Sepulveda', 34.2308311462402, 0.597440709196117, -118.467216491699, -2.06764298345308, 218, 6, 'PPL', 'P'),
(90669, 'Sequatchie', 35.1155586242676, 0.61288211667056, -85.5936126708984, -1.49389035978392, 218, 50, 'PPL', 'P'),
(208705, 'Sequim', 48.079719543457, 0.83914940946879, -123.100563049316, -2.14851013626944, 218, 56, 'PPL', 'P'),
(57485, 'Sequiota', 37.1474990844727, 0.648346167905627, -93.2388916015625, -1.62732564935735, 218, 29, 'PPL', 'P'),
(187337, 'Sequndo', 37.1208305358887, 0.647880713926108, -104.721672058105, -1.82773797560769, 218, 7, 'PPL', 'P'),
(185057, 'Sequoia', 37.8066711425781, 0.659850890656715, -119.894439697266, -2.09255272755108, 218, 6, 'PPL', 'P'),
(24741, 'Sequoia Acres', 34.2555618286133, 0.597872341029791, -85.1277770996094, -1.48575999529201, 218, 13, 'PPL', 'P'),
(90671, 'Sequoia Grove', 35.2125015258789, 0.614574089490114, -84.8477783203125, -1.48087309469172, 218, 50, 'PPL', 'P'),
(90672, 'Sequoia Hills', 36.0972213745117, 0.630015363806503, -82.8733291625977, -1.44641245597636, 218, 50, 'PPL', 'P'),
(24742, 'Sequoia View', 34.2538909912109, 0.597843179415855, -85.1236114501953, -1.48568729099425, 218, 13, 'PPL', 'P'),
(90673, 'Sequooyah Estates', 36.1636085510254, 0.631174038617769, -83.2777786254883, -1.45347143076173, 218, 50, 'PPL', 'P'),
(77212, 'Sequoyah', 36.3733291625977, 0.634834353799001, -95.5605621337891, -1.66784644429124, 218, 42, 'PPL', 'P'),
(24743, 'Sequoyah Estates', 34.086109161377, 0.594914834060231, -84.6741714477539, -1.47784308316148, 218, 13, 'PPL', 'P'),
(90674, 'Sequoyah Estates', 35.5088882446289, 0.619747013591484, -84.3805618286133, -1.47271862859195, 218, 50, 'PPL', 'P'),
(90675, 'Sequoyah Heights', 35.7700004577637, 0.624304281427855, -84.1677780151367, -1.46900485045183, 218, 50, 'PPL', 'P'),
(90678, 'Sequoyah Hills', 35.9361114501953, 0.627203465169543, -83.9747161865234, -1.46563528588261, 218, 50, 'PPL', 'P'),
(90679, 'Sequoyah Shores', 35.8472213745117, 0.625652040676517, -84.5288925170898, -1.47530748748761, 218, 50, 'PPL', 'P'),
(189546, 'Serafina', 35.3974990844727, 0.617802905995726, -105.323059082031, -1.83823415925396, 218, 38, 'PPL', 'P'),
(5738, 'Serange', 31.2177791595459, 0.544853031494544, -87.6391677856445, -1.52959203156725, 218, 2, 'PPL', 'P'),
(179124, 'Serape', 33.232780456543, 0.580021438559099, -111.836387634277, -1.95191318775481, 218, 5, 'PPL', 'P'),
(97975, 'Serbin', 30.1275005340576, 0.525824079715655, -96.9986114501953, -1.69294513966858, 218, 51, 'PPL', 'P'),
(43007, 'Serena', 31.4402809143066, 0.548736419706584, -91.8638916015625, -1.60332737214243, 218, 22, 'PPL', 'P'),
(121417, 'Serena', 41.4861106872559, 0.724069225339422, -88.7313919067383, -1.54865493865003, 218, 18, 'PPL', 'P'),
(185059, 'Serena', 34.4124984741211, 0.600611402210938, -119.555282592773, -2.08663331939616, 218, 6, 'PPL', 'P'),
(185060, 'Serena Park', 34.4186096191406, 0.600718061812595, -119.571670532227, -2.08691934289723, 218, 6, 'PPL', 'P'),
(97976, 'Serenada', 30.6991691589355, 0.535801579450124, -97.6916732788086, -1.70504135049777, 218, 51, 'PPL', 'P'),
(97977, 'Serendipity Way Colonia', 26.2070007324219, 0.457398449853327, -98.0800018310547, -1.71181896231397, 218, 51, 'PPL', 'P'),
(208704, 'Serene', 47.8708305358887, 0.835503608515499, -122.294441223145, -2.13444065623055, 218, 56, 'PPL', 'P'),
(192191, 'Serene Acres Colonia', 31.9139995574951, 0.557004369758303, -106.603996276855, -1.8605907308149, 218, 51, 'PPL', 'P'),
(83566, 'Serene Heights', 34.9508285522461, 0.610007034536737, -82.1666717529297, -1.43407895749404, 218, 48, 'PPL', 'P'),
(24744, 'Serene Shores', 34.2655601501465, 0.598046844660219, -83.9222183227539, -1.46471902530957, 218, 13, 'PPL', 'P'),
(51290, 'Serenity Woods', 38.5044403076172, 0.672029260005538, -76.8405609130859, -1.34112078701261, 218, 25, 'PPL', 'P'),
(57488, 'Sereno', 37.797779083252, 0.65969569494419, -89.8511123657227, -1.56819774736125, 218, 29, 'PPL', 'P'),
(166997, 'Sereno', 41.1541709899902, 0.718275784704064, -76.5216674804688, -1.33555504665045, 218, 45, 'PPL', 'P'),
(179122, 'Sereno', 35.2394409179688, 0.615044270580568, -112.272499084473, -1.95952476846637, 218, 5, 'PPL', 'P'),
(179123, 'Sereno Spring', 35.2388916015625, 0.615034683200643, -112.279716491699, -1.95965073598593, 218, 5, 'PPL', 'P'),
(11859, 'Serepta Springs (historical)', 33.6652793884277, 0.587569968931847, -93.2874984741211, -1.6281739993226, 218, 4, 'PPL', 'P'),
(166998, 'Sergeant', 41.6338882446289, 0.726648430276137, -78.7522201538086, -1.3744855349394, 218, 45, 'PPL', 'P'),
(117725, 'Sergeant Bluff', 42.4038887023926, 0.740087473505976, -96.3583297729492, -1.68177011626044, 218, 16, 'PPL', 'P'),
(146285, 'Sergeantsville', 40.4458312988281, 0.705912924870725, -74.9438934326172, -1.30801769466292, 218, 37, 'PPL', 'P'),
(38152, 'Sergent', 37.1474990844727, 0.648346167905627, -82.7697219848633, -1.4446041695962, 218, 21, 'PPL', 'P'),
(197502, 'Seright (historical)', 46.9680595397949, 0.819747282242154, -109.639442443848, -1.91356926069596, 218, 31, 'PPL', 'P'),
(90680, 'Serles', 35.1691703796387, 0.613817818319559, -88.8436126708984, -1.55061356047373, 218, 50, 'PPL', 'P'),
(212139, 'Serpentine Hot Springs', 65.8569412231445, 1.14942045963625, -164.714172363281, -2.87480463243671, 218, 1, 'PPL', 'P'),
(185061, 'Serra Mesa', 32.8027801513672, 0.572516517449201, -117.137496948242, -2.04443499929164, 218, 6, 'PPL', 'P'),
(185062, 'Serra Village', 36.6041717529297, 0.638863317054127, -121.697219848633, -2.12401717688204, 218, 6, 'PPL', 'P'),
(185063, 'Serrano', 35.3349990844727, 0.61671207521323, -120.653610229492, -2.10580275292255, 218, 6, 'PPL', 'P'),
(185064, 'Serrano Heights', 33.9580612182617, 0.592679975852464, -117.206939697266, -2.04564700390373, 218, 6, 'PPL', 'P'),
(185065, 'Serrano Place', 33.6469383239746, 0.587249856968819, -117.688888549805, -2.05405859820675, 218, 6, 'PPL', 'P'),
(185066, 'Serrano Village', 34.1788902282715, 0.596534169161054, -117.320831298828, -2.04763478734137, 218, 6, 'PPL', 'P'),
(112651, 'Servia', 38.6202812194824, 0.674051065326099, -80.9574966430664, -1.41297487059377, 218, 58, 'PPL', 'P'),
(123642, 'Servia', 40.9566688537598, 0.71482872214712, -85.7405624389648, -1.49645511707172, 218, 19, 'PPL', 'P'),
(209921, 'Servia', 46.9230613708496, 0.81896191603669, -118.753608703613, -2.07264147050305, 218, 56, 'PPL', 'P'),
(57487, 'Service', 37.9713897705078, 0.662725773053455, -91.1458282470703, -1.59079480236863, 218, 29, 'PPL', 'P'),
(61711, 'Service', 31.735559463501, 0.553890002600537, -89.2233276367188, -1.55724083684639, 218, 30, 'PPL', 'P'),
(201548, 'Service Creek', 44.797779083252, 0.781868742583794, -120.007217407227, -2.09452106991276, 218, 43, 'PPL', 'P'),
(90681, 'Servilla', 35.235279083252, 0.614971632861836, -84.461669921875, -1.47413423186938, 218, 50, 'PPL', 'P'),
(189547, 'Servilleta', 36.5533294677734, 0.637975951778913, -105.934997558594, -1.84891450048962, 218, 38, 'PPL', 'P'),
(126059, 'Sesachacha', 41.2833290100098, 0.720530017408762, -69.9833297729492, -1.22143952604694, 218, 23, 'PPL', 'P'),
(185067, 'Sespe', 34.4000015258789, 0.60039328931766, -118.949440002441, -2.07605937144605, 218, 6, 'PPL', 'P'),
(185070, 'Sespe Village', 34.3863906860352, 0.600155735348425, -118.954719543457, -2.07615151681977, 218, 6, 'PPL', 'P'),
(28567, 'Sesser', 38.0916709899902, 0.664825076361738, -89.0502777099609, -1.55422054585413, 218, 18, 'PPL', 'P'),
(68652, 'Sessex', 36.5616683959961, 0.638121493532486, -81.4191665649414, -1.42103253078791, 218, 33, 'PPL', 'P'),
(5739, 'Sessions', 32.9300003051758, 0.574736928008055, -85.7466735839844, -1.49656177667337, 218, 2, 'PPL', 'P'),
(61712, 'Sessions', 34.3413887023926, 0.599370302563934, -90.6313934326172, -1.58181622106954, 218, 30, 'PPL', 'P'),
(24745, 'Sessoms', 31.5155601501465, 0.550050290230375, -82.5830612182617, -1.44134632463471, 218, 13, 'PPL', 'P'),
(61713, 'Sessums', 33.4161109924316, 0.583221160029802, -88.7141723632813, -1.54835440092102, 218, 30, 'PPL', 'P'),
(205697, 'Set Point East', 40.6016693115234, 0.708632811292023, -111.820556640625, -1.95163688479172, 218, 52, 'PPL', 'P'),
(152478, 'Setauket', 40.935001373291, 0.714450553272329, -73.1188888549805, -1.2761653559192, 218, 40, 'PPL', 'P'),
(90682, 'Seth', 35.547779083252, 0.620425786774318, -87.2897186279297, -1.5234929931968, 218, 50, 'PPL', 'P'),
(97978, 'Seth', 30.2986106872559, 0.528810515272557, -94.1836090087891, -1.64381407861436, 218, 51, 'PPL', 'P'),
(111340, 'Seth', 38.1080589294434, 0.665111099862812, -81.6233291625977, -1.42459584032644, 218, 58, 'PPL', 'P'),
(192192, 'Seth Ward', 34.211669921875, 0.59710628274223, -101.689720153809, -1.77482043211559, 218, 51, 'PPL', 'P'),
(133055, 'Sethton', 43.2197189331055, 0.754326397169221, -84.7774963378906, -1.47964644269363, 218, 27, 'PPL', 'P'),
(189548, 'Seton Village', 35.5991706848145, 0.621322739429457, -105.931938171387, -1.84886110410976, 218, 38, 'PPL', 'P'),
(97979, 'Settegast', 29.8413906097412, 0.520830519513702, -95.2841720581055, -1.66302252745072, 218, 51, 'PPL', 'P'),
(195600, 'Setters', 47.4680595397949, 0.828473928502126, -117.007217407227, -2.04216119235293, 218, 17, 'PPL', 'P'),
(38153, 'Settle', 36.8694381713867, 0.643493089451176, -86.2144393920898, -1.50472583015307, 218, 21, 'PPL', 'P'),
(11860, 'Settlement (historical)', 35.6444396972656, 0.622112832745856, -92.3147201538086, -1.61119581474113, 218, 4, 'PPL', 'P'),
(24746, 'Settlers Grove', 33.6083297729492, 0.586576010634002, -83.8319396972656, -1.46314336605062, 218, 13, 'PPL', 'P'),
(24747, 'Settlers Landing', 32.5694389343262, 0.568443944931225, -83.6833267211914, -1.46054958030694, 218, 13, 'PPL', 'P'),
(51291, 'Settlers Landing', 39.1138916015625, 0.682666191715424, -76.8541717529297, -1.34135834098185, 218, 25, 'PPL', 'P'),
(90684, 'Settlers Point', 35.9491691589355, 0.627431365179826, -86.9466705322266, -1.51750567443408, 218, 50, 'PPL', 'P'),
(57489, 'Settletown', 37.9505615234375, 0.66236225156466, -90.595832824707, -1.58119557137749, 218, 29, 'PPL', 'P'),
(123643, 'Sevastopol', 41.1291694641113, 0.717839425759454, -86.0188903808594, -1.50131285605808, 218, 19, 'PPL', 'P'),
(90685, 'Seven (historical)', 35.271671295166, 0.61560679678182, -87.2388916015625, -1.52260589423769, 218, 50, 'PPL', 'P'),
(79106, 'Seven Acres', 39.9425010681152, 0.697128155119963, -76.6975021362305, -1.33862394033261, 218, 45, 'PPL', 'P'),
(208706, 'Seven Bays', 47.8511085510254, 0.835159394944606, -118.340560913086, -2.06543242659026, 218, 56, 'PPL', 'P'),
(51292, 'Seven Cedars', 39.6136093139648, 0.691387911127379, -76.397216796875, -1.33338297246538, 218, 25, 'PPL', 'P'),
(90686, 'Seven Cedars', 35.3450012207031, 0.616886645422684, -84.533332824707, -1.47538498547534, 218, 50, 'PPL', 'P'),
(38154, 'Seven Corners', 37.4819412231445, 0.654183284382863, -85.9927825927734, -1.50085718919556, 218, 21, 'PPL', 'P'),
(106117, 'Seven Corners', 38.871940612793, 0.67844335033294, -77.1555633544922, -1.34661861676697, 218, 53, 'PPL', 'P'),
(68656, 'Seven Creeks', 34.0819396972656, 0.594842063183445, -78.6302795410156, -1.37235726975426, 218, 33, 'PPL', 'P'),
(68654, 'Seven Devils', 36.1580581665039, 0.631077166133117, -81.835563659668, -1.42830003108663, 218, 33, 'PPL', 'P'),
(167000, 'Seven Fields', 40.6916694641113, 0.710203610281979, -80.0627822875977, -1.39735915922598, 218, 45, 'PPL', 'P'),
(106118, 'Seven Fountains', 38.8611106872559, 0.678254332474571, -78.3997192382813, -1.36833323334715, 218, 53, 'PPL', 'P'),
(133056, 'Seven Harbors', 42.6719398498535, 0.744765848592919, -83.5722198486328, -1.4586103995592, 218, 27, 'PPL', 'P'),
(51293, 'Seven Havens', 39.6588897705078, 0.69217820418086, -76.8236083984375, -1.3408249098155, 218, 25, 'PPL', 'P'),
(192193, 'Seven Heart Crossing', 31.163330078125, 0.543902715749063, -104.023612976074, -1.81555454625279, 218, 51, 'PPL', 'P'),
(14581, 'Seven Hickories', 39.2161102294922, 0.684450243329668, -75.6297225952148, -1.31998767165645, 218, 10, 'PPL', 'P'),
(5741, 'Seven Hills', 30.6538906097412, 0.535011319686156, -88.3030624389648, -1.54117917915407, 218, 2, 'PPL', 'P'),
(157582, 'Seven Hills', 41.3952789306641, 0.722483912121525, -81.6763916015625, -1.42552195459551, 218, 41, 'PPL', 'P'),
(194418, 'Seven Hills', 40.0372200012207, 0.698781312366629, -105.332496643066, -1.83839887576738, 218, 7, 'PPL', 'P'),
(90687, 'Seven Islands', 35.9480590820313, 0.627411990682896, -83.7038879394531, -1.46090844126383, 218, 50, 'PPL', 'P'),
(97980, 'Seven Knobs', 32.1519393920898, 0.561157203293632, -97.748893737793, -1.70604003590655, 218, 51, 'PPL', 'P'),
(97981, 'Seven L Crossing', 34.1888885498047, 0.596708672791481, -99.8744430541992, -1.74313786989136, 218, 51, 'PPL', 'P'),
(68661, 'Seven Lakes', 35.2783317565918, 0.615723043763402, -79.5647201538086, -1.38866633511185, 218, 33, 'PPL', 'P'),
(189549, 'Seven Lakes', 35.7847213745117, 0.62456120989402, -107.934997558594, -1.8838210855295, 218, 38, 'PPL', 'P'),
(187338, 'Seven Lakes (historical)', 38.7816696166992, 0.676867824232049, -105.008056640625, -1.8327363294996, 218, 7, 'PPL', 'P'),
(74257, 'Seven Mile', 39.4799995422363, 0.689055980697878, -84.5519409179688, -1.47570975797027, 218, 41, 'PPL', 'P'),
(208707, 'Seven Mile', 47.7422218322754, 0.833258963190726, -117.510276794434, -2.05094123499275, 218, 56, 'PPL', 'P'),
(197503, 'Seven Mile (historical)', 46.6333312988281, 0.813905172337875, -112.08332824707, -1.95622311450494, 218, 31, 'PPL', 'P'),
(106119, 'Seven Mile Ford', 36.8102798461914, 0.642460581896552, -81.6297225952148, -1.42470742677611, 218, 53, 'PPL', 'P'),
(51295, 'Seven Oaks', 39.0069389343262, 0.68079951552836, -77.0155563354492, -1.34417503330877, 218, 25, 'PPL', 'P'),
(77214, 'Seven Oaks', 35.4813919067383, 0.619267111963052, -94.7319412231445, -1.65338428114962, 218, 42, 'PPL', 'P'),
(83569, 'Seven Oaks', 34.6055603027344, 0.603980966780161, -82.9205627441406, -1.4472368374918, 218, 48, 'PPL', 'P'),
(90688, 'Seven Oaks', 36.1944389343262, 0.631712130316019, -83.3986129760742, -1.45558038802896, 218, 50, 'PPL', 'P'),
(97982, 'Seven Oaks', 30.8519401550293, 0.538467936333511, -94.866943359375, -1.65574051292406, 218, 51, 'PPL', 'P'),
(185071, 'Seven Oaks', 34.1863899230957, 0.596665063528631, -116.913330078125, -2.0405225493342, 218, 6, 'PPL', 'P'),
(201549, 'Seven Oaks', 42.3925018310547, 0.739888735109629, -122.936943054199, -2.14565442863255, 218, 43, 'PPL', 'P'),
(179125, 'Seven Palms Mobile Home Estates', 33.6425018310547, 0.587172425560125, -112.064437866211, -1.95589341516199, 218, 5, 'PPL', 'P'),
(68658, 'Seven Paths', 35.997501373291, 0.628274921455109, -78.1838912963867, -1.36456632514329, 218, 33, 'PPL', 'P'),
(5742, 'Seven Pines', 34.4738883972168, 0.601682858496504, -88.0686111450195, -1.53708723213916, 218, 2, 'PPL', 'P'),
(61715, 'Seven Pines', 33.3702812194824, 0.582421279596397, -90.0947189331055, -1.57244948404156, 218, 30, 'PPL', 'P'),
(97983, 'Seven Pines', 32.5913887023926, 0.568827040654033, -94.8188934326172, -1.6549018834968, 218, 51, 'PPL', 'P'),
(106120, 'Seven Pines', 37.5202789306641, 0.654852403606745, -77.3030624389648, -1.34919296143469, 218, 53, 'PPL', 'P'),
(111341, 'Seven Pines', 39.5666694641113, 0.690568656197043, -80.4419403076172, -1.40397671506066, 218, 58, 'PPL', 'P'),
(167002, 'Seven Pines', 40.4697189331055, 0.706329842739377, -77.4625015258789, -1.35197569845772, 218, 45, 'PPL', 'P'),
(185072, 'Seven Pines', 36.7855606079102, 0.642029149799959, -118.293060302734, -2.06460338454292, 218, 6, 'PPL', 'P'),
(97984, 'Seven Points', 32.3202781677246, 0.564095269187235, -96.2127838134766, -1.67922986005467, 218, 51, 'PPL', 'P'),
(167003, 'Seven Points', 40.8233299255371, 0.712501518828554, -76.7125015258789, -1.33888572906776, 218, 45, 'PPL', 'P'),
(177720, 'Seven Rivers', 32.5950012207031, 0.56889009099284, -104.421112060547, -1.8224922140505, 218, 38, 'PPL', 'P'),
(97985, 'Seven Sisters', 28.0102806091309, 0.488871621036856, -98.5388870239258, -1.71982801981822, 218, 51, 'PPL', 'P'),
(18039, 'Seven Springs', 28.2119407653809, 0.492391254733505, -82.6661071777344, -1.44279575005798, 218, 12, 'PPL', 'P'),
(24749, 'Seven Springs', 33.9777793884277, 0.593024122844329, -84.4311065673828, -1.47360080070304, 218, 13, 'PPL', 'P'),
(31100, 'Seven Springs', 38.1419410705566, 0.665702454782864, -85.9766693115234, -1.50057595938445, 218, 19, 'PPL', 'P'),
(61714, 'Seven Springs', 32.2158317565918, 0.562272335421075, -90.3736114501953, -1.57731707672396, 218, 30, 'PPL', 'P'),
(68659, 'Seven Springs', 35.2272186279297, 0.614830951377252, -77.8472213745117, -1.35869032651414, 218, 33, 'PPL', 'P'),
(167004, 'Seven Springs', 40.0230598449707, 0.69853417101747, -79.2975006103516, -1.38400247425285, 218, 45, 'PPL', 'P'),
(189550, 'Seven Springs', 35.9019393920898, 0.626607050243419, -106.711387634277, -1.8624650635901, 218, 38, 'PPL', 'P'),
(146286, 'Seven Stars', 40.0572204589844, 0.699130386206512, -74.2202835083008, -1.2953883189835, 218, 37, 'PPL', 'P'),
(167009, 'Seven Stars', 40.1002807617188, 0.699881930266132, -75.3011093139648, -1.31425228793286, 218, 45, 'PPL', 'P'),
(185073, 'Seven Trees', 37.2861099243164, 0.650765383439855, -121.837501525879, -2.1264655540302, 218, 6, 'PPL', 'P'),
(200198, 'Seven Troughs (historical)', 40.4625015258789, 0.706203875219817, -118.816673278809, -2.07374215498158, 218, 39, 'PPL', 'P'),
(79108, 'Seven Valleys', 39.8555603027344, 0.695610752509863, -76.7688903808594, -1.3398699002486, 218, 45, 'PPL', 'P'),
(179126, 'Sevenmile', 33.7852783203125, 0.589664345392113, -109.956108093262, -1.9190961189062, 218, 5, 'PPL', 'P'),
(77215, 'Sevenmile Corner', 34.1133308410645, 0.595389941998701, -96.1469421386719, -1.6780807060443, 218, 42, 'PPL', 'P'),
(192194, 'Sevenmile Corner', 31.3213901519775, 0.546661384453735, -101.942497253418, -1.77923222477742, 218, 51, 'PPL', 'P'),
(202605, 'Sevenmile Corner', 43.8358306884766, 0.765079575860689, -101.660003662109, -1.7743017814933, 218, 49, 'PPL', 'P'),
(209883, 'Sevenmile Corner', 48.8944396972656, 0.853368958635105, -102.545562744141, -1.78975770319569, 218, 34, 'PPL', 'P'),
(90691, 'Sevenmile Hill', 35.4066696166992, 0.61796296197724, -86.2425003051758, -1.50521558547753, 218, 50, 'PPL', 'P'),
(187339, 'Sevenmile Plaza', 37.6480598449707, 0.657082601282605, -106.236938476563, -1.85418436365466, 218, 7, 'PPL', 'P'),
(90690, 'Sevenoaks', 35.9072189331055, 0.626699195617136, -84.0950012207031, -1.46773465576992, 218, 50, 'PPL', 'P'),
(192195, 'Seventeen Mile Crossing', 31.5469398498535, 0.550597969308549, -100.163887023926, -1.74818962016313, 218, 51, 'PPL', 'P'),
(90693, 'Seventeen Seventysix Estates', 36.0877799987793, 0.629850580714054, -86.9519424438477, -1.51759768664975, 218, 50, 'PPL', 'P'),
(126060, 'Seventh Day Adventist Village', 42.4211082458496, 0.740388011234992, -71.6436080932617, -1.25041684923587, 218, 23, 'PPL', 'P'),
(152479, 'Seventh Day Hollow', 42.6841697692871, 0.744979300954288, -75.7622222900391, -1.32230022758902, 218, 40, 'PPL', 'P'),
(97986, 'Seventh Street Addition Colonia', 26.1919994354248, 0.457136627828659, -98.1129989624023, -1.7123948708997, 218, 51, 'PPL', 'P'),
(38155, 'Seventy Six', 36.7863883972168, 0.642043597448873, -85.1438903808594, -1.48604122510312, 218, 21, 'PPL', 'P'),
(90692, 'Seventy-Six Estates', 36.5180587768555, 0.637360362092941, -87.2577819824219, -1.52293559358065, 218, 50, 'PPL', 'P'),
(197504, 'Seventynine (historical)', 46.148609161377, 0.805445175082047, -109.28971862793, -1.90746542863555, 218, 31, 'PPL', 'P'),
(57490, 'Seventysix', 37.7200012207031, 0.65833821515755, -89.6122207641602, -1.56402830235862, 218, 29, 'PPL', 'P'),
(504, 'Severance', 39.767219543457, 0.694068915396761, -95.2497177124023, -1.66242118567658, 218, 20, 'PPL', 'P'),
(144437, 'Severance', 43.0105590820313, 0.750675869104995, -71.3808288574219, -1.24583048636459, 218, 36, 'PPL', 'P'),
(152481, 'Severance', 43.0502815246582, 0.75136915651577, -77.7283325195313, -1.3566153245508, 218, 40, 'PPL', 'P'),
(194419, 'Severance', 40.524169921875, 0.707280191774372, -104.850563049316, -1.82998754778048, 218, 7, 'PPL', 'P'),
(51296, 'Severn', 39.1369400024414, 0.68306846219808, -76.6986083984375, -1.33864324825051, 218, 25, 'PPL', 'P'),
(68663, 'Severn', 36.5149993896484, 0.637306965713085, -77.1900024414063, -1.347219692225, 218, 33, 'PPL', 'P'),
(106122, 'Severn', 37.2941703796387, 0.650906064924438, -76.4158325195313, -1.33370787811837, 218, 53, 'PPL', 'P'),
(51297, 'Severn Crossroads', 39.0597190856934, 0.681720702949418, -76.628059387207, -1.33741193572051, 218, 25, 'PPL', 'P'),
(51298, 'Severn Forest', 39.0991706848145, 0.682409263249258, -76.6849975585938, -1.33840569428127, 218, 25, 'PPL', 'P'),
(51299, 'Severn Grove', 39.0066719055176, 0.680794854996452, -76.5336074829102, -1.33576343900575, 218, 25, 'PPL', 'P'),
(51300, 'Severn Heights', 39.0494384765625, 0.681541272470974, -76.5319366455078, -1.33573427739182, 218, 25, 'PPL', 'P'),
(51301, 'Severn Landing', 39.0444412231445, 0.681454053945274, -76.5902786254883, -1.33675253703461, 218, 25, 'PPL', 'P'),
(51302, 'Severn Lea', 39.1111106872559, 0.682617655604557, -76.7011108398438, -1.33868692409239, 218, 25, 'PPL', 'P'),
(106121, 'Severn Manor', 37.3069381713867, 0.651128904928651, -76.4711074829102, -1.33467260822326, 218, 53, 'PPL', 'P'),
(51303, 'Severn Mills', 39.1336097717285, 0.683010338707289, -76.711669921875, -1.33887121483982, 218, 25, 'PPL', 'P'),
(51304, 'Severn Mobile Trailer Park', 39.1277809143066, 0.682908605953648, -76.6872177124023, -1.33844444327513, 218, 25, 'PPL', 'P'),
(51305, 'Severn Ridge', 39.1402816772461, 0.683126785425953, -76.720832824707, -1.33903113766328, 218, 25, 'PPL', 'P'),
(51306, 'Severn Village', 39.1347198486328, 0.683029713204219, -76.7002792358398, -1.33867240986445, 218, 25, 'PPL', 'P'),
(51307, 'Severn Woods', 39.1377792358398, 0.683083109584076, -76.7008285522461, -1.33868199724437, 218, 25, 'PPL', 'P'),
(51308, 'Severna Forest', 39.0791702270508, 0.682060189409376, -76.5647201538086, -1.33630645755202, 218, 25, 'PPL', 'P'),
(51309, 'Severna Gardens', 39.0750007629395, 0.68198741853259, -76.5555572509766, -1.33614653472856, 218, 25, 'PPL', 'P'),
(51310, 'Severna Park', 39.0702781677246, 0.681904993696852, -76.5455627441406, -1.33597209767716, 218, 25, 'PPL', 'P'),
(51311, 'Severndale', 39.0819396972656, 0.682108525783161, -76.5744400024414, -1.33647610091346, 218, 25, 'PPL', 'P'),
(51312, 'Severnside', 39.0016708374023, 0.680707569891725, -76.4866714477539, -1.33494425065444, 218, 25, 'PPL', 'P'),
(51313, 'Severnsides', 39.1316719055176, 0.682976516561445, -76.6913909912109, -1.33851728073095, 218, 25, 'PPL', 'P'),
(51314, 'Severnview', 39.0411109924316, 0.681395930454483, -76.5227813720703, -1.33557448772641, 218, 25, 'PPL', 'P'),
(117730, 'Severs', 41.651668548584, 0.726958755122158, -93.2130584716797, -1.6268747761848, 218, 16, 'PPL', 'P'),
(212140, 'Seversens', 59.7536087036133, 1.04289721182639, -154.81721496582, -2.70207013992141, 218, 1, 'PPL', 'P'),
(33925, 'Severy', 37.6222190856934, 0.656631594952, -96.227783203125, -1.67949164878983, 218, 20, 'PPL', 'P'),
(152482, 'Sevey', 44.2975006103516, 0.773137236054833, -74.7172164916992, -1.30406143570556, 218, 40, 'PPL', 'P'),
(68665, 'Sevier', 35.8025016784668, 0.624871534740042, -82.0169372558594, -1.43146559751635, 218, 33, 'PPL', 'P'),
(192776, 'Sevier', 38.5863914489746, 0.673459577247992, -112.257499694824, -1.95926297973121, 218, 52, 'PPL', 'P'),
(90696, 'Sevier Home', 35.8958282470703, 0.626500390641762, -83.8727798461914, -1.46385616111638, 218, 50, 'PPL', 'P'),
(90698, 'Sevierville', 35.8680610656738, 0.626015761902394, -83.5619430541992, -1.45843103565978, 218, 50, 'PPL', 'P'),
(18040, 'Seville', 29.3166694641113, 0.511672407867624, -81.4927825927734, -1.42231737285582, 218, 12, 'PPL', 'P'),
(24750, 'Seville', 31.9602794647217, 0.557812106516924, -83.6011123657227, -1.45911466911161, 218, 13, 'PPL', 'P'),
(121419, 'Seville', 40.4855613708496, 0.706606345439555, -90.3436126708984, -1.57679349925365, 218, 18, 'PPL', 'P'),
(157584, 'Seville', 41.0099983215332, 0.715759496948103, -81.8625030517578, -1.42877021217708, 218, 41, 'PPL', 'P'),
(185074, 'Seville', 36.4858283996582, 0.636797835891689, -119.222221374512, -2.08082030452679, 218, 6, 'PPL', 'P'),
(197505, 'Seville Colony', 48.6961097717285, 0.849907448429247, -112.580558776855, -1.96490142439113, 218, 31, 'PPL', 'P'),
(97987, 'Seville Park Number 1 Colonia', 26.2689990997314, 0.45848052549374, -98.1529998779297, -1.71309301857947, 218, 51, 'PPL', 'P'),
(117731, 'Sewal', 40.6441688537598, 0.709374568234638, -93.2586135864258, -1.62766986292825, 218, 16, 'PPL', 'P'),
(18041, 'Sewalls Point', 27.1991691589355, 0.474715055630322, -80.2024993896484, -1.39979768267811, 218, 12, 'PPL', 'P'),
(90699, 'Sewanee', 35.2030601501465, 0.614409306397666, -85.9211120605469, -1.49960630243155, 218, 50, 'PPL', 'P'),
(33926, 'Seward', 38.1777801513672, 0.666327964743897, -98.7944412231445, -1.72428828201189, 218, 20, 'PPL', 'P'),
(51315, 'Seward', 38.4469413757324, 0.671025714327769, -76.0811080932617, -1.32786583479312, 218, 25, 'PPL', 'P'),
(68666, 'Seward', 36.1863899230957, 0.631571648568518, -80.3694381713867, -1.40271131406871, 218, 33, 'PPL', 'P'),
(77217, 'Seward', 35.7980613708496, 0.62479403675232, -97.4880599975586, -1.70148762833917, 218, 42, 'PPL', 'P'),
(121420, 'Seward', 42.2388916015625, 0.737207730840246, -89.357780456543, -1.55958748124092, 218, 18, 'PPL', 'P'),
(142983, 'Seward', 40.9069404602051, 0.713960797947863, -97.0986099243164, -1.69469044228896, 218, 35, 'PPL', 'P'),
(152483, 'Seward', 42.7208290100098, 0.74561912540618, -74.6091690063477, -1.30217565133767, 218, 40, 'PPL', 'P'),
(157585, 'Seward', 41.6997184753418, 0.727797384549424, -84.0363922119141, -1.46671173559522, 218, 41, 'PPL', 'P'),
(167010, 'Seward', 40.4141693115234, 0.705360318944534, -79.0202789306641, -1.37916404318439, 218, 45, 'PPL', 'P'),
(212141, 'Seward', 60.1041717529297, 1.04901569127279, -149.44221496582, -2.60825869262671, 218, 1, 'PPL', 'P'),
(97988, 'Seward Junction', 30.6536102294922, 0.535006426127653, -97.8752822875977, -1.70824593223747, 218, 51, 'PPL', 'P'),
(146287, 'Sewaren', 40.5519409179688, 0.707764887092766, -74.2591705322266, -1.2960670255873, 218, 37, 'PPL', 'P'),
(90700, 'Sewee', 35.5922203063965, 0.621201432441804, -84.6791687011719, -1.47793030168718, 218, 50, 'PPL', 'P'),
(5743, 'Sewell', 33.389720916748, 0.582760566319273, -85.3063888549805, -1.488877358506, 218, 2, 'PPL', 'P'),
(38156, 'Sewell', 37.625560760498, 0.656689918179873, -83.3888931274414, -1.45541074466752, 218, 21, 'PPL', 'P'),
(71377, 'Sewell', 39.7663917541504, 0.694054467747848, -75.1447219848633, -1.31152281413163, 218, 37, 'PPL', 'P'),
(111342, 'Sewell', 37.9972190856934, 0.663176579646979, -81.021110534668, -1.41408514245222, 218, 58, 'PPL', 'P'),
(57491, 'Sewell Ford', 38.1886100769043, 0.666516982602265, -91.5638885498047, -1.59809133112323, 218, 29, 'PPL', 'P'),
(623, 'Sewell Mills', 38.9963912963867, 0.680615424518008, -75.7794418334961, -1.32260076531804, 218, 25, 'PPL', 'P'),
(38157, 'Sewell Shop', 38.0305595397949, 0.663758480345161, -84.0274963378906, -1.46655647330367, 218, 21, 'PPL', 'P'),
(106123, 'Sewells Gardens', 36.8963890075684, 0.643963470278711, -76.2455596923828, -1.33073605665795, 218, 53, 'PPL', 'P'),
(51316, 'Sewells Orchard', 39.1958312988281, 0.684096309220796, -76.8274993896484, -1.3408928204233, 218, 25, 'PPL', 'P'),
(157586, 'Sewellsville', 40.0980606079102, 0.699843181272271, -81.2133331298828, -1.41744005963545, 218, 41, 'PPL', 'P'),
(38158, 'Sewellton', 36.9361114501953, 0.644656757689486, -85.1050033569336, -1.48536251849932, 218, 21, 'PPL', 'P'),
(167012, 'Sewickley', 40.5363883972168, 0.70749344439866, -80.1847229003906, -1.39948742441111, 218, 45, 'PPL', 'P'),
(167013, 'Sewickley Heights', 40.5566711425781, 0.707847445086559, -80.163330078125, -1.39911404922628, 218, 45, 'PPL', 'P'),
(167015, 'Sewickley Hills', 40.5816688537598, 0.708283737452141, -80.1369400024414, -1.39865345551576, 218, 45, 'PPL', 'P'),
(28569, 'Sexson Corner', 39.3894386291504, 0.687475394590916, -88.5180587768555, -1.54493157312999, 218, 18, 'PPL', 'P'),
(68669, 'Sexton', 35.7975006103516, 0.624784249635314, -82.6144409179688, -1.44189400371288, 218, 33, 'PPL', 'P'),
(90701, 'Sexton', 35.0441703796387, 0.611636156754566, -87.2013931274414, -1.52195142239981, 218, 50, 'PPL', 'P'),
(97989, 'Sexton', 31.562780380249, 0.550874438719213, -93.9108276367188, -1.63905314553363, 218, 51, 'PPL', 'P'),
(112322, 'Sexton', 39.7000007629395, 0.692895726357554, -85.4347229003906, -1.49111721014082, 218, 19, 'PPL', 'P'),
(117732, 'Sexton', 43.0827789306641, 0.75193634324893, -94.0888900756836, -1.6421609213677, 218, 16, 'PPL', 'P'),
(11862, 'Sexton (historical)', 35.9152793884277, 0.626839877101719, -94.5066680908203, -1.64945252327428, 218, 4, 'PPL', 'P'),
(106125, 'Sexton (historical)', 37.0527801513672, 0.64669301065896, -76.9236068725586, -1.34257021243589, 218, 53, 'PPL', 'P'),
(97990, 'Sexton City', 32.29296875, 0.563618629931138, -94.9251327514648, -1.65675610940577, 218, 51, 'PPL', 'P'),
(106124, 'Sexton Hill', 38.0152816772461, 0.663491831341017, -76.7944412231445, -1.34031584657313, 218, 53, 'PPL', 'P'),
(38160, 'Sextons Creek', 37.314998626709, 0.651269586413234, -83.7838897705078, -1.46230473662336, 218, 21, 'PPL', 'P'),
(176326, 'Sextonville', 43.2783317565918, 0.755349383922948, -90.2908325195313, -1.57587231183259, 218, 57, 'PPL', 'P'),
(57492, 'Seybert', 37.5186080932617, 0.654823241992809, -93.7736129760742, -1.63665829792337, 218, 29, 'PPL', 'P'),
(123645, 'Seyberts', 41.7002792358398, 0.72780717166643, -85.5133285522461, -1.49248913757637, 218, 19, 'PPL', 'P'),
(113345, 'Seyfert', 40.288330078125, 0.703164009993546, -75.8838882446289, -1.32442369908419, 218, 45, 'PPL', 'P'),
(97991, 'Seymore', 32.9908294677734, 0.575798597176615, -95.5952835083008, -1.66845244659728, 218, 51, 'PPL', 'P'),
(74258, 'Seymoreville (historical)', 39.3444404602051, 0.686690028385452, -82.9472198486328, -1.44770209173424, 218, 41, 'PPL', 'P'),
(5745, 'Seymour', 33.1144409179688, 0.577956023975688, -87.0250015258789, -1.51887280817968, 218, 2, 'PPL', 'P'),
(31101, 'Seymour', 38.959171295166, 0.679965812949111, -85.8902816772461, -1.4990682107333, 218, 19, 'PPL', 'P'),
(38159, 'Seymour', 37.165828704834, 0.648666080131573, -85.8033294677734, -1.49755060838612, 218, 21, 'PPL', 'P'),
(57493, 'Seymour', 37.1463890075684, 0.648326793408697, -92.7686080932617, -1.61911765371968, 218, 29, 'PPL', 'P'),
(90702, 'Seymour', 35.8905601501465, 0.626408445005127, -83.7247161865234, -1.46127196275262, 218, 50, 'PPL', 'P'),
(97992, 'Seymour', 33.5941696166992, 0.586328869284843, -99.2600021362305, -1.73241385281383, 218, 51, 'PPL', 'P'),
(111343, 'Seymour', 39.5924987792969, 0.691019462790566, -78.8172225952148, -1.37562004156377, 218, 58, 'PPL', 'P'),
(114044, 'Seymour', 41.396671295166, 0.722508213466472, -73.0763931274414, -1.27542366555561, 218, 8, 'PPL', 'P'),
(117733, 'Seymour', 40.6824989318848, 0.710043554300466, -93.1208267211914, -1.62526502846391, 218, 16, 'PPL', 'P'),
(121423, 'Seymour', 40.1069412231445, 0.699998177247714, -88.4266662597656, -1.54333647279509, 218, 18, 'PPL', 'P'),
(176328, 'Seymour', 44.5149993896484, 0.776933305872631, -88.3302764892578, -1.54165415393449, 218, 57, 'PPL', 'P'),
(90703, 'Seymour Heights', 35.8772201538086, 0.626175618146826, -83.7619400024414, -1.46192164090055, 218, 50, 'PPL', 'P'),
(24751, 'Seymours Store', 34.1472206115723, 0.595981430076808, -83.0391693115234, -1.44930691260712, 218, 13, 'PPL', 'P'),
(43008, 'Seymourville', 30.2772197723389, 0.528437173377241, -91.2236099243164, -1.5921523487343, 218, 22, 'PPL', 'P'),
(111344, 'Seymourville', 39.0569381713867, 0.681672166838552, -79.1091690063477, -1.38071546767742, 218, 58, 'PPL', 'P'),
(167019, 'Seyoc', 40.2986106872559, 0.70334344047199, -77.6497192382813, -1.35524326395719, 218, 45, 'PPL', 'P'),
(11863, 'Seyppel', 34.8997192382813, 0.609115008729615, -90.2969436645508, -1.57597897143425, 218, 4, 'PPL', 'P'),
(97710, 'SH 88-14 North-6 West Colonia', 26.2630004882813, 0.458375829973386, -97.9990005493164, -1.7104052232493, 218, 51, 'PPL', 'P'),
(97711, 'SH 88-15 North-4 West Colonia', 26.2719993591309, 0.458532889898674, -97.9800033569336, -1.71007365969359, 218, 51, 'PPL', 'P'),
(123646, 'Sha-Get Acres', 41.5750007629395, 0.725620649832448, -85.1805572509766, -1.48668118271307, 218, 19, 'PPL', 'P'),
(138043, 'Sha-Sha Resort', 48.5963897705078, 0.848167006077853, -93.1602783203125, -1.62595358876375, 218, 28, 'PPL', 'P'),
(77219, 'Sha-To-She', 36.2130584716797, 0.632037102548036, -96.2769393920898, -1.680349586135, 218, 42, 'PPL', 'P'),
(121424, 'Shabbona', 41.7680587768555, 0.728990147822643, -88.8769378662109, -1.5511951948558, 218, 18, 'PPL', 'P'),
(133058, 'Shabbona', 43.5313911437988, 0.75976610343279, -83.0541687011719, -1.44956870134227, 218, 27, 'PPL', 'P'),
(121425, 'Shabbona Grove', 41.7324981689453, 0.7283694981306, -88.8555603027344, -1.55082208598708, 218, 18, 'PPL', 'P'),
(24752, 'Shack (historical)', 32.3600006103516, 0.564788556598009, -84.956672668457, -1.48277365960365, 218, 13, 'PPL', 'P'),
(106126, 'Shack Mills', 37.1944389343262, 0.649165422835963, -81.9538879394531, -1.43036517935393, 218, 53, 'PPL', 'P'),
(185075, 'Shackelford', 37.6138916015625, 0.656486252935509, -120.991668701172, -2.11170298631762, 218, 6, 'PPL', 'P'),
(24753, 'Shackelton (historical)', 34.4361114501953, 0.601023526389628, -85.279167175293, -1.48840225056753, 218, 13, 'PPL', 'P'),
(90705, 'Shackle Island', 36.3705596923828, 0.634786017425216, -86.6166687011719, -1.51174605594457, 218, 50, 'PPL', 'P'),
(57495, 'Shackleford', 39.1124992370605, 0.682641890370477, -93.2966690063477, -1.62833405530411, 218, 29, 'PPL', 'P'),
(61716, 'Shackleford', 33.1472206115723, 0.578528137556865, -90.2363891601563, -1.57492209595565, 218, 30, 'PPL', 'P'),
(57494, 'Shackleford Crossing', 38.8919410705566, 0.678792424172822, -93.033332824707, -1.62373797189485, 218, 29, 'PPL', 'P'),
(193941, 'Shackleford Place', 40.1269416809082, 0.700347251087596, -122.733329772949, -2.14210070647395, 218, 6, 'PPL', 'P'),
(106127, 'Shacklefords', 37.5513916015625, 0.655395422153012, -76.7324981689453, -1.33923473632862, 218, 53, 'PPL', 'P'),
(106128, 'Shacklefords Fork', 37.5438919067383, 0.655264527785435, -76.7038879394531, -1.33873539362423, 218, 53, 'PPL', 'P'),
(5746, 'Shacklesville', 31.7786102294922, 0.554641380212589, -86.815559387207, -1.51521735326743, 218, 2, 'PPL', 'P'),
(106129, 'Shacklet (historical)', 38.5319404602051, 0.672509228212998, -77.4466705322266, -1.35169939549462, 218, 53, 'PPL', 'P'),
(74259, 'Shackleton', 39.1755599975586, 0.683742508269979, -83.6780624389648, -1.46045770124933, 218, 41, 'PPL', 'P'),
(90704, 'Shacklett', 36.1247215270996, 0.630495332013962, -87.0980606079102, -1.52014792970961, 218, 50, 'PPL', 'P'),
(152485, 'Shackport', 42.3866691589355, 0.739786935776961, -74.9250030517578, -1.30768799531997, 218, 40, 'PPL', 'P'),
(146288, 'Shacks Corner', 40.2269401550293, 0.702092553707979, -74.1949996948242, -1.29494703319087, 218, 37, 'PPL', 'P'),
(68668, 'Shacktown', 36.1166687011719, 0.630354783687433, -80.5938873291016, -1.40662869087416, 218, 33, 'PPL', 'P'),
(111345, 'Shad (historical)', 38.6483306884766, 0.674540620913483, -81.3705596923828, -1.42018418082266, 218, 58, 'PPL', 'P'),
(106132, 'Shad Landing', 37.9394416809082, 0.66216817370022, -75.67138671875, -1.3207148477921, 218, 53, 'PPL', 'P'),
(83570, 'Shad Moss village', 33.5625, 0.585776130200597, -80.2055587768555, -1.39985107905796, 218, 48, 'PPL', 'P'),
(51317, 'Shad Point', 38.3397216796875, 0.669154377608798, -75.6324996948242, -1.32003614118829, 218, 25, 'PPL', 'P'),
(90706, 'Shaddon Mill', 35.6055603027344, 0.621434259300104, -84.1708297729492, -1.46905811367363, 218, 50, 'PPL', 'P'),
(685, 'Shade', 36.1755599975586, 0.631382630710149, -89.7666702270508, -1.566723954014, 218, 29, 'PPL', 'P'),
(38161, 'Shade', 37.6416702270508, 0.656971081411958, -83.8647232055664, -1.46371554621083, 218, 21, 'PPL', 'P'),
(74260, 'Shade', 39.225830078125, 0.684619886691106, -82.0386123657227, -1.43184389954919, 218, 41, 'PPL', 'P'),
(167023, 'Shade Gap', 40.1808280944824, 0.701287746426557, -77.8661117553711, -1.35902002585709, 218, 45, 'PPL', 'P'),
(74261, 'Shade River', 39.0683288574219, 0.681870971813926, -81.8144378662109, -1.4279313164337, 218, 41, 'PPL', 'P'),
(202606, 'Shadehill', 45.7655601501465, 0.798759708639567, -102.178886413574, -1.78335799393817, 218, 49, 'PPL', 'P'),
(38162, 'Shadeland', 38.0122184753418, 0.663438368382133, -84.4974975585938, -1.47475954209333, 218, 21, 'PPL', 'P'),
(106130, 'Shadeland', 37.2897186279297, 0.650828367199635, -79.9499969482422, -1.39539068370624, 218, 53, 'PPL', 'P'),
(123648, 'Shadeland', 40.3736114501953, 0.704652450726791, -86.9488906860352, -1.51754442342794, 218, 19, 'PPL', 'P'),
(167022, 'Shadeland', 41.815559387207, 0.729819189869985, -80.3763885498047, -1.40283262105636, 218, 45, 'PPL', 'P'),
(74262, 'Shademoore', 39.1380615234375, 0.683088036432092, -84.3683319091797, -1.47250517623058, 218, 41, 'PPL', 'P'),
(5748, 'Shades Cliff', 33.4311103820801, 0.583482948764957, -86.8269424438477, -1.51541602508475, 218, 2, 'PPL', 'P'),
(167024, 'Shades Glen', 41.1766700744629, 0.718668467806796, -75.684440612793, -1.32094268122335, 218, 45, 'PPL', 'P'),
(5749, 'Shades Run', 33.3347206115723, 0.581800629904354, -86.8769378662109, -1.51628860981592, 218, 2, 'PPL', 'P'),
(68671, 'Shadetown', 35.3474998474121, 0.616930254685535, -77.8027801513672, -1.35791468084665, 218, 33, 'PPL', 'P'),
(18043, 'Shadeville', 30.1991691589355, 0.527074933190152, -84.3088912963867, -1.47146774182794, 218, 12, 'PPL', 'P'),
(74263, 'Shadeville', 39.832218170166, 0.695203355442108, -83.0033264160156, -1.44868133606706, 218, 41, 'PPL', 'P'),
(152486, 'Shadigee', 43.375, 0.75703656305254, -78.3891677856445, -1.36814907575777, 218, 40, 'PPL', 'P'),
(167025, 'Shadle', 40.7058296203613, 0.710450751631139, -76.9925003051758, -1.34377262966806, 218, 45, 'PPL', 'P'),
(167027, 'Shado-Wood Village', 40.6091690063477, 0.708763705659601, -79.2016677856445, -1.38232987593022, 218, 45, 'PPL', 'P'),
(106137, 'Shadow', 37.3491706848145, 0.651866001339357, -76.2969436645508, -1.33163287615504, 218, 53, 'PPL', 'P'),
(208708, 'Shadow', 48.1472206115723, 0.840327525356014, -123.856391906738, -2.16170183841304, 218, 56, 'PPL', 'P'),
(83572, 'Shadow Brook', 34.0633316040039, 0.594517290688509, -81.1463928222656, -1.41627173086523, 218, 48, 'PPL', 'P'),
(179127, 'Shadow Canyon', 33.6530609130859, 0.587356716307559, -112.121109008789, -1.95688251319084, 218, 5, 'PPL', 'P'),
(179128, 'Shadow Hills', 33.6308288574219, 0.586968693736734, -112.177223205566, -1.95786189068172, 218, 5, 'PPL', 'P'),
(185077, 'Shadow Hills', 34.2619400024414, 0.597983661163357, -118.350830078125, -2.06561165733162, 218, 6, 'PPL', 'P'),
(205711, 'Shadow Hills East', 40.6113891601563, 0.708802454653461, -111.856666564941, -1.95226712186368, 218, 52, 'PPL', 'P'),
(121427, 'Shadow Lawn', 41.1597213745117, 0.718372657188716, -87.5716705322266, -1.52841398225905, 218, 18, 'PPL', 'P'),
(18044, 'Shadow Lawn Estates', 29.6838893890381, 0.518081604636523, -82.376106262207, -1.43773427924823, 218, 12, 'PPL', 'P'),
(24755, 'Shadow Moss', 33.9291687011719, 0.592175706300057, -83.3138885498047, -1.4541016678337, 218, 13, 'PPL', 'P'),
(179129, 'Shadow Mountain', 33.6055603027344, 0.586527674260217, -112.019439697266, -1.95510804895653, 218, 5, 'PPL', 'P'),
(205701, 'Shadow Mountain', 40.6661109924316, 0.709757530799391, -111.809722900391, -1.95144780035432, 218, 52, 'PPL', 'P'),
(193942, 'Shadow Mountain Mobile Home Park', 41.2755584716797, 0.720394395930249, -122.298057556152, -2.13450377314839, 218, 6, 'PPL', 'P'),
(179130, 'Shadow Mountain Village Scottsdale', 33.4533309936523, 0.5838707715987, -111.897216796875, -1.95297485692337, 218, 5, 'PPL', 'P'),
(11864, 'Shadow Oaks Addition', 34.9555587768555, 0.61008959253053, -91.9475021362305, -1.60478665126174, 218, 4, 'PPL', 'P'),
(43009, 'Shadow Pine Estates', 32.3375015258789, 0.564395873495277, -93.6944427490234, -1.63527651679179, 218, 22, 'PPL', 'P'),
(185076, 'Shadow Ridge Creek', 33.8105583190918, 0.590105564605711, -116.36888885498, -2.03102025740674, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(179131, 'Shadow Ridge II', 33.6238899230957, 0.586847586486163, -111.973609924316, -1.95430816852312, 218, 5, 'PPL', 'P'),
(205704, 'Shadow Run Estates', 40.7055587768555, 0.710446024520204, -112.078887939453, -1.95614561651722, 218, 52, 'PPL', 'P'),
(167026, 'Shadow Shuttle', 40.4524993896484, 0.706029305010362, -79.8199996948242, -1.39312180361555, 218, 45, 'PPL', 'P'),
(83573, 'Shadow Wood', 34.5694389343262, 0.603350529971111, -82.8241729736328, -1.4455545186312, 218, 48, 'PPL', 'P'),
(90707, 'Shadow Wood', 36.0116691589355, 0.628522195962322, -84.0397186279297, -1.46676979250698, 218, 50, 'PPL', 'P'),
(24756, 'Shadowbrook', 34.084171295166, 0.594881011914387, -84.595832824707, -1.47647581625783, 218, 13, 'PPL', 'P'),
(90708, 'Shadowbrook', 35.9166717529297, 0.626864178446666, -86.522216796875, -1.51009755922981, 218, 50, 'PPL', 'P'),
(106134, 'Shadowbrook Heights', 37.2588882446289, 0.650290275501385, -77.4361114501953, -1.35151510474719, 218, 53, 'PPL', 'P'),
(24757, 'Shadowland', 30.7458305358887, 0.53661597411147, -81.5875015258789, -1.42397053010248, 218, 13, 'PPL', 'P'),
(97994, 'Shadowland', 33.5186080932617, 0.585010071913036, -95.2822189331055, -1.66298843898877, 218, 51, 'PPL', 'P'),
(24758, 'Shadowmoor', 33.5133285522461, 0.584917926539319, -82.1388931274414, -1.43359412901759, 218, 13, 'PPL', 'P'),
(83575, 'Shadowmoss', 32.8436088562012, 0.573229112777879, -80.0652770996094, -1.3974027019098, 218, 48, 'PPL', 'P'),
(5751, 'Shadowood', 33.0402793884277, 0.576661661106882, -87.7519378662109, -1.53156024077087, 218, 2, 'PPL', 'P'),
(24760, 'Shadowood', 33.3925018310547, 0.58280910243014, -84.5566711425781, -1.47579231596406, 218, 13, 'PPL', 'P'),
(201550, 'Shadowood', 45.3788909912109, 0.792011058700224, -122.693328857422, -2.14140255879418, 218, 43, 'PPL', 'P'),
(24761, 'Shadowood Mobile Home Park', 34.1027793884277, 0.595205784409322, -84.585563659668, -1.47629658551647, 218, 13, 'PPL', 'P'),
(24762, 'Shadowwood', 33.9000015258789, 0.591666643057689, -84.4541702270508, -1.4740033375018, 218, 13, 'PPL', 'P'),
(90710, 'Shadrick Hill', 35.2677803039551, 0.615538886174023, -85.7027816772461, -1.49579571838581, 218, 50, 'PPL', 'P'),
(90711, 'Shadtown', 36.2294387817383, 0.632322992891056, -82.3191680908203, -1.43674052068747, 218, 50, 'PPL', 'P'),
(106136, 'Shadwell', 38.0127792358398, 0.663448155499139, -78.3958282470703, -1.36826532273935, 218, 53, 'PPL', 'P'),
(106139, 'Shadwell Estates', 38.0111083984375, 0.663418993885203, -78.3936080932617, -1.36822657374549, 218, 53, 'PPL', 'P'),
(106138, 'Shadwell Mountain', 38.0286102294922, 0.663724458462235, -78.4127807617188, -1.36856119993646, 218, 53, 'PPL', 'P'),
(83576, 'Shadwick', 34.6319389343262, 0.604441360753608, -82.9236068725586, -1.44728996755555, 218, 48, 'PPL', 'P'),
(11865, 'Shady', 34.4497184753418, 0.601261013779835, -94.120002746582, -1.64270393991396, 218, 4, 'PPL', 'P'),
(18045, 'Shady', 29.0952796936035, 0.507808427442028, -82.1691665649414, -1.43412250017787, 218, 12, 'PPL', 'P'),
(43011, 'Shady', 32.1875, 0.561777852985675, -92.8597183227539, -1.62070782720656, 218, 22, 'PPL', 'P'),
(152487, 'Shady', 42.0663909912109, 0.734197027227912, -74.1597213745117, -1.29433131034684, 218, 40, 'PPL', 'P'),
(138044, 'Shady Acre Mobile Home Park', 43.6949996948242, 0.7626216113326, -92.3905563354492, -1.6125194058029, 218, 28, 'PPL', 'P'),
(5752, 'Shady Acres', 33.6500015258789, 0.587303319927703, -86.4533309936523, -1.50889527515569, 218, 2, 'PPL', 'P'),
(24764, 'Shady Acres', 31.2402801513672, 0.54524574788679, -81.5455627441406, -1.42323856027688, 218, 13, 'PPL', 'P'),
(28570, 'Shady Acres', 39.8472213745117, 0.69546521075629, -90.554443359375, -1.58047318893181, 218, 18, 'PPL', 'P'),
(51318, 'Shady Acres', 38.6180610656738, 0.674012316332238, -77.0166702270508, -1.34419447438472, 218, 25, 'PPL', 'P'),
(83577, 'Shady Acres', 34.101390838623, 0.595181549643402, -81.3652801513672, -1.42009203544895, 218, 48, 'PPL', 'P'),
(90713, 'Shady Acres', 35.3030586242676, 0.616154609018049, -85.081672668457, -1.48495532116865, 218, 50, 'PPL', 'P'),
(167028, 'Shady Acres', 40.791389465332, 0.711944052633373, -76.4649963378906, -1.3345659486216, 218, 45, 'PPL', 'P'),
(97995, 'Shady Acres Colonia', 28.0279998779297, 0.489180880618442, -97.8430023193359, -1.70768254050886, 218, 51, 'PPL', 'P'),
(14583, 'Shady Acres Mobile Home Park', 38.5625, 0.673042592800313, -75.5580596923828, -1.31873691805049, 218, 10, 'PPL', 'P'),
(5756, 'Shady Acres Trailer Park', 33.5208282470703, 0.585048820906896, -86.6575012207031, -1.51245871785227, 218, 2, 'PPL', 'P'),
(68672, 'Shady Banks', 35.4947204589844, 0.61949973908427, -76.9897232055664, -1.34372416013622, 218, 33, 'PPL', 'P'),
(123649, 'Shady Banks', 41.392219543457, 0.722430515741669, -85.8302764892578, -1.49802092263463, 218, 19, 'PPL', 'P'),
(121428, 'Shady Beach', 41.538890838623, 0.724990412760481, -90.1966705322266, -1.5742288751239, 218, 18, 'PPL', 'P'),
(171278, 'Shady Beach', 45.4036102294922, 0.792442490796817, -96.6316680908203, -1.68654076987916, 218, 49, 'PPL', 'P'),
(33927, 'Shady Bend', 39.0183296203613, 0.680998320503734, -98.0213928222656, -1.71079604213927, 218, 20, 'PPL', 'P'),
(157588, 'Shady Bend', 40.2677803039551, 0.702805348773739, -81.6405563354492, -1.42489651121351, 218, 41, 'PPL', 'P'),
(51319, 'Shady Bower', 39.6588897705078, 0.69217820418086, -77.897216796875, -1.3595629112453, 218, 25, 'PPL', 'P'),
(5757, 'Shady Brook', 33.3663902282715, 0.5823533689886, -86.9702835083008, -1.51791779861277, 218, 2, 'PPL', 'P'),
(33928, 'Shady Brook', 38.7394409179688, 0.676130794400369, -96.982780456543, -1.69266883670548, 218, 20, 'PPL', 'P'),
(68673, 'Shady Brook', 35.4786109924316, 0.619218575852185, -80.6436080932617, -1.40749648191536, 218, 33, 'PPL', 'P'),
(111346, 'Shady Brook', 39.0505599975586, 0.681560846704986, -80.4691696166992, -1.40445195615718, 218, 58, 'PPL', 'P'),
(189552, 'Shady Brook', 36.3699989318848, 0.63477623030821, -105.467216491699, -1.84075018069381, 218, 38, 'PPL', 'P'),
(205708, 'Shady Brook Estates', 40.6430587768555, 0.709355193737707, -111.812782287598, -1.95150119673418, 218, 52, 'PPL', 'P'),
(152488, 'Shady Corner Curve', 44.2172203063965, 0.771736080426315, -73.9313888549805, -1.29034615609165, 218, 40, 'PPL', 'P'),
(201551, 'Shady Cove', 42.6108283996582, 0.743699252576342, -122.811393737793, -2.14346317968763, 218, 43, 'PPL', 'P'),
(83578, 'Shady Creek', 34.8972206115723, 0.609071399466765, -82.3574981689453, -1.4374095067533, 218, 48, 'PPL', 'P'),
(24765, 'Shady Dale', 33.4005584716797, 0.582949717335696, -83.5902786254883, -1.45892558467421, 218, 13, 'PPL', 'P'),
(51320, 'Shady Dale', 38.4555587768555, 0.671176116350331, -76.7133331298828, -1.3389002432957, 218, 25, 'PPL', 'P'),
(57500, 'Shady Dell', 36.7677803039551, 0.641718824953938, -90.4419403076172, -1.57850964026009, 218, 29, 'PPL', 'P'),
(176334, 'Shady Dell', 42.9588890075684, 0.749774056180867, -90.7911071777344, -1.58460375178252, 218, 57, 'PPL', 'P'),
(185079, 'Shady Dell', 32.9727783203125, 0.575483545219659, -116.916107177734, -2.04057101886604, 218, 6, 'PPL', 'P'),
(201552, 'Shady Dell', 45.1433296203613, 0.787899737188387, -122.537780761719, -2.13868773237896, 218, 43, 'PPL', 'P'),
(61720, 'Shady Dell (historical)', 32.1583290100098, 0.561268723164279, -89.9436111450195, -1.56981215561406, 218, 30, 'PPL', 'P'),
(14584, 'Shady Dell Mobile Home Park', 38.5208282470703, 0.672315283506613, -75.1041717529297, -1.31081507907194, 218, 10, 'PPL', 'P'),
(142985, 'Shady Elm Mobile Home Park', 40.8561096191406, 0.71307363240973, -96.6922225952148, -1.68759764535776, 218, 35, 'PPL', 'P'),
(142986, 'Shady Elm Trailer Court', 42.4799995422363, 0.741415858257708, -96.397216796875, -1.68244882286425, 218, 35, 'PPL', 'P'),
(68674, 'Shady Forest', 33.8877792358398, 0.591453323854373, -78.5505599975586, -1.37096590124275, 218, 33, 'PPL', 'P'),
(157589, 'Shady Glen', 40.4799995422363, 0.706509273217821, -80.6399993896484, -1.40743349815558, 218, 41, 'PPL', 'P'),
(185078, 'Shady Glen', 39.1180610656738, 0.68273896259221, -120.948608398438, -2.110951442258, 218, 6, 'PPL', 'P'),
(5765, 'Shady Grove', 31.6308307647705, 0.552062141986361, -88.3913879394531, -1.54272074995106, 218, 2, 'PPL', 'P'),
(11876, 'Shady Grove', 35.0527801513672, 0.611786425619074, -91.2750015258789, -1.59304930138944, 218, 4, 'PPL', 'P'),
(14585, 'Shady Grove', 38.725830078125, 0.675893240431134, -75.1224975585938, -1.31113492471886, 218, 10, 'PPL', 'P'),
(18047, 'Shady Grove', 30.2877807617188, 0.528621497414188, -83.6319427490234, -1.45965276080986, 218, 12, 'PPL', 'P'),
(24769, 'Shady Grove', 32.1855583190918, 0.561743964260804, -84.6980590820313, -1.47826000103013, 218, 13, 'PPL', 'P'),
(28571, 'Shady Grove', 37.1238899230957, 0.647934110305964, -88.5658264160156, -1.54576527570924, 218, 18, 'PPL', 'P'),
(38166, 'Shady Grove', 37.336669921875, 0.651647821867053, -87.8791732788086, -1.53378091764583, 218, 21, 'PPL', 'P'),
(43013, 'Shady Grove', 31.961109161377, 0.557826587455352, -91.4247207641602, -1.59566239505102, 218, 22, 'PPL', 'P'),
(51321, 'Shady Grove', 39.5224990844727, 0.689797737640492, -77.5466690063477, -1.35344469811501, 218, 25, 'PPL', 'P'),
(57499, 'Shady Grove', 37.8586082458496, 0.660757364112751, -92.2777786254883, -1.61055106344122, 218, 29, 'PPL', 'P'),
(61728, 'Shady Grove', 33.5188903808594, 0.585014998761052, -89.341667175293, -1.5593062514298, 218, 30, 'PPL', 'P'),
(68676, 'Shady Grove', 36.2416687011719, 0.632536445252426, -80.5236129760742, -1.40540217203413, 218, 33, 'PPL', 'P'),
(74264, 'Shady Grove', 39.7033309936523, 0.692953849848345, -83.642219543457, -1.45983212470927, 218, 41, 'PPL', 'P'),
(77223, 'Shady Grove', 35.3905601501465, 0.617681798745155, -94.5130615234375, -1.64956410972395, 218, 42, 'PPL', 'P'),
(79110, 'Shady Grove', 39.7777786254883, 0.694253206144195, -77.6688919067383, -1.35557789014816, 218, 45, 'PPL', 'P'),
(83579, 'Shady Grove', 33.8888893127441, 0.591472698351304, -80.3902816772461, -1.40307510187361, 218, 48, 'PPL', 'P'),
(90730, 'Shady Grove', 35.9080581665039, 0.626713843003131, -85.5769424438477, -1.49359940943482, 218, 50, 'PPL', 'P'),
(98008, 'Shady Grove', 32.6813888549805, 0.570397839643989, -95.1324996948242, -1.66037534532718, 218, 51, 'PPL', 'P'),
(106145, 'Shady Grove', 36.7236099243164, 0.640947906397387, -81.9697189331055, -1.43064148231702, 218, 53, 'PPL', 'P'),
(111350, 'Shady Grove', 39.6375007629395, 0.691804895575058, -78.1513900756836, -1.3639990718311, 218, 58, 'PPL', 'P'),
(117734, 'Shady Grove', 42.3805618286133, 0.739680342754331, -92.0547180175781, -1.60665792140169, 218, 16, 'PPL', 'P'),
(5766, 'Shady Grove (historical)', 34.7333297729492, 0.606210964718938, -87.4416732788086, -1.52614510216836, 218, 2, 'PPL', 'P'),
(83580, 'Shady Grove (historical)', 34.5722198486328, 0.603399066081978, -81.663330078125, -1.4252939880062, 218, 48, 'PPL', 'P'),
(90731, 'Shady Grove (historical)', 35.1319389343262, 0.61316800701358, -87.2805633544922, -1.5233332035314, 218, 50, 'PPL', 'P'),
(106146, 'Shady Grove Corner', 38.2216682434082, 0.667093956452431, -77.7113876342773, -1.35631958051175, 218, 53, 'PPL', 'P'),
(11877, 'Shady Grove Estates', 34.9797210693359, 0.610511304089144, -91.9652786254883, -1.60509690952874, 218, 4, 'PPL', 'P'),
(24770, 'Shady Grove Estates', 33.5091705322266, 0.584845355399614, -82.1508331298828, -1.43380252137289, 218, 13, 'PPL', 'P'),
(117735, 'Shady Grove Mobile Home Park', 42.0125007629395, 0.733256465309923, -93.5694427490234, -1.63309485522679, 218, 16, 'PPL', 'P'),
(90732, 'Shady Grove Shores', 35.2541694641113, 0.615301332204788, -85.1197204589844, -1.48561938038646, 218, 50, 'PPL', 'P'),
(169596, 'Shady Harbor', 41.3486099243164, 0.721669384302125, -71.7213897705078, -1.25177439560154, 218, 47, 'PPL', 'P'),
(106147, 'Shady Harbor Shores', 38.042781829834, 0.663971799548476, -76.5672225952148, -1.3363501333939, 218, 53, 'PPL', 'P'),
(5768, 'Shady Heights', 31.2119407653809, 0.544751132293335, -85.3819427490234, -1.49019602271976, 218, 2, 'PPL', 'P'),
(51322, 'Shady Hill', 38.6213912963867, 0.674070439823029, -76.6433334350586, -1.33767851814563, 218, 25, 'PPL', 'P'),
(90733, 'Shady Hill', 35.5666694641113, 0.62075548611727, -88.3202819824219, -1.54147971688309, 218, 50, 'PPL', 'P'),
(51323, 'Shady Hill Farm', 38.6163902282715, 0.673983154718302, -76.6527786254883, -1.3378433678171, 218, 25, 'PPL', 'P'),
(18048, 'Shady Hills', 28.4097194671631, 0.495843144269925, -82.5430603027344, -1.44064817695494, 218, 12, 'PPL', 'P'),
(123650, 'Shady Hills', 40.5894393920898, 0.708419358930653, -85.6741714477539, -1.49529637568142, 218, 19, 'PPL', 'P'),
(98009, 'Shady Hollow', 30.1647205352783, 0.526473691284553, -97.8619384765625, -1.70801303880014, 218, 51, 'PPL', 'P'),
(68678, 'Shady Knoll Mobile Estates', 35.6269416809082, 0.621807434747851, -77.3472213745117, -1.34996368025416, 218, 33, 'PPL', 'P'),
(5769, 'Shady Lane', 34.7563896179199, 0.606613434938677, -86.6205596923828, -1.51181396655237, 218, 2, 'PPL', 'P'),
(14586, 'Shady Lane', 39.1188888549805, 0.682753410241124, -75.5180587768555, -1.31803877037073, 218, 10, 'PPL', 'P'),
(24771, 'Shady Lane', 34.3686103820801, 0.599845410502404, -83.8361129760742, -1.46321620350644, 218, 13, 'PPL', 'P'),
(31102, 'Shady Lane', 39.5455589294434, 0.690200207860231, -87.1336135864258, -1.52076844624359, 218, 19, 'PPL', 'P'),
(106148, 'Shady Lane', 37.7144393920898, 0.658241142935816, -79.0227813720703, -1.37920771902627, 218, 53, 'PPL', 'P'),
(197506, 'Shady Lane Mobile Home Park', 48.2236099243164, 0.841660770376735, -114.260276794434, -1.99421803430294, 218, 31, 'PPL', 'P'),
(142987, 'Shady Lane Trailer Court', 40.5727806091309, 0.708128608318644, -98.3899993896484, -1.71722944038458, 218, 35, 'PPL', 'P'),
(123651, 'Shady Lawn', 41.3930587768555, 0.722445163127665, -87.3547210693359, -1.52462749982117, 218, 19, 'PPL', 'P'),
(146289, 'Shady Lawn Manor', 40.7719383239746, 0.711604566173415, -74.436393737793, -1.29916015403538, 218, 37, 'PPL', 'P'),
(123652, 'Shady Nook', 41.5566711425781, 0.725300737606502, -85.2333297729492, -1.48760223697607, 218, 19, 'PPL', 'P'),
(128789, 'Shady Nook', 43.6133308410645, 0.761196220938162, -70.9258270263672, -1.23788920631009, 218, 26, 'PPL', 'P'),
(61729, 'Shady Oak', 31.6936092376709, 0.553157833037847, -89.4361114501953, -1.56095461498651, 218, 30, 'PPL', 'P'),
(117736, 'Shady Oak', 42.461669921875, 0.741095946031762, -94.1566696166992, -1.64334389752391, 218, 16, 'PPL', 'P'),
(138045, 'Shady Oak Mobile Park', 45.5819396972656, 0.795554927162793, -94.2125015258789, -1.64431834816677, 218, 28, 'PPL', 'P'),
(24772, 'Shady Oaks', 33.0116691589355, 0.576162318402493, -85.133056640625, -1.48585214066573, 218, 13, 'PPL', 'P'),
(43014, 'Shady Oaks', 31.3058300018311, 0.546389808601574, -92.3466720581055, -1.61175348067339, 218, 22, 'PPL', 'P'),
(51325, 'Shady Oaks', 39.3375015258789, 0.68656892113488, -76.394172668457, -1.33332984240164, 218, 25, 'PPL', 'P'),
(98010, 'Shady Oaks', 32.1163902282715, 0.560536753338671, -95.9022216796875, -1.67380952828803, 218, 51, 'PPL', 'P'),
(106149, 'Shady Oaks', 37.1088905334473, 0.64767232157081, -76.3919372558594, -1.33329082709167, 218, 53, 'PPL', 'P'),
(43015, 'Shady Park', 32.5569381713867, 0.56822576545892, -93.5769424438477, -1.63322574959437, 218, 22, 'PPL', 'P'),
(14587, 'Shady Park Mobile Home Park', 38.4716682434082, 0.671457279582416, -75.0969390869141, -1.31068884523627, 218, 10, 'PPL', 'P'),
(201553, 'Shady Pine', 42.3083305358887, 0.738419668873314, -121.80249786377, -2.12585462487614, 218, 43, 'PPL', 'P'),
(167029, 'Shady Plain', 40.6119384765625, 0.708812042033386, -79.4383316040039, -1.38646043878094, 218, 45, 'PPL', 'P'),
(77224, 'Shady Point', 35.1300010681152, 0.613134184867736, -94.658332824707, -1.65209957223976, 218, 42, 'PPL', 'P'),
(179132, 'Shady Ranch Trailer Lodge', 33.4833297729492, 0.584394349069009, -111.985000610352, -1.95450697349849, 218, 5, 'PPL', 'P'),
(18050, 'Shady Rest', 30.5880603790283, 0.533862365412869, -84.4869384765625, -1.4745752513459, 218, 12, 'PPL', 'P'),
(90735, 'Shady Rest', 35.7163887023926, 0.623368579778856, -85.7247161865234, -1.49617854779251, 218, 50, 'PPL', 'P'),
(114046, 'Shady Rest', 41.4497184753418, 0.723434061419438, -73.2766723632813, -1.27891919764439, 218, 8, 'PPL', 'P'),
(185081, 'Shady Rest (historical)', 35.4061088562012, 0.617953174860234, -118.330558776855, -2.0652578563808, 218, 6, 'PPL', 'P'),
(179133, 'Shady Rest Mobile Home Park', 33.4152793884277, 0.583206645801861, -111.582221984863, -1.94747716032707, 218, 5, 'PPL', 'P'),
(14588, 'Shady Rest Park', 38.7183303833008, 0.675762346063557, -75.2616729736328, -1.31356399394912, 218, 10, 'PPL', 'P'),
(14589, 'Shady Ridge', 38.7277793884277, 0.67592726231406, -75.1216735839844, -1.31112054364898, 218, 10, 'PPL', 'P'),
(172505, 'Shady Rill', 44.3441696166992, 0.773951763874233, -72.5897216796875, -1.26692964641686, 218, 55, 'PPL', 'P'),
(98011, 'Shady Shores', 33.1650009155273, 0.578838462402886, -97.029167175293, -1.69347843767687, 218, 51, 'PPL', 'P'),
(133059, 'Shady Shores', 44.4063911437988, 0.77503773438774, -83.9744415283203, -1.46563049219265, 218, 27, 'PPL', 'P'),
(14590, 'Shady Side', 38.752498626709, 0.676358694410653, -75.2022171020508, -1.31252629323037, 218, 10, 'PPL', 'P'),
(51326, 'Shady Side', 38.8416709899902, 0.677915045751695, -76.5124969482422, -1.33539499066894, 218, 25, 'PPL', 'P'),
(123653, 'Shady Side', 41.6166687011719, 0.726347892547121, -87.1430587768555, -1.52093329591507, 218, 19, 'PPL', 'P'),
(176333, 'Shady Side (historical)', 42.5647201538086, 0.742894511873947, -88.4372177124023, -1.54352063038447, 218, 57, 'PPL', 'P'),
(111347, 'Shady Spring', 37.7055587768555, 0.658086146960374, -81.0986099243164, -1.41543776196987, 218, 58, 'PPL', 'P'),
(24773, 'Shady Valley', 34.3141708374023, 0.598895261204491, -83.7708282470703, -1.46207677003405, 218, 13, 'PPL', 'P'),
(112569, 'Shady Valley', 36.5191688537598, 0.637379736589871, -81.9280624389648, -1.42991443933943, 218, 50, 'PPL', 'P'),
(157590, 'Shadybrook Trailer Park', 40.6838912963867, 0.710067855645412, -80.5533294677734, -1.40592082265642, 218, 41, 'PPL', 'P'),
(24774, 'Shadynook', 34.9055595397949, 0.609216941220338, -85.2977828979492, -1.48872715622052, 218, 13, 'PPL', 'P'),
(43016, 'Shadyside', 29.7338905334473, 0.518954289236228, -91.3902816772461, -1.59506131959299, 218, 22, 'PPL', 'P'),
(74265, 'Shadyside', 39.9708290100098, 0.697622570976336, -80.7508316040039, -1.40936788521336, 218, 41, 'PPL', 'P'),
(106150, 'Shadyside', 37.3977813720703, 0.652714417883629, -75.9124984741211, -1.32492304178858, 218, 53, 'PPL', 'P'),
(111348, 'Shadyside', 38.6511116027832, 0.67458915702435, -80.8166732788086, -1.41051703922373, 218, 58, 'PPL', 'P'),
(133060, 'Shadyside', 41.8227806091309, 0.729945223968573, -84.5363922119141, -1.47543838185519, 218, 27, 'PPL', 'P'),
(167030, 'Shadyside', 40.4513893127441, 0.706009930513432, -79.9411087036133, -1.39523555457275, 218, 45, 'PPL', 'P'),
(167031, 'Shadyside Village', 40.8188896179199, 0.712424020840833, -79.6611099243164, -1.39034865397245, 218, 45, 'PPL', 'P'),
(5772, 'Shadywood', 33.577220916748, 0.586033058666762, -86.6916732788086, -1.5130551327784, 218, 2, 'PPL', 'P'),
(18051, 'Shaefer', 26.9069404602051, 0.469614702668657, -82.3255615234375, -1.43685210713714, 218, 12, 'PPL', 'P'),
(111349, 'Shafer', 39.2191696166992, 0.684503639709524, -79.5680618286133, -1.38872465833972, 218, 58, 'PPL', 'P'),
(138046, 'Shafer', 45.3869400024414, 0.792151540447726, -92.7474975585938, -1.61874920538286, 218, 28, 'PPL', 'P'),
(133061, 'Shafer Location', 46.0849990844727, 0.80433496980262, -88.3572235107422, -1.54212446818299, 218, 27, 'PPL', 'P'),
(167032, 'Shaffer', 41.1241683959961, 0.717752140654727, -78.7344436645508, -1.3741752766724, 218, 45, 'PPL', 'P'),
(14591, 'Shaffer Property', 38.7563896179199, 0.67642660501845, -75.1580581665039, -1.31175557441091, 218, 10, 'PPL', 'P'),
(157591, 'Shaffers (historical)', 40.8872184753418, 0.71361658437697, -81.1341705322266, -1.41605841166191, 218, 41, 'PPL', 'P'),
(157592, 'Shaffers Acres', 41.4791717529297, 0.723948118088851, -84.4922180175781, -1.47466739671961, 218, 41, 'PPL', 'P'),
(167033, 'Shaffers Corners', 41.4236106872559, 0.722978394556926, -75.790283203125, -1.32278998291349, 218, 45, 'PPL', 'P'),
(187340, 'Shaffers Crossing', 39.4786109924316, 0.689031745931958, -105.367782592773, -1.83901473176946, 218, 7, 'PPL', 'P'),
(51327, 'Shaffers Mill Estates', 39.3219413757324, 0.686297345282719, -77.144172668457, -1.3464198117916, 218, 25, 'PPL', 'P'),
(167034, 'Shaffersville', 40.5697212219238, 0.708075211938788, -78.1438903808594, -1.36386817746352, 218, 45, 'PPL', 'P'),
(117737, 'Shaffton', 41.7561111450195, 0.72878162230929, -90.3319396972656, -1.57658976743025, 218, 16, 'PPL', 'P'),
(79116, 'Shaft', 39.9038887023926, 0.696454242206118, -78.9355621337891, -1.37768545614718, 218, 45, 'PPL', 'P'),
(14592, 'Shaft Ox Corner', 38.5247192382813, 0.67238319411441, -75.3572235107422, -1.31523166542373, 218, 10, 'PPL', 'P'),
(28572, 'Shafter', 39.0136108398438, 0.680915962247024, -89.1849975585938, -1.55657185078057, 218, 18, 'PPL', 'P'),
(38165, 'Shafter', 37.0138893127441, 0.646014237476126, -84.6916732788086, -1.47814854773851, 218, 21, 'PPL', 'P'),
(57501, 'Shafter', 39.9838905334473, 0.697850537565647, -93.2847213745117, -1.62812552979076, 218, 29, 'PPL', 'P'),
(185083, 'Shafter', 38.0044403076172, 0.663302613745567, -122.707496643066, -2.1416498333014, 218, 6, 'PPL', 'P'),
(192196, 'Shafter', 29.8199996948242, 0.520457177618387, -104.302780151367, -1.82042693262515, 218, 51, 'PPL', 'P'),
(200200, 'Shafter', 40.8547210693359, 0.713049397643811, -114.443893432617, -1.99742274920069, 218, 39, 'PPL', 'P'),
(192197, 'Shafter Lake (historical)', 32.4045181274414, 0.56556553384604, -102.665466308594, -1.79185041518027, 218, 51, 'PPL', 'P'),
(167035, 'Shafton', 40.3308296203613, 0.70390576693616, -79.6933288574219, -1.39091098043662, 218, 45, 'PPL', 'P'),
(133062, 'Shaftsburg', 42.8047218322754, 0.747083331373506, -84.2930603027344, -1.47119143886484, 218, 27, 'PPL', 'P'),
(172506, 'Shaftsbury', 43.0086097717285, 0.750641847222069, -73.1916732788086, -1.27743568375916, 218, 55, 'PPL', 'P'),
(172507, 'Shaftsbury Center', 42.9824981689453, 0.75018611378053, -73.2069396972656, -1.27770213302623, 218, 55, 'PPL', 'P'),
(212142, 'Shageluk', 62.6822204589844, 1.09401112947023, -159.561935424805, -2.78488113401742, 218, 1, 'PPL', 'P'),
(111351, 'Shagtown', 39.4916687011719, 0.689259645942242, -80.1297225952148, -1.39852748799619, 218, 58, 'PPL', 'P'),
(51328, 'Shah Valley', 39.6786117553711, 0.692522417751752, -75.9194412231445, -1.32504421561818, 218, 25, 'PPL', 'P'),
(111352, 'Shahan', 38.7619400024414, 0.676523477503101, -80.1680603027344, -1.39919660722008, 218, 58, 'PPL', 'P'),
(5773, 'Shahan (historical)', 33.9741706848145, 0.592961139084549, -86.1900024414063, -1.50429932490449, 218, 2, 'PPL', 'P'),
(114047, 'Shailerville', 41.4708290100098, 0.723802509756251, -72.4958267211914, -1.26529087024008, 218, 8, 'PPL', 'P'),
(167037, 'Shainline', 40.0986099243164, 0.699852768652195, -75.352783203125, -1.31515416743601, 218, 45, 'PPL', 'P'),
(192911, 'Shake City', 39.4311103820801, 0.688202703884617, -123.466110229492, -2.15489013813489, 218, 6, 'PPL', 'P'),
(24776, 'Shake Rag', 34.0563888549805, 0.594396116858911, -84.1316680908203, -1.46837461337987, 218, 13, 'PPL', 'P'),
(90736, 'Shake Rag', 35.0800018310547, 0.612261533557544, -85.4661102294922, -1.49166502237705, 218, 50, 'PPL', 'P'),
(11880, 'Shake Rag (historical)', 35.5724983215332, 0.620857218870911, -92.4894409179688, -1.61424526734732, 218, 4, 'PPL', 'P'),
(61730, 'Shake Rag (historical)', 34.0019416809082, 0.593445834402943, -88.8249969482422, -1.55028865482074, 218, 30, 'PPL', 'P'),
(68679, 'Shaken', 34.6177787780762, 0.604194219404449, -77.7594375610352, -1.35715820993901, 218, 33, 'PPL', 'P'),
(208709, 'Shaker Church', 48.0527801513672, 0.838679228378337, -122.22721862793, -2.13326740061232, 218, 56, 'PPL', 'P'),
(152489, 'Shaker Crossing', 42.7341690063477, 0.74585195226448, -77.8488922119141, -1.35871948812807, 218, 40, 'PPL', 'P'),
(126061, 'Shaker Glen', 42.4541702270508, 0.740965051664185, -71.1991729736328, -1.24265999308685, 218, 23, 'PPL', 'P'),
(157593, 'Shaker Heights', 41.4738883972168, 0.723855906136107, -81.5372161865234, -1.42309288536525, 218, 41, 'PPL', 'P'),
(114048, 'Shaker Pines', 42.0286102294922, 0.733537628542008, -72.5377807617188, -1.26602310638179, 218, 8, 'PPL', 'P'),
(152490, 'Shaker Place', 43.3241691589355, 0.756149397514408, -74.5247192382813, -1.30070172483237, 218, 40, 'PPL', 'P'),
(126064, 'Shaker Village', 42.5361099243164, 0.742395169169557, -71.5550003051758, -1.24887035159086, 218, 23, 'PPL', 'P'),
(128790, 'Shaker Village', 43.9866714477539, 0.767712243756287, -70.3705596923828, -1.22819796310329, 218, 26, 'PPL', 'P'),
(144438, 'Shaker Village', 43.3586082458496, 0.756750472972439, -71.4905624389648, -1.24774569866252, 218, 36, 'PPL', 'P'),
(74266, 'Shaker Village (historical)', 39.2930603027344, 0.685793275467395, -84.7405624389648, -1.47900182455177, 218, 41, 'PPL', 'P'),
(28574, 'Shakerag', 37.8222198486328, 0.660122266771794, -88.9088897705078, -1.55175286078807, 218, 18, 'PPL', 'P'),
(126065, 'Shakerhill', 42.4583282470703, 0.741037622803889, -71.1805572509766, -1.24233508743386, 218, 23, 'PPL', 'P'),
(152491, 'Shakers', 42.7394409179688, 0.745943964480142, -73.8116683959961, -1.28825663990037, 218, 40, 'PPL', 'P'),
(11881, 'Shakertown', 33.9341697692871, 0.592262991404785, -92.9816665649414, -1.62283622554975, 218, 4, 'PPL', 'P'),
(38167, 'Shakertown', 37.8188896179199, 0.660064143281003, -84.7399978637695, -1.47899197085574, 218, 21, 'PPL', 'P'),
(74267, 'Shakertown', 39.7194404602051, 0.69323501308043, -84.1255569458008, -1.46826795377821, 218, 41, 'PPL', 'P'),
(189553, 'Shakespeare', 32.3258285522461, 0.564192141671886, -108.737777709961, -1.89783224234052, 218, 38, 'PPL', 'P'),
(167036, 'Shakespeare Club', 41.0144386291504, 0.715836994935824, -77.1786117553711, -1.34702088724963, 218, 45, 'PPL', 'P'),
(106152, 'Shakesville', 36.6094398498535, 0.638955262690762, -82.1391677856445, -1.43359892270756, 218, 53, 'PPL', 'P'),
(138049, 'Shakopee', 44.7980613708496, 0.78187366943181, -93.5266723632813, -1.63234837117324, 218, 28, 'PPL', 'P'),
(212143, 'Shaktoolik', 64.3338928222656, 1.12283825037368, -161.153884887695, -2.81266589367022, 218, 1, 'PPL', 'P'),
(205710, 'Shalamar', 40.6408309936523, 0.709316311585792, -111.826667785645, -1.95174354439337, 218, 52, 'PPL', 'P'),
(28575, 'Shale Bluff', 39.7769393920898, 0.6942385587582, -89.6097183227539, -1.56398462651675, 218, 18, 'PPL', 'P'),
(121429, 'Shale City', 41.2197189331055, 0.719419812129335, -90.6405563354492, -1.58197614389299, 218, 18, 'PPL', 'P'),
(205712, 'Shaleh Estates', 40.6622200012207, 0.709689620191594, -111.841667175293, -1.95200533312853, 218, 52, 'PPL', 'P'),
(157595, 'Shalersville', 41.2388916015625, 0.719754438320303, -81.2313919067383, -1.41775524475046, 218, 41, 'PPL', 'P'),
(68680, 'Shaleville', 35.9088897705078, 0.626728357231072, -82.8522186279297, -1.44604400763955, 218, 33, 'PPL', 'P'),
(18052, 'Shalimar', 30.4455604553223, 0.531375272560357, -86.5791702270508, -1.51109158410668, 218, 12, 'PPL', 'P'),
(68681, 'Shalimar', 36.0911102294922, 0.629908704204845, -80.1972198486328, -1.39970553730439, 218, 33, 'PPL', 'P'),
(83585, 'Shalimar', 35.1097183227539, 0.612780184179837, -81.6511077880859, -1.42508066880288, 218, 48, 'PPL', 'P'),
(51329, 'Shallmar', 39.3794403076172, 0.687300890960489, -79.2050018310547, -1.38238806600004, 218, 25, 'PPL', 'P'),
(68682, 'Shallotte', 33.9730606079102, 0.592941764587619, -78.3861083984375, -1.36809567937791, 218, 33, 'PPL', 'P'),
(68684, 'Shallow Ford', 35.2963905334473, 0.616038228878413, -83.4958267211914, -1.45727708795945, 218, 33, 'PPL', 'P'),
(126066, 'Shallow Pond', 41.2933311462402, 0.720704587618216, -70.1316680908203, -1.22402851810066, 218, 23, 'PPL', 'P'),
(187903, 'Shallow Water', 38.3736114501953, 0.669745865686904, -100.912498474121, -1.76125535478717, 218, 20, 'PPL', 'P'),
(192198, 'Shallowater', 33.6888885498047, 0.587982026531509, -101.997779846191, -1.78019708804036, 218, 51, 'PPL', 'P'),
(90737, 'Shallowford', 36.0991706848145, 0.630049385689428, -82.470832824707, -1.43938756965295, 218, 50, 'PPL', 'P'),
(24777, 'Shallowford Forest', 34.0730590820313, 0.594687067208002, -84.5288925170898, -1.47530748748761, 218, 13, 'PPL', 'P'),
(24778, 'Shallowford Heights', 33.6624984741211, 0.58752143282098, -84.7755584716797, -1.47961262054778, 218, 13, 'PPL', 'P'),
(133063, 'Shallows', 46.4747200012207, 0.811136882963764, -84.4441680908203, -1.47382876729235, 218, 27, 'PPL', 'P'),
(43017, 'Shamard Heights', 31.7452793121338, 0.554059645961975, -93.1444396972656, -1.6256771526426, 218, 22, 'PPL', 'P'),
(187341, 'Shamballah-Ashrama', 39.3430595397949, 0.686665926777586, -105.032783508301, -1.83316789475425, 218, 7, 'PPL', 'P'),
(117738, 'Shambaugh', 40.6588897705078, 0.709631496700803, -95.0316696166992, -1.65861552847886, 218, 16, 'PPL', 'P'),
(123658, 'Shambaugh Siding', 40.482780456543, 0.706557809328688, -86.1527786254883, -1.50364964675657, 218, 19, 'PPL', 'P'),
(197507, 'Shambo (historical)', 48.2999992370605, 0.842994015397456, -109.644439697266, -1.91365647922166, 218, 31, 'PPL', 'P'),
(197508, 'Shambo Springs', 48.2930603027344, 0.842872908146884, -109.665000915527, -1.91401534017855, 218, 31, 'PPL', 'P'),
(167040, 'Shamburg', 41.560001373291, 0.725358861097293, -79.6286087036133, -1.38978140066027, 218, 45, 'PPL', 'P'),
(51330, 'Shamburg (historical)', 39.6288909912109, 0.69165462671055, -76.7347183227539, -1.33927348532248, 218, 25, 'PPL', 'P'),
(83583, 'Shamokin', 34.3255615234375, 0.599094066179865, -80.6033325195313, -1.40679354054564, 218, 48, 'PPL', 'P'),
(167041, 'Shamokin', 40.788890838623, 0.711900443370523, -76.5591735839844, -1.33620965164639, 218, 45, 'PPL', 'P'),
(167045, 'Shamokin Dam', 40.8486099243164, 0.712942738042153, -76.8199996948242, -1.34076192605572, 218, 45, 'PPL', 'P'),
(18053, 'Shamrock', 29.6430606842041, 0.517369009307845, -83.1449966430664, -1.45115394798114, 218, 12, 'PPL', 'P'),
(24780, 'Shamrock', 32.4027786254883, 0.565535173809613, -82.0841674804688, -1.43263898629264, 218, 13, 'PPL', 'P'),
(43018, 'Shamrock', 31.708610534668, 0.553419655062516, -93.3305587768555, -1.62892554338222, 218, 22, 'PPL', 'P'),
(57502, 'Shamrock', 39.0027809143066, 0.680726944388655, -91.6941680908203, -1.60036513806194, 218, 29, 'PPL', 'P'),
(77227, 'Shamrock', 35.9099998474121, 0.626747731728003, -96.583610534668, -1.68570200729384, 218, 42, 'PPL', 'P'),
(106151, 'Shamrock', 37.2755584716797, 0.650581225850476, -80.0702819824219, -1.39749005359355, 218, 53, 'PPL', 'P'),
(111355, 'Shamrock', 37.8405609130859, 0.660442378734821, -82.0197219848633, -1.43151420020624, 218, 58, 'PPL', 'P'),
(121430, 'Shamrock', 40.4186096191406, 0.705437816932255, -88.8994369506836, -1.55158787795854, 218, 18, 'PPL', 'P'),
(152492, 'Shamrock', 42.9008293151855, 0.748760723386092, -76.3619384765625, -1.33276724962136, 218, 40, 'PPL', 'P'),
(167046, 'Shamrock', 40.8608283996582, 0.713155990666441, -76.5849990844727, -1.33666039166089, 218, 45, 'PPL', 'P'),
(176335, 'Shamrock', 44.1741714477539, 0.770984736103776, -90.804443359375, -1.58483651206179, 218, 57, 'PPL', 'P'),
(187342, 'Shamrock', 39.8852806091309, 0.696129469711183, -103.815826416016, -1.81192798663838, 218, 7, 'PPL', 'P'),
(192199, 'Shamrock', 35.214168548584, 0.614603184525023, -100.248611450195, -1.7496683403584, 218, 51, 'PPL', 'P'),
(185084, 'Shamrock (historical)', 33.1183280944824, 0.578023868004458, -115.579170227051, -2.01723706718504, 218, 6, 'PPL', 'P'),
(190724, 'Shamrock (historical)', 38.9352798461914, 0.679548828501431, -117.551109313965, -2.05165389690046, 218, 39, 'PPL', 'P'),
(51333, 'Shamrock Acres', 39.6811103820801, 0.692566027014602, -77.4063873291016, -1.35099632096684, 218, 25, 'PPL', 'P'),
(43019, 'Shamrock Gardens', 30.4972190856934, 0.532276885747404, -91.0377807617188, -1.58890901800074, 218, 22, 'PPL', 'P'),
(51334, 'Shamrock Glen Estates', 38.3747215270996, 0.669765240183835, -76.7480621337891, -1.3395063787598, 218, 25, 'PPL', 'P'),
(24781, 'Shamrock Heights', 34.3472213745117, 0.599472101896602, -83.7975006103516, -1.46254229059259, 218, 13, 'PPL', 'P'),
(123654, 'Shamrock Lakes', 40.4111099243164, 0.705306922564678, -85.4263916015625, -1.4909718015453, 218, 19, 'PPL', 'P'),
(142988, 'Shamrock Mobile Home Court', 40.8402786254883, 0.712797329446635, -96.6833267211914, -1.6874423830662, 218, 35, 'PPL', 'P'),
(138051, 'Shamrock Mobile Home Park', 45.6283302307129, 0.796364594713204, -94.5769424438477, -1.65067904211431, 218, 28, 'PPL', 'P'),
(179134, 'Shamrock Mobile Home Park', 33.535831451416, 0.585310676221078, -112.241111755371, -1.95897695623014, 218, 5, 'PPL', 'P'),
(98013, 'Shamrock Shores', 31.8202800750732, 0.555368656216777, -99.0988922119141, -1.72960195417687, 218, 51, 'PPL', 'P'),
(167047, 'Shamrock Station', 40.502498626709, 0.706901956320554, -75.6488876342773, -1.32032216468936, 218, 45, 'PPL', 'P'),
(68685, 'Shamrock Terrace', 35.5269393920898, 0.62006206554844, -77.3888931274414, -1.35069098954786, 218, 33, 'PPL', 'P'),
(68686, 'Shamrock Village', 34.8072204589844, 0.607500600476809, -77.4572219848633, -1.351883553084, 218, 33, 'PPL', 'P'),
(176336, 'Shanagolden', 46.1175003051758, 0.804902223114807, -90.6358337402344, -1.58189371905726, 218, 57, 'PPL', 'P'),
(152493, 'Shandaken', 42.1199989318848, 0.735132662297884, -74.3958282470703, -1.29845215265958, 218, 40, 'PPL', 'P'),
(152495, 'Shandelee', 41.8788909912109, 0.730924534880423, -74.8716735839844, -1.30675722051899, 218, 40, 'PPL', 'P'),
(74268, 'Shandon', 39.3263893127441, 0.686374976428495, -84.7147216796875, -1.47855081822117, 218, 41, 'PPL', 'P'),
(185085, 'Shandon', 35.6552810668945, 0.622302050341306, -120.374443054199, -2.1009303665502, 218, 6, 'PPL', 'P'),
(24782, 'Shandra Estates', 33.5894393920898, 0.58624631129105, -84.523063659668, -1.47520575473397, 218, 13, 'PPL', 'P'),
(185086, 'Shands (historical)', 39.4252815246582, 0.688100971130976, -120.779716491699, -2.10800372240545, 218, 6, 'PPL', 'P'),
(90739, 'Shandy', 35.2936096191406, 0.615989692767546, -88.9591674804688, -1.55263037236725, 218, 50, 'PPL', 'P'),
(51335, 'Shane', 39.6691703796387, 0.692357634659304, -76.5922164916992, -1.33678635918045, 218, 25, 'PPL', 'P'),
(157597, 'Shane', 40.4775009155273, 0.706465663954971, -80.804443359375, -1.41030358686236, 218, 41, 'PPL', 'P'),
(51336, 'Shane Valley', 39.6966705322266, 0.692837602866763, -76.5808334350586, -1.33658768736313, 218, 25, 'PPL', 'P'),
(167048, 'Shaner', 40.2811088562012, 0.703037975894958, -79.7752838134766, -1.3923413642581, 218, 45, 'PPL', 'P'),
(74269, 'Shanersville', 39.6375007629395, 0.691804895575058, -84.2249984741211, -1.47000353586061, 218, 41, 'PPL', 'P'),
(157600, 'Shanesville', 40.5111083984375, 0.707052225185061, -81.6533279418945, -1.42511941779674, 218, 41, 'PPL', 'P'),
(167049, 'Shanesville', 40.3641700744629, 0.704487667634342, -75.6977767944336, -1.32117544150263, 218, 45, 'PPL', 'P'),
(5775, 'Shanghai', 34.8499984741211, 0.608247217688413, -87.0849990844727, -1.5199199631203, 218, 2, 'PPL', 'P'),
(68688, 'Shanghai', 34.7649993896484, 0.606763703803184, -78.2077789306641, -1.36498324301194, 218, 33, 'PPL', 'P'),
(106153, 'Shanghai', 37.6080589294434, 0.65638445360284, -76.7788925170898, -1.34004447045805, 218, 53, 'PPL', 'P'),
(111353, 'Shanghai', 39.4413909912109, 0.688382134363061, -78.1324996948242, -1.36366937248815, 218, 58, 'PPL', 'P'),
(123655, 'Shanghai', 40.4461097717285, 0.705917785139715, -86.3283309936523, -1.5067136135907, 218, 19, 'PPL', 'P'),
(121431, 'Shanghai City', 41.0508308410645, 0.716472158855808, -90.4966735839844, -1.5794649161431, 218, 18, 'PPL', 'P'),
(133064, 'Shanghai Corners', 42.0333290100098, 0.733619986798719, -86.3283309936523, -1.5067136135907, 218, 27, 'PPL', 'P'),
(979, 'Shangrala', 35.9633293151855, 0.627678506528985, -85.084716796875, -1.48500845123239, 218, 50, 'PPL', 'P'),
(176338, 'Shangri La Point', 44.0663909912109, 0.769103612267798, -88.6074981689453, -1.54649258500294, 218, 57, 'PPL', 'P'),
(24783, 'Shangri-La on the Lake', 33.5625, 0.585776130200597, -84.4330596923828, -1.47363488916499, 218, 13, 'PPL', 'P'),
(5774, 'Shangrila', 34.2416687011719, 0.59762986021254, -85.6577835083008, -1.49501035218035, 218, 2, 'PPL', 'P'),
(205715, 'Shangrila', 40.6441688537598, 0.709374568234638, -111.827781677246, -1.95176298546933, 218, 52, 'PPL', 'P'),
(197509, 'Shangville (historical)', 46.9847183227539, 0.820038032854163, -114.405563354492, -1.99675376313486, 218, 31, 'PPL', 'P'),
(201554, 'Shaniko', 45.0038909912109, 0.785466074005245, -120.751106262207, -2.10750437970106, 218, 43, 'PPL', 'P'),
(177274, 'Shank Town', 40.2763900756836, 0.702955617638247, -80.6111068725586, -1.40692922860318, 218, 58, 'PPL', 'P'),
(98014, 'Shanklerville', 30.9699993133545, 0.540528457358419, -93.706672668457, -1.63548996915316, 218, 51, 'PPL', 'P'),
(106154, 'Shanklin (historical)', 38.017219543457, 0.663525653486861, -79.9188919067383, -1.39484779831803, 218, 53, 'PPL', 'P'),
(111354, 'Shanks', 39.3141708374023, 0.686161723804207, -78.6880569458008, -1.37336567570102, 218, 58, 'PPL', 'P'),
(79115, 'Shanks Mill', 39.725830078125, 0.693346532951077, -77.3638916015625, -1.35025463060325, 218, 45, 'PPL', 'P'),
(61731, 'Shankstown (historical)', 31.8144397735596, 0.555266723726054, -91.029167175293, -1.58875868255721, 218, 30, 'PPL', 'P'),
(167050, 'Shanksville', 40.0177803039551, 0.698442025643753, -78.9075012207031, -1.37719570082271, 218, 45, 'PPL', 'P'),
(167052, 'Shankweilers', 40.6502799987793, 0.709481227836295, -75.5986099243164, -1.31944465311018, 218, 45, 'PPL', 'P'),
(90740, 'Shanky Branch', 36.5275001525879, 0.63752514518539, -85.4983291625977, -1.49222734884122, 218, 50, 'PPL', 'P'),
(106155, 'Shannandale', 37.2144393920898, 0.649514496675845, -81.3622207641602, -1.42003863906909, 218, 53, 'PPL', 'P'),
(74270, 'Shannoah Town (historical)', 38.7249984741211, 0.675878726203193, -83.0472183227539, -1.44944739435462, 218, 41, 'PPL', 'P'),
(169597, 'Shannock', 41.4483299255371, 0.723409826653519, -71.6372222900391, -1.25030539594425, 218, 47, 'PPL', 'P'),
(5777, 'Shannon', 33.4052810668945, 0.583032142171434, -86.871940612793, -1.51620139129022, 218, 2, 'PPL', 'P'),
(11882, 'Shannon', 36.2088890075684, 0.63196433167125, -90.9580612182617, -1.58751764948923, 218, 4, 'PPL', 'P'),
(24788, 'Shannon', 33.4044418334961, 0.583017494785438, -84.4683303833008, -1.47425047885096, 218, 13, 'PPL', 'P'),
(33929, 'Shannon', 39.5652809143066, 0.690544421431123, -95.2430572509766, -1.662304938695, 218, 20, 'PPL', 'P'),
(38168, 'Shannon', 38.5483283996582, 0.672795251714072, -83.8913879394531, -1.46418093361132, 218, 21, 'PPL', 'P'),
(61732, 'Shannon', 34.1161117553711, 0.595438478109568, -88.711669921875, -1.54831072507914, 218, 30, 'PPL', 'P'),
(68690, 'Shannon', 34.8477783203125, 0.608208468694552, -79.1372222900391, -1.38120508984383, 218, 33, 'PPL', 'P'),
(83586, 'Shannon', 33.5852813720703, 0.586173740151346, -81.932502746582, -1.42999193732715, 218, 48, 'PPL', 'P'),
(98015, 'Shannon', 33.4738883972168, 0.584229565976561, -98.2586135864258, -1.71493632552796, 218, 51, 'PPL', 'P'),
(121432, 'Shannon', 42.1547203063965, 0.735738664603932, -89.7397232055664, -1.56625363976549, 218, 18, 'PPL', 'P'),
(157602, 'Shannon', 41.4116706848145, 0.722770002201627, -83.0788879394531, -1.45000013343886, 218, 41, 'PPL', 'P'),
(185088, 'Shannon', 37.2330589294434, 0.649839468907862, -121.96305847168, -2.12865693613317, 218, 6, 'PPL', 'P'),
(200201, 'Shannon', 40.1002807617188, 0.699881930266132, -116.200828552246, -2.02808705178213, 218, 39, 'PPL', 'P'),
(177275, 'Shannon (historical)', 40.1580581665039, 0.70089033621289, -80.6269378662109, -1.40720553156627, 218, 58, 'PPL', 'P'),
(68691, 'Shannon Acres', 35.792781829834, 0.624701891378604, -80.8161087036133, -1.4105071855277, 218, 33, 'PPL', 'P'),
(205717, 'Shannon Bee Estates', 41.309440612793, 0.720985750850301, -111.856109619141, -1.9522574013257, 218, 52, 'PPL', 'P'),
(117739, 'Shannon City', 40.901668548584, 0.713868785732201, -94.2630615234375, -1.64520078659397, 218, 16, 'PPL', 'P'),
(51337, 'Shannon Forest', 39.1513900756836, 0.683320663553311, -76.5830612182617, -1.33662656951505, 218, 25, 'PPL', 'P'),
(83587, 'Shannon Forest', 34.9186096191406, 0.609444708072567, -81.9722213745117, -1.4306851581589, 218, 48, 'PPL', 'P'),
(51338, 'Shannon Heath', 39.4483299255371, 0.688503241613632, -76.3680572509766, -1.33287404238107, 218, 25, 'PPL', 'P'),
(167053, 'Shannon Heights', 40.4891700744629, 0.706669329199335, -79.8305587768555, -1.39330609436299, 218, 45, 'PPL', 'P'),
(83588, 'Shannon Hill', 34.2513885498047, 0.597799503573978, -80.2041702270508, -1.39982684429204, 218, 48, 'PPL', 'P'),
(106156, 'Shannon Hill', 37.8816719055176, 0.661159900911516, -78.0386123657227, -1.36203072946942, 218, 53, 'PPL', 'P'),
(11883, 'Shannon Hills', 34.6199989318848, 0.604232968398309, -92.3952789306641, -1.61260183063863, 218, 4, 'PPL', 'P'),
(90741, 'Shannon Hills', 35.1808280944824, 0.614021283826841, -85.2147216796875, -1.48727746448114, 218, 50, 'PPL', 'P'),
(106158, 'Shannon Hills', 37.8869400024414, 0.661251846548151, -78.0258331298828, -1.36180768972813, 218, 53, 'PPL', 'P'),
(106159, 'Shannon Hills Estates', 37.8766708374023, 0.661072615806789, -78.0486068725586, -1.36220516652082, 218, 53, 'PPL', 'P'),
(106160, 'Shannon Hills Farms', 37.8586082458496, 0.660757364112751, -78.0599975585938, -1.3624039714962, 218, 53, 'PPL', 'P'),
(68694, 'Shannon Park', 35.7208290100098, 0.623446077766577, -80.4402770996094, -1.40394768660478, 218, 33, 'PPL', 'P'),
(193943, 'Shannon Place', 40.1547203063965, 0.700832079564045, -123.361106872559, -2.15305748383075, 218, 6, 'PPL', 'P'),
(51340, 'Shannon Square', 39.146671295166, 0.6832383052966, -76.5833282470703, -1.33663123004695, 218, 25, 'PPL', 'P'),
(11884, 'Shannon Tank', 34.089168548584, 0.594968230440087, -91.7186126708984, -1.60079177646857, 218, 4, 'PPL', 'P'),
(18054, 'Shannon Wood', 29.6327800750732, 0.517189578829401, -82.4391708374023, -1.43883496372676, 218, 12, 'PPL', 'P'),
(11885, 'Shannondale', 34.9191703796387, 0.609454495189573, -90.5074996948242, -1.57965386742245, 218, 4, 'PPL', 'P'),
(90742, 'Shannondale', 36.0511093139648, 0.629210556525081, -83.9113922119141, -1.46453007403023, 218, 50, 'PPL', 'P'),
(111356, 'Shannondale', 39.2169418334961, 0.684464757557609, -77.8077774047852, -1.35800189937235, 218, 58, 'PPL', 'P'),
(112422, 'Shannondale', 37.3899993896484, 0.652578596668035, -91.4375, -1.59588543479232, 218, 29, 'PPL', 'P'),
(123656, 'Shannondale', 40.0547218322754, 0.699086776943662, -86.695556640625, -1.51312291022814, 218, 19, 'PPL', 'P'),
(167055, 'Shannondale', 41.0811080932617, 0.717000596595107, -79.2324981689453, -1.38286796762847, 218, 45, 'PPL', 'P'),
(106162, 'Shannondale Estates', 37.6966705322266, 0.657931017826877, -77.3499984741211, -1.350012149786, 218, 53, 'PPL', 'P'),
(205718, 'Shannondoah Estates', 41.1719398498535, 0.718585909813004, -112.123611450195, -1.95692618903272, 218, 52, 'PPL', 'P'),
(11886, 'Shannonville', 35.2663917541504, 0.615514651408103, -90.4813919067383, -1.57919820055993, 218, 4, 'PPL', 'P'),
(197510, 'Shannonville (historical)', 47.6416702270508, 0.831504006611391, -115.394439697266, -2.01401291121133, 218, 31, 'PPL', 'P'),
(208710, 'Shano', 46.7633285522461, 0.816174052428567, -118.987503051758, -2.07672369697997, 218, 56, 'PPL', 'P'),
(167054, 'Shanor Heights', 40.9005584716797, 0.71384941123527, -79.9094390869141, -1.3946828154885, 218, 45, 'PPL', 'P'),
(138053, 'Shanty Town', 43.9741706848145, 0.767494064283982, -92.6397171020508, -1.61686808154689, 218, 28, 'PPL', 'P'),
(200202, 'Shanty Town', 40.1619415283203, 0.700958113662633, -115.501937866211, -2.01588910819929, 218, 39, 'PPL', 'P'),
(51341, 'Shanty Town (historical)', 39.646671295166, 0.691964951556572, -78.7633285522461, -1.37467941306675, 218, 25, 'PPL', 'P'),
(57509, 'Shantytown', 38.0338897705078, 0.663816603835952, -92.0458297729492, -1.60650279226819, 218, 29, 'PPL', 'P'),
(176339, 'Shantytown', 44.6877784729004, 0.779948869753955, -89.4238891601563, -1.56074129578319, 218, 57, 'PPL', 'P'),
(179135, 'Shaotkam', 31.7694396972656, 0.554481324231076, -112.409721374512, -1.96191974923468, 218, 5, 'PPL', 'P'),
(128791, 'Shapleigh', 43.5405616760254, 0.759926159414304, -70.8486099243164, -1.23654151364045, 218, 26, 'PPL', 'P'),
(98016, 'Share 52 Colonia', 26.3649997711182, 0.460156053293563, -98.7770004272461, -1.72398388269929, 218, 51, 'PPL', 'P'),
(38169, 'Sharer', 37.0366706848145, 0.646411847426875, -86.6708297729492, -1.51269134497349, 218, 21, 'PPL', 'P'),
(51342, 'Sharewood Acres', 39.1541709899902, 0.683369199664177, -76.7805633544922, -1.34007363207199, 218, 25, 'PPL', 'P'),
(61733, 'Shari', 34.5161094665527, 0.602419755170129, -89.0455627441406, -1.55413825417645, 218, 30, 'PPL', 'P'),
(11892, 'Shark', 34.9949989318848, 0.610777953093288, -93.5147171020508, -1.63213971250184, 218, 4, 'PPL', 'P'),
(146290, 'Shark River Hills', 40.1938896179199, 0.701515713015868, -74.0491714477539, -1.29240185013708, 218, 37, 'PPL', 'P'),
(38170, 'Sharkey', 38.2308311462402, 0.66725387927589, -83.5599975585938, -1.45839708035588, 218, 21, 'PPL', 'P'),
(43021, 'Sharkey', 30.3700008392334, 0.530056508478064, -90.4205627441406, -1.57813653139137, 218, 22, 'PPL', 'P'),
(112438, 'Sharkey', 33.9049987792969, 0.591753861583389, -90.2647171020508, -1.57541651181202, 218, 30, 'PPL', 'P'),
(197511, 'Sharkeyville (historical)', 46.6416702270508, 0.814050714091447, -112.836112976074, -1.96936168658479, 218, 31, 'PPL', 'P'),
(51343, 'Sharktown', 38.9738883972168, 0.680222674836249, -76.2808303833008, -1.33135164634393, 218, 25, 'PPL', 'P'),
(111359, 'Sharlow', 38.1324996948242, 0.665537671690416, -81.6344375610352, -1.42478971845379, 218, 58, 'PPL', 'P'),
(140855, 'Sharlow', 46.6800003051758, 0.814719700157275, -98.8597183227539, -1.72542758232622, 218, 34, 'PPL', 'P'),
(11887, 'Sharman', 33.189998626709, 0.579274754768468, -93.4108276367188, -1.63032649927366, 218, 4, 'PPL', 'P'),
(24790, 'Sharon', 31.8799991607666, 0.556410950888406, -83.1377792358398, -1.45102798046158, 218, 13, 'PPL', 'P'),
(33932, 'Sharon', 37.2486114501953, 0.650110911601968, -98.420280456543, -1.7177579447029, 218, 20, 'PPL', 'P'),
(43023, 'Sharon', 32.771671295166, 0.571973565481961, -92.7638931274414, -1.61903536204199, 218, 22, 'PPL', 'P'),
(51347, 'Sharon', 39.603889465332, 0.691218267765941, -76.4113922119141, -1.33363038013065, 218, 25, 'PPL', 'P'),
(57506, 'Sharon', 39.3005599975586, 0.685924169834972, -93.133056640625, -1.62547848082528, 218, 29, 'PPL', 'P'),
(61736, 'Sharon', 32.6583290100098, 0.569995369424251, -89.9361114501953, -1.56968126124648, 218, 30, 'PPL', 'P'),
(68702, 'Sharon', 35.3380584716797, 0.616765471593086, -77.5027770996094, -1.35267863982744, 218, 33, 'PPL', 'P'),
(77230, 'Sharon', 36.2758293151855, 0.633132660441468, -99.3352813720703, -1.73372772333762, 218, 42, 'PPL', 'P'),
(83592, 'Sharon', 34.9508285522461, 0.610007034536737, -81.3411102294922, -1.41967019073228, 218, 48, 'PPL', 'P'),
(90746, 'Sharon', 35.7555618286133, 0.624052279809706, -88.5141677856445, -1.5448636625222, 218, 50, 'PPL', 'P'),
(106163, 'Sharon', 36.6583290100098, 0.639808539504024, -79.5305633544922, -1.38807018650183, 218, 53, 'PPL', 'P'),
(111357, 'Sharon', 38.1594390869141, 0.666007852780869, -81.4472198486328, -1.42152215295432, 218, 58, 'PPL', 'P'),
(114051, 'Sharon', 41.8791694641113, 0.730929395149412, -73.4772186279297, -1.28241939026508, 218, 8, 'PPL', 'P'),
(117741, 'Sharon', 40.726390838623, 0.710809612588027, -91.6602783203125, -1.59977364998383, 218, 16, 'PPL', 'P'),
(123657, 'Sharon', 40.5536117553711, 0.707794048706703, -86.3913879394531, -1.50781416491118, 218, 19, 'PPL', 'P'),
(126067, 'Sharon', 42.1236114501953, 0.735195712636692, -71.1791687011719, -1.24231085266794, 218, 23, 'PPL', 'P'),
(133065, 'Sharon', 44.583610534668, 0.778130796256786, -85.0738906860352, -1.48481949995305, 218, 27, 'PPL', 'P'),
(140857, 'Sharon', 47.5972213745117, 0.830728227785851, -97.8936080932617, -1.70856577788439, 218, 34, 'PPL', 'P'),
(144439, 'Sharon', 42.813060760498, 0.747228873127078, -71.9161071777344, -1.25517285546859, 218, 36, 'PPL', 'P'),
(146291, 'Sharon', 40.2063903808594, 0.701733892488173, -74.5363922119141, -1.30090545665576, 218, 37, 'PPL', 'P'),
(152500, 'Sharon', 42.7611083984375, 0.746322133354934, -74.5330581665039, -1.30084726658594, 218, 40, 'PPL', 'P'),
(157603, 'Sharon', 40.0911102294922, 0.699721874284618, -82.9569396972656, -1.44787173509567, 218, 41, 'PPL', 'P'),
(167056, 'Sharon', 41.2330589294434, 0.719652638987635, -80.4936065673828, -1.40487846140576, 218, 45, 'PPL', 'P'),
(172510, 'Sharon', 43.7844390869141, 0.76418262320555, -72.454719543457, -1.26457341464241, 218, 55, 'PPL', 'P'),
(176340, 'Sharon', 42.502498626709, 0.74180854136044, -88.728889465332, -1.54861126280816, 218, 57, 'PPL', 'P'),
(185089, 'Sharon', 37.0980606079102, 0.647483303712441, -120.128890991211, -2.09664467456599, 218, 6, 'PPL', 'P'),
(195601, 'Sharon', 42.3505592346191, 0.739156698704994, -111.478332519531, -1.94566394709889, 218, 17, 'PPL', 'P'),
(51344, 'Sharon Acres', 39.5947189331055, 0.691058211784427, -76.4238891601563, -1.33384849302393, 218, 25, 'PPL', 'P'),
(68703, 'Sharon Apartments', 35.2905616760254, 0.615936496124772, -81.5572204589844, -1.42344202578416, 218, 33, 'PPL', 'P'),
(117742, 'Sharon Center', 41.5691719055176, 0.725518917078807, -91.6611099243164, -1.59978816421177, 218, 16, 'PPL', 'P'),
(152496, 'Sharon Center', 42.7799987792969, 0.746651832697885, -74.5869369506836, -1.30178762876685, 218, 40, 'PPL', 'P'),
(157604, 'Sharon Center', 41.0997200012207, 0.717325435669069, -81.7358322143555, -1.42655938899815, 218, 41, 'PPL', 'P'),
(167057, 'Sharon Center', 41.9402809143066, 0.731995991165989, -78.1458282470703, -1.36390199960937, 218, 45, 'PPL', 'P'),
(38171, 'Sharon Grove', 36.913330078125, 0.644259147738737, -87.0975036621094, -1.52013820917163, 218, 21, 'PPL', 'P'),
(111358, 'Sharon Heights', 37.6377792358398, 0.656903170804161, -81.9372177124023, -1.43007422900484, 218, 58, 'PPL', 'P'),
(126068, 'Sharon Heights', 42.1083297729492, 0.73492899705352, -71.1972198486328, -1.2426259046249, 218, 23, 'PPL', 'P'),
(51345, 'Sharon Hill', 39.5972213745117, 0.691101887626304, -76.42138671875, -1.33380481718205, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(79118, 'Sharon Hill', 39.9063911437988, 0.696497918047995, -75.2719421386719, -1.31374322469049, 218, 45, 'PPL', 'P'),
(133066, 'Sharon Hollow', 42.1783294677734, 0.736150722203594, -84.0938873291016, -1.46771521469396, 218, 27, 'PPL', 'P'),
(51346, 'Sharon Oaks', 39.5280609130859, 0.689894809862226, -76.9602813720703, -1.34321030320389, 218, 25, 'PPL', 'P'),
(24792, 'Sharon Park', 32.0902786254883, 0.560081019897131, -81.1705627441406, -1.4166935755819, 218, 13, 'PPL', 'P'),
(83593, 'Sharon Park', 34.9019393920898, 0.609153757723476, -82.4505615234375, -1.43903376870214, 218, 48, 'PPL', 'P'),
(90744, 'Sharon Park', 35.5980606079102, 0.621303364932526, -87.0466690063477, -1.51925097705447, 218, 50, 'PPL', 'P'),
(106166, 'Sharon Park', 37.6411094665527, 0.656961294294952, -77.3850021362305, -1.35062307894007, 218, 53, 'PPL', 'P'),
(106167, 'Sharon Springs', 37.0494384765625, 0.646634687431088, -81.2863922119141, -1.41871518116538, 218, 53, 'PPL', 'P'),
(152497, 'Sharon Springs', 42.7958297729492, 0.746928135660981, -74.6175003051758, -1.30232105993319, 218, 40, 'PPL', 'P'),
(187893, 'Sharon Springs', 38.8977813720703, 0.678894356663544, -101.751670837402, -1.77590167551817, 218, 20, 'PPL', 'P'),
(152498, 'Sharon Station', 41.8833312988281, 0.731002032868144, -73.5205612182617, -1.28317586117272, 218, 40, 'PPL', 'P'),
(114049, 'Sharon Valley', 41.8838882446289, 0.731011753406123, -73.4927825927734, -1.28269103269627, 218, 8, 'PPL', 'P'),
(185090, 'Sharon Valley', 39.4822196960449, 0.689094729691739, -121.245826721191, -2.11613888058731, 218, 6, 'PPL', 'P'),
(68706, 'Sharonbrook', 35.1161117553711, 0.612891770629511, -80.8769378662109, -1.41156885469626, 218, 33, 'PPL', 'P'),
(38172, 'Sharondale', 37.6100006103516, 0.656418342327712, -82.2683334350586, -1.43585328857031, 218, 21, 'PPL', 'P'),
(90745, 'Sharondale', 35.3594398498535, 0.617138647040833, -86.2444381713867, -1.50524940762338, 218, 50, 'PPL', 'P'),
(51348, 'Sharonville', 39.125, 0.682860069842781, -76.521110534668, -1.33554532611247, 218, 25, 'PPL', 'P'),
(74274, 'Sharonville', 39.2680587768555, 0.685356916522785, -84.413330078125, -1.47329054243604, 218, 41, 'PPL', 'P'),
(11888, 'Sharp', 35.8136100769043, 0.6250654128674, -91.5355606079102, -1.59759691526685, 218, 4, 'PPL', 'P'),
(43026, 'Sharp', 31.4033298492432, 0.548091501959108, -92.7780609130859, -1.61928263654921, 218, 22, 'PPL', 'P'),
(57507, 'Sharp', 36.6002807617188, 0.63879540644633, -92.2074966430664, -1.60932441144313, 218, 29, 'PPL', 'P'),
(83594, 'Sharp', 34.1741714477539, 0.596451810904343, -80.9508285522461, -1.41285849045413, 218, 48, 'PPL', 'P'),
(98017, 'Sharp', 30.7511100769043, 0.536708119485187, -97.1558303833008, -1.69568912769774, 218, 51, 'PPL', 'P'),
(128793, 'Sharp', 46.2866706848145, 0.807854803236351, -67.8427810668945, -1.18407990332698, 218, 26, 'PPL', 'P'),
(146292, 'Sharp', 40.0922203063965, 0.699741248781548, -74.7427825927734, -1.3045076483462, 218, 37, 'PPL', 'P'),
(193085, 'Sharp', 39.6236114501953, 0.691562481336833, -111.888893127441, -1.95282958148591, 218, 52, 'PPL', 'P'),
(68707, 'Sharp (historical)', 35.9427795410156, 0.627319845309179, -80.9111099243164, -1.41216526962238, 218, 33, 'PPL', 'P'),
(74276, 'Sharp (historical)', 39.8541717529297, 0.695586517743943, -82.9541702270508, -1.44782339872189, 218, 41, 'PPL', 'P'),
(90747, 'Sharp Estates', 35.8158302307129, 0.62510416186126, -84.269172668457, -1.47077452099619, 218, 50, 'PPL', 'P'),
(185091, 'Sharp Park', 37.6361083984375, 0.656874009190224, -122.486938476563, -2.13780036710374, 218, 6, 'PPL', 'P'),
(90748, 'Sharp Place', 36.5088882446289, 0.637200306111427, -84.8277816772461, -1.48052408743086, 218, 50, 'PPL', 'P'),
(68712, 'Sharp Point', 35.7177810668945, 0.623392881123803, -77.5938873291016, -1.35426881331433, 218, 33, 'PPL', 'P'),
(24793, 'Sharp Top', 34.3630599975586, 0.599748538017752, -84.4830627441406, -1.47450760705421, 218, 13, 'PPL', 'P'),
(43027, 'Sharp Town', 31.5822200775146, 0.551213725442089, -92.1136093139648, -1.6076857684244, 218, 22, 'PPL', 'P'),
(33934, 'Sharpe', 38.2819404602051, 0.668145905083012, -95.6916732788086, -1.67013476545789, 218, 20, 'PPL', 'P'),
(38173, 'Sharpe', 36.9686088562012, 0.645223944422645, -88.4583282470703, -1.54388907872128, 218, 21, 'PPL', 'P'),
(79119, 'Sharpe', 39.8163909912109, 0.69492711905804, -78.1186065673828, -1.3634268916709, 218, 45, 'PPL', 'P'),
(167060, 'Sharpe Hill', 40.5033302307129, 0.706916470548494, -79.9375, -1.39517257081297, 218, 45, 'PPL', 'P'),
(146293, 'Sharper', 40.0291709899902, 0.698640830619128, -74.9297180175781, -1.30777028699766, 218, 37, 'PPL', 'P'),
(51349, 'Sharperville', 38.6725006103516, 0.674962465630152, -76.9747161865234, -1.34346223824301, 218, 25, 'PPL', 'P'),
(18055, 'Sharpes', 28.4319400787354, 0.496230967103668, -80.7602767944336, -1.40953273488484, 218, 12, 'PPL', 'P'),
(208711, 'Sharpes Corner', 48.4638900756836, 0.845854450145283, -122.580833435059, -2.13943914328052, 218, 56, 'PPL', 'P'),
(83595, 'Sharpes Hill', 33.815559387207, 0.590192849710439, -81.1544418334961, -1.41641221261273, 218, 48, 'PPL', 'P'),
(157608, 'Sharpeye', 40.1061096191406, 0.699983663019773, -84.746940612793, -1.47911314468534, 218, 41, 'PPL', 'P'),
(24794, 'Sharphagen', 31.0205593109131, 0.541410895785617, -84.8288879394531, -1.48054339534877, 218, 13, 'PPL', 'P'),
(111360, 'Sharples', 37.920280456543, 0.661833747246333, -81.8294372558594, -1.42819310516886, 218, 58, 'PPL', 'P'),
(157609, 'Sharples', 41.6291694641113, 0.726566072019426, -83.8369369506836, -1.46323058457632, 218, 41, 'PPL', 'P'),
(14593, 'Sharpley', 39.7999992370605, 0.694641028977938, -75.5555572509766, -1.31869324220862, 218, 10, 'PPL', 'P'),
(68710, 'Sharps', 36.3641700744629, 0.634674497554569, -80.0286102294922, -1.39676274429985, 218, 33, 'PPL', 'P'),
(106168, 'Sharps', 37.8238906860352, 0.66015142838573, -76.7011108398438, -1.33868692409239, 218, 53, 'PPL', 'P'),
(90749, 'Sharps Chapel', 36.3436088562012, 0.634315636597681, -83.8041687011719, -1.46265867073223, 218, 50, 'PPL', 'P'),
(71379, 'Sharps Corner', 39.7997207641602, 0.694636168708948, -74.9663925170898, -1.30841037776566, 218, 37, 'PPL', 'P'),
(202609, 'Sharps Corner', 43.389720916748, 0.757293491518706, -102.398063659668, -1.78718335852796, 218, 49, 'PPL', 'P'),
(133068, 'Sharps Corners', 44.4211082458496, 0.775294596274878, -84.6836090087891, -1.4780077996749, 218, 27, 'PPL', 'P'),
(157610, 'Sharps Crossing', 40.1511116027832, 0.700769095804265, -84.7324981689453, -1.47886107648816, 218, 41, 'PPL', 'P'),
(5779, 'Sharps Mill', 34.9080581665039, 0.609260550483188, -87.7055587768555, -1.53075077295754, 218, 2, 'PPL', 'P'),
(24795, 'Sharpsburg', 33.339168548584, 0.58187826105013, -84.6486129760742, -1.47739700367889, 218, 13, 'PPL', 'P'),
(28578, 'Sharpsburg', 39.6138916015625, 0.691392837975395, -89.3511123657227, -1.55947110110128, 218, 18, 'PPL', 'P'),
(38175, 'Sharpsburg', 38.2019386291504, 0.666749609723483, -83.929443359375, -1.46484512598718, 218, 21, 'PPL', 'P'),
(51350, 'Sharpsburg', 39.4575004577637, 0.688663297595146, -77.7491683959961, -1.35697897919765, 218, 25, 'PPL', 'P'),
(57508, 'Sharpsburg', 39.686939239502, 0.692667759768243, -91.7622222900391, -1.60155290790811, 218, 29, 'PPL', 'P'),
(61739, 'Sharpsburg', 32.7558288574219, 0.571697062781784, -89.9894409179688, -1.57061203604746, 218, 30, 'PPL', 'P'),
(68711, 'Sharpsburg', 35.8669395446777, 0.625996187668382, -77.8294372558594, -1.35837993508909, 218, 33, 'PPL', 'P'),
(117747, 'Sharpsburg', 40.8025016784668, 0.712137997339758, -94.642219543457, -1.65181834242865, 218, 16, 'PPL', 'P'),
(157611, 'Sharpsburg', 40.3677787780762, 0.704550651394123, -84.709716796875, -1.47846346653741, 218, 41, 'PPL', 'P'),
(167062, 'Sharpsburg', 40.5202789306641, 0.707212281166575, -77.834716796875, -1.3584720804628, 218, 45, 'PPL', 'P'),
(24796, 'Sharpsburg Landing Subdivision', 33.4180603027344, 0.583255181912728, -84.6847229003906, -1.47802724075086, 218, 13, 'PPL', 'P'),
(18056, 'Sharpstown', 30.3663902282715, 0.52999349142877, -85.1002807617188, -1.48528009366358, 218, 12, 'PPL', 'P'),
(51351, 'Sharpstown', 39.1363906860352, 0.683058874818156, -76.2188873291016, -1.33027053609941, 218, 25, 'PPL', 'P'),
(38174, 'Sharpsville', 37.855281829834, 0.660699307200987, -85.067497253418, -1.48470791350338, 218, 21, 'PPL', 'P'),
(90750, 'Sharpsville', 35.8747215270996, 0.626132008883976, -86.2827835083008, -1.50591866000531, 218, 50, 'PPL', 'P'),
(123659, 'Sharpsville', 40.3794403076172, 0.704754183480432, -86.0886077880859, -1.50252965436013, 218, 19, 'PPL', 'P'),
(167064, 'Sharpsville', 41.2591705322266, 0.720108372429175, -80.4722213745117, -1.40450521937899, 218, 45, 'PPL', 'P'),
(74277, 'Sharpsville (historical)', 39.2574996948242, 0.685172625775352, -83.7491683959961, -1.46169873431731, 218, 41, 'PPL', 'P'),
(31103, 'Sharptown', 39.3669395446777, 0.687082711488184, -84.8736114501953, -1.48132396786427, 218, 19, 'PPL', 'P'),
(51352, 'Sharptown', 38.5424995422363, 0.672693518960431, -75.7197189331055, -1.32155840406738, 218, 25, 'PPL', 'P'),
(71380, 'Sharptown', 39.6555595397949, 0.692120080690069, -75.3655624389648, -1.3153772071773, 218, 37, 'PPL', 'P'),
(51353, 'Sharrer Heights', 39.5741691589355, 0.69069955056462, -77.2988891601563, -1.34912012397888, 218, 25, 'PPL', 'P'),
(167066, 'Sharrertown', 40.0547218322754, 0.699086776943662, -79.959716796875, -1.39556032706768, 218, 45, 'PPL', 'P'),
(51354, 'Sharretts (historical)', 39.6144409179688, 0.69140242535532, -77.228889465332, -1.34789839882881, 218, 25, 'PPL', 'P'),
(51355, 'Sharretts Ridge', 39.5430603027344, 0.690156598597381, -76.6297225952148, -1.33744096417639, 218, 25, 'PPL', 'P'),
(167067, 'Shartlesville', 40.5127792358398, 0.707081386798998, -76.1047210693359, -1.32827795897181, 218, 45, 'PPL', 'P'),
(11890, 'Sharum', 36.2227783203125, 0.632206745909474, -90.853889465332, -1.58569950941303, 218, 4, 'PPL', 'P'),
(98018, 'Shary Colonia', 26.2959995269775, 0.45895177184863, -98.265998840332, -1.71506522252472, 218, 51, 'PPL', 'P'),
(98019, 'Shary Country Acres Colonia', 26.3120002746582, 0.459231037578438, -98.2740020751953, -1.7152049053239, 218, 51, 'PPL', 'P'),
(98020, 'Shary Groves Estates Colonia', 26.2819995880127, 0.458707426818615, -98.2699966430664, -1.71513499734528, 218, 51, 'PPL', 'P'),
(98021, 'Shary Groves Estates Number 2 Colonia', 26.2639999389648, 0.458393273678526, -98.2689971923828, -1.71511755364014, 218, 51, 'PPL', 'P'),
(98022, 'Sharyland', 26.2108306884766, 0.457465295196688, -98.2877807617188, -1.71544538877033, 218, 51, 'PPL', 'P'),
(193944, 'Shasta', 40.5994415283203, 0.708593929140108, -122.490829467773, -2.13786827771154, 218, 6, 'PPL', 'P'),
(28579, 'Shasta (historical)', 37.1316719055176, 0.648069931521559, -89.3949966430664, -1.56023702623079, 218, 18, 'PPL', 'P'),
(157612, 'Shasta (historical)', 40.7713890075684, 0.711594978793491, -84.5716705322266, -1.47605410469922, 218, 41, 'PPL', 'P'),
(193946, 'Shasta Lake', 40.6805610656738, 0.710009732154621, -122.369720458984, -2.13575452675434, 218, 6, 'PPL', 'P'),
(193947, 'Shasta Retreat', 41.2355613708496, 0.719696314829512, -122.271392822266, -2.1340383857479, 218, 6, 'PPL', 'P'),
(193948, 'Shasta Springs', 41.246940612793, 0.719894920067805, -122.26000213623, -2.13383958077252, 218, 6, 'PPL', 'P'),
(68713, 'Shatley Springs', 36.4761085510254, 0.636628192530251, -81.4027786254883, -1.42074650728683, 218, 33, 'PPL', 'P'),
(111361, 'Shatto', 38.7900009155273, 0.677013232827567, -81.6549987792969, -1.42514857941068, 218, 58, 'PPL', 'P'),
(28580, 'Shattuc', 38.6105613708496, 0.673881421964661, -89.1927795410156, -1.55670767199616, 218, 18, 'PPL', 'P'),
(77231, 'Shattuck', 36.2758293151855, 0.633132660441468, -99.8808288574219, -1.74324932318298, 218, 42, 'PPL', 'P'),
(126070, 'Shattuckville', 42.6375007629395, 0.744164773134888, -72.726936340332, -1.26932449402711, 218, 23, 'PPL', 'P'),
(133069, 'Shattuckville', 43.4519386291504, 0.758379395453186, -84.0513916015625, -1.46697352433038, 218, 27, 'PPL', 'P'),
(157613, 'Shauck', 40.6208305358887, 0.70896723774591, -82.6619415283203, -1.44272304576022, 218, 41, 'PPL', 'P'),
(192200, 'Shaufler', 32.4022216796875, 0.565525453271634, -100.437217712402, -1.75296014062379, 218, 51, 'PPL', 'P'),
(192778, 'Shauntie', 38.3411102294922, 0.669178612374717, -113.165832519531, -1.97511637822629, 218, 52, 'PPL', 'P'),
(187343, 'Shavano (historical)', 38.6027793884277, 0.673745600749067, -106.28971862793, -1.85510555107572, 218, 7, 'PPL', 'P'),
(98023, 'Shavano Park', 29.5847206115723, 0.516350782954566, -98.5522232055664, -1.72006078009749, 218, 51, 'PPL', 'P'),
(11891, 'Shaver (historical)', 36.3594398498535, 0.634591939560777, -93.2694396972656, -1.62785881420759, 218, 4, 'PPL', 'P'),
(57511, 'Shaver Ford', 39.521671295166, 0.689783289991579, -91.6894378662109, -1.60028258006814, 218, 29, 'PPL', 'P'),
(185092, 'Shaver Lake', 37.1041717529297, 0.647589963314099, -119.316673278809, -2.08246880124155, 218, 6, 'PPL', 'P'),
(185093, 'Shaver Lake Heights', 37.1069412231445, 0.647638299687884, -119.319442749023, -2.08251713761533, 218, 6, 'PPL', 'P'),
(90751, 'Shaver Town', 36.1722183227539, 0.631324307482277, -86.0388870239258, -1.50166186331893, 218, 50, 'PPL', 'P'),
(61740, 'Shavers (historical)', 33.2555618286133, 0.580419048509848, -88.5299987792969, -1.54513996548529, 218, 30, 'PPL', 'P'),
(106169, 'Shavertown', 38.6636085510254, 0.674807269917627, -78.6263885498047, -1.37228935914646, 218, 53, 'PPL', 'P'),
(167068, 'Shavertown', 41.3197212219238, 0.721165181328745, -75.9383316040039, -1.32537391496114, 218, 45, 'PPL', 'P'),
(51356, 'Shavox', 38.3561096191406, 0.669440401109872, -75.4638900756836, -1.31709334818375, 218, 25, 'PPL', 'P'),
(5780, 'Shaw', 33.5063896179199, 0.584796819288747, -88.0941696166992, -1.53753331162175, 218, 2, 'PPL', 'P'),
(11894, 'Shaw', 34.4980583190918, 0.602104703213172, -92.5380630493164, -1.61509388362868, 218, 4, 'PPL', 'P'),
(13206, 'Shaw', 38.9119415283203, 0.679141498012704, -77.0216674804688, -1.34428169291043, 218, 9, 'PPL', 'P'),
(33935, 'Shaw', 37.6022186279297, 0.656282521112118, -95.3172225952148, -1.66359936814283, 218, 20, 'PPL', 'P'),
(43028, 'Shaw', 31.1913890838623, 0.544392437784015, -91.6311111450195, -1.59926458674146, 218, 22, 'PPL', 'P'),
(57510, 'Shaw', 38.9736099243164, 0.680217814567259, -92.2030563354492, -1.60924691345541, 218, 29, 'PPL', 'P'),
(90752, 'Shaw', 35.7216682434082, 0.623460725152572, -89.335563659668, -1.5591997249862, 218, 50, 'PPL', 'P'),
(112443, 'Shaw', 33.6016693115234, 0.58645976365242, -90.7736129760742, -1.58429842036354, 218, 30, 'PPL', 'P'),
(121434, 'Shaw', 41.0458297729492, 0.71638487375108, -90.6369400024414, -1.58191302697516, 218, 18, 'PPL', 'P'),
(138056, 'Shaw', 47.1133308410645, 0.822282744757964, -92.352783203125, -1.61186014027505, 218, 28, 'PPL', 'P'),
(187344, 'Shaw', 39.5505599975586, 0.690287492964958, -103.360282897949, -1.803977252362, 218, 7, 'PPL', 'P'),
(192201, 'Shaw', 30.0286102294922, 0.524098118302689, -102.005561828613, -1.78033290925595, 218, 51, 'PPL', 'P'),
(201555, 'Shaw', 44.8730583190918, 0.783182613107584, -122.870826721191, -2.14450048093222, 218, 43, 'PPL', 'P'),
(5781, 'Shaw (historical)', 34.9777793884277, 0.610477415364273, -88.1666717529297, -1.5387987126137, 218, 2, 'PPL', 'P'),
(11893, 'Shaw (historical)', 35.7299995422363, 0.623606133748091, -90.3666687011719, -1.57719590289436, 218, 4, 'PPL', 'P'),
(43029, 'Shaw (historical)', 30.0513896942139, 0.524495694963924, -91.6913909912109, -1.6003166685301, 218, 22, 'PPL', 'P'),
(171282, 'Shaw (historical)', 43.0791702270508, 0.751873359489149, -97.158332824707, -1.69573280353962, 218, 49, 'PPL', 'P'),
(144441, 'Shaw Corner (historical)', 43.4088897705078, 0.757628051130647, -71.688606262207, -1.25120221544134, 218, 36, 'PPL', 'P'),
(152501, 'Shaw Corners', 43.082218170166, 0.751926556131924, -74.0325012207031, -1.29211089978799, 218, 40, 'PPL', 'P'),
(83596, 'Shaw Heights', 33.9844398498535, 0.593140369825911, -80.482780456543, -1.40468951012642, 218, 48, 'PPL', 'P'),
(208714, 'Shaw Island', 48.5844383239746, 0.847958413985472, -122.927780151367, -2.14549450580909, 218, 56, 'PPL', 'P'),
(176346, 'Shaw Landing', 44.3663902282715, 0.774339586707976, -88.8091735839844, -1.5500124850157, 218, 57, 'PPL', 'P'),
(128794, 'Shaw Mills', 43.7402801513672, 0.763411904386081, -70.522216796875, -1.23084487891072, 218, 26, 'PPL', 'P'),
(112530, 'Shaw Mines', 39.7975006103516, 0.694597419715088, -79.0527801513672, -1.37973129649658, 218, 45, 'PPL', 'P'),
(197512, 'Shaw Place', 45.6458282470703, 0.796669992711209, -110.457496643066, -1.92784699993209, 218, 31, 'PPL', 'P'),
(51364, 'Shawan', 39.4955596923828, 0.689327556550039, -76.708610534668, -1.33881781845996, 218, 25, 'PPL', 'P'),
(57512, 'Shawan', 36.9638900756836, 0.645141586165935, -89.7797164916992, -1.5669516542872, 218, 29, 'PPL', 'P'),
(51358, 'Shawan at Hunt Valley', 39.4922218322754, 0.689269299901193, -76.6725006103516, -1.338187581388, 218, 25, 'PPL', 'P'),
(51357, 'Shawan Valley', 39.4813919067383, 0.689080282042825, -76.7111129760742, -1.33886149430184, 218, 25, 'PPL', 'P'),
(90753, 'Shawanee', 36.5805587768555, 0.638451192875438, -83.6388931274414, -1.45977406779751, 218, 50, 'PPL', 'P'),
(167069, 'Shawanese', 41.351390838623, 0.721717920412991, -76.0344390869141, -1.32705130697372, 218, 45, 'PPL', 'P'),
(18058, 'Shawano', 26.5544395446777, 0.46346240107641, -80.5116729736328, -1.40519377967883, 218, 12, 'PPL', 'P'),
(176344, 'Shawano', 44.7822189331055, 0.781597166731633, -88.60888671875, -1.54651681976886, 218, 57, 'PPL', 'P'),
(68714, 'Shawboro', 36.4052810668945, 0.635392019731264, -76.0944366455078, -1.32809846191434, 218, 33, 'PPL', 'P'),
(71381, 'Shawcrest', 38.9874992370605, 0.680460228805484, -74.8383331298828, -1.30617531982081, 218, 37, 'PPL', 'P'),
(38176, 'Shawhan', 38.3016700744629, 0.668490251811959, -84.2724990844727, -1.47083257790795, 218, 21, 'PPL', 'P'),
(126071, 'Shawkemo', 41.2944412231445, 0.720723962115147, -70.0583267211914, -1.22274846972271, 218, 23, 'PPL', 'P'),
(167070, 'Shawmont', 40.0527801513672, 0.69905288821879, -75.2363891601563, -1.3131227081565, 218, 45, 'PPL', 'P'),
(11896, 'Shawmut', 34.151668548584, 0.596059061222584, -93.4494400024414, -1.6310004121875, 218, 4, 'PPL', 'P'),
(128795, 'Shawmut', 44.6277809143066, 0.778901714813336, -69.5869369506836, -1.21452116616713, 218, 26, 'PPL', 'P'),
(167071, 'Shawmut', 41.2872200012207, 0.720597928016559, -78.7336120605469, -1.37416076244446, 218, 45, 'PPL', 'P'),
(179136, 'Shawmut', 32.996940612793, 0.575905256778273, -112.503059387207, -1.96354880487348, 218, 5, 'PPL', 'P'),
(197513, 'Shawmut', 46.3424987792969, 0.808829187300183, -109.524169921875, -1.91155737565046, 218, 31, 'PPL', 'P'),
(57513, 'Shawne', 37.1213912963867, 0.647890501043115, -91.2602767944336, -1.59279230634424, 218, 29, 'PPL', 'P'),
(5783, 'Shawnee', 31.9936103820801, 0.558393840767538, -87.2069396972656, -1.52204822830543, 218, 2, 'PPL', 'P'),
(11897, 'Shawnee', 35.4952812194824, 0.619509526201276, -90.1166687011719, -1.57283257976437, 218, 4, 'PPL', 'P'),
(14594, 'Shawnee', 38.889720916748, 0.678753675178961, -75.4569396972656, -1.3169720411961, 218, 10, 'PPL', 'P'),
(18057, 'Shawnee', 26.7769393920898, 0.467345755998937, -80.9652786254883, -1.41311069180936, 218, 12, 'PPL', 'P'),
(24797, 'Shawnee', 32.4755592346191, 0.566805435070554, -81.408332824707, -1.42084344635051, 218, 13, 'PPL', 'P'),
(33936, 'Shawnee', 39.0416717529297, 0.681405717571489, -94.7200012207031, -1.65317588879432, 218, 20, 'PPL', 'P'),
(51359, 'Shawnee', 39.6252784729004, 0.691591576371743, -76.3430633544922, -1.33243781659452, 218, 25, 'PPL', 'P'),
(74279, 'Shawnee', 39.6047210693359, 0.691232781993882, -82.211669921875, -1.43486432369951, 218, 41, 'PPL', 'P'),
(77232, 'Shawnee', 35.327220916748, 0.616576320576663, -96.9250030517578, -1.69166043075873, 218, 42, 'PPL', 'P'),
(98025, 'Shawnee', 33.8188896179199, 0.59025097320123, -96.5555572509766, -1.68521238512743, 218, 51, 'PPL', 'P'),
(140860, 'Shawnee', 47.9552803039551, 0.836977535020803, -97.7508316040039, -1.7060738580524, 218, 34, 'PPL', 'P'),
(152503, 'Shawnee', 43.128059387207, 0.752726636302411, -78.8380584716797, -1.37598369621062, 218, 40, 'PPL', 'P'),
(167072, 'Shawnee', 40.583610534668, 0.708317626177012, -77.523063659668, -1.35303270709437, 218, 45, 'PPL', 'P'),
(187345, 'Shawnee', 39.4211082458496, 0.688028133675162, -105.553611755371, -1.84225806250302, 218, 7, 'PPL', 'P'),
(208713, 'Shawnee', 46.8241691589355, 0.817235921334209, -117.270278930664, -2.04675248207222, 218, 56, 'PPL', 'P'),
(209728, 'Shawnee', 42.7477798461914, 0.746089506233715, -105.009170532227, -1.83275577057556, 218, 59, 'PPL', 'P'),
(14595, 'Shawnee Acres', 38.8944396972656, 0.678836033435672, -75.4027786254883, -1.31602675216717, 218, 10, 'PPL', 'P'),
(38177, 'Shawnee Estates', 36.9527816772461, 0.644947708038577, -86.4572219848633, -1.50896318576349, 218, 21, 'PPL', 'P'),
(51361, 'Shawnee Estates', 39.0611114501953, 0.681745004294365, -76.6305618286133, -1.33745561156239, 218, 25, 'PPL', 'P'),
(111362, 'Shawnee Estates', 38.5041694641113, 0.672024532894603, -81.8466720581055, -1.42849390921398, 218, 58, 'PPL', 'P'),
(38178, 'Shawnee Hills', 36.8441696166992, 0.643052069974658, -87.956672668457, -1.53513353716348, 218, 21, 'PPL', 'P'),
(157614, 'Shawnee Hills', 40.1577796936035, 0.700885475943901, -83.1341705322266, -1.4509649967018, 218, 41, 'PPL', 'P'),
(106170, 'Shawnee Land', 39.1913909912109, 0.684018811233075, -78.345832824707, -1.36739273800819, 218, 53, 'PPL', 'P'),
(57514, 'Shawnee Mound', 38.5297203063965, 0.672470479219137, -93.7616729736328, -1.63644990556808, 218, 29, 'PPL', 'P'),
(167073, 'Shawnee on Delaware', 41.0122184753418, 0.715798245941963, -75.1111068725586, -1.31093611974349, 218, 45, 'PPL', 'P'),
(98026, 'Shawnee Prairie', 31.1794395446777, 0.544183878981148, -94.5436096191406, -1.65009727457419, 218, 51, 'PPL', 'P'),
(51362, 'Shawnee View', 39.5316696166992, 0.689957793622006, -76.9097213745117, -1.34232786477669, 218, 25, 'PPL', 'P'),
(38179, 'Shawneeland', 38.2533302307129, 0.667646562378622, -85.8191680908203, -1.49782704450727, 218, 21, 'PPL', 'P'),
(28582, 'Shawneetown', 37.7130584716797, 0.658217041327951, -88.1866683959961, -1.53914771987456, 218, 18, 'PPL', 'P'),
(57518, 'Shawneetown', 37.5511093139648, 0.655390495304996, -89.6519393920898, -1.56472152319037, 218, 29, 'PPL', 'P'),
(112350, 'Shawneetown', 38.0186080932617, 0.66354988825278, -84.5102767944336, -1.47498258183463, 218, 21, 'PPL', 'P'),
(90754, 'Shawnette', 35.1838912963867, 0.614074746785724, -87.6711120605469, -1.53014956434145, 218, 50, 'PPL', 'P'),
(14596, 'Shawns Hideaway Mobile Home Park', 38.6527786254883, 0.674618252059259, -75.1833267211914, -1.31219659388742, 218, 10, 'PPL', 'P'),
(51363, 'Shawns Landing', 39.4041709899902, 0.687732522794163, -77.0116729736328, -1.34410725585902, 218, 25, 'PPL', 'P'),
(169598, 'Shawomet', 41.7169418334961, 0.728097988857467, -71.376106262207, -1.24574806152886, 218, 47, 'PPL', 'P'),
(117748, 'Shawondasse', 42.4394416809082, 0.740707990039965, -90.5913925170898, -1.58111807338977, 218, 16, 'PPL', 'P'),
(68715, 'Shaws', 35.1141700744629, 0.61285788190464, -78.9308319091797, -1.37760289815339, 218, 33, 'PPL', 'P'),
(121435, 'Shaws', 41.7075004577637, 0.727933205765018, -89.2352828979492, -1.5574494955178, 218, 18, 'PPL', 'P'),
(197514, 'Shaws', 45.6627807617188, 0.796965869908317, -111.778610229492, -1.95090478180805, 218, 31, 'PPL', 'P'),
(98027, 'Shaws Bend', 29.7363891601563, 0.518997898499078, -96.6394424438477, -1.6866764579367, 218, 51, 'PPL', 'P'),
(14597, 'Shaws Corner', 39.2030601501465, 0.684222476477439, -75.649169921875, -1.32032709153738, 218, 10, 'PPL', 'P'),
(144442, 'Shaws Corner', 43.0525016784668, 0.751407905509631, -72.333610534668, -1.26245966368521, 218, 36, 'PPL', 'P'),
(167074, 'Shaws Corners', 41.5611114501953, 0.725378235594224, -80.10888671875, -1.39816383334934, 218, 45, 'PPL', 'P'),
(83597, 'Shaws Crossroads', 33.9444389343262, 0.592442222146147, -80.2655563354492, -1.40089823399858, 218, 48, 'PPL', 'P'),
(185094, 'Shaws Flat', 38.0077781677246, 0.663360870394412, -120.408332824707, -2.1015218546283, 218, 6, 'PPL', 'P'),
(144443, 'Shaws Hill', 43.0713882446289, 0.751737538273555, -70.7275009155273, -1.23442776268326, 218, 36, 'PPL', 'P'),
(167075, 'Shaws Landing', 41.5513916015625, 0.725208592232785, -80.1147232055664, -1.39826569926104, 218, 45, 'PPL', 'P'),
(71382, 'Shaws Mill', 39.3105583190918, 0.6860986734654, -75.1566696166992, -1.31173133964499, 218, 37, 'PPL', 'P'),
(126072, 'Shawsheen Heights', 42.6755599975586, 0.744829032089781, -71.1597213745117, -1.24197143278701, 218, 23, 'PPL', 'P'),
(126074, 'Shawsheen Village', 42.6722183227539, 0.744770708861908, -71.1444396972656, -1.24170471720384, 218, 23, 'PPL', 'P'),
(51369, 'Shawsville', 39.6377792358398, 0.691809755844047, -76.5552825927734, -1.3361417410386, 218, 25, 'PPL', 'P'),
(106172, 'Shawsville', 37.1683311462402, 0.64870975597345, -80.2555618286133, -1.40072379694718, 218, 53, 'PPL', 'P'),
(51365, 'Shawsville Acres', 39.6313896179199, 0.6916982359734, -76.5522232055664, -1.33608834465874, 218, 25, 'PPL', 'P'),
(31104, 'Shawswick', 38.8955612182617, 0.678855607669684, -86.414436340332, -1.50821643539383, 218, 19, 'PPL', 'P'),
(5784, 'Shawtown', 33.1383285522461, 0.57837294184434, -87.1527786254883, -1.52110293927651, 218, 2, 'PPL', 'P'),
(68716, 'Shawtown', 35.3841705322266, 0.617570278874508, -78.8308334350586, -1.375857595533, 218, 33, 'PPL', 'P'),
(157618, 'Shawtown', 40.4833297729492, 0.706567396708612, -82.9641723632813, -1.44799796893134, 218, 41, 'PPL', 'P'),
(167076, 'Shawtown', 40.3347206115723, 0.703973677543957, -79.7052764892578, -1.39111950594998, 218, 45, 'PPL', 'P'),
(176348, 'Shawtown', 44.7949981689453, 0.781820206472927, -91.5369415283203, -1.59762101687472, 218, 57, 'PPL', 'P'),
(111364, 'Shawver', 37.8866691589355, 0.661247119437216, -80.7658309936523, -1.40962967394852, 218, 58, 'PPL', 'P'),
(106173, 'Shawver Mill', 37.1533317565918, 0.648447967238295, -81.353889465332, -1.41989323047357, 218, 53, 'PPL', 'P'),
(111363, 'Shawvers Crossing', 37.9533309936523, 0.662410587938445, -80.658332824707, -1.40775347696056, 218, 58, 'PPL', 'P'),
(167077, 'Shawville', 41.0691719055176, 0.716792270818835, -78.3583297729492, -1.36761085090146, 218, 45, 'PPL', 'P'),
(172511, 'Shawville', 44.9197196960449, 0.78399700776893, -72.9661102294922, -1.27349886587775, 218, 55, 'PPL', 'P'),
(192202, 'Shawville', 31.8500003814697, 0.555887373418097, -100.29972076416, -1.75056036616552, 218, 51, 'PPL', 'P'),
(157619, 'Shawville (historical)', 41.375560760498, 0.72213976512966, -82.0188903808594, -1.4314996859783, 218, 41, 'PPL', 'P'),
(167078, 'Shawwood Park', 40.9638900756836, 0.714954756245708, -80.1277770996094, -1.3984935326923, 218, 45, 'PPL', 'P'),
(74282, 'Shay', 39.5102806091309, 0.689584485016204, -81.2172164916992, -1.41750783708519, 218, 41, 'PPL', 'P'),
(77233, 'Shay', 33.9327812194824, 0.592238756638865, -96.7747192382813, -1.68903748340111, 218, 42, 'PPL', 'P'),
(167079, 'Shay', 40.7363891601563, 0.710984116218454, -79.4550018310547, -1.38675138913003, 218, 45, 'PPL', 'P'),
(197515, 'Shay (historical)', 47.0744400024414, 0.82160397157513, -108.155563354492, -1.88767068488521, 218, 31, 'PPL', 'P'),
(185095, 'Shay Creek Summer Home Area', 38.6941719055176, 0.67534070108397, -119.832778930664, -2.09147654415458, 218, 6, 'PPL', 'P'),
(133070, 'Shaytown', 42.7041702270508, 0.745328374794171, -84.9761123657227, -1.48311294632653, 218, 27, 'PPL', 'P'),
(146294, 'Shaytown', 41.2583312988281, 0.720093725043179, -74.7916717529297, -1.30536092515946, 218, 37, 'PPL', 'P'),
(167080, 'Shaytown', 41.9061088562012, 0.731399576239865, -78.1727828979492, -1.36437244701593, 218, 45, 'PPL', 'P'),
(167081, 'Shazen', 40.7013893127441, 0.710373253643417, -78.758056640625, -1.37458740085109, 218, 45, 'PPL', 'P'),
(77234, 'Shea', 36.3841705322266, 0.635023571394451, -97.7805633544922, -1.7065927749908, 218, 42, 'PPL', 'P'),
(90756, 'Shea', 36.2380599975586, 0.632473461492646, -84.3300018310547, -1.47183619016475, 218, 50, 'PPL', 'P'),
(126073, 'Shea Corner', 42.0416717529297, 0.733765595131319, -72.7013931274414, -1.26887868086063, 218, 23, 'PPL', 'P'),
(106174, 'Shea Terrace', 36.8419418334961, 0.643013187822743, -76.3252792358398, -1.33212742516947, 218, 53, 'PPL', 'P'),
(167083, 'Sheakleyville', 41.4427795410156, 0.723312954168867, -80.2080612182617, -1.39989475489984, 218, 45, 'PPL', 'P'),
(43030, 'Shear', 30.8080596923828, 0.537702077783031, -93.3627777099609, -1.62948786984639, 218, 22, 'PPL', 'P'),
(562, 'Shearer Valley', 36.7511100769043, 0.641427874604846, -84.9205627441406, -1.48214342253169, 218, 21, 'PPL', 'P'),
(167086, 'Shearersburg', 40.6150016784668, 0.708865504992269, -79.6544418334961, -1.39023227383282, 218, 45, 'PPL', 'P'),
(11898, 'Shearerville', 35.1480598449707, 0.613449369982746, -90.4005584716797, -1.57778739097246, 218, 4, 'PPL', 'P'),
(167084, 'Sheatown', 41.1933288574219, 0.718959218418806, -76.0149993896484, -1.32671202025085, 218, 45, 'PPL', 'P'),
(201556, 'Sheaville', 43.1272201538086, 0.752711988916415, -117.04972076416, -2.04290301587457, 218, 43, 'PPL', 'P'),
(176349, 'Sheboygan', 43.7508316040039, 0.76359606197546, -87.7144393920898, -1.53090576893298, 218, 57, 'PPL', 'P'),
(176351, 'Sheboygan Falls', 43.7291717529297, 0.763218026258723, -87.8105621337891, -1.53258342726168, 218, 57, 'PPL', 'P'),
(51366, 'Sheckells Hills', 38.6361083984375, 0.674327301710168, -76.6044387817383, -1.33699967838377, 218, 25, 'PPL', 'P'),
(201557, 'Shedd', 44.461669921875, 0.776002531071649, -123.109169006348, -2.14866033855492, 218, 43, 'PPL', 'P'),
(172512, 'Sheddsville', 43.4891700744629, 0.759029206759165, -72.4972229003906, -1.26531523816405, 218, 55, 'PPL', 'P'),
(199675, 'Shedeeds Trailer Court', 42.8047218322754, 0.747083331373506, -102.202781677246, -1.78377504496488, 218, 35, 'PPL', 'P'),
(152505, 'Sheds', 42.8111114501953, 0.747194851244153, -75.8305587768555, -1.32349292428321, 218, 40, 'PPL', 'P'),
(197516, 'Sheds (historical)', 45.6722183227539, 0.797130586421738, -111.203330993652, -1.94086426502429, 218, 31, 'PPL', 'P'),
(123661, 'Shedville', 40.2655601501465, 0.702766599779878, -85.1288909912109, -1.48577943636797, 218, 19, 'PPL', 'P'),
(167085, 'Sheeder', 40.151668548584, 0.700778816342243, -75.6202774047852, -1.31982282198497, 218, 45, 'PPL', 'P'),
(98028, 'Sheeks', 29.9811096191406, 0.523269076255347, -94.9749984741211, -1.65762643045, 218, 51, 'PPL', 'P'),
(142991, 'Sheens Trailer Court', 40.6972198486328, 0.710300482766631, -99.1430587768555, -1.73037280615439, 218, 35, 'PPL', 'P'),
(152504, 'Sheenwater', 42.9952812194824, 0.750409220100851, -79.01611328125, -1.37909133888663, 218, 40, 'PPL', 'P'),
(14602, 'Sheep Pen Landing', 38.6427803039551, 0.674443748428831, -75.148063659668, -1.31158113735951, 218, 10, 'PPL', 'P'),
(177685, 'Sheep Ranch', 38.2094383239746, 0.666880504091061, -120.46305847168, -2.10247699735326, 218, 6, 'PPL', 'P'),
(189555, 'Sheep Springs', 36.1433296203613, 0.630820104508897, -108.706672668457, -1.89728935695231, 218, 38, 'PPL', 'P'),
(106175, 'Sheep Town', 36.8238906860352, 0.642698135865787, -80.9147186279297, -1.41222825338216, 218, 53, 'PPL', 'P'),
(68718, 'Sheephead Rock', 33.939998626709, 0.592364724158426, -77.9138870239258, -1.35985386159439, 218, 33, 'PPL', 'P'),
(187346, 'Sheephorn', 39.892219543457, 0.696250576961754, -106.46639251709, -1.85818909214387, 218, 7, 'PPL', 'P'),
(128796, 'Sheepscot', 44.0494384765625, 0.768807735070691, -69.6066665649414, -1.21486551289608, 218, 26, 'PPL', 'P'),
(193949, 'Sheepshead', 40.8555603027344, 0.713064045029806, -120.823333740234, -2.10876498700304, 218, 6, 'PPL', 'P'),
(200203, 'Sheepshead', 40.4816703796387, 0.706538434831758, -119.831939697266, -2.09146189676858, 218, 39, 'PPL', 'P'),
(152506, 'Sheepshead Bay', 40.5911102294922, 0.70844852054459, -73.9449996948242, -1.29058371006088, 218, 40, 'PPL', 'P'),
(192203, 'Sheerin', 35.9708290100098, 0.627809400896563, -101.881942749023, -1.77817534929882, 218, 51, 'PPL', 'P'),
(192204, 'Sheerin Junction', 36.024169921875, 0.628740375434627, -101.882217407227, -1.77818014298878, 218, 51, 'PPL', 'P'),
(111365, 'Sheets Mills', 39.1822204589844, 0.683858755251561, -80.378059387207, -1.4028617826703, 218, 58, 'PPL', 'P'),
(123662, 'Sheff', 40.7055587768555, 0.710446024520204, -87.4491729736328, -1.52627599653593, 218, 19, 'PPL', 'P'),
(197517, 'Sheffels', 47.5947189331055, 0.830684551943973, -111.149436950684, -1.93992363652728, 218, 31, 'PPL', 'P'),
(112531, 'Sheffer', 39.7616691589355, 0.69397204291211, -76.6500015258789, -1.33779489828526, 218, 45, 'PPL', 'P'),
(5785, 'Sheffield', 34.7649993896484, 0.606763703803184, -87.6986083984375, -1.53062946596989, 218, 2, 'PPL', 'P'),
(68719, 'Sheffield', 35.9661102294922, 0.627727042639852, -80.6802825927734, -1.40813657268336, 218, 33, 'PPL', 'P'),
(83598, 'Sheffield', 34.1888885498047, 0.596708672791481, -82.1908264160156, -1.4345005358946, 218, 48, 'PPL', 'P'),
(106176, 'Sheffield', 37.3672218322754, 0.652181053296314, -79.1911087036133, -1.38214558518279, 218, 53, 'PPL', 'P'),
(117749, 'Sheffield', 42.8933296203613, 0.748629829018515, -93.2149963378906, -1.62690859833065, 218, 16, 'PPL', 'P'),
(121436, 'Sheffield', 41.3583297729492, 0.721839027663563, -89.7372207641602, -1.56620996392362, 218, 18, 'PPL', 'P'),
(133071, 'Sheffield', 43.1938896179199, 0.753875590575698, -85.4908294677734, -1.49209645447364, 218, 27, 'PPL', 'P'),
(157620, 'Sheffield', 41.4211082458496, 0.722934718715049, -82.0963897705078, -1.43285230549595, 218, 41, 'PPL', 'P'),
(167087, 'Sheffield', 41.7038917541504, 0.727870222005238, -79.0358276367188, -1.37943541929947, 218, 45, 'PPL', 'P'),
(171283, 'Sheffield', 44.4130592346191, 0.775154114527377, -98.0736083984375, -1.7117073758643, 218, 49, 'PPL', 'P'),
(172513, 'Sheffield', 44.6019401550293, 0.778450708482731, -72.1144409179688, -1.25863443225348, 218, 55, 'PPL', 'P'),
(177335, 'Sheffield', 42.110279083252, 0.734963018936446, -73.3555603027344, -1.28029605192796, 218, 23, 'PPL', 'P'),
(192205, 'Sheffield', 30.6902809143066, 0.535646450316627, -101.822219848633, -1.77713298804816, 218, 51, 'PPL', 'P'),
(197518, 'Sheffield', 46.3327789306641, 0.808659543938745, -106.138893127441, -1.85247314949623, 218, 31, 'PPL', 'P'),
(157621, 'Sheffield Center', 41.8236083984375, 0.729959671617487, -80.664436340332, -1.40786000340416, 218, 41, 'PPL', 'P'),
(106177, 'Sheffield Court', 37.5311088562012, 0.655041421465113, -77.5652770996094, -1.35376947060994, 218, 53, 'PPL', 'P'),
(24799, 'Sheffield Forest', 33.9291687011719, 0.592175706300057, -84.2102813720703, -1.46974667397348, 218, 13, 'PPL', 'P'),
(167088, 'Sheffield Junction', 41.5833282470703, 0.725765991848939, -78.9916687011719, -1.37866470048, 218, 45, 'PPL', 'P'),
(157622, 'Sheffield Lake', 41.4874992370605, 0.724093460105342, -82.1016693115234, -1.43294445086967, 218, 41, 'PPL', 'P'),
(14598, 'Sheffield Manor', 39.6980590820313, 0.692861837632683, -75.6900024414063, -1.32103975344509, 218, 10, 'PPL', 'P'),
(179137, 'Sheffield Place', 33.4874992370605, 0.584467119945796, -112.252777099609, -1.95918055489547, 218, 5, 'PPL', 'P'),
(172514, 'Sheffield Square', 44.622501373291, 0.77880956943962, -72.1572189331055, -1.25938104946508, 218, 55, 'PPL', 'P'),
(106178, 'Sheffield Terrace', 36.6083297729492, 0.638935888193832, -79.8552780151367, -1.39373752645958, 218, 53, 'PPL', 'P'),
(24800, 'Sheffield Woods', 33.6744384765625, 0.587729825176279, -84.1930618286133, -1.46944613624446, 218, 13, 'PPL', 'P'),
(208715, 'Sheffler', 46.4088897705078, 0.809987928690477, -118.634719848633, -2.07056646853971, 218, 56, 'PPL', 'P'),
(111366, 'Shegon', 37.8555603027344, 0.660704167469976, -82.0691680908203, -1.43237719755748, 218, 58, 'PPL', 'P'),
(68720, 'Shehan Crossroads (historical)', 35.3122215270996, 0.616314531841508, -82.0261077880859, -1.43162565349786, 218, 33, 'PPL', 'P'),
(167090, 'Shehawken', 41.8894386291504, 0.731108625890774, -75.3933334350586, -1.3158619024957, 218, 45, 'PPL', 'P'),
(57519, 'Sheil', 39.6338882446289, 0.69174184523625, -91.5983276367188, -1.59869240658126, 218, 29, 'PPL', 'P'),
(152507, 'Shekomeko', 41.9280586242676, 0.731782671962673, -73.5994415283203, -1.28455258229824, 218, 40, 'PPL', 'P'),
(144444, 'Shel Al Mobile Estates', 42.9816703796387, 0.750171666131616, -70.829719543457, -1.2362118142975, 218, 36, 'PPL', 'P'),
(51367, 'Shel-Mar Heights', 39.2869415283203, 0.685686482707683, -77.3216705322266, -1.34951773392963, 218, 25, 'PPL', 'P'),
(167091, 'Shelander Hollow', 41.7063903808594, 0.727913831268088, -79.0183334350586, -1.37913008788049, 218, 45, 'PPL', 'P'),
(38180, 'Shelbiana', 37.4252815246582, 0.653194386091089, -82.4930572509766, -1.43977545906572, 218, 21, 'PPL', 'P'),
(57520, 'Shelbina', 39.6938896179199, 0.692789066755897, -92.0427780151367, -1.60644952904639, 218, 29, 'PPL', 'P'),
(31112, 'Shelburn', 39.1783294677734, 0.683790844643764, -87.3936080932617, -1.52530620642498, 218, 19, 'PPL', 'P'),
(43031, 'Shelburn', 32.8841705322266, 0.57393704757465, -91.2255630493164, -1.59218643719625, 218, 22, 'PPL', 'P'),
(201558, 'Shelburn', 44.7361106872559, 0.780792426029238, -122.869438171387, -2.1444762461663, 218, 43, 'PPL', 'P'),
(121437, 'Shelburn (historical)', 41.6974983215332, 0.727758635555564, -89.3472213745117, -1.55940319049348, 218, 18, 'PPL', 'P'),
(31106, 'Shelburne', 39.4352798461914, 0.688275474761403, -86.3927764892578, -1.5078383996771, 218, 19, 'PPL', 'P'),
(126076, 'Shelburne', 42.5897216796875, 0.743330870818557, -72.6888885498047, -1.2686604348093, 218, 23, 'PPL', 'P'),
(144445, 'Shelburne', 44.4011116027832, 0.774945589014024, -71.0752792358398, -1.24049763943976, 218, 36, 'PPL', 'P'),
(172516, 'Shelburne', 44.3805618286133, 0.774586927794217, -73.2280578613281, -1.27807071452109, 218, 55, 'PPL', 'P'),
(126077, 'Shelburne Falls', 42.6041717529297, 0.743583072173787, -72.7397232055664, -1.26954766692646, 218, 23, 'PPL', 'P'),
(172517, 'Shelburne Falls', 44.3705596923828, 0.774412357584762, -73.2158279418945, -1.27785726215972, 218, 55, 'PPL', 'P'),
(59, 'Shelby', 30.021390914917, 0.523972117493614, -96.5980606079102, -1.68595420864907, 218, 51, 'PPL', 'P'),
(5787, 'Shelby', 33.110279083252, 0.577883386256956, -86.5841674804688, -1.51117880263238, 218, 2, 'PPL', 'P'),
(57522, 'Shelby', 36.5036087036133, 0.637108160737711, -91.522216796875, -1.59736402182953, 218, 29, 'PPL', 'P'),
(61742, 'Shelby', 33.9508285522461, 0.592553742016794, -90.7677764892578, -1.58419655445185, 218, 30, 'PPL', 'P'),
(68721, 'Shelby', 35.2922210693359, 0.615965458001626, -81.5358276367188, -1.42306865059933, 218, 33, 'PPL', 'P'),
(106179, 'Shelby', 38.3211097717285, 0.668829538534835, -78.3083267211914, -1.36673813301225, 218, 53, 'PPL', 'P'),
(113164, 'Shelby', 41.1922187805176, 0.718939843921875, -97.4250030517578, -1.7003870770187, 218, 35, 'PPL', 'P'),
(117751, 'Shelby', 41.5161094665527, 0.724592802809732, -95.4499969482422, -1.66591671776537, 218, 16, 'PPL', 'P'),
(123664, 'Shelby', 41.1952781677246, 0.718993240301731, -87.3477783203125, -1.52450632599158, 218, 19, 'PPL', 'P'),
(133073, 'Shelby', 43.6086082458496, 0.761113796102424, -86.3638916015625, -1.50733426328274, 218, 27, 'PPL', 'P'),
(157628, 'Shelby', 40.8813896179199, 0.713514851623329, -82.6619415283203, -1.44272304576022, 218, 41, 'PPL', 'P'),
(171284, 'Shelby', 43.9480590820313, 0.767038330842442, -99.1869430541992, -1.7311387312839, 218, 49, 'PPL', 'P'),
(176363, 'Shelby', 43.7691688537598, 0.76391610735946, -91.1608276367188, -1.59105659110378, 218, 57, 'PPL', 'P'),
(197519, 'Shelby', 48.5052795410156, 0.846576832590967, -111.856109619141, -1.9522574013257, 218, 31, 'PPL', 'P'),
(61743, 'Shelby (historical)', 31.954719543457, 0.557715067584704, -90.8249969482422, -1.58519523986063, 218, 30, 'PPL', 'P'),
(152511, 'Shelby Basin', 43.2158317565918, 0.754258553140452, -78.4308319091797, -1.36887625189342, 218, 40, 'PPL', 'P'),
(152508, 'Shelby Center', 43.1894416809082, 0.753797959429922, -78.3925018310547, -1.36820726582759, 218, 40, 'PPL', 'P'),
(38183, 'Shelby City', 37.5833282470703, 0.655952821769166, -84.779167175293, -1.47967560430756, 218, 21, 'PPL', 'P'),
(90758, 'Shelby Farms', 35.1536102294922, 0.613546242467398, -89.851936340332, -1.56821212843114, 218, 50, 'PPL', 'P'),
(185096, 'Shelby Flat (historical)', 39.288890838623, 0.685720504590608, -121.027496337891, -2.11232829654157, 218, 6, 'PPL', 'P'),
(24801, 'Shelby Forest', 33.6958312988281, 0.588103200361108, -84.7322235107422, -1.4788562827982, 218, 13, 'PPL', 'P'),
(5789, 'Shelby Shores', 33.1283302307129, 0.578198438213913, -86.4658279418945, -1.50911338804897, 218, 2, 'PPL', 'P'),
(5790, 'Shelby Springs', 33.1349983215332, 0.578314818353549, -86.6866683959961, -1.51296778109464, 218, 2, 'PPL', 'P'),
(11899, 'Shelbyville', 35.9588890075684, 0.627601008541264, -91.3994369506836, -1.59522110925839, 218, 4, 'PPL', 'P'),
(28587, 'Shelbyville', 39.4063911437988, 0.687771271788024, -88.7900009155273, -1.54967785882473, 218, 18, 'PPL', 'P'),
(31111, 'Shelbyville', 39.5213890075684, 0.689778363143562, -85.7769393920898, -1.49709001467559, 218, 19, 'PPL', 'P'),
(38182, 'Shelbyville', 38.2119407653809, 0.666924179932938, -85.2236099243164, -1.48743259361464, 218, 21, 'PPL', 'P'),
(57524, 'Shelbyville', 39.8058280944824, 0.694742761731579, -92.041389465332, -1.60642529428047, 218, 29, 'PPL', 'P'),
(90759, 'Shelbyville', 35.4833297729492, 0.619300934108896, -86.4602813720703, -1.50901658214335, 218, 50, 'PPL', 'P'),
(98031, 'Shelbyville', 31.7613906860352, 0.554340842483574, -94.0783309936523, -1.64197663062026, 218, 51, 'PPL', 'P'),
(133076, 'Shelbyville', 42.5941696166992, 0.743408501964333, -85.6372222900391, -1.49465149122346, 218, 27, 'PPL', 'P'),
(90760, 'Shelbyville Mills', 35.4719390869141, 0.619102129133521, -86.4883270263672, -1.5095060711517, 218, 50, 'PPL', 'P'),
(117754, 'Sheldahl', 41.8644409179688, 0.730672333525192, -93.6969375610352, -1.63532005947561, 218, 16, 'PPL', 'P'),
(57525, 'Sheldon', 37.6580581665039, 0.657257104913032, -94.2925033569336, -1.6457146435263, 218, 29, 'PPL', 'P'),
(83599, 'Sheldon', 32.601390838623, 0.569001610863488, -80.793327331543, -1.41010957557695, 218, 48, 'PPL', 'P'),
(98032, 'Sheldon', 29.8677806854248, 0.521291113224232, -95.128059387207, -1.66029784733946, 218, 51, 'PPL', 'P'),
(117755, 'Sheldon', 43.1811103820801, 0.753652550834404, -95.855827331543, -1.6729997941586, 218, 16, 'PPL', 'P'),
(121438, 'Sheldon', 40.7691688537598, 0.711556229799631, -87.5638885498047, -1.52827816104345, 218, 18, 'PPL', 'P'),
(133077, 'Sheldon', 42.2747192382813, 0.737833041064197, -83.475830078125, -1.4569280806986, 218, 27, 'PPL', 'P'),
(138059, 'Sheldon', 43.6783294677734, 0.762330660983509, -91.5930633544922, -1.59860052752365, 218, 28, 'PPL', 'P'),
(140862, 'Sheldon', 46.5858306884766, 0.813076130290533, -97.4908294677734, -1.70153596471296, 218, 34, 'PPL', 'P'),
(152510, 'Sheldon', 42.7372207641602, 0.745905215486282, -78.4188919067383, -1.36866785953812, 218, 40, 'PPL', 'P'),
(172519, 'Sheldon', 44.8816719055176, 0.783332948551119, -72.9433288574219, -1.27310125592701, 218, 55, 'PPL', 'P'),
(176357, 'Sheldon', 45.3105583190918, 0.790818428585059, -90.9558334350586, -1.58747876733732, 218, 57, 'PPL', 'P'),
(179138, 'Sheldon', 32.8147201538086, 0.5727249098045, -109.171669006348, -1.90540507405821, 218, 5, 'PPL', 'P'),
(185097, 'Sheldon', 38.4308280944824, 0.670744484516657, -121.299171447754, -2.1170699217044, 218, 6, 'PPL', 'P'),
(157630, 'Sheldon (historical)', 41.5438919067383, 0.725077697865208, -83.2694396972656, -1.45332588900816, 218, 41, 'PPL', 'P'),
(152512, 'Sheldon Center', 42.7377815246582, 0.745915002603288, -78.3886108398438, -1.36813935521979, 218, 40, 'PPL', 'P'),
(152515, 'Sheldon Hall', 42.1180610656738, 0.73509884015204, -79.3147201538086, -1.38430301198186, 218, 40, 'PPL', 'P'),
(172520, 'Sheldon Junction', 44.901668548584, 0.783681955811974, -72.9480590820313, -1.2731838139208, 218, 55, 'PPL', 'P'),
(172521, 'Sheldon Springs', 44.9061088562012, 0.783759453799695, -72.9780578613281, -1.27370739139111, 218, 55, 'PPL', 'P'),
(171286, 'Sheldon Trailor Town', 44.2688903808594, 0.772637893350443, -96.8158264160156, -1.68975493899877, 218, 49, 'PPL', 'P'),
(121440, 'Sheldons Grove', 40.1666717529297, 0.701040671656425, -90.2941665649414, -1.57593050190241, 218, 18, 'PPL', 'P'),
(126079, 'Sheldonville', 42.0347213745117, 0.733644288143666, -71.3874969482422, -1.24594686650423, 218, 23, 'PPL', 'P'),
(142992, 'Sheldonville', 41.4638900756836, 0.723681402505679, -97.4255599975586, -1.70039679755668, 218, 35, 'PPL', 'P'),
(152514, 'Sheldrake', 42.6650009155273, 0.744644741342347, -76.7019424438477, -1.33870143832033, 218, 40, 'PPL', 'P'),
(152516, 'Sheldrake Springs', 42.6583290100098, 0.744528294623684, -76.754997253418, -1.33962741943135, 218, 40, 'PPL', 'P'),
(106180, 'Shelfar', 37.8105583190918, 0.659918734685485, -77.8677825927734, -1.35904918747102, 218, 53, 'PPL', 'P'),
(5791, 'Shell', 31.601110458374, 0.551543424785041, -86.6536102294922, -1.51239080724448, 218, 2, 'PPL', 'P'),
(83600, 'Shell', 33.9022216796875, 0.591705392051549, -78.9136123657227, -1.37730236042437, 218, 48, 'PPL', 'P'),
(185098, 'Shell', 36.3288917541504, 0.634058774710543, -119.622222900391, -2.08780164816638, 218, 6, 'PPL', 'P'),
(209729, 'Shell', 44.5355606079102, 0.77729216682952, -107.779167175293, -1.88110133226626, 218, 59, 'PPL', 'P'),
(43032, 'Shell Beach', 29.8530597686768, 0.521034184758066, -89.679443359375, -1.56520155797686, 218, 22, 'PPL', 'P'),
(74284, 'Shell Beach', 39.920280456543, 0.69674033228622, -82.4866714477539, -1.4396640057741, 218, 41, 'PPL', 'P'),
(126080, 'Shell Beach', 41.6413917541504, 0.726779391222741, -70.8061065673828, -1.23579969011881, 218, 23, 'PPL', 'P'),
(185099, 'Shell Beach', 35.1552810668945, 0.613575404081334, -120.67138671875, -2.10611301118954, 218, 6, 'PPL', 'P'),
(18059, 'Shell Bluff', 29.5063896179199, 0.514983649208974, -81.4927825927734, -1.42231737285582, 218, 12, 'PPL', 'P'),
(24802, 'Shell Bluff', 33.1477813720703, 0.57853792467387, -81.898063659668, -1.42939086186912, 218, 13, 'PPL', 'P'),
(24803, 'Shell Bluff Landing', 33.2266693115234, 0.579914778957441, -81.8233337402344, -1.42808657872526, 218, 13, 'PPL', 'P'),
(90761, 'Shell Creek', 36.1891708374023, 0.631620184679384, -82.0427780151367, -1.43191660384695, 218, 50, 'PPL', 'P'),
(18061, 'Shell Island', 30.1594390869141, 0.526381512621323, -84.216667175293, -1.46985812726509, 218, 12, 'PPL', 'P'),
(57526, 'Shell Knob', 36.6322212219238, 0.639352872641511, -93.6341705322266, -1.6342245681612, 218, 29, 'PPL', 'P'),
(11900, 'Shell Lake', 35.1291694641113, 0.613119670639795, -90.4888916015625, -1.57932909492751, 218, 4, 'PPL', 'P'),
(176360, 'Shell Lake', 45.7394409179688, 0.798303842039972, -91.9252777099609, -1.60439876184897, 218, 57, 'PPL', 'P'),
(5793, 'Shell Landing', 30.9105606079102, 0.539491056245292, -87.8713912963867, -1.53364509643024, 218, 2, 'PPL', 'P'),
(14599, 'Shell Landing', 38.665828704834, 0.674846018911488, -75.1391677856445, -1.31142587506795, 218, 10, 'PPL', 'P'),
(68724, 'Shell Landing', 35.3855590820313, 0.617594513640428, -76.8261108398438, -1.34086858565738, 218, 33, 'PPL', 'P'),
(71383, 'Shell Pile', 39.2402801513672, 0.684872088046336, -75.0247192382813, -1.30942837109234, 218, 37, 'PPL', 'P'),
(83603, 'Shell Point', 32.788890838623, 0.572274103210977, -80.1069412231445, -1.39812987804545, 218, 48, 'PPL', 'P'),
(83604, 'Shell Point park', 32.3816719055176, 0.565166792051828, -80.7427825927734, -1.40922740346586, 218, 48, 'PPL', 'P'),
(18062, 'Shell Point Village', 26.5188903808594, 0.462841951121449, -81.9961090087891, -1.43110207602755, 218, 12, 'PPL', 'P'),
(98033, 'Shell Ridge', 27.996940612793, 0.488638794178556, -97.0599975585938, -1.69401652937512, 218, 51, 'PPL', 'P'),
(117756, 'Shell Rock', 42.7102813720703, 0.745435034395828, -92.5827789306641, -1.61587432298612, 218, 16, 'PPL', 'P'),
(140874, 'Shell Valley', 48.7980613708496, 0.851686839511583, -99.8644409179688, -1.7429632996819, 218, 34, 'PPL', 'P'),
(71384, 'Shellbed Landing', 39.0625, 0.681769239060285, -74.8194427490234, -1.30584562047786, 218, 37, 'PPL', 'P'),
(24804, 'Shellbine', 30.9074993133545, 0.539437626575923, -81.5177764892578, -1.42275359864237, 218, 13, 'PPL', 'P'),
(14600, 'Shellburne', 39.7805595397949, 0.694301742255062, -75.5124969482422, -1.317941698149, 218, 10, 'PPL', 'P'),
(133078, 'Shelldrake', 46.6777801513672, 0.814680951163415, -85.0336074829102, -1.48411642542527, 218, 27, 'PPL', 'P'),
(195602, 'Shelley', 43.3813896179199, 0.757148082923187, -112.122497558594, -1.95690674795676, 218, 17, 'PPL', 'P'),
(14601, 'Shelley Farms', 39.5802803039551, 0.690806210166278, -75.7724990844727, -1.32247959148844, 218, 10, 'PPL', 'P'),
(106181, 'Shelleys', 36.6369400024414, 0.639435230898222, -82.3383331298828, -1.43707501372038, 218, 53, 'PPL', 'P'),
(5794, 'Shellhorn', 31.8758296966553, 0.55633818001162, -86.079719543457, -1.50237452522664, 218, 2, 'PPL', 'P'),
(24805, 'Shellman', 31.7561092376709, 0.554248663820344, -84.6152801513672, -1.47681523613876, 218, 13, 'PPL', 'P'),
(24806, 'Shellman (historical)', 34.1269416809082, 0.595627495967936, -84.8866729736328, -1.48155193445358, 218, 13, 'PPL', 'P'),
(24807, 'Shellman Bluff', 31.5725002288818, 0.551044082080651, -81.3233337402344, -1.41935993246528, 218, 13, 'PPL', 'P'),
(61744, 'Shellmound', 33.6063919067383, 0.586542188488158, -90.2797164916992, -1.57567830054718, 218, 30, 'PPL', 'P'),
(90762, 'Shellmound (historical)', 34.9972190856934, 0.610816702087149, -85.591667175293, -1.49385640448002, 218, 50, 'PPL', 'P'),
(24808, 'Shellnut', 33.3013916015625, 0.581218928943253, -85.1347198486328, -1.48588116912161, 218, 13, 'PPL', 'P'),
(195603, 'Shells Lick', 45.7066688537598, 0.797731861616851, -116.126937866211, -2.02679741602426, 218, 17, 'PPL', 'P'),
(117758, 'Shellsburg', 42.0944404602051, 0.734686582815296, -91.8691711425781, -1.60341951751615, 218, 16, 'PPL', 'P'),
(90763, 'Shellsford', 35.672779083252, 0.622607448339311, -85.711669921875, -1.49595084751931, 218, 50, 'PPL', 'P'),
(167097, 'Shellsville', 40.3666687011719, 0.704531276897192, -76.6708297729492, -1.33815841977406, 218, 45, 'PPL', 'P'),
(51368, 'Shelltown', 37.9797210693359, 0.662871181648974, -75.6402816772461, -1.32017196240388, 218, 25, 'PPL', 'P'),
(167092, 'Shelltown', 40.4563903808594, 0.706097215618159, -78.206672668457, -1.36496393509403, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(185101, 'Shellville Colony', 38.2438888549805, 0.667481779286173, -122.415832519531, -2.13655933403577, 218, 6, 'PPL', 'P'),
(24813, 'Shelly', 30.999439239502, 0.541042281001236, -83.7372207641602, -1.46149020880396, 218, 13, 'PPL', 'P'),
(138063, 'Shelly', 47.4580612182617, 0.828299424871698, -96.8180618286133, -1.68979395430874, 218, 28, 'PPL', 'P'),
(167093, 'Shelly', 40.4808311462402, 0.706523787445762, -75.3724975585938, -1.31549824784885, 218, 45, 'PPL', 'P'),
(167094, 'Shellytown', 40.4088897705078, 0.705268173570817, -78.2094421386719, -1.36501227146782, 218, 45, 'PPL', 'P'),
(68727, 'Shelmerdine', 35.4474983215332, 0.618675557305918, -77.2641677856445, -1.34851412167283, 218, 33, 'PPL', 'P'),
(167095, 'Shelocta', 40.6558303833008, 0.709578100320947, -79.3022232055664, -1.38408489908859, 218, 45, 'PPL', 'P'),
(106183, 'Shelors Mill', 36.875560760498, 0.643599948789915, -80.3736114501953, -1.40278415152452, 218, 53, 'PPL', 'P'),
(208716, 'Shelter Bay', 48.3824996948242, 0.844433920019834, -122.513893127441, -2.13827081451031, 218, 56, 'PPL', 'P'),
(895, 'Shelter Cove', 32.1819381713867, 0.561680780763941, -80.7241668701172, -1.40890249781287, 218, 48, 'PPL', 'P'),
(193950, 'Shelter Cove', 40.0305595397949, 0.698665065385047, -124.071937561035, -2.16546381976889, 218, 6, 'PPL', 'P'),
(169599, 'Shelter Harbor', 41.3416709899902, 0.721548277051553, -71.7305603027344, -1.25193445158306, 218, 47, 'PPL', 'P'),
(152517, 'Shelter Island', 41.0680618286133, 0.716772896321905, -72.3391723632813, -1.26255673590695, 218, 40, 'PPL', 'P'),
(152518, 'Shelter Island Heights', 41.0838890075684, 0.717049132705973, -72.3563919067383, -1.26285727363596, 218, 40, 'PPL', 'P'),
(68728, 'Shelter Neck', 34.6199989318848, 0.604232968398309, -77.8427810668945, -1.35861282852641, 218, 33, 'PPL', 'P'),
(38184, 'Shelton', 37.5686111450195, 0.655695959882028, -87.7961120605469, -1.53233122590645, 218, 21, 'PPL', 'P'),
(61745, 'Shelton', 31.4922199249268, 0.549642926452133, -89.3491668701172, -1.55943714579738, 218, 30, 'PPL', 'P'),
(68729, 'Shelton', 36.5355606079102, 0.637665826669973, -79.4583282470703, -1.38680944604179, 218, 33, 'PPL', 'P'),
(83605, 'Shelton', 34.4972190856934, 0.602090055827177, -81.420280456543, -1.42105197186387, 218, 48, 'PPL', 'P'),
(111367, 'Shelton', 38.4313888549805, 0.670754271633663, -81.1952819824219, -1.41712500767849, 218, 58, 'PPL', 'P'),
(114052, 'Shelton', 41.3163909912109, 0.721107057837954, -73.0936126708984, -1.27572420328462, 218, 8, 'PPL', 'P'),
(142997, 'Shelton', 40.7791709899902, 0.711730800009085, -98.7305603027344, -1.72317334962152, 218, 35, 'PPL', 'P'),
(187347, 'Shelton', 38.0833282470703, 0.664679468029137, -103.605827331543, -1.80826281118816, 218, 7, 'PPL', 'P'),
(208717, 'Shelton', 47.2152786254883, 0.824062069261273, -123.09944152832, -2.14849056203543, 218, 56, 'PPL', 'P'),
(90764, 'Shelton Estates', 35.2027816772461, 0.614404446128676, -85.2055587768555, -1.48711754165768, 218, 50, 'PPL', 'P'),
(57528, 'Shelton Ford', 37.351390838623, 0.651904750333218, -90.4791717529297, -1.57915945156607, 218, 29, 'PPL', 'P'),
(68730, 'Shelton Laurel', 35.6808280944824, 0.622747930086813, -83.0077819824219, -1.44875910037089, 218, 33, 'PPL', 'P'),
(68731, 'Shelton Store', 36.5111083984375, 0.637239055105288, -80.1427764892578, -1.39875532142745, 218, 33, 'PPL', 'P'),
(43033, 'Sheltons', 32.8291702270508, 0.57297711115973, -91.9072189331055, -1.60408357673396, 218, 22, 'PPL', 'P'),
(68732, 'Sheltontown', 36.4933280944824, 0.636928730259267, -80.5563888549805, -1.40597421903627, 218, 33, 'PPL', 'P'),
(167098, 'Shelvey', 41.3697204589844, 0.722037832638937, -78.6502838134766, -1.37270641017317, 218, 45, 'PPL', 'P'),
(192779, 'Shem', 37.1916694641113, 0.649117086462178, -113.768058776855, -1.98562720925856, 218, 52, 'PPL', 'P'),
(14609, 'Shenandoah', 39.5052795410156, 0.689497199911477, -75.6311111450195, -1.32001190642237, 218, 10, 'PPL', 'P'),
(18063, 'Shenandoah', 25.7591705322266, 0.449582338370054, -80.2225036621094, -1.40014682309702, 218, 12, 'PPL', 'P'),
(24810, 'Shenandoah', 33.938060760498, 0.592330902012582, -84.3011093139648, -1.47133192061234, 218, 13, 'PPL', 'P'),
(43035, 'Shenandoah', 32.5486106872559, 0.568080423442429, -92.0100021362305, -1.60587748204424, 218, 22, 'PPL', 'P'),
(90765, 'Shenandoah', 35.2249984741211, 0.614792202383392, -84.852783203125, -1.48096044637547, 218, 50, 'PPL', 'P'),
(98034, 'Shenandoah', 30.1800003051758, 0.526740373578211, -95.4555587768555, -1.6660137899871, 218, 51, 'PPL', 'P'),
(106185, 'Shenandoah', 38.6602783203125, 0.674749146426836, -77.4652786254883, -1.35202416798956, 218, 53, 'PPL', 'P'),
(117760, 'Shenandoah', 40.7655601501465, 0.71149324603985, -95.371940612793, -1.66455437770974, 218, 16, 'PPL', 'P'),
(152520, 'Shenandoah', 41.5286102294922, 0.724810982282037, -73.7897186279297, -1.28787354417757, 218, 40, 'PPL', 'P'),
(157631, 'Shenandoah', 40.9116706848145, 0.714043355941655, -82.4994430541992, -1.43988691235734, 218, 41, 'PPL', 'P'),
(167099, 'Shenandoah', 40.8202781677246, 0.712448255606753, -76.2011108398438, -1.32996027783241, 218, 45, 'PPL', 'P'),
(106187, 'Shenandoah Caverns', 38.7130584716797, 0.675670333847895, -78.6666717529297, -1.37299243367424, 218, 53, 'PPL', 'P'),
(43036, 'Shenandoah Estates', 30.4002799987793, 0.530584979506876, -90.9972229003906, -1.588201149783, 218, 22, 'PPL', 'P'),
(90767, 'Shenandoah Estates', 35.8694381713867, 0.626039796931232, -84.6327819824219, -1.4771207007158, 218, 50, 'PPL', 'P'),
(106189, 'Shenandoah Farms', 38.9816703796387, 0.680358496051843, -78.0758285522461, -1.36268027445929, 218, 53, 'PPL', 'P'),
(106190, 'Shenandoah Forest', 38.6611099243164, 0.674763660654777, -78.5500030517578, -1.37095618070477, 218, 53, 'PPL', 'P'),
(167100, 'Shenandoah Heights', 40.8274993896484, 0.712574289705341, -76.2072219848633, -1.33006693743407, 218, 45, 'PPL', 'P'),
(106191, 'Shenandoah Hills', 39.1847190856934, 0.683902364514411, -78.1186065673828, -1.3634268916709, 218, 53, 'PPL', 'P'),
(106192, 'Shenandoah Homesteads Project', 38.7794418334961, 0.676828942080133, -78.1294403076172, -1.36361597610829, 218, 53, 'PPL', 'P'),
(111368, 'Shenandoah Junction', 39.3586082458496, 0.686937302892666, -77.8433303833008, -1.35862241590634, 218, 58, 'PPL', 'P'),
(106194, 'Shenandoah Mobile Home Park', 39.1252784729004, 0.682864930111771, -78.1566696166992, -1.36409121720482, 218, 53, 'PPL', 'P'),
(43037, 'Shenandoah North', 30.4102802276611, 0.530759516426818, -91.0124969482422, -1.58846773220812, 218, 22, 'PPL', 'P'),
(43038, 'Shenandoah Park', 30.4027805328369, 0.53062862205924, -91.0038909912109, -1.58831752992264, 218, 22, 'PPL', 'P'),
(106195, 'Shenandoah Retreat', 39.1341705322266, 0.683020125824295, -77.8652801513672, -1.35900551162915, 218, 53, 'PPL', 'P'),
(43039, 'Shenandoah Ridge', 30.4088897705078, 0.530735248371384, -90.9986114501953, -1.58822538454892, 218, 22, 'PPL', 'P'),
(106196, 'Shenandoah River Estates', 38.957218170166, 0.679931724487158, -78.1680603027344, -1.36429002218019, 218, 53, 'PPL', 'P'),
(106197, 'Shenandoah River Lakes', 38.9722213745117, 0.68019357980134, -78.2822189331055, -1.36628246614973, 218, 53, 'PPL', 'P'),
(106198, 'Shenandoah Shores', 38.9602813720703, 0.679985187446041, -78.1433334350586, -1.36385845692554, 218, 53, 'PPL', 'P'),
(43040, 'Shenandoah Square', 30.4022197723389, 0.530618834942234, -91.0138931274414, -1.58849210013209, 218, 22, 'PPL', 'P'),
(43041, 'Shenandoah Trails', 30.413610458374, 0.530817639917609, -90.9972229003906, -1.588201149783, 218, 22, 'PPL', 'P'),
(106199, 'Shenandoah Valley Estates', 38.0519409179688, 0.664131655792908, -79.0133285522461, -1.37904273619674, 218, 53, 'PPL', 'P'),
(24812, 'Shenandoah Woods', 33.5455589294434, 0.585480452740571, -82.1069412231445, -1.43303646308533, 218, 13, 'PPL', 'P'),
(167102, 'Shenango', 41.3797187805176, 0.722212336269365, -80.399169921875, -1.40323023100711, 218, 45, 'PPL', 'P'),
(111369, 'Shenango (historical)', 39.5852813720703, 0.690893495271005, -80.6872177124023, -1.40825761335491, 218, 58, 'PPL', 'P'),
(192780, 'Shenendoah City', 38.3522186279297, 0.669372490502075, -113.136390686035, -1.97460252129396, 218, 52, 'PPL', 'P'),
(18064, 'Shenks', 29.7619400024414, 0.519443844823612, -82.1419372558594, -1.43364725908134, 218, 12, 'PPL', 'P'),
(112724, 'Shenks Ferry', 39.8994407653809, 0.696376611060342, -76.3863906860352, -1.33319402118604, 218, 45, 'PPL', 'P'),
(176362, 'Shennington', 44.0258293151855, 0.768395677471028, -90.317497253418, -1.57633769923308, 218, 57, 'PPL', 'P'),
(90769, 'Shennon Village', 36.1744384765625, 0.631363056476137, -85.4388885498047, -1.49118991443858, 218, 50, 'PPL', 'P'),
(197520, 'Shennum Trailer Court', 48.5577812194824, 0.847493159743036, -109.665283203125, -1.91402026702656, 218, 31, 'PPL', 'P'),
(152521, 'Shenorock', 41.3316688537598, 0.721373706842099, -73.7386093139648, -1.28698151837044, 218, 40, 'PPL', 'P'),
(192206, 'Shep', 32.1564598083496, 0.561236099440925, -100.118896484375, -1.74740438711572, 218, 51, 'PPL', 'P'),
(74285, 'Shepard', 39.9833297729492, 0.697840750448641, -82.9416732788086, -1.44760528582861, 218, 41, 'PPL', 'P'),
(83606, 'Shepard', 34.3238906860352, 0.599064904565929, -80.541389465332, -1.40571243030112, 218, 48, 'PPL', 'P'),
(140867, 'Shepard', 47.389720916748, 0.827106661598479, -98.1316680908203, -1.71272070865907, 218, 34, 'PPL', 'P'),
(57529, 'Shepard (historical)', 37.6963882446289, 0.65792609097886, -90.8869400024414, -1.58627635010515, 218, 29, 'PPL', 'P'),
(117761, 'Shepard (historical)', 40.9902801513672, 0.715415349956237, -94.1538925170898, -1.64329542799207, 218, 16, 'PPL', 'P'),
(152522, 'Shepard Settlement', 42.9952812194824, 0.750409220100851, -76.3836135864258, -1.3331455516542, 218, 40, 'PPL', 'P'),
(185103, 'Shepards', 34.3988914489746, 0.60037391482073, -119.452499389648, -2.08483941408588, 218, 6, 'PPL', 'P'),
(152523, 'Shepards Corner', 43.1049995422363, 0.752324166082673, -76.8397216796875, -1.34110613962661, 218, 40, 'PPL', 'P'),
(138066, 'Shepardson''s Park', 43.8319396972656, 0.765011665252892, -91.3036117553711, -1.59354864409383, 218, 28, 'PPL', 'P'),
(31113, 'Shepardsville', 39.600830078125, 0.691164871386085, -87.4175033569336, -1.52572325745169, 218, 19, 'PPL', 'P'),
(133081, 'Shepardsville', 43.0044403076172, 0.750569076345283, -84.4258270263672, -1.47350865532932, 218, 27, 'PPL', 'P'),
(126081, 'Shepardville', 42.0230598449707, 0.733440756057357, -71.3088912963867, -1.24457493906868, 218, 23, 'PPL', 'P'),
(138067, 'Shephard', 46.2138900756836, 0.80658454197541, -94.103889465332, -1.64242271010285, 218, 28, 'PPL', 'P'),
(28589, 'Shepherd', 39.7249984741211, 0.693332018723137, -91.3444366455078, -1.59426117284348, 218, 18, 'PPL', 'P'),
(31114, 'Shepherd', 39.9672203063965, 0.697559587216556, -86.4313888549805, -1.50851231259094, 218, 19, 'PPL', 'P'),
(61746, 'Shepherd', 33.9691696166992, 0.592873853979822, -89.3994369506836, -1.56031452421851, 218, 30, 'PPL', 'P'),
(90770, 'Shepherd', 35.038890838623, 0.611544011380849, -85.1919403076172, -1.48687985453039, 218, 50, 'PPL', 'P'),
(98035, 'Shepherd', 30.4977798461914, 0.53228667286441, -94.9963912963867, -1.65799980563483, 218, 51, 'PPL', 'P'),
(133079, 'Shepherd', 43.5244407653809, 0.759644796445137, -84.6947174072266, -1.47820167780226, 218, 27, 'PPL', 'P'),
(197521, 'Shepherd', 45.9436111450195, 0.801867284736553, -108.341667175293, -1.89091880930873, 218, 31, 'PPL', 'P'),
(205721, 'Shepherd Creek County Estates', 41.0083312988281, 0.715730401913193, -111.898612976074, -1.95299922484735, 218, 52, 'PPL', 'P'),
(197522, 'Shepherd Crossing', 47.6069412231445, 0.830897871147289, -110.891937255859, -1.93542941902971, 218, 31, 'PPL', 'P'),
(90771, 'Shepherd Forest', 35.1311111450195, 0.613153559364666, -85.32861328125, -1.48926524791877, 218, 50, 'PPL', 'P'),
(5798, 'Shepherd Hill', 32.1855583190918, 0.561743964260804, -86.0663909912109, -1.50214189810542, 218, 2, 'PPL', 'P'),
(106200, 'Shepherd Hill', 36.8430595397949, 0.643032695477728, -82.9444427490234, -1.4476536222024, 218, 53, 'PPL', 'P'),
(13207, 'Shepherd Park', 38.9847183227539, 0.680411692694617, -77.033332824707, -1.34448529157576, 218, 9, 'PPL', 'P'),
(68734, 'Shepherds', 35.6352806091309, 0.621952976501424, -80.8277816772461, -1.41071091735109, 218, 33, 'PPL', 'P'),
(51370, 'Shepherds Glen', 39.2652816772461, 0.685308446990946, -76.9722213745117, -1.34341869555918, 218, 25, 'PPL', 'P'),
(128797, 'Shepherds Hill', 43.098331451416, 0.752207785943036, -70.7394409179688, -1.23463615503855, 218, 26, 'PPL', 'P'),
(197523, 'Shepherds Trailer Court', 46.4355583190918, 0.810453382669996, -109.833610534668, -1.91695813318309, 218, 31, 'PPL', 'P'),
(111370, 'Shepherdstown', 39.4300003051758, 0.688183329387686, -77.804443359375, -1.35794370930253, 218, 58, 'PPL', 'P'),
(157632, 'Shepherdstown', 40.1588897705078, 0.700904850440831, -80.9436111450195, -1.41273252293457, 218, 41, 'PPL', 'P'),
(167105, 'Shepherdstown', 40.1775016784668, 0.701229689514794, -76.9916687011719, -1.34375811544012, 218, 45, 'PPL', 'P'),
(38185, 'Shepherdsville', 37.9883308410645, 0.663021450513481, -85.7158279418945, -1.49602341865901, 218, 21, 'PPL', 'P'),
(112353, 'Shepherdtown', 37.2869415283203, 0.650779897667796, -83.8649978637695, -1.46372033990079, 218, 21, 'PPL', 'P'),
(176364, 'Shepley', 44.8622207641602, 0.782993462091161, -89.102783203125, -1.55513693958523, 218, 57, 'PPL', 'P'),
(38189, 'Shepola', 37.0486106872559, 0.646620239782174, -84.7061080932617, -1.47840048277763, 218, 21, 'PPL', 'P'),
(90773, 'Shepp', 35.5011100769043, 0.619611258954917, -89.3463897705078, -1.55938867626554, 218, 50, 'PPL', 'P'),
(5799, 'Sheppard', 31.9111099243164, 0.55695393614516, -87.4800033569336, -1.52681408823418, 218, 2, 'PPL', 'P'),
(11902, 'Sheppard', 33.6263885498047, 0.586891195749013, -93.7219390869141, -1.63575641842022, 218, 4, 'PPL', 'P'),
(176365, 'Sheppard', 44.2608299255371, 0.772497211865859, -90.7805633544922, -1.5844197273512, 218, 57, 'PPL', 'P'),
(51371, 'Sheppard (historical)', 39.3891716003418, 0.687470734059008, -76.6136093139648, -1.33715973436528, 218, 25, 'PPL', 'P'),
(83608, 'Sheppard Crossroads', 33.961669921875, 0.592742959612244, -82.0472183227539, -1.43199410183468, 218, 48, 'PPL', 'P'),
(11903, 'Sheppard Point', 34.1911087036133, 0.596747421785342, -91.211669921875, -1.591943956379, 218, 4, 'PPL', 'P'),
(24814, 'Sheppards', 32.6372184753418, 0.569626921087438, -81.5352783203125, -1.4230590632194, 218, 13, 'PPL', 'P'),
(106201, 'Sheppards', 37.3905601501465, 0.652588383785041, -78.4855575561523, -1.36983139461837, 218, 53, 'PPL', 'P'),
(71387, 'Sheppards Mill', 39.4102783203125, 0.687839115816794, -75.3183288574219, -1.31455282566187, 218, 37, 'PPL', 'P'),
(106202, 'Sheppards Mill', 36.5441703796387, 0.637816095534481, -80.0969390869141, -1.39795530783599, 218, 53, 'PPL', 'P'),
(61747, 'Sheppardtown', 33.3913917541504, 0.582789727933209, -90.3133316040039, -1.57626499493532, 218, 30, 'PPL', 'P'),
(51372, 'Shepperd', 39.5933303833008, 0.691033977018507, -76.5694427490234, -1.33638888238776, 218, 25, 'PPL', 'P'),
(11904, 'Shepperd Crossing', 34.9877815246582, 0.610651985573727, -90.6002807617188, -1.58127320252327, 218, 4, 'PPL', 'P'),
(167109, 'Sheppton', 40.8974990844727, 0.713796014855414, -76.1180572509766, -1.32851071925108, 218, 45, 'PPL', 'P'),
(106203, 'Sheps End', 37.4347190856934, 0.65335910260451, -75.8686065673828, -1.32415698350102, 218, 53, 'PPL', 'P'),
(98036, 'Shepton', 33.0272216796875, 0.576433761096599, -96.7944412231445, -1.689381696972, 218, 51, 'PPL', 'P'),
(138068, 'Sherack', 48.0208282470703, 0.838121562446074, -96.7813873291016, -1.68915386354074, 218, 28, 'PPL', 'P'),
(167106, 'Sheraden', 40.4594383239746, 0.706150412260933, -80.0774993896484, -1.39761602111311, 218, 45, 'PPL', 'P'),
(106204, 'Sherando', 37.9811096191406, 0.662895416414893, -78.9541702270508, -1.37801022864212, 218, 53, 'PPL', 'P'),
(61748, 'Sherard', 34.2155609130859, 0.597174193350027, -90.7061080932617, -1.58312023789729, 218, 30, 'PPL', 'P'),
(51373, 'Sherbert', 38.6138916015625, 0.673939545455452, -76.6080627441406, -1.33706292845966, 218, 25, 'PPL', 'P'),
(126082, 'Sherborn', 42.2388916015625, 0.737207730840246, -71.3702774047852, -1.24564632877521, 218, 23, 'PPL', 'P'),
(146295, 'Sherbrook Estates', 40.3144416809082, 0.703619743435085, -74.6149978637695, -1.30227738409131, 218, 37, 'PPL', 'P'),
(24816, 'Sherbrook Forest', 33.6599998474121, 0.58747782355813, -84.5758285522461, -1.47612667583892, 218, 13, 'PPL', 'P'),
(140869, 'Sherbrooke', 47.4608306884766, 0.828347761245483, -97.7191696166992, -1.70552125212621, 218, 34, 'PPL', 'P'),
(138069, 'Sherburn', 43.6522216796875, 0.761874994120996, -94.7266693115234, -1.65329226893395, 218, 28, 'PPL', 'P'),
(138070, 'Sherburn Southside Mobile Park', 43.6488914489746, 0.761816870630205, -94.7297210693359, -1.65334553215576, 218, 28, 'PPL', 'P'),
(38186, 'Sherburne', 38.2816696166992, 0.668141177972077, -83.8027801513672, -1.46263443596631, 218, 21, 'PPL', 'P'),
(43042, 'Sherburne', 30.514720916748, 0.532582350324436, -91.7188873291016, -1.60079657015853, 218, 22, 'PPL', 'P'),
(152524, 'Sherburne', 42.6780586242676, 0.744872641352631, -75.498893737793, -1.31770427733782, 218, 40, 'PPL', 'P'),
(172523, 'Sherburne Center', 43.6591682434082, 0.761996234529622, -72.7744369506836, -1.27015353607445, 218, 55, 'PPL', 'P'),
(138072, 'Sherburne Country Mobile Home Park', 45.5438919067383, 0.794890867944981, -93.5763931274414, -1.63321616221445, 218, 28, 'PPL', 'P'),
(152525, 'Sherburne Four Corners', 42.6480598449707, 0.744349063882321, -75.5469436645508, -1.31854290676508, 218, 40, 'PPL', 'P'),
(185104, 'Sherburns (historical)', 39.8261108398438, 0.695096762419477, -123.082778930664, -2.14819974484439, 218, 6, 'PPL', 'P'),
(121442, 'Sherburnville', 41.228889465332, 0.719579868110849, -87.5447235107422, -1.52794366801054, 218, 18, 'PPL', 'P'),
(33942, 'Sherdahl', 39.8569412231445, 0.695634854117728, -97.8077774047852, -1.70706774977122, 218, 20, 'PPL', 'P'),
(11906, 'Sheridan', 34.3069381713867, 0.598769027368821, -92.4011077880859, -1.61270356339227, 218, 4, 'PPL', 'P'),
(38187, 'Sheridan', 37.3516693115234, 0.651909610602208, -88.1988906860352, -1.53936103907787, 218, 21, 'PPL', 'P'),
(43043, 'Sheridan', 30.8683300018311, 0.538753993124099, -90.003059387207, -1.57084972317475, 218, 22, 'PPL', 'P'),
(74286, 'Sheridan', 38.4688911437988, 0.671408810050577, -82.6005630493164, -1.44165178921174, 218, 41, 'PPL', 'P'),
(98037, 'Sheridan', 29.4933300018311, 0.514755715909177, -96.6708297729492, -1.68722427017293, 218, 51, 'PPL', 'P'),
(111372, 'Sheridan', 38.2402801513672, 0.667418795526393, -82.1986083984375, -1.4346363571102, 218, 58, 'PPL', 'P'),
(117762, 'Sheridan', 41.8338890075684, 0.730139102095931, -92.5911102294922, -1.61601973158164, 218, 16, 'PPL', 'P'),
(121443, 'Sheridan', 41.5299987792969, 0.724835217047956, -88.6797180175781, -1.54775305914688, 218, 18, 'PPL', 'P'),
(123666, 'Sheridan', 40.1349983215332, 0.700487865993152, -86.2205581665039, -1.50483262291278, 218, 19, 'PPL', 'P'),
(128805, 'Sheridan', 46.6572189331055, 0.814322090206526, -68.4055633544922, -1.19390230721747, 218, 26, 'PPL', 'P'),
(133080, 'Sheridan', 43.2122192382813, 0.754195502801644, -85.0736083984375, -1.48481457310503, 218, 27, 'PPL', 'P'),
(139449, 'Sheridan', 40.5180587768555, 0.707173532172714, -94.6119384765625, -1.65128983811032, 218, 29, 'PPL', 'P'),
(152527, 'Sheridan', 42.4883308410645, 0.741561266853226, -79.2375030517578, -1.38295531931223, 218, 40, 'PPL', 'P'),
(167108, 'Sheridan', 40.5872192382813, 0.708380609936793, -76.5686111450195, -1.33637436815982, 218, 45, 'PPL', 'P'),
(176366, 'Sheridan', 44.3958282470703, 0.77485337706128, -89.1980590820313, -1.55679981736988, 218, 57, 'PPL', 'P'),
(177727, 'Sheridan', 38.8980598449707, 0.678899216932534, -119.821670532227, -2.09128266602722, 218, 39, 'PPL', 'P'),
(187348, 'Sheridan', 39.6469383239746, 0.691969612088479, -105.024719238281, -1.83302714669064, 218, 7, 'PPL', 'P'),
(189556, 'Sheridan', 35.4958305358887, 0.619519113581201, -105.243606567383, -1.83684745127436, 218, 38, 'PPL', 'P'),
(192910, 'Sheridan', 38.9797210693359, 0.680324474168917, -121.374443054199, -2.11838365907014, 218, 6, 'PPL', 'P'),
(197524, 'Sheridan', 45.4555587768555, 0.793349163989934, -112.196113586426, -1.95819159002467, 218, 31, 'PPL', 'P'),
(201559, 'Sheridan', 45.0994415283203, 0.787133745479853, -123.393608093262, -2.15362473714294, 218, 43, 'PPL', 'P'),
(208720, 'Sheridan', 47.5911102294922, 0.830621568184193, -122.639999389648, -2.1404717839932, 218, 56, 'PPL', 'P'),
(209730, 'Sheridan', 44.7972183227539, 0.781858955466788, -106.955558776855, -1.86672665396645, 218, 59, 'PPL', 'P'),
(202611, 'Sheridan (historical)', 43.9769401550293, 0.767542400657767, -103.470001220703, -1.80589219834382, 218, 49, 'PPL', 'P'),
(208718, 'Sheridan Beach', 47.7449989318848, 0.833307432722565, -122.28694152832, -2.13430976186298, 218, 56, 'PPL', 'P'),
(28591, 'Sheridan Estates', 39.8866691589355, 0.696153704477103, -91.379997253418, -1.59488182253552, 218, 18, 'PPL', 'P'),
(187349, 'Sheridan Lake', 38.4666709899902, 0.671370061056716, -102.29167175293, -1.7853264694579, 218, 7, 'PPL', 'P'),
(208719, 'Sheridan Park', 47.5849990844727, 0.830514908582535, -122.634719848633, -2.14037963861948, 218, 56, 'PPL', 'P'),
(14603, 'Sheridan Square', 39.725830078125, 0.693346532951077, -75.6547164916992, -1.320423897443, 218, 10, 'PPL', 'P'),
(197526, 'Sheridan Trailer Court', 45.4608306884766, 0.793441176205597, -112.195556640625, -1.95818186948669, 218, 31, 'PPL', 'P'),
(13208, 'Sheridan-Kalorama', 38.9144401550293, 0.679185107275554, -77.0500030517578, -1.34477624192485, 218, 9, 'PPL', 'P'),
(192207, 'Sherlock', 36.4455604553223, 0.636095027680017, -100.223609924316, -1.74923198141379, 218, 51, 'PPL', 'P'),
(152530, 'Sherlock Corners', 42.896671295166, 0.748688152246387, -76.5663909912109, -1.33633561916596, 218, 40, 'PPL', 'P'),
(51374, 'Sherlock Holmes Estates', 39.4225006103516, 0.688052435020109, -76.9194412231445, -1.34249750813813, 218, 25, 'PPL', 'P'),
(51375, 'Sherlock Mobile Home Estates', 38.2569389343262, 0.667709546138402, -76.4683303833008, -1.33462413869142, 218, 25, 'PPL', 'P'),
(18065, 'Sherman', 27.2102794647217, 0.474908967047194, -80.7555618286133, -1.40945044320715, 218, 12, 'PPL', 'P'),
(28590, 'Sherman', 39.8936080932617, 0.696274811727674, -89.6047210693359, -1.56389740799105, 218, 18, 'PPL', 'P'),
(33949, 'Sherman', 37.2572212219238, 0.650261180466476, -95.0569381713867, -1.65905654795538, 218, 20, 'PPL', 'P'),
(38188, 'Sherman', 38.7324981689453, 0.676009620570771, -84.5966720581055, -1.47649046364383, 218, 21, 'PPL', 'P'),
(57533, 'Sherman', 38.5377807617188, 0.672611160703721, -90.5919418334961, -1.5811276607697, 218, 29, 'PPL', 'P'),
(61749, 'Sherman', 34.3591690063477, 0.599680627409955, -88.8411102294922, -1.55056988463185, 218, 30, 'PPL', 'P'),
(98038, 'Sherman', 33.6355590820313, 0.587051251730527, -96.6086120605469, -1.68613836623845, 218, 51, 'PPL', 'P'),
(111373, 'Sherman', 38.9916687011719, 0.68053299968227, -81.7619400024414, -1.42701505586066, 218, 58, 'PPL', 'P'),
(114054, 'Sherman', 41.5791702270508, 0.725693420709234, -73.4961090087891, -1.28274908960804, 218, 8, 'PPL', 'P'),
(117768, 'Sherman', 42.353889465332, 0.739214822195785, -93.3736114501953, -1.62967695428379, 218, 16, 'PPL', 'P'),
(128798, 'Sherman', 45.8711090087891, 0.800601883744602, -68.418327331543, -1.19412508064265, 218, 26, 'PPL', 'P'),
(133089, 'Sherman', 44.4238891601563, 0.775343132385745, -85.6966705322266, -1.49568905878415, 218, 27, 'PPL', 'P'),
(138075, 'Sherman', 44.9477806091309, 0.784486763093396, -94.1333312988281, -1.64293656703518, 218, 28, 'PPL', 'P'),
(152529, 'Sherman', 42.1591682434082, 0.735816295749707, -79.5955581665039, -1.38920455996815, 218, 40, 'PPL', 'P'),
(167110, 'Sherman', 41.9874992370605, 0.732820106365314, -75.4266662597656, -1.31644367003583, 218, 45, 'PPL', 'P'),
(171288, 'Sherman', 43.7591705322266, 0.763741603729033, -96.475830078125, -1.68382088345786, 218, 49, 'PPL', 'P'),
(189557, 'Sherman', 32.7466697692871, 0.571537206537352, -107.885833740234, -1.88296301502628, 218, 38, 'PPL', 'P'),
(193951, 'Sherman', 40.7147216796875, 0.710605947343663, -122.240562438965, -2.13350029404965, 218, 6, 'PPL', 'P'),
(208721, 'Sherman', 47.8274993896484, 0.834747337344944, -118.603889465332, -2.07002837684146, 218, 56, 'PPL', 'P'),
(209732, 'Sherman', 41.0977783203125, 0.717291546944198, -105.350280761719, -1.83870926719243, 218, 59, 'PPL', 'P'),
(157633, 'Sherman (historical)', 41.0138893127441, 0.7158274075559, -81.6677780151367, -1.42537161915198, 218, 41, 'PPL', 'P'),
(200204, 'Sherman (historical)', 40.1313896179199, 0.700424882233372, -115.662780761719, -2.01869634630435, 218, 39, 'PPL', 'P'),
(185106, 'Sherman Acres', 38.4472198486328, 0.671030574596759, -120.070831298828, -2.09563134177121, 218, 6, 'PPL', 'P'),
(133088, 'Sherman City', 43.7266693115234, 0.763174350416846, -85.0772171020508, -1.48487755686481, 218, 27, 'PPL', 'P'),
(106205, 'Sherman Corner', 37.2594413757324, 0.650299929460336, -77.283332824707, -1.34884861470575, 218, 53, 'PPL', 'P'),
(114055, 'Sherman Corner', 41.7700004577637, 0.729024036547515, -72.1366729736328, -1.2590224548243, 218, 8, 'PPL', 'P'),
(126086, 'Sherman Corner', 42.1841697692871, 0.736252654694317, -70.7786102294922, -1.23531978849038, 218, 23, 'PPL', 'P'),
(121445, 'Sherman Corners', 42.3436088562012, 0.739035391717341, -87.9449996948242, -1.53492980534009, 218, 18, 'PPL', 'P'),
(157634, 'Sherman Corners', 41.2383308410645, 0.719744651203297, -81.7855606079102, -1.42742731319741, 218, 41, 'PPL', 'P'),
(18066, 'Sherman Grove', 30.350830078125, 0.529721915576609, -87.3605575561523, -1.52472936573287, 218, 12, 'PPL', 'P'),
(5803, 'Sherman Heights', 33.5213890075684, 0.585058608023902, -86.9052810668945, -1.5167832919884, 218, 2, 'PPL', 'P'),
(208722, 'Sherman Heights', 47.5444412231445, 0.829807040364792, -122.67749786377, -2.14112625583109, 218, 56, 'PPL', 'P'),
(98039, 'Sherman Junction', 33.6549987792969, 0.587390538453403, -96.5511093139648, -1.68513475398165, 218, 51, 'PPL', 'P'),
(128799, 'Sherman Mills', 45.8730583190918, 0.800635905627527, -68.3852767944336, -1.19354823995054, 218, 26, 'PPL', 'P'),
(18067, 'Sherman Oaks', 29.1894397735596, 0.509451830861203, -82.2561111450195, -1.43563996936699, 218, 12, 'PPL', 'P'),
(185108, 'Sherman Oaks', 34.1511116027832, 0.596049340684605, -118.448333740234, -2.06731341726818, 218, 6, 'PPL', 'P'),
(18068, 'Sherman Park', 28.1722202301025, 0.491698000612244, -80.6494369506836, -1.407598214669, 218, 12, 'PPL', 'P'),
(83611, 'Sherman Park', 35.0050010681152, 0.610952523302743, -81.9908294677734, -1.43100993065384, 218, 48, 'PPL', 'P'),
(106206, 'Sherman Park', 37.2597198486328, 0.650304789729326, -77.2850036621094, -1.34887777631968, 218, 53, 'PPL', 'P'),
(133090, 'Sherman Park', 42.4919395446777, 0.741624250613007, -86.0819396972656, -1.5024132742205, 218, 27, 'PPL', 'P'),
(152531, 'Sherman Park', 41.1266708374023, 0.717795816496604, -73.7755584716797, -1.28762640282841, 218, 40, 'PPL', 'P'),
(189558, 'Sherman Place', 33.2872200012207, 0.580971587857012, -104.629440307617, -1.82612822788679, 218, 38, 'PPL', 'P'),
(128800, 'Sherman Station', 45.899169921875, 0.801091639069067, -68.4300003051758, -1.19432881246604, 218, 26, 'PPL', 'P'),
(152533, 'Shermans Bay', 42.0988883972168, 0.734764213961072, -79.3483276367188, -1.38488957321195, 218, 40, 'PPL', 'P'),
(128803, 'Shermans Corner', 44.4580612182617, 0.775939547311868, -69.0069427490234, -1.20439835770569, 218, 26, 'PPL', 'P'),
(138077, 'Shermans Corner', 47.7791709899902, 0.833903847648688, -92.6561126708984, -1.61715423820601, 218, 28, 'PPL', 'P'),
(167114, 'Shermans Dale', 40.3241691589355, 0.703789519954578, -77.1733322143555, -1.34692874187591, 218, 45, 'PPL', 'P'),
(128804, 'Shermans Mill', 44.2794418334961, 0.772822050939822, -69.2352828979492, -1.20838364511894, 218, 26, 'PPL', 'P'),
(167111, 'Shermansville', 41.6258316040039, 0.726507815370581, -80.3741683959961, -1.4027938720625, 218, 45, 'PPL', 'P'),
(24817, 'Shermantown', 33.7555618286133, 0.58914569476982, -84.3797225952148, -1.47270398120595, 218, 13, 'PPL', 'P'),
(190726, 'Shermantown', 39.2027816772461, 0.684217616208449, -115.503608703613, -2.01591826981323, 218, 39, 'PPL', 'P'),
(167112, 'Shernerville', 40.7180595397949, 0.710664203992508, -75.1911087036133, -1.31233241510302, 218, 45, 'PPL', 'P'),
(111375, 'Sherrard', 39.9872207641602, 0.697908661056438, -80.6761093139648, -1.40806373522755, 218, 58, 'PPL', 'P'),
(121448, 'Sherrard', 41.3188896179199, 0.721150667100804, -90.5058288574219, -1.57962470580851, 218, 18, 'PPL', 'P'),
(187350, 'Sherrelwood', 39.8377799987793, 0.695300427663841, -105.000831604004, -1.83261022882199, 218, 7, 'PPL', 'P'),
(167113, 'Sherrett', 40.9347190856934, 0.714445626424312, -79.5713882446289, -1.38878271525149, 218, 45, 'PPL', 'P'),
(24818, 'Sherrian Estates', 33.7069396972656, 0.588297078488466, -84.7813873291016, -1.47971435330142, 218, 13, 'PPL', 'P'),
(90774, 'Sherril Heights', 35.5036087036133, 0.619654868217767, -84.3833312988281, -1.47276696496573, 218, 50, 'PPL', 'P'),
(11910, 'Sherrill', 34.3852806091309, 0.600136360851495, -91.9505615234375, -1.6048400476416, 218, 4, 'PPL', 'P'),
(57537, 'Sherrill', 37.5886116027832, 0.65604503372191, -91.876106262207, -1.60354055818769, 218, 29, 'PPL', 'P'),
(117778, 'Sherrill', 42.603889465332, 0.74357814532577, -90.7844390869141, -1.58448737164288, 218, 16, 'PPL', 'P'),
(152534, 'Sherrill', 43.0736083984375, 0.751776287267416, -75.5986099243164, -1.31944465311018, 218, 40, 'PPL', 'P'),
(51376, 'Sherrill Gardens', 39.6816711425781, 0.692575814131609, -76.3744430541992, -1.33298549567269, 218, 25, 'PPL', 'P'),
(68737, 'Sherrills Ford', 35.6202812194824, 0.621691187766269, -80.9866714477539, -1.41348406699419, 218, 33, 'PPL', 'P'),
(90775, 'Sherrilltown', 36.0488891601563, 0.62917180753122, -86.2027816772461, -1.50452236464578, 218, 50, 'PPL', 'P'),
(43044, 'Sherrington Place', 30.5947208404541, 0.533978612394451, -91.0194396972656, -1.58858890603772, 218, 22, 'PPL', 'P'),
(74287, 'Sherritts', 38.6925010681152, 0.675311539470034, -82.5208282470703, -1.44026015438412, 218, 41, 'PPL', 'P'),
(157636, 'Sherrodsville', 40.4947204589844, 0.706766201683987, -81.2430572509766, -1.41795884341579, 218, 41, 'PPL', 'P'),
(98040, 'Sherry', 33.5433311462402, 0.585441570588656, -95.102783203125, -1.65985669470489, 218, 51, 'PPL', 'P'),
(113402, 'Sherry', 44.584171295166, 0.778140583373792, -89.9155578613281, -1.56932253344765, 218, 57, 'PPL', 'P'),
(106207, 'Sherry Court', 37.353889465332, 0.651948359596068, -79.9725036621094, -1.39578349996703, 218, 53, 'PPL', 'P'),
(176382, 'Sherry Junction', 45.2191696166992, 0.789223394829184, -88.9877777099609, -1.55312971507164, 218, 57, 'PPL', 'P'),
(106208, 'Sherry Park', 36.8205604553223, 0.642640012374996, -76.2177810668945, -1.33025122818151, 218, 53, 'PPL', 'P'),
(197527, 'Sherryl', 46.5527801513672, 0.812499289598422, -113.217216491699, -1.97601319772337, 218, 31, 'PPL', 'P'),
(117779, 'Sherton Heights', 41.5924987792969, 0.725926047830453, -90.4263916015625, -1.57823826414501, 218, 16, 'PPL', 'P'),
(51377, 'Shervettes Corner', 39.396671295166, 0.687601628426586, -76.8955612182617, -1.34208072342753, 218, 25, 'PPL', 'P'),
(106209, 'Sherwill', 37.2822189331055, 0.650697472832058, -78.9599990844727, -1.37811196139576, 218, 53, 'PPL', 'P'),
(33960, 'Sherwin', 37.1800003051758, 0.648913421217814, -94.9475021362305, -1.65714652882157, 218, 20, 'PPL', 'P'),
(167115, 'Sherwin', 41.0044403076172, 0.715662491305396, -79.945556640625, -1.39531318571852, 218, 45, 'PPL', 'P'),
(193155, 'Sherwin', 46.9477806091309, 0.819393348133283, -116.346939086914, -2.03063716168394, 218, 17, 'PPL', 'P'),
(14604, 'Sherwood', 39.1430587768555, 0.683175254957792, -75.5347213745117, -1.31832958756177, 218, 10, 'PPL', 'P'),
(24819, 'Sherwood', 33.4077796936035, 0.583075751434284, -82.0086135864258, -1.43132032207889, 218, 13, 'PPL', 'P'),
(43045, 'Sherwood', 31.8502807617188, 0.5558922669766, -91.9477767944336, -1.6047914449517, 218, 22, 'PPL', 'P'),
(51379, 'Sherwood', 38.7613906860352, 0.676513890123177, -76.3191680908203, -1.33202076556781, 218, 25, 'PPL', 'P'),
(61750, 'Sherwood', 33.4877815246582, 0.584472046793812, -89.1338882446289, -1.55567982497344, 218, 30, 'PPL', 'P'),
(68738, 'Sherwood', 36.269718170166, 0.63302600083981, -81.7766723632813, -1.42727218406391, 218, 33, 'PPL', 'P'),
(77239, 'Sherwood', 34.3311080932617, 0.599190872085489, -94.7780609130859, -1.65418922158909, 218, 42, 'PPL', 'P'),
(90776, 'Sherwood', 35.0761108398438, 0.612193622949747, -85.9233322143555, -1.49964505142541, 218, 50, 'PPL', 'P'),
(111376, 'Sherwood', 39.2794418334961, 0.685555588340105, -80.6777801513672, -1.40809289684149, 218, 58, 'PPL', 'P'),
(112243, 'Sherwood', 34.814998626709, 0.607636355113376, -92.2241668701172, -1.60961536179222, 218, 4, 'PPL', 'P'),
(117780, 'Sherwood', 42.3591690063477, 0.739306967569501, -94.7266693115234, -1.65329226893395, 218, 16, 'PPL', 'P'),
(133100, 'Sherwood', 42.0013885498047, 0.733062520603538, -85.2386093139648, -1.48769438234979, 218, 27, 'PPL', 'P'),
(138078, 'Sherwood', 47.4516716003418, 0.828187905001051, -92.7408294677734, -1.61863282524323, 218, 28, 'PPL', 'P'),
(152536, 'Sherwood', 42.7608299255371, 0.746317273085944, -76.6216735839844, -1.33730048242889, 218, 40, 'PPL', 'P'),
(157637, 'Sherwood', 41.2872200012207, 0.720597928016559, -84.5536117553711, -1.47573891958421, 218, 41, 'PPL', 'P'),
(176374, 'Sherwood', 44.4674987792969, 0.77610426382529, -90.3555603027344, -1.577002024767, 218, 57, 'PPL', 'P'),
(192209, 'Sherwood', 31.2811107635498, 0.545958376504981, -100.794998168945, -1.75920458758975, 218, 51, 'PPL', 'P'),
(198889, 'Sherwood', 48.9599990844727, 0.854513185797457, -101.632217407227, -1.7738168198588, 218, 34, 'PPL', 'P'),
(201561, 'Sherwood', 45.3566703796387, 0.791623235866481, -122.838890075684, -2.14394308131607, 218, 43, 'PPL', 'P'),
(57540, 'Sherwood (historical)', 37.4275016784668, 0.65323313508495, -94.1772232055664, -1.64370262532274, 218, 29, 'PPL', 'P'),
(157638, 'Sherwood (historical)', 40.8052787780762, 0.712186466871598, -81.5550003051758, -1.4234032767903, 218, 41, 'PPL', 'P'),
(14605, 'Sherwood Acres', 38.5361099243164, 0.672581999089784, -75.1458282470703, -1.31154212204954, 218, 10, 'PPL', 'P'),
(68739, 'Sherwood Acres', 35.5819396972656, 0.62102200196336, -77.3822174072266, -1.35057447625017, 218, 33, 'PPL', 'P'),
(83613, 'Sherwood Acres', 34.9141693115234, 0.609367210084846, -81.9433288574219, -1.43018088860649, 218, 48, 'PPL', 'P'),
(195604, 'Sherwood Beach', 48.4966697692871, 0.846426563726459, -116.83943939209, -2.03923291357633, 218, 17, 'PPL', 'P'),
(24832, 'Sherwood Estates', 33.8672218322754, 0.591094529476512, -84.621940612793, -1.47693148312035, 218, 13, 'PPL', 'P'),
(90778, 'Sherwood Estates', 36.2105598449707, 0.631993493285186, -83.2227783203125, -1.45251149434681, 218, 50, 'PPL', 'P'),
(90780, 'Sherwood Farm', 35.9222183227539, 0.626960984352291, -85.0736083984375, -1.48481457310503, 218, 50, 'PPL', 'P'),
(106210, 'Sherwood Farms', 38.014720916748, 0.663482044224011, -78.5405578613281, -1.37079133103329, 218, 53, 'PPL', 'P'),
(5810, 'Sherwood Forest', 34.8436088562012, 0.608135697817766, -87.6816711425781, -1.53033385508889, 218, 2, 'PPL', 'P'),
(14606, 'Sherwood Forest', 39.6708297729492, 0.692386596536158, -75.6902770996094, -1.32104454713505, 218, 10, 'PPL', 'P'),
(18069, 'Sherwood Forest', 30.4097194671631, 0.530749729309811, -81.7244415283203, -1.42636058402278, 218, 12, 'PPL', 'P'),
(24827, 'Sherwood Forest', 33.877498626709, 0.591273893375929, -83.3802795410156, -1.45526040922399, 218, 13, 'PPL', 'P'),
(31115, 'Sherwood Forest', 39.9188919067383, 0.6967160975203, -86.1297225952148, -1.50324724311585, 218, 19, 'PPL', 'P'),
(43046, 'Sherwood Forest', 32.5405616760254, 0.567939941694927, -92.1888885498047, -1.60899963894819, 218, 22, 'PPL', 'P'),
(51383, 'Sherwood Forest', 38.3675003051758, 0.669639206085247, -75.1508331298828, -1.31162947373329, 218, 25, 'PPL', 'P'),
(61751, 'Sherwood Forest', 32.2083282470703, 0.562141374474471, -89.9669418334961, -1.57021935294473, 218, 30, 'PPL', 'P'),
(68743, 'Sherwood Forest', 35.1441688537598, 0.613381459374949, -82.6875, -1.44316912524281, 218, 33, 'PPL', 'P'),
(83617, 'Sherwood Forest', 33.9213905334473, 0.59203995166349, -80.3008270263672, -1.40151382368455, 218, 48, 'PPL', 'P'),
(90782, 'Sherwood Forest', 36.2227783203125, 0.632206745909474, -86.595832824707, -1.51138240129772, 218, 50, 'PPL', 'P'),
(106214, 'Sherwood Forest', 37.2425003051758, 0.65000425200031, -79.9430618286133, -1.3952696430347, 218, 53, 'PPL', 'P'),
(126084, 'Sherwood Forest', 41.7069396972656, 0.727923418648012, -70.9277801513672, -1.23792329477204, 218, 23, 'PPL', 'P'),
(172524, 'Sherwood Forest', 43.228328704834, 0.754476666033729, -72.8411102294922, -1.27131720431276, 218, 55, 'PPL', 'P'),
(176375, 'Sherwood Forest', 43.8316688537598, 0.765006938141957, -88.9783325195313, -1.55296486540016, 218, 57, 'PPL', 'P'),
(185110, 'Sherwood Forest', 38.0291709899902, 0.663734245579241, -120.223327636719, -2.09829290496464, 218, 6, 'PPL', 'P'),
(98041, 'Sherwood Forest Colonia', 27.9270000457764, 0.487418101003405, -97.1679992675781, -1.69590151479468, 218, 51, 'PPL', 'P'),
(179139, 'Sherwood Forest Estates', 35.2405586242676, 0.615063778235552, -112.044166564941, -1.95553961421117, 218, 5, 'PPL', 'P'),
(176376, 'Sherwood Forest Heights', 43.2333297729492, 0.754563951138456, -89.2383270263672, -1.55750262558155, 218, 57, 'PPL', 'P'),
(14607, 'Sherwood Forest Mobile Home Park', 38.6349983215332, 0.674307927213237, -75.195556640625, -1.31241004624879, 218, 10, 'PPL', 'P'),
(176377, 'Sherwood Glen', 43.1661109924316, 0.753390762099249, -89.2916717529297, -1.55843366669864, 218, 57, 'PPL', 'P'),
(68753, 'Sherwood Greens', 35.5680618286133, 0.620779787462217, -77.3116683959961, -1.34934316372018, 218, 33, 'PPL', 'P'),
(51384, 'Sherwood Hills', 39.4874992370605, 0.689186875065455, -76.6266708374023, -1.33738770095459, 218, 25, 'PPL', 'P'),
(106217, 'Sherwood Hills', 37.2752799987793, 0.650576365581487, -77.4205627441406, -1.35124372863211, 218, 53, 'PPL', 'P'),
(205724, 'Sherwood Hills', 40.6111106872559, 0.708797594384472, -111.792778015137, -1.95115205631527, 218, 52, 'PPL', 'P'),
(205725, 'Sherwood Hills Condo', 40.6119384765625, 0.708812042033386, -111.790832519531, -1.95111810101137, 218, 52, 'PPL', 'P'),
(152538, 'Sherwood Knolls', 43.0374984741211, 0.751146050195449, -76.2594375610352, -1.3309782711591, 218, 40, 'PPL', 'P'),
(51387, 'Sherwood Manor', 38.3869400024414, 0.669978492808123, -75.5486068725586, -1.31857193522096, 218, 25, 'PPL', 'P'),
(106218, 'Sherwood Manor', 38.0069389343262, 0.663346223008417, -78.5252838134766, -1.37052474860817, 218, 53, 'PPL', 'P'),
(114057, 'Sherwood Manor', 42.0133285522461, 0.733270912958837, -72.5647201538086, -1.26649328747225, 218, 8, 'PPL', 'P'),
(138079, 'Sherwood Manor', 45.5613899230957, 0.795196265942986, -94.1377792358398, -1.64301419818096, 218, 28, 'PPL', 'P'),
(121449, 'Sherwood Oaks', 42.0263900756836, 0.733498879548148, -88.2252807617188, -1.5398216327884, 218, 18, 'PPL', 'P'),
(205727, 'Sherwood Oaks Condominium', 41.1616706848145, 0.718406679071641, -112.042503356934, -1.95551058575529, 218, 52, 'PPL', 'P'),
(5815, 'Sherwood Park', 34.7197189331055, 0.605973410749703, -86.6624984741211, -1.51254593637798, 218, 2, 'PPL', 'P'),
(14608, 'Sherwood Park', 39.7361106872559, 0.693525963429522, -75.658332824707, -1.32048701436084, 218, 10, 'PPL', 'P'),
(18070, 'Sherwood Park', 26.4449996948242, 0.461552315363578, -80.1116714477539, -1.39821243603924, 218, 12, 'PPL', 'P'),
(68754, 'Sherwood Park', 35.1380615234375, 0.613274866352319, -79.4691696166992, -1.38699866363724, 218, 33, 'PPL', 'P'),
(106219, 'Sherwood Park', 37.0577812194824, 0.646780295763688, -76.3491668701172, -1.33254434303812, 218, 53, 'PPL', 'P'),
(152537, 'Sherwood Park', 42.6047210693359, 0.743592659553711, -73.7180633544922, -1.28662292372966, 218, 40, 'PPL', 'P'),
(167116, 'Sherwood Park', 40.2849998474121, 0.703105886502755, -76.9583282470703, -1.34317621474193, 218, 45, 'PPL', 'P'),
(98042, 'Sherwood Place', 29.8733291625977, 0.52138795241937, -95.3211135864258, -1.66366727875063, 218, 51, 'PPL', 'P'),
(38190, 'Sherwood Shores', 36.9300003051758, 0.644550098087828, -88.2200012207031, -1.53972948741469, 218, 21, 'PPL', 'P'),
(98045, 'Sherwood Shores', 33.8522186279297, 0.59083267416233, -96.817497253418, -1.68978410061271, 218, 51, 'PPL', 'P'),
(68757, 'Sherwood Terrace', 35.146110534668, 0.613415348099821, -82.6744384765625, -1.4429411586535, 218, 33, 'PPL', 'P'),
(68758, 'Sherwood Village', 35.9427795410156, 0.627319845309179, -79.9861068725586, -1.39602092077821, 218, 33, 'PPL', 'P'),
(74294, 'Sherwood Village', 39.0844383239746, 0.682152135046011, -84.3647232055664, -1.4724421924708, 218, 41, 'PPL', 'P'),
(212144, 'Sheshalik', 66.9941711425781, 1.16926886608256, -162.828063964844, -2.84188583083446, 218, 1, 'PPL', 'P'),
(138080, 'Sheshebee', 46.704719543457, 0.815151132253868, -93.2422180175781, -1.62738370626912, 218, 28, 'PPL', 'P'),
(167117, 'Sheshequin', 41.855281829834, 0.73051247728076, -76.4911117553711, -1.33502174864216, 218, 45, 'PPL', 'P'),
(143012, 'Shestak', 40.5680618286133, 0.708046250061933, -96.9630584716797, -1.69232462313459, 218, 35, 'PPL', 'P'),
(38191, 'Shetland', 38.0472183227539, 0.66404923095717, -84.7052764892578, -1.47838596854969, 218, 21, 'PPL', 'P'),
(51388, 'Shetland Hills', 39.4261093139648, 0.688115418779889, -76.6083297729492, -1.33706758899156, 218, 25, 'PPL', 'P'),
(51389, 'Shetland Square', 39.1316719055176, 0.682976516561445, -76.6208267211914, -1.33728570188484, 218, 25, 'PPL', 'P'),
(28592, 'Shetlerville', 37.4305610656738, 0.653286531464806, -88.4075012207031, -1.54300197976218, 218, 18, 'PPL', 'P'),
(167119, 'Shettleston', 41.0794410705566, 0.716971501560198, -77.8930587768555, -1.3594903401056, 218, 45, 'PPL', 'P'),
(106220, 'Sheva', 36.8658294677734, 0.643430105691395, -79.3349990844727, -1.38465694609073, 218, 53, 'PPL', 'P'),
(138082, 'Shevlin', 47.5302810668945, 0.829559899015633, -95.2583312988281, -1.66257152112012, 218, 28, 'PPL', 'P'),
(68759, 'Shewbird', 35.0083312988281, 0.611010646793534, -83.8333282470703, -1.46316760081654, 218, 33, 'PPL', 'P'),
(24839, 'Shewmake', 32.5138893127441, 0.567474421136382, -83.0347213745117, -1.44922928146134, 218, 13, 'PPL', 'P'),
(114058, 'Shewville', 41.4883308410645, 0.724107974333283, -71.995002746582, -1.25654984291022, 218, 8, 'PPL', 'P'),
(43054, 'Shexnayder', 30.728889465332, 0.536320296651444, -91.4519424438477, -1.59613750298949, 218, 22, 'PPL', 'P'),
(90786, 'Sheybogan', 35.753059387207, 0.624008603967829, -86.0536117553711, -1.50191885836412, 218, 50, 'PPL', 'P'),
(140872, 'Sheyenne', 47.8280601501465, 0.83475712446195, -99.1197204589844, -1.72996547566566, 218, 34, 'PPL', 'P'),
(133104, 'Shiawasseetown', 42.9294395446777, 0.749260066090482, -84.0794372558594, -1.46746301333873, 218, 27, 'PPL', 'P'),
(57541, 'Shibboleth', 38.0055618286133, 0.663322187979579, -90.7052764892578, -1.58310572366935, 218, 29, 'PPL', 'P'),
(11909, 'Shibley', 35.4502792358398, 0.618724093416785, -94.2936096191406, -1.6457339514442, 218, 4, 'PPL', 'P'),
(139452, 'Shibleys Point', 40.3133316040039, 0.703600368938155, -92.7608337402344, -1.61898196566214, 218, 29, 'PPL', 'P'),
(143013, 'Shickley', 40.4166717529297, 0.705403994786411, -97.7222213745117, -1.70557451534801, 218, 35, 'PPL', 'P'),
(167120, 'Shickshinny', 41.1530609130859, 0.718256410207134, -76.1505584716797, -1.32907797256327, 218, 45, 'PPL', 'P'),
(123667, 'Shideler', 40.3061103820801, 0.703474334839567, -85.3597183227539, -1.48980813330699, 218, 19, 'PPL', 'P'),
(77240, 'Shidler', 36.7819404602051, 0.641965966303097, -96.6608276367188, -1.68704969996347, 218, 42, 'PPL', 'P'),
(28593, 'Shields', 38.4677810668945, 0.671389435553647, -88.7133331298828, -1.54833975353502, 218, 18, 'PPL', 'P'),
(31116, 'Shields', 38.915828704834, 0.679209342041474, -86.0033264160156, -1.50104121362689, 218, 19, 'PPL', 'P'),
(38193, 'Shields', 36.8963890075684, 0.643963470278711, -83.1419372558594, -1.45110055160129, 218, 21, 'PPL', 'P'),
(98046, 'Shields', 31.5930595397949, 0.551402909748026, -99.4238891601563, -1.73527422098263, 218, 51, 'PPL', 'P'),
(106222, 'Shields', 37.5699996948242, 0.655720194647947, -75.853889465332, -1.32390012161389, 218, 53, 'PPL', 'P'),
(133105, 'Shields', 43.4152793884277, 0.757739571001294, -84.0563888549805, -1.46706074285608, 218, 27, 'PPL', 'P'),
(167122, 'Shields', 40.5625, 0.7079491778402, -80.2038879394531, -1.39982191744403, 218, 45, 'PPL', 'P'),
(187902, 'Shields', 38.6155586242676, 0.673968640490361, -100.444717407227, -1.75309103499137, 218, 20, 'PPL', 'P'),
(197528, 'Shields', 45.9569396972656, 0.802099911857771, -110.639999389648, -1.93103227375388, 218, 31, 'PPL', 'P'),
(198891, 'Shields', 46.2336082458496, 0.806928688967276, -101.125556945801, -1.76497392661724, 218, 34, 'PPL', 'P'),
(24833, 'Shields (historical)', 33.6672210693359, 0.587603857656718, -83.4063873291016, -1.4557160760865, 218, 13, 'PPL', 'P'),
(197529, 'Shields Crossing', 48.4722213745117, 0.845999858740801, -112.357498168945, -1.9610082823516, 218, 31, 'PPL', 'P'),
(167123, 'Shieldsburg', 40.3925018310547, 0.704982150069743, -79.4380569458008, -1.38645564509097, 218, 45, 'PPL', 'P'),
(138086, 'Shieldsville', 44.3661117553711, 0.774334726438987, -93.4086074829102, -1.6302877502798, 218, 28, 'PPL', 'P'),
(38192, 'Shiff', 38.2405586242676, 0.667423655795382, -84.5961074829102, -1.4764806099478, 218, 21, 'PPL', 'P'),
(128, 'Shifflet Corner', 38.3086090087891, 0.66861135906253, -78.2733306884766, -1.36612733701624, 218, 53, 'PPL', 'P'),
(197530, 'Shigley Mobile Home Park', 45.9294395446777, 0.801619943650312, -114.105560302734, -1.99151772211565, 218, 31, 'PPL', 'P'),
(157640, 'Shihold', 41.2602806091309, 0.720127746926105, -80.9550018310547, -1.41293132790994, 218, 41, 'PPL', 'P'),
(74290, 'Shilling (historical)', 39.5625, 0.690495885320257, -81.9899978637695, -1.4309954164259, 218, 41, 'PPL', 'P'),
(189559, 'Shillingburg (historical)', 35.7077789306641, 0.623218310914348, -108.284172058105, -1.88991533020998, 218, 38, 'PPL', 'P'),
(157641, 'Shillings Mill', 41.0583305358887, 0.716603053223385, -80.9861068725586, -1.41347421329816, 218, 41, 'PPL', 'P'),
(167124, 'Shillington', 40.3077812194824, 0.703503496453503, -75.9658279418945, -1.32585381658957, 218, 45, 'PPL', 'P'),
(11911, 'Shilo (historical)', 35.9030609130859, 0.626626624477431, -92.5277786254883, -1.6149143865712, 218, 4, 'PPL', 'P'),
(5824, 'Shiloh', 31.7811107635498, 0.554685022764953, -85.7441711425781, -1.4965181008315, 218, 2, 'PPL', 'P'),
(11919, 'Shiloh', 35.1180610656738, 0.612925792512437, -90.8472213745117, -1.5855831292734, 218, 4, 'PPL', 'P'),
(18071, 'Shiloh', 28.7902793884277, 0.502485167897123, -80.8047180175781, -1.41030838055232, 218, 12, 'PPL', 'P'),
(24837, 'Shiloh', 32.1525001525879, 0.561166990410638, -84.3097229003906, -1.47148225605588, 218, 13, 'PPL', 'P'),
(28594, 'Shiloh', 38.5613899230957, 0.673023218303383, -89.897216796875, -1.56900242148462, 218, 18, 'PPL', 'P'),
(31117, 'Shiloh', 39.038890838623, 0.681357181460623, -87.2925033569336, -1.52354159588669, 218, 19, 'PPL', 'P'),
(38194, 'Shiloh', 36.6858291625977, 0.640288507711483, -88.2136077880859, -1.53961790096501, 218, 21, 'PPL', 'P'),
(43057, 'Shiloh', 30.686939239502, 0.535588127088754, -90.5077819824219, -1.57965879427046, 218, 22, 'PPL', 'P'),
(51393, 'Shiloh', 38.3641700744629, 0.669581082594456, -76.9255599975586, -1.34260430089784, 218, 25, 'PPL', 'P'),
(61758, 'Shiloh', 34.1338882446289, 0.595748736376562, -88.5961074829102, -1.54629378002757, 218, 30, 'PPL', 'P'),
(68763, 'Shiloh', 35.2997207641602, 0.616096352369203, -81.9411087036133, -1.43014213961263, 218, 33, 'PPL', 'P'),
(77241, 'Shiloh', 35.8055610656738, 0.624924931119898, -97.1591720581055, -1.69574745092562, 218, 42, 'PPL', 'P'),
(83627, 'Shiloh', 33.939998626709, 0.592364724158426, -80.0411071777344, -1.39698085719313, 218, 48, 'PPL', 'P'),
(90796, 'Shiloh', 35.8611106872559, 0.625894454914741, -86.3305587768555, -1.50675249574262, 218, 50, 'PPL', 'P'),
(98052, 'Shiloh', 30.4922199249268, 0.53218963393219, -97.2024993896484, -1.69650365551714, 218, 51, 'PPL', 'P'),
(106228, 'Shiloh', 36.8011093139648, 0.642300525915038, -81.083610534668, -1.41517597323472, 218, 53, 'PPL', 'P'),
(111379, 'Shiloh', 39.4561080932617, 0.688638996250199, -81.0116729736328, -1.4139204259388, 218, 58, 'PPL', 'P'),
(128806, 'Shiloh', 43.9761085510254, 0.767527886429826, -70.0469436645508, -1.22254979790539, 218, 26, 'PPL', 'P'),
(133106, 'Shiloh', 43.1047210693359, 0.752319305813683, -85.0849990844727, -1.48501337808041, 218, 27, 'PPL', 'P'),
(146296, 'Shiloh', 40.9174995422363, 0.714145088695296, -74.9311065673828, -1.30779452176358, 218, 37, 'PPL', 'P'),
(157642, 'Shiloh', 40.9666709899902, 0.715003292356575, -82.6005630493164, -1.44165178921174, 218, 41, 'PPL', 'P'),
(167126, 'Shiloh', 41.0416717529297, 0.716312302611376, -78.2916717529297, -1.36644744897926, 218, 45, 'PPL', 'P'),
(185111, 'Shiloh', 38.523609161377, 0.672363819617479, -122.794723510742, -2.14317222933854, 218, 6, 'PPL', 'P'),
(195605, 'Shiloh', 48.5449981689453, 0.847270053422714, -116.394439697266, -2.03146620373128, 218, 17, 'PPL', 'P'),
(11920, 'Shiloh (historical)', 35.5355606079102, 0.62021253415003, -92.1394424438477, -1.60813664159695, 218, 4, 'PPL', 'P'),
(24838, 'Shiloh (historical)', 33.5805587768555, 0.586091315315608, -82.4972229003906, -1.43984816336348, 218, 13, 'PPL', 'P'),
(61759, 'Shiloh (historical)', 32.2361106872559, 0.562626269529947, -89.8333282470703, -1.5678873559362, 218, 30, 'PPL', 'P'),
(68764, 'Shiloh (historical)', 35.3891716003418, 0.617657563979235, -79.916389465332, -1.39480412247615, 218, 33, 'PPL', 'P'),
(98053, 'Shiloh (historical)', 30.0916595458984, 0.52519853646511, -97.3831481933594, -1.69965657193169, 218, 51, 'PPL', 'P'),
(111380, 'Shiloh (historical)', 39.1824989318848, 0.683863615520551, -78.4319381713867, -1.36889555981132, 218, 58, 'PPL', 'P'),
(68765, 'Shiloh Acres', 36.4566688537598, 0.636288905807375, -79.8469390869141, -1.39359198470601, 218, 33, 'PPL', 'P'),
(179140, 'Shiloh Canyon', 33.5847206115723, 0.58616395303434, -111.845558166504, -1.95207324373633, 218, 5, 'PPL', 'P'),
(51391, 'Shiloh Church', 38.5886116027832, 0.673498326241853, -75.8711090087891, -1.3242006593429, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(83629, 'Shiloh Estates', 34.6855583190918, 0.605377195560662, -82.9013900756836, -1.44690221130083, 218, 48, 'PPL', 'P'),
(24843, 'Shiloh Farms', 33.8236083984375, 0.59033333145794, -84.0774993896484, -1.46742919119289, 218, 13, 'PPL', 'P'),
(83630, 'Shiloh Heights', 33.6036109924316, 0.586493652377291, -81.7152786254883, -1.42620066119932, 218, 48, 'PPL', 'P'),
(28595, 'Shiloh Hill', 37.9252815246582, 0.661921032351061, -89.6211090087891, -1.56418343149212, 218, 18, 'PPL', 'P'),
(43058, 'Shiloh Landing (historical)', 32.9661102294922, 0.575367165080022, -92.0880584716797, -1.60723982209987, 218, 22, 'PPL', 'P'),
(51392, 'Shiloh Manor', 38.5886116027832, 0.673498326241853, -75.8763885498047, -1.32429280471662, 218, 25, 'PPL', 'P'),
(68766, 'Shiloh Mills', 35.9052810668945, 0.626665373471292, -77.4944381713867, -1.35253309807387, 218, 33, 'PPL', 'P'),
(28596, 'Shiloh Station', 38.5338897705078, 0.672543250095924, -89.898063659668, -1.56901720202867, 218, 18, 'PPL', 'P'),
(24840, 'Shiloh Terrace', 33.4027786254883, 0.582988466329556, -82.0475006103516, -1.43199902868269, 218, 13, 'PPL', 'P'),
(112286, 'Shiloh West', 34.0191688537598, 0.593746505290013, -84.6630630493164, -1.47764920503412, 218, 13, 'PPL', 'P'),
(18072, 'Shilow', 28.0400009155273, 0.489390338238177, -82.1272201538086, -1.4333903971942, 218, 12, 'PPL', 'P'),
(106230, 'Shilsons Corner', 37.2516708374023, 0.650164307981824, -76.5561065673828, -1.33615612210848, 218, 53, 'PPL', 'P'),
(157643, 'Shiltown', 41.0580596923828, 0.71659832611245, -80.9274978637695, -1.41245129312346, 218, 41, 'PPL', 'P'),
(167130, 'Shimer', 40.6674995422363, 0.709781765565311, -75.3855590820313, -1.31572621443816, 218, 45, 'PPL', 'P'),
(167129, 'Shimerville', 40.7597198486328, 0.711391313549127, -75.2344436645508, -1.3130887528526, 218, 45, 'PPL', 'P'),
(126085, 'Shimmo', 41.2861099243164, 0.720578553519628, -70.0749969482422, -1.2230394200718, 218, 23, 'PPL', 'P'),
(79122, 'Shimpstown', 39.7902793884277, 0.6944713856165, -77.9000015258789, -1.35961151393519, 218, 45, 'PPL', 'P'),
(152539, 'Shin Hollow', 41.4047203063965, 0.722648695213974, -74.6158294677734, -1.30229189831925, 218, 40, 'PPL', 'P'),
(128807, 'Shin Pond', 46.105281829834, 0.804688970490519, -68.5572204589844, -1.1965492230249, 218, 26, 'PPL', 'P'),
(167131, 'Shindle', 40.6694412231445, 0.709815654290182, -77.4136123657227, -1.35112242164446, 218, 45, 'PPL', 'P'),
(171293, 'Shindler', 43.4749984741211, 0.758781865672924, -96.6483306884766, -1.68683158707019, 218, 49, 'PPL', 'P'),
(68769, 'Shine', 35.4402809143066, 0.618549589786357, -77.7922210693359, -1.35773039009922, 218, 33, 'PPL', 'P'),
(208723, 'Shine-Gri-La', 47.8697204589844, 0.835484234018569, -122.687782287598, -2.14130575288856, 218, 56, 'PPL', 'P'),
(98054, 'Shiner', 29.4288902282715, 0.513631029691323, -97.170280456543, -1.69594132905297, 218, 51, 'PPL', 'P'),
(167133, 'Shinerville', 41.4874992370605, 0.724093460105342, -76.3822174072266, -1.33312118373023, 218, 45, 'PPL', 'P'),
(68771, 'Shines Crossroads', 35.4416694641113, 0.618573824552277, -77.7991714477539, -1.35785169708687, 218, 33, 'PPL', 'P'),
(77242, 'Shinewell', 33.8811111450195, 0.591336943714737, -94.5130615234375, -1.64956410972395, 218, 42, 'PPL', 'P'),
(18073, 'Shiney Town', 27.1936092376709, 0.474618016698102, -82.3461074829102, -1.43721070177792, 218, 12, 'PPL', 'P'),
(167132, 'Shingiss', 40.2400016784668, 0.70232052029729, -80.209716796875, -1.39992365019767, 218, 45, 'PPL', 'P'),
(68772, 'Shingle Hollow', 35.4708290100098, 0.619082754636591, -82.0738906860352, -1.43245962239322, 218, 33, 'PPL', 'P'),
(14610, 'Shingle Landing', 39.5433311462402, 0.690161325708315, -75.5941696166992, -1.31936715512246, 218, 10, 'PPL', 'P'),
(51394, 'Shingle Landing', 38.4052810668945, 0.67029860477115, -75.1958312988281, -1.31241483993876, 218, 25, 'PPL', 'P'),
(144447, 'Shingle Mill Corner', 43.3536109924316, 0.756663254446739, -71.915283203125, -1.25515847439871, 218, 36, 'PPL', 'P'),
(185114, 'Shingle Springs', 38.665828704834, 0.674846018911488, -120.925003051758, -2.11053945123737, 218, 6, 'PPL', 'P'),
(167134, 'Shinglebury', 41.8925018310547, 0.731162088849658, -77.2969436645508, -1.34908616867498, 218, 45, 'PPL', 'P'),
(68773, 'Shingleford Crossing', 34.6183280944824, 0.604203806784373, -78.8013916015625, -1.37534373860067, 218, 33, 'PPL', 'P'),
(167137, 'Shinglehouse', 41.9636116027832, 0.732403188496662, -78.1911087036133, -1.36469229266285, 218, 45, 'PPL', 'P'),
(24841, 'Shingler', 31.5780601501465, 0.551141121012871, -83.7847213745117, -1.4623192508513, 218, 13, 'PPL', 'P'),
(24842, 'Shinglers (historical)', 31.7702808380127, 0.554496004906585, -83.6241683959961, -1.45951707275232, 218, 13, 'PPL', 'P'),
(133107, 'Shingleton', 46.348331451416, 0.808930986632852, -86.4700012207031, -1.50918622550479, 218, 27, 'PPL', 'P'),
(90797, 'Shingletown', 36.5502815246582, 0.637922755136139, -81.7880630493164, -1.42747098903928, 218, 50, 'PPL', 'P'),
(167136, 'Shingletown', 40.7633285522461, 0.711454297308908, -77.8258285522461, -1.35831695132931, 218, 45, 'PPL', 'P'),
(193952, 'Shingletown', 40.4925003051758, 0.706727452690126, -121.888061523438, -2.1273479924574, 218, 6, 'PPL', 'P'),
(152540, 'Shinhopple', 42.0386085510254, 0.733712132172436, -75.0680618286133, -1.31018484199998, 218, 40, 'PPL', 'P'),
(28600, 'Shinn', 39.6763916015625, 0.692483668757892, -91.1672210693359, -1.59116817755346, 218, 18, 'PPL', 'P'),
(185115, 'Shinn', 37.5666694641113, 0.655662071157156, -121.982223510742, -2.12899142916609, 218, 6, 'PPL', 'P'),
(152541, 'Shinnecock Hills', 40.8908309936523, 0.713679634715778, -72.4641723632813, -1.26473839747194, 218, 40, 'PPL', 'P'),
(111381, 'Shinnston', 39.3955612182617, 0.687582253929655, -80.3002777099609, -1.40150423630463, 218, 58, 'PPL', 'P'),
(71391, 'Shinntown', 39.9000015258789, 0.696386398177348, -74.8444366455078, -1.30628184626441, 218, 37, 'PPL', 'P'),
(68774, 'Shinnville', 35.6586112976074, 0.622360173832097, -80.8033294677734, -1.4102841457864, 218, 33, 'PPL', 'P'),
(157644, 'Shinrock', 41.3461112976074, 0.721625775039275, -82.5213928222656, -1.44027000808015, 218, 41, 'PPL', 'P'),
(167138, 'Shintown', 41.3072204589844, 0.720947001856441, -77.8016662597656, -1.35789523977069, 218, 45, 'PPL', 'P'),
(106231, 'Shiny Rock', 36.5530586242676, 0.637971224667978, -78.5975036621094, -1.37178522275211, 218, 53, 'PPL', 'P'),
(176383, 'Shiocton', 44.4447212219238, 0.775706720453568, -88.5788879394531, -1.54599324229855, 218, 57, 'PPL', 'P'),
(71388, 'Ship Bottom', 39.6427803039551, 0.691897040948775, -74.1808319091797, -1.29469975868366, 218, 37, 'PPL', 'P'),
(167139, 'Ship Road', 40.0233306884766, 0.698538898128405, -75.6100006103516, -1.31964345808556, 218, 45, 'PPL', 'P'),
(90798, 'Shipetown', 36.0744400024414, 0.629617753855754, -83.7630615234375, -1.46194121513456, 218, 50, 'PPL', 'P'),
(38195, 'Shipley', 36.6672210693359, 0.639963735216548, -85.2177810668945, -1.487330860861, 218, 21, 'PPL', 'P'),
(51396, 'Shipley', 39.5038909912109, 0.689472965145557, -77.003059387207, -1.34395692041549, 218, 25, 'PPL', 'P'),
(113018, 'Shipley', 41.9799995422363, 0.732689211997736, -93.5113906860352, -1.63208165559007, 218, 16, 'PPL', 'P'),
(51397, 'Shipley Corner', 39.1588897705078, 0.683451557920888, -76.7138900756836, -1.33890996383368, 218, 25, 'PPL', 'P'),
(14611, 'Shipley Heights', 39.7833290100098, 0.694350078628847, -75.5250015258789, -1.31815994420033, 218, 10, 'PPL', 'P'),
(51398, 'Shipley Heights', 39.202220916748, 0.684207829091443, -76.6627807617188, -1.33801793802656, 218, 25, 'PPL', 'P'),
(14612, 'Shipley Ridge', 39.7783317565918, 0.694262860103146, -75.5199966430664, -1.31807259251657, 218, 10, 'PPL', 'P'),
(13209, 'Shipley Terrace', 38.8472213745117, 0.678011918236347, -76.9694366455078, -1.34337009286929, 218, 9, 'PPL', 'P'),
(14613, 'Shipley Woods', 39.8233299255371, 0.695048226308611, -75.5338897705078, -1.31831507333383, 218, 10, 'PPL', 'P'),
(51399, 'Shipleys Choice', 39.0961112976074, 0.682355866869402, -76.6108322143555, -1.33711126483344, 218, 25, 'PPL', 'P'),
(28601, 'Shipman', 39.1175003051758, 0.682729175475204, -90.0441665649414, -1.57156717877242, 218, 18, 'PPL', 'P'),
(61760, 'Shipman', 30.8772201538086, 0.53890915554711, -88.4749984741211, -1.54418002907037, 218, 30, 'PPL', 'P'),
(106232, 'Shipman', 37.7236099243164, 0.65840119891733, -78.8394393920898, -1.37600779781848, 218, 53, 'PPL', 'P'),
(172525, 'Shipman Hill', 44.5269393920898, 0.77714169822793, -73.2069396972656, -1.27770213302623, 218, 55, 'PPL', 'P'),
(167140, 'Shipmans Eddy', 41.829719543457, 0.730066331219144, -79.0872192382813, -1.38033237195461, 218, 45, 'PPL', 'P'),
(11923, 'Shipp', 36.2119407653809, 0.632017594893051, -92.3600006103516, -1.61198610779461, 218, 4, 'PPL', 'P'),
(43059, 'Shipp', 32.5938911437988, 0.56887071649591, -93.9811096191406, -1.64027979753172, 218, 22, 'PPL', 'P'),
(157646, 'Shipp', 41.7822189331055, 0.729237289171803, -80.5358276367188, -1.40561535807939, 218, 41, 'PPL', 'P'),
(185116, 'Shipp (historical)', 36.9452781677246, 0.644816747091972, -119.674171447754, -2.08870832135949, 218, 6, 'PPL', 'P'),
(114059, 'Shippan Point', 41.0277786254883, 0.716069821794124, -73.524169921875, -1.2832388449325, 218, 8, 'PPL', 'P'),
(177687, 'Shippee', 39.5400009155273, 0.690103202217524, -121.686943054199, -2.12383781298262, 218, 6, 'PPL', 'P'),
(199682, 'Shippee', 40.0591697692871, 0.699164408089437, -100.201942443848, -1.748853812539, 218, 35, 'PPL', 'P'),
(169601, 'Shippee Corner', 41.6430587768555, 0.726808486257651, -71.522216796875, -1.24829817143066, 218, 47, 'PPL', 'P'),
(11924, 'Shippen', 35.690559387207, 0.622917773185332, -90.0994415283203, -1.5725319088773, 218, 4, 'PPL', 'P'),
(146305, 'Shippenport', 40.8983306884766, 0.713810529083355, -74.6694412231445, -1.30322759996825, 218, 37, 'PPL', 'P'),
(167152, 'Shippensburg', 40.0505599975586, 0.69901413922493, -77.5205612182617, -1.35298903125249, 218, 45, 'PPL', 'P'),
(167145, 'Shippenville', 41.2502784729004, 0.71995317671665, -79.459716796875, -1.38683368080771, 218, 45, 'PPL', 'P'),
(51400, 'Shipping Creek', 38.9180603027344, 0.679248290772416, -76.3402786254883, -1.33238921390462, 218, 25, 'PPL', 'P'),
(167147, 'Shippingport', 40.6319389343262, 0.709161115873268, -80.4141693115234, -1.40349201974227, 218, 45, 'PPL', 'P'),
(189560, 'Shiprock', 36.7855606079102, 0.642029149799959, -108.686393737793, -1.89693542284343, 218, 38, 'PPL', 'P'),
(106233, 'Ships Corner', 36.7919387817383, 0.642140469933524, -76.0802764892578, -1.32785132056518, 218, 53, 'PPL', 'P'),
(123668, 'Shipshewana', 41.672779083252, 0.727327203458971, -85.5802764892578, -1.49365759950464, 218, 19, 'PPL', 'P'),
(68775, 'Shipswatch', 36.1938896179199, 0.631702542936095, -75.7527770996094, -1.32213537791754, 218, 33, 'PPL', 'P'),
(33964, 'Shipton', 38.913890838623, 0.67917551989563, -97.6819381713867, -1.70487144082023, 218, 20, 'PPL', 'P'),
(185117, 'Shipyard Acres', 38.2599983215332, 0.667762942518259, -122.269996643066, -2.13401401782392, 218, 6, 'PPL', 'P'),
(51401, 'Shipyard Landing', 39.1624984741211, 0.683514541680668, -76.1911087036133, -1.32978570762296, 218, 25, 'PPL', 'P'),
(83632, 'Shipyard Plantation', 32.1541709899902, 0.561196152024574, -80.7477798461914, -1.40931462199156, 218, 48, 'PPL', 'P'),
(167149, 'Shire Oaks', 40.2436103820801, 0.702383504057071, -79.9466705322266, -1.39533262679448, 218, 45, 'PPL', 'P'),
(18074, 'Shired Island', 29.3969402313232, 0.513073397048574, -83.2011108398438, -1.45213332547202, 218, 12, 'PPL', 'P'),
(167150, 'Shiremanstown', 40.223331451416, 0.702029569948199, -76.9538879394531, -1.34309871675421, 218, 45, 'PPL', 'P'),
(77243, 'Shirk', 36.121940612793, 0.630446795903095, -96.1272201538086, -1.67773649247341, 218, 42, 'PPL', 'P'),
(31118, 'Shirkieville', 39.6002807617188, 0.69115528400616, -87.4986114501953, -1.52713886072912, 218, 19, 'PPL', 'P'),
(167153, 'Shirks Corner', 40.2802810668945, 0.703023528246044, -75.4355621337891, -1.31659893232738, 218, 45, 'PPL', 'P'),
(126087, 'Shirkshire', 42.5513916015625, 0.742661884752729, -72.726936340332, -1.26932449402711, 218, 23, 'PPL', 'P'),
(167154, 'Shirksville', 40.4286117553711, 0.70561238714171, -76.4225006103516, -1.33382425825801, 218, 45, 'PPL', 'P'),
(121451, 'Shirland', 42.4444389343262, 0.740795208565665, -89.1975021362305, -1.5567900968319, 218, 18, 'PPL', 'P'),
(5825, 'Shirley', 33.3499984741211, 0.582067278908498, -87.7472229003906, -1.53147794909318, 218, 2, 'PPL', 'P'),
(11925, 'Shirley', 35.6561088562012, 0.62231649799022, -92.3191680908203, -1.6112734458869, 218, 4, 'PPL', 'P'),
(31119, 'Shirley', 39.8919410705566, 0.696245716692765, -85.5769424438477, -1.49359940943482, 218, 19, 'PPL', 'P'),
(57542, 'Shirley', 37.9150009155273, 0.661741601872617, -90.9191665649414, -1.58683880972737, 218, 29, 'PPL', 'P'),
(71390, 'Shirley', 39.5694389343262, 0.690616992570828, -75.2386093139648, -1.31316145715036, 218, 37, 'PPL', 'P'),
(83631, 'Shirley', 32.6599998474121, 0.570024531038187, -81.3163909912109, -1.41923875863569, 218, 48, 'PPL', 'P'),
(90799, 'Shirley', 36.3452796936035, 0.634344798211617, -84.7786102294922, -1.47966588376958, 218, 50, 'PPL', 'P'),
(98056, 'Shirley', 33.274169921875, 0.580743821004783, -95.5341720581055, -1.66738585058071, 218, 51, 'PPL', 'P'),
(106237, 'Shirley', 37.3416709899902, 0.65173510697178, -77.2608337402344, -1.34845593160302, 218, 53, 'PPL', 'P'),
(111382, 'Shirley', 39.3980598449707, 0.687625863192506, -80.7652816772461, -1.40962008656859, 218, 58, 'PPL', 'P'),
(121453, 'Shirley', 40.4072189331055, 0.705239011956881, -89.0625, -1.55443386505745, 218, 18, 'PPL', 'P'),
(126088, 'Shirley', 42.5436096191406, 0.742526063537135, -71.6500015258789, -1.25052843568555, 218, 23, 'PPL', 'P'),
(138090, 'Shirley', 47.8688888549805, 0.835469719790628, -96.6141662597656, -1.68623530530213, 218, 28, 'PPL', 'P'),
(152544, 'Shirley', 40.8013916015625, 0.712118622842828, -72.8680572509766, -1.27178751856127, 218, 40, 'PPL', 'P'),
(167155, 'Shirley', 40.2305603027344, 0.702155737204842, -79.2286071777344, -1.38280005702068, 218, 45, 'PPL', 'P'),
(176385, 'Shirley', 44.3569412231445, 0.774174670457473, -87.9475021362305, -1.53497348118197, 218, 57, 'PPL', 'P'),
(185119, 'Shirley', 33.8244400024414, 0.590347845685881, -118.023063659668, -2.05989105415207, 218, 6, 'PPL', 'P'),
(187351, 'Shirley', 38.9011116027832, 0.678952480154335, -104.652778625488, -1.82653555837552, 218, 7, 'PPL', 'P'),
(197531, 'Shirley', 46.5913887023926, 0.813173135933239, -105.579437255859, -1.84270880251751, 218, 31, 'PPL', 'P'),
(43060, 'Shirley (historical)', 30.9780597686768, 0.540669138843002, -92.2052764892578, -1.60928566244927, 218, 22, 'PPL', 'P'),
(187352, 'Shirley (historical)', 38.4244384765625, 0.67063296464601, -106.127777099609, -1.85227913821082, 218, 7, 'PPL', 'P'),
(209733, 'Shirley (historical)', 42.1888885498047, 0.736335012951028, -106.481391906738, -1.85845088087903, 218, 59, 'PPL', 'P'),
(126089, 'Shirley Center', 42.5722198486328, 0.743025406241525, -71.6513900756836, -1.25055267045147, 218, 23, 'PPL', 'P'),
(98057, 'Shirley Creek', 31.3148097991943, 0.546546535631726, -94.3836364746094, -1.64730521648735, 218, 51, 'PPL', 'P'),
(106234, 'Shirley Duke', 38.8152809143066, 0.677454452041166, -77.1094436645508, -1.34581367632749, 218, 53, 'PPL', 'P'),
(51405, 'Shirley Estates', 39.1988906860352, 0.684149705600652, -76.6469421386719, -1.33774150190541, 218, 25, 'PPL', 'P'),
(106235, 'Shirley Gate Park', 38.8433303833008, 0.67794400762855, -77.3394393920898, -1.34982785903857, 218, 53, 'PPL', 'P'),
(24844, 'Shirley Grove', 34.7161102294922, 0.605910426989923, -83.415283203125, -1.45587133837805, 218, 13, 'PPL', 'P'),
(51402, 'Shirley Heights', 39.2166709899902, 0.684460030446674, -76.6783294677734, -1.33828931414164, 218, 25, 'PPL', 'P'),
(51403, 'Shirley Manor', 39.5233306884766, 0.689812251868433, -76.9136123657227, -1.34239577538449, 218, 25, 'PPL', 'P'),
(185120, 'Shirley Meadows', 35.7108306884766, 0.623271574136149, -118.555557250977, -2.06918482056618, 218, 6, 'PPL', 'P'),
(128808, 'Shirley Mills', 45.3655586242676, 0.791778364999978, -69.6186065673828, -1.21507390525138, 218, 26, 'PPL', 'P'),
(24847, 'Shirley Park', 32.0238914489746, 0.558922345085865, -81.0794372558594, -1.4151031357789, 218, 13, 'PPL', 'P'),
(18075, 'Shirley Place', 29.3983306884766, 0.513097665104007, -81.4902801513672, -1.42227369701394, 218, 12, 'PPL', 'P'),
(5826, 'Shirleys Crossroads', 31.7147197723389, 0.55352628137466, -86.1650009155273, -1.50386296595988, 218, 2, 'PPL', 'P'),
(167156, 'Shirleysburg', 40.297779083252, 0.703328926244049, -77.8744430541992, -1.35916543445261, 218, 45, 'PPL', 'P'),
(90800, 'Shirleyton', 35.2366714477539, 0.614995934206783, -85.4952774047852, -1.49217408561941, 218, 50, 'PPL', 'P'),
(51404, 'Shirleyville', 39.0352783203125, 0.681294131121815, -76.4877777099609, -1.33496355857235, 218, 25, 'PPL', 'P'),
(212145, 'Shirleyville', 61.0136108398438, 1.06488839768578, -151.406936645508, -2.64254955482257, 218, 1, 'PPL', 'P'),
(106236, 'Shirlington', 38.8416709899902, 0.677915045751695, -77.0886077880859, -1.34545002168064, 218, 53, 'PPL', 'P'),
(98058, 'Shiro', 30.6130599975586, 0.534298691067965, -95.8880615234375, -1.67356238693887, 218, 51, 'PPL', 'P'),
(212146, 'Shishmaref', 66.2566680908203, 1.15639700958588, -166.07194519043, -2.89850223876456, 218, 1, 'PPL', 'P'),
(185121, 'Shisholop (historical)', 34.4583282470703, 0.601411282644343, -120.443061828613, -2.1021279900924, 218, 6, 'PPL', 'P'),
(98059, 'Shive', 31.6122207641602, 0.551737336201913, -98.2344436645508, -1.7145144808113, 218, 51, 'PPL', 'P'),
(38196, 'Shively', 38.2000007629395, 0.666715787577639, -85.8227767944336, -1.49789002826705, 218, 21, 'PPL', 'P'),
(111383, 'Shively', 37.9658317565918, 0.662628767410749, -82.1183319091797, -1.43323526806071, 218, 58, 'PPL', 'P'),
(157647, 'Shively', 40.5966682434082, 0.708545526187296, -84.6477813720703, -1.47738248945095, 218, 41, 'PPL', 'P'),
(193953, 'Shively', 40.4308280944824, 0.705651069556543, -123.968612670898, -2.16366046023674, 218, 6, 'PPL', 'P'),
(157648, 'Shively Corners', 41.1169395446777, 0.717625973398085, -80.7772216796875, -1.40982847892389, 218, 41, 'PPL', 'P'),
(24849, 'Shiver', 30.8280601501465, 0.538051151622914, -83.5419387817383, -1.45808189524087, 218, 13, 'PPL', 'P'),
(61761, 'Shivers', 31.7963905334473, 0.554951705058611, -89.9875030517578, -1.57057821390162, 218, 30, 'PPL', 'P'),
(24850, 'Shivers Mill', 31.6766700744629, 0.552862188867335, -84.7399978637695, -1.47899197085574, 218, 13, 'PPL', 'P'),
(11926, 'Shives', 33.2752799987793, 0.580763195501713, -91.1708297729492, -1.59123116131324, 218, 4, 'PPL', 'P'),
(192781, 'Shivwits', 37.1811103820801, 0.648932795714744, -113.75666809082, -1.98542840428319, 218, 52, 'PPL', 'P'),
(79124, 'Shoaf', 39.8408317565918, 0.695353690885643, -79.8086090087891, -1.39292299864018, 218, 45, 'PPL', 'P'),
(57543, 'Shoal', 39.6530609130859, 0.692076471427219, -93.9327774047852, -1.63943624125644, 218, 29, 'PPL', 'P'),
(24853, 'Shoal Creek', 33.5663909912109, 0.585844040808394, -83.9958267211914, -1.46600373421942, 218, 13, 'PPL', 'P'),
(57544, 'Shoal Creek Drive', 37.040828704834, 0.64648441856658, -94.519172668457, -1.64967076932561, 218, 29, 'PPL', 'P'),
(57545, 'Shoal Creek Estates', 37.0180587768555, 0.646087008352913, -94.495002746582, -1.64924892460894, 218, 29, 'PPL', 'P'),
(24854, 'Shoal Creek Farms', 33.8930587768555, 0.59154546922809, -83.2925033569336, -1.45372842580692, 218, 13, 'PPL', 'P'),
(112285, 'Shoal Creek Forest', 33.4044418334961, 0.583017494785438, -84.6319427490234, -1.4771060533298, 218, 13, 'PPL', 'P'),
(24855, 'Shoal Creek Plantation Subdivision', 33.4063911437988, 0.583051516668364, -84.648063659668, -1.47738741629897, 218, 13, 'PPL', 'P'),
(5828, 'Shoal Run', 33.413330078125, 0.583172623918935, -86.6727828979492, -1.51272543343545, 218, 2, 'PPL', 'P'),
(83633, 'Shoally Creek', 35.0161094665527, 0.6111464014301, -81.9513931274414, -1.43032163667011, 218, 48, 'PPL', 'P'),
(31122, 'Shoals', 38.666389465332, 0.674855806028494, -86.7911071777344, -1.51479058170275, 218, 19, 'PPL', 'P'),
(68779, 'Shoals', 36.2738914489746, 0.633098838295624, -80.5113906860352, -1.40518885283081, 218, 33, 'PPL', 'P'),
(77245, 'Shoals', 33.8977813720703, 0.591627894063828, -95.3974990844727, -1.66500045719232, 218, 42, 'PPL', 'P'),
(111384, 'Shoals', 38.3269386291504, 0.668931271288476, -82.4752807617188, -1.43946520079873, 218, 58, 'PPL', 'P'),
(5827, 'Shoals Acres', 34.8686103820801, 0.608572056762375, -87.5527801513672, -1.5280842829161, 218, 2, 'PPL', 'P'),
(83634, 'Shoals Creek Subdivision', 34.8430595397949, 0.608126110437842, -82.5194396972656, -1.4402359196182, 218, 48, 'PPL', 'P'),
(83635, 'Shoals Junction', 34.3561096191406, 0.599627231030099, -82.3030624389648, -1.43645942403441, 218, 48, 'PPL', 'P'),
(31120, 'Shoals Overlook', 38.6794395446777, 0.675083572880723, -86.804443359375, -1.51502334198202, 218, 19, 'PPL', 'P'),
(24856, 'Shoalsview', 33.9383316040039, 0.592335629123517, -83.351936340332, -1.45476572705151, 218, 13, 'PPL', 'P'),
(68778, 'Shoates', 34.8652801513672, 0.608513933271584, -80.1408309936523, -1.39872136612355, 218, 33, 'PPL', 'P'),
(79123, 'Shober', 39.8913917541504, 0.696236129312841, -79.0227813720703, -1.37920771902627, 218, 45, 'PPL', 'P'),
(28605, 'Shobonier', 38.8694381713867, 0.678399674491062, -89.0886077880859, -1.55488953191996, 218, 18, 'PPL', 'P'),
(5830, 'Shocco Springs', 33.4533309936523, 0.5838707715987, -86.1374969482422, -1.50338293117339, 218, 2, 'PPL', 'P'),
(61762, 'Shoccoe', 32.6097183227539, 0.569146952879979, -89.9011077880859, -1.56907033209242, 218, 30, 'PPL', 'P'),
(111385, 'Shock', 38.7783317565918, 0.676809567583203, -80.966667175293, -1.41313492657528, 218, 58, 'PPL', 'P'),
(51406, 'Shockeys (historical)', 39.7088890075684, 0.693050855491051, -77.5361099243164, -1.35326040736757, 218, 25, 'PPL', 'P'),
(106238, 'Shockeysville', 39.3858299255371, 0.687412410831136, -78.2441711425781, -1.36561840693192, 218, 53, 'PPL', 'P'),
(14615, 'Shockley Heights', 38.7144393920898, 0.67569443545576, -75.0991668701172, -1.31072772738819, 218, 10, 'PPL', 'P'),
(14614, 'Shockley Manor', 38.7166709899902, 0.675733384186702, -75.100830078125, -1.31075675584407, 218, 10, 'PPL', 'P'),
(106239, 'Shockoe', 36.8086090087891, 0.642431420282616, -79.2641677856445, -1.38342070671272, 218, 53, 'PPL', 'P'),
(68781, 'Shoeheel', 35.6269416809082, 0.621807434747851, -78.2102813720703, -1.36502691885382, 218, 33, 'PPL', 'P'),
(167159, 'Shoemak Village', 40.1683311462402, 0.70106963353328, -75.0749969482422, -1.31030588267152, 218, 45, 'PPL', 'P'),
(106240, 'Shoemaker', 39.2441711425781, 0.684939998654133, -77.6527786254883, -1.35529666033705, 218, 53, 'PPL', 'P'),
(167160, 'Shoemaker', 40.3941688537598, 0.705011245104652, -78.646110534668, -1.37263357271735, 218, 45, 'PPL', 'P'),
(189561, 'Shoemaker', 35.8163909912109, 0.625113948978266, -104.875831604004, -1.83042856725699, 218, 38, 'PPL', 'P'),
(98060, 'Shoemaker Acres Colonia', 26.07200050354, 0.455042251368393, -97.4449996948242, -1.70073608427955, 218, 51, 'PPL', 'P'),
(192210, 'Shoemaker Place', 30.2191696166992, 0.527424007030034, -103.142219543457, -1.80017132884817, 218, 51, 'PPL', 'P'),
(176386, 'Shoemaker Point', 44.7205581665039, 0.780520983335132, -87.7205581665039, -1.53101256169269, 218, 57, 'PPL', 'P'),
(5829, 'Shoemaker Springs (historical)', 34.8444404602051, 0.608150212045707, -87.1827774047852, -1.52162651674682, 218, 2, 'PPL', 'P'),
(167162, 'Shoemakers', 40.8311080932617, 0.712637273465121, -76.1302795410156, -1.3287240384544, 218, 45, 'PPL', 'P'),
(51407, 'Shoemakers Lot', 39.6258316040039, 0.691601230330694, -77.0219421386719, -1.34428648660039, 218, 25, 'PPL', 'P'),
(167163, 'Shoemakersville', 40.5008316040039, 0.706872861285644, -75.9702835083008, -1.3259315808934, 218, 45, 'PPL', 'P'),
(167165, 'Shoenberger', 40.6333312988281, 0.709185417218215, -78.1861114501953, -1.36460507413715, 218, 45, 'PPL', 'P'),
(167169, 'Shoentown', 40.7055587768555, 0.710446024520204, -76.1591720581055, -1.32922830800681, 218, 45, 'PPL', 'P'),
(11929, 'Shoffner', 35.4713897705078, 0.619092541753597, -91.230827331543, -1.59227831625386, 218, 4, 'PPL', 'P'),
(90801, 'Shofner', 36.4027786254883, 0.635348343889386, -88.9811096191406, -1.553013334932, 218, 50, 'PPL', 'P'),
(167166, 'Shohola', 41.4749984741211, 0.723875280633037, -74.9155578613281, -1.3075231456485, 218, 45, 'PPL', 'P'),
(167167, 'Shohola Falls', 41.3908309936523, 0.72240628097575, -74.9663925170898, -1.30841037776566, 218, 45, 'PPL', 'P'),
(152545, 'Shokan', 41.973331451416, 0.7325728318581, -74.2125015258789, -1.2952524977679, 218, 40, 'PPL', 'P'),
(121454, 'Shokokon', 40.747501373291, 0.711178060924839, -91.0741729736328, -1.58954418192073, 218, 18, 'PPL', 'P'),
(152546, 'Sholam', 41.8208312988281, 0.729911202085647, -74.4108276367188, -1.29871394139473, 218, 40, 'PPL', 'P'),
(68783, 'Sholars Crossroads', 34.7619400024414, 0.606710307423328, -77.8011093139648, -1.35788551923271, 218, 33, 'PPL', 'P'),
(143015, 'Sholes', 42.3327789306641, 0.738846373858972, -97.2941665649414, -1.69810354954201, 218, 35, 'PPL', 'P'),
(185122, 'Sholun', 37.6722183227539, 0.657504246262192, -122.476387023926, -2.13761620951436, 218, 6, 'PPL', 'P'),
(43061, 'Shongaloo', 32.9413909912109, 0.574935732983429, -93.2986068725586, -1.62836787744996, 218, 22, 'PPL', 'P'),
(61763, 'Shongelo', 32.1027793884277, 0.560299199369436, -89.5130615234375, -1.56229764712424, 218, 30, 'PPL', 'P'),
(152548, 'Shongo', 42.1386108398438, 0.735457501371846, -78.7783279418945, -1.37494120180191, 218, 40, 'PPL', 'P'),
(179141, 'Shongopovi', 35.8180618286133, 0.625143110592203, -110.533889770508, -1.92918031153184, 218, 5, 'PPL', 'P'),
(146297, 'Shongum', 40.8441696166992, 0.712865240054432, -74.533332824707, -1.3008520602759, 218, 37, 'PPL', 'P'),
(197532, 'Shonkin', 47.6288909912109, 0.831280966870096, -110.571937561035, -1.92984437074965, 218, 31, 'PPL', 'P'),
(179142, 'Shonto', 36.5944404602051, 0.638693473955608, -110.641670227051, -1.93106143536782, 218, 5, 'PPL', 'P'),
(11928, 'Shonyo (historical)', 35.8469390869141, 0.6256471138285, -90.0741729736328, -1.57209088940078, 218, 4, 'PPL', 'P'),
(121455, 'Shoo Fly', 40.4161109924316, 0.705394207669405, -90.4766693115234, -1.5791157757242, 218, 18, 'PPL', 'P'),
(68782, 'Shoofly', 36.2224998474121, 0.632201885640485, -78.7294387817383, -1.37408792498865, 218, 33, 'PPL', 'P'),
(57548, 'Shook', 37.042781829834, 0.646518507028533, -90.3088912963867, -1.5761874969476, 218, 29, 'PPL', 'P'),
(90803, 'Shooks', 35.9136085510254, 0.626810715487783, -83.82861328125, -1.46308530913886, 218, 50, 'PPL', 'P'),
(138091, 'Shooks', 47.8741683959961, 0.835561865164344, -94.4380569458008, -1.64825503289012, 218, 28, 'PPL', 'P'),
(90802, 'Shooks Gap', 35.8841705322266, 0.626296925134479, -83.7922210693359, -1.46245014521888, 218, 50, 'PPL', 'P'),
(51408, 'Shookstown', 39.4355583190918, 0.688280335030392, -77.4674987792969, -1.35206291698342, 218, 25, 'PPL', 'P'),
(51409, 'Shookstown Heights', 39.4347190856934, 0.688265687644397, -77.4647216796875, -1.35201444745158, 218, 25, 'PPL', 'P'),
(113215, 'Shooktown', 43.1594390869141, 0.753274315380586, -78.663330078125, -1.37293411044637, 218, 40, 'PPL', 'P'),
(24857, 'Shookville', 34.9116706848145, 0.609323600821996, -85.0863876342773, -1.48503761284633, 218, 13, 'PPL', 'P'),
(68785, 'Shookville', 35.146110534668, 0.613415348099821, -83.2227783203125, -1.45251149434681, 218, 33, 'PPL', 'P'),
(31121, 'Shooters Hill', 39.8300018310547, 0.695164673027275, -86.1822204589844, -1.5041635036889, 218, 19, 'PPL', 'P'),
(126091, 'Shooters Island', 41.6236114501953, 0.72646906637672, -69.977783203125, -1.22134272014132, 218, 23, 'PPL', 'P'),
(68784, 'Shooting Creek', 35.0255584716797, 0.611311317680604, -83.6669387817383, -1.46026355680587, 218, 33, 'PPL', 'P'),
(28606, 'Shop Creek', 39.2758293151855, 0.685492538001298, -89.6455612182617, -1.56461020305681, 218, 18, 'PPL', 'P'),
(90804, 'Shop Springs', 36.1277809143066, 0.630548728393818, -86.2122192382813, -1.50468708115921, 218, 50, 'PPL', 'P'),
(176387, 'Shopiere', 42.5724983215332, 0.743030266510514, -88.9383316040039, -1.5522667177204, 218, 57, 'PPL', 'P'),
(179143, 'Shopishk', 32.7213897705078, 0.571095987323753, -111.781112670898, -1.95094845764993, 218, 5, 'PPL', 'P'),
(5831, 'Shopton', 32.1169395446777, 0.560546340718595, -85.9422225952148, -1.49997475076837, 218, 2, 'PPL', 'P'),
(68787, 'Shopton', 35.1713905334473, 0.61385656731342, -80.961669921875, -1.41304770804958, 218, 33, 'PPL', 'P'),
(77246, 'Shopton', 35.726390838623, 0.62354314998831, -95.3569412231445, -1.66429258897458, 218, 42, 'PPL', 'P'),
(38197, 'Shopville', 37.1586112976074, 0.648540112612012, -84.4800033569336, -1.47445421067435, 218, 21, 'PPL', 'P'),
(18076, 'Shore Acres', 27.8177795410156, 0.48551184358464, -82.6036071777344, -1.44170491927549, 218, 12, 'PPL', 'P'),
(31123, 'Shore Acres', 39.8763885498047, 0.695974273998659, -86.1366729736328, -1.50336855010351, 218, 19, 'PPL', 'P'),
(51410, 'Shore Acres', 39.0555610656738, 0.681648131809714, -76.459716796875, -1.33447380324788, 218, 25, 'PPL', 'P'),
(90805, 'Shore Acres', 35.3122215270996, 0.616314531841508, -85.0772171020508, -1.48487755686481, 218, 50, 'PPL', 'P'),
(126093, 'Shore Acres', 42.2144393920898, 0.736780959275561, -70.7388916015625, -1.23462656765863, 218, 23, 'PPL', 'P'),
(146298, 'Shore Acres', 40.0252799987793, 0.698572920011331, -74.101936340332, -1.29332277124203, 218, 37, 'PPL', 'P'),
(152552, 'Shore Acres', 40.9469413757324, 0.714658945627627, -73.7244415283203, -1.28673424386323, 218, 40, 'PPL', 'P'),
(169600, 'Shore Acres', 41.5825004577637, 0.725751544200025, -71.4366683959961, -1.24680507016551, 218, 47, 'PPL', 'P'),
(185126, 'Shore Acres', 38.035831451416, 0.663850492560823, -121.96443939209, -2.12868103774104, 218, 6, 'PPL', 'P'),
(208727, 'Shore Acres', 47.3549995422363, 0.826500659292431, -122.446937561035, -2.13710221942398, 218, 56, 'PPL', 'P'),
(152553, 'Shore Haven', 42.3138885498047, 0.73851667451602, -79.6419372558594, -1.39001402778148, 218, 40, 'PPL', 'P'),
(146299, 'Shore Hills', 40.910831451416, 0.71402870855566, -74.6566696166992, -1.30300469338501, 218, 37, 'PPL', 'P'),
(152554, 'Shore Oaks', 43.5186080932617, 0.759542997112469, -76.3574981689453, -1.33268975163364, 218, 40, 'PPL', 'P'),
(106243, 'Shore Park', 37.1100006103516, 0.64769169606774, -76.5530624389648, -1.33610299204474, 218, 53, 'PPL', 'P'),
(146300, 'Shore Road Estates', 40.3611106872559, 0.704434271254486, -74.3930587768555, -1.29840381628579, 218, 37, 'PPL', 'P'),
(146301, 'Shore View', 40.5902786254883, 0.708434006316649, -74.3283309936523, -1.29727410335138, 218, 37, 'PPL', 'P'),
(98061, 'Shoreacres', 29.6200008392334, 0.516966539088106, -95.0097198486328, -1.65823243275605, 218, 51, 'PPL', 'P'),
(133108, 'Shorecrest', 42.5063896179199, 0.741876451968237, -86.2444381713867, -1.50524940762338, 218, 27, 'PPL', 'P'),
(133109, 'Shoreham', 42.059440612793, 0.734075720240259, -86.5163879394531, -1.50999582647617, 218, 27, 'PPL', 'P'),
(138093, 'Shoreham', 46.7574996948242, 0.816072319674926, -95.8986129760742, -1.67374654452825, 218, 28, 'PPL', 'P'),
(152555, 'Shoreham', 40.957218170166, 0.714838309527044, -72.9080581665039, -1.27248566624103, 218, 40, 'PPL', 'P'),
(172526, 'Shoreham', 43.8936080932617, 0.766087981807447, -73.3163909912109, -1.27961241847614, 218, 55, 'PPL', 'P'),
(51411, 'Shoreham Beach', 38.9000015258789, 0.678933105657405, -76.495002746582, -1.33508965924996, 218, 25, 'PPL', 'P'),
(114060, 'Shorehaven', 41.0916709899902, 0.717184953921567, -73.3888931274414, -1.28087781946809, 218, 8, 'PPL', 'P'),
(51412, 'Shoreland', 39.1749992370605, 0.683732721152973, -76.591667175293, -1.33677677180053, 218, 25, 'PPL', 'P'),
(157650, 'Shoreland', 41.7644386291504, 0.728926964325781, -81.2275009155273, -1.41768733414266, 218, 41, 'PPL', 'P'),
(152556, 'Shorelands', 42.2491683959961, 0.737387094739663, -79.4683303833008, -1.38698401625125, 218, 40, 'PPL', 'P'),
(43062, 'Shoreline', 32.7999992370605, 0.572467981338335, -93.9783325195313, -1.64023132799988, 218, 22, 'PPL', 'P'),
(208725, 'Shoreline', 47.7558288574219, 0.833496450580933, -122.340278625488, -2.13524066982201, 218, 56, 'PPL', 'P'),
(193304, 'Shoreline Drive', 55.375, 0.96647607329186, -131.725006103516, -2.29903506371597, 218, 1, 'PPL', 'P'),
(195606, 'Shoreline Drive Summer Home Area', 44.6474990844727, 0.779245861805202, -115.676666259766, -2.01893869396354, 218, 17, 'PPL', 'P'),
(83636, 'Shoreline Farms', 32.7275009155273, 0.571202646925411, -80.019172668457, -1.39659802778643, 218, 48, 'PPL', 'P'),
(200206, 'Shores', 41.5402793884277, 0.7250146475264, -114.798606872559, -2.00361366662874, 218, 39, 'PPL', 'P'),
(51413, 'Shores of Calvert', 38.7388916015625, 0.676121207020445, -76.679443359375, -1.3383087552176, 218, 25, 'PPL', 'P'),
(83637, 'Shoresbrook', 34.9383316040039, 0.60978892164346, -82.0105590820313, -1.43135427738278, 218, 48, 'PPL', 'P'),
(51414, 'Shoresville (historical)', 39.2811088562012, 0.685584683375014, -76.5547180175781, -1.33613188734256, 218, 25, 'PPL', 'P'),
(138094, 'Shoreview', 45.0791702270508, 0.786779944529036, -93.1469421386719, -1.62572082848447, 218, 28, 'PPL', 'P'),
(18077, 'Shorewood', 26.3030605316162, 0.459075009628073, -80.0997161865234, -1.39800377736783, 218, 12, 'PPL', 'P'),
(51415, 'Shorewood', 39.3583297729492, 0.686932442623676, -75.851936340332, -1.32386603315193, 218, 25, 'PPL', 'P'),
(90806, 'Shorewood', 35.7827796936035, 0.624527321169149, -84.6530609130859, -1.47747463482467, 218, 50, 'PPL', 'P'),
(106241, 'Shorewood', 36.8333282470703, 0.642862852379208, -76.4105606079102, -1.33361586590271, 218, 53, 'PPL', 'P'),
(121456, 'Shorewood', 41.5200004577637, 0.724660713417529, -88.2016677856445, -1.53940950860971, 218, 18, 'PPL', 'P'),
(133110, 'Shorewood', 42.6505584716797, 0.744392673145171, -86.2219390869141, -1.50485672452064, 218, 27, 'PPL', 'P'),
(138096, 'Shorewood', 44.9008293151855, 0.783667308425979, -93.5888900756836, -1.63343427510772, 218, 28, 'PPL', 'P'),
(152557, 'Shorewood', 42.4286117553711, 0.740518972181596, -77.102783203125, -1.34569742934591, 218, 40, 'PPL', 'P'),
(176388, 'Shorewood', 43.089168548584, 0.752047863119577, -87.8874969482422, -1.53392619308329, 218, 57, 'PPL', 'P'),
(201562, 'Shorewood', 43.4541702270508, 0.758418344184128, -124.216941833496, -2.16799462175279, 218, 43, 'PPL', 'P'),
(208726, 'Shorewood', 47.4972190856934, 0.82898285858644, -122.36222076416, -2.13562363238677, 218, 56, 'PPL', 'P'),
(51416, 'Shorewood Estates', 39.3569412231445, 0.686908207857756, -75.8505630493164, -1.32384206470212, 218, 25, 'PPL', 'P'),
(11931, 'Shorewood Hills', 34.4375, 0.601047761155547, -92.8958282470703, -1.62133806427853, 218, 4, 'PPL', 'P'),
(133111, 'Shorewood Hills', 41.8958282470703, 0.731220145761421, -86.6158294677734, -1.51173140855857, 218, 27, 'PPL', 'P'),
(176389, 'Shorewood Hills', 43.0774993896484, 0.751844197875213, -89.445556640625, -1.56111946465798, 218, 57, 'PPL', 'P'),
(157651, 'Shorewood Village', 41.4047203063965, 0.722648695213974, -83.0883331298828, -1.45016498311034, 218, 41, 'PPL', 'P'),
(128810, 'Shorey', 46.2269401550293, 0.806812308827639, -68.1500015258789, -1.18944191186575, 218, 26, 'PPL', 'P'),
(197533, 'Shorey (historical)', 46.0805587768555, 0.804257471814899, -109.099998474121, -1.9041541872942, 218, 31, 'PPL', 'P'),
(61764, 'Short', 34.9402809143066, 0.609822943526386, -88.1977767944336, -1.53934159800192, 218, 30, 'PPL', 'P'),
(77247, 'Short', 35.5713882446289, 0.620837844373981, -94.4911117553711, -1.64918101400114, 218, 42, 'PPL', 'P'),
(98062, 'Short', 31.7177791595459, 0.553579677754516, -94.1836090087891, -1.64381407861436, 218, 51, 'PPL', 'P'),
(11932, 'Short (historical)', 35.3597183227539, 0.617143507309823, -91.7402801513672, -1.60116994534336, 218, 4, 'PPL', 'P'),
(106242, 'Short (historical)', 37.1161117553711, 0.647798355669398, -82.5769424438477, -1.44123953187499, 218, 53, 'PPL', 'P'),
(114061, 'Short Beach', 41.2613906860352, 0.720147121423035, -72.8408279418945, -1.27131227746474, 218, 8, 'PPL', 'P'),
(57549, 'Short Bend', 37.7463912963867, 0.658798808868079, -91.4338912963867, -1.59582245103253, 218, 29, 'PPL', 'P'),
(5832, 'Short Camp', 33.6575012207031, 0.58743421429528, -87.2241668701172, -1.5223488991925, 218, 2, 'PPL', 'P'),
(5833, 'Short Creek', 33.5511093139648, 0.585577325225222, -87.1013870239258, -1.52020598662137, 218, 2, 'PPL', 'P'),
(38198, 'Short Creek', 37.5277786254883, 0.654983297974323, -86.4744415283203, -1.50926372349251, 218, 21, 'PPL', 'P'),
(90807, 'Short Creek', 35.672779083252, 0.622607448339311, -86.3608322143555, -1.50728086690289, 218, 50, 'PPL', 'P'),
(177276, 'Short Creek', 40.1855583190918, 0.70137030442035, -80.6747207641602, -1.40803950046163, 218, 58, 'PPL', 'P'),
(144448, 'Short Falls', 43.1983299255371, 0.753953088563419, -71.370002746582, -1.24564153508525, 218, 36, 'PPL', 'P'),
(111386, 'Short Gap', 39.5436096191406, 0.690166185977305, -78.811393737793, -1.37551830881013, 218, 58, 'PPL', 'P'),
(146302, 'Short Hills', 40.7477798461914, 0.711182921193829, -74.3258285522461, -1.2972304275095, 218, 37, 'PPL', 'P'),
(157653, 'Short Line Junction', 41.4222183227539, 0.722954093211979, -81.7969436645508, -1.42762598501473, 218, 41, 'PPL', 'P'),
(38199, 'Short Mountain', 36.8416709899902, 0.643008460711809, -84.8955612182617, -1.48170706358708, 218, 21, 'PPL', 'P'),
(185127, 'Short Place', 38.7799987792969, 0.676838662618112, -120.47306060791, -2.10265156756271, 218, 6, 'PPL', 'P'),
(106244, 'Short Pump', 37.6502799987793, 0.657121350276465, -77.6127777099609, -1.35459851265728, 218, 53, 'PPL', 'P'),
(167172, 'Short Run', 41.5897216796875, 0.725877578298613, -77.7819366455078, -1.35755089304174, 218, 45, 'PPL', 'P'),
(38200, 'Short Town', 36.877498626709, 0.643633770935759, -83.1605606079102, -1.45142559041233, 218, 21, 'PPL', 'P'),
(152558, 'Short Tract', 42.452220916748, 0.740931029781259, -78.0147171020508, -1.36161367844272, 218, 40, 'PPL', 'P'),
(98066, 'Shortall', 31.0752792358398, 0.542365938642033, -98.0813903808594, -1.71184319707989, 218, 51, 'PPL', 'P'),
(5834, 'Shorter', 32.394718170166, 0.56539449232503, -85.9169387817383, -1.49953346497574, 218, 2, 'PPL', 'P'),
(5835, 'Shorterville', 31.5699996948242, 0.551000439528288, -85.1013870239258, -1.48529940158148, 218, 2, 'PPL', 'P'),
(5836, 'Shortleaf', 32.5116691589355, 0.567435672142521, -87.8555603027344, -1.53336879346714, 218, 2, 'PPL', 'P'),
(14617, 'Shortly', 38.6072196960449, 0.673823098736788, -75.3949966430664, -1.31589093095158, 218, 10, 'PPL', 'P'),
(14616, 'Shorts Corner', 39.2063903808594, 0.68428059996823, -75.6727828979492, -1.32073921571607, 218, 10, 'PPL', 'P'),
(31124, 'Shorts Corner', 38.4997215270996, 0.671946901748827, -86.1002807617188, -1.50273338618352, 218, 19, 'PPL', 'P'),
(98063, 'Shorts Corner', 29.548059463501, 0.515710925213161, -98.4108276367188, -1.71759296187337, 218, 51, 'PPL', 'P'),
(106245, 'Shorts Creek', 36.8386116027832, 0.642955064331952, -80.8461074829102, -1.41103076299801, 218, 53, 'PPL', 'P'),
(14622, 'Shorts Landing', 39.3497200012207, 0.686782173759168, -75.5358276367188, -1.31834889547967, 218, 10, 'PPL', 'P'),
(24858, 'Shorts Mill', 34.5724983215332, 0.603403926350968, -83.4927825927734, -1.4572239578957, 218, 13, 'PPL', 'P'),
(106246, 'Shortsville', 36.7722206115723, 0.641796322941659, -81.9077835083008, -1.42956050523056, 218, 53, 'PPL', 'P'),
(152559, 'Shortsville', 42.9558296203613, 0.749720659801011, -77.2211074829102, -1.34776257761321, 218, 40, 'PPL', 'P'),
(167170, 'Shortsville', 41.8661117553711, 0.730701495139128, -77.3608322143555, -1.3502012342234, 218, 45, 'PPL', 'P'),
(106247, 'Shortt Gap', 37.1572189331055, 0.648515811267065, -81.8730621337891, -1.42895450292451, 218, 53, 'PPL', 'P'),
(176392, 'Shortville', 44.4949989318848, 0.776584232032749, -90.5163879394531, -1.57980899655594, 218, 57, 'PPL', 'P'),
(167171, 'Shortys Place', 40.019718170166, 0.698475847789597, -78.1619415283203, -1.36418322942048, 218, 45, 'PPL', 'P'),
(185128, 'Shoshone', 35.9730606079102, 0.627848349627505, -116.270278930664, -2.02929918955228, 218, 6, 'PPL', 'P'),
(193196, 'Shoshone', 40.6974983215332, 0.71030534303562, -116.556106567383, -2.03428782290622, 218, 39, 'PPL', 'P'),
(195608, 'Shoshone', 42.9361114501953, 0.749376512809146, -114.404998779297, -1.99674390943882, 218, 17, 'PPL', 'P'),
(209734, 'Shoshoni', 43.2358283996582, 0.754607560401306, -108.109718322754, -1.8868705381357, 218, 59, 'PPL', 'P'),
(98064, 'Shotgun Crossing', 32.9208297729492, 0.574576872026541, -95.706672668457, -1.67039655419304, 218, 51, 'PPL', 'P'),
(138098, 'Shotley', 48.0488891601563, 0.83861131777054, -94.6386108398438, -1.65175535866887, 218, 28, 'PPL', 'P'),
(176393, 'Shoto', 44.1752815246582, 0.771004110600706, -87.649169921875, -1.5297666017767, 218, 57, 'PPL', 'P'),
(139453, 'Shott', 40.1622200012207, 0.700962973931622, -93.6605606079102, -1.63468516187173, 218, 29, 'PPL', 'P'),
(5839, 'Shottsville', 34.2608299255371, 0.597964286666426, -88.1272201538086, -1.53811015231386, 218, 2, 'PPL', 'P'),
(5837, 'Shotwell', 32.584171295166, 0.568701073134472, -85.1836090087891, -1.48673444593487, 218, 2, 'PPL', 'P'),
(68790, 'Shotwell', 35.7369384765625, 0.623727240998662, -78.4449996948242, -1.36912352640063, 218, 33, 'PPL', 'P'),
(38201, 'Shoulderblade', 37.4972190856934, 0.654449933387007, -83.4672164916992, -1.45677774525506, 218, 21, 'PPL', 'P'),
(24859, 'Shoulderbone', 33.3394393920898, 0.581882988161065, -83.0800018310547, -1.45001957451482, 218, 13, 'PPL', 'P'),
(106248, 'Shoulders Hill', 36.8191719055176, 0.642615777609076, -76.4691696166992, -1.33463878607741, 218, 53, 'PPL', 'P'),
(90808, 'Shouns', 36.4452781677246, 0.636090100832001, -81.7997207641602, -1.42767445454657, 218, 50, 'PPL', 'P'),
(195609, 'Shoup', 45.3769416809082, 0.791977036817298, -114.276107788086, -1.99449433726603, 218, 17, 'PPL', 'P'),
(68789, 'Shoups Ford', 35.5916709899902, 0.621191845061879, -81.5599975585938, -1.423490495316, 218, 33, 'PPL', 'P'),
(74296, 'Shoups Mobile Home Park', 39.9252815246582, 0.696827617390947, -83.7655563354492, -1.46198475781838, 218, 41, 'PPL', 'P'),
(51417, 'Shour Valley', 39.7033309936523, 0.692953849848345, -77.0911102294922, -1.34549369752252, 218, 25, 'PPL', 'P'),
(106249, 'Shouse Village', 38.9472198486328, 0.67975722085673, -77.271110534668, -1.34863529550243, 218, 53, 'PPL', 'P'),
(138100, 'Shovel Lake', 46.9575004577637, 0.819562991494721, -93.7533264160156, -1.63630423065645, 218, 28, 'PPL', 'P'),
(98065, 'Shovel Mountain', 30.4829692840576, 0.532028179791104, -98.2777481079102, -1.71527028592866, 218, 51, 'PPL', 'P'),
(57555, 'Shoveltown', 38.815559387207, 0.677459312310155, -90.2805633544922, -1.57569308109123, 218, 29, 'PPL', 'P'),
(57551, 'Shover (historical)', 36.689998626709, 0.64036127858827, -90.095832824707, -1.57246892511752, 218, 29, 'PPL', 'P'),
(11934, 'Shover Springs', 33.6227798461914, 0.586828211989233, -93.5302810668945, -1.63241135493302, 218, 4, 'PPL', 'P'),
(179144, 'Show Low', 34.2541694641113, 0.597848039684844, -110.029167175293, -1.92037124043613, 218, 5, 'PPL', 'P'),
(11935, 'Showalters Corner', 35.1205596923828, 0.612969401775287, -91.591667175293, -1.59857615959968, 218, 4, 'PPL', 'P'),
(51418, 'Showell', 38.3977813720703, 0.670167710403573, -75.2152786254883, -1.31275425981969, 218, 25, 'PPL', 'P'),
(114062, 'Showtucket (historical)', 41.5569381713867, 0.72530539813841, -72.0455627441406, -1.25743228133742, 218, 8, 'PPL', 'P'),
(5838, 'Shrader', 34.7150001525879, 0.605891052492993, -85.7341690063477, -1.49634353062204, 218, 2, 'PPL', 'P'),
(167173, 'Shrader', 40.6977806091309, 0.710310269883637, -77.5538864135742, -1.35357066563457, 218, 45, 'PPL', 'P'),
(106250, 'Shraders', 37.1994400024414, 0.64925270794069, -81.554443359375, -1.42339355625232, 218, 53, 'PPL', 'P'),
(61765, 'Shraderville', 33.0636100769043, 0.577068858437556, -90.8072204589844, -1.58488498159363, 218, 30, 'PPL', 'P'),
(208728, 'Shreck', 46.6974983215332, 0.81502509815528, -117.886390686035, -2.05750566076369, 218, 56, 'PPL', 'P'),
(193954, 'Shregegon (historical)', 41.3347206115723, 0.7214269700639, -123.85417175293, -2.16166308941918, 218, 6, 'PPL', 'P'),
(167175, 'Shreiners', 40.8655586242676, 0.713238548660234, -76.8441696166992, -1.34118377077239, 218, 45, 'PPL', 'P'),
(5840, 'Shreve', 31.5094394683838, 0.549943464181149, -86.7069396972656, -1.51332158204546, 218, 2, 'PPL', 'P'),
(38202, 'Shreve', 37.5786094665527, 0.655870463512455, -86.6288909912109, -1.51195937514789, 218, 21, 'PPL', 'P'),
(57552, 'Shreve', 36.646110534668, 0.639595286879736, -90.095832824707, -1.57246892511752, 218, 29, 'PPL', 'P'),
(157654, 'Shreve', 40.6813888549805, 0.710024179803535, -82.0219421386719, -1.4315529492001, 218, 41, 'PPL', 'P'),
(43063, 'Shreveport', 32.5250015258789, 0.567668365842767, -93.75, -1.63624617374468, 218, 22, 'PPL', 'P'),
(77248, 'Shrewder', 34.7686080932617, 0.606826687562965, -99.7552795410156, -1.74105807423806, 218, 42, 'PPL', 'P'),
(38203, 'Shrewsbury', 37.3788909912109, 0.652384718540678, -86.3847198486328, -1.50769778477154, 218, 21, 'PPL', 'P'),
(43064, 'Shrewsbury', 29.9708309173584, 0.523089679066417, -90.142219543457, -1.5732785260889, 218, 22, 'PPL', 'P'),
(57553, 'Shrewsbury', 38.5902786254883, 0.673527421276762, -90.336669921875, -1.57667232542405, 218, 29, 'PPL', 'P'),
(79125, 'Shrewsbury', 39.7686080932617, 0.694093150162681, -76.6800003051758, -1.33831847575557, 218, 45, 'PPL', 'P'),
(111387, 'Shrewsbury', 38.2061080932617, 0.66682238060027, -81.4716720581055, -1.42194892451901, 218, 58, 'PPL', 'P'),
(126094, 'Shrewsbury', 42.2958297729492, 0.738201489401009, -71.7133331298828, -1.25163378069599, 218, 23, 'PPL', 'P'),
(146304, 'Shrewsbury', 40.3294410705566, 0.70388153217024, -74.0619430541992, -1.29262475672032, 218, 37, 'PPL', 'P'),
(172528, 'Shrewsbury', 43.5088882446289, 0.75937335375103, -72.8672180175781, -1.27177287117527, 218, 55, 'PPL', 'P'),
(79126, 'Shrewsbury Station', 39.7572212219238, 0.693894411766334, -76.7005615234375, -1.33867733671246, 218, 45, 'PPL', 'P'),
(126095, 'Shrewsbury Street', 42.2680587768555, 0.737716794082615, -71.7874984741211, -1.25292821014382, 218, 23, 'PPL', 'P'),
(208729, 'Shrine Beach', 47.9205589294434, 0.836371532714756, -120.209442138672, -2.09805055730544, 218, 56, 'PPL', 'P'),
(74297, 'Shrine Road Mobile Home Park', 39.9491691589355, 0.697244535259599, -83.876106262207, -1.46391421802815, 218, 41, 'PPL', 'P'),
(79129, 'Shrivers Corners', 39.8925018310547, 0.696255503809771, -77.1891708374023, -1.34720517799706, 218, 45, 'PPL', 'P'),
(61766, 'Shrock (historical)', 32.8875007629395, 0.573995171065441, -89.8747177124023, -1.56860973838189, 218, 30, 'PPL', 'P'),
(33966, 'Shroyer', 39.7694396972656, 0.694107664390622, -96.6783294677734, -1.6873551645405, 218, 20, 'PPL', 'P'),
(185129, 'Shrub', 38.5924987792969, 0.673566170270623, -120.95361328125, -2.11103879394175, 218, 6, 'PPL', 'P'),
(152560, 'Shrub Oak', 41.3274993896484, 0.721300935965312, -73.8199996948242, -1.28840204849589, 218, 40, 'PPL', 'P'),
(57554, 'Shrum', 37.3838882446289, 0.652471937066378, -90.0149993896484, -1.57105811553005, 218, 29, 'PPL', 'P'),
(111388, 'Shryock', 37.954719543457, 0.662434822704364, -80.1505584716797, -1.39889114264304, 218, 58, 'PPL', 'P'),
(106251, 'Shrys Store', 39.2316703796387, 0.684721819181829, -77.503059387207, -1.35268356667546, 218, 53, 'PPL', 'P'),
(90809, 'Shubert', 35.5333290100098, 0.620173585419088, -87.5699996948242, -1.52838482064511, 218, 50, 'PPL', 'P'),
(143016, 'Shubert', 40.2363891601563, 0.702257469958483, -95.6819381713867, -1.66996485578034, 218, 35, 'PPL', 'P'),
(61767, 'Shubuta', 31.8600006103516, 0.556061910338038, -88.6994400024414, -1.54809727271777, 218, 30, 'PPL', 'P'),
(51419, 'Shucks Corners', 39.5308303833008, 0.689943146236011, -76.2802810668945, -1.331342058964, 218, 25, 'PPL', 'P'),
(61769, 'Shucktown', 32.5441703796387, 0.568002925454708, -88.7702789306641, -1.54933364525384, 218, 30, 'PPL', 'P'),
(152561, 'Shuetown', 43.6202812194824, 0.761317527925816, -75.3288879394531, -1.3147371164093, 218, 40, 'PPL', 'P'),
(117782, 'Shueyville', 41.8505592346191, 0.730430052445022, -91.6463928222656, -1.59953130232463, 218, 16, 'PPL', 'P'),
(51420, 'Shufelt', 38.5647201538086, 0.673081341794174, -75.9908294677734, -1.32629017553418, 218, 25, 'PPL', 'P'),
(14618, 'Shuffelt Acres', 38.6441688537598, 0.674467983194751, -75.6727828979492, -1.32073921571607, 218, 10, 'PPL', 'P'),
(68791, 'Shuffletown', 35.3205604553223, 0.616460073595081, -80.9527816772461, -1.41289257891608, 218, 33, 'PPL', 'P'),
(61770, 'Shuford', 34.2222213745117, 0.597290440331609, -89.8069381713867, -1.56742676222567, 218, 30, 'PPL', 'P'),
(61771, 'Shula Grove (historical)', 33.4333305358887, 0.583521697758818, -88.5772171020508, -1.54596408068462, 218, 30, 'PPL', 'P'),
(11936, 'Shuler', 33.1786117553711, 0.579076016372121, -92.9013900756836, -1.62143513650026, 218, 4, 'PPL', 'P'),
(83638, 'Shuler (historical)', 33.8800010681152, 0.591317569217806, -81.1608276367188, -1.41652366590435, 218, 48, 'PPL', 'P'),
(83639, 'Shulerville', 33.1872215270996, 0.579226285236629, -79.6322174072266, -1.38984438442005, 218, 48, 'PPL', 'P'),
(43065, 'Shull (historical)', 32.4824981689453, 0.566926542321125, -92.7422180175781, -1.61865706000915, 218, 22, 'PPL', 'P'),
(98067, 'Shull Addition Colonia', 26.0939998626709, 0.455426212618555, -97.9560012817383, -1.70965474445412, 218, 51, 'PPL', 'P'),
(68792, 'Shulls Mill', 36.1736106872559, 0.631348608827224, -81.7438888549805, -1.42670000390371, 218, 33, 'PPL', 'P'),
(176394, 'Shullsburg', 42.5733299255371, 0.743044780738455, -90.230827331543, -1.57482502373391, 218, 57, 'PPL', 'P'),
(152562, 'Shultis Corners', 42.0502815246582, 0.733915863995827, -74.0691680908203, -1.29275085739794, 218, 40, 'PPL', 'P'),
(77249, 'Shults', 33.8955612182617, 0.591589145069967, -94.7391662597656, -1.65351038182723, 218, 42, 'PPL', 'P'),
(38204, 'Shultztown', 37.2922210693359, 0.650872043041513, -86.8377838134766, -1.5156052426802, 218, 21, 'PPL', 'P'),
(11937, 'Shumaker', 33.6716690063477, 0.587681488802494, -92.7255630493164, -1.61836637597616, 218, 4, 'PPL', 'P'),
(152563, 'Shumaker Crossing', 42.8944396972656, 0.748649203515445, -76.5699996948242, -1.33639860292574, 218, 40, 'PPL', 'P'),
(185130, 'Shuman', 34.8669395446777, 0.608542895148439, -120.521667480469, -2.10349991752796, 218, 6, 'PPL', 'P'),
(167179, 'Shumans', 40.9533309936523, 0.714770465498274, -76.3024978637695, -1.33172981521872, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(106252, 'Shumansville', 37.9322204589844, 0.662042139601632, -77.279167175293, -1.34877591040799, 218, 53, 'PPL', 'P'),
(106253, 'Shumate', 37.3147201538086, 0.651264726144245, -80.8483276367188, -1.41106951199187, 218, 53, 'PPL', 'P'),
(193955, 'Shumig (historical)', 41.1355590820313, 0.717950945630102, -124.151390075684, -2.16685052774849, 218, 6, 'PPL', 'P'),
(152564, 'Shumla', 42.3866691589355, 0.739786935776961, -79.2988891601563, -1.38402670901877, 218, 40, 'PPL', 'P'),
(192212, 'Shumla', 29.7811107635498, 0.519778437725067, -101.397216796875, -1.76971528546397, 218, 51, 'PPL', 'P'),
(68793, 'Shumont', 35.4708290100098, 0.619082754636591, -82.2588882446289, -1.43568843889883, 218, 33, 'PPL', 'P'),
(28607, 'Shumway', 39.185001373291, 0.683907291362428, -88.6522216796875, -1.54727315751844, 218, 18, 'PPL', 'P'),
(179145, 'Shumway', 34.4061088562012, 0.600499882340291, -110.072219848633, -1.9211226513377, 218, 5, 'PPL', 'P'),
(193956, 'Shumway', 40.6969413757324, 0.710295622497641, -120.48999786377, -2.10294717844371, 218, 6, 'PPL', 'P'),
(117783, 'Shunem', 40.776668548584, 0.711687124167208, -92.2972183227539, -1.61089035016409, 218, 16, 'PPL', 'P'),
(192782, 'Shunesburg', 37.1580581665039, 0.64853045865306, -112.976936340332, -1.97181951795483, 218, 52, 'PPL', 'P'),
(212147, 'Shungnak', 66.8880615234375, 1.16741690386052, -157.136383056641, -2.74254725901341, 218, 1, 'PPL', 'P'),
(179146, 'Shungopavi', 35.8055610656738, 0.624924931119898, -110.527221679688, -1.9290639313922, 218, 5, 'PPL', 'P'),
(157655, 'Shunk', 41.3636093139648, 0.721931173037279, -84.0388870239258, -1.46675527827904, 218, 41, 'PPL', 'P'),
(167178, 'Shunk', 41.5461082458496, 0.725116380280041, -76.7430572509766, -1.33941902707605, 218, 45, 'PPL', 'P'),
(152565, 'Shunpike', 41.8286094665527, 0.730046956722214, -73.7088928222656, -1.28646286774815, 218, 40, 'PPL', 'P'),
(106254, 'Shupe', 36.9833297729492, 0.645480872888811, -81.1616668701172, -1.41653831329035, 218, 53, 'PPL', 'P'),
(68794, 'Shupings Mill', 35.5513916015625, 0.620488837113126, -80.4816665649414, -1.40467006905046, 218, 33, 'PPL', 'P'),
(61772, 'Shuqualak', 32.978328704834, 0.57558041770431, -88.5699996948242, -1.54583811316506, 218, 30, 'PPL', 'P'),
(189562, 'Shuree', 36.7713890075684, 0.641781808713718, -105.191673278809, -1.83594104439735, 218, 38, 'PPL', 'P'),
(152566, 'Shurtleff', 44.2552795410156, 0.772400339381208, -74.745002746582, -1.30454639734006, 218, 40, 'PPL', 'P'),
(152567, 'Shushan', 43.0902786254883, 0.752067237616507, -73.3433303833008, -1.28008259956659, 218, 40, 'PPL', 'P'),
(61773, 'Shutersville (historical)', 34.2249984741211, 0.597338909863448, -90.5416717529297, -1.58025028234857, 218, 30, 'PPL', 'P'),
(126097, 'Shutesbury', 42.4563903808594, 0.741003800658045, -72.4102783203125, -1.26379776897492, 218, 23, 'PPL', 'P'),
(43066, 'Shuteston', 30.4280605316162, 0.531069841272839, -92.1002807617188, -1.60745314130318, 218, 22, 'PPL', 'P'),
(126099, 'Shutleff Corner', 41.9111099243164, 0.731486861344593, -70.769172668457, -1.23515507197696, 218, 23, 'PPL', 'P'),
(152568, 'Shutter Corners', 42.6752815246582, 0.744824171820791, -74.2533264160156, -1.29596502651755, 218, 40, 'PPL', 'P'),
(208730, 'Shuwah', 48.0213890075684, 0.83813134956308, -124.385276794434, -2.17093262106736, 218, 56, 'PPL', 'P'),
(128811, 'Shy Corner', 44.4627799987793, 0.776021905568579, -70.179443359375, -1.22486235383796, 218, 26, 'PPL', 'P'),
(74298, 'Shyville', 39.0074996948242, 0.680809302645366, -82.9858322143555, -1.44837600464808, 218, 41, 'PPL', 'P'),
(90810, 'Siam', 36.3477783203125, 0.634388407474467, -82.1502838134766, -1.43379293399297, 218, 50, 'PPL', 'P'),
(117784, 'Siam', 40.6277809143066, 0.709088544733563, -94.8852767944336, -1.65606049172904, 218, 16, 'PPL', 'P'),
(157656, 'Siam', 41.0847206115723, 0.717063646933914, -82.8783264160156, -1.44649967450206, 218, 41, 'PPL', 'P'),
(111389, 'Sias', 38.1847190856934, 0.666449071994468, -82.0875015258789, -1.43269717636246, 218, 58, 'PPL', 'P'),
(126100, 'Siasconset', 41.2625007629395, 0.720166495919966, -69.966667175293, -1.2211487088559, 218, 23, 'PPL', 'P'),
(185131, 'Sibagna (historical)', 34.0972213745117, 0.595108778766616, -118.106941223145, -2.06135499380329, 218, 6, 'PPL', 'P'),
(112283, 'Sibbie', 31.8544406890869, 0.555964871405818, -83.3050003051758, -1.4539465387002, 218, 13, 'PPL', 'P'),
(31125, 'Siberia', 38.2380599975586, 0.667380046532532, -86.7336120605469, -1.51378710260401, 218, 19, 'PPL', 'P'),
(128812, 'Siberia', 45.8758316040039, 0.80068430858034, -68.4638900756836, -1.19492030054415, 218, 26, 'PPL', 'P'),
(185132, 'Siberia', 34.6266708374023, 0.604349415116973, -115.985000610352, -2.02432014357827, 218, 6, 'PPL', 'P'),
(5841, 'Sibert', 30.7444400787354, 0.536591706056037, -88.0599975585938, -1.53693689669563, 218, 2, 'PPL', 'P'),
(38205, 'Sibert', 37.1230583190918, 0.647919596078024, -83.7872161865234, -1.46236279353512, 218, 21, 'PPL', 'P'),
(5842, 'Siberton', 33.9888916015625, 0.593218067550714, -86.1083297729492, -1.50287386793103, 218, 2, 'PPL', 'P'),
(24860, 'Sibley', 31.798059463501, 0.554980833383034, -83.7102813720703, -1.4610200277135, 218, 13, 'PPL', 'P'),
(43068, 'Sibley', 32.5755615234375, 0.568550804269964, -92.4672164916992, -1.61385737793455, 218, 22, 'PPL', 'P'),
(57556, 'Sibley', 39.1786117553711, 0.683795771491781, -94.1930618286133, -1.64397906144389, 218, 29, 'PPL', 'P'),
(61774, 'Sibley', 31.3791694641113, 0.547669823690007, -91.3986129760742, -1.59520672818851, 218, 30, 'PPL', 'P'),
(90811, 'Sibley', 35.3147201538086, 0.616358141104358, -88.2719421386719, -1.54063602744975, 218, 50, 'PPL', 'P'),
(117788, 'Sibley', 43.399169921875, 0.757458407769209, -95.7516708374023, -1.67118192039851, 218, 16, 'PPL', 'P'),
(121458, 'Sibley', 40.5869407653809, 0.708375749667803, -88.3811111450195, -1.54254138605165, 218, 18, 'PPL', 'P'),
(140878, 'Sibley', 47.2172203063965, 0.824095957986144, -97.9641723632813, -1.70979735673049, 218, 34, 'PPL', 'P'),
(185135, 'Sibley (historical)', 37.978328704834, 0.662846880304027, -121.159172058105, -2.11462647140426, 218, 6, 'PPL', 'P'),
(128813, 'Sibley Corner', 44.5055618286133, 0.77676858935921, -69.3550033569336, -1.21047316131021, 218, 26, 'PPL', 'P'),
(138102, 'Sibley Estates East', 44.5277786254883, 0.777156345613926, -93.9091720581055, -1.6390242502358, 218, 28, 'PPL', 'P'),
(24861, 'Sibley Forest', 33.9316711425781, 0.592219382141935, -84.4486083984375, -1.47390626528007, 218, 13, 'PPL', 'P'),
(126101, 'Sibleys Corner', 42.2516708374023, 0.737430770581541, -71.9772186279297, -1.25623945148517, 218, 23, 'PPL', 'P'),
(61775, 'Sibleyton', 33.438060760498, 0.58360425575261, -89.5250015258789, -1.56250603947953, 218, 30, 'PPL', 'P'),
(33968, 'Sibleyville', 38.8841705322266, 0.678656802694309, -95.1952819824219, -1.6614711029577, 218, 20, 'PPL', 'P'),
(152569, 'Sibleyville', 42.9669418334961, 0.749914604507396, -77.6186065673828, -1.35470024541092, 218, 40, 'PPL', 'P'),
(167180, 'Sibleyville', 41.9836082458496, 0.732752195757517, -80.0469436645508, -1.39708272310483, 218, 45, 'PPL', 'P'),
(117785, 'Sibyl (historical)', 41.9491691589355, 0.732151120299486, -90.1852798461914, -1.57403007014853, 218, 16, 'PPL', 'P'),
(209735, 'Sibylee', 42.0813903808594, 0.734458815963067, -104.949722290039, -1.83171820301486, 218, 59, 'PPL', 'P'),
(43069, 'Sicard', 32.5263900756836, 0.567692600608686, -92.041389465332, -1.60642529428047, 218, 22, 'PPL', 'P'),
(185133, 'Sicard Flat', 39.2311096191406, 0.684712032064823, -121.345001220703, -2.11786980213781, 218, 6, 'PPL', 'P'),
(179147, 'Sichomovi', 35.8352813720703, 0.625443648321218, -110.393608093262, -1.92673193438368, 218, 5, 'PPL', 'P'),
(28608, 'Sicily', 39.5900001525879, 0.690975853527716, -89.4911117553711, -1.56191455140143, 218, 18, 'PPL', 'P'),
(74299, 'Sicily (historical)', 39.0283317565918, 0.681172890713189, -83.8636093139648, -1.46369610513487, 218, 41, 'PPL', 'P'),
(43070, 'Sicily Island', 31.8463897705078, 0.555824356368803, -91.6561126708984, -1.59970094568607, 218, 22, 'PPL', 'P'),
(167183, 'Sickler Hill', 41.2275009155273, 0.719555633344929, -75.976936340332, -1.32604769471693, 218, 45, 'PPL', 'P'),
(71392, 'Sicklerville', 39.7172203063965, 0.69319626408657, -74.9697189331055, -1.30846843467742, 218, 37, 'PPL', 'P'),
(77251, 'Sickles', 35.3627815246582, 0.617196970268706, -98.4475021362305, -1.71823305264137, 218, 42, 'PPL', 'P'),
(133113, 'Sickles', 43.2777786254883, 0.755339729963996, -84.4488906860352, -1.47391119212809, 218, 27, 'PPL', 'P'),
(167181, 'Sickles Corner', 40.5538902282715, 0.707798908975692, -78.2830581665039, -1.36629711353573, 218, 45, 'PPL', 'P'),
(189563, 'Sid Place', 32.936939239502, 0.574858035258626, -108.969169616699, -1.90187079297557, 218, 38, 'PPL', 'P'),
(192211, 'Sid Place', 29.833610534668, 0.520694731587622, -103.652496337891, -1.80907733900756, 218, 51, 'PPL', 'P'),
(133114, 'Sid Town', 44.4519386291504, 0.775832687973129, -83.6061096191406, -1.45920188763731, 218, 27, 'PPL', 'P'),
(106256, 'Siddon', 36.5713882446289, 0.638291136893924, -78.6800003051758, -1.37322506079546, 218, 53, 'PPL', 'P'),
(167182, 'Siddonsburg', 40.1458282470703, 0.70067688385152, -76.9663925170898, -1.34331696280554, 218, 45, 'PPL', 'P'),
(5846, 'Siddonsville', 32.4180603027344, 0.565801889392785, -87.6133270263672, -1.52914102523664, 218, 2, 'PPL', 'P'),
(138105, 'Side Lake', 47.6652793884277, 0.831916064211053, -93.0155563354492, -1.62342771362786, 218, 28, 'PPL', 'P'),
(106255, 'Sideburn', 38.7999992370605, 0.677187736457994, -77.3091735839844, -1.34929962103635, 218, 53, 'PPL', 'P'),
(18078, 'Sidell', 27.1175003051758, 0.473289665235885, -82.1166687011719, -1.43320623960482, 218, 12, 'PPL', 'P'),
(28609, 'Sidell', 39.9097213745117, 0.696556041538786, -87.8211135864258, -1.53276758485106, 218, 18, 'PPL', 'P'),
(38206, 'Sidell', 37.1925010681152, 0.649131600690119, -83.8249969482422, -1.46302219222102, 218, 21, 'PPL', 'P'),
(205736, 'Siders Estates', 40.8441696166992, 0.712865240054432, -111.899436950684, -1.95301360591723, 218, 52, 'PPL', 'P'),
(185134, 'Sides (historical)', 36.2527809143066, 0.632730389958811, -119.098327636719, -2.0786579508797, 218, 6, 'PPL', 'P'),
(38207, 'Sideview', 38.1130599975586, 0.665198384967539, -84.0366668701172, -1.46671652928518, 218, 21, 'PPL', 'P'),
(90812, 'Sideview (historical)', 36.4458312988281, 0.636099754790952, -86.3611068725586, -1.50728566059285, 218, 50, 'PPL', 'P'),
(38208, 'Sideway', 38.184440612793, 0.666444211725479, -83.225830078125, -1.45256475756861, 218, 21, 'PPL', 'P'),
(5843, 'Sidhart (historical)', 34.0050010681152, 0.593499230782799, -85.459716796875, -1.49155343592737, 218, 2, 'PPL', 'P'),
(167186, 'Sidley', 40.065559387207, 0.699275927960084, -75.5627822875977, -1.31881934288623, 218, 45, 'PPL', 'P'),
(167184, 'Sidman', 40.3305587768555, 0.703901039825225, -78.745002746582, -1.37435956741983, 218, 45, 'PPL', 'P'),
(51421, 'Sidmar', 39.5533294677734, 0.690335829338743, -77.2633285522461, -1.34849947428684, 218, 25, 'PPL', 'P'),
(133115, 'Sidnaw', 46.5047187805176, 0.811660460434074, -88.7083282470703, -1.54825240185127, 218, 27, 'PPL', 'P'),
(5845, 'Sidney', 31.0677795410156, 0.542235044274455, -88.2344436645508, -1.53998155561186, 218, 2, 'PPL', 'P'),
(11939, 'Sidney', 36.003059387207, 0.628371927097815, -91.6597213745117, -1.59976392944585, 218, 4, 'PPL', 'P'),
(38209, 'Sidney', 37.6199989318848, 0.656592845958139, -82.3566665649414, -1.43739499252536, 218, 21, 'PPL', 'P'),
(68795, 'Sidney', 34.186939239502, 0.596674650908555, -78.789436340332, -1.37513507992927, 218, 33, 'PPL', 'P'),
(83644, 'Sidney', 32.999439239502, 0.575948866041123, -80.5686111450195, -1.40618753823959, 218, 48, 'PPL', 'P'),
(98068, 'Sidney', 31.9491691589355, 0.557618195100053, -98.7369384765625, -1.72328466975509, 218, 51, 'PPL', 'P'),
(111390, 'Sidney', 38.1569404602051, 0.665964243518019, -82.4727783203125, -1.43942152495685, 218, 58, 'PPL', 'P'),
(117786, 'Sidney', 40.7483291625977, 0.711192508573753, -95.647216796875, -1.66935885347429, 218, 16, 'PPL', 'P'),
(121459, 'Sidney', 40.0250015258789, 0.698568059742341, -88.0733337402344, -1.5371696569749, 218, 18, 'PPL', 'P'),
(123669, 'Sidney', 41.1055603027344, 0.717427368159792, -85.7436065673828, -1.49650824713546, 218, 19, 'PPL', 'P'),
(128814, 'Sidney', 44.4130592346191, 0.775154114527377, -69.7294387817383, -1.21700829230916, 218, 26, 'PPL', 'P'),
(133116, 'Sidney', 43.25, 0.754854901487548, -85.133056640625, -1.48585214066573, 218, 27, 'PPL', 'P'),
(139454, 'Sidney', 40.3541717529297, 0.704313164003915, -92.8188934326172, -1.61999529845691, 218, 29, 'PPL', 'P'),
(146308, 'Sidney', 40.6041717529297, 0.708676487133901, -74.9225006103516, -1.3076443194781, 218, 37, 'PPL', 'P'),
(152570, 'Sidney', 42.3147201538086, 0.738531188743961, -75.3919372558594, -1.31583753457172, 218, 40, 'PPL', 'P'),
(157657, 'Sidney', 40.2841682434082, 0.703091372274814, -84.1555633544922, -1.46879166440657, 218, 41, 'PPL', 'P'),
(167185, 'Sidney', 40.8772201538086, 0.713442080746543, -78.809440612793, -1.37548422034818, 218, 45, 'PPL', 'P'),
(176397, 'Sidney', 44.5527801513672, 0.777592704558535, -90.6386108398438, -1.5819421885891, 218, 57, 'PPL', 'P'),
(197534, 'Sidney', 47.7166709899902, 0.832813016866192, -104.155830383301, -1.81786217533735, 218, 31, 'PPL', 'P'),
(199683, 'Sidney', 41.1427803039551, 0.71807697972869, -102.977500915527, -1.79729644645143, 218, 35, 'PPL', 'P'),
(201563, 'Sidney', 44.7833290100098, 0.781616541228563, -123.108329772949, -2.14864569116893, 218, 43, 'PPL', 'P'),
(152571, 'Sidney Center', 42.2905616760254, 0.738109543764375, -75.2561111450195, -1.31346692172739, 218, 40, 'PPL', 'P'),
(68798, 'Sidney Crossroads', 35.4808311462402, 0.619257324846046, -76.6758270263672, -1.33824563829976, 218, 33, 'PPL', 'P'),
(24862, 'Sidney on Lanier', 34.327220916748, 0.59912302805672, -83.8847198486328, -1.46406455347168, 218, 13, 'PPL', 'P'),
(111391, 'Sidneyville', 38.8580589294434, 0.67820106925277, -81.732780456543, -1.42650612577635, 218, 58, 'PPL', 'P'),
(11940, 'Sidon', 35.3444404602051, 0.616876858305679, -91.9391708374023, -1.60464124266622, 218, 4, 'PPL', 'P'),
(61776, 'Sidon', 33.4080581665039, 0.583080611703273, -90.2038879394531, -1.57435484264346, 218, 30, 'PPL', 'P'),
(978, 'Sidonia', 36.2438888549805, 0.632575194246287, -88.9058303833008, -1.55169946440821, 218, 50, 'PPL', 'P'),
(193957, 'Sids Place', 40.4191703796387, 0.705447604049261, -123.455558776855, -2.15470598054551, 218, 6, 'PPL', 'P'),
(38210, 'Sidville', 38.128059387207, 0.665460173702694, -84.2597198486328, -1.47060953816666, 218, 21, 'PPL', 'P'),
(197535, 'Sieben', 46.898609161377, 0.818535144472004, -112.126388549805, -1.95697465856456, 218, 31, 'PPL', 'P'),
(11941, 'Siedenstricker', 34.728328704834, 0.606123679614211, -91.5527801513672, -1.59789745299587, 218, 4, 'PPL', 'P'),
(138106, 'Siegel', 45.0155601501465, 0.785669739249609, -92.8066711425781, -1.6197819792536, 218, 28, 'PPL', 'P'),
(190729, 'Siegel (historical)', 39.7311096191406, 0.693438678324794, -114.600830078125, -2.00016181038183, 218, 39, 'PPL', 'P'),
(43071, 'Siegen', 30.3733291625977, 0.530114598679341, -91.0711135864258, -1.58949078554087, 218, 22, 'PPL', 'P'),
(152573, 'Siegfield Park', 40.8405609130859, 0.712802256294651, -72.9402770996094, -1.2730479927052, 218, 40, 'PPL', 'P'),
(43072, 'Siegle', 32.4894409179688, 0.567047716150724, -92.1750030517578, -1.608757291289, 218, 22, 'PPL', 'P'),
(208731, 'Sieler', 47.0677795410156, 0.821487724593548, -119.175827026367, -2.08001057039735, 218, 56, 'PPL', 'P'),
(133118, 'Siemens', 46.4749984741211, 0.811141743232754, -90.1033325195313, -1.5725998194851, 218, 27, 'PPL', 'P'),
(98069, 'Sienna Plantation', 29.4858303070068, 0.5146248215416, -95.5077819824219, -1.66692525687018, 218, 51, 'PPL', 'P'),
(43073, 'Sieper', 31.2108306884766, 0.544731757796405, -92.8080596923828, -1.61980621401952, 218, 22, 'PPL', 'P'),
(43074, 'Sieps', 31.3216705322266, 0.546666278012238, -92.4613876342773, -1.61375564518091, 218, 22, 'PPL', 'P'),
(152574, 'Sierks', 42.8216705322266, 0.747379141991586, -78.3030624389648, -1.36664625395464, 218, 40, 'PPL', 'P'),
(98078, 'Sierra Alto Mobile Home Colonia', 26.1679992675781, 0.456717745878703, -97.8479995727539, -1.70776975903456, 218, 51, 'PPL', 'P'),
(192213, 'Sierra Blanca', 31.1744403839111, 0.544096627165934, -105.356666564941, -1.83882072048405, 218, 51, 'PPL', 'P'),
(185138, 'Sierra Cedars', 37.0761108398438, 0.647100207989633, -119.307220458984, -2.08230381841202, 218, 6, 'PPL', 'P'),
(192214, 'Sierra Chino', 29.0400009155273, 0.50684363075812, -103.413330078125, -1.80490310031497, 218, 51, 'PPL', 'P'),
(185136, 'Sierra City', 39.5658302307129, 0.690554008811048, -120.632781982422, -2.10543923143375, 218, 6, 'PPL', 'P'),
(189567, 'Sierra de los Pinos', 35.8116683959961, 0.625031524142528, -106.590278625488, -1.86035131263291, 218, 38, 'PPL', 'P'),
(185139, 'Sierra Glen', 36.6394386291504, 0.639478840161072, -118.999168395996, -2.07692729564531, 218, 6, 'PPL', 'P'),
(205737, 'Sierra Grande', 40.6405601501465, 0.709311584474857, -111.965827941895, -1.95417234730753, 218, 52, 'PPL', 'P'),
(185141, 'Sierra Heights', 36.1872215270996, 0.631586162796459, -119.061111450195, -2.07800840588983, 218, 6, 'PPL', 'P'),
(185142, 'Sierra Knoll Estates', 39.0672187805176, 0.681851597316996, -121.033332824707, -2.11243016245327, 218, 6, 'PPL', 'P'),
(185143, 'Sierra Madre', 34.1616706848145, 0.596233631432038, -118.051940917969, -2.06039505738837, 218, 6, 'PPL', 'P'),
(51430, 'Sierra Manor', 38.3902816772461, 0.670036816035995, -75.5038909912109, -1.31779149586352, 218, 25, 'PPL', 'P'),
(192215, 'Sierra Meadows Colonia', 31.5739994049072, 0.551070247638361, -106.261001586914, -1.85460434415857, 218, 51, 'PPL', 'P'),
(179148, 'Sierra Plaza Subdivision', 34.9105606079102, 0.609304226325065, -110.165000915527, -1.92274198643852, 218, 5, 'PPL', 'P'),
(185144, 'Sierra Sky Park', 36.8422203063965, 0.643018048091733, -119.864723205566, -2.09203407692879, 218, 6, 'PPL', 'P'),
(185145, 'Sierra Springs', 38.7069396972656, 0.675563541088182, -120.610557556152, -2.10505134202098, 218, 6, 'PPL', 'P'),
(185146, 'Sierra Subdivision', 39.6425018310547, 0.691892180679785, -120.215560913086, -2.09815735006515, 218, 6, 'PPL', 'P'),
(185148, 'Sierra Village', 38.0719413757324, 0.66448072963279, -120.171943664551, -2.09739608546755, 218, 6, 'PPL', 'P'),
(179149, 'Sierra Vista', 31.5544395446777, 0.550728863676127, -110.303062438965, -1.92515161459282, 218, 5, 'PPL', 'P'),
(185149, 'Sierra Vista', 37.1513900756836, 0.648414078513424, -120.285278320313, -2.09937414836721, 218, 6, 'PPL', 'P'),
(189565, 'Sierra Vista', 33.4088897705078, 0.583095125931214, -105.692497253418, -1.84468207172721, 218, 38, 'PPL', 'P'),
(179150, 'Sierra Vista Estates', 31.4833297729492, 0.549487764029123, -110.254173278809, -1.92429833777956, 218, 5, 'PPL', 'P'),
(189566, 'Sierra Vista Estates', 35.1263885498047, 0.613071134528928, -106.356391906738, -1.85626921931403, 218, 38, 'PPL', 'P'),
(185151, 'Sierra Vista Park', 39.2311096191406, 0.684712032064823, -121.076667785645, -2.11318650020285, 218, 6, 'PPL', 'P'),
(185153, 'Sierraville', 39.5897216796875, 0.690970993258727, -120.366386413574, -2.10078975164464, 218, 6, 'PPL', 'P'),
(205738, 'Siesta Drive Condo', 40.6155586242676, 0.708875225530248, -111.854721069336, -1.95223316655978, 218, 52, 'PPL', 'P'),
(18079, 'Siesta Key', 27.3016700744629, 0.476504034092583, -82.5516662597656, -1.44079837924042, 218, 12, 'PPL', 'P'),
(98070, 'Siesta Shores', 26.857780456543, 0.468756698744461, -99.2533264160156, -1.73229733951614, 218, 51, 'PPL', 'P'),
(98071, 'Siesta Shores 1 Colonia', 26.8610000610352, 0.468812891443461, -99.2539978027344, -1.73230905742493, 218, 51, 'PPL', 'P'),
(98072, 'Siesta Shores 3 Colonia', 26.8560009002686, 0.468725639628248, -99.2590026855469, -1.73239640910869, 218, 51, 'PPL', 'P'),
(98073, 'Siesta Shores Section A Colonia', 26.8549995422363, 0.468708162633594, -99.2529983520508, -1.73229161371979, 218, 51, 'PPL', 'P'),
(98074, 'Siesta Village Number 1 Colonia', 26.132999420166, 0.456106883303666, -97.9589996337891, -1.70970707556954, 218, 51, 'PPL', 'P'),
(98075, 'Siesta Village Number 2 Colonia', 26.1340007781982, 0.45612436029832, -97.9619979858398, -1.70975940668496, 218, 51, 'PPL', 'P'),
(98076, 'Siesta Village Number 3 Colonia', 26.132999420166, 0.456106883303666, -97.9619979858398, -1.70975940668496, 218, 51, 'PPL', 'P'),
(98077, 'Siesta Village Number 4 Colonia', 26.1310005187988, 0.456071995893386, -97.9619979858398, -1.70975940668496, 218, 51, 'PPL', 'P'),
(98079, 'Siez Tract Colonia', 26.3250007629395, 0.459457938903313, -98.1330032348633, -1.71274401131861, 218, 51, 'PPL', 'P'),
(179151, 'Sif Vaya', 32.6180610656738, 0.569292561212579, -112.113891601563, -1.95675654567128, 218, 5, 'PPL', 'P'),
(208732, 'Sifton', 45.672779083252, 0.797140373538744, -122.529998779297, -2.13855191116336, 218, 56, 'PPL', 'P'),
(152575, 'Sigby Corners', 42.8638916015625, 0.748116038665211, -75.4927825927734, -1.31759761773616, 218, 40, 'PPL', 'P'),
(28611, 'Sigel', 39.2261085510254, 0.684624746960095, -88.4941711425781, -1.54451465526134, 218, 18, 'PPL', 'P'),
(167187, 'Sigel', 41.2750015258789, 0.72038467539227, -79.1133270263672, -1.38078803881712, 218, 45, 'PPL', 'P'),
(208733, 'Sightly', 46.2999992370605, 0.808087430357569, -122.707221984863, -2.14164503961144, 218, 56, 'PPL', 'P'),
(167188, 'Siglerville', 40.7394409179688, 0.711037379440256, -77.5327835083008, -1.35320235045581, 218, 45, 'PPL', 'P'),
(90813, 'Siglo', 35.5872192382813, 0.621114147337076, -87.1294403076172, -1.52069560878778, 218, 50, 'PPL', 'P'),
(5850, 'Sigma', 31.2819404602051, 0.545972857443409, -85.1972198486328, -1.48697199990411, 218, 2, 'PPL', 'P'),
(106268, 'Sigma', 36.8300018310547, 0.642804795467445, -82.9366683959961, -1.44751793414486, 218, 53, 'PPL', 'P'),
(133120, 'Sigma', 44.6699981689453, 0.779638544907934, -85.0533294677734, -1.48446063899616, 218, 27, 'PPL', 'P'),
(111392, 'Sigman', 38.5816688537598, 0.673377152412254, -81.7591705322266, -1.42696671948688, 218, 58, 'PPL', 'P'),
(167189, 'Sigmund', 40.473331451416, 0.706392893078185, -75.5591735839844, -1.31875635912645, 218, 45, 'PPL', 'P'),
(68796, 'Sign Pine', 36.3088912963867, 0.633709700870661, -76.6244430541992, -1.33734881880268, 218, 33, 'PPL', 'P'),
(106259, 'Sign Pine (historical)', 36.6336097717285, 0.639377107407431, -76.2438888549805, -1.33070689504402, 218, 53, 'PPL', 'P'),
(106260, 'Sign Post', 37.9963912963867, 0.663162131998065, -75.4611129760742, -1.31704487865191, 218, 53, 'PPL', 'P'),
(106261, 'Sign Rock', 36.8286094665527, 0.642780494122498, -79.1111068725586, -1.38074928982326, 218, 53, 'PPL', 'P'),
(61777, 'Signal', 32.4008293151855, 0.565501151926687, -90.853889465332, -1.58569950941303, 218, 30, 'PPL', 'P'),
(157658, 'Signal', 40.7983283996582, 0.712065159883945, -80.6594390869141, -1.40777278487846, 218, 41, 'PPL', 'P'),
(179152, 'Signal', 34.4741706848145, 0.601687785344521, -113.633056640625, -1.98327097748411, 218, 5, 'PPL', 'P'),
(57557, 'Signal (historical)', 38.0311088562012, 0.663768067725085, -91.8152770996094, -1.60247888901913, 218, 29, 'PPL', 'P'),
(193958, 'Signal Butte', 41.2802810668945, 0.720476820765987, -122.1875, -2.13257417978057, 218, 6, 'PPL', 'P'),
(197536, 'Signal Butte (historical)', 45.9536094665527, 0.80204178836698, -106.349998474121, -1.85615763286436, 218, 31, 'PPL', 'P'),
(28613, 'Signal Hill', 38.577220916748, 0.673299521266479, -90.0566711425781, -1.57178542482375, 218, 18, 'PPL', 'P'),
(185154, 'Signal Hill', 33.8044395446777, 0.589998771845999, -118.166938781738, -2.06240214874391, 218, 6, 'PPL', 'P'),
(68797, 'Signal Hill Apartments', 35.7930603027344, 0.624706751647593, -80.8550033569336, -1.41118602528956, 218, 33, 'PPL', 'P'),
(90814, 'Signal Hills', 35.0988883972168, 0.612591166321468, -85.3330612182617, -1.48934287906455, 218, 50, 'PPL', 'P'),
(90815, 'Signal Mountain', 35.122501373291, 0.613003290500158, -85.3438873291016, -1.48953183034389, 218, 50, 'PPL', 'P'),
(24863, 'Signal Point', 34.0069389343262, 0.593533052928643, -84.6458282470703, -1.477348400989, 218, 13, 'PPL', 'P'),
(185155, 'Signal Port (historical)', 38.8291702270508, 0.67769686627939, -123.614440917969, -2.15747899703056, 218, 6, 'PPL', 'P'),
(179153, 'Signal Village', 31.5499992370605, 0.550651365688406, -110.355560302734, -1.92606787516587, 218, 5, 'PPL', 'P'),
(106262, 'Signboard', 37.8994407653809, 0.661470026020456, -77.4127807617188, -1.35110790741652, 218, 53, 'PPL', 'P'),
(129, 'Signpine', 37.4436111450195, 0.653514298317035, -76.6452789306641, -1.33771247344953, 218, 53, 'PPL', 'P'),
(117789, 'Sigourney', 41.3333282470703, 0.721402668718953, -92.2044372558594, -1.60927101506327, 218, 16, 'PPL', 'P'),
(5848, 'Sigsbee', 34.3413887023926, 0.599370302563934, -85.7099990844727, -1.49592168590537, 218, 2, 'PPL', 'P'),
(24864, 'Sigsbee', 31.2649993896484, 0.545677179983383, -83.8594436645508, -1.46362340083711, 218, 13, 'PPL', 'P'),
(57558, 'Sigsbee', 39.9075012207031, 0.696517292544926, -91.8686065673828, -1.60340966382012, 218, 29, 'PPL', 'P'),
(79130, 'Sigsbee', 39.8277816772461, 0.695125924033414, -79.9563903808594, -1.39550227015592, 218, 45, 'PPL', 'P'),
(83641, 'Sigsbee', 34.9866714477539, 0.610632611076797, -82.0088882446289, -1.43132511576885, 218, 48, 'PPL', 'P'),
(138109, 'Sigsbee', 43.6933288574219, 0.762592449718664, -93.208610534668, -1.62679714503903, 218, 28, 'PPL', 'P'),
(192783, 'Sigurd', 38.8405609130859, 0.677895671254765, -111.966941833496, -1.95419178838348, 218, 52, 'PPL', 'P'),
(24865, 'Sigurd (historical)', 32.1469383239746, 0.561069918188905, -82.9902801513672, -1.44845363579386, 218, 13, 'PPL', 'P'),
(5849, 'Sikes', 32.8886108398438, 0.574014545562371, -85.5586090087891, -1.49327943062985, 218, 2, 'PPL', 'P'),
(43076, 'Sikes', 32.0808296203613, 0.559916103646628, -92.4866714477539, -1.61419693097354, 218, 22, 'PPL', 'P'),
(187353, 'Sikes', 38.2583312988281, 0.667733847483349, -105.074172973633, -1.83389027719993, 218, 7, 'PPL', 'P'),
(57559, 'Sikeston', 36.8766708374023, 0.643619323286845, -89.5877838134766, -1.56360179711005, 218, 29, 'PPL', 'P'),
(5851, 'Sikesville', 33.1263885498047, 0.578164549489041, -85.6747207641602, -1.49530596306135, 218, 2, 'PPL', 'P'),
(167190, 'Siko', 41.6738891601563, 0.727346577955901, -75.2536087036133, -1.31342324588551, 218, 45, 'PPL', 'P'),
(179154, 'Sikort Chuapo', 32.3152809143066, 0.564008050661534, -112.671112060547, -1.96648187734004, 218, 5, 'PPL', 'P'),
(179155, 'Sikul Himatk', 32.1150016784668, 0.560512518572751, -112.035003662109, -1.95537969138771, 218, 5, 'PPL', 'P'),
(179156, 'Sil Murk (historical)', 32.9833297729492, 0.575667702809038, -112.727783203125, -1.96747097536889, 218, 5, 'PPL', 'P'),
(179157, 'Sil Nakya', 32.2216682434082, 0.562374201332771, -111.815826416016, -1.95155432679792, 218, 5, 'PPL', 'P'),
(5852, 'Silas', 31.7652797698975, 0.554408719801857, -88.3291702270508, -1.54163484601658, 218, 2, 'PPL', 'P'),
(98080, 'Silas', 31.8238906860352, 0.55543167326607, -94.3977813720703, -1.6475520915204, 218, 51, 'PPL', 'P'),
(24866, 'Silas (historical)', 33.0013885498047, 0.575982887924049, -82.8000030517578, -1.44513267391453, 218, 13, 'PPL', 'P'),
(24867, 'Silco', 30.8680591583252, 0.538749266013164, -81.8311080932617, -1.4282222667828, 218, 13, 'PPL', 'P'),
(208734, 'Silcott', 46.4152793884277, 0.810099448561124, -117.196670532227, -2.04546777316237, 218, 56, 'PPL', 'P'),
(106263, 'Silcott Spring', 39.1016693115234, 0.682452872512108, -77.7422180175781, -1.35685767221, 218, 53, 'PPL', 'P'),
(189568, 'Sile', 35.5644416809082, 0.620716603965355, -106.372222900391, -1.85654552227713, 218, 38, 'PPL', 'P'),
(11948, 'Silent Grove', 36.2219390869141, 0.632192098523479, -94.1597213745117, -1.64339716074571, 218, 4, 'PPL', 'P'),
(121461, 'Silent Meadow', 42.0116691589355, 0.733241951081982, -88.4236068725586, -1.54328307641523, 218, 18, 'PPL', 'P'),
(38212, 'Siler', 36.6944389343262, 0.640438776575991, -83.9588928222656, -1.46535911607757, 218, 21, 'PPL', 'P'),
(106264, 'Siler', 39.3505592346191, 0.686796821145164, -78.2391662597656, -1.36553105524817, 218, 53, 'PPL', 'P'),
(208735, 'Siler', 46.5097198486328, 0.811747745538801, -121.92749786377, -2.12803628644113, 218, 56, 'PPL', 'P'),
(68799, 'Siler City', 35.723331451416, 0.623489753608454, -79.4625015258789, -1.38688228349761, 218, 33, 'PPL', 'P'),
(90817, 'Silerton', 35.3402786254883, 0.616804220586947, -88.8061065673828, -1.54995895547779, 218, 50, 'PPL', 'P'),
(38214, 'Silerville', 36.6266708374023, 0.63925600015686, -84.4352798461914, -1.47367363815885, 218, 21, 'PPL', 'P'),
(167191, 'Siles', 40.1555595397949, 0.70084672695004, -74.9711074829102, -1.30849266944334, 218, 45, 'PPL', 'P'),
(51422, 'Silesia', 38.7422218322754, 0.676179330511236, -76.9991683959961, -1.34388900980769, 218, 25, 'PPL', 'P'),
(197537, 'Silesia', 45.5566711425781, 0.795113907686275, -108.840827941895, -1.8996308081827, 218, 31, 'PPL', 'P'),
(201564, 'Siletz', 44.7219390869141, 0.780545084942997, -123.918891906738, -2.16279266919554, 218, 43, 'PPL', 'P'),
(11942, 'Silex', 35.500560760498, 0.619601671574993, -93.2149963378906, -1.62690859833065, 218, 4, 'PPL', 'P'),
(31126, 'Silex', 39.3605613708496, 0.686971391354618, -86.6597213745117, -1.51249746684614, 218, 19, 'PPL', 'P'),
(57560, 'Silex', 39.1233291625977, 0.682830908228845, -91.0541687011719, -1.58919504150182, 218, 29, 'PPL', 'P'),
(33969, 'Silica', 38.3516693115234, 0.669362903122151, -98.461669921875, -1.71848032714859, 218, 20, 'PPL', 'P'),
(57561, 'Silica', 38.2347183227539, 0.66732172330466, -90.4258270263672, -1.57822841044898, 218, 29, 'PPL', 'P'),
(90818, 'Silica', 36.3236083984375, 0.633966562757799, -84.2433319091797, -1.47032351466559, 218, 50, 'PPL', 'P'),
(106265, 'Silica', 36.6902809143066, 0.640366205436286, -82.3488922119141, -1.43725930446782, 218, 53, 'PPL', 'P'),
(111393, 'Silica', 38.6872215270996, 0.675219394096317, -80.2402801513672, -1.40045708136401, 218, 58, 'PPL', 'P'),
(138110, 'Silica', 47.264720916748, 0.824925000033486, -93.0205612182617, -1.62351506531161, 218, 28, 'PPL', 'P'),
(157659, 'Silica', 41.6813888549805, 0.727477472323478, -83.7422180175781, -1.46157742732966, 218, 41, 'PPL', 'P'),
(176400, 'Silica', 43.8502807617188, 0.765331777215919, -88.341667175293, -1.54185295890986, 218, 57, 'PPL', 'P'),
(189569, 'Silio', 34.589168548584, 0.603694876700059, -105.933609008789, -1.8488902657237, 218, 38, 'PPL', 'P'),
(24869, 'Silk Hope', 32.042781829834, 0.559252044428816, -81.1919403076172, -1.41706668445062, 218, 13, 'PPL', 'P'),
(68800, 'Silk Hope', 35.7808303833008, 0.624493299286223, -79.3702774047852, -1.38527266893476, 218, 33, 'PPL', 'P'),
(24868, 'Silk Mills', 34.1049995422363, 0.595244533403183, -82.8469390869141, -1.44595186226583, 218, 13, 'PPL', 'P'),
(33970, 'Silkville', 38.4500007629395, 0.671079110707625, -95.4888916015625, -1.66659555752723, 218, 20, 'PPL', 'P'),
(167193, 'Silkworth', 41.2722206115723, 0.720336139281404, -76.086669921875, -1.32796290701486, 218, 45, 'PPL', 'P'),
(90819, 'Sill (historical)', 36.2872200012207, 0.633331465416842, -83.8955612182617, -1.46425377106713, 218, 50, 'PPL', 'P'),
(51423, 'Sillery Bay', 39.0994415283203, 0.682413990360193, -76.461669921875, -1.33450789170983, 218, 25, 'PPL', 'P'),
(51424, 'Sillery Bay Forest', 39.0980606079102, 0.682389888752328, -76.4663925170898, -1.33459031654557, 218, 25, 'PPL', 'P'),
(51425, 'Sillman Estates', 39.0269393920898, 0.681148589368242, -76.4972229003906, -1.33512840824382, 218, 25, 'PPL', 'P'),
(11943, 'Sills', 35.2777786254883, 0.61571338980445, -93.2769393920898, -1.62798970857517, 218, 4, 'PPL', 'P'),
(18082, 'Sills', 30.9449996948242, 0.540092131703323, -85.283332824707, -1.48847495486529, 218, 12, 'PPL', 'P'),
(187354, 'Sillsville', 38.4466705322266, 0.671020987216834, -106.760559082031, -1.86332326725138, 218, 7, 'PPL', 'P'),
(77253, 'Silo', 34.041389465332, 0.594134328123756, -96.4738922119141, -1.68378706131202, 218, 42, 'PPL', 'P'),
(157660, 'Silo', 41.3088912963867, 0.720976163470377, -81.2813873291016, -1.41862782948162, 218, 41, 'PPL', 'P'),
(5853, 'Siloam', 32.422779083252, 0.565884247649495, -88.2675018310547, -1.54055852946203, 218, 2, 'PPL', 'P'),
(24870, 'Siloam', 33.5366706848145, 0.585325323607074, -83.0811080932617, -1.45003888243273, 218, 13, 'PPL', 'P'),
(28614, 'Siloam', 39.8880615234375, 0.69617800582205, -90.9158325195313, -1.58678061965755, 218, 18, 'PPL', 'P'),
(38213, 'Siloam', 38.735279083252, 0.676058156681637, -82.8947219848633, -1.44678583116119, 218, 21, 'PPL', 'P'),
(51427, 'Siloam', 38.3277816772461, 0.668945985253499, -75.6833267211914, -1.32092324014739, 218, 25, 'PPL', 'P'),
(68801, 'Siloam', 36.285831451416, 0.633307230650922, -80.5627822875977, -1.40608580548595, 218, 33, 'PPL', 'P'),
(90820, 'Siloam', 36.5461082458496, 0.637849917680325, -86.2127838134766, -1.50469693485524, 218, 50, 'PPL', 'P'),
(98083, 'Siloam', 30.4258308410645, 0.53103092583141, -97.2838897705078, -1.69792418564259, 218, 51, 'PPL', 'P'),
(106266, 'Siloam', 36.9105606079102, 0.644210811364952, -80.9663925170898, -1.41313013288532, 218, 53, 'PPL', 'P'),
(112444, 'Siloam', 33.6366691589355, 0.587070626227457, -88.7574996948242, -1.54911060551254, 218, 30, 'PPL', 'P'),
(146309, 'Siloam', 40.1861114501953, 0.701379958379301, -74.3483276367188, -1.29762311061224, 218, 37, 'PPL', 'P'),
(152576, 'Siloam', 42.9847183227539, 0.75022486277439, -75.6416702270508, -1.3201961971698, 218, 40, 'PPL', 'P'),
(187355, 'Siloam', 38.2513885498047, 0.667612673653751, -104.975280761719, -1.83216428249745, 218, 7, 'PPL', 'P'),
(74300, 'Siloam (historical)', 38.8055610656738, 0.677284808679728, -82.3727798461914, -1.43767622233647, 218, 41, 'PPL', 'P'),
(11944, 'Siloam Springs', 36.188060760498, 0.631600810182454, -94.540283203125, -1.65003921766242, 218, 4, 'PPL', 'P'),
(43075, 'Siloam Springs', 32.1627807617188, 0.561346420889082, -92.6722183227539, -1.61743533485907, 218, 22, 'PPL', 'P'),
(139455, 'Siloam Springs', 40.3730583190918, 0.704642796767839, -94.2638931274414, -1.64521530082191, 218, 29, 'PPL', 'P'),
(185156, 'Silongkoyo (historical)', 39.9366683959961, 0.697026355787294, -120.944442749023, -2.11087873796024, 218, 6, 'PPL', 'P'),
(98084, 'Silsbee', 30.3488903045654, 0.529688060141251, -94.1777801513672, -1.64371234586072, 218, 51, 'PPL', 'P'),
(205740, 'Silsbee', 40.735279083252, 0.710964741721524, -113.926940917969, -1.98840022574361, 218, 52, 'PPL', 'P'),
(185157, 'Silt', 34.9997215270996, 0.610860377929026, -117.748611450195, -2.0551009594574, 218, 6, 'PPL', 'P'),
(187356, 'Silt', 39.5486106872559, 0.690253471082032, -107.655563354492, -1.87894403862524, 218, 7, 'PPL', 'P'),
(11946, 'Silt (historical)', 34.0675010681152, 0.594590061565296, -91.6741714477539, -1.60001613080108, 218, 4, 'PPL', 'P'),
(201565, 'Siltcoos', 43.8891716003418, 0.766010550398753, -124.0625, -2.16529910325547, 218, 43, 'PPL', 'P'),
(5854, 'Siluria', 33.2291717529297, 0.579958454799319, -86.8249969482422, -1.51538206978085, 218, 2, 'PPL', 'P'),
(57564, 'Silva', 37.1761093139648, 0.648845510610017, -90.4636077880859, -1.57888780913488, 218, 29, 'PPL', 'P'),
(140883, 'Silva', 48.1688919067383, 0.840705760809832, -99.9180603027344, -1.74389913448896, 218, 34, 'PPL', 'P'),
(51428, 'Silva-De-Amor', 39.1463890075684, 0.683233378448583, -76.7333297729492, -1.33924925055656, 218, 25, 'PPL', 'P'),
(90822, 'Silvacola', 36.5727806091309, 0.638315438238871, -82.3822174072266, -1.43784093884989, 218, 50, 'PPL', 'P'),
(208736, 'Silvana', 48.2024993896484, 0.841292322039922, -122.252502441406, -2.13370868640495, 218, 56, 'PPL', 'P'),
(208737, 'Silvana Terraces', 48.2027816772461, 0.841297248887939, -122.282218933105, -2.13422733702724, 218, 56, 'PPL', 'P'),
(167192, 'Silvara', 41.6986083984375, 0.727778010052494, -76.1347198486328, -1.32880153644212, 218, 45, 'PPL', 'P'),
(185158, 'Silvas Grove (historical)', 38.6002807617188, 0.673701991486217, -121.543327331543, -2.12133124576464, 218, 6, 'PPL', 'P'),
(11947, 'Silver', 34.5347213745117, 0.602744594244091, -93.5100021362305, -1.63205742082415, 218, 4, 'PPL', 'P'),
(83642, 'Silver', 33.6777801513672, 0.587788148404152, -80.3574981689453, -1.40250292171341, 218, 48, 'PPL', 'P'),
(192216, 'Silver', 32.0708312988281, 0.5597416000162, -100.682220458984, -1.75723624522807, 218, 51, 'PPL', 'P'),
(51429, 'Silver Acres', 39.5927810668945, 0.691024389638583, -76.1469421386719, -1.32901485564544, 218, 25, 'PPL', 'P'),
(189570, 'Silver Acres', 32.7299995422363, 0.571246256188261, -108.263061523438, -1.88954688187317, 218, 38, 'PPL', 'P'),
(205742, 'Silver Acres', 40.6083297729492, 0.708749058273605, -111.883331298828, -1.95273250926417, 218, 52, 'PPL', 'P'),
(138111, 'Silver Bay', 47.2944412231445, 0.825443717234806, -91.2572174072266, -1.59273890996439, 218, 28, 'PPL', 'P'),
(146310, 'Silver Bay', 40.0033302307129, 0.698189824288523, -74.1233291625977, -1.29369614642686, 218, 37, 'PPL', 'P'),
(152577, 'Silver Bay', 43.6963882446289, 0.76264584609852, -73.5061111450195, -1.28292365981749, 218, 40, 'PPL', 'P'),
(71393, 'Silver Beach', 39.9958305358887, 0.698058929920945, -74.0625, -1.2926344772583, 218, 37, 'PPL', 'P'),
(106267, 'Silver Beach', 37.485279083252, 0.654241541031708, -75.9608306884766, -1.32576659806387, 218, 53, 'PPL', 'P'),
(114063, 'Silver Beach', 41.2016716003418, 0.719104826751406, -73.0647201538086, -1.27521993373222, 218, 8, 'PPL', 'P'),
(126102, 'Silver Beach', 41.6402816772461, 0.726760016725811, -70.6374969482422, -1.23285689711427, 218, 23, 'PPL', 'P'),
(133121, 'Silver Beach', 45.5486106872559, 0.794973226201692, -84.5322189331055, -1.47536554439938, 218, 27, 'PPL', 'P'),
(152578, 'Silver Beach', 41.0502815246582, 0.716462571475883, -72.3566665649414, -1.26286206732592, 218, 40, 'PPL', 'P'),
(195611, 'Silver Beach', 47.9483299255371, 0.83685622803315, -116.89111328125, -2.04013479307948, 218, 17, 'PPL', 'P'),
(208740, 'Silver Beach', 48.7669410705566, 0.851143687807262, -122.413330078125, -2.13651565819389, 218, 56, 'PPL', 'P'),
(18080, 'Silver Beach Heights', 28.9505596160889, 0.505282585595656, -81.6588897705078, -1.42521649001848, 218, 12, 'PPL', 'P'),
(179159, 'Silver Bell', 32.3833312988281, 0.565195753928682, -111.5, -1.94604211597368, 218, 5, 'PPL', 'P'),
(205741, 'Silver Bell Estates', 41.3011093139648, 0.720840342254783, -111.856109619141, -1.9522574013257, 218, 52, 'PPL', 'P'),
(179158, 'Silver Bell Trailer Park', 33.5041694641113, 0.584758070294887, -112.0625, -1.95585959301615, 218, 5, 'PPL', 'P'),
(68803, 'Silver Bluff', 35.4761085510254, 0.619174900010308, -82.879997253418, -1.446528836116, 218, 33, 'PPL', 'P'),
(18081, 'Silver Bluff Estates', 25.7486095428467, 0.449398014333107, -80.2363891601563, -1.40038917075621, 218, 12, 'PPL', 'P'),
(83643, 'Silver Bluff Estates', 33.5208282470703, 0.585048820906896, -81.7319412231445, -1.42649147839035, 218, 48, 'PPL', 'P'),
(197538, 'Silver Bow', 46.0036087036133, 0.802914439677172, -112.666938781738, -1.96640903988422, 218, 31, 'PPL', 'P'),
(197539, 'Silver Bow (historical)', 48.8730583190918, 0.852995783187357, -108.718063354492, -1.89748816192768, 218, 31, 'PPL', 'P'),
(197541, 'Silver Bow Park', 46.000560760498, 0.802861243034398, -112.496391296387, -1.96343242473384, 218, 31, 'PPL', 'P'),
(14619, 'Silver Brook', 39.6563911437988, 0.69213459491801, -75.7541732788086, -1.32215974584152, 218, 10, 'PPL', 'P'),
(208739, 'Silver Brook', 46.538330078125, 0.812247088243191, -121.906936645508, -2.12767742548424, 218, 56, 'PPL', 'P'),
(24871, 'Silver City', 34.334171295166, 0.599244335044373, -84.1161117553711, -1.46810310410673, 218, 13, 'PPL', 'P'),
(38215, 'Silver City', 37.1377792358398, 0.648176524544189, -86.831672668457, -1.51549858307855, 218, 21, 'PPL', 'P'),
(61779, 'Silver City', 33.0963897705078, 0.577640972018732, -90.4966735839844, -1.5794649161431, 218, 30, 'PPL', 'P'),
(68804, 'Silver City', 34.9958305358887, 0.610792467321229, -79.2263870239258, -1.38276130802682, 218, 33, 'PPL', 'P'),
(77254, 'Silver City', 36.0902786254883, 0.629894189976904, -96.4941711425781, -1.68414099542089, 218, 42, 'PPL', 'P'),
(90821, 'Silver City', 36.2208290100098, 0.632172724026549, -83.1647186279297, -1.45149816155203, 218, 50, 'PPL', 'P'),
(98088, 'Silver City', 33.8527793884277, 0.590842461279336, -95.059440612793, -1.65910022379725, 218, 51, 'PPL', 'P'),
(117791, 'Silver City', 41.1133308410645, 0.717562989638304, -95.6369400024414, -1.66917948957488, 218, 16, 'PPL', 'P'),
(133122, 'Silver City', 46.8302803039551, 0.817342580935867, -89.5702819824219, -1.56329633253302, 218, 27, 'PPL', 'P'),
(185159, 'Silver City', 36.4661102294922, 0.636453688899824, -118.644996643066, -2.07074583243913, 218, 6, 'PPL', 'P'),
(189571, 'Silver City', 32.7700004577637, 0.571944403868025, -108.279716491699, -1.88983756590615, 218, 38, 'PPL', 'P'),
(190730, 'Silver City', 39.2636108398438, 0.685279285377009, -119.639442443848, -2.08810218589539, 218, 39, 'PPL', 'P'),
(192784, 'Silver City', 39.9099998474121, 0.696560901807776, -112.129173278809, -1.95702326125446, 218, 52, 'PPL', 'P'),
(195610, 'Silver City', 43.0169410705566, 0.750787255817588, -116.732223510742, -2.03736164343639, 218, 17, 'PPL', 'P'),
(197542, 'Silver City', 46.7555618286133, 0.816038497529082, -112.168891906738, -1.9577164820862, 218, 31, 'PPL', 'P'),
(202615, 'Silver City', 44.0844383239746, 0.769418597645728, -103.563331604004, -1.80752112082457, 218, 49, 'PPL', 'P'),
(190731, 'Silver City (historical)', 36.5299987792969, 0.63756875444824, -114.553329467773, -1.99933276833449, 218, 39, 'PPL', 'P'),
(187357, 'Silver Cliff', 38.1352806091309, 0.665586207801282, -105.445831298828, -1.84037693866704, 218, 7, 'PPL', 'P'),
(24872, 'Silver Creek', 34.1761093139648, 0.596485633050187, -85.1613922119141, -1.48634668968016, 218, 13, 'PPL', 'P'),
(38216, 'Silver Creek', 37.6572189331055, 0.657242457527037, -84.3661117553711, -1.47246642723672, 218, 21, 'PPL', 'P'),
(57565, 'Silver Creek', 37.0405616760254, 0.646479758034672, -94.4725036621094, -1.64885624150621, 218, 29, 'PPL', 'P'),
(61778, 'Silver Creek', 31.6049995422363, 0.551611302103325, -89.9983291625977, -1.57076716518096, 218, 30, 'PPL', 'P'),
(90823, 'Silver Creek', 35.5019416809082, 0.619625773182858, -86.8747177124023, -1.51624986082206, 218, 50, 'PPL', 'P'),
(138115, 'Silver Creek', 45.314998626709, 0.790895926572781, -93.9794387817383, -1.64025063591778, 218, 28, 'PPL', 'P'),
(143018, 'Silver Creek', 41.3088912963867, 0.720976163470377, -97.6575012207031, -1.70444493557165, 218, 35, 'PPL', 'P'),
(152579, 'Silver Creek', 42.5441703796387, 0.742535850654141, -79.1669387817383, -1.38172374046612, 218, 40, 'PPL', 'P'),
(157661, 'Silver Creek', 40.5763893127441, 0.708191592078424, -83.6783294677734, -1.46046236178124, 218, 41, 'PPL', 'P'),
(167194, 'Silver Creek', 40.732780456543, 0.710921132458674, -76.1336135864258, -1.32878222852422, 218, 45, 'PPL', 'P'),
(176402, 'Silver Creek', 43.5569381713867, 0.760211983178296, -88.0250015258789, -1.53632610069962, 218, 57, 'PPL', 'P'),
(179160, 'Silver Creek', 34.3400001525879, 0.599346067798014, -109.948890686035, -1.91897015138664, 218, 5, 'PPL', 'P'),
(208741, 'Silver Creek', 46.5255584716797, 0.812024181659951, -122.589172363281, -2.1395846850341, 218, 56, 'PPL', 'P'),
(185160, 'Silver Creek (historical)', 39.9444389343262, 0.697161977265807, -121.070556640625, -2.11307984060119, 218, 6, 'PPL', 'P'),
(61782, 'Silver Creek Acres', 30.4208297729492, 0.530943640726683, -89.4013900756836, -1.56034861268046, 218, 30, 'PPL', 'P'),
(205743, 'Silver Creek Junction', 40.7313919067383, 0.710896897692754, -111.497222900391, -1.94599364644184, 218, 52, 'PPL', 'P'),
(117792, 'Silver Creek Mobile Home Community', 41.5722198486328, 0.725572113721581, -90.6222229003906, -1.58165616508802, 218, 16, 'PPL', 'P'),
(98089, 'Silver Creek Village', 30.8553791046143, 0.538527957326579, -98.3947525024414, -1.71731239785253, 218, 51, 'PPL', 'P'),
(112399, 'Silver Crest', 39.2652816772461, 0.685308446990946, -77.1711120605469, -1.34688999288205, 218, 25, 'PPL', 'P'),
(5855, 'Silver Cross', 31.6808300018311, 0.552934793296553, -88.1741714477539, -1.53892960698128, 218, 2, 'PPL', 'P'),
(57567, 'Silver Dollar City', 36.667781829834, 0.639973522333554, -93.3394393920898, -1.62908053935766, 218, 29, 'PPL', 'P'),
(185161, 'Silver Dons Mobile Home Park', 33.2363891601563, 0.580084422318879, -116.365562438965, -2.03096220049498, 218, 6, 'PPL', 'P'),
(114064, 'Silver Falls', 41.4124984741211, 0.722784449850541, -72.2205581665039, -1.26048652763357, 218, 8, 'PPL', 'P'),
(51431, 'Silver Fern Estates', 39.3994407653809, 0.687649964800371, -77.1761093139648, -1.34697721140775, 218, 25, 'PPL', 'P'),
(167195, 'Silver Ford Heights', 40.3772201538086, 0.704715434486571, -77.8486099243164, -1.35871456128005, 218, 45, 'PPL', 'P'),
(205744, 'Silver Fork', 40.6300010681152, 0.709127293727424, -111.609718322754, -1.9479570619555, 218, 52, 'PPL', 'P'),
(197543, 'Silver Gate', 45.0069389343262, 0.78551927064802, -109.988891601563, -1.9196682990664, 218, 31, 'PPL', 'P'),
(51432, 'Silver Gate Village', 39.3936080932617, 0.687548165467702, -76.458610534668, -1.33445449532998, 218, 25, 'PPL', 'P'),
(121463, 'Silver Glen Meadows', 41.9730606079102, 0.732568104747165, -88.4258270263672, -1.54332182540909, 218, 18, 'PPL', 'P'),
(38217, 'Silver Grove', 39.0344390869141, 0.681279483735819, -84.3902816772461, -1.47288827195339, 218, 21, 'PPL', 'P'),
(90824, 'Silver Grove', 36.4961090087891, 0.636977266370133, -82.2074966430664, -1.43479148624369, 218, 50, 'PPL', 'P'),
(111394, 'Silver Grove', 39.2994384765625, 0.68590459560096, -77.7519378662109, -1.35702731557144, 218, 58, 'PPL', 'P'),
(187358, 'Silver Heights', 39.4180603027344, 0.687974937032388, -104.865280151367, -1.83024440966762, 218, 7, 'PPL', 'P'),
(11949, 'Silver Hill', 35.9705581665039, 0.627804673785628, -92.7458267211914, -1.61872004376893, 218, 4, 'PPL', 'P'),
(24874, 'Silver Hill', 34.401668548584, 0.600422384352569, -85.3072204589844, -1.48889187273395, 218, 13, 'PPL', 'P'),
(51434, 'Silver Hill', 38.8416709899902, 0.677915045751695, -76.9461135864258, -1.34296302869667, 218, 25, 'PPL', 'P'),
(68808, 'Silver Hill', 34.8894386291504, 0.608935578251171, -79.48388671875, -1.38725552552438, 218, 33, 'PPL', 'P'),
(90825, 'Silver Hill', 36.0013885498047, 0.628342765483878, -86.3672180175781, -1.50739232019451, 218, 50, 'PPL', 'P'),
(106269, 'Silver Hill', 38.482780456543, 0.671651224288801, -77.6963882446289, -1.35605779177659, 218, 53, 'PPL', 'P'),
(126106, 'Silver Hill', 42.3958282470703, 0.739946792021393, -71.3027801513672, -1.24446827946702, 218, 23, 'PPL', 'P'),
(51435, 'Silver Hill Farm', 39.3838882446289, 0.687378522106264, -76.4880599975586, -1.33496848542036, 218, 25, 'PPL', 'P'),
(51436, 'Silver Hill Park', 38.836669921875, 0.677827760646968, -76.9488906860352, -1.34301149822851, 218, 25, 'PPL', 'P'),
(31128, 'Silver Hills', 38.2825012207031, 0.668155692200018, -85.8452835083008, -1.49828284452784, 218, 19, 'PPL', 'P'),
(51437, 'Silver Hills', 39.6783294677734, 0.692517490903736, -77.0361099243164, -1.3445337611076, 218, 25, 'PPL', 'P'),
(98090, 'Silver Hills', 29.7796401977539, 0.519752771510061, -98.6006469726563, -1.72090593426943, 218, 51, 'PPL', 'P'),
(169603, 'Silver Hook', 41.7613906860352, 0.728873767683007, -71.418327331543, -1.24648495820248, 218, 47, 'PPL', 'P'),
(197544, 'Silver King (historical)', 47.0977783203125, 0.822011302063858, -112.480560302734, -1.96315612177074, 218, 31, 'PPL', 'P'),
(18083, 'Silver Lake', 28.8416690826416, 0.503382087262748, -81.7986068725586, -1.42765501347061, 218, 12, 'PPL', 'P'),
(24876, 'Silver Lake', 33.5061111450195, 0.584791959019758, -83.7508316040039, -1.46172776277319, 218, 13, 'PPL', 'P'),
(33972, 'Silver Lake', 39.1041717529297, 0.682496548353986, -95.8583297729492, -1.67304347000047, 218, 20, 'PPL', 'P'),
(57568, 'Silver Lake', 37.6836090087891, 0.657703051237566, -89.9899978637695, -1.57062175658544, 218, 29, 'PPL', 'P'),
(68810, 'Silver Lake', 34.148609161377, 0.596005664842727, -77.9138870239258, -1.35985386159439, 218, 33, 'PPL', 'P'),
(83645, 'Silver Lake', 33.8819389343262, 0.59135139136365, -81.0458297729492, -1.41451657454881, 218, 48, 'PPL', 'P'),
(90826, 'Silver Lake', 36.538330078125, 0.637714163043758, -81.7758331298828, -1.42725753667791, 218, 50, 'PPL', 'P'),
(98091, 'Silver Lake', 32.6697196960449, 0.570194174399625, -95.5955581665039, -1.66845724028725, 218, 51, 'PPL', 'P'),
(111395, 'Silver Lake', 39.2541694641113, 0.685114502284561, -79.4980621337891, -1.38750293318965, 218, 58, 'PPL', 'P'),
(117796, 'Silver Lake', 43.4808311462402, 0.758883665005592, -93.3663864135742, -1.62955085360617, 218, 16, 'PPL', 'P'),
(121465, 'Silver Lake', 42.2350006103516, 0.737139820232449, -88.2447204589844, -1.54016091951128, 218, 18, 'PPL', 'P'),
(123670, 'Silver Lake', 41.0722198486328, 0.71684546746161, -85.8916702270508, -1.49909244549922, 218, 19, 'PPL', 'P'),
(126104, 'Silver Lake', 42.0041694641113, 0.733111056714405, -70.7936096191406, -1.23558157722553, 218, 23, 'PPL', 'P'),
(138118, 'Silver Lake', 44.9033317565918, 0.783710984267856, -94.1952819824219, -1.64401781043775, 218, 28, 'PPL', 'P'),
(144449, 'Silver Lake', 43.8880615234375, 0.765991175901823, -71.1758270263672, -1.24225252944007, 218, 36, 'PPL', 'P'),
(152581, 'Silver Lake', 42.7016716003418, 0.745284765531321, -78.022216796875, -1.36174457281029, 218, 40, 'PPL', 'P'),
(157662, 'Silver Lake', 41.1588897705078, 0.718358142960775, -81.4544372558594, -1.42164812047388, 218, 41, 'PPL', 'P'),
(176404, 'Silver Lake', 44.0552787780762, 0.768909667561413, -89.2261123657227, -1.55728943953629, 218, 57, 'PPL', 'P'),
(208743, 'Silver Lake', 47.5530586242676, 0.829957442387354, -117.648063659668, -2.0533460694571, 218, 56, 'PPL', 'P'),
(209899, 'Silver Lake', 43.128059387207, 0.752726636302411, -121.044998168945, -2.1126337611186, 218, 43, 'PPL', 'P'),
(61780, 'Silver Lake (historical)', 33.1977806091309, 0.579410575984062, -91.0611114501953, -1.58931621533142, 218, 30, 'PPL', 'P'),
(121466, 'Silver Lake (historical)', 40.7638893127441, 0.711464084425914, -91.0641708374023, -1.58936961171127, 218, 18, 'PPL', 'P'),
(197545, 'Silver Lake (historical)', 46.1713905334473, 0.805842785032796, -113.234169006348, -1.97630907492048, 218, 31, 'PPL', 'P'),
(205745, 'Silver Lake Estates', 40.6027793884277, 0.708652185788954, -111.58332824707, -1.94749646824497, 218, 52, 'PPL', 'P'),
(152582, 'Silver Lake Junction', 42.6722183227539, 0.744770708861908, -78.0936126708984, -1.36299066588434, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(51438, 'Silver Lake Mobile Home Park', 38.3358306884766, 0.669086467001001, -75.1388931274414, -1.31142108137799, 218, 25, 'PPL', 'P'),
(205746, 'Silver Lake Summer Home Area', 40.4986114501953, 0.706834112291784, -111.648612976074, -1.94863590171736, 218, 52, 'PPL', 'P'),
(205747, 'Silver Lake Summer Resort', 40.6041717529297, 0.708676487133901, -111.580558776855, -1.94744813187118, 218, 52, 'PPL', 'P'),
(5856, 'Silver Landing', 31.232780456543, 0.545114853519213, -87.8477783203125, -1.53323297225155, 218, 2, 'PPL', 'P'),
(83646, 'Silver Leaf', 34.8944396972656, 0.609022863355899, -82.2822189331055, -1.43609563622951, 218, 48, 'PPL', 'P'),
(51439, 'Silver Manor', 39.3055610656738, 0.6860114549397, -76.4611129760742, -1.33449817117186, 218, 25, 'PPL', 'P'),
(51440, 'Silver Maple Estates', 39.3313903808594, 0.686462261533223, -77.2483291625977, -1.34823768555168, 218, 25, 'PPL', 'P'),
(24877, 'Silver Maple Ridge', 33.4991683959961, 0.584670785190159, -82.1622161865234, -1.43400119319021, 218, 13, 'PPL', 'P'),
(51441, 'Silver Meadow', 39.3891716003418, 0.687470734059008, -76.4863891601563, -1.33493932380643, 218, 25, 'PPL', 'P'),
(5857, 'Silver Meadows', 31.2083301544189, 0.544688115244041, -85.4361114501953, -1.49114144490674, 218, 2, 'PPL', 'P'),
(79131, 'Silver Mills', 39.7563896179199, 0.693879897538393, -78.3641662597656, -1.36771271681316, 218, 45, 'PPL', 'P'),
(185163, 'Silver Mountain (historical)', 38.605281829834, 0.673789276590944, -119.768333435059, -2.09035175806818, 218, 6, 'PPL', 'P'),
(18084, 'Silver Palm', 25.5505599975586, 0.445941397685752, -80.4413909912109, -1.40396712768074, 218, 12, 'PPL', 'P'),
(190735, 'Silver Peak', 37.7550010681152, 0.658949077732587, -117.633888244629, -2.05309866179183, 218, 39, 'PPL', 'P'),
(187359, 'Silver Plume', 39.6961097717285, 0.692827815749757, -105.725280761719, -1.84525425188741, 218, 7, 'PPL', 'P'),
(980, 'Silver Point', 36.0905609130859, 0.629899116824921, -85.7297210693359, -1.49626589947627, 218, 50, 'PPL', 'P'),
(123671, 'Silver Point', 41.3313903808594, 0.721368846573109, -85.7688903808594, -1.49694953292809, 218, 19, 'PPL', 'P'),
(138122, 'Silver Rapids', 47.9038887023926, 0.836080582365665, -91.7552795410156, -1.60143173407851, 218, 28, 'PPL', 'P'),
(192785, 'Silver Reef', 37.2527809143066, 0.650183682478754, -113.366943359375, -1.97862642454302, 218, 52, 'PPL', 'P'),
(24879, 'Silver Ridge', 33.832218170166, 0.590483600322448, -84.1622161865234, -1.4689077782301, 218, 13, 'PPL', 'P'),
(71394, 'Silver Ridge', 39.959171295166, 0.697419105469054, -74.2188873291016, -1.29536395105952, 218, 37, 'PPL', 'P'),
(90827, 'Silver Ridge', 35.7963905334473, 0.624764875138384, -84.283332824707, -1.47102166234535, 218, 50, 'PPL', 'P'),
(128816, 'Silver Ridge', 45.8063888549805, 0.799472303968245, -68.3252792358398, -1.19250108500992, 218, 26, 'PPL', 'P'),
(71395, 'Silver Ridge Park', 39.961109161377, 0.697452927614898, -74.2388916015625, -1.29571309147843, 218, 37, 'PPL', 'P'),
(51442, 'Silver Rock', 39.0811080932617, 0.68209401155522, -77.1277770996094, -1.34613365513247, 218, 25, 'PPL', 'P'),
(5858, 'Silver Run', 33.564998626709, 0.585819739463447, -85.9080581665039, -1.4993784690003, 218, 2, 'PPL', 'P'),
(51466, 'Silver Run', 38.3369407653809, 0.669105841497931, -75.6516723632813, -1.32037076737926, 218, 25, 'PPL', 'P'),
(61781, 'Silver Run', 30.7333297729492, 0.536397794639165, -89.3455581665039, -1.5593741620376, 218, 30, 'PPL', 'P'),
(74305, 'Silver Run', 38.976390838623, 0.680266350678126, -82.0911102294922, -1.43276016012224, 218, 41, 'PPL', 'P'),
(51444, 'Silver Run Estates', 39.646110534668, 0.691955164439566, -77.091667175293, -1.3455034180605, 218, 25, 'PPL', 'P'),
(51445, 'Silver Sands', 39.148609161377, 0.683272127442444, -76.5547180175781, -1.33613188734256, 218, 25, 'PPL', 'P'),
(195612, 'Silver Sands Beach', 47.892219543457, 0.835876917121301, -116.883613586426, -2.04000389871191, 218, 17, 'PPL', 'P'),
(205752, 'Silver Shadow Estates', 40.5611114501953, 0.70792494307428, -111.869171142578, -1.95248536791502, 218, 52, 'PPL', 'P'),
(126105, 'Silver Shell Beach', 41.6083297729492, 0.726202350793549, -70.8652801513672, -1.23683246398954, 218, 23, 'PPL', 'P'),
(18085, 'Silver Shores', 26.1894397735596, 0.457091953301373, -80.1011123657227, -1.3980281452918, 218, 12, 'PPL', 'P'),
(51446, 'Silver Spring', 38.9905586242676, 0.68051362518534, -77.0263900756836, -1.34436411774616, 218, 25, 'PPL', 'P'),
(167201, 'Silver Spring', 40.0641708374023, 0.699251693194165, -76.4375, -1.33408604699317, 218, 45, 'PPL', 'P'),
(169602, 'Silver Spring', 41.7891693115234, 0.729358596159456, -71.3680572509766, -1.24560757978135, 218, 47, 'PPL', 'P'),
(51447, 'Silver Spring Heights', 39.521671295166, 0.689783289991579, -76.3563919067383, -1.33267044371573, 218, 25, 'PPL', 'P'),
(51448, 'Silver Spring Park', 38.9933280944824, 0.680561961559125, -77.0199966430664, -1.34425253129649, 218, 25, 'PPL', 'P'),
(51449, 'Silver Spring Station', 39.3936080932617, 0.687548165467702, -76.4800033569336, -1.33482787051481, 218, 25, 'PPL', 'P'),
(14623, 'Silver Springs', 39.7541694641113, 0.693841148544532, -75.5922164916992, -1.31933306666051, 218, 10, 'PPL', 'P'),
(18087, 'Silver Springs', 30.8063907623291, 0.537672949458609, -86.5524978637695, -1.51062606354814, 218, 12, 'PPL', 'P'),
(57569, 'Silver Springs', 37.9991683959961, 0.663210601529904, -90.5244369506836, -1.57994947830344, 218, 29, 'PPL', 'P'),
(61783, 'Silver Springs', 34.7802810668945, 0.607030419386356, -88.7805633544922, -1.54951314231131, 218, 30, 'PPL', 'P'),
(68812, 'Silver Springs', 35.0961112976074, 0.612542696789629, -79.4713897705078, -1.3870374126311, 218, 33, 'PPL', 'P'),
(74302, 'Silver Springs', 39.6341705322266, 0.691746772084267, -83.870002746582, -1.46380769158454, 218, 41, 'PPL', 'P'),
(90828, 'Silver Springs', 36.1947212219238, 0.631717057164036, -86.4533309936523, -1.50889527515569, 218, 50, 'PPL', 'P'),
(106272, 'Silver Springs', 38.7838897705078, 0.676906573225909, -77.1294403076172, -1.34616268358835, 218, 53, 'PPL', 'P'),
(146311, 'Silver Springs', 40.9155616760254, 0.714111266549453, -74.6538925170898, -1.30295622385317, 218, 37, 'PPL', 'P'),
(152583, 'Silver Springs', 42.6605606079102, 0.744567243354626, -78.0858306884766, -1.36285484466875, 218, 40, 'PPL', 'P'),
(189572, 'Silver Springs', 33.0972213745117, 0.577655486246673, -105.620277404785, -1.84342159758327, 218, 38, 'PPL', 'P'),
(190738, 'Silver Springs', 39.4155616760254, 0.687931327769538, -119.223609924316, -2.08084453929271, 218, 39, 'PPL', 'P'),
(194420, 'Silver Springs', 40.0155601501465, 0.698403276649893, -105.453887939453, -1.8405175535726, 218, 7, 'PPL', 'P'),
(205755, 'Silver Springs', 40.7055587768555, 0.710446024520204, -111.544441223145, -1.94681776164116, 218, 52, 'PPL', 'P'),
(11952, 'Silver Springs (historical)', 36.2841682434082, 0.633278202195041, -94.0563888549805, -1.64159366805551, 218, 4, 'PPL', 'P'),
(18088, 'Silver Springs Shores', 29.1041698455811, 0.507963589865039, -82.0208282470703, -1.43153350812415, 218, 12, 'PPL', 'P'),
(194421, 'Silver Spruce', 40.0047187805176, 0.698214059054443, -105.347221374512, -1.83865587081258, 218, 7, 'PPL', 'P'),
(98094, 'Silver Spur Estates Colonia', 27.9950008392334, 0.488604938743199, -97.9329986572266, -1.70925327291979, 218, 51, 'PPL', 'P'),
(179161, 'Silver Spur Ranch', 33.4166717529297, 0.583230947146808, -111.629173278809, -1.94829661499448, 218, 5, 'PPL', 'P'),
(179162, 'Silver Spur Village', 33.4199981689453, 0.583289004058572, -111.627220153809, -1.94826252653253, 218, 5, 'PPL', 'P'),
(195613, 'Silver Star', 42.0819396972656, 0.734468403342991, -111.954170227051, -1.95396888180024, 218, 17, 'PPL', 'P'),
(197546, 'Silver Star', 45.6902809143066, 0.797445838115776, -112.282218933105, -1.95969441182781, 218, 31, 'PPL', 'P'),
(192912, 'Silver Strand', 34.1527786254883, 0.596078435719514, -119.217498779297, -2.08073787969105, 218, 6, 'PPL', 'P'),
(209736, 'Silver Tip', 41.9147186279297, 0.731549845104373, -104.26611328125, -1.8197869750152, 218, 59, 'PPL', 'P'),
(68813, 'Silver Valley', 35.7324981689453, 0.623649743010941, -80.1033325195313, -1.39806689428567, 218, 33, 'PPL', 'P'),
(98092, 'Silver Valley', 31.9563903808594, 0.557744229198641, -99.5458297729492, -1.73740248616776, 218, 51, 'PPL', 'P'),
(171298, 'Silver Valley Addition', 43.5336112976074, 0.759804852426651, -96.8072204589844, -1.68960473671329, 218, 49, 'PPL', 'P'),
(14624, 'Silver View Farm', 38.7033309936523, 0.675500557328402, -75.1138916015625, -1.31098472243338, 218, 10, 'PPL', 'P'),
(51450, 'Silver Woods', 39.3849983215332, 0.687397896603195, -76.4486083984375, -1.33427992512052, 218, 25, 'PPL', 'P'),
(200209, 'Silver Zone', 40.920280456543, 0.714193624806163, -114.352500915527, -1.99582764886578, 218, 39, 'PPL', 'P'),
(185166, 'Silverado', 33.7461090087891, 0.588980711940289, -117.636108398438, -2.05313741078569, 218, 6, 'PPL', 'P'),
(98093, 'Silverado Colonia', 26.2369995117188, 0.457922027323637, -98.4059982299805, -1.71750867282487, 218, 51, 'PPL', 'P'),
(179165, 'Silverbell', 32.4305610656738, 0.566020068865089, -111.537498474121, -1.94669658781156, 218, 5, 'PPL', 'P'),
(190740, 'Silverbow', 37.8880615234375, 0.661271420782163, -116.491111755371, -2.0331534494399, 218, 39, 'PPL', 'P'),
(14625, 'Silverbrook', 39.7544403076172, 0.693845875655467, -75.5983276367188, -1.31943972626217, 218, 10, 'PPL', 'P'),
(51451, 'Silverbrook Farm', 39.4047203063965, 0.687742110174087, -76.8069381713867, -1.34053395946641, 218, 25, 'PPL', 'P'),
(14626, 'Silverbrook Gardens', 39.7416687011719, 0.693622969072228, -75.5833282470703, -1.31917793752701, 218, 10, 'PPL', 'P'),
(24880, 'Silvercrest', 33.3930587768555, 0.582818822968118, -82.0233306884766, -1.43157718396602, 218, 13, 'PPL', 'P'),
(31129, 'Silverdale', 37.915828704834, 0.66175604952153, -87.0713882446289, -1.51968240915106, 218, 19, 'PPL', 'P'),
(33974, 'Silverdale', 37.0419387817383, 0.64650379306351, -96.9030609130859, -1.69127746819397, 218, 20, 'PPL', 'P'),
(68814, 'Silverdale', 34.7686080932617, 0.606826687562965, -77.1822204589844, -1.34708387100941, 218, 33, 'PPL', 'P'),
(90829, 'Silverdale', 35.0588912963867, 0.611893085220731, -85.1369400024414, -1.48591991811547, 218, 50, 'PPL', 'P'),
(106273, 'Silverdale', 38.6411094665527, 0.674414586814895, -77.3755569458008, -1.35045822926859, 218, 53, 'PPL', 'P'),
(138124, 'Silverdale', 47.9861106872559, 0.837515626719054, -93.1094436645508, -1.62506635664659, 218, 28, 'PPL', 'P'),
(167199, 'Silverdale', 40.3474998474121, 0.704196717285251, -75.2713928222656, -1.31373363731056, 218, 45, 'PPL', 'P'),
(208744, 'Silverdale', 47.644718170166, 0.831557203254165, -122.69361114502, -2.1414074856422, 218, 56, 'PPL', 'P'),
(187361, 'Silverdale (historical)', 39.6916694641113, 0.692750317762036, -105.695556640625, -1.84473546810706, 218, 7, 'PPL', 'P'),
(51452, 'Silvergate East', 39.3861083984375, 0.687417271100125, -76.4819412231445, -1.33486169266065, 218, 25, 'PPL', 'P'),
(179163, 'Silvergate II', 33.3402786254883, 0.58189763554706, -111.873329162598, -1.95255793905472, 218, 5, 'PPL', 'P'),
(179164, 'Silvergate Trails', 33.3283309936523, 0.581689110033707, -111.878059387207, -1.95264049704851, 218, 5, 'PPL', 'P'),
(5859, 'Silverhill', 30.545280456543, 0.533115714911751, -87.7516708374023, -1.53155558023896, 218, 2, 'PPL', 'P'),
(38218, 'Silverhill', 37.8822212219238, 0.66116948829144, -83.0491714477539, -1.44948148281657, 218, 21, 'PPL', 'P'),
(57570, 'Silverleaf', 39.9047203063965, 0.696468756434059, -93.6158294677734, -1.63390445619818, 218, 29, 'PPL', 'P'),
(140885, 'Silverleaf', 46.0136108398438, 0.803089009886627, -98.3805618286133, -1.71706472387116, 218, 34, 'PPL', 'P'),
(114065, 'Silvermine', 41.1513900756836, 0.718227248593197, -73.445556640625, -1.28186678433889, 218, 8, 'PPL', 'P'),
(114066, 'Silvermine Acres', 41.8313903808594, 0.730095492833081, -72.9091720581055, -1.27250510731699, 218, 8, 'PPL', 'P'),
(24881, 'Silvermont', 34.165828704834, 0.596306202571743, -85.1505584716797, -1.48615760524276, 218, 13, 'PPL', 'P'),
(152584, 'Silvernails', 42.014720916748, 0.733295214303784, -73.6836090087891, -1.28602158195552, 218, 40, 'PPL', 'P'),
(128817, 'Silvers Mills', 45.0849990844727, 0.786881677282677, -69.245002746582, -1.20855328848037, 218, 26, 'PPL', 'P'),
(14627, 'Silverside', 39.7930603027344, 0.694519921727366, -75.4905624389648, -1.3175588687423, 218, 10, 'PPL', 'P'),
(14628, 'Silverside Heights', 39.7847213745117, 0.694374379973793, -75.4805603027344, -1.31738429853284, 218, 10, 'PPL', 'P'),
(205758, 'Silversmith Estates', 40.5488891601563, 0.707711623870965, -111.858329772949, -1.95229615031957, 218, 52, 'PPL', 'P'),
(68815, 'Silverstone', 36.2880592346191, 0.633346112802837, -81.7519378662109, -1.42684048565121, 218, 33, 'PPL', 'P'),
(83649, 'Silverstreet', 34.2177810668945, 0.597212942343888, -81.7155609130859, -1.42620558804733, 218, 48, 'PPL', 'P'),
(193959, 'Silverthorn', 40.6477813720703, 0.709437618573445, -122.390556335449, -2.13611818140119, 218, 6, 'PPL', 'P'),
(187362, 'Silverthorne', 39.6375007629395, 0.691804895575058, -106.061393737793, -1.85112052997858, 218, 7, 'PPL', 'P'),
(212148, 'Silvertip', 60.750560760498, 1.06029730770356, -149.369720458984, -2.60699342479281, 218, 1, 'PPL', 'P'),
(195615, 'Silvertip Landing', 47.3616714477539, 0.826617106011095, -116.691673278809, -2.0366539083767, 218, 17, 'PPL', 'P'),
(57571, 'Silverton', 36.8172187805176, 0.642581689147123, -92.5652770996094, -1.61556885840909, 218, 29, 'PPL', 'P'),
(74303, 'Silverton', 39.1927795410156, 0.684043045998995, -84.4005584716797, -1.4730676358528, 218, 41, 'PPL', 'P'),
(111396, 'Silverton', 38.9261093139648, 0.679388772519918, -81.7225036621094, -1.42632676187693, 218, 58, 'PPL', 'P'),
(146312, 'Silverton', 40.0158309936523, 0.698408003760828, -74.1452789306641, -1.29407924214967, 218, 37, 'PPL', 'P'),
(167202, 'Silverton', 40.6586112976074, 0.709626636431814, -76.2708282470703, -1.33117707613447, 218, 45, 'PPL', 'P'),
(187363, 'Silverton', 37.811939239502, 0.65994283629335, -107.663887023926, -1.8790893140627, 218, 7, 'PPL', 'P'),
(192217, 'Silverton', 34.4741706848145, 0.601687785344521, -101.304168701172, -1.76809128983124, 218, 51, 'PPL', 'P'),
(195614, 'Silverton', 47.4930610656738, 0.828910287446735, -115.954437255859, -2.02378671241192, 218, 17, 'PPL', 'P'),
(201567, 'Silverton', 45.0052795410156, 0.785490308771165, -122.781936645508, -2.14294905643919, 218, 43, 'PPL', 'P'),
(208745, 'Silverton', 48.0786094665527, 0.83913003497186, -121.565826416016, -2.12172392886737, 218, 56, 'PPL', 'P'),
(146313, 'Silverton Estates', 40.0105590820313, 0.698315991545165, -74.149169921875, -1.29414715275747, 218, 37, 'PPL', 'P'),
(146314, 'Silverton Pine Terrace', 40.0094413757324, 0.698296483890181, -74.129997253418, -1.2938125265665, 218, 37, 'PPL', 'P'),
(90830, 'Silvertop', 36.2058296203613, 0.631910935291394, -87.658332824707, -1.52992652460016, 218, 50, 'PPL', 'P'),
(24883, 'Silvertown', 33.4222183227539, 0.583327753052432, -82.6447219848633, -1.44242250803121, 218, 13, 'PPL', 'P'),
(31130, 'Silverville', 38.8574981689453, 0.678191282135764, -86.665283203125, -1.51259453906787, 218, 19, 'PPL', 'P'),
(167203, 'Silverville', 40.7044410705566, 0.710426516865219, -79.7230606079102, -1.39142989737502, 218, 45, 'PPL', 'P'),
(31131, 'Silverwood', 39.9555587768555, 0.697356055130246, -87.4033279418945, -1.52547584978642, 218, 19, 'PPL', 'P'),
(43080, 'Silverwood', 30.1894397735596, 0.526905123381146, -92.5977783203125, -1.61613611172128, 218, 22, 'PPL', 'P'),
(106274, 'Silverwood', 36.8549995422363, 0.643241087833027, -76.4000015258789, -1.33343157515528, 218, 53, 'PPL', 'P'),
(133124, 'Silverwood', 43.3233299255371, 0.756134750128412, -83.2480621337891, -1.45295278013944, 218, 27, 'PPL', 'P'),
(138126, 'Silverwood', 47.3177795410156, 0.825851047723534, -93.309440612793, -1.62855696188735, 218, 28, 'PPL', 'P'),
(24884, 'Silverwood Plantation', 32.2652816772461, 0.563135399351343, -81.2138900756836, -1.41744978017343, 218, 13, 'PPL', 'P'),
(201566, 'Silvies', 44.0330581665039, 0.768521844727671, -118.934173583984, -2.07579292217899, 218, 43, 'PPL', 'P'),
(14629, 'Silview', 39.7127799987793, 0.693118766098848, -75.6222229003906, -1.31985677728887, 218, 10, 'PPL', 'P'),
(121467, 'Silvis', 41.5122184753418, 0.724524892201935, -90.4150009155273, -1.57803945916964, 218, 18, 'PPL', 'P'),
(71396, 'Sim Place', 39.7358283996582, 0.693521036581505, -74.4211120605469, -1.2988934384522, 218, 37, 'PPL', 'P'),
(138127, 'Simar', 46.813060760498, 0.817042043206852, -92.3436126708984, -1.61170008429353, 218, 28, 'PPL', 'P'),
(11953, 'Simco (historical)', 35.9208297729492, 0.626936749586371, -91.3836135864258, -1.59494493945335, 218, 4, 'PPL', 'P'),
(5860, 'Simcoe', 34.2241706848145, 0.597324462214535, -86.7344436645508, -1.51380161683195, 218, 2, 'PPL', 'P'),
(57572, 'Simcoe', 36.7216682434082, 0.640914017672516, -94.1672210693359, -1.64352805511329, 218, 29, 'PPL', 'P'),
(198898, 'Simcoe', 48.1563911437988, 0.840487581337528, -100.866386413574, -1.76045054750575, 218, 34, 'PPL', 'P'),
(106275, 'Simeon', 37.9913902282715, 0.663074846893338, -78.4444427490234, -1.36911380586265, 218, 53, 'PPL', 'P'),
(199686, 'Simeon', 42.6133308410645, 0.743742928418219, -100.719436645508, -1.75788579021794, 218, 35, 'PPL', 'P'),
(38220, 'Simers', 37.4636116027832, 0.653863372156917, -82.2616729736328, -1.43573704158873, 218, 21, 'PPL', 'P'),
(185167, 'Simerson', 39.4211082458496, 0.688028133675162, -123.353889465332, -2.15293151631119, 218, 6, 'PPL', 'P'),
(185168, 'Simi', 38.6399993896484, 0.674395212317965, -122.873329162598, -2.1445441567741, 218, 6, 'PPL', 'P'),
(185170, 'Simi Valley', 34.2694396972656, 0.598114555530934, -118.780563354492, -2.07311191790961, 218, 6, 'PPL', 'P'),
(208746, 'Similk Beach', 48.4480590820313, 0.845578147182187, -122.576667785645, -2.13936643898276, 218, 56, 'PPL', 'P'),
(197547, 'Simko Trailer Court', 48.5577812194824, 0.847493159743036, -109.671669006348, -1.91413172031818, 218, 31, 'PPL', 'P'),
(187364, 'Simla', 39.1416702270508, 0.683151020191873, -104.08332824707, -1.8165967743454, 218, 7, 'PPL', 'P'),
(139456, 'Simler', 40.122501373291, 0.700269753099875, -92.6952819824219, -1.61783787165784, 218, 29, 'PPL', 'P'),
(106276, 'Simmerman', 36.8163909912109, 0.64256724149821, -81.1405563354492, -1.41616986495353, 218, 53, 'PPL', 'P'),
(43081, 'Simmesport', 30.9833297729492, 0.540761117769151, -91.8000030517578, -1.60221230659402, 218, 22, 'PPL', 'P'),
(177688, 'Simmler', 35.351390838623, 0.616998165293332, -119.986106872559, -2.09415262157594, 218, 6, 'PPL', 'P'),
(83647, 'Simmon Tree (historical)', 34.8463897705078, 0.608184233928633, -81.5041732788086, -1.42251617783119, 218, 48, 'PPL', 'P'),
(11955, 'Simmons', 35.8061103820801, 0.624934518499822, -91.7227783203125, -1.60086448076633, 218, 4, 'PPL', 'P'),
(38219, 'Simmons', 37.3574981689453, 0.652011343355849, -86.9422225952148, -1.51742804328831, 218, 21, 'PPL', 'P'),
(57573, 'Simmons', 37.2305603027344, 0.649795859645012, -92.0152816772461, -1.60596962741795, 218, 29, 'PPL', 'P'),
(83648, 'Simmons', 34.3074989318848, 0.598778814485827, -82.2680587768555, -1.43584849488035, 218, 48, 'PPL', 'P'),
(98095, 'Simmons', 28.4058303833008, 0.495775266951642, -98.2802810668945, -1.71531449440276, 218, 51, 'PPL', 'P'),
(111397, 'Simmons', 37.3280601501465, 0.651497553002545, -81.3019409179688, -1.41898655728046, 218, 58, 'PPL', 'P'),
(133125, 'Simmons', 46.0961112976074, 0.804528914509005, -84.5963897705078, -1.47648553679581, 218, 27, 'PPL', 'P'),
(11954, 'Simmons (historical)', 35.3416709899902, 0.616828521931894, -91.2300033569336, -1.59226393518397, 218, 4, 'PPL', 'P'),
(51453, 'Simmons Acres', 38.6408309936523, 0.674409726545905, -77.0386123657227, -1.34457743694948, 218, 25, 'PPL', 'P'),
(68818, 'Simmons Bay', 34.1338882446289, 0.595748736376562, -78.6277770996094, -1.37231359391238, 218, 33, 'PPL', 'P'),
(98096, 'Simmons Bottom', 30.1569404602051, 0.526337903358473, -94.8852767944336, -1.65606049172904, 218, 51, 'PPL', 'P'),
(90831, 'Simmons Chapel', 35.7188911437988, 0.623412255620733, -86.0875015258789, -1.50251034644223, 218, 50, 'PPL', 'P'),
(68819, 'Simmons Corner', 35.0913887023926, 0.612460271953891, -77.2174987792969, -1.34769959385343, 218, 33, 'PPL', 'P'),
(169605, 'Simmons Corner', 41.814998626709, 0.729809402752979, -71.7344436645508, -1.2520022290328, 218, 47, 'PPL', 'P'),
(18089, 'Simmons Crossing', 30.913890838623, 0.539549179736083, -86.9644393920898, -1.51781579954302, 218, 12, 'PPL', 'P'),
(5861, 'Simmons Crossroads', 32.6672210693359, 0.570150565136775, -85.7225036621094, -1.49613993195671, 218, 2, 'PPL', 'P'),
(106277, 'Simmons Gap', 38.2966690063477, 0.668402966707232, -78.6222229003906, -1.3722166548487, 218, 53, 'PPL', 'P'),
(43082, 'Simmons Settlement', 30.6761093139648, 0.535399109230385, -92.8919372558594, -1.62127015367073, 218, 22, 'PPL', 'P'),
(79133, 'Simmonstown', 39.9755592346191, 0.697705128970128, -75.9941711425781, -1.32634849876205, 218, 45, 'PPL', 'P'),
(61784, 'Simmonsville', 31.063060760498, 0.542152686017745, -90.3144378662109, -1.57628430285322, 218, 30, 'PPL', 'P'),
(83651, 'Simmonsville', 33.4194412231445, 0.583279283520593, -79.1783294677734, -1.3819225454415, 218, 48, 'PPL', 'P'),
(98097, 'Simmonsville', 30.9602794647217, 0.540358813996981, -93.6322174072266, -1.63419047969925, 218, 51, 'PPL', 'P'),
(106279, 'Simmonsville', 37.3841705322266, 0.652476863914394, -80.3619384765625, -1.40258041970113, 218, 53, 'PPL', 'P'),
(169604, 'Simmonsville', 41.8011093139648, 0.729566988514755, -71.5019378662109, -1.24794423732179, 218, 47, 'PPL', 'P'),
(43083, 'Simms', 31.461109161377, 0.54909994119538, -92.4233322143555, -1.61309145280504, 218, 22, 'PPL', 'P'),
(185171, 'Simms', 37.7980613708496, 0.659700621792207, -121.094169616699, -2.11349196477988, 218, 6, 'PPL', 'P'),
(192218, 'Simms', 35.0333290100098, 0.611446939159116, -102.657218933105, -1.79170647132335, 218, 51, 'PPL', 'P'),
(197548, 'Simms', 47.4916687011719, 0.828885986101788, -111.927223205566, -1.95349856755174, 218, 31, 'PPL', 'P'),
(74306, 'Simms (historical)', 39.8097190856934, 0.694810672339376, -84.0738906860352, -1.46736620743311, 218, 41, 'PPL', 'P'),
(172530, 'Simms Hill', 44.860279083252, 0.78295957336629, -71.5886077880859, -1.24945691282095, 218, 55, 'PPL', 'P'),
(51454, 'Simms Landing', 38.4861106872559, 0.671709347779592, -77.0294418334961, -1.34441738096796, 218, 25, 'PPL', 'P'),
(51455, 'Simms Wharf', 38.3333282470703, 0.669042791159123, -75.7291717529297, -1.32172338689691, 218, 25, 'PPL', 'P'),
(5862, 'Simmsville', 33.3244400024414, 0.58162119942591, -86.7088928222656, -1.51335567050741, 218, 2, 'PPL', 'P'),
(201568, 'Simnasho', 44.9730606079102, 0.784927982306995, -121.348892211914, -2.1179377127456, 218, 43, 'PPL', 'P'),
(111400, 'Simoda', 38.7269401550293, 0.675912614928064, -79.4833297729492, -1.3872458049864, 218, 58, 'PPL', 'P'),
(111399, 'Simon', 37.6119384765625, 0.656452164473556, -81.7330627441406, -1.42651105262437, 218, 58, 'PPL', 'P'),
(190745, 'Simon (historical)', 38.5661087036133, 0.673105576560094, -117.86833190918, -2.05719047564868, 218, 39, 'PPL', 'P'),
(61785, 'Simonds', 31.0097198486328, 0.54122171147968, -90.1802825927734, -1.57394285162283, 218, 30, 'PPL', 'P'),
(14630, 'Simonds Gardens', 39.7055587768555, 0.69299273200026, -75.5438919067383, -1.31848964354328, 218, 10, 'PPL', 'P'),
(157664, 'Simons', 41.5333290100098, 0.724893340538747, -80.533332824707, -1.40557181539556, 218, 41, 'PPL', 'P'),
(185172, 'Simons', 33.9874992370605, 0.593193766205767, -118.132217407227, -2.06179614643786, 218, 6, 'PPL', 'P'),
(111401, 'Simons (historical)', 39.1208305358887, 0.682787298965995, -80.142219543457, -1.39874560088947, 218, 58, 'PPL', 'P'),
(106280, 'Simons Corner', 37.8519401550293, 0.660640983973114, -76.6866683959961, -1.33843485589521, 218, 53, 'PPL', 'P'),
(106281, 'Simonsdale', 36.8236083984375, 0.64269320901777, -76.378059387207, -1.33304861259053, 218, 53, 'PPL', 'P'),
(190746, 'Simonsen (historical)', 39.8430595397949, 0.695392573037558, -115.747222900391, -2.0201701396516, 218, 39, 'PPL', 'P'),
(106282, 'Simonson', 37.8066711425781, 0.659850890656715, -76.6338882446289, -1.33751366847415, 218, 53, 'PPL', 'P'),
(74307, 'Simonsons (historical)', 39.2355613708496, 0.684789729789626, -84.7874984741211, -1.47982101290308, 218, 41, 'PPL', 'P'),
(172531, 'Simonsville', 43.2577781677246, 0.754990656124114, -72.7163925170898, -1.26914046959578, 218, 55, 'PPL', 'P'),
(190747, 'Simonsville (historical)', 36.5627784729004, 0.638140868029416, -114.44361114502, -1.99741782235267, 218, 39, 'PPL', 'P'),
(98099, 'Simonton', 29.6791706085205, 0.517999246379812, -95.976936340332, -1.67511354511579, 218, 51, 'PPL', 'P'),
(128819, 'Simonton Corners', 44.1958312988281, 0.771362771820513, -69.103889465332, -1.20609039710427, 218, 26, 'PPL', 'P'),
(123672, 'Simonton Lake', 41.7541694641113, 0.728747733584419, -85.9749984741211, -1.50054679777051, 218, 19, 'PPL', 'P'),
(98100, 'Simpatico Acres Colonia', 26.3649997711182, 0.460156053293563, -98.2419967651367, -1.71464630728525, 218, 51, 'PPL', 'P'),
(106283, 'Simpkins', 37.3241691589355, 0.651429642394748, -75.9438934326172, -1.32547098718287, 218, 53, 'PPL', 'P'),
(106284, 'Simpkins Corner', 37.5902786254883, 0.656074128756819, -77.317497253418, -1.34944489647382, 218, 53, 'PPL', 'P'),
(197550, 'Simpkins Place', 45.3133316040039, 0.790866831537872, -109.407218933105, -1.90951619583297, 218, 31, 'PPL', 'P'),
(106286, 'Simpkinstown', 37.0127792358398, 0.645994862979196, -80.570556640625, -1.40622149354349, 218, 53, 'PPL', 'P'),
(106287, 'Simplicity', 37.079719543457, 0.647163191749414, -78.4244384765625, -1.36876466544374, 218, 53, 'PPL', 'P'),
(195616, 'Simplot', 43.6697196960449, 0.762180392119001, -116.732498168945, -2.03736643712635, 218, 17, 'PPL', 'P'),
(5863, 'Simpson', 33.0716705322266, 0.577209539922139, -85.7219390869141, -1.49613007826067, 218, 2, 'PPL', 'P'),
(11957, 'Simpson', 33.458610534668, 0.583962916972416, -92.1041717529297, -1.60752105191098, 218, 4, 'PPL', 'P'),
(24885, 'Simpson', 33.3472213745117, 0.582018809376659, -85.1719436645508, -1.48653084726954, 218, 13, 'PPL', 'P'),
(28615, 'Simpson', 37.4672203063965, 0.653926355916697, -88.754997253418, -1.54906692967067, 218, 18, 'PPL', 'P'),
(33979, 'Simpson', 39.3852806091309, 0.687402823451211, -97.9311065673828, -1.70922024972227, 218, 20, 'PPL', 'P'),
(38221, 'Simpson', 37.6680603027344, 0.657431675122487, -83.3702774047852, -1.45508583901453, 218, 21, 'PPL', 'P'),
(43084, 'Simpson', 31.2455596923828, 0.545337893260507, -93.0152816772461, -1.6234229199379, 218, 22, 'PPL', 'P'),
(57575, 'Simpson', 36.6605606079102, 0.639847488234966, -91.3736114501953, -1.5947703692439, 218, 29, 'PPL', 'P'),
(61786, 'Simpson', 31.8422203063965, 0.555751585492016, -89.3369369506836, -1.55922369343601, 218, 30, 'PPL', 'P'),
(68820, 'Simpson', 35.5750007629395, 0.620900894712788, -77.2788925170898, -1.34877111671803, 218, 33, 'PPL', 'P'),
(77255, 'Simpson', 34.1527786254883, 0.596078435719514, -96.8891677856445, -1.69103498737672, 218, 42, 'PPL', 'P'),
(83653, 'Simpson', 33.9861106872559, 0.593169531439848, -78.8302764892578, -1.37584787499503, 218, 48, 'PPL', 'P'),
(111402, 'Simpson', 39.2666702270508, 0.685332681756865, -80.0936126708984, -1.39789725092423, 218, 58, 'PPL', 'P'),
(123673, 'Simpson', 40.8549995422363, 0.7130542579128, -85.4130630493164, -1.49073917442408, 218, 19, 'PPL', 'P'),
(138128, 'Simpson', 43.9238891601563, 0.766616486125773, -92.4097213745117, -1.61285389883581, 218, 28, 'PPL', 'P'),
(167205, 'Simpson', 41.836669921875, 0.730187638206798, -78.5883331298828, -1.3716251667706, 218, 45, 'PPL', 'P'),
(187365, 'Simpson', 37.4977798461914, 0.654459720504013, -104.16667175293, -1.8180513929328, 218, 7, 'PPL', 'P'),
(190748, 'Simpson', 38.8694381713867, 0.678399674491062, -119.398330688477, -2.0838939918989, 218, 39, 'PPL', 'P'),
(197549, 'Simpson', 48.9286117553711, 0.853965373561228, -110.205276489258, -1.92344492780825, 218, 31, 'PPL', 'P'),
(83654, 'Simpson (historical)', 34.4638900756836, 0.601508354866076, -82.1241683959961, -1.4333371339724, 218, 48, 'PPL', 'P'),
(123674, 'Simpson Corner', 40.1425018310547, 0.700618826939757, -87.2430572509766, -1.52267859853545, 218, 19, 'PPL', 'P'),
(83655, 'Simpson Crossing', 33.249439239502, 0.580312189171108, -79.9752807617188, -1.39583196949887, 218, 48, 'PPL', 'P'),
(24886, 'Simpson Crossroads', 34.2975006103516, 0.5986043108554, -84.8002777099609, -1.48004405264438, 218, 13, 'PPL', 'P'),
(79132, 'Simpson Store', 39.978328704834, 0.697753465343913, -80.3983306884766, -1.40321558362112, 218, 45, 'PPL', 'P'),
(51456, 'Simpson Woods', 39.1758308410645, 0.683747235380914, -76.9244384765625, -1.34258472666383, 218, 25, 'PPL', 'P'),
(90832, 'Simpsons', 35.9124984741211, 0.626791340990853, -85.4997177124023, -1.49225158360714, 218, 50, 'PPL', 'P'),
(106288, 'Simpsons', 37.0377807617188, 0.646431221923806, -80.204719543457, -1.39983643167197, 218, 53, 'PPL', 'P'),
(128820, 'Simpsons Corner', 44.4174995422363, 0.775231612515098, -69.0430603027344, -1.20502872793571, 218, 26, 'PPL', 'P'),
(51457, 'Simpsons Farm', 38.6977806091309, 0.67540368484375, -76.6083297729492, -1.33706758899156, 218, 25, 'PPL', 'P'),
(51458, 'Simpsons Mill', 39.584171295166, 0.690874120774075, -77.2249984741211, -1.34783048822101, 218, 25, 'PPL', 'P'),
(38223, 'Simpsonville', 38.2224998474121, 0.667108470680371, -85.3552780151367, -1.48973063531927, 218, 21, 'PPL', 'P'),
(51459, 'Simpsonville', 39.1866683959961, 0.683936386397337, -76.8822174072266, -1.3418478299902, 218, 25, 'PPL', 'P'),
(83656, 'Simpsonville', 34.7369384765625, 0.606273948478719, -82.2544403076172, -1.43561080775306, 218, 48, 'PPL', 'P'),
(98102, 'Simpsonville', 32.8607215881348, 0.573527786294132, -95.0690689086914, -1.65926826926204, 218, 51, 'PPL', 'P'),
(152585, 'Simpsonville', 42.5038909912109, 0.741832842705387, -74.7830581665039, -1.30521058971593, 218, 40, 'PPL', 'P'),
(172532, 'Simpsonville', 43.0724983215332, 0.751756912770486, -72.6502838134766, -1.26798665505351, 218, 55, 'PPL', 'P'),
(61788, 'Simrall', 32.2016716003418, 0.562025194071916, -90.9452819824219, -1.58729460974794, 218, 30, 'PPL', 'P'),
(11960, 'Sims', 34.6591682434082, 0.604916601850133, -93.6908264160156, -1.63521339987395, 218, 4, 'PPL', 'P'),
(28618, 'Sims', 38.360279083252, 0.669513171986659, -88.5305633544922, -1.54514981918132, 218, 18, 'PPL', 'P'),
(68822, 'Sims', 35.7608299255371, 0.624144225446341, -78.0591735839844, -1.36238959042631, 218, 33, 'PPL', 'P'),
(83657, 'Sims', 33.954719543457, 0.592621652624591, -80.9572219848633, -1.4129700769038, 218, 48, 'PPL', 'P'),
(98103, 'Sims', 30.666109085083, 0.535224572310444, -96.5513916015625, -1.68513968082967, 218, 51, 'PPL', 'P'),
(111403, 'Sims', 37.9433288574219, 0.66223601772899, -80.8019409179688, -1.41025991102048, 218, 58, 'PPL', 'P'),
(123675, 'Sims', 40.4997215270996, 0.706853486788714, -85.8552780151367, -1.49845728157924, 218, 19, 'PPL', 'P'),
(193960, 'Sims', 41.0719413757324, 0.71684060719262, -122.353889465332, -2.13547822379125, 218, 6, 'PPL', 'P'),
(198899, 'Sims', 46.7722206115723, 0.816329248141092, -101.498062133789, -1.7714753686284, 218, 34, 'PPL', 'P'),
(11959, 'Sims (historical)', 35.4958305358887, 0.619519113581201, -90.241943359375, -1.57501903501933, 218, 4, 'PPL', 'P'),
(57577, 'Sims (historical)', 36.5458297729492, 0.637845057411336, -90.5077819824219, -1.57965879427046, 218, 29, 'PPL', 'P'),
(5866, 'Sims Chapel', 31.2194404602051, 0.544882026660912, -88.1486129760742, -1.53848352749869, 218, 2, 'PPL', 'P'),
(208747, 'Sims Corner', 47.815559387207, 0.834538944989645, -119.360832214355, -2.08323952006102, 218, 56, 'PPL', 'P'),
(57578, 'Sims Point', 37.4755592346191, 0.65407189767027, -93.9550018310547, -1.63982413066921, 218, 29, 'PPL', 'P'),
(90834, 'Sims Ridge', 35.2133293151855, 0.614588537139028, -87.5472183227539, -1.52798721069436, 218, 50, 'PPL', 'P'),
(90833, 'Sims Spring', 35.5108299255371, 0.619780902316355, -86.6158294677734, -1.51173140855857, 218, 50, 'PPL', 'P'),
(11961, 'Simsboro', 35.0252799987793, 0.611306457411614, -90.3730621337891, -1.57730748934403, 218, 4, 'PPL', 'P'),
(43085, 'Simsboro', 32.5344390869141, 0.567833082356188, -92.788330078125, -1.61946186729057, 218, 22, 'PPL', 'P'),
(98104, 'Simsboro', 31.6741695404053, 0.552818546314971, -96.3158264160156, -1.6810282927388, 218, 51, 'PPL', 'P'),
(114067, 'Simsbury', 41.8758316040039, 0.730871138500566, -72.8016662597656, -1.27062877717098, 218, 8, 'PPL', 'P'),
(38224, 'Simstown', 37.6338882446289, 0.656835260196364, -85.1777801513672, -1.48663271318123, 218, 21, 'PPL', 'P'),
(5867, 'Simsville', 32.1044387817383, 0.56032816124629, -85.8708267211914, -1.49872865769432, 218, 2, 'PPL', 'P'),
(18090, 'Simsville', 30.6805591583252, 0.535476773665675, -85.1741714477539, -1.48656972942145, 218, 12, 'PPL', 'P'),
(24887, 'Simsville', 33.7797203063965, 0.589567339749406, -84.4555587768555, -1.47402757226772, 218, 13, 'PPL', 'P'),
(18091, 'Sinai', 30.6616706848145, 0.535147107612237, -84.9102783203125, -1.48196392547421, 218, 12, 'PPL', 'P'),
(38225, 'Sinai', 37.9541702270508, 0.66242523532444, -85.0272216796875, -1.48400497213365, 218, 21, 'PPL', 'P'),
(61789, 'Sinai', 32.122501373291, 0.560643412940328, -90.1869430541992, -1.57405909860441, 218, 30, 'PPL', 'P'),
(106289, 'Sinai', 36.7388916015625, 0.641214621980558, -78.9369430541992, -1.37770955775505, 218, 53, 'PPL', 'P'),
(171299, 'Sinai', 44.2444381713867, 0.772211121785757, -97.0405578613281, -1.69367724265224, 218, 49, 'PPL', 'P'),
(111404, 'Sincerity', 39.5991706848145, 0.69113590950923, -80.5391693115234, -1.40567368130726, 218, 58, 'PPL', 'P'),
(28619, 'Sinclair', 39.8022193908691, 0.694679777971798, -90.1216735839844, -1.57291993144813, 218, 18, 'PPL', 'P'),
(111405, 'Sinclair', 39.2680587768555, 0.685356916522785, -79.8208312988281, -1.39313631784349, 218, 58, 'PPL', 'P'),
(117801, 'Sinclair', 42.5, 0.74176493209759, -92.7316665649414, -1.61847290241977, 218, 16, 'PPL', 'P'),
(128821, 'Sinclair', 47.1666717529297, 0.823213719296028, -68.2699966430664, -1.19153622174698, 218, 26, 'PPL', 'P'),
(195617, 'Sinclair', 48.9291687011719, 0.853975094099207, -116.175827026367, -2.02765069283752, 218, 17, 'PPL', 'P'),
(209737, 'Sinclair', 41.7750015258789, 0.729111321652242, -107.112503051758, -1.86946584830565, 218, 59, 'PPL', 'P'),
(98105, 'Sinclair City', 32.1983299255371, 0.561966870844043, -95.079719543457, -1.65945415790613, 218, 51, 'PPL', 'P'),
(152586, 'Sinclair Corner', 44.6436080932617, 0.779177951197405, -74.8913879394531, -1.30710130093183, 218, 40, 'PPL', 'P'),
(83658, 'Sinclair Crossroads', 34.5272216796875, 0.602613699876514, -79.4649963378906, -1.38692582618143, 218, 48, 'PPL', 'P'),
(106290, 'Sinclair Farms', 37.0530586242676, 0.64669787092795, -76.3525009155273, -1.33260253310794, 218, 53, 'PPL', 'P'),
(106293, 'Sinclair Manor', 37.6194381713867, 0.656583058841133, -77.2472229003906, -1.34821837763378, 218, 53, 'PPL', 'P'),
(152587, 'Sinclairville', 42.2638893127441, 0.737644023205829, -79.2588882446289, -1.383328561339, 218, 40, 'PPL', 'P'),
(179167, 'Sincuidados', 33.7561111450195, 0.589155282149744, -111.899719238281, -1.95301853276525, 218, 5, 'PPL', 'P'),
(208748, 'Sine', 47.0316696166992, 0.820857487521581, -123.263328552246, -2.15135093020423, 218, 56, 'PPL', 'P'),
(51460, 'Sinepuxent', 38.313060760498, 0.668689056787334, -75.1522216796875, -1.31165370849921, 218, 25, 'PPL', 'P'),
(157665, 'Siney (historical)', 41.6563911437988, 0.727041179957896, -83.9966735839844, -1.46601851476347, 218, 41, 'PPL', 'P'),
(146315, 'Singac', 40.8866691589355, 0.713606996997046, -74.2413864135742, -1.29575663416225, 218, 37, 'PPL', 'P'),
(133127, 'Singapore (historical)', 42.6777801513672, 0.744867781083641, -86.2099990844727, -1.50464833216535, 218, 27, 'PPL', 'P'),
(43086, 'Singer', 30.6547203063965, 0.535025800624584, -93.4122161865234, -1.63035073403958, 218, 22, 'PPL', 'P'),
(51461, 'Singer', 39.4744415283203, 0.688958975055172, -76.3391723632813, -1.33236990598672, 218, 25, 'PPL', 'P'),
(51463, 'Singer Woods', 39.4816703796387, 0.689085142311814, -76.3172225952148, -1.33198681026391, 218, 25, 'PPL', 'P'),
(51464, 'Singerly', 39.6488914489746, 0.692003700550432, -75.8441696166992, -1.32373047825245, 218, 25, 'PPL', 'P'),
(106291, 'Singerly', 38.0802803039551, 0.664626271386363, -76.8966674804688, -1.34210003134543, 218, 53, 'PPL', 'P'),
(106292, 'Singers Glen', 38.5525016784668, 0.672868089169886, -78.9136123657227, -1.37730236042437, 218, 53, 'PPL', 'P'),
(167206, 'Singersville', 40.3772201538086, 0.704715434486571, -76.9119415283203, -1.34236661377055, 218, 45, 'PPL', 'P'),
(83659, 'Singing Pines', 34.6586112976074, 0.604906881312154, -82.9283294677734, -1.44737239239128, 218, 48, 'PPL', 'P'),
(185173, 'Singing Springs', 34.3211097717285, 0.599016368455062, -118.127777099609, -2.06171864845014, 218, 6, 'PPL', 'P'),
(179166, 'Singing Spur Mobile Park', 33.5027809143066, 0.584733835528967, -112.033332824707, -1.95535052977378, 218, 5, 'PPL', 'P'),
(197551, 'Singleshot', 48.2472190856934, 0.842072827976397, -113.479721069336, -1.98059476690469, 218, 31, 'PPL', 'P'),
(83661, 'Singletary Forks', 33.3569412231445, 0.582188452738097, -79.6916732788086, -1.3908820851388, 218, 48, 'PPL', 'P'),
(61792, 'Singleton', 32.8861083984375, 0.573970869720494, -89.5366668701172, -1.56270963814487, 218, 30, 'PPL', 'P'),
(83662, 'Singleton', 33.6919403076172, 0.588035289753311, -80.7297210693359, -1.40899943687655, 218, 48, 'PPL', 'P'),
(90836, 'Singleton', 35.8583297729492, 0.625845918803875, -83.9749984741211, -1.46564021273063, 218, 50, 'PPL', 'P'),
(98106, 'Singleton', 30.6519393920898, 0.534977264513717, -95.9583282470703, -1.67478877262086, 218, 51, 'PPL', 'P'),
(187366, 'Singleton', 39.4430618286133, 0.688411295976997, -105.601387023926, -1.84309189824032, 218, 7, 'PPL', 'P'),
(61790, 'Singleton (historical)', 33.1888885498047, 0.579255380271538, -88.8569412231445, -1.55084618759495, 218, 30, 'PPL', 'P'),
(83663, 'Singleton Crossroads', 33.8355598449707, 0.590541923550321, -79.195556640625, -1.38222321632857, 218, 48, 'PPL', 'P'),
(61791, 'Singleton Settlement', 32.3833312988281, 0.565195753928682, -89.4088897705078, -1.56047950704804, 218, 30, 'PPL', 'P'),
(98107, 'Sings Colonia', 26.1630001068115, 0.456630494063489, -98.197998046875, -1.71387838478493, 218, 51, 'PPL', 'P'),
(90837, 'Sink (historical)', 35.4180603027344, 0.618161766952614, -84.289436340332, -1.47112818878895, 218, 50, 'PPL', 'P'),
(18092, 'Sink Creek', 30.6224994659424, 0.5344634408709, -85.1516723632813, -1.48617704631872, 218, 12, 'PPL', 'P'),
(195618, 'Sinker (historical)', 43.1208305358887, 0.752600469045768, -116.509719848633, -2.03347822193483, 218, 17, 'PPL', 'P'),
(57579, 'Sinkin (historical)', 37.4094390869141, 0.652917883390912, -91.4061126708984, -1.59533762255609, 218, 29, 'PPL', 'P'),
(90838, 'Sinking Creek', 36.3277816772461, 0.634039400213612, -82.3055572509766, -1.43650296671823, 218, 50, 'PPL', 'P'),
(106294, 'Sinking Creek', 37.4188919067383, 0.653082866220442, -80.2652816772461, -1.40089344030862, 218, 53, 'PPL', 'P'),
(38226, 'Sinking Fork', 36.9336090087891, 0.644613081847608, -87.5991668701172, -1.52889388388748, 218, 21, 'PPL', 'P'),
(74310, 'Sinking Spring', 39.0727806091309, 0.681948669538729, -83.3869400024414, -1.45537665620557, 218, 41, 'PPL', 'P'),
(167207, 'Sinking Spring', 40.327220916748, 0.703842783176379, -76.0113906860352, -1.32664903649106, 218, 45, 'PPL', 'P'),
(38227, 'Sinking Valley', 37.1822204589844, 0.648952170211675, -84.4072189331055, -1.47318388283439, 218, 21, 'PPL', 'P'),
(38228, 'Sinks', 37.3344383239746, 0.65160887313611, -84.2336120605469, -1.47015387130415, 218, 21, 'PPL', 'P'),
(201569, 'Sinks (historical)', 45.6180610656738, 0.796185363971841, -120.611106872559, -2.10506092940091, 218, 43, 'PPL', 'P'),
(111406, 'Sinks Grove', 37.6641693115234, 0.65736376451469, -80.5411071777344, -1.4057075034531, 218, 58, 'PPL', 'P'),
(194422, 'Sinnard', 40.5883293151855, 0.708399984433723, -105.002777099609, -1.83264418412589, 218, 7, 'PPL', 'P'),
(167209, 'Sinnemahoning', 41.3191719055176, 0.721155593948821, -78.0966720581055, -1.3630440622642, 218, 45, 'PPL', 'P'),
(106295, 'Sinnickson', 37.9861106872559, 0.662982701519621, -75.4297180175781, -1.31649693325763, 218, 53, 'PPL', 'P'),
(71397, 'Sinnickson Landing', 39.5697212219238, 0.690621919418845, -75.4961090087891, -1.31765567464792, 218, 37, 'PPL', 'P'),
(157666, 'Sinns Subdivision', 41.4561080932617, 0.723545581290086, -84.5263900756836, -1.47526381164574, 218, 41, 'PPL', 'P'),
(57580, 'Sinsabaugh', 36.5044403076172, 0.637122674965652, -90.7019424438477, -1.58304753359953, 218, 29, 'PPL', 'P'),
(79134, 'Sinsheim', 39.8047218322754, 0.694723453813676, -76.8663864135742, -1.34157152702711, 218, 45, 'PPL', 'P'),
(176406, 'Sinsinawa', 42.523609161377, 0.742176989697253, -90.5391693115234, -1.58020660650669, 218, 57, 'PPL', 'P'),
(98111, 'Sinton', 28.0363903045654, 0.489327321188883, -97.5088882446289, -1.70185114982797, 218, 51, 'PPL', 'P'),
(212149, 'Sinuk', 64.5927810668945, 1.12735670263717, -166.252777099609, -2.90165835097241, 218, 1, 'PPL', 'P'),
(167210, 'Siousca', 40.0041694641113, 0.698204471674518, -75.8211135864258, -1.32332807461174, 218, 45, 'PPL', 'P'),
(68824, 'Sioux', 36.0205612182617, 0.628677391674847, -82.3608322143555, -1.43746769682312, 218, 33, 'PPL', 'P'),
(176407, 'Sioux', 46.7372207641602, 0.815718385566055, -90.879997253418, -1.58615517627555, 218, 57, 'PPL', 'P'),
(24888, 'Sioux Acres Mobile Home Park', 33.9674987792969, 0.592844692365885, -84.0555572509766, -1.46704622862813, 218, 13, 'PPL', 'P'),
(117802, 'Sioux Center', 43.079719543457, 0.751882946869074, -96.1752777099609, -1.67857525505873, 218, 16, 'PPL', 'P'),
(117804, 'Sioux City', 42.5, 0.74176493209759, -96.4000015258789, -1.68249742555414, 218, 16, 'PPL', 'P'),
(197553, 'Sioux Crossing', 45.8713912963867, 0.800606810592618, -110.243606567383, -1.92411391387407, 218, 31, 'PPL', 'P'),
(171301, 'Sioux Falls', 43.5499992370605, 0.760090875927725, -96.6999969482422, -1.68773333341529, 218, 49, 'PPL', 'P'),
(171302, 'Sioux Falls Junction', 43.9791717529297, 0.767581349388709, -96.6891708374023, -1.68754438213595, 218, 49, 'PPL', 'P'),
(197552, 'Sioux Pass', 47.9225006103516, 0.836405421439627, -104.32527923584, -1.82081961572788, 218, 31, 'PPL', 'P'),
(117806, 'Sioux Rapids', 42.8933296203613, 0.748629829018515, -95.1508331298828, -1.66069532413216, 218, 16, 'PPL', 'P'),
(98108, 'Sioux Terrace Colonia', 26.2180004119873, 0.457590430478408, -98.1569976806641, -1.71316279340003, 218, 51, 'PPL', 'P'),
(98109, 'Sioux Terrace South Colonia', 26.2140007019043, 0.457520622368335, -98.1579971313477, -1.71318023710517, 218, 51, 'PPL', 'P'),
(138132, 'Sioux Valley', 43.5438919067383, 0.759984282905095, -95.304443359375, -1.66337632840154, 218, 28, 'PPL', 'P'),
(199688, 'Sioux View Park', 41.125560760498, 0.717776441999674, -100.750556945801, -1.75842894192227, 218, 35, 'PPL', 'P'),
(202616, 'Sioux Village', 44.1144409179688, 0.769942241695064, -103.217216491699, -1.80148027252394, 218, 49, 'PPL', 'P'),
(179168, 'Siovi Shuatak', 31.9508304595947, 0.557647190266421, -112.597503662109, -1.96519716843018, 218, 5, 'PPL', 'P'),
(38229, 'Sip', 37.9249992370605, 0.661916105503044, -82.8277816772461, -1.44561750239098, 218, 21, 'PPL', 'P'),
(189573, 'Sipapu', 36.1555595397949, 0.631033556870267, -105.550003051758, -1.84219507874324, 218, 38, 'PPL', 'P'),
(179169, 'Sipaulovi', 35.8083305358887, 0.624973267493683, -110.495559692383, -1.92851132546601, 218, 5, 'PPL', 'P'),
(98110, 'Sipe Springs', 32.0905609130859, 0.560085946745147, -98.7838897705078, -1.72410412442251, 218, 51, 'PPL', 'P'),
(197554, 'Sipes', 47.9327812194824, 0.836584851918071, -114.38500213623, -1.99639490217797, 218, 31, 'PPL', 'P'),
(79135, 'Sipes Mill', 39.9105606079102, 0.696570688924782, -78.1527786254883, -1.36402330659702, 218, 45, 'PPL', 'P'),
(167211, 'Sipesville', 40.0991706848145, 0.699862555769202, -79.0913925170898, -1.38040520941042, 218, 45, 'PPL', 'P'),
(126107, 'Sippewisset', 41.5652809143066, 0.72545100647101, -70.6469421386719, -1.23302174678575, 218, 23, 'PPL', 'P'),
(197555, 'Sipple', 46.9236106872559, 0.818971503416614, -109.761672973633, -1.91570258588717, 218, 31, 'PPL', 'P'),
(157667, 'Sippo', 40.8163909912109, 0.712380411577983, -81.6013870239258, -1.42421287776168, 218, 41, 'PPL', 'P'),
(157668, 'Sippo Heights', 40.8052787780762, 0.712186466871598, -81.5025024414063, -1.42248701621726, 218, 41, 'PPL', 'P'),
(5869, 'Sipsey', 33.8247184753418, 0.590352705954871, -87.0861129760742, -1.51993940419625, 218, 2, 'PPL', 'P'),
(61793, 'Sipsey Fork', 33.9491691589355, 0.592524780139939, -88.2436065673828, -1.54014147843532, 218, 30, 'PPL', 'P'),
(106296, 'Sir John Addition', 39.2550010681152, 0.685129016512502, -78.1561126708984, -1.36408149666684, 218, 53, 'PPL', 'P'),
(111407, 'Sir Johns Run', 39.6480598449707, 0.691989186322491, -78.2350006103516, -1.36545835095041, 218, 58, 'PPL', 'P'),
(43087, 'Siracusaville', 29.686939239502, 0.518134834568811, -91.148063659668, -1.5908338176786, 218, 22, 'PPL', 'P'),
(176411, 'Siren', 45.785831451416, 0.799113509590384, -92.3808288574219, -1.6123496292834, 218, 57, 'PPL', 'P'),
(90839, 'Sirenburg (historical)', 36.0191688537598, 0.6286530903299, -82.978889465332, -1.44825483081848, 218, 50, 'PPL', 'P'),
(18093, 'Sirmans', 30.3505592346191, 0.529717188465674, -83.6569366455078, -1.46008898659641, 218, 12, 'PPL', 'P'),
(24889, 'Sirmans', 31.0811100006104, 0.542467704685187, -82.9694366455078, -1.44808984798895, 218, 13, 'PPL', 'P'),
(38230, 'Sirocco', 37.9891700744629, 0.663036097899477, -86.272216796875, -1.50573423609982, 218, 21, 'PPL', 'P'),
(106297, 'Sirons Mill', 38.3974990844727, 0.670162783555556, -79.4733276367188, -1.38707123477695, 218, 53, 'PPL', 'P'),
(211097, 'Sisal', 21.3333301544189, 0.372336851609601, -158.066665649414, -2.7587837532313, 218, 15, 'PPL', 'P'),
(18094, 'Sisco', 29.5208301544189, 0.515235684116637, -81.6272201538086, -1.42466375093423, 218, 12, 'PPL', 'P'),
(208749, 'Sisco', 48.1277809143066, 0.839988238633138, -122.135833740234, -2.13167243343547, 218, 56, 'PPL', 'P'),
(208750, 'Sisco Heights', 48.1155586242676, 0.839774919429822, -122.095832824707, -2.13097428575571, 218, 56, 'PPL', 'P'),
(11962, 'Sisemore', 34.7836112976074, 0.607088542877147, -91.8513870239258, -1.6031091260911, 218, 4, 'PPL', 'P'),
(61795, 'Sisloff Junction', 33.7652816772461, 0.589315338131258, -90.2266693115234, -1.57475245259421, 218, 30, 'PPL', 'P'),
(185175, 'Sisquoc', 34.8647193908691, 0.608504146154578, -120.290557861328, -2.09946629374092, 218, 6, 'PPL', 'P'),
(171306, 'Sisseton', 45.6647186279297, 0.79699969205416, -97.0494384765625, -1.69383223862769, 218, 49, 'PPL', 'P'),
(31132, 'Sisson', 38.5305595397949, 0.672485126605132, -87.561393737793, -1.52823461835963, 218, 19, 'PPL', 'P'),
(152588, 'Sisson', 44.7055587768555, 0.780259194599977, -74.9872207641602, -1.30877389925445, 218, 40, 'PPL', 'P'),
(106298, 'Sissons Corner', 37.9372215270996, 0.662129424706359, -76.4458312988281, -1.33423145558868, 218, 53, 'PPL', 'P'),
(126108, 'Sissons Corner', 41.6194381713867, 0.726396228920906, -71.0527801513672, -1.24010495633703, 218, 23, 'PPL', 'P'),
(111408, 'Sissonville', 38.5280609130859, 0.672441517342282, -81.6311111450195, -1.42473166154203, 218, 58, 'PPL', 'P'),
(176412, 'Sister Bay', 45.1872215270996, 0.788665795475948, -87.1208267211914, -1.52054527334425, 218, 57, 'PPL', 'P'),
(133128, 'Sister Lakes', 42.0722198486328, 0.734298759981553, -86.1997222900391, -1.50446896826593, 218, 27, 'PPL', 'P'),
(98112, 'Sisterdale', 29.9727802276611, 0.523123700949342, -98.7205581665039, -1.72299877941207, 218, 51, 'PPL', 'P'),
(201570, 'Sisters', 44.2911109924316, 0.773025716184185, -121.548057556152, -2.12141380375843, 218, 43, 'PPL', 'P'),
(111409, 'Sistersville', 39.5641708374023, 0.690525046934193, -80.9961090087891, -1.41364878350761, 218, 58, 'PPL', 'P'),
(167212, 'Sistersville', 40.7861099243164, 0.711851907259657, -79.6125030517578, -1.38950030400721, 218, 45, 'PPL', 'P'),
(185176, 'Sites', 39.3088912963867, 0.68606957843049, -122.337501525879, -2.13519220029017, 218, 6, 'PPL', 'P'),
(157669, 'Sites Lake Cottage Area', 40.7808303833008, 0.71175976188594, -82.3858337402344, -1.43790405576772, 218, 41, 'PPL', 'P'),
(11963, 'Sitka', 36.1883316040039, 0.631605537293389, -91.42138671875, -1.5956042049812, 218, 4, 'PPL', 'P'),
(33977, 'Sitka', 37.1749992370605, 0.648826136113087, -99.6511077880859, -1.73923993416186, 218, 20, 'PPL', 'P'),
(38231, 'Sitka', 37.8805618286133, 0.661140526414586, -82.8383331298828, -1.44580165998035, 218, 21, 'PPL', 'P'),
(74308, 'Sitka', 39.4477806091309, 0.688493654233708, -81.3386077880859, -1.4196265148904, 218, 41, 'PPL', 'P'),
(79136, 'Sitka', 39.9913902282715, 0.697981431933224, -79.6116714477539, -1.38948578977927, 218, 45, 'PPL', 'P'),
(90840, 'Sitka', 35.8633308410645, 0.625933203908602, -88.7574996948242, -1.54911060551254, 218, 50, 'PPL', 'P'),
(123677, 'Sitka', 40.8255615234375, 0.712540467559497, -86.7352828979492, -1.51381626421794, 218, 19, 'PPL', 'P'),
(133129, 'Sitka', 43.3811111450195, 0.757143222654198, -86.0186080932617, -1.50130792921006, 218, 27, 'PPL', 'P'),
(193305, 'Sitka', 57.0530586242676, 0.995763721326816, -135.330001831055, -2.36195410868186, 218, 1, 'PPL', 'P'),
(202618, 'Sitka', 45.5169410705566, 0.794420487117446, -100.185829162598, -1.74857258272788, 218, 49, 'PPL', 'P'),
(201571, 'Sitkum', 43.1483306884766, 0.753080437253228, -123.860000610352, -2.16176482217282, 218, 43, 'PPL', 'P'),
(111410, 'Sitlington', 38.3583297729492, 0.669479150103733, -79.9252777099609, -1.39495925160965, 218, 58, 'PPL', 'P'),
(193307, 'Situk', 59.4352798461914, 1.03734132516027, -139.554718017578, -2.43568931609899, 218, 1, 'PPL', 'P'),
(201572, 'Siuslaw (historical)', 43.9041709899902, 0.766272339133908, -123.219436645508, -2.15058487191667, 218, 43, 'PPL', 'P'),
(98113, 'Sivells Bend', 33.8497200012207, 0.59078906489948, -97.2236099243164, -1.69687210385396, 218, 51, 'PPL', 'P'),
(74309, 'Siverly', 39.3488883972168, 0.686767659531227, -82.5, -1.43989663289532, 218, 41, 'PPL', 'P'),
(167213, 'Siverly', 41.4205589294434, 0.722925131335124, -79.6936111450195, -1.39091590728464, 218, 45, 'PPL', 'P'),
(68830, 'Sivey Town', 33.9672203063965, 0.592839832096896, -78.3066711425781, -1.36670923771442, 218, 33, 'PPL', 'P'),
(179170, 'Sivili Chuchg', 31.7441692352295, 0.554040271465045, -112.160003662109, -1.95756135295271, 218, 5, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(61794, 'Siwel', 32.246940612793, 0.562815287388315, -90.3027801513672, -1.57608083734594, 218, 30, 'PPL', 'P'),
(111412, 'Six', 37.3688888549805, 0.652210148331223, -81.6380615234375, -1.42485296852968, 218, 58, 'PPL', 'P'),
(157671, 'Six Corners', 41.0838890075684, 0.717049132705973, -81.4166717529297, -1.42098898810409, 218, 41, 'PPL', 'P'),
(169606, 'Six Corners', 41.8202781677246, 0.729901548126696, -71.3686065673828, -1.24561716716128, 218, 47, 'PPL', 'P'),
(201573, 'Six Corners', 45.3677787780762, 0.791817113993839, -122.845832824707, -2.14406425514566, 218, 43, 'PPL', 'P'),
(14631, 'Six Forks', 38.8883285522461, 0.678729373834014, -75.5299987792969, -1.31824716272603, 218, 10, 'PPL', 'P'),
(68826, 'Six Forks', 35.9008293151855, 0.626587675746489, -78.6524963378906, -1.37274502600897, 218, 33, 'PPL', 'P'),
(68828, 'Six Forks Crossroads', 35.8613891601563, 0.625899315183731, -78.482780456543, -1.36978292508653, 218, 33, 'PPL', 'P'),
(111411, 'Six Hill', 39.1941719055176, 0.684067347343942, -81.1327819824219, -1.41603417689599, 218, 58, 'PPL', 'P'),
(133130, 'Six Lakes', 43.4249992370605, 0.757909214362732, -85.1500015258789, -1.48614788470478, 218, 27, 'PPL', 'P'),
(5870, 'Six Mile', 34.4238891601563, 0.600810207186312, -86.7563934326172, -1.51418471255476, 218, 2, 'PPL', 'P'),
(24890, 'Six Mile', 34.1772193908691, 0.596505007547117, -85.2063903808594, -1.48713205588562, 218, 13, 'PPL', 'P'),
(74313, 'Six Mile', 39.7463912963867, 0.693705393907966, -84.3105621337891, -1.47149690344188, 218, 41, 'PPL', 'P'),
(83664, 'Six Mile', 34.8072204589844, 0.607500600476809, -82.8208312988281, -1.44549619540332, 218, 48, 'PPL', 'P'),
(106299, 'Six Mile', 37.3930587768555, 0.652631993047892, -79.0602798461914, -1.37986219086416, 218, 53, 'PPL', 'P'),
(197556, 'Six Mile (historical)', 47.0333290100098, 0.820886449398435, -114.351387023926, -1.99580820778982, 218, 31, 'PPL', 'P'),
(198903, 'Six Mile Corner', 46.9805603027344, 0.819965461714459, -103.190277099609, -1.80101009143349, 218, 34, 'PPL', 'P'),
(179171, 'Six Mile Crossing', 34.5611114501953, 0.60320518795462, -113.351112365723, -1.97835012157992, 218, 5, 'PPL', 'P'),
(128822, 'Six Mile Falls', 44.8591690063477, 0.78294019886936, -68.82861328125, -1.20128592133971, 218, 26, 'PPL', 'P'),
(189576, 'Six Mile Gate', 36.5872192382813, 0.63856743985702, -104.963607788086, -1.83196055067406, 218, 38, 'PPL', 'P'),
(74311, 'Six Point', 39.7236099243164, 0.693307783957217, -80.9983291625977, -1.41368753250147, 218, 41, 'PPL', 'P'),
(192220, 'Six Point', 34.0936088562012, 0.595045728427808, -101.800277709961, -1.77675002548341, 218, 51, 'PPL', 'P'),
(31134, 'Six Points', 39.3716697692871, 0.687165269481976, -86.9863891601563, -1.51819889526583, 218, 19, 'PPL', 'P'),
(68829, 'Six Points', 35.2794418334961, 0.615742418260332, -81.7480621337891, -1.42677284135952, 218, 33, 'PPL', 'P'),
(71398, 'Six Points', 39.5313911437988, 0.689952933353017, -75.107780456543, -1.31087806283172, 218, 37, 'PPL', 'P'),
(83665, 'Six Points', 33.5747184753418, 0.585989382824885, -81.7441711425781, -1.42670493075172, 218, 48, 'PPL', 'P'),
(157672, 'Six Points', 41.2825012207031, 0.720515569759848, -83.5547180175781, -1.45830493498217, 218, 41, 'PPL', 'P'),
(167214, 'Six Points', 41.1405601501465, 0.718038230734829, -79.754997253418, -1.39198729699118, 218, 45, 'PPL', 'P'),
(61796, 'Six Towns (historical)', 32.2569389343262, 0.562989791018743, -89.2333297729492, -1.55741540705585, 218, 30, 'PPL', 'P'),
(5872, 'Six Way', 34.5244407653809, 0.602565163765647, -86.8827819824219, -1.51639060888567, 218, 2, 'PPL', 'P'),
(201574, 'Sixes', 42.8202781677246, 0.747354840646639, -124.481941223145, -2.17261973361793, 218, 43, 'PPL', 'P'),
(5873, 'Sixmile', 33.0077781677246, 0.576094407794696, -87.0055618286133, -1.5185335214568, 218, 2, 'PPL', 'P'),
(74312, 'Sixmile', 39.8305587768555, 0.695174393565253, -84.254997253418, -1.47052711333092, 218, 41, 'PPL', 'P'),
(90841, 'Sixmile', 35.6597213745117, 0.622379548329027, -83.9619369506836, -1.46541224614132, 218, 50, 'PPL', 'P'),
(98114, 'Sixmile', 28.6862392425537, 0.500669324797366, -96.6861801147461, -1.68749218417859, 218, 51, 'PPL', 'P'),
(117813, 'Sixmile', 41.9097213745117, 0.731462626578673, -90.295280456543, -1.57594994297836, 218, 16, 'PPL', 'P'),
(18095, 'Sixmile Bend', 26.6455593109131, 0.465052741010865, -80.57861328125, -1.40636210844904, 218, 12, 'PPL', 'P'),
(18096, 'Sixmile Creek', 27.9663906097412, 0.488105596038809, -82.3608322143555, -1.43746769682312, 218, 12, 'PPL', 'P'),
(192219, 'Sixmile Crossing', 31.4688892364502, 0.54923572912146, -100.34139251709, -1.75128767545922, 218, 51, 'PPL', 'P'),
(197557, 'Sixmile Crossing', 45.690559387207, 0.797450698384765, -105.19361114502, -1.83597486654319, 218, 31, 'PPL', 'P'),
(51465, 'Sixmile House', 39.6380615234375, 0.691814682692064, -78.8486099243164, -1.3761678538, 218, 25, 'PPL', 'P'),
(192786, 'Sixmile Point', 38.771671295166, 0.676693320601621, -112.519721984863, -1.96383962206451, 218, 52, 'PPL', 'P'),
(146316, 'Sixmile Run', 40.4575004577637, 0.706116590115089, -74.5119400024414, -1.30047868509107, 218, 37, 'PPL', 'P'),
(179172, 'Sixmile Village', 36.9650001525879, 0.645160960662865, -112.578056335449, -1.96485774854925, 218, 5, 'PPL', 'P'),
(208751, 'Sixprong', 45.8574981689453, 0.800364329775367, -120.032501220703, -2.09496235570538, 218, 56, 'PPL', 'P'),
(117814, 'Sixteen', 43.1266708374023, 0.752702401536491, -91.3158264160156, -1.59376183013909, 218, 16, 'PPL', 'P'),
(197558, 'Sixteen', 46.2152786254883, 0.80660877674133, -110.996940612793, -1.93726207333385, 218, 31, 'PPL', 'P'),
(126109, 'Sixteen Acres', 42.1166687011719, 0.735074538807093, -72.5013885498047, -1.26538794246181, 218, 23, 'PPL', 'P'),
(192224, 'Sixteen Corner Windmill', 32.3738899230957, 0.565030970836234, -102.251106262207, -1.78461846808211, 218, 51, 'PPL', 'P'),
(192221, 'Sixteen Mile Crossing', 31.5419406890869, 0.550510717493336, -100.178062438965, -1.7484370278284, 218, 51, 'PPL', 'P'),
(74314, 'Sixteen Mile Stand', 39.2727813720703, 0.685439341358523, -84.3274993896484, -1.47179251432287, 218, 41, 'PPL', 'P'),
(11967, 'Sixteenth Section', 33.6624984741211, 0.58752143282098, -91.6138916015625, -1.59896404901245, 218, 4, 'PPL', 'P'),
(68832, 'Sixth Siding', 35.6744384765625, 0.622636410216166, -76.663330078125, -1.33802752540648, 218, 33, 'PPL', 'P'),
(112354, 'Sixth Vein', 37.2513885498047, 0.650159381133807, -87.6722183227539, -1.53016887225936, 218, 21, 'PPL', 'P'),
(83666, 'Sixty Six', 33.3055610656738, 0.58129169982004, -80.8263931274414, -1.41068668258517, 218, 48, 'PPL', 'P'),
(197559, 'Siyeh Bend', 48.7016716003418, 0.85000452065098, -113.66667175293, -1.98385767187226, 218, 31, 'PPL', 'P'),
(5874, 'Sizemore Landing', 30.8636093139648, 0.538671601577875, -87.8955612182617, -1.53406694114691, 218, 2, 'PPL', 'P'),
(38232, 'Sizerock', 37.2186088562012, 0.649587267552631, -83.4974975585938, -1.45730624957339, 218, 21, 'PPL', 'P'),
(167218, 'Sizerville', 41.5886116027832, 0.725858203801683, -78.1980590820313, -1.3648135996505, 218, 45, 'PPL', 'P'),
(198904, 'Skaar', 47.3733291625977, 0.826820571518377, -104.03971862793, -1.81583564290585, 218, 34, 'PPL', 'P'),
(11966, 'Skaggs', 36.2377815246582, 0.632468601223656, -90.9072189331055, -1.58663028421402, 218, 4, 'PPL', 'P'),
(38233, 'Skaggs', 38.0055618286133, 0.663322187979579, -82.9486083984375, -1.44772632650015, 218, 21, 'PPL', 'P'),
(197560, 'Skaggs (historical)', 47.0561103820801, 0.821284059349184, -109.219436645508, -1.90623877663746, 218, 31, 'PPL', 'P'),
(5875, 'Skaggs Corner', 34.6963882446289, 0.60556621341903, -85.690559387207, -1.4955823991825, 218, 2, 'PPL', 'P'),
(90842, 'Skaggston', 36.0875015258789, 0.629845720445065, -83.7600021362305, -1.46188781875471, 218, 50, 'PPL', 'P'),
(38234, 'Skaggstown', 37.4336090087891, 0.65333972810758, -86.1866683959961, -1.50424113483467, 218, 21, 'PPL', 'P'),
(208752, 'Skagit City', 48.3836097717285, 0.844453294516765, -122.361671447754, -2.13561404500684, 218, 56, 'PPL', 'P'),
(193308, 'Skagway', 59.4583282470703, 1.03774359564293, -135.313888549805, -2.36167287887075, 218, 1, 'PPL', 'P'),
(208754, 'Skamania', 45.6175003051758, 0.796175576854835, -122.040557861328, -2.13000955565083, 218, 56, 'PPL', 'P'),
(208756, 'Skamokawa', 46.2705612182617, 0.807573640004266, -123.455833435059, -2.15471077423547, 218, 56, 'PPL', 'P'),
(133131, 'Skandia', 46.377498626709, 0.80944004987522, -87.2413864135742, -1.52264943692152, 218, 27, 'PPL', 'P'),
(133132, 'Skandia Station', 46.3772201538086, 0.809435189606231, -87.2111129760742, -1.52212106576125, 218, 27, 'PPL', 'P'),
(152589, 'Skaneateles', 42.9469413757324, 0.749565530667514, -76.429443359375, -1.33394543208761, 218, 40, 'PPL', 'P'),
(152593, 'Skaneateles Falls', 42.9930610656738, 0.75037047110699, -76.4563903808594, -1.33441574633612, 218, 40, 'PPL', 'P'),
(152590, 'Skaneateles Junction', 43.0111083984375, 0.750685456484919, -76.4577789306641, -1.33443998110204, 218, 40, 'PPL', 'P'),
(133134, 'Skanee', 46.8733291625977, 0.818093925258406, -88.2138900756836, -1.53962282781303, 218, 27, 'PPL', 'P'),
(152592, 'Skanondaga Heights', 42.875560760498, 0.748319703909575, -76.4094390869141, -1.3335962916687, 218, 40, 'PPL', 'P'),
(121470, 'Skare Estates', 41.9438896179199, 0.732058974925769, -89.1527786254883, -1.5560095243164, 218, 18, 'PPL', 'P'),
(77258, 'Skedee', 36.3794403076172, 0.634941013400659, -96.704719543457, -1.68781575825103, 218, 42, 'PPL', 'P'),
(133135, 'Skeels', 44.0900001525879, 0.769515669867461, -84.586669921875, -1.47631589343437, 218, 27, 'PPL', 'P'),
(172533, 'Skeels Corner', 44.8988914489746, 0.783633486280135, -73.0669403076172, -1.27525868272608, 218, 55, 'PPL', 'P'),
(157673, 'Skeels Crossroads', 40.5736083984375, 0.708143055967558, -84.7847213745117, -1.47977254337124, 218, 41, 'PPL', 'P'),
(192222, 'Skeen', 33.0633316040039, 0.577063998168566, -101.786666870117, -1.77651247151418, 218, 51, 'PPL', 'P'),
(68833, 'Skeeter Point', 35.1855583190918, 0.614103841820633, -78.2119369506836, -1.36505581415164, 218, 33, 'PPL', 'P'),
(111413, 'Skeetersville', 39.3641700744629, 0.687034375114399, -77.8158264160156, -1.35814238111985, 218, 58, 'PPL', 'P'),
(106300, 'Skeetertown', 36.6602783203125, 0.63984256138695, -76.5800018310547, -1.33657317313519, 218, 53, 'PPL', 'P'),
(98115, 'Skeeterville', 31.353889465332, 0.547228604476408, -98.9625015258789, -1.7272214876365, 218, 51, 'PPL', 'P'),
(106301, 'Skeetrock', 37.2219390869141, 0.649645391043422, -82.4138870239258, -1.43839367793414, 218, 53, 'PPL', 'P'),
(106302, 'Skeggs', 37.1672210693359, 0.64869038147652, -82.0147171020508, -1.43142684852249, 218, 53, 'PPL', 'P'),
(5876, 'Skeggs Crossroads', 33.1152801513672, 0.577970671361684, -86.1127777099609, -1.5029514990768, 218, 2, 'PPL', 'P'),
(192223, 'Skellytown', 35.5752792358398, 0.620905754981778, -101.183891296387, -1.76599205310198, 218, 51, 'PPL', 'P'),
(33980, 'Skellyville', 37.6749992370605, 0.657552782373058, -98.4499969482422, -1.7182765953252, 218, 20, 'PPL', 'P'),
(167215, 'Skelp', 40.6197204589844, 0.70894786324898, -78.2683334350586, -1.36604011849054, 218, 45, 'PPL', 'P'),
(111414, 'Skelt', 38.5552787780762, 0.672916558701725, -80.3222198486328, -1.40188719886938, 218, 58, 'PPL', 'P'),
(31135, 'Skelton', 38.3413887023926, 0.669183472643707, -87.7816696166992, -1.53207915770927, 218, 19, 'PPL', 'P'),
(111415, 'Skelton', 37.8105583190918, 0.659918734685485, -81.1875, -1.4169891864629, 218, 58, 'PPL', 'P'),
(121471, 'Skelton', 40.1427803039551, 0.700623687208746, -89.2538909912109, -1.55777426801274, 218, 18, 'PPL', 'P'),
(167216, 'Skeltontown', 41.8122215270996, 0.72976093322114, -80.1119384765625, -1.39821709657115, 218, 45, 'PPL', 'P'),
(61797, 'Skene', 33.7036094665527, 0.588238954997675, -90.7941665649414, -1.58465714816238, 218, 30, 'PPL', 'P'),
(128823, 'Skerry', 46.6974983215332, 0.81502509815528, -68.4847183227539, -1.19528382203294, 218, 26, 'PPL', 'P'),
(152594, 'Skerry', 44.7677803039551, 0.781345165113484, -74.3822174072266, -1.29821459869034, 218, 40, 'PPL', 'P'),
(51468, 'Ski Acres', 39.4536094665527, 0.688595386987349, -76.9749984741211, -1.34346716509102, 218, 25, 'PPL', 'P'),
(167217, 'Ski Haven Lake Estates', 41.0933303833008, 0.717213915798422, -75.3077774047852, -1.31436866807249, 218, 45, 'PPL', 'P'),
(121472, 'Ski Hill', 42.2019386291504, 0.736562779803257, -88.2069396972656, -1.53950152082538, 218, 18, 'PPL', 'P'),
(68834, 'Ski Mountain', 36.1519393920898, 0.630970373373405, -81.6647186279297, -1.42531822277212, 218, 33, 'PPL', 'P'),
(43088, 'Ski Stone', 30.5894393920898, 0.53388643373122, -91.0930633544922, -1.58987388126368, 218, 22, 'PPL', 'P'),
(205764, 'Ski View Estates', 40.5738906860352, 0.708147982815574, -111.840278625488, -1.95198109836261, 218, 52, 'PPL', 'P'),
(205765, 'Ski/Lake Village Condominium', 41.2508316040039, 0.719962830675602, -111.79167175293, -1.95113274839736, 218, 52, 'PPL', 'P'),
(77261, 'Skiatook', 36.3683280944824, 0.634747068694274, -96.001106262207, -1.67553538983246, 218, 42, 'PPL', 'P'),
(68835, 'Skibo', 35.0591697692871, 0.611897945489721, -78.9705581665039, -1.37829625214319, 218, 33, 'PPL', 'P'),
(138139, 'Skibo', 47.4855613708496, 0.828779393079158, -91.9941711425781, -1.60560117908114, 218, 28, 'PPL', 'P'),
(24891, 'Skidaway Island', 31.9347190856934, 0.557365993744822, -81.0472183227539, -1.41454080931473, 218, 13, 'PPL', 'P'),
(43089, 'Skidder', 32.1005592346191, 0.560260450375575, -93.0569381713867, -1.62414996291549, 218, 22, 'PPL', 'P'),
(33982, 'Skiddy', 38.8680610656738, 0.678375639462224, -96.7941665649414, -1.68937690328204, 218, 20, 'PPL', 'P'),
(33981, 'Skidmore', 37.2402801513672, 0.64996550300645, -94.831672668457, -1.65512492323809, 218, 20, 'PPL', 'P'),
(51467, 'Skidmore', 39.021110534668, 0.681046856614601, -76.4155578613281, -1.33370308442841, 218, 25, 'PPL', 'P'),
(98116, 'Skidmore', 28.2538890838623, 0.493123391006682, -97.6852798461914, -1.7049297640481, 218, 51, 'PPL', 'P'),
(111416, 'Skidmore', 38.7605590820313, 0.676499375895236, -81.646110534668, -1.42499345027718, 218, 58, 'PPL', 'P'),
(133136, 'Skidmore', 45.7919387817383, 0.799220102613014, -88.0736083984375, -1.53717445066486, 218, 27, 'PPL', 'P'),
(139457, 'Skidmore', 40.288890838623, 0.703173797110552, -95.0811080932617, -1.65947839267204, 218, 29, 'PPL', 'P'),
(111418, 'Skidmore (historical)', 38.9599990844727, 0.679980260598024, -79.9916687011719, -1.39611799299995, 218, 58, 'PPL', 'P'),
(106303, 'Skidmore Corner', 38.4680595397949, 0.671394295822636, -77.5216674804688, -1.3530083391704, 218, 53, 'PPL', 'P'),
(111417, 'Skidmore Crossing', 38.4799995422363, 0.671602688177935, -80.442497253418, -1.40398643559864, 218, 58, 'PPL', 'P'),
(185178, 'Skidoo', 36.4355583190918, 0.635920457470563, -117.146667480469, -2.04459505527315, 218, 6, 'PPL', 'P'),
(133137, 'Skidway Lake', 44.1833305358887, 0.771144592348208, -84.0352783203125, -1.46669229451926, 218, 27, 'PPL', 'P'),
(106304, 'Skiffes Creek Annex', 37.2172203063965, 0.649563032786711, -76.584716796875, -1.33665546481287, 218, 53, 'PPL', 'P'),
(90843, 'Skiles (historical)', 35.4322204589844, 0.618408908301774, -85.2280578613281, -1.48751022476041, 218, 50, 'PPL', 'P'),
(38235, 'Skilesville', 37.214168548584, 0.64950976956491, -86.9030609130859, -1.51674454299454, 218, 21, 'PPL', 'P'),
(128824, 'Skillings Corner', 44.1988906860352, 0.771416168200369, -70.2738876342773, -1.22651071739467, 218, 26, 'PPL', 'P'),
(38236, 'Skillman', 37.8927803039551, 0.661353779038874, -86.6716690063477, -1.51270599235949, 218, 21, 'PPL', 'P'),
(146317, 'Skillman', 40.4199981689453, 0.705462051698175, -74.7149963378906, -1.3040226867117, 218, 37, 'PPL', 'P'),
(138140, 'Skime', 48.5469398498535, 0.847303942147585, -95.6025009155273, -1.66857841411685, 218, 28, 'PPL', 'P'),
(106305, 'Skimino', 37.3469390869141, 0.651827052608415, -76.7050018310547, -1.33875483470018, 218, 53, 'PPL', 'P'),
(106306, 'Skimino Farms', 37.3555603027344, 0.651977521210005, -76.6894378662109, -1.338483192269, 218, 53, 'PPL', 'P'),
(83667, 'Skimmer Bay', 33.7966690063477, 0.589863150367487, -78.7541732788086, -1.37451962340135, 218, 48, 'PPL', 'P'),
(146318, 'Skin Corner', 40.0127792358398, 0.698354740539026, -74.9352798461914, -1.30786735921939, 218, 37, 'PPL', 'P'),
(5878, 'Skinem', 34.9575004577637, 0.610123481255401, -86.5186080932617, -1.51003457547003, 218, 2, 'PPL', 'P'),
(90844, 'Skinem', 35.0905609130859, 0.612445824304977, -86.5886077880859, -1.5112563006201, 218, 50, 'PPL', 'P'),
(106307, 'Skinkers Corner', 38.2063903808594, 0.666827307448286, -77.2841720581055, -1.34886326209174, 218, 53, 'PPL', 'P'),
(106308, 'Skinkertown', 38.9013900756836, 0.678957340423325, -77.7427825927734, -1.35686752590603, 218, 53, 'PPL', 'P'),
(57584, 'Skinner', 39.2663917541504, 0.685327821487876, -91.9888916015625, -1.60550903370743, 218, 29, 'PPL', 'P'),
(128825, 'Skinner', 45.5280609130859, 0.794614564981886, -70.595832824707, -1.23212972097863, 218, 26, 'PPL', 'P'),
(90845, 'Skinner Crossroad', 36.1791687011719, 0.63144561446993, -83.0800018310547, -1.45001957451482, 218, 50, 'PPL', 'P'),
(193962, 'Skinner Mill Place', 40.1566696166992, 0.700866101446971, -122.701942443848, -2.14155289423772, 218, 6, 'PPL', 'P'),
(98117, 'Skinner Town', 31.0347194671631, 0.541658037134776, -94.8033294677734, -1.65463024106561, 218, 51, 'PPL', 'P'),
(185179, 'Skinners', 38.6991691589355, 0.67542791960967, -120.994171142578, -2.1117466621595, 218, 6, 'PPL', 'P'),
(187367, 'Skinners', 38.7688903808594, 0.676644784490754, -104.760833740234, -1.82842147590146, 218, 7, 'PPL', 'P'),
(167219, 'Skinners Eddy', 41.6413917541504, 0.726779391222741, -76.1469421386719, -1.32901485564544, 218, 45, 'PPL', 'P'),
(38237, 'Skinnersburg', 38.3061103820801, 0.66856774979968, -84.642219543457, -1.47728541722922, 218, 21, 'PPL', 'P'),
(68836, 'Skinnersville', 35.9394416809082, 0.627261588660333, -76.5374984741211, -1.33583134961355, 218, 33, 'PPL', 'P'),
(5879, 'Skinnerton', 31.6697196960449, 0.552740881879682, -87.0650024414063, -1.51957095585944, 218, 2, 'PPL', 'P'),
(114069, 'Skinnerville', 41.5563888549805, 0.725295810758486, -72.5091705322266, -1.2655237636774, 218, 8, 'PPL', 'P'),
(152595, 'Skinnerville', 44.7844390869141, 0.781635915725493, -74.8161087036133, -1.30578743040804, 218, 40, 'PPL', 'P'),
(106309, 'Skinquarter', 37.3969383239746, 0.652699703918607, -77.7816696166992, -1.35754623250984, 218, 53, 'PPL', 'P'),
(201575, 'Skipanon (historical)', 46.1480598449707, 0.805435587702123, -123.92749786377, -2.16294287148102, 218, 43, 'PPL', 'P'),
(51469, 'Skipnish (historical)', 39.410831451416, 0.687848769775745, -79.4688873291016, -1.38699373678922, 218, 25, 'PPL', 'P'),
(167220, 'Skippack', 40.2227783203125, 0.702019915989248, -75.399169921875, -1.31596376840739, 218, 45, 'PPL', 'P'),
(18097, 'Skipper', 30.048059463501, 0.524437571473133, -84.3602828979492, -1.47236469448308, 218, 12, 'PPL', 'P'),
(106310, 'Skippers', 36.6116714477539, 0.638994211421705, -77.5469436645508, -1.35344949180497, 218, 53, 'PPL', 'P'),
(68838, 'Skippers Corner', 34.3458290100098, 0.599447800551655, -77.9027786254883, -1.35965998346703, 218, 33, 'PPL', 'P'),
(24892, 'Skipperton', 32.7436103820801, 0.571483810157496, -83.692497253418, -1.46070963628845, 218, 13, 'PPL', 'P'),
(5882, 'Skipperville', 31.5575008392334, 0.550782293345497, -85.5455627441406, -1.49305173035665, 218, 2, 'PPL', 'P'),
(51470, 'Skipping Creek Plantation', 38.9019393920898, 0.678966927803249, -76.3388900756836, -1.3323649791387, 218, 25, 'PPL', 'P'),
(51471, 'Skipton', 38.8952789306641, 0.678850680821667, -76.0591735839844, -1.32748300538642, 218, 25, 'PPL', 'P'),
(106312, 'Skipwith', 36.6941719055176, 0.640434116044083, -78.4911117553711, -1.36992833368205, 218, 53, 'PPL', 'P'),
(106311, 'Skipwith Farms', 37.2983283996582, 0.650978636064143, -76.7313919067383, -1.33921542841071, 218, 53, 'PPL', 'P'),
(5881, 'Skirum', 34.3236083984375, 0.599059977717912, -85.9672164916992, -1.50041097655492, 218, 2, 'PPL', 'P'),
(157674, 'Skit', 40.3388900756836, 0.704046448420743, -80.9574966430664, -1.41297487059377, 218, 41, 'PPL', 'P'),
(121473, 'Skokie', 42.0333290100098, 0.733619986798719, -87.7333297729492, -1.53123546827593, 218, 18, 'PPL', 'P'),
(121474, 'Skokie Junction', 42.2591705322266, 0.737561664949118, -87.8536071777344, -1.53333470500519, 218, 18, 'PPL', 'P'),
(121475, 'Skokie Manor', 42.2438888549805, 0.737294949365947, -87.857780456543, -1.533407542461, 218, 18, 'PPL', 'P'),
(208757, 'Skokomish', 47.333610534668, 0.82612735068663, -123.156112670898, -2.14947966006429, 218, 56, 'PPL', 'P'),
(179173, 'Skoksonak', 32.2955589294434, 0.563663837090642, -111.53694152832, -1.94668686727359, 218, 5, 'PPL', 'P'),
(197561, 'Skones', 45.9633293151855, 0.802211431728418, -112.461387634277, -1.96282149557978, 218, 31, 'PPL', 'P'),
(133138, 'Skookum', 44.0805587768555, 0.769350886775012, -85.6436080932617, -1.49476294451508, 218, 27, 'PPL', 'P'),
(190750, 'Skookum (historical)', 39.5380592346191, 0.690069313492653, -117.175277709961, -2.04509439797754, 218, 39, 'PPL', 'P'),
(208758, 'Skookumchuck', 46.9055595397949, 0.818656451459658, -122.769721984863, -2.14273587039393, 218, 56, 'PPL', 'P'),
(128826, 'Skowhegan', 44.7649993896484, 0.781296629002617, -69.7197189331055, -1.21683864894772, 218, 26, 'PPL', 'P'),
(209738, 'Skull Creek', 44.1091690063477, 0.769850229479402, -104.366668701172, -1.82154199817356, 218, 59, 'PPL', 'P'),
(111419, 'Skull Run', 39.0083312988281, 0.680823816873307, -81.7594375610352, -1.42697138001879, 218, 58, 'PPL', 'P'),
(179174, 'Skull Valley', 34.5052795410156, 0.60223073731176, -112.684722900391, -1.96671943130927, 218, 5, 'PPL', 'P'),
(90846, 'Skullbone', 36.0838890075684, 0.629782670106257, -88.7611083984375, -1.54917358927233, 218, 50, 'PPL', 'P'),
(24893, 'Skullhead', 31.0905609130859, 0.542632654225204, -82.32861328125, -1.43690537035894, 218, 13, 'PPL', 'P'),
(77264, 'Skullyville', 35.2483291625977, 0.615199399714065, -94.5933303833008, -1.65096506561539, 218, 42, 'PPL', 'P'),
(61798, 'Skuna', 33.9580612182617, 0.592679975852464, -89.4552764892578, -1.56128910801942, 218, 30, 'PPL', 'P'),
(117815, 'Skunk River', 40.7266693115234, 0.710814472857016, -91.2005615234375, -1.59175007825164, 218, 16, 'PPL', 'P'),
(152596, 'Skunks Corner', 42.3619384765625, 0.739355303943286, -79.0591735839844, -1.37984288294625, 218, 40, 'PPL', 'P'),
(212150, 'Skwentna', 61.9902801513672, 1.08193449287505, -151.39778137207, -2.64238976515717, 218, 1, 'PPL', 'P'),
(57585, 'Sky', 36.6005592346191, 0.63880026671532, -89.642219543457, -1.56455187982893, 218, 29, 'PPL', 'P'),
(5894, 'Sky Ball', 34.0219383239746, 0.593794841663798, -86.6361083984375, -1.51208534266745, 218, 2, 'PPL', 'P'),
(126110, 'Sky Farm', 42.6399993896484, 0.744208382397738, -72.420280456543, -1.26397233918438, 218, 23, 'PPL', 'P'),
(18098, 'Sky Lake', 28.4569396972656, 0.496667292758764, -81.3916702270508, -1.42055262915948, 218, 12, 'PPL', 'P'),
(185180, 'Sky Londa', 37.3836097717285, 0.652467076797388, -122.261672973633, -2.13386874238646, 218, 6, 'PPL', 'P'),
(152597, 'Sky Ranch', 43.1500015258789, 0.753109598867164, -73.9180603027344, -1.29011352897043, 218, 40, 'PPL', 'P'),
(179175, 'Sky Ridge Mobile Homes', 33.3722190856934, 0.582455101742241, -112.066673278809, -1.95593243047196, 218, 5, 'PPL', 'P'),
(24894, 'Sky Valley', 34.9874992370605, 0.610647058725711, -83.3333282470703, -1.45444095455657, 218, 13, 'PPL', 'P'),
(185181, 'Sky Valley', 33.8899993896484, 0.591492072848234, -116.351669311523, -2.03071971967773, 218, 6, 'PPL', 'P'),
(185187, 'Sky Valley Mobile Home Park', 33.8997192382813, 0.591661716209672, -116.361671447754, -2.03089428988718, 218, 6, 'PPL', 'P'),
(51472, 'Sky View', 39.2938919067383, 0.685807789695336, -76.841667175293, -1.34114009493051, 218, 25, 'PPL', 'P'),
(192787, 'Sky View', 39.9508285522461, 0.697273497136454, -111.21443939209, -1.94105814315165, 218, 52, 'PPL', 'P'),
(167222, 'Sky View Acres', 41.0177803039551, 0.715895318163697, -76.429443359375, -1.33394543208761, 218, 45, 'PPL', 'P'),
(167223, 'Sky View Lake', 41.2924995422363, 0.720690073390275, -75.2416687011719, -1.31321485353021, 218, 45, 'PPL', 'P'),
(71399, 'Sky View Manor', 39.9777793884277, 0.697743877963989, -74.1458282470703, -1.29408882952959, 218, 37, 'PPL', 'P'),
(117819, 'Sky View Terrace Mobile Home Park', 42.4972190856934, 0.741716395986723, -92.283332824707, -1.6106480025049, 218, 16, 'PPL', 'P'),
(68839, 'Sky Village', 35.3169403076172, 0.616396890098219, -82.5108337402344, -1.44008571733272, 218, 33, 'PPL', 'P'),
(187368, 'Sky Village', 39.5505599975586, 0.690287492964958, -105.246673583984, -1.83690098081227, 218, 7, 'PPL', 'P'),
(138142, 'Skyberg', 44.2113914489746, 0.771634347672673, -92.9319381713867, -1.6219683013505, 218, 28, 'PPL', 'P'),
(185182, 'Skyforest', 34.235279083252, 0.597518340341892, -117.178329467773, -2.04514766119934, 218, 6, 'PPL', 'P'),
(111421, 'Skygusty', 37.3238906860352, 0.651424782125759, -81.4763870239258, -1.42203121619669, 218, 58, 'PPL', 'P'),
(5886, 'Skyhaven Estates', 34.151668548584, 0.596059061222584, -86.1497192382813, -1.50359625037671, 218, 2, 'PPL', 'P'),
(185183, 'Skyhigh', 38.4266700744629, 0.670671913376952, -120.098609924316, -2.09611617024766, 218, 6, 'PPL', 'P'),
(208759, 'Skykomish', 47.7094383239746, 0.832686783030522, -121.35888671875, -2.11811214979701, 218, 56, 'PPL', 'P'),
(68841, 'Skyland', 35.4891700744629, 0.619402866599619, -82.5244369506836, -1.4403231381439, 218, 33, 'PPL', 'P'),
(83668, 'Skyland', 35.042781829834, 0.611611921988646, -82.2666702270508, -1.43582426011443, 218, 48, 'PPL', 'P'),
(106318, 'Skyland', 38.5936088562012, 0.673585544767553, -78.3822174072266, -1.36802776877012, 218, 53, 'PPL', 'P'),
(126111, 'Skyland', 42.0713882446289, 0.734284245753612, -73.0475006103516, -1.2749193960032, 218, 23, 'PPL', 'P'),
(185184, 'Skyland', 34.2333297729492, 0.597484318458967, -117.285278320313, -2.04701427080738, 218, 6, 'PPL', 'P'),
(190751, 'Skyland', 39.0224990844727, 0.681071091380521, -119.947219848633, -2.09347391497214, 218, 39, 'PPL', 'P'),
(106313, 'Skyland Estates', 38.9230613708496, 0.679335575877143, -78.0824966430664, -1.36279665459893, 218, 53, 'PPL', 'P'),
(197565, 'Skyland Trailer Park', 48.6291694641113, 0.848739119659029, -112.334167480469, -1.96060108502092, 218, 31, 'PPL', 'P'),
(146319, 'Skylands', 41.1269416809082, 0.717800543607539, -74.2372207641602, -1.2956839298645, 218, 37, 'PPL', 'P'),
(24895, 'Skylane Hills', 33.5527801513672, 0.585606486839159, -84.4338912963867, -1.47364940339293, 218, 13, 'PPL', 'P'),
(111420, 'Skyles (historical)', 38.5044403076172, 0.672029260005538, -80.6772232055664, -1.40808317630351, 218, 58, 'PPL', 'P'),
(11969, 'Skylight', 35.8422203063965, 0.625564755571789, -94.394172668457, -1.64748910776062, 218, 4, 'PPL', 'P'),
(38238, 'Skylight', 38.4324989318848, 0.670773646130593, -85.5216674804688, -1.49263467932994, 218, 21, 'PPL', 'P'),
(5890, 'Skyline', 34.8138885498047, 0.607616980616446, -86.1152801513672, -1.50299517491868, 218, 2, 'PPL', 'P'),
(24896, 'Skyline', 33.5880584716797, 0.586222209683185, -83.7555618286133, -1.46181032076698, 218, 13, 'PPL', 'P'),
(38239, 'Skyline', 37.0758285522461, 0.647095281141617, -82.9816665649414, -1.44830330035032, 218, 21, 'PPL', 'P'),
(61799, 'Skyline', 34.2636108398438, 0.598012822777293, -88.64111328125, -1.54707927939109, 218, 30, 'PPL', 'P'),
(111423, 'Skyline', 39.3236083984375, 0.686326440317629, -79.1294403076172, -1.38106926862823, 218, 58, 'PPL', 'P'),
(138143, 'Skyline', 44.142219543457, 0.770427070171513, -94.0305633544922, -1.64114292804101, 218, 28, 'PPL', 'P'),
(143024, 'Skyline', 41.2497215270996, 0.719943456178672, -96.2491683959961, -1.6798648908166, 218, 35, 'PPL', 'P'),
(197562, 'Skyline', 46.6511116027832, 0.814215497183896, -112.284439086914, -1.95973316082167, 218, 31, 'PPL', 'P'),
(5891, 'Skyline Acres', 34.7152786254883, 0.605895912761982, -86.706672668457, -1.51331692151355, 218, 2, 'PPL', 'P'),
(74315, 'Skyline Acres', 39.2286109924316, 0.684668422801972, -84.5669403076172, -1.47597154670543, 218, 41, 'PPL', 'P'),
(179176, 'Skyline Bel Aire Estates', 32.3202781677246, 0.564095269187235, -110.888893127441, -1.93537628896596, 218, 5, 'PPL', 'P'),
(14632, 'Skyline Crest', 39.7249984741211, 0.693332018723137, -75.6847229003906, -1.32094760807137, 218, 10, 'PPL', 'P'),
(106314, 'Skyline Crest', 38.0494384765625, 0.664087979951031, -78.6297225952148, -1.37234754921628, 218, 53, 'PPL', 'P'),
(51473, 'Skyline Estates', 39.3877792358398, 0.687446432714061, -77.5116729736328, -1.352833902119, 218, 25, 'PPL', 'P'),
(24897, 'Skyline Forest', 33.6772193908691, 0.587778361287146, -84.3011093139648, -1.47133192061234, 218, 13, 'PPL', 'P'),
(51474, 'Skyline Gardens', 39.3958282470703, 0.687586914461563, -77.5091705322266, -1.35279022627712, 218, 25, 'PPL', 'P'),
(138144, 'Skyline Gardens Mobile Home Park', 44.1055603027344, 0.769787245719622, -93.232780456543, -1.6272189897557, 218, 28, 'PPL', 'P'),
(18099, 'Skyline Heights', 27.2472190856934, 0.475553685057588, -80.226936340332, -1.40022418792668, 218, 12, 'PPL', 'P'),
(79137, 'Skyline Heights', 39.9958305358887, 0.698058929920945, -76.7119369506836, -1.33887587537173, 218, 45, 'PPL', 'P'),
(171311, 'Skyline Heights', 43.6069412231445, 0.761084701067515, -96.7613906860352, -1.68880485627989, 218, 49, 'PPL', 'P'),
(179177, 'Skyline Heights', 33.547779083252, 0.585519201734432, -112.045562744141, -1.95556398213515, 218, 5, 'PPL', 'P'),
(51475, 'Skyline Manor', 39.3424987792969, 0.68665613966058, -77.2055587768555, -1.34749120149813, 218, 25, 'PPL', 'P'),
(205771, 'Skyline Manor', 40.6191711425781, 0.708938275869055, -111.847221374512, -1.95210227219221, 218, 52, 'PPL', 'P'),
(117816, 'Skyline Mobile Park', 41.0066719055176, 0.715701440036339, -92.4563903808594, -1.61366842665521, 218, 16, 'PPL', 'P'),
(185185, 'Skyline North', 34.9252815246582, 0.609561154791231, -117.015281677246, -2.04230194041654, 218, 6, 'PPL', 'P'),
(14633, 'Skyline Orchard', 39.7938919067383, 0.694534435955307, -75.6666717529297, -1.32063255611441, 218, 10, 'PPL', 'P'),
(24899, 'Skyline Park', 33.9324989318848, 0.592233829790848, -83.4319381713867, -1.45616202241104, 218, 13, 'PPL', 'P'),
(90848, 'Skyline Park', 35.148609161377, 0.613458957362671, -85.3255615234375, -1.48921198469697, 218, 50, 'PPL', 'P'),
(14634, 'Skyline Ridge', 39.7213897705078, 0.693269034963356, -75.6947174072266, -1.32112204512277, 218, 10, 'PPL', 'P'),
(197563, 'Skyline Trailer Court', 46.9305610656738, 0.819092810404267, -114.130561828613, -1.99195408106026, 218, 31, 'PPL', 'P'),
(167224, 'Skyline View', 40.339168548584, 0.704051308689733, -76.725830078125, -1.33911835618898, 218, 45, 'PPL', 'P'),
(106315, 'Skyline View Mobile Home Park', 38.8008308410645, 0.677202250685935, -78.2249984741211, -1.36528378074095, 218, 53, 'PPL', 'P'),
(133139, 'Skyline Village', 44.5711097717285, 0.777912616784481, -84.7022171020508, -1.47833257216984, 218, 27, 'PPL', 'P'),
(51476, 'Skyline Woods', 39.3522186279297, 0.686825783022018, -77.2027816772461, -1.34744273196629, 218, 25, 'PPL', 'P'),
(106316, 'Skymont', 38.1697196960449, 0.666187283259313, -79.0752792358398, -1.38012397959931, 218, 53, 'PPL', 'P'),
(24900, 'Skyridge', 34.0877799987793, 0.594943995674167, -84.5149993896484, -1.47506500667036, 218, 13, 'PPL', 'P'),
(98118, 'Skyscraper Shadows', 29.6197204589844, 0.516961645529603, -95.2752838134766, -1.66286739831723, 218, 51, 'PPL', 'P'),
(18100, 'Skytop', 28.5669403076172, 0.498587165588602, -81.716667175293, -1.42622489596524, 218, 12, 'PPL', 'P'),
(152598, 'Skytop', 43.0202789306641, 0.750845512466433, -76.1236114501953, -1.32860765831476, 218, 40, 'PPL', 'P'),
(167225, 'Skytop', 41.2277793884277, 0.719560493613918, -75.2386093139648, -1.31316145715036, 218, 45, 'PPL', 'P'),
(185186, 'Skytop', 35.7013893127441, 0.623106791043701, -117.498062133789, -2.05072804894749, 218, 6, 'PPL', 'P'),
(5893, 'Skyview', 33.3880615234375, 0.582731604442418, -86.975830078125, -1.5180146045184, 218, 2, 'PPL', 'P'),
(24901, 'Skyview', 33.7777786254883, 0.589533451024535, -84.6419372558594, -1.4772804903812, 218, 13, 'PPL', 'P'),
(106317, 'Skyview', 37.3027801513672, 0.651056333788946, -80.0911102294922, -1.39785357508235, 218, 53, 'PPL', 'P'),
(205774, 'Skyview', 40.6405601501465, 0.709311584474857, -111.988059997559, -1.95456036987835, 218, 52, 'PPL', 'P'),
(51477, 'Skyview Estates', 39.5533294677734, 0.690335829338743, -76.147216796875, -1.3290196493354, 218, 25, 'PPL', 'P'),
(24902, 'Skyview Heights', 33.7847213745117, 0.589654624854134, -84.6527786254883, -1.47746970797665, 218, 13, 'PPL', 'P'),
(117817, 'Skyview Mobile Home Park', 40.4661102294922, 0.706266858979597, -91.4333267211914, -1.5958125973365, 218, 16, 'PPL', 'P'),
(167226, 'Skyview Mobile Home Park', 40.1427803039551, 0.700623687208746, -76.8330612182617, -1.34098989264503, 218, 45, 'PPL', 'P'),
(68842, 'Skyview Park', 36.1011085510254, 0.630083207835272, -80.210563659668, -1.39993843074172, 218, 33, 'PPL', 'P'),
(208760, 'Skyway', 47.4916687011719, 0.828885986101788, -122.253059387207, -2.13371840694292, 218, 56, 'PPL', 'P'),
(79138, 'Slab', 39.7961082458496, 0.694573118370141, -76.336669921875, -1.33232623014484, 218, 45, 'PPL', 'P'),
(111422, 'Slab', 39.1288909912109, 0.682927980450578, -80.9766693115234, -1.41330949678473, 218, 58, 'PPL', 'P'),
(128830, 'Slab City', 44.3038902282715, 0.77324875592548, -69.0561065673828, -1.20525642820891, 218, 26, 'PPL', 'P'),
(144450, 'Slab City', 43.0986099243164, 0.752212646212025, -71.7616729736328, -1.25247747012932, 218, 36, 'PPL', 'P'),
(152601, 'Slab City', 44.6697196960449, 0.779633684638945, -75.0924987792969, -1.31061134724855, 218, 40, 'PPL', 'P'),
(176415, 'Slab City', 44.7202796936035, 0.780516123066142, -88.445556640625, -1.54366617213804, 218, 57, 'PPL', 'P'),
(98119, 'Slab Crossing', 31.5258293151855, 0.550229520971737, -98.0808334350586, -1.71183347654191, 218, 51, 'PPL', 'P'),
(197564, 'Slab Crossing', 48.2877807617188, 0.842780762773168, -104.697776794434, -1.82732092458098, 218, 31, 'PPL', 'P'),
(111424, 'Slab Fork', 37.686939239502, 0.657761174728357, -81.331672668457, -1.41950547421886, 218, 58, 'PPL', 'P'),
(90850, 'Slab Town (historical)', 35.047779083252, 0.611699140514346, -88.2525024414063, -1.54029674072687, 218, 50, 'PPL', 'P'),
(11970, 'Slabtown', 34.2666702270508, 0.598066219157149, -92.399169921875, -1.61266974124643, 218, 4, 'PPL', 'P'),
(31137, 'Slabtown', 39.2783317565918, 0.685536213843175, -85.4013900756836, -1.49053544260069, 218, 19, 'PPL', 'P'),
(38240, 'Slabtown', 38.4327812194824, 0.67077857297861, -85.0052795410156, -1.4836220095689, 218, 21, 'PPL', 'P'),
(51480, 'Slabtown', 39.6827812194824, 0.692595188628539, -78.8866729736328, -1.37683217933392, 218, 25, 'PPL', 'P'),
(57586, 'Slabtown', 37.563060760498, 0.655599087397376, -92.0194396972656, -1.60604219855766, 218, 29, 'PPL', 'P'),
(71401, 'Slabtown', 39.6183280944824, 0.691470269384089, -75.2666702270508, -1.31365121247482, 218, 37, 'PPL', 'P'),
(90851, 'Slabtown', 35.6180610656738, 0.621652438772409, -84.8186111450195, -1.48036403144935, 218, 50, 'PPL', 'P'),
(98120, 'Slabtown', 33.4716682434082, 0.5841908169827, -95.5350036621094, -1.66740036480865, 218, 51, 'PPL', 'P'),
(106322, 'Slabtown', 37.6758308410645, 0.657567296600999, -76.496940612793, -1.33512348139581, 218, 53, 'PPL', 'P'),
(111425, 'Slabtown', 37.6288909912109, 0.656748041670663, -81.870002746582, -1.42890110654466, 218, 58, 'PPL', 'P'),
(157675, 'Slabtown', 40.788890838623, 0.711900443370523, -84.0519409179688, -1.4669831117103, 218, 41, 'PPL', 'P'),
(167229, 'Slabtown', 40.8927803039551, 0.713713656598704, -76.1969375610352, -1.3298874403766, 218, 45, 'PPL', 'P'),
(176416, 'Slabtown', 42.9669418334961, 0.749914604507396, -88.6350021362305, -1.54697261978943, 218, 57, 'PPL', 'P'),
(195619, 'Slabtown', 46.8727798461914, 0.818084337878481, -116.392776489258, -2.0314371752754, 218, 17, 'PPL', 'P'),
(5895, 'Slabtown (historical)', 34.980281829834, 0.61052109120615, -87.4347229003906, -1.5260237951807, 218, 2, 'PPL', 'P'),
(24903, 'Slabtown (historical)', 33.7502784729004, 0.589053482817076, -84.3833312988281, -1.47276696496573, 218, 13, 'PPL', 'P'),
(5896, 'Slackland', 34.146671295166, 0.595971842696883, -85.8300018310547, -1.49801612894467, 218, 2, 'PPL', 'P'),
(43090, 'Slacks', 30.4655609130859, 0.53172434640024, -91.4933319091797, -1.59685988543518, 218, 22, 'PPL', 'P'),
(51479, 'Slacks Corner', 39.3197212219238, 0.686258596288859, -76.9486083984375, -1.3430065713805, 218, 25, 'PPL', 'P'),
(195620, 'Slacks Corner', 43.0819396972656, 0.751921695862934, -116.741111755371, -2.03751677256988, 218, 17, 'PPL', 'P'),
(79140, 'Slackwater', 39.9822196960449, 0.69782137595171, -76.3563919067383, -1.33267044371573, 218, 45, 'PPL', 'P'),
(121476, 'Slackwater (historical)', 40.9824981689453, 0.715279528740643, -89.8208312988281, -1.56766924304293, 218, 18, 'PPL', 'P'),
(146320, 'Slackwoods', 40.253059387207, 0.702548420307574, -74.7350006103516, -1.30437182713061, 218, 37, 'PPL', 'P'),
(18101, 'Slade', 30.2930603027344, 0.528713642787905, -82.9991683959961, -1.44860876492735, 218, 12, 'PPL', 'P'),
(38241, 'Slade', 37.7949981689453, 0.659647158833324, -83.7041702270508, -1.46091336811185, 218, 21, 'PPL', 'P'),
(126112, 'Slades Corner', 41.5694389343262, 0.725523577610715, -71.0330581665039, -1.23976074276614, 218, 23, 'PPL', 'P'),
(176417, 'Slades Corners', 42.5819396972656, 0.743195049602963, -88.2938919067383, -1.54101912317256, 218, 57, 'PPL', 'P'),
(126113, 'Slades Ferry', 41.7208290100098, 0.728165832886237, -71.158332824707, -1.24194719802109, 218, 23, 'PPL', 'P'),
(24904, 'Slades Mill', 33.5736083984375, 0.585970008327955, -83.9613876342773, -1.46540265876139, 218, 13, 'PPL', 'P'),
(68843, 'Sladesville', 35.4636116027832, 0.61895678711703, -76.4897232055664, -1.33499751387625, 218, 33, 'PPL', 'P'),
(193963, 'Slagger', 41.3258285522461, 0.721271774351376, -121.721939086914, -2.12444860897863, 218, 6, 'PPL', 'P'),
(43091, 'Slagle', 31.202220916748, 0.544581488931897, -93.1272201538086, -1.62537661491358, 218, 22, 'PPL', 'P'),
(57587, 'Slagle', 37.5322189331055, 0.655060795962044, -93.375, -1.62970118904971, 218, 29, 'PPL', 'P'),
(111426, 'Slagle', 37.8194389343262, 0.660073730660927, -81.8408279418945, -1.42839191014423, 218, 58, 'PPL', 'P'),
(83670, 'Slandsville', 32.980281829834, 0.575614506166263, -80.2416687011719, -1.40048131612993, 218, 48, 'PPL', 'P'),
(111427, 'Slanesville', 39.3730583190918, 0.687189504247896, -78.523063659668, -1.37048599961431, 218, 58, 'PPL', 'P'),
(71400, 'Slapes Corner', 39.639720916748, 0.691843644568918, -75.4361114501953, -1.3166085197073, 218, 37, 'PPL', 'P'),
(133140, 'Slapneck', 46.3427810668945, 0.8088341141482, -86.8863906860352, -1.51645359264545, 218, 27, 'PPL', 'P'),
(191015, 'Slapout', 36.6158294677734, 0.639066782561409, -100.108329772949, -1.74721996321023, 218, 42, 'PPL', 'P'),
(167230, 'Slaseman Mobile Home Park', 40.1963882446289, 0.701559322278718, -76.8427810668945, -1.34115953600647, 218, 45, 'PPL', 'P'),
(106323, 'Slash', 37.9752807617188, 0.662793683661252, -76.6286087036133, -1.33742152310044, 218, 53, 'PPL', 'P'),
(38242, 'Slat', 36.810001373291, 0.642455721627562, -84.9091720581055, -1.48194461755631, 218, 21, 'PPL', 'P'),
(106325, 'Slate', 37.3055610656738, 0.651104869899813, -81.9491729736328, -1.43028288767624, 218, 53, 'PPL', 'P'),
(111428, 'Slate', 39.1358299255371, 0.68304908770115, -81.4461135864258, -1.42150284503642, 218, 58, 'PPL', 'P'),
(187369, 'Slate Creek', 39.7841682434082, 0.694364726014842, -106.162780761719, -1.85289006736489, 218, 7, 'PPL', 'P'),
(195621, 'Slate Creek', 45.6383285522461, 0.796539098343631, -116.279441833496, -2.02945911237574, 218, 17, 'PPL', 'P'),
(79141, 'Slate Hill', 39.7391700744629, 0.693579359809378, -76.2897186279297, -1.33150677547742, 218, 45, 'PPL', 'P'),
(106326, 'Slate Hill', 37.6319389343262, 0.656801238313438, -78.3872222900391, -1.36811512045387, 218, 53, 'PPL', 'P'),
(113214, 'Slate Hill', 41.3908309936523, 0.72240628097575, -74.476936340332, -1.29986775593701, 218, 40, 'PPL', 'P'),
(38243, 'Slate Lick', 37.5463905334473, 0.655308137048285, -84.3111114501953, -1.4715064908218, 218, 21, 'PPL', 'P'),
(167231, 'Slate Lick', 40.7669410705566, 0.711517347647715, -79.6430587768555, -1.3900336020155, 218, 45, 'PPL', 'P'),
(74316, 'Slate Mills', 39.3505592346191, 0.686796821145164, -83.0572204589844, -1.44962196456407, 218, 41, 'PPL', 'P'),
(106327, 'Slate Mills', 38.5313911437988, 0.672499640833073, -78.1830596923828, -1.36455181091535, 218, 53, 'PPL', 'P'),
(68844, 'Slate Mountain', 36.5369415283203, 0.637689928277838, -80.5061111450195, -1.40509670745709, 218, 33, 'PPL', 'P'),
(79142, 'Slate Ridge', 39.7338905334473, 0.693487214435661, -77.0913925170898, -1.34549862437054, 218, 45, 'PPL', 'P'),
(167236, 'Slate Run', 41.4727783203125, 0.723836531639177, -77.5019378662109, -1.35266399244145, 218, 45, 'PPL', 'P'),
(98121, 'Slate Shoals', 33.8530616760254, 0.590847388127353, -95.4088897705078, -1.6651992621677, 218, 51, 'PPL', 'P'),
(61801, 'Slate Spring', 33.7405586242676, 0.588883839455638, -89.3711090087891, -1.55982010836214, 218, 30, 'PPL', 'P'),
(90852, 'Slate Springs', 36.0313911437988, 0.628866409533215, -84.9705581665039, -1.48301600726285, 218, 50, 'PPL', 'P'),
(38244, 'Slate Valley', 38.1691703796387, 0.666177695879389, -83.7233276367188, -1.46124772798671, 218, 21, 'PPL', 'P'),
(167232, 'Slate Valley', 40.7563896179199, 0.711333190058336, -75.5774993896484, -1.31907620477337, 218, 45, 'PPL', 'P'),
(492, 'Slatecut', 38.4483299255371, 0.671049949093689, -85.7658309936523, -1.49689613654823, 218, 19, 'PPL', 'P'),
(167233, 'Slatedale', 40.7444381713867, 0.711124597965956, -75.6569366455078, -1.32046264643687, 218, 45, 'PPL', 'P'),
(167234, 'Slatefield', 40.7958297729492, 0.712021550621095, -75.4977798461914, -1.31768483626186, 218, 45, 'PPL', 'P'),
(167235, 'Slateford', 40.9461097717285, 0.714644431399686, -75.1144409179688, -1.31099430981331, 218, 45, 'PPL', 'P'),
(176418, 'Slateford', 42.7855606079102, 0.746748904919619, -90.1933288574219, -1.57417055189603, 218, 57, 'PPL', 'P'),
(60, 'Slater', 31.3433303833008, 0.547044313728975, -97.9694366455078, -1.7098892357881, 218, 51, 'PPL', 'P'),
(18102, 'Slater', 26.7394409179688, 0.46669128416105, -81.8511123657227, -1.42857140720171, 218, 12, 'PPL', 'P'),
(38245, 'Slater', 37.0163917541504, 0.646057913318004, -88.9891662597656, -1.55315394983756, 218, 21, 'PPL', 'P'),
(57588, 'Slater', 39.2180595397949, 0.684484265212594, -93.0688934326172, -1.6243586215869, 218, 29, 'PPL', 'P'),
(83671, 'Slater', 35.0316696166992, 0.611417977282261, -82.4952774047852, -1.43981420805958, 218, 48, 'PPL', 'P'),
(112216, 'Slater', 31.9933300018311, 0.558388947209035, -88.0999984741211, -1.53763504437539, 218, 2, 'PPL', 'P'),
(117818, 'Slater', 41.8777809143066, 0.730905160383492, -93.6783294677734, -1.63499528698067, 218, 16, 'PPL', 'P'),
(157676, 'Slater', 40.5277786254883, 0.707343175534152, -84.0733337402344, -1.46735648689513, 218, 41, 'PPL', 'P'),
(185188, 'Slater', 35.5494384765625, 0.620454748651173, -119.196388244629, -2.08036943135424, 218, 6, 'PPL', 'P'),
(194423, 'Slater', 40.9477806091309, 0.714673593013623, -107.497222900391, -1.87618047636206, 218, 7, 'PPL', 'P'),
(208761, 'Slater', 46.1866683959961, 0.80610943403694, -118.80583190918, -2.07355293738613, 218, 56, 'PPL', 'P'),
(209739, 'Slater', 41.8730583190918, 0.730822735547754, -104.819442749023, -1.82944439607616, 218, 59, 'PPL', 'P'),
(74317, 'Slaters', 39.7655601501465, 0.694039953519907, -81.539436340332, -1.42313163435911, 218, 41, 'PPL', 'P'),
(169607, 'Slatersville', 42.0002784729004, 0.733043146106608, -71.5802764892578, -1.24931150422544, 218, 47, 'PPL', 'P'),
(106329, 'Slaterville', 37.4988899230957, 0.654479095000943, -76.942497253418, -1.34289991177884, 218, 53, 'PPL', 'P'),
(212151, 'Slaterville', 64.8480606079102, 1.13181217114087, -147.723617553711, -2.57826350926915, 218, 1, 'PPL', 'P'),
(205775, 'Slaterville (historical)', 41.2641716003418, 0.720195657533902, -112.031936645508, -1.9553261618498, 218, 52, 'PPL', 'P'),
(152603, 'Slaterville Springs', 42.3955612182617, 0.739942131489485, -76.350830078125, -1.332573371494, 218, 40, 'PPL', 'P'),
(106330, 'Slates Corner', 36.563060760498, 0.638145794877433, -77.6588897705078, -1.35540331993871, 218, 53, 'PPL', 'P'),
(185189, 'Slates Hot Springs', 36.1236114501953, 0.630475957517032, -121.636108398438, -2.12295058086546, 218, 6, 'PPL', 'P'),
(68845, 'Slatestone', 35.5724983215332, 0.620857218870911, -76.9225006103516, -1.34255090451798, 218, 33, 'PPL', 'P'),
(90853, 'Slatestone', 36.1858291625977, 0.631561861451512, -84.1963882446289, -1.46950419315622, 218, 50, 'PPL', 'P'),
(152602, 'Slateville', 43.3305587768555, 0.756260917385055, -73.2897186279297, -1.27914689791759, 218, 40, 'PPL', 'P'),
(167237, 'Slateville', 40.663890838623, 0.70971878180553, -75.8675003051758, -1.32413767558312, 218, 45, 'PPL', 'P'),
(167238, 'Slatington', 40.7483291625977, 0.711192508573753, -75.6122207641602, -1.31968220707942, 218, 45, 'PPL', 'P'),
(11971, 'Slatington (historical)', 34.4638900756836, 0.601508354866076, -93.8736114501953, -1.63840360054376, 218, 4, 'PPL', 'P'),
(192225, 'Slaton', 33.4372215270996, 0.583589608366615, -101.643058776855, -1.77400603745425, 218, 51, 'PPL', 'P'),
(111430, 'Slaty Fork', 38.416389465332, 0.670492482898508, -80.1269378662109, -1.3984788853063, 218, 58, 'PPL', 'P'),
(14635, 'Slaughter', 39.1594390869141, 0.683461145300812, -75.7152786254883, -1.32148090607966, 218, 10, 'PPL', 'P'),
(43092, 'Slaughter', 30.7172203063965, 0.53611663140708, -91.1413879394531, -1.59071730438091, 218, 22, 'PPL', 'P'),
(90854, 'Slaughter (historical)', 36.4452781677246, 0.636090100832001, -82.5449981689453, -1.44068199910079, 218, 50, 'PPL', 'P'),
(14636, 'Slaughter Beach', 38.9127807617188, 0.679156145398699, -75.304443359375, -1.31431047800267, 218, 10, 'PPL', 'P'),
(24905, 'Slaughter Creek (historical)', 32.1913909912109, 0.561845763593472, -84.6880569458008, -1.47808543082068, 218, 13, 'PPL', 'P'),
(61802, 'Slaughter Flat Landing', 30.5719394683838, 0.533581002443702, -88.4169387817383, -1.5431666962756, 218, 30, 'PPL', 'P'),
(5897, 'Slaughter Landing', 34.5872192382813, 0.603660854817133, -86.6997222900391, -1.5131956145259, 218, 2, 'PPL', 'P'),
(5898, 'Slaughters', 32.8252792358398, 0.572909200551934, -85.6725006103516, -1.49526721406749, 218, 2, 'PPL', 'P'),
(38246, 'Slaughters', 37.4888916015625, 0.654304591370516, -87.5022201538086, -1.5272018444889, 218, 21, 'PPL', 'P'),
(77265, 'Slaughterville', 35.0872192382813, 0.612387501077105, -97.334716796875, -1.6988112846017, 218, 42, 'PPL', 'P'),
(38247, 'Slavans', 36.7536087036133, 0.641471483867696, -84.6655578613281, -1.47769274771794, 218, 21, 'PPL', 'P'),
(18103, 'Slavia', 28.6477794647217, 0.499998075044612, -81.2305603027344, -1.41774073052252, 218, 12, 'PPL', 'P'),
(157678, 'Slavic Village', 41.4561080932617, 0.723545581290086, -81.6449966430664, -1.42497400920123, 218, 41, 'PPL', 'P'),
(194424, 'Slavonia', 40.7844390869141, 0.71182274564572, -106.70361328125, -1.86232937553256, 218, 7, 'PPL', 'P'),
(61803, 'Slavonia (historical)', 30.7716693878174, 0.537066947152561, -88.7861099243164, -1.54960994821693, 218, 30, 'PPL', 'P'),
(133142, 'Slaybaugh Corner', 43.9444389343262, 0.76697514734558, -85.4252777099609, -1.49095236046934, 218, 27, 'PPL', 'P'),
(981, 'Slayden', 36.2947196960449, 0.633462359784419, -87.4702835083008, -1.52664444487275, 218, 50, 'PPL', 'P'),
(61804, 'Slayden', 34.9469413757324, 0.609939190507968, -89.4408264160156, -1.56103690666419, 218, 30, 'PPL', 'P'),
(98122, 'Slayden', 29.5752792358398, 0.516185999862118, -97.5336074829102, -1.70228258192456, 218, 51, 'PPL', 'P'),
(112534, 'Slaymakersville', 39.9955596923828, 0.698054202810011, -76.0408325195313, -1.3271628934234, 218, 45, 'PPL', 'P'),
(138147, 'Slayton', 43.9877815246582, 0.767731618253217, -95.7555618286133, -1.6712498310063, 218, 28, 'PPL', 'P'),
(197566, 'Slayton Junction (historical)', 46.2980613708496, 0.808053608211725, -109.060829162598, -1.90347055384238, 218, 31, 'PPL', 'P'),
(11972, 'Slaytonville', 35.1105613708496, 0.61279489814486, -94.4383316040039, -1.64825982658009, 218, 4, 'PPL', 'P'),
(57589, 'Sledd', 39.2313919067383, 0.684716958912839, -90.8905563354492, -1.58633946702298, 218, 29, 'PPL', 'P'),
(5899, 'Sledge', 32.6994400024414, 0.570712891600945, -88.3099975585938, -1.54130021982561, 218, 2, 'PPL', 'P'),
(61805, 'Sledge', 34.4319381713867, 0.600950688933814, -90.220832824707, -1.57465058668251, 218, 30, 'PPL', 'P'),
(57590, 'Sleeper', 37.7605590820313, 0.659046083375293, -92.5927810668945, -1.61604889319558, 218, 29, 'PPL', 'P'),
(197567, 'Sleeping Buffalo', 48.4838905334473, 0.846203523985165, -107.528060913086, -1.87671870121837, 218, 31, 'PPL', 'P'),
(68846, 'Sleepy Creek', 35.2583312988281, 0.615373969923519, -77.970832824707, -1.36084775331321, 218, 33, 'PPL', 'P'),
(111431, 'Sleepy Creek', 39.6669387817383, 0.692318685928361, -78.0827789306641, -1.36280158144695, 218, 58, 'PPL', 'P'),
(138150, 'Sleepy Eye', 44.2972183227539, 0.773132309206816, -94.7238922119141, -1.65324379940211, 218, 28, 'PPL', 'P'),
(24906, 'Sleepy Hollow', 32.5666694641113, 0.56839560855744, -83.6944427490234, -1.46074359159235, 218, 13, 'PPL', 'P'),
(31138, 'Sleepy Hollow', 39.396671295166, 0.687601628426586, -85.7174987792969, -1.49605258027295, 218, 19, 'PPL', 'P'),
(51481, 'Sleepy Hollow', 38.649169921875, 0.674555268299478, -76.623893737793, -1.33733923142275, 218, 25, 'PPL', 'P'),
(61807, 'Sleepy Hollow', 32.9680595397949, 0.575401186962948, -90.5841674804688, -1.58099197271216, 218, 30, 'PPL', 'P'),
(98123, 'Sleepy Hollow', 30.177339553833, 0.526693934706703, -95.4052124023438, -1.66513507998543, 218, 51, 'PPL', 'P'),
(106335, 'Sleepy Hollow', 37.3222198486328, 0.651395620511822, -79.9208297729492, -1.39488162046388, 218, 53, 'PPL', 'P'),
(121477, 'Sleepy Hollow', 42.0941696166992, 0.734681855704361, -88.3024978637695, -1.54116932545804, 218, 18, 'PPL', 'P'),
(133143, 'Sleepy Hollow', 46.4047203063965, 0.809915157813691, -89.2408294677734, -1.55754630142343, 218, 27, 'PPL', 'P'),
(152604, 'Sleepy Hollow', 41.0855598449707, 0.71707829431991, -73.85888671875, -1.2890807550997, 218, 40, 'PPL', 'P'),
(179178, 'Sleepy Hollow', 34.2833290100098, 0.598356969769158, -110.94750213623, -1.93639920914066, 218, 5, 'PPL', 'P'),
(185191, 'Sleepy Hollow', 33.9477806091309, 0.59250054537402, -117.777778625488, -2.05561002269977, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(208762, 'Sleepy Hollow', 46.273609161377, 0.80762683664704, -123.451110839844, -2.15462834939974, 218, 56, 'PPL', 'P'),
(209740, 'Sleepy Hollow', 44.2411117553711, 0.772153064873994, -105.421669006348, -1.83995522710843, 218, 59, 'PPL', 'P'),
(157677, 'Sleepy Hollow Acres', 40.5449981689453, 0.707643713263168, -84.5455627441406, -1.47559843783671, 218, 41, 'PPL', 'P'),
(51485, 'Sleepy Hollow Estates', 39.3736114501953, 0.687199158206848, -77.3150024414063, -1.34940135378999, 218, 25, 'PPL', 'P'),
(106336, 'Sleepy Hollow Estates', 38.853328704834, 0.678118511258977, -77.1658325195313, -1.34679784750833, 218, 53, 'PPL', 'P'),
(106337, 'Sleepy Hollow Manor', 38.8658294677734, 0.678336690731282, -77.1558303833008, -1.34662327729888, 218, 53, 'PPL', 'P'),
(152605, 'Sleepy Hollow Manor', 41.1055603027344, 0.717427368159792, -73.8636093139648, -1.28916317993544, 218, 40, 'PPL', 'P'),
(51482, 'Sleepy Hollow Mobile Home Park', 39.3624992370605, 0.687005213500463, -76.4416732788086, -1.33415888444898, 218, 25, 'PPL', 'P'),
(106338, 'Sleepy Hollow Mobile Home Park', 38.0175018310547, 0.663530580334877, -78.4252777099609, -1.36877931282974, 218, 53, 'PPL', 'P'),
(111432, 'Sleepy Hollow Township', 38.4513893127441, 0.671103345473545, -81.9722213745117, -1.4306851581589, 218, 58, 'PPL', 'P'),
(179179, 'Sleepy Hollow Trailer Village', 33.4002799987793, 0.582944857066706, -112.073333740234, -1.95604867745354, 218, 5, 'PPL', 'P'),
(205777, 'Sleepy Hollow Two', 40.6666717529297, 0.709767317916397, -111.809997558594, -1.95145259404428, 218, 52, 'PPL', 'P'),
(106339, 'Sleepy Hollow Woods', 38.8408317565918, 0.6779003983657, -77.1805572509766, -1.34705484255352, 218, 53, 'PPL', 'P'),
(106340, 'Sleepy Lake', 36.9036102294922, 0.644089504377299, -76.5013885498047, -1.33520111254158, 218, 53, 'PPL', 'P'),
(106341, 'Sleepy Lake West', 36.9041709899902, 0.644099291494305, -76.5108337402344, -1.33536596221306, 218, 53, 'PPL', 'P'),
(106342, 'Sleepy Point Estates', 36.8388900756836, 0.642959924600942, -76.5305633544922, -1.33571030894201, 218, 53, 'PPL', 'P'),
(185192, 'Sleepy Valley', 34.5091705322266, 0.602298647919557, -118.364440917969, -2.06584921130085, 218, 6, 'PPL', 'P'),
(57591, 'Slees Mills', 39.7799987792969, 0.694291955138056, -91.6141662597656, -1.59896884270241, 218, 29, 'PPL', 'P'),
(123678, 'Sleeth', 40.649169921875, 0.709461853339365, -86.7174987792969, -1.51350587279289, 218, 19, 'PPL', 'P'),
(212152, 'Sleetmute', 61.7024993896484, 1.07691177105916, -157.169723510742, -2.74312915971159, 218, 1, 'PPL', 'P'),
(152606, 'Sleggs Landing', 42.8063888549805, 0.747112426408415, -77.7172164916992, -1.35642131326539, 218, 40, 'PPL', 'P'),
(152607, 'Sleightsburg', 41.9166717529297, 0.731583933566326, -73.976936340332, -1.29114110967704, 218, 40, 'PPL', 'P'),
(111433, 'Sleith (historical)', 38.6791687011719, 0.675078845769788, -80.9466705322266, -1.41278591931442, 218, 58, 'PPL', 'P'),
(38248, 'Slemp', 37.0786094665527, 0.647143817252483, -83.1116714477539, -1.45057231359907, 218, 21, 'PPL', 'P'),
(77266, 'Slick', 35.7769393920898, 0.624425388678426, -96.2658309936523, -1.68015570800764, 218, 42, 'PPL', 'P'),
(38249, 'Slick Rock', 37.0058288574219, 0.645873555991543, -85.7980575561523, -1.49745859617046, 218, 21, 'PPL', 'P'),
(90855, 'Slick Rock', 36.3038902282715, 0.633622415765933, -84.5044403076172, -1.47488071592293, 218, 50, 'PPL', 'P'),
(74318, 'Slickaway', 38.6836090087891, 0.675156343757509, -83.7463912963867, -1.46165026478547, 218, 41, 'PPL', 'P'),
(11973, 'Slicker (historical)', 35.8769416809082, 0.626170757877837, -92.834716796875, -1.62027146826195, 218, 4, 'PPL', 'P'),
(38250, 'Slickford', 36.6875, 0.64031766932542, -84.9205627441406, -1.48214342253169, 218, 21, 'PPL', 'P'),
(5900, 'Slicklizzard', 33.9644393920898, 0.592791295986029, -87.5019378662109, -1.52719691764088, 218, 2, 'PPL', 'P'),
(195622, 'Slickpoo', 46.3169403076172, 0.808383107817595, -116.709999084473, -2.03697375402362, 218, 17, 'PPL', 'P'),
(113334, 'Slickport', 40.6730613708496, 0.709878837787044, -78.7099990844727, -1.37374863826577, 218, 45, 'PPL', 'P'),
(68848, 'Slickrock Ford', 35.1991691589355, 0.614341395789869, -83.5250015258789, -1.45778628435987, 218, 33, 'PPL', 'P'),
(167240, 'Slickville', 40.4597206115723, 0.70615533910895, -79.5233306884766, -1.38794395266617, 218, 45, 'PPL', 'P'),
(38251, 'Slickway', 38.186939239502, 0.666487820988329, -84.7991714477539, -1.48002474472647, 218, 21, 'PPL', 'P'),
(192226, 'Slide', 33.413890838623, 0.583182411035941, -101.929443359375, -1.77900439134616, 218, 51, 'PPL', 'P'),
(43093, 'Slidell', 30.2749996185303, 0.528398424383381, -89.7811126708984, -1.56697602221118, 218, 22, 'PPL', 'P'),
(51483, 'Slidell', 39.2194404602051, 0.684508366820459, -77.3322219848633, -1.34970189151901, 218, 25, 'PPL', 'P'),
(98124, 'Slidell', 33.3597183227539, 0.582236922269936, -97.3913879394531, -1.69980038263055, 218, 51, 'PPL', 'P'),
(106343, 'Sliders', 37.4569396972656, 0.653746925438253, -78.6849975585938, -1.37331227932116, 218, 53, 'PPL', 'P'),
(117820, 'Slifer', 42.3413887023926, 0.73899664272348, -94.3783264160156, -1.64721253848141, 218, 16, 'PPL', 'P'),
(83672, 'Slighs', 34.1983299255371, 0.59687345588393, -81.4505615234375, -1.42158047618219, 218, 48, 'PPL', 'P'),
(38252, 'Sligo', 38.4888916015625, 0.671757883890459, -85.3133316040039, -1.4889985323356, 218, 21, 'PPL', 'P'),
(43097, 'Sligo', 32.4508285522461, 0.566373803236879, -93.5813903808594, -1.63330338074015, 218, 22, 'PPL', 'P'),
(51484, 'Sligo', 38.9961090087891, 0.680610497669991, -77.0286102294922, -1.34440286674002, 218, 25, 'PPL', 'P'),
(57592, 'Sligo', 37.7738914489746, 0.659278777075539, -91.3775024414063, -1.5948382798517, 218, 29, 'PPL', 'P'),
(68849, 'Sligo', 36.4516716003418, 0.636201687281675, -76.0774993896484, -1.32780285103334, 218, 33, 'PPL', 'P'),
(74319, 'Sligo', 39.4416694641113, 0.68838699463205, -83.920280456543, -1.46468520316373, 218, 41, 'PPL', 'P'),
(167242, 'Sligo', 41.1091690063477, 0.717490351919572, -79.4902801513672, -1.38736711197405, 218, 45, 'PPL', 'P'),
(192227, 'Sligo', 33.0455589294434, 0.576753806480599, -102.697776794434, -1.79241433954109, 218, 51, 'PPL', 'P'),
(90856, 'Sligo (historical)', 35.9666709899902, 0.627736829756858, -85.7119369506836, -1.49595550805122, 218, 50, 'PPL', 'P'),
(51486, 'Sligo Park Hills', 38.9919395446777, 0.680537726793205, -77.0108337402344, -1.34409260847303, 218, 25, 'PPL', 'P'),
(51487, 'Sligo Woods', 39.0263900756836, 0.681139001988318, -77.0255584716797, -1.34434960351822, 218, 25, 'PPL', 'P'),
(77267, 'Slim', 34.084171295166, 0.594881011914387, -95.1041717529297, -1.65988092947081, 218, 42, 'PPL', 'P'),
(202619, 'Slim Butte', 43.0761108398438, 0.751819963109293, -102.820281982422, -1.79455245842226, 218, 49, 'PPL', 'P'),
(114070, 'Slineyville (historical)', 41.3036117553711, 0.72088401809666, -72.9166717529297, -1.27263600168457, 218, 8, 'PPL', 'P'),
(176419, 'Slinger', 43.333610534668, 0.756314180606856, -88.2861099243164, -1.54088330195696, 218, 57, 'PPL', 'P'),
(152608, 'Slingerlands', 42.6291694641113, 0.744019364539369, -73.8649978637695, -1.28918741470136, 218, 40, 'PPL', 'P'),
(5901, 'Sliocco Springs', 33.4555587768555, 0.583909653750615, -86.1380615234375, -1.50339278486943, 218, 2, 'PPL', 'P'),
(11974, 'Slip-Up and Hitch (historical)', 34.2458305358887, 0.597702497931272, -93.95361328125, -1.63979989590329, 218, 4, 'PPL', 'P'),
(167244, 'Slippery Rock', 41.0638885498047, 0.716700058866091, -80.0566711425781, -1.39725249962432, 218, 45, 'PPL', 'P'),
(167245, 'Slippery Rock Park', 41.024169921875, 0.716006838034344, -80.0155563354492, -1.3965349108686, 218, 45, 'PPL', 'P'),
(152612, 'Sliters', 42.6047210693359, 0.743592659553711, -73.6066665649414, -1.28467868297585, 218, 40, 'PPL', 'P'),
(11975, 'Sloan', 36.1661109924316, 0.631217714459646, -91.144172668457, -1.5907659070708, 218, 4, 'PPL', 'P'),
(38253, 'Sloan', 37.6197204589844, 0.65658798568915, -82.7577819824219, -1.4443957772409, 218, 21, 'PPL', 'P'),
(61808, 'Sloan', 32.560001373291, 0.568279228417804, -90.0597229003906, -1.57183868804555, 218, 30, 'PPL', 'P'),
(68850, 'Sloan', 34.7780609130859, 0.606991670392495, -77.8294372558594, -1.35837993508909, 218, 33, 'PPL', 'P'),
(98125, 'Sloan', 31.1615791320801, 0.543872155975554, -98.9089126586914, -1.72628618546166, 218, 51, 'PPL', 'P'),
(112217, 'Sloan', 33.8474998474121, 0.59075031590562, -86.9558334350586, -1.51766559725754, 218, 2, 'PPL', 'P'),
(117821, 'Sloan', 42.232780456543, 0.737101071238589, -96.227783203125, -1.67949164878983, 218, 16, 'PPL', 'P'),
(123679, 'Sloan', 40.3019409179688, 0.703401563962781, -87.4761123657227, -1.52674617762639, 218, 19, 'PPL', 'P'),
(152609, 'Sloan', 42.8933296203613, 0.748629829018515, -78.7941665649414, -1.37521763792306, 218, 40, 'PPL', 'P'),
(190753, 'Sloan', 35.9436111450195, 0.62733435953712, -115.21639251709, -2.01090540169337, 218, 39, 'PPL', 'P'),
(193177, 'Sloan', 47.4927787780762, 0.828905360598719, -114.328330993652, -1.99540580414911, 218, 31, 'PPL', 'P'),
(194425, 'Sloan', 40.0516700744629, 0.69903351372186, -104.487503051758, -1.8236509554408, 218, 7, 'PPL', 'P'),
(57593, 'Sloan Ford', 36.5808296203613, 0.638455919986373, -91.5497207641602, -1.59784405661601, 218, 29, 'PPL', 'P'),
(14637, 'Sloan Landing', 38.6549987792969, 0.674657001053119, -75.1327819824219, -1.31131442177633, 218, 10, 'PPL', 'P'),
(28622, 'Sloan Station', 39.9550018310547, 0.697346334592267, -88.4069366455078, -1.54299212606614, 218, 18, 'PPL', 'P'),
(38254, 'Sloans Crossing', 37.1508293151855, 0.648404291396418, -86.0972213745117, -1.50267998980367, 218, 21, 'PPL', 'P'),
(38255, 'Sloans Valley', 36.9366683959961, 0.644666478227465, -84.5374984741211, -1.4754576897731, 218, 21, 'PPL', 'P'),
(152610, 'Sloansville', 42.7569389343262, 0.746249362478147, -74.3308334350586, -1.29731777919326, 218, 40, 'PPL', 'P'),
(106344, 'Sloantown', 36.6463890075684, 0.639600147148725, -82.7855606079102, -1.44488060571735, 218, 53, 'PPL', 'P'),
(90857, 'Sloanville', 35.353328704834, 0.617031987439176, -89.9530563354492, -1.56997700528553, 218, 50, 'PPL', 'P'),
(185193, 'Sloat', 39.8666687011719, 0.695804630637221, -120.726387023926, -2.10707294760446, 218, 6, 'PPL', 'P'),
(152611, 'Sloatsburg', 41.1544418334961, 0.718280511814999, -74.1933288574219, -1.29491787157693, 218, 40, 'PPL', 'P'),
(5902, 'Slocomb', 31.108060836792, 0.542938085512723, -85.5944366455078, -1.4939047408538, 218, 2, 'PPL', 'P'),
(68851, 'Slocomb', 35.1772193908691, 0.613958300067061, -78.8238906860352, -1.37573642170341, 218, 33, 'PPL', 'P'),
(11976, 'Slocomb (historical)', 34.5355606079102, 0.602759241630087, -92.7266693115234, -1.61838568389407, 218, 4, 'PPL', 'P'),
(825, 'Slocum', 38.7663917541504, 0.676601175227904, -82.8424987792969, -1.44587436427811, 218, 41, 'PPL', 'P'),
(43098, 'Slocum', 31.2827796936035, 0.545987504829404, -91.6386108398438, -1.59939548110904, 218, 22, 'PPL', 'P'),
(68852, 'Slocum', 35.4558296203613, 0.618820965901436, -76.0894393920898, -1.32801124338864, 218, 33, 'PPL', 'P'),
(98126, 'Slocum', 31.6311092376709, 0.552067002255351, -95.4619369506836, -1.66612511012066, 218, 51, 'PPL', 'P'),
(133144, 'Slocum', 43.2222213745117, 0.754370073011099, -85.9097213745117, -1.49940749745618, 218, 27, 'PPL', 'P'),
(167249, 'Slocum', 41.1319389343262, 0.717887762133239, -76.0461120605469, -1.32725503879711, 218, 45, 'PPL', 'P'),
(169608, 'Slocum', 41.5305595397949, 0.724845004164962, -71.5166702270508, -1.24820136552504, 218, 47, 'PPL', 'P'),
(195623, 'Slocum', 46.5555610656738, 0.812547825709288, -116.015281677246, -2.02484864789659, 218, 17, 'PPL', 'P'),
(121479, 'Slocum Corners', 42.4655609130859, 0.741163856639559, -87.9722213745117, -1.53540491327856, 218, 18, 'PPL', 'P'),
(167250, 'Slocum Corners', 41.1452789306641, 0.71812058899154, -76.0216674804688, -1.32682840039048, 218, 45, 'PPL', 'P'),
(74320, 'Slocum Heights', 38.7705612182617, 0.676673946104691, -82.8497161865234, -1.44600033179767, 218, 41, 'PPL', 'P'),
(126114, 'Slocums Corner', 41.5444412231445, 0.725087285245132, -71.0097198486328, -1.23935341227741, 218, 23, 'PPL', 'P'),
(167252, 'Slonaker', 40.1772193908691, 0.701224762666777, -75.6327819824219, -1.32004106803631, 218, 45, 'PPL', 'P'),
(43099, 'Slone', 32.1222190856934, 0.560638486092312, -93.6602783203125, -1.63468023502372, 218, 22, 'PPL', 'P'),
(18105, 'Slones Ridge', 28.5786094665527, 0.498790830832965, -81.9447174072266, -1.43020512337241, 218, 12, 'PPL', 'P'),
(11977, 'Slonikers Mill', 35.0077781677246, 0.611000992834582, -90.9166717529297, -1.58679526704355, 218, 4, 'PPL', 'P'),
(68854, 'Sloop Point', 34.4083290100098, 0.600538631334151, -77.5999984741211, -1.35437547291599, 218, 33, 'PPL', 'P'),
(5904, 'Sloss', 33.7519416809082, 0.589082511272958, -87.0783309936523, -1.51980358298066, 218, 2, 'PPL', 'P'),
(74321, 'Slough', 39.7994384765625, 0.694631241860932, -82.7616729736328, -1.4444636878487, 218, 41, 'PPL', 'P'),
(185194, 'Sloughhouse', 38.4958305358887, 0.67187899114103, -121.192779541016, -2.11521303263434, 218, 6, 'PPL', 'P'),
(11978, 'Slovak', 34.648609161377, 0.604732311102699, -91.5819396972656, -1.59840638308018, 218, 4, 'PPL', 'P'),
(11979, 'Slovaktown (historical)', 34.6375007629395, 0.604538432975341, -91.5927810668945, -1.59859560067563, 218, 4, 'PPL', 'P'),
(167253, 'Slovan', 40.3591690063477, 0.704400382529615, -80.3899993896484, -1.4030701750256, 218, 45, 'PPL', 'P'),
(176421, 'Slovan', 44.5308303833008, 0.777209608835727, -87.5830612182617, -1.52861278723442, 218, 57, 'PPL', 'P'),
(24907, 'Slover', 31.5536098480225, 0.5507143827377, -81.9402770996094, -1.43012762538469, 218, 13, 'PPL', 'P'),
(185195, 'Sly Park', 38.7213897705078, 0.675815742443413, -120.583610534668, -2.10458102777248, 218, 6, 'PPL', 'P'),
(152613, 'Slyboro', 43.4119415283203, 0.757681314352449, -73.3322219848633, -1.27988872143924, 218, 40, 'PPL', 'P'),
(167254, 'Slykerville', 40.9219398498535, 0.714222586683018, -75.9897232055664, -1.32627086761627, 218, 45, 'PPL', 'P'),
(77268, 'Smacker', 35.0133285522461, 0.611097865319234, -94.664436340332, -1.65220609868337, 218, 42, 'PPL', 'P'),
(11980, 'Smackover', 33.3647193908691, 0.582324207374663, -92.7247161865234, -1.61835159543211, 218, 4, 'PPL', 'P'),
(98128, 'Smada', 29.5811100006104, 0.516287765905272, -95.5800018310547, -1.66818573101411, 218, 51, 'PPL', 'P'),
(61809, 'Smalco', 34.5322189331055, 0.602700918402214, -89.0791702270508, -1.55472481540654, 218, 30, 'PPL', 'P'),
(11983, 'Smale', 34.7102813720703, 0.605808694236282, -91.103889465332, -1.59006283254302, 218, 4, 'PPL', 'P'),
(68855, 'Small', 35.2799987792969, 0.615752138798311, -76.8536071777344, -1.34134848728581, 218, 33, 'PPL', 'P'),
(98127, 'Small', 32.7449989318848, 0.571508044923416, -95.8516693115234, -1.67292722301889, 218, 51, 'PPL', 'P'),
(152614, 'Small Corners', 42.980281829834, 0.750147431365696, -75.4194412231445, -1.31631756935821, 218, 40, 'PPL', 'P'),
(128831, 'Small Point', 43.7380599975586, 0.763373155392221, -69.8408279418945, -1.21895239990491, 218, 26, 'PPL', 'P'),
(128832, 'Small Point Beach', 43.7208290100098, 0.763072417926123, -69.8372192382813, -1.21888941614513, 218, 26, 'PPL', 'P'),
(51489, 'Smallet Manor', 38.6752815246582, 0.675011001741018, -76.579719543457, -1.33656824628717, 218, 25, 'PPL', 'P'),
(57595, 'Smallett', 36.8486099243164, 0.64312956796238, -92.7138900756836, -1.61816264415277, 218, 29, 'PPL', 'P'),
(57594, 'Smalleys Corner', 36.6549987792969, 0.639750416013233, -93.815559387207, -1.63739040090704, 218, 29, 'PPL', 'P'),
(146321, 'Smalleytown', 40.6558303833008, 0.709578100320947, -74.4786071777344, -1.29989691755095, 218, 37, 'PPL', 'P'),
(38256, 'Smallhous', 37.3800010681152, 0.652404093037608, -87.0936126708984, -1.52007029856383, 218, 21, 'PPL', 'P'),
(18104, 'Smallpox Tommies Old Place', 25.8436107635498, 0.45105609842779, -80.7702789306641, -1.40970730509429, 218, 12, 'PPL', 'P'),
(24908, 'Smalls Crossing (historical)', 33.0505599975586, 0.576841091585326, -83.6363906860352, -1.45973039195563, 218, 13, 'PPL', 'P'),
(126115, 'Smalltown', 41.5958290100098, 0.725984171321244, -70.5380630493164, -1.23112144818992, 218, 23, 'PPL', 'P'),
(51490, 'Smallwood', 39.5127792358398, 0.689628094279054, -76.9747161865234, -1.34346223824301, 218, 25, 'PPL', 'P'),
(83674, 'Smallwood', 34.4930610656738, 0.602017484687472, -81.8672180175781, -1.42885250385476, 218, 48, 'PPL', 'P'),
(152615, 'Smallwood', 41.6652793884277, 0.727196309091393, -74.8197174072266, -1.30585041416782, 218, 40, 'PPL', 'P'),
(167256, 'Smallwood', 40.0683288574219, 0.699324264333869, -79.9186096191406, -1.39484287147002, 218, 45, 'PPL', 'P'),
(51491, 'Smallwood Acres', 39.503059387207, 0.689458450917616, -76.9711074829102, -1.34339925448323, 218, 25, 'PPL', 'P'),
(51492, 'Smallwood Estates', 38.5263900756836, 0.672412355728346, -77.1752777099609, -1.34696269717981, 218, 25, 'PPL', 'P'),
(90858, 'Smarden', 35.8333282470703, 0.625409559859265, -87.083610534668, -1.51989572835438, 218, 50, 'PPL', 'P'),
(24909, 'Smarr', 32.985279083252, 0.575701724691963, -83.8822174072266, -1.4640208776298, 218, 13, 'PPL', 'P'),
(106345, 'Smart', 36.9222183227539, 0.644414276872234, -80.1999969482422, -1.39975400683623, 218, 53, 'PPL', 'P'),
(128833, 'Smarts Corner', 44.6761093139648, 0.779745204509592, -69.2944412231445, -1.20941615267356, 218, 26, 'PPL', 'P'),
(123680, 'Smartsburg', 40.0469398498535, 0.698950955728067, -86.82861328125, -1.51544518669869, 218, 19, 'PPL', 'P'),
(90859, 'Smartt', 35.6402816772461, 0.622040261606151, -85.836669921875, -1.4981325090843, 218, 50, 'PPL', 'P'),
(152616, 'Smartville', 43.6413917541504, 0.761685976262628, -75.9627838134766, -1.32580068652582, 218, 40, 'PPL', 'P'),
(185196, 'Smartville', 39.2075004577637, 0.68429997446516, -121.297500610352, -2.11704076009047, 218, 6, 'PPL', 'P'),
(167255, 'Smathers', 40.5400009155273, 0.707556494737468, -79.2083282470703, -1.38244612291181, 218, 45, 'PPL', 'P'),
(112246, 'Smead', 33.7947196960449, 0.589829128484561, -92.817497253418, -1.61997093053294, 218, 4, 'PPL', 'P'),
(11986, 'Smead (historical)', 33.6152801513672, 0.586697317621655, -92.6122207641602, -1.61638817991845, 218, 4, 'PPL', 'P'),
(197568, 'Smead (historical)', 48.0213890075684, 0.83813134956308, -115.855560302734, -2.02206098402555, 218, 31, 'PPL', 'P'),
(11987, 'Smeadley (historical)', 35.5041694641113, 0.619664655334773, -93.6347198486328, -1.63423415554113, 218, 4, 'PPL', 'P'),
(11988, 'Smearny', 33.3972206115723, 0.58289146068685, -92.01611328125, -1.6059841416459, 218, 4, 'PPL', 'P'),
(61812, 'Smedes', 32.6936111450195, 0.570611158847304, -90.9205627441406, -1.58686317765134, 218, 30, 'PPL', 'P'),
(31139, 'Smedley', 38.6330604553223, 0.674274105067393, -86.2158279418945, -1.50475006491899, 218, 19, 'PPL', 'P'),
(106346, 'Smedley', 38.6983299255371, 0.675413272223675, -78.2169418334961, -1.3651431658354, 218, 53, 'PPL', 'P'),
(5905, 'Smelley', 33.3338890075684, 0.581786115676413, -86.0772171020508, -1.50233084938476, 218, 2, 'PPL', 'P'),
(179181, 'Smelter City', 34.7397193908691, 0.606322484589585, -111.995559692383, -1.95469126424593, 218, 5, 'PPL', 'P'),
(195624, 'Smelter Heights', 47.5391693115234, 0.82971502814913, -116.15860748291, -2.02735015510851, 218, 17, 'PPL', 'P'),
(197569, 'Smelter Hill', 47.5213890075684, 0.829404703303108, -111.268058776855, -1.9419939779587, 218, 31, 'PPL', 'P'),
(179180, 'Smelter Town', 33.2911109924316, 0.581039498464809, -111.276390075684, -1.94213938655422, 218, 5, 'PPL', 'P'),
(187370, 'Smeltertown', 38.5475006103516, 0.672780804065159, -106.013893127441, -1.85029148793124, 218, 7, 'PPL', 'P'),
(192228, 'Smeltertown', 31.7833309173584, 0.554723771758814, -106.526107788086, -1.85923132023647, 218, 51, 'PPL', 'P'),
(195625, 'Smelterville', 47.542781829834, 0.829778078487938, -116.180557250977, -2.02773325083131, 218, 17, 'PPL', 'P'),
(11992, 'Smeltzer', 35.4577789306641, 0.618854987784362, -94.3111114501953, -1.64603941602123, 218, 4, 'PPL', 'P'),
(51493, 'Smeltzer', 39.6150016784668, 0.691412212472326, -77.5258331298828, -1.35308104346816, 218, 25, 'PPL', 'P'),
(167257, 'Smeltzer', 40.8069381713867, 0.712215428748452, -79.2591705322266, -1.38333348818702, 218, 45, 'PPL', 'P'),
(185197, 'Smeltzer', 33.730281829834, 0.588704475556221, -117.993606567383, -2.05937693090363, 218, 6, 'PPL', 'P'),
(98131, 'Smetana', 30.6519393920898, 0.534977264513717, -96.4569396972656, -1.68349118411491, 218, 51, 'PPL', 'P'),
(68857, 'Smethport', 36.4263916015625, 0.635760468068076, -81.5019378662109, -1.42247716252122, 218, 33, 'PPL', 'P'),
(167258, 'Smethport', 41.8111114501953, 0.729741558724209, -78.4449996948242, -1.36912352640063, 218, 45, 'PPL', 'P'),
(167260, 'Smicksburg', 40.8697204589844, 0.713311186378966, -79.1711120605469, -1.38179657792194, 218, 45, 'PPL', 'P'),
(38257, 'Smilax', 37.1355590820313, 0.648137775550328, -83.2822189331055, -1.45354892874945, 218, 21, 'PPL', 'P'),
(38258, 'Smile', 38.2574996948242, 0.667719333255408, -83.4902801513672, -1.45718028205383, 218, 21, 'PPL', 'P'),
(98129, 'Smiley', 29.2674999237061, 0.51081423749586, -97.6355590820313, -1.7040619730069, 218, 51, 'PPL', 'P'),
(106347, 'Smiley', 36.6925010681152, 0.640404954430147, -83.2874984741211, -1.45364107412317, 218, 53, 'PPL', 'P'),
(167262, 'Smiley', 41.7805595397949, 0.729208327294948, -75.5877838134766, -1.31925570183084, 218, 45, 'PPL', 'P'),
(24911, 'Smiley (historical)', 31.9111099243164, 0.55695393614516, -81.8027801513672, -1.42772785092642, 218, 13, 'PPL', 'P'),
(157682, 'Smiley (historical)', 41.0774993896484, 0.716937612835326, -84.7941665649414, -1.47993739304272, 218, 41, 'PPL', 'P'),
(24910, 'Smiley Crossroads', 31.8630599975586, 0.556115306717894, -81.767219543457, -1.42710720123438, 218, 13, 'PPL', 'P'),
(43100, 'Smiley Heights', 30.4705600738525, 0.531811598215453, -91.1302795410156, -1.59052342625355, 218, 22, 'PPL', 'P'),
(185199, 'Smiley Park', 34.1983299255371, 0.59687345588393, -117.126670837402, -2.04424604801229, 218, 6, 'PPL', 'P'),
(33983, 'Smileyville', 37.519718170166, 0.654842616489739, -96.8805618286133, -1.69088478509124, 218, 20, 'PPL', 'P'),
(57596, 'Smileyville', 39.8669395446777, 0.695809357748155, -91.5627822875977, -1.59807202320532, 218, 29, 'PPL', 'P'),
(343, 'Smith', 33.1355590820313, 0.578324605470555, -92.6500015258789, -1.61704757860436, 218, 4, 'PPL', 'P'),
(5908, 'Smith', 32.5261116027832, 0.567687740339697, -85.8147201538086, -1.49774941336149, 218, 2, 'PPL', 'P'),
(38259, 'Smith', 36.7358283996582, 0.641161159021675, -83.2594375610352, -1.4531513187987, 218, 21, 'PPL', 'P'),
(51494, 'Smith', 39.3202781677246, 0.686268316826838, -77.2724990844727, -1.34865953026835, 218, 25, 'PPL', 'P'),
(61811, 'Smith', 32.4241714477539, 0.565908548994442, -88.4749984741211, -1.54418002907037, 218, 30, 'PPL', 'P'),
(83676, 'Smith', 34.8211097717285, 0.607743014715034, -81.1155624389648, -1.41573363916698, 218, 48, 'PPL', 'P'),
(90860, 'Smith', 35.8091697692871, 0.624987914879678, -88.5397186279297, -1.54530960884673, 218, 50, 'PPL', 'P'),
(98130, 'Smith', 31.0552806854248, 0.542016898091664, -97.3511123657227, -1.69909744126083, 218, 51, 'PPL', 'P'),
(123681, 'Smith', 41.7108306884766, 0.727991329255809, -86.6691665649414, -1.51266231651761, 218, 19, 'PPL', 'P'),
(167263, 'Smith', 40.4483299255371, 0.705956534133575, -79.2361068725586, -1.38293095138825, 218, 45, 'PPL', 'P'),
(190754, 'Smith', 38.8005599975586, 0.677197523575, -119.326393127441, -2.08263844460299, 218, 39, 'PPL', 'P'),
(193964, 'Smith', 40.6047210693359, 0.708686074513825, -122.053062438965, -2.13022780170216, 218, 6, 'PPL', 'P'),
(5906, 'Smith (historical)', 34.3713912963867, 0.59989394661327, -87.7188873291016, -1.53098340007876, 218, 2, 'PPL', 'P'),
(43101, 'Smith (historical)', 31.913330078125, 0.55699268513902, -92.4875030517578, -1.61421144520148, 218, 22, 'PPL', 'P'),
(68858, 'Smith (historical)', 35.6911087036133, 0.622927360565257, -80.4288864135742, -1.4037488816294, 218, 33, 'PPL', 'P'),
(74322, 'Smith (historical)', 39.8891716003418, 0.69619738031898, -81.8033294677734, -1.42773743830635, 218, 41, 'PPL', 'P'),
(193965, 'Smith (historical)', 40.3097190856934, 0.703537318599347, -123.762496948242, -2.16006306223626, 218, 6, 'PPL', 'P'),
(106348, 'Smith Beach', 37.3624992370605, 0.652098628460576, -75.9905624389648, -1.32628551500227, 218, 53, 'PPL', 'P'),
(33984, 'Smith Center', 39.7791709899902, 0.694277507489142, -98.7847213745117, -1.72411863865045, 218, 20, 'PPL', 'P'),
(11990, 'Smith Chapel', 35.163890838623, 0.613725672945842, -90.8469390869141, -1.58557820242538, 218, 4, 'PPL', 'P'),
(90862, 'Smith Chapel', 36.5444412231445, 0.637820822645416, -85.835563659668, -1.4981132011664, 218, 50, 'PPL', 'P'),
(24912, 'Smith City', 33.2627792358398, 0.580545016029409, -84.7602767944336, -1.47934590496461, 218, 13, 'PPL', 'P'),
(144451, 'Smith Colony', 42.9483299255371, 0.749589765433434, -70.795280456543, -1.23561073883947, 218, 36, 'PPL', 'P'),
(11991, 'Smith Corner', 34.7752799987793, 0.606943134281628, -90.908332824707, -1.58664972528997, 218, 4, 'PPL', 'P'),
(114071, 'Smith Corner', 41.5913887023926, 0.725906673333522, -72.1294403076172, -1.25889622098863, 218, 8, 'PPL', 'P'),
(144452, 'Smith Corner', 42.8933296203613, 0.748629829018515, -70.9891662597656, -1.23899468447858, 218, 36, 'PPL', 'P'),
(152617, 'Smith Corner', 42.4652786254883, 0.741158929791543, -74.1013870239258, -1.29331318386211, 218, 40, 'PPL', 'P'),
(167264, 'Smith Corner', 40.3574981689453, 0.704371220915679, -78.4891662597656, -1.36989437837815, 218, 45, 'PPL', 'P'),
(172534, 'Smith Corner', 44.4666709899902, 0.776089816176376, -72.2716674804688, -1.26137855344069, 218, 55, 'PPL', 'P'),
(185200, 'Smith Corner', 35.478328704834, 0.619213649004169, -119.277778625488, -2.08178996147969, 218, 6, 'PPL', 'P'),
(106349, 'Smith Corners', 37.0588912963867, 0.646799670260618, -82.3841705322266, -1.43787502731184, 218, 53, 'PPL', 'P'),
(152618, 'Smith Corners', 42.9483299255371, 0.749589765433434, -74.8550033569336, -1.3064662701699, 218, 40, 'PPL', 'P'),
(157681, 'Smith Corners', 40.457218170166, 0.706111663267073, -83.0472183227539, -1.44944739435462, 218, 41, 'PPL', 'P'),
(167265, 'Smith Corners', 41.1808280944824, 0.718741038946501, -79.8677825927734, -1.39395577251091, 218, 45, 'PPL', 'P'),
(195626, 'Smith Corrals', 43.3266716003418, 0.756193073356285, -113.245277404785, -1.97650295304784, 218, 17, 'PPL', 'P'),
(18106, 'Smith Creek', 30.1816692352295, 0.526769501902634, -84.6569366455078, -1.47754227911636, 218, 12, 'PPL', 'P'),
(68860, 'Smith Creek', 34.2627792358398, 0.597998308549352, -77.8638916015625, -1.35898127686323, 218, 33, 'PPL', 'P'),
(68862, 'Smith Crossing', 34.3219413757324, 0.599030882683003, -78.6488876342773, -1.37268204224919, 218, 33, 'PPL', 'P'),
(111434, 'Smith Crossing', 39.0541687011719, 0.681623830464767, -79.8177795410156, -1.39308305462169, 218, 58, 'PPL', 'P'),
(128834, 'Smith Crossing', 44.5394401550293, 0.777359877700235, -70.5238876342773, -1.23087404052465, 218, 26, 'PPL', 'P'),
(133145, 'Smith Crossing', 43.0263900756836, 0.750952172068091, -84.2230606079102, -1.46996971371477, 218, 27, 'PPL', 'P'),
(14638, 'Smith Crossroads', 39.0950012207031, 0.682336492372472, -75.7161102294922, -1.3214954203076, 218, 10, 'PPL', 'P'),
(18107, 'Smith Crossroads', 30.9833297729492, 0.540761117769151, -85.7716674804688, -1.49699800245993, 218, 12, 'PPL', 'P'),
(68863, 'Smith Crossroads', 34.6941719055176, 0.605527531004197, -78.3744430541992, -1.36789208071258, 218, 33, 'PPL', 'P'),
(111435, 'Smith Crossroads', 39.5677795410156, 0.690588030693973, -78.2275009155273, -1.36532745658283, 218, 58, 'PPL', 'P'),
(38260, 'Smith Ford', 37.3194389343262, 0.651347084400956, -87.8502807617188, -1.53327664809342, 218, 21, 'PPL', 'P'),
(83677, 'Smith Ford', 34.9966697692871, 0.610807114707224, -81.4855575561523, -1.4221912721782, 218, 48, 'PPL', 'P'),
(57597, 'Smith Ford (historical)', 37.832218170166, 0.660296770402221, -92.8480606079102, -1.62050436169928, 218, 29, 'PPL', 'P'),
(167266, 'Smith Gap', 40.8344383239746, 0.712695396955912, -75.4347229003906, -1.31658428494138, 218, 45, 'PPL', 'P'),
(68864, 'Smith Grove', 35.9638900756836, 0.627688293645991, -80.503059387207, -1.40504344423529, 218, 33, 'PPL', 'P'),
(98133, 'Smith Grove', 31.1388893127441, 0.543476143921459, -95.3852767944336, -1.66478713798901, 218, 51, 'PPL', 'P'),
(83678, 'Smith Heights', 34.8186111450195, 0.607699405452184, -82.432502746582, -1.43871858358713, 218, 48, 'PPL', 'P'),
(126116, 'Smith Highlands', 42.1944389343262, 0.736431885435679, -72.5888900756836, -1.26691513218891, 218, 23, 'PPL', 'P'),
(5910, 'Smith Hill', 33.1222190856934, 0.578091778612255, -87.101936340332, -1.52021557400129, 218, 2, 'PPL', 'P'),
(14639, 'Smith Hill', 38.4949989318848, 0.671864476913089, -75.5133285522461, -1.31795621237694, 218, 10, 'PPL', 'P'),
(98134, 'Smith Hill', 33.5400009155273, 0.585383447097865, -94.2947235107422, -1.64575339252016, 218, 51, 'PPL', 'P'),
(106350, 'Smith Hill', 38.1736106872559, 0.66625519386711, -77.0166702270508, -1.34419447438472, 218, 53, 'PPL', 'P'),
(177700, 'Smith Hill', 39.7783317565918, 0.694262860103146, -105.458061218262, -1.84059039102841, 218, 7, 'PPL', 'P'),
(5911, 'Smith Institute', 34.185001373291, 0.596640828762711, -86.0505599975586, -1.50186559514232, 218, 2, 'PPL', 'P'),
(51495, 'Smith Island', 37.9811096191406, 0.662895416414893, -76.0302810668945, -1.32697873583402, 218, 25, 'PPL', 'P'),
(138154, 'Smith Lake', 45.0830612182617, 0.786847855136833, -94.1147232055664, -1.64261179454025, 218, 28, 'PPL', 'P'),
(189577, 'Smith Lake', 35.5222206115723, 0.61997970729173, -108.139167785645, -1.88738452822608, 218, 38, 'PPL', 'P'),
(106351, 'Smith Lake Terrace', 36.8819389343262, 0.64371126892348, -76.1383285522461, -1.3288645202019, 218, 53, 'PPL', 'P'),
(14640, 'Smith Landing', 38.7936096191406, 0.677076216587347, -75.2736129760742, -1.31377238630442, 218, 10, 'PPL', 'P'),
(51496, 'Smith Landing', 38.9122200012207, 0.679146358281693, -75.8291702270508, -1.32346868951729, 218, 25, 'PPL', 'P'),
(128835, 'Smith Landing', 44.8016700744629, 0.781936653191591, -67.600830078125, -1.1798570619445, 218, 26, 'PPL', 'P'),
(152619, 'Smith Landing', 42.1322212219238, 0.735345981501199, -73.9158325195313, -1.29007464681852, 218, 40, 'PPL', 'P'),
(176423, 'Smith Landing', 44.6891708374023, 0.779973171098902, -92.6916732788086, -1.61777488789806, 218, 57, 'PPL', 'P'),
(74323, 'Smith Mill', 39.9275016784668, 0.696866366384808, -81.8552780151367, -1.42864411149946, 218, 41, 'PPL', 'P'),
(185201, 'Smith Mill', 36.0902786254883, 0.629894189976904, -118.657501220703, -2.07096407849046, 218, 6, 'PPL', 'P'),
(14641, 'Smith Mill Farms', 39.7291717529297, 0.69340485617895, -75.716667175293, -1.32150514084558, 218, 10, 'PPL', 'P'),
(38261, 'Smith Mills', 37.7983283996582, 0.659705282324115, -87.7619400024414, -1.53173481098032, 218, 21, 'PPL', 'P'),
(126117, 'Smith Mills', 41.6388893127441, 0.726735715380864, -70.9916687011719, -1.23903836032046, 218, 23, 'PPL', 'P'),
(152620, 'Smith Mills', 42.4949989318848, 0.741677646992863, -79.105827331543, -1.38065714444954, 218, 40, 'PPL', 'P'),
(167267, 'Smith Mills', 41.1019401550293, 0.71736418466293, -78.6736068725586, -1.37311347434579, 218, 45, 'PPL', 'P'),
(98135, 'Smith Oaks', 33.6483306884766, 0.587274158313766, -96.491943359375, -1.68410211326897, 218, 51, 'PPL', 'P'),
(187371, 'Smith Place', 38.2016716003418, 0.666744949191576, -107.059173583984, -1.86853507350467, 218, 7, 'PPL', 'P'),
(192229, 'Smith Place', 30.7552795410156, 0.536780890361973, -103.207778930664, -1.80131555601052, 218, 51, 'PPL', 'P'),
(208763, 'Smith Place', 47.6586112976074, 0.831799684071417, -123.930000305176, -2.16298654732289, 218, 56, 'PPL', 'P'),
(98136, 'Smith Point', 29.5366706848145, 0.515512153527301, -94.7602767944336, -1.65387883016404, 218, 51, 'PPL', 'P'),
(193966, 'Smith River', 41.9283294677734, 0.731787399073608, -124.14582824707, -2.16675345552676, 218, 6, 'PPL', 'P'),
(90864, 'Smith Shoals Subdivision', 36.4588890075684, 0.636327654801236, -82.4622192382813, -1.43923723420942, 218, 50, 'PPL', 'P'),
(90865, 'Smith Springs', 36.0875015258789, 0.629845720445065, -86.603889465332, -1.51152301620328, 218, 50, 'PPL', 'P'),
(195627, 'Smith Springs', 42.6375007629395, 0.744164773134888, -113.310562133789, -1.97764238652023, 218, 17, 'PPL', 'P'),
(106353, 'Smith Store', 37.6827812194824, 0.657688603588652, -78.5213928222656, -1.37045683800038, 218, 53, 'PPL', 'P'),
(90866, 'Smith Subdivision', 35.1863899230957, 0.614118356048574, -86.9305572509766, -1.51722444462297, 218, 50, 'PPL', 'P'),
(167268, 'Smith Summit', 41.2266693115234, 0.719541119116988, -78.8272171020508, -1.37579447861517, 218, 45, 'PPL', 'P'),
(563, 'Smith Town', 36.7033309936523, 0.640593972288515, -84.5055618286133, -1.47490029015694, 218, 21, 'PPL', 'P'),
(61814, 'Smith Town', 30.8077793121338, 0.537697184224529, -89.3125, -1.55879718818744, 218, 30, 'PPL', 'P'),
(199689, 'Smith Trailer Court', 40.3491706848145, 0.704225878899187, -101.107223510742, -1.76465394781227, 218, 35, 'PPL', 'P'),
(31140, 'Smith Valley', 39.605281829834, 0.691242569110888, -86.1969375610352, -1.50442036557603, 218, 19, 'PPL', 'P'),
(152621, 'Smith Valley', 42.413890838623, 0.740262043715431, -76.7413864135742, -1.33938986546211, 218, 40, 'PPL', 'P'),
(51499, 'Smith Village', 39.3355598449707, 0.686535032410009, -77.2291717529297, -1.34790332567682, 218, 25, 'PPL', 'P'),
(77269, 'Smith Village', 35.4508285522461, 0.618733680796709, -97.4569396972656, -1.70094447663485, 218, 42, 'PPL', 'P'),
(111436, 'Smith Village', 39.0538902282715, 0.681618970195777, -80.4711074829102, -1.40448577830303, 218, 58, 'PPL', 'P'),
(77270, 'Smith-Lee', 33.8869400024414, 0.591438676468378, -96.0244369506836, -1.67594258716313, 218, 42, 'PPL', 'P'),
(24913, 'Smithboro', 33.3052787780762, 0.581286772972023, -83.5838928222656, -1.45881413138259, 218, 13, 'PPL', 'P'),
(28625, 'Smithboro', 38.896110534668, 0.678865195049608, -89.3405609130859, -1.5592869435119, 218, 18, 'PPL', 'P'),
(57600, 'Smithboro', 37.392219543457, 0.652617345661896, -90.8244400024414, -1.58518551932265, 218, 29, 'PPL', 'P'),
(83679, 'Smithboro', 34.2702789306641, 0.598129202916929, -79.3036117553711, -1.38410913385451, 218, 48, 'PPL', 'P'),
(152622, 'Smithboro', 42.0338897705078, 0.733629773915725, -76.4005584716797, -1.33344129569326, 218, 40, 'PPL', 'P'),
(51497, 'Smithbrook Acres', 39.6433296203613, 0.691906628328699, -77.4105606079102, -1.35106915842266, 218, 25, 'PPL', 'P'),
(51498, 'Smithbrooke', 38.6888885498047, 0.675248489131226, -76.6055603027344, -1.33701925261778, 218, 25, 'PPL', 'P'),
(61815, 'Smithburg', 31.0283298492432, 0.541546517264129, -90.290283203125, -1.57586272445266, 218, 30, 'PPL', 'P'),
(111437, 'Smithburg', 39.2891693115234, 0.685725364859598, -80.7344436645508, -1.40908186171229, 218, 58, 'PPL', 'P'),
(146322, 'Smithburg', 40.2088890075684, 0.701777501751023, -74.3533325195313, -1.29771046229599, 218, 37, 'PPL', 'P'),
(5913, 'Smithdale', 34.2005615234375, 0.596912404614872, -86.8597183227539, -1.5159880720869, 218, 2, 'PPL', 'P'),
(11998, 'Smithdale', 35.2608299255371, 0.61541757918637, -90.523063659668, -1.57992550985363, 218, 4, 'PPL', 'P'),
(61816, 'Smithdale', 31.3394393920898, 0.546976403121178, -90.6827774047852, -1.58271304056662, 218, 30, 'PPL', 'P'),
(121480, 'Smithdale', 41.0847206115723, 0.717063646933914, -88.7750015258789, -1.54941607008958, 218, 18, 'PPL', 'P'),
(167278, 'Smithdale', 40.2277793884277, 0.702107201093975, -79.7916717529297, -1.39262738775918, 218, 45, 'PPL', 'P'),
(192230, 'Smithdale', 34.5958290100098, 0.603811123681641, -100.198059082031, -1.74878603508925, 218, 51, 'PPL', 'P'),
(157684, 'Smithdale (historical)', 40.3338890075684, 0.703959163316016, -81.1572189331055, -1.41646068214457, 218, 41, 'PPL', 'P'),
(111438, 'Smithers', 38.1811103820801, 0.666386088234687, -81.3072204589844, -1.41907870265417, 218, 58, 'PPL', 'P'),
(5916, 'Smithfield', 33.5083312988281, 0.584830708013619, -86.8419418334961, -1.51567781381991, 218, 2, 'PPL', 'P'),
(33986, 'Smithfield', 39.4811096191406, 0.689075355194808, -99.8258285522461, -1.74228938676806, 218, 20, 'PPL', 'P'),
(38262, 'Smithfield', 38.3866691589355, 0.669973765697188, -85.2569427490234, -1.48801436115476, 218, 21, 'PPL', 'P'),
(43102, 'Smithfield', 30.545280456543, 0.533115714911751, -91.2944412231445, -1.59338858811231, 218, 22, 'PPL', 'P'),
(57601, 'Smithfield', 37.1688919067383, 0.648719543090456, -94.602783203125, -1.65113004844492, 218, 29, 'PPL', 'P'),
(68867, 'Smithfield', 35.5083312988281, 0.619737293053505, -78.3397216796875, -1.36728607840653, 218, 33, 'PPL', 'P'),
(79144, 'Smithfield', 39.8030586242676, 0.694694425357794, -79.8080596923828, -1.39291341126025, 218, 45, 'PPL', 'P'),
(90867, 'Smithfield', 35.2791709899902, 0.615737691149397, -84.2522201538086, -1.47047864379908, 218, 50, 'PPL', 'P'),
(98137, 'Smithfield', 32.8708305358887, 0.573704220716349, -97.2149963378906, -1.69672176841042, 218, 51, 'PPL', 'P'),
(106355, 'Smithfield', 36.9363899230957, 0.644661617958475, -81.966667175293, -1.43058821909522, 218, 53, 'PPL', 'P'),
(111442, 'Smithfield', 39.499439239502, 0.689395267420754, -80.5619430541992, -1.40607115809995, 218, 58, 'PPL', 'P'),
(121481, 'Smithfield', 40.473331451416, 0.706392893078185, -90.2916717529297, -1.57588695921858, 218, 18, 'PPL', 'P'),
(123683, 'Smithfield', 40.1699981689453, 0.701098728568189, -85.2686080932617, -1.4882179598201, 218, 19, 'PPL', 'P'),
(128836, 'Smithfield', 44.6302795410156, 0.778945324076186, -69.8300018310547, -1.21876344862557, 218, 26, 'PPL', 'P'),
(143027, 'Smithfield', 40.5724983215332, 0.708123681470627, -99.741943359375, -1.74082531395879, 218, 35, 'PPL', 'P'),
(152623, 'Smithfield', 41.8855590820313, 0.731040915020059, -73.6005630493164, -1.28457215653225, 218, 40, 'PPL', 'P'),
(157685, 'Smithfield', 40.2708282470703, 0.702858545416513, -80.7816696166992, -1.40990611006967, 218, 41, 'PPL', 'P'),
(169609, 'Smithfield', 41.9219398498535, 0.731675879202961, -71.5500030517578, -1.24878313306516, 218, 47, 'PPL', 'P'),
(205784, 'Smithfield', 41.8383293151855, 0.730216600083652, -111.831939697266, -1.95183555660904, 218, 52, 'PPL', 'P'),
(14644, 'Smithfield Acres', 38.473331451416, 0.671486308038298, -75.1972198486328, -1.31243907470467, 218, 10, 'PPL', 'P'),
(185202, 'Smithflat', 38.7347183227539, 0.676048369564631, -120.754173278809, -2.10755790923897, 218, 6, 'PPL', 'P'),
(11999, 'Smithland', 33.2319412231445, 0.580006791173104, -93.3827819824219, -1.6298370102653, 218, 4, 'PPL', 'P'),
(31143, 'Smithland', 39.4602813720703, 0.688711833706013, -85.8466720581055, -1.49830707929376, 218, 19, 'PPL', 'P'),
(38263, 'Smithland', 37.1388893127441, 0.648195899041119, -88.4033279418945, -1.54292914230636, 218, 21, 'PPL', 'P'),
(43103, 'Smithland', 30.9099998474121, 0.539481269128286, -91.6636123657227, -1.59983184005365, 218, 22, 'PPL', 'P'),
(90868, 'Smithland', 35.1216697692871, 0.612988776272217, -86.3855590820313, -1.50771243215754, 218, 50, 'PPL', 'P'),
(98138, 'Smithland', 32.8138885498047, 0.572710395576559, -94.1680603027344, -1.64354270249928, 218, 51, 'PPL', 'P'),
(117824, 'Smithland', 42.2291717529297, 0.737038087478808, -95.9305572509766, -1.67430407730246, 218, 16, 'PPL', 'P'),
(167273, 'Smithland', 41.0202789306641, 0.715938927426547, -79.4058303833008, -1.38589318546875, 218, 45, 'PPL', 'P'),
(24914, 'Smithonia', 34.0027809143066, 0.593460481788939, -83.1761093139648, -1.45169696652741, 218, 13, 'PPL', 'P'),
(5915, 'Smithport', 30.4591693878174, 0.531612793240079, -88.1149978637695, -1.53789683311055, 218, 2, 'PPL', 'P'),
(167274, 'Smithport', 40.8358306884766, 0.712719698300859, -78.8766708374023, -1.37665760912446, 218, 45, 'PPL', 'P'),
(61817, 'Smiths', 32.339168548584, 0.564424968530186, -90.6730575561523, -1.58254339720518, 218, 30, 'PPL', 'P'),
(68869, 'Smiths', 34.6527786254883, 0.604805081979486, -78.8677825927734, -1.37650247999097, 218, 33, 'PPL', 'P'),
(117825, 'Smiths', 42.3224983215332, 0.738666943380528, -90.4308319091797, -1.57831576213274, 218, 16, 'PPL', 'P'),
(126118, 'Smiths (historical)', 42.3291702270508, 0.738783390099192, -72.3266677856445, -1.26233848985561, 218, 23, 'PPL', 'P'),
(98143, 'Smiths Bend', 31.8299999237061, 0.555538299578215, -97.3041687011719, -1.69827811975146, 218, 51, 'PPL', 'P'),
(5918, 'Smiths Bridge (historical)', 34.1527786254883, 0.596078435719514, -85.9875030517578, -1.50076504382185, 218, 2, 'PPL', 'P'),
(5917, 'Smiths Chapel', 34.1763916015625, 0.596490559898204, -86.065559387207, -1.50212738387748, 218, 2, 'PPL', 'P'),
(24915, 'Smiths Chapel', 33.1111106872559, 0.577897900484897, -84.3933334350586, -1.47294153517519, 218, 13, 'PPL', 'P'),
(152625, 'Smiths Clove', 41.3461112976074, 0.721625775039275, -74.2011108398438, -1.29505369279253, 218, 40, 'PPL', 'P'),
(68871, 'Smiths Corner', 36.3011093139648, 0.633573879655067, -76.0652770996094, -1.32758953183003, 218, 33, 'PPL', 'P'),
(144453, 'Smiths Corner', 43.3516693115234, 0.756629365721867, -71.7908325195313, -1.25298640021364, 218, 36, 'PPL', 'P'),
(152626, 'Smiths Corner', 42.6316719055176, 0.744063040381247, -78.2525024414063, -1.36576381552744, 218, 40, 'PPL', 'P'),
(167275, 'Smiths Corner', 40.4241714477539, 0.705534889153989, -75.1055603027344, -1.31083931383786, 218, 45, 'PPL', 'P'),
(152627, 'Smiths Corners', 43.0641708374023, 0.751611570753995, -74.376106262207, -1.29810793908869, 218, 40, 'PPL', 'P'),
(167276, 'Smiths Corners', 41.2991714477539, 0.720806520108939, -79.772216796875, -1.39228783472019, 218, 45, 'PPL', 'P'),
(38264, 'Smiths Creek', 38.458610534668, 0.671229379572133, -83.1861114501953, -1.45187153673686, 218, 21, 'PPL', 'P'),
(133146, 'Smiths Creek', 42.913890838623, 0.748988689975403, -82.603889465332, -1.4417098461235, 218, 27, 'PPL', 'P'),
(31144, 'Smiths Crossing', 39.3166694641113, 0.686205333067057, -85.3644409179688, -1.48989055814273, 218, 19, 'PPL', 'P'),
(24916, 'Smiths Crossroad', 32.954719543457, 0.575168360104648, -85.0197219848633, -1.48387407776607, 218, 13, 'PPL', 'P'),
(5926, 'Smiths Crossroads', 33.9688911437988, 0.592868993710832, -85.8847198486328, -1.49897113851157, 218, 2, 'PPL', 'P'),
(24918, 'Smiths Crossroads', 32.8375015258789, 0.573122519755249, -84.9341735839844, -1.48238097650092, 218, 13, 'PPL', 'P'),
(106358, 'Smiths Crossroads', 37.5661087036133, 0.65565228404015, -78.0122222900391, -1.36157013575889, 218, 53, 'PPL', 'P'),
(126119, 'Smiths Ferry', 42.2583312988281, 0.737547017563123, -72.6147232055664, -1.26736600536147, 218, 23, 'PPL', 'P'),
(167277, 'Smiths Ferry', 40.6474990844727, 0.709432691725429, -80.5022201538086, -1.4050287968493, 218, 45, 'PPL', 'P'),
(195628, 'Smiths Ferry', 44.3013916015625, 0.77320514666263, -116.088607788086, -2.02612842995843, 218, 17, 'PPL', 'P'),
(90869, 'Smiths Fork (historical)', 35.2569389343262, 0.615349668578573, -88.0722198486328, -1.53715021589894, 218, 50, 'PPL', 'P'),
(38265, 'Smiths Grove', 37.0525016784668, 0.646688150389971, -86.2077789306641, -1.50460958317148, 218, 21, 'PPL', 'P'),
(24919, 'Smiths Landing', 30.8947200775146, 0.539214586834628, -84.7497177124023, -1.47916161421718, 218, 13, 'PPL', 'P'),
(5919, 'Smiths Mill', 33.560001373291, 0.585732520937747, -86.120002746582, -1.50307759975442, 218, 2, 'PPL', 'P'),
(24920, 'Smiths Mill', 32.9083290100098, 0.574358692554236, -84.9663925170898, -1.48294330296509, 218, 13, 'PPL', 'P'),
(106359, 'Smiths Mill', 38.1719398498535, 0.666226032253174, -77.519172668457, -1.35296479648657, 218, 53, 'PPL', 'P'),
(138155, 'Smiths Mill', 44.1377792358398, 0.770349572183792, -93.7677764892578, -1.63655643201168, 218, 28, 'PPL', 'P'),
(24921, 'Smiths Mill (historical)', 33.3172187805176, 0.581495165327322, -83.8388900756836, -1.46326467303828, 218, 13, 'PPL', 'P'),
(146323, 'Smiths Mills', 41.0144386291504, 0.715836994935824, -74.3733291625977, -1.29805946955685, 218, 37, 'PPL', 'P'),
(106360, 'Smiths Paradise', 37.0280609130859, 0.646261578562368, -79.7249984741211, -1.39146371952087, 218, 53, 'PPL', 'P'),
(171313, 'Smiths Park', 43.935001373291, 0.766810430832159, -96.9966735839844, -1.69291131752274, 218, 49, 'PPL', 'P'),
(5920, 'Smiths Station', 32.5400009155273, 0.567930154577921, -85.0986099243164, -1.48525093204964, 218, 2, 'PPL', 'P'),
(79146, 'Smiths Station', 39.814998626709, 0.694902817713092, -76.9255599975586, -1.34260430089784, 218, 45, 'PPL', 'P'),
(24922, 'Smiths Store', 34.0583305358887, 0.594430005583782, -83.0152816772461, -1.44888999473847, 218, 13, 'PPL', 'P'),
(18108, 'Smiths Subdivision', 28.8063907623291, 0.502766364418722, -81.3022232055664, -1.41899148412847, 218, 12, 'PPL', 'P'),
(83683, 'Smiths Tavern', 34.8638916015625, 0.608489698505665, -81.9388885498047, -1.43010339061877, 218, 48, 'PPL', 'P'),
(197570, 'Smiths Trailer Court', 46.4069404602051, 0.809953906807551, -105.858329772949, -1.84757639519991, 218, 31, 'PPL', 'P'),
(51500, 'Smithsburg', 39.6547203063965, 0.692105433304073, -77.5730590820313, -1.35390529182554, 218, 25, 'PPL', 'P'),
(121482, 'Smithshire', 40.792781829834, 0.71196835397832, -90.7797164916992, -1.58440494680715, 218, 18, 'PPL', 'P'),
(5921, 'Smithson', 33.3097190856934, 0.581364270959744, -86.9524993896484, -1.51760740718773, 218, 2, 'PPL', 'P'),
(123685, 'Smithson', 40.7177810668945, 0.710659343723519, -86.8724975585938, -1.5162111118282, 218, 19, 'PPL', 'P'),
(197571, 'Smithson (historical)', 47.4486083984375, 0.828134442042168, -107.908332824707, -1.88335569812901, 218, 31, 'PPL', 'P'),
(98139, 'Smithson Valley', 29.812780380249, 0.520331176809313, -98.3369369506836, -1.7163033261155, 218, 51, 'PPL', 'P'),
(5922, 'Smithsonia', 34.7941703796387, 0.60727283362458, -87.8791732788086, -1.53378091764583, 218, 2, 'PPL', 'P'),
(24923, 'Smithsonia', 32.8033294677734, 0.572526104829126, -83.5683288574219, -1.4585424889514, 218, 13, 'PPL', 'P'),
(12000, 'Smithton', 33.9416694641113, 0.592393885772362, -93.1266708374023, -1.62536702753366, 218, 4, 'PPL', 'P'),
(28626, 'Smithton', 38.4086112976074, 0.670356728261941, -89.991943359375, -1.57065571188934, 218, 18, 'PPL', 'P'),
(57602, 'Smithton', 38.6800003051758, 0.675093359997729, -93.0927810668945, -1.62477553945555, 218, 29, 'PPL', 'P'),
(128838, 'Smithton', 44.4775009155273, 0.776278834034745, -69.3352813720703, -1.21012894773932, 218, 26, 'PPL', 'P'),
(167279, 'Smithton', 40.1538887023926, 0.700817565336104, -79.7413864135742, -1.39174974302194, 218, 45, 'PPL', 'P'),
(12001, 'Smithton (historical)', 33.9430618286133, 0.592418187117309, -93.1302795410156, -1.62543001129344, 218, 4, 'PPL', 'P'),
(57603, 'Smithton (historical)', 38.9527816772461, 0.679854293078463, -92.3375015258789, -1.61159342469188, 218, 29, 'PPL', 'P'),
(5923, 'Smithtown', 30.8608303070068, 0.538623098756522, -88.208610534668, -1.53953068243931, 218, 2, 'PPL', 'P'),
(61818, 'Smithtown', 31.437219619751, 0.548682990037214, -88.7158279418945, -1.54838329621884, 218, 30, 'PPL', 'P'),
(68874, 'Smithtown', 36.2358283996582, 0.632434512761703, -80.5777816772461, -1.4063475942211, 218, 33, 'PPL', 'P'),
(90871, 'Smithtown', 35.0811080932617, 0.612280841475447, -85.7350006103516, -1.49635804484998, 218, 50, 'PPL', 'P'),
(111439, 'Smithtown', 39.5294418334961, 0.689918911470091, -80.0416717529297, -1.39699071088916, 218, 58, 'PPL', 'P'),
(144454, 'Smithtown', 42.8763885498047, 0.748334151558488, -70.8705596923828, -1.23692460936326, 218, 36, 'PPL', 'P'),
(152628, 'Smithtown', 40.8558311462402, 0.713068772140741, -73.2011108398438, -1.27760040027258, 218, 40, 'PPL', 'P'),
(167282, 'Smithtown', 41.1444396972656, 0.718105941605544, -78.8530578613281, -1.37624548494577, 218, 45, 'PPL', 'P'),
(51501, 'Smithtown Ridge', 39.6594390869141, 0.692187791560784, -76.8436126708984, -1.34117405023441, 218, 25, 'PPL', 'P'),
(38266, 'Smithview', 37.4324989318848, 0.65332035361065, -86.5338897705078, -1.5103012910532, 218, 21, 'PPL', 'P'),
(12005, 'Smithville', 36.0802803039551, 0.629719686346477, -91.3036117553711, -1.59354864409383, 218, 4, 'PPL', 'P'),
(24924, 'Smithville', 31.9002799987793, 0.556764918286791, -84.2519378662109, -1.47047371695107, 218, 13, 'PPL', 'P'),
(31146, 'Smithville', 39.3208312988281, 0.686277970785789, -87.0258331298828, -1.51888732240762, 218, 19, 'PPL', 'P'),
(38267, 'Smithville', 38.0130615234375, 0.663453082347156, -85.5141677856445, -1.49250378496237, 218, 21, 'PPL', 'P'),
(43104, 'Smithville', 31.3244400024414, 0.546714614386023, -92.4100036621094, -1.61285882568383, 218, 22, 'PPL', 'P'),
(51506, 'Smithville', 39.0708312988281, 0.681914647655803, -76.9880599975586, -1.34369513168033, 218, 25, 'PPL', 'P'),
(57605, 'Smithville', 39.3869400024414, 0.687431785328066, -94.5808334350586, -1.65074695272211, 218, 29, 'PPL', 'P'),
(61819, 'Smithville', 34.0699996948242, 0.594633670828146, -88.39111328125, -1.5427159562611, 218, 30, 'PPL', 'P'),
(68875, 'Smithville', 35.4841690063477, 0.619315581494891, -80.8708267211914, -1.4114621950946, 218, 33, 'PPL', 'P'),
(71403, 'Smithville', 39.9858283996582, 0.697884359711491, -74.748893737793, -1.30461430794786, 218, 37, 'PPL', 'P'),
(77271, 'Smithville', 34.4666709899902, 0.601556890976943, -94.6436080932617, -1.65184257719457, 218, 42, 'PPL', 'P'),
(83684, 'Smithville', 34.1980590820313, 0.596868728772995, -82.2605590820313, -1.43571760051277, 218, 48, 'PPL', 'P'),
(90872, 'Smithville', 35.9605598449707, 0.6276301701552, -85.8141708374023, -1.49773982598157, 218, 50, 'PPL', 'P'),
(98141, 'Smithville', 29.523889541626, 0.515289080496493, -97.607780456543, -1.70357714453045, 218, 51, 'PPL', 'P'),
(106361, 'Smithville', 37.6669387817383, 0.657412100888475, -75.8438873291016, -1.32372555140443, 218, 53, 'PPL', 'P'),
(111441, 'Smithville', 39.0738906860352, 0.681968044035659, -81.0944366455078, -1.41536492451406, 218, 58, 'PPL', 'P'),
(113051, 'Smithville', 40.6602783203125, 0.709655731466723, -89.7997207641602, -1.56730079470611, 218, 18, 'PPL', 'P'),
(126120, 'Smithville', 42.3944396972656, 0.739922557255473, -72.0541687011719, -1.2575824836229, 218, 23, 'PPL', 'P'),
(128839, 'Smithville', 44.5369415283203, 0.777316268437385, -67.9577789306641, -1.18608699468252, 218, 26, 'PPL', 'P'),
(133148, 'Smithville', 44.524169921875, 0.777093361854145, -85.1741714477539, -1.48656972942145, 218, 27, 'PPL', 'P'),
(138156, 'Smithville', 46.7036094665527, 0.815131757756938, -92.2161102294922, -1.60947474688666, 218, 28, 'PPL', 'P'),
(144455, 'Smithville', 42.7374992370605, 0.745910075755271, -71.8716735839844, -1.25439734295916, 218, 36, 'PPL', 'P'),
(152630, 'Smithville', 43.8761100769043, 0.765782583809442, -76.1002807617188, -1.32820046098409, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(157688, 'Smithville', 40.8963890075684, 0.713776640358484, -83.2313919067383, -1.45266182979034, 218, 41, 'PPL', 'P'),
(167283, 'Smithville', 40.9716682434082, 0.715090510882275, -79.9194412231445, -1.39485738569796, 218, 45, 'PPL', 'P'),
(172535, 'Smithville', 43.3880615234375, 0.757264529641851, -72.668327331543, -1.26830157385241, 218, 55, 'PPL', 'P'),
(208764, 'Smithville', 45.6488914489746, 0.796723455670092, -121.162780761719, -2.11468945516404, 218, 56, 'PPL', 'P'),
(12004, 'Smithville (historical)', 35.9291687011719, 0.627082291339944, -90.5550003051758, -1.58048290946979, 218, 4, 'PPL', 'P'),
(83685, 'Smithville (historical)', 34.1933288574219, 0.596786170779202, -82.2702789306641, -1.43588724387421, 218, 48, 'PPL', 'P'),
(152631, 'Smithville Center', 42.4122200012207, 0.740232882101495, -75.7286071777344, -1.32171353320088, 218, 40, 'PPL', 'P'),
(152632, 'Smithville Flats', 42.3950004577637, 0.739932344372479, -75.8083267211914, -1.32310490171239, 218, 40, 'PPL', 'P'),
(24925, 'Smithwick', 33.499439239502, 0.584675512301094, -82.1361083984375, -1.4335455263277, 218, 13, 'PPL', 'P'),
(68877, 'Smithwick', 35.726390838623, 0.62354314998831, -77.0366668701172, -1.34454348164558, 218, 33, 'PPL', 'P'),
(98142, 'Smithwick', 30.5605602264404, 0.533382397205409, -98.1447219848633, -1.71294854209033, 218, 51, 'PPL', 'P'),
(202623, 'Smithwick', 43.3013916015625, 0.755751854142686, -103.217781066895, -1.80149012621998, 218, 49, 'PPL', 'P'),
(90873, 'Smithwood', 36.0277786254883, 0.628803359194408, -83.9222183227539, -1.46471902530957, 218, 50, 'PPL', 'P'),
(51507, 'Smithwood Manor', 38.3800010681152, 0.669857385557551, -75.5188903808594, -1.31805328459867, 218, 25, 'PPL', 'P'),
(24931, 'Smithwyck', 33.5022201538086, 0.584724048411961, -82.1291732788086, -1.43342448565616, 218, 13, 'PPL', 'P'),
(57606, 'Smittle', 37.4191703796387, 0.653087726489431, -92.5097198486328, -1.61459920145619, 218, 29, 'PPL', 'P'),
(143028, 'Smittys Mobile Home Plaza', 40.5736083984375, 0.708143055967558, -98.3783264160156, -1.71702570856119, 218, 35, 'PPL', 'P'),
(83686, 'Smoaks', 33.0894393920898, 0.577519665031079, -80.8141708374023, -1.41047336338185, 218, 48, 'PPL', 'P'),
(79148, 'Smock', 39.9980583190918, 0.698097812072861, -79.783332824707, -1.39248184600561, 218, 45, 'PPL', 'P'),
(74325, 'Smock (historical)', 39.4086112976074, 0.687810020781884, -82.4944381713867, -1.43979956067359, 218, 41, 'PPL', 'P'),
(146324, 'Smocks Corners', 40.3563919067383, 0.704351912997775, -74.2361068725586, -1.29566448878854, 218, 37, 'PPL', 'P'),
(31147, 'Smockville', 39.6261100769043, 0.691606090599683, -87.133056640625, -1.52075872570562, 218, 19, 'PPL', 'P'),
(43105, 'Smoke Bend', 30.1083297729492, 0.525489486814201, -91.0202789306641, -1.58860355342371, 218, 22, 'PPL', 'P'),
(123686, 'Smoke Corner', 41.4130592346191, 0.722794236967547, -87.0658264160156, -1.51958533692933, 218, 19, 'PPL', 'P'),
(200210, 'Smoke Creek', 40.4474983215332, 0.705942019905634, -119.665832519531, -2.08856277960592, 218, 39, 'PPL', 'P'),
(24926, 'Smoke Creek Mobile Home Park', 33.7769393920898, 0.58951880363854, -84.0527801513672, -1.4669977590963, 218, 13, 'PPL', 'P'),
(24927, 'Smoke Ridge', 33.5647201538086, 0.585814879194458, -84.4952774047852, -1.47472079309947, 218, 13, 'PPL', 'P'),
(5924, 'Smoke Rise', 33.8916702270508, 0.59152123446217, -86.8202819824219, -1.51529977810317, 218, 2, 'PPL', 'P'),
(24929, 'Smoke Rise', 32.9597206115723, 0.575255645209375, -85.0880584716797, -1.48506677446026, 218, 13, 'PPL', 'P'),
(83687, 'Smoke Rise', 34.6708297729492, 0.605120133936442, -80.7386093139648, -1.40915456601005, 218, 48, 'PPL', 'P'),
(90874, 'Smoke Rise', 35.8313903808594, 0.625375737713421, -84.7055587768555, -1.47839089539771, 218, 50, 'PPL', 'P'),
(146325, 'Smoke Rise', 40.9952812194824, 0.715502635060964, -74.4027786254883, -1.29857345964723, 218, 37, 'PPL', 'P'),
(24930, 'Smoke Rise Plantation', 33.4375, 0.583594468635604, -84.5766677856445, -1.47614132322492, 218, 13, 'PPL', 'P'),
(167284, 'Smoke Run', 40.7947196960449, 0.712002176124164, -78.4277801513672, -1.36882298867161, 218, 45, 'PPL', 'P'),
(179182, 'Smoke Signal', 35.9799995422363, 0.627969456878076, -110.044441223145, -1.92063782286125, 218, 5, 'PPL', 'P'),
(185203, 'Smoke Tree', 34.1352806091309, 0.595773037721509, -116.08943939209, -2.02614294418637, 218, 6, 'PPL', 'P'),
(111443, 'Smokeless', 37.4324989318848, 0.65332035361065, -81.2513885498047, -1.41810425201131, 218, 58, 'PPL', 'P'),
(68879, 'Smokerise', 36.1725006103516, 0.631329234330293, -80.0955581665039, -1.39793120622813, 218, 33, 'PPL', 'P'),
(90875, 'Smokerise', 36.1749992370605, 0.631372843593143, -83.3916702270508, -1.45545921419936, 218, 50, 'PPL', 'P'),
(157689, 'Smoketown', 40.6725006103516, 0.709869050670038, -81.5388870239258, -1.42312204697919, 218, 41, 'PPL', 'P'),
(167287, 'Smoketown', 40.3983306884766, 0.705083882823384, -75.3283309936523, -1.31472739587133, 218, 45, 'PPL', 'P'),
(24932, 'Smoketree', 33.8869400024414, 0.591438676468378, -84.2055587768555, -1.46966424913774, 218, 13, 'PPL', 'P'),
(24933, 'Smokey Acres', 33.3583297729492, 0.582212687504016, -84.8247222900391, -1.48047069105101, 218, 13, 'PPL', 'P'),
(68880, 'Smokey Creek', 35.8166694641113, 0.625118809247256, -81.5699996948242, -1.42366506552545, 218, 33, 'PPL', 'P'),
(106362, 'Smokey Hollow', 37.711109161377, 0.658183019445025, -77.7652816772461, -1.35726020900876, 218, 53, 'PPL', 'P'),
(208765, 'Smokey Point', 48.1525001525879, 0.840419670729731, -122.18138885498, -2.13246752017891, 218, 56, 'PPL', 'P'),
(51508, 'Smoky', 38.6463890075684, 0.674506732188612, -76.6511077880859, -1.33781420620317, 218, 25, 'PPL', 'P'),
(74326, 'Smoky Corners', 39.021671295166, 0.681056643731607, -83.3569412231445, -1.45485307873526, 218, 41, 'PPL', 'P'),
(57607, 'Smoky Hollow', 37.6222190856934, 0.656631594952, -91.6927795410156, -1.60034090329602, 218, 29, 'PPL', 'P'),
(90876, 'Smoky Junction', 36.2872200012207, 0.633331465416842, -84.3630599975586, -1.47241316401492, 218, 50, 'PPL', 'P'),
(38268, 'Smoky Valley', 38.3586082458496, 0.669484010372722, -83.2052764892578, -1.45220602976978, 218, 21, 'PPL', 'P'),
(90877, 'Smoky View Estates', 35.7636108398438, 0.624192761557208, -84.0391693115234, -1.46676020512706, 218, 50, 'PPL', 'P'),
(33990, 'Smolan', 38.7386093139648, 0.676116280172428, -97.6841735839844, -1.7049104561302, 218, 20, 'PPL', 'P'),
(98144, 'Smoot', 30.274169921875, 0.528383943444953, -97.6513900756836, -1.70433827596999, 218, 51, 'PPL', 'P'),
(111444, 'Smoot', 37.8786087036133, 0.661106437952633, -80.6591720581055, -1.40776812434655, 218, 58, 'PPL', 'P'),
(209741, 'Smoot', 42.6205596923828, 0.743869095674862, -110.913612365723, -1.93580772106256, 218, 59, 'PPL', 'P'),
(205788, 'Smoot Farm Estates', 40.9408302307129, 0.71455228602597, -111.881393432617, -1.95269868711833, 218, 52, 'PPL', 'P'),
(126121, 'Smooth Hummocks', 41.2497215270996, 0.719943456178672, -70.1416702270508, -1.22420308831011, 218, 23, 'PPL', 'P'),
(106363, 'Smoots', 38.0166702270508, 0.663516066106936, -77.2786102294922, -1.34876618987001, 218, 53, 'PPL', 'P'),
(106364, 'Smothers', 36.9044418334961, 0.64410401860524, -79.3824996948242, -1.38548598813808, 218, 53, 'PPL', 'P'),
(28629, 'Smothersville', 37.9541702270508, 0.66242523532444, -88.8405609130859, -1.55056029725193, 218, 18, 'PPL', 'P'),
(51509, 'Smugglers Cove', 39.0788917541504, 0.682055329140387, -76.5263900756836, -1.33563747148619, 218, 25, 'PPL', 'P'),
(167288, 'Smullton', 40.9361114501953, 0.714469927769259, -77.4400024414063, -1.35158301535499, 218, 45, 'PPL', 'P'),
(43106, 'Smurney', 32.6066703796387, 0.569093756237204, -92.3752822875977, -1.61225282337778, 218, 22, 'PPL', 'P'),
(179183, 'Smurr', 32.9286117553711, 0.574712693242135, -112.820556640625, -1.96909017731166, 218, 5, 'PPL', 'P'),
(5927, 'Smuteye', 31.9777793884277, 0.558117537804443, -85.6502838134766, -1.49487945781277, 218, 2, 'PPL', 'P'),
(5928, 'Smyer', 31.8933296203613, 0.556643611299138, -88.0288925170898, -1.53639401130742, 218, 2, 'PPL', 'P'),
(192231, 'Smyer', 33.584171295166, 0.586154365654415, -102.162780761719, -1.78307689728511, 218, 51, 'PPL', 'P'),
(83688, 'Smyly', 33.0258293151855, 0.576409459751652, -80.7958297729492, -1.41015325141883, 218, 48, 'PPL', 'P'),
(68882, 'Smyre', 35.2761116027832, 0.615684294769541, -81.126106262207, -1.4159176635983, 218, 33, 'PPL', 'P'),
(5930, 'Smyrna', 33.4566688537598, 0.583929028247545, -85.4458312988281, -1.49131108826817, 218, 2, 'PPL', 'P'),
(12008, 'Smyrna', 35.2508316040039, 0.615243075555942, -91.8444366455078, -1.60298781910345, 218, 4, 'PPL', 'P'),
(14642, 'Smyrna', 39.2997207641602, 0.685909522448977, -75.6050033569336, -1.31955623955986, 218, 10, 'PPL', 'P'),
(18109, 'Smyrna', 30.5997200012207, 0.534065864209665, -85.6780624389648, -1.49536428628922, 218, 12, 'PPL', 'P'),
(24934, 'Smyrna', 33.8838882446289, 0.591385413246576, -84.5144424438477, -1.47505528613238, 218, 13, 'PPL', 'P'),
(31152, 'Smyrna', 39.2638893127441, 0.685284145645999, -85.3772201538086, -1.49011359788402, 218, 19, 'PPL', 'P'),
(38269, 'Smyrna', 38.1324996948242, 0.665537671690416, -85.6519393920898, -1.4949083531106, 218, 21, 'PPL', 'P'),
(43107, 'Smyrna', 32.0919418334961, 0.560110048353013, -93.8886108398438, -1.63866538927891, 218, 22, 'PPL', 'P'),
(61821, 'Smyrna', 31.8700008392334, 0.556236447257979, -90.5091705322266, -1.57968302903638, 218, 30, 'PPL', 'P'),
(68883, 'Smyrna', 34.7591705322266, 0.606661971049543, -76.5277786254883, -1.33566170625211, 218, 33, 'PPL', 'P'),
(79150, 'Smyrna', 39.9463882446289, 0.697195999148732, -76.0438919067383, -1.32721628980325, 218, 45, 'PPL', 'P'),
(83690, 'Smyrna', 35.0424995422363, 0.61160699514063, -81.4063873291016, -1.42080949104661, 218, 48, 'PPL', 'P'),
(90883, 'Smyrna', 35.5777816772461, 0.620949430823655, -86.6980590820313, -1.51316658607002, 218, 50, 'PPL', 'P'),
(98148, 'Smyrna', 32.8490104675293, 0.573323388680468, -95.8217315673828, -1.67240471081302, 218, 51, 'PPL', 'P'),
(117826, 'Smyrna', 40.9422187805176, 0.714576520791889, -93.6094436645508, -1.63379300290656, 218, 16, 'PPL', 'P'),
(133147, 'Smyrna', 43.059440612793, 0.751529012760202, -85.2627792358398, -1.48811622706646, 218, 27, 'PPL', 'P'),
(143029, 'Smyrna', 40.1186103820801, 0.700201842492078, -98.0669403076172, -1.71159099572466, 218, 35, 'PPL', 'P'),
(152635, 'Smyrna', 42.6872215270996, 0.74503256417609, -75.5711135864258, -1.31896475148175, 218, 40, 'PPL', 'P'),
(157690, 'Smyrna', 40.1716690063477, 0.701127890182126, -81.2438888549805, -1.41797335764374, 218, 41, 'PPL', 'P'),
(208766, 'Smyrna', 46.8394393920898, 0.817502437180299, -119.661109924316, -2.08848035477018, 218, 56, 'PPL', 'P'),
(12009, 'Smyrna (historical)', 34.2419395446777, 0.597634587323474, -94.1694412231445, -1.64356680410715, 218, 4, 'PPL', 'P'),
(185204, 'Smyrna (historical)', 36.5166702270508, 0.637336127327022, -119.364166259766, -2.08329771013084, 218, 6, 'PPL', 'P'),
(128840, 'Smyrna Center', 46.1599998474121, 0.805643980057421, -68.101936340332, -1.18860301612237, 218, 26, 'PPL', 'P'),
(14643, 'Smyrna Landing', 39.3080596923828, 0.686055064202549, -75.5938873291016, -1.31936222827444, 218, 10, 'PPL', 'P'),
(128841, 'Smyrna Mills', 46.1294403076172, 0.805110615470106, -68.1647186279297, -1.18969877375288, 218, 26, 'PPL', 'P'),
(98149, 'Smyth Crossing', 29.1202793121338, 0.508244753097124, -99.8869400024414, -1.74335598278464, 218, 51, 'PPL', 'P'),
(31150, 'Smythe', 37.9913902282715, 0.663074846893338, -87.4925003051758, -1.52703220112746, 218, 19, 'PPL', 'P'),
(192788, 'Smyths', 38.5638885498047, 0.673066827566233, -112.990280151367, -1.97205241139215, 218, 52, 'PPL', 'P'),
(31151, 'Snacks', 39.8458290100098, 0.695440909411343, -86.2563934326172, -1.50545806629478, 218, 19, 'PPL', 'P'),
(57608, 'Snadon Ford', 37.3405609130859, 0.65171573247485, -93.7891693115234, -1.63692980719651, 218, 29, 'PPL', 'P'),
(77272, 'Snake Creek', 36.1761093139648, 0.631392218090074, -95.0980606079102, -1.65977426986915, 218, 42, 'PPL', 'P'),
(202625, 'Snake Creek', 45.5847206115723, 0.795603463273659, -100.585563659668, -1.75554926583556, 218, 49, 'PPL', 'P'),
(5931, 'Snake Creek (historical)', 34.6019401550293, 0.603917783283298, -85.7286071777344, -1.49624645840031, 218, 2, 'PPL', 'P'),
(152636, 'Snake Hill', 43.0033302307129, 0.750549701848353, -73.7347183227539, -1.28691360776265, 218, 40, 'PPL', 'P'),
(24935, 'Snake Nation (historical)', 33.7511100769043, 0.589067997045017, -84.4008331298828, -1.47307242954277, 218, 13, 'PPL', 'P'),
(179184, 'Snaketown', 33.1830596923828, 0.579153647517897, -111.918891906738, -1.95335315895622, 218, 5, 'PPL', 'P'),
(38270, 'Snap', 37.4030609130859, 0.652806563257346, -86.1561126708984, -1.50370783682638, 218, 21, 'PPL', 'P'),
(24937, 'Snapfinger', 33.9072189331055, 0.591792610577249, -83.3430633544922, -1.45461086423412, 218, 13, 'PPL', 'P'),
(5932, 'Snead', 34.1194381713867, 0.595496535021332, -86.3955612182617, -1.50788700236699, 218, 2, 'PPL', 'P'),
(24938, 'Snead', 33.565559387207, 0.585829526580453, -82.1208267211914, -1.43327881074453, 218, 13, 'PPL', 'P'),
(18110, 'Sneads', 30.7075004577637, 0.535946988045642, -84.9244384765625, -1.48221106682337, 218, 12, 'PPL', 'P'),
(106366, 'Sneads Corner', 36.9072189331055, 0.644152488137079, -78.1497192382813, -1.36396991021716, 218, 53, 'PPL', 'P'),
(68887, 'Sneads Ferry', 34.5525016784668, 0.603054919090113, -77.3974990844727, -1.35084119183334, 218, 33, 'PPL', 'P'),
(106367, 'Sneads Mobile Home Park', 38.0616683959961, 0.664301432312401, -78.6902770996094, -1.37340442469488, 218, 53, 'PPL', 'P'),
(106368, 'Sneads Spring', 37.1083297729492, 0.647662534453804, -78.1094436645508, -1.36326696884744, 218, 53, 'PPL', 'P'),
(28630, 'Snearlyville', 38.6100006103516, 0.673871634847655, -89.495002746582, -1.56198246200922, 218, 18, 'PPL', 'P'),
(167289, 'Snedekerville', 41.894718170166, 0.731200771264491, -76.8008270263672, -1.34042729986475, 218, 45, 'PPL', 'P'),
(208767, 'Snee Oosh', 48.4225006103516, 0.845132067699599, -122.553062438965, -2.13895444796213, 218, 56, 'PPL', 'P'),
(12011, 'Sneed (historical)', 33.8286094665527, 0.590420616562668, -92.2102813720703, -1.60937301413302, 218, 4, 'PPL', 'P'),
(77273, 'Sneed Acres', 34.6363906860352, 0.604519058478411, -98.3897171020508, -1.71722451353656, 218, 42, 'PPL', 'P'),
(90884, 'Sneed Forest Estates', 36.0227813720703, 0.628716140668708, -86.8925018310547, -1.51656025224711, 218, 50, 'PPL', 'P'),
(90885, 'Sneed Glen', 36.0325012207031, 0.628885784030146, -86.9319381713867, -1.51724854623084, 218, 50, 'PPL', 'P'),
(90886, 'Sneedville', 36.5297203063965, 0.637563894179251, -83.2174987792969, -1.45241934897309, 218, 50, 'PPL', 'P'),
(192232, 'Sneedville', 33.8800010681152, 0.591317569217806, -100.27889251709, -1.75019684467672, 218, 51, 'PPL', 'P'),
(187372, 'Sneffels', 37.9752807617188, 0.662793683661252, -107.749168395996, -1.88057775479595, 218, 7, 'PPL', 'P'),
(117827, 'Snefs', 42.7408294677734, 0.745968199246062, -91.1408309936523, -1.59070758384293, 218, 16, 'PPL', 'P'),
(12013, 'Snell', 35.4555587768555, 0.618816238790501, -91.9250030517578, -1.60439396815901, 218, 4, 'PPL', 'P'),
(61822, 'Snell', 32.1916694641113, 0.561850623862461, -88.5016708374023, -1.54464554962892, 218, 30, 'PPL', 'P'),
(106369, 'Snell', 38.1477813720703, 0.665804387273587, -77.6016693115234, -1.35440463452993, 218, 53, 'PPL', 'P'),
(176424, 'Snell', 45.0586090087891, 0.786421083572148, -89.2850036621094, -1.558317286559, 218, 57, 'PPL', 'P'),
(90887, 'Snell (historical)', 35.8433303833008, 0.62558413006872, -86.5416717529297, -1.5104371122688, 218, 50, 'PPL', 'P'),
(126122, 'Snell Corner', 41.586109161377, 0.725814527959806, -71.0819396972656, -1.24061388642135, 218, 23, 'PPL', 'P'),
(83693, 'Snelling', 33.2397193908691, 0.580142545809671, -81.4561080932617, -1.42167728208782, 218, 48, 'PPL', 'P'),
(185206, 'Snelling', 37.5191688537598, 0.654833029109815, -120.436393737793, -2.10201160995277, 218, 6, 'PPL', 'P'),
(138158, 'Snellman', 46.8894386291504, 0.818375088490491, -95.4127807617188, -1.6652671727755, 218, 28, 'PPL', 'P'),
(176425, 'Snells', 44.1416702270508, 0.770417482791589, -88.4905624389648, -1.54445167150156, 218, 57, 'PPL', 'P'),
(5936, 'Snells Crossroads', 31.5255603790283, 0.550224827150316, -85.4361114501953, -1.49114144490674, 218, 2, 'PPL', 'P'),
(68888, 'Snells Crossroads', 35.9577789306641, 0.627581634044334, -77.9274978637695, -1.36009141556363, 218, 33, 'PPL', 'P'),
(24939, 'Snellville', 33.8572196960449, 0.590919959267058, -84.0199966430664, -1.46642557893609, 218, 13, 'PPL', 'P'),
(126123, 'Snellville (historical)', 42.1152801513672, 0.735050304041173, -72.0994415283203, -1.25837264351832, 218, 23, 'PPL', 'P'),
(106370, 'Snelson (historical)', 37.9744415283203, 0.662779036275257, -77.6933288574219, -1.35600439539674, 218, 53, 'PPL', 'P'),
(24940, 'Snelsons Crossroads', 32.9749984741211, 0.575522294213519, -84.666389465332, -1.47770726194589, 218, 13, 'PPL', 'P'),
(57609, 'Sni Mills', 38.9408302307129, 0.679645700986083, -94.1322174072266, -1.64291712595922, 218, 29, 'PPL', 'P'),
(121483, 'Snicarte', 40.1233291625977, 0.700284200748788, -90.2313919067383, -1.57483487742995, 218, 18, 'PPL', 'P'),
(90888, 'Snider', 36.6213912963867, 0.639163854783143, -87.9127807617188, -1.53436747887592, 218, 50, 'PPL', 'P'),
(111445, 'Snider', 39.4599990844727, 0.688706906857996, -79.7002792358398, -1.39103228742428, 218, 58, 'PPL', 'P'),
(121484, 'Snider', 40.2041702270508, 0.701695143494312, -87.6977767944336, -1.53061495174194, 218, 18, 'PPL', 'P'),
(197572, 'Snider', 47.603889465332, 0.830844607925487, -115.217498779297, -2.01092470961128, 218, 31, 'PPL', 'P'),
(24941, 'Snider (historical)', 34.5747184753418, 0.603442675344828, -84.3708267211914, -1.4725487189144, 218, 13, 'PPL', 'P'),
(90889, 'Snider (historical)', 36.0597190856934, 0.629360825389588, -88.2375030517578, -1.54003495199172, 218, 50, 'PPL', 'P'),
(74327, 'Snidercrest', 39.3019409179688, 0.685948271442837, -84.3333282470703, -1.47189424707651, 218, 41, 'PPL', 'P'),
(83691, 'Sniders Crossroads', 32.8888893127441, 0.57401940583136, -80.8533325195313, -1.41115686367562, 218, 48, 'PPL', 'P'),
(51510, 'Sniders Estates', 39.1122207641602, 0.682637030101487, -76.9916687011719, -1.34375811544012, 218, 25, 'PPL', 'P'),
(176426, 'Sniderville', 44.3516693115234, 0.774082658241811, -88.1911087036133, -1.53922521786228, 218, 57, 'PPL', 'P'),
(12012, 'Snipe', 33.3244400024414, 0.58162119942591, -93.0480575561523, -1.62399496694005, 218, 4, 'PPL', 'P'),
(98150, 'Snipe', 29.1233291625977, 0.508297983029412, -95.4819412231445, -1.66647425053957, 218, 51, 'PPL', 'P'),
(24942, 'Snipesville', 31.7616691589355, 0.554345702752563, -82.751106262207, -1.44427926394321, 218, 13, 'PPL', 'P'),
(157691, 'Snively', 40.7555618286133, 0.711318742409423, -81.6708297729492, -1.42542488237378, 218, 41, 'PPL', 'P'),
(167290, 'Snively Corners', 41.246940612793, 0.719894920067805, -79.6205596923828, -1.38964091891276, 218, 45, 'PPL', 'P'),
(98153, 'Sno-Bird Estates Colonia', 26.2049999237061, 0.457363529153534, -98.3740005493164, -1.71695020794428, 218, 51, 'PPL', 'P'),
(98151, 'Sno-Bird Estates Number 2 Colonia', 26.2059993743896, 0.457380972858674, -98.3779983520508, -1.71701998276484, 218, 51, 'PPL', 'P'),
(185205, 'Snoboy', 37.5113906860352, 0.654697274473248, -121.945281982422, -2.12834667786618, 218, 6, 'PPL', 'P'),
(5933, 'Snoddy', 33.0386085510254, 0.576632499492946, -87.8755569458008, -1.533717800728, 218, 2, 'PPL', 'P'),
(83692, 'Snoddy', 34.9363899230957, 0.609755032918589, -82.0738906860352, -1.43245962239322, 218, 48, 'PPL', 'P'),
(157692, 'Snodes', 40.959171295166, 0.714872397988997, -80.9938888549805, -1.41361003451375, 218, 41, 'PPL', 'P'),
(90890, 'Snodgrass', 36.4452781677246, 0.636090100832001, -83.6258316040039, -1.4595461012082, 218, 50, 'PPL', 'P'),
(106373, 'Snodgrass', 36.7249984741211, 0.640972141163307, -81.8322219848633, -1.42824170785875, 218, 53, 'PPL', 'P'),
(208769, 'Snohomish', 47.9130592346191, 0.836240638347178, -122.096939086914, -2.13099359367361, 218, 56, 'PPL', 'P'),
(202626, 'Snoma (historical)', 44.6483306884766, 0.779260376033143, -103.691673278809, -1.80976110561743, 218, 49, 'PPL', 'P'),
(98152, 'Snook', 30.4886093139648, 0.532126616882896, -96.4641723632813, -1.68361741795058, 218, 51, 'PPL', 'P'),
(167291, 'Snook', 40.7119407653809, 0.710557411232796, -77.3869400024414, -1.35065690108591, 218, 45, 'PPL', 'P'),
(208770, 'Snoose Junction', 47.3925018310547, 0.827155197709346, -121.817497253418, -2.12611641361129, 218, 56, 'PPL', 'P'),
(208771, 'Snoqualmie', 47.5288887023926, 0.829535597670686, -121.824172973633, -2.12623292690898, 218, 56, 'PPL', 'P'),
(208772, 'Snoqualmie Falls', 47.5400009155273, 0.829729542377071, -121.808609008789, -2.1259612844778, 218, 56, 'PPL', 'P'),
(208773, 'Snoqualmie Pass', 47.3925018310547, 0.827155197709346, -121.398887634277, -2.11881029747677, 218, 56, 'PPL', 'P'),
(208774, 'Snoquera', 47.0380592346191, 0.820969007392228, -121.563888549805, -2.12169010672153, 218, 56, 'PPL', 'P'),
(133149, 'Snover', 43.461109161377, 0.758539451434699, -82.970832824707, -1.44811421591292, 218, 27, 'PPL', 'P'),
(12014, 'Snow', 36.2527809143066, 0.632730389958811, -92.8019409179688, -1.6196994212598, 218, 4, 'PPL', 'P'),
(38271, 'Snow', 36.7502784729004, 0.641413360376906, -85.1369400024414, -1.48591991811547, 218, 21, 'PPL', 'P'),
(77274, 'Snow', 34.3958282470703, 0.600320451861847, -95.4124984741211, -1.66526224592748, 218, 42, 'PPL', 'P'),
(133150, 'Snow', 41.9244384765625, 0.731719488465811, -86.4830627441406, -1.5094141920941, 218, 27, 'PPL', 'P'),
(205793, 'Snow', 40.2897186279297, 0.703188244759465, -111.694717407227, -1.94944057584073, 218, 52, 'PPL', 'P'),
(57612, 'Snow (historical)', 39.6163902282715, 0.691436447238245, -92.4155578613281, -1.61295576474751, 218, 29, 'PPL', 'P'),
(195629, 'Snow (historical)', 46.2999992370605, 0.808087430357569, -116.790832519531, -2.03838456361109, 218, 17, 'PPL', 'P'),
(185207, 'Snow Bend', 37.267219543457, 0.650435684096903, -119.125282287598, -2.07912839828626, 218, 6, 'PPL', 'P'),
(68889, 'Snow Camp', 35.8933296203613, 0.626456781378911, -79.4302825927734, -1.38631995703343, 218, 33, 'PPL', 'P'),
(128843, 'Snow Corner', 44.8247184753418, 0.782338923674247, -68.8913879394531, -1.20238154581217, 218, 26, 'PPL', 'P'),
(185208, 'Snow Creek', 33.8899993896484, 0.591492072848234, -116.683326721191, -2.03650823346507, 218, 6, 'PPL', 'P'),
(775, 'Snow Creek (historical)', 35.8886108398438, 0.626374423122201, -80.8811111450195, -1.41164169215207, 218, 33, 'PPL', 'P'),
(68891, 'Snow Geese Dunes', 36.1894416809082, 0.631624911790319, -75.7602767944336, -1.32226627228512, 218, 33, 'PPL', 'P'),
(68892, 'Snow Geese South', 36.1891708374023, 0.631620184679384, -75.7600021362305, -1.32226147859516, 218, 33, 'PPL', 'P'),
(5935, 'Snow Hill', 32.0044403076172, 0.558582858625907, -87.0072174072266, -1.51856241675463, 218, 2, 'PPL', 'P'),
(12015, 'Snow Hill', 33.3877792358398, 0.582726677594402, -92.6538925170898, -1.61711548921215, 218, 4, 'PPL', 'P'),
(18111, 'Snow Hill', 28.7030601501465, 0.500962905018034, -81.1147232055664, -1.41571899178098, 218, 12, 'PPL', 'P'),
(51511, 'Snow Hill', 38.1769409179688, 0.666313317357901, -75.3930587768555, -1.31585710880574, 218, 25, 'PPL', 'P'),
(68897, 'Snow Hill', 36.4161109924316, 0.635581037589632, -78.188606262207, -1.36464861682097, 218, 33, 'PPL', 'P'),
(71404, 'Snow Hill', 39.8699989318848, 0.695862754128012, -75.0330581665039, -1.30957391284591, 218, 37, 'PPL', 'P'),
(74328, 'Snow Hill', 39.3505592346191, 0.686796821145164, -83.7202835083008, -1.46119459792296, 218, 41, 'PPL', 'P'),
(90891, 'Snow Hill', 35.1794395446777, 0.613997049060921, -85.0444412231445, -1.48430550986267, 218, 50, 'PPL', 'P'),
(98157, 'Snow Hill', 32.7747688293457, 0.57202762765209, -94.7653121948242, -1.65396671448002, 218, 51, 'PPL', 'P'),
(106376, 'Snow Hill', 38.8605613708496, 0.678244745094647, -77.6177825927734, -1.35468586434104, 218, 53, 'PPL', 'P'),
(111448, 'Snow Hill', 38.3247184753418, 0.668892522294616, -81.5716705322266, -1.42369422713939, 218, 58, 'PPL', 'P'),
(123687, 'Snow Hill', 40.0919418334961, 0.699736388512559, -84.9630584716797, -1.48288511289527, 218, 19, 'PPL', 'P'),
(51512, 'Snow Hill (historical)', 39.4938888549805, 0.689298394936102, -75.8763885498047, -1.32429280471662, 218, 25, 'PPL', 'P'),
(167292, 'Snow Hill Falls', 41.1511116027832, 0.718222388324208, -75.2041702270508, -1.31256038169233, 218, 45, 'PPL', 'P'),
(51513, 'Snow Hill Manor', 39.0833282470703, 0.682132760549081, -76.8494415283203, -1.34127578298805, 218, 25, 'PPL', 'P'),
(57614, 'Snow Hollow Lake', 37.6288909912109, 0.656748041670663, -90.6852798461914, -1.5827567164085, 218, 29, 'PPL', 'P'),
(83694, 'Snow Junction', 33.6688919067383, 0.587633019270655, -79.4716720581055, -1.38704233947912, 218, 48, 'PPL', 'P'),
(12016, 'Snow Lake', 34.0608291625977, 0.594473614846632, -91.023063659668, -1.58865215611361, 218, 4, 'PPL', 'P'),
(61823, 'Snow Lake Shores', 34.8244400024414, 0.607801138205825, -89.2394409179688, -1.55752206665751, 218, 30, 'PPL', 'P'),
(90892, 'Snow Mayberry Subdivision', 36.1744384765625, 0.631363056476137, -85.584716796875, -1.49373509749236, 218, 50, 'PPL', 'P'),
(185209, 'Snow Point (historical)', 39.4269409179688, 0.68812993300783, -120.814437866211, -2.10860972471149, 218, 6, 'PPL', 'P'),
(128844, 'Snow Settlement', 46.4122200012207, 0.810046052181268, -67.8116683959961, -1.18353688478071, 218, 26, 'PPL', 'P'),
(167293, 'Snow Shoe', 41.0308303833008, 0.716123085015926, -77.9497222900391, -1.3604793049764, 218, 45, 'PPL', 'P'),
(24943, 'Snow Spring', 32.2541694641113, 0.562941454644958, -83.7816696166992, -1.4622659876295, 218, 13, 'PPL', 'P'),
(24944, 'Snow Springs', 34.3402786254883, 0.599350928067003, -84.9763870239258, -1.48311774001649, 218, 13, 'PPL', 'P'),
(185210, 'Snow Tent (historical)', 39.3958282470703, 0.687586914461563, -120.856666564941, -2.10934675454317, 218, 6, 'PPL', 'P'),
(83695, 'Snow Town', 33.584171295166, 0.586154365654415, -79.5152816772461, -1.38780347091866, 218, 48, 'PPL', 'P'),
(187373, 'Snow Water Springs', 39.264720916748, 0.68529865987394, -105.21639251709, -1.83637247649394, 218, 7, 'PPL', 'P'),
(12017, 'Snowball', 35.9063911437988, 0.626684747968222, -92.8216705322266, -1.62004376798875, 218, 4, 'PPL', 'P'),
(197573, 'Snowberg Court', 47.7991714477539, 0.83425292148857, -114.292221069336, -1.99477556707715, 218, 31, 'PPL', 'P'),
(205796, 'Snowbird Lodge', 40.5819396972656, 0.708288464563076, -111.654441833496, -1.948737634471, 218, 52, 'PPL', 'P'),
(51514, 'Snowden', 39.6602783203125, 0.692202438946779, -77.2755584716797, -1.34871292664821, 218, 25, 'PPL', 'P'),
(68900, 'Snowden', 36.4566688537598, 0.636288905807375, -76.10888671875, -1.32835066326957, 218, 33, 'PPL', 'P'),
(83696, 'Snowden', 32.8413887023926, 0.573190363784019, -79.8466720581055, -1.3935873241741, 218, 48, 'PPL', 'P'),
(106378, 'Snowden', 38.730281829834, 0.675970938155937, -77.0516662597656, -1.34480527038073, 218, 53, 'PPL', 'P'),
(111446, 'Snowden', 38.1974983215332, 0.666672111735762, -81.9375, -1.43007915585285, 218, 58, 'PPL', 'P'),
(138159, 'Snowden', 47.4552803039551, 0.828250888760832, -92.5502777099609, -1.61530706967394, 218, 28, 'PPL', 'P'),
(167296, 'Snowden', 40.2783317565918, 0.702989506363118, -79.9652786254883, -1.39565739928942, 218, 45, 'PPL', 'P'),
(193967, 'Snowden', 41.7933311462402, 0.729431233878188, -122.475830078125, -2.13760648897639, 218, 6, 'PPL', 'P'),
(197574, 'Snowden', 48.0269393920898, 0.838228222047732, -104.083610534668, -1.81660170119341, 218, 31, 'PPL', 'P'),
(208775, 'Snowden', 45.8325004577637, 0.799928037409784, -121.352500915527, -2.11800069650539, 218, 56, 'PPL', 'P'),
(51515, 'Snowdens Manor', 39.5722198486328, 0.690665528681695, -77.0047225952148, -1.34398594887137, 218, 25, 'PPL', 'P'),
(167297, 'Snowdenville', 40.1908302307129, 0.701462316636012, -75.6011123657227, -1.31948832895206, 218, 45, 'PPL', 'P'),
(152637, 'Snowdon', 42.7324981689453, 0.745822790650544, -75.063606262207, -1.31010707769615, 218, 40, 'PPL', 'P'),
(57615, 'Snowdon (historical)', 39.8786087036133, 0.696013022992519, -92.9397201538086, -1.62210412256609, 218, 29, 'PPL', 'P'),
(5938, 'Snowdoun', 32.2413902282715, 0.562718414903664, -86.29638671875, -1.50615608081649, 218, 2, 'PPL', 'P'),
(106379, 'Snowflake', 36.6897201538086, 0.64035641831928, -82.4899978637695, -1.43972206268587, 218, 53, 'PPL', 'P'),
(111447, 'Snowflake', 37.7466697692871, 0.658803669137068, -80.5547180175781, -1.40594505742234, 218, 58, 'PPL', 'P'),
(179185, 'Snowflake', 34.5133285522461, 0.602371219059262, -110.077781677246, -1.92121972355943, 218, 5, 'PPL', 'P'),
(68901, 'Snowhill', 34.1036109924316, 0.595220298637263, -78.7538909912109, -1.37451469655333, 218, 33, 'PPL', 'P'),
(187374, 'Snowmass', 39.3316688537598, 0.686467121802212, -106.985557556152, -1.86725023143676, 218, 7, 'PPL', 'P'),
(187375, 'Snowmass Village', 39.2130584716797, 0.684396980107866, -106.937217712402, -1.86640654200342, 218, 7, 'PPL', 'P'),
(18112, 'Snows Corner', 28.0025005340576, 0.488735833110776, -82.2200012207031, -1.43500973229503, 218, 12, 'PPL', 'P'),
(176429, 'Snows Corner', 44.6738891601563, 0.779706455515731, -92.4966735839844, -1.61437150118299, 218, 57, 'PPL', 'P'),
(90893, 'Snows Hill', 35.9841690063477, 0.628042227754863, -85.8766708374023, -1.49883065676407, 218, 50, 'PPL', 'P'),
(24945, 'Snows Mill', 33.8397216796875, 0.590614561269053, -83.5580596923828, -1.45836325821004, 218, 13, 'PPL', 'P'),
(167298, 'Snows Mill', 41.7983283996582, 0.729518452403888, -75.9852828979492, -1.32619336962855, 218, 45, 'PPL', 'P'),
(133151, 'Snowshoe', 47.2305603027344, 0.824328784844445, -88.2413864135742, -1.54010272944146, 218, 27, 'PPL', 'P'),
(185211, 'Snowshoe Springs', 38.2916717529297, 0.668315748181532, -120.281936645508, -2.09931582513933, 218, 6, 'PPL', 'P'),
(197575, 'Snowslip', 48.2594413757324, 0.842286147179713, -113.454437255859, -1.98015348111207, 218, 31, 'PPL', 'P'),
(5939, 'Snowtown', 33.6630592346191, 0.587531219937986, -87.038330078125, -1.51910543530089, 218, 2, 'PPL', 'P'),
(74329, 'Snowville', 39.1680603027344, 0.683611613902402, -82.0911102294922, -1.43276016012224, 218, 41, 'PPL', 'P'),
(106381, 'Snowville', 37.0325012207031, 0.646339076550089, -80.561393737793, -1.40606157072003, 218, 53, 'PPL', 'P'),
(133152, 'Snowville', 46.4997215270996, 0.811573241908374, -87.8191680908203, -1.53273362954716, 218, 27, 'PPL', 'P'),
(144456, 'Snowville', 43.9124984741211, 0.766417681150399, -71.0583267211914, -1.24020176224266, 218, 36, 'PPL', 'P'),
(205799, 'Snowville', 41.9655609130859, 0.732437210379588, -112.708892822266, -1.96714127602594, 218, 52, 'PPL', 'P'),
(98158, 'Snuff Ridge', 30.2944393157959, 0.528737711106257, -95.0861129760742, -1.6595657443558, 218, 51, 'PPL', 'P'),
(152638, 'Snufftown', 41.3230590820313, 0.721223437977591, -74.4305572509766, -1.29905828812368, 218, 40, 'PPL', 'P'),
(167299, 'Snufftown', 40.8561096191406, 0.71307363240973, -76.5808334350586, -1.33658768736313, 218, 45, 'PPL', 'P'),
(14645, 'Snug Harbor', 38.6583290100098, 0.67471512454391, -75.5736083984375, -1.31900829416557, 218, 10, 'PPL', 'P'),
(18113, 'Snug Harbor', 27.202220916748, 0.474768318852124, -80.2213897705078, -1.40012738202106, 218, 12, 'PPL', 'P'),
(51517, 'Snug Harbor', 38.2938919067383, 0.668354497175392, -75.133056640625, -1.3113192154663, 218, 25, 'PPL', 'P'),
(68904, 'Snug Harbor', 35.0661087036133, 0.612019052740292, -77.0763931274414, -1.34523683563538, 218, 33, 'PPL', 'P'),
(71405, 'Snug Harbor', 39.9916687011719, 0.697986292202214, -74.1444396972656, -1.29406459476367, 218, 37, 'PPL', 'P'),
(83698, 'Snug Harbor', 34.6061096191406, 0.603990554160085, -82.938606262207, -1.4475517562907, 218, 48, 'PPL', 'P'),
(114073, 'Snug Harbor', 41.4427795410156, 0.723312954168867, -73.4513931274414, -1.28196865025059, 218, 8, 'PPL', 'P'),
(133154, 'Snug Harbor', 43.0344390869141, 0.751092653815593, -86.1774978637695, -1.50408107885316, 218, 27, 'PPL', 'P'),
(169611, 'Snug Harbor', 41.3888893127441, 0.722372392250878, -71.5205612182617, -1.24826927613283, 218, 47, 'PPL', 'P'),
(208776, 'Snug Harbor', 48.0752792358398, 0.839071911481069, -123.701667785645, -2.1590013930677, 218, 56, 'PPL', 'P'),
(212153, 'Snug Harbor', 60.4891700744629, 1.0557351795982, -149.784164428711, -2.61422683662958, 218, 1, 'PPL', 'P'),
(51518, 'Snug Harbor Estates', 38.5166702270508, 0.672242712366908, -76.1819381713867, -1.32962565164145, 218, 25, 'PPL', 'P'),
(14646, 'Snug Hill', 39.7916717529297, 0.694495686961447, -75.6750030517578, -1.32077796470993, 218, 10, 'PPL', 'P'),
(144457, 'Snumshire', 43.2483291625977, 0.754825739873611, -72.4158325195313, -1.2638947080386, 218, 36, 'PPL', 'P'),
(12018, 'Snyder', 33.2949981689453, 0.581107342493579, -91.6222229003906, -1.59910945760797, 218, 4, 'PPL', 'P'),
(28631, 'Snyder', 39.2825012207031, 0.685608984719961, -87.6675033569336, -1.53008658058167, 218, 18, 'PPL', 'P'),
(57616, 'Snyder', 39.5163917541504, 0.689691144617862, -93.2399978637695, -1.62734495727526, 218, 29, 'PPL', 'P'),
(68903, 'Snyder', 35.6602783203125, 0.622389268867006, -80.1125030517578, -1.39822695026718, 218, 33, 'PPL', 'P'),
(77276, 'Snyder', 34.6588897705078, 0.604911741581143, -98.9513931274414, -1.72702760950914, 218, 42, 'PPL', 'P'),
(106380, 'Snyder', 38.1430587768555, 0.665721962437849, -79.1416702270508, -1.3812827209896, 218, 53, 'PPL', 'P'),
(143030, 'Snyder', 41.7038917541504, 0.727870222005238, -96.788330078125, -1.68927503737034, 218, 35, 'PPL', 'P'),
(152639, 'Snyder', 42.9636116027832, 0.749856481016605, -78.7841720581055, -1.37504320087166, 218, 40, 'PPL', 'P'),
(167300, 'Snyder', 40.4466705322266, 0.705927572256721, -79.2850036621094, -1.38378436135957, 218, 45, 'PPL', 'P'),
(192234, 'Snyder', 32.7177810668945, 0.571033003563973, -100.917221069336, -1.7613377796229, 218, 51, 'PPL', 'P'),
(194426, 'Snyder', 40.3291702270508, 0.703876805059305, -103.595832824707, -1.80808837413676, 218, 7, 'PPL', 'P'),
(205797, 'Snyder', 40.5319404602051, 0.707415813252884, -112.080001831055, -1.95616505759318, 218, 52, 'PPL', 'P'),
(157693, 'Snyder (historical)', 40.9291687011719, 0.71434875393966, -80.6638870239258, -1.40785041602423, 218, 41, 'PPL', 'P'),
(79152, 'Snyder Corner', 39.9197196960449, 0.696730545169214, -76.5283279418945, -1.33567129363204, 218, 45, 'PPL', 'P'),
(152643, 'Snyder Crossing', 43.0752792358398, 0.751805448881352, -75.9913864135742, -1.32629989607216, 218, 40, 'PPL', 'P'),
(209742, 'Snyder Place', 43.4191703796387, 0.757807481609091, -107.557220458984, -1.87722763130268, 218, 59, 'PPL', 'P'),
(194, 'Snyders', 39.6069412231445, 0.691271530987742, -78.0761108398438, -1.36268520130731, 218, 58, 'PPL', 'P'),
(167304, 'Snyders', 40.7211112976074, 0.71071746721431, -75.8619384765625, -1.32404060336139, 218, 45, 'PPL', 'P'),
(152640, 'Snyders Corner', 42.6699981689453, 0.744731959868047, -73.6208267211914, -1.28492582432501, 218, 40, 'PPL', 'P'),
(208777, 'Snyders Corner', 47.6666717529297, 0.831940365556, -122.162216186523, -2.13213289398795, 218, 56, 'PPL', 'P'),
(152641, 'Snyders Corners', 42.3588905334473, 0.739302107300512, -78.9141693115234, -1.37731208096235, 218, 40, 'PPL', 'P'),
(144458, 'Snyders Hill', 43.2877807617188, 0.755514300173451, -71.7122192382813, -1.25161433962003, 218, 36, 'PPL', 'P'),
(51519, 'Snyders Landing', 39.4652786254883, 0.688799052231713, -77.7780609130859, -1.35748324875006, 218, 25, 'PPL', 'P'),
(74331, 'Snyders Mill', 39.9352798461914, 0.697002121021375, -83.8625030517578, -1.46367679721697, 218, 41, 'PPL', 'P'),
(51520, 'Snydersburg', 39.6188888549805, 0.691480056501095, -76.896110534668, -1.34209031080745, 218, 25, 'PPL', 'P'),
(167314, 'Snydersburg', 41.3327789306641, 0.721393081339029, -79.355827331543, -1.38502046757953, 218, 45, 'PPL', 'P'),
(51521, 'Snydersburg Manor', 39.6202812194824, 0.691504357846042, -76.8969421386719, -1.34210482503539, 218, 25, 'PPL', 'P'),
(167306, 'Snydersville', 40.0499992370605, 0.699004352107924, -79.0141677856445, -1.37905738358273, 218, 45, 'PPL', 'P'),
(146326, 'Snydertown', 40.398609161377, 0.705088743092373, -74.8341674804688, -1.30610261552305, 218, 37, 'PPL', 'P'),
(167312, 'Snydertown', 40.3205604553223, 0.703726536194798, -79.3491668701172, -1.38490422059795, 218, 45, 'PPL', 'P'),
(74332, 'Snyderville', 39.9011116027832, 0.696405772674279, -83.9136123657227, -1.46456882302409, 218, 41, 'PPL', 'P'),
(133155, 'Snyderville', 42.836669921875, 0.747640930726741, -82.67138671875, -1.4428878954317, 218, 27, 'PPL', 'P'),
(152642, 'Snyderville', 42.0844383239746, 0.734512012605841, -73.7663879394531, -1.28746634684689, 218, 40, 'PPL', 'P'),
(205798, 'Snyderville', 40.6944389343262, 0.710251946655764, -111.543060302734, -1.9467936600333, 218, 52, 'PPL', 'P'),
(208778, 'Soap Lake', 47.3894386291504, 0.827101734750462, -119.489440917969, -2.08548416538579, 218, 56, 'PPL', 'P'),
(24946, 'Soapstick', 34.5805587768555, 0.603544607835551, -84.8797225952148, -1.48143062746593, 218, 13, 'PPL', 'P'),
(106382, 'Soapstone', 36.6725006103516, 0.640055880590265, -79.6455612182617, -1.39007727785737, 218, 53, 'PPL', 'P'),
(205800, 'Soapstone Summer Home Area', 40.5747184753418, 0.708162430464488, -111.050559997559, -1.9381979081409, 218, 52, 'PPL', 'P'),
(157694, 'Soaptown', 41.1425018310547, 0.7180721194597, -80.8269424438477, -1.41069626996509, 218, 41, 'PPL', 'P'),
(185214, 'Soapweed', 38.8419418334961, 0.67791977286263, -120.676940917969, -2.10620995025322, 218, 6, 'PPL', 'P'),
(208779, 'Sobey', 48.0688896179199, 0.838960391610422, -122.015556335449, -2.12957319670622, 218, 56, 'PPL', 'P'),
(138160, 'Sobieski', 45.9244384765625, 0.801532658545584, -94.4588928222656, -1.64861868753697, 218, 28, 'PPL', 'P'),
(176427, 'Sobieski', 44.7208290100098, 0.780525710446067, -88.0719375610352, -1.53714528905093, 218, 57, 'PPL', 'P'),
(176428, 'Sobieski Corners', 44.7211112976074, 0.780530637294083, -88.0522232055664, -1.53680120863809, 218, 57, 'PPL', 'P'),
(185216, 'Soboba Hot Springs', 33.7997207641602, 0.589916413589289, -116.928329467773, -2.04078433806936, 218, 6, 'PPL', 'P'),
(77277, 'Sobol', 34.1611099243164, 0.596223844315032, -95.2383270263672, -1.66222238070121, 218, 42, 'PPL', 'P'),
(185215, 'Sobrante', 38.0022201538086, 0.663263864751706, -122.348327636719, -2.13538115156951, 218, 6, 'PPL', 'P'),
(5940, 'Socapatoy', 32.9863891601563, 0.575721099188894, -86.0672225952148, -1.50215641233336, 218, 2, 'PPL', 'P'),
(83699, 'Socastee', 33.6833305358887, 0.587885020888803, -78.9986114501953, -1.3787858743096, 218, 48, 'PPL', 'P'),
(169613, 'Social', 42.0038909912109, 0.733106196445415, -71.5088882446289, -1.24806554430944, 218, 47, 'PPL', 'P'),
(24947, 'Social Circle', 33.6561088562012, 0.587409912950333, -83.7183303833008, -1.46116050946101, 218, 13, 'PPL', 'P'),
(12019, 'Social Hill', 34.3319396972656, 0.59920538631343, -92.9130630493164, -1.62163886832365, 218, 4, 'PPL', 'P'),
(79153, 'Social Island', 39.8847198486328, 0.696119682594177, -77.711669921875, -1.35632450735976, 218, 45, 'PPL', 'P'),
(68905, 'Social Plains', 35.8480606079102, 0.625666688062512, -78.2477798461914, -1.3656813906917, 218, 33, 'PPL', 'P'),
(5942, 'Social Town', 31.711669921875, 0.553473051442372, -86.1819381713867, -1.50415857684088, 218, 2, 'PPL', 'P'),
(74333, 'Socialville', 39.3194389343262, 0.686253669440842, -84.331672668457, -1.47186535177869, 218, 41, 'PPL', 'P'),
(5941, 'Society Hill', 32.4263916015625, 0.565947297988303, -85.4452819824219, -1.49130150088825, 218, 2, 'PPL', 'P'),
(51522, 'Society Hill', 38.2677803039551, 0.667898763733852, -76.6658325195313, -1.33807120124836, 218, 25, 'PPL', 'P'),
(61824, 'Society Hill', 31.4086093902588, 0.548183647332824, -89.8888931274414, -1.56885714604716, 218, 30, 'PPL', 'P'),
(83703, 'Society Hill', 34.5125007629395, 0.602356771410348, -79.8511123657227, -1.39366482216182, 218, 48, 'PPL', 'P'),
(146327, 'Society Hill', 40.5338897705078, 0.70744983513581, -74.4583282470703, -1.29954298344207, 218, 37, 'PPL', 'P'),
(111449, 'Society Hill Acres', 39.1769409179688, 0.683766609877844, -81.5027770996094, -1.42249180990722, 218, 58, 'PPL', 'P'),
(169612, 'Sockanosset', 41.7527809143066, 0.728723498818499, -71.4647216796875, -1.24729469233192, 218, 47, 'PPL', 'P'),
(43108, 'Soco', 33.0027809143066, 0.576007189268995, -93.147216796875, -1.62572562217443, 218, 22, 'PPL', 'P'),
(43109, 'Socola', 29.5333309173584, 0.515453863588941, -89.7594375610352, -1.56659772017833, 218, 22, 'PPL', 'P'),
(189578, 'Socorro', 34.0583305358887, 0.594430005583782, -106.890830993652, -1.86559694103204, 218, 38, 'PPL', 'P'),
(192235, 'Socorro', 31.6544399261475, 0.552474199586024, -106.302780151367, -1.85533351766503, 218, 51, 'PPL', 'P'),
(192236, 'Socorro Mission Number 1 Colonia', 31.6359996795654, 0.552152356568288, -106.290000915527, -1.85511047792374, 218, 51, 'PPL', 'P'),
(192237, 'Socorro Village Addition Colonia', 31.6539993286133, 0.552466509708376, -106.305999755859, -1.85538971036403, 218, 51, 'PPL', 'P'),
(24948, 'Socrates (historical)', 33.1344413757324, 0.57830509781557, -84.0286102294922, -1.46657591437963, 218, 13, 'PPL', 'P'),
(18114, 'Socrum', 28.1677799224854, 0.491620502624523, -82.019172668457, -1.43150461282632, 218, 12, 'PPL', 'P'),
(111450, 'Sod', 38.2441711425781, 0.66748670613419, -81.8763885498047, -1.42901255983628, 218, 58, 'PPL', 'P'),
(185217, 'Soda Bay', 39.0011100769043, 0.680697782774719, -122.788063049316, -2.14305598235696, 218, 6, 'PPL', 'P'),
(209743, 'Soda Butte (historical)', 44.8777809143066, 0.783265037943322, -110.152496337891, -1.92252374038719, 218, 59, 'PPL', 'P'),
(68906, 'Soda Hill', 36.2761116027832, 0.633137587289484, -81.6377792358398, -1.42484804168167, 218, 33, 'PPL', 'P'),
(98159, 'Soda Springs', 29.7186107635498, 0.51868760694257, -97.5988922119141, -1.70342201539695, 218, 51, 'PPL', 'P'),
(185222, 'Soda Springs', 36.0391693115234, 0.629002164169782, -118.757217407227, -2.07270445426283, 218, 6, 'PPL', 'P'),
(195630, 'Soda Springs', 42.6544418334961, 0.744460450594914, -111.603889465332, -1.94785532920186, 218, 17, 'PPL', 'P'),
(197576, 'Soda Springs', 45.565559387207, 0.795269036819772, -108.271667480469, -1.88969708415865, 218, 31, 'PPL', 'P'),
(12024, 'Soda Valley', 35.2586097717285, 0.615378830192509, -92.3602828979492, -1.61199103464262, 218, 4, 'PPL', 'P'),
(197577, 'Sodak Mill', 45.4283294677734, 0.79287392289341, -112.599998474121, -1.965240711114, 218, 31, 'PPL', 'P'),
(190758, 'Sodaville', 38.3411102294922, 0.669178612374717, -118.101936340332, -2.06126764211954, 218, 39, 'PPL', 'P'),
(201576, 'Sodaville', 44.4847183227539, 0.776404801554305, -122.870559692383, -2.14449582040031, 218, 43, 'PPL', 'P'),
(90894, 'Soddy', 35.2886085510254, 0.615902407662818, -85.1666717529297, -1.48643883505387, 218, 50, 'PPL', 'P'),
(90895, 'Soddy Lake Heights', 35.2780609130859, 0.615718316652467, -85.1358337402344, -1.48590061019757, 218, 50, 'PPL', 'P'),
(90896, 'Soddy-Daisy', 35.2358283996582, 0.61498122024176, -85.1908264160156, -1.48686041345443, 218, 50, 'PPL', 'P'),
(138162, 'Soderville', 45.2880592346191, 0.790425745482327, -93.2347183227539, -1.62725281190154, 218, 28, 'PPL', 'P'),
(111451, 'Sodom', 37.916389465332, 0.661765836638536, -81.8333282470703, -1.42826101577666, 218, 58, 'PPL', 'P'),
(114074, 'Sodom', 42.035831451416, 0.733663662640596, -73.2980575561523, -1.27929243967117, 218, 8, 'PPL', 'P'),
(128846, 'Sodom', 43.8230590820313, 0.764856669277449, -70.1608276367188, -1.22453744818497, 218, 26, 'PPL', 'P'),
(152645, 'Sodom', 43.6355590820313, 0.76158417692996, -73.9991683959961, -1.29152913224786, 218, 40, 'PPL', 'P'),
(157695, 'Sodom', 41.1819381713867, 0.718760413443431, -80.6427764892578, -1.40748196768742, 218, 41, 'PPL', 'P'),
(172536, 'Sodom', 42.9361114501953, 0.749376512809146, -73.26611328125, -1.27873490689696, 218, 55, 'PPL', 'P'),
(157696, 'Sodom (historical)', 40.0872192382813, 0.699653963676821, -84.0711135864258, -1.46731773790127, 218, 41, 'PPL', 'P'),
(133157, 'Sodus', 42.0436096191406, 0.733799417277163, -86.3691711425781, -1.50742640865646, 218, 27, 'PPL', 'P'),
(152646, 'Sodus', 43.2377815246582, 0.754641648863259, -77.0616683959961, -1.34497984059019, 218, 40, 'PPL', 'P'),
(152647, 'Sodus Center', 43.204719543457, 0.754064608434067, -77.0247192382813, -1.34433495613223, 218, 40, 'PPL', 'P'),
(152648, 'Sodus Point', 43.271671295166, 0.755233136941366, -76.9894409179688, -1.3437192332882, 218, 40, 'PPL', 'P'),
(98160, 'Sodville', 27.9694404602051, 0.488158825971097, -97.4730606079102, -1.70122583960402, 218, 51, 'PPL', 'P'),
(68907, 'Sodyeco', 35.2969398498535, 0.616047816258337, -80.9983291625977, -1.41368753250147, 218, 33, 'PPL', 'P'),
(205801, 'Soffe', 40.6122207641602, 0.708816968881402, -111.88111114502, -1.95269376027031, 218, 52, 'PPL', 'P'),
(189580, 'Sofia', 36.4516716003418, 0.636201687281675, -103.82861328125, -1.81215115953773, 218, 38, 'PPL', 'P'),
(24949, 'Sofkee', 32.7241706848145, 0.57114452343462, -83.6533279418945, -1.46002600283663, 218, 13, 'PPL', 'P'),
(24950, 'Sofkee (historical)', 30.8013896942139, 0.537585664353881, -84.3036117553711, -1.47137559645422, 218, 13, 'PPL', 'P'),
(24955, 'Sofkee Estates', 32.8111114501953, 0.57266192604472, -83.8152770996094, -1.46285254885959, 218, 13, 'PPL', 'P'),
(152650, 'Soft Maple', 43.9219398498535, 0.766582464242848, -75.2416687011719, -1.31321485353021, 218, 40, 'PPL', 'P'),
(38272, 'Soft Shell', 37.4022216796875, 0.652791915871351, -82.9422225952148, -1.44761487320854, 218, 21, 'PPL', 'P'),
(138164, 'Sogn', 44.4063911437988, 0.77503773438774, -92.9277801513672, -1.62189573021079, 218, 28, 'PPL', 'P'),
(189581, 'Soham', 35.4155616760254, 0.618118157689764, -105.493606567383, -1.84121077440434, 218, 38, 'PPL', 'P'),
(167316, 'Soho', 40.4375, 0.705767516275207, -79.982780456543, -1.39596286386645, 218, 45, 'PPL', 'P'),
(197578, 'Sohon', 47.4427795410156, 0.828032709288527, -115.701942443848, -2.01937984659812, 218, 31, 'PPL', 'P'),
(43111, 'Soileau', 30.6511096954346, 0.53496278357529, -92.1166687011719, -1.60773916480426, 218, 22, 'PPL', 'P'),
(133165, 'Sokol Camp', 41.815559387207, 0.729819189869985, -86.7216720581055, -1.51357871024871, 218, 27, 'PPL', 'P'),
(208780, 'Sokulk', 47.0741691589355, 0.821599244464195, -117.210563659668, -2.04571025397962, 218, 56, 'PPL', 'P'),
(18115, 'Solana', 26.9466705322266, 0.470308123237486, -82.0261077880859, -1.43162565349786, 218, 12, 'PPL', 'P'),
(138165, 'Solana', 46.3177795410156, 0.808397755203591, -93.1530609130859, -1.62582762124418, 218, 28, 'PPL', 'P'),
(185223, 'Solana Beach', 32.9911117553711, 0.575803524024632, -117.270278930664, -2.04675248207222, 218, 6, 'PPL', 'P'),
(189582, 'Solano', 35.848331451416, 0.625671415173447, -104.066940307617, -1.81631075084432, 218, 38, 'PPL', 'P'),
(185224, 'Solano City (historical)', 38.2261085510254, 0.667171454440152, -121.869171142578, -2.12701829311445, 218, 6, 'PPL', 'P'),
(106383, 'Solaris', 38.1680603027344, 0.666158321382458, -78.3649978637695, -1.3677272310411, 218, 53, 'PPL', 'P'),
(77278, 'Soldani', 36.7591705322266, 0.64156855608943, -96.7972183227539, -1.68943016650384, 218, 42, 'PPL', 'P'),
(33994, 'Soldier', 39.5361099243164, 0.690035291609727, -95.9638900756836, -1.67488584484259, 218, 20, 'PPL', 'P'),
(38273, 'Soldier', 38.2591705322266, 0.667748494869345, -83.2994384765625, -1.45384946647846, 218, 21, 'PPL', 'P'),
(117829, 'Soldier', 41.985279083252, 0.732781357371453, -95.779167175293, -1.67166182202694, 218, 16, 'PPL', 'P'),
(167315, 'Soldier', 41.0625, 0.716675824100172, -78.8441696166992, -1.37609035581228, 218, 45, 'PPL', 'P'),
(195631, 'Soldier', 43.3702812194824, 0.75695420479583, -114.790832519531, -2.0034779785712, 218, 17, 'PPL', 'P'),
(179186, 'Soldier Camp', 32.4269409179688, 0.565956885368227, -110.740562438965, -1.9327874300703, 218, 5, 'PPL', 'P'),
(202628, 'Soldier Creek', 43.3236083984375, 0.756139610397402, -100.88777923584, -1.76082392269057, 218, 49, 'PPL', 'P'),
(192789, 'Soldier Crossing', 37.6827812194824, 0.657688603588652, -110.216941833496, -1.92364852647358, 218, 52, 'PPL', 'P'),
(128847, 'Soldier Pond', 47.1561088562012, 0.823029361969568, -68.5763931274414, -1.19688384921586, 218, 26, 'PPL', 'P'),
(192790, 'Soldier Summit', 39.9286117553711, 0.696885740881738, -111.077217102051, -1.93866316238334, 218, 52, 'PPL', 'P'),
(176430, 'Soldiers Grove', 43.3952789306641, 0.757390497161412, -90.774169921875, -1.58430814090152, 218, 57, 'PPL', 'P'),
(192238, 'Soldiers Mound (historical)', 33.5226097106934, 0.585079913312623, -100.831481933594, -1.75984134940639, 218, 51, 'PPL', 'P'),
(152651, 'Soldiers Place', 42.9258308410645, 0.749197082330701, -78.873893737793, -1.37660913959262, 218, 40, 'PPL', 'P'),
(212154, 'Soldotna', 60.4877815246582, 1.05571094483228, -151.058334350586, -2.63646529699618, 218, 1, 'PPL', 'P'),
(167317, 'Solebury', 40.3805618286133, 0.704773757714444, -75.0086135864258, -1.30914727443928, 218, 45, 'PPL', 'P'),
(185226, 'Soledad', 36.4247207641602, 0.63573130645414, -121.32527923584, -2.11752558856692, 218, 6, 'PPL', 'P'),
(185227, 'Soledad Sulphur Springs (historical)', 34.4333305358887, 0.600974990278761, -118.359718322754, -2.06576678646512, 218, 6, 'PPL', 'P'),
(185228, 'Solemint', 34.416389465332, 0.600679312818735, -118.451393127441, -2.06736681364804, 218, 6, 'PPL', 'P'),
(198910, 'Solen', 46.3888893127441, 0.809638854850595, -100.798057556152, -1.75925798396961, 218, 34, 'PPL', 'P'),
(5943, 'Soleo', 33.0136108398438, 0.576196207127364, -86.0352783203125, -1.50159887955915, 218, 2, 'PPL', 'P'),
(106386, 'Soles', 37.4927787780762, 0.654372435399286, -76.4372177124023, -1.33408112014515, 218, 53, 'PPL', 'P'),
(12020, 'Solgohachia', 35.2561111450195, 0.615335220929659, -92.6761093139648, -1.61750324546687, 218, 4, 'PPL', 'P'),
(98161, 'Solino', 26.4880599975586, 0.462303859423199, -98.1324996948242, -1.71273522288701, 218, 51, 'PPL', 'P'),
(192239, 'Solis', 29.0611095428467, 0.507212045805419, -103.099166870117, -1.7994199179466, 218, 51, 'PPL', 'P'),
(98164, 'Solis Colonia', 26.2730007171631, 0.458550366893327, -98.6419982910156, -1.72162765092484, 218, 51, 'PPL', 'P'),
(192240, 'Solis Landing', 29.0441703796387, 0.506916401634906, -103.105003356934, -1.7995217838583, 218, 51, 'PPL', 'P'),
(18116, 'Solite (historical)', 30.0625, 0.524689606380795, -81.7608337402344, -1.42699574794276, 218, 12, 'PPL', 'P'),
(31154, 'Solitude', 38.014720916748, 0.663482044224011, -87.8988876342773, -1.53412499805867, 218, 19, 'PPL', 'P'),
(38274, 'Solitude', 37.9730606079102, 0.662754934667392, -85.540283203125, -1.49295958498293, 218, 21, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(43112, 'Solitude', 30.8322200775146, 0.538123756052132, -91.4250030517578, -1.59566732189904, 218, 22, 'PPL', 'P'),
(51523, 'Solitude', 38.7516708374023, 0.676344246761739, -76.1994400024414, -1.32993111621848, 218, 25, 'PPL', 'P'),
(106384, 'Solitude', 37.5636100769043, 0.6556086747773, -79.6066665649414, -1.38939843809551, 218, 53, 'PPL', 'P'),
(205802, 'Solitude', 40.6211090087891, 0.708972098014899, -111.592498779297, -1.94765652422648, 218, 52, 'PPL', 'P'),
(205803, 'Solitude Condominium', 41.2377815246582, 0.719735063823373, -111.949440002441, -1.95388632380645, 218, 52, 'PPL', 'P'),
(106385, 'Solitude Trails', 37.3930587768555, 0.652631993047892, -75.9447174072266, -1.32548536825275, 218, 53, 'PPL', 'P'),
(117832, 'Sollberg', 42.7388916015625, 0.745934377100218, -93.6366729736328, -1.63426824400308, 218, 16, 'PPL', 'P'),
(51525, 'Sollers', 38.3883285522461, 0.670002727574042, -76.4927825927734, -1.3350509102561, 218, 25, 'PPL', 'P'),
(51526, 'Sollers Point', 39.2333297729492, 0.684750781058683, -76.5138931274414, -1.33541935859291, 218, 25, 'PPL', 'P'),
(51527, 'Solley', 39.1708297729492, 0.683659950276187, -76.5547180175781, -1.33613188734256, 218, 25, 'PPL', 'P'),
(51528, 'Solley Heights', 39.1477813720703, 0.68325767979353, -76.5719375610352, -1.33643242507158, 218, 25, 'PPL', 'P'),
(43113, 'Solley Hill', 32.8672218322754, 0.573641236956569, -94.0361099243164, -1.64123973394664, 218, 22, 'PPL', 'P'),
(51529, 'Solley Park', 39.1813888549805, 0.68384424102362, -76.5508270263672, -1.33606397673477, 218, 25, 'PPL', 'P'),
(197579, 'Sollid (historical)', 48.1769409179688, 0.840846242557334, -111.495826721191, -1.94596927851786, 218, 31, 'PPL', 'P'),
(121485, 'Sollitt', 41.2933311462402, 0.720704587618216, -87.6347198486328, -1.52951440042147, 218, 18, 'PPL', 'P'),
(98165, 'Solms', 29.6655597686768, 0.517761692410577, -98.1705627441406, -1.71339954842093, 218, 51, 'PPL', 'P'),
(12021, 'Solo', 35.5872192382813, 0.621114147337076, -92.9633331298828, -1.62251624674478, 218, 4, 'PPL', 'P'),
(57617, 'Solo', 37.2333297729492, 0.649844196018797, -91.9530563354492, -1.60488359032542, 218, 29, 'PPL', 'P'),
(68908, 'Solo', 36.2819404602051, 0.633239320043125, -81.6177825927734, -1.42449903442081, 218, 33, 'PPL', 'P'),
(90898, 'Solo', 35.5838890075684, 0.621056023846285, -89.5997161865234, -1.56381005630729, 218, 50, 'PPL', 'P'),
(189583, 'Solo', 36.339168548584, 0.634238138609959, -105.950561523438, -1.8491861429208, 218, 38, 'PPL', 'P'),
(68909, 'Solola Valley', 35.496940612793, 0.619538488078131, -83.5008316040039, -1.45736443964321, 218, 33, 'PPL', 'P'),
(33996, 'Solomon', 38.9194412231445, 0.679272392380281, -97.3708267211914, -1.69944152167366, 218, 20, 'PPL', 'P'),
(117833, 'Solomon', 40.9052810668945, 0.713931836071008, -95.4416732788086, -1.6657714423279, 218, 16, 'PPL', 'P'),
(121486, 'Solomon', 40.2488899230957, 0.702475649430787, -88.8227767944336, -1.55024990582688, 218, 18, 'PPL', 'P'),
(179187, 'Solomon', 32.8125, 0.572686160810639, -109.633331298828, -1.9134626010943, 218, 5, 'PPL', 'P'),
(212155, 'Solomon', 64.5608291625977, 1.1267990367049, -164.439163208008, -2.87000481720406, 218, 1, 'PPL', 'P'),
(167319, 'Solomon Gap', 41.1791687011719, 0.718712077069646, -75.8833312988281, -1.32441397854622, 218, 45, 'PPL', 'P'),
(5944, 'Solomon Heights', 31.2394409179688, 0.545231100500794, -85.4258270263672, -1.49096194784926, 218, 2, 'PPL', 'P'),
(33997, 'Solomon Rapids', 39.4736099243164, 0.688944460827231, -98.1922225952148, -1.71377758413767, 218, 20, 'PPL', 'P'),
(51530, 'Solomons', 38.3183288574219, 0.668781002423969, -76.4544372558594, -1.33438165787416, 218, 25, 'PPL', 'P'),
(83700, 'Solomons Crossroads', 32.7944412231445, 0.572370975695629, -81.3225021362305, -1.41934541823734, 218, 48, 'PPL', 'P'),
(106387, 'Solomons Store', 37.6394386291504, 0.656932132681015, -77.459716796875, -1.35192709576782, 218, 53, 'PPL', 'P'),
(117834, 'Solon', 41.8072204589844, 0.729673648116412, -91.4938888549805, -1.59686960597315, 218, 16, 'PPL', 'P'),
(128849, 'Solon', 44.9494400024414, 0.784515724970251, -69.85888671875, -1.21926758501993, 218, 26, 'PPL', 'P'),
(133158, 'Solon', 44.809440612793, 0.782072274670103, -85.7611083984375, -1.4968137117125, 218, 27, 'PPL', 'P'),
(152652, 'Solon', 42.5969390869141, 0.743456838338117, -76.017219543457, -1.32675076924471, 218, 40, 'PPL', 'P'),
(157697, 'Solon', 41.389720916748, 0.722386906478819, -81.4413909912109, -1.42142042020068, 218, 41, 'PPL', 'P'),
(185230, 'Solon (historical)', 34.9544410705566, 0.610070084875545, -117.79638671875, -2.05593479519471, 218, 6, 'PPL', 'P'),
(133159, 'Solon Center', 43.2486114501953, 0.754830666721628, -85.6113891601563, -1.49420061805091, 218, 27, 'PPL', 'P'),
(121487, 'Solon Mills', 42.4422187805176, 0.740756459571804, -88.2733306884766, -1.54066026221567, 218, 18, 'PPL', 'P'),
(176432, 'Solon Springs', 46.353328704834, 0.809018205158552, -91.8222198486328, -1.60260006284873, 218, 57, 'PPL', 'P'),
(185231, 'Solromar', 34.0499992370605, 0.594284596988264, -118.952781677246, -2.07611769467393, 218, 6, 'PPL', 'P'),
(493, 'Solsberry', 39.0833282470703, 0.682132760549081, -86.7561111450195, -1.51417978570674, 218, 19, 'PPL', 'P'),
(106388, 'Solsburg', 38.4030609130859, 0.67025985577729, -78.6533279418945, -1.37275954023691, 218, 53, 'PPL', 'P'),
(152654, 'Solsville', 42.9105606079102, 0.748930566484612, -75.5180587768555, -1.31803877037073, 218, 40, 'PPL', 'P'),
(185232, 'Solvang', 34.5958290100098, 0.603811123681641, -120.136672973633, -2.09678049578158, 218, 6, 'PPL', 'P'),
(152655, 'Solvay', 43.0580596923828, 0.751504911152337, -76.2077789306641, -1.33007665797205, 218, 40, 'PPL', 'P'),
(38276, 'Solway', 37.6211090087891, 0.65661222045507, -86.1766662597656, -1.50406656462522, 218, 21, 'PPL', 'P'),
(90899, 'Solway', 35.9799995422363, 0.627969456878076, -84.1813888549805, -1.46924240442107, 218, 50, 'PPL', 'P'),
(138168, 'Solway', 47.5200004577637, 0.829380468537189, -95.1288909912109, -1.6603123615674, 218, 28, 'PPL', 'P'),
(185233, 'Solyo', 37.6094398498535, 0.656408555210706, -121.263328552246, -2.11644434516434, 218, 6, 'PPL', 'P'),
(192792, 'Soma', 39.5858306884766, 0.69090308265093, -112.161109924316, -1.95758066087061, 218, 52, 'PPL', 'P'),
(117835, 'Somber', 43.4225006103516, 0.757865605099882, -93.3988876342773, -1.63011810691836, 218, 16, 'PPL', 'P'),
(179188, 'Sombrero Butte', 32.7261085510254, 0.571178345580464, -110.481666564941, -1.92826884464876, 218, 5, 'PPL', 'P'),
(189584, 'Sombrillo', 35.9799995422363, 0.627969456878076, -106.039436340332, -1.85073730109772, 218, 38, 'PPL', 'P'),
(189585, 'Sombrio (historical)', 34.8772201538086, 0.608722325626883, -105.141387939453, -1.83506339966011, 218, 38, 'PPL', 'P'),
(71406, 'Somerdale', 39.8438911437988, 0.695407087265499, -75.023063659668, -1.30939947579451, 218, 37, 'PPL', 'P'),
(157699, 'Somerdale', 40.5663909912109, 0.708017088447997, -81.3608322143555, -1.42001440430317, 218, 41, 'PPL', 'P'),
(79155, 'Somerfield', 39.7538909912109, 0.693836288275543, -79.3916702270508, -1.38564604411959, 218, 45, 'PPL', 'P'),
(106389, 'Somers', 37.7880592346191, 0.659526051582752, -76.5666732788086, -1.33634054601397, 218, 53, 'PPL', 'P'),
(114075, 'Somers', 41.985279083252, 0.732781357371453, -72.4466705322266, -1.26443293289491, 218, 8, 'PPL', 'P'),
(117836, 'Somers', 42.3783302307129, 0.739641394023388, -94.4297180175781, -1.64810949113655, 218, 16, 'PPL', 'P'),
(152656, 'Somers', 41.3280601501465, 0.721310723082318, -73.6861114501953, -1.2860652577974, 218, 40, 'PPL', 'P'),
(176435, 'Somers', 42.6402816772461, 0.744213309245754, -87.9102783203125, -1.53432380303404, 218, 57, 'PPL', 'P'),
(197580, 'Somers', 48.0802803039551, 0.839159196585796, -114.220558166504, -1.99352481347119, 218, 31, 'PPL', 'P'),
(43114, 'Somers (historical)', 30.8019409179688, 0.537595285023319, -91.8080596923828, -1.60235292149957, 218, 22, 'PPL', 'P'),
(128851, 'Somers Corner', 46.8766708374023, 0.818152248486278, -67.9166717529297, -1.18536953908485, 218, 26, 'PPL', 'P'),
(68910, 'Somers Crossroads', 36.0833282470703, 0.629772882989251, -80.8966674804688, -1.41191320142521, 218, 33, 'PPL', 'P'),
(167332, 'Somers Lane', 41.9674987792969, 0.732471032525432, -77.1108322143555, -1.34583791109341, 218, 45, 'PPL', 'P'),
(71408, 'Somers Point', 39.3175010681152, 0.686219847294998, -74.5950012207031, -1.30192837683046, 218, 37, 'PPL', 'P'),
(5946, 'Somerset', 31.021110534668, 0.541420516455055, -85.8927764892578, -1.49911175341712, 218, 2, 'PPL', 'P'),
(24951, 'Somerset', 32.4119415283203, 0.565695096633072, -81.7652816772461, -1.42707337908854, 218, 13, 'PPL', 'P'),
(28632, 'Somerset', 37.6544418334961, 0.657193987995197, -88.4572219848633, -1.54386977080338, 218, 18, 'PPL', 'P'),
(34004, 'Somerset', 38.6049995422363, 0.673784349742928, -94.7686080932617, -1.65402423875956, 218, 20, 'PPL', 'P'),
(38275, 'Somerset', 37.0919418334961, 0.647376510952729, -84.6041717529297, -1.47662135801141, 218, 21, 'PPL', 'P'),
(43115, 'Somerset', 32.1761093139648, 0.5615790480103, -91.23388671875, -1.59233171263371, 218, 22, 'PPL', 'P'),
(51537, 'Somerset', 38.3950004577637, 0.670119174292706, -75.1669387817383, -1.31191057038635, 218, 25, 'PPL', 'P'),
(68913, 'Somerset', 36.3541717529297, 0.634499993924142, -78.9791717529297, -1.37844658758672, 218, 33, 'PPL', 'P'),
(74336, 'Somerset', 39.8069381713867, 0.694762136228509, -82.2972183227539, -1.43635742496466, 218, 41, 'PPL', 'P'),
(98166, 'Somerset', 29.226110458374, 0.510091855050176, -98.6575012207031, -1.72189822809159, 218, 51, 'PPL', 'P'),
(106391, 'Somerset', 38.2075004577637, 0.666846681945217, -78.2183303833008, -1.36516740060132, 218, 53, 'PPL', 'P'),
(123688, 'Somerset', 40.6691703796387, 0.709810927179247, -85.8283309936523, -1.49798696733073, 218, 19, 'PPL', 'P'),
(126124, 'Somerset', 41.7694396972656, 0.729014249430509, -71.1291732788086, -1.24143826793678, 218, 23, 'PPL', 'P'),
(133162, 'Somerset', 42.0483283996582, 0.733881775533874, -84.3766708374023, -1.47265071798415, 218, 27, 'PPL', 'P'),
(146329, 'Somerset', 40.497501373291, 0.706814737794853, -74.4888916015625, -1.30007641460842, 218, 37, 'PPL', 'P'),
(152658, 'Somerset', 43.3474998474121, 0.756556594845081, -78.5561065673828, -1.37106270714837, 218, 40, 'PPL', 'P'),
(167320, 'Somerset', 40.0083312988281, 0.69827710939325, -79.0783309936523, -1.38017724282111, 218, 45, 'PPL', 'P'),
(172537, 'Somerset', 42.9502792358398, 0.749623787316359, -72.9869384765625, -1.27386238736655, 218, 55, 'PPL', 'P'),
(176437, 'Somerset', 45.124439239502, 0.787570037845435, -92.6733322143555, -1.61745477593503, 218, 57, 'PPL', 'P'),
(187376, 'Somerset', 38.9263916015625, 0.679393699367934, -107.469718933105, -1.87570044157558, 218, 7, 'PPL', 'P'),
(193968, 'Somerset', 41.8525009155273, 0.730463941169893, -121.98999786377, -2.12912711722363, 218, 6, 'PPL', 'P'),
(199691, 'Somerset', 40.8252792358398, 0.71253554071148, -100.860557556152, -1.7603488147521, 218, 35, 'PPL', 'P'),
(208781, 'Somerset', 47.565559387207, 0.830175621859659, -122.155563354492, -2.13201678016442, 218, 56, 'PPL', 'P'),
(106392, 'Somerset Beach', 38.3411102294922, 0.669178612374717, -77.1833267211914, -1.34710317892731, 218, 53, 'PPL', 'P'),
(133163, 'Somerset Center', 42.0511093139648, 0.73393031164474, -84.4136123657227, -1.47329546928406, 218, 27, 'PPL', 'P'),
(205812, 'Somerset Estates Place', 40.6191711425781, 0.708938275869055, -111.82861328125, -1.95177749969727, 218, 52, 'PPL', 'P'),
(205804, 'Somerset Farm', 41.0102806091309, 0.715764423796119, -111.902778625488, -1.95307192914511, 218, 52, 'PPL', 'P'),
(205805, 'Somerset Garden Condominium', 40.769718170166, 0.711565817179555, -111.853889465332, -1.95221865233184, 218, 52, 'PPL', 'P'),
(51539, 'Somerset Heights', 38.9688911437988, 0.680135456310549, -77.0950012207031, -1.34556160813032, 218, 25, 'PPL', 'P'),
(24952, 'Somerset Hills', 34.0238914489746, 0.593828930125751, -83.9741668701172, -1.46562569850269, 218, 13, 'PPL', 'P'),
(128853, 'Somerset Junction', 45.6072196960449, 0.795996146376391, -69.7980575561523, -1.21820591585137, 218, 26, 'PPL', 'P'),
(146331, 'Somerset Park', 40.047779083252, 0.698965603114063, -74.8916702270508, -1.30710622777985, 218, 37, 'PPL', 'P'),
(205806, 'Somerset Place Condominium', 41.0191688537598, 0.715919552929616, -111.910003662109, -1.95319802982272, 218, 52, 'PPL', 'P'),
(201577, 'Somerset West', 45.5472183227539, 0.794948924856745, -122.866668701172, -2.14442790979251, 218, 43, 'PPL', 'P'),
(146332, 'Somersetin', 40.7400016784668, 0.711047166557262, -74.5766677856445, -1.30160839802549, 218, 37, 'PPL', 'P'),
(51540, 'Somersett Town (historical)', 38.1502799987793, 0.665847996536437, -75.7699966430664, -1.32243591564656, 218, 25, 'PPL', 'P'),
(114077, 'Somersville', 41.982780456543, 0.732737748108603, -72.4883270263672, -1.2651599758725, 218, 8, 'PPL', 'P'),
(185234, 'Somersville', 37.9569396972656, 0.662473571698225, -121.863327026367, -2.1269162940447, 218, 6, 'PPL', 'P'),
(144459, 'Somersworth', 43.2616691589355, 0.755058566731911, -70.8658294677734, -1.23684205136947, 218, 36, 'PPL', 'P'),
(74338, 'Somerton', 39.9011116027832, 0.696405772674279, -81.1369400024414, -1.4161067480357, 218, 41, 'PPL', 'P'),
(106393, 'Somerton', 36.5680618286133, 0.63823307998216, -76.7516708374023, -1.33956936251958, 218, 53, 'PPL', 'P'),
(167325, 'Somerton', 40.1233291625977, 0.700284200748788, -75.0152816772461, -1.30926365457892, 218, 45, 'PPL', 'P'),
(179189, 'Somerton', 32.5963897705078, 0.56891432575876, -114.708892822266, -2.00204786106583, 218, 5, 'PPL', 'P'),
(111452, 'Somervilla', 39.2638893127441, 0.685284145645999, -81.6191711425781, -1.42452326918673, 218, 58, 'PPL', 'P'),
(5947, 'Somerville', 34.4730606079102, 0.60166841084759, -86.7986068725586, -1.51492147607033, 218, 2, 'PPL', 'P'),
(31155, 'Somerville', 38.2763900756836, 0.66804903259836, -87.3777770996094, -1.52502990346188, 218, 19, 'PPL', 'P'),
(61825, 'Somerville', 33.7919387817383, 0.589780592373695, -90.2655563354492, -1.57543115919802, 218, 30, 'PPL', 'P'),
(74339, 'Somerville', 39.563060760498, 0.690505672437263, -84.6386108398438, -1.47722243346944, 218, 41, 'PPL', 'P'),
(90900, 'Somerville', 35.2436103820801, 0.615117041457354, -89.3499984741211, -1.55945166002532, 218, 50, 'PPL', 'P'),
(98168, 'Somerville', 30.3458309173584, 0.529634663761395, -96.5280609130859, -1.68473248349899, 218, 51, 'PPL', 'P'),
(106394, 'Somerville', 38.521671295166, 0.672329997471635, -77.6097183227539, -1.35454511627743, 218, 53, 'PPL', 'P'),
(126126, 'Somerville', 42.3875007629395, 0.739801450004902, -71.0999984741211, -1.24092907153636, 218, 23, 'PPL', 'P'),
(128854, 'Somerville', 44.3091697692871, 0.773340901299196, -69.4894409179688, -1.21281953938863, 218, 26, 'PPL', 'P'),
(146333, 'Somerville', 40.5741691589355, 0.708152843084564, -74.6102828979492, -1.30219509241363, 218, 37, 'PPL', 'P'),
(152660, 'Somerville', 44.2830581665039, 0.772885167857656, -75.5569381713867, -1.31871734381648, 218, 40, 'PPL', 'P'),
(167327, 'Somerville', 40.0516700744629, 0.69903351372186, -75.1516723632813, -1.31164412111929, 218, 45, 'PPL', 'P'),
(193969, 'Somes Bar', 41.3763885498047, 0.722154212778574, -123.474998474121, -2.15504526726839, 218, 6, 'PPL', 'P'),
(128856, 'Somesville', 44.3622207641602, 0.77426681583119, -68.334716796875, -1.19266580152334, 218, 26, 'PPL', 'P'),
(185235, 'Somis', 34.2572212219238, 0.597901302906646, -118.995277404785, -2.07685938503751, 218, 6, 'PPL', 'P'),
(185236, 'Somis (historical)', 34.2486114501953, 0.597751034042138, -119.003608703613, -2.07700479363303, 218, 6, 'PPL', 'P'),
(12022, 'Sommer (historical)', 35.3244400024414, 0.616527784465796, -93.4377822875977, -1.63079694668022, 218, 4, 'PPL', 'P'),
(98169, 'Sommers Mill', 30.9697208404541, 0.54052359708943, -97.4313888549805, -1.70049853031032, 218, 51, 'PPL', 'P'),
(205808, 'Sommerset Hollow', 41.0133285522461, 0.715817620438894, -111.906936645508, -1.95314450028481, 218, 52, 'PPL', 'P'),
(205809, 'Sommerset South Place', 40.6175003051758, 0.708909114255119, -111.82861328125, -1.95177749969727, 218, 52, 'PPL', 'P'),
(5949, 'Sommerville', 33.1983299255371, 0.579420163363987, -87.5805587768555, -1.52856911139255, 218, 2, 'PPL', 'P'),
(38277, 'Somo', 38.5966682434082, 0.673638941147409, -83.7425003051758, -1.46158235417767, 218, 21, 'PPL', 'P'),
(121489, 'Somonauk', 41.6336097717285, 0.726643570007147, -88.6811065673828, -1.5477772939128, 218, 18, 'PPL', 'P'),
(106395, 'Sonans', 36.8858299255371, 0.643779179531277, -79.317497253418, -1.3843514815137, 218, 53, 'PPL', 'P'),
(192241, 'Soncy', 35.1888885498047, 0.614161965311424, -101.941940307617, -1.77922250423944, 218, 51, 'PPL', 'P'),
(43116, 'Sondheimer', 32.5499992370605, 0.568104658208349, -91.1758270263672, -1.59131837983894, 218, 22, 'PPL', 'P'),
(83702, 'Sondleys (historical)', 34.3241691589355, 0.599069764834918, -81.4833297729492, -1.42215239002629, 218, 48, 'PPL', 'P'),
(167328, 'Sonestown', 41.3536109924316, 0.721756669406852, -76.554443359375, -1.3361270936526, 218, 45, 'PPL', 'P'),
(128857, 'Songo Lock', 43.9324989318848, 0.766766754990281, -70.570556640625, -1.23168856834406, 218, 26, 'PPL', 'P'),
(112287, 'Songwood', 33.792781829834, 0.589795306338717, -84.5950012207031, -1.47646130202989, 218, 13, 'PPL', 'P'),
(43117, 'Songy (historical)', 30.0152797698975, 0.523865457891957, -90.649169921875, -1.58212647933653, 218, 22, 'PPL', 'P'),
(43118, 'Soniat', 30.170280456543, 0.526570730216773, -91.1611099243164, -1.5910615179518, 218, 22, 'PPL', 'P'),
(24953, 'Sonja Heights', 32.586109161377, 0.568734895280316, -83.6527786254883, -1.46001641545671, 218, 13, 'PPL', 'P'),
(167329, 'Sonman', 40.3950004577637, 0.705025759332593, -78.6594390869141, -1.37286619983857, 218, 45, 'PPL', 'P'),
(195632, 'Sonna', 43.6097183227539, 0.761133170599355, -116.455833435059, -2.03253772659587, 218, 17, 'PPL', 'P'),
(197581, 'Sonnette', 45.4130592346191, 0.79260740704732, -105.830833435059, -1.84709649357147, 218, 31, 'PPL', 'P'),
(176440, 'Sono Junction', 44.9894409179688, 0.785213872650015, -92.6786117553711, -1.61754692130875, 218, 57, 'PPL', 'P'),
(179190, 'Sonoita', 31.6794395446777, 0.55291052524112, -110.654716491699, -1.93128913564102, 218, 5, 'PPL', 'P'),
(5950, 'Sonoma', 34.0750007629395, 0.594720955932873, -85.9027786254883, -1.49928632362658, 218, 2, 'PPL', 'P'),
(51541, 'Sonoma', 39.0011100769043, 0.680697782774719, -77.1138916015625, -1.34589130747327, 218, 25, 'PPL', 'P'),
(98170, 'Sonoma', 32.3402786254883, 0.564444343027117, -96.6097183227539, -1.68615767415635, 218, 51, 'PPL', 'P'),
(133166, 'Sonoma', 42.232780456543, 0.737101071238589, -85.2280578613281, -1.48751022476041, 218, 27, 'PPL', 'P'),
(185237, 'Sonoma', 38.2919387817383, 0.668320408713439, -122.456939697266, -2.13727678963343, 218, 6, 'PPL', 'P'),
(68914, 'Sonoma (historical)', 35.4708290100098, 0.619082754636591, -82.8850021362305, -1.44661618779976, 218, 33, 'PPL', 'P'),
(185240, 'Sonoma Vista', 38.3102798461914, 0.668640520676467, -122.509170532227, -2.13818838967457, 218, 6, 'PPL', 'P'),
(12023, 'Sonora', 36.1652793884277, 0.631203200231705, -94.0447235107422, -1.64139006939017, 218, 4, 'PPL', 'P'),
(38278, 'Sonora', 37.524169921875, 0.654920314214542, -85.8930587768555, -1.49911668026514, 218, 21, 'PPL', 'P'),
(61826, 'Sonora', 33.8450012207031, 0.59070670664277, -88.9991683959961, -1.55332852004701, 218, 30, 'PPL', 'P'),
(74340, 'Sonora', 39.9841690063477, 0.697855397834636, -81.9044418334961, -1.42950218200269, 218, 41, 'PPL', 'P'),
(139460, 'Sonora', 40.4980583190918, 0.706824458332832, -95.6591720581055, -1.6695675121457, 218, 29, 'PPL', 'P'),
(140890, 'Sonora', 46.0666694641113, 0.804015057576674, -96.7411117553711, -1.68845092217102, 218, 34, 'PPL', 'P'),
(152662, 'Sonora', 42.3338890075684, 0.738865748355903, -77.1669387817383, -1.34681715542623, 218, 40, 'PPL', 'P'),
(179191, 'Sonora', 33.1652793884277, 0.578843322671875, -110.995277404785, -1.93723304487797, 218, 5, 'PPL', 'P'),
(185246, 'Sonora', 37.9841690063477, 0.662948812794749, -120.38111114502, -2.10104674668983, 218, 6, 'PPL', 'P'),
(192242, 'Sonora', 30.5666694641113, 0.533489023517553, -100.643058776855, -1.75655274493431, 218, 51, 'PPL', 'P'),
(121491, 'Sonora (historical)', 40.4941711425781, 0.706756614304062, -91.3547210693359, -1.59444066990095, 218, 18, 'PPL', 'P'),
(185241, 'Sonora Hills', 37.9769401550293, 0.662822645538107, -120.365280151367, -2.10077044372674, 218, 6, 'PPL', 'P'),
(185242, 'Sonora Junction', 38.3486099243164, 0.669309506742295, -119.450828552246, -2.08481025247195, 218, 6, 'PPL', 'P'),
(185244, 'Sonora Meadows', 38.0111083984375, 0.663418993885203, -120.28556060791, -2.09937907521522, 218, 6, 'PPL', 'P'),
(185245, 'Sonora Ranchettes', 37.9544410705566, 0.662429962435375, -120.324996948242, -2.10006736919896, 218, 6, 'PPL', 'P'),
(179192, 'Sonora Town', 33.3352813720703, 0.58181041702136, -111.788887023926, -1.95108414570747, 218, 5, 'PPL', 'P'),
(24954, 'Sonoraville', 34.4480590820313, 0.601232051902981, -84.8088912963867, -1.48019438808791, 218, 13, 'PPL', 'P'),
(61827, 'Sontag', 31.6522197723389, 0.552435450592163, -90.2041702270508, -1.57435976949148, 218, 30, 'PPL', 'P'),
(152663, 'Sonyea', 42.6788902282715, 0.744887155580572, -77.8274993896484, -1.35834611294324, 218, 40, 'PPL', 'P'),
(133167, 'Soo Hill', 45.7947196960449, 0.799268638723881, -87.1102828979492, -1.52036124891292, 218, 27, 'PPL', 'P'),
(133168, 'Soo Junction', 46.3355598449707, 0.808708080049612, -85.2594375610352, -1.48805790383859, 218, 27, 'PPL', 'P'),
(77279, 'Sooner', 35.2324981689453, 0.614923096750969, -97.8533325195313, -1.70786283651466, 218, 42, 'PPL', 'P'),
(77280, 'Soonerville', 35.9275016784668, 0.627053196305035, -96.8372192382813, -1.6901283141836, 218, 42, 'PPL', 'P'),
(71410, 'Sooy Place', 39.8675003051758, 0.695819144865162, -74.6524963378906, -1.3029318559292, 218, 37, 'PPL', 'P'),
(18117, 'Sopchoppy', 30.0597190856934, 0.524641070269929, -84.4888916015625, -1.47460933980785, 218, 12, 'PPL', 'P'),
(77281, 'Soper', 34.0327796936035, 0.593984059259248, -95.6969375610352, -1.6702266445155, 218, 42, 'PPL', 'P'),
(24956, 'Soperton', 32.3769416809082, 0.565084234058035, -82.5924987792969, -1.44151104114813, 218, 13, 'PPL', 'P'),
(176442, 'Soperton', 45.4383316040039, 0.793048493102864, -88.6361083984375, -1.54699192770733, 218, 57, 'PPL', 'P'),
(167330, 'Sopertown', 41.875560760498, 0.730866411389631, -76.9047164916992, -1.34224051309293, 218, 45, 'PPL', 'P'),
(121493, 'Soperville', 41.0086097717285, 0.715735262182183, -90.3977813720703, -1.57773892144062, 218, 18, 'PPL', 'P'),
(90901, 'Sopha (historical)', 35.6652793884277, 0.622476553971734, -85.5213928222656, -1.49262988563998, 218, 50, 'PPL', 'P'),
(38279, 'Sophi', 38.2280616760254, 0.667205542902105, -83.0147171020508, -1.44888014104243, 218, 21, 'PPL', 'P'),
(68915, 'Sophia', 35.8230590820313, 0.625230329117903, -79.8611068725586, -1.39383925921322, 218, 33, 'PPL', 'P'),
(111453, 'Sophia', 37.7075004577637, 0.658120035685245, -81.2508316040039, -1.41809453147333, 218, 58, 'PPL', 'P'),
(191014, 'Sophia', 36.5288887023926, 0.63754937995131, -100.396392822266, -1.75224761187414, 218, 42, 'PPL', 'P'),
(24957, 'Sophia (historical)', 34.3194389343262, 0.598987206841126, -84.8000030517578, -1.48003925895441, 218, 13, 'PPL', 'P'),
(157700, 'Sophia (historical)', 41.0186080932617, 0.71590976581261, -84.7074966430664, -1.47842471754355, 218, 41, 'PPL', 'P'),
(187377, 'Sopris (historical)', 37.1347198486328, 0.648123128164333, -104.563888549805, -1.82498413388249, 218, 7, 'PPL', 'P'),
(187378, 'Sopris Plaza (historical)', 37.1405601501465, 0.648225060655056, -104.574996948242, -1.82517801200985, 218, 7, 'PPL', 'P'),
(24958, 'Soquee (historical)', 34.6194381713867, 0.604223181281303, -83.5299987792969, -1.45787350288557, 218, 13, 'PPL', 'P'),
(185247, 'Soquel', 36.9880599975586, 0.645563430882603, -121.955558776855, -2.1285260417656, 218, 6, 'PPL', 'P'),
(167331, 'Soradoville', 40.6797218322754, 0.709995084768626, -77.4127807617188, -1.35110790741652, 218, 45, 'PPL', 'P'),
(90902, 'Sorby (historical)', 35.3027801513672, 0.61614974874906, -87.8819427490234, -1.53382925401962, 218, 50, 'PPL', 'P'),
(205810, 'Sorensen', 40.6205596923828, 0.708962510634975, -111.845832824707, -1.95207803742629, 218, 52, 'PPL', 'P'),
(185248, 'Sorensens', 38.7744407653809, 0.676741656975406, -119.90193939209, -2.09268362191866, 218, 6, 'PPL', 'P'),
(185249, 'Sorenson', 37.6455612182617, 0.657038992019755, -122.064720153809, -2.13043126720944, 218, 6, 'PPL', 'P'),
(28635, 'Sorento', 38.9988899230957, 0.680659033780858, -89.5736083984375, -1.56335438944478, 218, 18, 'PPL', 'P'),
(74341, 'Sorg (historical)', 39.1086082458496, 0.68257397976268, -83.6758270263672, -1.46041868593936, 218, 41, 'PPL', 'P'),
(38280, 'Sorgho', 37.753059387207, 0.658915189007716, -87.2472229003906, -1.52275130283321, 218, 21, 'PPL', 'P'),
(98171, 'Sorghumville', 31.0566692352295, 0.542041132857584, -95.5083312988281, -1.6669348442501, 218, 51, 'PPL', 'P'),
(106396, 'Soroco', 36.7480583190918, 0.641374611383045, -76.5619430541992, -1.33625798802018, 218, 53, 'PPL', 'P'),
(18118, 'Soroka Shores', 26.1525001525879, 0.456447235290978, -80.1091690063477, -1.39816876019736, 218, 12, 'PPL', 'P'),
(43119, 'Sorrel', 29.8888893127441, 0.52165952827153, -91.6166687011719, -1.59901251854429, 218, 22, 'PPL', 'P'),
(167333, 'Sorrelhorse', 40.1472206115723, 0.700701185196468, -75.0566711425781, -1.3099860370246, 218, 45, 'PPL', 'P'),
(106397, 'Sorrell', 37.9541702270508, 0.66242523532444, -77.1961135864258, -1.34732635182666, 218, 53, 'PPL', 'P'),
(139461, 'Sorrell', 40.2150001525879, 0.701884161352681, -93.0202789306641, -1.6235101384636, 218, 29, 'PPL', 'P'),
(98172, 'Sorrelle', 29.3388900756836, 0.512060230701367, -96.1594390869141, -1.67829881893758, 218, 51, 'PPL', 'P'),
(12025, 'Sorrells', 34.160831451416, 0.596218984046043, -92.0658264160156, -1.60685179952904, 218, 4, 'PPL', 'P'),
(77282, 'Sorrels', 35.0291709899902, 0.611374368019411, -94.6466674804688, -1.65189597357443, 218, 42, 'PPL', 'P'),
(18119, 'Sorrento', 28.8075008392334, 0.502785738915652, -81.5638885498047, -1.42355840592379, 218, 12, 'PPL', 'P'),
(43120, 'Sorrento', 30.1841697692871, 0.526813144454997, -90.8591690063477, -1.58579165478675, 218, 22, 'PPL', 'P'),
(51542, 'Sorrento', 39.394718170166, 0.687567539964633, -76.6527786254883, -1.3378433678171, 218, 25, 'PPL', 'P'),
(128858, 'Sorrento', 44.473331451416, 0.776206063157958, -68.1777801513672, -1.1899267403422, 218, 26, 'PPL', 'P'),
(157701, 'Sorrento', 41.4455604553223, 0.723361490279734, -81.5841674804688, -1.42391234003267, 218, 41, 'PPL', 'P'),
(185250, 'Sorrento', 32.9008293151855, 0.574227798186659, -117.222221374512, -2.0459137194869, 218, 6, 'PPL', 'P'),
(51543, 'Sorrento Run', 39.3930587768555, 0.687538578087778, -76.665283203125, -1.33806161386844, 218, 25, 'PPL', 'P'),
(68916, 'Sorrento Skies', 36.1761093139648, 0.631392218090074, -81.6374969482422, -1.42484311483365, 218, 33, 'PPL', 'P'),
(185251, 'Sorroca', 38.3422203063965, 0.669197986871648, -121.60888671875, -2.12247547292699, 218, 6, 'PPL', 'P'),
(202629, 'Sorum', 45.4497184753418, 0.793247231499212, -102.928886413574, -1.79644796332813, 218, 49, 'PPL', 'P'),
(171316, 'Sorum Addition', 43.6511116027832, 0.761855619624066, -96.7130584716797, -1.68796130000461, 218, 49, 'PPL', 'P'),
(171315, 'Sorum Heights', 43.6541709899902, 0.761909016003922, -96.708610534668, -1.68788366885883, 218, 49, 'PPL', 'P'),
(61828, 'Soso', 31.7566699981689, 0.55425845093735, -89.274169921875, -1.55812820212161, 218, 30, 'PPL', 'P'),
(98173, 'Sotira Estates Colonia', 26.2150001525879, 0.457538066073475, -98.3820037841797, -1.71708989074346, 218, 51, 'PPL', 'P'),
(185252, 'Soto (historical)', 39.8769416809082, 0.69598392795761, -122.019721984863, -2.12964590100398, 218, 6, 'PPL', 'P'),
(185253, 'Soto Street Junction', 34.0188903808594, 0.593741645021024, -118.218330383301, -2.06329910139905, 218, 6, 'PPL', 'P'),
(179193, 'Sotos Crossing (historical)', 31.6305599212646, 0.552057414875426, -111.03556060791, -1.93793611940575, 218, 5, 'PPL', 'P'),
(51544, 'Sotterley', 38.3783302307129, 0.669828223943615, -76.533332824707, -1.33575864531579, 218, 25, 'PPL', 'P'),
(12026, 'Soudan', 34.8261108398438, 0.607830299819761, -90.6591720581055, -1.58230104954598, 218, 4, 'PPL', 'P'),
(106398, 'Soudan', 36.5627784729004, 0.638140868029416, -78.5208282470703, -1.37044698430434, 218, 53, 'PPL', 'P'),
(113143, 'Soudan', 47.8158302307129, 0.83454367210058, -92.2375030517578, -1.60984812207149, 218, 28, 'PPL', 'P'),
(185255, 'Soudan', 38.6027793884277, 0.673745600749067, -121.275001525879, -2.11664807698773, 218, 6, 'PPL', 'P'),
(197582, 'Soudan', 47.0263900756836, 0.820765342147864, -114.400001525879, -1.99665669091312, 218, 31, 'PPL', 'P'),
(57618, 'Souder', 36.788890838623, 0.64208727329075, -92.4583282470703, -1.61370224880105, 218, 29, 'PPL', 'P'),
(167334, 'Soudersburg', 40.0149993896484, 0.698393489532887, -76.1552810668945, -1.32916039739901, 218, 45, 'PPL', 'P'),
(167335, 'Souderton', 40.3116683959961, 0.703571340482273, -75.3255615234375, -1.31467905949754, 218, 45, 'PPL', 'P'),
(167337, 'Soukesburg', 40.3530616760254, 0.704293789506984, -78.7822189331055, -1.3750091124097, 218, 45, 'PPL', 'P'),
(68917, 'Soul City', 36.4083290100098, 0.635445216374038, -78.2705612182617, -1.36607900064245, 218, 33, 'PPL', 'P'),
(128871, 'Soule Mill', 44.9433288574219, 0.784409065368593, -70.2272186279297, -1.22569618957527, 218, 26, 'PPL', 'P'),
(98174, 'Soules Chapel', 32.8306884765625, 0.573003609612577, -95.0742034912109, -1.65935788463272, 218, 51, 'PPL', 'P'),
(43121, 'Soulouque', 30.2719402313232, 0.528345028003524, -91.1552810668945, -1.59095978519816, 218, 22, 'PPL', 'P'),
(185261, 'Soulsbyville', 37.9847183227539, 0.662958400174674, -120.26277923584, -2.09898146526448, 218, 6, 'PPL', 'P'),
(152664, 'Sound Beach', 40.9561080932617, 0.714818935030114, -72.9683303833008, -1.27353761487161, 218, 40, 'PPL', 'P'),
(68918, 'Sound Shores', 35.1152801513672, 0.61287725640157, -75.9727783203125, -1.32597512357722, 218, 33, 'PPL', 'P'),
(68919, 'Sound Side', 35.9516716003418, 0.627475041021703, -75.6319427490234, -1.32002642065031, 218, 33, 'PPL', 'P'),
(114078, 'Sound View', 41.288890838623, 0.720627089630495, -72.2880630493164, -1.26166471009982, 218, 8, 'PPL', 'P'),
(68921, 'Soundside', 35.9650001525879, 0.627707668142922, -76.2402801513672, -1.33064391128424, 218, 33, 'PPL', 'P'),
(197583, 'Sour Dough Flat (historical)', 47.999439239502, 0.837748253840272, -109.374443054199, -1.90894414883082, 218, 31, 'PPL', 'P'),
(98175, 'Sour Lake', 30.1399993896484, 0.526042225898447, -94.4108276367188, -1.6477797917936, 218, 51, 'PPL', 'P'),
(152665, 'Sour Spring Grove', 43.0122184753418, 0.75070483098185, -78.9233322143555, -1.37747200378581, 218, 40, 'PPL', 'P'),
(197584, 'Sourdough', 45.9019393920898, 0.801139975442852, -109.813606262207, -1.91660899276418, 218, 31, 'PPL', 'P'),
(198916, 'Souris', 48.9097213745117, 0.853635674218276, -100.681106567383, -1.75721680415212, 218, 34, 'PPL', 'P'),
(167338, 'Sours Mills', 40.7744407653809, 0.711648242015293, -75.3111114501953, -1.31442685814231, 218, 45, 'PPL', 'P'),
(38281, 'Sourwood', 37.3311080932617, 0.651550749645319, -83.7986068725586, -1.4625615985105, 218, 21, 'PPL', 'P'),
(185262, 'Sousa Corners', 38.4463882446289, 0.671016060368818, -122.860282897949, -2.14431645650089, 218, 6, 'PPL', 'P'),
(38282, 'South', 37.3291702270508, 0.651516927499475, -86.3647232055664, -1.50734877751069, 218, 21, 'PPL', 'P'),
(208782, 'South Aberdeen', 46.9688911437988, 0.819761796470095, -123.801391601563, -2.16074190199812, 218, 56, 'PPL', 'P'),
(113080, 'South Acton', 42.4583282470703, 0.741037622803889, -71.4541702270508, -1.24711053474254, 218, 23, 'PPL', 'P'),
(128860, 'South Acton', 43.5050010681152, 0.759305509722261, -70.9036102294922, -1.23750145005537, 218, 26, 'PPL', 'P'),
(144461, 'South Acworth', 43.1908302307129, 0.753822194195842, -72.2858276367188, -1.26162569478985, 218, 36, 'PPL', 'P'),
(121494, 'South Addison', 41.9049987792969, 0.731380201742935, -87.9886093139648, -1.53569093677964, 218, 18, 'PPL', 'P'),
(128861, 'South Addison', 44.5133285522461, 0.776904144258695, -67.7172164916992, -1.18188838806595, 218, 26, 'PPL', 'P'),
(152666, 'South Addison', 42.0819396972656, 0.734468403342991, -77.2697219848633, -1.34861106073651, 218, 40, 'PPL', 'P'),
(185263, 'South Adelanto', 34.5283317565918, 0.602633074373444, -117.416107177734, -2.04929766512601, 218, 6, 'PPL', 'P'),
(157702, 'South Akron', 41.0613899230957, 0.716656449603241, -81.5169372558594, -1.42273895125638, 218, 41, 'PPL', 'P'),
(152667, 'South Alabama', 43.0736083984375, 0.751776287267416, -78.3358306884766, -1.36721816779873, 218, 40, 'PPL', 'P'),
(98176, 'South Alamo', 26.1566696166992, 0.456520006167765, -98.1083297729492, -1.71231337817034, 218, 51, 'PPL', 'P'),
(152668, 'South Albany', 42.5513916015625, 0.742661884752729, -73.8461074829102, -1.2888577153584, 218, 40, 'PPL', 'P'),
(172539, 'South Albany', 44.6913909912109, 0.780011920092763, -72.3125, -1.2620912153484, 218, 55, 'PPL', 'P'),
(128862, 'South Albion', 44.5027809143066, 0.776720053248343, -69.4861068725586, -1.21276134931881, 218, 26, 'PPL', 'P'),
(172540, 'South Alburg', 44.8875007629395, 0.78343468130476, -73.2788925170898, -1.27895794663825, 218, 55, 'PPL', 'P'),
(144462, 'South Alexandria', 43.5574989318848, 0.760221770295302, -71.795280456543, -1.25306403135941, 218, 36, 'PPL', 'P'),
(18120, 'South Allapattah', 25.5330600738525, 0.445635966398233, -80.3661117553711, -1.40265325715695, 218, 12, 'PPL', 'P'),
(167340, 'South Altoona', 40.4888916015625, 0.706664468930346, -78.4094390869141, -1.36850287670859, 218, 45, 'PPL', 'P'),
(117837, 'South Amana', 41.7761116027832, 0.729130696149172, -91.9672164916992, -1.60513073167458, 218, 16, 'PPL', 'P'),
(146335, 'South Amboy', 40.4777793884277, 0.706470524223961, -74.2911071777344, -1.29662442520346, 218, 37, 'PPL', 'P'),
(146336, 'South Amboy Junction', 40.4916687011719, 0.706712938462185, -74.2836074829102, -1.29649353083588, 218, 37, 'PPL', 'P'),
(152669, 'South Amenia', 41.7988891601563, 0.729528239520894, -73.5363922119141, -1.28345216413582, 218, 40, 'PPL', 'P'),
(126128, 'South Amherst', 42.3402786254883, 0.73897726822655, -72.5055618286133, -1.26546077991762, 218, 23, 'PPL', 'P'),
(157703, 'South Amherst', 41.3558311462402, 0.721795418400713, -82.2538909912109, -1.43560122037313, 218, 41, 'PPL', 'P'),
(128863, 'South Amity', 45.8877792358398, 0.800892834093693, -67.8494415283203, -1.18419615030856, 218, 26, 'PPL', 'P'),
(152670, 'South Amsterdam', 42.9347190856934, 0.749352211464199, -74.1963882446289, -1.29497126795679, 218, 40, 'PPL', 'P'),
(185264, 'South Anaheim', 33.8088912963867, 0.590076469570802, -117.900283813477, -2.05774814158094, 218, 6, 'PPL', 'P'),
(128864, 'South Andover', 44.5938911437988, 0.77831022673523, -70.7372207641602, -1.23459740604469, 218, 26, 'PPL', 'P'),
(106400, 'South Anna', 37.8588905334473, 0.660762290960767, -77.9055633544922, -1.35970858615693, 218, 53, 'PPL', 'P'),
(152671, 'South Apalachin', 42.0191688537598, 0.73337284544956, -76.1555633544922, -1.32916532424703, 218, 40, 'PPL', 'P'),
(18125, 'South Apopka', 28.6616706848145, 0.50024052257235, -81.5097198486328, -1.42261298373682, 218, 12, 'PPL', 'P'),
(208783, 'South Arbor', 46.9211082458496, 0.818927827574737, -123.980560302734, -2.16386898575009, 218, 56, 'PPL', 'P'),
(152672, 'South Argyle', 43.1847190856934, 0.753715534594184, -73.4941711425781, -1.28271526746219, 218, 40, 'PPL', 'P'),
(128865, 'South Arm', 44.7552795410156, 0.781126985641179, -70.8461074829102, -1.23649783779857, 218, 26, 'PPL', 'P'),
(126129, 'South Ashburnham', 42.610279083252, 0.743689665196418, -71.9394378662109, -1.25558005279926, 218, 23, 'PPL', 'P'),
(126130, 'South Ashfield', 42.5105590820313, 0.741949222845024, -72.7769393920898, -1.27019721191633, 218, 23, 'PPL', 'P'),
(126131, 'South Athol', 42.5313911437988, 0.742312810912847, -72.2624969482422, -1.26121849745918, 218, 23, 'PPL', 'P'),
(152673, 'South Attica', 42.7933311462402, 0.746884526398131, -78.2638931274414, -1.36596262050281, 218, 40, 'PPL', 'P'),
(126132, 'South Attleboro', 41.9083290100098, 0.731438325233726, -71.3625030517578, -1.24551064071768, 218, 23, 'PPL', 'P'),
(167342, 'South Auburn', 41.6650009155273, 0.727191448822404, -76.0805587768555, -1.3278562474132, 218, 45, 'PPL', 'P'),
(117838, 'South Augusta', 40.7522201538086, 0.71126041918155, -91.2772216796875, -1.5930880503833, 218, 16, 'PPL', 'P'),
(152674, 'South Avon', 42.8658294677734, 0.748149860811055, -77.771110534668, -1.3573619417624, 218, 40, 'PPL', 'P'),
(51545, 'South Baltimore', 39.2727813720703, 0.685439341358523, -76.605827331543, -1.33702391314969, 218, 25, 'PPL', 'P'),
(128867, 'South Bancroft', 45.7208290100098, 0.79797900296601, -67.9858322143555, -1.18657661684893, 218, 26, 'PPL', 'P'),
(74342, 'South Bantam', 38.9833297729492, 0.680387457928697, -84.1463928222656, -1.46863160842506, 218, 41, 'PPL', 'P'),
(144463, 'South Barnstead', 43.314998626709, 0.755989341532894, -71.228889465332, -1.24317864370915, 218, 36, 'PPL', 'P'),
(126133, 'South Barre', 42.3852806091309, 0.739762701011041, -72.095832824707, -1.25830965975854, 218, 23, 'PPL', 'P'),
(152675, 'South Barre', 43.1519393920898, 0.753143421013008, -78.1500015258789, -1.36397483706518, 218, 40, 'PPL', 'P'),
(172541, 'South Barre', 44.1769409179688, 0.771033072477561, -72.5061111450195, -1.26547036729755, 218, 55, 'PPL', 'P'),
(121495, 'South Barrington', 42.0913887023926, 0.734633319593494, -88.1216735839844, -1.53801334640824, 218, 18, 'PPL', 'P'),
(144464, 'South Barrington', 43.1822204589844, 0.753671925331334, -71.0347213745117, -1.23978977122202, 218, 36, 'PPL', 'P'),
(34005, 'South Basehor', 39.1288909912109, 0.682927980450578, -94.9383316040039, -1.65698647284006, 218, 20, 'PPL', 'P'),
(209744, 'South Baxter', 41.3680610656738, 0.722008870762083, -109.121109008789, -1.90452263563102, 218, 59, 'PPL', 'P'),
(18121, 'South Bay', 26.663610458374, 0.465367792967821, -80.7163925170898, -1.40876680975533, 218, 12, 'PPL', 'P'),
(152677, 'South Bay', 43.5219383239746, 0.759601120603259, -73.508056640625, -1.28295761512139, 218, 40, 'PPL', 'P'),
(157704, 'South Bay', 40.4933280944824, 0.70674190033904, -82.5199966430664, -1.44024564015618, 218, 41, 'PPL', 'P'),
(208784, 'South Bay', 47.0805587768555, 0.821710764334842, -122.844718933105, -2.14404481406971, 218, 56, 'PPL', 'P'),
(18122, 'South Bay Estates', 25.7394409179688, 0.449237991641106, -80.2422180175781, -1.40049090350986, 218, 12, 'PPL', 'P'),
(185265, 'South Bay Terraces', 32.6836090087891, 0.570436588637849, -117.037216186523, -2.04268476982324, 218, 6, 'PPL', 'P'),
(199692, 'South Bayard', 41.7158317565918, 0.728078614360537, -103.321113586426, -1.80329361891018, 218, 35, 'PPL', 'P'),
(18123, 'South Beach', 27.5908298492432, 0.481550824226824, -80.3444366455078, -1.4022749551241, 218, 12, 'PPL', 'P'),
(74343, 'South Beach', 39.1824989318848, 0.683863615520551, -83.476936340332, -1.4569473886165, 218, 41, 'PPL', 'P'),
(152678, 'South Beach', 40.5902786254883, 0.708434006316649, -74.0672225952148, -1.29271690209404, 218, 40, 'PPL', 'P'),
(201578, 'South Beach', 44.6127815246582, 0.778639926078181, -124.047500610352, -2.16503731452031, 218, 43, 'PPL', 'P'),
(208786, 'South Beach', 48.9775009155273, 0.854818650374489, -123.049171447754, -2.1476131836143, 218, 56, 'PPL', 'P'),
(83704, 'South Beach Villas', 32.1111106872559, 0.560444607964954, -80.8249969482422, -1.4106623146612, 218, 48, 'PPL', 'P'),
(176443, 'South Beaver Dam', 43.4408302307129, 0.758185517325828, -88.8861083984375, -1.55135525083732, 218, 57, 'PPL', 'P'),
(51546, 'South Beechwood', 38.7438888549805, 0.676208425546145, -76.0638885498047, -1.32756529706411, 218, 25, 'PPL', 'P'),
(126134, 'South Bellingham', 42.0416717529297, 0.733765595131319, -71.4766693115234, -1.24750321784527, 218, 23, 'PPL', 'P'),
(208787, 'South Bellingham', 48.7191696166992, 0.850309918648985, -122.488609313965, -2.13782952871768, 218, 56, 'PPL', 'P'),
(146338, 'South Belmar', 40.1708297729492, 0.70111324279613, -74.0277786254883, -1.29202847495225, 218, 37, 'PPL', 'P'),
(68923, 'South Belmont', 35.230281829834, 0.614884414336136, -81.0427780151367, -1.41446331132701, 218, 33, 'PPL', 'P'),
(121496, 'South Beloit', 42.4930610656738, 0.741643824847019, -89.0366668701172, -1.5539829918849, 218, 18, 'PPL', 'P'),
(12027, 'South Bend', 34.8416709899902, 0.608101875671922, -92.0541687011719, -1.60664833402176, 218, 4, 'PPL', 'P'),
(24959, 'South Bend', 33.6425018310547, 0.587172425560125, -84.3555603027344, -1.47228226964734, 218, 13, 'PPL', 'P'),
(43123, 'South Bend', 29.6299991607666, 0.517141042718534, -91.5355606079102, -1.59759691526685, 218, 22, 'PPL', 'P'),
(98177, 'South Bend', 33.0044403076172, 0.57603615114585, -98.6680603027344, -1.72208251883903, 218, 51, 'PPL', 'P'),
(123689, 'South Bend', 41.6833305358887, 0.72751136104835, -86.25, -1.50534647984511, 218, 19, 'PPL', 'P'),
(143031, 'South Bend', 41.0016708374023, 0.715614154931612, -96.245002746582, -1.67979218651884, 218, 35, 'PPL', 'P'),
(167344, 'South Bend', 40.6277809143066, 0.709088544733563, -79.3697204589844, -1.38526294839678, 218, 45, 'PPL', 'P'),
(208788, 'South Bend', 46.663330078125, 0.814428749808184, -123.803329467773, -2.16077572414397, 218, 56, 'PPL', 'P'),
(12028, 'South Bend (historical)', 34.0374984741211, 0.594066417515959, -91.4636077880859, -1.59634110165483, 218, 4, 'PPL', 'P'),
(90904, 'South Berlin', 35.500560760498, 0.619601671574993, -86.836669921875, -1.51558580160425, 218, 50, 'PPL', 'P'),
(126135, 'South Berlin', 42.3597183227539, 0.739316554949426, -71.6291732788086, -1.25016491419675, 218, 23, 'PPL', 'P'),
(113213, 'South Berne', 42.5583305358887, 0.7427829920033, -74.1005630493164, -1.29329880279222, 218, 40, 'PPL', 'P'),
(128868, 'South Berwick', 43.2344398498535, 0.754583325635387, -70.8099975585938, -1.23586760072661, 218, 26, 'PPL', 'P'),
(14648, 'South Bethany', 38.5163917541504, 0.672237852097919, -75.0533294677734, -1.30992771379673, 218, 10, 'PPL', 'P'),
(152679, 'South Bethlehem', 42.5316696166992, 0.742317671181836, -73.8477783203125, -1.28888687697234, 218, 40, 'PPL', 'P'),
(167347, 'South Bethlehem', 40.6108283996582, 0.708792667536455, -75.3666687011719, -1.31539651509521, 218, 45, 'PPL', 'P'),
(126136, 'South Billerica', 42.5277786254883, 0.742249760574039, -71.2805633544922, -1.2440805232123, 218, 23, 'PPL', 'P'),
(43124, 'South Bilt', 30.5055599212646, 0.53242246079049, -90.4983291625977, -1.57949381144093, 218, 22, 'PPL', 'P'),
(179194, 'South Bisbee', 31.4169406890869, 0.548329055928343, -109.903060913086, -1.91817027095324, 218, 5, 'PPL', 'P'),
(139462, 'South Blanchard (historical)', 40.5777816772461, 0.708215893423371, -95.2213897705078, -1.66192676982021, 218, 29, 'PPL', 'P'),
(133171, 'South Blendon', 42.8849983215332, 0.748484420422996, -85.9208297729492, -1.49960137558354, 218, 27, 'PPL', 'P'),
(74344, 'South Bloomfield', 39.7183303833008, 0.6932156385835, -82.9869384765625, -1.44839531256598, 218, 41, 'PPL', 'P'),
(152680, 'South Bloomfield', 42.8611106872559, 0.748067502554344, -77.3897171020508, -1.35070537061775, 218, 40, 'PPL', 'P'),
(74345, 'South Bloomingville', 39.4186096191406, 0.687984524412312, -82.5994415283203, -1.44163221497773, 218, 41, 'PPL', 'P'),
(128870, 'South Blue Hill', 44.353889465332, 0.774121407235671, -68.5491714477539, -1.19640874127739, 218, 26, 'PPL', 'P'),
(111454, 'South Bluefield', 37.2577781677246, 0.650270901004455, -81.2183303833008, -1.41752727816115, 218, 58, 'PPL', 'P'),
(133172, 'South Boardman', 44.6413917541504, 0.779139268782571, -85.2797164916992, -1.48841183794746, 218, 27, 'PPL', 'P'),
(195633, 'South Boise (historical)', 43.5763893127441, 0.760551469638254, -116.165557861328, -2.02747146209616, 218, 17, 'PPL', 'P'),
(152681, 'South Bolivar', 42.0058288574219, 0.733140018591259, -78.1155624389648, -1.36337376160715, 218, 40, 'PPL', 'P'),
(126137, 'South Bolton', 42.396671295166, 0.739961505986416, -71.6055603027344, -1.24975279001806, 218, 23, 'PPL', 'P'),
(152682, 'South Bombay', 44.8899993896484, 0.78347829056761, -74.5547180175781, -1.30122530230268, 218, 40, 'PPL', 'P'),
(98178, 'South Bosque', 31.4816703796387, 0.549458802152268, -97.2877807617188, -1.69799209625039, 218, 51, 'PPL', 'P'),
(31156, 'South Boston', 38.5827789306641, 0.673396526909185, -85.9791717529297, -1.50061963522633, 218, 19, 'PPL', 'P'),
(106402, 'South Boston', 36.6986083984375, 0.640511547452777, -78.9016723632813, -1.37709396806907, 218, 53, 'PPL', 'P'),
(126138, 'South Boston', 42.3333282470703, 0.738855961238897, -71.0500030517578, -1.24005648680519, 218, 23, 'PPL', 'P'),
(157706, 'South Boulevards', 40.732780456543, 0.710921132458674, -82.533332824707, -1.44047840043545, 218, 41, 'PPL', 'P'),
(146340, 'South Bound Brook', 40.5533294677734, 0.707789121858686, -74.5319366455078, -1.30082769235193, 218, 37, 'PPL', 'P'),
(144465, 'South Bow', 43.0900001525879, 0.752062377347518, -71.5188903808594, -1.2482401145189, 218, 36, 'PPL', 'P'),
(14649, 'South Bowers', 39.0572204589844, 0.681677093686568, -75.3977813720703, -1.31593953364147, 218, 10, 'PPL', 'P'),
(18124, 'South Bradenton', 27.4627799987793, 0.479315932729543, -82.5819396972656, -1.44132675040069, 218, 12, 'PPL', 'P'),
(152683, 'South Bradford', 42.3111114501953, 0.738468204984181, -77.1272201538086, -1.34612393459449, 218, 40, 'PPL', 'P'),
(167349, 'South Bradford', 41.9291687011719, 0.731802046459604, -78.6530609130859, -1.37275487970501, 218, 45, 'PPL', 'P'),
(126139, 'South Braintree', 42.2000007629395, 0.736528957657413, -71, -1.23918376891597, 218, 23, 'PPL', 'P'),
(133173, 'South Branch', 44.4666709899902, 0.776089816176376, -83.8888931274414, -1.4641373909275, 218, 27, 'PPL', 'P'),
(138173, 'South Branch', 43.8838882446289, 0.765918338446009, -94.5491714477539, -1.65019434679592, 218, 28, 'PPL', 'P'),
(146342, 'South Branch', 40.5438919067383, 0.707624405345265, -74.6972198486328, -1.3037124284447, 218, 37, 'PPL', 'P'),
(167350, 'South Branch', 41.6483306884766, 0.726900498473313, -76.4449996948242, -1.33421694136074, 218, 45, 'PPL', 'P'),
(128872, 'South Brewer', 44.7702789306641, 0.781388774376334, -68.7805633544922, -1.20044729191244, 218, 26, 'PPL', 'P'),
(126140, 'South Brewster', 41.7472190856934, 0.728626426596766, -70.0602798461914, -1.22278255818467, 218, 23, 'PPL', 'P'),
(192243, 'South Brice', 34.6833305358887, 0.605338313408747, -100.895278930664, -1.76095481705815, 218, 51, 'PPL', 'P'),
(205815, 'South Bridge Plat A', 40.5869407653809, 0.708375749667803, -111.834716796875, -1.95188402614088, 218, 52, 'PPL', 'P'),
(126141, 'South Bridgewater', 41.9455604553223, 0.732088136539705, -70.9475021362305, -1.23826750834293, 218, 23, 'PPL', 'P'),
(128873, 'South Bridgton', 43.9913902282715, 0.767794602012997, -70.708610534668, -1.2340980633403, 218, 26, 'PPL', 'P'),
(113217, 'South Bristol', 42.7297210693359, 0.745774321118704, -77.3994369506836, -1.35087501397919, 218, 40, 'PPL', 'P'),
(128874, 'South Bristol', 43.8638916015625, 0.765569331185154, -69.5616683959961, -1.21408014669061, 218, 26, 'PPL', 'P'),
(114079, 'South Britain', 41.4708290100098, 0.723802509756251, -73.2519378662109, -1.27848749923169, 218, 8, 'PPL', 'P'),
(143038, 'South Broad Trailer Court', 41.4213905334473, 0.722939645563065, -96.4997177124023, -1.68423780132651, 218, 35, 'PPL', 'P'),
(208789, 'South Broadway', 46.5663909912109, 0.812736843567657, -120.515556335449, -2.1033932579263, 218, 56, 'PPL', 'P'),
(152685, 'South Brookfield', 42.7533302307129, 0.746186378718367, -75.3111114501953, -1.31442685814231, 218, 40, 'PPL', 'P'),
(144474, 'South Brookline', 42.7155609130859, 0.745527179769545, -71.6616668701172, -1.25073203435088, 218, 36, 'PPL', 'P'),
(157707, 'South Brooklyn', 41.4416694641113, 0.723293579671937, -81.7050018310547, -1.4260212972999, 218, 41, 'PPL', 'P'),
(18126, 'South Brooksville', 28.5311107635498, 0.497961822075137, -82.4024963378906, -1.43819487295876, 218, 12, 'PPL', 'P'),
(128876, 'South Brooksville', 44.3416709899902, 0.773908154611383, -68.7397232055664, -1.19973449684668, 218, 26, 'PPL', 'P'),
(197585, 'South Browning', 48.5461082458496, 0.847289427919645, -113.013328552246, -1.97245468187481, 218, 31, 'PPL', 'P'),
(146343, 'South Brunswick Terrace', 40.3791694641113, 0.704749456369497, -74.5666732788086, -1.30143396097409, 218, 37, 'PPL', 'P'),
(111457, 'South Buckhannon', 38.9819412231445, 0.680363223162778, -80.2213897705078, -1.40012738202106, 218, 58, 'PPL', 'P'),
(38287, 'South Buffalo', 37.5041694641113, 0.65457124037466, -85.7024993896484, -1.4957907915378, 218, 21, 'PPL', 'P'),
(172542, 'South Burlington', 44.4669418334961, 0.776094543287311, -73.17138671875, -1.27708161649224, 218, 55, 'PPL', 'P'),
(133175, 'South Butler', 42.0222206115723, 0.733426108671361, -84.8850021362305, -1.48152277283964, 218, 27, 'PPL', 'P'),
(152686, 'South Butler', 43.1313896179199, 0.752784759793202, -76.76611328125, -1.33982143071676, 218, 40, 'PPL', 'P'),
(128877, 'South Buxton', 43.6205596923828, 0.761322388194805, -70.4791717529297, -1.23009360116721, 218, 26, 'PPL', 'P'),
(126142, 'South Byfield', 42.7486114501953, 0.746104020461656, -70.904167175293, -1.23751117059335, 218, 23, 'PPL', 'P'),
(152687, 'South Byron', 43.0483283996582, 0.751335068053817, -78.0658264160156, -1.36250570424984, 218, 40, 'PPL', 'P'),
(176444, 'South Byron', 43.6388893127441, 0.761642300420751, -88.4863891601563, -1.54437883404575, 218, 57, 'PPL', 'P'),
(172544, 'South Cabot', 44.3675003051758, 0.774358961204906, -72.2761077880859, -1.26145605142842, 218, 55, 'PPL', 'P'),
(152688, 'South Cairo', 42.2769393920898, 0.737871790058058, -73.9572219848633, -1.2907970292642, 218, 40, 'PPL', 'P'),
(5951, 'South Calera', 33.0744400024414, 0.577257876295924, -86.7494430541992, -1.5140634055671, 218, 2, 'PPL', 'P'),
(185267, 'South Camanche Shore', 38.2083282470703, 0.66686112959413, -120.89582824707, -2.11003025483694, 218, 6, 'PPL', 'P'),
(152689, 'South Cambridge', 42.964168548584, 0.749866201554584, -73.4772186279297, -1.28241939026508, 218, 40, 'PPL', 'P'),
(172545, 'South Cambridge', 44.6100006103516, 0.778591389967315, -72.8108291625977, -1.27078869999443, 218, 55, 'PPL', 'P'),
(152690, 'South Cameron', 42.1738891601563, 0.736073224215873, -77.4305572509766, -1.35141816568351, 218, 40, 'PPL', 'P'),
(38283, 'South Campbellsville', 37.3333282470703, 0.65158949863918, -85.3255615234375, -1.48921198469697, 218, 21, 'PPL', 'P'),
(114080, 'South Canaan', 41.961669921875, 0.732369299771791, -73.3338928222656, -1.27991788305317, 218, 8, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(167352, 'South Canaan', 41.5052795410156, 0.724403784951363, -75.4124984741211, -1.31619639552861, 218, 45, 'PPL', 'P'),
(157708, 'South Canal', 41.1772193908691, 0.71867805518672, -80.9869384765625, -1.4134887275261, 218, 41, 'PPL', 'P'),
(152691, 'South Canisteo', 42.1958312988281, 0.736456186780626, -77.5508270263672, -1.35351726925471, 218, 40, 'PPL', 'P'),
(24960, 'South Canton', 34.2166709899902, 0.597193567846957, -84.5047225952148, -1.47488564277095, 218, 13, 'PPL', 'P'),
(202631, 'South Canyon Country Estates', 44.1019401550293, 0.76972406222276, -103.362503051758, -1.80401600135586, 218, 49, 'PPL', 'P'),
(111455, 'South Caperton', 38.0180587768555, 0.663540300872856, -81.0272216796875, -1.41419180205388, 218, 58, 'PPL', 'P'),
(189586, 'South Carmen', 35.8936080932617, 0.626461641647901, -105.335830688477, -1.8384570658372, 218, 38, 'PPL', 'P'),
(83705, 'South Carolina', 34.0002784729004, 0.593416805947061, -81.0002822875977, -1.41372162096342, 218, 48, 'ADM1', 'A'),
(51551, 'South Carroll Estates', 39.4119415283203, 0.687868144272675, -77.033332824707, -1.34448529157576, 218, 25, 'PPL', 'P'),
(38284, 'South Carrollton', 37.3375015258789, 0.651662336094994, -87.1419372558594, -1.52091372168106, 218, 21, 'PPL', 'P'),
(57621, 'South Carrollton', 39.3411102294922, 0.686631904894661, -93.4952774047852, -1.63180042577896, 218, 29, 'PPL', 'P'),
(152692, 'South Carrollton', 42.1030616760254, 0.734837051416885, -78.6622161865234, -1.37291466937041, 218, 40, 'PPL', 'P'),
(90905, 'South Carthage', 36.2419395446777, 0.632541172363361, -85.9519424438477, -1.5001443941298, 218, 50, 'PPL', 'P'),
(126143, 'South Carver', 41.8405609130859, 0.730255548814595, -70.7472229003906, -1.23477197625415, 218, 23, 'PPL', 'P'),
(128878, 'South Casco', 43.9147186279297, 0.76645643014426, -70.5183334350586, -1.23077710146098, 218, 26, 'PPL', 'P'),
(123692, 'South Center', 41.476390838623, 0.723899581977984, -86.6399993896484, -1.51215325327524, 218, 19, 'PPL', 'P'),
(152693, 'South Centerville', 41.3855590820313, 0.722314268760087, -74.5224990844727, -1.30066297583851, 218, 40, 'PPL', 'P'),
(114081, 'South Chaplin', 41.776668548584, 0.729140416687151, -72.1316680908203, -1.25893510314055, 218, 8, 'PPL', 'P'),
(74346, 'South Charleston', 39.8252792358398, 0.695082248191537, -83.6344375610352, -1.45969630349368, 218, 41, 'PPL', 'P'),
(111456, 'South Charleston', 38.3683280944824, 0.66965365373416, -81.6997222900391, -1.42592915192618, 218, 58, 'PPL', 'P'),
(144466, 'South Charlestown', 43.1794395446777, 0.753623389220468, -72.4377822875977, -1.26427780376141, 218, 36, 'PPL', 'P'),
(126144, 'South Charlton', 42.0980606079102, 0.734749766312158, -71.9250030517578, -1.25532811776014, 218, 23, 'PPL', 'P'),
(176445, 'South Chase', 44.689998626709, 0.779987618747816, -88.1511077880859, -1.53852707018252, 218, 57, 'PPL', 'P'),
(126145, 'South Chatham', 41.6791687011719, 0.727438723329618, -70.0250015258789, -1.22216683534064, 218, 23, 'PPL', 'P'),
(144467, 'South Chatham', 44.1011085510254, 0.769709547994819, -71.0074996948242, -1.23931466328355, 218, 36, 'PPL', 'P'),
(189587, 'South Chaves', 35.3883285522461, 0.617642850014212, -108.151390075684, -1.8875978474294, 218, 38, 'PPL', 'P'),
(126146, 'South Chelmsford', 42.5708312988281, 0.743001171475605, -71.3763885498047, -1.24575298837687, 218, 23, 'PPL', 'P'),
(193263, 'South Cheney', 47.4658317565918, 0.828435046350211, -117.57527923584, -2.05207574161713, 218, 56, 'PPL', 'P'),
(106404, 'South Chesconessex', 37.7430610656738, 0.658740685377288, -75.7788925170898, -1.32259117793811, 218, 53, 'PPL', 'P'),
(121498, 'South Chicago', 41.7227783203125, 0.728199854769162, -87.5363922119141, -1.52779825941502, 218, 18, 'PPL', 'P'),
(121500, 'South Chicago Heights', 41.4808311462402, 0.723977079965706, -87.6377792358398, -1.52956779680133, 218, 18, 'PPL', 'P'),
(152694, 'South Chili', 43.0538902282715, 0.75143214027555, -77.7813873291016, -1.35754130566182, 218, 40, 'PPL', 'P'),
(128879, 'South China', 44.3955612182617, 0.774848716529372, -69.5716705322266, -1.21425471690007, 218, 26, 'PPL', 'P'),
(157709, 'South Church', 41.6047210693359, 0.726139367033768, -81.3499984741211, -1.41982531986578, 218, 41, 'PPL', 'P'),
(208790, 'South Cle Elum', 47.1858291625977, 0.823548079170888, -120.947776794434, -2.11093692803006, 218, 56, 'PPL', 'P'),
(18127, 'South Clermont', 28.4977798461914, 0.497380087824523, -81.7724990844727, -1.4271993466081, 218, 12, 'PPL', 'P'),
(90907, 'South Cleveland', 35.1411094665527, 0.613328062995093, -84.8722229003906, -1.48129973309835, 218, 50, 'PPL', 'P'),
(18128, 'South Clewiston', 26.7094402313232, 0.466167673401226, -80.9022216796875, -1.41201014048888, 218, 12, 'PPL', 'P'),
(106405, 'South Clinchfield', 36.9625015258789, 0.645117351400015, -82.1761093139648, -1.43424367400747, 218, 53, 'PPL', 'P'),
(90906, 'South Clinton', 36.0719413757324, 0.629574144592904, -84.1333312988281, -1.46840364183575, 218, 50, 'PPL', 'P'),
(18129, 'South Clinton Heights', 28.3213901519775, 0.494301506893905, -82.1836090087891, -1.43437456837504, 218, 12, 'PPL', 'P'),
(74347, 'South Clippinger', 39.1761093139648, 0.683752095649903, -84.3499984741211, -1.47218519742561, 218, 41, 'PPL', 'P'),
(79160, 'South Coatesville', 39.9741706848145, 0.697680894204209, -75.8202819824219, -1.3233135603838, 218, 45, 'PPL', 'P'),
(18130, 'South Cocoa Beach', 28.2811107635498, 0.493598498945152, -80.6066665649414, -1.40685173061546, 218, 12, 'PPL', 'P'),
(77285, 'South Coffeyville', 36.9944381713867, 0.645674751016169, -95.620002746582, -1.66888387869388, 218, 42, 'PPL', 'P'),
(208791, 'South Colby', 47.5222206115723, 0.829419217531049, -122.536109924316, -2.13865857076502, 218, 56, 'PPL', 'P'),
(152700, 'South Colton', 44.5105590820313, 0.77685580788491, -74.8880615234375, -1.30704324402007, 218, 40, 'PPL', 'P'),
(152696, 'South Columbia', 42.8891716003418, 0.74855725787881, -75.0074996948242, -1.30912783336332, 218, 40, 'PPL', 'P'),
(38285, 'South Columbus', 36.7419395446777, 0.641267818623333, -89.0980606079102, -1.55505451474949, 218, 21, 'PPL', 'P'),
(126147, 'South Commons', 42.2369384765625, 0.737173642378293, -70.9875030517578, -1.2389656560227, 218, 23, 'PPL', 'P'),
(157710, 'South Condit', 40.2477798461914, 0.702456274933857, -82.789436340332, -1.44494825000904, 218, 41, 'PPL', 'P'),
(83706, 'South Congaree', 33.910831451416, 0.591855660916057, -81.1358337402344, -1.4160874401178, 218, 48, 'PPL', 'P'),
(79158, 'South Connellsville', 39.9966697692871, 0.698073577306941, -79.5861129760742, -1.38903971029668, 218, 45, 'PPL', 'P'),
(144468, 'South Conway', 43.9630584716797, 0.767300119577597, -71.023063659668, -1.23958630571474, 218, 36, 'PPL', 'P'),
(185269, 'South Corcoran', 36.0911102294922, 0.629908704204845, -119.553062438965, -2.0865945704023, 218, 6, 'PPL', 'P'),
(128880, 'South Corinth', 44.9688911437988, 0.784855211430208, -68.9744415283203, -1.2038311043935, 218, 26, 'PPL', 'P'),
(152697, 'South Corinth', 43.1963882446289, 0.753919199838548, -73.8677825927734, -1.28923601739125, 218, 40, 'PPL', 'P'),
(172546, 'South Corinth', 44.0161094665527, 0.76822603410959, -72.2330627441406, -1.2607047736849, 218, 55, 'PPL', 'P'),
(152698, 'South Corning', 42.1216697692871, 0.73516182391182, -77.0374984741211, -1.34455799587352, 218, 40, 'PPL', 'P'),
(144469, 'South Cornish', 43.4502792358398, 0.758350433576331, -72.3099975585938, -1.26204753950652, 218, 36, 'PPL', 'P'),
(152699, 'South Cortland', 42.5647201538086, 0.742894511873947, -76.2225036621094, -1.33033365301724, 218, 40, 'PPL', 'P'),
(205817, 'South Cottonwood Acres', 40.6472206115723, 0.709427831456439, -111.858329772949, -1.95229615031957, 218, 52, 'PPL', 'P'),
(83707, 'South Cove', 34.7161102294922, 0.605910426989923, -82.9602813720703, -1.44793005832355, 218, 48, 'PPL', 'P'),
(179195, 'South Cove', 36.0905609130859, 0.629899116824921, -114.097221374512, -1.99137218036208, 218, 5, 'PPL', 'P'),
(51548, 'South Covell', 39.332218170166, 0.686476709182136, -77.3925018310547, -1.35075397330764, 218, 25, 'PPL', 'P'),
(112986, 'South Coventry', 41.7700004577637, 0.729024036547515, -72.3055572509766, -1.2619700415188, 218, 8, 'PPL', 'P'),
(185270, 'South Coyote', 37.1988906860352, 0.649243120560766, -121.720558166504, -2.12442450737077, 218, 6, 'PPL', 'P'),
(772, 'South Creek', 35.3355598449707, 0.616721862330236, -76.6947174072266, -1.33857533764271, 218, 33, 'PPL', 'P'),
(90908, 'South Creek', 36.0988883972168, 0.630044458841412, -85.5074996948242, -1.49238740482273, 218, 50, 'PPL', 'P'),
(51549, 'South Creek View', 38.8258285522461, 0.677638543051518, -76.529167175293, -1.33568594101803, 218, 25, 'PPL', 'P'),
(12030, 'South Crossett', 33.1055603027344, 0.577801028000246, -91.95361328125, -1.6048933108634, 218, 4, 'PPL', 'P'),
(152712, 'South Cuba', 42.1997184753418, 0.736524030809396, -78.2736129760742, -1.36613226386425, 218, 40, 'PPL', 'P'),
(51550, 'South Cumberland', 39.6324996948242, 0.69171761047033, -78.7561111450195, -1.37455344554719, 218, 25, 'PPL', 'P'),
(128890, 'South Cushing', 43.9944381713867, 0.767847798655772, -69.2811126708984, -1.20918352555234, 218, 26, 'PPL', 'P'),
(202634, 'South Dakota', 44.5002784729004, 0.776676377406466, -100.250282287598, -1.74969750197233, 218, 49, 'ADM1', 'A'),
(171317, 'South Dakota Park', 45.4174995422363, 0.792684905035041, -96.7005615234375, -1.68774318711133, 218, 49, 'PPL', 'P'),
(144470, 'South Danbury', 43.4838905334473, 0.758937061385448, -71.8874969482422, -1.2546735127642, 218, 36, 'PPL', 'P'),
(152701, 'South Danby', 42.3063888549805, 0.738385780148443, -76.4433288574219, -1.33418777974681, 218, 40, 'PPL', 'P'),
(152702, 'South Dansville', 42.4697189331055, 0.741236427779264, -77.654167175293, -1.35532089510297, 218, 40, 'PPL', 'P'),
(121503, 'South Danville', 40.1150016784668, 0.700138858732297, -87.6374969482422, -1.52956286995331, 218, 18, 'PPL', 'P'),
(144471, 'South Danville', 42.9011116027832, 0.748765650234109, -71.1266708374023, -1.2413945920949, 218, 36, 'PPL', 'P'),
(167358, 'South Danville', 40.961669921875, 0.714916007251847, -76.6425018310547, -1.33766400391769, 218, 45, 'PPL', 'P'),
(126148, 'South Dartmouth', 41.5916709899902, 0.725911600181539, -70.9416732788086, -1.23816577558929, 218, 23, 'PPL', 'P'),
(90909, 'South Dayton', 35.4861106872559, 0.619349470219763, -85.0208282470703, -1.48389338568398, 218, 50, 'PPL', 'P'),
(98179, 'South Dayton', 29.9972190856934, 0.523550239487432, -94.8652801513672, -1.65571148446818, 218, 51, 'PPL', 'P'),
(152703, 'South Dayton', 42.3641700744629, 0.739394252674229, -79.0558319091797, -1.37978455971838, 218, 40, 'PPL', 'P'),
(18131, 'South Daytona', 29.1655597686768, 0.509035046150605, -81.0047225952148, -1.41379911895115, 218, 12, 'PPL', 'P'),
(128881, 'South Deer Isle', 44.1938896179199, 0.771328883095641, -68.6630630493164, -1.19839652471503, 218, 26, 'PPL', 'P'),
(126149, 'South Deerfield', 42.4772186279297, 0.741367322146841, -72.6083297729492, -1.26725441891179, 218, 23, 'PPL', 'P'),
(144472, 'South Deerfield', 43.0958290100098, 0.752164110101159, -71.2683334350586, -1.24386707085093, 218, 36, 'PPL', 'P'),
(121504, 'South Deering', 41.6922187805176, 0.727666490181847, -87.5583267211914, -1.52818108882172, 218, 18, 'PPL', 'P'),
(157711, 'South Delta', 41.5552787780762, 0.725276436261555, -84, -1.46607657167524, 218, 41, 'PPL', 'P'),
(157715, 'South Denmark', 41.7172203063965, 0.728102849126456, -80.6855621337891, -1.40822871805708, 218, 41, 'PPL', 'P'),
(71411, 'South Dennis', 39.1783294677734, 0.683790844643764, -74.8202819824219, -1.30586026786385, 218, 37, 'PPL', 'P'),
(126150, 'South Dennis', 41.6894416809082, 0.727618020650007, -70.1569366455078, -1.22446953757718, 218, 23, 'PPL', 'P'),
(167357, 'South Devonshire Estates', 40.3016700744629, 0.703396836851846, -76.7816696166992, -1.34009293998989, 218, 45, 'PPL', 'P'),
(192935, 'South Dodge', 37.7422218322754, 0.658726037991293, -100.019439697266, -1.74566853871721, 218, 20, 'PPL', 'P'),
(98180, 'South Donna Colonia', 26.1280002593994, 0.456019631488452, -98.0490036010742, -1.71127794113852, 218, 51, 'PPL', 'P'),
(172547, 'South Dorset', 43.2224998474121, 0.754374933280088, -73.0738906860352, -1.27537998971373, 218, 55, 'PPL', 'P'),
(185271, 'South Dos Palos', 36.9644393920898, 0.645151173545859, -120.652221679688, -2.10577851815663, 218, 6, 'PPL', 'P'),
(128882, 'South Dover', 45.1433296203613, 0.787899737188387, -69.1383285522461, -1.2066914725623, 218, 26, 'PPL', 'P'),
(152704, 'South Dover', 41.6611099243164, 0.727123538214607, -73.559440612793, -1.28385443461847, 218, 40, 'PPL', 'P'),
(51552, 'South Down Shores', 38.9383316040039, 0.679602091723233, -76.5708312988281, -1.33641311715368, 218, 25, 'PPL', 'P'),
(177347, 'South Dresden', 44.0491714477539, 0.768803074538783, -69.7724990844727, -1.21775983636878, 218, 26, 'PPL', 'P'),
(57622, 'South Drexel', 38.476390838623, 0.671539704418154, -94.6086120605469, -1.65123178119856, 218, 29, 'PPL', 'P'),
(128883, 'South Durham', 43.9419403076172, 0.76693153808273, -70.0747222900391, -1.22303462638184, 218, 26, 'PPL', 'P'),
(152705, 'South Durham', 42.3269386291504, 0.738744441368249, -74.0988922119141, -1.29326964117828, 218, 40, 'PPL', 'P'),
(172548, 'South Duxbury', 44.2486114501953, 0.772283959241571, -72.7869415283203, -1.27037178212578, 218, 55, 'PPL', 'P'),
(177331, 'South Duxbury', 42.0230598449707, 0.733440756057357, -70.6833267211914, -1.23365677754768, 218, 23, 'PPL', 'P'),
(90910, 'South Dyersburg', 36.0194396972656, 0.628657817440835, -89.39111328125, -1.56016924878104, 218, 50, 'PPL', 'P'),
(126151, 'South East Quarter (historical)', 41.25, 0.719948316447661, -70, -1.22173047639603, 218, 23, 'PPL', 'P'),
(126152, 'South Easton', 42.0472183227539, 0.733862401036943, -71.0819396972656, -1.24061388642135, 218, 23, 'PPL', 'P'),
(152706, 'South Easton', 42.9794387817383, 0.750132717400674, -73.5227813720703, -1.28321461016658, 218, 40, 'PPL', 'P'),
(167360, 'South Eaton', 41.4922218322754, 0.72417588494108, -75.9091720581055, -1.32486498487682, 218, 45, 'PPL', 'P'),
(167361, 'South Ebervale', 40.9791717529297, 0.715221471828879, -75.9463882446289, -1.32551452986669, 218, 45, 'PPL', 'P'),
(106406, 'South Edgewood', 37.2916717529297, 0.650862455661588, -80.0166702270508, -1.39655435194455, 218, 53, 'PPL', 'P'),
(123690, 'South Edgewood', 40.0972213745117, 0.699828533886276, -85.732780456543, -1.49631929585612, 218, 19, 'PPL', 'P'),
(152707, 'South Edmeston', 42.6841697692871, 0.744979300954288, -75.3180618286133, -1.31454816512996, 218, 40, 'PPL', 'P'),
(152708, 'South Edwards', 44.2675018310547, 0.772613658584523, -75.2074966430664, -1.31261843860409, 218, 40, 'PPL', 'P'),
(128884, 'South Effingham', 43.7019386291504, 0.762742718583171, -70.9822235107422, -1.23887351064898, 218, 26, 'PPL', 'P'),
(144473, 'South Effingham', 43.7011108398438, 0.762728270934258, -70.98388671875, -1.23890253910486, 218, 36, 'PPL', 'P'),
(71416, 'South Egg Harbor', 39.521110534668, 0.689773502874573, -74.6519393920898, -1.30292213539122, 218, 37, 'PPL', 'P'),
(126153, 'South Egremont', 42.1605606079102, 0.735840597094654, -73.4166717529297, -1.28136264794454, 218, 23, 'PPL', 'P'),
(185272, 'South El Monte', 34.0519409179688, 0.594318485713135, -118.045829772949, -2.06028839778671, 218, 6, 'PPL', 'P'),
(121507, 'South Elgin', 41.9941711425781, 0.732936553083977, -88.2922210693359, -1.54098996155862, 218, 18, 'PPL', 'P'),
(128885, 'South Eliot', 43.1080589294434, 0.752377562462529, -70.7780609130859, -1.23531020111045, 218, 26, 'PPL', 'P'),
(38286, 'South Elkhorn', 37.9963912963867, 0.663162131998065, -84.5822219848633, -1.4762382622886, 218, 21, 'PPL', 'P'),
(121508, 'South Elkhorn', 41.9666709899902, 0.732456584876518, -89.7122192382813, -1.56577360497901, 218, 18, 'PPL', 'P'),
(114082, 'South Ellsworth', 41.8188896179199, 0.729877313360776, -73.4297180175781, -1.28159034821774, 218, 8, 'PPL', 'P'),
(98181, 'South Elm', 30.9472198486328, 0.540130880697184, -97.129997253418, -1.69523825452519, 218, 51, 'PPL', 'P'),
(192244, 'South Elm Creek Number 1 Colonia', 28.7730007171631, 0.502183598193186, -100.49299621582, -1.75393365916027, 218, 51, 'PPL', 'P'),
(192245, 'South Elm Creek Number 2 Colonia', 28.7709999084473, 0.502148677493392, -100.495002746582, -1.7539686797286, 218, 51, 'PPL', 'P'),
(192246, 'South Elm Creek Number 3 Colonia', 28.7759990692139, 0.502235929308606, -100.491996765137, -1.75391621545513, 218, 51, 'PPL', 'P'),
(192967, 'South Elm Creek Number 4 Colonia', 28.7759990692139, 0.502235929308606, -100.49299621582, -1.75393365916027, 218, 51, 'PPL', 'P'),
(208792, 'South Elma', 46.9813919067383, 0.8199799759424, -123.412216186523, -2.15394950963787, 218, 56, 'PPL', 'P'),
(121509, 'South Elmhurst', 41.8819389343262, 0.730977731523197, -87.9400024414063, -1.53484258681439, 218, 18, 'PPL', 'P'),
(123691, 'South Elwood', 40.2625007629395, 0.702713203400022, -85.8422164916992, -1.49822931498993, 218, 19, 'PPL', 'P'),
(43127, 'South End', 31.1294403076172, 0.543311227670956, -93.2619400024414, -1.62772791984001, 218, 22, 'PPL', 'P'),
(114084, 'South End', 41.2438888549805, 0.719841656846003, -72.8944396972656, -1.27224797911374, 218, 8, 'PPL', 'P'),
(126154, 'South End', 42.0958290100098, 0.734710817581215, -72.5833282470703, -1.26681805996718, 218, 23, 'PPL', 'P'),
(172549, 'South End', 43.3172187805176, 0.756028090526755, -72.9930572509766, -1.27396918012626, 218, 55, 'PPL', 'P'),
(117839, 'South English', 41.452220916748, 0.723477737261316, -92.0902786254883, -1.60727857109373, 218, 16, 'PPL', 'P'),
(126155, 'South Essex', 42.6291694641113, 0.744019364539369, -70.7694396972656, -1.23515973250886, 218, 23, 'PPL', 'P'),
(157712, 'South Euclid', 41.5230598449707, 0.724714109797385, -81.5186080932617, -1.42276811287031, 218, 41, 'PPL', 'P'),
(121511, 'South Evanston', 42.0372200012207, 0.733687897406516, -87.6805572509766, -1.53031441401293, 218, 18, 'PPL', 'P'),
(74349, 'South Excello', 39.4716682434082, 0.68891057210236, -84.4188919067383, -1.47338761465778, 218, 41, 'PPL', 'P'),
(128886, 'South Exeter', 44.9438896179199, 0.784418852485599, -69.1388931274414, -1.20670132625833, 218, 26, 'PPL', 'P'),
(126156, 'South Factory Village', 42.0722198486328, 0.734298759981553, -72.3277816772461, -1.26235793093157, 218, 23, 'PPL', 'P'),
(212156, 'South Fairbanks', 64.8333282470703, 1.13155504293762, -147.716674804688, -2.57814233543955, 218, 1, 'PPL', 'P'),
(133177, 'South Fairfield', 41.7286109924316, 0.728301654101831, -83.9772186279297, -1.46567896172449, 218, 27, 'PPL', 'P'),
(106407, 'South Fairlington', 38.8325004577637, 0.677754989770181, -77.0899963378906, -1.34547425644656, 218, 53, 'PPL', 'P'),
(74350, 'South Fairmount', 39.125560760498, 0.682869856959788, -84.5519409179688, -1.47570975797027, 218, 41, 'PPL', 'P'),
(106408, 'South Fairview', 36.8250007629395, 0.642717510362717, -76.2444381713867, -1.33071648242394, 218, 53, 'PPL', 'P'),
(152709, 'South Fallsburg', 41.7205581665039, 0.728161105775302, -74.6347198486328, -1.30262159766221, 218, 40, 'PPL', 'P'),
(152710, 'South Farmingdale', 40.7205581665039, 0.710707813255358, -73.440559387207, -1.28177956581319, 218, 40, 'PPL', 'P'),
(114085, 'South Farms', 41.5541687011719, 0.725257061764625, -72.6433334350586, -1.26786534806585, 218, 8, 'PPL', 'P'),
(111458, 'South Fayette', 38.0652809143066, 0.664364482651208, -81.0808334350586, -1.41512750370288, 218, 58, 'PPL', 'P'),
(169614, 'South Ferry', 41.4922218322754, 0.72417588494108, -71.4216690063477, -1.24654328143035, 218, 47, 'PPL', 'P'),
(157714, 'South Findlay', 41.0227813720703, 0.715982603268424, -83.642219543457, -1.45983212470927, 218, 41, 'PPL', 'P'),
(126157, 'South Fitchburg', 42.5644416809082, 0.742889651604958, -71.783332824707, -1.25285550584606, 218, 23, 'PPL', 'P'),
(209745, 'South Flat', 43.9297218322754, 0.766718285458442, -108.003059387207, -1.88500898853373, 218, 59, 'PPL', 'P'),
(18132, 'South Flomaton', 30.9916706085205, 0.540906692812237, -87.2574996948242, -1.52293066673263, 218, 12, 'PPL', 'P'),
(152711, 'South Floral Park', 40.714168548584, 0.710596293384711, -73.7005615234375, -1.28631745915263, 218, 40, 'PPL', 'P'),
(5952, 'South Florence', 34.7763900756836, 0.606962508778559, -87.6680603027344, -1.53009630111965, 218, 2, 'PPL', 'P'),
(185275, 'South Fontana', 34.0627784729004, 0.594507636729558, -117.488059997559, -2.05055347873804, 218, 6, 'PPL', 'P'),
(83708, 'South Forest Estates', 34.7797203063965, 0.60702063226935, -82.3850021362305, -1.43788954153978, 218, 48, 'PPL', 'P'),
(38288, 'South Fork', 37.4094390869141, 0.652917883390912, -84.7380599975586, -1.4789581487099, 218, 21, 'PPL', 'P'),
(57624, 'South Fork', 36.6277809143066, 0.63927537465379, -91.9625015258789, -1.6050484399969, 218, 29, 'PPL', 'P'),
(68926, 'South Fork', 36.0897216796875, 0.629884469438925, -80.3186111450195, -1.4018242151096, 218, 33, 'PPL', 'P'),
(90911, 'South Fork', 35.9358291625977, 0.627198538321526, -89.3891677856445, -1.56013529347715, 218, 50, 'PPL', 'P'),
(167363, 'South Fork', 40.3672218322754, 0.704540930856144, -78.7916717529297, -1.37517409523924, 218, 45, 'PPL', 'P'),
(185277, 'South Fork', 39.4261093139648, 0.688115418779889, -123.726112365723, -2.15942803147433, 218, 6, 'PPL', 'P'),
(187379, 'South Fork', 37.6699981689453, 0.657465497268331, -106.639167785645, -1.86120458944617, 218, 7, 'PPL', 'P'),
(185278, 'South Fork (historical)', 39.540828704834, 0.690117649866438, -121.419441223145, -2.1191690252756, 218, 6, 'PPL', 'P'),
(197586, 'South Fork (historical)', 48.3472213745117, 0.843818197175808, -114.006942749023, -1.98979652110313, 218, 31, 'PPL', 'P'),
(98184, 'South Fork Colonia', 27.2700004577637, 0.475951295008337, -98.7020034790039, -1.72267493902352, 218, 51, 'PPL', 'P'),
(98183, 'South Fork Estates', 27.2691707611084, 0.47593681406991, -98.7058334350586, -1.72274178436688, 218, 51, 'PPL', 'P'),
(138176, 'South Fork Homes', 44.0299987792969, 0.768468448347815, -92.7505569458008, -1.61880260176272, 218, 28, 'PPL', 'P'),
(205821, 'South Fork Ranchettes', 41.2583312988281, 0.720093725043179, -111.709716796875, -1.94970236457588, 218, 52, 'PPL', 'P'),
(179196, 'South Fort', 34.146671295166, 0.595971842696883, -112.266387939453, -1.95941810886471, 218, 5, 'PPL', 'P'),
(38289, 'South Fort Mitchell', 39.0411109924316, 0.681395930454483, -84.5561065673828, -1.47578246226803, 218, 21, 'PPL', 'P'),
(12033, 'South Fort Smith', 35.3313903808594, 0.616649091453449, -94.4008331298828, -1.6476053547422, 218, 4, 'PPL', 'P'),
(169615, 'South Foster', 41.8227806091309, 0.729945223968573, -71.7041702270508, -1.25147385787253, 218, 47, 'PPL', 'P'),
(126178, 'South Foxboro', 42.0366706848145, 0.733678310026592, -71.2708282470703, -1.24391061353476, 218, 23, 'PPL', 'P'),
(172563, 'South Franklin', 44.9416694641113, 0.784380103491738, -72.8472213745117, -1.27142386391442, 218, 55, 'PPL', 'P'),
(121512, 'South Freeport', 42.2408294677734, 0.737241552986091, -89.5725021362305, -1.56333508152688, 218, 18, 'PPL', 'P'),
(128888, 'South Freeport', 43.8197212219238, 0.764798412628604, -70.1100006103516, -1.22365034922587, 218, 26, 'PPL', 'P'),
(90912, 'South Fulton', 36.5008316040039, 0.637059691205871, -88.8752822875977, -1.55116629955798, 218, 50, 'PPL', 'P'),
(5953, 'South Gadsden', 34.0016708374023, 0.593441107292008, -86.045280456543, -1.5017734497686, 218, 2, 'PPL', 'P'),
(34008, 'South Galena', 37.0641708374023, 0.646891815634335, -94.6377792358398, -1.65174084444093, 218, 20, 'PPL', 'P'),
(152713, 'South Galway Corner', 43.0205612182617, 0.75085043931445, -73.9719390869141, -1.29105389115134, 218, 40, 'PPL', 'P'),
(106415, 'South Gap', 37.2166709899902, 0.649553445406787, -81.0883331298828, -1.41525839807045, 218, 53, 'PPL', 'P'),
(189589, 'South Garcia', 34.8808288574219, 0.608785309386663, -107.080276489258, -1.86890338868342, 218, 38, 'PPL', 'P'),
(128889, 'South Gardiner', 44.1800003051758, 0.771086468857417, -69.7572174072266, -1.21749312078561, 218, 26, 'PPL', 'P'),
(126158, 'South Gardner', 42.5583305358887, 0.7427829920033, -71.9791717529297, -1.25627353994712, 218, 23, 'PPL', 'P'),
(117843, 'South Garry Owen', 42.2305603027344, 0.737062322244728, -90.8069381713867, -1.58488005474562, 218, 16, 'PPL', 'P'),
(68928, 'South Gastonia', 35.2191696166992, 0.614690469629751, -81.2058334350586, -1.41730916526787, 218, 33, 'PPL', 'P'),
(24961, 'South Gate', 33.5433311462402, 0.585441570588656, -85.0608291625977, -1.48459153336374, 218, 13, 'PPL', 'P'),
(31157, 'South Gate', 39.3211097717285, 0.686282831054779, -84.956672668457, -1.48277365960365, 218, 19, 'PPL', 'P'),
(51553, 'South Gate', 39.1288909912109, 0.682927980450578, -76.626106262207, -1.33737784725856, 218, 25, 'PPL', 'P'),
(185279, 'South Gate', 33.954719543457, 0.592621652624591, -118.211112976074, -2.06317313387949, 218, 6, 'PPL', 'P'),
(18133, 'South Gate Ridge', 27.2861099243164, 0.476232458240422, -82.496940612793, -1.43984323651547, 218, 12, 'PPL', 'P'),
(126159, 'South Georgetown', 42.7097206115723, 0.745425247278822, -70.9916687011719, -1.23903836032046, 218, 23, 'PPL', 'P'),
(167365, 'South Gibson', 41.7341690063477, 0.728398659744537, -75.6305618286133, -1.32000231904245, 218, 45, 'PPL', 'P'),
(152721, 'South Gilboa', 42.4150009155273, 0.740281418212361, -74.5316696166992, -1.30082303182002, 218, 40, 'PPL', 'P'),
(114090, 'South Glastonbury', 41.6669387817383, 0.727225270968248, -72.5972213745117, -1.26706054078443, 218, 8, 'PPL', 'P'),
(51554, 'South Glen', 39.3800010681152, 0.687310678077495, -77.2300033569336, -1.34791783990476, 218, 25, 'PPL', 'P'),
(152715, 'South Glens Falls', 43.2991714477539, 0.755713105148826, -73.6355590820313, -1.28518295252826, 218, 40, 'PPL', 'P'),
(152716, 'South Glenwood Landing', 40.8227806091309, 0.71249193144863, -73.647216796875, -1.28538641803554, 218, 40, 'PPL', 'P'),
(68929, 'South Goldsboro', 35.3574981689453, 0.617104758315962, -78.0061111450195, -1.36146347615723, 218, 33, 'PPL', 'P'),
(128893, 'South Gorham', 43.6411094665527, 0.761681049414611, -70.4205627441406, -1.22907068099251, 218, 26, 'PPL', 'P'),
(128891, 'South Gouldsboro', 44.4297218322754, 0.775444931718413, -68.1080627441406, -1.18870994204014, 218, 26, 'PPL', 'P'),
(111460, 'South Grafton', 39.3369407653809, 0.686559134017874, -80.0205612182617, -1.39662226255235, 218, 58, 'PPL', 'P'),
(126160, 'South Grafton Street', 42.2402801513672, 0.737231965606166, -71.7541732788086, -1.25234657576175, 218, 23, 'PPL', 'P'),
(152717, 'South Granby', 43.2511100769043, 0.754874275984478, -76.4047164916992, -1.33351386683296, 218, 40, 'PPL', 'P'),
(152718, 'South Granville', 43.3713912963867, 0.75697357929276, -73.2855606079102, -1.27907432677789, 218, 40, 'PPL', 'P'),
(128892, 'South Gray', 43.8486099243164, 0.765302615601983, -70.3222198486328, -1.22735427366995, 218, 26, 'PPL', 'P'),
(152719, 'South Greece', 43.1908302307129, 0.753822194195842, -77.7322235107422, -1.3566832351586, 218, 40, 'PPL', 'P'),
(209746, 'South Greeley', 41.0969390869141, 0.717276899558203, -104.80583190918, -1.82920684210692, 218, 59, 'PPL', 'P'),
(57629, 'South Greenfield', 37.3761100769043, 0.652336182429811, -93.8408279418945, -1.63783142038355, 218, 29, 'PPL', 'P'),
(152720, 'South Greenfield', 43.0952796936035, 0.752154522721234, -73.8625030517578, -1.28914387201753, 218, 40, 'PPL', 'P'),
(167366, 'South Greensburg', 40.2783317565918, 0.702989506363118, -79.5449981689453, -1.38832212154096, 218, 45, 'PPL', 'P'),
(83709, 'South Greenwood', 34.1644401550293, 0.596281967805823, -82.1369400024414, -1.43356004055564, 218, 48, 'PPL', 'P'),
(133178, 'South Greenwood', 46.4730606079102, 0.81110792108691, -87.7863922119141, -1.53216158254501, 218, 27, 'PPL', 'P'),
(98185, 'South Grove Street Colonia', 29.1949996948242, 0.509548869793422, -99.786003112793, -1.74159430172355, 218, 51, 'PPL', 'P'),
(126161, 'South Groveland', 42.7402801513672, 0.745958611866138, -71.0455627441406, -1.23997898881747, 218, 23, 'PPL', 'P'),
(189588, 'South Guam', 35.4749984741211, 0.619155525513377, -108.378608703613, -1.89156356060864, 218, 38, 'PPL', 'P'),
(133179, 'South Gull Lake', 42.3875007629395, 0.739801450004902, -85.3966674804688, -1.49045301776495, 218, 27, 'PPL', 'P'),
(146356, 'South Hackensack', 40.8624992370605, 0.713185152280377, -74.0483322143555, -1.29238720275109, 218, 37, 'PPL', 'P'),
(126162, 'South Hadley', 42.2583312988281, 0.737547017563123, -72.5749969482422, -1.26667265137166, 218, 23, 'PPL', 'P'),
(126163, 'South Hadley Falls', 42.2166709899902, 0.736819908006504, -72.5999984741211, -1.26710901031627, 218, 23, 'PPL', 'P'),
(5955, 'South Haleyville', 34.211109161377, 0.597096495625224, -87.6350021362305, -1.52951932726949, 218, 2, 'PPL', 'P'),
(126165, 'South Halifax', 41.9555587768555, 0.732262640170133, -70.8666687011719, -1.23685669875546, 218, 23, 'PPL', 'P'),
(90914, 'South Hall', 35.7769393920898, 0.624425388678426, -83.982780456543, -1.46577603394622, 218, 50, 'PPL', 'P'),
(74351, 'South Hamilton', 39.3816719055176, 0.687339839691431, -84.559440612793, -1.47584065233785, 218, 41, 'PPL', 'P'),
(126166, 'South Hamilton', 42.6069412231445, 0.743631408547572, -70.8791732788086, -1.23707494480679, 218, 23, 'PPL', 'P'),
(152730, 'South Hamilton', 42.7677803039551, 0.746438580073597, -75.4552764892578, -1.31694301274022, 218, 40, 'PPL', 'P'),
(152722, 'South Hammond', 44.399169921875, 0.774911700289152, -75.7333297729492, -1.32179595803661, 218, 40, 'PPL', 'P'),
(51555, 'South Hampton', 38.6794395446777, 0.675083572880723, -76.6611099243164, -1.33798877641262, 218, 25, 'PPL', 'P'),
(144475, 'South Hampton', 42.8808288574219, 0.74841164954621, -70.9630584716797, -1.23853901761607, 218, 36, 'PPL', 'P'),
(51556, 'South Hampton Village', 38.6277809143066, 0.674181959693676, -77.0791702270508, -1.34528530516722, 218, 25, 'PPL', 'P'),
(128898, 'South Hancock', 44.500560760498, 0.776681304254483, -68.2555618286133, -1.19128428670786, 218, 26, 'PPL', 'P'),
(98186, 'South Hanlon', 32.7275009155273, 0.571202646925411, -98.8775024414063, -1.72573797375127, 218, 51, 'PPL', 'P'),
(152723, 'South Hannibal', 43.2625007629395, 0.755073080959852, -76.5244369506836, -1.33560338302424, 218, 40, 'PPL', 'P'),
(126167, 'South Hanover', 42.0972213745117, 0.734735118926162, -70.8499984741211, -1.23656574840637, 218, 23, 'PPL', 'P'),
(126168, 'South Hanson', 42.0430603027344, 0.733789829897239, -70.8805618286133, -1.23709917957271, 218, 23, 'PPL', 'P'),
(128894, 'South Harpswell', 43.7416687011719, 0.763436139152001, -70.0149993896484, -1.22199226513119, 218, 26, 'PPL', 'P'),
(90918, 'South Harriman', 35.9205589294434, 0.626932022475436, -84.5641708374023, -1.47592321033164, 218, 50, 'PPL', 'P'),
(152724, 'South Hartford', 43.3477783203125, 0.75656145511407, -73.4066696166992, -1.28118807773509, 218, 40, 'PPL', 'P'),
(152725, 'South Hartwick', 42.6166687011719, 0.743801185067065, -75.0586090087891, -1.31001985917045, 218, 40, 'PPL', 'P'),
(121514, 'South Harvey', 41.5825004577637, 0.725751544200025, -87.6630630493164, -1.53000908259395, 218, 18, 'PPL', 'P'),
(126169, 'South Harwich', 41.6749992370605, 0.727365952452831, -70.0444412231445, -1.22250612206352, 218, 23, 'PPL', 'P'),
(34014, 'South Haven', 37.0519409179688, 0.646678363272965, -97.4049987792969, -1.70003793659979, 218, 20, 'PPL', 'P'),
(51557, 'South Haven', 38.9630584716797, 0.68003365697788, -76.5827789306641, -1.33662164266703, 218, 25, 'PPL', 'P'),
(68930, 'South Haven', 35.2833290100098, 0.615810262289102, -78.0158309936523, -1.36163311951867, 218, 33, 'PPL', 'P'),
(123701, 'South Haven', 41.5419387817383, 0.725043609403255, -87.1372222900391, -1.52083143000338, 218, 19, 'PPL', 'P'),
(133180, 'South Haven', 42.4030609130859, 0.740073025857063, -86.2736129760742, -1.5057586040238, 218, 27, 'PPL', 'P'),
(138179, 'South Haven', 45.2924995422363, 0.790503243470048, -94.211669921875, -1.64430383393883, 218, 28, 'PPL', 'P'),
(152726, 'South Haven', 40.7991714477539, 0.712079873848967, -72.8955612182617, -1.27226755334776, 218, 40, 'PPL', 'P'),
(192247, 'South Haven', 32.1841697692871, 0.561719729494884, -101.481391906738, -1.77118441827931, 218, 51, 'PPL', 'P'),
(133181, 'South Haven Highlands', 42.4516716003418, 0.740921442401335, -86.2563934326172, -1.50545806629478, 218, 27, 'PPL', 'P'),
(126170, 'South Hawley', 42.5463905334473, 0.742574599648001, -72.9049987792969, -1.27243226986118, 218, 23, 'PPL', 'P'),
(198923, 'South Heart', 46.8647193908691, 0.817943656393898, -102.991111755371, -1.79753400042066, 218, 34, 'PPL', 'P'),
(167369, 'South Heberton', 41.024169921875, 0.716006838034344, -75.8944396972656, -1.32460785667357, 218, 45, 'PPL', 'P'),
(167371, 'South Heights', 40.5736083984375, 0.708143055967558, -80.2358322143555, -1.40037945021824, 218, 45, 'PPL', 'P'),
(144477, 'South Hemlock', 43.2030601501465, 0.754035646557212, -72.3680572509766, -1.2630608723013, 218, 36, 'PPL', 'P'),
(152727, 'South Hempstead', 40.6808280944824, 0.710014392686529, -73.6158294677734, -1.28483860579931, 218, 40, 'PPL', 'P'),
(68931, 'South Henderson', 36.3080596923828, 0.63369518664272, -78.4069366455078, -1.36845920086671, 218, 33, 'PPL', 'P'),
(167373, 'South Hermitage', 40.0597190856934, 0.699173995469362, -75.9811096191406, -1.32612053217274, 218, 45, 'PPL', 'P'),
(172551, 'South Hero', 44.6452789306641, 0.779207112811341, -73.3027801513672, -1.2793748645069, 218, 55, 'PPL', 'P'),
(38290, 'South Higginsport', 38.7777786254883, 0.676799913624252, -83.966667175293, -1.46549480413511, 218, 21, 'PPL', 'P'),
(38291, 'South Highland', 36.6858291625977, 0.640288507711483, -88.6322174072266, -1.54692401709954, 218, 21, 'PPL', 'P'),
(43128, 'South Highland', 30.353889465332, 0.529775311956465, -91.1350021362305, -1.59060585108929, 218, 22, 'PPL', 'P'),
(152728, 'South Highland', 41.3813896179199, 0.722241497883301, -73.9127807617188, -1.29002138359671, 218, 40, 'PPL', 'P'),
(74352, 'South Highlands', 39.5019416809082, 0.689438943262631, -84.378059387207, -1.47267495275007, 218, 41, 'PPL', 'P'),
(112215, 'South Highlands', 33.5697212219238, 0.585902164299185, -86.7130584716797, -1.51342837480517, 218, 2, 'PPL', 'P'),
(208793, 'South Highlands', 46.1936111450195, 0.806230607866539, -119.136390686035, -2.07932227641362, 218, 56, 'PPL', 'P'),
(18134, 'South Highpoint', 27.9166698455811, 0.487237804997606, -82.7130584716797, -1.4436152047254, 218, 12, 'PPL', 'P'),
(281, 'South Hill', 34.4102783203125, 0.600572653217077, -86.038330078125, -1.50165214278095, 218, 2, 'PPL', 'P'),
(38292, 'South Hill', 37.1758308410645, 0.648840650341027, -86.8047180175781, -1.51502813567198, 218, 21, 'PPL', 'P'),
(106412, 'South Hill', 36.726390838623, 0.640996442508254, -78.1291732788086, -1.36361131557638, 218, 53, 'PPL', 'P'),
(152729, 'South Hill', 42.4291687011719, 0.740528692719575, -76.4952774047852, -1.33509445293992, 218, 40, 'PPL', 'P'),
(167374, 'South Hill', 41.8358306884766, 0.730172990820802, -76.2638931274414, -1.33105603546293, 218, 45, 'PPL', 'P'),
(208794, 'South Hill', 47.1413917541504, 0.82277250008243, -122.268890380859, -2.13399470990602, 218, 56, 'PPL', 'P'),
(205824, 'South Hill Crest', 40.6147193908691, 0.708860578144252, -111.869438171387, -1.95249002844692, 218, 52, 'PPL', 'P'),
(157716, 'South Hill Park', 41.6294403076172, 0.726570799130361, -83.6988906860352, -1.46082122273813, 218, 41, 'PPL', 'P'),
(83710, 'South Hills', 34.6875, 0.605411084285533, -81.6072235107422, -1.42431474367338, 218, 48, 'PPL', 'P'),
(90916, 'South Hills', 35.6833305358887, 0.62279160592869, -84.0124969482422, -1.46629468456851, 218, 50, 'PPL', 'P'),
(111462, 'South Hills', 39.6194381713867, 0.69148964388102, -79.9400024414063, -1.39521624665484, 218, 58, 'PPL', 'P'),
(167375, 'South Hills', 40.3919410705566, 0.704972362952737, -80.0377807617188, -1.39692280028137, 218, 45, 'PPL', 'P'),
(172553, 'South Hinesburg', 44.2922210693359, 0.773045090681116, -73.0702819824219, -1.27531700595395, 218, 55, 'PPL', 'P'),
(126171, 'South Hingham', 42.1958312988281, 0.736456186780626, -70.875, -1.23700210735098, 218, 23, 'PPL', 'P'),
(128895, 'South Hiram', 43.8127784729004, 0.764677238799005, -70.878059387207, -1.23705550373084, 218, 26, 'PPL', 'P'),
(34010, 'South Hoisington', 38.5055618286133, 0.67204883423955, -98.7750015258789, -1.72394899528901, 218, 20, 'PPL', 'P'),
(121515, 'South Holland', 41.600830078125, 0.726071456425971, -87.6069412231445, -1.52902957194502, 218, 18, 'PPL', 'P'),
(138181, 'South Hollandale', 43.7208290100098, 0.763072417926123, -93.1894378662109, -1.62646251884806, 218, 28, 'PPL', 'P'),
(128896, 'South Hollis', 43.5697212219238, 0.760435089498618, -70.6333312988281, -1.23278419281651, 218, 26, 'PPL', 'P'),
(5956, 'South Holt', 33.232780456543, 0.580021438559099, -87.48388671875, -1.52688186568393, 218, 2, 'PPL', 'P'),
(68933, 'South Hominy', 35.4919395446777, 0.619451202973404, -82.7383270263672, -1.44405622420192, 218, 33, 'PPL', 'P'),
(144478, 'South Hooksett', 43.0263900756836, 0.750952172068091, -71.4358291625977, -1.24679042277951, 218, 36, 'PPL', 'P'),
(128897, 'South Hope', 44.2144393920898, 0.771687544315448, -69.1922225952148, -1.20763210105931, 218, 26, 'PPL', 'P'),
(169616, 'South Hopkinton', 41.4119415283203, 0.722774729312562, -71.7591705322266, -1.25243379428745, 218, 47, 'PPL', 'P'),
(152734, 'South Horicon', 43.6544418334961, 0.761913743114857, -73.7611083984375, -1.28737420147318, 218, 40, 'PPL', 'P'),
(152731, 'South Hornell', 42.3019409179688, 0.738308149002667, -77.6561126708984, -1.35535485040687, 218, 40, 'PPL', 'P'),
(98187, 'South Houston', 29.6627807617188, 0.517713189589224, -95.2352828979492, -1.66216925063746, 218, 51, 'PPL', 'P'),
(152732, 'South Huntington', 40.8236083984375, 0.712506379097544, -73.399169921875, -1.28105718336751, 218, 40, 'PPL', 'P'),
(34012, 'South Hutchinson', 38.0280609130859, 0.663714871082311, -97.9400024414063, -1.70937551201382, 218, 20, 'PPL', 'P'),
(18135, 'South Idylwild', 29.6124992370605, 0.516835611431015, -82.3461074829102, -1.43721070177792, 218, 12, 'PPL', 'P'),
(152733, 'South Ilion', 42.9952812194824, 0.750409220100851, -75.0494384765625, -1.30985980318893, 218, 40, 'PPL', 'P'),
(138182, 'South International Falls', 48.586669921875, 0.847997362716415, -93.3988876342773, -1.63011810691836, 218, 28, 'PPL', 'P'),
(133184, 'South Ionia', 42.9688911437988, 0.749948626390322, -85.0694427490234, -1.48474186880728, 218, 27, 'PPL', 'P'),
(38293, 'South Irvine', 37.6833305358887, 0.657698190968577, -83.976936340332, -1.46567403487647, 218, 21, 'PPL', 'P'),
(176447, 'South Itasca', 46.6616706848145, 0.81439978793133, -92.004997253418, -1.60579013036048, 218, 57, 'PPL', 'P'),
(106414, 'South Jackson', 38.7380599975586, 0.676106692792504, -78.6427764892578, -1.37257538264754, 218, 53, 'PPL', 'P'),
(133185, 'South Jackson', 42.1602783203125, 0.735835670246638, -84.4277801513672, -1.47354274379127, 218, 27, 'PPL', 'P'),
(18136, 'South Jacksonville', 30.3108291625977, 0.529023767896845, -81.6458282470703, -1.42498852342917, 218, 12, 'PPL', 'P'),
(28642, 'South Jacksonville', 39.708610534668, 0.693045995222062, -90.2280578613281, -1.57477668736013, 218, 18, 'PPL', 'P'),
(152735, 'South Jamesport', 40.9363899230957, 0.714474788038248, -72.5777816772461, -1.26672125406156, 218, 40, 'PPL', 'P'),
(128899, 'South Jefferson', 44.163890838623, 0.770805305625332, -69.5475006103516, -1.2138328721834, 218, 26, 'PPL', 'P'),
(152741, 'South Jefferson', 42.4508285522461, 0.740906728436312, -74.5780563354492, -1.30163263279141, 218, 40, 'PPL', 'P'),
(152736, 'South Jewett', 42.223331451416, 0.736936154988086, -74.2563934326172, -1.29601855605546, 218, 40, 'PPL', 'P'),
(98188, 'South Jonestown Hills', 30.4694404602051, 0.531792057270955, -97.9377822875977, -1.70933676301996, 218, 51, 'PPL', 'P'),
(205826, 'South Jordan', 40.5622215270996, 0.707944317571211, -111.928886413574, -1.95352759600762, 218, 52, 'PPL', 'P'),
(152737, 'South Junction', 44.6330604553223, 0.778993860187053, -73.4544372558594, -1.28202178031433, 218, 40, 'PPL', 'P'),
(144479, 'South Keene', 42.9169387817383, 0.749041886618177, -72.2455596923828, -1.26092288657818, 218, 36, 'PPL', 'P'),
(43130, 'South Kenner', 29.958610534668, 0.522876393152615, -90.2705612182617, -1.57551851088177, 218, 22, 'PPL', 'P'),
(176455, 'South Kenosha', 42.5402793884277, 0.742467940046344, -87.8341674804688, -1.53299541828231, 218, 57, 'PPL', 'P'),
(51558, 'South Kensington', 39.0188903808594, 0.68100810762074, -77.0802764892578, -1.34530461308512, 218, 25, 'PPL', 'P'),
(114086, 'South Kent', 41.6794395446777, 0.727443450440553, -73.4711074829102, -1.28231273066343, 218, 8, 'PPL', 'P'),
(114087, 'South Killingly', 41.7911109924316, 0.729392484884327, -71.833610534668, -1.25373301742524, 218, 8, 'PPL', 'P'),
(144480, 'South Kingston', 42.8805618286133, 0.748406989014302, -71.0819396972656, -1.24061388642135, 218, 36, 'PPL', 'P'),
(172554, 'South Kirby', 44.4702796936035, 0.776152799936156, -71.9027786254883, -1.25494022834737, 218, 55, 'PPL', 'P'),
(24963, 'South Kirkwood', 33.7519416809082, 0.589082511272958, -84.3233337402344, -1.47171981002511, 218, 13, 'PPL', 'P'),
(90919, 'South Knoxville', 35.9430618286133, 0.627324772157196, -83.8988876342773, -1.4643118279789, 218, 50, 'PPL', 'P'),
(179197, 'South Komelik', 31.7222194671631, 0.553657175742237, -111.772216796875, -1.95079319535838, 218, 5, 'PPL', 'P'),
(152738, 'South Kortright', 42.3422203063965, 0.739011156951421, -74.7174987792969, -1.30406636255357, 218, 40, 'PPL', 'P'),
(98189, 'South La Paloma Estates Colonia', 27.8990001678467, 0.486929410943375, -97.9700012207031, -1.70989908948413, 218, 51, 'PPL', 'P'),
(128920, 'South Lagrange', 45.1161117553711, 0.787424695828944, -68.815559387207, -1.20105808790845, 218, 26, 'PPL', 'P'),
(192906, 'South Laguna', 33.500560760498, 0.584695086535106, -117.742218017578, -2.05498937300773, 218, 6, 'PPL', 'P'),
(185282, 'South Lake', 35.6369400024414, 0.621981938378279, -118.366111755371, -2.06587837291479, 218, 6, 'PPL', 'P'),
(201579, 'South Lake Oswego', 45.4080581665039, 0.792520121942593, -122.672218322754, -2.14103411045737, 218, 43, 'PPL', 'P'),
(185283, 'South Lake Tahoe', 38.9333305358887, 0.679514806618506, -119.983329772949, -2.0941041520441, 218, 6, 'PPL', 'P'),
(167377, 'South Lakemont', 40.4658317565918, 0.706261998710607, -78.3927764892578, -1.36821205951755, 218, 45, 'PPL', 'P'),
(146346, 'South Lakewood', 40.0716705322266, 0.699382587561742, -74.2458267211914, -1.29583413214998, 218, 37, 'PPL', 'P'),
(126172, 'South Lancaster', 42.4444389343262, 0.740795208565665, -71.6875, -1.25118290752344, 218, 23, 'PPL', 'P'),
(144481, 'South Lancaster', 44.458610534668, 0.775949134691793, -71.6458282470703, -1.25045559822973, 218, 36, 'PPL', 'P'),
(185284, 'South Landing', 37.5819396972656, 0.655928587003246, -118.732780456543, -2.07227794901425, 218, 6, 'PPL', 'P'),
(152739, 'South Lansing', 42.5377807617188, 0.742424330783494, -76.5061111450195, -1.33528353737732, 218, 40, 'PPL', 'P'),
(123694, 'South LaPorte', 41.5750007629395, 0.725620649832448, -86.7397232055664, -1.51389376220566, 218, 19, 'PPL', 'P'),
(51559, 'South Laurel', 39.0697212219238, 0.681895273158873, -76.8505630493164, -1.34129535722206, 218, 25, 'PPL', 'P'),
(51560, 'South Lawn', 38.792781829834, 0.677061768938434, -76.9922180175781, -1.34376770282004, 218, 25, 'PPL', 'P'),
(98190, 'South Lawn', 29.6938896179199, 0.518256141556464, -95.3733291625977, -1.66457861247566, 218, 51, 'PPL', 'P'),
(12036, 'South Lead Hill', 36.394718170166, 0.635207662404803, -92.9105606079102, -1.62159519248178, 218, 4, 'PPL', 'P'),
(74353, 'South Lebanon', 39.3708305358887, 0.687150622095981, -84.2133331298828, -1.46979993719528, 218, 41, 'PPL', 'P'),
(128900, 'South Lebanon', 43.3375015258789, 0.756382091214654, -70.9427795410156, -1.23818508350719, 218, 26, 'PPL', 'P'),
(152740, 'South Lebanon', 42.7591705322266, 0.74628831120909, -75.658332824707, -1.32048701436084, 218, 40, 'PPL', 'P'),
(167378, 'South Lebanon', 40.3283309936523, 0.70386215767331, -76.4033279418945, -1.33348963206704, 218, 45, 'PPL', 'P'),
(201580, 'South Lebanon', 44.5063896179199, 0.776783037008124, -122.90193939209, -2.14504349947849, 218, 43, 'PPL', 'P'),
(57631, 'South Lee', 38.8888893127441, 0.67873916095102, -94.3777770996094, -1.64720295110149, 218, 29, 'PPL', 'P'),
(126174, 'South Lee', 42.2777786254883, 0.737886437444053, -73.2777786254883, -1.2789385055623, 218, 23, 'PPL', 'P'),
(144482, 'South Lee', 43.0986099243164, 0.752212646212025, -71.0422210693359, -1.2399206655896, 218, 36, 'PPL', 'P'),
(128901, 'South Leeds', 44.2533302307129, 0.772366317498282, -70.1313934326172, -1.2240237244107, 218, 26, 'PPL', 'P'),
(185285, 'South Leggett', 39.8486099243164, 0.69548944552221, -123.706390380859, -2.15908381790344, 218, 6, 'PPL', 'P'),
(128902, 'South Levant', 44.8574981689453, 0.782911037255423, -69.0111083984375, -1.20447106200345, 218, 26, 'PPL', 'P'),
(128903, 'South Lewiston', 44.065559387207, 0.769089098039858, -70.1430587768555, -1.22422732307603, 218, 26, 'PPL', 'P'),
(57632, 'South Liberty', 39.2011108398438, 0.684188454594513, -94.3888931274414, -1.6473969623869, 218, 29, 'PPL', 'P'),
(90920, 'South Liberty', 35.3633308410645, 0.61720655764863, -84.6269378662109, -1.47701870164605, 218, 50, 'PPL', 'P'),
(98191, 'South Liberty', 30.0288906097412, 0.524103011861192, -94.7919387817383, -1.65443143609024, 218, 51, 'PPL', 'P'),
(128904, 'South Liberty', 44.3233299255371, 0.773588042648356, -69.3594436645508, -1.21055065929793, 218, 26, 'PPL', 'P'),
(152742, 'South Lima', 42.855281829834, 0.747965769800703, -77.6755599975586, -1.3556942702878, 218, 40, 'PPL', 'P'),
(128905, 'South Limington', 43.708610534668, 0.762859165301835, -70.6999969482422, -1.23394772789677, 218, 26, 'PPL', 'P'),
(113081, 'South Lincoln', 42.413890838623, 0.740262043715431, -71.3263931274414, -1.24488040364571, 218, 23, 'PPL', 'P'),
(128906, 'South Lincoln', 45.3344383239746, 0.791235213295657, -68.5822219848633, -1.19698558196951, 218, 26, 'PPL', 'P'),
(172555, 'South Lincoln', 44.0713882446289, 0.769190830793499, -72.9730606079102, -1.27362017286541, 218, 55, 'PPL', 'P'),
(68935, 'South Lincolnton', 35.4541702270508, 0.618792004024582, -81.2438888549805, -1.41797335764374, 218, 33, 'PPL', 'P'),
(139463, 'South Lineville', 40.5788917541504, 0.708235267920302, -93.5236129760742, -1.63229497479339, 218, 29, 'PPL', 'P'),
(128907, 'South Livermore', 44.3683280944824, 0.77437340885382, -70.2055587768555, -1.22531815385853, 218, 26, 'PPL', 'P'),
(152743, 'South Livonia', 42.7708282470703, 0.746491776716372, -77.67138671875, -1.35562143283198, 218, 40, 'PPL', 'P'),
(121519, 'South Lockport', 41.5730590820313, 0.725586761107577, -88.054443359375, -1.53683995763195, 218, 18, 'PPL', 'P'),
(152744, 'South Lockport', 43.1500015258789, 0.753109598867164, -78.6969375610352, -1.37352067167646, 218, 40, 'PPL', 'P'),
(74354, 'South Logan', 39.5288887023926, 0.689909257511139, -82.408332824707, -1.43829673887046, 218, 41, 'PPL', 'P'),
(172556, 'South Londonderry', 43.1927795410156, 0.753856216078768, -72.8147201538086, -1.27085661060223, 218, 55, 'PPL', 'P'),
(157717, 'South Lorain', 41.4388885498047, 0.72324504356107, -82.1366729736328, -1.43355538002373, 218, 41, 'PPL', 'P'),
(185286, 'South Los Angeles', 33.9275016784668, 0.592146611265148, -118.277221679688, -2.06432694842177, 218, 6, 'PPL', 'P'),
(5958, 'South Lowell', 33.9099998474121, 0.591841146688116, -87.2694396972656, -1.52313905908793, 218, 2, 'PPL', 'P'),
(126175, 'South Lowell', 42.6194381713867, 0.74384952144085, -71.2874984741211, -1.24420156388385, 218, 23, 'PPL', 'P'),
(128908, 'South Lubec', 44.8241691589355, 0.782329336294323, -66.9933319091797, -1.16925421869656, 218, 26, 'PPL', 'P'),
(172557, 'South Lunenburg', 44.4291687011719, 0.775435277759462, -71.6797180175781, -1.25104708630784, 218, 55, 'PPL', 'P'),
(114088, 'South Lyme', 41.3052787780762, 0.720913113131569, -72.2588882446289, -1.2611555136994, 218, 8, 'PPL', 'P'),
(83711, 'South Lynchburg', 34.0522193908691, 0.594323345982124, -80.0611114501953, -1.39732999761204, 218, 48, 'PPL', 'P'),
(144483, 'South Lyndeborough', 42.8800010681152, 0.748397201897296, -71.7841720581055, -1.25287015323205, 218, 36, 'PPL', 'P'),
(126176, 'South Lynnfield', 42.5166702270508, 0.742055882446681, -71.0019378662109, -1.23921759106182, 218, 23, 'PPL', 'P'),
(133186, 'South Lyon', 42.4605598449707, 0.741076571534832, -83.6516723632813, -1.4599971075388, 218, 27, 'PPL', 'P'),
(111464, 'South Madison', 38.0536117553711, 0.664160817406845, -81.8058319091797, -1.42778111414822, 218, 58, 'PPL', 'P'),
(157718, 'South Madison', 41.7252807617188, 0.72824353061104, -81.0502777099609, -1.41459420569459, 218, 41, 'PPL', 'P'),
(176449, 'South Madison', 43.0558280944824, 0.751465962421394, -89.3855590820313, -1.56007230971737, 218, 57, 'PPL', 'P'),
(111467, 'South Malden', 38.2922210693359, 0.668325335561456, -81.5680618286133, -1.42363124337961, 218, 58, 'PPL', 'P'),
(152745, 'South Manor', 40.8555603027344, 0.713064045029806, -72.8180618286133, -1.2709149338301, 218, 40, 'PPL', 'P'),
(43131, 'South Mansfield', 32.021671295166, 0.558883596092004, -93.7141723632813, -1.63562086352073, 218, 22, 'PPL', 'P'),
(146347, 'South Mantoloking Beach', 40.0227813720703, 0.698529310748481, -74.0552825927734, -1.29250850973874, 218, 37, 'PPL', 'P'),
(90921, 'South Mapleton Hills', 35.2297210693359, 0.61487462721913, -84.8486099243164, -1.48088760891966, 218, 50, 'PPL', 'P'),
(123695, 'South Marion', 40.9124984741211, 0.714057803590569, -87.1263885498047, -1.52064234556598, 218, 19, 'PPL', 'P'),
(38298, 'South Marshall', 36.7980613708496, 0.642247329272264, -88.3300018310547, -1.54164936024452, 218, 21, 'PPL', 'P'),
(31158, 'South Martin', 38.5444412231445, 0.672727407685302, -86.8741683959961, -1.51624027344213, 218, 19, 'PPL', 'P'),
(18140, 'South Masaryktown', 28.4280605316162, 0.496163256232952, -82.460563659668, -1.43920833891159, 218, 12, 'PPL', 'P'),
(126177, 'South Mashpee', 41.5825004577637, 0.725751544200025, -70.4775009155273, -1.23006443955327, 218, 23, 'PPL', 'P'),
(126179, 'South Meadow Village', 41.8938903808594, 0.731186323615577, -70.7513885498047, -1.23484468055191, 218, 23, 'PPL', 'P'),
(83712, 'South Meadows Farms', 34.9155616760254, 0.609391511429793, -81.9472198486328, -1.43024879921429, 218, 48, 'PPL', 'P'),
(79161, 'South Media', 39.9088897705078, 0.696541527310846, -75.3836135864258, -1.31569225913426, 218, 45, 'PPL', 'P'),
(114089, 'South Meriden', 41.5161094665527, 0.724592802809732, -72.8341674804688, -1.27119603048316, 218, 8, 'PPL', 'P'),
(144484, 'South Merrimack', 42.8047218322754, 0.747083331373506, -71.5555572509766, -1.24888007212884, 218, 36, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(43133, 'South Merrywoods', 32.5541687011719, 0.568177429085135, -93.5599975585938, -1.63293000555532, 218, 22, 'PPL', 'P'),
(18137, 'South Metro', 30.2875003814697, 0.528616603855685, -81.6333312988281, -1.42477041053589, 218, 12, 'PPL', 'P'),
(18138, 'South Miami', 25.7072200775146, 0.448675631887423, -80.2936096191406, -1.40138785616499, 218, 12, 'PPL', 'P'),
(18139, 'South Miami Heights', 25.5972194671631, 0.446755759057584, -80.3808288574219, -1.40291011904408, 218, 12, 'PPL', 'P'),
(126180, 'South Middleboro', 41.8241691589355, 0.729969458734493, -70.8280563354492, -1.23618278584162, 218, 23, 'PPL', 'P'),
(126181, 'South Middleton', 42.5708312988281, 0.743001171475605, -71.029167175293, -1.23969283215834, 218, 23, 'PPL', 'P'),
(74355, 'South Middletown', 39.4811096191406, 0.689075355194808, -84.4008331298828, -1.47307242954277, 218, 41, 'PPL', 'P'),
(74356, 'South Milford', 39.1547203063965, 0.683378787044102, -84.288330078125, -1.47110888087105, 218, 41, 'PPL', 'P'),
(123696, 'South Milford', 41.5325012207031, 0.724878892889834, -85.272216796875, -1.48828094357988, 218, 19, 'PPL', 'P'),
(126182, 'South Milford', 42.1027793884277, 0.734832124568868, -71.5047225952148, -1.24799284001168, 218, 23, 'PPL', 'P'),
(144485, 'South Milford', 42.8244400024414, 0.747427478365371, -71.6608276367188, -1.25071738696489, 218, 36, 'PPL', 'P'),
(14650, 'South Milford (historical)', 38.9113883972168, 0.679131844053752, -75.4291687011719, -1.3164873458777, 218, 10, 'PPL', 'P'),
(189590, 'South Mill', 33.1672210693359, 0.578877211396747, -104.143890380859, -1.81765378298205, 218, 38, 'PPL', 'P'),
(152758, 'South Millbrook', 41.774169921875, 0.729096807424301, -73.6983337402344, -1.28627857700072, 218, 40, 'PPL', 'P'),
(24964, 'South Millen (historical)', 32.7938919067383, 0.572361388315704, -81.9513931274414, -1.43032163667011, 218, 13, 'PPL', 'P'),
(68936, 'South Mills', 36.4455604553223, 0.636095027680017, -76.3277816772461, -1.33217110101134, 218, 33, 'PPL', 'P'),
(176450, 'South Milwaukee', 42.9105606079102, 0.748930566484612, -87.8605575561523, -1.53345601199284, 218, 57, 'PPL', 'P'),
(98195, 'South Minnesota Road Colonia', 26.2320003509521, 0.457834775508423, -98.3789978027344, -1.71703742646998, 218, 51, 'PPL', 'P'),
(98192, 'South Minnesota Road Colonia Number 2', 26.2310009002686, 0.457817331803283, -98.379997253418, -1.71705487017512, 218, 51, 'PPL', 'P'),
(98193, 'South Minnesota Road Colonia Number 3', 26.2310009002686, 0.457817331803283, -98.3769989013672, -1.7170025390597, 218, 51, 'PPL', 'P'),
(199693, 'South Mitchell', 41.9111099243164, 0.731486861344593, -103.812782287598, -1.81187485657463, 218, 35, 'PPL', 'P'),
(128909, 'South Monmouth', 44.1816711425781, 0.771115630471353, -69.9930572509766, -1.22160930256643, 218, 26, 'PPL', 'P'),
(133189, 'South Monroe', 41.8958282470703, 0.731220145761421, -83.4177780151367, -1.45591488106188, 218, 27, 'PPL', 'P'),
(126183, 'South Monson', 42.0916709899902, 0.734638246441511, -72.3111114501953, -1.26206698058248, 218, 23, 'PPL', 'P'),
(133188, 'South Monterey', 42.6025009155273, 0.743553910559851, -85.8436126708984, -1.4982536829139, 218, 27, 'PPL', 'P'),
(208795, 'South Montesano', 46.9577789306641, 0.81956785176371, -123.60417175293, -2.15729976628919, 218, 56, 'PPL', 'P'),
(167384, 'South Montrose', 41.7972183227539, 0.729499077906958, -75.8916702270508, -1.32455952029979, 218, 45, 'PPL', 'P'),
(128910, 'South Montville', 44.374439239502, 0.774480068455478, -69.2675018310547, -1.20894597158311, 218, 26, 'PPL', 'P'),
(199694, 'South Morrill', 41.9297218322754, 0.731811700418555, -103.927780151367, -1.81388194793017, 218, 35, 'PPL', 'P'),
(24965, 'South Moultrie', 31.1558303833008, 0.543771821381486, -83.773063659668, -1.46211578534402, 218, 13, 'PPL', 'P'),
(34013, 'South Mound', 37.4372215270996, 0.653402778446388, -95.2283325195313, -1.66204794364981, 218, 20, 'PPL', 'P'),
(157719, 'South Mount Vernon', 40.3816719055176, 0.704793132211374, -82.4925003051758, -1.43976573852774, 218, 41, 'PPL', 'P'),
(79162, 'South Mountain', 39.8463897705078, 0.695450696528349, -77.4880599975586, -1.35242177794031, 218, 45, 'PPL', 'P'),
(98194, 'South Mountain', 31.4274997711182, 0.548513346675776, -97.6772232055664, -1.70478914914254, 218, 51, 'PPL', 'P'),
(195634, 'South Mountain', 42.7522201538086, 0.746167004221437, -116.922500610352, -2.04068260531571, 218, 17, 'PPL', 'P'),
(179198, 'South Mountain Trailer Park', 33.3694381713867, 0.582406565631374, -112.073608398438, -1.9560534711435, 218, 5, 'PPL', 'P'),
(18141, 'South Mulberry', 27.8855590820313, 0.486694819740853, -81.9749984741211, -1.43073362769074, 218, 12, 'PPL', 'P'),
(212157, 'South Naknek', 58.7155609130859, 1.02477986008864, -156.998062133789, -2.74013310348525, 218, 1, 'PPL', 'P'),
(128911, 'South Naples', 43.9275016784668, 0.766679536464581, -70.6141662597656, -1.2324496997836, 218, 26, 'PPL', 'P'),
(126184, 'South Natick', 42.273609161377, 0.737813666567267, -71.3166732788086, -1.24471076028427, 218, 23, 'PPL', 'P'),
(146348, 'South Netcong', 40.8930587768555, 0.713718516867693, -74.6875, -1.30354278508326, 218, 37, 'PPL', 'P'),
(152746, 'South New Berlin', 42.5294418334961, 0.742278789029921, -75.3855590820313, -1.31572621443816, 218, 40, 'PPL', 'P'),
(167385, 'South New Castle', 40.9777793884277, 0.715197170483932, -80.3452835083008, -1.40228973566815, 218, 45, 'PPL', 'P'),
(152747, 'South New Haven', 43.4563903808594, 0.758457093177989, -76.353889465332, -1.33262676787386, 218, 40, 'PPL', 'P'),
(157720, 'South New Lyme', 41.5816688537598, 0.725737029972084, -80.7772216796875, -1.40982847892389, 218, 41, 'PPL', 'P'),
(128912, 'South Newburgh', 44.6897201538086, 0.779982758478827, -69.0122222900391, -1.2044905030794, 218, 26, 'PPL', 'P'),
(144486, 'South Newbury', 43.2955589294434, 0.755650054810018, -71.9972229003906, -1.25658859190408, 218, 36, 'PPL', 'P'),
(157721, 'South Newbury', 41.4391708374023, 0.723249970409087, -81.2080612182617, -1.41734804741978, 218, 41, 'PPL', 'P'),
(172558, 'South Newbury', 44.0461082458496, 0.7687496115799, -72.0852813720703, -1.25812550216916, 218, 55, 'PPL', 'P'),
(128913, 'South Newcastle', 44.003059387207, 0.767998267257361, -69.6127777099609, -1.21497217249774, 218, 26, 'PPL', 'P'),
(172559, 'South Newfane', 42.938060760498, 0.749410534692071, -72.7058334350586, -1.26895617884835, 218, 55, 'PPL', 'P'),
(144487, 'South Newington', 43.0669403076172, 0.751659907127779, -70.8311080932617, -1.23623604906342, 218, 36, 'PPL', 'P'),
(24966, 'South Newport', 31.6347198486328, 0.552130019304645, -81.3963928222656, -1.42063505399521, 218, 13, 'PPL', 'P'),
(172560, 'South Newport', 44.8802795410156, 0.783308647206172, -72.3361129760742, -1.26250333952709, 218, 55, 'PPL', 'P'),
(152748, 'South Newstead', 42.9622192382813, 0.749832179671658, -78.5133285522461, -1.37031608993677, 218, 40, 'PPL', 'P'),
(157722, 'South Niles', 41.1749992370605, 0.71863930619286, -80.7669372558594, -1.40964898186642, 218, 41, 'PPL', 'P'),
(114094, 'South Norfolk', 41.9230613708496, 0.731695453436973, -73.2077789306641, -1.27771678041222, 218, 8, 'PPL', 'P'),
(172561, 'South Northfield', 44.1152801513672, 0.76995688908106, -72.6547164916992, -1.26806401988317, 218, 55, 'PPL', 'P'),
(114091, 'South Norwalk', 41.0936088562012, 0.717218776067411, -73.4191665649414, -1.28140619062836, 218, 8, 'PPL', 'P'),
(111474, 'South Nuttall (historical)', 38.0466690063477, 0.664039643577246, -81.0374984741211, -1.41437116595329, 218, 58, 'PPL', 'P'),
(152749, 'South Nyack', 41.0830612182617, 0.71703468505706, -73.9205627441406, -1.29015720481231, 218, 40, 'PPL', 'P'),
(24971, 'South Oak Mobile Home Park', 33.5086097717285, 0.584835568282608, -84.6363906860352, -1.47718368447558, 218, 13, 'PPL', 'P'),
(24967, 'South Oaks', 32.5763893127441, 0.568565251918878, -83.6374969482422, -1.45974969987354, 218, 13, 'PPL', 'P'),
(51561, 'South Ocean Pines', 38.3827781677246, 0.669905855089391, -75.1458282470703, -1.31154212204954, 218, 25, 'PPL', 'P'),
(185287, 'South Oceanside', 33.1772193908691, 0.579051715027174, -117.355560302734, -2.04824092280547, 218, 6, 'PPL', 'P'),
(205830, 'South Ogden', 41.1919403076172, 0.718934983652886, -111.970558166504, -1.95425490530132, 218, 52, 'PPL', 'P'),
(146349, 'South Ogdensburg', 41.0747184753418, 0.71688907672446, -74.5966720581055, -1.3019575384444, 218, 37, 'PPL', 'P'),
(146350, 'South Old Bridge', 40.4080581665039, 0.705253659342876, -74.3547210693359, -1.29773469706191, 218, 37, 'PPL', 'P'),
(152750, 'South Olean', 42.0738906860352, 0.734327921595489, -78.4411087036133, -1.36905561579283, 218, 40, 'PPL', 'P'),
(74357, 'South Olive', 39.6688919067383, 0.692352774390314, -81.4863891601563, -1.42220578640614, 218, 41, 'PPL', 'P'),
(143049, 'South Omaha', 41.2105598449707, 0.719259955884903, -95.9622192382813, -1.67485668322865, 218, 35, 'PPL', 'P'),
(152751, 'South Onondaga', 42.9302787780762, 0.749274713476477, -76.2130584716797, -1.33016880334577, 218, 40, 'PPL', 'P'),
(146351, 'South Orange', 40.7488899230957, 0.711202295690759, -74.2616729736328, -1.29611070142918, 218, 37, 'PPL', 'P'),
(5959, 'South Orchard', 30.4647197723389, 0.531709665724731, -88.1505584716797, -1.53851748280259, 218, 2, 'PPL', 'P'),
(128914, 'South Orland', 44.5066719055176, 0.77678796385614, -68.7594375610352, -1.20007857725952, 218, 26, 'PPL', 'P'),
(126185, 'South Orleans', 41.750560760498, 0.728684749824639, -69.9916687011719, -1.22158506780051, 218, 23, 'PPL', 'P'),
(185288, 'South Oroville', 39.4966697692871, 0.689346931046969, -121.551109313965, -2.12146706698023, 218, 6, 'PPL', 'P'),
(128915, 'South Orrington', 44.6933288574219, 0.780045742238607, -68.8177795410156, -1.20109683690231, 218, 26, 'PPL', 'P'),
(152752, 'South Otselic', 42.646671295166, 0.744324829116402, -75.7816696166992, -1.32263964746995, 218, 40, 'PPL', 'P'),
(121522, 'South Ottawa (historical)', 41.3316688537598, 0.721373706842099, -88.8369369506836, -1.55049704717604, 218, 18, 'PPL', 'P'),
(152753, 'South Owego', 42.0244407653809, 0.733464857665222, -76.2144393920898, -1.33019290495363, 218, 40, 'PPL', 'P'),
(152754, 'South Oxford', 42.3880615234375, 0.739811237121908, -75.6216735839844, -1.31984718990895, 218, 40, 'PPL', 'P'),
(12037, 'South Ozark', 35.480281829834, 0.619247737466122, -93.8308334350586, -1.63765698333215, 218, 4, 'PPL', 'P'),
(152755, 'South Ozone Park', 40.6699981689453, 0.709825374828161, -73.8194427490234, -1.28839232795791, 218, 40, 'PPL', 'P'),
(98196, 'South Padre Island', 26.1033306121826, 0.455589064919214, -97.164436340332, -1.69583932998322, 218, 51, 'PPL', 'P'),
(18142, 'South Palm Beach', 26.5886096954346, 0.46405878271302, -80.0388870239258, -1.39694210819927, 218, 12, 'PPL', 'P'),
(98197, 'South Palm Gardens Estates Number 1 Colonia', 26.1480007171631, 0.456368705328334, -97.9550018310547, -1.70963730074898, 218, 51, 'PPL', 'P'),
(98198, 'South Palm Gardens Estates Number 2 Colonia', 26.1490001678467, 0.456386149033474, -97.9550018310547, -1.70963730074898, 218, 51, 'PPL', 'P'),
(128917, 'South Paris', 44.2236099243164, 0.771847600296962, -70.5138931274414, -1.23069960347325, 218, 26, 'PPL', 'P'),
(38294, 'South Park', 38.1124992370605, 0.665188597850533, -85.7477798461914, -1.49658108459128, 218, 21, 'PPL', 'P'),
(71413, 'South Park', 39.8261108398438, 0.695096762419477, -74.6047210693359, -1.3020980201919, 218, 37, 'PPL', 'P'),
(111469, 'South Park', 39.1066703796387, 0.682540157616836, -80.394172668457, -1.40314301248141, 218, 58, 'PPL', 'P'),
(121524, 'South Park', 41.7355613708496, 0.728422961089484, -88.3036117553711, -1.541188766534, 218, 18, 'PPL', 'P'),
(123697, 'South Park', 41.4008293151855, 0.722580784606177, -85.7211074829102, -1.49611556403273, 218, 19, 'PPL', 'P'),
(133190, 'South Park', 42.9427795410156, 0.749492892948782, -82.4563903808594, -1.43913550145578, 218, 27, 'PPL', 'P'),
(157723, 'South Park', 40.8163909912109, 0.712380411577983, -83.2866668701172, -1.45362655989523, 218, 41, 'PPL', 'P'),
(185289, 'South Park', 33.5716705322266, 0.585936186182111, -117.02555847168, -2.04248130431595, 218, 6, 'PPL', 'P'),
(208796, 'South Park', 47.526668548584, 0.829496848676825, -122.313331604004, -2.13477035557351, 218, 56, 'PPL', 'P'),
(209747, 'South Park', 43.4222183227539, 0.757860678251865, -110.792503356934, -1.93369397010536, 218, 59, 'PPL', 'P'),
(111471, 'South Park Trailer Park', 39.105281829834, 0.682515922850916, -80.3902816772461, -1.40307510187361, 218, 58, 'PPL', 'P'),
(38295, 'South Park View', 38.1183280944824, 0.665290330604174, -85.7216720581055, -1.49612541772876, 218, 21, 'PPL', 'P'),
(111472, 'South Parkersburg', 39.2366714477539, 0.684809104286556, -81.5425033569336, -1.42318516389702, 218, 58, 'PPL', 'P'),
(38296, 'South Parkland', 38.228889465332, 0.667219990551019, -85.8119430541992, -1.49770094382966, 218, 21, 'PPL', 'P'),
(128918, 'South Parsonsfield', 43.6958312988281, 0.762636125560541, -70.9002838134766, -1.23744339314361, 218, 26, 'PPL', 'P'),
(18143, 'South Pasadena', 27.7547206878662, 0.484411258974651, -82.7377777099609, -1.44404663682199, 218, 12, 'PPL', 'P'),
(185291, 'South Pasadena', 34.1161117553711, 0.595438478109568, -118.149436950684, -2.06209668416688, 218, 6, 'PPL', 'P'),
(61829, 'South Pascagoula', 30.3463897705078, 0.529644417588888, -88.5322189331055, -1.54517871447915, 218, 30, 'PPL', 'P'),
(43134, 'South Pass', 28.9944400787354, 0.506048444146136, -89.1427764892578, -1.55583495410694, 218, 22, 'PPL', 'P'),
(209748, 'South Pass City', 42.4683303833008, 0.741212193013344, -108.799171447754, -1.89890376520511, 218, 59, 'PPL', 'P'),
(126186, 'South Pasture (historical)', 41.25, 0.719948316447661, -70.091667175293, -1.2233303704209, 218, 23, 'PPL', 'P'),
(18144, 'South Patrick', 28.1983299255371, 0.49215370076427, -80.595832824707, -1.40666264617806, 218, 12, 'PPL', 'P'),
(18145, 'South Patrick Shores', 28.201940536499, 0.492216717813564, -80.6097183227539, -1.40690499383726, 218, 12, 'PPL', 'P'),
(24968, 'South Paulding Woods', 33.8113899230957, 0.590120078833652, -84.8222198486328, -1.48042701520913, 218, 13, 'PPL', 'P'),
(121525, 'South Paw Paw', 41.6647186279297, 0.727186521974387, -88.9411087036133, -1.55231518725224, 218, 18, 'PPL', 'P'),
(126187, 'South Peabody', 42.5097198486328, 0.741934575459028, -70.9499969482422, -1.23831105102676, 218, 23, 'PPL', 'P'),
(172562, 'South Peacham', 44.3147201538086, 0.773437773783848, -72.166389465332, -1.25954110544659, 218, 55, 'PPL', 'P'),
(121526, 'South Pekin', 40.4944381713867, 0.70676127483597, -89.6516723632813, -1.56471686265846, 218, 18, 'PPL', 'P'),
(71414, 'South Pemberton', 39.9674987792969, 0.697564447485545, -74.6852798461914, -1.3035040360894, 218, 37, 'PPL', 'P'),
(157724, 'South Peninsula Cottage Area', 40.7513885498047, 0.711245904953609, -82.3691711425781, -1.43761323857669, 218, 41, 'PPL', 'P'),
(71415, 'South Penns Grove', 39.7216682434082, 0.693273895232346, -75.459716796875, -1.31702051072794, 218, 37, 'PPL', 'P'),
(128919, 'South Penobscot', 44.4508285522461, 0.775813313476199, -68.7030563354492, -1.19909453923674, 218, 26, 'PPL', 'P'),
(126188, 'South Pepperell', 42.6416702270508, 0.744237544011674, -71.6055603027344, -1.24975279001806, 218, 23, 'PPL', 'P'),
(74358, 'South Perry', 39.4966697692871, 0.689346931046969, -82.6711120605469, -1.44288310174174, 218, 41, 'PPL', 'P'),
(123698, 'South Peru', 40.7455596923828, 0.711144172199968, -86.0569381713867, -1.50197691527589, 218, 19, 'PPL', 'P'),
(189591, 'South Petaca', 36.4972190856934, 0.636996640867064, -106.009719848633, -1.85021865047543, 218, 38, 'PPL', 'P'),
(167390, 'South Philipsburg', 40.8858299255371, 0.713592349611051, -78.2211074829102, -1.36521587013316, 218, 45, 'PPL', 'P'),
(179199, 'South Phoenix', 33.4066696166992, 0.583056376937353, -112.072776794434, -1.95603895691556, 218, 5, 'PPL', 'P'),
(18146, 'South Pine Lakes', 28.9313907623291, 0.504948025983715, -81.4322204589844, -1.42126036421917, 218, 12, 'PPL', 'P'),
(24969, 'South Pine Ranchettes', 32.9688911437988, 0.575415701190889, -85.0069427490234, -1.48365103802478, 218, 13, 'PPL', 'P'),
(51563, 'South Piscataway', 38.6858291625977, 0.67519509275137, -76.9805603027344, -1.34356423731276, 218, 25, 'PPL', 'P'),
(90922, 'South Pittsburg', 35.0122184753418, 0.611078490822303, -85.7044372558594, -1.49582461368364, 218, 50, 'PPL', 'P'),
(146353, 'South Plainfield', 40.5791702270508, 0.708240128189291, -74.4119415283203, -1.29873338247069, 218, 37, 'PPL', 'P'),
(12039, 'South Plains', 34.8413887023926, 0.608096948823905, -90.9963912963867, -1.58818663555506, 218, 4, 'PPL', 'P'),
(192248, 'South Plains', 34.2244415283203, 0.59732918932547, -101.309173583984, -1.76817864151499, 218, 51, 'PPL', 'P'),
(187380, 'South Platte', 39.4075012207031, 0.687790646284954, -105.170829772949, -1.83557725659244, 218, 7, 'PPL', 'P'),
(152756, 'South Plattsburgh', 44.6363906860352, 0.779051983677844, -73.4883270263672, -1.28261326839244, 218, 40, 'PPL', 'P'),
(74359, 'South Plymouth', 39.5800018310547, 0.690801349897289, -83.586669921875, -1.45886260091443, 218, 41, 'PPL', 'P'),
(152757, 'South Plymouth', 42.5813903808594, 0.743185462223038, -75.5647201538086, -1.31885316503208, 218, 40, 'PPL', 'P'),
(126189, 'South Pocasset', 41.6749992370605, 0.727365952452831, -70.6091690063477, -1.2323624812579, 218, 23, 'PPL', 'P'),
(43135, 'South Point', 30.1427803039551, 0.526090762009313, -89.8844375610352, -1.56877938174333, 218, 22, 'PPL', 'P'),
(74360, 'South Point', 38.417781829834, 0.670516784243455, -82.5863876342773, -1.44140438154647, 218, 41, 'PPL', 'P'),
(83716, 'South Point', 35.0944404602051, 0.612513535175693, -81.0588912963867, -1.41474454113812, 218, 48, 'PPL', 'P'),
(98199, 'South Point', 25.8683300018311, 0.451487530524383, -97.3833312988281, -1.699659767725, 218, 51, 'PPL', 'P'),
(106417, 'South Point', 37.7872200012207, 0.659511404196757, -75.5597229003906, -1.31876594650638, 218, 53, 'PPL', 'P'),
(57637, 'South Point (historical)', 38.5438919067383, 0.672717820305378, -90.9783325195313, -1.58787145044005, 218, 29, 'PPL', 'P'),
(98200, 'South Point Colonia', 25.8638896942139, 0.451410032536661, -97.3919372558594, -1.69980997001048, 218, 51, 'PPL', 'P'),
(24970, 'South Pointe', 32.5205612182617, 0.567590867855045, -83.6438903808594, -1.45986128632321, 218, 13, 'PPL', 'P'),
(83717, 'South Pointe', 33.024169921875, 0.576380497874797, -80.149169921875, -1.39886690787713, 218, 48, 'PPL', 'P'),
(128921, 'South Poland', 44.0227813720703, 0.768342480828254, -70.3652801513672, -1.22810581772957, 218, 26, 'PPL', 'P'),
(172564, 'South Pomfret', 43.6650009155273, 0.762098033862291, -72.5400009155273, -1.26606185537565, 218, 55, 'PPL', 'P'),
(126190, 'South Pond', 41.9069404602051, 0.731414090467806, -70.6416702270508, -1.23292973457009, 218, 23, 'PPL', 'P'),
(18147, 'South Ponte Vedra Beach', 30.0222206115723, 0.523986598432042, -81.3238906860352, -1.41936965300326, 218, 12, 'PPL', 'P'),
(18148, 'South Port', 28.1383304595947, 0.491106512534137, -81.3525009155273, -1.41986899570765, 218, 12, 'PPL', 'P'),
(128922, 'South Portland', 43.6413917541504, 0.761685976262628, -70.2413864135742, -1.22594346408248, 218, 26, 'PPL', 'P'),
(201581, 'South Portland (historical)', 45.4877815246582, 0.793911557033132, -122.68138885498, -2.14119416643889, 218, 43, 'PPL', 'P'),
(128923, 'South Portland Gardens', 43.6388893127441, 0.761642300420751, -70.3158264160156, -1.22724268722028, 218, 26, 'PPL', 'P'),
(38297, 'South Portsmouth', 38.7244415283203, 0.675869005665214, -83.0133285522461, -1.44885590627651, 218, 21, 'PPL', 'P'),
(169618, 'South Portsmouth', 41.5447196960449, 0.725092145514122, -71.2616729736328, -1.24375082386935, 218, 47, 'PPL', 'P'),
(167395, 'South Pottstown', 40.2394409179688, 0.702310733180284, -75.6513900756836, -1.32036584053124, 218, 45, 'PPL', 'P'),
(172565, 'South Poultney', 43.4755592346191, 0.75879165278993, -73.2363891601563, -1.27821612311661, 218, 55, 'PPL', 'P'),
(198927, 'South Prairie', 48.0519409179688, 0.838664580992341, -101.295280456543, -1.76793616069774, 218, 34, 'PPL', 'P'),
(208797, 'South Prairie', 47.1394386291504, 0.822738411620477, -122.096939086914, -2.13099359367361, 218, 56, 'PPL', 'P'),
(128925, 'South Princeton', 45.1494407653809, 0.788006396790045, -67.5008316040039, -1.17811175932411, 218, 26, 'PPL', 'P'),
(152759, 'South Pulteney', 42.5008316040039, 0.741779446325531, -77.1883316040039, -1.34719053061106, 218, 40, 'PPL', 'P'),
(18152, 'South Punta Gorda Heights', 26.8652801513672, 0.468887593112038, -81.9911117553711, -1.43101485750185, 218, 12, 'PPL', 'P'),
(98201, 'South Purmela', 31.4697208404541, 0.549250243349401, -97.9719390869141, -1.70993291162998, 218, 51, 'PPL', 'P'),
(126191, 'South Quabbin Villa', 42.2788887023926, 0.737905811940983, -72.3783264160156, -1.26324010304266, 218, 23, 'PPL', 'P'),
(126192, 'South Quarter', 42.1416702270508, 0.735510897751703, -72.8625030517578, -1.27169057949759, 218, 23, 'PPL', 'P'),
(106418, 'South Quay', 36.6222190856934, 0.639178302432057, -76.8888931274414, -1.34196434328789, 218, 53, 'PPL', 'P'),
(126193, 'South Quincy', 42.2388916015625, 0.737207730840246, -71.0083312988281, -1.23932917751149, 218, 23, 'PPL', 'P'),
(509, 'South Radley', 37.4713897705078, 0.653999126793484, -94.7600021362305, -1.65387403647408, 218, 20, 'PPL', 'P'),
(172566, 'South Randolph', 43.894718170166, 0.766107356304378, -72.5766677856445, -1.2667018129856, 218, 55, 'PPL', 'P'),
(176452, 'South Randolph', 43.5111083984375, 0.759412102744891, -88.998893737793, -1.55332372635705, 218, 57, 'PPL', 'P'),
(133191, 'South Range', 47.0699996948242, 0.821526473587409, -88.6430587768555, -1.54711323469499, 218, 27, 'PPL', 'P'),
(176453, 'South Range', 46.6080589294434, 0.81346408628233, -91.9833297729492, -1.60541196148569, 218, 57, 'PPL', 'P'),
(128926, 'South Rangeley', 44.9375, 0.784307332614952, -70.751106262207, -1.23483975370389, 218, 26, 'PPL', 'P'),
(98202, 'South Ratliff Street Colonia', 26.1299991607666, 0.456054518898732, -97.6589965820313, -1.70447103455033, 218, 51, 'PPL', 'P'),
(123699, 'South Raub', 40.3013916015625, 0.703391976582856, -86.913330078125, -1.5169237737359, 218, 19, 'PPL', 'P'),
(172567, 'South Reading', 43.4741706848145, 0.75876741802401, -72.5897216796875, -1.26692964641686, 218, 55, 'PPL', 'P'),
(24972, 'South Ree Springs', 30.875280380249, 0.538875300111752, -83.269172668457, -1.45332122847625, 218, 13, 'PPL', 'P'),
(126194, 'South Rehoboth', 41.8041687011719, 0.729620384894611, -71.2825012207031, -1.24411434535815, 218, 23, 'PPL', 'P'),
(167393, 'South Renovo', 41.3230590820313, 0.721223437977591, -77.7486114501953, -1.35696925865967, 218, 45, 'PPL', 'P'),
(172568, 'South Richford', 44.9341697692871, 0.784249209124161, -72.6522216796875, -1.26802047719935, 218, 55, 'PPL', 'P'),
(31159, 'South Richmond', 39.8005599975586, 0.694650816094944, -84.8883285522461, -1.48158082975141, 218, 19, 'PPL', 'P'),
(106419, 'South Richmond', 37.5222206115723, 0.654886292331616, -77.4416732788086, -1.35161217696892, 218, 53, 'PPL', 'P'),
(24973, 'South Ridge', 33.7419395446777, 0.588907941063503, -84.6680603027344, -1.47773642355982, 218, 13, 'PPL', 'P'),
(138185, 'South Ridge', 43.8252792358398, 0.76489541827131, -91.4269409179688, -1.59570114404488, 218, 28, 'PPL', 'P'),
(34015, 'South Ridge (historical)', 37.7183303833008, 0.658309053543613, -95.5961074829102, -1.66846682766717, 218, 20, 'PPL', 'P'),
(106420, 'South Ridge (historical)', 38.454719543457, 0.671161468964336, -78.0163879394531, -1.36164284005665, 218, 53, 'PPL', 'P'),
(79163, 'South Ridge Estates', 39.8983306884766, 0.696357236563412, -76.6511077880859, -1.33781420620317, 218, 45, 'PPL', 'P'),
(117844, 'South Ridge Estates', 41.5138893127441, 0.724554053815871, -93.602783203125, -1.63367675592498, 218, 16, 'PPL', 'P'),
(106421, 'South Riding', 38.9208297729492, 0.679296627146201, -77.5041732788086, -1.35270300775142, 218, 53, 'PPL', 'P'),
(133192, 'South Riley', 42.8600006103516, 0.748048128057414, -84.6613922119141, -1.47762004342019, 218, 27, 'PPL', 'P'),
(38299, 'South Ripley', 38.7411117553711, 0.676159956014306, -83.8541717529297, -1.46353138862145, 218, 21, 'PPL', 'P'),
(152760, 'South Ripley', 42.1949996948242, 0.736441672552685, -79.720832824707, -1.39139101522311, 218, 40, 'PPL', 'P'),
(51564, 'South River', 38.9030609130859, 0.678986502037261, -76.5608291625977, -1.33623854694422, 218, 25, 'PPL', 'P'),
(57639, 'South River', 39.8325004577637, 0.695208282290125, -91.4477767944336, -1.59606479869173, 218, 29, 'PPL', 'P'),
(68940, 'South River', 34.958610534668, 0.610142855752331, -76.5972213745117, -1.33687371086421, 218, 33, 'PPL', 'P'),
(106425, 'South River', 37.7744407653809, 0.659288364455463, -79.3883285522461, -1.38558772089172, 218, 53, 'PPL', 'P'),
(146355, 'South River', 40.4463882446289, 0.705922645408704, -74.3863906860352, -1.29828743614616, 218, 37, 'PPL', 'P'),
(117845, 'South River Crossing (historical)', 41.2177810668945, 0.719385989983491, -93.7458267211914, -1.63617333628887, 218, 16, 'PPL', 'P'),
(51565, 'South River Estates', 38.9044418334961, 0.679010603645126, -76.5663909912109, -1.33633561916596, 218, 25, 'PPL', 'P'),
(51566, 'South River Heights', 38.9527816772461, 0.679854293078463, -76.5749969482422, -1.33648582145144, 218, 25, 'PPL', 'P'),
(51567, 'South River Manor', 38.9705581665039, 0.680164551345458, -76.57861328125, -1.33654893836927, 218, 25, 'PPL', 'P'),
(51568, 'South River Spring Lakes', 38.961109161377, 0.679999635094955, -76.6194381713867, -1.33726146711892, 218, 25, 'PPL', 'P'),
(51569, 'South River Towers', 38.9747200012207, 0.68023718906419, -76.5905609130859, -1.33675746388262, 218, 25, 'PPL', 'P'),
(128927, 'South Robbinston', 45.0572204589844, 0.786396848806228, -67.1205596923828, -1.17147476241347, 218, 26, 'PPL', 'P'),
(133193, 'South Rockwood', 42.0638885498047, 0.734153351386035, -83.2611083984375, -1.45318048041264, 218, 27, 'PPL', 'P'),
(68942, 'South Rocky Mount', 35.9244384765625, 0.626999733346151, -77.7969436645508, -1.35781281493495, 218, 33, 'PPL', 'P'),
(68943, 'South Rodanthe', 35.5869407653809, 0.621109287068087, -75.4688873291016, -1.31718056670945, 218, 33, 'PPL', 'P'),
(194427, 'South Roggen', 40.1022186279297, 0.699915752411976, -104.33805847168, -1.82104265546917, 218, 7, 'PPL', 'P'),
(121529, 'South Rome', 40.8497200012207, 0.712962112539083, -89.5374984741211, -1.56272415237281, 218, 18, 'PPL', 'P'),
(68944, 'South Rosemary', 36.4513893127441, 0.636196760433658, -77.6975021362305, -1.35607723285255, 218, 33, 'PPL', 'P'),
(24974, 'South Rossville', 34.9691696166992, 0.610327146499765, -85.2947235107422, -1.48867375984067, 218, 13, 'PPL', 'P'),
(126195, 'South Row', 42.6333312988281, 0.744092002258101, -71.70361328125, -1.25146413733455, 218, 23, 'PPL', 'P'),
(28653, 'South Roxana', 38.8294410705566, 0.677701593390325, -90.0627822875977, -1.57189208442541, 218, 18, 'PPL', 'P'),
(126196, 'South Royalston', 42.6305618286133, 0.744043665884316, -72.1477813720703, -1.25921633295166, 218, 23, 'PPL', 'P'),
(172569, 'South Royalton', 43.8208312988281, 0.764817787125534, -72.5216674804688, -1.26574187657068, 218, 55, 'PPL', 'P'),
(111473, 'South Ruffner', 38.3325004577637, 0.66902834351021, -81.6188888549805, -1.42451834233871, 218, 58, 'PPL', 'P'),
(128928, 'South Rumford', 44.5258293151855, 0.777122323731, -70.5347213745117, -1.23106312496205, 218, 26, 'PPL', 'P'),
(138186, 'South Rushford', 43.7961082458496, 0.764386288449914, -91.754997253418, -1.6014268072305, 218, 28, 'PPL', 'P'),
(152761, 'South Russell', 44.3713912963867, 0.774426871812703, -75.1277770996094, -1.31122707009258, 218, 40, 'PPL', 'P'),
(157731, 'South Russell', 41.4313888549805, 0.723114149193493, -81.3655624389648, -1.42009696229696, 218, 41, 'PPL', 'P'),
(172570, 'South Ryegate', 44.1883316040039, 0.771231877452935, -72.1413879394531, -1.25910474650198, 218, 55, 'PPL', 'P'),
(138187, 'South Saint Paul', 44.8927803039551, 0.783526826678477, -93.0347213745117, -1.62376220666077, 218, 28, 'PPL', 'P'),
(74362, 'South Salem', 39.336109161377, 0.686544619789933, -83.3066711425781, -1.45397570031413, 218, 41, 'PPL', 'P'),
(98203, 'South Salem', 31.2677803039551, 0.545725716094249, -96.0713882446289, -1.67676204183055, 218, 51, 'PPL', 'P'),
(123700, 'South Salem', 40.1511116027832, 0.700769095804265, -84.8411102294922, -1.48075671455208, 218, 19, 'PPL', 'P'),
(126197, 'South Salem', 42.5111083984375, 0.741958810224948, -70.8930587768555, -1.23731729246599, 218, 23, 'PPL', 'P'),
(152762, 'South Salem', 41.2722206115723, 0.720336139281404, -73.5533294677734, -1.28374777501681, 218, 40, 'PPL', 'P'),
(68945, 'South Salisbury', 35.6436080932617, 0.622098318517915, -80.4627838134766, -1.40434050286556, 218, 33, 'PPL', 'P'),
(205833, 'South Salt Lake', 40.7188911437988, 0.710678718220449, -111.887496948242, -1.95280521356193, 218, 52, 'PPL', 'P'),
(185292, 'South San Diego', 32.583610534668, 0.568691286017466, -117.09610748291, -2.04371261684595, 218, 6, 'PPL', 'P'),
(185293, 'South San Francisco', 37.6547203063965, 0.657198848264187, -122.406669616699, -2.13639941121231, 218, 6, 'PPL', 'P'),
(185294, 'South San Gabriel', 34.0625, 0.594502776460568, -118.08943939209, -2.06104952922626, 218, 6, 'PPL', 'P'),
(185295, 'South San Jose Hills', 34.0127792358398, 0.593634985419366, -117.90389251709, -2.05781112534072, 218, 6, 'PPL', 'P'),
(189592, 'South San Ysidro', 35.4500007629395, 0.618719233147795, -105.576942443848, -1.84266525983369, 218, 38, 'PPL', 'P'),
(126198, 'South Sandisfield', 42.0683288574219, 0.734230849373756, -73.1600036621094, -1.27688294467492, 218, 23, 'PPL', 'P'),
(128929, 'South Sanford', 43.4111099243164, 0.757666800124508, -70.7430572509766, -1.23469927195639, 218, 26, 'PPL', 'P'),
(18149, 'South Sanford Heights', 28.7605590820313, 0.501966450695803, -81.2663879394531, -1.41836604074647, 218, 12, 'PPL', 'P'),
(185299, 'South Santa Ana', 33.7113914489746, 0.588374776213269, -117.867218017578, -2.05717103457272, 218, 6, 'PPL', 'P'),
(185296, 'South Santa Rosa', 38.4049987792969, 0.670293677923134, -122.726387023926, -2.14197953264435, 218, 6, 'PPL', 'P'),
(179200, 'South Santan', 33.1175003051758, 0.578009420355544, -111.745559692383, -1.95032794111594, 218, 5, 'PPL', 'P'),
(83718, 'South Santee', 33.1733283996582, 0.578983804419377, -79.4177780151367, -1.3861017109821, 218, 48, 'PPL', 'P'),
(18150, 'South Sarasota', 27.2858295440674, 0.476227564681919, -82.5330581665039, -1.44047360674549, 218, 12, 'PPL', 'P'),
(201582, 'South Scappoose', 45.7430610656738, 0.798367025536834, -122.878326416016, -2.1446313752998, 218, 43, 'PPL', 'P'),
(152767, 'South Schenectady', 42.7869415283203, 0.746773006527484, -73.9713897705078, -1.29104430377141, 218, 40, 'PPL', 'P'),
(152763, 'South Schodack', 42.5125007629395, 0.741983111569895, -73.7061080932617, -1.28641426505826, 218, 40, 'PPL', 'P'),
(152764, 'South Schroon', 43.7949981689453, 0.764366913952984, -73.7925033569336, -1.28792214686746, 218, 40, 'PPL', 'P'),
(169619, 'South Scituate (historical)', 41.7788887023926, 0.729179165681012, -71.6069412231445, -1.24977689162593, 218, 47, 'PPL', 'P'),
(152765, 'South Scriba', 43.4288902282715, 0.757977124970529, -76.3824996948242, -1.33312611057825, 218, 40, 'PPL', 'P'),
(83721, 'South Sea Pines', 32.1119384765625, 0.560459055613868, -80.8172225952148, -1.41052662660366, 218, 48, 'PPL', 'P'),
(144488, 'South Seabrook', 42.8713912963867, 0.748246933032788, -70.8569412231445, -1.23668692223597, 218, 36, 'PPL', 'P'),
(71423, 'South Seaside Park', 39.9105606079102, 0.696570688924782, -74.0802764892578, -1.29294473552529, 218, 37, 'PPL', 'P'),
(208798, 'South Seattle', 47.5616683959961, 0.830107711251862, -122.311668395996, -2.13474132711762, 218, 56, 'PPL', 'P'),
(71417, 'South Seaville', 39.1788902282715, 0.68380063176077, -74.7602767944336, -1.30481297976518, 218, 37, 'PPL', 'P'),
(128930, 'South Sebec', 45.2080612182617, 0.789029516701826, -69.0841674804688, -1.20574618353338, 218, 26, 'PPL', 'P'),
(126199, 'South Seekonk', 41.788890838623, 0.729353735890466, -71.3194427490234, -1.24475909665805, 218, 23, 'PPL', 'P'),
(34017, 'South Seneca Gardens', 37.6011085510254, 0.656263146615187, -97.3488922119141, -1.69905869226697, 218, 20, 'PPL', 'P'),
(152766, 'South Setauket', 40.9136085510254, 0.714077178087499, -73.1061096191406, -1.2759423161779, 218, 40, 'PPL', 'P'),
(172571, 'South Shaftsbury', 42.9463882446289, 0.749555876708562, -73.2111129760742, -1.27777497048204, 218, 55, 'PPL', 'P'),
(5963, 'South Sheffield', 34.7422218322754, 0.606366160431463, -87.70361328125, -1.53071681765364, 218, 2, 'PPL', 'P'),
(126200, 'South Sherborn', 42.2236099243164, 0.736941015257075, -71.3555603027344, -1.24538946688808, 218, 23, 'PPL', 'P'),
(172572, 'South Sherburne', 43.605281829834, 0.761055739190661, -72.7527770996094, -1.26977550035771, 218, 55, 'PPL', 'P'),
(38302, 'South Shore', 38.7208290100098, 0.675805955326407, -82.9583282470703, -1.44789596986159, 218, 21, 'PPL', 'P'),
(57640, 'South Shore', 38.8652801513672, 0.678327103351358, -90.523063659668, -1.57992550985363, 218, 29, 'PPL', 'P'),
(98204, 'South Shore', 32.6699981689453, 0.570199034668614, -94.0827789306641, -1.64205426176604, 218, 51, 'PPL', 'P'),
(171320, 'South Shore', 45.1058311462402, 0.7872452653505, -96.9283294677734, -1.69171848767049, 218, 49, 'PPL', 'P'),
(157725, 'South Shore Acres', 40.5069389343262, 0.706979454308275, -84.4538879394531, -1.47399841065379, 218, 41, 'PPL', 'P'),
(43138, 'South Shore Estates', 32.5097198486328, 0.567401650259595, -93.8888931274414, -1.63867031612693, 218, 22, 'PPL', 'P'),
(12042, 'South Shore Park', 35.4652786254883, 0.61898588215194, -92.1158294677734, -1.60772451741826, 218, 4, 'PPL', 'P'),
(157726, 'South Shore Park', 41.686939239502, 0.72757434480813, -83.4049987792969, -1.45569184132058, 218, 41, 'PPL', 'P'),
(185298, 'South Shore Port', 37.4266700744629, 0.653218620857009, -122.040000915527, -2.12999983511285, 218, 6, 'PPL', 'P'),
(126201, 'South Shrewsbury', 42.2763900756836, 0.737862202678133, -71.716667175293, -1.2516919707658, 218, 23, 'PPL', 'P'),
(18151, 'South Side', 29.4436092376709, 0.513887924867975, -82.2544403076172, -1.43561080775306, 218, 12, 'PPL', 'P'),
(68946, 'South Side', 36.0719413757324, 0.629574144592904, -80.2397232055664, -1.40044736082603, 218, 33, 'PPL', 'P'),
(83719, 'South Side', 34.1305618286133, 0.595690679464798, -79.7594375610352, -1.3920647949789, 218, 48, 'PPL', 'P'),
(128931, 'South Side', 43.1344413757324, 0.752838023015003, -70.6805572509766, -1.23360844117389, 218, 26, 'PPL', 'P'),
(157728, 'South Side', 40.4769401550293, 0.706455876837965, -81.4497222900391, -1.4215658287962, 218, 41, 'PPL', 'P'),
(143059, 'South Side Mobile Home Court', 40.4986114501953, 0.706834112291784, -98.9475021362305, -1.72695969890134, 218, 35, 'PPL', 'P'),
(143060, 'South Side Mobile Home Park', 40.9930610656738, 0.715463886067104, -95.8888931274414, -1.67357690116682, 218, 35, 'PPL', 'P'),
(98205, 'South Side Place', 29.7066707611084, 0.518479214587271, -95.4316711425781, -1.66559687211845, 218, 51, 'PPL', 'P'),
(138188, 'South Silver Lake', 44.8849983215332, 0.783391005462883, -94.1988906860352, -1.64408079419753, 218, 28, 'PPL', 'P'),
(143061, 'South Sioux City', 42.4738883972168, 0.74130919865605, -96.413330078125, -1.68273005267536, 218, 35, 'PPL', 'P'),
(208801, 'South Snohomish', 47.899169921875, 0.835998224108954, -122.107780456543, -2.13118281126906, 218, 56, 'PPL', 'P'),
(152768, 'South Sodus', 43.1672210693359, 0.75341013659618, -76.9872207641602, -1.34368048429434, 218, 40, 'PPL', 'P'),
(112487, 'South Solon', 39.7377815246582, 0.693555125043458, -83.6133270263672, -1.45932785515687, 218, 41, 'PPL', 'P'),
(128932, 'South Solon', 44.9130592346191, 0.783880760787348, -69.7788925170898, -1.21787142281845, 218, 26, 'PPL', 'P'),
(146361, 'South Somerville (historical)', 40.5355606079102, 0.707478996749746, -74.6188888549805, -1.30234529469911, 218, 37, 'PPL', 'P'),
(152769, 'South Spafford', 42.7794418334961, 0.746642112159907, -76.2183303833008, -1.33026081556143, 218, 40, 'PPL', 'P'),
(126202, 'South Spencer', 42.2186088562012, 0.736853730152348, -72.0152816772461, -1.25690377701909, 218, 23, 'PPL', 'P'),
(189594, 'South Spring', 33.3355598449707, 0.581815277290349, -104.472221374512, -1.82338423985763, 218, 38, 'PPL', 'P'),
(189593, 'South Spring Acres', 33.3444404602051, 0.581970273265792, -104.485000610352, -1.82360727959892, 218, 38, 'PPL', 'P'),
(128933, 'South Springfield', 45.3661117553711, 0.79178801895893, -68.0963897705078, -1.18850621021675, 218, 26, 'PPL', 'P'),
(24975, 'South Springs', 32.5322189331055, 0.567794333362327, -83.6416702270508, -1.45982253732935, 218, 13, 'PPL', 'P'),
(172574, 'South Starksboro', 44.1624984741211, 0.770781004280385, -73.0141677856445, -1.27433762846307, 218, 55, 'PPL', 'P'),
(167398, 'South Sterling', 41.2641716003418, 0.720195657533902, -75.3483276367188, -1.31507640313218, 218, 45, 'PPL', 'P'),
(152770, 'South Stockton', 42.2444381713867, 0.737304536745871, -79.315559387207, -1.38431765936786, 218, 40, 'PPL', 'P'),
(144489, 'South Stoddard', 43.0400009155273, 0.751189726037326, -72.0722198486328, -1.25789753557985, 218, 36, 'PPL', 'P'),
(126203, 'South Stoughton', 42.1152801513672, 0.735050304041173, -71.0805587768555, -1.24058978481348, 218, 23, 'PPL', 'P'),
(167413, 'South Strabane', 40.1383285522461, 0.700545989483943, -80.1636123657227, -1.3991189760743, 218, 45, 'PPL', 'P'),
(172573, 'South Strafford', 43.8352813720703, 0.765069988480764, -72.3666687011719, -1.26303663753538, 218, 55, 'PPL', 'P'),
(28649, 'South Strasburg', 39.3458290100098, 0.686714263151371, -88.620002746582, -1.54671083105427, 218, 18, 'PPL', 'P'),
(128934, 'South Strong', 44.7669410705566, 0.781330517727489, -70.2099990844727, -1.22539565184625, 218, 26, 'PPL', 'P'),
(12041, 'South Stuttgart', 34.4936103820801, 0.602027072067397, -91.540283203125, -1.59767934010259, 218, 4, 'PPL', 'P'),
(126204, 'South Sudbury', 42.3624992370605, 0.739365091060292, -71.4138870239258, -1.24640746021476, 218, 23, 'PPL', 'P'),
(106426, 'South Suffolk', 36.7169418334961, 0.64083152625775, -76.5905609130859, -1.33675746388262, 218, 53, 'PPL', 'P'),
(98206, 'South Sulphur', 33.2649993896484, 0.580583765023269, -96.0097198486328, -1.67568572527599, 218, 51, 'PPL', 'P'),
(83720, 'South Sumter', 33.9055595397949, 0.591763648700395, -80.3463897705078, -1.40230904358605, 218, 48, 'PPL', 'P'),
(176454, 'South Superior', 46.6694412231445, 0.814535409409842, -92.0950012207031, -1.60736099592947, 218, 57, 'PPL', 'P'),
(209749, 'South Superior', 41.7619400024414, 0.728883355062931, -108.966110229492, -1.90181739659571, 218, 59, 'PPL', 'P'),
(128935, 'South Surry', 44.4124984741211, 0.775144327410371, -68.4627838134766, -1.19490099262625, 218, 26, 'PPL', 'P'),
(126205, 'South Sutton', 42.0999984741211, 0.734783588458002, -71.7125015258789, -1.25161926646804, 218, 23, 'PPL', 'P'),
(144490, 'South Sutton', 43.3199996948242, 0.756076626637621, -71.9347229003906, -1.25549776112158, 218, 36, 'PPL', 'P'),
(126206, 'South Swansea', 41.7180595397949, 0.728117496512452, -71.2041702270508, -1.24274721161255, 218, 23, 'PPL', 'P'),
(157729, 'South Swanton', 41.582218170166, 0.725746617352009, -83.8633270263672, -1.46369117828685, 218, 41, 'PPL', 'P'),
(117846, 'South Switch Junction', 42.4713897705078, 0.7412655893932, -90.6500015258789, -1.58214099356447, 218, 16, 'PPL', 'P'),
(208799, 'South Tacoma', 47.2061080932617, 0.823902013279759, -122.482223510742, -2.13771807542606, 218, 56, 'PPL', 'P'),
(177689, 'South Taft', 35.1347198486328, 0.613216543124446, -119.455276489258, -2.08488788361772, 218, 6, 'PPL', 'P'),
(167400, 'South Tamaqua', 40.7577781677246, 0.711357424824256, -75.9447174072266, -1.32548536825275, 218, 45, 'PPL', 'P'),
(18153, 'South Tampa', 27.9488906860352, 0.48780016475129, -82.3544387817383, -1.43735611037344, 218, 12, 'PPL', 'P'),
(144491, 'South Tamworth', 43.8247184753418, 0.764885631154304, -71.3036117553711, -1.24448279369496, 218, 36, 'PPL', 'P'),
(167401, 'South Temple', 40.3980598449707, 0.705079155712449, -75.9219436645508, -1.32508789146006, 218, 45, 'PPL', 'P'),
(138189, 'South Terrace Mobile Home Park', 45.3869400024414, 0.792151540447726, -92.7474975585938, -1.61874920538286, 218, 28, 'PPL', 'P'),
(98207, 'South Texarkana', 33.4022216796875, 0.582978745791578, -94.0427780151367, -1.64135611408627, 218, 51, 'PPL', 'P'),
(128936, 'South Thomaston', 44.0513916015625, 0.768841823532644, -69.1283264160156, -1.20651690235284, 218, 26, 'PPL', 'P'),
(24976, 'South Thompson', 32.1080589294434, 0.560391344743152, -82.3708267211914, -1.43764213387452, 218, 13, 'PPL', 'P'),
(157730, 'South Thompson', 41.6477813720703, 0.726890911093389, -81.0449981689453, -1.41450206032087, 218, 41, 'PPL', 'P'),
(152771, 'South Thurston', 42.2024993896484, 0.736572566920263, -77.295280456543, -1.3490571402191, 218, 40, 'PPL', 'P'),
(51573, 'South Timber', 39.4355583190918, 0.688280335030392, -77.1711120605469, -1.34688999288205, 218, 25, 'PPL', 'P'),
(18154, 'South Titusville', 28.5508308410645, 0.498306002356517, -80.8102798461914, -1.41040545277406, 218, 12, 'PPL', 'P'),
(61, 'South Toledo Bend', 31.1530609130859, 0.543723485007701, -93.6044387817383, -1.6337056512228, 218, 51, 'PPL', 'P'),
(71418, 'South Toms River', 39.9419403076172, 0.697118368002957, -74.204719543457, -1.29511667655231, 218, 37, 'PPL', 'P'),
(209750, 'South Torrington', 42.0497207641602, 0.733906076878821, -104.178886413574, -1.81826457897806, 218, 59, 'PPL', 'P'),
(167403, 'South Towanda', 41.7508316040039, 0.728689476935574, -76.4436111450195, -1.33419270659482, 218, 45, 'PPL', 'P'),
(98208, 'South Tower Estates Colonia', 26.1499996185303, 0.456403592738614, -98.1129989624023, -1.7123948708997, 218, 51, 'PPL', 'P'),
(117847, 'South Towne Park', 41.5858306884766, 0.725809667690816, -91.0055618286133, -1.58834669153657, 218, 16, 'PPL', 'P'),
(18155, 'South Trail', 27.2983303070068, 0.476445744154224, -82.5305633544922, -1.44043006406166, 218, 12, 'PPL', 'P'),
(152772, 'South Trenton', 43.2183303833008, 0.754302162403302, -75.179443359375, -1.31212881643768, 218, 40, 'PPL', 'P'),
(128938, 'South Trescott', 44.7691688537598, 0.781369399879404, -67.0747222900391, -1.17067474882201, 218, 26, 'PPL', 'P'),
(185300, 'South Trona', 35.7155609130859, 0.623354132129942, -117.396392822266, -2.04895358471317, 218, 6, 'PPL', 'P'),
(152773, 'South Troupsburg', 42.0177803039551, 0.73334861068364, -77.5216674804688, -1.3530083391704, 218, 40, 'PPL', 'P'),
(57642, 'South Troy', 38.957218170166, 0.679931724487158, -90.9941711425781, -1.5881478865612, 218, 29, 'PPL', 'P'),
(113141, 'South Troy', 44.2055587768555, 0.771532548340005, -92.432502746582, -1.61325150878656, 218, 28, 'PPL', 'P'),
(152774, 'South Troy', 42.7008285522461, 0.745270051566298, -73.6730575561523, -1.28583742436615, 218, 40, 'PPL', 'P'),
(126207, 'South Truro', 41.9650001525879, 0.732427423262581, -70.0758285522461, -1.22305393429975, 218, 23, 'PPL', 'P'),
(179201, 'South Tucson', 32.1994400024414, 0.561986245340974, -110.967781066895, -1.93675314324954, 218, 5, 'PPL', 'P'),
(172575, 'South Tunbridge', 43.855281829834, 0.765419062320647, -72.5033264160156, -1.26542176460765, 218, 55, 'PPL', 'P'),
(68948, 'South Tunis', 36.3636093139648, 0.634664710437563, -76.9011077880859, -1.34217752933315, 218, 33, 'PPL', 'P'),
(90924, 'South Tunnel', 36.480281829834, 0.636701029986065, -86.4661102294922, -1.50911831489699, 218, 50, 'PPL', 'P'),
(128939, 'South Turner', 44.2125015258789, 0.771653722169604, -70.2358322143555, -1.2258465250188, 218, 26, 'PPL', 'P'),
(152775, 'South Unadilla', 42.3133316040039, 0.738506953978042, -75.3388900756836, -1.31491168661876, 218, 40, 'PPL', 'P'),
(38300, 'South Union', 36.8763885498047, 0.643614396438829, -86.6563873291016, -1.51243927677632, 218, 21, 'PPL', 'P'),
(83722, 'South Union', 34.5511093139648, 0.603030617745166, -83.0519409179688, -1.44952981919036, 218, 48, 'PPL', 'P'),
(128940, 'South Union', 44.1969413757324, 0.771382146317443, -69.2641677856445, -1.20888778151329, 218, 26, 'PPL', 'P'),
(167404, 'South Union', 41.5680618286133, 0.725499542581877, -76.9991683959961, -1.34388900980769, 218, 45, 'PPL', 'P'),
(208800, 'South Union', 46.9433288574219, 0.819315650408479, -122.906112670898, -2.1451163369343, 218, 56, 'PPL', 'P'),
(79165, 'South Uniontown', 39.8927803039551, 0.69626036407876, -79.7472229003906, -1.39185160893364, 218, 45, 'PPL', 'P'),
(43140, 'South Vacherie', 29.9272193908691, 0.522328514337358, -90.6997222900391, -1.58300878460567, 218, 22, 'PPL', 'P'),
(185301, 'South Vallejo', 38.0877799987793, 0.664757165753941, -122.242218017578, -2.13352918934747, 218, 6, 'PPL', 'P'),
(152776, 'South Valley', 42.707218170166, 0.745381571436945, -74.7108306884766, -1.30394998241394, 218, 40, 'PPL', 'P'),
(189595, 'South Valley', 35.0099983215332, 0.611039741828443, -106.67749786377, -1.861873575512, 218, 38, 'PPL', 'P'),
(152777, 'South Valley Stream', 40.6558303833008, 0.709578100320947, -73.7180633544922, -1.28662292372966, 218, 40, 'PPL', 'P'),
(205836, 'South Valley View', 40.8458290100098, 0.712894201931286, -111.893890380859, -1.95291680001161, 218, 52, 'PPL', 'P'),
(57643, 'South Van Buren', 36.9880599975586, 0.645563430882603, -91.0136108398438, -1.58848717328407, 218, 29, 'PPL', 'P'),
(152779, 'South Vandalia', 42.0833282470703, 0.734492638108911, -78.5905609130859, -1.37166404892251, 218, 40, 'PPL', 'P'),
(128941, 'South Vassalboro', 44.3849983215332, 0.774664359202911, -69.6155624389648, -1.21502077518763, 218, 26, 'PPL', 'P'),
(18156, 'South Venice', 27.0527801513672, 0.472160085459527, -82.4244384765625, -1.43857783552351, 218, 12, 'PPL', 'P'),
(172576, 'South Vernon', 42.7275009155273, 0.745735572124844, -72.4649963378906, -1.26475277854182, 218, 55, 'PPL', 'P'),
(172577, 'South Vershire', 43.9222183227539, 0.766587324511837, -72.3172225952148, -1.26217364018414, 218, 55, 'PPL', 'P'),
(152780, 'South Vestal', 42.0080604553223, 0.733178967322202, -76.0025024414063, -1.32649390735757, 218, 40, 'PPL', 'P'),
(74363, 'South Vienna', 39.9269409179688, 0.696856579267802, -83.6125030517578, -1.45931347408698, 218, 41, 'PPL', 'P'),
(79166, 'South View Acres', 39.9116706848145, 0.696590063421712, -76.6922225952148, -1.33853179495889, 218, 45, 'PPL', 'P'),
(90925, 'South View Estates', 35.6824989318848, 0.622777091700749, -83.9702835083008, -1.46555792105294, 218, 50, 'PPL', 'P'),
(863, 'South Village', 35.9130592346191, 0.626801128107859, -96.6419372558594, -1.68672000062052, 218, 42, 'PPL', 'P'),
(126208, 'South Village', 42.6666717529297, 0.744673902956284, -71.8249969482422, -1.25358268198171, 218, 23, 'PPL', 'P'),
(71420, 'South Vineland', 39.4458312988281, 0.688459632350782, -75.029167175293, -1.30950600223812, 218, 37, 'PPL', 'P'),
(5965, 'South Vinemont', 34.2388916015625, 0.5975813906807, -86.8644409179688, -1.51607049692264, 218, 2, 'PPL', 'P'),
(68949, 'South Wadesboro', 34.9561080932617, 0.610099179910454, -80.0774993896484, -1.39761602111311, 218, 33, 'PPL', 'P'),
(172578, 'South Walden', 44.4744415283203, 0.776225437654888, -72.290283203125, -1.26170345909368, 218, 55, 'PPL', 'P'),
(128942, 'South Waldoboro', 44.041389465332, 0.768667253323189, -69.3302764892578, -1.21004159605556, 218, 26, 'PPL', 'P'),
(106427, 'South Wales', 38.6636085510254, 0.674807269917627, -77.9258270263672, -1.36006225394969, 218, 53, 'PPL', 'P'),
(152781, 'South Wales', 42.7088890075684, 0.745410733050881, -78.5783309936523, -1.37145059656114, 218, 40, 'PPL', 'P'),
(172579, 'South Wallingford', 43.4127807617188, 0.757695961738444, -72.9930572509766, -1.27396918012626, 218, 55, 'PPL', 'P'),
(38301, 'South Wallins', 36.814998626709, 0.642542940153263, -83.4108276367188, -1.45579357407422, 218, 21, 'PPL', 'P'),
(126227, 'South Walpole', 42.1041717529297, 0.734856425913816, -71.2616729736328, -1.24375082386935, 218, 23, 'PPL', 'P'),
(123702, 'South Wanatah', 41.4058303833008, 0.722668069710904, -86.899169921875, -1.51667663238674, 218, 19, 'PPL', 'P'),
(172580, 'South Wardsboro', 43.0113906860352, 0.750690383332936, -72.7838897705078, -1.27031851890398, 218, 55, 'PPL', 'P'),
(126209, 'South Wareham', 41.7722206115723, 0.729062785541375, -70.75, -1.23482044578599, 218, 23, 'PPL', 'P'),
(128943, 'South Warren', 44.0755615234375, 0.769263668249312, -69.2233276367188, -1.20817498644753, 218, 26, 'PPL', 'P'),
(167407, 'South Warren', 41.829719543457, 0.730066331219144, -79.1691665649414, -1.38176262261804, 218, 45, 'PPL', 'P'),
(152782, 'South Warsaw', 42.7099990844727, 0.745430107547812, -78.1305618286133, -1.3636355503423, 218, 40, 'PPL', 'P'),
(157732, 'South Warsaw', 40.6583290100098, 0.709621709583797, -84.0325012207031, -1.46664382498742, 218, 41, 'PPL', 'P'),
(31160, 'South Washington', 38.6347198486328, 0.674303066944248, -87.1786117553711, -1.52155381244906, 218, 19, 'PPL', 'P'),
(172581, 'South Washington', 44.0280609130859, 0.768434626201971, -72.413330078125, -1.26385103219672, 218, 55, 'PPL', 'P'),
(128944, 'South Waterford', 44.166389465332, 0.770848914888182, -70.7172164916992, -1.23424826562578, 218, 26, 'PPL', 'P'),
(167408, 'South Waverly', 41.997501373291, 0.732994676574768, -76.5374984741211, -1.33583134961355, 218, 45, 'PPL', 'P'),
(185304, 'South Wawona', 37.5424995422363, 0.655240226440488, -119.643890380859, -2.08817981704117, 218, 6, 'PPL', 'P'),
(185302, 'South Wawona (historical)', 37.541389465332, 0.655220851943558, -119.640830993652, -2.08812642066131, 218, 6, 'PPL', 'P'),
(176456, 'South Wayne', 42.5688896179199, 0.742967282750734, -89.8797225952148, -1.56869709006564, 218, 57, 'PPL', 'P'),
(144492, 'South Weare', 43.0561103820801, 0.751470889269411, -71.7147216796875, -1.25165801546191, 218, 36, 'PPL', 'P'),
(205839, 'South Weber', 41.1324996948242, 0.717897549250245, -111.929443359375, -1.9535373165456, 218, 52, 'PPL', 'P'),
(74364, 'South Webster', 38.8133316040039, 0.67742043015824, -82.726936340332, -1.44385741922654, 218, 41, 'PPL', 'P'),
(68950, 'South Weldon', 36.415828704834, 0.635576110741615, -77.6033325195313, -1.35443366298581, 218, 33, 'PPL', 'P'),
(126210, 'South Wellfleet', 41.9180603027344, 0.731608168332246, -69.9958267211914, -1.22165763894022, 218, 23, 'PPL', 'P'),
(126211, 'South Wendell', 42.5208282470703, 0.742128453586386, -72.3916702270508, -1.26347299647999, 218, 23, 'PPL', 'P'),
(128945, 'South West Bend', 43.9805603027344, 0.767605584154629, -70.126106262207, -1.22393144587893, 218, 26, 'PPL', 'P'),
(57644, 'South West City', 36.5125007629395, 0.637263356450235, -94.6111068725586, -1.65127532388238, 218, 29, 'PPL', 'P'),
(140900, 'South West Fargo', 46.8736114501953, 0.818098852106422, -96.9000015258789, -1.69122407181412, 218, 34, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(152783, 'South Westerlo', 42.4477806091309, 0.740853531793538, -74.0274963378906, -1.29202354810424, 218, 40, 'PPL', 'P'),
(126212, 'South Westport', 41.5708312988281, 0.725547878955662, -71.0583267211914, -1.24020176224266, 218, 23, 'PPL', 'P'),
(71421, 'South Westville', 39.8605613708496, 0.69569803761459, -75.1319427490234, -1.31129977439034, 218, 37, 'PPL', 'P'),
(114092, 'South Wethersfield', 41.6902809143066, 0.727632668036003, -72.6561126708984, -1.26808838780715, 218, 8, 'PPL', 'P'),
(126213, 'South Weymouth', 42.1749992370605, 0.736092598712803, -70.9499969482422, -1.23831105102676, 218, 23, 'PPL', 'P'),
(133194, 'South Whitehall', 43.3983306884766, 0.757443760383214, -86.3483276367188, -1.50706262085156, 218, 27, 'PPL', 'P'),
(68953, 'South Whiteville', 34.3052787780762, 0.598740065491966, -78.7155609130859, -1.3738457104875, 218, 33, 'PPL', 'P'),
(123703, 'South Whitley', 41.0847206115723, 0.717063646933914, -85.628059387207, -1.4944915684, 218, 19, 'PPL', 'P'),
(185303, 'South Whittier', 33.9608306884766, 0.592728312226249, -118.040832519531, -2.06020117926101, 218, 6, 'PPL', 'P'),
(205841, 'South Willard', 41.3633308410645, 0.72192631276829, -112.035003662109, -1.95537969138771, 218, 52, 'PPL', 'P'),
(112356, 'South Williamson', 37.6719398498535, 0.657499385993202, -82.2841720581055, -1.43612972469146, 218, 21, 'PPL', 'P'),
(167411, 'South Williamsport', 41.2319412231445, 0.71963313133265, -76.9994430541992, -1.34389380349765, 218, 45, 'PPL', 'P'),
(126214, 'South Williamstown', 42.6605606079102, 0.744567243354626, -73.241943359375, -1.27831306218029, 218, 23, 'PPL', 'P'),
(114093, 'South Willington', 41.855281829834, 0.73051247728076, -72.3019409179688, -1.26190692460097, 218, 8, 'PPL', 'P'),
(14652, 'South Wilmington', 39.7291717529297, 0.69340485617895, -75.5444412231445, -1.3184992309232, 218, 10, 'PPL', 'P'),
(121533, 'South Wilmington', 41.172779083252, 0.718600557198999, -88.2766723632813, -1.54071858544354, 218, 18, 'PPL', 'P'),
(126215, 'South Wilmington', 42.5152816772461, 0.742031647680761, -71.1569366455078, -1.24192283009712, 218, 23, 'PPL', 'P'),
(152784, 'South Wilson', 43.2416687011719, 0.754709492892029, -78.8133316040039, -1.37555213095597, 218, 40, 'PPL', 'P'),
(114108, 'South Wilton', 41.1680603027344, 0.718518198942288, -73.4166717529297, -1.28136264794454, 218, 8, 'PPL', 'P'),
(83723, 'South Windermire', 32.7758293151855, 0.572046136621666, -79.9802780151367, -1.39591918802457, 218, 48, 'PPL', 'P'),
(114095, 'South Windham', 41.6794395446777, 0.727443450440553, -72.1708297729492, -1.25961860343432, 218, 8, 'PPL', 'P'),
(128946, 'South Windham', 43.7361106872559, 0.763339133509295, -70.4241714477539, -1.22913366475229, 218, 26, 'PPL', 'P'),
(172582, 'South Windham', 43.128059387207, 0.752726636302411, -72.711669921875, -1.26905804476005, 218, 55, 'PPL', 'P'),
(114097, 'South Windsor', 41.8236083984375, 0.729959671617487, -72.6216735839844, -1.26748731234912, 218, 8, 'PPL', 'P'),
(128947, 'South Windsor', 44.2791709899902, 0.772817323828887, -69.5991668701172, -1.2147346185285, 218, 26, 'PPL', 'P'),
(152785, 'South Windsor', 42.0275001525879, 0.733518254045078, -75.6227798461914, -1.31986649782685, 218, 40, 'PPL', 'P'),
(144493, 'South Wolfeboro', 43.5613899230957, 0.760289680903099, -71.1777801513672, -1.24228661790203, 218, 36, 'PPL', 'P'),
(79167, 'South Wood Hills', 39.9458312988281, 0.697186278610754, -76.7155609130859, -1.33893912544762, 218, 45, 'PPL', 'P'),
(157740, 'South Woodbury', 40.4197196960449, 0.705457191429186, -82.8569412231445, -1.44612643247529, 218, 41, 'PPL', 'P'),
(172583, 'South Woodbury', 44.4150009155273, 0.775188003252248, -72.4219436645508, -1.26400136764026, 218, 55, 'PPL', 'P'),
(51570, 'South Woodside Park', 39.0050010681152, 0.680765693382516, -77.0202789306641, -1.34425745814451, 218, 25, 'PPL', 'P'),
(114099, 'South Woodstock', 41.9388885498047, 0.731971689821042, -71.9599990844727, -1.25593891375615, 218, 8, 'PPL', 'P'),
(128948, 'South Woodstock', 44.3547210693359, 0.774135921463612, -70.5577774047852, -1.23146552860276, 218, 26, 'PPL', 'P'),
(172584, 'South Woodstock', 43.565559387207, 0.760362451779886, -72.5327835083008, -1.26593588785609, 218, 55, 'PPL', 'P'),
(128949, 'South Woodville', 45.4847183227539, 0.793858094074248, -68.4833297729492, -1.19525958726702, 218, 26, 'PPL', 'P'),
(126216, 'South Worcester', 42.2436103820801, 0.737290089096957, -71.8138885498047, -1.25338880385435, 218, 23, 'PPL', 'P'),
(152786, 'South Worcester', 42.5177803039551, 0.742075256943612, -74.7502822875977, -1.30463854271378, 218, 40, 'PPL', 'P'),
(111476, 'South Worthington', 39.4472198486328, 0.688483867116702, -80.2697219848633, -1.40097093829634, 218, 58, 'PPL', 'P'),
(126217, 'South Worthington', 42.3436088562012, 0.739035391717341, -72.8902816772461, -1.27217540797404, 218, 23, 'PPL', 'P'),
(143063, 'South Yankton', 42.8494415283203, 0.747863837309981, -97.398063659668, -1.69991689592824, 218, 35, 'PPL', 'P'),
(126218, 'South Yarmouth', 41.6666717529297, 0.72722061043634, -70.1852798461914, -1.22496421974966, 218, 23, 'PPL', 'P'),
(185306, 'South Yuba', 39.125560760498, 0.682869856959788, -121.584442138672, -2.12204883452036, 218, 6, 'PPL', 'P'),
(185305, 'South Yuba City', 39.1166687011719, 0.682714661247263, -121.638061523438, -2.12298466932741, 218, 6, 'PPL', 'P'),
(74365, 'South Zanesville', 39.899169921875, 0.696371883949407, -82.0063934326172, -1.43128157308502, 218, 41, 'PPL', 'P'),
(90926, 'Southall', 35.8925018310547, 0.626442333729998, -86.9263916015625, -1.51715174032521, 218, 50, 'PPL', 'P'),
(140901, 'Southam', 48.1583290100098, 0.840521403483372, -98.5516662597656, -1.72005105955952, 218, 34, 'PPL', 'P'),
(106428, 'Southampton', 37.2652816772461, 0.650401861951059, -79.8916702270508, -1.39437269037956, 218, 53, 'PPL', 'P'),
(112398, 'Southampton', 39.5516700744629, 0.690306867461888, -76.3266677856445, -1.33215165993539, 218, 25, 'PPL', 'P'),
(126219, 'Southampton', 42.2291717529297, 0.737038087478808, -72.7305603027344, -1.269387744103, 218, 23, 'PPL', 'P'),
(152787, 'Southampton', 40.8841705322266, 0.713563387734196, -72.3899993896484, -1.26344383486605, 218, 40, 'PPL', 'P'),
(167415, 'Southampton', 40.1741714477539, 0.701171566024003, -75.0441665649414, -1.30976779097327, 218, 45, 'PPL', 'P'),
(205842, 'Southampton', 40.6074981689453, 0.708734544045664, -111.797218322754, -1.95122955430299, 218, 52, 'PPL', 'P'),
(106432, 'Southampton Forest', 38.9105606079102, 0.679117396404839, -77.1902770996094, -1.34722448591496, 218, 53, 'PPL', 'P'),
(57647, 'Southard', 37.5391693115234, 0.655182102949697, -92.3375015258789, -1.61159342469188, 218, 29, 'PPL', 'P'),
(77293, 'Southard', 36.0558280944824, 0.629292914781791, -98.4749984741211, -1.71871295426981, 218, 42, 'PPL', 'P'),
(146358, 'Southard', 40.1383285522461, 0.700545989483943, -74.2252807617188, -1.2954755375092, 218, 37, 'PPL', 'P'),
(61831, 'Southaven', 34.9888916015625, 0.610671360070658, -90.0124969482422, -1.57101443968817, 218, 30, 'PPL', 'P'),
(126221, 'Southborough', 42.3055610656738, 0.738371332499529, -71.5250015258789, -1.24834677412056, 218, 23, 'PPL', 'P'),
(24977, 'Southbridge', 33.5691719055176, 0.585892576919261, -84.2055587768555, -1.46966424913774, 218, 13, 'PPL', 'P'),
(126223, 'Southbridge', 42.0750007629395, 0.73434729609242, -72.0338897705078, -1.25722854951402, 218, 23, 'PPL', 'P'),
(90928, 'Southbrook', 35.9124984741211, 0.626791340990853, -83.8866729736328, -1.46409864193364, 218, 50, 'PPL', 'P'),
(152789, 'Southburg', 42.672779083252, 0.744780495978914, -78.3380584716797, -1.36725704995065, 218, 40, 'PPL', 'P'),
(114100, 'Southbury', 41.4813919067383, 0.723986867082712, -73.2136077880859, -1.27781851316586, 218, 8, 'PPL', 'P'),
(18157, 'Southchase', 28.3927803039551, 0.495547500099413, -81.3836135864258, -1.42041201425392, 218, 12, 'PPL', 'P'),
(90929, 'Southcrest Subdivision', 35.0758285522461, 0.61218869610173, -86.5680618286133, -1.51089770597932, 218, 50, 'PPL', 'P'),
(167418, 'Southdale', 41.1513900756836, 0.718227248593197, -76.269172668457, -1.33114818083664, 218, 45, 'PPL', 'P'),
(38303, 'Southdown', 37.1583290100098, 0.648535185763995, -82.7972183227539, -1.44508407122463, 218, 21, 'PPL', 'P'),
(43142, 'Southdown', 29.586669921875, 0.516384804837492, -90.7388916015625, -1.5836924180575, 218, 22, 'PPL', 'P'),
(51572, 'Southdown Estates', 38.9363899230957, 0.679568202998362, -76.5708312988281, -1.33641311715368, 218, 25, 'PPL', 'P'),
(43143, 'Southdown Plantation', 29.982780456543, 0.523298237869283, -90.7283325195313, -1.58350812731006, 218, 22, 'PPL', 'P'),
(106433, 'Southdowns', 37.2583312988281, 0.650280554963406, -80.0361099243164, -1.39689363866743, 218, 53, 'PPL', 'P'),
(13210, 'Southeast', 38.8805618286133, 0.678593818934529, -76.9902801513672, -1.3437338806742, 218, 9, 'PPL', 'P'),
(123704, 'Southeast Grove', 41.3330612182617, 0.721398008187046, -87.2966690063477, -1.52361430018445, 218, 19, 'PPL', 'P'),
(51574, 'Southeast Landing', 39.1575012207031, 0.683427323154968, -76.0263900756836, -1.32691082522622, 218, 25, 'PPL', 'P'),
(31161, 'Southeast Manor', 39.627498626709, 0.691630325365603, -85.9047164916992, -1.49932014577242, 218, 19, 'PPL', 'P'),
(83724, 'Southeast Newberry', 34.250560760498, 0.597785055925064, -81.5727767944336, -1.42371353505729, 218, 48, 'PPL', 'P'),
(152790, 'Southeast Owasco', 42.7583312988281, 0.746273663823094, -76.459716796875, -1.33447380324788, 218, 40, 'PPL', 'P'),
(38304, 'Southeastern Hills', 37.9819412231445, 0.662909930642834, -84.48388671875, -1.4745219881241, 218, 21, 'PPL', 'P'),
(5966, 'Southern (historical)', 34.4744415283203, 0.601692512455455, -86.5272216796875, -1.51018491091357, 218, 2, 'PPL', 'P'),
(117848, 'Southern Acres Mobile Estates', 42.7105598449707, 0.745439894664818, -95.4375, -1.66569860487209, 218, 16, 'PPL', 'P'),
(179202, 'Southern Acres Mobile Home Park', 33.3933296203613, 0.582823550079053, -112.006393432617, -1.95488034868332, 218, 5, 'PPL', 'P'),
(90930, 'Southern Aire', 35.8252792358398, 0.625269078111763, -86.4749984741211, -1.50927344403049, 218, 50, 'PPL', 'P'),
(98209, 'Southern Breeze Colonia', 26.2950000762939, 0.45893432814349, -98.0540008544922, -1.71136515966422, 218, 51, 'PPL', 'P'),
(197587, 'Southern Cross (historical)', 46.2102813720703, 0.80652155821563, -113.235557556152, -1.9763333096864, 218, 31, 'PPL', 'P'),
(5968, 'Southern Estates', 31.0097198486328, 0.54122171147968, -87.4730606079102, -1.52669291440458, 218, 2, 'PPL', 'P'),
(106448, 'Southern Estates', 37.1283302307129, 0.648011608293686, -77.3552780151367, -1.35010429515972, 218, 53, 'PPL', 'P'),
(43146, 'Southern Gardens', 32.4666709899902, 0.566650305937057, -93.6619415283203, -1.6347092634796, 218, 22, 'PPL', 'P'),
(38305, 'Southern Heights', 38.1830596923828, 0.666420110117613, -85.7738876342773, -1.49703675145379, 218, 21, 'PPL', 'P'),
(208803, 'Southern Heights', 47.4958305358887, 0.82895862382052, -122.308059692383, -2.13467834335784, 218, 56, 'PPL', 'P'),
(28652, 'Southern Hills', 37.7038917541504, 0.658057051925465, -89.210563659668, -1.55701806342121, 218, 18, 'PPL', 'P'),
(90932, 'Southern Hills', 35.5900001525879, 0.621162683447943, -87.0341720581055, -1.51903286416119, 218, 50, 'PPL', 'P'),
(106434, 'Southern Hills', 37.225830078125, 0.649713301651219, -79.9625015258789, -1.39560892975758, 218, 53, 'PPL', 'P'),
(138195, 'Southern Hills Mobile Home Park', 43.8722190856934, 0.765714673201645, -92.4902801513672, -1.61425991473332, 218, 28, 'PPL', 'P'),
(12048, 'Southern Home (historical)', 35.0908317565918, 0.612450551415912, -93.6855621337891, -1.63512152081634, 218, 4, 'PPL', 'P'),
(5969, 'Southern Junction', 31.0291690826416, 0.541561164650124, -85.4700012207031, -1.49173293298484, 218, 2, 'PPL', 'P'),
(24978, 'Southern Junction', 31.2313899993896, 0.545090585463779, -81.5188903808594, -1.42277303971833, 218, 13, 'PPL', 'P'),
(190760, 'Southern Klondike (historical)', 37.9144401550293, 0.66173181475561, -117.209999084473, -2.04570040028359, 218, 39, 'PPL', 'P'),
(24979, 'Southern Manor', 33.7449989318848, 0.588961337443359, -84.6538925170898, -1.47748914905261, 218, 13, 'PPL', 'P'),
(90933, 'Southern Meadows', 35.9091682434082, 0.626733217500062, -86.5572204589844, -1.51070848838387, 218, 50, 'PPL', 'P'),
(24980, 'Southern Oaks', 34.1227798461914, 0.595554858249204, -84.4755630493164, -1.47437671268663, 218, 13, 'PPL', 'P'),
(83726, 'Southern Palms', 32.9819412231445, 0.575643468043118, -80.1338882446289, -1.39860019229395, 218, 48, 'PPL', 'P'),
(179203, 'Southern Palms Trailer Park', 33.3925018310547, 0.58280910243014, -111.831672668457, -1.95183089607713, 218, 5, 'PPL', 'P'),
(51575, 'Southern Pines', 38.3008308410645, 0.668475604425964, -75.4888916015625, -1.31752970712836, 218, 25, 'PPL', 'P'),
(68957, 'Southern Pines', 35.1738891601563, 0.61390017657627, -79.3925018310547, -1.38566055834753, 218, 33, 'PPL', 'P'),
(83727, 'Southern Pines', 34.9841690063477, 0.61058893523492, -81.8361129760742, -1.42830961846655, 218, 48, 'PPL', 'P'),
(106437, 'Southern Pines', 37.2102813720703, 0.64944192553614, -79.9836120605469, -1.39597737809439, 218, 53, 'PPL', 'P'),
(24981, 'Southern Pines Estates', 33.767219543457, 0.589349160277102, -84.6919403076172, -1.47815320827042, 218, 13, 'PPL', 'P'),
(106438, 'Southern Points', 36.8619384765625, 0.643362195083598, -76.0555572509766, -1.32741988846859, 218, 53, 'PPL', 'P'),
(83728, 'Southern Shops', 34.9858283996582, 0.610617897111774, -81.9947204589844, -1.43107784126163, 218, 48, 'PPL', 'P'),
(68959, 'Southern Shores', 36.1458282470703, 0.630863713771747, -76.4111099243164, -1.33362545328264, 218, 33, 'PPL', 'P'),
(192793, 'Southern Trailer Park', 37.1100006103516, 0.64769169606774, -113.592498779297, -1.98256310926637, 218, 52, 'PPL', 'P'),
(98210, 'Southern Valley Estates Colonia', 26.1411094665527, 0.456248430315604, -97.8755569458008, -1.70825072592743, 218, 51, 'PPL', 'P'),
(28654, 'Southern View', 39.7572212219238, 0.693894411766334, -89.6536102294922, -1.56475068480431, 218, 18, 'PPL', 'P'),
(157733, 'Southerton', 41.1800003051758, 0.718726591297587, -84.3111114501953, -1.4715064908218, 218, 41, 'PPL', 'P'),
(126225, 'Southfield', 42.101390838623, 0.734807889802949, -73.2333297729492, -1.27816272673676, 218, 23, 'PPL', 'P'),
(133195, 'Southfield', 42.473331451416, 0.741299478118072, -83.2219390869141, -1.45249684696081, 218, 27, 'PPL', 'P'),
(51576, 'Southfield At Whitemarsh', 39.378059387207, 0.687276789352623, -76.4749984741211, -1.33474051883105, 218, 25, 'PPL', 'P'),
(152792, 'Southfields', 41.2447204589844, 0.719856171073944, -74.1758270263672, -1.2946124069999, 218, 40, 'PPL', 'P'),
(114102, 'Southford', 41.4644393920898, 0.723690989885604, -73.1622161865234, -1.27692156051072, 218, 8, 'PPL', 'P'),
(24983, 'Southfork', 33.9300003051758, 0.592190220527998, -84.748893737793, -1.47914723314729, 218, 13, 'PPL', 'P'),
(38306, 'Southfork', 37.4141693115234, 0.653000441384704, -83.6619415283203, -1.46017633828017, 218, 21, 'PPL', 'P'),
(98211, 'Southfork Estates Colonia', 26.0960006713867, 0.455461133318349, -98.1849975585938, -1.71365148346005, 218, 51, 'PPL', 'P'),
(18158, 'Southfort', 27.0677795410156, 0.472421874194682, -81.9641723632813, -1.4305446764114, 218, 12, 'PPL', 'P'),
(18159, 'Southgate', 27.3077793121338, 0.476610660404727, -82.5100021362305, -1.44007120310478, 218, 12, 'PPL', 'P'),
(24985, 'Southgate', 34.2386093139648, 0.597576463832683, -83.9069366455078, -1.4644523097264, 218, 13, 'PPL', 'P'),
(38307, 'Southgate', 39.0719413757324, 0.681934022152734, -84.4727783203125, -1.47432810999674, 218, 21, 'PPL', 'P'),
(51578, 'Southgate', 38.2552795410156, 0.667680584261548, -76.4166717529297, -1.33372252550437, 218, 25, 'PPL', 'P'),
(68961, 'Southgate', 35.0972213745117, 0.612562071286559, -77.0880584716797, -1.34544043430072, 218, 33, 'PPL', 'P'),
(83730, 'Southgate', 33.8400001525879, 0.590619421538042, -80.3752822875977, -1.40281331313846, 218, 48, 'PPL', 'P'),
(121534, 'Southgate', 41.8916702270508, 0.731147574621717, -89.0641708374023, -1.55446302667139, 218, 18, 'PPL', 'P'),
(133198, 'Southgate', 42.2138900756836, 0.736771371895637, -83.1938934326172, -1.45200735795246, 218, 27, 'PPL', 'P'),
(43151, 'Southgate Estates', 32.415828704834, 0.565762940661842, -93.6963882446289, -1.63531047209568, 218, 22, 'PPL', 'P'),
(90935, 'Southgate Subdivision', 35.0894393920898, 0.612426250070965, -86.5658264160156, -1.51085869066936, 218, 50, 'PPL', 'P'),
(187381, 'Southglenn', 39.5872192382813, 0.690927317416849, -104.952217102051, -1.83176174569869, 218, 7, 'PPL', 'P'),
(51579, 'Southglenn Farms', 39.5208282470703, 0.689768576026556, -76.8652801513672, -1.3415522191092, 218, 25, 'PPL', 'P'),
(57649, 'Southhampton', 38.5933303833008, 0.673580684498564, -90.295280456543, -1.57594994297836, 218, 29, 'PPL', 'P'),
(61833, 'Southhaven', 34.9916687011719, 0.610719829602497, -90.1275024414063, -1.57302166420177, 218, 30, 'PPL', 'P'),
(138196, 'Southhaven Mobile Home Park', 44.1383285522461, 0.770359159563716, -93.9611129760742, -1.63993079027086, 218, 28, 'PPL', 'P'),
(114103, 'Southington', 41.5963897705078, 0.72599395843825, -72.878059387207, -1.27196208877072, 218, 8, 'PPL', 'P'),
(157735, 'Southington', 41.3083305358887, 0.720966376353371, -80.9561080932617, -1.41295063582785, 218, 41, 'PPL', 'P'),
(5973, 'Southlake', 33.3630599975586, 0.582295245497809, -86.7733306884766, -1.51448032343575, 218, 2, 'PPL', 'P'),
(98212, 'Southlake', 32.9411087036133, 0.574930806135413, -97.1338882446289, -1.69530616513299, 218, 51, 'PPL', 'P'),
(12050, 'Southland', 34.5852813720703, 0.603627032671289, -90.6538925170898, -1.58220890417227, 218, 4, 'PPL', 'P'),
(24987, 'Southland', 32.4008293151855, 0.565501151926687, -84.2275009155273, -1.47004721170249, 218, 13, 'PPL', 'P'),
(38308, 'Southland', 38.0194396972656, 0.663564402480721, -84.5308303833008, -1.47534130963346, 218, 21, 'PPL', 'P'),
(133200, 'Southland', 41.7308311462402, 0.728340403095691, -83.7830581665039, -1.46229022239542, 218, 27, 'PPL', 'P'),
(192249, 'Southland', 33.3619384765625, 0.582275671263797, -101.54972076416, -1.77237698181545, 218, 51, 'PPL', 'P'),
(98213, 'Southland Acres', 32.6752815246582, 0.570291246621358, -97.1161117553711, -1.694995906866, 218, 51, 'PPL', 'P'),
(106441, 'Southland Acres', 37.353889465332, 0.651948359596068, -79.188606262207, -1.38210190934091, 218, 53, 'PPL', 'P'),
(51580, 'Southland Hills', 39.398609161377, 0.68763545057243, -76.6108322143555, -1.33711126483344, 218, 25, 'PPL', 'P'),
(61835, 'Southland Park', 33.5319404602051, 0.585242765613281, -89.267219543457, -1.55800689513395, 218, 30, 'PPL', 'P'),
(28657, 'Southlawn', 39.7536087036133, 0.693831361427526, -89.6213912963867, -1.56418835834014, 218, 18, 'PPL', 'P'),
(98214, 'Southmayd', 33.6302795410156, 0.58695910635681, -96.7688903808594, -1.68893575064747, 218, 51, 'PPL', 'P'),
(18160, 'Southmere', 28.6650009155273, 0.500298646063141, -80.9563903808594, -1.41295556267586, 218, 12, 'PPL', 'P'),
(5976, 'Southmont', 32.3227806091309, 0.564138945029112, -86.2991714477539, -1.50620468350639, 218, 2, 'PPL', 'P'),
(68965, 'Southmont', 35.667781829834, 0.622520229813611, -80.267219543457, -1.40092726245446, 218, 33, 'PPL', 'P'),
(167419, 'Southmont', 40.3105583190918, 0.703551965985343, -78.9388885498047, -1.37774351305894, 218, 45, 'PPL', 'P'),
(121536, 'Southmoor', 41.6525001525879, 0.726973269350099, -87.829719543457, -1.53291778713654, 218, 18, 'PPL', 'P'),
(123705, 'Southmoor Park', 41.475830078125, 0.723889794860978, -87.3461074829102, -1.52447716437764, 218, 19, 'PPL', 'P'),
(157737, 'Southmoor Shores', 40.5130615234375, 0.707086313647014, -84.4319381713867, -1.47361531493098, 218, 41, 'PPL', 'P'),
(152793, 'Southold', 41.0647201538086, 0.716714573094032, -72.4266662597656, -1.264083792476, 218, 40, 'PPL', 'P'),
(24989, 'Southover', 32.0466690063477, 0.559319888457586, -81.1272201538086, -1.41593710467426, 218, 13, 'PPL', 'P'),
(157738, 'Southpark', 41.3666687011719, 0.721984569417136, -81.6108322143555, -1.42437772743316, 218, 41, 'PPL', 'P'),
(5977, 'Southpointe', 33.3211097717285, 0.581563075935119, -86.8891677856445, -1.51650206217729, 218, 2, 'PPL', 'P'),
(18161, 'Southport', 30.2891693115234, 0.528645732180108, -85.6405563354492, -1.49470968129328, 218, 12, 'PPL', 'P'),
(31164, 'Southport', 39.2769393920898, 0.685511912498228, -86.7616729736328, -1.51427685792847, 218, 19, 'PPL', 'P'),
(43154, 'Southport', 29.9622192382813, 0.522939376912395, -90.1427764892578, -1.57328824662688, 218, 22, 'PPL', 'P'),
(68968, 'Southport', 33.9213905334473, 0.59203995166349, -78.0205612182617, -1.36171567751247, 218, 33, 'PPL', 'P'),
(90936, 'Southport', 35.4705581665039, 0.619078027525656, -87.0988922119141, -1.52016244393755, 218, 50, 'PPL', 'P'),
(114105, 'Southport', 41.1363906860352, 0.717965459858042, -73.2838897705078, -1.27904516516395, 218, 8, 'PPL', 'P'),
(121537, 'Southport', 40.7924995422363, 0.711963427130304, -89.8986129760742, -1.56902678940859, 218, 18, 'PPL', 'P'),
(128951, 'Southport', 43.8408317565918, 0.765166860965416, -69.6591720581055, -1.21578190662718, 218, 26, 'PPL', 'P'),
(152796, 'Southport', 40.9083290100098, 0.713985032713783, -72.5486068725586, -1.26621205766113, 218, 40, 'PPL', 'P'),
(193970, 'Southport Landing', 40.6949996948242, 0.71026173377277, -124.247779846191, -2.16853284660909, 218, 6, 'PPL', 'P'),
(18162, 'Southridge', 30.2930603027344, 0.528713642787905, -81.5036087036133, -1.42250632413516, 218, 12, 'PPL', 'P'),
(106442, 'Southridge', 38.9186096191406, 0.67925787815234, -77.1836090087891, -1.34710810577533, 218, 53, 'PPL', 'P'),
(205865, 'Southridge', 40.6616706848145, 0.70968003281167, -111.981109619141, -1.9544390628907, 218, 52, 'PPL', 'P'),
(205852, 'Southridge Subdivision 1', 41.1683311462402, 0.718522926053223, -111.974998474121, -1.95433240328904, 218, 52, 'PPL', 'P'),
(205853, 'Southridge Subdivision 2', 41.1683311462402, 0.718522926053223, -111.974998474121, -1.95433240328904, 218, 52, 'PPL', 'P'),
(205854, 'Southridge Subdivision 3', 41.1683311462402, 0.718522926053223, -111.974998474121, -1.95433240328904, 218, 52, 'PPL', 'P'),
(205855, 'Southridge Subdivision 4', 41.1683311462402, 0.718522926053223, -111.974998474121, -1.95433240328904, 218, 52, 'PPL', 'P'),
(205856, 'Southridge Subdivision 5', 41.1683311462402, 0.718522926053223, -111.974998474121, -1.95433240328904, 218, 52, 'PPL', 'P'),
(205857, 'Southridge Subdivision 6', 41.1683311462402, 0.718522926053223, -111.974998474121, -1.95433240328904, 218, 52, 'PPL', 'P'),
(185307, 'Southridge Village', 34.040828704834, 0.59412454100675, -117.488059997559, -2.05055347873804, 218, 6, 'PPL', 'P'),
(5980, 'Southside', 33.9244384765625, 0.592093148306265, -86.0224990844727, -1.50137583981786, 218, 2, 'PPL', 'P'),
(12053, 'Southside', 35.4263916015625, 0.618307175548133, -92.3897171020508, -1.6125047584169, 218, 4, 'PPL', 'P'),
(61836, 'Southside', 33.3499984741211, 0.582067278908498, -90.5630569458008, -1.58062352437534, 218, 30, 'PPL', 'P'),
(68969, 'Southside', 35.4366683959961, 0.61848653944755, -81.2461090087891, -1.4180121066376, 218, 33, 'PPL', 'P'),
(79170, 'Southside', 39.7811088562012, 0.694311329634986, -76.3949966430664, -1.33334422347152, 218, 45, 'PPL', 'P'),
(90938, 'Southside', 36.3713912963867, 0.634800531653157, -87.2955627441406, -1.52359499226655, 218, 50, 'PPL', 'P'),
(111480, 'Southside', 38.7166709899902, 0.675733384186702, -81.9688873291016, -1.43062696808908, 218, 58, 'PPL', 'P'),
(5982, 'Southside Acres', 31.1888904571533, 0.544348828521165, -85.3724975585938, -1.49003117304828, 218, 2, 'PPL', 'P'),
(18163, 'Southside Estates', 30.298059463501, 0.528800894603119, -81.5583267211914, -1.42346133370206, 218, 12, 'PPL', 'P'),
(185308, 'Southside Highlands', 39.3158302307129, 0.686190685681062, -120.269439697266, -2.09909771224606, 218, 6, 'PPL', 'P'),
(106443, 'Southside Hills', 37.2750015258789, 0.650571505312497, -80.0791702270508, -1.39764518272705, 218, 53, 'PPL', 'P'),
(106445, 'Southside Meadows', 36.7000007629395, 0.640535848797724, -76.5988922119141, -1.33690287247814, 218, 53, 'PPL', 'P'),
(138197, 'Southside Mobile Home Park', 43.8905601501465, 0.766034785164673, -92.8475036621094, -1.6204946411613, 218, 28, 'PPL', 'P'),
(98215, 'Southside Place', 29.7058296203613, 0.518464533911762, -95.4366683959961, -1.66568409064415, 218, 51, 'PPL', 'P'),
(106446, 'Southside Shores', 36.5511093139648, 0.637937202785052, -77.8544387817383, -1.3588162940337, 218, 53, 'PPL', 'P'),
(143064, 'Southside Trailer Park', 40.3786087036133, 0.704739669252491, -95.8391723632813, -1.67270911012561, 218, 35, 'PPL', 'P'),
(98216, 'Southside Village Colonia', 26.1560001373291, 0.456508321548482, -98.1230010986328, -1.71256944110916, 218, 51, 'PPL', 'P'),
(98217, 'Southton', 29.2961101531982, 0.51131358020025, -98.418327331543, -1.71772385624095, 218, 51, 'PPL', 'P'),
(282, 'Southtown', 34.3499984741211, 0.599520571428441, -86.3097229003906, -1.50638884109577, 218, 2, 'PPL', 'P'),
(146359, 'Southtown', 40.9377784729004, 0.714499022804168, -74.8949966430664, -1.30716428469161, 218, 37, 'PPL', 'P'),
(51582, 'Southview', 39.2719383239746, 0.685424627393501, -77.2030563354492, -1.34744752565626, 218, 25, 'PPL', 'P'),
(106447, 'Southview', 39.1305618286133, 0.682957142064515, -78.1555633544922, -1.36407190928691, 218, 53, 'PPL', 'P'),
(167422, 'Southview', 40.3277816772461, 0.703852570293386, -80.2591705322266, -1.40078678070696, 218, 45, 'PPL', 'P'),
(117849, 'Southview Estates Mobile Home Park', 42.4305610656738, 0.740552994064522, -92.2916717529297, -1.61079354425847, 218, 16, 'PPL', 'P'),
(157739, 'Southview Estates Mobile Home Park', 41.5055618286133, 0.72440871179938, -83.6444396972656, -1.45987087370313, 218, 41, 'PPL', 'P'),
(38309, 'Southville', 38.1100006103516, 0.665144988587683, -85.1819381713867, -1.48670528432094, 218, 21, 'PPL', 'P'),
(126226, 'Southville', 42.2666702270508, 0.737692559316695, -71.5369415283203, -1.24855516647585, 218, 23, 'PPL', 'P'),
(152798, 'Southville', 44.6736106872559, 0.779701595246742, -74.8544387817383, -1.30645641647387, 218, 40, 'PPL', 'P'),
(24990, 'Southward', 32.1411094665527, 0.560968185435264, -81.70361328125, -1.42599706253398, 218, 13, 'PPL', 'P'),
(13212, 'Southwest', 38.8811111450195, 0.678603406314453, -77.0166702270508, -1.34419447438472, 218, 9, 'PPL', 'P'),
(68972, 'Southwest', 34.7383308410645, 0.606298249823666, -77.5086135864258, -1.35278050573914, 218, 33, 'PPL', 'P'),
(123706, 'Southwest', 41.5366706848145, 0.72495166376662, -85.9438934326172, -1.5000039123823, 218, 19, 'PPL', 'P'),
(167423, 'Southwest', 40.1988906860352, 0.701602998120596, -79.521110534668, -1.3879052036723, 218, 45, 'PPL', 'P'),
(167424, 'Southwest Greensburg', 40.2911109924316, 0.703212546104412, -79.5472183227539, -1.38836087053482, 218, 45, 'PPL', 'P'),
(128953, 'Southwest Harbor', 44.2797203063965, 0.772826911208811, -68.3255615234375, -1.19250601185794, 218, 26, 'PPL', 'P'),
(152799, 'Southwest Hoosick', 42.8736114501953, 0.748285682026649, -73.4033279418945, -1.28112975450721, 218, 40, 'PPL', 'P'),
(152800, 'Southwest Oswego', 43.4124984741211, 0.757691034890427, -76.5777816772461, -1.33653442414133, 218, 40, 'PPL', 'P'),
(18164, 'Southwest Ranches', 26.0583305358887, 0.454803665424236, -80.3375015258789, -1.40215391445256, 218, 12, 'PPL', 'P'),
(18165, 'Southwest Venice', 27.0397205352783, 0.47193215215973, -82.4236068725586, -1.43856332129557, 218, 12, 'PPL', 'P'),
(185309, 'Southwest Village', 33.8466682434082, 0.590735801677679, -118.309440612793, -2.06488927488593, 218, 6, 'PPL', 'P'),
(24991, 'Southwick', 33.4161109924316, 0.583221160029802, -82.0688934326172, -1.43237240386752, 218, 13, 'PPL', 'P'),
(126228, 'Southwick', 42.0547218322754, 0.733993361983548, -72.7708282470703, -1.27009055231467, 218, 23, 'PPL', 'P'),
(195635, 'Southwick', 46.6036109924316, 0.813386455136554, -116.47110748291, -2.03280430902099, 218, 17, 'PPL', 'P'),
(51583, 'Southwind', 38.9180603027344, 0.679248290772416, -76.3005599975586, -1.33169599307287, 218, 25, 'PPL', 'P'),
(90941, 'Southwind', 35.0519409179688, 0.611771778233078, -89.790283203125, -1.56713607819269, 218, 50, 'PPL', 'P'),
(146360, 'Southwind Mobile Home Park', 40.0986099243164, 0.699852768652195, -74.3119430541992, -1.29698807985031, 218, 37, 'PPL', 'P'),
(43156, 'Southwinds', 32.478328704834, 0.566853771444339, -92.0386123657227, -1.60637682474863, 218, 22, 'PPL', 'P'),
(5984, 'Southwood', 33.4697189331055, 0.584156795099774, -86.7825012207031, -1.51464037941727, 218, 2, 'PPL', 'P'),
(14653, 'Southwood', 39.7847213745117, 0.694374379973793, -75.7241668701172, -1.32163603521315, 218, 10, 'PPL', 'P'),
(31165, 'Southwood', 39.4030609130859, 0.687713148297233, -87.4016723632813, -1.52544695448859, 218, 19, 'PPL', 'P'),
(43157, 'Southwood', 30.2188892364502, 0.527419113471531, -91.0491714477539, -1.58910782297612, 218, 22, 'PPL', 'P'),
(51584, 'Southwood', 39.5522193908691, 0.690316454841813, -76.855827331543, -1.34138723627967, 218, 25, 'PPL', 'P'),
(68974, 'Southwood', 35.208610534668, 0.614506178882317, -77.567497253418, -1.3538082196038, 218, 33, 'PPL', 'P'),
(83733, 'Southwood', 33.524169921875, 0.585107144134769, -81.7666702270508, -1.42709761385446, 218, 48, 'PPL', 'P'),
(106449, 'Southwood', 38.7133293151855, 0.675675060958829, -77.105827331543, -1.34575055940966, 218, 53, 'PPL', 'P'),
(152801, 'Southwood', 42.9961090087891, 0.750423667749765, -76.1091690063477, -1.32835559011759, 218, 40, 'PPL', 'P'),
(114107, 'Southwood Acres', 41.9702796936035, 0.732519568636298, -72.5672225952148, -1.26653696331412, 218, 8, 'PPL', 'P'),
(14654, 'Southwood Acres Mobile Home Park', 39.0525016784668, 0.681594735429857, -75.504997253418, -1.31781080378142, 218, 10, 'PPL', 'P'),
(12055, 'Southwood Addition', 34.9199981689453, 0.609468942838487, -91.9749984741211, -1.60526655289017, 218, 4, 'PPL', 'P'),
(90942, 'Southwood Estates', 35.7897186279297, 0.62464842841972, -86.434440612793, -1.50856557581274, 218, 50, 'PPL', 'P'),
(106450, 'Southwood Estates Mobile Home Park', 37.997501373291, 0.663181506494995, -78.524169921875, -1.37050530753222, 218, 53, 'PPL', 'P'),
(79173, 'Southwood Hills', 39.8911094665527, 0.696231202464824, -76.6374969482422, -1.33757665223393, 218, 45, 'PPL', 'P'),
(106451, 'Southwood Hills', 39.3041687011719, 0.685987153594752, -78.3208312988281, -1.36695637906358, 218, 53, 'PPL', 'P'),
(106452, 'Southwoods', 37.2444381713867, 0.650038074146154, -80.0105590820313, -1.3964476923429, 218, 53, 'PPL', 'P'),
(157742, 'Southworth', 40.7638893127441, 0.711464084425914, -84.3399963378906, -1.47201062721615, 218, 41, 'PPL', 'P'),
(208802, 'Southworth', 47.5122184753418, 0.829244647321595, -122.500556945801, -2.13803805423103, 218, 56, 'PPL', 'P'),
(5986, 'Souwilpa', 31.8199996948242, 0.555363762658273, -88.3291702270508, -1.54163484601658, 218, 2, 'PPL', 'P'),
(111483, 'Sovereign', 37.8616714477539, 0.660810827071634, -81.8263931274414, -1.42813997510511, 218, 58, 'PPL', 'P'),
(169620, 'Sowams (historical)', 41.7308311462402, 0.728340403095691, -71.2869415283203, -1.24419184334587, 218, 47, 'PPL', 'P'),
(167428, 'Sowash', 40.3269386291504, 0.703837856328363, -79.4725036621094, -1.38705685370706, 218, 45, 'PPL', 'P'),
(106453, 'Sowego', 38.5988883972168, 0.67367769014127, -77.5766677856445, -1.35396827558532, 218, 53, 'PPL', 'P'),
(112567, 'Sowell Ford', 35.5924987792969, 0.621206292710793, -86.8847198486328, -1.51642443103151, 218, 50, 'PPL', 'P'),
(98218, 'Sowells Bluff', 33.750560760498, 0.589058409665092, -96.1947174072266, -1.67891454178161, 218, 51, 'PPL', 'P'),
(62, 'Sowers', 32.8283309936523, 0.572962463773735, -96.9930572509766, -1.6928482006049, 218, 51, 'PPL', 'P'),
(106454, 'Sowers', 37.0033302307129, 0.645829946728693, -80.3794403076172, -1.40288588427816, 218, 53, 'PPL', 'P'),
(38310, 'Spa', 36.961669921875, 0.645102837172074, -87.0047225952148, -1.5185188740708, 218, 21, 'PPL', 'P'),
(185310, 'Spa (historical)', 35.9419403076172, 0.627305197923184, -119.441108703613, -2.08464060911051, 218, 6, 'PPL', 'P'),
(189596, 'Spaceport City', 32.3958282470703, 0.56541386682196, -106.683326721191, -1.86197530826564, 218, 38, 'PPL', 'P'),
(167430, 'Spaces Corners', 40.8397216796875, 0.712787608908656, -79.4658279418945, -1.38694034040937, 218, 45, 'PPL', 'P'),
(152802, 'Spackenkill', 41.6558303833008, 0.72703139284089, -73.9138870239258, -1.29004069151462, 218, 40, 'PPL', 'P'),
(192259, 'Spade', 33.9261093139648, 0.592122309920201, -102.153060913086, -1.78290725392367, 218, 51, 'PPL', 'P'),
(77295, 'Spade Mountain', 35.877498626709, 0.626180478415816, -94.7461090087891, -1.65363155565683, 218, 42, 'PPL', 'P'),
(31166, 'Spades', 39.2538909912109, 0.685109642015571, -85.1227798461914, -1.48567277676631, 218, 19, 'PPL', 'P'),
(12056, 'Spadra', 35.4249992370605, 0.618282874203186, -93.4936065673828, -1.63177126416502, 218, 4, 'PPL', 'P'),
(185311, 'Spadra', 34.0522193908691, 0.594323345982124, -117.799171447754, -2.0559833978846, 218, 6, 'PPL', 'P'),
(138199, 'Spafford', 43.6161117553711, 0.761244757049029, -95.3716735839844, -1.66454971717783, 218, 28, 'PPL', 'P'),
(152803, 'Spafford', 42.8044395446777, 0.747078404525489, -76.2652816772461, -1.33108027022885, 218, 40, 'PPL', 'P'),
(152807, 'Spafford Landing', 42.7863883972168, 0.746763352568533, -76.2747192382813, -1.33124498674227, 218, 40, 'PPL', 'P'),
(152804, 'Spafford Valley', 42.8230590820313, 0.747403376757506, -76.2405624389648, -1.33064883813226, 218, 40, 'PPL', 'P'),
(24993, 'Spain', 30.8644409179688, 0.538686115805816, -83.5380630493164, -1.45801425094919, 218, 13, 'PPL', 'P'),
(171329, 'Spain', 45.7030601501465, 0.79766887785707, -97.7855606079102, -1.7066799935165, 218, 49, 'PPL', 'P'),
(90943, 'Spain (historical)', 35.8047218322754, 0.624910283733902, -88.5105590820313, -1.54480067876242, 218, 50, 'PPL', 'P'),
(106455, 'Spainville', 37.1886100769043, 0.649063690082322, -77.916389465332, -1.35989753743627, 218, 53, 'PPL', 'P'),
(24994, 'Spalding', 32.2930603027344, 0.563620227827792, -83.9977798461914, -1.46603782268138, 218, 13, 'PPL', 'P'),
(57651, 'Spalding', 39.6186103820801, 0.691475196232106, -91.5263900756836, -1.59743685928534, 218, 29, 'PPL', 'P'),
(133201, 'Spalding', 45.6958312988281, 0.797542710600428, -87.5108337402344, -1.52735217993243, 218, 27, 'PPL', 'P'),
(143066, 'Spalding', 41.6888885498047, 0.727608366691056, -98.3630599975586, -1.71675925929412, 218, 35, 'PPL', 'P'),
(189597, 'Spalding', 32.4491691589355, 0.566344841360025, -107.966941833496, -1.88437861830371, 218, 38, 'PPL', 'P'),
(195636, 'Spalding', 46.4469413757324, 0.810652054487315, -116.816390991211, -2.03883064309367, 218, 17, 'PPL', 'P'),
(83734, 'Spalding (historical)', 34.2744407653809, 0.598201840635661, -80.5922164916992, -1.40659952926022, 218, 48, 'PPL', 'P'),
(193971, 'Spalding Corner', 41.1305618286133, 0.717863727104401, -121.579170227051, -2.1219568223047, 218, 6, 'PPL', 'P'),
(24996, 'Spalding Hills', 33.9766693115234, 0.593004748347399, -84.3080596923828, -1.4714532276, 218, 13, 'PPL', 'P'),
(193972, 'Spalding Tract', 40.6530609130859, 0.709529763947162, -120.77082824707, -2.10784859327195, 218, 6, 'PPL', 'P'),
(208804, 'Spanaway', 47.1041717529297, 0.822122888513532, -122.433326721191, -2.13686466545474, 218, 56, 'PPL', 'P'),
(128955, 'Spang Mills', 43.478889465332, 0.758849776280721, -70.6358337402344, -1.23282786865839, 218, 26, 'PPL', 'P'),
(208805, 'Spangle', 47.4275016784668, 0.827766060284383, -117.379173278809, -2.04865304698416, 218, 56, 'PPL', 'P'),
(106456, 'Spangler', 37.2991714477539, 0.650993350029166, -80.0772171020508, -1.3976110942651, 218, 53, 'PPL', 'P'),
(111485, 'Spangler', 38.6061096191406, 0.673803724239858, -80.0238876342773, -1.39668031946412, 218, 58, 'PPL', 'P'),
(185312, 'Spangler', 35.5488891601563, 0.620445161271248, -117.450561523438, -2.04989900690015, 218, 6, 'PPL', 'P'),
(167431, 'Spangler (historical)', 40.6427803039551, 0.709350333468718, -78.773063659668, -1.3748493227443, 218, 45, 'PPL', 'P'),
(111486, 'Spangler Factory (historical)', 37.7430610656738, 0.658740685377288, -81.1930618286133, -1.41708625868463, 218, 58, 'PPL', 'P'),
(38311, 'Spanglin', 38.0661087036133, 0.664378930300122, -83.2316665649414, -1.45266662348031, 218, 21, 'PPL', 'P'),
(167433, 'Spangsville', 40.3563919067383, 0.704351912997775, -75.7427825927734, -1.32196094086614, 218, 45, 'PPL', 'P'),
(211102, 'Spanish B Village', 20.8683300018311, 0.364221067924666, -156.448333740234, -2.73053853302602, 218, 15, 'PPL', 'P'),
(98219, 'Spanish Bluff (historical)', 33.5426788330078, 0.585430185574996, -94.3861389160156, -1.64734889232922, 218, 51, 'PPL', 'P'),
(43159, 'Spanish City', 32.5291709899902, 0.567741136719553, -92.0316696166992, -1.60625565091903, 218, 22, 'PPL', 'P'),
(185315, 'Spanish Flat', 38.8233299255371, 0.677594933788668, -120.808326721191, -2.10850306510984, 218, 6, 'PPL', 'P'),
(185314, 'Spanish Flat Resort', 38.5200004577637, 0.672300835857699, -122.208610534668, -2.13294262811738, 218, 6, 'PPL', 'P'),
(205866, 'Spanish Fork', 40.1150016784668, 0.700138858732297, -111.654167175293, -1.94873284078104, 218, 52, 'PPL', 'P'),
(5987, 'Spanish Fort', 30.6747207641602, 0.535374874464466, -87.915283203125, -1.5344111547178, 218, 2, 'PPL', 'P'),
(43160, 'Spanish Fort', 30.0208301544189, 0.523962330376608, -90.0824966430664, -1.57223616483825, 218, 22, 'PPL', 'P'),
(61840, 'Spanish Fort', 32.7594413757324, 0.571760113120592, -90.7347183227539, -1.58361958060168, 218, 30, 'PPL', 'P'),
(98220, 'Spanish Fort', 33.9455604553223, 0.592461796380159, -97.6166687011719, -1.70373227366395, 218, 51, 'PPL', 'P'),
(90944, 'Spanish Grove', 35.9322204589844, 0.627135554561745, -88.2811126708984, -1.54079608343126, 218, 50, 'PPL', 'P'),
(106457, 'Spanish Grove', 36.7955589294434, 0.642203653430387, -78.5355606079102, -1.37070411250759, 218, 53, 'PPL', 'P'),
(185316, 'Spanish Hills', 34.2291717529297, 0.597411747319262, -119.093887329102, -2.07858045289198, 218, 6, 'PPL', 'P'),
(57652, 'Spanish Lake', 38.7877807617188, 0.676974483833706, -90.2158279418945, -1.57456323499876, 218, 29, 'PPL', 'P'),
(185317, 'Spanish Ranch', 39.9508285522461, 0.697273497136454, -121.056106567383, -2.11282763924596, 218, 6, 'PPL', 'P'),
(190761, 'Spanish Springs', 39.649169921875, 0.692008560819422, -119.706390380859, -2.08927064782366, 218, 39, 'PPL', 'P'),
(195637, 'Spanish Town (historical)', 43.7097206115723, 0.762878539798766, -115.254173278809, -2.01156480037928, 218, 17, 'PPL', 'P'),
(24997, 'Spanish Trace', 33.3808288574219, 0.582605370606749, -82.0811080932617, -1.43258558991278, 218, 13, 'PPL', 'P'),
(192251, 'Spanish Trail Additon Colonia', 31.6569995880127, 0.55251887411331, -106.295997619629, -1.85521514015458, 218, 51, 'PPL', 'P'),
(24998, 'Spanish Trails', 33.9308280944824, 0.592204668176912, -84.7738876342773, -1.47958345893385, 218, 13, 'PPL', 'P'),
(90945, 'Spanish Trails', 35.9486083984375, 0.62742157806282, -84.091667175293, -1.4676764657001, 218, 50, 'PPL', 'P'),
(192794, 'Spanish Valley', 38.4933280944824, 0.671835315299153, -109.457778930664, -1.91039863426017, 218, 52, 'PPL', 'P'),
(98223, 'Spanish Village', 28.2758293151855, 0.493506320281921, -96.8805618286133, -1.69088478509124, 218, 51, 'PPL', 'P'),
(194428, 'Spanish Village', 40.3844413757324, 0.704841468585159, -104.545829772949, -1.82466894876748, 218, 7, 'PPL', 'P'),
(83735, 'Spanish Wells', 32.1916694641113, 0.561850623862461, -80.7786102294922, -1.40985271368981, 218, 48, 'PPL', 'P'),
(111487, 'Spanishburg', 37.4458312988281, 0.653553047310895, -81.1202774047852, -1.41581593084466, 218, 58, 'PPL', 'P'),
(74369, 'Spanker', 39.8580589294434, 0.695654361772713, -84.2452774047852, -1.47035746996948, 218, 41, 'PPL', 'P'),
(28662, 'Spankey', 39.1888885498047, 0.683975135391198, -90.5505599975586, -1.58040541148207, 218, 18, 'PPL', 'P'),
(24999, 'Spann', 32.6655616760254, 0.57012160325992, -82.748893737793, -1.4442406481074, 218, 13, 'PPL', 'P'),
(38312, 'Spann', 36.8519401550293, 0.643187691453171, -84.7705612182617, -1.47952540202208, 218, 21, 'PPL', 'P'),
(74370, 'Spann (historical)', 39.0088882446289, 0.680833537411286, -84.2597198486328, -1.47060953816666, 218, 41, 'PPL', 'P'),
(5989, 'Spann Brothers Estates', 31.2222194671631, 0.544930529482265, -85.4749984741211, -1.49182015151054, 218, 2, 'PPL', 'P'),
(187382, 'Spar City', 37.707218170166, 0.658115108837228, -106.967781066895, -1.86693997316976, 218, 7, 'PPL', 'P'),
(192252, 'Sparenberg', 32.5838890075684, 0.568696146286455, -101.839721679688, -1.7774384526252, 218, 51, 'PPL', 'P'),
(74371, 'Spargursville', 39.2252807617188, 0.684610299311182, -83.1672210693359, -1.45154183739391, 218, 41, 'PPL', 'P'),
(192253, 'Spark''s Addition Colonia', 31.6709995269775, 0.552763219143325, -106.245002746582, -1.85432511171828, 218, 51, 'PPL', 'P'),
(192254, 'Spark''s Addition Number 2 Colonia', 31.6790008544922, 0.552902868652986, -106.244003295898, -1.85430766801314, 218, 51, 'PPL', 'P'),
(192255, 'Spark''s Addition Number 3 Colonia', 31.6720008850098, 0.552780696137978, -106.236999511719, -1.8541854289191, 218, 51, 'PPL', 'P'),
(192256, 'Spark''s Addition Number 4 Colonia', 31.6790008544922, 0.552902868652986, -106.235000610352, -1.85415054150882, 218, 51, 'PPL', 'P'),
(152806, 'Sparkill', 41.0311088562012, 0.716127945284915, -73.9274978637695, -1.29027824548385, 218, 40, 'PPL', 'P'),
(185318, 'Sparkle', 37.9283294677734, 0.661974228993835, -122.055557250977, -2.13027134438598, 218, 6, 'PPL', 'P'),
(68977, 'Sparkleberry Landing', 34.4777793884277, 0.601750769104301, -78.206672668457, -1.36496393509403, 218, 33, 'PPL', 'P'),
(106458, 'Sparkling Springs', 38.5513916015625, 0.672848714672956, -78.9519424438477, -1.3779713464902, 218, 53, 'PPL', 'P'),
(12058, 'Sparkman', 33.9166717529297, 0.59195759340678, -92.8480606079102, -1.62050436169928, 218, 4, 'PPL', 'P'),
(18166, 'Sparkman', 27.0061092376709, 0.471345524350613, -81.711669921875, -1.42613767743954, 218, 12, 'PPL', 'P'),
(90946, 'Sparkman', 35.8061103820801, 0.624934518499822, -85.5130615234375, -1.49248447704446, 218, 50, 'PPL', 'P'),
(25001, 'Sparks', 33.0877799987793, 0.577490703154224, -82.7377777099609, -1.44404663682199, 218, 13, 'PPL', 'P'),
(34020, 'Sparks', 39.8574981689453, 0.695644574655707, -95.1900024414063, -1.66137895758398, 218, 20, 'PPL', 'P'),
(43162, 'Sparks', 30.4986095428467, 0.532301153802837, -91.5272216796875, -1.59745137351328, 218, 22, 'PPL', 'P'),
(51585, 'Sparks', 39.5308303833008, 0.689943146236011, -76.646110534668, -1.33772698767747, 218, 25, 'PPL', 'P'),
(77296, 'Sparks', 35.6080589294434, 0.621477868562954, -96.8208312988281, -1.68984229068253, 218, 42, 'PPL', 'P'),
(190765, 'Sparks', 39.5349998474121, 0.690015917112797, -119.751670837402, -2.09006094087715, 218, 39, 'PPL', 'P'),
(192257, 'Sparks', 31.6725006103516, 0.552789417990548, -106.239166259766, -1.85422324580658, 218, 51, 'PPL', 'P'),
(199696, 'Sparks', 42.9411087036133, 0.749463731334846, -100.255561828613, -1.74978964734605, 218, 35, 'PPL', 'P'),
(111488, 'Sparks (historical)', 38.2355613708496, 0.667336437269682, -80.9027786254883, -1.41201986102686, 218, 58, 'PPL', 'P'),
(51586, 'Sparks Corner', 39.1161117553711, 0.682704940709284, -76.0216674804688, -1.32682840039048, 218, 25, 'PPL', 'P'),
(98225, 'Sparks Crossing', 31.0708293914795, 0.542288274206743, -98.1350021362305, -1.71277889872889, 218, 51, 'PPL', 'P'),
(28661, 'Sparks Hill', 37.5847206115723, 0.655977123114113, -88.2869415283203, -1.5408978161849, 218, 18, 'PPL', 'P'),
(25002, 'Sparks Mill', 34.8950004577637, 0.609032650472905, -84.1449966430664, -1.46860724050108, 218, 13, 'PPL', 'P'),
(31167, 'Sparksville', 38.7777786254883, 0.676799913624252, -86.2372207641602, -1.50512344010382, 218, 19, 'PPL', 'P'),
(38313, 'Sparksville', 37.0083312988281, 0.64591723183342, -85.4019393920898, -1.49054502998061, 218, 21, 'PPL', 'P'),
(185319, 'Sparkville (historical)', 36.9680595397949, 0.645214357042721, -119.611106872559, -2.08760763688097, 218, 6, 'PPL', 'P'),
(121538, 'Sparland', 41.0286102294922, 0.716084336022065, -89.4383316040039, -1.56099336398037, 218, 18, 'PPL', 'P'),
(133203, 'Sparlingville', 42.9644393920898, 0.749870928665519, -82.523063659668, -1.44029916969409, 218, 27, 'PPL', 'P'),
(18167, 'Sparr', 29.3383293151855, 0.512050443584361, -82.1127777099609, -1.43313832899703, 218, 12, 'PPL', 'P'),
(133204, 'Sparr', 45.041389465332, 0.786120545843132, -84.5725021362305, -1.47606861892716, 218, 27, 'PPL', 'P'),
(38314, 'Sparrow', 37.9238891601563, 0.661896731006114, -85.1508331298828, -1.48616239893272, 218, 21, 'PPL', 'P'),
(57654, 'Sparrow', 38.336669921875, 0.669101114386996, -93.7149963378906, -1.63563524459062, 218, 29, 'PPL', 'P'),
(152808, 'Sparrow Bush', 41.4000015258789, 0.722566336957263, -74.7236099243164, -1.30417302215523, 218, 40, 'PPL', 'P'),
(83736, 'Sparrows Crossroads', 34.0538902282715, 0.594352507596061, -79.879997253418, -1.39416895855617, 218, 48, 'PPL', 'P'),
(51587, 'Sparrows Point', 39.2191696166992, 0.684503639709524, -76.4763870239258, -1.33476475359697, 218, 25, 'PPL', 'P'),
(25003, 'Sparta', 33.2755584716797, 0.580768055770703, -82.9763870239258, -1.4482111549766, 218, 13, 'PPL', 'P'),
(28668, 'Sparta', 38.1230583190918, 0.665372888597967, -89.7016677856445, -1.56558944738963, 218, 18, 'PPL', 'P'),
(31171, 'Sparta', 39.105281829834, 0.682515922850916, -85.045280456543, -1.48432015724866, 218, 19, 'PPL', 'P'),
(38315, 'Sparta', 38.6769409179688, 0.675039963617873, -84.9069366455078, -1.48190560224634, 218, 21, 'PPL', 'P'),
(43163, 'Sparta', 32.3672218322754, 0.564914590696597, -93.0794372558594, -1.62454264601822, 218, 22, 'PPL', 'P'),
(57656, 'Sparta', 37.0011100769043, 0.645791197734832, -93.0813903808594, -1.62457673448017, 218, 29, 'PPL', 'P'),
(61838, 'Sparta', 33.7686080932617, 0.589373395043021, -88.9791717529297, -1.55297951278616, 218, 30, 'PPL', 'P'),
(68978, 'Sparta', 36.5052795410156, 0.637137322351647, -81.1211090087891, -1.4158304450726, 218, 33, 'PPL', 'P'),
(90947, 'Sparta', 35.9258308410645, 0.627024034691098, -85.4641723632813, -1.4916312002312, 218, 50, 'PPL', 'P'),
(106459, 'Sparta', 37.9916687011719, 0.663079707162327, -77.2305603027344, -1.34792756044274, 218, 53, 'PPL', 'P'),
(133205, 'Sparta', 43.160831451416, 0.753298616725532, -85.7099990844727, -1.49592168590537, 218, 27, 'PPL', 'P'),
(138202, 'Sparta', 47.4674987792969, 0.82846414138512, -92.4772186279297, -1.61403194814401, 218, 28, 'PPL', 'P'),
(143068, 'Sparta', 42.6552810668945, 0.744475097980909, -97.9733276367188, -1.7099571463959, 218, 35, 'PPL', 'P'),
(146362, 'Sparta', 41.0333290100098, 0.716166694278776, -74.6388931274414, -1.30269443511802, 218, 37, 'PPL', 'P'),
(152809, 'Sparta', 41.144718170166, 0.718110801874533, -73.8638916015625, -1.28916810678345, 218, 40, 'PPL', 'P'),
(157744, 'Sparta', 40.394718170166, 0.705020832484576, -82.7005615234375, -1.44339709183212, 218, 41, 'PPL', 'P'),
(167438, 'Sparta', 40.0286102294922, 0.698631043502122, -80.3188934326172, -1.40182914195762, 218, 45, 'PPL', 'P'),
(176458, 'Sparta', 43.9441719055176, 0.766970486813672, -90.8127822875977, -1.58498205381537, 218, 57, 'PPL', 'P'),
(201583, 'Sparta', 44.8711090087891, 0.783148591224658, -117.323059082031, -2.04767366949328, 218, 43, 'PPL', 'P'),
(146363, 'Sparta Junction', 41.0641708374023, 0.716704985714108, -74.6716690063477, -1.30326648212017, 218, 37, 'PPL', 'P'),
(25004, 'Spartan Lane', 33.8980598449707, 0.591632754332817, -83.4061126708984, -1.45571128239654, 218, 13, 'PPL', 'P'),
(197588, 'Spartan Manor Trailer Park', 48.170280456543, 0.840729995575752, -111.945281982422, -1.95381375266675, 218, 31, 'PPL', 'P'),
(83737, 'Spartanburg', 34.9494400024414, 0.609982799770818, -81.9322204589844, -1.42998701047914, 218, 48, 'PPL', 'P'),
(123708, 'Spartanburg', 40.0661087036133, 0.699285515340009, -84.8516693115234, -1.48094100529951, 218, 19, 'PPL', 'P'),
(167435, 'Spartansburg', 41.8238906860352, 0.729964598465503, -79.6838912963867, -1.3907462639232, 218, 45, 'PPL', 'P'),
(167437, 'Sparton Marshfield', 40.2874984741211, 0.703149495765605, -76.8424987792969, -1.34115460915845, 218, 45, 'PPL', 'P'),
(34021, 'Spasticville', 37.833610534668, 0.660321071747168, -97.3358306884766, -1.69883072567766, 218, 20, 'PPL', 'P'),
(5990, 'Spaulding', 33.4686088562012, 0.584137420602844, -86.8424987792969, -1.51568753435789, 218, 2, 'PPL', 'P'),
(18168, 'Spaulding', 30.4119396209717, 0.530788478303672, -81.7750015258789, -1.42724302244997, 218, 12, 'PPL', 'P'),
(43164, 'Spaulding', 31.9475002288818, 0.55758906677563, -92.182502746582, -1.60888818565657, 218, 22, 'PPL', 'P'),
(77297, 'Spaulding', 35.0138893127441, 0.61110765243624, -96.4397201538086, -1.68319064638589, 218, 42, 'PPL', 'P'),
(111489, 'Spaulding', 37.8783302307129, 0.661101577683643, -82.3550033569336, -1.43736596406947, 218, 58, 'PPL', 'P'),
(117851, 'Spaulding', 41.1624984741211, 0.718421126720555, -94.370002746582, -1.64706726304395, 218, 16, 'PPL', 'P'),
(121543, 'Spaulding', 42.0027809143066, 0.733086821948485, -88.2352828979492, -1.53999620299786, 218, 18, 'PPL', 'P'),
(128956, 'Spaulding', 46.878059387207, 0.818176483252198, -68.2405624389648, -1.19102249797271, 218, 26, 'PPL', 'P'),
(138204, 'Spaulding', 45.7761116027832, 0.798943866228946, -94.8525009155273, -1.65548844472689, 218, 28, 'PPL', 'P'),
(176461, 'Spaulding', 44.3558311462402, 0.774155295960543, -90.4155578613281, -1.57804917970762, 218, 57, 'PPL', 'P'),
(152812, 'Spaulding Corner', 42.5008316040039, 0.741779446325531, -76.7505569458008, -1.33954992144363, 218, 40, 'PPL', 'P'),
(121540, 'Spaulding Corners', 42.3705596923828, 0.739505772544876, -87.8811111450195, -1.53381473979167, 218, 18, 'PPL', 'P'),
(152811, 'Spaulding Furnace', 42.0277786254883, 0.733523114314067, -73.6952819824219, -1.28622531377892, 218, 40, 'PPL', 'P'),
(83739, 'Spaulding Heights', 34.2216682434082, 0.597280786372657, -79.7572174072266, -1.39202604598504, 218, 48, 'PPL', 'P'),
(51588, 'Spaulding Knolls', 39.1286087036133, 0.682923053602562, -76.6486129760742, -1.33777066351934, 218, 25, 'PPL', 'P'),
(25005, 'Spauldings Settlement (historical)', 32.0958290100098, 0.560177892381783, -81.0827789306641, -1.41516145900677, 218, 13, 'PPL', 'P'),
(77298, 'Spavinaw', 36.3911094665527, 0.635144678645022, -95.04638671875, -1.658872390366, 218, 42, 'PPL', 'P'),
(152813, 'Spawn Hollow', 42.5394401550293, 0.742453292660348, -73.8672180175781, -1.28922616369522, 218, 40, 'PPL', 'P'),
(5991, 'Speake', 34.415828704834, 0.600669525701729, -87.1675033569336, -1.5213599343217, 218, 2, 'PPL', 'P'),
(133207, 'Speaker', 43.2050018310547, 0.754069535282083, -82.8041687011719, -1.44520537821229, 218, 27, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(201584, 'Speaker', 42.7166709899902, 0.745546554266475, -123.292778015137, -2.15186492029462, 218, 43, 'PPL', 'P'),
(152814, 'Speakers Corner', 42.8699989318848, 0.748222631687841, -77.4483337402344, -1.3517284239505, 218, 40, 'PPL', 'P'),
(98227, 'Speaks', 29.2552795410156, 0.510600951582058, -96.6999969482422, -1.68773333341529, 218, 51, 'PPL', 'P'),
(83740, 'Speaks Mill', 32.7727813720703, 0.571992939978892, -81.1436080932617, -1.41622312817534, 218, 48, 'PPL', 'P'),
(68979, 'Spear', 36.0222206115723, 0.628706353551701, -82.0238876342773, -1.431586904504, 218, 33, 'PPL', 'P'),
(98226, 'Spear', 30.601390838623, 0.534095025823601, -96.336669921875, -1.68139208054371, 218, 51, 'PPL', 'P'),
(209879, 'Spear', 45.1997184753418, 0.788883908369226, -107.378608703613, -1.87411026808869, 218, 31, 'PPL', 'P'),
(12059, 'Spear (historical)', 34.709171295166, 0.605789319739352, -91.5849990844727, -1.59845977946004, 218, 4, 'PPL', 'P'),
(185321, 'Spear Creek Summer Home Tract', 35.8199996948242, 0.625176932738047, -118.593330383301, -2.06984408609403, 218, 6, 'PPL', 'P'),
(12060, 'Spear Lake', 35.5480613708496, 0.620430713622335, -90.3216705322266, -1.57641053668889, 218, 4, 'PPL', 'P'),
(202647, 'Spearfish', 44.4908294677734, 0.776511461155963, -103.85888671875, -1.812679530698, 218, 49, 'PPL', 'P'),
(61839, 'Spearman', 33.9272193908691, 0.592141684417132, -89.5933303833008, -1.56369860301567, 218, 30, 'PPL', 'P'),
(192258, 'Spearman', 36.1983299255371, 0.631780040923816, -101.191940307617, -1.76613253484948, 218, 51, 'PPL', 'P'),
(83741, 'Spearman (historical)', 34.2486114501953, 0.597751034042138, -81.6861114501953, -1.42569159795695, 218, 48, 'PPL', 'P'),
(192795, 'Spearmint', 39.1116714477539, 0.682627442721563, -111.803062438965, -1.95133155337274, 218, 52, 'PPL', 'P'),
(5992, 'Spears', 31.1447200775146, 0.543577909964614, -85.9855575561523, -1.50073108851795, 218, 2, 'PPL', 'P'),
(38316, 'Spears', 37.872501373291, 0.660999844930002, -84.4377822875977, -1.47371731400073, 218, 21, 'PPL', 'P'),
(189598, 'Spears', 31.7297191619873, 0.553788070109814, -108.816940307617, -1.89921389031405, 218, 38, 'PPL', 'P'),
(90950, 'Spears (historical)', 36.3666687011719, 0.634718106817419, -82.9958267211914, -1.44855044169948, 218, 50, 'PPL', 'P'),
(111490, 'Spears (historical)', 38.1222190856934, 0.665358241211971, -82.1158294677734, -1.43319159221883, 218, 58, 'PPL', 'P'),
(128957, 'Spears Corner', 44.2044410705566, 0.77151304068502, -69.8838882446289, -1.21970394396454, 218, 26, 'PPL', 'P'),
(157745, 'Spears Corners', 41.3325004577637, 0.72138822107004, -82.6244430541992, -1.44206857392234, 218, 41, 'PPL', 'P'),
(83742, 'Spears Creek', 34.1161117553711, 0.595438478109568, -80.7219390869141, -1.40886361566096, 218, 48, 'PPL', 'P'),
(167439, 'Spears Grove', 40.2722206115723, 0.70288284676146, -77.7063903808594, -1.35623236198605, 218, 45, 'PPL', 'P'),
(31169, 'Spearsville', 39.3305587768555, 0.686447747305282, -86.1963882446289, -1.50441077819611, 218, 19, 'PPL', 'P'),
(43165, 'Spearsville', 32.9358291625977, 0.574838660761696, -92.6050033569336, -1.61626221239889, 218, 22, 'PPL', 'P'),
(34022, 'Spearville', 37.8499984741211, 0.660607095248243, -99.7563934326172, -1.74107751531402, 218, 20, 'PPL', 'P'),
(106460, 'Spec', 37.4544410705566, 0.653703316175403, -79.7716674804688, -1.39227824734027, 218, 53, 'PPL', 'P'),
(157746, 'Specht', 40.6480598449707, 0.709442478842435, -81.0147171020508, -1.41397355600255, 218, 41, 'PPL', 'P'),
(98228, 'Specht Store', 29.7174301147461, 0.518667000733636, -98.4449234008789, -1.71818804521895, 218, 51, 'PPL', 'P'),
(167440, 'Spechty Kopf', 40.5227813720703, 0.707255957008452, -76.670280456543, -1.33814883239414, 218, 45, 'PPL', 'P'),
(38317, 'Speck', 37.3066711425781, 0.651124244396743, -85.1877822875977, -1.48680728339069, 218, 21, 'PPL', 'P'),
(90951, 'Speck', 36.4486083984375, 0.636148224322792, -84.684440612793, -1.47802231390284, 218, 50, 'PPL', 'P'),
(176462, 'Speck Oaks', 44.3002815246582, 0.773185772165699, -90.570556640625, -1.58075441874292, 218, 57, 'PPL', 'P'),
(90952, 'Speck Subdivision', 36.1783294677734, 0.631430967083934, -85.5597229003906, -1.49329887170581, 218, 50, 'PPL', 'P'),
(167441, 'Specktown', 40.5541687011719, 0.707803769244682, -75.3499984741211, -1.31510556474612, 218, 45, 'PPL', 'P'),
(152815, 'Speculator', 43.4972190856934, 0.759169688506667, -74.3622207641602, -1.29786559142949, 218, 40, 'PPL', 'P'),
(208806, 'Spee-Bi-Dah', 48.0916709899902, 0.839358001561171, -122.321937561035, -2.13492055785899, 218, 56, 'PPL', 'P'),
(167444, 'Speeceville', 40.374439239502, 0.704666898375705, -76.9944381713867, -1.3438064518139, 218, 45, 'PPL', 'P'),
(5993, 'Speed', 32.7747192382813, 0.572026762124736, -86.2319412231445, -1.5050312947301, 218, 2, 'PPL', 'P'),
(31170, 'Speed', 38.4122200012207, 0.670419712021722, -85.7525024414063, -1.49666350942701, 218, 19, 'PPL', 'P'),
(34024, 'Speed', 39.6772193908691, 0.692498116406805, -99.4205627441406, -1.73521616407086, 218, 20, 'PPL', 'P'),
(57658, 'Speed', 38.8480606079102, 0.678026565622342, -92.8030624389648, -1.61971899549382, 218, 29, 'PPL', 'P'),
(68980, 'Speed', 35.9677810668945, 0.627756204253788, -77.445556640625, -1.35167995441867, 218, 33, 'PPL', 'P'),
(111491, 'Speed', 38.7336082458496, 0.676028995067701, -81.3777770996094, -1.42031014834223, 218, 58, 'PPL', 'P'),
(61841, 'Speeds Addition', 32.3388900756836, 0.564420108261197, -90.8855590820313, -1.58625224849728, 218, 30, 'PPL', 'P'),
(152816, 'Speedsville', 42.3036117553711, 0.738337310616604, -76.2547225952148, -1.33089597948141, 218, 40, 'PPL', 'P'),
(61842, 'Speedtown', 31.6305599212646, 0.552057414875426, -89.4430618286133, -1.56107592197416, 218, 30, 'PPL', 'P'),
(31172, 'Speedway', 39.8022193908691, 0.694679777971798, -86.267219543457, -1.50564701757412, 218, 19, 'PPL', 'P'),
(111492, 'Speedway', 37.4563903808594, 0.653737338058329, -81.0105590820313, -1.41390098486284, 218, 58, 'PPL', 'P'),
(38318, 'Speedwell', 37.6741714477539, 0.657538334724145, -84.1752777099609, -1.46913574481941, 218, 21, 'PPL', 'P'),
(68981, 'Speedwell', 35.2841682434082, 0.615824909675097, -83.1880569458008, -1.45190549204076, 218, 33, 'PPL', 'P'),
(71424, 'Speedwell', 39.7630615234375, 0.693996344257057, -74.5458297729492, -1.30107017316918, 218, 37, 'PPL', 'P'),
(90953, 'Speedwell', 36.458610534668, 0.636322794532246, -83.871940612793, -1.46384151373039, 218, 50, 'PPL', 'P'),
(106461, 'Speedwell', 36.8136100769043, 0.642518705387343, -81.1719436645508, -1.41671767718976, 218, 53, 'PPL', 'P'),
(167442, 'Speedwell', 40.208610534668, 0.701772641482034, -76.3222198486328, -1.33207402878961, 218, 45, 'PPL', 'P'),
(98229, 'Speegleville', 31.5558300018311, 0.55075313173156, -97.2522201538086, -1.69737144655835, 218, 51, 'PPL', 'P'),
(77301, 'Speer', 34.1133308410645, 0.595389941998701, -95.5555572509766, -1.66775909260748, 218, 42, 'PPL', 'P'),
(121541, 'Speer', 40.9883308410645, 0.715381328073311, -89.6502838134766, -1.56469262789254, 218, 18, 'PPL', 'P'),
(209751, 'Speer', 41.0544395446777, 0.716535142615588, -104.894996643066, -1.83076306028991, 218, 59, 'PPL', 'P'),
(197589, 'Speer Trailer Park', 48.170280456543, 0.840729995575752, -111.945281982422, -1.95381375266675, 218, 31, 'PPL', 'P'),
(167443, 'Speers', 40.124439239502, 0.700303575245719, -79.879997253418, -1.39416895855617, 218, 45, 'PPL', 'P'),
(123709, 'Speicherville', 40.8544387817383, 0.713044470795794, -85.7916717529297, -1.49734714287884, 218, 19, 'PPL', 'P'),
(157747, 'Speidel', 40.0019416809082, 0.698165589522603, -81.1136093139648, -1.41569955070503, 218, 41, 'PPL', 'P'),
(90954, 'Speiden', 35.2097206115723, 0.614525553379248, -86.8433303833008, -1.51570204858583, 218, 50, 'PPL', 'P'),
(38319, 'Speight', 37.2750015258789, 0.650571505312497, -82.6875, -1.44316912524281, 218, 21, 'PPL', 'P'),
(68982, 'Speight', 35.5988883972168, 0.62131781258144, -77.3383331298828, -1.34980855112067, 218, 33, 'PPL', 'P'),
(68984, 'Speights Bridge', 35.5588912963867, 0.620619731480703, -77.7355575561523, -1.35674142522842, 218, 33, 'PPL', 'P'),
(152817, 'Speigletown', 42.8044395446777, 0.747078404525489, -73.6347198486328, -1.28516830514226, 218, 40, 'PPL', 'P'),
(5994, 'Speigner', 32.5838890075684, 0.568696146286455, -86.3447189331055, -1.50699963709178, 218, 2, 'PPL', 'P'),
(83743, 'Speigner', 33.9041709899902, 0.591739413934475, -81.7324981689453, -1.42650119892833, 218, 48, 'PPL', 'P'),
(157748, 'Spellacy', 40.5938911437988, 0.708497056655456, -82.2127838134766, -1.43488376477547, 218, 41, 'PPL', 'P'),
(185322, 'Spellacy', 35.1130599975586, 0.61283850740771, -119.470558166504, -2.08515459920089, 218, 6, 'PPL', 'P'),
(74372, 'Spellman Crossing', 39.1674995422363, 0.683601826785396, -83.274169921875, -1.45340844700195, 218, 41, 'PPL', 'P'),
(111493, 'Spelter', 39.3450012207031, 0.686699815502458, -80.3180618286133, -1.40181462772968, 218, 58, 'PPL', 'P'),
(77303, 'Spelter City', 35.4583282470703, 0.618864575164286, -95.9630584716797, -1.67487133061465, 218, 42, 'PPL', 'P'),
(31174, 'Spelterville', 39.5277786254883, 0.689889883014209, -87.3983306884766, -1.52538863126072, 218, 19, 'PPL', 'P'),
(143072, 'Spelts', 41.5966682434082, 0.725998818707239, -98.8469390869141, -1.72520454258493, 218, 35, 'PPL', 'P'),
(212159, 'Spenard', 61.1886100769043, 1.06794271056096, -149.906387329102, -2.61636002866273, 218, 1, 'PPL', 'P'),
(25006, 'Spence', 31.0324993133545, 0.541619288140915, -84.164436340332, -1.46894652722396, 218, 13, 'PPL', 'P'),
(34025, 'Spence', 39.9324989318848, 0.696953584910508, -96.9361114501953, -1.69185430888608, 218, 20, 'PPL', 'P'),
(51589, 'Spence', 38.1619415283203, 0.666051528622746, -75.3099975585938, -1.31440741706635, 218, 25, 'PPL', 'P'),
(185323, 'Spence', 36.6127815246582, 0.639013585918635, -121.565559387207, -2.12171926833546, 218, 6, 'PPL', 'P'),
(12061, 'Spence Jucntion', 35.7874984741211, 0.62460967942586, -93.0633316040039, -1.62426154936516, 218, 4, 'PPL', 'P'),
(5995, 'Spencer', 32.9447212219238, 0.57499385647422, -87.2463912963867, -1.52273678860527, 218, 2, 'PPL', 'P'),
(31173, 'Spencer', 39.2866706848145, 0.685681755596748, -86.7624969482422, -1.51429123899836, 218, 19, 'PPL', 'P'),
(34026, 'Spencer', 39.0577812194824, 0.681686880803574, -95.5319366455078, -1.66734683527074, 218, 20, 'PPL', 'P'),
(43166, 'Spencer', 32.7400016784668, 0.571420826397716, -92.1316680908203, -1.60800095353941, 218, 22, 'PPL', 'P'),
(57660, 'Spencer', 37.184440612793, 0.648990919205535, -93.7022171020508, -1.63541220484933, 218, 29, 'PPL', 'P'),
(61843, 'Spencer', 33.0180587768555, 0.57627383827314, -90.9761123657227, -1.58783270144619, 218, 30, 'PPL', 'P'),
(68986, 'Spencer', 35.6922187805176, 0.622946735062187, -80.4349975585938, -1.40385554123106, 218, 33, 'PPL', 'P'),
(77304, 'Spencer', 35.5227813720703, 0.619989494408736, -97.3769378662109, -1.69954818127532, 218, 42, 'PPL', 'P'),
(90955, 'Spencer', 35.7472190856934, 0.623906671477106, -85.466667175293, -1.49167474291502, 218, 50, 'PPL', 'P'),
(106463, 'Spencer', 36.6197204589844, 0.639134693169206, -80.0074996948242, -1.39639429596304, 218, 53, 'PPL', 'P'),
(111494, 'Spencer', 38.8019409179688, 0.677221625182866, -81.3511123657227, -1.41984476094173, 218, 58, 'PPL', 'P'),
(117853, 'Spencer', 43.1413917541504, 0.752959330002656, -95.144172668457, -1.66057907715057, 218, 16, 'PPL', 'P'),
(121542, 'Spencer', 41.4980583190918, 0.724277750852775, -87.9416732788086, -1.53487174842833, 218, 18, 'PPL', 'P'),
(126230, 'Spencer', 42.2438888549805, 0.737294949365947, -71.9927825927734, -1.25651109391636, 218, 23, 'PPL', 'P'),
(133210, 'Spencer', 44.6413917541504, 0.779139268782571, -85.1147232055664, -1.48553216186076, 218, 27, 'PPL', 'P'),
(143073, 'Spencer', 42.8738899230957, 0.748290542295639, -98.7011108398438, -1.72265935953114, 218, 35, 'PPL', 'P'),
(152818, 'Spencer', 42.2097206115723, 0.736698601018851, -76.4936065673828, -1.33506529132599, 218, 40, 'PPL', 'P'),
(157750, 'Spencer', 40.0577812194824, 0.699140173323518, -81.8869400024414, -1.42919671742566, 218, 41, 'PPL', 'P'),
(171330, 'Spencer', 43.7275009155273, 0.763188864644787, -97.5927810668945, -1.70331535579529, 218, 49, 'PPL', 'P'),
(176463, 'Spencer', 44.7577781677246, 0.781170594904029, -90.2966690063477, -1.57597417774428, 218, 57, 'PPL', 'P'),
(195638, 'Spencer', 44.3605613708496, 0.774237853954335, -112.186111450195, -1.95801701981522, 218, 17, 'PPL', 'P'),
(12062, 'Spencer (historical)', 36.2547187805176, 0.632764212104655, -92.245002746582, -1.60997901643907, 218, 4, 'PPL', 'P'),
(190763, 'Spencer (historical)', 39.7099990844727, 0.693070229987982, -116.766670227051, -2.03796285205247, 218, 39, 'PPL', 'P'),
(138207, 'Spencer Brook', 45.5219383239746, 0.794507705643146, -93.4402770996094, -1.63084048936404, 218, 28, 'PPL', 'P'),
(167446, 'Spencer Corner', 41.2758293151855, 0.720399123041184, -74.9066696166992, -1.307368016515, 218, 45, 'PPL', 'P'),
(152824, 'Spencer Corners', 41.9633293151855, 0.732398261648645, -73.5027770996094, -1.28286546974767, 218, 40, 'PPL', 'P'),
(31176, 'Spencer County Farm', 37.8727798461914, 0.661004705198992, -87.1069412231445, -1.52030292568505, 218, 19, 'PPL', 'P'),
(51590, 'Spencer Gardens', 39.1530609130859, 0.683349825167247, -76.5861129760742, -1.33667983273685, 218, 25, 'PPL', 'P'),
(28666, 'Spencer Heights', 37.1272201538086, 0.647992233796756, -89.1947174072266, -1.556741494142, 218, 18, 'PPL', 'P'),
(68987, 'Spencer Heights', 35.8583297729492, 0.625845918803875, -81.626106262207, -1.42464430985827, 218, 33, 'PPL', 'P'),
(194429, 'Spencer Heights', 40.6741714477539, 0.709898212283974, -105.783889770508, -1.84627717206211, 218, 7, 'PPL', 'P'),
(90957, 'Spencer Hill', 35.4486083984375, 0.618694931802848, -87.1638870239258, -1.52129681740387, 218, 50, 'PPL', 'P'),
(25008, 'Spencer Hills', 34.9669418334961, 0.61028826434785, -85.3097229003906, -1.48893554857582, 218, 13, 'PPL', 'P'),
(68988, 'Spencer Mountain', 35.3061103820801, 0.616207872239851, -81.1108322143555, -1.41565108117319, 218, 33, 'PPL', 'P'),
(12063, 'Spencer Place', 34.7897186279297, 0.607195135899777, -90.5977783203125, -1.58122952668139, 218, 4, 'PPL', 'P'),
(152819, 'Spencer Settlement', 43.1691703796387, 0.753444158479105, -75.482780456543, -1.3174230475267, 218, 40, 'PPL', 'P'),
(74373, 'Spencer Station', 39.9625015258789, 0.697477228959845, -81.272216796875, -1.41846777350011, 218, 41, 'PPL', 'P'),
(5996, 'Spencer Store', 34.915828704834, 0.6093961719617, -87.041389465332, -1.51915883168075, 218, 2, 'PPL', 'P'),
(57664, 'Spencerburg', 39.4216690063477, 0.688037920792168, -91.3874969482422, -1.5950127169031, 218, 29, 'PPL', 'P'),
(152821, 'Spencerport', 43.1863899230957, 0.753744696208121, -77.8041687011719, -1.35793891561257, 218, 40, 'PPL', 'P'),
(205868, 'Spencers Annex', 40.7080612182617, 0.710489700362081, -112.099998474121, -1.95651406485403, 218, 52, 'PPL', 'P'),
(169621, 'Spencers Corner', 41.6572189331055, 0.72705562760681, -71.5272216796875, -1.24838552311442, 218, 47, 'PPL', 'P'),
(167447, 'Spencers Corners', 41.6047210693359, 0.726139367033768, -75.5666732788086, -1.31888725349403, 218, 45, 'PPL', 'P'),
(117855, 'Spencers Grove', 42.2844390869141, 0.738002684425635, -91.8688888549805, -1.60341459066813, 218, 16, 'PPL', 'P'),
(90958, 'Spencers Mill', 35.9855613708496, 0.62806652909981, -87.2302780151367, -1.52245555879416, 218, 50, 'PPL', 'P'),
(51591, 'Spencers Wharf', 38.3211097717285, 0.668829538534835, -76.4791717529297, -1.33481335628687, 218, 25, 'PPL', 'P'),
(152822, 'Spencertown', 42.3233299255371, 0.738681457608469, -73.54638671875, -1.28362660118722, 218, 40, 'PPL', 'P'),
(167448, 'Spencertown', 41.6183280944824, 0.726376854423976, -76.899169921875, -1.34214370718731, 218, 45, 'PPL', 'P'),
(51592, 'Spencerville', 39.1141700744629, 0.682671051984413, -76.9786071777344, -1.3435301488508, 218, 25, 'PPL', 'P'),
(77305, 'Spencerville', 34.142219543457, 0.59589414497208, -95.3580627441406, -1.66431216320859, 218, 42, 'PPL', 'P'),
(123711, 'Spencerville', 41.2830581665039, 0.720525290297827, -84.9219436645508, -1.48216752413955, 218, 19, 'PPL', 'P'),
(157754, 'Spencerville', 40.7088890075684, 0.710504148010995, -84.3536071777344, -1.47224818118539, 218, 41, 'PPL', 'P'),
(189599, 'Spencerville', 36.8199996948242, 0.64263022525799, -108.057502746582, -1.88595920441067, 218, 38, 'PPL', 'P'),
(51593, 'Spencerville Knolls', 39.1213912963867, 0.682797086083001, -76.9722213745117, -1.34341869555918, 218, 25, 'PPL', 'P'),
(68989, 'Spences Corner', 36.350830078125, 0.634441670696269, -76.1961135864258, -1.32987305930671, 218, 33, 'PPL', 'P'),
(152823, 'Speonk', 40.8194389343262, 0.712433608220757, -72.7058334350586, -1.26895617884835, 218, 40, 'PPL', 'P'),
(77306, 'Sperry', 36.2972183227539, 0.63350596904727, -95.9911117553711, -1.67536095278106, 218, 42, 'PPL', 'P'),
(98230, 'Sperry', 33.5305595397949, 0.585218664005416, -96.7083282470703, -1.68787874201081, 218, 51, 'PPL', 'P'),
(117856, 'Sperry', 40.9569396972656, 0.714833449258055, -91.1563873291016, -1.59097909311606, 218, 16, 'PPL', 'P'),
(139464, 'Sperry', 40.2797203063965, 0.703013741129038, -92.4883270263672, -1.61422582627136, 218, 29, 'PPL', 'P'),
(185324, 'Sperry', 35.7416687011719, 0.623809798992454, -116.221389770508, -2.02844591273902, 218, 6, 'PPL', 'P'),
(208807, 'Sperry', 46.7000007629395, 0.815068773997157, -118.408889770508, -2.06662499012639, 218, 56, 'PPL', 'P'),
(197590, 'Sperry Chalets', 48.6049995422363, 0.848317274942361, -113.784721374512, -1.9859180264496, 218, 31, 'PPL', 'P'),
(146365, 'Sperry Springs', 40.9555587768555, 0.71480934765019, -74.6488876342773, -1.30286887216942, 218, 37, 'PPL', 'P'),
(130, 'Sperryville', 38.6569404602051, 0.674690889777991, -78.2263870239258, -1.36530801550687, 218, 53, 'PPL', 'P'),
(152825, 'Sperryville', 43.7730598449707, 0.763984017967257, -75.3069381713867, -1.3143540206865, 218, 40, 'PPL', 'P'),
(197591, 'Sphinx', 45.1711082458496, 0.788384565664836, -110.877220153809, -1.93517255714257, 218, 31, 'PPL', 'P'),
(187383, 'Sphinx Park', 39.4244384765625, 0.688086257165953, -105.314437866211, -1.83808369065237, 218, 7, 'PPL', 'P'),
(187911, 'Spica', 39.2066688537598, 0.684285460237219, -100.915000915527, -1.76129903062904, 218, 20, 'PPL', 'P'),
(195, 'Spice', 38.1100006103516, 0.665144988587683, -80.2666702270508, -1.40091767507454, 218, 58, 'PPL', 'P'),
(38321, 'Spice Knob', 37.8172187805176, 0.660034981667067, -86.9694366455078, -1.51790301806872, 218, 21, 'PPL', 'P'),
(31180, 'Spiceland', 39.8383293151855, 0.695310015043766, -85.4388885498047, -1.49118991443858, 218, 19, 'PPL', 'P'),
(138208, 'Spicer', 45.2330589294434, 0.789465809067408, -94.9397201538086, -1.65701070760598, 218, 28, 'PPL', 'P'),
(185325, 'Spicer City', 35.5011100769043, 0.619611258954917, -119.603607177734, -2.08747674251339, 218, 6, 'PPL', 'P'),
(146366, 'Spicertown', 40.913890838623, 0.714082104935516, -74.5777816772461, -1.30162783910144, 218, 37, 'PPL', 'P'),
(98231, 'Spicewood', 30.4752807617188, 0.531893989761678, -98.1561126708984, -1.7131473470657, 218, 51, 'PPL', 'P'),
(139465, 'Spickard', 40.2438888549805, 0.70238836432606, -93.5941696166992, -1.63352642048144, 218, 29, 'PPL', 'P'),
(51595, 'Spickler', 39.6580581665039, 0.692163689952919, -77.8702774047852, -1.35909273015485, 218, 25, 'PPL', 'P'),
(38322, 'Spider', 37.2586097717285, 0.650285415232395, -82.9122161865234, -1.44709116258017, 218, 21, 'PPL', 'P'),
(43167, 'Spider (historical)', 31.952220916748, 0.557671458321854, -93.7774963378906, -1.63672607537312, 218, 22, 'PPL', 'P'),
(83744, 'Spiderweb', 33.4099998474121, 0.583114500428144, -81.8313903808594, -1.42822719363081, 218, 48, 'PPL', 'P'),
(12064, 'Spielerville (historical)', 35.3086090087891, 0.616251481502701, -93.6416702270508, -1.63435546252878, 218, 4, 'PPL', 'P'),
(51594, 'Spielman', 39.5369415283203, 0.690049805837668, -77.7641677856445, -1.35724076793281, 218, 25, 'PPL', 'P'),
(68991, 'Spies', 35.4216690063477, 0.618224750712395, -79.6688919067383, -1.39048447518805, 218, 33, 'PPL', 'P'),
(189600, 'Spiess', 35.459171295166, 0.618879289129309, -105.906112670898, -1.84841036409526, 218, 38, 'PPL', 'P'),
(38323, 'Spike', 37.4069404602051, 0.652874274128062, -86.084716796875, -1.50246174375234, 218, 21, 'PPL', 'P'),
(167453, 'Spike Island', 41.3516693115234, 0.721722780681981, -75.7191696166992, -1.32154881668745, 218, 45, 'PPL', 'P'),
(201585, 'Spikenard (historical)', 42.6094398498535, 0.743675017810422, -122.951667785645, -2.14591142367774, 218, 43, 'PPL', 'P'),
(25009, 'Spile', 34.934440612793, 0.609721011035663, -83.9797210693359, -1.46572263756637, 218, 13, 'PPL', 'P'),
(68993, 'Spillcorn', 35.9544410705566, 0.627523377395488, -82.6502838134766, -1.44251958025294, 218, 33, 'PPL', 'P'),
(74375, 'Spiller', 38.9936103820801, 0.680566888407141, -81.8399963378906, -1.42837739591629, 218, 41, 'PPL', 'P'),
(98232, 'Spillers Store', 31.1416492462158, 0.543524313847676, -95.8658599853516, -1.67317489700027, 218, 51, 'PPL', 'P'),
(28667, 'Spillertown', 37.7663917541504, 0.659147882707961, -88.9194412231445, -1.55193701837745, 218, 18, 'PPL', 'P'),
(43168, 'Spillman', 30.9297199249268, 0.539825449409665, -91.2836074829102, -1.59319950367492, 218, 22, 'PPL', 'P'),
(117858, 'Spillville', 43.2050018310547, 0.754069535282083, -91.9508285522461, -1.60484470817351, 218, 16, 'PPL', 'P'),
(25010, 'Spilo (historical)', 34.934440612793, 0.609721011035663, -83.9800033569336, -1.46572756441438, 218, 13, 'PPL', 'P'),
(68994, 'Spilona', 35.4883308410645, 0.619388219213623, -78.4722213745117, -1.3695986343391, 218, 33, 'PPL', 'P'),
(167450, 'Spilt Rock', 41.0616683959961, 0.716661309872231, -75.6130599975586, -1.31969685446541, 218, 45, 'PPL', 'P'),
(68995, 'Spindale', 35.3600006103516, 0.617148434157839, -81.929443359375, -1.4299385409473, 218, 33, 'PPL', 'P'),
(98233, 'Spindletop', 30.0311107635498, 0.524141760855052, -94.0605621337891, -1.64166650551132, 218, 51, 'PPL', 'P'),
(38324, 'Spindletop Estates', 38.1344413757324, 0.665571560415287, -84.523063659668, -1.47520575473397, 218, 21, 'PPL', 'P'),
(167451, 'Spindletown', 40.9886093139648, 0.715386188342301, -78.9338912963867, -1.37765629453324, 218, 45, 'PPL', 'P'),
(126232, 'Spindleville', 42.1147193908691, 0.735040516924167, -71.5299987792969, -1.24843399264626, 218, 23, 'PPL', 'P'),
(167452, 'Spindley City', 40.5377807617188, 0.707517745743607, -78.5727767944336, -1.37135365749746, 218, 45, 'PPL', 'P'),
(171332, 'Spink', 42.8519401550293, 0.747907446572831, -96.7466735839844, -1.68854799439275, 218, 49, 'PPL', 'P'),
(195639, 'Spink', 44.7902793884277, 0.781737848216216, -116.047218322754, -2.02540604751275, 218, 17, 'PPL', 'P'),
(171333, 'Spink Colony', 44.7466697692871, 0.780976716776671, -98.2916717529297, -1.71551329937813, 218, 49, 'PPL', 'P'),
(5997, 'Spinks', 32.7619400024414, 0.571803722383442, -85.6191711425781, -1.4943364392665, 218, 2, 'PPL', 'P'),
(61845, 'Spinks (historical)', 32.7083282470703, 0.570868020734442, -88.8930587768555, -1.55147655782497, 218, 30, 'PPL', 'P'),
(185326, 'Spinks Corner', 36.2119407653809, 0.632017594893051, -119.232223510742, -2.08099487473624, 218, 6, 'PPL', 'P'),
(133212, 'Spinks Corners', 42.0938911437988, 0.734676995435371, -86.3208312988281, -1.50658271922312, 218, 27, 'PPL', 'P'),
(167454, 'Spinnerstown', 40.4388885498047, 0.705791751041127, -75.4375, -1.31663275447322, 218, 45, 'PPL', 'P'),
(152826, 'Spinnerville', 42.9674987792969, 0.749924325045375, -75.0405578613281, -1.30970480721349, 218, 40, 'PPL', 'P'),
(197592, 'Spion Kop', 47.2849998474121, 0.825278934142358, -110.616386413574, -1.93062014957519, 218, 31, 'PPL', 'P'),
(121544, 'Spires', 40.8763885498047, 0.713427566518602, -88.9602813720703, -1.55264981344321, 218, 18, 'PPL', 'P'),
(176467, 'Spirit', 45.4541702270508, 0.793324929224015, -90.1141662597656, -1.57278890392249, 218, 57, 'PPL', 'P'),
(208808, 'Spirit', 48.829719543457, 0.852239378858748, -117.649436950684, -2.05337003790691, 218, 56, 'PPL', 'P'),
(176468, 'Spirit Falls', 45.4530601501465, 0.793305554727084, -89.9805603027344, -1.57045704007202, 218, 57, 'PPL', 'P'),
(117859, 'Spirit Lake', 43.4222183227539, 0.757860678251865, -95.101936340332, -1.65984191416084, 218, 16, 'PPL', 'P'),
(195641, 'Spirit Lake', 47.9663887023926, 0.837171413148161, -116.867500305176, -2.0397226689008, 218, 17, 'PPL', 'P'),
(140905, 'Spiritwood', 46.9361114501953, 0.819189682888919, -98.4952774047852, -1.71906688837868, 218, 34, 'PPL', 'P'),
(140906, 'Spiritwood Lake', 47.0763893127441, 0.821637993458056, -98.5727767944336, -1.72041950789633, 218, 34, 'PPL', 'P'),
(38325, 'Spiro', 37.3424987792969, 0.651749554620694, -84.3997192382813, -1.47305298846681, 218, 21, 'PPL', 'P'),
(77307, 'Spiro', 35.2411117553711, 0.615073432194504, -94.6197204589844, -1.65142565932592, 218, 42, 'PPL', 'P'),
(195640, 'Spiry Place', 42.9102783203125, 0.748925639636595, -116.406387329102, -2.03167472924463, 218, 17, 'PPL', 'P'),
(201586, 'Spitzenberg', 45.8258285522461, 0.799811590691121, -122.944999694824, -2.14579504353811, 218, 43, 'PPL', 'P'),
(187384, 'Spivak', 39.7447204589844, 0.693676232294029, -105.067497253418, -1.83377376390224, 218, 7, 'PPL', 'P'),
(18169, 'Spivey', 28.0650005340576, 0.489826663893272, -82.5733337402344, -1.44117654811521, 218, 12, 'PPL', 'P'),
(34027, 'Spivey', 37.4458312988281, 0.653553047310895, -98.1630630493164, -1.71326865405336, 218, 20, 'PPL', 'P'),
(90959, 'Spivey', 36.5952796936035, 0.638708121341603, -85.8272171020508, -1.49796752625477, 218, 50, 'PPL', 'P'),
(25012, 'Spivey (historical)', 33.3994407653809, 0.582930209680711, -83.2744369506836, -1.45341310753386, 218, 13, 'PPL', 'P'),
(25011, 'Spivey Chase', 33.5038909912109, 0.584753210025897, -84.2611083984375, -1.47063377293258, 218, 13, 'PPL', 'P'),
(63, 'Spivey Crossing', 31.788330078125, 0.554811023574028, -97.3241729736328, -1.69862726017037, 218, 51, 'PPL', 'P'),
(106464, 'Spivey Mill', 36.6627807617188, 0.639886237228827, -82.6566696166992, -1.44263103354456, 218, 53, 'PPL', 'P'),
(106465, 'Spivey Store', 36.6963882446289, 0.640472798458917, -82.6838912963867, -1.44310614148303, 218, 53, 'PPL', 'P'),
(68996, 'Spiveys Corner', 35.1952781677246, 0.614273485182071, -78.4875030517578, -1.36986534992227, 218, 33, 'PPL', 'P'),
(98234, 'Splawn', 30.9200000762939, 0.539655806048227, -96.9855575561523, -1.69271730623732, 218, 51, 'PPL', 'P'),
(98235, 'Splendora', 30.232780456543, 0.527661560999269, -95.1608276367188, -1.66086976118356, 218, 51, 'PPL', 'P'),
(61844, 'Splinter', 34.2863883972168, 0.598410366149015, -89.6716690063477, -1.56506586991932, 218, 30, 'PPL', 'P'),
(128958, 'Split Hill', 44.8269386291504, 0.782377672668108, -67.043327331543, -1.17012680342773, 218, 26, 'PPL', 'P'),
(121545, 'Split Rail Farm', 41.9650001525879, 0.732427423262581, -88.3927764892578, -1.54274498471698, 218, 18, 'PPL', 'P'),
(152827, 'Split Rock', 43.024169921875, 0.75091342307423, -76.2236099243164, -1.33035296093515, 218, 40, 'PPL', 'P'),
(167455, 'Split Rock', 41.064998626709, 0.716719433363022, -75.6116714477539, -1.31967261969949, 218, 45, 'PPL', 'P'),
(176470, 'Split Rock', 44.7050018310547, 0.780249474061998, -89.0258331298828, -1.5537939074475, 218, 57, 'PPL', 'P'),
(171337, 'Split Rock Heights', 43.5280609130859, 0.759707979941999, -96.6494369506836, -1.6868508949881, 218, 49, 'PPL', 'P'),
(197593, 'Split Rock Junction', 47.5152816772461, 0.829298110280478, -112.457496643066, -1.96275358497198, 218, 31, 'PPL', 'P'),
(25013, 'Split Silk', 33.8294410705566, 0.590435130790609, -83.841667175293, -1.46331314257012, 218, 13, 'PPL', 'P'),
(57665, 'Splitlog', 36.7077789306641, 0.640671603434291, -94.458610534668, -1.64861376068896, 218, 29, 'PPL', 'P'),
(61846, 'Splunge', 33.9688911437988, 0.592868993710832, -88.2686080932617, -1.54057783737993, 218, 30, 'PPL', 'P'),
(5998, 'Spocari', 32.5177803039551, 0.567542331744179, -87.813606262207, -1.53263655732542, 218, 2, 'PPL', 'P'),
(144494, 'Spofford', 42.9069404602051, 0.74886738298775, -72.4199981689453, -1.26396741233636, 218, 36, 'PPL', 'P'),
(192260, 'Spofford', 29.1749992370605, 0.50919979595354, -100.413330078125, -1.75254322275514, 218, 51, 'PPL', 'P'),
(43170, 'Spokane', 31.6991691589355, 0.553254871970067, -91.4602813720703, -1.59628304474306, 218, 22, 'PPL', 'P'),
(57666, 'Spokane', 36.8680610656738, 0.643469054422338, -93.2966690063477, -1.62833405530411, 218, 29, 'PPL', 'P'),
(157755, 'Spokane', 41.3902816772461, 0.722396693595825, -80.8497161865234, -1.41109374675779, 218, 41, 'PPL', 'P'),
(202649, 'Spokane', 43.8413887023926, 0.765176581503395, -103.379440307617, -1.80431161223686, 218, 49, 'PPL', 'P'),
(208809, 'Spokane', 47.6588897705078, 0.831804544340406, -117.425003051758, -2.04945292741756, 218, 56, 'PPL', 'P'),
(208811, 'Spokane Valley', 47.6733283996582, 0.832056545958555, -117.238327026367, -2.04619481613996, 218, 56, 'PPL', 'P'),
(176471, 'Spokeville', 44.7125015258789, 0.780380368429575, -90.4341735839844, -1.57837408536061, 218, 57, 'PPL', 'P'),
(18170, 'Sponge Rocks', 25.4430599212646, 0.444065167408277, -80.289436340332, -1.40131501870918, 218, 12, 'PPL', 'P'),
(179204, 'Sponseller', 34.1963882446289, 0.596839567159059, -109.886672973633, -1.91788424745216, 218, 5, 'PPL', 'P'),
(31182, 'Sponsler', 39.0036087036133, 0.680741392037569, -87.1416702270508, -1.52090906114915, 218, 19, 'PPL', 'P'),
(187385, 'Spook City', 38.2299995422363, 0.667239365047949, -106.196670532227, -1.85348155544299, 218, 7, 'PPL', 'P'),
(51597, 'Spook Hill', 39.6355590820313, 0.691771006850187, -76.7186126708984, -1.33899238866942, 218, 25, 'PPL', 'P'),
(51598, 'Spoolsville', 39.4500007629395, 0.688532403227568, -77.5616683959961, -1.35370648685016, 218, 25, 'PPL', 'P'),
(185327, 'Spoonbill', 38.0605583190918, 0.66428205781547, -121.902778625488, -2.12760485434454, 218, 6, 'PPL', 'P'),
(25020, 'Spooner', 30.9724998474121, 0.540572099910783, -82.5441665649414, -1.44066748487285, 218, 13, 'PPL', 'P'),
(176472, 'Spooner', 45.8224983215332, 0.79975346720033, -91.8891677856445, -1.603768524777, 218, 57, 'PPL', 'P'),
(25014, 'Spooner (historical)', 31.0730590820313, 0.542327189648172, -84.8258285522461, -1.48048999896891, 218, 13, 'PPL', 'P'),
(25015, 'Spooner Ridge', 33.4186096191406, 0.583264769292652, -84.5886077880859, -1.47634971558022, 218, 13, 'PPL', 'P'),
(51599, 'Spooners Creek', 39.6347198486328, 0.691756359464191, -76.477783203125, -1.33478912152095, 218, 25, 'PPL', 'P'),
(128959, 'Spooners Mill', 45.0074996948242, 0.785529057765026, -69.2675018310547, -1.20894597158311, 218, 26, 'PPL', 'P'),
(57667, 'Spoonerville', 36.5494384765625, 0.637908041171116, -89.9705581665039, -1.57028246986257, 218, 29, 'PPL', 'P'),
(172585, 'Spoonerville', 43.311939239502, 0.755935945153038, -72.5469436645508, -1.26618302920525, 218, 55, 'PPL', 'P'),
(114109, 'Spoonville', 41.896110534668, 0.731225072609438, -72.745002746582, -1.26963981230017, 218, 8, 'PPL', 'P'),
(114110, 'Spoonville (historical)', 41.8969383239746, 0.731239520258352, -72.7494430541992, -1.2697173102879, 218, 8, 'PPL', 'P'),
(201587, 'Spoos Mill', 44.5183296203613, 0.776991429363422, -119.974998474121, -2.09395874344859, 218, 43, 'PPL', 'P'),
(157757, 'Spore', 40.8630599975586, 0.713194939397384, -83.039436340332, -1.44931157313902, 218, 41, 'PPL', 'P'),
(43169, 'Sport', 30.0547199249268, 0.524553818454715, -90.6672210693359, -1.58244153129349, 218, 22, 'PPL', 'P'),
(167457, 'Sporting Hill', 40.1438903808594, 0.700643061705677, -76.420280456543, -1.33378550926415, 218, 45, 'PPL', 'P'),
(167458, 'Sportsburg', 40.9213905334473, 0.714212999303094, -79.0088882446289, -1.37896523820902, 218, 45, 'PPL', 'P'),
(77309, 'Sportsman Acres', 36.2483291625977, 0.632652692234008, -95.26611328125, -1.66270734233571, 218, 42, 'PPL', 'P'),
(51600, 'Sportsman Hall', 38.9180603027344, 0.679248290772416, -76.17138671875, -1.32944149405207, 218, 25, 'PPL', 'P'),
(68999, 'Sportsmans Village', 34.9727783203125, 0.610390130259545, -76.5924987792969, -1.33679128602847, 218, 33, 'PPL', 'P'),
(77310, 'Sportsmen Acres', 36.2455596923828, 0.632604355860223, -95.2513885498047, -1.66245034729052, 218, 42, 'PPL', 'P'),
(38326, 'Sportsmens Paradise', 37.3549995422363, 0.651967734092999, -86.0894393920898, -1.50254416858807, 218, 21, 'PPL', 'P'),
(69000, 'Spot', 36.1180610656738, 0.63037908503238, -75.8194427490234, -1.3232989129978, 218, 33, 'PPL', 'P'),
(90960, 'Spot', 35.8861083984375, 0.626330747280323, -87.5913925170898, -1.52875819582994, 218, 50, 'PPL', 'P'),
(167459, 'Spot Mobile Home Park', 40.1605606079102, 0.700934012054768, -76.6383285522461, -1.33759116646187, 218, 45, 'PPL', 'P'),
(146367, 'Spotswood', 40.3916702270508, 0.704967635841802, -74.3988876342773, -1.29850554903943, 218, 37, 'PPL', 'P'),
(146368, 'Spotswood Manor', 40.3777809143066, 0.704725221603577, -74.3833312988281, -1.2982340397663, 218, 37, 'PPL', 'P'),
(106466, 'Spotsylvania', 38.2008285522461, 0.666730235226553, -77.5894393920898, -1.35419118216856, 218, 53, 'PPL', 'P'),
(106468, 'Spotsylvania Courthouse', 38.1977806091309, 0.666677038583779, -77.5880584716797, -1.35416708056069, 218, 53, 'PPL', 'P'),
(198936, 'Spotted Horn', 47.7133293151855, 0.832754693638319, -102.706390380859, -1.79256467498463, 218, 34, 'PPL', 'P'),
(209752, 'Spotted Horse', 44.7083282470703, 0.780307530973762, -105.834442138672, -1.84715947733125, 218, 59, 'PPL', 'P'),
(38327, 'Spottsville', 37.8574981689453, 0.66073798961582, -87.4136123657227, -1.52565534684389, 218, 21, 'PPL', 'P'),
(106469, 'Spottswood', 37.9550018310547, 0.662439749552381, -79.2138900756836, -1.38254319513354, 218, 53, 'PPL', 'P'),
(171339, 'Spottswood', 44.6522216796875, 0.77932828664094, -98.5052795410156, -1.71924145858813, 218, 49, 'PPL', 'P'),
(12065, 'Spotville', 33.190559387207, 0.579284541885474, -93.0205612182617, -1.62351506531161, 218, 4, 'PPL', 'P'),
(106474, 'Spout Run', 39.100830078125, 0.682438225126113, -77.8811111450195, -1.35928181459224, 218, 53, 'PPL', 'P'),
(106470, 'Spout Spring', 37.3497200012207, 0.651875588719282, -78.9094390869141, -1.37722952296856, 218, 53, 'PPL', 'P'),
(25016, 'Spout Spring Crossroads', 34.1766700744629, 0.596495420167193, -83.9100036621094, -1.46450583926431, 218, 13, 'PPL', 'P'),
(38328, 'Spout Springs', 37.8269386291504, 0.660204625028505, -83.9747161865234, -1.46563528588261, 218, 21, 'PPL', 'P'),
(69001, 'Spout Springs', 35.2694396972656, 0.615567848050877, -79.0599975585938, -1.37985726401614, 218, 33, 'PPL', 'P'),
(90961, 'Spout Springs', 36.4272193908691, 0.63577491571699, -89.3097229003906, -1.5587487186556, 218, 50, 'PPL', 'P'),
(192261, 'Spraberry', 31.923059463501, 0.557162494948027, -101.82527923584, -1.77718638442802, 218, 51, 'PPL', 'P'),
(106471, 'Spracher Place', 37.1208305358887, 0.647880713926108, -81.2808303833008, -1.41861810894364, 218, 53, 'PPL', 'P'),
(61847, 'Spraggins', 34.5547218322754, 0.603093668083973, -89.4855575561523, -1.56181761233775, 218, 30, 'PPL', 'P'),
(79179, 'Spraggs', 39.7805595397949, 0.694301742255062, -80.2163925170898, -1.40004016349536, 218, 45, 'PPL', 'P'),
(5999, 'Sprague', 32.1327781677246, 0.560822776839745, -86.2699966430664, -1.50569548710596, 218, 2, 'PPL', 'P'),
(57669, 'Sprague', 38.0955581665039, 0.664892920390507, -94.4594421386719, -1.6486282749169, 218, 29, 'PPL', 'P'),
(74376, 'Sprague', 39.6788902282715, 0.692527278020742, -81.2177810668945, -1.41751769078122, 218, 41, 'PPL', 'P'),
(111495, 'Sprague', 37.7930603027344, 0.65961333668748, -81.1841735839844, -1.41693112955113, 218, 58, 'PPL', 'P'),
(113165, 'Sprague', 40.6258316040039, 0.709054522850637, -96.7444381713867, -1.68850897908278, 218, 35, 'PPL', 'P'),
(176475, 'Sprague', 44.1477813720703, 0.770524142393247, -90.1313934326172, -1.57308957480956, 218, 57, 'PPL', 'P'),
(208812, 'Sprague', 47.3002815246582, 0.825545649725529, -117.97444152832, -2.05904243787072, 218, 56, 'PPL', 'P'),
(128960, 'Sprague City', 43.6261100769043, 0.761419260679457, -70.8399963378906, -1.23639117819692, 218, 26, 'PPL', 'P'),
(128961, 'Sprague Corner', 44.0683288574219, 0.769137434413642, -69.4416732788086, -1.21198583680938, 218, 26, 'PPL', 'P'),
(128962, 'Sprague Mill', 44.1938896179199, 0.771328883095641, -70.1161117553711, -1.22375700882753, 218, 26, 'PPL', 'P'),
(201588, 'Sprague River', 42.4555587768555, 0.740989286430105, -121.503059387207, -2.12062843755297, 218, 43, 'PPL', 'P'),
(152828, 'Spragues Corner', 42.8486099243164, 0.74784932308204, -78.0274963378906, -1.36183671818401, 218, 40, 'PPL', 'P'),
(128963, 'Spragues Mill', 44.9119415283203, 0.783861253132364, -69.248893737793, -1.20862119908817, 218, 26, 'PPL', 'P'),
(71427, 'Spraguetown', 39.6500015258789, 0.692023075047363, -74.3058319091797, -1.29688142024865, 218, 37, 'PPL', 'P'),
(152829, 'Spraguetown', 43.1327781677246, 0.752808994559121, -73.4786071777344, -1.282443625031, 218, 40, 'PPL', 'P'),
(113216, 'Spragueville', 44.2588882446289, 0.772463323140988, -75.5366668701172, -1.31836354286566, 218, 40, 'PPL', 'P'),
(117861, 'Spragueville', 42.0724983215332, 0.734303620250542, -90.4349975585938, -1.57838846643049, 218, 16, 'PPL', 'P'),
(128964, 'Spragueville', 46.6272201538086, 0.813798512736217, -68.0130615234375, -1.18705185794546, 218, 26, 'PPL', 'P'),
(144495, 'Spragueville', 42.8963890075684, 0.748683225398371, -72.2638931274414, -1.26124286538315, 218, 36, 'PPL', 'P'),
(169622, 'Spragueville', 41.8905601501465, 0.731128200124786, -71.5416717529297, -1.24863772446965, 218, 47, 'PPL', 'P'),
(152830, 'Sprakers', 42.8913917541504, 0.748596006872671, -74.5138931274414, -1.30051277355303, 218, 40, 'PPL', 'P'),
(69002, 'Sprangler Apartments', 35.2900009155273, 0.615926709007765, -81.5283279418945, -1.42293775623175, 218, 33, 'PPL', 'P'),
(167460, 'Sprankle Mills', 41.0019416809082, 0.715618882042546, -79.1138916015625, -1.38079789251316, 218, 45, 'PPL', 'P'),
(106473, 'Spratleys Mill', 37.077220916748, 0.647119582486564, -76.9250030517578, -1.34259458035986, 218, 53, 'PPL', 'P'),
(74377, 'Spratt', 39.8722190856934, 0.695901503121872, -81.7330627441406, -1.42651105262437, 218, 41, 'PPL', 'P'),
(133213, 'Spratt', 45.0086097717285, 0.785548432261956, -83.7480621337891, -1.46167942639941, 218, 27, 'PPL', 'P'),
(111496, 'Sprattsville', 37.5999984741211, 0.656243772118257, -81.8727798461914, -1.4289495760765, 218, 58, 'PPL', 'P'),
(18171, 'Spray', 30.5138893127441, 0.532567836096495, -83.6205596923828, -1.45945408899254, 218, 12, 'PPL', 'P'),
(201589, 'Spray', 44.8344383239746, 0.782508567035685, -119.793327331543, -2.09078798385474, 218, 43, 'PPL', 'P'),
(69003, 'Spray (historical)', 36.5161094665527, 0.637326340210015, -79.7608337402344, -1.39208916290287, 218, 33, 'PPL', 'P'),
(71425, 'Spray Beach', 39.5783309936523, 0.690772188283352, -74.2300033569336, -1.29555796234493, 218, 37, 'PPL', 'P'),
(25017, 'Sprayberry Farms', 33.8305587768555, 0.590454638445594, -84.7736129760742, -1.47957866524388, 218, 13, 'PPL', 'P'),
(31183, 'Spraytown', 39.0141716003418, 0.68092574936403, -86.0800018310547, -1.50237945207465, 218, 19, 'PPL', 'P'),
(111498, 'Spread', 38.4958305358887, 0.67187899114103, -81.0708312988281, -1.41495293349342, 218, 58, 'PPL', 'P'),
(176476, 'Spread Eagle', 45.8819389343262, 0.80079090160297, -88.1397171020508, -1.53832826520714, 218, 57, 'PPL', 'P'),
(185328, 'Spreckels', 36.621940612793, 0.639173442163067, -121.64582824707, -2.1231202242269, 218, 6, 'PPL', 'P'),
(185329, 'Spreckels Junction', 36.6583290100098, 0.639808539504024, -121.629722595215, -2.12283912757384, 218, 6, 'PPL', 'P'),
(211103, 'Spreckelsville', 20.8969402313232, 0.364720410629056, -156.414993286133, -2.72995663232784, 218, 15, 'PPL', 'P'),
(185330, 'Sprekelsville', 38.6327781677246, 0.674269178219377, -120.976387023926, -2.11143627073445, 218, 6, 'PPL', 'P'),
(157756, 'Spreng', 40.7808303833008, 0.71175976188594, -82.1563873291016, -1.43389946043657, 218, 41, 'PPL', 'P'),
(111497, 'Sprigg', 37.6286087036133, 0.656743114822647, -82.1975021362305, -1.43461704919229, 218, 58, 'PPL', 'P'),
(12066, 'Spriggs Mill', 35.4524993896484, 0.618762842410645, -91.3197174072266, -1.59382974074688, 218, 4, 'PPL', 'P'),
(98236, 'Spring', 30.079719543457, 0.524990144109811, -95.4169387817383, -1.6653397439152, 218, 51, 'PPL', 'P'),
(167462, 'Spring', 41.7966690063477, 0.729489490527033, -80.3266677856445, -1.40196483001516, 218, 45, 'PPL', 'P'),
(133214, 'Spring Arbor', 42.2050018310547, 0.73661624276214, -84.5527801513672, -1.47572440535627, 218, 27, 'PPL', 'P'),
(106475, 'Spring Bank', 38.7819404602051, 0.676872551342984, -77.0758285522461, -1.34522698193935, 218, 53, 'PPL', 'P'),
(167461, 'Spring Bank', 40.9233283996582, 0.714246821448938, -77.4833297729492, -1.35233921994651, 218, 45, 'PPL', 'P'),
(12067, 'Spring Bank (historical)', 33.0908317565918, 0.577543966376026, -93.8661117553711, -1.63827270617618, 218, 4, 'PPL', 'P'),
(176477, 'Spring Bank Park', 44.0066719055176, 0.768061317596169, -90.6208267211914, -1.58163179716405, 218, 57, 'PPL', 'P'),
(177329, 'Spring Bay', 40.8244400024414, 0.712520893325484, -89.522216796875, -1.56245743678964, 218, 18, 'PPL', 'P'),
(43171, 'Spring Bayou Landing', 31.1411094665527, 0.54351489291532, -92.0363922119141, -1.60633807575477, 218, 22, 'PPL', 'P'),
(133216, 'Spring Beach', 41.9072189331055, 0.731418950736796, -85.9583282470703, -1.50025584742142, 218, 27, 'PPL', 'P'),
(208814, 'Spring Beach', 47.3494415283203, 0.826403653649725, -122.525833129883, -2.1384792068656, 218, 56, 'PPL', 'P'),
(25018, 'Spring Bluff', 31.1055603027344, 0.542894442960359, -81.629997253418, -1.42471222046607, 218, 13, 'PPL', 'P'),
(57668, 'Spring Bluff', 38.2955589294434, 0.668383592210301, -91.2377777099609, -1.59239962324151, 218, 29, 'PPL', 'P'),
(25019, 'Spring Branch', 31.8413906097412, 0.555737104553589, -82.351936340332, -1.43731243453156, 218, 13, 'PPL', 'P'),
(51601, 'Spring Branch', 38.9416694641113, 0.679660348372078, -75.8138885498047, -1.32320197393412, 218, 25, 'PPL', 'P'),
(83746, 'Spring Branch', 34.2419395446777, 0.597634587323474, -79.3930587768555, -1.38567027888551, 218, 48, 'PPL', 'P'),
(98237, 'Spring Branch', 29.889720916748, 0.521674042499471, -98.4250030517578, -1.71784036953864, 218, 51, 'PPL', 'P'),
(83747, 'Spring Branch (historical)', 33.4555587768555, 0.583909653750615, -81.4419403076172, -1.4214300075806, 218, 48, 'PPL', 'P'),
(152831, 'Spring Brook', 42.8180618286133, 0.747316158231806, -78.6758270263672, -1.37315222333965, 218, 40, 'PPL', 'P'),
(167464, 'Spring Brook', 41.2966690063477, 0.720762844267062, -75.5927810668945, -1.31934292035654, 218, 45, 'PPL', 'P'),
(198938, 'Spring Brook', 48.252498626709, 0.842164973350114, -103.45832824707, -1.80568846652043, 218, 34, 'PPL', 'P'),
(14655, 'Spring Brook Forest', 38.4958305358887, 0.67187899114103, -75.1544418334961, -1.31169245749307, 218, 10, 'PPL', 'P'),
(152832, 'Spring Brook Station', 42.8388900756836, 0.747679679720602, -78.6802825927734, -1.37322998764348, 218, 40, 'PPL', 'P'),
(83748, 'Spring Brook Terrace', 34.7797203063965, 0.60702063226935, -82.413330078125, -1.43838395739616, 218, 48, 'PPL', 'P'),
(167466, 'Spring Church', 40.6061096191406, 0.708710309279745, -79.4891662597656, -1.3873476708981, 218, 45, 'PPL', 'P'),
(205870, 'Spring Circle', 40.5722198486328, 0.708118821201638, -111.85417175293, -1.95222357917986, 218, 52, 'PPL', 'P'),
(57670, 'Spring City', 36.9866714477539, 0.645539196116684, -94.5338897705078, -1.64992763121275, 218, 29, 'PPL', 'P'),
(90962, 'Spring City', 35.6919403076172, 0.622941874793198, -84.8608322143555, -1.48110092812297, 218, 50, 'PPL', 'P'),
(106476, 'Spring City', 36.9183311462402, 0.644346432843464, -82.107780456543, -1.43305111047133, 218, 53, 'PPL', 'P'),
(167467, 'Spring City', 40.1766700744629, 0.701215175286853, -75.5480575561523, -1.31856234784104, 218, 45, 'PPL', 'P'),
(192796, 'Spring City', 39.4824981689453, 0.689099589960728, -111.495277404785, -1.94595969113794, 218, 52, 'PPL', 'P'),
(200211, 'Spring City (historical)', 41.5900001525879, 0.725882438567603, -117.451942443848, -2.04992310850802, 218, 39, 'PPL', 'P'),
(61848, 'Spring Cottage', 31.0894393920898, 0.542613079991192, -89.7663879394531, -1.56671902716599, 218, 30, 'PPL', 'P'),
(51602, 'Spring Cove', 38.3522186279297, 0.669372490502075, -76.4719390869141, -1.3346871224512, 218, 25, 'PPL', 'P'),
(152833, 'Spring Cove', 44.5711097717285, 0.777912616784481, -74.4563903808594, -1.29950916129623, 218, 40, 'PPL', 'P'),
(6001, 'Spring Creek', 33.084171295166, 0.577427719394444, -86.5374984741211, -1.51036427481298, 218, 2, 'PPL', 'P'),
(12069, 'Spring Creek', 34.6886100769043, 0.605430458782463, -90.898063659668, -1.58647049454861, 218, 4, 'PPL', 'P'),
(18172, 'Spring Creek', 30.0805606842041, 0.52500482478532, -84.3277816772461, -1.47179744117089, 218, 12, 'PPL', 'P'),
(38329, 'Spring Creek', 37.0627784729004, 0.646867514289388, -83.5427780151367, -1.45809654262687, 218, 21, 'PPL', 'P'),
(43172, 'Spring Creek', 30.9119396209717, 0.539515124563644, -90.4469375610352, -1.57859685878579, 218, 22, 'PPL', 'P'),
(57671, 'Spring Creek', 37.7625007629395, 0.659079972100164, -92.0238876342773, -1.60611982970344, 218, 29, 'PPL', 'P'),
(61849, 'Spring Creek', 32.832218170166, 0.573030307802505, -89.0397186279297, -1.5540362551067, 218, 30, 'PPL', 'P'),
(69006, 'Spring Creek', 35.7986106872559, 0.624803624132245, -82.8544387817383, -1.44608275663341, 218, 33, 'PPL', 'P'),
(77311, 'Spring Creek', 35.2616691589355, 0.615432226572365, -98.1830596923828, -1.71361766131421, 218, 42, 'PPL', 'P'),
(90968, 'Spring Creek', 35.5641708374023, 0.62071187685442, -85.6191711425781, -1.4943364392665, 218, 50, 'PPL', 'P'),
(98239, 'Spring Creek', 33.3699989318848, 0.58241635274838, -98.9611129760742, -1.72719725287058, 218, 51, 'PPL', 'P'),
(106477, 'Spring Creek', 38.4008293151855, 0.670220907046347, -79.0344390869141, -1.37941118453355, 218, 53, 'PPL', 'P'),
(111499, 'Spring Creek', 37.9538917541504, 0.66242037505545, -80.3491668701172, -1.40235751311789, 218, 58, 'PPL', 'P'),
(138213, 'Spring Creek', 44.7180595397949, 0.780477374072282, -95.8483276367188, -1.67286889979102, 218, 28, 'PPL', 'P'),
(167470, 'Spring Creek', 41.8758316040039, 0.730871138500566, -79.5255584716797, -1.38798283481808, 218, 45, 'PPL', 'P'),
(185331, 'Spring Creek', 38.9291687011719, 0.679442168899774, -120.063888549805, -2.09551016794161, 218, 6, 'PPL', 'P'),
(200212, 'Spring Creek', 40.7266693115234, 0.710814472857016, -115.584999084473, -2.01733879993868, 218, 39, 'PPL', 'P'),
(202650, 'Spring Creek', 43.1175003051758, 0.752542345554977, -101.022216796875, -1.76317030076899, 218, 49, 'PPL', 'P'),
(90969, 'Spring Creek (historical)', 36.1488914489746, 0.630917176730631, -86.2425003051758, -1.50521558547753, 218, 50, 'PPL', 'P'),
(171341, 'Spring Creek Colony', 45.9091682434082, 0.801266142699495, -98.8783264160156, -1.72575235482116, 218, 49, 'PPL', 'P'),
(197594, 'Spring Creek Junction', 47.1272201538086, 0.822525158996189, -109.573333740234, -1.91241544615368, 218, 31, 'PPL', 'P'),
(167471, 'Spring Creek Manor', 40.285831451416, 0.703120400730695, -76.6425018310547, -1.33766400391769, 218, 45, 'PPL', 'P'),
(121547, 'Spring Creek Settlement (historical)', 40.5380592346191, 0.707522606012597, -90.7763900756836, -1.58434688989538, 218, 18, 'PPL', 'P'),
(111500, 'Spring Dale', 37.8797187805176, 0.661125812449563, -80.8036117553711, -1.41028907263442, 218, 58, 'PPL', 'P'),
(74379, 'Spring Dale Subdivision', 38.8250007629395, 0.677624095402604, -82.2291717529297, -1.43516978827654, 218, 41, 'PPL', 'P'),
(51603, 'Spring Fields', 39.0416717529297, 0.681405717571489, -76.6194381713867, -1.33726146711892, 218, 25, 'PPL', 'P'),
(57679, 'Spring Forest', 38.4052810668945, 0.67029860477115, -90.4169387817383, -1.57807328131548, 218, 29, 'PPL', 'P'),
(83750, 'Spring Forest', 34.8708305358887, 0.608610805756236, -82.3361129760742, -1.43703626472652, 218, 48, 'PPL', 'P'),
(57682, 'Spring Fork', 38.5786094665527, 0.673323756032398, -93.2383270263672, -1.62731579566132, 218, 29, 'PPL', 'P'),
(117865, 'Spring Fountain', 42.8327789306641, 0.747573020118944, -92.1802825927734, -1.60884943666271, 218, 16, 'PPL', 'P'),
(51604, 'Spring Gap', 39.5652809143066, 0.690544421431123, -78.716667175293, -1.37386501840541, 218, 25, 'PPL', 'P'),
(185332, 'Spring Gap', 38.1686096191406, 0.666167908762383, -120.101112365723, -2.09615984608954, 218, 6, 'PPL', 'P'),
(111503, 'Spring Gap (historical)', 39.4241714477539, 0.688081596634045, -78.5305633544922, -1.37061689398189, 218, 58, 'PPL', 'P'),
(6003, 'Spring Garden', 33.6133308410645, 0.58666329573873, -86.7563934326172, -1.51418471255476, 218, 2, 'PPL', 'P'),
(28670, 'Spring Garden', 38.1630592346191, 0.666071036277731, -88.8555603027344, -1.55082208598708, 218, 18, 'PPL', 'P'),
(57680, 'Spring Garden', 38.3852806091309, 0.669949530931268, -92.4225006103516, -1.6130769385771, 218, 29, 'PPL', 'P'),
(69007, 'Spring Garden', 35.2041702270508, 0.614428680894596, -77.1558303833008, -1.34662327729888, 218, 33, 'PPL', 'P'),
(106484, 'Spring Garden', 36.6105613708496, 0.638974836924774, -82.1827774047852, -1.4343600541471, 218, 53, 'PPL', 'P'),
(167474, 'Spring Garden', 41.1138916015625, 0.71757277675531, -76.9286117553711, -1.34265756411964, 218, 45, 'PPL', 'P'),
(185333, 'Spring Garden', 39.8950004577637, 0.696299113072621, -120.785003662109, -2.10809600093722, 218, 6, 'PPL', 'P'),
(51606, 'Spring Garden Estates', 39.2630615234375, 0.685269697997085, -77.225830078125, -1.34784500244895, 218, 25, 'PPL', 'P'),
(106480, 'Spring Garden Mobile Home Park', 37.214168548584, 0.64950976956491, -77.3649978637695, -1.35027393852116, 218, 53, 'PPL', 'P'),
(51607, 'Spring Gardens', 39.2675018310547, 0.685347195984806, -76.6447219848633, -1.33770275291155, 218, 25, 'PPL', 'P'),
(98240, 'Spring Gardens Colonia', 26.3770008087158, 0.460365510913298, -98.1279983520508, -1.71265665963486, 218, 51, 'PPL', 'P'),
(98241, 'Spring Gate Estates Colonia', 26.2530002593994, 0.458201293053445, -98.2720031738281, -1.71517001791362, 218, 51, 'PPL', 'P'),
(18173, 'Spring Glen', 30.2961101531982, 0.528766872720193, -81.6097183227539, -1.4243582863572, 218, 12, 'PPL', 'P'),
(114112, 'Spring Glen', 41.3633308410645, 0.72192631276829, -72.9091720581055, -1.27250510731699, 218, 8, 'PPL', 'P'),
(152834, 'Spring Glen', 41.6655616760254, 0.72720123593941, -74.4302825927734, -1.29905349443372, 218, 40, 'PPL', 'P'),
(167476, 'Spring Glen', 40.6261100769043, 0.709059383119627, -76.6211090087891, -1.33729062873286, 218, 45, 'PPL', 'P'),
(205875, 'Spring Glen', 40.767219543457, 0.711522207916705, -111.763893127441, -1.95064791992092, 218, 52, 'PPL', 'P'),
(208815, 'Spring Glen', 47.5613899230957, 0.830102850982873, -121.860282897949, -2.12686316398095, 218, 56, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(121548, 'Spring Green', 41.8566703796387, 0.73053671204668, -88.3574981689453, -1.54212926187296, 218, 18, 'PPL', 'P'),
(169625, 'Spring Green', 41.7400016784668, 0.728500459077205, -71.4122161865234, -1.24637829860082, 218, 47, 'PPL', 'P'),
(176479, 'Spring Green', 43.1752815246582, 0.753550818080763, -90.0677795410156, -1.57197930295111, 218, 57, 'PPL', 'P'),
(31191, 'Spring Grove', 39.848331451416, 0.69548458525322, -84.894172668457, -1.48168282882116, 218, 19, 'PPL', 'P'),
(38330, 'Spring Grove', 37.6808280944824, 0.657654515126699, -88.0274963378906, -1.53636964338344, 218, 21, 'PPL', 'P'),
(51608, 'Spring Grove', 38.4883308410645, 0.671748096773453, -75.7516708374023, -1.32211606999964, 218, 25, 'PPL', 'P'),
(57681, 'Spring Grove', 37.5519409179688, 0.655405009532937, -93.0374984741211, -1.62381067619261, 218, 29, 'PPL', 'P'),
(79176, 'Spring Grove', 39.874439239502, 0.695940252115733, -76.8661117553711, -1.34156673333714, 218, 45, 'PPL', 'P'),
(106483, 'Spring Grove', 37.1655616760254, 0.648661419599665, -76.9736099243164, -1.3434429303251, 218, 53, 'PPL', 'P'),
(117866, 'Spring Grove', 40.7397193908691, 0.711042239709245, -91.1580581665039, -1.59100825473, 218, 16, 'PPL', 'P'),
(121549, 'Spring Grove', 42.4436111450195, 0.740780760916751, -88.2363891601563, -1.54001551091576, 218, 18, 'PPL', 'P'),
(133217, 'Spring Grove', 42.5055618286133, 0.741862004319323, -86.168327331543, -1.50392102287164, 218, 27, 'PPL', 'P'),
(138216, 'Spring Grove', 43.5611114501953, 0.76028482063411, -91.6358337402344, -1.5993470115772, 218, 28, 'PPL', 'P'),
(157758, 'Spring Grove', 40.6272201538086, 0.709078757616557, -80.6183319091797, -1.40705532928079, 218, 41, 'PPL', 'P'),
(169623, 'Spring Grove', 41.9130592346191, 0.731520883227519, -71.6530609130859, -1.2505818320654, 218, 47, 'PPL', 'P'),
(171344, 'Spring Grove', 45.4630584716797, 0.793480058357512, -97.0497207641602, -1.6938371654757, 218, 49, 'PPL', 'P'),
(176482, 'Spring Grove', 43.814998626709, 0.764715987792866, -88.9413909912109, -1.55232011410025, 218, 57, 'PPL', 'P'),
(25022, 'Spring Grove (historical)', 32.1694412231445, 0.561462667870664, -85.0038909912109, -1.48359777480298, 218, 13, 'PPL', 'P'),
(83751, 'Spring Grove (historical)', 34.2666702270508, 0.598066219157149, -81.9411087036133, -1.43014213961263, 218, 48, 'PPL', 'P'),
(121550, 'Spring Grove (historical)', 41.0022201538086, 0.715623742311536, -90.6294403076172, -1.58178213260758, 218, 18, 'PPL', 'P'),
(157759, 'Spring Grove (historical)', 40.7874984741211, 0.711876142025576, -82.5133285522461, -1.44012926001654, 218, 41, 'PPL', 'P'),
(31184, 'Spring Grove Heights', 39.8433303833008, 0.695397300148493, -84.8925018310547, -1.48165366720722, 218, 19, 'PPL', 'P'),
(197595, 'Spring Grove Trailer Court', 47.1061096191406, 0.822156710659376, -104.738891601563, -1.8280385133367, 218, 31, 'PPL', 'P'),
(197596, 'Spring Gulch', 47.230281829834, 0.824323924575455, -114.979721069336, -2.00677470568461, 218, 31, 'PPL', 'P'),
(83752, 'Spring Gully', 33.3872184753418, 0.582716890477396, -79.4097213745117, -1.38596109607655, 218, 48, 'PPL', 'P'),
(144496, 'Spring Haven', 43.5552787780762, 0.760183021301442, -71.3183288574219, -1.2447396555821, 218, 36, 'PPL', 'P'),
(83753, 'Spring Head (historical)', 33.1786117553711, 0.579076016372121, -79.8069381713867, -1.39289383702624, 218, 48, 'PPL', 'P'),
(6012, 'Spring Hill', 33.9775009155273, 0.59301926257534, -87.5580596923828, -1.52817642828981, 218, 2, 'PPL', 'P'),
(12074, 'Spring Hill', 33.5063896179199, 0.584796819288747, -93.0213928222656, -1.62352957953956, 218, 4, 'PPL', 'P'),
(14656, 'Spring Hill', 38.9666709899902, 0.680096707316688, -75.4319381713867, -1.31653568225149, 218, 10, 'PPL', 'P'),
(18177, 'Spring Hill', 30.767219543457, 0.536989282717272, -86.9416732788086, -1.51741845590838, 218, 12, 'PPL', 'P'),
(25024, 'Spring Hill', 32.0130615234375, 0.558733327227496, -82.7255630493164, -1.44383345077673, 218, 13, 'PPL', 'P'),
(31186, 'Spring Hill', 39.4124984741211, 0.687877864810654, -87.3772201538086, -1.52502018292391, 218, 19, 'PPL', 'P'),
(34033, 'Spring Hill', 38.7430610656738, 0.676193977897231, -94.8252792358398, -1.65501333678842, 218, 20, 'PPL', 'P'),
(38331, 'Spring Hill', 36.7372207641602, 0.641185460366622, -88.9716720581055, -1.55284861841858, 218, 21, 'PPL', 'P'),
(43173, 'Spring Hill', 32.208610534668, 0.562146301322487, -92.6405563354492, -1.61688272893288, 218, 22, 'PPL', 'P'),
(51611, 'Spring Hill', 38.9536094665527, 0.679868740727377, -77.1066665649414, -1.34576520679565, 218, 25, 'PPL', 'P'),
(69010, 'Spring Hill', 34.8827781677246, 0.608819331269589, -79.3827819824219, -1.38549091498609, 218, 33, 'PPL', 'P'),
(77313, 'Spring Hill', 35.014720916748, 0.611122166664181, -97.2649993896484, -1.69759448629964, 218, 42, 'PPL', 'P'),
(83758, 'Spring Hill', 34.1755599975586, 0.596476045670263, -81.2874984741211, -1.41873448908328, 218, 48, 'PPL', 'P'),
(90976, 'Spring Hill', 35.9838905334473, 0.628037367485874, -89.1222229003906, -1.55547622630811, 218, 50, 'PPL', 'P'),
(98249, 'Spring Hill', 33.0083312988281, 0.576104061753647, -94.9000015258789, -1.65631748677423, 218, 51, 'PPL', 'P'),
(106485, 'Spring Hill', 38.2561111450195, 0.667695098489489, -79.0527801513672, -1.37973129649658, 218, 53, 'PPL', 'P'),
(111501, 'Spring Hill', 38.3544387817383, 0.669411239495936, -81.7313919067383, -1.42648189101043, 218, 58, 'PPL', 'P'),
(112445, 'Spring Hill', 32.7200012207031, 0.571071752557833, -89.1025009155273, -1.55513201273721, 218, 30, 'PPL', 'P'),
(114113, 'Spring Hill', 41.7869415283203, 0.729319714007541, -72.2244415283203, -1.26055430508331, 218, 8, 'PPL', 'P'),
(117868, 'Spring Hill', 41.4113883972168, 0.72276507535361, -93.6447219848633, -1.63440872575058, 218, 16, 'PPL', 'P'),
(121552, 'Spring Hill', 41.6124992370605, 0.726275121670335, -90.0449981689453, -1.57158169300036, 218, 18, 'PPL', 'P'),
(126233, 'Spring Hill', 42.3883285522461, 0.739815897653816, -71.1097183227539, -1.2410987148978, 218, 23, 'PPL', 'P'),
(138219, 'Spring Hill', 45.5247192382813, 0.794556241754013, -94.8291702270508, -1.65508124739621, 218, 28, 'PPL', 'P'),
(167479, 'Spring Hill', 40.3763885498047, 0.70470092025863, -78.670280456543, -1.37305541743402, 218, 45, 'PPL', 'P'),
(185334, 'Spring Hill', 39.2324981689453, 0.684736266830742, -121.043060302734, -2.11259993897276, 218, 6, 'PPL', 'P'),
(25025, 'Spring Hill (historical)', 32.8791694641113, 0.573849762469922, -83.959716796875, -1.46537349714746, 218, 13, 'PPL', 'P'),
(51612, 'Spring Hill (historical)', 38.4913902282715, 0.671801493153309, -76.9861068725586, -1.34366104321838, 218, 25, 'PPL', 'P'),
(83759, 'Spring Hill (historical)', 33.1124992370605, 0.577922135250817, -79.7936096191406, -1.39266120990502, 218, 48, 'PPL', 'P'),
(51613, 'Spring Hill Acres', 38.3902816772461, 0.670036816035995, -75.6208267211914, -1.3198324093649, 218, 25, 'PPL', 'P'),
(111502, 'Spring Hill Chapel', 39.2444381713867, 0.684944659186041, -80.3683319091797, -1.40269200615081, 218, 58, 'PPL', 'P'),
(205876, 'Spring Hill Condominium', 40.6566696166992, 0.709592747706942, -111.871940612793, -1.9525337042888, 218, 52, 'PPL', 'P'),
(51614, 'Spring Hill Estates', 39.6652793884277, 0.692289724051507, -77.7997207641602, -1.35786128446679, 218, 25, 'PPL', 'P'),
(51615, 'Spring Hill Farms', 39.524169921875, 0.689826899254429, -76.4036102294922, -1.33349455891506, 218, 25, 'PPL', 'P'),
(31187, 'Spring Hills', 39.836109161377, 0.695271266049905, -86.1936111450195, -1.50436230866427, 218, 19, 'PPL', 'P'),
(83760, 'Spring Hills', 35.0336112976074, 0.611451866007133, -81.9738922119141, -1.43071431977284, 218, 48, 'PPL', 'P'),
(98248, 'Spring Hills', 30.1197204589844, 0.525688291789575, -95.4244384765625, -1.66547063828278, 218, 51, 'PPL', 'P'),
(31188, 'Spring Hollow', 39.922779083252, 0.69678394154907, -86.1647186279297, -1.50385803911186, 218, 19, 'PPL', 'P'),
(69015, 'Spring Hope', 35.3019409179688, 0.616135101363064, -78.0388870239258, -1.36203552315938, 218, 33, 'PPL', 'P'),
(167480, 'Spring House', 40.1852798461914, 0.70136544415136, -75.2280578613281, -1.31297729956098, 218, 45, 'PPL', 'P'),
(51616, 'Spring House Estates', 39.6938896179199, 0.692789066755897, -76.3219375610352, -1.33206910194159, 218, 25, 'PPL', 'P'),
(14657, 'Spring Lake', 38.7050018310547, 0.675529718942338, -75.0875015258789, -1.31052412872285, 218, 10, 'PPL', 'P'),
(18178, 'Spring Lake', 28.4933300018311, 0.497302423389234, -82.3030624389648, -1.43645942403441, 218, 12, 'PPL', 'P'),
(25027, 'Spring Lake', 34.9799995422363, 0.610516164358133, -83.3083267211914, -1.45400459561196, 218, 13, 'PPL', 'P'),
(31189, 'Spring Lake', 39.776668548584, 0.694233831647265, -85.8530578613281, -1.49841853258538, 218, 19, 'PPL', 'P'),
(43174, 'Spring Lake', 32.7333297729492, 0.571304379679052, -93.0550003051758, -1.62411614076965, 218, 22, 'PPL', 'P'),
(69016, 'Spring Lake', 35.167781829834, 0.613793583553639, -78.9730606079102, -1.37833992798507, 218, 33, 'PPL', 'P'),
(83764, 'Spring Lake', 33.8830604553223, 0.591370965597663, -80.3916702270508, -1.40309933663953, 218, 48, 'PPL', 'P'),
(90977, 'Spring Lake', 35.246940612793, 0.615175164948145, -89.8708267211914, -1.56854182777409, 218, 50, 'PPL', 'P'),
(128965, 'Spring Lake', 45.2299995422363, 0.789412412687552, -70.2850036621094, -1.22670472868008, 218, 26, 'PPL', 'P'),
(133218, 'Spring Lake', 43.0769386291504, 0.751834410758207, -86.1969375610352, -1.50442036557603, 218, 27, 'PPL', 'P'),
(138224, 'Spring Lake', 44.7063903808594, 0.780273708827918, -93.4630584716797, -1.63123809931479, 218, 28, 'PPL', 'P'),
(146370, 'Spring Lake', 40.1533317565918, 0.700807844798125, -74.0286102294922, -1.29204298918019, 218, 37, 'PPL', 'P'),
(152835, 'Spring Lake', 43.125560760498, 0.752683027039561, -76.6883316040039, -1.33846388435109, 218, 40, 'PPL', 'P'),
(169624, 'Spring Lake', 41.6797218322754, 0.727448377288569, -71.5763931274414, -1.24924372677569, 218, 47, 'PPL', 'P'),
(176484, 'Spring Lake', 44.0233306884766, 0.768352068208178, -89.1586074829102, -1.55611125707004, 218, 57, 'PPL', 'P'),
(205878, 'Spring Lake', 40.0011100769043, 0.698151075294662, -111.745559692383, -1.95032794111594, 218, 52, 'PPL', 'P'),
(12076, 'Spring Lake (historical)', 34.4819412231445, 0.601823406823033, -92.9902801513672, -1.62298656099329, 218, 4, 'PPL', 'P'),
(6014, 'Spring Lake Estates', 33.6188888549805, 0.586760301381436, -86.6738891601563, -1.51274474135335, 218, 2, 'PPL', 'P'),
(12077, 'Spring Lake Estates', 36.3611106872559, 0.634621101174713, -92.4138870239258, -1.61292660313357, 218, 4, 'PPL', 'P'),
(43175, 'Spring Lake Estates', 32.4244384765625, 0.56591320952635, -93.7319412231445, -1.63593098862967, 218, 22, 'PPL', 'P'),
(146371, 'Spring Lake Heights', 40.1502799987793, 0.700754581576324, -74.0313873291016, -1.29209145871203, 218, 37, 'PPL', 'P'),
(128966, 'Spring Lake Landing', 45.2508316040039, 0.789776000755375, -70.2236099243164, -1.22563320581549, 218, 26, 'PPL', 'P'),
(121553, 'Spring Lake Mobile Home Park', 41.9980583190918, 0.733004397112747, -88.2333297729492, -1.5399621145359, 218, 18, 'PPL', 'P'),
(51617, 'Spring Lake Park', 39.0591697692871, 0.681711115569494, -77.1152801513672, -1.34591554223919, 218, 25, 'PPL', 'P'),
(138225, 'Spring Lake Park', 45.107780456543, 0.787279287233426, -93.2377777099609, -1.6273062082814, 218, 28, 'PPL', 'P'),
(25028, 'Spring Lakes', 33.5058288574219, 0.584787032171741, -82.1155624389648, -1.43318693168692, 218, 13, 'PPL', 'P'),
(205879, 'Spring Lane Condominium', 40.6558303833008, 0.709578100320947, -111.847221374512, -1.95210227219221, 218, 52, 'PPL', 'P'),
(38332, 'Spring Lick', 37.4447212219238, 0.653533672813965, -86.5566711425781, -1.51069890100395, 218, 21, 'PPL', 'P'),
(138228, 'Spring Lodge Resort and Marina', 48.5977783203125, 0.848191240843773, -93.2111129760742, -1.62684082088091, 218, 28, 'PPL', 'P'),
(51618, 'Spring Meadow', 39.6480598449707, 0.691989186322491, -76.9713897705078, -1.34340418133124, 218, 25, 'PPL', 'P'),
(167481, 'Spring Meadow', 40.1561088562012, 0.700856314329965, -78.5824966430664, -1.3715233008589, 218, 45, 'PPL', 'P'),
(12078, 'Spring Meadows', 35.1669387817383, 0.613778869588616, -92.7505569458008, -1.61880260176272, 218, 4, 'PPL', 'P'),
(51621, 'Spring Meadows', 39.1002807617188, 0.682428637746189, -77.3083267211914, -1.3492848404923, 218, 25, 'PPL', 'P'),
(74380, 'Spring Meadows', 39.2183303833008, 0.684488992323528, -84.529167175293, -1.47531228117758, 218, 41, 'PPL', 'P'),
(106489, 'Spring Meadows', 37.6141700744629, 0.656491113204498, -77.3494415283203, -1.35000242924802, 218, 53, 'PPL', 'P'),
(106486, 'Spring Meadows Trailer Park', 39.2388916015625, 0.684847853280417, -78.1066665649414, -1.3632184993156, 218, 53, 'PPL', 'P'),
(38333, 'Spring Mill', 38.1433296203613, 0.665726689548784, -85.6308288574219, -1.49453990477379, 218, 21, 'PPL', 'P'),
(146374, 'Spring Mill', 40.1741714477539, 0.701171566024003, -74.6030578613281, -1.30206899173602, 218, 37, 'PPL', 'P'),
(157760, 'Spring Mill', 40.810001373291, 0.712268891707336, -82.5897216796875, -1.44146257161629, 218, 41, 'PPL', 'P'),
(167482, 'Spring Mill', 40.0755615234375, 0.699450498169539, -75.2805633544922, -1.31389369329208, 218, 45, 'PPL', 'P'),
(31190, 'Spring Mill Estates', 39.875560760498, 0.695959826349745, -86.1669387817383, -1.50389678810572, 218, 19, 'PPL', 'P'),
(31192, 'Spring Mill Village', 38.7350006103516, 0.676053296412648, -86.4269409179688, -1.50843468144517, 218, 19, 'PPL', 'P'),
(31193, 'Spring Mill Woods', 39.9155616760254, 0.696657974029509, -86.1647186279297, -1.50385803911186, 218, 19, 'PPL', 'P'),
(51622, 'Spring Mills', 39.5547218322754, 0.69036013068369, -77.0124969482422, -1.34412163692891, 218, 25, 'PPL', 'P'),
(106487, 'Spring Mills', 37.2449989318848, 0.65004786126316, -78.9194412231445, -1.37740409317801, 218, 53, 'PPL', 'P'),
(111504, 'Spring Mills', 39.5583305358887, 0.69042311444347, -77.9541702270508, -1.36055693612217, 218, 58, 'PPL', 'P'),
(146375, 'Spring Mills', 40.5941696166992, 0.708501916924446, -75.116943359375, -1.31103798565518, 218, 37, 'PPL', 'P'),
(152836, 'Spring Mills', 42.0077781677246, 0.733174040474185, -77.7638931274414, -1.35723597424284, 218, 40, 'PPL', 'P'),
(167483, 'Spring Mills', 40.853328704834, 0.713025096298864, -77.5677795410156, -1.35381314645182, 218, 45, 'PPL', 'P'),
(167485, 'Spring Mount', 40.2755584716797, 0.702941103410306, -75.4569396972656, -1.3169720411961, 218, 45, 'PPL', 'P'),
(157761, 'Spring Mountain', 40.4086112976074, 0.705263313301828, -82.0508270263672, -1.43205708559446, 218, 41, 'PPL', 'P'),
(205881, 'Spring Mountain Ranchettes', 41.3222198486328, 0.721208790591595, -111.880561828613, -1.95268417289039, 218, 52, 'PPL', 'P'),
(51623, 'Spring Oak Estates', 38.5008316040039, 0.671966276245758, -76.9658279418945, -1.34330710910951, 218, 25, 'PPL', 'P'),
(138229, 'Spring Park', 44.9352798461914, 0.784268583621091, -93.6319427490234, -1.63418568600929, 218, 28, 'PPL', 'P'),
(25030, 'Spring Place', 34.7580604553223, 0.606642596552613, -84.8211135864258, -1.48040770729123, 218, 13, 'PPL', 'P'),
(90978, 'Spring Place', 36.0238914489746, 0.628735515165638, -83.8544387817383, -1.46353604915336, 218, 50, 'PPL', 'P'),
(83766, 'Spring Plain (historical)', 33.3766708374023, 0.582532799467044, -80.1780624389648, -1.39937117742953, 218, 48, 'PPL', 'P'),
(79178, 'Spring Plains', 39.9824981689453, 0.6978262362207, -76.6469421386719, -1.33774150190541, 218, 45, 'PPL', 'P'),
(61852, 'Spring Plains (historical)', 32.1416702270508, 0.56097797255227, -90.8041687011719, -1.58483171837183, 218, 30, 'PPL', 'P'),
(176486, 'Spring Prairie', 42.6913909912109, 0.745105335052876, -88.404167175293, -1.54294378969236, 218, 57, 'PPL', 'P'),
(143087, 'Spring Ranch (historical)', 40.4063911437988, 0.705224564307967, -98.2336120605469, -1.71449996658335, 218, 35, 'PPL', 'P'),
(43178, 'Spring Ridge', 31.7805595397949, 0.554675402095515, -93.5088882446289, -1.6320379797482, 218, 22, 'PPL', 'P'),
(51625, 'Spring Ridge', 38.2158317565918, 0.666992090540735, -76.3908309936523, -1.33327151917377, 218, 25, 'PPL', 'P'),
(61853, 'Spring Ridge', 32.1875, 0.561777852985675, -90.329719543457, -1.57655101843639, 218, 30, 'PPL', 'P'),
(106488, 'Spring Ridge', 38.9536094665527, 0.679868740727377, -77.2822189331055, -1.34882917362979, 218, 53, 'PPL', 'P'),
(167486, 'Spring Ridge', 40.3527793884277, 0.704288862658968, -75.9902801513672, -1.32628058815425, 218, 45, 'PPL', 'P'),
(25031, 'Spring Ridge Estates', 33.8555603027344, 0.590890997390203, -84.807502746582, -1.48017015332199, 218, 13, 'PPL', 'P'),
(111505, 'Spring Run', 39.4324989318848, 0.688226938650536, -81.1675033569336, -1.41664017920204, 218, 58, 'PPL', 'P'),
(167487, 'Spring Run', 40.1419410705566, 0.700609039822751, -77.7738876342773, -1.35741041129424, 218, 45, 'PPL', 'P'),
(205882, 'Spring Run', 40.6611099243164, 0.709670245694664, -111.84806060791, -1.9521169195782, 218, 52, 'PPL', 'P'),
(167488, 'Spring Run Acres', 40.1800003051758, 0.701273298777644, -76.9833297729492, -1.34361257368654, 218, 45, 'PPL', 'P'),
(167489, 'Spring Run Manor', 40.1766700744629, 0.701215175286853, -76.980827331543, -1.34356889784467, 218, 45, 'PPL', 'P'),
(98250, 'Spring Seat', 31.2069396972656, 0.544663847188608, -96.0369415283203, -1.67616083321446, 218, 51, 'PPL', 'P'),
(69019, 'Spring Time', 35.5969390869141, 0.621283790698514, -82.5169372558594, -1.44019224377632, 218, 33, 'PPL', 'P'),
(74388, 'Spring Valle Estates', 38.8447189331055, 0.677968242394469, -82.2541732788086, -1.43560614722115, 218, 41, 'PPL', 'P'),
(6016, 'Spring Valley', 34.6566696166992, 0.604872992587283, -87.6166687011719, -1.52919934846451, 218, 2, 'PPL', 'P'),
(12083, 'Spring Valley', 36.1761093139648, 0.631392218090074, -93.9347229003906, -1.63947019656033, 218, 4, 'PPL', 'P'),
(13214, 'Spring Valley', 38.9394416809082, 0.679621466220163, -77.0991668701172, -1.34563431242808, 218, 9, 'PPL', 'P'),
(14658, 'Spring Valley', 39.7708282470703, 0.694131899156542, -75.647216796875, -1.32029300307543, 218, 10, 'PPL', 'P'),
(25034, 'Spring Valley', 33.0374984741211, 0.576613124996016, -85.0963897705078, -1.48521218305578, 218, 13, 'PPL', 'P'),
(38334, 'Spring Valley', 38.2969398498535, 0.668407693818167, -85.6113891601563, -1.49420061805091, 218, 21, 'PPL', 'P'),
(51628, 'Spring Valley', 39.6852798461914, 0.692638797891389, -77.6888885498047, -1.35592689740901, 218, 25, 'PPL', 'P'),
(57685, 'Spring Valley', 36.5519409179688, 0.637951717012993, -94.4997177124023, -1.64933121628662, 218, 29, 'PPL', 'P'),
(61854, 'Spring Valley', 33.5475006103516, 0.585514341465442, -89.1125030517578, -1.55530658294667, 218, 30, 'PPL', 'P'),
(83769, 'Spring Valley', 34.9111099243164, 0.60931381370499, -80.9300003051758, -1.41249496896533, 218, 48, 'PPL', 'P'),
(90987, 'Spring Valley', 35.1222190856934, 0.612998363652142, -85.3125, -1.48898401810766, 218, 50, 'PPL', 'P'),
(98252, 'Spring Valley', 31.3997192382813, 0.548028484909814, -97.2897186279297, -1.69802591839623, 218, 51, 'PPL', 'P'),
(106493, 'Spring Valley', 38.3311080932617, 0.669004042165263, -77.4608306884766, -1.35194653684378, 218, 53, 'PPL', 'P'),
(111506, 'Spring Valley', 38.3852806091309, 0.669949530931268, -82.5169372558594, -1.44019224377632, 218, 58, 'PPL', 'P'),
(117870, 'Spring Valley', 41.4150009155273, 0.722828125692418, -92.4836120605469, -1.61414353459368, 218, 16, 'PPL', 'P'),
(121556, 'Spring Valley', 41.9047203063965, 0.731375341473946, -90.0363922119141, -1.57143149071488, 218, 18, 'PPL', 'P'),
(138232, 'Spring Valley', 43.686939239502, 0.762480929848017, -92.3888931274414, -1.61249037734701, 218, 28, 'PPL', 'P'),
(146377, 'Spring Valley', 41.0058288574219, 0.715686726071316, -74.9400024414063, -1.30794978405513, 218, 37, 'PPL', 'P'),
(152849, 'Spring Valley', 41.1130599975586, 0.717558262527369, -74.0441665649414, -1.29231449845333, 218, 40, 'PPL', 'P'),
(157763, 'Spring Valley', 41.6055603027344, 0.726154014419764, -83.730827331543, -1.46137862235428, 218, 41, 'PPL', 'P'),
(167493, 'Spring Valley', 40.5525016784668, 0.707774674209772, -75.3591690063477, -1.31526562072763, 218, 45, 'PPL', 'P'),
(171352, 'Spring Valley', 43.2041702270508, 0.754055021054142, -97.2686080932617, -1.69765747005942, 218, 49, 'PPL', 'P'),
(176490, 'Spring Valley', 42.6583290100098, 0.744528294623684, -89.3083267211914, -1.55872435073162, 218, 57, 'PPL', 'P'),
(179205, 'Spring Valley', 34.3450012207031, 0.599433352902741, -112.158332824707, -1.95753219133877, 218, 5, 'PPL', 'P'),
(185336, 'Spring Valley', 32.7447204589844, 0.571503184654426, -116.998062133789, -2.04200140268752, 218, 6, 'PPL', 'P'),
(190766, 'Spring Valley', 36.1080589294434, 0.630204514822926, -115.244171142578, -2.01139023016982, 218, 39, 'PPL', 'P'),
(205883, 'Spring Valley', 40.670280456543, 0.709830301676177, -111.949996948242, -1.95389604434443, 218, 52, 'PPL', 'P'),
(208816, 'Spring Valley', 47.2747192382813, 0.825099503663914, -117.28360748291, -2.04698510919344, 218, 56, 'PPL', 'P'),
(190767, 'Spring Valley (historical)', 38.041389465332, 0.663947498203529, -114.179443359375, -1.99280722471547, 218, 39, 'PPL', 'P'),
(197597, 'Spring Valley (historical)', 47.6883316040039, 0.832318401272737, -114.349998474121, -1.9957839730239, 218, 31, 'PPL', 'P'),
(6020, 'Spring Valley Acres', 31.172779083252, 0.544067631999566, -85.4316711425781, -1.49106394691901, 218, 2, 'PPL', 'P'),
(171353, 'Spring Valley Colony', 44.0405616760254, 0.768652805674275, -98.8866729736328, -1.72589802973278, 218, 49, 'PPL', 'P'),
(6021, 'Spring Valley Estates', 33.6138916015625, 0.586673082855735, -86.4658279418945, -1.50911338804897, 218, 2, 'PPL', 'P'),
(25036, 'Spring Valley Estates', 33.9625015258789, 0.592757473840185, -83.3444366455078, -1.45463483268393, 218, 13, 'PPL', 'P'),
(51630, 'Spring Valley Farms', 39.6827812194824, 0.692595188628539, -76.7138900756836, -1.33890996383368, 218, 25, 'PPL', 'P'),
(25037, 'Spring Valley Mobile Home Park', 34.0911102294922, 0.595002119164958, -84.5774993896484, -1.47615583745286, 218, 13, 'PPL', 'P'),
(138233, 'Spring Valley Trailer Park', 43.6952781677246, 0.762626471601589, -92.3905563354492, -1.6125194058029, 218, 28, 'PPL', 'P'),
(25038, 'Spring View Acres', 34.3300018310547, 0.599171564167586, -83.8397216796875, -1.46327918726622, 218, 13, 'PPL', 'P'),
(6022, 'Spring Villa', 32.5883293151855, 0.568773644274177, -85.311393737793, -1.48896471018976, 218, 2, 'PPL', 'P'),
(83771, 'Spring Village', 34.1988906860352, 0.596883243000936, -80.6800003051758, -1.40813164583535, 218, 48, 'PPL', 'P'),
(114114, 'Spring Village', 41.9194412231445, 0.731632269940111, -72.616943359375, -1.26740475435533, 218, 8, 'PPL', 'P'),
(83772, 'Springbank Hills', 33.9958305358887, 0.593339174801286, -80.5088882446289, -1.40514517698893, 218, 48, 'PPL', 'P'),
(176493, 'Springbluff (historical)', 43.9233283996582, 0.766606699008767, -89.6777801513672, -1.56517252952098, 218, 57, 'PPL', 'P'),
(74384, 'Springboro', 39.5522193908691, 0.690316454841813, -84.2333297729492, -1.47014894445613, 218, 41, 'PPL', 'P'),
(123718, 'Springboro', 40.5944404602051, 0.708506644035381, -86.7758331298828, -1.51452399927763, 218, 19, 'PPL', 'P'),
(167499, 'Springboro', 41.8005599975586, 0.72955740113483, -80.3691711425781, -1.4027066535368, 218, 45, 'PPL', 'P'),
(25039, 'Springbrook', 33.8247184753418, 0.590352705954871, -84.6730575561523, -1.47782364208552, 218, 13, 'PPL', 'P'),
(51632, 'Springbrook', 39.0536117553711, 0.681614109926788, -76.995002746582, -1.34381630550993, 218, 25, 'PPL', 'P'),
(117874, 'Springbrook', 42.1641693115234, 0.735903580854435, -90.4763870239258, -1.57911084887618, 218, 16, 'PPL', 'P'),
(157764, 'Springbrook', 41.4316711425781, 0.723119076041509, -82.8866729736328, -1.44664534941369, 218, 41, 'PPL', 'P'),
(176494, 'Springbrook', 45.9486083984375, 0.801954503262253, -91.6880569458008, -1.60025847846028, 218, 57, 'PPL', 'P'),
(201590, 'Springbrook', 45.3177795410156, 0.790944462683647, -122.944442749023, -2.14578532300013, 218, 43, 'PPL', 'P'),
(51633, 'Springbrook Forest', 39.0525016784668, 0.681594735429857, -77.0180587768555, -1.34421870915064, 218, 25, 'PPL', 'P'),
(51634, 'Springbrook Manor', 39.0497207641602, 0.681546199318991, -76.9883270263672, -1.34369979221224, 218, 25, 'PPL', 'P'),
(51635, 'Springbrook Terrace', 38.9552803039551, 0.679897902341314, -76.9177780151367, -1.34246847968224, 218, 25, 'PPL', 'P'),
(90982, 'Springcrest', 35.2005615234375, 0.614365697134815, -85.211669921875, -1.48722420125934, 218, 50, 'PPL', 'P'),
(6025, 'Springdale', 33.600830078125, 0.586445116266425, -86.7663879394531, -1.51435914960616, 218, 2, 'PPL', 'P'),
(12087, 'Springdale', 36.1866683959961, 0.631576508837507, -94.1286087036133, -1.64285414219944, 218, 4, 'PPL', 'P'),
(25040, 'Springdale', 34.3183288574219, 0.598967832344195, -83.9097213745117, -1.46450091241629, 218, 13, 'PPL', 'P'),
(34040, 'Springdale', 37.6749992370605, 0.657552782373058, -97.1686096191406, -1.69591216743904, 218, 20, 'PPL', 'P'),
(61856, 'Springdale', 34.2216682434082, 0.597280786372657, -89.6091690063477, -1.56397503913682, 218, 30, 'PPL', 'P'),
(69026, 'Springdale', 35.288890838623, 0.615907334510835, -81.1449966430664, -1.41624736294125, 218, 33, 'PPL', 'P'),
(74386, 'Springdale', 39.4047203063965, 0.687742110174087, -81.4730606079102, -1.42197315928493, 218, 41, 'PPL', 'P'),
(83779, 'Springdale', 34.9500007629395, 0.609992586887824, -81.876106262207, -1.42900763298826, 218, 48, 'PPL', 'P'),
(90984, 'Springdale', 36.5144386291504, 0.637297178596079, -82.5588912963867, -1.44092447991804, 218, 50, 'PPL', 'P'),
(98254, 'Springdale', 31.6127796173096, 0.551747090029405, -98.3147201538086, -1.71591556986079, 218, 51, 'PPL', 'P'),
(106497, 'Springdale', 39.2861099243164, 0.685671968479742, -77.6388931274414, -1.35505431267785, 218, 53, 'PPL', 'P'),
(112357, 'Springdale', 38.6227798461914, 0.674094674588949, -83.6688919067383, -1.46029764526782, 218, 21, 'PPL', 'P'),
(112391, 'Springdale', 39.1386108398438, 0.683097623812017, -76.4697189331055, -1.33464837345734, 218, 25, 'PPL', 'P'),
(114115, 'Springdale', 41.0877799987793, 0.71711704331377, -73.5247192382813, -1.28324843231243, 218, 8, 'PPL', 'P'),
(117876, 'Springdale', 42.5233306884766, 0.742172129428263, -96.3697204589844, -1.68196892123582, 218, 16, 'PPL', 'P'),
(126235, 'Springdale', 42.1533317565918, 0.735714429838012, -71.1297225952148, -1.2414478553167, 218, 23, 'PPL', 'P'),
(146379, 'Springdale', 41.0202789306641, 0.715938927426547, -74.7694396972656, -1.30497290258864, 218, 37, 'PPL', 'P'),
(167501, 'Springdale', 40.540828704834, 0.707570942386381, -79.7841720581055, -1.3924964933916, 218, 45, 'PPL', 'P'),
(177279, 'Springdale', 40.0625, 0.699222531580228, -80.6536102294922, -1.40767105212482, 218, 58, 'PPL', 'P'),
(190769, 'Springdale', 37.0299987792969, 0.646295400708212, -116.754173278809, -2.03774473915919, 218, 39, 'PPL', 'P'),
(192798, 'Springdale', 37.1888885498047, 0.649068550351311, -112.997779846191, -1.97218330575973, 218, 52, 'PPL', 'P'),
(194430, 'Springdale', 40.1097183227539, 0.700046646779553, -105.357780456543, -1.83884016156001, 218, 7, 'PPL', 'P'),
(195642, 'Springdale', 42.5155601501465, 0.742036507949751, -113.690002441406, -1.98426486920293, 218, 17, 'PPL', 'P'),
(197598, 'Springdale', 45.7383308410645, 0.798284467543042, -110.226387023926, -1.92381337614506, 218, 31, 'PPL', 'P'),
(208817, 'Springdale', 48.0574989318848, 0.838761586635047, -117.740280151367, -2.05495555086189, 218, 56, 'PPL', 'P'),
(209900, 'Springdale', 45.5191688537598, 0.794459369269361, -122.32861328125, -2.13503707115668, 218, 43, 'PPL', 'P'),
(69027, 'Springdale (historical)', 35.4413909912109, 0.618568964283288, -82.8138885498047, -1.44537502157372, 218, 33, 'PPL', 'P'),
(176496, 'Springdale (historical)', 44.5272216796875, 0.777146625075947, -91.7755584716797, -1.60178566818739, 218, 57, 'PPL', 'P'),
(69028, 'Springdale Acres', 34.7436103820801, 0.606390395197382, -77.482780456543, -1.35232963256659, 218, 33, 'PPL', 'P'),
(83783, 'Springdale Acres', 34.9249992370605, 0.609556227943214, -80.9599990844727, -1.41301854643564, 218, 48, 'PPL', 'P'),
(197599, 'Springdale Colony', 46.4619407653809, 0.81091384322247, -111.015556335449, -1.93758697898684, 218, 31, 'PPL', 'P'),
(25041, 'Springdale Estates', 33.9233283996582, 0.592073773809334, -84.2027816772461, -1.4696157796059, 218, 13, 'PPL', 'P'),
(83784, 'Springdale Estates', 35.0847206115723, 0.612343891814255, -81.8544387817383, -1.42862946411347, 218, 48, 'PPL', 'P'),
(111507, 'Springdale Estates', 38.4508285522461, 0.671093558356539, -81.9852828979492, -1.43091312474821, 218, 58, 'PPL', 'P'),
(25042, 'Springdale Forest', 34.3180618286133, 0.598963171812288, -83.916389465332, -1.46461729255593, 218, 13, 'PPL', 'P'),
(51640, 'Springdale Gardens', 38.9358291625977, 0.679558415881356, -76.8516693115234, -1.34131466513997, 218, 25, 'PPL', 'P'),
(83785, 'Springdale Place', 34.1888885498047, 0.596708672791481, -79.8652801513672, -1.39391209666903, 218, 48, 'PPL', 'P'),
(79181, 'Springdell', 39.9066696166992, 0.696502778316985, -75.8352813720703, -1.32357534911895, 218, 45, 'PPL', 'P'),
(83786, 'Springdell', 34.8236083984375, 0.607786623977884, -80.8816680908203, -1.41165141269005, 218, 48, 'PPL', 'P'),
(205885, 'Springdell', 40.3280601501465, 0.703857430562375, -111.623611450195, -1.94819954277275, 218, 52, 'PPL', 'P'),
(77316, 'Springer', 34.3144416809082, 0.598899988315426, -97.1425018310547, -1.69545650057652, 218, 42, 'PPL', 'P'),
(133221, 'Springer', 45.9205589294434, 0.801464947674869, -86.4022216796875, -1.50800324934857, 218, 27, 'PPL', 'P'),
(189601, 'Springer', 36.3611106872559, 0.634621101174713, -104.594718933105, -1.82552222558074, 218, 38, 'PPL', 'P'),
(90992, 'Springer Ridge (historical)', 35.5263900756836, 0.620052478168516, -87.4888916015625, -1.52696921736768, 218, 50, 'PPL', 'P'),
(28674, 'Springer Station', 38.1797218322754, 0.666361853468768, -88.3516693115234, -1.54202752911932, 218, 18, 'PPL', 'P'),
(192262, 'Springers Ranch (historical)', 35.8788604736328, 0.626204247128545, -100.188163757324, -1.74861332909256, 218, 51, 'PPL', 'P'),
(90988, 'Springers Station', 35.1388893127441, 0.613289314001233, -87.3869400024414, -1.52518982628534, 218, 50, 'PPL', 'P'),
(31194, 'Springersville', 39.6572189331055, 0.692149042566923, -85.0538864135742, -1.48447035953414, 218, 19, 'PPL', 'P'),
(28675, 'Springerton', 38.1794395446777, 0.666356926620751, -88.3541717529297, -1.54207120496119, 218, 18, 'PPL', 'P'),
(179206, 'Springerville', 34.1333312988281, 0.595739015838583, -109.285278320313, -1.90738793064783, 218, 5, 'PPL', 'P'),
(349, 'Springfield', 35.2675018310547, 0.615534025905033, -92.557502746582, -1.61543317035155, 218, 4, 'PPL', 'P'),
(6031, 'Springfield', 31.833610534668, 0.555601316627509, -87.7619400024414, -1.53173481098032, 218, 2, 'PPL', 'P'),
(18180, 'Springfield', 30.3455600738525, 0.52962993665046, -81.6536102294922, -1.42512434464476, 218, 12, 'PPL', 'P'),
(25051, 'Springfield', 33.6277809143066, 0.58691549709396, -82.9491729736328, -1.44773618019619, 218, 13, 'PPL', 'P'),
(28676, 'Springfield', 39.8016700744629, 0.694670190591874, -89.6436080932617, -1.56457611459485, 218, 18, 'PPL', 'P'),
(38337, 'Springfield', 37.6852798461914, 0.657732212851502, -85.2222213745117, -1.48740835884872, 218, 21, 'PPL', 'P'),
(43179, 'Springfield', 30.4288902282715, 0.531084322211266, -90.5486068725586, -1.58037132302011, 218, 22, 'PPL', 'P'),
(51644, 'Springfield', 38.7361106872559, 0.676072670909578, -76.0819396972656, -1.32788034902106, 218, 25, 'PPL', 'P'),
(57687, 'Springfield', 37.2152786254883, 0.64952914406184, -93.2980575561523, -1.62835829007003, 218, 29, 'PPL', 'P'),
(69030, 'Springfield', 34.7827796936035, 0.607074028649206, -79.5330581665039, -1.38811372918566, 218, 33, 'PPL', 'P'),
(74397, 'Springfield', 39.9241714477539, 0.696808242894017, -83.8088912963867, -1.46274109556797, 218, 41, 'PPL', 'P'),
(83789, 'Springfield', 33.4966697692871, 0.584627175927309, -81.2794418334961, -1.41859387417772, 218, 48, 'PPL', 'P'),
(90989, 'Springfield', 36.5091705322266, 0.637205232959444, -86.8850021362305, -1.51642935787953, 218, 50, 'PPL', 'P'),
(98257, 'Springfield', 31.6594390869141, 0.552561451401238, -96.4824981689453, -1.6839372635975, 218, 51, 'PPL', 'P'),
(106505, 'Springfield', 37.2705612182617, 0.650494007324776, -76.6350021362305, -1.33753310955011, 218, 53, 'PPL', 'P'),
(111508, 'Springfield', 39.4505615234375, 0.688542190344575, -78.6938934326172, -1.37346754161271, 218, 58, 'PPL', 'P'),
(123712, 'Springfield', 41.7152786254883, 0.728068960401585, -86.7774963378906, -1.51455302773351, 218, 19, 'PPL', 'P'),
(126236, 'Springfield', 42.101390838623, 0.734807889802949, -72.5902786254883, -1.26693936695483, 218, 23, 'PPL', 'P'),
(128967, 'Springfield', 45.396110534668, 0.79231159642924, -68.1361083984375, -1.18919943104849, 218, 26, 'PPL', 'P'),
(133236, 'Springfield', 42.3263893127441, 0.738734853988325, -85.2391662597656, -1.48770410288777, 218, 27, 'PPL', 'P'),
(138237, 'Springfield', 44.2388916015625, 0.772114315880133, -94.9755630493164, -1.65763628414604, 218, 28, 'PPL', 'P'),
(143091, 'Springfield', 41.0819396972656, 0.717015110823048, -96.1341705322266, -1.67785779946106, 218, 35, 'PPL', 'P'),
(144499, 'Springfield', 43.4949989318848, 0.759130939512806, -72.0338897705078, -1.25722854951402, 218, 36, 'PPL', 'P'),
(146381, 'Springfield', 40.7230606079102, 0.710751489097236, -74.3111114501953, -1.29697356562237, 218, 37, 'PPL', 'P'),
(152838, 'Springfield', 42.836109161377, 0.747631143609735, -74.853889465332, -1.30644682909394, 218, 40, 'PPL', 'P'),
(167505, 'Springfield', 41.8491706848145, 0.730405817679102, -76.7461090087891, -1.33947229029785, 218, 45, 'PPL', 'P'),
(171365, 'Springfield', 42.8541717529297, 0.747946395303773, -97.8969421386719, -1.7086239679542, 218, 49, 'PPL', 'P'),
(172586, 'Springfield', 43.2983283996582, 0.755698391183803, -72.482780456543, -1.26506316996687, 218, 55, 'PPL', 'P'),
(176498, 'Springfield', 42.6416702270508, 0.744237544011674, -88.4119415283203, -1.5430794777499, 218, 57, 'PPL', 'P'),
(185337, 'Springfield', 38.0208282470703, 0.663588637246641, -120.411392211914, -2.10157525100816, 218, 6, 'PPL', 'P'),
(187386, 'Springfield', 37.4083290100098, 0.652898508893981, -102.613891601563, -1.79095026673182, 218, 7, 'PPL', 'P'),
(195643, 'Springfield', 43.0816688537598, 0.751916968751999, -112.681106567383, -1.96665631439144, 218, 17, 'PPL', 'P'),
(201591, 'Springfield', 44.0463905334473, 0.768754538427916, -123.02082824707, -2.14711850144182, 218, 43, 'PPL', 'P'),
(12089, 'Springfield (historical)', 35.913890838623, 0.6268156423358, -90.2655563354492, -1.57543115919802, 218, 4, 'PPL', 'P'),
(61857, 'Springfield (historical)', 31.7472190856934, 0.554093501397333, -91.1902770996094, -1.59157058119417, 218, 30, 'PPL', 'P'),
(69031, 'Springfield (historical)', 36.3561096191406, 0.634533816069986, -81.1875, -1.4169891864629, 218, 33, 'PPL', 'P'),
(25052, 'Springfield Acres', 33.5047187805176, 0.584767657674811, -84.2474975585938, -1.47039621896335, 218, 13, 'PPL', 'P'),
(90991, 'Springfield Acres', 36.5227813720703, 0.637442786928679, -82.2083282470703, -1.43480600047164, 218, 50, 'PPL', 'P'),
(152839, 'Springfield Center', 42.8288917541504, 0.747505176090174, -74.8769378662109, -1.3068490995766, 218, 40, 'PPL', 'P'),
(176499, 'Springfield Corners', 43.1919403076172, 0.753841568692772, -89.5663909912109, -1.56322842192522, 218, 57, 'PPL', 'P'),
(14659, 'Springfield Crossroads', 38.6824989318848, 0.675136969260579, -75.3080596923828, -1.31437359492051, 218, 10, 'PPL', 'P'),
(25053, 'Springfield Downs', 34.211109161377, 0.597096495625224, -83.8388900756836, -1.46326467303828, 218, 13, 'PPL', 'P'),
(106507, 'Springfield Estates', 38.7833290100098, 0.676896786108903, -77.1750030517578, -1.34695790348985, 218, 53, 'PPL', 'P'),
(167506, 'Springfield Falls', 41.1438903808594, 0.71809635422562, -80.2216720581055, -1.40013230886908, 218, 45, 'PPL', 'P'),
(14660, 'Springfield Farms Addition', 38.6802787780762, 0.675098220266718, -75.375, -1.31554192369073, 218, 10, 'PPL', 'P'),
(106508, 'Springfield Forest', 38.773609161377, 0.676727142747465, -77.1641693115234, -1.34676881905245, 218, 53, 'PPL', 'P'),
(152840, 'Springfield Four Corners', 42.8377799987793, 0.747660305223671, -74.8702774047852, -1.30673285259502, 218, 40, 'PPL', 'P'),
(152841, 'Springfield Gardens', 40.6780586242676, 0.709966056312744, -73.746940612793, -1.28712692696596, 218, 40, 'PPL', 'P'),
(126237, 'Springfield Hill', 42.1216697692871, 0.73516182391182, -72.7111129760742, -1.26904832422207, 218, 23, 'PPL', 'P'),
(144497, 'Springfield Junction', 43.2502784729004, 0.754859761756537, -72.4255599975586, -1.26406448455809, 218, 36, 'PPL', 'P'),
(167507, 'Springfield Junction', 40.4744415283203, 0.706412267575115, -78.2286071777344, -1.36534676450073, 218, 45, 'PPL', 'P'),
(185338, 'Springfield Meadows', 38.6472206115723, 0.674521246416553, -121.072219848633, -2.11310886905707, 218, 6, 'PPL', 'P'),
(106510, 'Springfield Oaks', 38.725830078125, 0.675893240431134, -77.2061080932617, -1.34750078887806, 218, 53, 'PPL', 'P'),
(133223, 'Springfield Place', 42.3083305358887, 0.738419668873314, -85.2191696166992, -1.48735509562692, 218, 27, 'PPL', 'P'),
(106511, 'Springfield Square', 38.7816696166992, 0.676867824232049, -77.165283203125, -1.34678826012841, 218, 53, 'PPL', 'P'),
(106512, 'Springfield Station', 38.7705612182617, 0.676673946104691, -77.1738891601563, -1.34693846241389, 218, 53, 'PPL', 'P'),
(74389, 'Springfield Station (historical)', 39.9352798461914, 0.697002121021375, -83.8469390869141, -1.46340515478578, 218, 41, 'PPL', 'P'),
(167515, 'Springford Village', 40.2916717529297, 0.703222333221418, -76.7724990844727, -1.33993288400838, 218, 45, 'PPL', 'P'),
(51645, 'Springhaven', 38.6411094665527, 0.674414586814895, -76.9208297729492, -1.34252174290405, 218, 25, 'PPL', 'P'),
(69033, 'Springhaven', 35.3691711425781, 0.617308490139353, -80.1622161865234, -1.39909460815033, 218, 33, 'PPL', 'P'),
(167516, 'Springhaven', 40.2750015258789, 0.702931382872327, -76.2955627441406, -1.33160877454717, 218, 45, 'PPL', 'P'),
(25054, 'Springhaven (historical)', 32.4472198486328, 0.566310819477099, -83.0311126708984, -1.44916629770156, 218, 13, 'PPL', 'P'),
(51646, 'Springhaven Woods', 38.6369400024414, 0.674341815938108, -76.9233322143555, -1.34256541874592, 218, 25, 'PPL', 'P'),
(6032, 'Springhill', 33.3102798461914, 0.58137405807675, -85.9219436645508, -1.49962081665949, 218, 2, 'PPL', 'P'),
(12091, 'Springhill', 34.6333312988281, 0.604465662098555, -92.5083312988281, -1.61457496669027, 218, 4, 'PPL', 'P'),
(25065, 'Springhill', 33.5369415283203, 0.585330050718009, -83.913330078125, -1.46456389617607, 218, 13, 'PPL', 'P'),
(38338, 'Springhill', 36.9761085510254, 0.645354838790223, -86.4797210693359, -1.50935586886622, 218, 21, 'PPL', 'P'),
(43181, 'Springhill', 33.0058288574219, 0.57606038591177, -93.466667175293, -1.63130108307457, 218, 22, 'PPL', 'P'),
(51648, 'Springhill', 39.5872192382813, 0.690927317416849, -76.1833267211914, -1.32964988640737, 218, 25, 'PPL', 'P'),
(57690, 'Springhill', 39.8736114501953, 0.695925804466819, -93.6436080932617, -1.63438928467463, 218, 29, 'PPL', 'P'),
(61859, 'Springhill', 31.7444400787354, 0.55404499857598, -89.2141723632813, -1.55708104718099, 218, 30, 'PPL', 'P'),
(77319, 'Springhill', 35.813060760498, 0.625055825487475, -95.570556640625, -1.66802088134264, 218, 42, 'PPL', 'P'),
(79185, 'Springhill', 39.7313919067383, 0.693443605172811, -79.8030624389648, -1.39282619273455, 218, 45, 'PPL', 'P'),
(197600, 'Springhill', 45.8394393920898, 0.800049144660356, -111.033889770508, -1.93790695779181, 218, 31, 'PPL', 'P'),
(112323, 'Springhill (historical)', 39.4333305358887, 0.688241452878477, -85.4211120605469, -1.49087965617158, 218, 19, 'PPL', 'P'),
(25056, 'Springhill Estates', 33.7174987792969, 0.588481369235899, -84.6849975585938, -1.47803203444082, 218, 13, 'PPL', 'P'),
(51649, 'Springhill Farms', 39.4749984741211, 0.688968695593151, -76.7024993896484, -1.33871115885831, 218, 25, 'PPL', 'P'),
(51650, 'Springhill Lake', 39.0019416809082, 0.68071229700266, -76.9033279418945, -1.34221627832701, 218, 25, 'PPL', 'P'),
(197601, 'Springhill Park', 45.7333297729492, 0.798197182438315, -111.061111450195, -1.93838206573028, 218, 31, 'PPL', 'P'),
(157772, 'Springhills', 40.2555618286133, 0.702592096149451, -83.8697204589844, -1.46380276473653, 218, 41, 'PPL', 'P'),
(117881, 'Springhole', 42.2183303833008, 0.736848869883358, -91.0975036621094, -1.5899513792514, 218, 16, 'PPL', 'P'),
(167517, 'Springhope', 40.1030616760254, 0.699930466376999, -78.5997161865234, -1.37182383858792, 218, 45, 'PPL', 'P'),
(38339, 'Springlake', 38.9949989318848, 0.680591123173061, -84.4649963378906, -1.47419228878114, 218, 21, 'PPL', 'P'),
(51659, 'Springlake', 39.4569396972656, 0.68865351047814, -76.6086120605469, -1.33707251583958, 218, 25, 'PPL', 'P'),
(83791, 'Springlake', 35.0583305358887, 0.611883298103725, -81.932502746582, -1.42999193732715, 218, 48, 'PPL', 'P'),
(192263, 'Springlake', 34.2316703796387, 0.597455356582112, -102.305557250977, -1.7855688171171, 218, 51, 'PPL', 'P'),
(25057, 'Springlake Estates', 34.1086082458496, 0.595307517162963, -83.9663925170898, -1.46549001044515, 218, 13, 'PPL', 'P'),
(79188, 'Springlawn', 39.7358283996582, 0.693521036581505, -75.8675003051758, -1.32413767558312, 218, 45, 'PPL', 'P'),
(106513, 'Springlawn', 37.2166709899902, 0.649553445406787, -80.0149993896484, -1.39652519033062, 218, 53, 'PPL', 'P'),
(111511, 'Springlea Estates', 38.4680595397949, 0.671394295822636, -81.8597183227539, -1.42872160948719, 218, 58, 'PPL', 'P'),
(38340, 'Springlee', 38.2408294677734, 0.667428382906317, -85.6427764892578, -1.49474843028714, 218, 21, 'PPL', 'P'),
(83792, 'Springmaid Beach', 33.6563911437988, 0.58741483979835, -78.9205627441406, -1.37742366741203, 218, 48, 'PPL', 'P'),
(90993, 'Springmont', 36.2255592346191, 0.632255282020341, -86.5733337402344, -1.51098971819499, 218, 50, 'PPL', 'P'),
(167518, 'Springmont', 40.3263893127441, 0.703828268948439, -76, -1.32645023151569, 218, 45, 'PPL', 'P'),
(123716, 'Springport', 40.0475006103516, 0.698960742845073, -85.394172668457, -1.49040947508113, 218, 19, 'PPL', 'P'),
(133228, 'Springport', 42.3783302307129, 0.739641394023388, -84.6986083984375, -1.47826958841006, 218, 27, 'PPL', 'P'),
(79189, 'Springs', 39.7336082458496, 0.693482287587644, -79.1494369506836, -1.38141827588909, 218, 45, 'PPL', 'P'),
(152844, 'Springs', 41.0161094665527, 0.71586615654976, -72.1597213745117, -1.25942472530696, 218, 40, 'PPL', 'P'),
(6034, 'Springs Junction', 33.1116714477539, 0.577907687601903, -86.6861114501953, -1.51295806055666, 218, 2, 'PPL', 'P'),
(83793, 'Springs Park', 34.6061096191406, 0.603990554160085, -80.8822174072266, -1.41166100006997, 218, 48, 'PPL', 'P'),
(18181, 'Springside', 29.6749992370605, 0.517926442213512, -81.7149963378906, -1.4261957343513, 218, 12, 'PPL', 'P'),
(146384, 'Springside', 40.0602798461914, 0.699183782586368, -74.850830078125, -1.30639343271409, 218, 37, 'PPL', 'P'),
(18182, 'Springside Park', 29.6733303070068, 0.517897313889089, -81.7033309936523, -1.42599213568596, 218, 12, 'PPL', 'P'),
(176504, 'Springstead', 46.0252799987793, 0.80329267513099, -90.1366729736328, -1.57318172018328, 218, 57, 'PPL', 'P'),
(83794, 'Springstein', 34.9305610656738, 0.609653300164948, -80.956672668457, -1.41296048952388, 218, 48, 'PPL', 'P'),
(195644, 'Springston', 47.478328704834, 0.828653159243488, -116.731941223145, -2.03735671658837, 218, 17, 'PPL', 'P'),
(69035, 'Springsville (historical)', 35.4577789306641, 0.618854987784362, -80.7147216796875, -1.40873764814139, 218, 33, 'PPL', 'P'),
(197602, 'Springtime', 45.6983299255371, 0.797586319863278, -109.386672973633, -1.90915760119219, 218, 31, 'PPL', 'P'),
(25058, 'Springtime Mobile Home Park', 33.7750015258789, 0.589484981492696, -84.6786117553711, -1.4779205811492, 218, 13, 'PPL', 'P'),
(111512, 'Springton', 37.4558296203613, 0.653727550941323, -81.2444381713867, -1.41798294502366, 218, 58, 'PPL', 'P'),
(167519, 'Springton', 40.0758285522461, 0.699455158701447, -75.7702789306641, -1.32244084249458, 218, 45, 'PPL', 'P'),
(12093, 'Springtown', 36.2608299255371, 0.632870871706313, -94.4230575561523, -1.64799324415497, 218, 4, 'PPL', 'P'),
(31197, 'Springtown', 39.702220916748, 0.692934475351415, -86.6061096191406, -1.51156176519714, 218, 19, 'PPL', 'P'),
(57691, 'Springtown', 37.9236106872559, 0.661891870737124, -90.7605590820313, -1.58407058693229, 218, 29, 'PPL', 'P'),
(83796, 'Springtown', 33.0988883972168, 0.577684581281582, -80.6763916015625, -1.40806866207557, 218, 48, 'PPL', 'P'),
(98259, 'Springtown', 32.9658317565918, 0.575362304811033, -97.6833267211914, -1.70489567558615, 218, 51, 'PPL', 'P'),
(146386, 'Springtown', 40.648609161377, 0.709452066222359, -75.148063659668, -1.31158113735951, 218, 37, 'PPL', 'P'),
(152845, 'Springtown', 41.7822189331055, 0.729237289171803, -74.0872192382813, -1.29306590935489, 218, 40, 'PPL', 'P'),
(167524, 'Springtown', 41.1127815246582, 0.71755340225838, -76.851936340332, -1.34131932567188, 218, 45, 'PPL', 'P'),
(197603, 'Springtown', 46.7997207641602, 0.816809216348551, -113.278610229492, -1.97708472058797, 218, 31, 'PPL', 'P'),
(106514, 'Springtree', 37.2999992370605, 0.651007797678079, -79.8886108398438, -1.39431929399971, 218, 53, 'PPL', 'P'),
(205888, 'Springtree Condominium', 40.6508293151855, 0.70949081521622, -111.874168395996, -1.95257258644072, 218, 52, 'PPL', 'P'),
(25059, 'Springvale', 31.8280601501465, 0.555504444142857, -84.8797225952148, -1.48143062746593, 218, 13, 'PPL', 'P'),
(34042, 'Springvale', 37.5119400024414, 0.654706861853172, -98.9458312988281, -1.72693053728741, 218, 20, 'PPL', 'P'),
(51652, 'Springvale', 39.476390838623, 0.688992996938098, -77.6741714477539, -1.35567003552188, 218, 25, 'PPL', 'P'),
(74396, 'Springvale', 39.2272186279297, 0.684644121457025, -84.1958312988281, -1.46949447261824, 218, 41, 'PPL', 'P'),
(79190, 'Springvale', 39.894718170166, 0.696294186224604, -76.583610534668, -1.33663615689497, 218, 45, 'PPL', 'P'),
(90999, 'Springvale', 36.1974983215332, 0.631765526695875, -83.2061080932617, -1.45222054399772, 218, 50, 'PPL', 'P'),
(106516, 'Springvale', 38.7738914489746, 0.676732069595482, -77.1947174072266, -1.34730198390268, 218, 53, 'PPL', 'P'),
(128969, 'Springvale', 43.4666709899902, 0.758636523656433, -70.7941665649414, -1.23559129776351, 218, 26, 'PPL', 'P'),
(138240, 'Springvale', 45.6305618286133, 0.796403543444146, -93.3066711425781, -1.62850862551357, 218, 28, 'PPL', 'P'),
(152846, 'Springvale', 42.5194396972656, 0.742104218820466, -75.4738922119141, -1.31726791839321, 218, 40, 'PPL', 'P'),
(25060, 'Springview', 33.5916709899902, 0.586285260021993, -84.373893737793, -1.47260224845231, 218, 13, 'PPL', 'P'),
(51654, 'Springview', 39.2366714477539, 0.684809104286556, -75.8899993896484, -1.32453035868585, 218, 25, 'PPL', 'P'),
(90997, 'Springview', 35.8708305358887, 0.626064098276179, -86.8586120605469, -1.515968764169, 218, 50, 'PPL', 'P'),
(143109, 'Springview', 42.8244400024414, 0.747427478365371, -99.7486114501953, -1.74094169409842, 218, 35, 'PPL', 'P'),
(6035, 'Springville', 33.7750015258789, 0.589484981492696, -86.4716720581055, -1.50921538711872, 218, 2, 'PPL', 'P'),
(18183, 'Springville', 30.2924995422363, 0.528703855670899, -82.7636108398438, -1.44449750999454, 218, 12, 'PPL', 'P'),
(28678, 'Springville', 37.374439239502, 0.652307020815875, -89.2675018310547, -1.55801182198197, 218, 18, 'PPL', 'P'),
(43182, 'Springville', 30.4352798461914, 0.531195842081913, -90.6830596923828, -1.58271796741464, 218, 22, 'PPL', 'P'),
(61858, 'Springville', 34.2316703796387, 0.597455356582112, -89.1036071777344, -1.55515132065512, 218, 30, 'PPL', 'P'),
(71429, 'Springville', 39.9372215270996, 0.697036009746246, -74.8683319091797, -1.30669889729112, 218, 37, 'PPL', 'P'),
(90998, 'Springville', 36.2491683959961, 0.632667339620004, -88.1530609130859, -1.53856115864447, 218, 50, 'PPL', 'P'),
(106517, 'Springville', 37.1963882446289, 0.649199444718888, -81.4030609130859, -1.42075143413485, 218, 53, 'PPL', 'P'),
(117882, 'Springville', 42.059440612793, 0.734075720240259, -91.442497253418, -1.59597265331802, 218, 16, 'PPL', 'P'),
(123717, 'Springville', 41.6852798461914, 0.727545382931275, -86.7366714477539, -1.51384049898386, 218, 19, 'PPL', 'P'),
(133231, 'Springville', 42.0333290100098, 0.733619986798719, -84.1711120605469, -1.46906304052165, 218, 27, 'PPL', 'P'),
(152848, 'Springville', 40.8675003051758, 0.713272437385105, -72.5283279418945, -1.26585812355226, 218, 40, 'PPL', 'P'),
(157774, 'Springville', 40.7361106872559, 0.710979255949465, -82.0327835083008, -1.43174216679555, 218, 41, 'PPL', 'P'),
(167529, 'Springville', 40.1833305358887, 0.701331422268435, -76.8666687011719, -1.34157645387512, 218, 45, 'PPL', 'P'),
(176507, 'Springville', 43.583610534668, 0.760677503736842, -90.9397201538086, -1.5871975375262, 218, 57, 'PPL', 'P'),
(185340, 'Springville', 34.2205581665039, 0.597261411875727, -119.095001220703, -2.07859989396794, 218, 6, 'PPL', 'P'),
(205887, 'Springville', 40.1652793884277, 0.701016370311478, -111.610000610352, -1.94796198880352, 218, 52, 'PPL', 'P'),
(83797, 'Springville (historical)', 34.3408317565918, 0.599360582025955, -79.8547210693359, -1.3937278059216, 218, 48, 'PPL', 'P'),
(6036, 'Springville Lake Estates', 33.791389465332, 0.58977100499377, -86.51611328125, -1.50999103278621, 218, 2, 'PPL', 'P'),
(117883, 'Springwater', 43.3797187805176, 0.757118921309251, -91.7427825927734, -1.60121362118524, 218, 16, 'PPL', 'P'),
(152850, 'Springwater', 42.6372184753418, 0.744159846286871, -77.5961074829102, -1.35430756230819, 218, 40, 'PPL', 'P'),
(201592, 'Springwater', 45.2508316040039, 0.789776000755375, -122.338333129883, -2.13520671451811, 218, 43, 'PPL', 'P'),
(197604, 'Springwater Colony', 46.4594383239746, 0.810870167380593, -109.755561828613, -1.91559592628551, 218, 31, 'PPL', 'P'),
(25061, 'Springwater Plantation Subdivision', 33.4347190856934, 0.583545932524737, -84.6958312988281, -1.47822111887822, 218, 13, 'PPL', 'P'),
(133233, 'Springwell Heights', 45.4336090087891, 0.792966068267126, -84.6900024414063, -1.47811938612458, 218, 27, 'PPL', 'P'),
(51656, 'Springwood', 39.0633316040039, 0.681783753288226, -77.0202789306641, -1.34425745814451, 218, 25, 'PPL', 'P'),
(69036, 'Springwood', 35.2724990844727, 0.615621244430733, -81.0630569458008, -1.41481724543588, 218, 33, 'PPL', 'P'),
(106518, 'Springwood', 37.5488891601563, 0.655351746311135, -79.745002746582, -1.39181285993978, 218, 53, 'PPL', 'P'),
(83799, 'Springwood Lakes', 34.6866683959961, 0.605396570057592, -81.2402801513672, -1.41791037388395, 218, 48, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(25062, 'Springwood Valley', 33.5627784729004, 0.585780990469586, -84.2402801513672, -1.47027025144378, 218, 13, 'PPL', 'P'),
(197606, 'Sprinkle Trailer Court', 48.5900001525879, 0.848055486207206, -109.230560302734, -1.90643292108093, 218, 31, 'PPL', 'P'),
(25064, 'Sprite', 34.288330078125, 0.598444254873886, -85.3958282470703, -1.49043837037895, 218, 13, 'PPL', 'P'),
(197605, 'Sprole', 48.1072196960449, 0.83962937767625, -105.062782287598, -1.83369147222456, 218, 31, 'PPL', 'P'),
(6037, 'Sprott', 32.6766700744629, 0.570315481387278, -87.2213897705078, -1.52230042966066, 218, 2, 'PPL', 'P'),
(57692, 'Sprott', 37.8638916015625, 0.660849576065495, -90.3283309936523, -1.57652678367047, 218, 29, 'PPL', 'P'),
(157775, 'Sprotts Corners', 41.166389465332, 0.718489037328352, -81.2544403076172, -1.41815751523311, 218, 41, 'PPL', 'P'),
(111513, 'Sproul', 38.2511100769043, 0.667607813384761, -81.7955627441406, -1.42760188340686, 218, 58, 'PPL', 'P'),
(167533, 'Sproul', 40.2724990844727, 0.70288770703045, -78.4608306884766, -1.36939982936373, 218, 45, 'PPL', 'P'),
(106519, 'Sprouses Corner', 37.5291709899902, 0.655007599319269, -78.4922180175781, -1.36994764159995, 218, 53, 'PPL', 'P'),
(38341, 'Sprout', 38.3019409179688, 0.668494978922894, -83.8866729736328, -1.46409864193364, 218, 21, 'PPL', 'P'),
(152852, 'Sprout Brook', 42.850830078125, 0.7478880720759, -74.6855621337891, -1.30350896293742, 218, 40, 'PPL', 'P'),
(14661, 'Spruance City', 39.2944412231445, 0.68581737707526, -75.6166687011719, -1.31975983822519, 218, 10, 'PPL', 'P'),
(57693, 'Spruce', 38.2663917541504, 0.667874528967933, -94.133056640625, -1.64293177334522, 218, 29, 'PPL', 'P'),
(111514, 'Spruce', 38.4566688537598, 0.671195490847262, -79.9561080932617, -1.3954973433079, 218, 58, 'PPL', 'P'),
(133235, 'Spruce', 45.9858283996582, 0.80260411483115, -87.7772216796875, -1.53200152656349, 218, 27, 'PPL', 'P'),
(138242, 'Spruce', 47.4275016784668, 0.827766060284383, -92.5627822875977, -1.61552531572527, 218, 28, 'PPL', 'P'),
(167532, 'Spruce', 40.6797218322754, 0.709995084768626, -78.8583297729492, -1.37633749716144, 218, 45, 'PPL', 'P'),
(176510, 'Spruce', 44.9524993896484, 0.784569121350107, -88.1647186279297, -1.53876462415175, 218, 57, 'PPL', 'P'),
(187387, 'Spruce', 39.1566696166992, 0.683412808927027, -104.877777099609, -1.83046252256089, 218, 7, 'PPL', 'P'),
(200214, 'Spruce', 40.7983283996582, 0.712065159883945, -114.657501220703, -2.00115090841069, 218, 39, 'PPL', 'P'),
(185341, 'Spruce (historical)', 39.3158302307129, 0.686190685681062, -120.42749786377, -2.10185634766122, 218, 6, 'PPL', 'P'),
(138243, 'Spruce Center', 46.0705604553223, 0.804082968184471, -95.2233276367188, -1.66196059196605, 218, 28, 'PPL', 'P'),
(126239, 'Spruce Corner', 42.5022201538086, 0.741803681091451, -72.8472213745117, -1.27142386391442, 218, 23, 'PPL', 'P'),
(114116, 'Spruce Corner (historical)', 41.3313903808594, 0.721368846573109, -72.5875015258789, -1.26689089742299, 218, 8, 'PPL', 'P'),
(167534, 'Spruce Creek', 40.6094398498535, 0.708768432770536, -78.1358337402344, -1.36372756255797, 218, 45, 'PPL', 'P'),
(146387, 'Spruce Gardens', 40.0691719055176, 0.699338978298892, -74.2094421386719, -1.29519910138805, 218, 37, 'PPL', 'P'),
(79191, 'Spruce Grove', 39.8066711425781, 0.694757475696601, -76.0672225952148, -1.32762348713393, 218, 45, 'PPL', 'P'),
(128970, 'Spruce Head', 44.0113906860352, 0.768143675852879, -69.1333312988281, -1.2066042540366, 218, 26, 'PPL', 'P'),
(51657, 'Spruce Hill', 38.3600006103516, 0.669508311717669, -76.4661102294922, -1.33458538969756, 218, 25, 'PPL', 'P'),
(106520, 'Spruce Hill', 37.3722190856934, 0.652268271822014, -80.0325012207031, -1.39683065490765, 218, 53, 'PPL', 'P'),
(167536, 'Spruce Hill', 41.1986083984375, 0.719051363792522, -75.225830078125, -1.31293841740906, 218, 45, 'PPL', 'P'),
(51658, 'Spruce Hill Estates', 39.0550003051758, 0.681638344692708, -76.647216796875, -1.33774629559537, 218, 25, 'PPL', 'P'),
(6038, 'Spruce Pine', 34.3919410705566, 0.600252607833077, -87.7263870239258, -1.53111429444633, 218, 2, 'PPL', 'P'),
(38342, 'Spruce Pine', 36.9233283996582, 0.644433651369164, -83.4452819824219, -1.45639491584836, 218, 21, 'PPL', 'P'),
(69037, 'Spruce Pine', 35.9152793884277, 0.626839877101719, -82.0647201538086, -1.43229956641171, 218, 33, 'PPL', 'P'),
(91000, 'Spruce Pine', 36.3869400024414, 0.635071907768236, -83.2136077880859, -1.4523514383653, 218, 50, 'PPL', 'P'),
(193973, 'Spruce Point', 40.7433280944824, 0.711105223469026, -124.196670532227, -2.16764082080197, 218, 6, 'PPL', 'P'),
(146389, 'Spruce Run', 40.708610534668, 0.710499287742005, -74.9225006103516, -1.3076443194781, 218, 37, 'PPL', 'P'),
(128971, 'Spruce Shores', 43.8280601501465, 0.764943954382176, -69.5961074829102, -1.21468122214865, 218, 26, 'PPL', 'P'),
(111515, 'Spruce Valley', 37.8847198486328, 0.66121309755429, -81.8247222900391, -1.42811081349118, 218, 58, 'PPL', 'P'),
(179207, 'Sprucedale', 33.7402801513672, 0.588878979186648, -109.326393127441, -1.90810551940355, 218, 5, 'PPL', 'P'),
(187389, 'Sprucedale', 39.5888900756836, 0.690956479030786, -105.351669311523, -1.83873350195835, 218, 7, 'PPL', 'P'),
(200216, 'Sprucemont', 40.5505599975586, 0.707740785484901, -114.871391296387, -2.00488399446871, 218, 39, 'PPL', 'P'),
(79193, 'Spruces', 39.9636116027832, 0.697496603456775, -75.8194427490234, -1.3232989129978, 218, 45, 'PPL', 'P'),
(152853, 'Spruceton', 42.1916694641113, 0.736383549061894, -74.3080596923828, -1.29692030240056, 218, 40, 'PPL', 'P'),
(79194, 'Sprucetown', 39.7527809143066, 0.693816913778613, -79.9108276367188, -1.39470705025442, 218, 45, 'PPL', 'P'),
(157776, 'Sprucevale', 40.7069396972656, 0.710470126128069, -80.5819396972656, -1.40642016536081, 218, 41, 'PPL', 'P'),
(83800, 'Sprucewood', 32.9472198486328, 0.57503746573707, -80.216667175293, -1.40004495718532, 218, 48, 'PPL', 'P'),
(187388, 'Sprucewood', 39.3488883972168, 0.686767659531227, -105.120277404785, -1.8346949513233, 218, 7, 'PPL', 'P'),
(128972, 'Spruceworld', 43.8416709899902, 0.765181508351412, -69.6208267211914, -1.21511265424524, 218, 26, 'PPL', 'P'),
(12094, 'Sprudel', 33.6163902282715, 0.586716692118586, -93.7663879394531, -1.63653219724576, 218, 4, 'PPL', 'P'),
(38343, 'Sprule', 37.0161094665527, 0.646052986469987, -83.8497161865234, -1.46345362431762, 218, 21, 'PPL', 'P'),
(79195, 'Spry', 39.9183311462402, 0.696706310403294, -76.6852798461914, -1.33841062112929, 218, 45, 'PPL', 'P'),
(192799, 'Spry', 38.021671295166, 0.663603351211664, -112.363327026367, -1.96111001510524, 218, 52, 'PPL', 'P'),
(51660, 'Spry Landing', 39.2438888549805, 0.684935071806117, -75.9530563354492, -1.32563091000633, 218, 25, 'PPL', 'P'),
(18184, 'Spuds', 29.7394409179688, 0.51905116172088, -81.4716720581055, -1.42194892451901, 218, 12, 'PPL', 'P'),
(74398, 'Spunkeytown (historical)', 39.5991706848145, 0.69113590950923, -82.9722213745117, -1.44813845067884, 218, 41, 'PPL', 'P'),
(157777, 'Spunky Puddle (historical)', 40.0119400024414, 0.69834009315303, -83.7919387817383, -1.46244521837086, 218, 41, 'PPL', 'P'),
(897, 'Spur', 34.1680603027344, 0.596345151302685, -80.2983322143555, -1.40147028100073, 218, 48, 'PPL', 'P'),
(192973, 'Spur', 33.476390838623, 0.584273241818438, -100.855278015137, -1.76025666937839, 218, 51, 'PPL', 'P'),
(57695, 'Spur 3 (historical)', 37.2208290100098, 0.649626016546492, -91.4766693115234, -1.59656906824414, 218, 29, 'PPL', 'P'),
(179208, 'Spur Cross', 33.1833305358887, 0.579158374628832, -109.457221984863, -1.91038891372219, 218, 5, 'PPL', 'P'),
(12095, 'Spur Four', 35.6191711425781, 0.621671813269339, -90.0888900756836, -1.57234775128792, 218, 4, 'PPL', 'P'),
(189602, 'Spur Lake', 33.9930610656738, 0.593290838427501, -108.875282287598, -1.90023214995684, 218, 38, 'PPL', 'P'),
(31200, 'Spurgeon', 38.2522201538086, 0.667627187881692, -87.2572174072266, -1.52292573988461, 218, 19, 'PPL', 'P'),
(57696, 'Spurgeon', 36.934440612793, 0.644627596075549, -94.4713897705078, -1.64883680043025, 218, 29, 'PPL', 'P'),
(91001, 'Spurgeon', 36.4394416809082, 0.635988234920305, -82.4558334350586, -1.4391257809178, 218, 50, 'PPL', 'P'),
(111516, 'Spurgeon', 39.100830078125, 0.682438225126113, -80.7805633544922, -1.40988680215176, 218, 58, 'PPL', 'P'),
(69038, 'Spurgeon (historical)', 36.0916709899902, 0.629918491321851, -81.0258331298828, -1.41416756728796, 218, 33, 'PPL', 'P'),
(31201, 'Spurgeons Corner', 39.0708312988281, 0.681914647655803, -86.1449966430664, -1.50351382554097, 218, 19, 'PPL', 'P'),
(98260, 'Spurger', 30.6924991607666, 0.535685166020974, -94.1774978637695, -1.6437074190127, 218, 51, 'PPL', 'P'),
(199697, 'Spurior Place', 42.144718170166, 0.735564094394477, -103.904998779297, -1.81348433797942, 218, 35, 'PPL', 'P'),
(98261, 'Spurlin', 31.8436107635498, 0.55577585354745, -98.1386108398438, -1.71284188248867, 218, 51, 'PPL', 'P'),
(197607, 'Spurling', 45.6505584716797, 0.796752550705001, -108.844718933105, -1.8996987187905, 218, 31, 'PPL', 'P'),
(38344, 'Spurlington', 37.4122200012207, 0.652966419501778, -85.2747192382813, -1.48832461942176, 218, 21, 'PPL', 'P'),
(38345, 'Spurlock', 37.211669921875, 0.64946616030206, -83.6347198486328, -1.4597012303417, 218, 21, 'PPL', 'P'),
(179209, 'Spurlock', 34.1483306884766, 0.596000804573738, -111.031669616699, -1.93786820879795, 218, 5, 'PPL', 'P'),
(205890, 'Spurlock', 41.267219543457, 0.720248854176676, -111.826942443848, -1.95174833808334, 218, 52, 'PPL', 'P'),
(111517, 'Spurlockville', 38.1261100769043, 0.665426151819769, -82.021110534668, -1.43153843497216, 218, 58, 'PPL', 'P'),
(38346, 'Spurrier', 37.4744415283203, 0.654052390015285, -86.0541687011719, -1.5019285789021, 218, 21, 'PPL', 'P'),
(128973, 'Spurrs Corner', 44.0563888549805, 0.768929042058344, -70.5566711425781, -1.23144622068486, 218, 26, 'PPL', 'P'),
(143094, 'Spurville', 42.0188903808594, 0.73336798518057, -97.2138900756836, -1.69670246049252, 218, 35, 'PPL', 'P'),
(152854, 'Spuyten Duyvil', 40.8811111450195, 0.71350999135434, -73.9177780151367, -1.29010860212241, 218, 40, 'PPL', 'P'),
(111518, 'Spy Rock', 38.0699996948242, 0.664446840907919, -80.977783203125, -1.41332893786069, 218, 58, 'PPL', 'P'),
(51661, 'Spyglass', 38.7999992370605, 0.677187736457994, -76.5400009155273, -1.33587502545543, 218, 25, 'PPL', 'P'),
(25066, 'Spyglass Hill', 33.3933296203613, 0.582823550079053, -84.5688934326172, -1.47600563516738, 218, 13, 'PPL', 'P'),
(43183, 'Spyker', 32.7422218322754, 0.571459575391576, -91.95361328125, -1.6048933108634, 218, 22, 'PPL', 'P'),
(185342, 'Spyrock', 39.8766708374023, 0.695979200846675, -123.442779541016, -2.15448294080422, 218, 6, 'PPL', 'P'),
(185343, 'Squab', 38.1972198486328, 0.666667251466773, -122.276390075684, -2.1341256042736, 218, 6, 'PPL', 'P'),
(167539, 'Squab Hollow', 41.351390838623, 0.721717920412991, -78.6675033569336, -1.37300694790218, 218, 45, 'PPL', 'P'),
(185344, 'Squabbletown', 38.014720916748, 0.663482044224011, -120.385276794434, -2.10111945098759, 218, 6, 'PPL', 'P'),
(144500, 'Squag City', 43.5161094665527, 0.759499387849618, -72.371940612793, -1.26312864975104, 218, 36, 'PPL', 'P'),
(126240, 'Squam', 41.3166694641113, 0.721111918106944, -69.9916687011719, -1.22158506780051, 218, 23, 'PPL', 'P'),
(146388, 'Squankum', 40.1661109924316, 0.701030884539419, -74.154167175293, -1.29423437128317, 218, 37, 'PPL', 'P'),
(126242, 'Squantum', 42.2958297729492, 0.738201489401009, -71.0124969482422, -1.23940188180925, 218, 23, 'PPL', 'P'),
(144501, 'Squantum', 42.7905616760254, 0.746836190024346, -71.9861068725586, -1.25639458061867, 218, 36, 'PPL', 'P'),
(128974, 'Squapan', 46.563060760498, 0.812678720076866, -68.3786087036133, -1.1934318598109, 218, 26, 'PPL', 'P'),
(197608, 'Square Butte', 47.5149993896484, 0.829293183432461, -110.19750213623, -1.92330923975071, 218, 31, 'PPL', 'P'),
(79196, 'Square Corner', 39.809440612793, 0.694805812070386, -77.1063919067383, -1.34576041310569, 218, 45, 'PPL', 'P'),
(197609, 'Square Deal (historical)', 48.0380592346191, 0.838422299912171, -106.465827941895, -1.85817923844784, 218, 31, 'PPL', 'P'),
(77321, 'Squaretop', 35.0752792358398, 0.612179108721806, -98.3013916015625, -1.71568294273957, 218, 42, 'PPL', 'P'),
(152855, 'Squassux Landing', 40.7730598449707, 0.711624140407428, -72.8997192382813, -1.27234012448746, 218, 40, 'PPL', 'P'),
(117884, 'Squaw Creek Village', 42.038890838623, 0.733717059020452, -91.5458297729492, -1.59777614600822, 218, 16, 'PPL', 'P'),
(192800, 'Squaw Crossing', 39.9688911437988, 0.697588748830492, -109.668609619141, -1.91407832393833, 218, 52, 'PPL', 'P'),
(198943, 'Squaw Gap', 47.4888916015625, 0.828837516569949, -103.926940917969, -1.81386730054417, 218, 34, 'PPL', 'P'),
(212160, 'Squaw Harbor', 55.2433280944824, 0.964177965008203, -160.553329467773, -2.80218422425188, 218, 1, 'PPL', 'P'),
(185345, 'Squaw Hill', 39.9080581665039, 0.696527013082905, -122.091941833496, -2.13090637514791, 218, 6, 'PPL', 'P'),
(209754, 'Squaw Hollow (historical)', 41.1636085510254, 0.718440501217485, -109.559722900391, -1.91217789218445, 218, 59, 'PPL', 'P'),
(138250, 'Squaw Lake', 47.6324996948242, 0.831343950629877, -94.1361083984375, -1.64298503656702, 218, 28, 'PPL', 'P'),
(98262, 'Squaw Mountain', 33.3611106872559, 0.582261223614883, -98.320556640625, -1.71601743577248, 218, 51, 'PPL', 'P'),
(179210, 'Squaw Peak Terrace', 33.4958305358887, 0.584612528541314, -112.014717102051, -1.95502562412079, 218, 5, 'PPL', 'P'),
(209753, 'Squaw Place', 42.3699989318848, 0.73949598542787, -105.703330993652, -1.8448711561646, 218, 59, 'PPL', 'P'),
(185346, 'Squaw Valley', 36.7402801513672, 0.641238856746478, -119.245826721191, -2.08123229554742, 218, 6, 'PPL', 'P'),
(91002, 'Squawberry', 36.1305618286133, 0.630597264504685, -82.0694427490234, -1.43238199124745, 218, 50, 'PPL', 'P'),
(74399, 'Squawtown (historical)', 39.5091705322266, 0.689565110519274, -82.9833297729492, -1.4483323288062, 218, 41, 'PPL', 'P'),
(185347, 'Squeaky Springs (historical)', 33.2577781677246, 0.580457730924681, -115.94750213623, -2.02366567174038, 218, 6, 'PPL', 'P'),
(43184, 'Squealer Point Landing', 30.9752807617188, 0.540620636021649, -92.416389465332, -1.61297027897545, 218, 22, 'PPL', 'P'),
(38347, 'Squib', 37.1552810668945, 0.648481989121221, -84.3266677856445, -1.47177800009493, 218, 21, 'PPL', 'P'),
(126243, 'Squibnocket', 41.3069381713867, 0.720942075008424, -70.7750015258789, -1.2352568047306, 218, 23, 'PPL', 'P'),
(138252, 'Squier', 46.1375007629395, 0.805251296954689, -96.0813903808594, -1.67693661204, 218, 28, 'PPL', 'P'),
(111519, 'Squire', 37.2383308410645, 0.649931481123524, -81.6100006103516, -1.42436321320522, 218, 58, 'PPL', 'P'),
(83802, 'Squire Estates', 34.9116706848145, 0.609323600821996, -81.0680618286133, -1.41490459711964, 218, 48, 'PPL', 'P'),
(106521, 'Squire Hill', 38.0750007629395, 0.664534126012646, -78.470832824707, -1.36957439957318, 218, 53, 'PPL', 'P'),
(51662, 'Squires', 39.3983306884766, 0.68763059030344, -76.9161071777344, -1.34243931806831, 218, 25, 'PPL', 'P'),
(57697, 'Squires', 36.851390838623, 0.643178104073246, -92.6247177124023, -1.61660629281173, 218, 29, 'PPL', 'P'),
(83801, 'Squires', 34.3013916015625, 0.598672221463197, -79.2452774047852, -1.38309100736977, 218, 48, 'PPL', 'P'),
(157778, 'Squires', 41.2552795410156, 0.720040461821378, -83.3516693115234, -1.4547610665196, 218, 41, 'PPL', 'P'),
(51663, 'Squires Woods', 38.7833290100098, 0.676896786108903, -76.9688873291016, -1.34336050548937, 218, 25, 'PPL', 'P'),
(38348, 'Squiresville', 38.5422210693359, 0.672688658691442, -84.954719543457, -1.4827395711417, 218, 21, 'PPL', 'P'),
(152856, 'Squiretown', 40.894718170166, 0.713747478744548, -72.5269393920898, -1.26583388878634, 218, 40, 'PPL', 'P'),
(195645, 'Squirrel', 44.0272216796875, 0.768419978815975, -111.298332214355, -1.94252234911897, 218, 17, 'PPL', 'P'),
(25067, 'Squirrel Creek', 34.3800010681152, 0.600044215477778, -83.8727798461914, -1.46385616111638, 218, 13, 'PPL', 'P'),
(185348, 'Squirrel Creek (historical)', 39.7947196960449, 0.694548883604221, -120.716667175293, -2.10690330424303, 218, 6, 'PPL', 'P'),
(91003, 'Squirrel Flat', 36.4905586242676, 0.636880393885482, -84.9694366455078, -1.48299643302884, 218, 50, 'PPL', 'P'),
(167541, 'Squirrel Hill', 41.0386085510254, 0.716258839652492, -79.4119415283203, -1.38599984507041, 218, 45, 'PPL', 'P'),
(185349, 'Squirrel Mountain Valley', 35.6233291625977, 0.621744384409044, -118.408889770508, -2.06662499012639, 218, 6, 'PPL', 'P'),
(74400, 'Squirrel Town', 38.6972198486328, 0.675393897726744, -83.3794403076172, -1.45524576183799, 218, 41, 'PPL', 'P'),
(152857, 'Squirrels Corners', 41.5994415283203, 0.726047221660051, -74.75, -1.30463361586576, 218, 40, 'PPL', 'P'),
(83803, 'St. Andrews', 34.0486106872559, 0.594260362222344, -81.1033325195313, -1.41552018680561, 218, 48, 'PPL', 'P'),
(138253, 'St. Augusta', 45.4583282470703, 0.793397500363719, -94.1977767944336, -1.64406135312158, 218, 28, 'PPL', 'P'),
(205893, 'St. Benedict Manor Condominiums', 41.2097206115723, 0.719245308498907, -111.937782287598, -1.95368285829917, 218, 52, 'PPL', 'P'),
(152858, 'St. Bonaventure', 42.0802803039551, 0.734439441466136, -78.4752807617188, -1.36965203071896, 218, 40, 'PPL', 'P'),
(133238, 'St. Clair', 42.8208312988281, 0.747364494605591, -82.4861068725586, -1.43965415207807, 218, 27, 'PPL', 'P'),
(133239, 'St. Clair Shores', 42.496940612793, 0.741711535717734, -82.8888931274414, -1.44668409840755, 218, 27, 'PPL', 'P'),
(38349, 'St. Dennis', 38.1883316040039, 0.666512122333276, -85.845832824707, -1.49829243190776, 218, 21, 'PPL', 'P'),
(61860, 'St. Martin', 30.437780380249, 0.531239484634277, -88.8680572509766, -1.55104019888036, 218, 30, 'PPL', 'P'),
(51664, 'St. Marys City', 38.186939239502, 0.666487820988329, -76.4347229003906, -1.33403757746133, 218, 25, 'PPL', 'P'),
(69039, 'St. Stephens', 35.7644386291504, 0.624207209206122, -81.2733306884766, -1.41848721457607, 218, 33, 'PPL', 'P'),
(176513, 'Staadts (historical)', 44.7791709899902, 0.781543970088858, -90.120002746582, -1.57289076983419, 218, 57, 'PPL', 'P'),
(152859, 'Staatsburg', 41.8497200012207, 0.730415405059027, -73.9305572509766, -1.29033164186371, 218, 40, 'PPL', 'P'),
(38350, 'Stab', 37.1513900756836, 0.648414078513424, -84.4369430541992, -1.47370266661473, 218, 21, 'PPL', 'P'),
(51665, 'Stab', 39.292781829834, 0.685788415198405, -76.5197219848633, -1.33552109134655, 218, 25, 'PPL', 'P'),
(208818, 'Stabler', 45.8083305358887, 0.799506192693116, -121.906387329102, -2.12766783810432, 218, 56, 'PPL', 'P'),
(51666, 'Stablers Manor', 39.6599998474121, 0.69219757867779, -76.6544418334961, -1.33787239627299, 218, 25, 'PPL', 'P'),
(51667, 'Stablersville', 39.6505584716797, 0.692032795585341, -76.6161117553711, -1.33720341020716, 218, 25, 'PPL', 'P'),
(31202, 'Stacer', 38.148609161377, 0.665818834922501, -87.5666732788086, -1.52832676373335, 218, 19, 'PPL', 'P'),
(69040, 'Stacey', 36.4280586242676, 0.635789563102985, -79.581672668457, -1.38896221230896, 218, 33, 'PPL', 'P'),
(197610, 'Stacey', 45.7200012207031, 0.797964555317096, -105.890556335449, -1.84813885482213, 218, 31, 'PPL', 'P'),
(18185, 'Stacey Street', 26.6980590820313, 0.46596903487342, -80.123893737793, -1.39842575524255, 218, 12, 'PPL', 'P'),
(69041, 'Stackhouse', 35.8813896179199, 0.626248389023613, -82.7699966430664, -1.44460896328616, 218, 33, 'PPL', 'P'),
(6042, 'Stacks Hill (historical)', 33.1041717529297, 0.577776793234326, -87.0994415283203, -1.52017203131747, 218, 2, 'PPL', 'P'),
(167542, 'Stacktown', 40.0888900756836, 0.699683125290757, -76.6405563354492, -1.33763004861379, 218, 45, 'PPL', 'P'),
(985, 'Stacy', 36.4302787780762, 0.635828312096846, -82.795280456543, -1.44505024907879, 218, 50, 'PPL', 'P'),
(12101, 'Stacy', 35.6783294677734, 0.622704320823963, -90.5708312988281, -1.58075921243288, 218, 4, 'PPL', 'P'),
(38351, 'Stacy', 37.4030609130859, 0.652806563257346, -83.2102813720703, -1.45229338145353, 218, 21, 'PPL', 'P'),
(43185, 'Stacy', 31.6025009155273, 0.551567692840475, -91.6902770996094, -1.60029722745414, 218, 22, 'PPL', 'P'),
(69042, 'Stacy', 34.8497200012207, 0.608242357419424, -76.4161071777344, -1.33371267180834, 218, 33, 'PPL', 'P'),
(98263, 'Stacy', 31.4769401550293, 0.549376244158476, -99.5975036621094, -1.73830436567092, 218, 51, 'PPL', 'P'),
(106522, 'Stacy', 37.3208312988281, 0.651371385745903, -81.9963912963867, -1.43110700287557, 218, 53, 'PPL', 'P'),
(138254, 'Stacy', 45.3980598449707, 0.792345618312165, -92.9872207641602, -1.62293316461343, 218, 28, 'PPL', 'P'),
(193974, 'Stacy', 40.2299995422363, 0.702145950087836, -120.020278930664, -2.09474903650207, 218, 6, 'PPL', 'P'),
(157779, 'Stacy (historical)', 40.327220916748, 0.703842783176379, -81.0555572509766, -1.4146863510683, 218, 41, 'PPL', 'P'),
(152860, 'Stacy Basin', 43.1944389343262, 0.753885177955622, -75.6224975585938, -1.31986157097883, 218, 40, 'PPL', 'P'),
(172589, 'Stacy Crossroads', 43.7550010681152, 0.763668832852247, -73.3099975585938, -1.27950083202647, 218, 55, 'PPL', 'P'),
(38352, 'Stacy Fork', 37.8413887023926, 0.660456826383735, -83.2574996948242, -1.45311749665286, 218, 21, 'PPL', 'P'),
(43186, 'Stacy Landing', 32.7730598449707, 0.571997800247881, -94.021110534668, -1.64097794521148, 218, 22, 'PPL', 'P'),
(117886, 'Stacyville', 43.4361114501953, 0.758103159069117, -92.7822189331055, -1.61935520768891, 218, 16, 'PPL', 'P'),
(128976, 'Stacyville', 45.8636093139648, 0.800470989377024, -68.5058288574219, -1.19565227036976, 218, 26, 'PPL', 'P'),
(117887, 'Stacyville Junction', 43.4458312988281, 0.758272802430555, -92.932502746582, -1.62197815504653, 218, 16, 'PPL', 'P'),
(25070, 'Stadium Club', 32.4097213745117, 0.565656347639212, -81.7797164916992, -1.42732531412766, 218, 13, 'PPL', 'P'),
(6039, 'Stadium Place', 31.2083301544189, 0.544688115244041, -85.3819427490234, -1.49019602271976, 218, 2, 'PPL', 'P'),
(25068, 'Stadium Walk', 32.413890838623, 0.565729118515998, -81.779167175293, -1.42731572674773, 218, 13, 'PPL', 'P'),
(198944, 'Stady', 48.7205581665039, 0.850334153414905, -103.705558776855, -1.81000345327663, 218, 34, 'PPL', 'P'),
(98264, 'Staff', 32.3591690063477, 0.564774042370068, -98.7061080932617, -1.72274657805684, 218, 51, 'PPL', 'P'),
(12102, 'Stafford', 35.1563911437988, 0.613594778578265, -93.4300003051758, -1.63066112546462, 218, 4, 'PPL', 'P'),
(25069, 'Stafford', 30.8152809143066, 0.53782811188162, -81.4672164916992, -1.42187116021518, 218, 13, 'PPL', 'P'),
(34043, 'Stafford', 37.9622192382813, 0.662565717071942, -98.6002807617188, -1.72089954268281, 218, 20, 'PPL', 'P'),
(51670, 'Stafford', 38.9716682434082, 0.680183925842388, -76.8877792358398, -1.34194490221194, 218, 25, 'PPL', 'P'),
(74402, 'Stafford', 39.7133293151855, 0.693128353478773, -81.2763900756836, -1.41854061095592, 218, 41, 'PPL', 'P'),
(77322, 'Stafford', 35.5366706848145, 0.62023190864696, -99.1216735839844, -1.72999956412762, 218, 42, 'PPL', 'P'),
(83804, 'Stafford', 32.6699981689453, 0.570199034668614, -81.1650009155273, -1.41659650336016, 218, 48, 'PPL', 'P'),
(98265, 'Stafford', 29.6158294677734, 0.516893734921806, -95.557502746582, -1.66779304791138, 218, 51, 'PPL', 'P'),
(106523, 'Stafford', 38.4219398498535, 0.67058935538316, -77.4086074829102, -1.3510350699607, 218, 53, 'PPL', 'P'),
(112208, 'Stafford', 33.4466705322266, 0.583754524617118, -88.245002746582, -1.5401658463593, 218, 2, 'PPL', 'P'),
(114117, 'Stafford', 41.9847183227539, 0.732771570254447, -72.289436340332, -1.26168867854963, 218, 8, 'PPL', 'P'),
(143095, 'Stafford', 42.3283309936523, 0.738768742713196, -98.4466705322266, -1.71821853841343, 218, 35, 'PPL', 'P'),
(152861, 'Stafford', 42.9816703796387, 0.750171666131616, -78.0741729736328, -1.36265137916146, 218, 40, 'PPL', 'P'),
(193975, 'Stafford', 40.4541702270508, 0.706058466624298, -124.05249786377, -2.16512453304601, 218, 6, 'PPL', 'P'),
(201593, 'Stafford', 45.3574981689453, 0.791637683515395, -122.721389770508, -2.14189231411865, 218, 43, 'PPL', 'P'),
(51668, 'Stafford (historical)', 39.6230583190918, 0.691552827377882, -76.165283203125, -1.32933496760846, 218, 25, 'PPL', 'P'),
(185350, 'Stafford (historical)', 39.226390838623, 0.684629673808112, -121.660827636719, -2.12338201296205, 218, 6, 'PPL', 'P'),
(123719, 'Stafford Center', 41.4083290100098, 0.722711678973754, -84.8319396972656, -1.48059665857057, 218, 19, 'PPL', 'P'),
(71439, 'Stafford Forge', 39.6669387817383, 0.692318685928361, -74.3197174072266, -1.29712376790785, 218, 37, 'PPL', 'P'),
(51669, 'Stafford Heights', 38.8583297729492, 0.678205796363704, -75.8180618286133, -1.32327481138993, 218, 25, 'PPL', 'P'),
(83805, 'Stafford Heights', 32.7208290100098, 0.571086200206747, -80.0716705322266, -1.39751428835947, 218, 48, 'PPL', 'P'),
(167543, 'Stafford Heights', 40.2591705322266, 0.702655079909231, -76.644172668457, -1.33769316553162, 218, 45, 'PPL', 'P'),
(106525, 'Stafford Place', 37.288890838623, 0.650813919550722, -77.4819412231445, -1.35231498518059, 218, 53, 'PPL', 'P'),
(61863, 'Stafford Springs', 31.9047203063965, 0.556842416274513, -88.9333267211914, -1.55217936603664, 218, 30, 'PPL', 'P'),
(114118, 'Stafford Springs', 41.9541702270508, 0.732238405404213, -72.3027801513672, -1.26192157198696, 218, 8, 'PPL', 'P'),
(91004, 'Staffords Store', 36.0961112976074, 0.629995989309572, -88.6941680908203, -1.54800526050211, 218, 50, 'PPL', 'P'),
(38353, 'Staffordsburg', 38.9136085510254, 0.679170593047613, -84.501106262207, -1.47482252585311, 218, 21, 'PPL', 'P'),
(106526, 'Staffordshire', 37.5349998474121, 0.655109332072911, -77.5858306884766, -1.35412819840878, 218, 53, 'PPL', 'P'),
(38354, 'Staffordsville', 37.829719543457, 0.660253161139371, -82.8422164916992, -1.4458694374301, 218, 21, 'PPL', 'P'),
(106527, 'Staffordsville', 37.2413902282715, 0.64998487750338, -80.7169418334961, -1.40877639713526, 218, 53, 'PPL', 'P'),
(91005, 'Staffordtown', 34.9980583190918, 0.610831349473144, -84.3886108398438, -1.47285911033945, 218, 50, 'PPL', 'P'),
(71431, 'Staffordville', 39.6661109924316, 0.692304238279448, -74.2811126708984, -1.29644998815206, 218, 37, 'PPL', 'P'),
(114120, 'Staffordville', 41.9938888549805, 0.732931626235961, -72.2591705322266, -1.26116044054742, 218, 8, 'PPL', 'P'),
(167544, 'Stafore Estates', 40.6619415283203, 0.709684759922605, -75.4047164916992, -1.31606057431302, 218, 45, 'PPL', 'P'),
(98266, 'Stag Creek', 32.0119400024414, 0.558713752993484, -98.7566680908203, -1.72362901648404, 218, 51, 'PPL', 'P'),
(69044, 'Stag Park', 34.524169921875, 0.602560436654712, -77.8450012207031, -1.35865157752027, 218, 33, 'PPL', 'P'),
(61862, 'Stage', 32.2825012207031, 0.563435937080358, -89.6350021362305, -1.56442591230937, 218, 30, 'PPL', 'P'),
(194431, 'Stage', 40.6116714477539, 0.708807381501478, -104.742218017578, -1.82809657024847, 218, 7, 'PPL', 'P'),
(106528, 'Stage Junction', 37.790828704834, 0.659574387956537, -78.1536102294922, -1.36403782082496, 218, 53, 'PPL', 'P'),
(14662, 'Stage Mobile Home Village', 38.4672203063965, 0.671379648436641, -75.5519409179688, -1.31863012529078, 218, 10, 'PPL', 'P'),
(14663, 'Stage Road Development', 39.7166709899902, 0.693186676706645, -75.732780456543, -1.32178637065669, 218, 10, 'PPL', 'P'),
(98267, 'Stagecoach', 30.1452808380127, 0.526134404561677, -95.7133331298828, -1.67051280117462, 218, 51, 'PPL', 'P'),
(190771, 'Stagecoach', 39.3738899230957, 0.687204018475837, -119.373062133789, -2.08345297242239, 218, 39, 'PPL', 'P'),
(12103, 'Stagecoach Addition', 34.9708290100098, 0.610356108376619, -91.9755630493164, -1.60527640658621, 218, 4, 'PPL', 'P'),
(69045, 'Stagecoach Forest', 36.0924987792969, 0.629932938970765, -79.1597213745117, -1.38159777294656, 218, 33, 'PPL', 'P'),
(121560, 'Stagecoach Hills', 42.4208297729492, 0.740383150966002, -88.980827331543, -1.55300840808398, 218, 18, 'PPL', 'P'),
(28679, 'Stagecoach Junction', 39.2186088562012, 0.684493852592518, -89.6141662597656, -1.56406225766252, 218, 18, 'PPL', 'P'),
(25071, 'Stagecoach Manor', 33.6094398498535, 0.586595385130932, -84.2652816772461, -1.47070661038839, 218, 13, 'PPL', 'P'),
(179211, 'Stagecoach Trailer Park', 33.452220916748, 0.583851397101769, -112.148887634277, -1.95736734166729, 218, 5, 'PPL', 'P'),
(133240, 'Stager', 45.9908294677734, 0.802691399935878, -88.3480606079102, -1.54196454535954, 218, 27, 'PPL', 'P'),
(139466, 'Stahl', 40.291389465332, 0.703217406373402, -92.7888870239258, -1.61947158782855, 218, 29, 'PPL', 'P'),
(199698, 'Stahlas North Court', 41.2377815246582, 0.719735063823373, -103.669441223145, -1.80937308304661, 218, 35, 'PPL', 'P'),
(167545, 'Stahlstown', 40.1500015258789, 0.700749721307334, -79.3330612182617, -1.38462312394489, 218, 45, 'PPL', 'P'),
(199699, 'Stahr Trailer Court', 41.0927810668945, 0.717204328418498, -102.470283508301, -1.78844383267189, 218, 35, 'PPL', 'P'),
(91006, 'Stainville', 36.207218170166, 0.631935170057313, -84.3141708374023, -1.47155988720166, 218, 50, 'PPL', 'P'),
(152863, 'Stairs Corners', 43.0061111450195, 0.750598237959219, -74.1527786254883, -1.29421013651725, 218, 40, 'PPL', 'P'),
(98268, 'Stairtown', 29.7180595397949, 0.518677986273132, -97.7275009155273, -1.70566666072173, 218, 51, 'PPL', 'P'),
(167546, 'Stairville', 41.1311111450195, 0.717873314484326, -76.0122222900391, -1.32666355071901, 218, 45, 'PPL', 'P'),
(91007, 'Stakely Mill', 35.4436111450195, 0.618607713277148, -84.3533325195313, -1.47224338749542, 218, 50, 'PPL', 'P'),
(152864, 'Stalbird', 44.4000015258789, 0.774926214517093, -75.206672668457, -1.31260405753421, 218, 40, 'PPL', 'P'),
(25072, 'Stalco', 32.5333290100098, 0.567813707859258, -81.5588912963867, -1.42347118739809, 218, 13, 'PPL', 'P'),
(38355, 'Stalcup', 36.7027816772461, 0.640584384908591, -85.4466705322266, -1.49132573565417, 218, 21, 'PPL', 'P'),
(31204, 'Stalcup Corner', 38.9944381713867, 0.680581336056055, -87.01611328125, -1.51871767904618, 218, 19, 'PPL', 'P'),
(185351, 'Stalder', 34.0219383239746, 0.593794841663798, -117.523612976074, -2.05117399527203, 218, 6, 'PPL', 'P'),
(69050, 'Staley', 35.7958297729492, 0.624755088021378, -79.5516662597656, -1.38843850168059, 218, 33, 'PPL', 'P'),
(77323, 'Staley', 33.8266716003418, 0.590386794416824, -96.5297164916992, -1.68476137879682, 218, 42, 'PPL', 'P'),
(98269, 'Staley', 30.833610534668, 0.538148024107565, -95.2919387817383, -1.66315808235021, 218, 51, 'PPL', 'P'),
(121561, 'Staley', 40.1130599975586, 0.700104970007426, -88.3125, -1.54134389566749, 218, 18, 'PPL', 'P'),
(193977, 'Staley', 41.8883285522461, 0.731089251393844, -121.379722595215, -2.11847580444386, 218, 6, 'PPL', 'P'),
(208819, 'Staley', 46.6697196960449, 0.814540269678831, -117.147499084473, -2.04460956950109, 218, 56, 'PPL', 'P'),
(83809, 'Staley Crossroads', 33.6691703796387, 0.587637879539644, -80.9611129760742, -1.4130379875116, 218, 48, 'PPL', 'P'),
(106529, 'Staley Crossroads', 36.9097213745117, 0.644196163978957, -81.2736129760742, -1.41849214142408, 218, 53, 'PPL', 'P'),
(25073, 'Staley Heights', 32.0327796936035, 0.559077474219362, -81.1205596923828, -1.41582085769268, 218, 13, 'PPL', 'P'),
(197611, 'Staley Place', 46.2436103820801, 0.80710325917673, -110.655830383301, -1.93130857671698, 218, 31, 'PPL', 'P'),
(195646, 'Staley Springs', 44.6602783203125, 0.779468901546496, -111.434440612793, -1.94489788881132, 218, 17, 'PPL', 'P'),
(152865, 'Staleyville', 42.8116683959961, 0.747204571782131, -74.5994415283203, -1.30200587481818, 218, 40, 'PPL', 'P'),
(167547, 'Stalker', 41.8261108398438, 0.730003347459364, -75.1208267211914, -1.31110576310493, 218, 45, 'PPL', 'P'),
(25074, 'Stallings', 33.1041717529297, 0.577776793234326, -85.0386123657227, -1.48420377710902, 218, 13, 'PPL', 'P'),
(28680, 'Stallings', 38.7247200012207, 0.675873865934204, -90.0630569458008, -1.57189687811537, 218, 18, 'PPL', 'P'),
(69051, 'Stallings', 35.0905609130859, 0.612445824304977, -80.686393737793, -1.40824323228502, 218, 33, 'PPL', 'P'),
(25075, 'Stallings (historical)', 33.1002807617188, 0.577708882626529, -83.4199981689453, -1.45595363005574, 218, 13, 'PPL', 'P'),
(25076, 'Stallings Crossroad', 33.3386116027832, 0.581868540512151, -84.9800033569336, -1.48318085693433, 218, 13, 'PPL', 'P'),
(69053, 'Stallings Crossroads', 36.0938911437988, 0.629957240315712, -78.1655578613281, -1.36424634633831, 218, 33, 'PPL', 'P'),
(25077, 'Stallings Place', 33.5550003051758, 0.585645235833019, -82.0513916015625, -1.43206693929049, 218, 13, 'PPL', 'P'),
(185352, 'Stallion Oaks', 32.8733291625977, 0.573747829979199, -116.635559082031, -2.03567453088582, 218, 6, 'PPL', 'P'),
(185353, 'Stallion Springs', 35.0888900756836, 0.612416662691041, -118.641670227051, -2.07068777552736, 218, 6, 'PPL', 'P'),
(61864, 'Stallo', 32.9199981689453, 0.5745623577986, -89.1005630493164, -1.55509819059137, 218, 30, 'PPL', 'P'),
(133241, 'Stalls Corner', 42.6411094665527, 0.744227756894668, -84.8949966430664, -1.48169720989104, 218, 27, 'PPL', 'P'),
(83806, 'Stallsville', 32.9963912963867, 0.575895669398348, -80.1822204589844, -1.39944374856924, 218, 48, 'PPL', 'P'),
(192264, 'Stallwitz Lake', 35.810001373291, 0.625002429107619, -102.014999389648, -1.78049762576937, 218, 51, 'PPL', 'P'),
(25078, 'Stallworth Trailer Park', 32.5244407653809, 0.567658578725761, -83.9124984741211, -1.46454938194813, 218, 13, 'PPL', 'P'),
(83808, 'Stalvey', 33.685001373291, 0.58791418250274, -78.9691696166992, -1.37827201737727, 218, 48, 'PPL', 'P'),
(133242, 'Stalwart', 46.0980606079102, 0.804562936391931, -84.2386093139648, -1.47024108982985, 218, 27, 'PPL', 'P'),
(133243, 'Stambaugh', 46.0811080932617, 0.804267059194823, -88.6269378662109, -1.54683187172582, 218, 27, 'PPL', 'P'),
(43188, 'Stamboul (historical)', 32.6124992370605, 0.569195488990845, -91.1699981689453, -1.5912166470853, 218, 22, 'PPL', 'P'),
(69054, 'Stamey Town', 36.0047187805176, 0.628400888974669, -81.9466705322266, -1.43023921183437, 218, 33, 'PPL', 'P'),
(98270, 'Stamford', 32.9452781677246, 0.575003577012199, -99.8024978637695, -1.74188218943739, 218, 51, 'PPL', 'P'),
(114121, 'Stamford', 41.0533294677734, 0.716515768118658, -73.5391693115234, -1.28350063366766, 218, 8, 'PPL', 'P'),
(143096, 'Stamford', 40.1330604553223, 0.700454043847308, -99.5924987792969, -1.73821701398716, 218, 35, 'PPL', 'P'),
(152866, 'Stamford', 42.4072189331055, 0.740145596996767, -74.6147232055664, -1.30227259040135, 218, 40, 'PPL', 'P'),
(172588, 'Stamford', 42.7561111450195, 0.746234914829234, -73.0683288574219, -1.275282917492, 218, 55, 'PPL', 'P'),
(209905, 'Stamford', 43.8950004577637, 0.766112283152394, -101.088607788086, -1.76432904215928, 218, 49, 'PPL', 'P'),
(6043, 'Stamp', 34.5877799987793, 0.603670641934139, -85.7261123657227, -1.49620291571649, 218, 2, 'PPL', 'P'),
(25079, 'Stamp Creek (historical)', 34.2477798461914, 0.597736519814197, -84.6769409179688, -1.47789141953526, 218, 13, 'PPL', 'P'),
(98271, 'Stampede', 31.2819404602051, 0.545972857443409, -97.4036102294922, -1.70001370183387, 218, 51, 'PPL', 'P'),
(198946, 'Stampede', 48.8872184753418, 0.853242924536517, -102.73722076416, -1.79310276668288, 218, 34, 'PPL', 'P'),
(208820, 'Stampede', 47.2630615234375, 0.824896038156631, -121.365280151367, -2.11822373624668, 218, 56, 'PPL', 'P'),
(61865, 'Stamper (historical)', 32.5133285522461, 0.567464634019376, -89.1419372558594, -1.55582030672095, 218, 30, 'PPL', 'P'),
(106530, 'Stampers', 37.5397186279297, 0.655191690329621, -76.4327774047852, -1.33400362215743, 218, 53, 'PPL', 'P'),
(31210, 'Stampers Creek', 38.5583305358887, 0.672969821923527, -86.3833312988281, -1.50767355000562, 218, 19, 'PPL', 'P'),
(38356, 'Stamping Ground', 38.271671295166, 0.66796667434165, -84.686393737793, -1.47805640236479, 218, 21, 'PPL', 'P'),
(43189, 'Stampley', 32.8216705322266, 0.572846216792153, -91.7797164916992, -1.60185823932709, 218, 22, 'PPL', 'P'),
(61866, 'Stampley', 31.6369400024414, 0.552168768298505, -91.1311111450195, -1.59053794048149, 218, 30, 'PPL', 'P'),
(12106, 'Stamps', 33.3652801513672, 0.582333994491669, -93.495002746582, -1.631795632089, 218, 4, 'PPL', 'P'),
(98272, 'Stamps', 32.7574996948242, 0.57172622439572, -94.7877807617188, -1.65435886495053, 218, 51, 'PPL', 'P'),
(179212, 'Stan Shuatuk', 31.7988891601563, 0.554995314321461, -112.29972076416, -1.95999987640484, 218, 5, 'PPL', 'P'),
(111522, 'Stanaford', 37.8158302307129, 0.660010746901147, -81.1524963378906, -1.41637825730883, 218, 58, 'PPL', 'P'),
(106531, 'Stanards Mill', 38.1477813720703, 0.665804387273587, -77.5158309936523, -1.3529064732587, 218, 53, 'PPL', 'P'),
(106532, 'Stanardsville', 38.2972183227539, 0.668412554087156, -78.4402770996094, -1.36904110156489, 218, 53, 'PPL', 'P'),
(139467, 'Stanberry', 40.2177810668945, 0.701932697463547, -94.5380630493164, -1.65000046866856, 218, 29, 'PPL', 'P'),
(176517, 'Stanberry', 46.0072212219238, 0.80297749001598, -91.626106262207, -1.59917723505771, 218, 57, 'PPL', 'P'),
(74403, 'Stanbery Park', 39.0927810668945, 0.682297743378611, -84.3936080932617, -1.47294632886515, 218, 41, 'PPL', 'P'),
(152868, 'Stanbro', 42.6680603027344, 0.744698137722203, -75.6936111450195, -1.32110273720487, 218, 40, 'PPL', 'P'),
(51671, 'Stanbrook', 39.2613906860352, 0.685240536383149, -76.5055618286133, -1.3352739499974, 218, 25, 'PPL', 'P'),
(69055, 'Stancell', 36.5436096191406, 0.637806308417475, -77.7402801513672, -1.35682385006415, 218, 33, 'PPL', 'P'),
(138257, 'Stanchfield', 45.6733283996582, 0.797149960918668, -93.1830596923828, -1.62635119871449, 218, 28, 'PPL', 'P'),
(138258, 'Stanchfield Corner', 45.6736106872559, 0.797154887766685, -93.1927795410156, -1.62652084207593, 218, 28, 'PPL', 'P'),
(682, 'Stancil', 36.351390838623, 0.634451457813275, -89.6452789306641, -1.56460527620879, 218, 29, 'PPL', 'P'),
(69056, 'Stancils Chapel', 35.6811103820801, 0.622752856934829, -78.2099990844727, -1.3650219920058, 218, 33, 'PPL', 'P'),
(133246, 'Standale', 42.9724998474121, 0.750011610150102, -85.7763900756836, -1.49708042729567, 218, 27, 'PPL', 'P'),
(6045, 'Standard', 33.7358283996582, 0.588801281461845, -87.2705612182617, -1.52315863332194, 218, 2, 'PPL', 'P'),
(31206, 'Standard', 39.1963882446289, 0.684106029758775, -87.3891677856445, -1.52522870843726, 218, 19, 'PPL', 'P'),
(43191, 'Standard', 31.1555595397949, 0.543767094270551, -93.3608322143555, -1.62945391454249, 218, 22, 'PPL', 'P'),
(51672, 'Standard', 39.4150009155273, 0.687921540652532, -79.1755599975586, -1.38187420906771, 218, 25, 'PPL', 'P'),
(61867, 'Standard', 30.5494403839111, 0.53318831934097, -89.3777770996094, -1.55993648850177, 218, 30, 'PPL', 'P'),
(111523, 'Standard', 38.1361083984375, 0.665600655450196, -81.4008331298828, -1.42071255198294, 218, 58, 'PPL', 'P'),
(121562, 'Standard', 41.2566719055176, 0.720064763166325, -89.1808319091797, -1.55649914648281, 218, 18, 'PPL', 'P'),
(167548, 'Standard', 40.1594390869141, 0.700914437820756, -79.5363922119141, -1.38817191925548, 218, 45, 'PPL', 'P'),
(185354, 'Standard', 37.9666709899902, 0.662643414796745, -120.310829162598, -2.09982009469174, 218, 6, 'PPL', 'P'),
(212161, 'Standard', 64.7808303833008, 1.13063878236458, -148.529724121094, -2.59233272299193, 218, 1, 'PPL', 'P'),
(28681, 'Standard City', 39.3522186279297, 0.686825783022018, -89.7874984741211, -1.5670874755028, 218, 18, 'PPL', 'P'),
(167549, 'Standard Shaft', 40.1647186279297, 0.701006583194472, -79.533332824707, -1.38811852287562, 218, 45, 'PPL', 'P'),
(12105, 'Standard Umpstead', 33.3730583190918, 0.582469749128236, -92.6747207641602, -1.61747901070095, 218, 4, 'PPL', 'P'),
(157780, 'Standardsburg', 41.2174987792969, 0.719381063135474, -82.7052764892578, -1.44347938350981, 218, 41, 'PPL', 'P'),
(192801, 'Standardville', 39.7000007629395, 0.692895726357554, -110.932777404785, -1.93614221409547, 218, 52, 'PPL', 'P'),
(192265, 'Standart', 29.3422203063965, 0.512118354192158, -100.617782592773, -1.75611159229973, 218, 51, 'PPL', 'P'),
(205896, 'Standia', 40.6455612182617, 0.709398869579585, -111.83805847168, -1.95194234936875, 218, 52, 'PPL', 'P'),
(185356, 'Standiford', 37.6891708374023, 0.657800123459299, -121.002502441406, -2.11189207075502, 218, 6, 'PPL', 'P'),
(61868, 'Standing Pine', 32.6736106872559, 0.570262085007422, -89.4333267211914, -1.56090601229661, 218, 30, 'PPL', 'P'),
(6046, 'Standing Rock', 33.079719543457, 0.577350021669641, -85.253059387207, -1.48794658370502, 218, 2, 'PPL', 'P'),
(38357, 'Standing Rock', 37.7163887023926, 0.658275164818742, -83.7063903808594, -1.46095211710571, 218, 21, 'PPL', 'P'),
(189603, 'Standing Rock', 35.8030586242676, 0.624881255278021, -108.360282897949, -1.89124371496172, 218, 38, 'PPL', 'P'),
(167550, 'Standing Stone', 41.7394409179688, 0.728490671960199, -76.3616714477539, -1.33276258908945, 218, 45, 'PPL', 'P'),
(91008, 'Standingstone', 36.1547203063965, 0.631018909484272, -85.2819366455078, -1.48845058694132, 218, 50, 'PPL', 'P'),
(111524, 'Standingstone (historical)', 39.0747184753418, 0.681982491684573, -81.383056640625, -1.42040229371594, 218, 58, 'PPL', 'P'),
(57699, 'Standish', 39.3844413757324, 0.687388176065216, -93.4291687011719, -1.63064661123668, 218, 29, 'PPL', 'P'),
(126244, 'Standish', 42.1069412231445, 0.7349047622876, -70.7555618286133, -1.23491751800772, 218, 23, 'PPL', 'P'),
(128978, 'Standish', 43.7358283996582, 0.763334206661278, -70.5524978637695, -1.23137338322904, 218, 26, 'PPL', 'P'),
(133247, 'Standish', 43.9830589294434, 0.767649193417479, -83.9588928222656, -1.46535911607757, 218, 27, 'PPL', 'P'),
(152869, 'Standish', 44.6891708374023, 0.779973171098902, -73.9494400024414, -1.29066120804861, 218, 40, 'PPL', 'P'),
(193976, 'Standish', 40.3652801513672, 0.704507042131272, -120.421112060547, -2.1017448943696, 218, 6, 'PPL', 'P'),
(157781, 'Standley', 41.2675018310547, 0.720253781024693, -84.2275009155273, -1.47004721170249, 218, 41, 'PPL', 'P'),
(205897, 'Standrod', 41.9938888549805, 0.732931626235961, -113.418327331543, -1.9795232440401, 218, 52, 'PPL', 'P'),
(25080, 'Stanebrook', 33.5386085510254, 0.585359145752918, -84.3883285522461, -1.47285418349143, 218, 13, 'PPL', 'P'),
(69057, 'Stanfield', 35.2333297729492, 0.61493761097891, -80.4272232055664, -1.40371985317352, 218, 33, 'PPL', 'P'),
(98273, 'Stanfield', 33.9691696166992, 0.592873853979822, -97.9994430541992, -1.71041294641646, 218, 51, 'PPL', 'P'),
(179213, 'Stanfield', 32.8824996948242, 0.573907885960713, -111.961387634277, -1.9540948493198, 218, 5, 'PPL', 'P'),
(201594, 'Stanfield', 45.7805595397949, 0.799021497374721, -119.216110229492, -2.08071364492513, 218, 43, 'PPL', 'P'),
(6048, 'Stanfield (historical)', 34.0125007629395, 0.593630125150377, -86.1680603027344, -1.50391636233974, 218, 2, 'PPL', 'P'),
(185357, 'Stanfield Hill', 39.3424987792969, 0.68665613966058, -121.331939697266, -2.1176418355485, 218, 6, 'PPL', 'P'),
(38358, 'Stanfill', 36.7644386291504, 0.641660501726065, -83.3422164916992, -1.45459608369007, 218, 21, 'PPL', 'P'),
(91009, 'Stanfill', 36.4597206115723, 0.636342169029177, -84.2874984741211, -1.47109436664311, 218, 50, 'PPL', 'P'),
(12107, 'Stanford', 36.0972213745117, 0.630015363806503, -90.6636123657227, -1.58237854753371, 218, 4, 'PPL', 'P'),
(31207, 'Stanford', 39.0897216796875, 0.682244346998755, -86.6666717529297, -1.51261877383379, 218, 19, 'PPL', 'P'),
(38359, 'Stanford', 37.5311088562012, 0.655041421465113, -84.6619415283203, -1.47762963080011, 218, 21, 'PPL', 'P'),
(121563, 'Stanford', 40.4347190856934, 0.70571898016434, -89.2177810668945, -1.55714403094077, 218, 18, 'PPL', 'P'),
(185358, 'Stanford', 37.4241714477539, 0.653175011594159, -122.165000915527, -2.13218149667784, 218, 6, 'PPL', 'P'),
(195647, 'Stanford', 46.8327789306641, 0.817386190198717, -116.643608093262, -2.03581501263332, 218, 17, 'PPL', 'P'),
(197612, 'Stanford', 47.1536102294922, 0.822985752706718, -110.217498779297, -1.92365824701156, 218, 31, 'PPL', 'P'),
(185359, 'Stanford (historical)', 39.292781829834, 0.685788415198405, -120.266670227051, -2.09904937587227, 218, 6, 'PPL', 'P'),
(152870, 'Stanford Heights', 42.7655601501465, 0.746399831079737, -73.8894424438477, -1.28961405310799, 218, 40, 'PPL', 'P'),
(25081, 'Stanfordville', 33.2230606079102, 0.579851795197661, -83.5008316040039, -1.45736443964321, 218, 13, 'PPL', 'P'),
(152872, 'Stanfordville', 41.8672218322754, 0.730720869636059, -73.7147216796875, -1.28656460050179, 218, 40, 'PPL', 'P'),
(167551, 'Stanfordville', 41.9569396972656, 0.732286741777998, -75.829719543457, -1.32347827689722, 218, 45, 'PPL', 'P'),
(106537, 'Stange Mines (historical)', 37.2036094665527, 0.649325478817476, -80.934440612793, -1.41257246695305, 218, 53, 'PPL', 'P'),
(176515, 'Stangelville', 44.4002799987793, 0.774931074786083, -87.684440612793, -1.53038219146267, 218, 57, 'PPL', 'P'),
(38360, 'Stanhope', 37.4449996948242, 0.653538533082955, -87.6686096191406, -1.53010588849958, 218, 21, 'PPL', 'P'),
(57700, 'Stanhope', 39.1875, 0.683950900625278, -93.2602767944336, -1.62769889138413, 218, 29, 'PPL', 'P'),
(69058, 'Stanhope', 35.8655586242676, 0.625972086060517, -78.0813903808594, -1.36277734668103, 218, 33, 'PPL', 'P'),
(117889, 'Stanhope', 42.288890838623, 0.738080382150438, -93.7958297729492, -1.63704605417809, 218, 16, 'PPL', 'P'),
(146390, 'Stanhope', 40.9027786254883, 0.713888160229131, -74.7094421386719, -1.30392574764802, 218, 37, 'PPL', 'P'),
(157788, 'Stanhope', 41.4983291625977, 0.72428247796371, -80.6041717529297, -1.40680818793163, 218, 41, 'PPL', 'P'),
(167552, 'Stanhope', 40.5347213745117, 0.707464349363751, -76.3522186279297, -1.33259760625992, 218, 45, 'PPL', 'P'),
(185360, 'Stanislaus', 38.1383285522461, 0.665639404444057, -120.369171142578, -2.10083835433453, 218, 6, 'PPL', 'P'),
(196, 'Stanley', 39.3086090087891, 0.686064651582474, -80.892219543457, -1.41183557027943, 218, 58, 'PPL', 'P'),
(6049, 'Stanley', 31.2008304595947, 0.544557220876464, -86.4477767944336, -1.50879833609202, 218, 2, 'PPL', 'P'),
(31208, 'Stanley', 38.1644401550293, 0.666095137885596, -87.3550033569336, -1.52463242666919, 218, 19, 'PPL', 'P'),
(34046, 'Stanley', 38.8544387817383, 0.678137885755907, -94.6655578613281, -1.65222567291738, 218, 20, 'PPL', 'P'),
(38365, 'Stanley', 37.8233299255371, 0.660141641268724, -87.2438888549805, -1.52269311276339, 218, 21, 'PPL', 'P'),
(43195, 'Stanley', 31.9608306884766, 0.557821727186362, -93.8977813720703, -1.63882544526043, 218, 22, 'PPL', 'P'),
(51673, 'Stanley', 39.6966705322266, 0.692837602866763, -78.1500015258789, -1.36397483706518, 218, 25, 'PPL', 'P'),
(57701, 'Stanley', 36.3372192382813, 0.634204116727034, -89.7011108398438, -1.56557972685165, 218, 29, 'PPL', 'P'),
(69059, 'Stanley', 35.3588905334473, 0.617129059660909, -81.0972213745117, -1.41541352720395, 218, 33, 'PPL', 'P'),
(77324, 'Stanley', 34.5400009155273, 0.602836739617808, -95.4694366455078, -1.66625600448824, 218, 42, 'PPL', 'P'),
(91010, 'Stanley', 35.122501373291, 0.613003290500158, -85.4038925170898, -1.49057911844257, 218, 50, 'PPL', 'P'),
(106534, 'Stanley', 38.5752792358398, 0.673265632541607, -78.5027770996094, -1.37013193234739, 218, 53, 'PPL', 'P'),
(117890, 'Stanley', 42.6427803039551, 0.744256918508604, -91.8125, -1.60243041948729, 218, 16, 'PPL', 'P'),
(126245, 'Stanley', 42.0033302307129, 0.733096409328409, -70.9819412231445, -1.23886858380096, 218, 23, 'PPL', 'P'),
(138261, 'Stanley', 45.5505599975586, 0.795007248084618, -93.1524963378906, -1.62581776754815, 218, 28, 'PPL', 'P'),
(152873, 'Stanley', 42.8250007629395, 0.747437265482377, -77.0961074829102, -1.34558091604822, 218, 40, 'PPL', 'P'),
(157782, 'Stanley', 41.5919418334961, 0.725916327292474, -83.5186080932617, -1.4576746979102, 218, 41, 'PPL', 'P'),
(167553, 'Stanley', 41.0569381713867, 0.716578751878438, -78.791389465332, -1.37516916839122, 218, 45, 'PPL', 'P'),
(176516, 'Stanley', 44.9599990844727, 0.784700015717684, -90.9369430541992, -1.58714906799436, 218, 57, 'PPL', 'P'),
(185362, 'Stanley', 38.2447204589844, 0.667496293514114, -122.292778015137, -2.13441162777467, 218, 6, 'PPL', 'P'),
(189604, 'Stanley', 35.1474990844727, 0.61343958286574, -105.976387023926, -1.8496368829353, 218, 38, 'PPL', 'P'),
(195648, 'Stanley', 44.2113914489746, 0.771634347672673, -114.944999694824, -2.00616870337856, 218, 17, 'PPL', 'P'),
(198947, 'Stanley', 48.3172187805176, 0.843294553126471, -102.389999389648, -1.78704261046435, 218, 34, 'PPL', 'P'),
(12108, 'Stanley (historical)', 34.1366691589355, 0.595797272487429, -93.6350021362305, -1.63423908238915, 218, 4, 'PPL', 'P'),
(38361, 'Stanley Addition', 37.5169410705566, 0.6547941469579, -82.5658264160156, -1.44104552058958, 218, 21, 'PPL', 'P'),
(171369, 'Stanley Corner', 43.5433311462402, 0.759974495788089, -97.3874969482422, -1.69973247202276, 218, 49, 'PPL', 'P'),
(133250, 'Stanley Corners', 42.2174987792969, 0.736834355655417, -85.1377792358398, -1.48593456550147, 218, 27, 'PPL', 'P'),
(6050, 'Stanley Crossroads', 31.1344394683838, 0.54339847948617, -87.3402786254883, -1.524375431624, 218, 2, 'PPL', 'P'),
(194432, 'Stanley Heights Subdivision', 40.3811111450195, 0.704783345094368, -105.503890991211, -1.84139027146181, 218, 7, 'PPL', 'P'),
(91011, 'Stanley Junction', 36.4538917541504, 0.636240436275536, -84.4944381713867, -1.47470614571348, 218, 50, 'PPL', 'P'),
(25082, 'Stanley Landing', 30.7547206878662, 0.536771136534481, -82.0374984741211, -1.43182445847324, 218, 13, 'PPL', 'P'),
(38362, 'Stanley Landing', 37.0530586242676, 0.64669787092795, -88.3116683959961, -1.54132938143955, 218, 21, 'PPL', 'P'),
(14676, 'Stanley Manor', 38.9027786254883, 0.678981575189245, -75.459716796875, -1.31702051072794, 218, 10, 'PPL', 'P'),
(152874, 'Stanley Manor', 43.0397186279297, 0.751184799189309, -76.2574996948242, -1.33094444901325, 218, 40, 'PPL', 'P'),
(25083, 'Stanley Mill (historical)', 34.7433280944824, 0.606385468349366, -84.2911071777344, -1.47115735040289, 218, 13, 'PPL', 'P'),
(187390, 'Stanley Park', 39.6183280944824, 0.691470269384089, -105.292221069336, -1.83769593439766, 218, 7, 'PPL', 'P'),
(167554, 'Stanleys Corner', 41.3950004577637, 0.722479051852536, -79.6374969482422, -1.38993652979376, 218, 45, 'PPL', 'P'),
(106536, 'Stanleytown', 36.7708282470703, 0.641772021596712, -82.6894378662109, -1.44320294738866, 218, 53, 'PPL', 'P'),
(69060, 'Stanleyville', 36.202220916748, 0.631847951531613, -80.2811126708984, -1.40116974327172, 218, 33, 'PPL', 'P'),
(74404, 'Stanleyville', 39.4719390869141, 0.688915299213295, -81.4113922119141, -1.42089684273037, 218, 41, 'PPL', 'P'),
(172591, 'Stannard', 44.5422210693359, 0.777408413811102, -72.2147216796875, -1.26038466172188, 218, 55, 'PPL', 'P'),
(152875, 'Stannards', 42.0863914489746, 0.734546101067794, -77.9225006103516, -1.36000419703793, 218, 40, 'PPL', 'P'),
(187914, 'Stano', 37.5205612182617, 0.654857330454762, -101.489440917969, -1.77132490002681, 218, 20, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(209755, 'Stansbury', 41.7027816772461, 0.727850847508308, -109.187217712402, -1.90567645017329, 218, 59, 'PPL', 'P'),
(51675, 'Stansbury Estates', 39.3197212219238, 0.686258596288859, -76.4197235107422, -1.33377578872617, 218, 25, 'PPL', 'P'),
(205899, 'Stansbury park', 40.6377792358398, 0.709263048363991, -112.295280456543, -1.95992237841712, 218, 52, 'PPL', 'P'),
(6051, 'Stansel', 33.3194389343262, 0.581533914321182, -88.0455627441406, -1.53668496165651, 218, 2, 'PPL', 'P'),
(25084, 'Stansell (historical)', 34.0705604553223, 0.594643457945152, -82.7497177124023, -1.44425502917729, 218, 13, 'PPL', 'P'),
(6052, 'Stanton', 32.7355613708496, 0.571343328409994, -86.8997192382813, -1.51668621976667, 218, 2, 'PPL', 'P'),
(14664, 'Stanton', 39.7155609130859, 0.693167302209715, -75.64111328125, -1.32018647663182, 218, 10, 'PPL', 'P'),
(18186, 'Stanton', 28.9961109161377, 0.506077605760072, -81.915283203125, -1.42969139959814, 218, 12, 'PPL', 'P'),
(34047, 'Stanton', 38.5433311462402, 0.672708033188372, -95.0541687011719, -1.65900821158159, 218, 20, 'PPL', 'P'),
(38363, 'Stanton', 37.8455581665039, 0.660529597260522, -83.8583297729492, -1.46360395976115, 218, 21, 'PPL', 'P'),
(43196, 'Stanton', 29.9172191619873, 0.522153977417417, -89.9408264160156, -1.56976355292416, 218, 22, 'PPL', 'P'),
(57702, 'Stanton', 38.2744407653809, 0.668015010715434, -91.1055603027344, -1.59009199415696, 218, 29, 'PPL', 'P'),
(61870, 'Stanton', 31.6158294677734, 0.551800319961693, -91.2402801513672, -1.59244329908339, 218, 30, 'PPL', 'P'),
(91012, 'Stanton', 35.4622192382813, 0.618932485772083, -89.4019393920898, -1.56035820006039, 218, 50, 'PPL', 'P'),
(117891, 'Stanton', 40.9816703796387, 0.715265081091729, -95.103889465332, -1.65987600262279, 218, 16, 'PPL', 'P'),
(133252, 'Stanton', 43.2924995422363, 0.755596658430162, -85.0813903808594, -1.48495039432063, 218, 27, 'PPL', 'P'),
(138263, 'Stanton', 44.4719390869141, 0.776181761813011, -93.0227813720703, -1.62355381430548, 218, 28, 'PPL', 'P'),
(143097, 'Stanton', 41.9502792358398, 0.732170494796416, -97.2236099243164, -1.69687210385396, 218, 35, 'PPL', 'P'),
(146392, 'Stanton', 40.5750007629395, 0.708167357312505, -74.8380584716797, -1.30617052613085, 218, 37, 'PPL', 'P'),
(167555, 'Stanton', 41.0883293151855, 0.717126630693695, -79.1122207641602, -1.38076873089922, 218, 45, 'PPL', 'P'),
(176519, 'Stanton', 45.1730613708496, 0.788418654126789, -92.4669418334961, -1.61385258424459, 218, 57, 'PPL', 'P'),
(179214, 'Stanton', 34.1652793884277, 0.596296615191819, -112.728607177734, -1.96748535643878, 218, 5, 'PPL', 'P'),
(185363, 'Stanton', 33.8025016784668, 0.589964949700155, -117.992218017578, -2.05935269613771, 218, 6, 'PPL', 'P'),
(192266, 'Stanton', 32.1291694641113, 0.560759793079965, -101.788063049316, -1.77653683943815, 218, 51, 'PPL', 'P'),
(198949, 'Stanton', 47.3211097717285, 0.825909171214325, -101.38111114502, -1.76943418881091, 218, 34, 'PPL', 'P'),
(167560, 'Stanton Corner', 41.625560760498, 0.726503088259646, -75.1152801513672, -1.3110089571993, 218, 45, 'PPL', 'P'),
(195649, 'Stanton Crossing', 43.3277816772461, 0.756212447853215, -114.311668395996, -1.99511498695808, 218, 17, 'PPL', 'P'),
(14665, 'Stanton Estates', 39.7133293151855, 0.693128353478773, -75.647216796875, -1.32029300307543, 218, 10, 'PPL', 'P'),
(51674, 'Stanton Heights', 39.4874992370605, 0.689186875065455, -77.0766677856445, -1.34524162932534, 218, 25, 'PPL', 'P'),
(167558, 'Stanton Heights', 40.2125015258789, 0.701840552089831, -79.6002807617188, -1.38928698480389, 218, 45, 'PPL', 'P'),
(143101, 'Stanton Mobile Park', 41.9502792358398, 0.732170494796416, -97.2236099243164, -1.69687210385396, 218, 35, 'PPL', 'P'),
(13215, 'Stanton Park', 38.9013900756836, 0.678957340423325, -77.0002822875977, -1.34390845088365, 218, 9, 'PPL', 'P'),
(157783, 'Stanton Park', 40.3902816772461, 0.704943401075882, -80.6358337402344, -1.40736079385782, 218, 41, 'PPL', 'P'),
(69063, 'Stantonsburg', 35.6066703796387, 0.621453633797034, -77.8236083984375, -1.35827820233545, 218, 33, 'PPL', 'P'),
(91013, 'Stantonville', 35.1583290100098, 0.613628600724109, -88.4258270263672, -1.54332182540909, 218, 50, 'PPL', 'P'),
(38364, 'Stanville', 37.5666694641113, 0.655662071157156, -82.6425018310547, -1.44238375903735, 218, 21, 'PPL', 'P'),
(114123, 'Stanwich', 41.1194381713867, 0.717669582660935, -73.6197204589844, -1.28490651640711, 218, 8, 'PPL', 'P'),
(71432, 'Stanwick', 39.9730606079102, 0.697661519707278, -74.9369430541992, -1.30789638767527, 218, 37, 'PPL', 'P'),
(71433, 'Stanwick Glen', 39.9791717529297, 0.697768179308936, -74.9394378662109, -1.30793993035909, 218, 37, 'PPL', 'P'),
(152876, 'Stanwix', 43.1930618286133, 0.753861142926784, -75.4347229003906, -1.31658428494138, 218, 40, 'PPL', 'P'),
(179215, 'Stanwix', 32.8397216796875, 0.57316126874911, -113.322219848633, -1.97784585202751, 218, 5, 'PPL', 'P'),
(152877, 'Stanwix Heights', 43.1841697692871, 0.75370594721426, -75.4288864135742, -1.31648241902969, 218, 40, 'PPL', 'P'),
(117893, 'Stanwood', 41.8930587768555, 0.731171809387636, -91.1505584716797, -1.59087736036242, 218, 16, 'PPL', 'P'),
(133255, 'Stanwood', 43.5786094665527, 0.760590218632115, -85.4491729736328, -1.49136941149605, 218, 27, 'PPL', 'P'),
(152878, 'Stanwood', 41.2388916015625, 0.719754438320303, -73.746940612793, -1.28712692696596, 218, 40, 'PPL', 'P'),
(157784, 'Stanwood', 40.7583312988281, 0.711367078783208, -81.6338882446289, -1.42478013107387, 218, 41, 'PPL', 'P'),
(167559, 'Stanwood', 40.1072196960449, 0.700003037516703, -74.9527816772461, -1.30817282379642, 218, 45, 'PPL', 'P'),
(208821, 'Stanwood', 48.2413902282715, 0.841971095222756, -122.369438171387, -2.13574959990633, 218, 56, 'PPL', 'P'),
(128980, 'Stanwood Park', 43.6197204589844, 0.761307740808809, -70.2699966430664, -1.22644280678687, 218, 26, 'PPL', 'P'),
(117894, 'Stanzel', 41.3158302307129, 0.721097270720948, -94.2608337402344, -1.64516190444205, 218, 16, 'PPL', 'P'),
(143106, 'Staplehurst', 40.9749984741211, 0.715148634373066, -97.1722183227539, -1.69597515119882, 218, 35, 'PPL', 'P'),
(43197, 'Staples', 32.3641700744629, 0.564861327474796, -93.8163909912109, -1.63740491513498, 218, 22, 'PPL', 'P'),
(98274, 'Staples', 29.7811107635498, 0.519778437725067, -97.8358306884766, -1.70755737193763, 218, 51, 'PPL', 'P'),
(138265, 'Staples', 46.3555603027344, 0.809057153889494, -94.7919387817383, -1.65443143609024, 218, 28, 'PPL', 'P'),
(121565, 'Staples Corner', 42.1391716003418, 0.735467288488852, -88.0216674804688, -1.5362679106298, 218, 18, 'PPL', 'P'),
(126249, 'Staples Corner', 41.8611106872559, 0.730614210034401, -70.9388885498047, -1.2381171728994, 218, 23, 'PPL', 'P'),
(31209, 'Staples Ford', 38.8941688537598, 0.678831306324737, -85.7766723632813, -1.49708535414368, 218, 19, 'PPL', 'P'),
(126246, 'Staples Shore', 41.8527793884277, 0.730468801438883, -70.9250030517578, -1.2378748252402, 218, 23, 'PPL', 'P'),
(6053, 'Stapleton', 30.7425003051758, 0.536557850620679, -87.793327331543, -1.53228262321655, 218, 2, 'PPL', 'P'),
(25085, 'Stapleton', 33.2155609130859, 0.579720900830084, -82.4683303833008, -1.43934389381108, 218, 13, 'PPL', 'P'),
(106540, 'Stapleton', 37.4688911437988, 0.653955517530634, -78.978889465332, -1.37844166073871, 218, 53, 'PPL', 'P'),
(152879, 'Stapleton', 40.6263885498047, 0.709064243388616, -74.0780563354492, -1.29290598653143, 218, 40, 'PPL', 'P'),
(187391, 'Stapleton', 37.4988899230957, 0.654479095000943, -108.404167175293, -1.89200964009122, 218, 7, 'PPL', 'P'),
(199700, 'Stapleton', 41.480281829834, 0.723967492585781, -100.512496948242, -1.75427401114758, 218, 35, 'PPL', 'P'),
(201595, 'Stapleton', 44.8277816772461, 0.78239238663313, -123.204170227051, -2.15031842264961, 218, 43, 'PPL', 'P'),
(25086, 'Stapletons Crossroads', 33.100830078125, 0.577718470006453, -82.5041732788086, -1.43996947035114, 218, 13, 'PPL', 'P'),
(57703, 'Stapletown (historical)', 39.0097198486328, 0.680848051639227, -92.438606262207, -1.61335803523016, 218, 29, 'PPL', 'P'),
(77325, 'Stapp', 34.7550010681152, 0.606589200172757, -94.6236114501953, -1.65149356993371, 218, 42, 'PPL', 'P'),
(6054, 'Star', 33.6783294677734, 0.587797735784076, -88.1722183227539, -1.53889551851933, 218, 2, 'PPL', 'P'),
(18190, 'Star', 30.7175006866455, 0.536121524965583, -85.1366729736328, -1.48591525758356, 218, 12, 'PPL', 'P'),
(43199, 'Star', 29.7338905334473, 0.518954289236228, -90.008056640625, -1.57093694170045, 218, 22, 'PPL', 'P'),
(57704, 'Star', 36.8977813720703, 0.643987771623658, -90.2286071777344, -1.57478627474005, 218, 29, 'PPL', 'P'),
(61871, 'Star', 32.0938911437988, 0.560144070235938, -90.0461120605469, -1.57160113407632, 218, 30, 'PPL', 'P'),
(69065, 'Star', 35.4019393920898, 0.617880403983448, -79.7844390869141, -1.39250115392351, 218, 33, 'PPL', 'P'),
(77327, 'Star', 34.6711082458496, 0.605124994205431, -95.5386123657227, -1.66746334856843, 218, 42, 'PPL', 'P'),
(98275, 'Star', 31.4683303833008, 0.549225975293968, -98.3158264160156, -1.71593487777869, 218, 51, 'PPL', 'P'),
(106539, 'Star', 36.8055610656738, 0.642378223639841, -80.7205581665039, -1.40883951405309, 218, 53, 'PPL', 'P'),
(133256, 'Star', 46.3472213745117, 0.808911612135921, -86.392219543457, -1.50782867913912, 218, 27, 'PPL', 'P'),
(177338, 'Star', 42.6113891601563, 0.743709039693348, -98.3399963378906, -1.71635672249536, 218, 35, 'PPL', 'P'),
(195650, 'Star', 43.6922187805176, 0.762573075221733, -116.492500305176, -2.03317768420582, 218, 17, 'PPL', 'P'),
(197613, 'Star', 48.5441703796387, 0.847255605773801, -113.211112976074, -1.97590667127977, 218, 31, 'PPL', 'P'),
(43200, 'Star (historical)', 30.8944396972656, 0.539209693276125, -92.2033309936523, -1.60925170714537, 218, 22, 'PPL', 'P'),
(91014, 'Star (historical)', 35.0955581665039, 0.612533042830677, -87.6580581665039, -1.5299217309102, 218, 50, 'PPL', 'P'),
(83810, 'Star Bluff Crossroads', 33.8561096191406, 0.590900584770127, -78.7577819824219, -1.37458260716113, 218, 48, 'PPL', 'P'),
(106541, 'Star Cave', 36.9152793884277, 0.644293169621663, -80.789436340332, -1.41004166496915, 218, 53, 'PPL', 'P'),
(12110, 'Star City', 33.9427795410156, 0.592413260269292, -91.8433303833008, -1.60296851118554, 218, 4, 'PPL', 'P'),
(28683, 'Star City', 39.1341705322266, 0.683020125824295, -90.6736068725586, -1.58255298458511, 218, 18, 'PPL', 'P'),
(57705, 'Star City', 36.7702789306641, 0.641762434216788, -93.813606262207, -1.63735631244508, 218, 29, 'PPL', 'P'),
(111525, 'Star City', 39.6583290100098, 0.692168417063854, -79.9866714477539, -1.39603077447425, 218, 58, 'PPL', 'P'),
(123721, 'Star City', 40.9719390869141, 0.71509523799321, -86.5561065673828, -1.51068904730792, 218, 19, 'PPL', 'P'),
(133257, 'Star City', 44.3711090087891, 0.774421944964687, -84.9850006103516, -1.48326807546003, 218, 27, 'PPL', 'P'),
(200218, 'Star City (historical)', 40.5444412231445, 0.707633992725189, -118.140556335449, -2.06194168819144, 218, 39, 'PPL', 'P'),
(171370, 'Star Corner (historical)', 43.0402793884277, 0.751194586306315, -97.0638885498047, -1.69408443998292, 218, 49, 'PPL', 'P'),
(71434, 'Star Cross', 39.6463890075684, 0.691960024708555, -75.0155563354492, -1.30926844826888, 218, 37, 'PPL', 'P'),
(98276, 'Star Harbor', 32.1919403076172, 0.561855350973396, -96.0527801513672, -1.67643726933561, 218, 51, 'PPL', 'P'),
(6055, 'Star Hill', 31.9125003814697, 0.556978204200593, -85.6316680908203, -1.49455455215978, 218, 2, 'PPL', 'P'),
(14666, 'Star Hill', 39.105281829834, 0.682515922850916, -75.5408325195313, -1.31843624716342, 218, 10, 'PPL', 'P'),
(14667, 'Star Hill Village', 39.0999984741211, 0.682423710898172, -75.5374984741211, -1.31837805709361, 218, 10, 'PPL', 'P'),
(167571, 'Star Junction', 40.0625, 0.699222531580228, -79.7638931274414, -1.39214255928273, 218, 45, 'PPL', 'P'),
(152880, 'Star Lake', 44.1597213745117, 0.770732534748545, -75.0319366455078, -1.3095543386119, 218, 40, 'PPL', 'P'),
(176523, 'Star Lake', 46.038330078125, 0.803520441983219, -89.4722213745117, -1.56158485205848, 218, 57, 'PPL', 'P'),
(208822, 'Star Lake', 47.3580589294434, 0.826554055672288, -122.290283203125, -2.13436808509085, 218, 56, 'PPL', 'P'),
(14668, 'Star Landing', 38.7608299255371, 0.676504103006171, -75.2027816772461, -1.31253614692641, 218, 10, 'PPL', 'P'),
(123725, 'Star Mill', 41.7452812194824, 0.728592604450922, -85.4375, -1.49116567967266, 218, 19, 'PPL', 'P'),
(25087, 'Star Mills', 33.0230598449707, 0.576361123377867, -83.9186096191406, -1.46465604154979, 218, 13, 'PPL', 'P'),
(38366, 'Star Mills', 37.5991706848145, 0.656229324469343, -85.9802780151367, -1.50063894314423, 218, 21, 'PPL', 'P'),
(197615, 'Star Mobile Home Park', 45.7761116027832, 0.798943866228946, -111.176109313965, -1.94038915708582, 218, 31, 'PPL', 'P'),
(12111, 'Star of the West (historical)', 34.2397193908691, 0.597595838329614, -93.8244400024414, -1.63754539688248, 218, 4, 'PPL', 'P'),
(25088, 'Star Point', 33.4566688537598, 0.583929028247545, -85.0841674804688, -1.48499886385247, 218, 13, 'PPL', 'P'),
(91015, 'Star Point', 36.5716705322266, 0.63829606374194, -85.1619415283203, -1.48635627706008, 218, 50, 'PPL', 'P'),
(176524, 'Star Prairie', 45.1969413757324, 0.788835438837386, -92.5305633544922, -1.6149629892611, 218, 57, 'PPL', 'P'),
(195651, 'Star Ranch Summer Home Area', 43.9127807617188, 0.766422607998416, -115.967498779297, -2.02401467900124, 218, 17, 'PPL', 'P'),
(79197, 'Star Rock', 39.9372215270996, 0.697036009746246, -76.4544372558594, -1.33438165787416, 218, 45, 'PPL', 'P'),
(192267, 'Star Route', 33.7476081848145, 0.589006877497999, -102.865280151367, -1.79533782462773, 218, 51, 'PPL', 'P'),
(111526, 'Star Settlement (historical)', 39.1755599975586, 0.683742508269979, -81.0250015258789, -1.41415305306002, 218, 58, 'PPL', 'P'),
(179216, 'Star Valley', 34.2550010681152, 0.597862553912785, -111.257781982422, -1.94181461405929, 218, 5, 'PPL', 'P'),
(167561, 'Star Village', 40.5927810668945, 0.708477682158526, -75.3872222900391, -1.31575524289404, 218, 45, 'PPL', 'P'),
(128981, 'Starbird Corner', 44.0838890075684, 0.769409010265803, -69.9841690063477, -1.22145417343293, 218, 26, 'PPL', 'P'),
(128982, 'Starbirds', 45.1358299255371, 0.78776884282081, -69.2347183227539, -1.2083737914229, 218, 26, 'PPL', 'P'),
(128983, 'Starboard', 44.6108283996582, 0.778605837616228, -67.397216796875, -1.1763033397859, 218, 26, 'PPL', 'P'),
(167562, 'Starbrick', 41.8402786254883, 0.730250621966578, -79.2055587768555, -1.38239778653802, 218, 45, 'PPL', 'P'),
(185364, 'Starbright Acres', 39.1952781677246, 0.684086655261845, -121.086669921875, -2.1133610704123, 218, 6, 'PPL', 'P'),
(157785, 'Starbright Addition', 41.5669403076172, 0.725479968347865, -83.5350036621094, -1.45796085456933, 218, 41, 'PPL', 'P'),
(138270, 'Starbuck', 45.6144409179688, 0.796122180474979, -95.5308303833008, -1.66732752735284, 218, 28, 'PPL', 'P'),
(208823, 'Starbuck', 46.519718170166, 0.811922249169229, -118.127777099609, -2.06171864845014, 218, 56, 'PPL', 'P'),
(74405, 'Starbucktown', 39.476390838623, 0.688992996938098, -83.7866668701172, -1.4623532061552, 218, 41, 'PPL', 'P'),
(152881, 'Starbuckville', 43.6733283996582, 0.762243375878782, -73.7780609130859, -1.28767007867028, 218, 40, 'PPL', 'P'),
(98277, 'Stardust Colonia', 25.9340000152588, 0.452633688478526, -97.5329971313477, -1.7022719292802, 218, 51, 'PPL', 'P'),
(57706, 'Starfield', 39.6452789306641, 0.691940650211625, -94.5175018310547, -1.64964160771167, 218, 29, 'PPL', 'P'),
(167563, 'Starford', 40.7016716003418, 0.710378180491434, -78.9591674804688, -1.37809744716782, 218, 45, 'PPL', 'P'),
(179217, 'Stargo', 33.0677795410156, 0.577141629314342, -109.359443664551, -1.90868236009566, 218, 5, 'PPL', 'P'),
(190770, 'Stargo (historical)', 38.9430618286133, 0.679684649717025, -116.48722076416, -2.0330855388321, 218, 39, 'PPL', 'P'),
(43201, 'Starhill', 30.7619400024414, 0.536897137343555, -91.3069381713867, -1.59360670100559, 218, 22, 'PPL', 'P'),
(25089, 'Stark', 33.3333282470703, 0.581776328559407, -83.9066696166992, -1.46444764919449, 218, 13, 'PPL', 'P'),
(34052, 'Stark', 37.689998626709, 0.657814571108213, -95.1427764892578, -1.6605547092266, 218, 20, 'PPL', 'P'),
(38367, 'Stark', 38.1736106872559, 0.66625519386711, -83.1350021362305, -1.45097951092974, 218, 21, 'PPL', 'P'),
(57707, 'Stark', 39.372501373291, 0.687179783709917, -91.0247192382813, -1.58868105141143, 218, 29, 'PPL', 'P'),
(98278, 'Stark', 30.1313896179199, 0.525891957033939, -93.8675003051758, -1.6382969409421, 218, 51, 'PPL', 'P'),
(111527, 'Stark', 37.9119415283203, 0.661688205492761, -81.7441711425781, -1.42670493075172, 218, 58, 'PPL', 'P'),
(113171, 'Stark', 44.601390838623, 0.778441121102807, -71.4250030517578, -1.24660147150017, 218, 36, 'PPL', 'P'),
(121566, 'Stark', 40.9955596923828, 0.715507495329954, -89.7438888549805, -1.56632634406325, 218, 18, 'PPL', 'P'),
(133259, 'Stark', 42.3758316040039, 0.739597784760538, -83.3727798461914, -1.45512951485641, 218, 27, 'PPL', 'P'),
(138273, 'Stark', 45.5805587768555, 0.795530825554927, -93.0602798461914, -1.62420828614336, 218, 28, 'PPL', 'P'),
(152889, 'Stark', 44.4502792358398, 0.775803726096274, -74.7819366455078, -1.30519101548191, 218, 40, 'PPL', 'P'),
(179218, 'Stark', 31.3713893890381, 0.547534035763927, -110.036109924316, -1.92049241426573, 218, 5, 'PPL', 'P'),
(197616, 'Stark', 47.125560760498, 0.822496197119334, -114.504173278809, -1.99847483098932, 218, 31, 'PPL', 'P'),
(12112, 'Stark City', 35.9377784729004, 0.627232560204452, -90.0363922119141, -1.57143149071488, 218, 4, 'PPL', 'P'),
(57708, 'Stark City', 36.8622207641602, 0.643367121931615, -94.1855621337891, -1.64384816707632, 218, 29, 'PPL', 'P'),
(157786, 'Stark Corners', 40.3105583190918, 0.703551965985343, -82.8466720581055, -1.44594720173393, 218, 41, 'PPL', 'P'),
(57710, 'Starkdale (historical)', 39.2541694641113, 0.685114502284561, -90.820556640625, -1.58511774187291, 218, 29, 'PPL', 'P'),
(18187, 'Starke', 29.9438896179199, 0.522619464686449, -82.1100006103516, -1.43308985946519, 218, 12, 'PPL', 'P'),
(57711, 'Starkenburg', 38.7358283996582, 0.676067744061562, -91.5519409179688, -1.59788280560987, 218, 29, 'PPL', 'P'),
(18188, 'Starkes Ferry', 28.9916706085205, 0.506000107772351, -81.8322219848633, -1.42824170785875, 218, 12, 'PPL', 'P'),
(106542, 'Starkey', 37.2005615234375, 0.649272282174702, -79.998893737793, -1.39624409367756, 218, 53, 'PPL', 'P'),
(152883, 'Starkey', 42.5352783203125, 0.742380654941616, -76.9247207641602, -1.34258965351184, 218, 40, 'PPL', 'P'),
(195652, 'Starkey', 44.8505592346191, 0.782789930004852, -116.44750213623, -2.03239231800035, 218, 17, 'PPL', 'P'),
(201596, 'Starkey', 45.2216682434082, 0.789267004092034, -118.42472076416, -2.06690129308949, 218, 43, 'PPL', 'P'),
(91016, 'Starkey (historical)', 35.1416702270508, 0.613337850112099, -87.6372222900391, -1.52955807626335, 218, 50, 'PPL', 'P'),
(51676, 'Starkey Corner', 39.1205596923828, 0.68278257185506, -76.0147171020508, -1.32670709340283, 218, 25, 'PPL', 'P'),
(91017, 'Starkeytown', 35.732780456543, 0.623654669858957, -83.5766677856445, -1.45868803070498, 218, 50, 'PPL', 'P'),
(12113, 'Starks', 36.0283317565918, 0.628813013153359, -94.2663879394531, -1.64525884350573, 218, 4, 'PPL', 'P'),
(43203, 'Starks', 30.3152809143066, 0.529101465621648, -93.6616668701172, -1.63470446978964, 218, 22, 'PPL', 'P'),
(121568, 'Starks', 42.0883293151855, 0.734579923213638, -88.456672668457, -1.54386018342345, 218, 18, 'PPL', 'P'),
(128984, 'Starks', 44.7305603027344, 0.780695553544586, -69.966667175293, -1.2211487088559, 218, 26, 'PPL', 'P'),
(167564, 'Starks', 41.3486099243164, 0.721669384302125, -75.7358322143555, -1.32183963387849, 218, 45, 'PPL', 'P'),
(176528, 'Starks', 45.6630592346191, 0.796970730177306, -89.2216720581055, -1.55721194154857, 218, 57, 'PPL', 'P'),
(152885, 'Starks Knob', 43.1216697692871, 0.752615116431764, -73.5880584716797, -1.28435391048092, 218, 40, 'PPL', 'P'),
(152886, 'Starks Landing', 43.1713905334473, 0.753482907472966, -75.6486129760742, -1.3203173709994, 218, 40, 'PPL', 'P'),
(172593, 'Starksboro', 44.2272186279297, 0.771910584056742, -73.0577774047852, -1.27509875990262, 218, 55, 'PPL', 'P'),
(25090, 'Starksville', 31.7719402313232, 0.554524966783439, -84.1455612182617, -1.46861709419712, 218, 13, 'PPL', 'P'),
(61874, 'Starkville', 33.4502792358398, 0.583817508376898, -88.8183288574219, -1.5501722746811, 218, 30, 'PPL', 'P'),
(152887, 'Starkville', 42.9191703796387, 0.74908083534912, -74.7752838134766, -1.30507490165839, 218, 40, 'PPL', 'P'),
(167565, 'Starkville', 41.6058311462402, 0.726158741530698, -75.834716796875, -1.32356549542292, 218, 45, 'PPL', 'P'),
(187392, 'Starkville', 37.1152801513672, 0.647783841441457, -104.523612976074, -1.82428119251276, 218, 7, 'PPL', 'P'),
(6057, 'Starkville (historical)', 34.3880615234375, 0.600184896962362, -85.4922180175781, -1.49212068923956, 218, 2, 'PPL', 'P'),
(140916, 'Starkweather', 48.4519386291504, 0.845645858052902, -98.8833312988281, -1.72583970650491, 218, 34, 'PPL', 'P'),
(57712, 'Starland', 37.709171295166, 0.658149197299181, -89.5852813720703, -1.56355812126817, 218, 29, 'PPL', 'P'),
(25092, 'Starland Park', 32.122501373291, 0.560643412940328, -81.2252807617188, -1.4176485851488, 218, 13, 'PPL', 'P'),
(31211, 'Starlight', 38.4150009155273, 0.670468248132588, -85.8925018310547, -1.49910695972716, 218, 19, 'PPL', 'P'),
(69068, 'Starlight', 35.2663917541504, 0.615514651408103, -78.2586135864258, -1.3658704751291, 218, 33, 'PPL', 'P'),
(167566, 'Starlight', 41.9049987792969, 0.731380201742935, -75.3313903808594, -1.31478079225118, 218, 45, 'PPL', 'P'),
(69067, 'Starling', 34.7077789306641, 0.605765018394405, -77.2319412231445, -1.34795166205061, 218, 33, 'PPL', 'P'),
(43204, 'Starling (historical)', 30.3219394683838, 0.529217679313716, -91.1291732788086, -1.59050411833565, 218, 22, 'PPL', 'P'),
(106545, 'Starlings Crossroads', 36.5577812194824, 0.638053649503716, -79.726936340332, -1.39149754166671, 218, 53, 'PPL', 'P'),
(6058, 'Starlington', 31.6747207641602, 0.552828166984409, -86.8252792358398, -1.51538699662887, 218, 2, 'PPL', 'P'),
(83811, 'Starlite', 33.9355583190918, 0.592287226170704, -80.9680633544922, -1.41315929449925, 218, 48, 'PPL', 'P'),
(117896, 'Starlite Mobile Home Park', 42.0055618286133, 0.733135358059352, -92.915283203125, -1.62167761731751, 218, 16, 'PPL', 'P'),
(179219, 'Starlite Trailer Park', 33.4500007629395, 0.583812648107909, -111.991668701172, -1.95462335363813, 218, 5, 'PPL', 'P'),
(69069, 'Starmount', 35.7983283996582, 0.624798697284228, -80.9069366455078, -1.41209243216657, 218, 33, 'PPL', 'P'),
(83812, 'Starmount', 33.9230613708496, 0.592069113277427, -81.0708312988281, -1.41495293349342, 218, 48, 'PPL', 'P'),
(106543, 'Starmount', 37.3499984741211, 0.651880448988271, -79.9677810668945, -1.39570107513129, 218, 53, 'PPL', 'P'),
(83813, 'Starmount Acres', 34.6755599975586, 0.605202691930234, -80.7980575561523, -1.41019213357074, 218, 48, 'PPL', 'P'),
(69072, 'Starmount Forest', 36.0794410705566, 0.629705038960481, -79.8444366455078, -1.39354830886413, 218, 33, 'PPL', 'P'),
(28684, 'Starne', 39.8241691589355, 0.695062873694606, -89.6050033569336, -1.56390233483906, 218, 18, 'PPL', 'P'),
(167567, 'Starners', 40.0269393920898, 0.698601881888185, -77.220832824707, -1.34775778392325, 218, 45, 'PPL', 'P'),
(91018, 'Starnes (historical)', 36.5522193908691, 0.637956577281983, -82.8236083984375, -1.44554466493516, 218, 50, 'PPL', 'P'),
(43205, 'Starns', 30.5613899230957, 0.533396878143837, -90.6588897705078, -1.58229612269797, 218, 22, 'PPL', 'P'),
(18189, 'Starr', 30.2841701507568, 0.528558480364894, -83.0802764892578, -1.45002436820478, 218, 12, 'PPL', 'P'),
(51677, 'Starr', 38.9780616760254, 0.680295512292062, -76.0105590820313, -1.32663452226312, 218, 25, 'PPL', 'P'),
(74406, 'Starr', 39.3969383239746, 0.687606288958493, -82.3611068725586, -1.43747249051308, 218, 41, 'PPL', 'P'),
(83821, 'Starr', 34.3769416809082, 0.599990819097922, -82.6958312988281, -1.44331453383833, 218, 48, 'PPL', 'P'),
(167569, 'Starr', 41.7358283996582, 0.728427621621392, -79.5227813720703, -1.38793436528624, 218, 45, 'PPL', 'P'),
(192802, 'Starr', 39.8683280944824, 0.695833592514075, -111.854438781738, -1.95222823971177, 218, 52, 'PPL', 'P'),
(208824, 'Starr', 47.9952812194824, 0.837675682700567, -119.878326416016, -2.09227149773997, 218, 56, 'PPL', 'P'),
(200220, 'Starr (historical)', 40.4408302307129, 0.705825639765998, -116.86888885498, -2.03974690366671, 218, 39, 'PPL', 'P'),
(98279, 'Starr Colonia', 26.1620006561279, 0.456613050358349, -98.1920013427734, -1.71377372255409, 218, 51, 'PPL', 'P'),
(172595, 'Starr Farm Beach', 44.5102806091309, 0.776850947615921, -73.2738876342773, -1.2788705949545, 218, 55, 'PPL', 'P'),
(193310, 'Starr Hill', 58.3041687011719, 1.01759971147368, -134.404174804688, -2.3457953787678, 218, 1, 'PPL', 'P'),
(144503, 'Starr King', 44.4013900756836, 0.774950449283013, -71.4430618286133, -1.24691665661518, 218, 36, 'PPL', 'P'),
(197617, 'Starr School', 48.589168548584, 0.848040971979265, -113.139717102051, -1.97466057820572, 218, 31, 'PPL', 'P'),
(157792, 'Starrs Corners', 41.0244407653809, 0.716011565145279, -80.711669921875, -1.40868438491959, 218, 41, 'PPL', 'P'),
(25094, 'Starrs Mill', 33.327220916748, 0.581669735536776, -84.5124969482422, -1.47502133082849, 218, 13, 'PPL', 'P'),
(201597, 'Starrs Point (historical)', 44.2708282470703, 0.772671715496287, -123.294441223145, -2.1518939487505, 218, 43, 'PPL', 'P'),
(25095, 'Starrsville', 33.5394401550293, 0.585373659980859, -83.8194427490234, -1.46292525315735, 218, 13, 'PPL', 'P'),
(167570, 'Starrucca', 41.8997192382813, 0.731288056369218, -75.4711074829102, -1.31721931570331, 218, 45, 'PPL', 'P'),
(98281, 'Starrville', 32.4697189331055, 0.566703502579831, -95.1158294677734, -1.66008439497809, 218, 51, 'PPL', 'P'),
(43206, 'Start', 32.4863891601563, 0.566994452928922, -91.8591690063477, -1.60324494730669, 218, 22, 'PPL', 'P'),
(83815, 'Startex', 34.9283294677734, 0.609614351434005, -82.0991668701172, -1.43290077502779, 218, 48, 'PPL', 'P'),
(157789, 'Startle (historical)', 40.1938896179199, 0.701515713015868, -80.8194427490234, -1.41056537559752, 218, 41, 'PPL', 'P'),
(69073, 'Startown', 35.6450004577637, 0.622122619862862, -81.2694396972656, -1.41841930396827, 218, 33, 'PPL', 'P'),
(208825, 'Startup', 47.8680610656738, 0.835455272141714, -121.739166259766, -2.1247492798657, 218, 56, 'PPL', 'P'),
(98282, 'Startzville', 29.8444404602051, 0.52088374944599, -98.2736129760742, -1.71519811426312, 218, 51, 'PPL', 'P'),
(201598, 'Starvation Heights', 42.4855613708496, 0.741512930479441, -123.166938781738, -2.14966861134363, 218, 43, 'PPL', 'P'),
(167573, 'Starview', 40.0483283996582, 0.698975190493987, -76.688606262207, -1.33846867804105, 218, 45, 'PPL', 'P'),
(51678, 'Starview Estates', 39.4952812194824, 0.689322696281049, -76.9291687011719, -1.34266728465762, 218, 25, 'PPL', 'P'),
(79198, 'Starview Heights', 39.9527816772461, 0.697307585598407, -76.6577835083008, -1.33793071950086, 218, 45, 'PPL', 'P'),
(133260, 'Starville', 42.6811103820801, 0.744925904574432, -82.5877838134766, -1.44142874947044, 218, 27, 'PPL', 'P'),
(152888, 'State Bridge', 43.1458282470703, 0.75303676141135, -75.6769409179688, -1.32081178685577, 218, 40, 'PPL', 'P'),
(187393, 'State Bridge', 39.857780456543, 0.695649501503724, -106.649169921875, -1.86137915965562, 218, 7, 'PPL', 'P'),
(208826, 'State Camp', 46.25, 0.807214779047377, -123.319999694824, -2.15234002823308, 218, 56, 'PPL', 'P'),
(117897, 'State Center', 42.0166702270508, 0.73332923618671, -93.163330078125, -1.62600685198555, 218, 16, 'PPL', 'P'),
(117898, 'State Center Junction', 41.9422187805176, 0.732029813311833, -93.0469436645508, -1.62397552586409, 218, 16, 'PPL', 'P'),
(25096, 'State College', 32.5374984741211, 0.567886478736044, -83.8952789306641, -1.46424884421912, 218, 13, 'PPL', 'P'),
(167574, 'State College', 40.7933311462402, 0.711977941358245, -77.8602828979492, -1.35891829310345, 218, 45, 'PPL', 'P'),
(83816, 'State Farm (historical)', 34.0966682434082, 0.595099124807664, -80.5774993896484, -1.40634266737309, 218, 48, 'PPL', 'P'),
(202654, 'State Game Lodge', 43.771110534668, 0.763949996084332, -103.383331298828, -1.80437952284466, 218, 49, 'PPL', 'P'),
(167577, 'State Hill', 40.0061111450195, 0.698238360399389, -75.9380569458008, -1.32536912127117, 218, 45, 'PPL', 'P'),
(144504, 'State Landing', 43.7261085510254, 0.76316456329984, -71.3744430541992, -1.24571903307297, 218, 36, 'PPL', 'P'),
(61872, 'State Levee (historical)', 34.5047187805176, 0.602220950194754, -90.5416717529297, -1.58025028234857, 218, 30, 'PPL', 'P'),
(6060, 'State Line', 34.9905586242676, 0.610700455105567, -86.5713882446289, -1.51095576289109, 218, 2, 'PPL', 'P'),
(12115, 'State Line', 33.0513916015625, 0.576855605813267, -93.5388870239258, -1.6325615572185, 218, 4, 'PPL', 'P'),
(43207, 'State Line', 30.9805603027344, 0.540712781395366, -89.9502792358398, -1.56992853575369, 218, 22, 'PPL', 'P'),
(61873, 'State Line', 31.4361095428467, 0.548663615540284, -88.4744415283203, -1.54417030853239, 218, 30, 'PPL', 'P'),
(79200, 'State Line', 39.7247200012207, 0.693327158454147, -77.7247161865234, -1.35655220763297, 218, 45, 'PPL', 'P'),
(83817, 'State Line', 35.1766700744629, 0.613948712687136, -81.8002777099609, -1.42768417508455, 218, 48, 'PPL', 'P'),
(91019, 'State Line', 36.5902786254883, 0.638620836236876, -84.4388885498047, -1.47373662191863, 218, 50, 'PPL', 'P'),
(123724, 'State Line', 40.1972198486328, 0.701573836506659, -87.5269393920898, -1.52763327658549, 218, 19, 'PPL', 'P'),
(126248, 'State Line', 42.0319404602051, 0.733595752032799, -72.3225021362305, -1.26226578555785, 218, 23, 'PPL', 'P'),
(144505, 'State Line', 42.7180595397949, 0.745570789032395, -72.0838928222656, -1.25810126740324, 218, 36, 'PPL', 'P'),
(152891, 'State Line', 41.9583282470703, 0.732310976543918, -73.4938888549805, -1.28271034061417, 218, 40, 'PPL', 'P'),
(176529, 'State Line', 42.4944381713867, 0.741667859875857, -87.8208312988281, -1.53276265800304, 218, 57, 'PPL', 'P'),
(192269, 'State Line', 32.7266693115234, 0.57118813269747, -103.064437866211, -1.7988137824825, 218, 51, 'PPL', 'P'),
(91020, 'State Line (historical)', 34.9958305358887, 0.610792467321229, -89.8666687011719, -1.56846925663439, 218, 50, 'PPL', 'P'),
(157790, 'State Line (historical)', 40.8363914489746, 0.712729485417865, -80.5194396972656, -1.40532933457831, 218, 41, 'PPL', 'P'),
(195653, 'State Line Village', 47.7044410705566, 0.832599564504822, -117.036392211914, -2.04267038875335, 218, 17, 'PPL', 'P'),
(83818, 'State Park', 34.0905609130859, 0.594992531785034, -80.9663925170898, -1.41313013288532, 218, 48, 'PPL', 'P'),
(83819, 'State Park Acres', 34.1175003051758, 0.595462712875488, -80.9419403076172, -1.41270336132063, 218, 48, 'PPL', 'P'),
(28685, 'State Park Place', 38.6586112976074, 0.674720051391927, -90.0472183227539, -1.57162044199422, 218, 18, 'PPL', 'P'),
(69075, 'State Road', 36.3258285522461, 0.634005311751659, -80.8677825927734, -1.41140906503085, 218, 33, 'PPL', 'P'),
(121569, 'State Road', 40.0761108398438, 0.699460085549463, -87.9583282470703, -1.53516243246131, 218, 18, 'PPL', 'P'),
(128986, 'State Road', 46.7311096191406, 0.815611725964397, -68.1527786254883, -1.18949038139759, 218, 26, 'PPL', 'P'),
(157791, 'State Road', 41.3002815246582, 0.720825894605869, -80.898063659668, -1.41193756934918, 218, 41, 'PPL', 'P'),
(83820, 'Stateburg', 33.9575004577637, 0.592670188735458, -80.5350036621094, -1.4056009770095, 218, 48, 'PPL', 'P'),
(185365, 'Stateline', 38.9583282470703, 0.679951098984088, -119.942779541016, -2.09339641698442, 218, 6, 'PPL', 'P'),
(190773, 'Stateline', 37.2966690063477, 0.650949674187288, -117.405281066895, -2.04910871384667, 218, 39, 'PPL', 'P'),
(208827, 'Stateline', 46.0011100769043, 0.802870830414322, -118.413330078125, -2.06670248811412, 218, 56, 'PPL', 'P'),
(106546, 'Stately Oak', 37.9797210693359, 0.662871181648974, -76.5597229003906, -1.33621923902632, 218, 53, 'PPL', 'P'),
(91021, 'Statemount (historical)', 36.2374992370605, 0.63246367437564, -82.7361068725586, -1.44401747520806, 218, 50, 'PPL', 'P'),
(111528, 'Staten', 38.8702812194824, 0.678414388456085, -81.0491714477539, -1.41457489777669, 218, 58, 'PPL', 'P'),
(146393, 'Staten Island Junction', 40.6588897705078, 0.709631496700803, -74.2874984741211, -1.29656144144368, 218, 37, 'PPL', 'P'),
(25097, 'Statenville', 30.7030601501465, 0.535869490057921, -83.0277786254883, -1.44910810763174, 218, 13, 'PPL', 'P'),
(25098, 'Statesboro', 32.4486083984375, 0.566335054243018, -81.783332824707, -1.42738843104549, 218, 13, 'PPL', 'P'),
(25099, 'Statesborough', 32.2174987792969, 0.562301430455984, -81.7238922119141, -1.42635099664285, 218, 13, 'PPL', 'P'),
(6061, 'Statesville', 32.4694404602051, 0.566698642310841, -86.8305587768555, -1.51547914200259, 218, 2, 'PPL', 'P'),
(69076, 'Statesville', 35.7825012207031, 0.62452246090016, -80.8874969482422, -1.41175314544369, 218, 33, 'PPL', 'P'),
(91022, 'Statesville', 36.0194396972656, 0.628657817440835, -86.125, -1.50316481828012, 218, 50, 'PPL', 'P'),
(106547, 'Statesville', 36.5458297729492, 0.637845057411336, -77.0719375610352, -1.34515907133155, 218, 53, 'PPL', 'P'),
(69077, 'Statesville West', 35.7852783203125, 0.624570930431999, -80.9311065673828, -1.41251427688324, 218, 33, 'PPL', 'P'),
(25100, 'Statham', 33.9650001525879, 0.592801083103035, -83.5966720581055, -1.45903717112389, 218, 13, 'PPL', 'P'),
(25101, 'Statham Shoals', 31.9666690826416, 0.557923626387571, -83.2830581665039, -1.45356357613545, 218, 13, 'PPL', 'P'),
(25102, 'Stathams Landing', 32.5708312988281, 0.568468246276172, -83.5736083984375, -1.45863463432512, 218, 13, 'PPL', 'P'),
(38368, 'Static', 36.621940612793, 0.639173442163067, -85.0849990844727, -1.48501337808041, 218, 21, 'PPL', 'P'),
(91023, 'Static', 36.6216697692871, 0.639168715052132, -85.0861129760742, -1.48503281915637, 218, 50, 'PPL', 'P'),
(157799, 'Station 15', 40.3886108398438, 0.704914239461946, -81.2597198486328, -1.41824966060683, 218, 41, 'PPL', 'P'),
(91024, 'Station Camp (historical)', 36.3980598449707, 0.635265985632676, -86.559440612793, -1.51074723737774, 218, 50, 'PPL', 'P'),
(61875, 'Station Creek', 31.6777801513672, 0.552881563364265, -89.4833297729492, -1.56177873018583, 218, 30, 'PPL', 'P'),
(106548, 'Station Hills', 38.8005599975586, 0.677197523575, -77.3441696166992, -1.34991041703236, 218, 53, 'PPL', 'P'),
(51679, 'Station Roads', 39.4791717529297, 0.689041533048964, -77.5852813720703, -1.35411861102885, 218, 25, 'PPL', 'P'),
(91025, 'Station West', 35.8944396972656, 0.626476155875842, -84.1727828979492, -1.46909220213559, 218, 50, 'PPL', 'P'),
(69080, 'Staton', 35.6886100769043, 0.622883751302407, -77.3550033569336, -1.35009950146976, 218, 33, 'PPL', 'P'),
(197618, 'Staton', 46.0900001525879, 0.804422254907348, -112.873893737793, -1.9700210852707, 218, 31, 'PPL', 'P'),
(111529, 'Statts Mills', 38.7374992370605, 0.676096905675498, -81.6224975585938, -1.42458132609849, 218, 58, 'PPL', 'P'),
(51681, 'Staubs Thurmont Acres', 39.6380615234375, 0.691814682692064, -77.4038925170898, -1.35095277828302, 218, 25, 'PPL', 'P'),
(51680, 'Stauffer', 39.4694404602051, 0.688871689950445, -77.334716796875, -1.34974543420283, 218, 25, 'PPL', 'P'),
(185366, 'Stauffer', 34.7544403076172, 0.606579413055751, -119.065826416016, -2.07809069756751, 218, 6, 'PPL', 'P'),
(25106, 'Staunton', 31.2811107635498, 0.545958376504981, -83.4669418334961, -1.4567729515651, 218, 13, 'PPL', 'P'),
(28686, 'Staunton', 39.0122184753418, 0.680891660902077, -89.7911071777344, -1.56715045926258, 218, 18, 'PPL', 'P'),
(31217, 'Staunton', 39.4874992370605, 0.689186875065455, -87.1888885498047, -1.52173317634848, 218, 19, 'PPL', 'P'),
(69081, 'Staunton', 36.1952781677246, 0.631726777702015, -81.3133316040039, -1.41918536225583, 218, 33, 'PPL', 'P'),
(106549, 'Staunton', 38.1494407653809, 0.665833349150442, -79.0719375610352, -1.38006565637144, 218, 53, 'PPL', 'P'),
(157793, 'Staunton', 40.0400009155273, 0.698829848477496, -84.1808319091797, -1.46923268388309, 218, 41, 'PPL', 'P'),
(83822, 'Staunton Heights', 34.8050003051758, 0.607461851482949, -82.4411087036133, -1.43886878587261, 218, 48, 'PPL', 'P'),
(91026, 'Staunton Mill', 36.1233291625977, 0.630471030669015, -82.8441696166992, -1.44590352589205, 218, 50, 'PPL', 'P'),
(106550, 'Staunton Park', 38.163890838623, 0.666085550505672, -79.0927810668945, -1.38042944417634, 218, 53, 'PPL', 'P'),
(121571, 'Stavanger', 41.398609161377, 0.722542035612316, -88.6138916015625, -1.54660417145262, 218, 18, 'PPL', 'P'),
(6062, 'Stave Creek', 31.5555591583252, 0.550748404620625, -87.9388885498047, -1.53482314573843, 218, 2, 'PPL', 'P'),
(14669, 'Stave Landing', 39.4313888549805, 0.688207564153606, -75.6013870239258, -1.31949312264202, 218, 10, 'PPL', 'P'),
(83823, 'Stave Landing', 34.1769409179688, 0.596500147278128, -79.1911087036133, -1.38214558518279, 218, 48, 'PPL', 'P'),
(12116, 'Staves', 34.0391693115234, 0.594095579129895, -92.2772216796875, -1.61054134290324, 218, 4, 'PPL', 'P'),
(31213, 'Stavetown', 39.410831451416, 0.687848769775745, -85.0100021362305, -1.48370443440463, 218, 19, 'PPL', 'P'),
(6063, 'Stavo', 32.1044387817383, 0.56032816124629, -85.7249984741211, -1.49618347464053, 218, 2, 'PPL', 'P'),
(38369, 'Stay', 37.5102806091309, 0.654677899976318, -83.6522216796875, -1.46000669491873, 218, 21, 'PPL', 'P'),
(43208, 'Stay', 31.4722194671631, 0.549293852612251, -92.491943359375, -1.6142889431892, 218, 22, 'PPL', 'P'),
(25103, 'Stay (historical)', 34.561939239502, 0.603219635603534, -83.9075012207031, -1.46446216342243, 218, 13, 'PPL', 'P'),
(208828, 'Stayman', 47.7658309936523, 0.833671020790388, -120.088607788086, -2.0959416000382, 218, 56, 'PPL', 'P'),
(106553, 'Staytide (historical)', 37.291389465332, 0.650857528813572, -80.6172180175781, -1.40703588820483, 218, 53, 'PPL', 'P'),
(91027, 'Stayton', 36.2769393920898, 0.633152034938398, -87.3269424438477, -1.52414267134473, 218, 50, 'PPL', 'P'),
(201599, 'Stayton', 44.8008308410645, 0.781922005805595, -122.793327331543, -2.14314786141457, 218, 43, 'PPL', 'P'),
(14670, 'Staytonville', 38.8494415283203, 0.678050667230207, -75.519172668457, -1.31805821144669, 218, 10, 'PPL', 'P'),
(25104, 'Steadman', 33.8266716003418, 0.590386794416824, -85.3313903808594, -1.48931371745061, 218, 13, 'PPL', 'P'),
(205903, 'Steadman Estates - Numbers 2-5', 40.6327781677246, 0.709175763259263, -111.95361328125, -1.95395916126227, 218, 52, 'PPL', 'P'),
(128987, 'Steadman Landing', 45.2594413757324, 0.789926269619883, -69.2052764892578, -1.20785993449057, 218, 26, 'PPL', 'P'),
(111530, 'Stealey', 39.2791709899902, 0.68555086122917, -80.3597183227539, -1.40254167070727, 218, 58, 'PPL', 'P'),
(77332, 'Stealy', 34.9280586242676, 0.60960962432307, -97.4061126708984, -1.70005737767575, 218, 42, 'PPL', 'P'),
(179220, 'Steam', 32.7277793884277, 0.5712075071944, -114.699996948242, -2.00189259877427, 218, 5, 'PPL', 'P'),
(123726, 'Steam Corner', 40.042781829834, 0.698878384588363, -87.2433319091797, -1.52268339222542, 218, 19, 'PPL', 'P'),
(157795, 'Steam Corners', 40.6811103820801, 0.710019319534546, -82.664436340332, -1.44276658844405, 218, 41, 'PPL', 'P'),
(74409, 'Steam Furnace', 38.9058303833008, 0.679034838411046, -83.408332824707, -1.4557500313904, 218, 41, 'PPL', 'P'),
(25105, 'Steam Mill', 30.9699993133545, 0.540528457358419, -84.9686126708984, -1.48298205195895, 218, 13, 'PPL', 'P'),
(6064, 'Steam Mill Landing', 30.7547206878662, 0.536771136534481, -87.916389465332, -1.5344304626357, 218, 2, 'PPL', 'P'),
(167578, 'Steam Valley', 41.4583282470703, 0.723584330283946, -77.1311111450195, -1.34619184520228, 218, 45, 'PPL', 'P'),
(179221, 'Steamboat', 35.7513885498047, 0.623979442353893, -109.847221374512, -1.91719568715232, 218, 5, 'PPL', 'P'),
(190776, 'Steamboat', 39.3772201538086, 0.687262141966628, -119.742782592773, -2.08990581174365, 218, 39, 'PPL', 'P'),
(201601, 'Steamboat', 42.0758285522461, 0.734361743741333, -123.203887939453, -2.15031349580159, 218, 43, 'PPL', 'P'),
(195654, 'Steamboat (historical)', 47.6755599975586, 0.832095494689497, -116.143890380859, -2.02709329322137, 218, 17, 'PPL', 'P'),
(179222, 'Steamboat Canyon', 35.7480583190918, 0.623921318863102, -109.849998474121, -1.91724415668416, 218, 5, 'PPL', 'P'),
(194433, 'Steamboat II', 40.5080604553223, 0.706999028542287, -106.906112670898, -1.86586365661521, 218, 7, 'PPL', 'P'),
(14671, 'Steamboat Landing', 38.7986106872559, 0.677163501692075, -75.2425003051758, -1.31322936775816, 218, 10, 'PPL', 'P'),
(83824, 'Steamboat Landing', 32.6019401550293, 0.569011198243412, -80.2930603027344, -1.40137826878507, 218, 48, 'PPL', 'P'),
(117901, 'Steamboat Rock', 42.4094390869141, 0.740184345990628, -93.065559387207, -1.62430043151708, 218, 16, 'PPL', 'P'),
(195655, 'Steamboat Rock', 43.4483299255371, 0.758316411693405, -115.626388549805, -2.01806118238436, 218, 17, 'PPL', 'P'),
(195656, 'Steamboat Rocks', 47.9147186279297, 0.836269600224033, -116.125556945801, -2.02677331441639, 218, 17, 'PPL', 'P'),
(194434, 'Steamboat Springs', 40.4850006103516, 0.706596558322549, -106.831108093262, -1.86455457978138, 218, 7, 'PPL', 'P'),
(133261, 'Steamburg', 41.8758316040039, 0.730871138500566, -84.6125030517578, -1.47676676660692, 218, 27, 'PPL', 'P'),
(152894, 'Steamburg', 42.1080589294434, 0.734924269942585, -78.9044418334961, -1.37714230444286, 218, 40, 'PPL', 'P'),
(157796, 'Steamburg', 41.7138900756836, 0.728044725635665, -80.6183319091797, -1.40705532928079, 218, 41, 'PPL', 'P'),
(167579, 'Steamburg', 41.7377815246582, 0.728461710083344, -80.4705581665039, -1.4044761909231, 218, 45, 'PPL', 'P'),
(38371, 'Steamport Landing', 37.603328704834, 0.656301895609048, -87.4847183227539, -1.52689637991187, 218, 21, 'PPL', 'P'),
(74410, 'Steamtown', 39.8163909912109, 0.69492711905804, -81.3600006103516, -1.41999989007523, 218, 41, 'PPL', 'P'),
(31214, 'Stearleyville', 39.4449996948242, 0.688445118122841, -87.061393737793, -1.51950797209966, 218, 19, 'PPL', 'P'),
(106554, 'Stearnes', 37.7002792358398, 0.657994001586657, -78.2391662597656, -1.36553105524817, 218, 53, 'PPL', 'P'),
(38370, 'Stearns', 36.6988906860352, 0.640516474300794, -84.4775009155273, -1.47441053483248, 218, 21, 'PPL', 'P'),
(69082, 'Stearns', 35.2724990844727, 0.615621244430733, -82.2163925170898, -1.43494674853525, 218, 33, 'PPL', 'P'),
(176530, 'Stearns', 42.6563911437988, 0.74449447247784, -89.6072235107422, -1.56394108383292, 218, 57, 'PPL', 'P'),
(157797, 'Stearns Crest', 41.1997184753418, 0.719070738289453, -83.4272232055664, -1.45607973073335, 218, 41, 'PPL', 'P'),
(126250, 'Stearnsville', 42.4402809143066, 0.74072263742596, -73.3000030517578, -1.27932639497507, 218, 23, 'PPL', 'P'),
(212162, 'Stebbins', 63.5222206115723, 1.10867189785014, -162.288055419922, -2.83246090373667, 218, 1, 'PPL', 'P'),
(152895, 'Stebbins Corners', 42.1627807617188, 0.735879346088515, -79.5263900756836, -1.38799734904602, 218, 40, 'PPL', 'P'),
(176531, 'Stebbinsville', 42.8444404602051, 0.747776552205253, -89.1730575561523, -1.55636345842527, 218, 57, 'PPL', 'P'),
(77329, 'Stecker', 34.9575004577637, 0.610123481255401, -98.315559387207, -1.71593021724678, 218, 42, 'PPL', 'P'),
(18191, 'Steckert', 30.2102794647217, 0.527268844607023, -82.1252822875977, -1.43335657504836, 218, 12, 'PPL', 'P'),
(69083, 'Stecoah', 35.3697204589844, 0.617318077519277, -83.690559387207, -1.46067581414261, 218, 33, 'PPL', 'P'),
(6065, 'Stedman', 31.0711097717285, 0.542293167765246, -86.3036117553711, -1.50628218149411, 218, 2, 'PPL', 'P'),
(69085, 'Stedman', 35.0133285522461, 0.611097865319234, -78.6941680908203, -1.37347233530267, 218, 33, 'PPL', 'P'),
(152896, 'Stedman', 42.1694412231445, 0.735995593070097, -79.476936340332, -1.38713421853673, 218, 40, 'PPL', 'P'),
(185367, 'Stedman', 34.6300010681152, 0.604407538607764, -116.167221069336, -2.02750049055204, 218, 6, 'PPL', 'P'),
(64, 'Steedham', 33.6972198486328, 0.588127435127028, -96.779167175293, -1.68911511454688, 218, 51, 'PPL', 'P'),
(57716, 'Steedman', 38.704719543457, 0.675524792094322, -91.8177795410156, -1.60252256486101, 218, 29, 'PPL', 'P'),
(77330, 'Steedman', 34.815559387207, 0.607646142230382, -96.4797210693359, -1.68388879406566, 218, 42, 'PPL', 'P'),
(83825, 'Steedman', 33.7844390869141, 0.589649698006117, -81.4388885498047, -1.4213767443588, 218, 48, 'PPL', 'P'),
(69086, 'Steeds', 35.4708290100098, 0.619082754636591, -79.7777786254883, -1.39238490694193, 218, 33, 'PPL', 'P'),
(69087, 'Steel (historical)', 35.6786117553711, 0.622709247671979, -80.4552764892578, -1.40420947533993, 218, 33, 'PPL', 'P'),
(185369, 'Steel Canyon Resort', 38.5080604553223, 0.6720924435024, -122.202217102051, -2.13283104166771, 218, 6, 'PPL', 'P'),
(28691, 'Steel City', 37.9980583190918, 0.663191227032974, -88.8791732788086, -1.55123421016577, 218, 18, 'PPL', 'P'),
(167580, 'Steel City', 40.6277809143066, 0.709088544733563, -75.3280563354492, -1.31472260218136, 218, 45, 'PPL', 'P'),
(69090, 'Steel Creek (historical)', 35.1269416809082, 0.61308078848788, -80.960563659668, -1.41302840013168, 218, 33, 'PPL', 'P'),
(83826, 'Steel Creek Landing', 33.0950012207031, 0.577616737252812, -81.6119384765625, -1.42439703535106, 218, 48, 'PPL', 'P'),
(77331, 'Steel Junction', 34.0405616760254, 0.594119880474842, -94.7752838134766, -1.65414075205725, 218, 42, 'PPL', 'P'),
(157798, 'Steel Point', 40.019718170166, 0.698475847789597, -84.5472183227539, -1.47562733313453, 218, 41, 'PPL', 'P'),
(74411, 'Steel Run', 39.4936103820801, 0.689293534667113, -81.2630615234375, -1.4183079838347, 218, 41, 'PPL', 'P'),
(6066, 'Steele', 33.9397201538086, 0.592359863889436, -86.2016677856445, -1.50450292356983, 218, 2, 'PPL', 'P'),
(12118, 'Steele', 36.1436080932617, 0.630824964777887, -94.2388916015625, -1.6447789418773, 218, 4, 'PPL', 'P'),
(57713, 'Steele', 36.0838890075684, 0.629782670106257, -89.8291702270508, -1.5678147847965, 218, 29, 'PPL', 'P'),
(61876, 'Steele', 32.4902801513672, 0.567062363536719, -89.4252777099609, -1.56076553054911, 218, 30, 'PPL', 'P'),
(121572, 'Steele', 41.5058288574219, 0.724413372331288, -87.9622192382813, -1.53523034306911, 218, 18, 'PPL', 'P'),
(140918, 'Steele', 46.8547210693359, 0.81776915276347, -99.9155578613281, -1.74385545864708, 218, 34, 'PPL', 'P'),
(61877, 'Steele (historical)', 33.2152786254883, 0.579715973982067, -89.3263931274414, -1.55903966900469, 218, 30, 'PPL', 'P'),
(185368, 'Steele (historical)', 35.2144393920898, 0.614607911635958, -120.616943359375, -2.1051627953126, 218, 6, 'PPL', 'P'),
(14672, 'Steele Acres', 38.5816688537598, 0.673377152412254, -75.0772171020508, -1.31034463166538, 218, 10, 'PPL', 'P'),
(138277, 'Steele Center', 43.9894409179688, 0.767760580130072, -93.2261123657227, -1.62710260961606, 218, 28, 'PPL', 'P'),
(18192, 'Steele Church', 30.6483306884766, 0.534914280753937, -86.1474990844727, -1.50355750138285, 218, 12, 'PPL', 'P'),
(18193, 'Steele City', 30.7241706848145, 0.536237938394733, -85.3877792358398, -1.49029788863145, 218, 12, 'PPL', 'P'),
(143108, 'Steele City', 40.0377807617188, 0.698791099483635, -97.0244369506836, -1.69339587968308, 218, 35, 'PPL', 'P'),
(152897, 'Steele Corners', 43.0652809143066, 0.751630945250925, -74.1416702270508, -1.29401625838989, 218, 40, 'PPL', 'P'),
(6067, 'Steele Crossing', 34.9780616760254, 0.610482342212289, -86.4105606079102, -1.50814879110215, 218, 2, 'PPL', 'P'),
(83829, 'Steele Crossing', 34.9063911437988, 0.609231455448279, -81.059440612793, -1.41475412851805, 218, 48, 'PPL', 'P'),
(192270, 'Steele Hill', 33.4461097717285, 0.583744737500112, -100.787780761719, -1.75907862007019, 218, 51, 'PPL', 'P'),
(83827, 'Steele Town', 33.3747215270996, 0.582498777584118, -79.2877807617188, -1.38383283089141, 218, 48, 'PPL', 'P'),
(106555, 'Steeleburg', 37.0566711425781, 0.646760921266757, -81.76611328125, -1.42708789331648, 218, 53, 'PPL', 'P'),
(57714, 'Steeles', 36.6805610656738, 0.640196562074848, -90.791389465332, -1.58460867863054, 218, 29, 'PPL', 'P'),
(111532, 'Steeles', 37.538890838623, 0.655177242680708, -81.7755584716797, -1.42725274298795, 218, 58, 'PPL', 'P'),
(126251, 'Steeles Corners', 42.6605606079102, 0.744567243354626, -73.2416687011719, -1.27830826849033, 218, 23, 'PPL', 'P'),
(25107, 'Steeles Mill', 33.3074989318848, 0.581325521965884, -84.1369400024414, -1.46846662559553, 218, 13, 'PPL', 'P'),
(106556, 'Steeles Tavern', 37.9255599975586, 0.66192589262005, -79.2027816772461, -1.38234931700618, 218, 53, 'PPL', 'P'),
(28688, 'Steeleville', 38.0072212219238, 0.663351149856433, -89.658332824707, -1.56483310964005, 218, 18, 'PPL', 'P'),
(193979, 'Steelhead', 41.7769393920898, 0.729145143798086, -123.038063049316, -2.14741930548695, 218, 6, 'PPL', 'P'),
(71435, 'Steelman Landing', 39.3777809143066, 0.687271929083634, -74.7322235107422, -1.30432335759877, 218, 37, 'PPL', 'P'),
(71436, 'Steelmantown', 39.2666702270508, 0.685332681756865, -74.8019409179688, -1.30554015590082, 218, 37, 'PPL', 'P'),
(71437, 'Steelmanville', 39.334171295166, 0.686510797644089, -74.5947189331055, -1.30192344998244, 218, 37, 'PPL', 'P'),
(71438, 'Steels Corner', 39.5813903808594, 0.690825584663208, -75.192497253418, -1.31235664986894, 218, 37, 'PPL', 'P'),
(167584, 'Steelstown', 40.3544387817383, 0.704317824535822, -76.5763931274414, -1.33651018937541, 218, 45, 'PPL', 'P'),
(74412, 'Steelton', 39.9208297729492, 0.696749919666144, -82.9847183227539, -1.44835656357212, 218, 41, 'PPL', 'P'),
(111533, 'Steelton', 39.684440612793, 0.692624150505394, -80.8574981689453, -1.41122956797338, 218, 58, 'PPL', 'P'),
(121573, 'Steelton', 40.0094413757324, 0.698296483890181, -87.6788864135742, -1.53028525239899, 218, 18, 'PPL', 'P'),
(138279, 'Steelton', 46.670280456543, 0.814550056795837, -92.2202835083008, -1.60954758434248, 218, 28, 'PPL', 'P'),
(167581, 'Steelton', 40.235279083252, 0.702238095461552, -76.841667175293, -1.34114009493051, 218, 45, 'PPL', 'P'),
(57715, 'Steelville', 37.9680595397949, 0.662667649562664, -91.3547210693359, -1.59444066990095, 218, 29, 'PPL', 'P'),
(79201, 'Steelville', 39.9047203063965, 0.696468756434059, -75.9938888549805, -1.32634357191403, 218, 45, 'PPL', 'P'),
(6069, 'Steelwood', 30.7155609130859, 0.536087669530225, -87.7847213745117, -1.53213242093107, 218, 2, 'PPL', 'P'),
(98283, 'Steen', 29.3216705322266, 0.511759692972352, -97.3125, -1.69842352834698, 218, 51, 'PPL', 'P'),
(138280, 'Steen', 43.514720916748, 0.759475153083699, -96.2627792358398, -1.68010244478584, 218, 28, 'PPL', 'P'),
(69093, 'Steen Town', 34.8711090087891, 0.608615666025225, -79.6533279418945, -1.39021283275686, 218, 33, 'PPL', 'P'),
(167583, 'Steene', 41.5900001525879, 0.725882438567603, -75.350830078125, -1.31512007897406, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(61878, 'Steens', 33.5633316040039, 0.585790644428538, -88.3161087036133, -1.54140687942727, 218, 30, 'PPL', 'P'),
(6068, 'Steenson Hollow', 34.785831451416, 0.607127291871007, -87.6113891601563, -1.5291072030908, 218, 2, 'PPL', 'P'),
(83828, 'Steep Bottom (historical)', 32.6955604553223, 0.57064518073023, -81.2119369506836, -1.41741569171147, 218, 48, 'PPL', 'P'),
(113082, 'Steep Brook', 41.7416687011719, 0.728529554112114, -71.1291732788086, -1.24143826793678, 218, 23, 'PPL', 'P'),
(6070, 'Steep Creek', 32.1536102294922, 0.561186364907568, -86.4791717529297, -1.5093462814863, 218, 2, 'PPL', 'P'),
(128988, 'Steep Falls', 43.7938919067383, 0.76434760603508, -70.6530609130859, -1.23312853954546, 218, 26, 'PPL', 'P'),
(98284, 'Steep Hollow', 30.6949996948242, 0.535728808573337, -96.2905578613281, -1.68058727326229, 218, 51, 'PPL', 'P'),
(128989, 'Steep Landing', 44.7880592346191, 0.781699099222355, -68.1675033569336, -1.18974737644278, 218, 26, 'PPL', 'P'),
(69094, 'Steep Pines Fork', 34.7241706848145, 0.606051108474506, -76.6483306884766, -1.33776573667133, 218, 33, 'PPL', 'P'),
(69095, 'Steeple', 35.5736083984375, 0.620876593367841, -75.4541702270508, -1.31692370482231, 218, 33, 'PPL', 'P'),
(91028, 'Steeple Chase Farms', 36.0438919067383, 0.62908458900552, -86.9075012207031, -1.51682204098226, 218, 50, 'PPL', 'P'),
(25110, 'Steeplechase', 33.9916687011719, 0.593266537082554, -84.0611114501953, -1.46714316769181, 218, 13, 'PPL', 'P'),
(51683, 'Steeplechase', 39.6197204589844, 0.691494570729036, -76.7750015258789, -1.33997655985026, 218, 25, 'PPL', 'P'),
(179223, 'Steeplechase', 33.644718170166, 0.587211107974959, -112.123611450195, -1.95692618903272, 218, 5, 'PPL', 'P'),
(51682, 'Steeplechase Manor', 39.5791702270508, 0.690786835669348, -76.4625015258789, -1.33452240593778, 218, 25, 'PPL', 'P'),
(91029, 'Steeplechase Meadows', 35.7249984741211, 0.623518848643363, -86.404167175293, -1.50803720465247, 218, 50, 'PPL', 'P'),
(189605, 'Steeplerock (historical)', 32.8530616760254, 0.57339409560741, -108.965278625488, -1.90180288236777, 218, 38, 'PPL', 'P'),
(38372, 'Steff', 37.4297218322754, 0.65327188407881, -86.6055603027344, -1.51155217781721, 218, 21, 'PPL', 'P'),
(205906, 'Steffensen Heights', 40.6116714477539, 0.708807381501478, -111.812217712402, -1.95149134303814, 218, 52, 'PPL', 'P'),
(57717, 'Steffenville', 39.9705581665039, 0.697617843865401, -91.8819427490234, -1.60364242409939, 218, 29, 'PPL', 'P'),
(12120, 'Stegall', 35.6072196960449, 0.621463221176958, -91.1399993896484, -1.59069306961499, 218, 4, 'PPL', 'P'),
(43216, 'Stegall', 30.2366695404053, 0.527729438317553, -93.4291687011719, -1.63064661123668, 218, 22, 'PPL', 'P'),
(91030, 'Stegall', 35.5569381713867, 0.62058564301875, -88.4441680908203, -1.54364193737212, 218, 50, 'PPL', 'P'),
(192271, 'Stegall', 34.0033302307129, 0.593470069168863, -102.955833435059, -1.79691827757664, 218, 51, 'PPL', 'P'),
(199705, 'Stegall', 41.8713912963867, 0.730793640512845, -103.946937561035, -1.81421630780503, 218, 35, 'PPL', 'P'),
(185370, 'Stege', 37.9166717529297, 0.661770763486553, -122.326110839844, -2.1349933953148, 218, 6, 'PPL', 'P'),
(185371, 'Stegeman', 39.357780456543, 0.686922855243752, -122.027496337891, -2.12978158906151, 218, 6, 'PPL', 'P'),
(121574, 'Steger', 41.4700012207031, 0.723788062107337, -87.6363906860352, -1.52954356203541, 218, 18, 'PPL', 'P'),
(208829, 'Stehekin', 48.309440612793, 0.843158798489904, -120.655281066895, -2.10583191453649, 218, 56, 'PPL', 'P'),
(190778, 'Steigmeyer Mill', 38.7341690063477, 0.676038782184707, -117.056671142578, -2.04302432286222, 218, 39, 'PPL', 'P'),
(208830, 'Steilacoom', 47.1699981689453, 0.823271776207792, -122.601387023926, -2.13979787107936, 218, 56, 'PPL', 'P'),
(112380, 'Stein', 30.6902809143066, 0.535646450316627, -89.9391708374023, -1.56973465762634, 218, 22, 'PPL', 'P'),
(117902, 'Stein''s Rockin R Mobile Home Park', 42.7350006103516, 0.745866466492421, -94.4438934326172, -1.64835689880182, 218, 16, 'PPL', 'P'),
(143110, 'Steinauer', 40.2077789306641, 0.701758127254093, -96.23388671875, -1.67959817523343, 218, 35, 'PPL', 'P'),
(152898, 'Steinbeck Corners', 41.4555587768555, 0.723535993910161, -73.6025009155273, -1.28460597867809, 218, 40, 'PPL', 'P'),
(6071, 'Steiner', 32.3502807617188, 0.564618913236571, -86.2608337402344, -1.5055355642825, 218, 2, 'PPL', 'P'),
(61879, 'Steiner', 33.6161117553711, 0.586711831849596, -90.6177825927734, -1.5815786671003, 218, 30, 'PPL', 'P'),
(133269, 'Steiner', 41.9888916015625, 0.732844407710261, -83.3874969482422, -1.45538637674355, 218, 27, 'PPL', 'P'),
(111535, 'Steiner (historical)', 38.7833290100098, 0.676896786108903, -79.9100036621094, -1.39469266918453, 218, 58, 'PPL', 'P'),
(74413, 'Steinersville', 39.8688888549805, 0.695843379631081, -80.8313903808594, -1.41077390111087, 218, 41, 'PPL', 'P'),
(18194, 'Steinhatchee', 29.6708297729492, 0.517853671336725, -83.3877792358398, -1.45539130359157, 218, 12, 'PPL', 'P'),
(106561, 'Steinman', 37.1786117553711, 0.648889186451894, -82.341667175293, -1.4371332037902, 218, 53, 'PPL', 'P'),
(157800, 'Steinman (historical)', 40.3675003051758, 0.704545791125133, -84.4936065673828, -1.47469163148553, 218, 41, 'PPL', 'P'),
(57718, 'Steinmetz', 39.2350006103516, 0.68477994267262, -92.7574996948242, -1.61892377559232, 218, 29, 'PPL', 'P'),
(167585, 'Steins', 40.666389465332, 0.70976239106838, -76.3066711425781, -1.33180265267453, 218, 45, 'PPL', 'P'),
(189606, 'Steins', 32.2291717529297, 0.562505162279375, -108.988891601563, -1.90221500654646, 218, 38, 'PPL', 'P'),
(167586, 'Steinsburg', 40.4661102294922, 0.706266858979597, -75.42138671875, -1.31635152466211, 218, 45, 'PPL', 'P'),
(167587, 'Steinsville', 40.6575012207031, 0.709607261934883, -75.8555603027344, -1.32392928322782, 218, 45, 'PPL', 'P'),
(176532, 'Steinthal', 43.9824981689453, 0.767639406300473, -88.0022201538086, -1.53592849074887, 218, 57, 'PPL', 'P'),
(152899, 'Steinway', 40.7744407653809, 0.711648242015293, -73.904167175293, -1.28987104815318, 218, 40, 'PPL', 'P'),
(43211, 'Stekey', 30.3199996948242, 0.529183823878358, -92.0091705322266, -1.6058629678163, 218, 22, 'PPL', 'P'),
(192272, 'Stekoll Camp', 35.7783317565918, 0.624449690023373, -101.378326416016, -1.76938558612102, 218, 51, 'PPL', 'P'),
(194435, 'Stelbars Lindland', 40.5744400024414, 0.708157570195499, -106.064170837402, -1.85116899951042, 218, 7, 'PPL', 'P'),
(12121, 'Stella', 36.0108299255371, 0.628507548576327, -91.8002777099609, -1.60221710028398, 218, 4, 'PPL', 'P'),
(38374, 'Stella', 36.6402816772461, 0.639493554126095, -88.3966674804688, -1.54281289532478, 218, 21, 'PPL', 'P'),
(43212, 'Stella', 29.8191699981689, 0.52044269667996, -89.9958267211914, -1.57072348933908, 218, 22, 'PPL', 'P'),
(57719, 'Stella', 36.7613906860352, 0.641607305083291, -94.1911087036133, -1.64394497298194, 218, 29, 'PPL', 'P'),
(61880, 'Stella', 31.1838893890381, 0.544261543416438, -90.3447189331055, -1.57681280717155, 218, 30, 'PPL', 'P'),
(69097, 'Stella', 34.774169921875, 0.606923759784698, -77.1508331298828, -1.34653605877318, 218, 33, 'PPL', 'P'),
(74414, 'Stella', 39.3486099243164, 0.686762799262238, -82.5519409179688, -1.44080317293039, 218, 41, 'PPL', 'P'),
(77334, 'Stella', 35.3191719055176, 0.616435838829161, -97.2125015258789, -1.6966782257266, 218, 42, 'PPL', 'P'),
(91031, 'Stella', 35.038890838623, 0.611544011380849, -87.084716796875, -1.51991503627228, 218, 50, 'PPL', 'P'),
(106557, 'Stella', 36.6305618286133, 0.639323910764657, -80.0849990844727, -1.39774691548069, 218, 53, 'PPL', 'P'),
(143112, 'Stella', 40.2330589294434, 0.702199346467692, -95.773063659668, -1.67155529558334, 218, 35, 'PPL', 'P'),
(208831, 'Stella', 46.1908302307129, 0.806182071755672, -123.118606567383, -2.14882505506834, 218, 56, 'PPL', 'P'),
(152900, 'Stella Niagara', 43.2019386291504, 0.7540160723232, -79.0425033569336, -1.37955193259716, 218, 40, 'PPL', 'P'),
(98285, 'Stellar', 29.8902797698975, 0.521683796326964, -97.1402816772461, -1.69541775158266, 218, 51, 'PPL', 'P'),
(51684, 'Stellas Venture', 38.4441719055176, 0.670977377953984, -75.5013885498047, -1.31774782002164, 218, 25, 'PPL', 'P'),
(25111, 'Stellaville', 33.189998626709, 0.579274754768468, -82.3313903808594, -1.43695383989078, 218, 13, 'PPL', 'P'),
(152901, 'Stellaville', 44.4805603027344, 0.776332230414601, -75.2433319091797, -1.3132438819861, 218, 40, 'PPL', 'P'),
(121575, 'Stelle', 40.9500007629395, 0.714712342007483, -88.1533279418945, -1.53856581917638, 218, 18, 'PPL', 'P'),
(12122, 'Stelltown', 34.0466690063477, 0.594226473497473, -93.5491714477539, -1.63274105427598, 218, 4, 'PPL', 'P'),
(146394, 'Stelton', 40.5141716003418, 0.707105688143945, -74.4038925170898, -1.29859290072319, 218, 37, 'PPL', 'P'),
(157801, 'Stelvideo', 40.1519393920898, 0.700783543453178, -84.5511093139648, -1.47569524374233, 218, 41, 'PPL', 'P'),
(69096, 'Stem', 36.1997184753418, 0.631804275689736, -78.7225036621094, -1.3739668843171, 218, 33, 'PPL', 'P'),
(187394, 'Stem Beach', 38.163890838623, 0.666085550505672, -104.643058776855, -1.82636591501408, 218, 7, 'PPL', 'P'),
(167588, 'Stemlersville', 40.8472213745117, 0.712918503276233, -75.6083297729492, -1.31961429647162, 218, 45, 'PPL', 'P'),
(6072, 'Stemley', 33.5183296203613, 0.585005211644046, -86.2225036621094, -1.50486657821668, 218, 2, 'PPL', 'P'),
(6073, 'Stemley Cove', 33.5277786254883, 0.585170127894549, -86.2319412231445, -1.5050312947301, 218, 2, 'PPL', 'P'),
(31218, 'Stemm', 38.9569396972656, 0.679926864218168, -86.5041732788086, -1.50978264043091, 218, 19, 'PPL', 'P'),
(51685, 'Stemmers Run', 39.3305587768555, 0.686447747305282, -76.4722213745117, -1.33469204929921, 218, 25, 'PPL', 'P'),
(106558, 'Stemphleytown', 38.410831451416, 0.670395477255802, -78.9594421386719, -1.37810224085778, 218, 53, 'PPL', 'P'),
(157802, 'Stemple', 40.6180610656738, 0.708918901372125, -81.0897216796875, -1.41528263283637, 218, 41, 'PPL', 'P'),
(6074, 'Stems', 33.1311111450195, 0.578246974324779, -86.7555618286133, -1.51417019832681, 218, 2, 'PPL', 'P'),
(31219, 'Stendal', 38.2666702270508, 0.667879389236922, -87.1444396972656, -1.52095739752294, 218, 19, 'PPL', 'P'),
(111534, 'Stengel (historical)', 37.3300018310547, 0.651531441727416, -80.9863891601563, -1.41347914014617, 218, 58, 'PPL', 'P'),
(138284, 'Stenger''s Mobile Home Park', 45.6855583190918, 0.797363413280038, -92.9652786254883, -1.62255020204868, 218, 28, 'PPL', 'P'),
(117903, 'Stennett', 41.0897216796875, 0.717150932038642, -95.1941680908203, -1.66145166188174, 218, 16, 'PPL', 'P'),
(185372, 'Stent', 37.917781829834, 0.661790137983483, -120.412216186523, -2.10158963207804, 218, 6, 'PPL', 'P'),
(208832, 'Stentz Spring', 46.2280616760254, 0.806831883061651, -117.578056335449, -2.05212421114897, 218, 56, 'PPL', 'P'),
(57720, 'Stepanek Crossing', 39.0205612182617, 0.681037269234677, -91.0652770996094, -1.58938891962918, 218, 29, 'PPL', 'P'),
(171376, 'Stephan', 44.2480583190918, 0.77227430528262, -99.4527816772461, -1.73577849053503, 218, 49, 'PPL', 'P'),
(205909, 'Stephanie Estates', 40.6944389343262, 0.710251946655764, -112.066108703613, -1.95592257677593, 218, 52, 'PPL', 'P'),
(61881, 'Stephen', 33.5625, 0.585776130200597, -88.5447235107422, -1.54539696053048, 218, 30, 'PPL', 'P'),
(138285, 'Stephen', 48.4500007629395, 0.845612035907058, -96.8722229003906, -1.69073924333767, 218, 28, 'PPL', 'P'),
(98286, 'Stephen Creek', 30.6922206878662, 0.535680305751984, -95.1838912963867, -1.66127229798232, 218, 51, 'PPL', 'P'),
(167589, 'Stephen Heights', 41.3416709899902, 0.721548277051553, -75.5124969482422, -1.317941698149, 218, 45, 'PPL', 'P'),
(51686, 'Stephen Knolls', 39.0308303833008, 0.681216499976039, -77.0516662597656, -1.34480527038073, 218, 25, 'PPL', 'P'),
(983, 'Stephens', 36.060001373291, 0.629365752237605, -84.4458312988281, -1.47385779574823, 218, 50, 'PPL', 'P'),
(12124, 'Stephens', 33.4111099243164, 0.583133874925075, -93.0694427490234, -1.62436820896682, 218, 4, 'PPL', 'P'),
(25112, 'Stephens', 33.7947196960449, 0.589829128484561, -83.1616668701172, -1.45144489833023, 218, 13, 'PPL', 'P'),
(38375, 'Stephens', 38.1352806091309, 0.665586207801282, -82.9588928222656, -1.44790582355763, 218, 21, 'PPL', 'P'),
(43213, 'Stephens', 31.7686100006104, 0.554466843292648, -93.1500015258789, -1.62577422486433, 218, 22, 'PPL', 'P'),
(57722, 'Stephens', 38.9775009155273, 0.680285725175056, -92.1308288574219, -1.60798630615342, 218, 29, 'PPL', 'P'),
(106559, 'Stephens', 36.9919395446777, 0.645631141753318, -82.6025009155273, -1.44168561135758, 218, 53, 'PPL', 'P'),
(201602, 'Stephens', 43.3836097717285, 0.757186831917048, -123.39111328125, -2.15358119445912, 218, 43, 'PPL', 'P'),
(61883, 'Stephens (historical)', 31.0750007629395, 0.542361078373043, -90.4736099243164, -1.57906237934434, 218, 30, 'PPL', 'P'),
(106560, 'Stephens City', 39.0833282470703, 0.682132760549081, -78.2183303833008, -1.36516740060132, 218, 53, 'PPL', 'P'),
(98288, 'Stephens Crossing', 32.6186103820801, 0.569302148592503, -97.9641723632813, -1.70979735673049, 218, 51, 'PPL', 'P'),
(123727, 'Stephens Crossing', 40.160831451416, 0.700938739165703, -87.1808319091797, -1.52159256144292, 218, 19, 'PPL', 'P'),
(25114, 'Stephens Crossroad', 33.3125, 0.581412807070611, -84.8272171020508, -1.48051423373483, 218, 13, 'PPL', 'P'),
(69098, 'Stephens Crossroads', 36.4775009155273, 0.636652493875198, -79.6113891601563, -1.38948086293125, 218, 33, 'PPL', 'P'),
(83830, 'Stephens Crossroads', 33.8844413757324, 0.591395067205528, -78.6877822875977, -1.37336088201105, 218, 48, 'PPL', 'P'),
(106562, 'Stephens Fort', 39.0780601501465, 0.682040814912446, -78.3258285522461, -1.36704359758928, 218, 53, 'PPL', 'P'),
(112509, 'Stephens Gap', 34.1572189331055, 0.596155933707235, -94.6999969482422, -1.65282674837541, 218, 42, 'PPL', 'P'),
(38376, 'Stephensburg', 37.6247215270996, 0.656675270793877, -86.0188903808594, -1.50131285605808, 218, 21, 'PPL', 'P'),
(146395, 'Stephensburg', 40.7930603027344, 0.71197321424731, -74.8733291625977, -1.30678611581682, 218, 37, 'PPL', 'P'),
(61884, 'Stephenson', 31.2783298492432, 0.545909840394115, -91.0555572509766, -1.58921927626774, 218, 30, 'PPL', 'P'),
(91032, 'Stephenson', 35.3977813720703, 0.617807832843743, -85.9263916015625, -1.49969844780527, 218, 50, 'PPL', 'P'),
(106566, 'Stephenson', 39.2372207641602, 0.68481869166648, -78.1066665649414, -1.3632184993156, 218, 53, 'PPL', 'P'),
(111536, 'Stephenson', 37.5802803039551, 0.655899625126392, -81.3263931274414, -1.41941332884514, 218, 58, 'PPL', 'P'),
(133262, 'Stephenson', 45.4152793884277, 0.792646156041181, -87.6074981689453, -1.529039292483, 218, 27, 'PPL', 'P'),
(12123, 'Stephenson (historical)', 34.1030616760254, 0.595210711257339, -93.6730575561523, -1.63490327476501, 218, 4, 'PPL', 'P'),
(6075, 'Stephenson Crossing', 33.6986083984375, 0.588151669892948, -87.4161071777344, -1.52569888952771, 218, 2, 'PPL', 'P'),
(98289, 'Stephensons Colonia', 26.1110000610352, 0.455722922053504, -97.9130020141602, -1.70890426565893, 218, 51, 'PPL', 'P'),
(128990, 'Stephensons Landing', 45.7008285522461, 0.797629929126128, -68.9791717529297, -1.20391366238729, 218, 26, 'PPL', 'P'),
(197619, 'Stephensons Trailer Court', 47.4191703796387, 0.827620651688864, -105.592216491699, -1.84293184225881, 218, 31, 'PPL', 'P'),
(38377, 'Stephensport', 37.9124984741211, 0.661697926030739, -86.5272216796875, -1.51018491091357, 218, 21, 'PPL', 'P'),
(176535, 'Stephensville', 44.3733291625977, 0.774460693958547, -88.5841674804688, -1.54608538767227, 218, 57, 'PPL', 'P'),
(25115, 'Stephenton (historical)', 30.8288898468018, 0.538065632561341, -83.1688919067383, -1.45157099900785, 218, 13, 'PPL', 'P'),
(152902, 'Stephentown', 42.5486106872559, 0.742613348641862, -73.3744430541992, -1.28062561811286, 218, 40, 'PPL', 'P'),
(152903, 'Stephentown Center', 42.5652809143066, 0.742904298990953, -73.4108276367188, -1.28126064887479, 218, 40, 'PPL', 'P'),
(43214, 'Stephenville', 29.7780609130859, 0.519725207792779, -91.1658325195313, -1.59114394278754, 218, 22, 'PPL', 'P'),
(61885, 'Stephenville', 33.5480613708496, 0.585524128582448, -90.6716690063477, -1.58251916243926, 218, 30, 'PPL', 'P'),
(98290, 'Stephenville', 32.2205581665039, 0.56235482683584, -98.2019424438477, -1.71394722749911, 218, 51, 'PPL', 'P'),
(114124, 'Stepney', 41.3038902282715, 0.72088887836565, -73.2547225952148, -1.27853610192158, 218, 8, 'PPL', 'P'),
(106563, 'Stepney Plantation', 38.8661117553711, 0.678341617579298, -77.6083297729492, -1.35452088151151, 218, 53, 'PPL', 'P'),
(106564, 'Stepping Stone', 37.3477783203125, 0.651841699994411, -79.8497161865234, -1.39364045423784, 218, 53, 'PPL', 'P'),
(91033, 'Steppsville', 35.547779083252, 0.620425786774318, -85.6983337402344, -1.49571808724004, 218, 50, 'PPL', 'P'),
(111537, 'Stepptown', 37.8630599975586, 0.660835061837554, -82.4166717529297, -1.43844228062403, 218, 58, 'PPL', 'P'),
(6076, 'Steppville', 34.0652809143066, 0.594551312571435, -86.7388916015625, -1.51387924797772, 218, 2, 'PPL', 'P'),
(12125, 'Steprock', 35.4288902282715, 0.618350784810983, -91.6875, -1.6002487579223, 218, 4, 'PPL', 'P'),
(38378, 'Stepstone', 38.0877799987793, 0.664757165753941, -83.8291702270508, -1.46309502967684, 218, 21, 'PPL', 'P'),
(190779, 'Steptoe', 39.4069404602051, 0.687780859167948, -114.763061523438, -2.0029932832528, 218, 39, 'PPL', 'P'),
(208833, 'Steptoe', 47.0061111450195, 0.820411408038993, -117.355003356934, -2.04823120226749, 218, 56, 'PPL', 'P'),
(192972, 'Sterley', 34.211109161377, 0.597096495625224, -101.397216796875, -1.76971528546397, 218, 51, 'PPL', 'P'),
(25116, 'Sterling', 31.2722206115723, 0.545803214081971, -81.5616683959961, -1.42351965692993, 218, 13, 'PPL', 'P'),
(34054, 'Sterling', 38.2099990844727, 0.666890291208067, -98.206672668457, -1.7140297854929, 218, 20, 'PPL', 'P'),
(43215, 'Sterling', 29.8061103820801, 0.520214763380162, -91.4763870239258, -1.59656414139612, 218, 22, 'PPL', 'P'),
(57723, 'Sterling', 37.0438919067383, 0.646537881525463, -92.008056640625, -1.60584352674034, 218, 29, 'PPL', 'P'),
(61886, 'Sterling', 32.3050003051758, 0.56382862018309, -88.7736129760742, -1.54939183532366, 218, 30, 'PPL', 'P'),
(69099, 'Sterling', 35.1080589294434, 0.612751222302982, -80.8866729736328, -1.41173876437381, 218, 33, 'PPL', 'P'),
(77338, 'Sterling', 34.7502784729004, 0.606506775337019, -98.17138671875, -1.71341392949082, 218, 42, 'PPL', 'P'),
(106565, 'Sterling', 39.0061111450195, 0.680785067879446, -77.4288864135742, -1.35138900406957, 218, 53, 'PPL', 'P'),
(114125, 'Sterling', 41.7075004577637, 0.727933205765018, -71.8291702270508, -1.25365551943752, 218, 8, 'PPL', 'P'),
(117904, 'Sterling', 42.0766716003418, 0.734376457706356, -90.2527770996094, -1.57520811945672, 218, 16, 'PPL', 'P'),
(121577, 'Sterling', 41.7886085510254, 0.72934880904245, -89.6961135864258, -1.56549250832595, 218, 18, 'PPL', 'P'),
(126252, 'Sterling', 42.4375, 0.740674101315094, -71.7611083984375, -1.25246761643329, 218, 23, 'PPL', 'P'),
(133265, 'Sterling', 44.0333290100098, 0.768526571838606, -84.0227813720703, -1.46647418162599, 218, 27, 'PPL', 'P'),
(143113, 'Sterling', 40.459171295166, 0.706145751729025, -96.3772201538086, -1.6820998156034, 218, 35, 'PPL', 'P'),
(152905, 'Sterling', 43.3258285522461, 0.756178359391262, -76.6452789306641, -1.33771247344953, 218, 40, 'PPL', 'P'),
(157803, 'Sterling', 40.9674987792969, 0.715017740005488, -81.8486099243164, -1.42852773135983, 218, 41, 'PPL', 'P'),
(167591, 'Sterling', 41.3411102294922, 0.721538489934547, -75.3902816772461, -1.3158086392739, 218, 45, 'PPL', 'P'),
(192803, 'Sterling', 39.1936111450195, 0.684057560226936, -111.691673278809, -1.94938744577698, 218, 52, 'PPL', 'P'),
(194436, 'Sterling', 40.625560760498, 0.709049795739702, -103.207221984863, -1.80130583547254, 218, 7, 'PPL', 'P'),
(195657, 'Sterling', 43.0380592346191, 0.751155837312455, -112.730827331543, -1.96752410543264, 218, 17, 'PPL', 'P'),
(197620, 'Sterling', 45.5652809143066, 0.795264176550783, -111.758613586426, -1.9505557745472, 218, 31, 'PPL', 'P'),
(198957, 'Sterling', 46.8138885498047, 0.817056490855765, -100.291107177734, -1.75041003072198, 218, 34, 'PPL', 'P'),
(208834, 'Sterling', 48.4922218322754, 0.846348932580683, -122.279441833496, -2.1341788674954, 218, 56, 'PPL', 'P'),
(212163, 'Sterling', 60.5372200012207, 1.05657380902547, -150.764724731445, -2.63134084242664, 218, 1, 'PPL', 'P'),
(6077, 'Sterling (historical)', 34.2430610656738, 0.597654161557487, -85.5061111450195, -1.49236317005681, 218, 2, 'PPL', 'P'),
(12126, 'Sterling (historical)', 33.0258293151855, 0.576409459751652, -91.1833267211914, -1.59144927420652, 218, 4, 'PPL', 'P'),
(111538, 'Sterling (historical)', 38.1175003051758, 0.665275882955261, -81.6572189331055, -1.42518732840454, 218, 58, 'PPL', 'P'),
(25117, 'Sterling Acres', 33.8630599975586, 0.59102189175778, -84.1947174072266, -1.46947503154229, 218, 13, 'PPL', 'P'),
(126253, 'Sterling Camp Grounds', 42.4069404602051, 0.740140736727778, -71.7624969482422, -1.25249185119921, 218, 23, 'PPL', 'P'),
(138287, 'Sterling Center', 43.9061088562012, 0.766306161279752, -94.0769424438477, -1.64195239585434, 218, 28, 'PPL', 'P'),
(114126, 'Sterling City', 41.3836097717285, 0.722280246877162, -72.3397216796875, -1.26256632328687, 218, 8, 'PPL', 'P'),
(192273, 'Sterling City', 31.836109161377, 0.555644925890359, -100.984443664551, -1.76251103524114, 218, 51, 'PPL', 'P'),
(152906, 'Sterling Forest', 41.1824989318848, 0.718770200560437, -74.3191680908203, -1.29711418052792, 218, 40, 'PPL', 'P'),
(25121, 'Sterling Heights', 33.5252799987793, 0.585126518631699, -82.0486068725586, -1.4320183366006, 218, 13, 'PPL', 'P'),
(31220, 'Sterling Heights', 39.7425003051758, 0.693637483300169, -86.2841720581055, -1.50594289477123, 218, 19, 'PPL', 'P'),
(133266, 'Sterling Heights', 42.5802803039551, 0.743166087726108, -83.0302810668945, -1.44915178347362, 218, 27, 'PPL', 'P'),
(126254, 'Sterling Junction', 42.4041709899902, 0.740092400353993, -71.7708282470703, -1.25263725979473, 218, 23, 'PPL', 'P'),
(57724, 'Sterling Landing', 39.1130599975586, 0.682651677487483, -90.6941680908203, -1.58291184554199, 218, 29, 'PPL', 'P'),
(91034, 'Sterling Park', 35.1763916015625, 0.613943852418147, -85.2133331298828, -1.48725322971522, 218, 50, 'PPL', 'P'),
(106568, 'Sterling Park', 39.0036087036133, 0.680741392037569, -77.4008331298828, -1.35089938190316, 218, 53, 'PPL', 'P'),
(28692, 'Sterling Place', 38.6263885498047, 0.67415765834873, -90.0397186279297, -1.57148954762664, 218, 18, 'PPL', 'P'),
(106569, 'Sterling Point', 36.8422203063965, 0.643018048091733, -76.3827819824219, -1.33313103742626, 218, 53, 'PPL', 'P'),
(167592, 'Sterling Run', 41.4147186279297, 0.722823198844401, -78.1991729736328, -1.36483304072646, 218, 45, 'PPL', 'P'),
(12127, 'Sterling Springs', 35.9230613708496, 0.626975698317313, -90.7019424438477, -1.58304753359953, 218, 4, 'PPL', 'P'),
(152907, 'Sterling Valley', 43.3480606079102, 0.756566381962087, -76.6308288574219, -1.3374602720943, 218, 40, 'PPL', 'P'),
(146396, 'Sterling Woods', 40.1055603027344, 0.699974075639849, -74.0849990844727, -1.29302716036103, 218, 37, 'PPL', 'P'),
(43217, 'Sterlington', 32.6961097717285, 0.570654768110154, -92.0858306884766, -1.60720093994795, 218, 22, 'PPL', 'P'),
(152908, 'Sterlington', 41.1452789306641, 0.71812058899154, -74.1891708374023, -1.29484530043723, 218, 40, 'PPL', 'P'),
(152909, 'Sterlingville', 44.1030616760254, 0.769743636456772, -75.6875, -1.32099607760321, 218, 40, 'PPL', 'P'),
(167593, 'Sterlingworth', 40.5849990844727, 0.708341860942932, -75.5400009155273, -1.31842173293548, 218, 45, 'PPL', 'P'),
(18198, 'Stern', 30.4666690826416, 0.531743687607656, -83.6416702270508, -1.45982253732935, 218, 12, 'PPL', 'P'),
(51687, 'Sterner Heights Estates', 39.7013893127441, 0.692919961123474, -76.8758316040039, -1.34173637669858, 218, 25, 'PPL', 'P'),
(6078, 'Sterrett', 33.4486083984375, 0.583788346762962, -86.4800033569336, -1.50936079571424, 218, 2, 'PPL', 'P'),
(98291, 'Sterrett', 32.4738883972168, 0.566776273456617, -96.8311080932617, -1.69002165458195, 218, 51, 'PPL', 'P'),
(98292, 'Sterrett Hill', 32.2894401550293, 0.563557044330929, -94.392219543457, -1.64745501929866, 218, 51, 'PPL', 'P'),
(167595, 'Sterrettania', 42.0044403076172, 0.73311578382534, -80.2033309936523, -1.39981219690605, 218, 45, 'PPL', 'P'),
(57725, 'Stet', 39.4230613708496, 0.688062222137115, -93.7586135864258, -1.63639650918822, 218, 29, 'PPL', 'P'),
(167601, 'Stetlersville', 40.6238899230957, 0.709020634125766, -75.5586090087891, -1.31874650543042, 218, 45, 'PPL', 'P'),
(128991, 'Stetson', 44.8916702270508, 0.783507452181546, -69.1433334350586, -1.20677882424605, 218, 26, 'PPL', 'P'),
(193156, 'Stetson', 47.2849998474121, 0.825278934142358, -115.773330688477, -2.02062580651411, 218, 17, 'PPL', 'P'),
(114128, 'Stetson Corner', 41.7861099243164, 0.7293051997796, -72.008056640625, -1.25677767634147, 218, 8, 'PPL', 'P'),
(152910, 'Stetsonville', 42.5997200012207, 0.743505374448984, -75.1972198486328, -1.31243907470467, 218, 40, 'PPL', 'P'),
(176538, 'Stetsonville', 45.0769386291504, 0.786740995798094, -90.3150024414063, -1.57629415654926, 218, 57, 'PPL', 'P'),
(176540, 'Stettin (historical)', 44.9730606079102, 0.784927982306995, -89.807502746582, -1.56743661592171, 218, 57, 'PPL', 'P'),
(51688, 'Steuart Corner', 38.9336090087891, 0.679519666887495, -76.5694427490234, -1.33638888238776, 218, 25, 'PPL', 'P'),
(51689, 'Steuart Level', 38.9283294677734, 0.679427521513778, -76.5719375610352, -1.33643242507158, 218, 25, 'PPL', 'P'),
(117905, 'Steuben', 40.7236099243164, 0.71076107647716, -92.3883285522461, -1.61248052365098, 218, 16, 'PPL', 'P'),
(128992, 'Steuben', 44.5105590820313, 0.77685580788491, -67.9658279418945, -1.18622747643002, 218, 26, 'PPL', 'P'),
(133268, 'Steuben', 46.1883316040039, 0.806138462492822, -86.456672668457, -1.50895359838357, 218, 27, 'PPL', 'P'),
(152911, 'Steuben', 43.3199996948242, 0.756076626637621, -75.283332824707, -1.31394202966586, 218, 40, 'PPL', 'P'),
(157804, 'Steuben', 41.1047210693359, 0.717412720773796, -82.6872177124023, -1.44316419839479, 218, 41, 'PPL', 'P'),
(167597, 'Steuben', 40.6916694641113, 0.710203610281979, -75.366943359375, -1.31540130878517, 218, 45, 'PPL', 'P'),
(176542, 'Steuben', 43.1811103820801, 0.753652550834404, -90.8586120605469, -1.58578193424877, 218, 57, 'PPL', 'P'),
(185373, 'Steuben Place', 39.9644393920898, 0.697511051105689, -122.743606567383, -2.14228007037337, 218, 6, 'PPL', 'P'),
(152914, 'Steuben Valley', 43.2936096191406, 0.755616032927092, -75.245002746582, -1.31327304360003, 218, 40, 'PPL', 'P'),
(38379, 'Steubenville', 36.8875007629395, 0.643808341145214, -84.8027801513672, -1.48008772848625, 218, 21, 'PPL', 'P'),
(123731, 'Steubenville', 41.5322189331055, 0.724873966041817, -85.0227813720703, -1.48392747414593, 218, 19, 'PPL', 'P'),
(157805, 'Steubenville', 40.3697204589844, 0.704584540118994, -80.6341705322266, -1.40733176540194, 218, 41, 'PPL', 'P'),
(12128, 'Steve', 34.8705596923828, 0.608606078645301, -93.3219375610352, -1.62877507478063, 218, 4, 'PPL', 'P'),
(197621, 'Steve Forks', 47.2708282470703, 0.825031593056117, -107.33332824707, -1.87331997503521, 218, 31, 'PPL', 'P'),
(43221, 'Steven', 32.4961090087891, 0.56716409629036, -92.1672210693359, -1.6086214700734, 218, 22, 'PPL', 'P'),
(25119, 'Steven Hills', 33.9741706848145, 0.592961139084549, -84.1380615234375, -1.46848619982954, 218, 13, 'PPL', 'P'),
(6079, 'Stevens', 33.1277809143066, 0.578188850833988, -88.120002746582, -1.5379841847943, 218, 2, 'PPL', 'P'),
(25120, 'Stevens', 34.3413887023926, 0.599370302563934, -83.8013916015625, -1.46261020120039, 218, 13, 'PPL', 'P'),
(57726, 'Stevens', 38.6583290100098, 0.67471512454391, -90.6224975585938, -1.58166095877798, 218, 29, 'PPL', 'P'),
(61887, 'Stevens', 32.0308303833008, 0.559043452336436, -89.2755584716797, -1.55815243688753, 218, 30, 'PPL', 'P'),
(117906, 'Stevens', 43.4316711425781, 0.758025661081396, -94.0038909912109, -1.64067740748247, 218, 16, 'PPL', 'P'),
(146397, 'Stevens', 40.0886116027832, 0.699678265021768, -74.8252792358398, -1.30594748638955, 218, 37, 'PPL', 'P'),
(167600, 'Stevens', 40.2161102294922, 0.701903535849611, -76.1555633544922, -1.32916532424703, 218, 45, 'PPL', 'P'),
(172596, 'Stevens', 44.5980606079102, 0.778382997612016, -71.5611114501953, -1.24897701119252, 218, 55, 'PPL', 'P'),
(185374, 'Stevens', 35.3141708374023, 0.616348553724434, -119.189720153809, -2.0802530512146, 218, 6, 'PPL', 'P'),
(192275, 'Stevens', 36.4188919067383, 0.635629573700499, -101.92472076416, -1.77892196651043, 218, 51, 'PPL', 'P'),
(195658, 'Stevens', 44.8486099243164, 0.782755908121926, -116.377777099609, -2.03117538654024, 218, 17, 'PPL', 'P'),
(51690, 'Stevens Corner', 39.144718170166, 0.683204216834647, -75.8986129760742, -1.32468069412939, 218, 25, 'PPL', 'P'),
(126257, 'Stevens Corner', 42.3994407653809, 0.740009842360201, -73.331672668457, -1.27987913405931, 218, 23, 'PPL', 'P'),
(128996, 'Stevens Corner', 43.6572189331055, 0.761962212646697, -70.9674987792969, -1.23861651560379, 218, 26, 'PPL', 'P'),
(453, 'Stevens Creek', 33.5605583190918, 0.585742241475726, -82.0566711425781, -1.43215908466421, 218, 13, 'PPL', 'P'),
(106570, 'Stevens Creek', 36.7286109924316, 0.641035191502114, -80.9991683959961, -1.41370217988747, 218, 53, 'PPL', 'P'),
(25122, 'Stevens Creek West', 33.5511093139648, 0.585577325225222, -82.084716796875, -1.43264857367256, 218, 13, 'PPL', 'P'),
(25123, 'Stevens Crossing', 32.7724990844727, 0.571988013130875, -82.2547225952148, -1.43561573460107, 218, 13, 'PPL', 'P'),
(126256, 'Stevens Crossing', 42.6922187805176, 0.74511978270179, -71.1111068725586, -1.24112294966372, 218, 23, 'PPL', 'P'),
(25124, 'Stevens Forest', 33.4075012207031, 0.583070891165294, -84.5647201538086, -1.47593279771157, 218, 13, 'PPL', 'P'),
(51702, 'Stevens Forest', 39.1986083984375, 0.684144778752636, -76.8444366455078, -1.3411884313043, 218, 25, 'PPL', 'P'),
(176544, 'Stevens Hill', 44.8402786254883, 0.782610499526408, -87.3694381713867, -1.52488436170831, 218, 57, 'PPL', 'P'),
(152916, 'Stevens Landing', 44.4872207641602, 0.776448477396183, -73.7125015258789, -1.28652585150793, 218, 40, 'PPL', 'P'),
(69101, 'Stevens Mill', 35.3447189331055, 0.616881718574668, -78.116943359375, -1.36339786321501, 218, 33, 'PPL', 'P'),
(128997, 'Stevens Mill', 44.0877799987793, 0.7694769208736, -70.2624969482422, -1.22631191241929, 218, 26, 'PPL', 'P'),
(172597, 'Stevens Mills', 44.9952812194824, 0.785315805140738, -72.6144409179688, -1.26736107851345, 218, 55, 'PPL', 'P'),
(167602, 'Stevens Point', 41.9599990844727, 0.732340138157854, -75.5236129760742, -1.31813570943441, 218, 45, 'PPL', 'P'),
(176545, 'Stevens Point', 44.523609161377, 0.777083574737139, -89.5744400024414, -1.56336890367272, 218, 57, 'PPL', 'P'),
(25125, 'Stevens Pointe', 33.5411109924316, 0.585402821594795, -82.0586090087891, -1.43219290681005, 218, 13, 'PPL', 'P'),
(91035, 'Stevens Shop (historical)', 35.9955596923828, 0.628241032730237, -86.7788925170898, -1.51457739565749, 218, 50, 'PPL', 'P'),
(212164, 'Stevens Village', 66.0063934326172, 1.15202889276593, -149.090835571289, -2.60212596526848, 218, 1, 'PPL', 'P'),
(106575, 'Stevensburg', 38.4430618286133, 0.670958003457054, -77.9000015258789, -1.35961151393519, 218, 53, 'PPL', 'P'),
(111539, 'Stevensburg', 39.3008308410645, 0.685928896945907, -79.7958297729492, -1.39269995889888, 218, 58, 'PPL', 'P'),
(43222, 'Stevensdale', 30.4775009155273, 0.531932738755538, -91.0013885498047, -1.58827385408076, 218, 22, 'PPL', 'P'),
(6080, 'Stevenson', 34.8686103820801, 0.608572056762375, -85.8394393920898, -1.49818084545809, 218, 2, 'PPL', 'P'),
(31221, 'Stevenson', 38.0166702270508, 0.663516066106936, -87.4333267211914, -1.52599942725673, 218, 19, 'PPL', 'P'),
(38380, 'Stevenson', 37.5808296203613, 0.655909212506316, -83.2611083984375, -1.45318048041264, 218, 21, 'PPL', 'P'),
(43223, 'Stevenson', 32.9208297729492, 0.574576872026541, -91.9430618286133, -1.60470915327402, 218, 22, 'PPL', 'P'),
(51691, 'Stevenson', 39.4102783203125, 0.687839115816794, -76.7133331298828, -1.3389002432957, 218, 25, 'PPL', 'P'),
(114129, 'Stevenson', 41.3830604553223, 0.722270659497237, -73.1849975585938, -1.27731917046147, 218, 8, 'PPL', 'P'),
(138291, 'Stevenson', 47.4366683959961, 0.827926049686869, -93.0577774047852, -1.62416461030149, 218, 28, 'PPL', 'P'),
(167603, 'Stevenson', 41.6230583190918, 0.726459412417768, -76.4349975585938, -1.33404237115129, 218, 45, 'PPL', 'P'),
(208836, 'Stevenson', 45.6958312988281, 0.797542710600428, -121.883331298828, -2.12726543446361, 218, 56, 'PPL', 'P'),
(51692, 'Stevenson Garden Estates', 39.5380592346191, 0.690069313492653, -77.0736083984375, -1.34518823294549, 218, 25, 'PPL', 'P'),
(205917, 'Stevenson Island', 40.6408309936523, 0.709316311585792, -111.893890380859, -1.95291680001161, 218, 52, 'PPL', 'P'),
(51693, 'Stevenson Park', 39.1263885498047, 0.682884304608701, -76.6477813720703, -1.3377561492914, 218, 25, 'PPL', 'P'),
(167604, 'Stevenstown', 40.101390838623, 0.699901304763062, -76.9877777099609, -1.34369020483232, 218, 45, 'PPL', 'P'),
(176547, 'Stevenstown', 44.0363883972168, 0.768579968218462, -91.17138671875, -1.59124088185122, 218, 57, 'PPL', 'P'),
(51694, 'Stevensville', 38.9805603027344, 0.680339121554912, -76.3147201538086, -1.33194313442203, 218, 25, 'PPL', 'P'),
(106572, 'Stevensville', 37.7277793884277, 0.658473969794117, -76.9199981689453, -1.34250722867611, 218, 53, 'PPL', 'P'),
(128998, 'Stevensville', 46.7961082458496, 0.816746166009744, -67.8649978637695, -1.1844676595817, 218, 26, 'PPL', 'P'),
(133270, 'Stevensville', 42.0144386291504, 0.733290287455767, -86.5194396972656, -1.51004908969797, 218, 27, 'PPL', 'P'),
(167605, 'Stevensville', 41.7605590820313, 0.728859253455066, -76.1766662597656, -1.32953363942578, 218, 45, 'PPL', 'P'),
(172598, 'Stevensville', 44.5050010681152, 0.776758802242204, -72.866943359375, -1.27176807748531, 218, 55, 'PPL', 'P'),
(197622, 'Stevensville', 46.5099983215332, 0.811752605807791, -114.092216491699, -1.99128482867833, 218, 31, 'PPL', 'P'),
(200221, 'Stevensville (historical)', 40.3413887023926, 0.704090057683593, -118.095001220703, -2.06114660144799, 218, 39, 'PPL', 'P'),
(51695, 'Stevenswood', 39.3569412231445, 0.686908207857756, -76.7769393920898, -1.3400103819961, 218, 25, 'PPL', 'P'),
(152917, 'Stever Mill', 43.0663909912109, 0.751650319747855, -74.1624984741211, -1.29437977987868, 218, 40, 'PPL', 'P'),
(185375, 'Stevinson', 37.3277816772461, 0.651492692733556, -120.850563049316, -2.10924022809957, 218, 6, 'PPL', 'P'),
(121580, 'Steward', 41.8477783203125, 0.730381516334155, -89.0199966430664, -1.55369204153581, 218, 18, 'PPL', 'P'),
(18199, 'Steward City', 29.6683292388916, 0.517810028784362, -83.3883285522461, -1.45540089097149, 218, 12, 'PPL', 'P'),
(98293, 'Stewards Mill', 31.8233299255371, 0.555421886149065, -96.2013931274414, -1.6790310550793, 218, 51, 'PPL', 'P'),
(106574, 'Stewardsburg', 37.7511100769043, 0.65888116712479, -79.3741683959961, -1.38534057954256, 218, 53, 'PPL', 'P'),
(28694, 'Stewardson', 39.2630615234375, 0.685269697997085, -88.6297225952148, -1.54688047441571, 218, 18, 'PPL', 'P'),
(121581, 'Stewardsville (historical)', 40.3074989318848, 0.703498569605487, -90.5822219848633, -1.58095801740826, 218, 18, 'PPL', 'P'),
(91036, 'Stewardtown (historical)', 35.023609161377, 0.611277295797678, -84.3600006103516, -1.47235976763506, 218, 50, 'PPL', 'P'),
(6082, 'Stewart', 32.9111099243164, 0.574407228665103, -87.7061080932617, -1.53076036033746, 218, 2, 'PPL', 'P'),
(12129, 'Stewart', 35.4777793884277, 0.619204061624244, -90.6013870239258, -1.58129251044117, 218, 4, 'PPL', 'P'),
(25126, 'Stewart', 33.4219398498535, 0.583322892783443, -83.8522186279297, -1.4634973001595, 218, 13, 'PPL', 'P'),
(61888, 'Stewart', 33.4505615234375, 0.583822435224915, -89.4361114501953, -1.56095461498651, 218, 30, 'PPL', 'P'),
(74416, 'Stewart', 39.3080596923828, 0.686055064202549, -81.8947219848633, -1.42933253864125, 218, 41, 'PPL', 'P'),
(91037, 'Stewart', 36.3205604553223, 0.633913366115024, -87.8413925170898, -1.53312151895993, 218, 50, 'PPL', 'P'),
(98294, 'Stewart', 32.2975006103516, 0.563697725815513, -94.6477813720703, -1.65191541465038, 218, 51, 'PPL', 'P'),
(111540, 'Stewart', 39.2425003051758, 0.684910837040197, -81.51611328125, -1.42272457018649, 218, 58, 'PPL', 'P'),
(112355, 'Stewart', 37.6911087036133, 0.657833945605143, -85.0083312988281, -1.4836752727907, 218, 21, 'PPL', 'P'),
(112423, 'Stewart', 36.372501373291, 0.634819906150087, -89.6163864135742, -1.56410100665638, 218, 29, 'PPL', 'P'),
(123732, 'Stewart', 40.3600006103516, 0.704414896757556, -87.4725036621094, -1.52668319386661, 218, 19, 'PPL', 'P'),
(138293, 'Stewart', 47.103328704834, 0.822108174548509, -91.7091674804688, -1.60062692679709, 218, 28, 'PPL', 'P'),
(167607, 'Stewart', 40.3769416809082, 0.704710574217582, -79.7724990844727, -1.39229276156821, 218, 45, 'PPL', 'P'),
(190780, 'Stewart', 39.1163902282715, 0.682709800978274, -119.757499694824, -2.09016267363079, 218, 39, 'PPL', 'P'),
(43225, 'Stewart (historical)', 30.9569396972656, 0.540300524058622, -92.2680587768555, -1.61038142007978, 218, 22, 'PPL', 'P'),
(157808, 'Stewart (historical)', 40.7799987792969, 0.711745247657999, -82.5902786254883, -1.44147229215427, 218, 41, 'PPL', 'P'),
(185376, 'Stewart (historical)', 37.732780456543, 0.658561254898844, -121.003326416016, -2.1119064518249, 218, 6, 'PPL', 'P'),
(190781, 'Stewart (historical)', 36.2333297729492, 0.632390903498853, -115.114440917969, -2.00912601061104, 218, 39, 'PPL', 'P'),
(91038, 'Stewart Chapel', 35.8041687011719, 0.624900629774951, -85.8838882446289, -1.49895662428363, 218, 50, 'PPL', 'P'),
(98295, 'Stewart Colonia', 25.9309997558594, 0.452581324073592, -97.4380035400391, -1.70061397834357, 218, 51, 'PPL', 'P'),
(51697, 'Stewart Corner', 39.1363906860352, 0.683058874818156, -76.6858291625977, -1.33842020850922, 218, 25, 'PPL', 'P'),
(152920, 'Stewart Corners', 43.2694396972656, 0.755194188210424, -76.2394409179688, -1.33062926389824, 218, 40, 'PPL', 'P'),
(69102, 'Stewart Crossroads', 34.4727783203125, 0.601663483999574, -79.2574996948242, -1.38330432657308, 218, 33, 'PPL', 'P'),
(83833, 'Stewart Crossroads', 34.8016700744629, 0.607403727992158, -80.5980606079102, -1.40670152832997, 218, 48, 'PPL', 'P'),
(91040, 'Stewart Hill', 36.3077812194824, 0.63369032637373, -82.508056640625, -1.44003724780088, 218, 50, 'PPL', 'P'),
(152921, 'Stewart Landing', 43.1425018310547, 0.752978704499587, -74.5938873291016, -1.3019089357545, 218, 40, 'PPL', 'P'),
(201603, 'Stewart Lenox', 42.1916694641113, 0.736383549061894, -121.808326721191, -2.12595635762978, 218, 43, 'PPL', 'P'),
(152922, 'Stewart Manor', 40.7191696166992, 0.710683578489439, -73.6888885498047, -1.28611372732924, 218, 40, 'PPL', 'P'),
(25128, 'Stewart Mill', 34.8208312988281, 0.607738154446044, -84.3169403076172, -1.47160822357544, 218, 13, 'PPL', 'P'),
(25129, 'Stewart Mill Acres', 33.7097206115723, 0.588345614599333, -84.758056640625, -1.47930715597075, 218, 13, 'PPL', 'P'),
(179224, 'Stewart Mountain Trailer Park', 33.4161109924316, 0.583221160029802, -111.628059387207, -1.94827717391853, 218, 5, 'PPL', 'P'),
(98296, 'Stewart Palms Colonia', 26.2929992675781, 0.458899407443696, -98.2900009155273, -1.71548413776419, 218, 51, 'PPL', 'P'),
(98297, 'Stewart Place Colonia', 26.2269992828369, 0.457747490403696, -98.3000030517578, -1.71565870797365, 218, 51, 'PPL', 'P'),
(98298, 'Stewart Place Community Colonia', 26.2919998168945, 0.458881963738556, -98.2900009155273, -1.71548413776419, 218, 51, 'PPL', 'P'),
(43224, 'Stewart Plantation', 30.7208309173584, 0.536179648456374, -91.5330581665039, -1.59755323942498, 218, 22, 'PPL', 'P'),
(167609, 'Stewart Run', 41.5488891601563, 0.725164916390908, -79.4972229003906, -1.38748828580365, 218, 45, 'PPL', 'P'),
(6083, 'Stewart Settlement', 33.0730590820313, 0.577233774688059, -87.2505569458008, -1.52280949290303, 218, 2, 'PPL', 'P'),
(98299, 'Stewart South Colonia', 26.2830009460449, 0.458724903813268, -98.2910003662109, -1.71550158146933, 218, 51, 'PPL', 'P'),
(25130, 'Stewart Town', 34.8211097717285, 0.607743014715034, -85.5630569458008, -1.49335706177563, 218, 13, 'PPL', 'P'),
(51698, 'Stewart Town', 39.1791687011719, 0.68380549202976, -77.1900024414063, -1.347219692225, 218, 25, 'PPL', 'P'),
(25131, 'Stewart Woods', 33.7083282470703, 0.588321313254386, -84.7474975585938, -1.47912286522332, 218, 13, 'PPL', 'P'),
(79203, 'Stewarton', 39.9233283996582, 0.696793528928994, -79.4775009155273, -1.38714407223276, 218, 45, 'PPL', 'P'),
(106577, 'Stewartown', 38.9500007629395, 0.679805756967597, -77.6486129760742, -1.35522395603929, 218, 53, 'PPL', 'P'),
(6085, 'Stewarts', 33.6186103820801, 0.586755441112446, -86.3158264160156, -1.50649536753937, 218, 2, 'PPL', 'P'),
(6084, 'Stewarts Crossroads', 33.5405616760254, 0.585393234214871, -86.4574966430664, -1.50896797945345, 218, 2, 'PPL', 'P'),
(131, 'Stewarts Landing', 37.5086097717285, 0.654648738362381, -75.9044418334961, -1.32478242688303, 218, 53, 'PPL', 'P'),
(51699, 'Stewarts Landing', 39.0944404602051, 0.682326705255466, -76.5388870239258, -1.33585558437947, 218, 25, 'PPL', 'P'),
(69107, 'Stewarts Mill', 36.0419387817383, 0.629050500543567, -79.6658325195313, -1.39043107880819, 218, 33, 'PPL', 'P'),
(185378, 'Stewarts Point', 38.6519393920898, 0.674603604673263, -123.398063659668, -2.15370250144677, 218, 6, 'PPL', 'P'),
(190782, 'Stewarts Point', 36.3805618286133, 0.634960587634671, -114.406936645508, -1.99677773158467, 218, 39, 'PPL', 'P'),
(51700, 'Stewarts Purchase', 39.0888900756836, 0.682229832770814, -76.6041717529297, -1.33699501785186, 218, 25, 'PPL', 'P'),
(79204, 'Stewartstown', 39.7536087036133, 0.693831361427526, -76.591667175293, -1.33677677180053, 218, 45, 'PPL', 'P'),
(111541, 'Stewartstown', 39.7041702270508, 0.692968497234341, -79.9008331298828, -1.39453261320302, 218, 58, 'PPL', 'P'),
(144506, 'Stewartstown', 45.0061111450195, 0.785504822999106, -71.5083312988281, -1.24805582377146, 218, 36, 'PPL', 'P'),
(144507, 'Stewartstown Hollow', 44.9486083984375, 0.78450121074231, -71.4530563354492, -1.24709109366658, 218, 36, 'PPL', 'P'),
(31223, 'Stewartsville', 38.1847190856934, 0.666449071994468, -87.8327789306641, -1.53297118351639, 218, 19, 'PPL', 'P'),
(38381, 'Stewartsville', 38.6330604553223, 0.674274105067393, -84.6483306884766, -1.47739207683087, 218, 21, 'PPL', 'P'),
(57727, 'Stewartsville', 39.7508316040039, 0.693782891895687, -94.4963912963867, -1.64927315937486, 218, 29, 'PPL', 'P'),
(106578, 'Stewartsville', 37.2705612182617, 0.650494007324776, -79.7927780151367, -1.39264669567708, 218, 53, 'PPL', 'P'),
(146398, 'Stewartsville', 40.6936111450195, 0.710237499006851, -75.1113891601563, -1.31094104659151, 218, 37, 'PPL', 'P'),
(157809, 'Stewartsville', 40.0119400024414, 0.69834009315303, -80.8583297729492, -1.41124408220132, 218, 41, 'PPL', 'P'),
(167610, 'Stewartsville', 40.3400001525879, 0.704065822917674, -79.7547225952148, -1.39198250330122, 218, 45, 'PPL', 'P'),
(6087, 'Stewartville', 34.9480590820313, 0.609958698162952, -87.8688888549805, -1.53360142058836, 218, 2, 'PPL', 'P'),
(126258, 'Stewartville', 42.711109161377, 0.745449482044742, -72.6736068725586, -1.26839371922613, 218, 23, 'PPL', 'P'),
(138295, 'Stewartville', 43.8555603027344, 0.765423922589636, -92.4883270263672, -1.61422582627136, 218, 28, 'PPL', 'P'),
(167611, 'Stewartville', 41.600830078125, 0.726071456425971, -80.4274978637695, -1.40372464686348, 218, 45, 'PPL', 'P'),
(185379, 'Stewartville', 37.9463882446289, 0.662289414108846, -121.847503662109, -2.12664012423966, 218, 6, 'PPL', 'P'),
(51701, 'Steyer', 39.3055610656738, 0.6860114549397, -79.3111114501953, -1.38424002822208, 218, 25, 'PPL', 'P'),
(195659, 'Stibnite', 44.8983306884766, 0.783623699163128, -115.338333129883, -2.01303366687851, 218, 17, 'PPL', 'P'),
(139468, 'Sticklerville', 40.1605606079102, 0.700934012054768, -92.8936080932617, -1.62129931528467, 218, 29, 'PPL', 'P'),
(133271, 'Stickley', 46.313060760498, 0.80831539694688, -89.3947219848633, -1.56023223254082, 218, 27, 'PPL', 'P'),
(106579, 'Stickleyville', 36.7069396972656, 0.640656956048296, -82.9072189331055, -1.44700394405447, 218, 53, 'PPL', 'P'),
(57728, 'Stickney', 38.0675010681152, 0.664403231645069, -91.9352798461914, -1.60457333205843, 218, 29, 'PPL', 'P'),
(111542, 'Stickney', 37.9013900756836, 0.661504047903382, -81.5277786254883, -1.42292816885183, 218, 58, 'PPL', 'P'),
(112328, 'Stickney', 38.6380615234375, 0.674361390172121, -98.8291702270508, -1.72489441747599, 218, 20, 'PPL', 'P'),
(121583, 'Stickney', 41.8213882446289, 0.729920922623626, -87.7827835083008, -1.53209859878523, 218, 18, 'PPL', 'P'),
(167612, 'Stickney', 41.9619407653809, 0.732374026882725, -78.8055572509766, -1.37541644289843, 218, 45, 'PPL', 'P'),
(171380, 'Stickney', 43.589168548584, 0.760774509379548, -98.4369430541992, -1.71804876189394, 218, 49, 'PPL', 'P'),
(128999, 'Stickney Corner', 44.2452812194824, 0.77222583575078, -69.3824996948242, -1.21095306293864, 218, 26, 'PPL', 'P'),
(152923, 'Stickneys', 42.4691696166992, 0.74122684039934, -77.2994384765625, -1.34912971135881, 218, 40, 'PPL', 'P'),
(79206, 'Sticks', 39.746940612793, 0.69371498128789, -76.804443359375, -1.34049041678259, 218, 45, 'PPL', 'P'),
(38382, 'Stidham', 37.8824996948242, 0.66117434856043, -82.5852813720703, -1.44138507362857, 218, 21, 'PPL', 'P'),
(77339, 'Stidham', 35.3686103820801, 0.617298703022347, -95.6994400024414, -1.67027032035737, 218, 42, 'PPL', 'P'),
(83831, 'Stiefeltown', 33.5522193908691, 0.585596699722153, -81.7958297729492, -1.42760654393877, 218, 48, 'PPL', 'P'),
(167613, 'Stiefler Corner', 40.2705612182617, 0.702853884884606, -78.5283279418945, -1.37057787867192, 218, 45, 'PPL', 'P'),
(12130, 'Stier', 35.7044410705566, 0.623160054265502, -90.3413925170898, -1.57675475025979, 218, 4, 'PPL', 'P'),
(167614, 'Stier', 40.8980598449707, 0.71380580197242, -75.1533279418945, -1.31167301641711, 218, 45, 'PPL', 'P'),
(167615, 'Stiffler', 40.4375, 0.705767516275207, -78.4124984741211, -1.36855627308844, 218, 45, 'PPL', 'P'),
(167616, 'Stifflertown', 40.7336082458496, 0.710935580107588, -78.8022232055664, -1.37535825282861, 218, 45, 'PPL', 'P'),
(77340, 'Stigler', 35.2536087036133, 0.615291545087782, -95.1227798461914, -1.66020570196575, 218, 42, 'PPL', 'P'),
(38383, 'Stiles', 37.5394401550293, 0.655186830060632, -85.5805587768555, -1.49366252635266, 218, 21, 'PPL', 'P'),
(69108, 'Stiles', 35.2802810668945, 0.615757065646327, -83.4850006103516, -1.45708813668011, 218, 33, 'PPL', 'P'),
(117907, 'Stiles', 40.6349983215332, 0.709214512253124, -92.3511123657227, -1.61183097866111, 218, 16, 'PPL', 'P'),
(140924, 'Stiles', 46.0752792358398, 0.804165326441182, -97.0522232055664, -1.69388084131758, 218, 34, 'PPL', 'P'),
(152924, 'Stiles', 43.1138916015625, 0.752479361795197, -76.2769393920898, -1.33128373573613, 218, 40, 'PPL', 'P'),
(167617, 'Stiles', 40.6652793884277, 0.70974301657145, -75.5086135864258, -1.31787392069925, 218, 45, 'PPL', 'P'),
(176548, 'Stiles', 44.8611106872559, 0.782974087594231, -88.0483322143555, -1.53673329803029, 218, 57, 'PPL', 'P'),
(192276, 'Stiles', 31.4066696166992, 0.548149791897467, -101.565826416016, -1.7726580784685, 218, 51, 'PPL', 'P'),
(38384, 'Stiles Crossing', 37.0186080932617, 0.646096595732837, -88.5027770996094, -1.54466485754682, 218, 21, 'PPL', 'P'),
(167618, 'Stiles Crossing', 40.5913887023926, 0.708453380813579, -78.8722229003906, -1.37657997797869, 218, 45, 'PPL', 'P'),
(176549, 'Stiles Junction', 44.8833312988281, 0.783361910427974, -88.0466690063477, -1.53670426957441, 218, 57, 'PPL', 'P'),
(83832, 'Stiles Point', 32.7391700744629, 0.571406312169775, -79.9236068725586, -1.39493008999572, 218, 48, 'PPL', 'P'),
(25133, 'Stilesboro', 34.1047210693359, 0.595239673134193, -84.9158325195313, -1.48206086453789, 218, 13, 'PPL', 'P'),
(25132, 'Stilesboro Hills', 34.0036087036133, 0.593474929437852, -84.6691665649414, -1.47775573147772, 218, 13, 'PPL', 'P'),
(31224, 'Stilesville', 39.6383285522461, 0.691819343223972, -86.6336135864258, -1.51204179998362, 218, 19, 'PPL', 'P'),
(152925, 'Stilesville', 42.0802803039551, 0.734439441466136, -75.3994369506836, -1.3159684289393, 218, 40, 'PPL', 'P'),
(198959, 'Still', 47.1605606079102, 0.823107059694371, -100.635833740234, -1.75642664425669, 218, 34, 'PPL', 'P'),
(69109, 'Still Bluff', 34.4316711425781, 0.600946028401906, -78.1463928222656, -1.3639118533054, 218, 33, 'PPL', 'P'),
(91041, 'Still Brook', 36.0986099243164, 0.630039598572422, -83.9272232055664, -1.46480637699332, 218, 50, 'PPL', 'P'),
(167619, 'Still Creek', 40.8558311462402, 0.713068772140741, -76.0002822875977, -1.32645515836371, 218, 45, 'PPL', 'P'),
(57729, 'Still House Resort', 37.7999992370605, 0.659734443938051, -92.3291702270508, -1.61144801609636, 218, 29, 'PPL', 'P'),
(113121, 'Still Meadows', 41.8849983215332, 0.731031127903053, -88.445556640625, -1.54366617213804, 218, 18, 'PPL', 'P'),
(51703, 'Still Pond', 39.3291702270508, 0.686423512539362, -76.0458297729492, -1.3272501119491, 218, 25, 'PPL', 'P'),
(126259, 'Still River', 42.4916687011719, 0.741619523502072, -71.6180572509766, -1.24997090291134, 218, 23, 'PPL', 'P'),
(146399, 'Still Valley', 40.6738891601563, 0.709893285435958, -75.1388931274414, -1.31142108137799, 218, 37, 'PPL', 'P'),
(6088, 'Still Waters', 32.7449989318848, 0.571508044923416, -85.807502746582, -1.49762344584193, 218, 2, 'PPL', 'P'),
(43226, 'Stille', 31.2313899993896, 0.545090585463779, -92.829719543457, -1.62018424973625, 218, 22, 'PPL', 'P'),
(69110, 'Stilley', 35.3386116027832, 0.616775125552037, -76.9258270263672, -1.34260896142975, 218, 33, 'PPL', 'P'),
(69111, 'Stilleys Crossroads', 35.7177810668945, 0.623392881123803, -78.1969375610352, -1.36479402541649, 218, 33, 'PPL', 'P'),
(106580, 'Stillfield', 38.0680618286133, 0.664413018762075, -78.5202789306641, -1.37043739692442, 218, 53, 'PPL', 'P'),
(152926, 'Stillham', 42.7616691589355, 0.74633192047194, -73.3616714477539, -1.28040271152962, 218, 40, 'PPL', 'P'),
(57730, 'Stillhouse Ford', 39.0724983215332, 0.681943742690712, -91.2597198486328, -1.59278258580626, 218, 29, 'PPL', 'P'),
(74417, 'Stillhouse Run (historical)', 39.7833290100098, 0.694350078628847, -80.8569412231445, -1.4112198474354, 218, 41, 'PPL', 'P'),
(57731, 'Stillhouse Springs', 37.8011093139648, 0.659753818434981, -92.3344421386719, -1.61154002831202, 218, 29, 'PPL', 'P'),
(57732, 'Stillings', 39.3197212219238, 0.686258596288859, -94.8877792358398, -1.65610416757091, 218, 29, 'PPL', 'P'),
(12135, 'Stillions', 33.2527809143066, 0.580370512398981, -92.0422210693359, -1.60643980850841, 218, 4, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(133272, 'Stillman', 46.3424987792969, 0.808829187300183, -86.751106262207, -1.51409243402298, 218, 27, 'PPL', 'P'),
(121585, 'Stillman Valley', 42.1072196960449, 0.73490962255659, -89.1791687011719, -1.55647011802692, 218, 18, 'PPL', 'P'),
(114130, 'Stillmans Corner', 41.5625, 0.725402470360143, -72.8647232055664, -1.27172932849145, 218, 8, 'PPL', 'P'),
(169626, 'Stillmanville', 41.3913917541504, 0.722416068092756, -71.8233337402344, -1.25355365352582, 218, 47, 'PPL', 'P'),
(51704, 'Stillmeadow', 39.1138916015625, 0.682666191715424, -76.7094421386719, -1.3388323326879, 218, 25, 'PPL', 'P'),
(25134, 'Stillmore', 32.4419403076172, 0.566218674103382, -82.2152786254883, -1.43492730745929, 218, 13, 'PPL', 'P'),
(61889, 'Stillons (historical)', 34.0586090087891, 0.594434865852772, -90.4775009155273, -1.57913028995214, 218, 30, 'PPL', 'P'),
(6089, 'Stills Crossroads', 31.9972190856934, 0.558456824527319, -85.8930587768555, -1.49911668026514, 218, 2, 'PPL', 'P'),
(51705, 'Stilltown (historical)', 38.476390838623, 0.671539704418154, -76.8236083984375, -1.3408249098155, 218, 25, 'PPL', 'P'),
(12131, 'Stillwater', 34.7527809143066, 0.606550451178896, -93.4130630493164, -1.63036551458363, 218, 4, 'PPL', 'P'),
(38385, 'Stillwater', 37.7563896179199, 0.658973312498506, -83.4844436645508, -1.45707841614213, 218, 21, 'PPL', 'P'),
(77341, 'Stillwater', 36.1155586242676, 0.630335409190503, -97.0580596923828, -1.69398270722927, 218, 42, 'PPL', 'P'),
(129000, 'Stillwater', 44.9083290100098, 0.783798202793556, -68.6869430541992, -1.19881330942563, 218, 26, 'PPL', 'P'),
(138297, 'Stillwater', 45.0563888549805, 0.786382334578287, -92.8058319091797, -1.6197673318676, 218, 28, 'PPL', 'P'),
(144509, 'Stillwater', 44.1186103820801, 0.770015012571851, -71.4700012207031, -1.24738683770564, 218, 36, 'PPL', 'P'),
(146400, 'Stillwater', 41.035831451416, 0.716210370120653, -74.8786087036133, -1.30687826119053, 218, 37, 'PPL', 'P'),
(152932, 'Stillwater', 42.0588912963867, 0.734066132860335, -79.2188873291016, -1.38263041365924, 218, 40, 'PPL', 'P'),
(157810, 'Stillwater', 40.3233299255371, 0.703774872568583, -81.3086090087891, -1.41910293742009, 218, 41, 'PPL', 'P'),
(167620, 'Stillwater', 41.1488914489746, 0.718183639330347, -76.3661117553711, -1.33284008707717, 218, 45, 'PPL', 'P'),
(169627, 'Stillwater', 41.9077796936035, 0.731428737853802, -71.523063659668, -1.24831295197471, 218, 47, 'PPL', 'P'),
(190783, 'Stillwater', 39.521671295166, 0.689783289991579, -118.546112060547, -2.0690199708947, 218, 39, 'PPL', 'P'),
(208837, 'Stillwater', 47.6830596923828, 0.832226389057075, -121.918891906738, -2.12788608415565, 218, 56, 'PPL', 'P'),
(129001, 'Stillwater Avenue', 44.8405609130859, 0.782615426374424, -68.745002746582, -1.1998266422204, 218, 26, 'PPL', 'P'),
(74418, 'Stillwater Junction', 39.7805595397949, 0.694301742255062, -84.2694396972656, -1.4707791815281, 218, 41, 'PPL', 'P'),
(152933, 'Stillwater Junction', 42.9188919067383, 0.74907597508013, -73.6847229003906, -1.28604102303148, 218, 40, 'PPL', 'P'),
(167621, 'Stillwater Lake Estates', 41.1180610656738, 0.717645547632097, -75.4049987792969, -1.31606550116104, 218, 45, 'PPL', 'P'),
(25135, 'Stillwell', 32.3777809143066, 0.565098881444031, -81.2505569458008, -1.41808973778337, 218, 13, 'PPL', 'P'),
(111543, 'Stillwell', 38.2083282470703, 0.66686112959413, -80.0986099243164, -1.39798446944993, 218, 58, 'PPL', 'P'),
(117908, 'Stillwell', 41.5238914489746, 0.724728624025326, -92.668327331543, -1.61736742425128, 218, 16, 'PPL', 'P'),
(121586, 'Stillwell', 40.2186088562012, 0.701947145112461, -91.1827774047852, -1.59143968682659, 218, 18, 'PPL', 'P'),
(123733, 'Stillwell', 41.5558280944824, 0.72528602364148, -86.602783203125, -1.51150370828537, 218, 19, 'PPL', 'P'),
(157811, 'Stillwell', 40.4605598449707, 0.706169986494945, -82.0944366455078, -1.432818217034, 218, 41, 'PPL', 'P'),
(192277, 'Stillwell Crossing', 29.398609161377, 0.513102525372997, -102.818328857422, -1.79451836996031, 218, 51, 'PPL', 'P'),
(69113, 'Stillwood', 34.7649993896484, 0.606763703803184, -77.4911117553711, -1.35247504116211, 218, 33, 'PPL', 'P'),
(25136, 'Stilson', 32.3258285522461, 0.564192141671886, -81.5533294677734, -1.42337411517636, 218, 13, 'PPL', 'P'),
(98300, 'Stilson', 30.0186100006104, 0.523923581382748, -94.9186096191406, -1.65664225926916, 218, 51, 'PPL', 'P'),
(117909, 'Stilson', 43.038330078125, 0.75116056442339, -93.8850021362305, -1.63860240551913, 218, 16, 'PPL', 'P'),
(111544, 'Stiltner', 38.1319389343262, 0.66552788457341, -82.3805618286133, -1.43781204355206, 218, 58, 'PPL', 'P'),
(83834, 'Stilton', 33.5363883972168, 0.585320396759057, -80.8386077880859, -1.41089986863043, 218, 48, 'PPL', 'P'),
(79208, 'Stiltz', 39.7211112976074, 0.693264174694367, -76.7652816772461, -1.33980691648882, 218, 45, 'PPL', 'P'),
(34058, 'Stilwell', 38.7691688537598, 0.676649644759744, -94.6561126708984, -1.6520608232459, 218, 20, 'PPL', 'P'),
(77343, 'Stilwell', 35.8144416809082, 0.625079927095341, -94.6283264160156, -1.6515758616114, 218, 42, 'PPL', 'P'),
(190784, 'Stimler (historical)', 37.7986106872559, 0.659710209172131, -117.704170227051, -2.05432531378992, 218, 39, 'PPL', 'P'),
(12132, 'Stimson', 34.0294418334961, 0.593925802610403, -91.0730590820313, -1.58952474084477, 218, 4, 'PPL', 'P'),
(208838, 'Stimson', 47.0905609130859, 0.821885334544297, -123.230560302734, -2.15077901636014, 218, 56, 'PPL', 'P'),
(208839, 'Stimson Crossing', 48.1230583190918, 0.8399058137974, -122.181938171387, -2.13247710755884, 218, 56, 'PPL', 'P'),
(117910, 'Stimsons (historical)', 42.3541717529297, 0.739219749043801, -94.5999984741211, -1.65108144575502, 218, 16, 'PPL', 'P'),
(190785, 'Stine', 37.4952812194824, 0.654416111241163, -114.58805847168, -1.99993890379859, 218, 39, 'PPL', 'P'),
(91042, 'Stiner Store (historical)', 36.3858299255371, 0.635052533271306, -83.8291702270508, -1.46309502967684, 218, 50, 'PPL', 'P'),
(167623, 'Stines Corner', 40.6227798461914, 0.709001259628836, -75.7641677856445, -1.32233418289292, 218, 45, 'PPL', 'P'),
(31225, 'Stines Mill Corner', 39.475830078125, 0.688983209821092, -86.3727798461914, -1.50748939241624, 218, 19, 'PPL', 'P'),
(31226, 'Stinesville', 39.2986106872559, 0.685890147952046, -86.6522216796875, -1.51236657247856, 218, 19, 'PPL', 'P'),
(12133, 'Stineville (historical)', 35.0538902282715, 0.611805800116004, -91.5741729736328, -1.5982708281807, 218, 4, 'PPL', 'P'),
(98301, 'Stingaree', 29.461669921875, 0.514203143272499, -94.6405563354492, -1.65178931397277, 218, 51, 'PPL', 'P'),
(91043, 'Stinger', 35.9575004577637, 0.627576773775344, -89.5791702270508, -1.56345146166651, 218, 50, 'PPL', 'P'),
(106581, 'Stingray Point', 37.5586090087891, 0.655521389672573, -76.3055572509766, -1.33178321159857, 218, 53, 'PPL', 'P'),
(12134, 'Stinking Bay', 34.413330078125, 0.600625916438879, -91.192497253418, -1.59160933018803, 218, 4, 'PPL', 'P'),
(91044, 'Stinking Creek', 36.5066719055176, 0.637161623696594, -84.14111328125, -1.46853946305134, 218, 50, 'PPL', 'P'),
(38386, 'Stinnett', 37.0902786254883, 0.647347482496847, -83.3955612182617, -1.45552712480716, 218, 21, 'PPL', 'P'),
(192278, 'Stinnett', 35.8269386291504, 0.625298039988618, -101.442497253418, -1.77050557851745, 218, 51, 'PPL', 'P'),
(38387, 'Stinnettsville', 37.7808303833008, 0.65939988432611, -86.3086090087891, -1.50636940001981, 218, 21, 'PPL', 'P'),
(6090, 'Stinson', 34.0208282470703, 0.593775467166868, -87.9077835083008, -1.53428026035022, 218, 2, 'PPL', 'P'),
(38388, 'Stinson', 38.310001373291, 0.668635660407477, -82.8783264160156, -1.44649967450206, 218, 21, 'PPL', 'P'),
(57733, 'Stinson', 37.2463912963867, 0.650072162608107, -93.7522201538086, -1.63628492273854, 218, 29, 'PPL', 'P'),
(61890, 'Stinson', 32.2911109924316, 0.563586205944866, -88.6908264160156, -1.54794693727423, 218, 30, 'PPL', 'P'),
(106582, 'Stinson', 36.916389465332, 0.644312544118593, -81.3249969482422, -1.41938896092117, 218, 53, 'PPL', 'P'),
(111545, 'Stinson', 38.6563911437988, 0.674681302398066, -81.0747222900391, -1.41502084410122, 218, 58, 'PPL', 'P'),
(185380, 'Stinson Beach', 37.9005584716797, 0.661489533675441, -122.643333435059, -2.14052997406302, 218, 6, 'PPL', 'P'),
(144510, 'Stinson Lake', 43.8611106872559, 0.765520795074288, -71.8088912963867, -1.25330158532865, 218, 36, 'PPL', 'P'),
(197624, 'Stipek', 47.2122192382813, 0.824008672881417, -104.664436340332, -1.8267390238828, 218, 31, 'PPL', 'P'),
(197625, 'Stipes Trailer Court', 48.3858299255371, 0.844492043510625, -114.059997558594, -1.99072250221415, 218, 31, 'PPL', 'P'),
(34059, 'Stippville', 37.2222213745117, 0.649650317891439, -94.8375015258789, -1.65522665599173, 218, 20, 'PPL', 'P'),
(25137, 'Stir Up Manor', 34.0905609130859, 0.594992531785034, -84.5744400024414, -1.476102441073, 218, 13, 'PPL', 'P'),
(28695, 'Stiritz', 37.836109161377, 0.660364681010018, -88.9483337402344, -1.55244128792985, 218, 18, 'PPL', 'P'),
(146402, 'Stirling', 40.6719398498535, 0.709859263553032, -74.4952774047852, -1.30018786790004, 218, 37, 'PPL', 'P'),
(152938, 'Stirling', 41.1138916015625, 0.71757277675531, -72.3683319091797, -1.26306566599126, 218, 40, 'PPL', 'P'),
(190786, 'Stirling (historical)', 36.485279083252, 0.636788248511765, -115.957778930664, -2.0238450356398, 218, 39, 'PPL', 'P'),
(185381, 'Stirling City', 39.9077796936035, 0.696522152813915, -121.52693939209, -2.12104522226356, 218, 6, 'PPL', 'P'),
(185382, 'Stirling Junction', 39.714168548584, 0.693143000864768, -121.812217712402, -2.12602426823758, 218, 6, 'PPL', 'P'),
(133276, 'Stirlingville', 46.1872215270996, 0.806119087995892, -84.3211135864258, -1.47168106103125, 218, 27, 'PPL', 'P'),
(111546, 'Stirrat', 37.726390838623, 0.658449735028197, -82.0025024414063, -1.43121366247723, 218, 58, 'PPL', 'P'),
(14673, 'Stirrup Farms', 39.7597198486328, 0.693938021029184, -75.7333297729492, -1.32179595803661, 218, 10, 'PPL', 'P'),
(51708, 'Stirrup Run', 39.6074981689453, 0.691281251525721, -76.4086074829102, -1.33358177744076, 218, 25, 'PPL', 'P'),
(140926, 'Stirum', 46.2102813720703, 0.80652155821563, -97.8061065673828, -1.70703858815728, 218, 34, 'PPL', 'P'),
(152935, 'Stissing', 41.9091682434082, 0.731452972619722, -73.682502746582, -1.28600227403762, 218, 40, 'PPL', 'P'),
(38389, 'Stites', 38.0166702270508, 0.663516066106936, -85.9047164916992, -1.49932014577242, 218, 21, 'PPL', 'P'),
(195660, 'Stites', 46.0916709899902, 0.804451416521284, -115.975280761719, -2.02415050021683, 218, 17, 'PPL', 'P'),
(98302, 'Stith', 32.5463905334473, 0.568041674448568, -99.9438934326172, -1.74435000766151, 218, 51, 'PPL', 'P'),
(91046, 'Stithsville (historical)', 36.2216682434082, 0.632187371412544, -83.4491729736328, -1.45646282645616, 218, 50, 'PPL', 'P'),
(133273, 'Stittsville', 44.4516716003418, 0.775828027441221, -85.0749969482422, -1.48483880787095, 218, 27, 'PPL', 'P'),
(152936, 'Stittville', 43.2230606079102, 0.754384720397094, -75.2886123657227, -1.31403417503958, 218, 40, 'PPL', 'P'),
(176552, 'Stitzer', 42.9266700744629, 0.749211729716697, -90.6230621337891, -1.58167081247402, 218, 57, 'PPL', 'P'),
(91045, 'Stiversville', 35.4422187805176, 0.618583411932201, -87.0422210693359, -1.51917334590869, 218, 50, 'PPL', 'P'),
(179225, 'Stoa Pitk', 32.4850006103516, 0.566970218163002, -112.51611328125, -1.96377663830473, 218, 5, 'PPL', 'P'),
(51707, 'Stoakley', 38.5583305358887, 0.672969821923527, -76.5977783203125, -1.33688343140218, 218, 25, 'PPL', 'P'),
(167624, 'Stobo', 40.6630592346191, 0.709704267577589, -80.2630615234375, -1.40085469131476, 218, 45, 'PPL', 'P'),
(91047, 'Stock Creek', 35.871940612793, 0.62608347277311, -83.8933334350586, -1.46421488891522, 218, 50, 'PPL', 'P'),
(25138, 'Stock Hill', 34.7075004577637, 0.605760158125415, -84.2294387817383, -1.47008103384833, 218, 13, 'PPL', 'P'),
(18200, 'Stock Island', 24.5666694641113, 0.428769268397894, -81.7386093139648, -1.42660785852999, 218, 12, 'PPL', 'P'),
(18201, 'Stockade', 30.2211093902588, 0.527457862465392, -81.5055618286133, -1.42254041259711, 218, 12, 'PPL', 'P'),
(98303, 'Stockard', 32.2794418334961, 0.563382540700502, -95.9583282470703, -1.67478877262086, 218, 51, 'PPL', 'P'),
(25139, 'Stockbridge', 33.5441703796387, 0.585456217974651, -84.23388671875, -1.47015866499411, 218, 13, 'PPL', 'P'),
(126260, 'Stockbridge', 42.2874984741211, 0.738056080805491, -73.3208312988281, -1.27968991646386, 218, 23, 'PPL', 'P'),
(133274, 'Stockbridge', 42.4511108398438, 0.740911655284329, -84.1805572509766, -1.46922789019313, 218, 27, 'PPL', 'P'),
(152937, 'Stockbridge', 42.9911117553711, 0.750336449224065, -75.5997161865234, -1.31946396102809, 218, 40, 'PPL', 'P'),
(172599, 'Stockbridge', 43.7861099243164, 0.764211784819486, -72.7541732788086, -1.26979986828169, 218, 55, 'PPL', 'P'),
(176553, 'Stockbridge', 44.0716705322266, 0.769195757641515, -88.2988891601563, -1.54110634169826, 218, 57, 'PPL', 'P'),
(57734, 'Stockbridge (historical)', 39.7513885498047, 0.693792612433666, -94.666389465332, -1.65224018714532, 218, 29, 'PPL', 'P'),
(144511, 'Stockbridge Corner', 43.6358299255371, 0.761588904040895, -71.2033309936523, -1.24273256422656, 218, 36, 'PPL', 'P'),
(144512, 'Stockbridge Corners', 43.4141693115234, 0.757720196504364, -71.2030563354492, -1.2427277705366, 218, 36, 'PPL', 'P'),
(6092, 'Stockdale', 33.422779083252, 0.583337540169439, -86.0272216796875, -1.50145826465359, 218, 2, 'PPL', 'P'),
(14674, 'Stockdale', 39.7999992370605, 0.694641028977938, -75.4583282470703, -1.31699627596202, 218, 10, 'PPL', 'P'),
(57735, 'Stockdale', 39.290828704834, 0.685754326736452, -94.3422164916992, -1.64658230140944, 218, 29, 'PPL', 'P'),
(74420, 'Stockdale', 38.9563903808594, 0.679917276838244, -82.8583297729492, -1.44615066724121, 218, 41, 'PPL', 'P'),
(98304, 'Stockdale', 29.2366695404053, 0.510276145797609, -97.959716796875, -1.70971959242666, 218, 51, 'PPL', 'P'),
(121587, 'Stockdale', 41.3511085510254, 0.721712993564975, -88.4925003051758, -1.5444854936474, 218, 18, 'PPL', 'P'),
(123734, 'Stockdale', 40.9150009155273, 0.714101479432447, -85.9441680908203, -1.50000870607226, 218, 19, 'PPL', 'P'),
(167625, 'Stockdale', 40.0833282470703, 0.699586053069024, -79.8483276367188, -1.39361621947192, 218, 45, 'PPL', 'P'),
(172601, 'Stocker Acres', 43.1277809143066, 0.752721776033421, -72.8744430541992, -1.27189897185289, 218, 55, 'PPL', 'P'),
(167627, 'Stockertown', 40.7538909912109, 0.711289580795486, -75.2624969482422, -1.31357837501901, 218, 45, 'PPL', 'P'),
(197626, 'Stockett', 47.3566703796387, 0.826529820906368, -111.164436340332, -1.94018542526243, 218, 31, 'PPL', 'P'),
(74421, 'Stockham', 38.7444381713867, 0.676218012926069, -83.0325012207031, -1.44919053246748, 218, 41, 'PPL', 'P'),
(143120, 'Stockham', 40.7161102294922, 0.710630182109583, -97.9394378662109, -1.70936565831779, 218, 35, 'PPL', 'P'),
(179226, 'Stockham', 32.274169921875, 0.56329052848484, -111.006942749023, -1.9374366435433, 218, 5, 'PPL', 'P'),
(38390, 'Stockholm', 37.2480583190918, 0.650101257643017, -86.1308288574219, -1.50326655103376, 218, 21, 'PPL', 'P'),
(98305, 'Stockholm', 26.3864593505859, 0.460530593611369, -97.8788070678711, -1.70830745125865, 218, 51, 'PPL', 'P'),
(129002, 'Stockholm', 47.0422210693359, 0.82104164511096, -68.1399993896484, -1.18926734165629, 218, 26, 'PPL', 'P'),
(138300, 'Stockholm', 45.0363883972168, 0.786033260738405, -94.220832824707, -1.64446375676229, 218, 28, 'PPL', 'P'),
(146403, 'Stockholm', 41.0894393920898, 0.717146005190625, -74.5175018310547, -1.30057575731281, 218, 37, 'PPL', 'P'),
(171382, 'Stockholm', 45.0997200012207, 0.787138605748842, -96.8016662597656, -1.68950779764961, 218, 49, 'PPL', 'P'),
(176556, 'Stockholm', 44.4833297729492, 0.776380566788386, -92.2619400024414, -1.61027462732007, 218, 57, 'PPL', 'P'),
(152941, 'Stockholm Center', 44.7594413757324, 0.781199623359911, -74.8319396972656, -1.30606373337113, 218, 40, 'PPL', 'P'),
(71440, 'Stockington', 39.564998626709, 0.690539494583107, -75.3194427490234, -1.31457226673783, 218, 37, 'PPL', 'P'),
(121588, 'Stockland', 40.6144409179688, 0.708855717875263, -87.5927810668945, -1.52878243059586, 218, 18, 'PPL', 'P'),
(14675, 'Stockley', 38.6408309936523, 0.674409726545905, -75.3402786254883, -1.31493592138468, 218, 10, 'PPL', 'P'),
(51717, 'Stockman', 39.4019393920898, 0.687693574063221, -77.4930572509766, -1.35250899646601, 218, 25, 'PPL', 'P'),
(98306, 'Stockman', 31.7791690826416, 0.554651134040082, -94.4063873291016, -1.64770229380588, 218, 51, 'PPL', 'P'),
(51709, 'Stockman Estates', 39.3666687011719, 0.687077984377249, -77.5505599975586, -1.3535126087228, 218, 25, 'PPL', 'P'),
(74422, 'Stockport', 39.5483283996582, 0.690248544234015, -81.7930603027344, -1.42755820756498, 218, 41, 'PPL', 'P'),
(117912, 'Stockport', 40.8574981689453, 0.71309786717565, -91.8349990844727, -1.60282310259003, 218, 16, 'PPL', 'P'),
(123735, 'Stockport', 40.3208312988281, 0.703731263305732, -85.460563659668, -1.49156821647142, 218, 19, 'PPL', 'P'),
(152942, 'Stockport', 42.309440612793, 0.738439043370245, -73.7466735839844, -1.28712226643405, 218, 40, 'PPL', 'P'),
(167629, 'Stockport', 41.8944396972656, 0.731195910995502, -75.2774963378906, -1.31384016375417, 218, 45, 'PPL', 'P'),
(25143, 'Stocks', 31.6550006866455, 0.55248398670303, -84.0905609130859, -1.4676571577822, 218, 13, 'PPL', 'P'),
(25141, 'Stocks (historical)', 31.6547203063965, 0.552479093144527, -84.0902786254883, -1.46765223093418, 218, 13, 'PPL', 'P'),
(69114, 'Stocksville', 35.747501373291, 0.623911598325123, -82.5483322143555, -1.4407401891706, 218, 33, 'PPL', 'P'),
(510, 'Stockton', 39.438060760498, 0.68832401087227, -99.2647171020508, -1.73249614449151, 218, 20, 'PPL', 'P'),
(6091, 'Stockton', 30.9936103820801, 0.540940548247595, -87.8580627441406, -1.53341246930902, 218, 2, 'PPL', 'P'),
(12137, 'Stockton', 33.4491691589355, 0.583798133879968, -93.3102798461914, -1.62857160927335, 218, 4, 'PPL', 'P'),
(25142, 'Stockton', 30.9391708374023, 0.539990398949682, -82.9997177124023, -1.44861835230728, 218, 13, 'PPL', 'P'),
(31227, 'Stockton', 39.2388916015625, 0.684847853280417, -87.022216796875, -1.51882420548978, 218, 19, 'PPL', 'P'),
(51712, 'Stockton', 38.0536117553711, 0.664160817406845, -75.4102783203125, -1.31615764653475, 218, 25, 'PPL', 'P'),
(57736, 'Stockton', 37.6988906860352, 0.657969766820737, -93.7958297729492, -1.63704605417809, 218, 29, 'PPL', 'P'),
(74423, 'Stockton', 39.3224983215332, 0.686307065820698, -84.5038909912109, -1.47487112854301, 218, 41, 'PPL', 'P'),
(91049, 'Stockton', 36.4052810668945, 0.635392019731264, -84.8227767944336, -1.48043673574711, 218, 50, 'PPL', 'P'),
(106583, 'Stockton', 36.6641693115234, 0.639910471994746, -79.7361068725586, -1.39165759764823, 218, 53, 'PPL', 'P'),
(117913, 'Stockton', 41.5913887023926, 0.725906673333522, -90.8586120605469, -1.58578193424877, 218, 16, 'PPL', 'P'),
(121590, 'Stockton', 42.3497200012207, 0.739142051318998, -90.0066680908203, -1.57091270693453, 218, 18, 'PPL', 'P'),
(138302, 'Stockton', 44.0275001525879, 0.768424839084965, -91.7697219848633, -1.60168380227569, 218, 28, 'PPL', 'P'),
(146404, 'Stockton', 40.4077796936035, 0.705248799073887, -74.9786071777344, -1.30862356381092, 218, 37, 'PPL', 'P'),
(152944, 'Stockton', 42.3175010681152, 0.738579724854828, -79.3561096191406, -1.38502539442755, 218, 40, 'PPL', 'P'),
(176563, 'Stockton', 44.5113906860352, 0.776870322112851, -89.4669418334961, -1.56149270668476, 218, 57, 'PPL', 'P'),
(179227, 'Stockton', 35.309440612793, 0.616265995730642, -114.089172363281, -1.99123169861458, 218, 5, 'PPL', 'P'),
(185383, 'Stockton', 37.9577789306641, 0.66248821908422, -121.28971862793, -2.11690493887487, 218, 6, 'PPL', 'P'),
(205920, 'Stockton', 40.4527816772461, 0.706034231858378, -112.360000610352, -1.96105195819347, 218, 52, 'PPL', 'P'),
(83835, 'Stockton (historical)', 34.1480598449707, 0.595996077462803, -80.5727767944336, -1.40626024253735, 218, 48, 'PPL', 'P'),
(111547, 'Stockton (historical)', 38.750560760498, 0.676324872264809, -82.0369415283203, -1.43181473793526, 218, 58, 'PPL', 'P'),
(91048, 'Stockton Estates', 36.2599983215332, 0.632856357478372, -85.4652786254883, -1.4916505081491, 218, 50, 'PPL', 'P'),
(51713, 'Stockton Green', 39.4761085510254, 0.688988070090081, -76.3619384765625, -1.33276724962136, 218, 25, 'PPL', 'P'),
(189607, 'Stockton Place', 34.8555603027344, 0.608344289910146, -105.779716491699, -1.8462043346063, 218, 38, 'PPL', 'P'),
(129004, 'Stockton Springs', 44.4894409179688, 0.776487226390043, -68.8574981689453, -1.20179005773406, 218, 26, 'PPL', 'P'),
(51714, 'Stockton Woods', 39.5308303833008, 0.689943146236011, -76.602783203125, -1.33697078308594, 218, 25, 'PPL', 'P'),
(199706, 'Stockville', 40.5327796936035, 0.70743046063888, -100.383056640625, -1.75201485159486, 218, 35, 'PPL', 'P'),
(91050, 'Stockville (historical)', 36.4286117553711, 0.635799217061937, -83.9850006103516, -1.46581478294008, 218, 50, 'PPL', 'P'),
(190787, 'Stockville (historical)', 38.9283294677734, 0.679427521513778, -115.165000915527, -2.01000844903824, 218, 39, 'PPL', 'P'),
(123736, 'Stockwell', 40.2861099243164, 0.703125260999685, -86.7708282470703, -1.51443664759388, 218, 19, 'PPL', 'P'),
(152946, 'Stockwell', 42.8747215270996, 0.748305056523579, -75.3894424438477, -1.3157939918879, 218, 40, 'PPL', 'P'),
(69115, 'Stockwood', 35.5338897705078, 0.620183372536094, -82.517219543457, -1.44019717062434, 218, 33, 'PPL', 'P'),
(25144, 'Stockwood Estates', 34.0813903808594, 0.59483247580352, -84.5261077880859, -1.47525888479772, 218, 13, 'PPL', 'P'),
(51715, 'Stoddard', 39.5327796936035, 0.689977168118936, -76.6483306884766, -1.33776573667133, 218, 25, 'PPL', 'P'),
(57737, 'Stoddard', 36.791389465332, 0.6421308825536, -90.0341720581055, -1.57139274172102, 218, 29, 'PPL', 'P'),
(144513, 'Stoddard', 43.0786094665527, 0.751863572372143, -72.1149978637695, -1.25864415279146, 218, 36, 'PPL', 'P'),
(176560, 'Stoddard', 43.6619415283203, 0.762044637482434, -91.2183303833008, -1.59206020336058, 218, 57, 'PPL', 'P'),
(205921, 'Stoddard', 41.0669403076172, 0.716753322087893, -111.710563659668, -1.94971714511993, 218, 52, 'PPL', 'P'),
(143124, 'Stoddard (historical)', 40.0888900756836, 0.699683125290757, -97.6138916015625, -1.70368380413211, 218, 35, 'PPL', 'P'),
(167630, 'Stoddartsville', 41.1297187805176, 0.717849013139379, -75.6286087036133, -1.31996823058049, 218, 45, 'PPL', 'P'),
(106584, 'Stoddert', 37.3502807617188, 0.651885375836288, -78.295280456543, -1.36651043273904, 218, 53, 'PPL', 'P'),
(121592, 'Stoehrs', 40.5230598449707, 0.707260817277442, -89.6936111450195, -1.56544883248407, 218, 18, 'PPL', 'P'),
(111548, 'Stohrs Crossroads', 39.6333312988281, 0.691732124698271, -78.147216796875, -1.36392623437529, 218, 58, 'PPL', 'P'),
(185385, 'Stoil', 35.9180603027344, 0.626888413212586, -119.424438476563, -2.08434965876142, 218, 6, 'PPL', 'P'),
(106586, 'Stoke', 38.9752807617188, 0.680246976181196, -77.6666717529297, -1.3555391411543, 218, 53, 'PPL', 'P'),
(61891, 'Stokely', 34.2655601501465, 0.598046844660219, -90.7202835083008, -1.58336764556256, 218, 30, 'PPL', 'P'),
(6094, 'Stokes', 33.1352806091309, 0.578319745201566, -87.504997253418, -1.52725031402074, 218, 2, 'PPL', 'P'),
(12136, 'Stokes', 36.3558311462402, 0.634528955800996, -90.9341735839844, -1.58710073162058, 218, 4, 'PPL', 'P'),
(28697, 'Stokes', 38.0175018310547, 0.663530580334877, -88.2738876342773, -1.54066998275365, 218, 18, 'PPL', 'P'),
(61892, 'Stokes', 32.5950012207031, 0.56889009099284, -90.2038879394531, -1.57435484264346, 218, 30, 'PPL', 'P'),
(69116, 'Stokes', 35.7163887023926, 0.623368579778856, -77.2649993896484, -1.34852863590077, 218, 33, 'PPL', 'P'),
(83843, 'Stokes', 32.6416702270508, 0.569704618812241, -81.1705627441406, -1.4166935755819, 218, 48, 'PPL', 'P'),
(91051, 'Stokes', 35.9594383239746, 0.627610595921188, -89.2202835083008, -1.55718770678265, 218, 50, 'PPL', 'P'),
(61893, 'Stokes (historical)', 34.4166717529297, 0.600684239666751, -90.5694427490234, -1.58073497766696, 218, 30, 'PPL', 'P'),
(69117, 'Stokes (historical)', 36.1425018310547, 0.630805656859984, -81.2022171020508, -1.41724604835003, 218, 33, 'PPL', 'P'),
(74424, 'Stokes (historical)', 39.3772201538086, 0.687262141966628, -84.2886123657227, -1.47111380771907, 218, 41, 'PPL', 'P'),
(83837, 'Stokes (historical)', 33.0180587768555, 0.57627383827314, -79.9986114501953, -1.39623916682954, 218, 48, 'PPL', 'P'),
(106585, 'Stokes (historical)', 37.6547203063965, 0.657198848264187, -78.0449981689453, -1.36214218276104, 218, 53, 'PPL', 'P'),
(83838, 'Stokes Bluff Landing', 32.5572204589844, 0.568230692306937, -81.2827835083008, -1.4186521974056, 218, 48, 'PPL', 'P'),
(152947, 'Stokes Corner', 43.3036117553711, 0.755790603136547, -75.4736099243164, -1.31726299154519, 218, 40, 'PPL', 'P'),
(25145, 'Stokes Crossing', 33.5924987792969, 0.586299707670906, -84.2355575561523, -1.47018782660805, 218, 13, 'PPL', 'P'),
(69119, 'Stokes Ferry (historical)', 35.5072212219238, 0.619717918556575, -80.1827774047852, -1.39945346910722, 218, 33, 'PPL', 'P'),
(91053, 'Stokes Mill', 36.1802787780762, 0.63146498896686, -83.9775009155273, -1.4656838885725, 218, 50, 'PPL', 'P'),
(143127, 'Stokes Ranch', 41.9775009155273, 0.732645602734886, -98.4830627441406, -1.71885370233342, 218, 35, 'PPL', 'P'),
(69120, 'Stokesburg', 36.2827796936035, 0.633253967429121, -80.1419372558594, -1.39874067404146, 218, 33, 'PPL', 'P'),
(69121, 'Stokesdale', 36.2369384765625, 0.632453887258634, -79.9797210693359, -1.39590946748659, 218, 33, 'PPL', 'P'),
(167631, 'Stokesdale', 41.7775001525879, 0.729154930915092, -77.3097229003906, -1.34930920841628, 218, 45, 'PPL', 'P'),
(106588, 'Stokesland', 36.5494384765625, 0.637908041171116, -79.4608306884766, -1.38685312188367, 218, 53, 'PPL', 'P'),
(69122, 'Stokestown', 35.4302787780762, 0.618375019576903, -77.2955627441406, -1.34906206706712, 218, 33, 'PPL', 'P'),
(25147, 'Stokesville', 30.3830604553223, 0.530284441777861, -82.0683288574219, -1.43236255017149, 218, 13, 'PPL', 'P'),
(106587, 'Stokesville', 38.3525009155273, 0.669377417350092, -79.149169921875, -1.38141361535718, 218, 53, 'PPL', 'P'),
(57740, 'Stokley', 38.8394393920898, 0.677876097020753, -93.4694366455078, -1.63134941944836, 218, 29, 'PPL', 'P'),
(28699, 'Stolle', 38.5433311462402, 0.672708033188372, -90.1697235107422, -1.57375856087539, 218, 18, 'PPL', 'P'),
(28700, 'Stolletown', 38.6933288574219, 0.675325987118947, -89.4466705322266, -1.56113890573394, 218, 18, 'PPL', 'P'),
(111551, 'Stollings', 37.8375015258789, 0.660388982354965, -81.9647216796875, -1.43055426379132, 218, 58, 'PPL', 'P'),
(111549, 'Stollings (historical)', 37.9583282470703, 0.662497806464145, -82.0491714477539, -1.43202819029663, 218, 58, 'PPL', 'P'),
(187395, 'Stollsteimer', 37.1416702270508, 0.648244435151986, -107.35417175293, -1.87368376284012, 218, 7, 'PPL', 'P'),
(57741, 'Stolpe', 38.6433296203613, 0.674453335808756, -91.5936126708984, -1.59861011490358, 218, 29, 'PPL', 'P'),
(98307, 'Stolz', 30.7769393920898, 0.53715892607871, -98.5566711425781, -1.72013841124327, 218, 51, 'PPL', 'P'),
(185386, 'Stomar', 37.3619384765625, 0.65208884134357, -121.044723510742, -2.11262896742864, 218, 6, 'PPL', 'P'),
(83839, 'Stomp Springs', 34.4697189331055, 0.601610087619717, -81.7344436645508, -1.42653515423223, 218, 48, 'PPL', 'P'),
(34060, 'Stone', 39.1286087036133, 0.682923053602562, -94.9166717529297, -1.65660843712332, 218, 20, 'PPL', 'P'),
(38392, 'Stone', 37.5858306884766, 0.655996497611043, -82.271110534668, -1.43590175810215, 218, 21, 'PPL', 'P'),
(74426, 'Stone', 39.7833290100098, 0.694350078628847, -81.9088897705078, -1.42957981314846, 218, 41, 'PPL', 'P'),
(91052, 'Stone', 36.3941688537598, 0.635198075024879, -85.6608276367188, -1.4950634822441, 218, 50, 'PPL', 'P'),
(123737, 'Stone', 40.2366714477539, 0.702262396806499, -85.0044403076172, -1.4836073621829, 218, 19, 'PPL', 'P'),
(176562, 'Stone', 42.8747215270996, 0.748305056523579, -89.3099975585938, -1.55875351234556, 218, 57, 'PPL', 'P'),
(193980, 'Stone', 40.5122184753418, 0.707071599681992, -124.113059997559, -2.16618154168266, 218, 6, 'PPL', 'P'),
(195661, 'Stone', 42.0163917541504, 0.73332437591772, -112.694442749023, -1.96688907467071, 218, 17, 'PPL', 'P'),
(197627, 'Stone', 46.5052795410156, 0.81167024755108, -113.225280761719, -1.97615394578699, 218, 31, 'PPL', 'P'),
(12139, 'Stone (historical)', 36.3388900756836, 0.63423327834097, -92.6380615234375, -1.61683918624906, 218, 4, 'PPL', 'P'),
(152948, 'Stone Arabia', 42.9536094665527, 0.74968191080715, -74.5588912963867, -1.30129813975849, 218, 40, 'PPL', 'P'),
(51716, 'Stone Barn Station', 39.3372192382813, 0.686563994286864, -77.3752822875977, -1.35045343557863, 218, 25, 'PPL', 'P'),
(123738, 'Stone Bluff', 40.1699981689453, 0.701098728568189, -87.2527770996094, -1.52284824189689, 218, 19, 'PPL', 'P'),
(111550, 'Stone Branch', 37.9927787780762, 0.663099081659257, -82.0419387817383, -1.43190195646096, 218, 58, 'PPL', 'P'),
(106589, 'Stone Bridge', 36.8274993896484, 0.642761119625567, -76.4013900756836, -1.3334558099212, 218, 53, 'PPL', 'P'),
(171385, 'Stone Bridge', 44.6022186279297, 0.778455568751721, -97.059440612793, -1.69400680883714, 218, 49, 'PPL', 'P'),
(91054, 'Stone Bridge (historical)', 36.2544403076172, 0.632759351835666, -85.8722229003906, -1.49875302561829, 218, 50, 'PPL', 'P'),
(69123, 'Stone Brook', 35.3463897705078, 0.616910880188604, -82.491943359375, -1.43975601798977, 218, 33, 'PPL', 'P'),
(106590, 'Stone Bruise', 36.8811111450195, 0.643696821274567, -82.0741729736328, -1.43246454924124, 218, 53, 'PPL', 'P'),
(190788, 'Stone Cabin (historical)', 39.1858291625977, 0.683921739011342, -119.447776794434, -2.08475698925014, 218, 39, 'PPL', 'P'),
(25148, 'Stone Church', 34.9058303833008, 0.609221668331273, -85.0774993896484, -1.48488248371283, 218, 13, 'PPL', 'P'),
(28701, 'Stone Church', 38.3502807617188, 0.669338668356231, -89.6252822875977, -1.56425626894793, 218, 18, 'PPL', 'P'),
(146406, 'Stone Church', 40.3980598449707, 0.705079155712449, -74.0202789306641, -1.29189758058468, 218, 37, 'PPL', 'P'),
(152949, 'Stone Church', 43.0488891601563, 0.751344855170823, -77.9630584716797, -1.36071206525567, 218, 40, 'PPL', 'P'),
(167632, 'Stone Church', 40.8663902282715, 0.713253062888174, -75.128059387207, -1.3112319969406, 218, 45, 'PPL', 'P'),
(152950, 'Stone Church Corner', 42.9555587768555, 0.749715932690076, -76.8827819824219, -1.34185768368623, 218, 40, 'PPL', 'P'),
(98308, 'Stone City', 30.6299991607666, 0.534594335238477, -96.5416717529297, -1.68497003746823, 218, 51, 'PPL', 'P'),
(117914, 'Stone City', 42.1138916015625, 0.735026069275254, -91.3491668701172, -1.59434373083727, 218, 16, 'PPL', 'P'),
(187396, 'Stone City', 38.4486083984375, 0.671054809362678, -104.860557556152, -1.83016198483188, 218, 7, 'PPL', 'P'),
(34061, 'Stone City (historical)', 37.3072204589844, 0.651133831776668, -94.904167175293, -1.65639019107199, 218, 20, 'PPL', 'P'),
(25149, 'Stone Creek', 33.5591697692871, 0.585718006709806, -84.0136108398438, -1.46631412564447, 218, 13, 'PPL', 'P'),
(83840, 'Stone Creek', 35.0047187805176, 0.610947596454726, -82.0152816772461, -1.43143670221852, 218, 48, 'PPL', 'P'),
(106591, 'Stone Creek', 36.7763900756836, 0.641869093818445, -83.0569381713867, -1.44961703771606, 218, 53, 'PPL', 'P'),
(157814, 'Stone Creek', 40.3972206115723, 0.705064508326453, -81.5622177124023, -1.42352924430986, 218, 41, 'PPL', 'P'),
(51718, 'Stone Farm', 38.6361083984375, 0.674327301710168, -76.6355590820313, -1.33754283008809, 218, 25, 'PPL', 'P'),
(28703, 'Stone Fort', 37.6233291625977, 0.65665096944893, -89.1966705322266, -1.55677558260396, 218, 18, 'PPL', 'P'),
(83841, 'Stone Gap', 33.4986114501953, 0.584661064652181, -81.7655563354492, -1.4270781727785, 218, 48, 'PPL', 'P'),
(167633, 'Stone Glen', 40.3847198486328, 0.704846328854149, -76.8874969482422, -1.34193997536392, 218, 45, 'PPL', 'P'),
(71441, 'Stone Harbor', 39.0508308410645, 0.681565573815921, -74.7583312988281, -1.30477902446128, 218, 37, 'PPL', 'P'),
(71442, 'Stone Harbor Manor', 39.0597190856934, 0.681720702949418, -74.7699966430664, -1.30498262312662, 218, 37, 'PPL', 'P'),
(83842, 'Stone Haven', 34.7138900756836, 0.605871677996062, -82.8666687011719, -1.44629620899478, 218, 48, 'PPL', 'P'),
(31229, 'Stone Head', 39.1300010681152, 0.682947354947509, -86.1588897705078, -1.50375630635822, 218, 19, 'PPL', 'P'),
(69124, 'Stone Hedge Apartments', 35.2897186279297, 0.615921782159749, -81.5605621337891, -1.42350034901203, 218, 33, 'PPL', 'P'),
(38393, 'Stone Hedge Estates', 38.2486114501953, 0.667564204121911, -84.5702819824219, -1.4760298699333, 218, 21, 'PPL', 'P'),
(57743, 'Stone Hill', 37.6016693115234, 0.656272933732193, -91.3419418334961, -1.59421763015965, 218, 29, 'PPL', 'P'),
(79209, 'Stone Hill', 39.9541702270508, 0.697331820364327, -76.3533325195313, -1.33261704733588, 218, 45, 'PPL', 'P'),
(205924, 'Stone Hollow Condo', 40.6563911437988, 0.709587887437953, -111.977500915527, -1.95437607913092, 218, 52, 'PPL', 'P'),
(205925, 'Stone Hollow Condominium', 40.6894416809082, 0.710164728130064, -111.946670532227, -1.95383798743267, 218, 52, 'PPL', 'P'),
(167634, 'Stone House', 41.1902809143066, 0.718906021776031, -79.3619384765625, -1.38512712718119, 218, 45, 'PPL', 'P'),
(111552, 'Stone House (historical)', 39.2763900756836, 0.685502325118304, -80.0119400024414, -1.39647179395076, 218, 58, 'PPL', 'P'),
(200222, 'Stone House (historical)', 40.8372192382813, 0.712743933066779, -117.171112060547, -2.04502169367978, 218, 39, 'PPL', 'P'),
(167635, 'Stone House Corner', 41.8147201538086, 0.72980454248399, -76.1372222900391, -1.328845212284, 218, 45, 'PPL', 'P'),
(51719, 'Stone House Village', 39.4327812194824, 0.688231865498553, -77.041389465332, -1.34462590648132, 218, 25, 'PPL', 'P'),
(83844, 'Stone Lake', 34.8738899230957, 0.608664202136092, -82.3805618286133, -1.43781204355206, 218, 48, 'PPL', 'P'),
(176564, 'Stone Lake', 45.8455581665039, 0.800155937420068, -91.540283203125, -1.59767934010259, 218, 57, 'PPL', 'P'),
(83845, 'Stone Lake Heights', 34.8822212219238, 0.60880961073161, -82.3747177124023, -1.43771004448231, 218, 48, 'PPL', 'P'),
(25150, 'Stone Lea', 33.6861114501953, 0.58793355699967, -83.8591690063477, -1.46361860714715, 218, 13, 'PPL', 'P'),
(51720, 'Stone Manor', 39.5583305358887, 0.69042311444347, -77.2455596923828, -1.3481893491779, 218, 25, 'PPL', 'P'),
(106592, 'Stone Mill', 36.6980590820313, 0.640501960072853, -81.9916687011719, -1.43102457803983, 218, 53, 'PPL', 'P'),
(146411, 'Stone Mill', 40.6813888549805, 0.710024179803535, -74.879997253418, -1.30690249595645, 218, 37, 'PPL', 'P'),
(69125, 'Stone Mill Estates', 36.4283294677734, 0.63579429021392, -79.8888931274414, -1.39432422084772, 218, 33, 'PPL', 'P'),
(25152, 'Stone Mill Run', 33.8208312988281, 0.590284861926101, -84.1752777099609, -1.46913574481941, 218, 13, 'PPL', 'P'),
(152951, 'Stone Mills', 44.1144409179688, 0.769942241695064, -75.9741668701172, -1.32599935834314, 218, 40, 'PPL', 'P'),
(25153, 'Stone Mountain', 33.8080596923828, 0.590061955342861, -84.170280456543, -1.46904852629371, 218, 13, 'PPL', 'P'),
(83846, 'Stone Park', 32.7799987792969, 0.572118907498453, -80.0166702270508, -1.39655435194455, 218, 48, 'PPL', 'P'),
(121593, 'Stone Park', 41.9055595397949, 0.731389988859941, -87.8836135864258, -1.53385841563355, 218, 18, 'PPL', 'P'),
(185387, 'Stone Place', 35.9025001525879, 0.626616837360425, -118.733329772949, -2.07228753639418, 218, 6, 'PPL', 'P'),
(31230, 'Stone Quarry Mills', 39.8458290100098, 0.695440909411343, -85.4822235107422, -1.49194625218816, 218, 19, 'PPL', 'P'),
(91055, 'Stone Ridge', 35.9891700744629, 0.62812951285959, -86.601936340332, -1.51148892774132, 218, 50, 'PPL', 'P'),
(152953, 'Stone Ridge', 41.8530616760254, 0.730473728286899, -74.1394424438477, -1.29397737623797, 218, 40, 'PPL', 'P'),
(113347, 'Stone Row', 40.1305618286133, 0.700410434584458, -78.2497177124023, -1.36571521283755, 218, 45, 'PPL', 'P'),
(83847, 'Stone Station', 34.8461112976074, 0.608179373659643, -81.9255599975586, -1.42987076349756, 218, 48, 'PPL', 'P'),
(146407, 'Stone Tavern', 40.1888885498047, 0.701428427911141, -74.4716720581055, -1.2997758768794, 218, 37, 'PPL', 'P'),
(176566, 'Stonebank', 43.1425018310547, 0.752978704499587, -88.4105606079102, -1.54305537614203, 218, 57, 'PPL', 'P'),
(77346, 'Stonebluff', 35.8858299255371, 0.626325887011334, -95.7366714477539, -1.67092013166335, 218, 42, 'PPL', 'P'),
(83848, 'Stoneboro', 34.5400009155273, 0.602836739617808, -80.7372207641602, -1.40913033124413, 218, 48, 'PPL', 'P'),
(167643, 'Stoneboro', 41.339168548584, 0.721504601209676, -80.1052780151367, -1.39810084958956, 218, 45, 'PPL', 'P'),
(51721, 'Stonebraker (historical)', 39.3580589294434, 0.686927715512741, -77.6894378662109, -1.35593648478894, 218, 25, 'PPL', 'P'),
(25154, 'Stonebridge', 33.8758316040039, 0.59124479834102, -83.4375, -1.45625909463277, 218, 13, 'PPL', 'P'),
(106593, 'Stonebridge Acres', 37.2869415283203, 0.650779897667796, -79.8574981689453, -1.39377627545344, 218, 53, 'PPL', 'P'),
(205927, 'Stonebridge Condo', 40.6624984741211, 0.709694480460583, -111.893058776855, -1.95290228578367, 218, 52, 'PPL', 'P'),
(6096, 'Stonebridge Estates', 31.2166690826416, 0.544833656997614, -85.4236068725586, -1.4909231988554, 218, 2, 'PPL', 'P'),
(51722, 'Stonebrook', 39.1694412231445, 0.683635715510267, -76.8566665649414, -1.34140188366567, 218, 25, 'PPL', 'P'),
(91058, 'Stonebrook', 35.9508285522461, 0.627460327056681, -84.0569381713867, -1.467070330236, 218, 50, 'PPL', 'P'),
(106594, 'Stonebrook Farms', 39.142219543457, 0.683160607571797, -78.2319412231445, -1.36540495457055, 218, 53, 'PPL', 'P'),
(98309, 'Stoneburg', 33.6711082458496, 0.587671701685488, -97.9049987792969, -1.70876458285976, 218, 51, 'PPL', 'P'),
(123739, 'Stoneburner Landing', 41.2849998474121, 0.720559179022698, -85.7766723632813, -1.49708535414368, 218, 19, 'PPL', 'P'),
(152954, 'Stoneco', 41.6208305358887, 0.726420530265853, -73.9486083984375, -1.29064669382067, 218, 40, 'PPL', 'P'),
(111553, 'Stonecoal', 37.8833312988281, 0.661188862788371, -82.4177780151367, -1.43846158854193, 218, 58, 'PPL', 'P'),
(111554, 'Stonecoal Junction', 37.6030616760254, 0.65629723507714, -81.313606262207, -1.41919015594579, 218, 58, 'PPL', 'P'),
(51723, 'Stonecrest Hills', 39.2572212219238, 0.685167765506362, -76.8061065673828, -1.34051944523847, 218, 25, 'PPL', 'P'),
(167637, 'Stonedale', 40.5491714477539, 0.707716550718982, -80.121940612793, -1.3983916667806, 218, 45, 'PPL', 'P'),
(28704, 'Stonefort', 37.6141700744629, 0.656491113204498, -88.7080612182617, -1.54824774131936, 218, 18, 'PPL', 'P'),
(106598, 'Stonega', 36.9530601501465, 0.644952568307566, -82.791389465332, -1.44498233847099, 218, 53, 'PPL', 'P'),
(117915, 'Stonega', 42.4766693115234, 0.741357734766917, -93.7144393920898, -1.63562552405264, 218, 16, 'PPL', 'P'),
(91060, 'Stonegate', 36.5941696166992, 0.638688746844673, -82.1127777099609, -1.43313832899703, 218, 50, 'PPL', 'P'),
(106595, 'Stonegate', 37.3044395446777, 0.651085295665801, -80.0691680908203, -1.3974706125176, 218, 53, 'PPL', 'P'),
(187397, 'Stonegate', 39.5308303833008, 0.689943146236011, -104.803329467773, -1.82916316626504, 218, 7, 'PPL', 'P'),
(98310, 'Stonegate Colonia Number 1', 26.2369995117188, 0.457922027323637, -98.2819976806641, -1.71534445496502, 218, 51, 'PPL', 'P'),
(98311, 'Stonegate Colonia Number 2', 26.2369995117188, 0.457922027323637, -98.2850036621094, -1.71539691923849, 218, 51, 'PPL', 'P'),
(179228, 'Stonegate Crossing', 33.3319396972656, 0.581752093793487, -111.836936950684, -1.95192277513474, 218, 5, 'PPL', 'P'),
(51725, 'Stonegate Village', 38.9927787780762, 0.680552374179201, -76.6833267211914, -1.33837653266734, 218, 25, 'PPL', 'P'),
(185388, 'Stonegate Village', 38.6875, 0.675224254365306, -121.072776794434, -2.11311858959505, 218, 6, 'PPL', 'P'),
(98312, 'Stoneham', 30.3416690826416, 0.529562026042663, -95.9122161865234, -1.67398396533943, 218, 51, 'PPL', 'P'),
(126262, 'Stoneham', 42.4799995422363, 0.741415858257708, -71.0999984741211, -1.24092907153636, 218, 23, 'PPL', 'P'),
(167638, 'Stoneham', 41.7991714477539, 0.729533166368911, -79.0997161865234, -1.38055048484789, 218, 45, 'PPL', 'P'),
(194437, 'Stoneham', 40.6055603027344, 0.70870072189982, -103.666107177734, -1.80931489297679, 218, 7, 'PPL', 'P'),
(14678, 'Stonehaven', 39.7652816772461, 0.694035093250917, -75.5124969482422, -1.317941698149, 218, 10, 'PPL', 'P'),
(51726, 'Stonehaven', 39.1463890075684, 0.683233378448583, -76.563606262207, -1.33628701647606, 218, 25, 'PPL', 'P'),
(83849, 'Stonehaven', 34.5438919067383, 0.602904650225605, -82.727783203125, -1.44387219977059, 218, 48, 'PPL', 'P'),
(126264, 'Stonehaven (historical)', 42.6583290100098, 0.744528294623684, -70.5999984741211, -1.23220242527639, 218, 23, 'PPL', 'P'),
(51727, 'Stonehedge', 39.5516700744629, 0.690306867461888, -76.3627777099609, -1.33278189700735, 218, 25, 'PPL', 'P'),
(51728, 'Stonehedge Estates', 38.3569412231445, 0.669454915337813, -75.6727828979492, -1.32073921571607, 218, 25, 'PPL', 'P'),
(25156, 'Stonehenge', 33.6747207641602, 0.587734752024296, -84.2008285522461, -1.46958169114394, 218, 13, 'PPL', 'P'),
(106597, 'Stonehenge', 38.0513916015625, 0.664122068412984, -78.4658279418945, -1.36948704788943, 218, 53, 'PPL', 'P'),
(197628, 'Stonehill (historical)', 48.7461090087891, 0.850780099739439, -115.299438476563, -2.01235482711665, 218, 31, 'PPL', 'P'),
(190792, 'Stonehouse', 39.7808303833008, 0.694306469365996, -114.53971862793, -1.99909521436525, 218, 39, 'PPL', 'P'),
(51729, 'Stonehurst', 39.7136116027832, 0.693133280326789, -77.3402786254883, -1.34984250642456, 218, 25, 'PPL', 'P'),
(79211, 'Stonehurst', 39.9561080932617, 0.697365642510171, -75.2577819824219, -1.31349608334133, 218, 45, 'PPL', 'P'),
(185389, 'Stonehurst', 34.2511100769043, 0.597794643304988, -118.369438171387, -2.06593642982655, 218, 6, 'PPL', 'P'),
(146408, 'Stonehurst East', 40.2299995422363, 0.702145950087836, -74.2874984741211, -1.29656144144368, 218, 37, 'PPL', 'P'),
(146409, 'Stonehurst West', 40.2299995422363, 0.702145950087836, -74.3041687011719, -1.29685239179277, 218, 37, 'PPL', 'P'),
(51730, 'Stonelake', 39.3511085510254, 0.686806408525088, -77.2311096191406, -1.34793714782267, 218, 25, 'PPL', 'P'),
(83854, 'Stoneledge', 34.8402786254883, 0.608077574326975, -82.2799987792969, -1.43605688723565, 218, 48, 'PPL', 'P'),
(51731, 'Stoneleigh', 39.3805618286133, 0.687320465194501, -76.6033325195313, -1.33698037046586, 218, 25, 'PPL', 'P'),
(51733, 'Stoneleigh Square', 39.4249992370605, 0.688096044282959, -76.3194427490234, -1.33202555925777, 218, 25, 'PPL', 'P'),
(74427, 'Stonelick', 39.122501373291, 0.682816460579931, -84.1902770996094, -1.46939753355457, 218, 41, 'PPL', 'P'),
(185390, 'Stoneman', 34.0886116027832, 0.594958509902108, -118.121391296387, -2.06160719515852, 218, 6, 'PPL', 'P'),
(179229, 'Stoneman Lake', 34.7813911437988, 0.607049793883286, -111.511940002441, -1.94625050832898, 218, 5, 'PPL', 'P'),
(25158, 'Stonemont', 33.8472213745117, 0.59074545563663, -84.079719543457, -1.46746794018675, 218, 13, 'PPL', 'P'),
(167639, 'Stonemont', 40.5563888549805, 0.707842518238542, -76.2275009155273, -1.33042087154294, 218, 45, 'PPL', 'P'),
(51734, 'Stonemyer Manor', 39.7050018310547, 0.692983011462282, -77.2425003051758, -1.34813595279804, 218, 25, 'PPL', 'P'),
(133277, 'Stoneport', 45.2961082458496, 0.790566227229829, -83.4241714477539, -1.45602646751155, 218, 27, 'PPL', 'P'),
(167640, 'Stoner', 40.0038909912109, 0.698199611405529, -76.5769424438477, -1.33651977675533, 218, 45, 'PPL', 'P'),
(187398, 'Stoner', 37.5894393920898, 0.656059481370823, -108.319442749023, -1.89053091989596, 218, 7, 'PPL', 'P'),
(197630, 'Stoner Place', 47.5144386291504, 0.829283396315455, -112.72917175293, -1.96749521013481, 218, 31, 'PPL', 'P'),
(14679, 'Stoneridge', 39.7750015258789, 0.694204736612355, -75.6916732788086, -1.32106891505902, 218, 10, 'PPL', 'P'),
(25159, 'Stoneridge', 33.5541687011719, 0.585630721605079, -84.4219436645508, -1.47344087787958, 218, 13, 'PPL', 'P'),
(51752, 'Stoneridge', 39.1599998474121, 0.683470932417818, -77.2688903808594, -1.34859654650857, 218, 25, 'PPL', 'P'),
(57744, 'Stoneridge', 36.6666717529297, 0.639954147836624, -93.4124984741211, -1.63035566088759, 218, 29, 'PPL', 'P'),
(106608, 'Stoneridge', 38.791389465332, 0.677037467593487, -77.4613876342773, -1.35195625738176, 218, 53, 'PPL', 'P'),
(167641, 'Stonerstown', 40.2166709899902, 0.701913322966617, -78.2577819824219, -1.36585596090116, 218, 45, 'PPL', 'P'),
(167642, 'Stonersville', 40.3163909912109, 0.703653765318011, -75.804443359375, -1.32303712426264, 218, 45, 'PPL', 'P'),
(79210, 'Stonerville', 39.8600006103516, 0.695688250497584, -79.5116729736328, -1.38774048715888, 218, 45, 'PPL', 'P'),
(6103, 'Stones', 32.3372192382813, 0.564390946647261, -86.4208297729492, -1.50832802184351, 218, 2, 'PPL', 'P'),
(77347, 'Stones Corner', 35.8711090087891, 0.626068958545169, -95.6063919067383, -1.66864632472464, 218, 42, 'PPL', 'P'),
(106600, 'Stones Corner', 38.3280601501465, 0.668950845522488, -77.3908309936523, -1.35072481169371, 218, 53, 'PPL', 'P'),
(129007, 'Stones Corner', 44.502498626709, 0.776715126400327, -70.1788864135742, -1.22485263329999, 218, 26, 'PPL', 'P'),
(31231, 'Stones Crossing', 39.5777816772461, 0.690762600903428, -86.1591720581055, -1.50376123320624, 218, 19, 'PPL', 'P'),
(25160, 'Stones Crossroads', 33.5227813720703, 0.585082909368849, -82.4347229003906, -1.43875733258099, 218, 13, 'PPL', 'P'),
(43227, 'Stones Landing', 32.0847206115723, 0.559984014254425, -91.5669403076172, -1.59814459434503, 218, 22, 'PPL', 'P'),
(193981, 'Stones Landing', 40.7125015258789, 0.710567198349802, -120.722221374512, -2.1070002433067, 218, 6, 'PPL', 'P'),
(106602, 'Stones Mill', 36.9352798461914, 0.644642243461545, -81.0733337402344, -1.4149966093353, 218, 53, 'PPL', 'P'),
(205928, 'Stones Orchard Addition', 41.2391700744629, 0.719759298589293, -111.959716796875, -1.95406568770587, 218, 52, 'PPL', 'P'),
(91062, 'Stones River Homes', 36.0063896179199, 0.628430050588606, -86.495002746582, -1.50962258444939, 218, 50, 'PPL', 'P'),
(106603, 'Stones Store', 36.7441711425781, 0.641306767354275, -80.0772171020508, -1.3976110942651, 218, 53, 'PPL', 'P'),
(14681, 'Stones Throw', 39.6347198486328, 0.691756359464191, -75.7438888549805, -1.32198024878405, 218, 10, 'PPL', 'P'),
(69129, 'Stones Throw', 35.8758316040039, 0.626151383380907, -79.9944381713867, -1.39616632937373, 218, 33, 'PPL', 'P'),
(197629, 'Stones Trailer Park', 45.4027786254883, 0.792427976568876, -108.973609924316, -1.90194829096329, 218, 31, 'PPL', 'P'),
(57745, 'Stonesport (historical)', 38.6672210693359, 0.674870320256435, -92.2816696166992, -1.61061897404901, 218, 29, 'PPL', 'P'),
(146410, 'Stonetown', 41.0950012207031, 0.717243077412358, -74.3038864135742, -1.29684746494475, 218, 37, 'PPL', 'P'),
(167646, 'Stonetown', 40.3033294677734, 0.7034257987287, -75.8277816772461, -1.32344445475137, 218, 45, 'PPL', 'P'),
(167644, 'Stonevilla', 40.2944412231445, 0.703270669595203, -79.5177764892578, -1.38784701360249, 218, 45, 'PPL', 'P'),
(61897, 'Stoneville', 33.4238891601563, 0.583356914666369, -90.9150009155273, -1.58676610542961, 218, 30, 'PPL', 'P'),
(69130, 'Stoneville', 36.4663887023926, 0.636458549168813, -79.9072189331055, -1.39464406649464, 218, 33, 'PPL', 'P'),
(111555, 'Stoneville', 37.560001373291, 0.65554569101752, -81.6513900756836, -1.4250855956509, 218, 58, 'PPL', 'P'),
(126266, 'Stoneville', 42.2166709899902, 0.736819908006504, -71.8463897705078, -1.25395605716653, 218, 23, 'PPL', 'P'),
(157815, 'Stoneville', 41.5563888549805, 0.725295810758486, -80.9627838134766, -1.41306714912554, 218, 41, 'PPL', 'P'),
(202655, 'Stoneville', 44.7336082458496, 0.780748750187361, -102.654167175293, -1.79165320810155, 218, 49, 'PPL', 'P'),
(6105, 'Stonewall', 32.7063903808594, 0.570834198588598, -85.4775009155273, -1.49186382735242, 218, 2, 'PPL', 'P'),
(12140, 'Stonewall', 36.2430610656738, 0.632560746597373, -90.5522232055664, -1.58043443993795, 218, 4, 'PPL', 'P'),
(25163, 'Stonewall', 33.5977783203125, 0.586391853044623, -84.5475006103516, -1.47563225998255, 218, 13, 'PPL', 'P'),
(38395, 'Stonewall', 38.4391708374023, 0.670890092849257, -84.5647201538086, -1.47593279771157, 218, 21, 'PPL', 'P'),
(43228, 'Stonewall', 32.2816696166992, 0.563421422852417, -93.8238906860352, -1.63753580950255, 218, 22, 'PPL', 'P'),
(61900, 'Stonewall', 33.0833282470703, 0.577413005429421, -90.3702774047852, -1.57725888665414, 218, 30, 'PPL', 'P'),
(69131, 'Stonewall', 35.1372184753418, 0.613260152387296, -76.7480621337891, -1.3395063787598, 218, 33, 'PPL', 'P'),
(77348, 'Stonewall', 34.6525001525879, 0.604800221710496, -96.5258331298828, -1.68469360134708, 218, 42, 'PPL', 'P'),
(91063, 'Stonewall', 36.1902809143066, 0.631639559176315, -85.8988876342773, -1.49921841301878, 218, 50, 'PPL', 'P'),
(98313, 'Stonewall', 30.2358303070068, 0.527714790931557, -98.6641693115234, -1.72201460823123, 218, 51, 'PPL', 'P'),
(106606, 'Stonewall', 38.2994384765625, 0.668451303081017, -78.9697189331055, -1.37828160475719, 218, 53, 'PPL', 'P'),
(187400, 'Stonewall', 37.1522216796875, 0.648428592741365, -105.016670227051, -1.83288666494314, 218, 7, 'PPL', 'P'),
(111558, 'Stonewall (historical)', 37.8255615234375, 0.660180589999667, -81.1288909912109, -1.4159662662882, 218, 58, 'PPL', 'P'),
(106607, 'Stonewall Acres', 38.7722206115723, 0.676702907981546, -77.4894409179688, -1.35244587954817, 218, 53, 'PPL', 'P'),
(38396, 'Stonewall Estates', 38.0027809143066, 0.663273651868712, -84.5497207641602, -1.47567100897641, 218, 21, 'PPL', 'P'),
(106609, 'Stonewall Estates', 37.6069412231445, 0.656364945947856, -77.3013916015625, -1.34916379982076, 218, 53, 'PPL', 'P'),
(106610, 'Stonewall Forest', 37.3041687011719, 0.651080568554866, -80.0550003051758, -1.39722333801038, 218, 53, 'PPL', 'P'),
(187401, 'Stonewall Gap', 37.1513900756836, 0.648414078513424, -105.038063049316, -1.83326004012797, 218, 7, 'PPL', 'P'),
(106616, 'Stonewall Manor', 37.6361083984375, 0.656874009190224, -77.4691696166992, -1.35209207859735, 218, 53, 'PPL', 'P'),
(51735, 'Stonewall Manor Estates', 39.3211097717285, 0.686282831054779, -77.432502746582, -1.35145212098741, 218, 25, 'PPL', 'P'),
(106617, 'Stonewall Mills', 37.4480590820313, 0.653591929462811, -78.9161071777344, -1.37734590310819, 218, 53, 'PPL', 'P'),
(106618, 'Stonewall Orchard', 39.189998626709, 0.683994509888128, -78.2080612182617, -1.36498816985995, 218, 53, 'PPL', 'P'),
(83850, 'Stonewall Woods', 34.5574989318848, 0.603142137615813, -82.7027816772461, -1.44343584082598, 218, 48, 'PPL', 'P'),
(43229, 'Stonewalls (historical)', 31.1847190856934, 0.544276024354865, -92.2958297729492, -1.61086611539817, 218, 22, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(43230, 'Stonewell Plantation', 30.7252807617188, 0.536257312891663, -91.5038909912109, -1.59704417618261, 218, 22, 'PPL', 'P'),
(25165, 'Stonewood', 33.9099998474121, 0.591841146688116, -84.1894378662109, -1.46938288616857, 218, 13, 'PPL', 'P'),
(51736, 'Stonewood', 39.1061096191406, 0.68253037049983, -76.8777770996094, -1.34177033200248, 218, 25, 'PPL', 'P'),
(111557, 'Stonewood', 39.2508316040039, 0.685056245635715, -80.3125, -1.40171755550795, 218, 58, 'PPL', 'P'),
(69133, 'Stonewood Acres', 36.2555618286133, 0.632778926069678, -80.0683288574219, -1.3974559651316, 218, 33, 'PPL', 'P'),
(112535, 'Stonewood Farms', 39.9794387817383, 0.697772839840844, -76.6275024414063, -1.33740221518253, 218, 45, 'PPL', 'P'),
(51737, 'Stoney Brook', 39.0627784729004, 0.681774099329274, -77.0913925170898, -1.34549862437054, 218, 25, 'PPL', 'P'),
(51738, 'Stoney Brook Estates', 39.065559387207, 0.681822635440141, -77.0822219848633, -1.34533856838902, 218, 25, 'PPL', 'P'),
(106620, 'Stoney Brook Estates', 37.148609161377, 0.648365542402557, -76.5555572509766, -1.33614653472856, 218, 53, 'PPL', 'P'),
(25169, 'Stoney Brook Plantation', 33.4313888549805, 0.583487809033946, -84.5680618286133, -1.47599112093944, 218, 13, 'PPL', 'P'),
(133278, 'Stoney Corner', 44.1936111450195, 0.771324022826652, -85.2847213745117, -1.48849918963121, 218, 27, 'PPL', 'P'),
(69136, 'Stoney Creek', 35.4494400024414, 0.618709446030789, -77.9550018310547, -1.36057145035011, 218, 33, 'PPL', 'P'),
(51739, 'Stoney Creek Estates', 39.0611114501953, 0.681745004294365, -77.2644424438477, -1.3485189153628, 218, 25, 'PPL', 'P'),
(138307, 'Stoney Creek Estates', 43.6161117553711, 0.761244757049029, -93.352783203125, -1.62931343279499, 218, 28, 'PPL', 'P'),
(51740, 'Stoney Creek Farm', 39.0555610656738, 0.681648131809714, -77.2613906860352, -1.34846565214099, 218, 25, 'PPL', 'P'),
(51741, 'Stoney Creek Farms', 39.3941688537598, 0.687557952584708, -77.4694366455078, -1.35209673912926, 218, 25, 'PPL', 'P'),
(51742, 'Stoney Forest Estates', 39.5097198486328, 0.689574697899198, -76.2380599975586, -1.33060516229038, 218, 25, 'PPL', 'P'),
(38397, 'Stoney Fork', 36.832218170166, 0.642843477882278, -83.5347213745117, -1.45795592772131, 218, 21, 'PPL', 'P'),
(51743, 'Stoney Hill', 39.0825004577637, 0.682118312900167, -76.6999969482422, -1.33866748301643, 218, 25, 'PPL', 'P'),
(83851, 'Stoney Hill', 34.1672210693359, 0.59633050391669, -81.5749969482422, -1.42375228405115, 218, 48, 'PPL', 'P'),
(157816, 'Stoney Hill', 41.1358299255371, 0.717955672741036, -81.6680603027344, -1.42537654599999, 218, 41, 'PPL', 'P'),
(69137, 'Stoney Knob', 35.6800003051758, 0.622733482437899, -82.5727767944336, -1.44116682757724, 218, 33, 'PPL', 'P'),
(69138, 'Stoney Mountain Estate', 35.3586082458496, 0.617124132812892, -82.4861068725586, -1.43965415207807, 218, 33, 'PPL', 'P'),
(6106, 'Stoney Point', 32.5908317565918, 0.568817320116054, -86.4322204589844, -1.50852682681888, 218, 2, 'PPL', 'P'),
(12142, 'Stoney Point', 36.3152809143066, 0.633821220741308, -91.0772171020508, -1.58959731198447, 218, 4, 'PPL', 'P'),
(25166, 'Stoney Point', 33.4430618286133, 0.583691540857337, -85.1930618286133, -1.4868994287644, 218, 13, 'PPL', 'P'),
(38399, 'Stoney Point', 38.7652816772461, 0.676581800730974, -83.9230575561523, -1.46473367269556, 218, 21, 'PPL', 'P'),
(43231, 'Stoney Point', 30.8180599212646, 0.537876614702973, -90.2786102294922, -1.57565899262927, 218, 22, 'PPL', 'P'),
(77350, 'Stoney Point', 35.5958290100098, 0.621264416201584, -94.6627807617188, -1.65217720338554, 218, 42, 'PPL', 'P'),
(133279, 'Stoney Point', 42.0808296203613, 0.734449028846061, -84.5841674804688, -1.4762722175925, 218, 27, 'PPL', 'P'),
(6107, 'Stoney Point (historical)', 34.8972206115723, 0.609071399466765, -87.692497253418, -1.53052280636823, 218, 2, 'PPL', 'P'),
(51744, 'Stoney Ridge', 39.4708290100098, 0.688895924716364, -77.0741729736328, -1.34519808664152, 218, 25, 'PPL', 'P'),
(51746, 'Stoney Run', 38.2158317565918, 0.666992090540735, -76.4888916015625, -1.3349829996483, 218, 25, 'PPL', 'P'),
(51747, 'Stoney View', 39.1505584716797, 0.68330614932537, -76.5297164916992, -1.33569552839796, 218, 25, 'PPL', 'P'),
(25167, 'Stoneybrook', 33.7694396972656, 0.589387909270962, -84.6836090087891, -1.4780077996749, 218, 13, 'PPL', 'P'),
(38398, 'Stoneybrook', 37.9836082458496, 0.662939025677743, -84.5163879394531, -1.47508924143628, 218, 21, 'PPL', 'P'),
(51748, 'Stoneybrook', 39.4872207641602, 0.689182014796466, -76.3930587768555, -1.33331040132568, 218, 25, 'PPL', 'P'),
(69140, 'Stoneybrook', 35.7622184753418, 0.624168460212261, -77.9488906860352, -1.36046479074846, 218, 33, 'PPL', 'P'),
(51749, 'Stoneybrook North', 39.3777809143066, 0.687271929083634, -76.7838897705078, -1.34013168898375, 218, 25, 'PPL', 'P'),
(51750, 'Stoneybrook Village', 39.146671295166, 0.6832383052966, -76.5347213745117, -1.33578288008171, 218, 25, 'PPL', 'P'),
(121594, 'Stoneyville', 41.3047218322754, 0.720903392593591, -88.8363876342773, -1.55048745979612, 218, 18, 'PPL', 'P'),
(28706, 'Stonington', 39.6399993896484, 0.691848504837908, -89.1927795410156, -1.55670767199616, 218, 18, 'PPL', 'P'),
(31233, 'Stonington', 38.7316703796387, 0.675995172921857, -86.3675003051758, -1.50739724704252, 218, 19, 'PPL', 'P'),
(51751, 'Stonington', 39.0555610656738, 0.681648131809714, -76.4716720581055, -1.33468246191929, 218, 25, 'PPL', 'P'),
(61901, 'Stonington', 31.7588901519775, 0.55429719993121, -91.017219543457, -1.58855015704386, 218, 30, 'PPL', 'P'),
(114131, 'Stonington', 41.3358306884766, 0.72144634456083, -71.9063873291016, -1.25500321210715, 218, 8, 'PPL', 'P'),
(129008, 'Stonington', 44.1561088562012, 0.770669484409738, -68.6672210693359, -1.19846909585473, 218, 26, 'PPL', 'P'),
(133281, 'Stonington', 46.9744415283203, 0.819858668954747, -88.7836074829102, -1.54956627237506, 218, 27, 'PPL', 'P'),
(167645, 'Stonington', 40.8519401550293, 0.713000861532944, -76.67138671875, -1.33816814031204, 218, 45, 'PPL', 'P'),
(187402, 'Stonington', 37.2936096191406, 0.650896277807432, -102.186943054199, -1.78349860884373, 218, 7, 'PPL', 'P'),
(83853, 'Stono', 32.7299995422363, 0.571246256188261, -79.9824981689453, -1.39595793701843, 218, 48, 'PPL', 'P'),
(83855, 'Stono Station', 32.7608299255371, 0.571784347886511, -80.1061096191406, -1.3981153638175, 218, 48, 'PPL', 'P'),
(98314, 'Stony', 33.2241706848145, 0.579871169694591, -97.3522186279297, -1.69911674917873, 218, 51, 'PPL', 'P'),
(106621, 'Stony', 36.8466682434082, 0.643095679237509, -82.4538879394531, -1.4390918256139, 218, 53, 'PPL', 'P'),
(106622, 'Stony Battery', 36.7447204589844, 0.641316354734199, -81.5652770996094, -1.42358264068971, 218, 53, 'PPL', 'P'),
(51753, 'Stony Beach', 39.172779083252, 0.683693972159113, -76.5188903808594, -1.33550657711861, 218, 25, 'PPL', 'P'),
(126267, 'Stony Beach', 42.3069381713867, 0.738395367528367, -70.9022216796875, -1.23747721528945, 218, 23, 'PPL', 'P'),
(176567, 'Stony Beach', 43.9880599975586, 0.767736478522206, -88.5277786254883, -1.54510121649143, 218, 57, 'PPL', 'P'),
(111559, 'Stony Bottom', 38.3641700744629, 0.669581082594456, -79.9625015258789, -1.39560892975758, 218, 58, 'PPL', 'P'),
(152955, 'Stony Brook', 40.9255599975586, 0.71428577017988, -73.1413879394531, -1.27655803902193, 218, 40, 'PPL', 'P'),
(167647, 'Stony Brook', 40.1833305358887, 0.701331422268435, -75.1066665649414, -1.31085862175577, 218, 45, 'PPL', 'P'),
(51754, 'Stony Chase Court', 39.648609161377, 0.691998773702416, -75.9452819824219, -1.32549522194879, 218, 25, 'PPL', 'P'),
(69146, 'Stony Creek', 36.2586097717285, 0.632832122712452, -79.420280456543, -1.38614538682398, 218, 33, 'PPL', 'P'),
(106623, 'Stony Creek', 36.9477806091309, 0.64486042293385, -77.4011077880859, -1.35090417559313, 218, 53, 'PPL', 'P'),
(114133, 'Stony Creek', 41.2644386291504, 0.72020031806581, -72.7466735839844, -1.26966897391411, 218, 8, 'PPL', 'P'),
(123741, 'Stony Creek', 41.5347213745117, 0.724917641883694, -85.6500015258789, -1.49487453096475, 218, 19, 'PPL', 'P'),
(133284, 'Stony Creek', 42.1558303833008, 0.735758039100862, -83.6527786254883, -1.46001641545671, 218, 27, 'PPL', 'P'),
(152956, 'Stony Creek', 43.4241714477539, 0.757894766713819, -73.9302825927734, -1.29032684817375, 218, 40, 'PPL', 'P'),
(167648, 'Stony Creek', 40.5813903808594, 0.708278877183152, -76.0622177124023, -1.32753613545017, 218, 45, 'PPL', 'P'),
(167650, 'Stony Creek Mills', 40.3455581665039, 0.70416282856038, -75.8702774047852, -1.32418614511496, 218, 45, 'PPL', 'P'),
(185393, 'Stony Creek Village', 36.6641693115234, 0.639910471994746, -118.839721679688, -2.07414442546423, 218, 6, 'PPL', 'P'),
(14682, 'Stony Crest', 39.7477798461914, 0.693729628673885, -75.6236114501953, -1.31988101205479, 218, 10, 'PPL', 'P'),
(152958, 'Stony Ford', 41.4594383239746, 0.723603704780876, -74.3052825927734, -1.29687183286873, 218, 40, 'PPL', 'P'),
(69151, 'Stony Fork', 36.211109161377, 0.63200308066511, -81.4861068725586, -1.42220085955813, 218, 33, 'PPL', 'P'),
(167649, 'Stony Fork', 41.6730613708496, 0.727332130306987, -77.3625030517578, -1.35023039583734, 218, 45, 'PPL', 'P'),
(38400, 'Stony Fork Junction', 36.6016693115234, 0.63881964121225, -83.7522201538086, -1.46175199753911, 218, 21, 'PPL', 'P'),
(25168, 'Stony Hill', 33.3605613708496, 0.582251636234959, -82.7058334350586, -1.44348910404778, 218, 13, 'PPL', 'P'),
(57746, 'Stony Hill', 38.542781829834, 0.672698445808448, -91.3736114501953, -1.5947703692439, 218, 29, 'PPL', 'P'),
(69153, 'Stony Hill', 35.9813919067383, 0.627993758223024, -78.6122207641602, -1.37204208463925, 218, 33, 'PPL', 'P'),
(146412, 'Stony Hill', 40.670280456543, 0.709830301676177, -74.4277801513672, -1.29900981859184, 218, 37, 'PPL', 'P'),
(152959, 'Stony Hollow', 41.9719390869141, 0.732548530513153, -74.0802764892578, -1.29294473552529, 218, 40, 'PPL', 'P'),
(121595, 'Stony Island', 41.7224998474121, 0.728194994500173, -87.5749969482422, -1.52847203917081, 218, 18, 'PPL', 'P'),
(69154, 'Stony Knoll', 36.3113899230957, 0.633753310133511, -80.6738891601563, -1.40802498623369, 218, 33, 'PPL', 'P'),
(133285, 'Stony Lake', 43.5597190856934, 0.760260519289163, -86.5, -1.5097098029751, 218, 27, 'PPL', 'P'),
(83857, 'Stony Landing', 33.1930618286133, 0.579328217727352, -79.9694366455078, -1.39572997042912, 218, 48, 'PPL', 'P'),
(31232, 'Stony Lonesome', 39.2008285522461, 0.684183527746496, -86.0622177124023, -1.5020690606496, 218, 19, 'PPL', 'P'),
(106625, 'Stony Man', 38.6305618286133, 0.674230495804543, -78.4347229003906, -1.36894416250121, 218, 53, 'PPL', 'P'),
(106626, 'Stony Mill', 36.6394386291504, 0.639478840161072, -79.5441665649414, -1.38830760731302, 218, 53, 'PPL', 'P'),
(179230, 'Stony Mountain Villas', 33.5900001525879, 0.586256098408056, -112.030563354492, -1.95530219339999, 218, 5, 'PPL', 'P'),
(12143, 'Stony Point', 35.0769386291504, 0.612208070598661, -92.6044387817383, -1.61625235870286, 218, 4, 'PPL', 'P'),
(34062, 'Stony Point', 39.0944404602051, 0.682326705255466, -94.7600021362305, -1.65387403647408, 218, 20, 'PPL', 'P'),
(38401, 'Stony Point', 38.1205596923828, 0.665329279335117, -84.1938934326172, -1.4694606504724, 218, 21, 'PPL', 'P'),
(69156, 'Stony Point', 35.3050003051758, 0.61618849774292, -81.4327774047852, -1.42127008475714, 218, 33, 'PPL', 'P'),
(77352, 'Stony Point', 35.2527809143066, 0.615277097438868, -94.668327331543, -1.65227400929116, 218, 42, 'PPL', 'P'),
(83856, 'Stony Point', 34.2761116027832, 0.598231002249598, -82.1272201538086, -1.4333903971942, 218, 48, 'PPL', 'P'),
(91068, 'Stony Point', 35.9894409179688, 0.628134239970525, -83.7222213745117, -1.4612284200688, 218, 50, 'PPL', 'P'),
(106628, 'Stony Point', 37.8133316040039, 0.659967137638297, -78.4913864135742, -1.36993312737201, 218, 53, 'PPL', 'P'),
(133287, 'Stony Point', 41.9413909912109, 0.732015365662919, -83.2649993896484, -1.45324839102043, 218, 27, 'PPL', 'P'),
(152961, 'Stony Point', 41.2294387817383, 0.719589455490773, -73.9875030517578, -1.29132553358253, 218, 40, 'PPL', 'P'),
(167655, 'Stony Point', 40.4555587768555, 0.706082701390218, -75.7516708374023, -1.32211606999964, 218, 45, 'PPL', 'P'),
(185394, 'Stony Point', 38.3108291625977, 0.668650108056391, -122.73388671875, -2.14211042701193, 218, 6, 'PPL', 'P'),
(157817, 'Stony Prairie', 41.351390838623, 0.721717920412991, -83.1552810668945, -1.45133344503861, 218, 41, 'PPL', 'P'),
(106629, 'Stony Ridge', 37.1883316040039, 0.649058829813332, -81.5338897705078, -1.42303482845349, 218, 53, 'PPL', 'P'),
(123744, 'Stony Ridge', 41.327220916748, 0.721296075696323, -85.7769393920898, -1.49709001467559, 218, 19, 'PPL', 'P'),
(157819, 'Stony Ridge', 41.5102806091309, 0.724491070056091, -83.5072174072266, -1.45747589293483, 218, 41, 'PPL', 'P'),
(74429, 'Stony Ridge (historical)', 39.0625, 0.681769239060285, -83.1125030517578, -1.45058682782701, 218, 41, 'PPL', 'P'),
(212165, 'Stony River', 61.7830581665039, 1.07831778695666, -156.58805847168, -2.73297718963621, 218, 1, 'PPL', 'P'),
(51755, 'Stony Run', 39.1816711425781, 0.683849167871637, -76.6975021362305, -1.33862394033261, 218, 25, 'PPL', 'P'),
(106630, 'Stony Run', 37.9744415283203, 0.662779036275257, -79.2647171020508, -1.38343029409264, 218, 53, 'PPL', 'P'),
(167654, 'Stony Run', 40.6186103820801, 0.708928488752049, -75.8183288574219, -1.32327947192184, 218, 45, 'PPL', 'P'),
(106631, 'Stony Run Estates', 37.6838912963867, 0.657707978085583, -77.4749984741211, -1.352193811351, 218, 53, 'PPL', 'P'),
(106632, 'Stony Springs', 37.0544395446777, 0.646721972535815, -77.5638885498047, -1.35374523584402, 218, 53, 'PPL', 'P'),
(79219, 'Stonybreak', 39.7666702270508, 0.694059328016837, -78.246940612793, -1.36566674330571, 218, 45, 'PPL', 'P'),
(167657, 'Stonybrook', 40.1502799987793, 0.700754581576324, -74.829719543457, -1.30602498437727, 218, 45, 'PPL', 'P'),
(79214, 'Stonybrook Heights', 39.9811096191406, 0.69780200145478, -76.6374969482422, -1.33757665223393, 218, 45, 'PPL', 'P'),
(126268, 'Stonybrook Village', 42.2522201538086, 0.737440357961465, -71.1430587768555, -1.24168061559598, 218, 23, 'PPL', 'P'),
(167656, 'Stonycreek', 40.3038902282715, 0.703435585845706, -78.89111328125, -1.37690967732164, 218, 45, 'PPL', 'P'),
(185395, 'Stonyford', 39.3752784729004, 0.687228253241757, -122.543060302734, -2.13877987775267, 218, 6, 'PPL', 'P'),
(43232, 'Stonypoint (historical)', 30.6352806091309, 0.534686513901708, -90.9361114501953, -1.58713455376642, 218, 22, 'PPL', 'P'),
(152963, 'Stoodley Corners', 42.8688888549805, 0.748203257190911, -73.9336090087891, -1.29038490508551, 218, 40, 'PPL', 'P'),
(38402, 'Stoops', 38.128059387207, 0.665460173702694, -83.914436340332, -1.46458320409397, 218, 21, 'PPL', 'P'),
(12144, 'Stoops (historical)', 34.7938919067383, 0.607267973355591, -91.1555633544922, -1.59096471204618, 218, 4, 'PPL', 'P'),
(167659, 'Stoops Ferry', 40.5380592346191, 0.707522606012597, -80.1999969482422, -1.39975400683623, 218, 45, 'PPL', 'P'),
(167660, 'Stoopville', 40.2655601501465, 0.702766599779878, -74.9494400024414, -1.30811450056855, 218, 45, 'PPL', 'P'),
(25170, 'Stop', 33.4797210693359, 0.584331365309229, -84.5888900756836, -1.47635464242823, 218, 13, 'PPL', 'P'),
(12145, 'Stop (historical)', 35.7519416809082, 0.623989096312844, -94.4111099243164, -1.64778471864162, 218, 4, 'PPL', 'P'),
(38403, 'Stopover', 37.5158309936523, 0.654774772460969, -82.0913925170898, -1.43276508697025, 218, 21, 'PPL', 'P'),
(106633, 'Storck', 38.4191703796387, 0.670541019009375, -77.6138916015625, -1.35461795373324, 218, 53, 'PPL', 'P'),
(138312, 'Storden', 44.0377807617188, 0.768604269563409, -95.3180618286133, -1.66361401552883, 218, 28, 'PPL', 'P'),
(211104, 'Store Village', 20.9066696166992, 0.364890220438062, -156.374176025391, -2.72924423673625, 218, 15, 'PPL', 'P'),
(129010, 'Storers Corner', 45.1313896179199, 0.787691344833088, -68.8913879394531, -1.20238154581217, 218, 26, 'PPL', 'P'),
(83858, 'Storeville (historical)', 34.3588905334473, 0.599675767140966, -82.5805587768555, -1.44130264879283, 218, 48, 'PPL', 'P'),
(185396, 'Storey', 36.9741706848145, 0.645321016644379, -120.018058776855, -2.09471028750821, 218, 6, 'PPL', 'P'),
(91069, 'Storie', 35.9311103820801, 0.627116180064815, -85.0466690063477, -1.48434439201458, 218, 50, 'PPL', 'P'),
(171386, 'Storla', 43.8636093139648, 0.765564404337138, -98.3511123657227, -1.71655073378077, 218, 49, 'PPL', 'P'),
(83859, 'Storm Branch Park', 33.4811096191406, 0.584355600075149, -81.8936080932617, -1.42931309756529, 218, 48, 'PPL', 'P'),
(117916, 'Storm Lake', 42.6411094665527, 0.744227756894668, -95.2094421386719, -1.66171824430686, 218, 16, 'PPL', 'P'),
(205931, 'Storm Mountain Terrace', 40.5449981689453, 0.707643713263168, -111.868057250977, -1.95246592683906, 218, 52, 'PPL', 'P'),
(106634, 'Stormont', 37.5969390869141, 0.656190375738401, -76.5686111450195, -1.33637436815982, 218, 53, 'PPL', 'P'),
(74430, 'Storms', 39.2386093139648, 0.6848429264324, -83.1802825927734, -1.45176980398322, 218, 41, 'PPL', 'P'),
(167661, 'Stormstown', 40.7933311462402, 0.711977941358245, -78.0169372558594, -1.36165242743658, 218, 45, 'PPL', 'P'),
(152964, 'Stormville', 41.5702781677246, 0.72553822499671, -73.7458267211914, -1.28710748589, 218, 40, 'PPL', 'P'),
(167662, 'Stormville', 40.9516716003418, 0.71474150362142, -75.2438888549805, -1.31325360252408, 218, 45, 'PPL', 'P'),
(185397, 'Storrie', 39.9174995422363, 0.696691796175353, -121.322219848633, -2.11747219218706, 218, 6, 'PPL', 'P'),
(74431, 'Storrs', 39.105281829834, 0.682515922850916, -84.5533294677734, -1.47573399273619, 218, 41, 'PPL', 'P'),
(114134, 'Storrs', 41.8083305358887, 0.729693022613343, -72.25, -1.2610003845659, 218, 8, 'PPL', 'P'),
(192804, 'Storrs', 39.7038917541504, 0.692963636965351, -110.918891906738, -1.93589986643627, 218, 52, 'PPL', 'P'),
(197631, 'Storrs (historical)', 45.6297187805176, 0.796388829479124, -110.842216491699, -1.93456162798851, 218, 31, 'PPL', 'P'),
(12146, 'Story', 34.6930618286133, 0.605508156507266, -93.5175018310547, -1.63218831519173, 218, 4, 'PPL', 'P'),
(31234, 'Story', 39.0988883972168, 0.682404336401242, -86.2138900756836, -1.50471624277314, 218, 19, 'PPL', 'P'),
(43233, 'Story', 29.9130592346191, 0.522081372988199, -89.9091720581055, -1.56921108015603, 218, 22, 'PPL', 'P'),
(77353, 'Story', 34.855281829834, 0.608339429641157, -97.4583282470703, -1.70096871140077, 218, 42, 'PPL', 'P'),
(197632, 'Story', 45.7269401550293, 0.798085662567668, -111.081390380859, -1.93873599983915, 218, 31, 'PPL', 'P'),
(199709, 'Story', 42.9300003051758, 0.749269853207488, -103.938056945801, -1.81406131182959, 218, 35, 'PPL', 'P'),
(209756, 'Story', 44.5747184753418, 0.777975600544261, -106.886108398438, -1.8655145161963, 218, 59, 'PPL', 'P'),
(25175, 'Story (historical)', 33.9874992370605, 0.593193766205767, -84.7311096191406, -1.47883684172224, 218, 13, 'PPL', 'P'),
(57747, 'Story (historical)', 37.9302787780762, 0.662008250876761, -93.855827331543, -1.63809320911871, 218, 29, 'PPL', 'P'),
(61903, 'Story (historical)', 31.4500007629395, 0.548906063068022, -89.8841705322266, -1.56877472121142, 218, 30, 'PPL', 'P'),
(117918, 'Story City', 42.1872215270996, 0.736305917916118, -93.5955581665039, -1.63355065524736, 218, 16, 'PPL', 'P'),
(43234, 'Story Park', 29.9272193908691, 0.522328514337358, -89.9047164916992, -1.5691333158522, 218, 22, 'PPL', 'P'),
(98316, 'Storylane Colonia', 26.2469997406006, 0.458096564243578, -98.2819976806641, -1.71534445496502, 218, 51, 'PPL', 'P'),
(69157, 'Storys', 36.435001373291, 0.635910736932584, -76.8891677856445, -1.34196913697785, 218, 33, 'PPL', 'P'),
(25172, 'Storys (historical)', 34.4208297729492, 0.600756810806456, -85.2541732788086, -1.48796602478098, 218, 13, 'PPL', 'P'),
(43235, 'Storyville', 29.9561100006104, 0.522832750600251, -90.0725021362305, -1.57206172778685, 218, 22, 'PPL', 'P'),
(57748, 'Stotesbury', 37.9719390869141, 0.66273536043338, -94.5633316040039, -1.65044148814508, 218, 29, 'PPL', 'P'),
(111561, 'Stotesbury', 37.6816711425781, 0.657669229091722, -81.2888870239258, -1.4187587238492, 218, 58, 'PPL', 'P'),
(111560, 'Stotlers Crossroads', 39.5133285522461, 0.689637681658979, -78.2241668701172, -1.36526926651301, 218, 58, 'PPL', 'P'),
(179231, 'Stotonic', 33.1580581665039, 0.578717288573287, -111.798606872559, -1.95125378906891, 218, 5, 'PPL', 'P'),
(179232, 'Stotonyak', 32.1549987792969, 0.561210599673488, -112.368057250977, -1.96119257309903, 218, 5, 'PPL', 'P'),
(57749, 'Stotts City', 37.1036109924316, 0.647580176197093, -93.9494400024414, -1.63972705844747, 218, 29, 'PPL', 'P'),
(69158, 'Stotts Crossroads', 35.7405586242676, 0.623790424495524, -78.0630569458008, -1.36245736787605, 218, 33, 'PPL', 'P'),
(106635, 'Stotts Crossroads', 36.9261093139648, 0.644482187480031, -76.7705612182617, -1.33989906186254, 218, 53, 'PPL', 'P'),
(25173, 'Stottsville', 34.5299987792969, 0.602662169408353, -83.4875030517578, -1.45713181252199, 218, 13, 'PPL', 'P'),
(79216, 'Stottsville', 39.9594383239746, 0.697423766000961, -75.8886108398438, -1.32450612391993, 218, 45, 'PPL', 'P'),
(152965, 'Stottville', 42.2861099243164, 0.738031846039572, -73.7391662597656, -1.28699123890842, 218, 40, 'PPL', 'P'),
(167663, 'Stouchsburg', 40.3800010681152, 0.704763970597438, -76.2324981689453, -1.33050809006864, 218, 45, 'PPL', 'P'),
(74433, 'Stoudertown', 39.8675003051758, 0.695819144865162, -82.6913909912109, -1.44323703585061, 218, 41, 'PPL', 'P'),
(79217, 'Stoufferstown', 39.9277801513672, 0.696871226653797, -77.6308288574219, -1.35491356461424, 218, 45, 'PPL', 'P'),
(6108, 'Stough', 33.6955604553223, 0.588098473250173, -87.7444381713867, -1.53142934640329, 218, 2, 'PPL', 'P'),
(167664, 'Stoughstown', 40.1136093139648, 0.70011455738735, -77.4102783203125, -1.35106423157464, 218, 45, 'PPL', 'P'),
(126269, 'Stoughton', 42.125, 0.735219947402611, -71.102783203125, -1.24097767422625, 218, 23, 'PPL', 'P'),
(176568, 'Stoughton', 42.9169387817383, 0.749041886618177, -89.2177810668945, -1.55714403094077, 218, 57, 'PPL', 'P'),
(133288, 'Stoughton Corners', 42.2294387817383, 0.737042748010716, -86.166389465332, -1.5038872007258, 218, 27, 'PPL', 'P'),
(126270, 'Stoughton Junction', 42.0972213745117, 0.734735118926162, -71.0963897705078, -1.24086608777658, 218, 23, 'PPL', 'P'),
(61902, 'Stout', 32.3002815246582, 0.56374626192638, -90.899169921875, -1.58648980246652, 218, 30, 'PPL', 'P'),
(74432, 'Stout', 38.663890838623, 0.674812196765644, -83.3791732788086, -1.45524110130609, 218, 41, 'PPL', 'P'),
(91070, 'Stout', 35.0158309936523, 0.611141541161111, -87.9850006103516, -1.53562795301986, 218, 50, 'PPL', 'P'),
(98315, 'Stout', 32.871940612793, 0.57372359521328, -95.29638671875, -1.66323571349598, 218, 51, 'PPL', 'P'),
(117920, 'Stout', 42.5263900756836, 0.742225525808119, -92.711669921875, -1.61812389515891, 218, 16, 'PPL', 'P'),
(185398, 'Stout', 36.1827812194824, 0.631508664808737, -119.079437255859, -2.07832825153675, 218, 6, 'PPL', 'P'),
(195662, 'Stout Crossing', 43.1544418334961, 0.753187096854885, -115.309173583984, -2.0125247367942, 218, 17, 'PPL', 'P'),
(51762, 'Stouter', 39.7188911437988, 0.693225425700506, -77.3502807617188, -1.35001707663402, 218, 25, 'PPL', 'P'),
(57750, 'Stoutland', 37.8141708374023, 0.659981785024292, -92.5138931274414, -1.61467203891201, 218, 29, 'PPL', 'P'),
(69159, 'Stouts', 35.0552787780762, 0.611830034881924, -80.6397171020508, -1.40742857130757, 218, 33, 'PPL', 'P'),
(167665, 'Stouts', 40.6061096191406, 0.708710309279745, -75.2447204589844, -1.31326811675202, 218, 45, 'PPL', 'P'),
(111562, 'Stouts Mills', 38.8950004577637, 0.678845820552678, -80.7305603027344, -1.40901408426254, 218, 58, 'PPL', 'P'),
(123745, 'Stoutsburg', 41.1913909912109, 0.718925396272961, -87.1138916015625, -1.5204242326727, 218, 19, 'PPL', 'P'),
(146413, 'Stoutsburg', 40.398609161377, 0.705088743092373, -74.7358322143555, -1.30438634135855, 218, 37, 'PPL', 'P'),
(57752, 'Stoutsville', 39.5472183227539, 0.690229169737085, -91.8583297729492, -1.6032302999207, 218, 29, 'PPL', 'P'),
(74434, 'Stoutsville', 39.6047210693359, 0.691232781993882, -82.8291702270508, -1.4456417371569, 218, 41, 'PPL', 'P'),
(179233, 'Stoval', 32.7649993896484, 0.571857118763298, -113.621391296387, -1.98306737881878, 218, 5, 'PPL', 'P'),
(25174, 'Stovall', 32.9608306884766, 0.575275019706305, -84.851936340332, -1.48094566583142, 218, 13, 'PPL', 'P'),
(38404, 'Stovall', 37.0563888549805, 0.646755994418741, -86.0102767944336, -1.50116252061454, 218, 21, 'PPL', 'P'),
(61904, 'Stovall', 34.2966690063477, 0.598589796627459, -90.6447219848633, -1.58204884819075, 218, 30, 'PPL', 'P'),
(69160, 'Stovall', 36.4480590820313, 0.636138636942867, -78.570556640625, -1.3713149085036, 218, 33, 'PPL', 'P'),
(106636, 'Stovall', 36.9966697692871, 0.645713699747111, -79.0466690063477, -1.37962463689492, 218, 53, 'PPL', 'P'),
(25176, 'Stovall Mill', 34.6111106872559, 0.604077839264812, -83.6722183227539, -1.46035570217958, 218, 13, 'PPL', 'P'),
(194438, 'Stove Prairie Landing', 40.6824989318848, 0.710043554300466, -105.388610839844, -1.83937825325826, 218, 7, 'PPL', 'P'),
(197633, 'Stovepipe (historical)', 47.0277786254883, 0.820789576913784, -114.322219848633, -1.99529914454746, 218, 31, 'PPL', 'P'),
(34063, 'Stover', 37.1738891601563, 0.648806761616156, -95.1944427490234, -1.6614564555717, 218, 20, 'PPL', 'P'),
(57751, 'Stover', 38.4408302307129, 0.670919054726111, -92.9916687011719, -1.62301079575921, 218, 29, 'PPL', 'P'),
(61905, 'Stover', 34.047779083252, 0.594245847994403, -90.2786102294922, -1.57565899262927, 218, 30, 'PPL', 'P'),
(83860, 'Stover', 34.5508308410645, 0.603025757476176, -81.019172668457, -1.41405132030638, 218, 48, 'PPL', 'P'),
(106637, 'Stover', 38.2719383239746, 0.667971334873557, -79.147216796875, -1.38137952689523, 218, 53, 'PPL', 'P'),
(111563, 'Stover', 37.8141708374023, 0.659981785024292, -81.3541717529297, -1.41989815732159, 218, 58, 'PPL', 'P'),
(167670, 'Stover', 40.6772193908691, 0.709951408926749, -78.2019424438477, -1.36488137710024, 218, 45, 'PPL', 'P'),
(129011, 'Stover Corner', 44.4052810668945, 0.77501835989081, -68.7466735839844, -1.19985580383434, 218, 26, 'PPL', 'P'),
(117921, 'Stover Heights Community', 41.6388893127441, 0.726735715380864, -93.5583267211914, -1.63290084394138, 218, 16, 'PPL', 'P'),
(51756, 'Stovers', 39.5200004577637, 0.689754128377642, -77.3172225952148, -1.34944010278385, 218, 25, 'PPL', 'P'),
(129012, 'Stovers Corner', 44.3300018310547, 0.773704489367019, -69.2616729736328, -1.20884423882946, 218, 26, 'PPL', 'P'),
(167666, 'Stovers Mill', 41.1324996948242, 0.717897549250245, -79.5952835083008, -1.38919976627819, 218, 45, 'PPL', 'P'),
(79218, 'Stoverstown', 39.8841705322266, 0.696110095214253, -76.817497253418, -1.34071825021384, 218, 45, 'PPL', 'P'),
(74435, 'Stovertown', 39.8413887023926, 0.695363411423622, -81.9869384765625, -1.43094202004604, 218, 41, 'PPL', 'P'),
(12147, 'Stoverville', 36.0311088562012, 0.628861482685199, -93.398063659668, -1.63010372584847, 218, 4, 'PPL', 'P'),
(126272, 'Stow', 42.436939239502, 0.740664314198088, -71.5061111450195, -1.2480170747776, 218, 23, 'PPL', 'P'),
(129013, 'Stow', 44.1605606079102, 0.770747182134541, -70.9855575561523, -1.2389317007188, 218, 26, 'PPL', 'P'),
(152966, 'Stow', 42.1566696166992, 0.735772686486857, -79.4016723632813, -1.38582061432905, 218, 40, 'PPL', 'P'),
(157820, 'Stow', 41.1594390869141, 0.718367730340699, -81.440559387207, -1.42140590597274, 218, 41, 'PPL', 'P'),
(71444, 'Stow Acres', 39.9102783203125, 0.696565762076765, -74.914436340332, -1.30750357141449, 218, 37, 'PPL', 'P'),
(71447, 'Stow Creek Landing', 39.4425010681152, 0.688401508859991, -75.4088897705078, -1.31613341176883, 218, 37, 'PPL', 'P'),
(111564, 'Stowe', 37.8061103820801, 0.659841103539709, -81.7588882446289, -1.42696179263886, 218, 58, 'PPL', 'P'),
(167667, 'Stowe', 40.252498626709, 0.702538633190568, -75.6777801513672, -1.32082643424177, 218, 45, 'PPL', 'P'),
(172602, 'Stowe', 44.4652786254883, 0.776065514831429, -72.6849975585938, -1.2685925242015, 218, 55, 'PPL', 'P'),
(172603, 'Stowe Fork', 44.5022201538086, 0.776710266131337, -72.7566680908203, -1.26984341096551, 218, 55, 'PPL', 'P'),
(91073, 'Stowe Station', 35.8699989318848, 0.626049584048238, -84.529167175293, -1.47531228117758, 218, 50, 'PPL', 'P'),
(114136, 'Stowe Village Housing Project', 41.7936096191406, 0.729436094147177, -72.6708297729492, -1.26834524969429, 218, 8, 'PPL', 'P'),
(98317, 'Stowell', 29.7897205352783, 0.519928706589574, -94.383056640625, -1.6472950964752, 218, 51, 'PPL', 'P'),
(167669, 'Stowell', 41.5741691589355, 0.725606135604507, -76.2019424438477, -1.32997479206036, 218, 45, 'PPL', 'P'),
(91074, 'Stowers', 36.2313919067383, 0.632357081353009, -84.8169403076172, -1.48033486983541, 218, 50, 'PPL', 'P'),
(98318, 'Stowers Corner Windmill', 30.0277805328369, 0.524083637364261, -99.5025024414063, -1.73664628157624, 218, 51, 'PPL', 'P'),
(106638, 'Stowersville', 37.1911087036133, 0.649107299345172, -81.2402801513672, -1.41791037388395, 218, 53, 'PPL', 'P'),
(152967, 'Stowersville', 44.2866706848145, 0.772948218196464, -73.5216674804688, -1.28319516909062, 218, 40, 'PPL', 'P'),
(28709, 'Stoy', 38.997501373291, 0.680634799014939, -87.8330612182617, -1.53297611036441, 218, 18, 'PPL', 'P'),
(71446, 'Stoys Landing', 39.916389465332, 0.696672421678423, -75.0347213745117, -1.30960294130179, 218, 37, 'PPL', 'P'),
(167671, 'Stoystown', 40.103328704834, 0.699935126908906, -78.9497222900391, -1.37793259749634, 218, 45, 'PPL', 'P'),
(69161, 'Strabane', 35.1949996948242, 0.614268624913082, -77.7750015258789, -1.3574298523702, 218, 33, 'PPL', 'P'),
(167673, 'Strabane', 40.2508316040039, 0.702509538155659, -80.1980590820313, -1.39972018469039, 218, 45, 'PPL', 'P'),
(167674, 'Strables Corners', 40.7383308410645, 0.711018004943325, -79.9444427490234, -1.39529374464257, 218, 45, 'PPL', 'P'),
(43236, 'Strader', 30.3233299255371, 0.52924194736915, -90.4075012207031, -1.57790856480206, 218, 22, 'PPL', 'P'),
(57753, 'Strafford', 37.2683296203613, 0.650455058593834, -93.116943359375, -1.62519725101416, 218, 29, 'PPL', 'P'),
(144515, 'Strafford', 43.3269386291504, 0.756197733888193, -71.1847229003906, -1.24240779173162, 218, 36, 'PPL', 'P'),
(167676, 'Strafford', 40.0508308410645, 0.699018866335865, -75.4047164916992, -1.31606057431302, 218, 45, 'PPL', 'P'),
(172605, 'Strafford', 43.8663902282715, 0.765612940448004, -72.3783264160156, -1.26324010304266, 218, 55, 'PPL', 'P'),
(144516, 'Strafford Corner', 43.2941703796387, 0.755625820044098, -71.0774993896484, -1.24053638843363, 218, 36, 'PPL', 'P'),
(117922, 'Strahan', 40.9497184753418, 0.714707415159467, -95.498893737793, -1.66677012773668, 218, 16, 'PPL', 'P'),
(91075, 'Strahl', 36.353889465332, 0.634495067076125, -82.9563903808594, -1.44786214771575, 218, 50, 'PPL', 'P'),
(191017, 'Straight', 36.8766708374023, 0.643619323286845, -101.448333740234, -1.77060744442914, 218, 42, 'PPL', 'P'),
(38406, 'Straight Creek', 38.2677803039551, 0.667898763733852, -82.8775024414063, -1.44648529343218, 218, 21, 'PPL', 'P'),
(167675, 'Straight Creek', 41.5974998474121, 0.72601333293518, -78.4680633544922, -1.3695260631994, 218, 45, 'PPL', 'P'),
(91076, 'Straight Fork', 36.3783302307129, 0.634921638903728, -84.3583297729492, -1.47233060602112, 218, 50, 'PPL', 'P'),
(6111, 'Straight Mountain', 33.8763885498047, 0.591254518878999, -86.3944396972656, -1.50786742813298, 218, 2, 'PPL', 'P'),
(208840, 'Straight Point', 45.6974983215332, 0.797571805635337, -121.394721984863, -2.11873759317901, 218, 56, 'PPL', 'P'),
(106639, 'Straightstone', 37.0158309936523, 0.646048126200998, -79.1497192382813, -1.38142320273711, 218, 53, 'PPL', 'P'),
(12148, 'Strain', 36.0133285522461, 0.628551157839177, -94.0658264160156, -1.64175838456893, 218, 4, 'PPL', 'P'),
(57754, 'Strain', 38.2916717529297, 0.668315748181532, -91.3027801513672, -1.59353412986588, 218, 29, 'PPL', 'P'),
(98324, 'Strain', 30.1330604553223, 0.525921118647875, -94.5486068725586, -1.65018449309989, 218, 51, 'PPL', 'P'),
(25177, 'Strain (historical)', 31.9844398498535, 0.558233784786025, -81.7622222900391, -1.42701998270868, 218, 13, 'PPL', 'P'),
(69163, 'Straits', 34.728889465332, 0.606133466731217, -76.5713882446289, -1.33642283769166, 218, 33, 'PPL', 'P'),
(152968, 'Straits Corners', 42.1497192382813, 0.735651379499204, -76.3811111450195, -1.33310187581233, 218, 40, 'PPL', 'P'),
(69164, 'Straits Haven', 34.7299995422363, 0.606152841228147, -76.5788879394531, -1.33655373205923, 218, 33, 'PPL', 'P'),
(126274, 'Straits Pond', 42.2680587768555, 0.737716794082615, -70.845832824707, -1.23649304410861, 218, 23, 'PPL', 'P'),
(74436, 'Straitsville', 39.5947189331055, 0.691058211784427, -82.2458267211914, -1.43546047230952, 218, 41, 'PPL', 'P'),
(114135, 'Straitsville', 41.4697189331055, 0.723783135259321, -73.0336074829102, -1.27467691518595, 218, 8, 'PPL', 'P'),
(157822, 'Strakers (historical)', 40.3061103820801, 0.703474334839567, -84.4955596923828, -1.47472571994749, 218, 41, 'PPL', 'P'),
(197634, 'Stranahan', 47.9955596923828, 0.837680542969557, -110.320556640625, -1.9254569460118, 218, 31, 'PPL', 'P'),
(117923, 'Strand', 41.0722198486328, 0.71684546746161, -94.9016723632813, -1.65634664838817, 218, 16, 'PPL', 'P'),
(185399, 'Strand (historical)', 35.3405609130859, 0.616809147434963, -119.220283508301, -2.08078648238095, 218, 6, 'PPL', 'P'),
(171387, 'Strandburg', 45.0441703796387, 0.786169081953999, -96.7602767944336, -1.68878541520393, 218, 49, 'PPL', 'P'),
(208841, 'Strandell', 48.9122200012207, 0.853679283481126, -122.356941223145, -2.13553148701305, 218, 56, 'PPL', 'P'),
(138318, 'Strandquist', 48.4902801513672, 0.846315043855812, -96.4469375610352, -1.68331661390545, 218, 28, 'PPL', 'P'),
(77355, 'Strang', 36.4105606079102, 0.63548416510498, -95.1305618286133, -1.66034152318134, 218, 42, 'PPL', 'P'),
(143132, 'Strang', 40.4155616760254, 0.705384620289481, -97.586669921875, -1.70320869619364, 218, 35, 'PPL', 'P'),
(111565, 'Strange Creek', 38.563060760498, 0.673052379917319, -80.898063659668, -1.41193756934918, 218, 58, 'PPL', 'P'),
(98319, 'Stranger', 31.3266696929932, 0.546753529827452, -96.7241668701172, -1.68815517813196, 218, 51, 'PPL', 'P'),
(12149, 'Strangers Home', 35.920280456543, 0.626927162206447, -91.1283264160156, -1.5904893377916, 218, 4, 'PPL', 'P'),
(167677, 'Strangford', 40.4300003051758, 0.70563662190763, -79.2211074829102, -1.3826691626531, 218, 45, 'PPL', 'P'),
(28710, 'Strasburg', 39.3525009155273, 0.686830709870035, -88.6191711425781, -1.54669631682633, 218, 18, 'PPL', 'P'),
(79220, 'Strasburg', 39.9830589294434, 0.697836023337706, -76.184440612793, -1.32966932748332, 218, 45, 'PPL', 'P'),
(106640, 'Strasburg', 38.9886093139648, 0.680479603302414, -78.35888671875, -1.36762057143944, 218, 53, 'PPL', 'P'),
(112424, 'Strasburg', 38.7599983215332, 0.67648958877823, -94.1661071777344, -1.64350861403733, 218, 29, 'PPL', 'P'),
(133289, 'Strasburg', 41.9141693115234, 0.731540257724449, -83.5025024414063, -1.45739360125714, 218, 27, 'PPL', 'P'),
(157823, 'Strasburg', 40.5947189331055, 0.70851150430437, -81.5269393920898, -1.42291352146583, 218, 41, 'PPL', 'P'),
(187403, 'Strasburg', 39.7383308410645, 0.693564712423382, -104.322776794434, -1.820775939886, 218, 7, 'PPL', 'P'),
(198966, 'Strasburg', 46.1336097717285, 0.805183386346892, -100.161109924316, -1.74814115063129, 218, 34, 'PPL', 'P'),
(106641, 'Strasburg Junction', 38.996940612793, 0.680625011897932, -78.3783264160156, -1.36795985816232, 218, 53, 'PPL', 'P'),
(6110, 'Strata', 32.0344390869141, 0.559106436096216, -86.2941665649414, -1.50611733182263, 218, 2, 'PPL', 'P'),
(114137, 'Stratfield', 41.2066688537598, 0.719192045277106, -73.2363891601563, -1.27821612311661, 218, 8, 'PPL', 'P'),
(14683, 'Stratford', 39.6680603027344, 0.692338260162373, -75.6319427490234, -1.32002642065031, 218, 10, 'PPL', 'P'),
(25178, 'Stratford', 33.7541694641113, 0.589121393424873, -84.4805603027344, -1.47446393121233, 218, 13, 'PPL', 'P'),
(51757, 'Stratford', 39.4480590820313, 0.688498514502697, -76.6194381713867, -1.33726146711892, 218, 25, 'PPL', 'P'),
(69168, 'Stratford', 36.5183296203613, 0.637365089203876, -81.2161102294922, -1.41748852916729, 218, 33, 'PPL', 'P'),
(71448, 'Stratford', 39.8266716003418, 0.695106549536484, -75.0158309936523, -1.30927324195884, 218, 37, 'PPL', 'P'),
(77356, 'Stratford', 34.7966690063477, 0.60731644288743, -96.9591674804688, -1.69225671252679, 218, 42, 'PPL', 'P'),
(114138, 'Stratford', 41.184440612793, 0.718804089285308, -73.1336135864258, -1.27642235096439, 218, 8, 'PPL', 'P'),
(117924, 'Stratford', 42.2713890075684, 0.737774917573406, -93.9269409179688, -1.63933437534474, 218, 16, 'PPL', 'P'),
(121597, 'Stratford', 41.996940612793, 0.732984889457762, -89.4908294677734, -1.56190962455341, 218, 18, 'PPL', 'P'),
(144519, 'Stratford', 44.6549987792969, 0.779376756172779, -71.5561065673828, -1.24888965950877, 218, 36, 'PPL', 'P'),
(152969, 'Stratford', 43.1797218322754, 0.753628316068484, -74.6972198486328, -1.3037124284447, 218, 40, 'PPL', 'P'),
(157824, 'Stratford', 40.2561111450195, 0.702601683529375, -83.063606262207, -1.44973341785569, 218, 41, 'PPL', 'P'),
(171389, 'Stratford', 45.3163909912109, 0.790920227917728, -98.304443359375, -1.71573620596137, 218, 49, 'PPL', 'P'),
(176570, 'Stratford', 44.8011093139648, 0.781926866074585, -90.0791702270508, -1.57217810792648, 218, 57, 'PPL', 'P'),
(185400, 'Stratford', 36.1894416809082, 0.631624911790319, -119.822219848633, -2.09129225340714, 218, 6, 'PPL', 'P'),
(192280, 'Stratford', 36.336109161377, 0.634184742230103, -102.071670532227, -1.78148672379823, 218, 51, 'PPL', 'P'),
(208842, 'Stratford', 47.4272193908691, 0.827761133436366, -119.420562744141, -2.08428201446973, 218, 56, 'PPL', 'P'),
(31235, 'Stratford (historical)', 39.1327781677246, 0.682995824479348, -86.0944366455078, -1.50263138711377, 218, 19, 'PPL', 'P'),
(106642, 'Stratford Court', 37.2583312988281, 0.650280554963406, -79.9625015258789, -1.39560892975758, 218, 53, 'PPL', 'P'),
(83861, 'Stratford Forest', 34.9363899230957, 0.609755032918589, -82.4550018310547, -1.43911126668986, 218, 48, 'PPL', 'P'),
(106643, 'Stratford Hall', 38.1513900756836, 0.665867371033367, -76.834716796875, -1.34101878794286, 218, 53, 'PPL', 'P'),
(106645, 'Stratford Hills', 37.5516700744629, 0.655400282422002, -77.5363922119141, -1.35326533421559, 218, 53, 'PPL', 'P'),
(106646, 'Stratford Landing', 38.7216682434082, 0.675820602712402, -77.0744400024414, -1.34520274717343, 218, 53, 'PPL', 'P'),
(74437, 'Stratford Manor', 39.1672210693359, 0.683596966516406, -84.4100036621094, -1.47323248552428, 218, 41, 'PPL', 'P'),
(106647, 'Stratford Mill', 38.1622200012207, 0.666056388891736, -76.831672668457, -1.34096565787911, 218, 53, 'PPL', 'P'),
(25180, 'Stratford Oaks', 32.8883285522461, 0.574009618714354, -83.7111129760742, -1.46103454194144, 218, 13, 'PPL', 'P'),
(106651, 'Stratford on the Potomac', 38.7138900756836, 0.675684848075835, -77.0672225952148, -1.34507677965387, 218, 53, 'PPL', 'P'),
(106648, 'Stratford Park', 37.2661094665527, 0.650416309599973, -80.0138931274414, -1.39650588241272, 218, 53, 'PPL', 'P'),
(106649, 'Stratford Terrace', 36.7136116027832, 0.640773402766959, -76.5686111450195, -1.33637436815982, 218, 53, 'PPL', 'P'),
(106650, 'Stratford Woods', 37.2611083984375, 0.650329024495246, -77.3130569458008, -1.34936739848609, 218, 53, 'PPL', 'P'),
(144521, 'Stratham', 43.0238914489746, 0.750908562805241, -70.9141693115234, -1.2376857408028, 218, 36, 'PPL', 'P'),
(144522, 'Stratham Station', 43.0527801513672, 0.75141276577862, -70.8958282470703, -1.23736562883978, 218, 36, 'PPL', 'P'),
(138320, 'Strathcona', 48.5538902282715, 0.847425249135239, -96.1686096191406, -1.67845887491909, 218, 28, 'PPL', 'P'),
(79223, 'Strathcona Hills', 39.9438896179199, 0.697152389885882, -76.7130584716797, -1.33889544960574, 218, 45, 'PPL', 'P'),
(185401, 'Strathearn', 34.2811088562012, 0.598318220775298, -118.798332214355, -2.07342204301855, 218, 6, 'PPL', 'P'),
(106652, 'Strathmeade Springs', 38.8536109924316, 0.678123438106994, -77.2336120605469, -1.34798082366455, 218, 53, 'PPL', 'P'),
(71450, 'Strathmere', 39.1955604553223, 0.684091582109861, -74.658332824707, -1.3030337218409, 218, 37, 'PPL', 'P'),
(38409, 'Strathmoor Gardens', 38.2188911437988, 0.667045486920591, -85.6736068725586, -1.49528652198539, 218, 21, 'PPL', 'P'),
(38407, 'Strathmoor Manor', 38.2180595397949, 0.66703097269265, -85.6836090087891, -1.49546109219484, 218, 21, 'PPL', 'P'),
(38408, 'Strathmoor Village', 38.2230606079102, 0.667118257797378, -85.6777801513672, -1.4953593594412, 218, 21, 'PPL', 'P'),
(51758, 'Strathmore', 39.521110534668, 0.689773502874573, -76.4274978637695, -1.33391147678371, 218, 25, 'PPL', 'P'),
(146414, 'Strathmore', 40.3958282470703, 0.705040206981506, -74.2138900756836, -1.29527673253382, 218, 37, 'PPL', 'P'),
(152971, 'Strathmore', 40.7919387817383, 0.711953640013298, -73.6777801513672, -1.28591984920188, 218, 40, 'PPL', 'P'),
(185402, 'Strathmore', 36.1455612182617, 0.63085905323984, -119.059722900391, -2.07798417112391, 218, 6, 'PPL', 'P'),
(91077, 'Strathmore (historical)', 35.4000015258789, 0.617846581837604, -87.5097198486328, -1.52733273885648, 218, 50, 'PPL', 'P'),
(114140, 'Strathmore Woods', 41.4858283996582, 0.724064298491406, -72.8944396972656, -1.27224797911374, 218, 8, 'PPL', 'P'),
(106653, 'Strathouse', 37.7236099243164, 0.65840119891733, -78.3322219848633, -1.36715518403895, 218, 53, 'PPL', 'P'),
(187404, 'Stratmoor', 38.7738914489746, 0.676732069595482, -104.779167175293, -1.82874145470643, 218, 7, 'PPL', 'P'),
(187405, 'Stratmoor Hills', 38.7830581665039, 0.676892058997968, -104.793891906738, -1.82899844975162, 218, 7, 'PPL', 'P'),
(202658, 'Stratosphere Bowl', 43.9766693115234, 0.767537673546832, -103.345283508301, -1.80371546362685, 218, 49, 'PPL', 'P'),
(167678, 'Strattanville', 41.202220916748, 0.71911441413133, -79.3277816772461, -1.38453097857117, 218, 45, 'PPL', 'P'),
(132, 'Stratton', 37.0877799987793, 0.647303873233997, -82.3605575561523, -1.43746290313315, 218, 53, 'PPL', 'P'),
(25181, 'Stratton', 32.7986106872559, 0.572443746572415, -83.6305618286133, -1.45962865920199, 218, 13, 'PPL', 'P'),
(28711, 'Stratton', 38.4455604553223, 0.671001612719904, -88.7133331298828, -1.54833975353502, 218, 18, 'PPL', 'P'),
(61906, 'Stratton', 32.499439239502, 0.567222219781151, -89.1341705322266, -1.55568475182146, 218, 30, 'PPL', 'P'),
(98320, 'Stratton', 29.1513900756836, 0.508787738353878, -97.1500015258789, -1.6955873949441, 218, 51, 'PPL', 'P'),
(129015, 'Stratton', 45.1411094665527, 0.787860988194526, -70.4411087036133, -1.22942927563329, 218, 26, 'PPL', 'P'),
(152972, 'Stratton', 42.3469390869141, 0.739093515208132, -76.541389465332, -1.33589926022135, 218, 40, 'PPL', 'P'),
(157825, 'Stratton', 40.521671295166, 0.707236582511522, -80.6263885498047, -1.40719594418635, 218, 41, 'PPL', 'P'),
(172607, 'Stratton', 43.042781829834, 0.751238262148193, -72.9113922119141, -1.27254385631085, 218, 55, 'PPL', 'P'),
(187407, 'Stratton', 38.7477798461914, 0.676276336153942, -105.149436950684, -1.83520388140762, 218, 7, 'PPL', 'P'),
(199710, 'Stratton', 40.1480598449707, 0.700715832582463, -101.226387023926, -1.76673374346557, 218, 35, 'PPL', 'P'),
(172608, 'Stratton Acres', 43.1383285522461, 0.752905867043773, -72.8816680908203, -1.2720250725305, 218, 55, 'PPL', 'P'),
(83865, 'Stratton Capers', 32.9249992370605, 0.574649642903328, -80.0986099243164, -1.39798446944993, 218, 48, 'PPL', 'P'),
(187408, 'Stratton Meadows', 38.8033294677734, 0.677245859948785, -104.811111450195, -1.82929898748064, 218, 7, 'PPL', 'P'),
(172609, 'Stratton Mountain', 43.1166687011719, 0.752527831327036, -72.9069366455078, -1.27246609200702, 218, 55, 'PPL', 'P'),
(83866, 'Stratton Place', 34.8666687011719, 0.608538168037504, -82.3216705322266, -1.43678419652935, 218, 48, 'PPL', 'P'),
(172610, 'Stratton Valley', 43.1355590820313, 0.752857530669988, -72.8958282470703, -1.27227221387966, 218, 55, 'PPL', 'P'),
(51759, 'Stratton Woods', 39.0158309936523, 0.680954711240884, -77.1352767944336, -1.34626454950004, 218, 25, 'PPL', 'P'),
(172612, 'Strattonwald', 43.1538887023926, 0.753177442895934, -72.8819427490234, -1.27202986622047, 218, 55, 'PPL', 'P'),
(140930, 'Straubville', 46.0438919067383, 0.803617514204953, -97.8997192382813, -1.70867243748604, 218, 34, 'PPL', 'P'),
(6114, 'Straughn', 31.3880596160889, 0.547824986113018, -86.4180603027344, -1.50827968546972, 218, 2, 'PPL', 'P'),
(31236, 'Straughn', 39.8088912963867, 0.694796224690462, -85.291389465332, -1.48861556977085, 218, 19, 'PPL', 'P'),
(34066, 'Strauss', 37.3402786254883, 0.651710805626833, -95.085563659668, -1.65955615697588, 218, 20, 'PPL', 'P'),
(189608, 'Strauss', 31.8641700744629, 0.556134681214824, -106.698333740234, -1.86223723015885, 218, 38, 'PPL', 'P'),
(91078, 'Strauss Mill', 35.5597190856934, 0.620634179129617, -86.1244430541992, -1.50315509774214, 218, 50, 'PPL', 'P'),
(167680, 'Strausstown', 40.4922218322754, 0.706722592421137, -76.1833267211914, -1.32964988640737, 218, 45, 'PPL', 'P'),
(143133, 'Straussville', 40.1083297729492, 0.700022412013634, -95.6336135864258, -1.66912143266311, 218, 35, 'PPL', 'P'),
(28713, 'Straut', 39.4433288574219, 0.688415956508905, -90.7058334350586, -1.58311544420733, 218, 18, 'PPL', 'P'),
(6112, 'Straven', 33.2194404602051, 0.579788611700799, -86.8897171020508, -1.51651164955721, 218, 2, 'PPL', 'P'),
(38410, 'Straw', 37.2758293151855, 0.650585952961411, -86.1725006103516, -1.50399386032746, 218, 21, 'PPL', 'P'),
(197635, 'Straw', 46.8541717529297, 0.817759565383546, -109.788887023926, -1.91617756066758, 218, 31, 'PPL', 'P'),
(6113, 'Strawberry', 34.2491683959961, 0.597760754580117, -86.495002746582, -1.50962258444939, 218, 2, 'PPL', 'P'),
(12151, 'Strawberry', 35.9674987792969, 0.627751277405772, -91.3211135864258, -1.59385410867086, 218, 4, 'PPL', 'P'),
(34067, 'Strawberry', 39.7119407653809, 0.693104118712853, -97.254997253418, -1.69741991609019, 218, 20, 'PPL', 'P'),
(83868, 'Strawberry', 33.3300018310547, 0.581718271647643, -79.2544403076172, -1.38325093019323, 218, 48, 'PPL', 'P'),
(179234, 'Strawberry', 34.4077796936035, 0.600529043954227, -111.492782592773, -1.94591614845412, 218, 5, 'PPL', 'P'),
(185405, 'Strawberry', 38.1983299255371, 0.666686625963703, -120.008331298828, -2.09454051098871, 218, 6, 'PPL', 'P'),
(190793, 'Strawberry (historical)', 39.7013893127441, 0.692919961123474, -115.775001525879, -2.02065496812805, 218, 39, 'PPL', 'P'),
(69169, 'Strawberry Banks', 35.478328704834, 0.619213649004169, -77.4100036621094, -1.35105943788468, 218, 33, 'PPL', 'P'),
(111567, 'Strawberry Heights', 38.3819389343262, 0.669891207703395, -81.8541717529297, -1.42862480358156, 218, 58, 'PPL', 'P'),
(190794, 'Strawberry Hill', 37.6199989318848, 0.656592845958139, -114.512496948242, -1.99862010642678, 218, 39, 'PPL', 'P'),
(25182, 'Strawberry Hills', 33.6269416809082, 0.586900849707965, -84.2252807617188, -1.47000846270863, 218, 13, 'PPL', 'P'),
(51760, 'Strawberry Hills', 39.1263885498047, 0.682884304608701, -76.726936340332, -1.33913766410688, 218, 25, 'PPL', 'P'),
(51761, 'Strawberry Hills Estates', 38.6477813720703, 0.674531033533559, -77.0691680908203, -1.34511073495777, 218, 25, 'PPL', 'P'),
(14684, 'Strawberry Landing', 38.5008316040039, 0.671966276245758, -75.0716705322266, -1.31024782575976, 218, 10, 'PPL', 'P'),
(83869, 'Strawberry Landing', 33.0919418334961, 0.577563340872956, -79.9444427490234, -1.39529374464257, 218, 48, 'PPL', 'P'),
(185406, 'Strawberry Manor', 37.894718170166, 0.661387601184718, -122.510559082031, -2.13821262444049, 218, 6, 'PPL', 'P'),
(91079, 'Strawberry Plains', 36.063060760498, 0.629419148617461, -83.6861114501953, -1.46059818299683, 218, 50, 'PPL', 'P'),
(117925, 'Strawberry Point', 42.6836090087891, 0.744969513837282, -91.5338897705078, -1.59756775365292, 218, 16, 'PPL', 'P'),
(69170, 'Strawberry Ridge', 35.8433303833008, 0.62558413006872, -82.1113891601563, -1.43311409423111, 218, 33, 'PPL', 'P'),
(167682, 'Strawberry Ridge', 41.0741691589355, 0.716879489344535, -76.6519393920898, -1.33782872043111, 218, 45, 'PPL', 'P'),
(106654, 'Strawberry Run', 37.6569404602051, 0.657237597258047, -77.8252792358398, -1.35830736394938, 218, 53, 'PPL', 'P'),
(77359, 'Strawberry Spring', 35.9897193908691, 0.628139100239515, -94.6494369506836, -1.65194430994821, 218, 42, 'PPL', 'P'),
(185408, 'Strawberry Valley', 39.5641708374023, 0.690525046934193, -121.105827331543, -2.11369543028716, 218, 6, 'PPL', 'P'),
(167683, 'Strawbridge', 41.3138885498047, 0.721063381996077, -76.6236114501953, -1.33733430457474, 218, 45, 'PPL', 'P'),
(176572, 'Strawbridge', 42.5327796936035, 0.742337045678766, -90.3786087036133, -1.57740429524966, 218, 57, 'PPL', 'P'),
(51763, 'Strawbridge Estates', 39.4208297729492, 0.688023273406173, -76.9486083984375, -1.3430065713805, 218, 25, 'PPL', 'P'),
(106655, 'Strawhorn', 37.6488914489746, 0.657097115510546, -77.3352813720703, -1.34975528789886, 218, 53, 'PPL', 'P'),
(51764, 'Strawleigh', 39.3994407653809, 0.687649964800371, -77.5069427490234, -1.3527513441252, 218, 25, 'PPL', 'P'),
(51765, 'Strawn', 39.7211112976074, 0.693264174694367, -79.2969436645508, -1.38399275371487, 218, 25, 'PPL', 'P'),
(98321, 'Strawn', 32.5519409179688, 0.56813854693322, -98.4977798461914, -1.71911056422055, 218, 51, 'PPL', 'P'),
(121598, 'Strawn', 40.6525001525879, 0.709519976830156, -88.3963928222656, -1.54280810163482, 218, 18, 'PPL', 'P'),
(28714, 'Strawns Crossing', 39.785831451416, 0.694393754470724, -90.1508331298828, -1.57342886153244, 218, 18, 'PPL', 'P'),
(167684, 'Strawntown', 40.4716682434082, 0.706363864622303, -75.272216796875, -1.31374801838045, 218, 45, 'PPL', 'P'),
(123746, 'Strawtown', 40.1233291625977, 0.700284200748788, -85.9444427490234, -1.50001349976223, 218, 19, 'PPL', 'P'),
(61907, 'Strayhorn', 34.6122207641602, 0.604097213761743, -90.1438903808594, -1.57330768770284, 218, 30, 'PPL', 'P'),
(179235, 'Strayhorse', 33.5505599975586, 0.585567737845298, -109.317497253418, -1.907950257112, 218, 5, 'PPL', 'P'),
(28715, 'Streadle', 39.853328704834, 0.69557180377892, -89.6144409179688, -1.56406705135248, 218, 18, 'PPL', 'P'),
(51766, 'Streamwood', 39.4116706848145, 0.687863417161741, -77.022216796875, -1.34429128029035, 218, 25, 'PPL', 'P'),
(121599, 'Streamwood', 42.0255584716797, 0.733484365320207, -88.1783294677734, -1.53900217812099, 218, 18, 'PPL', 'P'),
(121600, 'Streator', 41.1208305358887, 0.717693884005882, -88.8352813720703, -1.55046815187821, 218, 18, 'PPL', 'P'),
(111568, 'Streby', 39.0802803039551, 0.682079563906306, -79.2397232055664, -1.38299406830609, 218, 58, 'PPL', 'P'),
(51767, 'Strecker', 39.4749984741211, 0.688968695593151, -79.1911087036133, -1.38214558518279, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(117926, 'Streepy', 40.6961097717285, 0.710281108269701, -92.9158325195313, -1.62168720469744, 218, 16, 'PPL', 'P'),
(51768, 'Street', 39.6688919067383, 0.692352774390314, -76.3797225952148, -1.33307764104641, 218, 25, 'PPL', 'P'),
(6115, 'Street (historical)', 34.2783317565918, 0.598269751243458, -86.3261108398438, -1.50667486459684, 218, 2, 'PPL', 'P'),
(152973, 'Street Road', 43.8802795410156, 0.765855354686229, -73.4497222900391, -1.28193948863665, 218, 40, 'PPL', 'P'),
(167685, 'Street Road', 40.1580581665039, 0.70089033621289, -75.0155563354492, -1.30926844826888, 218, 45, 'PPL', 'P'),
(98322, 'Streeter', 30.764720916748, 0.536945673454422, -99.376106262207, -1.73444025208727, 218, 51, 'PPL', 'P'),
(111569, 'Streeter', 37.6272201538086, 0.656718880056727, -81.0180587768555, -1.41403187923042, 218, 58, 'PPL', 'P'),
(140942, 'Streeter', 46.6552810668945, 0.814288268060682, -99.3536071777344, -1.73404756898454, 218, 34, 'PPL', 'P'),
(152974, 'Streeters Corners', 43.202220916748, 0.754020999171216, -78.8258285522461, -1.37577024384925, 218, 40, 'PPL', 'P'),
(98323, 'Streetman', 31.8772201538086, 0.556362448067053, -96.3247222900391, -1.68118355503035, 218, 51, 'PPL', 'P'),
(157826, 'Streetsboro', 41.2391700744629, 0.719759298589293, -81.3461074829102, -1.41975740925798, 218, 41, 'PPL', 'P'),
(167686, 'Streights', 41.5705604553223, 0.725543151844727, -78.6224975585938, -1.37222144853866, 218, 45, 'PPL', 'P'),
(212166, 'Strelna', 61.5113906860352, 1.07357629495189, -144.068893432617, -2.51447654010401, 218, 1, 'PPL', 'P'),
(79226, 'Stremmels', 39.8438911437988, 0.695407087265499, -77.26611328125, -1.34854807697673, 218, 45, 'PPL', 'P'),
(61908, 'Strengthford', 31.6136093139648, 0.551761570967832, -88.8847198486328, -1.5513310160714, 218, 30, 'PPL', 'P'),
(195663, 'Strevell', 42.0061111450195, 0.733144945439276, -113.202781677246, -1.97576126268425, 218, 17, 'PPL', 'P'),
(91080, 'Stribling (historical)', 36.3688888549805, 0.63475685581128, -87.9694366455078, -1.53535631058867, 218, 50, 'PPL', 'P'),
(106660, 'Stribling Springs', 38.3086090087891, 0.66861135906253, -79.1747207641602, -1.38185956168172, 218, 53, 'PPL', 'P'),
(79227, 'Strickersville', 39.7338905334473, 0.693487214435661, -75.793327331543, -1.32284311297723, 218, 45, 'PPL', 'P'),
(79228, 'Strickhousers', 39.8386116027832, 0.695314941891782, -76.8088912963867, -1.34056804792836, 218, 45, 'PPL', 'P'),
(61909, 'Strickland', 34.8783302307129, 0.608741700123813, -88.4413909912109, -1.54359346784028, 218, 30, 'PPL', 'P'),
(133290, 'Strickland', 43.4949989318848, 0.759130939512806, -84.8352813720703, -1.48065498179844, 218, 27, 'PPL', 'P'),
(176573, 'Strickland', 45.4366683959961, 0.793019464646983, -91.521110534668, -1.59734471391162, 218, 57, 'PPL', 'P'),
(185409, 'Strickland Acres', 34.2583312988281, 0.597920677403576, -119.148612976074, -2.07953559561693, 218, 6, 'PPL', 'P'),
(98326, 'Strickland Crossing', 31.3266696929932, 0.546753529827452, -93.9383316040039, -1.63953318032011, 218, 51, 'PPL', 'P'),
(6116, 'Strickland Crossroads', 33.0627784729004, 0.577054344209615, -86.3861083984375, -1.50772201953746, 218, 2, 'PPL', 'P'),
(69173, 'Strickland Crossroads', 35.855281829834, 0.6257927221611, -78.0127792358398, -1.36157985629687, 218, 33, 'PPL', 'P'),
(25183, 'Strickland Heights', 34.1872215270996, 0.596679577756572, -83.8502807617188, -1.46346347801365, 218, 13, 'PPL', 'P'),
(129016, 'Stricklands', 44.3733291625977, 0.774460693958547, -70.1433334350586, -1.224232116766, 218, 26, 'PPL', 'P'),
(12155, 'Strickler', 35.833610534668, 0.625414486707282, -94.3130569458008, -1.64607337132513, 218, 4, 'PPL', 'P'),
(167687, 'Strickler', 40.0111083984375, 0.69832557892509, -76.5513916015625, -1.3360738304308, 218, 45, 'PPL', 'P'),
(167688, 'Stricklerstown', 40.3250007629395, 0.703804034182519, -76.2261123657227, -1.33039663677702, 218, 45, 'PPL', 'P'),
(561, 'Stricklett', 38.4844398498535, 0.671680186165656, -83.3874969482422, -1.45538637674355, 218, 21, 'PPL', 'P'),
(98325, 'Stricklin Springs', 32.4316711425781, 0.56603944336202, -94.1524963378906, -1.64327106006809, 218, 51, 'PPL', 'P'),
(208843, 'Striebels Corner', 47.8050003051758, 0.834354654242211, -122.566940307617, -2.13919666246327, 218, 56, 'PPL', 'P'),
(91082, 'Striggersville', 36.4422187805176, 0.636036704452145, -82.9905624389648, -1.44845856264187, 218, 50, 'PPL', 'P'),
(195664, 'Striker', 42.4749984741211, 0.741328573152981, -114.304168701172, -1.9949840925905, 218, 17, 'PPL', 'P'),
(167689, 'Strinestown', 40.0911102294922, 0.699721874284618, -76.7616729736328, -1.33974393272904, 218, 45, 'PPL', 'P'),
(98327, 'String Prairie', 29.8855590820313, 0.521601404780739, -97.3466720581055, -1.69901994327311, 218, 51, 'PPL', 'P'),
(6117, 'Stringer', 34.4355583190918, 0.601013872430676, -86.7563934326172, -1.51418471255476, 218, 2, 'PPL', 'P'),
(61910, 'Stringer', 31.8666706085205, 0.556178323767188, -89.2633285522461, -1.55793898452616, 218, 30, 'PPL', 'P'),
(157828, 'Stringer', 40.232780456543, 0.702194486198702, -80.6624984741211, -1.40782618125832, 218, 41, 'PPL', 'P'),
(112247, 'Stringers Mill', 35.5224990844727, 0.619984567560719, -91.1163864135742, -1.5902809454363, 218, 4, 'PPL', 'P'),
(83870, 'Stringfellow', 34.7374992370605, 0.606283735595725, -81.1752777099609, -1.41677586725958, 218, 48, 'PPL', 'P'),
(179236, 'Stringfield', 34.6949996948242, 0.60554197865311, -112.55583190918, -1.96446985913648, 218, 5, 'PPL', 'P'),
(98328, 'Strington', 30.4591693878174, 0.531612793240079, -94.9733276367188, -1.65759726883607, 218, 51, 'PPL', 'P'),
(12157, 'Stringtown', 33.9363899230957, 0.592301740398645, -94.2438888549805, -1.644866160403, 218, 4, 'PPL', 'P'),
(28716, 'Stringtown', 38.8250007629395, 0.677624095402604, -87.9836120605469, -1.53560371825394, 218, 18, 'PPL', 'P'),
(51769, 'Stringtown', 39.5544395446777, 0.690355203835673, -76.7191696166992, -1.3390021092074, 218, 25, 'PPL', 'P'),
(57757, 'Stringtown', 36.7527809143066, 0.641457036218783, -90.5827789306641, -1.58096773794624, 218, 29, 'PPL', 'P'),
(61911, 'Stringtown', 33.5747184753418, 0.585989382824885, -90.9844436645508, -1.58797811004171, 218, 30, 'PPL', 'P'),
(77362, 'Stringtown', 34.4666709899902, 0.601556890976943, -96.0530624389648, -1.67644219618363, 218, 42, 'PPL', 'P'),
(91088, 'Stringtown', 35.8927803039551, 0.626447193998987, -85.3019409179688, -1.48879972736023, 218, 50, 'PPL', 'P'),
(98332, 'Stringtown', 31.1916694641113, 0.544397331342518, -93.9255599975586, -1.63931027373687, 218, 51, 'PPL', 'P'),
(106658, 'Stringtown', 36.9769401550293, 0.645369353018164, -81.0338897705078, -1.41430818219351, 218, 53, 'PPL', 'P'),
(111574, 'Stringtown', 39.4819412231445, 0.689089869422749, -80.3525009155273, -1.40241570318771, 218, 58, 'PPL', 'P'),
(112359, 'Stringtown', 38.0080604553223, 0.663365797242429, -84.8808288574219, -1.48144993538383, 218, 21, 'PPL', 'P'),
(117927, 'Stringtown', 40.978889465332, 0.715216544980863, -94.557502746582, -1.65033975539144, 218, 16, 'PPL', 'P'),
(123747, 'Stringtown', 40.0816688537598, 0.699557091192169, -86.4766693115234, -1.50930260564442, 218, 19, 'PPL', 'P'),
(133291, 'Stringtown', 41.8836097717285, 0.731006893137133, -84.834716796875, -1.48064512810241, 218, 27, 'PPL', 'P'),
(157830, 'Stringtown', 40.6833305358887, 0.710058068528406, -81.9922180175781, -1.43103416541976, 218, 41, 'PPL', 'P'),
(167690, 'Stringtown', 40.7641716003418, 0.71146901127393, -79.5236129760742, -1.38794887951418, 218, 45, 'PPL', 'P'),
(187409, 'Stringtown', 39.2336082458496, 0.684755641327673, -106.31861114502, -1.85560982062813, 218, 7, 'PPL', 'P'),
(208845, 'Stringtown', 46.3063888549805, 0.808198950228216, -123.977500915527, -2.16381558937024, 218, 56, 'PPL', 'P'),
(111573, 'Stringtown (historical)', 38.9888916015625, 0.680484530150431, -79.4738922119141, -1.38708108847298, 218, 58, 'PPL', 'P'),
(157832, 'Stringtown (historical)', 40.6744384765625, 0.709902872815882, -82.9486083984375, -1.44772632650015, 218, 41, 'PPL', 'P'),
(193982, 'Stringtown (historical)', 41.041389465332, 0.716307375763359, -122.701110839844, -2.14153838000978, 218, 6, 'PPL', 'P'),
(197637, 'Stringtown (historical)', 46.0416717529297, 0.803578765211092, -112.544441223145, -1.96427105416111, 218, 31, 'PPL', 'P'),
(201604, 'Stringtown (historical)', 45.339168548584, 0.791317771289449, -122.639442443848, -2.14046206345522, 218, 43, 'PPL', 'P'),
(192281, 'Strip Crossing', 35.5161094665527, 0.619873047690072, -102.655281066895, -1.79167264917751, 218, 51, 'PPL', 'P'),
(167691, 'Strip District', 40.4538917541504, 0.706053606355309, -79.9844436645508, -1.39599189232233, 218, 45, 'PPL', 'P'),
(185410, 'Striplin (historical)', 38.8669395446777, 0.678356065228212, -121.542778015137, -2.12132165838471, 218, 6, 'PPL', 'P'),
(157833, 'Striptown (historical)', 40.589168548584, 0.708414631819719, -84.6894378662109, -1.47810953242854, 218, 41, 'PPL', 'P'),
(167692, 'Strobleton', 41.3677787780762, 0.722003943914066, -79.4086074829102, -1.38594165500059, 218, 45, 'PPL', 'P'),
(57758, 'Stroderville (historical)', 37.2466697692871, 0.650077022877097, -89.8130569458008, -1.56753355498539, 218, 29, 'PPL', 'P'),
(167693, 'Strodes Mills', 40.5508308410645, 0.707745512595836, -77.6733322143555, -1.35565538813588, 218, 45, 'PPL', 'P'),
(123748, 'Stroh', 41.5813903808594, 0.725732169703095, -85.1994400024414, -1.48701074889797, 218, 19, 'PPL', 'P'),
(77364, 'Strohm', 36.6430587768555, 0.639542023657934, -96.5552825927734, -1.68520759143746, 218, 42, 'PPL', 'P'),
(106659, 'Strom', 37.6916694641113, 0.657843732722149, -79.8902816772461, -1.39434845561364, 218, 53, 'PPL', 'P'),
(197638, 'Strom', 46.8911094665527, 0.818404250104427, -112.310829162598, -1.9601937545322, 218, 31, 'PPL', 'P'),
(25184, 'Stroms', 31.5433292388916, 0.550534952259255, -84.0941696166992, -1.46772014154198, 218, 13, 'PPL', 'P'),
(138322, 'Stroms', 44.6294403076172, 0.778930676690191, -92.6613922119141, -1.61724638357973, 218, 28, 'PPL', 'P'),
(143135, 'Stromsburg', 41.1141700744629, 0.7175776370243, -97.5986099243164, -1.70341708854894, 218, 35, 'PPL', 'P'),
(133292, 'Stronach', 44.2133293151855, 0.771668169818517, -86.2752838134766, -1.50578776563774, 218, 27, 'PPL', 'P'),
(167694, 'Stronach', 40.9655609130859, 0.714983917859644, -78.5891723632813, -1.37163981415659, 218, 45, 'PPL', 'P'),
(209757, 'Stroner', 44.7666702270508, 0.781325790616554, -105.044998168945, -1.83338108079951, 218, 59, 'PPL', 'P'),
(185411, 'Stronetta', 38.9472198486328, 0.67975722085673, -123.701393127441, -2.15899659937774, 218, 6, 'PPL', 'P'),
(12158, 'Strong', 33.1074981689453, 0.57783485014609, -92.334716796875, -1.61154482200198, 218, 4, 'PPL', 'P'),
(61912, 'Strong', 33.6952781677246, 0.588093546402157, -88.6044387817383, -1.54643918862309, 218, 30, 'PPL', 'P'),
(129017, 'Strong', 44.8074989318848, 0.782038385945232, -70.2213897705078, -1.22559445682163, 218, 26, 'PPL', 'P'),
(167695, 'Strong', 40.7986106872559, 0.712070086731961, -76.4383316040039, -1.33410056122111, 218, 45, 'PPL', 'P'),
(187410, 'Strong', 37.7125015258789, 0.658207320789972, -104.901672363281, -1.8308795735876, 218, 7, 'PPL', 'P'),
(192805, 'Strong', 39.4347190856934, 0.688265687644397, -112.469169616699, -1.96295731679537, 218, 52, 'PPL', 'P'),
(34070, 'Strong City', 38.3972206115723, 0.670157923286567, -96.5366668701172, -1.68488268578447, 218, 20, 'PPL', 'P'),
(77365, 'Strong City', 35.670280456543, 0.622563839076461, -99.5991668701172, -1.7383333941268, 218, 42, 'PPL', 'P'),
(51770, 'Stronghold', 39.2513885498047, 0.685065966173694, -77.3933334350586, -1.35076848753559, 218, 25, 'PPL', 'P'),
(129019, 'Stronghold', 44.9166717529297, 0.783943811126156, -69.4711074829102, -1.21249956058365, 218, 26, 'PPL', 'P'),
(193983, 'Stronghold', 41.9055595397949, 0.731389988859941, -121.40860748291, -2.11897994083821, 218, 6, 'PPL', 'P'),
(61913, 'Stronghope', 31.7438907623291, 0.554035411196056, -90.2633285522461, -1.5753922770461, 218, 30, 'PPL', 'P'),
(121602, 'Stronghurst', 40.746940612793, 0.711168273807833, -90.9038925170898, -1.58657222730225, 218, 18, 'PPL', 'P'),
(133294, 'Strongs', 46.357780456543, 0.809095902883355, -84.9694366455078, -1.48299643302884, 218, 27, 'PPL', 'P'),
(133295, 'Strongs Corner', 46.3461112976074, 0.808892237638991, -84.9691696166992, -1.48299177249693, 218, 27, 'PPL', 'P'),
(185412, 'Strongs Mobile Village', 36.9652786254883, 0.645165820931854, -121.768058776855, -2.12525354941811, 218, 6, 'PPL', 'P'),
(176575, 'Strongs Prairie', 44.0613899230957, 0.769016327163071, -89.975830078125, -1.57037448207823, 218, 57, 'PPL', 'P'),
(157841, 'Strongs Ridge', 41.2836112976074, 0.720534944256778, -82.7863922119141, -1.44489511994529, 218, 41, 'PPL', 'P'),
(167696, 'Strongstown', 40.5527801513672, 0.707779534478762, -78.9219436645508, -1.37744776901989, 218, 45, 'PPL', 'P'),
(157834, 'Strongsville', 41.3144416809082, 0.721073035955029, -81.8358306884766, -1.42830469161853, 218, 41, 'PPL', 'P'),
(202659, 'Strool', 45.500560760498, 0.794134596774426, -102.804443359375, -1.79427602230111, 218, 49, 'PPL', 'P'),
(57759, 'Strother', 39.4255599975586, 0.688105831399965, -91.8883285522461, -1.60375387739101, 218, 29, 'PPL', 'P'),
(83871, 'Strother', 34.3936080932617, 0.600281702867986, -81.3949966430664, -1.42061068607124, 218, 48, 'PPL', 'P'),
(106661, 'Stroubles Mill', 37.2097206115723, 0.649432138419134, -80.4555587768555, -1.40421440218795, 218, 53, 'PPL', 'P'),
(6118, 'Stroud', 33.0547218322754, 0.576913729304058, -85.3308334350586, -1.48930399691264, 218, 2, 'PPL', 'P'),
(38422, 'Stroud', 37.4088897705078, 0.652908296010987, -87.1524963378906, -1.52109801242849, 218, 21, 'PPL', 'P'),
(77366, 'Stroud', 35.7486114501953, 0.623930972822053, -96.6577835083008, -1.68699656989972, 218, 42, 'PPL', 'P'),
(25185, 'Strouds', 32.920280456543, 0.574567284646617, -84.0661087036133, -1.46723038621751, 218, 13, 'PPL', 'P'),
(111575, 'Strouds', 38.3877792358398, 0.669993140194118, -80.6166687011719, -1.40702630082491, 218, 58, 'PPL', 'P'),
(209758, 'Strouds', 42.8549995422363, 0.747960842952687, -106.240829467773, -1.85425227426246, 218, 59, 'PPL', 'P'),
(167698, 'Stroudsburg', 40.9866714477539, 0.715352366196457, -75.1949996948242, -1.31240032571081, 218, 45, 'PPL', 'P'),
(91091, 'Stroudville', 36.4824981689453, 0.636739712400898, -87.1069412231445, -1.52030292568505, 218, 50, 'PPL', 'P'),
(129020, 'Stroudwater', 43.6561088562012, 0.761942838149766, -70.3152770996094, -1.22723309984035, 218, 26, 'PPL', 'P'),
(152975, 'Stroughs Crossing', 44.1941719055176, 0.771333809943658, -75.8627777099609, -1.32405525074738, 218, 40, 'PPL', 'P'),
(157836, 'Stroups', 41.339168548584, 0.721504601209676, -80.9355621337891, -1.41259204118707, 218, 41, 'PPL', 'P'),
(167701, 'Strouptown', 40.6933288574219, 0.710232572158834, -77.0338897705078, -1.34449501211374, 218, 45, 'PPL', 'P'),
(138323, 'Strout', 45.0299987792969, 0.785921740867758, -94.5941696166992, -1.65097971300138, 218, 28, 'PPL', 'P'),
(117928, 'Struble', 42.8952789306641, 0.74866385090144, -96.1949996948242, -1.67891946862962, 218, 16, 'PPL', 'P'),
(167700, 'Struble', 40.7827796936035, 0.711793783768866, -77.8763885498047, -1.3591993897565, 218, 45, 'PPL', 'P'),
(98333, 'Structure', 30.4716205596924, 0.531830107185029, -97.2743377685547, -1.69775747175835, 218, 51, 'PPL', 'P'),
(176577, 'Strum', 44.5497207641602, 0.777539308178679, -91.3925018310547, -1.59510006858685, 218, 57, 'PPL', 'P'),
(25186, 'Strum Bay (historical)', 32.0208282470703, 0.558868882126981, -81.6361083984375, -1.42481888006773, 218, 13, 'PPL', 'P'),
(38421, 'Strunk', 36.621940612793, 0.639173442163067, -84.4336090087891, -1.47364447654492, 218, 21, 'PPL', 'P'),
(157837, 'Struthers', 41.0525016784668, 0.716501320469744, -80.6080627441406, -1.40687609853943, 218, 41, 'PPL', 'P'),
(157839, 'Stryker', 41.5036087036133, 0.724374623337427, -84.4141693115234, -1.47330518982204, 218, 41, 'PPL', 'P'),
(197640, 'Stryker', 48.6741714477539, 0.849524552443521, -114.769172668457, -2.00309994285446, 218, 31, 'PPL', 'P'),
(98334, 'Stryker Creek Junction', 31.8891696929932, 0.55657100686992, -95.0294418334961, -1.65857664632694, 218, 51, 'PPL', 'P'),
(91089, 'Stryker Village', 36.6383285522461, 0.639459465664142, -87.4402770996094, -1.52612073424438, 218, 50, 'PPL', 'P'),
(152976, 'Strykersville', 42.7050018310547, 0.745342889022112, -78.4486083984375, -1.36918651016041, 218, 40, 'PPL', 'P'),
(12169, 'Stuart', 36.2638893127441, 0.632924268086169, -91.5183334350586, -1.59729624437978, 218, 4, 'PPL', 'P'),
(18202, 'Stuart', 27.1972198486328, 0.474681033747396, -80.253059387207, -1.40068012110531, 218, 12, 'PPL', 'P'),
(77367, 'Stuart', 34.9013900756836, 0.609144170343552, -96.0986099243164, -1.67723714976902, 218, 42, 'PPL', 'P'),
(106662, 'Stuart', 36.6408309936523, 0.639503141506019, -80.2658309936523, -1.40090302768855, 218, 53, 'PPL', 'P'),
(117929, 'Stuart', 41.5033302307129, 0.724369763068438, -94.3183288574219, -1.64616538354079, 218, 16, 'PPL', 'P'),
(143137, 'Stuart', 42.5991706848145, 0.74349578706906, -99.142219543457, -1.73035815876839, 218, 35, 'PPL', 'P'),
(185413, 'Stuart', 33.2511100769043, 0.580341350785045, -117.419998168945, -2.04936557573381, 218, 6, 'PPL', 'P'),
(187411, 'Stuart', 38.4713897705078, 0.671452419313427, -102.19416809082, -1.78362470952134, 218, 7, 'PPL', 'P'),
(197639, 'Stuart', 46.0858306884766, 0.804349484030561, -112.796943664551, -1.96867805313297, 218, 31, 'PPL', 'P'),
(208846, 'Stuart', 47.6886100769043, 0.832323261541726, -121.947219848633, -2.12838050001202, 218, 56, 'PPL', 'P'),
(106663, 'Stuart Corner', 38.1494407653809, 0.665833349150442, -77.3166732788086, -1.34943051540393, 218, 53, 'PPL', 'P'),
(91090, 'Stuart Heights', 35.0986099243164, 0.612586306052479, -85.2847213745117, -1.48849918963121, 218, 50, 'PPL', 'P'),
(192282, 'Stuart Place', 29.9394397735596, 0.52254180025116, -102.610282897949, -1.79088728297204, 218, 51, 'PPL', 'P'),
(129021, 'Stuarts Corner', 44.1416702270508, 0.770417482791589, -70.6005630493164, -1.23221227897242, 218, 26, 'PPL', 'P'),
(106664, 'Stuarts Draft', 38.0299987792969, 0.663748693228155, -79.0338897705078, -1.37940159715363, 218, 53, 'PPL', 'P'),
(28717, 'Stubblefield', 38.848331451416, 0.678031292733277, -89.4663925170898, -1.56148311930484, 218, 18, 'PPL', 'P'),
(38423, 'Stubblefield', 36.6372184753418, 0.639440091167211, -88.6797180175781, -1.54775305914688, 218, 21, 'PPL', 'P'),
(98336, 'Stubblefield', 31.3141708374023, 0.546535383644661, -95.1097183227539, -1.65997773537643, 218, 51, 'PPL', 'P'),
(91092, 'Stubblefields (historical)', 35.5522193908691, 0.620503284762039, -88.2777786254883, -1.54073789336144, 218, 50, 'PPL', 'P'),
(34073, 'Stubbs', 37.0066719055176, 0.645888269956566, -98.565559387207, -1.72029354037677, 218, 20, 'PPL', 'P'),
(57760, 'Stubbs', 39.4249992370605, 0.688096044282959, -94.7508316040039, -1.65371398049257, 218, 29, 'PPL', 'P'),
(69174, 'Stubbs', 35.3269386291504, 0.616571393728646, -81.4713897705078, -1.42194399767099, 218, 33, 'PPL', 'P'),
(98337, 'Stubbs', 32.4086112976074, 0.565636973142281, -96.2874984741211, -1.68053387688243, 218, 51, 'PPL', 'P'),
(106665, 'Stubbs', 38.1502799987793, 0.665847996536437, -77.8288879394531, -1.35837034770916, 218, 53, 'PPL', 'P'),
(129022, 'Stubbs Corner', 44.964168548584, 0.78477278659447, -69.1819381713867, -1.20745260400184, 218, 26, 'PPL', 'P'),
(25187, 'Stubbs Plantation', 33.3652801513672, 0.582333994491669, -84.4266662597656, -1.47352330271532, 218, 13, 'PPL', 'P'),
(57761, 'Stubtown', 36.1761093139648, 0.631392218090074, -89.6991729736328, -1.56554590470581, 218, 29, 'PPL', 'P'),
(208847, 'Stuck', 47.2827796936035, 0.825240185148497, -122.227500915527, -2.13327232746034, 218, 56, 'PPL', 'P'),
(25188, 'Stuckey', 32.1708297729492, 0.561486902636584, -82.7102813720703, -1.44356673519356, 218, 13, 'PPL', 'P'),
(83873, 'Stuckey', 33.7316703796387, 0.58872871032214, -79.5127792358398, -1.38775979507679, 218, 48, 'PPL', 'P'),
(167702, 'Studa', 40.3036117553711, 0.703430725576717, -80.4469375610352, -1.40406393358636, 218, 45, 'PPL', 'P'),
(6119, 'Studdards Crossroads', 33.8083305358887, 0.590066682453796, -87.5875015258789, -1.52869028522214, 218, 2, 'PPL', 'P'),
(185414, 'Studebaker', 33.9197196960449, 0.592010790049554, -118.095283508301, -2.06115152829601, 218, 6, 'PPL', 'P'),
(12159, 'Studemeir (historical)', 34.1763916015625, 0.596490559898204, -92.3013916015625, -1.61096318761991, 218, 4, 'PPL', 'P'),
(185415, 'Studio City', 34.148609161377, 0.596005664842727, -118.395561218262, -2.06639236300518, 218, 6, 'PPL', 'P'),
(106666, 'Studley', 37.6755599975586, 0.657562569490064, -77.2911071777344, -1.34898430276329, 218, 53, 'PPL', 'P'),
(187919, 'Studley', 39.3530616760254, 0.686840496987041, -100.163330078125, -1.74817989962515, 218, 20, 'PPL', 'P'),
(106667, 'Studley Farms', 37.6716690063477, 0.657494658882267, -77.2905578613281, -1.34897471538336, 218, 53, 'PPL', 'P'),
(192283, 'Study Butte', 29.3181190490723, 0.51169770789798, -103.5302734375, -1.8069441469744, 218, 51, 'PPL', 'P'),
(34071, 'Stull', 38.9711112976074, 0.680174205304409, -95.4558334350586, -1.66601858367706, 218, 20, 'PPL', 'P'),
(51771, 'Stull', 39.5611114501953, 0.690471650554337, -77.2986068725586, -1.34911519713086, 218, 25, 'PPL', 'P'),
(167704, 'Stull', 41.4172210693359, 0.722866874686279, -76.0919418334961, -1.32805491923052, 218, 45, 'PPL', 'P'),
(195665, 'Stull', 47.4722213745117, 0.828546566220858, -115.863609313965, -2.02220146577306, 218, 17, 'PPL', 'P'),
(106670, 'Stultz Mill', 38.5138893127441, 0.672194176256041, -78.9486083984375, -1.37791315642038, 218, 53, 'PPL', 'P'),
(167703, 'Stump Creek', 41.0125007629395, 0.71580317278998, -78.8375015258789, -1.37597397567264, 218, 45, 'PPL', 'P'),
(91093, 'Stump Knob (historical)', 36.311939239502, 0.633762897513435, -81.9633331298828, -1.4305300290254, 218, 50, 'PPL', 'P'),
(197643, 'Stump Town', 46.1508293151855, 0.805483924075908, -113.040000915527, -1.97292020243336, 218, 31, 'PPL', 'P'),
(197641, 'Stump Town (historical)', 46.8283309936523, 0.817308559052941, -113.345832824707, -1.9782579762062, 218, 31, 'PPL', 'P'),
(31241, 'Stumpke Corner', 39.1777801513672, 0.68378125726384, -85.1319427490234, -1.48583269958977, 218, 19, 'PPL', 'P'),
(12160, 'Stumptoe', 35.4658317565918, 0.618995536110891, -92.829719543457, -1.62018424973625, 218, 4, 'PPL', 'P'),
(31242, 'Stumptown', 39.8522186279297, 0.69555242928199, -87.2744369506836, -1.52322627761363, 218, 19, 'PPL', 'P'),
(51772, 'Stumptown', 39.6497192382813, 0.692018148199346, -77.14111328125, -1.34636641541174, 218, 25, 'PPL', 'P'),
(69176, 'Stumptown', 35.689998626709, 0.622907986068326, -81.9847183227539, -1.43090327105218, 218, 33, 'PPL', 'P'),
(98338, 'Stumptown', 31.1558303833008, 0.543771821381486, -93.9669418334961, -1.6400325230245, 218, 51, 'PPL', 'P'),
(106669, 'Stumptown', 37.3402786254883, 0.651710805626833, -75.9469375610352, -1.32552411724662, 218, 53, 'PPL', 'P'),
(111576, 'Stumptown', 38.8488883972168, 0.678041013271256, -80.9941711425781, -1.41361496136177, 218, 58, 'PPL', 'P'),
(167708, 'Stumptown', 40.061939239502, 0.699212744463222, -76.1672210693359, -1.32936878975431, 218, 45, 'PPL', 'P'),
(69177, 'Stumpy Point', 35.6983299255371, 0.623053394663845, -75.7408294677734, -1.32192685240419, 218, 33, 'PPL', 'P'),
(25191, 'Sturbridge', 34.1083297729492, 0.595302656893974, -84.5730590820313, -1.47607833946514, 218, 13, 'PPL', 'P'),
(51774, 'Sturbridge', 39.4930610656738, 0.689283947287189, -76.5250015258789, -1.33561323672027, 218, 25, 'PPL', 'P'),
(126276, 'Sturbridge', 42.1083297729492, 0.73492899705352, -72.0791702270508, -1.25801884256751, 218, 23, 'PPL', 'P'),
(25190, 'Sturbridge Village', 34.0194396972656, 0.593751232400948, -84.4080581665039, -1.47319853022038, 218, 13, 'PPL', 'P'),
(121604, 'Sturbridge Village', 42.3519401550293, 0.739180800312859, -89.0738906860352, -1.55463267003282, 218, 18, 'PPL', 'P'),
(12161, 'Sturdevant (historical)', 35.2519416809082, 0.615262450052872, -91.1547164916992, -1.59094993150213, 218, 4, 'PPL', 'P'),
(6120, 'Sturdivant', 32.910831451416, 0.574402368396114, -85.851936340332, -1.49839895835137, 218, 2, 'PPL', 'P'),
(57762, 'Sturdivant', 37.0494384765625, 0.646634687431088, -90.0138931274414, -1.57103880761215, 218, 29, 'PPL', 'P'),
(98339, 'Sturdivant', 32.7652816772461, 0.571862045611314, -98.0663909912109, -1.71158140834474, 218, 51, 'PPL', 'P'),
(61914, 'Sturdivant (historical)', 33.829719543457, 0.590439991059598, -90.3291702270508, -1.57654143105647, 218, 30, 'PPL', 'P'),
(91095, 'Sturdivant Crossing', 35.4524993896484, 0.618762842410645, -89.0658264160156, -1.55449192196921, 218, 50, 'PPL', 'P'),
(69178, 'Sturdivants Crossroads', 34.9058303833008, 0.609221668331273, -80.3283309936523, -1.40199385847104, 218, 33, 'PPL', 'P'),
(38424, 'Sturgeon', 37.4191703796387, 0.653087726489431, -83.7850036621094, -1.46232417769932, 218, 21, 'PPL', 'P'),
(57763, 'Sturgeon', 39.2341690063477, 0.684765428444679, -92.2805633544922, -1.61059966613111, 218, 29, 'PPL', 'P'),
(98340, 'Sturgeon', 33.7572212219238, 0.589174656646674, -96.9752807617188, -1.69253794233791, 218, 51, 'PPL', 'P'),
(138325, 'Sturgeon', 47.776668548584, 0.833860171806811, -92.8686065673828, -1.62086295634006, 218, 28, 'PPL', 'P'),
(167706, 'Sturgeon', 40.3847198486328, 0.704846328854149, -80.2111129760742, -1.39994801812164, 218, 45, 'PPL', 'P'),
(195666, 'Sturgeon', 47.8497200012207, 0.835135160178686, -116.859718322754, -2.0395868476852, 218, 17, 'PPL', 'P'),
(176580, 'Sturgeon Bay', 44.834171295166, 0.782503906503777, -87.3769378662109, -1.52501525607589, 218, 57, 'PPL', 'P'),
(111577, 'Sturgeon Branch (historical)', 37.9377784729004, 0.662139145244338, -80.8180618286133, -1.41054127398965, 218, 58, 'PPL', 'P'),
(138326, 'Sturgeon Lake', 46.3811111450195, 0.809503100214028, -92.8236083984375, -1.6200775901346, 218, 28, 'PPL', 'P'),
(138331, 'Sturgeon River Landing', 48.2125015258789, 0.841466892249377, -93.8861083984375, -1.63862171343703, 218, 28, 'PPL', 'P'),
(106672, 'Sturgeonville', 36.9005584716797, 0.644036241155497, -77.8105621337891, -1.35805050206224, 218, 53, 'PPL', 'P'),
(57764, 'Sturges', 39.8772201538086, 0.6959887882266, -93.5008316040039, -1.63189736484264, 218, 29, 'PPL', 'P'),
(167707, 'Sturges', 41.4944381713867, 0.724214567355913, -75.5852813720703, -1.31921202598896, 218, 45, 'PPL', 'P'),
(152977, 'Sturges Corner', 42.4488906860352, 0.740872906290468, -74.7566680908203, -1.3047499960054, 218, 40, 'PPL', 'P'),
(51779, 'Sturgill', 39.6599998474121, 0.69219757867779, -76.246940612793, -1.33076015826582, 218, 25, 'PPL', 'P'),
(69179, 'Sturgills', 36.5552787780762, 0.638009973661839, -81.4986114501953, -1.42241910560946, 218, 33, 'PPL', 'P'),
(38425, 'Sturgis', 37.5466690063477, 0.655312997317274, -87.98388671875, -1.5356085119439, 218, 21, 'PPL', 'P'),
(61915, 'Sturgis', 33.3444404602051, 0.581970273265792, -89.045280456543, -1.55413332732843, 218, 30, 'PPL', 'P'),
(133296, 'Sturgis', 41.7991714477539, 0.729533166368911, -85.4191665649414, -1.49084570086768, 218, 27, 'PPL', 'P'),
(191016, 'Sturgis', 36.8938903808594, 0.643919861015861, -102.069717407227, -1.78145263533627, 218, 42, 'PPL', 'P'),
(202661, 'Sturgis', 44.4097213745117, 0.775095857878531, -103.508613586426, -1.80656611125767, 218, 49, 'PPL', 'P'),
(12162, 'Sturgis (historical)', 33.3211097717285, 0.581563075935119, -92.1405563354492, -1.60815608267291, 218, 4, 'PPL', 'P'),
(83874, 'Sturgis Estates', 34.9338912963867, 0.609711423655738, -80.977783203125, -1.41332893786069, 218, 48, 'PPL', 'P'),
(111578, 'Sturgisson', 39.583610534668, 0.690864333657069, -79.8683319091797, -1.39396535989083, 218, 58, 'PPL', 'P'),
(18203, 'Sturkey', 28.3952808380127, 0.495591142651776, -82.070556640625, -1.4324014323234, 218, 12, 'PPL', 'P'),
(6121, 'Sturkie', 32.797779083252, 0.572429232344474, -85.4688873291016, -1.49171349190888, 218, 2, 'PPL', 'P'),
(12163, 'Sturkie', 36.457218170166, 0.636298493187299, -91.8730621337891, -1.60348742812395, 218, 4, 'PPL', 'P'),
(111579, 'Sturms Mill', 39.452220916748, 0.688571152221429, -80.3238906860352, -1.40191636048332, 218, 58, 'PPL', 'P'),
(176583, 'Sturtevant', 42.6980590820313, 0.745221715192513, -87.8944396972656, -1.53404736691289, 218, 57, 'PPL', 'P'),
(129023, 'Sturtevant Hill', 44.3394393920898, 0.773869205880441, -69.9916687011719, -1.22158506780051, 218, 26, 'PPL', 'P'),
(126278, 'Sturtevant Mill', 41.7061080932617, 0.727908904420071, -70.8405609130859, -1.23640103189295, 218, 23, 'PPL', 'P'),
(146415, 'Sturwood Hamlet', 40.2733306884766, 0.702902221258391, -74.7425003051758, -1.30450272149818, 218, 37, 'PPL', 'P'),
(133299, 'Stutsmanville', 45.5080604553223, 0.794265491142003, -85.0066680908203, -1.48364624433482, 218, 27, 'PPL', 'P'),
(12164, 'Stuttgart', 34.5002784729004, 0.602143452207033, -91.5524978637695, -1.59789252614785, 218, 4, 'PPL', 'P'),
(34072, 'Stuttgart', 39.7994384765625, 0.694631241860932, -99.4550018310547, -1.73581723952889, 218, 20, 'PPL', 'P'),
(57765, 'Stutts', 36.7652816772461, 0.641675215691088, -93.3472213745117, -1.62921636057326, 218, 29, 'PPL', 'P'),
(6122, 'Stutts (historical)', 34.9300003051758, 0.609643513047942, -87.5116729736328, -1.52736682731843, 218, 2, 'PPL', 'P'),
(212167, 'Stuyahok', 62.0602798461914, 1.08315621802512, -160.950836181641, -2.80912202520765, 218, 1, 'PPL', 'P'),
(152978, 'Stuyvesant', 42.3902816772461, 0.739849986115769, -73.7819366455078, -1.28773772296197, 218, 40, 'PPL', 'P'),
(152980, 'Stuyvesant Falls', 42.355281829834, 0.739239123540732, -73.7313919067383, -1.28685555085088, 218, 40, 'PPL', 'P'),
(14685, 'Stuyvesant Hills', 39.7750015258789, 0.694204736612355, -75.6672210693359, -1.32064214349434, 218, 10, 'PPL', 'P'),
(12165, 'Styra (historical)', 36.4583282470703, 0.63631786768423, -90.3052825927734, -1.57612451318782, 218, 4, 'PPL', 'P'),
(98341, 'Styx', 32.3630599975586, 0.564841952977865, -96.3277816772461, -1.68123695141021, 218, 51, 'PPL', 'P'),
(185416, 'Styx', 33.878059387207, 0.591283680492935, -114.794441223145, -2.00354096233098, 218, 6, 'PPL', 'P'),
(83875, 'Styx (historical)', 33.913330078125, 0.591899270178907, -81.1236114501953, -1.41587412091448, 218, 48, 'PPL', 'P'),
(176585, 'Suamico', 44.6319389343262, 0.778974285953041, -88.0391693115234, -1.53657337520683, 218, 57, 'PPL', 'P'),
(12166, 'Sub Rosa (historical)', 35.3916702270508, 0.617701173242085, -93.9463882446289, -1.63967379522567, 218, 4, 'PPL', 'P'),
(185417, 'Subaco', 38.9286117553711, 0.679432448361795, -121.738327026367, -2.12473463247971, 218, 6, 'PPL', 'P'),
(185418, 'Subeet', 38.228328704834, 0.667210203434012, -122.080001831055, -2.13069798279261, 218, 6, 'PPL', 'P'),
(83876, 'Suber', 34.9302787780762, 0.609648373316931, -82.2694396972656, -1.43587259648821, 218, 48, 'PPL', 'P'),
(12167, 'Subiaco', 35.292781829834, 0.615975245118632, -93.6344375610352, -1.63422922869311, 218, 4, 'PPL', 'P'),
(38426, 'Sublett', 37.6775016784668, 0.657596458214936, -83.0374984741211, -1.44927775099318, 218, 21, 'PPL', 'P'),
(98342, 'Sublett', 32.644718170166, 0.569757815455015, -97.133056640625, -1.69529165090505, 218, 51, 'PPL', 'P'),
(195667, 'Sublett', 42.3122215270996, 0.738487579481111, -113.136108398438, -1.97459759444594, 218, 17, 'PPL', 'P'),
(6124, 'Sublett Mill', 34.6988906860352, 0.605609889260908, -86.4186096191406, -1.50828927284965, 218, 2, 'PPL', 'P'),
(121606, 'Sublette', 41.6430587768555, 0.726808486257651, -89.227783203125, -1.55731860115022, 218, 18, 'PPL', 'P'),
(139469, 'Sublette', 40.3005599975586, 0.703377462354915, -92.5713882446289, -1.61567551801075, 218, 29, 'PPL', 'P'),
(187926, 'Sublette', 37.4816703796387, 0.654178557271928, -100.843330383301, -1.76004814386503, 218, 20, 'PPL', 'P'),
(189609, 'Sublette', 36.9888916015625, 0.645577945110544, -106.229438781738, -1.85405346928709, 218, 38, 'PPL', 'P'),
(106676, 'Subletts', 37.5855598449707, 0.655991770500108, -77.7494430541992, -1.35698377288761, 218, 53, 'PPL', 'P'),
(25195, 'Subligna', 34.560001373291, 0.60318581345769, -85.1875, -1.48680235654267, 218, 13, 'PPL', 'P'),
(98343, 'Sublime', 29.478609085083, 0.514498787443012, -96.7972183227539, -1.68943016650384, 218, 51, 'PPL', 'P'),
(201605, 'Sublimity', 44.829719543457, 0.782426208778974, -122.793327331543, -2.14314786141457, 218, 43, 'PPL', 'P'),
(38427, 'Sublimity City', 37.0944404602051, 0.647420120215579, -84.083610534668, -1.46753585079455, 218, 21, 'PPL', 'P'),
(157842, 'Subrosa (historical)', 40.9436111450195, 0.714600822136836, -80.5416717529297, -1.40571735714914, 218, 41, 'PPL', 'P'),
(69181, 'Suburb', 34.0058288574219, 0.593513678431713, -78.1488876342773, -1.36395539598922, 218, 33, 'PPL', 'P'),
(51775, 'Suburban Acres', 38.3408317565918, 0.669173752105728, -75.5941696166992, -1.31936715512246, 218, 25, 'PPL', 'P'),
(106673, 'Suburban Acres', 36.9063911437988, 0.644138040488166, -76.2644424438477, -1.33106562284285, 218, 53, 'PPL', 'P'),
(25192, 'Suburban Estates', 33.8263893127441, 0.590381867568807, -85.022216796875, -1.4839176204499, 218, 13, 'PPL', 'P'),
(18204, 'Suburban Heights', 29.6677799224854, 0.517800441404437, -82.3916702270508, -1.43800592167942, 218, 12, 'PPL', 'P'),
(91097, 'Suburban Hills', 35.4105606079102, 0.618030872585037, -84.6774978637695, -1.47790114007324, 218, 50, 'PPL', 'P'),
(51776, 'Suburban Mobile Estates', 38.2577781677246, 0.667724193524398, -76.478889465332, -1.33480842943885, 218, 25, 'PPL', 'P'),
(138330, 'Suburban Mobile Home Park', 45.9727783203125, 0.802376347978921, -94.341667175293, -1.64657271402952, 218, 28, 'PPL', 'P'),
(43237, 'Suburban North', 32.6191711425781, 0.569311935709509, -92.0055618286133, -1.60579998405652, 218, 22, 'PPL', 'P'),
(71451, 'Suburban Park', 39.9661102294922, 0.697540212719625, -74.2319412231445, -1.29559178449078, 218, 37, 'PPL', 'P'),
(126279, 'Suburban Park', 41.6444396972656, 0.726832587865516, -71.0652770996094, -1.24032306923031, 218, 23, 'PPL', 'P'),
(91098, 'Suburban Shores', 35.8527793884277, 0.625749046319223, -84.5027770996094, -1.47485168746705, 218, 50, 'PPL', 'P'),
(126280, 'Suburban Village Trailer Park', 42.672779083252, 0.744780495978914, -71.6233291625977, -1.250062915127, 218, 23, 'PPL', 'P'),
(51778, 'Suburbia', 39.4513893127441, 0.688556637993488, -76.8069381713867, -1.34053395946641, 218, 25, 'PPL', 'P'),
(61917, 'Sucarnoochee', 32.7311096191406, 0.571265630685191, -88.4730606079102, -1.54414620692453, 218, 30, 'PPL', 'P'),
(146416, 'Succasunna', 40.8683280944824, 0.713286885034018, -74.6408309936523, -1.30272825726386, 218, 37, 'PPL', 'P'),
(12168, 'Success', 36.4544410705566, 0.63625002365546, -90.7213897705078, -1.58338695348046, 218, 4, 'PPL', 'P'),
(57766, 'Success', 37.4436111450195, 0.653514298317035, -92.0875015258789, -1.60723010156189, 218, 29, 'PPL', 'P'),
(61920, 'Success', 30.610559463501, 0.534255048515601, -89.0516662597656, -1.55424478062005, 218, 30, 'PPL', 'P'),
(74448, 'Success', 39.1349983215332, 0.683034573473209, -81.8324966430664, -1.42824650154872, 218, 41, 'PPL', 'P'),
(77369, 'Success', 36.6127815246582, 0.639013585918635, -95.0347213745117, -1.65866879170066, 218, 42, 'PPL', 'P'),
(106675, 'Success', 38.9972190856934, 0.680629872166922, -78.1508331298828, -1.36398935129312, 218, 53, 'PPL', 'P'),
(61918, 'Success (historical)', 32.2024993896484, 0.56203964172083, -89.283332824707, -1.55828812494507, 218, 30, 'PPL', 'P'),
(171391, 'Success (historical)', 44.5705604553223, 0.777903029404557, -97.5361099243164, -1.70232625776644, 218, 49, 'PPL', 'P'),
(205937, 'Success Estates', 40.547779083252, 0.707692249374035, -111.845832824707, -1.95207803742629, 218, 52, 'PPL', 'P'),
(25194, 'Suches', 34.6888885498047, 0.605435319051453, -84.022216796875, -1.46646432792995, 218, 13, 'PPL', 'P'),
(91099, 'Suck Creek', 35.1808280944824, 0.614021283826841, -85.4266662597656, -1.49097659523526, 218, 50, 'PPL', 'P'),
(111581, 'Suck Creek', 37.607780456543, 0.656379593333851, -80.9872207641602, -1.41349365437411, 218, 58, 'PPL', 'P'),
(152981, 'Sucker Brook', 42.7466697692871, 0.746070131736785, -78.0344390869141, -1.36195789201361, 218, 40, 'PPL', 'P'),
(185419, 'Sucker Flat', 39.2119407653809, 0.684377472452881, -121.296112060547, -2.11701652532455, 218, 6, 'PPL', 'P'),
(129024, 'Suckerville', 43.9261093139648, 0.766655235119634, -70.394172668457, -1.22861008728198, 218, 26, 'PPL', 'P'),
(185421, 'Sucro', 38.4697189331055, 0.671423257699491, -121.803611755371, -2.1258740659521, 218, 6, 'PPL', 'P'),
(185420, 'Sucrosa (historical)', 34.1963882446289, 0.596839567159059, -119.068893432617, -2.07814422710542, 218, 6, 'PPL', 'P'),
(167710, 'Sudan', 40.163890838623, 0.700992135545559, -79.9677810668945, -1.39570107513129, 218, 45, 'PPL', 'P'),
(192284, 'Sudan', 34.0677795410156, 0.594594921834285, -102.523887634277, -1.78937940116284, 218, 51, 'PPL', 'P'),
(51780, 'Sudbrook Park', 39.3672218322754, 0.6870876383362, -76.7283325195313, -1.33916203203086, 218, 25, 'PPL', 'P'),
(126281, 'Sudbury', 42.3833312988281, 0.739728679128115, -71.4166717529297, -1.24645606290465, 218, 23, 'PPL', 'P'),
(172613, 'Sudbury', 43.7991714477539, 0.764439751408797, -73.2050018310547, -1.27766831088038, 218, 55, 'PPL', 'P'),
(208848, 'Sudbury', 46.0941696166992, 0.804495025784134, -118.476387023926, -2.06780303943459, 218, 56, 'PPL', 'P'),
(208849, 'Sudden Valley', 48.7230606079102, 0.850377829256782, -122.345283508301, -2.13532802150577, 218, 56, 'PPL', 'P'),
(98344, 'Sudduth', 30.6580600738525, 0.535084090562943, -98.2525024414063, -1.71482966592631, 218, 51, 'PPL', 'P'),
(28718, 'Sudduth (historical)', 39.7050018310547, 0.692983011462282, -89.8158264160156, -1.56758189135917, 218, 18, 'PPL', 'P'),
(57767, 'Sudheimer', 38.1330604553223, 0.665547458807422, -92.1786117553711, -1.60882027504878, 218, 29, 'PPL', 'P'),
(25196, 'Sudie', 33.8672218322754, 0.591094529476512, -84.8413925170898, -1.4807616414001, 218, 13, 'PPL', 'P'),
(38428, 'Sudith', 38.0183296203613, 0.663545027983791, -83.6322174072266, -1.45965755449982, 218, 21, 'PPL', 'P'),
(51781, 'Sudlersville', 39.186939239502, 0.683941113508272, -75.8591690063477, -1.3239922669876, 218, 25, 'PPL', 'P'),
(51782, 'Sudley', 38.8166694641113, 0.677478686807086, -76.57861328125, -1.33654893836927, 218, 25, 'PPL', 'P'),
(106680, 'Sudley', 38.792781829834, 0.677061768938434, -77.4977798461914, -1.35259142130174, 218, 53, 'PPL', 'P'),
(106677, 'Sudley Mountain Estates', 38.839168548584, 0.677871369909818, -77.5558319091797, -1.35360462093847, 218, 53, 'PPL', 'P'),
(106678, 'Sudley Springs', 38.8411102294922, 0.677905258634689, -77.5380630493164, -1.35329449582953, 218, 53, 'PPL', 'P'),
(106679, 'Sudley Square', 38.7905616760254, 0.677023019944573, -77.4844436645508, -1.35235866102247, 218, 53, 'PPL', 'P'),
(51783, 'Sudleys Choice', 38.8377799987793, 0.677847135143898, -76.6052780151367, -1.33701432576976, 218, 25, 'PPL', 'P'),
(111582, 'Sue', 37.9563903808594, 0.662463984318301, -80.209716796875, -1.39992365019767, 218, 58, 'PPL', 'P'),
(57768, 'Sue City', 39.9672203063965, 0.697559587216556, -92.3649978637695, -1.61207332632031, 218, 29, 'PPL', 'P'),
(51784, 'Sue Creek Landing', 39.290828704834, 0.685754326736452, -76.4127807617188, -1.33365461489657, 218, 25, 'PPL', 'P'),
(74449, 'Sue-Lin Acres', 39.9027786254883, 0.696434867709188, -81.352783203125, -1.41987392255567, 218, 41, 'PPL', 'P'),
(6125, 'Sueann', 33.7702789306641, 0.589402556656958, -86.670280456543, -1.51268175759357, 218, 2, 'PPL', 'P'),
(167709, 'Suedberg', 40.5269393920898, 0.707328528148157, -76.4700012207031, -1.33465330030535, 218, 45, 'PPL', 'P'),
(57769, 'Suelthaus Ford', 38.4075012207031, 0.670337353765011, -91.595832824707, -1.59864886389744, 218, 29, 'PPL', 'P'),
(83878, 'Sueville (historical)', 34.3216705322266, 0.599026155572068, -81.35888671875, -1.41998044899927, 218, 48, 'PPL', 'P'),
(152982, 'Suffern', 41.1147193908691, 0.717587224404224, -74.1500015258789, -1.29416166698541, 218, 40, 'PPL', 'P'),
(152983, 'Suffern Park', 41.110279083252, 0.717509726416503, -74.121940612793, -1.29367191166094, 218, 40, 'PPL', 'P'),
(114141, 'Suffield', 41.9816703796387, 0.732718373611673, -72.6511077880859, -1.26800103612339, 218, 8, 'PPL', 'P'),
(157843, 'Suffield', 41.0230598449707, 0.715987463537413, -81.3475036621094, -1.41978177718195, 218, 41, 'PPL', 'P'),
(126283, 'Suffield Corner', 42.0625, 0.734129116620115, -72.6319427490234, -1.26766654309048, 218, 23, 'PPL', 'P'),
(114142, 'Suffield Depot', 41.9811096191406, 0.732708586494667, -72.6502838134766, -1.26798665505351, 218, 8, 'PPL', 'P'),
(157844, 'Suffield Station', 41.021671295166, 0.715963228771494, -81.3730621337891, -1.42022785666454, 218, 41, 'PPL', 'P'),
(61919, 'Suffolk', 31.461109161377, 0.54909994119538, -90.9661102294922, -1.58765813123673, 218, 30, 'PPL', 'P'),
(106681, 'Suffolk', 36.7280616760254, 0.64102560412219, -76.5838928222656, -1.33664108374299, 218, 53, 'PPL', 'P'),
(197644, 'Suffolk', 47.4669418334961, 0.828454420847141, -109.355003356934, -1.90860486210794, 218, 31, 'PPL', 'P'),
(25197, 'Suffolk Downs', 33.5988883972168, 0.586411227541554, -84.5924987792969, -1.47641762618801, 218, 13, 'PPL', 'P'),
(126285, 'Suffolk Downs Station', 42.389720916748, 0.739840198998763, -70.9983291625977, -1.23915460730204, 218, 23, 'PPL', 'P'),
(106683, 'Suffolk Trailer Park', 36.7400016784668, 0.641233996477489, -76.5658264160156, -1.33632576546992, 218, 53, 'PPL', 'P'),
(187412, 'Sugar', 38.1502799987793, 0.665847996536437, -102.668060302734, -1.7918956889188, 218, 7, 'PPL', 'P'),
(6126, 'Sugar (historical)', 34.9980583190918, 0.610831349473144, -87.2183303833008, -1.52224703328081, 218, 2, 'PPL', 'P'),
(185423, 'Sugar (historical)', 33.7380599975586, 0.588840230192788, -117.997222900391, -2.05944004782147, 218, 6, 'PPL', 'P'),
(98345, 'Sugar Acres Colonia', 26.3229999542236, 0.459423018203519, -98.1729965209961, -1.71344202584032, 218, 51, 'PPL', 'P'),
(57770, 'Sugar Beach', 36.6036109924316, 0.638853529937121, -94.3666687011719, -1.64700907297413, 218, 29, 'PPL', 'P'),
(190795, 'Sugar Bunker', 36.8394393920898, 0.642969511980866, -115.96028137207, -2.02388871148167, 218, 39, 'PPL', 'P'),
(176589, 'Sugar Bush', 44.4816703796387, 0.776351604911531, -88.7358322143555, -1.54873243663775, 218, 57, 'PPL', 'P'),
(157846, 'Sugar Bush Knolls', 41.2044410705566, 0.719153163125191, -81.3461074829102, -1.41975740925798, 218, 41, 'PPL', 'P'),
(111583, 'Sugar Camp', 39.2408294677734, 0.684881675426261, -80.6936111450195, -1.40836919980458, 218, 58, 'PPL', 'P'),
(176590, 'Sugar Camp', 45.7944412231445, 0.799263778454891, -89.3138885498047, -1.55882142295336, 218, 57, 'PPL', 'P'),
(187413, 'Sugar City', 38.2319412231445, 0.66727325377282, -103.662498474121, -1.80925190921701, 218, 7, 'PPL', 'P'),
(195668, 'Sugar City', 43.8730583190918, 0.765729320587641, -111.747497558594, -1.95036176326179, 218, 17, 'PPL', 'P'),
(6127, 'Sugar Creek', 33.9388885498047, 0.592345349661495, -86.6800003051758, -1.51285140095501, 218, 2, 'PPL', 'P'),
(25200, 'Sugar Creek', 33.607780456543, 0.586566423254078, -83.3772201538086, -1.45520701284413, 218, 13, 'PPL', 'P'),
(31243, 'Sugar Creek', 39.6405601501465, 0.691858291954914, -85.9130630493164, -1.49946582068405, 218, 19, 'PPL', 'P'),
(43238, 'Sugar Creek', 32.6680603027344, 0.57016521252277, -92.8866729736328, -1.62117827461312, 218, 22, 'PPL', 'P'),
(57771, 'Sugar Creek', 39.1097183227539, 0.68259335425961, -94.4444427490234, -1.64836648618174, 218, 29, 'PPL', 'P'),
(74450, 'Sugar Creek', 39.3822212219238, 0.687349427071355, -82.0791702270508, -1.43255176776694, 218, 41, 'PPL', 'P'),
(77370, 'Sugar Creek', 34.889720916748, 0.608940505099188, -94.4786071777344, -1.64896276794981, 218, 42, 'PPL', 'P'),
(83879, 'Sugar Creek', 34.8824996948242, 0.6088144710006, -82.272216796875, -1.43592106602005, 218, 48, 'PPL', 'P'),
(91101, 'Sugar Creek', 36.5980606079102, 0.63875665745247, -81.7280578613281, -1.42642370094061, 218, 50, 'PPL', 'P'),
(117931, 'Sugar Creek (historical)', 40.4077796936035, 0.705248799073887, -91.504997253418, -1.59706348410051, 218, 16, 'PPL', 'P'),
(28719, 'Sugar Creek Ranch', 37.5722198486328, 0.655758943641808, -88.9272232055664, -1.55207283959304, 218, 18, 'PPL', 'P'),
(83880, 'Sugar Creek Villas', 34.8888893127441, 0.608925990871247, -82.2763900756836, -1.43599390347587, 218, 48, 'PPL', 'P'),
(91102, 'Sugar Forks', 36.024169921875, 0.628740375434627, -83.4038925170898, -1.45567253340268, 218, 50, 'PPL', 'P'),
(12174, 'Sugar Grove', 35.0819396972656, 0.612295355703388, -93.8011093139648, -1.63713819955181, 218, 4, 'PPL', 'P'),
(31249, 'Sugar Grove', 38.1177787780762, 0.66528074322425, -85.9111099243164, -1.4994317322221, 218, 19, 'PPL', 'P'),
(38431, 'Sugar Grove', 37.0900001525879, 0.647342622227858, -86.6650009155273, -1.51258961221985, 218, 21, 'PPL', 'P'),
(69183, 'Sugar Grove', 36.2577781677246, 0.632817608484511, -81.788330078125, -1.42747564957119, 218, 33, 'PPL', 'P'),
(106686, 'Sugar Grove', 37.1016693115234, 0.647546287472222, -80.3288879394531, -1.40200357900902, 218, 53, 'PPL', 'P'),
(111584, 'Sugar Grove', 38.5111083984375, 0.672145640145175, -79.3219375610352, -1.38442897950142, 218, 58, 'PPL', 'P'),
(112571, 'Sugar Grove', 36.6269416809082, 0.639260727267794, -86.2675018310547, -1.50565194442214, 218, 50, 'PPL', 'P'),
(121611, 'Sugar Grove', 40.0294418334961, 0.698645557730063, -90.5716705322266, -1.58077385981888, 218, 18, 'PPL', 'P'),
(133300, 'Sugar Grove', 44.0050010681152, 0.768032155982232, -86.2794418334961, -1.50586033677744, 218, 27, 'PPL', 'P'),
(157854, 'Sugar Grove', 40.0794410705566, 0.699518209040254, -84.3525009155273, -1.47222887326748, 218, 41, 'PPL', 'P'),
(167711, 'Sugar Grove', 41.9824981689453, 0.732732821260586, -79.3388900756836, -1.38472485669853, 218, 45, 'PPL', 'P'),
(176593, 'Sugar Grove', 43.4258308410645, 0.757923728590673, -90.6836090087891, -1.58272755479456, 218, 57, 'PPL', 'P'),
(25204, 'Sugar Hill', 34.226390838623, 0.597363211208395, -83.7363891601563, -1.46147569457602, 218, 13, 'PPL', 'P'),
(38430, 'Sugar Hill', 37.1269416809082, 0.647987373527766, -84.554443359375, -1.47575343381215, 218, 21, 'PPL', 'P'),
(61921, 'Sugar Hill', 33.5491714477539, 0.585543503079378, -89.586669921875, -1.56358235603409, 218, 30, 'PPL', 'P'),
(69185, 'Sugar Hill', 34.7574996948242, 0.606632809435607, -79.4591674804688, -1.38682409342779, 218, 33, 'PPL', 'P'),
(83885, 'Sugar Hill', 33.2077789306641, 0.57958507961449, -80.0458297729492, -1.39706328202887, 218, 48, 'PPL', 'P'),
(91106, 'Sugar Hill', 35.2266693115234, 0.614821363997328, -89.0400009155273, -1.55404118195472, 218, 50, 'PPL', 'P'),
(106685, 'Sugar Hill', 37.0750007629395, 0.647080833492703, -78.9169387817383, -1.37736041733614, 218, 53, 'PPL', 'P'),
(129025, 'Sugar Hill', 46.4358291625977, 0.81045810978093, -67.8027801513672, -1.18338175564722, 218, 26, 'PPL', 'P'),
(144525, 'Sugar Hill', 44.2152786254883, 0.771702191701443, -71.8000030517578, -1.25314645619515, 218, 36, 'PPL', 'P'),
(167716, 'Sugar Hill', 40.1522216796875, 0.700788470301195, -80.3102798461914, -1.40167880651409, 218, 45, 'PPL', 'P'),
(25205, 'Sugar Hill (historical)', 34.3108291625977, 0.598836937976618, -84.6861114501953, -1.47805147551678, 218, 13, 'PPL', 'P'),
(31248, 'Sugar Hills', 39.8611106872559, 0.695707624994514, -85.8227767944336, -1.49789002826705, 218, 19, 'PPL', 'P'),
(91107, 'Sugar Hollow', 36.1680603027344, 0.631251736342572, -82.0777816772461, -1.43252753300102, 218, 50, 'PPL', 'P'),
(172615, 'Sugar Hollow', 43.7619400024414, 0.763789940102818, -73.0233306884766, -1.27449755128653, 218, 55, 'PPL', 'P'),
(205939, 'Sugar House', 40.725830078125, 0.710799825471021, -111.864440917969, -1.95240280992122, 218, 52, 'PPL', 'P'),
(121614, 'Sugar Island', 41.0063896179199, 0.715696513188322, -87.8236083984375, -1.53281112753488, 218, 18, 'PPL', 'P'),
(176594, 'Sugar Island', 43.225830078125, 0.754433056770879, -88.579719543457, -1.54600775652649, 218, 57, 'PPL', 'P'),
(18205, 'Sugar Junction', 26.7361106872559, 0.466633160670259, -80.9208297729492, -1.41233491298382, 218, 12, 'PPL', 'P'),
(187414, 'Sugar Junction', 37.5677795410156, 0.655681445654087, -106.111938476563, -1.85200270208967, 218, 7, 'PPL', 'P'),
(57774, 'Sugar Lake', 39.5125007629395, 0.689623234010065, -95.0177764892578, -1.65837304766161, 218, 29, 'PPL', 'P'),
(98346, 'Sugar Land', 29.6194400787354, 0.5169567519711, -95.6347198486328, -1.66914074058102, 218, 51, 'PPL', 'P'),
(133302, 'Sugar Loaf', 46.589168548584, 0.813134386939378, -87.4449996948242, -1.52620315908012, 218, 27, 'PPL', 'P'),
(152985, 'Sugar Loaf', 41.3208312988281, 0.721184555825676, -74.2858276367188, -1.29653227982974, 218, 40, 'PPL', 'P'),
(195669, 'Sugar Loaf', 42.6813888549805, 0.744930764843422, -114.376937866211, -1.99625415411436, 218, 17, 'PPL', 'P'),
(14686, 'Sugar Loaf Chase', 39.482780456543, 0.689104516808745, -75.6436080932617, -1.32023001931565, 218, 10, 'PPL', 'P'),
(106687, 'Sugar Loaf Estates', 37.2402801513672, 0.64996550300645, -80.0330581665039, -1.39684037544563, 218, 53, 'PPL', 'P'),
(106688, 'Sugar Loaf Farms', 37.2358283996582, 0.649887805281647, -80.0280609130859, -1.39675315691993, 218, 53, 'PPL', 'P'),
(106689, 'Sugar Loaf Highlands', 37.2455596923828, 0.650057648380166, -80.0438919067383, -1.39702945988302, 218, 53, 'PPL', 'P'),
(106690, 'Sugar Loaf Hills', 37.2275009155273, 0.649742463265156, -80.0425033569336, -1.39700522511711, 218, 53, 'PPL', 'P'),
(83883, 'Sugar Mill', 34.8824996948242, 0.6088144710006, -82.2597198486328, -1.43570295312677, 218, 48, 'PPL', 'P'),
(18206, 'Sugar Mill Estates', 29.0436096191406, 0.5069066145179, -80.982780456543, -1.41341615638639, 218, 12, 'PPL', 'P'),
(25206, 'Sugar Mill Plantation', 30.7763900756836, 0.537149338698786, -81.57861328125, -1.42381540096899, 218, 13, 'PPL', 'P'),
(69189, 'Sugar Mountain', 36.1272201538086, 0.630538941276812, -81.8602828979492, -1.42873146318322, 218, 33, 'PPL', 'P'),
(167717, 'Sugar Notch', 41.1969413757324, 0.719022268757613, -75.9286117553711, -1.3252042715997, 218, 45, 'PPL', 'P'),
(185424, 'Sugar Pine', 37.4411087036133, 0.653470622475158, -119.633331298828, -2.08799552629374, 218, 6, 'PPL', 'P'),
(133303, 'Sugar Rapids', 44.0880584716797, 0.76948178114259, -84.4077835083008, -1.47319373653042, 218, 27, 'PPL', 'P'),
(25207, 'Sugar Ridge', 34.1083297729492, 0.595302656893974, -84.0569381713867, -1.467070330236, 218, 13, 'PPL', 'P'),
(157855, 'Sugar Ridge', 41.4288902282715, 0.723070539930643, -83.6224975585938, -1.45948791113838, 218, 41, 'PPL', 'P'),
(167719, 'Sugar Run', 41.642219543457, 0.726793838871655, -76.241943359375, -1.33067293974012, 218, 45, 'PPL', 'P'),
(167720, 'Sugar Run (historical)', 41.896671295166, 0.731234859726444, -78.9438934326172, -1.3778308647427, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(69191, 'Sugar Town', 35.0555610656738, 0.61183496172994, -80.182502746582, -1.39944867541725, 218, 33, 'PPL', 'P'),
(112572, 'Sugar Tree', 35.8291702270508, 0.62533698871956, -88.0361099243164, -1.53651997882698, 218, 50, 'PPL', 'P'),
(91108, 'Sugar Tree Knob', 35.8652801513672, 0.625967225791528, -85.9958267211914, -1.50091031925931, 218, 50, 'PPL', 'P'),
(74454, 'Sugar Tree Ridge', 39.0702781677246, 0.681904993696852, -83.6619415283203, -1.46017633828017, 218, 41, 'PPL', 'P'),
(25208, 'Sugar Valley', 34.5580596923828, 0.603151924732819, -85.0119400024414, -1.48373825655048, 218, 13, 'PPL', 'P'),
(51785, 'Sugar Valley', 39.7194404602051, 0.69323501308043, -76.8111114501953, -1.34060679692222, 218, 25, 'PPL', 'P'),
(74455, 'Sugar Valley', 39.6922187805176, 0.69275990514196, -84.7130584716797, -1.47852178976529, 218, 41, 'PPL', 'P'),
(98347, 'Sugar Valley', 29.0625, 0.507236313860852, -95.8394393920898, -1.67271377065752, 218, 51, 'PPL', 'P'),
(111586, 'Sugar Valley', 39.4194412231445, 0.687999038640253, -81.0872192382813, -1.4152389569945, 218, 58, 'PPL', 'P'),
(152986, 'Sugarbush', 44.5416717529297, 0.777398826431177, -73.9702835083008, -1.29102499585351, 218, 40, 'PPL', 'P'),
(172616, 'Sugarbush Village', 44.1413917541504, 0.7704126225226, -72.896110534668, -1.27227714072768, 218, 55, 'PPL', 'P'),
(25209, 'Sugarcreek', 33.4847183227539, 0.584418583834929, -82.1813888549805, -1.43433581938118, 218, 13, 'PPL', 'P'),
(157856, 'Sugarcreek', 40.503059387207, 0.70691174343756, -81.64111328125, -1.42490623175148, 218, 41, 'PPL', 'P'),
(167721, 'Sugarcreek', 41.4213905334473, 0.722939645563065, -79.8813934326172, -1.39419332648015, 218, 45, 'PPL', 'P'),
(185425, 'Sugarfield', 38.7138900756836, 0.675684848075835, -121.752502441406, -2.12498204014497, 218, 6, 'PPL', 'P'),
(189610, 'Sugarite', 36.9438896179199, 0.644792512326053, -104.381393432617, -1.82179899321876, 218, 38, 'PPL', 'P'),
(51786, 'Sugarland', 39.0994415283203, 0.682413990360193, -77.3913879394531, -1.35073453223169, 218, 25, 'PPL', 'P'),
(106691, 'Sugarland Run', 39.0374984741211, 0.681332880115676, -77.3755569458008, -1.35045822926859, 218, 53, 'PPL', 'P'),
(91109, 'Sugarlimb', 35.7708282470703, 0.624318729076769, -84.3105621337891, -1.47149690344188, 218, 50, 'PPL', 'P'),
(138334, 'Sugarloaf', 44.026668548584, 0.768410324857024, -91.6230621337891, -1.59912410499396, 218, 28, 'PPL', 'P'),
(193984, 'Sugarloaf', 40.8583297729492, 0.713112381403591, -122.39582824707, -2.13621019361686, 218, 6, 'PPL', 'P'),
(194439, 'Sugarloaf', 40.0169410705566, 0.698427378257758, -105.406669616699, -1.83969343837327, 218, 7, 'PPL', 'P'),
(51787, 'Sugarloaf Estates', 39.3105583190918, 0.6860986734654, -77.3786087036133, -1.35051149249039, 218, 25, 'PPL', 'P'),
(28722, 'Sugarloaf Heights', 38.4961090087891, 0.67188385141002, -90.2125015258789, -1.574505178087, 218, 18, 'PPL', 'P'),
(51788, 'Sugarloaf Meadows', 39.3077812194824, 0.68605020393356, -77.3249969482422, -1.34957579084139, 218, 25, 'PPL', 'P'),
(185427, 'Sugarloaf Mountain Park', 35.8388900756836, 0.625506632080998, -118.603607177734, -2.07002344999344, 218, 6, 'PPL', 'P'),
(51789, 'Sugarloaf Overlook', 39.3436088562012, 0.686675514157511, -77.2427825927734, -1.34814087964606, 218, 25, 'PPL', 'P'),
(18207, 'Sugarloaf Shores', 24.6438903808594, 0.430117027646555, -81.5622177124023, -1.42352924430986, 218, 12, 'PPL', 'P'),
(69192, 'Sugarloaf Shores', 35.3558311462402, 0.617075663281053, -80.0633316040039, -1.3973687466059, 218, 33, 'PPL', 'P'),
(185428, 'Sugarloaf Village', 35.8258285522461, 0.625278665491688, -118.633331298828, -2.07054223377379, 218, 6, 'PPL', 'P'),
(51790, 'Sugarloaf Vista', 39.2902793884277, 0.685744739356528, -77.2983322143555, -1.3491104034409, 218, 25, 'PPL', 'P'),
(51791, 'Sugarloaf West', 39.2880592346191, 0.685705990362667, -77.4066696166992, -1.35100124781486, 218, 25, 'PPL', 'P'),
(18208, 'Sugarmill Woods', 28.7319393157959, 0.501466941543845, -82.5063934326172, -1.440008219345, 218, 12, 'PPL', 'P'),
(185429, 'Sugarpine', 38.0583305358887, 0.664243175663555, -120.200561523438, -2.09789556133, 218, 6, 'PPL', 'P'),
(205941, 'Sugarplum Condominiums', 40.5855598449707, 0.708351648059938, -111.651672363281, -1.94868929809722, 218, 52, 'PPL', 'P'),
(38432, 'Sugartit', 38.9727783203125, 0.680203300339318, -84.6627807617188, -1.47764427818611, 218, 21, 'PPL', 'P'),
(18209, 'Sugarton', 26.7649993896484, 0.467137363643638, -80.960563659668, -1.41302840013168, 218, 12, 'PPL', 'P'),
(25210, 'Sugartown', 34.8861083984375, 0.60887745476038, -85.0716705322266, -1.48478075095919, 218, 13, 'PPL', 'P'),
(43239, 'Sugartown', 30.8397197723389, 0.538254650419709, -93.0147171020508, -1.62341306624186, 218, 22, 'PPL', 'P'),
(69193, 'Sugartown', 36.1500015258789, 0.630936551227561, -80.6202774047852, -1.40708928458469, 218, 33, 'PPL', 'P'),
(79231, 'Sugartown', 39.9997215270996, 0.698126840528742, -75.5083312988281, -1.31786899385124, 218, 45, 'PPL', 'P'),
(152987, 'Sugartown', 42.2377815246582, 0.737188356343316, -78.5947189331055, -1.37173662006222, 218, 40, 'PPL', 'P'),
(57775, 'Sugartree', 37.9677810668945, 0.662662789293675, -91.9705581665039, -1.60518905490245, 218, 29, 'PPL', 'P'),
(51792, 'Sugarvale Estates', 39.4486083984375, 0.688508101882621, -76.7174987792969, -1.33897294759346, 218, 25, 'PPL', 'P'),
(6130, 'Sugarville', 32.5319404602051, 0.567789473093338, -87.4402770996094, -1.52612073424438, 218, 2, 'PPL', 'P'),
(91110, 'Sugarville', 36.5855598449707, 0.638538477980165, -82.1908264160156, -1.4345005358946, 218, 50, 'PPL', 'P'),
(192806, 'Sugarville', 39.4652786254883, 0.688799052231713, -112.648612976074, -1.9660891942373, 218, 52, 'PPL', 'P'),
(172617, 'Sugarwood Hill', 43.6652793884277, 0.76210289413128, -72.9861068725586, -1.27384787313861, 218, 55, 'PPL', 'P'),
(77371, 'Sugden', 34.0819396972656, 0.594842063183445, -97.9780578613281, -1.71003970438969, 218, 42, 'PPL', 'P'),
(192285, 'Suggs', 31.1222190856934, 0.543185193572368, -101.076942443848, -1.76412544349395, 218, 51, 'PPL', 'P'),
(91111, 'Suggs Creek', 36.1186103820801, 0.630388672412304, -86.4952774047852, -1.50962737813936, 218, 50, 'PPL', 'P'),
(69194, 'Suggs Crossroads', 35.8213882446289, 0.625201167503966, -77.5838928222656, -1.35409437626293, 218, 33, 'PPL', 'P'),
(83884, 'Suggs Crossroads', 34.2449989318848, 0.597687983703331, -80.0372161865234, -1.39691294658533, 218, 48, 'PPL', 'P'),
(6131, 'Suggsville', 31.5894393920898, 0.551339726251164, -87.6930618286133, -1.53053266006426, 218, 2, 'PPL', 'P'),
(43240, 'Sugrue', 30.9619407653809, 0.540387809163349, -93.0441665649414, -1.62392705633225, 218, 22, 'PPL', 'P'),
(152988, 'Suicide Corners', 42.9049987792969, 0.748833494262878, -78.103889465332, -1.36317002978376, 218, 40, 'PPL', 'P'),
(185431, 'Suisun City', 38.2383308410645, 0.667384773643467, -122.039169311523, -2.12998532088491, 218, 6, 'PPL', 'P'),
(74457, 'Suiter', 38.5902786254883, 0.673527421276762, -82.4250030517578, -1.43858768921955, 218, 41, 'PPL', 'P'),
(106692, 'Suiter', 37.1197204589844, 0.647861339429178, -81.2136077880859, -1.41744485332541, 218, 53, 'PPL', 'P'),
(51793, 'Suitland', 38.8486099243164, 0.678036153002266, -76.9241714477539, -1.34258006613192, 218, 25, 'PPL', 'P'),
(51794, 'Suitland Manor', 38.853328704834, 0.678118511258977, -76.9263916015625, -1.34261881512578, 218, 25, 'PPL', 'P'),
(69195, 'Sukey Young Crossroads', 36.1305618286133, 0.630597264504685, -78.2072219848633, -1.36497352247396, 218, 33, 'PPL', 'P'),
(197645, 'Sula', 45.836669921875, 0.800000808286571, -113.980827331543, -1.98934072108257, 218, 31, 'PPL', 'P'),
(212168, 'Sulatna Crossing', 64.1891708374023, 1.1203123752378, -155.463607788086, -2.7133518229312, 218, 1, 'PPL', 'P'),
(190796, 'Sulfur', 38.6197204589844, 0.674041278209093, -119.252777099609, -2.08135360253508, 218, 39, 'PPL', 'P'),
(167727, 'Sulger', 41.1661109924316, 0.718484177059363, -78.9841690063477, -1.37853380611242, 218, 45, 'PPL', 'P'),
(106693, 'Sulgrave Manor', 38.7169418334961, 0.675738111297637, -77.1011123657227, -1.34566826773197, 218, 53, 'PPL', 'P'),
(6132, 'Sulligent', 33.901668548584, 0.591695738092598, -88.1344375610352, -1.53823611983342, 218, 2, 'PPL', 'P'),
(28723, 'Sullivan', 39.5994415283203, 0.691140636620165, -88.607780456543, -1.54649751185096, 218, 18, 'PPL', 'P'),
(31251, 'Sullivan', 39.0952796936035, 0.682341352641461, -87.4058303833008, -1.5255195256283, 218, 19, 'PPL', 'P'),
(34075, 'Sullivan', 39.6652793884277, 0.692289724051507, -96.3555603027344, -1.68172177988666, 218, 20, 'PPL', 'P'),
(38433, 'Sullivan', 37.497501373291, 0.654454860235024, -87.9452819824219, -1.53493473218811, 218, 21, 'PPL', 'P'),
(57777, 'Sullivan', 38.2080612182617, 0.666856469062223, -91.1602783203125, -1.59104700372386, 218, 29, 'PPL', 'P'),
(106694, 'Sullivan', 38.311939239502, 0.668669482553321, -77.4097213745117, -1.35105451103666, 218, 53, 'PPL', 'P'),
(112662, 'Sullivan', 38.9072189331055, 0.679059073176966, -79.870002746582, -1.39399452150477, 218, 58, 'PPL', 'P'),
(129026, 'Sullivan', 44.5202789306641, 0.777025451246348, -68.1972198486328, -1.19026602706507, 218, 26, 'PPL', 'P'),
(133304, 'Sullivan', 43.1836090087891, 0.753696160097254, -86.0530624389648, -1.5019092709842, 218, 27, 'PPL', 'P'),
(144527, 'Sullivan', 43.0130615234375, 0.750719544946873, -72.2213897705078, -1.26050104186151, 218, 36, 'PPL', 'P'),
(152989, 'Sullivan', 43.0544395446777, 0.751441727655475, -75.8472213745117, -1.32378374147425, 218, 40, 'PPL', 'P'),
(157857, 'Sullivan', 41.0280609130859, 0.716074748642141, -82.2222213745117, -1.43504848128889, 218, 41, 'PPL', 'P'),
(176595, 'Sullivan', 43.0127792358398, 0.750714618098856, -88.5880584716797, -1.54615329828007, 218, 57, 'PPL', 'P'),
(185432, 'Sullivan', 39.2033309936523, 0.684227203588374, -121.634437561035, -2.12292141925152, 218, 6, 'PPL', 'P'),
(187415, 'Sullivan', 39.6713905334473, 0.692396383653164, -104.897499084473, -1.83080673613179, 218, 7, 'PPL', 'P'),
(106695, 'Sullivan (historical)', 38.2750015258789, 0.668024797832441, -78.6119384765625, -1.37203715779123, 218, 53, 'PPL', 'P'),
(185433, 'Sullivan (historical)', 35.1263885498047, 0.613071134528928, -118.404441833496, -2.06654735898062, 218, 6, 'PPL', 'P'),
(197646, 'Sullivan (historical)', 48.9874992370605, 0.854993154004917, -113.048606872559, -1.97307040471884, 218, 31, 'PPL', 'P'),
(212169, 'Sullivan Camp', 65.0630569458008, 1.13556456511679, -166.195281982422, -2.90065487187367, 218, 1, 'PPL', 'P'),
(121615, 'Sullivan Center (historical)', 40.9211082458496, 0.714208072455077, -88.2975006103516, -1.54108210693234, 218, 18, 'PPL', 'P'),
(98348, 'Sullivan City', 26.2772197723389, 0.458624003297468, -98.5633316040039, -1.72025465822485, 218, 51, 'PPL', 'P'),
(6133, 'Sullivan Crossroads', 34.9002799987793, 0.609124795846621, -87.8008270263672, -1.53241351758413, 218, 2, 'PPL', 'P'),
(83886, 'Sullivan Crossroads', 33.9211082458496, 0.592035024815474, -82.1155624389648, -1.43318693168692, 218, 48, 'PPL', 'P'),
(91113, 'Sullivan Gardens', 36.4777793884277, 0.636657354144187, -82.5933303833008, -1.44152555537607, 218, 50, 'PPL', 'P'),
(6134, 'Sullivan Heights', 31.2486095428467, 0.545391123192795, -85.420280456543, -1.49086514194364, 218, 2, 'PPL', 'P'),
(25211, 'Sullivan Heights', 33.8108291625977, 0.590110291716646, -84.6841735839844, -1.47801765337093, 218, 13, 'PPL', 'P'),
(51807, 'Sullivan Heights', 39.5900001525879, 0.690975853527716, -76.9908294677734, -1.34374346805412, 218, 25, 'PPL', 'P'),
(83887, 'Sullivans Island', 32.7630615234375, 0.571823296617454, -79.8369369506836, -1.39341741449655, 218, 48, 'PPL', 'P'),
(133306, 'Sullivans Landing', 46.648609161377, 0.814171821342019, -86.1963882446289, -1.50441077819611, 218, 27, 'PPL', 'P'),
(51795, 'Sullivans Trailer Park', 39.5186080932617, 0.689729827032695, -76.9199981689453, -1.34250722867611, 218, 25, 'PPL', 'P'),
(74456, 'Sullivants (historical)', 39.9388885498047, 0.697065104781155, -83.0999984741211, -1.45036858177568, 218, 41, 'PPL', 'P'),
(152992, 'Sullivanville', 42.2099990844727, 0.73670346128784, -76.7705612182617, -1.33989906186254, 218, 40, 'PPL', 'P'),
(111588, 'Sully', 38.9569396972656, 0.679926864218168, -79.5730590820313, -1.38881187686542, 218, 58, 'PPL', 'P'),
(117935, 'Sully', 41.5783309936523, 0.725678773323239, -92.8447189331055, -1.62044603847141, 218, 16, 'PPL', 'P'),
(106696, 'Sully Plantation', 38.9075012207031, 0.679064000024982, -77.4308319091797, -1.35142295937347, 218, 53, 'PPL', 'P'),
(198973, 'Sully Springs', 46.8672218322754, 0.817987332235775, -103.39111328125, -1.80451534406025, 218, 34, 'PPL', 'P'),
(6135, 'Sulpher Springs', 33.9152793884277, 0.591933292061833, -86.8647232055664, -1.51607542377066, 218, 2, 'PPL', 'P'),
(31253, 'Sulphur', 38.2275009155273, 0.667195755785099, -86.470832824707, -1.50920073973273, 218, 19, 'PPL', 'P'),
(38434, 'Sulphur', 38.4947204589844, 0.6718596166441, -85.2736129760742, -1.48830531150386, 218, 21, 'PPL', 'P'),
(43241, 'Sulphur', 30.2363891601563, 0.52772454475905, -93.3772201538086, -1.62973993804357, 218, 22, 'PPL', 'P'),
(77372, 'Sulphur', 34.5077781677246, 0.60227434657461, -96.9680633544922, -1.69241197481835, 218, 42, 'PPL', 'P'),
(91114, 'Sulphur', 36.3066711425781, 0.6336709518768, -85.378059387207, -1.49012824527001, 218, 50, 'PPL', 'P'),
(98350, 'Sulphur', 31.0588893890381, 0.542079881851445, -94.9772186279297, -1.65766517944386, 218, 51, 'PPL', 'P'),
(200223, 'Sulphur', 40.8747215270996, 0.713398471483693, -118.735557556152, -2.07232641854609, 218, 39, 'PPL', 'P'),
(202665, 'Sulphur', 44.8766708374023, 0.783245663446392, -102.913063049316, -1.79617179352309, 218, 49, 'PPL', 'P'),
(208850, 'Sulphur', 46.6375007629395, 0.813977943214661, -118.724716186523, -2.07213720095064, 218, 56, 'PPL', 'P'),
(98349, 'Sulphur Bluff', 33.3325004577637, 0.581761880910493, -95.398063659668, -1.66501031088836, 218, 51, 'PPL', 'P'),
(12182, 'Sulphur City', 35.9650001525879, 0.627707668142922, -94.0502777099609, -1.64148700845385, 218, 4, 'PPL', 'P'),
(111589, 'Sulphur City', 39.3530616760254, 0.686840496987041, -79.1377792358398, -1.38121481038181, 218, 58, 'PPL', 'P'),
(74459, 'Sulphur Grove', 39.8608283996582, 0.695702698146498, -84.1047210693359, -1.46790429913136, 218, 41, 'PPL', 'P'),
(38435, 'Sulphur Lick', 36.8052787780762, 0.642373296791825, -85.7386093139648, -1.49642102860976, 218, 21, 'PPL', 'P'),
(74458, 'Sulphur Lick', 39.3627815246582, 0.687010140348479, -83.1177825927734, -1.45067897320073, 218, 41, 'PPL', 'P'),
(12183, 'Sulphur Rock', 35.7511100769043, 0.623974582084903, -91.5005569458008, -1.59698598611279, 218, 4, 'PPL', 'P'),
(6136, 'Sulphur Spring', 33.1155586242676, 0.577975531630673, -86.4436111450195, -1.50872563179426, 218, 2, 'PPL', 'P'),
(31254, 'Sulphur Spring', 39.7700004577637, 0.694117451507628, -85.5158309936523, -1.49253281341825, 218, 19, 'PPL', 'P'),
(12184, 'Sulphur Spring (historical)', 36.107780456543, 0.630199654553936, -93.0711135864258, -1.62439737058076, 218, 4, 'PPL', 'P'),
(106697, 'Sulphur Spring (historical)', 37.127498626709, 0.647997094065745, -81.7822189331055, -1.42736898996953, 218, 53, 'PPL', 'P'),
(6142, 'Sulphur Springs', 34.9174995422363, 0.609425333575637, -86.5058288574219, -1.50981153572874, 218, 2, 'PPL', 'P'),
(12191, 'Sulphur Springs', 35.1925010681152, 0.614225015650232, -93.3258285522461, -1.62884298538843, 218, 4, 'PPL', 'P'),
(18210, 'Sulphur Springs', 28.0249996185303, 0.489128516213508, -82.4511108398438, -1.43904335608206, 218, 12, 'PPL', 'P'),
(38436, 'Sulphur Springs', 37.5355606079102, 0.655119119189917, -86.7766723632813, -1.51453864666363, 218, 21, 'PPL', 'P'),
(57778, 'Sulphur Springs', 38.336109161377, 0.66909132726999, -90.373893737793, -1.57732200357197, 218, 29, 'PPL', 'P'),
(69198, 'Sulphur Springs', 36.5397186279297, 0.637738397809678, -80.5747222900391, -1.40629419784125, 218, 33, 'PPL', 'P'),
(79232, 'Sulphur Springs', 39.9638900756836, 0.697501463725765, -78.6080627441406, -1.37196951349954, 218, 45, 'PPL', 'P'),
(91124, 'Sulphur Springs', 36.249439239502, 0.632672066730938, -87.0541687011719, -1.51938187142204, 218, 50, 'PPL', 'P'),
(98352, 'Sulphur Springs', 31.896390914917, 0.556697040968508, -94.7649993896484, -1.65396125499978, 218, 51, 'PPL', 'P'),
(106698, 'Sulphur Springs', 36.7255592346191, 0.640981928280313, -83.0808334350586, -1.45003408874276, 218, 53, 'PPL', 'P'),
(111590, 'Sulphur Springs', 37.8308296203613, 0.660272535636302, -82.1030578613281, -1.43296868563559, 218, 58, 'PPL', 'P'),
(113047, 'Sulphur Springs', 41.4191703796387, 0.722900896569205, -88.774169921875, -1.54940155586164, 218, 18, 'PPL', 'P'),
(117936, 'Sulphur Springs', 42.621940612793, 0.743893197282727, -95.0969390869141, -1.65975469563514, 218, 16, 'PPL', 'P'),
(123757, 'Sulphur Springs', 40.0047187805176, 0.698214059054443, -85.4427795410156, -1.49125782504637, 218, 19, 'PPL', 'P'),
(133307, 'Sulphur Springs', 42.4161109924316, 0.740300792709292, -86.2350006103516, -1.50508469110995, 218, 27, 'PPL', 'P'),
(152994, 'Sulphur Springs', 43.0175018310547, 0.750797042934594, -75.8513870239258, -1.32385644577201, 218, 40, 'PPL', 'P'),
(157879, 'Sulphur Springs', 40.8708305358887, 0.713330560875896, -82.8772201538086, -1.44648036658416, 218, 41, 'PPL', 'P'),
(185435, 'Sulphur Springs', 34.4269409179688, 0.600863470408114, -119.093612670898, -2.07857565920202, 218, 6, 'PPL', 'P'),
(189611, 'Sulphur Springs', 35.9075012207031, 0.626704122465153, -106.615280151367, -1.86078767157752, 218, 38, 'PPL', 'P'),
(28725, 'Sulphur Springs (historical)', 37.6047210693359, 0.656326196953995, -88.8413925170898, -1.55057481147987, 218, 18, 'PPL', 'P'),
(91123, 'Sulphur Springs (historical)', 35.7938919067383, 0.624721265875534, -87.0519409179688, -1.51934298927013, 218, 50, 'PPL', 'P'),
(185436, 'Sulphur Springs (historical)', 38.1247215270996, 0.665401917053849, -122.188888549805, -2.13259841454649, 218, 6, 'PPL', 'P'),
(106699, 'Sulphur Springs Heights', 36.8030586242676, 0.642334547797964, -81.6944427490234, -1.42583700655247, 218, 53, 'PPL', 'P'),
(25212, 'Sulphur Springs Station', 34.6883316040039, 0.605425598513474, -85.541389465332, -1.49297889290084, 218, 13, 'PPL', 'P'),
(91125, 'Sulphura', 36.538890838623, 0.637723950160764, -86.4127807617188, -1.50818754009601, 218, 50, 'PPL', 'P'),
(192807, 'Sulphurdale', 38.5602798461914, 0.673003843806453, -112.581108093262, -1.96491101177105, 218, 52, 'PPL', 'P'),
(138336, 'Sultan', 48.9908294677734, 0.855051277495708, -97.1774978637695, -1.69606729657253, 218, 28, 'PPL', 'P'),
(208851, 'Sultan', 47.8627815246582, 0.835363126767997, -121.815277099609, -2.12607766461743, 218, 56, 'PPL', 'P'),
(185441, 'Sultana', 36.5455589294434, 0.637840330300401, -119.339172363281, -2.08286148434428, 218, 6, 'PPL', 'P'),
(25213, 'Sumac', 34.8836097717285, 0.60883384549753, -84.7994384765625, -1.48002940525838, 218, 13, 'PPL', 'P'),
(91126, 'Sumac', 35.2461090087891, 0.615160650720204, -86.9408264160156, -1.51740367536433, 218, 50, 'PPL', 'P'),
(57779, 'Sumach', 36.3238906860352, 0.633971489605815, -89.9913864135742, -1.57064599135136, 218, 29, 'PPL', 'P'),
(123752, 'Suman', 41.542781829834, 0.725058323368278, -87, -1.51843644923507, 218, 19, 'PPL', 'P'),
(208852, 'Sumas', 49.0002784729004, 0.855216193746211, -122.263610839844, -2.1339025645323, 218, 56, 'PPL', 'P'),
(18211, 'Sumatra', 30.0200004577637, 0.523947849438181, -84.9791717529297, -1.48316634270638, 218, 12, 'PPL', 'P'),
(197647, 'Sumatra', 46.6183280944824, 0.813643317023692, -107.550559997559, -1.8771113843211, 218, 31, 'PPL', 'P'),
(123753, 'Sumava Resorts', 41.166389465332, 0.718489037328352, -87.4391708374023, -1.52610142632648, 218, 19, 'PPL', 'P'),
(61922, 'Sumbax', 31.235279083252, 0.545158462782063, -89.9230575561523, -1.56945342781522, 218, 30, 'PPL', 'P'),
(83888, 'Sumei Circle', 34.125560760498, 0.595603394360071, -80.7552795410156, -1.40944551635914, 218, 48, 'PPL', 'P'),
(98353, 'Sumer Hill', 32.336669921875, 0.564381359267336, -95.820556640625, -1.67238420447262, 218, 51, 'PPL', 'P'),
(43242, 'Sumerall', 30.0130596160889, 0.523826708898096, -91.8461074829102, -1.60301698071738, 218, 22, 'PPL', 'P'),
(111591, 'Sumerco', 38.2311096191406, 0.667258739544879, -81.9116668701172, -1.4296282826803, 218, 58, 'PPL', 'P'),
(106701, 'Sumerduck', 38.4599990844727, 0.671253614338053, -77.7283325195313, -1.3566153245508, 218, 53, 'PPL', 'P'),
(167730, 'Sumerson', 41.3263893127441, 0.721281561468382, -78.3324966430664, -1.36715997772891, 218, 45, 'PPL', 'P'),
(6143, 'Sumiton', 33.7555618286133, 0.58914569476982, -87.0500030517578, -1.51930916712429, 218, 2, 'PPL', 'P'),
(6144, 'Sumiton Trailer Park', 33.7622184753418, 0.589261875172374, -87.0405578613281, -1.51914431745281, 218, 2, 'PPL', 'P'),
(6145, 'Summer Bluff', 34.959171295166, 0.610152642869337, -85.767219543457, -1.49692037131415, 218, 2, 'PPL', 'P'),
(25214, 'Summer Brooke', 33.3711090087891, 0.58243572724531, -84.5480575561523, -1.47564198052053, 218, 13, 'PPL', 'P'),
(51796, 'Summer City', 38.6661109924316, 0.674850945759504, -76.5374984741211, -1.33583134961355, 218, 25, 'PPL', 'P'),
(91129, 'Summer City', 35.5741691589355, 0.620886380484847, -85.1161117553711, -1.48555639662668, 218, 50, 'PPL', 'P'),
(205944, 'Summer Garden Townhouse Condominium', 40.8630599975586, 0.713194939397384, -111.892501831055, -1.95289256524569, 218, 52, 'PPL', 'P'),
(43243, 'Summer Grove', 32.4022216796875, 0.565525453271634, -93.8144378662109, -1.63737082667302, 218, 22, 'PPL', 'P'),
(129028, 'Summer Harbor', 44.4155616760254, 0.775197790369254, -68.1063919067383, -1.1886807804262, 218, 26, 'PPL', 'P'),
(18212, 'Summer Haven', 29.6988906860352, 0.518343426661191, -81.2236099243164, -1.41761942353486, 218, 12, 'PPL', 'P'),
(91127, 'Summer Haven', 35.1605606079102, 0.613667549455051, -85.0863876342773, -1.48503761284633, 218, 50, 'PPL', 'P'),
(126286, 'Summer Heights', 42.1791687011719, 0.736165369589589, -71.147216796875, -1.24175318673568, 218, 23, 'PPL', 'P'),
(14687, 'Summer Hill', 39.6480598449707, 0.691989186322491, -75.6927795410156, -1.32108822297693, 218, 10, 'PPL', 'P'),
(28726, 'Summer Hill', 39.5463905334473, 0.690214722088171, -90.9191665649414, -1.58683880972737, 218, 18, 'PPL', 'P'),
(51797, 'Summer Hill', 39.4333305358887, 0.688241452878477, -76.5344390869141, -1.33577795323369, 218, 25, 'PPL', 'P'),
(83889, 'Summer Hill', 33.5058288574219, 0.584787032171741, -81.954719543457, -1.43037969358187, 218, 48, 'PPL', 'P'),
(152995, 'Summer Hill', 42.6388893127441, 0.744189007900807, -76.3261108398438, -1.33214193939741, 218, 40, 'PPL', 'P'),
(167731, 'Summer Hill', 41.0922203063965, 0.717194541301492, -76.2547225952148, -1.33089597948141, 218, 45, 'PPL', 'P'),
(51798, 'Summer Hill Trailer Park', 39.0077781677246, 0.680814162914355, -76.5911102294922, -1.33676705126255, 218, 25, 'PPL', 'P'),
(51799, 'Summer Hills', 39.5833282470703, 0.690859406809052, -76.9077835083008, -1.34229404263084, 218, 25, 'PPL', 'P'),
(91128, 'Summer Hills', 36.4736099243164, 0.636584583267401, -82.5152816772461, -1.44016334847849, 218, 50, 'PPL', 'P'),
(185437, 'Summer Home', 37.8474998474121, 0.660563485985393, -121.184722900391, -2.11507241772879, 218, 6, 'PPL', 'P'),
(201606, 'Summer Lake', 42.9730606079102, 0.750021397267108, -120.776390075684, -2.10794566549368, 218, 43, 'PPL', 'P'),
(179237, 'Summer Mesa', 33.401668548584, 0.582969091832626, -111.748893737793, -1.95038613118576, 218, 5, 'PPL', 'P'),
(205948, 'Summer Oaks', 40.6061096191406, 0.708710309279745, -111.793060302734, -1.95115698316328, 218, 52, 'PPL', 'P'),
(205949, 'Summer Oaks Twin Homes', 40.6058311462402, 0.708705449010755, -111.847221374512, -1.95210227219221, 218, 52, 'PPL', 'P'),
(25215, 'Summer Place', 33.7999992370605, 0.589921273858278, -84.0119400024414, -1.46628496403054, 218, 13, 'PPL', 'P'),
(83890, 'Summer Place', 34.5827789306641, 0.603583356829412, -82.6755599975586, -1.44296073288751, 218, 48, 'PPL', 'P'),
(179238, 'Summer Place Trails', 33.3958282470703, 0.582867159341903, -111.781936645508, -1.95096283871982, 218, 5, 'PPL', 'P'),
(179239, 'Summer Place Village', 33.4000015258789, 0.582939996797717, -111.784172058105, -1.95100185402979, 218, 5, 'PPL', 'P'),
(25216, 'Summer Point', 34.3052787780762, 0.598740065491966, -83.9158325195313, -1.46460757201795, 218, 13, 'PPL', 'P'),
(38437, 'Summer Shade', 36.8841705322266, 0.643750217654423, -85.7024993896484, -1.4957907915378, 218, 21, 'PPL', 'P'),
(83891, 'Summer View', 33.9127807617188, 0.591889682798983, -80.4138870239258, -1.40348709289425, 218, 48, 'PPL', 'P'),
(205950, 'Summer Wood', 41.0125007629395, 0.71580317278998, -111.904167175293, -1.95309616391102, 218, 52, 'PPL', 'P'),
(6147, 'Summerdale', 30.4874992370605, 0.532107242385966, -87.6997222900391, -1.53064890704584, 218, 2, 'PPL', 'P'),
(152996, 'Summerdale', 42.2138900756836, 0.736771371895637, -79.570556640625, -1.38876820102354, 218, 40, 'PPL', 'P'),
(167733, 'Summerdale', 40.3088912963867, 0.703522870950434, -76.9277801513672, -1.3426430498917, 218, 45, 'PPL', 'P'),
(106703, 'Summerdean', 37.3463897705078, 0.651817465228491, -79.9444427490234, -1.39529374464257, 218, 53, 'PPL', 'P'),
(106704, 'Summerdean Gardens', 37.3416709899902, 0.65173510697178, -79.9352798461914, -1.39513382181911, 218, 53, 'PPL', 'P'),
(6148, 'Summerfield', 32.5205612182617, 0.567590867855045, -87.0416717529297, -1.51916375852877, 218, 2, 'PPL', 'P'),
(18213, 'Summerfield', 29.0083293914795, 0.50629085838436, -82.0350036621094, -1.43178091578941, 218, 12, 'PPL', 'P'),
(28727, 'Summerfield', 38.5972213745117, 0.673648595106361, -89.7516708374023, -1.56646216527885, 218, 18, 'PPL', 'P'),
(34076, 'Summerfield', 39.9972190856934, 0.698083164686865, -96.3499984741211, -1.68162470766493, 218, 20, 'PPL', 'P'),
(43246, 'Summerfield', 31.579719543457, 0.551170082889726, -92.7213897705078, -1.61829353852035, 218, 22, 'PPL', 'P'),
(51800, 'Summerfield', 39.1319389343262, 0.682981177093353, -76.5147171020508, -1.3354337396628, 218, 25, 'PPL', 'P'),
(57780, 'Summerfield', 38.2836112976074, 0.668175066696948, -91.8047180175781, -1.6022945982717, 218, 29, 'PPL', 'P'),
(69202, 'Summerfield', 35.5680618286133, 0.620779787462217, -77.4030609130859, -1.35093826405508, 218, 33, 'PPL', 'P'),
(74462, 'Summerfield', 39.7966690063477, 0.694582905487147, -81.3361129760742, -1.41958297220658, 218, 41, 'PPL', 'P'),
(77374, 'Summerfield', 34.898609161377, 0.609095634232685, -94.8658294677734, -1.65572107184811, 218, 42, 'PPL', 'P'),
(91130, 'Summerfield', 35.2536087036133, 0.615291545087782, -85.7991714477539, -1.49747803724642, 218, 50, 'PPL', 'P'),
(106705, 'Summerfield', 38.0944404602051, 0.664873412735522, -78.9738922119141, -1.37835444221301, 218, 53, 'PPL', 'P'),
(146417, 'Summerfield', 40.7874984741211, 0.711876142025576, -75.043327331543, -1.30975314358728, 218, 37, 'PPL', 'P'),
(192286, 'Summerfield', 34.7380599975586, 0.606293522712731, -102.50666809082, -1.78907886343382, 218, 51, 'PPL', 'P'),
(51801, 'Summerfield (historical)', 39.4352798461914, 0.688275474761403, -76.5202789306641, -1.33553081188453, 218, 25, 'PPL', 'P'),
(51802, 'Summerfield Farms', 39.4316711425781, 0.688212491001623, -76.5288925170898, -1.33568114732807, 218, 25, 'PPL', 'P'),
(74463, 'Summerford', 39.9333305358887, 0.696968099138449, -83.4916687011719, -1.45720451681975, 218, 41, 'PPL', 'P'),
(69205, 'Summerhaven', 35.6380615234375, 0.622001512612291, -82.3916702270508, -1.43800592167942, 218, 33, 'PPL', 'P'),
(129029, 'Summerhaven', 44.3899993896484, 0.774751644307639, -69.811393737793, -1.21843867613064, 218, 26, 'PPL', 'P'),
(179240, 'Summerhaven', 32.4386100769043, 0.566160550612591, -110.759170532227, -1.93311220256523, 218, 5, 'PPL', 'P'),
(167735, 'Summerhill', 40.378059387207, 0.704730081872567, -78.7608337402344, -1.37463587038293, 218, 45, 'PPL', 'P'),
(185438, 'Summerhome Park', 38.4966697692871, 0.671893638527026, -122.938331604004, -2.14567866339847, 218, 6, 'PPL', 'P'),
(208853, 'Summerhurst', 47.3472213745117, 0.826364904655865, -122.451667785645, -2.13718477741777, 218, 56, 'PPL', 'P'),
(61923, 'Summerland', 31.7991695404053, 0.555000207879964, -89.3602828979492, -1.55963115708279, 218, 30, 'PPL', 'P'),
(185439, 'Summerland', 34.4213905334473, 0.600766597923462, -119.595558166504, -2.08733626076589, 218, 6, 'PPL', 'P'),
(74464, 'Summerland Beach', 39.9000015258789, 0.696386398177348, -82.5250015258789, -1.44033299183993, 218, 41, 'PPL', 'P'),
(18214, 'Summerland Key', 24.6652793884277, 0.430490336252357, -81.442497253418, -1.42143972811858, 218, 12, 'PPL', 'P'),
(111594, 'Summerlee', 38.0027809143066, 0.663273651868712, -81.1602783203125, -1.41651407852443, 218, 58, 'PPL', 'P'),
(69206, 'Summerlins Crossroads', 35.084171295166, 0.61233430443433, -77.9577789306641, -1.36061991988195, 218, 33, 'PPL', 'P'),
(179241, 'Summerplace Green', 33.396671295166, 0.582881873306926, -111.775001525879, -1.95084179804827, 218, 5, 'PPL', 'P'),
(18215, 'Summerport Beach', 28.4899997711182, 0.497244299898443, -81.5647201538086, -1.42357292015174, 218, 12, 'PPL', 'P'),
(12200, 'Summers', 35.9811096191406, 0.627988831375007, -94.4913864135742, -1.64918580769111, 218, 4, 'PPL', 'P'),
(51803, 'Summers', 39.4888916015625, 0.689211176410402, -77.584716796875, -1.35410875733282, 218, 25, 'PPL', 'P'),
(111592, 'Summers', 39.1575012207031, 0.683427323154968, -80.8288879394531, -1.41073022526899, 218, 58, 'PPL', 'P'),
(185440, 'Summers (historical)', 35.5327796936035, 0.620163998039163, -120.080558776855, -2.0958011182907, 218, 6, 'PPL', 'P'),
(51804, 'Summerseat', 38.396671295166, 0.670148335906642, -76.6624984741211, -1.33801301117854, 218, 25, 'PPL', 'P'),
(51805, 'Summerseat Village', 38.3983306884766, 0.670177297783497, -76.6580581665039, -1.33793551319082, 218, 25, 'PPL', 'P'),
(117937, 'Summerset', 41.4313888549805, 0.723114149193493, -93.5447235107422, -1.6326634231302, 218, 16, 'PPL', 'P'),
(83895, 'Summerset Acres', 33.0311088562012, 0.576501605125369, -80.2774963378906, -1.40110662635388, 218, 48, 'PPL', 'P'),
(117938, 'Summerset Junction (historical)', 41.4444389343262, 0.723341916045722, -93.5441665649414, -1.63265370259222, 218, 16, 'PPL', 'P'),
(74465, 'Summerside', 39.1047210693359, 0.68250613573391, -84.288330078125, -1.47110888087105, 218, 41, 'PPL', 'P'),
(74466, 'Summerside Estates', 39.1227798461914, 0.682821320848921, -84.2847213745117, -1.47104589711127, 218, 41, 'PPL', 'P'),
(28728, 'Summersville', 38.3277816772461, 0.668945985253499, -88.866943359375, -1.5510207578044, 218, 18, 'PPL', 'P'),
(38438, 'Summersville', 37.3261108398438, 0.651463531119619, -85.5444412231445, -1.49303215612264, 218, 21, 'PPL', 'P'),
(57782, 'Summersville', 37.1791687011719, 0.648898906989873, -91.6566696166992, -1.59971066622405, 218, 29, 'PPL', 'P'),
(91131, 'Summersville', 36.4647216796875, 0.636429454133904, -82.5308303833008, -1.44043472459357, 218, 50, 'PPL', 'P'),
(111600, 'Summersville', 38.2811088562012, 0.668131390855071, -80.852783203125, -1.4111472762957, 218, 58, 'PPL', 'P'),
(157859, 'Summersville', 40.4000015258789, 0.70511304443732, -83.4111099243164, -1.45579850092224, 218, 41, 'PPL', 'P'),
(69208, 'Summertime', 35.065559387207, 0.612009465360368, -78.9361114501953, -1.3776950435271, 218, 33, 'PPL', 'P'),
(83896, 'Summerton', 33.6080589294434, 0.586571283523067, -80.3513870239258, -1.40239626211175, 218, 48, 'PPL', 'P'),
(133310, 'Summerton', 43.4663887023926, 0.758631596808416, -84.7261123657227, -1.47874962319654, 218, 27, 'PPL', 'P'),
(25219, 'Summertown', 32.7458305358887, 0.571522559151357, -82.2763900756836, -1.43599390347587, 218, 13, 'PPL', 'P'),
(91133, 'Summertown', 35.4347190856934, 0.618452517564624, -87.3127822875977, -1.52389552999557, 218, 50, 'PPL', 'P'),
(193985, 'Summertown', 40.5444412231445, 0.707633992725189, -121.566390991211, -2.1217337825634, 218, 6, 'PPL', 'P'),
(6150, 'Summerville', 30.7452793121338, 0.536606353442032, -88.0766677856445, -1.53722784704472, 218, 2, 'PPL', 'P'),
(12201, 'Summerville', 33.5202789306641, 0.585039233526972, -92.3555603027344, -1.61190860980689, 218, 4, 'PPL', 'P'),
(25222, 'Summerville', 33.4741706848145, 0.584234492824577, -82.0186080932617, -1.43149475913029, 218, 13, 'PPL', 'P'),
(28729, 'Summerville', 39.1888885498047, 0.683975135391198, -90.1236114501953, -1.57295375359397, 218, 18, 'PPL', 'P'),
(43247, 'Summerville', 31.7552795410156, 0.554234182881916, -92.1622161865234, -1.60853411838965, 218, 22, 'PPL', 'P'),
(83898, 'Summerville', 34.2088890075684, 0.597057746631363, -81.3097229003906, -1.41912237849605, 218, 48, 'PPL', 'P'),
(98355, 'Summerville', 29.4549999237061, 0.514086729843349, -97.4702835083008, -1.70117737007218, 218, 51, 'PPL', 'P'),
(152998, 'Summerville', 43.2563896179199, 0.754966421358195, -77.6013870239258, -1.35439970768191, 218, 40, 'PPL', 'P'),
(167738, 'Summerville', 41.1161117553711, 0.717611525749171, -79.1869430541992, -1.38207288088503, 218, 45, 'PPL', 'P'),
(193986, 'Summerville', 41.0988883972168, 0.717310921441128, -123.066673278809, -2.14791864819134, 218, 6, 'PPL', 'P'),
(194440, 'Summerville', 40.0569381713867, 0.699125459358495, -105.393890380859, -1.83947039863198, 218, 7, 'PPL', 'P'),
(201607, 'Summerville', 45.4886093139648, 0.793926004682046, -118.001937866211, -2.05952233949915, 218, 43, 'PPL', 'P'),
(202666, 'Summerville', 45.7738914489746, 0.798905117235085, -102.176940917969, -1.78332403863427, 218, 49, 'PPL', 'P'),
(51806, 'Summerville (historical)', 38.3325004577637, 0.66902834351021, -76.4805603027344, -1.33483759105279, 218, 25, 'PPL', 'P'),
(57783, 'Summerville (historical)', 38.8605613708496, 0.678244745094647, -92.2108306884766, -1.60938260151295, 218, 29, 'PPL', 'P'),
(61925, 'Summerville (historical)', 32.9438896179199, 0.574979342246279, -88.7352828979492, -1.54872284925783, 218, 30, 'PPL', 'P'),
(193987, 'Summerville (historical)', 40.1958312988281, 0.70154960174074, -121.680282592773, -2.12372156600104, 218, 6, 'PPL', 'P'),
(83899, 'Summerville Farms', 32.9736099243164, 0.5754980594476, -80.2158279418945, -1.40003030979933, 218, 48, 'PPL', 'P'),
(83900, 'Summerville Place', 32.9861106872559, 0.575716238919904, -80.1416702270508, -1.39873601350955, 218, 48, 'PPL', 'P'),
(83901, 'Summerwood', 32.9713897705078, 0.575459310453739, -80.1388931274414, -1.39868754397771, 218, 48, 'PPL', 'P'),
(205957, 'Summerwood', 40.6352806091309, 0.70921943910114, -111.951667785645, -1.95392520595837, 218, 52, 'PPL', 'P'),
(98356, 'Summerwood Colonia', 26.3540000915527, 0.459964072668482, -98.1210021972656, -1.71253455369888, 218, 51, 'PPL', 'P'),
(205958, 'Summerwood Estates', 40.649169921875, 0.709461853339365, -111.94416809082, -1.95379431159079, 218, 52, 'PPL', 'P'),
(91134, 'Summey Subdivision', 36.1527786254883, 0.6309850207594, -82.79638671875, -1.44506955699669, 218, 50, 'PPL', 'P'),
(6151, 'Summit', 34.2044410705566, 0.596980115485587, -86.4941711425781, -1.50960807022145, 218, 2, 'PPL', 'P'),
(12202, 'Summit', 36.2522201538086, 0.632720602841805, -92.690559387207, -1.6177554468221, 218, 4, 'PPL', 'P'),
(34078, 'Summit', 39.8972206115723, 0.696337862066482, -96.3472213745117, -1.68157623813309, 218, 20, 'PPL', 'P'),
(38441, 'Summit', 38.0366706848145, 0.663865139946819, -82.5905609130859, -1.44147721900228, 218, 21, 'PPL', 'P'),
(43248, 'Summit', 32.3980598449707, 0.565452815552902, -92.1766662597656, -1.60878631974488, 218, 22, 'PPL', 'P'),
(51869, 'Summit', 38.702220916748, 0.675481182831472, -76.5597229003906, -1.33621923902632, 218, 25, 'PPL', 'P'),
(57784, 'Summit', 37.9119415283203, 0.661688205492761, -90.7080612182617, -1.58315432635925, 218, 29, 'PPL', 'P'),
(61927, 'Summit', 31.2836093902588, 0.546001985767832, -90.4683303833008, -1.57897023397062, 218, 30, 'PPL', 'P'),
(77375, 'Summit', 35.665828704834, 0.622486141351658, -95.4225006103516, -1.66543681613693, 218, 42, 'PPL', 'P'),
(83903, 'Summit', 33.9247207641602, 0.592098075154281, -81.4222183227539, -1.42108579400971, 218, 48, 'PPL', 'P'),
(91135, 'Summit', 35.0697212219238, 0.6120821030791, -85.100830078125, -1.4852896810435, 218, 50, 'PPL', 'P'),
(106707, 'Summit', 36.892219543457, 0.643890699401924, -81.3008270263672, -1.4189671162045, 218, 53, 'PPL', 'P'),
(111597, 'Summit', 39.3544387817383, 0.686864532015879, -81.5119400024414, -1.42265173273068, 218, 58, 'PPL', 'P'),
(117942, 'Summit', 41.5086097717285, 0.724461908442155, -91.022216796875, -1.58863737556956, 218, 16, 'PPL', 'P'),
(121619, 'Summit', 41.7880592346191, 0.729339221662526, -87.8102798461914, -1.53257850041366, 218, 18, 'PPL', 'P'),
(123756, 'Summit', 40.4166717529297, 0.705403994786411, -86.9291687011719, -1.51720020985705, 218, 19, 'PPL', 'P'),
(126287, 'Summit', 42.3333282470703, 0.738855961238897, -71.7916717529297, -1.25300104759963, 218, 23, 'PPL', 'P'),
(138337, 'Summit', 43.9208297729492, 0.766563089745917, -93.1852798461914, -1.62638994770836, 218, 28, 'PPL', 'P'),
(146418, 'Summit', 40.7413902282715, 0.711071401323182, -74.3600006103516, -1.29782684243563, 218, 37, 'PPL', 'P'),
(152999, 'Summit', 42.5794410705566, 0.743151440340113, -74.5886077880859, -1.30181679038078, 218, 40, 'PPL', 'P'),
(157860, 'Summit', 41.1438903808594, 0.71809635422562, -80.7225036621094, -1.40887346935699, 218, 41, 'PPL', 'P'),
(167740, 'Summit', 41.9427795410156, 0.732039600428839, -78.5319366455078, -1.3706408624317, 218, 45, 'PPL', 'P'),
(171393, 'Summit', 45.3044395446777, 0.790711635825347, -97.0361099243164, -1.69359961150647, 218, 49, 'PPL', 'P'),
(172618, 'Summit', 44.6894416809082, 0.779977898209837, -72.0569381713867, -1.25763081999668, 218, 55, 'PPL', 'P'),
(179242, 'Summit', 32.0669403076172, 0.559673689408403, -110.950828552246, -1.93645726605243, 218, 5, 'PPL', 'P'),
(185443, 'Summit', 35.1277809143066, 0.613095435873875, -118.413063049316, -2.06669782758221, 218, 6, 'PPL', 'P'),
(192808, 'Summit', 37.8011093139648, 0.659753818434981, -112.935562133789, -1.97109740182525, 218, 52, 'PPL', 'P'),
(197649, 'Summit', 45.2188911437988, 0.789218534560194, -111.930000305176, -1.95354703708358, 218, 31, 'PPL', 'P'),
(201608, 'Summit', 44.6380615234375, 0.77908114529178, -123.577499389648, -2.15683424573065, 218, 43, 'PPL', 'P'),
(208855, 'Summit', 47.3613891601563, 0.826612179163079, -122.019172668457, -2.12963631362405, 218, 56, 'PPL', 'P'),
(212170, 'Summit', 63.3313903808594, 1.10534128201186, -149.122222900391, -2.6026737775047, 218, 1, 'PPL', 'P'),
(12204, 'Summit (historical)', 36.0652809143066, 0.629457897611322, -94.0886077880859, -1.64215599451968, 218, 4, 'PPL', 'P'),
(25224, 'Summit (historical)', 34.3083305358887, 0.598793328713768, -84.9375, -1.48243903341268, 218, 13, 'PPL', 'P'),
(117943, 'Summit (historical)', 40.6652793884277, 0.70974301657145, -91.3349990844727, -1.59409645633005, 218, 16, 'PPL', 'P'),
(157861, 'Summit (historical)', 40.8055610656738, 0.712191393719614, -81.646110534668, -1.42499345027718, 218, 41, 'PPL', 'P'),
(185444, 'Summit (historical)', 35.0677795410156, 0.612048214354229, -120.511108398438, -2.10331562678053, 218, 6, 'PPL', 'P'),
(200225, 'Summit (historical)', 41.2252807617188, 0.719516884351068, -116.8125, -2.03876273248588, 218, 39, 'PPL', 'P'),
(157862, 'Summit Beach Park', 41.0541687011719, 0.716530415504653, -81.5416717529297, -1.42317064966908, 218, 41, 'PPL', 'P'),
(14688, 'Summit Bridge', 39.5352783203125, 0.690020777381786, -75.7263870239258, -1.32167478420701, 218, 10, 'PPL', 'P'),
(123765, 'Summit Chapel', 41.2452812194824, 0.71986595819095, -86.084716796875, -1.50246174375234, 218, 19, 'PPL', 'P'),
(25225, 'Summit Chase', 33.8569412231445, 0.590915098998068, -83.9694366455078, -1.46554314050889, 218, 13, 'PPL', 'P'),
(51809, 'Summit Chase', 39.3858299255371, 0.687412410831136, -76.6777801513672, -1.33827972676171, 218, 25, 'PPL', 'P'),
(57785, 'Summit City', 36.7391700744629, 0.641219482249548, -92.6136093139648, -1.61641241468437, 218, 29, 'PPL', 'P'),
(133311, 'Summit City', 44.5508308410645, 0.777558682675609, -85.5149993896484, -1.49251829919031, 218, 27, 'PPL', 'P'),
(193988, 'Summit City (historical)', 40.6861114501953, 0.710106604639273, -122.40055847168, -2.13629275161065, 218, 6, 'PPL', 'P'),
(176598, 'Summit Corners', 43.0766716003418, 0.751829750226299, -88.4700012207031, -1.54409281054467, 218, 57, 'PPL', 'P'),
(153004, 'Summit Crossing', 42.6816711425781, 0.744935691691438, -75.024169921875, -1.30941878371242, 218, 40, 'PPL', 'P'),
(71452, 'Summit East', 39.9777793884277, 0.697743877963989, -74.2444381713867, -1.29580989738406, 218, 37, 'PPL', 'P'),
(6152, 'Summit Farm', 33.3011093139648, 0.581214002095237, -86.9833297729492, -1.51814549888598, 218, 2, 'PPL', 'P'),
(25226, 'Summit Grove', 33.8800010681152, 0.591317569217806, -83.4047164916992, -1.45568691447257, 218, 13, 'PPL', 'P'),
(31258, 'Summit Grove', 39.7244415283203, 0.693322298185158, -87.3891677856445, -1.52522870843726, 218, 19, 'PPL', 'P'),
(126288, 'Summit Grove', 41.6375007629395, 0.726711480614944, -70.9972229003906, -1.23913529938413, 218, 23, 'PPL', 'P'),
(25227, 'Summit Hill', 34.957218170166, 0.610118554407384, -85.1552810668945, -1.4862400300785, 218, 13, 'PPL', 'P'),
(153000, 'Summit Hill', 42.0588912963867, 0.734066132860335, -75.916389465332, -1.32499095239638, 218, 40, 'PPL', 'P'),
(167741, 'Summit Hill', 40.8247184753418, 0.712525753594474, -75.8713912963867, -1.32420558619092, 218, 45, 'PPL', 'P'),
(106708, 'Summit Hills', 37.2938919067383, 0.650901204655449, -80.0102767944336, -1.39644276549488, 218, 53, 'PPL', 'P'),
(38442, 'Summit Hills Heights', 39.0061111450195, 0.680785067879446, -84.5530624389648, -1.47572933220428, 218, 21, 'PPL', 'P'),
(176599, 'Summit Lake', 45.3777809143066, 0.791991684203294, -89.1947174072266, -1.556741494142, 218, 57, 'PPL', 'P'),
(167744, 'Summit Lawn', 40.5591697692871, 0.707891054349409, -75.4338912963867, -1.31656977071344, 218, 45, 'PPL', 'P'),
(79234, 'Summit Mills', 39.8088912963867, 0.694796224690462, -79.0758285522461, -1.38013356697924, 218, 45, 'PPL', 'P'),
(138339, 'Summit Mobile Home Park', 44.3458290100098, 0.773980725751088, -93.9661102294922, -1.64001800879656, 218, 28, 'PPL', 'P'),
(51810, 'Summit Park', 39.3788909912109, 0.687291303580564, -76.6816711425781, -1.33834763736951, 218, 25, 'PPL', 'P'),
(111598, 'Summit Park', 39.2816696166992, 0.68559447049202, -80.3105621337891, -1.4016837333621, 218, 58, 'PPL', 'P'),
(153001, 'Summit Park', 41.1563911437988, 0.718314533697925, -74.0438919067383, -1.29230970476337, 218, 40, 'PPL', 'P'),
(205960, 'Summit Park', 40.7458305358887, 0.711148899310903, -111.610832214355, -1.94797650303146, 218, 52, 'PPL', 'P'),
(111599, 'Summit Point', 39.249439239502, 0.685031944290768, -77.9588928222656, -1.36063936095791, 218, 58, 'PPL', 'P'),
(25228, 'Summit Ridge', 33.7763900756836, 0.589509216258615, -84.5702819824219, -1.4760298699333, 218, 13, 'PPL', 'P'),
(74469, 'Summit Station', 39.996940612793, 0.698078304417876, -82.7522201538086, -1.44429870501917, 218, 41, 'PPL', 'P'),
(167745, 'Summit Station', 40.5638885498047, 0.70797341260612, -76.204719543457, -1.3300232615922, 218, 45, 'PPL', 'P'),
(185446, 'Summit Terrace', 34.3452796936035, 0.599438213171731, -117.420829772949, -2.04938008996175, 218, 6, 'PPL', 'P'),
(197650, 'Summit Valley', 45.7705612182617, 0.798846993744294, -111.891670227051, -1.95287805101775, 218, 31, 'PPL', 'P'),
(14689, 'Summit View', 39.6472206115723, 0.691974538936496, -75.772216796875, -1.32247466464042, 218, 10, 'PPL', 'P'),
(117944, 'Summit View Mobile Home Park', 41.9527816772461, 0.732214170638293, -91.7305603027344, -1.60100030198192, 218, 16, 'PPL', 'P'),
(129030, 'Summit View Park (historical)', 43.7169418334961, 0.763004573897354, -70.2916717529297, -1.22682110881972, 218, 26, 'PPL', 'P'),
(185447, 'Summit Village', 38.7272186279297, 0.675917475197054, -121.095001220703, -2.11350647900782, 218, 6, 'PPL', 'P'),
(190798, 'Summit Village', 38.9702796936035, 0.680159691076468, -119.886672973633, -2.09241717265159, 218, 39, 'PPL', 'P'),
(117945, 'Summit Village Dyersville Park', 42.4844398498535, 0.741493356245429, -91.1149978637695, -1.59025671067038, 218, 16, 'PPL', 'P'),
(74471, 'Summithill', 39.2180595397949, 0.684484265212594, -83.1133270263672, -1.4506012088969, 218, 41, 'PPL', 'P'),
(208856, 'Summitview', 46.5966682434082, 0.813265281306956, -120.640830993652, -2.10557971318126, 218, 56, 'PPL', 'P'),
(91138, 'Summitville', 35.559440612793, 0.620629318860627, -85.9925003051758, -1.50085226234755, 218, 50, 'PPL', 'P'),
(117950, 'Summitville', 40.4727783203125, 0.706383239119233, -91.4486083984375, -1.59607931291967, 218, 16, 'PPL', 'P'),
(123758, 'Summitville', 40.3386116027832, 0.704041588151754, -85.6444396972656, -1.49477745874302, 218, 19, 'PPL', 'P'),
(153003, 'Summitville', 41.6213912963867, 0.726430317382859, -74.4511108398438, -1.29941701592251, 218, 40, 'PPL', 'P'),
(157864, 'Summitville', 40.6780586242676, 0.709966056312744, -80.8863906860352, -1.41173383752579, 218, 41, 'PPL', 'P'),
(187417, 'Summitville', 37.4305610656738, 0.653286531464806, -106.591667175293, -1.86037554739883, 218, 7, 'PPL', 'P'),
(157865, 'Summitville (historical)', 40.1611099243164, 0.700943599434692, -84.3272171020508, -1.47178758747486, 218, 41, 'PPL', 'P'),
(121620, 'Summum', 40.2677803039551, 0.702805348773739, -90.2783279418945, -1.57565406578126, 218, 18, 'PPL', 'P'),
(18216, 'Sumner', 29.2166690826416, 0.509927071957727, -82.9677810668945, -1.44806095269112, 218, 12, 'PPL', 'P'),
(25229, 'Sumner', 31.5127792358398, 0.550001754119508, -83.7386093139648, -1.46151444356988, 218, 13, 'PPL', 'P'),
(28732, 'Sumner', 38.7169418334961, 0.675738111297637, -87.8613891601563, -1.53347052622078, 218, 18, 'PPL', 'P'),
(51811, 'Sumner', 38.9552803039551, 0.679897902341314, -77.1152801513672, -1.34591554223919, 218, 25, 'PPL', 'P'),
(57788, 'Sumner', 39.6525001525879, 0.692066684310213, -93.2444381713867, -1.62742245526298, 218, 29, 'PPL', 'P'),
(61928, 'Sumner', 33.9708290100098, 0.592902815856676, -90.3686065673828, -1.5772297250402, 218, 30, 'PPL', 'P'),
(74472, 'Sumner', 39.1391716003418, 0.683107410929023, -81.9266662597656, -1.42989007141546, 218, 41, 'PPL', 'P'),
(77376, 'Sumner', 36.3188896179199, 0.633884204501088, -97.1211090087891, -1.6950831253917, 218, 42, 'PPL', 'P'),
(98357, 'Sumner', 33.7402801513672, 0.588878979186648, -95.6727828979492, -1.66980506611494, 218, 51, 'PPL', 'P'),
(117951, 'Sumner', 42.8474998474121, 0.747829948585109, -92.0913925170898, -1.60729801216969, 218, 16, 'PPL', 'P'),
(129031, 'Sumner', 44.3919410705566, 0.77478553303251, -70.4388885498047, -1.22939052663943, 218, 26, 'PPL', 'P'),
(133314, 'Sumner', 43.3069381713867, 0.755848660048311, -84.8158264160156, -1.48031542875945, 218, 27, 'PPL', 'P'),
(143143, 'Sumner', 40.9500007629395, 0.714712342007483, -99.504997253418, -1.73668982426006, 218, 35, 'PPL', 'P'),
(176604, 'Sumner', 45.3863906860352, 0.792141953067801, -91.6522216796875, -1.59963303507827, 218, 57, 'PPL', 'P'),
(197651, 'Sumner', 48.7797203063965, 0.851366727548556, -108.103607177734, -1.88676387853404, 218, 31, 'PPL', 'P'),
(201609, 'Sumner', 43.2819404602051, 0.755412367682728, -124.149719238281, -2.16682136613455, 218, 43, 'PPL', 'P'),
(208857, 'Sumner', 47.2033309936523, 0.82385354374792, -122.239166259766, -2.13347592612567, 218, 56, 'PPL', 'P'),
(185450, 'Sumner Hill', 36.9555587768555, 0.644996177570416, -119.749168395996, -2.09001726503527, 218, 6, 'PPL', 'P'),
(69214, 'Sumnersville (historical)', 36.5319404602051, 0.637602643173111, -76.6408309936523, -1.33763484230375, 218, 33, 'PPL', 'P'),
(34087, 'Sumnerville', 39.1974983215332, 0.684125404255705, -97.7361068725586, -1.70581686300721, 218, 20, 'PPL', 'P'),
(133316, 'Sumnerville', 41.9116706848145, 0.731496648461599, -86.2074966430664, -1.50460465632347, 218, 27, 'PPL', 'P'),
(167750, 'Sumneytown', 40.3288917541504, 0.703871944790316, -75.4513931274414, -1.31687523529047, 218, 45, 'PPL', 'P'),
(51812, 'Sumor Estates', 39.4805603027344, 0.689065767814884, -76.9322204589844, -1.34272054787942, 218, 25, 'PPL', 'P'),
(12208, 'Sumpter', 33.4855613708496, 0.584433297799952, -92.0491714477539, -1.60656111549606, 218, 4, 'PPL', 'P'),
(38443, 'Sumpter', 36.7608299255371, 0.641597517966285, -84.8466720581055, -1.48085378677381, 218, 21, 'PPL', 'P'),
(77378, 'Sumpter', 36.8836097717285, 0.643740430537417, -97.2941665649414, -1.69810354954201, 218, 42, 'PPL', 'P'),
(201610, 'Sumpter', 44.7458305358887, 0.780962069390676, -118.201110839844, -2.06299856367003, 218, 43, 'PPL', 'P'),
(43249, 'Sumpter (historical)', 32.5813903808594, 0.568652537023605, -92.5830612182617, -1.61587924983414, 218, 22, 'PPL', 'P'),
(91140, 'Sumpter (historical)', 36.4972190856934, 0.636996640867064, -82.2938919067383, -1.4362993680529, 218, 50, 'PPL', 'P'),
(98358, 'Sumpter (historical)', 31.0362796783447, 0.541685267956922, -95.0535736083984, -1.65899782525334, 218, 51, 'PPL', 'P'),
(25230, 'Sumpter Ridge', 34.0886116027832, 0.594958509902108, -84.5697174072266, -1.47602001623727, 218, 13, 'PPL', 'P'),
(61930, 'Sumrall', 31.9069404602051, 0.556881165268373, -88.7125015258789, -1.54832523930708, 218, 30, 'PPL', 'P'),
(6154, 'Sumter', 33.353328704834, 0.582125402399289, -87.1277770996094, -1.5206665803319, 218, 2, 'PPL', 'P'),
(25231, 'Sumter', 31.9491691589355, 0.557618195100053, -84.254997253418, -1.47052711333092, 218, 13, 'PPL', 'P'),
(83904, 'Sumter', 33.920280456543, 0.59202057716656, -80.341667175293, -1.40222661875031, 218, 48, 'PPL', 'P'),
(138343, 'Sumter', 44.7394409179688, 0.780850549520029, -94.2630615234375, -1.64520078659397, 218, 28, 'PPL', 'P'),
(143144, 'Sumter', 41.5894393920898, 0.725872651450597, -98.7880630493164, -1.72417696187832, 218, 35, 'PPL', 'P'),
(91141, 'Sumter Hills', 36.1277809143066, 0.630548728393818, -83.9319381713867, -1.46488866867101, 218, 50, 'PPL', 'P'),
(83906, 'Sumter Junction', 33.8352813720703, 0.590537063281331, -80.5661087036133, -1.40614386239771, 218, 48, 'PPL', 'P'),
(6156, 'Sumterville', 32.711669921875, 0.570926343962315, -88.2388916015625, -1.54005918675764, 218, 2, 'PPL', 'P'),
(18218, 'Sumterville', 28.7447204589844, 0.501690014574653, -82.063606262207, -1.43228012533575, 218, 12, 'PPL', 'P'),
(133, 'Sun', 36.9416694641113, 0.644753763332192, -82.2858276367188, -1.43615861998929, 218, 53, 'PPL', 'P'),
(596, 'Sun', 30.648889541626, 0.534924034581429, -89.8925018310547, -1.56892012980694, 218, 22, 'PPL', 'P'),
(61931, 'Sun', 32.2261085510254, 0.562451699320492, -89.3611068725586, -1.55964553815268, 218, 30, 'PPL', 'P'),
(69219, 'Sun', 35.6963882446289, 0.623019505938973, -77.8349990844727, -1.35847700731082, 218, 33, 'PPL', 'P'),
(111609, 'Sun', 37.9191703796387, 0.661814372749403, -81.1699981689453, -1.41668372188586, 218, 58, 'PPL', 'P'),
(153006, 'Sun', 44.9527816772461, 0.784574048198123, -74.184440612793, -1.29476274244344, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(18219, 'Sun City', 27.6780605316162, 0.483073286842995, -82.478889465332, -1.43952818455851, 218, 12, 'PPL', 'P'),
(34088, 'Sun City', 37.3786087036133, 0.652379791692661, -98.9155578613281, -1.72640216612714, 218, 20, 'PPL', 'P'),
(179243, 'Sun City', 33.5974998474121, 0.586386992775634, -112.271110534668, -1.95950053370045, 218, 5, 'PPL', 'P'),
(185448, 'Sun City', 33.709171295166, 0.588336027219408, -117.196388244629, -2.04546284631435, 218, 6, 'PPL', 'P'),
(18220, 'Sun City Center', 27.7177791595459, 0.483766507674743, -82.351936340332, -1.43731243453156, 218, 12, 'PPL', 'P'),
(179244, 'Sun City West', 33.6619415283203, 0.587511712283001, -112.340560913086, -1.9607126714706, 218, 5, 'PPL', 'P'),
(98360, 'Sun Country Estates Colonia', 28.0160007476807, 0.488971456288221, -97.6179962158203, -1.70375544316543, 218, 51, 'PPL', 'P'),
(31259, 'Sun Down', 39.725830078125, 0.693346532951077, -85.9897232055664, -1.50080379281571, 218, 19, 'PPL', 'P'),
(179245, 'Sun Grove Mobile Home Park', 33.5569381713867, 0.585679057978863, -112.279167175293, -1.959641148606, 218, 5, 'PPL', 'P'),
(98361, 'Sun Grove Park Colonia', 26.1760005950928, 0.456857395388364, -98.0879974365234, -1.71195851195509, 218, 51, 'PPL', 'P'),
(153005, 'Sun Haven', 40.9238891601563, 0.714256608565944, -73.7705612182617, -1.28753918430271, 218, 40, 'PPL', 'P'),
(25235, 'Sun Hill', 31.4511108398438, 0.548925437564952, -81.9211120605469, -1.42979313235178, 218, 13, 'PPL', 'P'),
(111601, 'Sun Hill', 37.6236114501953, 0.656655896296947, -81.7033309936523, -1.42599213568596, 218, 58, 'PPL', 'P'),
(179246, 'Sun Lakes', 33.211109161377, 0.579643203105281, -111.874717712402, -1.95258217382064, 218, 5, 'PPL', 'P'),
(18221, 'Sun N Sand Beaches', 29.9130592346191, 0.522081372988199, -84.3658294677734, -1.4724615003887, 218, 12, 'PPL', 'P'),
(176609, 'Sun Prairie', 43.1836090087891, 0.753696160097254, -89.2136077880859, -1.55707119348496, 218, 57, 'PPL', 'P'),
(197653, 'Sun Prairie', 47.8455581665039, 0.835062522459954, -107.745826721191, -1.88051943156808, 218, 31, 'PPL', 'P'),
(197654, 'Sun River', 47.5333290100098, 0.829613095658407, -111.720558166504, -1.94989158217133, 218, 31, 'PPL', 'P'),
(121623, 'Sun River Terrace', 41.1269416809082, 0.717800543607539, -87.7355575561523, -1.53127435042785, 218, 18, 'PPL', 'P'),
(51813, 'Sun Set Knoll', 39.1036109924316, 0.68248676123698, -76.5363922119141, -1.33581204169565, 218, 25, 'PPL', 'P'),
(34090, 'Sun Springs', 39.8894386291504, 0.696202040850888, -95.7033309936523, -1.67033823096517, 218, 20, 'PPL', 'P'),
(18222, 'Sun Swept Isles', 25.9738903045654, 0.453329905366499, -80.1524963378906, -1.39892496478889, 218, 12, 'PPL', 'P'),
(179247, 'Sun Tech', 33.3300018310547, 0.581718271647643, -111.863609313965, -1.95238829569328, 218, 5, 'PPL', 'P'),
(179248, 'Sun Trailer Park', 33.4516716003418, 0.583841809721845, -112.106109619141, -1.95662072445569, 218, 5, 'PPL', 'P'),
(6157, 'Sun Valley', 33.6441688537598, 0.587201520595035, -86.6988906860352, -1.51318110029796, 218, 2, 'PPL', 'P'),
(18223, 'Sun Valley', 26.5277805328369, 0.46299711354446, -80.1377792358398, -1.39866810290175, 218, 12, 'PPL', 'P'),
(25238, 'Sun Valley', 33.9338912963867, 0.592258131135795, -84.4891662597656, -1.47461413349781, 218, 13, 'PPL', 'P'),
(51815, 'Sun Valley', 39.461109161377, 0.688726281354926, -77.0722198486328, -1.34516399817957, 218, 25, 'PPL', 'P'),
(91142, 'Sun Valley', 36.1861114501953, 0.631566788299528, -85.5416717529297, -1.49298381974885, 218, 50, 'PPL', 'P'),
(98362, 'Sun Valley', 33.6644401550293, 0.587555321545852, -95.4280624389648, -1.66553388835867, 218, 51, 'PPL', 'P'),
(106716, 'Sun Valley', 38.9397201538086, 0.679626326489153, -77.2863922119141, -1.3489020110856, 218, 53, 'PPL', 'P'),
(167752, 'Sun Valley', 41.0111083984375, 0.715778871445033, -75.4700012207031, -1.31720000778541, 218, 45, 'PPL', 'P'),
(177280, 'Sun Valley', 40.4444389343262, 0.705888623525778, -80.5683288574219, -1.40618261139157, 218, 58, 'PPL', 'P'),
(179250, 'Sun Valley', 34.9805603027344, 0.610525951475139, -110.057502746582, -1.92086578945056, 218, 5, 'PPL', 'P'),
(185449, 'Sun Valley', 34.2174987792969, 0.597208015495871, -118.369438171387, -2.06593642982655, 218, 6, 'PPL', 'P'),
(189612, 'Sun Valley', 33.4122200012207, 0.583153249422005, -105.681938171387, -1.84449778097977, 218, 38, 'PPL', 'P'),
(190799, 'Sun Valley', 39.5963897705078, 0.691087373398363, -119.775001525879, -2.09046813820782, 218, 39, 'PPL', 'P'),
(195670, 'Sun Valley', 43.6972198486328, 0.762660360326461, -114.350830078125, -1.99579848725185, 218, 17, 'PPL', 'P'),
(98363, 'Sun Valley Colonia', 26.2099990844727, 0.457450780968747, -98.2710037231445, -1.71515257420848, 218, 51, 'PPL', 'P'),
(51816, 'Sun Valley Estates', 38.6377792358398, 0.674356463324104, -76.934440612793, -1.34275929687328, 218, 25, 'PPL', 'P'),
(111604, 'Sun Valley Estates', 38.4530601501465, 0.671132507087481, -81.8955612182617, -1.42934718602725, 218, 58, 'PPL', 'P'),
(98364, 'Sun Valley Estates Colonia', 26.3269996643066, 0.459492826313593, -98.3399963378906, -1.71635672249536, 218, 51, 'PPL', 'P'),
(98365, 'Sun Valley Estates Number 1 Colonia', 26.1830005645752, 0.456979567903371, -98.1370010375977, -1.71281378613917, 218, 51, 'PPL', 'P'),
(51817, 'Sun Valley Farms', 39.4625015258789, 0.688750582699873, -77.0752792358398, -1.34521739455942, 218, 25, 'PPL', 'P'),
(179251, 'Sun Valley Mobile Home Park', 33.5924987792969, 0.586299707670906, -111.985000610352, -1.95450697349849, 218, 5, 'PPL', 'P'),
(143145, 'Sun Valley Trailer Court', 40.7422218322754, 0.711085915551123, -98.8486099243164, -1.72523370419886, 218, 35, 'PPL', 'P'),
(179252, 'Sun Valley Trailer Park', 33.4647216796875, 0.584069576574074, -112.008888244629, -1.95492389136715, 218, 5, 'PPL', 'P'),
(138345, 'Sun-Bay Mobile Court and Camping', 46.3811111450195, 0.809503100214028, -92.8236083984375, -1.6200775901346, 218, 28, 'PPL', 'P'),
(18224, 'Sun-Tan Village', 25.8302803039551, 0.450823438017058, -80.2658309936523, -1.40090302768855, 218, 12, 'PPL', 'P'),
(43250, 'Suna', 30.8108291625977, 0.537750414156816, -91.8158264160156, -1.60248847639906, 218, 22, 'PPL', 'P'),
(74474, 'Sunaire', 39.0961112976074, 0.682355866869402, -84.6283264160156, -1.47704293641197, 218, 41, 'PPL', 'P'),
(144530, 'Sunapee', 43.3875007629395, 0.757254742524845, -72.0883331298828, -1.25817876539096, 218, 36, 'PPL', 'P'),
(208858, 'Sunbeach', 47.4236106872559, 0.827698149676586, -122.894172668457, -2.144907944579, 218, 56, 'PPL', 'P'),
(18225, 'Sunbeam', 30.2058296203613, 0.527191180171734, -81.5788879394531, -1.42382019465895, 218, 12, 'PPL', 'P'),
(106710, 'Sunbeam', 36.5875015258789, 0.638572366705036, -77.0280609130859, -1.3443932793601, 218, 53, 'PPL', 'P'),
(111605, 'Sunbeam', 37.8466682434082, 0.660548971757452, -81.9452819824219, -1.43021497706845, 218, 58, 'PPL', 'P'),
(121624, 'Sunbeam', 41.1272201538086, 0.717805403876529, -90.7350006103516, -1.5836245074497, 218, 18, 'PPL', 'P'),
(194441, 'Sunbeam', 40.5508308410645, 0.707745512595836, -108.195281982422, -1.88836390571696, 218, 7, 'PPL', 'P'),
(195671, 'Sunbeam', 44.271110534668, 0.772676642344303, -114.733329772949, -2.0024743663144, 218, 17, 'PPL', 'P'),
(43251, 'Sunbeam (historical)', 30.7563896179199, 0.536800264858903, -90.9219436645508, -1.58688727925921, 218, 22, 'PPL', 'P'),
(91143, 'Sunbright', 36.2433280944824, 0.632565407129281, -84.6699981689453, -1.47777024570567, 218, 50, 'PPL', 'P'),
(106711, 'Sunbright', 36.7299995422363, 0.641059426268034, -82.7613906860352, -1.44445876100068, 218, 53, 'PPL', 'P'),
(167753, 'Sunbrook', 40.4333305358887, 0.705694745398421, -78.4333267211914, -1.36891979457724, 218, 45, 'PPL', 'P'),
(138346, 'Sunburg', 45.3477783203125, 0.791468040153957, -95.2380599975586, -1.6622177201693, 218, 28, 'PPL', 'P'),
(69217, 'Sunburst', 35.4105606079102, 0.618030872585037, -82.9322204589844, -1.44744030299908, 218, 33, 'PPL', 'P'),
(176612, 'Sunburst', 43.1777801513672, 0.753594427343613, -89.290283203125, -1.55840943193272, 218, 57, 'PPL', 'P'),
(197655, 'Sunburst', 48.8827781677246, 0.853165426548795, -111.91056060791, -1.9532077503607, 218, 31, 'PPL', 'P'),
(205965, 'Sunburst Circle', 40.6233291625977, 0.70901084700876, -111.813331604004, -1.9515107841141, 218, 52, 'PPL', 'P'),
(179253, 'Sunburst Homes', 33.4674987792969, 0.584118046105914, -112.1875, -1.95804125458114, 218, 5, 'PPL', 'P'),
(205966, 'Sunburst Meadows', 40.5999984741211, 0.708603649678087, -111.875556945801, -1.95259682120663, 218, 52, 'PPL', 'P'),
(25240, 'Sunbury', 31.7680606842041, 0.554457255912724, -81.2811126708984, -1.41862303579166, 218, 13, 'PPL', 'P'),
(69218, 'Sunbury', 36.4408302307129, 0.636012469686225, -76.6119384765625, -1.33713057275134, 218, 33, 'PPL', 'P'),
(117958, 'Sunbury', 41.6699981689453, 0.727278667348104, -90.9308319091797, -1.58704240839271, 218, 16, 'PPL', 'P'),
(121625, 'Sunbury', 41.100830078125, 0.717344810165999, -88.5274963378906, -1.54509628964341, 218, 18, 'PPL', 'P'),
(157866, 'Sunbury', 40.2425003051758, 0.70236412956014, -82.8591690063477, -1.4461653146272, 218, 41, 'PPL', 'P'),
(167754, 'Sunbury', 40.8624992370605, 0.713185152280377, -76.7947235107422, -1.34032077342115, 218, 45, 'PPL', 'P'),
(167756, 'Suncliff', 40.5577812194824, 0.707866819583489, -79.0086135864258, -1.37896044451906, 218, 45, 'PPL', 'P'),
(18226, 'Suncoast Estates', 26.711389541626, 0.466201695284152, -81.8691711425781, -1.42888659231672, 218, 12, 'PPL', 'P'),
(144532, 'Suncook', 43.1305618286133, 0.752770312144288, -71.45361328125, -1.24710081420456, 218, 36, 'PPL', 'P'),
(111607, 'Suncrest', 38.688060760498, 0.675234041482312, -80.2536087036133, -1.40068970848523, 218, 58, 'PPL', 'P'),
(185451, 'Suncrest', 32.8041687011719, 0.572540752215121, -116.863609313965, -2.039654758293, 218, 6, 'PPL', 'P'),
(205967, 'Suncrest', 40.6472206115723, 0.709427831456439, -112.02555847168, -1.95521484171624, 218, 52, 'PPL', 'P'),
(106712, 'Suncrest Heights', 37.1972198486328, 0.649213958946829, -79.9408264160156, -1.39523062772473, 218, 53, 'PPL', 'P'),
(111608, 'Suncrest Lake', 39.6644401550293, 0.692275076665511, -79.9763870239258, -1.39585127741677, 218, 58, 'PPL', 'P'),
(179254, 'Suncrest Villas Chandler', 33.3027801513672, 0.581243163709173, -111.938056945801, -1.95368765198913, 218, 5, 'PPL', 'P'),
(179255, 'Suncrest Villas East', 33.6386108398438, 0.587104514952328, -112.033058166504, -1.95534573608381, 218, 5, 'PPL', 'P'),
(179256, 'Suncrest Villas Mesa', 33.3888893127441, 0.582746052091332, -111.779716491699, -1.95092408972596, 218, 5, 'PPL', 'P'),
(179257, 'Suncrest Villas West', 33.6744384765625, 0.587729825176279, -112.147216796875, -1.95733818005336, 218, 5, 'PPL', 'P'),
(179258, 'Sundad', 33.1813888549805, 0.57912448590396, -113.235282897949, -1.97632851599644, 218, 5, 'PPL', 'P'),
(171400, 'Sundahl Trailer Court', 44.3413887023926, 0.773903227763367, -96.7772216796875, -1.68908115924298, 218, 49, 'PPL', 'P'),
(138348, 'Sundal', 47.4563903808594, 0.828270263257762, -96.1980590820313, -1.67897286500948, 218, 28, 'PPL', 'P'),
(74477, 'Sundale', 39.9772186279297, 0.697734090846983, -81.7916717529297, -1.42753397279907, 218, 41, 'PPL', 'P'),
(167757, 'Sundale', 40.4805603027344, 0.706519060334827, -75.1102828979492, -1.3109217386736, 218, 45, 'PPL', 'P'),
(208859, 'Sundale', 45.7200012207031, 0.797964555317096, -120.316673278809, -2.09992209376149, 218, 56, 'PPL', 'P'),
(83907, 'Sundance', 34.9236106872559, 0.609531993177294, -81.8411102294922, -1.42839683699225, 218, 48, 'PPL', 'P'),
(189613, 'Sundance', 35.4602813720703, 0.618898663626239, -108.637496948242, -1.89608201287212, 218, 38, 'PPL', 'P'),
(197656, 'Sundance', 48.6338882446289, 0.84882147791574, -112.532783508301, -1.96406758865382, 218, 31, 'PPL', 'P'),
(209760, 'Sundance', 44.4063911437988, 0.77503773438774, -104.375282287598, -1.8216923336171, 218, 59, 'PPL', 'P'),
(189614, 'Sundance Mesa', 35.3302803039551, 0.616629716956519, -106.483329772949, -1.85848470302487, 218, 38, 'PPL', 'P'),
(51819, 'Sunday', 39.5833282470703, 0.690859406809052, -77.4241714477539, -1.35130671239189, 218, 25, 'PPL', 'P'),
(61932, 'Sunday (historical)', 34.3499984741211, 0.599520571428441, -90.4527816772461, -1.57869885785554, 218, 30, 'PPL', 'P'),
(51820, 'Sundays Manor', 39.4911117553711, 0.689249925404263, -77.4261093139648, -1.35134053453773, 218, 25, 'PPL', 'P'),
(133318, 'Sundell', 46.3472213745117, 0.808911612135921, -87.079719543457, -1.51982781774658, 218, 27, 'PPL', 'P'),
(51821, 'Sunderland', 38.6711082458496, 0.674938164285204, -76.5983276367188, -1.33689301878211, 218, 25, 'PPL', 'P'),
(126290, 'Sunderland', 42.2444381713867, 0.737304536745871, -71.772216796875, -1.25266149456065, 218, 23, 'PPL', 'P'),
(172619, 'Sunderland', 43.1133308410645, 0.752469574678191, -73.1036071777344, -1.27589864033602, 218, 55, 'PPL', 'P'),
(51822, 'Sunderland Estates', 38.6527786254883, 0.674618252059259, -76.5899963378906, -1.33674761018659, 218, 25, 'PPL', 'P'),
(51823, 'Sunderland Farms', 38.6730613708496, 0.674972252747157, -76.6244430541992, -1.33734881880268, 218, 25, 'PPL', 'P'),
(51824, 'Sunderland Hills', 38.6458282470703, 0.674496945071606, -76.5633316040039, -1.3362822227861, 218, 25, 'PPL', 'P'),
(51825, 'Sunderland Park', 38.6477813720703, 0.674531033533559, -76.6116714477539, -1.33712591221944, 218, 25, 'PPL', 'P'),
(51826, 'Sunderland Woods', 38.6549987792969, 0.674657001053119, -76.6288909912109, -1.33742644994845, 218, 25, 'PPL', 'P'),
(51827, 'Sunderlandville (historical)', 38.6836090087891, 0.675156343757509, -76.600830078125, -1.33693669462399, 218, 25, 'PPL', 'P'),
(167758, 'Sunderlinville', 41.8277816772461, 0.730032509073301, -77.6388931274414, -1.35505431267785, 218, 45, 'PPL', 'P'),
(111610, 'Sundial', 37.8761100769043, 0.661062828689783, -81.5147171020508, -1.42270020226252, 218, 58, 'PPL', 'P'),
(179259, 'Sundial Mobile Park', 33.4536094665527, 0.583875631867689, -111.828887939453, -1.95178229338723, 218, 5, 'PPL', 'P'),
(57789, 'Sundown', 36.5663909912109, 0.638203918368224, -92.6366729736328, -1.61681495148314, 218, 29, 'PPL', 'P'),
(153007, 'Sundown', 41.8877792358398, 0.73107966401392, -74.460563659668, -1.29958199875204, 218, 40, 'PPL', 'P'),
(190800, 'Sundown', 37.6269416809082, 0.656714019787738, -115.803886413574, -2.0211591045224, 218, 39, 'PPL', 'P'),
(192287, 'Sundown', 33.4561080932617, 0.583919241130539, -102.488891601563, -1.78876860516683, 218, 51, 'PPL', 'P'),
(205974, 'Sundown Condominiums at Powder Mountain', 41.3777809143066, 0.722178514123521, -111.783889770508, -1.95099692718177, 218, 52, 'PPL', 'P'),
(31260, 'Sundown Manor', 39.5838890075684, 0.690869193926059, -86.378059387207, -1.50758153778996, 218, 19, 'PPL', 'P'),
(51828, 'Sundown Manor', 39.3333282470703, 0.686496083679067, -77.225830078125, -1.34784500244895, 218, 25, 'PPL', 'P'),
(25241, 'Sundown on Lanier', 34.3616714477539, 0.599724303251832, -83.8486099243164, -1.46343431639971, 218, 13, 'PPL', 'P'),
(190801, 'Sundown Town', 39.336669921875, 0.686554406906939, -119.826942443848, -2.09137467824288, 218, 39, 'PPL', 'P'),
(205976, 'Sundowner Condominium', 41.1027793884277, 0.717378832048925, -111.998611450195, -1.95474452746773, 218, 52, 'PPL', 'P'),
(167759, 'Sundy Place', 40.2799987792969, 0.703018601398027, -77.461669921875, -1.35196118422978, 218, 45, 'PPL', 'P'),
(185453, 'Sunfair', 34.163890838623, 0.596272380425899, -116.246391296387, -2.02888227168363, 218, 6, 'PPL', 'P'),
(185454, 'Sunfair Heights', 34.2402801513672, 0.59760562544662, -116.218063354492, -2.02838785582725, 218, 6, 'PPL', 'P'),
(28734, 'Sunfield', 38.0644416809082, 0.664349835265213, -89.2399978637695, -1.55753178719548, 218, 18, 'PPL', 'P'),
(133319, 'Sunfield', 42.7622184753418, 0.746341507851864, -84.9925003051758, -1.4833989698276, 218, 27, 'PPL', 'P'),
(117959, 'Sunfield Mobile Home Park', 41.3694381713867, 0.722032905790921, -93.5505599975586, -1.6327652890419, 218, 16, 'PPL', 'P'),
(38444, 'Sunfish', 37.2969398498535, 0.650954401298223, -86.3697204589844, -1.50743599603639, 218, 21, 'PPL', 'P'),
(138351, 'Sunfish Lake', 44.8708305358887, 0.783143730955669, -93.0983276367188, -1.62487234536117, 218, 28, 'PPL', 'P'),
(6159, 'Sunflower', 31.3822193145752, 0.547723053622295, -88.0083312988281, -1.53603515035053, 218, 2, 'PPL', 'P'),
(34091, 'Sunflower', 39.0652809143066, 0.681817775171152, -94.8638916015625, -1.65568724970226, 218, 20, 'PPL', 'P'),
(61934, 'Sunflower', 33.542781829834, 0.585431983208731, -90.5369415283203, -1.58016772435478, 218, 30, 'PPL', 'P'),
(111616, 'Sunflower', 38.9049987792969, 0.679020324183105, -81.4783325195313, -1.42206517150059, 218, 58, 'PPL', 'P'),
(167760, 'Sunflower', 40.7313919067383, 0.710896897692754, -80.2397232055664, -1.40044736082603, 218, 45, 'PPL', 'P'),
(176613, 'Sunflower', 45.8033294677734, 0.799418907588389, -89.642219543457, -1.56455187982893, 218, 57, 'PPL', 'P'),
(179260, 'Sunflower', 33.8641700744629, 0.591041266254711, -111.466941833496, -1.94546514212351, 218, 5, 'PPL', 'P'),
(61936, 'Sunflower Landing', 34.1661109924316, 0.59631112941976, -90.8019409179688, -1.58479283621992, 218, 30, 'PPL', 'P'),
(199713, 'Sunflower Mobile Home Park', 41.9402809143066, 0.731995991165989, -103.808059692383, -1.81179243173889, 218, 35, 'PPL', 'P'),
(138353, 'Sungold Heights Mobile Home Park', 43.6338882446289, 0.761555015316023, -95.5744400024414, -1.66808865879238, 218, 28, 'PPL', 'P'),
(192288, 'Sunhaven Farms Colonia', 31.6380004882813, 0.552187277268081, -106.258003234863, -1.85455201304315, 218, 51, 'PPL', 'P'),
(18227, 'Suniland', 25.6574993133545, 0.44780784084622, -80.3227767944336, -1.40189691940736, 218, 12, 'PPL', 'P'),
(179262, 'Sunizona', 31.8819408416748, 0.556444839613278, -109.652778625488, -1.91380202097523, 218, 5, 'PPL', 'P'),
(106715, 'Sunken Meadow Beach', 37.2186088562012, 0.649587267552631, -76.9349975585938, -1.34276901741126, 218, 53, 'PPL', 'P'),
(126292, 'Sunken Meadow Beach', 41.8722190856934, 0.730808088161759, -70.0083312988281, -1.22187588499155, 218, 23, 'PPL', 'P'),
(77386, 'Sunkist', 34.1419410705566, 0.595889284703091, -95.8858337402344, -1.67352350478696, 218, 42, 'PPL', 'P'),
(185455, 'Sunkist', 34.077220916748, 0.594759704926734, -117.190002441406, -2.04535139302273, 218, 6, 'PPL', 'P'),
(91144, 'Sunkist Beach', 36.3525009155273, 0.634470832310205, -89.4524993896484, -1.56124063848758, 218, 50, 'PPL', 'P'),
(98366, 'Sunkist Country Estates Colonia', 28.007999420166, 0.48883180677856, -97.5500030517578, -1.70256873858369, 218, 51, 'PPL', 'P'),
(185458, 'Sunland', 36.0224990844727, 0.628711213820691, -118.981391906738, -2.07661703737832, 218, 6, 'PPL', 'P'),
(187923, 'Sunland', 38.8927803039551, 0.678807071558817, -101.821113586426, -1.77711368013026, 218, 20, 'PPL', 'P'),
(185459, 'Sunland (historical)', 37.3325004577637, 0.651575050990266, -118.403610229492, -2.06653284475268, 218, 6, 'PPL', 'P'),
(18228, 'Sunland Estates', 28.7541694641113, 0.501854930825156, -81.2816696166992, -1.41863275632964, 218, 12, 'PPL', 'P'),
(18229, 'Sunland Gardens', 27.4624996185303, 0.47931103917104, -80.3622207641602, -1.40258534654915, 218, 12, 'PPL', 'P'),
(189615, 'Sunland Park', 31.7963905334473, 0.554951705058611, -106.579437255859, -1.86016209503746, 218, 38, 'PPL', 'P'),
(6160, 'Sunlight', 33.9269409179688, 0.592136824148142, -87.2102813720703, -1.52210655153331, 218, 2, 'PPL', 'P'),
(57790, 'Sunlight', 37.7816696166992, 0.659414531712105, -90.9049987792969, -1.58659153522016, 218, 29, 'PPL', 'P'),
(111611, 'Sunlight', 37.9869384765625, 0.662997149168534, -80.461669921875, -1.40432106178961, 218, 58, 'PPL', 'P'),
(197657, 'Sunlight', 45.9000015258789, 0.801106153297008, -112.016670227051, -1.95505971258274, 218, 31, 'PPL', 'P'),
(25242, 'Sunlight (historical)', 31.9988899230957, 0.558485986141255, -84.9052810668945, -1.48187670694851, 218, 13, 'PPL', 'P'),
(208860, 'Sunlight Beach', 47.9911117553711, 0.837602911823781, -122.47917175293, -2.13766481220426, 218, 56, 'PPL', 'P'),
(31261, 'Sunman', 39.2369384765625, 0.684813764818464, -85.0947189331055, -1.48518302144185, 218, 19, 'PPL', 'P'),
(172621, 'Sunmit', 44.6902809143066, 0.779992545595833, -72.0577774047852, -1.25764546738268, 218, 55, 'PPL', 'P'),
(18230, 'Sunniland', 26.2688903808594, 0.458478627991463, -81.3419418334961, -1.41968470496022, 218, 12, 'PPL', 'P'),
(198976, 'Sunny', 46.8294410705566, 0.817327933549872, -100.956672668457, -1.76202633992274, 218, 34, 'PPL', 'P'),
(25243, 'Sunny Acres', 33.8525009155273, 0.590837601010347, -83.9211120605469, -1.46469971739167, 218, 13, 'PPL', 'P'),
(38446, 'Sunny Acres', 39.0158309936523, 0.680954711240884, -84.4980621337891, -1.47476939578936, 218, 21, 'PPL', 'P'),
(51829, 'Sunny Acres', 39.4505615234375, 0.688542190344575, -77.4652786254883, -1.35202416798956, 218, 25, 'PPL', 'P'),
(83909, 'Sunny Acres', 34.6688919067383, 0.605086311790598, -82.7991714477539, -1.44511815968659, 218, 48, 'PPL', 'P'),
(185460, 'Sunny Acres Trailer Park', 37.9619407653809, 0.662560856802952, -122.027221679688, -2.12977679537155, 218, 6, 'PPL', 'P'),
(179261, 'Sunny Acres Trailer Village', 33.4124984741211, 0.583158109690994, -111.664436340332, -1.9489120715224, 218, 5, 'PPL', 'P'),
(106717, 'Sunny Bank (historical)', 38.9833297729492, 0.680387457928697, -77.7155609130859, -1.35639241796756, 218, 53, 'PPL', 'P'),
(106718, 'Sunny Banks', 37.3397216796875, 0.651701085088854, -79.2413864135742, -1.38302309676197, 218, 53, 'PPL', 'P'),
(153008, 'Sunny Brae', 40.9308280944824, 0.714377715816515, -73.8241729736328, -1.28847488595171, 218, 40, 'PPL', 'P'),
(193989, 'Sunny Brae', 40.8583297729492, 0.713112381403591, -124.065277099609, -2.1653475727873, 218, 6, 'PPL', 'P'),
(25246, 'Sunny Brook', 34.1197204589844, 0.595501461869348, -84.4688873291016, -1.47426019938894, 218, 13, 'PPL', 'P'),
(83911, 'Sunny Brook', 33.6766700744629, 0.587768773907221, -81.8130569458008, -1.42790721482584, 218, 48, 'PPL', 'P'),
(91145, 'Sunny Brook', 36.545280456543, 0.637835470031411, -82.228889465332, -1.43516486142852, 218, 50, 'PPL', 'P'),
(38445, 'Sunny Corner', 37.8522186279297, 0.660645844242103, -86.6697235107422, -1.51267203705559, 218, 21, 'PPL', 'P'),
(6161, 'Sunny Cove', 30.4838905334473, 0.532044258626185, -88.100830078125, -1.53764955860333, 218, 2, 'PPL', 'P'),
(121627, 'Sunny Crest', 41.535831451416, 0.724937016380625, -87.6938934326172, -1.5305471742922, 218, 18, 'PPL', 'P'),
(12212, 'Sunny Gap (historical)', 35.0952796936035, 0.612528182561688, -92.336669921875, -1.61157891046393, 218, 4, 'PPL', 'P'),
(83912, 'Sunny Glen', 34.9444389343262, 0.60989551466609, -82.1944427490234, -1.43456365281244, 218, 48, 'PPL', 'P'),
(98367, 'Sunny Haven Estates Colonia', 26.2080001831055, 0.457415893558467, -98.3779983520508, -1.71701998276484, 218, 51, 'PPL', 'P'),
(43252, 'Sunny Hill', 30.9241695404053, 0.539728576925014, -90.3272171020508, -1.57650734259452, 218, 22, 'PPL', 'P'),
(121628, 'Sunny Hill', 41.3988914489746, 0.722546962460333, -90.4158325195313, -1.57805397339758, 218, 18, 'PPL', 'P'),
(208874, 'Sunny Hill', 47.4124984741211, 0.827504204970201, -120.251937866211, -2.09879224766903, 218, 56, 'PPL', 'P'),
(121629, 'Sunny Hill Estates', 41.3963890075684, 0.722503286618456, -90.4288864135742, -1.57828180682884, 218, 18, 'PPL', 'P'),
(185461, 'Sunny Hills', 33.9011116027832, 0.591686017554619, -117.935562133789, -2.05836386442497, 218, 6, 'PPL', 'P'),
(185462, 'Sunny Hills Estates Mobile Home Park', 34.8624992370605, 0.608465397160718, -120.39582824707, -2.10130360857697, 218, 6, 'PPL', 'P'),
(6162, 'Sunny Home', 34.084171295166, 0.594881011914387, -87.6991729736328, -1.53063931966592, 218, 2, 'PPL', 'P'),
(51830, 'Sunny Isle of Kent', 38.934440612793, 0.679534181115436, -76.35888671875, -1.33271398639956, 218, 25, 'PPL', 'P'),
(18231, 'Sunny Isles', 25.9502792358398, 0.452917814477323, -80.1230621337891, -1.39841124101461, 218, 12, 'PPL', 'P'),
(106719, 'Sunny Knoll', 38.5811080932617, 0.673367365295249, -77.8030624389648, -1.35791960769467, 218, 53, 'PPL', 'P'),
(6163, 'Sunny Level', 32.9797210693359, 0.575604719049257, -85.9300003051758, -1.49976143156505, 218, 2, 'PPL', 'P'),
(25247, 'Sunny Point', 33.0944404602051, 0.577606950135806, -85.057502746582, -1.48453347645198, 218, 13, 'PPL', 'P'),
(69221, 'Sunny Point', 35.0336112976074, 0.611451866007133, -84.208610534668, -1.46971751235954, 218, 33, 'PPL', 'P'),
(106720, 'Sunny Point', 36.8199996948242, 0.64263022525799, -82.376106262207, -1.43773427924823, 218, 53, 'PPL', 'P'),
(167761, 'Sunny Rest Lodge', 40.8222198486328, 0.712482144331624, -75.6500015258789, -1.32034160576532, 218, 45, 'PPL', 'P'),
(106721, 'Sunny Ridge', 39.163890838623, 0.683538843025615, -77.8000030517578, -1.35786621131481, 218, 53, 'PPL', 'P'),
(208861, 'Sunny Shore Acres', 48.1088905334473, 0.839658539290186, -122.405563354492, -2.1363801032944, 218, 56, 'PPL', 'P'),
(153009, 'Sunny Shores', 42.7619400024414, 0.746336647582875, -77.7122192382813, -1.35633409473969, 218, 40, 'PPL', 'P'),
(208862, 'Sunny Shores', 48.1086082458496, 0.839653612442169, -122.345001220703, -2.13532309465775, 218, 56, 'PPL', 'P'),
(25248, 'Sunny Side', 33.3405609130859, 0.581902562395077, -84.2908325195313, -1.47115255671293, 218, 13, 'PPL', 'P'),
(69222, 'Sunny Side', 35.9225006103516, 0.626965911200307, -75.7122192382813, -1.3214275096998, 218, 33, 'PPL', 'P'),
(83913, 'Sunny Side', 33.5661087036133, 0.585839113960377, -79.0280609130859, -1.37929986439999, 218, 48, 'PPL', 'P'),
(91147, 'Sunny Side', 36.3069381713867, 0.633675612408708, -88.2305603027344, -1.53991377816212, 218, 50, 'PPL', 'P'),
(98369, 'Sunny Side', 29.8883304595947, 0.521649774444038, -96.0688934326172, -1.67671849914673, 218, 51, 'PPL', 'P'),
(106723, 'Sunny Side', 37.4791717529297, 0.654134948009078, -78.1594390869141, -1.3641395535786, 218, 53, 'PPL', 'P'),
(167763, 'Sunny Side', 40.1419410705566, 0.700609039822751, -78.2858276367188, -1.36634544990951, 218, 45, 'PPL', 'P'),
(189616, 'Sunny Side', 36.3636093139648, 0.634664710437563, -104.901390075684, -1.83087464673958, 218, 38, 'PPL', 'P'),
(98370, 'Sunny Side PO', 29.9091701507568, 0.522013495669916, -96.0658264160156, -1.67666496960882, 218, 51, 'PPL', 'P'),
(12213, 'Sunny Slope', 35.6300010681152, 0.621860831127707, -92.1425018310547, -1.60819003797681, 218, 4, 'PPL', 'P'),
(91148, 'Sunny Slope', 35.7944412231445, 0.624730853255458, -86.0986099243164, -1.50270422456959, 218, 50, 'PPL', 'P'),
(179264, 'Sunny Slope Mobile Home Park', 33.5702781677246, 0.585911884837164, -112.081672668457, -1.95619421920711, 218, 5, 'PPL', 'P'),
(31262, 'Sunny Slopes', 39.1319389343262, 0.682981177093353, -86.5311126708984, -1.51025282152136, 218, 19, 'PPL', 'P'),
(83914, 'Sunny Slopes', 34.9833297729492, 0.610574287848924, -82.4530563354492, -1.43907731138596, 218, 48, 'PPL', 'P'),
(6164, 'Sunny South', 31.9647197723389, 0.557889604504646, -87.6399993896484, -1.52960654579519, 218, 2, 'PPL', 'P'),
(201611, 'Sunny Valley', 42.6391716003418, 0.744193934748824, -123.374443054199, -2.15329024411003, 218, 43, 'PPL', 'P'),
(69223, 'Sunny View', 35.3741683959961, 0.617395708665053, -82.1880569458008, -1.43445219952082, 218, 33, 'PPL', 'P'),
(185463, 'Sunny Vista', 32.644718170166, 0.569757815455015, -117.067222595215, -2.0432084804516, 218, 6, 'PPL', 'P'),
(117960, 'Sunny-Brook Mobile Home Park', 41.6688919067383, 0.727259359430201, -93.5449981689453, -1.63266821682016, 218, 16, 'PPL', 'P'),
(106724, 'Sunnybank', 37.8861083984375, 0.66123733232021, -76.2675018310547, -1.33111901922271, 218, 53, 'PPL', 'P'),
(153010, 'Sunnybank', 44.1655616760254, 0.770834467239268, -76.2538909912109, -1.33088146525347, 218, 40, 'PPL', 'P'),
(208863, 'Sunnybank', 47.8600006103516, 0.83531459065713, -120.149169921875, -2.09699860867486, 218, 56, 'PPL', 'P'),
(38447, 'Sunnybrook', 36.6577796936035, 0.639798952124099, -84.975830078125, -1.48310801947851, 218, 21, 'PPL', 'P'),
(43253, 'Sunnybrook', 30.4927806854248, 0.532199421049196, -91.0869369506836, -1.58976695534591, 218, 22, 'PPL', 'P'),
(51831, 'Sunnybrook', 39.5041694641113, 0.689477825414547, -76.5716705322266, -1.33642776453967, 218, 25, 'PPL', 'P'),
(106725, 'Sunnybrook', 37.3430595397949, 0.6517593417377, -79.9524993896484, -1.39543435954812, 218, 53, 'PPL', 'P'),
(153011, 'Sunnybrook', 41.3849983215332, 0.722304481643081, -73.8608322143555, -1.2891147104036, 218, 40, 'PPL', 'P'),
(167764, 'Sunnybrook', 40.1133308410645, 0.700109697118361, -75.1977767944336, -1.31244879524265, 218, 45, 'PPL', 'P'),
(185464, 'Sunnybrook', 38.3430595397949, 0.669212634257643, -120.875831604004, -2.10968124757609, 218, 6, 'PPL', 'P'),
(123759, 'Sunnybrook Acres', 41.1561088562012, 0.718309606849908, -85.0719375610352, -1.4847854114911, 218, 19, 'PPL', 'P'),
(51832, 'Sunnybrook Estates', 39.5666694641113, 0.690568656197043, -75.8005599975586, -1.3229693468129, 218, 25, 'PPL', 'P'),
(106726, 'Sunnybrook Estates', 38.7719383239746, 0.676697981133529, -77.4922180175781, -1.35249434908001, 218, 53, 'PPL', 'P'),
(25249, 'Sunnybrook Farms', 34.1286087036133, 0.595656591002845, -84.2877807617188, -1.47109929349113, 218, 13, 'PPL', 'P'),
(43254, 'Sunnybrook Farms', 32.4388885498047, 0.56616541088158, -92.2050018310547, -1.6092808687593, 218, 22, 'PPL', 'P'),
(51834, 'Sunnybrook Farms', 39.3161087036133, 0.686195545950051, -77.254997253418, -1.34835406569132, 218, 25, 'PPL', 'P'),
(28737, 'Sunnybrook Meadows', 39.9058303833008, 0.696488130930989, -91.3897171020508, -1.59505146589696, 218, 18, 'PPL', 'P'),
(79236, 'Sunnyburn', 39.8055610656738, 0.694738101199671, -76.3711090087891, -1.33292730560287, 218, 45, 'PPL', 'P'),
(201612, 'Sunnycrest', 45.3019409179688, 0.790668026562497, -123.016670227051, -2.14704593030212, 218, 43, 'PPL', 'P'),
(12214, 'Sunnydale', 35.4474983215332, 0.618675557305918, -91.6958312988281, -1.60039416651782, 218, 4, 'PPL', 'P'),
(34092, 'Sunnydale', 37.8683280944824, 0.660927007474189, -97.2991714477539, -1.69819090122576, 218, 20, 'PPL', 'P'),
(38448, 'Sunnydale', 37.5361099243164, 0.655128706569841, -86.8194427490234, -1.51528513071718, 218, 21, 'PPL', 'P'),
(192809, 'Sunnydale', 39.5333290100098, 0.689986755498861, -110.400001525879, -1.92684352083335, 218, 52, 'PPL', 'P'),
(201613, 'Sunnydale', 43.6541709899902, 0.761909016003922, -123.404167175293, -2.15380902789037, 218, 43, 'PPL', 'P'),
(208865, 'Sunnydale', 46.8338890075684, 0.817405564695647, -122.931671142578, -2.14556241641689, 218, 56, 'PPL', 'P'),
(83916, 'Sunnydale Acres', 35.0333290100098, 0.611446939159116, -81.9441680908203, -1.43019553599249, 218, 48, 'PPL', 'P'),
(195672, 'Sunnydell', 43.684440612793, 0.762437320585167, -111.754173278809, -1.95047827655948, 218, 17, 'PPL', 'P'),
(51835, 'Sunnyfield Estates', 39.2061080932617, 0.684275673120213, -76.6369400024414, -1.33756693169595, 218, 25, 'PPL', 'P'),
(83917, 'Sunnyhill', 34.288890838623, 0.598454041990892, -80.6286087036133, -1.40723469318021, 218, 48, 'PPL', 'P'),
(91150, 'Sunnyhill', 35.5347213745117, 0.620197886764035, -89.2491683959961, -1.557691843177, 218, 50, 'PPL', 'P'),
(18232, 'Sunnyland', 27.2852802276611, 0.476217977301995, -82.4933319091797, -1.43978025275569, 218, 12, 'PPL', 'P'),
(74480, 'Sunnyland', 39.9038887023926, 0.696454242206118, -83.8494415283203, -1.46344883062766, 218, 41, 'PPL', 'P'),
(121630, 'Sunnyland', 40.6913909912109, 0.71019875001299, -89.508056640625, -1.56221029544048, 218, 18, 'PPL', 'P'),
(167765, 'Sunnyland', 40.2027816772461, 0.701670908728393, -77.0116729736328, -1.34410725585902, 218, 45, 'PPL', 'P'),
(98372, 'Sunnylane', 30.9297199249268, 0.539825449409665, -98.1361083984375, -1.71279820664679, 218, 51, 'PPL', 'P'),
(185465, 'Sunnymead', 33.939998626709, 0.592364724158426, -117.242782592773, -2.04627258044379, 218, 6, 'PPL', 'P'),
(51836, 'Sunnymeade', 39.1894416809082, 0.683984789350149, -77.0444412231445, -1.34467916970312, 218, 25, 'PPL', 'P'),
(123760, 'Sunnymeadow', 41.1311111450195, 0.717873314484326, -85.0952835083008, -1.48519287513788, 218, 19, 'PPL', 'P'),
(6165, 'Sunnymeadows', 33.3844413757324, 0.582668420945556, -86.7125015258789, -1.51341865426719, 218, 2, 'PPL', 'P'),
(123761, 'Sunnymede', 40.8080596923828, 0.712235002982464, -85.841667175293, -1.49821972761, 218, 19, 'PPL', 'P'),
(123762, 'Sunnymede Woods', 41.0652809143066, 0.716724360211038, -85.0661087036133, -1.48468367873746, 218, 19, 'PPL', 'P'),
(201614, 'Sunnyridge', 44.5936088562012, 0.778305299887213, -123.920829772949, -2.16282649134138, 218, 43, 'PPL', 'P'),
(6166, 'Sunnyside', 33.7174987792969, 0.588481369235899, -86.591667175293, -1.51130969699996, 218, 2, 'PPL', 'P'),
(12216, 'Sunnyside', 35.3686103820801, 0.617298703022347, -92.6275024414063, -1.61665489550163, 218, 4, 'PPL', 'P'),
(18234, 'Sunnyside', 28.7986106872559, 0.502630576492642, -81.835563659668, -1.42830003108663, 218, 12, 'PPL', 'P'),
(25253, 'Sunnyside', 31.2391700744629, 0.54522637338986, -82.3422164916992, -1.43714279117013, 218, 13, 'PPL', 'P'),
(51840, 'Sunnyside', 39.0230598449707, 0.681080878497527, -76.9072189331055, -1.34228418893481, 218, 25, 'PPL', 'P'),
(57791, 'Sunnyside', 38.348331451416, 0.669304646473305, -90.3694381713867, -1.57724423926814, 218, 29, 'PPL', 'P'),
(61938, 'Sunnyside', 33.6963882446289, 0.588112920899087, -90.2949981689453, -1.57594501613035, 218, 30, 'PPL', 'P'),
(69227, 'Sunnyside', 34.7030601501465, 0.605682660137694, -78.033332824707, -1.3619385840957, 218, 33, 'PPL', 'P'),
(91157, 'Sunnyside', 36.541389465332, 0.637767559423614, -82.4555587768555, -1.43912098722784, 218, 50, 'PPL', 'P'),
(106728, 'Sunnyside', 39.2061080932617, 0.684275673120213, -78.1727828979492, -1.36437244701593, 218, 53, 'PPL', 'P'),
(111612, 'Sunnyside', 39.4233283996582, 0.688066882669023, -80.8186111450195, -1.41055086136958, 218, 58, 'PPL', 'P'),
(112358, 'Sunnyside', 37.0283317565918, 0.646266305673302, -86.307502746582, -1.50635009210191, 218, 21, 'PPL', 'P'),
(114146, 'Sunnyside', 41.2972183227539, 0.720772431646986, -73.0730590820313, -1.27536547548579, 218, 8, 'PPL', 'P'),
(121632, 'Sunnyside', 42.3566703796387, 0.739263358306651, -89.9136123657227, -1.56928857814375, 218, 18, 'PPL', 'P'),
(126293, 'Sunnyside', 42.0625, 0.734129116620115, -71.8861083984375, -1.25464927799828, 218, 23, 'PPL', 'P'),
(133321, 'Sunnyside', 42.2622184753418, 0.737614861591892, -83.3236083984375, -1.45427131119513, 218, 27, 'PPL', 'P'),
(146420, 'Sunnyside', 40.5816688537598, 0.708283737452141, -74.879997253418, -1.30690249595645, 218, 37, 'PPL', 'P'),
(153015, 'Sunnyside', 40.6161117553711, 0.708884879489199, -74.1041717529297, -1.293361786552, 218, 40, 'PPL', 'P'),
(157869, 'Sunnyside', 41.4225006103516, 0.722959020059996, -82.3105621337891, -1.43659031840199, 218, 41, 'PPL', 'P'),
(167770, 'Sunnyside', 41.9513893127441, 0.732189869293346, -78.186393737793, -1.36461000098516, 218, 45, 'PPL', 'P'),
(176614, 'Sunnyside', 46.6041717529297, 0.81339624225356, -92.0563888549805, -1.60668708301562, 218, 57, 'PPL', 'P'),
(179263, 'Sunnyside', 31.4338893890381, 0.548624866546423, -110.404441833496, -1.92692101882107, 218, 5, 'PPL', 'P'),
(185469, 'Sunnyside', 39.8441696166992, 0.695411947534488, -122.864166259766, -2.14438423395064, 218, 6, 'PPL', 'P'),
(190802, 'Sunnyside', 38.4233283996582, 0.670613590149079, -115.020278930664, -2.00748257390235, 218, 39, 'PPL', 'P'),
(192289, 'Sunnyside', 34.3477783203125, 0.599481822434581, -102.303062438965, -1.78552527443328, 218, 51, 'PPL', 'P'),
(192810, 'Sunnyside', 39.5513916015625, 0.690302007192899, -110.387222290039, -1.92662048109206, 218, 52, 'PPL', 'P'),
(193311, 'Sunnyside', 57.982780456543, 1.0119904284277, -136.252212524414, -2.37804972167808, 218, 1, 'PPL', 'P'),
(194442, 'Sunnyside', 40.0036087036133, 0.698194684557512, -105.38111114502, -1.83924735889068, 218, 7, 'PPL', 'P'),
(195673, 'Sunnyside', 48.2802810668945, 0.84264986840559, -116.396110534668, -2.03149536534521, 218, 17, 'PPL', 'P'),
(197658, 'Sunnyside', 46.1155586242676, 0.804868334389936, -112.992782592773, -1.97209608723403, 218, 31, 'PPL', 'P'),
(201617, 'Sunnyside', 45.9625015258789, 0.802196984079505, -118.401107788086, -2.0664891689108, 218, 43, 'PPL', 'P'),
(208868, 'Sunnyside', 46.3238906860352, 0.808504414805248, -120.007499694824, -2.09452599676077, 218, 56, 'PPL', 'P'),
(111613, 'Sunnyside (historical)', 38.0963897705078, 0.664907434618448, -81.0988922119141, -1.41544268881789, 218, 58, 'PPL', 'P'),
(114144, 'Sunnyside (historical)', 41.5169410705566, 0.724607317037673, -72.0666732788086, -1.25780072967423, 218, 8, 'PPL', 'P'),
(185470, 'Sunnyside (historical)', 39.9327812194824, 0.696958511758525, -123.206390380859, -2.15035717164347, 218, 6, 'PPL', 'P'),
(83918, 'Sunnyside Acres', 34.5858306884766, 0.603636620051213, -82.6708297729492, -1.44287817489372, 218, 48, 'PPL', 'P'),
(91158, 'Sunnyside Estates', 36.0222206115723, 0.628706353551701, -86.8763885498047, -1.51627902243599, 218, 50, 'PPL', 'P'),
(185471, 'Sunnyside Estates', 33.7011108398438, 0.588195345734825, -116.247497558594, -2.02890157960153, 218, 6, 'PPL', 'P'),
(192811, 'Sunnyside Junction', 39.5255584716797, 0.689851134020348, -110.572219848633, -1.92984929759767, 218, 52, 'PPL', 'P'),
(6167, 'Sunnyside Landing', 34.5758285522461, 0.603462049841759, -86.725830078125, -1.51365128138841, 218, 2, 'PPL', 'P'),
(114145, 'Sunnyside Trailer Park', 41.2930603027344, 0.720699860507281, -73.0699996948242, -1.27531207910593, 218, 8, 'PPL', 'P'),
(179265, 'Sunnyslope', 33.5658302307129, 0.585834253691388, -112.064437866211, -1.95589341516199, 218, 5, 'PPL', 'P'),
(185473, 'Sunnyslope', 34.0119400024414, 0.593620338033371, -117.432502746582, -2.04958382178514, 218, 6, 'PPL', 'P'),
(195674, 'Sunnyslope', 43.5886116027832, 0.76076478884157, -116.792221069336, -2.038408798377, 218, 17, 'PPL', 'P'),
(208870, 'Sunnyslope', 47.5047187805176, 0.829113752954017, -122.727783203125, -2.14200390056832, 218, 56, 'PPL', 'P'),
(57792, 'Sunnyvale', 37.0508308410645, 0.646658988776035, -94.495002746582, -1.64924892460894, 218, 29, 'PPL', 'P'),
(69228, 'Sunnyvale', 35.7388916015625, 0.623761329460615, -82.1361083984375, -1.4335455263277, 218, 33, 'PPL', 'P'),
(98375, 'Sunnyvale', 32.7963905334473, 0.572404997578554, -96.5605621337891, -1.68529973681118, 218, 51, 'PPL', 'P'),
(185474, 'Sunnyvale', 37.3688888549805, 0.652210148331223, -122.035278320313, -2.12991741027711, 218, 6, 'PPL', 'P'),
(31263, 'Sunnyview', 39.7458305358887, 0.69369560679096, -86.0827789306641, -1.50242792160649, 218, 19, 'PPL', 'P'),
(106729, 'Sunnyview', 38.7336082458496, 0.676028995067701, -77.0877838134766, -1.34543564061076, 218, 53, 'PPL', 'P'),
(171401, 'Sunnyview', 44.3447189331055, 0.773961351254158, -96.7850036621094, -1.68921698045858, 218, 49, 'PPL', 'P'),
(51841, 'Sunnyview Acres', 39.061939239502, 0.681759451943279, -76.6449966430664, -1.33770754660151, 218, 25, 'PPL', 'P'),
(113346, 'Sunol', 41.4741706848145, 0.723860832984124, -80.1455612182617, -1.39880392411734, 218, 45, 'PPL', 'P'),
(185475, 'Sunol', 37.5944404602051, 0.656146766475551, -121.887496948242, -2.12733813876137, 218, 6, 'PPL', 'P'),
(199714, 'Sunol', 41.1552810668945, 0.718295159200994, -102.763061523438, -1.79355377301348, 218, 35, 'PPL', 'P'),
(77381, 'Sunray', 34.4124984741211, 0.600611402210938, -97.9647216796875, -1.70980694411042, 218, 42, 'PPL', 'P'),
(106730, 'Sunray', 36.7805595397949, 0.641941864695232, -76.4113922119141, -1.33363038013065, 218, 53, 'PPL', 'P'),
(192290, 'Sunray', 36.0166702270508, 0.62860948106705, -101.824172973633, -1.77716707651012, 218, 51, 'PPL', 'P'),
(179266, 'Sunray Manor', 33.6122207641602, 0.586643921241799, -112.140281677246, -1.95721713938181, 218, 5, 'PPL', 'P'),
(205986, 'Sunridge Highlands', 41.3958282470703, 0.72249349950145, -111.663887023926, -1.94890248414248, 218, 52, 'PPL', 'P'),
(179267, 'Sunridge IV', 33.3527793884277, 0.582115815019365, -111.855560302734, -1.95224781394578, 218, 5, 'PPL', 'P'),
(18236, 'Sunrise', 27.2591705322266, 0.475762277149969, -82.4430618286133, -1.43890287433456, 218, 12, 'PPL', 'P'),
(25254, 'Sunrise', 33.6227798461914, 0.586828211989233, -84.5219421386719, -1.47518618049996, 218, 13, 'PPL', 'P'),
(38449, 'Sunrise', 38.5424995422363, 0.672693518960431, -84.2366714477539, -1.470207267684, 218, 21, 'PPL', 'P'),
(43256, 'Sunrise', 30.4772205352783, 0.531927845197035, -91.2022171020508, -1.59177897354947, 218, 22, 'PPL', 'P'),
(51843, 'Sunrise', 39.314998626709, 0.686176171453121, -77.5561065673828, -1.35360941462843, 218, 25, 'PPL', 'P'),
(57794, 'Sunrise', 36.0602798461914, 0.629370612506594, -90.0305633544922, -1.57132975796124, 218, 29, 'PPL', 'P'),
(61940, 'Sunrise', 32.7705612182617, 0.571954190985031, -89.4388885498047, -1.56100308451835, 218, 30, 'PPL', 'P'),
(74481, 'Sunrise', 38.4888916015625, 0.671757883890459, -82.5472183227539, -1.44072074809465, 218, 41, 'PPL', 'P'),
(77383, 'Sunrise', 35.4561080932617, 0.618825826170426, -95.9175033569336, -1.67407624387121, 218, 42, 'PPL', 'P'),
(91161, 'Sunrise', 36.5699996948242, 0.638266902128004, -85.8977813720703, -1.49919910510088, 218, 50, 'PPL', 'P'),
(98377, 'Sunrise', 31.5113906860352, 0.549977519353588, -94.0752792358398, -1.64192336739846, 218, 51, 'PPL', 'P'),
(106731, 'Sunrise', 38.1925010681152, 0.666584893210062, -79.8138885498047, -1.39301514401389, 218, 53, 'PPL', 'P'),
(111615, 'Sunrise', 39.2705612182617, 0.685400592364663, -81.5038909912109, -1.42251125098318, 218, 58, 'PPL', 'P'),
(138355, 'Sunrise', 45.5469398498535, 0.794944064587756, -92.8547210693359, -1.62062060868086, 218, 28, 'PPL', 'P'),
(167771, 'Sunrise', 40.9713897705078, 0.715085650613285, -79.168327331543, -1.38174797523204, 218, 45, 'PPL', 'P'),
(179268, 'Sunrise', 35.2986106872559, 0.616076977872273, -110.988609313965, -1.93711666473833, 218, 5, 'PPL', 'P'),
(185476, 'Sunrise', 34.6730613708496, 0.605159082667384, -118.130828857422, -2.06177191167194, 218, 6, 'PPL', 'P'),
(208871, 'Sunrise', 46.9150009155273, 0.818821234552106, -121.64111328125, -2.12303793254922, 218, 56, 'PPL', 'P'),
(209761, 'Sunrise', 42.3302803039551, 0.738802764596122, -104.705001831055, -1.8274470252586, 218, 59, 'PPL', 'P'),
(212171, 'Sunrise', 60.8866691589355, 1.06267284739591, -149.427780151367, -2.60800675758759, 218, 1, 'PPL', 'P'),
(12217, 'Sunrise (historical)', 35.1549987792969, 0.613570477233318, -91.9972229003906, -1.60565444230294, 218, 4, 'PPL', 'P'),
(51844, 'Sunrise Acres', 38.2208290100098, 0.667079309066435, -76.3891677856445, -1.33324249071788, 218, 25, 'PPL', 'P'),
(69229, 'Sunrise Acres', 35.5316696166992, 0.620144623542233, -78.3522186279297, -1.36750419129981, 218, 33, 'PPL', 'P'),
(83919, 'Sunrise Acres', 34.910831451416, 0.609308953436, -80.9983291625977, -1.41368753250147, 218, 48, 'PPL', 'P'),
(192291, 'Sunrise Acres', 31.860559463501, 0.55607166416553, -106.444717407227, -1.85781079011103, 218, 51, 'PPL', 'P'),
(98378, 'Sunrise Acres Colonia', 27.9300003051758, 0.487470465408338, -97.5699996948242, -1.70291774584455, 218, 51, 'PPL', 'P'),
(176615, 'Sunrise Bay', 44.1636085510254, 0.770800378777315, -88.438606262207, -1.54354486515039, 218, 57, 'PPL', 'P'),
(51845, 'Sunrise Beach', 39.0697212219238, 0.681895273158873, -76.5908279418945, -1.33676212441453, 218, 25, 'PPL', 'P'),
(57795, 'Sunrise Beach', 38.1758308410645, 0.666293942860971, -92.7841720581055, -1.61938929615086, 218, 29, 'PPL', 'P'),
(69231, 'Sunrise Beach', 35.7625007629395, 0.624173387060278, -81.0975036621094, -1.41541845405197, 218, 33, 'PPL', 'P'),
(71453, 'Sunrise Beach', 39.8413887023926, 0.695363411423622, -74.1466674804688, -1.29410347691559, 218, 37, 'PPL', 'P'),
(123763, 'Sunrise Beach', 41.4027786254883, 0.722614806489103, -85.6866683959961, -1.4955144885747, 218, 19, 'PPL', 'P'),
(208873, 'Sunrise Beach', 47.0855598449707, 0.82179804943957, -122.989723205566, -2.14657561605361, 218, 56, 'PPL', 'P'),
(98379, 'Sunrise Beach Village', 30.5994396209717, 0.534060970651162, -98.4097213745117, -1.71757365395547, 218, 51, 'PPL', 'P'),
(98380, 'Sunrise Colonia', 26.1439990997314, 0.456298863928747, -97.8730010986328, -1.70820611797917, 218, 51, 'PPL', 'P'),
(138356, 'Sunrise Court', 44.7719383239746, 0.781417736253189, -94.1427764892578, -1.64310141670666, 218, 28, 'PPL', 'P'),
(138357, 'Sunrise Estates Mobile Home Park', 45.3938903808594, 0.792272847435379, -92.9958267211914, -1.62308336689891, 218, 28, 'PPL', 'P'),
(98381, 'Sunrise Estates Number 1 Colonia', 26.298999786377, 0.459004136253563, -98.1399993896484, -1.71286611725459, 218, 51, 'PPL', 'P'),
(98382, 'Sunrise Estates Number 2 Colonia', 26.2999992370605, 0.459021579958703, -98.1399993896484, -1.71286611725459, 218, 51, 'PPL', 'P'),
(18237, 'Sunrise Harbor', 25.7052803039551, 0.448641776452065, -80.2480621337891, -1.40059290257961, 218, 12, 'PPL', 'P'),
(18238, 'Sunrise Heights', 26.142219543457, 0.456267804812534, -80.245002746582, -1.40053950619975, 218, 12, 'PPL', 'P'),
(106732, 'Sunrise Heights', 37.2947196960449, 0.650915652304363, -79.9258270263672, -1.39496883898958, 218, 53, 'PPL', 'P'),
(185477, 'Sunrise Heights', 39.2316703796387, 0.684721819181829, -121.070831298828, -2.11308463429115, 218, 6, 'PPL', 'P'),
(179269, 'Sunrise Heights Mobile Home Park', 33.6480598449707, 0.587269431202831, -112.047218322754, -1.95559287743297, 218, 5, 'PPL', 'P'),
(98383, 'Sunrise Hill Colonia', 26.2189998626709, 0.457607874183548, -97.9619979858398, -1.70975940668496, 218, 51, 'PPL', 'P'),
(28739, 'Sunrise Hills', 39.2308311462402, 0.684707171795833, -89.6094436645508, -1.56397983282678, 218, 18, 'PPL', 'P'),
(51847, 'Sunrise Hills', 38.7224998474121, 0.675835116940343, -76.7688903808594, -1.3398699002486, 218, 25, 'PPL', 'P'),
(205988, 'Sunrise Hills', 40.625560760498, 0.709049795739702, -111.818061828613, -1.95159334210789, 218, 52, 'PPL', 'P'),
(18239, 'Sunrise Key', 26.1299991607666, 0.456054518898732, -80.1166687011719, -1.39829965456494, 218, 12, 'PPL', 'P'),
(167772, 'Sunrise Lake', 41.3097190856934, 0.720990611119291, -74.9669418334961, -1.30841996514558, 218, 45, 'PPL', 'P'),
(43257, 'Sunrise Landing', 32.2849998474121, 0.563479546343208, -91.5266723632813, -1.59744178613336, 218, 22, 'PPL', 'P'),
(133323, 'Sunrise Landing', 46.5288887023926, 0.812082305150743, -86.0883331298828, -1.50252486067017, 218, 27, 'PPL', 'P'),
(190803, 'Sunrise Manor', 36.211109161377, 0.63200308066511, -115.072219848633, -2.00838911393741, 218, 39, 'PPL', 'P'),
(138358, 'Sunrise Manor Mobile Home Park', 43.7677803039551, 0.763891872593541, -94.1655578613281, -1.64349902665741, 218, 28, 'PPL', 'P'),
(117961, 'Sunrise Mobile Court', 41.9249992370605, 0.731729275582817, -91.6750030517578, -1.60003064502902, 218, 16, 'PPL', 'P'),
(117962, 'Sunrise Mobile Home Community', 41.7222213745117, 0.728190134231184, -93.0277786254883, -1.62364103283118, 218, 16, 'PPL', 'P'),
(51848, 'Sunrise Mobile Home Park', 39.5272216796875, 0.68988016247623, -76.2822189331055, -1.33137588110985, 218, 25, 'PPL', 'P'),
(117964, 'Sunrise Mobile Home Park', 43.0833282470703, 0.751945930628854, -96.1597213745117, -1.6783037457856, 218, 16, 'PPL', 'P'),
(117965, 'Sunrise Mobile Home Village', 41.6388893127441, 0.726735715380864, -91.480827331543, -1.59664163938384, 218, 16, 'PPL', 'P'),
(83920, 'Sunrise Point', 35.101390838623, 0.612634842163346, -81.0541687011719, -1.41466211630239, 218, 48, 'PPL', 'P'),
(121634, 'Sunrise Ridge', 42.3791694641113, 0.739656041409384, -88.3666687011719, -1.54228931785447, 218, 18, 'PPL', 'P'),
(179270, 'Sunrise Springs', 35.6036109924316, 0.621400237417178, -109.744720458984, -1.91540670869006, 218, 5, 'PPL', 'P'),
(179271, 'Sunrise Terrace', 33.4958305358887, 0.584612528541314, -112.234169006348, -1.95885578240054, 218, 5, 'PPL', 'P'),
(197659, 'Sunrise Trailer Court', 48.167781829834, 0.840686386312902, -111.940559387207, -1.95373132783101, 218, 31, 'PPL', 'P'),
(91162, 'Sunrise Valley', 36.5380592346191, 0.637709435932823, -82.4005584716797, -1.43816105081292, 218, 50, 'PPL', 'P'),
(179272, 'Sunrise Village Mobile Home Park', 33.4594383239746, 0.58397736462133, -111.708892822266, -1.949687983506, 218, 5, 'PPL', 'P'),
(199715, 'Sunrise Village Mobile Home Park', 41.8569412231445, 0.730541439157615, -103.640281677246, -1.8088641529623, 218, 35, 'PPL', 'P'),
(185479, 'Sunrise Vista', 38.8800010681152, 0.678584031817523, -122.733062744141, -2.14209604594204, 218, 6, 'PPL', 'P'),
(179273, 'Sunrise Vista Mobile Home Park', 33.4099998474121, 0.583114500428144, -111.755279541016, -1.95049758447738, 218, 5, 'PPL', 'P'),
(201618, 'Sunriver', 43.8841705322266, 0.765923265294026, -121.4375, -2.11948421039061, 218, 43, 'PPL', 'P'),
(179274, 'Sunscape Homes', 33.461109161377, 0.584006526235267, -112.194442749023, -1.95816242841074, 218, 5, 'PPL', 'P'),
(12219, 'Sunset', 35.8102798461914, 0.625007289376609, -94.0130615234375, -1.64083746346398, 218, 4, 'PPL', 'P'),
(18240, 'Sunset', 25.7055606842041, 0.448646670010568, -80.3525009155273, -1.40241570318771, 218, 12, 'PPL', 'P'),
(25255, 'Sunset', 31.103609085083, 0.54286038778792, -83.7944412231445, -1.46248889421274, 218, 13, 'PPL', 'P'),
(38450, 'Sunset', 38.2844390869141, 0.668189514345862, -83.690559387207, -1.46067581414261, 218, 21, 'PPL', 'P'),
(43258, 'Sunset', 30.4111099243164, 0.530773997365245, -92.0683288574219, -1.60689547537092, 218, 22, 'PPL', 'P'),
(51849, 'Sunset', 38.6261100769043, 0.67415279807974, -76.5780563354492, -1.33653921783129, 218, 25, 'PPL', 'P'),
(57796, 'Sunset', 37.5511093139648, 0.655390495304996, -93.307502746582, -1.62852313974151, 218, 29, 'PPL', 'P'),
(61942, 'Sunset', 31.663890838623, 0.552639149126041, -89.6286087036133, -1.5643143258597, 218, 30, 'PPL', 'P'),
(77384, 'Sunset', 35.7544403076172, 0.624032705575694, -98.9683303833008, -1.72732322039014, 218, 42, 'PPL', 'P'),
(83921, 'Sunset', 34.9775009155273, 0.610472555095283, -82.7991714477539, -1.44511815968659, 218, 48, 'PPL', 'P'),
(91168, 'Sunset', 36.2513885498047, 0.632706088613864, -83.5833282470703, -1.45880427768656, 218, 50, 'PPL', 'P'),
(98385, 'Sunset', 33.4519386291504, 0.583846470253753, -97.7663879394531, -1.70634536732553, 218, 51, 'PPL', 'P'),
(129033, 'Sunset', 44.2058296203613, 0.77153727545094, -68.7052764892578, -1.1991332882306, 218, 26, 'PPL', 'P'),
(167773, 'Sunset', 40.3647193908691, 0.704497255014267, -76.4177780151367, -1.33374183342227, 218, 45, 'PPL', 'P'),
(176616, 'Sunset', 45.0033302307129, 0.785456286888239, -89.491943359375, -1.56192906562937, 218, 57, 'PPL', 'P'),
(179275, 'Sunset', 32.5238914489746, 0.567648991345836, -110.206672668457, -1.92346929573222, 218, 5, 'PPL', 'P'),
(189617, 'Sunset', 33.3394393920898, 0.581882988161065, -105.074722290039, -1.83389986457986, 218, 38, 'PPL', 'P'),
(192913, 'Sunset', 39.250560760498, 0.68505151852478, -121.650833129883, -2.12320757591065, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(194443, 'Sunset', 40.035831451416, 0.69875707760071, -105.468330383301, -1.84076962176977, 218, 7, 'PPL', 'P'),
(197660, 'Sunset', 46.938060760498, 0.819223704771844, -113.465827941895, -1.98035228608744, 218, 31, 'PPL', 'P'),
(201620, 'Sunset', 45.3600006103516, 0.791681359357272, -122.628890991211, -2.14027790586584, 218, 43, 'PPL', 'P'),
(205992, 'Sunset', 41.1363906860352, 0.717965459858042, -112.030281066895, -1.95529726655198, 218, 52, 'PPL', 'P'),
(208876, 'Sunset', 47.1208305358887, 0.822413639125541, -117.484443664551, -2.0504903618202, 218, 56, 'PPL', 'P'),
(6171, 'Sunset (historical)', 34.9330596923828, 0.609696909427798, -86.0772171020508, -1.50233084938476, 218, 2, 'PPL', 'P'),
(111617, 'Sunset (historical)', 38.2000007629395, 0.666715787577639, -79.9444427490234, -1.39529374464257, 218, 58, 'PPL', 'P'),
(195675, 'Sunset (historical)', 47.5625, 0.830122225479803, -115.834442138672, -2.02169240253069, 218, 17, 'PPL', 'P'),
(6172, 'Sunset Acres', 34.3191719055176, 0.598982546309218, -86.5138931274414, -1.50995228379235, 218, 2, 'PPL', 'P'),
(34093, 'Sunset Acres', 37.7249984741211, 0.65842543368325, -97.1283264160156, -1.69520909291126, 218, 20, 'PPL', 'P'),
(51851, 'Sunset Acres', 39.6388893127441, 0.691829130340978, -77.6847229003906, -1.35585419311126, 218, 25, 'PPL', 'P'),
(83923, 'Sunset Acres', 34.1666717529297, 0.596320916536766, -82.1194381713867, -1.43325457597861, 218, 48, 'PPL', 'P'),
(91166, 'Sunset Acres', 35.9674987792969, 0.627751277405772, -86.6969375610352, -1.51314701183601, 218, 50, 'PPL', 'P'),
(111618, 'Sunset Acres', 39.0469398498535, 0.681497663208124, -80.4966735839844, -1.40493199094367, 218, 58, 'PPL', 'P'),
(143146, 'Sunset Acres', 41.452220916748, 0.723477737261316, -97.0800018310547, -1.69436566979403, 218, 35, 'PPL', 'P'),
(98386, 'Sunset Acres Colonia', 27.7940006256104, 0.485096823218264, -99.4570007324219, -1.73585212693917, 218, 51, 'PPL', 'P'),
(153016, 'Sunset Bay', 42.563060760498, 0.742865549997093, -79.1336135864258, -1.38114210608405, 218, 40, 'PPL', 'P'),
(18242, 'Sunset Beach', 27.7519397735596, 0.484362722863784, -82.7633285522461, -1.44449258314653, 218, 12, 'PPL', 'P'),
(51852, 'Sunset Beach', 39.1583290100098, 0.683441770803882, -76.5227813720703, -1.33557448772641, 218, 25, 'PPL', 'P'),
(69237, 'Sunset Beach', 33.8805618286133, 0.591327356334812, -78.5124969482422, -1.37030157570883, 218, 33, 'PPL', 'P'),
(71455, 'Sunset Beach', 39.8138885498047, 0.694883443216162, -75.0961074829102, -1.31067433100833, 218, 37, 'PPL', 'P'),
(111619, 'Sunset Beach', 39.6794395446777, 0.692536865400666, -79.8566665649414, -1.3937617612255, 218, 58, 'PPL', 'P'),
(133325, 'Sunset Beach', 45.9625015258789, 0.802196984079505, -86.3163909912109, -1.5065052212354, 218, 27, 'PPL', 'P'),
(153018, 'Sunset Beach', 43.3711090087891, 0.756968652444743, -78.2724990844727, -1.3661128227883, 218, 40, 'PPL', 'P'),
(157871, 'Sunset Beach', 41.1136093139648, 0.717567849907294, -80.9719390869141, -1.41322693879094, 218, 41, 'PPL', 'P'),
(176618, 'Sunset Beach', 43.5016708374023, 0.75924738623147, -88.8655624389648, -1.55099665619654, 218, 57, 'PPL', 'P'),
(185480, 'Sunset Beach', 33.7163887023926, 0.588461994738969, -118.068061828613, -2.06067642035754, 218, 6, 'PPL', 'P'),
(201621, 'Sunset Beach', 46.101390838623, 0.804621059882722, -123.929168701172, -2.16297203309495, 218, 43, 'PPL', 'P'),
(208881, 'Sunset Beach', 47.0924987792969, 0.821919156690141, -122.961112976074, -2.14607627334922, 218, 56, 'PPL', 'P'),
(211105, 'Sunset Beach', 21.673059463501, 0.378266246618608, -158.048065185547, -2.75845911389442, 218, 15, 'PPL', 'P'),
(187419, 'Sunset City', 38.4124984741211, 0.670424572290711, -105.41667175293, -1.83986800858273, 218, 7, 'PPL', 'P'),
(179276, 'Sunset City (historical)', 35.0444412231445, 0.611640883865501, -110.652778625488, -1.93125531349518, 218, 5, 'PPL', 'P'),
(185481, 'Sunset Cliffs', 32.728889465332, 0.571226881691331, -117.260833740234, -2.04658763240075, 218, 6, 'PPL', 'P'),
(98387, 'Sunset Colonia', 26.423999786377, 0.461185797818556, -99.0619964599609, -1.72895800182529, 218, 51, 'PPL', 'P'),
(77385, 'Sunset Corner', 35.2383308410645, 0.615024896083637, -94.6719436645508, -1.652337126209, 218, 42, 'PPL', 'P'),
(18243, 'Sunset Corners', 25.7016696929932, 0.448578759402771, -80.3341674804688, -1.40209572438274, 218, 12, 'PPL', 'P'),
(111620, 'Sunset Court', 37.9605598449707, 0.662536755195087, -82.0219421386719, -1.4315529492001, 218, 58, 'PPL', 'P'),
(6173, 'Sunset Cove', 34.6444396972656, 0.604659540225913, -86.5286102294922, -1.51020914567948, 218, 2, 'PPL', 'P'),
(205996, 'Sunset Downs', 40.6558303833008, 0.709578100320947, -112.015281677246, -1.95503547781682, 218, 52, 'PPL', 'P'),
(208882, 'Sunset Farm', 47.6650009155273, 0.831911203942064, -122.747222900391, -2.1423431872912, 218, 56, 'PPL', 'P'),
(83925, 'Sunset Forest', 34.7750015258789, 0.606938274012639, -82.3305587768555, -1.43693932566284, 218, 48, 'PPL', 'P'),
(91169, 'Sunset Gap', 35.8583297729492, 0.625845918803875, -83.2827835083008, -1.45355878244548, 218, 50, 'PPL', 'P'),
(51853, 'Sunset Gardens', 39.6902809143066, 0.692726082996116, -76.0533294677734, -1.32738100631667, 218, 25, 'PPL', 'P'),
(18244, 'Sunset Harbor', 28.9916706085205, 0.506000107772351, -81.9794387817383, -1.43081112567846, 218, 12, 'PPL', 'P'),
(28740, 'Sunset Harbor', 37.6166687011719, 0.656534722467348, -88.9347229003906, -1.55220373396062, 218, 18, 'PPL', 'P'),
(157872, 'Sunset Harbor', 41.4211082458496, 0.722934718715049, -82.918327331543, -1.44719782218183, 218, 41, 'PPL', 'P'),
(25257, 'Sunset Heights', 34.3416709899902, 0.59937522941195, -83.8183288574219, -1.46290581208139, 218, 13, 'PPL', 'P'),
(111621, 'Sunset Heights', 39.276668548584, 0.685507185387293, -81.5022201538086, -1.42248208936924, 218, 58, 'PPL', 'P'),
(157873, 'Sunset Heights', 40.0997200012207, 0.699872143149126, -80.7827835083008, -1.40992555114562, 218, 41, 'PPL', 'P'),
(25258, 'Sunset Hill', 33.7508316040039, 0.589063136776027, -84.7041702270508, -1.47836666063179, 218, 13, 'PPL', 'P'),
(51855, 'Sunset Hill', 39.4513893127441, 0.688556637993488, -76.9927825927734, -1.34377755651607, 218, 25, 'PPL', 'P'),
(208883, 'Sunset Hill', 47.6758308410645, 0.832100221800432, -122.397216796875, -2.13623442838278, 218, 56, 'PPL', 'P'),
(146421, 'Sunset Hill Garden', 40.4366683959961, 0.705753002047266, -74.5875015258789, -1.30179748246288, 218, 37, 'PPL', 'P'),
(25260, 'Sunset Hills', 33.9136085510254, 0.591904130447896, -84.8080596923828, -1.48017987385997, 218, 13, 'PPL', 'P'),
(57797, 'Sunset Hills', 38.538890838623, 0.672630535200651, -90.4072189331055, -1.57790363795405, 218, 29, 'PPL', 'P'),
(69241, 'Sunset Hills', 36.4972190856934, 0.636996640867064, -79.8116683959961, -1.39297639502003, 218, 33, 'PPL', 'P'),
(91171, 'Sunset Hills', 36.5111083984375, 0.637239055105288, -82.5147171020508, -1.44015349478246, 218, 50, 'PPL', 'P'),
(106734, 'Sunset Hills', 37.2533302307129, 0.650193269858679, -80.0319366455078, -1.39682080121162, 218, 53, 'PPL', 'P'),
(179277, 'Sunset Hills', 33.6277809143066, 0.58691549709396, -112.035003662109, -1.95537969138771, 218, 5, 'PPL', 'P'),
(185484, 'Sunset Hills', 34.4955596923828, 0.602061093950322, -117.221389770508, -2.04589920525896, 218, 6, 'PPL', 'P'),
(83927, 'Sunset Homes', 33.9008293151855, 0.591681090706602, -80.3838882446289, -1.40296351542394, 218, 48, 'PPL', 'P'),
(51857, 'Sunset Knoll', 39.6500015258789, 0.692023075047363, -76.0283279418945, -1.32694464737206, 218, 25, 'PPL', 'P'),
(129034, 'Sunset Landing', 43.7266693115234, 0.763174350416846, -70.1391677856445, -1.22415941246824, 218, 26, 'PPL', 'P'),
(106735, 'Sunset Manor', 38.8444404602051, 0.67796338212548, -77.128059387207, -1.34613858198048, 218, 53, 'PPL', 'P'),
(167774, 'Sunset Manor', 40.3394393920898, 0.704056035800668, -76.8233337402344, -1.34082011612554, 218, 45, 'PPL', 'P'),
(138360, 'Sunset Mobile Home Park', 44.2761116027832, 0.772763927449031, -94.1872177124023, -1.64387706237414, 218, 28, 'PPL', 'P'),
(185485, 'Sunset Mobile Home Park', 38.6469383239746, 0.674516319568536, -121.061111450195, -2.11291499092972, 218, 6, 'PPL', 'P'),
(6175, 'Sunset Mountain', 33.5583305358887, 0.58570335932381, -86.9069366455078, -1.51681218728623, 218, 2, 'PPL', 'P'),
(179278, 'Sunset North', 33.6230583190918, 0.586833072258222, -112.086112976074, -1.95627171719484, 218, 5, 'PPL', 'P'),
(25261, 'Sunset Park', 32.0347213745117, 0.559111362944233, -81.0661087036133, -1.41487050865768, 218, 13, 'PPL', 'P'),
(34095, 'Sunset Park', 37.577220916748, 0.655846228746535, -97.3388900756836, -1.69888412205751, 218, 20, 'PPL', 'P'),
(129035, 'Sunset Park', 43.6172218322754, 0.76126413154596, -70.3133316040039, -1.22719914453645, 218, 26, 'PPL', 'P'),
(31264, 'Sunset Parkway', 38.9633293151855, 0.680038384088815, -85.9058303833008, -1.49933958684838, 218, 19, 'PPL', 'P'),
(167775, 'Sunset Pines', 41.1469383239746, 0.718149550868394, -77.470832824707, -1.35212110705324, 218, 45, 'PPL', 'P'),
(18245, 'Sunset Point', 25.0472202301025, 0.437156461487421, -80.4902801513672, -1.404820404494, 218, 12, 'PPL', 'P'),
(51858, 'Sunset Point', 39.4219398498535, 0.688042647903103, -75.9922180175781, -1.3263144103001, 218, 25, 'PPL', 'P'),
(176619, 'Sunset Point', 44.0555610656738, 0.76891459440943, -88.5875015258789, -1.54614357774209, 218, 57, 'PPL', 'P'),
(185487, 'Sunset Point', 38.1888885498047, 0.666521842871254, -120.36222076416, -2.10071704734688, 218, 6, 'PPL', 'P'),
(176620, 'Sunset Point (historical)', 43.8958282470703, 0.766126730801308, -91.3249969482422, -1.5939218861206, 218, 57, 'PPL', 'P'),
(153019, 'Sunset Ridge', 40.9791717529297, 0.715221471828879, -73.709716796875, -1.28647724881804, 218, 40, 'PPL', 'P'),
(185488, 'Sunset Ridge', 34.4538917541504, 0.601333851235649, -117.385559082031, -2.04876450027578, 218, 6, 'PPL', 'P'),
(179279, 'Sunset Ridge I', 33.6266708374023, 0.58689612259703, -111.947219848633, -1.95384757481259, 218, 5, 'PPL', 'P'),
(83928, 'Sunset Shores', 34.7369384765625, 0.606273948478719, -82.9652786254883, -1.44801727684925, 218, 48, 'PPL', 'P'),
(25262, 'Sunset Terrace', 32.4466705322266, 0.566301232097174, -84.9194412231445, -1.48212384829767, 218, 13, 'PPL', 'P'),
(51859, 'Sunset Terrace', 39.0194396972656, 0.681017695000665, -77.0274963378906, -1.34438342566407, 218, 25, 'PPL', 'P'),
(79237, 'Sunset Terrace', 39.9066696166992, 0.696502778316985, -76.6600036621094, -1.33796946849472, 218, 45, 'PPL', 'P'),
(208884, 'Sunset Terrace', 48.2161102294922, 0.841529876009157, -122.673057556152, -2.14104875784337, 218, 56, 'PPL', 'P'),
(179280, 'Sunset Trail Ranch', 33.413330078125, 0.583172623918935, -111.644439697266, -1.94856306426155, 218, 5, 'PPL', 'P'),
(197662, 'Sunset Trailer Court', 46.2347183227539, 0.806948063464206, -112.123611450195, -1.95692618903272, 218, 31, 'PPL', 'P'),
(98388, 'Sunset Valley', 30.2255592346191, 0.527535526900681, -97.8033294677734, -1.70699011862544, 218, 51, 'PPL', 'P'),
(157874, 'Sunset Valley', 40.5319404602051, 0.707415813252884, -81.2533264160156, -1.41813807415716, 218, 41, 'PPL', 'P'),
(167777, 'Sunset Valley', 40.3052787780762, 0.703459820611626, -79.7394409179688, -1.39171578771804, 218, 45, 'PPL', 'P'),
(51861, 'Sunset View', 39.3952789306641, 0.687577327081639, -77.5111083984375, -1.35282404842296, 218, 25, 'PPL', 'P'),
(113218, 'Sunset View', 43.2444381713867, 0.754757829265814, -76.9416732788086, -1.34288553070895, 218, 40, 'PPL', 'P'),
(185490, 'Sunset View', 39.2294387817383, 0.684682870450886, -121.095283508301, -2.11351140585584, 218, 6, 'PPL', 'P'),
(206003, 'Sunset View Estates', 40.9372215270996, 0.714489302266189, -111.880561828613, -1.95268417289039, 218, 52, 'PPL', 'P'),
(121635, 'Sunset Villa', 41.9083290100098, 0.731438325233726, -88.4280624389648, -1.54336084071906, 218, 18, 'PPL', 'P'),
(98389, 'Sunset Villa Colonia', 26.8729991912842, 0.469022315773682, -99.2979965209961, -1.73307697992526, 218, 51, 'PPL', 'P'),
(25263, 'Sunset Village', 32.8977813720703, 0.574174601543885, -84.4038925170898, -1.47312582592262, 218, 13, 'PPL', 'P'),
(31265, 'Sunset Village', 38.4569396972656, 0.671200217958197, -85.5344390869141, -1.49285758591318, 218, 19, 'PPL', 'P'),
(106736, 'Sunset Village', 37.2994384765625, 0.650998010561073, -80.0216674804688, -1.39664157047025, 218, 53, 'PPL', 'P'),
(117967, 'Sunset Village', 42.0458297729492, 0.733838166271024, -91.6750030517578, -1.60003064502902, 218, 16, 'PPL', 'P'),
(179281, 'Sunset Village', 33.5924987792969, 0.586299707670906, -112.259437561035, -1.95929680187706, 218, 5, 'PPL', 'P'),
(208885, 'Sunset Village', 47.5825004577637, 0.830471299319685, -122.138893127441, -2.13172582981533, 218, 56, 'PPL', 'P'),
(117968, 'Sunset Village Mobile Home Park', 42.0074996948242, 0.733169180205196, -92.8944396972656, -1.62131382951261, 218, 16, 'PPL', 'P'),
(51862, 'Sunset Vista', 39.5933303833008, 0.691033977018507, -77.0833282470703, -1.34535787630693, 218, 25, 'PPL', 'P'),
(179282, 'Sunset Vista', 33.648609161377, 0.587279018582756, -112.188331604004, -1.95805576880908, 218, 5, 'PPL', 'P'),
(51863, 'Sunset Way', 39.6327781677246, 0.69172247073932, -76.8313903808594, -1.3409607310311, 218, 25, 'PPL', 'P'),
(6179, 'Sunshine', 32.5597190856934, 0.568274301569787, -87.5486068725586, -1.52801144546028, 218, 2, 'PPL', 'P'),
(12221, 'Sunshine', 34.4744415283203, 0.601692512455455, -93.2358322143555, -1.6272722529775, 218, 4, 'PPL', 'P'),
(38452, 'Sunshine', 36.8372192382813, 0.642930762987005, -83.32861328125, -1.45435866287889, 218, 21, 'PPL', 'P'),
(43260, 'Sunshine', 29.5244407653809, 0.515298701165931, -90.7394409179688, -1.58370200543742, 218, 22, 'PPL', 'P'),
(51864, 'Sunshine', 39.2211112976074, 0.684537528434395, -77.0602798461914, -1.34495560582427, 218, 25, 'PPL', 'P'),
(69247, 'Sunshine', 35.4488906860352, 0.618699858650865, -81.8105621337891, -1.42786367214202, 218, 33, 'PPL', 'P'),
(74483, 'Sunshine', 38.7155609130859, 0.675714009689772, -83.315559387207, -1.45413082944763, 218, 41, 'PPL', 'P'),
(79238, 'Sunshine', 39.8163909912109, 0.69492711905804, -79.9166717529297, -1.39480904932417, 218, 45, 'PPL', 'P'),
(91175, 'Sunshine', 35.6833305358887, 0.62279160592869, -83.7936096191406, -1.4624743799848, 218, 50, 'PPL', 'P'),
(98390, 'Sunshine', 31.8633308410645, 0.556120033828829, -98.1444396972656, -1.71294361524231, 218, 51, 'PPL', 'P'),
(117969, 'Sunshine', 40.7397193908691, 0.711042239709245, -92.9250030517578, -1.62184726067895, 218, 16, 'PPL', 'P'),
(129036, 'Sunshine', 44.1972198486328, 0.771387006586432, -68.581672668457, -1.19697599458958, 218, 26, 'PPL', 'P'),
(179283, 'Sunshine', 35.1238899230957, 0.613027525266078, -111.030830383301, -1.93785356141196, 218, 5, 'PPL', 'P'),
(189618, 'Sunshine', 36.8438911437988, 0.643047209705669, -105.639442443848, -1.84375609061619, 218, 38, 'PPL', 'P'),
(194444, 'Sunshine', 40.0658302307129, 0.699280655071019, -105.366111755371, -1.83898557015553, 218, 7, 'PPL', 'P'),
(208886, 'Sunshine', 46.7197189331055, 0.815412920989023, -117.095001220703, -2.04369330892805, 218, 56, 'PPL', 'P'),
(209762, 'Sunshine', 44.0275001525879, 0.768424839084965, -108.990280151367, -1.90223924131238, 218, 59, 'PPL', 'P'),
(212172, 'Sunshine', 62.167781829834, 1.08503248159211, -150.073059082031, -2.61926899952142, 218, 1, 'PPL', 'P'),
(12222, 'Sunshine (historical)', 34.0311088562012, 0.593954897645312, -94.0130615234375, -1.64083746346398, 218, 4, 'PPL', 'P'),
(25264, 'Sunshine (historical)', 33.2986106872559, 0.581170392832387, -82.9197235107422, -1.4472221901058, 218, 13, 'PPL', 'P'),
(74484, 'Sunshine (historical)', 38.9069404602051, 0.679054212907976, -83.9258270263672, -1.46478200906935, 218, 41, 'PPL', 'P'),
(189619, 'Sunshine (historical)', 32.1383285522461, 0.560919649324397, -107.752220153809, -1.88063101801775, 218, 38, 'PPL', 'P'),
(51866, 'Sunshine Acres', 39.2236099243164, 0.684581137697245, -77.0580596923828, -1.34491685683041, 218, 25, 'PPL', 'P'),
(179284, 'Sunshine Acres', 33.4769401550293, 0.584282829198362, -111.713890075684, -1.9497752020317, 218, 5, 'PPL', 'P'),
(192292, 'Sunshine Acres Colonia', 31.5699996948242, 0.551000439528288, -106.216003417969, -1.85381897795311, 218, 51, 'PPL', 'P'),
(18246, 'Sunshine Beach', 27.7766704559326, 0.484794354697459, -82.7786102294922, -1.4447592987297, 218, 12, 'PPL', 'P'),
(133326, 'Sunshine Beach', 47.0888900756836, 0.821856172930361, -88.5155563354492, -1.54488789728812, 218, 27, 'PPL', 'P'),
(208887, 'Sunshine Beach', 47.3544387817383, 0.826490872175425, -122.730560302734, -2.14205237010016, 218, 56, 'PPL', 'P'),
(185491, 'Sunshine Camp', 37.9877815246582, 0.663011863133557, -120.281669616699, -2.09931116460743, 218, 6, 'PPL', 'P'),
(190805, 'Sunshine Camp (historical)', 39.2719383239746, 0.685424627393501, -114.986938476563, -2.00690067320417, 218, 39, 'PPL', 'P'),
(192974, 'Sunshine Colonia', 31.6660003662109, 0.552675967328111, -106.299003601074, -1.85526760442805, 218, 51, 'PPL', 'P'),
(31266, 'Sunshine Gardens', 39.688060760498, 0.692687334002256, -86.2111129760742, -1.5046677732413, 218, 19, 'PPL', 'P'),
(43261, 'Sunshine Heights', 32.5305595397949, 0.567765371485473, -92.1774978637695, -1.60880083397282, 218, 22, 'PPL', 'P'),
(18247, 'Sunshine Park', 26.0291690826416, 0.454294702050408, -80.211669921875, -1.39995773865962, 218, 12, 'PPL', 'P'),
(74485, 'Sunshine Park', 39.9958305358887, 0.698058929920945, -82.6166687011719, -1.4419328858648, 218, 41, 'PPL', 'P'),
(18249, 'Sunshine Ranches', 26.045560836792, 0.45458079213051, -80.3291702270508, -1.40200850585704, 218, 12, 'PPL', 'P'),
(189620, 'Sunshine Valley', 36.8416709899902, 0.643008460711809, -105.658332824707, -1.84408578995914, 218, 38, 'PPL', 'P'),
(179285, 'Sunshine Valley Mobile Home Park', 33.2816696166992, 0.580874715372361, -111.844436645508, -1.95205366950231, 218, 5, 'PPL', 'P'),
(153020, 'Sunside', 42.3402786254883, 0.73897726822655, -74.0788879394531, -1.29292050075937, 218, 40, 'PPL', 'P'),
(206005, 'Sunstone', 40.6697196960449, 0.709820514559171, -111.908332824707, -1.95316886820878, 218, 52, 'PPL', 'P'),
(25266, 'Sunsweet', 31.5691699981689, 0.55098595858986, -83.5658264160156, -1.45849881310953, 218, 13, 'PPL', 'P'),
(77388, 'Sunsweet', 36.5825004577637, 0.638485081600309, -95.3238906860352, -1.66371574828247, 218, 42, 'PPL', 'P'),
(185492, 'Sunsweet', 34.060001373291, 0.594459167197718, -117.683891296387, -2.05397137968105, 218, 6, 'PPL', 'P'),
(201622, 'Suntex', 43.5908317565918, 0.76080353783543, -119.629173278809, -2.08792295515403, 218, 43, 'PPL', 'P'),
(179286, 'Suntrails', 33.3972206115723, 0.58289146068685, -111.757217407227, -1.95053140662322, 218, 5, 'PPL', 'P'),
(212173, 'Suntrana', 63.8541717529297, 1.11446553822258, -148.848327636719, -2.59789340334801, 218, 1, 'PPL', 'P'),
(179287, 'Suntree', 33.3833312988281, 0.582649046448626, -111.765281677246, -1.95067215468683, 218, 5, 'PPL', 'P'),
(91176, 'Suntree Subdivision', 36.2119407653809, 0.632017594893051, -85.4736099243164, -1.49179591674462, 218, 50, 'PPL', 'P'),
(18250, 'Sunvale', 27.3102798461914, 0.476654302957091, -81.2669372558594, -1.41837562812639, 218, 12, 'PPL', 'P'),
(31267, 'Sunview', 39.9488906860352, 0.69723967499061, -85.8399963378906, -1.49819056599607, 218, 19, 'PPL', 'P'),
(51867, 'Sunview', 39.6819381713867, 0.692580474663516, -76.0774993896484, -1.32780285103334, 218, 25, 'PPL', 'P'),
(179288, 'Sunview', 33.3763885498047, 0.582527872619027, -111.794441223145, -1.95118108477115, 218, 5, 'PPL', 'P'),
(167778, 'Sunville', 41.5519409179688, 0.72521817961271, -79.8349990844727, -1.39338359235071, 218, 45, 'PPL', 'P'),
(138361, 'Suomi', 47.4833297729492, 0.828740444348215, -93.7411117553711, -1.63609104461119, 218, 28, 'PPL', 'P'),
(179289, 'Supai', 36.2369384765625, 0.632453887258634, -112.688331604004, -1.96678241506905, 218, 5, 'PPL', 'P'),
(12223, 'Super (historical)', 34.5672187805176, 0.603311780977251, -91.5652770996094, -1.59811556588915, 218, 4, 'PPL', 'P'),
(6182, 'Superior', 33.2105598449707, 0.579633615725356, -86.9302825927734, -1.51721965093301, 218, 2, 'PPL', 'P'),
(31268, 'Superior', 39.6294403076172, 0.691664214090474, -87.1555633544922, -1.5211515419664, 218, 19, 'PPL', 'P'),
(43262, 'Superior', 32.8247184753418, 0.572899413434927, -93.9786071777344, -1.64023612168984, 218, 22, 'PPL', 'P'),
(111622, 'Superior', 37.4211082458496, 0.653121548635275, -81.5425033569336, -1.42318516389702, 218, 58, 'PPL', 'P'),
(117970, 'Superior', 43.4302787780762, 0.758001359736449, -94.9461135864258, -1.65712229405565, 218, 16, 'PPL', 'P'),
(133328, 'Superior', 42.2630615234375, 0.737629575556915, -83.6377792358398, -1.45975462672155, 218, 27, 'PPL', 'P'),
(143147, 'Superior', 40.0208282470703, 0.698495222286528, -98.0697174072266, -1.7116394652565, 218, 35, 'PPL', 'P'),
(167779, 'Superior', 40.355281829834, 0.704332538500845, -79.3383331298828, -1.38471513616055, 218, 45, 'PPL', 'P'),
(176621, 'Superior', 46.7208290100098, 0.815432295485953, -92.103889465332, -1.60751612506296, 218, 57, 'PPL', 'P'),
(179290, 'Superior', 33.2938919067383, 0.581088034575676, -111.095558166504, -1.93898327434637, 218, 5, 'PPL', 'P'),
(187420, 'Superior', 39.9527816772461, 0.697307585598407, -105.168060302734, -1.83552892021866, 218, 7, 'PPL', 'P'),
(197663, 'Superior', 47.1916694641113, 0.823650011661611, -114.890830993652, -2.00522328119158, 218, 31, 'PPL', 'P'),
(209763, 'Superior', 41.7694396972656, 0.729014249430509, -108.975830078125, -1.90198703995715, 218, 59, 'PPL', 'P'),
(157876, 'Superior (historical)', 41.4041709899902, 0.72263910783405, -80.5533294677734, -1.40592082265642, 218, 41, 'PPL', 'P'),
(111623, 'Superior Bottom', 37.7488899230957, 0.658842418130929, -81.9994430541992, -1.43116026609737, 218, 58, 'PPL', 'P'),
(176622, 'Superior Village', 46.6569404602051, 0.814317229937537, -92.1041717529297, -1.60752105191098, 218, 57, 'PPL', 'P'),
(179291, 'Superstition Country Subdivision', 33.4002799987793, 0.582944857066706, -111.629173278809, -1.94829661499448, 218, 5, 'PPL', 'P'),
(179292, 'Superstition Shadows Mobile Home Park', 33.4166717529297, 0.583230947146808, -111.590827941895, -1.94762736261255, 218, 5, 'PPL', 'P'),
(167780, 'Suplee', 40.0994415283203, 0.699867282880136, -75.8794403076172, -1.32434606793842, 218, 45, 'PPL', 'P'),
(201623, 'Suplee', 44.0694389343262, 0.769156808910573, -119.675559997559, -2.08873255612541, 218, 43, 'PPL', 'P'),
(34098, 'Suppesville', 37.5008316040039, 0.654512983725814, -97.7699966430664, -1.70640835108531, 218, 20, 'PPL', 'P'),
(208888, 'Supplee', 47.6519393920898, 0.831683237352753, -119.88166809082, -2.09232982096784, 218, 56, 'PPL', 'P'),
(12224, 'Supply', 36.4569396972656, 0.63629363291831, -90.8413925170898, -1.58548139651976, 218, 4, 'PPL', 'P'),
(112804, 'Supply', 34.0175018310547, 0.593717410255104, -78.2677764892578, -1.36603039795256, 218, 33, 'PPL', 'P'),
(43263, 'Supreme', 29.8591709136963, 0.521140844359724, -90.9811096191406, -1.58791991997189, 218, 22, 'PPL', 'P'),
(83930, 'Supreme Forest', 34.8027801513672, 0.607423102489088, -82.4433288574219, -1.43890753486647, 218, 48, 'PPL', 'P'),
(61944, 'Suqualena', 32.4433288574219, 0.566242908869302, -88.8263931274414, -1.55031302274472, 218, 30, 'PPL', 'P'),
(208889, 'Suquamish', 47.7313919067383, 0.833069945332357, -122.551109313965, -2.13892035950018, 218, 56, 'PPL', 'P'),
(111624, 'Surbaugh', 38.0144386291504, 0.663477117375994, -80.7955627441406, -1.41014859088692, 218, 58, 'PPL', 'P'),
(106738, 'Surber', 37.6311111450195, 0.656786790664524, -79.9430618286133, -1.3952696430347, 218, 53, 'PPL', 'P'),
(18251, 'Surf', 29.9847202301025, 0.523332093304641, -84.4211120605469, -1.47342636365164, 218, 12, 'PPL', 'P'),
(185494, 'Surf', 34.684440612793, 0.605357687905677, -120.602500915527, -2.10491072711543, 218, 6, 'PPL', 'P'),
(185495, 'Surf and Sand Mobile Home Park', 36.9697189331055, 0.645243318919576, -121.956390380859, -2.12854055599354, 218, 6, 'PPL', 'P'),
(69251, 'Surf City', 34.4269409179688, 0.600863470408114, -77.54638671875, -1.35343977126699, 218, 33, 'PPL', 'P'),
(71456, 'Surf City', 39.6619415283203, 0.692231467402661, -74.1655578613281, -1.29443317625854, 218, 37, 'PPL', 'P'),
(66, 'Surf Oaks', 29.5888900756836, 0.516423553831353, -94.9961090087891, -1.65799487878682, 218, 51, 'PPL', 'P'),
(83931, 'Surf Pines', 33.6166687011719, 0.586721552387575, -78.9899978637695, -1.37863553886607, 218, 48, 'PPL', 'P'),
(201624, 'Surf Pines', 46.0583305358887, 0.803869515823102, -123.922218322754, -2.1628507261073, 218, 43, 'PPL', 'P'),
(25267, 'Surf Side Club Estates', 34.3741683959961, 0.59994241614511, -83.7502822875977, -1.46171817539327, 218, 13, 'PPL', 'P'),
(18252, 'Surfside', 25.878059387207, 0.451657340333389, -80.1258316040039, -1.3984595773884, 218, 12, 'PPL', 'P'),
(51868, 'Surfside', 39.1616706848145, 0.683500094031755, -76.5038909912109, -1.33524478838346, 218, 25, 'PPL', 'P'),
(98391, 'Surfside', 28.9430599212646, 0.505151691228079, -95.2975006103516, -1.66325515457194, 218, 51, 'PPL', 'P'),
(126294, 'Surfside', 41.2444381713867, 0.719851244225928, -70.0883331298828, -1.22327218035108, 218, 23, 'PPL', 'P'),
(129039, 'Surfside', 43.5288887023926, 0.759722427590913, -70.3630599975586, -1.22806706873571, 218, 26, 'PPL', 'P'),
(185496, 'Surfside', 33.7277793884277, 0.588660799714343, -118.081390380859, -2.06090904747876, 218, 6, 'PPL', 'P'),
(83932, 'Surfside Beach', 33.6058311462402, 0.586532401371152, -78.9733276367188, -1.37834458851697, 218, 48, 'PPL', 'P'),
(98392, 'Surfside Beach', 28.9441699981689, 0.505171065725009, -95.2886123657227, -1.66310002543844, 218, 51, 'PPL', 'P'),
(167781, 'Surgeon Hall', 40.3480606079102, 0.704206504402257, -79.9663925170898, -1.39567684036537, 218, 45, 'PPL', 'P'),
(6183, 'Surginer', 32.0552787780762, 0.559470157322094, -87.7091674804688, -1.53081375671732, 218, 2, 'PPL', 'P'),
(91177, 'Surgoinsville', 36.4708290100098, 0.636536047156534, -82.851936340332, -1.44603908079154, 218, 50, 'PPL', 'P'),
(193990, 'Surgone', 41.3349990844727, 0.72143183033289, -123.853332519531, -2.16164844203318, 218, 6, 'PPL', 'P'),
(176627, 'Suring', 44.9991683959961, 0.785383649169507, -88.371940612793, -1.54238133007013, 218, 57, 'PPL', 'P'),
(69252, 'Surl', 36.3436088562012, 0.634315636597681, -78.8974990844727, -1.37702113061326, 218, 33, 'PPL', 'P'),
(111625, 'Surosa', 37.6413917541504, 0.656966221142968, -82.1752777099609, -1.43422915977952, 218, 58, 'PPL', 'P'),
(31269, 'Surprise', 38.9705581665039, 0.680164551345458, -86.0588912963867, -1.50201100373784, 218, 19, 'PPL', 'P'),
(91178, 'Surprise', 35.646110534668, 0.622141994359792, -84.6338882446289, -1.4771400086337, 218, 50, 'PPL', 'P'),
(106740, 'Surprise', 38.4019393920898, 0.670240281543277, -78.0677795410156, -1.36253979271179, 218, 53, 'PPL', 'P'),
(143148, 'Surprise', 41.1086082458496, 0.717480564802566, -97.3108291625977, -1.69839436673305, 218, 35, 'PPL', 'P'),
(153021, 'Surprise', 42.3925018310547, 0.739888735109629, -73.9502792358398, -1.2906758554346, 218, 40, 'PPL', 'P'),
(179293, 'Surprise', 33.6305618286133, 0.586964033204827, -112.332496643066, -1.96057192340699, 218, 5, 'PPL', 'P'),
(157878, 'Surprise (historical)', 40.6105613708496, 0.708788007004548, -82.8433303833008, -1.44588887850605, 218, 41, 'PPL', 'P'),
(197664, 'Surprise Creek Colony', 47.170280456543, 0.823276703055809, -110.33943939209, -1.9257865121967, 218, 31, 'PPL', 'P'),
(106739, 'Surprise Hill', 37.8699989318848, 0.660956169088125, -76.3141708374023, -1.33193354704211, 218, 53, 'PPL', 'P'),
(193991, 'Surprise Station', 41.5738906860352, 0.725601275335518, -120.435279846191, -2.10199216887681, 218, 6, 'PPL', 'P'),
(201625, 'Surprise Valley', 42.9541702270508, 0.749691697924156, -123.308326721191, -2.15213629640969, 218, 43, 'PPL', 'P'),
(208890, 'Surprise Valley', 46.9305610656738, 0.819092810404267, -122.231666564941, -2.13334503175809, 218, 56, 'PPL', 'P'),
(25268, 'Surrency', 31.7236099243164, 0.55368144379767, -82.1980590820313, -1.43462676973027, 218, 13, 'PPL', 'P'),
(121636, 'Surrey', 40.9116706848145, 0.714043355941655, -90.4680633544922, -1.57896557343871, 218, 18, 'PPL', 'P'),
(123764, 'Surrey', 40.9980583190918, 0.715551104592804, -87.2002792358398, -1.52193198132385, 218, 19, 'PPL', 'P'),
(198979, 'Surrey', 48.2363891601563, 0.841883810118029, -101.133056640625, -1.76510482098482, 218, 34, 'PPL', 'P'),
(14690, 'Surrey Park', 39.8041687011719, 0.694713799854724, -75.5305633544922, -1.31825701642206, 218, 10, 'PPL', 'P'),
(71458, 'Surrey Place', 39.9322204589844, 0.696948724641519, -74.9961090087891, -1.30892902838795, 218, 37, 'PPL', 'P'),
(51870, 'Surrey Ridge', 39.686939239502, 0.692667759768243, -75.8600006103516, -1.32400678121554, 218, 25, 'PPL', 'P'),
(106741, 'Surry', 37.1377792358398, 0.648176524544189, -76.835563659668, -1.34103356848691, 218, 53, 'PPL', 'P'),
(129037, 'Surry', 44.4958305358887, 0.77659874626069, -68.5022201538086, -1.19558928660998, 218, 26, 'PPL', 'P'),
(144533, 'Surry', 43.0177803039551, 0.750801903203583, -72.3216705322266, -1.26225127132991, 218, 36, 'PPL', 'P'),
(25270, 'Surry Chase', 33.6227798461914, 0.586828211989233, -83.7427825927734, -1.46158728102569, 218, 13, 'PPL', 'P'),
(106743, 'Surry Hills', 36.5980606079102, 0.63875665745247, -79.4713897705078, -1.3870374126311, 218, 53, 'PPL', 'P'),
(31270, 'Survant', 38.3738899230957, 0.669750725955894, -87.1552810668945, -1.52114661511839, 218, 19, 'PPL', 'P'),
(111626, 'Surveyor', 37.7658309936523, 0.659138095590955, -81.3180618286133, -1.41926792024962, 218, 58, 'PPL', 'P'),
(167782, 'Surveyor', 41.0738906860352, 0.716874629075546, -78.3258285522461, -1.36704359758928, 218, 45, 'PPL', 'P'),
(106744, 'Susan', 37.3658294677734, 0.652156751951367, -76.3138885498047, -1.33192862019409, 218, 53, 'PPL', 'P'),
(14691, 'Susan Beach Corner', 38.4680595397949, 0.671394295822636, -75.6527786254883, -1.32039007529716, 218, 10, 'PPL', 'P'),
(34099, 'Susank', 38.6408309936523, 0.674409726545905, -98.7736129760742, -1.72392476052309, 218, 20, 'PPL', 'P'),
(57798, 'Susanna', 37.3794403076172, 0.652394305920602, -92.7302780151367, -1.61844866765385, 218, 29, 'PPL', 'P'),
(193992, 'Susanville', 40.416389465332, 0.705399067938395, -120.65193939209, -2.10577359130861, 218, 6, 'PPL', 'P'),
(201626, 'Susanville', 44.7133293151855, 0.780394816078489, -118.782783508301, -2.07315066690347, 218, 43, 'PPL', 'P'),
(185497, 'Suscol', 38.2438888549805, 0.667481779286173, -122.283889770508, -2.13425649864117, 218, 6, 'PPL', 'P'),
(167783, 'Suscon', 41.3022193908691, 0.720859716751713, -75.7227783203125, -1.32161180044723, 218, 45, 'PPL', 'P'),
(38453, 'Susie', 36.7763900756836, 0.641869093818445, -84.9563903808594, -1.48276873275564, 218, 21, 'PPL', 'P'),
(61945, 'Susie', 33.7541694641113, 0.589121393424873, -89.5500030517578, -1.56294239842414, 218, 30, 'PPL', 'P'),
(208891, 'Susie', 46.5922203063965, 0.81318765016118, -119.622222900391, -2.08780164816638, 218, 56, 'PPL', 'P'),
(212174, 'Susitna', 61.5436096191406, 1.07413862141606, -150.512496948242, -2.62693863714474, 218, 1, 'PPL', 'P'),
(91180, 'Susong', 36.1719398498535, 0.631319447213287, -83.192497253418, -1.45198299002848, 218, 50, 'PPL', 'P'),
(6185, 'Suspension', 32.1963882446289, 0.561932982119172, -85.5880584716797, -1.49379342072024, 218, 2, 'PPL', 'P'),
(167791, 'Susquehanna', 41.9433288574219, 0.732049187808763, -75.5999984741211, -1.3194688878761, 218, 45, 'PPL', 'P'),
(51873, 'Susquehanna (historical)', 38.3036117553711, 0.66852414053683, -76.4138870239258, -1.33367392281448, 218, 25, 'PPL', 'P'),
(79240, 'Susquehanna Heights', 39.9047203063965, 0.696468756434059, -76.725830078125, -1.33911835618898, 218, 45, 'PPL', 'P'),
(51871, 'Susquehanna Hills', 39.6749992370605, 0.692459367412945, -76.1638870239258, -1.32931059968449, 218, 25, 'PPL', 'P'),
(167786, 'Susquehanna Manor', 40.2941703796387, 0.703265942484268, -76.8483276367188, -1.3412563419121, 218, 45, 'PPL', 'P'),
(51872, 'Susquehanna Point', 38.5061111450195, 0.672058421619475, -76.2569427490234, -1.33093472847527, 218, 25, 'PPL', 'P'),
(51876, 'Susquehanna River Hills', 39.5713882446289, 0.690651014453754, -76.1319427490234, -1.32875306691028, 218, 25, 'PPL', 'P'),
(79241, 'Susquehanna Trails', 39.7586097717285, 0.693918646532254, -76.3683319091797, -1.33287883607103, 218, 45, 'PPL', 'P'),
(106746, 'Sussex', 36.9150009155273, 0.644288309352673, -77.2794418334961, -1.34878070409795, 218, 53, 'PPL', 'P'),
(146422, 'Sussex', 41.2097206115723, 0.719245308498907, -74.6080627441406, -1.30215634341977, 218, 37, 'PPL', 'P'),
(176628, 'Sussex', 43.1338882446289, 0.752828369056052, -88.2219390869141, -1.53976330956053, 218, 57, 'PPL', 'P'),
(209764, 'Sussex', 43.6983299255371, 0.762679734823391, -106.294441223145, -1.85518797591146, 218, 59, 'PPL', 'P'),
(106747, 'Sussex At Hampton', 37.0055618286133, 0.645868895459635, -76.3530578613281, -1.33261225364592, 218, 53, 'PPL', 'P'),
(25274, 'Sussex Commons', 32.4141693115234, 0.565733978784988, -81.7861099243164, -1.42743690057733, 218, 13, 'PPL', 'P'),
(14693, 'Sussex Estates', 38.6019401550293, 0.673730953363072, -75.5561065673828, -1.31870282958854, 218, 10, 'PPL', 'P'),
(25271, 'Sussex Manor', 33.5338897705078, 0.585276787496207, -84.3844375610352, -1.47278627288364, 218, 13, 'PPL', 'P'),
(146424, 'Sussex Mills', 41.0513916015625, 0.716481945972814, -74.6808319091797, -1.30342640494363, 218, 37, 'PPL', 'P'),
(14694, 'Sussex Shores', 38.5499992370605, 0.672824413328009, -75.057502746582, -1.31000055125254, 218, 10, 'PPL', 'P'),
(209765, 'Sussex Unit', 43.607780456543, 0.761099348453511, -106.201393127441, -1.85356398027873, 218, 59, 'PPL', 'P'),
(14695, 'Sussex Woods', 38.836109161377, 0.677817973529962, -75.4391708374023, -1.31666191608716, 218, 10, 'PPL', 'P'),
(25272, 'Sutallee', 34.2227783203125, 0.597300160869588, -84.6180572509766, -1.4768637056706, 218, 13, 'PPL', 'P'),
(190806, 'Sutcliffe', 39.9502792358398, 0.69726390975653, -119.59944152832, -2.08740403821563, 218, 39, 'PPL', 'P'),
(111627, 'Suter (historical)', 39.6186103820801, 0.691475196232106, -80.6513900756836, -1.40763230313096, 218, 58, 'PPL', 'P'),
(167792, 'Sutersville', 40.2361106872559, 0.702252609689493, -79.7994384765625, -1.39276294265866, 218, 45, 'PPL', 'P'),
(38456, 'Suterville', 38.3680610656738, 0.669648993202253, -84.70361328125, -1.47835694009381, 218, 21, 'PPL', 'P'),
(38454, 'Sutherland', 37.6699981689453, 0.657465497268331, -87.1211090087891, -1.52055020019226, 218, 21, 'PPL', 'P'),
(57799, 'Sutherland', 38.5849990844727, 0.673435275903046, -93.5924987792969, -1.6334972588675, 218, 29, 'PPL', 'P'),
(69255, 'Sutherland', 36.3941688537598, 0.635198075024879, -81.6919403076172, -1.42579333071059, 218, 33, 'PPL', 'P'),
(91179, 'Sutherland', 36.6041717529297, 0.638863317054127, -81.8102798461914, -1.427858745294, 218, 50, 'PPL', 'P'),
(106751, 'Sutherland', 36.9575004577637, 0.645030066295288, -81.1613922119141, -1.41653351960038, 218, 53, 'PPL', 'P'),
(117972, 'Sutherland', 42.9741706848145, 0.750040771764038, -95.4972229003906, -1.66674096612275, 218, 16, 'PPL', 'P'),
(176630, 'Sutherland', 46.4375, 0.810487271394867, -91.1763916015625, -1.59132823353497, 218, 57, 'PPL', 'P'),
(192812, 'Sutherland', 39.3888893127441, 0.687465807210992, -112.632781982422, -1.96581289127421, 218, 52, 'PPL', 'P'),
(199716, 'Sutherland', 41.1569404602051, 0.718324121077849, -101.125831604004, -1.76497872030721, 218, 35, 'PPL', 'P'),
(111628, 'Sutherland (historical)', 39.5036087036133, 0.689468038297541, -79.7108306884766, -1.39121644501365, 218, 58, 'PPL', 'P'),
(197665, 'Sutherland (historical)', 46.5780601501465, 0.812940508812021, -105.344436645508, -1.83860726812268, 218, 31, 'PPL', 'P'),
(12227, 'Sutherland Crossroads', 35.5347213745117, 0.620197886764035, -93.7705612182617, -1.63660503470157, 218, 4, 'PPL', 'P'),
(106752, 'Sutherland Manor', 37.1911087036133, 0.649107299345172, -77.5508270263672, -1.35351726925471, 218, 53, 'PPL', 'P'),
(98393, 'Sutherland Springs', 29.2730598449707, 0.51091127642808, -98.0563888549805, -1.71140683813528, 218, 51, 'PPL', 'P'),
(126295, 'Sutherland Woods', 42.4211082458496, 0.740388011234992, -71.2058334350586, -1.24277624006844, 218, 23, 'PPL', 'P'),
(18253, 'Sutherlands Still', 29.5733299255371, 0.516151977979192, -81.6033325195313, -1.42424683306558, 218, 12, 'PPL', 'P'),
(106753, 'Sutherlin', 36.6247215270996, 0.639221978273934, -79.1972198486328, -1.38225224478445, 218, 53, 'PPL', 'P'),
(201627, 'Sutherlin', 43.3902816772461, 0.757303278635712, -123.311393737793, -2.1521898259476, 218, 43, 'PPL', 'P'),
(208892, 'Sutico', 46.6330604553223, 0.81390044522694, -123.524436950684, -2.15590813146157, 218, 56, 'PPL', 'P'),
(117973, 'Sutliff', 41.839168548584, 0.730231247469648, -91.3913879394531, -1.59508062751089, 218, 16, 'PPL', 'P'),
(34100, 'Sutphen', 39.0483283996582, 0.681521897974044, -97.0550003051758, -1.69392931084942, 218, 20, 'PPL', 'P'),
(69256, 'Sutphin', 35.8891716003418, 0.626384210239207, -79.3469390869141, -1.38486533844603, 218, 33, 'PPL', 'P'),
(190808, 'Sutro', 39.2799987792969, 0.685565308878084, -119.583061218262, -2.08711814787261, 218, 39, 'PPL', 'P'),
(206009, 'Sutro', 40.0919418334961, 0.699736388512559, -111.596389770508, -1.94772443483428, 218, 52, 'PPL', 'P'),
(69257, 'Suttentown', 35.2066688537598, 0.614472290157446, -78.2569427490234, -1.36584131351516, 218, 33, 'PPL', 'P'),
(121648, 'Sutter', 40.2791709899902, 0.703004153749114, -91.3433303833008, -1.59424186492557, 218, 18, 'PPL', 'P'),
(185498, 'Sutter', 39.1599998474121, 0.683470932417818, -121.751670837402, -2.12496752591703, 218, 6, 'PPL', 'P'),
(185500, 'Sutter Creek', 38.3930587768555, 0.670085285567835, -120.801391601563, -2.10838202443829, 218, 6, 'PPL', 'P'),
(185501, 'Sutter Hill', 38.3783302307129, 0.669828223943615, -120.800559997559, -2.10836751021035, 218, 6, 'PPL', 'P'),
(6186, 'Suttle', 32.5361099243164, 0.567862243970124, -87.1797180175781, -1.52157312036696, 218, 2, 'PPL', 'P'),
(12228, 'Suttle', 35.9761085510254, 0.62790154627028, -94.398063659668, -1.64755701836841, 218, 4, 'PPL', 'P'),
(25273, 'Suttles Mill', 34.625, 0.604320253503037, -85.1833267211914, -1.48672951908686, 218, 13, 'PPL', 'P'),
(12229, 'Sutton', 33.644718170166, 0.587211107974959, -93.3983306884766, -1.63010838638038, 218, 4, 'PPL', 'P'),
(38455, 'Sutton', 37.416389465332, 0.653039190378565, -82.456672668457, -1.43914042830379, 218, 21, 'PPL', 'P'),
(69258, 'Sutton', 35.9275016784668, 0.627053196305035, -78.2613906860352, -1.36591894466094, 218, 33, 'PPL', 'P'),
(98394, 'Sutton', 30.8211097717285, 0.537929844635261, -96.5297164916992, -1.68476137879682, 218, 51, 'PPL', 'P'),
(111629, 'Sutton', 38.6644401550293, 0.674821784145568, -80.7099990844727, -1.40865522330566, 218, 58, 'PPL', 'P'),
(121639, 'Sutton', 42.0958290100098, 0.734710817581215, -88.1941680908203, -1.53927861424214, 218, 18, 'PPL', 'P'),
(126296, 'Sutton', 42.1500015258789, 0.735656306347221, -71.7633285522461, -1.25250636542715, 218, 23, 'PPL', 'P'),
(140938, 'Sutton', 47.4019393920898, 0.827319914222767, -98.4388885498047, -1.71808271719784, 218, 34, 'PPL', 'P'),
(143149, 'Sutton', 40.6055603027344, 0.70870072189982, -97.85888671875, -1.70795977557834, 218, 35, 'PPL', 'P'),
(144534, 'Sutton', 43.334171295166, 0.756323967723862, -71.9519424438477, -1.2557982988506, 218, 36, 'PPL', 'P'),
(167794, 'Sutton', 41.1483306884766, 0.718173852213341, -79.2155609130859, -1.38257235674748, 218, 45, 'PPL', 'P'),
(172622, 'Sutton', 44.6330604553223, 0.778993860187053, -72.0261077880859, -1.25709272829843, 218, 55, 'PPL', 'P'),
(187924, 'Sutton', 37.9058303833008, 0.661581545891103, -101.464996337891, -1.77089826162018, 218, 20, 'PPL', 'P'),
(206010, 'Sutton', 40.5916709899902, 0.708458307661596, -111.794441223145, -1.95118108477115, 218, 52, 'PPL', 'P'),
(208893, 'Sutton', 46.9027786254883, 0.818607915348791, -117.843063354492, -2.05674945617216, 218, 56, 'PPL', 'P'),
(212175, 'Sutton', 61.7113914489746, 1.07706696677168, -148.894165039063, -2.59869341693947, 218, 1, 'PPL', 'P'),
(146426, 'Sutton (historical)', 40.6822204589844, 0.710038694031476, -74.7225036621094, -1.30415371423733, 218, 37, 'PPL', 'P'),
(51874, 'Sutton Acres', 38.496940612793, 0.671898365637961, -77.0202789306641, -1.34425745814451, 218, 25, 'PPL', 'P'),
(206011, 'Sutton Estates', 40.7055587768555, 0.710446024520204, -112.076942443848, -1.95611166121332, 218, 52, 'PPL', 'P'),
(43264, 'Sutton Junction (historical)', 30.9063892364502, 0.539418252078992, -93.503059387207, -1.63193624699455, 218, 22, 'PPL', 'P'),
(51875, 'Sutton Manor', 39.6055603027344, 0.691247429379877, -76.5538864135742, -1.33611737311462, 218, 25, 'PPL', 'P'),
(167795, 'Sutton Mill', 41.1902809143066, 0.718906021776031, -79.7819366455078, -1.39245747808163, 218, 45, 'PPL', 'P'),
(146427, 'Sutton Park', 40.8250007629395, 0.71253068044249, -74.7055587768555, -1.30385797019828, 218, 37, 'PPL', 'P'),
(13217, 'Sutton Place', 38.9313888549805, 0.679480917893634, -77.0819396972656, -1.34533364154101, 218, 9, 'PPL', 'P'),
(83933, 'Sutton Spring (historical)', 34.9811096191406, 0.610535538855064, -81.2916717529297, -1.41880732653909, 218, 48, 'PPL', 'P'),
(167796, 'Sutton Terrace', 40.0066719055176, 0.698248147516396, -75.2200012207031, -1.31283668465542, 218, 45, 'PPL', 'P'),
(83934, 'Suttons', 33.3938903808594, 0.582833337196059, -79.7438888549805, -1.39179341886382, 218, 48, 'PPL', 'P'),
(133332, 'Suttons Bay', 44.9766693115234, 0.784990966066775, -85.6505584716797, -1.49488425150273, 218, 27, 'PPL', 'P'),
(25275, 'Suttons Corner', 31.6005592346191, 0.551533804115603, -84.8441696166992, -1.48081011093194, 218, 13, 'PPL', 'P'),
(69260, 'Suttons Corner', 34.644718170166, 0.604664400494902, -78.5927810668945, -1.37170279791637, 218, 33, 'PPL', 'P'),
(153022, 'Suttons Corner', 43.3241691589355, 0.756149397514408, -76.2880630493164, -1.3314778801796, 218, 40, 'PPL', 'P'),
(98395, 'Suttons Mill', 31.4880599975586, 0.549570322022915, -94.3808288574219, -1.64725621432329, 218, 51, 'PPL', 'P'),
(126298, 'Suttons Mills', 42.7069396972656, 0.745376711167956, -71.1333312988281, -1.24151083907649, 218, 23, 'PPL', 'P'),
(69262, 'Suttontown', 35.2033309936523, 0.6144140335086, -78.2408294677734, -1.36556008370405, 218, 33, 'PPL', 'P'),
(193993, 'Suty (historical)', 41.8722190856934, 0.730808088161759, -121.416107177734, -2.11911083520579, 218, 6, 'PPL', 'P'),
(185502, 'Suval', 38.2466697692871, 0.66753031539704, -122.076667785645, -2.13063979272279, 218, 6, 'PPL', 'P'),
(201628, 'Suver', 44.7430610656738, 0.780913733016891, -123.206108093262, -2.15035224479545, 218, 43, 'PPL', 'P'),
(25276, 'Suwanee', 34.0513916015625, 0.594308898333211, -84.0713882446289, -1.46732253159123, 218, 13, 'PPL', 'P'),
(38457, 'Suwanee', 37.0502815246582, 0.64664940139611, -88.165283203125, -1.53877447784778, 218, 21, 'PPL', 'P'),
(189621, 'Suwanee', 34.935001373291, 0.609730798152669, -107.136672973633, -1.86988769302232, 218, 38, 'PPL', 'P'),
(18254, 'Suwanee Old Town (historical)', 29.6166706085205, 0.516908415597315, -82.966667175293, -1.44804151161517, 218, 12, 'PPL', 'P'),
(18256, 'Suwannee', 30.3888893127441, 0.530386174531502, -82.956672668457, -1.44786707456377, 218, 12, 'PPL', 'P'),
(18258, 'Suwannee Springs', 30.3938903808594, 0.530473459636229, -82.9375, -1.4475324483728, 218, 12, 'PPL', 'P'),
(18259, 'Suwannee Valley', 30.2988891601563, 0.528815375541546, -82.7083282470703, -1.44353264673161, 218, 12, 'PPL', 'P'),
(18260, 'Svea', 30.9675006866455, 0.540484848095569, -86.4033279418945, -1.50802255726648, 218, 12, 'PPL', 'P'),
(138362, 'Svea', 45.0033302307129, 0.785456286888239, -95.021110534668, -1.65843123773143, 218, 28, 'PPL', 'P'),
(138364, 'Sveadahl', 44.0741691589355, 0.769239366904365, -94.7391662597656, -1.65351038182723, 218, 28, 'PPL', 'P'),
(185503, 'Sveadal', 37.083610534668, 0.647231102357211, -121.788063049316, -2.12560268983702, 218, 6, 'PPL', 'P'),
(201629, 'Svensen', 46.1708297729492, 0.80583299791579, -123.658058166504, -2.15824026162816, 218, 43, 'PPL', 'P'),
(201630, 'Svensen Junction', 46.1655616760254, 0.805741052279155, -123.65860748291, -2.15824984900808, 218, 43, 'PPL', 'P'),
(208894, 'Svensens Landing', 46.3199996948242, 0.808436504197451, -123.706672668457, -2.15908874475145, 218, 56, 'PPL', 'P'),
(77389, 'Svoboda', 34.7102813720703, 0.605808694236282, -98.9555587768555, -1.7271003138069, 218, 42, 'PPL', 'P'),
(140941, 'Svold', 48.8077812194824, 0.851856482873021, -97.79638671875, -1.70686894479584, 218, 34, 'PPL', 'P'),
(6188, 'Swagg', 33.374439239502, 0.582493850736101, -85.5480575561523, -1.49309527304047, 218, 2, 'PPL', 'P'),
(25278, 'Swaggy Valley', 33.4555587768555, 0.583909653750615, -83.0372161865234, -1.44927282414516, 218, 13, 'PPL', 'P'),
(6189, 'Swaim', 34.8694381713867, 0.608586504411289, -86.1983337402344, -1.50444473350001, 218, 2, 'PPL', 'P'),
(209766, 'Swaim Place', 43.3480606079102, 0.756566381962087, -107.375556945801, -1.87405700486689, 218, 59, 'PPL', 'P'),
(69263, 'Swaimtown', 36.0297203063965, 0.628837247919279, -80.2755584716797, -1.40107280420804, 218, 33, 'PPL', 'P'),
(797, 'Swain', 39.1252784729004, 0.682864930111771, -74.8005599975586, -1.30551605429296, 218, 37, 'PPL', 'P'),
(12230, 'Swain', 35.8491706848145, 0.625686062559443, -93.3397216796875, -1.62908546620568, 218, 4, 'PPL', 'P'),
(153023, 'Swain', 42.4777793884277, 0.741377109263847, -77.8536071777344, -1.35880177980576, 218, 40, 'PPL', 'P'),
(69264, 'Swain (historical)', 35.916389465332, 0.62685925159865, -76.6283264160156, -1.33741659625242, 218, 33, 'PPL', 'P'),
(14696, 'Swain Acres', 38.6916694641113, 0.675297025242093, -75.4000015258789, -1.31597828263534, 218, 10, 'PPL', 'P'),
(193994, 'Swain Place', 40.1783294677734, 0.701244137163707, -122.575828552246, -2.13935179159677, 218, 6, 'PPL', 'P'),
(25279, 'Swainsboro', 32.5972213745117, 0.568928839986701, -82.3338928222656, -1.43699751573266, 218, 13, 'PPL', 'P'),
(69265, 'Swainsville', 35.2938919067383, 0.615994619615562, -81.6516723632813, -1.42509052249892, 218, 33, 'PPL', 'P'),
(71459, 'Swainton', 39.1313896179199, 0.682971589713429, -74.7777786254883, -1.30511844434221, 218, 37, 'PPL', 'P'),
(208895, 'Swale', 45.7586097717285, 0.798638401651913, -121.071113586426, -2.11308956113917, 218, 56, 'PPL', 'P'),
(117974, 'Swaledale', 42.9786109924316, 0.75011826975176, -93.3166732788086, -1.62868319572302, 218, 16, 'PPL', 'P'),
(167797, 'Swales', 40.6544418334961, 0.709553865555027, -77.2280578613281, -1.34788388460087, 218, 45, 'PPL', 'P'),
(185504, 'Swall', 36.2408294677734, 0.632521797866431, -119.286109924316, -2.08193537007521, 218, 6, 'PPL', 'P'),
(14697, 'Swallow Hill', 39.7938919067383, 0.694534435955307, -75.6355590820313, -1.32008953756815, 218, 10, 'PPL', 'P'),
(38458, 'Swallowfield', 38.339168548584, 0.669144723649846, -84.8486099243164, -1.48088760891966, 218, 21, 'PPL', 'P'),
(187421, 'Swallows', 38.3022193908691, 0.668499839191883, -104.859718322754, -1.83014733744588, 218, 7, 'PPL', 'P'),
(187422, 'Swallows Nest (historical)', 37.1572189331055, 0.648515811267065, -108.467216491699, -1.89311005825364, 218, 7, 'PPL', 'P'),
(31271, 'Swalls', 39.4602813720703, 0.688711833706013, -87.2888870239258, -1.52347847896886, 218, 19, 'PPL', 'P'),
(34102, 'Swamp Angel', 39.1944389343262, 0.684072007875849, -96.4819412231445, -1.68392754305952, 218, 20, 'PPL', 'P'),
(38460, 'Swamp Branch', 37.7358283996582, 0.658614451541618, -82.8949966430664, -1.44679062485116, 218, 21, 'PPL', 'P'),
(83939, 'Swamp Fox', 33.4402809143066, 0.583643004746471, -79.9861068725586, -1.39602092077821, 218, 48, 'PPL', 'P'),
(111630, 'Swamp Run', 39.0244407653809, 0.681104980105392, -80.0749969482422, -1.39757234527124, 218, 58, 'PPL', 'P'),
(43265, 'Swampers', 32.1908302307129, 0.561835976476466, -91.5708312988281, -1.59821250495283, 218, 22, 'PPL', 'P'),
(167798, 'Swamproot (historical)', 41.1425018310547, 0.7180721194597, -80.0527801513672, -1.39718458901652, 218, 45, 'PPL', 'P'),
(126299, 'Swampscott', 42.4708290100098, 0.741255802276194, -70.9180603027344, -1.2377536514106, 218, 23, 'PPL', 'P'),
(38459, 'Swampton', 37.6586112976074, 0.657266758871984, -83.0113906860352, -1.44882208413067, 218, 21, 'PPL', 'P'),
(25280, 'Swan', 34.7552795410156, 0.606594060441746, -84.1900024414063, -1.4693927398646, 218, 13, 'PPL', 'P'),
(57800, 'Swan', 36.795280456543, 0.642198793161397, -93.0625, -1.62424703513722, 218, 29, 'PPL', 'P'),
(98396, 'Swan', 32.4347190856934, 0.566092640004794, -95.366943359375, -1.66446715918404, 218, 51, 'PPL', 'P'),
(113404, 'Swan', 44.9311103820801, 0.784195812744305, -90.1188888549805, -1.57287132875823, 218, 57, 'PPL', 'P'),
(117975, 'Swan', 41.4652786254883, 0.723705637271599, -93.3111114501953, -1.62858612350129, 218, 16, 'PPL', 'P'),
(123768, 'Swan', 41.3158302307129, 0.721097270720948, -85.2125015258789, -1.48723871548728, 218, 19, 'PPL', 'P'),
(187423, 'Swan (historical)', 38.6800003051758, 0.675093359997729, -106.041389465332, -1.85077138955967, 218, 7, 'PPL', 'P'),
(126301, 'Swan Avenue', 42.2583312988281, 0.737547017563123, -71.8486099243164, -1.2539948061604, 218, 23, 'PPL', 'P'),
(91181, 'Swan Bluff', 35.714168548584, 0.623329830784995, -87.4286117553711, -1.52591713557904, 218, 50, 'PPL', 'P'),
(69267, 'Swan Corner', 35.1650009155273, 0.613745047442772, -76.7227783203125, -1.33906509296718, 218, 33, 'PPL', 'P'),
(126302, 'Swan Corner', 42.651668548584, 0.744412047642102, -71.4361114501953, -1.24679534962753, 218, 23, 'PPL', 'P'),
(51877, 'Swan Creek', 39.5230598449707, 0.689807524757498, -76.1377792358398, -1.32885493282198, 218, 25, 'PPL', 'P'),
(69272, 'Swan Creek', 36.1783294677734, 0.631430967083934, -80.8691711425781, -1.41143329979677, 218, 33, 'PPL', 'P'),
(74487, 'Swan Creek', 38.5938911437988, 0.67359047161557, -82.2022171020508, -1.43469934086998, 218, 41, 'PPL', 'P'),
(121640, 'Swan Creek', 40.667781829834, 0.709786692413327, -90.6547164916992, -1.58222328524215, 218, 18, 'PPL', 'P'),
(133334, 'Swan Creek', 43.3797187805176, 0.757118921309251, -84.0911102294922, -1.46766674516212, 218, 27, 'PPL', 'P'),
(206014, 'Swan Creek Estates', 41.1775016784668, 0.718682982034737, -112.108329772949, -1.95665947344955, 218, 52, 'PPL', 'P'),
(195676, 'Swan Falls', 43.2416687011719, 0.754709492892029, -116.373329162598, -2.03109775539446, 218, 17, 'PPL', 'P'),
(51878, 'Swan Harbor', 38.392219543457, 0.670070638181839, -76.2805633544922, -1.33134698581202, 218, 25, 'PPL', 'P'),
(51879, 'Swan Harbor Dell Trailer Park', 39.5258293151855, 0.689855861131283, -76.144172668457, -1.32896651927165, 218, 25, 'PPL', 'P'),
(51880, 'Swan Haven', 38.788890838623, 0.676993858330637, -76.0338897705078, -1.3270417195938, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(12232, 'Swan Lake', 34.1822204589844, 0.596592292651845, -91.6938934326172, -1.60036034437198, 218, 4, 'PPL', 'P'),
(25282, 'Swan Lake', 33.8458290100098, 0.590721154291683, -84.817497253418, -1.48034459037339, 218, 13, 'PPL', 'P'),
(38461, 'Swan Lake', 36.8261108398438, 0.642736884859648, -83.9272232055664, -1.46480637699332, 218, 21, 'PPL', 'P'),
(61946, 'Swan Lake', 33.8747215270996, 0.59122542384409, -90.283332824707, -1.57574141746501, 218, 30, 'PPL', 'P'),
(77392, 'Swan Lake', 35.2347183227539, 0.61496184574483, -98.5158309936523, -1.71942561617751, 218, 42, 'PPL', 'P'),
(143154, 'Swan Lake', 42.1699981689453, 0.736005313608076, -99.0213928222656, -1.72824933465922, 218, 35, 'PPL', 'P'),
(153024, 'Swan Lake', 41.750560760498, 0.728684749824639, -74.7783279418945, -1.30512803172213, 218, 40, 'PPL', 'P'),
(195677, 'Swan Lake', 42.3077812194824, 0.73841008149339, -111.998062133789, -1.95473494008781, 218, 17, 'PPL', 'P'),
(197666, 'Swan Lake', 47.9291687011719, 0.836521801579263, -113.843887329102, -1.98695066716228, 218, 31, 'PPL', 'P'),
(51883, 'Swan Point', 38.3061103820801, 0.66856774979968, -76.9197235107422, -1.34250243498614, 218, 25, 'PPL', 'P'),
(51884, 'Swan Point Estates', 39.0536117553711, 0.681614109926788, -76.5308303833008, -1.33571496947391, 218, 25, 'PPL', 'P'),
(111631, 'Swan Pond', 39.4691696166992, 0.68886696283951, -77.8775024414063, -1.35921883083246, 218, 58, 'PPL', 'P'),
(138367, 'Swan River', 47.086669921875, 0.8218174239365, -93.1947174072266, -1.62655466422178, 218, 28, 'PPL', 'P'),
(197667, 'Swan River (historical)', 48.0955581665039, 0.83942584558994, -114.027778625488, -1.99016017574998, 218, 31, 'PPL', 'P'),
(195678, 'Swan Valley', 43.4561080932617, 0.758452166329972, -111.340827941895, -1.94326403948256, 218, 17, 'PPL', 'P'),
(51885, 'Swan Villas', 38.8050003051758, 0.677275021562722, -76.2169418334961, -1.33023658079551, 218, 25, 'PPL', 'P'),
(91183, 'Swanay (historical)', 36.3438911437988, 0.634320563445697, -82.6986083984375, -1.44336300337017, 218, 50, 'PPL', 'P'),
(138368, 'Swanburg', 46.7402801513672, 0.815771781945911, -94.1752777099609, -1.64366867001884, 218, 28, 'PPL', 'P'),
(6190, 'Swancott', 34.5972213745117, 0.603835425026588, -86.7886123657227, -1.51474703901893, 218, 2, 'PPL', 'P'),
(153025, 'Swancott Mill', 43.4622192382813, 0.75855882593163, -75.6033325195313, -1.31952707794592, 218, 40, 'PPL', 'P'),
(83936, 'Swandale', 33.9794387817383, 0.593053084721184, -80.8638916015625, -1.41134115442306, 218, 48, 'PPL', 'P'),
(111633, 'Swandale', 38.4705581665039, 0.671437905085486, -80.959716796875, -1.41301361958763, 218, 58, 'PPL', 'P'),
(157881, 'Swander', 41.0952796936035, 0.717247937681348, -83.0933303833008, -1.45025220163604, 218, 41, 'PPL', 'P'),
(157882, 'Swanders', 40.3605613708496, 0.704424683874562, -84.1730575561523, -1.46909699582555, 218, 41, 'PPL', 'P'),
(14709, 'Swanendael', 38.7649993896484, 0.676576873882958, -75.1636123657227, -1.31185251347458, 218, 10, 'PPL', 'P'),
(123767, 'Swanington', 40.5833282470703, 0.708312699328996, -87.2772216796875, -1.52327488030352, 218, 19, 'PPL', 'P'),
(74489, 'Swanktown', 39.8708305358887, 0.695877268355953, -84.3786087036133, -1.47268454013, 218, 41, 'PPL', 'P'),
(195679, 'Swanlake', 42.313060760498, 0.738502226867107, -112.003059387207, -1.95482215861351, 218, 17, 'PPL', 'P'),
(69270, 'Swann', 35.3808288574219, 0.617511955646635, -79.1091690063477, -1.38071546767742, 218, 33, 'PPL', 'P'),
(91184, 'Swann', 36.0083312988281, 0.628463939313477, -83.3633270263672, -1.45496453202688, 218, 50, 'PPL', 'P'),
(111632, 'Swann', 38.5230598449707, 0.672354232237555, -82.1588897705078, -1.43394313627845, 218, 58, 'PPL', 'P'),
(51886, 'Swann Hills', 39.1766700744629, 0.68376188276691, -76.9897232055664, -1.34372416013622, 218, 25, 'PPL', 'P'),
(14698, 'Swann Keys', 38.4799995422363, 0.671602688177935, -75.086669921875, -1.31050961449491, 218, 10, 'PPL', 'P'),
(69271, 'Swannanoa', 35.5977783203125, 0.62129843808451, -82.4000015258789, -1.43815133027494, 218, 33, 'PPL', 'P'),
(106755, 'Swannanoa', 38.0283317565918, 0.663719598193246, -78.8705596923828, -1.37655094952281, 218, 53, 'PPL', 'P'),
(106756, 'Swannanoa Estates', 37.6563911437988, 0.657228009878123, -77.3744430541992, -1.35043878819263, 218, 53, 'PPL', 'P'),
(69273, 'Swannanoa Hills', 35.5927810668945, 0.62121121955881, -82.4716720581055, -1.43940221703895, 218, 33, 'PPL', 'P'),
(91185, 'Swannsylvania', 36.0166702270508, 0.62860948106705, -83.3116683959961, -1.45406291883983, 218, 50, 'PPL', 'P'),
(38462, 'Swanpond', 36.8308296203613, 0.642819243116358, -83.9030609130859, -1.46438466543471, 218, 21, 'PPL', 'P'),
(69275, 'Swanquarter', 35.4061088562012, 0.617953174860234, -76.3294372558594, -1.33219999630917, 218, 33, 'PPL', 'P'),
(51887, 'Swans', 38.7994384765625, 0.677177949340988, -76.5272216796875, -1.33565198571413, 218, 25, 'PPL', 'P'),
(157883, 'Swans', 40.0625, 0.699222531580228, -82.3499984741211, -1.43727861238572, 218, 41, 'PPL', 'P'),
(106757, 'Swans Corner', 37.9466705322266, 0.662294340956863, -77.4330596923828, -1.35146184152539, 218, 53, 'PPL', 'P'),
(129040, 'Swans Island', 44.1450004577637, 0.77047560628238, -68.4522171020508, -1.19471656872076, 218, 26, 'PPL', 'P'),
(69276, 'Swansboro', 34.6875, 0.605411084285533, -77.1194381713867, -1.34598811337889, 218, 33, 'PPL', 'P'),
(28742, 'Swansea', 38.5338897705078, 0.672543250095924, -89.9888916015625, -1.57060244866754, 218, 18, 'PPL', 'P'),
(83937, 'Swansea', 33.7380599975586, 0.588840230192788, -81.0980606079102, -1.41542817458995, 218, 48, 'PPL', 'P'),
(126303, 'Swansea', 41.7480583190918, 0.728641073982761, -71.1902770996094, -1.2425047307953, 218, 23, 'PPL', 'P'),
(179294, 'Swansea', 34.1699981689453, 0.596378973448529, -113.845283508301, -1.98697503508625, 218, 5, 'PPL', 'P'),
(185505, 'Swansea', 36.5247192382813, 0.637476609074523, -117.903060913086, -2.05779661111278, 218, 6, 'PPL', 'P'),
(6191, 'Swansea (historical)', 33.8541717529297, 0.590866762624283, -86.5555572509766, -1.51067945992799, 218, 2, 'PPL', 'P'),
(190809, 'Swansea (historical)', 39.2249984741211, 0.684605372463165, -115.501388549805, -2.01587952081937, 218, 39, 'PPL', 'P'),
(126304, 'Swansea Center', 41.7416687011719, 0.728529554112114, -71.1933288574219, -1.2425579940171, 218, 23, 'PPL', 'P'),
(106758, 'Swansen', 38.9436111450195, 0.67969423709695, -77.5638885498047, -1.35374523584402, 218, 53, 'PPL', 'P'),
(51888, 'Swansfield', 39.2163887023926, 0.684455103598657, -76.892219543457, -1.34202240019966, 218, 25, 'PPL', 'P'),
(25283, 'Swanson', 33.9333305358887, 0.592248344018789, -83.4419403076172, -1.45633659262049, 218, 13, 'PPL', 'P'),
(133336, 'Swanson', 45.4747200012207, 0.793683590443821, -87.708610534668, -1.53080403617934, 218, 27, 'PPL', 'P'),
(157884, 'Swanson', 40.3797187805176, 0.704759043749421, -80.8886108398438, -1.41177258651965, 218, 41, 'PPL', 'P'),
(126306, 'Swanson Corners', 42.1980590820313, 0.736495068932541, -72.726936340332, -1.26932449402711, 218, 23, 'PPL', 'P'),
(51891, 'Swanson Creek Landing', 38.5416717529297, 0.672679071311518, -76.727783203125, -1.33915244465093, 218, 25, 'PPL', 'P'),
(25284, 'Swanson Heights', 34.0349998474121, 0.594022808253109, -84.478889465332, -1.4744347695984, 218, 13, 'PPL', 'P'),
(25285, 'Swanson Mill', 34.9772186279297, 0.610467628247267, -85.1455612182617, -1.48607038671706, 218, 13, 'PPL', 'P'),
(98397, 'Swansons Landing', 32.6747207641602, 0.570281459504352, -94.0558319091797, -1.64158394751753, 218, 51, 'PPL', 'P'),
(106759, 'Swansons Mill', 36.790828704834, 0.642121095436594, -79.6483306884766, -1.39012561423116, 218, 53, 'PPL', 'P'),
(106761, 'Swansonville', 36.7363891601563, 0.641170946138681, -79.5791702270508, -1.38891853646708, 218, 53, 'PPL', 'P'),
(208896, 'Swansonville', 47.9372215270996, 0.836662349905792, -122.699172973633, -2.14150455786393, 218, 56, 'PPL', 'P'),
(185506, 'Swanston', 38.6049995422363, 0.673784349742928, -121.435829162598, -2.11945504877668, 218, 6, 'PPL', 'P'),
(51889, 'Swanton', 39.4588890075684, 0.688687532361066, -79.2311096191406, -1.38284373286255, 218, 25, 'PPL', 'P'),
(117978, 'Swanton', 42.5, 0.74176493209759, -92.6922225952148, -1.61778447527798, 218, 16, 'PPL', 'P'),
(143156, 'Swanton', 40.3786087036133, 0.704739669252491, -97.0794372558594, -1.694355816098, 218, 35, 'PPL', 'P'),
(157885, 'Swanton', 41.5886116027832, 0.725858203801683, -83.89111328125, -1.46417613992136, 218, 41, 'PPL', 'P'),
(172624, 'Swanton', 44.9180603027344, 0.783968045892076, -73.1247177124023, -1.27626708867284, 218, 55, 'PPL', 'P'),
(185507, 'Swanton', 37.0641708374023, 0.646891815634335, -122.226387023926, -2.13325288638438, 218, 6, 'PPL', 'P'),
(51890, 'Swanton (historical)', 39.3647193908691, 0.687043962494323, -75.8344421386719, -1.32356070173295, 218, 25, 'PPL', 'P'),
(172625, 'Swanton Junction', 44.8777809143066, 0.783265037943322, -73.0991668701172, -1.2758211423483, 218, 55, 'PPL', 'P'),
(208897, 'Swantown', 48.3052787780762, 0.843086160771172, -122.711669921875, -2.14172267075721, 218, 56, 'PPL', 'P'),
(31272, 'Swanville', 38.6863899230957, 0.675204879868376, -85.5586090087891, -1.49327943062985, 218, 19, 'PPL', 'P'),
(129042, 'Swanville', 44.521110534668, 0.777039965474289, -68.9983291625977, -1.20424802226215, 218, 26, 'PPL', 'P'),
(138370, 'Swanville', 45.9102783203125, 0.801285517196425, -94.6433334350586, -1.65183778350461, 218, 28, 'PPL', 'P'),
(167799, 'Swanville', 42.064998626709, 0.734172725882965, -80.1947174072266, -1.39966186146251, 218, 45, 'PPL', 'P'),
(28741, 'Swanwick', 38.1697196960449, 0.666187283259313, -89.5361099243164, -1.56269991760689, 218, 18, 'PPL', 'P'),
(57802, 'Swanwick', 39.3141708374023, 0.686161723804207, -94.0308303833008, -1.64114758857292, 218, 29, 'PPL', 'P'),
(117979, 'Swanwood', 41.6513900756836, 0.726953894853169, -93.5902786254883, -1.63345850987364, 218, 16, 'PPL', 'P'),
(14699, 'Swanwyck', 39.6936111450195, 0.692784206486907, -75.5608291625977, -1.31878525442428, 218, 10, 'PPL', 'P'),
(14700, 'Swanwyck Estates', 39.6930618286133, 0.692774619106983, -75.5638885498047, -1.31883865080414, 218, 10, 'PPL', 'P'),
(14701, 'Swanwyck Gardens', 39.6944389343262, 0.692798654135821, -75.5666732788086, -1.31888725349403, 218, 10, 'PPL', 'P'),
(144536, 'Swanzey', 42.8697204589844, 0.748217771418852, -72.2822189331055, -1.26156271103007, 218, 36, 'PPL', 'P'),
(144537, 'Swanzey Station', 42.8866691589355, 0.748513582036933, -72.2874984741211, -1.26165485640379, 218, 36, 'PPL', 'P'),
(133337, 'Swanzy', 46.3027801513672, 0.808135966468436, -87.373893737793, -1.52496212601214, 218, 27, 'PPL', 'P'),
(57803, 'Swart', 37.7511100769043, 0.65888116712479, -94.5833282470703, -1.65079049540593, 218, 29, 'PPL', 'P'),
(79242, 'Swarthmore', 39.9019393920898, 0.696420220323192, -75.3502807617188, -1.31511049159413, 218, 45, 'PPL', 'P'),
(106763, 'Swarthmore Place', 37.3033294677734, 0.65106592116887, -79.977783203125, -1.39587564534075, 218, 53, 'PPL', 'P'),
(98398, 'Swartout', 30.6383304595947, 0.534739743833995, -95.0047225952148, -1.65814521423035, 218, 51, 'PPL', 'P'),
(153026, 'Swartoutville', 41.5633316040039, 0.725416984588084, -73.8494415283203, -1.28891590542822, 218, 40, 'PPL', 'P'),
(79244, 'Swarts', 39.9555587768555, 0.697356055130246, -80.253059387207, -1.40068012110531, 218, 45, 'PPL', 'P'),
(146428, 'Swartswood', 41.0869407653809, 0.717102395927775, -74.8274993896484, -1.30598623538341, 218, 37, 'PPL', 'P'),
(153027, 'Swartwood', 42.2244415283203, 0.736955529485016, -76.6100006103516, -1.3370967506055, 218, 40, 'PPL', 'P'),
(43268, 'Swartz', 32.5686111450195, 0.568429497282311, -91.9850006103516, -1.60544112309963, 218, 22, 'PPL', 'P'),
(195680, 'Swartz Corner', 43.5013885498047, 0.759242459383453, -116.554168701172, -2.03425400076037, 218, 17, 'PPL', 'P'),
(157887, 'Swartz Corners', 41.0286102294922, 0.716084336022065, -81.5272216796875, -1.42291844831385, 218, 41, 'PPL', 'P'),
(133338, 'Swartz Creek', 42.957218170166, 0.749744894566931, -83.8305587768555, -1.46311926444276, 218, 27, 'PPL', 'P'),
(74490, 'Swartz Mill', 39.6322212219238, 0.691712750201341, -82.4941711425781, -1.43979490014168, 218, 41, 'PPL', 'P'),
(167802, 'Swartzville', 40.2330589294434, 0.702199346467692, -76.07861328125, -1.3278222921093, 218, 45, 'PPL', 'P'),
(153028, 'Swastika', 44.5130615234375, 0.776899483726787, -73.7611083984375, -1.28737420147318, 218, 40, 'PPL', 'P'),
(138373, 'Swatara', 46.8955612182617, 0.81848194782923, -93.6738891601563, -1.63491778899295, 218, 28, 'PPL', 'P'),
(167801, 'Swatara', 40.6549987792969, 0.709563586093006, -76.3550033569336, -1.33264620894981, 218, 45, 'PPL', 'P'),
(167806, 'Swatara Crest', 40.2461090087891, 0.702427113319921, -76.7852783203125, -1.34015592374967, 218, 45, 'PPL', 'P'),
(43269, 'Swayze Lake', 30.6399993896484, 0.534768872158418, -91.8266677856445, -1.60267769399451, 218, 22, 'PPL', 'P'),
(123769, 'Swayzee', 40.5083312988281, 0.707003755653222, -85.8255615234375, -1.49793863095694, 218, 19, 'PPL', 'P'),
(146429, 'Swayzes Mills', 40.896671295166, 0.713781567206501, -74.9974975585938, -1.30895326315387, 218, 37, 'PPL', 'P'),
(74491, 'Swazey', 39.7638893127441, 0.69401079190597, -81.2877807617188, -1.4187394159313, 218, 41, 'PPL', 'P'),
(117980, 'Swea (historical)', 43.4147186279297, 0.757729783884288, -94.3833312988281, -1.64729989016517, 218, 16, 'PPL', 'P'),
(117981, 'Swea City', 43.3844413757324, 0.757201346144989, -94.3147201538086, -1.64610239978101, 218, 16, 'PPL', 'P'),
(51892, 'Sweadner', 39.3222198486328, 0.686302205551709, -77.2794418334961, -1.34878070409795, 218, 25, 'PPL', 'P'),
(6192, 'Swearengin', 34.5633316040039, 0.603243936948481, -86.1902770996094, -1.50430411859445, 218, 2, 'PPL', 'P'),
(192295, 'Swearingen', 34.148609161377, 0.596005664842727, -100.147499084473, -1.74790359666205, 218, 51, 'PPL', 'P'),
(83938, 'Swearingen (historical)', 33.7044410705566, 0.588253469225616, -81.9199981689453, -1.42977369127582, 218, 48, 'PPL', 'P'),
(61947, 'Sweatman', 33.6341705322266, 0.587027016964607, -89.579719543457, -1.56346104904644, 218, 30, 'PPL', 'P'),
(208898, 'Swede Heaven', 48.2844390869141, 0.842722439545295, -121.726936340332, -2.12453582750433, 218, 56, 'PPL', 'P'),
(167805, 'Swede Hill', 40.2777786254883, 0.702979852404167, -79.5713882446289, -1.38878271525149, 218, 45, 'PPL', 'P'),
(208899, 'Swede Hill', 47.353328704834, 0.826471497678495, -122.617782592773, -2.14008402773849, 218, 56, 'PPL', 'P'),
(57804, 'Swedeborg', 37.913890838623, 0.661722227375686, -92.331672668457, -1.61149169193823, 218, 29, 'PPL', 'P'),
(143157, 'Swedeburg', 41.1361083984375, 0.717960533010026, -96.6244430541992, -1.68641466920154, 218, 35, 'PPL', 'P'),
(143158, 'Swedehome', 41.1627807617188, 0.718426053568572, -97.663330078125, -1.70454666832529, 218, 35, 'PPL', 'P'),
(167807, 'Swedeland', 40.0877799987793, 0.699663750793827, -75.3313903808594, -1.31478079225118, 218, 45, 'PPL', 'P'),
(12234, 'Sweden', 34.1930618286133, 0.596781510247295, -91.7241668701172, -1.60088871553225, 218, 4, 'PPL', 'P'),
(25286, 'Sweden', 34.5433311462402, 0.602894863108599, -84.6419372558594, -1.4772804903812, 218, 13, 'PPL', 'P'),
(57805, 'Sweden', 36.877498626709, 0.643633770935759, -92.5008316040039, -1.6144440723227, 218, 29, 'PPL', 'P'),
(83944, 'Sweden', 33.3788909912109, 0.582571548460905, -81.1352767944336, -1.41607771957982, 218, 48, 'PPL', 'P'),
(129045, 'Sweden', 44.1333312988281, 0.770271941038016, -70.8230590820313, -1.23609556731592, 218, 26, 'PPL', 'P'),
(167808, 'Sweden', 41.8019409179688, 0.729581502742696, -77.8711090087891, -1.35910724438279, 218, 45, 'PPL', 'P'),
(153031, 'Sweden Center', 43.1783294677734, 0.753604014723537, -77.9452819824219, -1.36040180698867, 218, 40, 'PPL', 'P'),
(167809, 'Sweden Valley', 41.7563896179199, 0.72878648257828, -77.9505615234375, -1.36049395236239, 218, 45, 'PPL', 'P'),
(185508, 'Swedes Flat (historical)', 39.4466705322266, 0.688474279736777, -121.373611450195, -2.1183691448422, 218, 6, 'PPL', 'P'),
(200226, 'Swedes Place', 41.2169418334961, 0.719371342597495, -119.495277404785, -2.08558603129749, 218, 39, 'PPL', 'P'),
(71461, 'Swedesboro', 39.747501373291, 0.693724768404896, -75.3108291625977, -1.31442193129429, 218, 37, 'PPL', 'P'),
(117983, 'Swedesburg', 41.105281829834, 0.717422507890803, -91.5469436645508, -1.59779558708417, 218, 16, 'PPL', 'P'),
(167811, 'Swedesburg', 40.1041717529297, 0.699949840873929, -75.3291702270508, -1.31474204325732, 218, 45, 'PPL', 'P'),
(167812, 'Swedesford Road', 40.0422210693359, 0.698868597471357, -75.5800018310547, -1.31911988061525, 218, 45, 'PPL', 'P'),
(133340, 'Swedetown', 47.2363891601563, 0.824430517598086, -88.4647216796875, -1.54400066517096, 218, 27, 'PPL', 'P'),
(167813, 'Swedetown', 40.6747207641602, 0.709907799663899, -78.6991729736328, -1.37355968698643, 218, 45, 'PPL', 'P'),
(121645, 'Swedona', 41.2791709899902, 0.720457446269057, -90.4447174072266, -1.57855810979193, 218, 18, 'PPL', 'P'),
(38463, 'Sweeden', 37.2536087036133, 0.650198130127668, -86.2788925170898, -1.50585074939752, 218, 21, 'PPL', 'P'),
(195681, 'Sweeney', 47.5402793884277, 0.82973440264606, -116.168609619141, -2.02752472531796, 218, 17, 'PPL', 'P'),
(197668, 'Sweeney Creek (historical)', 46.6111106872559, 0.813517349504132, -114.088890075684, -1.99122677176656, 218, 31, 'PPL', 'P'),
(209767, 'Sweeney Ranch', 41.4797210693359, 0.723957705468775, -109.010559082031, -1.90259317542125, 218, 59, 'PPL', 'P'),
(111634, 'Sweeneyburg', 37.8363914489746, 0.660369607858035, -81.258056640625, -1.41822063215095, 218, 58, 'PPL', 'P'),
(185509, 'Sweeneys Crossing', 38.6527786254883, 0.674618252059259, -120.623893737793, -2.10528410230026, 218, 6, 'PPL', 'P'),
(167814, 'Sweeneys Crossroads', 40.1769409179688, 0.701219902397788, -79.8058319091797, -1.39287452910834, 218, 45, 'PPL', 'P'),
(38464, 'Sweeneyville', 37.3522186279297, 0.651919197982132, -85.399169921875, -1.49049669360683, 218, 21, 'PPL', 'P'),
(98399, 'Sweeny', 29.038610458374, 0.506819362702686, -95.6983337402344, -1.67025101243947, 218, 51, 'PPL', 'P'),
(51893, 'Sweepstakes', 39.2583312988281, 0.685187140003293, -77.2180633544922, -1.34770944754947, 218, 25, 'PPL', 'P'),
(106764, 'Sweepstakes (historical)', 36.5552787780762, 0.638009973661839, -76.9336090087891, -1.34274478264534, 218, 53, 'PPL', 'P'),
(195682, 'Sweet', 43.9730606079102, 0.767474689787051, -116.323608398438, -2.03022996435326, 218, 17, 'PPL', 'P'),
(51895, 'Sweet Air', 39.3933296203613, 0.687543305198713, -76.9208297729492, -1.34252174290405, 218, 25, 'PPL', 'P'),
(51896, 'Sweet Air Manor', 39.5175018310547, 0.689710519114792, -76.5255584716797, -1.33562295725825, 218, 25, 'PPL', 'P'),
(25290, 'Sweet Apple Crossing', 34.0902786254883, 0.594987604937017, -84.3811111450195, -1.47272821597187, 218, 13, 'PPL', 'P'),
(91186, 'Sweet Briar', 35.8969383239746, 0.626519765138692, -84.165283203125, -1.46896130776801, 218, 50, 'PPL', 'P'),
(167815, 'Sweet Briar', 40.1100006103516, 0.70005157362757, -75.379997253418, -1.31562914221643, 218, 45, 'PPL', 'P'),
(198981, 'Sweet Briar', 46.8244400024414, 0.817240648445144, -101.154441833496, -1.7654780630116, 218, 34, 'PPL', 'P'),
(14702, 'Sweet Briar Mobile Home Park', 38.7513885498047, 0.676339319913722, -75.2263870239258, -1.31294813794704, 218, 10, 'PPL', 'P'),
(25287, 'Sweet Briar Mobile Home Park', 33.5047187805176, 0.584767657674811, -84.6397171020508, -1.47724174138734, 218, 13, 'PPL', 'P'),
(106765, 'Sweet Briar Park', 37.6202812194824, 0.656597772806156, -77.5319366455078, -1.35318756991176, 218, 53, 'PPL', 'P'),
(106766, 'Sweet Briar Station', 37.5527801513672, 0.655419656918932, -79.0666732788086, -1.37997377731383, 218, 53, 'PPL', 'P'),
(106767, 'Sweet Chalybeate', 37.644718170166, 0.657024278054732, -80.2380599975586, -1.40041833237015, 218, 53, 'PPL', 'P'),
(197669, 'Sweet Grass', 48.9961090087891, 0.855143422869424, -111.959716796875, -1.95406568770587, 218, 31, 'PPL', 'P'),
(51897, 'Sweet Grass Meadow', 39.6513900756836, 0.692047309813282, -76.0238876342773, -1.32686714938434, 218, 25, 'PPL', 'P'),
(6193, 'Sweet Gum', 34.9780616760254, 0.610482342212289, -87.418327331543, -1.52573763852157, 218, 2, 'PPL', 'P'),
(25288, 'Sweet Gum', 34.9811096191406, 0.610535538855064, -84.2008285522461, -1.46958169114394, 218, 13, 'PPL', 'P'),
(83940, 'Sweet Gum Trail', 34.5652809143066, 0.603277958831407, -82.6577835083008, -1.44265047462052, 218, 48, 'PPL', 'P'),
(25289, 'Sweet Hill', 31.8483295440674, 0.55585821180416, -81.2425003051758, -1.41794912287782, 218, 13, 'PPL', 'P'),
(57806, 'Sweet Hollow Ford (historical)', 37.834171295166, 0.660330858864174, -92.8402786254883, -1.62036854048369, 218, 29, 'PPL', 'P'),
(6194, 'Sweet Home', 33.5555610656738, 0.585655022950025, -85.9000015258789, -1.49923785409474, 218, 2, 'PPL', 'P'),
(12236, 'Sweet Home', 34.6863899230957, 0.605391709788603, -92.2422180175781, -1.60993041374918, 218, 4, 'PPL', 'P'),
(43270, 'Sweet Home', 30.0119400024414, 0.523807167953598, -91.0305633544922, -1.58878305048118, 218, 22, 'PPL', 'P'),
(91187, 'Sweet Home', 36.2369384765625, 0.632453887258634, -87.3491668701172, -1.5245305607575, 218, 50, 'PPL', 'P'),
(98402, 'Sweet Home', 30.257360458374, 0.528090562961367, -96.8212280273438, -1.68984921490136, 218, 51, 'PPL', 'P'),
(201631, 'Sweet Home', 44.3977813720703, 0.774887465523233, -122.735000610352, -2.14212986808788, 218, 43, 'PPL', 'P'),
(121646, 'Sweet Home (historical)', 42.4663887023926, 0.741178304288473, -90.0458297729492, -1.5715962072283, 218, 18, 'PPL', 'P'),
(43271, 'Sweet Lake', 29.9838905334473, 0.523317612366214, -93.1291732788086, -1.62541070337553, 218, 22, 'PPL', 'P'),
(91188, 'Sweet Lips', 35.4083290100098, 0.617991923854095, -88.522216796875, -1.5450041442697, 218, 50, 'PPL', 'P'),
(153030, 'Sweet Meadows', 41.999439239502, 0.733028498720612, -74.0500030517578, -1.29241636436502, 218, 40, 'PPL', 'P'),
(38465, 'Sweet Owen', 38.5558280944824, 0.67292614608165, -84.7605590820313, -1.47935083181263, 218, 21, 'PPL', 'P'),
(111637, 'Sweet Run', 38.3669395446777, 0.669629418968241, -82.5802764892578, -1.44129772194481, 218, 58, 'PPL', 'P'),
(195683, 'Sweet Sage (historical)', 43.8277816772461, 0.764939094113187, -112.926940917969, -1.97094693322366, 218, 17, 'PPL', 'P'),
(57807, 'Sweet Springs', 38.9636116027832, 0.680043310936832, -93.4147186279297, -1.63039440988145, 218, 29, 'PPL', 'P'),
(111636, 'Sweet Springs', 37.6283302307129, 0.656738254553657, -80.2416687011719, -1.40048131612993, 218, 58, 'PPL', 'P'),
(98403, 'Sweet Union', 31.4890098571777, 0.549586900200701, -95.0299606323242, -1.65858570107465, 218, 51, 'PPL', 'P'),
(167816, 'Sweet Valley', 41.2822189331055, 0.720510642911831, -76.1449966430664, -1.32898090034154, 218, 45, 'PPL', 'P'),
(6195, 'Sweet Water', 32.0972213745117, 0.560202193726729, -87.8675003051758, -1.53357718582244, 218, 2, 'PPL', 'P'),
(25291, 'Sweet Water', 33.9255599975586, 0.592112722540277, -84.0625, -1.46716740245773, 218, 13, 'PPL', 'P'),
(121647, 'Sweet Water', 40.0538902282715, 0.699072262715721, -89.6938934326172, -1.56545375933209, 218, 18, 'PPL', 'P'),
(25293, 'Sweetbriar', 33.5180587768555, 0.585000484533111, -82.1066665649414, -1.43303166939537, 218, 13, 'PPL', 'P'),
(83941, 'Sweetbriar', 33.0186080932617, 0.576283425653064, -80.2463912963867, -1.40056374096567, 218, 48, 'PPL', 'P'),
(193995, 'Sweetbriar', 41.1300010681152, 0.717853939987395, -122.31916809082, -2.1348722214852, 218, 6, 'PPL', 'P'),
(91189, 'Sweetens Cove', 35.0541687011719, 0.611810660384993, -85.7411117553711, -1.49646470445164, 218, 50, 'PPL', 'P'),
(69280, 'Sweetgum', 35.2911109924316, 0.615946083504696, -83.771110534668, -1.46208169688206, 218, 33, 'PPL', 'P'),
(91190, 'Sweetgum', 35.7933311462402, 0.624711478758528, -85.4091720581055, -1.49067126381628, 218, 50, 'PPL', 'P'),
(176631, 'Sweetheart City', 45.3091697692871, 0.79079419381914, -87.9761123657227, -1.53547282388636, 218, 57, 'PPL', 'P'),
(199720, 'Sweetheart Trailer Court', 42.8727798461914, 0.748271167798708, -100.550559997559, -1.7549383366815, 218, 35, 'PPL', 'P'),
(12238, 'Sweethome', 34.5763893127441, 0.603471836958765, -93.5794372558594, -1.63326929227819, 218, 4, 'PPL', 'P'),
(111639, 'Sweetland', 38.2594413757324, 0.66775322198028, -82.0422210693359, -1.43190688330898, 218, 58, 'PPL', 'P'),
(185510, 'Sweetland', 39.3430595397949, 0.686665926777586, -121.119171142578, -2.11392832372449, 218, 6, 'PPL', 'P'),
(171408, 'Sweetland (historical)', 44.3405609130859, 0.773888780114453, -98.9844436645508, -1.72760445020125, 218, 49, 'PPL', 'P'),
(117984, 'Sweetland Center', 41.4933280944824, 0.724195192858983, -90.9694366455078, -1.5877161881485, 218, 16, 'PPL', 'P'),
(146430, 'Sweetman', 40.2194404602051, 0.701961659340402, -74.3880615234375, -1.29831659776009, 218, 37, 'PPL', 'P'),
(91193, 'Sweeton Hill', 35.3344383239746, 0.616702288096224, -85.7174987792969, -1.49605258027295, 218, 50, 'PPL', 'P'),
(153032, 'Sweets', 42.723331451416, 0.745662801248057, -75.3050003051758, -1.31432019854065, 218, 40, 'PPL', 'P'),
(126307, 'Sweets Corner', 42.6783294677734, 0.744877368463566, -73.2111129760742, -1.27777497048204, 218, 23, 'PPL', 'P'),
(153034, 'Sweets Crossing', 43.0222206115723, 0.750879401191304, -76.3633270263672, -1.33279148438728, 218, 40, 'PPL', 'P'),
(123770, 'Sweetser', 40.5719413757324, 0.708113960932649, -85.769172668457, -1.49695445977611, 218, 19, 'PPL', 'P'),
(51899, 'Sweetser Heights', 39.2269401550293, 0.684639261188036, -76.6563873291016, -1.33790635157688, 218, 25, 'PPL', 'P'),
(43273, 'Sweetville (historical)', 30.6747207641602, 0.535374874464466, -93.2480621337891, -1.62748570533887, 218, 22, 'PPL', 'P'),
(6196, 'Sweetwater', 34.6283302307129, 0.604378376993828, -86.9158325195313, -1.51696744957778, 218, 2, 'PPL', 'P'),
(18264, 'Sweetwater', 30.2694396972656, 0.528301385451161, -81.7644424438477, -1.42705873170254, 218, 12, 'PPL', 'P'),
(57808, 'Sweetwater', 36.8266716003418, 0.642746671976654, -94.2655563354492, -1.64524432927779, 218, 29, 'PPL', 'P'),
(69279, 'Sweetwater', 36.2924995422363, 0.633423610790559, -81.8199996948242, -1.42802838865544, 218, 33, 'PPL', 'P'),
(71462, 'Sweetwater', 39.6263885498047, 0.691610950868673, -74.6497192382813, -1.30288338639736, 218, 37, 'PPL', 'P'),
(77391, 'Sweetwater', 35.4222183227539, 0.618234338092319, -99.9111099243164, -1.7437778275013, 218, 42, 'PPL', 'P'),
(83943, 'Sweetwater', 33.5855598449707, 0.586178600420335, -81.9408264160156, -1.43013721276462, 218, 48, 'PPL', 'P'),
(91192, 'Sweetwater', 35.601390838623, 0.621361488423317, -84.4611129760742, -1.4741245113314, 218, 50, 'PPL', 'P'),
(140944, 'Sweetwater', 48.2158317565918, 0.841525015740168, -98.8708267211914, -1.72562146045358, 218, 34, 'PPL', 'P'),
(143159, 'Sweetwater', 41.0444412231445, 0.716360638985161, -99.0072174072266, -1.72800192699395, 218, 35, 'PPL', 'P'),
(167817, 'Sweetwater', 40.0277786254883, 0.698616529274181, -77.8847198486328, -1.35934479835202, 218, 45, 'PPL', 'P'),
(192296, 'Sweetwater', 32.4708290100098, 0.566722877076761, -100.405563354492, -1.75240766785565, 218, 51, 'PPL', 'P'),
(192883, 'Sweetwater', 31.9608306884766, 0.557821727186362, -112.58332824707, -1.96494976076491, 218, 5, 'PPL', 'P'),
(195684, 'Sweetwater', 46.372501373291, 0.80935283134952, -116.791938781738, -2.03840387152899, 218, 17, 'PPL', 'P'),
(189622, 'Sweetwater (historical)', 36.2836112976074, 0.633268481657062, -104.912498474121, -1.83106852486694, 218, 38, 'PPL', 'P'),
(190810, 'Sweetwater (historical)', 38.4625015258789, 0.67129729017993, -119.173889160156, -2.07997674825151, 218, 39, 'PPL', 'P'),
(197671, 'Sweetwater (historical)', 45.1158294677734, 0.787419768980927, -112.183326721191, -1.95796841712532, 218, 31, 'PPL', 'P'),
(25294, 'Sweetwater Bluff', 33.6322212219238, 0.586992995081681, -84.8372192382813, -1.48068880394428, 218, 13, 'PPL', 'P'),
(209769, 'Sweetwater Crossing', 42.5416717529297, 0.742492241391291, -108.178886413574, -1.88807774905783, 218, 59, 'PPL', 'P'),
(12239, 'Sweetwater Estates', 34.9880599975586, 0.610656845842717, -91.9622192382813, -1.60504351314888, 218, 4, 'PPL', 'P'),
(25295, 'Sweetwater Estates', 33.7902793884277, 0.58975163049684, -84.7816696166992, -1.47971928014944, 218, 13, 'PPL', 'P'),
(179295, 'Sweetwater Garden', 33.6041717529297, 0.586503439494298, -111.993057250977, -1.95464758840405, 218, 5, 'PPL', 'P'),
(31273, 'Sweetwater Lake', 39.2999992370605, 0.685914382717966, -86.1291732788086, -1.50323765573593, 218, 19, 'PPL', 'P'),
(25296, 'Sweetwater Oaks', 33.3875007629395, 0.582721817325412, -84.5722198486328, -1.47606369207914, 218, 13, 'PPL', 'P'),
(179296, 'Sweetwater Ranch', 33.6041717529297, 0.586503439494298, -111.887496948242, -1.95280521356193, 218, 5, 'PPL', 'P'),
(209770, 'Sweetwater Station', 42.5422210693359, 0.742501828771215, -108.183059692383, -1.88815058651364, 218, 59, 'PPL', 'P'),
(74492, 'Sweetwine (historical)', 39.0497207641602, 0.681546199318991, -84.394172668457, -1.47295618256118, 218, 41, 'PPL', 'P'),
(208900, 'Swem', 46.6599998474121, 0.814370626317393, -123.403327941895, -2.15379438050438, 218, 56, 'PPL', 'P'),
(167818, 'Swengel', 40.892219543457, 0.713703869481698, -77.1269378662109, -1.34611900774647, 218, 45, 'PPL', 'P'),
(192297, 'Swenson', 33.2069396972656, 0.579570432228494, -100.311668395996, -1.75076889167887, 218, 51, 'PPL', 'P'),
(69284, 'Swepsonville', 36.021110534668, 0.628686979054771, -79.3616714477539, -1.38512246664928, 218, 33, 'PPL', 'P'),
(202671, 'Swett', 43.1719398498535, 0.75349249485289, -101.951110839844, -1.77938256022095, 218, 49, 'PPL', 'P'),
(144539, 'Swetts Mills', 43.3147201538086, 0.755984481263905, -71.7211074829102, -1.25176946875353, 218, 36, 'PPL', 'P'),
(153035, 'Sweyze', 40.917781829834, 0.714150015543313, -72.7213897705078, -1.26922768812148, 218, 40, 'PPL', 'P'),
(157889, 'Swickards Addition', 40.3722190856934, 0.704628149381844, -80.7352828979492, -1.40909650909828, 218, 41, 'PPL', 'P'),
(6197, 'Swift', 30.3761100769043, 0.530163134790208, -87.6263885498047, -1.52936899182595, 218, 2, 'PPL', 'P'),
(43274, 'Swift', 32.4463882446289, 0.566296305249158, -93.2536087036133, -1.62758251124449, 218, 22, 'PPL', 'P'),
(57809, 'Swift', 36.3291702270508, 0.634063634979532, -89.7541732788086, -1.56650584112072, 218, 29, 'PPL', 'P'),
(74493, 'Swift', 39.5536117553711, 0.69034075618676, -81.7163925170898, -1.42622010227527, 218, 41, 'PPL', 'P'),
(91194, 'Swift', 35.3438911437988, 0.616867270925754, -88.14111328125, -1.53835263313112, 218, 50, 'PPL', 'P'),
(98404, 'Swift', 31.6200008392334, 0.551873124127993, -94.4830627441406, -1.64904053225364, 218, 51, 'PPL', 'P'),
(121649, 'Swift', 41.920280456543, 0.731646917326107, -88.0422210693359, -1.53662663842863, 218, 18, 'PPL', 'P'),
(138379, 'Swift', 48.853328704834, 0.85265143645841, -95.2211074829102, -1.66192184297219, 218, 28, 'PPL', 'P'),
(208901, 'Swift', 46.6752815246582, 0.814637341900564, -117.59806060791, -2.05247335156788, 218, 56, 'PPL', 'P'),
(153036, 'Swift Corner', 42.8663902282715, 0.748159647928061, -76.0288925170898, -1.3269545010681, 218, 40, 'PPL', 'P'),
(25297, 'Swift Creek', 33.7522201538086, 0.589087371541947, -84.1222229003906, -1.46820976370839, 218, 13, 'PPL', 'P'),
(106769, 'Swift Creek Farms', 37.4144401550293, 0.653005168495639, -77.6163864135742, -1.35466149641706, 218, 53, 'PPL', 'P'),
(138381, 'Swift Falls', 45.3988914489746, 0.792360132540106, -95.4236068725586, -1.66545612405484, 218, 28, 'PPL', 'P'),
(126308, 'Swift River', 42.4472198486328, 0.740843744676532, -72.8583297729492, -1.27161774204178, 218, 23, 'PPL', 'P'),
(106770, 'Swift Run', 38.3683280944824, 0.66965365373416, -78.5811080932617, -1.37149906609298, 218, 53, 'PPL', 'P'),
(179298, 'Swift Trail Junction', 32.7297210693359, 0.571241395919271, -109.713333129883, -1.91485889645383, 218, 5, 'PPL', 'P'),
(193178, 'Swiftcurrent', 48.7975006103516, 0.851677052394577, -113.668060302734, -1.98388190663818, 218, 31, 'PPL', 'P'),
(98405, 'Swiftex', 30.2059803009033, 0.52719381004331, -97.3132019042969, -1.698435778888, 218, 51, 'PPL', 'P'),
(12240, 'Swifton', 35.8216705322266, 0.625206094351983, -91.1283264160156, -1.5904893377916, 218, 4, 'PPL', 'P'),
(38466, 'Swifton', 36.8677787780762, 0.643464127574321, -84.9049987792969, -1.4818717801005, 218, 21, 'PPL', 'P'),
(61949, 'Swiftown', 33.3055610656738, 0.58129169982004, -90.4250030517578, -1.57821402937909, 218, 30, 'PPL', 'P'),
(126309, 'Swifts Beach', 41.7416687011719, 0.728529554112114, -70.720832824707, -1.23431138254362, 218, 23, 'PPL', 'P'),
(153037, 'Swifts Mills', 43.0597190856934, 0.751533873029192, -78.5186080932617, -1.37040823531048, 218, 40, 'PPL', 'P'),
(61950, 'Swiftwater', 33.3375015258789, 0.581849166015221, -91.0597229003906, -1.5892919805655, 218, 30, 'PPL', 'P'),
(144540, 'Swiftwater', 44.1327781677246, 0.770262287079065, -71.9519424438477, -1.2557982988506, 218, 36, 'PPL', 'P'),
(167819, 'Swiftwater', 41.0952796936035, 0.717247937681348, -75.3252792358398, -1.31467413264952, 218, 45, 'PPL', 'P'),
(51898, 'Swiger', 39.5502815246582, 0.690282632695969, -77.2772216796875, -1.34874195510409, 218, 25, 'PPL', 'P'),
(106771, 'Swimley', 39.2427787780762, 0.684915697309186, -78.0077819824219, -1.36149263777117, 218, 53, 'PPL', 'P'),
(69287, 'Swindell', 35.6233291625977, 0.621744384409044, -76.6902770996094, -1.33849783965499, 218, 33, 'PPL', 'P'),
(69288, 'Swindell Fork', 35.4419403076172, 0.618578551663212, -76.2797164916992, -1.33133220526797, 218, 33, 'PPL', 'P'),
(595, 'Swindleville', 32.7891693115234, 0.572278963479966, -93.7205581665039, -1.63573231681235, 218, 22, 'PPL', 'P'),
(146431, 'Swinesburg', 40.6386108398438, 0.709277562591931, -75.0577774047852, -1.31000534494251, 218, 37, 'PPL', 'P'),
(185511, 'Swingle', 38.5583305358887, 0.672969821923527, -121.674438476563, -2.12361956693129, 218, 6, 'PPL', 'P'),
(6198, 'Swink', 32.1375007629395, 0.560905201675483, -86.9952774047852, -1.51835402439933, 218, 2, 'PPL', 'P'),
(77393, 'Swink', 34.0177803039551, 0.593722270524094, -95.2019424438477, -1.66158734993928, 218, 42, 'PPL', 'P'),
(187424, 'Swink', 38.0144386291504, 0.663477117375994, -103.627777099609, -1.80864590691096, 218, 7, 'PPL', 'P'),
(106772, 'Swinks Mill', 38.9580612182617, 0.67994643845218, -77.2050018310547, -1.34748148096016, 218, 53, 'PPL', 'P'),
(208902, 'Swinomish Village', 48.4083290100098, 0.844884726613357, -122.51000213623, -2.13820290390251, 218, 56, 'PPL', 'P'),
(57810, 'Swinton', 37.0277786254883, 0.646256651714351, -89.9447174072266, -1.56983146353196, 218, 29, 'PPL', 'P'),
(83945, 'Swinton', 33.9958305358887, 0.593339174801286, -80.4058303833008, -1.40334647798869, 218, 48, 'PPL', 'P'),
(117986, 'Swisher', 41.8455581665039, 0.730342767340295, -91.6927795410156, -1.60034090329602, 218, 16, 'PPL', 'P'),
(57811, 'Swiss', 38.5627784729004, 0.673047453069303, -91.4711074829102, -1.59647199602241, 218, 29, 'PPL', 'P'),
(69289, 'Swiss', 35.9141693115234, 0.626820502604789, -82.4499969482422, -1.4390239150061, 218, 33, 'PPL', 'P'),
(111640, 'Swiss', 38.2330589294434, 0.667292761427805, -81.128059387207, -1.41595175206026, 218, 58, 'PPL', 'P'),
(98406, 'Swiss Alp', 29.7822208404541, 0.519797812221997, -96.9091720581055, -1.69138412779563, 218, 51, 'PPL', 'P'),
(193996, 'Swiss Bar', 41.8652801513672, 0.730686980911187, -122.712501525879, -2.14173718498515, 218, 6, 'PPL', 'P'),
(167820, 'Swissdale', 41.1780586242676, 0.718692702572716, -77.4336090087891, -1.35147142890531, 218, 45, 'PPL', 'P'),
(201632, 'Swisshome', 44.0580596923828, 0.76895820367228, -123.798057556152, -2.1606837119283, 218, 43, 'PPL', 'P'),
(167822, 'Swissmont', 41.4766693115234, 0.723904442246974, -78.4877777099609, -1.36987014361223, 218, 45, 'PPL', 'P'),
(34104, 'Swissvale', 38.833610534668, 0.677774364267112, -95.5800018310547, -1.66818573101411, 218, 20, 'PPL', 'P'),
(167823, 'Swissvale', 40.4236106872559, 0.705525102036983, -79.883056640625, -1.39422235493603, 218, 45, 'PPL', 'P'),
(106773, 'Switch Back', 38.0127792358398, 0.663448155499139, -79.8430633544922, -1.39352434041432, 218, 53, 'PPL', 'P'),
(111641, 'Switchback', 37.3711090087891, 0.652248897325084, -81.3858337402344, -1.42045076324778, 218, 58, 'PPL', 'P'),
(31276, 'Switz City', 39.2750015258789, 0.685478090352384, -87.0533294677734, -1.51936722403605, 218, 19, 'PPL', 'P'),
(74494, 'Switzer', 39.8358306884766, 0.695266405780916, -80.8891677856445, -1.41178230705763, 218, 41, 'PPL', 'P'),
(83947, 'Switzer', 34.8050003051758, 0.607461851482949, -82.0283279418945, -1.43166440249172, 218, 48, 'PPL', 'P'),
(111642, 'Switzer', 37.7930603027344, 0.65961333668748, -81.9877777099609, -1.43095666743203, 218, 58, 'PPL', 'P'),
(167825, 'Switzer', 40.6477813720703, 0.709437618573445, -75.7147216796875, -1.32147118554168, 218, 45, 'PPL', 'P'),
(31274, 'Switzer Crossroads', 38.2688903808594, 0.667918138230783, -86.4166717529297, -1.5082554507038, 218, 19, 'PPL', 'P'),
(18265, 'Switzerland', 30.0758304595947, 0.524922266791527, -81.6474990844727, -1.4250176850431, 218, 12, 'PPL', 'P'),
(83946, 'Switzerland', 32.4275016784668, 0.565966672485233, -81.0088882446289, -1.4138718232489, 218, 48, 'PPL', 'P'),
(194445, 'Switzerland Park', 40.0013885498047, 0.698155935563652, -105.434173583984, -1.84017347315976, 218, 7, 'PPL', 'P'),
(57812, 'Switzler', 39.0099983215332, 0.680852911908216, -92.2755584716797, -1.61051231444736, 218, 29, 'PPL', 'P'),
(193999, 'Swobe', 41.2769393920898, 0.720418497538114, -121.913330078125, -2.12778901193392, 218, 6, 'PPL', 'P'),
(208903, 'Swofford', 46.5052795410156, 0.81167024755108, -122.387222290039, -2.13605999133138, 218, 56, 'PPL', 'P'),
(106774, 'Swoope', 38.1580581665039, 0.665983751173004, -79.206672668457, -1.38241722761398, 218, 53, 'PPL', 'P'),
(25298, 'Swords', 33.5441703796387, 0.585456217974651, -83.3069381713867, -1.45398036084604, 218, 13, 'PPL', 'P'),
(43276, 'Swords', 30.5125007629395, 0.532543601330575, -92.2622222900391, -1.61027955416808, 218, 22, 'PPL', 'P'),
(106775, 'Swords Creek', 37.0361099243164, 0.646402060309869, -81.9180603027344, -1.42973986912998, 218, 53, 'PPL', 'P'),
(153046, 'Swormville', 43.038330078125, 0.75116056442339, -78.6975021362305, -1.37353052537249, 218, 40, 'PPL', 'P'),
(167826, 'Swoyersville', 41.2916717529297, 0.720675625741362, -75.875, -1.3242685699507, 218, 45, 'PPL', 'P'),
(121650, 'Swygert', 40.9116706848145, 0.714043355941655, -88.5294418334961, -1.54513024494731, 218, 18, 'PPL', 'P'),
(74496, 'Sybene', 38.4194412231445, 0.67054574612031, -82.5038909912109, -1.43996454350312, 218, 41, 'PPL', 'P'),
(25299, 'Sybert', 33.8147201538086, 0.590178202324443, -82.5550003051758, -1.44085656931024, 218, 13, 'PPL', 'P'),
(167831, 'Syberton', 40.5083312988281, 0.707003755653222, -78.5830612182617, -1.37153315455493, 218, 45, 'PPL', 'P'),
(167828, 'Sybertsville', 41.0013885498047, 0.715609228083595, -76.0766677856445, -1.3277883368054, 218, 45, 'PPL', 'P'),
(143160, 'Sybrant', 42.3183288574219, 0.738594172503742, -99.350830078125, -1.7339990994527, 218, 35, 'PPL', 'P'),
(6199, 'Sycamore', 33.2511100769043, 0.580341350785045, -86.2024993896484, -1.50451743779777, 218, 2, 'PPL', 'P'),
(12242, 'Sycamore', 33.8424987792969, 0.590663030800892, -93.1622161865234, -1.62598741090959, 218, 4, 'PPL', 'P'),
(14703, 'Sycamore', 38.5958290100098, 0.673624293761414, -75.4908294677734, -1.3175635292742, 218, 10, 'PPL', 'P'),
(25300, 'Sycamore', 31.6741695404053, 0.552818546314971, -83.6374969482422, -1.45974969987354, 218, 13, 'PPL', 'P'),
(34105, 'Sycamore', 37.3269386291504, 0.651477978768533, -95.7152786254883, -1.67054675647852, 218, 20, 'PPL', 'P'),
(38467, 'Sycamore', 38.246940612793, 0.667535042507975, -85.5608291625977, -1.49331817962371, 218, 21, 'PPL', 'P'),
(43275, 'Sycamore', 31.6124992370605, 0.551742196470902, -91.5341720581055, -1.59757268050093, 218, 22, 'PPL', 'P'),
(57813, 'Sycamore', 36.7033309936523, 0.640593972288515, -92.274169921875, -1.61048807968144, 218, 29, 'PPL', 'P'),
(77394, 'Sycamore', 36.4049987792969, 0.635387092883247, -94.7130584716797, -1.65305471496472, 218, 42, 'PPL', 'P'),
(79245, 'Sycamore', 39.9266700744629, 0.696851852156867, -80.245002746582, -1.40053950619975, 218, 45, 'PPL', 'P'),
(83948, 'Sycamore', 33.0355606079102, 0.576579302850172, -81.2222213745117, -1.41759518876894, 218, 48, 'PPL', 'P'),
(91197, 'Sycamore', 36.3219413757324, 0.63393746772289, -87.0530624389648, -1.51936256350414, 218, 50, 'PPL', 'P'),
(98407, 'Sycamore', 33.3236083984375, 0.581606685197969, -97.4897232055664, -1.70151665679505, 218, 51, 'PPL', 'P'),
(106776, 'Sycamore', 37.024169921875, 0.64619366795457, -79.3586120605469, -1.38506907026942, 218, 53, 'PPL', 'P'),
(111644, 'Sycamore', 37.8277816772461, 0.660219338993527, -82.0713882446289, -1.43241594655134, 218, 58, 'PPL', 'P'),
(112265, 'Sycamore', 30.583890914917, 0.533789594536082, -84.8288879394531, -1.48054339534877, 218, 12, 'PPL', 'P'),
(121651, 'Sycamore', 41.9888916015625, 0.732844407710261, -88.6866683959961, -1.54787436613453, 218, 18, 'PPL', 'P'),
(123771, 'Sycamore', 40.4941711425781, 0.706756614304062, -85.9194412231445, -1.49957714081762, 218, 19, 'PPL', 'P'),
(157890, 'Sycamore', 40.9497184753418, 0.714707415159467, -83.1708297729492, -1.45160482115369, 218, 41, 'PPL', 'P'),
(179299, 'Sycamore', 34.8638916015625, 0.608489698505665, -112.099166870117, -1.95649955062609, 218, 5, 'PPL', 'P'),
(185512, 'Sycamore', 39.1338882446289, 0.683015198976279, -121.940826416016, -2.12826891356235, 218, 6, 'PPL', 'P'),
(61951, 'Sycamore (historical)', 33.9130592346191, 0.591894543067972, -88.879997253418, -1.55124859123566, 218, 30, 'PPL', 'P'),
(91196, 'Sycamore (historical)', 36.3886108398438, 0.635101069382172, -83.5263900756836, -1.45781051912579, 218, 50, 'PPL', 'P'),
(51903, 'Sycamore Acres', 39.1172218322754, 0.682724315206215, -77.0902786254883, -1.34547918329458, 218, 25, 'PPL', 'P'),
(69290, 'Sycamore Acres', 35.8613891601563, 0.625899315183731, -81.585563659668, -1.42393670795664, 218, 33, 'PPL', 'P'),
(12243, 'Sycamore Bend Farm', 34.9847183227539, 0.610598522614844, -90.4522171020508, -1.57868900415951, 218, 4, 'PPL', 'P'),
(123772, 'Sycamore Corner', 40.3600006103516, 0.704414896757556, -87.434440612793, -1.52601886833269, 218, 19, 'PPL', 'P'),
(185513, 'Sycamore Cove', 34.0711097717285, 0.594653045325076, -119.013893127441, -2.0771842906905, 218, 6, 'PPL', 'P'),
(51900, 'Sycamore Creek', 39.0922203063965, 0.682287956261605, -77.0961074829102, -1.34558091604822, 218, 25, 'PPL', 'P'),
(106777, 'Sycamore Creek', 37.6783294677734, 0.657610905863849, -77.6994400024414, -1.35611105499839, 218, 53, 'PPL', 'P'),
(106778, 'Sycamore Crossroads', 36.9850006103516, 0.645510034502747, -76.8338928222656, -1.34100440687297, 218, 53, 'PPL', 'P'),
(14704, 'Sycamore Farms', 39.4300003051758, 0.688183329387686, -75.6555633544922, -1.32043867798705, 218, 10, 'PPL', 'P'),
(51901, 'Sycamore Farms', 39.5511093139648, 0.690297080344882, -75.8152770996094, -1.32322620870004, 218, 25, 'PPL', 'P'),
(38468, 'Sycamore Flat', 37.1238899230957, 0.647934110305964, -85.043327331543, -1.48428606878671, 218, 21, 'PPL', 'P'),
(185514, 'Sycamore Flat', 36.2666702270508, 0.632972804197036, -121.392501831055, -2.11869884418515, 218, 6, 'PPL', 'P'),
(31277, 'Sycamore Ford', 39.9583282470703, 0.697404391504031, -87.0466690063477, -1.51925097705447, 218, 19, 'PPL', 'P'),
(14705, 'Sycamore Gardens', 39.6958312988281, 0.692822955480768, -75.7069396972656, -1.32133536432608, 218, 10, 'PPL', 'P'),
(12244, 'Sycamore Heights', 36.2855606079102, 0.633302503539987, -92.2652816772461, -1.61033295054794, 218, 4, 'PPL', 'P'),
(51902, 'Sycamore Heights', 39.6405601501465, 0.691858291954914, -77.6505584716797, -1.35525791134319, 218, 25, 'PPL', 'P'),
(57814, 'Sycamore Hills', 38.7008285522461, 0.675456881486525, -90.3497161865234, -1.57690002569725, 218, 29, 'PPL', 'P'),
(185516, 'Sycamore Hills', 33.5952796936035, 0.586348243781773, -116.951667785645, -2.04119166855808, 218, 6, 'PPL', 'P'),
(79246, 'Sycamore Mills', 39.9458312988281, 0.697186278610754, -75.42138671875, -1.31635152466211, 218, 45, 'PPL', 'P'),
(51904, 'Sycamore Ridge', 38.6972198486328, 0.675393897726744, -76.5944366455078, -1.33682510817431, 218, 25, 'PPL', 'P'),
(12251, 'Sycamore Spring', 36.2986106872559, 0.633530270392216, -92.248893737793, -1.61004692704687, 218, 4, 'PPL', 'P'),
(91198, 'Sycamore Spring', 36.2347183227539, 0.632415138264773, -83.5708312988281, -1.45858616479328, 218, 50, 'PPL', 'P'),
(51905, 'Sycamore Springs', 39.2758293151855, 0.685492538001298, -76.961669921875, -1.34323453796981, 218, 25, 'PPL', 'P'),
(185518, 'Sycamore Springs', 35.1863899230957, 0.614118356048574, -120.713333129883, -2.10684511417321, 218, 6, 'PPL', 'P'),
(91199, 'Sycamore Swamp', 35.077220916748, 0.612212997446677, -86.3930587768555, -1.50784332652511, 218, 50, 'PPL', 'P'),
(74498, 'Sycamore Valley', 39.666389465332, 0.692309098548437, -81.2436065673828, -1.41796843079572, 218, 41, 'PPL', 'P'),
(91200, 'Sycamore Valley', 36.517219543457, 0.637345714706946, -85.9280624389648, -1.49972760941921, 218, 50, 'PPL', 'P'),
(106779, 'Sycamore Valley', 37.8769416809082, 0.661077342917724, -79.5058288574219, -1.38763848808913, 218, 53, 'PPL', 'P'),
(117987, 'Sycamore Village', 41.4069404602051, 0.722687444207835, -94.9972229003906, -1.65801431986277, 218, 16, 'PPL', 'P'),
(153038, 'Sycaway', 42.7419395446777, 0.745987573742992, -73.6530609130859, -1.28548841710529, 218, 40, 'PPL', 'P'),
(106780, 'Sycolin', 39.0636100769043, 0.681788613557215, -77.5519409179688, -1.35353671033067, 218, 53, 'PPL', 'P'),
(25301, 'Sycorax (historical)', 33.9916687011719, 0.593266537082554, -82.9166717529297, -1.447168926884, 218, 13, 'PPL', 'P'),
(12245, 'Sydenham (historical)', 36.0550003051758, 0.629278467132878, -94.0250015258789, -1.64104585581928, 218, 4, 'PPL', 'P'),
(18266, 'Sydney', 27.9630603790283, 0.488047472548018, -82.2074966430664, -1.43479148624369, 218, 12, 'PPL', 'P'),
(140946, 'Sydney', 46.7308311462402, 0.815606865695408, -98.7694396972656, -1.72385192306728, 218, 34, 'PPL', 'P'),
(111645, 'Sydnor Addition', 37.5955581665039, 0.656166274130536, -82.1369400024414, -1.43356004055564, 218, 58, 'PPL', 'P'),
(106781, 'Sydnorsville', 36.8919410705566, 0.643885839132935, -79.8655624389648, -1.39391702351705, 218, 53, 'PPL', 'P'),
(176633, 'Syene (historical)', 43.0055618286133, 0.750588650579295, -89.3955612182617, -1.56024687992682, 218, 57, 'PPL', 'P'),
(57815, 'Syenite', 37.6766700744629, 0.657581943986995, -90.3916702270508, -1.57763226183897, 218, 29, 'PPL', 'P'),
(167829, 'Sygan', 40.353889465332, 0.704308237155898, -80.1369400024414, -1.39865345551576, 218, 45, 'PPL', 'P'),
(167830, 'Sygan Hill', 40.3561096191406, 0.704346986149759, -80.1350021362305, -1.39861963336991, 218, 45, 'PPL', 'P'),
(986, 'Sykes', 36.1233291625977, 0.630471030669015, -85.977783203125, -1.50059540046041, 218, 50, 'PPL', 'P'),
(61952, 'Sykes', 32.0938911437988, 0.560144070235938, -88.5922164916992, -1.54622586941977, 218, 30, 'PPL', 'P'),
(185520, 'Sykes', 36.0366706848145, 0.628958554906932, -117.959442138672, -2.05878064913557, 218, 6, 'PPL', 'P'),
(61953, 'Sykes (historical)', 33.7730598449707, 0.589451092767824, -88.6108322143555, -1.54655077507276, 218, 30, 'PPL', 'P'),
(140948, 'Sykeston', 47.4650001525879, 0.82842053212227, -99.399169921875, -1.73484278888603, 218, 34, 'PPL', 'P'),
(51906, 'Sykesville', 39.3736114501953, 0.687199158206848, -76.9680633544922, -1.34334612441948, 218, 25, 'PPL', 'P'),
(146432, 'Sykesville', 40.0636100769043, 0.699241906077159, -74.6188888549805, -1.30234529469911, 218, 37, 'PPL', 'P'),
(167832, 'Sykesville', 41.0502815246582, 0.716462571475883, -78.8225021362305, -1.37571218693749, 218, 45, 'PPL', 'P'),
(6201, 'Sylacauga', 33.1730613708496, 0.578979143887469, -86.2516708374023, -1.50537564145905, 218, 2, 'PPL', 'P'),
(12246, 'Sylamore', 35.9413909912109, 0.627295610543259, -92.1080627441406, -1.60758896251878, 218, 4, 'PPL', 'P'),
(91201, 'Sylco', 35.0338897705078, 0.611456726276122, -84.5986099243164, -1.47652428578967, 218, 50, 'PPL', 'P'),
(83959, 'Sylecope', 32.7894401550293, 0.572283690590901, -80.0388870239258, -1.39694210819927, 218, 48, 'PPL', 'P'),
(51907, 'Sylmac', 38.9947204589844, 0.680586262904072, -76.5888900756836, -1.33672830226869, 218, 25, 'PPL', 'P'),
(51908, 'Sylmar', 39.7213897705078, 0.693269034963356, -76.0280609130859, -1.32693998684016, 218, 25, 'PPL', 'P'),
(79247, 'Sylmar', 39.7230606079102, 0.693298196577293, -76.0280609130859, -1.32693998684016, 218, 45, 'PPL', 'P'),
(185524, 'Sylmar', 34.3077812194824, 0.598783741333844, -118.448333740234, -2.06731341726818, 218, 6, 'PPL', 'P'),
(69292, 'Sylva', 35.3736114501953, 0.617385988127074, -83.2261123657227, -1.45256968441663, 218, 33, 'PPL', 'P'),
(153039, 'Sylva', 41.6322212219238, 0.726619335241228, -74.1055603027344, -1.29338602131792, 218, 40, 'PPL', 'P'),
(6202, 'Sylvan', 33.0727806091309, 0.577228914419069, -87.6986083984375, -1.53062946596989, 218, 2, 'PPL', 'P'),
(79248, 'Sylvan', 39.7533302307129, 0.693826501158537, -78.0219421386719, -1.36173977912033, 218, 45, 'PPL', 'P'),
(98408, 'Sylvan', 33.6441688537598, 0.587201520595035, -95.4338912963867, -1.66563562111231, 218, 51, 'PPL', 'P'),
(138382, 'Sylvan', 46.3349990844727, 0.808698292932606, -94.4063873291016, -1.64770229380588, 218, 28, 'PPL', 'P'),
(176634, 'Sylvan', 43.4225006103516, 0.757865605099882, -90.628059387207, -1.58175803099972, 218, 57, 'PPL', 'P'),
(201633, 'Sylvan', 45.5091705322266, 0.794284865638934, -122.734443664551, -2.14212014754991, 218, 43, 'PPL', 'P'),
(28744, 'Sylvan (historical)', 39.9850006103516, 0.697869912062577, -90.0711135864258, -1.57203749302093, 218, 18, 'PPL', 'P'),
(209771, 'Sylvan Bay Summer Home Area', 42.9544410705566, 0.749696425035091, -109.784439086914, -1.91609992952181, 218, 59, 'PPL', 'P'),
(98409, 'Sylvan Beach', 29.6474990844727, 0.517446474006052, -95.0136108398438, -1.65830034336385, 218, 51, 'PPL', 'P'),
(133342, 'Sylvan Beach', 43.371940612793, 0.756983166672684, -86.4236068725586, -1.50837649137535, 218, 27, 'PPL', 'P'),
(153041, 'Sylvan Beach', 42.4647216796875, 0.741149209253564, -77.1086120605469, -1.34579916209955, 218, 40, 'PPL', 'P'),
(133343, 'Sylvan Center', 42.2861099243164, 0.738031846039572, -84.0777816772461, -1.4674341180409, 218, 27, 'PPL', 'P'),
(167834, 'Sylvan Dell', 41.2305603027344, 0.719609029724785, -76.9411087036133, -1.34287567701292, 218, 45, 'PPL', 'P'),
(146433, 'Sylvan Glen', 40.1783294677734, 0.701244137163707, -74.7050018310547, -1.3038482496603, 218, 37, 'PPL', 'P'),
(6203, 'Sylvan Grove', 31.353609085083, 0.547223710917905, -85.4655609130859, -1.49165543499712, 218, 2, 'PPL', 'P'),
(31279, 'Sylvan Grove', 38.4677810668945, 0.671389435553647, -85.7363891601563, -1.4963822796159, 218, 19, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(34108, 'Sylvan Grove', 39.0094413757324, 0.680843191370237, -98.3938903808594, -1.71729735099237, 218, 20, 'PPL', 'P'),
(51916, 'Sylvan Grove', 39.6644401550293, 0.692275076665511, -77.7972183227539, -1.35781760862492, 218, 25, 'PPL', 'P'),
(167835, 'Sylvan Grove', 41.0294418334961, 0.716098850250006, -78.1547164916992, -1.36405712874286, 218, 45, 'PPL', 'P'),
(91202, 'Sylvan Heights', 35.1763916015625, 0.613943852418147, -90.017219543457, -1.57109686452391, 218, 50, 'PPL', 'P'),
(51909, 'Sylvan Hill', 39.2900009155273, 0.685739879087539, -76.7941665649414, -1.34031105288317, 218, 25, 'PPL', 'P'),
(12248, 'Sylvan Hills', 34.8363914489746, 0.608009730298205, -92.2311096191406, -1.60973653562182, 218, 4, 'PPL', 'P'),
(25302, 'Sylvan Hills', 33.709171295166, 0.588336027219408, -84.4177780151367, -1.47336817358182, 218, 13, 'PPL', 'P'),
(83949, 'Sylvan Hills', 34.9319381713867, 0.609677335193786, -82.3680572509766, -1.43759379750073, 218, 48, 'PPL', 'P'),
(167836, 'Sylvan Hills', 40.4461097717285, 0.705917785139715, -78.3850021362305, -1.36807637146001, 218, 45, 'PPL', 'P'),
(18267, 'Sylvan Lake', 28.795280456543, 0.502572453001851, -81.3630599975586, -1.42005328645509, 218, 12, 'PPL', 'P'),
(121653, 'Sylvan Lake', 42.2438888549805, 0.737294949365947, -88.0527801513672, -1.53681092917607, 218, 18, 'PPL', 'P'),
(133344, 'Sylvan Lake', 42.6113891601563, 0.743709039693348, -83.32861328125, -1.45435866287889, 218, 27, 'PPL', 'P'),
(153042, 'Sylvan Lake', 41.6074981689453, 0.726187836565608, -73.7350006103516, -1.28691853461066, 218, 40, 'PPL', 'P'),
(43277, 'Sylvan Lake Estates', 32.5491714477539, 0.568090210559435, -92.1869430541992, -1.60896568364429, 218, 22, 'PPL', 'P'),
(202672, 'Sylvan Lake Resort', 43.8461112976074, 0.765259006339133, -103.563888549805, -1.80753084136255, 218, 49, 'PPL', 'P'),
(79250, 'Sylvan Lane', 39.7436103820801, 0.693656857797099, -79.1122207641602, -1.38076873089922, 218, 45, 'PPL', 'P'),
(185521, 'Sylvan Lodge', 38.084171295166, 0.66469418199416, -120.156112670898, -2.09711978250446, 218, 6, 'PPL', 'P'),
(123773, 'Sylvan Manor', 41.4588890075684, 0.723594117400952, -87.1074981689453, -1.52031264622303, 218, 19, 'PPL', 'P'),
(185522, 'Sylvan Meadows', 33.5302810668945, 0.585213803736427, -117.281112670898, -2.04694156650962, 218, 6, 'PPL', 'P'),
(176635, 'Sylvan Mounds', 42.9991683959961, 0.750477064129621, -88.9783325195313, -1.55296486540016, 218, 57, 'PPL', 'P'),
(51910, 'Sylvan Park', 39.6211090087891, 0.691518805494956, -76.9175033569336, -1.34246368599228, 218, 25, 'PPL', 'P'),
(51911, 'Sylvan Shores', 38.9527816772461, 0.679854293078463, -76.5813903808594, -1.33659740790111, 218, 25, 'PPL', 'P'),
(74501, 'Sylvan Shores', 39.9397201538086, 0.697079619009096, -83.5911102294922, -1.45894009890215, 218, 41, 'PPL', 'P'),
(176636, 'Sylvan Shores', 43.8069381713867, 0.764575306308282, -89.0380630493164, -1.55400735980887, 218, 57, 'PPL', 'P'),
(6204, 'Sylvan Springs', 33.5155601501465, 0.584956875270261, -87.0149993896484, -1.51869823797022, 218, 2, 'PPL', 'P'),
(51912, 'Sylvan View', 39.0924987792969, 0.682292816530595, -76.4641723632813, -1.33455156755171, 218, 25, 'PPL', 'P'),
(121667, 'Sylvan Woods', 41.6438903808594, 0.726823000485591, -87.9663925170898, -1.53530318052492, 218, 18, 'PPL', 'P'),
(25303, 'Sylvandale', 31.5933303833008, 0.551407636858961, -84.1141662597656, -1.46806914880283, 218, 13, 'PPL', 'P'),
(185523, 'Sylvandale (historical)', 39.4886093139648, 0.689206249562386, -123.421669006348, -2.1541144924674, 218, 6, 'PPL', 'P'),
(38469, 'Sylvandell', 38.4474983215332, 0.671035434865748, -84.1594390869141, -1.46885930869826, 218, 21, 'PPL', 'P'),
(51913, 'Sylvanhurst', 38.6236114501953, 0.67410918881689, -76.7750015258789, -1.33997655985026, 218, 25, 'PPL', 'P'),
(6205, 'Sylvania', 34.5622215270996, 0.603224562451551, -85.8125, -1.49771066436763, 218, 2, 'PPL', 'P'),
(12249, 'Sylvania', 34.9722213745117, 0.610380409721566, -91.9283294677734, -1.60445202507077, 218, 4, 'PPL', 'P'),
(18268, 'Sylvania', 30.6166706085205, 0.534361708117259, -85.6747207641602, -1.49530596306135, 218, 12, 'PPL', 'P'),
(25304, 'Sylvania', 32.7502784729004, 0.571600190297132, -81.6369400024414, -1.42483339429567, 218, 13, 'PPL', 'P'),
(31278, 'Sylvania', 39.9188919067383, 0.6967160975203, -87.2944412231445, -1.52357541803254, 218, 19, 'PPL', 'P'),
(38470, 'Sylvania', 38.1569404602051, 0.665964243518019, -85.8741683959961, -1.49878698092219, 218, 21, 'PPL', 'P'),
(57816, 'Sylvania', 37.5077781677246, 0.65463422413444, -94.0224990844727, -1.6410021799774, 218, 29, 'PPL', 'P'),
(157893, 'Sylvania', 41.7188911437988, 0.728132010740393, -83.7130584716797, -1.46106849724534, 218, 41, 'PPL', 'P'),
(167837, 'Sylvania', 41.8050003051758, 0.729634899122552, -76.8572235107422, -1.34141160420365, 218, 45, 'PPL', 'P'),
(176638, 'Sylvania', 42.6986083984375, 0.745231302572437, -87.9583282470703, -1.53516243246131, 218, 57, 'PPL', 'P'),
(190811, 'Sylvania', 37.3980598449707, 0.652719278152619, -117.723327636719, -2.05465967366478, 218, 39, 'PPL', 'P'),
(79251, 'Sylvania Heights', 39.9291687011719, 0.696895461419717, -76.6666717529297, -1.33808584863436, 218, 45, 'PPL', 'P'),
(106783, 'Sylvania Heights', 38.2738914489746, 0.66800542333551, -77.4449996948242, -1.35167023388069, 218, 53, 'PPL', 'P'),
(197672, 'Sylvanite', 48.7163887023926, 0.850261382538118, -115.873329162598, -2.02237110913449, 218, 31, 'PPL', 'P'),
(61954, 'Sylvarena', 32.0108299255371, 0.558694378496554, -89.3805618286133, -1.55998509119167, 218, 30, 'PPL', 'P'),
(106782, 'Sylvatus', 36.8583297729492, 0.643299211323818, -80.7638931274414, -1.40959585180267, 218, 53, 'PPL', 'P'),
(12250, 'Sylverino', 33.3166694641113, 0.581485577947397, -93.9375, -1.63951866609217, 218, 4, 'PPL', 'P'),
(25305, 'Sylvester', 31.5305595397949, 0.550312078965529, -83.835563659668, -1.46320661612651, 218, 13, 'PPL', 'P'),
(111646, 'Sylvester', 38.0102806091309, 0.663404546236289, -81.5577774047852, -1.42345174632214, 218, 58, 'PPL', 'P'),
(133348, 'Sylvester', 43.5397186279297, 0.759911445449281, -85.2544403076172, -1.48797068531289, 218, 27, 'PPL', 'P'),
(167840, 'Sylvester', 41.9636116027832, 0.732403188496662, -77.5591735839844, -1.35366294416634, 218, 45, 'PPL', 'P'),
(192299, 'Sylvester', 32.7208290100098, 0.571086200206747, -100.253890991211, -1.74976048573211, 218, 51, 'PPL', 'P'),
(34109, 'Sylvia', 37.9577789306641, 0.66248821908422, -98.4077835083008, -1.71753983180963, 218, 20, 'PPL', 'P'),
(91203, 'Sylvia', 36.1716690063477, 0.631314720102352, -87.4255599975586, -1.52586387235724, 218, 50, 'PPL', 'P'),
(12253, 'Sylvia (historical)', 36.107780456543, 0.630199654553936, -92.6022186279297, -1.616213609709, 218, 4, 'PPL', 'P'),
(192300, 'Sylvia Andrea Colonia', 31.5739994049072, 0.551070247638361, -106.267997741699, -1.85472645009455, 218, 51, 'PPL', 'P'),
(98410, 'Sylvia Colonia', 26.2140007019043, 0.457520622368335, -97.9850006103516, -1.71016087821929, 218, 51, 'PPL', 'P'),
(83950, 'Sylvia Lane', 32.7891693115234, 0.572278963479966, -80.0480575561523, -1.39710216418078, 218, 48, 'PPL', 'P'),
(185525, 'Sylvia Park', 34.1150016784668, 0.595419103612638, -118.580833435059, -2.06962597320075, 218, 6, 'PPL', 'P'),
(77395, 'Sylvian', 35.3477783203125, 0.616935114954524, -96.5652770996094, -1.68538202848886, 218, 42, 'PPL', 'P'),
(167841, 'Sylvis', 40.7363891601563, 0.710984116218454, -78.7230606079102, -1.37397660485508, 218, 45, 'PPL', 'P'),
(38471, 'Symbol', 37.2738914489746, 0.650552130815567, -84.1388931274414, -1.46850071405748, 218, 21, 'PPL', 'P'),
(176639, 'Symco', 44.5133285522461, 0.776904144258695, -88.9038925170898, -1.55166564226237, 218, 57, 'PPL', 'P'),
(121654, 'Symerton', 41.3286094665527, 0.721320310462243, -88.0524978637695, -1.53680600232805, 218, 18, 'PPL', 'P'),
(74502, 'Symmes', 39.246940612793, 0.684988335027918, -84.29638671875, -1.47124949577661, 218, 41, 'PPL', 'P'),
(74503, 'Symmes Corner', 39.3377799987793, 0.68657378140387, -84.5697174072266, -1.47602001623727, 218, 41, 'PPL', 'P'),
(126310, 'Symmes Corner', 42.4430618286133, 0.740771173536827, -71.1333312988281, -1.24151083907649, 218, 23, 'PPL', 'P'),
(61955, 'Symonds', 33.8338890075684, 0.590512761936385, -90.8902816772461, -1.58633467333302, 218, 30, 'PPL', 'P'),
(69296, 'Symonds Creek', 36.1925010681152, 0.631678308170175, -76.2316665649414, -1.3304935758407, 218, 33, 'PPL', 'P'),
(38472, 'Symsonia', 36.920280456543, 0.64438045472639, -88.5199966430664, -1.54496539527584, 218, 21, 'PPL', 'P'),
(61956, 'Synagogue', 34.7833290100098, 0.60708361602913, -88.5597229003906, -1.54565874926564, 218, 30, 'PPL', 'P'),
(208905, 'Synarep', 48.521110534668, 0.846853135554062, -119.329719543457, -2.08269650151475, 218, 56, 'PPL', 'P'),
(31280, 'Syndicate', 39.6172218322754, 0.691450961466186, -87.4141693115234, -1.52566506738187, 218, 19, 'PPL', 'P'),
(167842, 'Syner', 40.3491706848145, 0.704225878899187, -76.5880584716797, -1.33671378804075, 218, 45, 'PPL', 'P'),
(153043, 'Syosset', 40.8261108398438, 0.712550054939421, -73.5025024414063, -1.28286067605771, 218, 40, 'PPL', 'P'),
(57818, 'Syracuse', 38.6699981689453, 0.674918789788274, -92.8730621337891, -1.62094072064389, 218, 29, 'PPL', 'P'),
(74507, 'Syracuse', 38.997501373291, 0.680634799014939, -81.9741668701172, -1.4307191134628, 218, 41, 'PPL', 'P'),
(83951, 'Syracuse', 34.2311096191406, 0.597445569465106, -79.9674987792969, -1.39569614828328, 218, 48, 'PPL', 'P'),
(123774, 'Syracuse', 41.4277801513672, 0.723051165433712, -85.7525024414063, -1.49666350942701, 218, 19, 'PPL', 'P'),
(143161, 'Syracuse', 40.6572189331055, 0.709602335086867, -96.1861114501953, -1.67876433949613, 218, 35, 'PPL', 'P'),
(153044, 'Syracuse', 43.0480613708496, 0.751330407521909, -76.1477813720703, -1.32902950303143, 218, 40, 'PPL', 'P'),
(187925, 'Syracuse', 37.9805603027344, 0.662885829034969, -101.752220153809, -1.77591126289809, 218, 20, 'PPL', 'P'),
(206018, 'Syracuse', 41.0894393920898, 0.717146005190625, -112.063888549805, -1.95588382778207, 218, 52, 'PPL', 'P'),
(138385, 'Syre', 47.1802787780762, 0.823451206686236, -96.2583312988281, -1.68002481364006, 218, 28, 'PPL', 'P'),
(31282, 'Syria', 38.586109161377, 0.673454650399976, -86.4016723632813, -1.50799366196865, 218, 19, 'PPL', 'P'),
(106784, 'Syria', 38.4877815246582, 0.671738509393529, -78.3263931274414, -1.36705345128531, 218, 53, 'PPL', 'P'),
(106785, 'Syringa', 37.5788917541504, 0.655875390360472, -76.4569396972656, -1.33442533371604, 218, 53, 'PPL', 'P'),
(195685, 'Syringa', 46.1508293151855, 0.805483924075908, -115.726112365723, -2.01980169131478, 218, 17, 'PPL', 'P'),
(106786, 'Sysonby Ridge', 37.2144393920898, 0.649514496675845, -77.4852828979492, -1.35237330840847, 218, 53, 'PPL', 'P'),
(51914, 'T B', 38.7011108398438, 0.675461808334541, -76.8747177124023, -1.34171693562262, 218, 25, 'PPL', 'P'),
(208904, 'T Bridge Corner', 47.9749984741211, 0.837321682012669, -117.478332519531, -2.05038370221855, 218, 56, 'PPL', 'P'),
(114147, 'Ta''agan Point', 41.4375, 0.72322080879515, -73.45361328125, -1.28200739924445, 218, 8, 'PPL', 'P'),
(113063, 'Tab', 40.4111099243164, 0.705306922564678, -87.4727783203125, -1.52668798755657, 218, 19, 'PPL', 'P'),
(153047, 'Tabasco', 41.8474998474121, 0.730376656065166, -74.3011093139648, -1.29679899541291, 218, 40, 'PPL', 'P'),
(43278, 'Tabatiere Perdue', 29.7269401550293, 0.518832982248575, -90.3397216796875, -1.57672558864585, 218, 22, 'PPL', 'P'),
(106788, 'Tabb', 37.1230583190918, 0.647919596078024, -76.4577789306641, -1.33443998110204, 218, 53, 'PPL', 'P'),
(111648, 'Tabb (historical)', 39.5138893127441, 0.689647468775985, -77.9680633544922, -1.36079941693942, 218, 58, 'PPL', 'P'),
(61957, 'Tabbville', 33.8472213745117, 0.59074545563663, -89.086669921875, -1.55485570977412, 218, 30, 'PPL', 'P'),
(51915, 'Tabbys Delight', 39.5663909912109, 0.690563795928054, -76.8819427490234, -1.34184303630024, 218, 25, 'PPL', 'P'),
(57823, 'Tabeau', 39.2044410705566, 0.684246578085304, -93.7236099243164, -1.63578558003415, 218, 29, 'PPL', 'P'),
(106797, 'Taber', 37.0730590820313, 0.647046944767832, -79.2033309936523, -1.38235890438611, 218, 53, 'PPL', 'P'),
(195686, 'Taber', 43.3180618286133, 0.756042804491777, -112.688056945801, -1.96677762137909, 218, 17, 'PPL', 'P'),
(153048, 'Taberg', 43.3036117553711, 0.755790603136547, -75.6172180175781, -1.31976942560512, 218, 40, 'PPL', 'P'),
(6209, 'Tabernacle', 31.1816692352295, 0.544222794422577, -85.4683303833008, -1.49170377137091, 218, 2, 'PPL', 'P'),
(25315, 'Tabernacle', 33.7833290100098, 0.589630323509187, -85.211669921875, -1.48722420125934, 218, 13, 'PPL', 'P'),
(38473, 'Tabernacle', 36.8738899230957, 0.643570787175979, -87.2313919067383, -1.52247499987012, 218, 21, 'PPL', 'P'),
(71466, 'Tabernacle', 39.8438911437988, 0.695407087265499, -74.710563659668, -1.30394532188203, 218, 37, 'PPL', 'P'),
(83952, 'Tabernacle', 34.0586090087891, 0.594434865852772, -79.436393737793, -1.38642661663509, 218, 48, 'PPL', 'P'),
(91204, 'Tabernacle', 35.5224990844727, 0.619984567560719, -89.5769424438477, -1.5634125795146, 218, 50, 'PPL', 'P'),
(106789, 'Tabernacle', 37.4230613708496, 0.653155637097228, -76.2966690063477, -1.33162808246508, 218, 53, 'PPL', 'P'),
(61958, 'Tabernacle (historical)', 33.0783309936523, 0.577325786903721, -89.4286117553711, -1.56082372061893, 218, 30, 'PPL', 'P'),
(83953, 'Tabernacle (historical)', 34.4427795410156, 0.601139906529264, -80.1716690063477, -1.39925959097986, 218, 48, 'PPL', 'P'),
(187425, 'Tabernash', 39.9936103820801, 0.698020180927085, -105.842498779297, -1.84730009223681, 218, 7, 'PPL', 'P'),
(31281, 'Tabertown', 39.4947204589844, 0.689312909164043, -87.253059387207, -1.52285316874491, 218, 19, 'PPL', 'P'),
(57820, 'Taberville', 38.0083312988281, 0.663370524353364, -93.9944381713867, -1.64051242465294, 218, 29, 'PPL', 'P'),
(206021, 'Tabiona', 40.3547210693359, 0.704322751383839, -110.712783813477, -1.93230260159385, 218, 52, 'PPL', 'P'),
(193997, 'Table Bluff', 40.6583290100098, 0.709621709583797, -124.215278625488, -2.16796559329691, 218, 6, 'PPL', 'P'),
(193998, 'Table Bluff Rancheria', 40.6841697692871, 0.710072715914402, -124.244438171387, -2.16847452338122, 218, 6, 'PPL', 'P'),
(121655, 'Table Grove', 40.3641700744629, 0.704487667634342, -90.4250030517578, -1.57821402937909, 218, 18, 'PPL', 'P'),
(117988, 'Table Mound Mobile Home Park', 42.4555587768555, 0.740989286430105, -90.6722183227539, -1.58252874981919, 218, 16, 'PPL', 'P'),
(57822, 'Table Rock', 36.6047210693359, 0.638872904434052, -93.2986068725586, -1.62836787744996, 218, 29, 'PPL', 'P'),
(69295, 'Table Rock', 35.8380584716797, 0.625492117853058, -81.8047180175781, -1.42776167307227, 218, 33, 'PPL', 'P'),
(79252, 'Table Rock', 39.913330078125, 0.696619025298567, -77.2216720581055, -1.34777243130925, 218, 45, 'PPL', 'P'),
(143163, 'Table Rock', 40.1783294677734, 0.701244137163707, -96.0963897705078, -1.67719840077516, 218, 35, 'PPL', 'P'),
(201634, 'Table Rock', 42.4513893127441, 0.740916515553318, -122.911666870117, -2.14521327599798, 218, 43, 'PPL', 'P'),
(209772, 'Table Rock', 41.6141700744629, 0.726304283284271, -108.387222290039, -1.89171389605217, 218, 59, 'PPL', 'P'),
(77396, 'Tabler', 35.0441703796387, 0.611636156754566, -97.8194427490234, -1.70727134843655, 218, 42, 'PPL', 'P'),
(111647, 'Tablers Station', 39.398609161377, 0.68763545057243, -78.0111083984375, -1.36155069468293, 218, 58, 'PPL', 'P'),
(38474, 'Tablow', 37.8647193908691, 0.660864023714408, -85.0141677856445, -1.48377713870239, 218, 21, 'PPL', 'P'),
(275, 'Tabor', 34.1513900756836, 0.596054200953594, -85.9180603027344, -1.49955303920975, 218, 2, 'PPL', 'P'),
(34111, 'Tabor', 39.8569412231445, 0.695634854117728, -97.5166702270508, -1.70198697104356, 218, 20, 'PPL', 'P'),
(77398, 'Tabor', 35.8016700744629, 0.624857020512101, -96.2633285522461, -1.68011203216576, 218, 42, 'PPL', 'P'),
(83954, 'Tabor', 34.5938911437988, 0.603777301535797, -83.1413879394531, -1.45109096422136, 218, 48, 'PPL', 'P'),
(91206, 'Tabor', 36.0222206115723, 0.628706353551701, -85.0430603027344, -1.4842814082548, 218, 50, 'PPL', 'P'),
(98411, 'Tabor', 30.795560836792, 0.53748393160024, -96.3708267211914, -1.68198822915372, 218, 51, 'PPL', 'P'),
(117990, 'Tabor', 40.8983306884766, 0.713810529083355, -95.6711120605469, -1.669775904501, 218, 16, 'PPL', 'P'),
(121656, 'Tabor', 40.1805610656738, 0.70128308589465, -89.1347198486328, -1.55569433920138, 218, 18, 'PPL', 'P'),
(138386, 'Tabor', 48.0791702270508, 0.839139822088866, -96.8625030517578, -1.69056959997623, 218, 28, 'PPL', 'P'),
(146434, 'Tabor', 40.8711090087891, 0.713335421144885, -74.4802780151367, -1.29992607916488, 218, 37, 'PPL', 'P'),
(157895, 'Tabor', 40.5530586242676, 0.707784394747751, -81.1527786254883, -1.41638318415685, 218, 41, 'PPL', 'P'),
(167843, 'Tabor', 40.0386085510254, 0.698805547132549, -75.1425018310547, -1.31148406513777, 218, 45, 'PPL', 'P'),
(171409, 'Tabor', 42.9486083984375, 0.749594625702423, -97.6586074829102, -1.70446424348955, 218, 49, 'PPL', 'P'),
(176641, 'Tabor', 42.815559387207, 0.747272482389928, -87.8349990844727, -1.53300993251025, 218, 57, 'PPL', 'P'),
(194446, 'Tabor', 40.0513916015625, 0.69902865345287, -105.073608398438, -1.8338804235039, 218, 7, 'PPL', 'P'),
(91205, 'Tabor (historical)', 35.7227783203125, 0.623480099649503, -84.6350021362305, -1.47715944970966, 218, 50, 'PPL', 'P'),
(69297, 'Tabor City', 34.148609161377, 0.596005664842727, -78.8769378662109, -1.37666226965637, 218, 33, 'PPL', 'P'),
(25307, 'Tabor Estates', 33.9397201538086, 0.592359863889436, -84.7727813720703, -1.47956415101594, 218, 13, 'PPL', 'P'),
(106790, 'Tabors', 37.2572212219238, 0.650261180466476, -81.3783264160156, -1.42031973572215, 218, 53, 'PPL', 'P'),
(153049, 'Taborton', 42.646110534668, 0.744315041999395, -73.4855575561523, -1.28256493201866, 218, 40, 'PPL', 'P'),
(157896, 'Taborville', 41.3616714477539, 0.721897350891435, -81.2955627441406, -1.41887523714689, 218, 41, 'PPL', 'P'),
(106791, 'Tabscott', 37.8613891601563, 0.660805900223617, -78.0644378662109, -1.36248146948392, 218, 53, 'PPL', 'P'),
(106792, 'Tabscott East', 37.8558311462402, 0.660708894580911, -78.0672225952148, -1.36253007217381, 218, 53, 'PPL', 'P'),
(91207, 'Tackett Creek', 36.538890838623, 0.637723950160764, -84.008056640625, -1.46621718658079, 218, 50, 'PPL', 'P'),
(38475, 'Tacketts Mill', 38.3672218322754, 0.669634345816257, -84.7897186279297, -1.47985976189694, 218, 21, 'PPL', 'P'),
(106793, 'Tacketts Mill', 38.5061111450195, 0.672058421619475, -77.5641708374023, -1.35375016269204, 218, 53, 'PPL', 'P'),
(57824, 'Tackner', 38.2358283996582, 0.66734109780159, -93.4297180175781, -1.63065619861661, 218, 29, 'PPL', 'P'),
(38476, 'Tacky Town', 36.8505592346191, 0.643163589845306, -83.4752807617188, -1.45691849331867, 218, 21, 'PPL', 'P'),
(179300, 'Tacna', 32.6974983215332, 0.570679002876074, -113.952781677246, -1.98885123207421, 218, 5, 'PPL', 'P'),
(6210, 'Tacoa', 33.3019409179688, 0.581228516323178, -86.8541717529297, -1.51589126618128, 218, 2, 'PPL', 'P'),
(18269, 'Tacoma', 29.5277805328369, 0.51535699110429, -82.3191680908203, -1.43674052068747, 218, 12, 'PPL', 'P'),
(74508, 'Tacoma', 39.9972190856934, 0.698083164686865, -81.1466674804688, -1.41627652455519, 218, 41, 'PPL', 'P'),
(106794, 'Tacoma', 36.9377784729004, 0.644685852724395, -82.5341720581055, -1.44049304782145, 218, 53, 'PPL', 'P'),
(129047, 'Tacoma', 44.1922187805176, 0.771299721481705, -69.9697189331055, -1.2212019720777, 218, 26, 'PPL', 'P'),
(153050, 'Tacoma', 42.235279083252, 0.737144680501439, -75.2802810668945, -1.31388876644406, 218, 40, 'PPL', 'P'),
(187426, 'Tacoma', 37.523609161377, 0.654910527097536, -107.781387329102, -1.88114008126012, 218, 7, 'PPL', 'P'),
(208906, 'Tacoma', 47.253059387207, 0.824721467947177, -122.443061828613, -2.13703457513229, 218, 56, 'PPL', 'P'),
(208907, 'Tacoma Junction', 47.2408294677734, 0.824508015585807, -122.393333435059, -2.13616665093303, 218, 56, 'PPL', 'P'),
(171413, 'Tacoma Park', 45.5430603027344, 0.79487635371704, -98.2466735839844, -1.71472793317267, 218, 49, 'PPL', 'P'),
(6211, 'Tacon', 30.687780380249, 0.535602807764263, -88.1047210693359, -1.53771746921113, 218, 2, 'PPL', 'P'),
(43279, 'Taconey', 31.5752792358398, 0.551092584902004, -91.4680633544922, -1.59641886595866, 218, 22, 'PPL', 'P'),
(114148, 'Taconic', 42.0355606079102, 0.733658935529661, -73.408332824707, -1.28121710619097, 218, 8, 'PPL', 'P'),
(138388, 'Taconite', 47.3127784729004, 0.825763762618807, -93.3819427490234, -1.6298223628793, 218, 28, 'PPL', 'P'),
(138389, 'Taconite Harbor', 47.5224990844727, 0.829424077800039, -90.9286117553711, -1.58700365939885, 218, 28, 'PPL', 'P'),
(167844, 'Tacony', 40.0311088562012, 0.698674652764972, -75.0447235107422, -1.30977751151125, 218, 45, 'PPL', 'P'),
(98412, 'Tacubaya', 26.9197196960449, 0.469837742409951, -98.274169921875, -1.7152078348011, 218, 51, 'PPL', 'P'),
(111649, 'Tacy', 39.1619415283203, 0.68350482114269, -79.9422225952148, -1.39525499564871, 218, 58, 'PPL', 'P'),
(111650, 'Tad', 38.3333282470703, 0.669042791159123, -81.4944381713867, -1.42234626815365, 218, 58, 'PPL', 'P'),
(206022, 'Tad Park', 40.5, 0.706858347057703, -112.338333129883, -1.96067378931868, 218, 52, 'PPL', 'P'),
(98413, 'Tadmor', 31.4288902282715, 0.54853761473121, -95.1755599975586, -1.6611268893868, 218, 51, 'PPL', 'P'),
(167846, 'Tadmor', 40.7297210693359, 0.710867736078818, -75.3580627441406, -1.31524631280973, 218, 45, 'PPL', 'P'),
(74509, 'Tadmor (historical)', 39.8958282470703, 0.696313560721535, -84.165283203125, -1.46896130776801, 218, 41, 'PPL', 'P'),
(176642, 'Taegesville', 45.0466690063477, 0.786212691216849, -89.7263870239258, -1.56602087948622, 218, 57, 'PPL', 'P'),
(133349, 'Taffeltown', 44.5405616760254, 0.777379451934247, -85.1750030517578, -1.48658424364939, 218, 27, 'PPL', 'P'),
(38477, 'Taffy', 37.5538902282715, 0.655439031415862, -86.8916702270508, -1.51654573801916, 218, 21, 'PPL', 'P'),
(189623, 'Tafoya (historical)', 36.4458312988281, 0.636099754790952, -104.060829162598, -1.81620409124266, 218, 38, 'PPL', 'P'),
(6212, 'Taft', 34.3422203063965, 0.599384816791875, -85.6272201538086, -1.49447692101401, 218, 2, 'PPL', 'P'),
(18270, 'Taft', 28.4294395446777, 0.496187324551304, -81.3652801513672, -1.42009203544895, 218, 12, 'PPL', 'P'),
(38479, 'Taft', 37.3613891601563, 0.652079253963646, -83.6866683959961, -1.46060790353481, 218, 21, 'PPL', 'P'),
(43280, 'Taft', 29.9911098480225, 0.523443613175288, -90.4480590820313, -1.57861643301981, 218, 22, 'PPL', 'P'),
(57825, 'Taft', 36.6349983215332, 0.639401342173351, -90.5377807617188, -1.58018237174077, 218, 29, 'PPL', 'P'),
(77399, 'Taft', 35.7616691589355, 0.624158872832337, -95.5461120605469, -1.66759424293601, 218, 42, 'PPL', 'P'),
(83955, 'Taft', 33.5008316040039, 0.584699813646041, -79.7825012207031, -1.39246733177766, 218, 48, 'PPL', 'P'),
(91208, 'Taft', 35.0205612182617, 0.611224099154904, -86.7180633544922, -1.51351572648893, 218, 50, 'PPL', 'P'),
(98414, 'Taft', 27.978609085083, 0.488318848663097, -97.3983306884766, -1.69992155646015, 218, 51, 'PPL', 'P'),
(106795, 'Taft', 37.6327781677246, 0.656815885699433, -76.3916702270508, -1.33328616655976, 218, 53, 'PPL', 'P'),
(138390, 'Taft', 46.9944381713867, 0.820207676215602, -92.3324966430664, -1.61150607300812, 218, 28, 'PPL', 'P'),
(140950, 'Taft', 47.4563903808594, 0.828270263257762, -97.0697174072266, -1.69418617273656, 218, 34, 'PPL', 'P'),
(185526, 'Taft', 35.1425018310547, 0.61335236434004, -119.455558776855, -2.08489281046574, 218, 6, 'PPL', 'P'),
(209881, 'Taft', 47.4191703796387, 0.827620651688864, -115.597221374512, -2.01755211914199, 218, 31, 'PPL', 'P'),
(190813, 'Taft (historical)', 39.3325004577637, 0.686481636030153, -114.486106872559, -1.99815951271626, 218, 39, 'PPL', 'P'),
(185527, 'Taft Heights', 35.1347198486328, 0.613216543124446, -119.471672058105, -2.08517404027685, 218, 6, 'PPL', 'P'),
(98415, 'Taft Southwest', 27.9736995697021, 0.488233161455023, -97.4026412963867, -1.69999679076095, 218, 51, 'PPL', 'P'),
(12254, 'Tafton', 34.6194381713867, 0.604223181281303, -92.2211074829102, -1.60956196541236, 218, 4, 'PPL', 'P'),
(167845, 'Tafton', 41.4044418334961, 0.722643834944985, -75.1833267211914, -1.31219659388742, 218, 45, 'PPL', 'P'),
(126311, 'Tafts Corner', 42.2563896179199, 0.737513128838251, -71.9599990844727, -1.25593891375615, 218, 23, 'PPL', 'P'),
(172627, 'Tafts Corner', 44.4497184753418, 0.775793938979268, -73.1108322143555, -1.27602474101364, 218, 55, 'PPL', 'P'),
(172628, 'Taftsville', 43.6305618286133, 0.76149695840426, -72.4694366455078, -1.26483027652955, 218, 55, 'PPL', 'P'),
(114149, 'Taftville', 41.5697212219238, 0.725528504458731, -72.0477828979492, -1.25747103033128, 218, 8, 'PPL', 'P'),
(348, 'Tag', 35.5313911437988, 0.620139763273243, -93.041389465332, -1.62387858680041, 218, 4, 'PPL', 'P'),
(77401, 'Tagg Flats', 36.339168548584, 0.634238138609959, -94.9252777099609, -1.6567586394088, 218, 42, 'PPL', 'P'),
(31284, 'Taggart', 39.2616691589355, 0.685245396652138, -86.1388931274414, -1.50340729909737, 218, 19, 'PPL', 'P'),
(106796, 'Taggart', 37.7227783203125, 0.658386684689389, -78.4216690063477, -1.36871632906996, 218, 53, 'PPL', 'P'),
(31283, 'Taggart Crossing', 39.3791694641113, 0.687296163849554, -86.4005584716797, -1.50797422089269, 218, 19, 'PPL', 'P'),
(206023, 'Taggarts', 41.0597190856934, 0.716627287989305, -111.591110229492, -1.94763228946056, 218, 52, 'PPL', 'P'),
(153051, 'Taghkanic', 42.142219543457, 0.735520485131627, -73.6777801513672, -1.28591984920188, 218, 40, 'PPL', 'P'),
(98416, 'Tagle Colonia Number 1', 26.2110004425049, 0.457468257963401, -98.1740036010742, -1.71345960270351, 218, 51, 'PPL', 'P'),
(111651, 'Tague', 38.7016716003418, 0.675471595451547, -80.9155578613281, -1.41224290076816, 218, 58, 'PPL', 'P'),
(185529, 'Tagus', 36.2713890075684, 0.633055162453746, -119.367218017578, -2.08335097335264, 218, 6, 'PPL', 'P'),
(198984, 'Tagus', 48.3463897705078, 0.843803682947867, -101.933609008789, -1.77907709564392, 218, 34, 'PPL', 'P'),
(126312, 'Tahanto Beach', 41.7000007629395, 0.727802311397441, -70.6208267211914, -1.23256594676518, 218, 23, 'PPL', 'P'),
(153053, 'Tahawus', 44.0505599975586, 0.768827309304703, -74.0513916015625, -1.29244059913094, 218, 40, 'PPL', 'P'),
(179301, 'Tahchee', 36.2286109924316, 0.632308545242143, -109.893890380859, -1.91801021497172, 218, 5, 'PPL', 'P'),
(77400, 'Tahlequah', 35.9152793884277, 0.626839877101719, -94.9697189331055, -1.65753428507629, 218, 42, 'PPL', 'P'),
(208908, 'Tahlequah', 47.3327789306641, 0.826112836458689, -122.50611114502, -2.13813499329471, 218, 56, 'PPL', 'P'),
(83956, 'Taho (historical)', 35.0569381713867, 0.611858996758778, -82.3152770996094, -1.43667261007967, 218, 48, 'PPL', 'P'),
(195687, 'Tahoe', 46.0963897705078, 0.804533774777995, -115.806106567383, -2.02119785351626, 218, 17, 'PPL', 'P'),
(185540, 'Tahoe City', 39.1722183227539, 0.683684185042106, -120.13777923584, -2.09679980369948, 218, 6, 'PPL', 'P'),
(185530, 'Tahoe Estates', 39.2441711425781, 0.684939998654133, -120.055557250977, -2.09536475934609, 218, 6, 'PPL', 'P'),
(185532, 'Tahoe Marina Estates', 39.2408294677734, 0.684881675426261, -120.060829162598, -2.09545677156176, 218, 6, 'PPL', 'P'),
(185533, 'Tahoe Park', 39.142219543457, 0.683160607571797, -120.156936645508, -2.09713416357434, 218, 6, 'PPL', 'P'),
(185534, 'Tahoe Pines', 39.1047210693359, 0.68250613573391, -120.159172058105, -2.09717317888431, 218, 6, 'PPL', 'P'),
(185535, 'Tahoe Valley', 38.9136085510254, 0.679170593047613, -120.003326416016, -2.09445315930496, 218, 6, 'PPL', 'P'),
(190815, 'Tahoe Village', 38.9702796936035, 0.680159691076468, -119.934997558594, -2.09326059576882, 218, 39, 'PPL', 'P'),
(185536, 'Tahoe Vista', 39.2400016784668, 0.684867227777347, -120.050003051758, -2.09526782028241, 218, 6, 'PPL', 'P'),
(185537, 'Tahoe Woods', 39.149169921875, 0.68328191455945, -120.15055847168, -2.09702284344078, 218, 6, 'PPL', 'P'),
(192301, 'Tahoka', 33.1666717529297, 0.578867624016822, -101.793327331543, -1.77662871849576, 218, 51, 'PPL', 'P'),
(208910, 'Taholah', 47.3474998474121, 0.826369764924854, -124.291938781738, -2.16930356542856, 218, 56, 'PPL', 'P'),
(25308, 'Tahoma', 33.3097190856934, 0.581364270959744, -81.9280624389648, -1.42991443933943, 218, 13, 'PPL', 'P'),
(185538, 'Tahoma', 39.0675010681152, 0.681856524165012, -120.127220153809, -2.09661551295205, 218, 6, 'PPL', 'P'),
(208909, 'Tahoma', 47.3883285522461, 0.827082360253532, -122.010276794434, -2.1294810513325, 218, 56, 'PPL', 'P'),
(185539, 'Tahoma Meadows', 39.0652809143066, 0.681817775171152, -120.146942138672, -2.09695972652294, 218, 6, 'PPL', 'P'),
(77402, 'Tahona', 35.1613883972168, 0.613681997103965, -94.6030578613281, -1.65113484213488, 218, 42, 'PPL', 'P'),
(208911, 'Tahuya', 47.3713912963867, 0.826786749372533, -123.054443359375, -2.14770519582997, 218, 56, 'PPL', 'P'),
(189624, 'Taiban', 34.439998626709, 0.601091370418397, -104.008613586426, -1.81529275751764, 218, 38, 'PPL', 'P'),
(77403, 'Tailholt', 35.836669921875, 0.625467883087138, -94.8419418334961, -1.65530415397945, 218, 42, 'PPL', 'P'),
(25309, 'Tails Creek', 34.6897201538086, 0.605449833279394, -84.6155624389648, -1.47682016298678, 218, 13, 'PPL', 'P'),
(51917, 'Tailwinds Estates', 39.6813888549805, 0.692570887283592, -75.9669418334961, -1.32587325766552, 218, 25, 'PPL', 'P'),
(129048, 'Tainter Corner', 44.5875015258789, 0.778198706864583, -70.3658294677734, -1.2281154051095, 218, 26, 'PPL', 'P'),
(176646, 'Tainter Lake', 44.9891700744629, 0.78520914553908, -91.8475036621094, -1.60304134864136, 218, 57, 'PPL', 'P'),
(117993, 'Taintor', 41.5011100769043, 0.724331014074577, -92.7383270263672, -1.61858914940135, 218, 16, 'PPL', 'P'),
(167847, 'Taintor', 41.8061103820801, 0.729654273619482, -78.666389465332, -1.37298750682623, 218, 45, 'PPL', 'P'),
(185541, 'Taison (historical)', 38.2041702270508, 0.666788558454426, -121.408332824707, -2.11897514714825, 218, 6, 'PPL', 'P'),
(167848, 'Tait', 41.0911102294922, 0.717175166804561, -79.0494384765625, -1.37967297326871, 218, 45, 'PPL', 'P'),
(98417, 'Taiton', 29.309289932251, 0.511543610739405, -96.3421630859375, -1.68148795434295, 218, 51, 'PPL', 'P'),
(6213, 'Taits Gap', 33.9647216796875, 0.592796222834046, -86.3994369506836, -1.50795464665868, 218, 2, 'PPL', 'P'),
(57826, 'Taitsville', 39.4844398498535, 0.689133478685599, -93.9577789306641, -1.63987260020104, 218, 29, 'PPL', 'P'),
(185543, 'Tajiguas', 34.4666709899902, 0.601556890976943, -120.107498168945, -2.09627129938116, 218, 6, 'PPL', 'P'),
(189625, 'Tajique', 34.7516708374023, 0.606531076681966, -106.287216186523, -1.85506187523385, 218, 38, 'PPL', 'P'),
(189626, 'Tajo (historical)', 34.0430603027344, 0.594163489737692, -106.85221862793, -1.86492302811819, 218, 38, 'PPL', 'P'),
(201636, 'Takilma', 42.0516700744629, 0.733940098761746, -123.61833190918, -2.15754690763835, 218, 43, 'PPL', 'P'),
(167849, 'Takitezy', 41.413330078125, 0.722798964078482, -79.9197235107422, -1.39486231254597, 218, 45, 'PPL', 'P'),
(51918, 'Takoma Park', 38.9777793884277, 0.680290585444046, -77.0077819824219, -1.34403934525123, 218, 25, 'PPL', 'P'),
(212176, 'Takotna', 62.9886093139648, 1.09935862378105, -156.064163208008, -2.72383349234953, 218, 1, 'PPL', 'P'),
(212177, 'Takshak', 61.9577789306641, 1.08136723956286, -162.176940917969, -2.83052158983087, 218, 1, 'PPL', 'P'),
(18271, 'Tala Apopka (historical)', 28.4666690826416, 0.49683710256777, -81.1833267211914, -1.41691634900708, 218, 12, 'PPL', 'P'),
(195688, 'Talache', 48.1408309936523, 0.840216005485367, -116.484169006348, -2.0330322756103, 218, 17, 'PPL', 'P'),
(195689, 'Talache Landing', 48.1286087036133, 0.840002686282051, -116.477783203125, -2.03292082231868, 218, 17, 'PPL', 'P'),
(77404, 'Talala', 36.5297203063965, 0.637563894179251, -95.7011108398438, -1.67029948197131, 218, 42, 'PPL', 'P'),
(190816, 'Talapoosa', 39.4541702270508, 0.688605174104355, -119.275001525879, -2.08174149194785, 218, 39, 'PPL', 'P'),
(25310, 'Talasee (historical)', 34.017219543457, 0.593712483407087, -83.5111083984375, -1.45754380354262, 218, 13, 'PPL', 'P'),
(6214, 'Talasse (historical)', 32.4819412231445, 0.566916821783146, -85.8555603027344, -1.49846220842725, 218, 2, 'PPL', 'P'),
(83957, 'Talatha', 33.3950004577637, 0.58285271169299, -81.704719543457, -1.42601637045188, 218, 48, 'PPL', 'P'),
(83958, 'Talatha Farms', 33.4819412231445, 0.584370114303089, -81.6836090087891, -1.42564792211507, 218, 48, 'PPL', 'P'),
(74510, 'Talawanda Springs', 39.5788917541504, 0.690781975400358, -84.8038864135742, -1.48010703640416, 218, 41, 'PPL', 'P'),
(38478, 'Talbert', 37.4213905334473, 0.653126475483292, -83.458610534668, -1.45662754296958, 218, 21, 'PPL', 'P'),
(185544, 'Talbert', 33.7013893127441, 0.588200206003814, -117.962219238281, -2.05882911866741, 218, 6, 'PPL', 'P'),
(51919, 'Talbert (historical)', 38.7291717529297, 0.675951563659007, -76.8277816772461, -1.34089774727132, 218, 25, 'PPL', 'P'),
(98419, 'Talbert Crossing', 34.3494415283203, 0.599510850890463, -99.7802810668945, -1.74149443318267, 218, 51, 'PPL', 'P'),
(123775, 'Talbot', 40.5052795410156, 0.70695049243142, -87.4541702270508, -1.52636321506163, 218, 19, 'PPL', 'P'),
(133350, 'Talbot', 45.5105590820313, 0.794309100404853, -87.5975036621094, -1.5288648554316, 218, 27, 'PPL', 'P'),
(201637, 'Talbot', 44.7611083984375, 0.78122871839482, -123.095001220703, -2.14841306404771, 218, 43, 'PPL', 'P'),
(185545, 'Talbot (historical)', 37.0736083984375, 0.647056532147756, -120.030830383301, -2.09493319409145, 218, 6, 'PPL', 'P'),
(12255, 'Talbot Addition', 34.9644393920898, 0.610244588505972, -91.9963912963867, -1.605639928075, 218, 4, 'PPL', 'P'),
(43281, 'Talbot Landing', 32.0888900756836, 0.560056785131211, -91.5605621337891, -1.59803327421146, 218, 22, 'PPL', 'P'),
(51921, 'Talbot Mobile Home Park', 38.8097190856934, 0.677357379819432, -76.0538864135742, -1.32739072685465, 218, 25, 'PPL', 'P'),
(106798, 'Talbot Park', 36.9036102294922, 0.644089504377299, -76.2797164916992, -1.33133220526797, 218, 53, 'PPL', 'P'),
(91209, 'Talbott', 36.1525001525879, 0.630980160490411, -83.415283203125, -1.45587133837805, 218, 50, 'PPL', 'P'),
(111653, 'Talbott', 38.9769401550293, 0.68027593805805, -80.0136108398438, -1.3965009555647, 218, 58, 'PPL', 'P'),
(121657, 'Talbott', 40.5102806091309, 0.707037777536148, -89.7844390869141, -1.56703407912294, 218, 18, 'PPL', 'P'),
(51923, 'Talbott Springs', 39.2125015258789, 0.684387259569887, -76.8477783203125, -1.34124675453217, 218, 25, 'PPL', 'P'),
(25312, 'Talbotton', 32.6775016784668, 0.570329995615219, -84.539436340332, -1.47549151191894, 218, 13, 'PPL', 'P'),
(51924, 'Talbotts Choice', 39.4536094665527, 0.688595386987349, -76.6305618286133, -1.33745561156239, 218, 25, 'PPL', 'P'),
(197673, 'Talc', 47.7202796936035, 0.832876000625972, -115.434440612793, -2.0147110588911, 218, 31, 'PPL', 'P'),
(185546, 'Talc (historical)', 35.4777793884277, 0.619204061624244, -116.123611450195, -2.0267393591125, 218, 6, 'PPL', 'P'),
(69298, 'Talc Mountain', 35.3136100769043, 0.616338766607428, -83.64111328125, -1.45981281679137, 218, 33, 'PPL', 'P'),
(98418, 'Talco', 33.3624992370605, 0.582285458380803, -95.1044387817383, -1.65988559000272, 218, 51, 'PPL', 'P'),
(79253, 'Talcose', 39.9869384765625, 0.697903734208421, -75.6661071777344, -1.32062270241838, 218, 45, 'PPL', 'P'),
(111652, 'Talcott', 37.6513900756836, 0.657140724773396, -80.7544403076172, -1.40943086897314, 218, 58, 'PPL', 'P'),
(114150, 'Talcottville', 41.8186111450195, 0.729872453091787, -72.501106262207, -1.26538301561379, 218, 8, 'PPL', 'P'),
(153054, 'Talcottville', 43.5333290100098, 0.759799925578634, -75.3655624389648, -1.3153772071773, 218, 40, 'PPL', 'P'),
(153055, 'Talcville', 44.3097190856934, 0.773350488679121, -75.3063888549805, -1.31434443330657, 218, 40, 'PPL', 'P'),
(172629, 'Talcville', 43.8586082458496, 0.76547711923241, -72.8058319091797, -1.27070148146873, 218, 55, 'PPL', 'P'),
(201638, 'Talent', 42.2458305358887, 0.737328838090818, -122.787498474121, -2.14304612866093, 218, 43, 'PPL', 'P'),
(25313, 'Taliaferro (historical)', 34.3788909912109, 0.600024840980848, -85.3938903808594, -1.49040454823311, 218, 13, 'PPL', 'P'),
(185547, 'Talich', 33.2000007629395, 0.579449324977923, -117.316673278809, -2.04756221620166, 218, 6, 'PPL', 'P'),
(179302, 'Taliesin West', 33.6069412231445, 0.586551775868082, -111.842498779297, -1.95201984735647, 218, 5, 'PPL', 'P'),
(77406, 'Talihina', 34.7513885498047, 0.606526149833949, -95.0477828979492, -1.65889675828997, 218, 42, 'PPL', 'P'),
(43282, 'Talisheek', 30.5324993133545, 0.532892641880944, -89.8766708374023, -1.56864382684384, 218, 22, 'PPL', 'P'),
(18272, 'Talisman', 28.4819393157959, 0.497103618413859, -82.1727828979492, -1.4341856170957, 218, 12, 'PPL', 'P'),
(179303, 'Taliverde', 33.5180587768555, 0.585000484533111, -112.027778625488, -1.9552535907101, 218, 5, 'PPL', 'P'),
(212178, 'Talkeetna', 62.3238906860352, 1.08775709512434, -150.109436035156, -2.6199038971253, 218, 1, 'PPL', 'P'),
(106799, 'Talking Leaves', 37.288330078125, 0.650804132433716, -80.1569366455078, -1.39900246277661, 218, 53, 'PPL', 'P'),
(25316, 'Talking Rock', 34.5091705322266, 0.602298647919557, -84.504997253418, -1.47489043646091, 218, 13, 'PPL', 'P'),
(51925, 'Tall Oak Manor', 39.5166702270508, 0.689696004886851, -76.4400024414063, -1.33412972283504, 218, 25, 'PPL', 'P'),
(51926, 'Tall Oaks', 38.7508316040039, 0.676329599375744, -76.6022186279297, -1.33696092938991, 218, 25, 'PPL', 'P'),
(193236, 'Tall Oaks', 40.6386108398438, 0.709277562591931, -111.838607788086, -1.95195193674867, 218, 52, 'PPL', 'P'),
(83960, 'Tall PInes', 33.0099983215332, 0.576133156788556, -80.1055603027344, -1.39810577643758, 218, 48, 'PPL', 'P'),
(51927, 'Tall Pines Trailer Park', 39.1372184753418, 0.68307332246707, -76.7527770996094, -1.33958867043749, 218, 25, 'PPL', 'P'),
(194447, 'Tall Timber', 40.0144386291504, 0.698383702415881, -105.351112365723, -1.83872378142037, 218, 7, 'PPL', 'P'),
(185548, 'Tall Timber Camp', 38.0736083984375, 0.664509824667699, -120.17138671875, -2.09738636492957, 218, 6, 'PPL', 'P'),
(43283, 'Tall Timbers', 32.5611114501953, 0.568298602914734, -93.5794372558594, -1.63326929227819, 218, 22, 'PPL', 'P'),
(51929, 'Tall Timbers', 38.1688919067383, 0.666172835610399, -76.545280456543, -1.33596717082914, 218, 25, 'PPL', 'P'),
(123776, 'Tall Timbers', 41.5505599975586, 0.725194078004844, -85.2341690063477, -1.48761688436207, 218, 19, 'PPL', 'P'),
(51930, 'Tall Timbers Estates', 39.0705604553223, 0.681909920544868, -76.0116729736328, -1.32665396333908, 218, 25, 'PPL', 'P'),
(106800, 'Tall Trees Estates', 38.6891708374023, 0.675253415979243, -77.482780456543, -1.35232963256659, 218, 53, 'PPL', 'P'),
(43285, 'Talla Bena', 32.4916687011719, 0.567086598302639, -91.1533279418945, -1.59092569673621, 218, 22, 'PPL', 'P'),
(6215, 'Talladega', 33.4358291625977, 0.583565307021668, -86.105827331543, -1.50283019208915, 218, 2, 'PPL', 'P'),
(6217, 'Talladega Springs', 33.1213912963867, 0.578077330963341, -86.4433288574219, -1.50872070494624, 218, 2, 'PPL', 'P'),
(61960, 'Tallahala', 31.3863906860352, 0.547795857788595, -89.1230621337891, -1.5554908736941, 218, 30, 'PPL', 'P'),
(18273, 'Tallahasse - Yuchi (historical)', 29.0666694641113, 0.507309084737638, -81.3666687011719, -1.42011627021487, 218, 12, 'PPL', 'P'),
(18274, 'Tallahassee', 30.438060760498, 0.53124437819278, -84.2808303833008, -1.47097798650347, 218, 12, 'PPL', 'P'),
(25317, 'Tallahassee', 31.9188899993896, 0.55708972407124, -82.5691680908203, -1.44110384381745, 218, 13, 'PPL', 'P'),
(6222, 'Tallahatta Springs', 31.9094390869141, 0.556924774531223, -87.8766708374023, -1.53373724180395, 218, 2, 'PPL', 'P'),
(61962, 'Tallahoma (historical)', 32.1230583190918, 0.560653133478307, -89.1205596923828, -1.55544719785222, 218, 30, 'PPL', 'P'),
(61963, 'Tallahomo', 31.5324993133545, 0.550345934400887, -89.0755615234375, -1.55466183164676, 218, 30, 'PPL', 'P'),
(77410, 'Tallant', 36.5974998474121, 0.638746870335464, -96.1902770996094, -1.67883704379389, 218, 42, 'PPL', 'P'),
(25320, 'Tallapoosa', 33.7444381713867, 0.588951550326353, -85.2880630493164, -1.48855751285909, 218, 13, 'PPL', 'P'),
(57827, 'Tallapoosa', 36.5080604553223, 0.637185858462514, -89.8191680908203, -1.56764021458704, 218, 29, 'PPL', 'P'),
(6218, 'Tallapoosa City', 32.5513916015625, 0.568128959553296, -85.8486099243164, -1.4983409014396, 218, 2, 'PPL', 'P'),
(6220, 'Tallaseehatchee', 33.2666702270508, 0.580612926637206, -86.2416687011719, -1.50520107124959, 218, 2, 'PPL', 'P'),
(6221, 'Tallaseehatchee (historical)', 33.7822189331055, 0.589610949012256, -85.9091720581055, -1.49939791007625, 218, 2, 'PPL', 'P'),
(6223, 'Tallassee', 32.535831451416, 0.567857383701135, -85.8933334350586, -1.4991214739551, 218, 2, 'PPL', 'P'),
(91210, 'Tallassee', 35.5466690063477, 0.620406412277388, -84.0599975585938, -1.46712372661586, 218, 50, 'PPL', 'P'),
(25318, 'Tallassee Estates', 33.9874992370605, 0.593193766205767, -83.4763870239258, -1.45693780123658, 218, 13, 'PPL', 'P'),
(25319, 'Tallassee Farms', 33.9780616760254, 0.593029049692346, -83.4649963378906, -1.4567389962612, 218, 13, 'PPL', 'P'),
(38480, 'Tallega', 37.5602798461914, 0.655550551286509, -83.5902786254883, -1.45892558467421, 218, 21, 'PPL', 'P'),
(57828, 'Tallent', 37.4652786254883, 0.653892467191826, -90.0683288574219, -1.57198889033103, 218, 29, 'PPL', 'P'),
(106801, 'Tallent Town', 38.0130615234375, 0.663453082347156, -76.7697219848633, -1.33988441447654, 218, 53, 'PPL', 'P'),
(153056, 'Tallette', 42.7400016784668, 0.745953751597148, -75.333610534668, -1.31481954124504, 218, 40, 'PPL', 'P'),
(112263, 'Tallevast', 27.4013900756836, 0.478244476443977, -82.5430603027344, -1.44064817695494, 218, 12, 'PPL', 'P'),
(12258, 'Talley', 33.1622200012207, 0.578789926292019, -93.0736083984375, -1.62444091326458, 218, 4, 'PPL', 'P'),
(38481, 'Talley', 37.4505615234375, 0.653635605304688, -85.8438873291016, -1.49825847660386, 218, 21, 'PPL', 'P'),
(91211, 'Talley', 35.3563919067383, 0.617085450398059, -86.6833267211914, -1.51290945786677, 218, 50, 'PPL', 'P'),
(192302, 'Talley', 28.983060836792, 0.505849838907843, -103.183609008789, -1.80089371129385, 218, 51, 'PPL', 'P'),
(6224, 'Talley (historical)', 34.5194396972656, 0.60247787866092, -85.9813919067383, -1.50065838422019, 218, 2, 'PPL', 'P'),
(14706, 'Talley Brook', 39.8180618286133, 0.694956280671976, -75.533332824707, -1.31830535279585, 218, 10, 'PPL', 'P'),
(167850, 'Talley Cavey', 40.5900001525879, 0.70842914604766, -79.9477767944336, -1.39535193471238, 218, 45, 'PPL', 'P'),
(18275, 'Talleyrand', 30.3594398498535, 0.529872184441117, -81.6327819824219, -1.42476082315597, 218, 12, 'PPL', 'P'),
(117994, 'Talleyrand', 41.2949981689453, 0.720733682653125, -91.9649963378906, -1.60509198268072, 218, 16, 'PPL', 'P'),
(14707, 'Talleys Corner', 39.8080596923828, 0.694781710462521, -75.5158309936523, -1.31799988821881, 218, 10, 'PPL', 'P'),
(69299, 'Talleys Crossing', 36.1341705322266, 0.630660248264465, -80.1180572509766, -1.39832388933086, 218, 33, 'PPL', 'P'),
(14708, 'Talleyville', 39.8088912963867, 0.694796224690462, -75.5491714477539, -1.318581788917, 218, 10, 'PPL', 'P'),
(121660, 'Tallmadge', 41.1113891601563, 0.717529100913433, -87.625, -1.52934475706003, 218, 18, 'PPL', 'P'),
(133351, 'Tallmadge', 42.9925003051758, 0.750360683989984, -85.8341674804688, -1.49808883324243, 218, 27, 'PPL', 'P'),
(157897, 'Tallmadge', 41.101390838623, 0.717354597283006, -81.4419403076172, -1.4214300075806, 218, 41, 'PPL', 'P'),
(133352, 'Tallman', 43.9847183227539, 0.767678155294334, -86.1122207641602, -1.50294177853882, 218, 27, 'PPL', 'P'),
(153057, 'Tallman', 41.1111106872559, 0.717524240644444, -74.1002807617188, -1.2932938759442, 218, 40, 'PPL', 'P'),
(111654, 'Tallmans', 39.2458305358887, 0.684968960530988, -81.6858291625977, -1.42568667110893, 218, 58, 'PPL', 'P'),
(111655, 'Tallmansville', 38.913330078125, 0.679165732778623, -80.1802825927734, -1.39940992642339, 218, 58, 'PPL', 'P'),
(167851, 'Tallmanville', 41.872501373291, 0.730813015009775, -75.4022216796875, -1.3160170316292, 218, 45, 'PPL', 'P'),
(25321, 'Tallokas (historical)', 30.9933300018311, 0.540935654689092, -83.6152801513672, -1.45936194361882, 218, 13, 'PPL', 'P'),
(61964, 'Tallow (historical)', 32.2999992370605, 0.563741335078363, -89.1166687011719, -1.55537928724443, 218, 30, 'PPL', 'P'),
(43286, 'Tallow Wood', 30.5174999237061, 0.532630853145789, -90.4022216796875, -1.57781641942835, 218, 22, 'PPL', 'P'),
(28747, 'Tallula', 39.9444389343262, 0.697161977265807, -89.9372177124023, -1.56970056916438, 218, 18, 'PPL', 'P'),
(61965, 'Tallula', 32.7794418334961, 0.572109186960474, -91.1144409179688, -1.5902469901324, 218, 30, 'PPL', 'P'),
(43287, 'Tallulah', 32.4083290100098, 0.565632046294265, -91.1866683959961, -1.59150759743439, 218, 22, 'PPL', 'P'),
(25322, 'Tallulah Falls', 34.7305603027344, 0.606162628345153, -83.3944396972656, -1.45550755057315, 218, 13, 'PPL', 'P'),
(25323, 'Tallulah Park (historical)', 34.7152786254883, 0.605895912761982, -83.3958282470703, -1.45553178533907, 218, 13, 'PPL', 'P'),
(117995, 'Tallview Terrace Mobile Home Park', 42.523609161377, 0.742176989697253, -96.3569412231445, -1.68174588149452, 218, 16, 'PPL', 'P'),
(129049, 'Tallwood', 44.3433303833008, 0.773937116488238, -69.9555587768555, -1.22095483072855, 218, 26, 'PPL', 'P'),
(111656, 'Tallwood Acres', 38.4219398498535, 0.67058935538316, -82.3213882446289, -1.43677926968133, 218, 58, 'PPL', 'P'),
(106802, 'Tally (historical)', 37.5702781677246, 0.655725054916937, -78.2402801513672, -1.36555049632412, 218, 53, 'PPL', 'P'),
(43288, 'Tally Ho', 30.2052803039551, 0.52718159279181, -91.184440612793, -1.59146871528247, 218, 22, 'PPL', 'P'),
(135, 'Tally Ho Estates', 37.8052787780762, 0.659826589311768, -77.92138671875, -1.35998475596197, 218, 53, 'PPL', 'P'),
(111657, 'Tallyho', 39.2808303833008, 0.685579823106025, -81.4397201538086, -1.42139125858674, 218, 58, 'PPL', 'P'),
(167852, 'Tallyho', 41.7669410705566, 0.728970640167659, -78.7186126708984, -1.37389897370931, 218, 45, 'PPL', 'P'),
(106803, 'Tallysville', 37.5244407653809, 0.654925041325477, -77.0755615234375, -1.34522232140744, 218, 53, 'PPL', 'P'),
(123777, 'Talma', 41.1538887023926, 0.718270857856047, -86.1350021362305, -1.50333938848957, 218, 19, 'PPL', 'P'),
(447, 'Talmadge', 34.4241714477539, 0.600815134034329, -84.5875015258789, -1.47633040766231, 218, 13, 'PPL', 'P'),
(114151, 'Talmadge Hill', 41.1186103820801, 0.717655135012021, -73.4994430541992, -1.28280727967785, 218, 8, 'PPL', 'P'),
(34112, 'Talmage', 39.0250015258789, 0.681114767222398, -97.2602767944336, -1.6975120614639, 218, 20, 'PPL', 'P'),
(38482, 'Talmage', 37.850830078125, 0.660621609476184, -84.8694381713867, -1.48125113040845, 218, 21, 'PPL', 'P'),
(57829, 'Talmage', 37.2577781677246, 0.650270901004455, -92.4127807617188, -1.61290729521567, 218, 29, 'PPL', 'P'),
(112188, 'Talmage', 40, 0.698131700797732, -76.2136077880859, -1.33017839072569, 218, 45, 'PPL', 'P'),
(117996, 'Talmage', 41.0269393920898, 0.716055174408129, -94.1116714477539, -1.64255853131844, 218, 16, 'PPL', 'P'),
(143165, 'Talmage', 40.5305595397949, 0.707391711645019, -96.0213928222656, -1.67588945709939, 218, 35, 'PPL', 'P'),
(185550, 'Talmage', 39.1333312988281, 0.6830054784383, -123.16667175293, -2.14966395081172, 218, 6, 'PPL', 'P'),
(195690, 'Talmage', 42.6788902282715, 0.744887155580572, -111.786666870117, -1.95104539671361, 218, 17, 'PPL', 'P'),
(206024, 'Talmage', 40.3400001525879, 0.704065822917674, -110.426666259766, -1.92730890823384, 218, 52, 'PPL', 'P'),
(57830, 'Talmage City', 37.0119400024414, 0.645980215593201, -94.0905609130859, -1.64219008298163, 218, 29, 'PPL', 'P'),
(167853, 'Talmer', 41.2361106872559, 0.719705902209436, -76.4805603027344, -1.33483759105279, 218, 45, 'PPL', 'P'),
(25325, 'Talmo', 31.313060760498, 0.54651600914773, -82.5691680908203, -1.44110384381745, 218, 13, 'PPL', 'P'),
(34113, 'Talmo', 39.6958312988281, 0.692822955480768, -97.5877838134766, -1.70322813726959, 218, 20, 'PPL', 'P'),
(185551, 'Talmont', 39.1450004577637, 0.683209143682664, -120.165832519531, -2.09728942586589, 218, 6, 'PPL', 'P'),
(138391, 'Talmoon', 47.5999984741211, 0.83077669731769, -93.7736129760742, -1.63665829792337, 218, 28, 'PPL', 'P'),
(77411, 'Taloah', 34.2588882446289, 0.597930397941555, -96.2022171020508, -1.67904543614918, 218, 42, 'PPL', 'P'),
(77412, 'Taloga', 36.0386085510254, 0.628992377052776, -98.9633331298828, -1.72723600186444, 218, 42, 'PPL', 'P'),
(91213, 'Talome (historical)', 35.8486099243164, 0.625676275442437, -86.0277786254883, -1.50146798519157, 218, 50, 'PPL', 'P'),
(25326, 'Talona', 34.5972213745117, 0.603835425026588, -84.5119400024414, -1.47501161029051, 218, 13, 'PPL', 'P'),
(61966, 'Talowah', 31.0758304595947, 0.542375559311471, -89.4302825927734, -1.56085288223287, 218, 30, 'PPL', 'P'),
(98420, 'Talpa', 31.7763900756836, 0.554602631218729, -99.7091674804688, -1.74025326695664, 218, 51, 'PPL', 'P'),
(189628, 'Talpa', 36.3413887023926, 0.63427688760382, -105.596389770508, -1.84300467971462, 218, 38, 'PPL', 'P'),
(106804, 'Talpa (historical)', 37.0247192382813, 0.646203255334495, -77.3550033569336, -1.35009950146976, 218, 53, 'PPL', 'P'),
(98424, 'Talty', 32.6830596923828, 0.570427001257925, -96.3852767944336, -1.68224043050895, 218, 51, 'PPL', 'P'),
(6225, 'Talucah', 34.5561103820801, 0.603117902849893, -86.7008285522461, -1.5132149224438, 218, 2, 'PPL', 'P'),
(185552, 'Talus', 36.0869407653809, 0.629835933328059, -117.971939086914, -2.05899876202884, 218, 6, 'PPL', 'P'),
(192303, 'Tam Anne', 34.5308303833008, 0.602676683636294, -102.518890380859, -1.78929218263714, 218, 51, 'PPL', 'P'),
(43289, 'Tama', 32.3269386291504, 0.564211516168816, -92.2555618286133, -1.6101633071865, 218, 22, 'PPL', 'P'),
(117997, 'Tama', 41.9666709899902, 0.732456584876518, -92.5766677856445, -1.61576766338447, 218, 16, 'PPL', 'P'),
(157899, 'Tama', 40.6330604553223, 0.70918069010728, -84.6188888549805, -1.47687821989854, 218, 41, 'PPL', 'P'),
(18276, 'Tama (historical)', 30.1499996185303, 0.526216762818388, -84.6833267211914, -1.47800287282688, 218, 12, 'PPL', 'P'),
(77414, 'Tamaha', 35.396110534668, 0.617778671229807, -94.9833297729492, -1.65777183904552, 218, 42, 'PPL', 'P'),
(28749, 'Tamalco', 38.7708282470703, 0.676678606636599, -89.291389465332, -1.55842873985062, 218, 18, 'PPL', 'P'),
(185556, 'Tamalpais Valley', 37.8797187805176, 0.661125812449563, -122.544723510742, -2.13880890620856, 218, 6, 'PPL', 'P'),
(185553, 'Tamalpais Valley Junction', 37.8819389343262, 0.661164561443424, -122.523612976074, -2.13844045787174, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(167854, 'Tamanend', 40.8436088562012, 0.712855452937426, -76.0397186279297, -1.32714345234744, 218, 45, 'PPL', 'P'),
(167855, 'Tamaqua', 40.7972183227539, 0.712045785387014, -75.9697189331055, -1.32592172719736, 218, 45, 'PPL', 'P'),
(121661, 'Tamara Heights', 42.0027809143066, 0.733086821948485, -88.4311065673828, -1.54341397078281, 218, 18, 'PPL', 'P'),
(18277, 'Tamarac', 26.2124996185303, 0.457494423521111, -80.25, -1.40062672472545, 218, 12, 'PPL', 'P'),
(25327, 'Tamarack', 33.6819381713867, 0.587860719543856, -84.254997253418, -1.47052711333092, 218, 13, 'PPL', 'P'),
(91214, 'Tamarack', 36.3019409179688, 0.633588393883007, -82.4305572509766, -1.43868462828323, 218, 50, 'PPL', 'P'),
(121662, 'Tamarack', 41.6508293151855, 0.726944107736163, -88.2527770996094, -1.54030153441684, 218, 18, 'PPL', 'P'),
(133355, 'Tamarack', 47.2480583190918, 0.824634182842449, -88.4683303833008, -1.54406364893074, 218, 27, 'PPL', 'P'),
(138393, 'Tamarack', 46.6444396972656, 0.814099050465232, -93.1269378662109, -1.62537168806556, 218, 28, 'PPL', 'P'),
(153058, 'Tamarack', 42.7719383239746, 0.746511151213302, -73.5438919067383, -1.28358305850339, 218, 40, 'PPL', 'P'),
(167857, 'Tamarack', 41.4244384765625, 0.722992842205839, -77.8486099243164, -1.35871456128005, 218, 45, 'PPL', 'P'),
(176645, 'Tamarack', 44.1749992370605, 0.77099918375269, -91.4477767944336, -1.59606479869173, 218, 57, 'PPL', 'P'),
(185554, 'Tamarack', 38.4388885498047, 0.67088516600124, -120.074996948242, -2.09570404606897, 218, 6, 'PPL', 'P'),
(195691, 'Tamarack', 44.9552803039551, 0.784617657460973, -116.384719848633, -2.03129656036984, 218, 17, 'PPL', 'P'),
(185555, 'Tamarack (historical)', 39.3061103820801, 0.686021042319624, -120.491111755371, -2.10296661951967, 218, 6, 'PPL', 'P'),
(123778, 'Tamarack Grange', 41.5961112976074, 0.72598909816926, -86.1377792358398, -1.50338785802141, 218, 19, 'PPL', 'P'),
(74511, 'Tamarack Hills', 39.5691719055176, 0.69061233203892, -84.2472229003906, -1.47039142527338, 218, 41, 'PPL', 'P'),
(185557, 'Tamarack Springs', 38.4402809143066, 0.670909467346187, -120.081939697266, -2.09582521989857, 218, 6, 'PPL', 'P'),
(28751, 'Tamaroa', 38.1377792358398, 0.665629817064132, -89.2300033569336, -1.55735735014408, 218, 18, 'PPL', 'P'),
(83961, 'Tamassee', 34.8802795410156, 0.608775722006739, -83.0197219848633, -1.44896749272619, 218, 48, 'PPL', 'P'),
(18278, 'Tamathli (historical)', 30.7000007629395, 0.535816093678065, -84.9166717529297, -1.48207551192389, 218, 12, 'PPL', 'P'),
(98421, 'Tamberg', 29.9091701507568, 0.522013495669916, -96.7191696166992, -1.68806795960626, 218, 51, 'PPL', 'P'),
(167858, 'Tambine', 41.5297203063965, 0.724830356778967, -78.6791687011719, -1.37321054656752, 218, 45, 'PPL', 'P'),
(185558, 'Tambo', 39.2394409179688, 0.684857440660341, -121.576110839844, -2.12190342592484, 218, 6, 'PPL', 'P'),
(61967, 'Tamburo (historical)', 33.4736099243164, 0.584224705707571, -90.9236068725586, -1.58691630771509, 218, 30, 'PPL', 'P'),
(111660, 'Tamcliff', 37.6383285522461, 0.656912758184085, -81.8766708374023, -1.42901748668429, 218, 58, 'PPL', 'P'),
(25328, 'Tamerlane', 33.3627815246582, 0.582290385228819, -84.538330078125, -1.47547220400104, 218, 13, 'PPL', 'P'),
(190818, 'Tamerlane (historical)', 39.186939239502, 0.683941113508272, -114.764717102051, -2.00302217855063, 218, 39, 'PPL', 'P'),
(51932, 'Tameron Hall', 38.9000015258789, 0.678933105657405, -76.5872192382813, -1.33669914065475, 218, 25, 'PPL', 'P'),
(98422, 'Tamez Colonia', 26.3349990844727, 0.45963244253374, -98.7580032348633, -1.72365231914358, 218, 51, 'PPL', 'P'),
(18279, 'Tamiami', 25.7583293914795, 0.449567657694545, -80.3986129760742, -1.40322051046913, 218, 12, 'PPL', 'P'),
(208912, 'Tamill', 47.5122184753418, 0.829244647321595, -122.249717712402, -2.13366008371505, 218, 56, 'PPL', 'P'),
(167859, 'Tamiment', 41.142219543457, 0.718067192611684, -75.0274963378906, -1.30947684062418, 218, 45, 'PPL', 'P'),
(98423, 'Tamina', 30.1783294677734, 0.526711211964275, -95.4413909912109, -1.66576651547989, 218, 51, 'PPL', 'P'),
(206027, 'Tamlee Village', 40.6111106872559, 0.708797594384472, -111.878326416016, -1.95264515758042, 218, 52, 'PPL', 'P'),
(195692, 'Tammany', 47.4333305358887, 0.827867793038024, -115.650833129883, -2.01848782079099, 218, 17, 'PPL', 'P'),
(51933, 'Tammany Manor', 39.610279083252, 0.691329787636588, -77.7936096191406, -1.35775462486514, 218, 25, 'PPL', 'P'),
(28754, 'Tamms', 37.2350006103516, 0.649873357632733, -89.2699966430664, -1.55805536466579, 218, 18, 'PPL', 'P'),
(25329, 'Tammy Heights', 33.785831451416, 0.589673999351064, -84.6699981689453, -1.47777024570567, 218, 13, 'PPL', 'P'),
(12259, 'Tamo', 34.110279083252, 0.5953366787769, -91.7591705322266, -1.60149964468631, 218, 4, 'PPL', 'P'),
(61968, 'Tamola', 32.586669921875, 0.568744682397322, -88.476936340332, -1.54421385121622, 218, 30, 'PPL', 'P'),
(143166, 'Tamora', 40.8938903808594, 0.713733031095634, -97.2247161865234, -1.69689141177186, 218, 35, 'PPL', 'P'),
(18280, 'Tampa', 27.9472198486328, 0.487771003137354, -82.458610534668, -1.43917425044964, 218, 12, 'PPL', 'P'),
(34114, 'Tampa', 38.5472183227539, 0.672775877217142, -97.1527786254883, -1.69563586447594, 218, 20, 'PPL', 'P'),
(194448, 'Tampa', 40.1500015258789, 0.700749721307334, -104.455001831055, -1.82308370212861, 218, 7, 'PPL', 'P'),
(31285, 'Tampico', 38.7999992370605, 0.677187736457994, -85.9561080932617, -1.50021709842756, 218, 19, 'PPL', 'P'),
(91216, 'Tampico', 36.1963882446289, 0.631746152198945, -83.5619430541992, -1.45843103565978, 218, 50, 'PPL', 'P'),
(121663, 'Tampico', 41.6302795410156, 0.726585446516356, -89.7861099243164, -1.56706324073688, 218, 18, 'PPL', 'P'),
(157900, 'Tampico', 40.0486106872559, 0.698980117342004, -84.7930603027344, -1.47991808512481, 218, 41, 'PPL', 'P'),
(197674, 'Tampico', 48.3047218322754, 0.843076440233194, -106.826393127441, -1.8644722881037, 218, 31, 'PPL', 'P'),
(208913, 'Tampico', 46.5352783203125, 0.81219382502139, -120.866111755371, -2.10951160421465, 218, 56, 'PPL', 'P'),
(111658, 'Tamroy (historical)', 37.8519401550293, 0.660640983973114, -81.1669387817383, -1.41663032550601, 218, 58, 'PPL', 'P'),
(111659, 'Tams', 37.6647186279297, 0.657373351894614, -81.3077774047852, -1.41908842319215, 218, 58, 'PPL', 'P'),
(106805, 'Tamworth', 37.6480598449707, 0.657082601282605, -78.0811080932617, -1.36277241983301, 218, 53, 'PPL', 'P'),
(144543, 'Tamworth', 43.8597183227539, 0.765496493729341, -71.2636108398438, -1.24378464601519, 218, 36, 'PPL', 'P'),
(185559, 'Tan Oak Park', 39.8277816772461, 0.695125924033414, -123.603057861328, -2.15728032521324, 218, 6, 'PPL', 'P'),
(91217, 'Tan Rara Oesta', 35.8827781677246, 0.626272623789533, -84.1138916015625, -1.46806435511287, 218, 50, 'PPL', 'P'),
(212179, 'Tanacross', 63.3852806091309, 1.10628184392985, -143.346389770508, -2.50186647234248, 218, 1, 'PPL', 'P'),
(51934, 'Tanager Forest', 39.0455589294434, 0.681473561600259, -76.6438903808594, -1.33768823868361, 218, 25, 'PPL', 'P'),
(212180, 'Tanaina', 61.6269416809082, 1.07559304026638, -149.42805480957, -2.60801155127755, 218, 1, 'PPL', 'P'),
(212181, 'Tanana', 65.1719436645508, 1.13746499687067, -152.078887939453, -2.65427731731495, 218, 1, 'PPL', 'P'),
(193131, 'Tanani', 59.2700004577637, 1.03445665564652, -135.443328857422, -2.36393203842346, 218, 1, 'PPL', 'P'),
(201639, 'Tanasbourne', 45.538890838623, 0.794803582840254, -122.863891601563, -2.14437944026067, 218, 43, 'PPL', 'P'),
(38483, 'Tanbark', 36.7222213745117, 0.640923671631467, -85.3844375610352, -1.49023956540358, 218, 21, 'PPL', 'P'),
(91218, 'Tanbark (historical)', 35.6622200012207, 0.622423157591878, -85.0138931274414, -1.48377234501243, 218, 50, 'PPL', 'P'),
(185562, 'Tancred', 38.7652816772461, 0.676581800730974, -122.162498474121, -2.13213782083596, 218, 6, 'PPL', 'P'),
(18281, 'Tancrede', 27.9566707611084, 0.487935952677371, -81.9730606079102, -1.4306998055449, 218, 12, 'PPL', 'P'),
(61973, 'Tandy', 33.9625015258789, 0.592757473840185, -90.1647186279297, -1.57367120919164, 218, 30, 'PPL', 'P'),
(106806, 'Tandy', 37.2099990844727, 0.649436998688123, -82.3872222900391, -1.43792829053364, 218, 53, 'PPL', 'P'),
(195693, 'Taney (historical)', 46.5994415283203, 0.813313684259768, -116.542778015137, -2.034055195785, 218, 17, 'PPL', 'P'),
(51935, 'Taneytown', 39.6577796936035, 0.692158829683929, -77.1747207641602, -1.34695297664183, 218, 25, 'PPL', 'P'),
(57832, 'Taneyville', 36.7413902282715, 0.641258231243408, -93.0341720581055, -1.62375261928085, 218, 29, 'PPL', 'P'),
(18282, 'Tang-O-Mar Beach', 30.3722190856934, 0.530095224182411, -86.3447189331055, -1.50699963709178, 218, 12, 'PPL', 'P'),
(185561, 'Tangair', 34.7544403076172, 0.606579413055751, -120.610000610352, -2.10504162148301, 218, 6, 'PPL', 'P'),
(18283, 'Tangelo Park', 28.4555606842041, 0.496643224440412, -81.4461135864258, -1.42150284503642, 218, 12, 'PPL', 'P'),
(143167, 'Tangeman', 40.5586090087891, 0.707881267232403, -96.0861129760742, -1.67701903687574, 218, 35, 'PPL', 'P'),
(201640, 'Tangent', 44.541389465332, 0.777393899583161, -123.106941223145, -2.14862145640301, 218, 43, 'PPL', 'P'),
(18284, 'Tangerine', 28.764720916748, 0.502039088414535, -81.6308288574219, -1.42472673469401, 218, 12, 'PPL', 'P'),
(98425, 'Tangerine Estates Colonia', 26.2660007476807, 0.45842819437832, -98.3109970092773, -1.71585058873019, 218, 51, 'PPL', 'P'),
(31286, 'Tangier', 39.9191703796387, 0.69672095778929, -87.3180618286133, -1.52398767536928, 218, 19, 'PPL', 'P'),
(77415, 'Tangier', 36.4208297729492, 0.635663395846343, -99.5330581665039, -1.73717957958452, 218, 42, 'PPL', 'P'),
(106807, 'Tangier', 37.8261108398438, 0.660190177379591, -75.991943359375, -1.32630961661013, 218, 53, 'PPL', 'P'),
(43291, 'Tangipahoa', 30.8758296966553, 0.538884887491677, -90.5119400024414, -1.57973136541017, 218, 22, 'PPL', 'P'),
(61969, 'Tangipahoa', 31.2597198486328, 0.545585034609666, -90.5694427490234, -1.58073497766696, 218, 30, 'PPL', 'P'),
(25330, 'Tanglebrook', 33.9219398498535, 0.592049539043415, -83.4291687011719, -1.45611368603725, 218, 13, 'PPL', 'P'),
(12260, 'Tanglewood', 36.3166694641113, 0.633845455507227, -93.9300003051758, -1.6393877717246, 218, 4, 'PPL', 'P'),
(25336, 'Tanglewood', 32.8444404602051, 0.57324362700582, -83.5627822875977, -1.45844568304578, 218, 13, 'PPL', 'P'),
(43296, 'Tanglewood', 30.5377807617188, 0.532984820544174, -91.0749969482422, -1.58955856299061, 218, 22, 'PPL', 'P'),
(51939, 'Tanglewood', 38.9991683959961, 0.680663894049848, -76.4372177124023, -1.33408112014515, 218, 25, 'PPL', 'P'),
(61970, 'Tanglewood', 32.2755584716797, 0.56331476325076, -89.3047180175781, -1.55866136697184, 218, 30, 'PPL', 'P'),
(83966, 'Tanglewood', 34.8274993896484, 0.607854534585681, -82.4555587768555, -1.43912098722784, 218, 48, 'PPL', 'P'),
(91219, 'Tanglewood', 36.2752799987793, 0.633123073061543, -85.9877777099609, -1.50076983751181, 218, 50, 'PPL', 'P'),
(98426, 'Tanglewood', 30.4974994659424, 0.532281779305907, -96.9861068725586, -1.69272689361725, 218, 51, 'PPL', 'P'),
(106809, 'Tanglewood', 36.8327789306641, 0.642853264999284, -76.232780456543, -1.33051301691666, 218, 53, 'PPL', 'P'),
(111661, 'Tanglewood', 39.6519393920898, 0.692056897193207, -79.9491729736328, -1.39537630263636, 218, 58, 'PPL', 'P'),
(121665, 'Tanglewood', 41.8338890075684, 0.730139102095931, -88.3586120605469, -1.54214870294891, 218, 18, 'PPL', 'P'),
(123779, 'Tanglewood', 41.0733299255371, 0.71686484195854, -85.0044403076172, -1.4836073621829, 218, 19, 'PPL', 'P'),
(126313, 'Tanglewood', 42.3472213745117, 0.739098442056148, -73.3097229003906, -1.2794960383365, 218, 23, 'PPL', 'P'),
(167860, 'Tanglewood', 41.4150009155273, 0.722828125692418, -75.1708297729492, -1.31197848099415, 218, 45, 'PPL', 'P'),
(187427, 'Tanglewood Acres', 38.0938911437988, 0.664863825355598, -105.561111450195, -1.84238895687059, 218, 7, 'PPL', 'P'),
(167861, 'Tanglewood Estate', 41.3675003051758, 0.721999083645076, -75.2416687011719, -1.31321485353021, 218, 45, 'PPL', 'P'),
(91222, 'Tanglewood Estates', 36.1511116027832, 0.630955925724491, -82.809440612793, -1.44529739042795, 218, 50, 'PPL', 'P'),
(98427, 'Tanglewood Forest', 30.1744403839111, 0.526643334645991, -97.8388900756836, -1.70761076831748, 218, 51, 'PPL', 'P'),
(206030, 'Tanglewood Subdivision Number 3', 40.6327781677246, 0.709175763259263, -111.85221862793, -1.95218949071791, 218, 52, 'PPL', 'P'),
(111662, 'Tango', 38.2522201538086, 0.667627187881692, -81.9263916015625, -1.4298852777255, 218, 58, 'PPL', 'P'),
(79254, 'Tanguy', 39.9502792358398, 0.69726390975653, -75.5108337402344, -1.31791266969311, 218, 45, 'PPL', 'P'),
(189629, 'Tank Canyon (historical)', 34.6080589294434, 0.604024576043011, -107.975563049316, -1.8845290869053, 218, 38, 'PPL', 'P'),
(192304, 'Tankersley', 31.3494396209717, 0.547150940041119, -100.643058776855, -1.75655274493431, 218, 51, 'PPL', 'P'),
(38485, 'Tanksley', 37.2166709899902, 0.649553445406787, -83.7102813720703, -1.4610200277135, 218, 21, 'PPL', 'P'),
(28756, 'Tankville', 37.1269416809082, 0.647987373527766, -89.3836135864258, -1.56003835441347, 218, 18, 'PPL', 'P'),
(6231, 'Tannehill', 33.2602806091309, 0.580501406766559, -87.0800018310547, -1.5198327445946, 218, 2, 'PPL', 'P'),
(43295, 'Tannehill', 31.9977798461914, 0.558466611644325, -92.6549987792969, -1.61713479713006, 218, 22, 'PPL', 'P'),
(12261, 'Tannenbaum', 35.5588912963867, 0.620619731480703, -92.0569381713867, -1.60669667039555, 218, 4, 'PPL', 'P'),
(6233, 'Tanner', 34.7313919067383, 0.606177142573094, -86.9705581665039, -1.51792259230274, 218, 2, 'PPL', 'P'),
(25334, 'Tanner', 32.9752807617188, 0.575527221061536, -82.7422180175781, -1.44412413480971, 218, 13, 'PPL', 'P'),
(31287, 'Tanner', 39.0180587768555, 0.680993593392799, -86.793327331543, -1.51482933069661, 218, 19, 'PPL', 'P'),
(38484, 'Tanner', 37.5094413757324, 0.654663252590322, -85.7850036621094, -1.4972307627392, 218, 21, 'PPL', 'P'),
(57833, 'Tanner', 36.9180603027344, 0.644341705732529, -89.6833267211914, -1.5652693354266, 218, 29, 'PPL', 'P'),
(111663, 'Tanner', 38.9813919067383, 0.680353635782853, -80.9497222900391, -1.41283918253623, 218, 58, 'PPL', 'P'),
(208914, 'Tanner', 47.4755592346191, 0.828604822869703, -121.745002746582, -2.1248511457774, 218, 56, 'PPL', 'P'),
(106811, 'Tanner Creek', 36.9172210693359, 0.644327058346534, -76.2505569458008, -1.33082327518366, 218, 53, 'PPL', 'P'),
(6234, 'Tanner Crossroads', 34.7311096191406, 0.606172215725078, -86.9550018310547, -1.5176510830296, 218, 2, 'PPL', 'P'),
(6235, 'Tanner Heights', 34.4222183227539, 0.600781045572376, -86.9313888549805, -1.51723895885091, 218, 2, 'PPL', 'P'),
(206033, 'Tanner Lane Condo', 40.6338882446289, 0.709195137756193, -111.840278625488, -1.95198109836261, 218, 52, 'PPL', 'P'),
(25335, 'Tanner Mill', 34.1780586242676, 0.596519654933113, -83.7858276367188, -1.4623385587692, 218, 13, 'PPL', 'P'),
(98429, 'Tanner Settlement', 30.2091693878174, 0.527249470110093, -94.70361328125, -1.65288986529324, 218, 51, 'PPL', 'P'),
(179304, 'Tanner Springs', 35.288330078125, 0.615897547393829, -109.684997558594, -1.9143643474394, 218, 5, 'PPL', 'P'),
(6236, 'Tanner Williams', 30.7238903045654, 0.53623304483623, -88.370002746582, -1.54234750792429, 218, 2, 'PPL', 'P'),
(121666, 'Tanner Woods', 41.8122215270996, 0.72976093322114, -88.3963928222656, -1.54280810163482, 218, 18, 'PPL', 'P'),
(167862, 'Tannerie Woods', 40.1583290100098, 0.700895063323825, -75.1916732788086, -1.31234226879905, 218, 45, 'PPL', 'P'),
(106812, 'Tanners', 38.3041687011719, 0.668533861074809, -78.1527786254883, -1.36402330659702, 218, 53, 'PPL', 'P'),
(146435, 'Tanners Corners', 40.438060760498, 0.705777303392213, -74.3930587768555, -1.29840381628579, 218, 37, 'PPL', 'P'),
(106814, 'Tanners Cross Roads (historical)', 36.915828704834, 0.644302757001587, -76.2522201538086, -1.33085230363954, 218, 53, 'PPL', 'P'),
(167863, 'Tanners Falls', 41.660831451416, 0.727118677945618, -75.2886123657227, -1.31403417503958, 218, 45, 'PPL', 'P'),
(31288, 'Tannersville', 39.0950012207031, 0.682336492372472, -85.7474975585938, -1.49657615774326, 218, 19, 'PPL', 'P'),
(106813, 'Tannersville', 36.973331451416, 0.645306369258383, -81.6255569458008, -1.42463472247835, 218, 53, 'PPL', 'P'),
(153059, 'Tannersville', 42.1955604553223, 0.736451459669691, -74.1341705322266, -1.29388536402231, 218, 40, 'PPL', 'P'),
(167864, 'Tannersville', 41.0400009155273, 0.716283140997439, -75.3061065673828, -1.31433950645856, 218, 45, 'PPL', 'P'),
(167865, 'Tannertown', 40.9708290100098, 0.715075863496279, -77.0380630493164, -1.34456784956955, 218, 45, 'PPL', 'P'),
(38486, 'Tannery', 38.5438919067383, 0.672717820305378, -83.2158279418945, -1.45239018735916, 218, 21, 'PPL', 'P'),
(51940, 'Tannery', 39.5705604553223, 0.69063656680484, -76.9483337402344, -1.34300177769053, 218, 25, 'PPL', 'P'),
(111664, 'Tannery', 39.0513916015625, 0.681575360932927, -78.9574966430664, -1.37806828555388, 218, 58, 'PPL', 'P'),
(167866, 'Tannery', 41.0380592346191, 0.716249252272568, -75.7627792358398, -1.322309948127, 218, 45, 'PPL', 'P'),
(176647, 'Tannery Town', 46.3191719055176, 0.808422056548538, -90.6536102294922, -1.58220397732425, 218, 57, 'PPL', 'P'),
(194000, 'Tanoak (historical)', 40.3177795410156, 0.703678000083931, -123.770561218262, -2.16020381029987, 218, 6, 'PPL', 'P'),
(167867, 'Tanoma', 40.7002792358398, 0.710353879146487, -79.0458297729492, -1.37960998950893, 218, 45, 'PPL', 'P'),
(179305, 'Tanque', 32.6088905334473, 0.569132505231065, -109.537498474121, -1.91179000277168, 218, 5, 'PPL', 'P'),
(179306, 'Tanque Aloma', 32.6972198486328, 0.570674142607084, -113.956939697266, -1.98892380321392, 218, 5, 'PPL', 'P'),
(179307, 'Tanque Verde', 32.2516708374023, 0.562897845382108, -110.736671447754, -1.9327195194625, 218, 5, 'PPL', 'P'),
(98428, 'Tanquecitos South Acres Colonia', 27.4899997711182, 0.4797910073785, -99.379997253418, -1.73450816269507, 218, 51, 'PPL', 'P'),
(71465, 'Tansboro', 39.7688903808594, 0.694098077010698, -74.9199981689453, -1.30760064363622, 218, 37, 'PPL', 'P'),
(138396, 'Tansem', 46.6752815246582, 0.814637341900564, -96.2358322143555, -1.67963213053733, 218, 28, 'PPL', 'P'),
(43297, 'Tansey', 31.8263893127441, 0.555475282528921, -92.3819427490234, -1.61236907035936, 218, 22, 'PPL', 'P'),
(28757, 'Tansill', 37.3061103820801, 0.651114457279737, -88.5377807617188, -1.54527578670089, 218, 18, 'PPL', 'P'),
(51941, 'Tantallon', 38.7238883972168, 0.675859351706263, -77.0100021362305, -1.34407809424509, 218, 25, 'PPL', 'P'),
(91223, 'Tantallon', 35.1016693115234, 0.612639702432335, -85.9349975585938, -1.49984865009075, 218, 50, 'PPL', 'P'),
(51942, 'Tantallon Hills', 38.7099990844727, 0.675616937468038, -77.0119400024414, -1.34411191639093, 218, 25, 'PPL', 'P'),
(51943, 'Tantallon North', 38.7299995422363, 0.675966011307921, -77.0194396972656, -1.34424281075851, 218, 25, 'PPL', 'P'),
(51944, 'Tantallon South', 38.7202796936035, 0.675796367946483, -76.9930572509766, -1.34378235020604, 218, 25, 'PPL', 'P'),
(51945, 'Tantallon Square', 38.728889465332, 0.67594663681099, -77.0022201538086, -1.34394227302949, 218, 25, 'PPL', 'P'),
(51946, 'Tanterra', 39.1669387817383, 0.68359203966839, -77.0666732788086, -1.34506719227394, 218, 25, 'PPL', 'P'),
(69306, 'Tants Crossroads', 35.8983306884766, 0.626544066483639, -78.23388671875, -1.36543890987445, 218, 33, 'PPL', 'P'),
(208915, 'Tanwax', 47.0036087036133, 0.820367732197115, -122.242218017578, -2.13352918934747, 218, 56, 'PPL', 'P'),
(6238, 'Tanyard', 33.6355590820313, 0.587051251730527, -86.3247222900391, -1.50665062983092, 218, 2, 'PPL', 'P'),
(51947, 'Tanyard', 38.750560760498, 0.676324872264809, -75.976936340332, -1.32604769471693, 218, 25, 'PPL', 'P'),
(91224, 'Tanyard (historical)', 35.1672210693359, 0.613783796436633, -89.226936340332, -1.55730382060617, 218, 50, 'PPL', 'P'),
(51952, 'Tanyard Estates', 38.7244415283203, 0.675869005665214, -75.9805603027344, -1.32611094479281, 218, 25, 'PPL', 'P'),
(138398, 'Taopi', 43.5580596923828, 0.760231557412309, -92.6425018310547, -1.61691668423678, 218, 28, 'PPL', 'P'),
(57834, 'Taos', 38.5063896179199, 0.672063281888464, -92.0708312988281, -1.6069391512128, 218, 29, 'PPL', 'P'),
(189635, 'Taos', 36.4072189331055, 0.635425841877108, -105.57250213623, -1.84258776184597, 218, 38, 'PPL', 'P'),
(189631, 'Taos Junction', 36.3624992370605, 0.634645335940633, -105.896110534668, -1.84823579388581, 218, 38, 'PPL', 'P'),
(189632, 'Taos Pueblo', 36.4386100769043, 0.635973720692364, -105.543891906738, -1.84208841914158, 218, 38, 'PPL', 'P'),
(189634, 'Taos Ski Valley', 36.5844383239746, 0.638518903746153, -105.452217102051, -1.84048839195866, 218, 38, 'PPL', 'P'),
(25337, 'Tapawingo', 34.339168548584, 0.599331553570073, -83.811393737793, -1.46278477140984, 218, 13, 'PPL', 'P'),
(167868, 'Tapawingo', 41.3730583190918, 0.722096089287783, -78.7916717529297, -1.37517409523924, 218, 45, 'PPL', 'P'),
(179308, 'Tapco', 34.7947196960449, 0.607282421004504, -112.046112060547, -1.95557356951507, 218, 5, 'PPL', 'P'),
(25338, 'Tapestry', 33.3861083984375, 0.582697515980465, -84.5458297729492, -1.47560309836861, 218, 13, 'PPL', 'P'),
(189636, 'Tapicitoes', 36.459171295166, 0.636332581649252, -107.013328552246, -1.86773492675515, 218, 38, 'PPL', 'P'),
(133356, 'Tapiola', 46.9247207641602, 0.818990877913544, -88.6263885498047, -1.54682228434589, 218, 27, 'PPL', 'P'),
(126314, 'Tapleyville', 42.5541687011719, 0.742710354284568, -70.9486083984375, -1.23828681626084, 218, 23, 'PPL', 'P'),
(111668, 'Taplin', 37.7583312988281, 0.659007201223378, -81.8958282470703, -1.42935184655915, 218, 58, 'PPL', 'P'),
(195694, 'Taplin', 46.1522216796875, 0.805508225420855, -116.930282592773, -2.04081842653131, 218, 17, 'PPL', 'P'),
(69307, 'Tapoco', 35.4433288574219, 0.618602786429132, -83.9369430541992, -1.46497602035476, 218, 33, 'PPL', 'P'),
(106815, 'Tappahannock', 37.9252815246582, 0.661921032351061, -76.8594436645508, -1.34145035319751, 218, 53, 'PPL', 'P'),
(111665, 'Tappan', 39.3761100769043, 0.687242767469698, -80.158332824707, -1.39902683070058, 218, 58, 'PPL', 'P'),
(133357, 'Tappan', 42.9661102294922, 0.749900090279455, -82.482780456543, -1.43959609516631, 218, 27, 'PPL', 'P'),
(153060, 'Tappan', 41.0219383239746, 0.715967889303401, -73.9477767944336, -1.29063217959272, 218, 40, 'PPL', 'P'),
(157901, 'Tappan', 40.3572196960449, 0.704366360646689, -81.2077789306641, -1.41734312057177, 218, 41, 'PPL', 'P'),
(6239, 'Tappan (historical)', 34.1180610656738, 0.595472499992494, -86.4866714477539, -1.50947717585388, 218, 2, 'PPL', 'P'),
(144544, 'Tappan Corners', 42.9105606079102, 0.748930566484612, -70.9902801513672, -1.23901412555454, 218, 36, 'PPL', 'P'),
(140952, 'Tappen', 46.875, 0.818123086872342, -99.6361083984375, -1.73897814542671, 218, 34, 'PPL', 'P'),
(51948, 'Tappers Corner', 38.8855590820313, 0.678681037460229, -75.9611129760742, -1.32577152491188, 218, 25, 'PPL', 'P'),
(106816, 'Tapscott', 37.7872200012207, 0.659511404196757, -78.5772171020508, -1.37143115548518, 218, 53, 'PPL', 'P'),
(69308, 'Tar Corner', 36.4769401550293, 0.636642706758192, -76.2863922119141, -1.33144871856566, 218, 33, 'PPL', 'P'),
(38487, 'Tar Fork', 37.7205581665039, 0.658347935695529, -86.6016693115234, -1.51148426720941, 218, 21, 'PPL', 'P'),
(69309, 'Tar Heel', 34.7330589294434, 0.606206237608004, -78.790283203125, -1.37514986047332, 218, 33, 'PPL', 'P'),
(38488, 'Tar Hill', 37.565559387207, 0.655642696660226, -86.2183303833008, -1.50479374076086, 218, 21, 'PPL', 'P'),
(69310, 'Tar Landing', 34.7777786254883, 0.606986743544478, -77.4938888549805, -1.35252351069395, 218, 33, 'PPL', 'P'),
(69311, 'Tar River', 36.1997184753418, 0.631804275689736, -78.6297225952148, -1.37234754921628, 218, 33, 'PPL', 'P'),
(25344, 'Tara', 32.8705596923828, 0.573699493605415, -83.7652816772461, -1.46197996412842, 218, 13, 'PPL', 'P'),
(51950, 'Tara', 39.7013893127441, 0.692919961123474, -75.7916717529297, -1.32281421767941, 218, 25, 'PPL', 'P'),
(106817, 'Tara', 38.8902816772461, 0.678763462295967, -77.1352767944336, -1.34626454950004, 218, 53, 'PPL', 'P'),
(118001, 'Tara', 42.5002784729004, 0.741769792366579, -94.2955627441406, -1.64576803990615, 218, 16, 'PPL', 'P'),
(206034, 'Tara Condominium', 40.7752799987793, 0.711662889401288, -111.892501831055, -1.95289256524569, 218, 52, 'PPL', 'P'),
(74512, 'Tara Estates', 38.8880615234375, 0.678724713302106, -82.1505584716797, -1.43379772768293, 218, 41, 'PPL', 'P'),
(91227, 'Tara Estates', 36.1749992370605, 0.631372843593143, -85.5736083984375, -1.49354121936501, 218, 50, 'PPL', 'P'),
(206035, 'Tara Estates', 40.6236114501953, 0.709015773856777, -111.868057250977, -1.95246592683906, 218, 52, 'PPL', 'P'),
(83967, 'Tara Hills', 34.1358299255371, 0.595782625101433, -79.7519378662109, -1.39193390061132, 218, 48, 'PPL', 'P'),
(185563, 'Tara Hills', 37.9936103820801, 0.663113595887198, -122.315277099609, -2.1348043108774, 218, 6, 'PPL', 'P'),
(51951, 'Tara Oaks', 39.5461082458496, 0.690209795240155, -76.9550018310547, -1.34311815783017, 218, 25, 'PPL', 'P'),
(83968, 'Tara Village', 34.1294403076172, 0.595671105230786, -79.7527770996094, -1.39194854799732, 218, 48, 'PPL', 'P'),
(25341, 'Tara Way', 33.9605598449707, 0.592723585115314, -83.4266662597656, -1.45607001019537, 218, 13, 'PPL', 'P'),
(106818, 'Tara Wood', 38.7775001525879, 0.676795053355262, -77.5166702270508, -1.3529211206447, 218, 53, 'PPL', 'P'),
(25342, 'Tara Woods', 33.7280616760254, 0.58866572656236, -84.6736068725586, -1.47783322946545, 218, 13, 'PPL', 'P'),
(12264, 'Taral', 35.360279083252, 0.617153294426829, -93.1213912963867, -1.62527488215994, 218, 4, 'PPL', 'P'),
(38489, 'Tarascon', 38.4113883972168, 0.670405197793781, -85.3091735839844, -1.4889259611959, 218, 21, 'PPL', 'P'),
(172630, 'Tarbellville', 43.4086112976074, 0.757623190861658, -72.841667175293, -1.27132692485074, 218, 55, 'PPL', 'P'),
(25343, 'Tarboro', 31.0174999237061, 0.541357499405761, -81.8055572509766, -1.42777632045826, 218, 13, 'PPL', 'P'),
(69317, 'Tarboro', 35.896671295166, 0.626515104606784, -77.5361099243164, -1.35326040736757, 218, 33, 'PPL', 'P'),
(83969, 'Tarboro', 32.5316696166992, 0.567784745982403, -81.1544418334961, -1.41641221261273, 218, 48, 'PPL', 'P'),
(169629, 'Tarbox Corner', 41.6416702270508, 0.726784251491731, -71.5469436645508, -1.24872973668531, 218, 47, 'PPL', 'P'),
(6241, 'Tarentum', 31.6391696929932, 0.552207683739934, -85.8788909912109, -1.49886940575793, 218, 2, 'PPL', 'P'),
(167869, 'Tarentum', 40.601390838623, 0.708627951023034, -79.7600021362305, -1.39207464867493, 218, 45, 'PPL', 'P'),
(74513, 'Tarhe Town (historical)', 39.7077789306641, 0.693031480994121, -82.5994415283203, -1.44163221497773, 218, 41, 'PPL', 'P'),
(69318, 'Tarheel', 36.4563903808594, 0.636284045538386, -76.8566665649414, -1.34140188366567, 218, 33, 'PPL', 'P'),
(111667, 'Tarico Heights', 39.3263893127441, 0.686374976428495, -78.0041732788086, -1.36142965401139, 218, 58, 'PPL', 'P'),
(91228, 'Tariffville', 35.4866714477539, 0.619359257336769, -84.1786117553711, -1.46919393488923, 218, 50, 'PPL', 'P'),
(112987, 'Tariffville', 41.9086112976074, 0.731443252081743, -72.7605590820313, -1.26991132157331, 218, 8, 'PPL', 'P'),
(114152, 'Tariffville Center', 41.9211082458496, 0.73166136497502, -72.7641677856445, -1.26997430533309, 218, 8, 'PPL', 'P'),
(185564, 'Tarke', 39.1452789306641, 0.683214003951653, -121.84806060791, -2.12664984477764, 218, 6, 'PPL', 'P'),
(31289, 'Tarkeo Corner', 39.2627792358398, 0.685264771149068, -85.48388671875, -1.49197528064404, 218, 19, 'PPL', 'P'),
(69320, 'Tarkey Tail (historical)', 35.7299995422363, 0.623606133748091, -81.7352828979492, -1.42654980161823, 218, 33, 'PPL', 'P'),
(106821, 'Tarkiln', 37.0569381713867, 0.646765581798665, -81.9875030517578, -1.43095187374207, 218, 53, 'PPL', 'P'),
(126318, 'Tarkiln', 42.0333290100098, 0.733619986798719, -70.7388916015625, -1.23462656765863, 218, 23, 'PPL', 'P'),
(169628, 'Tarkiln', 41.9550018310547, 0.732252919632154, -71.6066665649414, -1.24977209793597, 218, 47, 'PPL', 'P'),
(139473, 'Tarkio', 40.4402809143066, 0.705816052386074, -95.3775024414063, -1.66465144993147, 218, 29, 'PPL', 'P'),
(197675, 'Tarkio', 47.0213890075684, 0.820678057043137, -114.738059997559, -2.00255692430819, 218, 31, 'PPL', 'P'),
(118014, 'Tarkio City (historical)', 40.7324981689453, 0.710916205610657, -95.1952819824219, -1.6614711029577, 218, 16, 'PPL', 'P'),
(74514, 'Tarlton', 39.5558280944824, 0.690379438601593, -82.7761077880859, -1.44471562288782, 218, 41, 'PPL', 'P'),
(91229, 'Tarlton', 35.4930610656738, 0.619470777207416, -85.6530609130859, -1.49492792734461, 218, 50, 'PPL', 'P'),
(12265, 'Tarnceville', 34.8474998474121, 0.608203608425563, -91.6033325195313, -1.59877975826501, 218, 4, 'PPL', 'P'),
(143168, 'Tarnov', 41.6158294677734, 0.726333245161126, -97.5019378662109, -1.70172984284032, 218, 35, 'PPL', 'P'),
(106819, 'Taro', 37.1361083984375, 0.648147362930253, -78.6408309936523, -1.37254142734364, 218, 53, 'PPL', 'P'),
(185565, 'Tarpey', 36.7877807617188, 0.64206789879382, -119.699722290039, -2.08915426768403, 218, 6, 'PPL', 'P'),
(185566, 'Tarpey Village', 36.7930603027344, 0.642160044167536, -119.699996948242, -2.08915906137399, 218, 6, 'PPL', 'P'),
(6245, 'Tarpley', 33.4447212219238, 0.583720502734192, -86.8908309936523, -1.51653109063317, 218, 2, 'PPL', 'P'),
(91232, 'Tarpley', 35.142219543457, 0.613347437492024, -86.9933319091797, -1.51832006909543, 218, 50, 'PPL', 'P'),
(98430, 'Tarpley', 29.6569404602051, 0.517611257098501, -99.2761077880859, -1.73269494946688, 218, 51, 'PPL', 'P'),
(18285, 'Tarpon', 28.0394401550293, 0.489380551121171, -82.5666732788086, -1.44106030113363, 218, 12, 'PPL', 'P'),
(106820, 'Tarpon', 37.1858291625977, 0.649015153971455, -82.3513870239258, -1.43730284715164, 218, 53, 'PPL', 'P'),
(83973, 'Tarpon Bay', 33.7238883972168, 0.588592889106546, -78.9530563354492, -1.37799078756616, 218, 48, 'PPL', 'P'),
(18286, 'Tarpon Point', 27.0216693878174, 0.471617100202774, -82.2769393920898, -1.43600349085579, 218, 12, 'PPL', 'P'),
(18289, 'Tarpon Springs', 28.1458301544189, 0.491237406901715, -82.7569427490234, -1.44438112985491, 218, 12, 'PPL', 'P'),
(106822, 'Tarrallton', 36.9205589294434, 0.644385314995379, -76.2202835083008, -1.33029490402338, 218, 53, 'PPL', 'P'),
(98431, 'Tarrant', 32.8166694641113, 0.572758931687426, -97.0769424438477, -1.69431227341417, 218, 51, 'PPL', 'P'),
(176648, 'Tarrant', 44.5966682434082, 0.778358696267069, -91.8430633544922, -1.60296385065364, 218, 57, 'PPL', 'P'),
(6242, 'Tarrant City', 33.5833282470703, 0.586139651689393, -86.7727813720703, -1.51447073605583, 218, 2, 'PPL', 'P'),
(6244, 'Tarrant Heights', 33.5955581665039, 0.586353104050763, -86.7569427490234, -1.51419429993468, 218, 2, 'PPL', 'P'),
(57839, 'Tarrants', 39.3566703796387, 0.686903480746822, -91.1827774047852, -1.59143968682659, 218, 29, 'PPL', 'P'),
(129051, 'Tarratine', 45.6169395446777, 0.796165789737829, -69.8488922119141, -1.21909314796853, 218, 26, 'PPL', 'P'),
(51953, 'Tarrington Creek', 38.607780456543, 0.673832885853794, -77.0124969482422, -1.34412163692891, 218, 25, 'PPL', 'P'),
(167874, 'Tarrs', 40.1699981689453, 0.701098728568189, -79.5983276367188, -1.38925289634194, 218, 45, 'PPL', 'P'),
(167871, 'Tarrtown', 40.8522186279297, 0.713005721801933, -79.519172668457, -1.38787138152646, 218, 45, 'PPL', 'P'),
(12268, 'Tarry', 34.0758285522461, 0.594735403581787, -91.8413925170898, -1.6029346890397, 218, 4, 'PPL', 'P'),
(31290, 'Tarry Park', 38.8013916015625, 0.677212037802941, -86.5091705322266, -1.50986985895661, 218, 19, 'PPL', 'P'),
(83971, 'Tarry Town', 33.0811080932617, 0.57737425643556, -79.9930572509766, -1.39614222776587, 218, 48, 'PPL', 'P'),
(187428, 'Tarryall', 39.121940612793, 0.682806673462925, -105.474998474121, -1.84088600190941, 218, 7, 'PPL', 'P'),
(157906, 'Tarrymore', 40.7330589294434, 0.710925992727663, -81.5180587768555, -1.42275852549039, 218, 41, 'PPL', 'P'),
(18287, 'Tarrytown', 28.5547199249268, 0.4983738796748, -82.0547180175781, -1.43212499620225, 218, 12, 'PPL', 'P'),
(25345, 'Tarrytown', 32.3186111450195, 0.564066174152325, -82.559440612793, -1.44093406729796, 218, 13, 'PPL', 'P'),
(57835, 'Tarrytown', 39.2844390869141, 0.685642806865805, -94.6777801513672, -1.65243899212069, 218, 29, 'PPL', 'P'),
(153062, 'Tarrytown', 41.0761108398438, 0.716913378069407, -73.8591690063477, -1.28908568194772, 218, 40, 'PPL', 'P'),
(57836, 'Tarsney', 38.9413909912109, 0.679655488103089, -94.2155609130859, -1.64437174454662, 218, 29, 'PPL', 'P'),
(57837, 'Tarsney Lakes', 38.9497184753418, 0.67980083011958, -94.20361328125, -1.64416321903327, 218, 29, 'PPL', 'P'),
(51958, 'Tarson Manor', 39.4805603027344, 0.689065767814884, -77.1191711425781, -1.34598345284699, 218, 25, 'PPL', 'P'),
(6247, 'Tarsus', 33.6363906860352, 0.587065765958468, -85.9111099243164, -1.4994317322221, 218, 2, 'PPL', 'P'),
(12266, 'Tarsus', 35.0900001525879, 0.612436037187971, -90.4072189331055, -1.57790363795405, 218, 4, 'PPL', 'P'),
(91231, 'Tarsus', 36.4236106872559, 0.635711931957209, -87.5391693115234, -1.52784672894686, 218, 50, 'PPL', 'P'),
(6246, 'Tarsus (historical)', 33.6222190856934, 0.586818424872227, -85.9561080932617, -1.50021709842756, 218, 2, 'PPL', 'P'),
(51954, 'Tarton Hill', 39.3833312988281, 0.687368801568286, -76.4561080932617, -1.3344108194881, 218, 25, 'PPL', 'P'),
(79255, 'Tartown', 39.8227806091309, 0.695038638928687, -77.4400024414063, -1.35158301535499, 218, 45, 'PPL', 'P'),
(179309, 'Tartron', 32.8788909912109, 0.573844902200933, -113.099166870117, -1.97395284314603, 218, 5, 'PPL', 'P'),
(25346, 'Tarver', 30.7013893127441, 0.535840328443984, -82.9244384765625, -1.44730448178349, 218, 13, 'PPL', 'P'),
(25347, 'Tarversville', 32.5400009155273, 0.567930154577921, -83.4400024414063, -1.45630277047465, 218, 13, 'PPL', 'P'),
(106823, 'Taryn Hills', 37.2477798461914, 0.650096397374027, -80.0058288574219, -1.3963651343491, 218, 53, 'PPL', 'P'),
(192305, 'Tarzan', 32.3052787780762, 0.56383348045208, -101.974716186523, -1.77979455124159, 218, 51, 'PPL', 'P'),
(51955, 'Tarzan Forest', 38.9500007629395, 0.679805756967597, -76.5802764892578, -1.33657796682515, 218, 25, 'PPL', 'P'),
(185567, 'Tarzana', 34.1733283996582, 0.59643709693932, -118.553062438965, -2.06914127788236, 218, 6, 'PPL', 'P'),
(177703, 'Tasco', 39.3541717529297, 0.686859871483971, -100.290832519531, -1.75040523703202, 218, 20, 'PPL', 'P'),
(198986, 'Tasco', 48.6872215270996, 0.84975231929575, -100.254722595215, -1.74977499996005, 218, 34, 'PPL', 'P'),
(192306, 'Tascosa', 35.5111083984375, 0.619785762585345, -102.250831604004, -1.78461367439214, 218, 51, 'PPL', 'P'),
(194001, 'Tasikoyo (historical)', 40.0750007629395, 0.699440711052533, -120.838890075684, -2.10903649627618, 218, 6, 'PPL', 'P'),
(61975, 'Taska', 34.9188919067383, 0.609449634920584, -89.5652770996094, -1.56320898084926, 218, 30, 'PPL', 'P'),
(57838, 'Taskee Station (historical)', 36.9925003051758, 0.645640928870325, -90.4502792358398, -1.57865518201367, 218, 29, 'PPL', 'P'),
(208916, 'Tasker', 46.6958312988281, 0.814996003120371, -120.742782592773, -2.10735910426359, 218, 56, 'PPL', 'P'),
(106824, 'Tasley', 37.7102813720703, 0.658168571796112, -75.7008285522461, -1.32122870472443, 218, 53, 'PPL', 'P'),
(133358, 'Tasmas Corners', 42.8047218322754, 0.747083331373506, -86.1569366455078, -1.50372221789627, 218, 27, 'PPL', 'P'),
(185568, 'Tassajara', 37.7958297729492, 0.659661673061265, -121.862503051758, -2.12690191297481, 218, 6, 'PPL', 'P'),
(185569, 'Tassajara Hot Springs', 36.2341690063477, 0.632405550884849, -121.547782897949, -2.12140901006847, 218, 6, 'PPL', 'P'),
(126315, 'Tasseltop', 42.0222206115723, 0.733426108671361, -71.7194366455078, -1.25174030713959, 218, 23, 'PPL', 'P'),
(6249, 'Tasso', 32.2172203063965, 0.562296570186995, -87.1966705322266, -1.52186899756407, 218, 2, 'PPL', 'P'),
(91233, 'Tasso', 35.211669921875, 0.614559575262173, -84.8041687011719, -1.48011196325217, 218, 50, 'PPL', 'P'),
(91234, 'Tasso Heights', 35.211109161377, 0.614549788145167, -84.8116683959961, -1.48024285761975, 218, 50, 'PPL', 'P'),
(31291, 'Taswell', 38.334171295166, 0.669057505124146, -86.5611114501953, -1.51077639899167, 218, 19, 'PPL', 'P'),
(179310, 'Tat Momoli', 32.6041717529297, 0.569050146974354, -111.882499694824, -1.95271799503623, 218, 5, 'PPL', 'P'),
(179311, 'Tatai Toak', 32.3963890075684, 0.565423653938966, -112.495826721191, -1.96342257103781, 218, 5, 'PPL', 'P'),
(167872, 'Tatamy', 40.7408294677734, 0.711061614206176, -75.2574996948242, -1.31349115649331, 218, 45, 'PPL', 'P'),
(987, 'Tate', 35.957218170166, 0.627571846927328, -88.4630584716797, -1.54397163671507, 218, 50, 'PPL', 'P'),
(12267, 'Tate', 35.026668548584, 0.611330692177534, -93.9966735839844, -1.64055143996291, 218, 4, 'PPL', 'P'),
(25348, 'Tate', 34.4183311462402, 0.600713201543606, -84.3827819824219, -1.47275737758581, 218, 13, 'PPL', 'P'),
(111669, 'Tate', 38.6158294677734, 0.673973367601296, -80.9111099243164, -1.41216526962238, 218, 58, 'PPL', 'P'),
(69321, 'Tate (historical)', 35.4844398498535, 0.619320308605826, -81.9461135864258, -1.43022949129639, 218, 33, 'PPL', 'P'),
(91235, 'Tate (historical)', 36.2050018310547, 0.63189648764248, -86.533332824707, -1.51029157051522, 218, 50, 'PPL', 'P'),
(143169, 'Tate (historical)', 40.2097206115723, 0.701792015978964, -96.4541702270508, -1.68344284774112, 218, 35, 'PPL', 'P'),
(189637, 'Tate (historical)', 36.3041687011719, 0.633627276034923, -103.400001525879, -1.80467047319375, 218, 38, 'PPL', 'P'),
(25349, 'Tate City', 34.9816703796387, 0.61054532597207, -83.554443359375, -1.45830014129221, 218, 13, 'PPL', 'P'),
(43300, 'Tate Cove', 30.7438907623291, 0.536582118676112, -92.246940612793, -1.61001283858491, 218, 22, 'PPL', 'P'),
(197676, 'Tate Place', 45.0538902282715, 0.786338725315437, -112.01611328125, -1.95504999204476, 218, 31, 'PPL', 'P'),
(91236, 'Tate Springs', 36.3400001525879, 0.6342526528379, -83.345832824707, -1.4546592006079, 218, 50, 'PPL', 'P'),
(98433, 'Tate Springs', 32.6811103820801, 0.570392979374999, -97.1930618286133, -1.69633893900372, 218, 51, 'PPL', 'P'),
(91237, 'Tater Peeler (historical)', 36.1002807617188, 0.630068760186359, -86.2761077880859, -1.50580214670762, 218, 50, 'PPL', 'P'),
(43301, 'Taterville', 30.8069400787354, 0.537682536838533, -91.9538879394531, -1.60489810455336, 218, 22, 'PPL', 'P'),
(51957, 'Tates Bank', 38.561939239502, 0.673032805683307, -76.0386123657227, -1.32712414442954, 218, 25, 'PPL', 'P'),
(12270, 'Tates Bluff', 33.7988891601563, 0.589901899361348, -92.9008331298828, -1.62142541596228, 218, 4, 'PPL', 'P'),
(91238, 'Tatesville', 35.3666687011719, 0.617264814297476, -85.5611114501953, -1.49332310647173, 218, 50, 'PPL', 'P'),
(167875, 'Tatesville', 40.0597190856934, 0.699173995469362, -78.3574981689453, -1.36759633667352, 218, 45, 'PPL', 'P'),
(12271, 'Tatetown (historical)', 35.4422187805176, 0.618583411932201, -93.2263870239258, -1.62710740330602, 218, 4, 'PPL', 'P'),
(38490, 'Tateville', 36.9644393920898, 0.645151173545859, -84.5813903808594, -1.47622374806066, 218, 21, 'PPL', 'P'),
(126316, 'Tatham', 42.1041717529297, 0.734856425913816, -72.6800003051758, -1.2685053056758, 218, 23, 'PPL', 'P'),
(25350, 'Tatham Mines (historical)', 33.6227798461914, 0.586828211989233, -82.5400009155273, -1.44059478057509, 218, 13, 'PPL', 'P'),
(38491, 'Tatham Springs', 37.8658294677734, 0.660883398211339, -85.123893737793, -1.48569221784227, 218, 21, 'PPL', 'P'),
(212182, 'Tatitlek', 60.8647193908691, 1.0622897516731, -146.678604125977, -2.56002458422763, 218, 1, 'PPL', 'P'),
(179312, 'Tatk Kam Vo', 31.9899997711182, 0.558330823718244, -112.343063354492, -1.96075634731247, 218, 5, 'PPL', 'P'),
(179313, 'Tatkum Vo', 31.6680603027344, 0.552711920002827, -112.123062133789, -1.9569166016528, 218, 5, 'PPL', 'P'),
(194002, 'Tatlatunne (historical)', 41.7569389343262, 0.728796069958204, -124.22721862793, -2.16817398565221, 218, 6, 'PPL', 'P'),
(129052, 'Tatnic', 43.2769393920898, 0.755325082578001, -70.684440612793, -1.23367621862364, 218, 26, 'PPL', 'P'),
(126317, 'Tatnuck', 42.2833290100098, 0.737983309928705, -71.8499984741211, -1.25401904092631, 218, 23, 'PPL', 'P'),
(98434, 'Tatsie', 30.7933292388916, 0.537444982869298, -96.601936340332, -1.68602185294076, 218, 51, 'PPL', 'P'),
(98435, 'Tatsie Crossing', 30.8008308410645, 0.537575910526389, -96.6063919067383, -1.68609961724459, 218, 51, 'PPL', 'P'),
(129053, 'Tattle Corner', 43.4724998474121, 0.758738256410074, -70.4147186279297, -1.22896868192276, 218, 26, 'PPL', 'P'),
(6250, 'Tattlersville', 31.7124996185303, 0.553487532380799, -88.0563888549805, -1.53687391293585, 218, 2, 'PPL', 'P'),
(197677, 'Tattnall', 48.6272201538086, 0.848705097776103, -107.542221069336, -1.87696584256753, 218, 31, 'PPL', 'P'),
(185570, 'Tatu', 39.6583290100098, 0.692168417063854, -123.343612670898, -2.15275215241177, 218, 6, 'PPL', 'P'),
(18288, 'Tatum', 27.3180599212646, 0.476790090883171, -82.4261093139648, -1.43860699713745, 218, 12, 'PPL', 'P'),
(61977, 'Tatum', 31.148889541626, 0.543650680841401, -91.0436096191406, -1.58901075075438, 218, 30, 'PPL', 'P'),
(83972, 'Tatum', 34.6438903808594, 0.604649952845988, -79.586669921875, -1.38904943083466, 218, 48, 'PPL', 'P'),
(98436, 'Tatum', 32.3158302307129, 0.564017638041459, -94.5163879394531, -1.64962216663572, 218, 51, 'PPL', 'P'),
(106825, 'Tatum', 38.211109161377, 0.666909665704997, -77.8955612182617, -1.35953401594747, 218, 53, 'PPL', 'P'),
(189638, 'Tatum', 33.2569389343262, 0.580443083538686, -103.317222595215, -1.80322570830238, 218, 38, 'PPL', 'P'),
(25352, 'Tatum (historical)', 34.8380584716797, 0.608038825333114, -85.5155563354492, -1.49252801972829, 218, 13, 'PPL', 'P'),
(98437, 'Tatum Addition Colonia', 26.2290000915527, 0.457782411103489, -97.5820007324219, -1.70312720346428, 218, 51, 'PPL', 'P'),
(18290, 'Tatum Ridge', 27.3211097717285, 0.476843320815459, -82.4077835083008, -1.43828715149053, 218, 12, 'PPL', 'P'),
(77417, 'Tatums', 34.482780456543, 0.601838054209028, -97.4613876342773, -1.70102210778063, 218, 42, 'PPL', 'P'),
(25353, 'Tatumsville', 32.0372200012207, 0.559154972207083, -81.1149978637695, -1.41572378547095, 218, 13, 'PPL', 'P'),
(38492, 'Tatumsville', 36.9327812194824, 0.644598634198695, -88.3063888549805, -1.54123723606583, 218, 21, 'PPL', 'P'),
(28759, 'Tatumville', 37.2577781677246, 0.650270901004455, -89.2794418334961, -1.55822021433727, 218, 18, 'PPL', 'P'),
(91239, 'Tatumville', 36.0424995422363, 0.629060287660573, -89.1941680908203, -1.55673190676208, 218, 50, 'PPL', 'P'),
(12272, 'Tatumville (historical)', 34.711669921875, 0.605832929002202, -92.5875015258789, -1.61595674782186, 218, 4, 'PPL', 'P'),
(153064, 'Taughannock Falls', 42.5319404602051, 0.742322398292771, -76.6122207641602, -1.33713549959936, 218, 40, 'PPL', 'P'),
(38493, 'Taulbee', 37.6427803039551, 0.656990455908888, -83.3305587768555, -1.45439261818279, 218, 21, 'PPL', 'P'),
(126319, 'Taunton', 41.9000015258789, 0.731292983217235, -71.0902786254883, -1.24075942817492, 218, 23, 'PPL', 'P'),
(138402, 'Taunton', 44.5936088562012, 0.778305299887213, -96.065559387207, -1.67666030907691, 218, 28, 'PPL', 'P'),
(153063, 'Taunton', 43.0305595397949, 0.751024942944877, -76.2091674804688, -1.33010089273797, 218, 40, 'PPL', 'P'),
(71467, 'Taunton Lake', 39.8505592346191, 0.695523467405135, -74.8491668701172, -1.3063644042582, 218, 37, 'PPL', 'P'),
(77418, 'Taupa', 34.603889465332, 0.603951805166224, -98.5100021362305, -1.71932388342387, 218, 42, 'PPL', 'P'),
(57840, 'Tauria', 36.8058280944824, 0.642382884171749, -93.345832824707, -1.62919212580734, 218, 29, 'PPL', 'P'),
(185572, 'Taurusa', 36.417781829834, 0.635610199203568, -119.252502441406, -2.08134880884512, 218, 6, 'PPL', 'P'),
(176649, 'Taus', 44.1891708374023, 0.771246524838931, -87.8619384765625, -1.53348011360071, 218, 57, 'PPL', 'P'),
(34116, 'Taussig', 37.1055603027344, 0.647614198080019, -96.5702819824219, -1.68546938017262, 218, 20, 'PPL', 'P'),
(106826, 'Tauxenent (historical)', 38.709171295166, 0.675602489819125, -77.0869369506836, -1.34542086006671, 218, 53, 'PPL', 'P'),
(18291, 'Tavares', 28.8038902282715, 0.502722721866358, -81.725830078125, -1.4263848187887, 218, 12, 'PPL', 'P'),
(98439, 'Tavener', 29.5400009155273, 0.515570277018091, -95.9891662597656, -1.67532699747716, 218, 51, 'PPL', 'P'),
(111671, 'Tavennersville', 39.2522201538086, 0.685080480401635, -81.5505599975586, -1.42332577880258, 218, 58, 'PPL', 'P'),
(176650, 'Tavera', 43.2841682434082, 0.755451249834644, -90.6455612182617, -1.58206349557675, 218, 57, 'PPL', 'P'),
(57841, 'Tavern', 38.1624984741211, 0.666061249160725, -92.1294403076172, -1.6079620713875, 218, 29, 'PPL', 'P'),
(144545, 'Tavern Village', 43.0391693115234, 0.751175211809385, -71.7038879394531, -1.25146893102451, 218, 36, 'PPL', 'P'),
(18292, 'Tavernier', 25.0111103057861, 0.436526224415454, -80.5152816772461, -1.40525676343861, 218, 12, 'PPL', 'P'),
(14710, 'Tavistock', 39.8055610656738, 0.694738101199671, -75.5583267211914, -1.3187415785824, 218, 10, 'PPL', 'P'),
(71468, 'Tavistock', 39.8761100769043, 0.695969413729669, -75.0299987792969, -1.30952051646606, 218, 37, 'PPL', 'P'),
(61979, 'Tawanta', 31.5475006103516, 0.550607756425555, -89.2494430541992, -1.55769663686696, 218, 30, 'PPL', 'P'),
(133359, 'Tawas City', 44.2694396972656, 0.772647480730367, -83.5147171020508, -1.4576067873024, 218, 27, 'PPL', 'P'),
(157902, 'Tawawa', 40.2361106872559, 0.702252609689493, -84.0277786254883, -1.46656140015169, 218, 41, 'PPL', 'P'),
(138404, 'Tawney', 43.6163902282715, 0.761249617318019, -91.7897186279297, -1.60203280953655, 218, 28, 'PPL', 'P'),
(25354, 'Tax Crossroads', 32.8116683959961, 0.572671646582698, -84.5983276367188, -1.47651935894166, 218, 13, 'PPL', 'P'),
(83974, 'Taxahaw', 34.6897201538086, 0.605449833279394, -80.5169372558594, -1.40528565873643, 218, 48, 'PPL', 'P'),
(112533, 'Taxville', 39.9583282470703, 0.697404391504031, -76.8150024414063, -1.34067470753002, 218, 45, 'PPL', 'P'),
(176651, 'Taycheedah', 43.8088912963867, 0.764609394770235, -88.3949966430664, -1.54278373371084, 218, 57, 'PPL', 'P'),
(6251, 'Tayloe', 32.4480590820313, 0.566325466863094, -87.4380569458008, -1.52608198525052, 218, 2, 'PPL', 'P'),
(6253, 'Taylor', 31.9752807617188, 0.558073928541593, -86.2333297729492, -1.50505552949602, 218, 2, 'PPL', 'P'),
(12273, 'Taylor', 33.1002807617188, 0.577708882626529, -93.4608306884766, -1.63119921716287, 218, 4, 'PPL', 'P'),
(18293, 'Taylor', 30.4402809143066, 0.531283127186641, -82.291389465332, -1.43625569221102, 218, 12, 'PPL', 'P'),
(28760, 'Taylor', 39.6002807617188, 0.69115528400616, -90.9633331298828, -1.58760966170489, 218, 18, 'PPL', 'P'),
(43302, 'Taylor', 32.5455589294434, 0.568027160220627, -93.1191711425781, -1.62523613316608, 218, 22, 'PPL', 'P'),
(51959, 'Taylor', 39.5761108398438, 0.690733439289492, -76.5175018310547, -1.33548234235269, 218, 25, 'PPL', 'P'),
(57843, 'Taylor', 39.938060760498, 0.697050657132241, -91.5236129760742, -1.5973883897535, 218, 29, 'PPL', 'P'),
(61980, 'Taylor', 34.2722206115723, 0.598163091641801, -89.5886077880859, -1.56361617817993, 218, 30, 'PPL', 'P'),
(77420, 'Taylor', 34.1736106872559, 0.596442023787337, -98.3308334350586, -1.7161967996719, 218, 42, 'PPL', 'P'),
(91240, 'Taylor', 35.1263885498047, 0.613071134528928, -84.783332824707, -1.47974830860532, 218, 50, 'PPL', 'P'),
(98438, 'Taylor', 30.5705604553223, 0.53355693412535, -97.4091720581055, -1.7001107740556, 218, 51, 'PPL', 'P'),
(106827, 'Taylor', 37.0986099243164, 0.647492891092366, -79.9049987792969, -1.39460531750078, 218, 53, 'PPL', 'P'),
(111670, 'Taylor', 39.0469398498535, 0.681497663208124, -78.9800033569336, -1.37846110181467, 218, 58, 'PPL', 'P'),
(118003, 'Taylor', 41.2713890075684, 0.720321625053463, -95.5197219848633, -1.66713364922548, 218, 16, 'PPL', 'P'),
(123780, 'Taylor', 40.3402786254883, 0.704070683186663, -86.9336090087891, -1.51727770784477, 218, 19, 'PPL', 'P'),
(133361, 'Taylor', 42.2408294677734, 0.737241552986091, -83.2697219848633, -1.45333081585617, 218, 27, 'PPL', 'P'),
(143170, 'Taylor', 41.7702789306641, 0.729028896816504, -99.3783264160156, -1.73447900108113, 218, 35, 'PPL', 'P'),
(153066, 'Taylor', 42.936939239502, 0.749390960458059, -77.8808288574219, -1.35927688774423, 218, 40, 'PPL', 'P'),
(167877, 'Taylor', 41.394718170166, 0.722474125004519, -75.7069396972656, -1.32133536432608, 218, 45, 'PPL', 'P'),
(176652, 'Taylor', 44.3211097717285, 0.773549293654495, -91.1197204589844, -1.59033913550612, 218, 57, 'PPL', 'P'),
(179314, 'Taylor', 34.4650001525879, 0.601527729363007, -110.090560913086, -1.92144276330072, 218, 5, 'PPL', 'P'),
(185571, 'Taylor', 33.598331451416, 0.586401507003575, -116.417503356934, -2.03186874053004, 218, 6, 'PPL', 'P'),
(195695, 'Taylor', 45.6855583190918, 0.797363413280038, -116.382499694824, -2.03125781137598, 218, 17, 'PPL', 'P'),
(198988, 'Taylor', 46.9005584716797, 0.81856916635493, -102.42472076416, -1.7876486127704, 218, 34, 'PPL', 'P'),
(206037, 'Taylor', 41.2272186279297, 0.719550706496912, -112.082778930664, -1.95621352712502, 218, 52, 'PPL', 'P'),
(212183, 'Taylor', 65.7272186279297, 1.14715637323552, -164.848617553711, -2.87715114367318, 218, 1, 'PPL', 'P'),
(190819, 'Taylor (historical)', 39.079719543457, 0.6820697767893, -114.684440612793, -2.00162108950114, 218, 39, 'PPL', 'P'),
(91241, 'Taylor Acres', 36.1816711425781, 0.631489290311807, -82.7855606079102, -1.44488060571735, 218, 50, 'PPL', 'P'),
(172631, 'Taylor Bridge', 44.4841690063477, 0.776395214174381, -72.2930603027344, -1.26175192862552, 218, 55, 'PPL', 'P'),
(153067, 'Taylor Center', 42.6138916015625, 0.743752715535225, -75.9252777099609, -1.32514608152988, 218, 40, 'PPL', 'P'),
(157903, 'Taylor Centre (historical)', 40.3447189331055, 0.704148181174384, -83.3958282470703, -1.45553178533907, 218, 41, 'PPL', 'P'),
(123782, 'Taylor Corner', 40.0250015258789, 0.698568059742341, -87.01611328125, -1.51871767904618, 218, 19, 'PPL', 'P'),
(77421, 'Taylor Corner Gin', 34.2180595397949, 0.597217802612877, -98.9233322143555, -1.72653785418468, 218, 42, 'PPL', 'P'),
(114153, 'Taylor Corners', 41.4466705322266, 0.723380864776664, -73.5252838134766, -1.28325828600846, 218, 8, 'PPL', 'P'),
(157904, 'Taylor Corners', 41.1169395446777, 0.717625973398085, -80.7944412231445, -1.41012901665291, 218, 41, 'PPL', 'P'),
(18295, 'Taylor Creek', 27.2163906097412, 0.475015626648851, -80.7897186279297, -1.41004659181717, 218, 12, 'PPL', 'P'),
(25356, 'Taylor Crossing', 33.540828704834, 0.585397894746778, -84.4027786254883, -1.47310638484666, 218, 13, 'PPL', 'P'),
(69324, 'Taylor Crossroads', 36.1247215270996, 0.630495332013962, -77.7425003051758, -1.35686259905801, 218, 33, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(91244, 'Taylor Crossroads', 36.2019386291504, 0.631843024683597, -87.4388885498047, -1.52609649947846, 218, 50, 'PPL', 'P'),
(112253, 'Taylor Estates', 39.1277809143066, 0.682908605953648, -75.5299987792969, -1.31824716272603, 218, 10, 'PPL', 'P'),
(77423, 'Taylor Ferry', 35.9441719055176, 0.627344146654126, -95.2788925170898, -1.66293038207701, 218, 42, 'PPL', 'P'),
(167878, 'Taylor Highlands', 40.5063896179199, 0.706969866928351, -78.017219543457, -1.36165735428459, 218, 45, 'PPL', 'P'),
(28761, 'Taylor Hill', 38.1122207641602, 0.665183737581544, -88.7958297729492, -1.54977959157837, 218, 18, 'PPL', 'P'),
(91246, 'Taylor Hill', 35.4811096191406, 0.619262185115035, -85.0269393920898, -1.48400004528563, 218, 50, 'PPL', 'P'),
(153068, 'Taylor Hollow', 42.5194396972656, 0.742104218820466, -78.9291687011719, -1.37757386969751, 218, 40, 'PPL', 'P'),
(185573, 'Taylor Junction', 34.063060760498, 0.594512563577575, -118.222221374512, -2.06336701200685, 218, 6, 'PPL', 'P'),
(98441, 'Taylor Lake Village', 29.5750007629395, 0.516181139593128, -95.0500030517578, -1.65893550728383, 218, 51, 'PPL', 'P'),
(51961, 'Taylor Landing', 38.0752792358398, 0.664538986281636, -75.3658294677734, -1.31538186770921, 218, 25, 'PPL', 'P'),
(206041, 'Taylor Lane', 40.6563911437988, 0.709587887437953, -111.961387634277, -1.9540948493198, 218, 52, 'PPL', 'P'),
(143172, 'Taylor Manor Trailer Court', 40.0997200012207, 0.699872143149126, -99.2200012207031, -1.73171570513406, 218, 35, 'PPL', 'P'),
(38495, 'Taylor Mill', 38.997501373291, 0.680634799014939, -84.4963912963867, -1.47474023417543, 218, 21, 'PPL', 'P'),
(91248, 'Taylor Mill', 36.3141708374023, 0.633801846244377, -82.5702819824219, -1.44112328489341, 218, 50, 'PPL', 'P'),
(179315, 'Taylor Place', 32.0761108398438, 0.559833745389917, -109.324172973633, -1.90806677040969, 218, 5, 'PPL', 'P'),
(189639, 'Taylor Ranch', 35.1686096191406, 0.613808031202553, -106.719169616699, -1.8626008848057, 218, 38, 'PPL', 'P'),
(121668, 'Taylor Ridge', 41.3866691589355, 0.722333643257018, -90.6680603027344, -1.58245617867948, 218, 18, 'PPL', 'P'),
(153070, 'Taylor Settlement', 43.7827796936035, 0.764153661328695, -76.0749969482422, -1.32775917519146, 218, 40, 'PPL', 'P'),
(28762, 'Taylor Springs', 39.1308288574219, 0.682961802596422, -89.491943359375, -1.56192906562937, 218, 18, 'PPL', 'P'),
(189640, 'Taylor Springs', 36.327220916748, 0.634029613096606, -104.491668701172, -1.82372365973856, 218, 38, 'PPL', 'P'),
(74516, 'Taylor Station', 39.9877815246582, 0.697918448173444, -82.8430633544922, -1.44588421797415, 218, 41, 'PPL', 'P'),
(98445, 'Taylor Town', 33.4563903808594, 0.583924167978556, -95.4499969482422, -1.66591671776537, 218, 51, 'PPL', 'P'),
(114154, 'Taylor Town', 41.6438903808594, 0.726823000485591, -72.6063919067383, -1.26722059676595, 218, 8, 'PPL', 'P'),
(153069, 'Taylor Valley', 42.5930595397949, 0.743389127467402, -75.9527816772461, -1.32562611631637, 218, 40, 'PPL', 'P'),
(112719, 'Tayloria', 39.7949981689453, 0.69455374387321, -76.0697174072266, -1.32766702981775, 218, 45, 'PPL', 'P'),
(83975, 'Taylors', 34.920280456543, 0.609473869686503, -82.29638671875, -1.43634291073672, 218, 48, 'PPL', 'P'),
(91249, 'Taylors', 36.0136108398438, 0.628556084687194, -85.3622207641602, -1.48985180914886, 218, 50, 'PPL', 'P'),
(106829, 'Taylors', 38.0541687011719, 0.664170537944823, -77.0883331298828, -1.34544522799068, 218, 53, 'PPL', 'P'),
(61981, 'Taylors (historical)', 33.1936111450195, 0.579337805107276, -88.7347183227539, -1.5487129955618, 218, 30, 'PPL', 'P'),
(69327, 'Taylors Beach', 36.2794418334961, 0.633195710780275, -76.1172180175781, -1.32849607186509, 218, 33, 'PPL', 'P'),
(69331, 'Taylors Bridge', 34.8444404602051, 0.608150212045707, -78.2413864135742, -1.36556980424203, 218, 33, 'PPL', 'P'),
(91250, 'Taylors Chapel', 35.9263916015625, 0.627033821808104, -85.1688919067383, -1.48647758404773, 218, 50, 'PPL', 'P'),
(51962, 'Taylors Choice', 39.6941719055176, 0.692793993603913, -76.916389465332, -1.34244424491632, 218, 25, 'PPL', 'P'),
(14711, 'Taylors Corner', 39.3875007629395, 0.687441572445072, -75.7161102294922, -1.3214954203076, 218, 10, 'PPL', 'P'),
(69330, 'Taylors Corner', 35.0102806091309, 0.611044668676459, -77.5897216796875, -1.35419610901657, 218, 33, 'PPL', 'P'),
(106831, 'Taylors Corner', 37.2291717529297, 0.649771624879092, -77.0405578613281, -1.34461139225338, 218, 53, 'PPL', 'P'),
(153072, 'Taylors Corner', 44.7686080932617, 0.781359612762398, -74.6291732788086, -1.30252479175658, 218, 40, 'PPL', 'P'),
(176656, 'Taylors Corners', 43.0869407653809, 0.752008980967662, -89.1994400024414, -1.55682391897774, 218, 57, 'PPL', 'P'),
(74517, 'Taylors Creek', 39.2105598449707, 0.684353370845016, -84.6741714477539, -1.47784308316148, 218, 41, 'PPL', 'P'),
(83976, 'Taylors Creek', 34.4425010681152, 0.601135046260275, -80.8833312988281, -1.41168044114593, 218, 48, 'PPL', 'P'),
(25357, 'Taylors Creek (historical)', 31.9347190856934, 0.557365993744822, -81.649169921875, -1.42504684665704, 218, 13, 'PPL', 'P'),
(91251, 'Taylors Crossing', 35.5247192382813, 0.62002331655458, -88.2522201538086, -1.54029181387886, 218, 50, 'PPL', 'P'),
(6259, 'Taylors Crossroads', 33.225830078125, 0.579900131571446, -85.3605575561523, -1.48982278069298, 218, 2, 'PPL', 'P'),
(83977, 'Taylors Crossroads', 34.2661094665527, 0.598056432040143, -81.4980621337891, -1.42240951822953, 218, 48, 'PPL', 'P'),
(91252, 'Taylors Crossroads', 36.5105590820313, 0.637229467725364, -85.2525024414063, -1.48793686316704, 218, 50, 'PPL', 'P'),
(138407, 'Taylors Falls', 45.4019393920898, 0.792413329182881, -92.6522216796875, -1.61708632759822, 218, 28, 'PPL', 'P'),
(14712, 'Taylors Gut Landing', 39.3274993896484, 0.686394350925426, -75.5152816772461, -1.31799030083889, 218, 10, 'PPL', 'P'),
(51963, 'Taylors Island', 38.4688911437988, 0.671408810050577, -76.2994384765625, -1.33167641883886, 218, 25, 'PPL', 'P'),
(51964, 'Taylors Landing', 39.4988899230957, 0.68938568004083, -77.7677764892578, -1.35730375169259, 218, 25, 'PPL', 'P'),
(6255, 'Taylors Mill', 33.2611083984375, 0.580515854415472, -86.0791702270508, -1.50236493784671, 218, 2, 'PPL', 'P'),
(25358, 'Taylors Mill', 32.6058311462402, 0.569079108851209, -83.873893737793, -1.46387560219234, 218, 13, 'PPL', 'P'),
(146436, 'Taylors Mills', 40.2966690063477, 0.703309551747118, -74.3405609130859, -1.29748755571275, 218, 37, 'PPL', 'P'),
(69333, 'Taylors Store', 36.0897216796875, 0.629884469438925, -77.9875030517578, -1.3611387036623, 218, 33, 'PPL', 'P'),
(106832, 'Taylors Valley', 36.6236114501953, 0.639202603777003, -81.7177810668945, -1.42624433704119, 218, 53, 'PPL', 'P'),
(74518, 'Taylorsburg', 39.8327789306641, 0.695213142559114, -84.293327331543, -1.47119609939675, 218, 41, 'PPL', 'P'),
(153073, 'Taylorshire', 42.7452812194824, 0.746045896970865, -78.6561126708984, -1.37280814292681, 218, 40, 'PPL', 'P'),
(38497, 'Taylorsport', 39.0997200012207, 0.682418850629183, -84.6933288574219, -1.47817744303634, 218, 21, 'PPL', 'P'),
(106833, 'Taylorstown', 39.2541694641113, 0.685114502284561, -77.5749969482422, -1.35393911397138, 218, 53, 'PPL', 'P'),
(167887, 'Taylorstown', 40.1597213745117, 0.700919364668772, -80.3783264160156, -1.40286644320221, 218, 45, 'PPL', 'P'),
(167884, 'Taylorstown Station', 40.1500015258789, 0.700749721307334, -80.3713912963867, -1.40274540253066, 218, 45, 'PPL', 'P'),
(25360, 'Taylorsville', 34.086109161377, 0.594914834060231, -84.9875030517578, -1.4833117513019, 218, 13, 'PPL', 'P'),
(31295, 'Taylorsville', 39.2958297729492, 0.68584161184118, -85.9508285522461, -1.50012495305385, 218, 19, 'PPL', 'P'),
(38496, 'Taylorsville', 38.0316696166992, 0.663777854842091, -85.3424987792969, -1.48950759557797, 218, 21, 'PPL', 'P'),
(51965, 'Taylorsville', 39.4577789306641, 0.688668157864135, -77.0869369506836, -1.34542086006671, 218, 25, 'PPL', 'P'),
(61983, 'Taylorsville', 31.829439163208, 0.555528512461208, -89.4280624389648, -1.56081413323901, 218, 30, 'PPL', 'P'),
(69334, 'Taylorsville', 35.9216690063477, 0.626951396972366, -81.1766662597656, -1.4168001020255, 218, 33, 'PPL', 'P'),
(74520, 'Taylorsville', 39.8641700744629, 0.695761021374371, -84.166389465332, -1.46898061568591, 218, 41, 'PPL', 'P'),
(91254, 'Taylorsville', 36.2755584716797, 0.633127933330533, -86.1997222900391, -1.50446896826593, 218, 50, 'PPL', 'P'),
(98442, 'Taylorsville', 29.8958301544189, 0.521780668811615, -97.4977798461914, -1.70165727170061, 218, 51, 'PPL', 'P'),
(106834, 'Taylorsville', 37.8269386291504, 0.660204625028505, -77.4594421386719, -1.35192230207786, 218, 53, 'PPL', 'P'),
(118011, 'Taylorsville', 42.767219543457, 0.746428792956591, -91.6466674804688, -1.5995360960146, 218, 16, 'PPL', 'P'),
(167886, 'Taylorsville', 40.711109161377, 0.710542897004855, -78.9766693115234, -1.37840291174485, 218, 45, 'PPL', 'P'),
(194003, 'Taylorsville', 40.0755615234375, 0.699450498169539, -120.838607788086, -2.10903156942816, 218, 6, 'PPL', 'P'),
(206044, 'Taylorsville', 40.667781829834, 0.709786692413327, -111.938056945801, -1.95368765198913, 218, 52, 'PPL', 'P'),
(69335, 'Taylorsville Beach', 35.8280601501465, 0.62531761422263, -81.2038879394531, -1.41727520996397, 218, 33, 'PPL', 'P'),
(206045, 'Taylorsville Cove', 40.6644401550293, 0.709728369185455, -111.970558166504, -1.95425490530132, 218, 52, 'PPL', 'P'),
(206046, 'Taylorsville Gardens', 40.6791687011719, 0.709985430809674, -111.94361114502, -1.95378459105281, 218, 52, 'PPL', 'P'),
(14713, 'Taylortown', 39.6472206115723, 0.691974538936496, -75.6716690063477, -1.32071977464011, 218, 10, 'PPL', 'P'),
(43304, 'Taylortown', 32.9863891601563, 0.575721099188894, -92.6005630493164, -1.61618471441117, 218, 22, 'PPL', 'P'),
(69337, 'Taylortown', 35.2075004577637, 0.614486804385387, -79.4861068725586, -1.38729427451824, 218, 33, 'PPL', 'P'),
(91258, 'Taylortown', 35.1991691589355, 0.614341395789869, -86.7544403076172, -1.5141506240928, 218, 50, 'PPL', 'P'),
(146437, 'Taylortown', 40.9377784729004, 0.714499022804168, -74.3949966430664, -1.29843763843164, 218, 37, 'PPL', 'P'),
(153074, 'Taylortown', 42.7638893127441, 0.7463706694658, -74.9819412231445, -1.30868175388074, 218, 40, 'PPL', 'P'),
(157909, 'Taylortown', 40.857780456543, 0.713102794023667, -82.6102828979492, -1.44182143257318, 218, 41, 'PPL', 'P'),
(6256, 'Taylorville', 33.1433296203613, 0.578460226949067, -87.5472183227539, -1.52798721069436, 218, 2, 'PPL', 'P'),
(28763, 'Taylorville', 39.5488891601563, 0.690258331351022, -89.2944412231445, -1.55848200307242, 218, 18, 'PPL', 'P'),
(31296, 'Taylorville', 39.4625015258789, 0.688750582699873, -87.4236068725586, -1.52582978389529, 218, 19, 'PPL', 'P'),
(51966, 'Taylorville', 38.3583297729492, 0.669479150103733, -75.1686096191406, -1.31193973200028, 218, 25, 'PPL', 'P'),
(111673, 'Taylorville', 37.6641693115234, 0.65736376451469, -82.1566696166992, -1.43390438728459, 218, 58, 'PPL', 'P'),
(167888, 'Taylorville', 40.7413902282715, 0.711071401323182, -76.3908309936523, -1.33327151917377, 218, 45, 'PPL', 'P'),
(195696, 'Taylorville', 43.3827781677246, 0.757172317689107, -112.035827636719, -1.9553940724576, 218, 17, 'PPL', 'P'),
(201641, 'Taylorville', 46.1413917541504, 0.805319207562486, -123.398063659668, -2.15370250144677, 218, 43, 'PPL', 'P'),
(12277, 'Taylorville (historical)', 35.2972183227539, 0.616052676527326, -91.1374969482422, -1.59064939377311, 218, 4, 'PPL', 'P'),
(185574, 'Taylorville (historical)', 38.0291709899902, 0.663734245579241, -122.739723205566, -2.14221229292362, 218, 6, 'PPL', 'P'),
(106835, 'Taylorwood Estates', 36.836109161377, 0.642911388490075, -76.4250030517578, -1.33386793409989, 218, 53, 'PPL', 'P'),
(133365, 'Taymouth', 43.2427787780762, 0.75472886738896, -83.873893737793, -1.46387560219234, 218, 27, 'PPL', 'P'),
(25361, 'Tazewell', 32.3802795410156, 0.565142490706881, -84.4408264160156, -1.47377044406448, 218, 13, 'PPL', 'P'),
(91259, 'Tazewell', 36.4541702270508, 0.636245296544525, -83.5694427490234, -1.45856193002736, 218, 50, 'PPL', 'P'),
(98443, 'Tazewell', 33.0566711425781, 0.576947751186984, -95.6197204589844, -1.66887895184586, 218, 51, 'PPL', 'P'),
(106836, 'Tazewell', 37.1147193908691, 0.647774054324451, -81.5197219848633, -1.42278755394627, 218, 53, 'PPL', 'P'),
(121671, 'Tazewell', 40.4844398498535, 0.706586771205543, -89.3324966430664, -1.55914619544829, 218, 18, 'PPL', 'P'),
(106837, 'Tazewell (historical)', 36.6044387817383, 0.638867977586035, -78.2088928222656, -1.3650026840879, 218, 53, 'PPL', 'P'),
(212184, 'Tazlina', 62.0638885498047, 1.0832192017849, -146.454727172852, -2.55611719427627, 218, 1, 'PPL', 'P'),
(106787, 'TB Crossroads', 37.5113906860352, 0.654697274473248, -75.8436126708984, -1.32372075771447, 218, 53, 'PPL', 'P'),
(61984, 'Tchula', 33.1827812194824, 0.579148787248907, -90.2227783203125, -1.57468454198641, 218, 30, 'PPL', 'P'),
(57846, 'Tea', 38.2999992370605, 0.668461090198023, -91.3963928222656, -1.59516797919465, 218, 29, 'PPL', 'P'),
(171417, 'Tea', 43.4463882446289, 0.758282522968534, -96.835563659668, -1.69009941888578, 218, 49, 'PPL', 'P'),
(129054, 'Tea Kettle Corner', 43.4427795410156, 0.758219539208754, -70.4413909912109, -1.2294342024813, 218, 26, 'PPL', 'P'),
(38498, 'Teaberry', 37.4266700744629, 0.653218620857009, -82.6430587768555, -1.44239347957533, 218, 21, 'PPL', 'P'),
(111674, 'Teaberry', 37.7705612182617, 0.659220653584748, -80.440559387207, -1.40395261345279, 218, 58, 'PPL', 'P'),
(14714, 'Teaberry Woods', 38.4705581665039, 0.671437905085486, -75.0977783203125, -1.31070349262227, 218, 10, 'PPL', 'P'),
(69338, 'Teachey', 34.7680587768555, 0.60681710018304, -78.0083312988281, -1.3615022251511, 218, 33, 'PPL', 'P'),
(79256, 'Teagarden Homes', 39.9761085510254, 0.697714716350053, -80.0494384765625, -1.39712626578865, 218, 45, 'PPL', 'P'),
(185575, 'Teagle (historical)', 35.4361114501953, 0.618476818909571, -117.640556335449, -2.05321504193146, 218, 6, 'PPL', 'P'),
(91260, 'Teague', 35.410831451416, 0.618035599695972, -88.915283203125, -1.55186444723774, 218, 50, 'PPL', 'P'),
(98444, 'Teague', 31.6269397735596, 0.551994231378564, -96.2836074829102, -1.68046596627463, 218, 51, 'PPL', 'P'),
(69339, 'Teague (historical)', 35.6558303833008, 0.62231163772123, -82.9991683959961, -1.44860876492735, 218, 33, 'PPL', 'P'),
(51967, 'Teagues Point', 38.538330078125, 0.672620748083645, -76.7202835083008, -1.33902155028335, 218, 25, 'PPL', 'P'),
(69340, 'Teaguetown', 36.0288887023926, 0.628822733691338, -80.0980606079102, -1.39797488207, 218, 33, 'PPL', 'P'),
(185576, 'Teagueville (historical)', 34.4083290100098, 0.600538631334151, -119.081108093262, -2.07835741315068, 218, 6, 'PPL', 'P'),
(195697, 'Teakean', 46.5511093139648, 0.812470127984485, -116.379722595215, -2.03120934184414, 218, 17, 'PPL', 'P'),
(185577, 'Teakettle Junction', 36.7602806091309, 0.64158793058636, -117.54167175293, -2.05148918038704, 218, 6, 'PPL', 'P'),
(74521, 'Teakwood Acres', 39.2066688537598, 0.684285460237219, -84.5422210693359, -1.47554011460883, 218, 41, 'PPL', 'P'),
(185578, 'Teal', 38.1733283996582, 0.666250267019094, -122.077781677246, -2.13065923379875, 218, 6, 'PPL', 'P'),
(57848, 'Teal (historical)', 38.3416709899902, 0.669188399491723, -92.2413864135742, -1.60991589952123, 218, 29, 'PPL', 'P'),
(91261, 'Teal (historical)', 35.5527801513672, 0.620513071879045, -86.0886077880859, -1.50252965436013, 218, 50, 'PPL', 'P'),
(83979, 'Teal Acres', 32.7211112976074, 0.571091127054764, -79.9458312988281, -1.39531797940849, 218, 48, 'PPL', 'P'),
(51968, 'Teal Bay', 38.396671295166, 0.670148335906642, -75.1444396972656, -1.31151788728362, 218, 25, 'PPL', 'P'),
(57847, 'Teal Bend', 38.2847213745117, 0.668194441193879, -93.480827331543, -1.63154822442373, 218, 29, 'PPL', 'P'),
(153075, 'Teall Beach', 42.8147201538086, 0.747257835003933, -76.938606262207, -1.34283200117104, 218, 40, 'PPL', 'P'),
(6260, 'Teals Crossroads', 31.6408290863037, 0.552236645616789, -85.5686111450195, -1.49345400083931, 218, 2, 'PPL', 'P'),
(208917, 'Teanaway', 47.1749992370605, 0.82335906131252, -120.856391906738, -2.10934196085321, 218, 56, 'PPL', 'P'),
(146438, 'Teaneck', 40.8974990844727, 0.713796014855414, -74.0163879394531, -1.29182966997688, 218, 37, 'PPL', 'P'),
(133367, 'Teapot Dome', 42.2108306884766, 0.736717975515781, -85.9661102294922, -1.50039166863702, 218, 27, 'PPL', 'P'),
(167889, 'Tearing Run', 40.5277786254883, 0.707343175534152, -79.1538925170898, -1.38149604019292, 218, 45, 'PPL', 'P'),
(18296, 'Teasdale', 29.7372207641602, 0.519012412727019, -81.6466674804688, -1.42500317081516, 218, 12, 'PPL', 'P'),
(61985, 'Teasdale', 34.1158294677734, 0.595433551261551, -90.022216796875, -1.57118408304961, 218, 30, 'PPL', 'P'),
(192813, 'Teasdale', 38.2861099243164, 0.668218675959798, -111.476669311523, -1.945634918643, 218, 52, 'PPL', 'P'),
(98446, 'Teaselville', 32.1477813720703, 0.561084632153927, -95.4044418334961, -1.66512163102192, 218, 51, 'PPL', 'P'),
(6261, 'Teasleys Mill', 32.1541709899902, 0.561196152024574, -86.1113891601563, -1.50292726431088, 218, 2, 'PPL', 'P'),
(38502, 'Teatersville', 37.6888885498047, 0.657795196611283, -84.5069427490234, -1.47492439176481, 218, 21, 'PPL', 'P'),
(126321, 'Teaticket', 41.5644416809082, 0.725436359085014, -70.5963897705078, -1.23213944151661, 218, 23, 'PPL', 'P'),
(25362, 'Teaver Hill', 33.0208282470703, 0.576322174646925, -85.1127777099609, -1.48549820655686, 218, 13, 'PPL', 'P'),
(106839, 'Teaverton', 38.1097183227539, 0.665140061739667, -78.961669921875, -1.37814112300969, 218, 53, 'PPL', 'P'),
(111678, 'Teays', 38.4416694641113, 0.670933702112107, -81.9530563354492, -1.43035066512599, 218, 58, 'PPL', 'P'),
(111675, 'Teays Farm', 38.4858283996582, 0.671704420931576, -81.9027786254883, -1.42947315354681, 218, 58, 'PPL', 'P'),
(111677, 'Teays Meadow', 38.4297218322754, 0.670725176598754, -81.9305572509766, -1.42995798202326, 218, 58, 'PPL', 'P'),
(111683, 'Teays Valley', 38.4500007629395, 0.671079110707625, -81.929443359375, -1.4299385409473, 218, 58, 'PPL', 'P'),
(111679, 'Teays Valley Estates', 38.4391708374023, 0.670890092849257, -81.9502792358398, -1.43030219559415, 218, 58, 'PPL', 'P'),
(111680, 'Teays Valley Meadows', 38.4486083984375, 0.671054809362678, -81.9791717529297, -1.43080646514655, 218, 58, 'PPL', 'P'),
(111681, 'Teays Villa', 38.4527816772461, 0.671127646818492, -81.8994369506836, -1.42941483031893, 218, 58, 'PPL', 'P'),
(111682, 'Teays Village', 38.4425010681152, 0.670948216340048, -81.9419403076172, -1.43015665384058, 218, 58, 'PPL', 'P'),
(57849, 'Tebbetts', 38.6205596923828, 0.674055925595089, -91.9622192382813, -1.60504351314888, 218, 29, 'PPL', 'P'),
(38499, 'Tebbs', 37.9977798461914, 0.663186366763985, -84.2825012207031, -1.47100714811741, 218, 21, 'PPL', 'P'),
(51969, 'Tebbston', 39.0875015258789, 0.682205598004894, -76.5194396972656, -1.33551616449854, 218, 25, 'PPL', 'P'),
(153076, 'Teboville', 44.8066711425781, 0.782023938296318, -74.2447204589844, -1.29581482423207, 218, 40, 'PPL', 'P'),
(185579, 'Tecate', 32.577220916748, 0.568579766146819, -116.626670837402, -2.03551940175232, 218, 6, 'PPL', 'P'),
(189641, 'Techado', 34.5852813720703, 0.603627032671289, -108.386390686035, -1.89169938182423, 218, 38, 'PPL', 'P'),
(121673, 'Techny (historical)', 42.1161117553711, 0.735064818269114, -87.8222198486328, -1.53278689276896, 218, 18, 'PPL', 'P'),
(209773, 'Teckla', 43.5583305358887, 0.760236284523243, -105.34944152832, -1.83869461980644, 218, 59, 'PPL', 'P'),
(61986, 'Teckville', 34.5063896179199, 0.602250111808691, -89.6627807617188, -1.56491074078582, 218, 30, 'PPL', 'P'),
(189644, 'Tecolote', 35.3194389343262, 0.616440499361069, -106.404998779297, -1.85711756927928, 218, 38, 'PPL', 'P'),
(189645, 'Tecolotito', 35.2344398498535, 0.61495698547584, -105.158889770508, -1.83536886423715, 218, 38, 'PPL', 'P'),
(200228, 'Tecoma', 41.3202781677246, 0.721174901866724, -114.080558776855, -1.99108136317104, 218, 39, 'PPL', 'P'),
(185580, 'Tecopa', 35.848331451416, 0.625671415173447, -116.225563049316, -2.02851875019483, 218, 6, 'PPL', 'P'),
(98447, 'Tecula', 32.019718170166, 0.558849507630051, -95.2091674804688, -1.66171345061689, 218, 51, 'PPL', 'P'),
(6262, 'Tecumseh', 33.9988899230957, 0.593392571181142, -85.4241714477539, -1.49093305255144, 218, 2, 'PPL', 'P'),
(34117, 'Tecumseh', 39.0480613708496, 0.681517237442136, -95.5788879394531, -1.66816628993816, 218, 20, 'PPL', 'P'),
(57851, 'Tecumseh', 36.586669921875, 0.638557852477095, -92.2863922119141, -1.61070139888475, 218, 29, 'PPL', 'P'),
(77424, 'Tecumseh', 35.2577781677246, 0.615364315964568, -96.936393737793, -1.6918592357341, 218, 42, 'PPL', 'P'),
(123784, 'Tecumseh', 40.3927803039551, 0.704987010338732, -86.8683319091797, -1.51613840753044, 218, 19, 'PPL', 'P'),
(133370, 'Tecumseh', 42.0038909912109, 0.733106196445415, -83.9449996948242, -1.46511663526032, 218, 27, 'PPL', 'P'),
(143174, 'Tecumseh', 40.3666687011719, 0.704531276897192, -96.1958312988281, -1.67893398285756, 218, 35, 'PPL', 'P'),
(74522, 'Tecumseh Estates', 39.8325004577637, 0.695208282290125, -83.8861083984375, -1.4640887882376, 218, 41, 'PPL', 'P'),
(6263, 'Tecumseh Furnace', 33.9808311462402, 0.593077386066131, -85.4247207641602, -1.49094263993136, 218, 2, 'PPL', 'P'),
(18297, 'Tedder', 26.2838897705078, 0.458740416726618, -80.1224975585938, -1.39840138731858, 218, 12, 'PPL', 'P'),
(38500, 'Tedders', 37.0191688537598, 0.646106382849843, -83.8797225952148, -1.46397733494598, 218, 21, 'PPL', 'P'),
(38501, 'Teddy', 37.1797218322754, 0.648908560948825, -84.9419403076172, -1.48251653140041, 218, 21, 'PPL', 'P'),
(43306, 'Teddy', 30.9841709136963, 0.54077579844466, -90.9766693115234, -1.58784242198417, 218, 22, 'PPL', 'P'),
(121674, 'Tedens (historical)', 41.6944389343262, 0.727705239175708, -87.9727783203125, -1.53541463381654, 218, 18, 'PPL', 'P'),
(57852, 'Tedieville', 38.9199981689453, 0.67928211291826, -93.2719421386719, -1.62790249004947, 218, 29, 'PPL', 'P'),
(57853, 'Tedrick (historical)', 36.9105606079102, 0.644210811364952, -92.3733291625977, -1.61221873491583, 218, 29, 'PPL', 'P'),
(157910, 'Tedrow', 41.603328704834, 0.726115065688821, -84.2061080932617, -1.46967383651766, 218, 41, 'PPL', 'P'),
(118012, 'Teds Mobile Home Park', 41.5374984741211, 0.724966111415534, -90.6333312988281, -1.58185004321538, 218, 16, 'PPL', 'P'),
(18298, 'Tee and Green Estates', 26.9447193145752, 0.470274068065047, -82.0025024414063, -1.43121366247723, 218, 12, 'PPL', 'P'),
(193313, 'Tee Harbor', 58.4124984741211, 1.01949042268958, -134.755828857422, -2.351932899816, 218, 1, 'PPL', 'P'),
(123785, 'Tee Lake', 41.7169418334961, 0.728097988857467, -86.6900024414063, -1.51302597116446, 218, 19, 'PPL', 'P'),
(25363, 'Tee Pee', 33.9077796936035, 0.591802397694255, -83.3988876342773, -1.45558518171892, 218, 13, 'PPL', 'P'),
(197678, 'Tee Pee Trailer Court', 45.6805610656738, 0.797276194754338, -111.065277099609, -1.93845477002804, 218, 31, 'PPL', 'P'),
(179316, 'Teec Nos Pos', 36.9211082458496, 0.644394902375304, -109.084999084473, -1.90389239855905, 218, 5, 'PPL', 'P'),
(153077, 'Teed Corners', 42.7986106872559, 0.746976671771848, -77.8966674804688, -1.35955332386538, 218, 40, 'PPL', 'P'),
(118013, 'Teeds Grove', 42.0116691589355, 0.733241951081982, -90.2474975585938, -1.57511597408301, 218, 16, 'PPL', 'P'),
(123786, 'Teegarden', 41.4650001525879, 0.72370077700261, -86.3775024414063, -1.50757181725198, 218, 19, 'PPL', 'P'),
(157911, 'Teegarden', 40.8227806091309, 0.71249193144863, -80.8288879394531, -1.41073022526899, 218, 41, 'PPL', 'P'),
(43305, 'Teel (historical)', 32.1080589294434, 0.560391344743152, -94.0250015258789, -1.64104585581928, 218, 22, 'PPL', 'P'),
(106840, 'Teel Subdivision', 37.1388893127441, 0.648195899041119, -80.3677825927734, -1.40268241877088, 218, 53, 'PPL', 'P'),
(157912, 'Teemes (historical)', 41.4144401550293, 0.722818338575412, -82.8630599975586, -1.446233225235, 218, 41, 'PPL', 'P'),
(167890, 'Teepleville', 41.752498626709, 0.728718571970483, -79.9383316040039, -1.39518708504091, 218, 45, 'PPL', 'P'),
(69342, 'Teer', 35.9602813720703, 0.627625309886211, -79.2305603027344, -1.38283414548263, 218, 33, 'PPL', 'P'),
(179317, 'Tees Toh', 35.499439239502, 0.619582097340981, -110.404998779297, -1.92693073935905, 218, 5, 'PPL', 'P'),
(38507, 'Teetersville', 36.813060760498, 0.642509118007419, -83.3361129760742, -1.45448955724647, 218, 21, 'PPL', 'P'),
(25364, 'Teeterville', 31.1124992370605, 0.54301555021093, -83.1438903808594, -1.45113464006324, 218, 13, 'PPL', 'P'),
(133371, 'Teeterville', 43.4949989318848, 0.759130939512806, -84.416389465332, -1.4733439388159, 218, 27, 'PPL', 'P'),
(123787, 'Tefft', 41.1986083984375, 0.719051363792522, -86.9738922119141, -1.51798078237255, 218, 19, 'PPL', 'P'),
(83980, 'Tega Cay', 35.024169921875, 0.611287082914684, -81.0280609130859, -1.41420644943987, 218, 48, 'PPL', 'P'),
(77425, 'Tegarden', 36.797779083252, 0.642242402424247, -98.9697189331055, -1.72734745515606, 218, 42, 'PPL', 'P'),
(38503, 'Teges', 37.2944412231445, 0.650910792035373, -83.6675033569336, -1.4602734105019, 218, 21, 'PPL', 'P'),
(185581, 'Tehachapi', 35.1322212219238, 0.613172933861596, -118.448059082031, -2.06730862357822, 218, 6, 'PPL', 'P'),
(194004, 'Tehama', 40.0272216796875, 0.698606808736202, -122.122222900391, -2.13143487946624, 218, 6, 'PPL', 'P'),
(121675, 'Teheran', 40.2244415283203, 0.702048944445129, -89.7988891601563, -1.56728628047817, 218, 18, 'PPL', 'P'),
(98448, 'Tehuacana', 31.7411098480225, 0.553986875085189, -96.5466690063477, -1.68505725599393, 218, 51, 'PPL', 'P'),
(197679, 'Teigen', 47.0366706848145, 0.820944772626308, -108.59610748291, -1.89535963042643, 218, 31, 'PPL', 'P'),
(38504, 'Tejay', 36.7636108398438, 0.641646054077151, -83.5622177124023, -1.45843582934975, 218, 21, 'PPL', 'P'),
(189647, 'Tejon', 34.5897216796875, 0.60370453065901, -105.28556060791, -1.83757968741607, 218, 38, 'PPL', 'P'),
(189648, 'Tejon (historical)', 35.3300018310547, 0.61662485668753, -106.364723205566, -1.85641462790955, 218, 38, 'PPL', 'P'),
(143175, 'Tekamah', 41.7783317565918, 0.729169445143033, -96.220832824707, -1.67937034180217, 218, 35, 'PPL', 'P'),
(189650, 'Tekapo', 35.0219383239746, 0.611248134183741, -108.942222595215, -1.90140047872706, 218, 38, 'PPL', 'P'),
(91263, 'Tekoa', 35.9877815246582, 0.628105278093671, -84.0419387817383, -1.46680854150085, 218, 50, 'PPL', 'P'),
(208918, 'Tekoa', 47.223331451416, 0.824202617587802, -117.071113586426, -2.0432763910594, 218, 56, 'PPL', 'P'),
(133372, 'Tekonsha', 42.0933303833008, 0.734667208318365, -84.9858322143555, -1.48328258968797, 218, 27, 'PPL', 'P'),
(143177, 'Telbasta', 41.5816688537598, 0.725737029972084, -96.3858337402344, -1.68225015104693, 218, 35, 'PPL', 'P'),
(98449, 'Telegraph', 30.327220916748, 0.529309857976947, -99.9058303833008, -1.74368568212759, 218, 51, 'PPL', 'P'),
(189649, 'Telegraph (historical)', 32.7788887023926, 0.572099533001522, -108.624168395996, -1.8958493857509, 218, 38, 'PPL', 'P'),
(185582, 'Telegraph City', 37.934440612793, 0.662080888595493, -120.738891601563, -2.1072911936558, 218, 6, 'PPL', 'P'),
(18299, 'Telegraph Estates', 26.7316703796387, 0.466555662682537, -81.6883316040039, -1.42573034695081, 218, 12, 'PPL', 'P'),
(195698, 'Telegraph Hill', 43.0155601501465, 0.750763154209723, -116.746673583984, -2.03761384479162, 218, 17, 'PPL', 'P'),
(106841, 'Telegraph Spring', 39.1049995422363, 0.682510996002899, -77.708610534668, -1.35627111097991, 218, 53, 'PPL', 'P'),
(172632, 'Telemark Village', 43.6686096191406, 0.762161017622071, -72.8047180175781, -1.27068204039278, 218, 55, 'PPL', 'P'),
(98450, 'Telephone', 33.7811088562012, 0.589591574515326, -96.0177764892578, -1.67582634018155, 218, 51, 'PPL', 'P'),
(167891, 'Telescope', 41.7813911437988, 0.729222841522889, -77.7394409179688, -1.35680920267816, 218, 45, 'PPL', 'P'),
(51970, 'Television Hill', 39.332218170166, 0.686476709182136, -76.6502838134766, -1.33779982513328, 218, 25, 'PPL', 'P'),
(25366, 'Telfair Junction', 32.0788917541504, 0.559882281500784, -81.146110534668, -1.41626680401721, 218, 13, 'PPL', 'P'),
(25367, 'Telfair Woods', 33.0933303833008, 0.577587575638876, -81.8238906860352, -1.42809629926324, 218, 13, 'PPL', 'P'),
(98451, 'Telferner', 28.8486099243164, 0.503503227802833, -96.8902816772461, -1.69105442845268, 218, 51, 'PPL', 'P'),
(91264, 'Telford', 36.2488899230957, 0.632662479351014, -82.545280456543, -1.4406869259488, 218, 50, 'PPL', 'P'),
(167892, 'Telford', 40.3219413757324, 0.703750637802663, -75.3283309936523, -1.31472739587133, 218, 45, 'PPL', 'P'),
(208919, 'Telford', 47.6944389343262, 0.832424994295367, -118.406112670898, -2.06657652059455, 218, 56, 'PPL', 'P'),
(98453, 'Telico', 32.371940612793, 0.564996948953308, -96.5122222900391, -1.68445604737784, 218, 51, 'PPL', 'P'),
(12278, 'Telico (historical)', 35.0525016784668, 0.611781565350084, -90.8436126708984, -1.58552014551362, 218, 4, 'PPL', 'P'),
(212185, 'Telida', 63.3838882446289, 1.1062575425849, -153.2822265625, -2.67527953830353, 218, 1, 'PPL', 'P'),
(25368, 'Tell', 33.6513900756836, 0.587327554693623, -84.5944366455078, -1.47645144833386, 218, 13, 'PPL', 'P'),
(176657, 'Tell', 44.3805618286133, 0.774586927794217, -91.8661117553711, -1.60336612113629, 218, 57, 'PPL', 'P'),
(192307, 'Tell', 34.3758316040039, 0.599971444600992, -100.394439697266, -1.75221352341218, 218, 51, 'PPL', 'P'),
(31297, 'Tell City', 37.9513893127441, 0.662376699213573, -86.7677764892578, -1.51438338437208, 218, 19, 'PPL', 'P'),
(91265, 'Tellassee (historical)', 35.5055618286133, 0.61968895667972, -84.0002822875977, -1.46608149852325, 218, 50, 'PPL', 'P'),
(212186, 'Teller', 65.2636108398438, 1.13906489089554, -166.360824584961, -2.9035441353403, 218, 1, 'PPL', 'P'),
(69343, 'Tellico', 35.2755584716797, 0.615674640810589, -83.5277786254883, -1.45783475389171, 218, 33, 'PPL', 'P'),
(91266, 'Tellico Beach', 35.3549995422363, 0.617061149053112, -84.2669372558594, -1.47073550568622, 218, 50, 'PPL', 'P'),
(91267, 'Tellico Hills', 35.464168548584, 0.618966507655009, -84.5869369506836, -1.47632055396628, 218, 50, 'PPL', 'P'),
(91268, 'Tellico Plains', 35.3627815246582, 0.617196970268706, -84.2941665649414, -1.47121074678275, 218, 50, 'PPL', 'P'),
(187430, 'Telluride', 37.9375, 0.662134284975349, -107.811668395996, -1.88166858557845, 218, 7, 'PPL', 'P'),
(195699, 'Telluride', 42.5366706848145, 0.742404956286563, -111.779167175293, -1.95091450234603, 218, 17, 'PPL', 'P'),
(200231, 'Telluride (historical)', 40.5608291625977, 0.707920016226264, -117.186668395996, -2.04529320295291, 218, 39, 'PPL', 'P'),
(208920, 'Telma', 47.8433303833008, 0.835023640308039, -120.814437866211, -2.10860972471149, 218, 56, 'PPL', 'P'),
(201642, 'Telocaset', 45.1011085510254, 0.787162840514762, -117.82527923584, -2.05643906474711, 218, 43, 'PPL', 'P'),
(25369, 'Teloga', 34.560001373291, 0.60318581345769, -85.4097213745117, -1.49068085119621, 218, 13, 'PPL', 'P'),
(18300, 'Telogia', 30.3505592346191, 0.529717188465674, -84.8191680908203, -1.48037375198733, 218, 12, 'PPL', 'P'),
(106842, 'Teman', 37.936939239502, 0.662124497858343, -77.6288909912109, -1.3548797424684, 218, 53, 'PPL', 'P'),
(98452, 'Temco', 30.3597202301025, 0.52987707799962, -94.0666732788086, -1.64177316511298, 218, 51, 'PPL', 'P'),
(185585, 'Temecula', 33.4936103820801, 0.584573779547453, -117.147499084473, -2.04460956950109, 218, 6, 'PPL', 'P'),
(185586, 'Temecula Ranchos', 33.4708290100098, 0.584176169596704, -117.086387634277, -2.04354297348451, 218, 6, 'PPL', 'P'),
(185587, 'Temelec', 38.2666702270508, 0.667879389236922, -122.491668701172, -2.13788292509754, 218, 6, 'PPL', 'P'),
(185588, 'Temescal', 33.7627792358398, 0.58927166228938, -117.484443664551, -2.0504903618202, 218, 6, 'PPL', 'P'),
(69344, 'Temora Lake Estates', 36.2011108398438, 0.631828577034683, -80.2586135864258, -1.40077706016898, 218, 33, 'PPL', 'P'),
(111684, 'Tempa', 37.7249984741211, 0.65842543368325, -80.754997253418, -1.40944058951112, 218, 58, 'PPL', 'P'),
(179318, 'Tempe', 33.4147186279297, 0.583196858684855, -111.90860748291, -1.95317366189875, 218, 5, 'PPL', 'P'),
(179319, 'Tempe Camp', 34.9077796936035, 0.609255690214199, -111.441673278809, -1.94502412264699, 218, 5, 'PPL', 'P'),
(179320, 'Tempe Cascade', 33.4241714477539, 0.583361841514386, -111.886672973633, -1.95279083249205, 218, 5, 'PPL', 'P'),
(179321, 'Tempe Junction', 33.4141693115234, 0.583187271304931, -111.942779541016, -1.95377007682487, 218, 5, 'PPL', 'P'),
(179322, 'Tempe Royal Palms', 33.348331451416, 0.582038183873589, -111.904167175293, -1.95309616391102, 218, 5, 'PPL', 'P'),
(179323, 'Tempe Travel Trailer Villa', 33.413330078125, 0.583172623918935, -111.906112670898, -1.95313011921492, 218, 5, 'PPL', 'P'),
(25370, 'Temperance', 31.889440536499, 0.556575733980855, -83.1463928222656, -1.45117831590512, 218, 13, 'PPL', 'P'),
(38505, 'Temperance', 36.7769393920898, 0.64187868119837, -86.4311065673828, -1.50850738574292, 218, 21, 'PPL', 'P'),
(133374, 'Temperance', 41.7791709899902, 0.729184092529028, -83.5688934326172, -1.45855234264744, 218, 27, 'PPL', 'P'),
(25371, 'Temperance Bell', 33.6761093139648, 0.587758986790215, -83.0480575561523, -1.44946204174061, 218, 13, 'PPL', 'P'),
(91269, 'Temperance Hall', 36.0838890075684, 0.629782670106257, -85.9008331298828, -1.49925236832268, 218, 50, 'PPL', 'P'),
(83981, 'Temperance Hill', 34.2886085510254, 0.598449115142875, -79.379997253418, -1.3854423122962, 218, 48, 'PPL', 'P'),
(12280, 'Temperanceville', 33.9702796936035, 0.592893228476752, -93.8827819824219, -1.63856365652527, 218, 4, 'PPL', 'P'),
(74523, 'Temperanceville', 39.9077796936035, 0.696522152813915, -81.2297210693359, -1.41772608313652, 218, 41, 'PPL', 'P'),
(106843, 'Temperanceville', 37.8927803039551, 0.661353779038874, -75.5475006103516, -1.31855262730306, 218, 53, 'PPL', 'P'),
(61987, 'Temperence Hill (historical)', 33.7916717529297, 0.589775931841787, -88.341667175293, -1.54185295890986, 218, 30, 'PPL', 'P'),
(190824, 'Tempest (historical)', 38.0800018310547, 0.664621411117374, -114.618606567383, -2.00047206864883, 218, 39, 'PPL', 'P'),
(83982, 'Tempie Hill', 34.726390838623, 0.606089857468367, -81.688606262207, -1.42573514064077, 218, 48, 'PPL', 'P'),
(190825, 'Tempiute', 37.6525001525879, 0.657160099270326, -115.63500213623, -2.0182115178279, 218, 39, 'PPL', 'P'),
(12281, 'Temple', 33.582218170166, 0.586120277192462, -93.9905624389648, -1.64044478036125, 218, 4, 'PPL', 'P'),
(25372, 'Temple', 33.7369384765625, 0.588820655958775, -85.0325012207031, -1.48409711750737, 218, 13, 'PPL', 'P'),
(31298, 'Temple', 38.3444404602051, 0.669236735865508, -86.4158325195313, -1.50824080331781, 218, 19, 'PPL', 'P'),
(43307, 'Temple', 31.2780609130859, 0.545905146572694, -92.9552764892578, -1.62237563183922, 218, 22, 'PPL', 'P'),
(77426, 'Temple', 34.2719383239746, 0.598158164793784, -98.2355575561523, -1.71453392188725, 218, 42, 'PPL', 'P'),
(98456, 'Temple', 31.0980606079102, 0.542763548592782, -97.3424987792969, -1.69894710581729, 218, 51, 'PPL', 'P'),
(129055, 'Temple', 44.685001373291, 0.779900400222116, -70.226936340332, -1.22569126272725, 218, 26, 'PPL', 'P'),
(133375, 'Temple', 44.0308303833008, 0.768482962575756, -85.0283279418945, -1.48402428005155, 218, 27, 'PPL', 'P'),
(144546, 'Temple', 42.8180618286133, 0.747316158231806, -71.851936340332, -1.25405286307216, 218, 36, 'PPL', 'P'),
(167894, 'Temple', 40.4086112976074, 0.705263313301828, -75.9219436645508, -1.32508789146006, 218, 45, 'PPL', 'P'),
(198992, 'Temple', 48.3888893127441, 0.844545439890481, -103.055557250977, -1.79865878650706, 218, 34, 'PPL', 'P'),
(57854, 'Temple (historical)', 37.8977813720703, 0.661441064143601, -94.4513931274414, -1.6484877931694, 218, 29, 'PPL', 'P'),
(91270, 'Temple Acres', 36.1002807617188, 0.630068760186359, -83.9252777099609, -1.46477242168943, 218, 50, 'PPL', 'P'),
(185589, 'Temple City', 34.1072196960449, 0.595283282397043, -118.056938171387, -2.06048227591407, 218, 6, 'PPL', 'P'),
(209775, 'Temple Creek Summer Home Area', 42.6672210693359, 0.744683490336208, -109.262496948242, -1.90699032069708, 218, 59, 'PPL', 'P'),
(106844, 'Temple Estates', 37.1599998474121, 0.648564347377932, -77.3247222900391, -1.34957099715143, 218, 53, 'PPL', 'P'),
(25373, 'Temple Grove', 34.9283294677734, 0.609614351434005, -84.7716674804688, -1.47954470993999, 218, 13, 'PPL', 'P'),
(129056, 'Temple Heights', 44.3452796936035, 0.773971138371164, -68.9508285522461, -1.20341898021481, 218, 26, 'PPL', 'P'),
(28765, 'Temple Hill', 37.3072204589844, 0.651133831776668, -88.6302795410156, -1.54689019495369, 218, 18, 'PPL', 'P'),
(38506, 'Temple Hill', 36.8866691589355, 0.643793826917273, -85.8472213745117, -1.49831666667368, 218, 21, 'PPL', 'P'),
(91271, 'Temple Hill', 36.0875015258789, 0.629845720445065, -82.4861068725586, -1.43965415207807, 218, 50, 'PPL', 'P'),
(106845, 'Temple Hill', 36.8786087036133, 0.643653145432689, -82.2758331298828, -1.43598418293789, 218, 53, 'PPL', 'P'),
(118015, 'Temple Hill', 42.225830078125, 0.736979764250936, -90.9761123657227, -1.58783270144619, 218, 16, 'PPL', 'P'),
(51972, 'Temple Hills', 38.8138885498047, 0.677430150696219, -76.9458312988281, -1.34295810184866, 218, 25, 'PPL', 'P'),
(91272, 'Temple Hills Country Club Estates', 36.0269393920898, 0.628788711808412, -86.9472198486328, -1.51751526181401, 218, 50, 'PPL', 'P'),
(51973, 'Temple Hills Park', 38.809440612793, 0.677352519550443, -76.9444427490234, -1.34293386708274, 218, 25, 'PPL', 'P'),
(129057, 'Temple Intervale', 44.7069396972656, 0.780283296207842, -70.258056640625, -1.22623441443157, 218, 26, 'PPL', 'P'),
(18301, 'Temple Terrace', 28.0349998474121, 0.489303053133449, -82.3894424438477, -1.43796703952751, 218, 12, 'PPL', 'P'),
(18302, 'Temple Terrace Junction', 28.0311107635498, 0.489235175815166, -82.3525009155273, -1.4373222882276, 218, 12, 'PPL', 'P'),
(106847, 'Templeman', 38.0705604553223, 0.664456628024925, -76.7752838134766, -1.33998148669827, 218, 53, 'PPL', 'P'),
(57855, 'Temples Corner', 36.0305595397949, 0.628851895305274, -89.9588928222656, -1.57007887119723, 218, 29, 'PPL', 'P'),
(91273, 'Templeton', 36.1566696166992, 0.631052931367198, -89.228889465332, -1.55733790906813, 218, 50, 'PPL', 'P'),
(106848, 'Templeton', 37.082218170166, 0.647206801012264, -77.3552780151367, -1.35010429515972, 218, 53, 'PPL', 'P'),
(118016, 'Templeton', 41.9183311462402, 0.731612895443181, -94.942497253418, -1.65705917713782, 218, 16, 'PPL', 'P'),
(123788, 'Templeton', 40.5127792358398, 0.707081386798998, -87.2077789306641, -1.52206287569143, 218, 19, 'PPL', 'P'),
(126322, 'Templeton', 42.5555610656738, 0.742734655629515, -72.0680618286133, -1.25782496444015, 218, 23, 'PPL', 'P'),
(167897, 'Templeton', 40.9172210693359, 0.714140228426307, -79.4611129760742, -1.38685804873169, 218, 45, 'PPL', 'P'),
(185590, 'Templeton', 35.5497207641602, 0.620459675499189, -120.705001831055, -2.10669970557769, 218, 6, 'PPL', 'P'),
(201643, 'Templeton', 43.5458297729492, 0.760018105050939, -124.098609924316, -2.16592934032743, 218, 43, 'PPL', 'P'),
(106849, 'Templeton Acres', 38.1208305358887, 0.665334006446052, -78.4583282470703, -1.36935615352185, 218, 53, 'PPL', 'P'),
(126323, 'Templeton Station', 42.5591697692871, 0.742797639389296, -72.0819396972656, -1.25806717894129, 218, 23, 'PPL', 'P'),
(51974, 'Templeville', 39.1361083984375, 0.683053947970139, -75.7663879394531, -1.32237293188678, 218, 25, 'PPL', 'P'),
(91274, 'Templow', 36.4358291625977, 0.635925184581497, -86.2369384765625, -1.5051185132558, 218, 50, 'PPL', 'P'),
(25374, 'Tempy', 31.4486103057861, 0.548881795012589, -83.817497253418, -1.46289129785345, 218, 13, 'PPL', 'P'),
(198993, 'Temvik', 46.3697204589844, 0.809304295238654, -100.258056640625, -1.74983319002987, 218, 34, 'PPL', 'P'),
(98454, 'Ten Acres Colonia', 26.30299949646, 0.459073944363637, -97.9889984130859, -1.71023065303985, 218, 51, 'PPL', 'P'),
(6265, 'Ten Broeck', 34.417781829834, 0.600703614163682, -85.9869384765625, -1.50075519012581, 218, 2, 'PPL', 'P'),
(38508, 'Ten Broeck', 38.2969398498535, 0.668407693818167, -85.5811080932617, -1.49367211373258, 218, 21, 'PPL', 'P'),
(57857, 'Ten Brook', 38.4336090087891, 0.670793020627523, -90.3499984741211, -1.57690495254527, 218, 29, 'PPL', 'P'),
(129059, 'Ten Degree', 44.792781829834, 0.781781524058093, -70.710563659668, -1.23413215180226, 218, 26, 'PPL', 'P'),
(51975, 'Ten Hills', 39.2841682434082, 0.68563807975487, -76.7013931274414, -1.3386918509404, 218, 25, 'PPL', 'P'),
(126325, 'Ten Hills', 42.396671295166, 0.739961505986416, -71.0875015258789, -1.24071095864308, 218, 23, 'PPL', 'P'),
(6267, 'Ten Islands', 33.8027801513672, 0.589969809969145, -86.0366668701172, -1.50162311432507, 218, 2, 'PPL', 'P'),
(61989, 'Ten Mile', 30.7652797698975, 0.536955427281914, -89.1436080932617, -1.55584946833488, 218, 30, 'PPL', 'P'),
(83983, 'Ten Mile', 32.8872184753418, 0.573990244217424, -79.7441711425781, -1.39179834571184, 218, 48, 'PPL', 'P'),
(91276, 'Ten Mile', 35.6666717529297, 0.622500855316681, -84.6647186279297, -1.47767810033195, 218, 50, 'PPL', 'P'),
(139478, 'Ten Mile', 40.0774993896484, 0.699484320315383, -91.6430587768555, -1.59947311225482, 218, 29, 'PPL', 'P'),
(167898, 'Ten Mile', 40.0205612182617, 0.69849056175462, -80.1566696166992, -1.3989978022447, 218, 45, 'PPL', 'P'),
(146440, 'Ten Mile Run', 40.413890838623, 0.705355458675545, -74.5736083984375, -1.30155500164563, 218, 37, 'PPL', 'P'),
(51976, 'Ten Oaks', 39.4575004577637, 0.688663297595146, -77.3091735839844, -1.34929962103635, 218, 25, 'PPL', 'P'),
(209774, 'Ten Sleep', 44.0341682434082, 0.768541219224601, -107.450561523438, -1.87536608170072, 218, 59, 'PPL', 'P'),
(38509, 'Ten Spot', 36.8436088562012, 0.643042282857652, -83.2172164916992, -1.45241442212508, 218, 21, 'PPL', 'P'),
(200233, 'Tenabo', 40.3144416809082, 0.703619743435085, -116.675827026367, -2.03637733909749, 218, 39, 'PPL', 'P'),
(146441, 'Tenafly', 40.9252815246582, 0.714280909910891, -73.9633331298828, -1.29090368886586, 218, 37, 'PPL', 'P'),
(98455, 'Tenaha', 31.9436092376709, 0.557521156167833, -94.2438888549805, -1.644866160403, 218, 51, 'PPL', 'P'),
(193314, 'Tenakee Springs', 57.7808303833008, 1.00846573472498, -135.218887329102, -2.36001479477606, 218, 1, 'PPL', 'P'),
(129060, 'Tenants Harbor', 43.9672203063965, 0.767372757296329, -69.208610534668, -1.20791812456039, 218, 26, 'PPL', 'P'),
(153078, 'Tenantville', 43.2844390869141, 0.755455976945578, -74.1158294677734, -1.29356525205928, 218, 40, 'PPL', 'P'),
(14715, 'Tenby Chase', 39.7680587768555, 0.694083562782757, -75.7291717529297, -1.32172338689691, 218, 10, 'PPL', 'P'),
(91277, 'Tench', 36.3458290100098, 0.634354385591541, -84.9180603027344, -1.48209974668981, 218, 50, 'PPL', 'P'),
(43309, 'Tendal', 32.4322204589844, 0.566049030741944, -91.3666687011719, -1.5946491954143, 218, 22, 'PPL', 'P'),
(18303, 'Tendil Crossing', 30.9638900756836, 0.540421831046275, -85.579719543457, -1.49364787896666, 218, 12, 'PPL', 'P'),
(195700, 'Tendoy', 44.9594383239746, 0.784690228600678, -113.643890380859, -1.98346006192151, 218, 17, 'PPL', 'P'),
(98457, 'Teneryville', 32.5372200012207, 0.567881618467055, -94.8077774047852, -1.65470787221139, 218, 51, 'PPL', 'P'),
(18304, 'Tenile', 30.7313899993896, 0.536363939203808, -87.4644393920898, -1.526542445803, 218, 12, 'PPL', 'P'),
(208921, 'Tenino', 46.8569412231445, 0.817807901757331, -122.851669311523, -2.14416612105736, 218, 56, 'PPL', 'P'),
(77427, 'Tenkiller', 35.8005599975586, 0.624837646015171, -94.8636093139648, -1.65568232285425, 218, 42, 'PPL', 'P'),
(13218, 'Tenleytown', 38.9494400024414, 0.679795969850591, -77.0861129760742, -1.34540647899682, 218, 9, 'PPL', 'P'),
(43308, 'Tenmile', 30.7661094665527, 0.536969908220341, -92.904167175293, -1.6214836060321, 218, 22, 'PPL', 'P'),
(83984, 'Tenmile', 32.898609161377, 0.574189049192798, -80.0177764892578, -1.39657365986246, 218, 48, 'PPL', 'P'),
(111685, 'Tenmile', 38.8738899230957, 0.678477372215865, -80.1897201538086, -1.39957464293681, 218, 58, 'PPL', 'P'),
(118017, 'Tenmile', 41.9455604553223, 0.732088136539705, -90.3338928222656, -1.57662385589221, 218, 16, 'PPL', 'P'),
(192308, 'Tenmile', 32.5977783203125, 0.56893856052468, -101.915000915527, -1.77875232314899, 218, 51, 'PPL', 'P'),
(201645, 'Tenmile', 43.0963897705078, 0.752173897218165, -123.563056945801, -2.15658217753347, 218, 43, 'PPL', 'P'),
(209776, 'Tenmile', 41.3527793884277, 0.721742155178911, -106.534439086914, -1.85937672883199, 218, 59, 'PPL', 'P'),
(194006, 'Tenmile (historical)', 40.0711097717285, 0.699372800444736, -121.949440002441, -2.12841924900588, 218, 6, 'PPL', 'P'),
(18305, 'Tenmile Corner', 25.6155605316162, 0.447075871020612, -80.8574981689453, -1.41122956797338, 218, 12, 'PPL', 'P'),
(138414, 'Tenmile Corner', 43.9786109924316, 0.767571562271703, -94.4288864135742, -1.64809497690861, 218, 28, 'PPL', 'P'),
(98459, 'Tenmile Crossing', 30.8836097717285, 0.539020675417757, -99.6297225952148, -1.73886669213509, 218, 51, 'PPL', 'P'),
(69346, 'Tenmile Fork', 35.0561103820801, 0.611844549109865, -77.2063903808594, -1.34750571572608, 218, 33, 'PPL', 'P'),
(195701, 'Tenmile Summer Home Area', 43.8972206115723, 0.766151032146255, -115.71305847168, -2.01957385788353, 218, 17, 'PPL', 'P'),
(51977, 'Tenn Wood Acres', 38.4005584716797, 0.670216179935412, -76.7247161865234, -1.33909891511302, 218, 25, 'PPL', 'P'),
(6268, 'Tennala', 34.0977783203125, 0.595118499304595, -85.6744384765625, -1.49530103621333, 218, 2, 'PPL', 'P'),
(153079, 'Tennanah Lake', 41.8950004577637, 0.731205698112508, -74.976936340332, -1.30859440219698, 218, 40, 'PPL', 'P'),
(6269, 'Tennant', 33.2680587768555, 0.580637161403125, -85.4569396972656, -1.49150496639553, 218, 2, 'PPL', 'P'),
(118018, 'Tennant', 41.5936088562012, 0.725945422327383, -95.4408264160156, -1.66575666178385, 218, 16, 'PPL', 'P'),
(194007, 'Tennant', 41.5838890075684, 0.725775778965945, -121.912216186523, -2.12776957085796, 218, 6, 'PPL', 'P'),
(43310, 'Tennant (historical)', 30.8872203826904, 0.539083692467051, -93.1952819824219, -1.62656451791781, 218, 22, 'PPL', 'P'),
(185591, 'Tennant (historical)', 37.1150016784668, 0.647778981172467, -121.633888244629, -2.1229118318716, 218, 6, 'PPL', 'P'),
(91281, 'Tennemo', 36.160831451416, 0.631125569085929, -89.5688934326172, -1.5632720977671, 218, 50, 'PPL', 'P'),
(146443, 'Tennent', 40.2794418334961, 0.703008880860048, -74.334716796875, -1.297385556643, 218, 37, 'PPL', 'P'),
(111686, 'Tennerton', 38.9633293151855, 0.680038384088815, -80.2241668701172, -1.4001758515529, 218, 58, 'PPL', 'P'),
(12282, 'Tennessee', 33.6311111450195, 0.586973620584751, -91.8486099243164, -1.60306065655926, 218, 4, 'PPL', 'P'),
(91283, 'Tennessee', 35.7502784729004, 0.623960067856962, -86.2502822875977, -1.50535140669313, 218, 50, 'ADM1', 'A'),
(98460, 'Tennessee', 31.9564094543457, 0.557744562093777, -94.318000793457, -1.64615965774445, 218, 51, 'PPL', 'P'),
(121680, 'Tennessee', 40.4119415283203, 0.705321436792619, -90.8391723632813, -1.5854426475259, 218, 18, 'PPL', 'P'),
(91278, 'Tennessee (historical)', 35.5499992370605, 0.620464535768179, -84.1313934326172, -1.4683698196899, 218, 50, 'PPL', 'P'),
(91279, 'Tennessee City', 36.0930595397949, 0.629942726087771, -87.5147171020508, -1.52741995738218, 218, 50, 'PPL', 'P'),
(98461, 'Tennessee Colony', 31.8352794647217, 0.555630444951931, -95.8386077880859, -1.67269925642958, 218, 51, 'PPL', 'P'),
(91280, 'Tennessee Hills', 36.5361099243164, 0.637675414049898, -82.2399978637695, -1.43535873955588, 218, 50, 'PPL', 'P'),
(91284, 'Tennessee Ridge', 36.311939239502, 0.633762897513435, -87.7733306884766, -1.5319336159557, 218, 50, 'PPL', 'P'),
(91282, 'Tennessee Towne (historical)', 36.0950012207031, 0.629976614812642, -86.9252777099609, -1.51713229924925, 218, 50, 'PPL', 'P'),
(138415, 'Tenney', 46.0444412231445, 0.803627101584877, -96.4530563354492, -1.68342340666517, 218, 28, 'PPL', 'P'),
(69347, 'Tenney Circle', 35.9208297729492, 0.626936749586371, -79.0449981689453, -1.37959547528098, 218, 33, 'PPL', 'P'),
(211106, 'Tenney Village', 21.3425006866455, 0.372496907591115, -158.044723510742, -2.75840079066654, 218, 15, 'PPL', 'P'),
(126326, 'Tenneyville', 42.1513900756836, 0.735680541113141, -72.3138885498047, -1.26211545011432, 218, 23, 'PPL', 'P'),
(25375, 'Tennga', 34.9866714477539, 0.610632611076797, -84.7386093139648, -1.47896773608982, 218, 13, 'PPL', 'P'),
(6270, 'Tennille', 31.6230602264404, 0.551926520507849, -85.7686080932617, -1.49694460608007, 218, 2, 'PPL', 'P'),
(18306, 'Tennille', 29.7777805328369, 0.519720314234276, -83.3261108398438, -1.45431498703701, 218, 12, 'PPL', 'P'),
(25376, 'Tennille', 32.9358291625977, 0.574838660761696, -82.8116683959961, -1.44533627257986, 218, 13, 'PPL', 'P'),
(187929, 'Tennis', 38.163330078125, 0.666075763388666, -100.91056060791, -1.76122153264132, 218, 20, 'PPL', 'P'),
(31300, 'Tennyson', 38.082218170166, 0.664660093532207, -87.1183319091797, -1.52050173066042, 218, 19, 'PPL', 'P'),
(74524, 'Tennyson', 39.0544395446777, 0.681628557575702, -83.1224975585938, -1.45076126487841, 218, 41, 'PPL', 'P'),
(176668, 'Tennyson', 42.689998626709, 0.745081033707929, -90.6849975585938, -1.58275178956048, 218, 57, 'PPL', 'P'),
(192309, 'Tennyson', 31.7416706085205, 0.553996662202195, -100.285827636719, -1.75031788534827, 218, 51, 'PPL', 'P'),
(43311, 'Tensas', 32.0499992370605, 0.559378011948377, -91.2502822875977, -1.59261786929284, 218, 22, 'PPL', 'P'),
(43314, 'Tensas Bluff', 32.1616706848145, 0.561327046392152, -91.4055633544922, -1.59532803517616, 218, 22, 'PPL', 'P'),
(43312, 'Tensas Bluff Landing', 32.1647186279297, 0.561380243034926, -91.404167175293, -1.59530366725219, 218, 22, 'PPL', 'P'),
(6271, 'Tensaw', 31.1566696166992, 0.543786468767481, -87.7991714477539, -1.5323846222863, 218, 2, 'PPL', 'P'),
(195702, 'Tensed', 47.1599998474121, 0.823097272577365, -116.920829772949, -2.04065344370178, 218, 17, 'PPL', 'P'),
(106851, 'Tenso', 37.1575012207031, 0.648520738115082, -82.3311080932617, -1.43694891304277, 218, 53, 'PPL', 'P'),
(138417, 'Tenstrike', 47.6566696166992, 0.831765795346545, -94.6744384765625, -1.65238066889282, 218, 28, 'PPL', 'P'),
(14716, 'Tent', 39.3572196960449, 0.686913068126746, -75.6063919067383, -1.31958047432578, 218, 10, 'PPL', 'P'),
(133376, 'Tent City', 44.5011100769043, 0.776690891634407, -84.8230590820313, -1.48044166259512, 218, 27, 'PPL', 'P'),
(185592, 'Tent City (historical)', 32.6769409179688, 0.570320208498213, -117.172782897949, -2.04505085529372, 218, 6, 'PPL', 'P'),
(106852, 'Tenth Legion', 38.577220916748, 0.673299521266479, -78.7316665649414, -1.37412680714056, 218, 53, 'PPL', 'P'),
(118019, 'Tenville', 41.0086097717285, 0.715735262182183, -94.991943359375, -1.65792217448906, 218, 16, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(61990, 'Teoc', 33.5791702270508, 0.586067080549688, -90.0552825927734, -1.57176119005783, 218, 30, 'PPL', 'P'),
(43315, 'Tepetate', 30.4141693115234, 0.530827393745101, -92.5524978637695, -1.6153458186678, 218, 22, 'PPL', 'P'),
(18307, 'Tequesta', 26.9677791595459, 0.470676538284785, -80.1288909912109, -1.39851297376825, 218, 12, 'PPL', 'P'),
(187431, 'Tercio', 37.0519409179688, 0.646678363272965, -104.996109008789, -1.83252780398625, 218, 7, 'PPL', 'P'),
(189652, 'Tererro', 35.7419395446777, 0.623814526103389, -105.674438476563, -1.8443668866122, 218, 38, 'PPL', 'P'),
(6275, 'Terese', 31.8047199249268, 0.555097080364616, -85.1638870239258, -1.48639023236398, 218, 2, 'PPL', 'P'),
(185595, 'Terese (historical)', 35.5669403076172, 0.620760213228205, -117.778327941895, -2.0556196100797, 218, 6, 'PPL', 'P'),
(38510, 'Teresita', 38.3927803039551, 0.670080425298845, -84.7761077880859, -1.47962220792771, 218, 21, 'PPL', 'P'),
(57859, 'Teresita', 36.9847183227539, 0.64550510765473, -91.6286087036133, -1.59922091089958, 218, 29, 'PPL', 'P'),
(69348, 'Teresita', 35.1027793884277, 0.612659076929265, -83.4505615234375, -1.45648706122208, 218, 33, 'PPL', 'P'),
(77428, 'Teresita', 36.1094398498535, 0.630228616430791, -94.9925003051758, -1.65793189502704, 218, 42, 'PPL', 'P'),
(123789, 'Terhune', 40.1652793884277, 0.701016370311478, -86.2802810668945, -1.50587498416344, 218, 19, 'PPL', 'P'),
(192310, 'Terlingua', 29.3213901519775, 0.511754799413849, -103.615562438965, -1.8084327208657, 218, 51, 'PPL', 'P'),
(192311, 'Terlingua Abaja', 29.1933307647705, 0.509519741469, -103.606941223145, -1.80828225226411, 218, 51, 'PPL', 'P'),
(77429, 'Terlton', 36.188060760498, 0.631600810182454, -96.4899978637695, -1.68406815796507, 218, 42, 'PPL', 'P'),
(206052, 'Terminal', 40.7558288574219, 0.71132340294133, -112.008613586426, -1.95491909767718, 218, 52, 'PPL', 'P'),
(201646, 'Terminal City', 42.2666702270508, 0.737692559316695, -121.809997558594, -2.12598551924372, 218, 43, 'PPL', 'P'),
(157913, 'Terminal Junction', 40.1083297729492, 0.700022412013634, -80.7102813720703, -1.40866015015367, 218, 41, 'PPL', 'P'),
(185596, 'Terminous', 38.1133308410645, 0.665203112078474, -121.494438171387, -2.12047796895138, 218, 6, 'PPL', 'P'),
(194008, 'Termo', 40.8658294677734, 0.713243275771168, -120.459167480469, -2.10240908674546, 218, 6, 'PPL', 'P'),
(157914, 'Termway Trailer Court', 41.5774993896484, 0.725664259095298, -83.5997161865234, -1.45909030118763, 218, 41, 'PPL', 'P'),
(185598, 'Ternez (historical)', 34.2724990844727, 0.59816795191079, -118.934440612793, -2.0757975827109, 218, 6, 'PPL', 'P'),
(153080, 'Terpening Corners', 42.538330078125, 0.742433918163418, -76.4930572509766, -1.33505570394606, 218, 40, 'PPL', 'P'),
(206053, 'Terra', 40.3213882446289, 0.703740983843711, -112.625831604004, -1.96569158428655, 218, 52, 'PPL', 'P'),
(111687, 'Terra Alta', 39.4455604553223, 0.688454905239847, -79.5466690063477, -1.38835128315489, 218, 58, 'PPL', 'P'),
(185599, 'Terra Bella', 35.9625015258789, 0.627664058880072, -119.043327331543, -2.07769801446478, 218, 6, 'PPL', 'P'),
(18308, 'Terra Ceia', 27.5791702270508, 0.481347325430028, -82.5805587768555, -1.44130264879283, 218, 12, 'PPL', 'P'),
(69349, 'Terra Ceia', 35.6011085510254, 0.621356561575301, -76.7652816772461, -1.33980691648882, 218, 33, 'PPL', 'P'),
(13219, 'Terra Cotta', 38.9536094665527, 0.679868740727377, -76.9986114501953, -1.34387928926971, 218, 9, 'PPL', 'P'),
(25377, 'Terra Cotta', 32.7936096191406, 0.572356461467688, -83.642219543457, -1.45983212470927, 218, 13, 'PPL', 'P'),
(34121, 'Terra Cotta', 38.7416687011719, 0.676169676552284, -97.9569396972656, -1.70967112289482, 218, 20, 'PPL', 'P'),
(69350, 'Terra Cotta', 36.0636100769043, 0.629428735997385, -79.8675003051758, -1.39395084566289, 218, 33, 'PPL', 'P'),
(121677, 'Terra Cotta', 42.2816696166992, 0.73795434805185, -88.3005599975586, -1.54113550331219, 218, 18, 'PPL', 'P'),
(185600, 'Terra Cotta', 33.7030601501465, 0.588229367617751, -117.373893737793, -2.04856090161044, 218, 6, 'PPL', 'P'),
(25378, 'Terra Haute', 30.7861099243164, 0.537318982060224, -81.6947174072266, -1.42584180024243, 218, 13, 'PPL', 'P'),
(43316, 'Terra Haute', 30.3724994659424, 0.530100117740914, -91.0833282470703, -1.58970397158613, 218, 22, 'PPL', 'P'),
(34120, 'Terra Heights', 38.9766693115234, 0.680271210947115, -95.6830596923828, -1.66998443001435, 218, 20, 'PPL', 'P'),
(185601, 'Terra Linda', 38.0041694641113, 0.663297886634632, -122.548606872559, -2.1388766836583, 218, 6, 'PPL', 'P'),
(185602, 'Terra Lindo', 38.0116691589355, 0.663428781002209, -122.54167175293, -2.13875564298675, 218, 6, 'PPL', 'P'),
(18309, 'Terra Mana', 27.5244407653809, 0.480392116126044, -82.60888671875, -1.4417970646492, 218, 12, 'PPL', 'P'),
(18310, 'Terra Mar', 26.2158298492432, 0.457552547011902, -80.0955581665039, -1.39793120622813, 218, 12, 'PPL', 'P'),
(83985, 'Terra Oaks', 34.8736114501953, 0.608659341867103, -82.3125, -1.43662414054783, 218, 48, 'PPL', 'P'),
(74526, 'Terrace', 39.9563903808594, 0.697370569358187, -82.0136108398438, -1.43140754060459, 218, 41, 'PPL', 'P'),
(98462, 'Terrace', 33.6811103820801, 0.587846271894943, -96.4513931274414, -1.68339437820928, 218, 51, 'PPL', 'P'),
(113145, 'Terrace', 45.5099983215332, 0.794299313287847, -95.3197174072266, -1.66364291082666, 218, 28, 'PPL', 'P'),
(167899, 'Terrace', 40.3908309936523, 0.704952988455806, -79.8897171020508, -1.39433860191761, 218, 45, 'PPL', 'P'),
(25379, 'Terrace (historical)', 31.2944393157959, 0.5461910036262, -83.9974975585938, -1.46603289583336, 218, 13, 'PPL', 'P'),
(123790, 'Terrace Bay', 40.7150001525879, 0.710610807612652, -86.7461090087891, -1.51400521549728, 218, 19, 'PPL', 'P'),
(206058, 'Terrace Falls Condominium', 40.7730598449707, 0.711624140407428, -111.917221069336, -1.95332399734228, 218, 52, 'PPL', 'P'),
(51978, 'Terrace Gardens', 39.0402793884277, 0.681381416226542, -76.5111083984375, -1.33537075590302, 218, 25, 'PPL', 'P'),
(69351, 'Terrace Gardens', 35.3388900756836, 0.616779985821027, -82.4822235107422, -1.43958637462833, 218, 33, 'PPL', 'P'),
(153081, 'Terrace Heights', 40.7213897705078, 0.710722327483299, -73.7697219848633, -1.28752453691671, 218, 40, 'PPL', 'P'),
(208922, 'Terrace Heights', 46.6063919067383, 0.813434991247421, -120.438606262207, -2.10205022578857, 218, 56, 'PPL', 'P'),
(167900, 'Terrace Hill', 40.2433280944824, 0.702378577209054, -75.5883331298828, -1.31926528921077, 218, 45, 'PPL', 'P'),
(51979, 'Terrace Hills', 39.6680603027344, 0.692338260162373, -77.7024993896484, -1.35616445137825, 218, 25, 'PPL', 'P'),
(25380, 'Terrace Manor', 33.4336090087891, 0.583526558027807, -82.0622177124023, -1.43225589056983, 218, 13, 'PPL', 'P'),
(118020, 'Terrace Manor Mobile Home Court', 42.0063896179199, 0.733149805708265, -92.7841720581055, -1.61938929615086, 218, 16, 'PPL', 'P'),
(143178, 'Terrace Mobile Home Park', 40.3875007629395, 0.704894864965015, -95.8544387817383, -1.67297555939268, 218, 35, 'PPL', 'P'),
(74527, 'Terrace Park', 39.1591682434082, 0.683456418189877, -84.3072204589844, -1.471438580214, 218, 41, 'PPL', 'P'),
(153082, 'Terrace Park', 44.5980606079102, 0.778382997612016, -75.6352767944336, -1.32008461072013, 218, 40, 'PPL', 'P'),
(208923, 'Terrace Park', 47.4049987792969, 0.827373310602623, -120.256393432617, -2.09887001197286, 218, 56, 'PPL', 'P'),
(91285, 'Terrace View', 35.7508316040039, 0.623969721815914, -84.7255630493164, -1.47874003581662, 218, 50, 'PPL', 'P'),
(51980, 'Terrace View Estates', 39.2183303833008, 0.684488992323528, -76.6308288574219, -1.3374602720943, 218, 25, 'PPL', 'P'),
(206060, 'Terraces Mount Olympus Condominium', 40.6652793884277, 0.70974301657145, -111.808326721191, -1.95142343243035, 218, 52, 'PPL', 'P'),
(77430, 'Terral', 33.896671295166, 0.591608519566898, -97.9361114501953, -1.70930760140603, 218, 42, 'PPL', 'P'),
(98463, 'Terramar Beach', 29.1355590820313, 0.508511435390782, -95.0602798461914, -1.65911487118325, 218, 51, 'PPL', 'P'),
(114155, 'Terramuggus', 41.6349983215332, 0.726667804773067, -72.470832824707, -1.26485464445352, 218, 8, 'PPL', 'P'),
(38511, 'Terrapin', 37.8841705322266, 0.661203510174366, -84.938606262207, -1.48245834133059, 218, 21, 'PPL', 'P'),
(83987, 'Terrapin Crossroads', 34.8305587768555, 0.607907930965537, -82.7774963378906, -1.44473985765374, 218, 48, 'PPL', 'P'),
(136, 'Terrapin Forest', 38.6622200012207, 0.674783035151707, -77.397216796875, -1.35083626498533, 218, 53, 'PPL', 'P'),
(202677, 'Terraville', 44.3622207641602, 0.77426681583119, -103.764167785645, -1.81102637345133, 218, 49, 'PPL', 'P'),
(123791, 'Terre Coupee', 41.702220916748, 0.727841060391301, -86.4772186279297, -1.50931219302435, 218, 19, 'PPL', 'P'),
(57860, 'Terre Du Lac', 37.9116706848145, 0.661683478381826, -90.6252822875977, -1.58170956146788, 218, 29, 'PPL', 'P'),
(106853, 'Terre Grande', 38.7313919067383, 0.675990312652868, -77.2044372558594, -1.34747162726412, 218, 53, 'PPL', 'P'),
(31301, 'Terre Haute', 39.4666709899902, 0.68882335357666, -87.4138870239258, -1.52566014053385, 218, 19, 'PPL', 'P'),
(118021, 'Terre Haute', 40.6833305358887, 0.710058068528406, -93.8663864135742, -1.63827749986614, 218, 16, 'PPL', 'P'),
(121678, 'Terre Haute', 40.666389465332, 0.70976239106838, -90.9811096191406, -1.58791991997189, 218, 18, 'PPL', 'P'),
(139479, 'Terre Haute', 40.4394416809082, 0.705801405000078, -93.23388671875, -1.6272382976736, 218, 29, 'PPL', 'P'),
(157915, 'Terre Haute', 40.0494384765625, 0.698994564990918, -83.878059387207, -1.4639483064901, 218, 41, 'PPL', 'P'),
(167901, 'Terre Hill', 40.1572189331055, 0.700875688826895, -76.0508270263672, -1.3273373304748, 218, 45, 'PPL', 'P'),
(491, 'Terre Town', 39.5175018310547, 0.689710519114792, -87.3752822875977, -1.52498636077806, 218, 19, 'PPL', 'P'),
(51981, 'Terre Verde', 38.7013893127441, 0.675466668603531, -76.5877838134766, -1.33670899435078, 218, 25, 'PPL', 'P'),
(138419, 'Terrebonne', 47.8325004577637, 0.834834622449671, -96.133056640625, -1.67783835838511, 218, 28, 'PPL', 'P'),
(201647, 'Terrebonne', 44.3530616760254, 0.774106959586758, -121.176666259766, -2.11493180282323, 218, 43, 'PPL', 'P'),
(18311, 'Terrell', 28.5602798461914, 0.49847091860702, -82.1627807617188, -1.43401104688625, 218, 12, 'PPL', 'P'),
(25382, 'Terrell', 31.6177806854248, 0.551834375134132, -83.7452774047852, -1.46163082370951, 218, 13, 'PPL', 'P'),
(57861, 'Terrell', 37.0827789306641, 0.64721658812927, -93.4188919067383, -1.63046724733727, 218, 29, 'PPL', 'P'),
(61993, 'Terrell', 31.5991706848145, 0.551509569349684, -89.7316665649414, -1.56611302485994, 218, 30, 'PPL', 'P'),
(69352, 'Terrell', 35.589168548584, 0.621148169220002, -80.9783325195313, -1.41333852524062, 218, 33, 'PPL', 'P'),
(91286, 'Terrell', 36.3849983215332, 0.635038019043365, -88.9438934326172, -1.55236378994213, 218, 50, 'PPL', 'P'),
(98464, 'Terrell', 32.7358283996582, 0.571347988941902, -96.2750015258789, -1.68031576398915, 218, 51, 'PPL', 'P'),
(206061, 'Terrell', 40.621940612793, 0.70898661224284, -111.887496948242, -1.95280521356193, 218, 52, 'PPL', 'P'),
(83986, 'Terrell Crossroad', 33.8450012207031, 0.59070670664277, -79.878059387207, -1.39413513641033, 218, 48, 'PPL', 'P'),
(98465, 'Terrell Hills', 29.4747200012207, 0.514430910124728, -98.4505615234375, -1.71828644902123, 218, 51, 'PPL', 'P'),
(25385, 'Terrell Mill Estates', 33.9205589294434, 0.59202543743555, -84.459716796875, -1.47410014340743, 218, 13, 'PPL', 'P'),
(106854, 'Terrell Store', 37.9233283996582, 0.661886943889108, -77.6594390869141, -1.35541290731863, 218, 53, 'PPL', 'P'),
(98466, 'Terrell Wells', 29.3394393920898, 0.512069818081291, -98.5155563354492, -1.71942082248755, 218, 51, 'PPL', 'P'),
(69353, 'Terrells', 35.8202781677246, 0.625181793007036, -79.230827331543, -1.38283880601454, 218, 33, 'PPL', 'P'),
(61994, 'Terrells (historical)', 33.7591705322266, 0.5892086785296, -88.6258316040039, -1.54681256380792, 218, 30, 'PPL', 'P'),
(61995, 'Terrene Landing', 33.8905601501465, 0.59150185996524, -91.040283203125, -1.58895269384262, 218, 30, 'PPL', 'P'),
(71470, 'Terrestria', 39.7633285522461, 0.694001004788964, -75.033332824707, -1.30957870653588, 218, 37, 'PPL', 'P'),
(195703, 'Terreton', 43.8416709899902, 0.765181508351412, -112.435562133789, -1.96237075556528, 218, 17, 'PPL', 'P'),
(118022, 'Terril', 43.3058280944824, 0.75582928555138, -94.9713897705078, -1.65756344669022, 218, 16, 'PPL', 'P'),
(38512, 'Terrill', 37.6861114501953, 0.657746727079443, -84.2591705322266, -1.47059995078674, 218, 21, 'PPL', 'P'),
(43318, 'Terrills', 32.6630592346191, 0.570077927418043, -92.3736114501953, -1.61222366176384, 218, 22, 'PPL', 'P'),
(12285, 'Terry', 34.0783309936523, 0.594779079423664, -91.8580627441406, -1.60322563938879, 218, 4, 'PPL', 'P'),
(31302, 'Terry', 38.0872192382813, 0.664747378636935, -86.633056640625, -1.51203207944564, 218, 19, 'PPL', 'P'),
(43319, 'Terry', 32.9294395446777, 0.574727140891049, -91.3486099243164, -1.59433401029929, 218, 22, 'PPL', 'P'),
(57863, 'Terry', 36.276668548584, 0.633147307827463, -89.7605590820313, -1.56661729441234, 218, 29, 'PPL', 'P'),
(61996, 'Terry', 32.0961112976074, 0.560182819229799, -90.2941665649414, -1.57593050190241, 218, 30, 'PPL', 'P'),
(91287, 'Terry', 35.9027786254883, 0.626621697629415, -88.57861328125, -1.54598844860859, 218, 50, 'PPL', 'P'),
(98467, 'Terry', 30.0994396209717, 0.52533432439119, -93.932502746582, -1.63943144756647, 218, 51, 'PPL', 'P'),
(111688, 'Terry', 37.8608283996582, 0.660796113106611, -81.0991668701172, -1.41544748250785, 218, 58, 'PPL', 'P'),
(197680, 'Terry', 46.7930603027344, 0.816692969366969, -105.311668395996, -1.83803535427859, 218, 31, 'PPL', 'P'),
(202678, 'Terry', 44.333610534668, 0.7737674731268, -103.816390991211, -1.81193784033441, 218, 49, 'PPL', 'P'),
(83989, 'Terry (historical)', 35.1238899230957, 0.613027525266078, -82.4558334350586, -1.4391257809178, 218, 48, 'PPL', 'P'),
(98468, 'Terry Chapel', 31.0529804229736, 0.541976750938231, -97.0930862426758, -1.6945940358575, 218, 51, 'PPL', 'P'),
(83988, 'Terry Creek', 35.1302795410156, 0.613139045136725, -82.4497222900391, -1.43901912131614, 218, 48, 'PPL', 'P'),
(91289, 'Terry Creek', 36.4386100769043, 0.635973720692364, -84.3116683959961, -1.47151621135978, 218, 50, 'PPL', 'P'),
(6277, 'Terry Crossroads', 31.1063899993896, 0.542908923898786, -85.2863922119141, -1.48852835124515, 218, 2, 'PPL', 'P'),
(91288, 'Terry Estates', 35.1794395446777, 0.613997049060921, -87.0483322143555, -1.51928000551035, 218, 50, 'PPL', 'P'),
(69354, 'Terry Fork', 35.8213882446289, 0.625201167503966, -82.4408264160156, -1.43886385902459, 218, 33, 'PPL', 'P'),
(6279, 'Terry Heights', 34.7324981689453, 0.606196450490997, -86.6041717529297, -1.51152794305129, 218, 2, 'PPL', 'P'),
(111689, 'Terry Junction', 37.8497200012207, 0.660602234979253, -81.0833282470703, -1.4151710463867, 218, 58, 'PPL', 'P'),
(106855, 'Terrybrook', 38.1313896179199, 0.665518297193485, -78.4188919067383, -1.36866785953812, 218, 53, 'PPL', 'P'),
(106856, 'Terrys Corner', 36.6833305358887, 0.640244898448633, -79.0325012207031, -1.37937736238771, 218, 53, 'PPL', 'P'),
(208924, 'Terrys Corner', 48.2447204589844, 0.842029218713547, -122.454719543457, -2.13723804063957, 218, 56, 'PPL', 'P'),
(153083, 'Terrys Corners', 43.1741714477539, 0.753531443583833, -78.6005630493164, -1.37183861913197, 218, 40, 'PPL', 'P'),
(61997, 'Terrys Creek', 31.0686092376709, 0.542249525212883, -90.5280609130859, -1.58001272837933, 218, 30, 'PPL', 'P'),
(106857, 'Terrys Fork', 37.0458297729492, 0.646571703671307, -80.2647171020508, -1.40088358661259, 218, 53, 'PPL', 'P'),
(6280, 'Terrytown', 34.6247215270996, 0.604315393234047, -87.3441696166992, -1.52444334223179, 218, 2, 'PPL', 'P'),
(12286, 'Terrytown', 34.6536102294922, 0.604819596207426, -92.4272232055664, -1.61315936341284, 218, 4, 'PPL', 'P'),
(18312, 'Terrytown', 26.3358306884766, 0.459646956761681, -80.539436340332, -1.40567834183917, 218, 12, 'PPL', 'P'),
(43320, 'Terrytown', 29.9099998474121, 0.522027976608343, -90.0325012207031, -1.57136358010708, 218, 22, 'PPL', 'P'),
(167903, 'Terrytown', 41.6694412231445, 0.727268946810125, -76.2802810668945, -1.331342058964, 218, 45, 'PPL', 'P'),
(199721, 'Terrytown', 41.8474998474121, 0.730376656065166, -103.661109924316, -1.80922767445109, 218, 35, 'PPL', 'P'),
(38513, 'Terryville', 37.9897193908691, 0.663045685279401, -82.9872207641602, -1.448400239414, 218, 21, 'PPL', 'P'),
(98469, 'Terryville', 29.1897201538086, 0.509456724419706, -97.0708312988281, -1.69420561381251, 218, 51, 'PPL', 'P'),
(106860, 'Terryville', 37.0297203063965, 0.646290540439222, -78.8822174072266, -1.37675441503009, 218, 53, 'PPL', 'P'),
(114156, 'Terryville', 41.6780586242676, 0.727419348832687, -73.0113906860352, -1.27428915893124, 218, 8, 'PPL', 'P'),
(153084, 'Terryville', 40.9088897705078, 0.713994819830789, -73.065559387207, -1.27523458111821, 218, 40, 'PPL', 'P'),
(167905, 'Terwood', 40.1349983215332, 0.700487865993152, -75.0841674804688, -1.31046593865303, 218, 45, 'PPL', 'P'),
(720, 'Terza', 34.351390838623, 0.599544872773388, -89.8541717529297, -1.56825114374111, 218, 30, 'PPL', 'P'),
(179324, 'Tes Nez Iah', 36.9430618286133, 0.644778064677139, -109.70832824707, -1.91477154477008, 218, 5, 'PPL', 'P'),
(133377, 'Tesch', 45.7516708374023, 0.798517294401342, -87.283332824707, -1.52338153990518, 218, 27, 'PPL', 'P'),
(192314, 'Tesco', 32.4944381713867, 0.567134934676424, -100.242782592773, -1.74956660760475, 218, 51, 'PPL', 'P'),
(34122, 'Tescott', 39.0080604553223, 0.680819089762372, -97.8752822875977, -1.70824593223747, 218, 20, 'PPL', 'P'),
(208925, 'Teske', 47.0741691589355, 0.821599244464195, -118.151672363281, -2.06213569947685, 218, 56, 'PPL', 'P'),
(111690, 'Tesla', 38.6019401550293, 0.673730953363072, -80.70361328125, -1.40854377001404, 218, 58, 'PPL', 'P'),
(25386, 'Tesnatee', 34.5416717529297, 0.602865901231744, -83.8319396972656, -1.46314336605062, 218, 13, 'PPL', 'P'),
(192315, 'Tesnus', 30.1180591583252, 0.525659296623207, -102.897499084473, -1.7959001510919, 218, 51, 'PPL', 'P'),
(176659, 'Tess Corners', 42.9222183227539, 0.749134031991894, -88.0994415283203, -1.53762532383741, 218, 57, 'PPL', 'P'),
(14746, 'Tessie-Maringola Estates', 38.8349990844727, 0.677798599033031, -75.4366683959961, -1.31661824024528, 218, 10, 'PPL', 'P'),
(6281, 'Tessner', 34.2541694641113, 0.597848039684844, -87.789436340332, -1.53221471260876, 218, 2, 'PPL', 'P'),
(83990, 'Testo', 33.7936096191406, 0.589809753987631, -81.2130584716797, -1.41743526594548, 218, 48, 'PPL', 'P'),
(189653, 'Tesuque', 35.7616691589355, 0.624158872832337, -105.931938171387, -1.84886110410976, 218, 38, 'PPL', 'P'),
(189654, 'Tesuque Pueblo', 35.8025016784668, 0.624871534740042, -105.974998474121, -1.84961264816938, 218, 38, 'PPL', 'P'),
(111691, 'Teter', 39.0616683959961, 0.681754724832344, -80.1577835083008, -1.39901724332066, 218, 58, 'PPL', 'P'),
(146444, 'Teterboro', 40.8597183227539, 0.713136616169511, -74.0597229003906, -1.29258600772646, 218, 37, 'PPL', 'P'),
(123792, 'Tetersburg', 40.2752799987793, 0.702936243141317, -86.1511077880859, -1.50362048514263, 218, 19, 'PPL', 'P'),
(111692, 'Teterton', 38.8330612182617, 0.677764776887187, -79.4055633544922, -1.38588852493684, 218, 58, 'PPL', 'P'),
(34123, 'Teterville', 38.0430603027344, 0.663976659817466, -96.420280456543, -1.68285135966302, 218, 20, 'PPL', 'P'),
(212187, 'Tetlin Junction', 63.3122215270996, 1.10500672239992, -142.601669311523, -2.48886864832624, 218, 1, 'PPL', 'P'),
(25387, 'Tetlow', 31.6797199249268, 0.552915418799623, -82.0713882446289, -1.43241594655134, 218, 13, 'PPL', 'P'),
(195704, 'Teton', 43.8866691589355, 0.765966874556876, -111.676940917969, -1.94913031757373, 218, 17, 'PPL', 'P'),
(202679, 'Teton', 44.2869415283203, 0.772952945307399, -100.507499694824, -1.75418679262188, 218, 49, 'PPL', 'P'),
(83991, 'Teton Forest', 34.9102783203125, 0.609299299477049, -82.2472229003906, -1.4354848402335, 218, 48, 'PPL', 'P'),
(209778, 'Teton Village', 43.5880584716797, 0.760755134882618, -110.827217102051, -1.93429983925335, 218, 59, 'PPL', 'P'),
(195706, 'Tetonia', 43.8191719055176, 0.764788825248679, -111.16194152832, -1.94014188257861, 218, 17, 'PPL', 'P'),
(106858, 'Tetotum', 38.2758293151855, 0.668039245481354, -77.0455627441406, -1.34469874393713, 218, 53, 'PPL', 'P'),
(106859, 'Tettington', 37.2413902282715, 0.64998487750338, -76.9469375610352, -1.34297740976656, 218, 53, 'PPL', 'P'),
(111693, 'Teutonic (historical)', 39.7561111450195, 0.693875037269404, -80.716667175293, -1.40877160344529, 218, 58, 'PPL', 'P'),
(28766, 'Teutopolis', 39.1330604553223, 0.683000751327365, -88.4719390869141, -1.54412663269052, 218, 18, 'PPL', 'P'),
(91291, 'Tevis', 35.4972190856934, 0.61954334834712, -84.3125, -1.47153072558772, 218, 50, 'PPL', 'P'),
(6282, 'Tew', 31.6408290863037, 0.552236645616789, -85.4419403076172, -1.49124317766038, 218, 2, 'PPL', 'P'),
(179325, 'Tewa', 35.8555603027344, 0.62579758243009, -110.383331298828, -1.92655257048426, 218, 5, 'PPL', 'P'),
(126327, 'Tewksbury', 42.6105613708496, 0.743694592044434, -71.2347183227539, -1.24328037646279, 218, 23, 'PPL', 'P'),
(126328, 'Tewksbury Junction', 42.6152801513672, 0.743776950301145, -71.216667175293, -1.24296532450583, 218, 23, 'PPL', 'P'),
(143179, 'Tewsville', 42.7569389343262, 0.746249362478147, -97.7394409179688, -1.70587505307702, 218, 35, 'PPL', 'P'),
(153088, 'Texaco Town', 42.9066696166992, 0.748862655876815, -78.0647201538086, -1.36248639633193, 218, 40, 'PPL', 'P'),
(69356, 'Texana', 35.1022186279297, 0.612649289812259, -84.0380630493164, -1.46674089720916, 218, 33, 'PPL', 'P'),
(77431, 'Texanna', 35.3472213745117, 0.616925394416545, -95.4366683959961, -1.66568409064415, 218, 42, 'PPL', 'P'),
(12287, 'Texarkana', 33.4416694641113, 0.58366723951239, -94.0374984741211, -1.64126396871256, 218, 4, 'PPL', 'P'),
(98470, 'Texarkana', 33.4249992370605, 0.583376289163299, -94.0475006103516, -1.64143853892201, 218, 51, 'PPL', 'P'),
(6283, 'Texas', 33.9297218322754, 0.592185360259009, -87.6786117553711, -1.53028045870903, 218, 2, 'PPL', 'P'),
(25388, 'Texas', 33.2408294677734, 0.580161920306601, -85.1988906860352, -1.48700116151804, 218, 13, 'PPL', 'P'),
(31303, 'Texas', 39.0475006103516, 0.68150745032513, -84.8936080932617, -1.48167297512512, 218, 19, 'PPL', 'P'),
(38515, 'Texas', 37.6555595397949, 0.657213495650182, -85.1102828979492, -1.48545466387303, 218, 21, 'PPL', 'P'),
(43321, 'Texas', 30.1716709136963, 0.526594998272206, -91.1380615234375, -1.59065924746914, 218, 22, 'PPL', 'P'),
(51982, 'Texas', 39.4636116027832, 0.688769957196804, -76.6438903808594, -1.33768823868361, 218, 25, 'PPL', 'P'),
(61998, 'Texas', 30.8858299255371, 0.539059424411618, -89.2719421386719, -1.55808931996969, 218, 30, 'PPL', 'P'),
(69355, 'Texas', 36.1977806091309, 0.631770453543892, -76.0102767944336, -1.32662959541511, 218, 33, 'PPL', 'P'),
(83992, 'Texas', 33.1319389343262, 0.578261421973693, -80.5538864135742, -1.4059305431944, 218, 48, 'PPL', 'P'),
(98474, 'Texas', 31.250280380249, 0.545420284806731, -99.2502822875977, -1.73224420945239, 218, 51, 'ADM1', 'A'),
(126330, 'Texas', 42.1652793884277, 0.735922955351365, -71.8927764892578, -1.25476565813792, 218, 23, 'PPL', 'P'),
(146447, 'Texas', 40.3605613708496, 0.704424683874562, -74.3697204589844, -1.29799648579707, 218, 37, 'PPL', 'P'),
(153086, 'Texas', 43.5127792358398, 0.759441264358828, -76.2513885498047, -1.3308377894116, 218, 40, 'PPL', 'P'),
(157916, 'Texas', 41.4236106872559, 0.722978394556926, -83.9516677856445, -1.46523301539995, 218, 41, 'PPL', 'P'),
(167907, 'Texas', 41.5349998474121, 0.724922502152684, -77.253059387207, -1.34832024354548, 218, 45, 'PPL', 'P'),
(172633, 'Texas', 44.417781829834, 0.775236539363115, -71.8249969482422, -1.25358268198171, 218, 55, 'PPL', 'P'),
(61999, 'Texas (historical)', 32.5986099243164, 0.568953074752621, -88.8938903808594, -1.55149107205291, 218, 30, 'PPL', 'P'),
(111695, 'Texas (historical)', 39.1672210693359, 0.683596966516406, -79.8050003051758, -1.3928600148804, 218, 58, 'PPL', 'P'),
(190826, 'Texas Acres', 35.9749984741211, 0.627882171773349, -114.912216186523, -2.00559652321836, 218, 39, 'PPL', 'P'),
(57864, 'Texas Bend', 36.9799995422363, 0.64542274939802, -89.3563919067383, -1.559563246475, 218, 29, 'PPL', 'P'),
(28768, 'Texas City', 37.8783302307129, 0.661101577683643, -88.3933334350586, -1.54275470525496, 218, 18, 'PPL', 'P'),
(98471, 'Texas City', 29.3836097717285, 0.512840736637842, -94.9024963378906, -1.65636102945805, 218, 51, 'PPL', 'P'),
(98472, 'Texas City Junction', 29.3494396209717, 0.512244355001232, -94.9391708374023, -1.65700112022605, 218, 51, 'PPL', 'P'),
(98473, 'Texas City Terminal Junction', 29.3302803039551, 0.511909961836859, -94.9655609130859, -1.65746171393658, 218, 51, 'PPL', 'P'),
(167906, 'Texas Corner', 40.1319389343262, 0.700434469613296, -78.4013900756836, -1.36836239496109, 218, 45, 'PPL', 'P'),
(133378, 'Texas Corners', 42.2011108398438, 0.736548332154343, -85.6866683959961, -1.4955144885747, 218, 27, 'PPL', 'P'),
(192928, 'Texas Creek', 38.4130592346191, 0.670434359407717, -105.580001831055, -1.84271865621355, 218, 7, 'PPL', 'P'),
(28769, 'Texas Junction', 37.7597198486328, 0.659031435989297, -89.3233337402344, -1.55898627262483, 218, 18, 'PPL', 'P'),
(91292, 'Texas Settlement (historical)', 35.7508316040039, 0.623969721815914, -83.3125, -1.45407743306778, 218, 50, 'PPL', 'P'),
(153087, 'Texas Valley', 42.4861106872559, 0.741522517859366, -75.9733276367188, -1.32598471095714, 218, 40, 'PPL', 'P'),
(6284, 'Texasville', 31.7150001525879, 0.553531174933163, -85.4244384765625, -1.49093771308334, 218, 2, 'PPL', 'P'),
(191020, 'Texhoma', 36.5050010681152, 0.637132462082658, -101.782501220703, -1.77643976721642, 218, 42, 'PPL', 'P'),
(192316, 'Texhoma', 36.4980583190918, 0.637011288253059, -101.782501220703, -1.77643976721642, 218, 51, 'PPL', 'P'),
(28770, 'Texico', 38.4394416809082, 0.670894819960192, -88.8969421386719, -1.55154433527471, 218, 18, 'PPL', 'P'),
(189656, 'Texico', 34.3886108398438, 0.600194484342286, -103.050827026367, -1.79857622851326, 218, 38, 'PPL', 'P'),
(98475, 'Texla', 30.2199993133545, 0.527438487968461, -93.8808288574219, -1.63852956806332, 218, 51, 'PPL', 'P'),
(192317, 'Texline', 36.3777809143066, 0.634912051523804, -103.023612976074, -1.79810125373285, 218, 51, 'PPL', 'P'),
(38514, 'Texola', 37.6536102294922, 0.657179473767256, -83.8713912963867, -1.46383192635046, 218, 21, 'PPL', 'P'),
(77434, 'Texola', 35.2191696166992, 0.614690469629751, -99.9908294677734, -1.74516919601282, 218, 42, 'PPL', 'P'),
(192318, 'Texon', 31.2247200012207, 0.544974172034629, -101.689170837402, -1.77481084473567, 218, 51, 'PPL', 'P'),
(192319, 'Texroy', 35.6344413757324, 0.621938329115429, -101.295829772949, -1.76794574807766, 218, 51, 'PPL', 'P'),
(51983, 'Thabar', 39.7177810668945, 0.693206051203576, -75.7949981689453, -1.32287227459117, 218, 25, 'PPL', 'P'),
(6286, 'Thach', 33.9736099243164, 0.592951351967543, -87.3472213745117, -1.5244966054536, 218, 2, 'PPL', 'P'),
(74529, 'Thacher', 39.5636100769043, 0.690515259817187, -82.8841705322266, -1.44660167357181, 218, 41, 'PPL', 'P'),
(146448, 'Thachers Hill', 40.5258293151855, 0.707309153651227, -74.8783264160156, -1.30687333434252, 218, 37, 'PPL', 'P'),
(111694, 'Thacker', 37.5944404602051, 0.656146766475551, -82.1316680908203, -1.43346802833998, 218, 58, 'PPL', 'P'),
(111696, 'Thacker Mines', 37.6036109924316, 0.656306822457065, -82.0969390869141, -1.43286189287588, 218, 58, 'PPL', 'P'),
(28778, 'Thackeray', 38.1199989318848, 0.665319492218111, -88.4530563354492, -1.54379706650562, 218, 18, 'PPL', 'P'),
(77436, 'Thackerville', 33.7933311462402, 0.589804893718641, -97.1427764892578, -1.69546129426649, 218, 42, 'PPL', 'P'),
(157918, 'Thackery', 40.0555610656738, 0.699101424329657, -83.9188919067383, -1.46466096839781, 218, 41, 'PPL', 'P'),
(25389, 'Thalean', 32.0183296203613, 0.558825272864131, -84.2936096191406, -1.47120102624477, 218, 13, 'PPL', 'P'),
(31304, 'Thales', 38.5102806091309, 0.672131192496261, -86.7986068725586, -1.51492147607033, 218, 19, 'PPL', 'P'),
(98476, 'Thalia', 33.9847183227539, 0.593145230094901, -99.5374984741211, -1.73725707757224, 218, 51, 'PPL', 'P'),
(106861, 'Thalia', 36.8433303833008, 0.643037422588663, -76.1211090087891, -1.32856398247289, 218, 53, 'PPL', 'P'),
(106862, 'Thalia Gardens', 36.853328704834, 0.643211926219091, -76.116943359375, -1.32849127817513, 218, 53, 'PPL', 'P'),
(106863, 'Thalia Manor', 36.8486099243164, 0.64312956796238, -76.1158294677734, -1.32847183709917, 218, 53, 'PPL', 'P'),
(106864, 'Thalia Shores', 36.8547210693359, 0.643236227564038, -76.1074981689453, -1.32832642850365, 218, 53, 'PPL', 'P'),
(106865, 'Thalia Village', 36.8413887023926, 0.643003533863792, -76.1211090087891, -1.32856398247289, 218, 53, 'PPL', 'P'),
(25390, 'Thalmann', 31.2905597686768, 0.546123292755485, -81.6888885498047, -1.42574006748879, 218, 13, 'PPL', 'P'),
(195707, 'Thama', 48.1533317565918, 0.840434184957672, -116.846672058105, -2.039359147412, 218, 17, 'PPL', 'P'),
(18313, 'Thames', 29.6802806854248, 0.518018620876742, -82.6922225952148, -1.44325155007855, 218, 12, 'PPL', 'P'),
(114158, 'Thames View', 41.3944396972656, 0.72246926473553, -72.1094436645508, -1.25854721372778, 218, 8, 'PPL', 'P'),
(114157, 'Thamesville', 41.5099983215332, 0.724486143208074, -72.0886077880859, -1.25818355908093, 218, 8, 'PPL', 'P'),
(193315, 'Thane', 58.2641716003418, 1.01690163037294, -134.330276489258, -2.34450560985188, 218, 1, 'PPL', 'P'),
(69357, 'Thankful', 36.0461082458496, 0.629123271420353, -81.2916717529297, -1.41880732653909, 218, 33, 'PPL', 'P'),
(51984, 'Thanksgiving', 38.7555618286133, 0.676412157369536, -76.1569366455078, -1.32918929269684, 218, 25, 'PPL', 'P'),
(6287, 'Tharin', 32.2044410705566, 0.562073530445701, -86.2838897705078, -1.50593796792322, 218, 2, 'PPL', 'P'),
(91293, 'Tharpe', 36.5736083984375, 0.638329885887785, -87.934440612793, -1.53474551459266, 218, 50, 'PPL', 'P'),
(25391, 'Tharpe (historical)', 32.5752792358398, 0.568545877421948, -83.6930618286133, -1.46071948998449, 218, 13, 'PPL', 'P'),
(6288, 'Tharptown', 34.5222206115723, 0.602526414771786, -87.6286087036133, -1.52940774081981, 218, 2, 'PPL', 'P'),
(179326, 'Thatcher', 32.8491706848145, 0.573326184999613, -109.758613586426, -1.91564918950731, 218, 5, 'PPL', 'P'),
(195708, 'Thatcher', 42.4088897705078, 0.740174758610704, -111.726112365723, -1.94998852123501, 218, 17, 'PPL', 'P'),
(199722, 'Thatcher', 42.8061103820801, 0.747107566139425, -100.465827941895, -1.75345948332818, 218, 35, 'PPL', 'P'),
(202680, 'Thatcher', 45.0219383239746, 0.785781059383174, -100.927223205566, -1.76151234983236, 218, 49, 'PPL', 'P'),
(206064, 'Thatcher', 41.6938896179199, 0.727695651795783, -112.293327331543, -1.95988828995516, 218, 52, 'PPL', 'P'),
(208928, 'Thatcher', 48.5550003051758, 0.847444623632169, -122.817497253418, -2.14356970613124, 218, 56, 'PPL', 'P'),
(14717, 'Thatchers Landing', 38.5563888549805, 0.672935933198656, -75.2022171020508, -1.31252629323037, 218, 10, 'PPL', 'P'),
(208926, 'Thavis', 46.9577789306641, 0.81956785176371, -118.218887329102, -2.06330882193703, 218, 56, 'PPL', 'P'),
(121682, 'Thawville', 40.6758308410645, 0.709927174160829, -88.1161117553711, -1.53791627418651, 218, 18, 'PPL', 'P'),
(62000, 'Thaxton', 34.3074989318848, 0.598778814485827, -89.1780624389648, -1.55645081010902, 218, 30, 'PPL', 'P'),
(106866, 'Thaxton', 37.3527793884277, 0.651928985099138, -79.6166687011719, -1.38957300830497, 218, 53, 'PPL', 'P'),
(25393, 'Thaxton (historical)', 33.8255615234375, 0.590367419919894, -82.8880615234375, -1.44666958417961, 218, 13, 'PPL', 'P'),
(206065, 'Thaxton Acres', 40.5472183227539, 0.707682462257028, -111.959716796875, -1.95406568770587, 218, 52, 'PPL', 'P'),
(28771, 'Thayer', 39.5380592346191, 0.690069313492653, -89.7630615234375, -1.56666097025422, 218, 18, 'PPL', 'P'),
(34124, 'Thayer', 37.4930610656738, 0.654377362247302, -95.4700012207031, -1.66626585818428, 218, 20, 'PPL', 'P'),
(57867, 'Thayer', 36.5244407653809, 0.637471748805534, -91.5380630493164, -1.59764059110873, 218, 29, 'PPL', 'P'),
(62001, 'Thayer', 31.4899997711182, 0.549604177458273, -90.4477767944336, -1.57861150617179, 218, 30, 'PPL', 'P'),
(83993, 'Thayer', 32.874439239502, 0.57376720447613, -80.6288909912109, -1.40723962002823, 218, 48, 'PPL', 'P'),
(111697, 'Thayer', 37.9011116027832, 0.661499187634392, -81.0311126708984, -1.41425971266167, 218, 58, 'PPL', 'P'),
(113064, 'Thayer', 41.1733283996582, 0.718610144578923, -87.333610534668, -1.52425905148436, 218, 19, 'PPL', 'P'),
(118024, 'Thayer', 41.0280609130859, 0.716074748642141, -94.0505599975586, -1.64149193530187, 218, 16, 'PPL', 'P'),
(133380, 'Thayer', 46.3291702270508, 0.808596560178965, -89.4619369506836, -1.561405355001, 218, 27, 'PPL', 'P'),
(143180, 'Thayer', 40.9686088562012, 0.715037114502419, -97.496940612793, -1.70164262431462, 218, 35, 'PPL', 'P'),
(172634, 'Thayer Beach', 44.5508308410645, 0.777558682675609, -73.2602767944336, -1.27863304098526, 218, 55, 'PPL', 'P'),
(153089, 'Thayer Corners', 44.9216690063477, 0.784031029651856, -74.14111328125, -1.29400653785191, 218, 40, 'PPL', 'P'),
(209779, 'Thayer Junction', 41.686939239502, 0.72757434480813, -108.91056060791, -1.90084787280087, 218, 59, 'PPL', 'P'),
(51985, 'Thayerville', 39.5016708374023, 0.689434216151697, -79.3269424438477, -1.38451633118518, 218, 25, 'PPL', 'P'),
(209780, 'Thayne', 42.9208297729492, 0.749109797225974, -111.001388549805, -1.93733970447963, 218, 59, 'PPL', 'P'),
(51986, 'The Alameda', 38.6002807617188, 0.673701991486217, -76.6319427490234, -1.33747971317025, 218, 25, 'PPL', 'P'),
(157919, 'The Angle', 41.4936103820801, 0.724200119707, -81.7050018310547, -1.4260212972999, 218, 41, 'PPL', 'P'),
(25395, 'The Arbors', 33.4038887023926, 0.583007840826487, -84.584716796875, -1.47628180497242, 218, 13, 'PPL', 'P'),
(206068, 'The Avenues Condominium', 40.7744407653809, 0.711648242015293, -111.872497558594, -1.95254342482678, 218, 52, 'PPL', 'P'),
(206066, 'The Avenues Hertiage Condominium', 40.7722206115723, 0.711609493021432, -111.870559692383, -1.95250960268094, 218, 52, 'PPL', 'P'),
(51987, 'The Bachelor Point Harbor', 38.672779083252, 0.674967325899141, -76.1722183227539, -1.32945600828001, 218, 25, 'PPL', 'P'),
(83994, 'The Barrows', 33.1405601501465, 0.578411890575283, -80.0638885498047, -1.39737846714388, 218, 48, 'PPL', 'P'),
(12291, 'The Basin', 36.0980606079102, 0.630030011192498, -93.158332824707, -1.62591963345985, 218, 4, 'PPL', 'P'),
(51988, 'The Beechs', 39.4150009155273, 0.687921540652532, -76.5633316040039, -1.3362822227861, 218, 25, 'PPL', 'P'),
(157920, 'The Bend', 41.2838897705078, 0.720539804525767, -84.5155563354492, -1.47507472720834, 218, 41, 'PPL', 'P'),
(51989, 'The Birches', 39.2291717529297, 0.684678209918979, -76.8644409179688, -1.34153757172321, 218, 25, 'PPL', 'P'),
(69359, 'The Black Cat', 34.7127799987793, 0.605852303499132, -76.6247177124023, -1.33735361249264, 218, 33, 'PPL', 'P'),
(14718, 'The Blades', 39.1166687011719, 0.682714661247263, -75.529167175293, -1.31823264849809, 218, 10, 'PPL', 'P'),
(25396, 'The Bluff', 32.0625, 0.559596191420682, -81.040283203125, -1.41441976864319, 218, 13, 'PPL', 'P'),
(38516, 'The Bluff', 37.189998626709, 0.649087924848241, -88.0716705322266, -1.53714062851902, 218, 21, 'PPL', 'P'),
(14719, 'The Bluffs', 39.7277793884277, 0.693380554834003, -75.7041702270508, -1.3212870279523, 218, 10, 'PPL', 'P'),
(25397, 'The Bluffs', 34.3708305358887, 0.599884159496264, -83.8427810668945, -1.46333258364607, 218, 13, 'PPL', 'P'),
(51990, 'The Bluffs', 39.6547203063965, 0.692105433304073, -76.148063659668, -1.32903442987945, 218, 25, 'PPL', 'P'),
(69360, 'The Borough', 34.4297218322754, 0.60091200651898, -78.1063919067383, -1.36321370562563, 218, 33, 'PPL', 'P'),
(6289, 'The Bottle', 32.6761093139648, 0.570305694270272, -85.4863891601563, -1.49201895648592, 218, 2, 'PPL', 'P'),
(126331, 'The Boulders', 42.4747200012207, 0.741323712883991, -73.2008285522461, -1.27759547342457, 218, 23, 'PPL', 'P'),
(6290, 'The Brick Store', 33.5644416809082, 0.585810018925468, -86.0152816772461, -1.50124987229829, 218, 2, 'PPL', 'P'),
(177330, 'The Burg', 41.7063903808594, 0.727913831268088, -89.0986099243164, -1.55506410212942, 218, 18, 'PPL', 'P'),
(209781, 'The Buttes', 41.1725006103516, 0.71859569693001, -105.566940307617, -1.84249068962424, 218, 59, 'PPL', 'P'),
(153090, 'The Cape', 41.747501373291, 0.728631353444783, -74.4336090087891, -1.29911155134548, 218, 40, 'PPL', 'P'),
(206067, 'The Capitol Building Condominium', 41.2200012207031, 0.719424738977351, -111.943061828613, -1.95377500367289, 218, 52, 'PPL', 'P'),
(6291, 'The Cedars', 34.8355598449707, 0.607995216070264, -87.6594390869141, -1.52994583251806, 218, 2, 'PPL', 'P'),
(14720, 'The Cedars', 39.7402801513672, 0.693598734306308, -75.6333312988281, -1.32005065541623, 218, 10, 'PPL', 'P'),
(51991, 'The Cedars', 39.482780456543, 0.689104516808745, -76.2969436645508, -1.33163287615504, 218, 25, 'PPL', 'P'),
(114159, 'The Cedars', 41.9322204589844, 0.731855309681405, -73.4555587768555, -1.28204135454835, 218, 8, 'PPL', 'P'),
(185603, 'The Cedars', 39.253059387207, 0.68509512778763, -120.35221862793, -2.10054247713743, 218, 6, 'PPL', 'P'),
(195710, 'The Cedars', 46.8727798461914, 0.818084337878481, -115.076110839844, -2.00845702454521, 218, 17, 'PPL', 'P'),
(51992, 'The Chase', 39.2430610656738, 0.684920624157203, -76.9180603027344, -1.34247340653026, 218, 25, 'PPL', 'P'),
(51993, 'The Chase at Foxridge', 39.3933296203613, 0.687543305198713, -76.790283203125, -1.34024327543343, 218, 25, 'PPL', 'P'),
(25399, 'The Circles', 34.0144386291504, 0.593663947296221, -83.9861068725586, -1.46583409085799, 218, 13, 'PPL', 'P'),
(179327, 'The Citadel', 33.5722198486328, 0.585945773562035, -112.201393127441, -1.95828373539839, 218, 5, 'PPL', 'P'),
(206095, 'The Cliff Lodge', 40.5827789306641, 0.708303111949071, -111.656387329102, -1.9487715897749, 218, 52, 'PPL', 'P'),
(25400, 'The Cloister', 33.4044418334961, 0.583017494785438, -84.5875015258789, -1.47633040766231, 218, 13, 'PPL', 'P'),
(13223, 'The Cloisters', 38.9277801513672, 0.679417934133854, -77.0055618286133, -1.34400059625737, 218, 9, 'PPL', 'P'),
(106867, 'The Cloisters', 38.9505615234375, 0.679815544084603, -77.1805572509766, -1.34705484255352, 218, 53, 'PPL', 'P'),
(51994, 'The Cloisters at Charles', 39.3836097717285, 0.687373661837275, -76.6172180175781, -1.33722271812506, 218, 25, 'PPL', 'P'),
(206069, 'The Cobbles Condominium', 41.2444381713867, 0.719851244225928, -111.893608093262, -1.95291187316359, 218, 52, 'PPL', 'P'),
(106868, 'The Colonies', 37.6797218322754, 0.657635207208796, -77.289436340332, -1.34895514114935, 218, 53, 'PPL', 'P'),
(25401, 'The Colonnade', 33.3583297729492, 0.582212687504016, -84.5338897705078, -1.47539470601332, 218, 13, 'PPL', 'P'),
(283, 'The Colony', 33.9455604553223, 0.592461796380159, -86.9016723632813, -1.51672030822862, 218, 2, 'PPL', 'P'),
(25402, 'The Colony', 33.002498626709, 0.576002262420979, -83.2238922119141, -1.45253093542277, 218, 13, 'PPL', 'P'),
(51996, 'The Colony', 39.1777801513672, 0.68378125726384, -77.2616729736328, -1.34847057898901, 218, 25, 'PPL', 'P'),
(98477, 'The Colony', 33.0888900756836, 0.577510077651154, -96.8861083984375, -1.69098159099686, 218, 51, 'PPL', 'P'),
(185604, 'The Colony Mobile Home Park', 34.1636085510254, 0.596267453577882, -119.13777923584, -2.07934651117954, 218, 6, 'PPL', 'P'),
(25403, 'The Columns', 33.9461097717285, 0.592471383760083, -84.4124984741211, -1.4732760282081, 218, 13, 'PPL', 'P'),
(25404, 'The Corners', 33.9569396972656, 0.592660401618452, -84.2430572509766, -1.47031872097562, 218, 13, 'PPL', 'P'),
(51997, 'The Corners', 39.264720916748, 0.68529865987394, -76.9805603027344, -1.34356423731276, 218, 25, 'PPL', 'P'),
(83997, 'The Cottage', 33.146671295166, 0.57851855017694, -80.0583267211914, -1.39728139492215, 218, 48, 'PPL', 'P'),
(121684, 'The Cottage', 41.6902809143066, 0.727632668036003, -87.6061096191406, -1.52901505771708, 218, 18, 'PPL', 'P'),
(206071, 'The Cottonwood Condominium', 40.6569404602051, 0.709597474817877, -111.838607788086, -1.95195193674867, 218, 52, 'PPL', 'P'),
(206072, 'The Cottonwoods Condominium', 40.6577796936035, 0.709612122203873, -111.834999084473, -1.95188895298889, 218, 52, 'PPL', 'P'),
(106869, 'The Country Store', 38.0572204589844, 0.664223801166625, -78.7541732788086, -1.37451962340135, 218, 53, 'PPL', 'P'),
(51998, 'The Courts At Piney Orchard', 39.0727806091309, 0.681948669538729, -76.709716796875, -1.33883712637787, 218, 25, 'PPL', 'P'),
(51999, 'The Courts of Four Seasons', 39.0558280944824, 0.681652792341621, -76.6980590820313, -1.33863366087058, 218, 25, 'PPL', 'P'),
(206073, 'The Courtyard Condominium', 40.8911094665527, 0.713684494984767, -111.885276794434, -1.95276646456807, 218, 52, 'PPL', 'P'),
(25405, 'The Courtyards', 33.9161109924316, 0.591947806289774, -84.4638900756836, -1.47417298086324, 218, 13, 'PPL', 'P'),
(52000, 'The Courtyards', 38.9847183227539, 0.680411692694617, -76.5477828979492, -1.33601084667102, 218, 25, 'PPL', 'P'),
(396, 'The Cove', 26.3111095428467, 0.459215491375575, -80.0849990844727, -1.39774691548069, 218, 12, 'PPL', 'P'),
(206074, 'The Cove at Hidden Valley', 40.535831451416, 0.707483723860681, -111.819717407227, -1.95162223740572, 218, 52, 'PPL', 'P'),
(179328, 'The Covey', 33.6194381713867, 0.58676988876136, -111.980278015137, -1.95442454866276, 218, 5, 'PPL', 'P'),
(153091, 'The Creek Beach', 41.0094413757324, 0.715749776410124, -72.1816711425781, -1.25980782102977, 218, 40, 'PPL', 'P'),
(106870, 'The Cross Roads', 36.8427810668945, 0.643027835208739, -82.1572189331055, -1.43391397466451, 218, 53, 'PPL', 'P'),
(129061, 'The Crossing', 46.1355590820313, 0.805217408229818, -68.918327331543, -1.20285172690262, 218, 26, 'PPL', 'P'),
(190827, 'The Crossing', 37.8697204589844, 0.660951308819136, -117.970558166504, -2.05897466042098, 218, 39, 'PPL', 'P'),
(194009, 'The Crossing', 40.4863891601563, 0.706620793088468, -120.47306060791, -2.10265156756271, 218, 6, 'PPL', 'P'),
(18314, 'The Crossings', 25.670280456543, 0.448030913877028, -80.4013900756836, -1.40326898000097, 218, 12, 'PPL', 'P'),
(25406, 'The Crossings', 33.1227798461914, 0.578101565729261, -85.0947189331055, -1.48518302144185, 218, 13, 'PPL', 'P'),
(25408, 'The Crossroads', 33.1211090087891, 0.578072404115325, -85.0638885498047, -1.4846449297436, 218, 13, 'PPL', 'P'),
(28772, 'The Crossroads', 38.9008293151855, 0.678947553306319, -90.5625, -1.58061380383736, 218, 18, 'PPL', 'P'),
(91295, 'The Crossroads', 35.0522193908691, 0.611776638502068, -85.841667175293, -1.49821972761, 218, 50, 'PPL', 'P'),
(98478, 'The Crossroads', 30.7472190856934, 0.53664020887739, -97.1319427490234, -1.69527220982909, 218, 51, 'PPL', 'P'),
(52001, 'The Dales', 39.1049995422363, 0.682510996002899, -76.5638885498047, -1.33629194332408, 218, 25, 'PPL', 'P'),
(201648, 'The Dalles', 45.5947189331055, 0.795777966904087, -121.17749786377, -2.11494631705117, 218, 43, 'PPL', 'P'),
(34125, 'The Dell', 37.6749992370605, 0.657552782373058, -97.4611129760742, -1.70101731409066, 218, 20, 'PPL', 'P'),
(57869, 'The Diamonds', 38.4730606079102, 0.671481580927363, -90.8566665649414, -1.58574797894487, 218, 29, 'PPL', 'P'),
(52002, 'The Downs', 39.0166702270508, 0.68096935862688, -76.5536117553711, -1.33611257942466, 218, 25, 'PPL', 'P'),
(206075, 'The Downs', 40.6097183227539, 0.708773293039525, -111.844169616699, -1.95204900897041, 218, 52, 'PPL', 'P'),
(6293, 'The Drifttracks', 33.5369415283203, 0.585330050718009, -86.8752822875977, -1.51625971451809, 218, 2, 'PPL', 'P'),
(157921, 'The Eastern', 40.496940612793, 0.706804950677847, -80.896110534668, -1.41190348088723, 218, 41, 'PPL', 'P'),
(153092, 'The Elms', 43.663890838623, 0.76207865936536, -76.1727828979492, -1.32946586197604, 218, 40, 'PPL', 'P'),
(167909, 'The Escape', 41.3555603027344, 0.721790691289778, -75.3063888549805, -1.31434443330657, 218, 45, 'PPL', 'P'),
(52003, 'The Estates of Wyn Lea', 39.6991691589355, 0.692881212129613, -75.908332824707, -1.32485033749083, 218, 25, 'PPL', 'P'),
(52004, 'The Fairways', 39.2777786254883, 0.685526559884223, -76.8680572509766, -1.34160068864104, 218, 25, 'PPL', 'P'),
(52006, 'The Falls', 39.3827781677246, 0.687359147609334, -76.6722183227539, -1.33818265453998, 218, 25, 'PPL', 'P'),
(98479, 'The Falman Colonia', 27.9290008544922, 0.487453021703198, -97.1719970703125, -1.69597128961524, 218, 51, 'PPL', 'P'),
(896, 'The Farms', 32.9075012207031, 0.574344244905323, -80.0063934326172, -1.39637498804514, 218, 48, 'PPL', 'P'),
(52007, 'The Fields of Four Corners', 39.5152816772461, 0.689671770120932, -76.5527801513672, -1.33609806519672, 218, 25, 'PPL', 'P'),
(144548, 'The Five Corners', 42.938060760498, 0.749410534692071, -70.8199996948242, -1.23604217093606, 218, 36, 'PPL', 'P'),
(111698, 'The Flatts', 39.6522216796875, 0.692061824041223, -79.9638900756836, -1.3956331645235, 218, 58, 'PPL', 'P'),
(14722, 'The Flying Dutchman Mobile Home Park', 39.0386085510254, 0.681352254612606, -75.5541687011719, -1.3186690074427, 218, 10, 'PPL', 'P'),
(84001, 'The Forest', 34.0875015258789, 0.594939135405178, -81.1436080932617, -1.41622312817534, 218, 48, 'PPL', 'P'),
(106871, 'The Forest', 37.6458282470703, 0.657043652551662, -77.8102798461914, -1.35804557521423, 218, 53, 'PPL', 'P'),
(69365, 'The Forest at Blowing Rock', 36.1180610656738, 0.63037908503238, -81.7202835083008, -1.42628801288307, 218, 33, 'PPL', 'P'),
(129062, 'The Forks', 45.336109161377, 0.791264374909593, -69.9677810668945, -1.22116814993186, 218, 26, 'PPL', 'P'),
(185605, 'The Forks', 39.1911087036133, 0.684013884385058, -123.206672668457, -2.15036209849148, 218, 6, 'PPL', 'P'),
(172635, 'The Four Corners', 44.5941696166992, 0.778315087004219, -72.2297210693359, -1.26064645045703, 218, 55, 'PPL', 'P'),
(114160, 'The Gables', 41.9441719055176, 0.732063901773786, -72.7941665649414, -1.2704978828034, 218, 8, 'PPL', 'P'),
(14723, 'The Glade', 38.7361106872559, 0.676072670909578, -75.0999984741211, -1.31074224161613, 218, 10, 'PPL', 'P'),
(25409, 'The Glades (historical)', 33.3944396972656, 0.582842924575984, -83.4438934326172, -1.45637068108244, 218, 13, 'PPL', 'P'),
(144549, 'The Glen', 45.1041717529297, 0.787216303473645, -71.2583312988281, -1.24369250064148, 218, 36, 'PPL', 'P'),
(153093, 'The Glen', 43.5838890075684, 0.760682364005832, -73.8633270263672, -1.28915825308742, 218, 40, 'PPL', 'P'),
(126332, 'The Green', 41.9066696166992, 0.731409363356871, -70.8861083984375, -1.23719598547834, 218, 23, 'PPL', 'P'),
(52008, 'The Greens', 39.3777809143066, 0.687271929083634, -77.3152770996094, -1.34940614747996, 218, 25, 'PPL', 'P'),
(52009, 'The Greens of Crofton', 38.9944381713867, 0.680581336056055, -76.6777801513672, -1.33827972676171, 218, 25, 'PPL', 'P'),
(52010, 'The Grove', 39.1916694641113, 0.684023671502064, -76.0013885498047, -1.32647446628161, 218, 25, 'PPL', 'P'),
(98480, 'The Grove', 31.2730598449707, 0.545817861467966, -97.5250015258789, -1.70213237963908, 218, 51, 'PPL', 'P'),
(121685, 'The Grove', 42.084171295166, 0.734507352073933, -87.8672180175781, -1.53357225897442, 218, 18, 'PPL', 'P'),
(185607, 'The Grove', 37.4038887023926, 0.65282101090626, -120.593887329102, -2.10476039167189, 218, 6, 'PPL', 'P'),
(84004, 'The Groves', 34.2000007629395, 0.596902617497866, -80.6750030517578, -1.40804442730965, 218, 48, 'PPL', 'P'),
(206076, 'The Groves', 40.8183288574219, 0.712414233723827, -111.725280761719, -1.94997400700707, 218, 52, 'PPL', 'P'),
(179329, 'The Haciendas', 33.2930603027344, 0.581073520347735, -111.820831298828, -1.95164167848168, 218, 5, 'PPL', 'P'),
(28773, 'The Hall', 37.5233306884766, 0.654905666828547, -89.0980606079102, -1.55505451474949, 218, 18, 'PPL', 'P'),
(14724, 'The Hamlet', 39.1694412231445, 0.683635715510267, -75.5486068725586, -1.31857193522096, 218, 10, 'PPL', 'P'),
(52011, 'The Hamlet', 38.9866714477539, 0.68044578115657, -77.0738906860352, -1.3451931597935, 218, 25, 'PPL', 'P'),
(157923, 'The Hamlet', 41.5819396972656, 0.725741757083019, -83.5980606079102, -1.4590614058898, 218, 41, 'PPL', 'P'),
(18315, 'The Hammocks', 25.6711101531982, 0.448045394815455, -80.4447174072266, -1.4040251845925, 218, 12, 'PPL', 'P'),
(144550, 'The Hand', 44.8797187805176, 0.783298860089166, -71.0919418334961, -1.2407884566308, 218, 36, 'PPL', 'P'),
(14725, 'The Heath', 38.9069404602051, 0.679054212907976, -75.4583282470703, -1.31699627596202, 218, 10, 'PPL', 'P'),
(25410, 'The Heather on Houston Lake', 32.5055618286133, 0.567329079119891, -83.6650009155273, -1.46022973466002, 218, 13, 'PPL', 'P'),
(106872, 'The Heights', 38.6758308410645, 0.675020589120942, -77.2900009155273, -1.34896499484538, 218, 53, 'PPL', 'P'),
(133381, 'The Heights', 42.0825004577637, 0.734478190459997, -84.2027816772461, -1.4696157796059, 218, 27, 'PPL', 'P'),
(206077, 'The Heights Condominium', 41.2102813720703, 0.719255095615913, -111.931938171387, -1.95358085922942, 218, 52, 'PPL', 'P'),
(52012, 'The Hemlocks', 39.4036102294922, 0.687722735677157, -76.9338912963867, -1.34274970949336, 218, 25, 'PPL', 'P'),
(52013, 'The Heritage', 39.2583312988281, 0.685187140003293, -77.0063934326172, -1.34401511048531, 218, 25, 'PPL', 'P'),
(52014, 'The Hermitage', 39.5288887023926, 0.689909257511139, -77.0386123657227, -1.34457743694948, 218, 25, 'PPL', 'P'),
(206078, 'The Hermitage', 41.2533302307129, 0.720006439938452, -111.875556945801, -1.95259682120663, 218, 52, 'PPL', 'P'),
(6296, 'The Highlands', 34.7566719055176, 0.606618361786693, -86.6338882446289, -1.51204659367359, 218, 2, 'PPL', 'P'),
(14726, 'The Highlands', 39.7208290100098, 0.69325924784635, -75.6833267211914, -1.32092324014739, 218, 10, 'PPL', 'P'),
(25412, 'The Highlands', 33.8402786254883, 0.590624281807032, -84.8069381713867, -1.48016029962596, 218, 13, 'PPL', 'P'),
(43324, 'The Highlands', 30.3527793884277, 0.529755937459535, -91.0647201538086, -1.5893791990912, 218, 22, 'PPL', 'P'),
(52017, 'The Highlands', 39.6863899230957, 0.692658172388319, -75.791389465332, -1.32280929083139, 218, 25, 'PPL', 'P'),
(74530, 'The Highlands', 39.2127799987793, 0.684392119838877, -84.271110534668, -1.47080834314204, 218, 41, 'PPL', 'P'),
(84005, 'The Highlands', 34.7902793884277, 0.607204923016783, -82.394172668457, -1.4380495975213, 218, 48, 'PPL', 'P'),
(129064, 'The Highlands', 45.4811096191406, 0.793795110314468, -69.5849990844727, -1.21448734402129, 218, 26, 'PPL', 'P'),
(208927, 'The Highlands', 47.7438888549805, 0.833288058225635, -122.36833190918, -2.13573029198842, 218, 56, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(25414, 'The Highlands At Akers', 33.8908309936523, 0.591506587076175, -84.4519424438477, -1.47396445534989, 218, 13, 'PPL', 'P'),
(98481, 'The Highlands Colonia', 26.2310009002686, 0.457817331803283, -97.9759979248047, -1.71000375171497, 218, 51, 'PPL', 'P'),
(52018, 'The Highlands of Hunt Valley', 39.5166702270508, 0.689696004886851, -76.6044387817383, -1.33699967838377, 218, 25, 'PPL', 'P'),
(52019, 'The Hill Farm', 39.438060760498, 0.68832401087227, -76.6791687011719, -1.33830396152763, 218, 25, 'PPL', 'P'),
(52020, 'The Hills', 38.7527809143066, 0.676363621258669, -76.5763931274414, -1.33651018937541, 218, 25, 'PPL', 'P'),
(98482, 'The Hills', 30.3477802276611, 0.529668685644321, -97.9847183227539, -1.71015595137127, 218, 51, 'PPL', 'P'),
(14727, 'The Hills of Skyline', 39.7208290100098, 0.69325924784635, -75.6875, -1.32099607760321, 218, 10, 'PPL', 'P'),
(206079, 'The Hills Subdivisions', 40.9038887023926, 0.713907534726062, -111.865280151367, -1.95241745730722, 218, 52, 'PPL', 'P'),
(206080, 'The Hillsite Addition', 41.1711082458496, 0.718571395585063, -112.023612976074, -1.95518088641234, 218, 52, 'PPL', 'P'),
(77437, 'The Holy City', 34.7425003051758, 0.606371020700452, -98.5899963378906, -1.72072004562534, 218, 42, 'PPL', 'P'),
(179330, 'The Home Place', 33.314998626709, 0.581456416333461, -111.878059387207, -1.95264049704851, 218, 5, 'PPL', 'P'),
(185608, 'The Homestead', 37.9388885498047, 0.662158519741268, -121.284721374512, -2.11681772034917, 218, 6, 'PPL', 'P'),
(84006, 'The Hook (historical)', 34.3527793884277, 0.599569107539308, -82.413330078125, -1.43838395739616, 218, 48, 'PPL', 'P'),
(206081, 'The Horse Store', 40.5527801513672, 0.707779534478762, -111.938331604004, -1.95369244567909, 218, 52, 'PPL', 'P'),
(14729, 'The Island', 38.6472206115723, 0.674521246416553, -75.5955581665039, -1.31939138988838, 218, 10, 'PPL', 'P'),
(172636, 'The Island', 43.2544403076172, 0.754932399475269, -72.795280456543, -1.27051732387936, 218, 55, 'PPL', 'P'),
(133382, 'The Jackpines', 44.4536094665527, 0.775861849587065, -83.7980575561523, -1.46255201113057, 218, 27, 'PPL', 'P'),
(25416, 'The Jockey Club Estates', 33.9197196960449, 0.592010790049554, -83.3097229003906, -1.45402896353594, 218, 13, 'PPL', 'P'),
(18316, 'The Jungle', 27.788330078125, 0.484997853494254, -82.7525024414063, -1.44430363186718, 218, 12, 'PPL', 'P'),
(18317, 'The Keyhole', 25.5033302307129, 0.445117082749345, -80.1811065673828, -1.39942430749328, 218, 12, 'PPL', 'P'),
(52021, 'The Knolls', 38.5402793884277, 0.672654769966571, -76.6005630493164, -1.33693203409208, 218, 25, 'PPL', 'P'),
(106873, 'The Knolls', 39.2822189331055, 0.685604057871945, -78.3583297729492, -1.36761085090146, 218, 53, 'PPL', 'P'),
(121686, 'The Knolls', 41.9566688537598, 0.732282014667063, -88.4338912963867, -1.5434625734727, 218, 18, 'PPL', 'P'),
(157925, 'The Knolls', 40.0136108398438, 0.698369254766967, -83.7361068725586, -1.461470767728, 218, 41, 'PPL', 'P'),
(52022, 'The Lakes', 39.4691696166992, 0.68886696283951, -76.6086120605469, -1.33707251583958, 218, 25, 'PPL', 'P'),
(138420, 'The Lakes', 44.1383285522461, 0.770359159563716, -95.6650009155273, -1.66966924489934, 218, 28, 'PPL', 'P'),
(179331, 'The Lakes', 33.3711090087891, 0.58243572724531, -111.919441223145, -1.95336274633614, 218, 5, 'PPL', 'P'),
(14731, 'The Landing', 38.7138900756836, 0.675684848075835, -75.1305618286133, -1.31127567278247, 218, 10, 'PPL', 'P'),
(57870, 'The Landing', 39.5636100769043, 0.690515259817187, -91.6608276367188, -1.59978323736376, 218, 29, 'PPL', 'P'),
(129065, 'The Landing', 45.0736083984375, 0.786682872307302, -70.5883331298828, -1.23199882661105, 218, 26, 'PPL', 'P'),
(153094, 'The Landing', 40.8613891601563, 0.713165777783447, -73.1972198486328, -1.27753248966479, 218, 40, 'PPL', 'P'),
(84007, 'The Landing at Plantation Point', 33.7333297729492, 0.588757672198995, -78.878059387207, -1.37668184389038, 218, 48, 'PPL', 'P'),
(25419, 'The Landings', 33.7972183227539, 0.589872737747411, -84.0927810668945, -1.46769590677606, 218, 13, 'PPL', 'P'),
(121687, 'The Landings', 42.1386108398438, 0.735457501371846, -88.4024963378906, -1.54291462807842, 218, 18, 'PPL', 'P'),
(179332, 'The Landings', 33.3666687011719, 0.582358229257589, -111.907783508301, -1.95315928082886, 218, 5, 'PPL', 'P'),
(57871, 'The Lead Belt', 37.9236106872559, 0.661891870737124, -90.5563888549805, -1.58050714423571, 218, 29, 'PPL', 'P'),
(144551, 'The Ledges', 43.5416717529297, 0.759945533911234, -71.4505615234375, -1.24704755098276, 218, 36, 'PPL', 'P'),
(106874, 'The Lions Den', 38.9880599975586, 0.68047001592249, -78.158332824707, -1.3641202456607, 218, 53, 'PPL', 'P'),
(52023, 'The Manors', 39.4627799987793, 0.688755442968863, -76.7863922119141, -1.34017536482563, 218, 25, 'PPL', 'P'),
(71472, 'The Maples', 39.9075012207031, 0.696517292544926, -74.9250030517578, -1.30768799531997, 218, 37, 'PPL', 'P'),
(157926, 'The Maples', 40.5027809143066, 0.70690688316857, -84.5036087036133, -1.47486620169499, 218, 41, 'PPL', 'P'),
(25420, 'The Marks', 33.3705596923828, 0.582426139865386, -84.5416717529297, -1.47553052722891, 218, 13, 'PPL', 'P'),
(206082, 'The Maryland Condominium', 40.769718170166, 0.711565817179555, -111.865829467773, -1.95242704468714, 218, 52, 'PPL', 'P'),
(69370, 'The Meadow Apartments', 35.2688903808594, 0.615558260670953, -81.5280609130859, -1.42293309569984, 218, 33, 'PPL', 'P'),
(6298, 'The Meadows', 31.211669921875, 0.5447464051824, -85.3994369506836, -1.49050135413874, 218, 2, 'PPL', 'P'),
(18318, 'The Meadows', 27.3613891601563, 0.477546328764213, -82.4691696166992, -1.43935854119707, 218, 12, 'PPL', 'P'),
(25422, 'The Meadows', 31.163890838623, 0.543912502866069, -81.3777770996094, -1.42031014834223, 218, 13, 'PPL', 'P'),
(52029, 'The Meadows', 39.1505584716797, 0.68330614932537, -75.9802780151367, -1.3261060179448, 218, 25, 'PPL', 'P'),
(69371, 'The Meadows', 36.247501373291, 0.632638244585094, -80.4013900756836, -1.40326898000097, 218, 33, 'PPL', 'P'),
(84009, 'The Meadows', 34.6355590820313, 0.60450454425047, -82.9230575561523, -1.44728038017562, 218, 48, 'PPL', 'P'),
(106876, 'The Meadows', 37.3311080932617, 0.651550749645319, -75.9502792358398, -1.32558244047449, 218, 53, 'PPL', 'P'),
(118025, 'The Meadows', 41.5144386291504, 0.724563641195796, -93.654167175293, -1.63457357542206, 218, 16, 'PPL', 'P'),
(157927, 'The Meadows', 41.5950012207031, 0.72596972367233, -83.4436111450195, -1.45636575423443, 218, 41, 'PPL', 'P'),
(167910, 'The Meadows', 40.1749992370605, 0.701186013672916, -75.1566696166992, -1.31173133964499, 218, 45, 'PPL', 'P'),
(52031, 'The Meadows at Elk Creek', 39.6305618286133, 0.691683788324487, -75.8033294677734, -1.32301768318669, 218, 25, 'PPL', 'P'),
(206084, 'The Meadows Condominium', 41.1605606079102, 0.718387304574711, -111.934722900391, -1.95362946191931, 218, 52, 'PPL', 'P'),
(206085, 'The Meadows East PRUD', 41.1611099243164, 0.718396891954635, -111.932777404785, -1.95359550661541, 218, 52, 'PPL', 'P'),
(25425, 'The Meadows North', 33.702220916748, 0.588214720231755, -84.7016677856445, -1.47832298478991, 218, 13, 'PPL', 'P'),
(206086, 'The Meadows PRUD', 41.1602783203125, 0.718382377726694, -111.933059692383, -1.95360043346343, 218, 52, 'PPL', 'P'),
(185610, 'The Mesa', 34.394718170166, 0.600301077364916, -117.272216796875, -2.04678630421807, 218, 6, 'PPL', 'P'),
(111699, 'The Mileground', 39.6425018310547, 0.691892180679785, -79.9308319091797, -1.39505619067333, 218, 58, 'PPL', 'P'),
(18319, 'The Moorings', 26.163890838623, 0.456646040266353, -81.8083267211914, -1.42782465683205, 218, 12, 'PPL', 'P'),
(25426, 'The Moorings', 33.8072204589844, 0.590047307956866, -84.0722198486328, -1.46733704581917, 218, 13, 'PPL', 'P'),
(38517, 'The Moors', 36.9261093139648, 0.644482187480031, -88.2177810668945, -1.53969073842083, 218, 21, 'PPL', 'P'),
(185611, 'The Muirlands', 32.8197212219238, 0.572812194909227, -117.272216796875, -2.04678630421807, 218, 6, 'PPL', 'P'),
(43327, 'The Myrtles', 30.3652801513672, 0.52997411693184, -91.1125030517578, -1.59021316798656, 218, 22, 'PPL', 'P'),
(14732, 'The Narrows', 38.4933280944824, 0.671835315299153, -75.0766677856445, -1.31033504428546, 218, 10, 'PPL', 'P'),
(153095, 'The Narrows', 42.3363914489746, 0.73890942419778, -78.4872207641602, -1.36986042307425, 218, 40, 'PPL', 'P'),
(25427, 'The Noles Estates', 33.6441688537598, 0.587201520595035, -84.852783203125, -1.48096044637547, 218, 13, 'PPL', 'P'),
(12293, 'The Oaks', 34.9361114501953, 0.609750172649599, -91.9897232055664, -1.60552354793537, 218, 4, 'PPL', 'P'),
(14733, 'The Oaks', 38.663890838623, 0.674812196765644, -75.5986099243164, -1.31944465311018, 218, 10, 'PPL', 'P'),
(25429, 'The Oaks', 33.9086112976074, 0.591816911922196, -84.4086074829102, -1.47320811760031, 218, 13, 'PPL', 'P'),
(52033, 'The Oaks', 39.2861099243164, 0.685671968479742, -76.7955627441406, -1.34033542080715, 218, 25, 'PPL', 'P'),
(69374, 'The Oaks', 35.9944381713867, 0.628221458496225, -80.2091674804688, -1.39991406281774, 218, 33, 'PPL', 'P'),
(106879, 'The Oaks', 37.8938903808594, 0.661373153535804, -75.5111083984375, -1.31791746338308, 218, 53, 'PPL', 'P'),
(185614, 'The Oaks', 39.2194404602051, 0.684508366820459, -121.080001831055, -2.11324469027267, 218, 6, 'PPL', 'P'),
(52034, 'The Oaks at Five Farms', 39.4436111450195, 0.688420883356921, -76.654167175293, -1.33786760258302, 218, 25, 'PPL', 'P'),
(206089, 'The Oaks at Mutton Hollow', 41.0597190856934, 0.716627287989305, -111.917503356934, -1.9533289241903, 218, 52, 'PPL', 'P'),
(69378, 'The Oaks II', 35.9305610656738, 0.627106592684891, -79.0072174072266, -1.37893607659508, 218, 33, 'PPL', 'P'),
(84011, 'The Old Home Place', 33.8488883972168, 0.590774550671539, -78.6222229003906, -1.3722166548487, 218, 48, 'PPL', 'P'),
(106880, 'The Orchard', 37.2358283996582, 0.649887805281647, -80.3930587768555, -1.40312357140545, 218, 53, 'PPL', 'P'),
(177281, 'The Orchard', 40.3333282470703, 0.70394937619901, -80.5944366455078, -1.40663827825409, 218, 58, 'PPL', 'P'),
(52035, 'The Orchards', 39.2988891601563, 0.685895008221036, -76.8344421386719, -1.3410139942529, 218, 25, 'PPL', 'P'),
(106881, 'The Orchards', 37.3291702270508, 0.651516927499475, -79.8805618286133, -1.3941788122522, 218, 53, 'PPL', 'P'),
(146449, 'The Orchards', 40.2388916015625, 0.70230114580036, -74.6975021362305, -1.30371735529272, 218, 37, 'PPL', 'P'),
(189657, 'The Overlook', 35.3069381713867, 0.616222319888764, -106.448059082031, -1.8578691133389, 218, 38, 'PPL', 'P'),
(13229, 'The Palisades', 38.9249992370605, 0.679369398022987, -77.1016693115234, -1.34567798826995, 218, 9, 'PPL', 'P'),
(43328, 'The Parks', 30.2213897705078, 0.527462756023895, -91.3166732788086, -1.59377661068314, 218, 22, 'PPL', 'P'),
(126333, 'The Patten', 42.6247215270996, 0.743941733393594, -72.7091674804688, -1.26901436891817, 218, 23, 'PPL', 'P'),
(52036, 'The Peach Orchard', 39.1375007629395, 0.683078249315086, -76.716667175293, -1.33895843336552, 218, 25, 'PPL', 'P'),
(179333, 'The Phoenix-Scottsdale Mobile Home Park', 33.6377792358398, 0.587090000724387, -112.019996643066, -1.9551177694945, 218, 5, 'PPL', 'P'),
(187432, 'The Pinery', 39.4552803039551, 0.688624548601285, -104.73388671875, -1.82795116165295, 218, 7, 'PPL', 'P'),
(12294, 'The Pines', 34.8666687011719, 0.608538168037504, -94.0702819824219, -1.64183614887276, 218, 4, 'PPL', 'P'),
(18320, 'The Pines', 25.7455596923828, 0.449344784400819, -80.2411117553711, -1.40047159559195, 218, 12, 'PPL', 'P'),
(52038, 'The Pines', 39.3250007629395, 0.686350741662576, -76.084716796875, -1.3279288185529, 218, 25, 'PPL', 'P'),
(69381, 'The Pines', 35.4722213745117, 0.619107055981538, -77.4388885498047, -1.35156357427903, 218, 33, 'PPL', 'P'),
(74532, 'The Pines', 39.1147193908691, 0.682680639364337, -84.6288909912109, -1.477052790108, 218, 41, 'PPL', 'P'),
(106883, 'The Pines', 37.2438888549805, 0.65002848676623, -80.0258331298828, -1.39671427476801, 218, 53, 'PPL', 'P'),
(126334, 'The Pines', 42.5436096191406, 0.742526063537135, -71.2272186279297, -1.24314948209521, 218, 23, 'PPL', 'P'),
(129066, 'The Pines', 45.1941719055176, 0.788787102463601, -67.9927825927734, -1.18669792383658, 218, 26, 'PPL', 'P'),
(167914, 'The Pines', 40.1450004577637, 0.700662436202607, -75.4116668701172, -1.31618188130067, 218, 45, 'PPL', 'P'),
(185616, 'The Pines', 37.3188896179199, 0.651337497021031, -119.552223205566, -2.0865799230163, 218, 6, 'PPL', 'P'),
(185617, 'The Pines (historical)', 34.1847190856934, 0.596635901914695, -116.904441833496, -2.0403674202007, 218, 6, 'PPL', 'P'),
(52039, 'The Pines at Deep Run', 39.4666709899902, 0.68882335357666, -76.6994400024414, -1.33865776247845, 218, 25, 'PPL', 'P'),
(14734, 'The Pines of Pike Creek', 39.7458305358887, 0.69369560679096, -75.709716796875, -1.32138383385792, 218, 10, 'PPL', 'P'),
(25430, 'The Plains', 34.0283317565918, 0.593906428113473, -84.4761123657227, -1.47438630006656, 218, 13, 'PPL', 'P'),
(74533, 'The Plains', 39.3688888549805, 0.68711673337111, -82.1324996948242, -1.43348254256792, 218, 41, 'PPL', 'P'),
(106884, 'The Plains', 38.8619384765625, 0.678268780123485, -77.774169921875, -1.35741533814226, 218, 53, 'PPL', 'P'),
(112401, 'The Plains', 39.0036087036133, 0.680741392037569, -75.8874969482422, -1.32448668284398, 218, 25, 'PPL', 'P'),
(144552, 'The Plains', 43.4633293151855, 0.75857820042856, -71.5494384765625, -1.24877327936913, 218, 36, 'PPL', 'P'),
(153096, 'The Plains', 43.0527801513672, 0.75141276577862, -73.35888671875, -1.28035410883973, 218, 40, 'PPL', 'P'),
(126335, 'The Plains (historical)', 41.2750015258789, 0.72038467539227, -70.158332824707, -1.22449390550115, 218, 23, 'PPL', 'P'),
(144553, 'The Plantation', 42.9291687011719, 0.749255338979547, -70.8066711425781, -1.23580954381484, 218, 36, 'PPL', 'P'),
(14735, 'The Plantations', 38.7333297729492, 0.676024134798712, -75.1627807617188, -1.31183799924664, 218, 10, 'PPL', 'P'),
(52041, 'The Plantations', 39.249439239502, 0.685031944290768, -77.1975021362305, -1.34735058659258, 218, 25, 'PPL', 'P'),
(185618, 'The Plaza', 34.1502799987793, 0.596034826456664, -116.053329467773, -2.0255127071144, 218, 6, 'PPL', 'P'),
(74534, 'The Point', 39.2313919067383, 0.684716958912839, -83.3480606079102, -1.45469808275982, 218, 41, 'PPL', 'P'),
(52042, 'The Pointe', 39.4683303833008, 0.688852315453514, -76.3180618286133, -1.33200145764991, 218, 25, 'PPL', 'P'),
(179334, 'The Pointe', 33.5541687011719, 0.585630721605079, -112.045829772949, -1.95556864266705, 218, 5, 'PPL', 'P'),
(179335, 'The Pointe at South Mountain', 33.374439239502, 0.582493850736101, -111.975563049316, -1.95434225698507, 218, 5, 'PPL', 'P'),
(25431, 'The Polo Fields', 34.184440612793, 0.596631041645705, -84.2133331298828, -1.46979993719528, 218, 13, 'PPL', 'P'),
(52043, 'The Pond', 39.5625, 0.690495885320257, -76.3783264160156, -1.33305327312243, 218, 25, 'PPL', 'P'),
(52044, 'The Ponderosa', 39.2849998474121, 0.685652593982811, -77.2830581665039, -1.34884382101579, 218, 25, 'PPL', 'P'),
(179336, 'The Preserve', 33.5802803039551, 0.586086455046618, -112.02082824707, -1.95513228372245, 218, 5, 'PPL', 'P'),
(52045, 'The Provinces', 39.1322212219238, 0.682986103941369, -76.716667175293, -1.33895843336552, 218, 25, 'PPL', 'P'),
(12295, 'The Quarry', 35.7919387817383, 0.624687177413581, -91.751106262207, -1.6013588966227, 218, 4, 'PPL', 'P'),
(31305, 'The Red Mills', 39.5813903808594, 0.690825584663208, -85.9225006103516, -1.49963053719747, 218, 19, 'PPL', 'P'),
(14736, 'The Reservation', 38.5736083984375, 0.673236470927671, -75.0783309936523, -1.31036407274134, 218, 10, 'PPL', 'P'),
(25432, 'The Retreat', 33.3736114501953, 0.582479403087188, -84.5447235107422, -1.47558379045071, 218, 13, 'PPL', 'P'),
(38518, 'The Ridge', 38.0936088562012, 0.664858898507582, -83.1991729736328, -1.45209950332617, 218, 21, 'PPL', 'P'),
(106885, 'The Ridge', 36.6830596923828, 0.640240171337698, -78.3455581665039, -1.36738794431823, 218, 53, 'PPL', 'P'),
(111700, 'The Ridge Estates', 38.4599990844727, 0.671253614338053, -81.9491729736328, -1.43028288767624, 218, 58, 'PPL', 'P'),
(52046, 'The Ridges', 38.9905586242676, 0.68051362518534, -76.595832824707, -1.33684947609829, 218, 25, 'PPL', 'P'),
(52047, 'The Ridings', 38.9483299255371, 0.67977659535366, -76.5255584716797, -1.33562295725825, 218, 25, 'PPL', 'P'),
(25433, 'The Rock', 32.9638900756836, 0.575328416086161, -84.2411117553711, -1.47028476567173, 218, 13, 'PPL', 'P'),
(43329, 'The Rock', 31.5508308410645, 0.550665879916346, -92.7130584716797, -1.61814812992483, 218, 22, 'PPL', 'P'),
(52048, 'The Rock (historical)', 39.7000007629395, 0.692895726357554, -75.8861083984375, -1.32446244807806, 218, 25, 'PPL', 'P'),
(38519, 'The Rocks', 37.6747207641602, 0.657547922104069, -88.0936126708984, -1.53752359108377, 218, 21, 'PPL', 'P'),
(106886, 'The Row', 37.2591705322266, 0.650295202349402, -76.9672164916992, -1.34333134387543, 218, 53, 'PPL', 'P'),
(25434, 'The Rubicon', 33.3505592346191, 0.582077066025504, -84.5388870239258, -1.47548192453902, 218, 13, 'PPL', 'P'),
(106887, 'The Sage', 38.8891716003418, 0.678744087799037, -77.9625015258789, -1.36070234471769, 218, 53, 'PPL', 'P'),
(52049, 'The Sands', 38.8699989318848, 0.678409461608068, -76.6733322143555, -1.33820209561594, 218, 25, 'PPL', 'P'),
(43331, 'The Shire', 30.3624992370605, 0.529925580820973, -91.0708312988281, -1.58948585869285, 218, 22, 'PPL', 'P'),
(14737, 'The Shoals', 38.4772186279297, 0.671554152067068, -75.0516662597656, -1.30989868534085, 218, 10, 'PPL', 'P'),
(84012, 'The Shoals', 34.5277786254883, 0.602623420414493, -82.7977828979492, -1.44509392492067, 218, 48, 'PPL', 'P'),
(185619, 'The Shores of Poker Flat', 37.9030609130859, 0.661533209517318, -120.581108093262, -2.1045373519306, 218, 6, 'PPL', 'P'),
(52050, 'The Sounding', 38.3458290100098, 0.669260970631428, -76.432502746582, -1.33399882846747, 218, 25, 'PPL', 'P'),
(25436, 'The Springs', 33.4944381713867, 0.584588227196367, -84.3472213745117, -1.47213672789377, 218, 13, 'PPL', 'P'),
(126336, 'The Springs', 41.7472190856934, 0.728626426596766, -70.4791717529297, -1.23009360116721, 218, 23, 'PPL', 'P'),
(194010, 'The Springs', 40.7988891601563, 0.712074947000951, -124.034721374512, -2.16481427477902, 218, 6, 'PPL', 'P'),
(126337, 'The Spruces Mobile Home Park', 42.7041702270508, 0.745328374794171, -73.1805572509766, -1.27724167247375, 218, 23, 'PPL', 'P'),
(25437, 'The Station', 33.8355598449707, 0.590541923550321, -83.9916687011719, -1.46593116307972, 218, 13, 'PPL', 'P'),
(126338, 'The Street', 42.5750007629395, 0.743073942352391, -72.2194366455078, -1.26046695339956, 218, 23, 'PPL', 'P'),
(195709, 'The String', 43.5847206115723, 0.760696878233773, -111.087783813477, -1.93884758628883, 218, 17, 'PPL', 'P'),
(25438, 'The Summit', 33.3816719055176, 0.582620084571771, -84.5416717529297, -1.47553052722891, 218, 13, 'PPL', 'P'),
(25439, 'The Terraces', 33.3808288574219, 0.582605370606749, -84.5555572509766, -1.47577287488811, 218, 13, 'PPL', 'P'),
(52051, 'The Terraces', 39.3680610656738, 0.687102285722196, -76.6569366455078, -1.33791593895681, 218, 25, 'PPL', 'P'),
(206098, 'The Terraces Condominium', 40.7308311462402, 0.710887110575748, -111.891670227051, -1.95287805101775, 218, 52, 'PPL', 'P'),
(206099, 'The Terraces of Rose Park Condominium', 40.7841682434082, 0.711818018534785, -111.925559997559, -1.95346953909585, 218, 52, 'PPL', 'P'),
(69388, 'The Tides', 36.1527786254883, 0.6309850207594, -75.7397232055664, -1.32190754448629, 218, 33, 'PPL', 'P'),
(14738, 'The Timbers', 39.8255615234375, 0.695087175039553, -75.4794387817383, -1.31736472429883, 218, 10, 'PPL', 'P'),
(52053, 'The Timbers', 39.4316711425781, 0.688212491001623, -76.274169921875, -1.33123539936234, 218, 25, 'PPL', 'P'),
(179337, 'The Town Square', 33.6413917541504, 0.587153051063195, -112.06861114502, -1.9559662526178, 218, 5, 'PPL', 'P'),
(179338, 'The Trails III', 33.4530601501465, 0.583866044487765, -111.894439697266, -1.95292638739153, 218, 5, 'PPL', 'P'),
(14739, 'The Villa', 39.663330078125, 0.692255702168581, -75.6430587768555, -1.32022043193572, 218, 10, 'PPL', 'P'),
(206100, 'The Villa Granade Condominium', 40.7755584716797, 0.711667749670278, -111.893058776855, -1.95290228578367, 218, 52, 'PPL', 'P'),
(52056, 'The Village', 38.6966705322266, 0.67538431034682, -76.8349990844727, -1.34102371479088, 218, 25, 'PPL', 'P'),
(77438, 'The Village', 35.5608291625977, 0.620653553626547, -97.5511093139648, -1.70258804650159, 218, 42, 'PPL', 'P'),
(84013, 'The Village', 32.8069381713867, 0.572589088588906, -79.8408279418945, -1.39348532510435, 218, 48, 'PPL', 'P'),
(185621, 'The Village', 34.5505599975586, 0.603021030365241, -117.339721679688, -2.04796448668432, 218, 6, 'PPL', 'P'),
(146451, 'The Village at Little Falls', 40.8683280944824, 0.713286885034018, -74.1966705322266, -1.29497619480481, 218, 37, 'PPL', 'P'),
(25440, 'The Village Mobile Home Park', 33.7555618286133, 0.58914569476982, -84.5794372558594, -1.4761896595987, 218, 13, 'PPL', 'P'),
(18321, 'The Village of Baytowne Wharf', 30.3869400024414, 0.530352152648576, -86.3252792358398, -1.5066603503689, 218, 12, 'PPL', 'P'),
(74535, 'The Village of Indian Hill', 39.2497215270996, 0.685036871138785, -84.2958297729492, -1.47123977523863, 218, 41, 'PPL', 'P'),
(144554, 'The Village of Loon Mountain', 44.0611114501953, 0.769011466894082, -71.6275024414063, -1.25013575258282, 218, 36, 'PPL', 'P'),
(84014, 'The Village Subdivision', 33.9052810668945, 0.591758788431405, -80.3913879394531, -1.40309440979152, 218, 48, 'PPL', 'P'),
(18322, 'The Villages', 28.9333305358887, 0.504981881419073, -81.9486083984375, -1.43027303398021, 218, 12, 'PPL', 'P'),
(153097, 'The Vly', 41.8863906860352, 0.731055429248, -74.204719543457, -1.29511667655231, 218, 40, 'PPL', 'P'),
(106889, 'The Waterfront', 37.1055603027344, 0.647614198080019, -79.6549987792969, -1.39024199437079, 218, 53, 'PPL', 'P'),
(18323, 'The Watson Place', 25.7099990844727, 0.448724134708776, -81.2447204589844, -1.41798787187168, 218, 12, 'PPL', 'P'),
(179339, 'The West Winds Trailer Court', 33.3055610656738, 0.58129169982004, -111.831672668457, -1.95183089607713, 218, 5, 'PPL', 'P'),
(25441, 'The Wildings', 33.9513893127441, 0.5925635291338, -84.0872192382813, -1.46759883455433, 218, 13, 'PPL', 'P'),
(206101, 'The Willowbrook Condominium', 40.6544418334961, 0.709553865555027, -111.875556945801, -1.95259682120663, 218, 52, 'PPL', 'P'),
(14741, 'The Willows', 38.6866683959961, 0.675209740137365, -75.1838912963867, -1.31220644758346, 218, 10, 'PPL', 'P'),
(25442, 'The Willows', 33.5272216796875, 0.58516040735657, -84.3894424438477, -1.47287362456739, 218, 13, 'PPL', 'P'),
(52058, 'The Willows', 39.2516708374023, 0.685070893021711, -76.8541717529297, -1.34135834098185, 218, 25, 'PPL', 'P'),
(144555, 'The Willows', 42.9113883972168, 0.748945014133525, -70.8247222900391, -1.2361245957718, 218, 36, 'PPL', 'P'),
(185623, 'The Willows', 37.1027793884277, 0.647565661969152, -121.923606872559, -2.12796837583333, 218, 6, 'PPL', 'P'),
(52059, 'The Willows of Ruxton', 39.4097213745117, 0.687829395278815, -76.6291732788086, -1.33743137679647, 218, 25, 'PPL', 'P'),
(206102, 'The Wilshire Condo', 40.7597198486328, 0.711391313549127, -111.86222076416, -1.95236406092736, 218, 52, 'PPL', 'P'),
(25444, 'The Woodlands', 34.0869407653809, 0.594929348288172, -84.6091690063477, -1.47670857653711, 218, 13, 'PPL', 'P'),
(98483, 'The Woodlands', 30.1577796936035, 0.526352550744468, -95.4891662597656, -1.66660035121719, 218, 51, 'PPL', 'P'),
(106890, 'The Woodlands', 37.339168548584, 0.651691431129903, -79.9791717529297, -1.39589988010667, 218, 53, 'PPL', 'P'),
(167911, 'The Woodlands', 40.1699981689453, 0.701098728568189, -75.1566696166992, -1.31173133964499, 218, 45, 'PPL', 'P'),
(206104, 'The Woodlands Business Park', 40.6847190856934, 0.710082303294326, -111.869438171387, -1.95249002844692, 218, 52, 'PPL', 'P'),
(14742, 'The Woods', 39.684440612793, 0.692624150505394, -75.6372222900391, -1.32011856602403, 218, 10, 'PPL', 'P'),
(25445, 'The Woods', 33.5583305358887, 0.58570335932381, -84.5247192382813, -1.4752346500318, 218, 13, 'PPL', 'P'),
(43333, 'The Woods', 30.3944396972656, 0.530483047016154, -90.9908294677734, -1.58808956333333, 218, 22, 'PPL', 'P'),
(52060, 'The Woods', 39.014720916748, 0.680935336743954, -76.5586090087891, -1.33619979795036, 218, 25, 'PPL', 'P'),
(84015, 'The Woods', 34.6549987792969, 0.604843830973346, -82.9944381713867, -1.44852620693356, 218, 48, 'PPL', 'P'),
(167912, 'The Woods', 40.163330078125, 0.700982348428553, -75.1999969482422, -1.31248754423651, 218, 45, 'PPL', 'P'),
(172637, 'The Woods', 43.660831451416, 0.762025262985504, -72.7936096191406, -1.27048816226542, 218, 55, 'PPL', 'P'),
(25446, 'The Woods at Colony Crossing', 34.1086082458496, 0.595307517162963, -84.586669921875, -1.47631589343437, 218, 13, 'PPL', 'P'),
(52061, 'The Woods of Marlton', 38.7644386291504, 0.676567086765951, -76.7819366455078, -1.3400976005218, 218, 25, 'PPL', 'P'),
(52062, 'The Woods of Town Point', 39.4922218322754, 0.689269299901193, -75.9186096191406, -1.32502970139024, 218, 25, 'PPL', 'P'),
(14743, 'The Woods on Herring Creek', 38.6644401550293, 0.674821784145568, -75.1444396972656, -1.31151788728362, 218, 10, 'PPL', 'P'),
(185624, 'The Woods Trailer Park', 32.9147186279297, 0.574470212424884, -117.124443054199, -2.04420716586038, 218, 6, 'PPL', 'P'),
(91301, 'The Wye', 36.2147216796875, 0.632066131003918, -84.1661071777344, -1.4689756888379, 218, 50, 'PPL', 'P'),
(126339, 'The X', 42.086109161377, 0.734541174219777, -72.5583267211914, -1.26638170102257, 218, 23, 'PPL', 'P'),
(91302, 'The Y', 36.2999992370605, 0.633554505158136, -82.3822174072266, -1.43784093884989, 218, 50, 'PPL', 'P'),
(111701, 'The Y', 38.8963890075684, 0.678870055318597, -81.6699981689453, -1.42541036814584, 218, 58, 'PPL', 'P'),
(57872, 'Theabeau Town', 38.0327796936035, 0.663797229339022, -90.7283325195313, -1.58350812731006, 218, 29, 'PPL', 'P'),
(38520, 'Thealka', 37.8219413757324, 0.660117406502804, -82.7888870239258, -1.44493866262911, 218, 21, 'PPL', 'P'),
(43335, 'Theall', 29.8766708374023, 0.521446275647242, -92.2169418334961, -1.6094892611146, 218, 22, 'PPL', 'P'),
(6304, 'Theba', 31.5555591583252, 0.550748404620625, -86.3036117553711, -1.50628218149411, 218, 2, 'PPL', 'P'),
(179340, 'Theba', 32.9194412231445, 0.574552637260621, -112.893890380859, -1.97037009253155, 218, 5, 'PPL', 'P'),
(12296, 'Thebes', 33.2861099243164, 0.580952213360082, -91.5841674804688, -1.5984452652321, 218, 4, 'PPL', 'P'),
(28774, 'Thebes', 37.2208290100098, 0.649626016546492, -89.4608306884766, -1.5613860470831, 218, 18, 'PPL', 'P'),
(67, 'Thedford', 32.4844398498535, 0.566960431045996, -95.3963928222656, -1.66498114927442, 218, 51, 'PPL', 'P'),
(199723, 'Thedford', 41.978328704834, 0.7326600503838, -100.575828552246, -1.75537935615802, 218, 35, 'PPL', 'P'),
(133383, 'Theilers', 46.4636116027832, 0.810943004836407, -89.6986083984375, -1.56553605100977, 218, 27, 'PPL', 'P'),
(138421, 'Theilman', 44.2891693115234, 0.772991827459314, -92.1919403076172, -1.60905290216999, 218, 28, 'PPL', 'P'),
(198994, 'Thelan', 46.8036117553711, 0.816877126956348, -103.971389770508, -1.81464307936971, 218, 34, 'PPL', 'P'),
(38521, 'Thelma', 37.8191719055176, 0.66006907012902, -82.7655563354492, -1.44453146529844, 218, 21, 'PPL', 'P'),
(57873, 'Thelma', 36.7425003051758, 0.641277605740339, -93.3694381713867, -1.62960411682797, 218, 29, 'PPL', 'P'),
(62009, 'Thelma', 33.9874992370605, 0.593193766205767, -89.0263900756836, -1.55380362798548, 218, 30, 'PPL', 'P'),
(69385, 'Thelma', 36.4702796936035, 0.63652645977661, -77.7936096191406, -1.35775462486514, 218, 33, 'PPL', 'P'),
(71473, 'Thelma', 39.4150009155273, 0.687921540652532, -74.6563873291016, -1.302999766537, 218, 37, 'PPL', 'P'),
(98488, 'Thelma', 29.2138900756836, 0.509878569136374, -98.5013885498047, -1.71917354798033, 218, 51, 'PPL', 'P'),
(106891, 'Thelma', 38.0455589294434, 0.664020269080316, -78.2422180175781, -1.36558431846997, 218, 53, 'PPL', 'P'),
(157929, 'Thelma', 41.6458282470703, 0.726856822631435, -84.2294387817383, -1.47008103384833, 218, 41, 'PPL', 'P'),
(185625, 'Thenard', 33.7866706848145, 0.58968864673706, -118.241668701172, -2.06370643188778, 218, 6, 'PPL', 'P'),
(153098, 'Thendara', 43.7000007629395, 0.762708896437327, -75.0022201538086, -1.30903568798961, 218, 40, 'PPL', 'P'),
(6305, 'Theo', 32.7222213745117, 0.571110501551694, -87.1888885498047, -1.52173317634848, 218, 2, 'PPL', 'P'),
(62010, 'Theo', 34.9308280944824, 0.609657960696855, -88.6975021362305, -1.54806345057193, 218, 30, 'PPL', 'P'),
(6306, 'Theodore', 30.5475006103516, 0.533154463905612, -88.1752777099609, -1.53894891489918, 218, 2, 'PPL', 'P'),
(52063, 'Theodore', 39.6386108398438, 0.691824270071988, -76.0102767944336, -1.32662959541511, 218, 25, 'PPL', 'P'),
(91306, 'Theodore', 35.5550003051758, 0.620551820872906, -87.540283203125, -1.52786617002282, 218, 50, 'PPL', 'P'),
(98485, 'Theodore', 33.7144393920898, 0.588427972856043, -96.904167175293, -1.69129677611188, 218, 51, 'PPL', 'P'),
(133384, 'Theodore', 46.0013885498047, 0.802875690683311, -87.836669921875, -1.53303909412419, 218, 27, 'PPL', 'P'),
(57874, 'Theodosia', 36.5827789306641, 0.638489941869298, -92.6758270263672, -1.61749831861885, 218, 29, 'PPL', 'P'),
(57875, 'Theodosia (historical)', 36.5766716003418, 0.638383348846668, -92.648063659668, -1.61701375645851, 218, 29, 'PPL', 'P'),
(98486, 'Theon', 30.7627792358398, 0.53691178472955, -97.5969390869141, -1.703387926935, 218, 51, 'PPL', 'P'),
(208930, 'Theon', 46.1547203063965, 0.805551834683705, -117.095001220703, -2.04369330892805, 218, 56, 'PPL', 'P'),
(208929, 'Thera', 46.9361114501953, 0.819189682888919, -117.553611755371, -2.05169757274234, 218, 56, 'PPL', 'P'),
(153099, 'Theresa', 44.2152786254883, 0.771702191701443, -75.7975006103516, -1.32291595043305, 218, 40, 'PPL', 'P'),
(176661, 'Theresa', 43.517219543457, 0.759518762346549, -88.4511108398438, -1.54376311120172, 218, 57, 'PPL', 'P'),
(91303, 'Theresa Heights', 35.1138916015625, 0.61285302163565, -85.170280456543, -1.48650181881365, 218, 50, 'PPL', 'P'),
(176662, 'Theresa Station', 43.526668548584, 0.759683678597052, -88.4277801513672, -1.54335591387105, 218, 57, 'PPL', 'P'),
(18325, 'Theressa', 29.8349990844727, 0.520718966353542, -82.0708312988281, -1.43240622601337, 218, 12, 'PPL', 'P'),
(43337, 'Theriot', 29.461109161377, 0.514193356155493, -90.7513885498047, -1.58391053095077, 218, 22, 'PPL', 'P'),
(185626, 'Thermal', 33.6402816772461, 0.587133676566265, -116.138610839844, -2.02700114784765, 218, 6, 'PPL', 'P'),
(6307, 'Thermal (historical)', 33.8138885498047, 0.590163688096502, -86.725830078125, -1.51365128138841, 218, 2, 'PPL', 'P'),
(69386, 'Thermal City', 35.5191688537598, 0.619926444069928, -81.9749984741211, -1.43073362769074, 218, 33, 'PPL', 'P'),
(185627, 'Thermalito', 39.5113906860352, 0.689603859513135, -121.585830688477, -2.12207306928628, 218, 6, 'PPL', 'P'),
(98487, 'Thermo', 33.1022186279297, 0.577742704772373, -95.5158309936523, -1.66706573861768, 218, 51, 'PPL', 'P'),
(192814, 'Thermo', 38.2144393920898, 0.666967789195788, -113.170829772949, -1.97520359675199, 218, 52, 'PPL', 'P'),
(209782, 'Thermopolis', 43.646110534668, 0.761768334519339, -108.211387634277, -1.88864500237002, 218, 59, 'PPL', 'P'),
(126340, 'Thermopylae', 42.2819404602051, 0.737959075162785, -72.600830078125, -1.26712352454421, 218, 23, 'PPL', 'P'),
(106892, 'Thessalia', 37.2522201538086, 0.650173895361748, -80.7866668701172, -1.40999332859537, 218, 53, 'PPL', 'P'),
(12297, 'Thessing (historical)', 35.2930603027344, 0.615980105387621, -94.0255584716797, -1.64105557635726, 218, 4, 'PPL', 'P'),
(91304, 'Theta', 35.7786102294922, 0.624454550292363, -87.0502777099609, -1.51931396081425, 218, 50, 'PPL', 'P'),
(133385, 'Thetford Center', 43.1791687011719, 0.753618662109533, -83.6402816772461, -1.45979830256343, 218, 27, 'PPL', 'P'),
(172638, 'Thetford Center', 43.8286094665527, 0.764953541762101, -72.2466735839844, -1.26094232765414, 218, 55, 'PPL', 'P'),
(172639, 'Thetford Hill', 43.8194389343262, 0.764793485780587, -72.2291717529297, -1.26063686307711, 218, 55, 'PPL', 'P'),
(195711, 'Thiard', 47.6155586242676, 0.831048273169851, -115.904167175293, -2.0229093339908, 218, 17, 'PPL', 'P'),
(43338, 'Thibodaux', 29.795560836792, 0.520030639080297, -90.8227767944336, -1.58515649086677, 218, 22, 'PPL', 'P'),
(43339, 'Thibodaux Junction', 29.7527809143066, 0.51928398857918, -90.7994384765625, -1.58474916037804, 218, 22, 'PPL', 'P'),
(91305, 'Thick', 35.6588897705078, 0.622365034101086, -86.7341690063477, -1.51379682314199, 218, 50, 'PPL', 'P'),
(98489, 'Thicket', 30.3955593109131, 0.530502587960652, -94.629997253418, -1.65160502322533, 218, 51, 'PPL', 'P'),
(893, 'Thicketty', 35.0163917541504, 0.611151328278117, -81.7249984741211, -1.42637030456076, 218, 48, 'PPL', 'P'),
(12298, 'Thida', 35.5711097717285, 0.620832984104991, -91.478889465332, -1.596607817238, 218, 4, 'PPL', 'P'),
(138426, 'Thief River Falls', 48.1191711425781, 0.83983796976863, -96.1808319091797, -1.67867219412241, 218, 28, 'PPL', 'P'),
(12299, 'Thiel', 34.2452812194824, 0.597692910551347, -92.6158294677734, -1.61645116367823, 218, 4, 'PPL', 'P'),
(208931, 'Thiel', 46.1402816772461, 0.805299833065556, -118.490562438965, -2.06805044709986, 218, 56, 'PPL', 'P'),
(153101, 'Thiells', 41.2105598449707, 0.719259955884903, -74.0180587768555, -1.29185883159081, 218, 40, 'PPL', 'P'),
(167913, 'Thielman Crossroads', 40.6958312988281, 0.710276248000711, -80.0497207641602, -1.39713119263667, 218, 45, 'PPL', 'P'),
(197682, 'Thiels West Trailer Court', 48.5486106872559, 0.847333103761522, -109.745826721191, -1.91542601660796, 218, 31, 'PPL', 'P'),
(176665, 'Thiensville', 43.2374992370605, 0.754636722015243, -87.9786071777344, -1.53551636657018, 218, 57, 'PPL', 'P'),
(25448, 'Thigpen', 33.5149993896484, 0.584947088153255, -82.6338882446289, -1.44223342359381, 218, 13, 'PPL', 'P'),
(206107, 'Third and M Townhouse Condominium', 40.7730598449707, 0.711624140407428, -111.864440917969, -1.95240280992122, 218, 52, 'PPL', 'P'),
(126341, 'Third Cliff', 42.1791687011719, 0.736165369589589, -70.7180633544922, -1.23426304616983, 218, 23, 'PPL', 'P'),
(91307, 'Third Creek', 35.9702796936035, 0.627799813516638, -84.0033264160156, -1.466134628587, 218, 50, 'PPL', 'P'),
(98491, 'Third Crossing', 29.5361099243164, 0.515502366410294, -99.7130584716797, -1.74032117756444, 218, 51, 'PPL', 'P'),
(98492, 'Third Hidalgo Colonia', 27.9729995727539, 0.488220944203523, -97.4059982299805, -1.70005538030493, 218, 51, 'PPL', 'P'),
(121692, 'Third Lake', 42.3738899230957, 0.739563896035667, -88.0108337402344, -1.53607882619241, 218, 18, 'PPL', 'P'),
(98493, 'Third Rancho Chico Addition Colonia', 28.0249996185303, 0.489128516213508, -97.4960021972656, -1.70162624587391, 218, 51, 'PPL', 'P'),
(25449, 'Thirteen Forks', 34.2130584716797, 0.59713051750815, -82.9291687011719, -1.44738703977728, 218, 13, 'PPL', 'P'),
(43340, 'Thirteen Points Landing', 32.9563903808594, 0.575197521718584, -92.085563659668, -1.60719627941605, 218, 22, 'PPL', 'P'),
(118026, 'Thirty', 40.6961097717285, 0.710281108269701, -92.8675003051758, -1.62084364842216, 218, 16, 'PPL', 'P'),
(57877, 'Thirtyfour Corner', 36.776668548584, 0.641873954087435, -89.2108306884766, -1.55702272395312, 218, 29, 'PPL', 'P'),
(201649, 'Thirtymile', 45.1694412231445, 0.788355470629927, -120.157501220703, -2.09714401727038, 218, 43, 'PPL', 'P'),
(6308, 'Thirtynine (historical)', 34.4627799987793, 0.601488980369146, -86.0113906860352, -1.5011819616905, 218, 2, 'PPL', 'P'),
(176669, 'Thiry Daems', 44.6030616760254, 0.778470282716743, -87.6930618286133, -1.53053266006426, 218, 57, 'PPL', 'P'),
(190828, 'Thisby', 39.5883293151855, 0.69094669191378, -119.420280456543, -2.08427708762171, 218, 39, 'PPL', 'P'),
(52065, 'Thistle', 39.2536087036133, 0.685104715167555, -76.767219543457, -1.33984073863466, 218, 25, 'PPL', 'P'),
(192815, 'Thistle', 39.9913902282715, 0.697981431933224, -111.497497558594, -1.9459984401318, 218, 52, 'PPL', 'P'),
(187433, 'Thistledown', 37.9936103820801, 0.663113595887198, -107.699172973633, -1.87970517006478, 218, 7, 'PPL', 'P'),
(74536, 'Thivener', 38.7361106872559, 0.676072670909578, -82.2452774047852, -1.4354508849296, 218, 41, 'PPL', 'P'),
(38522, 'Thixton', 38.1005592346191, 0.664980205495235, -85.565559387207, -1.4934007376175, 218, 21, 'PPL', 'P'),
(111702, 'Thoburn', 39.4630584716797, 0.688760303237852, -80.228889465332, -1.40025827638864, 218, 58, 'PPL', 'P'),
(197683, 'Thoeny', 48.8769416809082, 0.8530635606371, -106.916938781738, -1.86605260789455, 218, 31, 'PPL', 'P'),
(12300, 'Thola', 35.8866691589355, 0.62634053439733, -92.4291687011719, -1.61319331871674, 218, 4, 'PPL', 'P'),
(91308, 'Thom (historical)', 36.4819412231445, 0.636729991862919, -82.3680572509766, -1.43759379750073, 218, 50, 'PPL', 'P'),
(185628, 'Thoman', 38.4911117553711, 0.67179663288432, -122.450828552246, -2.13717013003178, 218, 6, 'PPL', 'P'),
(6310, 'Thomas', 33.5325012207031, 0.585252552730287, -86.8569412231445, -1.51593960255506, 218, 2, 'PPL', 'P'),
(31306, 'Thomas', 38.6127815246582, 0.673920170958522, -87.2316665649414, -1.52247979356008, 218, 19, 'PPL', 'P'),
(38523, 'Thomas', 37.6816711425781, 0.657669229091722, -82.5858306884766, -1.44139466100849, 218, 21, 'PPL', 'P'),
(43343, 'Thomas', 30.9677791595459, 0.540489708364558, -90.0286102294922, -1.57129566949929, 218, 22, 'PPL', 'P'),
(52066, 'Thomas', 38.5713882446289, 0.67319772193381, -76.2772216796875, -1.33128866258415, 218, 25, 'PPL', 'P'),
(77439, 'Thomas', 35.7441711425781, 0.623853474834332, -98.7472229003906, -1.72346416681256, 218, 42, 'PPL', 'P'),
(91309, 'Thomas', 36.083610534668, 0.629777809837268, -85.6452789306641, -1.49479210612902, 218, 50, 'PPL', 'P'),
(98494, 'Thomas', 32.8608283996582, 0.573529650506895, -95.0672225952148, -1.65923604501285, 218, 51, 'PPL', 'P'),
(106893, 'Thomas', 37.3450012207031, 0.651793230462571, -82.1680603027344, -1.43410319225996, 218, 53, 'PPL', 'P'),
(111703, 'Thomas', 39.1488914489746, 0.683277054290461, -79.4983291625977, -1.38750759372156, 218, 58, 'PPL', 'P'),
(121694, 'Thomas', 40.3086090087891, 0.703517944102417, -87.5297164916992, -1.52768174611733, 218, 18, 'PPL', 'P'),
(133388, 'Thomas', 43.7005615234375, 0.762718683554333, -83.5480575561523, -1.45818868800059, 218, 27, 'PPL', 'P'),
(144556, 'Thomas', 42.749439239502, 0.74611846811057, -72.0438919067383, -1.25740311972348, 218, 36, 'PPL', 'P'),
(167915, 'Thomas', 40.2374992370605, 0.702276844455413, -80.0941696166992, -1.39790697146221, 218, 45, 'PPL', 'P'),
(171422, 'Thomas', 44.7608299255371, 0.781223858125831, -97.2091674804688, -1.69662003565678, 218, 49, 'PPL', 'P'),
(189658, 'Thomas', 36.2455596923828, 0.632604355860223, -103.291938781738, -1.80278442250975, 218, 38, 'PPL', 'P'),
(195712, 'Thomas', 43.1827812194824, 0.75368171244834, -112.503890991211, -1.96356331910142, 218, 17, 'PPL', 'P'),
(208933, 'Thomas', 46.0361099243164, 0.803481692989359, -118.144439697266, -2.06200946564118, 218, 56, 'PPL', 'P'),
(12301, 'Thomas (historical)', 34.7586097717285, 0.606652183932537, -91.5152816772461, -1.59724298115798, 218, 4, 'PPL', 'P'),
(43342, 'Thomas (historical)', 31.4091701507568, 0.54819343444983, -92.3475036621094, -1.61176799490133, 218, 22, 'PPL', 'P'),
(6309, 'Thomas Acres', 33.3794403076172, 0.582581135840829, -86.980827331543, -1.5181018230441, 218, 2, 'PPL', 'P'),
(25450, 'Thomas Acres', 31.5352802276611, 0.550394470511754, -83.9897232055664, -1.46589720777582, 218, 13, 'PPL', 'P'),
(91310, 'Thomas Addition', 36.5750007629395, 0.638354187232732, -82.5505599975586, -1.44077907132252, 218, 50, 'PPL', 'P'),
(13231, 'Thomas Circle', 38.9061088562012, 0.679039698680036, -77.029167175293, -1.344412587278, 218, 9, 'PPL', 'P'),
(18327, 'Thomas City', 30.3549995422363, 0.529794686453395, -83.9730606079102, -1.46560639058478, 218, 12, 'PPL', 'P'),
(84016, 'Thomas Corner', 33.1605606079102, 0.578760964415165, -79.7149963378906, -1.39128914931141, 218, 48, 'PPL', 'P'),
(106894, 'Thomas Corner', 36.8555603027344, 0.643250874950033, -76.2094421386719, -1.33010568642793, 218, 53, 'PPL', 'P'),
(98495, 'Thomas Crossing', 31.371940612793, 0.547543656433365, -94.5283279418945, -1.64983055899101, 218, 51, 'PPL', 'P'),
(6311, 'Thomas Crossroad', 31.7763900756836, 0.554602631218729, -86.1286087036133, -1.5032278020399, 218, 2, 'PPL', 'P'),
(25452, 'Thomas Crossroads', 33.4077796936035, 0.583075751434284, -84.6822204589844, -1.47798356490898, 218, 13, 'PPL', 'P'),
(69392, 'Thomas Crossroads', 35.2830581665039, 0.615805535178167, -79.5124969482422, -1.38775486822877, 218, 33, 'PPL', 'P'),
(167918, 'Thomas Crossroads', 40.2402801513672, 0.70232538056628, -79.1975021362305, -1.38225717163246, 218, 45, 'PPL', 'P'),
(206109, 'Thomas Estates', 40.6624984741211, 0.709694480460583, -111.955558776855, -1.95399311656616, 218, 52, 'PPL', 'P'),
(206112, 'Thomas Gardens', 40.7027816772461, 0.710397554988364, -112.094718933105, -1.95642191948032, 218, 52, 'PPL', 'P'),
(91311, 'Thomas Heights', 36.5416717529297, 0.637772486271631, -82.475830078125, -1.43947478817865, 218, 50, 'PPL', 'P'),
(57878, 'Thomas Hill', 39.5208282470703, 0.689768576026556, -92.6555633544922, -1.61714465082609, 218, 29, 'PPL', 'P'),
(14744, 'Thomas Landing', 39.4480590820313, 0.688498514502697, -75.6133270263672, -1.31970151499732, 218, 10, 'PPL', 'P'),
(25453, 'Thomas Landing', 31.6408290863037, 0.552236645616789, -81.2569427490234, -1.41820119107499, 218, 13, 'PPL', 'P'),
(69391, 'Thomas Landing', 34.4866714477539, 0.601905964816825, -77.4766693115234, -1.35222297296493, 218, 33, 'PPL', 'P'),
(185629, 'Thomas Lane', 35.4874992370605, 0.619373704985682, -119.283889770508, -2.08189662108134, 218, 6, 'PPL', 'P'),
(636, 'Thomas Manor', 38.4708290100098, 0.671442632196421, -76.898063659668, -1.34212439926941, 218, 25, 'PPL', 'P'),
(6313, 'Thomas Mill', 32.9736099243164, 0.5754980594476, -86.9583282470703, -1.51770913994137, 218, 2, 'PPL', 'P'),
(25454, 'Thomas Mill', 34.9311103820801, 0.609662887544872, -84.1380615234375, -1.46848619982954, 218, 13, 'PPL', 'P'),
(167916, 'Thomas Mill', 40.225830078125, 0.702073179211049, -78.9875030517578, -1.37859199618224, 218, 45, 'PPL', 'P'),
(167917, 'Thomas Mills', 40.6616706848145, 0.70968003281167, -78.663330078125, -1.37293411044637, 218, 45, 'PPL', 'P'),
(185630, 'Thomas Mountain', 33.6124992370605, 0.586648781510789, -116.626106262207, -2.03550954805629, 218, 6, 'PPL', 'P'),
(98496, 'Thomas Ortega Colonia', 26.2679996490479, 0.4584630817886, -98.265998840332, -1.71506522252472, 218, 51, 'PPL', 'P'),
(6314, 'Thomas Place', 34.3199996948242, 0.598996993958132, -86.9930572509766, -1.51831527540547, 218, 2, 'PPL', 'P'),
(185632, 'Thomas Place', 35.1755599975586, 0.613929338190206, -115.463890075684, -2.01522504898148, 218, 6, 'PPL', 'P'),
(200234, 'Thomas Place', 40.5011100769043, 0.706877721554634, -116.226936340332, -2.02854271864464, 218, 39, 'PPL', 'P'),
(52070, 'Thomas Run', 39.5905609130859, 0.690985640644722, -76.2838897705078, -1.33140504272378, 218, 25, 'PPL', 'P'),
(153102, 'Thomas Settlement', 43.8138885498047, 0.764696613295935, -76.0749969482422, -1.32775917519146, 218, 40, 'PPL', 'P'),
(91312, 'Thomas Springs', 35.8458290100098, 0.62562773933157, -85.2138900756836, -1.4872629502532, 218, 50, 'PPL', 'P'),
(25455, 'Thomas Station', 33.017219543457, 0.576259190887144, -81.9855575561523, -1.43091791843817, 218, 13, 'PPL', 'P'),
(106895, 'Thomas Terrace', 37.3738899230957, 0.65229743343595, -79.0141677856445, -1.37905738358273, 218, 53, 'PPL', 'P'),
(52067, 'Thomas Town', 38.9169387817383, 0.679228716538404, -75.9286117553711, -1.3252042715997, 218, 25, 'PPL', 'P'),
(91313, 'Thomas Town (historical)', 35.8069381713867, 0.624948966148736, -85.9766693115234, -1.50057595938445, 218, 50, 'PPL', 'P'),
(179341, 'Thomas Trailer Court', 33.4808311462402, 0.584350739806159, -112.039436340332, -1.95545705621738, 218, 5, 'PPL', 'P'),
(74538, 'Thomas Village', 39.0333290100098, 0.681260109238889, -82.0630569458008, -1.43227053795583, 218, 41, 'PPL', 'P'),
(25456, 'Thomas Woods', 33.4308280944824, 0.58347802191694, -82.0480575561523, -1.43200874922067, 218, 13, 'PPL', 'P'),
(25457, 'Thomasboro', 32.7194404602051, 0.571061965440827, -81.790283203125, -1.42750973803315, 218, 13, 'PPL', 'P'),
(69393, 'Thomasboro', 33.9386100769043, 0.592340489392506, -78.5555572509766, -1.37105311976845, 218, 33, 'PPL', 'P'),
(121695, 'Thomasboro', 40.2416687011719, 0.702349615332199, -88.1841735839844, -1.53910417719074, 218, 18, 'PPL', 'P'),
(167919, 'Thomasdale', 40.2205581665039, 0.701981166995387, -79.0122222900391, -1.37902342827884, 218, 45, 'PPL', 'P'),
(106896, 'Thomason Park', 38.5400009155273, 0.672649909697581, -77.3305587768555, -1.34967286306313, 218, 53, 'PPL', 'P'),
(185633, 'Thomasson', 38.2172203063965, 0.667016325306655, -122.106391906738, -2.13115857650314, 218, 6, 'PPL', 'P'),
(6315, 'Thomaston', 32.2663917541504, 0.563154773848273, -87.6252822875977, -1.52934968390805, 218, 2, 'PPL', 'P'),
(25460, 'Thomaston', 32.8880615234375, 0.574004958182447, -84.3266677856445, -1.47177800009493, 218, 13, 'PPL', 'P'),
(98497, 'Thomaston', 28.9972190856934, 0.506096946967489, -97.1547164916992, -1.69566968662179, 218, 51, 'PPL', 'P'),
(114161, 'Thomaston', 41.6738891601563, 0.727346577955901, -73.0736083984375, -1.27537506286571, 218, 8, 'PPL', 'P'),
(123793, 'Thomaston', 41.3783302307129, 0.722188101503445, -86.8141708374023, -1.51519311850151, 218, 19, 'PPL', 'P'),
(129067, 'Thomaston', 44.0788917541504, 0.769321791740103, -69.1822204589844, -1.20745753084986, 218, 26, 'PPL', 'P'),
(133390, 'Thomaston', 46.5163917541504, 0.811864192257465, -89.9272232055664, -1.56952613211298, 218, 27, 'PPL', 'P'),
(153103, 'Thomaston', 40.7861099243164, 0.711851907259657, -73.7141723632813, -1.28655501312187, 218, 40, 'PPL', 'P'),
(43344, 'Thomastown', 32.3572196960449, 0.564740020487143, -91.0697174072266, -1.5894664176169, 218, 22, 'PPL', 'P'),
(62015, 'Thomastown', 32.8638916015625, 0.573583113465778, -89.6694412231445, -1.5650269877674, 218, 30, 'PPL', 'P'),
(106897, 'Thomastown', 38.0080604553223, 0.663365797242429, -79.8408279418945, -1.39348532510435, 218, 53, 'PPL', 'P'),
(126342, 'Thomastown', 41.8752784729004, 0.730861484541615, -70.8405609130859, -1.23640103189295, 218, 23, 'PPL', 'P'),
(157930, 'Thomastown', 41.0438919067383, 0.716351051605236, -81.4863891601563, -1.42220578640614, 218, 41, 'PPL', 'P'),
(6316, 'Thomasville', 31.913330078125, 0.55699268513902, -87.7358322143555, -1.53127914411781, 218, 2, 'PPL', 'P'),
(12302, 'Thomasville', 34.7458305358887, 0.606429144191243, -90.9338912963867, -1.58709580477256, 218, 4, 'PPL', 'P'),
(25459, 'Thomasville', 30.836389541626, 0.538196526928918, -83.978889465332, -1.46570812333842, 218, 13, 'PPL', 'P'),
(28776, 'Thomasville', 39.4897193908691, 0.689225624059316, -89.6544418334961, -1.56476519903225, 218, 18, 'PPL', 'P'),
(57881, 'Thomasville', 36.7891693115234, 0.642092133559739, -91.5319366455078, -1.59753366519097, 218, 29, 'PPL', 'P'),
(62011, 'Thomasville', 32.1563911437988, 0.561234901018435, -90.0127792358398, -1.57101936653619, 218, 30, 'PPL', 'P'),
(69396, 'Thomasville', 35.8824996948242, 0.626267763520543, -80.0822219848633, -1.39769844594885, 218, 33, 'PPL', 'P'),
(79258, 'Thomasville', 39.9286117553711, 0.696885740881738, -76.850830078125, -1.34130001775397, 218, 45, 'PPL', 'P'),
(91314, 'Thomasville', 36.413890838623, 0.635542288595771, -87.1336135864258, -1.52076844624359, 218, 50, 'PPL', 'P'),
(118027, 'Thomasville', 42.7538909912109, 0.746196165835373, -91.5808334350586, -1.59838707516228, 218, 16, 'PPL', 'P'),
(153104, 'Thomasville', 44.4747200012207, 0.776230297923878, -73.6144409179688, -1.28481437103339, 218, 40, 'PPL', 'P'),
(187434, 'Thomasville', 39.360279083252, 0.686966464506602, -106.701942443848, -1.86230021391863, 218, 7, 'PPL', 'P'),
(197684, 'Thomasville (historical)', 45.8300018310547, 0.799884428146934, -111.04167175293, -1.93804277900741, 218, 31, 'PPL', 'P'),
(6317, 'Thompson', 32.185001373291, 0.561734243722825, -85.8180618286133, -1.49780773658937, 218, 2, 'PPL', 'P'),
(12304, 'Thompson', 35.9216690063477, 0.626951396972366, -93.9461135864258, -1.63966900153571, 218, 4, 'PPL', 'P'),
(14745, 'Thompson', 39.7291717529297, 0.69340485617895, -75.7569427490234, -1.3222080822153, 218, 10, 'PPL', 'P'),
(18336, 'Thompson', 25.0419406890869, 0.437064316113704, -80.4927825927734, -1.40486408033587, 218, 12, 'PPL', 'P'),
(52068, 'Thompson', 38.535831451416, 0.672577138820795, -76.0311126708984, -1.32699325006196, 218, 25, 'PPL', 'P'),
(57882, 'Thompson', 39.1886100769043, 0.683970275122208, -91.982780456543, -1.60540237410577, 218, 29, 'PPL', 'P'),
(62013, 'Thompson', 32.297779083252, 0.563702586084502, -90.3663864135742, -1.57719097604634, 218, 30, 'PPL', 'P'),
(114163, 'Thompson', 41.958610534668, 0.732315903391934, -71.8630599975586, -1.25424700751563, 218, 8, 'PPL', 'P'),
(118028, 'Thompson', 43.3713912963867, 0.75697357929276, -93.7733306884766, -1.63665337107536, 218, 16, 'PPL', 'P'),
(129069, 'Thompson', 44.8566703796387, 0.78289658960651, -69.4377822875977, -1.21191792620158, 218, 26, 'PPL', 'P'),
(133391, 'Thompson', 45.9049987792969, 0.801193371822708, -86.3302764892578, -1.5067475688946, 218, 27, 'PPL', 'P'),
(140960, 'Thompson', 47.773609161377, 0.833806775426955, -97.1094436645508, -1.69487952672636, 218, 34, 'PPL', 'P'),
(143185, 'Thompson', 40.0683288574219, 0.699324264333869, -97.2583312988281, -1.69747810616, 218, 35, 'PPL', 'P'),
(153105, 'Thompson', 43.003059387207, 0.750544974737418, -76.9641723632813, -1.34327821381168, 218, 40, 'PPL', 'P'),
(157931, 'Thompson', 41.689998626709, 0.727627741187986, -81.0516662597656, -1.41461844046051, 218, 41, 'PPL', 'P'),
(167921, 'Thompson', 41.8636093139648, 0.730657819297251, -75.5147171020508, -1.31798044714286, 218, 45, 'PPL', 'P'),
(176670, 'Thompson', 43.2586097717285, 0.755005170352055, -88.3705596923828, -1.54235722846227, 218, 57, 'PPL', 'P'),
(185634, 'Thompson', 38.2391700744629, 0.667399421029463, -122.280563354492, -2.13419844172941, 218, 6, 'PPL', 'P'),
(62014, 'Thompson (historical)', 33.1166687011719, 0.577994906127603, -89.3791732788086, -1.55996085642575, 218, 30, 'PPL', 'P'),
(69398, 'Thompson (historical)', 35.7900009155273, 0.624653355267737, -78.7149963378906, -1.37383585679147, 218, 33, 'PPL', 'P'),
(84017, 'Thompson (historical)', 33.5777816772461, 0.586042845783768, -79.0386123657227, -1.37948402198936, 218, 48, 'PPL', 'P'),
(190829, 'Thompson (historical)', 39.1611099243164, 0.683490306914749, -119.19750213623, -2.0803888724302, 218, 39, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(208934, 'Thompson (historical)', 48.1394386291504, 0.84019170414042, -119.747222900391, -2.08998330973137, 218, 56, 'PPL', 'P'),
(111704, 'Thompson Acres', 38.413890838623, 0.670448873635658, -82.0325012207031, -1.43173723994754, 218, 58, 'PPL', 'P'),
(98498, 'Thompson Colonia', 26.2810001373291, 0.458689983113475, -98.3519973754883, -1.71656618011509, 218, 51, 'PPL', 'P'),
(52069, 'Thompson Corner', 38.4494400024414, 0.671069323590619, -76.7861099243164, -1.34017043797762, 218, 25, 'PPL', 'P'),
(77441, 'Thompson Corner', 35.9152793884277, 0.626839877101719, -95.0824966430664, -1.65950262743796, 218, 42, 'PPL', 'P'),
(84018, 'Thompson Corner', 33.1269416809082, 0.578174203447993, -79.584716796875, -1.3890153423727, 218, 48, 'PPL', 'P'),
(118029, 'Thompson Corner', 43.2663917541504, 0.755140991567649, -91.2305603027344, -1.59227365572195, 218, 16, 'PPL', 'P'),
(129070, 'Thompson Corner', 44.8549995422363, 0.782867427992573, -69.4749984741211, -1.21256747119145, 218, 26, 'PPL', 'P'),
(144557, 'Thompson Corner', 43.3969383239746, 0.757419459038267, -71.7180633544922, -1.25171633868978, 218, 36, 'PPL', 'P'),
(211107, 'Thompson Corner', 21.5652809143066, 0.376385156072144, -158.115829467773, -2.75964182373452, 218, 15, 'PPL', 'P'),
(114164, 'Thompson Corner (historical)', 41.276668548584, 0.72041377042718, -72.8736114501953, -1.27188445762495, 218, 8, 'PPL', 'P'),
(25461, 'Thompson Crossroad', 33.0750007629395, 0.57726766341293, -84.772216796875, -1.47955429731991, 218, 13, 'PPL', 'P'),
(91315, 'Thompson Crossroads', 35.2619400024414, 0.6154369536833, -88.0491714477539, -1.53674794541629, 218, 50, 'PPL', 'P'),
(179342, 'Thompson Draw Summer Homes Unit One', 34.313060760498, 0.59887588670756, -111.103332519531, -1.93911896240391, 218, 5, 'PPL', 'P'),
(179343, 'Thompson Draw Summer Homes Unit Two', 34.313060760498, 0.59887588670756, -111.117500305176, -1.93936623691112, 218, 5, 'PPL', 'P'),
(52078, 'Thompson Estates', 39.5997200012207, 0.691145496889154, -76.7480621337891, -1.3395063787598, 218, 25, 'PPL', 'P'),
(197685, 'Thompson Falls', 47.5972213745117, 0.830728227785851, -115.343330383301, -2.01312088540421, 218, 31, 'PPL', 'P'),
(12305, 'Thompson Grove', 34.9474983215332, 0.609948911045946, -90.3377838134766, -1.57669176650001, 218, 4, 'PPL', 'P'),
(192320, 'Thompson Grove', 36.4144401550293, 0.635551875975696, -102.803886413574, -1.79426630176314, 218, 51, 'PPL', 'P'),
(111705, 'Thompson Heights', 38.4169387817383, 0.670502070278432, -82.0358276367188, -1.4317952968593, 218, 58, 'PPL', 'P'),
(138428, 'Thompson Heights', 45.1830596923828, 0.788593157757216, -93.3375015258789, -1.62904671721182, 218, 28, 'PPL', 'P'),
(106898, 'Thompson Landing', 36.7733306884766, 0.641815697438589, -76.557502746582, -1.33618049003246, 218, 53, 'PPL', 'P'),
(25462, 'Thompson Mill', 34.3663902282715, 0.599806661508543, -83.85888671875, -1.46361368029913, 218, 13, 'PPL', 'P'),
(91316, 'Thompson Mill', 36.5827789306641, 0.638489941869298, -83.3686065673828, -1.4550566774006, 218, 50, 'PPL', 'P'),
(79259, 'Thompson Number 1', 39.9433288574219, 0.697142602768876, -79.883056640625, -1.39422235493603, 218, 45, 'PPL', 'P'),
(79260, 'Thompson Number 2', 39.9605598449707, 0.697443340234974, -79.8927764892578, -1.39439199829746, 218, 45, 'PPL', 'P'),
(189659, 'Thompson Place', 34.9438896179199, 0.609885927286166, -106.136108398438, -1.85242454680634, 218, 38, 'PPL', 'P'),
(194011, 'Thompson Place', 40.1602783203125, 0.700929085206751, -121.972778320313, -2.12882657949461, 218, 6, 'PPL', 'P'),
(208935, 'Thompson Place', 47.0555610656738, 0.82127447196926, -122.782218933105, -2.14295398328721, 218, 56, 'PPL', 'P'),
(153106, 'Thompson Ridge', 41.5680618286133, 0.725499542581877, -74.3302764892578, -1.29730805865528, 218, 40, 'PPL', 'P'),
(138437, 'Thompson Riverview Terrace', 45.1575012207031, 0.788147078274628, -93.331672668457, -1.62894498445818, 218, 28, 'PPL', 'P'),
(192816, 'Thompson Springs', 38.9711112976074, 0.680174205304409, -109.71305847168, -1.91485410276387, 218, 52, 'PPL', 'P'),
(12306, 'Thompson Subdivision', 33.584171295166, 0.586154365654415, -94.0311126708984, -1.64115251542094, 218, 4, 'PPL', 'P'),
(111706, 'Thompson Town', 37.8486099243164, 0.660582860482323, -82.0266723632813, -1.4316355071939, 218, 58, 'PPL', 'P'),
(106899, 'Thompson Valley', 37.0783309936523, 0.647138956983494, -81.5477828979492, -1.42327730927074, 218, 53, 'PPL', 'P'),
(172641, 'Thompsonburg', 43.2077789306641, 0.754118004813923, -72.7805633544922, -1.27026046199222, 218, 55, 'PPL', 'P'),
(98499, 'Thompsons', 29.4974994659424, 0.514828486785963, -95.584716796875, -1.6682680226918, 218, 51, 'PPL', 'P'),
(106900, 'Thompsons', 36.7666702270508, 0.641699450457007, -79.1172180175781, -1.38085594942492, 218, 53, 'PPL', 'P'),
(84019, 'Thompsons (historical)', 34.6963882446289, 0.60556621341903, -79.9819412231445, -1.39594821648045, 218, 48, 'PPL', 'P'),
(52072, 'Thompsons Corner', 39.2422218322754, 0.684905976771208, -77.3263931274414, -1.34960015876537, 218, 25, 'PPL', 'P'),
(57883, 'Thompsons Corner', 36.6558303833008, 0.639764930241174, -93.855827331543, -1.63809320911871, 218, 29, 'PPL', 'P'),
(153108, 'Thompsons Corner', 43.288330078125, 0.755523887553375, -75.7683334350586, -1.32240688719068, 218, 40, 'PPL', 'P'),
(153113, 'Thompsons Crossing', 42.7802810668945, 0.746656759545902, -78.1494369506836, -1.36396498336915, 218, 40, 'PPL', 'P'),
(91317, 'Thompsons Crossroads', 36.1500015258789, 0.630936551227561, -87.5316696166992, -1.52771583457928, 218, 50, 'PPL', 'P'),
(153109, 'Thompsons Lake', 42.6427803039551, 0.744256918508604, -74.0444412231445, -1.29231929214329, 218, 40, 'PPL', 'P'),
(25463, 'Thompsons Mill', 34.1127815246582, 0.595380354618777, -83.8177795410156, -1.46289622470146, 218, 13, 'PPL', 'P'),
(167924, 'Thompsons Mills', 41.6730613708496, 0.727332130306987, -79.6805572509766, -1.39068807385338, 218, 45, 'PPL', 'P'),
(52073, 'Thompsons Purchase', 39.1958312988281, 0.684096309220796, -76.7874984741211, -1.34019467274354, 218, 25, 'PPL', 'P'),
(91318, 'Thompsons Station', 35.8019409179688, 0.624861747623036, -86.9113922119141, -1.51688995159006, 218, 50, 'PPL', 'P'),
(91319, 'Thompsons Store', 36.6066703796387, 0.638906926316977, -85.4227828979492, -1.49090881778552, 218, 50, 'PPL', 'P'),
(52074, 'Thompsontown', 38.5747184753418, 0.673255845424601, -75.9005584716797, -1.32471464943329, 218, 25, 'PPL', 'P'),
(71474, 'Thompsontown', 39.416389465332, 0.687945775418451, -74.7091674804688, -1.30392095395806, 218, 37, 'PPL', 'P'),
(167926, 'Thompsontown', 40.5644416809082, 0.707983066565071, -77.2375030517578, -1.34804873427234, 218, 45, 'PPL', 'P'),
(167927, 'Thompsontown Station', 40.5519409179688, 0.707764887092766, -77.2366714477539, -1.3480342200444, 218, 45, 'PPL', 'P'),
(14747, 'Thompsonville', 38.999439239502, 0.680668621160783, -75.3899993896484, -1.31580371242588, 218, 10, 'PPL', 'P'),
(25464, 'Thompsonville', 34.8633308410645, 0.608479911388659, -85.4075012207031, -1.49064210220235, 218, 13, 'PPL', 'P'),
(28777, 'Thompsonville', 37.9174995422363, 0.661785211135467, -88.7622222900391, -1.54919303034828, 218, 18, 'PPL', 'P'),
(34127, 'Thompsonville', 39.1055603027344, 0.682520783119905, -95.4333267211914, -1.66562576741627, 218, 20, 'PPL', 'P'),
(38524, 'Thompsonville', 37.7269401550293, 0.658459322408121, -85.1369400024414, -1.48591991811547, 218, 21, 'PPL', 'P'),
(62016, 'Thompsonville', 32.0591697692871, 0.559538067929891, -90.4591674804688, -1.57881031114716, 218, 30, 'PPL', 'P'),
(98501, 'Thompsonville', 27.2052803039551, 0.47482171523198, -98.9400024414063, -1.72682880453377, 218, 51, 'PPL', 'P'),
(114166, 'Thompsonville', 41.996940612793, 0.732984889457762, -72.5994415283203, -1.26709928977829, 218, 8, 'PPL', 'P'),
(126343, 'Thompsonville', 42.3152809143066, 0.738540975860967, -71.1847229003906, -1.24240779173162, 218, 23, 'PPL', 'P'),
(133393, 'Thompsonville', 44.5202789306641, 0.777025451246348, -85.9438934326172, -1.5000039123823, 218, 27, 'PPL', 'P'),
(153110, 'Thompsonville', 41.6680603027344, 0.72724484520226, -74.6255569458008, -1.30246167483875, 218, 40, 'PPL', 'P'),
(167929, 'Thompsonville', 40.290828704834, 0.703207619256396, -80.1083297729492, -1.39815411281137, 218, 45, 'PPL', 'P'),
(176671, 'Thompsonville', 42.7786102294922, 0.746627597931966, -87.9527816772461, -1.53506562655569, 218, 57, 'PPL', 'P'),
(192817, 'Thompsonville', 38.4169387817383, 0.670502070278432, -112.215827941895, -1.95853567043751, 218, 52, 'PPL', 'P'),
(57884, 'Thoms', 37.1441688537598, 0.648288044414836, -94.5558319091797, -1.6503105937775, 218, 29, 'PPL', 'P'),
(193316, 'Thoms Place', 56.2019386291504, 0.980908875082463, -132.184997558594, -2.30706342913813, 218, 1, 'PPL', 'P'),
(25465, 'Thomson', 33.4705581665039, 0.58417144248577, -82.5047225952148, -1.43997905773106, 218, 13, 'PPL', 'P'),
(38525, 'Thomson', 38.0058288574219, 0.663326848511486, -84.0261077880859, -1.46653223853775, 218, 21, 'PPL', 'P'),
(121697, 'Thomson', 41.9588890075684, 0.732320763660924, -90.0991668701172, -1.57252711518734, 218, 18, 'PPL', 'P'),
(138430, 'Thomson', 46.6636085510254, 0.814433610077173, -92.3977813720703, -1.61264550648051, 218, 28, 'PPL', 'P'),
(153111, 'Thomson', 43.1258316040039, 0.752687754150496, -73.5833282470703, -1.28427135248712, 218, 40, 'PPL', 'P'),
(157935, 'Thomsontown (historical)', 41.211669921875, 0.719279330381833, -82.8794403076172, -1.44651911557802, 218, 41, 'PPL', 'P'),
(57885, 'Thomure', 38.0038909912109, 0.663293026365642, -90.059440612793, -1.57183376119754, 218, 29, 'PPL', 'P'),
(12308, 'Thomwall (historical)', 34.2675018310547, 0.59808073338509, -91.3447189331055, -1.59426609969149, 218, 4, 'PPL', 'P'),
(18337, 'Thonotosassa', 28.0611095428467, 0.489758753285475, -82.3024978637695, -1.43644957033838, 218, 12, 'PPL', 'P'),
(84020, 'Thor', 33.7105598449707, 0.588360261985328, -81.2588882446289, -1.41823514637889, 218, 48, 'PPL', 'P'),
(118031, 'Thor', 42.688060760498, 0.745047211562085, -94.0491714477539, -1.64146770053595, 218, 16, 'PPL', 'P'),
(138433, 'Thor', 46.4761085510254, 0.811161117729684, -93.4205627441406, -1.6304964089512, 218, 28, 'PPL', 'P'),
(189660, 'Thoreau', 35.4025001525879, 0.617890191100454, -108.222778320313, -1.88884380734539, 218, 38, 'PPL', 'P'),
(195713, 'Thorenson', 42.0833282470703, 0.734492638108911, -111.991668701172, -1.95462335363813, 218, 17, 'PPL', 'P'),
(138434, 'Thorhult', 48.230281829834, 0.841777217095399, -95.2477798461914, -1.66238736353074, 218, 28, 'PPL', 'P'),
(62017, 'Thorn', 33.9425010681152, 0.592408400000303, -89.1025009155273, -1.55513201273721, 218, 30, 'PPL', 'P'),
(185635, 'Thorn', 34.475830078125, 0.601716747221375, -117.279998779297, -2.04692212543366, 218, 6, 'PPL', 'P'),
(106903, 'Thorn Ferry', 36.8586082458496, 0.643304071592807, -80.9291687011719, -1.41248045473739, 218, 53, 'PPL', 'P'),
(91320, 'Thorn Grove', 36.0044403076172, 0.62839602870568, -83.6933288574219, -1.4607241505164, 218, 50, 'PPL', 'P'),
(91321, 'Thorn Hill', 36.3583297729492, 0.634572565063846, -83.4175033569336, -1.45591008737191, 218, 50, 'PPL', 'P'),
(98502, 'Thorn Hill', 29.7430591583252, 0.519114311928228, -98.0988922119141, -1.71214866165692, 218, 51, 'PPL', 'P'),
(153112, 'Thorn Hill', 42.8977813720703, 0.748707526743318, -76.341667175293, -1.33241344867054, 218, 40, 'PPL', 'P'),
(157936, 'Thorn Hill', 41.1241683959961, 0.717752140654727, -80.6163864135742, -1.40702137397689, 218, 41, 'PPL', 'P'),
(194012, 'Thorn Junction', 40.0636100769043, 0.699241906077159, -123.962501525879, -2.16355380063508, 218, 6, 'PPL', 'P'),
(176672, 'Thornapple', 45.4097213745117, 0.792549150398475, -91.2194366455078, -1.59207951127848, 218, 57, 'PPL', 'P'),
(98503, 'Thornberry', 34.0580596923828, 0.594425278472847, -98.3888931274414, -1.71721013246667, 218, 51, 'PPL', 'P'),
(52077, 'Thornbrook', 39.3011093139648, 0.685933757214896, -76.8430633544922, -1.34116446285449, 218, 25, 'PPL', 'P'),
(12309, 'Thornburg', 34.9341697692871, 0.609716283924728, -92.8063888549805, -1.61977705240558, 218, 4, 'PPL', 'P'),
(34128, 'Thornburg', 39.9444389343262, 0.697161977265807, -98.7858276367188, -1.72413794656835, 218, 20, 'PPL', 'P'),
(106901, 'Thornburg', 38.1333312988281, 0.665552185918357, -77.5219421386719, -1.35301313286036, 218, 53, 'PPL', 'P'),
(118032, 'Thornburg', 41.454719543457, 0.723521346524166, -92.335563659668, -1.61155960254603, 218, 16, 'PPL', 'P'),
(167936, 'Thornburg', 40.434440612793, 0.705714119895351, -80.0824966430664, -1.39770323963881, 218, 45, 'PPL', 'P'),
(194449, 'Thornburgh', 40.2069396972656, 0.701743479868097, -107.695281982422, -1.87963725945699, 218, 7, 'PPL', 'P'),
(106902, 'Thorncliff', 37.6469383239746, 0.657063027048593, -77.8422164916992, -1.35860297483038, 218, 53, 'PPL', 'P'),
(6318, 'Thorndale', 33.3083305358887, 0.581340036193825, -87.6319427490234, -1.52946593088963, 218, 2, 'PPL', 'P'),
(98506, 'Thorndale', 30.6136093139648, 0.534308278447889, -97.2052764892578, -1.69655212504898, 218, 51, 'PPL', 'P'),
(167931, 'Thorndale', 41.4244384765625, 0.722992842205839, -76.4211120605469, -1.33380002349209, 218, 45, 'PPL', 'P'),
(209783, 'Thorndale Acres', 42.8197212219238, 0.74734512010866, -106.3125, -1.85550316102647, 218, 59, 'PPL', 'P'),
(126344, 'Thorndike', 42.1875, 0.736310778185108, -72.3361129760742, -1.26250333952709, 218, 23, 'PPL', 'P'),
(129071, 'Thorndike', 44.5780601501465, 0.778033923772134, -69.2763900756836, -1.2091011007166, 218, 26, 'PPL', 'P'),
(98504, 'Thorne', 33.6333312988281, 0.587012369578612, -96.7863922119141, -1.6892412152245, 218, 51, 'PPL', 'P'),
(140963, 'Thorne', 48.7391700744629, 0.850658992488867, -99.9311065673828, -1.74412683476216, 218, 34, 'PPL', 'P'),
(190830, 'Thorne', 38.6019401550293, 0.673730953363072, -118.590560913086, -2.06979574972024, 218, 39, 'PPL', 'P'),
(193317, 'Thorne Bay', 55.6877784729004, 0.971935087473332, -132.522216796875, -2.3129490151472, 218, 1, 'PPL', 'P'),
(106905, 'Thornecrest', 37.3316688537598, 0.651560536762325, -79.9861068725586, -1.39602092077821, 218, 53, 'PPL', 'P'),
(12310, 'Thorney', 35.9952812194824, 0.628236172461248, -93.9322204589844, -1.63942652071846, 218, 4, 'PPL', 'P'),
(57886, 'Thornfield', 36.708610534668, 0.640686117662232, -92.6591720581055, -1.61720763458587, 218, 29, 'PPL', 'P'),
(25466, 'Thornhedge', 33.5852813720703, 0.586173740151346, -84.4513931274414, -1.47395486796996, 218, 13, 'PPL', 'P'),
(6321, 'Thornhill', 33.4000015258789, 0.582939996797717, -86.1405563354492, -1.50343632755325, 218, 2, 'PPL', 'P'),
(38526, 'Thornhill', 38.288330078125, 0.668257424953659, -85.6258316040039, -1.49445268624809, 218, 21, 'PPL', 'P'),
(106904, 'Thornhill', 38.1541709899902, 0.665915907144234, -77.9683303833008, -1.36080407747133, 218, 53, 'PPL', 'P'),
(157937, 'Thornhill', 40.4822196960449, 0.706548022211682, -81.1936111450195, -1.41709584606455, 218, 41, 'PPL', 'P'),
(123795, 'Thornhope', 40.9258308410645, 0.714290497290815, -86.5294418334961, -1.51022365990743, 218, 19, 'PPL', 'P'),
(167932, 'Thornhurst', 41.1783294677734, 0.718697429683651, -75.5808334350586, -1.31913439484319, 218, 45, 'PPL', 'P'),
(52079, 'Thornleigh', 39.4172210693359, 0.687960289646392, -76.6513900756836, -1.33781913305118, 218, 25, 'PPL', 'P'),
(74539, 'Thornport', 39.9130592346191, 0.696614298187632, -82.4111099243164, -1.4383452084023, 218, 41, 'PPL', 'P'),
(167934, 'Thornridge', 40.1736106872559, 0.701161778906997, -74.8238906860352, -1.30592325162363, 218, 45, 'PPL', 'P'),
(351, 'Thornton', 33.7788887023926, 0.589552825521465, -92.4916687011719, -1.61428414949924, 218, 4, 'PPL', 'P'),
(718, 'Thornton', 33.0791702270508, 0.577340434289716, -90.3225021362305, -1.57642505091683, 218, 30, 'PPL', 'P'),
(6324, 'Thornton', 32.7019386291504, 0.570756500863795, -85.7480621337891, -1.49658601143929, 218, 2, 'PPL', 'P'),
(31307, 'Thornton', 38.9166717529297, 0.679224056006496, -86.5013885498047, -1.50973403774101, 218, 19, 'PPL', 'P'),
(38527, 'Thornton', 37.1733283996582, 0.64879697449915, -82.7786102294922, -1.4447592987297, 218, 21, 'PPL', 'P'),
(57888, 'Thornton', 39.1511116027832, 0.683315803284321, -94.524169921875, -1.64975798785131, 218, 29, 'PPL', 'P'),
(91322, 'Thornton', 35.8822212219238, 0.626262903251554, -84.148063659668, -1.468660770039, 218, 50, 'PPL', 'P'),
(98505, 'Thornton', 31.4108295440674, 0.548222396326685, -96.5719375610352, -1.68549827547045, 218, 51, 'PPL', 'P'),
(112536, 'Thornton', 39.9072189331055, 0.696512365696909, -75.5319366455078, -1.31828098487187, 218, 45, 'PPL', 'P'),
(112661, 'Thornton', 39.3455581665039, 0.686709536040437, -79.9422225952148, -1.39525499564871, 218, 58, 'PPL', 'P'),
(118033, 'Thornton', 42.9447212219238, 0.749526781673653, -93.3844375610352, -1.62986590556313, 218, 16, 'PPL', 'P'),
(121701, 'Thornton', 41.5680618286133, 0.725499542581877, -87.6080627441406, -1.52904914617903, 218, 18, 'PPL', 'P'),
(133395, 'Thornton', 42.9686088562012, 0.749943699542305, -82.6175003051758, -1.44194740009274, 218, 27, 'PPL', 'P'),
(144559, 'Thornton', 43.8927803039551, 0.766073534158534, -71.6763916015625, -1.25098902939608, 218, 36, 'PPL', 'P'),
(153114, 'Thornton', 42.2638893127441, 0.737644023205829, -79.1575012207031, -1.3815590239527, 218, 40, 'PPL', 'P'),
(169630, 'Thornton', 41.7941703796387, 0.729445881264183, -71.478889465332, -1.24754196683913, 218, 47, 'PPL', 'P'),
(176674, 'Thornton', 44.7966690063477, 0.781849368086863, -88.6911087036133, -1.54795186412225, 218, 57, 'PPL', 'P'),
(185636, 'Thornton', 38.2261085510254, 0.667171454440152, -121.423606872559, -2.11924172957336, 218, 6, 'PPL', 'P'),
(187435, 'Thornton', 39.8680610656738, 0.695828931982168, -104.971389770508, -1.83209637188966, 218, 7, 'PPL', 'P'),
(195714, 'Thornton', 43.7583312988281, 0.763726956343038, -111.844436645508, -1.95205366950231, 218, 17, 'PPL', 'P'),
(208936, 'Thornton', 47.1208305358887, 0.822413639125541, -117.388610839844, -2.04881776349758, 218, 56, 'PPL', 'P'),
(209784, 'Thornton', 44.1627807617188, 0.770785931128402, -104.742782592773, -1.8281064239445, 218, 59, 'PPL', 'P'),
(74540, 'Thornton (historical)', 39.3919410705566, 0.687519070432793, -83.3249969482422, -1.45429554596105, 218, 41, 'PPL', 'P'),
(25477, 'Thornton Estates', 33.5027809143066, 0.584733835528967, -84.3300018310547, -1.47183619016475, 218, 13, 'PPL', 'P'),
(38528, 'Thornton Gap', 37.2024993896484, 0.649306104320546, -82.7925033569336, -1.44500177954695, 218, 21, 'PPL', 'P'),
(153115, 'Thornton Grove', 42.8838882446289, 0.748465045926066, -76.4088897705078, -1.33358670428878, 218, 40, 'PPL', 'P'),
(25467, 'Thornton Heights', 32.8294410705566, 0.572981838270665, -83.5299987792969, -1.45787350288557, 218, 13, 'PPL', 'P'),
(129073, 'Thornton Heights', 43.6216697692871, 0.761341762691735, -70.3055572509766, -1.22706345647891, 218, 26, 'PPL', 'P'),
(153116, 'Thornton Heights', 42.8800010681152, 0.748397201897296, -76.4086074829102, -1.33358177744076, 218, 40, 'PPL', 'P'),
(121702, 'Thornton Junction', 41.589168548584, 0.725867924339662, -87.6069412231445, -1.52902957194502, 218, 18, 'PPL', 'P'),
(167935, 'Thornton Junction', 41.9913902282715, 0.732888016973111, -80.3755569458008, -1.40281810682842, 218, 45, 'PPL', 'P'),
(6325, 'Thornton Springs', 31.9019393920898, 0.556793880163646, -88.2161102294922, -1.53966157680689, 218, 2, 'PPL', 'P'),
(25468, 'Thornton Woods', 33.5699996948242, 0.585907024568174, -84.4722213745117, -1.47431838945876, 218, 13, 'PPL', 'P'),
(153117, 'Thorntons Corner', 43.1747207641602, 0.753541030963757, -77.0113906860352, -1.34410232901101, 218, 40, 'PPL', 'P'),
(144561, 'Thorntons Ferry', 42.8419418334961, 0.747732942942403, -71.4930572509766, -1.24778924134635, 218, 36, 'PPL', 'P'),
(6326, 'Thorntontown', 34.8394393920898, 0.608062926940979, -87.3555603027344, -1.52464214720717, 218, 2, 'PPL', 'P'),
(192321, 'Thorntonville', 31.5827808380127, 0.551223512559095, -102.920280456543, -1.79629776104265, 218, 51, 'PPL', 'P'),
(14749, 'Thorntown', 39.5177803039551, 0.689715379383782, -75.6030578613281, -1.31952228425596, 218, 10, 'PPL', 'P'),
(123796, 'Thorntown', 40.1294403076172, 0.700390860350446, -86.6066665649414, -1.51157148573512, 218, 19, 'PPL', 'P'),
(74541, 'Thornville', 39.8963890075684, 0.696323347838541, -82.420280456543, -1.43850526438381, 218, 41, 'PPL', 'P'),
(133396, 'Thornville', 42.9425010681152, 0.749488032679793, -83.2238922119141, -1.45253093542277, 218, 27, 'PPL', 'P'),
(43345, 'Thornwell', 30.0983295440674, 0.52531494989426, -92.7972183227539, -1.61961699642407, 218, 22, 'PPL', 'P'),
(84021, 'Thornwood', 34.9013900756836, 0.609144170343552, -82.3186111450195, -1.43673080014949, 218, 48, 'PPL', 'P'),
(111708, 'Thornwood', 38.5583305358887, 0.672969821923527, -79.7372207641602, -1.39167703872418, 218, 58, 'PPL', 'P'),
(153118, 'Thornwood', 41.1233291625977, 0.717737493268732, -73.7794418334961, -1.28769418027815, 218, 40, 'PPL', 'P'),
(167937, 'Thornwood', 40.1130599975586, 0.700104970007426, -79.585563659668, -1.38903012291675, 218, 45, 'PPL', 'P'),
(208937, 'Thornwood', 48.583610534668, 0.847943966336559, -122.22917175293, -2.13330148907427, 218, 56, 'PPL', 'P'),
(84022, 'Thornwood Acres', 34.9008293151855, 0.609134383226546, -82.3086090087891, -1.43655622994004, 218, 48, 'PPL', 'P'),
(111709, 'Thorny Creek', 38.2527809143066, 0.667636974998698, -80.0372161865234, -1.39691294658533, 218, 58, 'PPL', 'P'),
(71475, 'Thorofare', 39.8422203063965, 0.695377925651563, -75.1966705322266, -1.31242948732475, 218, 37, 'PPL', 'P'),
(38529, 'Thoroughbred Acres', 38.0816688537598, 0.664650506152283, -84.4550018310547, -1.47401785172974, 218, 21, 'PPL', 'P'),
(106906, 'Thoroughgood', 36.8916702270508, 0.643881112022, -76.1294403076172, -1.3287093910684, 218, 53, 'PPL', 'P'),
(176675, 'Thorp', 44.961109161377, 0.784719390214614, -90.7997207641602, -1.58475408722606, 218, 57, 'PPL', 'P'),
(208938, 'Thorp', 47.0680618286133, 0.821492651441565, -120.669998168945, -2.10608877642362, 218, 56, 'PPL', 'P'),
(98507, 'Thorp Spring', 32.4738883972168, 0.566776273456617, -97.8263931274414, -1.70739265542421, 218, 51, 'PPL', 'P'),
(57889, 'Thorpe', 37.4858283996582, 0.654251128411632, -92.9980621337891, -1.62312238220888, 218, 29, 'PPL', 'P'),
(111710, 'Thorpe', 37.3686103820801, 0.652205288062234, -81.5166702270508, -1.42273429072447, 218, 58, 'PPL', 'P'),
(118034, 'Thorpe', 42.5661087036133, 0.742918746639867, -91.4491729736328, -1.59608916661571, 218, 16, 'PPL', 'P'),
(74542, 'Thorps', 39.8800010681152, 0.696037324337466, -83.7072219848633, -1.46096663133365, 218, 41, 'PPL', 'P'),
(6327, 'Thorsby', 32.9155616760254, 0.574484926389906, -86.7158279418945, -1.51347671117896, 218, 2, 'PPL', 'P'),
(118035, 'Thoten', 43.3097190856934, 0.755897196159177, -91.6397171020508, -1.59941478902694, 218, 16, 'PPL', 'P'),
(153119, 'Thousand Island Park', 44.2869415283203, 0.772952945307399, -76.0280609130859, -1.32693998684016, 218, 40, 'PPL', 'P'),
(57890, 'Thousand Oaks', 37.9897193908691, 0.663045685279401, -91.4625015258789, -1.59632179373692, 218, 29, 'PPL', 'P'),
(185637, 'Thousand Oaks', 34.1705589294434, 0.596388760565535, -118.836669921875, -2.07409116224243, 218, 6, 'PPL', 'P'),
(185639, 'Thousand Palms', 33.8199996948242, 0.59027034769816, -116.389442443848, -2.03137898520558, 218, 6, 'PPL', 'P'),
(38530, 'Thousandsticks', 37.185001373291, 0.649000706322541, -83.4288864135742, -1.45610875918923, 218, 21, 'PPL', 'P'),
(34129, 'Thrall', 38.0099983215332, 0.663399619388273, -96.3208312988281, -1.68111564442256, 218, 20, 'PPL', 'P'),
(98508, 'Thrall', 30.5902805328369, 0.533901114406729, -97.2966690063477, -1.69814722538389, 218, 51, 'PPL', 'P'),
(208939, 'Thrall', 46.9305610656738, 0.819092810404267, -120.51000213623, -2.10329631886262, 218, 56, 'PPL', 'P'),
(57892, 'Thralls Prairie (historical)', 39.0130615234375, 0.680906374867099, -92.5550003051758, -1.61538949450967, 218, 29, 'PPL', 'P'),
(114167, 'Thralltown', 41.8822212219238, 0.730982658371213, -72.6552810668945, -1.26807387357921, 218, 8, 'PPL', 'P'),
(111711, 'Thrash (historical)', 38.6291694641113, 0.674206194459596, -80.6402816772461, -1.4074384250036, 218, 58, 'PPL', 'P'),
(62018, 'Thrasher', 34.7194404602051, 0.605968550480714, -88.5338897705078, -1.54520787609309, 218, 30, 'PPL', 'P'),
(12311, 'Thrasher (historical)', 33.6611099243164, 0.587497198055061, -93.8138885498047, -1.6373612392931, 218, 4, 'PPL', 'P'),
(6328, 'Thrasher Crossroads', 34.2788887023926, 0.598279471781437, -86.4813919067383, -1.50938503048016, 218, 2, 'PPL', 'P'),
(98509, 'Thrasher Terrace Colonia', 26.2310009002686, 0.457817331803283, -98.1880035400391, -1.71370394773353, 218, 51, 'PPL', 'P'),
(208940, 'Thrashers Corner', 47.8091697692871, 0.834427425118998, -122.206672668457, -2.13290880597154, 218, 56, 'PPL', 'P'),
(62019, 'Threadville', 31.9741706848145, 0.558054554044662, -88.5113906860352, -1.54481519299036, 218, 30, 'PPL', 'P'),
(185640, 'Three Arch Bay', 33.4908294677734, 0.584525243436587, -117.731391906738, -2.05480042172839, 218, 6, 'PPL', 'P'),
(190831, 'Three Bar (historical)', 39.8033294677734, 0.694699152468729, -116.468887329102, -2.03276556002713, 218, 39, 'PPL', 'P'),
(146453, 'Three Bridges', 40.519718170166, 0.707202494049569, -74.7997207641602, -1.30550140690696, 218, 37, 'PPL', 'P'),
(12312, 'Three Brothers', 36.4524993896484, 0.636216134930589, -92.4655609130859, -1.61382848263672, 218, 4, 'PPL', 'P'),
(52080, 'Three Brothers', 38.5727806091309, 0.673222023278757, -76.79638671875, -1.34034980187703, 218, 25, 'PPL', 'P'),
(111712, 'Three Churches', 39.4008293151855, 0.68767419956629, -78.6544418334961, -1.37277898131287, 218, 58, 'PPL', 'P'),
(133397, 'Three Churches Corner', 43.6674995422363, 0.762141643125141, -84.0086135864258, -1.46622690711877, 218, 27, 'PPL', 'P'),
(192322, 'Three Corner Windmill', 31.6352806091309, 0.552139806421651, -103.059722900391, -1.79873149080482, 218, 51, 'PPL', 'P'),
(195715, 'Three Creek', 42.0713882446289, 0.734284245753612, -115.15860748291, -2.00989686258856, 218, 17, 'PPL', 'P'),
(12313, 'Three Creeks', 33.0944404602051, 0.577606950135806, -92.8536071777344, -1.6206011676049, 218, 4, 'PPL', 'P'),
(185641, 'Three Crossing', 39.3166694641113, 0.686205333067057, -122.920280456543, -2.14536361144151, 218, 6, 'PPL', 'P'),
(6331, 'Three Forks', 33.5533294677734, 0.585616074219083, -87.3330612182617, -1.52424946410444, 218, 2, 'PPL', 'P'),
(12314, 'Three Forks', 35.3377799987793, 0.616760611324097, -90.445556640625, -1.57857275717793, 218, 4, 'PPL', 'P'),
(25471, 'Three Forks', 34.9677810668945, 0.610302911733845, -83.2136077880859, -1.4523514383653, 218, 13, 'PPL', 'P'),
(38532, 'Three Forks', 36.9530601501465, 0.644952568307566, -86.2038879394531, -1.50454167256369, 218, 21, 'PPL', 'P'),
(69402, 'Three Forks', 35.644718170166, 0.622117693014845, -83.2622222900391, -1.45319992148859, 218, 33, 'PPL', 'P'),
(74543, 'Three Forks', 39.6908302307129, 0.692735670376041, -81.5341720581055, -1.4230397553015, 218, 41, 'PPL', 'P'),
(91324, 'Three Forks', 35.0522193908691, 0.611776638502068, -86.1061096191406, -1.50283511893716, 218, 50, 'PPL', 'P'),
(106909, 'Three Forks', 36.8125, 0.642499330890413, -82.658332824707, -1.44266006200044, 218, 53, 'PPL', 'P'),
(179344, 'Three Forks', 33.8547210693359, 0.590876350004208, -109.313606262207, -1.9078823465042, 218, 5, 'PPL', 'P'),
(189661, 'Three Forks', 32.351390838623, 0.564638287733502, -104.781669616699, -1.82878513054831, 218, 38, 'PPL', 'P'),
(197688, 'Three Forks', 45.8925018310547, 0.800975258929431, -111.551391601563, -1.94693906862882, 218, 31, 'PPL', 'P'),
(201650, 'Three Forks', 44.2833290100098, 0.772889894968591, -119.627777099609, -2.08789858723006, 218, 43, 'PPL', 'P'),
(206123, 'Three Forks', 40.0844383239746, 0.699605427565954, -111.354721069336, -1.94350652029981, 218, 52, 'PPL', 'P'),
(209786, 'Three Forks', 41.3974990844727, 0.722522661115386, -110.979438781738, -1.93695660875682, 218, 59, 'PPL', 'P'),
(197689, 'Three Forks Junction', 45.898609161377, 0.801081851952061, -111.598892211914, -1.94776811067616, 218, 31, 'PPL', 'P'),
(84023, 'Three Fountains', 33.9425010681152, 0.592408400000303, -81.1563873291016, -1.41644616791663, 218, 48, 'PPL', 'P'),
(106910, 'Three Fountains', 37.413890838623, 0.652995581115715, -79.2055587768555, -1.38239778653802, 218, 53, 'PPL', 'P'),
(179345, 'Three Fountains', 33.5186080932617, 0.585010071913036, -112.188056945801, -1.95805097511912, 218, 5, 'PPL', 'P'),
(206119, 'Three Fountains Bountiful Condominium', 40.8822212219238, 0.71352936585127, -111.873611450195, -1.95256286590274, 218, 52, 'PPL', 'P'),
(206120, 'Three Fountains East Condominium', 40.6277809143066, 0.709088544733563, -111.862503051758, -1.95236898777538, 218, 52, 'PPL', 'P'),
(206121, 'Three Fountains Manor House Condominium', 40.663890838623, 0.70971878180553, -111.870277404785, -1.95250467583292, 218, 52, 'PPL', 'P'),
(206122, 'Three Fountains North Ogden Condominium', 41.3033294677734, 0.720879091248644, -111.969436645508, -1.95423533106731, 218, 52, 'PPL', 'P'),
(206125, 'Three Fountains Townhomes and Manor Houses', 40.6622200012207, 0.709689620191594, -111.866668701172, -1.95244169207314, 218, 52, 'PPL', 'P'),
(206124, 'Three Fountains Young American Family Condominium', 40.6616706848145, 0.70968003281167, -111.869171142578, -1.95248536791502, 218, 52, 'PPL', 'P'),
(57893, 'Three Island Resort', 37.9191703796387, 0.661814372749403, -92.0316696166992, -1.60625565091903, 218, 29, 'PPL', 'P'),
(18338, 'Three Lakes', 25.6416702270508, 0.447531571172638, -80.3986129760742, -1.40322051046913, 218, 12, 'PPL', 'P'),
(133398, 'Three Lakes', 46.5544395446777, 0.812528251475276, -88.2011108398438, -1.53939978807173, 218, 27, 'PPL', 'P'),
(176678, 'Three Lakes', 45.7983283996582, 0.799331622483661, -89.1627807617188, -1.55618409452585, 218, 57, 'PPL', 'P'),
(208941, 'Three Lakes', 47.9449996948242, 0.836798104542359, -122.010276794434, -2.1294810513325, 218, 56, 'PPL', 'P'),
(192323, 'Three Leagues', 32.4955596923828, 0.567154508910436, -101.971672058105, -1.77974142117784, 218, 51, 'PPL', 'P'),
(157938, 'Three Legs Town (historical)', 40.4272193908691, 0.705588085796763, -81.3691711425781, -1.42015994605674, 218, 41, 'PPL', 'P'),
(74544, 'Three Locks', 39.253059387207, 0.68509512778763, -82.9091720581055, -1.44703803251642, 218, 41, 'PPL', 'P'),
(201651, 'Three Lynx', 45.1263885498047, 0.787604059728361, -122.070281982422, -2.13052833943117, 218, 43, 'PPL', 'P'),
(69404, 'Three Mile', 35.9850006103516, 0.628056741982804, -81.9786071777344, -1.43079661145052, 218, 33, 'PPL', 'P'),
(111713, 'Three Mile', 38.4302787780762, 0.670734897136732, -81.4297180175781, -1.42121668837729, 218, 58, 'PPL', 'P'),
(153120, 'Three Mile Bay', 44.0813903808594, 0.769365401002953, -76.1986083984375, -1.32991660199054, 218, 40, 'PPL', 'P'),
(91325, 'Three Mountains', 36.2472190856934, 0.632633317737078, -82.2638931274414, -1.43577579058259, 218, 50, 'PPL', 'P'),
(6333, 'Three Notch', 32.1061096191406, 0.560357322860227, -85.5791702270508, -1.49363829158674, 218, 2, 'PPL', 'P'),
(18339, 'Three Oaks', 26.4697208404541, 0.461983780749685, -81.7941665649414, -1.42757751548289, 218, 12, 'PPL', 'P'),
(25472, 'Three Oaks', 32.7055587768555, 0.570819684360657, -83.6869430541992, -1.46061269722478, 218, 13, 'PPL', 'P'),
(91327, 'Three Oaks', 35.0366706848145, 0.611505262386989, -86.5411071777344, -1.51042725857276, 218, 50, 'PPL', 'P'),
(98510, 'Three Oaks', 28.976390838623, 0.505733425478693, -98.1669387817383, -1.71333629834504, 218, 51, 'PPL', 'P'),
(106911, 'Three Oaks', 37.7308311462402, 0.658527233015918, -77.834716796875, -1.3584720804628, 218, 53, 'PPL', 'P'),
(133401, 'Three Oaks', 41.7986106872559, 0.729523379251905, -86.6105575561523, -1.51163939634291, 218, 27, 'PPL', 'P'),
(192820, 'Three Pines', 39.4194412231445, 0.687999038640253, -109.399719238281, -1.90938530146539, 218, 52, 'PPL', 'P'),
(201652, 'Three Pines', 42.5658302307129, 0.742913886370878, -123.397499084473, -2.15369264775074, 218, 43, 'PPL', 'P'),
(38533, 'Three Point', 36.7633285522461, 0.641641127229135, -83.2602767944336, -1.4531659661847, 218, 21, 'PPL', 'P'),
(91328, 'Three Point', 35.6925010681152, 0.622951661910204, -89.6997222900391, -1.56555549208573, 218, 50, 'PPL', 'P'),
(25476, 'Three Points', 31.0716705322266, 0.542302954882252, -82.4794387817383, -1.43953777193843, 218, 13, 'PPL', 'P'),
(91330, 'Three Points', 35.5111083984375, 0.619785762585345, -84.2069396972656, -1.4696883507456, 218, 50, 'PPL', 'P'),
(98511, 'Three Points', 30.4513893127441, 0.531477005313999, -97.6619415283203, -1.70452243355937, 218, 51, 'PPL', 'P'),
(179346, 'Three Points', 32.0766716003418, 0.559843532506923, -111.313056945801, -1.94277934416417, 218, 5, 'PPL', 'P'),
(185644, 'Three Points', 34.7358283996582, 0.606254573981788, -118.597778320313, -2.0699217172398, 218, 6, 'PPL', 'P'),
(209787, 'Three River Junction', 44.2891693115234, 0.772991827459314, -110.892219543457, -1.93543434587773, 218, 59, 'PPL', 'P'),
(62020, 'Three Rivers', 30.586669921875, 0.533838097357435, -88.5625, -1.54570721879748, 218, 30, 'PPL', 'P'),
(98512, 'Three Rivers', 28.4599990844727, 0.49672068913862, -98.1822204589844, -1.71360301392822, 218, 51, 'PPL', 'P'),
(133400, 'Three Rivers', 41.9438896179199, 0.732058974925769, -85.6324996948242, -1.49456906638772, 218, 27, 'PPL', 'P'),
(153121, 'Three Rivers', 43.2008285522461, 0.75399669782627, -76.2783279418945, -1.33130797050205, 218, 40, 'PPL', 'P'),
(177324, 'Three Rivers', 42.1811103820801, 0.736199258314461, -72.3611068725586, -1.26293956531364, 218, 23, 'PPL', 'P'),
(189662, 'Three Rivers', 33.3213882446289, 0.581567936204108, -106.074440002441, -1.85134823025178, 218, 38, 'PPL', 'P'),
(192914, 'Three Rivers', 36.4388885498047, 0.635978580961354, -118.903610229492, -2.07525949101265, 218, 6, 'PPL', 'P'),
(201653, 'Three Rivers', 43.8202781677246, 0.764808133166582, -121.468063354492, -2.12001764155696, 218, 43, 'PPL', 'P'),
(185643, 'Three Rocks', 36.502498626709, 0.63708878624078, -120.390556335449, -2.10121159636131, 218, 6, 'PPL', 'P'),
(201654, 'Three Rocks', 45.0447196960449, 0.786178669333923, -123.998062133789, -2.16417445032712, 218, 43, 'PPL', 'P'),
(14748, 'Three Seasons Mobile Home Park', 38.7002792358398, 0.6754472941066, -75.1149978637695, -1.31100403035129, 218, 10, 'PPL', 'P'),
(38535, 'Three Springs', 36.9166717529297, 0.64431747096661, -86.4369430541992, -1.50860925165462, 218, 21, 'PPL', 'P'),
(106912, 'Three Springs', 36.6186103820801, 0.639115318672276, -82.2438888549805, -1.43542665016368, 218, 53, 'PPL', 'P'),
(167938, 'Three Springs', 40.1949996948242, 0.701535087512799, -77.9833297729492, -1.36106586620649, 218, 45, 'PPL', 'P'),
(167939, 'Three Springs Run', 41.5658302307129, 0.725460593850934, -77.2563934326172, -1.34837843361529, 218, 45, 'PPL', 'P'),
(106913, 'Three Square', 37.6650009155273, 0.657378278742631, -77.995002746582, -1.36126959802988, 218, 53, 'PPL', 'P'),
(43346, 'Three States', 33.0191688537598, 0.57629321277007, -94.0425033569336, -1.64135132039631, 218, 22, 'PPL', 'P'),
(57894, 'Three States', 36.6177787780762, 0.639100804444335, -89.2758331298828, -1.55815723057749, 218, 29, 'PPL', 'P'),
(98513, 'Three States', 33.0191688537598, 0.57629321277007, -94.0425033569336, -1.64135132039631, 218, 51, 'PPL', 'P'),
(129074, 'Three Streams', 45.5102806091309, 0.794304240135864, -70.2458267211914, -1.2260209620702, 218, 26, 'PPL', 'P'),
(84024, 'Three Trees', 32.7299995422363, 0.571246256188261, -79.9319381713867, -1.39507549859123, 218, 48, 'PPL', 'P'),
(167941, 'Three Tuns', 40.1783294677734, 0.701244137163707, -75.1933288574219, -1.31237116409688, 218, 45, 'PPL', 'P'),
(198997, 'Three V Crossing', 46.5569381713867, 0.812571860738126, -103.791389465332, -1.8115014813898, 218, 34, 'PPL', 'P'),
(12316, 'Three Way', 35.6988906860352, 0.623063181780851, -90.2438888549805, -1.57505299032322, 218, 4, 'PPL', 'P'),
(91331, 'Three Way', 35.7758293151855, 0.624406014181496, -88.8594436645508, -1.55088986343683, 218, 50, 'PPL', 'P'),
(98514, 'Three Way', 32.1576881408691, 0.561257537887701, -98.0295181274414, -1.71093785546732, 218, 51, 'PPL', 'P'),
(179347, 'Three Way', 32.9483299255371, 0.575056840234001, -109.229721069336, -1.90641827369493, 218, 5, 'PPL', 'P'),
(77442, 'Three-Way Corner', 35.290828704834, 0.615941156656679, -98.4116668701172, -1.71760760925937, 218, 42, 'PPL', 'P'),
(111714, 'Threefork Bridge', 39.4402809143066, 0.68836275986613, -79.8497161865234, -1.39364045423784, 218, 58, 'PPL', 'P'),
(38536, 'Threeforks', 37.7611083984375, 0.659055670755217, -82.4591674804688, -1.43918397098762, 218, 21, 'PPL', 'P'),
(38537, 'Threelinks', 37.4677810668945, 0.653936143033703, -84.1894378662109, -1.46938288616857, 218, 21, 'PPL', 'P'),
(167942, 'Threemile', 41.5330581665039, 0.724888613427812, -78.8841705322266, -1.37678850349204, 218, 45, 'PPL', 'P'),
(106914, 'Threemile Corner', 37.9302787780762, 0.662008250876761, -77.8663864135742, -1.35902481954705, 218, 53, 'PPL', 'P'),
(195716, 'Threemile Corner', 48.7313919067383, 0.8505232378523, -116.298606872559, -2.02979360540865, 218, 17, 'PPL', 'P'),
(195717, 'Threemile Crossing', 42.2477798461914, 0.737362859973744, -114.863891601563, -2.00475310010113, 218, 17, 'PPL', 'P'),
(153126, 'Threemile Harbor', 41.0158309936523, 0.715861296280771, -72.1800003051758, -1.25977865941583, 218, 40, 'PPL', 'P'),
(52087, 'Threemile Oak Corner', 38.9861106872559, 0.680435994039564, -76.5477828979492, -1.33601084667102, 218, 25, 'PPL', 'P'),
(6334, 'Threet', 34.9505615234375, 0.61000237400483, -87.8288879394531, -1.5329032729086, 218, 2, 'PPL', 'P'),
(106915, 'Threeway', 37.9925003051758, 0.663094221390268, -76.6994400024414, -1.33865776247845, 218, 53, 'PPL', 'P'),
(25480, 'Thrift', 32.6988906860352, 0.570703304221021, -82.0561065673828, -1.43214923096817, 218, 13, 'PPL', 'P'),
(52081, 'Thrift', 38.7191696166992, 0.675776993449552, -76.9327774047852, -1.3427302684174, 218, 25, 'PPL', 'P'),
(98515, 'Thrift', 34.1261100769043, 0.595612981739995, -98.6216735839844, -1.72127291786764, 218, 51, 'PPL', 'P'),
(208942, 'Thrift', 47.0527801513672, 0.821225935858393, -122.251106262207, -2.13368431848097, 218, 56, 'PPL', 'P'),
(74546, 'Thrifton', 39.3433303833008, 0.686670653888521, -83.366943359375, -1.45502764894472, 218, 41, 'PPL', 'P'),
(98518, 'Thrifty', 31.8108291625977, 0.55520370667676, -99.1316680908203, -1.73017400117902, 218, 51, 'PPL', 'P'),
(91332, 'Throckmorton', 36.4283294677734, 0.63579429021392, -87.6366729736328, -1.52954848888342, 218, 50, 'PPL', 'P'),
(98516, 'Throckmorton', 33.1786117553711, 0.579076016372121, -99.1772232055664, -1.73096908792246, 218, 51, 'PPL', 'P'),
(153122, 'Throgs Neck', 40.8224983215332, 0.712487004600613, -73.8199996948242, -1.28840204849589, 218, 40, 'PPL', 'P'),
(153123, 'Throop', 42.975830078125, 0.750069733640893, -76.5711135864258, -1.33641804400169, 218, 40, 'PPL', 'P'),
(167943, 'Throop', 41.4513893127441, 0.723463223033375, -75.6122207641602, -1.31968220707942, 218, 45, 'PPL', 'P'),
(153125, 'Throopsville', 42.9730606079102, 0.750021397267108, -76.6022186279297, -1.33696092938991, 218, 40, 'PPL', 'P'),
(38539, 'Thruston', 37.8011093139648, 0.659753818434981, -87.0280609130859, -1.51892620455953, 218, 21, 'PPL', 'P'),
(91333, 'Thula', 36.1636085510254, 0.631174038617769, -83.0897216796875, -1.45018921787626, 218, 50, 'PPL', 'P'),
(126345, 'Thumpertown Beach', 41.8436088562012, 0.730308745457369, -70.0041732788086, -1.22180331385184, 218, 23, 'PPL', 'P'),
(167945, 'Thumptown', 41.7027816772461, 0.727850847508308, -77.3913879394531, -1.35073453223169, 218, 45, 'PPL', 'P'),
(202681, 'Thunder Butte', 45.2127799987793, 0.789111874958537, -101.669723510742, -1.77447142485474, 218, 49, 'PPL', 'P'),
(202682, 'Thunder Hawk', 45.9383316040039, 0.801775139362836, -101.97444152832, -1.77978975755163, 218, 49, 'PPL', 'P'),
(52082, 'Thunder Hill', 39.226390838623, 0.684629673808112, -76.8333282470703, -1.34099455317694, 218, 25, 'PPL', 'P'),
(189663, 'Thunderbird', 34.5763893127441, 0.603471836958765, -106.398330688477, -1.85700118913964, 218, 38, 'PPL', 'P'),
(202685, 'Thunderbird Homes Addition', 44.1222190856934, 0.770077996331631, -103.470283508301, -1.80589712519184, 218, 49, 'PPL', 'P'),
(84026, 'Thunderbird Mobile Home Park', 35.0069389343262, 0.610986345448587, -81.9786071777344, -1.43079661145052, 218, 48, 'PPL', 'P'),
(138439, 'Thunderbird Mobile Home Park', 43.7572212219238, 0.763707581846107, -91.350830078125, -1.59437275929315, 218, 28, 'PPL', 'P'),
(179348, 'Thunderbird Palms II', 33.6094398498535, 0.586595385130932, -112.183059692383, -1.95796375659342, 218, 5, 'PPL', 'P'),
(185645, 'Thunderbird Ranches', 34.5227813720703, 0.602536201888793, -117.119720458984, -2.04412474102464, 218, 6, 'PPL', 'P'),
(138440, 'Thunderbird Resort', 48.5994415283203, 0.848220269299654, -93.1872177124023, -1.6264237698542, 218, 28, 'PPL', 'P'),
(179349, 'Thunderbird Valley Number Two', 33.6152801513672, 0.586697317621655, -112.11222076416, -1.95672738405735, 218, 5, 'PPL', 'P'),
(25478, 'Thunderbolt', 32.0333290100098, 0.559087061599286, -81.0500030517578, -1.41458941200463, 218, 13, 'PPL', 'P'),
(84027, 'Thunderwoods', 34.2266693115234, 0.597368071477385, -80.7319412231445, -1.40903818587041, 218, 48, 'PPL', 'P'),
(28779, 'Thurber', 38.0825004577637, 0.664665020380224, -88.4274978637695, -1.54335098702303, 218, 18, 'PPL', 'P'),
(98519, 'Thurber', 32.5072212219238, 0.567358040996745, -98.4169387817383, -1.71769962147503, 218, 51, 'PPL', 'P'),
(185646, 'Thurin', 33.6541709899902, 0.587376090804489, -117.906936645508, -2.05786425540447, 218, 6, 'PPL', 'P'),
(38538, 'Thurlow', 37.2125015258789, 0.649480674530001, -85.5363922119141, -1.49289167437514, 218, 21, 'PPL', 'P'),
(197690, 'Thurlow', 46.2877807617188, 0.807874177733281, -106.305557250977, -1.85538198719687, 218, 31, 'PPL', 'P'),
(25479, 'Thurmack', 34.1530609130859, 0.596083362567531, -83.7386093139648, -1.46151444356988, 218, 13, 'PPL', 'P'),
(12317, 'Thurman', 34.9794387817383, 0.610506377241127, -91.7819366455078, -1.60189698832095, 218, 4, 'PPL', 'P'),
(69405, 'Thurman', 35.0444412231445, 0.611640883865501, -77.0033264160156, -1.3439615809474, 218, 33, 'PPL', 'P'),
(74547, 'Thurman', 38.9000015258789, 0.678933105657405, -82.4458312988281, -1.43895121070834, 218, 41, 'PPL', 'P'),
(91334, 'Thurman', 35.4252815246582, 0.618287801051202, -88.1986083984375, -1.53935611222986, 218, 50, 'PPL', 'P'),
(118036, 'Thurman', 40.8199996948242, 0.712443395337763, -95.7474975585938, -1.67110908294269, 218, 16, 'PPL', 'P'),
(123797, 'Thurman', 41.1199989318848, 0.717679369777941, -85.0041732788086, -1.48360270165099, 218, 19, 'PPL', 'P'),
(153127, 'Thurman', 43.5333290100098, 0.759799925578634, -73.916389465332, -1.2900843673565, 218, 40, 'PPL', 'P'),
(187436, 'Thurman', 39.5961112976074, 0.691082513129374, -103.216941833496, -1.80147547883398, 218, 7, 'PPL', 'P'),
(69406, 'Thurmond', 36.3663902282715, 0.63471324654843, -80.9286117553711, -1.41247073419941, 218, 33, 'PPL', 'P'),
(111715, 'Thurmond', 37.9613914489746, 0.662551269423028, -81.0824966430664, -1.41515653215876, 218, 58, 'PPL', 'P'),
(52083, 'Thurmont', 39.6236114501953, 0.691562481336833, -77.4111099243164, -1.35107874580258, 218, 25, 'PPL', 'P'),
(52084, 'Thurmont Overlook', 39.6088905334473, 0.691305552870668, -77.4258270263672, -1.35133560768972, 218, 25, 'PPL', 'P'),
(57895, 'Thuroy', 36.5050010681152, 0.637132462082658, -92.2027816772461, -1.60924211976544, 218, 29, 'PPL', 'P'),
(84028, 'Thursa', 34.2544403076172, 0.597852766795779, -80.2874984741211, -1.40128119656334, 218, 48, 'PPL', 'P'),
(6335, 'Thurston', 31.014720916748, 0.541308996584408, -85.7819366455078, -1.49717723320129, 218, 2, 'PPL', 'P'),
(25481, 'Thurston', 33.5538902282715, 0.585625861336089, -83.2102813720703, -1.45229338145353, 218, 13, 'PPL', 'P'),
(52086, 'Thurston', 39.2799987792969, 0.685565308878084, -77.3583297729492, -1.35015755838152, 218, 25, 'PPL', 'P'),
(74548, 'Thurston', 39.8402786254883, 0.695344036926691, -82.5461120605469, -1.44070144017674, 218, 41, 'PPL', 'P'),
(106916, 'Thurston', 38.083610534668, 0.664684394877154, -78.6938934326172, -1.37346754161271, 218, 53, 'PPL', 'P'),
(143191, 'Thurston', 42.1772193908691, 0.736131347706664, -96.7005615234375, -1.68774318711133, 218, 35, 'PPL', 'P'),
(153129, 'Thurston', 42.2227783203125, 0.736926501029134, -77.2644424438477, -1.3485189153628, 218, 40, 'PPL', 'P'),
(201655, 'Thurston', 44.0533294677734, 0.768875645678488, -122.915283203125, -2.14527639291581, 218, 43, 'PPL', 'P'),
(129075, 'Thurstons Corner', 44.4669418334961, 0.776094543287311, -69.3383331298828, -1.21018221096112, 218, 26, 'PPL', 'P'),
(62021, 'Thweatt (historical)', 33.0194396972656, 0.576297939881005, -89.6427764892578, -1.56456160036691, 218, 30, 'PPL', 'P'),
(25482, 'Thyatira', 34.1411094665527, 0.59587477047515, -83.533332824707, -1.45793169295539, 218, 13, 'PPL', 'P'),
(62022, 'Thyatira', 34.6338882446289, 0.604475382636534, -89.7555618286133, -1.56653007588664, 218, 30, 'PPL', 'P'),
(91335, 'Thyatira (historical)', 35.7458305358887, 0.623882436711186, -86.1838912963867, -1.50419266530283, 218, 50, 'PPL', 'P'),
(185647, 'Thyle', 35.3411102294922, 0.616818734814887, -120.632499694824, -2.10543430458574, 218, 6, 'PPL', 'P'),
(77443, 'Ti', 34.709171295166, 0.605789319739352, -95.6611099243164, -1.66960133429154, 218, 42, 'PPL', 'P'),
(77444, 'Tia Juana', 36.478889465332, 0.636676728641118, -95.003059387207, -1.65811618577447, 218, 42, 'PPL', 'P'),
(167946, 'Tiadaghton', 41.6472206115723, 0.726881123976382, -77.4458312988281, -1.35168474810863, 218, 45, 'PPL', 'P'),
(153131, 'Tiana', 40.871940612793, 0.713349935372826, -72.5419387817383, -1.2660956775215, 218, 40, 'PPL', 'P'),
(77445, 'Tiawah', 36.2611083984375, 0.632875731975302, -95.5605621337891, -1.66784644429124, 218, 42, 'PPL', 'P'),
(62023, 'Tibbee', 33.5283317565918, 0.585179781853501, -88.6313934326172, -1.54690963602965, 218, 30, 'PPL', 'P'),
(176681, 'Tibbets', 42.7347183227539, 0.745861539644404, -88.5813903808594, -1.54603691814043, 218, 57, 'PPL', 'P'),
(157939, 'Tibbetts Corners', 41.1816711425781, 0.718755752911523, -80.7174987792969, -1.40878611767323, 218, 41, 'PPL', 'P'),
(129076, 'Tibbettstown', 44.7166709899902, 0.780453139306362, -67.7574996948242, -1.18259146259374, 218, 26, 'PPL', 'P'),
(6336, 'Tibbie', 31.3619403839111, 0.547369119513424, -88.2486114501953, -1.54022883011908, 218, 2, 'PPL', 'P'),
(62024, 'Tibbs', 34.4672203063965, 0.601566478356867, -90.3099975585938, -1.5762068048655, 218, 30, 'PPL', 'P'),
(91336, 'Tibbs', 35.6986083984375, 0.623058254932834, -89.3469390869141, -1.55939826364547, 218, 50, 'PPL', 'P'),
(106917, 'Tibbstown', 38.1836090087891, 0.666429697497538, -78.2563934326172, -1.36583172613524, 218, 53, 'PPL', 'P'),
(185648, 'Tiber', 35.1783294677734, 0.613977674563991, -120.617500305176, -2.10517251585058, 218, 6, 'PPL', 'P'),
(197691, 'Tiber', 48.5088882446289, 0.846639816350747, -111.080001831055, -1.93871176507323, 218, 31, 'PPL', 'P'),
(197692, 'Tiber Dam Camp', 48.3102798461914, 0.8431734458759, -111.086669921875, -1.93882814521287, 218, 31, 'PPL', 'P'),
(25483, 'Tibet (historical)', 31.6236095428467, 0.551936107887773, -81.5983276367188, -1.42415948138183, 218, 13, 'PPL', 'P'),
(106918, 'Tibitha', 37.8383293151855, 0.660403430003879, -76.2624969482422, -1.33103166753895, 218, 53, 'PPL', 'P'),
(179350, 'Tiburon', 33.3302803039551, 0.581723131916633, -111.888893127441, -1.95282958148591, 218, 5, 'PPL', 'P'),
(185649, 'Tiburon', 37.8736114501953, 0.661019219426933, -122.455558776855, -2.13725268802557, 218, 6, 'PPL', 'P'),
(84029, 'Tibwin', 33.0763893127441, 0.57729189817885, -79.5105590820313, -1.38772104608293, 218, 48, 'PPL', 'P'),
(192821, 'Ticaboo', 37.6749992370605, 0.657552782373058, -110.695831298828, -1.93200672439674, 218, 52, 'PPL', 'P'),
(18340, 'Tice', 26.6744403839111, 0.46555681082619, -81.8152770996094, -1.4279459638197, 218, 12, 'PPL', 'P'),
(28780, 'Tice', 39.985279083252, 0.697874772331566, -89.7947235107422, -1.56721357618041, 218, 18, 'PPL', 'P'),
(172642, 'Tice', 44.9797210693359, 0.785044229288577, -72.0355606079102, -1.25725771112796, 218, 55, 'PPL', 'P'),
(187932, 'Tice', 37.5161094665527, 0.654779632729959, -100.726387023926, -1.7580070972056, 218, 20, 'PPL', 'P'),
(111716, 'Tichenal', 39.189998626709, 0.683994509888128, -80.4766693115234, -1.40458285052476, 218, 58, 'PPL', 'P'),
(176680, 'Tichigan', 42.8288917541504, 0.747505176090174, -88.1975021362305, -1.53933680431195, 218, 57, 'PPL', 'P'),
(12318, 'Tichnor', 34.1402816772461, 0.595860322826236, -91.2705612182617, -1.59297180340171, 218, 4, 'PPL', 'P'),
(69407, 'Tick Bite', 35.3480606079102, 0.616940041802541, -77.4311065673828, -1.35142775306343, 218, 33, 'PPL', 'P'),
(74549, 'Tick Ridge', 39.3588905334473, 0.686942229740682, -81.7163925170898, -1.42622010227527, 218, 41, 'PPL', 'P'),
(25484, 'Tickanetley', 34.6538887023926, 0.604824456476416, -84.2938919067383, -1.47120595309278, 218, 13, 'PPL', 'P'),
(43347, 'Tickfaw', 30.577220916748, 0.533673181106932, -90.4830627441406, -1.57922736217387, 218, 22, 'PPL', 'P'),
(84030, 'Tickle Hill', 34.2311096191406, 0.597445569465106, -80.5763931274414, -1.40632335945518, 218, 48, 'PPL', 'P'),
(25485, 'Ticknor', 31.333890914917, 0.54687956392604, -83.9433288574219, -1.46508747364638, 218, 13, 'PPL', 'P'),
(106919, 'Ticktown', 37.7200012207031, 0.65833821515755, -75.6927795410156, -1.32108822297693, 218, 53, 'PPL', 'P'),
(121706, 'Ticona', 41.2241706848145, 0.719497509854138, -89.0524978637695, -1.554259294848, 218, 18, 'PPL', 'P'),
(153133, 'Ticonderoga', 43.8486099243164, 0.765302615601983, -73.4238891601563, -1.2814886154641, 218, 40, 'PPL', 'P'),
(118037, 'Ticonic', 42.1661109924316, 0.735937469579306, -95.9522171020508, -1.6746821130192, 218, 16, 'PPL', 'P'),
(167947, 'Tidal', 40.9577789306641, 0.71484809664405, -79.4963912963867, -1.38747377157571, 218, 45, 'PPL', 'P'),
(84031, 'Tidalview', 32.7374992370605, 0.571377150555838, -79.9705581665039, -1.39574954466313, 218, 48, 'PPL', 'P'),
(14751, 'Tidbury Creek Park Mobile Home Park', 39.1127815246582, 0.682646817218493, -75.5149993896484, -1.31798537399087, 218, 10, 'PPL', 'P'),
(14750, 'Tidbury Manor', 39.1161117553711, 0.682704940709284, -75.5147171020508, -1.31798044714286, 218, 10, 'PPL', 'P'),
(167948, 'Tide', 40.5547218322754, 0.707813423203633, -79.1305618286133, -1.38108884286225, 218, 45, 'PPL', 'P'),
(43348, 'Tide (historical)', 31.7333297729492, 0.553851087159108, -92.6194381713867, -1.61651414743801, 218, 22, 'PPL', 'P'),
(12319, 'Tide Water', 33.2144393920898, 0.579701326596072, -93.1397171020508, -1.62559472780686, 218, 4, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(106920, 'Tidemill', 37.2677803039551, 0.650445471213909, -76.4833297729492, -1.33488592742657, 218, 53, 'PPL', 'P'),
(18341, 'Tidewater', 29.1286106109619, 0.508390161692643, -82.5702819824219, -1.44112328489341, 218, 12, 'PPL', 'P'),
(106921, 'Tidewater', 37.8549995422363, 0.66069438035297, -76.6988906860352, -1.33864817509853, 218, 53, 'PPL', 'P'),
(201656, 'Tidewater', 44.4113883972168, 0.77512495291344, -123.899169921875, -2.16244845562464, 218, 43, 'PPL', 'P'),
(206128, 'Tidewater Village Condominium', 40.6655616760254, 0.709747943419467, -111.852783203125, -1.95219934441394, 218, 52, 'PPL', 'P'),
(25486, 'Tidings', 34.4238891601563, 0.600810207186312, -85.2474975585938, -1.48784951148329, 218, 13, 'PPL', 'P'),
(167949, 'Tidioute', 41.685001373291, 0.727540522662286, -79.4033279418945, -1.38584950962687, 218, 45, 'PPL', 'P'),
(84032, 'Tidmans Place', 35.1124992370605, 0.612828720290704, -82.0627822875977, -1.43226574426586, 218, 48, 'PPL', 'P'),
(6337, 'Tidwell', 31.2427806854248, 0.545289390439154, -85.4105606079102, -1.4906954985822, 218, 2, 'PPL', 'P'),
(91338, 'Tidwell', 35.9319381713867, 0.627130627713729, -87.2191696166992, -1.5222616806668, 218, 50, 'PPL', 'P'),
(98520, 'Tidwell', 33.2094383239746, 0.579614041491344, -96.1011123657227, -1.6772808256109, 218, 51, 'PPL', 'P'),
(98521, 'Tidwell Prairie', 31.0897197723389, 0.542617973549695, -96.6572189331055, -1.68698671620369, 218, 51, 'PPL', 'P'),
(106922, 'Tidwells', 38.1211090087891, 0.665338866715041, -76.6449966430664, -1.33770754660151, 218, 53, 'PPL', 'P'),
(62026, 'Tie Plant', 33.7413902282715, 0.588898353683578, -89.7900009155273, -1.56713115134468, 218, 30, 'PPL', 'P'),
(209788, 'Tie Siding', 41.0802803039551, 0.716986148946193, -105.506942749023, -1.84144353468362, 218, 59, 'PPL', 'P'),
(195718, 'Tiegs Corner', 43.5138893127441, 0.759460638855758, -116.513061523438, -2.0335365451627, 218, 17, 'PPL', 'P'),
(98523, 'Tiejerina Estates Colonia', 26.2479991912842, 0.458114007948718, -97.9580001831055, -1.7096896318644, 218, 51, 'PPL', 'P'),
(201658, 'Tiernan', 44.0161094665527, 0.76822603410959, -123.938888549805, -2.16314167645639, 218, 43, 'PPL', 'P'),
(146454, 'Tierneys Corner', 40.9588890075684, 0.71486747114098, -74.5977783203125, -1.3019768463623, 218, 37, 'PPL', 'P'),
(189664, 'Tierra Amarilla', 36.7002792358398, 0.640540709066714, -106.549171447754, -1.85963385703524, 218, 38, 'PPL', 'P'),
(189666, 'Tierra Azul', 36.2066688537598, 0.631925582677389, -106.248062133789, -1.85437850809813, 218, 38, 'PPL', 'P'),
(98522, 'Tierra Bella Colonia', 26.128999710083, 0.456037075193592, -98.0530014038086, -1.71134771595908, 218, 51, 'PPL', 'P'),
(98524, 'Tierra Bonita', 26.271110534668, 0.458517376985324, -97.8255615234375, -1.70737814119626, 218, 51, 'PPL', 'P'),
(98525, 'Tierra Bonita Colonia', 26.2679996490479, 0.4584630817886, -97.8239974975586, -1.70735084379509, 218, 51, 'PPL', 'P'),
(98526, 'Tierra Bonita Number 1 Colonia', 26.2269992828369, 0.457747490403696, -98.1060028076172, -1.71227276496372, 218, 51, 'PPL', 'P'),
(98528, 'Tierra Bonita Number 2 Colonia', 26.2259998321533, 0.457730046698556, -98.1060028076172, -1.71227276496372, 218, 51, 'PPL', 'P'),
(98529, 'Tierra Bonita Number 3 Colonia', 26.2199993133545, 0.457625317888688, -97.8040008544922, -1.70700183653424, 218, 51, 'PPL', 'P'),
(185650, 'Tierra Buena', 39.1488914489746, 0.683277054290461, -121.665832519531, -2.12346936464581, 218, 6, 'PPL', 'P'),
(98530, 'Tierra Buena Colonia', 27.9699993133545, 0.488168579798589, -97.3990020751953, -1.69993327436895, 218, 51, 'PPL', 'P'),
(201657, 'Tierra Del Mar', 45.2522201538086, 0.789800235521295, -123.963333129883, -2.16356831486302, 218, 43, 'PPL', 'P'),
(185651, 'Tierra del Sol', 32.6222190856934, 0.569365132352283, -116.321670532227, -2.03019614220742, 218, 6, 'PPL', 'P'),
(98540, 'Tierra del Valle Colonia', 26.2600002288818, 0.458323465568453, -98.1380004882813, -1.71283122984431, 218, 51, 'PPL', 'P'),
(98532, 'Tierra Dorada Colonia', 26.3999996185303, 0.4607669158686, -98.9199981689453, -1.72647966411486, 218, 51, 'PPL', 'P'),
(98533, 'Tierra Estates Colonia', 26.30299949646, 0.459073944363637, -98.3079986572266, -1.71579825761477, 218, 51, 'PPL', 'P'),
(98534, 'Tierra Estates Number 2 Colonia', 26.2819995880127, 0.458707426818615, -98.3209991455078, -1.71602515893964, 218, 51, 'PPL', 'P'),
(98535, 'Tierra Grande', 27.6922206878662, 0.483320428192154, -97.5813903808594, -1.70311655081992, 218, 51, 'PPL', 'P'),
(98537, 'Tierra Linda Colonia', 26.3619995117188, 0.46010368888863, -98.7819976806641, -1.72407110122499, 218, 51, 'PPL', 'P'),
(98538, 'Tierra Maria Colonia', 26.2310009002686, 0.457817331803283, -98.3980026245117, -1.71736912318375, 218, 51, 'PPL', 'P'),
(189669, 'Tierra Monte', 35.8591690063477, 0.62586056618987, -105.346939086914, -1.83865094396456, 218, 38, 'PPL', 'P'),
(189667, 'Tierra Monte Subdivision', 35.209171295166, 0.614515965999323, -106.485832214355, -1.85852837886675, 218, 38, 'PPL', 'P'),
(98539, 'Tierra Prieta Colonia', 26.1319999694824, 0.456089439598526, -98.052001953125, -1.71133027225394, 218, 51, 'PPL', 'P'),
(18342, 'Tierra Verde', 27.6916694641113, 0.483310807522716, -82.7236099243164, -1.44379936231478, 218, 12, 'PPL', 'P'),
(185652, 'Tierrasanta', 32.8291702270508, 0.57297711115973, -117.102783203125, -2.04382913014364, 218, 6, 'PPL', 'P'),
(208944, 'Tieton', 46.702220916748, 0.815107522991018, -120.754173278809, -2.10755790923897, 218, 56, 'PPL', 'P'),
(208945, 'Tietonview Grange', 46.5933303833008, 0.81320702465811, -120.707496643066, -2.10674324826151, 218, 56, 'PPL', 'P'),
(57896, 'Tiff', 38.0191688537598, 0.663559675369786, -90.6527786254883, -1.58218946309631, 218, 29, 'PPL', 'P'),
(57897, 'Tiff City', 36.6683311462402, 0.639983109713478, -94.616943359375, -1.65137718979408, 218, 29, 'PPL', 'P'),
(167951, 'Tiffany', 41.8369407653809, 0.730192365317732, -75.8211135864258, -1.32332807461174, 218, 45, 'PPL', 'P'),
(176682, 'Tiffany', 42.5825004577637, 0.743204836719969, -88.9269409179688, -1.55206791274502, 218, 57, 'PPL', 'P'),
(177701, 'Tiffany', 37.0327796936035, 0.646343936819078, -107.537498474121, -1.87688341773179, 218, 7, 'PPL', 'P'),
(189668, 'Tiffany', 33.7230606079102, 0.588578441457633, -106.942779541016, -1.86650361422515, 218, 38, 'PPL', 'P'),
(74550, 'Tiffany Acres', 39.8669395446777, 0.695809357748155, -83.8874969482422, -1.46411302300352, 218, 41, 'PPL', 'P'),
(114168, 'Tiffany Hill Corner', 41.4327812194824, 0.72313845053844, -72.4061126708984, -1.26372506467716, 218, 8, 'PPL', 'P'),
(25487, 'Tiffany Hills', 33.5480613708496, 0.585524128582448, -84.3199996948242, -1.4716616199553, 218, 13, 'PPL', 'P'),
(57898, 'Tiffany Springs', 39.2613906860352, 0.685240536383149, -94.6961135864258, -1.65275897092567, 218, 29, 'PPL', 'P'),
(52088, 'Tiffany Woods', 38.7986106872559, 0.677163501692075, -76.5311126708984, -1.33571989632193, 218, 25, 'PPL', 'P'),
(57899, 'Tiffin', 37.9550018310547, 0.662439749552381, -93.9380569458008, -1.63952838663015, 218, 29, 'PPL', 'P'),
(98541, 'Tiffin', 32.4963912963867, 0.567169023138377, -98.6627807617188, -1.72199037346531, 218, 51, 'PPL', 'P'),
(118038, 'Tiffin', 41.7058296203613, 0.727904044151082, -91.6627807617188, -1.59981732582571, 218, 16, 'PPL', 'P'),
(157940, 'Tiffin', 41.1144409179688, 0.717582364135235, -83.1780624389648, -1.45173105498936, 218, 41, 'PPL', 'P'),
(185653, 'Tiffin (historical)', 36.1836090087891, 0.631523112457651, -119.02693939209, -2.07741199096371, 218, 6, 'PPL', 'P'),
(157941, 'Tiffin Meadows', 41.5202789306641, 0.724665573686518, -84.399169921875, -1.47304340108688, 218, 41, 'PPL', 'P'),
(208946, 'Tiflis', 47.0694389343262, 0.821516686470403, -119.057502746582, -2.07794542213005, 218, 56, 'PPL', 'P'),
(79265, 'Tifllie', 39.8583297729492, 0.695659088883648, -77.3258285522461, -1.34959030506933, 218, 45, 'PPL', 'P'),
(133403, 'Tift Corner', 43.3958282470703, 0.757400084541336, -85.6227798461914, -1.49439942302628, 218, 27, 'PPL', 'P'),
(25489, 'Tifton', 31.4502792358398, 0.548910923337012, -83.5086135864258, -1.4575002608588, 218, 13, 'PPL', 'P'),
(91339, 'Tiftonia', 35.0202789306641, 0.611219172306887, -85.3661117553711, -1.48991971975666, 218, 50, 'PPL', 'P'),
(201659, 'Tigard', 45.4313888549805, 0.792927319273266, -122.770278930664, -2.14274559093191, 218, 43, 'PPL', 'P'),
(25490, 'Tiger', 34.8469390869141, 0.608193821308557, -83.4330596923828, -1.45618159664505, 218, 13, 'PPL', 'P'),
(77447, 'Tiger', 36.1886100769043, 0.631610397562378, -95.804443359375, -1.67210297466151, 218, 42, 'PPL', 'P'),
(157944, 'Tiger', 41.1341705322266, 0.717926710864182, -80.9061126708984, -1.41207805109668, 218, 41, 'PPL', 'P'),
(179351, 'Tiger', 32.7077789306641, 0.570858433354518, -110.681671142578, -1.93175958304758, 218, 5, 'PPL', 'P'),
(208947, 'Tiger', 48.6916694641113, 0.849829950441526, -117.406669616699, -2.04913294861259, 218, 56, 'PPL', 'P'),
(18343, 'Tiger Bay', 27.7588901519775, 0.484484029851437, -81.8472213745117, -1.42850349659391, 218, 12, 'PPL', 'P'),
(43349, 'Tiger Bluff Landing', 30.3052806854248, 0.528926928701707, -90.6594390869141, -1.58230571007789, 218, 22, 'PPL', 'P'),
(84033, 'Tiger Corner (historical)', 33.2522201538086, 0.580360725281975, -79.6894378662109, -1.39084306982883, 218, 48, 'PPL', 'P'),
(185654, 'Tiger Lily', 38.6811103820801, 0.675112734494659, -120.773887634277, -2.10790198965181, 218, 6, 'PPL', 'P'),
(18344, 'Tiger Point', 30.3783302307129, 0.530201883784069, -87.0555572509766, -1.51940610618796, 218, 12, 'PPL', 'P'),
(91340, 'Tiger Tail', 35.9361114501953, 0.627203465169543, -89.579719543457, -1.56346104904644, 218, 50, 'PPL', 'P'),
(91341, 'Tiger Valley', 36.228328704834, 0.632303618394126, -82.1866683959961, -1.4344279647549, 218, 50, 'PPL', 'P'),
(176684, 'Tigerton', 44.7408294677734, 0.780874784285949, -89.0630569458008, -1.55444358559543, 218, 57, 'PPL', 'P'),
(91342, 'Tigertown', 36.1955604553223, 0.631731704550031, -83.2794418334961, -1.45350045921761, 218, 50, 'PPL', 'P'),
(98542, 'Tigertown', 33.7136116027832, 0.58841352520713, -95.8041687011719, -1.67209818097155, 218, 51, 'PPL', 'P'),
(43351, 'Tigerville', 30.0424995422363, 0.524340532540913, -90.543327331543, -1.5802791776464, 218, 22, 'PPL', 'P'),
(84034, 'Tigerville', 35.0683288574219, 0.612057801734153, -82.3686065673828, -1.43760338488065, 218, 48, 'PPL', 'P'),
(98543, 'Tigerville', 30.7024993896484, 0.535859702940915, -95.0736083984375, -1.65934749830447, 218, 51, 'PPL', 'P'),
(202683, 'Tigerville', 43.9766693115234, 0.767537673546832, -103.639442443848, -1.8088495055763, 218, 49, 'PPL', 'P'),
(31309, 'Tighe', 39.6208305358887, 0.691513945225967, -87.523063659668, -1.5275656322938, 218, 19, 'PPL', 'P'),
(111717, 'Tigheville', 38.9797210693359, 0.680324474168917, -79.9199981689453, -1.39486710623594, 218, 58, 'PPL', 'P'),
(57900, 'Tightwad', 38.309440612793, 0.668625873290471, -93.54638671875, -1.63269245158608, 218, 29, 'PPL', 'P'),
(25491, 'Tignall', 33.8675003051758, 0.591099389745502, -82.7413864135742, -1.44410962058177, 218, 13, 'PPL', 'P'),
(106923, 'Tignor', 37.975830078125, 0.662803271041177, -77.107780456543, -1.34578464787161, 218, 53, 'PPL', 'P'),
(91343, 'Tigrett', 35.9513893127441, 0.627470114173687, -89.2399978637695, -1.55753178719548, 218, 50, 'PPL', 'P'),
(57901, 'Tigris', 37.0227813720703, 0.646169433188651, -92.771110534668, -1.61916132956155, 218, 29, 'PPL', 'P'),
(192324, 'Tigua', 31.7416706085205, 0.553996662202195, -106.363609313965, -1.85639518683359, 218, 51, 'PPL', 'P'),
(126346, 'Tihonet', 41.7866706848145, 0.729314986896606, -70.7183303833008, -1.23426770670174, 218, 23, 'PPL', 'P'),
(179352, 'Tiis Holoni', 35.564998626709, 0.620726324503334, -111.053329467773, -1.93824624451469, 218, 5, 'PPL', 'P'),
(187438, 'Tijeras', 37.1258316040039, 0.647967999030836, -104.662498474121, -1.82670520173695, 218, 7, 'PPL', 'P'),
(189670, 'Tijeras', 35.0808296203613, 0.612275981206458, -106.387496948242, -1.85681210470225, 218, 38, 'PPL', 'P'),
(179353, 'Tiki Tai Village', 33.5305595397949, 0.585218664005416, -112.180557250977, -1.95792008075154, 218, 5, 'PPL', 'P'),
(195719, 'Tikura', 43.2147216796875, 0.754239178643521, -114.011940002441, -1.98988373962883, 218, 17, 'PPL', 'P'),
(6338, 'Tilden', 32.0658302307129, 0.559654314911473, -87.1430587768555, -1.52093329591507, 218, 2, 'PPL', 'P'),
(28781, 'Tilden', 38.2119407653809, 0.666924179932938, -89.682502746582, -1.56525495435671, 218, 18, 'PPL', 'P'),
(31308, 'Tilden', 39.8213882446289, 0.69501433758374, -86.4388885498047, -1.50864320695852, 218, 19, 'PPL', 'P'),
(38540, 'Tilden', 37.6041717529297, 0.656316609574071, -87.7102813720703, -1.53083319779328, 218, 21, 'PPL', 'P'),
(57902, 'Tilden', 37.7061080932617, 0.658095734340298, -92.9602813720703, -1.62246298352298, 218, 29, 'PPL', 'P'),
(62027, 'Tilden', 34.1866683959961, 0.596669923797621, -88.351936340332, -1.54203218965122, 218, 30, 'PPL', 'P'),
(98545, 'Tilden', 28.461669921875, 0.496749850752556, -98.5488891601563, -1.72000259002768, 218, 51, 'PPL', 'P'),
(111718, 'Tilden', 37.728889465332, 0.658493344291047, -81.1769409179688, -1.41680489571546, 218, 58, 'PPL', 'P'),
(140966, 'Tilden', 48.1558303833008, 0.840477794220522, -99.2463912963867, -1.73217629884459, 218, 34, 'PPL', 'P'),
(143193, 'Tilden', 42.0472183227539, 0.733862401036943, -97.833610534668, -1.70751862294377, 218, 35, 'PPL', 'P'),
(176686, 'Tilden', 45.0066719055176, 0.785514610116112, -91.4375, -1.59588543479232, 218, 57, 'PPL', 'P'),
(138442, 'Tilden Junction', 47.702220916748, 0.832560815510961, -96.2886123657227, -1.68055331795839, 218, 28, 'PPL', 'P'),
(52089, 'Tilden Woods', 39.0469398498535, 0.681497663208124, -77.1408309936523, -1.34636148856372, 218, 25, 'PPL', 'P'),
(18345, 'Tildenville', 28.559440612793, 0.498456271221024, -81.6086120605469, -1.4243389784393, 218, 12, 'PPL', 'P'),
(74552, 'Tile', 39.9652786254883, 0.697525698491684, -81.9986114501953, -1.43114575186943, 218, 41, 'PPL', 'P'),
(118040, 'Tileville', 41.3480606079102, 0.7216597969222, -93.9358291625977, -1.63948950447824, 218, 16, 'PPL', 'P'),
(25492, 'Tilford', 33.8086090087891, 0.590071542722786, -84.4527816772461, -1.47397910273588, 218, 13, 'PPL', 'P'),
(38542, 'Tilford', 37.0305595397949, 0.646305187825218, -83.0661087036133, -1.44977709369757, 218, 21, 'PPL', 'P'),
(202684, 'Tilford', 44.3002815246582, 0.773185772165699, -103.429443359375, -1.80518433012608, 218, 49, 'PPL', 'P'),
(52090, 'Tilghman', 38.7169418334961, 0.675738111297637, -76.334716796875, -1.33229214168289, 218, 25, 'PPL', 'P'),
(91344, 'Tilghman', 36.1508293151855, 0.630950998876475, -89.0875015258789, -1.55487022400206, 218, 50, 'PPL', 'P'),
(52091, 'Tilghman Island', 38.7036094665527, 0.675505417597391, -76.3388900756836, -1.3323649791387, 218, 25, 'PPL', 'P'),
(52092, 'Tilghman Island Beach', 38.7000007629395, 0.675442433837611, -76.3422164916992, -1.33242303605047, 218, 25, 'PPL', 'P'),
(146455, 'Tilghmans Corner', 40.0605583190918, 0.699188642855357, -74.6324996948242, -1.30258284866835, 218, 37, 'PPL', 'P'),
(52094, 'Tilghmanton', 39.5333290100098, 0.689986755498861, -77.7411117553711, -1.35683836429209, 218, 25, 'PPL', 'P'),
(52095, 'Tilghmanton Heights', 39.5416717529297, 0.690132363831461, -77.741943359375, -1.35685287852004, 218, 25, 'PPL', 'P'),
(38543, 'Tiline', 37.1725006103516, 0.648782526850237, -88.2444381713867, -1.54015599266326, 218, 21, 'PPL', 'P'),
(201660, 'Tillamook', 45.4563903808594, 0.793363678217875, -123.842781066895, -2.16146428444381, 218, 43, 'PPL', 'P'),
(12320, 'Tillar', 33.7122192382813, 0.588389223862183, -91.4527816772461, -1.59615215037549, 218, 4, 'PPL', 'P'),
(62028, 'Tillatoba', 33.9847183227539, 0.593145230094901, -89.8966674804688, -1.5689928341047, 218, 30, 'PPL', 'P'),
(176688, 'Tilleda', 44.815559387207, 0.782179067429815, -88.9111099243164, -1.55179160978193, 218, 57, 'PPL', 'P'),
(209901, 'Tiller', 42.9286117553711, 0.749245618441568, -122.949996948242, -2.14588226206381, 218, 43, 'PPL', 'P'),
(84036, 'Tiller Circle', 33.8794403076172, 0.5913077821008, -80.3411102294922, -1.40221689821234, 218, 48, 'PPL', 'P'),
(6339, 'Tiller Crossroads', 32.9897193908691, 0.575779222679685, -85.5722198486328, -1.49351698459909, 218, 2, 'PPL', 'P'),
(84037, 'Tillersville', 34.3627815246582, 0.599743677748763, -80.3066711425781, -1.40161582275431, 218, 48, 'PPL', 'P'),
(69410, 'Tillery', 36.2516708374023, 0.632711015461881, -77.4858322143555, -1.35238289578839, 218, 33, 'PPL', 'P'),
(6340, 'Tillery Crossroad', 32.6936111450195, 0.570611158847304, -85.1961135864258, -1.4869526919862, 218, 2, 'PPL', 'P'),
(25493, 'Tilley (historical)', 31.9888896942139, 0.558311449221314, -84.8138885498047, -1.48028160661361, 218, 13, 'PPL', 'P'),
(208948, 'Tillicum', 47.1236114501953, 0.822462175236408, -122.55583190918, -2.13900278433591, 218, 56, 'PPL', 'P'),
(201662, 'Tillicum Beach', 44.3630599975586, 0.774281463217185, -124.091667175293, -2.16580816649783, 218, 43, 'PPL', 'P'),
(38544, 'Tillie', 37.1808280944824, 0.648927868866728, -82.8638916015625, -1.44624773946294, 218, 21, 'PPL', 'P'),
(25494, 'Tillman', 30.9238891601563, 0.539723683366511, -83.3497161865234, -1.45472697805765, 218, 13, 'PPL', 'P'),
(28786, 'Tillman', 38.5363883972168, 0.672586859358773, -90.1522216796875, -1.57345309629836, 218, 18, 'PPL', 'P'),
(57904, 'Tillman', 37.0552787780762, 0.64673661992181, -89.8641662597656, -1.56842558079251, 218, 29, 'PPL', 'P'),
(62030, 'Tillman', 31.8924999237061, 0.556629130360711, -90.4463882446289, -1.57858727140587, 218, 30, 'PPL', 'P'),
(84038, 'Tillman', 32.4633293151855, 0.566591982709184, -81.1074981689453, -1.41559289110337, 218, 48, 'PPL', 'P'),
(123798, 'Tillman', 41.024169921875, 0.716006838034344, -84.8933334350586, -1.48166818143516, 218, 19, 'PPL', 'P'),
(25495, 'Tillman (historical)', 30.889720916748, 0.539127335019415, -83.4622192382813, -1.45669052672936, 218, 13, 'PPL', 'P'),
(185656, 'Tillman (historical)', 37.041389465332, 0.646494205683586, -120.326393127441, -2.10009173712293, 218, 6, 'PPL', 'P'),
(106924, 'Tillmans', 37.8286094665527, 0.660233786642441, -78.6369400024414, -1.37247351673584, 218, 53, 'PPL', 'P'),
(6341, 'Tillmans Corner', 30.5900001525879, 0.533896220848227, -88.1708297729492, -1.53887128375341, 218, 2, 'PPL', 'P'),
(167953, 'Tillotson', 41.8338890075684, 0.730139102095931, -79.8180618286133, -1.39308798146971, 218, 45, 'PPL', 'P'),
(172643, 'Tillotson Mill', 44.7819404602051, 0.781592306462643, -72.5180587768555, -1.2656788928109, 218, 55, 'PPL', 'P'),
(153135, 'Tillson', 41.8288917541504, 0.730051883570231, -74.0688934326172, -1.29274606370797, 218, 40, 'PPL', 'P'),
(12321, 'Tilly', 35.7200012207031, 0.623431630117663, -92.8327789306641, -1.62023764611611, 218, 4, 'PPL', 'P'),
(153134, 'Tilly Foster', 41.416389465332, 0.722852360458338, -73.6497192382813, -1.28543009387742, 218, 40, 'PPL', 'P'),
(43352, 'Tilman Park', 30.4844398498535, 0.53205384600611, -90.5113906860352, -1.57972177803024, 218, 22, 'PPL', 'P'),
(98544, 'Tilmon', 29.7975006103516, 0.520064494515655, -97.5530624389648, -1.70262213496355, 218, 51, 'PPL', 'P'),
(57905, 'Tilsit', 37.3302803039551, 0.651536301996406, -89.741943359375, -1.56629238875935, 218, 29, 'PPL', 'P'),
(12322, 'Tilton', 35.3172187805176, 0.616401750367208, -91.0138931274414, -1.58849210013209, 218, 4, 'PPL', 'P'),
(18346, 'Tilton', 29.7388896942139, 0.519041541051442, -85.0822219848633, -1.48496490854857, 218, 12, 'PPL', 'P'),
(25496, 'Tilton', 34.6650009155273, 0.605018401182801, -84.9394378662109, -1.48247285555853, 218, 13, 'PPL', 'P'),
(38545, 'Tilton', 38.3463897705078, 0.669270757748434, -83.7597198486328, -1.46188289190669, 218, 21, 'PPL', 'P'),
(62039, 'Tilton', 31.4147205352783, 0.548290306934482, -90.0208282470703, -1.57115984828369, 218, 30, 'PPL', 'P'),
(118041, 'Tilton', 41.5097198486328, 0.724481282939085, -92.3522186279297, -1.61185028657901, 218, 16, 'PPL', 'P'),
(121705, 'Tilton', 40.0952796936035, 0.699794645161405, -87.6474990844727, -1.52973744016276, 218, 18, 'PPL', 'P'),
(144562, 'Tilton', 43.4422187805176, 0.758209752091748, -71.5894393920898, -1.2494714270489, 218, 36, 'PPL', 'P'),
(129077, 'Tilton Corner', 44.7922210693359, 0.781771736941087, -69.4922180175781, -1.21286800892047, 218, 26, 'PPL', 'P'),
(157949, 'Tilton Crossroads', 40.1697196960449, 0.7010938682992, -82.2433319091797, -1.4354169296257, 218, 41, 'PPL', 'P'),
(146456, 'Tiltons Corners', 40.4355583190918, 0.705733627550336, -74.1313934326172, -1.29383689449047, 218, 37, 'PPL', 'P'),
(157945, 'Tiltonsville', 40.1666717529297, 0.701040671656425, -80.6999969482422, -1.4084806530962, 218, 41, 'PPL', 'P'),
(185657, 'Timba', 37.3427810668945, 0.65175448146871, -121.029998779297, -2.11237197238345, 218, 6, 'PPL', 'P'),
(57906, 'Timber', 37.3630599975586, 0.652108415577582, -91.4263916015625, -1.59569155666496, 218, 29, 'PPL', 'P'),
(201663, 'Timber', 45.7200012207031, 0.797964555317096, -123.293327331543, -2.15187450767454, 218, 43, 'PPL', 'P'),
(52096, 'Timber Chase', 39.458610534668, 0.688682672092076, -76.7972183227539, -1.34036431610497, 218, 25, 'PPL', 'P'),
(143196, 'Timber Creek', 41.4480590820313, 0.723405099542584, -98.195556640625, -1.71383577420749, 218, 35, 'PPL', 'P'),
(52098, 'Timber Glade', 39.1375007629395, 0.683078249315086, -76.5727767944336, -1.33644707245758, 218, 25, 'PPL', 'P'),
(52099, 'Timber Grove', 39.4552803039551, 0.688624548601285, -76.7983322143555, -1.34038375718093, 218, 25, 'PPL', 'P'),
(201664, 'Timber Grove', 45.2008285522461, 0.788903282866156, -122.444999694824, -2.13706839727813, 218, 43, 'PPL', 'P'),
(91345, 'Timber Hills', 35.1124992370605, 0.612828720290704, -84.8874969482422, -1.48156631552346, 218, 50, 'PPL', 'P'),
(167954, 'Timber Hills', 40.246940612793, 0.702441627547862, -76.4794387817383, -1.33481801681877, 218, 45, 'PPL', 'P'),
(202688, 'Timber Lake', 45.4291687011719, 0.792888570279405, -101.073608398438, -1.76406725342413, 218, 49, 'PPL', 'P'),
(98546, 'Timber Lake Estates', 29.9416694641113, 0.522580715692589, -94.8305587768555, -1.65510548216213, 218, 51, 'PPL', 'P'),
(12324, 'Timber Lake Manor', 36.2866706848145, 0.633321878036918, -92.2125015258789, -1.60941176312688, 218, 4, 'PPL', 'P'),
(206130, 'Timber Lakes', 40.473331451416, 0.706392893078185, -111.246940612793, -1.94162539646384, 218, 52, 'PPL', 'P'),
(91346, 'Timber Line Estates', 36.0844383239746, 0.629792257486181, -83.9688873291016, -1.46553355312897, 218, 50, 'PPL', 'P'),
(18347, 'Timber Pines', 28.4699993133545, 0.496895226058561, -82.6033325195313, -1.44170012558552, 218, 12, 'PPL', 'P'),
(52100, 'Timber Point', 39.2722206115723, 0.685429554241517, -76.7847213745117, -1.3401462032117, 218, 25, 'PPL', 'P'),
(14754, 'Timber Ridge', 39.6619415283203, 0.692231467402661, -75.6297225952148, -1.31998767165645, 218, 10, 'PPL', 'P'),
(25497, 'Timber Ridge', 33.0122184753418, 0.576171905782417, -85.144172668457, -1.48604615195114, 218, 13, 'PPL', 'P'),
(52102, 'Timber Ridge', 39.4291687011719, 0.688168815159745, -77.1052780151367, -1.34574097202973, 218, 25, 'PPL', 'P'),
(84040, 'Timber Ridge', 35.1083297729492, 0.612755949413917, -81.0694427490234, -1.4149286987275, 218, 48, 'PPL', 'P'),
(91348, 'Timber Ridge', 36.2949981689453, 0.633467220053409, -82.442497253418, -1.43889302063853, 218, 50, 'PPL', 'P'),
(106928, 'Timber Ridge', 38.332218170166, 0.669023416662193, -78.8649978637695, -1.37645387730107, 218, 53, 'PPL', 'P'),
(113352, 'Timber Ridge', 40.2055587768555, 0.701719378260232, -76.8858337402344, -1.34191094690804, 218, 45, 'PPL', 'P'),
(121707, 'Timber Ridge', 40.6355590820313, 0.70922429937013, -88.8000030517578, -1.54985242903419, 218, 18, 'PPL', 'P'),
(52103, 'Timber Ridge Heights', 39.7102813720703, 0.693075156835998, -78.1258316040039, -1.36355299234851, 218, 25, 'PPL', 'P'),
(121709, 'Timber Ridge Mobile Home Park', 41.4955596923828, 0.724234141589926, -87.7755584716797, -1.53197249810761, 218, 18, 'PPL', 'P'),
(52115, 'Timber Run', 39.226390838623, 0.684629673808112, -76.8069381713867, -1.34053395946641, 218, 25, 'PPL', 'P'),
(25498, 'Timber Trace', 33.8333282470703, 0.590502974819379, -84.0530624389648, -1.46700268594431, 218, 13, 'PPL', 'P'),
(43356, 'Timber Trails', 31.4080600738525, 0.5481740599529, -92.4844436645508, -1.61415804882162, 218, 22, 'PPL', 'P'),
(185659, 'Timber Trails', 39.2486114501953, 0.685017496641855, -121.043060302734, -2.11259993897276, 218, 6, 'PPL', 'P'),
(25499, 'Timber Valley', 33.7319412231445, 0.588733437433075, -84.7247161865234, -1.47872525527257, 218, 13, 'PPL', 'P'),
(118043, 'Timber Valley Mobile Home Park', 41.9833297729492, 0.732747335488527, -92.8916702270508, -1.62126549313882, 218, 16, 'PPL', 'P'),
(52104, 'Timberbrook', 39.6124992370605, 0.691368536630448, -75.9452819824219, -1.32549522194879, 218, 25, 'PPL', 'P'),
(25500, 'Timberchase', 33.9272193908691, 0.592141684417132, -84.7422180175781, -1.4790307198496, 218, 13, 'PPL', 'P'),
(69414, 'Timbercreek', 35.6141700744629, 0.621584528164612, -80.4166717529297, -1.40353569558414, 218, 33, 'PPL', 'P'),
(192325, 'Timbercreek Canyon', 35.0530586242676, 0.611791285888063, -101.817497253418, -1.77705056321243, 218, 51, 'PPL', 'P'),
(25501, 'Timbercrest', 33.9127807617188, 0.591889682798983, -83.9800033569336, -1.46572756441438, 218, 13, 'PPL', 'P'),
(91350, 'Timbercrest', 35.9524993896484, 0.627489488670617, -84.0122222900391, -1.46628989087855, 218, 50, 'PPL', 'P'),
(121712, 'Timbercrest', 41.8597183227539, 0.730589908689454, -88.4636077880859, -1.543981224095, 218, 18, 'PPL', 'P'),
(123799, 'Timbercrest', 41.017219543457, 0.715885531046691, -85.3150024414063, -1.48902769394954, 218, 19, 'PPL', 'P'),
(98547, 'Timberhill Villa Colonia', 26.2880001068115, 0.458812155628482, -98.2170028686523, -1.7142100814987, 218, 51, 'PPL', 'P'),
(68, 'Timberhill Villa Number 4 Colonia', 26.2900009155273, 0.458847076328276, -98.2210006713867, -1.71427985631926, 218, 51, 'PPL', 'P'),
(123800, 'Timberhurst', 41.5463905334473, 0.725121307128058, -85.2186126708984, -1.48734537508894, 218, 19, 'PPL', 'P'),
(25504, 'Timberidge', 34.3899993896484, 0.600218719108206, -83.970832824707, -1.46556750843287, 218, 13, 'PPL', 'P'),
(106929, 'Timberidge Acres', 37.2713890075684, 0.65050845497369, -79.8930587768555, -1.39439692514548, 218, 53, 'PPL', 'P'),
(25505, 'Timberlake', 33.523609161377, 0.585097357017763, -84.4277801513672, -1.47354274379127, 218, 13, 'PPL', 'P'),
(52105, 'Timberlake', 38.3383293151855, 0.669130076263851, -75.6288909912109, -1.31997315742851, 218, 25, 'PPL', 'P'),
(69418, 'Timberlake', 36.2861099243164, 0.633312090919912, -78.9527816772461, -1.3779859938762, 218, 33, 'PPL', 'P'),
(84044, 'Timberlake', 34.5902786254883, 0.603714251196989, -82.918327331543, -1.44719782218183, 218, 48, 'PPL', 'P'),
(91353, 'Timberlake', 35.9416694641113, 0.627300470812249, -86.4341735839844, -1.50856091528083, 218, 50, 'PPL', 'P'),
(106931, 'Timberlake', 37.3205604553223, 0.651366658634968, -79.2577819824219, -1.3833092534211, 218, 53, 'PPL', 'P'),
(111719, 'Timberlake', 38.416389465332, 0.670492482898508, -82.3277816772461, -1.436890856131, 218, 58, 'PPL', 'P'),
(157946, 'Timberlake', 41.665828704834, 0.727205896471318, -81.4433288574219, -1.42145424234652, 218, 41, 'PPL', 'P'),
(25506, 'Timberlake North', 34.0919418334961, 0.595016633392899, -84.6208267211914, -1.47691204204439, 218, 13, 'PPL', 'P'),
(69422, 'Timberland', 35.0041694641113, 0.610938009074802, -79.2900009155273, -1.38387157988527, 218, 33, 'PPL', 'P'),
(176689, 'Timberland', 45.6761093139648, 0.797198497029535, -92.105827331543, -1.60754994720881, 218, 57, 'PPL', 'P'),
(185660, 'Timberland', 39.127498626709, 0.682903679105631, -120.16471862793, -2.09726998478994, 218, 6, 'PPL', 'P'),
(52106, 'Timberland Estates', 39.1513900756836, 0.683320663553311, -77.0555572509766, -1.34487318098853, 218, 25, 'PPL', 'P'),
(91355, 'Timberland Estates', 35.9152793884277, 0.626839877101719, -85.1244430541992, -1.48570180522219, 218, 50, 'PPL', 'P'),
(25508, 'Timberland Trail Subdivision', 33.3561096191406, 0.582173938510156, -84.8402786254883, -1.48074220032414, 218, 13, 'PPL', 'P'),
(43358, 'Timberlane', 29.8772201538086, 0.521455863027167, -90.0319366455078, -1.57135372641105, 218, 22, 'PPL', 'P'),
(77452, 'Timberlane', 36.2125015258789, 0.632027382010057, -96.2616729736328, -1.68008313686793, 218, 42, 'PPL', 'P'),
(84045, 'Timberlane', 34.815559387207, 0.607646142230382, -82.5666732788086, -1.44106030113363, 218, 48, 'PPL', 'P'),
(121713, 'Timberlane', 42.3347206115723, 0.738880262583843, -88.8611068725586, -1.55091889189271, 218, 18, 'PPL', 'P'),
(208949, 'Timberlane', 47.3652801513672, 0.826680089770876, -122.080558776855, -2.13070770333059, 218, 56, 'PPL', 'P'),
(98548, 'Timberlane Acres', 30.0877799987793, 0.525130825594394, -95.2386093139648, -1.66222730754922, 218, 51, 'PPL', 'P'),
(25509, 'Timberlay', 33.3727798461914, 0.582464888859247, -84.5494384765625, -1.47566608212839, 218, 13, 'PPL', 'P'),
(52107, 'Timberlea', 39.545280456543, 0.690195347591241, -76.3880615234375, -1.33322318279998, 218, 25, 'PPL', 'P'),
(52108, 'Timberleigh', 39.2669410705566, 0.6853374088678, -76.9216690063477, -1.34253639029004, 218, 25, 'PPL', 'P'),
(52109, 'Timberleigh Village', 39.3013916015625, 0.685938684062913, -77.1227798461914, -1.34604643660677, 218, 25, 'PPL', 'P'),
(52110, 'Timberline', 39.170280456543, 0.683650362896262, -76.6149978637695, -1.3371839691312, 218, 25, 'PPL', 'P'),
(52111, 'Timberline Park', 39.4677810668945, 0.68884272807359, -76.5961074829102, -1.33685426978825, 218, 25, 'PPL', 'P'),
(91356, 'Timberlinks', 35.1300010681152, 0.613134184867736, -85.3469390869141, -1.48958509356569, 218, 50, 'PPL', 'P'),
(133405, 'Timberlost', 46.5613899230957, 0.812649558462929, -85.1705627441406, -1.48650674566167, 218, 27, 'PPL', 'P'),
(106930, 'Timberly Heights', 37.2191696166992, 0.649597054669637, -77.352783203125, -1.3500607524759, 218, 53, 'PPL', 'P'),
(167955, 'Timberly Heights', 40.9122200012207, 0.71405294332158, -79.9258270263672, -1.39496883898958, 218, 45, 'PPL', 'P'),
(52112, 'Timbermead', 39.4324989318848, 0.688226938650536, -77.0780563354492, -1.34526586409126, 218, 25, 'PPL', 'P'),
(189671, 'Timberon', 32.6208305358887, 0.569340897586364, -105.69361114502, -1.84470151280316, 218, 38, 'PPL', 'P'),
(43360, 'Timberton (historical)', 30.076940536499, 0.524941641288458, -90.8327789306641, -1.58533106107622, 218, 22, 'PPL', 'P'),
(52113, 'Timberview', 39.2094383239746, 0.684333796611004, -76.7483291625977, -1.33951103929171, 218, 25, 'PPL', 'P'),
(106932, 'Timberville', 38.6388893127441, 0.674375837821034, -78.774169921875, -1.3748686306622, 218, 53, 'PPL', 'P'),
(157948, 'Timberville (historical)', 41.0483283996582, 0.71642848301393, -84.3808288574219, -1.47272328912386, 218, 41, 'PPL', 'P'),
(25510, 'Timberwood Estates', 34.0838890075684, 0.59487608506637, -83.9155578613281, -1.46460277832799, 218, 13, 'PPL', 'P'),
(98549, 'Timberwood Park', 29.7055606842041, 0.518459840090341, -98.4780578613281, -1.71876635064966, 218, 51, 'PPL', 'P'),
(167956, 'Timblin', 40.9663887023926, 0.714998365508558, -79.1983337402344, -1.38227168586041, 218, 45, 'PPL', 'P'),
(12326, 'Timbo', 35.8708305358887, 0.626064098276179, -92.3169403076172, -1.61123456373499, 218, 4, 'PPL', 'P'),
(167958, 'Timbuck', 41.8030586242676, 0.72960101039768, -78.6980590820313, -1.37354024591047, 218, 45, 'PPL', 'P'),
(146457, 'Timbuctoo', 40.003059387207, 0.698185097177588, -74.8144378662109, -1.3057582687941, 218, 37, 'PPL', 'P'),
(185661, 'Timbuctoo', 39.2169418334961, 0.684464757557609, -121.317497253418, -2.11738976735132, 218, 6, 'PPL', 'P'),
(28783, 'Time', 39.5613899230957, 0.690476510823326, -90.7241668701172, -1.5834354230123, 218, 18, 'PPL', 'P'),
(57907, 'Times Beach (historical)', 38.5086097717285, 0.672102030882325, -90.6025009155273, -1.58131195151713, 218, 29, 'PPL', 'P'),
(123801, 'Times Corner', 41.0616683959961, 0.716661309872231, -85.2194366455078, -1.48735975615882, 218, 19, 'PPL', 'P'),
(91357, 'Timesville', 35.1549987792969, 0.613570477233318, -85.3311080932617, -1.4893087906026, 218, 50, 'PPL', 'P'),
(98550, 'Timesville', 31.5258293151855, 0.550229520971737, -95.7838897705078, -1.67174424686268, 218, 51, 'PPL', 'P'),
(121714, 'Timewell', 40.0077781677246, 0.698267455434299, -90.8736114501953, -1.58604372298393, 218, 18, 'PPL', 'P'),
(34132, 'Timken', 38.4736099243164, 0.671491168307288, -99.1777801513672, -1.73097880846044, 218, 20, 'PPL', 'P'),
(198998, 'Timmer', 46.3713912963867, 0.80933345685259, -101.017501831055, -1.76308800909131, 218, 34, 'PPL', 'P'),
(28784, 'Timmons', 37.711669921875, 0.658192806562032, -88.9649963378906, -1.55273210512089, 218, 18, 'PPL', 'P'),
(6348, 'Timmons Springs (historical)', 33.7555618286133, 0.58914569476982, -86.0102767944336, -1.50116252061454, 218, 2, 'PPL', 'P'),
(52114, 'Timmonstown', 38.3416709899902, 0.669188399491723, -75.3036117553711, -1.31429596377473, 218, 25, 'PPL', 'P'),
(84046, 'Timmonsville', 34.1347198486328, 0.595763250604503, -79.9400024414063, -1.39521624665484, 218, 48, 'PPL', 'P'),
(194450, 'Timnath', 40.5291709899902, 0.707367476879099, -104.984718322754, -1.83232899901087, 218, 7, 'PPL', 'P'),
(43361, 'Timon', 31.889720916748, 0.556580627539358, -93.2383270263672, -1.62731579566132, 218, 22, 'PPL', 'P'),
(98551, 'Timon and Morgan Colonia', 27.9330005645752, 0.487522829813272, -97.5940017700195, -1.70333666108401, 218, 51, 'PPL', 'P'),
(129078, 'Timoney', 46.1202812194824, 0.804950759225674, -68.0972213745117, -1.18852072444469, 218, 26, 'PPL', 'P'),
(52116, 'Timonium', 39.436939239502, 0.688304436638258, -76.620002746582, -1.33727132081495, 218, 25, 'PPL', 'P'),
(52117, 'Timonium Heights', 39.4524993896484, 0.688576012490419, -76.6336135864258, -1.33750887478419, 218, 25, 'PPL', 'P'),
(28785, 'Timothy', 39.3030586242676, 0.685967779097822, -88.1294403076172, -1.53814890130772, 218, 18, 'PPL', 'P'),
(69424, 'Timothy', 35.2252807617188, 0.614797129231408, -78.4602813720703, -1.3693902419838, 218, 33, 'PPL', 'P'),
(91358, 'Timothy', 36.4891700744629, 0.636856159119562, -85.4069366455078, -1.49063224850631, 218, 50, 'PPL', 'P'),
(43362, 'Timothy (historical)', 32.9666709899902, 0.575376952197028, -93.5097198486328, -1.63205249397614, 218, 22, 'PPL', 'P'),
(25511, 'Timothy Estates', 33.9341697692871, 0.592262991404785, -83.4186096191406, -1.45592939528982, 218, 13, 'PPL', 'P'),
(153136, 'Timothy Heights', 41.7391700744629, 0.728485944849264, -73.8386077880859, -1.28872682099083, 218, 40, 'PPL', 'P'),
(206131, 'Timp View Plat A,B,C,D', 40.5180587768555, 0.707173532172714, -111.948059082031, -1.95386222219859, 218, 52, 'PPL', 'P'),
(187439, 'Timpas', 37.8180618286133, 0.660049695632089, -103.773612976074, -1.81119122312281, 218, 7, 'PPL', 'P'),
(206132, 'Timpie', 40.747501373291, 0.711178060924839, -112.655830383301, -1.96621516175686, 218, 52, 'PPL', 'P'),
(98552, 'Timpson', 31.9036102294922, 0.556823041777582, -94.3949966430664, -1.6475034888305, 218, 51, 'PPL', 'P'),
(38546, 'Timsley', 36.7841682434082, 0.642004848455012, -83.7683334350586, -1.46203322735022, 218, 21, 'PPL', 'P'),
(69425, 'Tin City', 34.7402801513672, 0.606332271706591, -77.9786071777344, -1.36098344137075, 218, 33, 'PPL', 'P'),
(185662, 'Tin City', 35.5636100769043, 0.620702089737414, -121.077217102051, -2.11319608758277, 218, 6, 'PPL', 'P'),
(212188, 'Tin City', 65.5586090087891, 1.14421358023099, -167.948059082031, -2.93124660331541, 218, 1, 'PPL', 'P'),
(91360, 'Tin Cup', 36.0455589294434, 0.629113684040429, -88.1005630493164, -1.53764489807143, 218, 50, 'PPL', 'P'),
(179354, 'Tin House', 35.6977806091309, 0.62304380728392, -112.545280456543, -1.9642857015471, 218, 5, 'PPL', 'P'),
(57908, 'Tin Mountain', 37.5247192382813, 0.654929901594466, -90.4088897705078, -1.57793279956798, 218, 29, 'PPL', 'P'),
(185664, 'Tin Shack (historical)', 34.3702812194824, 0.59987457211634, -114.269439697266, -1.9943779571264, 218, 6, 'PPL', 'P'),
(98554, 'Tin Top', 32.5974998474121, 0.56893370025569, -97.8127822875977, -1.70715510145497, 218, 51, 'PPL', 'P'),
(57909, 'Tin Town', 37.4538917541504, 0.653693728795479, -93.1930618286133, -1.62652576892395, 218, 29, 'PPL', 'P'),
(38547, 'Tina', 37.3611106872559, 0.652074393694656, -83.0197219848633, -1.44896749272619, 218, 21, 'PPL', 'P'),
(57910, 'Tina', 39.5361099243164, 0.690035291609727, -93.4400024414063, -1.63083569567408, 218, 29, 'PPL', 'P'),
(84048, 'Tina', 33.6019401550293, 0.586464490763355, -80.6116714477539, -1.40693908229921, 218, 48, 'PPL', 'P'),
(111720, 'Tina (historical)', 37.8352813720703, 0.660350233361105, -80.8652801513672, -1.41136538918898, 218, 58, 'PPL', 'P'),
(189673, 'Tinaja', 36.6530609130859, 0.639716593867389, -104.389717102051, -1.82194426865622, 218, 38, 'PPL', 'P'),
(192326, 'Tinaja', 30.1886100769043, 0.526890642442719, -103.97721862793, -1.81474481212335, 218, 51, 'PPL', 'P'),
(192327, 'Tinaja (historical)', 29.7386093139648, 0.519036647492939, -102.880561828613, -1.7956045402109, 218, 51, 'PPL', 'P'),
(91361, 'Tinch (historical)', 36.271110534668, 0.633050302184757, -84.8802795410156, -1.4814403480039, 218, 50, 'PPL', 'P'),
(187440, 'Tincup', 38.7544403076172, 0.676392583135524, -106.477783203125, -1.85838789711925, 218, 7, 'PPL', 'P'),
(84047, 'Tindal', 33.8213882446289, 0.59029458246408, -80.3569412231445, -1.40249320117543, 218, 48, 'PPL', 'P'),
(106933, 'Tindall', 37.0038909912109, 0.645839733845699, -80.3380584716797, -1.40216363499053, 218, 53, 'PPL', 'P'),
(139480, 'Tindall', 40.1611099243164, 0.700943599434692, -93.6080627441406, -1.63376890129869, 218, 29, 'PPL', 'P'),
(195720, 'Tindall (historical)', 42.2661094665527, 0.737682772199689, -115.88111114502, -2.02250693035009, 218, 17, 'PPL', 'P'),
(197693, 'Tindall (historical)', 47.1583290100098, 0.823068110963428, -107.616111755371, -1.8782554783254, 218, 31, 'PPL', 'P'),
(69426, 'Tindallsville (historical)', 34.9655609130859, 0.610264162739984, -79.9355621337891, -1.39513874866712, 218, 33, 'PPL', 'P'),
(71476, 'Tindells Landing', 39.3763885498047, 0.687247627738687, -75.2458267211914, -1.31328742466992, 218, 37, 'PPL', 'P'),
(6349, 'Tinela', 31.8083305358887, 0.55516009741391, -87.397216796875, -1.52536919018476, 218, 2, 'PPL', 'P'),
(189675, 'Tinen Place', 35.2591705322266, 0.615388617309515, -106.01277923584, -1.85027204685528, 218, 38, 'PPL', 'P'),
(77453, 'Tiner', 34.0411109924316, 0.594129467854767, -94.6333312988281, -1.65166321329515, 218, 42, 'PPL', 'P'),
(189674, 'Tingle', 34.6719398498535, 0.605139508433372, -108.540557861328, -1.89439010663159, 218, 38, 'PPL', 'P'),
(57911, 'Tingley', 37.6611099243164, 0.657310368134834, -93.998893737793, -1.64059018895677, 218, 29, 'PPL', 'P'),
(118044, 'Tingley', 40.8527793884277, 0.713015508918939, -94.1949996948242, -1.64401288358974, 218, 16, 'PPL', 'P'),
(167961, 'Tingley', 41.9030609130859, 0.731346379597091, -75.7350006103516, -1.32182511965055, 218, 45, 'PPL', 'P'),
(189676, 'Tinian', 35.8400001525879, 0.625526006577929, -107.325561523438, -1.87318442013573, 218, 38, 'PPL', 'P'),
(167959, 'Tinicum', 40.4483299255371, 0.705956534133575, -75.1080627441406, -1.31088298967974, 218, 45, 'PPL', 'P'),
(106934, 'Tinker (historical)', 37.4536094665527, 0.653688801947462, -80.0141677856445, -1.39651067610268, 218, 53, 'PPL', 'P'),
(106936, 'Tinker Knoll', 37.3486099243164, 0.651856214222352, -79.9591674804688, -1.39555073968776, 218, 53, 'PPL', 'P'),
(153137, 'Tinker Tavern Corner', 43.5066719055176, 0.759334671336197, -76.1283264160156, -1.32868994999245, 218, 40, 'PPL', 'P'),
(106935, 'Tinkertown', 37.9413909912109, 0.662202195583146, -79.8747177124023, -1.39407681318245, 218, 53, 'PPL', 'P'),
(126347, 'Tinkertown', 42.023609161377, 0.733450343437281, -70.720832824707, -1.23431138254362, 218, 23, 'PPL', 'P'),
(153138, 'Tinkertown', 42.2677803039551, 0.737711933813626, -77.7680587768555, -1.3573086785406, 218, 40, 'PPL', 'P'),
(57912, 'Tinkerville', 36.190559387207, 0.631644419445304, -89.959716796875, -1.57009325226712, 218, 29, 'PPL', 'P'),
(144565, 'Tinkerville', 44.2722206115723, 0.772696016841234, -71.9355621337891, -1.25551240850758, 218, 36, 'PPL', 'P'),
(126348, 'Tinkhamtown', 41.6833305358887, 0.72751136104835, -70.8516693115234, -1.23659491002031, 218, 23, 'PPL', 'P'),
(121715, 'Tinley Park', 41.5733299255371, 0.725591488218512, -87.7844390869141, -1.53212749408306, 218, 18, 'PPL', 'P'),
(172645, 'Tinmouth', 43.4486083984375, 0.758321271962395, -73.0500030517578, -1.27496307184508, 218, 55, 'PPL', 'P'),
(157950, 'Tinney', 41.3127784729004, 0.721044007499147, -83.311393737793, -1.45405812514987, 218, 41, 'PPL', 'P'),
(57913, 'Tinney Grove', 39.5041694641113, 0.689477825414547, -93.8041687011719, -1.63719159593166, 218, 29, 'PPL', 'P'),
(189677, 'Tinnie', 33.3705596923828, 0.582426139865386, -105.225830078125, -1.83653719300736, 218, 38, 'PPL', 'P'),
(62035, 'Tinnin', 32.4241714477539, 0.565908548994442, -90.3452835083008, -1.57682266086758, 218, 30, 'PPL', 'P'),
(106937, 'Tinsberry Trace', 37.3066711425781, 0.651124244396743, -77.4127807617188, -1.35110790741652, 218, 53, 'PPL', 'P'),
(62036, 'Tinsley', 32.7319412231445, 0.571280144913132, -90.4602813720703, -1.57882975222312, 218, 30, 'PPL', 'P'),
(84049, 'Tinsley', 34.3147201538086, 0.598904848584415, -82.2802810668945, -1.43606181408366, 218, 48, 'PPL', 'P'),
(189678, 'Tinsley Crossing', 34.1269416809082, 0.595627495967936, -103.420829772949, -1.80503399468254, 218, 38, 'PPL', 'P'),
(25512, 'Tinsley Mill Village', 33.4052810668945, 0.583032142171434, -84.5819396972656, -1.47623333544058, 218, 13, 'PPL', 'P'),
(106938, 'Tinsleys', 37.5058288574219, 0.654600202251515, -77.5800018310547, -1.35402646565513, 218, 53, 'PPL', 'P'),
(12328, 'Tinsman', 33.6297187805176, 0.586949319239804, -92.3550033569336, -1.61189888926891, 218, 4, 'PPL', 'P'),
(138443, 'Tintah', 46.0097198486328, 0.80302109927883, -96.3222198486328, -1.68113987918848, 218, 28, 'PPL', 'P'),
(192822, 'Tintic Junction', 39.9272193908691, 0.696861439536791, -112.160003662109, -1.95756135295271, 218, 52, 'PPL', 'P'),
(202687, 'Tinton', 44.3805618286133, 0.774586927794217, -104.048057556152, -1.81598118465942, 218, 49, 'PPL', 'P'),
(146458, 'Tinton Falls', 40.3041687011719, 0.703440446114696, -74.100830078125, -1.29330346332413, 218, 37, 'PPL', 'P'),
(12329, 'Tintop', 34.7533302307129, 0.60656003855882, -94.2708282470703, -1.64533634149345, 218, 4, 'PPL', 'P'),
(52118, 'Tintop Hill', 38.3222198486328, 0.668848913031766, -76.6188888549805, -1.337251879739, 218, 25, 'PPL', 'P'),
(177643, 'Tintown', 31.4141693115234, 0.548280686265044, -109.89778137207, -1.91807812557952, 218, 5, 'PPL', 'P'),
(106939, 'Tiny', 37.1055603027344, 0.647614198080019, -82.2397232055664, -1.43535394586592, 218, 53, 'PPL', 'P'),
(98555, 'Tiny Acres Colonia', 26.2390003204346, 0.45795694802343, -98.1579971313477, -1.71318023710517, 218, 51, 'PPL', 'P'),
(69427, 'Tiny Oak Fork', 35.4066696166992, 0.61796296197724, -76.288330078125, -1.3314825407115, 218, 33, 'PPL', 'P'),
(106940, 'Tinytown', 36.9819412231445, 0.645456638122891, -80.6966705322266, -1.40842259618444, 218, 53, 'PPL', 'P'),
(25513, 'Tioga', 34.6100006103516, 0.604058464767882, -84.5041732788086, -1.47487605539102, 218, 13, 'PPL', 'P'),
(43363, 'Tioga', 31.3869400024414, 0.54780544516852, -92.4255599975586, -1.61313033495696, 218, 22, 'PPL', 'P'),
(91362, 'Tioga', 36.1277809143066, 0.630548728393818, -84.4049987792969, -1.47314513384053, 218, 50, 'PPL', 'P'),
(98556, 'Tioga', 33.4666709899902, 0.584103598457, -96.9180603027344, -1.69153925692913, 218, 51, 'PPL', 'P'),
(111721, 'Tioga', 38.420280456543, 0.670560393506305, -80.6563873291016, -1.40771952165666, 218, 58, 'PPL', 'P'),
(118046, 'Tioga', 41.2969398498535, 0.720767571377997, -92.4222183227539, -1.61307201172909, 218, 16, 'PPL', 'P'),
(121716, 'Tioga', 40.211109161377, 0.701816250744884, -91.3469390869141, -1.59430484868535, 218, 18, 'PPL', 'P'),
(133406, 'Tioga', 46.5583305358887, 0.812596162083073, -88.3486099243164, -1.54197413273946, 218, 27, 'PPL', 'P'),
(167970, 'Tioga', 41.9086112976074, 0.731443252081743, -77.1333312988281, -1.34623059419615, 218, 45, 'PPL', 'P'),
(176690, 'Tioga', 44.6841697692871, 0.779885885994175, -90.7930603027344, -1.58463784024447, 218, 57, 'PPL', 'P'),
(187441, 'Tioga', 37.6988906860352, 0.657969766820737, -104.926940917969, -1.83132059306412, 218, 7, 'PPL', 'P'),
(199001, 'Tioga', 48.3972206115723, 0.844690848486, -102.937782287598, -1.79660322561968, 218, 34, 'PPL', 'P'),
(153139, 'Tioga Center', 42.0561103820801, 0.734017596749468, -76.3483276367188, -1.33252969565212, 218, 40, 'PPL', 'P'),
(167964, 'Tioga Junction', 41.9577789306641, 0.732301389163993, -77.1074981689453, -1.34577972102359, 218, 45, 'PPL', 'P'),
(79267, 'Tioga Park', 39.9972190856934, 0.698083164686865, -75.1033325195313, -1.31080043168595, 218, 45, 'PPL', 'P'),
(167965, 'Tioga Valley', 41.961669921875, 0.732369299771791, -76.4783325195313, -1.33479870890087, 218, 45, 'PPL', 'P'),
(167968, 'Tiona', 41.746940612793, 0.728621566327777, -79.067497253418, -1.37998815838372, 218, 45, 'PPL', 'P'),
(167969, 'Tionesta', 41.4952812194824, 0.724229281320936, -79.4561080932617, -1.38677069704793, 218, 45, 'PPL', 'P'),
(194013, 'Tionesta', 41.646110534668, 0.726861749479452, -121.326942443848, -2.1175546170228, 218, 6, 'PPL', 'P'),
(123802, 'Tiosa', 41.1527786254883, 0.718251483359117, -86.2055587768555, -1.50457083417762, 218, 19, 'PPL', 'P'),
(12330, 'Tip', 35.1627807617188, 0.613706298448912, -91.1672210693359, -1.59116817755346, 218, 4, 'PPL', 'P'),
(77454, 'Tip', 36.350830078125, 0.634441670696269, -95.1838912963867, -1.66127229798232, 218, 42, 'PPL', 'P'),
(91363, 'Tip Top', 36.538890838623, 0.637723950160764, -87.8966674804688, -1.53408624906481, 218, 50, 'PPL', 'P'),
(153142, 'Tip Top', 42.2230606079102, 0.736931427877151, -77.7900009155273, -1.35769164110536, 218, 40, 'PPL', 'P'),
(84050, 'Tip Top (historical)', 34.6613883972168, 0.604955350843993, -81.0686111450195, -1.41491418449956, 218, 48, 'PPL', 'P'),
(179355, 'Tip Top (historical)', 34.0508308410645, 0.594299111216205, -112.246109008789, -1.95906417475584, 218, 5, 'PPL', 'P'),
(106941, 'Tipers', 37.8447189331055, 0.660514949874526, -76.3716735839844, -1.33293715929891, 218, 53, 'PPL', 'P'),
(153143, 'Tiplady', 43.2519416809082, 0.754888790212419, -73.2841720581055, -1.27905009201197, 218, 40, 'PPL', 'P'),
(176691, 'Tipler', 45.9249992370605, 0.80154244566259, -88.6347198486328, -1.54696769294141, 218, 57, 'PPL', 'P'),
(62037, 'Tiplersville', 34.8955612182617, 0.609042437589911, -88.9075012207031, -1.55172862602215, 218, 30, 'PPL', 'P'),
(74553, 'Tipp City', 39.9583282470703, 0.697404391504031, -84.1722183227539, -1.46908234843955, 218, 41, 'PPL', 'P'),
(123803, 'Tippecanoe', 41.2088890075684, 0.719230794270966, -86.1149978637695, -1.50299024807066, 218, 19, 'PPL', 'P'),
(157951, 'Tippecanoe', 40.269718170166, 0.702839170919583, -81.2869415283203, -1.4187247685453, 218, 41, 'PPL', 'P'),
(167973, 'Tippecanoe', 40.0127792358398, 0.698354740539026, -79.7947235107422, -1.39268065098098, 218, 45, 'PPL', 'P'),
(185665, 'Tippecanoe (historical)', 39.4638900756836, 0.688774817465793, -120.964721679688, -2.11123267206911, 218, 6, 'PPL', 'P'),
(190832, 'Tippecanoe (historical)', 38.836669921875, 0.677827760646968, -119.189720153809, -2.0802530512146, 218, 39, 'PPL', 'P'),
(12331, 'Tipperary', 36.334171295166, 0.634150920084259, -90.4725036621094, -1.57904307142644, 218, 4, 'PPL', 'P'),
(118048, 'Tipperary', 41.1136093139648, 0.717567849907294, -93.154167175293, -1.62584692916209, 218, 16, 'PPL', 'P'),
(139481, 'Tipperary', 40.1916694641113, 0.701476964022008, -92.709716796875, -1.61808980669696, 218, 29, 'PPL', 'P'),
(195721, 'Tipperary Corner', 42.5788917541504, 0.743141852960188, -114.295562744141, -1.99483389030502, 218, 17, 'PPL', 'P'),
(167974, 'Tippery', 41.377498626709, 0.722173587275504, -79.6374969482422, -1.38993652979376, 218, 45, 'PPL', 'P'),
(197694, 'Tippet Place', 45.9258308410645, 0.801556959890531, -112.182220458984, -1.95794910920742, 218, 31, 'PPL', 'P'),
(52119, 'Tippett', 38.7472190856934, 0.676266549036936, -76.932502746582, -1.34272547472744, 218, 25, 'PPL', 'P'),
(190833, 'Tippett', 39.8686103820801, 0.695838519362092, -114.348892211914, -1.995764665106, 218, 39, 'PPL', 'P'),
(25514, 'Tippetts', 32.2641716003418, 0.563116024854412, -83.4863891601563, -1.45711237144603, 218, 13, 'PPL', 'P'),
(25515, 'Tippettville', 32.0986099243164, 0.560226428492649, -83.6141662597656, -1.45934250254286, 218, 13, 'PPL', 'P'),
(167975, 'Tippletown', 40.6150016784668, 0.708865504992269, -78.5061111450195, -1.37019012241721, 218, 45, 'PPL', 'P'),
(62040, 'Tippo', 33.9119415283203, 0.591875035412987, -90.1805572509766, -1.57394764531279, 218, 30, 'PPL', 'P'),
(91364, 'Tiprell', 36.5825004577637, 0.638485081600309, -83.6788864135742, -1.46047208231922, 218, 50, 'PPL', 'P'),
(12332, 'Tipton', 33.7936096191406, 0.589809753987631, -92.2866668701172, -1.61070619257472, 218, 4, 'PPL', 'P'),
(34136, 'Tipton', 39.3430595397949, 0.686665926777586, -98.4705581665039, -1.71863545628208, 218, 20, 'PPL', 'P'),
(57915, 'Tipton', 38.6555595397949, 0.674666788170125, -92.7797164916992, -1.61931153184703, 218, 29, 'PPL', 'P'),
(77455, 'Tipton', 34.5027809143066, 0.60218712804891, -99.1405563354492, -1.73032913031251, 218, 42, 'PPL', 'P'),
(91365, 'Tipton', 35.4136085510254, 0.618084069227811, -89.8197174072266, -1.56764980196697, 218, 50, 'PPL', 'P'),
(111722, 'Tipton', 38.2588882446289, 0.667743568021328, -80.9891662597656, -1.41352760967801, 218, 58, 'PPL', 'P'),
(118049, 'Tipton', 41.769718170166, 0.729019109699498, -91.1277770996094, -1.59047975041167, 218, 16, 'PPL', 'P'),
(121717, 'Tipton', 40.0697212219238, 0.699348565678816, -88.0350036621094, -1.53650067090907, 218, 18, 'PPL', 'P'),
(123810, 'Tipton', 40.2822189331055, 0.703057350391888, -86.0411071777344, -1.50170061231279, 218, 19, 'PPL', 'P'),
(133407, 'Tipton', 42.0166702270508, 0.73332923618671, -84.0641708374023, -1.46719656407167, 218, 27, 'PPL', 'P'),
(157952, 'Tipton', 41.0191688537598, 0.715919552929616, -84.6697235107422, -1.4777654520157, 218, 41, 'PPL', 'P'),
(167976, 'Tipton', 40.6358299255371, 0.709229026481065, -78.2961120605469, -1.36652494696698, 218, 45, 'PPL', 'P'),
(185666, 'Tipton', 36.059440612793, 0.629355965120599, -119.311111450195, -2.08237172901981, 218, 6, 'PPL', 'P'),
(209789, 'Tipton', 41.6277809143066, 0.726541837253506, -108.26277923584, -1.88954195502516, 218, 59, 'PPL', 'P'),
(43364, 'Tipton (historical)', 32.9172210693359, 0.574513888266761, -91.85888671875, -1.60324002045868, 218, 22, 'PPL', 'P'),
(195722, 'Tipton (historical)', 42.2805595397949, 0.73793497355492, -113.159721374512, -1.97500971862463, 218, 17, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(57914, 'Tipton Ford', 36.9766693115234, 0.645364625907229, -94.4258270263672, -1.64804158052875, 218, 29, 'PPL', 'P'),
(69428, 'Tipton Hill', 36.0344390869141, 0.62891960617599, -82.2677764892578, -1.43584356803233, 218, 33, 'PPL', 'P'),
(118050, 'Tipton Mobile Home Park', 41.7777786254883, 0.729159791184081, -91.1305618286133, -1.59052835310157, 218, 16, 'PPL', 'P'),
(38548, 'Tipton Ridge', 37.711109161377, 0.658183019445025, -83.8811111450195, -1.4640015697119, 218, 21, 'PPL', 'P'),
(91367, 'Tiptonville', 36.3783302307129, 0.634921638903728, -89.4719390869141, -1.56157992521046, 218, 50, 'PPL', 'P'),
(189679, 'Tiptonville', 35.8205604553223, 0.625186719855053, -104.996940612793, -1.83254231821419, 218, 38, 'PPL', 'P'),
(38549, 'Tiptop', 37.6138916015625, 0.656486252935509, -83.0611114501953, -1.44968987517187, 218, 21, 'PPL', 'P'),
(91368, 'Tiptop', 35.6433296203613, 0.622093458248926, -85.2177810668945, -1.487330860861, 218, 50, 'PPL', 'P'),
(106942, 'Tiptop', 37.2108306884766, 0.649451512916064, -81.4341735839844, -1.42129445268112, 218, 53, 'PPL', 'P'),
(197695, 'Tipville (historical)', 48.851390838623, 0.852617614312566, -112.319442749023, -1.96034408997573, 218, 31, 'PPL', 'P'),
(98557, 'Tira', 33.3263893127441, 0.581655221308836, -95.5744400024414, -1.66808865879238, 218, 51, 'PPL', 'P'),
(167977, 'Tire Hill', 40.2686080932617, 0.702819796422653, -78.9161071777344, -1.37734590310819, 218, 45, 'PPL', 'P'),
(208950, 'Tire Junction', 46.0980606079102, 0.804562936391931, -121.720558166504, -2.12442450737077, 218, 56, 'PPL', 'P'),
(157953, 'Tiro', 40.9055595397949, 0.713936696339998, -82.7727813720703, -1.44465756597606, 218, 41, 'PPL', 'P'),
(84051, 'Tirzah', 34.9961090087891, 0.610797327590218, -81.1436080932617, -1.41622312817534, 218, 48, 'PPL', 'P'),
(167978, 'Tirzah', 41.75, 0.728674962707633, -75.5611114501953, -1.3187901812723, 218, 45, 'PPL', 'P'),
(176693, 'Tisch Mills', 44.327220916748, 0.773655953256153, -87.6236114501953, -1.52932052229411, 218, 57, 'PPL', 'P'),
(34134, 'Tisdale', 37.2433280944824, 0.650018699649224, -96.8516693115234, -1.69038051553883, 218, 20, 'PPL', 'P'),
(84052, 'Tisdale', 33.4874992370605, 0.584467119945796, -79.6563873291016, -1.39026622913671, 218, 48, 'PPL', 'P'),
(185667, 'Tisdale', 39.0405616760254, 0.681386343074559, -121.785003662109, -2.12554929345716, 218, 6, 'PPL', 'P'),
(62041, 'Tisdell Landing', 32.9322204589844, 0.574775677001916, -90.7566680908203, -1.58400267632449, 218, 30, 'PPL', 'P'),
(6350, 'Tishabee', 32.6375007629395, 0.569631847935455, -87.9986114501953, -1.53586550698909, 218, 2, 'PPL', 'P'),
(62043, 'Tishomingo', 34.6366691589355, 0.6045239187474, -88.2316665649414, -1.53993308608002, 218, 30, 'PPL', 'P'),
(77456, 'Tishomingo', 34.2361106872559, 0.597532854569833, -96.6783294677734, -1.6873551645405, 218, 42, 'PPL', 'P'),
(121718, 'Tiskilwa', 41.2922210693359, 0.720685213121286, -89.5061111450195, -1.56217634013658, 218, 18, 'PPL', 'P'),
(25516, 'Tison', 31.9383296966553, 0.557429010794116, -82.0208282470703, -1.43153350812415, 218, 13, 'PPL', 'P'),
(28788, 'Tison', 37.889720916748, 0.661300382659018, -88.5144424438477, -1.54486845621216, 218, 18, 'PPL', 'P'),
(18348, 'Tisonia', 30.5341701507568, 0.53292180349488, -81.6213912963867, -1.42456201818059, 218, 12, 'PPL', 'P'),
(126352, 'Tississa', 41.3583297729492, 0.721839027663563, -70.6527786254883, -1.23312361269744, 218, 23, 'PPL', 'P'),
(38550, 'Titan Siding', 37.4627799987793, 0.653848857928976, -82.5261077880859, -1.44035229975783, 218, 21, 'PPL', 'P'),
(77457, 'Titanic', 35.9008293151855, 0.626587675746489, -94.7719421386719, -1.65408242882938, 218, 42, 'PPL', 'P'),
(114169, 'Titicus', 41.2922210693359, 0.720685213121286, -73.5038909912109, -1.28288491082363, 218, 8, 'PPL', 'P'),
(192328, 'Titley', 30.4833297729492, 0.532034471509179, -103.588333129883, -1.80795747976918, 218, 51, 'PPL', 'P'),
(208951, 'Titlow', 47.2466697692871, 0.82460994807653, -122.551666259766, -2.13893008003815, 218, 56, 'PPL', 'P'),
(167979, 'Titlows Corner', 40.2277793884277, 0.702107201093975, -75.6549987792969, -1.32042882429102, 218, 45, 'PPL', 'P'),
(6351, 'Tito', 32.0813903808594, 0.559925890763634, -85.7388916015625, -1.49642595545778, 218, 2, 'PPL', 'P'),
(106943, 'Tito', 36.7580604553223, 0.6415491815925, -82.8144378662109, -1.44538460895365, 218, 53, 'PPL', 'P'),
(118052, 'Titonka', 43.2369384765625, 0.754626934898237, -94.0411071777344, -1.64132695247234, 218, 16, 'PPL', 'P'),
(118053, 'Titu', 41.2750015258789, 0.72038467539227, -91.7916717529297, -1.6020668979985, 218, 16, 'PPL', 'P'),
(6352, 'Titus', 32.7122192382813, 0.570935931342239, -86.3183288574219, -1.50653904338125, 218, 2, 'PPL', 'P'),
(25517, 'Titus', 34.9469413757324, 0.609939190507968, -83.6316680908203, -1.45964796711989, 218, 13, 'PPL', 'P'),
(28789, 'Titus', 39.1933288574219, 0.684052633378919, -90.57861328125, -1.58089503364848, 218, 18, 'PPL', 'P'),
(31311, 'Titus', 38.0541687011719, 0.664170537944823, -86.2561111450195, -1.50545313944677, 218, 19, 'PPL', 'P'),
(91369, 'Titus', 36.3916702270508, 0.635154465762029, -84.279167175293, -1.47094895804759, 218, 50, 'PPL', 'P'),
(133408, 'Titus', 43.6683311462402, 0.762156157353082, -85.1069412231445, -1.48539634064516, 218, 27, 'PPL', 'P'),
(185668, 'Titus', 32.6324996948242, 0.569544562830727, -116.178886413574, -2.02770408921738, 218, 6, 'PPL', 'P'),
(52120, 'Titus Estates', 39.2755584716797, 0.685487810890363, -77.4930572509766, -1.35250899646601, 218, 25, 'PPL', 'P'),
(18352, 'Titusville', 28.6119403839111, 0.49937256508358, -80.8077774047852, -1.41036177693218, 218, 12, 'PPL', 'P'),
(146460, 'Titusville', 40.309440612793, 0.703532458330358, -74.8808288574219, -1.3069170101844, 218, 37, 'PPL', 'P'),
(153144, 'Titusville', 41.6674995422363, 0.727235058085254, -73.8744430541992, -1.28935226437283, 218, 40, 'PPL', 'P'),
(167980, 'Titusville', 41.6269416809082, 0.726527189867511, -79.6738891601563, -1.39057169371375, 218, 45, 'PPL', 'P'),
(169631, 'Tiverton', 41.6258316040039, 0.726507815370581, -71.2138900756836, -1.24291685497399, 218, 47, 'PPL', 'P'),
(157954, 'Tiverton Center', 40.4180603027344, 0.705428229552331, -82.1383285522461, -1.43358427532156, 218, 41, 'PPL', 'P'),
(169632, 'Tiverton Four Corners', 41.5708312988281, 0.725547878955662, -71.1883316040039, -1.2424707754914, 218, 47, 'PPL', 'P'),
(98559, 'Tivett', 29.9874992370605, 0.523380596125994, -94.7416687011719, -1.65355405766911, 218, 51, 'PPL', 'P'),
(106944, 'Tivis', 37.2466697692871, 0.650077022877097, -82.3724975585938, -1.43767129548845, 218, 53, 'PPL', 'P'),
(98560, 'Tivoli', 28.4549999237061, 0.496633437323406, -96.8877792358398, -1.6910107526108, 218, 51, 'PPL', 'P'),
(153145, 'Tivoli', 42.0583305358887, 0.734056345743328, -73.9097213745117, -1.28996798721686, 218, 40, 'PPL', 'P'),
(167982, 'Tivoli', 41.2980613708496, 0.720787145612009, -76.6916732788086, -1.33852220757897, 218, 45, 'PPL', 'P'),
(98561, 'Tivydale', 30.250560760498, 0.527971885845291, -99.0991668701172, -1.72960674786683, 218, 51, 'PPL', 'P'),
(12252, 'TKO Subdivision', 34.935001373291, 0.609730798152669, -92.0708312988281, -1.6069391512128, 218, 4, 'PPL', 'P'),
(153146, 'Toad Harbor', 43.2413902282715, 0.75470463262304, -76.0752792358398, -1.32776410203948, 218, 40, 'PPL', 'P'),
(31310, 'Toad Hop', 39.4588890075684, 0.688687532361066, -87.4636077880859, -1.52652793157505, 218, 19, 'PPL', 'P'),
(12334, 'Toad Suck', 35.0755615234375, 0.612184035569823, -92.5597229003906, -1.61547191934541, 218, 4, 'PPL', 'P'),
(189680, 'Toadlena', 36.2369384765625, 0.632453887258634, -108.891937255859, -1.90052283398983, 218, 38, 'PPL', 'P'),
(185669, 'Toadtown', 39.8880615234375, 0.69617800582205, -121.58943939209, -2.12213605304606, 218, 6, 'PPL', 'P'),
(6353, 'Toadvine', 33.499439239502, 0.584675512301094, -87.1555633544922, -1.5211515419664, 218, 2, 'PPL', 'P'),
(106946, 'Toano', 37.3797187805176, 0.652399166189591, -76.804443359375, -1.34049041678259, 218, 53, 'PPL', 'P'),
(200235, 'Toano (historical)', 41.1316719055176, 0.717883101601332, -114.422218322754, -1.99704444716784, 218, 39, 'PPL', 'P'),
(69429, 'Toast', 36.5002784729004, 0.63705003724692, -80.6266708374023, -1.40720087103436, 218, 33, 'PPL', 'P'),
(106945, 'Tobacco', 36.889720916748, 0.643847090139074, -77.9377822875977, -1.3602709126211, 218, 53, 'PPL', 'P'),
(197696, 'Tobacco', 48.8311080932617, 0.852263613624667, -114.976112365723, -2.00671172192483, 218, 31, 'PPL', 'P'),
(197697, 'Tobacco (historical)', 48.9199981689453, 0.853815038117693, -115.055557250977, -2.00809829674638, 218, 31, 'PPL', 'P'),
(31314, 'Tobacco Landing', 38.0052795410156, 0.663317261131562, -86.086669921875, -1.50249583221429, 218, 19, 'PPL', 'P'),
(98562, 'Tobacco Patch', 30.7230091094971, 0.536217665080935, -95.1039733886719, -1.65987746736139, 218, 51, 'PPL', 'P'),
(18349, 'Tobacco Patch Landing', 29.4302806854248, 0.513655297746756, -81.9252777099609, -1.42986583664954, 218, 12, 'PPL', 'P'),
(52136, 'Tobacco Woods', 38.6186103820801, 0.674021903712163, -76.5311126708984, -1.33571989632193, 218, 25, 'PPL', 'P'),
(91370, 'Tobaccoport', 36.642219543457, 0.639527376271939, -87.8899993896484, -1.53396986892517, 218, 50, 'PPL', 'P'),
(69431, 'Tobaccoville', 36.2380599975586, 0.632473461492646, -80.3716735839844, -1.40275032937868, 218, 33, 'PPL', 'P'),
(106947, 'Tobaccoville', 37.4822196960449, 0.654188144651852, -78.0961074829102, -1.36303420856816, 218, 53, 'PPL', 'P'),
(200236, 'Tobar (historical)', 40.8963890075684, 0.713776640358484, -114.889442443848, -2.00519904642566, 218, 39, 'PPL', 'P'),
(74554, 'Tobasco', 39.0683288574219, 0.681870971813926, -84.2977828979492, -1.47127386370058, 218, 41, 'PPL', 'P'),
(187442, 'Tobe', 37.2191696166992, 0.649597054669637, -103.611106872559, -1.80835495656187, 218, 7, 'PPL', 'P'),
(69430, 'Tobermory', 34.8091697692871, 0.607534622359735, -78.8772201538086, -1.37666719650439, 218, 33, 'PPL', 'P'),
(129079, 'Tobeys Corner', 43.1183280944824, 0.752556793203891, -70.7925033569336, -1.23556226930763, 218, 26, 'PPL', 'P'),
(143199, 'Tobias', 40.4180603027344, 0.705428229552331, -97.3358306884766, -1.69883072567766, 218, 35, 'PPL', 'P'),
(157962, 'Tobias', 40.6883316040039, 0.710145353633134, -83.0663909912109, -1.44978202054559, 218, 41, 'PPL', 'P'),
(201665, 'Tobias', 45.4955596923828, 0.794047311669699, -122.879997253418, -2.14466053691373, 218, 43, 'PPL', 'P'),
(133411, 'Tobico Beach', 43.6763916015625, 0.762296838837665, -83.9122161865234, -1.46454445510011, 218, 27, 'PPL', 'P'),
(52121, 'Tobin', 39.4036102294922, 0.687722735677157, -76.758056640625, -1.3396808158112, 218, 25, 'PPL', 'P'),
(176694, 'Tobin', 42.5074996948242, 0.741895826465168, -87.8405609130859, -1.53310700473199, 218, 57, 'PPL', 'P'),
(185670, 'Tobin', 39.938060760498, 0.697050657132241, -121.307502746582, -2.11721533029992, 218, 6, 'PPL', 'P'),
(194451, 'Tobin', 40.834171295166, 0.712690736424004, -102.872222900391, -1.79545899845733, 218, 7, 'PPL', 'P'),
(197698, 'Tobin', 46.6380615234375, 0.813987730331667, -112.103607177734, -1.95657704861381, 218, 31, 'PPL', 'P'),
(133412, 'Tobin Location', 46.0924987792969, 0.804465864170198, -88.3561096191406, -1.54210502710704, 218, 27, 'PPL', 'P'),
(31313, 'Tobinsport', 37.8525009155273, 0.66065077109012, -86.6355590820313, -1.51207575528752, 218, 19, 'PPL', 'P'),
(138448, 'Tobique', 47.1155586242676, 0.822321626909879, -94.039436340332, -1.6412977908584, 218, 28, 'PPL', 'P'),
(157956, 'Toboso', 40.0563888549805, 0.699115871978571, -82.2183303833008, -1.43498057068109, 218, 41, 'PPL', 'P'),
(167984, 'Toby', 41.3274993896484, 0.721300935965312, -78.6322174072266, -1.3723910919001, 218, 45, 'PPL', 'P'),
(167987, 'Tobyhanna', 41.1769409179688, 0.718673194917731, -75.418327331543, -1.31629812828225, 218, 45, 'PPL', 'P'),
(84053, 'Tobys Bluff', 32.910831451416, 0.574402368396114, -80.9891662597656, -1.41352760967801, 218, 48, 'PPL', 'P'),
(52122, 'Tobytown', 39.0611114501953, 0.681745004294365, -77.2874984741211, -1.34892131900351, 218, 25, 'PPL', 'P'),
(43365, 'Toca', 29.8663902282715, 0.521266845168798, -89.8363876342773, -1.56794075231606, 218, 22, 'PPL', 'P'),
(185671, 'Tocaloma', 38.0502815246582, 0.664102693916054, -122.758331298828, -2.14253706541856, 218, 6, 'PPL', 'P'),
(25519, 'Toccoa', 34.577220916748, 0.603486351186706, -83.3324966430664, -1.45442644032863, 218, 13, 'PPL', 'P'),
(57916, 'Toccoa', 36.7511100769043, 0.641427874604846, -92.2358322143555, -1.60981896045756, 218, 29, 'PPL', 'P'),
(25518, 'Toccoa Falls', 34.5936088562012, 0.60377237468778, -83.3583297729492, -1.45487731350118, 218, 13, 'PPL', 'P'),
(62044, 'Toccopola', 34.2563896179199, 0.597886788678705, -89.2355575561523, -1.55745428920776, 218, 30, 'PPL', 'P'),
(189681, 'Tocito', 36.3994407653809, 0.635290087240541, -108.780563354492, -1.89857899271018, 218, 38, 'PPL', 'P'),
(18350, 'Tocktoethla (historical)', 30.8666706085205, 0.538725031247245, -84.966667175293, -1.48294809665505, 218, 12, 'PPL', 'P'),
(98563, 'Toco', 33.6547203063965, 0.587385678184413, -95.6458282470703, -1.66933461870837, 218, 51, 'PPL', 'P'),
(18351, 'Tocoi', 29.8447208404541, 0.520888643004493, -81.5580596923828, -1.42345667317015, 218, 12, 'PPL', 'P'),
(62045, 'Tocowa', 34.2236099243164, 0.597314675097529, -90.0597229003906, -1.57183868804555, 218, 30, 'PPL', 'P'),
(123813, 'Tocsin', 40.8302803039551, 0.712622825816207, -85.1091690063477, -1.48543522279708, 218, 19, 'PPL', 'P'),
(43366, 'Todd', 29.7080593109131, 0.518503449353191, -91.4636077880859, -1.59634110165483, 218, 22, 'PPL', 'P'),
(69436, 'Todd', 36.309440612793, 0.633719288250585, -81.5955581665039, -1.42411114500804, 218, 33, 'PPL', 'P'),
(77458, 'Todd', 36.6666717529297, 0.639954147836624, -95.0530624389648, -1.65898890366369, 218, 42, 'PPL', 'P'),
(98564, 'Todd', 30.2677803039551, 0.528272423574306, -95.8394393920898, -1.67271377065752, 218, 51, 'PPL', 'P'),
(143200, 'Todd', 40.8811111450195, 0.71350999135434, -95.9300003051758, -1.67429435676448, 218, 35, 'PPL', 'P'),
(167989, 'Todd', 40.2599983215332, 0.702669527558145, -78.0766677856445, -1.36269492184529, 218, 45, 'PPL', 'P'),
(193318, 'Todd', 57.461109161377, 1.00288554671391, -135.03971862793, -2.35688771102409, 218, 1, 'PPL', 'P'),
(12335, 'Todd (historical)', 33.9144401550293, 0.591918644675837, -91.7513885498047, -1.60136382347072, 218, 4, 'PPL', 'P'),
(57917, 'Todd (historical)', 38.3177795410156, 0.668771415044044, -92.9852828979492, -1.62289934246759, 218, 29, 'PPL', 'P'),
(98566, 'Todd City', 31.9188899993896, 0.55708972407124, -95.4775009155273, -1.66639675255185, 218, 51, 'PPL', 'P'),
(98565, 'Todd Colonia Number 3', 26.0869998931885, 0.455304040103548, -97.963996887207, -1.70979429409524, 218, 51, 'PPL', 'P'),
(187443, 'Todd Creek', 39.9780616760254, 0.697748804812006, -104.872779846191, -1.83037530403519, 218, 7, 'PPL', 'P'),
(14752, 'Todd Estates', 39.6708297729492, 0.692386596536158, -75.7125015258789, -1.32143243654782, 218, 10, 'PPL', 'P'),
(52123, 'Todd Estates', 39.5938911437988, 0.691043764135513, -76.2733306884766, -1.33122075197635, 218, 25, 'PPL', 'P'),
(52124, 'Todd Lakes', 39.5163917541504, 0.689691144617862, -76.2911071777344, -1.33153101024334, 218, 25, 'PPL', 'P'),
(98567, 'Todd Mission', 30.2613906860352, 0.528160903703659, -95.8300018310547, -1.6725490541441, 218, 51, 'PPL', 'P'),
(185672, 'Todd Place', 35.274169921875, 0.61565040604467, -120.162498474121, -2.09723123579608, 218, 6, 'PPL', 'P'),
(91371, 'Todd Town', 35.8869400024414, 0.626345261508264, -85.2227783203125, -1.4874180793867, 218, 50, 'PPL', 'P'),
(185673, 'Todd Valley', 38.9980583190918, 0.680644519552917, -120.850563049316, -2.10924022809957, 218, 6, 'PPL', 'P'),
(52125, 'Todd Village Trailer Park', 39.5063896179199, 0.689516574408407, -76.9013900756836, -1.34218245618117, 218, 25, 'PPL', 'P'),
(74557, 'Todds', 39.5247192382813, 0.689836486634353, -81.8469390869141, -1.42849856974589, 218, 41, 'PPL', 'P'),
(98568, 'Todds Colonia Number 1', 26.0890007019043, 0.455338960803342, -97.963996887207, -1.70979429409524, 218, 51, 'PPL', 'P'),
(98569, 'Todds Colonia Number 2', 26.0879993438721, 0.455321483808688, -97.963996887207, -1.70979429409524, 218, 51, 'PPL', 'P'),
(129080, 'Todds Corner', 44.9866714477539, 0.78516553627623, -69.4255599975586, -1.21170460699826, 218, 26, 'PPL', 'P'),
(129081, 'Todds Corners', 43.8300018310547, 0.764977843107048, -70.1374969482422, -1.2241302508543, 218, 26, 'PPL', 'P'),
(69432, 'Todds Crossroads', 36.086109161377, 0.629821419100118, -76.8772201538086, -1.3417606114645, 218, 33, 'PPL', 'P'),
(28790, 'Todds Mill', 38.2024993896484, 0.666759396840489, -89.3658294677734, -1.55972796298842, 218, 18, 'PPL', 'P'),
(28791, 'Todds Point', 39.5769386291504, 0.690747886938405, -88.7658309936523, -1.54925601410806, 218, 18, 'PPL', 'P'),
(38552, 'Todds Point', 38.2841682434082, 0.668184787234927, -85.345832824707, -1.48956578564779, 218, 21, 'PPL', 'P'),
(106948, 'Todds Tavern', 38.2480583190918, 0.66755455016296, -77.6688919067383, -1.35557789014816, 218, 53, 'PPL', 'P'),
(153147, 'Toddsville', 42.6877784729004, 0.745042284714069, -74.958610534668, -1.30827455655006, 218, 40, 'PPL', 'P'),
(6355, 'Toddtown', 31.6186103820801, 0.55184885607256, -87.8766708374023, -1.53373724180395, 218, 2, 'PPL', 'P'),
(38553, 'Toddville', 37.7324981689453, 0.658556328050827, -84.6361083984375, -1.47717875762756, 218, 21, 'PPL', 'P'),
(52126, 'Toddville', 38.2997207641602, 0.668456229929033, -76.0708312988281, -1.32768647089371, 218, 25, 'PPL', 'P'),
(69433, 'Toddville', 35.2738914489746, 0.61564554577568, -80.913330078125, -1.41220401861624, 218, 33, 'PPL', 'P'),
(84055, 'Toddville', 33.7586097717285, 0.589198891412594, -79.0763931274414, -1.38014342067527, 218, 48, 'PPL', 'P'),
(118058, 'Toddville', 42.0991706848145, 0.734769140809088, -91.716667175293, -1.60075782116467, 218, 16, 'PPL', 'P'),
(153148, 'Toddville', 41.2936096191406, 0.720709447887206, -73.8888931274414, -1.28960446572806, 218, 40, 'PPL', 'P'),
(98570, 'Todville', 29.5663890838623, 0.516030837439107, -95.0133285522461, -1.65829541651583, 218, 51, 'PPL', 'P'),
(69435, 'Toecane', 36.0088882446289, 0.628473659851456, -82.1922225952148, -1.43452490381858, 218, 33, 'PPL', 'P'),
(118054, 'Toeterville', 43.4422187805176, 0.758209752091748, -92.8902816772461, -1.62124125837291, 218, 16, 'PPL', 'P'),
(138451, 'Tofte', 47.5738906860352, 0.830321030455177, -90.8361129760742, -1.58538925114604, 218, 28, 'PPL', 'P'),
(212189, 'Tofty', 65.0933303833008, 1.13609293627706, -150.877212524414, -2.63330412478225, 218, 1, 'PPL', 'P'),
(57918, 'Toga', 37.1161117553711, 0.647798355669398, -89.8847198486328, -1.56878430859134, 218, 29, 'PPL', 'P'),
(106949, 'Toga', 37.4938888549805, 0.654391809896216, -78.6336135864258, -1.37241545982408, 218, 53, 'PPL', 'P'),
(153149, 'Toggletown', 42.9186096191406, 0.749071048232113, -77.8130569458008, -1.35809404474607, 218, 40, 'PPL', 'P'),
(212190, 'Togiak', 59.061939239502, 1.03082530234214, -160.376388549805, -2.79909602265183, 218, 1, 'PPL', 'P'),
(12336, 'Togo', 35.3408317565918, 0.616813874545898, -90.5486068725586, -1.58037132302011, 218, 4, 'PPL', 'P'),
(34137, 'Togo', 39.1833305358887, 0.683878129748491, -99.8658294677734, -1.74298753444782, 218, 20, 'PPL', 'P'),
(62046, 'Togo', 33.2847213745117, 0.580927978594162, -88.3847198486328, -1.54260436981143, 218, 30, 'PPL', 'P'),
(77459, 'Togo', 36.4197196960449, 0.635644021349412, -98.7644424438477, -1.72376470454158, 218, 42, 'PPL', 'P'),
(98571, 'Togo', 29.9502792358398, 0.522730984557097, -97.2188873291016, -1.69678967901822, 218, 51, 'PPL', 'P'),
(138453, 'Togo', 47.8213882446289, 0.834640677743286, -93.1558303833008, -1.62587595761797, 218, 28, 'PPL', 'P'),
(118055, 'Togo (historical)', 40.6205596923828, 0.708962510634975, -93.8852767944336, -1.63860719920909, 218, 16, 'PPL', 'P'),
(129082, 'Togus', 44.2744407653809, 0.772734765835094, -69.70361328125, -1.21655755229466, 218, 26, 'PPL', 'P'),
(189682, 'Tohatchi', 35.8588905334473, 0.625855705920881, -108.760833740234, -1.89823464598123, 218, 38, 'PPL', 'P'),
(13232, 'Tohoga (historical)', 38.9027786254883, 0.678981575189245, -77.0625, -1.34499435481813, 218, 9, 'PPL', 'P'),
(6357, 'Tohopeka', 32.9555587768555, 0.575183007490643, -85.7605590820313, -1.49680412433257, 218, 2, 'PPL', 'P'),
(18353, 'Tohopikaliga (historical)', 28.2833309173584, 0.493637247939012, -81.2666702270508, -1.41837096759448, 218, 12, 'PPL', 'P'),
(114170, 'Toilsome Hill', 41.2019386291504, 0.719109487283313, -73.2230606079102, -1.27798349599539, 218, 8, 'PPL', 'P'),
(138454, 'Toimi', 47.4005584716797, 0.827295812614902, -91.7675018310547, -1.60164505328183, 218, 28, 'PPL', 'P'),
(6356, 'Toinette', 31.3394393920898, 0.546976403121178, -88.0083312988281, -1.53603515035053, 218, 2, 'PPL', 'P'),
(133413, 'Toivola', 46.9991683959961, 0.820290234209394, -88.7699966430664, -1.54932871840582, 218, 27, 'PPL', 'P'),
(138456, 'Toivola', 47.1669387817383, 0.823218379827936, -92.8108291625977, -1.6198545503933, 218, 28, 'PPL', 'P'),
(212191, 'Tok', 63.336669921875, 1.10543342738558, -142.985565185547, -2.49556889531277, 218, 1, 'PPL', 'P'),
(12337, 'Tokalon', 35.3763885498047, 0.617434457658914, -93.4711074829102, -1.63137858106229, 218, 4, 'PPL', 'P'),
(185675, 'Tokay', 36.5519409179688, 0.637951717012993, -119.358062744141, -2.08319118368723, 218, 6, 'PPL', 'P'),
(189683, 'Tokay', 33.8736114501953, 0.591206049347159, -106.738609313965, -1.86294017152857, 218, 38, 'PPL', 'P'),
(193320, 'Tokeen', 55.9944381713867, 0.977287308895091, -133.463882446289, -2.32938418118241, 218, 1, 'PPL', 'P'),
(84054, 'Tokeena Point', 34.6069412231445, 0.604005068388026, -82.9077835083008, -1.4470137977505, 218, 48, 'PPL', 'P'),
(208952, 'Tokeland', 46.7066688537598, 0.815185154136794, -123.980560302734, -2.16386898575009, 218, 56, 'PPL', 'P'),
(176695, 'Token Creek', 43.1944389343262, 0.753885177955622, -89.2936096191406, -1.55846748884448, 218, 57, 'PPL', 'P'),
(114171, 'Tokeneke', 41.0666694641113, 0.716748594976958, -73.466667175293, -1.2822352326757, 218, 8, 'PPL', 'P'),
(201666, 'Toketee Falls', 43.2758293151855, 0.755305708081071, -122.449722290039, -2.13715082211387, 218, 43, 'PPL', 'P'),
(12338, 'Tokio', 34.0033302307129, 0.593470069168863, -93.7508316040039, -1.63626068797262, 218, 4, 'PPL', 'P'),
(62047, 'Tokio', 31.7447204589844, 0.554049892134483, -88.5480575561523, -1.5454551506003, 218, 30, 'PPL', 'P'),
(140967, 'Tokio', 47.9247207641602, 0.836444170433488, -98.8158264160156, -1.72466152403866, 218, 34, 'PPL', 'P'),
(192329, 'Tokio', 33.1813888549805, 0.57912448590396, -102.274719238281, -1.78503059226079, 218, 51, 'PPL', 'P'),
(208953, 'Tokio', 47.2097206115723, 0.823965063618567, -118.268608093262, -2.06417661297823, 218, 56, 'PPL', 'P'),
(212192, 'Toklat', 64.4711074829102, 1.12523309798394, -150.325836181641, -2.62368079218325, 218, 1, 'PPL', 'P'),
(190834, 'Tokop', 37.3016700744629, 0.651036959292016, -117.260276794434, -2.04657791186277, 218, 39, 'PPL', 'P'),
(212193, 'Toksook Bay', 60.5302810668945, 1.0564527017749, -165.102493286133, -2.88158211109485, 218, 1, 'PPL', 'P'),
(208954, 'Tokul', 47.5622215270996, 0.830117365210814, -121.823059082031, -2.12621348583303, 218, 56, 'PPL', 'P'),
(167991, 'Toland', 40.0697212219238, 0.699348565678816, -77.2122192382813, -1.34760744847972, 218, 45, 'PPL', 'P'),
(192330, 'Toland', 32.4494400024414, 0.566349568470959, -100.149719238281, -1.74794234565592, 218, 51, 'PPL', 'P'),
(185676, 'Toland Landing', 38.0883293151855, 0.664766753133865, -121.750282287598, -2.12494329115111, 218, 6, 'PPL', 'P'),
(179356, 'Tolani Lake', 35.4347190856934, 0.618452517564624, -110.843887329102, -1.93459078960245, 218, 5, 'PPL', 'P'),
(98573, 'Tolar', 32.3888893127441, 0.565292759571389, -97.920280456543, -1.70903129844293, 218, 51, 'PPL', 'P'),
(189684, 'Tolar', 34.4508285522461, 0.601280388276766, -103.931106567383, -1.81394000484193, 218, 38, 'PPL', 'P'),
(69438, 'Tolar Landing', 34.8355598449707, 0.607995216070264, -78.8227767944336, -1.37571698062745, 218, 33, 'PPL', 'P'),
(69439, 'Tolarsville', 34.7611083984375, 0.606695793195387, -78.8724975585938, -1.37658477166865, 218, 33, 'PPL', 'P'),
(62049, 'Tolarville', 33.0472183227539, 0.576782768357454, -90.2186126708984, -1.57461183768865, 218, 30, 'PPL', 'P'),
(98574, 'Tolbert', 34.2191696166992, 0.597237177109807, -99.396110534668, -1.73478939250618, 218, 51, 'PPL', 'P'),
(111723, 'Tolbert', 38.1966705322266, 0.666657664086848, -80.6911087036133, -1.40832552396271, 218, 58, 'PPL', 'P'),
(91372, 'Tolbertsville (historical)', 35.7069396972656, 0.623203663528352, -86.1761093139648, -1.50405684408724, 218, 50, 'PPL', 'P'),
(52127, 'Tolchester', 39.2227783203125, 0.684566623469304, -76.2388916015625, -1.33061967651832, 218, 25, 'PPL', 'P'),
(52128, 'Tolchester Beach', 39.214168548584, 0.684416354604796, -76.245002746582, -1.33072633611998, 218, 25, 'PPL', 'P'),
(52129, 'Tolchester Estates', 39.2291717529297, 0.684678209918979, -76.2322235107422, -1.33050329637868, 218, 25, 'PPL', 'P'),
(52130, 'Tolchester Heights', 39.2166709899902, 0.684460030446674, -76.2375030517578, -1.3305954417524, 218, 25, 'PPL', 'P'),
(179357, 'Tolchico', 35.3933296203613, 0.61773013511894, -111.107223510742, -1.9391868730117, 218, 5, 'PPL', 'P'),
(12339, 'Toledo', 33.9263916015625, 0.592127236768218, -92.1611099243164, -1.60851481047174, 218, 4, 'PPL', 'P'),
(25520, 'Toledo', 30.6358299255371, 0.534696101281632, -82.0527801513672, -1.43209117405641, 218, 13, 'PPL', 'P'),
(28793, 'Toledo', 39.273609161377, 0.685453789007437, -88.2436065673828, -1.54014147843532, 218, 18, 'PPL', 'P'),
(34138, 'Toledo', 38.4222183227539, 0.670594215652149, -96.3708267211914, -1.68198822915372, 218, 20, 'PPL', 'P'),
(57920, 'Toledo', 36.7744407653809, 0.64183507193552, -92.6852798461914, -1.61766330144838, 218, 29, 'PPL', 'P'),
(69440, 'Toledo', 35.9869384765625, 0.628090564128648, -82.2697219848633, -1.43587752333623, 218, 33, 'PPL', 'P'),
(98575, 'Toledo', 31.1741695404053, 0.544091900055, -93.5611114501953, -1.63294944663127, 218, 51, 'PPL', 'P'),
(118056, 'Toledo', 41.9955596923828, 0.732960787849897, -92.5766677856445, -1.61576766338447, 218, 16, 'PPL', 'P'),
(157958, 'Toledo', 41.663890838623, 0.727172074325474, -83.5552825927734, -1.4583147886782, 218, 41, 'PPL', 'P'),
(201667, 'Toledo', 44.6216697692871, 0.778795055211679, -123.937217712402, -2.16311251484246, 218, 43, 'PPL', 'P'),
(208955, 'Toledo', 46.439998626709, 0.810530880657717, -122.845558166504, -2.1440594614557, 218, 56, 'PPL', 'P'),
(157959, 'Toledo Junction', 40.8127784729004, 0.712317361239175, -82.6161117553711, -1.44192316532682, 218, 41, 'PPL', 'P'),
(157961, 'Toledoville (historical)', 40.1622200012207, 0.700962973931622, -81.6466674804688, -1.42500317081516, 218, 41, 'PPL', 'P'),
(185678, 'Tolenas', 38.2652816772461, 0.667855154471003, -122.004440307617, -2.1293791854208, 218, 6, 'PPL', 'P'),
(38555, 'Toler', 37.6372184753418, 0.656893383687155, -82.2525024414063, -1.43557698560721, 218, 21, 'PPL', 'P'),
(34140, 'Tolerville', 37.7527809143066, 0.658910328738726, -97.2688903808594, -1.69766239690744, 218, 20, 'PPL', 'P'),
(14753, 'Tolham Estates', 39.6133308410645, 0.691383050858389, -75.6647186279297, -1.32059846765246, 218, 10, 'PPL', 'P'),
(190837, 'Tolicha (historical)', 37.2900009155273, 0.650833294047652, -116.788887023926, -2.03835060830719, 218, 39, 'PPL', 'P'),
(38554, 'Toliver', 37.8136100769043, 0.659971997907286, -83.4577789306641, -1.45661302874164, 218, 21, 'PPL', 'P'),
(69441, 'Toliver', 36.3683280944824, 0.634747068694274, -81.6002807617188, -1.42419356984378, 218, 33, 'PPL', 'P'),
(153150, 'Toll Corner', 42.480281829834, 0.741420785105725, -75.279167175293, -1.3138693253681, 218, 40, 'PPL', 'P'),
(111724, 'Toll Gate', 39.2724990844727, 0.685434414510507, -80.915283203125, -1.41223810707819, 218, 58, 'PPL', 'P'),
(153154, 'Toll Gate Corner', 42.0258293151855, 0.733489092431142, -78.3388900756836, -1.36727156417859, 218, 40, 'PPL', 'P'),
(153151, 'Toll Gate Corners', 42.6955604553223, 0.745178105929663, -76.4205627441406, -1.33379043611217, 218, 40, 'PPL', 'P'),
(123814, 'Toll Gate Heights', 40.7572212219238, 0.711347704286277, -85.1658325195313, -1.48642418766788, 218, 19, 'PPL', 'P'),
(52131, 'Toll House', 39.267219543457, 0.68534226913679, -76.8152770996094, -1.34067950121998, 218, 25, 'PPL', 'P'),
(114172, 'Tolland', 41.8713912963867, 0.730793640512845, -72.3691711425781, -1.26308031337726, 218, 8, 'PPL', 'P'),
(187444, 'Tolland', 39.9049987792969, 0.696473616703049, -105.588607788086, -1.84286885849903, 218, 7, 'PPL', 'P'),
(126350, 'Tolland Center', 42.0811080932617, 0.73445388911505, -73.0124969482422, -1.27430846684914, 218, 23, 'PPL', 'P'),
(98576, 'Tolle Colonia', 26.2199993133545, 0.457625317888688, -98.3460006713867, -1.71646151788425, 218, 51, 'PPL', 'P'),
(98577, 'Tolle Colonia Number 2', 26.2290000915527, 0.457782411103489, -98.3460006713867, -1.71646151788425, 218, 51, 'PPL', 'P'),
(114175, 'Tolles', 41.6441688537598, 0.726827860754581, -73.0100021362305, -1.27426492416532, 218, 8, 'PPL', 'P'),
(38556, 'Tollesboro', 38.559440612793, 0.672989196420457, -83.5761108398438, -1.458678310167, 218, 21, 'PPL', 'P'),
(179358, 'Tolleson', 33.4500007629395, 0.583812648107909, -112.258613586426, -1.95928242080717, 218, 5, 'PPL', 'P'),
(12340, 'Tollette', 33.8197212219238, 0.590265487429171, -93.894172668457, -1.63876246150065, 218, 4, 'PPL', 'P'),
(199003, 'Tolley', 48.728889465332, 0.850479562010423, -101.826942443848, -1.7772154128839, 218, 34, 'PPL', 'P'),
(52132, 'Tolley Terrace', 39.3630599975586, 0.687015000617469, -77.2416687011719, -1.3481214385701, 218, 25, 'PPL', 'P'),
(91373, 'Tolley Town', 36.190559387207, 0.631644419445304, -82.2180633544922, -1.43497591014918, 218, 50, 'PPL', 'P'),
(111725, 'Tolleys', 37.7558288574219, 0.6589635253815, -81.3116683959961, -1.41915633379995, 218, 58, 'PPL', 'P'),
(52133, 'Tollgate', 39.4199981689453, 0.688008759178232, -76.7944412231445, -1.34031584657313, 218, 25, 'PPL', 'P'),
(201668, 'Tollgate', 45.7805595397949, 0.799021497374721, -118.091667175293, -2.06108841137817, 218, 43, 'PPL', 'P'),
(52134, 'Tollgate Estates', 39.5175018310547, 0.689710519114792, -76.3491668701172, -1.33254434303812, 218, 25, 'PPL', 'P'),
(185679, 'Tollhouse', 37.0188903808594, 0.646101522580854, -119.398330688477, -2.0838939918989, 218, 6, 'PPL', 'P'),
(62050, 'Tollison', 33.2533302307129, 0.580380099778906, -89.1913909912109, -1.55668343723024, 218, 30, 'PPL', 'P'),
(25521, 'Tolliver Heights', 33.6666717529297, 0.587594270276794, -84.2822189331055, -1.47100222126939, 218, 13, 'PPL', 'P'),
(38557, 'Tolliver Town', 37.1802787780762, 0.648918281486803, -82.7091674804688, -1.4435472941176, 218, 21, 'PPL', 'P'),
(12345, 'Tollville', 34.7197189331055, 0.605973410749703, -91.5352783203125, -1.59759198841884, 218, 4, 'PPL', 'P'),
(172649, 'Tolman Corner', 44.5675010681152, 0.7778496330247, -72.3072204589844, -1.26199906997468, 218, 55, 'PPL', 'P'),
(79269, 'Tolna', 39.7619400024414, 0.693976770023045, -76.6519393920898, -1.33782872043111, 218, 45, 'PPL', 'P'),
(140969, 'Tolna', 47.827220916748, 0.834742477075954, -98.4397201538086, -1.71809723142578, 218, 34, 'PPL', 'P'),
(201669, 'Tolo', 42.4244384765625, 0.740446134725783, -122.970283508301, -2.14623632933073, 218, 43, 'PPL', 'P'),
(208956, 'Tolo', 47.6549987792969, 0.831736633732609, -122.583892822266, -2.13949253966038, 218, 56, 'PPL', 'P'),
(18354, 'Tolomato (historical)', 30.2333297729492, 0.527671148379193, -81.466667175293, -1.42186157283525, 218, 12, 'PPL', 'P'),
(139483, 'Tolona', 40.0430603027344, 0.698883244857352, -91.7483291625977, -1.60131042709086, 218, 29, 'PPL', 'P'),
(28794, 'Tolono', 39.9861106872559, 0.697889286559507, -88.2588882446289, -1.54040819401849, 218, 18, 'PPL', 'P'),
(98579, 'Tolosa', 32.3705596923828, 0.564972847345443, -96.2402801513672, -1.6797097616831, 218, 51, 'PPL', 'P'),
(201670, 'Tolovana Park', 45.8722190856934, 0.800621258241532, -123.958610534668, -2.16348589002728, 218, 43, 'PPL', 'P'),
(52135, 'Tolson', 38.1377792358398, 0.665629817064132, -76.5274963378906, -1.33565677940409, 218, 25, 'PPL', 'P'),
(212194, 'Tolsona', 62.0838890075684, 1.08356827562478, -146.070281982422, -2.54940735990981, 218, 1, 'PPL', 'P'),
(171426, 'Tolstoy', 45.2080612182617, 0.789029516701826, -99.6138916015625, -1.73859038917199, 218, 49, 'PPL', 'P'),
(12342, 'Toltec', 34.6511116027832, 0.604775986944576, -92.0558319091797, -1.60667736247764, 218, 4, 'PPL', 'P'),
(179359, 'Toltec', 32.7922210693359, 0.572332226701768, -111.614166259766, -1.94803469310127, 218, 5, 'PPL', 'P'),
(189685, 'Toltec', 36.982780456543, 0.645471285508886, -106.271667480469, -1.85479049911877, 218, 38, 'PPL', 'P'),
(209790, 'Toltec', 42.3069381713867, 0.738395367528367, -105.652778625488, -1.84398885089546, 218, 59, 'PPL', 'P'),
(12343, 'Tolu', 35.8144416809082, 0.625079927095341, -94.495002746582, -1.64924892460894, 218, 4, 'PPL', 'P'),
(38558, 'Tolu', 37.4330596923828, 0.653330140727656, -88.2452774047852, -1.54017064004926, 218, 21, 'PPL', 'P'),
(12344, 'Toluca', 35.7994384765625, 0.624818071781158, -89.9274978637695, -1.56953092580295, 218, 4, 'PPL', 'P'),
(69442, 'Toluca', 35.5291709899902, 0.620101014279383, -81.5111083984375, -1.42263721850274, 218, 33, 'PPL', 'P'),
(98578, 'Toluca', 26.0705604553223, 0.455017117785606, -97.9438934326172, -1.70944342262162, 218, 51, 'PPL', 'P'),
(121720, 'Toluca', 41.0022201538086, 0.715623742311536, -89.1333312988281, -1.55567010443546, 218, 18, 'PPL', 'P'),
(197699, 'Toluca', 45.7472190856934, 0.798439596676539, -107.871391296387, -1.8827109468291, 218, 31, 'PPL', 'P'),
(25522, 'Tom', 32.7094383239746, 0.570887395231373, -82.4880599975586, -1.43968824054002, 218, 13, 'PPL', 'P'),
(77461, 'Tom', 33.7358283996582, 0.588801281461845, -94.5727767944336, -1.65060633781655, 218, 42, 'PPL', 'P'),
(98580, 'Tom Bean', 33.5200004577637, 0.585034373257983, -96.4836120605469, -1.68395670467345, 218, 51, 'PPL', 'P'),
(74555, 'Tom Corwin', 39.0988883972168, 0.682404336401242, -82.5783309936523, -1.44126376664091, 218, 41, 'PPL', 'P'),
(38559, 'Tom Gray Ford', 37.3063888549805, 0.651119317548727, -87.8294372558594, -1.53291286028852, 218, 21, 'PPL', 'P'),
(57921, 'Tom Hollow Ford (historical)', 37.8461112976074, 0.660539251219473, -92.8513870239258, -1.62056241861104, 218, 29, 'PPL', 'P'),
(38560, 'Tom Johns Crossing', 37.2497215270996, 0.650130286098898, -86.0244369506836, -1.5014096619637, 218, 21, 'PPL', 'P'),
(91374, 'Tom Town', 35.8452796936035, 0.625618151951646, -83.0166702270508, -1.44891422950438, 218, 50, 'PPL', 'P'),
(129083, 'Tomah', 45.5463905334473, 0.794934477207831, -67.6502838134766, -1.18072019245379, 218, 26, 'PPL', 'P'),
(176696, 'Tomah', 43.9786109924316, 0.767571562271703, -90.5038909912109, -1.57959088366267, 218, 57, 'PPL', 'P'),
(187445, 'Tomah', 39.3019409179688, 0.685948271442837, -104.889442443848, -1.83066612122623, 218, 7, 'PPL', 'P'),
(12346, 'Tomahawk', 36.0605583190918, 0.629375472775584, -92.7063903808594, -1.6180317497852, 218, 4, 'PPL', 'P'),
(25523, 'Tomahawk', 34.1152801513672, 0.595423963881627, -84.4136123657227, -1.47329546928406, 218, 13, 'PPL', 'P'),
(38562, 'Tomahawk', 37.8686103820801, 0.660931934322205, -82.5972213745117, -1.44159346598387, 218, 21, 'PPL', 'P'),
(69444, 'Tomahawk', 34.711109161377, 0.605823141885196, -78.3277816772461, -1.36707768605123, 218, 33, 'PPL', 'P'),
(111726, 'Tomahawk', 39.5302810668945, 0.689933558856086, -78.0472183227539, -1.3621809317549, 218, 58, 'PPL', 'P'),
(176699, 'Tomahawk', 45.4711112976074, 0.793620606684041, -89.7297210693359, -1.56607906955604, 218, 57, 'PPL', 'P'),
(202690, 'Tomahawk', 44.2119407653809, 0.771643935052598, -103.528060913086, -1.8069055311386, 218, 49, 'PPL', 'P'),
(121721, 'Tomahawk Bluff', 41.3805618286133, 0.722227050234387, -89.0833282470703, -1.55479738654625, 218, 18, 'PPL', 'P'),
(185680, 'Tomales', 38.2463912963867, 0.667525455128051, -122.904441833496, -2.14508717532036, 218, 6, 'PPL', 'P'),
(153152, 'Tomantown', 43.2005615234375, 0.753992037294362, -74.2955627441406, -1.29670218950729, 218, 40, 'PPL', 'P'),
(189686, 'Tomasino Mill', 34.252498626709, 0.597818878070908, -106.672782897949, -1.86179128383431, 218, 38, 'PPL', 'P'),
(12351, 'Tomato', 35.8436088562012, 0.625588990337709, -89.7411117553711, -1.56627787453141, 218, 4, 'PPL', 'P'),
(167992, 'Tomb', 41.2483291625977, 0.719919154833725, -77.3274993896484, -1.34961946668327, 218, 45, 'PPL', 'P'),
(98581, 'Tomball', 30.0969390869141, 0.525290681838826, -95.6158294677734, -1.66881104123806, 218, 51, 'PPL', 'P'),
(12348, 'Tomberlin', 34.5158309936523, 0.602414894901139, -91.8713912963867, -1.60345826651001, 218, 4, 'PPL', 'P'),
(6358, 'Tombigbee (historical)', 32.4080581665039, 0.56562731918333, -87.6666717529297, -1.53007206635373, 218, 2, 'PPL', 'P'),
(187446, 'Tomboy (historical)', 37.9366683959961, 0.662119770747408, -107.753890991211, -1.88066017963169, 218, 7, 'PPL', 'P'),
(167993, 'Tombs Run', 41.252498626709, 0.719991925710511, -77.3258285522461, -1.34959030506933, 218, 45, 'PPL', 'P'),
(179360, 'Tombstone', 31.7127799987793, 0.553492425939302, -110.066940307617, -1.92103050596398, 218, 5, 'PPL', 'P'),
(189687, 'Tome', 34.7408294677734, 0.606341859086516, -106.727783203125, -1.86275122024923, 218, 38, 'PPL', 'P'),
(153153, 'Tomhannock', 42.8688888549805, 0.748203257190911, -73.5441665649414, -1.28358785219336, 218, 40, 'PPL', 'P'),
(167994, 'Tomhicken', 40.9694404602051, 0.71505162873036, -76.095832824707, -1.32812282983831, 218, 45, 'PPL', 'P'),
(153155, 'Tomkins Cove', 41.2569389343262, 0.720069423698232, -73.98388671875, -1.29126241666469, 218, 40, 'PPL', 'P'),
(71478, 'Tomlin', 39.7780609130859, 0.694258132992212, -75.2727813720703, -1.31375787207648, 218, 37, 'PPL', 'P'),
(121722, 'Tomlinson', 40.3188896179199, 0.703697374580861, -88.2330627441406, -1.539957454004, 218, 18, 'PPL', 'P'),
(153156, 'Tomlinson Corners', 42.9647216796875, 0.749875855513535, -77.5027770996094, -1.35267863982744, 218, 40, 'PPL', 'P'),
(98582, 'Tomlinson Hill', 31.2655601501465, 0.545686967100389, -96.9877777099609, -1.69275605523118, 218, 51, 'PPL', 'P'),
(71477, 'Tomlinson Mill', 39.8672218322754, 0.695814284596172, -74.8949966430664, -1.30716428469161, 218, 37, 'PPL', 'P'),
(74556, 'Tomlison Addition', 38.8858299255371, 0.678685764571164, -82.9738922119141, -1.44816761229278, 218, 41, 'PPL', 'P'),
(91375, 'Tommotley (historical)', 35.5702781677246, 0.62081846987705, -84.1861114501953, -1.46932482925681, 218, 50, 'PPL', 'P'),
(98583, 'Tommy Knocker Colonia', 26.2310009002686, 0.457817331803283, -98.3580017089844, -1.71667097550399, 218, 51, 'PPL', 'P'),
(18355, 'Tommytown', 28.3758296966553, 0.495251656191818, -82.2038879394531, -1.43472850248391, 218, 12, 'PPL', 'P'),
(62051, 'Tomnolen', 33.4847183227539, 0.584418583834929, -89.3605575561523, -1.55963595077276, 218, 30, 'PPL', 'P'),
(18356, 'Tomoka Estates', 29.3147201538086, 0.511638385984698, -81.0991668701172, -1.41544748250785, 218, 12, 'PPL', 'P'),
(69445, 'Tomotla', 35.1347198486328, 0.613216543124446, -83.9844436645508, -1.4658050624021, 218, 33, 'PPL', 'P'),
(84056, 'Tomotley', 32.6316719055176, 0.569530115181814, -80.8152770996094, -1.41049267129976, 218, 48, 'PPL', 'P'),
(25524, 'Tompkins', 30.9113903045654, 0.53950553718372, -81.7927780151367, -1.42755328071697, 218, 13, 'PPL', 'P'),
(84057, 'Tompkins', 33.9272193908691, 0.592141684417132, -79.2427825927734, -1.38304746468595, 218, 48, 'PPL', 'P'),
(133414, 'Tompkins', 42.3730583190918, 0.739549381807726, -84.5416717529297, -1.47553052722891, 218, 27, 'PPL', 'P'),
(167995, 'Tompkins', 41.9766693115234, 0.732631088506945, -77.1911087036133, -1.3472390001429, 218, 45, 'PPL', 'P'),
(208958, 'Tompkins', 46.4605598449707, 0.810889741614605, -118.36888885498, -2.06592684244663, 218, 56, 'PPL', 'P'),
(153159, 'Tompkins Corners', 41.1911087036133, 0.718920469424945, -73.7830581665039, -1.28775729719598, 218, 40, 'PPL', 'P'),
(84058, 'Tompkins Cross Roads', 33.9211082458496, 0.592035024815474, -81.9316711425781, -1.42997742309921, 218, 48, 'PPL', 'P'),
(6359, 'Tompkinsville', 32.2030601501465, 0.562049428837836, -88.0202789306641, -1.53624367586388, 218, 2, 'PPL', 'P'),
(38561, 'Tompkinsville', 36.702220916748, 0.640574597791585, -85.6916732788086, -1.49560184025845, 218, 21, 'PPL', 'P'),
(52138, 'Tompkinsville', 38.3216705322266, 0.668839325651841, -76.8927764892578, -1.34203212073764, 218, 25, 'PPL', 'P'),
(153162, 'Tompkinsville', 40.6363906860352, 0.709238813598071, -74.0858306884766, -1.29304167458897, 218, 40, 'PPL', 'P'),
(167996, 'Tompkinsville', 41.5897216796875, 0.725877578298613, -75.6144409179688, -1.31972095607328, 218, 45, 'PPL', 'P'),
(106950, 'Toms Brook', 38.9463882446289, 0.679742706628789, -78.4394378662109, -1.3690264541789, 218, 53, 'PPL', 'P'),
(25526, 'Toms Creek', 34.4797210693359, 0.601784657829172, -83.2438888549805, -1.45287994268362, 218, 13, 'PPL', 'P'),
(69446, 'Toms Creek', 35.7402801513672, 0.623785564226535, -82.0500030517578, -1.43204270452457, 218, 33, 'PPL', 'P'),
(106951, 'Toms Creek', 36.9666709899902, 0.645190122276801, -82.454719543457, -1.43910633984184, 218, 53, 'PPL', 'P'),
(91376, 'Toms Creek (historical)', 35.7533302307129, 0.624013331078764, -87.9888916015625, -1.53569586362765, 218, 50, 'PPL', 'P'),
(153163, 'Toms Landing', 43.3408317565918, 0.756440214705444, -78.2238922119141, -1.36526447282305, 218, 40, 'PPL', 'P'),
(185683, 'Toms Place', 37.5613899230957, 0.65556992578344, -118.680282592773, -2.07136168844121, 218, 6, 'PPL', 'P'),
(28795, 'Toms Prairie', 38.4077796936035, 0.670342214034, -88.2586135864258, -1.54040340032853, 218, 18, 'PPL', 'P'),
(71479, 'Toms River', 39.9536094665527, 0.69732203324732, -74.1983337402344, -1.29500522326069, 218, 37, 'PPL', 'P'),
(185684, 'Tomspur', 38.0572204589844, 0.664223801166625, -121.275833129883, -2.11666259121567, 218, 6, 'PPL', 'P'),
(79274, 'Tomstown', 39.792781829834, 0.694515061458377, -77.5619430541992, -1.35371128054012, 218, 45, 'PPL', 'P'),
(179361, 'Tonalea', 36.3224983215332, 0.633947188260868, -110.962783813477, -1.93666592472384, 218, 5, 'PPL', 'P'),
(208957, 'Tonasket', 48.7052803039551, 0.850067504410761, -119.438331604004, -2.08459213957867, 218, 56, 'PPL', 'P'),
(153164, 'Tonawanda', 43.0202789306641, 0.750845512466433, -78.8805618286133, -1.37672551973226, 218, 40, 'PPL', 'P'),
(157963, 'Tondagamies Village (historical)', 41.4661102294922, 0.72372015149954, -83.7666702270508, -1.46200419889434, 218, 41, 'PPL', 'P'),
(185685, 'Toners Place', 38.5308303833008, 0.672489853716067, -123.176940917969, -2.14984318155308, 218, 6, 'PPL', 'P'),
(176702, 'Tonet', 44.589168548584, 0.778227801899492, -87.7336120605469, -1.53124039512395, 218, 57, 'PPL', 'P'),
(6360, 'Toney', 34.8980598449707, 0.609086046852761, -86.7336120605469, -1.51378710260401, 218, 2, 'PPL', 'P'),
(12360, 'Toney', 35.5180587768555, 0.619907069572998, -93.9625015258789, -1.63995502503678, 218, 4, 'PPL', 'P'),
(111727, 'Toney', 38.0108299255371, 0.663414133616214, -82.0730590820313, -1.43244510816528, 218, 58, 'PPL', 'P'),
(84059, 'Toney Creek', 34.5541687011719, 0.603084014125022, -82.4225006103516, -1.43854401337767, 218, 48, 'PPL', 'P'),
(111728, 'Toney Fork', 37.7127799987793, 0.658212181058962, -81.5977783203125, -1.4241498940019, 218, 58, 'PPL', 'P'),
(144566, 'Toneys Mobile Park', 44.3011093139648, 0.773200219814613, -71.7513885498047, -1.25229797307185, 218, 36, 'PPL', 'P'),
(12352, 'Toneyville', 34.8994407653809, 0.609110148460626, -92.101936340332, -1.60748203660101, 218, 4, 'PPL', 'P'),
(34141, 'Tonganoxie', 39.1097183227539, 0.68259335425961, -95.0875015258789, -1.65958997912172, 218, 20, 'PPL', 'P'),
(12353, 'Tongin', 34.8561096191406, 0.608353877290071, -90.6080627441406, -1.58140902373886, 218, 4, 'PPL', 'P'),
(201671, 'Tongue Point Village', 46.1969413757324, 0.80628873135733, -123.770561218262, -2.16020381029987, 218, 43, 'PPL', 'P'),
(121724, 'Tonica', 41.2158317565918, 0.719351968100565, -89.0666732788086, -1.55450670251326, 218, 18, 'PPL', 'P'),
(38563, 'Tonieville', 37.6094398498535, 0.656408555210706, -85.7961120605469, -1.49742464086656, 218, 21, 'PPL', 'P'),
(200237, 'Tonka', 40.7172203063965, 0.710649556606513, -116.009170532227, -2.02474198829494, 218, 39, 'PPL', 'P'),
(138457, 'Tonka Bay', 44.9086112976074, 0.783803129641573, -93.5927810668945, -1.63350218571552, 218, 28, 'PPL', 'P'),
(77462, 'Tonkawa', 36.6783294677734, 0.640157613343906, -97.3097229003906, -1.69837505881514, 218, 42, 'PPL', 'P'),
(190840, 'Tonkin', 39.9391708374023, 0.697070031629172, -116.41056060791, -2.03174756670044, 218, 39, 'PPL', 'P'),
(77466, 'Tonnece', 36.2786102294922, 0.633181196552334, -94.6116714477539, -1.65128517757842, 218, 42, 'PPL', 'P'),
(208959, 'Tono', 46.7761116027832, 0.816397158748889, -122.822776794434, -2.14366185150495, 218, 56, 'PPL', 'P'),
(190838, 'Tonogold (historical)', 38.1375007629395, 0.665624956795143, -117.213333129883, -2.04575859035341, 218, 39, 'PPL', 'P'),
(177642, 'Tonopah', 33.4936103820801, 0.584573779547453, -112.936393737793, -1.97111191605319, 218, 5, 'PPL', 'P'),
(190839, 'Tonopah', 38.0672187805176, 0.664398304797052, -117.22917175293, -2.04603502647456, 218, 39, 'PPL', 'P'),
(190841, 'Tonopah Junction', 38.2644386291504, 0.66784044050598, -118.095001220703, -2.06114660144799, 218, 39, 'PPL', 'P'),
(34142, 'Tonovay', 37.8522186279297, 0.660645844242103, -96.1777801513672, -1.67861893090061, 218, 20, 'PPL', 'P'),
(126353, 'Tonset', 41.7999992370605, 0.729547614017824, -69.9541702270508, -1.22093059596263, 218, 23, 'PPL', 'P'),
(212195, 'Tonsina', 61.6558303833008, 1.07609724323976, -145.175277709961, -2.53378658853595, 218, 1, 'PPL', 'P'),
(28796, 'Tonti', 38.6647186279297, 0.674826644414557, -88.9783325195313, -1.55296486540016, 218, 18, 'PPL', 'P'),
(12354, 'Tontitown', 36.1777801513672, 0.63142137970401, -94.2333297729492, -1.64468186965556, 218, 4, 'PPL', 'P'),
(179362, 'Tonto Basin', 33.8316688537598, 0.590474012942524, -111.293891906738, -1.94244485113125, 218, 5, 'PPL', 'P'),
(179363, 'Tonto Estate', 34.3588905334473, 0.599675767140966, -111.093887329102, -1.93895411273243, 218, 5, 'PPL', 'P'),
(179364, 'Tonto Hills Subdivision', 33.8686103820801, 0.591118764242432, -111.828056335449, -1.95176777915929, 218, 5, 'PPL', 'P'),
(179365, 'Tonto Village', 34.3161087036133, 0.598929083350335, -111.131393432617, -1.93960871772837, 218, 5, 'PPL', 'P'),
(157964, 'Tontogany', 41.4191703796387, 0.722900896569205, -83.7408294677734, -1.46155319256374, 218, 41, 'PPL', 'P'),
(189689, 'Tonuco', 32.5908317565918, 0.568817320116054, -106.996109008789, -1.86743438902614, 218, 38, 'PPL', 'P'),
(194452, 'Tonville', 40.0091705322266, 0.698291756779246, -104.703330993652, -1.82741786364466, 218, 7, 'PPL', 'P'),
(43368, 'Tony', 30.041389465332, 0.524321158043983, -91.7333297729492, -1.60104863835571, 218, 22, 'PPL', 'P'),
(176703, 'Tony', 45.4830589294434, 0.793829132197394, -90.9925003051758, -1.58811872494726, 218, 57, 'PPL', 'P'),
(189690, 'Tony', 34.6150016784668, 0.604145749872609, -105.181671142578, -1.83576647418789, 218, 38, 'PPL', 'P'),
(199727, 'Tony', 41.8305587768555, 0.73008097860514, -103.395278930664, -1.80458804835801, 218, 35, 'PPL', 'P'),
(98584, 'Tony Colonia', 26.2299995422363, 0.457799854808629, -97.9940032958984, -1.7103180047236, 218, 51, 'PPL', 'P'),
(185689, 'Tonyville', 36.2486114501953, 0.632657619082025, -119.089721679688, -2.07850774859422, 218, 6, 'PPL', 'P'),
(206135, 'Tooele', 40.5308303833008, 0.707396438755954, -112.297500610352, -1.95996112741098, 218, 52, 'PPL', 'P'),
(18357, 'Tooke Lake Junction', 28.5316696166992, 0.49797157590263, -82.3872222900391, -1.43792829053364, 218, 12, 'PPL', 'P'),
(106952, 'Tookland', 37.2502784729004, 0.650140006636877, -82.1086120605469, -1.43306562469927, 218, 53, 'PPL', 'P'),
(6361, 'Tooktocaugee (historical)', 33.6930618286133, 0.588054863987323, -85.6986083984375, -1.49572288093, 218, 2, 'PPL', 'P'),
(98586, 'Tool', 32.2677803039551, 0.563179008614193, -96.1699981689453, -1.67848310968501, 218, 51, 'PPL', 'P'),
(197700, 'Toole', 47.3261108398438, 0.825996456319052, -115.021942138672, -2.00751160235823, 218, 31, 'PPL', 'P'),
(118059, 'Toolesboro', 41.1419410705566, 0.718062332342694, -91.0619430541992, -1.58933072955936, 218, 16, 'PPL', 'P'),
(167997, 'Tooley Corners', 41.3397216796875, 0.721514255168628, -75.5805587768555, -1.31912960115323, 218, 45, 'PPL', 'P'),
(185687, 'Toolville', 36.2874984741211, 0.633336325685831, -119.116668701172, -2.07897806284273, 218, 6, 'PPL', 'P'),
(25527, 'Toombs Central', 32.0472183227539, 0.55932947583751, -82.3480606079102, -1.43724479023988, 218, 13, 'PPL', 'P'),
(62052, 'Toomer (historical)', 32.4111099243164, 0.565680582405131, -89.1258316040039, -1.55553921006789, 218, 30, 'PPL', 'P'),
(43369, 'Toomey', 30.1525001525879, 0.526260405370751, -93.6497192382813, -1.63449594427628, 218, 22, 'PPL', 'P'),
(185688, 'Toomey', 34.9208297729492, 0.609483457066428, -116.744438171387, -2.03757482948165, 218, 6, 'PPL', 'P'),
(25529, 'Toomsboro', 32.8266716003418, 0.572933501896881, -83.0794372558594, -1.45000972081879, 218, 13, 'PPL', 'P'),
(62053, 'Toomsuba', 32.4183311462402, 0.565806616503719, -88.5069427490234, -1.54473756184458, 218, 30, 'PPL', 'P'),
(91377, 'Toomy', 36.4669418334961, 0.636468203127765, -84.5944366455078, -1.47645144833386, 218, 50, 'PPL', 'P'),
(91383, 'Toone', 35.3522186279297, 0.617012612942245, -88.9524993896484, -1.55251399222761, 218, 50, 'PPL', 'P'),
(6362, 'Toonersville', 34.8630599975586, 0.608475184277724, -87.3377838134766, -1.52433188894018, 218, 2, 'PPL', 'P'),
(38564, 'Toonerville', 37.3699989318848, 0.652229522828153, -82.230827331543, -1.43519868357437, 218, 21, 'PPL', 'P'),
(57923, 'Toonerville', 38.6916694641113, 0.675297025242093, -90.7333297729492, -1.58359534583576, 218, 29, 'PPL', 'P'),
(167998, 'Toonerville', 41.5697212219238, 0.725528504458731, -79.6911087036133, -1.39087223144276, 218, 45, 'PPL', 'P'),
(187447, 'Toonerville', 37.7750015258789, 0.659298151572469, -103.163612365723, -1.800544704033, 218, 7, 'PPL', 'P'),
(25531, 'Toonnerville', 34.8680610656738, 0.608562469382451, -84.8877792358398, -1.48157124237148, 218, 13, 'PPL', 'P'),
(114176, 'Tootin'' Hills', 41.8586082458496, 0.730570534192524, -72.8663864135742, -1.27175835694733, 218, 8, 'PPL', 'P'),
(157965, 'Toots Corners', 40.9880599975586, 0.715376600962376, -80.7980575561523, -1.41019213357074, 218, 41, 'PPL', 'P'),
(157966, 'Toots Crossroads', 40.538890838623, 0.707537120240537, -81.0683288574219, -1.41490925765154, 218, 41, 'PPL', 'P'),
(167999, 'Top', 40.7099990844727, 0.710523522507925, -79.4458312988281, -1.38659133314851, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(106953, 'Top Hill', 39.0908317565918, 0.682263721495685, -77.9102783203125, -1.35979087783461, 218, 53, 'PPL', 'P'),
(197702, 'Top O''Deep', 46.8244400024414, 0.817240648445144, -113.258331298828, -1.9767307864791, 218, 31, 'PPL', 'P'),
(14765, 'Top of the Wedge', 39.7083282470703, 0.693041068374045, -75.779167175293, -1.32259597162807, 218, 10, 'PPL', 'P'),
(185690, 'Top of the World', 33.5483283996582, 0.585528789114356, -117.753326416016, -2.05518325113509, 218, 6, 'PPL', 'P'),
(206137, 'Top of the World', 40.5994415283203, 0.708593929140108, -111.79167175293, -1.95113274839736, 218, 52, 'PPL', 'P'),
(74558, 'Top-of-the-Ridge', 39.1961097717285, 0.684101169489786, -84.2677764892578, -1.47075015307222, 218, 41, 'PPL', 'P'),
(179366, 'Top-of-the-World', 33.3494415283203, 0.582057558370519, -110.991943359375, -1.93717485480815, 218, 5, 'PPL', 'P'),
(185691, 'Topanga', 34.0936088562012, 0.595045728427808, -118.600563049316, -2.0699703199297, 218, 6, 'PPL', 'P'),
(185692, 'Topanga Beach', 34.0400009155273, 0.594110093357836, -118.57861328125, -2.06958722420689, 218, 6, 'PPL', 'P'),
(185693, 'Topanga Oaks', 34.1011085510254, 0.595176622795386, -118.58943939209, -2.06977617548623, 218, 6, 'PPL', 'P'),
(185694, 'Topanga Park', 34.1074981689453, 0.595288142666033, -118.628326416016, -2.07045488209004, 218, 6, 'PPL', 'P'),
(179367, 'Topawa', 31.8138904571533, 0.555257136346129, -111.824996948242, -1.95171438277944, 218, 5, 'PPL', 'P'),
(12356, 'Topaz', 35.0363883972168, 0.611500335538972, -90.3591690063477, -1.57706500852678, 218, 4, 'PPL', 'P'),
(57924, 'Topaz', 36.9455604553223, 0.644821673939989, -92.2027816772461, -1.60924211976544, 218, 29, 'PPL', 'P'),
(133416, 'Topaz', 46.5711097717285, 0.812819201824367, -89.4688873291016, -1.56152666198866, 218, 27, 'PPL', 'P'),
(195723, 'Topaz (historical)', 42.6272201538086, 0.743985342656444, -112.084716796875, -1.95624734927086, 218, 17, 'PPL', 'P'),
(190844, 'Topaz Lake', 38.6958312988281, 0.675369662960825, -119.543060302734, -2.08642000019284, 218, 39, 'PPL', 'P'),
(185695, 'Topaz PO', 38.6111106872559, 0.673891009344585, -119.517776489258, -2.08597871440022, 218, 6, 'PPL', 'P'),
(34152, 'Topeka', 39.0483283996582, 0.681521897974044, -95.6777801513672, -1.66989228464064, 218, 20, 'PPL', 'P'),
(62054, 'Topeka', 31.4150009155273, 0.548295200492985, -90.1883316040039, -1.57408333337033, 218, 30, 'PPL', 'P'),
(121725, 'Topeka', 40.3302803039551, 0.703896179556236, -89.9311065673828, -1.56959390956273, 218, 18, 'PPL', 'P'),
(123815, 'Topeka', 41.5391693115234, 0.72499527302947, -85.5397186279297, -1.4929497312869, 218, 19, 'PPL', 'P'),
(52139, 'Topeka East', 39.6952781677246, 0.692813301521816, -76.1452789306641, -1.32898582718955, 218, 25, 'PPL', 'P'),
(25530, 'Topeka Junction', 32.9744415283203, 0.57551257367554, -84.208610534668, -1.46971751235954, 218, 13, 'PPL', 'P'),
(69447, 'Topia', 36.5155601501465, 0.637316752830091, -81.3177795410156, -1.41926299340161, 218, 33, 'PPL', 'P'),
(133417, 'Topinabee', 45.4838905334473, 0.793843646425335, -84.5952835083008, -1.47646622887791, 218, 27, 'PPL', 'P'),
(111729, 'Topins Grove', 39.0513916015625, 0.681575360932927, -81.7072219848633, -1.42606004629376, 218, 58, 'PPL', 'P'),
(62055, 'Topisaw', 31.2897205352783, 0.546108645369489, -90.273063659668, -1.57556218672365, 218, 30, 'PPL', 'P'),
(52140, 'Topkapi', 39.5369415283203, 0.690049805837668, -76.9986114501953, -1.34387928926971, 218, 25, 'PPL', 'P'),
(18358, 'Topkegaiga (historical)', 30.5666694641113, 0.533489023517553, -84.4499969482422, -1.47393050004599, 218, 12, 'PPL', 'P'),
(206138, 'Topliff', 40.1561088562012, 0.700856314329965, -112.211936950684, -1.95846775982971, 218, 52, 'PPL', 'P'),
(69454, 'Topnot', 36.3727798461914, 0.634824766419077, -79.2594375610352, -1.38333814871893, 218, 33, 'PPL', 'P'),
(18359, 'Topocapa (historical)', 30.1499996185303, 0.526216762818388, -84.0166702270508, -1.46636752202433, 218, 12, 'PPL', 'P'),
(179368, 'Topock', 34.7183303833008, 0.605949175983784, -114.486389160156, -1.99816443956427, 218, 5, 'PPL', 'P'),
(18360, 'Toponanaulka (historical)', 30.4500007629395, 0.531452770548079, -83.716667175293, -1.46113148100512, 218, 12, 'PPL', 'P'),
(194453, 'Toponas', 40.0602798461914, 0.699183782586368, -106.807502746582, -1.86414258876074, 218, 7, 'PPL', 'P'),
(208960, 'Toppenish', 46.377498626709, 0.80944004987522, -120.307502746582, -2.09976203777998, 218, 56, 'PPL', 'P'),
(57925, 'Topper', 37.952220916748, 0.662391213441514, -93.6458282470703, -1.63442803366849, 218, 29, 'PPL', 'P'),
(77469, 'Toppers', 35.9705581665039, 0.627804673785628, -95.309440612793, -1.66346354692724, 218, 42, 'PPL', 'P'),
(57926, 'Toppertown', 36.9630584716797, 0.645127071937994, -89.8411102294922, -1.5680231771518, 218, 29, 'PPL', 'P'),
(106954, 'Topping', 37.5880584716797, 0.656035379762958, -76.4747161865234, -1.33473559198304, 218, 53, 'PPL', 'P'),
(69448, 'Topsail', 34.3861083984375, 0.600150808500409, -77.688606262207, -1.355921970561, 218, 33, 'PPL', 'P'),
(69449, 'Topsail Beach', 34.3650016784668, 0.599782426742623, -77.6308288574219, -1.35491356461424, 218, 33, 'PPL', 'P'),
(98585, 'Topsey', 31.2188892364502, 0.544872405991474, -97.9847183227539, -1.71015595137127, 218, 51, 'PPL', 'P'),
(126354, 'Topsfield', 42.6375007629395, 0.744164773134888, -70.9499969482422, -1.23831105102676, 218, 23, 'PPL', 'P'),
(129084, 'Topsfield', 45.4188919067383, 0.792709206379988, -67.7361068725586, -1.18221808740891, 218, 26, 'PPL', 'P'),
(129086, 'Topsham', 43.9275016784668, 0.766679536464581, -69.9763870239258, -1.22131835221734, 218, 26, 'PPL', 'P'),
(172647, 'Topsham Four Corners', 44.0988883972168, 0.769670799000958, -72.2249984741211, -1.26056402562129, 218, 55, 'PPL', 'P'),
(91378, 'Topside', 35.8758316040039, 0.626151383380907, -83.959716796875, -1.46537349714746, 218, 50, 'PPL', 'P'),
(176706, 'Topside', 46.5591697692871, 0.812610809469069, -91.3225021362305, -1.59387834343678, 218, 57, 'PPL', 'P'),
(114177, 'Topstone', 41.2958297729492, 0.720748196881066, -73.4494400024414, -1.28193456178863, 218, 8, 'PPL', 'P'),
(43370, 'Topsy', 30.4091701507568, 0.530740141929887, -93.1222229003906, -1.62528939638788, 218, 22, 'PPL', 'P'),
(69451, 'Topsy', 36.5033302307129, 0.637103300468721, -76.8711090087891, -1.34165395186284, 218, 33, 'PPL', 'P'),
(91379, 'Topsy', 35.4255599975586, 0.618292661320192, -87.7030563354492, -1.53070709711566, 218, 50, 'PPL', 'P'),
(139484, 'Topsy', 40.3530616760254, 0.704293789506984, -93.4797210693359, -1.63152891650583, 218, 29, 'PPL', 'P'),
(6363, 'Topton', 31.2861099243164, 0.546045628320195, -88.1500015258789, -1.53850776226461, 218, 2, 'PPL', 'P'),
(62056, 'Topton', 32.4672203063965, 0.566659893316981, -88.6022186279297, -1.54640043962923, 218, 30, 'PPL', 'P'),
(69452, 'Topton', 35.246940612793, 0.615175164948145, -83.7033309936523, -1.46089872072585, 218, 33, 'PPL', 'P'),
(168000, 'Topton', 40.5033302307129, 0.706916470548494, -75.7016677856445, -1.32124335211042, 218, 45, 'PPL', 'P'),
(91380, 'Toqua', 35.5636100769043, 0.620702089737414, -84.1944427490234, -1.46947023785232, 218, 50, 'PPL', 'P'),
(91381, 'Toqua (historical)', 35.5680618286133, 0.620779787462217, -84.1741714477539, -1.46911643690151, 218, 50, 'PPL', 'P'),
(192825, 'Toquerville', 37.2533302307129, 0.650193269858679, -113.283889770508, -1.97717686596168, 218, 52, 'PPL', 'P'),
(133418, 'Toquin', 42.2574996948242, 0.737532503335182, -86.2230606079102, -1.50487629875466, 218, 27, 'PPL', 'P'),
(43371, 'Torbert', 30.5541706085205, 0.533270877334762, -91.4902801513672, -1.59680662221337, 218, 22, 'PPL', 'P'),
(168002, 'Torbert', 41.2205581665039, 0.71943445951533, -77.3188934326172, -1.34946926439779, 218, 45, 'PPL', 'P'),
(91382, 'Torbet', 35.3566703796387, 0.617090310667048, -85.6283264160156, -1.49449622893191, 218, 50, 'PPL', 'P'),
(208961, 'Torboy', 48.6800003051758, 0.849626285197162, -118.661666870117, -2.07103678278822, 218, 56, 'PPL', 'P'),
(57927, 'Torch', 36.5363883972168, 0.637680274318887, -90.6761093139648, -1.58259666042698, 218, 29, 'PPL', 'P'),
(74559, 'Torch', 39.2394409179688, 0.684857440660341, -81.7491683959961, -1.42679214927742, 218, 41, 'PPL', 'P'),
(133419, 'Torch Lake', 45.0752792358398, 0.786712033921239, -85.3586120605469, -1.48978882538908, 218, 27, 'PPL', 'P'),
(133422, 'Torch River', 44.8511085510254, 0.782799517384776, -85.3238906860352, -1.48918282308304, 218, 27, 'PPL', 'P'),
(38565, 'Torchlight', 38.0494384765625, 0.664087979951031, -82.6147232055664, -1.4418989305609, 218, 21, 'PPL', 'P'),
(187450, 'Tordal Estates', 39.3925018310547, 0.687528857549799, -106.049438476563, -1.85091187130718, 218, 7, 'PPL', 'P'),
(197703, 'Torens Trailer Park', 48.170280456543, 0.840729995575752, -111.945281982422, -1.95381375266675, 218, 31, 'PPL', 'P'),
(179369, 'Toreva', 35.8041687011719, 0.624900629774951, -110.496391296387, -1.92852583969395, 218, 5, 'PPL', 'P'),
(138461, 'Torfin', 48.5977783203125, 0.848191240843773, -95.7333297729492, -1.67086180843548, 218, 28, 'PPL', 'P'),
(38566, 'Toria', 36.9894409179688, 0.645587532490468, -85.4375, -1.49116567967266, 218, 21, 'PPL', 'P'),
(98587, 'Torian', 27.7144393920898, 0.483708217736384, -98.0763931274414, -1.71175597855419, 218, 51, 'PPL', 'P'),
(189691, 'Toril', 36.3875007629395, 0.635081694885242, -104.585563659668, -1.82536243591534, 218, 38, 'PPL', 'P'),
(121726, 'Torino', 41.2058296203613, 0.71917739789111, -88.2347183227539, -1.53998634930182, 218, 18, 'PPL', 'P'),
(185696, 'Tormey', 38.0505599975586, 0.664107554185043, -122.248062133789, -2.13363118841722, 218, 6, 'PPL', 'P'),
(111730, 'Tornado', 38.3430595397949, 0.669212634257643, -81.8499984741211, -1.42855196612575, 218, 58, 'PPL', 'P'),
(189692, 'Tornero', 33.8844413757324, 0.591395067205528, -103.713333129883, -1.81013914133417, 218, 38, 'PPL', 'P'),
(192332, 'Tornillo', 31.4452800750732, 0.548823671521798, -106.087783813477, -1.85158112368911, 218, 51, 'PPL', 'P'),
(43372, 'Toro', 31.2802791595459, 0.545943862277041, -93.5438919067383, -1.63264890890226, 218, 22, 'PPL', 'P'),
(185697, 'Toro Canyon', 34.4199981689453, 0.600742296578515, -119.566108703613, -2.0868222706755, 218, 6, 'PPL', 'P'),
(208962, 'Toroda', 48.9430618286133, 0.854217574916458, -118.760833740234, -2.07276757118066, 218, 56, 'PPL', 'P'),
(28798, 'Toronto', 39.7138900756836, 0.693138140595779, -89.6297225952148, -1.56433376693566, 218, 18, 'PPL', 'P'),
(31315, 'Toronto', 39.7816696166992, 0.694321116751992, -87.4955596923828, -1.52708559750732, 218, 19, 'PPL', 'P'),
(34146, 'Toronto', 37.7988891601563, 0.659715069441121, -95.9488906860352, -1.67462405610743, 218, 20, 'PPL', 'P'),
(57928, 'Toronto', 38.0036087036133, 0.663288099517626, -92.5252838134766, -1.61487084388738, 218, 29, 'PPL', 'P'),
(118060, 'Toronto', 41.9049987792969, 0.731380201742935, -90.8638916015625, -1.58587407962249, 218, 16, 'PPL', 'P'),
(157967, 'Toronto', 40.464168548584, 0.706232970254726, -80.6011123657227, -1.40675479155178, 218, 41, 'PPL', 'P'),
(171428, 'Toronto', 44.5730590820313, 0.777946638667407, -96.642219543457, -1.68672492746854, 218, 49, 'PPL', 'P'),
(192333, 'Toronto', 30.3400001525879, 0.529532897718241, -103.750282287598, -1.81078402579213, 218, 51, 'PPL', 'P'),
(77467, 'Torpedo', 36.7269401550293, 0.641006029888178, -96.0427780151367, -1.67626269912616, 218, 42, 'PPL', 'P'),
(168003, 'Torpedo', 41.7791709899902, 0.729184092529028, -79.4658279418945, -1.38694034040937, 218, 45, 'PPL', 'P'),
(168004, 'Torrance', 40.4172210693359, 0.705413582166335, -79.2230606079102, -1.38270325111505, 218, 45, 'PPL', 'P'),
(185698, 'Torrance', 33.8358306884766, 0.590546650661256, -118.339721679688, -2.06541777920426, 218, 6, 'PPL', 'P'),
(189693, 'Torrance', 34.3411102294922, 0.599365442294944, -105.527496337891, -1.84180226248245, 218, 38, 'PPL', 'P'),
(69453, 'Torrance (historical)', 35.5344390869141, 0.620192959916018, -80.7602767944336, -1.40953273488484, 218, 33, 'PPL', 'P'),
(43374, 'Torras', 30.9894409179688, 0.540867777370809, -91.6788864135742, -1.60009842247877, 218, 22, 'PPL', 'P'),
(43373, 'Torras Landing', 30.9694404602051, 0.540518703530927, -91.6669387817383, -1.59988989696541, 218, 22, 'PPL', 'P'),
(38567, 'Torrent', 37.7158317565918, 0.658265444280763, -83.6630630493164, -1.46019591251418, 218, 21, 'PPL', 'P'),
(189696, 'Torreon', 34.7222213745117, 0.606017086591581, -106.298057556152, -1.8552510928293, 218, 38, 'PPL', 'P'),
(187449, 'Torres', 37.6066703796387, 0.656360218836921, -106.203887939453, -1.85360752296255, 218, 7, 'PPL', 'P'),
(168005, 'Torresdale', 40.0547218322754, 0.699086776943662, -75.0047225952148, -1.30907936383149, 218, 45, 'PPL', 'P'),
(168006, 'Torresdale Manor', 40.060001373291, 0.699178922317378, -74.966667175293, -1.30841517145562, 218, 45, 'PPL', 'P'),
(18361, 'Torrey', 27.610559463501, 0.481895170955771, -81.8263931274414, -1.42813997510511, 218, 12, 'PPL', 'P'),
(168007, 'Torrey', 41.6327781677246, 0.726629055779206, -75.192497253418, -1.31235664986894, 218, 45, 'PPL', 'P'),
(192823, 'Torrey', 38.2988891601563, 0.668441715701092, -111.418327331543, -1.94461665900021, 218, 52, 'PPL', 'P'),
(195724, 'Torreys', 44.2536087036133, 0.772371177767271, -114.601387023926, -2.00017153091981, 218, 17, 'PPL', 'P'),
(200238, 'Torreytown (historical)', 40.3588905334473, 0.704395522260625, -118.328056335449, -2.06521418053892, 218, 39, 'PPL', 'P'),
(114178, 'Torringford', 41.8211097717285, 0.729916062354637, -73.0805587768555, -1.27549636985337, 218, 8, 'PPL', 'P'),
(114179, 'Torrington', 41.8005599975586, 0.72955740113483, -73.1216735839844, -1.27621395860909, 218, 8, 'PPL', 'P'),
(209791, 'Torrington', 42.0625, 0.734129116620115, -104.183891296387, -1.81835193066181, 218, 59, 'PPL', 'P'),
(179371, 'Tortilla Flat', 33.5263900756836, 0.58514589312863, -111.389167785645, -1.9441077289159, 218, 5, 'PPL', 'P'),
(192824, 'Tortoise and Hare Trailer Court', 37.2933311462402, 0.650891417538443, -112.616386413574, -1.96552673461508, 218, 52, 'PPL', 'P'),
(179370, 'Tortolita', 32.4102783203125, 0.565666068177191, -111.016670227051, -1.9376064200628, 218, 5, 'PPL', 'P'),
(43375, 'Tortue', 30.1797199249268, 0.526735480019708, -92.4475021362305, -1.61351329752171, 218, 22, 'PPL', 'P'),
(185699, 'Tortuga', 33.167781829834, 0.578886998513753, -115.341941833496, -2.01309665063829, 218, 6, 'PPL', 'P'),
(189697, 'Tortugas', 32.2700004577637, 0.563217757608053, -106.752220153809, -1.86317772549781, 218, 38, 'PPL', 'P'),
(176707, 'Torun', 44.6136093139648, 0.778654373727095, -89.5094375610352, -1.56223439704835, 218, 57, 'PPL', 'P'),
(171431, 'Torvik Subdivision', 45.6624984741211, 0.7969609430603, -97.0766677856445, -1.69430747972421, 218, 49, 'PPL', 'P'),
(129088, 'Tory Hill', 43.605281829834, 0.761055739190661, -70.5366668701172, -1.23109708026595, 218, 26, 'PPL', 'P'),
(185700, 'Tosco (historical)', 33.6922187805176, 0.5880401500223, -114.601669311523, -2.00017645776783, 218, 6, 'PPL', 'P'),
(106956, 'Toshes', 36.9691696166992, 0.645233731539651, -79.4863891601563, -1.38729920136626, 218, 53, 'PPL', 'P'),
(197704, 'Toston', 46.172779083252, 0.805867019798716, -111.440277099609, -1.94499975472302, 218, 31, 'PPL', 'P'),
(179372, 'Totacon', 36.8499984741211, 0.6431538027283, -109.425003051758, -1.90982658725802, 218, 5, 'PPL', 'P'),
(84060, 'Totany Woods', 34.8883285522461, 0.608916203754241, -82.3372192382813, -1.43705557264443, 218, 48, 'PPL', 'P'),
(106955, 'Totaro', 36.7472190856934, 0.641359963997049, -77.6958312988281, -1.35604807123861, 218, 53, 'PPL', 'P'),
(189698, 'Totavi', 35.875560760498, 0.626146656269972, -106.17472076416, -1.85309845972018, 218, 38, 'PPL', 'P'),
(208963, 'Totem Park', 48.1586112976074, 0.840526330331388, -122.176666259766, -2.13238509534318, 218, 56, 'PPL', 'P'),
(212196, 'Totem Park', 64.8627777099609, 1.13206903302801, -147.778060913086, -2.57921372514609, 218, 1, 'PPL', 'P'),
(106958, 'Totier Hills', 37.8258285522461, 0.660185250531574, -78.5305633544922, -1.37061689398189, 218, 53, 'PPL', 'P'),
(84061, 'Totness', 33.7425003051758, 0.588917728180509, -80.8002777099609, -1.4102308825646, 218, 48, 'PPL', 'P'),
(123816, 'Toto', 41.2594413757324, 0.72011309954011, -86.6980590820313, -1.51316658607002, 218, 19, 'PPL', 'P'),
(114181, 'Totoket', 41.3283309936523, 0.721315450193253, -72.8138885498047, -1.27084209637429, 218, 8, 'PPL', 'P'),
(179373, 'Totopitk', 32.5633316040039, 0.568337351908594, -112.212219238281, -1.95847268667773, 218, 5, 'PPL', 'P'),
(106959, 'Totopotomoy', 37.6930618286133, 0.657868034067096, -77.4230575561523, -1.35128727131593, 218, 53, 'PPL', 'P'),
(146461, 'Totowa', 40.9049987792969, 0.713926909222992, -74.2102813720703, -1.29521374877404, 218, 37, 'PPL', 'P'),
(18362, 'Totstalahoeetska (historical)', 27.8333301544189, 0.485783252989232, -82.6333312988281, -1.44222370305583, 218, 12, 'PPL', 'P'),
(153171, 'Tottenville', 40.5111083984375, 0.707052225185061, -74.2497177124023, -1.29590204275777, 218, 40, 'PPL', 'P'),
(91384, 'Tottys Bend', 35.7844390869141, 0.624556283046004, -87.3688888549805, -1.52487477432839, 218, 50, 'PPL', 'P'),
(106960, 'Totuskey', 37.9438896179199, 0.662245804845996, -76.6175003051758, -1.33722764497308, 218, 53, 'PPL', 'P'),
(38568, 'Totz', 36.9447212219238, 0.644807026553993, -83.1177825927734, -1.45067897320073, 218, 21, 'PPL', 'P'),
(208964, 'Touchet', 46.0400009155273, 0.803549603597156, -118.671112060547, -2.0712016324597, 218, 56, 'PPL', 'P'),
(62057, 'Touchstone', 31.9983291625977, 0.558476199024249, -90.0344390869141, -1.57139740225293, 218, 30, 'PPL', 'P'),
(62058, 'Tougaloo', 32.3974990844727, 0.565443028435896, -90.1588897705078, -1.573569476438, 218, 30, 'PPL', 'P'),
(79270, 'Toughkenamon', 39.8313903808594, 0.695188907793194, -75.7577819824219, -1.3222227296013, 218, 45, 'PPL', 'P'),
(208965, 'Touhey', 47.7541694641113, 0.833467488704079, -119.710563659668, -2.08934348527948, 218, 56, 'PPL', 'P'),
(143202, 'Touhy', 41.1330604553223, 0.717907336367251, -96.8227767944336, -1.68987624598643, 218, 35, 'PPL', 'P'),
(126356, 'Touisset', 41.7208290100098, 0.728165832886237, -71.227783203125, -1.24315933579124, 218, 23, 'PPL', 'P'),
(169634, 'Touisset Highlands', 41.7097206115723, 0.727971954758879, -71.2416687011719, -1.24340168345044, 218, 47, 'PPL', 'P'),
(6364, 'Toulminville', 30.7186107635498, 0.536140899462513, -88.0908279418945, -1.53747498839388, 218, 2, 'PPL', 'P'),
(34148, 'Toulon', 38.8516693115234, 0.678089549382123, -99.2411117553711, -1.73208415347087, 218, 20, 'PPL', 'P'),
(91385, 'Toulon', 35.7383308410645, 0.623751542343609, -89.4155578613281, -1.56059588718768, 218, 50, 'PPL', 'P'),
(121727, 'Toulon', 41.0936088562012, 0.717218776067411, -89.8647232055664, -1.56843530133049, 218, 18, 'PPL', 'P'),
(200239, 'Toulon', 40.0627784729004, 0.699227391849218, -118.643890380859, -2.07072652452123, 218, 39, 'PPL', 'P'),
(129089, 'Toulouse Corner', 44.6069412231445, 0.778537993587459, -69.6969375610352, -1.21644103899697, 218, 26, 'PPL', 'P'),
(25534, 'Touraine (historical)', 30.9272193908691, 0.539781806857302, -83.8844375610352, -1.46405962662367, 218, 13, 'PPL', 'P'),
(38570, 'Touristville', 36.9255599975586, 0.644472600100107, -84.7616729736328, -1.47937027288859, 218, 21, 'PPL', 'P'),
(98588, 'Tours', 31.7597198486328, 0.554311680869638, -97.0374984741211, -1.69362384627239, 218, 51, 'PPL', 'P'),
(157968, 'Tousaint (historical)', 41.4794387817383, 0.723952778620759, -83.3874969482422, -1.45538637674355, 218, 41, 'PPL', 'P'),
(38569, 'Tousey', 37.5144386291504, 0.654750471116022, -86.5477828979492, -1.51054377187045, 218, 21, 'PPL', 'P'),
(208966, 'Toutle', 46.3250007629395, 0.808523789302179, -122.735282897949, -2.1421347949359, 218, 56, 'PPL', 'P'),
(77468, 'Touzalin', 36.3333282470703, 0.634136206119237, -99.9744415283203, -1.74488317251174, 218, 42, 'PPL', 'P'),
(28803, 'Tovey', 39.5888900756836, 0.690956479030786, -89.4561080932617, -1.56130362224736, 218, 18, 'PPL', 'P'),
(28799, 'Tovey Humphrey Station', 39.5897216796875, 0.690970993258727, -89.4550018310547, -1.56128431432946, 218, 18, 'PPL', 'P'),
(179374, 'Tovrea', 33.4433288574219, 0.583696201389245, -111.976112365723, -1.954351844365, 218, 5, 'PPL', 'P'),
(98589, 'Tow', 30.8833293914795, 0.539015781859254, -98.4722213745117, -1.71866448473797, 218, 51, 'PPL', 'P'),
(146463, 'Towaco', 40.9219398498535, 0.714222586683018, -74.345832824707, -1.29757956792841, 218, 37, 'PPL', 'P'),
(208967, 'Towal', 45.7513885498047, 0.798512367553325, -120.602783203125, -2.10491565396344, 218, 56, 'PPL', 'P'),
(25532, 'Towalaga', 33.3141708374023, 0.581441968684547, -84.204719543457, -1.46964960175174, 218, 13, 'PPL', 'P'),
(25533, 'Towaliga (historical)', 33.2383308410645, 0.580118311043751, -84.0680618286133, -1.46726447467947, 218, 13, 'PPL', 'P'),
(168008, 'Towamensing Trails', 41.0077781677246, 0.715720747954242, -75.5849990844727, -1.31920709914095, 218, 45, 'PPL', 'P'),
(34149, 'Towanda', 37.7975006103516, 0.659690834675201, -96.9994430541992, -1.69295965389652, 218, 20, 'PPL', 'P'),
(121729, 'Towanda', 40.5638885498047, 0.70797341260612, -88.8988876342773, -1.55157829057861, 218, 18, 'PPL', 'P'),
(168010, 'Towanda', 41.7675018310547, 0.728980427284665, -76.4430618286133, -1.3341831192149, 218, 45, 'PPL', 'P'),
(187451, 'Towaoc', 37.2044410705566, 0.649339993045417, -108.728889465332, -1.89767711320702, 218, 7, 'PPL', 'P'),
(112573, 'Towee', 35.2322196960449, 0.61491823648198, -84.4416732788086, -1.47378522460853, 218, 50, 'PPL', 'P'),
(91387, 'Towee Falls (historical)', 35.252498626709, 0.615272170590851, -84.3736114501953, -1.4725973216043, 218, 50, 'PPL', 'P'),
(133423, 'Tower', 45.355281829834, 0.791599001100562, -84.3005599975586, -1.47132233323242, 218, 27, 'PPL', 'P'),
(138464, 'Tower', 47.8055610656738, 0.834364441359218, -92.2744369506836, -1.61049274021335, 218, 28, 'PPL', 'P'),
(52141, 'Tower Acres', 39.1338882446289, 0.683015198976279, -76.8777770996094, -1.34177033200248, 218, 25, 'PPL', 'P'),
(140972, 'Tower City', 46.922779083252, 0.818956989188673, -97.6736068725586, -1.70472603222471, 218, 34, 'PPL', 'P'),
(168016, 'Tower City', 40.589168548584, 0.708414631819719, -76.5527801513672, -1.33609806519672, 218, 45, 'PPL', 'P'),
(98590, 'Tower Colonia', 26.3040008544922, 0.459091421358291, -98.0859985351563, -1.71192362454481, 218, 51, 'PPL', 'P'),
(52142, 'Tower Gardens of the Bay', 38.8736114501953, 0.678472511946876, -76.3625030517578, -1.33277710331739, 218, 25, 'PPL', 'P'),
(69456, 'Tower Gate', 36.1644401550293, 0.63118855284571, -80.3030624389648, -1.40155283899452, 218, 33, 'PPL', 'P'),
(57929, 'Tower Grove', 38.622501373291, 0.67408981431996, -90.26611328125, -1.57544087973599, 218, 29, 'PPL', 'P'),
(28800, 'Tower Heights', 39.5247192382813, 0.689836486634353, -89.769172668457, -1.56676762985588, 218, 18, 'PPL', 'P'),
(98591, 'Tower Heights Colonia', 26.3159999847412, 0.459300845688512, -98.088996887207, -1.71197595566023, 218, 51, 'PPL', 'P'),
(28801, 'Tower Hill', 39.3877792358398, 0.687446432714061, -88.960563659668, -1.55265474029122, 218, 18, 'PPL', 'P'),
(126357, 'Tower Hill', 42.3680610656738, 0.739462163282026, -71.3388900756836, -1.24509851653899, 218, 23, 'PPL', 'P'),
(169635, 'Tower Hill (historical)', 41.4677810668945, 0.723749313113477, -71.4627838134766, -1.24726087018608, 218, 47, 'PPL', 'P'),
(12358, 'Tower Hill Addition', 34.8786087036133, 0.608746560392803, -91.9847183227539, -1.60543619625161, 218, 4, 'PPL', 'P'),
(206140, 'Tower Hill Condominium', 40.7763900756836, 0.711682263898219, -111.883056640625, -1.95272771557421, 218, 52, 'PPL', 'P'),
(79271, 'Tower Hill Number One', 39.9505615234375, 0.697268836604546, -79.8772201538086, -1.39412048902433, 218, 45, 'PPL', 'P'),
(79272, 'Tower Hill Number Two', 39.9672203063965, 0.697559587216556, -79.8963928222656, -1.3944551152153, 218, 45, 'PPL', 'P'),
(133424, 'Tower Hill Shorelands', 41.901668548584, 0.731322078252144, -86.6108322143555, -1.51164419003287, 218, 27, 'PPL', 'P'),
(138465, 'Tower Junction', 47.8050003051758, 0.834354654242211, -92.2561111450195, -1.61017289456643, 218, 28, 'PPL', 'P'),
(209792, 'Tower Junction', 44.916389465332, 0.783938884278139, -110.416107177734, -1.92712461748641, 218, 59, 'PPL', 'P'),
(121731, 'Tower Lake', 42.2319412231445, 0.737086423852593, -88.1519393920898, -1.53854158441046, 218, 18, 'PPL', 'P'),
(52143, 'Tower Mobile Home Park', 38.9047203063965, 0.679015463914116, -75.7886123657227, -1.32276082129955, 218, 25, 'PPL', 'P'),
(25535, 'Tower Pines', 33.4544410705566, 0.58389014609563, -82.1272201538086, -1.4333903971942, 218, 13, 'PPL', 'P'),
(199728, 'Tower Plaza Mobile Home Park', 42.1016693115234, 0.734812750071938, -102.871673583984, -1.7954494110774, 218, 35, 'PPL', 'P'),
(52144, 'Tower Point', 39.4986114501953, 0.68938081977184, -75.915283203125, -1.32497164447848, 218, 25, 'PPL', 'P'),
(14755, 'Tower Shores', 38.5838890075684, 0.673415901406115, -75.0611114501953, -1.31006353501232, 218, 10, 'PPL', 'P'),
(118061, 'Tower Station (historical)', 41.0269393920898, 0.716055174408129, -92.8727798461914, -1.62093579379587, 218, 16, 'PPL', 'P'),
(118062, 'Tower Terrace Mobile Home Park', 42.0591697692871, 0.734070993129324, -91.6944427490234, -1.6003699317519, 218, 16, 'PPL', 'P'),
(43378, 'Tower Trailer Park', 31.1402797698975, 0.543500411976893, -93.29638671875, -1.6283291284561, 218, 22, 'PPL', 'P'),
(91386, 'Towering Heights', 35.482780456543, 0.619291346728972, -89.9447174072266, -1.56983146353196, 218, 50, 'PPL', 'P'),
(52145, 'Towering Oaks', 39.1541709899902, 0.683369199664177, -76.6175003051758, -1.33722764497308, 218, 25, 'PPL', 'P'),
(153172, 'Towers Corners', 43.2580604553223, 0.754995582972131, -79.0094375610352, -1.37897482558894, 218, 40, 'PPL', 'P'),
(79273, 'Towerville', 39.9555587768555, 0.697356055130246, -75.8491668701172, -1.32381769677815, 218, 45, 'PPL', 'P'),
(153173, 'Towerville', 42.208610534668, 0.73667922652192, -79.2955627441406, -1.383968652107, 218, 40, 'PPL', 'P'),
(176708, 'Towerville', 43.4075012207031, 0.757603816364727, -90.8891677856445, -1.58631523225706, 218, 57, 'PPL', 'P'),
(185701, 'Towle', 39.2041702270508, 0.684241850974369, -120.798057556152, -2.10832383436847, 218, 6, 'PPL', 'P'),
(12359, 'Towle (historical)', 34.6775016784668, 0.605236580655106, -91.1041717529297, -1.59006775939104, 218, 4, 'PPL', 'P'),
(144567, 'Towles Corner', 42.8950004577637, 0.748658990632451, -70.9283294677734, -1.23793288215196, 218, 36, 'PPL', 'P'),
(153174, 'Towlesville', 42.333610534668, 0.738860888086913, -77.4561080932617, -1.35186411200804, 218, 40, 'PPL', 'P'),
(106961, 'Towlston Meadow', 38.9505615234375, 0.679815544084603, -77.2680587768555, -1.34858203228063, 218, 53, 'PPL', 'P'),
(18363, 'Town ''n'' Country', 28.0102806091309, 0.488871621036856, -82.5774993896484, -1.44124925241297, 218, 12, 'PPL', 'P'),
(91388, 'Town Acres', 36.1588897705078, 0.631091680361058, -82.8086090087891, -1.44528287620001, 218, 50, 'PPL', 'P'),
(25538, 'Town and Country', 33.3722190856934, 0.582455101742241, -82.07861328125, -1.43254204722896, 218, 13, 'PPL', 'P'),
(43380, 'Town and Country', 32.5569381713867, 0.56822576545892, -92.0641708374023, -1.60682290423122, 218, 22, 'PPL', 'P'),
(52160, 'Town and Country', 39.0972213745117, 0.682375241366333, -76.8233337402344, -1.34082011612554, 218, 25, 'PPL', 'P'),
(57930, 'Town and Country', 38.6122207641602, 0.673910383841516, -90.4633331298828, -1.57888301544492, 218, 29, 'PPL', 'P'),
(69463, 'Town and Country', 35.848331451416, 0.625671415173447, -81.5888900756836, -1.4239947648684, 218, 33, 'PPL', 'P'),
(84062, 'Town and Country', 34.0283317565918, 0.593906428113473, -81.2249984741211, -1.41764365830078, 218, 48, 'PPL', 'P'),
(106962, 'Town and Country', 37.3291702270508, 0.651516927499475, -79.5455627441406, -1.38833197523699, 218, 53, 'PPL', 'P'),
(208968, 'Town and Country', 47.7275009155273, 0.83300203472456, -117.420562744141, -2.04937542942984, 218, 56, 'PPL', 'P'),
(25540, 'Town and Country Estates', 31.0216693878174, 0.541430270282547, -84.8883285522461, -1.48158082975141, 218, 13, 'PPL', 'P'),
(74560, 'Town and Country Estates', 38.8408317565918, 0.6779003983657, -82.2247161865234, -1.43509202397271, 218, 41, 'PPL', 'P'),
(143204, 'Town and Country Mobile Homes', 41.3416709899902, 0.721548277051553, -95.9741668701172, -1.67506520874201, 218, 35, 'PPL', 'P'),
(52156, 'Town and Country North', 39.4694404602051, 0.688871689950445, -76.6191711425781, -1.33725680658701, 218, 25, 'PPL', 'P'),
(25541, 'Town and Country Subdivision Number 2', 31.021110534668, 0.541420516455055, -84.8983306884766, -1.48175539996086, 218, 13, 'PPL', 'P'),
(185705, 'Town and Country Trailer Estates', 34.8630599975586, 0.608475184277724, -120.399169921875, -2.10136193180484, 218, 6, 'PPL', 'P'),
(197705, 'Town and Country Trailer Park', 45.438060760498, 0.793043765991929, -105.411109924316, -1.83977093636099, 218, 31, 'PPL', 'P'),
(185707, 'Town and Country Village', 38.6180610656738, 0.674012316332238, -121.399719238281, -2.11882481170471, 218, 6, 'PPL', 'P'),
(52146, 'Town And Country West', 39.2861099243164, 0.685671968479742, -76.8152770996094, -1.34067950121998, 218, 25, 'PPL', 'P'),
(71480, 'Town Bank', 38.9874992370605, 0.680460228805484, -74.95361328125, -1.30818733802436, 218, 37, 'PPL', 'P'),
(98592, 'Town Bluff', 30.78782081604, 0.537348842753946, -94.1803817749023, -1.64375775275731, 218, 51, 'PPL', 'P'),
(146464, 'Town Brook', 40.392219543457, 0.704977223221726, -74.0999984741211, -1.29328894909619, 218, 37, 'PPL', 'P'),
(52148, 'Town Commons', 39.5708312988281, 0.690641293915775, -75.9819412231445, -1.32613504640068, 218, 25, 'PPL', 'P'),
(6365, 'Town Creek', 34.6811103820801, 0.605299564414886, -87.4061126708984, -1.52552445247631, 218, 2, 'PPL', 'P'),
(25537, 'Town Creek', 34.8222198486328, 0.607762389211964, -83.870002746582, -1.46380769158454, 218, 13, 'PPL', 'P'),
(52149, 'Town Creek', 38.3216705322266, 0.668839325651841, -76.4797210693359, -1.33482294366679, 218, 25, 'PPL', 'P'),
(69458, 'Town Creek', 35.814998626709, 0.625089647633319, -77.8013916015625, -1.35789044608073, 218, 33, 'PPL', 'P'),
(91390, 'Town Creek', 36.5288887023926, 0.63754937995131, -83.7388916015625, -1.46151937041789, 218, 50, 'PPL', 'P'),
(52150, 'Town Creek (historical)', 39.6313896179199, 0.6916982359734, -78.5652770996094, -1.37122276312988, 218, 25, 'PPL', 'P'),
(52151, 'Town Creek Farm', 38.3127784729004, 0.668684129939317, -76.4861068725586, -1.33493439695841, 218, 25, 'PPL', 'P'),
(52152, 'Town Creek Manor', 38.3038902282715, 0.66852900080582, -76.4916687011719, -1.33503146918014, 218, 25, 'PPL', 'P'),
(126358, 'Town Crest Village', 42.5780601501465, 0.743127338732247, -73.1508331298828, -1.2767228886934, 218, 23, 'PPL', 'P'),
(43379, 'Town East', 32.5255584716797, 0.567678086380745, -91.9875030517578, -1.60548479894151, 218, 22, 'PPL', 'P'),
(146465, 'Town Estates', 40.0586090087891, 0.699154620972431, -74.8677825927734, -1.30668930991119, 218, 37, 'PPL', 'P'),
(69460, 'Town Forest', 35.3205604553223, 0.616460073595081, -82.4880599975586, -1.43968824054002, 218, 33, 'PPL', 'P'),
(126359, 'Town Hall', 42.0652809143066, 0.734177652730982, -70.8666687011719, -1.23685669875546, 218, 23, 'PPL', 'P'),
(144568, 'Town Hall Corner', 42.9213905334473, 0.74911958434298, -70.8733291625977, -1.23697294573704, 218, 36, 'PPL', 'P'),
(31316, 'Town Hill', 39.1980590820313, 0.684135191372711, -86.2466735839844, -1.50528842293335, 218, 19, 'PPL', 'P'),
(111731, 'Town Hill', 39.002498626709, 0.680722017540639, -79.1316680908203, -1.38110815078015, 218, 58, 'PPL', 'P'),
(114182, 'Town Hill', 41.8530616760254, 0.730473728286899, -72.9994430541992, -1.27408063341788, 218, 8, 'PPL', 'P'),
(129090, 'Town Hill', 44.398609161377, 0.774901913172146, -68.3341674804688, -1.19265621414342, 218, 26, 'PPL', 'P'),
(168015, 'Town Hill', 41.1791687011719, 0.718712077069646, -76.2555618286133, -1.33091062686741, 218, 45, 'PPL', 'P'),
(144569, 'Town House', 43.4411087036133, 0.758190377594817, -70.9852828979492, -1.23892690702884, 218, 36, 'PPL', 'P'),
(129091, 'Town House Corners', 43.3811111450195, 0.757143222654198, -70.477783203125, -1.23006936640129, 218, 26, 'PPL', 'P'),
(114183, 'Town Landing', 41.2958297729492, 0.720748196881066, -72.3283309936523, -1.2623675183115, 218, 8, 'PPL', 'P'),
(129092, 'Town Landing', 43.5447196960449, 0.759998730554008, -70.333610534668, -1.22755307864533, 218, 26, 'PPL', 'P'),
(153175, 'Town Line', 42.8905601501465, 0.74858149264473, -78.5780563354492, -1.37144580287118, 218, 40, 'PPL', 'P'),
(153176, 'Town Line Station', 42.9013900756836, 0.748770510503098, -78.5783309936523, -1.37145059656114, 218, 40, 'PPL', 'P'),
(123817, 'Town of Pines', 41.6819381713867, 0.727487059703403, -86.9602813720703, -1.51774322840332, 218, 19, 'PPL', 'P'),
(18364, 'Town Park Estates', 25.7544403076172, 0.449499780376261, -80.3516693115234, -1.40240118895977, 218, 12, 'PPL', 'P'),
(126360, 'Town Pasture', 41.2833290100098, 0.720530017408762, -70.1166687011719, -1.22376672936551, 218, 23, 'PPL', 'P'),
(114184, 'Town Plot Hill', 41.538890838623, 0.724990412760481, -73.0533294677734, -1.27502112875684, 218, 8, 'PPL', 'P'),
(52154, 'Town Point', 39.4955596923828, 0.689327556550039, -75.8966674804688, -1.32464673882549, 218, 25, 'PPL', 'P'),
(52155, 'Town Point Estates', 38.5458297729492, 0.672751642451222, -76.2099990844727, -1.33011540696591, 218, 25, 'PPL', 'P'),
(153177, 'Town Pump', 43.151668548584, 0.753138693902073, -77.8555603027344, -1.35883586826771, 218, 40, 'PPL', 'P'),
(69462, 'Town Ranch Heights', 34.7691688537598, 0.606836474679971, -77.4761123657227, -1.35221325242695, 218, 33, 'PPL', 'P'),
(185702, 'Town Talk', 39.2433280944824, 0.684925284689111, -121.029716491699, -2.11236704553543, 218, 6, 'PPL', 'P'),
(98593, 'Town West', 29.663610458374, 0.517727670527651, -95.6308288574219, -1.66907282997322, 218, 51, 'PPL', 'P'),
(206142, 'Towncrest Terrace', 40.622501373291, 0.708996399359846, -111.827781677246, -1.95176298546933, 218, 52, 'PPL', 'P'),
(206143, 'Towne and Country Village', 40.6111106872559, 0.708797594384472, -111.806938171387, -1.95139919766443, 218, 52, 'PPL', 'P'),
(52157, 'Towne Centre Place', 39.1508293151855, 0.683310876436305, -77.0683288574219, -1.34509608757177, 218, 25, 'PPL', 'P'),
(84065, 'Towne Creek Acres', 34.5611114501953, 0.60320518795462, -82.6750030517578, -1.44295101234953, 218, 48, 'PPL', 'P'),
(98594, 'Towne East Colonia Number 1', 26.2999992370605, 0.459021579958703, -98.0950012207031, -1.71208075104913, 218, 51, 'PPL', 'P'),
(91394, 'Towne Hills', 35.1474990844727, 0.61343958286574, -85.2383270263672, -1.48768945550177, 218, 50, 'PPL', 'P'),
(121733, 'Towne Oaks', 40.5833282470703, 0.708312699328996, -89.5480575561523, -1.56290844312025, 218, 18, 'PPL', 'P'),
(14756, 'Towne Point', 39.1777801513672, 0.68378125726384, -75.5166702270508, -1.31801453560481, 218, 10, 'PPL', 'P'),
(168017, 'Towner', 41.8838882446289, 0.731011753406123, -76.3808288574219, -1.33309694896431, 218, 45, 'PPL', 'P'),
(187452, 'Towner', 38.4708290100098, 0.671442632196421, -102.079170227051, -1.7816176181658, 218, 7, 'PPL', 'P'),
(199007, 'Towner', 48.3458290100098, 0.843793895830861, -100.404998779297, -1.75239781415962, 218, 34, 'PPL', 'P'),
(153178, 'Towners', 41.4797210693359, 0.723957705468775, -73.6105575561523, -1.28474659358365, 218, 40, 'PPL', 'P'),
(143205, 'Townhall', 40.5463905334473, 0.707668014608115, -97.4255599975586, -1.70039679755668, 218, 35, 'PPL', 'P'),
(206144, 'Townhouse Condominium', 41.0622215270996, 0.716670963831182, -111.956939697266, -1.95401721817403, 218, 52, 'PPL', 'P'),
(129093, 'Townhouse Corner', 44.3127784729004, 0.773403885058977, -69.0883331298828, -1.20581888783113, 218, 26, 'PPL', 'P'),
(6368, 'Townley', 33.8288917541504, 0.590425543410684, -87.4316711425781, -1.5259705319589, 218, 2, 'PPL', 'P'),
(57931, 'Townley', 36.6166687011719, 0.639081429947405, -89.9697189331055, -1.57026782247657, 218, 29, 'PPL', 'P'),
(123818, 'Townley', 41.0180587768555, 0.715900178432686, -84.8638916015625, -1.48115432450283, 218, 19, 'PPL', 'P'),
(157969, 'Townline (historical)', 41.7097206115723, 0.727971954758879, -83.9986114501953, -1.46605233690932, 218, 41, 'PPL', 'P'),
(25542, 'Towns', 32.0041694641113, 0.558578131514972, -82.7547225952148, -1.44434238086105, 218, 13, 'PPL', 'P'),
(146466, 'Townsbury', 40.850830078125, 0.712981487036014, -74.9338912963867, -1.30784312445347, 218, 37, 'PPL', 'P'),
(14757, 'Townsend', 39.3950004577637, 0.687572466812649, -75.6919403076172, -1.32107357559093, 218, 10, 'PPL', 'P'),
(18365, 'Townsend', 30.1288890838623, 0.525848314481575, -83.3394393920898, -1.45454761415823, 218, 12, 'PPL', 'P'),
(25543, 'Townsend', 31.5391693115234, 0.550462347830037, -81.5227813720703, -1.42284095032613, 218, 13, 'PPL', 'P'),
(62059, 'Townsend', 32.7552795410156, 0.57168747540186, -88.5488891601563, -1.54546966482824, 218, 30, 'PPL', 'P'),
(91395, 'Townsend', 35.6752815246582, 0.622651124181188, -83.7558288574219, -1.46181498129889, 218, 50, 'PPL', 'P'),
(98595, 'Townsend', 31.3508205413818, 0.547175041648984, -94.3117828369141, -1.64605113393003, 218, 51, 'PPL', 'P'),
(106964, 'Townsend', 37.184440612793, 0.648990919205535, -75.958610534668, -1.32572784907001, 218, 53, 'PPL', 'P'),
(126361, 'Townsend', 42.6666717529297, 0.744673902956284, -71.7055587768555, -1.25149809263845, 218, 23, 'PPL', 'P'),
(153179, 'Townsend', 42.3486099243164, 0.739122676822068, -76.956672668457, -1.34314731944411, 218, 40, 'PPL', 'P'),
(176709, 'Townsend', 45.3280601501465, 0.791123893162091, -88.5894393920898, -1.54617739988793, 218, 57, 'PPL', 'P'),
(192826, 'Townsend', 39.9927787780762, 0.698005666699144, -111.827781677246, -1.95176298546933, 218, 52, 'PPL', 'P'),
(197706, 'Townsend', 46.3191719055176, 0.808422056548538, -111.519996643066, -1.94639112323453, 218, 31, 'PPL', 'P'),
(6369, 'Townsend Crossroads', 34.6494407653809, 0.60474682533064, -85.6630630493164, -1.49510249755407, 218, 2, 'PPL', 'P'),
(126362, 'Townsend Harbor', 42.6527786254883, 0.744431422139032, -71.6722183227539, -1.25091619194026, 218, 23, 'PPL', 'P'),
(25545, 'Townsend Mill', 34.920280456543, 0.609473869686503, -83.8672180175781, -1.46375908889465, 218, 13, 'PPL', 'P'),
(52158, 'Townsends Cross Roads', 38.9063911437988, 0.679044625528052, -75.7941665649414, -1.32285776036323, 218, 25, 'PPL', 'P'),
(71481, 'Townsends Inlet', 39.1263885498047, 0.682884304608701, -74.711669921875, -1.30396462979993, 218, 37, 'PPL', 'P'),
(153180, 'Townsendville', 42.5727806091309, 0.743035193358531, -76.7825012207031, -1.34010745421783, 218, 40, 'PPL', 'P'),
(52159, 'Townshend', 38.6650009155273, 0.674831571262574, -76.8672180175781, -1.34158604125505, 218, 25, 'PPL', 'P'),
(172650, 'Townshend', 43.0472183227539, 0.751315693556887, -72.6680603027344, -1.2682969133205, 218, 55, 'PPL', 'P'),
(12375, 'Townsley (historical)', 35.9249992370605, 0.627009520463157, -93.5022201538086, -1.63192159960856, 218, 4, 'PPL', 'P'),
(69587, 'Townsville', 36.4944381713867, 0.636948104756197, -78.4238891601563, -1.36875507806382, 218, 33, 'PPL', 'P'),
(84067, 'Townville', 34.5636100769043, 0.60324879721747, -82.8986129760742, -1.44685374176899, 218, 48, 'PPL', 'P'),
(168018, 'Townville', 41.6777801513672, 0.727414488563698, -79.879997253418, -1.39416895855617, 218, 45, 'PPL', 'P'),
(106965, 'Townwood', 38.0813903808594, 0.664645645883293, -78.4888916015625, -1.36988958468819, 218, 53, 'PPL', 'P'),
(157972, 'Townwood', 41.1094398498535, 0.717495079030507, -83.9005584716797, -1.46434098959283, 218, 41, 'PPL', 'P'),
(52161, 'Towson', 39.4013900756836, 0.687683986683296, -76.6022186279297, -1.33696092938991, 218, 25, 'PPL', 'P'),
(111732, 'Towson (historical)', 39.413330078125, 0.687892379038595, -79.7547225952148, -1.39198250330122, 218, 58, 'PPL', 'P'),
(52162, 'Towson Estates', 39.3974990844727, 0.687616076075499, -76.5791702270508, -1.33655865890725, 218, 25, 'PPL', 'P'),
(52163, 'Towson Park', 39.4072189331055, 0.687785719436937, -76.6055603027344, -1.33701925261778, 218, 25, 'PPL', 'P'),
(172652, 'Towtaid (historical)', 43.8658294677734, 0.765603153330998, -73.1080627441406, -1.27597640463985, 218, 55, 'PPL', 'P'),
(84066, 'Toxaway', 34.4961090087891, 0.602070681330247, -82.6297225952148, -1.44216071929605, 218, 48, 'PPL', 'P'),
(69589, 'Toxaway Falls', 35.1216697692871, 0.612988776272217, -82.9319381713867, -1.44743537615106, 218, 33, 'PPL', 'P'),
(6370, 'Toxey', 31.9127807617188, 0.556983097759096, -88.309440612793, -1.54129049928764, 218, 2, 'PPL', 'P'),
(193198, 'Toy (historical)', 40.0169410705566, 0.698427378257758, -118.672218322754, -2.0712209403776, 218, 39, 'PPL', 'P'),
(192334, 'Toyah', 31.3147201538086, 0.546544971024585, -103.792778015137, -1.81152571615572, 218, 51, 'PPL', 'P'),
(192335, 'Toyahvale', 30.9441699981689, 0.540077650764896, -103.788887023926, -1.81145780554792, 218, 51, 'PPL', 'P'),
(185709, 'Toyanza Subdivision', 38.1877784729004, 0.666502468374324, -120.670829772949, -2.10610329065157, 218, 6, 'PPL', 'P'),
(179375, 'Toyei', 35.7024993896484, 0.623126165540631, -109.9375, -1.91877134641127, 218, 5, 'PPL', 'P'),
(185708, 'Toyon', 38.2050018310547, 0.666803072682367, -120.764442443848, -2.10773713998033, 218, 6, 'PPL', 'P'),
(126364, 'Tozier Corner', 42.7583312988281, 0.746273663823094, -71.17138671875, -1.24217503145235, 218, 23, 'PPL', 'P'),
(153181, 'Toziers Corner', 42.7374992370605, 0.745910075755271, -78.3625030517578, -1.36768368835728, 218, 40, 'PPL', 'P'),
(84068, 'Traber', 34.7727813720703, 0.606899525018778, -82.7072219848633, -1.4435133388137, 218, 48, 'PPL', 'P'),
(185711, 'Trabuco Canyon', 33.6624984741211, 0.58752143282098, -117.58943939209, -2.05232288296629, 218, 6, 'PPL', 'P'),
(185712, 'Trabuco Highlands', 33.6147193908691, 0.586687530504649, -117.565559387207, -2.05190609825569, 218, 6, 'PPL', 'P'),
(12376, 'Trace', 33.8369407653809, 0.590566025158186, -92.9519424438477, -1.62231744176941, 218, 4, 'PPL', 'P'),
(111733, 'Trace', 37.8872184753418, 0.66125670681714, -82.1969375610352, -1.43460719549626, 218, 58, 'PPL', 'P'),
(91397, 'Trace End Estates', 36.0302810668945, 0.628847035036285, -86.9272232055664, -1.51716625455315, 218, 50, 'PPL', 'P'),
(43381, 'Trace Estates', 32.5694389343262, 0.568443944931225, -92.2544403076172, -1.61014373295249, 218, 22, 'PPL', 'P'),
(52164, 'Trace Hollow', 38.3019409179688, 0.668494978922894, -75.5666732788086, -1.31888725349403, 218, 25, 'PPL', 'P'),
(111734, 'Trace Junction', 37.8252792358398, 0.66017566315165, -82.0500030517578, -1.43204270452457, 218, 58, 'PPL', 'P'),
(91398, 'Traceview', 35.9041709899902, 0.626645998974362, -86.9930572509766, -1.51831527540547, 218, 50, 'PPL', 'P'),
(52165, 'Traceys Meadows', 38.8069381713867, 0.677308843708566, -76.5972213745117, -1.33687371086421, 218, 25, 'PPL', 'P'),
(168020, 'Trachsville', 40.8808288574219, 0.713505064506323, -75.5297164916992, -1.31824223587801, 218, 45, 'PPL', 'P'),
(25546, 'Trackrock (historical)', 34.9088897705078, 0.609275064711129, -83.8741683959961, -1.4638803958823, 218, 13, 'PPL', 'P'),
(38571, 'Tracy', 36.7980613708496, 0.642247329272264, -85.9705581665039, -1.50046929978279, 218, 21, 'PPL', 'P'),
(57933, 'Tracy', 37.9799995422363, 0.662876041917963, -93.6549987792969, -1.63458808965, 218, 29, 'PPL', 'P'),
(98596, 'Tracy', 30.7416706085205, 0.536543369682252, -97.0969390869141, -1.69466128067503, 218, 51, 'PPL', 'P'),
(114185, 'Tracy', 41.5022201538086, 0.724350388571507, -72.8122177124023, -1.27081293476035, 218, 8, 'PPL', 'P'),
(118069, 'Tracy', 41.2763900756836, 0.72040891015819, -92.8752822875977, -1.62097946963775, 218, 16, 'PPL', 'P'),
(123820, 'Tracy', 41.485279083252, 0.724054711111481, -86.682502746582, -1.51289507679688, 218, 19, 'PPL', 'P'),
(138467, 'Tracy', 44.2333297729492, 0.7720172436584, -95.6188888549805, -1.66886443761792, 218, 28, 'PPL', 'P'),
(146467, 'Tracy', 40.3027801513672, 0.703416211348776, -74.3838882446289, -1.29824376030428, 218, 37, 'PPL', 'P'),
(168021, 'Tracy', 41.8747215270996, 0.730851764003636, -80.4713897705078, -1.40449070515105, 218, 45, 'PPL', 'P'),
(185724, 'Tracy', 37.7397193908691, 0.658682362149415, -121.424171447754, -2.1192515832694, 218, 6, 'PPL', 'P'),
(197707, 'Tracy', 47.4130592346191, 0.827513992087207, -111.153327941895, -1.93999154713507, 218, 31, 'PPL', 'P'),
(201672, 'Tracy', 45.3027801513672, 0.790682673948493, -122.290000915527, -2.13436315824283, 218, 43, 'PPL', 'P'),
(208971, 'Tracy', 46.0833282470703, 0.804305808188684, -118.187782287598, -2.06276593654881, 218, 56, 'PPL', 'P'),
(209793, 'Tracy', 41.1483306884766, 0.718173852213341, -104.157783508301, -1.8178962637993, 218, 59, 'PPL', 'P'),
(91399, 'Tracy City', 35.2602806091309, 0.615407991806445, -85.7361068725586, -1.49637735276789, 218, 50, 'PPL', 'P'),
(126365, 'Tracy Corner', 41.9388885498047, 0.731971689821042, -71.0541687011719, -1.24012919110295, 218, 23, 'PPL', 'P'),
(153182, 'Tracy Creek', 42.0194396972656, 0.733377572560495, -76.0802764892578, -1.32785132056518, 218, 40, 'PPL', 'P'),
(52166, 'Tracys Landing', 38.7799987792969, 0.676838662618112, -76.5961074829102, -1.33685426978825, 218, 25, 'PPL', 'P'),
(208970, 'Tracyton', 47.6091690063477, 0.830936753299204, -122.65389251709, -2.14071426481045, 218, 56, 'PPL', 'P'),
(6371, 'Trade', 34.0661087036133, 0.594565760220349, -87.0905609130859, -1.52001703534203, 218, 2, 'PPL', 'P'),
(91400, 'Trade', 36.3491706848145, 0.634412708819414, -81.7458267211914, -1.42673382604955, 218, 50, 'PPL', 'P'),
(168022, 'Trade City', 40.8786087036133, 0.713466315512463, -79.0747222900391, -1.38011425906133, 218, 45, 'PPL', 'P'),
(176711, 'Trade Lake', 45.6897201538086, 0.79743605099877, -92.5927810668945, -1.61604889319558, 218, 57, 'PPL', 'P'),
(176713, 'Trade River', 45.6483306884766, 0.796713668553086, -92.6725006103516, -1.61744026170709, 218, 57, 'PPL', 'P'),
(6372, 'Trade Winds Trailer Park', 30.2627792358398, 0.528185138469579, -88.1152801513672, -1.53790175995856, 218, 2, 'PPL', 'P'),
(57934, 'Traderight', 38.1116714477539, 0.66517415020162, -92.1975021362305, -1.60914997439173, 218, 29, 'PPL', 'P'),
(25547, 'Traders Hill', 30.7794399261475, 0.537202568631074, -82.0311126708984, -1.43171300518162, 218, 13, 'PPL', 'P'),
(31319, 'Traders Point', 39.8936080932617, 0.696274811727674, -86.3027801513672, -1.50626766726617, 218, 19, 'PPL', 'P'),
(74561, 'Tradersville', 39.9997215270996, 0.698126840528742, -83.4986114501953, -1.45732569064935, 218, 41, 'PPL', 'P'),
(84069, 'Tradesville', 34.7686080932617, 0.606826687562965, -80.5472183227539, -1.40581416305476, 218, 48, 'PPL', 'P'),
(168025, 'Tradesville', 40.2708282470703, 0.702858545416513, -75.163330078125, -1.31184758662657, 218, 45, 'PPL', 'P'),
(98597, 'Tradewinds', 27.9902801513672, 0.488522547196974, -97.2616729736328, -1.69753642938788, 218, 51, 'PPL', 'P'),
(98598, 'Tradewinds Estates Colonia', 27.9909992218018, 0.488535097343611, -97.2620010375977, -1.69754215518422, 218, 51, 'PPL', 'P'),
(69590, 'Trading Ford', 35.6949996948242, 0.622995271173054, -80.3724975585938, -1.40276471044857, 218, 33, 'PPL', 'P'),
(34187, 'Trading Post', 38.2486114501953, 0.667564204121911, -94.6805572509766, -1.65248746165253, 218, 20, 'PPL', 'P'),
(118063, 'Traer', 42.1936111450195, 0.736417437786765, -92.4652786254883, -1.61382355578871, 218, 16, 'PPL', 'P'),
(187933, 'Traer', 39.9283294677734, 0.696880814033722, -100.665832519531, -1.756950221727, 218, 20, 'PPL', 'P'),
(12377, 'Trafalgar', 33.3541717529297, 0.582140116364312, -91.5950012207031, -1.59863434966949, 218, 4, 'PPL', 'P'),
(31317, 'Trafalgar', 39.4161109924316, 0.687940915149462, -86.1508331298828, -1.50361569145267, 218, 19, 'PPL', 'P'),
(6373, 'Trafford', 33.8180618286133, 0.590236525552316, -86.7427825927734, -1.51394715858552, 218, 2, 'PPL', 'P'),
(168023, 'Trafford', 40.3855590820313, 0.704860976240144, -79.7591705322266, -1.39206013444699, 218, 45, 'PPL', 'P'),
(208972, 'Trafton', 48.2372207641602, 0.84189832434597, -122.057220458984, -2.13030037284186, 218, 56, 'PPL', 'P'),
(185728, 'Tragedy Spring (historical)', 38.6388893127441, 0.674375837821034, -120.143608093262, -2.09690153645312, 218, 6, 'PPL', 'P'),
(57935, 'Trail', 36.7680587768555, 0.641723685222927, -92.2955627441406, -1.61086145486627, 218, 29, 'PPL', 'P'),
(77485, 'Trail', 35.9686088562012, 0.627770651902702, -99.29638671875, -1.73304888357576, 218, 42, 'PPL', 'P'),
(138469, 'Trail', 47.7799987792969, 0.833918295297602, -95.6919403076172, -1.6701394259898, 218, 28, 'PPL', 'P'),
(157973, 'Trail', 40.5902786254883, 0.708434006316649, -81.7063903808594, -1.42604553206582, 218, 41, 'PPL', 'P'),
(201673, 'Trail', 42.648609161377, 0.744358651262245, -122.809440612793, -2.14342909122568, 218, 43, 'PPL', 'P'),
(18366, 'Trail Center', 25.8044395446777, 0.450372431686453, -80.876106262207, -1.41155434046832, 218, 12, 'PPL', 'P'),
(18367, 'Trail City', 25.7602806091309, 0.449601712866984, -80.9963912963867, -1.41365371035563, 218, 12, 'PPL', 'P'),
(202693, 'Trail City', 45.4724998474121, 0.79364484144996, -100.724998474121, -1.75798286243968, 218, 49, 'PPL', 'P'),
(25553, 'Trail Creek', 33.7577781677246, 0.589184377184653, -84.6641693115234, -1.47766851295202, 218, 13, 'PPL', 'P'),
(123821, 'Trail Creek', 41.6983299255371, 0.727773149783504, -86.8591690063477, -1.51597848470698, 218, 19, 'PPL', 'P'),
(25548, 'Trail Creek Estates Mobile Home Park', 34.0161094665527, 0.593693108910157, -83.3263931274414, -1.45431991388503, 218, 13, 'PPL', 'P'),
(201674, 'Trail Fork (historical)', 45.1041717529297, 0.787216303473645, -120.065277099609, -2.09553440270753, 218, 43, 'PPL', 'P'),
(179376, 'Trail Inn Lodge', 33.4516716003418, 0.583841809721845, -112.123611450195, -1.95692618903272, 218, 5, 'PPL', 'P'),
(187453, 'Trail Junction Picnic Grounds', 38.9027786254883, 0.678981575189245, -104.913330078125, -1.83108303909488, 218, 7, 'PPL', 'P'),
(179381, 'Trail Riders Holiday Park', 33.4174995422363, 0.583245394795722, -111.775833129883, -1.95085631227621, 218, 5, 'PPL', 'P'),
(74562, 'Trail Run (historical)', 39.6166687011719, 0.691441307507235, -81.0491714477539, -1.41457489777669, 218, 41, 'PPL', 'P'),
(179377, 'Trail-R-Dale Mobile Home Park', 33.4249992370605, 0.583376289163299, -112.349166870117, -1.96086287375608, 218, 5, 'PPL', 'P'),
(197708, 'Trailcreek', 48.9191703796387, 0.853800590468779, -114.406387329102, -1.99676814420474, 218, 31, 'PPL', 'P'),
(179378, 'Trailer Corral', 33.452220916748, 0.583851397101769, -112.146667480469, -1.95732859267343, 218, 5, 'PPL', 'P'),
(18368, 'Trailer Estates', 27.4241695404053, 0.478642053105212, -82.5802764892578, -1.44129772194481, 218, 12, 'PPL', 'P'),
(185729, 'Trailer Rancho Mobile Home Park', 37.4869384765625, 0.654270502908563, -122.189720153809, -2.13261292877443, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(199729, 'Trailerville Court', 42.1016693115234, 0.734812750071938, -102.871673583984, -1.7954494110774, 218, 35, 'PPL', 'P'),
(179379, 'Trailing R Mobile Park', 33.417781829834, 0.583250321643738, -111.641937255859, -1.94851938841967, 218, 5, 'PPL', 'P'),
(121734, 'Trailpark Gardens', 40.7338905334473, 0.710940506955604, -89.5183334350586, -1.5623896593399, 218, 18, 'PPL', 'P'),
(25549, 'Trailridge', 33.9419403076172, 0.592398612883297, -84.3447189331055, -1.47209305205189, 218, 13, 'PPL', 'P'),
(52172, 'Trails', 38.7200012207031, 0.675791507677493, -76.5658264160156, -1.33632576546992, 218, 25, 'PPL', 'P'),
(114186, 'Trails Corner', 41.3413887023926, 0.721543350203537, -72.0577774047852, -1.25764546738268, 218, 8, 'PPL', 'P'),
(25550, 'Trails End', 32.8544387817383, 0.573418130636248, -83.7763900756836, -1.46217384225578, 218, 13, 'PPL', 'P'),
(31318, 'Trails End', 39.9541702270508, 0.697331820364327, -86.0658264160156, -1.50213204440938, 218, 19, 'PPL', 'P'),
(91401, 'Trails End', 35.9541702270508, 0.627518650284553, -84.10888671875, -1.46797700342912, 218, 50, 'PPL', 'P'),
(197709, 'Trails End Trailer Court', 48.776668548584, 0.851313464326754, -104.574996948242, -1.82517801200985, 218, 31, 'PPL', 'P'),
(52167, 'Trails End Trailer Park', 38.8938903808594, 0.678826446055747, -76.6708297729492, -1.33815841977406, 218, 25, 'PPL', 'P'),
(91402, 'Trails West', 35.9147186279297, 0.626830089984713, -84.0522232055664, -1.46698803855832, 218, 50, 'PPL', 'P'),
(179380, 'Trails West Mobile Home Park', 33.4099998474121, 0.583114500428144, -111.589172363281, -1.94759846731472, 218, 5, 'PPL', 'P'),
(195725, 'Trailton (historical)', 43.1300010681152, 0.752760525027282, -111.911109924316, -1.95321733774062, 218, 17, 'PPL', 'P'),
(18369, 'Trailtown', 25.8555603027344, 0.451264657230657, -81.0233306884766, -1.41412389144608, 218, 12, 'PPL', 'P'),
(12378, 'Trailwood Addition', 34.975830078125, 0.610443393481347, -91.9591674804688, -1.60499024992708, 218, 4, 'PPL', 'P'),
(79275, 'Trainer', 39.8274993896484, 0.695120997185397, -75.4147186279297, -1.31623514452247, 218, 45, 'PPL', 'P'),
(111736, 'Trainer', 38.0397186279297, 0.663918336589593, -80.0319366455078, -1.39682080121162, 218, 58, 'PPL', 'P'),
(126366, 'Trainfield', 42.1408309936523, 0.735496250365707, -72.754997253418, -1.26981424935157, 218, 23, 'PPL', 'P'),
(129094, 'Trainor Corner', 44.2197189331055, 0.771779689689165, -69.6588897705078, -1.21577697977916, 218, 26, 'PPL', 'P'),
(25551, 'Traisville', 31.059440612793, 0.542089502520883, -82.6852798461914, -1.44313037624895, 218, 13, 'PPL', 'P'),
(62064, 'Tralake', 33.2702789306641, 0.580675910396986, -90.7947235107422, -1.58466686870036, 218, 30, 'PPL', 'P'),
(111735, 'Tralee', 37.5572204589844, 0.655497154906653, -81.4008331298828, -1.42071255198294, 218, 58, 'PPL', 'P'),
(38572, 'Tram', 37.5733299255371, 0.655778318138738, -82.6463928222656, -1.44245166964514, 218, 21, 'PPL', 'P'),
(25552, 'Tramlin Acres', 33.8486099243164, 0.59076969040255, -83.4358291625977, -1.45622993301883, 218, 13, 'PPL', 'P'),
(38573, 'Trammel', 36.7852783203125, 0.642024222951942, -86.3533325195313, -1.50714997253531, 218, 21, 'PPL', 'P'),
(106966, 'Trammel', 37.0144386291504, 0.646023824856051, -82.2938919067383, -1.4362993680529, 218, 53, 'PPL', 'P'),
(106967, 'Trammel (historical)', 36.9916687011719, 0.645626414642384, -82.2936096191406, -1.43629444120488, 218, 53, 'PPL', 'P'),
(6374, 'Trammel Crossroads', 32.9711112976074, 0.57545445018475, -85.5352783203125, -1.49287223329918, 218, 2, 'PPL', 'P'),
(12379, 'Trammell (historical)', 36.2944412231445, 0.63345749951543, -94.4705581665039, -1.64882228620231, 218, 4, 'PPL', 'P'),
(98599, 'Trammels', 29.5344390869141, 0.515473204796358, -95.5372161865234, -1.66743898064445, 218, 51, 'PPL', 'P'),
(106968, 'Trammeltown (historical)', 39.0666694641113, 0.681842009937071, -77.6388931274414, -1.35505431267785, 218, 53, 'PPL', 'P'),
(189710, 'Trampas', 36.1311111450195, 0.630606851884609, -105.758331298828, -1.84583109257952, 218, 38, 'PPL', 'P'),
(69592, 'Tramway', 35.4444389343262, 0.618622160926062, -79.2147216796875, -1.38255770936148, 218, 33, 'PPL', 'P'),
(84070, 'Tramway', 33.0502815246582, 0.576836231316337, -80.1430587768555, -1.39876024827547, 218, 48, 'PPL', 'P'),
(195726, 'Tramway', 46.2847213745117, 0.807820781353425, -116.106941223145, -2.0264484087634, 218, 17, 'PPL', 'P'),
(185733, 'Trancas', 34.0311088562012, 0.593954897645312, -118.842216491699, -2.07418796814806, 218, 6, 'PPL', 'P'),
(62065, 'Tranquil', 33.9422187805176, 0.592403473152286, -88.5994415283203, -1.54635197009739, 218, 30, 'PPL', 'P'),
(84080, 'Tranquil Acres', 32.9583282470703, 0.575231343864428, -80.1569366455078, -1.39900246277661, 218, 48, 'PPL', 'P'),
(84071, 'Tranquil Estates', 32.9674987792969, 0.575391399845942, -80.1430587768555, -1.39876024827547, 218, 48, 'PPL', 'P'),
(69594, 'Tranquil Hill', 35.9816703796387, 0.627998618492013, -81.5586090087891, -1.42346626055008, 218, 33, 'PPL', 'P'),
(52170, 'Tranquility', 39.3458290100098, 0.686714263151371, -77.2608337402344, -1.34845593160302, 218, 25, 'PPL', 'P'),
(69595, 'Tranquility', 35.2750015258789, 0.615664920272611, -82.4663925170898, -1.43931007166523, 218, 33, 'PPL', 'P'),
(74563, 'Tranquility', 38.9625015258789, 0.680023936439902, -83.5330581665039, -1.45792689926543, 218, 41, 'PPL', 'P'),
(146468, 'Tranquility', 40.9561080932617, 0.714818935030114, -74.8088912963867, -1.30566146288848, 218, 37, 'PPL', 'P'),
(52171, 'Tranquility Estates', 39.6502799987793, 0.692027935316352, -77.1355590820313, -1.34626947634806, 218, 25, 'PPL', 'P'),
(18370, 'Tranquility Park', 28.0083293914795, 0.488837565864417, -81.7455596923828, -1.42672916551764, 218, 12, 'PPL', 'P'),
(91403, 'Tranquillity', 35.5574989318848, 0.620595430135756, -84.6774978637695, -1.47790114007324, 218, 50, 'PPL', 'P'),
(185734, 'Tranquillity', 36.6488914489746, 0.639643822990602, -120.251670837402, -2.09878758713712, 218, 6, 'PPL', 'P'),
(25555, 'Transco', 34.1500015258789, 0.596029966187674, -83.1449966430664, -1.45115394798114, 218, 13, 'PPL', 'P'),
(106971, 'Transco Village', 36.8313903808594, 0.642829030233364, -79.334716796875, -1.38465201924272, 218, 53, 'PPL', 'P'),
(168026, 'Transfer', 41.3288917541504, 0.721325237310259, -80.4330596923828, -1.40382171908522, 218, 45, 'PPL', 'P'),
(195727, 'Transfer', 46.4291687011719, 0.810341862799349, -117.029441833496, -2.0425490817657, 218, 17, 'PPL', 'P'),
(69596, 'Transou', 36.4038887023926, 0.635367718386317, -81.3005599975586, -1.41896245567259, 218, 33, 'PPL', 'P'),
(206147, 'Transwest Hollow', 40.663890838623, 0.70971878180553, -111.966110229492, -1.95417727415554, 218, 52, 'PPL', 'P'),
(43382, 'Transylvania', 32.6783294677734, 0.570344443264133, -91.182502746582, -1.59143489313663, 218, 22, 'PPL', 'P'),
(38574, 'Transylvania Beach', 38.3411102294922, 0.669178612374717, -85.6399993896484, -1.4946999607553, 218, 21, 'PPL', 'P'),
(106969, 'Trantwood Shores', 36.8691711425781, 0.643488428919268, -76.0519409179688, -1.32735677155075, 218, 53, 'PPL', 'P'),
(69598, 'Trap', 36.2066688537598, 0.631925582677389, -76.8711090087891, -1.34165395186284, 218, 33, 'PPL', 'P'),
(129095, 'Trap Corner', 44.3313903808594, 0.773728724132939, -70.5558319091797, -1.23143157329886, 218, 26, 'PPL', 'P'),
(111737, 'Trap Hill', 37.7827796936035, 0.659433906209036, -81.3436126708984, -1.41971386657416, 218, 58, 'PPL', 'P'),
(69601, 'Traphill', 36.3463897705078, 0.634364172708548, -81.0327835083008, -1.41428887427561, 218, 33, 'PPL', 'P'),
(18371, 'Trapnell', 27.9666690826416, 0.488110456307798, -82.1047210693359, -1.43299771409147, 218, 12, 'PPL', 'P'),
(38575, 'Trapp', 37.8833312988281, 0.661188862788371, -84.0550003051758, -1.46703650809016, 218, 21, 'PPL', 'P'),
(62072, 'Trapp', 32.7394409179688, 0.571411039280709, -89.2136077880859, -1.55707119348496, 218, 30, 'PPL', 'P'),
(106970, 'Trapp', 39.0580596923828, 0.681691741072564, -77.8658294677734, -1.35901509900907, 218, 53, 'PPL', 'P'),
(106973, 'Trapp Hill', 39.1652793884277, 0.683563077791535, -77.9775009155273, -1.36096413345284, 218, 53, 'PPL', 'P'),
(52174, 'Trappe', 38.3141708374023, 0.668708431284264, -75.1911087036133, -1.31233241510302, 218, 25, 'PPL', 'P'),
(168027, 'Trappe', 40.1988906860352, 0.701602998120596, -75.4766693115234, -1.31731638792505, 218, 45, 'PPL', 'P'),
(52175, 'Trappe Landing', 38.6561088562012, 0.67467637555005, -76.0852813720703, -1.32793867224894, 218, 25, 'PPL', 'P'),
(194454, 'Trapper', 40.103889465332, 0.699944914025912, -106.879173278809, -1.86539347552475, 218, 7, 'PPL', 'P'),
(212197, 'Trapper Creek', 62.3166694641113, 1.08763106102575, -150.231384277344, -2.62203229546849, 218, 1, 'PPL', 'P'),
(6375, 'Trapptown', 34.3713912963867, 0.59989394661327, -87.6183319091797, -1.52922837692039, 218, 2, 'PPL', 'P'),
(144570, 'Trapshire', 43.1949996948242, 0.753894965072628, -72.4388885498047, -1.26429711167931, 218, 36, 'PPL', 'P'),
(57936, 'Trask', 36.9775009155273, 0.64537914013517, -91.8013916015625, -1.60223654135994, 218, 29, 'PPL', 'P'),
(197710, 'Trask', 46.1027793884277, 0.804645294648642, -112.416389465332, -1.96203612937431, 218, 31, 'PPL', 'P'),
(12380, 'Traskwood', 34.4491691589355, 0.601251426399911, -92.6538925170898, -1.61711548921215, 218, 4, 'PPL', 'P'),
(123822, 'Tratebas Mill', 41.563060760498, 0.725412257477149, -87.0177764892578, -1.51874670750206, 218, 19, 'PPL', 'P'),
(168029, 'Trauger', 40.232780456543, 0.702194486198702, -79.4627838134766, -1.38688721034562, 218, 45, 'PPL', 'P'),
(138472, 'Traulich Estates', 44.3388900756836, 0.773859618500516, -94.4861068725586, -1.64909366231739, 218, 28, 'PPL', 'P'),
(133425, 'Traunik', 46.2608299255371, 0.807403796905746, -86.9694366455078, -1.51790301806872, 218, 27, 'PPL', 'P'),
(84072, 'Traus (historical)', 33.9694404602051, 0.592878581090756, -81.7344436645508, -1.42653515423223, 218, 48, 'PPL', 'P'),
(6377, 'Travelers Rest', 32.8194389343262, 0.572807268061211, -86.3305587768555, -1.50675249574262, 218, 2, 'PPL', 'P'),
(25556, 'Travelers Rest', 32.2811088562012, 0.563411635735411, -84.0288925170898, -1.46658084122764, 218, 13, 'PPL', 'P'),
(84073, 'Travelers Rest', 34.9674987792969, 0.610297984885828, -82.4436111450195, -1.43891246171448, 218, 48, 'PPL', 'P'),
(38576, 'Travellers Rest', 37.4483299255371, 0.653596656573746, -83.7872161865234, -1.46236279353512, 218, 21, 'PPL', 'P'),
(197711, 'Travellers Rest Trailer Court', 46.7533302307129, 0.81599954879814, -114.080558776855, -1.99108136317104, 218, 31, 'PPL', 'P'),
(185735, 'Travelodge Mobile Home Park', 37.4000015258789, 0.65275316687749, -122.074722290039, -2.13060583741889, 218, 6, 'PPL', 'P'),
(185737, 'Traver', 36.4552803039551, 0.636264671041455, -119.48388671875, -2.08538722632211, 218, 6, 'PPL', 'P'),
(57937, 'Travers', 36.7436103820801, 0.641296980237269, -93.8363876342773, -1.63775392239583, 218, 29, 'PPL', 'P'),
(209869, 'Travers', 42.6091690063477, 0.743670290699487, -113.736106872559, -1.9850695433263, 218, 17, 'PPL', 'P'),
(153184, 'Travers Corners', 43.1566696166992, 0.753225979006801, -73.73388671875, -1.28689909353471, 218, 40, 'PPL', 'P'),
(133426, 'Traverse', 47.2552795410156, 0.824760216941037, -88.2641677856445, -1.54050033939221, 218, 27, 'PPL', 'P'),
(138473, 'Traverse', 44.3486099243164, 0.774029261861955, -94.017219543457, -1.64091003460369, 218, 28, 'PPL', 'P'),
(133427, 'Traverse Bay', 47.1944389343262, 0.823698348035396, -88.23388671875, -1.53997183507388, 218, 27, 'PPL', 'P'),
(133428, 'Traverse City', 44.7630615234375, 0.781262806856773, -85.6205596923828, -1.49436067403242, 218, 27, 'PPL', 'P'),
(52176, 'Travilah', 39.0688896179199, 0.681880758930932, -77.2633285522461, -1.34849947428684, 218, 25, 'PPL', 'P'),
(52177, 'Travilah Acres', 39.0872192382813, 0.682200671156878, -77.2694396972656, -1.3486061338885, 218, 25, 'PPL', 'P'),
(52178, 'Travilah Meadows', 39.0666694641113, 0.681842009937071, -77.2708282470703, -1.34863036865442, 218, 25, 'PPL', 'P'),
(69603, 'Travis', 35.8974990844727, 0.626529552255698, -76.3244400024414, -1.33211277778347, 218, 33, 'PPL', 'P'),
(91404, 'Travis', 36.1877784729004, 0.631595883334437, -86.6074981689453, -1.51158599996306, 218, 50, 'PPL', 'P'),
(98600, 'Travis', 31.1352806091309, 0.543413160161679, -97.0025024414063, -1.69301305027638, 218, 51, 'PPL', 'P'),
(153183, 'Travis', 40.5930595397949, 0.708482542427516, -74.1883316040039, -1.29483065305123, 218, 40, 'PPL', 'P'),
(98603, 'Travis and Vermillion Colonia', 25.931999206543, 0.452598767778732, -97.4189987182617, -1.7002822816298, 218, 51, 'PPL', 'P'),
(6376, 'Travis Bridge', 31.4541702270508, 0.548978833944809, -86.7888870239258, -1.51475183270889, 218, 2, 'PPL', 'P'),
(185738, 'Travis Field', 38.2722206115723, 0.667976261721574, -121.931671142578, -2.12810912389694, 218, 6, 'PPL', 'P'),
(106972, 'Travis Mill', 38.1483306884766, 0.665813974653511, -77.3269424438477, -1.34960974614529, 218, 53, 'PPL', 'P'),
(98602, 'Travis Road Colonia', 25.931999206543, 0.452598767778732, -97.3929977416992, -1.69982847898005, 218, 51, 'PPL', 'P'),
(91405, 'Travisville', 36.5844383239746, 0.638518903746153, -84.9938888549805, -1.48342320459352, 218, 50, 'PPL', 'P'),
(123823, 'Travisville', 40.6919403076172, 0.710208337392914, -85.2080612182617, -1.48716121749956, 218, 19, 'PPL', 'P'),
(197712, 'Travois Village', 46.8872184753418, 0.81833633949663, -114.019996643066, -1.99002435453439, 218, 31, 'PPL', 'P'),
(98604, 'Trawick', 31.7708301544189, 0.554505592286509, -94.7430572509766, -1.65357829243503, 218, 51, 'PPL', 'P'),
(6378, 'Trawick Road Estates', 31.1966705322266, 0.544484616447245, -85.4625015258789, -1.49160203861726, 218, 2, 'PPL', 'P'),
(18377, 'Traxler', 29.8705596923828, 0.521339616045585, -82.540283203125, -1.4405997074231, 218, 12, 'PPL', 'P'),
(62066, 'Traxler', 32.0097198486328, 0.558675003999624, -89.6494369506836, -1.56467784734849, 218, 30, 'PPL', 'P'),
(118064, 'Traxler (historical)', 41.0277786254883, 0.716069821794124, -91.5805587768555, -1.59838228147232, 218, 16, 'PPL', 'P'),
(168030, 'Traymore', 40.230281829834, 0.702150876935852, -75.0661087036133, -1.31015075353802, 218, 45, 'PPL', 'P'),
(91406, 'Treadway', 36.4186096191406, 0.635624646852482, -83.2244415283203, -1.45254052280269, 218, 50, 'PPL', 'P'),
(157975, 'Treadway (historical)', 41.7122192382813, 0.728015564021729, -83.8805618286133, -1.46399198233198, 218, 41, 'PPL', 'P'),
(25557, 'Treadwell', 34.7833290100098, 0.60708361602913, -84.8708267211914, -1.48127536517437, 218, 13, 'PPL', 'P'),
(106974, 'Treadwell', 39.1477813720703, 0.68325767979353, -77.9649963378906, -1.36074588740151, 218, 53, 'PPL', 'P'),
(153185, 'Treadwell', 42.3422203063965, 0.739011156951421, -75.0516662597656, -1.30989868534085, 218, 40, 'PPL', 'P'),
(187454, 'Treasure', 37.3125, 0.651225977150384, -106.964996337891, -1.86689137047987, 218, 7, 'PPL', 'P'),
(190846, 'Treasure City (historical)', 39.2297210693359, 0.684687797298903, -115.47917175293, -2.01549176456465, 218, 39, 'PPL', 'P'),
(18372, 'Treasure Hill Park', 30.3238906860352, 0.529251734486156, -87.4066696166992, -1.52553417301429, 218, 12, 'PPL', 'P'),
(18373, 'Treasure Island', 27.7688903808594, 0.484658566771378, -82.769172668457, -1.44459458221628, 218, 12, 'PPL', 'P'),
(43383, 'Treasure Island', 32.5833282470703, 0.568686359169449, -92.0652770996094, -1.60684221214912, 218, 22, 'PPL', 'P'),
(168031, 'Treasure Lake', 41.1733283996582, 0.718610144578923, -78.7161102294922, -1.37385529786743, 218, 45, 'PPL', 'P'),
(52179, 'Treasure Mountain', 39.3583297729492, 0.686932442623676, -77.1991729736328, -1.34737974820651, 218, 25, 'PPL', 'P'),
(195728, 'Treasureton', 42.2652816772461, 0.737668324550776, -111.845558166504, -1.95207324373633, 218, 17, 'PPL', 'P'),
(12382, 'Treat', 35.6124992370605, 0.621555366550675, -93.1611099243164, -1.62596810299169, 218, 4, 'PPL', 'P'),
(43384, 'Treat', 32.7933311462402, 0.572351601198698, -93.4086074829102, -1.6302877502798, 218, 22, 'PPL', 'P'),
(25558, 'Treat (historical)', 33.9013900756836, 0.591690877823608, -85.3661117553711, -1.48991971975666, 218, 13, 'PPL', 'P'),
(157976, 'Treaton', 40.8277816772461, 0.712579216553357, -82.2305603027344, -1.43519402304246, 218, 41, 'PPL', 'P'),
(123824, 'Treaty', 40.7244415283203, 0.710775590705101, -85.7825012207031, -1.49718708689732, 218, 19, 'PPL', 'P'),
(52180, 'Trebee Highlands', 39.5855598449707, 0.690898355539995, -76.9402770996094, -1.34286116278498, 218, 25, 'PPL', 'P'),
(74564, 'Trebein', 39.7055587768555, 0.69299273200026, -83.9852828979492, -1.4658197097881, 218, 41, 'PPL', 'P'),
(62068, 'Trebloc', 33.8411102294922, 0.590638796034972, -88.8302764892578, -1.55038080019446, 218, 30, 'PPL', 'P'),
(6379, 'Tredegar', 33.8525009155273, 0.590837601010347, -85.7736129760742, -1.49703195776383, 218, 2, 'PPL', 'P'),
(106975, 'Tredway (historical)', 37.2347183227539, 0.649868430784716, -78.5219421386719, -1.3704664253803, 218, 53, 'PPL', 'P'),
(206149, 'Tree Farm Estates', 40.5994415283203, 0.708593929140108, -111.799438476563, -1.95126830329685, 218, 52, 'PPL', 'P'),
(69605, 'Tree Haven', 35.3311080932617, 0.616644164605433, -82.5102767944336, -1.44007599679474, 218, 33, 'PPL', 'P'),
(126367, 'Tree of Knowledge Corner', 42.0291709899902, 0.733547415659014, -70.7333297729492, -1.2345294954369, 218, 23, 'PPL', 'P'),
(123825, 'Tree Spring', 40.0966682434082, 0.699818879927324, -87.4330596923828, -1.52599476672482, 218, 19, 'PPL', 'P'),
(52181, 'Tree Top Station', 39.4677810668945, 0.68884272807359, -76.8072204589844, -1.34053888631443, 218, 25, 'PPL', 'P'),
(14758, 'Tree Top Valley', 39.7750015258789, 0.694204736612355, -75.6833267211914, -1.32092324014739, 218, 10, 'PPL', 'P'),
(52182, 'Tree Tops', 39.0902786254883, 0.682254067536734, -76.4588928222656, -1.33445942217799, 218, 25, 'PPL', 'P'),
(34188, 'Treece', 37.0008316040039, 0.645786337465843, -94.8430633544922, -1.65532372821347, 218, 20, 'PPL', 'P'),
(52184, 'Treelin Manor', 39.6502799987793, 0.692027935316352, -76.8708267211914, -1.34164902501483, 218, 25, 'PPL', 'P'),
(168033, 'Treemont', 40.297779083252, 0.703328926244049, -76.9538879394531, -1.34309871675421, 218, 45, 'PPL', 'P'),
(208973, 'Treemont', 47.6258316040039, 0.83122757049024, -122.61833190918, -2.14009361511841, 218, 56, 'PPL', 'P'),
(43385, 'Trees', 32.7874984741211, 0.57224980186603, -94.0308303833008, -1.64114758857292, 218, 22, 'PPL', 'P'),
(168034, 'Trees Mills', 40.4308280944824, 0.705651069556543, -79.5458297729492, -1.3883366357689, 218, 45, 'PPL', 'P'),
(25559, 'Treetop', 33.8944396972656, 0.591569570835955, -84.4486083984375, -1.47390626528007, 218, 13, 'PPL', 'P'),
(69606, 'Treetops', 35.5505599975586, 0.620474322885185, -77.3836135864258, -1.35059884417415, 218, 33, 'PPL', 'P'),
(52186, 'Treeview Estates', 38.6766700744629, 0.675035236506938, -77.0041732788086, -1.34397636149145, 218, 25, 'PPL', 'P'),
(91407, 'Treeville', 36.0027809143066, 0.628367066828825, -84.0833282470703, -1.46753092394653, 218, 50, 'PPL', 'P'),
(129096, 'Trefethen', 43.6686096191406, 0.762161017622071, -70.1911087036133, -1.2250659525033, 218, 26, 'PPL', 'P'),
(52187, 'Trego', 39.4330596923828, 0.688236725767542, -77.6783294677734, -1.35574260666158, 218, 25, 'PPL', 'P'),
(176714, 'Trego', 45.8997192382813, 0.801101226448992, -91.8208312988281, -1.60257582808281, 218, 57, 'PPL', 'P'),
(197714, 'Trego', 48.7052803039551, 0.850067504410761, -114.86833190918, -2.00483059808885, 218, 31, 'PPL', 'P'),
(200241, 'Trego', 40.764720916748, 0.711478598653855, -119.142776489258, -2.07943372970524, 218, 39, 'PPL', 'P'),
(34189, 'Trego Center', 38.8855590820313, 0.678681037460229, -99.8913879394531, -1.74343361393041, 218, 20, 'PPL', 'P'),
(201675, 'Treharne', 45.8419418334961, 0.800092820502233, -123.218612670898, -2.15057049084678, 218, 43, 'PPL', 'P'),
(106976, 'Treherneville', 37.4269409179688, 0.653223347967944, -75.8905563354492, -1.32454007922383, 218, 53, 'PPL', 'P'),
(98610, 'Treichel', 30.0813903808594, 0.525019305723747, -95.6513900756836, -1.66943169093011, 218, 51, 'PPL', 'P'),
(168035, 'Treichlers', 40.7341690063477, 0.710945367224594, -75.5441665649414, -1.31849443723324, 218, 45, 'PPL', 'P'),
(25560, 'Treillage', 33.3813896179199, 0.582615157723755, -84.5513916015625, -1.47570017059035, 218, 13, 'PPL', 'P'),
(57938, 'Treloar', 38.6444396972656, 0.674472710305686, -91.1877822875977, -1.59152703851035, 218, 29, 'PPL', 'P'),
(209794, 'Trelona (historical)', 41.7727813720703, 0.729072572658381, -104.432502746582, -1.82269101902588, 218, 59, 'PPL', 'P'),
(209795, 'Tremain', 41.5522193908691, 0.725223039881699, -104.108329772949, -1.81703313329, 218, 59, 'PPL', 'P'),
(179382, 'Tremaine', 33.3588905334473, 0.582222474621022, -111.831672668457, -1.95183089607713, 218, 5, 'PPL', 'P'),
(133430, 'Tremaine Corners', 42.9005584716797, 0.748755996275157, -85.0747222900391, -1.48483401418099, 218, 27, 'PPL', 'P'),
(176716, 'Tremble', 44.6380615234375, 0.77908114529178, -88.0694427490234, -1.53710174636711, 218, 57, 'PPL', 'P'),
(189711, 'Trementina', 35.4697189331055, 0.619063380139661, -104.527221679688, -1.82434417627254, 218, 38, 'PPL', 'P'),
(146469, 'Tremley', 40.6130599975586, 0.708831616267398, -74.2302780151367, -1.2955627560349, 218, 37, 'PPL', 'P'),
(146470, 'Tremley Point', 40.6016693115234, 0.708632811292023, -74.2052764892578, -1.29512639709029, 218, 37, 'PPL', 'P'),
(157977, 'Tremleys (historical)', 40.0291709899902, 0.698640830619128, -81.9936065673828, -1.43105840018568, 218, 41, 'PPL', 'P'),
(25561, 'Tremont', 32.0052795410156, 0.558597506011902, -83.6438903808594, -1.45986128632321, 218, 13, 'PPL', 'P'),
(38577, 'Tremont', 36.8438911437988, 0.643047209705669, -83.397216796875, -1.45555602010499, 218, 21, 'PPL', 'P'),
(43386, 'Tremont', 32.5191688537598, 0.567566566510098, -92.454719543457, -1.61363926504127, 218, 22, 'PPL', 'P'),
(62069, 'Tremont', 34.2347183227539, 0.597508553224886, -88.2586135864258, -1.54040340032853, 218, 30, 'PPL', 'P'),
(84075, 'Tremont', 34.3136100769043, 0.598885474087485, -80.0297164916992, -1.39678205221776, 218, 48, 'PPL', 'P'),
(91408, 'Tremont', 35.6208305358887, 0.621700775146193, -83.6774978637695, -1.4604478475533, 218, 50, 'PPL', 'P'),
(121735, 'Tremont', 40.5275001525879, 0.707338315265163, -89.4925003051758, -1.56193878616735, 218, 18, 'PPL', 'P'),
(123826, 'Tremont', 41.648609161377, 0.726905358742302, -87.0436096191406, -1.51919758067461, 218, 19, 'PPL', 'P'),
(126368, 'Tremont', 41.7902793884277, 0.729377970656386, -70.7708282470703, -1.23518396727478, 218, 23, 'PPL', 'P'),
(129097, 'Tremont', 44.2536087036133, 0.772371177767271, -68.351936340332, -1.19296633925236, 218, 26, 'PPL', 'P'),
(153186, 'Tremont', 40.8494415283203, 0.712957252270094, -73.9061126708984, -1.28990500345708, 218, 40, 'PPL', 'P'),
(157978, 'Tremont', 41.480281829834, 0.723967492585781, -81.6833267211914, -1.42564299526705, 218, 41, 'PPL', 'P'),
(168036, 'Tremont', 40.6283302307129, 0.709098132113487, -76.3874969482422, -1.33321332910395, 218, 45, 'PPL', 'P'),
(157979, 'Tremont City', 40.0111083984375, 0.69832557892509, -83.8361129760742, -1.46321620350644, 218, 41, 'PPL', 'P'),
(106978, 'Tremont Gardens', 38.8727798461914, 0.678457997718935, -77.2019424438477, -1.3474280845803, 218, 53, 'PPL', 'P'),
(785, 'Tremont Park', 35.9161109924316, 0.62685439132966, -81.5044403076172, -1.4225208383631, 218, 33, 'PPL', 'P'),
(25562, 'Tremont Park', 32.0597190856934, 0.559547655309815, -81.1380615234375, -1.41612632226971, 218, 13, 'PPL', 'P'),
(146471, 'Tremont Park', 40.7050018310547, 0.710436303982225, -74.353889465332, -1.29772018283397, 218, 37, 'PPL', 'P'),
(84076, 'Tremont Terrace', 34.1938896179199, 0.596795957896208, -79.6897201538086, -1.39084799667684, 218, 48, 'PPL', 'P'),
(206150, 'Tremonton', 41.7119407653809, 0.72801070375274, -112.16471862793, -1.95764364463039, 218, 52, 'PPL', 'P'),
(176717, 'Trempealeau', 44.0055618286133, 0.768041943099238, -91.4419403076172, -1.59596293278004, 218, 57, 'PPL', 'P'),
(52188, 'Tremper Farm', 39.389720916748, 0.687480321438933, -76.4550018310547, -1.3343915115702, 218, 25, 'PPL', 'P'),
(133431, 'Trenary', 46.1952781677246, 0.806259702901448, -86.9697189331055, -1.51790794491674, 218, 27, 'PPL', 'P'),
(177645, 'Trench Camp', 31.4644393920898, 0.549158064686171, -110.728607177734, -1.93257877139889, 218, 5, 'PPL', 'P'),
(52189, 'Trengail Manor', 39.6408309936523, 0.691863019065849, -77.6747207641602, -1.3556796229018, 218, 25, 'PPL', 'P'),
(106979, 'Trenholm', 37.5947189331055, 0.65615162674454, -78.0622177124023, -1.36244272049006, 218, 53, 'PPL', 'P'),
(201676, 'Trenholm', 45.8955612182617, 0.801028655309287, -122.964172363281, -2.14612966972907, 218, 43, 'PPL', 'P'),
(38578, 'Trent', 37.7719383239746, 0.659244688613586, -83.4613876342773, -1.45667601250142, 218, 21, 'PPL', 'P'),
(112537, 'Trent', 39.9847183227539, 0.69786498521456, -79.2438888549805, -1.38306677260385, 218, 45, 'PPL', 'P'),
(171432, 'Trent', 43.9063911437988, 0.766311088127769, -96.6536102294922, -1.68692373244391, 218, 49, 'PPL', 'P'),
(185742, 'Trent', 37.0774993896484, 0.647124442755553, -120.879722595215, -2.10974915818388, 218, 6, 'PPL', 'P'),
(192336, 'Trent', 32.4894409179688, 0.567047716150724, -100.126106262207, -1.74753022147723, 218, 51, 'PPL', 'P'),
(201677, 'Trent', 43.9430618286133, 0.766951112316742, -122.859443664551, -2.1443018091149, 218, 43, 'PPL', 'P'),
(69616, 'Trent Shores', 35.0758285522461, 0.61218869610173, -77.0711135864258, -1.34514469026167, 218, 33, 'PPL', 'P'),
(91409, 'Trent Valley', 36.497501373291, 0.63700156771508, -83.1922225952148, -1.45197819633852, 218, 50, 'PPL', 'P'),
(69608, 'Trent Woods', 35.0819396972656, 0.612295355703388, -77.086669921875, -1.3454161995348, 218, 33, 'PPL', 'P'),
(6381, 'Trenton', 34.7447204589844, 0.606409769694313, -86.2516708374023, -1.50537564145905, 218, 2, 'PPL', 'P'),
(12383, 'Trenton', 34.4997215270996, 0.602133731669054, -90.8652801513672, -1.58589831438841, 218, 4, 'PPL', 'P'),
(18374, 'Trenton', 29.6130599975586, 0.516845398548021, -82.8177795410156, -1.44544293218152, 218, 12, 'PPL', 'P'),
(25563, 'Trenton', 34.871940612793, 0.608630180253166, -85.5091705322266, -1.49241656643667, 218, 13, 'PPL', 'P'),
(28804, 'Trenton', 38.6055603027344, 0.673794136859934, -89.6819381713867, -1.56524510066068, 218, 18, 'PPL', 'P'),
(34191, 'Trenton', 38.8869400024414, 0.678705139068094, -97.6488876342773, -1.70429460012812, 218, 20, 'PPL', 'P'),
(38579, 'Trenton', 36.7238883972168, 0.640952766666376, -87.2627792358398, -1.52302281210635, 218, 21, 'PPL', 'P'),
(43387, 'Trenton', 31.9500007629395, 0.557632709327994, -93.7191696166992, -1.63570808204643, 218, 22, 'PPL', 'P'),
(52190, 'Trenton', 39.5788917541504, 0.690781975400358, -76.8080596923828, -1.34055353370042, 218, 25, 'PPL', 'P'),
(62070, 'Trenton', 32.1691703796387, 0.561457940759729, -89.6108322143555, -1.5640040675927, 218, 30, 'PPL', 'P'),
(69610, 'Trenton', 35.0669403076172, 0.612033566968233, -77.3530578613281, -1.35006554616586, 218, 33, 'PPL', 'P'),
(74565, 'Trenton', 39.4808311462402, 0.689070494925819, -84.4577789306641, -1.47406632126158, 218, 41, 'PPL', 'P'),
(84077, 'Trenton', 33.7438888549805, 0.588941962946429, -81.8408279418945, -1.42839191014423, 218, 48, 'PPL', 'P'),
(91410, 'Trenton', 35.9805603027344, 0.627979243995083, -88.9413909912109, -1.55232011410025, 218, 50, 'PPL', 'P'),
(98605, 'Trenton', 33.4305610656738, 0.583473361385033, -96.3383331298828, -1.68142110899959, 218, 51, 'PPL', 'P'),
(118065, 'Trenton', 41.0616683959961, 0.716661309872231, -91.6372222900391, -1.59937124634312, 218, 16, 'PPL', 'P'),
(123827, 'Trenton', 40.4500007629395, 0.705985695747512, -85.2388916015625, -1.48769930919781, 218, 19, 'PPL', 'P'),
(129099, 'Trenton', 44.4388885498047, 0.7756049211209, -68.3705596923828, -1.1932913780634, 218, 26, 'PPL', 'P'),
(133432, 'Trenton', 42.1394386291504, 0.73547194902076, -83.1783294677734, -1.45173571552127, 218, 27, 'PPL', 'P'),
(139485, 'Trenton', 40.0788917541504, 0.69950862166033, -93.6163864135742, -1.63391417673616, 218, 29, 'PPL', 'P'),
(146472, 'Trenton', 40.2169418334961, 0.701918050077552, -74.7433319091797, -1.30451723572612, 218, 37, 'PPL', 'P'),
(168039, 'Trenton', 40.8380584716797, 0.712758580452774, -76.0908279418945, -1.32803547815456, 218, 45, 'PPL', 'P'),
(176721, 'Trenton', 44.603889465332, 0.778484730365657, -92.5647201538086, -1.61555913787111, 218, 57, 'PPL', 'P'),
(185743, 'Trenton', 38.485279083252, 0.671694833551651, -122.850830078125, -2.14415147367136, 218, 6, 'PPL', 'P'),
(199009, 'Trenton', 48.0705604553223, 0.838989553224358, -103.836387634277, -1.81228684759527, 218, 34, 'PPL', 'P'),
(199730, 'Trenton', 40.1755599975586, 0.701195800789923, -101.012496948242, -1.76300065740755, 218, 35, 'PPL', 'P'),
(206151, 'Trenton', 41.917781829834, 0.731603308063256, -111.941673278809, -1.95375076890697, 218, 52, 'PPL', 'P'),
(98606, 'Trenton Acres Colonia', 26.2569999694824, 0.458271101163519, -98.1460037231445, -1.71297091264349, 218, 51, 'PPL', 'P'),
(121737, 'Trenton Corners', 40.9080581665039, 0.713980305602848, -90.1138916015625, -1.57278411023253, 218, 18, 'PPL', 'P'),
(153197, 'Trenton Falls', 43.2713890075684, 0.755228210093349, -75.1605606079102, -1.31179925025278, 218, 40, 'PPL', 'P'),
(146473, 'Trenton Gardens', 40.1972198486328, 0.701573836506659, -74.6997222900391, -1.30375610428658, 218, 37, 'PPL', 'P'),
(98607, 'Trenton Manor Colonia', 26.2569999694824, 0.458271101163519, -98.1500015258789, -1.71304068746405, 218, 51, 'PPL', 'P'),
(52191, 'Trenton Mill', 39.5752792358398, 0.690718925061551, -76.811393737793, -1.34061172377024, 218, 25, 'PPL', 'P'),
(106980, 'Trenton Mills', 37.6291694641113, 0.656752901939653, -78.2286071777344, -1.36534676450073, 218, 53, 'PPL', 'P'),
(52192, 'Trenton Place', 38.4533309936523, 0.671137234198416, -76.8199996948242, -1.34076192605572, 218, 25, 'PPL', 'P'),
(98608, 'Trenton Terrace Colonia', 26.2569999694824, 0.458271101163519, -98.1589965820313, -1.71319768081031, 218, 51, 'PPL', 'P'),
(106981, 'Trents Mill', 37.5547218322754, 0.655453545643803, -78.2897186279297, -1.36641336051731, 218, 53, 'PPL', 'P'),
(91411, 'Trentville', 36.0277786254883, 0.628803359194408, -83.7202835083008, -1.46119459792296, 218, 50, 'PPL', 'P'),
(208974, 'Trentwood', 47.6966705322266, 0.83246394302631, -117.209716796875, -2.04569547343557, 218, 56, 'PPL', 'P'),
(14759, 'Trepagnier', 39.7791709899902, 0.694277507489142, -75.6688919067383, -1.32067130510827, 218, 10, 'PPL', 'P'),
(98609, 'Tres Amigos Colonia', 26.2749996185303, 0.458585254303607, -98.3300018310547, -1.71618228544396, 218, 51, 'PPL', 'P'),
(189713, 'Tres Lagunas', 35.7211112976074, 0.623451004614594, -105.67749786377, -1.84442028299205, 218, 38, 'PPL', 'P'),
(192337, 'Tres Papalotes', 29.4566707611084, 0.514115891457286, -103.77555847168, -1.81122517842671, 218, 51, 'PPL', 'P'),
(189714, 'Tres Piedras', 36.6469383239746, 0.639609734528649, -105.966667175293, -1.84946723957386, 218, 38, 'PPL', 'P'),
(185745, 'Tres Pinos', 36.7900009155273, 0.64210664778768, -121.319999694824, -2.1174334431932, 218, 6, 'PPL', 'P'),
(179383, 'Tres Rios', 34.5638885498047, 0.60325365748646, -111.847503662109, -1.95210719904022, 218, 5, 'PPL', 'P'),
(189715, 'Tres Ritos', 36.1305618286133, 0.630597264504685, -105.515281677246, -1.84158907643719, 218, 38, 'PPL', 'P'),
(185746, 'Trescape (historical)', 35.1399993896484, 0.613308688498163, -118.075561523438, -2.06080731472512, 218, 6, 'PPL', 'P'),
(168040, 'Tresckow', 40.913330078125, 0.71407231781851, -75.9669418334961, -1.32587325766552, 218, 45, 'PPL', 'P'),
(206152, 'Tresend', 41.2208290100098, 0.719439186626265, -112.759719848633, -1.96802837498504, 218, 52, 'PPL', 'P'),
(34193, 'Tresham', 37.1699981689453, 0.648738851008359, -97.0494384765625, -1.69383223862769, 218, 20, 'PPL', 'P'),
(38582, 'Tress Shop', 36.8288917541504, 0.642785420970514, -87.2183303833008, -1.52224703328081, 218, 21, 'PPL', 'P'),
(168041, 'Tresslarville', 41.454719543457, 0.723521346524166, -75.3994369506836, -1.3159684289393, 218, 45, 'PPL', 'P'),
(153188, 'Tressmar', 43.1266708374023, 0.752702401536491, -77.6902770996094, -1.35595113217493, 218, 40, 'PPL', 'P'),
(195729, 'Trestle Creek', 48.2833290100098, 0.842703065048365, -116.349716186523, -2.03068563121577, 218, 17, 'PPL', 'P'),
(77488, 'Trestle Ford', 34.9922218322754, 0.610729483561449, -94.4800033569336, -1.64898713587379, 218, 42, 'PPL', 'P'),
(52193, 'Trevanion', 39.624439239502, 0.691576928985747, -77.1397171020508, -1.34634204748776, 218, 25, 'PPL', 'P'),
(185749, 'Trevarno', 37.690559387207, 0.657824358225219, -121.746391296387, -2.12487538054332, 218, 6, 'PPL', 'P'),
(98611, 'Trevat', 31.1197204589844, 0.543141584309518, -94.9461135864258, -1.65712229405565, 218, 51, 'PPL', 'P'),
(185747, 'Treves (historical)', 35.3286094665527, 0.616600555342583, -118.788887023926, -2.07325719334707, 218, 6, 'PPL', 'P'),
(168042, 'Treveskyn', 40.3486099243164, 0.704216091782181, -80.1549987792969, -1.39896864063077, 218, 45, 'PPL', 'P'),
(129102, 'Trevett', 43.8847198486328, 0.76593285267395, -69.6733322143555, -1.21602904797633, 218, 26, 'PPL', 'P'),
(206153, 'Trevi Towers Condominium', 40.7747192382813, 0.711653102284282, -111.892501831055, -1.95289256524569, 218, 52, 'PPL', 'P'),
(106982, 'Trevilians', 38.0513916015625, 0.664122068412984, -78.0730590820313, -1.36263193808551, 218, 53, 'PPL', 'P'),
(176725, 'Trevino', 44.4286117553711, 0.775425557221483, -92.0677795410156, -1.606885887991, 218, 57, 'PPL', 'P'),
(98612, 'Trevino Colonia', 26.2129993438721, 0.457503145373681, -98.2580032348633, -1.7149256728836, 218, 51, 'PPL', 'P'),
(98613, 'Trevinos Colonia', 26.3910007476807, 0.460609855943313, -98.8399963378906, -1.72508336875533, 218, 51, 'PPL', 'P'),
(98614, 'Trevinos Number 1 Colonia', 26.3910007476807, 0.460609855943313, -98.8410034179688, -1.72510094561852, 218, 51, 'PPL', 'P'),
(31321, 'Trevlac', 39.2655601501465, 0.685313307259935, -86.3369369506836, -1.50686381587618, 218, 19, 'PPL', 'P'),
(176726, 'Trevor', 42.5125007629395, 0.741983111569895, -88.1208267211914, -1.53799856586419, 218, 57, 'PPL', 'P'),
(52195, 'Trevor Woods', 39.1791687011719, 0.68380549202976, -76.6305618286133, -1.33745561156239, 218, 25, 'PPL', 'P'),
(168043, 'Trevorton', 40.7811088562012, 0.711764622154929, -76.6733322143555, -1.33820209561594, 218, 45, 'PPL', 'P'),
(168044, 'Trevose', 40.1391716003418, 0.700560703448966, -74.9813919067383, -1.30867216650081, 218, 45, 'PPL', 'P'),
(168045, 'Trevose Heights', 40.1511116027832, 0.700769095804265, -74.9875030517578, -1.30877882610247, 218, 45, 'PPL', 'P'),
(168047, 'Trewigtown', 40.2772216796875, 0.702970131866188, -75.2605590820313, -1.31354455287317, 218, 45, 'PPL', 'P'),
(168046, 'Trexler', 40.6355590820313, 0.70922429937013, -75.8536071777344, -1.32389519476587, 218, 45, 'PPL', 'P'),
(84078, 'Trexler Acres', 34.9777793884277, 0.610477415364273, -81.0519409179688, -1.41462323415047, 218, 48, 'PPL', 'P'),
(168048, 'Trexlertown', 40.5480613708496, 0.707697176222051, -75.6061096191406, -1.31957554747776, 218, 45, 'PPL', 'P'),
(118067, 'Treynor', 41.2324981689453, 0.719642851870629, -95.6127777099609, -1.66875777801626, 218, 16, 'PPL', 'P'),
(91412, 'Trezevant', 36.0113906860352, 0.628517335693333, -88.6227798461914, -1.54675930058611, 218, 50, 'PPL', 'P'),
(38580, 'Tri City', 36.5897216796875, 0.638611115698897, -88.5319366455078, -1.54517378763114, 218, 21, 'PPL', 'P'),
(201678, 'Tri City', 42.9808311462402, 0.75015701874562, -123.321937561035, -2.15237385037893, 218, 43, 'PPL', 'P'),
(168049, 'Tri Mills', 41.2616691589355, 0.720151981692025, -76.345832824707, -1.3324861529683, 218, 45, 'PPL', 'P'),
(199732, 'Tri States Trailer Court', 41.125560760498, 0.717776441999674, -100.750556945801, -1.75842894192227, 218, 35, 'PPL', 'P'),
(201679, 'Tri-City', 42.9847183227539, 0.75022486277439, -123.310562133789, -2.15217531171966, 218, 43, 'PPL', 'P'),
(98615, 'Tri-City Colonia Number 1', 26.2849998474121, 0.458759791223548, -98.286003112793, -1.71541436294363, 218, 51, 'PPL', 'P'),
(98616, 'Tri-City Colonia Number 2', 26.2849998474121, 0.458759791223548, -98.2829971313477, -1.71536189867016, 218, 51, 'PPL', 'P'),
(79277, 'Tri-Hill', 39.9422187805176, 0.697123228271946, -76.7088928222656, -1.33882274530798, 218, 45, 'PPL', 'P'),
(123828, 'Tri-Lakes', 41.2458305358887, 0.719875545570875, -85.4419403076172, -1.49124317766038, 218, 19, 'PPL', 'P'),
(206155, 'Tri-S Village Estates', 41.1736106872559, 0.71861507142694, -112.106941223145, -1.95663523868363, 218, 52, 'PPL', 'P'),
(14760, 'Tri-State Mobile Home Park', 38.6969413757324, 0.675389037457755, -75.1686096191406, -1.31193973200028, 218, 10, 'PPL', 'P'),
(52196, 'Tri-Woods', 39.603328704834, 0.691208480648935, -77.0711135864258, -1.34514469026167, 218, 25, 'PPL', 'P'),
(74567, 'Triadelphia', 39.6997184753418, 0.692890799509538, -81.9655609130859, -1.43056891117732, 218, 41, 'PPL', 'P'),
(177282, 'Triadelphia', 40.0525016784668, 0.699048027949801, -80.6286087036133, -1.40723469318021, 218, 58, 'PPL', 'P'),
(52198, 'Triadelphia (historical)', 39.2333297729492, 0.684750781058683, -77.0416717529297, -1.34463083332933, 218, 25, 'PPL', 'P'),
(52199, 'Triadelphia Woods', 39.2866706848145, 0.685681755596748, -76.9341735839844, -1.34275463634137, 218, 25, 'PPL', 'P'),
(6382, 'Triana', 34.586109161377, 0.603641480320203, -86.7333297729492, -1.51378217575599, 218, 2, 'PPL', 'P'),
(6383, 'Triana Landing', 34.5802803039551, 0.603539747566562, -86.730827331543, -1.51373849991411, 218, 2, 'PPL', 'P'),
(98617, 'Triangle', 31.2813892364502, 0.545963236773971, -96.9897232055664, -1.69279001053508, 218, 51, 'PPL', 'P'),
(106983, 'Triangle', 38.5466690063477, 0.672766289837218, -77.3369369506836, -1.34978418319669, 218, 53, 'PPL', 'P'),
(153189, 'Triangle', 42.3397216796875, 0.738967547688571, -75.8805618286133, -1.32436564217243, 218, 40, 'PPL', 'P'),
(195730, 'Triangle', 42.7838897705078, 0.746719743305682, -116.624443054199, -2.03548051960041, 218, 17, 'PPL', 'P'),
(69613, 'Triangle (historical)', 35.4824981689453, 0.619286419880955, -81.0100021362305, -1.41389126432486, 218, 33, 'PPL', 'P'),
(201680, 'Triangle Lake', 44.1708297729492, 0.770926412875903, -123.577781677246, -2.15683917257866, 218, 43, 'PPL', 'P'),
(69614, 'Triangle Trailer Park', 34.7516708374023, 0.606531076681966, -77.4552764892578, -1.3518495977801, 218, 33, 'PPL', 'P'),
(98618, 'Triangula Colonia', 28.7210006713867, 0.5012760261832, -99.8379974365234, -1.74250177386499, 218, 51, 'PPL', 'P'),
(62071, 'Tribbett', 33.351390838623, 0.582091580253445, -90.7983322143555, -1.58472985246014, 218, 30, 'PPL', 'P'),
(38581, 'Tribbey', 37.3044395446777, 0.651085295665801, -83.1444396972656, -1.45114422744316, 218, 21, 'PPL', 'P'),
(77487, 'Tribbey', 35.1152801513672, 0.61287725640157, -97.0530624389648, -1.69389548870357, 218, 42, 'PPL', 'P'),
(111738, 'Tribble', 38.6875, 0.675224254365306, -81.8380584716797, -1.42834357377045, 218, 58, 'PPL', 'P'),
(153192, 'Tribes Hill', 42.9552803039551, 0.749711072421087, -74.2855606079102, -1.29652761929783, 218, 40, 'PPL', 'P'),
(118068, 'Triboji Beach', 43.4269409179688, 0.757943103087603, -95.1744384765625, -1.66110731515279, 218, 16, 'PPL', 'P'),
(38583, 'Tribune', 37.3477783203125, 0.651841699994411, -87.991943359375, -1.53574912684945, 218, 21, 'PPL', 'P'),
(98619, 'Tribune', 33.598331451416, 0.586401507003575, -96.5902786254883, -1.68581838743347, 218, 51, 'PPL', 'P'),
(187934, 'Tribune', 38.4697189331055, 0.671423257699491, -101.752220153809, -1.77591126289809, 218, 20, 'PPL', 'P'),
(106984, 'Trice (historical)', 37.9491691589355, 0.662337950219713, -78.1808319091797, -1.36451292876343, 218, 53, 'PPL', 'P'),
(106985, 'Trice Subdivision', 37.8305587768555, 0.660267808525367, -77.9738922119141, -1.36090114969306, 218, 53, 'PPL', 'P'),
(52200, 'Tricfield', 38.7755584716797, 0.676761164630391, -76.2272186279297, -1.33041594469493, 218, 25, 'PPL', 'P'),
(43388, 'Trichell', 31.8174991607666, 0.55532012010591, -92.9697189331055, -1.6226277000364, 218, 22, 'PPL', 'P'),
(6385, 'Trickem', 32.2733306884766, 0.563275881098844, -86.746940612793, -1.51401972972522, 218, 2, 'PPL', 'P'),
(25565, 'Trickem', 33.8405609130859, 0.590629208655048, -84.1311111450195, -1.46836489284189, 218, 13, 'PPL', 'P'),
(98620, 'Trickham', 31.5874996185303, 0.551305870815806, -99.2302780151367, -1.73189506903348, 218, 51, 'PPL', 'P'),
(25566, 'Trickum', 34.7961082458496, 0.607306655770424, -85.0827789306641, -1.48497462908655, 218, 13, 'PPL', 'P'),
(25567, 'Trickum Hills', 34.0805587768555, 0.594817961575579, -84.4875030517578, -1.47458510504193, 218, 13, 'PPL', 'P'),
(185750, 'Trico Mobile Estates', 33.2286109924316, 0.579948667682313, -117.328330993652, -2.04776568170894, 218, 6, 'PPL', 'P'),
(206157, 'Tridell', 40.4536094665527, 0.706048679507292, -109.849166870117, -1.91722964245622, 218, 52, 'PPL', 'P'),
(12384, 'Trident', 36.100830078125, 0.630078347566283, -94.4802780151367, -1.64899192956375, 218, 4, 'PPL', 'P'),
(197716, 'Trident', 45.9474983215332, 0.801935128765323, -111.475830078125, -1.94562027125701, 218, 31, 'PPL', 'P'),
(52201, 'Trident Acres', 39.5872192382813, 0.690927317416849, -76.9236068725586, -1.34257021243589, 218, 25, 'PPL', 'P'),
(91413, 'Trigg', 35.3116683959961, 0.616304877882557, -86.851936340332, -1.51585225087131, 218, 50, 'PPL', 'P'),
(106986, 'Trigg', 37.2455596923828, 0.650057648380166, -80.6802825927734, -1.40813657268336, 218, 53, 'PPL', 'P'),
(12385, 'Trigg (historical)', 33.9666709899902, 0.592830244716972, -92.3808288574219, -1.6123496292834, 218, 4, 'PPL', 'P'),
(38585, 'Trigg Furnace', 36.8899993896484, 0.643851950408064, -87.9361114501953, -1.53477467620659, 218, 21, 'PPL', 'P'),
(185751, 'Trigo', 36.9130592346191, 0.644254420627802, -119.959442138672, -2.09368723417545, 218, 6, 'PPL', 'P'),
(185752, 'Trigo (historical)', 37.8863906860352, 0.661242259168227, -120.972221374512, -2.11136356643669, 218, 6, 'PPL', 'P'),
(91414, 'Trigonia', 35.6130599975586, 0.621565153667681, -84.1880569458008, -1.46935878456071, 218, 50, 'PPL', 'P'),
(208975, 'Trikkala', 47.6302795410156, 0.831305201636016, -122.609169006348, -2.13993369229495, 218, 56, 'PPL', 'P'),
(18375, 'Trilby', 28.4622192382813, 0.49675943813248, -82.1949996948242, -1.43457337335042, 218, 12, 'PPL', 'P'),
(177402, 'Trilby', 41.7208290100098, 0.728165832886237, -83.6216735839844, -1.45947353006849, 218, 41, 'PPL', 'P'),
(111739, 'Trilby (historical)', 39.2466697692871, 0.684983607916983, -80.9447174072266, -1.41275183085247, 218, 58, 'PPL', 'P'),
(194455, 'Trilby Corner', 40.4947204589844, 0.706766201683987, -105.076942443848, -1.83393861357372, 218, 7, 'PPL', 'P'),
(18376, 'Trilcoochee', 28.4636096954346, 0.496783706187914, -82.1833267211914, -1.43436964152703, 218, 12, 'PPL', 'P'),
(28805, 'Trilla', 39.375, 0.687223392972767, -88.3502807617188, -1.5420032943534, 218, 18, 'PPL', 'P'),
(31322, 'Trilobi Hills', 39.8791694641113, 0.696022810109525, -85.9966735839844, -1.50092509980336, 218, 19, 'PPL', 'P'),
(176727, 'Trimbelle', 44.7316703796387, 0.780714928041517, -92.579719543457, -1.61582092660627, 218, 57, 'PPL', 'P'),
(6389, 'Trimble', 34.0933303833008, 0.595040868158819, -86.9486083984375, -1.51753949657993, 218, 2, 'PPL', 'P'),
(25568, 'Trimble', 33.2019386291504, 0.579483147123767, -84.892219543457, -1.4816487403592, 218, 13, 'PPL', 'P'),
(28806, 'Trimble', 39.0633316040039, 0.681783753288226, -87.684440612793, -1.53038219146267, 218, 18, 'PPL', 'P'),
(38586, 'Trimble', 37.0119400024414, 0.645980215593201, -84.7358322143555, -1.47891926655798, 218, 21, 'PPL', 'P'),
(57940, 'Trimble', 39.4711112976074, 0.688900851564381, -94.5644378662109, -1.65046079606298, 218, 29, 'PPL', 'P'),
(74568, 'Trimble', 39.4847183227539, 0.689138338954589, -82.0791702270508, -1.43255176776694, 218, 41, 'PPL', 'P'),
(91415, 'Trimble', 36.2030601501465, 0.631862598917609, -89.1908264160156, -1.55667358353421, 218, 50, 'PPL', 'P'),
(106987, 'Trimble', 38.3044395446777, 0.668538588185744, -79.6191711425781, -1.38961668414684, 218, 53, 'PPL', 'P'),
(187455, 'Trimble', 37.3902816772461, 0.652583523516052, -107.845832824707, -1.88226486734651, 218, 7, 'PPL', 'P'),
(52202, 'Trimble Fields', 39.4183311462402, 0.687979664143322, -76.3061065673828, -1.3317927989785, 218, 25, 'PPL', 'P'),
(106988, 'Trimbles Mill', 38.1352806091309, 0.665586207801282, -79.2188873291016, -1.38263041365924, 218, 53, 'PPL', 'P'),
(185753, 'Trimmer', 36.9049987792969, 0.644113739143219, -119.295280456543, -2.08209542605672, 218, 6, 'PPL', 'P'),
(106989, 'Trimmers Crossing', 38.288890838623, 0.668267212070665, -78.0880584716797, -1.36289372682066, 218, 53, 'PPL', 'P'),
(138478, 'Trimont', 43.7622184753418, 0.763794800371807, -94.7069396972656, -1.65294792220501, 218, 28, 'PPL', 'P'),
(133434, 'Trimountain', 47.0552787780762, 0.821269545121243, -88.6605606079102, -1.54741869927202, 218, 27, 'PPL', 'P'),
(187456, 'Trinchera', 37.0422210693359, 0.646508719911527, -104.046943664551, -1.81596174358347, 218, 7, 'PPL', 'P'),
(168050, 'Trindle Springs', 40.2063903808594, 0.701733892488173, -77.0236129760742, -1.34431564821432, 218, 45, 'PPL', 'P'),
(197715, 'Trine (historical)', 47.7924995422363, 0.834136474769907, -108.344436645508, -1.89096714568251, 218, 31, 'PPL', 'P'),
(13233, 'Trinidad', 38.9055595397949, 0.679030111300111, -76.9847183227539, -1.34363680845246, 218, 9, 'PPL', 'P'),
(98621, 'Trinidad', 32.1438903808594, 0.56101672154613, -96.0908279418945, -1.67710132855343, 218, 51, 'PPL', 'P'),
(187457, 'Trinidad', 37.1694412231445, 0.64872913047038, -104.5, -1.82386906833407, 218, 7, 'PPL', 'P'),
(194014, 'Trinidad', 41.059440612793, 0.716622427720315, -124.141937255859, -2.16668554491896, 218, 6, 'PPL', 'P'),
(208977, 'Trinidad', 47.2299995422363, 0.824318997727439, -119.999443054199, -2.09438538185522, 218, 56, 'PPL', 'P'),
(398, 'Trinity', 28.1805591583252, 0.491843542365817, -82.6819381713867, -1.44307205302108, 218, 12, 'PPL', 'P'),
(6388, 'Trinity', 34.6066703796387, 0.604000341277091, -87.0883331298828, -1.51997815319011, 218, 2, 'PPL', 'P'),
(14761, 'Trinity', 38.624439239502, 0.674123636465804, -75.1869430541992, -1.31225971080526, 218, 10, 'PPL', 'P'),
(25569, 'Trinity', 31.9297199249268, 0.557278741929609, -81.5566711425781, -1.42343243840423, 218, 13, 'PPL', 'P'),
(38588, 'Trinity', 38.6669387817383, 0.674865393408418, -83.6163864135742, -1.45938125153672, 218, 21, 'PPL', 'P'),
(43389, 'Trinity', 31.6319408416748, 0.552081516483292, -91.8108291625977, -1.60240125787336, 218, 22, 'PPL', 'P'),
(52204, 'Trinity', 38.2936096191406, 0.668349570327376, -75.7466735839844, -1.32202885147394, 218, 25, 'PPL', 'P'),
(62074, 'Trinity', 33.3458290100098, 0.581994508031712, -88.4622192382813, -1.54395698932908, 218, 30, 'PPL', 'P'),
(69618, 'Trinity', 34.8497200012207, 0.608242357419424, -80.5311126708984, -1.4055330664017, 218, 33, 'PPL', 'P'),
(84079, 'Trinity', 34.2488899230957, 0.597755894311128, -81.7358322143555, -1.42655938899815, 218, 48, 'PPL', 'P'),
(91417, 'Trinity', 35.9102783203125, 0.626752591996992, -86.7538909912109, -1.51414103671288, 218, 50, 'PPL', 'P'),
(98622, 'Trinity', 30.9449996948242, 0.540092131703323, -95.3752822875977, -1.66461270093761, 218, 51, 'PPL', 'P'),
(106990, 'Trinity', 37.4558296203613, 0.653727550941323, -79.8899993896484, -1.39434352876563, 218, 53, 'PPL', 'P'),
(123829, 'Trinity', 40.5424995422363, 0.707600104000318, -84.8486099243164, -1.48088760891966, 218, 19, 'PPL', 'P'),
(190847, 'Trinity', 39.9449996948242, 0.697171764382813, -118.746940612793, -2.07252509036341, 218, 39, 'PPL', 'P'),
(208976, 'Trinity', 48.0747184753418, 0.839062124364063, -120.851387023926, -2.10925460916946, 218, 56, 'PPL', 'P'),
(139487, 'Trinity (historical)', 40.3402786254883, 0.704070683186663, -92.4508285522461, -1.61357135443348, 218, 29, 'PPL', 'P'),
(157981, 'Trinity (historical)', 41.4480590820313, 0.723405099542584, -82.0005569458008, -1.43117970717333, 218, 41, 'PPL', 'P'),
(197717, 'Trinity (historical)', 46.7694396972656, 0.816280712030225, -112.216667175293, -1.95855031782351, 218, 31, 'PPL', 'P'),
(194015, 'Trinity Alps', 40.8574981689453, 0.71309786717565, -122.889167785645, -2.14482059289525, 218, 6, 'PPL', 'P'),
(194016, 'Trinity Center', 40.9833297729492, 0.715294042968584, -122.698608398438, -2.1414947041679, 218, 6, 'PPL', 'P'),
(84082, 'Trinity Cross Roads', 33.9666709899902, 0.592830244716972, -80.0708312988281, -1.39749964097348, 218, 48, 'PPL', 'P'),
(52205, 'Trinity Farms', 39.0727806091309, 0.681948669538729, -76.540283203125, -1.33587995230344, 218, 25, 'PPL', 'P'),
(98624, 'Trinity Mills', 32.9813919067383, 0.575633880663194, -96.9272232055664, -1.69169917975259, 218, 51, 'PPL', 'P'),
(69619, 'Trinity Park', 35.8974990844727, 0.626529552255698, -79.995002746582, -1.39617618306976, 218, 33, 'PPL', 'P'),
(98625, 'Trinity Park', 33.0877799987793, 0.577490703154224, -96.5416717529297, -1.68497003746823, 218, 51, 'PPL', 'P'),
(98626, 'Trinity River Lake Estates', 30.3374996185303, 0.529489255165877, -94.7874984741211, -1.65435393810251, 218, 51, 'PPL', 'P'),
(194017, 'Trinity Village', 40.875560760498, 0.713413118869688, -123.527221679688, -2.15595673415147, 218, 6, 'PPL', 'P'),
(12386, 'Trinnon', 36.3827781677246, 0.634999270049504, -90.1494369506836, -1.57340449360847, 218, 4, 'PPL', 'P'),
(157982, 'Trinway', 40.1411094665527, 0.70059452559481, -82.0100021362305, -1.4313445568448, 218, 41, 'PPL', 'P'),
(6390, 'Trio', 32.9122200012207, 0.574426603162033, -87.0247192382813, -1.51886788133166, 218, 2, 'PPL', 'P'),
(84083, 'Trio', 33.4858283996582, 0.584437958331859, -79.7177810668945, -1.39133775200131, 218, 48, 'PPL', 'P'),
(98627, 'Trio', 29.4022197723389, 0.513165542422291, -99.5580596923828, -1.73761593852913, 218, 51, 'PPL', 'P'),
(69622, 'Trio (historical)', 35.5083312988281, 0.619737293053505, -81.915283203125, -1.42969139959814, 218, 33, 'PPL', 'P'),
(25570, 'Trion', 34.5438919067383, 0.602904650225605, -85.3105621337891, -1.48895019596182, 218, 13, 'PPL', 'P'),
(98628, 'Triple C Colonia', 26.378999710083, 0.460400398323578, -98.1139984130859, -1.71241231460484, 218, 51, 'PPL', 'P'),
(199733, 'Triple C Trailer Court', 40.8419418334961, 0.712826357902517, -101.724716186523, -1.7754312281116, 218, 35, 'PPL', 'P'),
(52206, 'Triple Lakes', 39.5811080932617, 0.690820657815192, -78.8469390869141, -1.37613869218606, 218, 25, 'PPL', 'P'),
(98629, 'Triple R Colonia', 26.3920001983643, 0.460627299648453, -98.8430023193359, -1.7251358330288, 218, 51, 'PPL', 'P'),
(98630, 'Triple R Number 1 Colonia', 26.3950004577637, 0.460679664053387, -98.8440017700195, -1.72515327673394, 218, 51, 'PPL', 'P'),
(69623, 'Triple Springs', 36.4874992370605, 0.636826997505626, -78.8486099243164, -1.3761678538, 218, 33, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(179384, 'Triple T Mobilcity', 33.5411109924316, 0.585402821594795, -112.198608398438, -1.9582351327085, 218, 5, 'PPL', 'P'),
(106991, 'Triplet', 36.610279083252, 0.638969910076758, -77.76611328125, -1.3572747232367, 218, 53, 'PPL', 'P'),
(62075, 'Triplets Corners', 33.0911102294922, 0.577548826645015, -88.8216705322266, -1.55023059790898, 218, 30, 'PPL', 'P'),
(38589, 'Triplett', 38.2933311462402, 0.668344710058386, -83.3963928222656, -1.4555416390351, 218, 21, 'PPL', 'P'),
(57941, 'Triplett', 39.4980583190918, 0.689371165812889, -93.1936111450195, -1.62653535630387, 218, 29, 'PPL', 'P'),
(69624, 'Triplett', 36.2030601501465, 0.631862598917609, -81.5588912963867, -1.42347118739809, 218, 33, 'PPL', 'P'),
(111740, 'Triplett', 38.8394393920898, 0.677876097020753, -81.2983322143555, -1.41892357352068, 218, 58, 'PPL', 'P'),
(118070, 'Tripoli', 42.8080596923828, 0.747141588022351, -92.258056640625, -1.61020684987033, 218, 16, 'PPL', 'P'),
(153194, 'Tripoli', 43.3908309936523, 0.757312866015636, -73.5800018310547, -1.28421329557536, 218, 40, 'PPL', 'P'),
(168051, 'Tripoli', 40.5447196960449, 0.707638852994178, -78.7772216796875, -1.374921893884, 218, 45, 'PPL', 'P'),
(176728, 'Tripoli', 45.5552787780762, 0.795089606341328, -89.9938888549805, -1.57068966719324, 218, 57, 'PPL', 'P'),
(144571, 'Tripoli Mill', 43.9980583190918, 0.767910982152634, -71.5777816772461, -1.24926796154161, 218, 36, 'PPL', 'P'),
(98631, 'Tripp', 32.7947196960449, 0.572375835964618, -96.5602798461914, -1.68529480996316, 218, 51, 'PPL', 'P'),
(111741, 'Tripp', 37.9249992370605, 0.661916105503044, -82.4797210693359, -1.43954269878645, 218, 58, 'PPL', 'P'),
(171435, 'Tripp', 43.2255592346191, 0.754428329659944, -97.9655609130859, -1.70982159149641, 218, 49, 'PPL', 'P'),
(12387, 'Trippe Junction', 33.5952796936035, 0.586348243781773, -91.3344421386719, -1.59408673579208, 218, 4, 'PPL', 'P'),
(169636, 'Tripps Corner', 41.5424995422363, 0.725053396520261, -71.6013870239258, -1.24967995256225, 218, 47, 'PPL', 'P'),
(176730, 'Trippville', 43.709171295166, 0.762868952418841, -90.404167175293, -1.57785037473224, 218, 57, 'PPL', 'P'),
(133436, 'Trist', 42.336109161377, 0.738904497349763, -84.2002792358398, -1.46957210376402, 218, 27, 'PPL', 'P'),
(111743, 'Tristan', 38.8025016784668, 0.677231412299872, -81.2272186279297, -1.41768240729464, 218, 58, 'PPL', 'P'),
(18378, 'Tristan Village', 30.4583301544189, 0.531598145854083, -87.2622222900391, -1.52301309156837, 218, 12, 'PPL', 'P'),
(153195, 'Tristates', 41.3605613708496, 0.721877976394505, -74.6822204589844, -1.30345063970955, 218, 40, 'PPL', 'P'),
(208978, 'Triton', 47.6049995422363, 0.830863982422417, -122.988609313965, -2.14655617497765, 218, 56, 'PPL', 'P'),
(43391, 'Triumph', 29.3391704559326, 0.51206512425987, -89.4766693115234, -1.56166248320425, 218, 22, 'PPL', 'P'),
(121738, 'Triumph', 41.499439239502, 0.724301852460641, -89.0219421386719, -1.55372599683971, 218, 18, 'PPL', 'P'),
(157983, 'Triumph', 41.4911117553711, 0.72415651044415, -80.7472229003906, -1.40930490145358, 218, 41, 'PPL', 'P'),
(168056, 'Triumph', 41.6725006103516, 0.727322343189981, -79.4466705322266, -1.38660598053451, 218, 45, 'PPL', 'P'),
(195731, 'Triumph', 43.6450004577637, 0.761748960022408, -114.253326416016, -1.99409672731529, 218, 17, 'PPL', 'P'),
(91418, 'Triune', 35.8541717529297, 0.62577334766417, -86.6586074829102, -1.51247802577018, 218, 50, 'PPL', 'P'),
(111742, 'Triune', 39.4963912963867, 0.68934207077798, -79.9752807617188, -1.39583196949887, 218, 58, 'PPL', 'P'),
(185756, 'Triunfo Corner', 34.1575012207031, 0.596160860555252, -118.823890686035, -2.07386812250114, 218, 6, 'PPL', 'P'),
(121739, 'Trivoli', 40.690559387207, 0.710184235785049, -89.8919372558594, -1.5689102761109, 218, 18, 'PPL', 'P'),
(38590, 'Trixie', 37.3352813720703, 0.651623587101133, -83.6699981689453, -1.46031695318572, 218, 21, 'PPL', 'P'),
(185754, 'Trocha', 35.7980613708496, 0.62479403675232, -119.146110534668, -2.07949191977506, 218, 6, 'PPL', 'P'),
(209907, 'Trojan', 44.3422203063965, 0.773917741991307, -103.837501525879, -1.81230628867122, 218, 49, 'PPL', 'P'),
(106993, 'Trojan Woods', 37.2333297729492, 0.649844196018797, -77.4486083984375, -1.35173321764047, 218, 53, 'PPL', 'P'),
(157984, 'Trombley', 41.2538909912109, 0.720016227055458, -83.6452789306641, -1.45988552108913, 218, 41, 'PPL', 'P'),
(153196, 'Trombley Landing', 44.6366691589355, 0.779056843946833, -74.376106262207, -1.29810793908869, 218, 40, 'PPL', 'P'),
(133435, 'Trombly', 46.0430603027344, 0.803602999977012, -87.148063659668, -1.52102064759883, 218, 27, 'PPL', 'P'),
(138479, 'Trommald', 46.5052795410156, 0.81167024755108, -94.0180587768555, -1.64092468198968, 218, 28, 'PPL', 'P'),
(185755, 'Trona', 35.7627792358398, 0.624178247329267, -117.371940612793, -2.04852681314849, 218, 6, 'PPL', 'P'),
(138482, 'Trondjem', 44.4791717529297, 0.776307995648681, -93.3927764892578, -1.6300114473167, 218, 28, 'PPL', 'P'),
(179385, 'Troon', 33.7147216796875, 0.58843289970406, -111.852783203125, -1.95219934441394, 218, 5, 'PPL', 'P'),
(168053, 'Trooper', 40.1497192382813, 0.700744794459318, -75.4022216796875, -1.3160170316292, 218, 45, 'PPL', 'P'),
(98632, 'Trophy Club', 32.9977798461914, 0.575919904164268, -97.1833267211914, -1.69616902932618, 218, 51, 'PPL', 'P'),
(18379, 'Tropic', 28.1641693115234, 0.491557485575229, -80.6161117553711, -1.40701658028693, 218, 12, 'PPL', 'P'),
(74570, 'Tropic', 39.7374992370605, 0.693550198195441, -82.0713882446289, -1.43241594655134, 218, 41, 'PPL', 'P'),
(192827, 'Tropic', 37.6252784729004, 0.656684991331856, -112.081390380859, -1.9561892923591, 218, 52, 'PPL', 'P'),
(18380, 'Tropic Isle', 26.4349994659424, 0.461377778443637, -80.0680618286133, -1.39745130459969, 218, 12, 'PPL', 'P'),
(43392, 'Tropical Bend', 29.4011096954346, 0.513146167925361, -89.6069412231445, -1.56393615698491, 218, 22, 'PPL', 'P'),
(98633, 'Tropical Farms Colonia', 26.2220001220703, 0.457660238588482, -97.9899978637695, -1.71024809674499, 218, 51, 'PPL', 'P'),
(18381, 'Tropical Gulf Acres', 26.8416690826416, 0.468475502222862, -81.9911117553711, -1.43101485750185, 218, 12, 'PPL', 'P'),
(18382, 'Tropical Park', 27.0980606079102, 0.472950378513008, -80.2777786254883, -1.4011115532019, 218, 12, 'PPL', 'P'),
(98634, 'Tropicana Colonia', 26.30299949646, 0.459073944363637, -98.0400009155273, -1.71112081463421, 218, 51, 'PPL', 'P'),
(138483, 'Trosky', 43.8891716003418, 0.766010550398753, -96.2566680908203, -1.67999578518418, 218, 28, 'PPL', 'P'),
(38591, 'Trosper', 36.788330078125, 0.642077486173744, -83.8191680908203, -1.46292045946738, 218, 21, 'PPL', 'P'),
(98635, 'Trosper Road Colonia', 26.2900009155273, 0.458847076328276, -98.3219985961914, -1.71604260264478, 218, 51, 'PPL', 'P'),
(121741, 'Troster', 40.3183288574219, 0.703687587463855, -88.4797210693359, -1.54426245390611, 218, 18, 'PPL', 'P'),
(126369, 'Trots Hills', 41.2874984741211, 0.720602788285548, -70.158332824707, -1.22449390550115, 218, 23, 'PPL', 'P'),
(168054, 'Trotter', 40.0086097717285, 0.69828196966224, -79.621940612793, -1.38966502052063, 218, 45, 'PPL', 'P'),
(31323, 'Trotter Crossing', 38.5113906860352, 0.672150566993191, -86.3655624389648, -1.50736342489668, 218, 19, 'PPL', 'P'),
(62076, 'Trotter Landing', 34.5436096191406, 0.602899723377588, -90.5330581665039, -1.58009994690503, 218, 30, 'PPL', 'P'),
(199012, 'Trotters', 47.3230590820313, 0.825943193097251, -103.917778015137, -1.81370737772071, 218, 34, 'PPL', 'P'),
(84084, 'Trotters Ridge', 33.0252799987793, 0.576399872371728, -80.2272186279297, -1.4002291147747, 218, 48, 'PPL', 'P'),
(69625, 'Trotville', 36.3688888549805, 0.63475685581128, -76.5980606079102, -1.3368883582502, 218, 33, 'PPL', 'P'),
(74571, 'Trotwood', 39.7972183227539, 0.694592492867071, -84.311393737793, -1.47151141766982, 218, 41, 'PPL', 'P'),
(6392, 'Trotwood Park', 33.565559387207, 0.585829526580453, -86.7355575561523, -1.5138210579079, 218, 2, 'PPL', 'P'),
(194456, 'Troublesome', 40.0608291625977, 0.699193369966292, -106.291107177734, -1.85512978584164, 218, 7, 'PPL', 'P'),
(168055, 'Trough Creek', 40.2816696166992, 0.703047763011964, -78.1313934326172, -1.36365006457024, 218, 45, 'PPL', 'P'),
(98636, 'Troup', 32.1444396972656, 0.561026308926054, -95.1202774047852, -1.66016202612387, 218, 51, 'PPL', 'P'),
(25579, 'Troup Factory (historical)', 32.9444389343262, 0.574988929626204, -84.9236068725586, -1.48219655259543, 218, 13, 'PPL', 'P'),
(52207, 'Troupe Springs', 39.6741714477539, 0.692444919764031, -77.7930603027344, -1.35774503748521, 218, 25, 'PPL', 'P'),
(153198, 'Troupsburg', 42.0436096191406, 0.733799417277163, -77.54638671875, -1.35343977126699, 218, 40, 'PPL', 'P'),
(25572, 'Troupville', 30.8488903045654, 0.538414706401223, -83.3375015258789, -1.45451379201239, 218, 13, 'PPL', 'P'),
(34195, 'Trousdale', 37.8152809143066, 0.660001159521223, -99.0852813720703, -1.72936440020763, 218, 20, 'PPL', 'P'),
(77489, 'Trousdale', 35.0411109924316, 0.61158276037471, -97.0425033569336, -1.69371119795614, 218, 42, 'PPL', 'P'),
(91420, 'Trousdale', 35.6694412231445, 0.622549191690466, -85.9388885498047, -1.49991656069855, 218, 50, 'PPL', 'P'),
(38592, 'Trout', 38.6386108398438, 0.674370977552045, -85.4088897705078, -1.49066633696827, 218, 21, 'PPL', 'P'),
(43393, 'Trout', 31.6955604553223, 0.553191888210287, -92.1786117553711, -1.60882027504878, 218, 22, 'PPL', 'P'),
(69626, 'Trout', 36.3950004577637, 0.63521258925282, -81.6094436645508, -1.42435349266724, 218, 33, 'PPL', 'P'),
(111744, 'Trout', 38.0166702270508, 0.663516066106936, -80.4680633544922, -1.40443264823928, 218, 58, 'PPL', 'P'),
(195732, 'Trout', 42.3224983215332, 0.738666943380528, -113.900283813477, -1.98793497150117, 218, 17, 'PPL', 'P'),
(199734, 'Trout', 41.8963890075684, 0.731229932878427, -103.602783203125, -1.80820968112441, 218, 35, 'PPL', 'P'),
(98637, 'Trout Creek', 30.6172199249268, 0.534371295497183, -93.8091735839844, -1.63727894761542, 218, 51, 'PPL', 'P'),
(133437, 'Trout Creek', 46.4822196960449, 0.811267777331342, -89.0116729736328, -1.55354676609834, 218, 27, 'PPL', 'P'),
(153200, 'Trout Creek', 42.2036094665527, 0.736591941417193, -75.2797164916992, -1.31387891274803, 218, 40, 'PPL', 'P'),
(168057, 'Trout Creek', 40.747501373291, 0.711178060924839, -75.6208267211914, -1.3198324093649, 218, 45, 'PPL', 'P'),
(192828, 'Trout Creek', 39.6894416809082, 0.692711435610121, -113.827781677246, -1.98666957050922, 218, 52, 'PPL', 'P'),
(197718, 'Trout Creek', 47.8369407653809, 0.834912120437392, -115.597221374512, -2.01755211914199, 218, 31, 'PPL', 'P'),
(201681, 'Trout Creek', 43.9272193908691, 0.766674609616564, -118.938888549805, -2.07587521385668, 218, 43, 'PPL', 'P'),
(106994, 'Trout Dale', 36.7019386291504, 0.640569670943568, -81.440559387207, -1.42140590597274, 218, 53, 'PPL', 'P'),
(133438, 'Trout Lake', 46.1936111450195, 0.806230607866539, -85.0188903808594, -1.48385956353813, 218, 27, 'PPL', 'P'),
(208979, 'Trout Lake', 45.997501373291, 0.802807846654542, -121.52693939209, -2.12104522226356, 218, 56, 'PPL', 'P'),
(153201, 'Trout River', 44.9913902282715, 0.785247894532941, -74.3086090087891, -1.29692988978049, 218, 40, 'PPL', 'P'),
(168058, 'Trout Run', 41.3861083984375, 0.722323856140012, -77.0572204589844, -1.34490220944441, 218, 45, 'PPL', 'P'),
(189716, 'Trout Springs', 35.6597213745117, 0.622379548329027, -105.339996337891, -1.83852977013496, 218, 38, 'PPL', 'P'),
(121742, 'Trout Valley', 42.1980590820313, 0.736495068932541, -88.2533264160156, -1.54031112179676, 218, 18, 'PPL', 'P'),
(153202, 'Troutburg', 43.3644409179688, 0.756852272305107, -77.9902801513672, -1.36118717319414, 218, 40, 'PPL', 'P'),
(129106, 'Troutdale', 45.292781829834, 0.790508170318065, -69.8363876342773, -1.21887490191719, 218, 26, 'PPL', 'P'),
(187458, 'Troutdale', 39.6369400024414, 0.691795108458052, -105.347503662109, -1.83866079766059, 218, 7, 'PPL', 'P'),
(201682, 'Troutdale', 45.5394401550293, 0.794813170220178, -122.386108398438, -2.13604055025542, 218, 43, 'PPL', 'P'),
(25573, 'Troutman', 31.9366703033447, 0.557400048917262, -84.6969375610352, -1.47824042679612, 218, 13, 'PPL', 'P'),
(69627, 'Troutman', 35.7005615234375, 0.623092343394787, -80.8883285522461, -1.41176765967163, 218, 33, 'PPL', 'P'),
(168059, 'Troutman', 40.9880599975586, 0.715376600962376, -79.7941665649414, -1.392670930443, 218, 45, 'PPL', 'P'),
(168064, 'Trouts Corners', 41.2333297729492, 0.71965736609857, -80.4711074829102, -1.40448577830303, 218, 45, 'PPL', 'P'),
(52208, 'Troutville', 39.5533294677734, 0.690335829338743, -77.3375015258789, -1.34979403689273, 218, 25, 'PPL', 'P'),
(106995, 'Troutville', 37.4180603027344, 0.653068351992501, -79.875, -1.39408174003047, 218, 53, 'PPL', 'P'),
(168060, 'Troutville', 41.0255584716797, 0.716031072800263, -78.7855606079102, -1.37506743563758, 218, 45, 'PPL', 'P'),
(168062, 'Troutwell', 40.6872215270996, 0.710125979136203, -76.982780456543, -1.34360298630662, 218, 45, 'PPL', 'P'),
(179386, 'Trovia', 33.7561111450195, 0.589155282149744, -111.970558166504, -1.95425490530132, 218, 5, 'PPL', 'P'),
(176732, 'Trow (historical)', 44.4916687011719, 0.776526108541958, -90.7624969482422, -1.58410440907813, 218, 57, 'PPL', 'P'),
(28807, 'Trowbridge', 39.3102798461914, 0.68609381319641, -88.5177764892578, -1.54492664628198, 218, 18, 'PPL', 'P'),
(133440, 'Trowbridge', 45.2294387817383, 0.789402625570546, -84.5863876342773, -1.47631096658636, 218, 27, 'PPL', 'P'),
(157985, 'Trowbridge', 41.5800018310547, 0.725707934937175, -83.2811126708984, -1.45352962083155, 218, 41, 'PPL', 'P'),
(168063, 'Trowbridge', 41.9583282470703, 0.732310976543918, -76.9797210693359, -1.34354958992676, 218, 45, 'PPL', 'P'),
(185758, 'Trowbridge', 38.910831451416, 0.679122123515774, -121.524169921875, -2.12099688588978, 218, 6, 'PPL', 'P'),
(111746, 'Trowbridge (historical)', 39.4286117553711, 0.688159094621767, -79.6855621337891, -1.39077542553714, 218, 58, 'PPL', 'P'),
(133441, 'Trowbridge Park', 46.5566711425781, 0.812567200206219, -87.4372177124023, -1.52606733786453, 218, 27, 'PPL', 'P'),
(126370, 'Trowbridgeville (historical)', 42.2449989318848, 0.737314323862877, -71.8380584716797, -1.25381064857102, 218, 23, 'PPL', 'P'),
(179388, 'Troweek', 33.9288902282715, 0.592170846031068, -109.059997558594, -1.90345603961444, 218, 5, 'PPL', 'P'),
(106996, 'Trower', 37.6058311462402, 0.656345571450925, -75.7422180175781, -1.32195108717011, 218, 53, 'PPL', 'P'),
(52214, 'Troxel', 39.7063903808594, 0.693007246228201, -77.3361129760742, -1.34976980212681, 218, 25, 'PPL', 'P'),
(121743, 'Troxel', 41.834171295166, 0.730144028943948, -88.5963897705078, -1.54629870687558, 218, 18, 'PPL', 'P'),
(168065, 'Troxelville', 40.8030586242676, 0.712147717877737, -77.2055587768555, -1.34749120149813, 218, 45, 'PPL', 'P'),
(69628, 'Troxlers Mill', 36.0402793884277, 0.629021538666712, -79.6830596923828, -1.39073174969526, 218, 33, 'PPL', 'P'),
(199, 'Troy', 39.019718170166, 0.681022555269654, -80.7633285522461, -1.40958599810664, 218, 58, 'PPL', 'P'),
(495, 'Troy', 37.9952812194824, 0.663142757501134, -86.7977828979492, -1.51490709500044, 218, 19, 'PPL', 'P'),
(6393, 'Troy', 31.8086109161377, 0.555164990972413, -85.9700012207031, -1.50045957924481, 218, 2, 'PPL', 'P'),
(12388, 'Troy', 33.5008316040039, 0.584699813646041, -93.0869369506836, -1.6246735403858, 218, 4, 'PPL', 'P'),
(28808, 'Troy', 38.7291717529297, 0.675951563659007, -89.883056640625, -1.56875528013546, 218, 18, 'PPL', 'P'),
(34196, 'Troy', 39.7830581665039, 0.694345351517912, -95.0897216796875, -1.65962872811558, 218, 20, 'PPL', 'P'),
(38593, 'Troy', 37.9099998474121, 0.661654316767889, -84.6947174072266, -1.47820167780226, 218, 21, 'PPL', 'P'),
(43394, 'Troy', 31.8125, 0.555232868290696, -91.4508285522461, -1.59611806191353, 218, 22, 'PPL', 'P'),
(57944, 'Troy', 38.9794387817383, 0.6803195473209, -90.9805603027344, -1.58791033259196, 218, 29, 'PPL', 'P'),
(62077, 'Troy', 34.1188888549805, 0.595486947641407, -88.8850021362305, -1.55133594291942, 218, 30, 'PPL', 'P'),
(69629, 'Troy', 35.3583297729492, 0.617119272543903, -79.8947219848633, -1.39442595360136, 218, 33, 'PPL', 'P'),
(77490, 'Troy', 34.327220916748, 0.59912302805672, -96.7813873291016, -1.68915386354074, 218, 42, 'PPL', 'P'),
(84086, 'Troy', 33.9874992370605, 0.593193766205767, -82.2980575561523, -1.43637207235066, 218, 48, 'PPL', 'P'),
(91422, 'Troy', 36.3386116027832, 0.634228418071981, -89.1638870239258, -1.55620340244375, 218, 50, 'PPL', 'P'),
(98638, 'Troy', 31.2066707611084, 0.544659153367186, -97.3024978637695, -1.69824895813753, 218, 51, 'PPL', 'P'),
(106997, 'Troy', 37.9508285522461, 0.662366912096567, -78.2466735839844, -1.3656620827738, 218, 53, 'PPL', 'P'),
(118071, 'Troy', 40.7486114501953, 0.71119743542177, -92.2024993896484, -1.60923719291743, 218, 16, 'PPL', 'P'),
(129103, 'Troy', 44.6647186279297, 0.779546399534217, -69.2413864135742, -1.20849017156254, 218, 26, 'PPL', 'P'),
(133444, 'Troy', 42.6055603027344, 0.743607306939707, -83.1500015258789, -1.4512412996649, 218, 27, 'PPL', 'P'),
(138486, 'Troy', 43.8708305358887, 0.765690438435726, -92.0677795410156, -1.606885887991, 218, 28, 'PPL', 'P'),
(144572, 'Troy', 42.8238906860352, 0.747417890985447, -72.1816711425781, -1.25980782102977, 218, 36, 'PPL', 'P'),
(153205, 'Troy', 42.728328704834, 0.745750019773757, -73.6922225952148, -1.28617191739906, 218, 40, 'PPL', 'P'),
(157986, 'Troy', 40.0394401550293, 0.69882006136049, -84.2033309936523, -1.46962536698582, 218, 41, 'PPL', 'P'),
(168068, 'Troy', 41.1175003051758, 0.717635760515091, -79.1933288574219, -1.38218433417665, 218, 45, 'PPL', 'P'),
(171439, 'Troy', 45.0374984741211, 0.786052635235335, -96.8649978637695, -1.69061314266005, 218, 49, 'PPL', 'P'),
(172654, 'Troy', 44.9013900756836, 0.783677095542985, -72.4019393920898, -1.26365222722135, 218, 55, 'PPL', 'P'),
(176733, 'Troy', 42.7788887023926, 0.746632458200955, -88.4447174072266, -1.54365152475205, 218, 57, 'PPL', 'P'),
(179387, 'Troy', 33.1436080932617, 0.578465087218057, -110.898612976074, -1.9355459323274, 218, 5, 'PPL', 'P'),
(185759, 'Troy', 39.3116683959961, 0.68611804796233, -120.461936950684, -2.10245742311925, 218, 6, 'PPL', 'P'),
(195734, 'Troy', 46.7369384765625, 0.815713458718038, -116.768608093262, -2.03799667419832, 218, 17, 'PPL', 'P'),
(197719, 'Troy', 48.4633293151855, 0.845844663028277, -115.888610839844, -2.02263782471766, 218, 31, 'PPL', 'P'),
(201683, 'Troy', 45.9469413757324, 0.801925408227344, -117.450561523438, -2.04989900690015, 218, 43, 'PPL', 'P'),
(6394, 'Troy (historical)', 32.3677787780762, 0.564924311234576, -88.0425033569336, -1.53663156527665, 218, 2, 'PPL', 'P'),
(12389, 'Troy (historical)', 33.422779083252, 0.583337540169439, -91.5827789306641, -1.59842103046618, 218, 4, 'PPL', 'P'),
(43395, 'Troy (historical)', 30.9947204589844, 0.540959922744525, -90.8872222900391, -1.58628127695316, 218, 22, 'PPL', 'P'),
(118072, 'Troy (historical)', 41.0366706848145, 0.716225017506648, -93.4255599975586, -1.6305836274769, 218, 16, 'PPL', 'P'),
(121744, 'Troy (historical)', 40.6908302307129, 0.710188962895984, -90.3349990844727, -1.57664316381011, 218, 18, 'PPL', 'P'),
(190848, 'Troy (historical)', 38.3430595397949, 0.669212634257643, -115.573608398438, -2.0171399949633, 218, 39, 'PPL', 'P'),
(129104, 'Troy Center', 44.6824989318848, 0.779856724380239, -69.2572174072266, -1.20876647452563, 218, 26, 'PPL', 'P'),
(168069, 'Troy Center', 41.6425018310547, 0.726798765719672, -79.8261108398438, -1.39322846321721, 218, 45, 'PPL', 'P'),
(176734, 'Troy Center', 42.8097190856934, 0.747170549899206, -88.4649963378906, -1.54400545886092, 218, 57, 'PPL', 'P'),
(28809, 'Troy Crossing', 38.7055587768555, 0.675539439480317, -89.9569396972656, -1.57004478273528, 218, 18, 'PPL', 'P'),
(121745, 'Troy Grove', 41.4677810668945, 0.723749313113477, -89.0830612182617, -1.55479272601434, 218, 18, 'PPL', 'P'),
(168070, 'Troy Hill', 40.4688911437988, 0.706315395090464, -79.978889465332, -1.39589495325865, 218, 45, 'PPL', 'P'),
(146475, 'Troy Hills', 40.8527793884277, 0.713015508918939, -74.3925018310547, -1.29839409574781, 218, 37, 'PPL', 'P'),
(28810, 'Troy Junction', 38.7344398498535, 0.676043509295642, -89.9280624389648, -1.56954077949898, 218, 18, 'PPL', 'P'),
(118073, 'Troy Mills', 42.2900009155273, 0.738099756647368, -91.6822204589844, -1.60015661254858, 218, 16, 'PPL', 'P'),
(139488, 'Troy Mills', 40.146671295166, 0.700691597816543, -92.6002807617188, -1.61617978756315, 218, 29, 'PPL', 'P'),
(111745, 'Troy Town', 37.8569412231445, 0.660728269077841, -82.0772171020508, -1.43251767930498, 218, 58, 'PPL', 'P'),
(157988, 'Troy Villa Mobile Home Park', 41.5027809143066, 0.724360175688513, -83.4663925170898, -1.45676336418518, 218, 41, 'PPL', 'P'),
(52209, 'Troyer', 39.6049995422363, 0.691237642262871, -76.5783309936523, -1.33654401152125, 218, 25, 'PPL', 'P'),
(157995, 'Troyton', 40.3941688537598, 0.705011245104652, -83.0802764892578, -1.45002436820478, 218, 41, 'PPL', 'P'),
(168074, 'Troytown', 40.0724983215332, 0.699397035210656, -79.8444366455078, -1.39354830886413, 218, 45, 'PPL', 'P'),
(14762, 'Tru Vale Acres', 38.7319412231445, 0.675999900032792, -75.1244430541992, -1.31116888002276, 218, 10, 'PPL', 'P'),
(176738, 'Truax', 44.8491706848145, 0.782765695238932, -91.5691680908203, -1.59818347649694, 218, 57, 'PPL', 'P'),
(199014, 'Truax', 47.3583297729492, 0.826558782783222, -101.646392822266, -1.77406422752407, 218, 34, 'PPL', 'P'),
(98639, 'Truby', 32.6452789306641, 0.569767602572022, -99.9250030517578, -1.74402030831856, 218, 51, 'PPL', 'P'),
(79279, 'Truce', 39.8899993896484, 0.696211827967894, -76.2380599975586, -1.33060516229038, 218, 45, 'PPL', 'P'),
(98640, 'Truce', 33.4130592346191, 0.583167896808001, -98.0305633544922, -1.71095609812079, 218, 51, 'PPL', 'P'),
(189717, 'Truchas', 36.0436096191406, 0.629079662157503, -105.811111450195, -1.84675228000058, 218, 38, 'PPL', 'P'),
(197720, 'Truchot Hill', 47.8363914489746, 0.834902533057468, -112.191390991211, -1.95810916518894, 218, 31, 'PPL', 'P'),
(18383, 'Truck Corner', 28.6916694641113, 0.50076410004266, -81.1797180175781, -1.4168533652473, 218, 12, 'PPL', 'P'),
(185760, 'Truckee', 39.3280601501465, 0.686404138042432, -120.182220458984, -2.09757544936697, 218, 6, 'PPL', 'P'),
(25574, 'Truckers', 32.3555603027344, 0.564711058610288, -81.6341705322266, -1.42478505792189, 218, 13, 'PPL', 'P'),
(185761, 'Truckhaven', 33.2969398498535, 0.58114123121845, -115.976387023926, -2.02416980813473, 218, 6, 'PPL', 'P'),
(18384, 'Truckland', 26.4986095428467, 0.462487983723064, -81.9680633544922, -1.4306125870192, 218, 12, 'PPL', 'P'),
(168080, 'Trucksville', 41.3038902282715, 0.72088887836565, -75.932502746582, -1.32527218220749, 218, 45, 'PPL', 'P'),
(168075, 'Trucksville Gardens', 41.3122215270996, 0.721034286961168, -75.9205627441406, -1.3250637898522, 218, 45, 'PPL', 'P'),
(187459, 'Truckton', 38.7380599975586, 0.676106692792504, -104.181671142578, -1.81831318166795, 218, 7, 'PPL', 'P'),
(195733, 'Trude', 44.461109161377, 0.775992743954643, -111.345283508301, -1.94334180378639, 218, 17, 'PPL', 'P'),
(208980, 'Trude', 47.389720916748, 0.827106661598479, -121.924438476563, -2.12798289006127, 218, 56, 'PPL', 'P'),
(153204, 'Trudeau', 44.3422203063965, 0.773917741991307, -74.1216735839844, -1.29366725112903, 218, 40, 'PPL', 'P'),
(25575, 'Trudie', 31.2999992370605, 0.54628804255842, -81.9644393920898, -1.43054933694331, 218, 13, 'PPL', 'P'),
(25576, 'Trudy', 34.2666702270508, 0.598066219157149, -83.9358291625977, -1.4649565792788, 218, 13, 'PPL', 'P'),
(25577, 'Trudy Estates', 34.204719543457, 0.596984975754577, -83.9430618286133, -1.46508281311447, 218, 13, 'PPL', 'P'),
(98641, 'True', 33.2797203063965, 0.580840693489435, -98.7283325195313, -1.72313446746961, 218, 51, 'PPL', 'P'),
(111747, 'True', 37.5805587768555, 0.655904485395381, -80.936393737793, -1.41260655541501, 218, 58, 'PPL', 'P'),
(84085, 'True Blue', 33.4472198486328, 0.583764111997042, -79.1500015258789, -1.38142812958512, 218, 48, 'PPL', 'P'),
(106998, 'True Blue', 38.3558311462402, 0.669435540840883, -77.9266662597656, -1.36007690133569, 218, 53, 'PPL', 'P'),
(52210, 'True Estates', 39.4972190856934, 0.689356518426893, -76.9400024414063, -1.34285636909501, 218, 25, 'PPL', 'P'),
(111748, 'Truebada', 38.9300003051758, 0.679456683127715, -80.7777786254883, -1.40983819946187, 218, 58, 'PPL', 'P'),
(143226, 'Trued', 40.7277793884277, 0.710833847353947, -99.4638900756836, -1.73597236866239, 218, 35, 'PPL', 'P'),
(52211, 'Trueman Pointe', 38.3694381713867, 0.669673028231091, -76.4674987792969, -1.33460962446348, 218, 25, 'PPL', 'P'),
(168076, 'Truemans', 41.6186103820801, 0.726381781271993, -79.1338882446289, -1.38114689977401, 218, 45, 'PPL', 'P'),
(57945, 'Truesdale', 38.8116683959961, 0.677391401702358, -91.1302795410156, -1.59052342625355, 218, 29, 'PPL', 'P'),
(118078, 'Truesdale', 42.7291717529297, 0.74576473373878, -95.182502746582, -1.6612480632164, 218, 16, 'PPL', 'P'),
(153207, 'Truesdale Lake', 41.2836112976074, 0.720534944256778, -73.5599975585938, -1.28386415515645, 218, 40, 'PPL', 'P'),
(168077, 'Truesdale Terrace', 41.1777801513672, 0.718687842303726, -75.958610534668, -1.32572784907001, 218, 45, 'PPL', 'P'),
(176740, 'Truesdell', 42.5666694641113, 0.742928533756873, -87.9011077880859, -1.53416374705253, 218, 57, 'PPL', 'P'),
(74573, 'Truetown', 39.4497184753418, 0.688527476379552, -82.1083297729492, -1.43306069785125, 218, 41, 'PPL', 'P'),
(6395, 'Truett', 33.0969390869141, 0.577650559398656, -85.5952835083008, -1.49391952139785, 218, 2, 'PPL', 'P'),
(133447, 'Trufant', 43.3138885498047, 0.755969967035964, -85.3544387817383, -1.48971598793327, 218, 27, 'PPL', 'P'),
(106999, 'Truhart', 37.648609161377, 0.657092188662529, -76.8399963378906, -1.34111093331658, 218, 53, 'PPL', 'P'),
(107000, 'Truit', 36.9355583190918, 0.644647103730534, -77.5500030517578, -1.35350288818482, 218, 53, 'PPL', 'P'),
(38594, 'Truitt', 38.5750007629395, 0.673260772272618, -83.0086135864258, -1.44877361459883, 218, 21, 'PPL', 'P'),
(52212, 'Truitt', 38.3466682434082, 0.669275618017424, -75.3655624389648, -1.3153772071773, 218, 25, 'PPL', 'P'),
(62078, 'Truitt', 32.8069381713867, 0.572589088588906, -89.9088897705078, -1.56920615330801, 218, 30, 'PPL', 'P'),
(14763, 'Truitts Midway Development', 38.7305603027344, 0.675975798424927, -75.1352767944336, -1.31135796446016, 218, 10, 'PPL', 'P'),
(14764, 'Truitts Park', 38.7055587768555, 0.675539439480317, -75.091667175293, -1.31059683302061, 218, 10, 'PPL', 'P'),
(168078, 'Truittsburg', 41.0622215270996, 0.716670963831182, -79.2841720581055, -1.38376984713163, 218, 45, 'PPL', 'P'),
(187460, 'Trujillo', 37.1005592346191, 0.647526912975291, -107.04638671875, -1.86831190060532, 218, 7, 'PPL', 'P'),
(189718, 'Trujillo', 35.5347213745117, 0.620197886764035, -104.690826416016, -1.82719961759333, 218, 38, 'PPL', 'P'),
(12391, 'Trull', 33.1474990844727, 0.578532997825854, -92.8352813720703, -1.62028132195799, 218, 4, 'PPL', 'P'),
(185762, 'Trull', 37.9386100769043, 0.662153659472279, -121.500556945801, -2.12058476171109, 218, 6, 'PPL', 'P'),
(197721, 'Truly', 47.3558311462402, 0.826515173520372, -111.440559387207, -1.94500468157104, 218, 31, 'PPL', 'P'),
(138489, 'Truman', 43.8277816772461, 0.764939094113187, -94.4369430541992, -1.64823559181417, 218, 28, 'PPL', 'P'),
(168079, 'Truman', 41.4769401550293, 0.723909169357909, -78.3688888549805, -1.3677951416489, 218, 45, 'PPL', 'P'),
(176741, 'Truman', 42.7194404602051, 0.74559489064026, -90.2297210693359, -1.57480571581601, 218, 57, 'PPL', 'P'),
(57946, 'Truman Corners', 38.9080581665039, 0.679073720562961, -94.5194396972656, -1.64967542985752, 218, 29, 'PPL', 'P'),
(12392, 'Trumann', 35.6736106872559, 0.622621962567252, -90.5072174072266, -1.57964894057443, 218, 4, 'PPL', 'P'),
(153206, 'Trumansburg', 42.5422210693359, 0.742501828771215, -76.666389465332, -1.33808092178634, 218, 40, 'PPL', 'P'),
(168081, 'Trumbauersville', 40.4105606079102, 0.705297335184754, -75.3786087036133, -1.31560490745051, 218, 45, 'PPL', 'P'),
(98642, 'Trumbull', 32.4902801513672, 0.567062363536719, -96.665283203125, -1.6871274642673, 218, 51, 'PPL', 'P'),
(114187, 'Trumbull', 41.2427787780762, 0.719822282349073, -73.2011108398438, -1.27760040027258, 218, 8, 'PPL', 'P'),
(143225, 'Trumbull', 40.6794395446777, 0.709990157920609, -98.273063659668, -1.71518852688319, 218, 35, 'PPL', 'P'),
(157996, 'Trumbull', 41.6780586242676, 0.727419348832687, -80.9541702270508, -1.412916813682, 218, 41, 'PPL', 'P'),
(187462, 'Trumbull', 39.2630615234375, 0.685269697997085, -105.218887329102, -1.83641601917776, 218, 7, 'PPL', 'P'),
(153212, 'Trumbull Corners', 42.3836097717285, 0.739733539397105, -76.6327819824219, -1.33749436055625, 218, 40, 'PPL', 'P'),
(52213, 'Trump', 39.6822204589844, 0.692585401511533, -76.6025009155273, -1.33696585623792, 218, 25, 'PPL', 'P'),
(157999, 'Trump', 40.8283309936523, 0.712588803933282, -81.3486099243164, -1.41980108509986, 218, 41, 'PPL', 'P'),
(187461, 'Trump', 38.8491706848145, 0.678045940119272, -105.787780761719, -1.84634508266991, 218, 7, 'PPL', 'P'),
(91423, 'Trundle Crossroad', 35.8863906860352, 0.62633567412834, -83.7352828979492, -1.46145638665811, 218, 50, 'PPL', 'P'),
(168086, 'Trunkeyville', 41.6130599975586, 0.726284908787341, -79.4022216796875, -1.38583020170897, 218, 45, 'PPL', 'P'),
(74574, 'Truro', 39.9338912963867, 0.696977886255455, -82.8836135864258, -1.44659195303384, 218, 41, 'PPL', 'P'),
(118079, 'Truro', 41.2097206115723, 0.719245308498907, -93.8463897705078, -1.63792849260529, 218, 16, 'PPL', 'P'),
(121750, 'Truro', 40.9575004577637, 0.714843236375061, -90.0422210693359, -1.57153322346852, 218, 18, 'PPL', 'P'),
(126373, 'Truro', 41.9933280944824, 0.732921839118955, -70.0502777099609, -1.22260798797521, 218, 23, 'PPL', 'P'),
(199017, 'Truro', 48.6938896179199, 0.849868699435386, -101.445831298828, -1.77056376858727, 218, 34, 'PPL', 'P'),
(126371, 'Truro Station (historical)', 41.9916687011719, 0.7328928772421, -70.0708312988281, -1.22296671577405, 218, 23, 'PPL', 'P'),
(98643, 'Truscott', 33.7541694641113, 0.589121393424873, -99.8108291625977, -1.7420275980329, 218, 51, 'PPL', 'P'),
(6396, 'Trussville', 33.6197204589844, 0.586774815609377, -86.60888671875, -1.51161023472898, 218, 2, 'PPL', 'P'),
(69631, 'Trust', 35.752498626709, 0.623998816850823, -82.870002746582, -1.4463543990646, 218, 33, 'PPL', 'P'),
(79280, 'Trust', 39.9263916015625, 0.696846991887878, -77.3986129760742, -1.3508606329093, 218, 45, 'PPL', 'P'),
(12393, 'Truth (historical)', 36.0936088562012, 0.629952313467695, -93.6236114501953, -1.63404027741377, 218, 4, 'PPL', 'P'),
(185763, 'Truth Home', 38.5800018310547, 0.673348057377345, -123.137496948242, -2.1491547544113, 218, 6, 'PPL', 'P'),
(189719, 'Truth or Consequences', 33.1283302307129, 0.578198438213913, -107.252220153809, -1.87190437175778, 218, 38, 'PPL', 'P'),
(153208, 'Truthville', 43.4502792358398, 0.758350433576331, -73.3252792358398, -1.27976754760964, 218, 40, 'PPL', 'P'),
(168083, 'Truxall', 40.5486106872559, 0.707706763601975, -79.5408325195313, -1.3882494172432, 218, 45, 'PPL', 'P'),
(107001, 'Truxillo', 37.3708305358887, 0.652244037056094, -78.0419387817383, -1.36208878638119, 218, 53, 'PPL', 'P'),
(43396, 'Truxno', 32.9474983215332, 0.57504232600606, -92.4058303833008, -1.61278598822801, 218, 22, 'PPL', 'P'),
(57947, 'Truxton', 39.0019416809082, 0.68071229700266, -91.2397232055664, -1.59243357854541, 218, 29, 'PPL', 'P'),
(153209, 'Truxton', 42.7119407653809, 0.745463996272683, -76.0288925170898, -1.3269545010681, 218, 40, 'PPL', 'P'),
(179389, 'Truxton', 35.4850006103516, 0.619330095722832, -113.562782287598, -1.98204445864408, 218, 5, 'PPL', 'P'),
(13234, 'Truxton Circle', 38.9097213745117, 0.679102749018843, -77.0152816772461, -1.34417023961881, 218, 9, 'PPL', 'P'),
(52215, 'Truxton Heights', 38.9666709899902, 0.680096707316688, -76.5061111450195, -1.33528353737732, 218, 25, 'PPL', 'P'),
(107004, 'Tryme', 38.4536094665527, 0.671142094467406, -78.1719436645508, -1.36435779962993, 218, 53, 'PPL', 'P'),
(18385, 'Tryon', 27.2477798461914, 0.475563472174594, -81.9533309936523, -1.43035545881595, 218, 12, 'PPL', 'P'),
(69636, 'Tryon', 35.3397216796875, 0.616794500048968, -81.3222198486328, -1.41934049138933, 218, 33, 'PPL', 'P'),
(77491, 'Tryon', 35.8697204589844, 0.626044723779249, -96.9636077880859, -1.69233421051452, 218, 42, 'PPL', 'P'),
(91424, 'Tryon', 35.9841690063477, 0.628042227754863, -83.3230590820313, -1.45426172381521, 218, 50, 'PPL', 'P'),
(199735, 'Tryon', 41.5527801513672, 0.725232826998705, -100.957221984863, -1.76203592730267, 218, 35, 'PPL', 'P'),
(194018, 'Tryon Corner', 41.877498626709, 0.730900233535476, -124.145278930664, -2.16674386814683, 218, 6, 'PPL', 'P'),
(153211, 'Tryons Corners', 42.8172187805176, 0.747301444266783, -77.9419403076172, -1.3603434837608, 218, 40, 'PPL', 'P'),
(168084, 'Tryonville', 41.7016716003418, 0.727831473011377, -79.7850036621094, -1.39251100761954, 218, 45, 'PPL', 'P'),
(168085, 'Trythall', 40.1800003051758, 0.701273298777644, -75.7525024414063, -1.32213058422758, 218, 45, 'PPL', 'P'),
(62079, 'Tryus', 31.6913890838623, 0.553119084043987, -90.1991729736328, -1.57427255096578, 218, 30, 'PPL', 'P'),
(77492, 'Tsa La Gi Indian Village', 35.8663902282715, 0.625986600288458, -94.9583282470703, -1.65733548010091, 218, 42, 'PPL', 'P'),
(189720, 'Tsaya', 36.1330604553223, 0.630640873767535, -108.173606872559, -1.88798560368411, 218, 38, 'PPL', 'P'),
(171444, 'Tschetter Colony', 43.3702812194824, 0.75695420479583, -97.6858291625977, -1.70493935142802, 218, 49, 'PPL', 'P'),
(189721, 'Tse Bonito', 35.6566696166992, 0.622326285107226, -109.040557861328, -1.90311675289156, 218, 38, 'PPL', 'P'),
(179390, 'Tsegi', 36.6494407653809, 0.639653410370527, -110.428611755371, -1.92734286353774, 218, 5, 'PPL', 'P'),
(192829, 'Tselakai Dezza', 37.2030601501465, 0.649315891437552, -109.605827331543, -1.91298256630782, 218, 52, 'PPL', 'P'),
(179391, 'Tsintaa Yiti Ii', 35.8255615234375, 0.62527400495978, -109.811668395996, -1.91657517061833, 218, 5, 'PPL', 'P'),
(194019, 'Tsurau (historical)', 41.0597190856934, 0.716627287989305, -124.141937255859, -2.16668554491896, 218, 6, 'PPL', 'P'),
(201684, 'Tualatin', 45.3841705322266, 0.792103204073941, -122.76277923584, -2.14261469656433, 218, 43, 'PPL', 'P'),
(179392, 'Tuba City', 36.1349983215332, 0.630674695913379, -111.239166259766, -1.9414897084063, 218, 5, 'PPL', 'P'),
(179393, 'Tubac', 31.6124992370605, 0.551742196470902, -111.045280456543, -1.93810576276719, 218, 5, 'PPL', 'P'),
(12394, 'Tubal', 33.0625, 0.577049483940625, -92.9194412231445, -1.62175018845722, 218, 4, 'PPL', 'P'),
(192338, 'Tubbs Corner', 31.3824996948242, 0.547727947180798, -102.616668701172, -1.79099873626366, 218, 51, 'PPL', 'P'),
(25578, 'Tube (historical)', 34.5708312988281, 0.603374831316059, -83.9683303833008, -1.46552383259099, 218, 13, 'PPL', 'P'),
(194020, 'Tuber', 41.936939239502, 0.731937667938116, -121.45027923584, -2.11970725013191, 218, 6, 'PPL', 'P'),
(208981, 'Tucannon', 46.4891700744629, 0.811389084318995, -117.959167480469, -2.0587758554456, 218, 56, 'PPL', 'P'),
(38595, 'Tuck', 37.6816711425781, 0.657669229091722, -87.1530609130859, -1.52110786612453, 218, 21, 'PPL', 'P'),
(107002, 'Tuck Fork', 37.8274993896484, 0.660214412145511, -77.2555618286133, -1.34836391938735, 218, 53, 'PPL', 'P'),
(57948, 'Tuckahoe', 37.1286087036133, 0.648016468562675, -94.529167175293, -1.64984520637701, 218, 29, 'PPL', 'P'),
(69637, 'Tuckahoe', 36.1522216796875, 0.630975300221422, -75.746940612793, -1.32203351200585, 218, 33, 'PPL', 'P'),
(71482, 'Tuckahoe', 39.2900009155273, 0.685739879087539, -74.7541732788086, -1.30470645332158, 218, 37, 'PPL', 'P'),
(107003, 'Tuckahoe', 37.5900001525879, 0.65606926848783, -77.5566711425781, -1.35361926832446, 218, 53, 'PPL', 'P'),
(111749, 'Tuckahoe', 37.7522201538086, 0.65890054162172, -80.2736129760742, -1.40103884890414, 218, 58, 'PPL', 'P'),
(153214, 'Tuckahoe', 40.9502792358398, 0.714717202276473, -73.8277816772461, -1.28853786971149, 218, 40, 'PPL', 'P'),
(14766, 'Tuckahoe Acres', 38.5888900756836, 0.673503186510843, -75.1208267211914, -1.31110576310493, 218, 10, 'PPL', 'P'),
(6398, 'Tuckahoe Heights', 34.0697212219238, 0.594628810559157, -86.0202789306641, -1.50133709082399, 218, 2, 'PPL', 'P'),
(52216, 'Tuckahoe Springs', 38.8333282470703, 0.677769437419095, -75.9055633544922, -1.32480200111704, 218, 25, 'PPL', 'P'),
(107006, 'Tuckahoe Village', 37.5977783203125, 0.656205023124396, -77.623893737793, -1.3547925239427, 218, 53, 'PPL', 'P'),
(91425, 'Tuckaleechee', 35.6733283996582, 0.622617035719235, -83.7750015258789, -1.46214960748986, 218, 50, 'PPL', 'P'),
(69639, 'Tuckasegee', 35.2702789306641, 0.615582495436873, -83.1227798461914, -1.45076619172643, 218, 33, 'PPL', 'P'),
(69640, 'Tuckaway Park', 35.100830078125, 0.61262505504634, -80.8236083984375, -1.41063807989528, 218, 33, 'PPL', 'P'),
(91426, 'Tuckegee (historical)', 35.0666694641113, 0.612028839857298, -85.3444366455078, -1.48954141772382, 218, 50, 'PPL', 'P'),
(6400, 'Tucker', 33.9708290100098, 0.592902815856676, -87.7736129760742, -1.53193854280371, 218, 2, 'PPL', 'P'),
(12396, 'Tucker', 34.4444389343262, 0.601168868406119, -91.9544372558594, -1.60490769193329, 218, 4, 'PPL', 'P'),
(25580, 'Tucker', 33.8544387817383, 0.590871423156191, -84.2172164916992, -1.46986771464502, 218, 13, 'PPL', 'P'),
(57950, 'Tucker', 36.5447196960449, 0.637825682914405, -91.0711135864258, -1.58949078554087, 218, 29, 'PPL', 'P'),
(62080, 'Tucker', 32.7063903808594, 0.570834198588598, -89.0538864135742, -1.55428352961391, 218, 30, 'PPL', 'P'),
(77493, 'Tucker', 35.3036117553711, 0.616164262977001, -94.7300033569336, -1.65335045900377, 218, 42, 'PPL', 'P'),
(98644, 'Tucker', 31.6733303070068, 0.552803898928976, -95.7477798461914, -1.67111400979071, 218, 51, 'PPL', 'P'),
(179394, 'Tucker', 33.6408309936523, 0.587143263946189, -110.606666564941, -1.93045050621375, 218, 5, 'PPL', 'P'),
(192830, 'Tucker', 39.934440612793, 0.696987473635379, -111.198608398438, -1.94078184018855, 218, 52, 'PPL', 'P'),
(197722, 'Tucker', 46.3708305358887, 0.809323669735584, -114.141670227051, -1.99214795918762, 218, 31, 'PPL', 'P'),
(6401, 'Tucker (historical)', 34.3083305358887, 0.598793328713768, -85.7186126708984, -1.49607202134891, 218, 2, 'PPL', 'P'),
(201685, 'Tucker (historical)', 45.0666694641113, 0.786561765056731, -123.29167175293, -2.15184561237671, 218, 43, 'PPL', 'P'),
(6402, 'Tucker Crossroads', 34.1349983215332, 0.595768110873492, -85.5719375610352, -1.49351205775107, 218, 2, 'PPL', 'P'),
(69641, 'Tucker Estates', 35.5833282470703, 0.621046236729279, -77.3555603027344, -1.35010922200774, 218, 33, 'PPL', 'P'),
(69642, 'Tucker Farms', 35.5758285522461, 0.620915342361702, -77.4172210693359, -1.35118540540424, 218, 33, 'PPL', 'P'),
(153215, 'Tucker Heights', 42.9099998474121, 0.748920779367606, -73.9375, -1.29045281569331, 218, 40, 'PPL', 'P'),
(107007, 'Tucker Hill', 38.0663909912109, 0.664383857148139, -76.5944366455078, -1.33682510817431, 218, 53, 'PPL', 'P'),
(25581, 'Tucker Mobile Home Park', 33.8666687011719, 0.591084875517561, -84.1738891601563, -1.46911151005349, 218, 13, 'PPL', 'P'),
(91427, 'Tucker Springs', 35.1113891601563, 0.612809345793773, -84.9641723632813, -1.48290455397123, 218, 50, 'PPL', 'P'),
(153216, 'Tucker Terrace', 44.9486083984375, 0.78450121074231, -74.9736099243164, -1.30853634528522, 218, 40, 'PPL', 'P'),
(69643, 'Tuckerdale', 36.5277786254883, 0.637530005454379, -81.5330581665039, -1.42302031422554, 218, 33, 'PPL', 'P'),
(12397, 'Tuckerman', 35.7305603027344, 0.623615920865097, -91.1983337402344, -1.59171119609972, 218, 4, 'PPL', 'P'),
(18386, 'Tuckers Corner', 26.8575000762939, 0.468751805185958, -81.7597198486328, -1.4269763068668, 218, 12, 'PPL', 'P'),
(57951, 'Tuckers Corner', 37.3305587768555, 0.651541162265395, -94.4844436645508, -1.64906463386151, 218, 29, 'PPL', 'P'),
(91428, 'Tuckers Corner', 36.0050010681152, 0.628405815822686, -88.8455581665039, -1.55064751577763, 218, 50, 'PPL', 'P'),
(98646, 'Tuckers Corner', 33.4272193908691, 0.58341503815716, -94.7088928222656, -1.65298201066696, 218, 51, 'PPL', 'P'),
(153217, 'Tuckers Corner', 41.6674995422363, 0.727235058085254, -74.0294418334961, -1.29205750340813, 218, 40, 'PPL', 'P'),
(28811, 'Tuckers Corners', 37.9908294677734, 0.663065059776331, -88.5955581665039, -1.54628419264764, 218, 18, 'PPL', 'P'),
(62083, 'Tuckers Crossing', 32.6538887023926, 0.569917871436529, -89.5738906860352, -1.5633593162928, 218, 30, 'PPL', 'P'),
(25582, 'Tuckers Crossroad', 32.7008285522461, 0.570737126366865, -82.8652801513672, -1.44627197422886, 218, 13, 'PPL', 'P'),
(91429, 'Tuckers Crossroads', 36.1988906860352, 0.631789828040822, -86.1738891601563, -1.50401809509338, 218, 50, 'PPL', 'P'),
(91430, 'Tuckers Gap (historical)', 36.1852798461914, 0.631552274071587, -86.3791732788086, -1.50760097886592, 218, 50, 'PPL', 'P'),
(52222, 'Tuckers Reach', 38.6980590820313, 0.67540854511274, -76.6119384765625, -1.33713057275134, 218, 25, 'PPL', 'P'),
(284, 'Tuckersburg', 32.7594413757324, 0.571760113120592, -85.3675003051758, -1.48994395452258, 218, 2, 'PPL', 'P'),
(71483, 'Tuckerton', 39.6030616760254, 0.691203820117027, -74.3405609130859, -1.29748755571275, 218, 37, 'PPL', 'P'),
(168087, 'Tuckerton', 40.4047203063965, 0.705195402694031, -75.9372177124023, -1.32535447388518, 218, 45, 'PPL', 'P'),
(71484, 'Tuckerton Shores', 39.6069412231445, 0.691271530987742, -74.3252792358398, -1.29722084012958, 218, 37, 'PPL', 'P'),
(12398, 'Tuckertown', 35.8097190856934, 0.624997502259603, -89.9358291625977, -1.56967633439846, 218, 4, 'PPL', 'P'),
(38596, 'Tuckertown', 37.0763893127441, 0.647105068258623, -86.2613906860352, -1.50554528482048, 218, 21, 'PPL', 'P'),
(79281, 'Tuckertown', 39.973331451416, 0.697666246818213, -79.8283309936523, -1.39326721221107, 218, 45, 'PPL', 'P'),
(84088, 'Tuckertown', 34.5261116027832, 0.602594325379583, -81.4861068725586, -1.42220085955813, 218, 48, 'PPL', 'P'),
(169637, 'Tuckertown', 41.4302787780762, 0.723094774696562, -71.5430603027344, -1.24866195923557, 218, 47, 'PPL', 'P'),
(169638, 'Tuckertown Four Corners', 41.4283294677734, 0.723060752813637, -71.5597229003906, -1.2489527764266, 218, 47, 'PPL', 'P'),
(192929, 'Tuckerville', 37.4925003051758, 0.654367575130296, -107.484718322754, -1.87596223031073, 218, 7, 'PPL', 'P'),
(6403, 'Tucktown', 33.4630584716797, 0.584040548118192, -86.1569366455078, -1.50372221789627, 218, 2, 'PPL', 'P'),
(74577, 'Tucson', 39.3563919067383, 0.686898620477832, -82.8261108398438, -1.44558834077704, 218, 41, 'PPL', 'P'),
(179395, 'Tucson', 32.2216682434082, 0.562374201332771, -110.925827026367, -1.93602090710782, 218, 5, 'PPL', 'P'),
(179396, 'Tucson Country Club Estates', 32.2591705322266, 0.563028739749685, -110.858062744141, -1.93483819726771, 218, 5, 'PPL', 'P'),
(179397, 'Tucson Estates', 32.1875, 0.561777852985675, -111.090278625488, -1.93889112897265, 218, 5, 'PPL', 'P'),
(179398, 'Tucson National Estates', 32.3530616760254, 0.564667449347438, -111.025001525879, -1.93775182865832, 218, 5, 'PPL', 'P'),
(189722, 'Tucumcari', 35.1716690063477, 0.613861427582409, -103.72444152832, -1.81033301946153, 218, 38, 'PPL', 'P'),
(185764, 'Tudor', 39.0050010681152, 0.680765693382516, -121.622497558594, -2.12271302689623, 218, 6, 'PPL', 'P'),
(52218, 'Tudor Forest', 39.5511093139648, 0.690297080344882, -76.3019409179688, -1.33172009468074, 218, 25, 'PPL', 'P'),
(52219, 'Tudor Manor', 39.5597190856934, 0.69044734920939, -76.3191680908203, -1.33202076556781, 218, 25, 'PPL', 'P'),
(114189, 'Tudor Village', 41.7508316040039, 0.728689476935574, -72.6147232055664, -1.26736600536147, 218, 8, 'PPL', 'P'),
(98645, 'Tuff', 29.7688903808594, 0.519565151811265, -99.4033279418945, -1.73491536002574, 218, 51, 'PPL', 'P'),
(52220, 'Tufton Farms', 39.4847183227539, 0.689138338954589, -76.7333297729492, -1.33924925055656, 218, 25, 'PPL', 'P'),
(52221, 'Tufton Ridge Estates', 39.4863891601563, 0.689167500568525, -76.727783203125, -1.33915244465093, 218, 25, 'PPL', 'P'),
(144574, 'Tuftonboro', 43.6963882446289, 0.76264584609852, -71.2225036621094, -1.24306719041753, 218, 36, 'PPL', 'P'),
(126374, 'Tufts Village (historical)', 42.0783309936523, 0.734405419583211, -71.9383316040039, -1.25556074488136, 218, 23, 'PPL', 'P'),
(169639, 'Tug Hollow', 41.5597190856934, 0.725353934249277, -71.6455612182617, -1.25045093769783, 218, 47, 'PPL', 'P'),
(25583, 'Tugaloo', 34.7075004577637, 0.605760158125415, -83.366943359375, -1.45502764894472, 218, 13, 'PPL', 'P'),
(107008, 'Tuggle', 37.3058280944824, 0.65110953043172, -78.4888916015625, -1.36988958468819, 218, 53, 'PPL', 'P'),
(38597, 'Tuggleville', 36.7722206115723, 0.641796322941659, -83.5044403076172, -1.45742742340299, 218, 21, 'PPL', 'P'),
(84089, 'Tugtown', 33.3144416809082, 0.581446695795482, -80.3349990844727, -1.40211023861068, 218, 48, 'PPL', 'P'),
(43397, 'Tugwell', 32.8886108398438, 0.574014545562371, -92.3816680908203, -1.6123642766694, 218, 22, 'PPL', 'P'),
(69644, 'Tugwell (historical)', 35.6480598449707, 0.622176016242718, -77.6241683959961, -1.35479731763266, 218, 33, 'PPL', 'P'),
(185766, 'Tujunga', 34.2522201538086, 0.597814017801919, -118.287498474121, -2.06450631232118, 218, 6, 'PPL', 'P'),
(208982, 'Tukey', 48.0541687011719, 0.838703463144256, -122.841667175293, -2.1439915508479, 218, 56, 'PPL', 'P'),
(208983, 'Tukwila', 47.4741706848145, 0.828580588103783, -122.259719848633, -2.13383465392451, 218, 56, 'PPL', 'P'),
(62084, 'Tula', 34.232780456543, 0.597474731079042, -89.3622207641602, -1.55966497922864, 218, 30, 'PPL', 'P'),
(133448, 'Tula', 46.5463905334473, 0.812387769727775, -89.8147201538086, -1.56756258344127, 218, 27, 'PPL', 'P'),
(208984, 'Tulalip', 48.0686111450195, 0.838955531341432, -122.290557861328, -2.13437287878081, 218, 56, 'PPL', 'P'),
(208985, 'Tulalip Bay', 48.0374984741211, 0.838412512795165, -122.308891296387, -2.13469285758578, 218, 56, 'PPL', 'P'),
(18387, 'Tulane', 30.3638896942139, 0.529949848876406, -81.9436111450195, -1.43018581545451, 218, 12, 'PPL', 'P'),
(98647, 'Tulane', 30.0955600738525, 0.525266613520475, -93.8386077880859, -1.63779267138969, 218, 51, 'PPL', 'P'),
(171445, 'Tulare', 44.7380599975586, 0.780826447912164, -98.5094375610352, -1.71931402972784, 218, 49, 'PPL', 'P'),
(185768, 'Tulare', 36.2077789306641, 0.63194495717432, -119.346389770508, -2.08298745186384, 218, 6, 'PPL', 'P'),
(208986, 'Tulare Beach', 48.1019401550293, 0.839537232302533, -122.341941833496, -2.1352696982779, 218, 56, 'PPL', 'P'),
(189723, 'Tularosa', 33.0738906860352, 0.577248288916, -106.018058776855, -1.850364192229, 218, 38, 'PPL', 'P'),
(200243, 'Tulasco', 41.1297187805176, 0.717849013139379, -115.121673583984, -2.00925224444671, 218, 39, 'PPL', 'P'),
(200244, 'Tule', 41.024169921875, 0.716006838034344, -117.649169921875, -2.053365377375, 218, 39, 'PPL', 'P'),
(201686, 'Tule Lake (historical)', 42.1111106872559, 0.734977533164387, -121.280563354492, -2.11674514920947, 218, 43, 'PPL', 'P'),
(194021, 'Tulelake', 41.9561080932617, 0.732272227550057, -121.476387023926, -2.12016291699442, 218, 6, 'PPL', 'P'),
(98648, 'Tuleta', 28.5705604553223, 0.498650349085464, -97.7969436645508, -1.70687866533382, 218, 51, 'PPL', 'P'),
(176742, 'Tuleta Hills', 43.8086090087891, 0.764604467922219, -88.9811096191406, -1.553013334932, 218, 57, 'PPL', 'P'),
(192339, 'Tulia', 34.535831451416, 0.602763968741022, -101.758056640625, -1.77601312880979, 218, 51, 'PPL', 'P'),
(69645, 'Tulin (historical)', 35.4655609130859, 0.618990808999956, -80.7174987792969, -1.40878611767323, 218, 33, 'PPL', 'P'),
(12399, 'Tulip', 34.082218170166, 0.594846923452434, -92.6536102294922, -1.61711056236414, 218, 4, 'PPL', 'P'),
(31325, 'Tulip', 39.0819396972656, 0.682108525783161, -86.8866729736328, -1.51645851949346, 218, 19, 'PPL', 'P'),
(43398, 'Tulip', 32.6816711425781, 0.570402766492006, -92.9863891601563, -1.62291865038549, 218, 22, 'PPL', 'P'),
(57952, 'Tulip', 39.3427810668945, 0.686661066508597, -92.1569366455078, -1.60844197301593, 218, 29, 'PPL', 'P'),
(74576, 'Tulip', 38.7344398498535, 0.676043509295642, -83.4150009155273, -1.45586641153004, 218, 41, 'PPL', 'P'),
(98649, 'Tulip', 33.8080596923828, 0.590061955342861, -96.1311111450195, -1.67780440308121, 218, 51, 'PPL', 'P'),
(107009, 'Tulip', 39.0325012207031, 0.681245661589975, -78.2272186279297, -1.36532252973481, 218, 53, 'PPL', 'P'),
(91432, 'Tulip Grove', 36.2000007629395, 0.631809202537753, -86.5922164916992, -1.51131928437988, 218, 50, 'PPL', 'P'),
(52224, 'Tulip Hill', 38.9672203063965, 0.680106294696612, -77.1338882446289, -1.34624031473412, 218, 25, 'PPL', 'P'),
(107010, 'Tulip Tree Acres', 37.3302803039551, 0.651536301996406, -79.1624984741211, -1.3816462424784, 218, 53, 'PPL', 'P'),
(208988, 'Tulips', 47.0722198486328, 0.821565222581269, -124.039169311523, -2.16489190592479, 218, 56, 'PPL', 'P'),
(208987, 'Tulker', 48.2816696166992, 0.84267410317151, -121.764167785645, -2.12518563881031, 218, 56, 'PPL', 'P'),
(12400, 'Tull', 34.4477806091309, 0.601227191633991, -92.5761108398438, -1.61575794284649, 218, 4, 'PPL', 'P'),
(43399, 'Tulla', 30.7402801513672, 0.536519101626818, -93.2502822875977, -1.62752445433273, 218, 22, 'PPL', 'P'),
(77494, 'Tullahassee', 35.8347206115723, 0.625433861204212, -95.4375, -1.66569860487209, 218, 42, 'PPL', 'P'),
(91435, 'Tullahoma', 35.3619384765625, 0.617182256303683, -86.2094421386719, -1.50463861162737, 218, 50, 'PPL', 'P'),
(112282, 'Tullamore', 34.1575012207031, 0.596160860555252, -84.3480606079102, -1.47215137527976, 218, 13, 'PPL', 'P'),
(6404, 'Tullis', 31.8872203826904, 0.556536984986994, -85.1877822875977, -1.48680728339069, 218, 2, 'PPL', 'P'),
(43400, 'Tullis', 32.2705612182617, 0.563227544725059, -93.2858276367188, -1.62814483770866, 218, 22, 'PPL', 'P'),
(209796, 'Tullis', 41.2286109924316, 0.719575007841859, -107.298332214355, -1.8727091790392, 218, 59, 'PPL', 'P'),
(206159, 'Tullis Addition', 41.1599998474121, 0.718377517457705, -112.037780761719, -1.95542816091955, 218, 52, 'PPL', 'P'),
(43401, 'Tullos', 31.8191699981689, 0.555349281719846, -92.329719543457, -1.61145760347628, 218, 22, 'PPL', 'P'),
(69646, 'Tulls', 36.4911117553711, 0.636890047844433, -76.0741729736328, -1.32774479412158, 218, 33, 'PPL', 'P'),
(52225, 'Tulls Corner', 38.0152816772461, 0.663491831341017, -75.7544403076172, -1.32216440637343, 218, 25, 'PPL', 'P'),
(69647, 'Tulls Mill', 35.1530609130859, 0.613536655087474, -77.732780456543, -1.35669295569658, 218, 33, 'PPL', 'P'),
(18388, 'Tully', 30.1041698455811, 0.525416882384982, -84.3811111450195, -1.47272821597187, 218, 12, 'PPL', 'P'),
(126375, 'Tully', 42.6375007629395, 0.744164773134888, -72.2486114501953, -1.26097614979998, 218, 23, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(139489, 'Tully', 40.1377792358398, 0.700536402104019, -91.522216796875, -1.59736402182953, 218, 29, 'PPL', 'P'),
(153218, 'Tully', 42.7980613708496, 0.746967084391924, -76.1097183227539, -1.32836517749751, 218, 40, 'PPL', 'P'),
(179400, 'Tully', 31.982780456543, 0.55820482290917, -110.122779846191, -1.92200508976489, 218, 5, 'PPL', 'P'),
(153219, 'Tully Center', 42.7988891601563, 0.746981532040837, -76.1224975585938, -1.32858821723881, 218, 40, 'PPL', 'P'),
(153220, 'Tully Lake Park', 42.7841682434082, 0.746724603574672, -76.1363906860352, -1.32883069805606, 218, 40, 'PPL', 'P'),
(168088, 'Tullytown', 40.1391716003418, 0.700560703448966, -74.8150024414063, -1.30576812249014, 218, 45, 'PPL', 'P'),
(12401, 'Tulot', 35.6188888549805, 0.621666886421322, -90.475830078125, -1.5791011283382, 218, 4, 'PPL', 'P'),
(168091, 'Tulpohocken', 40.0380592346191, 0.698795959752625, -75.1958312988281, -1.31241483993876, 218, 45, 'PPL', 'P'),
(77495, 'Tulsa', 36.1538887023926, 0.631004395256331, -95.9925003051758, -1.67538518754698, 218, 42, 'PPL', 'P'),
(6405, 'Tulse', 33.2449989318848, 0.580234691183387, -86.9027786254883, -1.51673961614652, 218, 2, 'PPL', 'P'),
(98650, 'Tulsita', 28.6427803039551, 0.499910823229398, -97.8158264160156, -1.70720823151872, 218, 51, 'PPL', 'P'),
(91433, 'Tulu', 35.0627784729004, 0.611960929249501, -88.3938903808594, -1.54276442579294, 218, 50, 'PPL', 'P'),
(212198, 'Tuluksak', 61.1025009155273, 1.0664398221788, -160.961669921875, -2.80931110964504, 218, 1, 'PPL', 'P'),
(69648, 'Tulula', 35.269718170166, 0.615572708319867, -83.7527770996094, -1.46176171807709, 218, 33, 'PPL', 'P'),
(179399, 'Tumacacori', 31.5686092376709, 0.550976171472854, -111.051666259766, -1.93821721605881, 218, 5, 'PPL', 'P'),
(201687, 'Tumalo', 44.1500015258789, 0.770562891387107, -121.329719543457, -2.11760308655464, 218, 43, 'PPL', 'P'),
(107011, 'Tumbez', 36.7680587768555, 0.641723685222927, -82.2658309936523, -1.43580961272843, 218, 53, 'PPL', 'P'),
(146476, 'Tumble Falls', 40.4536094665527, 0.706048679507292, -75.0625, -1.31008776977824, 218, 37, 'PPL', 'P'),
(69649, 'Tumblerville', 35.1138916015625, 0.61285302163565, -83.3641662597656, -1.45497917941288, 218, 33, 'PPL', 'P'),
(6406, 'Tumbleton', 31.4063892364502, 0.548144898338964, -85.2566680908203, -1.4880095674648, 218, 2, 'PPL', 'P'),
(91434, 'Tumbling', 36.2411117553711, 0.632526724714447, -88.5425033569336, -1.54535821153662, 218, 50, 'PPL', 'P'),
(107012, 'Tumbling Creek', 36.8741683959961, 0.643575647444968, -81.8461074829102, -1.42848405551795, 218, 53, 'PPL', 'P'),
(12402, 'Tumbling Shoals', 35.5419387817383, 0.620323854283595, -91.9672164916992, -1.60513073167458, 218, 4, 'PPL', 'P'),
(84090, 'Tumbling Shoals (historical)', 34.5055618286133, 0.602235664159777, -82.2249984741211, -1.43509695082073, 218, 48, 'PPL', 'P'),
(25589, 'Tumlin Heights', 34.2611083984375, 0.597969146935416, -83.8472213745117, -1.46341008163379, 218, 13, 'PPL', 'P'),
(208989, 'Tumtum', 47.8916702270508, 0.835867329741376, -117.681938171387, -2.05393729121909, 218, 56, 'PPL', 'P'),
(208990, 'Tumwater', 47.0074996948242, 0.820435642804912, -122.908058166504, -2.1451502922382, 218, 56, 'PPL', 'P'),
(168092, 'Tuna', 41.9961090087891, 0.732970375229821, -78.6175003051758, -1.37213423001296, 218, 45, 'PPL', 'P'),
(686, 'Tunas', 37.8497200012207, 0.660602234979253, -93.0274963378906, -1.62363610598316, 218, 29, 'PPL', 'P'),
(121752, 'Tunbridge', 40.1136093139648, 0.70011455738735, -89.0486068725586, -1.5541913842402, 218, 18, 'PPL', 'P'),
(172655, 'Tunbridge', 43.8908309936523, 0.766039512275608, -72.4916687011719, -1.26521829910037, 218, 55, 'PPL', 'P'),
(199019, 'Tunbridge', 48.3658294677734, 0.844142969670743, -100.105827331543, -1.74717628736835, 218, 34, 'PPL', 'P'),
(98653, 'Tundra', 32.4638900756836, 0.56660176982619, -95.8802795410156, -1.67342656572328, 218, 51, 'PPL', 'P'),
(212199, 'Tundra', 61.1333312988281, 1.06697791387705, -162.816665649414, -2.84168689270103, 218, 1, 'PPL', 'P'),
(171448, 'Tunerville', 44.8902816772461, 0.783483217415627, -96.6808319091797, -1.68739884038238, 218, 49, 'PPL', 'P'),
(69650, 'Tungsten', 36.5136108398438, 0.637282730947165, -78.4705581665039, -1.36956960588322, 218, 33, 'PPL', 'P'),
(197724, 'Tungsten', 46.2752799987793, 0.807655998260976, -113.061668395996, -1.97329837130815, 218, 31, 'PPL', 'P'),
(200245, 'Tungsten', 40.7791709899902, 0.711730800009085, -118.124168395996, -2.06165566469036, 218, 39, 'PPL', 'P'),
(187463, 'Tungsten (historical)', 39.9719390869141, 0.697641945473266, -105.475563049316, -1.84089585560544, 218, 7, 'PPL', 'P'),
(190853, 'Tungstonia (historical)', 39.6575012207031, 0.69215396941494, -114.163612365723, -1.99253092175237, 218, 39, 'PPL', 'P'),
(12403, 'Tuni', 34.9402809143066, 0.609822943526386, -90.7088928222656, -1.58316884058719, 218, 4, 'PPL', 'P'),
(43402, 'Tunica', 30.9291706085205, 0.539815862029741, -91.5550003051758, -1.59793620198973, 218, 22, 'PPL', 'P'),
(62085, 'Tunica', 34.684440612793, 0.605357687905677, -90.3827819824219, -1.57747713270547, 218, 30, 'PPL', 'P'),
(43403, 'Tunica (historical)', 31.8624992370605, 0.556105519600888, -92.5583267211914, -1.61544755142144, 218, 22, 'PPL', 'P'),
(43404, 'Tunica Landing', 30.922779083252, 0.53970430886958, -91.5561065673828, -1.59795550990763, 218, 22, 'PPL', 'P'),
(62086, 'Tunica North', 34.7027816772461, 0.605677799868705, -90.3777770996094, -1.57738978102171, 218, 30, 'PPL', 'P'),
(12405, 'Tunis', 35.9661102294922, 0.627727042639852, -90.5377807617188, -1.58018237174077, 218, 4, 'PPL', 'P'),
(52226, 'Tunis', 38.8277816772461, 0.677672631513471, -76.2669372558594, -1.33110916552668, 218, 25, 'PPL', 'P'),
(69651, 'Tunis', 36.3841705322266, 0.635023571394451, -76.8883285522461, -1.34195448959186, 218, 33, 'PPL', 'P'),
(98651, 'Tunis', 30.5447196960449, 0.533105927794746, -96.5269393920898, -1.68471290926498, 218, 51, 'PPL', 'P'),
(107013, 'Tunis', 38.7027816772461, 0.675490969948478, -78.8675003051758, -1.37649755314295, 218, 53, 'PPL', 'P'),
(177358, 'Tunis', 46.4433288574219, 0.810589004148508, -88.6175003051758, -1.5466671552124, 218, 27, 'PPL', 'P'),
(189724, 'Tunis', 32.2513885498047, 0.562892918534091, -107.917221069336, -1.88351082726251, 218, 38, 'PPL', 'P'),
(197723, 'Tunis', 47.8069381713867, 0.834388476388055, -110.841941833496, -1.93455683429855, 218, 31, 'PPL', 'P'),
(454, 'Tunis (historical)', 33.5074996948242, 0.584816193785678, -84.190559387207, -1.46940246040258, 218, 13, 'PPL', 'P'),
(52227, 'Tunis Mills', 38.8202781677246, 0.677541670566866, -76.1666717529297, -1.32935920237438, 218, 25, 'PPL', 'P'),
(25585, 'Tunis Trace', 33.4166717529297, 0.583230947146808, -84.4166717529297, -1.47334886566392, 218, 13, 'PPL', 'P'),
(129107, 'Tunk Lake', 44.5488891601563, 0.777524793950738, -68.1141662597656, -1.18881646848374, 218, 26, 'PPL', 'P'),
(123832, 'Tunker', 41.0486106872559, 0.716433409861947, -85.557502746582, -1.49326012271195, 218, 19, 'PPL', 'P'),
(168093, 'Tunkhannock', 41.5386085510254, 0.724985485912464, -75.9469375610352, -1.32552411724662, 218, 45, 'PPL', 'P'),
(13235, 'Tunlaw Heights (historical)', 38.9291687011719, 0.679442168899774, -77.0763931274414, -1.34523683563538, 218, 9, 'PPL', 'P'),
(153221, 'Tunnel', 42.2161102294922, 0.736810120889498, -75.726936340332, -1.32168437158694, 218, 40, 'PPL', 'P'),
(12404, 'Tunnel (historical)', 36.4483299255371, 0.636143364053802, -93.6872177124023, -1.63515041611417, 218, 4, 'PPL', 'P'),
(200246, 'Tunnel Camp (historical)', 40.4438896179199, 0.705879036145854, -118.770561218262, -2.07293734770015, 218, 39, 'PPL', 'P'),
(176743, 'Tunnel City', 44.0072212219238, 0.768070904976093, -90.565559387207, -1.58066720021722, 218, 57, 'PPL', 'P'),
(25586, 'Tunnel Hill', 34.8405609130859, 0.608082501174992, -85.0427780151367, -1.48427648140678, 218, 13, 'PPL', 'P'),
(28812, 'Tunnel Hill', 37.523609161377, 0.654910527097536, -88.8386077880859, -1.55052620878998, 218, 18, 'PPL', 'P'),
(38598, 'Tunnel Hill', 37.6841697692871, 0.657712838354572, -87.64111328125, -1.52962598687114, 218, 21, 'PPL', 'P'),
(158002, 'Tunnel Hill', 40.2547187805176, 0.702577382184428, -82.0491714477539, -1.43202819029663, 218, 41, 'PPL', 'P'),
(38599, 'Tunnel Hills', 37.732780456543, 0.658561254898844, -85.8313903808594, -1.49804036371059, 218, 21, 'PPL', 'P'),
(194022, 'Tunnel Inn', 40.726390838623, 0.710809612588027, -122.323608398438, -2.13494971947292, 218, 6, 'PPL', 'P'),
(6407, 'Tunnel Springs', 31.6424999237061, 0.552265807230725, -87.2399978637695, -1.5226252021556, 218, 2, 'PPL', 'P'),
(168097, 'Tunnelhill', 40.4780616760254, 0.706475451071977, -78.5411071777344, -1.37080091841322, 218, 45, 'PPL', 'P'),
(107014, 'Tunnels Mill', 37.9663887023926, 0.662638487948728, -75.5811080932617, -1.31913918853315, 218, 53, 'PPL', 'P'),
(31326, 'Tunnelton', 38.7686080932617, 0.676639857642738, -86.3427810668945, -1.50696581494593, 218, 19, 'PPL', 'P'),
(111752, 'Tunnelton', 39.3916702270508, 0.687514343321858, -79.7486114501953, -1.39187584369956, 218, 58, 'PPL', 'P'),
(168099, 'Tunnelton', 40.4602813720703, 0.706165126225956, -79.3888931274414, -1.38559757458775, 218, 45, 'PPL', 'P'),
(176744, 'Tunnelville', 43.5530586242676, 0.760144272307581, -90.658332824707, -1.58228640215999, 218, 57, 'PPL', 'P'),
(168100, 'Tunnelville (historical)', 40.7152786254883, 0.710615667881642, -79.5008316040039, -1.38755126956343, 218, 45, 'PPL', 'P'),
(107017, 'Tunstall', 37.5961112976074, 0.656175928089487, -77.102783203125, -1.34569742934591, 218, 53, 'PPL', 'P'),
(212200, 'Tuntutuliak', 60.3430595397949, 1.0531850696964, -162.663055419922, -2.83900588843164, 218, 1, 'PPL', 'P'),
(212201, 'Tununak', 60.5855598449707, 1.0574174984588, -165.255828857422, -2.88425832167427, 218, 1, 'PPL', 'P'),
(195735, 'Tunupa', 42.9550018310547, 0.749706212152097, -114.578330993652, -1.9997691272791, 218, 17, 'PPL', 'P'),
(114190, 'Tunxis Hill', 41.1761093139648, 0.71865868068979, -73.2411117553711, -1.27829854795235, 218, 8, 'PPL', 'P'),
(185771, 'Tuolumne', 37.9608306884766, 0.662541482306022, -120.236389160156, -2.09852087155395, 218, 6, 'PPL', 'P'),
(185772, 'Tuolumne City', 37.9627799987793, 0.662575504188948, -120.240280151367, -2.09858878216174, 218, 6, 'PPL', 'P'),
(185773, 'Tuolumne City (historical)', 37.6041717529297, 0.656316609574071, -121.129997253418, -2.11411727500383, 218, 6, 'PPL', 'P'),
(212202, 'Tuomi', 61.2799987792969, 1.06953774431684, -149.830001831055, -2.61502685022104, 218, 1, 'PPL', 'P'),
(43405, 'Tupawek', 32.5397186279297, 0.567925227729905, -92.1680603027344, -1.6086361174594, 218, 22, 'PPL', 'P'),
(6408, 'Tupelo', 34.7508316040039, 0.60651642929597, -86.0777816772461, -1.50234070308079, 218, 2, 'PPL', 'P'),
(12406, 'Tupelo', 35.3930587768555, 0.617725408008005, -91.2305603027344, -1.59227365572195, 218, 4, 'PPL', 'P'),
(62087, 'Tupelo', 34.2574996948242, 0.597906163175635, -88.7033309936523, -1.54816518332557, 218, 30, 'PPL', 'P'),
(77498, 'Tupelo', 34.6047210693359, 0.603966319394165, -96.4238891601563, -1.6829143434228, 218, 42, 'PPL', 'P'),
(98652, 'Tupelo', 32.2127685546875, 0.562218872462192, -96.4375915527344, -1.68315349528869, 218, 51, 'PPL', 'P'),
(185775, 'Tupman', 35.2980613708496, 0.616067390492349, -119.350280761719, -2.08305536247164, 218, 6, 'PPL', 'P'),
(172657, 'Tupper', 43.8072204589844, 0.764580233156299, -72.7852783203125, -1.2703427536699, 218, 55, 'PPL', 'P'),
(153226, 'Tupper Lake', 44.2238883972168, 0.771852460565951, -74.4644393920898, -1.29964964304373, 218, 40, 'PPL', 'P'),
(91437, 'Tupper Town', 36.0525016784668, 0.629234857870028, -84.3452835083008, -1.47210290574792, 218, 50, 'PPL', 'P'),
(74578, 'Tuppers Plains', 39.1686096191406, 0.683621201282326, -81.8466720581055, -1.42849390921398, 218, 41, 'PPL', 'P'),
(197725, 'Turah', 46.836109161377, 0.817444313689508, -113.829170227051, -1.98669380527514, 218, 31, 'PPL', 'P'),
(129108, 'Turbats Creek', 43.3544387817383, 0.756677702095652, -70.4505615234375, -1.22959425846282, 218, 26, 'PPL', 'P'),
(84093, 'Turbeville', 33.8905601501465, 0.59150185996524, -80.0186080932617, -1.3965881740904, 218, 48, 'PPL', 'P'),
(107016, 'Turbeville', 36.6230583190918, 0.639192949818052, -79.0397186279297, -1.37950332990727, 218, 53, 'PPL', 'P'),
(168102, 'Turbotville', 41.1019401550293, 0.71736418466293, -76.7713928222656, -1.33991357609048, 218, 45, 'PPL', 'P'),
(34198, 'Turck', 37.2305603027344, 0.649795859645012, -94.831672668457, -1.65512492323809, 218, 20, 'PPL', 'P'),
(98654, 'Turcotte', 27.0069408416748, 0.471360038578554, -97.7949981689453, -1.70684471002992, 218, 51, 'PPL', 'P'),
(192340, 'Turf Estates Number 1 Colonia', 31.8059997558594, 0.555119417628259, -106.252998352051, -1.8544646613594, 218, 51, 'PPL', 'P'),
(179401, 'Turf Mobile Manor', 33.6272201538086, 0.586905709976954, -112.097503662109, -1.95647052217021, 218, 5, 'PPL', 'P'),
(179402, 'Turf Trailer Lodge', 33.6416702270508, 0.587157911332184, -112.094436645508, -1.9564169926323, 218, 5, 'PPL', 'P'),
(52230, 'Turf Valley', 39.1316719055176, 0.682976516561445, -76.5416717529297, -1.33590418706936, 218, 25, 'PPL', 'P'),
(52229, 'Turf Valley Overlook', 39.285831451416, 0.685667108210752, -76.8713912963867, -1.34165887871086, 218, 25, 'PPL', 'P'),
(25588, 'Turin', 33.3263893127441, 0.581655221308836, -84.6358337402344, -1.4771739639376, 218, 13, 'PPL', 'P'),
(118080, 'Turin', 42.0194396972656, 0.733377572560495, -95.9661102294922, -1.67492459383645, 218, 16, 'PPL', 'P'),
(153224, 'Turin', 43.6272201538086, 0.761438635176387, -75.4116668701172, -1.31618188130067, 218, 40, 'PPL', 'P'),
(12407, 'Turin (historical)', 34.2797203063965, 0.598293986009378, -92.4902801513672, -1.61425991473332, 218, 4, 'PPL', 'P'),
(185776, 'Turk', 36.1711082458496, 0.631304932985346, -120.22110748291, -2.09825415597077, 218, 6, 'PPL', 'P'),
(208991, 'Turk', 48.0541687011719, 0.838703463144256, -118.11222076416, -2.06144713917701, 218, 56, 'PPL', 'P'),
(133450, 'Turk Lake', 43.2708282470703, 0.755218422976343, -85.2563934326172, -1.48800477377484, 218, 27, 'PPL', 'P'),
(6410, 'Turkestan (historical)', 31.7766704559326, 0.554607524777232, -87.1549987792969, -1.52114168827037, 218, 2, 'PPL', 'P'),
(12408, 'Turkey', 36.2444381713867, 0.632584781626211, -92.7636108398438, -1.61903043519398, 218, 4, 'PPL', 'P'),
(38600, 'Turkey', 37.4791717529297, 0.654134948009078, -83.5077819824219, -1.45748574663086, 218, 21, 'PPL', 'P'),
(69652, 'Turkey', 34.9922218322754, 0.610729483561449, -78.1833267211914, -1.36455647144725, 218, 33, 'PPL', 'P'),
(74579, 'Turkey', 39.1083297729492, 0.68256911949369, -83.4488906860352, -1.45645789960814, 218, 41, 'PPL', 'P'),
(111753, 'Turkey', 37.6402816772461, 0.656946846646038, -81.5783309936523, -1.42381047412097, 218, 58, 'PPL', 'P'),
(192341, 'Turkey', 34.3925018310547, 0.600262394950083, -100.897216796875, -1.760988639204, 218, 51, 'PPL', 'P'),
(6409, 'Turkey Branch', 30.4216709136963, 0.530958321402192, -87.8363876342773, -1.53303416727617, 218, 2, 'PPL', 'P'),
(168104, 'Turkey City', 41.1852798461914, 0.718818736671304, -79.6136093139648, -1.38951961192511, 218, 45, 'PPL', 'P'),
(114191, 'Turkey Cobble', 41.9288902282715, 0.731797186190614, -73.1930618286133, -1.27745991852508, 218, 8, 'PPL', 'P'),
(12409, 'Turkey Creek', 35.7663917541504, 0.624241297668075, -92.209716796875, -1.60936316043699, 218, 4, 'PPL', 'P'),
(18389, 'Turkey Creek', 27.9777793884277, 0.48830436772467, -82.1849975585938, -1.43439880314096, 218, 12, 'PPL', 'P'),
(38601, 'Turkey Creek', 37.6708297729492, 0.657480011496272, -82.3072204589844, -1.43653199517412, 218, 21, 'PPL', 'P'),
(43406, 'Turkey Creek', 30.8769397735596, 0.538904261988607, -92.4130630493164, -1.61291222206368, 218, 22, 'PPL', 'P'),
(62089, 'Turkey Creek', 33.8875007629395, 0.591448463585384, -89.6819381713867, -1.56524510066068, 218, 30, 'PPL', 'P'),
(91438, 'Turkey Creek', 35.3063888549805, 0.61621273250884, -86.2813873291016, -1.50589429208134, 218, 50, 'PPL', 'P'),
(123833, 'Turkey Creek', 41.5558280944824, 0.72528602364148, -85.1708297729492, -1.48651140619358, 218, 19, 'PPL', 'P'),
(91439, 'Turkey Creek (historical)', 36.4938888549805, 0.636938517376273, -85.583610534668, -1.49371578957446, 218, 50, 'PPL', 'P'),
(25590, 'Turkey Creek Estates', 33.6061096191406, 0.586537261640142, -83.8927764892578, -1.46420516837724, 218, 13, 'PPL', 'P'),
(123834, 'Turkey Creek Meadows', 41.4952812194824, 0.724229281320936, -87.3433303833008, -1.5244286948458, 218, 19, 'PPL', 'P'),
(177644, 'Turkey Crossing', 34.4280586242676, 0.600882978063099, -111.021942138672, -1.93769843227846, 218, 5, 'PPL', 'P'),
(179403, 'Turkey Flat', 32.6308288574219, 0.569515401216791, -109.820556640625, -1.91673029975183, 218, 5, 'PPL', 'P'),
(18390, 'Turkey Foot', 26.0872192382813, 0.455307868397615, -81.0319366455078, -1.41427409373156, 218, 12, 'PPL', 'P'),
(38603, 'Turkey Foot', 38.3383293151855, 0.669130076263851, -84.5111083984375, -1.47499709606257, 218, 21, 'PPL', 'P'),
(158004, 'Turkey Foot Corner', 41.6725006103516, 0.727322343189981, -80.8363876342773, -1.41086111963657, 218, 41, 'PPL', 'P'),
(69653, 'Turkey Ford', 36.3875007629395, 0.635081694885242, -80.6630630493164, -1.40783603495435, 218, 33, 'PPL', 'P'),
(77499, 'Turkey Ford', 36.6674995422363, 0.639968595485538, -94.7152786254883, -1.65309346395858, 218, 42, 'PPL', 'P'),
(107019, 'Turkey Fork', 36.8161087036133, 0.642562314650193, -79.6336135864258, -1.38986875234402, 218, 53, 'PPL', 'P'),
(52232, 'Turkey Hill', 39.5122184753418, 0.689618307162048, -77.5347213745117, -1.35323617260165, 218, 25, 'PPL', 'P'),
(114192, 'Turkey Hill', 41.6155586242676, 0.726328518050191, -72.7861099243164, -1.27035726789784, 218, 8, 'PPL', 'P'),
(126377, 'Turkey Hill Shores', 42.3375015258789, 0.73892879869471, -71.9563903808594, -1.25587592999637, 218, 23, 'PPL', 'P'),
(98655, 'Turkey Hollow', 30.4822196960449, 0.532015097012249, -97.7425003051758, -1.70592844945688, 218, 51, 'PPL', 'P'),
(111754, 'Turkey Knob', 37.8988914489746, 0.661460438640532, -81.1530609130859, -1.41638811100487, 218, 58, 'PPL', 'P'),
(25591, 'Turkey Point', 33.065559387207, 0.577102880320481, -85.170280456543, -1.48650181881365, 218, 13, 'PPL', 'P'),
(52234, 'Turkey Point', 39.2938919067383, 0.685807789695336, -76.408332824707, -1.3335769837508, 218, 25, 'PPL', 'P'),
(71486, 'Turkey Point Corner', 39.2827796936035, 0.685613844988951, -75.1327819824219, -1.31131442177633, 218, 37, 'PPL', 'P'),
(84095, 'Turkey Pond', 33.2394409179688, 0.580137685540681, -79.6377792358398, -1.38994145664178, 218, 48, 'PPL', 'P'),
(52235, 'Turkey Ridge', 38.5527801513672, 0.672872949438875, -76.5777816772461, -1.33653442414133, 218, 25, 'PPL', 'P'),
(57953, 'Turkey Ridge', 37.8216705322266, 0.66011267939187, -92.3266677856445, -1.61140434025448, 218, 29, 'PPL', 'P'),
(168105, 'Turkey Ridge', 41.3250007629395, 0.721257326702462, -79.245002746582, -1.38308621367981, 218, 45, 'PPL', 'P'),
(171450, 'Turkey Ridge', 43.2436103820801, 0.7547433816169, -97.279167175293, -1.69784176080685, 218, 49, 'PPL', 'P'),
(118081, 'Turkey River', 42.7061080932617, 0.745362196940015, -91.0258331298828, -1.58870049248739, 218, 16, 'PPL', 'P'),
(107020, 'Turkey Run', 38.6716690063477, 0.674947951402211, -77.7441711425781, -1.35689176067195, 218, 53, 'PPL', 'P'),
(168107, 'Turkey Run', 40.8080596923828, 0.712235002982464, -76.20361328125, -1.33000395367429, 218, 45, 'PPL', 'P'),
(12411, 'Turkey Scratch', 34.6438903808594, 0.604649952845988, -90.9272232055664, -1.58697942463293, 218, 4, 'PPL', 'P'),
(6411, 'Turkey Town (historical)', 34.1361083984375, 0.595787485370423, -85.6916732788086, -1.49560184025845, 218, 2, 'PPL', 'P'),
(31327, 'Turkey Track', 39.3544387817383, 0.686864532015879, -86.4983291625977, -1.50968064136116, 218, 19, 'PPL', 'P'),
(91440, 'Turkey Track', 35.389720916748, 0.61766715135916, -87.5738906860352, -1.52845273125291, 218, 50, 'PPL', 'P'),
(91441, 'Turkeyfoot', 35.1074981689453, 0.612741435185976, -85.1722183227539, -1.4865356409595, 218, 50, 'PPL', 'P'),
(168109, 'Turkeyfoot', 40.2747192382813, 0.70292645602431, -80.038330078125, -1.39693238766129, 218, 45, 'PPL', 'P'),
(177283, 'Turkeyfoot (historical)', 40.521110534668, 0.707226795394516, -80.5302810668945, -1.40551855217376, 218, 58, 'PPL', 'P'),
(6412, 'Turkeytown', 34.0930595397949, 0.595036141047884, -85.8983306884766, -1.4992086924808, 218, 2, 'PPL', 'P'),
(38604, 'Turkeytown', 37.4205589294434, 0.653111961255351, -84.4869384765625, -1.4745752513459, 218, 21, 'PPL', 'P'),
(168110, 'Turkeytown', 40.1949996948242, 0.701535087512799, -79.7302780151367, -1.39155586489459, 218, 45, 'PPL', 'P'),
(91442, 'Turkeytown (historical)', 36.4561080932617, 0.636279118690369, -85.5158309936523, -1.49253281341825, 218, 50, 'PPL', 'P'),
(34202, 'Turkville', 39.103328704834, 0.682481834388963, -99.2452774047852, -1.73215685776863, 218, 20, 'PPL', 'P'),
(57954, 'Turley', 37.4466705322266, 0.653567694696891, -92.1819381713867, -1.60887833196054, 218, 29, 'PPL', 'P'),
(77500, 'Turley', 36.2419395446777, 0.632541172363361, -95.9755630493164, -1.67508957666598, 218, 42, 'PPL', 'P'),
(91443, 'Turley', 36.3694381713867, 0.634766443191204, -84.2736129760742, -1.47085201898391, 218, 50, 'PPL', 'P'),
(177722, 'Turley', 36.752498626709, 0.641452109370766, -107.764442443848, -1.88084433722107, 218, 38, 'PPL', 'P'),
(206161, 'Turley', 40.7083282470703, 0.710494360893989, -111.990280151367, -1.95459911887221, 218, 52, 'PPL', 'P'),
(91444, 'Turley Mills (historical)', 36.2633285522461, 0.632914480969163, -83.4180603027344, -1.45591980790989, 218, 50, 'PPL', 'P'),
(31328, 'Turleys', 38.5708312988281, 0.673188001395832, -86.5205612182617, -1.51006866393198, 218, 19, 'PPL', 'P'),
(107024, 'Turleytown', 38.6138916015625, 0.673939545455452, -78.8713912963867, -1.37656546375075, 218, 53, 'PPL', 'P'),
(69656, 'Turlington', 35.3633308410645, 0.61720655764863, -78.6641693115234, -1.37294875783236, 218, 33, 'PPL', 'P'),
(98656, 'Turlington', 31.6947193145752, 0.553177207534778, -96.0541687011719, -1.67646150410153, 218, 51, 'PPL', 'P'),
(107021, 'Turlington Park', 36.7005615234375, 0.64054563591473, -76.6213912963867, -1.33729555558087, 218, 53, 'PPL', 'P'),
(185777, 'Turlock', 37.4947204589844, 0.654406324124157, -120.845558166504, -2.10915287641581, 218, 6, 'PPL', 'P'),
(25592, 'Turman', 31.5013904571533, 0.549802982433647, -84.7294387817383, -1.47880768010831, 218, 13, 'PPL', 'P'),
(114193, 'Turn of River', 41.1030616760254, 0.717383758896942, -73.5486068725586, -1.28366535018108, 218, 8, 'PPL', 'P'),
(52240, 'Turn Quist', 39.6138916015625, 0.691392837975395, -75.790283203125, -1.32278998291349, 218, 25, 'PPL', 'P'),
(168111, 'Turn Villa', 41.0691719055176, 0.716792270818835, -75.0436096191406, -1.30975807043529, 218, 45, 'PPL', 'P'),
(212203, 'Turnagain Heights', 61.1958312988281, 1.06806874465955, -149.941390991211, -2.6169709578168, 218, 1, 'PPL', 'P'),
(69657, 'Turnage', 35.6883316040039, 0.622878891033417, -77.6619415283203, -1.35545658316051, 218, 33, 'PPL', 'P'),
(57955, 'Turnback (historical)', 37.3072204589844, 0.651133831776668, -93.7900009155273, -1.63694432142445, 218, 29, 'PPL', 'P'),
(192342, 'Turnbaugh Corner', 31.9797191619873, 0.5581513932398, -102.682220458984, -1.79214283026796, 218, 51, 'PPL', 'P'),
(6414, 'Turnbough Town', 33.6744384765625, 0.587729825176279, -86.4697189331055, -1.50918129865677, 218, 2, 'PPL', 'P'),
(84096, 'Turnbridge Landing', 32.1297187805176, 0.560769380459889, -81.0136108398438, -1.41395424808464, 218, 48, 'PPL', 'P'),
(6413, 'Turnbull', 31.7147197723389, 0.55352628137466, -87.1319427490234, -1.52073928462966, 218, 2, 'PPL', 'P'),
(18391, 'Turnbull', 28.7099990844727, 0.501084012268605, -80.8625030517578, -1.41131691965714, 218, 12, 'PPL', 'P'),
(43407, 'Turnbull', 30.954439163208, 0.540256881506258, -91.4669418334961, -1.59639929172465, 218, 22, 'PPL', 'P'),
(62090, 'Turnbull', 31.0222206115723, 0.541439890951985, -91.2919387817383, -1.59334491227043, 218, 30, 'PPL', 'P'),
(107022, 'Turnbull', 38.6674995422363, 0.674875180525424, -77.8605575561523, -1.35892308679341, 218, 53, 'PPL', 'P'),
(185778, 'Turnbull (historical)', 36.0486106872559, 0.629166947262231, -119.518890380859, -2.08599815547618, 218, 6, 'PPL', 'P'),
(153227, 'Turnbull Corner', 44.7747192382813, 0.781466272364055, -75.1463928222656, -1.31155197574557, 218, 40, 'PPL', 'P'),
(52236, 'Turnbull Estates', 38.9249992370605, 0.679369398022987, -76.5327835083008, -1.33574905793587, 218, 25, 'PPL', 'P'),
(6417, 'Turner', 33.5361099243164, 0.585315536490068, -86.0438919067383, -1.50174921500268, 218, 2, 'PPL', 'P'),
(12413, 'Turner', 34.4761085510254, 0.601721607490365, -91.0186080932617, -1.58857439180978, 218, 4, 'PPL', 'P'),
(31330, 'Turner', 39.4983291625977, 0.689375892923824, -87.1602783203125, -1.52123383364409, 218, 19, 'PPL', 'P'),
(34203, 'Turner', 39.0833282470703, 0.682132760549081, -94.7041702270508, -1.65289958583122, 218, 20, 'PPL', 'P'),
(52237, 'Turner', 39.2447204589844, 0.684949586034058, -76.5149993896484, -1.33543866651082, 218, 25, 'PPL', 'P'),
(57957, 'Turner', 36.5877799987793, 0.638577226974026, -89.9124984741211, -1.56926913706779, 218, 29, 'PPL', 'P'),
(62091, 'Turner', 33.9736099243164, 0.592951351967543, -90.2847213745117, -1.57576565223093, 218, 30, 'PPL', 'P'),
(107023, 'Turner', 36.7688903808594, 0.641738199450868, -76.8097229003906, -1.34058256215631, 218, 53, 'PPL', 'P'),
(111755, 'Turner', 38.4813919067383, 0.671626989522882, -81.311393737793, -1.41915154010999, 218, 58, 'PPL', 'P'),
(112789, 'Turner', 33.939998626709, 0.592364724158426, -97.3163909912109, -1.69849143895478, 218, 42, 'PPL', 'P'),
(129109, 'Turner', 44.2563896179199, 0.772419713878138, -70.2566680908203, -1.22621017966565, 218, 26, 'PPL', 'P'),
(133452, 'Turner', 46.1327781677246, 0.805168872118951, -87.9000015258789, -1.53414443913463, 218, 27, 'PPL', 'P'),
(168113, 'Turner', 41.2405586242676, 0.719783533355212, -80.1866683959961, -1.39952137971501, 218, 45, 'PPL', 'P'),
(185780, 'Turner', 38.3411102294922, 0.669178612374717, -122.776390075684, -2.14285225053357, 218, 6, 'PPL', 'P'),
(195737, 'Turner', 42.5766716003418, 0.743103103966328, -111.818061828613, -1.95159334210789, 218, 17, 'PPL', 'P'),
(197726, 'Turner', 48.8436088562012, 0.852481793096972, -108.406387329102, -1.89204838908508, 218, 31, 'PPL', 'P'),
(201688, 'Turner', 44.8433303833008, 0.782663762748209, -122.951667785645, -2.14591142367774, 218, 43, 'PPL', 'P'),
(208992, 'Turner', 46.4124984741211, 0.810050912450257, -117.853607177734, -2.05693348060349, 218, 56, 'PPL', 'P'),
(118082, 'Turner (historical)', 41.702220916748, 0.727841060391301, -92.8177795410156, -1.61997585738095, 218, 16, 'PPL', 'P'),
(121754, 'Turner Camp', 42.1891708374023, 0.736339939799044, -88.2505569458008, -1.54026278542297, 218, 18, 'PPL', 'P'),
(129110, 'Turner Center', 44.2713890075684, 0.772681502613293, -70.2194366455078, -1.22556036835967, 218, 26, 'PPL', 'P'),
(6418, 'Turner Chapel', 34.7619400024414, 0.606710307423328, -87.0280609130859, -1.51892620455953, 218, 2, 'PPL', 'P'),
(25593, 'Turner City', 31.5977802276611, 0.55148530129425, -84.1080627441406, -1.46796262235923, 218, 13, 'PPL', 'P'),
(197727, 'Turner Colony', 48.7583312988281, 0.850993418942754, -108.434173583984, -1.89253335071959, 218, 31, 'PPL', 'P'),
(208993, 'Turner Corner', 47.8047218322754, 0.834349793973222, -122.142219543457, -2.13178388672709, 218, 56, 'PPL', 'P'),
(6419, 'Turner Crossroads', 31.312219619751, 0.546501328472221, -85.9741668701172, -1.50053228354257, 218, 2, 'PPL', 'P'),
(111756, 'Turner Douglass', 39.375, 0.687223392972767, -79.4944381713867, -1.38743968311376, 218, 58, 'PPL', 'P'),
(57958, 'Turner Ford (historical)', 37.8472213745117, 0.660558625716403, -92.8736114501953, -1.62095030802381, 218, 29, 'PPL', 'P'),
(28815, 'Turner Landing', 39.0702781677246, 0.681904993696852, -90.6952819824219, -1.58293128661795, 218, 18, 'PPL', 'P'),
(38605, 'Turner Landing', 37.1697196960449, 0.64873399073937, -89.0694427490234, -1.55455503888705, 218, 21, 'PPL', 'P'),
(84097, 'Turner Place', 34.1994400024414, 0.59689283038086, -79.3944396972656, -1.38569438049338, 218, 48, 'PPL', 'P'),
(133453, 'Turner Shores', 41.860279083252, 0.73059969580646, -86.6597213745117, -1.51249746684614, 218, 27, 'PPL', 'P'),
(25595, 'Turner Village', 33.8008308410645, 0.589935788086219, -84.3277816772461, -1.47179744117089, 218, 13, 'PPL', 'P'),
(107025, 'Turner Woods', 37.4638900756836, 0.653868232425906, -77.3041687011719, -1.3492122693526, 218, 53, 'PPL', 'P'),
(209797, 'Turnercrest', 43.5627784729004, 0.760313915669019, -105.668609619141, -1.84426515385856, 218, 59, 'PPL', 'P'),
(57959, 'Turners', 37.1808280944824, 0.648927868866728, -93.1552810668945, -1.62586637023805, 218, 29, 'PPL', 'P'),
(52238, 'Turners Chance', 39.3469390869141, 0.686733637648302, -77.2519378662109, -1.34830066931146, 218, 25, 'PPL', 'P'),
(25596, 'Turners Corner', 34.6630592346191, 0.60498451245793, -83.9008331298828, -1.46434578328279, 218, 13, 'PPL', 'P'),
(129112, 'Turners Corner', 44.0313911437988, 0.768492749692762, -69.4175033569336, -1.21156399209271, 218, 26, 'PPL', 'P'),
(133455, 'Turners Corner', 42.4272193908691, 0.74049467083665, -85.4255599975586, -1.49095728731736, 218, 27, 'PPL', 'P'),
(69659, 'Turners Crossroads', 36.5330581665039, 0.637622150828096, -77.3772201538086, -1.35048725772447, 218, 33, 'PPL', 'P'),
(107026, 'Turners Crossroads', 36.5502815246582, 0.637922755136139, -77.586669921875, -1.35414284579477, 218, 53, 'PPL', 'P'),
(126376, 'Turners Falls', 42.6041717529297, 0.743583072173787, -72.5569381713867, -1.26635746625665, 218, 23, 'PPL', 'P'),
(52239, 'Turners Field', 38.5880584716797, 0.673488672282902, -76.5955581665039, -1.33684468240832, 218, 25, 'PPL', 'P'),
(62092, 'Turners Flat', 33.6233291625977, 0.586837799369157, -90.8541717529297, -1.58570443626105, 218, 30, 'PPL', 'P'),
(57960, 'Turners Mill', 36.7663917541504, 0.641694590188018, -91.2663879394531, -1.5928989659459, 218, 29, 'PPL', 'P'),
(25597, 'Turners Rock', 32.0130615234375, 0.558733327227496, -81.0055618286133, -1.41381376633714, 218, 13, 'PPL', 'P'),
(107027, 'Turners Siding', 36.8177795410156, 0.642591476264129, -83.0488891601563, -1.44947655596856, 218, 53, 'PPL', 'P'),
(38609, 'Turners Station', 38.5555610656738, 0.672921485549742, -85.1677780151367, -1.48645814297178, 218, 21, 'PPL', 'P'),
(91446, 'Turners Station', 36.610279083252, 0.638969910076758, -86.2683334350586, -1.50566645865008, 218, 50, 'PPL', 'P'),
(69660, 'Turnersburg', 35.9083290100098, 0.626718570114066, -80.807502746582, -1.41035698324222, 218, 33, 'PPL', 'P'),
(38606, 'Turnersville', 37.4902801513672, 0.654328826136436, -84.7388916015625, -1.47897266293784, 218, 21, 'PPL', 'P'),
(71487, 'Turnersville', 39.7730598449707, 0.694170847887484, -75.0516662597656, -1.30989868534085, 218, 37, 'PPL', 'P'),
(91447, 'Turnersville', 36.4877815246582, 0.636831924353642, -87.0400009155273, -1.51913459691483, 218, 50, 'PPL', 'P'),
(98658, 'Turnersville', 30.0925006866455, 0.525213217140619, -97.7808303833008, -1.70659743552271, 218, 51, 'PPL', 'P'),
(168115, 'Turnersville', 41.3141708374023, 0.721068308844094, -75.475830078125, -1.31730174053905, 218, 45, 'PPL', 'P'),
(38608, 'Turnertown', 36.7747192382813, 0.641839932204509, -86.6552810668945, -1.51241996885841, 218, 21, 'PPL', 'P'),
(98659, 'Turnertown', 32.1897201538086, 0.561816601979535, -94.9494400024414, -1.65718035096742, 218, 51, 'PPL', 'P'),
(111757, 'Turnertown', 39.0744400024414, 0.681977631415584, -80.4652786254883, -1.40438404554939, 218, 58, 'PPL', 'P'),
(6420, 'Turnerville', 30.9783306121826, 0.540673865953937, -88.1291732788086, -1.53814424077582, 218, 2, 'PPL', 'P'),
(25598, 'Turnerville', 34.6866683959961, 0.605396570057592, -83.4261093139648, -1.45606028965739, 218, 13, 'PPL', 'P'),
(43408, 'Turnerville', 30.2941703796387, 0.528733017284835, -91.2388916015625, -1.59241906431747, 218, 22, 'PPL', 'P'),
(57961, 'Turnerville', 37.0405616760254, 0.646479758034672, -91.7391662597656, -1.6011505042674, 218, 29, 'PPL', 'P'),
(62093, 'Turnerville', 32.0255584716797, 0.558951440120774, -89.2033309936523, -1.55689182958554, 218, 30, 'PPL', 'P'),
(189725, 'Turnerville', 32.8019409179688, 0.572501870063206, -108.084167480469, -1.88642459181116, 218, 38, 'PPL', 'P'),
(209798, 'Turnerville', 42.8588905334473, 0.748028753560484, -110.901107788086, -1.93558947501123, 218, 59, 'PPL', 'P'),
(62094, 'Turnetta', 32.6252784729004, 0.569418528732139, -89.9930572509766, -1.5706751529653, 218, 30, 'PPL', 'P'),
(57962, 'Turney', 39.6347198486328, 0.691756359464191, -94.3208312988281, -1.64620905938267, 218, 29, 'PPL', 'P'),
(91448, 'Turney', 35.142219543457, 0.613347437492024, -87.0500030517578, -1.51930916712429, 218, 50, 'PPL', 'P'),
(98660, 'Turney', 31.9088897705078, 0.556915187151299, -95.1949996948242, -1.66146617610968, 218, 51, 'PPL', 'P'),
(12414, 'Turney (historical)', 35.4272193908691, 0.618321623197046, -90.5922164916992, -1.58113245445966, 218, 4, 'PPL', 'P'),
(6421, 'Turney Crossroads', 34.4463882446289, 0.601202890289044, -86.7838897705078, -1.51466461418319, 218, 2, 'PPL', 'P'),
(12415, 'Turnip (historical)', 35.3180618286133, 0.616416464332231, -92.0025024414063, -1.60574658767666, 218, 4, 'PPL', 'P'),
(168116, 'Turnip Hole', 41.1525001525879, 0.718246623090128, -79.5894393920898, -1.38909776720844, 218, 45, 'PPL', 'P'),
(25599, 'Turniptown (historical)', 34.709171295166, 0.605789319739352, -84.4208297729492, -1.47342143680362, 218, 13, 'PPL', 'P'),
(14767, 'Turnkey', 39.0880584716797, 0.682215318542873, -75.5477828979492, -1.31855755415108, 218, 10, 'PPL', 'P'),
(62095, 'Turnpike', 34.2897186279297, 0.598468489639805, -89.1233291625977, -1.55549553422601, 218, 30, 'PPL', 'P'),
(69662, 'Turnpike', 35.5380592346191, 0.62025614341288, -82.76611328125, -1.44454118583642, 218, 33, 'PPL', 'P'),
(195738, 'Turnpike', 42.1100006103516, 0.734958158667457, -111.26277923584, -1.94190183258499, 218, 17, 'PPL', 'P'),
(25600, 'Turntime Crossroads', 32.6902809143066, 0.570553035356513, -84.7886123657227, -1.47984045397904, 218, 13, 'PPL', 'P'),
(25601, 'Turnwold', 33.3802795410156, 0.582595783226824, -83.2758331298828, -1.45343747545783, 218, 13, 'PPL', 'P'),
(153228, 'Turnwood', 42.024169921875, 0.733460130554287, -74.7094421386719, -1.30392574764802, 218, 40, 'PPL', 'P'),
(34204, 'Turon', 37.8072204589844, 0.659860478036639, -98.4263916015625, -1.71786460430456, 218, 20, 'PPL', 'P'),
(62096, 'Turon', 34.1041717529297, 0.595230085754269, -88.3249969482422, -1.54156200856077, 218, 30, 'PPL', 'P'),
(28816, 'Turpin', 39.7886085510254, 0.694442224002563, -88.9191665649414, -1.55193222468748, 218, 18, 'PPL', 'P'),
(107028, 'Turpin', 37.7611083984375, 0.659055670755217, -77.147216796875, -1.34647294185534, 218, 53, 'PPL', 'P'),
(191022, 'Turpin', 36.8675003051758, 0.643459267305332, -100.876937866211, -1.76063470509512, 218, 42, 'PPL', 'P'),
(25604, 'Turpin (historical)', 33.7355613708496, 0.588796620929937, -83.4261093139648, -1.45606028965739, 218, 13, 'PPL', 'P'),
(31331, 'Turpin Hill', 38.142219543457, 0.665707315051854, -87.290283203125, -1.52350284689283, 218, 19, 'PPL', 'P'),
(832, 'Turpin Hills', 39.1100006103516, 0.682598281107627, -84.379997253418, -1.47270877489592, 218, 41, 'PPL', 'P'),
(43409, 'Turps', 30.4180603027344, 0.530895304352898, -93.2002792358398, -1.62665173644351, 218, 22, 'PPL', 'P'),
(189726, 'Turquoise', 32.4449996948242, 0.566272070483238, -106.032218933105, -1.85061133357816, 218, 38, 'PPL', 'P'),
(18393, 'Turquoise Beach', 30.4077796936035, 0.530715873874454, -86.311393737793, -1.5064180027097, 218, 12, 'PPL', 'P'),
(206162, 'Turramurra Lodge Condominiums', 40.5777816772461, 0.708215893423371, -111.672218322754, -1.949047892738, 218, 52, 'PPL', 'P'),
(12416, 'Turrell', 35.3797187805176, 0.617492581149705, -90.2577819824219, -1.57529547114048, 218, 4, 'PPL', 'P'),
(187464, 'Turret', 38.6402816772461, 0.674400139165981, -105.988327026367, -1.8498452752906, 218, 7, 'PPL', 'P'),
(57963, 'Turtle', 37.5233306884766, 0.654905666828547, -91.4122161865234, -1.59544414899969, 218, 29, 'PPL', 'P'),
(133456, 'Turtle', 44.1908302307129, 0.771275486715785, -83.7425003051758, -1.46158235417767, 218, 27, 'PPL', 'P'),
(98661, 'Turtle Bayou', 29.8270492553711, 0.520580215660749, -94.6672286987305, -1.65225483453131, 218, 51, 'PPL', 'P'),
(43410, 'Turtle Beach', 31.4177799224854, 0.548343703314338, -93.6444396972656, -1.63440379890257, 218, 22, 'PPL', 'P'),
(25603, 'Turtle Creek', 32.5738906860352, 0.568521642656028, -83.6522216796875, -1.46000669491873, 218, 13, 'PPL', 'P'),
(111758, 'Turtle Creek', 38.0297203063965, 0.663743832959165, -81.8730621337891, -1.42895450292451, 218, 58, 'PPL', 'P'),
(168117, 'Turtle Creek', 40.4058303833008, 0.705214777190961, -79.8252792358398, -1.39321394898927, 218, 45, 'PPL', 'P'),
(179404, 'Turtle Creek', 33.6383285522461, 0.587099588104312, -112.070556640625, -1.9560002079217, 218, 5, 'PPL', 'P'),
(176745, 'Turtle Lake', 45.3944396972656, 0.792282434815303, -92.142219543457, -1.60818511112879, 218, 57, 'PPL', 'P'),
(197728, 'Turtle Lake', 47.6694412231445, 0.831988701929785, -114.073333740234, -1.99095526249343, 218, 31, 'PPL', 'P'),
(199037, 'Turtle Lake', 47.5200004577637, 0.829380468537189, -100.889717102051, -1.76085774483642, 218, 34, 'PPL', 'P'),
(43411, 'Turtle Lake (historical)', 31.607780456543, 0.551659838214191, -91.620002746582, -1.5990707086141, 218, 22, 'PPL', 'P'),
(158007, 'Turtle Neck Point', 40.5019416809082, 0.706892235782575, -84.5408325195313, -1.47551587984291, 218, 41, 'PPL', 'P'),
(138497, 'Turtle River', 47.5875015258789, 0.830558584424412, -94.7513885498047, -1.65372370103055, 218, 28, 'PPL', 'P'),
(168119, 'Turtlepoint', 41.8716697692871, 0.730798500781835, -78.3399963378906, -1.36729087209649, 218, 45, 'PPL', 'P'),
(25605, 'Turtles Cove', 33.3819389343262, 0.582624745103679, -83.834716796875, -1.46319183558246, 218, 13, 'PPL', 'P'),
(91449, 'Turtletown', 35.1269416809082, 0.61308078848788, -84.3536071777344, -1.47224818118539, 218, 50, 'PPL', 'P'),
(111759, 'Turtletown', 38.0191688537598, 0.663559675369786, -81.8736114501953, -1.42896409030444, 218, 58, 'PPL', 'P'),
(168120, 'Turtleville', 40.9249992370605, 0.714275983062874, -76.8644409179688, -1.34153757172321, 218, 45, 'PPL', 'P'),
(171454, 'Turton', 45.0497207641602, 0.786265954438651, -98.0952835083008, -1.71208567789714, 218, 49, 'PPL', 'P'),
(179405, 'Tusayan', 35.9736099243164, 0.627857937007429, -112.125831604004, -1.95696493802658, 218, 5, 'PPL', 'P'),
(6422, 'Tuscahoma Landing', 32.0580596923828, 0.559518693432961, -88.1149978637695, -1.53789683311055, 218, 2, 'PPL', 'P'),
(6423, 'Tuscaloosa', 33.2097206115723, 0.579618968339361, -87.5691680908203, -1.52837030641717, 218, 2, 'PPL', 'P'),
(62098, 'Tuscan', 33.3122215270996, 0.581407946801622, -89.1544418334961, -1.55603855277228, 218, 30, 'PPL', 'P'),
(153229, 'Tuscan', 42.586669921875, 0.743277607596755, -74.7694396972656, -1.30497290258864, 218, 40, 'PPL', 'P'),
(18394, 'Tuscannoga', 28.6197204589844, 0.49950835300966, -81.9463882446289, -1.43023428498635, 218, 12, 'PPL', 'P'),
(12417, 'Tuscany (historical)', 35.6963882446289, 0.623019505938973, -91.1083297729492, -1.59014033053074, 218, 4, 'PPL', 'P'),
(158008, 'Tuscarawas', 40.394718170166, 0.705020832484576, -81.4072189331055, -1.42082400527456, 218, 41, 'PPL', 'P'),
(52241, 'Tuscarora', 39.2566719055176, 0.685158178126438, -77.4705581665039, -1.35211631336327, 218, 25, 'PPL', 'P'),
(69664, 'Tuscarora', 35.1594390869141, 0.613647975221039, -77.2141723632813, -1.34764153694167, 218, 33, 'PPL', 'P'),
(121755, 'Tuscarora', 40.605281829834, 0.708695861630831, -89.6672210693359, -1.56498823877354, 218, 18, 'PPL', 'P'),
(153230, 'Tuscarora', 42.6305618286133, 0.744043665884316, -77.870002746582, -1.35908793646488, 218, 40, 'PPL', 'P'),
(168122, 'Tuscarora', 40.7700004577637, 0.711570744027571, -76.0377807617188, -1.32710963020159, 218, 45, 'PPL', 'P'),
(200247, 'Tuscarora', 41.3141708374023, 0.721068308844094, -116.220832824707, -2.02843619220104, 218, 39, 'PPL', 'P'),
(69665, 'Tuscarora Beach', 36.3888893127441, 0.635105929651162, -76.9097213745117, -1.34232786477669, 218, 33, 'PPL', 'P'),
(52247, 'Tuscarora Knolls', 39.4555587768555, 0.688629408870275, -77.3916702270508, -1.3507394590797, 218, 25, 'PPL', 'P'),
(52242, 'Tuscarora Springs', 39.5055618286133, 0.689502126759494, -77.4444427490234, -1.35166051334271, 218, 25, 'PPL', 'P'),
(79283, 'Tuscarora Summit', 39.915828704834, 0.696662634561417, -77.9569396972656, -1.36060527249596, 218, 45, 'PPL', 'P'),
(176749, 'Tuscobia', 45.5669403076172, 0.795293138427638, -91.758056640625, -1.60148020361035, 218, 57, 'PPL', 'P'),
(28817, 'Tuscola', 39.7991714477539, 0.694626581329024, -88.2830581665039, -1.54083003873516, 218, 18, 'PPL', 'P'),
(62099, 'Tuscola', 32.6199989318848, 0.569326383358423, -89.5277786254883, -1.56255450901137, 218, 30, 'PPL', 'P'),
(98662, 'Tuscola', 32.2094383239746, 0.562160748971401, -99.79638671875, -1.74177552983573, 218, 51, 'PPL', 'P'),
(133458, 'Tuscola', 43.3263893127441, 0.756188146508268, -83.6572189331055, -1.46009391344443, 218, 27, 'PPL', 'P'),
(69666, 'Tuscola Park', 35.5230598449707, 0.619994354677725, -82.9602813720703, -1.44793005832355, 218, 33, 'PPL', 'P'),
(197729, 'Tuscor', 47.9033317565918, 0.836070861827686, -115.690002441406, -2.01917145424282, 218, 31, 'PPL', 'P'),
(25606, 'Tusculum', 32.3927803039551, 0.565360670179186, -81.4308319091797, -1.42123612945325, 218, 13, 'PPL', 'P'),
(74581, 'Tusculum', 39.1227798461914, 0.682821320848921, -84.4283294677734, -1.4735523311712, 218, 41, 'PPL', 'P'),
(91450, 'Tusculum', 36.1749992370605, 0.631372843593143, -82.7588882446289, -1.4444150851588, 218, 50, 'PPL', 'P'),
(168126, 'Tusculum', 40.0380592346191, 0.698795959752625, -77.5158309936523, -1.3529064732587, 218, 45, 'PPL', 'P'),
(91452, 'Tusculum Heights', 36.1763916015625, 0.63139714493809, -82.7805633544922, -1.44479338719165, 218, 50, 'PPL', 'P'),
(91453, 'Tusculum Place', 36.1686096191406, 0.631261323722496, -82.7591705322266, -1.44442001200682, 218, 50, 'PPL', 'P'),
(6425, 'Tuscumbia', 34.7311096191406, 0.606172215725078, -87.7024993896484, -1.53069737657768, 218, 2, 'PPL', 'P'),
(57964, 'Tuscumbia', 38.2330589294434, 0.667292761427805, -92.4583282470703, -1.61370224880105, 218, 29, 'PPL', 'P'),
(77504, 'Tushka', 34.3202781677246, 0.599001854227121, -96.1669387817383, -1.67842971330516, 218, 42, 'PPL', 'P'),
(69667, 'Tusk', 34.7441711425781, 0.606400182314389, -76.5188903808594, -1.33550657711861, 218, 33, 'PPL', 'P'),
(77505, 'Tuskahoma', 34.6177787780762, 0.604194219404449, -95.2763900756836, -1.66288670623513, 218, 42, 'PPL', 'P'),
(69669, 'Tuskasaga (historical)', 35.2999992370605, 0.616101212638193, -80.9916687011719, -1.41357128551989, 218, 33, 'PPL', 'P'),
(69668, 'Tuskeegee', 35.4083290100098, 0.617991923854095, -83.7194366455078, -1.46117981737891, 218, 33, 'PPL', 'P'),
(91454, 'Tuskeegee (historical)', 35.5916709899902, 0.621191845061879, -84.2022171020508, -1.46960592590986, 218, 50, 'PPL', 'P'),
(118083, 'Tuskeego', 40.6666717529297, 0.709767317916397, -93.98388671875, -1.64032826706356, 218, 16, 'PPL', 'P'),
(6426, 'Tuskegee', 32.4238891601563, 0.565903622146426, -85.6916732788086, -1.49560184025845, 218, 2, 'PPL', 'P'),
(77507, 'Tuskegee', 35.6530609130859, 0.622263301347445, -96.2808303833008, -1.68041749674279, 218, 42, 'PPL', 'P'),
(197730, 'Tusler', 46.4836082458496, 0.811292012097261, -105.751106262207, -1.84570499190191, 218, 31, 'PPL', 'P'),
(69670, 'Tusquitee', 35.0844383239746, 0.612338964966238, -83.7658309936523, -1.46198955150835, 218, 33, 'PPL', 'P'),
(168127, 'Tusseyville', 40.7972183227539, 0.712045785387014, -77.6788864135742, -1.35575232719956, 218, 45, 'PPL', 'P'),
(14768, 'Tussock Pond', 38.5400009155273, 0.672649909697581, -75.6366729736328, -1.3201089786441, 218, 10, 'PPL', 'P'),
(77508, 'Tussy', 34.5066719055176, 0.602255038656707, -97.5427780151367, -1.70244263790608, 218, 42, 'PPL', 'P'),
(153233, 'Tusten', 41.5552787780762, 0.725276436261555, -75.0194396972656, -1.30933622571862, 218, 40, 'PPL', 'P'),
(133461, 'Tustin', 44.1025009155273, 0.769733849339766, -85.4588928222656, -1.49153905485748, 218, 27, 'PPL', 'P'),
(176750, 'Tustin', 44.1627807617188, 0.770785931128402, -88.892219543457, -1.55146191043898, 218, 57, 'PPL', 'P'),
(185781, 'Tustin', 33.7458305358887, 0.5889758516713, -117.82527923584, -2.05643906474711, 218, 6, 'PPL', 'P'),
(185782, 'Tustin Foothills', 33.7644386291504, 0.589300624166235, -117.793060302734, -2.05587673828294, 218, 6, 'PPL', 'P'),
(84099, 'Tuten (historical)', 33.0380592346191, 0.576622912113022, -81.147216796875, -1.41628611193512, 218, 48, 'PPL', 'P'),
(25610, 'Tutens', 32.1049995422363, 0.560337948363296, -81.2538909912109, -1.41814792785319, 218, 13, 'PPL', 'P'),
(153235, 'Tuthill', 41.6875, 0.727584131925136, -74.1627807617188, -1.2943847067267, 218, 40, 'PPL', 'P'),
(202698, 'Tuthill', 43.1558303833008, 0.753211331620805, -101.49333190918, -1.77139281063461, 218, 49, 'PPL', 'P'),
(153236, 'Tuthilltown', 41.686939239502, 0.72757434480813, -74.1758270263672, -1.2946124069999, 218, 40, 'PPL', 'P'),
(38612, 'Tutor Key', 37.8444404602051, 0.660510089605537, -82.7669372558594, -1.44455556690631, 218, 21, 'PPL', 'P'),
(179406, 'Tutt', 34.6605606079102, 0.60494090319508, -112.414169311523, -1.96199738038045, 218, 5, 'PPL', 'P'),
(12418, 'Tuttle', 36.0336112976074, 0.628905158527076, -93.9722213745117, -1.64012466839822, 218, 4, 'PPL', 'P'),
(38610, 'Tuttle', 37.0102806091309, 0.645951253716346, -83.9316711425781, -1.4648840081391, 218, 21, 'PPL', 'P'),
(77509, 'Tuttle', 35.290828704834, 0.615941156656679, -97.8119430541992, -1.70714045406897, 218, 42, 'PPL', 'P'),
(140981, 'Tuttle', 47.1436080932617, 0.822811182497263, -99.9941711425781, -1.74522751924069, 218, 34, 'PPL', 'P'),
(185784, 'Tuttle', 37.2961082458496, 0.650939887070283, -120.377777099609, -2.10098855662001, 218, 6, 'PPL', 'P'),
(195739, 'Tuttle', 42.8583297729492, 0.748018966443478, -114.839172363281, -2.00432166800454, 218, 17, 'PPL', 'P'),
(168128, 'Tuttle Lake', 41.6333312988281, 0.726638709738158, -80.4899978637695, -1.40481547764598, 218, 45, 'PPL', 'P'),
(146477, 'Tuttles Corner', 41.1980590820313, 0.719041776412598, -74.8030624389648, -1.30555973013484, 218, 37, 'PPL', 'P'),
(12420, 'Tuttleton', 34.9305610656738, 0.609653300164948, -90.6930618286133, -1.58289253762409, 218, 4, 'PPL', 'P'),
(185785, 'Tuttletown', 37.9916687011719, 0.663079707162327, -120.458610534668, -2.10239936620748, 218, 6, 'PPL', 'P'),
(126378, 'Tuttleville', 42.209171295166, 0.736689013638926, -70.908332824707, -1.23758387489111, 218, 23, 'PPL', 'P'),
(201689, 'Tutuilla', 45.6233291625977, 0.796277309608477, -118.697776794434, -2.07166701986019, 218, 43, 'PPL', 'P'),
(6427, 'Tutwiler', 33.5905609130859, 0.586265885525062, -87.2805633544922, -1.5233332035314, 218, 2, 'PPL', 'P'),
(62100, 'Tutwiler', 34.014720916748, 0.593668874144237, -90.4316711425781, -1.57833040951873, 218, 30, 'PPL', 'P'),
(179407, 'Tuweep', 36.415828704834, 0.635576110741615, -113.065826416016, -1.97337094244785, 218, 5, 'PPL', 'P'),
(52243, 'Tuxedo', 38.9208297729492, 0.679296627146201, -76.9194412231445, -1.34249750813813, 218, 25, 'PPL', 'P'),
(69673, 'Tuxedo', 35.2252807617188, 0.614797129231408, -82.4297180175781, -1.43866998089723, 218, 33, 'PPL', 'P'),
(98663, 'Tuxedo', 32.9327812194824, 0.574785464118922, -99.9513931274414, -1.74448090202908, 218, 51, 'PPL', 'P'),
(52244, 'Tuxedo Colony', 38.9122200012207, 0.679146358281693, -76.9111099243164, -1.34235209954261, 218, 25, 'PPL', 'P'),
(25607, 'Tuxedo Estates', 33.9313888549805, 0.592214455293918, -84.4858322143555, -1.47455594342799, 218, 13, 'PPL', 'P'),
(14769, 'Tuxedo Park', 39.7180595397949, 0.693210911472565, -75.6208267211914, -1.3198324093649, 218, 10, 'PPL', 'P'),
(153239, 'Tuxedo Park', 42.8197212219238, 0.74734512010866, -77.6969375610352, -1.35606737915652, 218, 40, 'PPL', 'P'),
(194023, 'Twain', 40.0202789306641, 0.698485634906603, -121.070831298828, -2.11308463429115, 218, 6, 'PPL', 'P'),
(200249, 'Twain', 40.5494384765625, 0.707721211250889, -118.23722076416, -2.063628800742, 218, 39, 'PPL', 'P'),
(185786, 'Twain Harte', 38.0397186279297, 0.663918336589593, -120.231666564941, -2.09843844671821, 218, 6, 'PPL', 'P'),
(185787, 'Twain Harte Valley', 38.0536117553711, 0.664160817406845, -120.228332519531, -2.09838025664839, 218, 6, 'PPL', 'P'),
(38611, 'Tway', 36.827220916748, 0.642756259356578, -83.3161087036133, -1.45414041682756, 218, 21, 'PPL', 'P'),
(25608, 'Tweed', 32.4288902282715, 0.565990907251153, -82.758056640625, -1.44440057093086, 218, 13, 'PPL', 'P'),
(79284, 'Tweedale', 39.7947196960449, 0.694548883604221, -76.029167175293, -1.32695929475806, 218, 45, 'PPL', 'P'),
(208994, 'Tweedie', 48.0858306884766, 0.839256069070448, -117.044723510742, -2.04281579734887, 218, 56, 'PPL', 'P'),
(598, 'Twelve Cedars', 29.8086109161377, 0.520258405932526, -90.8005599975586, -1.58476873461205, 218, 22, 'PPL', 'P'),
(129113, 'Twelve Corners', 44.4627799987793, 0.776021905568579, -70.1161117553711, -1.22375700882753, 218, 26, 'PPL', 'P'),
(133462, 'Twelve Corners', 42.144718170166, 0.735564094394477, -86.3786087036133, -1.50759112516988, 218, 27, 'PPL', 'P'),
(153240, 'Twelve Corners', 43.1269416809082, 0.752707128647426, -77.5658264160156, -1.35377905798987, 218, 40, 'PPL', 'P'),
(176751, 'Twelve Corners', 44.401668548584, 0.774955309552002, -88.4347229003906, -1.54347708770065, 218, 57, 'PPL', 'P'),
(138499, 'Twelve Hi Mobile Home Estates', 45.0666694641113, 0.786561765056731, -93.9388885498047, -1.63954290085809, 218, 28, 'PPL', 'P'),
(52245, 'Twelve Hills', 39.2319412231445, 0.684726546292763, -76.9661102294922, -1.34331203595753, 218, 25, 'PPL', 'P'),
(123836, 'Twelve Mile', 40.8663902282715, 0.713253062888174, -86.2252807617188, -1.50491504774852, 218, 19, 'PPL', 'P'),
(25609, 'Twelve Oaks', 33.9486083984375, 0.592514993022933, -84.7705612182617, -1.47952540202208, 218, 13, 'PPL', 'P'),
(91455, 'Twelve Oaks', 35.7694396972656, 0.624294494310849, -83.9027786254883, -1.46437973858669, 218, 50, 'PPL', 'P'),
(31332, 'Twelve Points', 39.4922218322754, 0.689269299901193, -87.3977813720703, -1.52537904388079, 218, 19, 'PPL', 'P'),
(52246, 'Twelve Trees', 39.3891716003418, 0.687470734059008, -76.8277816772461, -1.34089774727132, 218, 25, 'PPL', 'P'),
(57965, 'Twelvemile', 37.3661117553711, 0.652161678799384, -90.3630599975586, -1.57713291913458, 218, 29, 'PPL', 'P'),
(84098, 'Twelvemile', 33.8230590820313, 0.590323744078016, -79.2119369506836, -1.38250910667159, 218, 48, 'PPL', 'P'),
(121756, 'Twelvemile Corner', 41.7594413757324, 0.728839745800081, -89.0833282470703, -1.55479738654625, 218, 18, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(194457, 'Twelvemile Corner', 40.0733299255371, 0.699411549438597, -103.792221069336, -1.81151599561774, 218, 7, 'PPL', 'P'),
(201690, 'Twelvemile Corner', 45.5191688537598, 0.794459369269361, -122.433059692383, -2.13686000492284, 218, 43, 'PPL', 'P'),
(190854, 'Twelvemile House', 38.9066696166992, 0.679049485797042, -119.706672668457, -2.08927557467168, 218, 39, 'PPL', 'P'),
(74582, 'Twenty Mile Stand', 39.3063888549805, 0.686025902588613, -84.2799987792969, -1.47096347227553, 218, 41, 'PPL', 'P'),
(168129, 'Twenty Row', 40.5380592346191, 0.707522606012597, -78.793327331543, -1.37520299053706, 218, 45, 'PPL', 'P'),
(206163, 'Twenty-seventh Street Condo', 40.6597213745117, 0.709646010928744, -111.956108093262, -1.95400270394609, 218, 52, 'PPL', 'P'),
(18395, 'Twentymile', 30.1263904571533, 0.525804705218725, -81.4219436645508, -1.42108100031975, 218, 12, 'PPL', 'P'),
(18396, 'Twentymile Bend', 26.6861095428467, 0.465760476070553, -80.3886108398438, -1.40304594025968, 218, 12, 'PPL', 'P'),
(98665, 'Twentymile Crossing', 30.9122200012207, 0.539520018122147, -99.4922180175781, -1.73646678451876, 218, 51, 'PPL', 'P'),
(185788, 'Twentynine Palms', 34.1355590820313, 0.595777897990498, -116.053329467773, -2.0255127071144, 218, 6, 'PPL', 'P'),
(38613, 'Twentysix', 37.9447212219238, 0.662260319073937, -83.3611068725586, -1.45492578303302, 218, 21, 'PPL', 'P'),
(12422, 'Twentythree', 35.3761100769043, 0.617429597389924, -91.559440612793, -1.59801369997745, 218, 4, 'PPL', 'P'),
(192343, 'Twichell', 36.4375, 0.635954346195434, -100.728607177734, -1.75804584619946, 218, 51, 'PPL', 'P'),
(25611, 'Twickenham', 34.209171295166, 0.59706267347938, -85.149169921875, -1.48613337047684, 218, 13, 'PPL', 'P'),
(201691, 'Twickenham (historical)', 44.7438888549805, 0.780928180665805, -120.170829772949, -2.09737664439159, 218, 43, 'PPL', 'P'),
(138501, 'Twig', 46.8944396972656, 0.818462373595218, -92.3644409179688, -1.61206360578233, 218, 28, 'PPL', 'P'),
(138502, 'Twig Station', 46.8777809143066, 0.818171622983209, -92.3461074829102, -1.61174362697736, 218, 28, 'PPL', 'P'),
(84100, 'Twiggs', 33.3861083984375, 0.582697515980465, -81.8805618286133, -1.42908539729209, 218, 48, 'PPL', 'P'),
(111760, 'Twiggs', 39.3974990844727, 0.687616076075499, -81.0319366455078, -1.41427409373156, 218, 58, 'PPL', 'P'),
(52249, 'Twiggs Corner', 38.310001373291, 0.668635660407477, -75.7041702270508, -1.3212870279523, 218, 25, 'PPL', 'P'),
(52248, 'Twiggtown', 39.6394386291504, 0.691838717720902, -78.6558303833008, -1.37280321607879, 218, 25, 'PPL', 'P'),
(74583, 'Twightwee', 39.2519416809082, 0.685075620132646, -84.2866668701172, -1.47107985241517, 218, 41, 'PPL', 'P'),
(25613, 'Twigs Corner', 33.396671295166, 0.582881873306926, -84.5872192382813, -1.4763254808143, 218, 13, 'PPL', 'P'),
(38614, 'Twila', 36.7722206115723, 0.641796322941659, -83.3944396972656, -1.45550755057315, 218, 21, 'PPL', 'P'),
(168130, 'Twilight', 40.1127815246582, 0.700100109738437, -79.8888931274414, -1.39432422084772, 218, 45, 'PPL', 'P'),
(177284, 'Twilight', 40.0361099243164, 0.698761937869699, -80.5936126708984, -1.4066238971842, 218, 58, 'PPL', 'P'),
(25614, 'Twilight (historical)', 31.086389541626, 0.542559850058904, -84.7322235107422, -1.4788562827982, 218, 13, 'PPL', 'P'),
(202699, 'Twilight Hills Addition', 44.0805587768555, 0.769350886775012, -103.146110534668, -1.80023923945596, 218, 49, 'PPL', 'P'),
(153241, 'Twilight Park', 42.1891708374023, 0.736339939799044, -74.0875015258789, -1.29307083620291, 218, 40, 'PPL', 'P'),
(118085, 'Twilight Trailer Court', 42.9986114501953, 0.750467343591642, -96.0672225952148, -1.67668933753279, 218, 16, 'PPL', 'P'),
(52272, 'Twilley', 38.4500007629395, 0.671079110707625, -75.3522186279297, -1.31514431373998, 218, 25, 'PPL', 'P'),
(112219, 'Twilley Town', 33.6624984741211, 0.58752143282098, -87.0869369506836, -1.51995378526614, 218, 2, 'PPL', 'P'),
(62102, 'Twin', 31.0074996948242, 0.54118296248582, -89.7980575561523, -1.56727176625023, 218, 30, 'PPL', 'P'),
(208995, 'Twin', 48.1650009155273, 0.840637850202035, -123.952781677246, -2.16338415727364, 218, 56, 'PPL', 'P'),
(179410, 'Twin Acres Family Mobile Park', 33.4136085510254, 0.583177484187925, -111.615829467773, -1.94806372155716, 218, 5, 'PPL', 'P'),
(197731, 'Twin Acres Mobile Home Park', 48.1716690063477, 0.840754230341672, -114.288887023926, -1.99471737700733, 218, 31, 'PPL', 'P'),
(31333, 'Twin Beach', 39.5180587768555, 0.689720239652771, -87.2050018310547, -1.52201440615959, 218, 19, 'PPL', 'P'),
(195740, 'Twin Beaches', 47.6199989318848, 0.831125771157572, -116.797218322754, -2.0384960169027, 218, 17, 'PPL', 'P'),
(176752, 'Twin Bluffs', 43.2738914489746, 0.755271885935227, -90.3127822875977, -1.5762554075554, 218, 57, 'PPL', 'P'),
(111762, 'Twin Branch', 37.4747200012207, 0.654057250284275, -81.6686096191406, -1.42538613337992, 218, 58, 'PPL', 'P'),
(12421, 'Twin Bridges', 36.1383285522461, 0.63073281940417, -91.9505615234375, -1.6048400476416, 218, 4, 'PPL', 'P'),
(31334, 'Twin Bridges', 38.5533294677734, 0.6728825368188, -87.6308288574219, -1.52944648981367, 218, 19, 'PPL', 'P'),
(43415, 'Twin Bridges', 32.7986106872559, 0.572443746572415, -91.5013885498047, -1.59700050034073, 218, 22, 'PPL', 'P'),
(168131, 'Twin Bridges', 40.1316719055176, 0.700429809081388, -79.9263916015625, -1.39497869268561, 218, 45, 'PPL', 'P'),
(185789, 'Twin Bridges', 38.8113899230957, 0.677386541433369, -120.123062133789, -2.09654294181234, 218, 6, 'PPL', 'P'),
(197732, 'Twin Bridges', 45.5444412231445, 0.794900455324906, -112.330276489258, -1.96053317441313, 218, 31, 'PPL', 'P'),
(52250, 'Twin Brook', 39.0744400024414, 0.681977631415584, -77.1202774047852, -1.34600276076489, 218, 25, 'PPL', 'P'),
(129114, 'Twin Brook', 45.0255584716797, 0.785844242880037, -69.1061096191406, -1.20612914609813, 218, 26, 'PPL', 'P'),
(52251, 'Twin Brook Estates', 39.4955596923828, 0.689327556550039, -76.3722229003906, -1.33294674667883, 218, 25, 'PPL', 'P'),
(52252, 'Twin Brook Forest', 39.0808296203613, 0.682089151286231, -77.1177825927734, -1.34595921808107, 218, 25, 'PPL', 'P'),
(31335, 'Twin Brooks', 39.6688919067383, 0.692352774390314, -86.1202774047852, -1.50308239344438, 218, 19, 'PPL', 'P'),
(84108, 'Twin Brooks', 35.0458297729492, 0.611665118631421, -82.0094375610352, -1.43133470314877, 218, 48, 'PPL', 'P'),
(171457, 'Twin Brooks', 45.2058296203613, 0.788990567970883, -96.779167175293, -1.68911511454688, 218, 49, 'PPL', 'P'),
(179409, 'Twin Buttes', 31.9025001525879, 0.556803667280652, -111.059997558594, -1.93836262465432, 218, 5, 'PPL', 'P'),
(185790, 'Twin Buttes', 36.4666709899902, 0.63646347601683, -119.205558776855, -2.08052948733575, 218, 6, 'PPL', 'P'),
(189727, 'Twin Buttes', 35.5044403076172, 0.619669382445708, -108.846672058105, -1.89973280725245, 218, 38, 'PPL', 'P'),
(199025, 'Twin Buttes', 47.5163917541504, 0.829317484777408, -102.245826721191, -1.78452632270839, 218, 34, 'PPL', 'P'),
(187465, 'Twin Cedars', 39.3597183227539, 0.686956677389596, -105.16667175293, -1.83550468545274, 218, 7, 'PPL', 'P'),
(25615, 'Twin Chapel', 32.5680618286133, 0.568419909902387, -84.9727783203125, -1.48305475625671, 218, 13, 'PPL', 'P'),
(28820, 'Twin Churches', 39.1430587768555, 0.683175254957792, -89.0111083984375, -1.55353691240231, 218, 18, 'PPL', 'P'),
(168132, 'Twin Churchs', 41.3608283996582, 0.721882636926413, -79.836669921875, -1.39341275396464, 218, 45, 'PPL', 'P'),
(185792, 'Twin Cities', 38.2911109924316, 0.668305961064526, -121.309997558594, -2.11725887298374, 218, 6, 'PPL', 'P'),
(25616, 'Twin City', 32.5827789306641, 0.568676771789525, -82.1552810668945, -1.43388015251867, 218, 13, 'PPL', 'P'),
(98664, 'Twin City', 33.7033309936523, 0.588234094728685, -96.5699996948242, -1.6854644533246, 218, 51, 'PPL', 'P'),
(52253, 'Twin Cove', 39.1783294677734, 0.683790844643764, -76.5997161865234, -1.33691725354803, 218, 25, 'PPL', 'P'),
(52254, 'Twin Cove Estates', 38.8833312988281, 0.678642155308314, -76.3536071777344, -1.33262184102584, 218, 25, 'PPL', 'P'),
(12423, 'Twin Creek', 35.9455604553223, 0.627368381420046, -92.0361099243164, -1.60633314890675, 218, 4, 'PPL', 'P'),
(69677, 'Twin Creek', 35.5597190856934, 0.620634179129617, -77.2647171020508, -1.34852370905276, 218, 33, 'PPL', 'P'),
(84101, 'Twin Creek', 35.0397186279297, 0.611558459029763, -81.95361328125, -1.43036038566397, 218, 48, 'PPL', 'P'),
(25625, 'Twin Creeks', 33.5888900756836, 0.586236723911126, -84.4513931274414, -1.47395486796996, 218, 13, 'PPL', 'P'),
(185791, 'Twin Creeks', 37.1561088562012, 0.648496436770135, -121.843063354492, -2.12656262625194, 218, 6, 'PPL', 'P'),
(197733, 'Twin Creeks', 46.9127807617188, 0.818782485558246, -113.71305847168, -1.98466727284364, 218, 31, 'PPL', 'P'),
(14773, 'Twin Eagle Farms', 39.2805595397949, 0.68557509599509, -75.7125015258789, -1.32143243654782, 218, 10, 'PPL', 'P'),
(179411, 'Twin Falls', 36.8636093139648, 0.643391356697535, -109.101936340332, -1.90418800944005, 218, 5, 'PPL', 'P'),
(195741, 'Twin Falls', 42.563060760498, 0.742865549997093, -114.459999084473, -1.99770384585374, 218, 17, 'PPL', 'P'),
(190855, 'Twin Flat', 39.2666702270508, 0.685332681756865, -119.640556335449, -2.08812162697135, 218, 39, 'PPL', 'P'),
(187466, 'Twin Forks', 39.5927810668945, 0.691024389638583, -105.219169616699, -1.83642094602578, 218, 7, 'PPL', 'P'),
(195744, 'Twin Forks', 43.7319412231445, 0.763266362632508, -111.193061828613, -1.94068503428293, 218, 17, 'PPL', 'P'),
(121757, 'Twin Grove', 40.4933280944824, 0.70674190033904, -89.079719543457, -1.55473440278647, 218, 18, 'PPL', 'P'),
(138513, 'Twin Grove', 43.7027816772461, 0.762757432548194, -93.1880569458008, -1.62643841724019, 218, 28, 'PPL', 'P'),
(176753, 'Twin Grove', 42.5313911437988, 0.742312810912847, -89.5430603027344, -1.56282122459455, 218, 57, 'PPL', 'P'),
(192345, 'Twin Grove', 36.3286094665527, 0.634053847862526, -100.437782287598, -1.75296999431982, 218, 51, 'PPL', 'P'),
(168134, 'Twin Grove Park', 40.5119400024414, 0.707066739413002, -76.5147171020508, -1.3354337396628, 218, 45, 'PPL', 'P'),
(12424, 'Twin Groves', 35.3333282470703, 0.616682913599293, -92.4219436645508, -1.61306721803912, 218, 4, 'PPL', 'P'),
(195743, 'Twin Groves', 43.9744415283203, 0.767498791394917, -111.626937866211, -1.94825759968451, 218, 17, 'PPL', 'P'),
(52255, 'Twin Harbors', 39.0625, 0.681769239060285, -76.5130615234375, -1.33540484436497, 218, 25, 'PPL', 'P'),
(25617, 'Twin Haynes Creek', 33.709171295166, 0.588336027219408, -83.9158325195313, -1.46460757201795, 218, 13, 'PPL', 'P'),
(146478, 'Twin Hill Park', 40.0083312988281, 0.69827710939325, -74.8777770996094, -1.30686374696259, 218, 37, 'PPL', 'P'),
(52256, 'Twin Hills', 38.9908294677734, 0.680518352296275, -76.5888900756836, -1.33672830226869, 218, 25, 'PPL', 'P'),
(212204, 'Twin Hills', 59.0791702270508, 1.03112603980824, -160.274993896484, -2.79732635210747, 218, 1, 'PPL', 'P'),
(168137, 'Twin Hollows', 41.172779083252, 0.718600557198999, -77.9677810668945, -1.36079449009141, 218, 45, 'PPL', 'P'),
(52257, 'Twin Knolls', 39.5061111450195, 0.689511714139418, -76.878059387207, -1.3417752588505, 218, 25, 'PPL', 'P'),
(179412, 'Twin Knolls', 33.413330078125, 0.583172623918935, -111.65055847168, -1.94866985702126, 218, 5, 'PPL', 'P'),
(62104, 'Twin Lake', 32.4888916015625, 0.567038128770799, -90.8199996948242, -1.58510802133493, 218, 30, 'PPL', 'P'),
(133463, 'Twin Lake', 43.3627815246582, 0.756823310428252, -86.1647186279297, -1.50385803911186, 218, 27, 'PPL', 'P'),
(98666, 'Twin Lake Colonia', 26.3560009002686, 0.459998993368276, -98.1210021972656, -1.71253455369888, 218, 51, 'PPL', 'P'),
(6434, 'Twin Lake Estates', 33.6222190856934, 0.586818424872227, -86.466667175293, -1.50912803543497, 218, 2, 'PPL', 'P'),
(18397, 'Twin Lakes', 26.1805591583252, 0.45693695732593, -80.1602783203125, -1.39906078600448, 218, 12, 'PPL', 'P'),
(25618, 'Twin Lakes', 30.6958293914795, 0.535743289511765, -83.2058334350586, -1.45221575030776, 218, 13, 'PPL', 'P'),
(38615, 'Twin Lakes', 36.9638900756836, 0.645141586165935, -88.1900024414063, -1.53920590994438, 218, 21, 'PPL', 'P'),
(52259, 'Twin Lakes', 39.7011108398438, 0.692915100854485, -77.0058288574219, -1.34400525678927, 218, 25, 'PPL', 'P'),
(62105, 'Twin Lakes', 34.9444389343262, 0.60989551466609, -90.091667175293, -1.57239622081976, 218, 30, 'PPL', 'P'),
(69678, 'Twin Lakes', 35.2405586242676, 0.615063778235552, -78.9574966430664, -1.37806828555388, 218, 33, 'PPL', 'P'),
(77511, 'Twin Lakes', 35.8694381713867, 0.626039796931232, -97.664436340332, -1.7045659762432, 218, 42, 'PPL', 'P'),
(84105, 'Twin Lakes', 33.8938903808594, 0.591559983456031, -80.4044418334961, -1.40332224322277, 218, 48, 'PPL', 'P'),
(114194, 'Twin Lakes', 42.0183296203613, 0.733358198063564, -73.3872222900391, -1.28084865785415, 218, 8, 'PPL', 'P'),
(123838, 'Twin Lakes', 41.3041687011719, 0.720893738634639, -86.3572235107422, -1.50721788314311, 218, 19, 'PPL', 'P'),
(133464, 'Twin Lakes', 46.8972206115723, 0.818510909706085, -88.850830078125, -1.55073952799329, 218, 27, 'PPL', 'P'),
(138503, 'Twin Lakes', 43.5597190856934, 0.760260519289163, -93.4227828979492, -1.63053515794506, 218, 28, 'PPL', 'P'),
(158012, 'Twin Lakes', 41.2016716003418, 0.719104826751406, -81.3408279418945, -1.41966526388426, 218, 41, 'PPL', 'P'),
(168136, 'Twin Lakes', 41.3894386291504, 0.722381979630803, -74.8974990844727, -1.30720796053349, 218, 45, 'PPL', 'P'),
(176754, 'Twin Lakes', 42.5311088562012, 0.74230788406483, -88.2480621337891, -1.54021924273915, 218, 57, 'PPL', 'P'),
(185796, 'Twin Lakes', 36.9674987792969, 0.645204569925715, -121.996940612793, -2.12924829105323, 218, 6, 'PPL', 'P'),
(187468, 'Twin Lakes', 39.0827789306641, 0.682123173169156, -106.381393432617, -1.85670557825864, 218, 7, 'PPL', 'P'),
(189728, 'Twin Lakes', 35.709171295166, 0.623242612259295, -108.774169921875, -1.8984674062605, 218, 38, 'PPL', 'P'),
(158013, 'Twin Lakes (historical)', 40.121940612793, 0.700259965982869, -84.2180633544922, -1.46988249518907, 218, 41, 'PPL', 'P'),
(69679, 'Twin Lakes Estates', 35.7483291625977, 0.623926045974036, -78.6538925170898, -1.37276939393295, 218, 33, 'PPL', 'P'),
(168138, 'Twin Lakes Park', 40.2775001525879, 0.702974992135177, -76.8022232055664, -1.34045166778873, 218, 45, 'PPL', 'P'),
(118087, 'Twin Lakes Trailer Court', 42.4694404602051, 0.741231567510274, -94.6438903808594, -1.65184750404259, 218, 16, 'PPL', 'P'),
(144577, 'Twin Lakes Village', 43.4411087036133, 0.758190377594817, -72.0113906860352, -1.25683586641129, 218, 36, 'PPL', 'P'),
(153243, 'Twin Lakes Village', 41.2991714477539, 0.720806520108939, -73.5702819824219, -1.28404365221392, 218, 40, 'PPL', 'P'),
(52260, 'Twin Maples', 39.3433303833008, 0.686670653888521, -77.1044387817383, -1.34572632464374, 218, 25, 'PPL', 'P'),
(158014, 'Twin Maples Trailer Court', 41.3419418334961, 0.721553004162488, -83.4241714477539, -1.45602646751155, 218, 41, 'PPL', 'P'),
(192344, 'Twin Mill', 35.9558296203613, 0.627547612161408, -102.808326721191, -1.79434379975086, 218, 51, 'PPL', 'P'),
(194458, 'Twin Mills', 40.5736083984375, 0.708143055967558, -103.125831604004, -1.79988530534709, 218, 7, 'PPL', 'P'),
(144576, 'Twin Mountain', 44.2722206115723, 0.772696016841234, -71.539436340332, -1.24859870915968, 218, 36, 'PPL', 'P'),
(98667, 'Twin Mountains', 33.1094398498535, 0.577868738870961, -98.5824966430664, -1.72058915125777, 218, 51, 'PPL', 'P'),
(69680, 'Twin Oak', 34.4955596923828, 0.602061093950322, -77.8974990844727, -1.35956783809332, 218, 33, 'PPL', 'P'),
(91456, 'Twin Oak', 36.0755615234375, 0.629637328089766, -85.6222229003906, -1.49438970248831, 218, 50, 'PPL', 'P'),
(12425, 'Twin Oak (historical)', 34.2630615234375, 0.598003235397369, -92.8013916015625, -1.61968983387988, 218, 4, 'PPL', 'P'),
(91457, 'Twin Oak Estates', 35.7694396972656, 0.624294494310849, -83.9166717529297, -1.46462221940394, 218, 50, 'PPL', 'P'),
(12427, 'Twin Oaks', 36.0525016784668, 0.629234857870028, -90.4402770996094, -1.57848061180421, 218, 4, 'PPL', 'P'),
(14770, 'Twin Oaks', 39.7847213745117, 0.694374379973793, -75.5361099243164, -1.31835382232769, 218, 10, 'PPL', 'P'),
(25619, 'Twin Oaks', 33.4069404602051, 0.583061104048288, -82.0869369506836, -1.43268732266642, 218, 13, 'PPL', 'P'),
(38616, 'Twin Oaks', 38.0191688537598, 0.663559675369786, -84.5408325195313, -1.47551587984291, 218, 21, 'PPL', 'P'),
(43414, 'Twin Oaks', 32.8925018310547, 0.574082456170168, -91.790283203125, -1.60204266323258, 218, 22, 'PPL', 'P'),
(52262, 'Twin Oaks', 39.1588897705078, 0.683451557920888, -76.883056640625, -1.3418624773762, 218, 25, 'PPL', 'P'),
(57968, 'Twin Oaks', 38.5647201538086, 0.673081341794174, -90.4963912963867, -1.57945998929509, 218, 29, 'PPL', 'P'),
(69681, 'Twin Oaks', 36.5275001525879, 0.63752514518539, -81.163330078125, -1.41656734174623, 218, 33, 'PPL', 'P'),
(77512, 'Twin Oaks', 36.2052803039551, 0.631901347911469, -94.8511123657227, -1.65546420996097, 218, 42, 'PPL', 'P'),
(91460, 'Twin Oaks', 36.5938911437988, 0.638683886575683, -81.9700012207031, -1.43064640916504, 218, 50, 'PPL', 'P'),
(107030, 'Twin Oaks', 38.7516708374023, 0.676344246761739, -77.6069412231445, -1.35449664674559, 218, 53, 'PPL', 'P'),
(168139, 'Twin Oaks', 41.3369407653809, 0.721465719057761, -79.6838912963867, -1.3907462639232, 218, 45, 'PPL', 'P'),
(185798, 'Twin Oaks', 33.1852798461914, 0.579192396511757, -117.15389251709, -2.04472115595077, 218, 6, 'PPL', 'P'),
(143233, 'Twin Oaks Mobile Park', 40.8866691589355, 0.713606996997046, -97.102783203125, -1.69476327974478, 218, 35, 'PPL', 'P'),
(158016, 'Twin Oaks Trailer Park', 40.6605606079102, 0.709660658314739, -80.6288909912109, -1.40723962002823, 218, 41, 'PPL', 'P'),
(153242, 'Twin Orchard', 42.0972213745117, 0.734735118926162, -76.0266723632813, -1.32691575207424, 218, 40, 'PPL', 'P'),
(172658, 'Twin Orchards', 44.4372215270996, 0.775575826085991, -73.210563659668, -1.27776538310212, 218, 55, 'PPL', 'P'),
(185799, 'Twin Peaks', 34.2388916015625, 0.5975813906807, -117.232780456543, -2.04609801023434, 218, 6, 'PPL', 'P'),
(206168, 'Twin Peaks Circle', 40.6547203063965, 0.709558725824017, -111.861938476563, -1.95235913407935, 218, 52, 'PPL', 'P'),
(206169, 'Twin Peaks Condominium', 40.6083297729492, 0.708749058273605, -111.799171447754, -1.95126364276494, 218, 52, 'PPL', 'P'),
(185800, 'Twin Peaks Estates', 39.1436080932617, 0.683184842337717, -120.173332214355, -2.09742032023347, 218, 6, 'PPL', 'P'),
(25621, 'Twin Pine Estates', 33.7094383239746, 0.588340687751316, -84.774169921875, -1.47958838578186, 218, 13, 'PPL', 'P'),
(118089, 'Twin Pine Mobile Home Park', 41.2127799987793, 0.719298704878763, -92.4250030517578, -1.61312061441898, 218, 16, 'PPL', 'P'),
(25622, 'Twin Pines', 34.1044387817383, 0.595234746286177, -84.6552810668945, -1.47751338381853, 218, 13, 'PPL', 'P'),
(107031, 'Twin Pines', 36.8788909912109, 0.643658072280706, -76.392219543457, -1.33329575393968, 218, 53, 'PPL', 'P'),
(185801, 'Twin Pines', 39.0255584716797, 0.681124487760377, -120.978332519531, -2.11147022603835, 218, 6, 'PPL', 'P'),
(18398, 'Twin Pole', 30.1022205352783, 0.525382860502057, -84.8497161865234, -1.48090691683756, 218, 12, 'PPL', 'P'),
(107032, 'Twin Poplars', 37.8605613708496, 0.660791452574704, -78.8041687011719, -1.37539220813251, 218, 53, 'PPL', 'P'),
(52263, 'Twin Ridge', 39.1430587768555, 0.683175254957792, -76.6138916015625, -1.3371646612133, 218, 25, 'PPL', 'P'),
(52264, 'Twin Ridge Estates', 39.6416702270508, 0.691877666451844, -76.4691696166992, -1.33463878607741, 218, 25, 'PPL', 'P'),
(52265, 'Twin River Trailer Park', 38.2905616760254, 0.668296373684601, -75.8763885498047, -1.32429280471662, 218, 25, 'PPL', 'P'),
(25623, 'Twin Rivers', 34.2825012207031, 0.598342522120245, -83.920280456543, -1.46468520316373, 218, 13, 'PPL', 'P'),
(146479, 'Twin Rivers', 40.2638893127441, 0.702737438165942, -74.4916687011719, -1.30012488414026, 218, 37, 'PPL', 'P'),
(111763, 'Twin Rivers Mobile Home Park', 38.4569396972656, 0.671200217958197, -81.8199996948242, -1.42802838865544, 218, 58, 'PPL', 'P'),
(98668, 'Twin Roads Colonia', 26.3250007629395, 0.459457938903313, -98.2630004882813, -1.7150128914093, 218, 51, 'PPL', 'P'),
(168140, 'Twin Rocks', 40.4966697692871, 0.706800223566913, -78.8661117553711, -1.37647331837703, 218, 45, 'PPL', 'P'),
(185802, 'Twin Rocks', 39.8227806091309, 0.695038638928687, -123.564170837402, -2.15660161860943, 218, 6, 'PPL', 'P'),
(201692, 'Twin Rocks', 45.5977783203125, 0.795831363283943, -123.944717407227, -2.16324340921003, 218, 43, 'PPL', 'P'),
(52266, 'Twin Shields Estates', 38.7597198486328, 0.676484728509241, -76.6458282470703, -1.33772206082945, 218, 25, 'PPL', 'P'),
(98669, 'Twin Sisters', 30.0025005340576, 0.523642418150663, -98.4049987792969, -1.71749122911973, 218, 51, 'PPL', 'P'),
(208996, 'Twin Spits', 47.9266700744629, 0.836478192316413, -122.609718322754, -2.13994327967488, 218, 56, 'PPL', 'P'),
(12429, 'Twin Springs', 34.7374992370605, 0.606283735595725, -92.4847183227539, -1.61416284251158, 218, 4, 'PPL', 'P'),
(57969, 'Twin Springs', 38.2719383239746, 0.667971334873557, -91.0736083984375, -1.58953432822469, 218, 29, 'PPL', 'P'),
(91462, 'Twin Springs', 35.8108291625977, 0.625016876756533, -86.3308334350586, -1.50675728943258, 218, 50, 'PPL', 'P'),
(107033, 'Twin Springs', 36.7747192382813, 0.641839932204509, -82.4644393920898, -1.43927598320328, 218, 53, 'PPL', 'P'),
(118092, 'Twin Springs', 43.1252784729004, 0.752678100191544, -91.8583297729492, -1.6032302999207, 218, 16, 'PPL', 'P'),
(195745, 'Twin Springs', 43.6694412231445, 0.762175531850012, -115.70027923584, -2.01935081814223, 218, 17, 'PPL', 'P'),
(187469, 'Twin Spruce', 39.8891716003418, 0.69619738031898, -105.358062744141, -1.83884508840803, 218, 7, 'PPL', 'P'),
(118093, 'Twin T Mobile Home Park', 42.4633293151855, 0.741124907908617, -90.6875, -1.58279546540236, 218, 16, 'PPL', 'P'),
(176756, 'Twin Town', 45.3600006103516, 0.791681359357272, -92.0322189331055, -1.60626523829895, 218, 57, 'PPL', 'P'),
(74584, 'Twin Valley', 38.7902793884277, 0.677018093096556, -82.9524993896484, -1.44779423710795, 218, 41, 'PPL', 'P'),
(138507, 'Twin Valley', 47.2602806091309, 0.824847502045765, -96.2586135864258, -1.68002974048808, 218, 28, 'PPL', 'P'),
(118094, 'Twin View Heights', 41.8105583190918, 0.729731904765258, -91.5730590820313, -1.59825138710474, 218, 16, 'PPL', 'P'),
(25624, 'Twin Village', 33.8180618286133, 0.590236525552316, -84.0325012207031, -1.46664382498742, 218, 13, 'PPL', 'P'),
(52267, 'Twinbrook Estates', 38.6230583190918, 0.674099534857939, -77.0072174072266, -1.34402949155519, 218, 25, 'PPL', 'P'),
(13237, 'Twining', 38.8716697692871, 0.678438623222005, -76.9661102294922, -1.34331203595753, 218, 9, 'PPL', 'P'),
(133465, 'Twining', 44.1130599975586, 0.769918140087199, -83.807502746582, -1.46271686080205, 218, 27, 'PPL', 'P'),
(189729, 'Twining', 36.5947189331055, 0.638698334224597, -105.449722290039, -1.84044484927484, 218, 38, 'PPL', 'P'),
(195746, 'Twinlow', 47.8772201538086, 0.835615128386146, -116.855278015137, -2.03950934969748, 218, 17, 'PPL', 'P'),
(52268, 'Twinridge', 39.3863906860352, 0.687422197948142, -76.6666717529297, -1.33808584863436, 218, 25, 'PPL', 'P'),
(206172, 'Twins of Arden', 40.6563911437988, 0.709587887437953, -112.021667480469, -1.95514693110844, 218, 52, 'PPL', 'P'),
(158017, 'Twinsburg', 41.3125, 0.721039147230157, -81.4402770996094, -1.42140097912472, 218, 41, 'PPL', 'P'),
(91465, 'Twinton', 36.2841682434082, 0.633278202195041, -85.1277770996094, -1.48575999529201, 218, 50, 'PPL', 'P'),
(91466, 'Twinville', 36.1427803039551, 0.630810517128973, -83.9855575561523, -1.46582450347806, 218, 50, 'PPL', 'P'),
(208997, 'Twisp', 48.3636093139648, 0.844104220676883, -120.121109008789, -2.09650885335039, 218, 56, 'PPL', 'P'),
(12431, 'Twist', 35.3761100769043, 0.617429597389924, -90.5072174072266, -1.57964894057443, 218, 4, 'PPL', 'P'),
(111764, 'Twistville (historical)', 38.6083297729492, 0.673842473233719, -80.8150024414063, -1.41048787760979, 218, 58, 'PPL', 'P'),
(129115, 'Twitchell Corner', 44.6911087036133, 0.780006993244746, -69.3672180175781, -1.21068634735547, 218, 26, 'PPL', 'P'),
(192346, 'Twitty', 35.3138885498047, 0.616343626876417, -100.235832214355, -1.7494453006171, 218, 51, 'PPL', 'P'),
(146480, 'Two Bridges', 40.8955612182617, 0.71376219270957, -74.2774963378906, -1.29638687123422, 218, 37, 'PPL', 'P'),
(153244, 'Two Brooks', 44.5794410705566, 0.778058025379999, -73.9711074829102, -1.2910393769234, 218, 40, 'PPL', 'P'),
(187470, 'Two Buttes', 37.5611114501953, 0.65556506551445, -102.397216796875, -1.78716857798391, 218, 7, 'PPL', 'P'),
(91467, 'Two Chestnut', 36.4469413757324, 0.636119129287883, -86.616943359375, -1.51175084963453, 218, 50, 'PPL', 'P'),
(176757, 'Two Creeks', 44.3022193908691, 0.773219594311543, -87.5630569458008, -1.52826364681551, 218, 57, 'PPL', 'P'),
(18399, 'Two Egg', 30.8525009155273, 0.538477723450517, -85.0763931274414, -1.48486317579493, 218, 12, 'PPL', 'P'),
(192347, 'Two F Crossing', 33.3050003051758, 0.581281912703034, -100.018890380859, -1.74565895133728, 218, 51, 'PPL', 'P'),
(195747, 'Two Forks', 43.7130584716797, 0.762936796447611, -111.176391601563, -1.94039408393384, 218, 17, 'PPL', 'P'),
(189730, 'Two Grey Hills', 36.2374992370605, 0.63246367437564, -108.801940917969, -1.8989521015789, 218, 38, 'PPL', 'P'),
(179413, 'Two Guns', 35.1177787780762, 0.61292086566442, -111.092781066895, -1.93893480481453, 218, 5, 'PPL', 'P'),
(138509, 'Two Harbors', 47.0227813720703, 0.820702358388084, -91.6705627441406, -1.5999531470413, 218, 28, 'PPL', 'P'),
(185803, 'Two Harbors', 33.439998626709, 0.583638077898454, -118.498329162598, -2.06818600199934, 218, 6, 'PPL', 'P'),
(91468, 'Two Hills', 35.898609161377, 0.626548926752628, -86.3291702270508, -1.5067282609767, 218, 50, 'PPL', 'P'),
(138511, 'Two Inlets', 47.0527801513672, 0.821225935858393, -95.2172164916992, -1.6618539323644, 218, 28, 'PPL', 'P'),
(52269, 'Two Johns Estates', 38.8216705322266, 0.677565971911813, -75.8625030517578, -1.32405045705742, 218, 25, 'PPL', 'P'),
(168141, 'Two Lick', 40.5675010681152, 0.708036462944927, -79.1641693115234, -1.38167540409234, 218, 45, 'PPL', 'P'),
(52270, 'Two Locks', 39.6150016784668, 0.691412212472326, -77.9241714477539, -1.36003335865186, 218, 25, 'PPL', 'P'),
(18400, 'Two Mile', 29.7133293151855, 0.51859542827934, -85.0077819824219, -1.48366568541077, 218, 12, 'PPL', 'P'),
(12433, 'Two Mile (historical)', 34.5111083984375, 0.602332470065401, -94.3475036621094, -1.64667457994122, 218, 4, 'PPL', 'P'),
(206173, 'Two Pines Condominium', 40.6875, 0.710130839405193, -111.930557250977, -1.95355675762155, 218, 52, 'PPL', 'P'),
(197734, 'Two River Trailer Park', 46.7550010681152, 0.816028710412076, -114.086112976074, -1.99117830223472, 218, 31, 'PPL', 'P'),
(52271, 'Two Rivers', 39.4894409179688, 0.689220763790327, -75.9058303833008, -1.32480666164895, 218, 25, 'PPL', 'P'),
(133466, 'Two Rivers', 43.625, 0.761399886182526, -84.9519424438477, -1.48269110160986, 218, 27, 'PPL', 'P'),
(176759, 'Two Rivers', 44.1538887023926, 0.770630735415877, -87.5691680908203, -1.52837030641717, 218, 57, 'PPL', 'P'),
(185804, 'Two Rivers', 39.8230590820313, 0.695043499197676, -120.669166564941, -2.10607426219568, 218, 6, 'PPL', 'P'),
(208998, 'Two Rivers', 46.1408309936523, 0.80530942044548, -118.941390991211, -2.07591888969855, 218, 56, 'PPL', 'P'),
(185805, 'Two Rock', 38.2663917541504, 0.667874528967933, -122.791107177734, -2.14310911242071, 218, 6, 'PPL', 'P'),
(111766, 'Two Run', 38.9644393920898, 0.680057758585746, -81.3874969482422, -1.42047979170366, 218, 58, 'PPL', 'P'),
(202703, 'Two Strike', 43.2130584716797, 0.754210150187639, -100.875282287598, -1.7606058097973, 218, 49, 'PPL', 'P'),
(79286, 'Two Taverns', 39.7783317565918, 0.694262860103146, -77.1658325195313, -1.34679784750833, 218, 45, 'PPL', 'P'),
(129116, 'Two Trails', 43.7319412231445, 0.763266362632508, -70.5902786254883, -1.23203278191495, 218, 26, 'PPL', 'P'),
(197735, 'Twodot', 46.4244384765625, 0.810259304805556, -110.072219848633, -1.9211226513377, 218, 31, 'PPL', 'P'),
(91469, 'Twomey', 35.7661094665527, 0.624236370820058, -87.4641723632813, -1.52653778527109, 218, 50, 'PPL', 'P'),
(111767, 'Twomile', 38.3669395446777, 0.669629418968241, -81.6069412231445, -1.42430981682536, 218, 58, 'PPL', 'P'),
(168142, 'Twomile', 41.8325004577637, 0.730114867330011, -78.2961120605469, -1.36652494696698, 218, 45, 'PPL', 'P'),
(107035, 'Twymans Mill', 38.3177795410156, 0.668771415044044, -78.1716690063477, -1.36435300593997, 218, 53, 'PPL', 'P'),
(25626, 'Ty Ty', 31.4716701507568, 0.549284265232327, -83.6469421386719, -1.45991454954501, 218, 13, 'PPL', 'P'),
(52273, 'Tyaskin', 38.3219413757324, 0.668844052762776, -75.873893737793, -1.32424926203279, 218, 25, 'PPL', 'P'),
(52278, 'Tyaskin Estates', 38.3224983215332, 0.668853773300755, -75.8672180175781, -1.3241327487351, 218, 25, 'PPL', 'P'),
(25627, 'Tybee Island', 32, 0.558505360638185, -80.845832824707, -1.41102596930805, 218, 13, 'PPL', 'P'),
(190857, 'Tybo', 38.3699989318848, 0.669682815348097, -116.400283813477, -2.03156820280103, 218, 39, 'PPL', 'P'),
(14771, 'Tybouts Corner', 39.6199989318848, 0.691499430998026, -75.6425018310547, -1.32021071139774, 218, 10, 'PPL', 'P'),
(14772, 'Tybrook', 39.7486114501953, 0.693744142901826, -75.6319427490234, -1.32002642065031, 218, 10, 'PPL', 'P'),
(52274, 'Tydings', 39.1483306884766, 0.683267267173455, -76.591667175293, -1.33677677180053, 218, 25, 'PPL', 'P'),
(52275, 'Tydings on the Bay', 39.0361099243164, 0.681308645349756, -76.4113922119141, -1.33363038013065, 218, 25, 'PPL', 'P'),
(98670, 'Tye', 32.4575004577637, 0.566490249955543, -99.8711090087891, -1.74307967982154, 218, 51, 'PPL', 'P'),
(107036, 'Tye River', 37.6525001525879, 0.657160099270326, -78.9483337402344, -1.37790836273042, 218, 53, 'PPL', 'P'),
(193321, 'Tyee', 57.0405616760254, 0.995545608433538, -134.543334960938, -2.34822418168196, 218, 1, 'PPL', 'P'),
(201693, 'Tyee', 43.4436111450195, 0.758234053436695, -123.550003051758, -2.15635434410222, 218, 43, 'PPL', 'P'),
(208999, 'Tyee Beach', 48.0927810668945, 0.839377376058101, -122.384437561035, -2.13601138864148, 218, 56, 'PPL', 'P'),
(194024, 'Tyee City', 40.9225006103516, 0.714232373800024, -124.125556945801, -2.16639965457594, 218, 6, 'PPL', 'P'),
(38617, 'Tyewhoppety', 37.0322189331055, 0.646334149702072, -87.1227798461914, -1.5205793618062, 218, 21, 'PPL', 'P'),
(111769, 'Tygart Junction', 39.098331451416, 0.682394615863263, -80.0752792358398, -1.39757727211925, 218, 58, 'PPL', 'P'),
(38622, 'Tygarts Valley', 38.4816703796387, 0.671631849791871, -83.0319366455078, -1.44918067877145, 218, 21, 'PPL', 'P'),
(84110, 'Tyger', 34.9363899230957, 0.609755032918589, -82.1791687011719, -1.43429707038732, 218, 48, 'PPL', 'P'),
(84109, 'Tyger (historical)', 35.0844383239746, 0.612338964966238, -82.2472229003906, -1.4354848402335, 218, 48, 'PPL', 'P'),
(201694, 'Tygh Valley', 45.247501373291, 0.789717877264584, -121.171943664551, -2.11484937798749, 218, 43, 'PPL', 'P'),
(195748, 'Tyhee', 42.9516716003418, 0.749648088661306, -112.465560913086, -1.96289433303559, 218, 17, 'PPL', 'P'),
(6437, 'Tyler', 32.339168548584, 0.564424968530186, -86.8797225952148, -1.51633721250581, 218, 2, 'PPL', 'P'),
(18401, 'Tyler', 29.6508293151855, 0.517504597496843, -82.7641677856445, -1.44450723053252, 218, 12, 'PPL', 'P'),
(34206, 'Tyler', 37.6694412231445, 0.657455776730352, -97.4444427490234, -1.70072636374157, 218, 20, 'PPL', 'P'),
(38619, 'Tyler', 37.060001373291, 0.646819044757548, -88.5827789306641, -1.54606115290635, 218, 21, 'PPL', 'P'),
(52277, 'Tyler', 37.9663887023926, 0.662638487948728, -75.8363876342773, -1.32359465703685, 218, 25, 'PPL', 'P'),
(57970, 'Tyler', 36.0338897705078, 0.628910018796065, -89.7372207641602, -1.56620996392362, 218, 29, 'PPL', 'P'),
(62106, 'Tyler', 30.7072200775146, 0.535942094487139, -89.6061096191406, -1.56392164275697, 218, 30, 'PPL', 'P'),
(77513, 'Tyler', 34.1036109924316, 0.595220298637263, -96.9094390869141, -1.69138878832754, 218, 42, 'PPL', 'P'),
(98671, 'Tyler', 32.3511085510254, 0.564633360885485, -95.3008270263672, -1.6633132114837, 218, 51, 'PPL', 'P'),
(111772, 'Tyler', 39.4330596923828, 0.688236725767542, -80.8269424438477, -1.41069626996509, 218, 58, 'PPL', 'P'),
(138515, 'Tyler', 44.2783317565918, 0.772802676442891, -96.1344375610352, -1.67786245999297, 218, 28, 'PPL', 'P'),
(140986, 'Tyler', 46.149169921875, 0.805454962199053, -96.6050033569336, -1.68607538247867, 218, 34, 'PPL', 'P'),
(144578, 'Tyler', 43.2344398498535, 0.754583325635387, -71.6900024414063, -1.25122658336531, 218, 36, 'PPL', 'P'),
(168144, 'Tyler', 41.7186088562012, 0.728127083892376, -75.9122161865234, -1.32491811494057, 218, 45, 'PPL', 'P'),
(206174, 'Tyler', 40.6513900756836, 0.709500602333226, -111.851669311523, -1.95217990333798, 218, 52, 'PPL', 'P'),
(209000, 'Tyler', 47.4361114501953, 0.82791632914889, -117.782501220703, -2.05569244753551, 218, 56, 'PPL', 'P'),
(12436, 'Tyler (historical)', 35.538890838623, 0.620270657640821, -91.8388900756836, -1.60289101319782, 218, 4, 'PPL', 'P'),
(185807, 'Tyler (historical)', 37.0566711425781, 0.646760921266757, -120.313606262207, -2.09986856422358, 218, 6, 'PPL', 'P'),
(129119, 'Tyler Corner', 44.5927810668945, 0.778290852238299, -69.7600021362305, -1.2175417234755, 218, 26, 'PPL', 'P'),
(6438, 'Tyler Crossroads', 31.7030601501465, 0.553322782577864, -85.5266723632813, -1.4927220310137, 218, 2, 'PPL', 'P'),
(84113, 'Tyler Crossroads', 33.6736106872559, 0.587715377527365, -79.2872161865234, -1.38382297719538, 218, 48, 'PPL', 'P'),
(25628, 'Tyler Estates', 32.954719543457, 0.575168360104648, -85.1497192382813, -1.48614295785677, 218, 13, 'PPL', 'P'),
(176767, 'Tyler Forks', 46.3358306884766, 0.808712807160547, -90.5274963378906, -1.5800028746833, 218, 57, 'PPL', 'P'),
(107042, 'Tyler Gardens', 38.8822212219238, 0.678622780811384, -77.1772232055664, -1.34699665248371, 218, 53, 'PPL', 'P'),
(52279, 'Tyler Heights', 38.9594383239746, 0.679970473481018, -76.4983291625977, -1.33514771616173, 218, 25, 'PPL', 'P'),
(111775, 'Tyler Heights', 38.4311103820801, 0.670749411364673, -81.7538909912109, -1.42687457411316, 218, 58, 'PPL', 'P'),
(168145, 'Tyler Hill', 41.6949996948242, 0.727715026292714, -75.1083297729492, -1.31088765021165, 218, 45, 'PPL', 'P'),
(114195, 'Tyler Lake Heights', 41.8377799987793, 0.730207012703728, -73.2708282470703, -1.27881719857464, 218, 8, 'PPL', 'P'),
(111774, 'Tyler Mountain', 38.3925018310547, 0.670075565029856, -81.7211074829102, -1.42630239395296, 218, 58, 'PPL', 'P'),
(107039, 'Tyler Park', 38.872501373291, 0.678453137449946, -77.195556640625, -1.34731663128868, 218, 53, 'PPL', 'P'),
(168146, 'Tylerdale', 40.1808280944824, 0.701287746426557, -80.251106262207, -1.40064603264335, 218, 45, 'PPL', 'P'),
(107040, 'Tylers', 37.9558296203613, 0.662454197201295, -77.7013931274414, -1.35614514346035, 218, 53, 'PPL', 'P'),
(107041, 'Tylers Beach', 37.0800018310547, 0.647168118597431, -76.6691665649414, -1.33812939131818, 218, 53, 'PPL', 'P'),
(129118, 'Tylers Corner', 43.6399993896484, 0.761661674917681, -70.6091690063477, -1.2323624812579, 218, 26, 'PPL', 'P'),
(153262, 'Tylers Corner', 43.5136108398438, 0.759455778586768, -76.1630630493164, -1.3292962186146, 218, 40, 'PPL', 'P'),
(185808, 'Tylers Corner', 38.5283317565918, 0.672446244453217, -120.685279846191, -2.1063554920068, 218, 6, 'PPL', 'P'),
(158020, 'Tylers Corners', 40.0955581665039, 0.699799505430394, -82.6630630493164, -1.44274261999424, 218, 41, 'PPL', 'P'),
(52280, 'Tylers Summit', 39.4958305358887, 0.689332283660974, -76.9130630493164, -1.34238618800456, 218, 25, 'PPL', 'P'),
(168147, 'Tylersburg', 41.3847198486328, 0.722299621374092, -79.3225021362305, -1.38443883319746, 218, 45, 'PPL', 'P'),
(168148, 'Tylersport', 40.3494415283203, 0.704230606010122, -75.3813934326172, -1.3156535101404, 218, 45, 'PPL', 'P'),
(74588, 'Tylersville', 39.3574981689453, 0.686917928395735, -84.42138671875, -1.4734311573416, 218, 41, 'PPL', 'P'),
(84111, 'Tylersville', 34.5811080932617, 0.603554195215475, -81.9211120605469, -1.42979313235178, 218, 48, 'PPL', 'P'),
(91470, 'Tylersville', 36.0041694641113, 0.628391301594745, -89.541389465332, -1.56279206298061, 218, 50, 'PPL', 'P'),
(153245, 'Tylersville', 43.9008293151855, 0.766214015906035, -75.7997207641602, -1.32295469942691, 218, 40, 'PPL', 'P'),
(168149, 'Tylersville', 40.9905586242676, 0.715420210225227, -77.4252777099609, -1.35132602030979, 218, 45, 'PPL', 'P'),
(52281, 'Tylerton', 37.9677810668945, 0.662662789293675, -76.0233306884766, -1.32685742884636, 218, 25, 'PPL', 'P'),
(107045, 'Tylerton', 38.2816696166992, 0.668141177972077, -77.4347229003906, -1.35149086998127, 218, 53, 'PPL', 'P'),
(62107, 'Tylertown', 31.1158294677734, 0.543073673701721, -90.1419372558594, -1.57327359924089, 218, 30, 'PPL', 'P'),
(71488, 'Tylertown', 39.6547203063965, 0.692105433304073, -74.6094436645508, -1.30218044502763, 218, 37, 'PPL', 'P'),
(153246, 'Tylertown', 41.6266708374023, 0.726522462756576, -74.9491729736328, -1.30810984003664, 218, 40, 'PPL', 'P'),
(114196, 'Tylerville', 41.4474983215332, 0.723395312425578, -72.4755630493164, -1.26493720244731, 218, 8, 'PPL', 'P'),
(197736, 'Tyman Place', 46.2216682434082, 0.806720296611977, -110.638610839844, -1.93100803898796, 218, 31, 'PPL', 'P'),
(158021, 'Tymochtee', 40.9491691589355, 0.714697827779542, -83.2702789306641, -1.45334053639415, 218, 41, 'PPL', 'P'),
(98673, 'Tynan', 28.1691703796387, 0.491644770679956, -97.7572174072266, -1.70618531134402, 218, 51, 'PPL', 'P'),
(158023, 'Tyndall', 40.2172203063965, 0.701922910346541, -81.8822174072266, -1.42911429258992, 218, 41, 'PPL', 'P'),
(171461, 'Tyndall', 42.9933280944824, 0.750375131638898, -97.8625030517578, -1.70802289249617, 218, 49, 'PPL', 'P'),
(52282, 'Tyndall Estates', 38.2294387817383, 0.667229577930943, -75.4661102294922, -1.31713209717761, 218, 25, 'PPL', 'P'),
(185809, 'Tyndall Landing', 38.8830604553223, 0.678637428197379, -121.816940307617, -2.12610669307331, 218, 6, 'PPL', 'P'),
(71489, 'Tyndall Village', 39.892219543457, 0.696250576961754, -75.0213928222656, -1.30937031418058, 218, 37, 'PPL', 'P'),
(25629, 'Tyner', 34.2797203063965, 0.598293986009378, -83.8130569458008, -1.46281379986573, 218, 13, 'PPL', 'P'),
(38620, 'Tyner', 37.3452796936035, 0.65179809073156, -83.904167175293, -1.46440397335261, 218, 21, 'PPL', 'P'),
(77514, 'Tyner', 36.7388916015625, 0.641214621980558, -97.2919387817383, -1.69806466739009, 218, 42, 'PPL', 'P'),
(91471, 'Tyner', 35.0627784729004, 0.611960929249501, -85.1572189331055, -1.48627385222434, 218, 50, 'PPL', 'P'),
(123839, 'Tyner', 41.4097213745117, 0.722735980318701, -86.4024963378906, -1.50800804303853, 218, 19, 'PPL', 'P'),
(153247, 'Tyner', 42.4302787780762, 0.740548067216506, -75.6658325195313, -1.32061790872842, 218, 40, 'PPL', 'P'),
(158024, 'Tyner', 40.105281829834, 0.699969215370859, -81.570556640625, -1.42367478606343, 218, 41, 'PPL', 'P'),
(12439, 'Tyner (historical)', 34.6297187805176, 0.604402611759747, -90.8563919067383, -1.58574318525491, 218, 4, 'PPL', 'P'),
(111778, 'Tyner (historical)', 39.1430587768555, 0.683175254957792, -81.6430587768555, -1.42494018705538, 218, 58, 'PPL', 'P'),
(31336, 'Tyner Crossing', 39.6547203063965, 0.692105433304073, -85.1769409179688, -1.48661806579524, 218, 19, 'PPL', 'P'),
(91472, 'Tyner Hills', 35.0574989318848, 0.611868783875784, -85.1500015258789, -1.48614788470478, 218, 50, 'PPL', 'P'),
(126379, 'Tyngsboro', 42.6766700744629, 0.744848406586711, -71.4250030517578, -1.24660147150017, 218, 23, 'PPL', 'P'),
(74589, 'Tynrhos (historical)', 38.857780456543, 0.67819620898378, -82.4124984741211, -1.43836944316822, 218, 41, 'PPL', 'P'),
(212205, 'Tyonek', 61.0680618286133, 1.06583874672077, -151.136932373047, -2.63783709127367, 218, 1, 'PPL', 'P'),
(98674, 'Type', 30.44407081604, 0.531349273450216, -97.3550109863281, -1.69916548502668, 218, 51, 'PPL', 'P'),
(38621, 'Typo', 37.2777786254883, 0.650619974844337, -83.254997253418, -1.45307382081098, 218, 21, 'PPL', 'P'),
(176762, 'Tyran', 45.9488906860352, 0.80195943011027, -88.3052825927734, -1.54121792814793, 218, 57, 'PPL', 'P'),
(133467, 'Tyre', 43.6749992370605, 0.762272537492718, -82.89111328125, -1.44672284740141, 218, 27, 'PPL', 'P'),
(153248, 'Tyre', 42.9911117553711, 0.750336449224065, -76.8024978637695, -1.34045646147869, 218, 40, 'PPL', 'P'),
(25630, 'Tyree', 33.6150016784668, 0.586692457352666, -84.8794403076172, -1.48142570061791, 218, 13, 'PPL', 'P'),
(91473, 'Tyree Springs (historical)', 36.4416694641113, 0.63602711707222, -86.6455612182617, -1.51225032549698, 218, 50, 'PPL', 'P'),
(126381, 'Tyringham', 42.2458305358887, 0.737328838090818, -73.2041702270508, -1.27765379665244, 218, 23, 'PPL', 'P'),
(138, 'Tyro', 37.8213882446289, 0.660107752543853, -79.004997253418, -1.37889732760122, 218, 53, 'PPL', 'P'),
(12437, 'Tyro', 33.8355598449707, 0.590541923550321, -91.7205581665039, -1.60082573177247, 218, 4, 'PPL', 'P'),
(34207, 'Tyro', 37.0377807617188, 0.646431221923806, -95.8211135864258, -1.6723939250106, 218, 20, 'PPL', 'P'),
(62108, 'Tyro', 34.583610534668, 0.603597871057353, -89.7052764892578, -1.56565243114941, 218, 30, 'PPL', 'P'),
(69685, 'Tyro', 35.8088912963867, 0.624983054610689, -80.3730621337891, -1.4027745641446, 218, 33, 'PPL', 'P'),
(200250, 'Tyrol', 40.6783294677734, 0.709970783423679, -116.153060913086, -2.02725334920288, 218, 39, 'PPL', 'P'),
(77515, 'Tyrola', 34.9069404602051, 0.609241042828203, -96.6952819824219, -1.68765104173761, 218, 42, 'PPL', 'P'),
(190858, 'Tyrolian Village', 39.2563896179199, 0.685153251278421, -119.925827026367, -2.09310053978731, 218, 39, 'PPL', 'P'),
(25632, 'Tyrone', 33.6722183227539, 0.587691076182418, -82.8613891601563, -1.44620406362107, 218, 13, 'PPL', 'P'),
(38623, 'Tyrone', 38.0327796936035, 0.663797229339022, -84.8363876342773, -1.48067428971634, 218, 21, 'PPL', 'P'),
(43416, 'Tyrone', 30.496940612793, 0.532272025478414, -92.5111083984375, -1.61462343622211, 218, 22, 'PPL', 'P'),
(52284, 'Tyrone', 39.6186103820801, 0.691475196232106, -77.0938873291016, -1.34554216705436, 218, 25, 'PPL', 'P'),
(57973, 'Tyrone', 37.2033309936523, 0.649320618548487, -91.8763885498047, -1.60354548503571, 218, 29, 'PPL', 'P'),
(111776, 'Tyrone', 39.6394386291504, 0.691838717720902, -79.85888671875, -1.39380051021936, 218, 58, 'PPL', 'P'),
(118095, 'Tyrone', 40.9777793884277, 0.715197170483932, -92.9463882446289, -1.62222050270573, 218, 16, 'PPL', 'P'),
(153250, 'Tyrone', 42.4080581665039, 0.740160244382763, -77.0586090087891, -1.34492644421033, 218, 40, 'PPL', 'P'),
(158025, 'Tyrone', 40.2527809143066, 0.702543560038584, -81.9780578613281, -1.4307870240706, 218, 41, 'PPL', 'P'),
(168150, 'Tyrone', 40.6705589294434, 0.709835161945167, -78.2388916015625, -1.36552626155821, 218, 45, 'PPL', 'P'),
(185810, 'Tyrone', 38.4491691589355, 0.671064596479684, -122.999443054199, -2.14674525941505, 218, 6, 'PPL', 'P'),
(187471, 'Tyrone', 37.4541702270508, 0.653698589064468, -104.207778930664, -1.81876884853046, 218, 7, 'PPL', 'P'),
(189731, 'Tyrone', 32.7097206115723, 0.570892322079389, -108.301391601563, -1.890215867939, 218, 38, 'PPL', 'P'),
(191023, 'Tyrone', 36.9541702270508, 0.644971942804497, -101.065002441406, -1.76391705113865, 218, 42, 'PPL', 'P'),
(52285, 'Tyrone Acres', 39.6222190856934, 0.691538179991886, -77.101936340332, -1.34568264880186, 218, 25, 'PPL', 'P'),
(168151, 'Tyrone Forge', 40.6605606079102, 0.709660658314739, -78.2180633544922, -1.36516274006941, 218, 45, 'PPL', 'P'),
(12438, 'Tyronza', 35.4900016784668, 0.61941738082756, -90.3586120605469, -1.5770552879888, 218, 4, 'PPL', 'P'),
(12440, 'Tyronza Junction', 35.5122184753418, 0.619805137082275, -90.3891677856445, -1.57758858599709, 218, 4, 'PPL', 'P'),
(158026, 'Tyrrell', 41.2722206115723, 0.720336139281404, -80.6363906860352, -1.4073705143958, 218, 41, 'PPL', 'P'),
(168155, 'Tyrrell', 41.9252815246582, 0.731734202430834, -76.2841720581055, -1.3314099695718, 218, 45, 'PPL', 'P'),
(6439, 'Tyson', 32.1866683959961, 0.561763338757734, -86.4394378662109, -1.50865279433844, 218, 2, 'PPL', 'P'),
(57972, 'Tyson', 38.5369415283203, 0.672596513317725, -90.5616683959961, -1.58059928960942, 218, 29, 'PPL', 'P'),
(62109, 'Tyson', 33.9338912963867, 0.592258131135795, -89.533332824707, -1.56265144807505, 218, 30, 'PPL', 'P'),
(98675, 'Tyson', 31.7986106872559, 0.554990454052472, -97.2391662597656, -1.69714361312709, 218, 51, 'PPL', 'P'),
(172659, 'Tyson', 43.4652786254883, 0.758612222311486, -72.7055587768555, -1.26895138515839, 218, 55, 'PPL', 'P'),
(177641, 'Tyson', 32.7966690063477, 0.572409857847544, -113.880828857422, -1.98759541846218, 218, 5, 'PPL', 'P'),
(195749, 'Tyson Creek Station', 47.1338882446289, 0.822641539135825, -116.413330078125, -2.03179590307423, 218, 17, 'PPL', 'P'),
(25635, 'Tyson Estates', 34.0916709899902, 0.595011906281964, -84.5897216796875, -1.47636915665618, 218, 13, 'PPL', 'P'),
(91474, 'Tyson Store', 36.1427803039551, 0.630810517128973, -89.0702819824219, -1.55456968627304, 218, 50, 'PPL', 'P'),
(107043, 'Tysons Corner', 38.9186096191406, 0.67925787815234, -77.2313919067383, -1.34794207467068, 218, 53, 'PPL', 'P'),
(107044, 'Tysons Green', 38.9216690063477, 0.679311274532196, -77.2497177124023, -1.3482619203176, 218, 53, 'PPL', 'P'),
(6440, 'Tysonville', 32.4002799987793, 0.565491564546763, -85.9986114501953, -1.5009589219492, 218, 2, 'PPL', 'P'),
(69688, 'Tysonville', 35.8205604553223, 0.625186719855053, -78.7050018310547, -1.37366141974007, 218, 33, 'PPL', 'P'),
(91475, 'Tysonville (historical)', 36.1555595397949, 0.631033556870267, -89.0727767944336, -1.55461322895687, 218, 50, 'PPL', 'P'),
(25634, 'Tyus', 33.4674987792969, 0.584118046105914, -85.2022171020508, -1.48705921842981, 218, 13, 'PPL', 'P'),
(43431, 'U and I Landing', 31.7694396972656, 0.554481324231076, -91.5611114501953, -1.59804286159139, 218, 22, 'PPL', 'P'),
(69689, 'U-No', 35.3588905334473, 0.617129059660909, -82.42138671875, -1.43852457230171, 218, 33, 'PPL', 'P'),
(179414, 'Ubank Place', 34.910831451416, 0.609308953436, -109.950828552246, -1.91900397353248, 218, 5, 'PPL', 'P'),
(176763, 'Ubet', 45.353889465332, 0.791574699755615, -92.529167175293, -1.61493862133712, 218, 57, 'PPL', 'P'),
(133470, 'Ubly', 43.7099990844727, 0.762883400067755, -82.9316711425781, -1.44743071561916, 218, 27, 'PPL', 'P'),
(6441, 'Uchee', 32.3505592346191, 0.564623773505561, -85.3647232055664, -1.48989548499074, 218, 2, 'PPL', 'P'),
(192831, 'Ucolo', 37.8608283996582, 0.660796113106611, -109.064170837402, -1.90352887707025, 218, 52, 'PPL', 'P'),
(195750, 'Ucon', 43.5963897705078, 0.760900543478136, -111.96305847168, -1.95412401093374, 218, 17, 'PPL', 'P'),
(209799, 'Ucross', 44.5608291625977, 0.777733186306037, -106.539436340332, -1.85946394735769, 218, 59, 'PPL', 'P'),
(34208, 'Udall', 37.3875007629395, 0.652534987405185, -97.1138916015625, -1.69495715787213, 218, 20, 'PPL', 'P'),
(57976, 'Udall', 36.5438919067383, 0.637811235265492, -92.2586135864258, -1.6102165704083, 218, 29, 'PPL', 'P'),
(57977, 'Udall Landing', 36.5430603027344, 0.637796721037551, -92.2888870239258, -1.61074494156858, 218, 29, 'PPL', 'P'),
(118096, 'Udell', 40.7808303833008, 0.71175976188594, -92.741943359375, -1.61865226631918, 218, 16, 'PPL', 'P'),
(133471, 'Udell', 44.2336082458496, 0.772022103927389, -86.0913925170898, -1.50257825705003, 218, 27, 'PPL', 'P'),
(121758, 'Udina', 42.0433311462402, 0.733794557008174, -88.376106262207, -1.54245403436789, 218, 18, 'PPL', 'P'),
(143234, 'Uehling', 41.7341690063477, 0.728398659744537, -96.5047225952148, -1.68432515301027, 218, 35, 'PPL', 'P'),
(194025, 'Ueland Place', 40.313060760498, 0.70359564182722, -123.395561218262, -2.15365882560489, 218, 6, 'PPL', 'P'),
(111777, 'Uffington', 39.5863914489746, 0.690912869767936, -79.9763870239258, -1.39585127741677, 218, 58, 'PPL', 'P'),
(212206, 'Ugashik', 57.5130615234375, 1.00379228648605, -157.397506713867, -2.74710472658686, 218, 1, 'PPL', 'P'),
(168156, 'Uhdey', 41.7241706848145, 0.728224156114109, -76.4038925170898, -1.33349948576308, 218, 45, 'PPL', 'P'),
(6442, 'Uhland', 32.4261093139648, 0.565942371140286, -85.2866668701172, -1.48853314493511, 218, 2, 'PPL', 'P'),
(98676, 'Uhland', 29.9575004577637, 0.522857018655685, -97.7858276367188, -1.70668465404841, 218, 51, 'PPL', 'P'),
(168159, 'Uhlers Crossing', 40.750560760498, 0.711231457304695, -75.2330627441406, -1.31306465124473, 218, 45, 'PPL', 'P'),
(168157, 'Uhlerstown', 40.5252799987793, 0.707299566271302, -75.0736083984375, -1.3102816479056, 218, 45, 'PPL', 'P'),
(168158, 'Uhlersville (historical)', 40.6269416809082, 0.709073897347568, -75.1913909912109, -1.31233734195103, 218, 45, 'PPL', 'P'),
(158027, 'Uhrichsville', 40.3930587768555, 0.704991870607721, -81.3466720581055, -1.41976726295401, 218, 41, 'PPL', 'P'),
(179415, 'Uhs Kug', 31.9661102294922, 0.557913872560079, -111.551940917969, -1.94694865600874, 218, 5, 'PPL', 'P'),
(206175, 'Uintah', 41.1441688537598, 0.718101214494609, -111.922500610352, -1.953416142716, 218, 52, 'PPL', 'P'),
(206177, 'Uintah Highlands', 41.1561088562012, 0.718309606849908, -111.926940917969, -1.95349364070372, 218, 52, 'PPL', 'P'),
(206178, 'Uintah Junction', 41.139720916748, 0.718023583348833, -111.914169311523, -1.95327073412048, 218, 52, 'PPL', 'P'),
(192832, 'Uisco', 39.5652809143066, 0.690544421431123, -112.199996948242, -1.95825936747442, 218, 52, 'PPL', 'P'),
(212207, 'Ukak', 60.7275009155273, 1.05989483748382, -164.932495117188, -2.87861508332439, 218, 1, 'PPL', 'P'),
(185812, 'Ukiah', 39.1502799987793, 0.68330128905638, -123.206672668457, -2.15036209849148, 218, 6, 'PPL', 'P'),
(201695, 'Ukiah', 45.1341705322266, 0.787739880943955, -118.93138885498, -2.0757443194891, 218, 43, 'PPL', 'P'),
(185813, 'Ukiah Rancheria', 39.0902786254883, 0.682254067536734, -123.158332824707, -2.14951840905815, 218, 6, 'PPL', 'P'),
(146493, 'Ukrainian Village', 40.5277786254883, 0.707343175534152, -74.5133285522461, -1.30050291985699, 218, 37, 'PPL', 'P'),
(38624, 'Ula', 37.098331451416, 0.647488030823376, -84.4305572509766, -1.47359121332311, 218, 21, 'PPL', 'P'),
(69692, 'Ulah', 35.6352806091309, 0.621952976501424, -79.8269424438477, -1.39324297744515, 218, 33, 'PPL', 'P'),
(121759, 'Ulah', 41.2691688537598, 0.720282876059602, -90.146110534668, -1.5733464366967, 218, 18, 'PPL', 'P'),
(77516, 'Ulan', 35.1161117553711, 0.612891770629511, -95.8861083984375, -1.67352829847692, 218, 42, 'PPL', 'P'),
(176764, 'Ulao', 43.3205604553223, 0.756086413754627, -87.916389465332, -1.5344304626357, 218, 57, 'PPL', 'P'),
(79288, 'Uledi', 39.896110534668, 0.696318487569551, -79.7905578613281, -1.39260794668322, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(123840, 'Ulen', 40.063060760498, 0.699232318697234, -86.4644393920898, -1.50908915328305, 218, 19, 'PPL', 'P'),
(138520, 'Ulen', 47.0788917541504, 0.821681669299933, -96.2586135864258, -1.68002974048808, 218, 28, 'PPL', 'P'),
(111779, 'Uler', 38.6177787780762, 0.674007389484222, -81.1433334350586, -1.41621833448537, 218, 58, 'PPL', 'P'),
(189733, 'Ulibarri Place', 36.9569396972656, 0.645020279178282, -107.524169921875, -1.87665079061057, 218, 38, 'PPL', 'P'),
(28822, 'Ullin', 37.2769393920898, 0.650605327458341, -89.1833267211914, -1.55654268916663, 218, 18, 'PPL', 'P'),
(28824, 'Ullrich', 39.7408294677734, 0.693608321686232, -88.6813888549805, -1.54778222076081, 218, 18, 'PPL', 'P'),
(12444, 'Ulm', 34.5758285522461, 0.603462049841759, -91.460563659668, -1.59628797159108, 218, 4, 'PPL', 'P'),
(197737, 'Ulm', 47.4305610656738, 0.827819456664239, -111.506393432617, -1.94615370242335, 218, 31, 'PPL', 'P'),
(209800, 'Ulm', 44.651668548584, 0.779318632681988, -106.588607788086, -1.86032215101897, 218, 59, 'PPL', 'P'),
(57978, 'Ulman', 38.1530609130859, 0.665896532647304, -92.4438934326172, -1.61345031376193, 218, 29, 'PPL', 'P'),
(185816, 'Ulmar', 37.7030601501465, 0.658042537697524, -121.714996337891, -2.12432743514903, 218, 6, 'PPL', 'P'),
(84112, 'Ulmer', 33.0972213745117, 0.577655486246673, -81.2083282470703, -1.41735270795169, 218, 48, 'PPL', 'P'),
(118098, 'Ulmer', 42.2677803039551, 0.737711933813626, -94.9497222900391, -1.65718527781543, 218, 16, 'PPL', 'P'),
(197738, 'Ulmer', 46.3544387817383, 0.809037579655482, -105.928886413574, -1.84880784088796, 218, 31, 'PPL', 'P'),
(18402, 'Ulmerton', 27.8944396972656, 0.486849815716295, -82.7705612182617, -1.4446188169822, 218, 12, 'PPL', 'P'),
(189734, 'Ulmoris', 32.3288917541504, 0.564245604630769, -108.63166809082, -1.89598028011848, 218, 38, 'PPL', 'P'),
(52286, 'Ulmstead Acres', 39.0613899230957, 0.681749864563355, -76.4819412231445, -1.33486169266065, 218, 25, 'PPL', 'P'),
(52287, 'Ulmstead Cove', 39.0561103820801, 0.681657719189638, -76.4819412231445, -1.33486169266065, 218, 25, 'PPL', 'P'),
(52288, 'Ulmstead Estates', 39.0513916015625, 0.681575360932927, -76.4683303833008, -1.33462413869142, 218, 25, 'PPL', 'P'),
(52289, 'Ulmstead Gardens', 39.0519409179688, 0.681584948312852, -76.4791717529297, -1.33481335628687, 218, 25, 'PPL', 'P'),
(52290, 'Ulmstead Point', 39.0588912963867, 0.681706255300505, -76.4805603027344, -1.33483759105279, 218, 25, 'PPL', 'P'),
(74590, 'Ulric', 38.9141693115234, 0.679180380164619, -81.8611068725586, -1.42874584425311, 218, 41, 'PPL', 'P'),
(168160, 'Ulster', 41.8458290100098, 0.73034749445123, -76.5022201538086, -1.33521562676952, 218, 45, 'PPL', 'P'),
(153253, 'Ulster Heights', 41.773609161377, 0.729087020307295, -74.4841690063477, -1.29999398977268, 218, 40, 'PPL', 'P'),
(153254, 'Ulster Landing', 41.9972190856934, 0.732989749726752, -73.9480590820313, -1.29063710644074, 218, 40, 'PPL', 'P'),
(153255, 'Ulster Park', 41.8558311462402, 0.730522064660684, -73.9775009155273, -1.29115096337307, 218, 40, 'PPL', 'P'),
(153257, 'Ulsterville', 41.6100006103516, 0.726231512407485, -74.3361129760742, -1.29740992456698, 218, 40, 'PPL', 'P'),
(77517, 'Ultima Thule', 34.0591697692871, 0.594444652969778, -94.4786071777344, -1.64896276794981, 218, 42, 'PPL', 'P'),
(185817, 'Ultra', 35.964168548584, 0.627693153914981, -118.997497558594, -2.07689813403137, 218, 6, 'PPL', 'P'),
(211114, 'Ulu Ko *', 21.9661102294922, 0.383380947360646, -159.371673583984, -2.7815604384542, 218, 15, 'PPL', 'P'),
(211115, 'Ulu Mahi', 21.9697208404541, 0.38344396440994, -159.373611450195, -2.78159426060004, 218, 15, 'PPL', 'P'),
(211116, 'Ulumalu', 20.9094390869141, 0.364938556811847, -156.286666870117, -2.72771691385109, 218, 15, 'PPL', 'P'),
(211119, 'Ulupalakua', 20.6499996185303, 0.360410483878926, -156.39306640625, -2.7295739360792, 218, 15, 'PPL', 'P'),
(38626, 'Ulvah', 37.1277809143066, 0.648002020913762, -83.0522232055664, -1.44953474603837, 218, 21, 'PPL', 'P'),
(43417, 'Ulyssee', 30.0180606842041, 0.523913994002823, -91.8763885498047, -1.60354548503571, 218, 22, 'PPL', 'P'),
(38625, 'Ulysses', 37.9458312988281, 0.662279693570867, -82.6736068725586, -1.44292664442556, 218, 21, 'PPL', 'P'),
(143235, 'Ulysses', 41.0719413757324, 0.71684060719262, -97.2016677856445, -1.6964891412892, 218, 35, 'PPL', 'P'),
(168162, 'Ulysses', 41.9038887023926, 0.731360827246005, -77.7622222900391, -1.35720681262891, 218, 45, 'PPL', 'P'),
(187940, 'Ulysses', 37.5813903808594, 0.655918999623322, -101.354721069336, -1.76897359510038, 218, 20, 'PPL', 'P'),
(195751, 'Ulysses (historical)', 45.4577789306641, 0.793387912983795, -114.15055847168, -1.99230308832112, 218, 17, 'PPL', 'P'),
(201696, 'Umapine', 45.9766693115234, 0.802444258586719, -118.495277404785, -2.06813273877754, 218, 43, 'PPL', 'P'),
(18403, 'Umatilla', 28.9291706085205, 0.504909276989854, -81.6658325195313, -1.42533766384808, 218, 12, 'PPL', 'P'),
(201697, 'Umatilla', 45.9174995422363, 0.801411551295013, -119.34139251709, -2.08290023333814, 218, 43, 'PPL', 'P'),
(192348, 'Umbarger', 34.9544410705566, 0.610070084875545, -102.105003356934, -1.78206849133835, 218, 51, 'PPL', 'P'),
(57979, 'Umber', 37.6247215270996, 0.656675270793877, -93.7552795410156, -1.6363383191184, 218, 29, 'PPL', 'P'),
(57980, 'Umber View Heights', 37.6236114501953, 0.656655896296947, -93.8033294677734, -1.63717694854567, 218, 29, 'PPL', 'P'),
(98677, 'Umberto Garcia Junior Colonia', 26.2080001831055, 0.457415893558467, -98.3639984130859, -1.71677563773483, 218, 51, 'PPL', 'P'),
(158028, 'Umbria (historical)', 40.4000015258789, 0.70511304443732, -82.1902770996094, -1.43449094851468, 218, 41, 'PPL', 'P'),
(212208, 'Umiat', 69.366943359375, 1.21068155366551, -152.144165039063, -2.65541661762929, 218, 1, 'PPL', 'P'),
(212209, 'Umkumiut', 60.4983291625977, 1.05589503584263, -165.198883056641, -2.88326442995545, 218, 1, 'PPL', 'P'),
(212210, 'Umnak', 53.2666702270508, 0.929678777036072, -168.216674804688, -2.93593483209839, 218, 1, 'PPL', 'P'),
(12445, 'Umpire', 34.2788887023926, 0.598279471781437, -94.0505599975586, -1.64149193530187, 218, 4, 'PPL', 'P'),
(57981, 'Umpire', 37.1797218322754, 0.648908560948825, -92.605827331543, -1.61627659346878, 218, 29, 'PPL', 'P'),
(201699, 'Umpqua', 43.3655586242676, 0.756871779960092, -123.467216491699, -2.15490944605279, 218, 43, 'PPL', 'P'),
(201700, 'Umpqua City (historical)', 43.7097206115723, 0.762878539798766, -124.163887023926, -2.16706864064177, 218, 43, 'PPL', 'P'),
(209001, 'Umtanum', 46.8650016784668, 0.817948583241915, -120.478607177734, -2.10274837346834, 218, 56, 'PPL', 'P'),
(62110, 'Una', 33.7969398498535, 0.589867877478422, -88.8069381713867, -1.54997346970573, 218, 30, 'PPL', 'P'),
(84115, 'Una', 34.2700004577637, 0.59812434264794, -80.1347198486328, -1.39861470652189, 218, 48, 'PPL', 'P'),
(91480, 'Una', 36.0972213745117, 0.630015363806503, -86.6547164916992, -1.51241011516238, 218, 50, 'PPL', 'P'),
(185818, 'Una', 35.4244384765625, 0.61827308708618, -119.176940917969, -2.08003001147331, 218, 6, 'PPL', 'P'),
(187472, 'Una', 39.3997192382813, 0.68765482506936, -108.108062744141, -1.88684164283787, 218, 7, 'PPL', 'P'),
(25636, 'Unadilla', 32.2613906860352, 0.563067488743546, -83.7366714477539, -1.46148062142403, 218, 13, 'PPL', 'P'),
(133472, 'Unadilla', 42.4286117553711, 0.740518972181596, -84.0566711425781, -1.46706566970409, 218, 27, 'PPL', 'P'),
(143237, 'Unadilla', 40.6833305358887, 0.710058068528406, -96.2694396972656, -1.68021869176742, 218, 35, 'PPL', 'P'),
(153259, 'Unadilla', 42.3252792358398, 0.738715479491395, -75.3127822875977, -1.31445601975625, 218, 40, 'PPL', 'P'),
(153260, 'Unadilla Center', 42.4041709899902, 0.740092400353993, -75.3091735839844, -1.31439303599647, 218, 40, 'PPL', 'P'),
(153261, 'Unadilla Forks', 42.8416709899902, 0.747728215831468, -75.2405624389648, -1.31319554561231, 218, 40, 'PPL', 'P'),
(69694, 'Unahala', 35.3547210693359, 0.617056288784123, -83.4100036621094, -1.45577919300434, 218, 33, 'PPL', 'P'),
(69695, 'Unaka', 35.1952781677246, 0.614273485182071, -84.1416702270508, -1.46854918358932, 218, 33, 'PPL', 'P'),
(91476, 'Unaka Springs', 36.0974998474121, 0.630020224075492, -82.4416732788086, -1.43887863956864, 218, 50, 'PPL', 'P'),
(91477, 'Unaka Station (historical)', 35.9436111450195, 0.62733435953712, -82.9000015258789, -1.44687797653491, 218, 50, 'PPL', 'P'),
(212211, 'Unalakleet', 63.8730583190918, 1.11479517098651, -160.788055419922, -2.80628096495675, 218, 1, 'PPL', 'P'),
(212212, 'Unalaska', 53.8736114501953, 0.940271899746025, -166.536666870117, -2.9066131621805, 218, 1, 'PPL', 'P'),
(79289, 'Unamis', 39.7427787780762, 0.693642343569158, -79.2855606079102, -1.38379408189755, 218, 45, 'PPL', 'P'),
(43418, 'Unatex', 30.4938907623291, 0.532218795546127, -92.5258331298828, -1.61488043126731, 218, 22, 'PPL', 'P'),
(870, 'Uncas', 36.7955589294434, 0.642203653430387, -96.929443359375, -1.69173792874645, 218, 42, 'PPL', 'P'),
(209002, 'Uncas', 47.9877815246582, 0.83754478833299, -122.88166809082, -2.14468969852767, 218, 56, 'PPL', 'P'),
(114197, 'Uncasville', 41.434440612793, 0.723167412415294, -72.1102828979492, -1.25856186111377, 218, 8, 'PPL', 'P'),
(98678, 'Uncertain', 32.7119407653809, 0.57093107107325, -94.1211090087891, -1.64272324783187, 218, 51, 'PPL', 'P'),
(69696, 'Uncle Jimmys Landing', 35.5994415283203, 0.621327466540392, -75.4702835083008, -1.31720493463343, 218, 33, 'PPL', 'P'),
(43419, 'Uncle Sam (historical)', 30.0375003814697, 0.524253280725699, -90.8263931274414, -1.5852196077846, 218, 22, 'PPL', 'P'),
(12447, 'Unco', 33.4836082458496, 0.584399209337999, -92.4211120605469, -1.61305270381118, 218, 4, 'PPL', 'P'),
(187473, 'Uncompahgre', 38.378059387207, 0.66982349683268, -107.818061828613, -1.88178017202812, 218, 7, 'PPL', 'P'),
(121760, 'Undercliff', 41.1877784729004, 0.718862345934154, -89.3661117553711, -1.55973288983643, 218, 18, 'PPL', 'P'),
(153279, 'Undercliff', 44.339168548584, 0.773864478769506, -73.9697189331055, -1.29101514215748, 218, 40, 'PPL', 'P'),
(168165, 'Undercliff', 40.5119400024414, 0.707066739413002, -79.9469375610352, -1.39533728732639, 218, 45, 'PPL', 'P'),
(146481, 'Undercliff Junction', 40.8286094665527, 0.712593664202271, -74.0244369506836, -1.29197015172438, 218, 37, 'PPL', 'P'),
(172660, 'Underhill', 44.5258293151855, 0.777122323731, -72.945556640625, -1.27314013807892, 218, 55, 'PPL', 'P'),
(176765, 'Underhill', 44.8752784729004, 0.783221362101445, -88.3844375610352, -1.54259944296341, 218, 57, 'PPL', 'P'),
(172661, 'Underhill Center', 44.5074996948242, 0.776802411505054, -72.9000015258789, -1.27234505133548, 218, 55, 'PPL', 'P'),
(195752, 'Underkoflers Corner', 43.6191711425781, 0.761298153428885, -116.671669006348, -2.03630476795779, 218, 17, 'PPL', 'P'),
(6444, 'Underwood', 34.8711090087891, 0.608615666025225, -87.7008285522461, -1.53066821496375, 218, 2, 'PPL', 'P'),
(25637, 'Underwood', 33.127498626709, 0.578183923985972, -83.1147232055664, -1.45062557682087, 218, 13, 'PPL', 'P'),
(31337, 'Underwood', 38.6036109924316, 0.673760114977008, -85.7744369506836, -1.49704633883371, 218, 19, 'PPL', 'P'),
(91479, 'Underwood', 35.9972190856934, 0.628269994607092, -83.6347198486328, -1.4597012303417, 218, 50, 'PPL', 'P'),
(118100, 'Underwood', 41.3869400024414, 0.722338370367953, -95.6763916015625, -1.66986804987472, 218, 16, 'PPL', 'P'),
(138524, 'Underwood', 46.2852783203125, 0.807830501891404, -95.8705596923828, -1.67325692236184, 218, 28, 'PPL', 'P'),
(153264, 'Underwood', 44.0877799987793, 0.7694769208736, -73.6766662597656, -1.28590040812593, 218, 40, 'PPL', 'P'),
(192349, 'Underwood', 33.9858283996582, 0.593164604591831, -101.843063354492, -1.77749677585307, 218, 51, 'PPL', 'P'),
(199028, 'Underwood', 47.4563903808594, 0.828270263257762, -101.136672973633, -1.76516793790266, 218, 34, 'PPL', 'P'),
(209003, 'Underwood', 45.7297210693359, 0.798134198678534, -121.525001525879, -2.12101140011772, 218, 56, 'PPL', 'P'),
(12448, 'Underwood (historical)', 35.6800003051758, 0.622733482437899, -91.3833312988281, -1.59494001260534, 218, 4, 'PPL', 'P'),
(52292, 'Underwood (historical)', 38.5069389343262, 0.672072869268388, -76.7513885498047, -1.33956443567157, 218, 25, 'PPL', 'P'),
(14774, 'Underwood Corner', 39.2444381713867, 0.684944659186041, -75.6805572509766, -1.32087490377361, 218, 10, 'PPL', 'P'),
(153265, 'Underwood Corner', 42.148609161377, 0.735632005002274, -78.9038925170898, -1.37713271706293, 218, 40, 'PPL', 'P'),
(18404, 'Underwood Crossing', 30.9744396209717, 0.54060595534614, -85.583610534668, -1.49371578957446, 218, 12, 'PPL', 'P'),
(209802, 'Underwood Crossing', 43.4961090087891, 0.759150314009736, -104.94416809082, -1.83162126395119, 218, 59, 'PPL', 'P'),
(6472, 'Underwood Crossroads', 34.7563896179199, 0.606613434938677, -87.529167175293, -1.52767215873741, 218, 2, 'PPL', 'P'),
(6446, 'Underwood Heights', 34.6263885498047, 0.604344488268956, -87.7444381713867, -1.53142934640329, 218, 2, 'PPL', 'P'),
(209005, 'Underwood Heights', 45.7358283996582, 0.798240791701165, -121.526107788086, -2.12103070803562, 218, 56, 'PPL', 'P'),
(185819, 'Underwood Park', 39.8600006103516, 0.695688250497584, -123.715827941895, -2.15924853441686, 218, 6, 'PPL', 'P'),
(91489, 'Underwood Springs (historical)', 36.4333305358887, 0.635881575318647, -82.1777801513672, -1.4342728356214, 218, 50, 'PPL', 'P'),
(25638, 'Undine', 32.2272186279297, 0.562471073817422, -81.9797210693359, -1.43081605252648, 218, 13, 'PPL', 'P'),
(111781, 'Uneeda', 38.0355606079102, 0.663845765449888, -81.7808303833008, -1.42734475520361, 218, 58, 'PPL', 'P'),
(153266, 'Uneeda Beach', 43.2947196960449, 0.755635407424022, -78.9208297729492, -1.37742832794393, 218, 40, 'PPL', 'P'),
(43420, 'Uneedus', 30.6172199249268, 0.534371295497183, -90.2611083984375, -1.57535352805224, 218, 22, 'PPL', 'P'),
(209004, 'Unfried (historical)', 46.4122200012207, 0.810046052181268, -117.363891601563, -2.04838633140099, 218, 56, 'PPL', 'P'),
(212213, 'Unga', 55.1827812194824, 0.96312122268766, -160.506393432617, -2.80136503590057, 218, 1, 'PPL', 'P'),
(212214, 'Ungalikthluk', 58.9352798461914, 1.0286146789003, -160.145278930664, -2.79506239886479, 218, 1, 'PPL', 'P'),
(77518, 'Unger', 34.0261116027832, 0.593867679119612, -95.7816696166992, -1.67170549786882, 218, 42, 'PPL', 'P'),
(111782, 'Unger', 39.4366683959961, 0.688299709527323, -78.2541732788086, -1.36579297714138, 218, 58, 'PPL', 'P'),
(43421, 'Uni (historical)', 32.7347183227539, 0.571328614444972, -93.8344421386719, -1.63771996709193, 218, 22, 'PPL', 'P'),
(91481, 'Unicoi', 36.1952781677246, 0.631726777702015, -82.3497161865234, -1.4372736855377, 218, 50, 'PPL', 'P'),
(52291, 'Unicorn', 39.2480583190918, 0.685007842682903, -75.8633270263672, -1.32406483812731, 218, 25, 'PPL', 'P'),
(79290, 'Unicorn', 39.836669921875, 0.695281053166911, -76.1522216796875, -1.32910700101915, 218, 45, 'PPL', 'P'),
(52293, 'Unicorn Crossing', 39.2511100769043, 0.685061105904705, -75.8550033569336, -1.32391956268984, 218, 25, 'PPL', 'P'),
(52294, 'Unicorn Manor', 39.2452812194824, 0.684959373151064, -75.8686065673828, -1.32415698350102, 218, 25, 'PPL', 'P'),
(6447, 'Uniform', 31.3491706848145, 0.547146246219698, -88.2344436645508, -1.53998155561186, 218, 2, 'PPL', 'P'),
(6457, 'Union', 32.6986083984375, 0.570698377373004, -85.8472213745117, -1.49831666667368, 218, 2, 'PPL', 'P'),
(12453, 'Union', 35.3027801513672, 0.61614974874906, -91.2680587768555, -1.59292812755984, 218, 4, 'PPL', 'P'),
(18405, 'Union', 30.8036098480225, 0.537624413347742, -86.0422210693359, -1.50172005338875, 218, 12, 'PPL', 'P'),
(25646, 'Union', 32.1563911437988, 0.561234901018435, -84.9036102294922, -1.48184754533458, 218, 13, 'PPL', 'P'),
(31339, 'Union', 38.4652786254883, 0.671345759711769, -87.4347229003906, -1.5260237951807, 218, 19, 'PPL', 'P'),
(38627, 'Union', 38.9458312988281, 0.67973298609081, -84.6805572509766, -1.4779545364531, 218, 21, 'PPL', 'P'),
(43422, 'Union', 30.0869407653809, 0.525116178208399, -90.9047164916992, -1.58658660837214, 218, 22, 'PPL', 'P'),
(62119, 'Union', 31.5022201538086, 0.549817463372074, -89.480827331543, -1.56173505434396, 218, 30, 'PPL', 'P'),
(69701, 'Union', 34.9813919067383, 0.61054046570308, -80.7236099243164, -1.40889277727489, 218, 33, 'PPL', 'P'),
(74591, 'Union', 39.8977813720703, 0.696347649183488, -84.3063888549805, -1.47142406598606, 218, 41, 'PPL', 'P'),
(77520, 'Union', 36.0736083984375, 0.629603239627813, -95.8644409179688, -1.67315012960213, 218, 42, 'PPL', 'P'),
(79292, 'Union', 39.8408317565918, 0.695353690885643, -76.0608291625977, -1.32751190068425, 218, 45, 'PPL', 'P'),
(84118, 'Union', 34.7152786254883, 0.605895912761982, -81.623893737793, -1.42460569402247, 218, 48, 'PPL', 'P'),
(91488, 'Union', 35.7127799987793, 0.623305596019075, -85.7011108398438, -1.49576655677188, 218, 50, 'PPL', 'P'),
(107047, 'Union', 36.8102798461914, 0.642460581896552, -80.4419403076172, -1.40397671506066, 218, 53, 'PPL', 'P'),
(111784, 'Union', 37.5913887023926, 0.656093503253749, -80.5438919067383, -1.405756106143, 218, 58, 'PPL', 'P'),
(112988, 'Union', 41.9908294677734, 0.732878229856105, -72.1577835083008, -1.25939090316111, 218, 8, 'PPL', 'P'),
(113105, 'Union', 44.2113914489746, 0.771634347672673, -69.2747192382813, -1.20907193910267, 218, 26, 'PPL', 'P'),
(118101, 'Union', 42.2455596923828, 0.737324110979883, -93.0644378662109, -1.62428085728307, 218, 16, 'PPL', 'P'),
(121764, 'Union', 41.496940612793, 0.724258243197791, -88.0233306884766, -1.53629693908568, 218, 18, 'PPL', 'P'),
(133474, 'Union', 41.7861099243164, 0.7293051997796, -85.8677825927734, -1.49867552763057, 218, 27, 'PPL', 'P'),
(138527, 'Union', 43.8919410705566, 0.766058886772538, -93.1252822875977, -1.62534279276774, 218, 28, 'PPL', 'P'),
(139491, 'Union', 40.3627815246582, 0.704463432868423, -91.7541732788086, -1.60141242616061, 218, 29, 'PPL', 'P'),
(140988, 'Union', 48.5577812194824, 0.847493159743036, -97.9486083984375, -1.7095257142993, 218, 34, 'PPL', 'P'),
(143238, 'Union', 40.8133316040039, 0.712327015198127, -95.9225006103516, -1.67416346239691, 218, 35, 'PPL', 'P'),
(144580, 'Union', 43.4913902282715, 0.759067955753026, -71.0236129760742, -1.23959589309466, 218, 36, 'PPL', 'P'),
(146483, 'Union', 40.6974983215332, 0.71030534303562, -74.2636108398438, -1.29614452357502, 218, 37, 'PPL', 'P'),
(153267, 'Union', 42.8677787780762, 0.748183882693981, -75.8874969482422, -1.32448668284398, 218, 40, 'PPL', 'P'),
(176770, 'Union', 42.8244400024414, 0.747427478365371, -89.3016662597656, -1.55860810375004, 218, 57, 'PPL', 'P'),
(185822, 'Union', 35.6375007629395, 0.621991725495285, -120.559997558594, -2.10416890359379, 218, 6, 'PPL', 'P'),
(190859, 'Union', 38.871940612793, 0.67844335033294, -117.59806060791, -2.05247335156788, 218, 39, 'PPL', 'P'),
(192352, 'Union', 33.0363883972168, 0.576593750499085, -102.221389770508, -1.78409981745981, 218, 51, 'PPL', 'P'),
(194459, 'Union', 40.3766708374023, 0.704705847106647, -103.500556945801, -1.80642549635211, 218, 7, 'PPL', 'P'),
(201701, 'Union', 45.208610534668, 0.78903910408175, -117.864166259766, -2.05711777135092, 218, 43, 'PPL', 'P'),
(206180, 'Union', 40.6205596923828, 0.708962510634975, -111.871391296387, -1.95252411690888, 218, 52, 'PPL', 'P'),
(209007, 'Union', 47.355281829834, 0.826505586140448, -123.099716186523, -2.14849535572539, 218, 56, 'PPL', 'P'),
(25647, 'Union (historical)', 31.166389465332, 0.543956112128919, -81.6430587768555, -1.42494018705538, 218, 13, 'PPL', 'P'),
(190860, 'Union (historical)', 38.8688888549805, 0.678390087111138, -117.609169006348, -2.05266722969523, 218, 39, 'PPL', 'P'),
(197739, 'Union (historical)', 47.1872215270996, 0.823572380515835, -105.30583190918, -1.83793348836689, 218, 31, 'PPL', 'P'),
(146484, 'Union Beach', 40.4463882446289, 0.705922645408704, -74.1786117553711, -1.2946610096898, 218, 37, 'PPL', 'P'),
(52305, 'Union Bridge', 39.5688896179199, 0.690607405190904, -77.1772232055664, -1.34699665248371, 218, 25, 'PPL', 'P'),
(118102, 'Union Burg (historical)', 41.5391693115234, 0.72499527302947, -95.6413879394531, -1.66925712072065, 218, 16, 'PPL', 'P'),
(28825, 'Union Center', 39.3327789306641, 0.686486496299142, -88.0813903808594, -1.53731027188046, 218, 18, 'PPL', 'P'),
(98684, 'Union Center', 32.1705589294434, 0.561482175525649, -98.9602813720703, -1.72718273864264, 218, 51, 'PPL', 'P'),
(118103, 'Union Center', 42.6925010681152, 0.745124709549807, -96.0580596923828, -1.67652941470933, 218, 16, 'PPL', 'P'),
(123841, 'Union Center', 41.4841690063477, 0.724035336614551, -86.6397171020508, -1.51214832642723, 218, 19, 'PPL', 'P'),
(153269, 'Union Center', 41.8511085510254, 0.730439639824946, -73.9974975585938, -1.29149997063393, 218, 40, 'PPL', 'P'),
(168166, 'Union Center', 41.6188888549805, 0.726386641540982, -76.9472198486328, -1.34298233661458, 218, 45, 'PPL', 'P'),
(176771, 'Union Center', 43.6852798461914, 0.762451967971162, -90.2666702270508, -1.57545060027397, 218, 57, 'PPL', 'P'),
(202705, 'Union Center', 44.5608291625977, 0.777733186306037, -102.668891906738, -1.79191020314674, 218, 49, 'PPL', 'P'),
(209008, 'Union Center', 46.7433280944824, 0.815824978588685, -117.330833435059, -2.04780935755082, 218, 56, 'PPL', 'P'),
(91490, 'Union Central', 35.9644393920898, 0.627697881025916, -88.7863922119141, -1.54961487506495, 218, 50, 'PPL', 'P'),
(6458, 'Union Chapel', 33.8166694641113, 0.590212224207369, -87.1777801513672, -1.52153929822112, 218, 2, 'PPL', 'P'),
(126383, 'Union Chapel', 42.1841697692871, 0.736252654694317, -72.0338897705078, -1.25722854951402, 218, 23, 'PPL', 'P'),
(6459, 'Union Church', 30.5652809143066, 0.533464788751634, -88.3438873291016, -1.54189170790372, 218, 2, 'PPL', 'P'),
(62117, 'Union Church', 31.6827793121338, 0.552968815179479, -90.7874984741211, -1.58454076802274, 218, 30, 'PPL', 'P'),
(176773, 'Union Church', 42.8436088562012, 0.747762037977312, -88.0691680908203, -1.53709695267714, 218, 57, 'PPL', 'P'),
(12457, 'Union City', 35.4877815246582, 0.619378631833699, -93.5477828979492, -1.63271681951006, 218, 4, 'PPL', 'P'),
(25648, 'Union City', 33.5869407653809, 0.5862027020282, -84.5425033569336, -1.47554504145685, 218, 13, 'PPL', 'P'),
(38629, 'Union City', 37.7972183227539, 0.659685907827184, -84.1977767944336, -1.46952842792214, 218, 21, 'PPL', 'P'),
(57983, 'Union City', 36.978889465332, 0.645403374901089, -93.4655609130859, -1.63128177515667, 218, 29, 'PPL', 'P'),
(77521, 'Union City', 35.3916702270508, 0.617701173242085, -97.9411087036133, -1.70939481993173, 218, 42, 'PPL', 'P'),
(91507, 'Union City', 36.4241714477539, 0.635721719074215, -89.0569381713867, -1.55433679283572, 218, 50, 'PPL', 'P'),
(111785, 'Union City', 37.4305610656738, 0.653286531464806, -81.7966690063477, -1.42762119132477, 218, 58, 'PPL', 'P'),
(114198, 'Union City', 41.4966697692871, 0.724253516086856, -73.0488891601563, -1.27494363076912, 218, 8, 'PPL', 'P'),
(123842, 'Union City', 40.2019386291504, 0.70165619476337, -84.8091735839844, -1.48019931493593, 218, 19, 'PPL', 'P'),
(133475, 'Union City', 42.0666694641113, 0.734201887496901, -85.1361083984375, -1.48590540388753, 218, 27, 'PPL', 'P'),
(146486, 'Union City', 40.7794418334961, 0.71173552712002, -74.024169921875, -1.29196549119247, 218, 37, 'PPL', 'P'),
(158029, 'Union City', 40.1994400024414, 0.70161258550052, -84.8052825927734, -1.48013140432813, 218, 41, 'PPL', 'P'),
(168167, 'Union City', 41.8994407653809, 0.731283196100229, -79.8455581665039, -1.39356788309814, 218, 45, 'PPL', 'P'),
(185824, 'Union City', 37.5958290100098, 0.656171001241471, -122.018058776855, -2.12961687254809, 218, 6, 'PPL', 'P'),
(52295, 'Union Corner', 39.0272216796875, 0.681153516216259, -75.8055572509766, -1.3230565653386, 218, 25, 'PPL', 'P'),
(111786, 'Union Corner', 39.398609161377, 0.68763545057243, -78.0858306884766, -1.36285484466875, 218, 58, 'PPL', 'P'),
(168169, 'Union Corner', 40.9000015258789, 0.713839690697292, -76.5777816772461, -1.33653442414133, 218, 45, 'PPL', 'P'),
(52296, 'Union Corners', 38.9002799987793, 0.678937965926394, -75.730827331543, -1.32175228219474, 218, 25, 'PPL', 'P'),
(153272, 'Union Corners', 42.728328704834, 0.745750019773757, -77.6730575561523, -1.35565059444592, 218, 40, 'PPL', 'P'),
(158030, 'Union Corners', 40.0791702270508, 0.699513481929319, -84.4902801513672, -1.47463357457377, 218, 41, 'PPL', 'P'),
(201703, 'Union Creek', 42.9072189331055, 0.748872243256739, -122.444442749023, -2.13705867674016, 218, 43, 'PPL', 'P'),
(69705, 'Union Cross', 36.1841697692871, 0.631532899574657, -80.5980606079102, -1.40670152832997, 218, 33, 'PPL', 'P'),
(91492, 'Union Cross', 35.7597198486328, 0.624124850949411, -88.454719543457, -1.5438260949615, 218, 50, 'PPL', 'P'),
(6460, 'Union Crossroads', 32.5708312988281, 0.568468246276172, -85.4116668701172, -1.4907148065001, 218, 2, 'PPL', 'P'),
(84123, 'Union Crossroads', 33.8013916015625, 0.589945575203225, -79.9866714477539, -1.39603077447425, 218, 48, 'PPL', 'P'),
(168171, 'Union Dale', 41.7166709899902, 0.728093261746532, -75.4925003051758, -1.31759269088814, 218, 45, 'PPL', 'P'),
(168173, 'Union Deposit', 40.2902793884277, 0.703198031876471, -76.6822204589844, -1.33835722474943, 218, 45, 'PPL', 'P'),
(129120, 'Union Falls', 43.5708312988281, 0.760454463995548, -70.5602798461914, -1.23150920444464, 218, 26, 'PPL', 'P'),
(153273, 'Union Falls', 44.5072212219238, 0.776797551236065, -73.9169387817383, -1.29009395473642, 218, 40, 'PPL', 'P'),
(74592, 'Union Furnace', 39.461669921875, 0.688736068471932, -82.3563919067383, -1.43739019883539, 218, 41, 'PPL', 'P'),
(168174, 'Union Furnace', 40.6127815246582, 0.708826755998408, -78.163330078125, -1.3642074641864, 218, 45, 'PPL', 'P'),
(201704, 'Union Gap', 43.4066696166992, 0.757589302136786, -123.312782287598, -2.15221406071352, 218, 43, 'PPL', 'P'),
(209009, 'Union Gap', 46.5574989318848, 0.812581647855132, -120.473892211914, -2.10266608179065, 218, 56, 'PPL', 'P'),
(98685, 'Union Grave', 31.440559387207, 0.548741279975573, -94.1500015258789, -1.64322751738427, 218, 51, 'PPL', 'P'),
(6465, 'Union Grove', 34.401668548584, 0.600422384352569, -86.4491729736328, -1.50882270401599, 218, 2, 'PPL', 'P'),
(69708, 'Union Grove', 36.2075004577637, 0.63194009690533, -80.6074981689453, -1.4068662448434, 218, 33, 'PPL', 'P'),
(71490, 'Union Grove', 39.6408309936523, 0.691863019065849, -75.2825012207031, -1.31392751543792, 218, 37, 'PPL', 'P'),
(91499, 'Union Grove', 35.9438896179199, 0.627339219806109, -83.5411071777344, -1.45806738101293, 218, 50, 'PPL', 'P'),
(98688, 'Union Grove', 32.5711097717285, 0.568473106545161, -94.920280456543, -1.6566714208831, 218, 51, 'PPL', 'P'),
(121765, 'Union Grove', 41.834171295166, 0.730144028943948, -90.0263900756836, -1.57125692050543, 218, 18, 'PPL', 'P'),
(168175, 'Union Grove', 40.1505584716797, 0.700759441845313, -76.0238876342773, -1.32686714938434, 218, 45, 'PPL', 'P'),
(176774, 'Union Grove', 42.688060760498, 0.745047211562085, -88.0513916015625, -1.53678669441015, 218, 57, 'PPL', 'P'),
(62120, 'Union Hall', 34.2244415283203, 0.59732918932547, -89.5427780151367, -1.56281629774653, 218, 30, 'PPL', 'P'),
(107048, 'Union Hall', 37.0186080932617, 0.646096595732837, -79.6866683959961, -1.39079473345504, 218, 53, 'PPL', 'P'),
(91500, 'Union Heights', 36.1827812194824, 0.631508664808737, -83.2486114501953, -1.45296236751936, 218, 50, 'PPL', 'P'),
(98689, 'Union High', 31.8437099456787, 0.555777584602158, -96.5967330932617, -1.68593103914758, 218, 51, 'PPL', 'P'),
(6471, 'Union Hill', 34.3333282470703, 0.59922962107935, -86.8008270263672, -1.51496022506419, 218, 2, 'PPL', 'P'),
(12462, 'Union Hill', 35.0602798461914, 0.611917319986651, -90.8161087036133, -1.58504011072713, 218, 4, 'PPL', 'P'),
(25653, 'Union Hill', 34.5022201538086, 0.602177340931904, -83.283332824707, -1.45356836982541, 218, 13, 'PPL', 'P'),
(43424, 'Union Hill', 31.940559387207, 0.557467926235545, -92.7388916015625, -1.61859900309738, 218, 22, 'PPL', 'P'),
(62121, 'Union Hill', 34.4863891601563, 0.601901037968809, -88.9519424438477, -1.55250427168963, 218, 30, 'PPL', 'P'),
(69711, 'Union Hill', 36.2402801513672, 0.632512210486506, -80.4816665649414, -1.40467006905046, 218, 33, 'PPL', 'P'),
(77523, 'Union Hill', 34.8227806091309, 0.60777217632897, -96.7655563354492, -1.68887756057765, 218, 42, 'PPL', 'P'),
(91506, 'Union Hill', 35.8894386291504, 0.626388870771114, -83.5500030517578, -1.45822264330448, 218, 50, 'PPL', 'P'),
(98695, 'Union Hill', 30.2027797698975, 0.527137950239446, -96.6133270263672, -1.68622065791613, 218, 51, 'PPL', 'P'),
(107051, 'Union Hill', 37.5377807617188, 0.655157868183777, -78.3294372558594, -1.36710658134906, 218, 53, 'PPL', 'P'),
(121767, 'Union Hill', 41.1074981689453, 0.717461190305636, -88.1466674804688, -1.53844957219479, 218, 18, 'PPL', 'P'),
(126384, 'Union Hill', 42.2513885498047, 0.737425843733524, -71.7916717529297, -1.25300104759963, 218, 23, 'PPL', 'P'),
(138529, 'Union Hill', 44.5436096191406, 0.777432648577021, -93.6669387817383, -1.6347964820053, 218, 28, 'PPL', 'P'),
(146489, 'Union Hill', 40.8672218322754, 0.713267577116115, -74.5224990844727, -1.30066297583851, 218, 37, 'PPL', 'P'),
(153274, 'Union Hill', 43.2227783203125, 0.754379793549077, -77.371940612793, -1.35039511235076, 218, 40, 'PPL', 'P'),
(168177, 'Union Hill', 41.7838897705078, 0.729266450785739, -75.6236114501953, -1.31988101205479, 218, 45, 'PPL', 'P'),
(185826, 'Union Hill', 39.5972213745117, 0.691101887626304, -121.002220153809, -2.111887143907, 218, 6, 'PPL', 'P'),
(189736, 'Union Hill', 32.8344383239746, 0.573069056796366, -108.078330993652, -1.88632272589947, 218, 38, 'PPL', 'P'),
(52297, 'Union Hills', 39.5999984741211, 0.691150357158144, -77.1502838134766, -1.34652647139325, 218, 25, 'PPL', 'P'),
(179416, 'Union Hills Manor', 33.6533317565918, 0.587361443418494, -112.135276794434, -1.95712978769806, 218, 5, 'PPL', 'P'),
(69712, 'Union Hope', 35.8424987792969, 0.625569615840779, -78.2197189331055, -1.36519163536724, 218, 33, 'PPL', 'P'),
(25654, 'Union Junction', 32.0499992370605, 0.559378011948377, -81.1266708374023, -1.41592751729434, 218, 13, 'PPL', 'P'),
(133476, 'Union Lake', 42.6147193908691, 0.743767163184139, -83.4469375610352, -1.45642381114619, 218, 27, 'PPL', 'P'),
(43425, 'Union Landing', 30.3211097717285, 0.529203198375289, -90.6944427490234, -1.58291663923196, 218, 22, 'PPL', 'P'),
(146490, 'Union Landing', 40.0219383239746, 0.698514596783458, -74.9966735839844, -1.30893888208398, 218, 37, 'PPL', 'P'),
(185827, 'Union Landing', 39.6994400024414, 0.692885939240548, -123.800559997559, -2.16072738777018, 218, 6, 'PPL', 'P'),
(107052, 'Union Level', 36.7161102294922, 0.64081701202981, -78.2352828979492, -1.36546327779842, 218, 53, 'PPL', 'P'),
(209010, 'Union Mill', 47.0327796936035, 0.820876862018511, -122.773330688477, -2.14279885415371, 218, 56, 'PPL', 'P'),
(38631, 'Union Mills', 37.8902816772461, 0.661310169776024, -84.5100021362305, -1.47497778814466, 218, 21, 'PPL', 'P'),
(52298, 'Union Mills', 39.6697196960449, 0.692367222039228, -77.0250015258789, -1.34433988298024, 218, 25, 'PPL', 'P'),
(69713, 'Union Mills', 35.4877815246582, 0.619378631833699, -81.9636077880859, -1.43053482271537, 218, 33, 'PPL', 'P'),
(71492, 'Union Mills', 39.8530616760254, 0.695567143247013, -74.9097213745117, -1.3074212797368, 218, 37, 'PPL', 'P'),
(107053, 'Union Mills', 37.9391708374023, 0.662163446589285, -78.3008270263672, -1.36660723864467, 218, 53, 'PPL', 'P'),
(111796, 'Union Mills', 39.3911094665527, 0.687504556204852, -81.1352767944336, -1.41607771957982, 218, 58, 'PPL', 'P'),
(118106, 'Union Mills', 41.4524993896484, 0.723482597530305, -92.570556640625, -1.61566100378281, 218, 16, 'PPL', 'P'),
(123843, 'Union Mills', 41.4930610656738, 0.724190532327075, -86.7774963378906, -1.51455302773351, 218, 19, 'PPL', 'P'),
(153275, 'Union Mills', 43.0897216796875, 0.752057517078528, -74.1338882446289, -1.29388043717429, 218, 40, 'PPL', 'P'),
(168178, 'Union Mills', 40.6058311462402, 0.708705449010755, -77.6997222900391, -1.35611598184641, 218, 45, 'PPL', 'P'),
(185828, 'Union Mills', 39.353889465332, 0.686854944635955, -120.106109619141, -2.09624706461524, 218, 6, 'PPL', 'P'),
(201705, 'Union Mills', 45.1997184753418, 0.788883908369226, -122.557502746582, -2.13903194594985, 218, 43, 'PPL', 'P'),
(18407, 'Union Park', 28.5677795410156, 0.498601812974597, -81.2863922119141, -1.41871518116538, 218, 12, 'PPL', 'P'),
(133477, 'Union Pier', 41.8280601501465, 0.73003736934229, -86.692497253418, -1.51306951384828, 218, 27, 'PPL', 'P'),
(133478, 'Union Plains', 42.829719543457, 0.747519623739088, -84.0127792358398, -1.46629961141653, 218, 27, 'PPL', 'P'),
(206181, 'Union Plat', 40.6197204589844, 0.70894786324898, -111.859718322754, -1.95232038508548, 218, 52, 'PPL', 'P'),
(25656, 'Union Point', 34.7663917541504, 0.606788005148131, -84.9266662597656, -1.48224994897529, 218, 13, 'PPL', 'P'),
(28830, 'Union Point', 37.5491714477539, 0.655356673159152, -89.5038909912109, -1.56213759114272, 218, 18, 'PPL', 'P'),
(43427, 'Union Point', 31.2205600738525, 0.544901567605411, -91.6255569458008, -1.59916764767778, 218, 22, 'PPL', 'P'),
(57984, 'Union Point', 38.9505615234375, 0.679815544084603, -94.4658279418945, -1.64873972820852, 218, 29, 'PPL', 'P'),
(69714, 'Union Point', 34.7994384765625, 0.607364779261215, -76.8536071777344, -1.34134848728581, 218, 33, 'PPL', 'P'),
(201706, 'Union Point (historical)', 44.3486099243164, 0.774029261861955, -122.984443664551, -2.14648347067989, 218, 43, 'PPL', 'P'),
(38632, 'Union Ridge', 37.1369400024414, 0.648161877158194, -87.0019378662109, -1.51847027138091, 218, 21, 'PPL', 'P'),
(69716, 'Union Ridge', 36.0516700744629, 0.629220343642087, -80.2252807617188, -1.40019529262886, 218, 33, 'PPL', 'P'),
(91508, 'Union Ridge', 35.5102806091309, 0.619771314936431, -86.2647171020508, -1.50560334173225, 218, 50, 'PPL', 'P'),
(158032, 'Union Ridge', 40.7744407653809, 0.711648242015293, -80.5758285522461, -1.40631350575915, 218, 41, 'PPL', 'P'),
(153276, 'Union Settlement', 43.3202781677246, 0.756081486906611, -76.0436096191406, -1.32721136295524, 218, 40, 'PPL', 'P'),
(6474, 'Union Springs', 32.1441688537598, 0.56102158181512, -85.7149963378906, -1.49600890443107, 218, 2, 'PPL', 'P'),
(43428, 'Union Springs', 31.8302803039551, 0.555543193136718, -93.7897186279297, -1.63693939457643, 218, 22, 'PPL', 'P'),
(107054, 'Union Springs', 38.4688911437988, 0.671408810050577, -79.0563888549805, -1.37979428025636, 218, 53, 'PPL', 'P'),
(153277, 'Union Springs', 42.8397216796875, 0.747694193948542, -76.6936111450195, -1.33855602972481, 218, 40, 'PPL', 'P'),
(146491, 'Union Square', 40.6586112976074, 0.709626636431814, -74.2027816772461, -1.29508285440646, 218, 37, 'PPL', 'P'),
(168179, 'Union Square', 40.1824989318848, 0.701316908040494, -76.4641723632813, -1.33455156755171, 218, 45, 'PPL', 'P'),
(38633, 'Union Star', 37.9383316040039, 0.66214879920329, -86.4516677856445, -1.50886624669981, 218, 21, 'PPL', 'P'),
(57985, 'Union Star', 39.9805603027344, 0.697792414074856, -94.5941696166992, -1.65097971300138, 218, 29, 'PPL', 'P'),
(158033, 'Union Station', 40.0213890075684, 0.698505009403534, -82.5127792358398, -1.44011967263662, 218, 41, 'PPL', 'P'),
(91509, 'Union Temple', 36.2980613708496, 0.633520683012292, -82.7355575561523, -1.44400788782813, 218, 50, 'PPL', 'P'),
(69717, 'Union Terrace', 35.6394386291504, 0.622025547641129, -80.3894424438477, -1.40306045448762, 218, 33, 'PPL', 'P'),
(28831, 'Union Town', 38.5188903808594, 0.672281461360769, -88.7502822875977, -1.54898463799298, 218, 18, 'PPL', 'P'),
(12463, 'Union Valley', 34.764720916748, 0.606758843534195, -92.0033264160156, -1.60576096874655, 218, 4, 'PPL', 'P'),
(52299, 'Union Valley', 39.6463890075684, 0.691960024708555, -75.9097213745117, -1.32487457225675, 218, 25, 'PPL', 'P'),
(77524, 'Union Valley', 34.6941719055176, 0.605527531004197, -96.5824966430664, -1.68568256621788, 218, 42, 'PPL', 'P'),
(91510, 'Union Valley', 35.9205589294434, 0.626932022475436, -83.710563659668, -1.46102495456152, 218, 50, 'PPL', 'P'),
(98697, 'Union Valley', 32.6972198486328, 0.570674142607084, -96.3002777099609, -1.68075691662372, 218, 51, 'PPL', 'P'),
(146492, 'Union Valley', 40.3036117553711, 0.703430725576717, -74.4563903808594, -1.29950916129623, 218, 37, 'PPL', 'P'),
(153281, 'Union Valley', 42.3241691589355, 0.738696104994464, -75.5422210693359, -1.31846048192934, 218, 40, 'PPL', 'P'),
(168180, 'Union Valley', 40.9366683959961, 0.714479648307238, -80.3422164916992, -1.40223620613024, 218, 45, 'PPL', 'P'),
(206183, 'Union View', 40.6177787780762, 0.708913974524108, -111.846672058105, -1.95209268481228, 218, 52, 'PPL', 'P'),
(146500, 'Union Village', 40.6666717529297, 0.709767317916397, -74.4558334350586, -1.29949944075825, 218, 37, 'PPL', 'P'),
(169640, 'Union Village', 41.9911117553711, 0.732883156704121, -71.5397186279297, -1.24860363600769, 218, 47, 'PPL', 'P'),
(172663, 'Union Village', 43.7886085510254, 0.764255394082336, -72.2558288574219, -1.26110211731954, 218, 55, 'PPL', 'P'),
(168181, 'Union Water Works', 40.3658294677734, 0.704516629511197, -76.5244369506836, -1.33560338302424, 218, 45, 'PPL', 'P'),
(144579, 'Union Wharf', 43.6519393920898, 0.76187006727298, -71.2827835083008, -1.24411927220616, 218, 36, 'PPL', 'P'),
(146496, 'Unionburg', 40.7052803039551, 0.710441164251214, -74.2816696166992, -1.29645970869004, 218, 37, 'PPL', 'P'),
(123867, 'Uniondale', 40.8305587768555, 0.712627686085197, -85.2416687011719, -1.48774777872965, 218, 19, 'PPL', 'P'),
(153283, 'Uniondale', 40.7002792358398, 0.710353879146487, -73.5933303833008, -1.28444592269658, 218, 40, 'PPL', 'P'),
(123868, 'Unionport', 40.1208305358887, 0.700240591485938, -85.0963897705078, -1.48521218305578, 218, 19, 'PPL', 'P'),
(153284, 'Unionport', 40.827220916748, 0.712569429436351, -73.8505630493164, -1.28893547966223, 218, 40, 'PPL', 'P'),
(158046, 'Unionport', 40.3580589294434, 0.704381008032685, -80.845832824707, -1.41102596930805, 218, 41, 'PPL', 'P'),
(6475, 'Uniontown', 32.4494400024414, 0.566349568470959, -87.5141677856445, -1.52741037000225, 218, 2, 'PPL', 'P'),
(12488, 'Uniontown', 35.5844383239746, 0.62106561122621, -94.4438934326172, -1.64835689880182, 218, 4, 'PPL', 'P'),
(31353, 'Uniontown', 38.2252807617188, 0.667157006791238, -86.6608276367188, -1.51251677476404, 218, 19, 'PPL', 'P'),
(34226, 'Uniontown', 37.8472213745117, 0.660558625716403, -94.9749984741211, -1.65762643045, 218, 20, 'PPL', 'P'),
(38634, 'Uniontown', 37.7752799987793, 0.659303011841458, -87.9305572509766, -1.53467773714292, 218, 21, 'PPL', 'P'),
(52300, 'Uniontown', 39.5933303833008, 0.691033977018507, -77.1163864135742, -1.34593485015709, 218, 25, 'PPL', 'P'),
(58010, 'Uniontown', 37.6147193908691, 0.656500700584422, -89.7138900756836, -1.56580276659294, 218, 29, 'PPL', 'P'),
(107055, 'Uniontown', 38.8208312988281, 0.677551324525817, -77.4519424438477, -1.35179140771029, 218, 53, 'PPL', 'P'),
(111797, 'Uniontown', 39.6336097717285, 0.691736984967261, -80.5583267211914, -1.40600804118212, 218, 58, 'PPL', 'P'),
(121770, 'Uniontown', 40.747501373291, 0.711178060924839, -90.0986099243164, -1.57251739464936, 218, 18, 'PPL', 'P'),
(146497, 'Uniontown', 40.7205581665039, 0.710707813255358, -75.1408309936523, -1.31145490352384, 218, 37, 'PPL', 'P'),
(158048, 'Uniontown', 40.9749984741211, 0.715148634373066, -81.408332824707, -1.42084344635051, 218, 41, 'PPL', 'P'),
(168202, 'Uniontown', 40.0652809143066, 0.699271067691095, -77.0558319091797, -1.34487797467849, 218, 45, 'PPL', 'P'),
(201707, 'Uniontown', 46.1861114501953, 0.806099713498961, -123.852783203125, -2.16163885465326, 218, 43, 'PPL', 'P'),
(209011, 'Uniontown', 46.5394401550293, 0.812266462740121, -117.086669921875, -2.04354790033253, 218, 56, 'PPL', 'P'),
(62122, 'Uniontown (historical)', 31.7583293914795, 0.554287412814204, -91.1727828979492, -1.59126524977519, 218, 30, 'PPL', 'P'),
(158049, 'Unionvale', 40.2722206115723, 0.70288284676146, -80.9272232055664, -1.41244649943349, 218, 41, 'PPL', 'P'),
(201708, 'Unionvale', 45.1433296203613, 0.787899737188387, -123.059440612793, -2.14779241435567, 218, 43, 'PPL', 'P'),
(25659, 'Unionville', 31.4347190856934, 0.548639347484851, -83.5097198486328, -1.4575195687767, 218, 13, 'PPL', 'P'),
(31354, 'Unionville', 39.2299995422363, 0.684692657567892, -86.4161071777344, -1.50824559700777, 218, 19, 'PPL', 'P'),
(43429, 'Unionville', 32.6691703796387, 0.570184587019701, -92.6413879394531, -1.61689724316082, 218, 22, 'PPL', 'P'),
(52303, 'Unionville', 38.0605583190918, 0.66428205781547, -75.5994415283203, -1.31945916733812, 218, 25, 'PPL', 'P'),
(69723, 'Unionville', 35.0872192382813, 0.612387501077105, -80.5091705322266, -1.40515010383695, 218, 33, 'PPL', 'P'),
(91512, 'Unionville', 35.9516716003418, 0.627475041021703, -89.4361114501953, -1.56095461498651, 218, 50, 'PPL', 'P'),
(107056, 'Unionville', 38.2597198486328, 0.667758082249269, -77.9686126708984, -1.36080900431935, 218, 53, 'PPL', 'P'),
(114200, 'Unionville', 41.7577781677246, 0.728810717344199, -72.8866729736328, -1.27211242421426, 218, 8, 'PPL', 'P'),
(118150, 'Unionville', 40.8183288574219, 0.712414233723827, -92.6952819824219, -1.61783787165784, 218, 16, 'PPL', 'P'),
(121772, 'Unionville', 41.8191719055176, 0.729882240208793, -89.9824981689453, -1.57049086221786, 218, 18, 'PPL', 'P'),
(126386, 'Unionville', 42.3583297729492, 0.739292320183506, -71.8388900756836, -1.25382516279896, 218, 23, 'PPL', 'P'),
(129122, 'Unionville', 44.5788917541504, 0.778048438000075, -67.9908294677734, -1.18666383537463, 218, 26, 'PPL', 'P'),
(133482, 'Unionville', 43.6536102294922, 0.761899228886916, -83.4661102294922, -1.45675843733716, 218, 27, 'PPL', 'P'),
(139501, 'Unionville', 40.4769401550293, 0.706455876837965, -93.003059387207, -1.62320960073458, 218, 29, 'PPL', 'P'),
(146499, 'Unionville', 40.4286117553711, 0.70561238714171, -74.8399963378906, -1.30620434827669, 218, 37, 'PPL', 'P'),
(153290, 'Unionville', 41.8569412231445, 0.730541439157615, -74.563606262207, -1.30138043143618, 218, 40, 'PPL', 'P'),
(158052, 'Unionville', 41.7802810668945, 0.729203467025959, -81.003059387207, -1.41377009049526, 218, 41, 'PPL', 'P'),
(168209, 'Unionville', 40.2983283996582, 0.703338513623973, -75.283332824707, -1.31394202966586, 218, 45, 'PPL', 'P'),
(197740, 'Unionville', 46.541389465332, 0.812300484623047, -112.084167480469, -1.95623776189094, 218, 31, 'PPL', 'P'),
(200253, 'Unionville', 40.4455604553223, 0.70590819775979, -118.119720458984, -2.06157803354459, 218, 39, 'PPL', 'P'),
(12489, 'Unionville (historical)', 33.975830078125, 0.592990100961403, -92.1986083984375, -1.60916928230963, 218, 4, 'PPL', 'P'),
(185829, 'Unionville (historical)', 39.4730606079102, 0.688934873447307, -120.85221862793, -2.1092691233974, 218, 6, 'PPL', 'P'),
(158053, 'Unionville Center', 40.1383285522461, 0.700545989483943, -83.3399963378906, -1.45455733469621, 218, 41, 'PPL', 'P'),
(52304, 'Unionville Heights', 38.0625, 0.664315946540342, -75.5966720581055, -1.31941083096434, 218, 25, 'PPL', 'P'),
(206184, 'Unionwood Place', 40.610279083252, 0.708783080156531, -111.878326416016, -1.95264515758042, 218, 52, 'PPL', 'P'),
(158054, 'Uniopolis', 40.6022186279297, 0.708642398671948, -84.086669921875, -1.4675892471744, 218, 41, 'PPL', 'P'),
(118151, 'Unique', 42.7172203063965, 0.7455561416464, -94.3450012207031, -1.64663090409934, 218, 16, 'PPL', 'P'),
(107057, 'Unison', 39.0349998474121, 0.681289270852825, -77.7908325195313, -1.3577061553333, 218, 53, 'PPL', 'P'),
(43430, 'United', 29.7797203063965, 0.519754169669633, -91.7461090087891, -1.601271678097, 218, 22, 'PPL', 'P'),
(111798, 'United', 37.9905586242676, 0.663060332665397, -81.4266662597656, -1.42116342515549, 218, 58, 'PPL', 'P'),
(168211, 'United', 40.2183303833008, 0.701942284843472, -79.4880599975586, -1.38732836298019, 218, 45, 'PPL', 'P'),
(69724, 'United Industrial Park', 35.6494407653809, 0.622200117850583, -77.3516693115234, -1.35004131139994, 218, 33, 'PPL', 'P'),
(91513, 'Unitia', 35.7466697692871, 0.623897084097182, -84.1797180175781, -1.46921324280713, 218, 50, 'PPL', 'P'),
(6476, 'Unity', 33.0052795410156, 0.576050798531845, -86.3591690063477, -1.50725183844701, 218, 2, 'PPL', 'P'),
(12492, 'Unity', 33.9077796936035, 0.591802397694255, -93.8472213745117, -1.63794300683323, 218, 4, 'PPL', 'P'),
(25661, 'Unity', 33.392219543457, 0.582804175582123, -85.1833267211914, -1.48672951908686, 218, 13, 'PPL', 'P'),
(28835, 'Unity', 37.1497192382813, 0.648384916899488, -89.2727813720703, -1.55810396735569, 218, 18, 'PPL', 'P'),
(52306, 'Unity', 39.2261085510254, 0.684624746960095, -77.0697174072266, -1.34512032233769, 218, 25, 'PPL', 'P'),
(84122, 'Unity', 34.7975006103516, 0.607330957115371, -80.6991729736328, -1.40846627202632, 218, 48, 'PPL', 'P'),
(91515, 'Unity', 36.4786109924316, 0.636671868372128, -85.3252792358398, -1.48920705784896, 218, 50, 'PPL', 'P'),
(98699, 'Unity', 29.1972198486328, 0.509587618787283, -98.0536117553711, -1.71135836860344, 218, 51, 'PPL', 'P'),
(107058, 'Unity', 36.8125, 0.642499330890413, -76.8899993896484, -1.3419836512058, 218, 53, 'PPL', 'P'),
(112903, 'Unity', 34.3899993896484, 0.600218719108206, -88.5688934326172, -1.54581880524715, 218, 30, 'PPL', 'P'),
(129123, 'Unity', 44.6111106872559, 0.778610764464245, -69.3349990844727, -1.2101240208913, 218, 26, 'PPL', 'P'),
(139502, 'Unity', 40.3911094665527, 0.704957848724796, -92.2555618286133, -1.6101633071865, 218, 29, 'PPL', 'P'),
(144581, 'Unity', 43.2938919067383, 0.755620959775109, -72.2608337402344, -1.2611894690033, 218, 36, 'PPL', 'P'),
(158055, 'Unity', 40.8647193908691, 0.713223901274238, -80.5597229003906, -1.40603240910609, 218, 41, 'PPL', 'P'),
(168212, 'Unity', 40.4922218322754, 0.706722592421137, -79.7797164916992, -1.39241872908777, 218, 45, 'PPL', 'P'),
(176782, 'Unity', 44.8516693115234, 0.782809304501782, -90.3163909912109, -1.57631839131518, 218, 57, 'PPL', 'P'),
(191024, 'Unity', 36.7619400024414, 0.641616892463215, -101.70832824707, -1.77514520461053, 218, 42, 'PPL', 'P'),
(195753, 'Unity', 42.5186080932617, 0.742089704592525, -113.742500305176, -1.98518112977597, 218, 17, 'PPL', 'P'),
(201710, 'Unity', 43.9472198486328, 0.767023683456447, -122.766670227051, -2.14268260717213, 218, 43, 'PPL', 'P'),
(783, 'Unity (historical)', 35.7597198486328, 0.624124850949411, -80.6463928222656, -1.40754508460526, 218, 33, 'PPL', 'P'),
(62123, 'Unity (historical)', 33.1708297729492, 0.578940195156527, -89.7305603027344, -1.56609371694203, 218, 30, 'PPL', 'P'),
(25662, 'Unity Grove', 33.3761100769043, 0.582523012350038, -84.0708312988281, -1.46731281105325, 218, 13, 'PPL', 'P'),
(168213, 'Unity Junction', 40.4980583190918, 0.706824458332832, -79.7861099243164, -1.39253031553745, 218, 45, 'PPL', 'P'),
(58011, 'Unity Village', 38.9513893127441, 0.679829991733517, -94.4013900756836, -1.64761507528018, 218, 29, 'PPL', 'P'),
(168215, 'Unityville', 41.2330589294434, 0.719652638987635, -76.51611328125, -1.33545810758677, 218, 45, 'PPL', 'P'),
(171475, 'Unityville', 43.8013916015625, 0.764478500402658, -97.4522171020508, -1.70086205179911, 218, 49, 'PPL', 'P'),
(31355, 'Universal', 39.6216697692871, 0.691528592611962, -87.4513931274414, -1.52631474552979, 218, 19, 'PPL', 'P'),
(168216, 'Universal', 40.4730606079102, 0.70638816596725, -79.7969436645508, -1.39271939997484, 218, 45, 'PPL', 'P'),
(98700, 'Universal City', 29.547779083252, 0.515706031654658, -98.2908325195313, -1.71549865199213, 218, 51, 'PPL', 'P'),
(185830, 'Universal City', 34.1388893127441, 0.595836021481289, -118.352500915527, -2.06564081894556, 218, 6, 'PPL', 'P'),
(98701, 'Universal Estates Colonia', 26.1270008087158, 0.456002187783312, -98.193000793457, -1.71379116625923, 218, 51, 'PPL', 'P'),
(28837, 'University', 37.9363899230957, 0.662114910478418, -88.6094436645508, -1.54652654030684, 218, 18, 'PPL', 'P'),
(69726, 'University', 36.0372200012207, 0.628968142286856, -79.0358276367188, -1.37943541929947, 218, 33, 'PPL', 'P'),
(209012, 'University', 47.6666717529297, 0.831940365556, -122.308609008789, -2.13468793073777, 218, 56, 'PPL', 'P'),
(107059, 'University Center', 39.0569381713867, 0.681672166838552, -77.4444427490234, -1.35166051334271, 218, 53, 'PPL', 'P'),
(58013, 'University City', 38.6666717529297, 0.67486073287651, -90.3208312988281, -1.5763958893029, 218, 29, 'PPL', 'P'),
(185831, 'University City', 32.8547210693359, 0.573423057484264, -117.203056335449, -2.04557922645399, 218, 6, 'PPL', 'P'),
(25663, 'University Estates', 33.5894393920898, 0.58624631129105, -84.3333282470703, -1.47189424707651, 218, 13, 'PPL', 'P'),
(69728, 'University Estates', 36.3997192382813, 0.63529494750953, -79.7058334350586, -1.39112922648795, 218, 33, 'PPL', 'P'),
(84124, 'University Forest', 33.8097190856934, 0.590090917219716, -79.0088882446289, -1.37896523820902, 218, 48, 'PPL', 'P'),
(153291, 'University Gardens', 40.7772216796875, 0.711696778126159, -73.7230606079102, -1.28671014225536, 218, 40, 'PPL', 'P'),
(13238, 'University Heights', 38.9397201538086, 0.679626326489153, -76.9938888549805, -1.34379686443398, 218, 9, 'PPL', 'P'),
(25664, 'University Heights', 33.9241714477539, 0.592088487774357, -83.352783203125, -1.45478050759556, 218, 13, 'PPL', 'P'),
(31356, 'University Heights', 39.704719543457, 0.692978084614265, -86.1344375610352, -1.50332953479354, 218, 19, 'PPL', 'P'),
(107060, 'University Heights', 38.040828704834, 0.663937711086523, -78.5224990844727, -1.37047614591828, 218, 53, 'PPL', 'P'),
(118153, 'University Heights', 41.6549987792969, 0.727016878612949, -91.5566711425781, -1.59796536360367, 218, 16, 'PPL', 'P'),
(153292, 'University Heights', 40.8600006103516, 0.713141543017527, -73.9097213745117, -1.28996798721686, 218, 40, 'PPL', 'P'),
(158057, 'University Heights', 41.4977798461914, 0.724272890583786, -81.5374984741211, -1.42309781221327, 218, 41, 'PPL', 'P'),
(168217, 'University Heights', 40.5961112976074, 0.708535805649317, -75.3899993896484, -1.31580371242588, 218, 45, 'PPL', 'P'),
(185833, 'University Heights', 32.7555618286133, 0.571692402249876, -117.138610839844, -2.04445444036759, 218, 6, 'PPL', 'P'),
(197741, 'University Heights', 46.0336112976074, 0.803438083726509, -114.214721679688, -1.9934229475595, 218, 31, 'PPL', 'P'),
(126387, 'University Highlands', 41.6241683959961, 0.726478786914699, -71.0013885498047, -1.23920800368189, 218, 23, 'PPL', 'P'),
(179417, 'University Mobile Home Park', 33.4169387817383, 0.583235607678716, -111.922782897949, -1.95342106956401, 218, 5, 'PPL', 'P'),
(18410, 'University Park', 26.3938903808594, 0.460660289556456, -80.1308288574219, -1.3985467959141, 218, 12, 'PPL', 'P'),
(52308, 'University Park', 38.9702796936035, 0.680159691076468, -76.9422225952148, -1.34289511808888, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(84126, 'University Park', 32.9194412231445, 0.574552637260621, -80.0952835083008, -1.39792641253816, 218, 48, 'PPL', 'P'),
(98702, 'University Park', 32.8499984741211, 0.573340632648526, -96.8000030517578, -1.68947876919373, 218, 51, 'PPL', 'P'),
(118154, 'University Park', 41.2869415283203, 0.720593067747569, -92.6183319091797, -1.61649483952011, 218, 16, 'PPL', 'P'),
(121773, 'University Park', 41.5922203063965, 0.725921187561463, -87.6852798461914, -1.53039683884867, 218, 18, 'PPL', 'P'),
(126388, 'University Park', 42.25, 0.737401608967604, -71.8166732788086, -1.25343740654424, 218, 23, 'PPL', 'P'),
(168218, 'University Park', 40.8019409179688, 0.712128210222752, -77.8566665649414, -1.35885517618561, 218, 45, 'PPL', 'P'),
(189737, 'University Park', 32.2833290100098, 0.563450384729272, -106.752777099609, -1.86318744603579, 218, 38, 'PPL', 'P'),
(201711, 'University Park', 45.5763893127441, 0.795458054678141, -122.727500915527, -2.14199897372031, 218, 43, 'PPL', 'P'),
(138531, 'University Park of Mankato', 44.1416702270508, 0.770417482791589, -93.9861068725586, -1.64036701605742, 218, 28, 'PPL', 'P'),
(43437, 'University Place', 30.5166702270508, 0.532616372207362, -90.4744415283203, -1.57907689357228, 218, 22, 'PPL', 'P'),
(69732, 'University Place', 35.3102798461914, 0.616280643116637, -80.7644424438477, -1.4096054391826, 218, 33, 'PPL', 'P'),
(143253, 'University Place', 40.8408317565918, 0.712806983405586, -96.6549987792969, -1.68694796720983, 218, 35, 'PPL', 'P'),
(209013, 'University Place', 47.2358283996582, 0.82442073048108, -122.549171447754, -2.13888653735433, 218, 56, 'PPL', 'P'),
(43439, 'University Shadows', 30.3661098480225, 0.529988597870267, -91.147216796875, -1.59081903713455, 218, 22, 'PPL', 'P'),
(121774, 'University Village', 40.4647216796875, 0.706242624213677, -90.6791687011719, -1.58265005680684, 218, 18, 'PPL', 'P'),
(185834, 'University Village', 34.0658302307129, 0.59456089995136, -117.161109924316, -2.04484712347033, 218, 6, 'PPL', 'P'),
(206191, 'University Village', 40.7527809143066, 0.711270206298556, -111.833892822266, -1.95186964507099, 218, 52, 'PPL', 'P'),
(25665, 'Univeter', 34.1961097717285, 0.596834706890069, -84.5005569458008, -1.47481293847319, 218, 13, 'PPL', 'P'),
(12493, 'Uno', 35.648609161377, 0.622185603622642, -91.0274963378906, -1.58872952094327, 218, 4, 'PPL', 'P'),
(38635, 'Uno', 37.1891708374023, 0.649073477199328, -85.8244400024414, -1.49791905672293, 218, 21, 'PPL', 'P'),
(107063, 'Uno', 38.2588882446289, 0.667743568021328, -78.2311096191406, -1.36539044034261, 218, 53, 'PPL', 'P'),
(111799, 'Uno', 37.6286087036133, 0.656743114822647, -81.7372207641602, -1.42658362376407, 218, 58, 'PPL', 'P'),
(158059, 'Uno', 40.3444404602051, 0.704143320905395, -84.2655563354492, -1.47071140407836, 218, 41, 'PPL', 'P'),
(168219, 'Uno', 40.103328704834, 0.699935126908906, -76.9836120605469, -1.34361750053456, 218, 45, 'PPL', 'P'),
(111800, 'Unus', 37.9408302307129, 0.66219240846614, -80.4444427490234, -1.40402039090254, 218, 58, 'PPL', 'P'),
(18411, 'Up the Grove Beach', 27.1758308410645, 0.474307725141595, -80.7266693115234, -1.40894617365475, 218, 12, 'PPL', 'P'),
(206192, 'Upalco', 40.2780609130859, 0.702984779252183, -110.217498779297, -1.92365824701156, 218, 52, 'PPL', 'P'),
(58014, 'Upalika', 36.9366683959961, 0.644666478227465, -90.6391677856445, -1.58195190912708, 218, 29, 'PPL', 'P'),
(25666, 'Upatoi', 32.5486106872559, 0.568080423442429, -84.7399978637695, -1.47899197085574, 218, 13, 'PPL', 'P'),
(38636, 'Upchurch', 36.7463912963867, 0.641345516348136, -85.1108322143555, -1.48546425125296, 218, 21, 'PPL', 'P'),
(69733, 'Upchurch', 35.7891693115234, 0.624638841039796, -78.857780456543, -1.37632790978151, 218, 33, 'PPL', 'P'),
(91516, 'Upchurch', 36.2422218322754, 0.632546099211378, -82.7738876342773, -1.44467687389396, 218, 50, 'PPL', 'P'),
(597, 'Upco', 32.7644386291504, 0.571847331646292, -92.1355590820313, -1.60806886414721, 218, 22, 'PPL', 'P'),
(14775, 'Upcounty Mobile Home Park', 38.6213912963867, 0.674070439823029, -75.64111328125, -1.32018647663182, 218, 10, 'PPL', 'P'),
(113019, 'Updegraff', 42.6838912963867, 0.744974440685299, -91.2369384765625, -1.59238497585551, 218, 16, 'PPL', 'P'),
(62127, 'Updike', 33.059440612793, 0.576996087560769, -90.7686080932617, -1.58421106867979, 218, 30, 'PPL', 'P'),
(133483, 'Updyke', 43.1861114501953, 0.753739835939131, -86.1063919067383, -1.50284004578518, 218, 27, 'PPL', 'P'),
(189738, 'Upham', 32.8863906860352, 0.57397579656851, -107.001670837402, -1.86753146124787, 218, 38, 'PPL', 'P'),
(199031, 'Upham', 48.5816688537598, 0.847910077611687, -100.727783203125, -1.75803146512957, 218, 34, 'PPL', 'P'),
(126389, 'Uphams Corner', 42.3166694641113, 0.738565210626887, -71.0611114501953, -1.24025036493255, 218, 23, 'PPL', 'P'),
(34228, 'Upland', 39.8244400024414, 0.695067600805541, -96.5555572509766, -1.68521238512743, 218, 20, 'PPL', 'P'),
(43443, 'Upland', 32.7311096191406, 0.571265630685191, -91.883056640625, -1.60366186517535, 218, 22, 'PPL', 'P'),
(79300, 'Upland', 39.8525009155273, 0.695557356130007, -75.383056640625, -1.31568253859628, 218, 45, 'PPL', 'P'),
(111802, 'Upland', 37.3925018310547, 0.652622272509913, -81.4216690063477, -1.42107620662979, 218, 58, 'PPL', 'P'),
(123869, 'Upland', 40.4755592346191, 0.7064317752301, -85.4944381713867, -1.49215943823342, 218, 19, 'PPL', 'P'),
(143254, 'Upland', 40.3186111450195, 0.703692514311872, -98.9008331298828, -1.72614517108194, 218, 35, 'PPL', 'P'),
(185836, 'Upland', 34.0974998474121, 0.595113639035605, -117.647499084473, -2.05333621576106, 218, 6, 'PPL', 'P'),
(25667, 'Upland Estates', 34.0963897705078, 0.595094264538675, -84.4749984741211, -1.4743668589906, 218, 13, 'PPL', 'P'),
(158061, 'Upland Heights', 40.1588897705078, 0.700904850440831, -80.7241668701172, -1.40890249781287, 218, 41, 'PPL', 'P'),
(58015, 'Uplands Park', 38.6930618286133, 0.67532132658704, -90.2822189331055, -1.57572197638905, 218, 29, 'PPL', 'P'),
(34229, 'Upola', 37.4166717529297, 0.653044117226581, -95.9983291625977, -1.67548692030062, 218, 20, 'PPL', 'P'),
(185837, 'Upp', 39.4272193908691, 0.68813479327682, -123.355827331543, -2.15296533845704, 218, 6, 'PPL', 'P'),
(129126, 'Upper Abbot', 45.2050018310547, 0.78897612032197, -69.4641723632813, -1.21237851991211, 218, 26, 'PPL', 'P'),
(28838, 'Upper Alton', 38.9113883972168, 0.679131844053752, -90.1505584716797, -1.57342406784248, 218, 18, 'PPL', 'P'),
(189739, 'Upper Anton Chico', 35.2083282470703, 0.614501252034301, -105.168327331543, -1.83553358075057, 218, 38, 'PPL', 'P'),
(74613, 'Upper Arlington', 39.9944381713867, 0.698034628575998, -83.0625, -1.44971410993779, 218, 41, 'PPL', 'P'),
(153293, 'Upper Barbourville', 42.1599998474121, 0.735830809977648, -75.355827331543, -1.31520729749976, 218, 40, 'PPL', 'P'),
(153294, 'Upper Beechwood', 41.7769393920898, 0.729145143798086, -74.9899978637695, -1.30882236878629, 218, 40, 'PPL', 'P'),
(153295, 'Upper Benson', 43.2491683959961, 0.754840387259607, -74.336669921875, -1.29741964510495, 218, 40, 'PPL', 'P'),
(177285, 'Upper Benwood', 40.0311088562012, 0.698674652764972, -80.7286071777344, -1.40897999580059, 218, 58, 'PPL', 'P'),
(168223, 'Upper Black Eddy', 40.5652809143066, 0.707997713951067, -75.0999984741211, -1.31074224161613, 218, 45, 'PPL', 'P'),
(38637, 'Upper Blue Licks', 38.3319396972656, 0.669018556393204, -83.8566665649414, -1.46357493130527, 218, 21, 'PPL', 'P'),
(25668, 'Upper Bradley Place', 32.2050018310547, 0.562083317562707, -84.9458312988281, -1.4825844420082, 218, 13, 'PPL', 'P'),
(52309, 'Upper Brambley (historical)', 38.3019409179688, 0.668494978922894, -76.8105621337891, -1.3405972095423, 218, 25, 'PPL', 'P'),
(107064, 'Upper Brandon', 37.2886085510254, 0.650808992702705, -77.0272216796875, -1.3443786319741, 218, 53, 'PPL', 'P'),
(197742, 'Upper Bridger (historical)', 45.7358283996582, 0.798240791701165, -110.903060913086, -1.93562356347318, 218, 31, 'PPL', 'P'),
(153296, 'Upper Brookville', 40.8386116027832, 0.712768234411726, -73.565559387207, -1.28396122737818, 218, 40, 'PPL', 'P'),
(168224, 'Upper Brownville', 40.8191719055176, 0.712428947688849, -76.2194366455078, -1.33028012347933, 218, 45, 'PPL', 'P'),
(6482, 'Upper Coalburg', 33.6122207641602, 0.586643921241799, -86.850830078125, -1.51583294295341, 218, 2, 'PPL', 'P'),
(189740, 'Upper Colonias', 35.5763893127441, 0.620925129478708, -105.583892822266, -1.84278656682134, 218, 38, 'PPL', 'P'),
(52310, 'Upper Crest Estates', 39.5336112976074, 0.689991682346877, -76.3249969482422, -1.33212249832145, 218, 25, 'PPL', 'P'),
(195754, 'Upper Crossing', 45.6444396972656, 0.796645757945289, -114.706108093262, -2.00199925837593, 218, 17, 'PPL', 'P'),
(52311, 'Upper Crossroads', 39.5422210693359, 0.690141951211385, -76.4744415283203, -1.33473079829307, 218, 25, 'PPL', 'P'),
(129127, 'Upper Dam', 44.8838882446289, 0.783371630965953, -70.8622207641602, -1.23677906760969, 218, 26, 'PPL', 'P'),
(79303, 'Upper Darby', 39.9283294677734, 0.696880814033722, -75.274169921875, -1.3137821068424, 218, 45, 'PPL', 'P'),
(74614, 'Upper Dayton View', 39.7833290100098, 0.694350078628847, -84.2333297729492, -1.47014894445613, 218, 41, 'PPL', 'P'),
(189741, 'Upper Dilia', 35.1847190856934, 0.614089194434638, -105.080276489258, -1.83399680364354, 218, 38, 'PPL', 'P'),
(129128, 'Upper Drew', 45.6277809143066, 0.79635500733328, -68.0711135864258, -1.18806505758218, 218, 26, 'PPL', 'P'),
(168226, 'Upper Dutchtown', 40.4199981689453, 0.705462051698175, -78.6388931274414, -1.37250760519779, 218, 45, 'PPL', 'P'),
(197743, 'Upper Ellis Place', 47.3152809143066, 0.825807438460684, -112.337219238281, -1.96065434824272, 218, 31, 'PPL', 'P'),
(168227, 'Upper Emilie', 40.1605606079102, 0.700934012054768, -74.8491668701172, -1.3063644042582, 218, 45, 'PPL', 'P'),
(168228, 'Upper Exeter', 41.4069404602051, 0.722687444207835, -75.8380584716797, -1.32362381865079, 218, 45, 'PPL', 'P'),
(209015, 'Upper Fairfax', 47.0058288574219, 0.820406481190976, -121.999168395996, -2.12928717320514, 218, 56, 'PPL', 'P'),
(153297, 'Upper Fairfield', 42.2691688537598, 0.737736168579545, -76.2908325195313, -1.33152621655338, 218, 40, 'PPL', 'P'),
(52312, 'Upper Fairmount', 38.103889465332, 0.665038328986026, -75.7916717529297, -1.32281421767941, 218, 25, 'PPL', 'P'),
(52313, 'Upper Falls', 39.4372215270996, 0.688309363486274, -76.4036102294922, -1.33349455891506, 218, 25, 'PPL', 'P'),
(111803, 'Upper Falls', 38.3427810668945, 0.669207773988654, -81.8444366455078, -1.42845489390401, 218, 58, 'PPL', 'P'),
(52314, 'Upper Ferry Acres', 38.3363914489746, 0.669096254118007, -75.6986083984375, -1.32118995573057, 218, 25, 'PPL', 'P'),
(52315, 'Upper Ferry Estates', 38.3430595397949, 0.669212634257643, -75.6930618286133, -1.32109314982494, 218, 25, 'PPL', 'P'),
(74615, 'Upper Fivemile', 39.1194381713867, 0.682762997621048, -83.9330596923828, -1.46490824290502, 218, 41, 'PPL', 'P'),
(111804, 'Upper Flats', 38.9252815246582, 0.679374324871004, -81.9922180175781, -1.43103416541976, 218, 58, 'PPL', 'P'),
(185838, 'Upper Forni', 38.8222198486328, 0.677575559291737, -120.171669006348, -2.09739129177759, 218, 6, 'PPL', 'P'),
(126390, 'Upper Four Corners', 41.8680610656738, 0.730735517022054, -70.9319381713867, -1.23799586591174, 218, 23, 'PPL', 'P'),
(176788, 'Upper French Creek', 44.2174987792969, 0.771740940695304, -91.3247222900391, -1.59391709243064, 218, 57, 'PPL', 'P'),
(129129, 'Upper Frenchville', 47.2799987792969, 0.82519164903763, -68.4250030517578, -1.19424159394034, 218, 26, 'PPL', 'P'),
(189742, 'Upper Frijoles Crossing', 35.8152809143066, 0.625094574481336, -106.360832214355, -1.85634671730175, 218, 38, 'PPL', 'P'),
(189743, 'Upper Fruitland', 36.7158317565918, 0.64081215176082, -108.313606262207, -1.89042905398426, 218, 38, 'PPL', 'P'),
(38638, 'Upper Gillmore', 37.7236099243164, 0.65840119891733, -83.3627777099609, -1.45495494464696, 218, 21, 'PPL', 'P'),
(168232, 'Upper Glasgow', 40.2691688537598, 0.702829583539659, -75.664436340332, -1.32059354080444, 218, 45, 'PPL', 'P'),
(129130, 'Upper Gloucester', 43.9891700744629, 0.767755853019137, -70.2949981689453, -1.22687916573148, 218, 26, 'PPL', 'P'),
(6487, 'Upper Gordon Landing', 31.166109085083, 0.543951218570416, -85.1033325195313, -1.48533335688538, 218, 2, 'PPL', 'P'),
(18412, 'Upper Grand Lagoon', 30.1630592346191, 0.526444696118185, -85.7408294677734, -1.49645977760362, 218, 12, 'PPL', 'P'),
(172664, 'Upper Graniteville', 44.1416702270508, 0.770417482791589, -72.476936340332, -1.26496117089712, 218, 55, 'PPL', 'P'),
(126391, 'Upper Green', 42.7930603027344, 0.746879799287196, -70.8611068725586, -1.23675962653373, 218, 23, 'PPL', 'P'),
(6483, 'Upper Green Hill', 34.9847183227539, 0.610598522614844, -87.5066680908203, -1.52727947563467, 218, 2, 'PPL', 'P'),
(146502, 'Upper Greenwood Lake', 41.1816711425781, 0.718755752911523, -74.3824996948242, -1.29821952553836, 218, 37, 'PPL', 'P'),
(6484, 'Upper Hall Landing', 30.874439239502, 0.538860619436243, -87.8925018310547, -1.53401354476705, 218, 2, 'PPL', 'P'),
(201712, 'Upper Highland', 45.2358283996582, 0.789514145441193, -122.428886413574, -2.13678716746702, 218, 43, 'PPL', 'P'),
(52316, 'Upper Hill', 38.1116714477539, 0.66517415020162, -75.7905578613281, -1.32279477660345, 218, 25, 'PPL', 'P'),
(126392, 'Upper Hill', 42.1097183227539, 0.73495323181944, -72.5541687011719, -1.26630912988287, 218, 23, 'PPL', 'P'),
(168235, 'Upper Hillville', 41.0372200012207, 0.716234604886573, -79.6113891601563, -1.38948086293125, 218, 45, 'PPL', 'P'),
(38639, 'Upper Hodge Landing', 37.0347213745117, 0.64637782554395, -88.4530563354492, -1.54379706650562, 218, 21, 'PPL', 'P'),
(153298, 'Upper Hollowville', 42.2066688537598, 0.736645337797049, -73.6647186279297, -1.28569188261257, 218, 40, 'PPL', 'P'),
(91517, 'Upper Holly Creek', 35.1100006103516, 0.612785111027853, -87.6074981689453, -1.529039292483, 218, 50, 'PPL', 'P'),
(168236, 'Upper Holmesburg', 40.0466690063477, 0.698946228617133, -75.0100021362305, -1.3091715092052, 218, 45, 'PPL', 'P'),
(153299, 'Upper Jay', 44.3363914489746, 0.773816009237666, -73.7761077880859, -1.28763599020833, 218, 40, 'PPL', 'P'),
(52317, 'Upper Jutland', 38.1388893127441, 0.665649191561063, -76.4124984741211, -1.33364968804856, 218, 25, 'PPL', 'P'),
(144583, 'Upper Kidderville', 44.8824996948242, 0.783347396200033, -71.3649978637695, -1.2455541834015, 218, 36, 'PPL', 'P'),
(192833, 'Upper Kimberly', 38.4855613708496, 0.671699760399668, -112.396392822266, -1.96168712211346, 218, 52, 'PPL', 'P'),
(189744, 'Upper La Jara', 36.1205596923828, 0.63042269429523, -106.922218322754, -1.86614475326826, 218, 38, 'PPL', 'P'),
(189745, 'Upper La Posada', 35.649169921875, 0.622195390739648, -105.681106567383, -1.84448326675183, 218, 38, 'PPL', 'P'),
(185840, 'Upper Lake', 39.1647186279297, 0.683553290674529, -122.909439086914, -2.14517439384606, 218, 6, 'PPL', 'P'),
(129131, 'Upper Landing', 43.3294410705566, 0.75624140973007, -70.5672225952148, -1.23163037827424, 218, 26, 'PPL', 'P'),
(168238, 'Upper Lawn', 40.228328704834, 0.702116788473899, -76.5516662597656, -1.33607862412076, 218, 45, 'PPL', 'P'),
(111805, 'Upper Leatherwood', 38.4352798461914, 0.67082218224146, -81.103889465332, -1.41552990734359, 218, 58, 'PPL', 'P'),
(168240, 'Upper Lehigh', 41.0322189331055, 0.716147319781845, -75.9072189331055, -1.32483089641487, 218, 45, 'PPL', 'P'),
(153300, 'Upper Lisle', 42.396110534668, 0.73995171886941, -75.9574966430664, -1.32570840799405, 218, 40, 'PPL', 'P'),
(146503, 'Upper Longwood', 40.9772186279297, 0.715187383366926, -74.5458297729492, -1.30107017316918, 218, 37, 'PPL', 'P'),
(189746, 'Upper Lovett Place', 31.6538906097412, 0.5524646122061, -108.948890686035, -1.9015168588667, 218, 38, 'PPL', 'P'),
(74617, 'Upper Lowell', 39.5355606079102, 0.690025704229803, -81.5219421386719, -1.42282630294013, 218, 41, 'PPL', 'P'),
(146504, 'Upper Macopin', 41.0849990844727, 0.717068507202904, -74.3861083984375, -1.29828250929814, 218, 37, 'PPL', 'P'),
(52318, 'Upper Marlboro', 38.8158302307129, 0.67746403942109, -76.75, -1.33954020090565, 218, 25, 'PPL', 'P'),
(114201, 'Upper Merryall', 41.6622200012207, 0.727142912711537, -73.4225006103516, -1.28146438069818, 218, 8, 'PPL', 'P'),
(98704, 'Upper Meyersville', 28.9191703796387, 0.504734740069913, -97.3461074829102, -1.69901008957707, 218, 51, 'PPL', 'P'),
(79305, 'Upper Middletown', 39.9661102294922, 0.697540212719625, -79.7547225952148, -1.39198250330122, 218, 45, 'PPL', 'P'),
(71494, 'Upper Mill', 39.9124984741211, 0.696604511070626, -74.5738906860352, -1.30155992849365, 218, 37, 'PPL', 'P'),
(168247, 'Upper Mill', 40.1030616760254, 0.699930466376999, -77.179443359375, -1.34703540147757, 218, 45, 'PPL', 'P'),
(209016, 'Upper Mill', 47.1936111450195, 0.823683900386482, -121.925827026367, -2.12800712482719, 218, 56, 'PPL', 'P'),
(111806, 'Upper Mingo', 38.4930610656738, 0.671830654767246, -80.0561065673828, -1.39724264592829, 218, 58, 'PPL', 'P'),
(91518, 'Upper Mockeson', 35.0699996948242, 0.612086963348089, -87.3022232055664, -1.52371123924813, 218, 50, 'PPL', 'P'),
(146505, 'Upper Mohawk', 41.0311088562012, 0.716127945284915, -74.6636123657227, -1.30312586721461, 218, 37, 'PPL', 'P'),
(153301, 'Upper Mongaup', 41.4575004577637, 0.723569882635032, -74.7652816772461, -1.30490033144893, 218, 40, 'PPL', 'P'),
(146506, 'Upper Montclair', 40.8461112976074, 0.712899128779303, -74.2016677856445, -1.29506341333051, 218, 37, 'PPL', 'P'),
(146507, 'Upper Montvale', 41.0605583190918, 0.7166419353753, -74.0524978637695, -1.29245990704885, 218, 37, 'PPL', 'P'),
(107065, 'Upper Mount Landing', 37.9472198486328, 0.662303928336787, -76.9388885498047, -1.34283692801906, 218, 53, 'PPL', 'P'),
(211125, 'Upper Nahiku *', 20.8022193908691, 0.363067220092876, -156.072784423828, -2.72398396095112, 218, 15, 'PPL', 'P'),
(12494, 'Upper Nodena (historical)', 35.6041717529297, 0.621410024534184, -89.980827331543, -1.57046170060393, 218, 4, 'PPL', 'P'),
(189747, 'Upper Nutria', 35.269718170166, 0.615572708319867, -108.570281982422, -1.89490889041194, 218, 38, 'PPL', 'P'),
(153302, 'Upper Nyack', 41.1069412231445, 0.717451469767657, -73.9205627441406, -1.29015720481231, 218, 40, 'PPL', 'P'),
(79306, 'Upper Octoraro', 39.9736099243164, 0.697671107087203, -75.92138671875, -1.32507817092208, 218, 45, 'PPL', 'P'),
(79308, 'Upper Peanut', 39.978889465332, 0.697763252460919, -79.779167175293, -1.39240914170785, 218, 45, 'PPL', 'P'),
(69738, 'Upper Pigeonroost', 36.0911102294922, 0.629908704204845, -82.2688903808594, -1.43586300910829, 218, 33, 'PPL', 'P'),
(168253, 'Upper Pittston', 41.3380584716797, 0.721485226712746, -75.7866668701172, -1.32272686599565, 218, 45, 'PPL', 'P'),
(107066, 'Upper Pocosin', 38.4008293151855, 0.670220907046347, -78.4822235107422, -1.36977320454855, 218, 53, 'PPL', 'P'),
(69739, 'Upper Poplar', 36.1105613708496, 0.630248190664803, -82.3063888549805, -1.43651748094617, 218, 33, 'PPL', 'P'),
(12496, 'Upper Poplar Ridge', 35.8916702270508, 0.626427819502057, -90.4077835083008, -1.57791349165008, 218, 4, 'PPL', 'P'),
(209017, 'Upper Preston', 47.5052795410156, 0.829123540071023, -121.906387329102, -2.12766783810432, 218, 56, 'PPL', 'P'),
(79309, 'Upper Providence', 39.9550018310547, 0.697346334592267, -75.4233322143555, -1.31638547996601, 218, 45, 'PPL', 'P'),
(189748, 'Upper Pueblo', 35.334171295166, 0.616697627564316, -105.429718017578, -1.84009570885593, 218, 38, 'PPL', 'P'),
(190862, 'Upper Pyramid (historical)', 39.8499984741211, 0.695513680288129, -119.595001220703, -2.08732654022791, 218, 39, 'PPL', 'P'),
(153303, 'Upper Red Hook', 42.0297203063965, 0.733557003038939, -73.8450012207031, -1.2888384074405, 218, 40, 'PPL', 'P'),
(113354, 'Upper Reese', 40.4388885498047, 0.705791751041127, -78.3199996948242, -1.36694186483564, 218, 45, 'PPL', 'P'),
(189749, 'Upper Rociada', 35.8549995422363, 0.625787795313084, -105.426391601563, -1.84003765194416, 218, 38, 'PPL', 'P'),
(146508, 'Upper Saddle River', 41.0583305358887, 0.716603053223385, -74.0988922119141, -1.29326964117828, 218, 37, 'PPL', 'P'),
(153304, 'Upper Saint Regis', 44.3977813720703, 0.774887465523233, -74.2699966430664, -1.29625597686664, 218, 40, 'PPL', 'P'),
(168258, 'Upper Sainte Clair', 40.3358306884766, 0.703993052040887, -80.083610534668, -1.39772268071477, 218, 45, 'PPL', 'P'),
(209018, 'Upper Salmon Junction', 46.3544387817383, 0.809037579655482, -123.734169006348, -2.15956864637989, 218, 56, 'PPL', 'P'),
(158063, 'Upper Sandusky', 40.827220916748, 0.712569429436351, -83.2813873291016, -1.45353441452151, 218, 41, 'PPL', 'P'),
(69740, 'Upper Sawra Town (historical)', 36.3994407653809, 0.635290087240541, -80.1505584716797, -1.39889114264304, 218, 33, 'PPL', 'P'),
(52319, 'Upper Seneca Crest', 39.2572212219238, 0.685167765506362, -77.1699981689453, -1.34687055180609, 218, 25, 'PPL', 'P'),
(91520, 'Upper Shady', 36.502498626709, 0.63708878624078, -81.9397201538086, -1.43011790484671, 218, 50, 'PPL', 'P'),
(144584, 'Upper Shaker Village', 43.6116714477539, 0.761167259061308, -72.1386108398438, -1.25905627697015, 218, 36, 'PPL', 'P'),
(98705, 'Upper Sharyland Colonia', 26.3159999847412, 0.459300845688512, -98.2839965820313, -1.7153793423753, 218, 51, 'PPL', 'P'),
(91521, 'Upper Shell Creek', 36.1674995422363, 0.631241949225566, -82.0316696166992, -1.4317227257196, 218, 50, 'PPL', 'P'),
(107067, 'Upper Shirley', 37.3474998474121, 0.651836839725421, -77.2561111450195, -1.34837350676728, 218, 53, 'PPL', 'P'),
(129132, 'Upper Shirley Corner', 45.3752784729004, 0.791948008361416, -69.595832824707, -1.21467642845868, 218, 26, 'PPL', 'P'),
(91522, 'Upper Sinking', 35.6669387817383, 0.622505515848588, -87.6466674804688, -1.52972292593482, 218, 50, 'PPL', 'P'),
(201713, 'Upper Soda', 44.4063911437988, 0.77503773438774, -122.281669616699, -2.13421774964731, 218, 43, 'PPL', 'P'),
(118155, 'Upper South Amana', 41.7658309936523, 0.728951265670728, -91.9677810668945, -1.60514058537061, 218, 16, 'PPL', 'P'),
(38640, 'Upper Spencer', 38.0299987792969, 0.663748693228155, -83.8469390869141, -1.46340515478578, 218, 21, 'PPL', 'P'),
(114202, 'Upper Stepney', 41.3224983215332, 0.721213650860585, -73.2655563354492, -1.27872518635898, 218, 8, 'PPL', 'P'),
(168262, 'Upper Strasburg', 40.0602798461914, 0.699183782586368, -77.7091674804688, -1.35628083151789, 218, 45, 'PPL', 'P'),
(192834, 'Upper Sunnyside', 39.5666694641113, 0.690568656197043, -110.372222900391, -1.9263586923569, 218, 52, 'PPL', 'P'),
(123870, 'Upper Sunset Park', 40.7249984741211, 0.71078531124308, -86.7544403076172, -1.5141506240928, 218, 19, 'PPL', 'P'),
(158064, 'Upper Tauwa (historical)', 41.0133285522461, 0.715817620438894, -84.0208282470703, -1.46644009316403, 218, 41, 'PPL', 'P'),
(43444, 'Upper Texas', 29.8688907623291, 0.521310487721162, -91.0902786254883, -1.58982527857379, 218, 22, 'PPL', 'P'),
(84131, 'Upper Topsaw Landing', 33.6247215270996, 0.586862100714104, -79.1613922119141, -1.3816269345605, 218, 48, 'PPL', 'P'),
(185842, 'Upper Town', 38.3544387817383, 0.669411239495936, -119.116943359375, -2.07898285653269, 218, 6, 'PPL', 'P'),
(190863, 'Upper Town (historical)', 38.521110534668, 0.672320210354629, -116.362503051758, -2.03090880411512, 218, 39, 'PPL', 'P'),
(153305, 'Upper Town Landing', 44.2616691589355, 0.772511859251855, -76.10888671875, -1.32835066326957, 218, 40, 'PPL', 'P'),
(111807, 'Upper Tract', 38.7872200012207, 0.6769646967167, -79.2827835083008, -1.38374561236571, 218, 58, 'PPL', 'P'),
(168264, 'Upper Two Lick', 40.5905609130859, 0.708438933164665, -79.1388931274414, -1.38123425145776, 218, 45, 'PPL', 'P'),
(38641, 'Upper Tygart', 38.2958297729492, 0.668388319321236, -83.2794418334961, -1.45350045921761, 218, 21, 'PPL', 'P'),
(74618, 'Upper Valley Trailer Court', 39.832218170166, 0.695203355442108, -84.0605621337891, -1.46713358031189, 218, 41, 'PPL', 'P'),
(144586, 'Upper Village', 44.1772193908691, 0.77103793274655, -71.9447174072266, -1.25567219817298, 218, 36, 'PPL', 'P'),
(129133, 'Upper Village (historical)', 43.8027801513672, 0.764502735168578, -70.1952819824219, -1.22513878995911, 218, 26, 'PPL', 'P'),
(211127, 'Upper Village Three', 20.8872203826904, 0.364550767267618, -156.42138671875, -2.73006821877752, 218, 15, 'PPL', 'P'),
(179418, 'Upper Wheatfields', 36.2230606079102, 0.632211672757491, -109.079170227051, -1.90379066580541, 218, 5, 'PPL', 'P'),
(111808, 'Upper Whitman', 37.7930603027344, 0.65961333668748, -82.0530624389648, -1.43209610090443, 218, 58, 'PPL', 'P'),
(168279, 'Upper Whyel', 40.2313919067383, 0.702170251432782, -79.6813888549805, -1.39070258808132, 218, 45, 'PPL', 'P'),
(91523, 'Upper Windrock', 36.0919418334961, 0.629923218432786, -84.3408279418945, -1.47202514144409, 218, 50, 'PPL', 'P'),
(126393, 'Upper Wire Village', 42.2722206115723, 0.737789431801347, -71.9772186279297, -1.25623945148517, 218, 23, 'PPL', 'P'),
(107068, 'Upper Zion', 38.0652809143066, 0.664364482651208, -77.2433319091797, -1.34815046702598, 218, 53, 'PPL', 'P'),
(52320, 'Upperco', 39.5627784729004, 0.690500745589246, -76.835563659668, -1.34103356848691, 218, 25, 'PPL', 'P'),
(111809, 'Upperglade', 38.4091682434082, 0.67036644879992, -80.5069427490234, -1.40511122168503, 218, 58, 'PPL', 'P'),
(107069, 'Upperville', 38.9938888549805, 0.680571748676131, -77.8850021362305, -1.35934972520004, 218, 53, 'PPL', 'P'),
(153307, 'Upperville', 42.7002792358398, 0.745260464186374, -75.6155624389648, -1.31974053030729, 218, 40, 'PPL', 'P'),
(107070, 'Upright', 37.8097190856934, 0.659904087299489, -76.8380584716797, -1.34107711117073, 218, 53, 'PPL', 'P'),
(168268, 'Upsal', 40.0447196960449, 0.698912206734207, -75.1983337402344, -1.31245851578063, 218, 45, 'PPL', 'P'),
(138533, 'Upsala', 45.8108291625977, 0.799549801955966, -94.5711135864258, -1.65057730936067, 218, 28, 'PPL', 'P'),
(6486, 'Upshaw', 34.2813911437988, 0.598323147623314, -87.1558303833008, -1.52115620249831, 218, 2, 'PPL', 'P'),
(107071, 'Upshaw', 37.7938919067383, 0.659627850915421, -77.147216796875, -1.34647294185534, 218, 53, 'PPL', 'P'),
(189750, 'Upshaw Place', 31.6986103057861, 0.553245118142575, -108.706108093262, -1.89727950325627, 218, 38, 'PPL', 'P'),
(176789, 'Upson', 46.3691711425781, 0.809294707858729, -90.4066696166992, -1.57789405057412, 218, 57, 'PPL', 'P'),
(107073, 'Upson Addition', 37.3027801513672, 0.651056333788946, -79.9391708374023, -1.3952017324269, 218, 53, 'PPL', 'P'),
(153308, 'Upson Corners', 43.3616714477539, 0.756803935931322, -76.2286071777344, -1.33044017946085, 218, 40, 'PPL', 'P'),
(168269, 'Upsonville', 41.9147186279297, 0.731549845104373, -75.8033294677734, -1.32301768318669, 218, 45, 'PPL', 'P'),
(6489, 'Upton', 34.0738906860352, 0.594701581435943, -85.9461135864258, -1.50004266137616, 218, 2, 'PPL', 'P'),
(25670, 'Upton', 31.521390914917, 0.550152056273529, -82.8933334350586, -1.44676159639527, 218, 13, 'PPL', 'P'),
(31357, 'Upton', 37.9644393920898, 0.662604466065802, -87.961669921875, -1.53522075568918, 218, 19, 'PPL', 'P'),
(38643, 'Upton', 37.4650001525879, 0.653887606922837, -85.8933334350586, -1.4991214739551, 218, 21, 'PPL', 'P'),
(58017, 'Upton', 37.3688888549805, 0.652210148331223, -92.1638870239258, -1.60856328000358, 218, 29, 'PPL', 'P'),
(62128, 'Upton', 31.9899997711182, 0.558330823718244, -89.7038879394531, -1.56562819638349, 218, 30, 'PPL', 'P'),
(69741, 'Upton', 36.0699996948242, 0.629540255868033, -81.695556640625, -1.42585644762842, 218, 33, 'PPL', 'P'),
(71497, 'Upton', 39.9347190856934, 0.696992333904369, -74.5244369506836, -1.30069679798435, 218, 37, 'PPL', 'P'),
(98707, 'Upton', 30.0111103057861, 0.52379268701517, -97.2638931274414, -1.69757517838174, 218, 51, 'PPL', 'P'),
(111811, 'Upton', 39.5416717529297, 0.690132363831461, -80.2283325195313, -1.40024855585066, 218, 58, 'PPL', 'P'),
(126394, 'Upton', 42.1744384765625, 0.736082811595797, -71.602783203125, -1.24970432048622, 218, 23, 'PPL', 'P'),
(129134, 'Upton', 44.6941719055176, 0.78006045620363, -71.0111083984375, -1.23937764704333, 218, 26, 'PPL', 'P'),
(153309, 'Upton', 40.8694381713867, 0.713306259530949, -72.8872222900391, -1.27212201159418, 218, 40, 'PPL', 'P'),
(158065, 'Upton', 41.4150009155273, 0.722828125692418, -83.0113906860352, -1.44882208413067, 218, 41, 'PPL', 'P'),
(168270, 'Upton', 40.0433311462402, 0.698887971968287, -75.3550033569336, -1.31519291642987, 218, 45, 'PPL', 'P'),
(189751, 'Upton', 34.1552810668945, 0.596122111561391, -103.652496337891, -1.80907733900756, 218, 38, 'PPL', 'P'),
(193223, 'Upton', 40.9636116027832, 0.714949895976718, -111.234718322754, -1.94141207726052, 218, 52, 'PPL', 'P'),
(194026, 'Upton', 41.3411102294922, 0.721538489934547, -122.346939086914, -2.1353569168036, 218, 6, 'PPL', 'P'),
(209803, 'Upton', 44.0997200012207, 0.769685313228899, -104.627502441406, -1.82609440574094, 218, 59, 'PPL', 'P'),
(6488, 'Upton (historical)', 34.4472198486328, 0.601217404516985, -86.3897171020508, -1.50778500329724, 218, 2, 'PPL', 'P'),
(25671, 'Uptonville', 30.8994407653809, 0.539296978380853, -82.0683288574219, -1.43236255017149, 218, 13, 'PPL', 'P'),
(91524, 'Uptonville', 35.454719543457, 0.618801591404506, -88.978889465332, -1.55297458593814, 218, 50, 'PPL', 'P'),
(153310, 'Uptonville', 43.2030601501465, 0.754035646557212, -77.6449966430664, -1.35516083912145, 218, 40, 'PPL', 'P'),
(69742, 'Upward', 35.2963905334473, 0.616038228878413, -82.3866729736328, -1.43791870315372, 218, 33, 'PPL', 'P'),
(74620, 'Ural (historical)', 39.2591705322266, 0.685201787389288, -82.379997253418, -1.43780218985603, 218, 41, 'PPL', 'P'),
(197744, 'Ural (historical)', 48.6097183227539, 0.848399633199071, -115.253326416016, -2.01155001983523, 218, 31, 'PPL', 'P'),
(43445, 'Urania', 31.8636093139648, 0.556124894097818, -92.2958297729492, -1.61086611539817, 218, 22, 'PPL', 'P'),
(187474, 'Uravan', 38.3683280944824, 0.66965365373416, -108.735832214355, -1.89779828703662, 218, 7, 'PPL', 'P'),
(193180, 'Urback Place', 45.6744384765625, 0.797169335415599, -110.450828552246, -1.92773061979246, 218, 31, 'PPL', 'P'),
(28839, 'Urbain', 37.9744415283203, 0.662779036275257, -89.0405578613281, -1.5540509024927, 218, 18, 'PPL', 'P'),
(38642, 'Urban', 37.1572189331055, 0.648515811267065, -83.8469390869141, -1.46340515478578, 218, 21, 'PPL', 'P'),
(168272, 'Urban', 40.6811103820801, 0.710019319534546, -76.7719421386719, -1.3399231634704, 218, 45, 'PPL', 'P'),
(209019, 'Urban', 48.6180610656738, 0.848545241531671, -122.690826416016, -2.14135888295231, 218, 56, 'PPL', 'P'),
(158066, 'Urban Hill', 40.8472213745117, 0.712918503276233, -81.6188888549805, -1.42451834233871, 218, 41, 'PPL', 'P'),
(12500, 'Urbana', 33.1594390869141, 0.578741390181153, -92.4458312988281, -1.61348413590778, 218, 4, 'PPL', 'P'),
(34230, 'Urbana', 37.5580596923828, 0.655511802292649, -95.399169921875, -1.66502961880626, 218, 20, 'PPL', 'P'),
(52321, 'Urbana', 39.3258285522461, 0.686365189311489, -77.3516693115234, -1.35004131139994, 218, 25, 'PPL', 'P'),
(58019, 'Urbana', 37.8422203063965, 0.660471340611676, -93.1666717529297, -1.62606517521342, 218, 29, 'PPL', 'P'),
(98708, 'Urbana', 30.5602798461914, 0.533377503646906, -94.956672668457, -1.65730658480309, 218, 51, 'PPL', 'P'),
(118156, 'Urbana', 42.2241706848145, 0.736950802374081, -91.8741683959961, -1.60350673604185, 218, 16, 'PPL', 'P'),
(121776, 'Urbana', 40.1105613708496, 0.700061360744576, -88.2072219848633, -1.53950644767339, 218, 18, 'PPL', 'P'),
(123871, 'Urbana', 40.8983306884766, 0.713810529083355, -85.7927780151367, -1.49736645079674, 218, 19, 'PPL', 'P'),
(140990, 'Urbana', 46.934440612793, 0.819160521274982, -98.4113922119141, -1.71760281556941, 218, 34, 'PPL', 'P'),
(153311, 'Urbana', 42.4544410705566, 0.74096977877512, -77.1813888549805, -1.34706935678147, 218, 40, 'PPL', 'P'),
(158067, 'Urbana', 40.1083297729492, 0.700022412013634, -83.7525024414063, -1.46175692438713, 218, 41, 'PPL', 'P'),
(52322, 'Urbana Overlook', 39.3213882446289, 0.686287691323768, -77.3708267211914, -1.3503756712748, 218, 25, 'PPL', 'P'),
(74621, 'Urbancrest', 39.8974990844727, 0.696342722335471, -83.0869369506836, -1.45014061518637, 218, 41, 'PPL', 'P'),
(28840, 'Urbandale', 37.0527801513672, 0.64669301065896, -89.1858291625977, -1.55658636500851, 218, 18, 'PPL', 'P'),
(58020, 'Urbandale', 39.3950004577637, 0.687572466812649, -92.4438934326172, -1.61345031376193, 218, 29, 'PPL', 'P'),
(118158, 'Urbandale', 41.6266708374023, 0.726522462756576, -93.7119369506836, -1.63558184821076, 218, 16, 'PPL', 'P'),
(133484, 'Urbandale', 42.3522186279297, 0.739185660581848, -85.2441711425781, -1.48779145457153, 218, 27, 'PPL', 'P'),
(12501, 'Urbanette', 36.4197196960449, 0.635644021349412, -93.533332824707, -1.63246461815483, 218, 4, 'PPL', 'P'),
(138535, 'Urbank', 46.1227798461914, 0.804994368488524, -95.5116729736328, -1.66699316747798, 218, 28, 'PPL', 'P'),
(107072, 'Urbanna', 37.6375007629395, 0.656898310535171, -76.5747222900391, -1.33648102776147, 218, 53, 'PPL', 'P'),
(52323, 'Urbanwood', 39.3158302307129, 0.686190685681062, -76.4733276367188, -1.33471135721712, 218, 25, 'PPL', 'P'),
(62129, 'Urbo (historical)', 32.3194389343262, 0.564080621801239, -89.0861129760742, -1.55484598923614, 218, 30, 'PPL', 'P'),
(98709, 'Urebeno', 26.9455604553223, 0.470288748740556, -99.3144378662109, -1.73336393553271, 218, 51, 'PPL', 'P'),
(69743, 'Uree', 35.4249992370605, 0.618282874203186, -82.1672210693359, -1.43408854487397, 218, 33, 'PPL', 'P'),
(168273, 'Urey', 40.8436088562012, 0.712855452937426, -78.8261108398438, -1.37577517069727, 218, 45, 'PPL', 'P'),
(185843, 'Urgon', 38.1580581665039, 0.665983751173004, -121.270561218262, -2.11657057900001, 218, 6, 'PPL', 'P'),
(6496, 'Uriah', 31.3050003051758, 0.546375327663147, -87.5022201538086, -1.5272018444889, 218, 2, 'PPL', 'P'),
(168274, 'Uriah', 40.0422210693359, 0.698868597471357, -77.1766662597656, -1.34698693194573, 218, 45, 'PPL', 'P'),
(58021, 'Urich', 38.4597206115723, 0.671248754069063, -94.0005569458008, -1.64061921741265, 218, 29, 'PPL', 'P'),
(209804, 'Urie', 41.3161087036133, 0.721102130989938, -110.335563659668, -1.92571886790501, 218, 59, 'PPL', 'P'),
(52324, 'Urieville', 39.2833290100098, 0.685623432368875, -76.0194396972656, -1.32678951823857, 218, 25, 'PPL', 'P'),
(31358, 'Urmeyville', 39.5219383239746, 0.689787950523486, -85.9852828979492, -1.50072629482799, 218, 19, 'PPL', 'P'),
(176790, 'Urne', 44.4986114501953, 0.776647282371557, -91.892219543457, -1.60382178799881, 218, 57, 'PPL', 'P'),
(25672, 'Urquhart', 31.4736099243164, 0.549318120667685, -85.0094375610352, -1.4836945807086, 218, 13, 'PPL', 'P'),
(189752, 'Urraca Place', 36.4099998474121, 0.635474377987974, -104.843330383301, -1.82986131394481, 218, 38, 'PPL', 'P'),
(43446, 'Ursa', 29.6672191619873, 0.517790654287431, -91.063606262207, -1.58935975801524, 218, 22, 'PPL', 'P'),
(121778, 'Ursa', 40.0747184753418, 0.699435784204516, -91.3672180175781, -1.59465878279422, 218, 18, 'PPL', 'P'),
(79313, 'Ursina', 39.8175010681152, 0.69494649355497, -79.3280563354492, -1.38453577226114, 218, 45, 'PPL', 'P'),
(190864, 'Ursine', 37.9847183227539, 0.662958400174674, -114.21443939209, -1.99341802071148, 218, 39, 'PPL', 'P'),
(12502, 'Ursula', 35.3238906860352, 0.616518197085872, -94.0927810668945, -1.64222883197549, 218, 4, 'PPL', 'P'),
(77532, 'Ury', 34.0516700744629, 0.5943137586022, -96.3727798461914, -1.68202231761567, 218, 42, 'PPL', 'P'),
(111812, 'Ury', 37.6536102294922, 0.657179473767256, -81.3152770996094, -1.41921931755973, 218, 58, 'PPL', 'P'),
(69690, 'USAR Center', 35.6316719055176, 0.621889992741644, -77.3805618286133, -1.35054558095235, 218, 33, 'PPL', 'P'),
(43447, 'Uscarco', 32.7547187805176, 0.571677688284854, -91.9336090087891, -1.60454417044449, 218, 22, 'PPL', 'P'),
(18413, 'Usher', 29.4072208404541, 0.513252827527018, -82.8169403076172, -1.44542828479553, 218, 12, 'PPL', 'P'),
(153313, 'Ushers', 42.9080581665039, 0.748886890642735, -73.774169921875, -1.28760216806249, 218, 40, 'PPL', 'P'),
(212216, 'Usibelli', 63.8613891601563, 1.11459150574214, -148.7802734375, -2.59670563350184, 218, 1, 'PPL', 'P'),
(18414, 'Usina Beach', 29.9527797698975, 0.52277462710946, -81.3047180175781, -1.4190350268123, 218, 12, 'PPL', 'P'),
(209020, 'Usk', 48.3138885498047, 0.84323642963568, -117.278610229492, -2.04689789066774, 218, 56, 'PPL', 'P'),
(169641, 'Usquepaug', 41.503059387207, 0.724365035957503, -71.6094436645508, -1.2498205674678, 218, 47, 'PPL', 'P'),
(62132, 'Usrytown', 32.3863906860352, 0.565249150308539, -89.3811111450195, -1.55999467857159, 218, 30, 'PPL', 'P'),
(202711, 'Usta', 45.2202796936035, 0.789242769326114, -102.162498474121, -1.7830719704371, 218, 49, 'PPL', 'P'),
(62130, 'Ustane', 31.2866706848145, 0.546055415437201, -90.8313903808594, -1.5853068263103, 218, 30, 'PPL', 'P'),
(121779, 'Ustick', 41.8838882446289, 0.731011753406123, -89.991943359375, -1.57065571188934, 218, 18, 'PPL', 'P'),
(193157, 'Ustick', 43.6336097717285, 0.761550155047034, -116.320831298828, -2.03018149482142, 218, 17, 'PPL', 'P'),
(168275, 'Uswick', 41.4505615234375, 0.723448775384461, -75.2477798461914, -1.31332151313187, 218, 45, 'PPL', 'P'),
(31359, 'Utah', 39.0608291625977, 0.681740077446349, -84.898063659668, -1.48175073942895, 218, 19, 'PPL', 'P'),
(91526, 'Utah', 35.5902786254883, 0.621167543716932, -88.0583267211914, -1.53690773508169, 218, 50, 'PPL', 'P'),
(113056, 'Utah', 40.9841690063477, 0.715308690354579, -90.4877777099609, -1.57930965385155, 218, 18, 'PPL', 'P'),
(192836, 'Utah', 39.2502784729004, 0.685046591676764, -111.750282287598, -1.95041036595168, 218, 52, 'ADM1', 'A'),
(187475, 'Utah Junction', 39.8005599975586, 0.694650816094944, -104.997497558594, -1.83255203875217, 218, 7, 'PPL', 'P'),
(206196, 'Utah Labor Center Condominium', 40.7213897705078, 0.710722327483299, -111.9375, -1.95367793145115, 218, 52, 'PPL', 'P'),
(206198, 'Utahn', 40.271110534668, 0.70286347226453, -110.43138885498, -1.92739133306958, 218, 52, 'PPL', 'P'),
(168276, 'Utahville', 40.7433280944824, 0.711105223469026, -78.4702835083008, -1.36956481219326, 218, 45, 'PPL', 'P'),
(187476, 'Utaline', 39.1269416809082, 0.682893958567653, -109.04167175293, -1.90313619396752, 218, 7, 'PPL', 'P'),
(118159, 'Ute', 42.0502815246582, 0.733915863995827, -95.7061080932617, -1.67038670049701, 218, 16, 'PPL', 'P'),
(177729, 'Ute', 36.5661087036133, 0.638198991520207, -114.714721679688, -2.00214959381947, 218, 39, 'PPL', 'P'),
(187477, 'Ute', 38.2555618286133, 0.667685511109564, -108.270561218262, -1.88967777624075, 218, 7, 'PPL', 'P'),
(189753, 'Ute Park', 36.5580596923828, 0.638058509772705, -105.114440917969, -1.83459308541161, 218, 38, 'PPL', 'P'),
(179420, 'Utevak', 31.702220916748, 0.553308135191869, -111.748893737793, -1.95038613118576, 218, 5, 'PPL', 'P'),
(31360, 'Utica', 38.333610534668, 0.66904771800714, -85.6536102294922, -1.49493751472453, 218, 19, 'PPL', 'P'),
(38644, 'Utica', 37.6022186279297, 0.656282521112118, -87.1130599975586, -1.52040971844476, 218, 21, 'PPL', 'P'),
(52325, 'Utica', 39.5258293151855, 0.689855861131283, -77.394172668457, -1.35078313492158, 218, 25, 'PPL', 'P'),
(58022, 'Utica', 39.7436103820801, 0.693656857797099, -93.6263885498047, -1.63408874694561, 218, 29, 'PPL', 'P'),
(62131, 'Utica', 32.1094398498535, 0.560415446351018, -90.6233291625977, -1.58167547300592, 218, 30, 'PPL', 'P'),
(77533, 'Utica', 33.9013900756836, 0.591690877823608, -96.2211074829102, -1.67937513549214, 218, 42, 'PPL', 'P'),
(84128, 'Utica', 34.6780586242676, 0.605246301193084, -82.9316711425781, -1.44743071561916, 218, 48, 'PPL', 'P'),
(111813, 'Utica', 39.045280456543, 0.68146870133127, -81.6588897705078, -1.42521649001848, 218, 58, 'PPL', 'P'),
(118160, 'Utica', 40.8147201538086, 0.712351249964046, -91.834716796875, -1.60281817574201, 218, 16, 'PPL', 'P'),
(121781, 'Utica', 41.3405609130859, 0.721528902554623, -89.0100021362305, -1.55351760448441, 218, 18, 'PPL', 'P'),
(133485, 'Utica', 42.6261100769043, 0.743965968159513, -83.0336074829102, -1.44920984038538, 218, 27, 'PPL', 'P'),
(138538, 'Utica', 43.9755592346191, 0.767518299049902, -91.954719543457, -1.6049126187813, 218, 28, 'PPL', 'P'),
(143255, 'Utica', 40.896110534668, 0.713771780089495, -97.3450012207031, -1.69899078165917, 218, 35, 'PPL', 'P'),
(153314, 'Utica', 43.100830078125, 0.752251395205886, -75.2330627441406, -1.31306465124473, 218, 40, 'PPL', 'P'),
(158069, 'Utica', 40.2341690063477, 0.702218720964622, -82.4513931274414, -1.43904828293008, 218, 41, 'PPL', 'P'),
(168277, 'Utica', 41.4355583190918, 0.723186920070279, -79.9574966430664, -1.39552157807382, 218, 45, 'PPL', 'P'),
(171476, 'Utica', 42.9811096191406, 0.75016187901461, -97.4961090087891, -1.70162811008667, 218, 49, 'PPL', 'P'),
(176798, 'Utica', 42.9655609130859, 0.749890502899531, -89.121940612793, -1.55547129946009, 218, 57, 'PPL', 'P'),
(187939, 'Utica', 38.6438903808594, 0.674463122925762, -100.169441223145, -1.74828655922681, 218, 20, 'PPL', 'P'),
(197745, 'Utica', 46.9683303833008, 0.819752009353089, -110.091667175293, -1.92146207121863, 218, 31, 'PPL', 'P'),
(52326, 'Utica Mills Estates', 39.5291709899902, 0.689914184359156, -77.394172668457, -1.35078313492158, 218, 25, 'PPL', 'P'),
(206203, 'Utida', 41.9991683959961, 0.733023771609677, -111.97444152832, -1.95432268275106, 218, 52, 'PPL', 'P'),
(43448, 'Utility', 31.6022205352783, 0.551562799281971, -91.8886108398438, -1.60375880423903, 218, 22, 'PPL', 'P'),
(74623, 'Utley', 39.3869400024414, 0.687431785328066, -81.9100036621094, -1.42959925422442, 218, 41, 'PPL', 'P'),
(98710, 'Utley', 30.1816692352295, 0.526769501902634, -97.4205627441406, -1.70030957903098, 218, 51, 'PPL', 'P'),
(176794, 'Utley', 43.7275009155273, 0.763188864644787, -88.9061126708984, -1.55170439125623, 218, 57, 'PPL', 'P'),
(206204, 'Utley', 40.6347198486328, 0.709209651984134, -111.610000610352, -1.94796198880352, 218, 52, 'PPL', 'P'),
(91525, 'Utley (historical)', 35.7691688537598, 0.624289767199914, -88.5536117553711, -1.54555208966398, 218, 50, 'PPL', 'P'),
(38645, 'Utley Ford', 37.3280601501465, 0.651497553002545, -87.8361129760742, -1.53302937358621, 218, 21, 'PPL', 'P'),
(187478, 'Utleyville', 37.271110534668, 0.6505035947047, -103.030830383301, -1.79822722125241, 218, 7, 'PPL', 'P'),
(18415, 'Utopia', 27.2897205352783, 0.476295475289716, -82.3602828979492, -1.43745810944319, 218, 12, 'PPL', 'P'),
(34231, 'Utopia', 37.8977813720703, 0.661441064143601, -96.2238922119141, -1.67942373818203, 218, 20, 'PPL', 'P'),
(74624, 'Utopia', 38.7761116027832, 0.676770818589343, -84.0572204589844, -1.46707525708402, 218, 41, 'PPL', 'P'),
(98711, 'Utopia', 29.6149997711182, 0.516879253983379, -99.5266723632813, -1.7370681262929, 218, 51, 'PPL', 'P'),
(121783, 'Utopia', 41.8511085510254, 0.730439639824946, -87.9727783203125, -1.53541463381654, 218, 18, 'PPL', 'P'),
(153321, 'Utopia', 40.7272186279297, 0.71082406023694, -73.7869415283203, -1.28782507464573, 218, 40, 'PPL', 'P'),
(43449, 'Utopia (historical)', 29.7419395446777, 0.51909477098373, -90.5625, -1.58061380383736, 218, 22, 'PPL', 'P'),
(69744, 'Utopia Mobile Home Park', 34.7369384765625, 0.606273948478719, -77.4797210693359, -1.35227623618673, 218, 33, 'PPL', 'P'),
(176795, 'Utowana Beach', 44.2050018310547, 0.771522827802026, -88.3636093139648, -1.54223592147461, 218, 57, 'PPL', 'P'),
(209021, 'Utsalady', 48.2519416809082, 0.842155252812135, -122.475830078125, -2.13760648897639, 218, 56, 'PPL', 'P'),
(146510, 'Uttertown', 41.1266708374023, 0.717795816496604, -74.4166717529297, -1.29881594046448, 218, 37, 'PPL', 'P'),
(179419, 'Utting', 33.8388900756836, 0.590600047041112, -113.886108398438, -1.9876875638359, 218, 5, 'PPL', 'P'),
(38646, 'Uttingertown', 38.0397186279297, 0.663918336589593, -84.3694381713867, -1.47252448414848, 218, 21, 'PPL', 'P'),
(58023, 'Uva', 39.7311096191406, 0.693438678324794, -91.4530563354492, -1.59615694406545, 218, 29, 'PPL', 'P'),
(185844, 'Uva', 36.6188888549805, 0.639120178941265, -119.488891601563, -2.08547457800587, 218, 6, 'PPL', 'P'),
(209805, 'Uva', 42.1319389343262, 0.735341054653183, -104.919166564941, -1.83118490500658, 218, 59, 'PPL', 'P'),
(190865, 'Uvada (historical)', 39.6711082458496, 0.692391456805148, -114.04972076416, -1.99054313831474, 218, 39, 'PPL', 'P'),
(25673, 'Uvalda', 32.0355606079102, 0.559126010330228, -82.5083312988281, -1.44004204149084, 218, 13, 'PPL', 'P'),
(98712, 'Uvalde', 29.2094402313232, 0.509800904701085, -99.7858276367188, -1.74159123908829, 218, 51, 'PPL', 'P'),
(98713, 'Uvalde Colonia', 26.2670001983643, 0.45844563808346, -97.9769973754883, -1.71002119542011, 218, 51, 'PPL', 'P'),
(98715, 'Uvalde Estates', 29.1650009155273, 0.509025292323113, -99.8319396972656, -1.74239604636972, 218, 51, 'PPL', 'P'),
(98716, 'Uvalde Estates Colonia', 29.1639995574951, 0.509007815328459, -99.8320007324219, -1.74239711163415, 218, 51, 'PPL', 'P'),
(25674, 'Uvena', 34.4433288574219, 0.601149493909188, -83.4166717529297, -1.45589557314397, 218, 13, 'PPL', 'P'),
(111814, 'Uvilla', 39.3688888549805, 0.68711673337111, -77.8005599975586, -1.35787593185279, 218, 58, 'PPL', 'P'),
(69745, 'Uwharrie', 35.4150009155273, 0.618108370572758, -80.0038909912109, -1.39633131220326, 218, 33, 'PPL', 'P'),
(126396, 'Uxbridge', 42.077220916748, 0.73438604508628, -71.629997253418, -1.25017929526664, 218, 23, 'PPL', 'P'),
(212217, 'Uyak', 57.6377792358398, 1.00596902120303, -153.999435424805, -2.68779719437523, 218, 1, 'PPL', 'P'),
(12503, 'Uzzett (historical)', 34.8902816772461, 0.608950292216194, -91.6916732788086, -1.60032159537811, 218, 4, 'PPL', 'P'),
(69748, 'V Point', 35.9116706848145, 0.626776893341939, -80.7186126708984, -1.40880555874919, 218, 33, 'PPL', 'P'),
(12504, 'Vaby', 34.704719543457, 0.605711622014549, -91.4816665649414, -1.59665628676984, 218, 4, 'PPL', 'P'),
(185845, 'Vacation Beach', 38.4897193908691, 0.671772331539373, -123.012222290039, -2.14696829915634, 218, 6, 'PPL', 'P'),
(211128, 'Vacationland Hawaii', 19.4944400787354, 0.340242165206675, -154.823883056641, -2.70218652006104, 218, 15, 'PPL', 'P'),
(185846, 'Vacaville', 38.3566703796387, 0.669450188226878, -121.986671447754, -2.12906906031186, 218, 6, 'PPL', 'P'),
(185847, 'Vacaville Junction', 38.2955589294434, 0.668383592210301, -121.964172363281, -2.12867637720913, 218, 6, 'PPL', 'P'),
(185848, 'Vaccaro (historical)', 35.1944389343262, 0.614258837796076, -118.814437866211, -2.07370313967161, 218, 6, 'PPL', 'P'),
(43450, 'Vacherie', 30.0108299255371, 0.523787793456667, -90.7194366455078, -1.58335286501851, 218, 22, 'PPL', 'P'),
(25675, 'Vacuna (historical)', 30.7800006866455, 0.53721235574808, -81.6875, -1.42571583272287, 218, 13, 'PPL', 'P'),
(458, 'Vada', 31.0786094665527, 0.542424062132824, -84.413330078125, -1.47329054243604, 218, 13, 'PPL', 'P'),
(58024, 'Vada', 37.4716682434082, 0.654003987062473, -92.0508270263672, -1.60659001079389, 218, 29, 'PPL', 'P'),
(112362, 'Vada', 37.622501373291, 0.656636521800016, -83.5908279418945, -1.45893517205413, 218, 21, 'PPL', 'P'),
(69749, 'Vade Mecum', 36.4186096191406, 0.635624646852482, -80.3069381713867, -1.40162048328621, 218, 33, 'PPL', 'P'),
(12505, 'Vaden', 33.871940612793, 0.591176887733223, -92.9369430541992, -1.62205565303425, 218, 4, 'PPL', 'P'),
(107074, 'Vadens Mill', 36.9127807617188, 0.644249560358813, -79.3713912963867, -1.38529211001072, 218, 53, 'PPL', 'P'),
(209022, 'Vader', 46.4027786254883, 0.809881269088819, -122.959167480469, -2.14604231804532, 218, 56, 'PPL', 'P'),
(200, 'Vadis', 39.0422210693359, 0.681415304951413, -80.7024993896484, -1.40852432893808, 218, 58, 'PPL', 'P'),
(74625, 'Vadis', 39.9247207641602, 0.696817830273941, -80.8266677856445, -1.41069147627513, 218, 41, 'PPL', 'P'),
(189754, 'Vadito', 36.1911087036133, 0.631654006825228, -105.670280456543, -1.84429431547249, 218, 38, 'PPL', 'P'),
(138544, 'Vadnais Heights', 45.0574989318848, 0.786401709075217, -93.0736083984375, -1.62444091326458, 218, 28, 'PPL', 'P'),
(189755, 'Vado', 32.1116714477539, 0.56045439508196, -106.66194152832, -1.86160206623886, 218, 38, 'PPL', 'P'),
(111815, 'Vago', 37.8827781677246, 0.661179208829419, -80.3724975585938, -1.40276471044857, 218, 58, 'PPL', 'P'),
(98717, 'Vahlsing', 28.1236095428467, 0.490849584067972, -97.7997207641602, -1.70692713486566, 218, 51, 'PPL', 'P'),
(6490, 'Vaiden', 32.519718170166, 0.567576153890023, -87.3711090087891, -1.52491352332225, 218, 2, 'PPL', 'P'),
(62133, 'Vaiden', 33.3319396972656, 0.581752093793487, -89.7411117553711, -1.56627787453141, 218, 30, 'PPL', 'P'),
(12506, 'Vail', 35.8300018310547, 0.625351502947501, -90.2838897705078, -1.57575113800299, 218, 4, 'PPL', 'P'),
(118162, 'Vail', 42.061939239502, 0.734119329503109, -95.1997222900391, -1.66154860094542, 218, 16, 'PPL', 'P'),
(133487, 'Vail', 46.336669921875, 0.808727454546542, -86.7727813720703, -1.51447073605583, 218, 27, 'PPL', 'P'),
(146511, 'Vail', 40.9627799987793, 0.714935381748778, -75.0205612182617, -1.30935579995264, 218, 37, 'PPL', 'P'),
(168281, 'Vail', 40.7055587768555, 0.710446024520204, -78.2111129760742, -1.36504143308176, 218, 45, 'PPL', 'P'),
(179421, 'Vail', 32.047779083252, 0.559339262954517, -110.711387634277, -1.93227823366988, 218, 5, 'PPL', 'P'),
(187479, 'Vail', 39.6402816772461, 0.691853431685925, -106.373611450195, -1.85656975704305, 218, 7, 'PPL', 'P'),
(209023, 'Vail', 46.8452796936035, 0.817604369671022, -122.654998779297, -2.14073357272836, 218, 56, 'PPL', 'P'),
(153316, 'Vail Mills', 43.0499992370605, 0.751364229667753, -74.2183303833008, -1.29535423052154, 218, 40, 'PPL', 'P'),
(158070, 'Vails Corners', 40.3647193908691, 0.704497255014267, -82.7536087036133, -1.44432293978509, 218, 41, 'PPL', 'P'),
(153317, 'Vails Gate', 41.4541702270508, 0.723511759144241, -74.0580596923828, -1.29255697927058, 218, 40, 'PPL', 'P'),
(153318, 'Vails Gate Junction', 41.4599990844727, 0.723613491897882, -74.0619430541992, -1.29262475672032, 218, 40, 'PPL', 'P'),
(107075, 'Vails Mill', 36.6399993896484, 0.639488627278078, -81.8111114501953, -1.42787325952194, 218, 53, 'PPL', 'P'),
(179422, 'Vainom Kug', 32.0466690063477, 0.559319888457586, -112.057220458984, -1.95576744764243, 218, 5, 'PPL', 'P'),
(98718, 'Vair', 31.2808303833008, 0.545953482946479, -94.913330078125, -1.65655011389545, 218, 51, 'PPL', 'P'),
(179423, 'Vaiva Vo', 32.7177810668945, 0.571033003563973, -111.925827026367, -1.95347419962776, 218, 5, 'PPL', 'P'),
(179424, 'Vakamok', 31.7055606842041, 0.553366425130228, -112.030281066895, -1.95529726655198, 218, 5, 'PPL', 'P'),
(98719, 'Val Bar Estate Colonia', 26.2070007324219, 0.457398449853327, -98.129997253418, -1.71269154704514, 218, 51, 'PPL', 'P'),
(206208, 'Val Verda', 40.8555603027344, 0.713064045029806, -111.892219543457, -1.95288763839767, 218, 52, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(206209, 'Val Verda Condominium', 40.8588905334473, 0.713122168520597, -111.892776489258, -1.95289735893565, 218, 52, 'PPL', 'P'),
(98721, 'Val Verde', 30.8341693878174, 0.538157777935058, -97.2474975585938, -1.69728902172261, 218, 51, 'PPL', 'P'),
(185850, 'Val Verde', 33.848331451416, 0.590764830133561, -117.253059387207, -2.04645194434321, 218, 6, 'PPL', 'P'),
(189756, 'Val Verde', 33.7030601501465, 0.588229367617751, -106.930282592773, -1.86628550133188, 218, 38, 'PPL', 'P'),
(98722, 'Val Verde Acres Colonia', 26.2950000762939, 0.45893432814349, -98.2900009155273, -1.71548413776419, 218, 51, 'PPL', 'P'),
(98723, 'Val Verde Grove Colonia', 26.1720008850098, 0.45678758727829, -98.0839996337891, -1.71188873713453, 218, 51, 'PPL', 'P'),
(69, 'Val Verde North Colonia', 26.201000213623, 0.45729372104346, -98.0859985351563, -1.71192362454481, 218, 51, 'PPL', 'P'),
(192355, 'Val Verde Park', 29.374719619751, 0.512685574214831, -100.831390380859, -1.75983975150974, 218, 51, 'PPL', 'P'),
(192356, 'Val Verde Park Colonia', 29.3729991912842, 0.512655547073541, -100.838996887207, -1.75997251009008, 218, 51, 'PPL', 'P'),
(192357, 'Val Verde Park Number 2 Colonia', 29.3740005493164, 0.512673024068194, -100.827003479004, -1.7597631856284, 218, 51, 'PPL', 'P'),
(189757, 'Val Verde Ski Area', 36.5550003051758, 0.638005113392849, -105.321113586426, -1.83820020395006, 218, 38, 'PPL', 'P'),
(206211, 'Val Vista', 40.8574981689453, 0.71309786717565, -111.883331298828, -1.95273250926417, 218, 52, 'PPL', 'P'),
(179425, 'Val Vista Trailer Park', 33.6594390869141, 0.587468036441124, -112.032218933105, -1.95533108869782, 218, 5, 'PPL', 'P'),
(107076, 'Valaho (historical)', 36.8208312988281, 0.642644739485931, -82.5763931274414, -1.44122994449507, 218, 53, 'PPL', 'P'),
(206213, 'Valaire', 40.6333312988281, 0.709185417218215, -111.931106567383, -1.95356634500148, 218, 52, 'PPL', 'P'),
(153319, 'Valatie', 42.413330078125, 0.740252256598425, -73.6736068725586, -1.28584701174607, 218, 40, 'PPL', 'P'),
(153320, 'Valatie Colony', 42.4358291625977, 0.740644939701157, -73.6725006103516, -1.28582770382817, 218, 40, 'PPL', 'P'),
(201715, 'Valby', 45.3166694641113, 0.790925088186717, -119.840278625488, -2.09160743852215, 218, 43, 'PPL', 'P'),
(153330, 'Valcour', 44.6049995422363, 0.778504104862587, -73.4402770996094, -1.28177463896518, 218, 40, 'PPL', 'P'),
(168282, 'Valcourt', 41.1161117553711, 0.717611525749171, -80.1183319091797, -1.39832868302082, 218, 45, 'PPL', 'P'),
(98724, 'Valdasta', 33.2938919067383, 0.581088034575676, -96.470832824707, -1.68373366493216, 218, 51, 'PPL', 'P'),
(43452, 'Valde Rouge (historical)', 31.1222190856934, 0.543185193572368, -92.5036087036133, -1.61449254185454, 218, 22, 'PPL', 'P'),
(91527, 'Valdeau', 35.083610534668, 0.612324517317324, -85.3183288574219, -1.4890857508613, 218, 50, 'PPL', 'P'),
(176796, 'Valders', 44.0661087036133, 0.769098685419782, -87.8841705322266, -1.53386813617153, 218, 57, 'PPL', 'P'),
(69750, 'Valdese', 35.7405586242676, 0.623790424495524, -81.5633316040039, -1.42354868538582, 218, 33, 'PPL', 'P'),
(18418, 'Valdez', 28.8449993133545, 0.50344021075354, -81.3225021362305, -1.41934541823734, 218, 12, 'PPL', 'P'),
(185851, 'Valdez', 38.3261108398438, 0.668916823639563, -121.61222076416, -2.12253366299681, 218, 6, 'PPL', 'P'),
(187480, 'Valdez', 37.1222190856934, 0.647904948692028, -104.701393127441, -1.82738404149882, 218, 7, 'PPL', 'P'),
(189758, 'Valdez', 36.5344390869141, 0.637646252435961, -105.58332824707, -1.84277671312531, 218, 38, 'PPL', 'P'),
(212218, 'Valdez', 61.1308288574219, 1.06693423803518, -146.348327636719, -2.55426017204815, 218, 1, 'PPL', 'P'),
(189759, 'Valdez Place', 36.274169921875, 0.633103698564613, -104.853889465332, -1.83004560469224, 218, 38, 'PPL', 'P'),
(98725, 'Valdina Farms', 29.4941692352295, 0.514770363295173, -99.3802795410156, -1.73451308954308, 218, 51, 'PPL', 'P'),
(25676, 'Valdo (historical)', 33.2797203063965, 0.580840693489435, -84.3769378662109, -1.47265537851606, 218, 13, 'PPL', 'P'),
(118163, 'Valdora (historical)', 43.024169921875, 0.75091342307423, -91.3450012207031, -1.59427102653951, 218, 16, 'PPL', 'P'),
(6492, 'Valdosta', 34.7163887023926, 0.605915287258912, -87.7236099243164, -1.5310658249145, 218, 2, 'PPL', 'P'),
(25677, 'Valdosta', 30.8325004577637, 0.538128649610635, -83.2786102294922, -1.45348594498967, 218, 13, 'PPL', 'P'),
(52327, 'Vale', 39.5333290100098, 0.689986755498861, -76.3916702270508, -1.33328616655976, 218, 25, 'PPL', 'P'),
(58025, 'Vale', 38.9436111450195, 0.67969423709695, -94.4375, -1.64824531235215, 218, 29, 'PPL', 'P'),
(69752, 'Vale', 35.5397186279297, 0.620285105289735, -81.3974990844727, -1.42065436191312, 218, 33, 'PPL', 'P'),
(91528, 'Vale', 36.1066703796387, 0.630180280057006, -88.2588882446289, -1.54040819401849, 218, 50, 'PPL', 'P'),
(107077, 'Vale', 38.8908309936523, 0.678773049675891, -77.3486099243164, -1.34998791502008, 218, 53, 'PPL', 'P'),
(111816, 'Vale', 37.8802795410156, 0.661135599566569, -80.7219390869141, -1.40886361566096, 218, 58, 'PPL', 'P'),
(185852, 'Vale', 38.3202781677246, 0.668815024306894, -121.784439086914, -2.12553943976113, 218, 6, 'PPL', 'P'),
(201714, 'Vale', 43.9822196960449, 0.767634546031484, -117.23722076416, -2.04617550822206, 218, 43, 'PPL', 'P'),
(202713, 'Vale', 44.6202812194824, 0.778770820445759, -103.401672363281, -1.80469963480768, 218, 49, 'PPL', 'P'),
(52328, 'Vale Hills', 39.5361099243164, 0.690035291609727, -76.3891677856445, -1.33324249071788, 218, 25, 'PPL', 'P'),
(52329, 'Vale Summit', 39.6186103820801, 0.691475196232106, -78.9063873291016, -1.37717625974676, 218, 25, 'PPL', 'P'),
(34232, 'Valeda', 37.0472183227539, 0.646595938437227, -95.4472198486328, -1.66586824823353, 218, 20, 'PPL', 'P'),
(189760, 'Valedon', 32.3175010681152, 0.564046799655395, -108.744438171387, -1.8979484893221, 218, 38, 'PPL', 'P'),
(31362, 'Valeene', 38.4388885498047, 0.67088516600124, -86.397216796875, -1.50791589766482, 218, 19, 'PPL', 'P'),
(168283, 'Valemont Heights', 40.5038909912109, 0.7069262576655, -79.8147201538086, -1.39302965824183, 218, 45, 'PPL', 'P'),
(62134, 'Valena (historical)', 32.9541702270508, 0.575158772724723, -89.8833312988281, -1.56876007382542, 218, 30, 'PPL', 'P'),
(34233, 'Valencia', 39.0786094665527, 0.68205040229237, -95.876106262207, -1.67335372826747, 218, 20, 'PPL', 'P'),
(168284, 'Valencia', 40.6747207641602, 0.709907799663899, -79.9897232055664, -1.39608403769605, 218, 45, 'PPL', 'P'),
(179426, 'Valencia', 33.3794403076172, 0.582581135840829, -112.58332824707, -1.96494976076491, 218, 5, 'PPL', 'P'),
(185853, 'Valencia', 34.4436111450195, 0.601154420757205, -118.608612060547, -2.0701108016772, 218, 6, 'PPL', 'P'),
(189761, 'Valencia', 34.7994384765625, 0.607364779261215, -106.699722290039, -1.86226146492477, 218, 38, 'PPL', 'P'),
(206214, 'Valencia', 40.9077796936035, 0.713975445333858, -111.902778625488, -1.95307192914511, 218, 52, 'PPL', 'P'),
(84129, 'Valencia Heights', 33.976390838623, 0.59299988807841, -80.9852828979492, -1.41345983222827, 218, 48, 'PPL', 'P'),
(25678, 'Valencia Hill', 33.917781829834, 0.59197696790371, -84.4655609130859, -1.47420214247718, 218, 13, 'PPL', 'P'),
(6493, 'Valentine', 33.2238883972168, 0.579866242846575, -86.4705581665039, -1.50919594604276, 218, 2, 'PPL', 'P'),
(12507, 'Valentine', 34.8216705322266, 0.60775280183204, -92.1619415283203, -1.60852932469968, 218, 4, 'PPL', 'P'),
(43451, 'Valentine', 29.5944404602051, 0.516520426316004, -90.4672164916992, -1.57895079289466, 218, 22, 'PPL', 'P'),
(84130, 'Valentine', 32.8233299255371, 0.572875178669008, -81.2577819824219, -1.41821583846099, 218, 48, 'PPL', 'P'),
(123872, 'Valentine', 41.5902786254883, 0.725887298836592, -85.3869400024414, -1.49028324124546, 218, 19, 'PPL', 'P'),
(146512, 'Valentine', 40.5308303833008, 0.707396438755954, -74.3258285522461, -1.2972304275095, 218, 37, 'PPL', 'P'),
(179427, 'Valentine', 35.3875007629395, 0.617628402365299, -113.656936645508, -1.98368776219471, 218, 5, 'PPL', 'P'),
(192358, 'Valentine', 30.5872192382813, 0.53384768473736, -104.496109008789, -1.82380115772628, 218, 51, 'PPL', 'P'),
(197746, 'Valentine', 47.3116683959961, 0.825744388121876, -108.42138671875, -1.89231017782024, 218, 31, 'PPL', 'P'),
(199743, 'Valentine', 42.8727798461914, 0.748271167798708, -100.550559997559, -1.7549383366815, 218, 35, 'PPL', 'P'),
(158071, 'Valentine (historical)', 40.2222213745117, 0.702010195451269, -84.0583267211914, -1.46709456500192, 218, 41, 'PPL', 'P'),
(52330, 'Valentine Creek', 39.0513916015625, 0.681575360932927, -76.5849990844727, -1.33666039166089, 218, 25, 'PPL', 'P'),
(58026, 'Valentine Ford', 38.4113883972168, 0.670405197793781, -91.6380615234375, -1.59938589372912, 218, 29, 'PPL', 'P'),
(121784, 'Valentine Manor', 42.228328704834, 0.737023373513786, -88.1066665649414, -1.53775142451503, 218, 18, 'PPL', 'P'),
(107078, 'Valentines', 36.5883293151855, 0.63858681435395, -77.8302764892578, -1.35839458247508, 218, 53, 'PPL', 'P'),
(153322, 'Valentines Beach', 43.1938896179199, 0.753875590575698, -76.0352783203125, -1.32706595435972, 218, 40, 'PPL', 'P'),
(98726, 'Valera', 31.7527809143066, 0.554190573619066, -99.5469436645508, -1.73742192724372, 218, 51, 'PPL', 'P'),
(38648, 'Valeria', 37.8300018310547, 0.660258087987388, -83.5166702270508, -1.45764087576436, 218, 21, 'PPL', 'P'),
(118164, 'Valeria', 41.7299995422363, 0.72832588886775, -93.3249969482422, -1.62882847116049, 218, 16, 'PPL', 'P'),
(185857, 'Valerie', 33.5688896179199, 0.585887650071244, -116.179443359375, -2.02771380975536, 218, 6, 'PPL', 'P'),
(98727, 'Vales Colonia', 26.2749996185303, 0.458585254303607, -98.5660018920898, -1.72030126354393, 218, 51, 'PPL', 'P'),
(74626, 'Vales Mills', 39.1777801513672, 0.68378125726384, -82.3147201538086, -1.43666288954169, 218, 41, 'PPL', 'P'),
(62135, 'Valewood', 33.0047187805176, 0.576041011414839, -91.1111068725586, -1.59018880006258, 218, 30, 'PPL', 'P'),
(52331, 'Valewood At Hampton Gardens', 39.4186096191406, 0.687984524412312, -76.5619430541992, -1.33625798802018, 218, 25, 'PPL', 'P'),
(52332, 'Valewood Estates', 39.5377807617188, 0.690064453223664, -76.3866729736328, -1.33319894803406, 218, 25, 'PPL', 'P'),
(6494, 'Valhalla', 33.4491691589355, 0.583798133879968, -86.9266662597656, -1.51715653401517, 218, 2, 'PPL', 'P'),
(18419, 'Valhalla', 24.7416706085205, 0.431823614562592, -80.977783203125, -1.41332893786069, 218, 12, 'PPL', 'P'),
(69756, 'Valhalla', 36.1369400024414, 0.63070858463825, -76.6580581665039, -1.33793551319082, 218, 33, 'PPL', 'P'),
(153323, 'Valhalla', 41.0747184753418, 0.71688907672446, -73.7755584716797, -1.28762640282841, 218, 40, 'PPL', 'P'),
(6495, 'Valhermoso Springs', 34.5011100769043, 0.602157966434974, -86.6858291625977, -1.51295313370865, 218, 2, 'PPL', 'P'),
(28841, 'Valier', 38.0152816772461, 0.663491831341017, -89.0425033569336, -1.55408485779659, 218, 18, 'PPL', 'P'),
(168287, 'Valier', 40.915828704834, 0.71411592708136, -79.0449981689453, -1.37959547528098, 218, 45, 'PPL', 'P'),
(197747, 'Valier', 48.3077812194824, 0.84312983661305, -112.248893737793, -1.95911277744573, 218, 31, 'PPL', 'P'),
(28842, 'Valier Patch', 38.026668548584, 0.663690569737364, -89.0366668701172, -1.5539829918849, 218, 18, 'PPL', 'P'),
(185858, 'Valinda', 34.045280456543, 0.594202238731553, -117.942779541016, -2.05848983194453, 218, 6, 'PPL', 'P'),
(185859, 'Valjean', 35.5855598449707, 0.621085185460222, -116.123893737793, -2.02674428596051, 218, 6, 'PPL', 'P'),
(18420, 'Valkaria', 27.9633293151855, 0.488052166369439, -80.5438919067383, -1.405756106143, 218, 12, 'PPL', 'P'),
(185860, 'Valla', 33.9580612182617, 0.592679975852464, -118.058609008789, -2.06051143752801, 218, 6, 'PPL', 'P'),
(168288, 'Vallamont Hills', 41.2558288574219, 0.720050049201302, -77.0236129760742, -1.34431564821432, 218, 45, 'PPL', 'P'),
(179428, 'Valle', 35.6536102294922, 0.62227288872737, -112.13777923584, -1.95717346353994, 218, 5, 'PPL', 'P'),
(98728, 'Valle Alto Number 1 Colonia', 26.1040000915527, 0.455600749538496, -98.2320022583008, -1.71447187023385, 218, 51, 'PPL', 'P'),
(98729, 'Valle Alto Number 2 Colonia', 26.1009998321533, 0.455548385133563, -98.2320022583008, -1.71447187023385, 218, 51, 'PPL', 'P'),
(69754, 'Valle Crucis', 36.209171295166, 0.631969258519267, -81.7786102294922, -1.42730600620975, 218, 33, 'PPL', 'P'),
(185867, 'Valle de los Caballos', 33.5252799987793, 0.585126518631699, -117.040000915527, -2.04273337251313, 218, 6, 'PPL', 'P'),
(98740, 'Valle de Palmas Number 1 Colonia', 26.173999786377, 0.45682247468857, -97.9039993286133, -1.70874713915462, 218, 51, 'PPL', 'P'),
(189763, 'Valle Escondido', 36.3663902282715, 0.63471324654843, -105.380279541016, -1.83923284466274, 218, 38, 'PPL', 'P'),
(98730, 'Valle Escondido Colonia', 25.8759994506836, 0.451621387658673, -97.3840026855469, -1.69967148563379, 218, 51, 'PPL', 'P'),
(206217, 'Valle Grande Condominium', 41.2408294677734, 0.719788260466147, -111.950561523438, -1.95390589804046, 218, 52, 'PPL', 'P'),
(206218, 'Valle Grande East Condominium', 41.2394409179688, 0.719764025700227, -111.948890686035, -1.95387673642653, 218, 52, 'PPL', 'P'),
(98732, 'Valle Hermosa Colonia', 26.3810005187988, 0.460435319023372, -98.7870025634766, -1.72415845290874, 218, 51, 'PPL', 'P'),
(98733, 'Valle Hermoso Estates Colonia', 26.3229999542236, 0.459423018203519, -98.2559967041016, -1.71489065231527, 218, 51, 'PPL', 'P'),
(192359, 'Valle Real Colonia', 31.6070003509521, 0.551646222803118, -106.277000427246, -1.85488357659886, 218, 51, 'PPL', 'P'),
(98736, 'Valle Verde Colonia', 27.048999786377, 0.472094105643521, -99.4339981079102, -1.73545065540484, 218, 51, 'PPL', 'P'),
(192360, 'Valle Villa Addition Colonia', 31.5949993133545, 0.551436765183383, -106.271003723145, -1.85477891436802, 218, 51, 'PPL', 'P'),
(192361, 'Valle Villa Addition Number 2 Colonia', 31.5970001220703, 0.551471685883177, -106.271003723145, -1.85477891436802, 218, 51, 'PPL', 'P'),
(185866, 'Valle Vista', 33.7477798461914, 0.589009873554226, -116.892501831055, -2.0401590278454, 218, 6, 'PPL', 'P'),
(98737, 'Valle Vista Colonia', 26.3080005645752, 0.459161229468364, -98.5579986572266, -1.72016158074475, 218, 51, 'PPL', 'P'),
(98738, 'Valle Vista Number 1 Colonia', 26.3150005340576, 0.459283401983372, -98.6559982299805, -1.72187199595486, 218, 51, 'PPL', 'P'),
(98739, 'Valle Vista Number 2 Colonia', 26.3169994354248, 0.459318289393652, -98.6549987792969, -1.72185455224972, 218, 51, 'PPL', 'P'),
(185868, 'Vallecito', 38.0902786254883, 0.664800775016791, -120.472503662109, -2.10264184702474, 218, 6, 'PPL', 'P'),
(187481, 'Vallecito', 37.3752784729004, 0.65232166820187, -107.58332824707, -1.8776832981652, 218, 7, 'PPL', 'P'),
(189764, 'Vallecito', 36.1575012207031, 0.631067445595138, -105.783889770508, -1.84627717206211, 218, 38, 'PPL', 'P'),
(189768, 'Vallecitos', 36.2566719055176, 0.632798300566608, -105.608062744141, -1.84320841153801, 218, 38, 'PPL', 'P'),
(189769, 'Vallecitos Corrales', 36.0666694641113, 0.629482132377241, -106.355560302734, -1.85625470508609, 218, 38, 'PPL', 'P'),
(185869, 'Vallejo', 38.1041717529297, 0.665043255834042, -122.255561828613, -2.1337620827848, 218, 6, 'PPL', 'P'),
(185873, 'Vallemar', 37.6136093139648, 0.656481326087492, -122.479721069336, -2.13767439958418, 218, 6, 'PPL', 'P'),
(126398, 'Vallersville', 41.8699989318848, 0.730769339167898, -70.5361099243164, -1.23108735972797, 218, 23, 'PPL', 'P'),
(58028, 'Valles Mines', 38.0419387817383, 0.663957085583453, -90.4997177124023, -1.57951804620685, 218, 29, 'PPL', 'P'),
(185870, 'Valleton', 35.8894386291504, 0.626388870771114, -120.704719543457, -2.10669477872967, 218, 6, 'PPL', 'P'),
(6497, 'Valley', 32.8186111450195, 0.572792820412297, -85.179443359375, -1.48666174163711, 218, 2, 'PPL', 'P'),
(38647, 'Valley', 38.1061096191406, 0.665077077979886, -85.8622207641602, -1.49857845540884, 218, 21, 'PPL', 'P'),
(62137, 'Valley', 32.7597198486328, 0.571764973389581, -90.4802780151367, -1.57917875948398, 218, 30, 'PPL', 'P'),
(69755, 'Valley', 36.0844383239746, 0.629792257486181, -82.041389465332, -1.43189236908103, 218, 33, 'PPL', 'P'),
(143256, 'Valley', 41.3127784729004, 0.721044007499147, -96.345832824707, -1.68155200336717, 218, 35, 'PPL', 'P'),
(146513, 'Valley', 40.6672210693359, 0.709776905296321, -75.0325012207031, -1.30956419230793, 218, 37, 'PPL', 'P'),
(158072, 'Valley', 40.8655586242676, 0.713238548660234, -80.9483337402344, -1.41281494777031, 218, 41, 'PPL', 'P'),
(176799, 'Valley', 43.6416702270508, 0.761690836531617, -90.5416717529297, -1.58025028234857, 218, 57, 'PPL', 'P'),
(190866, 'Valley', 36.274169921875, 0.633103698564613, -115.070556640625, -2.00836008548153, 218, 39, 'PPL', 'P'),
(209024, 'Valley', 48.1752815246582, 0.840817280680479, -117.723609924316, -2.05466460051279, 218, 56, 'PPL', 'P'),
(197748, 'Valley (historical)', 46.023609161377, 0.803263513517054, -112.116668701172, -1.95680501520312, 218, 31, 'PPL', 'P'),
(107079, 'Valley Acres', 39.1416702270508, 0.683151020191873, -78.2041702270508, -1.36492025925216, 218, 53, 'PPL', 'P'),
(185871, 'Valley Acres', 35.2061080932617, 0.61446250304044, -119.405830383301, -2.08402488626648, 218, 6, 'PPL', 'P'),
(52333, 'Valley Anne Estates', 39.3216705322266, 0.686292618171785, -76.8777770996094, -1.34177033200248, 218, 25, 'PPL', 'P'),
(111817, 'Valley Bend', 39.0616683959961, 0.681754724832344, -79.9716720581055, -1.39576898573909, 218, 58, 'PPL', 'P'),
(52334, 'Valley Brook', 39.4333305358887, 0.688241452878477, -76.7194366455078, -1.33900676973931, 218, 25, 'PPL', 'P'),
(77534, 'Valley Brook', 35.4019393920898, 0.617880403983448, -97.4811096191406, -1.70136632135152, 218, 42, 'PPL', 'P'),
(107080, 'Valley Brook', 38.8497200012207, 0.678055527499197, -77.1855621337891, -1.34714219423728, 218, 53, 'PPL', 'P'),
(113062, 'Valley Brook', 40.8055610656738, 0.712191393719614, -85.8444366455078, -1.49826806398379, 218, 19, 'PPL', 'P'),
(153324, 'Valley Brook', 42.9288902282715, 0.749250478710558, -74.6594390869141, -1.3030530297588, 218, 40, 'PPL', 'P'),
(111819, 'Valley Brook Mobile Home Park', 38.4466705322266, 0.671020987216834, -81.8236083984375, -1.42809137241522, 218, 58, 'PPL', 'P'),
(168289, 'Valley Camp', 40.5852813720703, 0.708346787790949, -79.7666702270508, -1.39219102881457, 218, 45, 'PPL', 'P'),
(177286, 'Valley Camp', 40.0644416809082, 0.699256420305099, -80.607780456543, -1.40687117169141, 218, 58, 'PPL', 'P'),
(34235, 'Valley Center', 37.8347206115723, 0.660340446244099, -97.3730621337891, -1.69948053698363, 218, 20, 'PPL', 'P'),
(133488, 'Valley Center', 43.185001373291, 0.753720461442201, -82.9186096191406, -1.44720274902985, 218, 27, 'PPL', 'P'),
(185872, 'Valley Center', 33.2183303833008, 0.579769237203869, -117.033332824707, -2.04261699237349, 218, 6, 'PPL', 'P'),
(111820, 'Valley Chapel', 39.1097183227539, 0.68259335425961, -80.4947204589844, -1.40489790248172, 218, 58, 'PPL', 'P'),
(494, 'Valley City', 38.0938911437988, 0.664863825355598, -86.2227783203125, -1.50487137190664, 218, 19, 'PPL', 'P'),
(28843, 'Valley City', 39.7069396972656, 0.693016833608126, -90.6524963378906, -1.58218453624829, 218, 18, 'PPL', 'P'),
(58029, 'Valley City', 38.8655586242676, 0.678331963620347, -93.6116714477539, -1.63383188505847, 218, 29, 'PPL', 'P'),
(140994, 'Valley City', 46.9233283996582, 0.818966576568597, -98.0027770996094, -1.71047113648628, 218, 34, 'PPL', 'P'),
(158073, 'Valley City', 41.2377815246582, 0.719735063823373, -81.9316711425781, -1.42997742309921, 218, 41, 'PPL', 'P'),
(143257, 'Valley City (historical)', 40.6472206115723, 0.709427831456439, -98.8666687011719, -1.72554888931388, 218, 35, 'PPL', 'P'),
(158074, 'Valley City Station', 41.2383308410645, 0.719744651203297, -81.9008331298828, -1.42943919824291, 218, 41, 'PPL', 'P'),
(168290, 'Valley Corners', 41.9872207641602, 0.732815246096324, -79.8938903808594, -1.39441143937342, 218, 45, 'PPL', 'P'),
(153325, 'Valley Cottage', 41.1180610656738, 0.717645547632097, -73.9558334350586, -1.29077279449828, 218, 40, 'PPL', 'P'),
(138546, 'Valley Courts', 44.8052787780762, 0.781999636951371, -95.5466690063477, -1.66760396347399, 218, 28, 'PPL', 'P'),
(6498, 'Valley Creek', 33.3875007629395, 0.582721817325412, -87.0722198486328, -1.519696923379, 218, 2, 'PPL', 'P'),
(69770, 'Valley Creek', 36.144718170166, 0.630844339274817, -81.7988891601563, -1.42765994031863, 218, 33, 'PPL', 'P'),
(91529, 'Valley Creek', 36.5719413757324, 0.638300790852875, -83.9119415283203, -1.46453966141015, 218, 50, 'PPL', 'P'),
(121785, 'Valley Creek (historical)', 42.2588882446289, 0.737556738101101, -89.5425033569336, -1.56281150405657, 218, 18, 'PPL', 'P'),
(6499, 'Valley Creek Junction', 32.5683288574219, 0.568424570434295, -86.9488906860352, -1.51754442342794, 218, 2, 'PPL', 'P'),
(52335, 'Valley Crest', 39.4363899230957, 0.688294849258333, -76.601936340332, -1.33695600254189, 218, 25, 'PPL', 'P'),
(206222, 'Valley Crest Estates', 40.6027793884277, 0.708652185788954, -111.876388549805, -1.95261133543458, 218, 52, 'PPL', 'P'),
(74627, 'Valley Crossing', 39.8888893127441, 0.696192453470963, -82.9491729736328, -1.44773618019619, 218, 41, 'PPL', 'P'),
(185874, 'Valley Crossing', 38.6997184753418, 0.675437506989594, -123.412498474121, -2.15395443648589, 218, 6, 'PPL', 'P'),
(84132, 'Valley Dale Park', 34.8888893127441, 0.608925990871247, -82.0250015258789, -1.43160634557996, 218, 48, 'PPL', 'P'),
(38649, 'Valley Downs', 38.1138916015625, 0.66521289919548, -85.8730621337891, -1.49876767300429, 218, 21, 'PPL', 'P'),
(197750, 'Valley Drive Mobile Home Park', 46.4180603027344, 0.810147984671991, -105.825828552246, -1.84700914188772, 218, 31, 'PPL', 'P'),
(6501, 'Valley Estates', 31.5494403839111, 0.550641611860913, -87.2983322143555, -1.52364332864034, 218, 2, 'PPL', 'P'),
(206226, 'Valley Fair Estates', 40.6505584716797, 0.709486088105285, -111.861106872559, -1.9523446198514, 218, 52, 'PPL', 'P'),
(34238, 'Valley Falls', 39.3433303833008, 0.686670653888521, -95.4599990844727, -1.66609128797482, 218, 20, 'PPL', 'P'),
(84133, 'Valley Falls', 35.0158309936523, 0.611141541161111, -81.9749984741211, -1.43073362769074, 218, 48, 'PPL', 'P'),
(111821, 'Valley Falls', 39.3894386291504, 0.687475394590916, -80.0877838134766, -1.39779551817059, 218, 58, 'PPL', 'P'),
(153326, 'Valley Falls', 42.9033317565918, 0.748804399227969, -73.5630569458008, -1.28391755153631, 218, 40, 'PPL', 'P'),
(168291, 'Valley Falls', 40.1116714477539, 0.700080735241506, -75.0550003051758, -1.30995687541067, 218, 45, 'PPL', 'P'),
(169642, 'Valley Falls', 41.9066696166992, 0.731409363356871, -71.39111328125, -1.24600998342207, 218, 47, 'PPL', 'P'),
(201719, 'Valley Falls', 42.4841690063477, 0.741488629134494, -120.280830383301, -2.09929651722143, 218, 43, 'PPL', 'P'),
(126399, 'Valley Falls (historical)', 42.2397193908691, 0.73722217848916, -71.8561096191406, -1.25412570052797, 218, 23, 'PPL', 'P'),
(98741, 'Valley Farms', 32.3077812194824, 0.563877156293957, -96.4052810668945, -1.68258957092786, 218, 51, 'PPL', 'P'),
(133489, 'Valley Farms', 42.7841682434082, 0.746724603574672, -84.5427780151367, -1.47554983514681, 218, 27, 'PPL', 'P'),
(179429, 'Valley Farms', 32.9883308410645, 0.575754987913765, -111.446670532227, -1.94511134117269, 218, 5, 'PPL', 'P'),
(74628, 'Valley Ford', 39.1666717529297, 0.683587379136482, -82.2447204589844, -1.43544116439162, 218, 41, 'PPL', 'P'),
(185875, 'Valley Ford', 38.3180618286133, 0.668776341892061, -122.923057556152, -2.14541208097335, 218, 6, 'PPL', 'P'),
(25679, 'Valley Forest', 33.5849990844727, 0.586168813303329, -84.4574966430664, -1.47406139441357, 218, 13, 'PPL', 'P'),
(25680, 'Valley Forge', 33.3930587768555, 0.582818822968118, -82.0355606079102, -1.43179063632739, 218, 13, 'PPL', 'P'),
(91530, 'Valley Forge', 36.3063888549805, 0.633666025028783, -82.1933288574219, -1.43454421173648, 218, 50, 'PPL', 'P'),
(168292, 'Valley Forge', 40.0969390869141, 0.699823607038259, -75.4700012207031, -1.31720000778541, 218, 45, 'PPL', 'P'),
(58030, 'Valley Forge (historical)', 37.7852783203125, 0.659477515471886, -90.3733291625977, -1.57731214987594, 218, 29, 'PPL', 'P'),
(168293, 'Valley Forge Acres', 40.0833282470703, 0.699586053069024, -75.3649978637695, -1.31536735348127, 218, 45, 'PPL', 'P'),
(168294, 'Valley Forge Homes', 40.0883293151855, 0.699673338173751, -75.3733291625977, -1.31551276207679, 218, 45, 'PPL', 'P'),
(168295, 'Valley Forge Trailer Park', 40.103328704834, 0.699935126908906, -75.4250030517578, -1.31641464157994, 218, 45, 'PPL', 'P'),
(111822, 'Valley Fork', 38.5250015258789, 0.672388120962426, -81.1180572509766, -1.4157771818508, 218, 58, 'PPL', 'P'),
(107081, 'Valley Front (historical)', 37.3977813720703, 0.652714417883629, -76.6166687011719, -1.33721313074514, 218, 53, 'PPL', 'P'),
(111823, 'Valley Furnace', 39.1949996948242, 0.684081794992855, -79.8769378662109, -1.39411556217631, 218, 58, 'PPL', 'P'),
(38650, 'Valley Gardens', 38.1177787780762, 0.66528074322425, -85.8724975585938, -1.49875781930825, 218, 21, 'PPL', 'P'),
(179430, 'Valley Gardens Trailer Park', 33.4500007629395, 0.583812648107909, -112.005561828613, -1.95486583445538, 218, 5, 'PPL', 'P'),
(158075, 'Valley Glen', 40.3088912963867, 0.703522870950434, -80.6855621337891, -1.40822871805708, 218, 41, 'PPL', 'P'),
(168299, 'Valley Glenn', 40.3450012207031, 0.704153108022401, -76.6161117553711, -1.33720341020716, 218, 45, 'PPL', 'P'),
(6503, 'Valley Grande', 32.5088882446289, 0.567387136031654, -86.9875030517578, -1.51821833634179, 218, 2, 'PPL', 'P'),
(168297, 'Valley Green', 40.1572189331055, 0.700875688826895, -76.7930603027344, -1.34029174496527, 218, 45, 'PPL', 'P'),
(168298, 'Valley Green Estates', 40.149169921875, 0.700735207079393, -76.7888870239258, -1.34021890750945, 218, 45, 'PPL', 'P'),
(206227, 'Valley Green Estates', 41.2174987792969, 0.719381063135474, -112.077781677246, -1.95612630859932, 218, 52, 'PPL', 'P'),
(6504, 'Valley Grove', 34.7000007629395, 0.605629263757838, -87.6125030517578, -1.52912664416675, 218, 2, 'PPL', 'P'),
(91533, 'Valley Grove', 35.8927803039551, 0.626447193998987, -83.7958297729492, -1.46251312897866, 218, 50, 'PPL', 'P'),
(98742, 'Valley Grove', 31.8788890838623, 0.556391576391476, -94.8083267211914, -1.65471745959131, 218, 51, 'PPL', 'P'),
(177287, 'Valley Grove', 40.0875015258789, 0.699658890524838, -80.570556640625, -1.40622149354349, 218, 58, 'PPL', 'P'),
(209028, 'Valley Grove', 46.1525001525879, 0.805513085689844, -118.347778320313, -2.06555839410982, 218, 56, 'PPL', 'P'),
(84134, 'Valley Haven', 34.9738883972168, 0.610409504756475, -82.2622222900391, -1.43574662896865, 218, 48, 'PPL', 'P'),
(6505, 'Valley Head', 34.5688896179199, 0.603340942591187, -85.6149978637695, -1.49426360181069, 218, 2, 'PPL', 'P'),
(25681, 'Valley Head', 34.7416687011719, 0.606356506472511, -85.334716796875, -1.48937177436238, 218, 13, 'PPL', 'P'),
(111824, 'Valley Head', 38.5449981689453, 0.672737128223281, -80.0361099243164, -1.39689363866743, 218, 58, 'PPL', 'P'),
(52337, 'Valley Heights', 39.4013900756836, 0.687683986683296, -77.5111083984375, -1.35282404842296, 218, 25, 'PPL', 'P'),
(111825, 'Valley Heights', 37.6922187805176, 0.657853320102074, -80.7161102294922, -1.40876188290731, 218, 58, 'PPL', 'P'),
(206228, 'Valley Heights Twin Home Condo', 40.6605606079102, 0.709660658314739, -111.975830078125, -1.95434691751698, 218, 52, 'PPL', 'P'),
(98743, 'Valley Hi', 29.3733291625977, 0.512661306159398, -98.6391677856445, -1.72157824928662, 218, 51, 'PPL', 'P'),
(158076, 'Valley Hi', 40.3125, 0.703585854710214, -83.6833267211914, -1.46054958030694, 218, 41, 'PPL', 'P'),
(38651, 'Valley Hill', 37.7508316040039, 0.6588763068558, -85.2622222900391, -1.48810650652848, 218, 21, 'PPL', 'P'),
(62138, 'Valley Hill', 33.5041694641113, 0.584758070294887, -90.0611114501953, -1.57186292281147, 218, 30, 'PPL', 'P'),
(69758, 'Valley Hill', 35.2983283996582, 0.616072051024257, -82.4833297729492, -1.43960568254623, 218, 33, 'PPL', 'P'),
(25682, 'Valley Hill Estates', 34.0088882446289, 0.593567074811569, -84.6552810668945, -1.47751338381853, 218, 13, 'PPL', 'P'),
(52338, 'Valley Hill Farms', 39.4355583190918, 0.688280335030392, -77.0919418334961, -1.34550821175046, 218, 25, 'PPL', 'P'),
(43453, 'Valley Hills', 32.5269393920898, 0.567702187988611, -92.2324981689453, -1.60976077038774, 218, 22, 'PPL', 'P'),
(52339, 'Valley Hills', 39.4599990844727, 0.688706906857996, -76.7594375610352, -1.33970491741907, 218, 25, 'PPL', 'P'),
(91535, 'Valley Home', 35.2805595397949, 0.615761925915317, -85.8611068725586, -1.49855901433288, 218, 50, 'PPL', 'P'),
(185878, 'Valley Home', 37.8288917541504, 0.660238713490458, -120.911109924316, -2.11029697042011, 218, 6, 'PPL', 'P'),
(133490, 'Valley Island', 43.7922210693359, 0.764318444421144, -83.4280624389648, -1.45609437811935, 218, 27, 'PPL', 'P'),
(6507, 'Valley Junction', 33.077220916748, 0.577306412406791, -86.8258285522461, -1.5153965840088, 218, 2, 'PPL', 'P'),
(12508, 'Valley Junction', 33.4452781677246, 0.583730223272171, -91.7936096191406, -1.60210072014434, 218, 4, 'PPL', 'P'),
(79316, 'Valley Junction', 39.8113899230957, 0.694839833953312, -76.8730621337891, -1.3416880403248, 218, 45, 'PPL', 'P'),
(98744, 'Valley Junction', 30.8416690826416, 0.538288672302635, -96.6374969482422, -1.6866425026328, 218, 51, 'PPL', 'P'),
(118165, 'Valley Junction', 41.5691719055176, 0.725518917078807, -93.7094421386719, -1.63553830552694, 218, 16, 'PPL', 'P'),
(158078, 'Valley Junction', 40.5844383239746, 0.708332073825926, -81.3847198486328, -1.42043132217182, 218, 41, 'PPL', 'P'),
(176800, 'Valley Junction', 44.0533294677734, 0.768875645678488, -90.4122161865234, -1.57799085647975, 218, 57, 'PPL', 'P'),
(201716, 'Valley Junction', 45.0622215270996, 0.786484133910955, -123.570831298828, -2.15671786559101, 218, 43, 'PPL', 'P'),
(206232, 'Valley Lake Estates', 41.2477798461914, 0.7199095674538, -111.785003662109, -1.95101636825773, 218, 52, 'PPL', 'P'),
(185879, 'Valley Lake Ranchos', 37.0613899230957, 0.646843279523468, -120.014717102051, -2.09465196428033, 218, 6, 'PPL', 'P'),
(52341, 'Valley Lee', 38.1958312988281, 0.666643016700853, -76.5130615234375, -1.33540484436497, 218, 25, 'PPL', 'P'),
(111828, 'Valley Manor Addition', 39.3691711425781, 0.687121660219126, -81.4813919067383, -1.42211856788044, 218, 58, 'PPL', 'P'),
(52342, 'Valley Meade', 39.2836112976074, 0.685628359216892, -76.8477783203125, -1.34124675453217, 218, 25, 'PPL', 'P'),
(52343, 'Valley Mill', 39.6733283996582, 0.692430205799008, -76.6927795410156, -1.33854151549687, 218, 25, 'PPL', 'P'),
(107083, 'Valley Mill', 37.3791694641113, 0.652389578809667, -80.3480606079102, -1.40233820519999, 218, 53, 'PPL', 'P'),
(52344, 'Valley Mill Farms', 39.6655616760254, 0.692294650899523, -76.6930618286133, -1.33854644234489, 218, 25, 'PPL', 'P'),
(31363, 'Valley Mills', 39.6911087036133, 0.69274053064503, -86.2772216796875, -1.50582158778358, 218, 19, 'PPL', 'P'),
(62139, 'Valley Mills', 32.389720916748, 0.56530727379933, -90.8583297729492, -1.58577700740076, 218, 30, 'PPL', 'P'),
(98745, 'Valley Mills', 31.6591701507568, 0.552556757579816, -97.4719390869141, -1.70120626537001, 218, 51, 'PPL', 'P'),
(111829, 'Valley Mills', 39.3177795410156, 0.686224707563988, -81.4433288574219, -1.42145424234652, 218, 58, 'PPL', 'P'),
(153327, 'Valley Mills', 43.0119400024414, 0.75069997071286, -75.5899963378906, -1.31929431766665, 218, 40, 'PPL', 'P'),
(28844, 'Valley Mission', 37.3580589294434, 0.652021130472855, -89.3391723632813, -1.55926270874598, 218, 18, 'PPL', 'P'),
(114203, 'Valley Mobile Home Park', 41.4708290100098, 0.723802509756251, -73.0052795410156, -1.27418249932958, 218, 8, 'PPL', 'P'),
(179431, 'Valley Mobile Homes Estate', 33.3175010681152, 0.581500092175338, -111.837501525879, -1.95193262883077, 218, 5, 'PPL', 'P'),
(52345, 'Valley North', 39.4894409179688, 0.689220763790327, -76.5400009155273, -1.33587502545543, 218, 25, 'PPL', 'P'),
(38652, 'Valley Oak', 37.1891708374023, 0.649073477199328, -84.4722213745117, -1.47431838945876, 218, 21, 'PPL', 'P'),
(69759, 'Valley Oaks', 36.0352783203125, 0.628934253561985, -80.4583282470703, -1.40426273856173, 218, 33, 'PPL', 'P'),
(107084, 'Valley Oaks', 37.6027793884277, 0.656292308229124, -77.254997253418, -1.34835406569132, 218, 53, 'PPL', 'P'),
(185880, 'Valley Oaks Mobile Home Park', 39.4119415283203, 0.687868144272675, -123.313606262207, -2.15222844178341, 218, 6, 'PPL', 'P'),
(185887, 'Valley of Enchantment', 34.2466697692871, 0.597717145317267, -117.303886413574, -2.04733904330231, 218, 6, 'PPL', 'P'),
(6515, 'Valley of Shiloh', 31.4158306121826, 0.548309681431412, -86.466667175293, -1.50912803543497, 218, 2, 'PPL', 'P'),
(123873, 'Valley Outlet Center', 41.7286109924316, 0.728301654101831, -85.003059387207, -1.48358326057504, 218, 19, 'PPL', 'P'),
(52346, 'Valley Overlook', 39.4205589294434, 0.688018546295238, -77.5808334350586, -1.35404097988307, 218, 25, 'PPL', 'P'),
(179432, 'Valley Palms Mobile Home Park', 33.4144401550293, 0.583191998415866, -111.620826721191, -1.94815094008286, 218, 5, 'PPL', 'P'),
(25685, 'Valley Park', 33.4655609130859, 0.58408422396007, -82.0580596923828, -1.43218331943013, 218, 13, 'PPL', 'P'),
(58031, 'Valley Park', 38.5491714477539, 0.672809965679095, -90.4925003051758, -1.57939207868729, 218, 29, 'PPL', 'P'),
(62140, 'Valley Park', 32.6333312988281, 0.569559077058668, -90.8666687011719, -1.58592254915433, 218, 30, 'PPL', 'P'),
(77535, 'Valley Park', 36.292781829834, 0.633428537638575, -95.7372207641602, -1.67092971904328, 218, 42, 'PPL', 'P'),
(91536, 'Valley Park', 36.3430595397949, 0.634306049217757, -82.1999969482422, -1.43466059187612, 218, 50, 'PPL', 'P'),
(206233, 'Valley Park', 40.6511116027832, 0.709495742064236, -111.948608398438, -1.95387180957851, 218, 52, 'PPL', 'P'),
(111830, 'Valley Point', 39.5800018310547, 0.690801349897289, -79.6369400024414, -1.38992680925578, 218, 58, 'PPL', 'P'),
(153328, 'Valley Pond Estates', 41.3088912963867, 0.720976163470377, -73.7233276367188, -1.28671480278727, 218, 40, 'PPL', 'P'),
(185881, 'Valley Ranch', 39.7377815246582, 0.693555125043458, -120.565002441406, -2.10425625527754, 218, 6, 'PPL', 'P'),
(98746, 'Valley Rancheros Colonia', 26.3279991149902, 0.459510270018733, -98.338996887207, -1.71633927879022, 218, 51, 'PPL', 'P'),
(58032, 'Valley Ridge', 36.5647201538086, 0.638174756754287, -90.083610534668, -1.57225560591421, 218, 29, 'PPL', 'P'),
(98747, 'Valley Ridge', 32.5872192382813, 0.568754269777246, -97.2413864135742, -1.69718236212095, 218, 51, 'PPL', 'P'),
(12509, 'Valley Ridge (historical)', 34.2177810668945, 0.597212942343888, -94.2211074829102, -1.64446855045225, 218, 4, 'PPL', 'P'),
(14776, 'Valley Run', 39.8177795410156, 0.694951353823959, -75.4705581665039, -1.31720972832339, 218, 10, 'PPL', 'P'),
(98748, 'Valley Spring', 30.8591709136963, 0.538594136879667, -98.8169403076172, -1.72468096511462, 218, 51, 'PPL', 'P'),
(12510, 'Valley Springs', 36.1575012207031, 0.631067445595138, -92.9927825927734, -1.62303023683517, 218, 4, 'PPL', 'P'),
(69760, 'Valley Springs', 35.5127792358398, 0.619814924199281, -82.521110534668, -1.44026508123213, 218, 33, 'PPL', 'P'),
(171479, 'Valley Springs', 43.5825004577637, 0.760658129239912, -96.4674987792969, -1.68367547486234, 218, 49, 'PPL', 'P'),
(185882, 'Valley Springs', 38.1916694641113, 0.666570378982121, -120.828056335449, -2.10884741183878, 218, 6, 'PPL', 'P'),
(158079, 'Valley Springs Addition', 41.4902801513672, 0.724141996216209, -84.7477798461914, -1.47912779207133, 218, 41, 'PPL', 'P'),
(98749, 'Valley Star Acres Colonia', 26.2430000305176, 0.458026756133504, -98.1309967041016, -1.71270899075028, 218, 51, 'PPL', 'P'),
(38660, 'Valley Station', 38.1111106872559, 0.665164363084614, -85.8702774047852, -1.49871907031439, 218, 21, 'PPL', 'P'),
(52347, 'Valley Stream', 39.3766708374023, 0.687252554586704, -76.6861114501953, -1.33842513535723, 218, 25, 'PPL', 'P'),
(153329, 'Valley Stream', 40.6641693115234, 0.70972364207452, -73.7088928222656, -1.28646286774815, 218, 40, 'PPL', 'P'),
(52348, 'Valley Stream Estates', 39.1080589294434, 0.682564392382755, -76.9222183227539, -1.34254597766997, 218, 25, 'PPL', 'P'),
(168300, 'Valley Stream Estates', 40.2099990844727, 0.701796876247953, -77.0299987792969, -1.34442710150594, 218, 45, 'PPL', 'P'),
(206239, 'Valley Terrace Condominium', 41.2333297729492, 0.71965736609857, -111.945281982422, -1.95381375266675, 218, 52, 'PPL', 'P'),
(6510, 'Valley View', 34.4672203063965, 0.601566478356867, -86.940559387207, -1.51739901483243, 218, 2, 'PPL', 'P'),
(12511, 'Valley View', 35.7797203063965, 0.624473924789293, -90.7427825927734, -1.58376032866529, 218, 4, 'PPL', 'P'),
(14777, 'Valley View', 39.7972183227539, 0.694592492867071, -75.6777801513672, -1.32082643424177, 218, 10, 'PPL', 'P'),
(25689, 'Valley View', 34.922779083252, 0.609517478949353, -85.3513870239258, -1.48966272471147, 218, 13, 'PPL', 'P'),
(38653, 'Valley View', 37.8461112976074, 0.660539251219473, -84.4305572509766, -1.47359121332311, 218, 21, 'PPL', 'P'),
(52355, 'Valley View', 38.7344398498535, 0.676043509295642, -76.9741668701172, -1.34345265086308, 218, 25, 'PPL', 'P'),
(58034, 'Valley View', 38.0519409179688, 0.664131655792908, -90.2755584716797, -1.57560572940747, 218, 29, 'PPL', 'P'),
(69763, 'Valley View', 36.1533317565918, 0.630994674718352, -80.3180618286133, -1.40181462772968, 218, 33, 'PPL', 'P'),
(84136, 'Valley View', 34.6527786254883, 0.604805081979486, -82.8808288574219, -1.44654335034394, 218, 48, 'PPL', 'P'),
(91537, 'Valley View', 36.0280609130859, 0.628808286042424, -84.1486129760742, -1.46867035741892, 218, 50, 'PPL', 'P'),
(107089, 'Valley View', 37.3180618286133, 0.651323049372118, -79.9499969482422, -1.39539068370624, 218, 53, 'PPL', 'P'),
(121787, 'Valley View', 41.9661102294922, 0.732446797759512, -88.2988891601563, -1.54110634169826, 218, 18, 'PPL', 'P'),
(126400, 'Valley View', 42.1222190856934, 0.735171411291745, -71.4749984741211, -1.24747405623134, 218, 23, 'PPL', 'P'),
(153331, 'Valley View', 42.7391700744629, 0.745939237369208, -77.2561111450195, -1.34837350676728, 218, 40, 'PPL', 'P'),
(158081, 'Valley View', 40.355281829834, 0.704332538500845, -80.7644424438477, -1.4096054391826, 218, 41, 'PPL', 'P'),
(168303, 'Valley View', 40.6458282470703, 0.709403530111492, -76.539436340332, -1.33586517175939, 218, 45, 'PPL', 'P'),
(179434, 'Valley View', 32.3183288574219, 0.564061247304309, -110.967216491699, -1.9367432895535, 218, 5, 'PPL', 'P'),
(187482, 'Valley View', 38.0683288574219, 0.664417679293983, -104.976387023926, -1.83218359041536, 218, 7, 'PPL', 'P'),
(190867, 'Valley View', 38.0683288574219, 0.664417679293983, -117.223609924316, -2.04593795425282, 218, 39, 'PPL', 'P'),
(192364, 'Valley View', 31.7928009033203, 0.554889054193967, -100.027183532715, -1.74580369414253, 218, 51, 'PPL', 'P'),
(74632, 'Valley View (historical)', 39.2425003051758, 0.684910837040197, -84.706672668457, -1.47841033647367, 218, 41, 'PPL', 'P'),
(190868, 'Valley View (historical)', 38.8641700744629, 0.678307728854427, -119.801109313965, -2.09092380507033, 218, 39, 'PPL', 'P'),
(111831, 'Valley View Acres', 39.211109161377, 0.68436295822494, -81.4958267211914, -1.42237050291957, 218, 58, 'PPL', 'P'),
(168304, 'Valley View Acres', 40.2538909912109, 0.702562934535515, -76.6433334350586, -1.33767851814563, 218, 45, 'PPL', 'P'),
(197751, 'Valley View Castle Mobile Home Park', 47.0736083984375, 0.821589457347189, -109.441673278809, -1.91011753760711, 218, 31, 'PPL', 'P'),
(52356, 'Valley View Estates', 39.4577789306641, 0.688668157864135, -77.5127792358398, -1.3528532100369, 218, 25, 'PPL', 'P'),
(111832, 'Valley View Estates', 38.4541702270508, 0.671151881584412, -81.982780456543, -1.43086944890633, 218, 58, 'PPL', 'P'),
(171482, 'Valley View Estates', 45.6541709899902, 0.796815601043809, -97.1241683959961, -1.69513652177155, 218, 49, 'PPL', 'P'),
(98756, 'Valley View Estates Colonia', 26.2080001831055, 0.457415893558467, -98.2919998168945, -1.71551902517447, 218, 51, 'PPL', 'P'),
(74634, 'Valley View Heights', 39.1205596923828, 0.68278257185506, -84.2919387817383, -1.47117186463083, 218, 41, 'PPL', 'P'),
(91539, 'Valley View Heights', 36.0280609130859, 0.628808286042424, -84.1577835083008, -1.46883041340043, 218, 50, 'PPL', 'P'),
(195756, 'Valley View Heights', 46.4233283996582, 0.810239930308626, -116.969718933105, -2.04150672051504, 218, 17, 'PPL', 'P'),
(138547, 'Valley View Park', 44.0333290100098, 0.768526571838606, -92.8583297729492, -1.62068359244064, 218, 28, 'PPL', 'P'),
(185883, 'Valley View Park', 34.2350006103516, 0.597513480072903, -117.307220458984, -2.04739723337213, 218, 6, 'PPL', 'P'),
(206245, 'Valley View Park', 40.6505584716797, 0.709486088105285, -112.016937255859, -1.95506437311465, 218, 52, 'PPL', 'P'),
(84137, 'Valley View Shores', 34.6805610656738, 0.605289977034962, -82.8808288574219, -1.44654335034394, 218, 48, 'PPL', 'P'),
(209025, 'Valley View Tracts', 46.1794395446777, 0.805983266780298, -122.97444152832, -2.14630890047044, 218, 56, 'PPL', 'P'),
(143260, 'Valley View Trailer Court', 40.7027816772461, 0.710397554988364, -99.0569381713867, -1.72886971803515, 218, 35, 'PPL', 'P'),
(192837, 'Valley View Trailer Park', 37.1241683959961, 0.647938970574954, -113.53556060791, -1.98156935070561, 218, 52, 'PPL', 'P'),
(91540, 'Valley Village', 35.0505599975586, 0.611747676625213, -85.3541717529297, -1.48971132740136, 218, 50, 'PPL', 'P'),
(118166, 'Valley Village Mobile Home Park', 40.9861106872559, 0.715342579079451, -92.3791732788086, -1.61232073398558, 218, 16, 'PPL', 'P'),
(52357, 'Valley Vista', 39.6916694641113, 0.692750317762036, -76.8724975585938, -1.34167818662876, 218, 25, 'PPL', 'P'),
(185884, 'Valley Vista', 33.7413902282715, 0.588898353683578, -117.072219848633, -2.0432956989773, 218, 6, 'PPL', 'P'),
(197752, 'Valley Vista Mobile Home Community', 45.9472198486328, 0.801930268496333, -112.513893127441, -1.96373788931087, 218, 31, 'PPL', 'P'),
(52358, 'Valley Vista North', 39.6944389343262, 0.692798654135821, -76.8769378662109, -1.34175568461648, 218, 25, 'PPL', 'P'),
(197753, 'Valley Vista Trailer Park', 45.6444396972656, 0.796645757945289, -109.261672973633, -1.9069759396272, 218, 31, 'PPL', 'P'),
(107091, 'Valley Vue', 38.6605606079102, 0.674754073274853, -77.4244384765625, -1.3513113729238, 218, 53, 'PPL', 'P'),
(58035, 'Valley Water Mills', 37.2658309936523, 0.650411449330983, -93.2477798461914, -1.62748077849085, 218, 29, 'PPL', 'P'),
(98757, 'Valley Wells', 28.4805603027344, 0.497079550095508, -99.5088882446289, -1.73675773486786, 218, 51, 'PPL', 'P'),
(185885, 'Valley Wells', 35.8283309936523, 0.625322341333565, -117.330833435059, -2.04780935755082, 218, 6, 'PPL', 'P'),
(185886, 'Valley Wells Station', 35.4347190856934, 0.618452517564624, -115.701393127441, -2.01937025921819, 218, 6, 'PPL', 'P'),
(197754, 'Valley West Trailer Court', 46.7486114501953, 0.815917190541429, -114.091110229492, -1.99126552076042, 218, 31, 'PPL', 'P'),
(25690, 'Valley Woods', 33.5602798461914, 0.585737381206736, -84.4519424438477, -1.47396445534989, 218, 13, 'PPL', 'P'),
(168307, 'Valley-Hi', 40.0291709899902, 0.698640830619128, -78.1916732788086, -1.36470214635888, 218, 45, 'PPL', 'P'),
(52359, 'Valleybrook', 39.4680595397949, 0.688847588342579, -76.3858337402344, -1.33318430064806, 218, 25, 'PPL', 'P'),
(91541, 'Valleybrook', 35.1555595397949, 0.613580264350324, -85.2133331298828, -1.48725322971522, 218, 50, 'PPL', 'P'),
(107092, 'Valleyburgh', 38.6163902282715, 0.673983154718302, -78.4091720581055, -1.36849821617668, 218, 53, 'PPL', 'P'),
(74637, 'Valleydale', 39.2083282470703, 0.684314422114074, -84.4833297729492, -1.47451226758612, 218, 41, 'PPL', 'P'),
(209026, 'Valleyford', 47.5319404602051, 0.829588860892487, -117.238059997559, -2.04619015560805, 218, 56, 'PPL', 'P'),
(6516, 'Valleyhaven', 33.610279083252, 0.586610032516928, -86.4652786254883, -1.50910380066905, 218, 2, 'PPL', 'P'),
(69767, 'Valleytown', 35.1941719055176, 0.614254177264168, -83.8066711425781, -1.46270234657411, 218, 33, 'PPL', 'P'),
(197755, 'Valleytown', 48.7055587768555, 0.85007236467975, -107.239166259766, -1.87167653832652, 218, 31, 'PPL', 'P'),
(91542, 'Valleyview', 35.9724998474121, 0.627838562510499, -86.3233337402344, -1.506626395065, 218, 50, 'PPL', 'P'),
(158083, 'Valleyview', 40.5638885498047, 0.70797341260612, -81.2002792358398, -1.41721222620419, 218, 41, 'PPL', 'P'),
(171490, 'Valleyview', 42.9672203063965, 0.749919464776385, -97.2786102294922, -1.69783204026888, 218, 49, 'PPL', 'P'),
(107093, 'Valleyview Corner', 38.2055587768555, 0.666812793220345, -77.3077774047852, -1.34927525311238, 218, 53, 'PPL', 'P'),
(91543, 'Valleyview Subdivision', 35.0227813720703, 0.611262848148764, -85.1175003051758, -1.4855806313926, 218, 50, 'PPL', 'P'),
(52360, 'Valleywood', 39.4466705322266, 0.688474279736777, -76.6419372558594, -1.33765415022165, 218, 25, 'PPL', 'P'),
(74638, 'Valleywood', 39.7227783203125, 0.693293269729276, -84.0749969482422, -1.46738551535101, 218, 41, 'PPL', 'P'),
(52361, 'Valliant', 38.7686080932617, 0.676639857642738, -76.379997253418, -1.33308243473637, 218, 25, 'PPL', 'P'),
(77540, 'Valliant', 34.0022201538086, 0.593450694671933, -95.0936126708984, -1.65969663872338, 218, 42, 'PPL', 'P'),
(187483, 'Vallie', 38.3941688537598, 0.670104660064765, -105.771942138672, -1.84606864654876, 218, 7, 'PPL', 'P'),
(12519, 'Vallier', 34.3263893127441, 0.599108513828779, -91.6338882446289, -1.5993130562733, 218, 4, 'PPL', 'P'),
(43454, 'Vallier', 29.8724994659424, 0.521373471480942, -90.4483337402344, -1.57862122670977, 218, 22, 'PPL', 'P'),
(6517, 'Valliwood', 33.2472190856934, 0.580273440177248, -87.6672210693359, -1.53008165373366, 218, 2, 'PPL', 'P'),
(31364, 'Vallonia', 38.8469390869141, 0.67800699138833, -86.0977783203125, -1.50268971034165, 218, 19, 'PPL', 'P'),
(74639, 'Vallonia', 39.9602813720703, 0.697438479965984, -80.8300018310547, -1.41074966634495, 218, 41, 'PPL', 'P'),
(153332, 'Vallonia Springs', 42.1797218322754, 0.736175023548541, -75.5372161865234, -1.31837313024559, 218, 40, 'PPL', 'P'),
(187484, 'Vallorso', 37.2827796936035, 0.650707259949064, -104.644439697266, -1.82639001662194, 218, 7, 'PPL', 'P'),
(111833, 'Vallscreek', 37.2319412231445, 0.649819961252877, -81.6452789306641, -1.42497893604924, 218, 58, 'PPL', 'P'),
(98758, 'Vally-Hi Acres Number 1 Colonia', 27.996000289917, 0.488622382448339, -98.0910034179688, -1.71201097622857, 218, 51, 'PPL', 'P'),
(98759, 'Vally-Hi Acres Number 2 Colonia', 28.0020008087158, 0.488727111258206, -98.0899963378906, -1.71199339936537, 218, 51, 'PPL', 'P'),
(69768, 'Valmead', 35.936939239502, 0.627217912818456, -81.538330078125, -1.42311232644121, 218, 33, 'PPL', 'P'),
(28845, 'Valmeyer', 38.3055610656738, 0.668558162419756, -90.2763900756836, -1.57562024363541, 218, 18, 'PPL', 'P'),
(189770, 'Valmont', 32.7466697692871, 0.571537206537352, -105.986938476563, -1.84982104052468, 218, 38, 'PPL', 'P'),
(194460, 'Valmont', 40.0319404602051, 0.698689166992913, -105.213890075684, -1.83632880065206, 218, 7, 'PPL', 'P'),
(107094, 'Valmont Estates', 37.785831451416, 0.659487169430837, -78.5138931274414, -1.3703259436328, 218, 53, 'PPL', 'P'),
(189771, 'Valmora', 35.8163909912109, 0.625113948978266, -104.922500610352, -1.83124309507639, 218, 38, 'PPL', 'P'),
(176801, 'Valmy', 44.9080581665039, 0.783793475682621, -87.2630615234375, -1.52302773895436, 218, 57, 'PPL', 'P'),
(200256, 'Valmy', 40.792781829834, 0.71196835397832, -117.125831604004, -2.0442314006263, 218, 39, 'PPL', 'P'),
(153333, 'Valois', 42.5347213745117, 0.742370934403638, -76.8775024414063, -1.34176553831252, 218, 40, 'PPL', 'P'),
(25692, 'Valona', 31.4780597686768, 0.549395785102974, -81.3441696166992, -1.41972358711214, 218, 13, 'PPL', 'P'),
(185888, 'Valona', 38.0522193908691, 0.664136516061898, -122.223327636719, -2.13319949000452, 218, 6, 'PPL', 'P'),
(18421, 'Valparaiso', 30.5083293914795, 0.532470797164275, -86.5027770996094, -1.50975827250693, 218, 12, 'PPL', 'P'),
(123874, 'Valparaiso', 41.4730606079102, 0.723841458487193, -87.0611114501953, -1.51950304525164, 218, 19, 'PPL', 'P'),
(143266, 'Valparaiso', 41.0813903808594, 0.717005523443123, -96.8313903808594, -1.69002658142996, 218, 35, 'PPL', 'P'),
(18422, 'Valrico', 27.9455604553223, 0.487742041260499, -82.258056640625, -1.43567392467089, 218, 12, 'PPL', 'P'),
(18423, 'Valroy', 27.649169921875, 0.482569050580102, -82.5155563354492, -1.44016814216846, 218, 12, 'PPL', 'P'),
(201717, 'Valsetz (historical)', 44.8383293151855, 0.782576477643482, -123.65389251709, -2.1581675573304, 218, 43, 'PPL', 'P'),
(176802, 'Valton', 43.5730590820313, 0.760493346147463, -90.274169921875, -1.57558149464155, 218, 57, 'PPL', 'P'),
(62142, 'Value', 32.2874984741211, 0.563523155606058, -89.9955596923828, -1.57071882880718, 218, 30, 'PPL', 'P'),
(43455, 'Valverda', 30.541389465332, 0.533047804303954, -91.5519409179688, -1.59788280560987, 218, 22, 'PPL', 'P'),
(185889, 'Valyermo', 34.4461097717285, 0.601198030020055, -117.851387023926, -2.05689473160963, 218, 6, 'PPL', 'P'),
(18424, 'Vamo', 27.2216701507568, 0.475107772022568, -82.4980621337891, -1.43986281074948, 218, 12, 'PPL', 'P'),
(77541, 'Vamoosa', 34.9855613708496, 0.610613236579867, -96.6697235107422, -1.68720496225502, 218, 42, 'PPL', 'P'),
(179435, 'Vamori', 31.7211093902588, 0.553637801245307, -111.904716491699, -1.95310575129095, 218, 5, 'PPL', 'P'),
(12520, 'Van', 34.3266716003418, 0.599113440676795, -91.2341690063477, -1.59233663948173, 218, 4, 'PPL', 'P'),
(38654, 'Van', 37.1513900756836, 0.648414078513424, -82.8736114501953, -1.44641738282438, 218, 21, 'PPL', 'P'),
(58037, 'Van', 37.5613899230957, 0.65556992578344, -93.2869415283203, -1.62816427878462, 218, 29, 'PPL', 'P'),
(98760, 'Van', 32.5247192382813, 0.56766343899475, -95.6369400024414, -1.66917948957488, 218, 51, 'PPL', 'P'),
(107095, 'Van', 36.6136093139648, 0.639028033567549, -83.1555633544922, -1.45133837188663, 218, 53, 'PPL', 'P'),
(111834, 'Van', 37.9711112976074, 0.662720912784466, -81.7111129760742, -1.42612795690156, 218, 58, 'PPL', 'P'),
(118170, 'Van', 41.9397201538086, 0.731986204048983, -93.0186080932617, -1.62348097684966, 218, 16, 'PPL', 'P'),
(133492, 'Van', 45.5938911437988, 0.795763519255173, -84.7825012207031, -1.47973379437738, 218, 27, 'PPL', 'P'),
(158085, 'Van', 40.502498626709, 0.706901956320554, -83.6152801513672, -1.45936194361882, 218, 41, 'PPL', 'P'),
(168308, 'Van', 41.3177795410156, 0.721131292603874, -79.6549987792969, -1.39024199437079, 218, 45, 'PPL', 'P'),
(192838, 'Van', 39.2305603027344, 0.684702444684898, -112.667778015137, -1.96642368727022, 218, 52, 'PPL', 'P'),
(201718, 'Van', 43.9900016784668, 0.767770367247078, -118.687217712402, -2.07148272911275, 218, 43, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(118171, 'Van Ackers Mobile Home Park', 41.3972206115723, 0.722517800846397, -91.0722198486328, -1.58951009345877, 218, 16, 'PPL', 'P'),
(185890, 'Van Allen', 37.7983283996582, 0.659705282324115, -121.051391601563, -2.11274534756828, 218, 6, 'PPL', 'P'),
(153334, 'Van Allen Park', 42.6549987792969, 0.744470171132893, -73.7088928222656, -1.28646286774815, 218, 40, 'PPL', 'P'),
(98761, 'Van Alstyne', 33.4213905334473, 0.583313305403519, -96.5769424438477, -1.6855856271542, 218, 51, 'PPL', 'P'),
(34252, 'Van Arsdale', 37.9991683959961, 0.663210601529904, -97.4266662597656, -1.70041610547458, 218, 20, 'PPL', 'P'),
(52362, 'Van Bibber', 39.4436111450195, 0.688420883356921, -76.3022232055664, -1.33172502152876, 218, 25, 'PPL', 'P'),
(52363, 'Van Bibber Manor', 39.4480590820313, 0.688498514502697, -76.3083267211914, -1.33183154797236, 218, 25, 'PPL', 'P'),
(12525, 'Van Buren', 35.4366683959961, 0.61848653944755, -94.3480606079102, -1.6466843004792, 218, 4, 'PPL', 'P'),
(38655, 'Van Buren', 37.9744415283203, 0.662779036275257, -85.165283203125, -1.48641460028795, 218, 21, 'PPL', 'P'),
(58038, 'Van Buren', 36.9955596923828, 0.645694325250181, -91.0144424438477, -1.58850168751202, 218, 29, 'PPL', 'P'),
(62143, 'Van Buren', 34.1916694641113, 0.596757208902348, -88.4113922119141, -1.54306989036997, 218, 30, 'PPL', 'P'),
(91545, 'Van Buren', 35.1313896179199, 0.613158419633655, -89.0752792358398, -1.55465690479874, 218, 50, 'PPL', 'P'),
(118172, 'Van Buren', 42.0844383239746, 0.734512012605841, -90.3647232055664, -1.57716194759046, 218, 16, 'PPL', 'P'),
(123875, 'Van Buren', 40.6172218322754, 0.70890425398613, -85.5047225952148, -1.49233893529089, 218, 19, 'PPL', 'P'),
(129136, 'Van Buren', 47.1572189331055, 0.823048736466498, -67.9358291625977, -1.18570389895971, 218, 26, 'PPL', 'P'),
(153339, 'Van Buren', 43.1136093139648, 0.75247443494718, -76.3024978637695, -1.33172981521872, 218, 40, 'PPL', 'P'),
(158086, 'Van Buren', 41.1386108398438, 0.718004208851903, -83.6494369506836, -1.45995809222883, 218, 41, 'PPL', 'P'),
(168312, 'Van Buren', 40.077220916748, 0.699479460046394, -80.2908325195313, -1.40133938663315, 218, 45, 'PPL', 'P'),
(176803, 'Van Buren', 42.6763916015625, 0.744843546317722, -90.7255630493164, -1.58345979093628, 218, 57, 'PPL', 'P'),
(25693, 'Van Buren (historical)', 32.8722190856934, 0.573728455482269, -83.540283203125, -1.45805299994305, 218, 13, 'PPL', 'P'),
(43456, 'Van Buren (historical)', 30.4355602264404, 0.531200735640416, -90.6719436645508, -1.58252395612922, 218, 22, 'PPL', 'P'),
(153335, 'Van Buren Bay', 42.4502792358398, 0.740897141056388, -79.4066696166992, -1.38590783285474, 218, 40, 'PPL', 'P'),
(107096, 'Van Buren Furnace', 38.9761085510254, 0.680261423830109, -78.5563888549805, -1.37106763399639, 218, 53, 'PPL', 'P'),
(31365, 'Van Buren Park', 39.1358299255371, 0.68304908770115, -86.5808334350586, -1.51112061256256, 218, 19, 'PPL', 'P'),
(153336, 'Van Buren Point', 42.4488906860352, 0.740872906290468, -79.4186096191406, -1.38611622521004, 218, 40, 'PPL', 'P'),
(28846, 'Van Burensburg', 39.0361099243164, 0.681308645349756, -89.2794418334961, -1.55822021433727, 218, 18, 'PPL', 'P'),
(153338, 'Van Burenville', 41.4986114501953, 0.724287404811727, -74.4280624389648, -1.29901474543986, 218, 40, 'PPL', 'P'),
(176804, 'Van Buskirk', 46.3872184753418, 0.809609693236658, -90.1433334350586, -1.57329796716486, 218, 57, 'PPL', 'P'),
(111836, 'Van Camp', 39.5872192382813, 0.690927317416849, -80.8947219848633, -1.41187924612131, 218, 58, 'PPL', 'P'),
(38656, 'Van Cleave', 36.6544418334961, 0.639740695475254, -88.2388916015625, -1.54005918675764, 218, 21, 'PPL', 'P'),
(58041, 'Van Cleve', 38.2350006103516, 0.667326650152676, -92.1572189331055, -1.60844689986395, 218, 29, 'PPL', 'P'),
(118178, 'Van Cleve', 41.9313888549805, 0.731840795453464, -93.0188903808594, -1.62348590369768, 218, 16, 'PPL', 'P'),
(111837, 'Van Clevesville', 39.4288902282715, 0.688163954890756, -77.9052810668945, -1.35970365930891, 218, 58, 'PPL', 'P'),
(153340, 'Van Cortlandtville', 41.3147201538086, 0.721077896224018, -73.904167175293, -1.28987104815318, 218, 40, 'PPL', 'P'),
(126401, 'Van Deusenville', 42.2272186279297, 0.737003999016855, -73.3638916015625, -1.28044146052348, 218, 23, 'PPL', 'P'),
(153341, 'Van Deusenville', 42.8430595397949, 0.747752450597388, -74.6866683959961, -1.30352827085532, 218, 40, 'PPL', 'P'),
(146514, 'Van Dorans Mills', 40.7313919067383, 0.710896897692754, -74.5411071777344, -1.30098774833344, 218, 37, 'PPL', 'P'),
(153342, 'Van Dorn Corner', 42.452220916748, 0.740931029781259, -76.5913925170898, -1.33677197811057, 218, 40, 'PPL', 'P'),
(91547, 'Van Dyke', 36.2213897705078, 0.632182511143555, -88.3011093139648, -1.54114509069212, 218, 50, 'PPL', 'P'),
(107097, 'Van Dyke', 37.1122207641602, 0.647730445061601, -81.7213897705078, -1.42630732080097, 218, 53, 'PPL', 'P'),
(206251, 'Van Dyke and Willey Condominium', 40.8955612182617, 0.71376219270957, -111.890556335449, -1.95285860994179, 218, 52, 'PPL', 'P'),
(52364, 'Van Dyke Manor', 39.3416709899902, 0.686641692011667, -76.5274963378906, -1.33565677940409, 218, 25, 'PPL', 'P'),
(168310, 'Van Dykes', 40.7125015258789, 0.710567198349802, -79.6408309936523, -1.38999471986358, 218, 45, 'PPL', 'P'),
(176805, 'Van Dyne', 43.8875007629395, 0.765981388784817, -88.5041732788086, -1.5446892254708, 218, 57, 'PPL', 'P'),
(69769, 'Van Eden', 34.6183280944824, 0.604203806784373, -77.9499969482422, -1.36048409866636, 218, 33, 'PPL', 'P'),
(168311, 'Van Emman', 40.2777786254883, 0.702979852404167, -80.144172668457, -1.39877968935143, 218, 45, 'PPL', 'P'),
(153343, 'Van Etten', 42.1986083984375, 0.736504656312466, -76.5527801513672, -1.33609806519672, 218, 40, 'PPL', 'P'),
(153344, 'Van Etten Junction', 42.1886100769043, 0.736330152682038, -76.5591735839844, -1.33620965164639, 218, 40, 'PPL', 'P'),
(91548, 'Van Hill', 36.3886108398438, 0.635101069382172, -82.8133316040039, -1.44536530103575, 218, 50, 'PPL', 'P'),
(146515, 'Van Hiseville', 40.1116714477539, 0.700080735241506, -74.3430633544922, -1.29753123155463, 218, 37, 'PPL', 'P'),
(192365, 'Van Horn', 31.0397205352783, 0.541745322239503, -104.830276489258, -1.82963348051355, 218, 51, 'PPL', 'P'),
(209029, 'Van Horn', 48.5166702270508, 0.846775637566341, -121.704170227051, -2.12413848386969, 218, 56, 'PPL', 'P'),
(118179, 'Van Horne', 42.0086097717285, 0.733188554702126, -92.0908279418945, -1.60728815847365, 218, 16, 'PPL', 'P'),
(153346, 'Van Hornesville', 42.8950004577637, 0.748658990632451, -74.8280563354492, -1.30599595592139, 218, 40, 'PPL', 'P'),
(189772, 'Van Houten', 36.7922210693359, 0.642145396781541, -104.565277099609, -1.82500836864841, 218, 38, 'PPL', 'P'),
(153347, 'Van Keuren', 41.5902786254883, 0.725887298836592, -74.3099975585938, -1.29695412454641, 218, 40, 'PPL', 'P'),
(153348, 'Van Keurens', 41.6452789306641, 0.726847235251511, -73.9441680908203, -1.29056919583294, 218, 40, 'PPL', 'P'),
(38657, 'Van Lear', 37.771110534668, 0.659230240964672, -82.758056640625, -1.44440057093086, 218, 21, 'PPL', 'P'),
(52365, 'Van Lear Manor', 39.6069412231445, 0.691271530987742, -77.7922210693359, -1.35773039009922, 218, 25, 'PPL', 'P'),
(123882, 'Van Loon', 41.5683288574219, 0.725504203113784, -87.4227828979492, -1.5258154028254, 218, 19, 'PPL', 'P'),
(146516, 'Van Marters Corner', 40.4375, 0.705767516275207, -74.1805572509766, -1.29469496499369, 218, 37, 'PPL', 'P'),
(113120, 'Van Meer', 46.4194412231445, 0.810172086279856, -86.4697189331055, -1.50918129865677, 218, 27, 'PPL', 'P'),
(74640, 'Van Meter', 39.0422210693359, 0.681415304951413, -83.0269393920898, -1.44909346024575, 218, 41, 'PPL', 'P'),
(118180, 'Van Meter', 41.5319404602051, 0.724869105772828, -93.9538879394531, -1.63980468959325, 218, 16, 'PPL', 'P'),
(168313, 'Van Meter', 40.1388893127441, 0.700555776600949, -79.7458267211914, -1.39182724100966, 218, 45, 'PPL', 'P'),
(202717, 'Van Metre', 44.1594390869141, 0.770727607900529, -100.793327331543, -1.75917542597582, 218, 49, 'PPL', 'P'),
(185891, 'Van Ness', 33.9824981689453, 0.59310648110104, -118.31861114502, -2.06504933086745, 218, 6, 'PPL', 'P'),
(190869, 'Van Ness (historical)', 38.6438903808594, 0.674463122925762, -116.978332519531, -2.04165705595857, 218, 39, 'PPL', 'P'),
(153349, 'Van Nest', 40.848331451416, 0.712937877773164, -73.8641662597656, -1.28917290047342, 218, 40, 'PPL', 'P'),
(197756, 'Van Norman', 47.353328704834, 0.826471497678495, -106.386672973633, -1.85679772363236, 218, 31, 'PPL', 'P'),
(31371, 'Van Nuys', 39.9599990844727, 0.697433553117968, -85.353889465332, -1.48970640055335, 218, 19, 'PPL', 'P'),
(185892, 'Van Nuys', 34.1866683959961, 0.596669923797621, -118.448059082031, -2.06730862357822, 218, 6, 'PPL', 'P'),
(121791, 'Van Orin', 41.5499992370605, 0.725184290887838, -89.3533325195313, -1.55950985009514, 218, 18, 'PPL', 'P'),
(168315, 'Van Ormer', 40.6733283996582, 0.709883498318952, -78.4927825927734, -1.36995749529599, 218, 45, 'PPL', 'P'),
(98762, 'Van Pelt', 29.1333293914795, 0.508472519949353, -95.4308319091797, -1.66558222473245, 218, 51, 'PPL', 'P'),
(121792, 'Van Peterson Subdivision', 41.3369407653809, 0.721465719057761, -88.4008331298828, -1.54288559962254, 218, 18, 'PPL', 'P'),
(121793, 'Van Petten', 41.7041702270508, 0.727875082274227, -89.621940612793, -1.56419794572006, 218, 18, 'PPL', 'P'),
(70, 'Van Raub', 29.7294406890869, 0.518876624800938, -98.6555633544922, -1.72186440594575, 218, 51, 'PPL', 'P'),
(168314, 'Van Reeds Mill', 40.3655586242676, 0.704511902400262, -75.9944381713867, -1.32635315929396, 218, 45, 'PPL', 'P'),
(206253, 'Van Ross Estates', 40.5483283996582, 0.707701836753959, -111.955001831055, -1.95398339602818, 218, 52, 'PPL', 'P'),
(146518, 'Van Syckel', 40.6497192382813, 0.709471440719289, -74.970832824707, -1.30848787575338, 218, 37, 'PPL', 'P'),
(146517, 'Van Syckles', 41.2708282470703, 0.720311837936457, -74.5783309936523, -1.30163742648137, 218, 37, 'PPL', 'P'),
(209806, 'Van Tassell', 42.6627807617188, 0.744605992348487, -104.087783813477, -1.81667453864923, 218, 59, 'PPL', 'P'),
(98763, 'Van Vleck', 29.0174999237061, 0.506450914365874, -95.8891677856445, -1.67358169485678, 218, 51, 'PPL', 'P'),
(185893, 'Van Vleck', 38.7780609130859, 0.676804840472268, -120.514442443848, -2.10337381685034, 218, 6, 'PPL', 'P'),
(62144, 'Van Vleet', 33.9869384765625, 0.593183979088761, -88.9002838134766, -1.55160265850259, 218, 30, 'PPL', 'P'),
(153350, 'Van Vleet', 42.0386085510254, 0.733712132172436, -77.2841720581055, -1.34886326209174, 218, 40, 'PPL', 'P'),
(111838, 'Van Voorhis', 39.6827812194824, 0.692595188628539, -79.9552764892578, -1.39548282907996, 218, 58, 'PPL', 'P'),
(168318, 'Van Voorhis', 40.1561088562012, 0.700856314329965, -79.9744415283203, -1.39581732211288, 218, 45, 'PPL', 'P'),
(168316, 'Van Voorhis Hill', 40.0738906860352, 0.699421336555603, -80.0427780151367, -1.39701001880707, 218, 45, 'PPL', 'P'),
(38659, 'Van Voorhis Manor', 37.9052810668945, 0.661571958511179, -85.9891662597656, -1.50079407227773, 218, 21, 'PPL', 'P'),
(12526, 'Van Wagoner (historical)', 33.6838912963867, 0.587894808005809, -92.9855575561523, -1.62290413615755, 218, 4, 'PPL', 'P'),
(25694, 'Van Wert', 33.9872207641602, 0.593188905936778, -85.043327331543, -1.48428606878671, 218, 13, 'PPL', 'P'),
(118182, 'Van Wert', 40.8697204589844, 0.713311186378966, -93.7927780151367, -1.63699279095629, 218, 16, 'PPL', 'P'),
(158102, 'Van Wert', 40.8694381713867, 0.713306259530949, -84.5841674804688, -1.4762722175925, 218, 41, 'PPL', 'P'),
(168317, 'Van Wert', 40.5830612182617, 0.708308038797088, -77.2975006103516, -1.34909588921296, 218, 45, 'PPL', 'P'),
(62145, 'Van Winkle', 32.2986106872559, 0.563717100312443, -90.2636108398438, -1.57539720389412, 218, 30, 'PPL', 'P'),
(28847, 'Van Wood', 39.9613914489746, 0.697457854462915, -89.5986099243164, -1.56379074838939, 218, 18, 'PPL', 'P'),
(84138, 'Van Wyck', 34.8583297729492, 0.608392626283931, -80.8461074829102, -1.41103076299801, 218, 48, 'PPL', 'P'),
(209032, 'Van Wyck', 48.8038902282715, 0.851788572265224, -122.419441223145, -2.13662231779555, 218, 56, 'PPL', 'P'),
(209030, 'Van Zandt', 48.7891693115234, 0.851531643799059, -122.190559387207, -2.13262757616043, 218, 56, 'PPL', 'P'),
(31372, 'Vanada', 37.9322204589844, 0.662042139601632, -87.3644409179688, -1.52479714318261, 218, 19, 'PPL', 'P'),
(187485, 'Vanadium', 37.9669418334961, 0.66264814190768, -107.97110748291, -1.88445132260147, 218, 7, 'PPL', 'P'),
(189773, 'Vanadium', 32.7791709899902, 0.572104459849539, -108.116943359375, -1.88699663881331, 218, 38, 'PPL', 'P'),
(197757, 'Vananda', 46.3919410705566, 0.809692118072396, -107.001670837402, -1.86753146124787, 218, 31, 'PPL', 'P'),
(179436, 'Vanar', 32.2411117553711, 0.562713554634674, -109.094436645508, -1.90405711507247, 218, 5, 'PPL', 'P'),
(38661, 'Vanarsdell', 37.8925018310547, 0.661348918769884, -84.8805618286133, -1.48144527485192, 218, 21, 'PPL', 'P'),
(158092, 'Vanatta', 40.1258316040039, 0.700327876590666, -82.429443359375, -1.43866518720727, 218, 41, 'PPL', 'P'),
(91549, 'Vanbebber Spring', 36.5038909912109, 0.637113087585727, -83.7972183227539, -1.46253736374458, 218, 50, 'PPL', 'P'),
(6520, 'Vance', 33.1741714477539, 0.5789985183844, -87.2336120605469, -1.52251374886398, 218, 2, 'PPL', 'P'),
(12527, 'Vance', 35.7772216796875, 0.624430315526443, -91.1636123657227, -1.59110519379368, 218, 4, 'PPL', 'P'),
(58044, 'Vance', 37.4394416809082, 0.653441527440248, -92.7797164916992, -1.61931153184703, 218, 29, 'PPL', 'P'),
(62146, 'Vance', 34.0727806091309, 0.594682206939013, -90.350830078125, -1.57691946677321, 218, 30, 'PPL', 'P'),
(84139, 'Vance', 33.4336090087891, 0.583526558027807, -80.4230575561523, -1.40364714887576, 218, 48, 'PPL', 'P'),
(91550, 'Vance', 36.5222206115723, 0.637432999811673, -82.2130584716797, -1.43488855846543, 218, 50, 'PPL', 'P'),
(107098, 'Vance', 36.6661109924316, 0.639944360719618, -79.5586090087891, -1.38855967551019, 218, 53, 'PPL', 'P'),
(111839, 'Vance', 39.378059387207, 0.687276789352623, -78.7388916015625, -1.37425290781818, 218, 58, 'PPL', 'P'),
(141001, 'Vance', 47.0338897705078, 0.820896236515442, -97.2174987792969, -1.6967654442523, 218, 34, 'PPL', 'P'),
(168325, 'Vance', 40.1652793884277, 0.701016370311478, -80.1941680908203, -1.39965227408259, 218, 45, 'PPL', 'P'),
(185894, 'Vance', 36.2241706848145, 0.632231047254421, -119.102500915527, -2.07873078833551, 218, 6, 'PPL', 'P'),
(192366, 'Vance', 29.815559387207, 0.520379679630666, -100.013328552246, -1.74556187911555, 218, 51, 'PPL', 'P'),
(199748, 'Vance', 41.7772216796875, 0.729150070646103, -103.112777709961, -1.79965747191584, 218, 35, 'PPL', 'P'),
(209031, 'Vance (not official)', 46.5166702270508, 0.811869052526454, -121.936393737793, -2.12819154873268, 218, 56, 'PPL', 'P'),
(187486, 'Vance Junction', 37.9355583190918, 0.662100396250478, -107.898063659668, -1.88317646738765, 218, 7, 'PPL', 'P'),
(107099, 'Vance Mill', 36.6847190856934, 0.640269133214553, -81.9722213745117, -1.4306851581589, 218, 53, 'PPL', 'P'),
(52366, 'Vance Valley', 39.5986099243164, 0.691126122392224, -76.5683288574219, -1.3363694413118, 218, 25, 'PPL', 'P'),
(69774, 'Vanceboro', 35.3083305358887, 0.616246621233711, -77.1544418334961, -1.34659904253296, 218, 33, 'PPL', 'P'),
(129138, 'Vanceboro', 45.5633316040039, 0.795230154667857, -67.4302825927734, -1.17688044679412, 218, 26, 'PPL', 'P'),
(38662, 'Vanceburg', 38.5991706848145, 0.673682616989287, -83.3188934326172, -1.45418901951745, 218, 21, 'PPL', 'P'),
(91551, 'Vancel Mill', 36.5233306884766, 0.637452374308603, -83.633056640625, -1.45967220188581, 218, 50, 'PPL', 'P'),
(79320, 'Vances Mill', 39.9524993896484, 0.69730265875039, -79.7311096191406, -1.39157037912253, 218, 45, 'PPL', 'P'),
(25695, 'Vanceville', 31.4327793121338, 0.548605492049493, -83.4408264160156, -1.45631715154453, 218, 13, 'PPL', 'P'),
(43457, 'Vanceville', 32.600830078125, 0.568991823746482, -93.7341690063477, -1.63596987078159, 218, 22, 'PPL', 'P'),
(168319, 'Vanceville', 40.1405601501465, 0.700584938214886, -80.0794372558594, -1.39764984325896, 218, 45, 'PPL', 'P'),
(25696, 'Vancise', 31.6166706085205, 0.551815000637202, -84.2819366455078, -1.47099729442138, 218, 13, 'PPL', 'P'),
(62147, 'Vancleave', 30.5402793884277, 0.533028429807024, -88.6875, -1.54788888036247, 218, 30, 'PPL', 'P'),
(38663, 'Vancleve', 37.627498626709, 0.656723740325717, -83.4136123657227, -1.45584217676412, 218, 21, 'PPL', 'P'),
(187487, 'Vancorum', 38.2316703796387, 0.667268526661885, -108.595001220703, -1.89534032250853, 218, 7, 'PPL', 'P'),
(192367, 'Vancourt', 31.3427791595459, 0.547034693059537, -100.176666259766, -1.74841265990442, 218, 51, 'PPL', 'P'),
(209033, 'Vancouver', 45.6388893127441, 0.796548885460637, -122.660278320313, -2.14082571810207, 218, 56, 'PPL', 'P'),
(91552, 'Vancouver (historical)', 35.8736114501953, 0.626112634387046, -84.2652816772461, -1.47070661038839, 218, 50, 'PPL', 'P'),
(209034, 'Vancouver Junction', 45.6775016784668, 0.797222798374482, -122.690826416016, -2.14135888295231, 218, 56, 'PPL', 'P'),
(84140, 'Vandale Place', 34.4619407653809, 0.601474332983151, -82.7205581665039, -1.44374609909298, 218, 48, 'PPL', 'P'),
(28848, 'Vandalia', 38.9605598449707, 0.67999004771503, -89.0936126708984, -1.55497688360372, 218, 18, 'PPL', 'P'),
(31373, 'Vandalia', 39.3125, 0.686132562190271, -86.8661117553711, -1.51609965853658, 218, 19, 'PPL', 'P'),
(58045, 'Vandalia', 39.3108291625977, 0.686103400576334, -91.4883270263672, -1.59677253375142, 218, 29, 'PPL', 'P'),
(69775, 'Vandalia', 36.0163917541504, 0.62860462079806, -79.7766723632813, -1.39236559902402, 218, 33, 'PPL', 'P'),
(74641, 'Vandalia', 39.8905601501465, 0.6962216150849, -84.1988906860352, -1.4695478689981, 218, 41, 'PPL', 'P'),
(98765, 'Vandalia', 33.6716690063477, 0.587681488802494, -95.0155563354492, -1.65833429866775, 218, 51, 'PPL', 'P'),
(111842, 'Vandalia', 38.7594413757324, 0.676479868240251, -81.4444427490234, -1.42147368342248, 218, 58, 'PPL', 'P'),
(118183, 'Vandalia', 41.5394401550293, 0.725000000140405, -93.3058319091797, -1.62849397812757, 218, 16, 'PPL', 'P'),
(133495, 'Vandalia', 41.9169387817383, 0.731588594098234, -85.9147186279297, -1.49949471598188, 218, 27, 'PPL', 'P'),
(153351, 'Vandalia', 42.0961112976074, 0.734715744429232, -78.5800018310547, -1.37147975817508, 218, 40, 'PPL', 'P'),
(197758, 'Vandalia', 48.3547210693359, 0.843949091543385, -106.909172058105, -1.86591705299506, 218, 31, 'PPL', 'P'),
(69776, 'Vandemere', 35.1838912963867, 0.614074746785724, -76.6638870239258, -1.33803724594446, 218, 33, 'PPL', 'P'),
(185895, 'Vanden (historical)', 38.2855606079102, 0.668209088579874, -121.967498779297, -2.1287344341209, 218, 6, 'PPL', 'P'),
(179437, 'Vandenberg Village', 32.1802787780762, 0.561651818887087, -110.867218017578, -1.93499798693312, 218, 5, 'PPL', 'P'),
(185896, 'Vandenberg Village', 34.7083282470703, 0.605774605774329, -120.466667175293, -2.10253998111304, 218, 6, 'PPL', 'P'),
(69778, 'Vander', 35.0319404602051, 0.611422704393196, -78.7949981689453, -1.375232152151, 218, 33, 'PPL', 'P'),
(6518, 'Vanderbilt', 33.5497207641602, 0.585553090459303, -86.7869415283203, -1.51471787740499, 218, 2, 'PPL', 'P'),
(98766, 'Vanderbilt', 28.8227806091309, 0.50305242120931, -96.6172180175781, -1.68628856852393, 218, 51, 'PPL', 'P'),
(133496, 'Vanderbilt', 45.1427803039551, 0.787890149808463, -84.6602783203125, -1.47760060234423, 218, 27, 'PPL', 'P'),
(168320, 'Vanderbilt', 40.0330581665039, 0.698708674647897, -79.6616668701172, -1.39035837451043, 218, 45, 'PPL', 'P'),
(185897, 'Vanderbilt', 35.3305587768555, 0.616634577225509, -115.250282287598, -2.01149688977148, 218, 6, 'PPL', 'P'),
(190870, 'Vanderbilt (historical)', 39.4247207641602, 0.68809118401397, -115.977500915527, -2.02418924921069, 218, 39, 'PPL', 'P'),
(18425, 'Vanderbilt Beach', 26.2702808380127, 0.458502896046897, -81.7900009155273, -1.42750481118513, 218, 12, 'PPL', 'P'),
(18426, 'Vanderbilt Beach Estates', 26.2630596160889, 0.458376861948309, -81.8241729736328, -1.42810122611125, 218, 12, 'PPL', 'P'),
(193322, 'Vanderbilt Hill', 58.3450012207031, 1.01831237338138, -134.492218017578, -2.34733202271678, 218, 1, 'PPL', 'P'),
(18427, 'Vanderbilt Park', 25.7986106872559, 0.450270698932812, -80.3586120605469, -1.40252236278937, 218, 12, 'PPL', 'P'),
(38664, 'Vanderburg', 37.4872207641602, 0.654275429756579, -87.644172668457, -1.529679383251, 218, 21, 'PPL', 'P'),
(146521, 'Vanderburg', 40.3141708374023, 0.70361501632415, -74.1894378662109, -1.29484996096914, 218, 37, 'PPL', 'P'),
(121795, 'Vandercook', 40.1002807617188, 0.699881930266132, -87.648063659668, -1.5297472938588, 218, 18, 'PPL', 'P'),
(133497, 'Vandercook Lake', 42.1933288574219, 0.736412510938749, -84.39111328125, -1.47290278618133, 218, 27, 'PPL', 'P'),
(168322, 'Vandergrift', 40.6027793884277, 0.708652185788954, -79.5650024414063, -1.38867126195987, 218, 45, 'PPL', 'P'),
(168323, 'Vandergrift Heights', 40.5952796936035, 0.708521291421376, -79.5730590820313, -1.38881187686542, 218, 45, 'PPL', 'P'),
(74643, 'Vanderhoof', 39.2019386291504, 0.684202902243427, -81.8611068725586, -1.42874584425311, 218, 41, 'PPL', 'P'),
(98767, 'Vanderpool', 29.7450008392334, 0.519148200653099, -99.5547180175781, -1.73755761530126, 218, 51, 'PPL', 'P'),
(107100, 'Vanderpool', 38.3694381713867, 0.669673028231091, -79.6255569458008, -1.38972813743846, 218, 53, 'PPL', 'P'),
(209035, 'Vanderpool Crossing', 48.6616706848145, 0.849306372971216, -120.327217102051, -2.10010611819282, 218, 56, 'PPL', 'P'),
(28850, 'Vanderville', 39.4252815246582, 0.688100971130976, -89.2975006103516, -1.55853539945228, 218, 18, 'PPL', 'P'),
(12528, 'Vandervoort', 34.3813896179199, 0.600068450243698, -94.3655624389648, -1.64698976505623, 218, 4, 'PPL', 'P'),
(74644, 'Vandervorts Corners', 39.4447212219238, 0.688440257853852, -83.9888916015625, -1.46588269354788, 218, 41, 'PPL', 'P'),
(189774, 'Vanderwagen', 35.2738914489746, 0.61564554577568, -108.754173278809, -1.89811839899965, 218, 38, 'PPL', 'P'),
(200257, 'Vanderwater (historical)', 40.3519401550293, 0.704274215272972, -118.157783508301, -2.06224235907851, 218, 39, 'PPL', 'P'),
(38665, 'Vandetta', 37.4513893127441, 0.653650052953602, -87.4252777099609, -1.52585894550923, 218, 21, 'PPL', 'P'),
(91553, 'Vandever', 35.8308296203613, 0.625365950596415, -85.0919418334961, -1.48513455191001, 218, 50, 'PPL', 'P'),
(459, 'Vandiver', 34.4011116027832, 0.600412663814591, -83.2525024414063, -1.45303027812716, 218, 13, 'PPL', 'P'),
(6519, 'Vandiver', 33.4705581665039, 0.58417144248577, -86.5133285522461, -1.50994243009631, 218, 2, 'PPL', 'P'),
(58046, 'Vandiver', 39.1630592346191, 0.683524328797674, -91.8433303833008, -1.60296851118554, 218, 29, 'PPL', 'P'),
(25697, 'Vandiver Heights', 34.0280609130859, 0.593901701002538, -84.4897232055664, -1.47462385403579, 218, 13, 'PPL', 'P'),
(168326, 'Vandling', 41.6330604553223, 0.726633982627223, -75.470832824707, -1.31721452201335, 218, 45, 'PPL', 'P'),
(107101, 'Vandola', 36.5777816772461, 0.638402723343598, -79.5116729736328, -1.38774048715888, 218, 53, 'PPL', 'P'),
(18428, 'Vandolah', 27.5152797698975, 0.480232226592098, -81.9255599975586, -1.42987076349756, 218, 12, 'PPL', 'P'),
(58047, 'Vanduser', 36.9905586242676, 0.645607040145453, -89.6855621337891, -1.56530835073657, 218, 29, 'PPL', 'P'),
(12529, 'Vanduzer', 33.651668548584, 0.587332414962612, -92.773063659668, -1.61919541802351, 218, 4, 'PPL', 'P'),
(14778, 'Vandyke', 39.3572196960449, 0.686913068126746, -75.7452774047852, -1.32200448354997, 218, 10, 'PPL', 'P'),
(98768, 'Vandyke', 31.9722194671631, 0.558020498872223, -98.5605621337891, -1.72020632185107, 218, 51, 'PPL', 'P'),
(107102, 'Vandyke', 37.1419410705566, 0.648249162262921, -81.9227828979492, -1.42982229396572, 218, 53, 'PPL', 'P'),
(168328, 'Vandyke', 40.5319404602051, 0.707415813252884, -77.2936096191406, -1.34902797860516, 218, 45, 'PPL', 'P'),
(107103, 'Vane (historical)', 36.9513893127441, 0.64492340669363, -82.432502746582, -1.43871858358713, 218, 53, 'PPL', 'P'),
(98769, 'Vanessa Street Colonia', 29.1940002441406, 0.509531426088282, -99.7979965209961, -1.74180362618523, 218, 51, 'PPL', 'P'),
(111843, 'Vanetta', 38.1752815246582, 0.666284355481046, -81.1938934326172, -1.41710077291257, 218, 58, 'PPL', 'P'),
(141002, 'Vang', 48.9058303833008, 0.853567763610479, -98.1244430541992, -1.71259460798146, 218, 34, 'PPL', 'P'),
(6521, 'Vangale', 32.0713882446289, 0.559751320554179, -87.8308334350586, -1.53293722821249, 218, 2, 'PPL', 'P'),
(52367, 'Vangline Acres', 39.7105598449707, 0.693080017104988, -76.8105621337891, -1.3405972095423, 218, 25, 'PPL', 'P'),
(6522, 'Vangordon', 30.791109085083, 0.537406233875437, -87.7708282470703, -1.53188994011382, 218, 2, 'PPL', 'P'),
(185898, 'Vanguard', 36.2552795410156, 0.632773999221661, -119.958061218262, -2.09366313256759, 218, 6, 'PPL', 'P'),
(98770, 'Vanham Addition Colonia', 29.2390003204346, 0.51031682558326, -99.7939987182617, -1.74173385136467, 218, 51, 'PPL', 'P'),
(38666, 'Vanhook', 37.2138900756836, 0.649504909295921, -84.4022216796875, -1.47309666430869, 218, 21, 'PPL', 'P'),
(79321, 'Vanilla', 39.7780609130859, 0.694258132992212, -77.850830078125, -1.35875331027392, 218, 45, 'PPL', 'P'),
(168329, 'Vankirk', 40.1208305358887, 0.700240591485938, -80.2430572509766, -1.40050555089585, 218, 45, 'PPL', 'P'),
(121796, 'Vanland (historical)', 42.1433296203613, 0.735539859628557, -88.9655609130859, -1.55274195881692, 218, 18, 'PPL', 'P'),
(6523, 'Vanlandingham Mill', 31.0433292388916, 0.541808305999284, -85.7588882446289, -1.49677496271863, 218, 2, 'PPL', 'P'),
(91554, 'Vanleer', 36.2350006103516, 0.63242006511279, -87.4438934326172, -1.52618385116222, 218, 50, 'PPL', 'P'),
(158093, 'Vanlue', 40.9752807617188, 0.715153561221082, -83.4791717529297, -1.45698640392647, 218, 41, 'PPL', 'P'),
(123883, 'Vanmeter Park', 41.0858306884766, 0.717083021430845, -86.5680618286133, -1.51089770597932, 218, 19, 'PPL', 'P'),
(6524, 'Vann', 31.2091693878174, 0.544702762630036, -85.3850021362305, -1.49024941909961, 218, 2, 'PPL', 'P'),
(185899, 'Vann', 39.2527809143066, 0.685090267518641, -122.954437255859, -2.14595976005153, 218, 6, 'PPL', 'P'),
(69779, 'Vann Crossroads', 35.1752815246582, 0.613924477921217, -78.3983306884766, -1.36830899858123, 218, 33, 'PPL', 'P'),
(25698, 'Vanna', 34.2413902282715, 0.59762499994355, -83.0716705322266, -1.4498741659193, 218, 13, 'PPL', 'P'),
(91555, 'Vannatta', 35.6158294677734, 0.621613490041466, -86.4819412231445, -1.50939461786008, 218, 50, 'PPL', 'P'),
(12530, 'Vanndale', 35.3133316040039, 0.616333906338439, -90.7738876342773, -1.58430321405351, 218, 4, 'PPL', 'P'),
(12531, 'Vanness Crossing', 34.8619384765625, 0.608455610043712, -90.6522216796875, -1.58217974255833, 218, 4, 'PPL', 'P'),
(69780, 'Vannoy', 36.3133316040039, 0.633787198858382, -81.2733306884766, -1.41848721457607, 218, 33, 'PPL', 'P'),
(107104, 'Vannoy Acres', 38.8305587768555, 0.67772110104531, -77.3727798461914, -1.35040975973675, 218, 53, 'PPL', 'P'),
(107117, 'Vannoy Park', 38.8116683959961, 0.677391401702358, -77.3824996948242, -1.35057940309819, 218, 53, 'PPL', 'P'),
(111844, 'Vannoys Mill', 39.1305618286133, 0.682957142064515, -79.958610534668, -1.39554101914978, 218, 58, 'PPL', 'P'),
(6525, 'Vanns', 33.6624984741211, 0.58752143282098, -86.5952835083008, -1.5113728139178, 218, 2, 'PPL', 'P'),
(91558, 'Vanntown', 35.0088882446289, 0.611020367331512, -86.4561080932617, -1.50894374468753, 218, 50, 'PPL', 'P'),
(34253, 'Vanora', 37.7658309936523, 0.659138095590955, -96.8888931274414, -1.69103019368676, 218, 20, 'PPL', 'P'),
(185900, 'Vanormer (historical)', 37.4986114501953, 0.654474234731954, -121.146110534668, -2.11439850481494, 218, 6, 'PPL', 'P'),
(77544, 'Vanoss', 34.7638893127441, 0.606744329306254, -96.8716735839844, -1.69072965595774, 218, 42, 'PPL', 'P'),
(168330, 'Vanport', 40.684440612793, 0.710077443025337, -80.3291702270508, -1.40200850585704, 218, 45, 'PPL', 'P'),
(201720, 'Vanport City (historical)', 45.6022186279297, 0.795908861271664, -122.698890686035, -2.14149963101592, 218, 43, 'PPL', 'P'),
(185901, 'Vanris (historical)', 36.7758293151855, 0.641859306701439, -119.699440002441, -2.08914934083601, 218, 6, 'PPL', 'P'),
(58048, 'Vans Camp', 38.8838882446289, 0.678651875846293, -90.5102767944336, -1.57970233695429, 218, 29, 'PPL', 'P'),
(195757, 'Vans Corner', 48.5252799987793, 0.846925906430849, -116.937782287598, -2.04094932089889, 218, 17, 'PPL', 'P'),
(25701, 'Vans Valley', 34.1313896179199, 0.595705127113712, -85.3233337402344, -1.48917310254506, 218, 13, 'PPL', 'P'),
(158094, 'Vans Valley', 40.2180595397949, 0.701937557732537, -82.8027801513672, -1.44518114344637, 218, 41, 'PPL', 'P'),
(107105, 'Vansant', 37.2322196960449, 0.649824821521866, -82.0991668701172, -1.43290077502779, 218, 53, 'PPL', 'P'),
(52374, 'Vansville', 39.0433311462402, 0.681434679448344, -76.8958282470703, -1.34208538395944, 218, 25, 'PPL', 'P'),
(209927, 'Vantage', 46.9455604553223, 0.819354599139422, -119.986106872559, -2.09415262157594, 218, 56, 'PPL', 'P'),
(52368, 'Vantage Point', 39.2238883972168, 0.684585997966235, -76.8541717529297, -1.34135834098185, 218, 25, 'PPL', 'P'),
(69782, 'Vantine', 35.2813911437988, 0.615776440143258, -81.3008270263672, -1.4189671162045, 218, 33, 'PPL', 'P'),
(133498, 'Vantown', 42.6005592346191, 0.74352002183498, -84.2236099243164, -1.46997930109469, 218, 27, 'PPL', 'P'),
(98771, 'Vanva Settlement', 30.3305606842041, 0.529368147915306, -94.6999969482422, -1.65282674837541, 218, 51, 'PPL', 'P'),
(111845, 'Vanville', 39.3797187805176, 0.687305751229478, -77.9800033569336, -1.36100780929472, 218, 58, 'PPL', 'P'),
(199039, 'Vanville', 48.6294403076172, 0.848743846769964, -102.372222900391, -1.78673235219736, 218, 34, 'PPL', 'P'),
(38669, 'Vanzant', 37.6430587768555, 0.656995316177877, -86.6125030517578, -1.51167335164681, 218, 21, 'PPL', 'P'),
(58049, 'Vanzant', 36.9697189331055, 0.645243318919576, -92.3027801513672, -1.61098742238583, 218, 29, 'PPL', 'P'),
(189775, 'Vaqueros (historical)', 36.7588882446289, 0.641563629241413, -107.199172973633, -1.87097852380481, 218, 38, 'PPL', 'P'),
(138550, 'Varco', 43.6058311462402, 0.761065326570585, -92.9563903808594, -1.62239507291518, 218, 28, 'PPL', 'P'),
(62149, 'Vardaman', 33.875560760498, 0.591240071230085, -89.1772232055664, -1.55643616272303, 218, 30, 'PPL', 'P'),
(168332, 'Varden', 41.4836082458496, 0.724025549497545, -75.396110534668, -1.31591037202754, 218, 45, 'PPL', 'P'),
(52369, 'Vardo', 39.6163902282715, 0.691436447238245, -77.7394409179688, -1.35680920267816, 218, 25, 'PPL', 'P'),
(91557, 'Vardy', 36.5783309936523, 0.638412310723522, -83.1805572509766, -1.45177459767318, 218, 50, 'PPL', 'P'),
(84142, 'Varennes (historical)', 34.4375, 0.601047761155547, -82.6097183227539, -1.44181157887714, 218, 48, 'PPL', 'P'),
(84143, 'Varennes Heights', 34.4677810668945, 0.601576265473873, -82.670280456543, -1.4428685875138, 218, 48, 'PPL', 'P'),
(189776, 'Variadero', 35.3880615234375, 0.617638189482305, -104.458892822266, -1.82315161273641, 218, 38, 'PPL', 'P'),
(38667, 'Varilla', 36.7394409179688, 0.641224209360483, -83.5999984741211, -1.45909522803565, 218, 21, 'PPL', 'P'),
(107106, 'Varina', 37.4494400024414, 0.653616031070676, -77.3452835083008, -1.34992985810832, 218, 53, 'PPL', 'P'),
(118184, 'Varina', 42.6580581665039, 0.744523567512749, -94.8974990844727, -1.65627381093235, 218, 16, 'PPL', 'P'),
(107107, 'Varina Farm', 37.3816719055176, 0.652433254651544, -77.3363876342773, -1.34977459581677, 218, 53, 'PPL', 'P'),
(107108, 'Varina Gardens', 37.4394416809082, 0.653441527440248, -77.3597183227539, -1.35018179314744, 218, 53, 'PPL', 'P'),
(107109, 'Varina Grove', 37.4430618286133, 0.65350471093711, -77.3488922119141, -1.3499928418681, 218, 53, 'PPL', 'P'),
(107111, 'Varina Meadows', 37.4524993896484, 0.653669427450532, -77.3491668701172, -1.34999763555806, 218, 53, 'PPL', 'P'),
(107112, 'Varina Place', 37.4472198486328, 0.653577282076815, -77.352783203125, -1.3500607524759, 218, 53, 'PPL', 'P'),
(98772, 'Varisco', 30.642219543457, 0.534807621152279, -96.5425033569336, -1.68498455169617, 218, 51, 'PPL', 'P'),
(14779, 'Varlano', 39.6591682434082, 0.692183064449849, -75.6736068725586, -1.32075359678596, 218, 10, 'PPL', 'P'),
(121797, 'Varna', 41.0363883972168, 0.716220090658632, -89.2261123657227, -1.55728943953629, 218, 18, 'PPL', 'P'),
(153353, 'Varna', 42.4550018310547, 0.740979565892126, -76.4383316040039, -1.33410056122111, 218, 40, 'PPL', 'P'),
(209036, 'Varna', 46.2897186279297, 0.807907999879125, -118.081108093262, -2.06090412063074, 218, 56, 'PPL', 'P'),
(43458, 'Varnado', 30.8936100006104, 0.539195212337698, -89.8294372558594, -1.56781944532841, 218, 22, 'PPL', 'P'),
(62148, 'Varnado', 31.3386096954346, 0.546961922182751, -89.357780456543, -1.55958748124092, 218, 30, 'PPL', 'P'),
(69783, 'Varnamtown', 33.9355583190918, 0.592287226170704, -78.248893737793, -1.36570083176766, 218, 33, 'PPL', 'P'),
(84144, 'Varnarsdale', 34.0041694641113, 0.593484716554858, -81.1466674804688, -1.41627652455519, 218, 48, 'PPL', 'P'),
(25699, 'Varnell', 34.9011116027832, 0.609139310074562, -84.9738922119141, -1.48307419733267, 218, 13, 'PPL', 'P'),
(91560, 'Varnell Estates', 35.1347198486328, 0.613216543124446, -84.9172210693359, -1.48208509930381, 218, 50, 'PPL', 'P'),
(12534, 'Varner', 34.038330078125, 0.5940809317439, -91.6188888549805, -1.59905126753815, 218, 4, 'PPL', 'P'),
(34254, 'Varner', 37.7188911437988, 0.65831884066062, -98.0361099243164, -1.71105290402641, 218, 20, 'PPL', 'P'),
(111846, 'Varner', 38.9072189331055, 0.679059073176966, -81.7041702270508, -1.42600678307196, 218, 58, 'PPL', 'P'),
(38668, 'Varney', 37.6386108398438, 0.656917685032102, -82.4238891601563, -1.43856824814359, 218, 21, 'PPL', 'P'),
(111847, 'Varney', 37.6691703796387, 0.657451049619417, -82.1222229003906, -1.4333031786685, 218, 58, 'PPL', 'P'),
(189777, 'Varney', 34.3047218322754, 0.598730344953988, -105.563888549805, -1.84243742640243, 218, 38, 'PPL', 'P'),
(197759, 'Varney', 45.2324981689453, 0.789456021950402, -111.760833740234, -1.95059452354106, 218, 31, 'PPL', 'P'),
(129140, 'Varney Corner', 44.1025009155273, 0.769733849339766, -69.9700012207031, -1.22120689892572, 218, 26, 'PPL', 'P'),
(129141, 'Varney Crossing', 43.2936096191406, 0.755616032927092, -70.7438888549805, -1.23471378618433, 218, 26, 'PPL', 'P'),
(111848, 'Varneytown', 38.4872207641602, 0.671728722276523, -81.1469421386719, -1.41628131824515, 218, 58, 'PPL', 'P'),
(112218, 'Varnons', 33.1661109924316, 0.578857836899816, -86.7619400024414, -1.51428151846038, 218, 2, 'PPL', 'P'),
(84145, 'Varntown (historical)', 32.8650016784668, 0.573602487962708, -80.899169921875, -1.41195687726708, 218, 48, 'PPL', 'P'),
(13240, 'Varnum', 38.9430618286133, 0.679684649717025, -77.0055618286133, -1.34400059625737, 218, 9, 'PPL', 'P'),
(69786, 'Varnum', 33.9474983215332, 0.592495618526003, -78.2272186279297, -1.36532252973481, 218, 33, 'PPL', 'P'),
(126402, 'Varnumtown', 42.7041702270508, 0.745328374794171, -71.3666687011719, -1.24558334501543, 218, 23, 'PPL', 'P'),
(84146, 'Varnville', 32.8502807617188, 0.573345559496543, -81.0794372558594, -1.4151031357789, 218, 48, 'PPL', 'P'),
(211129, 'Varona Village', 21.3369407653809, 0.372399868658895, -158.045837402344, -2.7584202317425, 218, 15, 'PPL', 'P'),
(58051, 'Varsh Ford', 37.3738899230957, 0.65229743343595, -90.4541702270508, -1.57872309262146, 218, 29, 'PPL', 'P'),
(107113, 'Varsity Park', 38.8236083984375, 0.677599794057657, -77.1125030517578, -1.34586707270735, 218, 53, 'PPL', 'P'),
(58052, 'Varvol', 37.0972213745117, 0.647468656326446, -91.9608306884766, -1.60501927838296, 218, 29, 'PPL', 'P'),
(153354, 'Varysburg', 42.7633285522461, 0.746360882348794, -78.3099975585938, -1.36676729462618, 218, 40, 'PPL', 'P'),
(200258, 'Varyville (historical)', 41.4930610656738, 0.724190532327075, -118.80638885498, -2.07356265792411, 218, 39, 'PPL', 'P'),
(138551, 'Vasa', 44.5033302307129, 0.776729640628268, -92.7222213745117, -1.61830805274829, 218, 28, 'PPL', 'P'),
(209037, 'Vasa Park', 47.5800018310547, 0.830427690056835, -122.110832214355, -2.13123607449086, 218, 56, 'PPL', 'P'),
(98773, 'Vasco', 33.4150009155273, 0.583201785532872, -95.495002746582, -1.66670221712888, 218, 51, 'PPL', 'P'),
(209038, 'Vashon', 47.4474983215332, 0.828115067545238, -122.458610534668, -2.13730595124737, 218, 56, 'PPL', 'P'),
(209039, 'Vashon Heights', 47.5058288574219, 0.829133127450948, -122.464172363281, -2.1374030234691, 218, 56, 'PPL', 'P'),
(6526, 'Vashti', 31.7030601501465, 0.553322782577864, -87.6380615234375, -1.52957272364934, 218, 2, 'PPL', 'P'),
(69784, 'Vashti', 35.9977798461914, 0.628279781724098, -81.1055603027344, -1.41555906895752, 218, 33, 'PPL', 'P'),
(98774, 'Vashti', 33.5555610656738, 0.585655022950025, -98.0405578613281, -1.71113053517219, 218, 51, 'PPL', 'P'),
(107114, 'Vashti', 36.8633308410645, 0.643386496428545, -79.6397171020508, -1.38997527878762, 218, 53, 'PPL', 'P'),
(141003, 'Vashti', 47.1888885498047, 0.823601475550744, -99.0802764892578, -1.72927704852388, 218, 34, 'PPL', 'P'),
(185902, 'Vasona Junction', 37.2572212219238, 0.650261180466476, -121.963607788086, -2.1286665235131, 218, 6, 'PPL', 'P'),
(91559, 'Vasper', 36.271110534668, 0.633050302184757, -84.1949996948242, -1.4694799583903, 218, 50, 'PPL', 'P'),
(779, 'Vass', 35.2561111450195, 0.615335220929659, -79.2825012207031, -1.38374068551769, 218, 33, 'PPL', 'P'),
(129143, 'Vassalboro', 44.459171295166, 0.775958921808799, -69.6780624389648, -1.21611160597013, 218, 26, 'PPL', 'P'),
(34255, 'Vassar', 38.6472206115723, 0.674521246416553, -95.6222229003906, -1.66892262768774, 218, 20, 'PPL', 'P'),
(133499, 'Vassar', 43.371940612793, 0.756983166672684, -83.5833282470703, -1.45880427768656, 218, 27, 'PPL', 'P'),
(195758, 'Vassar', 46.8291702270508, 0.817323206438937, -116.616111755371, -2.03533511100489, 218, 17, 'PPL', 'P'),
(62150, 'Vassar (historical)', 33.8369407653809, 0.590566025158186, -88.4250030517578, -1.54330744433921, 218, 30, 'PPL', 'P'),
(187488, 'Vastine', 37.6344413757324, 0.656844914155315, -106.102783203125, -1.85184291242427, 218, 7, 'PPL', 'P'),
(58053, 'Vastus', 36.5511093139648, 0.637937202785052, -90.4080581665039, -1.57791828534004, 218, 29, 'PPL', 'P'),
(91561, 'Vater (historical)', 35.3486099243164, 0.616949629182465, -87.2347183227539, -1.52253305678188, 218, 50, 'PPL', 'P'),
(43459, 'Vatican', 30.3091697692871, 0.52899480601999, -92.1163864135742, -1.60773423795624, 218, 22, 'PPL', 'P'),
(98777, 'Vattman', 27.3328609466553, 0.477048417508909, -97.7451019287109, -1.70597385635347, 218, 51, 'PPL', 'P'),
(98775, 'Vattmannville', 27.3319396972656, 0.477032338673827, -97.7519378662109, -1.7060931659703, 218, 51, 'PPL', 'P'),
(74645, 'Vauces', 39.2702789306641, 0.685395665516646, -82.8899993896484, -1.44670340632546, 218, 41, 'PPL', 'P'),
(12532, 'Vaucluse', 33.3463897705078, 0.582004295148718, -91.1986083984375, -1.59171598978969, 218, 4, 'PPL', 'P'),
(84147, 'Vaucluse', 33.6124992370605, 0.586648781510789, -81.8099975585938, -1.42785381844598, 218, 48, 'PPL', 'P'),
(107115, 'Vaucluse', 39.0580596923828, 0.681691741072564, -78.2472229003906, -1.36567167015372, 218, 53, 'PPL', 'P'),
(111849, 'Vaucluse', 39.3847198486328, 0.687393036334205, -81.2316665649414, -1.41776003844042, 218, 58, 'PPL', 'P'),
(107116, 'Vaucluse Shores', 37.4241714477539, 0.653175011594159, -75.9791717529297, -1.32608671002689, 218, 53, 'PPL', 'P'),
(176808, 'Vaudreuil', 44.3063888549805, 0.77329236518833, -90.8097229003906, -1.58492865743551, 218, 57, 'PPL', 'P'),
(31375, 'Vaughan', 37.9013900756836, 0.661504047903382, -87.6302795410156, -1.52943690243375, 218, 19, 'PPL', 'P'),
(62153, 'Vaughan', 32.8063888549805, 0.572579501208982, -90.0416717529297, -1.5715236360886, 218, 30, 'PPL', 'P'),
(69785, 'Vaughan', 36.4263916015625, 0.635760468068076, -78.0038909912109, -1.36142472716337, 218, 33, 'PPL', 'P'),
(98776, 'Vaughan', 31.9144401550293, 0.557012059635951, -97.1733322143555, -1.69599459227478, 218, 51, 'PPL', 'P'),
(111850, 'Vaughan', 38.2783317565918, 0.668082921323232, -81.1447219848633, -1.41624256925129, 218, 58, 'PPL', 'P'),
(84148, 'Vaughans Crossroads', 34.208610534668, 0.597052886362374, -80.1025009155273, -1.39805238005772, 218, 48, 'PPL', 'P'),
(6528, 'Vaughanville', 31.0058307647705, 0.541153834161397, -85.914436340332, -1.49948978913386, 218, 2, 'PPL', 'P'),
(84149, 'Vaughanville', 34.2433280944824, 0.597658822089394, -81.9130630493164, -1.42965265060428, 218, 48, 'PPL', 'P'),
(6529, 'Vaughn', 31.0297203063965, 0.541570785319562, -87.8611068725586, -1.53346559937277, 218, 2, 'PPL', 'P'),
(12533, 'Vaughn', 36.3152809143066, 0.633821220741308, -94.3038864135742, -1.64591331534362, 218, 4, 'PPL', 'P'),
(18429, 'Vaughn', 26.6322193145752, 0.464819914152565, -80.8691711425781, -1.41143329979677, 218, 12, 'PPL', 'P'),
(25700, 'Vaughn', 33.2808303833008, 0.580860067986365, -84.3916702270508, -1.47291250671931, 218, 13, 'PPL', 'P'),
(34256, 'Vaughn', 38.3411102294922, 0.669178612374717, -99.2858276367188, -1.73286459282832, 218, 20, 'PPL', 'P'),
(43460, 'Vaughn', 32.9519386291504, 0.575119823993781, -91.9630584716797, -1.60505816053488, 218, 22, 'PPL', 'P'),
(62154, 'Vaughn', 31.576940536499, 0.551121580068373, -90.5733337402344, -1.58080288827476, 218, 30, 'PPL', 'P'),
(107118, 'Vaughn', 38.7186088562012, 0.675767206332546, -78.3977813720703, -1.3682994112013, 218, 53, 'PPL', 'P'),
(168333, 'Vaughn', 40.3216705322266, 0.703745910691728, -76.7850036621094, -1.34015113005971, 218, 45, 'PPL', 'P'),
(189778, 'Vaughn', 34.6016693115234, 0.603913056172363, -105.207778930664, -1.83622214105041, 218, 38, 'PPL', 'P'),
(197760, 'Vaughn', 47.5605583190918, 0.830088336754932, -111.544998168945, -1.94682748217914, 218, 31, 'PPL', 'P'),
(201721, 'Vaughn', 44.0238914489746, 0.768361855325184, -123.435829162598, -2.15436163381656, 218, 43, 'PPL', 'P'),
(209040, 'Vaughn', 47.3444404602051, 0.826316368544998, -122.761940002441, -2.14260004917834, 218, 56, 'PPL', 'P'),
(6530, 'Vaughn Corners', 34.7719383239746, 0.606884811053756, -86.7141723632813, -1.51344781588113, 218, 2, 'PPL', 'P'),
(169643, 'Vaughn Hollow', 41.7194404602051, 0.728141598120317, -71.7563934326172, -1.25238532475561, 218, 47, 'PPL', 'P'),
(14780, 'Vaughn Landing', 38.7786102294922, 0.676814427852193, -75.2825012207031, -1.31392751543792, 218, 10, 'PPL', 'P'),
(153356, 'Vaughns Corners', 43.371940612793, 0.756983166672684, -73.5644378662109, -1.28394165314417, 218, 40, 'PPL', 'P'),
(91562, 'Vaughns Gap', 36.0686111450195, 0.629516021102113, -86.8986129760742, -1.51666691184876, 218, 50, 'PPL', 'P'),
(91563, 'Vaughns Grove', 36.0019416809082, 0.62835241944283, -88.8561096191406, -1.55083167336701, 218, 50, 'PPL', 'P'),
(38670, 'Vaughns Mill', 37.813060760498, 0.659962410527362, -83.9166717529297, -1.46462221940394, 218, 21, 'PPL', 'P'),
(158096, 'Vaughnsville', 40.8816719055176, 0.713519778471346, -84.1505584716797, -1.46870431272282, 218, 41, 'PPL', 'P'),
(133502, 'Vaughsville', 47.3813896179199, 0.826961253002961, -88.2958297729492, -1.5410529453184, 218, 27, 'PPL', 'P'),
(84150, 'Vaught', 33.7786102294922, 0.589547965252476, -78.7925033569336, -1.37518860946718, 218, 48, 'PPL', 'P'),
(62155, 'Vaughts', 31.1691703796387, 0.544004648239786, -90.2627792358398, -1.57538268966618, 218, 30, 'PPL', 'P'),
(91564, 'Vaughtsville (historical)', 36.4147186279297, 0.635556736244685, -81.8375015258789, -1.42833385323247, 218, 50, 'PPL', 'P'),
(146519, 'Vauxhall', 40.7313919067383, 0.710896897692754, -74.283332824707, -1.29648873714592, 218, 37, 'PPL', 'P'),
(138553, 'Vawter', 45.9122200012207, 0.801319405921296, -94.2447204589844, -1.64488067463094, 218, 28, 'PPL', 'P'),
(168334, 'Vawter', 41.9261093139648, 0.731748650079748, -76.4066696166992, -1.33354795529492, 218, 45, 'PPL', 'P'),
(107120, 'Vawter Corner', 38.1288909912109, 0.665474687930635, -78.0144424438477, -1.36160888475275, 218, 53, 'PPL', 'P'),
(123884, 'Vawter Park', 41.3875007629395, 0.722348157484959, -85.692497253418, -1.49561622132834, 218, 19, 'PPL', 'P'),
(195759, 'Vay', 48.1155586242676, 0.839774919429822, -116.77693939209, -2.03814208279383, 218, 17, 'PPL', 'P'),
(179438, 'Vaya Chin', 32.3472213745117, 0.564565516856715, -112.326110839844, -1.96046047011537, 218, 5, 'PPL', 'P'),
(113355, 'Vayland', 44.4936103820801, 0.77655999726683, -98.7986068725586, -1.72436098630965, 218, 49, 'PPL', 'P'),
(98778, 'Veach', 31.2213897705078, 0.544916048543838, -94.179443359375, -1.6437413743166, 218, 51, 'PPL', 'P'),
(38671, 'Veachland', 38.2113914489746, 0.666914592553014, -85.1975021362305, -1.48697692675212, 218, 21, 'PPL', 'P'),
(25703, 'Veal', 32.7791709899902, 0.572104459849539, -82.9274978637695, -1.44735787816334, 218, 13, 'PPL', 'P'),
(192368, 'Vealmoor', 32.5205612182617, 0.567590867855045, -101.569999694824, -1.77273091592432, 218, 51, 'PPL', 'P'),
(38672, 'Vealsburg', 36.6027793884277, 0.63883901570918, -88.5400009155273, -1.54531453569475, 218, 21, 'PPL', 'P'),
(201722, 'Veatch', 43.7561111450195, 0.763688207349177, -123.101936340332, -2.14853410471925, 218, 43, 'PPL', 'P'),
(25714, 'Veazey', 33.5044403076172, 0.584762797405822, -83.14111328125, -1.4510861705314, 218, 13, 'PPL', 'P'),
(38673, 'Veazey', 37.4480590820313, 0.653591929462811, -87.5902786254883, -1.52873875475398, 218, 21, 'PPL', 'P'),
(43462, 'Veazie', 30.5294399261475, 0.532839245501088, -92.1388931274414, -1.60812705421703, 218, 22, 'PPL', 'P'),
(129144, 'Veazie', 44.8386116027832, 0.782581404491499, -68.7058334350586, -1.19914300876858, 218, 26, 'PPL', 'P'),
(209041, 'Veazie', 47.2477798461914, 0.82462932257346, -121.95361328125, -2.1284920864617, 218, 56, 'PPL', 'P'),
(171492, 'Veblen', 45.8630599975586, 0.8004614019971, -97.2872161865234, -1.69798224255436, 218, 49, 'PPL', 'P'),
(171495, 'Vedin Corner', 43.0825004577637, 0.75193148297994, -97.3986129760742, -1.69992648330817, 218, 49, 'PPL', 'P'),
(38674, 'Veech', 38.1199989318848, 0.665319492218111, -85.3211135864258, -1.4891343535512, 218, 21, 'PPL', 'P'),
(38675, 'Veechdale', 38.211109161377, 0.666909665704997, -85.3499984741211, -1.48963848994555, 218, 21, 'PPL', 'P'),
(123885, 'Veedersburg', 40.1130599975586, 0.700104970007426, -87.2624969482422, -1.52301788525833, 218, 19, 'PPL', 'P'),
(176809, 'Veedum', 44.4097213745117, 0.775095857878531, -90.1733322143555, -1.57382154463517, 218, 57, 'PPL', 'P'),
(176810, 'Veefkind', 44.6916694641113, 0.780016780361752, -90.3733291625977, -1.57731214987594, 218, 57, 'PPL', 'P'),
(25704, 'Vega', 33.0233306884766, 0.576365850488802, -84.2886123657227, -1.47111380771907, 218, 13, 'PPL', 'P'),
(74647, 'Vega', 38.9580612182617, 0.67994643845218, -82.4972229003906, -1.43984816336348, 218, 41, 'PPL', 'P'),
(133503, 'Vega', 45.785831451416, 0.799113509590384, -87.6030578613281, -1.52896179449528, 218, 27, 'PPL', 'P'),
(153355, 'Vega', 42.2552795410156, 0.737493754341321, -74.5302810668945, -1.3007987970541, 218, 40, 'PPL', 'P'),
(185904, 'Vega', 34.1919403076172, 0.596761936013283, -118.349998474121, -2.06559714310368, 218, 6, 'PPL', 'P'),
(192369, 'Vega', 35.2427787780762, 0.615102527229413, -102.427780151367, -1.78770200915025, 218, 51, 'PPL', 'P'),
(185905, 'Vega (historical)', 36.8958282470703, 0.643953683161705, -121.689720153809, -2.12388628251446, 218, 6, 'PPL', 'P'),
(206255, 'Vega Park', 40.7000007629395, 0.710349018877498, -112.075561523438, -1.95608755960546, 218, 52, 'PPL', 'P'),
(111851, 'Vegan', 38.9638900756836, 0.680048171205821, -80.1138916015625, -1.3982511850331, 218, 58, 'PPL', 'P'),
(189779, 'Vegas Junction', 34.976390838623, 0.610453180598353, -104.990562438965, -1.83243099808062, 218, 38, 'PPL', 'P'),
(189780, 'Veguita', 34.5161094665527, 0.602419755170129, -106.766670227051, -1.86342992685304, 218, 38, 'PPL', 'P'),
(18430, 'Vehlin', 25.5872192382813, 0.446581222137643, -80.4194412231445, -1.40358403195793, 218, 12, 'PPL', 'P'),
(168335, 'Veilstown', 41.5686111450195, 0.725509129961801, -77.1033325195313, -1.34570701672584, 218, 45, 'PPL', 'P'),
(69787, 'Vein Mountain', 35.5519409179688, 0.62049842449305, -81.9641723632813, -1.4305446764114, 218, 33, 'PPL', 'P'),
(12538, 'Veits (historical)', 34.7291717529297, 0.606138393579234, -91.585563659668, -1.59846963315607, 218, 4, 'PPL', 'P'),
(25705, 'Vel Manor', 33.8105583190918, 0.590105564605711, -84.5205612182617, -1.4751620788921, 218, 13, 'PPL', 'P'),
(189781, 'Velarde', 36.1588897705078, 0.631091680361058, -105.974166870117, -1.84959813394144, 218, 38, 'PPL', 'P'),
(98779, 'Velasco', 28.961669921875, 0.505476497012528, -95.3602828979492, -1.66435091220245, 218, 51, 'PPL', 'P'),
(98780, 'Velasco Heights', 28.982780456543, 0.50584494534934, -95.3708267211914, -1.66453493663378, 218, 51, 'PPL', 'P'),
(206257, 'Velasquez', 40.6930618286133, 0.710227911626926, -111.896942138672, -1.95297006323341, 218, 52, 'PPL', 'P'),
(187489, 'Velasquez Plaza', 37.1236114501953, 0.647929250036975, -104.781936645508, -1.82878979108021, 218, 7, 'PPL', 'P'),
(206258, 'Velbar', 40.6680603027344, 0.709791552682317, -111.950828552246, -1.95391055857237, 218, 52, 'PPL', 'P'),
(179439, 'Velda Rose Estates', 33.4194412231445, 0.583279283520593, -111.689170837402, -1.9493437699351, 218, 5, 'PPL', 'P'),
(179440, 'Velda Rose Gardens', 33.4124984741211, 0.583158109690994, -111.712783813477, -1.94975589411379, 218, 5, 'PPL', 'P'),
(58054, 'Velda Village', 38.689998626709, 0.675267863628156, -90.2941665649414, -1.57593050190241, 218, 29, 'PPL', 'P'),
(58055, 'Velda Village Hills', 38.690559387207, 0.675277650745162, -90.2872161865234, -1.57580919491475, 218, 29, 'PPL', 'P'),
(12539, 'Velie', 33.6994400024414, 0.588166184120889, -92.8202819824219, -1.62001953322283, 218, 4, 'PPL', 'P'),
(28851, 'Velma', 39.514720916748, 0.689661983003926, -89.2324981689453, -1.55740089282791, 218, 18, 'PPL', 'P'),
(43464, 'Velma', 30.6591701507568, 0.535103465059873, -90.498893737793, -1.57950366513697, 218, 22, 'PPL', 'P'),
(62156, 'Velma', 34.0602798461914, 0.594464027466708, -89.6444396972656, -1.56459062882279, 218, 30, 'PPL', 'P'),
(77545, 'Velma', 34.4599990844727, 0.601440444258279, -97.6736068725586, -1.70472603222471, 218, 42, 'PPL', 'P'),
(107121, 'Velma', 37.6469383239746, 0.657063027048593, -76.7161102294922, -1.33894871282754, 218, 53, 'PPL', 'P'),
(199749, 'Velma', 41.6313896179199, 0.726604821013287, -101.941390991211, -1.77921291685952, 218, 35, 'PPL', 'P'),
(52370, 'Velmeade', 38.9174995422363, 0.67923850365541, -76.6638870239258, -1.33803724594446, 218, 25, 'PPL', 'P'),
(209042, 'Velox', 47.6958312988281, 0.832449295640314, -117.182502746582, -2.04522049865516, 218, 56, 'PPL', 'P'),
(31377, 'Velpen', 38.355281829834, 0.669425953460958, -87.101936340332, -1.52021557400129, 218, 19, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(25706, 'Velpoe', 34.1766700744629, 0.596495420167193, -83.2341690063477, -1.45271029932218, 218, 13, 'PPL', 'P'),
(58056, 'Velsor', 37.0202789306641, 0.646125757346773, -93.0355606079102, -1.62377685404677, 218, 29, 'PPL', 'P'),
(25707, 'Velta', 33.5963897705078, 0.586367618278703, -84.0149993896484, -1.46633836041039, 218, 13, 'PPL', 'P'),
(43463, 'Veltin', 30.4952793121338, 0.532243030312046, -92.0888900756836, -1.60725433632781, 218, 22, 'PPL', 'P'),
(199041, 'Velva', 48.0561103820801, 0.838737351869128, -100.928886413574, -1.76154137828824, 218, 34, 'PPL', 'P'),
(209043, 'Velvet', 48.9861106872559, 0.854968919238997, -117.825828552246, -2.05644865212704, 218, 56, 'PPL', 'P'),
(52371, 'Velvet Hills', 39.457218170166, 0.688658370747129, -76.7850036621094, -1.34015113005971, 218, 25, 'PPL', 'P'),
(52372, 'Velvet Hills South', 39.4516716003418, 0.688561564841505, -76.783332824707, -1.34012196844578, 218, 25, 'PPL', 'P'),
(12540, 'Velvet Ridge', 35.4130592346191, 0.618074481847887, -91.5761108398438, -1.59830465032654, 218, 4, 'PPL', 'P'),
(52373, 'Velvet Ridge', 39.4297218322754, 0.688178469118697, -76.73388671875, -1.33925897109454, 218, 25, 'PPL', 'P'),
(52375, 'Velvet Run', 39.5952796936035, 0.691067998901433, -76.9499969482422, -1.34303080614641, 218, 25, 'PPL', 'P'),
(52381, 'Velvet Valley', 39.4247207641602, 0.68809118401397, -76.7361068725586, -1.3392977200884, 218, 25, 'PPL', 'P'),
(98781, 'Vemo', 31.5499992370605, 0.550651365688406, -97.084716796875, -1.69444796147171, 218, 51, 'PPL', 'P'),
(58057, 'Venable', 37.4061088562012, 0.652859759900121, -91.9941711425781, -1.60560117908114, 218, 29, 'PPL', 'P'),
(69788, 'Venable', 35.5261116027832, 0.620047617899527, -82.6069412231445, -1.4417631093453, 218, 33, 'PPL', 'P'),
(98782, 'Venable', 31.4638900756836, 0.549148477306247, -94.0894393920898, -1.64217050874762, 218, 51, 'PPL', 'P'),
(74646, 'Venable (historical)', 39.5277786254883, 0.689889883014209, -84.146110534668, -1.46862668157704, 218, 41, 'PPL', 'P'),
(69789, 'Venable Community', 35.563060760498, 0.62069250235749, -82.6033325195313, -1.44170012558552, 218, 33, 'PPL', 'P'),
(91565, 'Venable Spring', 35.6074981689453, 0.621468081445948, -86.7822189331055, -1.51463545256925, 218, 50, 'PPL', 'P'),
(98783, 'Venadito', 26.0522193908691, 0.454697005822578, -97.7688903808594, -1.70638904316741, 218, 51, 'PPL', 'P'),
(185907, 'Venado', 38.6055603027344, 0.673794136859934, -123.006942749023, -2.14687615378262, 218, 6, 'PPL', 'P'),
(200261, 'Venado (historical)', 40.9347190856934, 0.714445626424312, -118.249717712402, -2.06384691363528, 218, 39, 'PPL', 'P'),
(34257, 'Venango', 38.6388893127441, 0.674375837821034, -97.9861068725586, -1.71018018613719, 218, 20, 'PPL', 'P'),
(168361, 'Venango', 41.7724990844727, 0.729067645810365, -80.1133270263672, -1.39824133133707, 218, 45, 'PPL', 'P'),
(199750, 'Venango', 40.7636108398438, 0.711459224156924, -102.040283203125, -1.780938911562, 218, 35, 'PPL', 'P'),
(201723, 'Venator', 43.3480606079102, 0.756566381962087, -118.304168701172, -2.06479726267027, 218, 43, 'PPL', 'P'),
(197761, 'Vendome', 45.8177795410156, 0.799671108943619, -112.241668701172, -1.95898667676812, 218, 31, 'PPL', 'P'),
(12542, 'Vendor', 35.9472198486328, 0.6273973432969, -93.0772171020508, -1.62450389702436, 218, 4, 'PPL', 'P'),
(98784, 'Venecia Colonia', 26.2789993286133, 0.458655062413681, -98.6490020751953, -1.72174989001888, 218, 51, 'PPL', 'P'),
(158097, 'Venedocia', 40.7863883972168, 0.711856767528646, -84.4569396972656, -1.47405167387559, 218, 41, 'PPL', 'P'),
(28852, 'Venedy', 38.3950004577637, 0.670119174292706, -89.6458282470703, -1.56461486358871, 218, 18, 'PPL', 'P'),
(209051, 'Venersborg', 45.7738914489746, 0.798905117235085, -122.423332214355, -2.13669022840334, 218, 56, 'PPL', 'P'),
(201724, 'Veneta', 44.0488891601563, 0.768798147690766, -123.349716186523, -2.15285867885538, 218, 43, 'PPL', 'P'),
(18431, 'Venetia', 30.2472190856934, 0.527913562617418, -81.6938934326172, -1.42582741917254, 218, 12, 'PPL', 'P'),
(98785, 'Venetia', 31.1466693878174, 0.54361193184754, -96.2644424438477, -1.68013147324172, 218, 51, 'PPL', 'P'),
(168342, 'Venetia', 40.2466697692871, 0.702436900436927, -80.0425033569336, -1.39700522511711, 218, 45, 'PPL', 'P'),
(18432, 'Venetia Terrace', 30.2361106872559, 0.52771968449006, -81.7180633544922, -1.42624926388921, 218, 12, 'PPL', 'P'),
(43465, 'Venetian Isles', 30.0669403076172, 0.524767104368517, -89.8127822875977, -1.56752876129542, 218, 22, 'PPL', 'P'),
(121799, 'Venetian Village', 42.398609161377, 0.73999532813226, -88.0524978637695, -1.53680600232805, 218, 18, 'PPL', 'P'),
(212220, 'Venetie', 67.0138931274414, 1.16961307965345, -146.418609619141, -2.55548682404624, 218, 1, 'PPL', 'P'),
(212221, 'Venetie Landing', 66.6105575561523, 1.16257354594405, -145.992218017578, -2.54804488669613, 218, 1, 'PPL', 'P'),
(179441, 'Venezia', 34.3930587768555, 0.600272115488062, -112.416107177734, -1.9620312025263, 218, 5, 'PPL', 'P'),
(107122, 'Venia', 37.0911102294922, 0.647361996724788, -82.0500030517578, -1.43204270452457, 218, 53, 'PPL', 'P'),
(12543, 'Venice', 33.0369415283203, 0.576603404458037, -92.0277786254883, -1.60618774031123, 218, 4, 'PPL', 'P'),
(18433, 'Venice', 27.0994396209717, 0.47297444683136, -82.4544372558594, -1.43910141299382, 218, 12, 'PPL', 'P'),
(28854, 'Venice', 38.6722183227539, 0.674957538782135, -90.1697235107422, -1.57375856087539, 218, 18, 'PPL', 'P'),
(43466, 'Venice', 29.2769393920898, 0.510978987298795, -89.3547210693359, -1.55953408486106, 218, 22, 'PPL', 'P'),
(58058, 'Venice', 37.2077789306641, 0.649398249694263, -91.3997192382813, -1.59522603610641, 218, 29, 'PPL', 'P'),
(143267, 'Venice', 41.2338905334473, 0.719667153215576, -96.3533325195313, -1.68168289773474, 218, 35, 'PPL', 'P'),
(158098, 'Venice', 41.4458312988281, 0.723366217390669, -82.7705612182617, -1.4446188169822, 218, 41, 'PPL', 'P'),
(168343, 'Venice', 40.3211097717285, 0.703736123574722, -80.2188873291016, -1.40008370617918, 218, 45, 'PPL', 'P'),
(185908, 'Venice', 33.9908294677734, 0.593251889696558, -118.459167480469, -2.06750250170558, 218, 6, 'PPL', 'P'),
(192839, 'Venice', 38.8002815246582, 0.677192663306011, -112.005561828613, -1.95486583445538, 218, 52, 'PPL', 'P'),
(209045, 'Venice', 46.7241706848145, 0.815490618713826, -123.96443939209, -2.16358762278093, 218, 56, 'PPL', 'P'),
(18434, 'Venice Beach', 27.0997200012207, 0.472979340389863, -82.4577789306641, -1.4391597362217, 218, 12, 'PPL', 'P'),
(52376, 'Venice Beach', 38.9252815246582, 0.679374324871004, -76.4655609130859, -1.33457580231763, 218, 25, 'PPL', 'P'),
(113212, 'Venice Center', 42.7391700744629, 0.745939237369208, -76.5569381713867, -1.33617063633643, 218, 40, 'PPL', 'P'),
(18435, 'Venice East', 27.0566692352295, 0.472227962777811, -82.3786087036133, -1.43777795509011, 218, 12, 'PPL', 'P'),
(18436, 'Venice Gardens', 27.0727806091309, 0.47250915929941, -82.4077835083008, -1.43828715149053, 218, 12, 'PPL', 'P'),
(18437, 'Venice Groves', 27.0524997711182, 0.472155191901024, -82.4047164916992, -1.43823362195262, 218, 12, 'PPL', 'P'),
(107123, 'Venice Heights', 37.6847190856934, 0.657722425734496, -77.8988876342773, -1.35959207285924, 218, 53, 'PPL', 'P'),
(158099, 'Venice Heights', 41.2527809143066, 0.719996852558528, -80.7408294677734, -1.40919331500391, 218, 41, 'PPL', 'P'),
(52377, 'Venice on the Bay', 39.1552810668945, 0.683388574161108, -76.4794387817383, -1.33481801681877, 218, 25, 'PPL', 'P'),
(71499, 'Venice Park', 39.3763885498047, 0.687247627738687, -74.445556640625, -1.29932007685884, 218, 37, 'PPL', 'P'),
(185909, 'Venida', 36.3327789306641, 0.634126618739312, -119.129173278809, -2.07919630889406, 218, 6, 'PPL', 'P'),
(206259, 'Venier', 40.6188888549805, 0.708933349021039, -111.841110229492, -1.95199561259055, 218, 52, 'PPL', 'P'),
(141004, 'Venlo', 46.4863891601563, 0.811340548208128, -97.4458312988281, -1.70075059850749, 218, 34, 'PPL', 'P'),
(209046, 'Venner', 46.4049987792969, 0.80992001808268, -120.500831604004, -2.10313626288111, 218, 56, 'PPL', 'P'),
(185910, 'Venola', 35.3108291625977, 0.616290230496561, -119.053329467773, -2.07787258467424, 218, 6, 'PPL', 'P'),
(12544, 'Venquin (historical)', 35.9513893127441, 0.627470114173687, -93.7458267211914, -1.63617333628887, 218, 4, 'PPL', 'P'),
(179442, 'Ventana', 32.4661102294922, 0.566640518820051, -112.242500305176, -1.95900119099606, 218, 5, 'PPL', 'P'),
(107125, 'Venter', 37.7622184753418, 0.659075045252148, -77.1355590820313, -1.34626947634806, 218, 53, 'PPL', 'P'),
(189782, 'Ventero', 36.9836082458496, 0.6454857331578, -105.405281066895, -1.83966920360735, 218, 38, 'PPL', 'P'),
(38676, 'Venters', 37.3313903808594, 0.651555676493336, -82.4377822875977, -1.43881072896084, 218, 21, 'PPL', 'P'),
(69790, 'Venters', 35.4694404602051, 0.619058519870671, -77.3480606079102, -1.34997832764016, 218, 33, 'PPL', 'P'),
(84151, 'Venters', 33.7844390869141, 0.589649698006117, -79.4491729736328, -1.38664965637639, 218, 48, 'PPL', 'P'),
(52378, 'Ventnor', 39.1247215270996, 0.682855209573792, -76.4541702270508, -1.33437699734226, 218, 25, 'PPL', 'P'),
(71500, 'Ventnor City', 39.3402786254883, 0.68661739066672, -74.477783203125, -1.29988253648106, 218, 37, 'PPL', 'P'),
(52379, 'Ventnor Forest', 39.1136093139648, 0.682661264867407, -76.4522171020508, -1.3343429088803, 218, 25, 'PPL', 'P'),
(71502, 'Ventnor Heights', 39.3494415283203, 0.686777313490179, -74.4850006103516, -1.30000850400062, 218, 37, 'PPL', 'P'),
(38677, 'Vento', 37.4180603027344, 0.653068351992501, -85.8930587768555, -1.49911668026514, 218, 21, 'PPL', 'P'),
(52380, 'Venton', 38.1966705322266, 0.666657664086848, -75.7794418334961, -1.32260076531804, 218, 25, 'PPL', 'P'),
(107124, 'Ventosa', 36.8461112976074, 0.64308595869953, -76.2302780151367, -1.33046934107478, 218, 53, 'PPL', 'P'),
(200262, 'Ventosa', 40.8572196960449, 0.713093006906661, -114.803329467773, -2.00369609146448, 218, 39, 'PPL', 'P'),
(43467, 'Ventress', 30.6816692352295, 0.535496148162605, -91.4080581665039, -1.59537157785998, 218, 22, 'PPL', 'P'),
(185911, 'Ventucopa', 34.8313903808594, 0.607922445193478, -119.468887329102, -2.08512543758696, 218, 6, 'PPL', 'P'),
(98786, 'Ventura', 30.1913890838623, 0.526939145264072, -95.6600036621094, -1.66958202637364, 218, 51, 'PPL', 'P'),
(118185, 'Ventura', 43.1263885498047, 0.752697474688474, -93.4775009155273, -1.63149016751197, 218, 16, 'PPL', 'P'),
(185912, 'Ventura', 34.2783317565918, 0.598269751243458, -119.292221069336, -2.08204202967686, 218, 6, 'PPL', 'P'),
(118186, 'Ventura Heights', 43.1177787780762, 0.752547205823967, -93.4738922119141, -1.63142718375219, 218, 16, 'PPL', 'P'),
(25708, 'Venture Cove', 34.3283309936523, 0.59914240255365, -83.8958282470703, -1.46425843159904, 218, 13, 'PPL', 'P'),
(179443, 'Venture Out', 33.4116706848145, 0.583143662042081, -111.723327636719, -1.94993991854512, 218, 5, 'PPL', 'P'),
(168344, 'Venturetown', 41.8633308410645, 0.730652959028262, -79.1549987792969, -1.38151534811082, 218, 45, 'PPL', 'P'),
(141005, 'Venturia', 45.9986114501953, 0.802827221151472, -99.5458297729492, -1.73740248616776, 218, 34, 'PPL', 'P'),
(12548, 'Venus', 35.9252815246582, 0.627014447311174, -93.6036071777344, -1.63369113699486, 218, 4, 'PPL', 'P'),
(18438, 'Venus', 27.0669403076172, 0.472407226808687, -81.3569412231445, -1.41994649369537, 218, 12, 'PPL', 'P'),
(38678, 'Venus', 38.4419403076172, 0.670938429223042, -84.192497253418, -1.46943628254843, 218, 21, 'PPL', 'P'),
(58059, 'Venus', 38.1802787780762, 0.666371574006747, -92.0338897705078, -1.60629439991289, 218, 29, 'PPL', 'P'),
(98787, 'Venus', 32.4333305358887, 0.566068405238874, -97.1022186279297, -1.69475342604874, 218, 51, 'PPL', 'P'),
(111852, 'Venus', 37.3619384765625, 0.65208884134357, -81.5369415283203, -1.42308809167529, 218, 58, 'PPL', 'P'),
(143268, 'Venus', 42.457218170166, 0.741018248306959, -98.2675018310547, -1.71509145466146, 218, 35, 'PPL', 'P'),
(168345, 'Venus', 41.3666687011719, 0.721984569417136, -79.4783325195313, -1.3871585864607, 218, 45, 'PPL', 'P'),
(185914, 'Venus', 35.2483291625977, 0.615199399714065, -116.794166564941, -2.0384427536809, 218, 6, 'PPL', 'P'),
(118187, 'Veo', 41.1541709899902, 0.718275784704064, -91.9077835083008, -1.60409343042999, 218, 16, 'PPL', 'P'),
(71, 'Vera', 33.6333312988281, 0.587012369578612, -99.5658264160156, -1.73775149342862, 218, 51, 'PPL', 'P'),
(28856, 'Vera', 39.0341682434082, 0.681274756624885, -89.1130599975586, -1.55531630348465, 218, 18, 'PPL', 'P'),
(34258, 'Vera', 39.0669403076172, 0.681846737048006, -96.0947189331055, -1.67716923916122, 218, 20, 'PPL', 'P'),
(58060, 'Vera', 39.3783302307129, 0.687281516463558, -91.1449966430664, -1.59078028814069, 218, 29, 'PPL', 'P'),
(77546, 'Vera', 36.4491691589355, 0.636158011439798, -95.8805618286133, -1.6734314925713, 218, 42, 'PPL', 'P'),
(107126, 'Vera', 37.413330078125, 0.652985793998709, -78.7638931274414, -1.37468926676279, 218, 53, 'PPL', 'P'),
(209047, 'Vera', 47.6555595397949, 0.831746420849615, -117.186393737793, -2.04528840926295, 218, 56, 'PPL', 'P'),
(58061, 'Vera Cruz', 36.913890838623, 0.644268934855743, -92.4933319091797, -1.61431317795512, 218, 29, 'PPL', 'P'),
(98788, 'Vera Cruz', 27.4413890838623, 0.478942590834228, -98.2644424438477, -1.7150380582816, 218, 51, 'PPL', 'P'),
(112496, 'Vera Cruz', 39.1719398498535, 0.683679324773117, -83.9625015258789, -1.46542209983735, 218, 41, 'PPL', 'P'),
(123886, 'Vera Cruz', 40.7011108398438, 0.710368393374428, -85.0791702270508, -1.48491164532677, 218, 19, 'PPL', 'P'),
(168347, 'Vera Cruz', 40.5055618286133, 0.706955419279437, -75.496940612793, -1.31767018887586, 218, 45, 'PPL', 'P'),
(6531, 'Vera Cruz (historical)', 31.5097198486328, 0.549948357739652, -86.5999984741211, -1.51145510559548, 218, 2, 'PPL', 'P'),
(189783, 'Vera Cruz (historical)', 33.6061096191406, 0.586537261640142, -105.700828552246, -1.84482748032273, 218, 38, 'PPL', 'P'),
(168348, 'Vera Cruz Station', 40.5125007629395, 0.707076526530008, -75.480827331543, -1.31738895906475, 218, 45, 'PPL', 'P'),
(74648, 'Vera Junction', 38.7611083984375, 0.67650896327516, -82.9916687011719, -1.44847787055978, 218, 41, 'PPL', 'P'),
(209048, 'Veradale', 47.6569404602051, 0.83177052245748, -117.195281982422, -2.04544353839645, 218, 56, 'PPL', 'P'),
(111854, 'Veranda (historical)', 38.6925010681152, 0.675311539470034, -82.0374984741211, -1.43182445847324, 218, 58, 'PPL', 'P'),
(185915, 'Verano', 38.3027801513672, 0.668509626308889, -122.473892211914, -2.13757266683054, 218, 6, 'PPL', 'P'),
(62158, 'Verba', 32.1355590820313, 0.560871312950612, -89.1741714477539, -1.55638289950122, 218, 30, 'PPL', 'P'),
(153358, 'Verbank', 41.7286109924316, 0.728301654101831, -73.7108306884766, -1.28649668989399, 218, 40, 'PPL', 'P'),
(153359, 'Verbank Village', 41.728328704834, 0.728296727253814, -73.728889465332, -1.28681187500901, 218, 40, 'PPL', 'P'),
(6532, 'Verbena', 32.7497215270996, 0.571590469759154, -86.5113906860352, -1.50990860795047, 218, 2, 'PPL', 'P'),
(107127, 'Verbena', 38.4652786254883, 0.671345759711769, -78.6163864135742, -1.37211478893701, 218, 53, 'PPL', 'P'),
(192370, 'Verbena', 33.2747192382813, 0.580753408384707, -101.195281982422, -1.76619085807736, 218, 51, 'PPL', 'P'),
(91566, 'Verble', 36.1083297729492, 0.63020924193386, -85.3099975585938, -1.48894034226579, 218, 50, 'PPL', 'P'),
(201725, 'Verboort', 45.5497207641602, 0.794992600698622, -123.085563659668, -2.14824834753429, 218, 43, 'PPL', 'P'),
(38679, 'Verda', 36.8486099243164, 0.64312956796238, -83.2191696166992, -1.45244851058703, 218, 21, 'PPL', 'P'),
(43468, 'Verda', 31.6997203826904, 0.553264492639505, -92.7727813720703, -1.61919049117549, 218, 22, 'PPL', 'P'),
(185916, 'Verdant', 33.1175003051758, 0.578009420355544, -115.558059692383, -2.01686861884823, 218, 6, 'PPL', 'P'),
(179444, 'Verde', 34.7161102294922, 0.605910426989923, -111.994171142578, -1.95466702948001, 218, 5, 'PPL', 'P'),
(185917, 'Verde', 35.1716690063477, 0.613861427582409, -120.556938171387, -2.10411550721393, 218, 6, 'PPL', 'P'),
(179445, 'Verde Glen', 34.3972206115723, 0.600344753206794, -111.269996643066, -1.94202780010455, 218, 5, 'PPL', 'P'),
(179446, 'Verde Real', 33.6266708374023, 0.58689612259703, -112.148330688477, -1.95735762112932, 218, 5, 'PPL', 'P'),
(179448, 'Verde River Meadows One', 34.5827789306641, 0.603583356829412, -111.870277404785, -1.95250467583292, 218, 5, 'PPL', 'P'),
(98789, 'Verde, Canada', 29.1916694641113, 0.509490746302631, -98.2752838134766, -1.71522727587705, 218, 51, 'PPL', 'P'),
(143269, 'Verdel', 42.8111114501953, 0.747194851244153, -98.1922225952148, -1.71377758413767, 218, 35, 'PPL', 'P'),
(58062, 'Verdella', 37.6063919067383, 0.656355358567931, -94.4383316040039, -1.64825982658009, 218, 29, 'PPL', 'P'),
(185918, 'Verdemont', 34.1930618286133, 0.596781510247295, -117.366668701172, -2.04843480093283, 218, 6, 'PPL', 'P'),
(77547, 'Verden', 35.0833282470703, 0.612319590469308, -98.0875015258789, -1.71194985668155, 218, 42, 'PPL', 'P'),
(84152, 'Verdery', 34.1091690063477, 0.595317304279969, -82.2494430541992, -1.43552358922736, 218, 48, 'PPL', 'P'),
(34259, 'Verdi', 38.9916687011719, 0.68053299968227, -97.5027770996094, -1.70174449022631, 218, 20, 'PPL', 'P'),
(98790, 'Verdi', 29.0497207641602, 0.507013274119558, -98.399169921875, -1.71738949636609, 218, 51, 'PPL', 'P'),
(107128, 'Verdi', 36.7763900756836, 0.641869093818445, -82.7038879394531, -1.44345514874389, 218, 53, 'PPL', 'P'),
(138556, 'Verdi', 44.208610534668, 0.771585811561807, -96.351936340332, -1.68165852981077, 218, 28, 'PPL', 'P'),
(190871, 'Verdi', 39.5183296203613, 0.689724966763706, -119.987777709961, -2.09418178318988, 218, 39, 'PPL', 'P'),
(185919, 'Verdi-Sierra Pines', 39.5244407653809, 0.689831626365364, -120.012222290039, -2.09460842159651, 218, 6, 'PPL', 'P'),
(18439, 'Verdie', 30.4349994659424, 0.53119094852341, -81.92138671875, -1.42979792604174, 218, 12, 'PPL', 'P'),
(107129, 'Verdiersville', 38.271671295166, 0.66796667434165, -77.9027786254883, -1.35965998346703, 218, 53, 'PPL', 'P'),
(143270, 'Verdigre', 42.5969390869141, 0.743456838338117, -98.033332824707, -1.71100443449457, 218, 35, 'PPL', 'P'),
(77548, 'Verdigris', 36.2347183227539, 0.632415138264773, -95.6908264160156, -1.67011998491384, 218, 42, 'PPL', 'P'),
(168349, 'Verdilla', 40.7433280944824, 0.711105223469026, -76.9008331298828, -1.34217273564319, 218, 45, 'PPL', 'P'),
(84153, 'Verdin Estates', 34.7744407653809, 0.606928486895633, -82.2880630493164, -1.43619763529926, 218, 48, 'PPL', 'P'),
(107130, 'Verdon', 37.878059387207, 0.661096850572708, -77.5058288574219, -1.35273190304925, 218, 53, 'PPL', 'P'),
(143274, 'Verdon', 40.1483306884766, 0.700720559693398, -95.7125015258789, -1.67049828694668, 218, 35, 'PPL', 'P'),
(171496, 'Verdon', 45.2438888549805, 0.789654826925776, -98.0972213745117, -1.71211950004299, 218, 49, 'PPL', 'P'),
(25709, 'Verdon Forest', 33.9594383239746, 0.592704010881302, -84.3394393920898, -1.47200090667817, 218, 13, 'PPL', 'P'),
(153360, 'Verdoy', 42.7644386291504, 0.746380256845725, -73.804443359375, -1.28813053922276, 218, 40, 'PPL', 'P'),
(185920, 'Verdugo City', 34.2113914489746, 0.597101422473241, -118.238609313965, -2.06365303550792, 218, 6, 'PPL', 'P'),
(43471, 'Verdun', 30.3394393920898, 0.529523110601235, -90.7344436645508, -1.58361478691172, 218, 22, 'PPL', 'P'),
(91567, 'Verdun', 36.4947204589844, 0.636953031604214, -84.5408325195313, -1.47551587984291, 218, 50, 'PPL', 'P'),
(43469, 'Verdunville', 29.7538890838623, 0.519303329786596, -91.4008331298828, -1.59524547718237, 218, 22, 'PPL', 'P'),
(111853, 'Verdunville', 37.8444404602051, 0.660510089605537, -82.0552825927734, -1.43213484989829, 218, 58, 'PPL', 'P'),
(192840, 'Verdure', 37.785831451416, 0.659487169430837, -109.34806060791, -1.90848368827834, 218, 52, 'PPL', 'P'),
(98791, 'Vereda Tropical Colonia', 26.2759990692139, 0.458602698008747, -98.3270034790039, -1.71612995432854, 218, 51, 'PPL', 'P'),
(18440, 'Vereen', 30.2727794647217, 0.52835967538952, -84.2411117553711, -1.47028476567173, 218, 12, 'PPL', 'P'),
(168350, 'Vereeville', 40.0875015258789, 0.699658890524838, -75.0561065673828, -1.30997618332857, 218, 45, 'PPL', 'P'),
(199043, 'Verendrye', 48.1211090087891, 0.839871791914474, -100.738609313965, -1.75822041640891, 218, 34, 'PPL', 'P'),
(202718, 'Verendrye Hill', 44.3569412231445, 0.774174670457473, -100.381942749023, -1.75199541051891, 218, 49, 'PPL', 'P'),
(71503, 'Verga', 39.8611106872559, 0.695707624994514, -75.1591720581055, -1.31177501548686, 218, 37, 'PPL', 'P'),
(138559, 'Vergas', 46.6566696166992, 0.814312502826602, -95.8050003051758, -1.67211269519949, 218, 28, 'PPL', 'P'),
(28857, 'Vergennes', 37.9022216796875, 0.661518562131322, -89.335563659668, -1.5591997249862, 218, 18, 'PPL', 'P'),
(172665, 'Vergennes', 44.1672210693359, 0.770863429116123, -73.2544403076172, -1.27853117507357, 218, 55, 'PPL', 'P'),
(192371, 'Verhalen', 31.1263904571533, 0.543257997738668, -103.593063354492, -1.80804003776297, 218, 51, 'PPL', 'P'),
(98792, 'Verhelle', 29.0438899993896, 0.506911508076403, -97.1927795410156, -1.69633401215571, 218, 51, 'PPL', 'P'),
(25710, 'Veribest', 33.9441719055176, 0.592437561614239, -82.9952774047852, -1.44854085431956, 218, 13, 'PPL', 'P'),
(192372, 'Veribest', 31.476390838623, 0.549366656778551, -100.259170532227, -1.74985263110583, 218, 51, 'PPL', 'P'),
(6533, 'Verlie', 33.2130584716797, 0.579677224988206, -86.8019409179688, -1.51497966614014, 218, 2, 'PPL', 'P'),
(209049, 'Verlot', 48.0905609130859, 0.83933862706424, -121.776107788086, -2.12539403116561, 218, 56, 'PPL', 'P'),
(133506, 'Vermilac', 46.5308303833008, 0.812116193875614, -88.4588928222656, -1.54389893241731, 218, 27, 'PPL', 'P'),
(28859, 'Vermilion', 39.5811080932617, 0.690820657815192, -87.5888900756836, -1.52871451998806, 218, 18, 'PPL', 'P'),
(133507, 'Vermilion', 46.7625007629395, 0.816159604779654, -85.1500015258789, -1.48614788470478, 218, 27, 'PPL', 'P'),
(153367, 'Vermilion', 43.4169387817383, 0.757768532878149, -76.2780609130859, -1.33130330997014, 218, 40, 'PPL', 'P'),
(158101, 'Vermilion', 41.4219398498535, 0.72294923294299, -82.3647232055664, -1.43753560743091, 218, 41, 'PPL', 'P'),
(121800, 'Vermilion City', 41.0958290100098, 0.717257525061272, -88.834716796875, -1.55045829818218, 218, 18, 'PPL', 'P'),
(28872, 'Vermilion Grove', 39.9249992370605, 0.696822690542931, -87.6549987792969, -1.52986833453034, 218, 18, 'PPL', 'P'),
(121802, 'Vermilion Heights', 40.1236114501953, 0.700289127596805, -87.6533279418945, -1.5298391729164, 218, 18, 'PPL', 'P'),
(168351, 'Vermilion Hill', 40.1805610656738, 0.70128308589465, -74.8288879394531, -1.30601047014933, 218, 45, 'PPL', 'P'),
(158103, 'Vermilion-on-the-Lake', 41.4283294677734, 0.723060752813637, -82.3238906860352, -1.43682294552321, 218, 41, 'PPL', 'P'),
(121803, 'Vermilionville', 41.2594413757324, 0.72011309954011, -88.9955596923828, -1.55326553628723, 218, 18, 'PPL', 'P'),
(34261, 'Vermillion', 39.7194404602051, 0.69323501308043, -96.2655563354492, -1.68015091431768, 218, 20, 'PPL', 'P'),
(84154, 'Vermillion', 34.4127807617188, 0.600616329058954, -82.3427810668945, -1.43715264486616, 218, 48, 'PPL', 'P'),
(138562, 'Vermillion', 44.6736106872559, 0.779701595246742, -92.9669418334961, -1.62257923050456, 218, 28, 'PPL', 'P'),
(171498, 'Vermillion', 42.7794418334961, 0.746642112159907, -96.9288864135742, -1.69172820820847, 218, 49, 'PPL', 'P'),
(192841, 'Vermillion', 38.8608283996582, 0.678249405626554, -111.96443939209, -1.95414811254161, 218, 52, 'PPL', 'P'),
(74649, 'Vermona', 39.1094398498535, 0.682588493990621, -84.2852783203125, -1.47105561764925, 218, 41, 'PPL', 'P'),
(121805, 'Vermont', 40.2941703796387, 0.703265942484268, -90.4277801513672, -1.57826249891093, 218, 18, 'PPL', 'P'),
(123887, 'Vermont', 40.4991683959961, 0.706843832829762, -86.0319366455078, -1.50154055633128, 218, 19, 'PPL', 'P'),
(172668, 'Vermont', 44.0002784729004, 0.767949731146494, -72.7502822875977, -1.26973195767389, 218, 55, 'ADM1', 'A'),
(176811, 'Vermont', 43.0722198486328, 0.751752052501496, -89.7855606079102, -1.56705365335695, 218, 57, 'PPL', 'P'),
(18441, 'Vermont Heights', 29.8099994659424, 0.520282640698446, -81.397216796875, -1.4206494350651, 218, 12, 'PPL', 'P'),
(107131, 'Vermont Heights', 37.2958297729492, 0.650935026801293, -80.1138916015625, -1.3982511850331, 218, 53, 'PPL', 'P'),
(201726, 'Vermont Hills', 45.4775009155273, 0.793732126554688, -122.726669311523, -2.14198445949237, 218, 43, 'PPL', 'P'),
(177288, 'Vermont Terrace', 40.4194412231445, 0.705452331160196, -80.5702819824219, -1.40621669985353, 218, 58, 'PPL', 'P'),
(172667, 'Vermont Ventures', 43.1688919067383, 0.753439298210116, -72.8938903808594, -1.27223839173382, 218, 55, 'PPL', 'P'),
(133508, 'Vermontville', 42.6288909912109, 0.74401450427038, -85.024169921875, -1.48395170891185, 218, 27, 'PPL', 'P'),
(153361, 'Vermontville', 44.4516716003418, 0.775828027441221, -74.0661087036133, -1.29269746101808, 218, 40, 'PPL', 'P'),
(209050, 'Vermontville (historical)', 47.475830078125, 0.828609549980638, -122.445281982422, -2.13707332412615, 218, 56, 'PPL', 'P'),
(138564, 'Vern', 47.3038902282715, 0.825608633485309, -95.2141723632813, -1.66180080230065, 218, 28, 'PPL', 'P'),
(206261, 'Vern G Taylor', 41.1922187805176, 0.718939843921875, -112.122222900391, -1.9569019542668, 218, 52, 'PPL', 'P'),
(18442, 'Verna', 27.3869400024414, 0.477992275088746, -82.2683334350586, -1.43585328857031, 218, 12, 'PPL', 'P'),
(62159, 'Verna', 31.3730602264404, 0.547563197377863, -90.2425003051758, -1.57502875555731, 218, 30, 'PPL', 'P'),
(62160, 'Vernal', 31.038330078125, 0.54172105418407, -88.6108322143555, -1.54655077507276, 218, 30, 'PPL', 'P'),
(121807, 'Vernal', 40.2636108398438, 0.702732577896953, -87.6994400024414, -1.53064398019783, 218, 18, 'PPL', 'P'),
(187490, 'Vernal', 38.389720916748, 0.670027028918989, -107.82861328125, -1.8819643296175, 218, 7, 'PPL', 'P'),
(206262, 'Vernal', 40.4555587768555, 0.706082701390218, -109.528060913086, -1.91162528625826, 218, 52, 'PPL', 'P'),
(185921, 'Vernalis', 37.6308288574219, 0.656781863816507, -121.286109924316, -2.11684195511509, 218, 6, 'PPL', 'P'),
(138575, 'Verndale', 46.3983306884766, 0.809803637943043, -95.0144424438477, -1.65831485759179, 218, 28, 'PPL', 'P'),
(31380, 'Verne', 38.6366691589355, 0.674337088827174, -87.429443359375, -1.52593164980699, 218, 19, 'PPL', 'P'),
(38680, 'Verne', 36.7191696166992, 0.640870408409666, -84.0697174072266, -1.46729336997729, 218, 21, 'PPL', 'P'),
(209807, 'Verne', 41.5750007629395, 0.725620649832448, -110.089996337891, -1.92143290960469, 218, 59, 'PPL', 'P'),
(111855, 'Verner', 37.663330078125, 0.657349117128694, -81.8505630493164, -1.42856181982178, 218, 58, 'PPL', 'P'),
(168352, 'Vernfield', 40.2972183227539, 0.703319139127043, -75.4091720581055, -1.31613833861685, 218, 45, 'PPL', 'P'),
(6534, 'Vernledge', 31.771110534668, 0.554510485845012, -86.2927780151367, -1.50609309705671, 218, 2, 'PPL', 'P'),
(6535, 'Vernon', 33.7569389343262, 0.589169729798658, -88.10888671875, -1.53779017350889, 218, 2, 'PPL', 'P'),
(14781, 'Vernon', 38.8933296203613, 0.678816658938741, -75.6530609130859, -1.32039500214518, 218, 10, 'PPL', 'P'),
(18443, 'Vernon', 30.6227798461914, 0.534468334429403, -85.7122192382813, -1.49596043489923, 218, 12, 'PPL', 'P'),
(25711, 'Vernon', 33.060001373291, 0.577005874677775, -85.1580581665039, -1.48628849961034, 218, 13, 'PPL', 'P'),
(28860, 'Vernon', 38.8022193908691, 0.677226485451855, -89.0869369506836, -1.55486037030603, 218, 18, 'PPL', 'P'),
(31381, 'Vernon', 38.9847183227539, 0.680411692694617, -85.6094436645508, -1.49416666274701, 218, 19, 'PPL', 'P'),
(34263, 'Vernon', 37.9805603027344, 0.662885829034969, -95.6566696166992, -1.66952383630382, 218, 20, 'PPL', 'P'),
(38681, 'Vernon', 36.6369400024414, 0.639435230898222, -85.5091705322266, -1.49241656643667, 218, 21, 'PPL', 'P'),
(43472, 'Vernon', 32.3886108398438, 0.565287899302399, -92.5713882446289, -1.61567551801075, 218, 22, 'PPL', 'P'),
(52383, 'Vernon', 39.6372184753418, 0.691799968727041, -76.5980606079102, -1.3368883582502, 218, 25, 'PPL', 'P'),
(62163, 'Vernon', 32.9855613708496, 0.57570665153998, -88.9313888549805, -1.5521455438908, 218, 30, 'PPL', 'P'),
(77549, 'Vernon', 35.2155609130859, 0.61462748586997, -95.9255599975586, -1.67421685877676, 218, 42, 'PPL', 'P'),
(91568, 'Vernon', 35.8694381713867, 0.626039796931232, -87.4963912963867, -1.52710011173526, 218, 50, 'PPL', 'P'),
(98793, 'Vernon', 34.1544418334961, 0.596107464175396, -99.2647171020508, -1.73249614449151, 218, 51, 'PPL', 'P'),
(111857, 'Vernon', 39.6572189331055, 0.692149042566923, -80.8063888549805, -1.41033754216626, 218, 58, 'PPL', 'P'),
(114204, 'Vernon', 41.8186111450195, 0.729872453091787, -72.4800033569336, -1.26501470043503, 218, 8, 'PPL', 'P'),
(118190, 'Vernon', 40.7224998474121, 0.71074170198023, -91.8550033569336, -1.60317224300894, 218, 16, 'PPL', 'P'),
(133510, 'Vernon', 42.9391708374023, 0.749429909189002, -84.0294418334961, -1.46659042860757, 218, 27, 'PPL', 'P'),
(138567, 'Vernon', 43.9033317565918, 0.766257691747913, -92.7380599975586, -1.61858448886944, 218, 28, 'PPL', 'P'),
(146520, 'Vernon', 41.1983299255371, 0.719046503523533, -74.4836120605469, -1.2999842692347, 218, 37, 'PPL', 'P'),
(153362, 'Vernon', 43.0794410705566, 0.751878086600084, -75.5397186279297, -1.31841680608747, 218, 40, 'PPL', 'P'),
(158105, 'Vernon', 41.3863906860352, 0.722328782988028, -80.5688934326172, -1.40619246508761, 218, 41, 'PPL', 'P'),
(168353, 'Vernon', 41.4466705322266, 0.723380864776664, -75.9574966430664, -1.32570840799405, 218, 45, 'PPL', 'P'),
(169644, 'Vernon', 41.7191696166992, 0.728136871009382, -71.7177810668945, -1.25171141184176, 218, 47, 'PPL', 'P'),
(172669, 'Vernon', 42.7619400024414, 0.746336647582875, -72.5138931274414, -1.26560618851314, 218, 55, 'PPL', 'P'),
(176813, 'Vernon', 42.9036102294922, 0.748809259496959, -88.2522201538086, -1.54029181387886, 218, 57, 'PPL', 'P'),
(179447, 'Vernon', 34.2574996948242, 0.597906163175635, -109.692222595215, -1.91449044811702, 218, 5, 'PPL', 'P'),
(185922, 'Vernon', 34.0038909912109, 0.593479856285869, -118.22917175293, -2.0634883189945, 218, 6, 'PPL', 'P'),
(187491, 'Vernon', 39.9463882446289, 0.697195999148732, -102.315002441406, -1.78573366678858, 218, 7, 'PPL', 'P'),
(195760, 'Vernon', 43.5886116027832, 0.76076478884157, -116.160003662109, -2.02737452303248, 218, 17, 'PPL', 'P'),
(206263, 'Vernon', 40.0922203063965, 0.699741248781548, -112.432777404785, -1.96232215287539, 218, 52, 'PPL', 'P'),
(25712, 'Vernon (historical)', 33.0569381713867, 0.576952411718892, -85.1616668701172, -1.48635148337012, 218, 13, 'PPL', 'P'),
(200263, 'Vernon (historical)', 40.4261093139648, 0.705568711299833, -118.788612365723, -2.07325239965711, 218, 39, 'PPL', 'P'),
(114205, 'Vernon Center', 41.8369407653809, 0.730192365317732, -72.4725036621094, -1.26488380606746, 218, 8, 'PPL', 'P'),
(138568, 'Vernon Center', 43.9619407653809, 0.767280611922612, -94.1688919067383, -1.64355721672722, 218, 28, 'PPL', 'P'),
(153363, 'Vernon Center', 43.0522193908691, 0.751402978661614, -75.5019378662109, -1.31775740740156, 218, 40, 'PPL', 'P'),
(107132, 'Vernon Estates', 38.6822204589844, 0.675132108991589, -77.4377822875977, -1.35154426636113, 218, 53, 'PPL', 'P'),
(25713, 'Vernon Ferry Estates', 33.0366706848145, 0.576598677347102, -85.1333312988281, -1.48585693435569, 218, 13, 'PPL', 'P'),
(91569, 'Vernon Heights', 36.4955596923828, 0.636967678990209, -82.5666732788086, -1.44106030113363, 218, 50, 'PPL', 'P'),
(111858, 'Vernon Heights', 39.4544410705566, 0.68860990121529, -80.1852798461914, -1.39949714494909, 218, 58, 'PPL', 'P'),
(118191, 'Vernon Heights Mobile Home Park', 41.9219398498535, 0.731675879202961, -91.4166717529297, -1.59552191330352, 218, 16, 'PPL', 'P'),
(107133, 'Vernon Hill', 36.7563896179199, 0.641520019978563, -79.1030578613281, -1.38060880807576, 218, 53, 'PPL', 'P'),
(126403, 'Vernon Hill', 42.2444381713867, 0.737304536745871, -71.8000030517578, -1.25314645619515, 218, 23, 'PPL', 'P'),
(121808, 'Vernon Hills', 42.2194404602051, 0.736868244380289, -87.9794387817383, -1.53553088079812, 218, 18, 'PPL', 'P'),
(158106, 'Vernon Junction', 40.8502807617188, 0.712971899656089, -82.6875, -1.44316912524281, 218, 41, 'PPL', 'P'),
(107134, 'Vernon Mills', 38.8030586242676, 0.67724113283785, -77.9563903808594, -1.36059568511603, 218, 53, 'PPL', 'P'),
(153364, 'Vernon Park', 40.9097213745117, 0.71400933405873, -73.8186111450195, -1.28837781372997, 218, 40, 'PPL', 'P'),
(118192, 'Vernon Springs', 43.3499984741211, 0.756600204107931, -92.1380615234375, -1.60811253998909, 218, 16, 'PPL', 'P'),
(107135, 'Vernon Square', 38.7058296203613, 0.675544166591252, -77.1036071777344, -1.3457118104158, 218, 53, 'PPL', 'P'),
(146536, 'Vernon Valley', 41.2366714477539, 0.719715689326442, -74.4875030517578, -1.3000521798425, 218, 37, 'PPL', 'P'),
(153365, 'Vernon Valley', 40.8994407653809, 0.713829903580286, -73.3294372558594, -1.27984011874934, 218, 40, 'PPL', 'P'),
(25718, 'Vernon View', 31.9286098480225, 0.557259367432678, -81.0988922119141, -1.41544268881789, 218, 13, 'PPL', 'P'),
(118194, 'Vernon View', 41.9755592346191, 0.732611714010015, -91.5727767944336, -1.59824646025672, 218, 16, 'PPL', 'P'),
(25715, 'Vernonburg', 31.9655609130859, 0.557904285180155, -81.1202774047852, -1.41581593084466, 218, 13, 'PPL', 'P'),
(168355, 'Vernondale', 42.0683288574219, 0.734230849373756, -80.2016677856445, -1.39978316845017, 218, 45, 'PPL', 'P'),
(201727, 'Vernonia', 45.8588905334473, 0.800388631120314, -123.191673278809, -2.15010030975633, 218, 43, 'PPL', 'P'),
(6537, 'Vernontown', 33.0563888549805, 0.576942824338967, -87.1938934326172, -1.52182052803223, 218, 2, 'PPL', 'P'),
(146523, 'Vernoy', 40.735279083252, 0.710964741721524, -74.8269424438477, -1.30597651484543, 218, 37, 'PPL', 'P'),
(18444, 'Vero Beach', 27.6383304595947, 0.482379866274166, -80.3974990844727, -1.40320106939317, 218, 12, 'PPL', 'P'),
(18445, 'Vero Lake Estates', 27.7450008392334, 0.484241615613213, -80.5280609130859, -1.4054798031799, 218, 12, 'PPL', 'P'),
(12546, 'Verona', 36.1091690063477, 0.630223889319856, -92.8272171020508, -1.62014057389438, 218, 4, 'PPL', 'P'),
(38682, 'Verona', 38.8183288574219, 0.67750764868394, -84.6608276367188, -1.47761018972415, 218, 21, 'PPL', 'P'),
(52382, 'Verona', 39.560001373291, 0.690452276057407, -76.6561126708984, -1.33790155788692, 218, 25, 'PPL', 'P'),
(58065, 'Verona', 36.9638900756836, 0.645141586165935, -93.7955627441406, -1.63704139364618, 218, 29, 'PPL', 'P'),
(62164, 'Verona', 34.1941719055176, 0.596800884744225, -88.7197189331055, -1.54845120682664, 218, 30, 'PPL', 'P'),
(69791, 'Verona', 34.6694412231445, 0.605095899170522, -77.4719390869141, -1.35214041497114, 218, 33, 'PPL', 'P'),
(74652, 'Verona', 39.9033317565918, 0.696444521668139, -84.4855575561523, -1.47455114973803, 218, 41, 'PPL', 'P'),
(91570, 'Verona', 35.5305595397949, 0.620125249045303, -86.7697219848633, -1.51441733967597, 218, 50, 'PPL', 'P'),
(98794, 'Verona', 33.2533302307129, 0.580380099778906, -96.4352798461914, -1.68311314839817, 218, 51, 'PPL', 'P'),
(107136, 'Verona', 38.2019386291504, 0.666749609723483, -79.0086135864258, -1.37896044451906, 218, 53, 'PPL', 'P'),
(121810, 'Verona', 41.2177810668945, 0.719385989983491, -88.5013885498047, -1.5446406227809, 218, 18, 'PPL', 'P'),
(123888, 'Verona', 40.8180618286133, 0.712409573191919, -86.3736114501953, -1.50750390664418, 218, 19, 'PPL', 'P'),
(129146, 'Verona', 44.5652809143066, 0.77781088403084, -68.7908325195313, -1.20062652265381, 218, 26, 'PPL', 'P'),
(133516, 'Verona', 46.4775009155273, 0.811185419074631, -89.9888916015625, -1.57060244866754, 218, 27, 'PPL', 'P'),
(141010, 'Verona', 46.3638916015625, 0.809202562485013, -98.0719375610352, -1.71167821425036, 218, 34, 'PPL', 'P'),
(143275, 'Verona', 40.5536117553711, 0.707794048706703, -97.9658279418945, -1.70982625202832, 218, 35, 'PPL', 'P'),
(146524, 'Verona', 40.829719543457, 0.712613038699201, -74.2405624389648, -1.29574225309237, 218, 37, 'PPL', 'P'),
(153387, 'Verona', 43.1380615234375, 0.752901206511865, -75.5711135864258, -1.31896475148175, 218, 40, 'PPL', 'P'),
(168356, 'Verona', 40.5063896179199, 0.706969866928351, -79.8433303833008, -1.39352900094622, 218, 45, 'PPL', 'P'),
(176816, 'Verona', 42.9908294677734, 0.750331522376048, -89.5330581665039, -1.56264665438509, 218, 57, 'PPL', 'P'),
(185923, 'Verona', 38.7861099243164, 0.67694532221977, -121.617500305176, -2.12262580837053, 218, 6, 'PPL', 'P'),
(197762, 'Verona', 48.1227798461914, 0.83990095352841, -110.189437866211, -1.9231684916871, 218, 31, 'PPL', 'P'),
(209808, 'Verona', 44.7400016784668, 0.780860336637035, -106.668891906738, -1.86172337322652, 218, 59, 'PPL', 'P'),
(153368, 'Verona Beach', 43.1908302307129, 0.753822194195842, -75.7294387817383, -1.32172804742882, 218, 40, 'PPL', 'P'),
(168357, 'Verona Hills', 40.5013885498047, 0.706882581823623, -79.8302764892578, -1.39330116751497, 218, 45, 'PPL', 'P'),
(153369, 'Verona Mills', 43.1972198486328, 0.753933714066489, -75.5591735839844, -1.31875635912645, 218, 40, 'PPL', 'P'),
(129147, 'Verona Park', 44.5525016784668, 0.777587844289546, -68.8016662597656, -1.2008156070912, 218, 26, 'PPL', 'P'),
(133514, 'Verona Park', 42.3302803039551, 0.738802764596122, -85.1555633544922, -1.48624495692652, 218, 27, 'PPL', 'P'),
(153370, 'Verona Station', 43.1336097717285, 0.752823508787062, -75.5869369506836, -1.31924092128679, 218, 40, 'PPL', 'P'),
(153372, 'Verplanck', 41.2527809143066, 0.719996852558528, -73.9602813720703, -1.29085042564406, 218, 40, 'PPL', 'P'),
(43475, 'Verret', 29.8616695404053, 0.521184453622574, -89.7797164916992, -1.5669516542872, 218, 22, 'PPL', 'P'),
(28861, 'Versailles', 39.8849983215332, 0.696124542863166, -90.6558303833008, -1.58224272631811, 218, 18, 'PPL', 'P'),
(31386, 'Versailles', 39.0719413757324, 0.681934022152734, -85.2519378662109, -1.48792700947101, 218, 19, 'PPL', 'P'),
(38684, 'Versailles', 38.0525016784668, 0.664141442909914, -84.7300033569336, -1.47881753380434, 218, 21, 'PPL', 'P'),
(43476, 'Versailles', 29.9480590820313, 0.522692235563236, -89.9608306884766, -1.57011269334307, 218, 22, 'PPL', 'P'),
(58064, 'Versailles', 38.4313888549805, 0.670754271633663, -92.8408279418945, -1.62037812786361, 218, 29, 'PPL', 'P'),
(91571, 'Versailles', 35.7294387817383, 0.623596346631085, -86.541389465332, -1.51043218542078, 218, 50, 'PPL', 'P'),
(114207, 'Versailles', 41.6016693115234, 0.726086103811967, -72.0377807617188, -1.25729646012182, 218, 8, 'PPL', 'P'),
(153373, 'Versailles', 42.5188903808594, 0.742094631440542, -78.9961090087891, -1.37874219846772, 218, 40, 'PPL', 'P'),
(158109, 'Versailles', 40.2224998474121, 0.702015055720258, -84.4844436645508, -1.47453170866207, 218, 41, 'PPL', 'P'),
(168359, 'Versailles', 40.315559387207, 0.70363925109007, -79.8313903808594, -1.39332060859093, 218, 45, 'PPL', 'P'),
(172671, 'Vershire', 43.9697189331055, 0.767416366559179, -72.3230590820313, -1.26227550609583, 218, 55, 'PPL', 'P'),
(172672, 'Vershire Center', 43.9527816772461, 0.76712075567818, -72.3380584716797, -1.26253729483099, 218, 55, 'PPL', 'P'),
(172673, 'Vershire Heights', 43.9874992370605, 0.7677266914052, -72.3694381713867, -1.26308497390916, 218, 55, 'PPL', 'P'),
(31387, 'Vertland', 39.910831451416, 0.696575416035717, -86.0458297729492, -1.50178303714853, 218, 19, 'PPL', 'P'),
(38683, 'Vertrees', 37.6963882446289, 0.65792609097886, -86.1344375610352, -1.50332953479354, 218, 21, 'PPL', 'P'),
(98795, 'Vertress Colonia', 26.1089992523193, 0.45568800135371, -98.0540008544922, -1.71136515966422, 218, 51, 'PPL', 'P'),
(91572, 'Vervilla', 35.5955581665039, 0.621259689090649, -85.8713912963867, -1.49873851139035, 218, 50, 'PPL', 'P'),
(141012, 'Veseleyville', 48.3252792358398, 0.843435234611055, -97.5569381713867, -1.70268977925523, 218, 34, 'PPL', 'P'),
(138573, 'Veseli', 44.5149993896484, 0.776933305872631, -93.459716796875, -1.63117977608692, 218, 28, 'PPL', 'P'),
(34265, 'Vesper', 39.0319404602051, 0.681235874472969, -98.2797164916992, -1.71530464070672, 218, 20, 'PPL', 'P'),
(153374, 'Vesper', 42.8175010681152, 0.7473063711148, -76.1816711425781, -1.32962099110954, 218, 40, 'PPL', 'P'),
(176819, 'Vesper', 44.4822196960449, 0.776361192291455, -89.9638900756836, -1.57016608972293, 218, 57, 'PPL', 'P'),
(192373, 'Vesrue', 31.9033298492432, 0.556818148219079, -103.116111755371, -1.79971566198566, 218, 51, 'PPL', 'P'),
(98796, 'Vessey', 33.7208290100098, 0.58853949272669, -94.966667175293, -1.65748102185449, 218, 51, 'PPL', 'P'),
(38685, 'Vest', 37.396671295166, 0.652695043386699, -83.0066680908203, -1.44873965929493, 218, 21, 'PPL', 'P'),
(12547, 'Vest (historical)', 36.0499992370605, 0.62919118202815, -92.0647201538086, -1.60683249161114, 218, 4, 'PPL', 'P'),
(189784, 'Vest Wells', 33.6352806091309, 0.587046391461537, -103.699440002441, -1.80989666051692, 218, 38, 'PPL', 'P'),
(12549, 'Vesta', 35.3791694641113, 0.61748299376978, -94.0416717529297, -1.64133680616837, 218, 4, 'PPL', 'P'),
(25716, 'Vesta', 33.9563903808594, 0.592650814238527, -82.938606262207, -1.4475517562907, 218, 13, 'PPL', 'P'),
(31388, 'Vesta', 38.4850006103516, 0.671689973282662, -85.5505599975586, -1.49313894888235, 218, 19, 'PPL', 'P'),
(91573, 'Vesta', 36.064998626709, 0.629452970763305, -86.413330078125, -1.50819712747593, 218, 50, 'PPL', 'P'),
(107137, 'Vesta', 36.7166709899902, 0.640826799146816, -80.3580627441406, -1.40251277540944, 218, 53, 'PPL', 'P'),
(138574, 'Vesta', 44.5077781677246, 0.776807271774043, -95.4161071777344, -1.66532522968726, 218, 28, 'PPL', 'P'),
(143277, 'Vesta', 40.3563919067383, 0.704351912997775, -96.3372192382813, -1.68140166792363, 218, 35, 'PPL', 'P'),
(209052, 'Vesta', 46.8333282470703, 0.817395777578641, -123.587501525879, -2.1570088159401, 218, 56, 'PPL', 'P'),
(168372, 'Vesta Heights', 40.0133285522461, 0.69836432791895, -79.9958267211914, -1.39619056413965, 218, 45, 'PPL', 'P'),
(168362, 'Vesta Number Six', 40.002498626709, 0.698175310060582, -79.9377822875977, -1.39517749766098, 218, 45, 'PPL', 'P'),
(133517, 'Vestaburg', 43.399169921875, 0.757458407769209, -84.9055633544922, -1.48188163379653, 218, 27, 'PPL', 'P'),
(168363, 'Vestaburg', 40.0161094665527, 0.698412864029817, -79.9899978637695, -1.39608883138601, 218, 45, 'PPL', 'P'),
(91574, 'Vestal', 35.9269409179688, 0.627043409188029, -83.9222183227539, -1.46471902530957, 218, 50, 'PPL', 'P'),
(107138, 'Vestal', 36.6527786254883, 0.639711667019372, -81.8486099243164, -1.42852773135983, 218, 53, 'PPL', 'P'),
(153375, 'Vestal', 42.0849990844727, 0.734521799722847, -76.0541687011719, -1.32739565370267, 218, 40, 'PPL', 'P'),
(185924, 'Vestal', 35.8397216796875, 0.625521146308939, -119.083892822266, -2.07840601584058, 218, 6, 'PPL', 'P'),
(153376, 'Vestal Corner', 42.0327796936035, 0.733610399418795, -76.0152816772461, -1.32671694709886, 218, 40, 'PPL', 'P'),
(202720, 'Vestal Springs', 43.8286094665527, 0.764953541762101, -103.685829162598, -1.80965910654768, 218, 49, 'PPL', 'P'),
(69792, 'Vestavia', 35.3280601501465, 0.616590967962658, -81.5025024414063, -1.42248701621726, 218, 33, 'PPL', 'P'),
(25717, 'Vestavia Estates', 34.0944404602051, 0.595060242655749, -84.6430587768555, -1.47730006461521, 218, 13, 'PPL', 'P'),
(6544, 'Vestavia Hills', 33.4486083984375, 0.583788346762962, -86.7877807617188, -1.51473252479098, 218, 2, 'PPL', 'P'),
(194027, 'Vestil', 41.2366714477539, 0.719715689326442, -120.558326721191, -2.10413974197985, 218, 6, 'PPL', 'P'),
(62166, 'Vestry', 30.7266693115234, 0.536281547657583, -88.7758331298828, -1.54943058431752, 218, 30, 'PPL', 'P'),
(69793, 'Vests', 35.1236114501953, 0.613022664997089, -84.2055587768555, -1.46966424913774, 218, 33, 'PPL', 'P'),
(107139, 'Vesuvius', 37.9061088562012, 0.661586406160092, -79.1975021362305, -1.38225717163246, 218, 53, 'PPL', 'P'),
(74653, 'Vesuvius (historical)', 38.5997200012207, 0.673692204369211, -82.6686096191406, -1.44283942589986, 218, 41, 'PPL', 'P'),
(74654, 'Vesuvius Furnace', 38.6061096191406, 0.673803724239858, -82.6291732788086, -1.44215113191613, 218, 41, 'PPL', 'P'),
(202721, 'Vetal', 43.2144393920898, 0.754234251795505, -101.376388549805, -1.76935176397517, 218, 49, 'PPL', 'P'),
(168364, 'Vetera', 40.5724983215332, 0.708123681470627, -78.7813873291016, -1.37499459818176, 218, 45, 'PPL', 'P'),
(153378, 'Veteran', 42.0802803039551, 0.734439441466136, -73.9947204589844, -1.29145150110209, 218, 40, 'PPL', 'P'),
(209809, 'Veteran', 41.9644393920898, 0.732417636145575, -104.379997253418, -1.82177462529478, 218, 59, 'PPL', 'P'),
(190874, 'Veteran (historical)', 39.2675018310547, 0.685347195984806, -115.028610229492, -2.00762798249787, 218, 39, 'PPL', 'P'),
(185925, 'Veteran Heights', 38.5741691589355, 0.673246258044677, -122.434997558594, -2.13689382706868, 218, 6, 'PPL', 'P'),
(77551, 'Veterans Colony', 34.8061103820801, 0.607481225979879, -95.3047180175781, -1.6633811220915, 218, 42, 'PPL', 'P'),
(6552, 'Veto', 34.9944381713867, 0.610768165976282, -86.9888916015625, -1.51824257110771, 218, 2, 'PPL', 'P'),
(62167, 'Veto', 31.5777797698975, 0.551136227454368, -90.7708282470703, -1.58424981767365, 218, 30, 'PPL', 'P'),
(111859, 'Veto', 39.6116714477539, 0.691354088981535, -80.8424987792969, -1.41096777923823, 218, 58, 'PPL', 'P'),
(112497, 'Veto', 39.3416709899902, 0.686641692011667, -81.6725006103516, -1.42545404398771, 218, 41, 'PPL', 'P'),
(31389, 'Vevay', 38.7477798461914, 0.676276336153942, -85.0672225952148, -1.48470311981341, 218, 19, 'PPL', 'P'),
(189785, 'Vevay', 31.9186096191406, 0.557084830512737, -106.759437561035, -1.86330369301737, 218, 38, 'PPL', 'P'),
(28863, 'Vevay Park', 39.2791709899902, 0.68555086122917, -88.0536117553711, -1.53682544340401, 218, 18, 'PPL', 'P'),
(192842, 'Veyo', 37.3380584716797, 0.651672056632972, -113.692222595215, -1.98430361819679, 218, 52, 'PPL', 'P'),
(168365, 'Viall Hill', 41.6858291625977, 0.7275549703112, -76.3169403076172, -1.33198188341589, 218, 45, 'PPL', 'P'),
(77552, 'Vian', 35.4983291625977, 0.619562722844051, -94.9694366455078, -1.65752935822827, 218, 42, 'PPL', 'P'),
(38686, 'Vianna', 37.836109161377, 0.660364681010018, -84.038330078125, -1.46674555774106, 218, 21, 'PPL', 'P'),
(112575, 'Viar', 36.0177803039551, 0.62862885556398, -89.3280563354492, -1.55906869746057, 218, 50, 'PPL', 'P'),
(179449, 'Viason Chin', 32.0152816772461, 0.558772076221357, -112.28971862793, -1.95982530619538, 218, 5, 'PPL', 'P'),
(58066, 'Vibbard', 39.3805618286133, 0.687320465194501, -94.146110534668, -1.64315960677648, 218, 29, 'PPL', 'P'),
(98797, 'Viboras', 26.7169399261475, 0.466298567768804, -98.8269424438477, -1.72485553532407, 218, 51, 'PPL', 'P'),
(171505, 'Viborg', 43.170280456543, 0.753463532976036, -97.0811080932617, -1.69438497771193, 218, 49, 'PPL', 'P'),
(58067, 'Viburnum', 37.7152786254883, 0.658255790321812, -91.1350021362305, -1.59060585108929, 218, 29, 'PPL', 'P'),
(111860, 'Vicars', 38.6563911437988, 0.674681302398066, -81.5016708374023, -1.42247250198932, 218, 58, 'PPL', 'P'),
(38687, 'Vicco', 37.2155609130859, 0.649534070909857, -83.0616683959961, -1.44969959570985, 218, 21, 'PPL', 'P'),
(107140, 'Vicco', 36.9602813720703, 0.645078602406154, -82.4244384765625, -1.43857783552351, 218, 53, 'PPL', 'P'),
(98798, 'Vicente Sandoval Colonia', 26.2119998931885, 0.457485701668541, -97.4830017089844, -1.70139934454904, 218, 51, 'PPL', 'P'),
(107141, 'Vicey', 37.2069396972656, 0.649383602308267, -82.2286071777344, -1.43515993458051, 218, 53, 'PPL', 'P'),
(58068, 'Vichy', 38.1113891601563, 0.665169223353603, -91.7602767944336, -1.60151895260421, 218, 29, 'PPL', 'P'),
(185927, 'Vichy Springs', 38.3377799987793, 0.669120488883926, -122.26000213623, -2.13383958077252, 218, 6, 'PPL', 'P'),
(77554, 'Vici', 36.1497192382813, 0.630931624379544, -99.2977828979492, -1.73307325149973, 218, 42, 'PPL', 'P'),
(6553, 'Vick', 32.9408302307129, 0.574925945866423, -87.0833282470703, -1.51989080150636, 218, 2, 'PPL', 'P'),
(12550, 'Vick', 33.3286094665527, 0.581693970302696, -92.1055603027344, -1.6075452866769, 218, 4, 'PPL', 'P'),
(43477, 'Vick', 31.2299995422363, 0.545066317408346, -92.1055603027344, -1.6075452866769, 218, 22, 'PPL', 'P'),
(133519, 'Vick', 46.3247184753418, 0.808518862454162, -87.1577835083008, -1.52119029096026, 218, 27, 'PPL', 'P'),
(192374, 'Vick', 31.3408298492432, 0.547000671176611, -100.091667175293, -1.74692914601919, 218, 51, 'PPL', 'P'),
(107142, 'Vicker', 37.1636085510254, 0.648627331137712, -80.4880599975586, -1.40478165550014, 218, 53, 'PPL', 'P'),
(107143, 'Vicker Heights', 37.1650009155273, 0.648651632482659, -80.477783203125, -1.40460229160072, 218, 53, 'PPL', 'P'),
(25719, 'Vickers', 34.3525009155273, 0.599564247270319, -83.9369430541992, -1.46497602035476, 218, 13, 'PPL', 'P'),
(158110, 'Vickers', 41.6161117553711, 0.726338172009143, -83.4958267211914, -1.45727708795945, 218, 41, 'PPL', 'P'),
(25720, 'Vickers Crossing', 30.7338905334473, 0.536407581756171, -82.5952835083008, -1.44155964383802, 218, 13, 'PPL', 'P'),
(185928, 'Vickers Hot Springs', 34.4977798461914, 0.602099842944183, -119.336936950684, -2.08282246903431, 218, 6, 'PPL', 'P'),
(158111, 'Vickery', 41.3819389343262, 0.722251085263225, -82.9349975585938, -1.44748877253092, 218, 41, 'PPL', 'P'),
(133520, 'Vickery Landing', 42.5038909912109, 0.741832842705387, -85.2713928222656, -1.48826656251, 218, 27, 'PPL', 'P'),
(129149, 'Vickerys Corner', 44.401668548584, 0.774955309552002, -69.1133270263672, -1.20625511361769, 218, 26, 'PPL', 'P'),
(133521, 'Vickeryville', 43.1922187805176, 0.753846428961762, -84.9652786254883, -1.48292386188913, 218, 27, 'PPL', 'P'),
(62168, 'Vickland', 33.042781829834, 0.57670533694876, -90.8477783203125, -1.58559284981138, 218, 30, 'PPL', 'P'),
(69794, 'Vicksboro', 36.3061103820801, 0.633661164759794, -78.2772216796875, -1.36619524762403, 218, 33, 'PPL', 'P'),
(18446, 'Vicksburg', 30.3255596160889, 0.529280862810578, -85.6647186279297, -1.49513139285189, 218, 12, 'PPL', 'P'),
(31390, 'Vicksburg', 39.0905609130859, 0.682258994384751, -87.1980590820313, -1.52189323232999, 218, 19, 'PPL', 'P'),
(38694, 'Vicksburg', 37.1852798461914, 0.649005566591531, -88.3327789306641, -1.54169782977636, 218, 21, 'PPL', 'P'),
(58069, 'Vicksburg', 36.1538887023926, 0.631004395256331, -89.870002746582, -1.5685274467042, 218, 29, 'PPL', 'P'),
(62169, 'Vicksburg', 32.3525009155273, 0.564657662230432, -90.8777770996094, -1.58611642728169, 218, 30, 'PPL', 'P'),
(133522, 'Vicksburg', 42.1199989318848, 0.735132662297884, -85.5327835083008, -1.49282869061536, 218, 27, 'PPL', 'P'),
(168367, 'Vicksburg', 40.9386100769043, 0.714513537032109, -76.9883270263672, -1.34369979221224, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(179450, 'Vicksburg', 33.7444381713867, 0.588951550326353, -113.751388549805, -1.98533625890947, 218, 5, 'PPL', 'P'),
(187492, 'Vicksburg', 38.9991683959961, 0.680663894049848, -106.377220153809, -1.85663274080283, 218, 7, 'PPL', 'P'),
(179451, 'Vicksburg Junction', 33.7188911437988, 0.588505670580846, -113.766670227051, -1.98560297449264, 218, 5, 'PPL', 'P'),
(74662, 'Vicksville', 39.5494384765625, 0.690267918730946, -82.0236129760742, -1.43158211081404, 218, 41, 'PPL', 'P'),
(107144, 'Vicksville', 36.8133316040039, 0.642513845118354, -77.0224990844727, -1.34429620713837, 218, 53, 'PPL', 'P'),
(52384, 'Vicky Estates', 39.3747215270996, 0.687218532703778, -77.0308303833008, -1.34444161573388, 218, 25, 'PPL', 'P'),
(52385, 'Vicmyer Vista', 39.6049995422363, 0.691237642262871, -77.3152770996094, -1.34940614747996, 218, 25, 'PPL', 'P'),
(12551, 'Victor', 35.6505584716797, 0.622219625505568, -93.0025024414063, -1.6231998801966, 218, 4, 'PPL', 'P'),
(18447, 'Victor', 28.1694393157959, 0.491649464501377, -82.7733306884766, -1.44466715335598, 218, 12, 'PPL', 'P'),
(31391, 'Victor', 39.0608291625977, 0.681740077446349, -86.5808334350586, -1.51112061256256, 218, 19, 'PPL', 'P'),
(34268, 'Victor', 39.2480583190918, 0.685007842682903, -98.2836074829102, -1.71537255131452, 218, 20, 'PPL', 'P'),
(58070, 'Victor', 39.4541702270508, 0.688605174104355, -91.8291702270508, -1.60272136983638, 218, 29, 'PPL', 'P'),
(62170, 'Victor', 33.7769393920898, 0.58951880363854, -90.8249969482422, -1.58519523986063, 218, 30, 'PPL', 'P'),
(77555, 'Victor', 34.9663887023926, 0.610278610388898, -94.7866668701172, -1.65433942387457, 218, 42, 'PPL', 'P'),
(98800, 'Victor', 29.9269409179688, 0.522323654068369, -95.2108306884766, -1.66174247907278, 218, 51, 'PPL', 'P'),
(111862, 'Victor', 38.4233283996582, 0.670613590149079, -81.4263916015625, -1.42115863146552, 218, 58, 'PPL', 'P'),
(113020, 'Victor', 41.7316703796387, 0.728355050481687, -92.2977828979492, -1.61090020386013, 218, 16, 'PPL', 'P'),
(153380, 'Victor', 42.9824981689453, 0.75018611378053, -77.4091720581055, -1.35104492365674, 218, 40, 'PPL', 'P'),
(168368, 'Victor', 40.8802795410156, 0.713495477126399, -78.258056640625, -1.36586075459112, 218, 45, 'PPL', 'P'),
(171507, 'Victor', 45.8688888549805, 0.800563134750741, -96.8324966430664, -1.69004588934787, 218, 49, 'PPL', 'P'),
(185929, 'Victor', 38.1380615234375, 0.665634743912149, -121.205001831055, -2.11542635183766, 218, 6, 'PPL', 'P'),
(187493, 'Victor', 38.7099990844727, 0.675616937468038, -105.139442443848, -1.83502944435622, 218, 7, 'PPL', 'P'),
(192843, 'Victor', 39.4013900756836, 0.687683986683296, -110.714721679688, -1.93233642373969, 218, 52, 'PPL', 'P'),
(195761, 'Victor', 43.6027793884277, 0.761012063348783, -111.110557556152, -1.93924506308152, 218, 17, 'PPL', 'P'),
(197763, 'Victor', 46.4166717529297, 0.810123749906071, -114.149169921875, -1.9922788535552, 218, 31, 'PPL', 'P'),
(209054, 'Victor', 48.8333282470703, 0.852302362618528, -122.441940307617, -2.13701500089828, 218, 56, 'PPL', 'P'),
(52386, 'Victor (historical)', 38.2369384765625, 0.66736047229852, -75.8461074829102, -1.32376430039829, 218, 25, 'PPL', 'P'),
(197764, 'Victor Crossing', 46.4144401550293, 0.810084801175129, -114.120277404785, -1.99177458400279, 218, 31, 'PPL', 'P'),
(14784, 'Victor E Hurley Estates', 38.6463890075684, 0.674506732188612, -75.5972213745117, -1.31942041834426, 218, 10, 'PPL', 'P'),
(52387, 'Victor Haven', 38.9538917541504, 0.679873667575394, -76.4930572509766, -1.33505570394606, 218, 25, 'PPL', 'P'),
(84155, 'Victor Mills', 34.9275016784668, 0.609599903785091, -82.2163925170898, -1.43494674853525, 218, 48, 'PPL', 'P'),
(6554, 'Victoria', 31.5297203063965, 0.550297431579534, -85.9383316040039, -1.49990684016057, 218, 2, 'PPL', 'P'),
(12558, 'Victoria', 35.7566719055176, 0.624071654306637, -90.0558319091797, -1.57177077743776, 218, 4, 'PPL', 'P'),
(25721, 'Victoria', 34.1369400024414, 0.595801999598364, -84.6094436645508, -1.47671337022707, 218, 13, 'PPL', 'P'),
(31392, 'Victoria', 39.0463905334473, 0.6814880758282, -87.2227783203125, -1.52232466442658, 218, 19, 'PPL', 'P'),
(34270, 'Victoria', 38.8527793884277, 0.678108923879053, -99.147216796875, -1.73044537729409, 218, 20, 'PPL', 'P'),
(38688, 'Victoria', 37.3069381713867, 0.651128904928651, -87.5077819824219, -1.52729891671063, 218, 21, 'PPL', 'P'),
(43478, 'Victoria', 31.663890838623, 0.552639149126041, -93.2252807617188, -1.62708809538812, 218, 22, 'PPL', 'P'),
(58071, 'Victoria', 38.1777801513672, 0.666327964743897, -90.5258331298828, -1.57997384622742, 218, 29, 'PPL', 'P'),
(62171, 'Victoria', 34.8461112976074, 0.608179373659643, -89.6180572509766, -1.56413016827032, 218, 30, 'PPL', 'P'),
(79324, 'Victoria', 39.8519401550293, 0.695547569013001, -79.4580612182617, -1.38680478550988, 218, 45, 'PPL', 'P'),
(91575, 'Victoria', 35.1536102294922, 0.613546242467398, -85.5541687011719, -1.49320193264213, 218, 50, 'PPL', 'P'),
(98802, 'Victoria', 28.8050003051758, 0.502742096363289, -97.0033264160156, -1.69302743134626, 218, 51, 'PPL', 'P'),
(107145, 'Victoria', 36.9947204589844, 0.645679677864185, -78.2275009155273, -1.36532745658283, 218, 53, 'PPL', 'P'),
(111863, 'Victoria', 39.417781829834, 0.687970076763398, -79.8894424438477, -1.39433380822765, 218, 58, 'PPL', 'P'),
(112403, 'Victoria', 38.5663909912109, 0.67311050340811, -76.0022201538086, -1.32648898050955, 218, 25, 'PPL', 'P'),
(121813, 'Victoria', 41.0336112976074, 0.716171621126792, -90.0983276367188, -1.57251246780134, 218, 18, 'PPL', 'P'),
(133524, 'Victoria', 46.6991691589355, 0.815054259769216, -89.2294387817383, -1.55734749644805, 218, 27, 'PPL', 'P'),
(138579, 'Victoria', 44.8586082458496, 0.782930411752354, -93.6613922119141, -1.63469967609968, 218, 28, 'PPL', 'P'),
(153382, 'Victoria', 42.1641693115234, 0.735903580854435, -79.4274978637695, -1.38627135434354, 218, 40, 'PPL', 'P'),
(185930, 'Victoria', 34.0736083984375, 0.594696654587926, -117.251670837402, -2.04642770957729, 218, 6, 'PPL', 'P'),
(202724, 'Victoria', 44.3950004577637, 0.774838929412366, -103.907218933105, -1.81352308697328, 218, 49, 'PPL', 'P'),
(98803, 'Victoria Acres Colonia', 26.1830005645752, 0.456979567903371, -98.0250015258789, -1.71085902589905, 218, 51, 'PPL', 'P'),
(98804, 'Victoria Belen Colonia', 26.1550006866455, 0.456490877843342, -98.0380020141602, -1.71108592722393, 218, 51, 'PPL', 'P'),
(98805, 'Victoria Colonia', 26.4139995574951, 0.461011260898615, -98.9830017089844, -1.72757928332895, 218, 51, 'PPL', 'P'),
(25722, 'Victoria Cove', 33.8555603027344, 0.590890997390203, -84.8466720581055, -1.48085378677381, 218, 13, 'PPL', 'P'),
(38689, 'Victoria Crossroads', 37.7477798461914, 0.658823043633999, -86.6777801513672, -1.51281265196115, 218, 21, 'PPL', 'P'),
(52388, 'Victoria Estates', 38.6522216796875, 0.67460853152128, -76.5738906860352, -1.33646651353353, 218, 25, 'PPL', 'P'),
(168369, 'Victoria Furnace', 40.416389465332, 0.705399067938395, -76.876106262207, -1.34174117038854, 218, 45, 'PPL', 'P'),
(107146, 'Victoria Hills', 37.3355598449707, 0.651628447370122, -77.4441680908203, -1.35165571965275, 218, 53, 'PPL', 'P'),
(25723, 'Victoria Landing', 34.1536102294922, 0.596092949947455, -84.621940612793, -1.47693148312035, 218, 13, 'PPL', 'P'),
(206265, 'Victoria Meadow Condo', 40.6127815246582, 0.708826755998408, -111.817497253418, -1.95158348841186, 218, 52, 'PPL', 'P'),
(25724, 'Victoria Station', 33.8705596923828, 0.591152786125358, -83.379997253418, -1.45525548237597, 218, 13, 'PPL', 'P'),
(52389, 'Victoria Station', 38.684440612793, 0.67517085798545, -76.6247177124023, -1.33735361249264, 218, 25, 'PPL', 'P'),
(98807, 'Victoria Vera Colonia', 26.318000793457, 0.459335766388305, -98.693000793457, -1.7225178125192, 218, 51, 'PPL', 'P'),
(14782, 'Victoria Woods', 39.6605606079102, 0.692207365794796, -75.6430587768555, -1.32022043193572, 218, 10, 'PPL', 'P'),
(206267, 'Victorian Condominium', 40.7733306884766, 0.711628867518362, -111.86888885498, -1.952480441067, 218, 52, 'PPL', 'P'),
(84156, 'Victorian Hills', 34.9258308410645, 0.609570742171155, -82.2080612182617, -1.43480133993973, 218, 48, 'PPL', 'P'),
(192375, 'Victoriano Hernandez Colonia', 28.6189994812012, 0.499495769573509, -100.432998657227, -1.75288650421965, 218, 51, 'PPL', 'P'),
(179452, 'Victorine Crossing', 34.5711097717285, 0.603379691585048, -111.067497253418, -1.9384935190219, 218, 5, 'PPL', 'P'),
(185932, 'Victorville', 34.5361099243164, 0.602768829010011, -117.290283203125, -2.04710162249113, 218, 6, 'PPL', 'P'),
(25725, 'Victory', 33.5111083984375, 0.584879177545458, -85.2102813720703, -1.48719996649342, 218, 13, 'PPL', 'P'),
(38690, 'Victory', 37.2538909912109, 0.650203056975685, -84.0955581665039, -1.4677443763079, 218, 21, 'PPL', 'P'),
(77557, 'Victory', 34.6522216796875, 0.604795361441507, -99.438606262207, -1.73553108286976, 218, 42, 'PPL', 'P'),
(91576, 'Victory', 36.3908309936523, 0.635139818376033, -84.0088882446289, -1.46623170080873, 218, 50, 'PPL', 'P'),
(98808, 'Victory', 32.7980613708496, 0.572434159192491, -94.5686111450195, -1.6505336335188, 218, 51, 'PPL', 'P'),
(172675, 'Victory', 44.5094413757324, 0.776836300229925, -71.8463897705078, -1.25395605716653, 218, 55, 'PPL', 'P'),
(176821, 'Victory', 43.4855613708496, 0.758966222999385, -91.2125015258789, -1.59195847060694, 218, 57, 'PPL', 'P'),
(177394, 'Victory', 43.1972198486328, 0.753933714066489, -76.6547164916992, -1.33787718996295, 218, 40, 'PPL', 'P'),
(91577, 'Victory (historical)', 35.149169921875, 0.613468744479677, -87.8138885498047, -1.53264148417344, 218, 50, 'PPL', 'P'),
(158113, 'Victory Camp', 40.1811103820801, 0.701292673274574, -82.9316711425781, -1.44743071561916, 218, 41, 'PPL', 'P'),
(176822, 'Victory Center', 43.2069396972656, 0.754103357427927, -88.0824966430664, -1.53732957979836, 218, 57, 'PPL', 'P'),
(98809, 'Victory City', 33.4650001525879, 0.584074436843063, -94.2366714477539, -1.64474019288344, 218, 51, 'PPL', 'P'),
(52390, 'Victory Gardens', 38.4194412231445, 0.67054574612031, -75.563606262207, -1.31883372395612, 218, 25, 'PPL', 'P'),
(146526, 'Victory Gardens', 40.8758316040039, 0.713417845980623, -74.5427780151367, -1.30101690994738, 218, 37, 'PPL', 'P'),
(25726, 'Victory Heights', 32.0419387817383, 0.559237330463794, -81.0619430541992, -1.41479780435992, 218, 13, 'PPL', 'P'),
(168370, 'Victory Heights', 41.3630599975586, 0.721921585657355, -79.7622222900391, -1.39211339766879, 218, 45, 'PPL', 'P'),
(176823, 'Victory Heights', 42.542781829834, 0.742511615888221, -89.0905609130859, -1.55492362038192, 218, 57, 'PPL', 'P'),
(107148, 'Victory Hill', 37.2519416809082, 0.650169035092759, -76.4700012207031, -1.33465330030535, 218, 53, 'PPL', 'P'),
(126404, 'Victory Hill', 42.4686088562012, 0.741217053282334, -73.2305603027344, -1.27811439036297, 218, 23, 'PPL', 'P'),
(168371, 'Victory Hills', 40.1913909912109, 0.701472103753018, -79.8927764892578, -1.39439199829746, 218, 45, 'PPL', 'P'),
(34273, 'Victory Junction', 39.1288909912109, 0.682927980450578, -94.9011077880859, -1.65633679469213, 218, 20, 'PPL', 'P'),
(71505, 'Victory Lakes', 39.6330604553223, 0.691727397587336, -74.9663925170898, -1.30841037776566, 218, 37, 'PPL', 'P'),
(153383, 'Victory Mills', 43.0877799987793, 0.752023628353657, -73.5944366455078, -1.28446523061448, 218, 40, 'PPL', 'P'),
(107149, 'Victory Park', 36.7930603027344, 0.642160044167536, -76.351936340332, -1.3325926794119, 218, 53, 'PPL', 'P'),
(153384, 'Victory Park', 40.9524993896484, 0.714755951270333, -73.7944412231445, -1.2879559690133, 218, 40, 'PPL', 'P'),
(98810, 'Victory Place Colonia', 27.2290000915527, 0.475235703623433, -98.1630020141602, -1.71326758878892, 218, 51, 'PPL', 'P'),
(52391, 'Victory Villa', 39.3411102294922, 0.686631904894661, -76.4572219848633, -1.33443026056406, 218, 25, 'PPL', 'P'),
(52392, 'Victory Villa Gardens', 39.3463897705078, 0.686724050268377, -76.4416732788086, -1.33415888444898, 218, 25, 'PPL', 'P'),
(285, 'Vida', 32.6100006103516, 0.569151879727995, -86.6744384765625, -1.51275432873327, 218, 2, 'PPL', 'P'),
(43484, 'Vida', 30.0338897705078, 0.524190263676405, -91.7302780151367, -1.6009953751339, 218, 22, 'PPL', 'P'),
(58072, 'Vida', 37.8569412231445, 0.660728269077841, -91.7994384765625, -1.60220245289798, 218, 29, 'PPL', 'P'),
(197765, 'Vida', 47.8319396972656, 0.834824835332665, -105.492500305176, -1.84119146648644, 218, 31, 'PPL', 'P'),
(201728, 'Vida', 44.146110534668, 0.77049498077931, -122.56861114502, -2.13922582407721, 218, 43, 'PPL', 'P'),
(6555, 'Vida Junction', 32.5738906860352, 0.568521642656028, -86.6822204589844, -1.51289014994887, 218, 2, 'PPL', 'P'),
(185933, 'Vidal', 34.1188888549805, 0.595486947641407, -114.509437561035, -1.99856671004693, 218, 6, 'PPL', 'P'),
(185934, 'Vidal Junction', 34.1886100769043, 0.596703812522492, -114.573333740234, -1.9996819087534, 218, 6, 'PPL', 'P'),
(25728, 'Vidalia', 32.2174987792969, 0.562301430455984, -82.4136123657227, -1.43838888424417, 218, 13, 'PPL', 'P'),
(43481, 'Vidalia', 31.5652809143066, 0.550918081271577, -91.4258270263672, -1.59568170296892, 218, 22, 'PPL', 'P'),
(98811, 'Vidaurri', 28.4363899230957, 0.496308631538957, -97.1366729736328, -1.69535476782288, 218, 51, 'PPL', 'P'),
(6556, 'Vidette', 31.732780456543, 0.553841499779184, -86.1949996948242, -1.50438654343019, 218, 2, 'PPL', 'P'),
(12554, 'Vidette', 36.4272193908691, 0.63577491571699, -92.1183319091797, -1.60776819326014, 218, 4, 'PPL', 'P'),
(25729, 'Vidette', 33.0374984741211, 0.576613124996016, -82.2474975585938, -1.43548963392346, 218, 13, 'PPL', 'P'),
(98812, 'Vidor', 30.1313896179199, 0.525891957033939, -94.0152816772461, -1.64087621245784, 218, 51, 'PPL', 'P'),
(43483, 'Vidrine', 30.6924991607666, 0.535685166020974, -92.398063659668, -1.61265043332853, 218, 22, 'PPL', 'P'),
(187494, 'Viejo San Acacio', 37.2027816772461, 0.649311031168563, -105.507781982422, -1.84145818206961, 218, 7, 'PPL', 'P'),
(118202, 'Viele', 40.6130599975586, 0.708831616267398, -91.4336090087891, -1.59581752418452, 218, 16, 'PPL', 'P'),
(58073, 'Vieman (historical)', 38.2019386291504, 0.666749609723483, -91.4791717529297, -1.59661274408602, 218, 29, 'PPL', 'P'),
(6557, 'Vienna', 33.0186080932617, 0.576283425653064, -88.1919403076172, -1.53923973209022, 218, 2, 'PPL', 'P'),
(25730, 'Vienna', 32.0913887023926, 0.560100394394061, -83.7955627441406, -1.46250846844675, 218, 13, 'PPL', 'P'),
(28864, 'Vienna', 37.4152793884277, 0.653019815881634, -88.8977813720703, -1.55155898266071, 218, 18, 'PPL', 'P'),
(31393, 'Vienna', 38.6488914489746, 0.674550408030489, -85.7688903808594, -1.49694953292809, 218, 19, 'PPL', 'P'),
(43493, 'Vienna', 32.5908317565918, 0.568817320116054, -92.6477813720703, -1.6170088296105, 218, 22, 'PPL', 'P'),
(52393, 'Vienna', 38.4847183227539, 0.671685046434645, -75.8249969482422, -1.32339585206148, 218, 25, 'PPL', 'P'),
(58074, 'Vienna', 38.1866683959961, 0.666483093877394, -91.9469375610352, -1.60477679756571, 218, 29, 'PPL', 'P'),
(69795, 'Vienna', 36.1375007629395, 0.630718371755256, -80.4022216796875, -1.40328349422891, 218, 33, 'PPL', 'P'),
(98813, 'Vienna', 29.378059387207, 0.51274386415319, -96.7922210693359, -1.68934294797814, 218, 51, 'PPL', 'P'),
(107150, 'Vienna', 38.9011116027832, 0.678952480154335, -77.2655563354492, -1.34853835643875, 218, 53, 'PPL', 'P'),
(111865, 'Vienna', 39.3269386291504, 0.68638456380842, -81.5486068725586, -1.42329169034062, 218, 58, 'PPL', 'P'),
(113239, 'Vienna', 43.2394409179688, 0.754670610740114, -75.7027816772461, -1.32126279318638, 218, 40, 'PPL', 'P'),
(129150, 'Vienna', 44.5333290100098, 0.777253218098577, -69.9852828979492, -1.22147361450889, 218, 26, 'PPL', 'P'),
(133531, 'Vienna', 41.7869415283203, 0.729319714007541, -83.4780578613281, -1.45696696285051, 218, 27, 'PPL', 'P'),
(146528, 'Vienna', 40.8686103820801, 0.713291811882035, -74.8894424438477, -1.30706734562793, 218, 37, 'PPL', 'P'),
(158114, 'Vienna', 41.2377815246582, 0.719735063823373, -80.664436340332, -1.40786000340416, 218, 41, 'PPL', 'P'),
(171511, 'Vienna', 44.7030601501465, 0.780215585337127, -97.501106262207, -1.70171532861237, 218, 49, 'PPL', 'P'),
(43485, 'Vienna Bend', 31.7322196960449, 0.553831712662178, -93.0408325195313, -1.62386886626243, 218, 22, 'PPL', 'P'),
(133526, 'Vienna Corners', 44.9702796936035, 0.784879446196128, -84.3708267211914, -1.4725487189144, 218, 27, 'PPL', 'P'),
(69796, 'Vienna Forest', 36.1333312988281, 0.63064560087847, -80.4013900756836, -1.40326898000097, 218, 33, 'PPL', 'P'),
(71506, 'Vienna Gardens', 39.5111083984375, 0.689598932665118, -74.6227798461914, -1.30241320530691, 218, 37, 'PPL', 'P'),
(133528, 'Vienna Junction', 44.8797187805176, 0.783298860089166, -84.3236083984375, -1.47172460371508, 218, 27, 'PPL', 'P'),
(107151, 'Vienna Woods', 38.8877792358398, 0.67871978645409, -77.2477798461914, -1.34822809817176, 218, 53, 'PPL', 'P'),
(18448, 'Viera', 28.2466697692871, 0.492997390197607, -80.7372207641602, -1.40913033124413, 218, 12, 'PPL', 'P'),
(107152, 'Viers', 37.1719398498535, 0.64877273973323, -82.2363891601563, -1.4352957557961, 218, 53, 'PPL', 'P'),
(52394, 'Viers Mill Village', 39.0558280944824, 0.681652792341621, -77.0822219848633, -1.34533856838902, 218, 25, 'PPL', 'P'),
(43486, 'Vieux Carre', 29.9602794647217, 0.522905521477038, -90.0647201538086, -1.57192590657125, 218, 22, 'PPL', 'P'),
(38691, 'View', 37.2633285522461, 0.650367773489106, -88.1386108398438, -1.53830895728924, 218, 21, 'PPL', 'P'),
(98814, 'View', 32.3427810668945, 0.564488018868994, -99.8844375610352, -1.74331230694276, 218, 51, 'PPL', 'P'),
(195762, 'View', 42.4508285522461, 0.740906728436312, -113.696388244629, -1.98437632249455, 218, 17, 'PPL', 'P'),
(74656, 'View (historical)', 39.4036102294922, 0.687722735677157, -83.0505599975586, -1.44950571758249, 218, 41, 'PPL', 'P'),
(206271, 'View Condominiums', 40.5833282470703, 0.708312699328996, -111.648612976074, -1.94863590171736, 218, 52, 'PPL', 'P'),
(52395, 'View More Heights', 39.4469413757324, 0.688479006847712, -77.3091735839844, -1.34929962103635, 218, 25, 'PPL', 'P'),
(185935, 'View Park', 33.9988899230957, 0.593392571181142, -118.341667175293, -2.06545173450816, 218, 6, 'PPL', 'P'),
(52396, 'View Point', 39.1597213745117, 0.683466072148829, -76.533332824707, -1.33575864531579, 218, 25, 'PPL', 'P'),
(84157, 'View Point Place', 34.8672218322754, 0.608547821996456, -82.4452819824219, -1.43894162332842, 218, 48, 'PPL', 'P'),
(25731, 'View Pointe', 33.1027793884277, 0.577752491889379, -85.0255584716797, -1.48397594367777, 218, 13, 'PPL', 'P'),
(209056, 'View Ridge', 47.6797218322754, 0.832168132408229, -122.27278137207, -2.13406262051382, 218, 56, 'PPL', 'P'),
(52397, 'View West Acres', 39.603328704834, 0.691208480648935, -77.0238876342773, -1.34432044190429, 218, 25, 'PPL', 'P'),
(206273, 'Viewcrest Park', 40.6166687011719, 0.708894600027178, -111.838890075684, -1.95195686359669, 218, 52, 'PPL', 'P'),
(202725, 'Viewfield', 44.2119407653809, 0.771643935052598, -102.829170227051, -1.79470758755576, 218, 49, 'PPL', 'P'),
(194028, 'Viewland', 40.4302787780762, 0.705641482176619, -120.279167175293, -2.09926748876555, 218, 6, 'PPL', 'P'),
(787, 'Viewmont', 35.747501373291, 0.623911598325123, -81.3375015258789, -1.4196072069725, 218, 33, 'PPL', 'P'),
(206274, 'Viewmont Circle', 40.6613883972168, 0.709675105963653, -111.82250213623, -1.95167084009561, 218, 52, 'PPL', 'P'),
(206275, 'Viewmont Condominium', 40.663330078125, 0.709708994688524, -111.828887939453, -1.95178229338723, 218, 52, 'PPL', 'P'),
(107153, 'Viewmont Park', 37.2944412231445, 0.650910792035373, -79.9833297729492, -1.39597245124637, 218, 53, 'PPL', 'P'),
(153388, 'Viewmonte', 42.0986099243164, 0.734759353692082, -73.8744430541992, -1.28935226437283, 218, 40, 'PPL', 'P'),
(52398, 'Viewsite Estates', 39.4030609130859, 0.687713148297233, -77.3294372558594, -1.34965328882911, 218, 25, 'PPL', 'P'),
(107154, 'Viewtown', 38.6391716003418, 0.674380764669051, -78.0397186279297, -1.36205003738732, 218, 53, 'PPL', 'P'),
(158116, 'Vigil', 41.3197212219238, 0.721165181328745, -81.857780456543, -1.42868778734134, 218, 41, 'PPL', 'P'),
(187495, 'Vigil', 37.1611099243164, 0.648583721874862, -104.941108703613, -1.83156786757133, 218, 7, 'PPL', 'P'),
(176825, 'Vignes', 44.7261085510254, 0.780617855819783, -87.3775024414063, -1.52502510977192, 218, 57, 'PPL', 'P'),
(6558, 'Vigo', 33.9180603027344, 0.5919818281727, -85.5580596923828, -1.49326984324993, 218, 2, 'PPL', 'P'),
(31398, 'Vigo', 39.2872200012207, 0.685691342976672, -87.5372161865234, -1.52781264048491, 218, 19, 'PPL', 'P'),
(74657, 'Vigo', 39.2477798461914, 0.685002982413914, -82.7930603027344, -1.44501150008493, 218, 41, 'PPL', 'P'),
(192376, 'Vigo Park', 34.6525001525879, 0.604800221710496, -101.495559692383, -1.77143169278652, 218, 51, 'PPL', 'P'),
(107155, 'Vigor', 37.9361114501953, 0.662110050209429, -77.9805603027344, -1.3610175298327, 218, 53, 'PPL', 'P'),
(58075, 'Vigus', 38.7355613708496, 0.676063083529654, -90.4647216796875, -1.57890725021084, 218, 29, 'PPL', 'P'),
(18449, 'Viking', 27.541389465332, 0.480687926744125, -80.3622207641602, -1.40258534654915, 218, 12, 'PPL', 'P'),
(138583, 'Viking', 48.2186088562012, 0.841573485272007, -96.4055633544922, -1.68259449777588, 218, 28, 'PPL', 'P'),
(176826, 'Viking', 44.8616714477539, 0.782983874711237, -92.35888671875, -1.61196666671865, 218, 57, 'PPL', 'P'),
(206276, 'Viking Estates', 40.5194396972656, 0.70719763378058, -111.963333129883, -1.9541288046237, 218, 52, 'PPL', 'P'),
(138584, 'Viking Estates Mobile Home Park', 45.9916687011719, 0.802706047321873, -95.959716796875, -1.67481300738678, 218, 28, 'PPL', 'P'),
(107156, 'Viking Fiord', 37.4588890075684, 0.653780947321179, -79.1036071777344, -1.38061839545568, 218, 53, 'PPL', 'P'),
(52399, 'Viking Highlands', 39.6661109924316, 0.692304238279448, -76.3499984741211, -1.33255885726606, 218, 25, 'PPL', 'P'),
(74658, 'Viking Village', 39.0977783203125, 0.682384961904311, -84.2997207641602, -1.47130768584642, 218, 41, 'PPL', 'P'),
(138587, 'Vikre Manufactured Home Park', 43.5552787780762, 0.760183021301442, -92.0100021362305, -1.60587748204424, 218, 28, 'PPL', 'P'),
(58076, 'Vilander', 38.0963897705078, 0.664907434618448, -91.1313934326172, -1.59054286732951, 218, 29, 'PPL', 'P'),
(18450, 'Vilano Beach', 29.9186096191406, 0.522178245472851, -81.2930603027344, -1.41883156130501, 218, 12, 'PPL', 'P'),
(18451, 'Vilas', 30.2188892364502, 0.527419113471531, -84.8858337402344, -1.48153728706758, 218, 12, 'PPL', 'P'),
(31397, 'Vilas', 39.1699981689453, 0.683645436048246, -86.8399963378906, -1.51564385851601, 218, 19, 'PPL', 'P'),
(34275, 'Vilas', 37.6541709899902, 0.657189260884262, -95.5861129760742, -1.66829239061577, 218, 20, 'PPL', 'P'),
(69798, 'Vilas', 36.2455596923828, 0.632604355860223, -81.7677764892578, -1.42711692177236, 218, 33, 'PPL', 'P'),
(98815, 'Vilas', 30.8408298492432, 0.53827402491664, -97.3033294677734, -1.69826347236547, 218, 51, 'PPL', 'P'),
(171513, 'Vilas', 44.0105590820313, 0.768129161624938, -97.5969390869141, -1.703387926935, 218, 49, 'PPL', 'P'),
(176827, 'Vilas', 43.0897216796875, 0.752057517078528, -89.2347183227539, -1.55743964182177, 218, 57, 'PPL', 'P'),
(187499, 'Vilas', 37.3736114501953, 0.652292573166961, -102.445831298828, -1.78801706110721, 218, 7, 'PPL', 'P'),
(91578, 'Vildo', 35.4055595397949, 0.61794358748031, -89.1036071777344, -1.55515132065512, 218, 50, 'PPL', 'P'),
(38692, 'Viley', 38.0755615234375, 0.664543913129652, -84.5516662597656, -1.47570496428031, 218, 21, 'PPL', 'P'),
(74659, 'Villa', 39.9652786254883, 0.697525698491684, -83.7586135864258, -1.46186358398879, 218, 41, 'PPL', 'P'),
(98816, 'Villa', 31.6149997711182, 0.551785839023266, -98.7355575561523, -1.72326056814722, 218, 51, 'PPL', 'P'),
(107157, 'Villa (historical)', 37.0555610656738, 0.646741546769827, -79.8300018310547, -1.39329637382501, 218, 53, 'PPL', 'P'),
(111866, 'Villa (historical)', 38.3752784729004, 0.669774960721813, -81.504997253418, -1.42253055890108, 218, 58, 'PPL', 'P'),
(192377, 'Villa Alegre Colonia', 31.2919998168945, 0.546148426338272, -105.851997375488, -1.84746587401467, 218, 51, 'PPL', 'P'),
(52400, 'Villa Bella', 39.083610534668, 0.682137687397097, -76.6813888549805, -1.33834271052149, 218, 25, 'PPL', 'P'),
(98817, 'Villa Capri Colonia', 26.2639999389648, 0.458393273678526, -98.3509979248047, -1.71654873640995, 218, 51, 'PPL', 'P'),
(179453, 'Villa Carmel Mobile Home Park', 33.6341705322266, 0.587027016964607, -112.027778625488, -1.9552535907101, 218, 5, 'PPL', 'P'),
(98818, 'Villa Cavazos', 26.0177803039551, 0.454095930364547, -97.6080627441406, -1.70358207137847, 218, 51, 'PPL', 'P'),
(98819, 'Villa Cavazos Colonia', 26.0170001983643, 0.454082314953474, -97.6070022583008, -1.70356356240889, 218, 51, 'PPL', 'P'),
(25732, 'Villa Chase', 33.9863891601563, 0.593174391708837, -84.418327331543, -1.47337776096174, 218, 13, 'PPL', 'P'),
(52401, 'Villa Cresta', 39.377498626709, 0.687267002235617, -76.5458297729492, -1.33597675820907, 218, 25, 'PPL', 'P'),
(189790, 'Villa de Cubero', 35.0847206115723, 0.612343891814255, -107.54167175293, -1.8769562551876, 218, 38, 'PPL', 'P'),
(98829, 'Villa de Frontera Colonia', 26.4020004272461, 0.460801836568394, -98.9889984130859, -1.72768394555979, 218, 51, 'PPL', 'P'),
(98830, 'Villa de Martinez Colonia', 26.4020004272461, 0.460801836568394, -98.9899978637695, -1.72770138926493, 218, 51, 'PPL', 'P'),
(179457, 'Villa de Paz', 33.4997215270996, 0.584680439149111, -112.282501220703, -1.95969933867582, 218, 5, 'PPL', 'P'),
(185944, 'Villa del Arroyo Mobile Home Estates', 34.2902793884277, 0.598478276756812, -118.833610534668, -2.07403776586258, 218, 6, 'PPL', 'P'),
(98831, 'Villa del Mundo Colonia', 26.2509994506836, 0.458166372353652, -98.1600036621094, -1.7132152576735, 218, 51, 'PPL', 'P'),
(98832, 'Villa del Sol', 26.1911106109619, 0.457121114915309, -97.5738906860352, -1.70298565645234, 218, 51, 'PPL', 'P'),
(98834, 'Villa del Sol Colonia', 26.2479991912842, 0.458114007948718, -98.1600036621094, -1.7132152576735, 218, 51, 'PPL', 'P'),
(107158, 'Villa Del-Ray', 38.7669410705566, 0.676610762607829, -77.1877822875977, -1.34718094323114, 218, 53, 'PPL', 'P'),
(98820, 'Villa Donna Colonia', 26.1720008850098, 0.45678758727829, -98.072998046875, -1.71169672321994, 218, 51, 'PPL', 'P'),
(192378, 'Villa Espana Colonia', 31.6490001678467, 0.552379257893163, -106.291000366211, -1.85512792162888, 218, 51, 'PPL', 'P'),
(98821, 'Villa Estates Colonia', 26.2730007171631, 0.458550366893327, -98.5699996948242, -1.72037103836449, 218, 51, 'PPL', 'P'),
(91579, 'Villa Gardens', 36.0547218322754, 0.629273606863888, -83.9138870239258, -1.46457361671405, 218, 50, 'PPL', 'P'),
(185951, 'Villa Grande', 38.4730606079102, 0.671481580927363, -123.024436950684, -2.1471814852016, 218, 6, 'PPL', 'P'),
(79322, 'Villa Green', 39.9536094665527, 0.69732203324732, -76.6997222900391, -1.33866268932647, 218, 45, 'PPL', 'P'),
(28869, 'Villa Grove', 39.8627815246582, 0.695736786608451, -88.1622161865234, -1.53872094830987, 218, 18, 'PPL', 'P'),
(168374, 'Villa Grove', 41.2583312988281, 0.720093725043179, -76.7158279418945, -1.33894378597952, 218, 45, 'PPL', 'P'),
(187500, 'Villa Grove', 38.2486114501953, 0.667564204121911, -105.948608398438, -1.84915205445885, 218, 7, 'PPL', 'P'),
(52403, 'Villa Heights', 38.9372215270996, 0.679582717226303, -76.9188919067383, -1.3424879207582, 218, 25, 'PPL', 'P'),
(91580, 'Villa Heights', 35.2119407653809, 0.614564302373108, -84.8958282470703, -1.48171172411898, 218, 50, 'PPL', 'P'),
(107160, 'Villa Heights', 37.2949981689453, 0.650920512573352, -79.977783203125, -1.39587564534075, 218, 53, 'PPL', 'P'),
(38693, 'Villa Hills', 39.0633316040039, 0.681783753288226, -84.5930633544922, -1.47642747988405, 218, 21, 'PPL', 'P'),
(146529, 'Villa Madonna', 40.9144401550293, 0.71409169231544, -74.8127822875977, -1.30572937349627, 218, 37, 'PPL', 'P'),
(189786, 'Villa Madonna', 33.4225006103516, 0.583332679900449, -105.72306060791, -1.84521550289355, 218, 38, 'PPL', 'P'),
(168375, 'Villa Maria', 41.0736083984375, 0.716869702227529, -80.5074996948242, -1.40512094222301, 218, 45, 'PPL', 'P'),
(168376, 'Villa Maria Infirmary', 40.3069381713867, 0.703488782488481, -76.0961074829102, -1.32812762352828, 218, 45, 'PPL', 'P'),
(146530, 'Villa Marie Claire', 41.0136108398438, 0.71582254728691, -74.101936340332, -1.29332277124203, 218, 37, 'PPL', 'P'),
(206280, 'Villa Montaige Condominium', 40.7602806091309, 0.711401100666133, -111.930282592773, -1.95355196393159, 218, 52, 'PPL', 'P'),
(179454, 'Villa Monte Vista', 33.3944396972656, 0.582842924575984, -112.055557250977, -1.95573841918655, 218, 5, 'PPL', 'P'),
(52404, 'Villa Monticello', 39.3233299255371, 0.686321580048639, -77.0005569458008, -1.34391324457361, 218, 25, 'PPL', 'P'),
(52405, 'Villa Nova', 39.351390838623, 0.686811335373105, -76.73388671875, -1.33925897109454, 218, 25, 'PPL', 'P'),
(158117, 'Villa Nova', 40.545280456543, 0.707648640111184, -84.4247207641602, -1.47348934741142, 218, 41, 'PPL', 'P'),
(206282, 'Villa Nova Condominium', 40.8697204589844, 0.713311186378966, -111.886672973633, -1.95279083249205, 218, 52, 'PPL', 'P'),
(179455, 'Villa Novena', 33.5277786254883, 0.585170127894549, -112.084999084473, -1.95625227611888, 218, 5, 'PPL', 'P'),
(98822, 'Villa Nueva', 25.9505596160889, 0.452922708035826, -97.5558319091797, -1.70267047133733, 218, 51, 'PPL', 'P'),
(98823, 'Villa Nueva Colonia', 25.9489994049072, 0.45289547721368, -97.5510025024414, -1.70258618228883, 218, 51, 'PPL', 'P'),
(98824, 'Villa Pancho', 25.8838901519775, 0.451759106376543, -97.4155578613281, -1.70022222734722, 218, 51, 'PPL', 'P'),
(98825, 'Villa Pancho Colonia', 25.882999420166, 0.45174356017368, -97.4120025634766, -1.70016017569382, 218, 51, 'PPL', 'P'),
(121817, 'Villa Park', 41.889720916748, 0.731113552738791, -87.9888916015625, -1.53569586362765, 218, 18, 'PPL', 'P'),
(146531, 'Villa Park', 40.1436080932617, 0.70063813485766, -74.0425033569336, -1.29228546999745, 218, 37, 'PPL', 'P'),
(185941, 'Villa Park', 33.8144416809082, 0.590173342055454, -117.812217712402, -2.0562110981578, 218, 6, 'PPL', 'P'),
(25734, 'Villa Rica', 33.7319412231445, 0.588733437433075, -84.9191665649414, -1.48211905460771, 218, 13, 'PPL', 'P'),
(28870, 'Villa Ridge', 37.1586112976074, 0.648540112612012, -89.1947174072266, -1.556741494142, 218, 18, 'PPL', 'P'),
(112421, 'Villa Ridge', 38.4724998474121, 0.671471793810357, -90.8866729736328, -1.58627168957324, 218, 29, 'PPL', 'P'),
(201729, 'Villa Ridge', 45.4430618286133, 0.793131051096657, -122.741111755371, -2.14223652768954, 218, 43, 'PPL', 'P'),
(18452, 'Villa Sabine', 30.3316707611084, 0.529387522412236, -87.1591720581055, -1.52121452572618, 218, 12, 'PPL', 'P'),
(98826, 'Villa Siesta Retirement Village', 30.3722190856934, 0.530095224182411, -97.6708297729492, -1.70467756269287, 218, 51, 'PPL', 'P'),
(18453, 'Villa Tasso', 30.4599990844727, 0.531627274178506, -86.3880615234375, -1.50775610799941, 218, 12, 'PPL', 'P'),
(52406, 'Villa Tomarchio', 39.4736099243164, 0.688944460827231, -77.0902786254883, -1.34547918329458, 218, 25, 'PPL', 'P'),
(52407, 'Villa Tuscana', 39.1313896179199, 0.682971589713429, -76.5330581665039, -1.33575385162583, 218, 25, 'PPL', 'P'),
(12556, 'Villa Vale (historical)', 34.0313911437988, 0.593959824493329, -91.9094390869141, -1.60412232572782, 218, 4, 'PPL', 'P'),
(129152, 'Villa Vaughn', 44.8972206115723, 0.783604324666198, -68.7624969482422, -1.20013197363938, 218, 26, 'PPL', 'P'),
(98827, 'Villa Verde', 26.1316699981689, 0.456083680512669, -97.9980621337891, -1.7103888448086, 218, 51, 'PPL', 'P'),
(98828, 'Villa Verde Colonia', 26.1319408416748, 0.456088407623604, -98.0005569458008, -1.71043238749242, 218, 51, 'PPL', 'P'),
(52408, 'Villa Verdi', 39.0852813720703, 0.682166849011034, -76.6536102294922, -1.33785788204504, 218, 25, 'PPL', 'P'),
(118204, 'Villa Village Mobile Home Park', 41.0097198486328, 0.715754636679113, -95.2252807617188, -1.66199468042801, 218, 16, 'PPL', 'P'),
(179456, 'Villa Vista', 33.5897216796875, 0.586251238139067, -112.255561828613, -1.95922915758537, 218, 5, 'PPL', 'P'),
(84158, 'Villa Woods', 33.7213897705078, 0.588549279843696, -78.9611129760742, -1.37813140247171, 218, 48, 'PPL', 'P'),
(12557, 'Village', 33.2633285522461, 0.580554603409333, -93.0538864135742, -1.62409669969369, 218, 4, 'PPL', 'P'),
(107161, 'Village', 37.9488906860352, 0.662333089950723, -76.6044387817383, -1.33699967838377, 218, 53, 'PPL', 'P'),
(107162, 'Village Acres', 37.6872215270996, 0.657766101576374, -77.8925018310547, -1.35948061956762, 218, 53, 'PPL', 'P'),
(84163, 'Village at Bay Tree', 33.8697204589844, 0.591138138739362, -78.6641693115234, -1.37294875783236, 218, 48, 'PPL', 'P'),
(107163, 'Village At Griffinsburg', 38.5133285522461, 0.672184389139035, -78.0980606079102, -1.36306829703012, 218, 53, 'PPL', 'P'),
(25735, 'Village At Watervale', 33.538330078125, 0.585354285483928, -82.0619430541992, -1.43225109687987, 218, 13, 'PPL', 'P'),
(25736, 'Village Bluff', 31.226110458374, 0.544998440090062, -81.3583297729492, -1.41997072846129, 218, 13, 'PPL', 'P'),
(43492, 'Village Cote', 30.4799995422363, 0.531976348018388, -91.0041732788086, -1.58832245677065, 218, 22, 'PPL', 'P'),
(6559, 'Village Creek', 33.5536117553711, 0.5856210010671, -86.8083267211914, -1.51509111943176, 218, 2, 'PPL', 'P'),
(84161, 'Village Creek', 34.6936111450195, 0.605517743887191, -82.9105606079102, -1.44706226728234, 218, 48, 'PPL', 'P'),
(118205, 'Village Creek', 43.3091697692871, 0.755887608779253, -91.2350006103516, -1.59235115370967, 218, 16, 'PPL', 'P'),
(6575, 'Village Creek Junction', 33.5286102294922, 0.58518464212249, -86.8919372558594, -1.51655039855107, 218, 2, 'PPL', 'P'),
(43497, 'Village de L''Est', 30.0369396209717, 0.524243493608693, -89.9286117553711, -1.5695503668789, 218, 22, 'PPL', 'P'),
(189787, 'Village de las Huertas', 35.3013916015625, 0.61612551398314, -106.408889770508, -1.85718547988707, 218, 38, 'PPL', 'P'),
(98835, 'Village East Colonia', 27.6790008544922, 0.483089698573213, -99.1969985961914, -1.73131423359973, 218, 51, 'PPL', 'P'),
(118206, 'Village East Resort', 43.3875007629395, 0.757254742524845, -95.128059387207, -1.66029784733946, 218, 16, 'PPL', 'P'),
(211130, 'Village Eight', 20.857780456543, 0.364036943624801, -156.441116333008, -2.73041256550646, 218, 15, 'PPL', 'P'),
(179458, 'Village Fairways', 33.5950012207031, 0.586343383512784, -111.980560302734, -1.95442947551077, 218, 5, 'PPL', 'P'),
(211131, 'Village Five', 20.8594398498535, 0.364065905501655, -156.45832824707, -2.73071297007743, 218, 15, 'PPL', 'P'),
(211132, 'Village Four', 20.875, 0.364337481353816, -156.439712524414, -2.73038806442444, 218, 15, 'PPL', 'P'),
(25740, 'Village Green', 33.5894393920898, 0.58624631129105, -83.920280456543, -1.46468520316373, 218, 13, 'PPL', 'P'),
(79323, 'Village Green', 39.8694381713867, 0.695852967011006, -75.4277801513672, -1.31646311111178, 218, 45, 'PPL', 'P'),
(84162, 'Village Green', 34.1722183227539, 0.59641772244239, -79.8847198486328, -1.39425138339191, 218, 48, 'PPL', 'P'),
(91581, 'Village Green', 35.8841705322266, 0.626296925134479, -84.1675033569336, -1.46900005676187, 218, 50, 'PPL', 'P'),
(153389, 'Village Green', 43.1333312988281, 0.752818648518073, -76.3133316040039, -1.33191889965611, 218, 40, 'PPL', 'P'),
(52410, 'Village Green Estates', 39.3911094665527, 0.687504556204852, -77.0527801513672, -1.34482471145669, 218, 25, 'PPL', 'P'),
(158118, 'Village Green Mobile Home Park', 41.4944381713867, 0.724214567355913, -83.5408325195313, -1.45806258732297, 218, 41, 'PPL', 'P'),
(185945, 'Village Green Trailer Park', 32.9147186279297, 0.574470212424884, -117.122779846191, -2.0441781374045, 218, 6, 'PPL', 'P'),
(69801, 'Village Grove', 35.6049995422363, 0.621424472183098, -77.3949966430664, -1.35079751599147, 218, 33, 'PPL', 'P'),
(98836, 'Village Grove Number 2 Colonia', 26.1720008850098, 0.45678758727829, -98.0820007324219, -1.71185384972425, 218, 51, 'PPL', 'P'),
(114208, 'Village Hill', 41.6830596923828, 0.727506633937415, -72.2386093139648, -1.26080157959053, 218, 8, 'PPL', 'P'),
(12559, 'Village Junction', 33.2491683959961, 0.580307462060174, -93.0508270263672, -1.62404330331383, 218, 4, 'PPL', 'P'),
(52411, 'Village Manor', 39.5802803039551, 0.690806210166278, -76.397216796875, -1.33338297246538, 218, 25, 'PPL', 'P'),
(192886, 'Village Meadows', 31.5499992370605, 0.550651365688406, -110.27082824707, -1.92458902181254, 218, 5, 'PPL', 'P'),
(25743, 'Village Mill', 33.940559387207, 0.592374511275432, -84.3144378662109, -1.47156454773356, 218, 13, 'PPL', 'P'),
(98837, 'Village Mills', 30.4936103820801, 0.532213901987623, -94.397216796875, -1.64754223782436, 218, 51, 'PPL', 'P'),
(25744, 'Village North', 33.9375, 0.592321114895576, -84.3077774047852, -1.47144830075198, 218, 13, 'PPL', 'P'),
(6561, 'Village Number 1', 34.7400016784668, 0.606327411437602, -87.7177810668945, -1.53096409216085, 218, 2, 'PPL', 'P'),
(69802, 'Village Oaks', 36.3763885498047, 0.634887750178857, -79.6758270263672, -1.39060551585959, 218, 33, 'PPL', 'P'),
(172677, 'Village of Alpenwald', 42.8205604553223, 0.747359767494656, -73.0330581665039, -1.27466732780603, 218, 55, 'PPL', 'P'),
(52413, 'Village of Bachman', 39.6227798461914, 0.691547967108892, -76.9766693115234, -1.34349632670496, 218, 25, 'PPL', 'P'),
(52414, 'Village of Bynum Run', 39.4749984741211, 0.688968695593151, -76.2805633544922, -1.33134698581202, 218, 25, 'PPL', 'P'),
(52415, 'Village of Church Creek', 39.4780616760254, 0.689022158552034, -76.2552795410156, -1.33090570001939, 218, 25, 'PPL', 'P'),
(52416, 'Village of Cross Keys', 39.3572196960449, 0.686913068126746, -76.6469421386719, -1.33774150190541, 218, 25, 'PPL', 'P'),
(52417, 'Village of Deep Run', 39.1886100769043, 0.683970275122208, -76.7869415283203, -1.34018495220556, 218, 25, 'PPL', 'P'),
(52418, 'Village of Dorseys Search', 39.2366714477539, 0.684809104286556, -76.851936340332, -1.34131932567188, 218, 25, 'PPL', 'P'),
(69805, 'Village of Forest Hills', 35.2961082458496, 0.616033302030396, -83.1941680908203, -1.45201215164242, 218, 33, 'PPL', 'P'),
(14783, 'Village of Garrison Lake', 39.2588882446289, 0.685196860541271, -75.5897216796875, -1.31928952397669, 218, 10, 'PPL', 'P'),
(179460, 'Village of Gila Springs', 33.3116683959961, 0.58139829284267, -111.938606262207, -1.95369723936906, 218, 5, 'PPL', 'P'),
(71507, 'Village of Glen Oaks', 39.8233299255371, 0.695048226308611, -75.0380630493164, -1.30966126452967, 218, 37, 'PPL', 'P'),
(129153, 'Village of Halidon (historical)', 43.6963882446289, 0.76264584609852, -70.3586120605469, -1.22798943758994, 218, 26, 'PPL', 'P'),
(133532, 'Village of Lake Isabella', 43.6436080932617, 0.761724658677461, -84.9972229003906, -1.48348139466334, 218, 27, 'PPL', 'P'),
(168378, 'Village of Mingo', 40.1833305358887, 0.701331422268435, -75.5100021362305, -1.31789815546517, 218, 45, 'PPL', 'P'),
(107165, 'Village of Mount Air', 38.725830078125, 0.675893240431134, -77.1761093139648, -1.34697721140775, 218, 53, 'PPL', 'P'),
(126405, 'Village of Nagog Woods', 42.5188903808594, 0.742094631440542, -71.4300003051758, -1.24668869002587, 218, 23, 'PPL', 'P'),
(52419, 'Village of Painters Mill', 39.398609161377, 0.68763545057243, -76.7874984741211, -1.34019467274354, 218, 25, 'PPL', 'P'),
(52420, 'Village of Pawner', 39.3405609130859, 0.686622317514736, -76.4380569458008, -1.33409576753114, 218, 25, 'PPL', 'P'),
(52421, 'Village of Peachwood', 39.5263900756836, 0.689865648248289, -76.9000015258789, -1.34215822141525, 218, 25, 'PPL', 'P'),
(52422, 'Village of Silver Hall', 39.3888893127441, 0.687465807210992, -76.4627838134766, -1.33452733278579, 218, 25, 'PPL', 'P'),
(153390, 'Village of the Branch', 40.8561096191406, 0.71307363240973, -73.1877822875977, -1.27736777315137, 218, 40, 'PPL', 'P'),
(52424, 'Village of Thomas Run', 39.5638885498047, 0.690520120086176, -76.3247222900391, -1.33211770463149, 218, 25, 'PPL', 'P'),
(98841, 'Village of Tiki Island', 29.2966709136963, 0.511323367317256, -94.9175033569336, -1.65662295135126, 218, 51, 'PPL', 'P'),
(52425, 'Village of Timber Grove', 39.4558296203613, 0.688634135981209, -76.8050003051758, -1.34050013732057, 218, 25, 'PPL', 'P'),
(52426, 'Village of Vanderway', 39.4030609130859, 0.687713148297233, -76.5141677856445, -1.33542415228288, 218, 25, 'PPL', 'P'),
(179461, 'Village on the Lakes', 33.5152816772461, 0.584952015001272, -112.012496948242, -1.95498687512693, 218, 5, 'PPL', 'P'),
(138588, 'Village Park', 44.4305610656738, 0.775459579104409, -95.7805633544922, -1.67168618995091, 218, 28, 'PPL', 'P'),
(179459, 'Village Park', 33.584171295166, 0.586154365654415, -112.199996948242, -1.95825936747442, 218, 5, 'PPL', 'P'),
(211133, 'Village Park', 21.3980598449707, 0.373466597833526, -158.0302734375, -2.75814858931131, 218, 15, 'PPL', 'P'),
(43495, 'Village Saint George', 30.3619403839111, 0.52991582699348, -91.0672225952148, -1.58942287493307, 218, 22, 'PPL', 'P'),
(168377, 'Village Shires', 40.2030601501465, 0.701675768997382, -74.970832824707, -1.30848787575338, 218, 45, 'PPL', 'P'),
(211134, 'Village Six', 20.8394393920898, 0.363716831661773, -156.472503662109, -2.73096037774269, 218, 15, 'PPL', 'P'),
(6563, 'Village Springs', 33.7583312988281, 0.589194031143605, -86.6386108398438, -1.51212901850932, 218, 2, 'PPL', 'P'),
(52412, 'Village Square', 39.128059387207, 0.682913466222637, -76.6347198486328, -1.33752818270209, 218, 25, 'PPL', 'P'),
(107169, 'Village Square', 38.0544395446777, 0.664175265055758, -78.4625015258789, -1.36942899097766, 218, 53, 'PPL', 'P'),
(199752, 'Village Square', 41.139720916748, 0.718023583348833, -100.801940917969, -1.75932576141935, 218, 35, 'PPL', 'P'),
(69804, 'Village Square Townhouses', 35.2886085510254, 0.615902407662818, -81.5388870239258, -1.42312204697919, 218, 33, 'PPL', 'P'),
(43496, 'Village St. George', 30.3619403839111, 0.52991582699348, -91.0672225952148, -1.58942287493307, 218, 22, 'PPL', 'P'),
(211135, 'Village Ten', 20.8616695404053, 0.364104820943084, -156.400283813477, -2.72969990359876, 218, 15, 'PPL', 'P'),
(138589, 'Village Terrace', 43.7583312988281, 0.763726956343038, -91.35888671875, -1.59451337419871, 218, 28, 'PPL', 'P'),
(211136, 'Village Thirteen', 20.8369407653809, 0.363673222398923, -156.434997558594, -2.73030577274675, 218, 15, 'PPL', 'P'),
(206287, 'Village Three Condominium', 40.642219543457, 0.709340546351712, -111.847221374512, -1.95210227219221, 218, 52, 'PPL', 'P'),
(211137, 'Village Two', 20.8947200775146, 0.364681661635195, -156.4052734375, -2.7297869889664, 218, 15, 'PPL', 'P'),
(206288, 'Village Two Condo', 40.6808280944824, 0.710014392686529, -111.954437255859, -1.95397354233215, 218, 52, 'PPL', 'P'),
(25745, 'Village West', 33.517219543457, 0.584985837147116, -82.0550003051758, -1.43212992305027, 218, 13, 'PPL', 'P'),
(52427, 'Villages of Elk Neck', 39.5325012207031, 0.689972307849947, -75.9027786254883, -1.32475339842715, 218, 25, 'PPL', 'P'),
(52428, 'Villages of Montpelier', 39.0499992370605, 0.68155105958798, -76.8394393920898, -1.3411012127786, 218, 25, 'PPL', 'P'),
(18454, 'Villages of Oriole', 26.4619407653809, 0.461847992823604, -80.1530609130859, -1.39893481848492, 218, 12, 'PPL', 'P'),
(192379, 'Villalobos Estates Colonia', 31.6000003814697, 0.551524050288111, -106.259002685547, -1.85456945674829, 218, 51, 'PPL', 'P'),
(107166, 'Villamay', 38.7583312988281, 0.676460493743321, -77.054443359375, -1.34485373991257, 218, 53, 'PPL', 'P'),
(107167, 'Villamont', 37.3952789306641, 0.652670742041752, -79.7763900756836, -1.39236067217601, 218, 53, 'PPL', 'P'),
(18455, 'Villano Beach', 29.9383296966553, 0.52252242575423, -81.3022232055664, -1.41899148412847, 218, 12, 'PPL', 'P'),
(62175, 'Villanova', 32.4336090087891, 0.566073265507864, -90.7727813720703, -1.5842839061356, 218, 30, 'PPL', 'P'),
(168379, 'Villanova', 40.0372200012207, 0.698781312366629, -75.3494415283203, -1.31509584420814, 218, 45, 'PPL', 'P'),
(25746, 'Villanow', 34.6736106872559, 0.605168670047309, -85.1147232055664, -1.48553216186076, 218, 13, 'PPL', 'P'),
(189788, 'Villanueva', 35.2666702270508, 0.615519511677092, -105.360282897949, -1.83888383740189, 218, 38, 'PPL', 'P'),
(138590, 'Villard', 45.7155609130859, 0.797887057329375, -95.2688903808594, -1.66275581186755, 218, 28, 'PPL', 'P'),
(209057, 'Villard Junction', 46.1786117553711, 0.805968819131384, -118.991386413574, -2.07679147442972, 218, 56, 'PPL', 'P'),
(98838, 'Villareal Colonia', 26.306999206543, 0.459143752473711, -98.6439971923828, -1.72166253833512, 218, 51, 'PPL', 'P'),
(98839, 'Villareales', 26.3731708526611, 0.460298665569937, -98.8737869262695, -1.72567312577873, 218, 51, 'PPL', 'P'),
(401, 'Villas', 26.5499992370605, 0.463384903088689, -81.8688888549805, -1.4288816654687, 218, 12, 'PPL', 'P'),
(28873, 'Villas', 38.8994407653809, 0.678923318540399, -87.7536087036133, -1.5315894023848, 218, 18, 'PPL', 'P'),
(71508, 'Villas', 39.0286102294922, 0.681177750982178, -74.9388885498047, -1.30793034297917, 218, 37, 'PPL', 'P'),
(98840, 'Villas del Valle Colonia', 26.1240005493164, 0.455949823378379, -98.1859970092773, -1.7136689271652, 218, 51, 'PPL', 'P'),
(168380, 'Villas of Middletown', 40.1533317565918, 0.700807844798125, -74.8983306884766, -1.30722247476143, 218, 45, 'PPL', 'P'),
(179462, 'Villas Plaza', 33.6716690063477, 0.587681488802494, -112.120826721191, -1.95687758634283, 218, 5, 'PPL', 'P'),
(107168, 'Villboro', 38.1349983215332, 0.665581280953266, -77.3897171020508, -1.35070537061775, 218, 53, 'PPL', 'P'),
(43498, 'Ville Platte', 30.687780380249, 0.535602807764263, -92.2713928222656, -1.6104396101496, 218, 22, 'PPL', 'P'),
(187503, 'Villegreen', 37.3058280944824, 0.65110953043172, -103.519721984863, -1.80675998938502, 218, 7, 'PPL', 'P'),
(185948, 'Villinger', 38.1441688537598, 0.665741336934779, -121.372497558594, -2.11834970376624, 218, 6, 'PPL', 'P'),
(118208, 'Villisca', 40.9297218322754, 0.714358407898612, -94.975830078125, -1.65764094467794, 218, 16, 'PPL', 'P'),
(6565, 'Villula', 32.2658309936523, 0.563144986731267, -85.1647186279297, -1.48640474659192, 218, 2, 'PPL', 'P'),
(12564, 'Vilonia', 35.0838890075684, 0.612329377586314, -92.2077789306641, -1.60932933829114, 218, 4, 'PPL', 'P'),
(6566, 'Vilula', 32.5497207641602, 0.568099797939359, -87.2705612182617, -1.52315863332194, 218, 2, 'PPL', 'P'),
(62176, 'Vimville', 32.3300018310547, 0.5642649791277, -88.5727767944336, -1.5458865826969, 218, 30, 'PPL', 'P'),
(112249, 'Vimy Ridge', 34.6011085510254, 0.603903269055357, -92.413330078125, -1.61291688259559, 218, 4, 'PPL', 'P'),
(185949, 'Vin', 38.649169921875, 0.674555268299478, -121.601112365723, -2.12233978486945, 218, 6, 'PPL', 'P'),
(6567, 'Vina', 34.3763885498047, 0.59998116513897, -88.0586090087891, -1.53691266192971, 218, 2, 'PPL', 'P'),
(84164, 'Vina', 33.860279083252, 0.590973355646914, -78.9369430541992, -1.37770955775505, 218, 48, 'PPL', 'P'),
(185950, 'Vina', 39.9330596923828, 0.696963372027514, -122.052780151367, -2.13022287485414, 218, 6, 'PPL', 'P'),
(129154, 'Vinalhaven', 44.0480613708496, 0.768783700041853, -68.8322219848633, -1.20134890509949, 218, 26, 'PPL', 'P'),
(111867, 'Vincen', 39.5463905334473, 0.690214722088171, -80.783332824707, -1.40993513852555, 218, 58, 'PPL', 'P'),
(31399, 'Vincennes', 38.6772193908691, 0.675044823886862, -87.5286102294922, -1.52766243819943, 218, 19, 'PPL', 'P'),
(118209, 'Vincennes', 40.4963912963867, 0.706795363297923, -91.5697174072266, -1.59819306387687, 218, 16, 'PPL', 'P'),
(6568, 'Vincent', 33.3844413757324, 0.582668420945556, -86.4119415283203, -1.50817289271001, 218, 2, 'PPL', 'P'),
(12563, 'Vincent', 35.2122192382813, 0.614569162642098, -90.3008270263672, -1.57604674888399, 218, 4, 'PPL', 'P'),
(25747, 'Vincent', 32.473331451416, 0.566766552918639, -83.0005569458008, -1.44863299969327, 218, 13, 'PPL', 'P'),
(34276, 'Vincent', 39.1916694641113, 0.684023671502064, -98.7194366455078, -1.72297920517806, 218, 20, 'PPL', 'P'),
(38698, 'Vincent', 37.4683303833008, 0.653945730413628, -83.7738876342773, -1.4621301664139, 218, 21, 'PPL', 'P'),
(118210, 'Vincent', 42.5919418334961, 0.743369619812417, -94.0199966430664, -1.64095850413552, 218, 16, 'PPL', 'P'),
(153392, 'Vincent', 42.8352813720703, 0.747616695960821, -77.4013900756836, -1.35090910244114, 218, 40, 'PPL', 'P'),
(158119, 'Vincent', 41.420280456543, 0.722920271066135, -82.1161117553711, -1.43319651906685, 218, 41, 'PPL', 'P'),
(185953, 'Vincent', 36.0833282470703, 0.629772882989251, -119.144439697266, -2.07946275816112, 218, 6, 'PPL', 'P'),
(192380, 'Vincent', 32.4816703796387, 0.566912094672211, -101.225280761719, -1.76671443554767, 218, 51, 'PPL', 'P'),
(197766, 'Vincent', 45.6958312988281, 0.797542710600428, -111.359169006348, -1.94358415144559, 218, 31, 'PPL', 'P'),
(107170, 'Vincent Corner', 37.1419410705566, 0.648249162262921, -78.70361328125, -1.37363718497415, 218, 53, 'PPL', 'P'),
(107171, 'Vincent Grove', 36.7125015258789, 0.640754028270029, -77.1494369506836, -1.3465116908492, 218, 53, 'PPL', 'P'),
(43499, 'Vincent Landing', 30.1555595397949, 0.526313801750607, -93.3319396972656, -1.62894964499008, 218, 22, 'PPL', 'P'),
(185954, 'Vincent Landing', 38.2194404602051, 0.667055074300515, -122.940826416016, -2.14572220608229, 218, 6, 'PPL', 'P'),
(71509, 'Vincentown', 39.9338912963867, 0.696977886255455, -74.748893737793, -1.30461430794786, 218, 37, 'PPL', 'P'),
(58077, 'Vincit', 36.165828704834, 0.631212787611629, -90.0691680908203, -1.57200353771703, 218, 29, 'PPL', 'P'),
(77559, 'Vinco', 35.9536094665527, 0.627508863167547, -97.0372161865234, -1.69361891942437, 218, 42, 'PPL', 'P'),
(168381, 'Vinco', 40.4049987792969, 0.70520026296302, -78.855827331543, -1.37629382131956, 218, 45, 'PPL', 'P'),
(38695, 'Vine', 37.3127784729004, 0.651230837419374, -83.8394393920898, -1.4632742604182, 218, 21, 'PPL', 'P'),
(91583, 'Vine', 36.0311088562012, 0.628861482685199, -86.357780456543, -1.50722760368109, 218, 50, 'PPL', 'P'),
(107172, 'Vine', 36.5713882446289, 0.638291136893924, -76.0769424438477, -1.32779313049536, 218, 53, 'PPL', 'P'),
(123889, 'Vine', 40.2949981689453, 0.703280390133182, -87.1350021362305, -1.52079268100951, 218, 19, 'PPL', 'P'),
(34277, 'Vine Creek', 39.1180610656738, 0.68273896259221, -97.4155578613281, -1.70022222734722, 218, 20, 'PPL', 'P'),
(38696, 'Vine Grove', 37.810001373291, 0.659909014147506, -85.9813919067383, -1.50065838422019, 218, 21, 'PPL', 'P'),
(38697, 'Vine Grove Junction', 37.8319396972656, 0.660291910133232, -85.9347229003906, -1.49984385640079, 218, 21, 'PPL', 'P'),
(6569, 'Vine Hill', 32.6122207641602, 0.569190628721856, -86.9022216796875, -1.51672989560854, 218, 2, 'PPL', 'P'),
(177693, 'Vine Hill', 38.0086097717285, 0.663375384622353, -122.095001220703, -2.13095977152777, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(91584, 'Vine Ridge', 36.2605590820313, 0.632866144595378, -85.1188888549805, -1.48560486615852, 218, 50, 'PPL', 'P'),
(206304, 'Vine Street East Condominium', 40.6388893127441, 0.709282422860921, -111.859718322754, -1.95232038508548, 218, 52, 'PPL', 'P'),
(153393, 'Vine Valley', 42.7236099243164, 0.745667661517047, -77.3249969482422, -1.34957579084139, 218, 40, 'PPL', 'P'),
(185955, 'Vineburg', 38.2724990844727, 0.667981121990563, -122.4375, -2.13693750291056, 218, 6, 'PPL', 'P'),
(192975, 'Vinedo Acres Colonia', 31.6280002593994, 0.55201274034814, -106.283996582031, -1.85500568253484, 218, 51, 'PPL', 'P'),
(6570, 'Vinegar Bend', 31.2636108398438, 0.545652945217463, -88.3447189331055, -1.54190622213166, 218, 2, 'PPL', 'P'),
(52429, 'Vinegar Hill', 39.6736106872559, 0.692435132647025, -76.1163864135742, -1.32848155763715, 218, 25, 'PPL', 'P'),
(58079, 'Vinegar Hill', 36.7425003051758, 0.641277605740339, -90.4013900756836, -1.5778019052004, 218, 29, 'PPL', 'P'),
(69808, 'Vinegar Hill', 34.1711082458496, 0.59639834794546, -78.820556640625, -1.37567823163359, 218, 33, 'PPL', 'P'),
(91585, 'Vinegar Hill', 36.5511093139648, 0.637937202785052, -82.1030578613281, -1.43296868563559, 218, 50, 'PPL', 'P'),
(192381, 'Vinegarone', 29.9488906860352, 0.522706749791177, -100.760559082031, -1.75860351213172, 218, 51, 'PPL', 'P'),
(6571, 'Vineland', 32.0355606079102, 0.559126010330228, -87.6594390869141, -1.52994583251806, 218, 2, 'PPL', 'P'),
(18456, 'Vineland', 28.3950004577637, 0.495586249093273, -81.5033264160156, -1.42250139728714, 218, 12, 'PPL', 'P'),
(58078, 'Vineland', 38.0952796936035, 0.664888060121518, -90.6127777099609, -1.58149131541655, 218, 29, 'PPL', 'P'),
(71510, 'Vineland', 39.4861106872559, 0.689162640299536, -75.0261077880859, -1.30945260585826, 218, 37, 'PPL', 'P'),
(133533, 'Vineland', 42.0613899230957, 0.734109742123185, -86.4702835083008, -1.5091911523528, 218, 27, 'PPL', 'P'),
(138593, 'Vineland', 46.1636085510254, 0.805706963817202, -93.7572174072266, -1.63637214126424, 218, 28, 'PPL', 'P'),
(187501, 'Vineland', 38.2455596923828, 0.66751094090011, -104.458892822266, -1.82315161273641, 218, 7, 'PPL', 'P'),
(209059, 'Vineland', 46.3972206115723, 0.809784263446113, -117.053062438965, -2.04296133910244, 218, 56, 'PPL', 'P'),
(107181, 'Vineland (historical)', 36.6341705322266, 0.639386894524437, -77.841667175293, -1.35859338745046, 218, 53, 'PPL', 'P'),
(6572, 'Vineland Park', 33.4397201538086, 0.583633217629465, -86.9947204589844, -1.51834430386135, 218, 2, 'PPL', 'P'),
(201730, 'Vinemaple', 45.8886108398438, 0.800907348321634, -123.543060302734, -2.15623317027262, 218, 43, 'PPL', 'P'),
(6573, 'Vinemont', 34.2416687011719, 0.59762986021254, -86.8661117553711, -1.51609965853658, 218, 2, 'PPL', 'P'),
(168382, 'Vinemont', 40.2819404602051, 0.703052490122899, -76.0813903808594, -1.32787076164114, 218, 45, 'PPL', 'P'),
(6574, 'Vines Mill', 33.4930610656738, 0.584564192167529, -87.164436340332, -1.52130640478379, 218, 2, 'PPL', 'P'),
(25749, 'Vineville', 32.8441696166992, 0.573238899894885, -83.6600036621094, -1.46014251613432, 218, 13, 'PPL', 'P'),
(34278, 'Vinewood', 39.1716690063477, 0.683674597662182, -94.793327331543, -1.65445567085616, 218, 20, 'PPL', 'P'),
(158120, 'Vinewood Beach', 41.6536102294922, 0.72699264384703, -81.4561080932617, -1.42167728208782, 218, 41, 'PPL', 'P'),
(12566, 'Viney Grove', 36.0083312988281, 0.628463939313477, -94.3300018310547, -1.64636911536418, 218, 4, 'PPL', 'P'),
(12567, 'Vineyard', 34.6577796936035, 0.604892367084213, -90.870002746582, -1.58598073922415, 218, 4, 'PPL', 'P'),
(38700, 'Vineyard', 37.8438911437988, 0.660500502225612, -84.5877838134766, -1.47633533451033, 218, 21, 'PPL', 'P'),
(98842, 'Vineyard', 33.167781829834, 0.578886998513753, -97.9661102294922, -1.70983117887634, 218, 51, 'PPL', 'P'),
(153394, 'Vineyard', 42.3927803039551, 0.739893595378619, -79.4627838134766, -1.38688721034562, 218, 40, 'PPL', 'P'),
(168383, 'Vineyard', 40.4247207641602, 0.705544476533913, -77.7838897705078, -1.3575849815037, 218, 45, 'PPL', 'P'),
(209891, 'Vineyard', 40.2999992370605, 0.703367675237909, -111.732780456543, -1.95010490137465, 218, 52, 'PPL', 'P'),
(185956, 'Vineyard (historical)', 36.7502784729004, 0.641413360376906, -121.384719848633, -2.11856302296956, 218, 6, 'PPL', 'P'),
(206292, 'Vineyard Condominium', 40.8491706848145, 0.712952525159159, -111.90055847168, -1.95303318015124, 218, 52, 'PPL', 'P'),
(25757, 'Vineyard Creek', 34.1175003051758, 0.595462712875488, -83.0869369506836, -1.45014061518637, 218, 13, 'PPL', 'P'),
(25750, 'Vineyard Crossroads', 33.3811111450195, 0.582610297454765, -84.67138671875, -1.47779448047159, 218, 13, 'PPL', 'P'),
(126406, 'Vineyard Haven', 41.4541702270508, 0.723511759144241, -70.6041717529297, -1.2322752627322, 218, 23, 'PPL', 'P'),
(126407, 'Vineyard Highlands', 41.4638900756836, 0.723681402505679, -70.5666732788086, -1.23162079089431, 218, 23, 'PPL', 'P'),
(18457, 'Vineyards', 26.2275009155273, 0.457756245545779, -81.7094421386719, -1.42609879528762, 218, 12, 'PPL', 'P'),
(34279, 'Vining', 39.5669403076172, 0.690573383307978, -97.2949981689453, -1.69811806376995, 218, 20, 'PPL', 'P'),
(77561, 'Vining', 36.7675018310547, 0.641713964684948, -98.1638870239258, -1.71328303512324, 218, 42, 'PPL', 'P'),
(118211, 'Vining', 41.9900016784668, 0.732863782207191, -92.3797225952148, -1.6123303213655, 218, 16, 'PPL', 'P'),
(138595, 'Vining', 46.2630615234375, 0.807442745636688, -95.5366668701172, -1.66742939326453, 218, 28, 'PPL', 'P'),
(126408, 'Vining Hill', 42.0311088562012, 0.733581237804858, -72.8055572509766, -1.27069668777877, 218, 23, 'PPL', 'P'),
(43500, 'Vining Mills (historical)', 32.6994400024414, 0.570712891600945, -92.7422180175781, -1.61865706000915, 218, 22, 'PPL', 'P'),
(25751, 'Vinings', 33.8647193908691, 0.591050853634635, -84.4644393920898, -1.47418256824317, 218, 13, 'PPL', 'P'),
(77562, 'Vinita', 36.6386108398438, 0.639464392512158, -95.1538925170898, -1.66074872051201, 218, 42, 'PPL', 'P'),
(107174, 'Vinita', 37.5819396972656, 0.655928587003246, -77.6827774047852, -1.35582023780736, 218, 53, 'PPL', 'P'),
(139505, 'Vinita', 40.5652809143066, 0.707997713951067, -92.3988876342773, -1.61266481439841, 218, 29, 'PPL', 'P'),
(58081, 'Vinita Park', 38.689998626709, 0.675267863628156, -90.3424987792969, -1.57677405817769, 218, 29, 'PPL', 'P'),
(58082, 'Vinita Terrace', 38.6855583190918, 0.675190365640435, -90.3291702270508, -1.57654143105647, 218, 29, 'PPL', 'P'),
(12568, 'Vinity Corner', 35.079719543457, 0.612256606709527, -91.7430572509766, -1.6012184148752, 218, 4, 'PPL', 'P'),
(118212, 'Vinje', 43.473331451416, 0.758752770638015, -93.6766662597656, -1.63496625852479, 218, 16, 'PPL', 'P'),
(34281, 'Vinland', 38.8394393920898, 0.677876097020753, -95.1819381713867, -1.66123820952037, 218, 20, 'PPL', 'P'),
(192916, 'Vinland', 35.7150001525879, 0.623344345012936, -119.23388671875, -2.08102390319213, 218, 6, 'PPL', 'P'),
(209058, 'Vinland', 47.7733306884766, 0.833801915157965, -122.696113586426, -2.14145116148408, 218, 56, 'PPL', 'P'),
(6576, 'Vinnette', 33.6261100769043, 0.586886335480024, -85.9188919067383, -1.49956755343769, 218, 2, 'PPL', 'P'),
(38701, 'Vinnie', 37.0108299255371, 0.64596084109627, -84.8691711425781, -1.48124646987655, 218, 21, 'PPL', 'P'),
(176831, 'Vinnie Ha Ha', 42.8805618286133, 0.748406989014302, -88.9047164916992, -1.55168002333225, 218, 57, 'PPL', 'P'),
(77563, 'Vinson', 34.9005584716797, 0.609129656115611, -99.8594436645508, -1.7428760811562, 218, 42, 'PPL', 'P'),
(91586, 'Vinson', 36.6152801513672, 0.639057195181485, -88.0208282470703, -1.53625326324381, 218, 50, 'PPL', 'P'),
(98843, 'Vinson', 30.2180595397949, 0.527404632533104, -97.7808303833008, -1.70659743552271, 218, 51, 'PPL', 'P'),
(12569, 'Vinson (historical)', 33.4277801513672, 0.583424825274166, -91.2141723632813, -1.59198763222088, 218, 4, 'PPL', 'P'),
(25752, 'Vinson (historical)', 33.9363899230957, 0.592301740398645, -85.0491714477539, -1.48438806785646, 218, 13, 'PPL', 'P'),
(91587, 'Vinta Mill', 35.0697212219238, 0.6120821030791, -86.9391708374023, -1.51737478006651, 218, 50, 'PPL', 'P'),
(168384, 'Vintage', 40.0008316040039, 0.698146215025673, -76.0800018310547, -1.32784652687522, 218, 45, 'PPL', 'P'),
(168385, 'Vintage Station', 40.0008316040039, 0.698146215025673, -76.0811080932617, -1.32786583479312, 218, 45, 'PPL', 'P'),
(14790, 'Vintage Village', 39.788330078125, 0.694437363733574, -75.7069396972656, -1.32133536432608, 218, 10, 'PPL', 'P'),
(34282, 'Vinton', 37.1055603027344, 0.647614198080019, -96.8249969482422, -1.68991499498029, 218, 20, 'PPL', 'P'),
(43501, 'Vinton', 30.190559387207, 0.526924664325644, -93.5811080932617, -1.63329845389213, 218, 22, 'PPL', 'P'),
(62177, 'Vinton', 33.6583290100098, 0.587448661944194, -88.5233306884766, -1.54502358534565, 218, 30, 'PPL', 'P'),
(74664, 'Vinton', 39.2441711425781, 0.684939998654133, -82.4369430541992, -1.43879608157485, 218, 41, 'PPL', 'P'),
(107175, 'Vinton', 37.2808303833008, 0.650673238066138, -79.897216796875, -1.39446949628519, 218, 53, 'PPL', 'P'),
(118213, 'Vinton', 42.1686096191406, 0.735981078842156, -92.0233306884766, -1.60611010916546, 218, 16, 'PPL', 'P'),
(185960, 'Vinton', 39.8044395446777, 0.694718526965659, -120.177223205566, -2.09748823084127, 218, 6, 'PPL', 'P'),
(192383, 'Vinton', 31.9511108398438, 0.557652083824924, -106.601936340332, -1.86055477814019, 218, 51, 'PPL', 'P'),
(111868, 'Vinton (historical)', 38.2275009155273, 0.667195755785099, -80.9933319091797, -1.41360031397577, 218, 58, 'PPL', 'P'),
(143288, 'Vinton (historical)', 41.5391693115234, 0.72499527302947, -98.9800033569336, -1.72752695221353, 218, 35, 'PPL', 'P'),
(192382, 'Vinton Acres Number 1 Colonia', 31.9619998931885, 0.557842133658215, -106.61799621582, -1.86083507584492, 218, 51, 'PPL', 'P'),
(107176, 'Vinton Heights', 37.2613906860352, 0.650333951343262, -79.8861083984375, -1.39427561815783, 218, 53, 'PPL', 'P'),
(25754, 'Vinton Woods', 33.5875015258789, 0.586212489145206, -84.3611068725586, -1.47237907555296, 218, 13, 'PPL', 'P'),
(69812, 'Vinton Woods', 35.3083305358887, 0.616246621233711, -81.1552810668945, -1.41642685999873, 218, 33, 'PPL', 'P'),
(168386, 'Vintondale', 40.4813919067383, 0.706533574562768, -78.9188919067383, -1.37739450579809, 218, 45, 'PPL', 'P'),
(153395, 'Vintonton', 42.6105613708496, 0.743694592044434, -74.4747161865234, -1.29982900694315, 218, 40, 'PPL', 'P'),
(185961, 'Vinvale', 33.9536094665527, 0.592602278127661, -118.162780761719, -2.06232957760421, 218, 6, 'PPL', 'P'),
(12571, 'Viola', 36.396671295166, 0.635241750866756, -91.9824981689453, -1.60539744725775, 218, 4, 'PPL', 'P'),
(14785, 'Viola', 39.042781829834, 0.68142509206842, -75.5722198486328, -1.31898405939965, 218, 10, 'PPL', 'P'),
(25755, 'Viola', 33.2547187805176, 0.580404334544825, -85.1488876342773, -1.48612844362882, 218, 13, 'PPL', 'P'),
(34283, 'Viola', 37.4830589294434, 0.654202792037847, -97.6436080932617, -1.7042024547544, 218, 20, 'PPL', 'P'),
(38704, 'Viola', 36.8555603027344, 0.643250874950033, -88.6413879394531, -1.54708407308105, 218, 21, 'PPL', 'P'),
(58083, 'Viola', 36.5730590820313, 0.63832029850786, -93.5819396972656, -1.63331296812007, 218, 29, 'PPL', 'P'),
(91588, 'Viola', 35.538330078125, 0.620260870523815, -85.8591690063477, -1.49852519218703, 218, 50, 'PPL', 'P'),
(98844, 'Viola', 27.8419399261475, 0.48593352185374, -97.5233306884766, -1.70210321802514, 218, 51, 'PPL', 'P'),
(111870, 'Viola', 39.9650001525879, 0.697520838222695, -80.5899963378906, -1.40656078026636, 218, 58, 'PPL', 'P'),
(118215, 'Viola', 42.0908317565918, 0.734623599055515, -91.4375, -1.59588543479232, 218, 16, 'PPL', 'P'),
(121820, 'Viola', 41.2030601501465, 0.719129061517325, -90.5869369506836, -1.58104030908594, 218, 18, 'PPL', 'P'),
(138597, 'Viola', 44.0633316040039, 0.769050215887942, -92.2680587768555, -1.61038142007978, 218, 28, 'PPL', 'P'),
(153396, 'Viola', 41.1363906860352, 0.717965459858042, -74.0827789306641, -1.29298841136717, 218, 40, 'PPL', 'P'),
(168388, 'Viola', 40.7522201538086, 0.71126041918155, -78.4013900756836, -1.36836239496109, 218, 45, 'PPL', 'P'),
(176832, 'Viola', 43.5061111450195, 0.759324884219191, -90.6680603027344, -1.58245617867948, 218, 57, 'PPL', 'P'),
(194029, 'Viola', 40.5180587768555, 0.707173532172714, -121.676666259766, -2.1236584490832, 218, 6, 'PPL', 'P'),
(195763, 'Viola', 46.8386116027832, 0.817487989531385, -117.023612976074, -2.04244734901206, 218, 17, 'PPL', 'P'),
(201731, 'Viola', 45.2983283996582, 0.790604976223689, -122.409172058105, -2.13644308705418, 218, 43, 'PPL', 'P'),
(209810, 'Viola', 42.2661094665527, 0.737682772199689, -110.377777099609, -1.92645563142058, 218, 59, 'PPL', 'P'),
(6577, 'Viola (historical)', 33.8611106872559, 0.590987869874855, -86.5580596923828, -1.51072313576987, 218, 2, 'PPL', 'P'),
(43502, 'Viola (historical)', 30.6550006866455, 0.535030694183087, -90.2944412231445, -1.57593529559237, 218, 22, 'PPL', 'P'),
(187502, 'Viola (historical)', 37.1333312988281, 0.648098893398413, -104.599998474121, -1.82561437095446, 218, 7, 'PPL', 'P'),
(190877, 'Viola (historical)', 37.2658309936523, 0.650411449330983, -114.384719848633, -1.99638997532995, 218, 39, 'PPL', 'P'),
(118216, 'Viola Center', 41.8058280944824, 0.729649346771465, -94.8019409179688, -1.65460600629969, 218, 16, 'PPL', 'P'),
(43503, 'Violet', 29.8955593109131, 0.521775941700681, -89.8977813720703, -1.56901227518065, 218, 22, 'PPL', 'P'),
(58084, 'Violet', 37.6674995422363, 0.657421888005481, -93.3194427490234, -1.62873153209681, 218, 29, 'PPL', 'P'),
(62178, 'Violet', 31.8205604553223, 0.55537354977528, -90.852783203125, -1.58568020149513, 218, 30, 'PPL', 'P'),
(69813, 'Violet', 35.1897201538086, 0.614176479539365, -84.2177810668945, -1.46987756834105, 218, 33, 'PPL', 'P'),
(98845, 'Violet', 27.7833309173584, 0.484910601679041, -97.5950012207031, -1.70335410478915, 218, 51, 'PPL', 'P'),
(111871, 'Violet', 38.1569404602051, 0.665964243518019, -80.142219543457, -1.39874560088947, 218, 58, 'PPL', 'P'),
(143285, 'Violet (historical)', 40.1324996948242, 0.700444256730302, -96.2544403076172, -1.67995690303226, 218, 35, 'PPL', 'P'),
(158121, 'Violet (historical)', 41.5180587768555, 0.724626824692658, -82.8077774047852, -1.44526836197207, 218, 41, 'PPL', 'P'),
(185962, 'Violet (historical)', 38.3841705322266, 0.669930156434338, -121.970832824707, -2.12879262419071, 218, 6, 'PPL', 'P'),
(12572, 'Violet Hill', 36.1536102294922, 0.630999534987341, -91.8413925170898, -1.6029346890397, 218, 4, 'PPL', 'P'),
(79326, 'Violet Hill', 39.9416694641113, 0.697113640892022, -76.7113876342773, -1.3388662879918, 218, 45, 'PPL', 'P'),
(168389, 'Violet Wood', 40.1380615234375, 0.700541328952035, -74.8499984741211, -1.30637891848614, 218, 45, 'PPL', 'P'),
(129156, 'Violette Settlement', 47.2194404602051, 0.824134706980005, -68.6497192382813, -1.1981636312777, 218, 26, 'PPL', 'P'),
(52430, 'Violetville', 39.2675018310547, 0.685347195984806, -76.6747207641602, -1.33822633038186, 218, 25, 'PPL', 'P'),
(38702, 'Viper', 37.1827812194824, 0.648961957328681, -83.1483306884766, -1.45121213805096, 218, 21, 'PPL', 'P'),
(107178, 'Vir-Mar Beach', 37.9291687011719, 0.66198887637983, -76.3061065673828, -1.3317927989785, 218, 53, 'PPL', 'P'),
(168390, 'Vira', 40.6513900756836, 0.709500602333226, -77.533332824707, -1.35321193783573, 218, 45, 'PPL', 'P'),
(28874, 'Virden', 39.5008316040039, 0.689419568765701, -89.7677764892578, -1.56674326193191, 218, 18, 'PPL', 'P'),
(38703, 'Virden', 37.8819389343262, 0.661164561443424, -83.9550018310547, -1.46529120546977, 218, 21, 'PPL', 'P'),
(189789, 'Virden', 32.686939239502, 0.57049471212864, -109.001388549805, -1.90243311943974, 218, 38, 'PPL', 'P'),
(193182, 'Virden', 48.5244407653809, 0.846911259044853, -111.906936645508, -1.95314450028481, 218, 31, 'PPL', 'P'),
(197767, 'Virgelle', 48.0152816772461, 0.83802475654045, -110.249717712402, -1.92422057347573, 218, 31, 'PPL', 'P'),
(38705, 'Virgie', 37.3349990844727, 0.651618660253116, -82.579719543457, -1.44128800140683, 218, 21, 'PPL', 'P'),
(123890, 'Virgie', 41.1152801513672, 0.71759701152123, -87.1800003051758, -1.52157804721498, 218, 19, 'PPL', 'P'),
(34285, 'Virgil', 37.9808311462402, 0.662890556145904, -96.0100021362305, -1.67569065212401, 218, 20, 'PPL', 'P'),
(77564, 'Virgil', 34.0697212219238, 0.594628810559157, -95.3822174072266, -1.66473374160915, 218, 42, 'PPL', 'P'),
(121822, 'Virgil', 41.9558296203613, 0.732267367281068, -88.5372161865234, -1.54526593300485, 218, 18, 'PPL', 'P'),
(153397, 'Virgil', 42.5105590820313, 0.741949222845024, -76.1947174072266, -1.32984869138274, 218, 40, 'PPL', 'P'),
(171516, 'Virgil', 44.290828704834, 0.773020789336169, -98.4238891601563, -1.71782092846268, 218, 49, 'PPL', 'P'),
(111872, 'Virgil (historical)', 38.6138916015625, 0.673939545455452, -81.3408279418945, -1.41966526388426, 218, 58, 'PPL', 'P'),
(121823, 'Virgil (historical)', 40.624439239502, 0.70903022150569, -90.3966674804688, -1.57771948036467, 218, 18, 'PPL', 'P'),
(58085, 'Virgil City', 37.7663917541504, 0.659147882707961, -94.0725021362305, -1.64187489786662, 218, 29, 'PPL', 'P'),
(133535, 'Virgil Location', 46.107780456543, 0.804732579753369, -88.6363906860352, -1.54699685455535, 218, 27, 'PPL', 'P'),
(194030, 'Virgilia', 40.0186080932617, 0.698456473292667, -121.104438781738, -2.11367119552124, 218, 6, 'PPL', 'P'),
(107179, 'Virgilina', 36.5433311462402, 0.637801448148485, -78.7752838134766, -1.37488807173816, 218, 53, 'PPL', 'P'),
(192844, 'Virgin', 37.2083282470703, 0.649407837074187, -113.1875, -1.97549454710108, 218, 52, 'PPL', 'P'),
(192846, 'Virgin Territory Trailer Park', 37.2077789306641, 0.649398249694263, -113.271110534668, -1.97695382622039, 218, 52, 'PPL', 'P'),
(6578, 'Virginia', 33.4088897705078, 0.583095125931214, -87.0505599975586, -1.51931888766226, 218, 2, 'PPL', 'P'),
(28876, 'Virginia', 39.9511108398438, 0.69727842398447, -90.2122192382813, -1.57450025123898, 218, 18, 'PPL', 'P'),
(38707, 'Virginia', 37.4638900756836, 0.653868232425906, -87.8916702270508, -1.53399903053911, 218, 21, 'PPL', 'P'),
(58087, 'Virginia', 38.2669410705566, 0.667884116347857, -94.4955596923828, -1.64925864514692, 218, 29, 'PPL', 'P'),
(138599, 'Virginia', 47.5233306884766, 0.82943859202798, -92.5363922119141, -1.61506472201474, 218, 28, 'PPL', 'P'),
(143286, 'Virginia', 40.2458305358887, 0.702422253050931, -96.4966735839844, -1.68418467126276, 218, 35, 'PPL', 'P'),
(177350, 'Virginia', 44.5305595397949, 0.777204881724792, -70.54638671875, -1.23126672362739, 218, 26, 'PPL', 'P'),
(195764, 'Virginia', 42.4941711425781, 0.741663199343949, -112.16471862793, -1.95764364463039, 218, 17, 'PPL', 'P'),
(202729, 'Virginia', 45.2425003051758, 0.789630592159857, -100.567497253418, -1.7552339475625, 218, 49, 'PPL', 'P'),
(209060, 'Virginia', 47.7075004577637, 0.832652960884678, -122.636108398438, -2.1404038733854, 218, 56, 'PPL', 'P'),
(202728, 'Virginia (historical)', 44.3263893127441, 0.773641439028212, -103.648612976074, -1.80900956155781, 218, 49, 'PPL', 'P'),
(107180, 'Virginia Beach', 36.8527793884277, 0.643202338839166, -75.9783325195313, -1.3260720626409, 218, 53, 'PPL', 'P'),
(107183, 'Virginia City', 36.9183311462402, 0.644346432843464, -82.3450012207031, -1.43719139386002, 218, 53, 'PPL', 'P'),
(189791, 'Virginia City', 36.579719543457, 0.638436545489442, -105.239440917969, -1.8367747469766, 218, 38, 'PPL', 'P'),
(190879, 'Virginia City', 39.3097190856934, 0.686084026079404, -119.648612976074, -2.08826224187691, 218, 39, 'PPL', 'P'),
(197768, 'Virginia City', 45.2938919067383, 0.790527544814995, -111.945281982422, -1.95381375266675, 218, 31, 'PPL', 'P'),
(209061, 'Virginia City (historical)', 48.0902786254883, 0.839333700216224, -119.779716491699, -2.0905504298855, 218, 56, 'PPL', 'P'),
(190880, 'Virginia City Highlands', 39.3808288574219, 0.687325125726408, -119.642776489258, -2.08816037596521, 218, 39, 'PPL', 'P'),
(185963, 'Virginia Colony', 34.2877807617188, 0.598434667493961, -118.857498168945, -2.07445468373123, 218, 6, 'PPL', 'P'),
(107184, 'Virginia Forest', 38.8833312988281, 0.678642155308314, -77.1897201538086, -1.34721476537698, 218, 53, 'PPL', 'P'),
(18460, 'Virginia Gardens', 25.8099994659424, 0.450469470618673, -80.3024978637695, -1.40154298529849, 218, 12, 'PPL', 'P'),
(107185, 'Virginia Gardens', 36.9124984741211, 0.644244633510796, -76.2861099243164, -1.33144379171764, 218, 53, 'PPL', 'P'),
(107189, 'Virginia Heights', 37.2666702270508, 0.650426096716979, -79.9847183227539, -1.39599668601229, 218, 53, 'PPL', 'P'),
(111873, 'Virginia Heights', 38.3858299255371, 0.669959118311192, -81.8516693115234, -1.42858112773968, 218, 58, 'PPL', 'P'),
(107190, 'Virginia Highlands', 38.8583297729492, 0.678205796363704, -77.0650024414063, -1.34503803066001, 218, 53, 'PPL', 'P'),
(98846, 'Virginia Hill', 32.128059387207, 0.560740418583034, -95.8166732788086, -1.67231642702288, 218, 51, 'PPL', 'P'),
(107192, 'Virginia Hills', 38.7786102294922, 0.676814427852193, -77.0997161865234, -1.345643899808, 218, 53, 'PPL', 'P'),
(111874, 'Virginia Manor', 39.6622200012207, 0.692236327671651, -79.966667175293, -1.39568163405534, 218, 58, 'PPL', 'P'),
(79325, 'Virginia Mills', 39.8027801513672, 0.694689565088804, -77.3763885498047, -1.35047274349653, 218, 45, 'PPL', 'P'),
(107195, 'Virginia Mineral Springs', 37.5275001525879, 0.654978437705333, -80.0663909912109, -1.39742214298576, 218, 53, 'PPL', 'P'),
(133534, 'Virginia Park', 42.7722206115723, 0.746516078061319, -86.1761093139648, -1.50405684408724, 218, 27, 'PPL', 'P'),
(98847, 'Virginia Point', 29.3052806854248, 0.511473636181763, -94.8974990844727, -1.65627381093235, 218, 51, 'PPL', 'P'),
(58088, 'Virginia Settlement', 37.1897201538086, 0.649083064579252, -90.6352767944336, -1.58188399851928, 218, 29, 'PPL', 'P'),
(6580, 'Virginia Shores', 34.7936096191406, 0.607263046507574, -87.5466690063477, -1.52797762331444, 218, 2, 'PPL', 'P'),
(206295, 'Virginia Square Condo', 40.6230583190918, 0.709006119897825, -111.826393127441, -1.95173875070341, 218, 52, 'PPL', 'P'),
(107197, 'Virginias Chesapeake Shores', 37.2277793884277, 0.649747323534145, -76.0102767944336, -1.32662959541511, 218, 53, 'PPL', 'P'),
(185964, 'Virginiatown', 38.9005584716797, 0.678942826195384, -121.213607788086, -2.11557655412314, 218, 6, 'PPL', 'P'),
(111875, 'Virginius (historical)', 39.3213882446289, 0.686287691323768, -77.7399978637695, -1.35681892321614, 218, 58, 'PPL', 'P'),
(168391, 'Virginville', 40.5238914489746, 0.707275331505383, -75.8733291625977, -1.32423940833676, 218, 45, 'PPL', 'P'),
(177290, 'Virginville', 40.292781829834, 0.703241707718349, -80.5238876342773, -1.40540696572409, 218, 58, 'PPL', 'P'),
(62179, 'Virlilia', 32.6261100769043, 0.56943304296008, -90.1313934326172, -1.57308957480956, 218, 30, 'PPL', 'P'),
(111876, 'Viropa', 39.4113883972168, 0.687858490313724, -80.2822189331055, -1.40118905118962, 218, 58, 'PPL', 'P'),
(176834, 'Viroqua', 43.5569381713867, 0.760211983178296, -90.8886108398438, -1.58630551171908, 218, 57, 'PPL', 'P'),
(107198, 'Virso', 37.0936088562012, 0.647405605987638, -78.4061126708984, -1.36844481979682, 218, 53, 'PPL', 'P'),
(168392, 'Virsoix', 40.4669418334961, 0.706281373207538, -80.3150024414063, -1.40176123134982, 218, 45, 'PPL', 'P'),
(52431, 'Virts', 39.3583297729492, 0.686932442623676, -77.5999984741211, -1.35437547291599, 218, 25, 'PPL', 'P'),
(107199, 'Virts Corner', 39.0863914489746, 0.682186223507964, -77.5880584716797, -1.35416708056069, 218, 53, 'PPL', 'P'),
(991, 'Virtue', 35.8563919067383, 0.625812096658031, -84.1786117553711, -1.46919393488923, 218, 50, 'PPL', 'P'),
(25758, 'Visage (historical)', 34.9300003051758, 0.609643513047942, -83.6672210693359, -1.46026848365388, 218, 13, 'PPL', 'P'),
(38706, 'Visalia', 38.9161109924316, 0.67921426888949, -84.4491729736328, -1.4739161189761, 218, 21, 'PPL', 'P'),
(185965, 'Visalia', 36.3302803039551, 0.634083009476462, -119.291107177734, -2.08202258860091, 218, 6, 'PPL', 'P'),
(153399, 'Vischer Ferry', 42.7972183227539, 0.746952370426901, -73.8288879394531, -1.28855717762939, 218, 40, 'PPL', 'P'),
(107200, 'Viscose City', 38.9161109924316, 0.67921426888949, -78.2055587768555, -1.36494449401808, 218, 53, 'PPL', 'P'),
(12574, 'Vise Addition', 34.9786109924316, 0.610491929592213, -91.991943359375, -1.60556229692923, 218, 4, 'PPL', 'P'),
(91589, 'Vise Landing', 35.5077781677246, 0.619727639094554, -87.9775009155273, -1.53549705865228, 218, 50, 'PPL', 'P'),
(209062, 'Vision Acres', 46.0875015258789, 0.804378645644498, -122.866111755371, -2.14441818925454, 218, 56, 'PPL', 'P'),
(18458, 'Vista', 29.3766708374023, 0.512719629387271, -83.0483322143555, -1.44946683543058, 218, 12, 'PPL', 'P'),
(58090, 'Vista', 37.9883308410645, 0.663021450513481, -93.6638870239258, -1.6347432187835, 218, 29, 'PPL', 'P'),
(98848, 'Vista', 31.5247192382813, 0.550210146474807, -98.2119369506836, -1.71412166455051, 218, 51, 'PPL', 'P'),
(118221, 'Vista', 42.413330078125, 0.740252256598425, -91.9869384765625, -1.60547494524547, 218, 16, 'PPL', 'P'),
(138601, 'Vista', 43.957218170166, 0.767198187086874, -93.4663925170898, -1.63129628938461, 218, 28, 'PPL', 'P'),
(153400, 'Vista', 41.202220916748, 0.71911441413133, -73.5105590820313, -1.28300129096327, 218, 40, 'PPL', 'P'),
(168393, 'Vista', 40.2783317565918, 0.702989506363118, -79.7955627441406, -1.39269529836698, 218, 45, 'PPL', 'P'),
(185966, 'Vista', 33.2000007629395, 0.579449324977923, -117.241668701172, -2.04625313936783, 218, 6, 'PPL', 'P'),
(189792, 'Vista', 31.9652805328369, 0.557899391621652, -108.438331604004, -1.89260592185929, 218, 38, 'PPL', 'P'),
(190882, 'Vista', 39.5263900756836, 0.689865648248289, -119.699722290039, -2.08915426768403, 218, 39, 'PPL', 'P'),
(192845, 'Vista', 38.9638900756836, 0.680048171205821, -109.676666259766, -1.91421893884388, 218, 52, 'PPL', 'P'),
(197770, 'Vista', 46.7872200012207, 0.816591036876247, -111.615280151367, -1.94805413417723, 218, 31, 'PPL', 'P'),
(209063, 'Vista', 46.2127799987793, 0.80656516747848, -119.208892822266, -2.08058767740557, 218, 56, 'PPL', 'P'),
(107202, 'Vista Acres', 37.3477783203125, 0.651841699994411, -79.192497253418, -1.38216981994871, 218, 53, 'PPL', 'P'),
(179463, 'Vista Alegre', 33.3736114501953, 0.582479403087188, -111.83805847168, -1.95194234936875, 218, 5, 'PPL', 'P'),
(457, 'Vista Brook', 34.2249984741211, 0.597338909863448, -83.8902816772461, -1.46416162569342, 218, 13, 'PPL', 'P'),
(146532, 'Vista Center', 40.1591682434082, 0.700909710709821, -74.3183288574219, -1.29709953314193, 218, 37, 'PPL', 'P'),
(189794, 'Vista de Oro de Placitas', 35.3022193908691, 0.616139961632054, -106.470832824707, -1.85826659013159, 218, 38, 'PPL', 'P'),
(179465, 'Vista del Cerro', 33.5719413757324, 0.585940913293046, -111.997222900391, -1.95472029270181, 218, 5, 'PPL', 'P'),
(185975, 'Vista del Mar', 33.8188896179199, 0.59025097320123, -118.197776794434, -2.06294037360022, 218, 6, 'PPL', 'P'),
(179464, 'Vista Encantada', 36.2305603027344, 0.632342567125068, -111.972778320313, -1.95429365429518, 218, 5, 'PPL', 'P'),
(189793, 'Vista Encantada', 35.1108283996582, 0.612799558676767, -106.567497253418, -1.85995370268216, 218, 38, 'PPL', 'P'),
(107203, 'Vista Estates', 39.1344413757324, 0.68302485293523, -77.9266662597656, -1.36007690133569, 218, 53, 'PPL', 'P'),
(118222, 'Vista Estates Mobile Home Park', 42.649169921875, 0.744368438379251, -95.209716796875, -1.66172303799682, 218, 16, 'PPL', 'P'),
(52432, 'Vista Farms', 39.5069389343262, 0.689526161788331, -77.5366668701172, -1.35327012790555, 218, 25, 'PPL', 'P'),
(107204, 'Vista Heights', 37.327220916748, 0.65148290561655, -79.9402770996094, -1.39522104034481, 218, 53, 'PPL', 'P'),
(192384, 'Vista Larga Colonia', 31.6089992523193, 0.551681110213398, -106.184997558594, -1.8532778236196, 218, 51, 'PPL', 'P'),
(192385, 'Vista Larga Number 2 Colonia', 31.6040000915527, 0.551593858398185, -106.18399810791, -1.85326037991446, 218, 51, 'PPL', 'P'),
(206296, 'Vista Plat', 40.5849990844727, 0.708341860942932, -111.977783203125, -1.95438100597893, 218, 52, 'PPL', 'P'),
(52433, 'Vista Raceway', 38.9558296203613, 0.679907489721238, -76.8272171020508, -1.34088789357528, 218, 25, 'PPL', 'P'),
(185970, 'Vista Robles', 39.4208297729492, 0.688023273406173, -121.551391601563, -2.12147199382825, 218, 6, 'PPL', 'P'),
(185971, 'Vista Santa Rosa', 33.6277809143066, 0.58691549709396, -116.217216491699, -2.0283730752832, 218, 6, 'PPL', 'P'),
(12575, 'Vista Shores', 36.4236106872559, 0.635711931957209, -93.904167175293, -1.63893689855205, 218, 4, 'PPL', 'P'),
(25759, 'Vista Terrace', 32.4658317565918, 0.566635658551061, -84.8983306884766, -1.48175539996086, 218, 13, 'PPL', 'P'),
(206297, 'Vista Ventes', 40.624439239502, 0.70903022150569, -111.844169616699, -1.95204900897041, 218, 52, 'PPL', 'P'),
(185972, 'Vista Verde', 37.3369407653809, 0.651652548977988, -122.193061828613, -2.13267125200231, 218, 6, 'PPL', 'P'),
(138602, 'Vista Village Mobile Home Park', 43.7402801513672, 0.763411904386081, -92.8691711425781, -1.62087281003609, 218, 28, 'PPL', 'P'),
(209811, 'Vista West Trailer Park', 44.4197196960449, 0.775270361508959, -104.404716491699, -1.82220605739137, 218, 59, 'PPL', 'P'),
(138603, 'Vista-Villa Mobilehome Community', 44.0825004577637, 0.769384775499884, -93.5305633544922, -1.63241628178104, 218, 28, 'PPL', 'P'),
(201732, 'Vistillas (historical)', 42.1666717529297, 0.735947256696312, -120.747222900391, -2.10743660225131, 218, 43, 'PPL', 'P'),
(98849, 'Vistula', 31.1044406890869, 0.542874902015861, -95.6366729736328, -1.66917482904297, 218, 51, 'PPL', 'P'),
(123911, 'Vistula', 41.7491683959961, 0.728660448479692, -85.7280578613281, -1.49623687102038, 218, 19, 'PPL', 'P'),
(98850, 'Viterbo', 29.9555606842041, 0.522823163220327, -94.0427780151367, -1.64135611408627, 218, 51, 'PPL', 'P'),
(18459, 'Vitis', 28.2808303833008, 0.493593605386649, -82.144172668457, -1.43368627439131, 218, 12, 'PPL', 'P'),
(43504, 'Viva', 30.7350006103516, 0.536426956253102, -91.6402816772461, -1.59942464272298, 218, 22, 'PPL', 'P'),
(31403, 'Vivalia', 39.6775016784668, 0.692503043254822, -87.0122222900391, -1.51864976843838, 218, 19, 'PPL', 'P'),
(43505, 'Vivian', 32.8713912963867, 0.573714007833355, -93.9872207641602, -1.64038645713338, 218, 22, 'PPL', 'P'),
(77565, 'Vivian', 35.2897186279297, 0.615921782159749, -95.7161102294922, -1.67056127070646, 218, 42, 'PPL', 'P'),
(98852, 'Vivian', 34.0663909912109, 0.594570687068366, -99.9727783203125, -1.74485414405586, 218, 51, 'PPL', 'P'),
(111877, 'Vivian', 37.4180603027344, 0.653068351992501, -81.4875030517578, -1.4222252274821, 218, 58, 'PPL', 'P'),
(200265, 'Vivian', 40.7249984741211, 0.71078531124308, -116.055557250977, -2.02555158926632, 218, 39, 'PPL', 'P'),
(202730, 'Vivian', 43.9269409179688, 0.766669749347575, -100.29167175293, -1.75041988441802, 218, 49, 'PPL', 'P'),
(206300, 'Vivian Park', 40.3549995422363, 0.704327611652828, -111.573333740234, -1.94732203119357, 218, 52, 'PPL', 'P'),
(112289, 'Viviani', 31.2538890838623, 0.545483268566511, -82.5347213745117, -1.44050263520137, 218, 13, 'PPL', 'P'),
(197772, 'Vivs Trailer Court', 48.7713890075684, 0.851221318953038, -104.567497253418, -1.82504711764227, 218, 31, 'PPL', 'P'),
(43506, 'Vixen', 32.2341690063477, 0.562592380805076, -92.2686080932617, -1.6103910074597, 218, 22, 'PPL', 'P'),
(138605, 'Vlasaty', 43.9647216796875, 0.767329148033479, -92.8488922119141, -1.62051887592722, 218, 28, 'PPL', 'P'),
(34286, 'Vliets', 39.7138900756836, 0.693138140595779, -96.3333282470703, -1.68133375731583, 218, 20, 'PPL', 'P'),
(146533, 'Vliettown', 40.6822204589844, 0.710038694031476, -74.7172164916992, -1.30406143570556, 218, 37, 'PPL', 'P'),
(153401, 'Voak', 42.7313919067383, 0.745803482732641, -77.1333312988281, -1.34623059419615, 218, 40, 'PPL', 'P'),
(98853, 'Voca', 31.0108299255371, 0.541241085976611, -99.1841735839844, -1.73109039491011, 218, 51, 'PPL', 'P'),
(209812, 'Vocation', 44.663330078125, 0.779522164768298, -108.942779541016, -1.90141019926504, 218, 59, 'PPL', 'P'),
(187943, 'Voda', 39.0491714477539, 0.681536611939067, -100.019439697266, -1.74566853871721, 218, 20, 'PPL', 'P'),
(197771, 'Voegeles Trailer Court', 45.7761116027832, 0.798943866228946, -111.176109313965, -1.94038915708582, 218, 31, 'PPL', 'P'),
(168394, 'Vogansville', 40.1238899230957, 0.700293987865794, -76.1302795410156, -1.3287240384544, 218, 45, 'PPL', 'P'),
(12576, 'Vogel (historical)', 36.2249984741211, 0.632245494903335, -94.1374969482422, -1.64300927133294, 218, 4, 'PPL', 'P'),
(91591, 'Vogel (historical)', 36.4900016784668, 0.636870673347503, -82.9391708374023, -1.44756160998673, 218, 50, 'PPL', 'P'),
(133536, 'Vogel Center', 44.1925010681152, 0.771304648329722, -85.0524978637695, -1.48444612476822, 218, 27, 'PPL', 'P'),
(189795, 'Voght Place', 35.6066703796387, 0.621453633797034, -107.716110229492, -1.88000078094578, 218, 38, 'PPL', 'P'),
(168395, 'Vogleyville', 40.8491706848145, 0.712952525159159, -79.8613891601563, -1.39384418606124, 218, 45, 'PPL', 'P'),
(200266, 'Voight (historical)', 40.7627792358398, 0.711444709928983, -115.436393737793, -2.01474514735305, 218, 39, 'PPL', 'P'),
(168396, 'Volant', 41.1136093139648, 0.717567849907294, -80.2591705322266, -1.40078678070696, 218, 45, 'PPL', 'P'),
(6582, 'Volanta', 30.5336093902588, 0.532912016377874, -87.9016723632813, -1.53417360074856, 218, 2, 'PPL', 'P'),
(197773, 'Volborg', 45.8427810668945, 0.800107467888228, -105.680557250977, -1.84447367937191, 218, 31, 'PPL', 'P'),
(62180, 'Volcan (historical)', 32.2619400024414, 0.56307707612347, -89.195556640625, -1.556756141528, 218, 30, 'PPL', 'P'),
(185976, 'Volcano', 38.4430618286133, 0.670958003457054, -120.629722595215, -2.1053858350539, 218, 6, 'PPL', 'P'),
(211138, 'Volcano', 19.4308300018311, 0.339131959927248, -155.237777709961, -2.70941034451788, 218, 15, 'PPL', 'P'),
(190883, 'Volcano (historical)', 38.1197204589844, 0.665314631949121, -116.907501220703, -2.04042081658056, 218, 39, 'PPL', 'P'),
(185977, 'Volcanoville', 38.9819412231445, 0.680363223162778, -120.788063049316, -2.10814939731707, 218, 6, 'PPL', 'P'),
(197774, 'Volcour (historical)', 48.5486106872559, 0.847333103761522, -115.216667175293, -2.01091019538334, 218, 31, 'PPL', 'P'),
(107206, 'Volens', 36.935001373291, 0.644637383192555, -79.0124969482422, -1.3790282219688, 218, 53, 'PPL', 'P'),
(98854, 'Volente', 30.4336109161377, 0.531166713757491, -97.9033279418945, -1.70873542124582, 218, 51, 'PPL', 'P'),
(31401, 'Volga', 38.7838897705078, 0.676906573225909, -85.5180587768555, -1.49257169557016, 218, 19, 'PPL', 'P'),
(38708, 'Volga', 37.8713912963867, 0.660980470433072, -82.8733291625977, -1.44641245597636, 218, 21, 'PPL', 'P'),
(111878, 'Volga', 39.0783309936523, 0.682045542023381, -80.1355590820313, -1.39862935390789, 218, 58, 'PPL', 'P'),
(118223, 'Volga', 42.8047218322754, 0.747083331373506, -91.5408325195313, -1.59768892748252, 218, 16, 'PPL', 'P'),
(171520, 'Volga', 44.3236083984375, 0.773592902917345, -96.9261093139648, -1.69167973867663, 218, 49, 'PPL', 'P'),
(171523, 'Volin', 42.957218170166, 0.749744894566931, -97.1800003051758, -1.69611097241441, 218, 49, 'PPL', 'P'),
(133537, 'Volinia', 42.0116691589355, 0.733241951081982, -85.954719543457, -1.50019286366164, 218, 27, 'PPL', 'P'),
(34287, 'Volland', 38.9444389343262, 0.679708684745863, -96.404167175293, -1.6825701298519, 218, 20, 'PPL', 'P'),
(153402, 'Vollentine', 42.1047210693359, 0.73486601329374, -79.0088882446289, -1.37896523820902, 218, 40, 'PPL', 'P'),
(194461, 'Vollmar', 40.1349983215332, 0.700487865993152, -104.838333129883, -1.82977409541911, 218, 7, 'PPL', 'P'),
(31402, 'Vollmer', 38.5475006103516, 0.672780804065159, -87.5199966430664, -1.52751210275589, 218, 19, 'PPL', 'P'),
(195765, 'Vollmer', 46.2427787780762, 0.807088744948789, -116.465278625488, -2.03270257626735, 218, 17, 'PPL', 'P'),
(194033, 'Vollmers', 40.9430618286133, 0.714591234756912, -122.438888549805, -2.13696173767648, 218, 6, 'PPL', 'P'),
(197775, 'Volmer', 48.5366706848145, 0.847124711406223, -104.149436950684, -1.81775058888767, 218, 31, 'PPL', 'P'),
(107207, 'Volney', 36.625, 0.639226838542923, -81.3883285522461, -1.4204943059316, 218, 53, 'PPL', 'P'),
(118225, 'Volney', 43.1305618286133, 0.752770312144288, -91.3736114501953, -1.5947703692439, 218, 16, 'PPL', 'P'),
(133539, 'Volney', 43.6994400024414, 0.762699109320321, -86.0197219848633, -1.50132737028602, 218, 27, 'PPL', 'P'),
(153403, 'Volney', 43.3427810668945, 0.75647423658837, -76.3580627441406, -1.33269960532967, 218, 40, 'PPL', 'P'),
(121825, 'Volo', 42.3261108398438, 0.738729993719336, -88.1677780151367, -1.53881802053161, 218, 18, 'PPL', 'P'),
(185978, 'Volponi Acres', 37.9652786254883, 0.662619113451798, -120.401390075684, -2.1014006807987, 218, 6, 'PPL', 'P'),
(197776, 'Volt', 48.3883285522461, 0.844535652773475, -105.718330383301, -1.84513294489976, 218, 31, 'PPL', 'P'),
(185979, 'Volta', 37.0974998474121, 0.647473516595435, -120.925003051758, -2.11053945123737, 218, 6, 'PPL', 'P'),
(201733, 'Voltage', 43.2613906860352, 0.755053706462922, -118.806106567383, -2.07355773107609, 218, 43, 'PPL', 'P'),
(209064, 'Voltage', 47.348331451416, 0.826384279152795, -120.095283508301, -2.0960581133359, 218, 56, 'PPL', 'P'),
(199047, 'Voltaire', 48.0205612182617, 0.838116901914166, -100.841110229492, -1.76000939487117, 218, 34, 'PPL', 'P'),
(69815, 'Volunteer', 36.3677787780762, 0.634737481314349, -80.4199981689453, -1.40359375249591, 218, 33, 'PPL', 'P'),
(202732, 'Volunteer', 44.5119400024414, 0.776879909492775, -103.132499694824, -1.80000168548673, 218, 49, 'PPL', 'P'),
(158123, 'Volunteer Bay', 41.398609161377, 0.722542035612316, -82.420280456543, -1.43850526438381, 218, 41, 'PPL', 'P'),
(91593, 'Volunteer Heights', 35.9330596923828, 0.627150201947741, -85.0391693115234, -1.484213497647, 218, 50, 'PPL', 'P'),
(168398, 'Volunteertown', 40.0441703796387, 0.698902619354283, -75.0883331298828, -1.31053864295079, 218, 45, 'PPL', 'P'),
(114209, 'Voluntown', 41.5705604553223, 0.725543151844727, -71.8708267211914, -1.25438256241511, 218, 8, 'PPL', 'P'),
(18461, 'Volusia', 29.1683292388916, 0.50908338252439, -81.521110534668, -1.42281178871219, 218, 12, 'PPL', 'P'),
(153405, 'Volusia', 42.2511100769043, 0.737420983464535, -79.5994415283203, -1.3892723374179, 218, 40, 'PPL', 'P'),
(121826, 'Von Glen Acres', 42.1150016784668, 0.735045443772184, -89.2191696166992, -1.55716826570669, 218, 18, 'PPL', 'P'),
(98855, 'Von Ormy', 29.288890838623, 0.511187579391175, -98.644172668457, -1.72166560097038, 218, 51, 'PPL', 'P'),
(187504, 'Vona', 39.3036117553711, 0.685977433056774, -102.742500305176, -1.7931949120566, 218, 7, 'PPL', 'P'),
(91594, 'Vonore', 35.5900001525879, 0.621162683447943, -84.241943359375, -1.47029927989967, 218, 50, 'PPL', 'P'),
(25761, 'Vonreg Subdivision', 32.7277793884277, 0.5712075071944, -83.7077789306641, -1.46097635187163, 218, 13, 'PPL', 'P'),
(107208, 'Vontay', 37.7574996948242, 0.658992686995437, -77.7505569458008, -1.35700321396357, 218, 53, 'PPL', 'P'),
(146534, 'Voorhees', 40.4811096191406, 0.706528647714752, -74.4836120605469, -1.2999842692347, 218, 37, 'PPL', 'P'),
(146535, 'Voorhees Corner', 40.502498626709, 0.706901956320554, -74.8091735839844, -1.30566638973649, 218, 37, 'PPL', 'P'),
(153406, 'Voorheesville', 42.6538887023926, 0.744450796635962, -73.9291687011719, -1.29030740709779, 218, 40, 'PPL', 'P'),
(74668, 'Voorheis (historical)', 39.6352806091309, 0.691766146581197, -82.9466705322266, -1.44769250435431, 218, 41, 'PPL', 'P'),
(28878, 'Voorhies', 39.8669395446777, 0.695809357748155, -88.5800018310547, -1.54601268337451, 218, 18, 'PPL', 'P'),
(43507, 'Voorhies', 31.076940536499, 0.542394933808401, -91.9313888549805, -1.60450542145063, 218, 22, 'PPL', 'P'),
(91595, 'Voorhies', 35.4491691589355, 0.618704718919854, -87.5611114501953, -1.52822969151162, 218, 50, 'PPL', 'P'),
(118226, 'Voorhies', 42.3358306884766, 0.738899637080774, -92.4824981689453, -1.61412409351772, 218, 16, 'PPL', 'P'),
(179466, 'Vopolo Havoka', 31.7591705322266, 0.554302093489713, -111.923606872559, -1.9534354506339, 218, 5, 'PPL', 'P'),
(185980, 'Vorden', 38.2772216796875, 0.668063546826301, -121.540000915527, -2.12127318885287, 218, 6, 'PPL', 'P'),
(153409, 'Vorea', 43.600830078125, 0.760978041465858, -75.9725036621094, -1.32597032988726, 218, 40, 'PPL', 'P'),
(143287, 'Vorhees', 41.6483306884766, 0.726900498473313, -97.8888931274414, -1.7084834862067, 218, 35, 'PPL', 'P'),
(74669, 'Vorhies (historical)', 39.7958297729492, 0.694568258101151, -81.4661102294922, -1.42185185229727, 218, 41, 'PPL', 'P'),
(153407, 'Vorman Corners', 42.5052795410156, 0.741857077471307, -74.5519409179688, -1.30117683277084, 218, 40, 'PPL', 'P'),
(38709, 'Vortex', 37.6972198486328, 0.657940605206801, -83.5272216796875, -1.45782503335374, 218, 21, 'PPL', 'P'),
(43508, 'Vortex (historical)', 31.0894393920898, 0.542613079991192, -92.5149993896484, -1.61469134682991, 218, 22, 'PPL', 'P'),
(153408, 'Vosburg', 42.0713882446289, 0.734284245753612, -78.0813903808594, -1.36277734668103, 218, 40, 'PPL', 'P'),
(168399, 'Vosburg', 41.5611114501953, 0.725378235594224, -76.0047225952148, -1.32653265635143, 218, 45, 'PPL', 'P'),
(195766, 'Vosburg Place', 42.1911087036133, 0.736373761944888, -114.816673278809, -2.0039289849018, 218, 17, 'PPL', 'P'),
(91596, 'Vose', 35.7919387817383, 0.624687177413581, -83.9641723632813, -1.46545126145129, 218, 50, 'PPL', 'P'),
(126409, 'Vose', 42.6124992370605, 0.743728414190278, -71.6333312988281, -1.25023748533646, 218, 23, 'PPL', 'P'),
(14786, 'Voshell Cove', 39.1688919067383, 0.683626128130343, -75.6050033569336, -1.31955623955986, 218, 10, 'PPL', 'P'),
(14787, 'Voshell Mill', 39.0980606079102, 0.682389888752328, -75.5288925170898, -1.31822785480813, 218, 10, 'PPL', 'P'),
(52434, 'Voshelle', 39.5763893127441, 0.690738299558481, -76.3566665649414, -1.3326752374057, 218, 25, 'PPL', 'P'),
(98856, 'Voss', 31.6208305358887, 0.55188760506642, -99.561393737793, -1.73767412859895, 218, 51, 'PPL', 'P'),
(141019, 'Voss', 48.2963905334473, 0.842931031637675, -97.4550018310547, -1.70091065448901, 218, 34, 'PPL', 'P'),
(185981, 'Voss', 38.6572189331055, 0.67469575004698, -120.386672973633, -2.10114381891157, 218, 6, 'PPL', 'P'),
(209065, 'Voss Resort', 46.9738883972168, 0.819849014995795, -122.232498168945, -2.13335954598604, 218, 56, 'PPL', 'P'),
(62181, 'Vossburg', 31.9286098480225, 0.557259367432678, -88.9408264160156, -1.55231026040422, 218, 30, 'PPL', 'P'),
(98857, 'Votaw', 30.4352798461914, 0.531195842081913, -94.6730575561523, -1.65235656728495, 218, 51, 'PPL', 'P'),
(107209, 'Vote', 36.9327812194824, 0.644598634198695, -77.9402770996094, -1.36031445530492, 218, 53, 'PPL', 'P'),
(98858, 'Voth', 30.1749992370605, 0.526653088473483, -94.2016677856445, -1.64412926372937, 218, 51, 'PPL', 'P'),
(62182, 'Vowell', 32.982780456543, 0.575658115429113, -89.307502746582, -1.55870996966174, 218, 30, 'PPL', 'P'),
(43509, 'Vowells Mill', 31.5672206878662, 0.550951936706935, -93.2838897705078, -1.62811101556282, 218, 22, 'PPL', 'P'),
(168400, 'Vowinckel', 41.4113883972168, 0.72276507535361, -79.228889465332, -1.38280498386869, 218, 45, 'PPL', 'P'),
(38710, 'Vox', 36.9863891601563, 0.645534269268667, -84.1991729736328, -1.46955279584612, 218, 21, 'PPL', 'P'),
(69821, 'Vox', 36.5530586242676, 0.637971224667978, -81.0561065673828, -1.41469593844823, 218, 33, 'PPL', 'P'),
(139506, 'Voyage (historical)', 40.2783317565918, 0.702989506363118, -94.445556640625, -1.6483859272577, 218, 29, 'PPL', 'P'),
(6584, 'Vredenburgh', 31.8283290863037, 0.555509137964278, -87.3216705322266, -1.52405065912906, 218, 2, 'PPL', 'P'),
(133540, 'Vriesland', 42.811939239502, 0.747209298893066, -85.9402770996094, -1.49994079546447, 218, 27, 'PPL', 'P'),
(187505, 'Vroman', 38.0897216796875, 0.664791054478812, -103.809722900391, -1.81182146019477, 218, 7, 'PPL', 'P'),
(199754, 'Vroman', 40.9669418334961, 0.715008019467509, -100.256942749023, -1.74981374895391, 218, 35, 'PPL', 'P'),
(168401, 'Vroman Hill', 41.7413902282715, 0.728524693843125, -76.6619415283203, -1.33800329064056, 218, 45, 'PPL', 'P'),
(168402, 'Vrooman', 41.725830078125, 0.728253117990964, -79.6497192382813, -1.39014984899708, 218, 45, 'PPL', 'P'),
(62183, 'Vrue (historical)', 31.9950008392334, 0.558418108822972, -89.1680603027344, -1.55627623989957, 218, 30, 'PPL', 'P'),
(98859, 'Vsetin', 29.4940490722656, 0.514768266055814, -96.8495101928711, -1.69034283180941, 218, 51, 'PPL', 'P'),
(169645, 'Vue de l''eau', 41.7877807617188, 0.729334361393536, -71.3697204589844, -1.24563660823724, 218, 47, 'PPL', 'P'),
(153411, 'Vukote', 42.1061096191406, 0.73489024805966, -79.3600006103516, -1.38509330503534, 218, 40, 'PPL', 'P'),
(6585, 'Vulcan', 33.6955604553223, 0.588098473250173, -86.9736099243164, -1.51797585552454, 218, 2, 'PPL', 'P'),
(28879, 'Vulcan', 38.5288887023926, 0.672455964991196, -90.2422180175781, -1.57502382870929, 218, 18, 'PPL', 'P'),
(58093, 'Vulcan', 37.309440612793, 0.651172580770528, -90.6624984741211, -1.58235910645775, 218, 29, 'PPL', 'P'),
(91597, 'Vulcan', 35.0066719055176, 0.610981684916679, -85.5299987792969, -1.49278008792546, 218, 50, 'PPL', 'P'),
(107210, 'Vulcan', 38.2147216796875, 0.666972716043805, -77.9227828979492, -1.36000912388594, 218, 53, 'PPL', 'P'),
(111879, 'Vulcan', 37.5522193908691, 0.655409869801926, -82.126106262207, -1.43337095611825, 218, 58, 'PPL', 'P'),
(133541, 'Vulcan', 45.7805595397949, 0.799021497374721, -87.8625030517578, -1.53348996729674, 218, 27, 'PPL', 'P'),
(158125, 'Vulcan', 41.6508293151855, 0.726944107736163, -83.6094436645508, -1.45926007770712, 218, 41, 'PPL', 'P'),
(168403, 'Vulcan', 40.8105583190918, 0.712278612245315, -76.1091690063477, -1.32835559011759, 218, 45, 'PPL', 'P'),
(118227, 'Vulcan (historical)', 41.420280456543, 0.722920271066135, -92.3697204589844, -1.61215575115605, 218, 16, 'PPL', 'P'),
(187506, 'Vulcan (historical)', 38.3455581665039, 0.669256243520493, -107.000831604004, -1.86751681386187, 218, 7, 'PPL', 'P'),
(6586, 'Vulcan City', 33.5583305358887, 0.58570335932381, -86.7966690063477, -1.51488765392448, 218, 2, 'PPL', 'P'),
(69816, 'Vultare', 36.5169410705566, 0.637340854437956, -77.7652816772461, -1.35726020900876, 218, 33, 'PPL', 'P'),
(200267, 'Vya', 41.5922203063965, 0.725921187561463, -119.859443664551, -2.09194193155507, 218, 39, 'PPL', 'P'),
(58091, 'W B Junction', 39.3349990844727, 0.686525245293003, -93.5299987792969, -1.63240642808501, 218, 29, 'PPL', 'P'),
(98860, 'W J Ranch Colonia', 28.0009994506836, 0.488709634263552, -97.5550003051758, -1.70265595710939, 218, 51, 'PPL', 'P'),
(91598, 'Wa-Ni Village', 36.2227783203125, 0.632206745909474, -83.4544372558594, -1.45655470551377, 218, 50, 'PPL', 'P'),
(123891, 'Wa-Will-Away Park', 41.2900009155273, 0.720646464127425, -85.7780609130859, -1.4971095889096, 218, 19, 'PPL', 'P'),
(209066, 'Waatch', 48.3469390869141, 0.843813270327791, -124.667221069336, -2.17585347697156, 218, 56, 'PPL', 'P'),
(126410, 'Waban', 42.3277816772461, 0.738759155333272, -71.227783203125, -1.24315933579124, 218, 23, 'PPL', 'P'),
(133542, 'Wabaningo', 43.3705596923828, 0.756959065064819, -86.4216690063477, -1.5083426692295, 218, 27, 'PPL', 'P'),
(79327, 'Wabank', 39.9983291625977, 0.698102539183796, -76.3302764892578, -1.33221464369517, 218, 45, 'PPL', 'P'),
(12577, 'Wabash', 34.3886108398438, 0.600194484342286, -90.82861328125, -1.58525835677846, 218, 4, 'PPL', 'P'),
(38711, 'Wabash', 37.4063911437988, 0.652864686748137, -85.8494415283203, -1.49835541566754, 218, 21, 'PPL', 'P'),
(123892, 'Wabash', 40.797779083252, 0.71205557250402, -85.820556640625, -1.49785127927319, 218, 19, 'PPL', 'P'),
(143289, 'Wabash', 40.8863906860352, 0.713602136728057, -96.2541732788086, -1.67995224250036, 218, 35, 'PPL', 'P'),
(158126, 'Wabash', 40.5455589294434, 0.707653500380174, -84.75, -1.47916654106519, 218, 41, 'PPL', 'P'),
(209069, 'Wabash', 47.2430610656738, 0.824546964316749, -122.05638885498, -2.13028585861392, 218, 56, 'PPL', 'P'),
(107211, 'Wabash (historical)', 37.228328704834, 0.649756910914069, -80.7399978637695, -1.40917880077597, 218, 53, 'PPL', 'P'),
(111880, 'Wabash (historical)', 39.3277816772461, 0.686399277773442, -79.1819381713867, -1.38198552920128, 218, 58, 'PPL', 'P'),
(58092, 'Wabash Crossing', 39.9283294677734, 0.696880814033722, -93.9377822875977, -1.63952359294019, 218, 29, 'PPL', 'P'),
(28882, 'Wabash Point', 39.4422187805176, 0.688396582011974, -88.4208297729492, -1.54323460688339, 218, 18, 'PPL', 'P'),
(123894, 'Wabash Shores', 40.4491691589355, 0.705971181519571, -86.9108276367188, -1.51688009789402, 218, 19, 'PPL', 'P'),
(179467, 'Wabash Trailer Court', 33.5702781677246, 0.585911884837164, -112.064170837402, -1.95588875463008, 218, 5, 'PPL', 'P'),
(138608, 'Wabasha', 44.3838882446289, 0.774644984705981, -92.0327835083008, -1.60627509199499, 218, 28, 'PPL', 'P'),
(18463, 'Wabasso', 27.7480602264404, 0.484295011993069, -80.436393737793, -1.40387990915504, 218, 12, 'PPL', 'P'),
(138611, 'Wabasso', 44.4019393920898, 0.774960036662937, -95.2555618286133, -1.66252318474633, 218, 28, 'PPL', 'P'),
(18464, 'Wabasso Beach', 27.764440536499, 0.484580902336089, -80.399169921875, -1.40323023100711, 218, 12, 'PPL', 'P'),
(34290, 'Wabaunsee', 39.146110534668, 0.683228518179594, -96.345832824707, -1.68155200336717, 218, 20, 'PPL', 'P'),
(12578, 'Wabbaseka', 34.3608283996582, 0.59970958928681, -91.7958297729492, -1.6021394691382, 218, 4, 'PPL', 'P'),
(12579, 'Wabbel', 34.6355590820313, 0.60450454425047, -92.0175018310547, -1.60600837641182, 218, 4, 'PPL', 'P'),
(38712, 'Wabd', 37.3133316040039, 0.651240491378325, -84.3897171020508, -1.47287841825735, 218, 21, 'PPL', 'P'),
(138613, 'Wabedo', 46.9205589294434, 0.818918240194812, -94.1877822875977, -1.64388691607018, 218, 28, 'PPL', 'P'),
(199049, 'Wabek', 47.9719390869141, 0.837268285632813, -101.956108093262, -1.77946977874665, 218, 34, 'PPL', 'P'),
(176837, 'Wabeno', 45.4386100769043, 0.793053353371854, -88.6602783203125, -1.547413772424, 218, 57, 'PPL', 'P'),
(107212, 'Wabun', 37.2488899230957, 0.650115771870957, -80.1416702270508, -1.39873601350955, 218, 53, 'PPL', 'P'),
(190885, 'Wabuska', 39.1438903808594, 0.683189769185733, -119.182220458984, -2.08012215684703, 218, 39, 'PPL', 'P'),
(18465, 'Wacahoota', 29.5563907623291, 0.51585633380868, -82.39111328125, -1.43799620114144, 218, 12, 'PPL', 'P'),
(153410, 'Waccabuc', 41.2905616760254, 0.720656251244431, -73.595832824707, -1.28448959853846, 218, 40, 'PPL', 'P'),
(107213, 'Wachapreague', 37.6041717529297, 0.656316609574071, -75.6900024414063, -1.32103975344509, 218, 53, 'PPL', 'P'),
(84168, 'Wachesaw Landing', 33.5605583190918, 0.585742241475726, -79.0849990844727, -1.38029362296075, 218, 48, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(18468, 'Wachitokha (historical)', 29.9500007629395, 0.522726124288107, -82.9000015258789, -1.44687797653491, 218, 12, 'PPL', 'P'),
(84170, 'Wachovia Hills', 34.2986106872559, 0.59862368535233, -79.6930618286133, -1.39090631990471, 218, 48, 'PPL', 'P'),
(126411, 'Wachusett', 42.538890838623, 0.742443705280424, -71.8711090087891, -1.25438748926313, 218, 23, 'PPL', 'P'),
(126412, 'Wachusett Station', 42.5583305358887, 0.7427829920033, -71.845832824707, -1.25394633662856, 218, 23, 'PPL', 'P'),
(18466, 'Wacissa', 30.3583297729492, 0.529852809944186, -83.9872207641602, -1.46585353193394, 218, 12, 'PPL', 'P'),
(18467, 'Wacissa (historical)', 30.3333301544189, 0.529416484289091, -83.9499969482422, -1.46520385378602, 218, 12, 'PPL', 'P'),
(121827, 'Wacker', 42.0580596923828, 0.734051618632394, -90.0461120605469, -1.57160113407632, 218, 18, 'PPL', 'P'),
(74672, 'Wacker Heights', 39.7430610656738, 0.693647270417175, -82.5783309936523, -1.44126376664091, 218, 41, 'PPL', 'P'),
(6587, 'Waco', 34.4819412231445, 0.601823406823033, -87.6538925170898, -1.52984902661244, 218, 2, 'PPL', 'P'),
(25760, 'Waco', 33.7027816772461, 0.588224507348761, -85.1833267211914, -1.48672951908686, 218, 13, 'PPL', 'P'),
(31406, 'Waco', 38.5352783203125, 0.672567484861843, -87.040283203125, -1.51913952376285, 218, 19, 'PPL', 'P'),
(34293, 'Waco', 37.5205612182617, 0.654857330454762, -97.3072204589844, -1.69833138297327, 218, 20, 'PPL', 'P'),
(38713, 'Waco', 37.7425003051758, 0.658730898260282, -84.144172668457, -1.4685928594312, 218, 21, 'PPL', 'P'),
(58094, 'Waco', 37.246940612793, 0.650081749988032, -94.5991668701172, -1.65106693152708, 218, 29, 'PPL', 'P'),
(69819, 'Waco', 35.3613891601563, 0.617172668923759, -81.4288864135742, -1.42120217414935, 218, 33, 'PPL', 'P'),
(91600, 'Waco', 35.3758316040039, 0.617424737120935, -87.0319366455078, -1.51899384885122, 218, 50, 'PPL', 'P'),
(98861, 'Waco', 31.5491695404053, 0.550636884749978, -97.1463928222656, -1.69552441118432, 218, 51, 'PPL', 'P'),
(143290, 'Waco', 40.8969383239746, 0.713786227738408, -97.4630584716797, -1.70105126939456, 218, 35, 'PPL', 'P'),
(158128, 'Waco', 40.7786102294922, 0.711721012892079, -81.3472213745117, -1.41977685033394, 218, 41, 'PPL', 'P'),
(197777, 'Waco', 46.0738906860352, 0.804141091675262, -107.706390380859, -1.87983113758435, 218, 31, 'PPL', 'P'),
(12581, 'Waco (historical)', 35.7447204589844, 0.623863062214256, -90.3252792358398, -1.57647352044867, 218, 4, 'PPL', 'P'),
(91599, 'Waconda Point', 35.1344413757324, 0.613211682855457, -85.133056640625, -1.48585214066573, 218, 50, 'PPL', 'P'),
(138615, 'Waconia', 44.850830078125, 0.782794657115787, -93.7866668701172, -1.63688613135463, 218, 28, 'PPL', 'P'),
(6588, 'Wacoochee Valley', 32.6294403076172, 0.569491166450871, -85.1383285522461, -1.48594415288139, 218, 2, 'PPL', 'P'),
(209068, 'Wacota', 46.6580581665039, 0.814336737592522, -118.492500305176, -2.0680842692457, 218, 56, 'PPL', 'P'),
(133543, 'Wacousta', 42.8277816772461, 0.747485801593244, -84.7008285522461, -1.47830833740392, 218, 27, 'PPL', 'P'),
(138618, 'Wacouta', 44.5449981689453, 0.777456883342941, -92.4347229003906, -1.61329025778042, 218, 28, 'PPL', 'P'),
(138619, 'Wacouta Beach', 44.5458297729492, 0.777471397570882, -92.4102783203125, -1.61286361937379, 218, 28, 'PPL', 'P'),
(84171, 'Wadboo', 33.1908302307129, 0.579289268996409, -79.9377822875977, -1.39517749766098, 218, 48, 'PPL', 'P'),
(121830, 'Waddams Grove', 42.4174995422363, 0.740325027475211, -89.8841705322266, -1.56877472121142, 218, 18, 'PPL', 'P'),
(43510, 'Waddel', 31.6000003814697, 0.551524050288111, -92.7844390869141, -1.61939395668277, 218, 22, 'PPL', 'P'),
(43511, 'Waddell', 32.7522201538086, 0.571634079022004, -91.2699966430664, -1.59296194970568, 218, 22, 'PPL', 'P'),
(62186, 'Waddell', 33.5802803039551, 0.586086455046618, -88.8711090087891, -1.55109346210216, 218, 30, 'PPL', 'P'),
(179468, 'Waddell', 33.6113891601563, 0.586629407013858, -112.426391601563, -1.96221069958377, 218, 5, 'PPL', 'P'),
(52435, 'Waddells Corner', 38.6513900756836, 0.674594017293339, -75.9033279418945, -1.32476298580707, 218, 25, 'PPL', 'P'),
(18469, 'Waddells Mill', 30.8702793121338, 0.538788015007025, -85.3255615234375, -1.48921198469697, 218, 12, 'PPL', 'P'),
(138621, 'Waddells Mobile Home Park', 45.5944404602051, 0.795773106635097, -95.8958282470703, -1.67369794183836, 218, 28, 'PPL', 'P'),
(107214, 'Waddeys', 37.7844390869141, 0.65946286808589, -76.3566665649414, -1.3326752374057, 218, 53, 'PPL', 'P'),
(153412, 'Waddington', 44.8644409179688, 0.783032211085022, -75.2044372558594, -1.31256504222424, 218, 40, 'PPL', 'P'),
(194031, 'Waddington', 40.5672187805176, 0.708031536096911, -124.200561523438, -2.16770873140977, 218, 6, 'PPL', 'P'),
(168404, 'Waddle', 40.8338890075684, 0.712685809575988, -77.9349975585938, -1.3602223099312, 218, 45, 'PPL', 'P'),
(38714, 'Waddy', 38.1369400024414, 0.665615169678137, -85.0744400024414, -1.48482908733298, 218, 21, 'PPL', 'P'),
(12580, 'Wade', 33.9841690063477, 0.593135642714976, -94.3824996948242, -1.64728537593723, 218, 4, 'PPL', 'P'),
(18470, 'Wade', 29.7411098480225, 0.519080290045302, -82.6194381713867, -1.44198122223858, 218, 12, 'PPL', 'P'),
(62184, 'Wade', 30.642219543457, 0.534807621152279, -88.5697174072266, -1.54583318631704, 218, 30, 'PPL', 'P'),
(69822, 'Wade', 35.1627807617188, 0.613706298448912, -78.7363891601563, -1.3742092319763, 218, 33, 'PPL', 'P'),
(74670, 'Wade', 39.440559387207, 0.68836762013512, -81.1727828979492, -1.41673232457576, 218, 41, 'PPL', 'P'),
(77567, 'Wade', 33.8888893127441, 0.591472698351304, -96.0758285522461, -1.67683953981827, 218, 42, 'PPL', 'P'),
(91601, 'Wade', 35.9608306884766, 0.627634897266135, -86.4955596923828, -1.50963230498737, 218, 50, 'PPL', 'P'),
(111882, 'Wade', 39.7077789306641, 0.693031480994121, -80.5619430541992, -1.40607115809995, 218, 58, 'PPL', 'P'),
(197778, 'Wade', 45.1586112976074, 0.788166452771558, -108.81861114502, -1.89924305192799, 218, 31, 'PPL', 'P'),
(62185, 'Wade (historical)', 33.8408317565918, 0.590633935765983, -90.4644393920898, -1.57890232336283, 218, 30, 'PPL', 'P'),
(84172, 'Wade Hampton', 34.9036102294922, 0.609182919337412, -82.3333282470703, -1.43698766203663, 218, 48, 'PPL', 'P'),
(84173, 'Wade Hampton Gardens', 34.8925018310547, 0.608989041210054, -82.3541717529297, -1.43735144984153, 218, 48, 'PPL', 'P'),
(84174, 'Wade Hampton Heights', 34.9524993896484, 0.610036196150674, -82.1833267211914, -1.43436964152703, 218, 48, 'PPL', 'P'),
(84175, 'Wade Heights', 34.1805610656738, 0.59656333077499, -82.14111328125, -1.43363287801146, 218, 48, 'PPL', 'P'),
(69823, 'Wade Mills', 34.9655609130859, 0.610264162739984, -80.0472183227539, -1.39708751679479, 218, 33, 'PPL', 'P'),
(194032, 'Wade Place', 40.2961082458496, 0.703299764630112, -121.914169311523, -2.12780365931991, 218, 6, 'PPL', 'P'),
(58095, 'Wadell', 36.7797203063965, 0.641927217309236, -94.1555633544922, -1.64332458960601, 218, 29, 'PPL', 'P'),
(12583, 'Wadell (historical)', 35.086109161377, 0.612368126580174, -90.9569396972656, -1.58749807525522, 218, 4, 'PPL', 'P'),
(77568, 'Wadena', 34.4025001525879, 0.60043689858051, -95.5966720581055, -1.6684766813632, 218, 42, 'PPL', 'P'),
(118229, 'Wadena', 42.8427810668945, 0.747747590328399, -91.6566696166992, -1.59971066622405, 218, 16, 'PPL', 'P'),
(123899, 'Wadena', 40.6933288574219, 0.710232572158834, -87.2766723632813, -1.5232652929236, 218, 19, 'PPL', 'P'),
(138622, 'Wadena', 46.4425010681152, 0.810574556499594, -95.1358337402344, -1.660433535397, 218, 28, 'PPL', 'P'),
(25762, 'Wades', 31.8500003814697, 0.555887373418097, -84.7572174072266, -1.47929250858476, 218, 13, 'PPL', 'P'),
(12582, 'Wades Chapel', 33.6647186279297, 0.587560181814841, -94.2713928222656, -1.64534619518948, 218, 4, 'PPL', 'P'),
(126413, 'Wades Corner', 41.8783302307129, 0.730914747763416, -71.168327331543, -1.24212163507249, 218, 23, 'PPL', 'P'),
(107215, 'Wades Mill', 37.9488906860352, 0.662333089950723, -79.2863922119141, -1.38380859612549, 218, 53, 'PPL', 'P'),
(69824, 'Wades Point', 35.3988914489746, 0.617827207340673, -76.6258316040039, -1.3373730535686, 218, 33, 'PPL', 'P'),
(18472, 'Wadesboro', 30.5049991607666, 0.532412673673484, -84.0658264160156, -1.4672254593695, 218, 12, 'PPL', 'P'),
(38715, 'Wadesboro', 36.7480583190918, 0.641374611383045, -88.3213882446289, -1.54149902480099, 218, 21, 'PPL', 'P'),
(43512, 'Wadesboro', 30.4241695404053, 0.531001930665042, -90.4852828979492, -1.57926611116773, 218, 22, 'PPL', 'P'),
(69825, 'Wadesboro', 34.9680595397949, 0.610307772002834, -80.0769424438477, -1.39760630057514, 218, 33, 'PPL', 'P'),
(98862, 'Wadeside Addition Colonia', 28.0219993591309, 0.489076151808574, -97.8809967041016, -1.70834566762029, 218, 51, 'PPL', 'P'),
(111883, 'Wadestown', 39.6752815246582, 0.692464294260961, -80.3383331298828, -1.4021684286805, 218, 58, 'PPL', 'P'),
(31407, 'Wadesville', 38.1025009155273, 0.665014094220106, -87.7861099243164, -1.53215665569699, 218, 19, 'PPL', 'P'),
(107216, 'Wadesville', 39.2425003051758, 0.684910837040197, -78.0391693115234, -1.3620404500074, 218, 53, 'PPL', 'P'),
(168405, 'Wadesville', 40.7163887023926, 0.710635042378572, -76.2125015258789, -1.33015908280779, 218, 45, 'PPL', 'P'),
(69827, 'Wadeville', 35.2825012207031, 0.615795814640188, -79.9700012207031, -1.39573982412515, 218, 33, 'PPL', 'P'),
(111884, 'Wadeville', 39.1505584716797, 0.68330614932537, -81.6358337402344, -1.42481408637777, 218, 58, 'PPL', 'P'),
(133544, 'Wadhams', 42.9872207641602, 0.750268538616268, -82.5386123657227, -1.44057054580917, 218, 27, 'PPL', 'P'),
(153415, 'Wadhams', 44.2297210693359, 0.771954259898619, -73.4608306884766, -1.28213336676401, 218, 40, 'PPL', 'P'),
(71513, 'Wading River', 39.6152801513672, 0.691417072741315, -74.5044403076172, -1.3003477907235, 218, 37, 'PPL', 'P'),
(153414, 'Wading River', 40.9502792358398, 0.714717202276473, -72.8430633544922, -1.27135129277471, 218, 40, 'PPL', 'P'),
(153416, 'Wading River Landing', 40.9666709899902, 0.715003292356575, -72.8541717529297, -1.27154517090207, 218, 40, 'PPL', 'P'),
(118230, 'Wadleigh', 42.4736099243164, 0.741304338387061, -94.4030609130859, -1.64764423689411, 218, 16, 'PPL', 'P'),
(6589, 'Wadley', 33.1213912963867, 0.578077330963341, -85.5663909912109, -1.49341525184545, 218, 2, 'PPL', 'P'),
(25763, 'Wadley', 32.8666687011719, 0.573631582997618, -82.404167175293, -1.4382240345727, 218, 13, 'PPL', 'P'),
(98863, 'Wadley', 30.0013904571533, 0.523623043653732, -94.9472198486328, -1.65714160197355, 218, 51, 'PPL', 'P'),
(144587, 'Wadley Falls', 43.0919418334961, 0.752096266072389, -71.0083312988281, -1.23932917751149, 218, 36, 'PPL', 'P'),
(84176, 'Wadmalaw Island', 32.6708297729492, 0.570213548896555, -80.2347183227539, -1.40036000914228, 218, 48, 'PPL', 'P'),
(185982, 'Wadstrom', 34.3161087036133, 0.598929083350335, -119.290557861328, -2.08201300122098, 218, 6, 'PPL', 'P'),
(6591, 'Wadsworth', 32.6747207641602, 0.570281459504352, -86.4508285522461, -1.50885159931382, 218, 2, 'PPL', 'P'),
(34295, 'Wadsworth', 39.2783317565918, 0.685536213843175, -94.9000015258789, -1.65631748677423, 218, 20, 'PPL', 'P'),
(84177, 'Wadsworth', 34.9469413757324, 0.609939190507968, -81.9961090087891, -1.43110207602755, 218, 48, 'PPL', 'P'),
(98864, 'Wadsworth', 28.8322200775146, 0.503217171012245, -95.9347229003906, -1.67437678160022, 218, 51, 'PPL', 'P'),
(121829, 'Wadsworth', 42.4286117553711, 0.740518972181596, -87.9238891601563, -1.53456135700328, 218, 18, 'PPL', 'P'),
(126414, 'Wadsworth', 42.0583305358887, 0.734056345743328, -71.4375, -1.24681958439345, 218, 23, 'PPL', 'P'),
(153417, 'Wadsworth', 42.8202781677246, 0.747354840646639, -77.8969421386719, -1.35955811755534, 218, 40, 'PPL', 'P'),
(158129, 'Wadsworth', 41.0255584716797, 0.716031072800263, -81.7300033569336, -1.42645765624451, 218, 41, 'PPL', 'P'),
(168406, 'Wadsworth', 40.8630599975586, 0.713194939397384, -79.8161087036133, -1.39305389300775, 218, 45, 'PPL', 'P'),
(190886, 'Wadsworth', 39.6338882446289, 0.69174184523625, -119.284439086914, -2.08190620846127, 218, 39, 'PPL', 'P'),
(153418, 'Wadsworth Cove', 42.7902793884277, 0.74683126317633, -77.7225036621094, -1.35651359179716, 218, 40, 'PPL', 'P'),
(98865, 'Waelder', 29.6949996948242, 0.518275516053394, -97.2983322143555, -1.69817625383977, 218, 51, 'PPL', 'P'),
(43517, 'Wafer Forest', 32.5605583190918, 0.568288948955782, -93.5730590820313, -1.63315797214463, 218, 22, 'PPL', 'P'),
(12584, 'Wafers Crossing', 33.6361083984375, 0.587060839110451, -93.6961135864258, -1.63530567840572, 218, 4, 'PPL', 'P'),
(6592, 'Wagar', 31.4416694641113, 0.548760654472504, -87.9936065673828, -1.53577815530534, 218, 2, 'PPL', 'P'),
(6593, 'Wagarville', 31.4361095428467, 0.548663615540284, -88.0283279418945, -1.53638415761138, 218, 2, 'PPL', 'P'),
(133545, 'Wagarville', 44.0308303833008, 0.768482962575756, -84.4674987792969, -1.47423596462302, 218, 27, 'PPL', 'P'),
(84178, 'Wagener', 33.6522216796875, 0.587342068921563, -81.3613891601563, -1.42002412484115, 218, 48, 'PPL', 'P'),
(12585, 'Wager (historical)', 36.2227783203125, 0.632206745909474, -94.288330078125, -1.64564180607048, 218, 4, 'PPL', 'P'),
(38716, 'Wagersville', 37.6263885498047, 0.656704365828786, -83.9538879394531, -1.46527176439381, 218, 21, 'PPL', 'P'),
(43513, 'Waggaman', 29.9183292388916, 0.522173351914348, -90.2108306884766, -1.57447601647306, 218, 22, 'PPL', 'P'),
(52436, 'Waggaman Heights', 38.8069381713867, 0.677308843708566, -76.942497253418, -1.34289991177884, 218, 25, 'PPL', 'P'),
(28886, 'Waggoner', 39.377498626709, 0.687267002235617, -89.6530609130859, -1.56474109742438, 218, 18, 'PPL', 'P'),
(74671, 'Waggoner Ripple (historical)', 38.7125015258789, 0.675660613309916, -83.442497253418, -1.45634631315847, 218, 41, 'PPL', 'P'),
(111886, 'Waggy (historical)', 38.5316696166992, 0.672504501102063, -80.6530609130859, -1.40766146474489, 218, 58, 'PPL', 'P'),
(18471, 'Wagner', 28.704719543457, 0.500991866894889, -81.2825012207031, -1.41864727055758, 218, 12, 'PPL', 'P'),
(98866, 'Wagner', 33.1877784729004, 0.579236005774608, -96.2149963378906, -1.67926847589048, 218, 51, 'PPL', 'P'),
(168407, 'Wagner', 40.6813888549805, 0.710024179803535, -77.3886108398438, -1.35068606269985, 218, 45, 'PPL', 'P'),
(171528, 'Wagner', 43.079719543457, 0.751882946869074, -98.2927780151367, -1.71553260729603, 218, 49, 'PPL', 'P'),
(176839, 'Wagner', 45.3022193908691, 0.790672886831487, -87.7355575561523, -1.53127435042785, 218, 57, 'PPL', 'P'),
(185984, 'Wagner', 38.3586082458496, 0.669484010372722, -119.876937866211, -2.09224726297405, 218, 6, 'PPL', 'P'),
(197779, 'Wagner', 48.3705596923828, 0.844225527664536, -108.076942443848, -1.88629849113355, 218, 31, 'PPL', 'P'),
(209070, 'Wagner', 47.8791694641113, 0.835649150269072, -121.935279846191, -2.12817210765673, 218, 56, 'PPL', 'P'),
(111887, 'Wagner (historical)', 38.836669921875, 0.677827760646968, -82.1180572509766, -1.43323047437074, 218, 58, 'PPL', 'P'),
(133546, 'Wagner Beach', 44.1147193908691, 0.769947101964054, -83.5672225952148, -1.4585231810335, 218, 27, 'PPL', 'P'),
(52437, 'Wagner Landing', 38.2758293151855, 0.668039245481354, -75.7300033569336, -1.32173790112485, 218, 25, 'PPL', 'P'),
(31408, 'Wagner Station', 38.8519401550293, 0.678094276493057, -87.2336120605469, -1.52251374886398, 218, 19, 'PPL', 'P'),
(168408, 'Wagners', 41.1194381713867, 0.717669582660935, -75.5261077880859, -1.31817925211823, 218, 45, 'PPL', 'P'),
(185985, 'Wagners (historical)', 39.6500015258789, 0.692023075047363, -121.225830078125, -2.11578987332646, 218, 6, 'PPL', 'P'),
(52438, 'Wagners Crossroads', 39.5738906860352, 0.690694690295631, -77.6466674804688, -1.35519000073539, 218, 25, 'PPL', 'P'),
(168409, 'Wagners Forest Park', 41.121940612793, 0.717713258502812, -75.5374984741211, -1.31837805709361, 218, 45, 'PPL', 'P'),
(143293, 'Wagners Lake', 41.4219398498535, 0.72294923294299, -97.3852767944336, -1.6996937230289, 218, 35, 'PPL', 'P'),
(52439, 'Wagners Mill', 39.5613899230957, 0.690476510823326, -77.0558319091797, -1.34487797467849, 218, 25, 'PPL', 'P'),
(209071, 'Wagnersburg', 47.601390838623, 0.830800998662637, -120.240829467773, -2.09859836954167, 218, 56, 'PPL', 'P'),
(168410, 'Wagnerville', 40.6511116027832, 0.709495742064236, -75.3108291625977, -1.31442193129429, 218, 45, 'PPL', 'P'),
(12587, 'Wagnon', 33.6652793884277, 0.587569968931847, -92.2886123657227, -1.61074014787861, 218, 4, 'PPL', 'P'),
(38717, 'Wago', 36.7363891601563, 0.641170946138681, -85.1725006103516, -1.48654056780751, 218, 21, 'PPL', 'P'),
(168411, 'Wago Junction', 40.0872192382813, 0.699653963676821, -76.6952819824219, -1.33858519133875, 218, 45, 'PPL', 'P'),
(28889, 'Wagon Creek Heaven', 37.5830612182617, 0.655948161237258, -88.8974990844727, -1.55155405581269, 218, 18, 'PPL', 'P'),
(189796, 'Wagon Mound', 36.0088882446289, 0.628473659851456, -104.706108093262, -1.8274663331765, 218, 38, 'PPL', 'P'),
(18481, 'Wagon Wheel', 26.1005592346191, 0.455540695255915, -81.0650024414063, -1.41485120073978, 218, 12, 'PPL', 'P'),
(25764, 'Wagon Wheel', 31.2366695404053, 0.545182730837496, -83.4619369506836, -1.45668559988134, 218, 13, 'PPL', 'P'),
(179469, 'Wagon Wheel Mobile Ranch', 33.4597206115723, 0.583982291469347, -111.981109619141, -1.9544390628907, 218, 5, 'PPL', 'P'),
(197782, 'Wagon Wheel Trailer Court', 47.7094383239746, 0.832686783030522, -104.160827636719, -1.81794939386305, 218, 31, 'PPL', 'P'),
(199755, 'Wagon Wheel Trailer Court', 42.8294410705566, 0.747514763470098, -103.002777099609, -1.797737599086, 218, 35, 'PPL', 'P'),
(206305, 'Wagon Wheel Trailer Park', 40.1597213745117, 0.700919364668772, -111.609718322754, -1.9479570619555, 218, 52, 'PPL', 'P'),
(91602, 'Wagonda Hills', 36.0999984741211, 0.630063833338342, -85.4869384765625, -1.49202854386584, 218, 50, 'PPL', 'P'),
(58096, 'Wagoner', 37.6705589294434, 0.657475284385337, -93.9252777099609, -1.63930534688886, 218, 29, 'PPL', 'P'),
(69829, 'Wagoner', 36.401668548584, 0.635328969392456, -81.3866729736328, -1.42046541063378, 218, 33, 'PPL', 'P'),
(77569, 'Wagoner', 35.9594383239746, 0.627610595921188, -95.3691711425781, -1.66450604133595, 218, 42, 'PPL', 'P'),
(111888, 'Wagoner', 39.5380592346191, 0.690069313492653, -78.6725006103516, -1.37309416642788, 218, 58, 'PPL', 'P'),
(123900, 'Wagoner', 41.0141716003418, 0.715832334403916, -86.149169921875, -1.50358666299678, 218, 19, 'PPL', 'P'),
(179470, 'Wagoner', 34.2136116027832, 0.597140171467101, -112.535003662109, -1.96410633764768, 218, 5, 'PPL', 'P'),
(194034, 'Wagoner', 40.5658302307129, 0.708007301330991, -122.026107788086, -2.12975735429559, 218, 6, 'PPL', 'P'),
(201734, 'Wagontire', 43.2497215270996, 0.754850041218558, -119.874717712402, -2.09220851398019, 218, 43, 'PPL', 'P'),
(168412, 'Wagontown', 40.0105590820313, 0.698315991545165, -75.8430633544922, -1.32371117033454, 218, 45, 'PPL', 'P'),
(69838, 'Wagram', 34.8877792358398, 0.608906616374317, -79.3663864135742, -1.38520475832696, 218, 33, 'PPL', 'P'),
(74673, 'Wagram', 39.9566688537598, 0.697375429627177, -82.7305603027344, -1.44392066930243, 218, 41, 'PPL', 'P'),
(43514, 'Wags (historical)', 30.0088901519775, 0.52375393802131, -90.6769409179688, -1.58261117465492, 218, 22, 'PPL', 'P'),
(197783, 'Wagsmith Villa (historical)', 48.3472213745117, 0.843818197175808, -114.006942749023, -1.98979652110313, 218, 31, 'PPL', 'P'),
(34297, 'Wagstaff', 38.6650009155273, 0.674831571262574, -94.7961120605469, -1.65450427354605, 218, 20, 'PPL', 'P'),
(153419, 'Wagstaff Corner', 44.7616691589355, 0.781238505511826, -74.7144393920898, -1.30401296617372, 218, 40, 'PPL', 'P'),
(187507, 'Wah Keeney Park', 39.6602783203125, 0.692202438946779, -105.339996337891, -1.83852977013496, 218, 7, 'PPL', 'P'),
(195767, 'Waha', 46.2133293151855, 0.806574754858404, -116.851112365723, -2.03943664539972, 218, 17, 'PPL', 'P'),
(179471, 'Wahak Hotrontk', 32.1827812194824, 0.561695494728964, -112.36499786377, -1.96113917671917, 218, 5, 'PPL', 'P'),
(62187, 'Wahalak', 32.9055595397949, 0.574310356180451, -88.5297164916992, -1.54513503863727, 218, 30, 'PPL', 'P'),
(74674, 'Wahanaker', 39.5900001525879, 0.690975853527716, -81.0583267211914, -1.41473468744209, 218, 41, 'PPL', 'P'),
(211145, 'WahÃƒÂ¯lauhue', 21.1708297729492, 0.369500684917207, -157.257507324219, -2.74466127628672, 218, 15, 'PPL', 'P'),
(211140, 'WahiawÃƒÂ¤', 21.5027809143066, 0.375294325289648, -158.02360534668, -2.75803220917168, 218, 15, 'PPL', 'P'),
(133547, 'Wahjamega', 43.4555587768555, 0.758442578950048, -83.4397201538086, -1.45629784362663, 218, 27, 'PPL', 'P'),
(209072, 'Wahkiacus', 45.8258285522461, 0.799811590691121, -121.097221374512, -2.11354522800168, 218, 56, 'PPL', 'P'),
(138627, 'Wahkon', 46.1183280944824, 0.804916670763721, -93.5208282470703, -1.63224637210349, 218, 28, 'PPL', 'P'),
(6594, 'Wahl', 31.0049991607666, 0.541139319933456, -87.2213897705078, -1.52230042966066, 218, 2, 'PPL', 'P'),
(209075, 'Wahl', 48.8363914489746, 0.852355825577411, -122.363059997559, -2.13563827977276, 218, 56, 'PPL', 'P'),
(74675, 'Wahlsburg', 38.9136085510254, 0.679170593047613, -83.9027786254883, -1.46437973858669, 218, 41, 'PPL', 'P'),
(138629, 'Wahlsten', 47.7358283996582, 0.833147376741051, -92.283332824707, -1.6106480025049, 218, 28, 'PPL', 'P'),
(209074, 'Wahluke', 46.7097206115723, 0.815238417358595, -119.541107177734, -2.08638591173089, 218, 56, 'PPL', 'P'),
(168413, 'Wahlville', 40.8052787780762, 0.712186466871598, -80.0547180175781, -1.39721841116237, 218, 45, 'PPL', 'P'),
(153421, 'Wahmeda', 42.2163887023926, 0.736814981158487, -79.4783325195313, -1.3871585864607, 218, 40, 'PPL', 'P'),
(190888, 'Wahmonie (historical)', 36.8116683959961, 0.642484816662472, -116.159172058105, -2.02736000880454, 218, 39, 'PPL', 'P'),
(18473, 'Wahneta', 27.9524993896484, 0.487863148511071, -81.7272186279297, -1.42640905355462, 218, 12, 'PPL', 'P'),
(168414, 'Wahneta', 40.4541702270508, 0.706058466624298, -77.1891708374023, -1.34720517799706, 218, 45, 'PPL', 'P'),
(25765, 'Wahoma', 31.1605606079102, 0.543854379375278, -82.4277801513672, -1.43863615875139, 218, 13, 'PPL', 'P'),
(18474, 'Wahoo', 28.6902809143066, 0.50073986527674, -82.1958312988281, -1.43458788757836, 218, 12, 'PPL', 'P'),
(111889, 'Wahoo', 39.4550018310547, 0.688619688332296, -80.226936340332, -1.40022418792668, 218, 58, 'PPL', 'P'),
(143294, 'Wahoo', 41.2113914489746, 0.719274470112844, -96.620002746582, -1.68633717121382, 218, 35, 'PPL', 'P'),
(91603, 'Wahoo (historical)', 36.4708290100098, 0.636536047156534, -82.4522171020508, -1.43906266399996, 218, 50, 'PPL', 'P'),
(185987, 'Wahoo (historical)', 34.2413902282715, 0.59762499994355, -118.393890380859, -2.06636320139124, 218, 6, 'PPL', 'P'),
(25766, 'Wahoo Forest', 34.4030609130859, 0.600446685697516, -83.8819427490234, -1.46401608393984, 218, 13, 'PPL', 'P'),
(25767, 'Wahoo Valley', 34.3972206115723, 0.600344753206794, -83.8763885498047, -1.46391914487616, 218, 13, 'PPL', 'P'),
(6595, 'Wahouma', 33.5527801513672, 0.585606486839159, -86.7352828979492, -1.51381626421794, 218, 2, 'PPL', 'P'),
(118232, 'Wahpeton', 43.3661117553711, 0.756881433919043, -95.1716690063477, -1.66105897877901, 218, 16, 'PPL', 'P'),
(141021, 'Wahpeton', 46.2652816772461, 0.807481494630549, -96.6055603027344, -1.68608510301664, 218, 34, 'PPL', 'P'),
(206308, 'Wahsatch', 41.1991691589355, 0.719061150909528, -111.11222076416, -1.9392740915374, 218, 52, 'PPL', 'P'),
(185988, 'Wahtoke', 36.6769409179688, 0.640133378577986, -119.456939697266, -2.0849169120736, 218, 6, 'PPL', 'P'),
(179472, 'Wahweap', 36.9966697692871, 0.645713699747111, -111.489440917969, -1.94585782522624, 218, 5, 'PPL', 'P'),
(211150, 'Waiaka', 20.0297203063965, 0.349584567600186, -155.701934814453, -2.71751141423779, 218, 15, 'PPL', 'P'),
(211152, 'Waiakahiula (historical)', 19.563060760498, 0.341439822038397, -154.891662597656, -2.70336949621725, 218, 15, 'PPL', 'P'),
(211159, 'Waiakoa', 20.7625007629395, 0.362373999261128, -156.330001831055, -2.72847325160067, 218, 15, 'PPL', 'P'),
(211168, 'WaialeÃ‚â€˜e', 21.6897201538086, 0.378557030520131, -158.026382446289, -2.75808067870352, 218, 15, 'PPL', 'P'),
(211172, 'Waialua', 21.1002807617188, 0.368269372387209, -156.761383056641, -2.73600227431843, 218, 15, 'PPL', 'P'),
(211182, 'Waiau', 21.3930606842041, 0.373379346018312, -157.962493896484, -2.7569656131551, 218, 15, 'PPL', 'P'),
(211162, 'WaiÃ‚â€˜alae', 21.2791690826416, 0.371391562580677, -157.790832519531, -2.75396955692876, 218, 15, 'PPL', 'P'),
(211174, 'WaiÃ‚â€˜anae', 21.4447193145752, 0.374280959205359, -158.190002441406, -2.76093638634041, 218, 15, 'PPL', 'P'),
(211264, 'WaiÃ‚â€˜ÃƒÂ¶hinu', 19.0702800750732, 0.3328391765875, -155.614166259766, -2.71597956397878, 218, 15, 'PPL', 'P'),
(211148, 'WaiÃƒÂ¤hole', 21.4858303070068, 0.374998481382053, -157.856674194336, -2.75511871093913, 218, 15, 'PPL', 'P'),
(211156, 'WaiÃƒÂ¤kea', 19.7169399261475, 0.344125520129201, -155.070831298828, -2.70649657996923, 218, 15, 'PPL', 'P'),
(52459, 'Waibelwood Park', 39.6305618286133, 0.691683788324487, -76.0908279418945, -1.32803547815456, 218, 25, 'PPL', 'P'),
(107217, 'Waidsboro', 36.9486083984375, 0.644874870582763, -79.9599990844727, -1.3955652539157, 218, 53, 'PPL', 'P'),
(211186, 'Waiehu', 20.9213905334473, 0.365147148904228, -156.496932983398, -2.73138674983322, 218, 15, 'PPL', 'P'),
(211189, 'Waiehu Village', 20.9174995422363, 0.365079238296431, -156.515563964844, -2.73171192180231, 218, 15, 'PPL', 'P'),
(211188, 'Waieli', 22.0166702270508, 0.384263385787844, -159.783325195313, -2.78874511444301, 218, 15, 'PPL', 'P'),
(211191, 'Waihee', 20.9338893890381, 0.365365295087019, -156.514724731445, -2.73169727441632, 218, 15, 'PPL', 'P'),
(211193, 'Waihou', 19.5400009155273, 0.341037351818659, -155.903335571289, -2.72102652056059, 218, 15, 'PPL', 'P'),
(209078, 'Waiilatpo (historical)', 46.0411109924316, 0.803568978094086, -118.461112976074, -2.06753645700947, 218, 56, 'PPL', 'P'),
(211203, 'Waikapu', 20.858060836792, 0.364041837183304, -156.506942749023, -2.73156145320072, 218, 15, 'PPL', 'P'),
(211205, 'Waikapuna', 19.0247192382813, 0.332043989975515, -155.582214355469, -2.71542189804652, 218, 15, 'PPL', 'P'),
(211200, 'WaikÃƒÂ¤ne', 21.500560760498, 0.375255576295787, -157.854995727539, -2.75508941616714, 218, 15, 'PPL', 'P'),
(211210, 'WaikÃƒÂ¯kÃƒÂ¯', 21.2827796936035, 0.371454579629971, -157.829437255859, -2.75464333668455, 218, 15, 'PPL', 'P'),
(211209, 'WaikiÃ‚â€˜i', 19.860559463501, 0.346632153926211, -155.652221679688, -2.71664375635465, 218, 15, 'PPL', 'P'),
(211213, 'Waikoloa', 19.9430599212646, 0.348072058548589, -155.790283203125, -2.71905338450895, 218, 15, 'PPL', 'P'),
(211215, 'Waikoloa Village', 19.9325008392334, 0.347887767801156, -155.827774047852, -2.71970772318878, 218, 15, 'PPL', 'P'),
(211218, 'Waikui', 20.0249996185303, 0.349502176053962, -155.824172973633, -2.71964487258706, 218, 15, 'PPL', 'P'),
(211220, 'Wailau (historical)', 21.1686096191406, 0.369461935923347, -156.830825805664, -2.73721427893053, 218, 15, 'PPL', 'P'),
(211223, 'Wailea', 19.8875007629395, 0.347102368306178, -155.123611450195, -2.70741776739028, 218, 15, 'PPL', 'P'),
(211227, 'Wailua', 20.8486099243164, 0.363876887643287, -156.136383056641, -2.72509396649347, 218, 15, 'PPL', 'P'),
(211231, 'Wailua House Lots', 22.062219619751, 0.385058372662746, -159.346115112305, -2.78111435897161, 218, 15, 'PPL', 'P'),
(211235, 'Wailuku', 20.8911094665527, 0.364618644585901, -156.50471496582, -2.73152257104881, 218, 15, 'PPL', 'P'),
(211237, 'Wailuku Heights', 20.8775005340576, 0.36438112390618, -156.519439697266, -2.731779566094, 218, 15, 'PPL', 'P'),
(211240, 'Wailupe', 21.2797203063965, 0.371401183250115, -157.759719848633, -2.75342653838249, 218, 15, 'PPL', 'P'),
(211242, 'Waimalu', 21.4047203063965, 0.373582844815108, -157.943328857422, -2.75663112012219, 218, 15, 'PPL', 'P'),
(211246, 'Waimanalo Village', 21.3327808380127, 0.372327264229677, -158.092498779297, -2.75923462640385, 218, 15, 'PPL', 'P'),
(211244, 'WaimÃƒÂ¤nalo', 21.3500003814697, 0.372627801958692, -157.720825195313, -2.75274769862063, 218, 15, 'PPL', 'P'),
(211245, 'WaimÃƒÂ¤nalo Beach', 21.3402805328369, 0.372458158597254, -157.702774047852, -2.75243264666368, 218, 15, 'PPL', 'P'),
(211253, 'Waimea', 20.0230598449707, 0.349468320618604, -155.671676635742, -2.71698330939363, 218, 15, 'PPL', 'P'),
(211257, 'Wainaku', 19.7447204589844, 0.344610381895163, -155.095001220703, -2.70691842468589, 218, 15, 'PPL', 'P'),
(211259, 'Wainee', 20.8741703033447, 0.364323000415389, -156.670562744141, -2.73441716083762, 218, 15, 'PPL', 'P'),
(211262, 'Wainiha', 22.2161102294922, 0.387744270490632, -159.543334960938, -2.78455649468054, 218, 15, 'PPL', 'P'),
(176841, 'Waino', 46.639720916748, 0.814016692208522, -91.5733337402344, -1.5982561807947, 218, 57, 'PPL', 'P'),
(133552, 'Wainola', 46.730281829834, 0.815597278315484, -89.0313873291016, -1.55389084651118, 218, 27, 'PPL', 'P'),
(153420, 'Wainscott', 40.9366683959961, 0.714479648307238, -72.2433319091797, -1.26088400442627, 218, 40, 'PPL', 'P'),
(111890, 'Wainville', 38.4913902282715, 0.671801493153309, -80.5730590820313, -1.40626516938537, 218, 58, 'PPL', 'P'),
(6596, 'Wainwright', 31.648889541626, 0.552377327101372, -87.4869384765625, -1.52693512890573, 218, 2, 'PPL', 'P'),
(58097, 'Wainwright', 38.583610534668, 0.673411041137126, -92.0680618286133, -1.60689081483901, 218, 29, 'PPL', 'P'),
(77571, 'Wainwright', 35.6124992370605, 0.621555366550675, -95.5641708374023, -1.66790942805102, 218, 42, 'PPL', 'P'),
(158131, 'Wainwright', 40.4186096191406, 0.705437816932255, -81.4291687011719, -1.42120710099736, 218, 41, 'PPL', 'P'),
(212223, 'Wainwright', 70.6369400024414, 1.23284717657629, -160.038330078125, -2.79319578925676, 218, 1, 'PPL', 'P'),
(211278, 'Waipahu', 21.3866691589355, 0.373267792858152, -158.009170532227, -2.75778027413255, 218, 15, 'PPL', 'P'),
(211277, 'WaipÃƒÂ¤hoehoe', 19.6041698455811, 0.342157310925578, -155.011108398438, -2.70545421871857, 218, 15, 'PPL', 'P'),
(211283, 'WaipiÃ‚â€˜o', 21.4183292388916, 0.37382036549483, -158.000564575195, -2.75763007184707, 218, 15, 'PPL', 'P'),
(211284, 'WaipiÃ‚â€˜o Acres', 21.4675006866455, 0.374678569156108, -158.016387939453, -2.75790624165212, 218, 15, 'PPL', 'P'),
(211281, 'Waipio', 20.1111106872559, 0.351005097725634, -155.598617553711, -2.7157081878637, 218, 15, 'PPL', 'P'),
(211288, 'Waipouli', 22.0638904571533, 0.385087534276682, -159.324722290039, -2.78074098378678, 218, 15, 'PPL', 'P'),
(38718, 'Wait', 36.7675018310547, 0.641713964684948, -84.995002746582, -1.48344264566948, 218, 21, 'PPL', 'P'),
(129158, 'Waite', 45.3255615234375, 0.791080283899241, -67.6908264160156, -1.18142779435543, 218, 26, 'PPL', 'P'),
(158132, 'Waite Hill', 41.6186103820801, 0.726381781271993, -81.3841705322266, -1.4204217347919, 218, 41, 'PPL', 'P'),
(138631, 'Waite Park', 45.5572204589844, 0.7951234950662, -94.2238922119141, -1.64451715314214, 218, 28, 'PPL', 'P'),
(62193, 'Waites', 34.7016716003418, 0.605658425371774, -89.3794403076172, -1.55996551695765, 218, 30, 'PPL', 'P'),
(126415, 'Waites Corner', 42.5638885498047, 0.742879997646006, -71.8505630493164, -1.25402889462235, 218, 23, 'PPL', 'P'),
(129160, 'Waites Landing', 43.7061080932617, 0.762815489459958, -70.2177810668945, -1.22553147306185, 218, 26, 'PPL', 'P'),
(111893, 'Waiteville', 37.4736099243164, 0.654037875787344, -80.4222183227539, -1.40363250148977, 218, 58, 'PPL', 'P'),
(38719, 'Waitman', 37.9080581665039, 0.661620428043018, -86.9508285522461, -1.51757824557379, 218, 21, 'PPL', 'P'),
(209076, 'Waits', 48.1897201538086, 0.841069282298628, -117.781936645508, -2.05568259383948, 218, 56, 'PPL', 'P'),
(18475, 'Waits Junction', 28.5719394683838, 0.498674417403815, -81.690559387207, -1.42576922910272, 218, 12, 'PPL', 'P'),
(172678, 'Waits River', 44.0894393920898, 0.769505882750455, -72.2825012207031, -1.26156763787809, 218, 55, 'PPL', 'P'),
(209077, 'Waitsburg', 46.2705612182617, 0.807573640004266, -118.152221679688, -2.06214528685677, 218, 56, 'PPL', 'P'),
(172679, 'Waitsfield', 44.189998626709, 0.771260972487844, -72.8252792358398, -1.27104090134967, 218, 55, 'PPL', 'P'),
(172680, 'Waitsfield Common', 44.189998626709, 0.771260972487844, -72.7980575561523, -1.2705657934112, 218, 55, 'PPL', 'P'),
(177747, 'Waka', 36.2816696166992, 0.63323459293219, -101.047218322754, -1.7636066597136, 218, 51, 'PPL', 'P'),
(34296, 'Wakarusa', 38.8858299255371, 0.678685764571164, -95.695556640625, -1.67020254290763, 218, 20, 'PPL', 'P'),
(123901, 'Wakarusa', 41.5361099243164, 0.724941876649614, -86.0208282470703, -1.50134667820392, 218, 19, 'PPL', 'P'),
(18476, 'Wakasassa (historical)', 29.2000007629395, 0.50963615489815, -83.0166702270508, -1.44891422950438, 218, 12, 'PPL', 'P'),
(158134, 'Wakatomika', 40.1986083984375, 0.701598071272579, -82.0472183227539, -1.43199410183468, 218, 41, 'PPL', 'P'),
(158135, 'Wakatomika (historical)', 40.1208305358887, 0.700240591485938, -82.0111083984375, -1.43136386476271, 218, 41, 'PPL', 'P'),
(107218, 'Wake', 37.5680618286133, 0.655686372502103, -76.429443359375, -1.33394543208761, 218, 53, 'PPL', 'P'),
(192386, 'Wake', 33.7825012207031, 0.589615875860273, -101.094169616699, -1.76442611438102, 218, 51, 'PPL', 'P'),
(12588, 'Wake (historical)', 36.3055610656738, 0.63365157737987, -92.2113876342773, -1.60939232205092, 218, 4, 'PPL', 'P'),
(69831, 'Wake Crossroads', 35.8830604553223, 0.626277550637549, -78.5102767944336, -1.37026282671497, 218, 33, 'PPL', 'P'),
(69832, 'Wake Forest', 35.9797210693359, 0.627964596609087, -78.5100021362305, -1.370258033025, 218, 33, 'PPL', 'P'),
(107219, 'Wake Forest', 37.2213897705078, 0.649635803663498, -80.5722198486328, -1.40625052199937, 218, 53, 'PPL', 'P'),
(123902, 'Wake Robin Fields', 41.6150016784668, 0.726318797512212, -87.0261077880859, -1.51889211609758, 218, 19, 'PPL', 'P'),
(98867, 'Wake Village', 33.4266700744629, 0.583405450777236, -94.1061096191406, -1.64246145909671, 218, 51, 'PPL', 'P'),
(126416, 'Wakeby', 41.6777801513672, 0.727414488563698, -70.4747161865234, -1.23001583686338, 218, 23, 'PPL', 'P'),
(34288, 'WaKeeney', 39.0250015258789, 0.681114767222398, -99.8791732788086, -1.74322042788515, 218, 20, 'PPL', 'P'),
(28887, 'Wakefield', 38.8400001525879, 0.677885884137759, -88.2438888549805, -1.54014640528334, 218, 18, 'PPL', 'P'),
(31409, 'Wakefield', 38.7872200012207, 0.6769646967167, -85.5599975585938, -1.49330366539577, 218, 19, 'PPL', 'P'),
(34299, 'Wakefield', 39.2133293151855, 0.684401707218801, -97.0052795410156, -1.69306151980822, 218, 20, 'PPL', 'P'),
(38720, 'Wakefield', 37.9716682434082, 0.662730633322445, -85.3080596923828, -1.48890652011994, 218, 21, 'PPL', 'P'),
(43515, 'Wakefield', 30.8891696929932, 0.539117714349977, -91.3499984741211, -1.59435824506521, 218, 22, 'PPL', 'P'),
(52443, 'Wakefield', 38.5952796936035, 0.67361470638149, -76.8938903808594, -1.34205156181359, 218, 25, 'PPL', 'P'),
(62188, 'Wakefield', 34.7430610656738, 0.606380807817458, -89.7408294677734, -1.5662729476834, 218, 30, 'PPL', 'P'),
(79330, 'Wakefield', 39.773609161377, 0.694180435267408, -76.179443359375, -1.32958210895762, 218, 45, 'PPL', 'P'),
(98868, 'Wakefield', 31.0986099243164, 0.542773135972706, -94.8349990844727, -1.65518298014986, 218, 51, 'PPL', 'P'),
(107223, 'Wakefield', 36.9680595397949, 0.645214357042721, -76.9899978637695, -1.34372895382618, 218, 53, 'PPL', 'P'),
(111891, 'Wakefield', 39.2208290100098, 0.684532601586378, -81.6419372558594, -1.42492061282137, 218, 58, 'PPL', 'P'),
(126417, 'Wakefield', 42.5063896179199, 0.741876451968237, -71.0733337402344, -1.24046368413587, 218, 23, 'PPL', 'P'),
(133548, 'Wakefield', 46.4752807617188, 0.81114667008077, -89.9397201538086, -1.56974424500626, 218, 27, 'PPL', 'P'),
(143297, 'Wakefield', 42.2691688537598, 0.737736168579545, -96.8647232055664, -1.69060834897009, 218, 35, 'PPL', 'P'),
(144588, 'Wakefield', 43.5680618286133, 0.760406127621763, -71.0305633544922, -1.23971720008232, 218, 36, 'PPL', 'P'),
(153422, 'Wakefield', 40.8977813720703, 0.713800941703431, -73.852783203125, -1.2889742286561, 218, 40, 'PPL', 'P'),
(158136, 'Wakefield', 40.1416702270508, 0.700604312711816, -84.6141662597656, -1.47679579506281, 218, 41, 'PPL', 'P'),
(169646, 'Wakefield', 41.4372215270996, 0.723215948526161, -71.5019378662109, -1.24794423732179, 218, 47, 'PPL', 'P'),
(209929, 'Wakefield', 48.2024993896484, 0.841292322039922, -119.709167480469, -2.0893191173555, 218, 56, 'PPL', 'P'),
(12595, 'Wakefield (historical)', 33.9111099243164, 0.591860521185046, -93.883056640625, -1.63856845021523, 218, 4, 'PPL', 'P'),
(107224, 'Wakefield (historical)', 38.1861114501953, 0.666473373339415, -76.9238891601563, -1.3425751392839, 218, 53, 'PPL', 'P'),
(107225, 'Wakefield Corner', 38.1719398498535, 0.666226032253174, -76.9494400024414, -1.34302108560844, 218, 53, 'PPL', 'P'),
(52444, 'Wakefield Estates', 39.5333290100098, 0.689986755498861, -77.0502777099609, -1.34478103561481, 218, 25, 'PPL', 'P'),
(107226, 'Wakefield Forest', 38.8352813720703, 0.677803525881048, -77.2394409179688, -1.34808255641819, 218, 53, 'PPL', 'P'),
(126418, 'Wakefield Junction', 42.4958305358887, 0.741692161220804, -71.0708312988281, -1.24042000829399, 218, 23, 'PPL', 'P'),
(107229, 'Wakefield Manor', 38.8163909912109, 0.677473826538096, -78.1074981689453, -1.36323301354354, 218, 53, 'PPL', 'P'),
(52446, 'Wakefield Meadows', 39.5208282470703, 0.689768576026556, -76.3397216796875, -1.33237949336664, 218, 25, 'PPL', 'P'),
(52447, 'Wakefield Mill', 39.5669403076172, 0.690573383307978, -77.065559387207, -1.34504775119799, 218, 25, 'PPL', 'P'),
(25768, 'Wakefield Mobile Home Park', 33.913330078125, 0.591899270178907, -83.3455581665039, -1.45465440691794, 218, 13, 'PPL', 'P'),
(12589, 'Wakefield Village', 34.6861114501953, 0.605386849519613, -92.3277816772461, -1.61142378133044, 218, 4, 'PPL', 'P'),
(31410, 'Wakeland', 39.4691696166992, 0.68886696283951, -86.5752792358398, -1.51102367349889, 218, 19, 'PPL', 'P'),
(62189, 'Wakeland', 33.6186103820801, 0.586755441112446, -90.1994400024414, -1.57427721149768, 218, 30, 'PPL', 'P'),
(133551, 'Wakelee', 41.9838905334473, 0.732757122605533, -85.8788909912109, -1.49886940575793, 218, 27, 'PPL', 'P'),
(69834, 'Wakelon', 36.1586112976074, 0.631086820092069, -76.8438873291016, -1.34117884392437, 218, 33, 'PPL', 'P'),
(52449, 'Wakely Terrace', 39.5255584716797, 0.689851134020348, -76.3352813720703, -1.33230199537892, 218, 25, 'PPL', 'P'),
(107230, 'Wakema', 37.6527786254883, 0.657164959539315, -76.898063659668, -1.34212439926941, 218, 53, 'PPL', 'P'),
(158137, 'Wakeman', 41.2544403076172, 0.720025814435382, -82.3997192382813, -1.43814640342692, 218, 41, 'PPL', 'P'),
(107231, 'Wakemans Grove', 38.8463897705078, 0.677997404008406, -78.6180572509766, -1.37214395055094, 218, 53, 'PPL', 'P'),
(138634, 'Wakemup', 47.9241714477539, 0.836434583053563, -92.6449966430664, -1.6169602269206, 218, 28, 'PPL', 'P'),
(168416, 'Wakena', 40.4897193908691, 0.706678916579259, -79.4813919067383, -1.38721198284056, 218, 45, 'PPL', 'P'),
(58098, 'Wakenda', 39.3141708374023, 0.686161723804207, -93.3769378662109, -1.62973501119555, 218, 29, 'PPL', 'P'),
(107232, 'Wakenva', 37.0416717529297, 0.646499132531603, -82.3133316040039, -1.43663865477577, 218, 53, 'PPL', 'P'),
(123903, 'Wakeville Village', 41.4630584716797, 0.723666888277739, -85.2569427490234, -1.48801436115476, 218, 19, 'PPL', 'P'),
(77572, 'Wakita', 36.8833312988281, 0.643735570268427, -97.9216690063477, -1.70905553320885, 218, 42, 'PPL', 'P'),
(171532, 'Wakonda', 43.0083312988281, 0.75063698695308, -97.1063919067383, -1.69482626350456, 218, 49, 'PPL', 'P'),
(201735, 'Wakonda Beach', 44.3880615234375, 0.774717822161795, -124.087501525879, -2.16573546220007, 218, 43, 'PPL', 'P'),
(202736, 'Wakpala', 45.6572189331055, 0.796868797686583, -100.534721374512, -1.75466190056035, 218, 49, 'PPL', 'P'),
(202738, 'Wakpamani', 43.1216697692871, 0.752615116431764, -102.14778137207, -1.78281510854996, 218, 49, 'PPL', 'P'),
(18477, 'Wakulla', 30.2366695404053, 0.527729438317553, -84.2311096191406, -1.47011019546227, 218, 12, 'PPL', 'P'),
(69836, 'Wakulla', 34.7924995422363, 0.607243672010644, -79.2552795410156, -1.38326557757922, 218, 33, 'PPL', 'P'),
(18478, 'Wakulla Beach', 30.1091709136963, 0.52550416748971, -84.2591705322266, -1.47059995078674, 218, 12, 'PPL', 'P'),
(18480, 'Wakulla Gardens', 30.1763896942139, 0.526677356528917, -84.3077774047852, -1.47144830075198, 218, 12, 'PPL', 'P'),
(18484, 'Wakulla Springs', 30.2333297729492, 0.527671148379193, -84.3052825927734, -1.47140475806816, 218, 12, 'PPL', 'P'),
(179473, 'Walapai', 35.3444404602051, 0.616876858305679, -113.883331298828, -1.98763909430406, 218, 5, 'PPL', 'P'),
(168415, 'Walbert', 40.6111106872559, 0.708797594384472, -75.5686111450195, -1.31892107563987, 218, 45, 'PPL', 'P'),
(58102, 'Walbert (historical)', 38.3300018310547, 0.66898473424736, -91.331672668457, -1.59403839941829, 218, 29, 'PPL', 'P'),
(138644, 'Walbo', 45.5872192382813, 0.795647072536509, -93.3266677856445, -1.62885763277442, 218, 28, 'PPL', 'P'),
(38721, 'Walbridge', 38.0774993896484, 0.664577735275496, -82.602783203125, -1.4416905382056, 218, 21, 'PPL', 'P'),
(158139, 'Walbridge', 41.5877799987793, 0.725843689573742, -83.4933319091797, -1.45723354527563, 218, 41, 'PPL', 'P'),
(52450, 'Walbrook', 39.3088912963867, 0.68606957843049, -76.6716690063477, -1.33817306716006, 218, 25, 'PPL', 'P'),
(52451, 'Walbrook Manor', 39.6561088562012, 0.692129668069993, -76.8208312988281, -1.34077644028366, 218, 25, 'PPL', 'P'),
(98869, 'Walburg', 30.7366695404053, 0.536456084577524, -97.5800018310547, -1.703092316054, 218, 51, 'PPL', 'P'),
(18482, 'Walcan', 30.7244396209717, 0.536242632216154, -86.0861129760742, -1.50248611167631, 218, 12, 'PPL', 'P'),
(38722, 'Walche Cut', 37.0963897705078, 0.647454142098505, -87.7977828979492, -1.53236038752038, 218, 21, 'PPL', 'P'),
(168417, 'Walcksville', 40.8691711425781, 0.713301598999041, -75.6561126708984, -1.32044826536698, 218, 45, 'PPL', 'P'),
(12590, 'Walco (historical)', 34.3383293151855, 0.599316906184078, -92.8152770996094, -1.61993218153908, 218, 4, 'PPL', 'P'),
(354, 'Walcott', 36.0433311462402, 0.629074801888514, -90.6711120605469, -1.58250944190128, 218, 4, 'PPL', 'P'),
(118233, 'Walcott', 41.5847206115723, 0.725790293193886, -90.7719421386719, -1.58426925874961, 218, 16, 'PPL', 'P'),
(138635, 'Walcott', 44.2333297729492, 0.7720172436584, -93.1833267211914, -1.6263558592464, 218, 28, 'PPL', 'P'),
(141024, 'Walcott', 46.5488891601563, 0.812431378990625, -96.936393737793, -1.6918592357341, 218, 34, 'PPL', 'P'),
(192387, 'Walcott', 34.9305610656738, 0.609653300164948, -102.814720153809, -1.79445538620053, 218, 51, 'PPL', 'P'),
(209813, 'Walcott', 41.7611083984375, 0.72886884083499, -106.844436645508, -1.8647872069026, 218, 59, 'PPL', 'P'),
(118234, 'Walcott Eststes', 41.5944404602051, 0.725959936555324, -90.7819366455078, -1.58444369580101, 218, 16, 'PPL', 'P'),
(6598, 'Wald', 31.7577800750732, 0.55427782543428, -86.6655578613281, -1.51259933275783, 218, 2, 'PPL', 'P'),
(118235, 'Wald', 41.8377799987793, 0.730207012703728, -91.1322174072266, -1.59055724839939, 218, 16, 'PPL', 'P'),
(123904, 'Wald View', 41.4002799987793, 0.722571197226253, -87.3547210693359, -1.52462749982117, 218, 19, 'PPL', 'P'),
(98870, 'Walda', 30.8722190856934, 0.538821870442383, -94.8622207641602, -1.65565808808833, 218, 51, 'PPL', 'P'),
(34301, 'Waldeck', 37.6538887023926, 0.657184334036246, -98.6097183227539, -1.72106425919624, 218, 20, 'PPL', 'P'),
(98871, 'Waldeck', 30.0633296966553, 0.524704087319223, -96.7925033569336, -1.68934787482616, 218, 51, 'PPL', 'P'),
(111892, 'Waldeck', 39.047779083252, 0.68151231059412, -80.5094375610352, -1.40515476436886, 218, 58, 'PPL', 'P'),
(138637, 'Waldeck', 46.6744384765625, 0.814622627935542, -93.6074981689453, -1.63375904760266, 218, 28, 'PPL', 'P'),
(168418, 'Waldeck', 40.2683296203613, 0.702814936153663, -76.304443359375, -1.33176377052262, 218, 45, 'PPL', 'P'),
(107233, 'Waldemar (historical)', 37.0074996948242, 0.645902717605479, -77.5233306884766, -1.35303736762628, 218, 53, 'PPL', 'P'),
(25769, 'Walden', 32.7080612182617, 0.570863360202535, -83.6655578613281, -1.460239455198, 218, 13, 'PPL', 'P'),
(38723, 'Walden', 36.8458290100098, 0.643081031851513, -84.1677780151367, -1.46900485045183, 218, 21, 'PPL', 'P'),
(52452, 'Walden', 39.0250015258789, 0.681114767222398, -76.6733322143555, -1.33820209561594, 218, 25, 'PPL', 'P'),
(84179, 'Walden', 34.0597190856934, 0.594454240349702, -81.1880569458008, -1.41699890700088, 218, 48, 'PPL', 'P'),
(91604, 'Walden', 35.1647186279297, 0.613740120594756, -85.3013916015625, -1.4887901399803, 218, 50, 'PPL', 'P'),
(98872, 'Walden', 30.0349998474121, 0.524209638173336, -94.1494369506836, -1.64321766368824, 218, 51, 'PPL', 'P'),
(107234, 'Walden', 37.1122207641602, 0.647730445061601, -76.5299987792969, -1.33570045524597, 218, 53, 'PPL', 'P'),
(141027, 'Walden', 47.1747207641602, 0.82335420104353, -97.6897201538086, -1.70500726203582, 218, 34, 'PPL', 'P'),
(153424, 'Walden', 41.5611114501953, 0.725378235594224, -74.1888885498047, -1.29484037358921, 218, 40, 'PPL', 'P'),
(172682, 'Walden', 44.4497184753418, 0.775793938979268, -72.2236099243164, -1.26053979085537, 218, 55, 'PPL', 'P'),
(194462, 'Walden', 40.7316703796387, 0.710901757961743, -106.283058166504, -1.85498930409414, 218, 7, 'PPL', 'P'),
(201736, 'Walden', 43.7763900756836, 0.764042141458048, -123.004173278809, -2.14682781740884, 218, 43, 'PPL', 'P'),
(12591, 'Walden (historical)', 36.4830589294434, 0.636749499517904, -93.8166732788086, -1.63740984198299, 218, 4, 'PPL', 'P'),
(62190, 'Walden (historical)', 33.9338912963867, 0.592258131135795, -88.4277801513672, -1.54335591387105, 218, 30, 'PPL', 'P'),
(52453, 'Walden Circle', 39.3033294677734, 0.685972506208757, -76.7333297729492, -1.33924925055656, 218, 25, 'PPL', 'P'),
(153425, 'Walden Cliffs', 42.7255592346191, 0.745701683399972, -78.9516677856445, -1.37796655280024, 218, 40, 'PPL', 'P'),
(52454, 'Walden Farms', 39.5988883972168, 0.691130982661213, -77.211669921875, -1.34759786109979, 218, 25, 'PPL', 'P'),
(172683, 'Walden Heights', 44.452220916748, 0.775837614821146, -72.2574996948242, -1.26113127893348, 218, 55, 'PPL', 'P'),
(84180, 'Walden Pond', 34.8933296203613, 0.609003488858968, -82.307502746582, -1.43653692202213, 218, 48, 'PPL', 'P'),
(6600, 'Walden Quarters', 32.746940612793, 0.571541933648287, -87.8625030517578, -1.53348996729674, 218, 2, 'PPL', 'P'),
(25770, 'Walden Woods', 34.4263916015625, 0.600853883028189, -83.8133316040039, -1.46281859355569, 218, 13, 'PPL', 'P'),
(98873, 'Walden Woods', 30.0941696166992, 0.525242345465041, -95.1722183227539, -1.66106856615893, 218, 51, 'PPL', 'P'),
(12592, 'Waldenburg', 35.5652809143066, 0.62073125135135, -90.9336090087891, -1.58709087792455, 218, 4, 'PPL', 'P'),
(133554, 'Waldenburg', 42.6572189331055, 0.744508920126753, -82.9375, -1.4475324483728, 218, 27, 'PPL', 'P'),
(91605, 'Waldens Creek', 35.7872200012207, 0.62460481915687, -83.6266708374023, -1.45956074859419, 218, 50, 'PPL', 'P'),
(91606, 'Waldensia', 35.913330078125, 0.626805855218794, -84.7919387817383, -1.4798985108908, 218, 50, 'PPL', 'P'),
(43519, 'Waldheim', 30.5561103820801, 0.53330473277012, -90.0119400024414, -1.5710047191502, 218, 22, 'PPL', 'P'),
(79328, 'Waldheim', 39.9075012207031, 0.696517292544926, -77.0605621337891, -1.34496053267229, 218, 45, 'PPL', 'P'),
(43518, 'Walding', 31.2038898468018, 0.54461061725632, -92.7677764892578, -1.61910313949173, 218, 22, 'PPL', 'P'),
(6601, 'Waldo', 33.3802795410156, 0.582595783226824, -86.0269393920898, -1.50145333780558, 218, 2, 'PPL', 'P'),
(12593, 'Waldo', 33.351390838623, 0.582091580253445, -93.2955627441406, -1.62831474738621, 218, 4, 'PPL', 'P'),
(18483, 'Waldo', 29.7894401550293, 0.519923813031071, -82.1675033569336, -1.43409347172198, 218, 12, 'PPL', 'P'),
(34302, 'Waldo', 39.1183280944824, 0.682743623124118, -98.7977828979492, -1.72434660523976, 218, 20, 'PPL', 'P'),
(38724, 'Waldo', 37.5758285522461, 0.655821927401589, -82.977783203125, -1.44823552290058, 218, 21, 'PPL', 'P'),
(58101, 'Waldo', 37.1891708374023, 0.649073477199328, -92.7444381713867, -1.61869580900301, 218, 29, 'PPL', 'P'),
(62191, 'Waldo', 32.7372207641602, 0.571372290286849, -89.2769393920898, -1.55817653849539, 218, 30, 'PPL', 'P'),
(121831, 'Waldo', 40.7980613708496, 0.712060499352037, -88.8324966430664, -1.55041954918832, 218, 18, 'PPL', 'P'),
(129161, 'Waldo', 44.5125007629395, 0.776889696609781, -69.0766677856445, -1.2056152891658, 218, 26, 'PPL', 'P'),
(138640, 'Waldo', 47.0661087036133, 0.821458562979612, -91.6988906860352, -1.60044756289768, 218, 28, 'PPL', 'P'),
(158140, 'Waldo', 40.4588890075684, 0.706140824881009, -83.0772171020508, -1.44997097182493, 218, 41, 'PPL', 'P'),
(176842, 'Waldo', 43.6747207641602, 0.762267677223729, -87.9486083984375, -1.53499278909987, 218, 57, 'PPL', 'P'),
(185990, 'Waldo', 37.8711090087891, 0.660975543585055, -122.502502441406, -2.13807200953493, 218, 6, 'PPL', 'P'),
(189797, 'Waldo (historical)', 35.4505615234375, 0.618729020264801, -106.147216796875, -1.8526184249337, 218, 38, 'PPL', 'P'),
(185991, 'Waldo Junction', 39.1111106872559, 0.682617655604557, -121.308059692383, -2.1172250508379, 218, 6, 'PPL', 'P'),
(129164, 'Waldoboro', 44.0952796936035, 0.769607815241178, -69.376106262207, -1.21084147648897, 218, 26, 'PPL', 'P'),
(185992, 'Waldon', 37.9263916015625, 0.661940406847991, -122.054443359375, -2.13025190331002, 218, 6, 'PPL', 'P'),
(192388, 'Waldon Place Windmill', 32.3338890075684, 0.56433282315647, -102.455558776855, -1.7881868376267, 218, 51, 'PPL', 'P'),
(107235, 'Waldon Woods', 38.7266693115234, 0.67590788781713, -77.0861129760742, -1.34540647899682, 218, 53, 'PPL', 'P'),
(52455, 'Waldorf', 38.624439239502, 0.674123636465804, -76.9394378662109, -1.34284651539898, 218, 25, 'PPL', 'P'),
(138641, 'Waldorf', 43.935001373291, 0.766810430832159, -93.6972198486328, -1.63532498632363, 218, 28, 'PPL', 'P'),
(185993, 'Waldorf', 34.9111099243164, 0.60931381370499, -120.554168701172, -2.10406717084015, 218, 6, 'PPL', 'P'),
(201737, 'Waldport', 44.4269409179688, 0.775396395607547, -124.067497253418, -2.16538632178117, 218, 43, 'PPL', 'P'),
(6602, 'Waldrep', 33.3388900756836, 0.58187340078114, -85.3127822875977, -1.48898894495568, 218, 2, 'PPL', 'P'),
(98874, 'Waldrip', 31.4424991607666, 0.548775135410931, -99.4227828979492, -1.73525491306472, 218, 51, 'PPL', 'P'),
(12596, 'Waldron', 34.8983306884766, 0.609090773963696, -94.0905609130859, -1.64219008298163, 218, 4, 'PPL', 'P'),
(31411, 'Waldron', 39.4536094665527, 0.688595386987349, -85.6669387817383, -1.49517014184575, 218, 19, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(34304, 'Waldron', 37.0022201538086, 0.645810572231763, -98.1822204589844, -1.71360301392822, 218, 20, 'PPL', 'P'),
(58105, 'Waldron', 39.2222213745117, 0.684556902931325, -94.7930603027344, -1.65445101032425, 218, 29, 'PPL', 'P'),
(133555, 'Waldron', 41.7277793884277, 0.72828713987389, -84.4188919067383, -1.47338761465778, 218, 27, 'PPL', 'P'),
(209079, 'Waldron', 48.6877784729004, 0.849762039833729, -123.03556060791, -2.14737562964507, 218, 56, 'PPL', 'P'),
(121833, 'Waldron (historical)', 41.1341705322266, 0.717926710864182, -89.751106262207, -1.56645231158281, 218, 18, 'PPL', 'P'),
(201738, 'Waldron (historical)', 44.7244415283203, 0.780588760784874, -120.027496337891, -2.09487500402163, 218, 43, 'PPL', 'P'),
(169647, 'Waldron Corners', 41.8738899230957, 0.730837249775695, -71.6033325195313, -1.24971390786615, 218, 47, 'PPL', 'P'),
(107236, 'Waldrop', 38.0736083984375, 0.664509824667699, -78.2019424438477, -1.36488137710024, 218, 53, 'PPL', 'P'),
(84181, 'Waldrop Crossroads', 34.663890838623, 0.604999026685871, -81.9250030517578, -1.42986104295958, 218, 48, 'PPL', 'P'),
(185994, 'Waldrue Heights', 38.3644409179688, 0.669585809705391, -122.559997558594, -2.13907548863367, 218, 6, 'PPL', 'P'),
(62192, 'Waldrup', 31.9650001525879, 0.557894498063149, -89.107780456543, -1.55522415811093, 218, 30, 'PPL', 'P'),
(12597, 'Waldstein (historical)', 34.1527786254883, 0.596078435719514, -91.543327331543, -1.59773247016634, 218, 4, 'PPL', 'P'),
(146537, 'Waldwick', 41.0105590820313, 0.715769284065109, -74.1183319091797, -1.29360892790116, 218, 37, 'PPL', 'P'),
(176844, 'Waldwick', 42.8255615234375, 0.747447052599383, -90.0397186279297, -1.57148954762664, 218, 57, 'PPL', 'P'),
(185995, 'Walerga', 38.6749992370605, 0.675006074893001, -121.364723205566, -2.1182140157087, 218, 6, 'PPL', 'P'),
(38725, 'Wales', 37.336109161377, 0.651638034750047, -82.6380615234375, -1.44230626104963, 218, 21, 'PPL', 'P'),
(91607, 'Wales', 35.2488899230957, 0.615209186831071, -87.0827789306641, -1.51988121412643, 218, 50, 'PPL', 'P'),
(113147, 'Wales', 47.2350006103516, 0.824406282832166, -91.7466735839844, -1.60128153179303, 218, 28, 'PPL', 'P'),
(118236, 'Wales', 41.1169395446777, 0.717625973398085, -95.3269424438477, -1.66376901150427, 218, 16, 'PPL', 'P'),
(126420, 'Wales', 42.0694389343262, 0.734250223870686, -72.2227783203125, -1.26052527662743, 218, 23, 'PPL', 'P'),
(141029, 'Wales', 48.8958282470703, 0.853393193401024, -98.6022186279297, -1.72093336482866, 218, 34, 'PPL', 'P'),
(176846, 'Wales', 43.0044403076172, 0.750569076345283, -88.3766708374023, -1.54246388806393, 218, 57, 'PPL', 'P'),
(192847, 'Wales', 39.4869384765625, 0.689177087948449, -111.634437561035, -1.94838849405209, 218, 52, 'PPL', 'P'),
(212224, 'Wales', 65.6091690063477, 1.14509601865818, -168.087493896484, -2.93368019991953, 218, 1, 'PPL', 'P'),
(133559, 'Wales Center', 42.9419403076172, 0.749478245562787, -82.6783294677734, -1.4430090692613, 218, 27, 'PPL', 'P'),
(153426, 'Wales Center', 42.7683296203613, 0.746448167453522, -78.5302810668945, -1.37061196713388, 218, 40, 'PPL', 'P'),
(129166, 'Wales Corner', 44.1836090087891, 0.771149452617197, -70.065559387207, -1.22287470355838, 218, 26, 'PPL', 'P'),
(158142, 'Wales Corners', 41.315559387207, 0.721092543610014, -82.9027786254883, -1.44692644606675, 218, 41, 'PPL', 'P'),
(153427, 'Wales Hollow', 42.7425003051758, 0.745997360859998, -78.4886093139648, -1.36988465784017, 218, 40, 'PPL', 'P'),
(52456, 'Wales of Harford', 39.560001373291, 0.690452276057407, -76.4266662597656, -1.33389696255577, 218, 25, 'PPL', 'P'),
(31412, 'Walesboro', 39.1452789306641, 0.683214003951653, -85.914436340332, -1.49948978913386, 218, 19, 'PPL', 'P'),
(25771, 'Waleska', 34.3163909912109, 0.598934010198351, -84.5522232055664, -1.47571468481829, 218, 13, 'PPL', 'P'),
(153429, 'Walesville', 43.1152801513672, 0.752503596561117, -75.3658294677734, -1.31538186770921, 218, 40, 'PPL', 'P'),
(43520, 'Walet', 30.1025009155273, 0.52538775406056, -91.7263870239258, -1.60092746452611, 218, 22, 'PPL', 'P'),
(118237, 'Walford', 41.8783302307129, 0.730914747763416, -91.8344421386719, -1.60281338205205, 218, 16, 'PPL', 'P'),
(133557, 'Walgamor Corners', 43.7419395446777, 0.763440866262936, -85.9491729736328, -1.50009605775602, 218, 27, 'PPL', 'P'),
(111895, 'Walgrove', 38.4638900756836, 0.67132152494585, -81.4372177124023, -1.42134758274487, 218, 58, 'PPL', 'P'),
(176847, 'Walhain', 44.545280456543, 0.777461810190958, -87.7541732788086, -1.53159925608084, 218, 57, 'PPL', 'P'),
(84183, 'Walhalla', 34.764720916748, 0.606758843534195, -83.0641708374023, -1.44974327155173, 218, 48, 'PPL', 'P'),
(98875, 'Walhalla', 30.0230598449707, 0.524001245818037, -96.7591705322266, -1.68876610728603, 218, 51, 'PPL', 'P'),
(133558, 'Walhalla', 43.9536094665527, 0.767135203327094, -86.1147232055664, -1.5029854543807, 218, 27, 'PPL', 'P'),
(141031, 'Walhalla', 48.9233283996582, 0.853873161608484, -97.9177780151367, -1.70898762260105, 218, 34, 'PPL', 'P'),
(107237, 'Walhaven', 38.7763900756836, 0.676775678858332, -77.1438903808594, -1.34641488494358, 218, 53, 'PPL', 'P'),
(158143, 'Walhonding', 40.3594398498535, 0.70440510964055, -82.1469421386719, -1.4337346107651, 218, 41, 'PPL', 'P'),
(52457, 'Waljacks Corners', 38.9233283996582, 0.679340236409051, -75.9583282470703, -1.32572292222199, 218, 25, 'PPL', 'P'),
(168420, 'Walkchalk', 40.8352813720703, 0.712710110920935, -79.5769424438477, -1.38887965431516, 218, 45, 'PPL', 'P'),
(25772, 'Walkee (historical)', 32.2947196960449, 0.563649189704646, -82.8661117553711, -1.4462864884568, 218, 13, 'PPL', 'P'),
(12599, 'Walker', 35.121940612793, 0.612993503383152, -91.6894378662109, -1.60028258006814, 218, 4, 'PPL', 'P'),
(14788, 'Walker', 39.3416709899902, 0.686641692011667, -75.6030578613281, -1.31952228425596, 218, 10, 'PPL', 'P'),
(25773, 'Walker', 31.5402793884277, 0.550481722326967, -84.3150024414063, -1.4715744014296, 218, 13, 'PPL', 'P'),
(34305, 'Walker', 38.8672218322754, 0.678360992076229, -99.0755615234375, -1.72919475684619, 218, 20, 'PPL', 'P'),
(38726, 'Walker', 36.8830604553223, 0.643730843157492, -83.7149963378906, -1.46110231939119, 218, 21, 'PPL', 'P'),
(43522, 'Walker', 30.4877796173096, 0.532112135944469, -90.8613891601563, -1.58583040378061, 218, 22, 'PPL', 'P'),
(52458, 'Walker', 39.6594390869141, 0.692187791560784, -76.6719436645508, -1.33817786085002, 218, 25, 'PPL', 'P'),
(58104, 'Walker', 37.898609161377, 0.661455511792515, -94.2319412231445, -1.64465763488964, 218, 29, 'PPL', 'P'),
(79329, 'Walker', 39.9275016784668, 0.696866366384808, -79.7205581665039, -1.39138622153315, 218, 45, 'PPL', 'P'),
(84184, 'Walker', 33.4127807617188, 0.583163036539011, -81.3013916015625, -1.41897696990053, 218, 48, 'PPL', 'P'),
(111894, 'Walker', 39.1791687011719, 0.68380549202976, -81.3841705322266, -1.4204217347919, 218, 58, 'PPL', 'P'),
(118238, 'Walker', 42.2866706848145, 0.738041633156578, -91.7805633544922, -1.60187301987114, 218, 16, 'PPL', 'P'),
(121834, 'Walker', 41.6177787780762, 0.726367267044052, -88.2063903808594, -1.53949193344545, 218, 18, 'PPL', 'P'),
(129168, 'Walker', 46.6074981689453, 0.813454299165324, -68.2438888549805, -1.19108055488447, 218, 26, 'PPL', 'P'),
(133560, 'Walker', 43.0013885498047, 0.750515813123481, -85.7680587768555, -1.49693501870015, 218, 27, 'PPL', 'P'),
(138643, 'Walker', 47.101390838623, 0.822074352402665, -94.5869369506836, -1.65085347916571, 218, 28, 'PPL', 'P'),
(153431, 'Walker', 43.4866714477539, 0.758985597496315, -76.4497222900391, -1.33429936619648, 218, 40, 'PPL', 'P'),
(176848, 'Walker', 44.3861083984375, 0.774683733699842, -89.9786071777344, -1.57042295161007, 218, 57, 'PPL', 'P'),
(179474, 'Walker', 34.4558296203613, 0.601367673381493, -112.377502441406, -1.96135742277051, 218, 5, 'PPL', 'P'),
(194035, 'Walker', 41.834171295166, 0.730144028943948, -122.838333129883, -2.14393336077809, 218, 6, 'PPL', 'P'),
(194463, 'Walker', 40.2644386291504, 0.702747025545866, -104.951667785645, -1.83175215831876, 218, 7, 'PPL', 'P'),
(195768, 'Walker', 43.7722206115723, 0.763969370581262, -111.707778930664, -1.94966854243004, 218, 17, 'PPL', 'P'),
(201739, 'Walker', 43.8541717529297, 0.765399687823716, -123.038612365723, -2.14742889286687, 218, 43, 'PPL', 'P'),
(202739, 'Walker', 45.9102783203125, 0.801285517196425, -101.089996337891, -1.7643532769252, 218, 49, 'PPL', 'P'),
(209080, 'Walker', 46.4305610656738, 0.810366164144295, -118.630279541016, -2.07048897055199, 218, 56, 'PPL', 'P'),
(6603, 'Walker (historical)', 34.8388900756836, 0.608053339561055, -88.0666732788086, -1.53705340999332, 218, 2, 'PPL', 'P'),
(197784, 'Walker (historical)', 45.7666702270508, 0.798779083136497, -111.027778625488, -1.93780029819015, 218, 31, 'PPL', 'P'),
(6604, 'Walker Chapel', 33.6066703796387, 0.586547048757148, -86.8225021362305, -1.51533852709703, 218, 2, 'PPL', 'P'),
(107238, 'Walker Chapel', 38.9213905334473, 0.679306414263207, -77.1297225952148, -1.34616761043636, 218, 53, 'PPL', 'P'),
(129170, 'Walker Corner', 44.5661087036133, 0.777825331679753, -69.2194366455078, -1.20810707583973, 218, 26, 'PPL', 'P'),
(12600, 'Walker Creek', 33.1155586242676, 0.577975531630673, -93.5124969482422, -1.63210096350798, 218, 4, 'PPL', 'P'),
(98877, 'Walker Crossing', 31.434440612793, 0.548634487215861, -99.3619384765625, -1.73419297758005, 218, 51, 'PPL', 'P'),
(25775, 'Walker Grove Settlement', 33.149169921875, 0.57856215943979, -82.1666717529297, -1.43407895749404, 218, 13, 'PPL', 'P'),
(52462, 'Walker Hill', 39.1069412231445, 0.682544884727771, -76.8891677856445, -1.34196913697785, 218, 25, 'PPL', 'P'),
(111896, 'Walker Hill (historical)', 38.0299987792969, 0.663748693228155, -80.7263870239258, -1.40894124680673, 218, 58, 'PPL', 'P'),
(25776, 'Walker Hills', 34.2425003051758, 0.59764437444048, -84.8333282470703, -1.48062089333649, 218, 13, 'PPL', 'P'),
(168421, 'Walker Lake', 41.4188919067383, 0.722896036300215, -74.9188919067383, -1.30758133571832, 218, 45, 'PPL', 'P'),
(190890, 'Walker Lake', 38.6483306884766, 0.674540620913483, -118.754173278809, -2.07265132419908, 218, 39, 'PPL', 'P'),
(185998, 'Walker Landing', 38.2152786254883, 0.666982436581783, -121.60417175293, -2.12239318124931, 218, 6, 'PPL', 'P'),
(52460, 'Walker Manor', 39.663330078125, 0.692255702168581, -76.7050018310547, -1.33875483470018, 218, 25, 'PPL', 'P'),
(25777, 'Walker Mill', 33.2705612182617, 0.580680837245003, -84.1716690063477, -1.46907276105963, 218, 13, 'PPL', 'P'),
(52461, 'Walker Mill', 38.8752784729004, 0.678501606981785, -76.8886108398438, -1.34195941643988, 218, 25, 'PPL', 'P'),
(197785, 'Walker Mobile Home Park', 48.1497192382813, 0.840371134618864, -104.52278137207, -1.82426667828482, 218, 31, 'PPL', 'P'),
(25778, 'Walker Park', 33.8369407653809, 0.590566025158186, -83.7350006103516, -1.4614514598101, 218, 13, 'PPL', 'P'),
(123905, 'Walker Park', 41.3294410705566, 0.721334824690183, -85.7533264160156, -1.4966778904969, 218, 19, 'PPL', 'P'),
(25779, 'Walker Place', 33.7786102294922, 0.589547965252476, -84.6947174072266, -1.47820167780226, 218, 13, 'PPL', 'P'),
(107239, 'Walker Place', 36.8536109924316, 0.643216853067107, -81.9069366455078, -1.42954572468651, 218, 53, 'PPL', 'P'),
(192389, 'Walker Place', 30.2083301544189, 0.527234822724098, -103.151107788086, -1.80032645798166, 218, 51, 'PPL', 'P'),
(194036, 'Walker Place (historical)', 40.2155609130859, 0.701893948469687, -122.537216186523, -2.13867787868292, 218, 6, 'PPL', 'P'),
(179475, 'Walker Place Windmill', 34.3438911437988, 0.599413978405811, -112.621673583984, -1.96561901314685, 218, 5, 'PPL', 'P'),
(190891, 'Walker River (historical)', 38.7941703796387, 0.677086003704353, -119.366943359375, -2.08334617966267, 218, 39, 'PPL', 'P'),
(129169, 'Walker Settlement', 46.0322189331055, 0.803413782381562, -68.2113876342773, -1.19051330157229, 218, 26, 'PPL', 'P'),
(62194, 'Walker Siding', 34.8319396972656, 0.607932032573402, -88.2888870239258, -1.5409317714888, 218, 30, 'PPL', 'P'),
(6606, 'Walker Springs', 31.5405597686768, 0.550486615885471, -87.7911071777344, -1.53224387422269, 218, 2, 'PPL', 'P'),
(6607, 'Walker Subdivision', 33.5722198486328, 0.585945773562035, -86.2319412231445, -1.5050312947301, 218, 2, 'PPL', 'P'),
(91608, 'Walker Subdivision', 35.9388885498047, 0.627251934701382, -84.4902801513672, -1.47463357457377, 218, 50, 'PPL', 'P'),
(153432, 'Walker Valley', 41.6336097717285, 0.726643570007147, -74.3783264160156, -1.29814668808255, 218, 40, 'PPL', 'P'),
(98878, 'Walker Village', 31.1358299255371, 0.543422747541603, -97.7241668701172, -1.70560847065191, 218, 51, 'PPL', 'P'),
(185999, 'Walkermine (historical)', 39.9638900756836, 0.697501463725765, -120.66667175293, -2.10603071951186, 218, 6, 'PPL', 'P'),
(69840, 'Walkers', 34.5405616760254, 0.602846526734814, -77.8544387817383, -1.3588162940337, 218, 33, 'PPL', 'P'),
(107241, 'Walkers', 37.4152793884277, 0.653019815881634, -76.9402770996094, -1.34286116278498, 218, 53, 'PPL', 'P'),
(158144, 'Walkers', 40.6222190856934, 0.70899147251183, -80.616943359375, -1.40703109451487, 218, 41, 'PPL', 'P'),
(14789, 'Walkers Acres', 38.8047218322754, 0.677270161293732, -75.4316711425781, -1.31653102171958, 218, 10, 'PPL', 'P'),
(52464, 'Walkers Choice', 39.163890838623, 0.683538843025615, -77.2058334350586, -1.3474959951881, 218, 25, 'PPL', 'P'),
(6610, 'Walkers Corner', 34.1780586242676, 0.596519654933113, -86.7425003051758, -1.5139422317375, 218, 2, 'PPL', 'P'),
(12605, 'Walkers Corner', 34.7133293151855, 0.605861890879056, -92.0911102294922, -1.60729308532167, 218, 4, 'PPL', 'P'),
(58109, 'Walkers Corner', 38.1824989318848, 0.666410323000607, -93.0963897705078, -1.62483852321533, 218, 29, 'PPL', 'P'),
(107242, 'Walkers Corner', 37.9116706848145, 0.661683478381826, -76.5466690063477, -1.33599140559506, 218, 53, 'PPL', 'P'),
(153433, 'Walkers Corners', 43.1211090087891, 0.752605329314758, -75.7736129760742, -1.32249903256439, 218, 40, 'PPL', 'P'),
(84185, 'Walkers Crossing', 34.8199996948242, 0.607723640218103, -82.2563934326172, -1.43564489621501, 218, 48, 'PPL', 'P'),
(111898, 'Walkers Crossing (historical)', 39.2377815246582, 0.684828478783486, -81.6877822875977, -1.42572075957088, 218, 58, 'PPL', 'P'),
(69851, 'Walkers Crossroads', 35.9255599975586, 0.627019307580163, -78.5047225952148, -1.37016588765129, 218, 33, 'PPL', 'P'),
(107244, 'Walkers Ford', 37.502498626709, 0.654542078760724, -78.9358291625977, -1.37769011667909, 218, 53, 'PPL', 'P'),
(71514, 'Walkers Forge', 39.440559387207, 0.68836762013512, -74.7561111450195, -1.30474027546742, 218, 37, 'PPL', 'P'),
(62195, 'Walkers Gin', 33.6444396972656, 0.587206247705969, -88.970832824707, -1.55283397103258, 218, 30, 'PPL', 'P'),
(209081, 'Walkers Landing', 47.2827796936035, 0.825240185148497, -122.924171447754, -2.14543152204931, 218, 56, 'PPL', 'P'),
(98879, 'Walkers Mill', 32.589168548584, 0.568788291660172, -94.5530624389648, -1.65026225740372, 218, 51, 'PPL', 'P'),
(168434, 'Walkers Mill', 40.3958282470703, 0.705040206981506, -80.1305618286133, -1.39854213538219, 218, 45, 'PPL', 'P'),
(25780, 'Walkers Park', 33.8469390869141, 0.590740528788614, -83.9905624389648, -1.46591185516182, 218, 13, 'PPL', 'P'),
(52463, 'Walkers Run', 39.7138900756836, 0.693138140595779, -76.7811126708984, -1.34008321945192, 218, 25, 'PPL', 'P'),
(69842, 'Walkers Store', 34.5016708374023, 0.60216775355198, -77.8530578613281, -1.35879219242583, 218, 33, 'PPL', 'P'),
(25781, 'Walkersville', 31.3936100006104, 0.54792185859767, -82.2761077880859, -1.43598897662785, 218, 13, 'PPL', 'P'),
(52465, 'Walkersville', 39.4861106872559, 0.689162640299536, -77.3522186279297, -1.35005089877986, 218, 25, 'PPL', 'P'),
(58112, 'Walkersville', 39.7405586242676, 0.693603594575297, -92.0683288574219, -1.60689547537092, 218, 29, 'PPL', 'P'),
(111899, 'Walkersville', 38.8694381713867, 0.678399674491062, -80.4569396972656, -1.40423850379581, 218, 58, 'PPL', 'P'),
(69843, 'Walkersville (historical)', 34.8499984741211, 0.608247217688413, -80.6527786254883, -1.40765653789688, 218, 33, 'PPL', 'P'),
(91609, 'Walkersville (historical)', 35.5766716003418, 0.620930056326725, -86.23388671875, -1.505065250034, 218, 50, 'PPL', 'P'),
(6611, 'Walkerton', 33.5849990844727, 0.586168813303329, -86.29638671875, -1.50615608081649, 218, 2, 'PPL', 'P'),
(98880, 'Walkerton', 30.5327796936035, 0.532897535439447, -97.8349990844727, -1.70754285770969, 218, 51, 'PPL', 'P'),
(107245, 'Walkerton', 37.7261085510254, 0.65844480818018, -77.023063659668, -1.3443060608344, 218, 53, 'PPL', 'P'),
(123907, 'Walkerton', 41.4666709899902, 0.723729938616546, -86.4830627441406, -1.5094141920941, 218, 19, 'PPL', 'P'),
(38727, 'Walkertown', 37.2636108398438, 0.650372700337123, -83.190559387207, -1.45194916788264, 218, 21, 'PPL', 'P'),
(43523, 'Walkertown', 29.8899993896484, 0.521678902768461, -90.1136093139648, -1.57277918338452, 218, 22, 'PPL', 'P'),
(52466, 'Walkertown', 38.7916717529297, 0.677042394441503, -76.0361099243164, -1.32708046858766, 218, 25, 'PPL', 'P'),
(69846, 'Walkertown', 35.2855606079102, 0.615849211020044, -78.8138885498047, -1.37556185149395, 218, 33, 'PPL', 'P'),
(91611, 'Walkertown', 35.1852798461914, 0.614098981551644, -88.2433319091797, -1.54013668474536, 218, 50, 'PPL', 'P'),
(168427, 'Walkertown', 40.0544395446777, 0.699081850095645, -79.945556640625, -1.39531318571852, 218, 45, 'PPL', 'P'),
(12606, 'Walkerville', 33.0894393920898, 0.577519665031079, -93.3138885498047, -1.62863459303313, 218, 4, 'PPL', 'P'),
(28890, 'Walkerville', 39.3869400024414, 0.687431785328066, -90.4952774047852, -1.57944054821913, 218, 18, 'PPL', 'P'),
(31414, 'Walkerville', 39.5277786254883, 0.689889883014209, -85.7630615234375, -1.49684780017445, 218, 19, 'PPL', 'P'),
(133563, 'Walkerville', 43.7144393920898, 0.762960898055476, -86.1244430541992, -1.50315509774214, 218, 27, 'PPL', 'P'),
(197786, 'Walkerville', 46.0341682434082, 0.803447804264488, -112.535003662109, -1.96410633764768, 218, 31, 'PPL', 'P'),
(62196, 'Walkiah (historical)', 30.5705604553223, 0.53355693412535, -89.7869415283203, -1.56707775496482, 218, 30, 'PPL', 'P'),
(18485, 'Walkill', 29.937780380249, 0.522512838374305, -81.6622161865234, -1.42527454693024, 218, 12, 'PPL', 'P'),
(187946, 'Walkinghood', 38.4722213745117, 0.671466933541368, -101.972221374512, -1.77975100855777, 218, 20, 'PPL', 'P'),
(25782, 'Walkinshaw', 33.2769393920898, 0.580792157378568, -81.8947219848633, -1.42933253864125, 218, 13, 'PPL', 'P'),
(153434, 'Walkleys Landing', 42.7308311462402, 0.745793695615635, -77.7063903808594, -1.35623236198605, 218, 40, 'PPL', 'P'),
(69847, 'Walks (historical)', 35.9941711425781, 0.628216797964318, -80.2686080932617, -1.40095149722038, 218, 33, 'PPL', 'P'),
(168428, 'Walkton', 40.8186111450195, 0.712419160571843, -75.5483322143555, -1.318567141531, 218, 45, 'PPL', 'P'),
(168429, 'Wall', 40.3936080932617, 0.705001457987646, -79.7863922119141, -1.39253524238546, 218, 45, 'PPL', 'P'),
(192390, 'Wall', 31.3738899230957, 0.547577678316291, -100.307220458984, -1.7506912605331, 218, 51, 'PPL', 'P'),
(202740, 'Wall', 43.9925003051758, 0.767813976509928, -102.241111755371, -1.7844440310307, 218, 49, 'PPL', 'P'),
(197787, 'Wall City', 46.5438919067383, 0.812344160464925, -112.937782287598, -1.97113615081911, 218, 31, 'PPL', 'P'),
(43524, 'Wall Lake', 32.6324996948242, 0.569544562830727, -92.1416702270508, -1.60817552374887, 218, 22, 'PPL', 'P'),
(118239, 'Wall Lake', 42.271110534668, 0.737770057304417, -95.0927810668945, -1.65968212449544, 218, 16, 'PPL', 'P'),
(138646, 'Wall Lake', 46.290828704834, 0.807927374376055, -95.9644393920898, -1.67489543222251, 218, 28, 'PPL', 'P'),
(118240, 'Wall Lake Station', 42.2563896179199, 0.737513128838251, -95.2569427490234, -1.6625472863542, 218, 16, 'PPL', 'P'),
(168430, 'Wall Rose', 40.6341705322266, 0.70920006460421, -80.1608276367188, -1.39907037338441, 218, 45, 'PPL', 'P'),
(43525, 'Wall Settlement', 30.4083309173584, 0.530725494543892, -90.633056640625, -1.58184524952542, 218, 22, 'PPL', 'P'),
(18486, 'Wall Springs', 28.101110458374, 0.49045690096524, -82.7719421386719, -1.44464291859006, 218, 12, 'PPL', 'P'),
(58110, 'Wall Street', 37.6124992370605, 0.656461951590562, -92.954719543457, -1.62236591130125, 218, 29, 'PPL', 'P'),
(206316, 'Wall Street Condominium', 40.7841682434082, 0.711818018534785, -111.893890380859, -1.95291680001161, 218, 52, 'PPL', 'P'),
(28892, 'Walla Walla', 39.2008285522461, 0.684183527746496, -88.1922225952148, -1.53924465893824, 218, 18, 'PPL', 'P'),
(209082, 'Walla Walla', 46.0647201538086, 0.803981035693749, -118.341941833496, -2.06545652819812, 218, 56, 'PPL', 'P'),
(69848, 'Walla Watta', 35.5852813720703, 0.621080325191232, -76.873893737793, -1.34170255455274, 218, 33, 'PPL', 'P'),
(721, 'Wallace', 34.3730583190918, 0.59992304164818, -89.7319412231445, -1.5661178185499, 218, 30, 'PPL', 'P'),
(6612, 'Wallace', 31.2094402313232, 0.544707489740971, -87.2183303833008, -1.52224703328081, 218, 2, 'PPL', 'P'),
(12608, 'Wallace', 33.6816711425781, 0.587856059011949, -94.3583297729492, -1.64686353122056, 218, 4, 'PPL', 'P'),
(18487, 'Wallace', 30.6772193908691, 0.535418483727316, -87.1800003051758, -1.52157804721498, 218, 12, 'PPL', 'P'),
(25783, 'Wallace', 32.1969413757324, 0.561942636078123, -83.4972229003906, -1.45730145588343, 218, 13, 'PPL', 'P'),
(31415, 'Wallace', 39.9863891601563, 0.697894146828497, -87.1483306884766, -1.52102530813073, 218, 19, 'PPL', 'P'),
(38728, 'Wallace', 38.1211090087891, 0.665338866715041, -84.6922225952148, -1.47815813511844, 218, 21, 'PPL', 'P'),
(43527, 'Wallace', 30.0430603027344, 0.524350319657919, -90.6672210693359, -1.58244153129349, 218, 22, 'PPL', 'P'),
(58111, 'Wallace', 39.5552787780762, 0.690369851221669, -94.8466720581055, -1.65538671197325, 218, 29, 'PPL', 'P'),
(69849, 'Wallace', 34.7355613708496, 0.606249913449881, -77.9955596923828, -1.36127931856786, 218, 33, 'PPL', 'P'),
(84186, 'Wallace', 34.7200012207031, 0.60597833759772, -79.841667175293, -1.39349997249034, 218, 48, 'PPL', 'P'),
(98881, 'Wallace', 32.5466690063477, 0.568046534717558, -95.9402770996094, -1.6744737206639, 218, 51, 'PPL', 'P'),
(107246, 'Wallace', 36.6527786254883, 0.639711667019372, -82.128059387207, -1.4334050445802, 218, 53, 'PPL', 'P'),
(111901, 'Wallace', 38.4588890075684, 0.671234239841122, -81.6619415283203, -1.42526975324028, 218, 58, 'PPL', 'P'),
(118243, 'Wallace', 43.2700004577637, 0.75520397532743, -95.3288879394531, -1.66380296680817, 218, 16, 'PPL', 'P'),
(133565, 'Wallace', 45.3261108398438, 0.791089871279166, -87.6138916015625, -1.52915087893267, 218, 27, 'PPL', 'P'),
(153435, 'Wallace', 42.4411087036133, 0.740737085074874, -77.4591674804688, -1.3519175083879, 218, 40, 'PPL', 'P'),
(168433, 'Wallace', 40.0883293151855, 0.699673338173751, -75.7447204589844, -1.32199476301199, 218, 45, 'PPL', 'P'),
(171536, 'Wallace', 45.086109161377, 0.786901051779607, -97.4755630493164, -1.7012695154459, 218, 49, 'PPL', 'P'),
(186000, 'Wallace', 38.1941719055176, 0.666614054823998, -120.976936340332, -2.11144585811437, 218, 6, 'PPL', 'P'),
(187947, 'Wallace', 38.9113883972168, 0.679131844053752, -101.591110229492, -1.77309936426113, 218, 20, 'PPL', 'P'),
(195769, 'Wallace', 47.4741706848145, 0.828580588103783, -115.926940917969, -2.02330681078349, 218, 17, 'PPL', 'P'),
(199756, 'Wallace', 40.8383293151855, 0.712763307563709, -101.164436340332, -1.765652500063, 218, 35, 'PPL', 'P'),
(206317, 'Wallace', 41.2172203063965, 0.719376202866485, -111.946113586426, -1.95382826689469, 218, 52, 'PPL', 'P'),
(25784, 'Wallace (historical)', 33.8052787780762, 0.590013419231995, -84.336669921875, -1.47195257030439, 218, 13, 'PPL', 'P'),
(190892, 'Wallace (historical)', 35.5138893127441, 0.619834298696211, -114.768890380859, -2.00309501600645, 218, 39, 'PPL', 'P'),
(201740, 'Wallace (historical)', 43.6527786254883, 0.761884714658975, -123.087501525879, -2.14828216968013, 218, 43, 'PPL', 'P'),
(91612, 'Wallace Acres', 35.4608306884766, 0.618908251006164, -86.7794418334961, -1.51458698303741, 218, 50, 'PPL', 'P'),
(186001, 'Wallace Center', 35.1697196960449, 0.613827405699483, -119.464721679688, -2.0850527332892, 218, 6, 'PPL', 'P'),
(168437, 'Wallace City', 40.6769409179688, 0.709946548657759, -80.1900024414063, -1.39957956978483, 218, 45, 'PPL', 'P'),
(168435, 'Wallace Corners', 41.3525009155273, 0.721737294909922, -79.9880599975586, -1.39605500924016, 218, 45, 'PPL', 'P'),
(62197, 'Wallace Creek', 34.1602783203125, 0.596209330087091, -89.892219543457, -1.56891520295892, 218, 30, 'PPL', 'P'),
(84189, 'Wallace Crossroads', 34.202220916748, 0.596941366491727, -79.915283203125, -1.39478481455825, 218, 48, 'PPL', 'P'),
(52467, 'Wallace Estates', 38.7513885498047, 0.676339319913722, -76.7972183227539, -1.34036431610497, 218, 25, 'PPL', 'P'),
(158145, 'Wallace Heights', 40.4580612182617, 0.706126377232095, -80.629997253418, -1.40725892794613, 218, 41, 'PPL', 'P'),
(206325, 'Wallace Heights', 40.5791702270508, 0.708240128189291, -111.89582824707, -1.95295062215745, 218, 52, 'PPL', 'P'),
(31416, 'Wallace Junction', 39.4636116027832, 0.688769957196804, -86.726936340332, -1.51367058930632, 218, 19, 'PPL', 'P'),
(168436, 'Wallace Junction', 42.0133285522461, 0.733270912958837, -80.3197174072266, -1.40184352302751, 218, 45, 'PPL', 'P'),
(43528, 'Wallace Landing', 30.4058303833008, 0.530681851991528, -90.2624969482422, -1.57537776281816, 218, 22, 'PPL', 'P'),
(206319, 'Wallace Lane Condominium', 40.665828704834, 0.709752603951374, -111.805282592773, -1.9513703023666, 218, 52, 'PPL', 'P'),
(69852, 'Wallace Mill', 36.5341682434082, 0.637641525325026, -79.3522186279297, -1.38495748381975, 218, 33, 'PPL', 'P'),
(146540, 'Wallace Mill', 40.1072196960449, 0.700003037516703, -74.6311111450195, -1.30255861390243, 218, 37, 'PPL', 'P'),
(74678, 'Wallace Mills', 38.8583297729492, 0.678205796363704, -82.7972183227539, -1.44508407122463, 218, 41, 'PPL', 'P'),
(172685, 'Wallace Pond', 45.0091705322266, 0.785558219378962, -71.6208267211914, -1.25001923928512, 218, 55, 'PPL', 'P'),
(43529, 'Wallace Ridge', 31.7094402313232, 0.553434136000943, -91.8272171020508, -1.60268728137443, 218, 22, 'PPL', 'P'),
(69853, 'Wallace Store (historical)', 35.4011116027832, 0.617865956334534, -80.7624969482422, -1.4095714838787, 218, 33, 'PPL', 'P'),
(187508, 'Wallace Village', 39.8833312988281, 0.696095447828257, -105.092216491699, -1.83420519599884, 218, 7, 'PPL', 'P'),
(12613, 'Wallaceburg', 33.8930587768555, 0.59154546922809, -93.5472183227539, -1.63270696581402, 218, 4, 'PPL', 'P'),
(107247, 'Wallaces Corner', 38.371940612793, 0.669716704072968, -77.5022201538086, -1.35266891928947, 218, 53, 'PPL', 'P'),
(38729, 'Wallaceton', 37.5680618286133, 0.655686372502103, -84.3622207641602, -1.47239851662892, 218, 21, 'PPL', 'P'),
(107248, 'Wallaceton', 36.6144409179688, 0.63904254779549, -76.3791732788086, -1.33306805366648, 218, 53, 'PPL', 'P'),
(168439, 'Wallaceton', 40.9597206115723, 0.714881985368921, -78.2891693115234, -1.36640377313739, 218, 45, 'PPL', 'P'),
(25785, 'Wallaceville', 34.8977813720703, 0.609081186583771, -85.3188934326172, -1.48909560455734, 218, 13, 'PPL', 'P'),
(84187, 'Wallaceville', 34.2119407653809, 0.597111009853165, -81.2527770996094, -1.41812848677723, 218, 48, 'PPL', 'P'),
(168441, 'Wallaceville', 41.5625, 0.725402470360143, -79.8027801513672, -1.39282126588654, 218, 45, 'PPL', 'P'),
(129171, 'Wallagrass', 47.1294403076172, 0.822563907990049, -68.5977783203125, -1.19725709124264, 218, 26, 'PPL', 'P'),
(91613, 'Walland', 35.7280616760254, 0.623572311602247, -83.8133316040039, -1.46281859355569, 218, 50, 'PPL', 'P'),
(111902, 'Wallback', 38.565559387207, 0.673095989180169, -81.1305618286133, -1.41599542790213, 218, 58, 'PPL', 'P'),
(69854, 'Wallburg', 36.0099983215332, 0.628493034348386, -80.1394424438477, -1.39869713135763, 218, 33, 'PPL', 'P'),
(133566, 'Walled Lake', 42.5377807617188, 0.742424330783494, -83.4811096191406, -1.45702022607231, 218, 27, 'PPL', 'P'),
(123908, 'Wallen', 41.1611099243164, 0.718396891954635, -85.1661071777344, -1.48642898135784, 218, 19, 'PPL', 'P'),
(168442, 'Wallenpaupack Mills', 41.3863906860352, 0.722328782988028, -75.4280624389648, -1.3164680379598, 218, 45, 'PPL', 'P'),
(43530, 'Waller', 32.5163917541504, 0.567518096978259, -93.6997222900391, -1.6353686621655, 218, 22, 'PPL', 'P'),
(98882, 'Waller', 30.0563907623291, 0.524582980068651, -95.9266662597656, -1.67423616669466, 218, 51, 'PPL', 'P'),
(168443, 'Waller', 41.2324981689453, 0.719642851870629, -76.4236068725586, -1.33384356617591, 218, 45, 'PPL', 'P'),
(209084, 'Waller', 47.2008285522461, 0.823809867906043, -122.368057250977, -2.13572549829846, 218, 56, 'PPL', 'P'),
(43531, 'Waller Landing', 32.041389465332, 0.559227743083869, -91.6269378662109, -1.59919174928565, 218, 22, 'PPL', 'P'),
(107249, 'Wallers Corner', 38.079719543457, 0.664616484269357, -77.5408325195313, -1.35334283220331, 218, 53, 'PPL', 'P'),
(62198, 'Wallerville', 34.4416694641113, 0.601120532032334, -88.9458312988281, -1.55239761208798, 218, 30, 'PPL', 'P'),
(6613, 'Walley', 31.184440612793, 0.544271164085875, -88.4250030517578, -1.54330744433921, 218, 2, 'PPL', 'P'),
(168444, 'Walley Mill', 41.0436096191406, 0.71634612475722, -79.7772216796875, -1.39237518640395, 218, 45, 'PPL', 'P'),
(190893, 'Walleys Hot Springs', 38.9811096191406, 0.680348708934837, -119.83332824707, -2.0914861315345, 218, 39, 'PPL', 'P'),
(62199, 'Wallfield', 34.1091690063477, 0.595317304279969, -89.0269393920898, -1.55381321536541, 218, 30, 'PPL', 'P'),
(62200, 'Wallhill', 34.7144393920898, 0.605881265375987, -89.7038879394531, -1.56562819638349, 218, 30, 'PPL', 'P'),
(118244, 'Wallin', 41.060001373291, 0.716632214837322, -95.0558319091797, -1.65903724003747, 218, 16, 'PPL', 'P'),
(133568, 'Wallin', 44.5708312988281, 0.777907756515491, -85.8888931274414, -1.49904397596738, 218, 27, 'PPL', 'P'),
(91614, 'Walling', 35.8080596923828, 0.624968540382748, -85.5994415283203, -1.49399209253756, 218, 50, 'PPL', 'P'),
(158146, 'Walling Corners', 41.3455581665039, 0.721616121080323, -81.6847229003906, -1.42566736319103, 218, 41, 'PPL', 'P'),
(84188, 'Walling Grove', 32.4922218322754, 0.56709625226159, -80.6577835083008, -1.40774388958063, 218, 48, 'PPL', 'P'),
(38730, 'Wallingford', 38.4049987792969, 0.670293677923134, -83.6122207641602, -1.45930854723896, 218, 21, 'PPL', 'P'),
(79331, 'Wallingford', 39.8908309936523, 0.696226342195835, -75.3633270263672, -1.31533819186733, 218, 45, 'PPL', 'P'),
(114211, 'Wallingford', 41.4569396972656, 0.723560095518026, -72.8236083984375, -1.27101173973573, 218, 8, 'PPL', 'P'),
(118245, 'Wallingford', 43.3197212219238, 0.756071766368632, -94.7925033569336, -1.65444128978627, 218, 16, 'PPL', 'P'),
(121838, 'Wallingford', 41.3716697692871, 0.722071854521863, -87.9438934326172, -1.53491049742219, 218, 18, 'PPL', 'P'),
(172686, 'Wallingford', 43.4716682434082, 0.758723742182133, -72.977783203125, -1.27370259770115, 218, 55, 'PPL', 'P'),
(209089, 'Wallingford', 47.6558303833008, 0.83175114796055, -122.326393127441, -2.13499832216282, 218, 56, 'PPL', 'P'),
(146541, 'Wallington', 40.8530616760254, 0.713020435766956, -74.1141662597656, -1.2935362236034, 218, 37, 'PPL', 'P'),
(153436, 'Wallington', 43.2216682434082, 0.754360419052147, -77.0127792358398, -1.34412656377693, 218, 40, 'PPL', 'P'),
(153437, 'Wallins Corners', 42.9719390869141, 0.750001823033096, -74.1705627441406, -1.29452052794229, 218, 40, 'PPL', 'P'),
(38731, 'Wallins Creek', 36.8311080932617, 0.642824103385348, -83.4169387817383, -1.45590023367588, 218, 21, 'PPL', 'P'),
(62201, 'Wallis', 31.1552791595459, 0.543762200712048, -89.2383270263672, -1.55750262558155, 218, 30, 'PPL', 'P'),
(112604, 'Wallis', 29.6311092376709, 0.517160417215464, -96.0650024414063, -1.67665058853893, 218, 51, 'PPL', 'P'),
(168445, 'Wallis Run', 41.417781829834, 0.722876661803285, -76.8594436645508, -1.34145035319751, 218, 45, 'PPL', 'P'),
(144593, 'Wallis Sands', 43.0238914489746, 0.750908562805241, -70.732780456543, -1.23451990805697, 218, 36, 'PPL', 'P'),
(98884, 'Wallisville', 29.8352794647217, 0.520723859912045, -94.7416687011719, -1.65355405766911, 218, 51, 'PPL', 'P'),
(153438, 'Wallkill', 41.6055603027344, 0.726154014419764, -74.184440612793, -1.29476274244344, 218, 40, 'PPL', 'P'),
(153439, 'Wallkill Camp', 41.7161102294922, 0.728083474629526, -74.1624984741211, -1.29437977987868, 218, 40, 'PPL', 'P'),
(52468, 'Wallman', 39.3169403076172, 0.686210060177992, -79.2841720581055, -1.38376984713163, 218, 25, 'PPL', 'P'),
(209085, 'Wallner', 47.2649993896484, 0.824929860302476, -117.059440612793, -2.04307265923601, 218, 56, 'PPL', 'P'),
(168449, 'Wallner (historical)', 40.5777816772461, 0.708215893423371, -75.6563873291016, -1.32045305905694, 218, 45, 'PPL', 'P'),
(38732, 'Wallonia', 36.9444389343262, 0.644802099705977, -87.783332824707, -1.53210818616515, 218, 21, 'PPL', 'P'),
(153441, 'Walloomsac', 42.9241714477539, 0.749168120453847, -73.3241729736328, -1.27974823969173, 218, 40, 'PPL', 'P'),
(133569, 'Walloon Lake', 45.2661094665527, 0.790042649759519, -84.9336090087891, -1.48237112280489, 218, 27, 'PPL', 'P'),
(74679, 'Wallopsburg', 39.3541717529297, 0.686859871483971, -83.7594375610352, -1.46187796505867, 218, 41, 'PPL', 'P'),
(193219, 'Wallowa', 45.5702781677246, 0.795351395076483, -117.527221679688, -2.05123697903181, 218, 43, 'PPL', 'P'),
(146543, 'Wallpack Center', 41.1588897705078, 0.718358142960775, -74.8805618286133, -1.30691234965249, 218, 37, 'PPL', 'P'),
(43532, 'Walls', 30.5869407653809, 0.53384282446837, -91.3261108398438, -1.59394132719656, 218, 22, 'PPL', 'P'),
(62202, 'Walls', 34.9577789306641, 0.61012834152439, -90.1516723632813, -1.57344350891844, 218, 30, 'PPL', 'P'),
(77577, 'Walls', 35.0369415283203, 0.611509989497924, -94.9088897705078, -1.65647261590773, 218, 42, 'PPL', 'P'),
(168446, 'Walls Corners', 41.538890838623, 0.724990412760481, -75.7888870239258, -1.32276561498951, 218, 45, 'PPL', 'P'),
(25788, 'Walls Crossing', 32.2536087036133, 0.562931667527952, -84.3705596923828, -1.47254405838249, 218, 13, 'PPL', 'P'),
(69855, 'Walls Landing', 34.9672203063965, 0.610293124616839, -79.8652801513672, -1.39391209666903, 218, 33, 'PPL', 'P'),
(6614, 'Wallsboro', 32.586669921875, 0.568744682397322, -86.2091674804688, -1.5046338179374, 218, 2, 'PPL', 'P'),
(206320, 'Wallsburg', 40.3877792358398, 0.704899725234005, -111.421669006348, -1.94467498222809, 218, 52, 'PPL', 'P'),
(38733, 'Wallsend', 36.7661094665527, 0.641689663340001, -83.7099990844727, -1.46101510086549, 218, 21, 'PPL', 'P'),
(25786, 'Wallston', 32.6194381713867, 0.569316596241417, -83.5999984741211, -1.45909522803565, 218, 13, 'PPL', 'P'),
(6615, 'Wallstown', 33.8983306884766, 0.591637481443752, -86.7005615234375, -1.5132102619119, 218, 2, 'PPL', 'P'),
(194464, 'Wallstreet', 40.038890838623, 0.698810473980566, -105.390281677246, -1.8394074148722, 218, 7, 'PPL', 'P'),
(168447, 'Wallsville', 41.5755615234375, 0.725630436949454, -75.7119369506836, -1.32142258285178, 218, 45, 'PPL', 'P'),
(38734, 'Walltown', 37.3222198486328, 0.651395620511822, -84.7316665649414, -1.47884656226022, 218, 21, 'PPL', 'P'),
(168448, 'Walltown', 40.9647216796875, 0.714969270473649, -78.6430587768555, -1.37258030949555, 218, 45, 'PPL', 'P'),
(186002, 'Walltown', 38.5741691589355, 0.673246258044677, -121.102783203125, -2.11364230022342, 218, 6, 'PPL', 'P'),
(34307, 'Wallula', 39.1725006103516, 0.683689111890123, -94.9002838134766, -1.65632241362225, 218, 20, 'PPL', 'P'),
(209086, 'Wallula', 46.0855598449707, 0.804344756919626, -118.904167175293, -2.07526921155063, 218, 56, 'PPL', 'P'),
(209087, 'Wallula Junction', 46.0586090087891, 0.803874376092091, -118.90860748291, -2.07534670953835, 218, 56, 'PPL', 'P'),
(169648, 'Wallum Lake (historical)', 41.9991683959961, 0.733023771609677, -71.7611083984375, -1.25246761643329, 218, 47, 'PPL', 'P'),
(197788, 'Wallview (historical)', 46.7638893127441, 0.816183839545574, -108.465278625488, -1.8930762361078, 218, 31, 'PPL', 'P'),
(52469, 'Wallville', 38.4152793884277, 0.670473108401578, -76.5055618286133, -1.3352739499974, 218, 25, 'PPL', 'P'),
(77578, 'Wallville', 34.7680587768555, 0.60681710018304, -97.5036087036133, -1.70175900445425, 218, 42, 'PPL', 'P'),
(52470, 'Wallville Acres', 38.4494400024414, 0.671069323590619, -76.5261077880859, -1.33563254463817, 218, 25, 'PPL', 'P'),
(168450, 'Walmo', 41.0363883972168, 0.716220090658632, -80.3561096191406, -1.40247868694749, 218, 45, 'PPL', 'P'),
(153442, 'Walmore', 43.1213912963867, 0.752610256162774, -78.9313888549805, -1.37761261869137, 218, 40, 'PPL', 'P'),
(186003, 'Walmort', 38.3805618286133, 0.669867172674557, -121.243057250977, -2.11609054421353, 218, 6, 'PPL', 'P'),
(107250, 'Walmsley', 37.9411087036133, 0.662197268735129, -76.5355606079102, -1.33579752746771, 218, 53, 'PPL', 'P'),
(107252, 'Walmsley (historical)', 38.524169921875, 0.672373606734485, -77.4830627441406, -1.35233455941461, 218, 53, 'PPL', 'P'),
(146544, 'Walnford', 40.1344413757324, 0.700478145455173, -74.5602798461914, -1.30132237452441, 218, 37, 'PPL', 'P'),
(12616, 'Walnut', 35.7905616760254, 0.624663142384743, -93.3591690063477, -1.62942488608661, 218, 4, 'PPL', 'P'),
(34308, 'Walnut', 37.601390838623, 0.656268073463204, -95.0777816772461, -1.65942033576028, 218, 20, 'PPL', 'P'),
(52471, 'Walnut', 38.3191719055176, 0.668795716388991, -75.6641693115234, -1.32058888027254, 218, 25, 'PPL', 'P'),
(58114, 'Walnut', 39.9902801513672, 0.697962057436294, -92.7180633544922, -1.61823548160859, 218, 29, 'PPL', 'P'),
(62204, 'Walnut', 34.9461097717285, 0.609924676280027, -88.8997192382813, -1.55159280480655, 218, 30, 'PPL', 'P'),
(69856, 'Walnut', 35.8494415283203, 0.625690789670378, -82.7388916015625, -1.44406607789795, 218, 33, 'PPL', 'P'),
(74680, 'Walnut', 39.7094383239746, 0.693060442870976, -82.851936340332, -1.44603908079154, 218, 41, 'PPL', 'P'),
(111904, 'Walnut', 38.4230613708496, 0.670608929617172, -80.0741729736328, -1.39755796420135, 218, 58, 'PPL', 'P'),
(118246, 'Walnut', 41.4775009155273, 0.723918956474915, -95.2216720581055, -1.66193169666823, 218, 16, 'PPL', 'P'),
(121840, 'Walnut', 40.4838905334473, 0.706577183825618, -89.3713912963867, -1.55982503521015, 218, 18, 'PPL', 'P'),
(123909, 'Walnut', 41.1761093139648, 0.71865868068979, -86.2119369506836, -1.50468215431119, 218, 19, 'PPL', 'P'),
(143300, 'Walnut', 42.5494384765625, 0.742627796290776, -98.208610534668, -1.71406360763874, 218, 35, 'PPL', 'P'),
(168451, 'Walnut', 40.5247192382813, 0.707289779154296, -77.4897232055664, -1.35245080639619, 218, 45, 'PPL', 'P'),
(186004, 'Walnut', 34.0202789306641, 0.593765879786944, -117.864440917969, -2.05712256504088, 218, 6, 'PPL', 'P'),
(25787, 'Walnut (historical)', 34.6722183227539, 0.605144368702362, -83.9225006103516, -1.46472395215759, 218, 13, 'PPL', 'P'),
(91615, 'Walnut Acres', 35.9766693115234, 0.627911333387286, -86.898063659668, -1.51665732446884, 218, 50, 'PPL', 'P'),
(114213, 'Walnut Beach', 41.1930618286133, 0.718954557886898, -73.083610534668, -1.27554963307517, 218, 8, 'PPL', 'P'),
(98885, 'Walnut Bend', 33.7787284851074, 0.589550029202321, -97.0643692016602, -1.69409282894035, 218, 51, 'PPL', 'P'),
(111905, 'Walnut Bottom', 39.1058311462402, 0.68252551023084, -79.0163879394531, -1.37909613257659, 218, 58, 'PPL', 'P'),
(168453, 'Walnut Bottom', 40.0894393920898, 0.699692712670682, -77.404167175293, -1.35095757197298, 218, 45, 'PPL', 'P'),
(118247, 'Walnut City', 40.8122215270996, 0.712307640701196, -92.9447174072266, -1.62219134109179, 218, 16, 'PPL', 'P'),
(12620, 'Walnut Corner', 36.0402793884277, 0.629021538666712, -90.7755584716797, -1.58433237566744, 218, 4, 'PPL', 'P'),
(123910, 'Walnut Corners', 41.1327781677246, 0.717902409519235, -85.4963912963867, -1.49219352669537, 218, 19, 'PPL', 'P'),
(52472, 'Walnut Cove', 38.4436111450195, 0.670967590836978, -76.4755630493164, -1.33475037252709, 218, 25, 'PPL', 'P'),
(69857, 'Walnut Cove', 36.295280456543, 0.633472146901426, -80.1419372558594, -1.39874067404146, 218, 33, 'PPL', 'P'),
(25789, 'Walnut Creek', 33.4747200012207, 0.584244080204501, -84.3574981689453, -1.47231609179318, 218, 13, 'PPL', 'P'),
(62205, 'Walnut Creek', 34.8063888549805, 0.607486086248868, -88.8897171020508, -1.5514182345971, 218, 30, 'PPL', 'P'),
(69865, 'Walnut Creek', 35.3069381713867, 0.616222319888764, -77.8652801513672, -1.35900551162915, 218, 33, 'PPL', 'P'),
(84190, 'Walnut Creek', 33.9283294677734, 0.592161058914062, -81.2152786254883, -1.41747401493935, 218, 48, 'PPL', 'P'),
(158147, 'Walnut Creek', 40.541389465332, 0.707580729503387, -81.7219390869141, -1.4263169081809, 218, 41, 'PPL', 'P'),
(186005, 'Walnut Creek', 37.9063911437988, 0.661591333008109, -122.063888549805, -2.1304167529815, 218, 6, 'PPL', 'P'),
(38735, 'Walnut Flat', 37.4952812194824, 0.654416111241163, -84.5788879394531, -1.47618007221878, 218, 21, 'PPL', 'P'),
(98886, 'Walnut Forest', 30.3827800750732, 0.530279548219358, -97.67138671875, -1.70468728323085, 218, 51, 'PPL', 'P'),
(123912, 'Walnut Gardens', 40.6988906860352, 0.710329644380567, -86.7544403076172, -1.5141506240928, 218, 19, 'PPL', 'P'),
(6618, 'Walnut Grove', 34.9425010681152, 0.609861692520246, -86.4958267211914, -1.50963696551928, 218, 2, 'PPL', 'P'),
(12628, 'Walnut Grove', 36.3713912963867, 0.634800531653157, -90.5247192382813, -1.57995440515146, 218, 4, 'PPL', 'P'),
(25791, 'Walnut Grove', 33.7425003051758, 0.588917728180509, -83.8525009155273, -1.46350222700751, 218, 13, 'PPL', 'P'),
(38737, 'Walnut Grove', 37.271671295166, 0.650513381821706, -84.4508285522461, -1.47394501427393, 218, 21, 'PPL', 'P'),
(52473, 'Walnut Grove', 39.6983299255371, 0.692866564743618, -77.1716690063477, -1.34689971342003, 218, 25, 'PPL', 'P'),
(58116, 'Walnut Grove', 37.4111099243164, 0.652947045004848, -93.5494384765625, -1.63274571480788, 218, 29, 'PPL', 'P'),
(62207, 'Walnut Grove', 32.5902786254883, 0.568807666157102, -89.4583282470703, -1.56134237124122, 218, 30, 'PPL', 'P'),
(84198, 'Walnut Grove', 34.7941703796387, 0.60727283362458, -81.9141693115234, -1.42967195852218, 218, 48, 'PPL', 'P'),
(91629, 'Walnut Grove', 36.0347213745117, 0.628924533024006, -85.4930572509766, -1.49213533662555, 218, 50, 'PPL', 'P'),
(98888, 'Walnut Grove', 32.1763916015625, 0.561583974858317, -95.2555618286133, -1.66252318474633, 218, 51, 'PPL', 'P'),
(107255, 'Walnut Grove', 36.7069396972656, 0.640656956048296, -82.251106262207, -1.43555261768324, 218, 53, 'PPL', 'P'),
(111906, 'Walnut Grove', 38.7350006103516, 0.676053296412648, -81.3027801513672, -1.41900120466645, 218, 58, 'PPL', 'P'),
(118248, 'Walnut Grove', 41.4702796936035, 0.723792922376327, -90.6611099243164, -1.58233487169183, 218, 16, 'PPL', 'P'),
(121842, 'Walnut Grove', 41.1766700744629, 0.718668467806796, -89.3608322143555, -1.55964074446272, 218, 18, 'PPL', 'P'),
(123949, 'Walnut Grove', 40.1619415283203, 0.700958113662633, -85.9397201538086, -1.49993107492649, 218, 19, 'PPL', 'P'),
(138647, 'Walnut Grove', 44.2230606079102, 0.771838012917037, -95.4691696166992, -1.66625134395633, 218, 28, 'PPL', 'P'),
(158150, 'Walnut Grove', 40.4272193908691, 0.705588085796763, -83.6233291625977, -1.45950242536632, 218, 41, 'PPL', 'P'),
(168455, 'Walnut Grove', 40.457218170166, 0.706111663267073, -77.2600021362305, -1.34844141737507, 218, 45, 'PPL', 'P'),
(179476, 'Walnut Grove', 34.2830581665039, 0.598352242658224, -112.547782897949, -1.96432937738898, 218, 5, 'PPL', 'P'),
(186006, 'Walnut Grove', 38.2422218322754, 0.667452684251264, -121.510559082031, -2.12075933192054, 218, 6, 'PPL', 'P'),
(206322, 'Walnut Grove', 40.6133308410645, 0.708836343378333, -111.8125, -1.95149626988616, 218, 52, 'PPL', 'P'),
(209088, 'Walnut Grove', 45.6680603027344, 0.797058015282033, -122.597778320313, -2.13973488731958, 218, 56, 'PPL', 'P'),
(91630, 'Walnut Grove (historical)', 35.0152816772461, 0.611131953781187, -88.1811065673828, -1.53905064765283, 218, 50, 'PPL', 'P'),
(12629, 'Walnut Grove Corner', 35.627498626709, 0.62181715528583, -90.6175003051758, -1.58157374025228, 218, 4, 'PPL', 'P'),
(52474, 'Walnut Grove Mills', 39.5086097717285, 0.689555323402268, -76.9297180175781, -1.34267687203754, 218, 25, 'PPL', 'P'),
(107258, 'Walnut Heights', 36.7027816772461, 0.640584384908591, -77.5680618286133, -1.35381807329984, 218, 53, 'PPL', 'P'),
(186007, 'Walnut Heights', 37.8766708374023, 0.661072615806789, -122.050003051758, -2.1301744053223, 218, 6, 'PPL', 'P'),
(6620, 'Walnut Hill', 32.7099990844727, 0.570897182348379, -85.7855606079102, -1.49724048327718, 218, 2, 'PPL', 'P'),
(12631, 'Walnut Hill', 33.1097183227539, 0.57787359913995, -93.6838912963867, -1.63509235920241, 218, 4, 'PPL', 'P'),
(14791, 'Walnut Hill', 39.7986106872559, 0.694616794212018, -75.6944427490234, -1.32111725143281, 218, 10, 'PPL', 'P'),
(18488, 'Walnut Hill', 30.8852806091309, 0.539049837031693, -87.5100021362305, -1.52733766570449, 218, 12, 'PPL', 'P'),
(28893, 'Walnut Hill', 38.4772186279297, 0.671554152067068, -89.043327331543, -1.55409923886648, 218, 18, 'PPL', 'P'),
(38740, 'Walnut Hill', 38.0111083984375, 0.663418993885203, -84.3874969482422, -1.47283966926349, 218, 21, 'PPL', 'P'),
(43533, 'Walnut Hill', 31.1966705322266, 0.544484616447245, -93.091667175293, -1.62475609837959, 218, 22, 'PPL', 'P'),
(52476, 'Walnut Hill', 39.1297187805176, 0.682942428099492, -77.1805572509766, -1.34705484255352, 218, 25, 'PPL', 'P'),
(84192, 'Walnut Hill', 32.4680595397949, 0.566674540702976, -80.6433334350586, -1.4074916882254, 218, 48, 'PPL', 'P'),
(91633, 'Walnut Hill', 36.5697212219238, 0.638262041859015, -82.2569427490234, -1.43565448359493, 218, 50, 'PPL', 'P'),
(107259, 'Walnut Hill', 37.2002792358398, 0.649267355326685, -77.392219543457, -1.35074904645963, 218, 53, 'PPL', 'P'),
(111907, 'Walnut Hill', 37.8236083984375, 0.660146501537714, -82.0294418334961, -1.43168384356768, 218, 58, 'PPL', 'P'),
(126422, 'Walnut Hill', 42.4958305358887, 0.741692161220804, -71.1291732788086, -1.24143826793678, 218, 23, 'PPL', 'P'),
(129173, 'Walnut Hill', 43.2372207641602, 0.754631861746253, -70.5950012207031, -1.23211520675069, 218, 26, 'PPL', 'P'),
(168457, 'Walnut Hill', 40.0969390869141, 0.699823607038259, -75.0783309936523, -1.31036407274134, 218, 45, 'PPL', 'P'),
(25792, 'Walnut Hill (historical)', 34.3536109924316, 0.599583621767249, -83.336669921875, -1.45449927778444, 218, 13, 'PPL', 'P'),
(158151, 'Walnut Hill (historical)', 41.2458305358887, 0.719875545570875, -80.522216796875, -1.40537780411015, 218, 41, 'PPL', 'P'),
(91634, 'Walnut Hill Estates', 35.6888885498047, 0.622888611571396, -84.0147171020508, -1.46633343356238, 218, 50, 'PPL', 'P'),
(107260, 'Walnut Hill Estates', 36.7174987792969, 0.640841246795729, -76.5652770996094, -1.33631617809, 218, 53, 'PPL', 'P'),
(107261, 'Walnut Hill Gardens', 37.1949996948242, 0.649175209952969, -77.3819427490234, -1.35056968256021, 218, 53, 'PPL', 'P'),
(52477, 'Walnut Hills', 38.5125007629395, 0.672169941490122, -76.7719421386719, -1.3399231634704, 218, 25, 'PPL', 'P'),
(84193, 'Walnut Hills', 33.9494400024414, 0.592529507250874, -80.345832824707, -1.40229932304807, 218, 48, 'PPL', 'P'),
(91636, 'Walnut Hills', 35.961109161377, 0.627639757535125, -86.8544387817383, -1.51589592671319, 218, 50, 'PPL', 'P'),
(107262, 'Walnut Hills', 37.2619400024414, 0.650343538723187, -76.7283325195313, -1.33916203203086, 218, 53, 'PPL', 'P'),
(158152, 'Walnut Hills', 40.7813911437988, 0.711769549002946, -81.5008316040039, -1.42245785460332, 218, 41, 'PPL', 'P'),
(206324, 'Walnut Hills', 40.6408309936523, 0.709316311585792, -112.029998779297, -1.95529233970396, 218, 52, 'PPL', 'P'),
(52478, 'Walnut Hills Estates', 39.4500007629395, 0.688532403227568, -76.3977813720703, -1.33339282616142, 218, 25, 'PPL', 'P'),
(186008, 'Walnut Hills Mobile Home Park', 34.0444412231445, 0.594187591345558, -117.817497253418, -2.05630324353152, 218, 6, 'PPL', 'P'),
(69871, 'Walnut Island', 36.2402801513672, 0.632512210486506, -75.8763885498047, -1.32429280471662, 218, 33, 'PPL', 'P'),
(52479, 'Walnut Lake', 38.934440612793, 0.679534181115436, -76.478889465332, -1.33480842943885, 218, 25, 'PPL', 'P'),
(52481, 'Walnut Landing', 38.5302810668945, 0.672480266336143, -75.76611328125, -1.32236813819682, 218, 25, 'PPL', 'P'),
(43535, 'Walnut Lane (historical)', 32.6055603027344, 0.569074381740274, -92.3488922119141, -1.61179222966725, 218, 22, 'PPL', 'P'),
(172688, 'Walnut Ledge', 44.5999984741211, 0.77841681975786, -73.1975021362305, -1.2775374165128, 218, 55, 'PPL', 'P'),
(91639, 'Walnut Log', 36.4677810668945, 0.63648285051376, -89.315559387207, -1.55885058456729, 218, 50, 'PPL', 'P'),
(6621, 'Walnut Park', 34.0144386291504, 0.593663947296221, -86.0591735839844, -1.50201593058586, 218, 2, 'PPL', 'P'),
(74684, 'Walnut Park', 38.4094390869141, 0.670371175910855, -82.5202789306641, -1.44025056700419, 218, 41, 'PPL', 'P'),
(186009, 'Walnut Park', 33.9680595397949, 0.592854479482891, -118.224166870117, -2.06340096731074, 218, 6, 'PPL', 'P'),
(133570, 'Walnut Point', 42.3502807617188, 0.739151838436004, -84.9852828979492, -1.48327300230804, 218, 27, 'PPL', 'P'),
(107263, 'Walnut Point (historical)', 37.9847183227539, 0.662958400174674, -76.4638900756836, -1.33454664070369, 218, 53, 'PPL', 'P'),
(28894, 'Walnut Prairie', 39.2400016784668, 0.684867227777347, -87.6661071777344, -1.5300622126577, 218, 18, 'PPL', 'P'),
(12634, 'Walnut Ridge', 36.0683288574219, 0.629511094254096, -90.9558334350586, -1.58747876733732, 218, 4, 'PPL', 'P'),
(14792, 'Walnut Ridge', 39.8027801513672, 0.694689565088804, -75.6313934326172, -1.32001683327039, 218, 10, 'PPL', 'P'),
(31417, 'Walnut Ridge', 38.9249992370605, 0.679369398022987, -85.5561065673828, -1.49323575478797, 218, 19, 'PPL', 'P'),
(52483, 'Walnut Ridge', 39.5527801513672, 0.690326241958819, -76.9694366455078, -1.34337009286929, 218, 25, 'PPL', 'P'),
(91640, 'Walnut Ridge', 35.9777793884277, 0.627930707884216, -86.5977783203125, -1.51141635660162, 218, 50, 'PPL', 'P'),
(98889, 'Walnut Ridge', 33.7291717529297, 0.58868510105929, -95.3688888549805, -1.66450111448793, 218, 51, 'PPL', 'P'),
(186010, 'Walnut Ridge', 34.1333312988281, 0.595739015838583, -117.439437866211, -2.04970486245668, 218, 6, 'PPL', 'P'),
(58118, 'Walnut Shade', 36.7324981689453, 0.641103035530884, -93.1933288574219, -1.62653042945586, 218, 29, 'PPL', 'P'),
(91641, 'Walnut Shade', 36.5744400024414, 0.638344400115725, -85.8300018310547, -1.49801612894467, 218, 50, 'PPL', 'P'),
(52486, 'Walnut Shores', 38.9427795410156, 0.679679722869009, -76.2841720581055, -1.3314099695718, 218, 25, 'PPL', 'P'),
(12635, 'Walnut Springs', 33.9491691589355, 0.592524780139939, -94.2922210693359, -1.64570971667828, 218, 4, 'PPL', 'P'),
(52484, 'Walnut Springs', 39.6624984741211, 0.69224118794064, -76.5813903808594, -1.33659740790111, 218, 25, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(98891, 'Walnut Springs', 32.0574989318848, 0.559508906315955, -97.7491683959961, -1.70604482959652, 218, 51, 'PPL', 'P'),
(146545, 'Walnut Valley', 40.975830078125, 0.715163148601007, -75.023063659668, -1.30939947579451, 218, 37, 'PPL', 'P'),
(52485, 'Walnut Woods', 39.0513916015625, 0.681575360932927, -77.1488876342773, -1.34650210346928, 218, 25, 'PPL', 'P'),
(168458, 'Walnutport', 40.7541694641113, 0.711294441064476, -75.5991668701172, -1.31945437364816, 218, 45, 'PPL', 'P'),
(168461, 'Walnuttown', 40.4494400024414, 0.705975908630506, -75.8430633544922, -1.32371117033454, 218, 45, 'PPL', 'P'),
(186011, 'Walong', 35.1974983215332, 0.614312234175932, -118.53694152832, -2.06885991491319, 218, 6, 'PPL', 'P'),
(111909, 'Walpers Cross-Roads', 39.3997192382813, 0.68765482506936, -77.871940612793, -1.35912175861073, 218, 58, 'PPL', 'P'),
(179477, 'Walpi', 35.832218170166, 0.625390185362335, -110.397216796875, -1.92679491814346, 218, 5, 'PPL', 'P'),
(28895, 'Walpole', 37.9366683959961, 0.662119770747408, -88.5547180175781, -1.54557139758188, 218, 18, 'PPL', 'P'),
(126423, 'Walpole', 42.1416702270508, 0.735510897751703, -71.25, -1.24354709204596, 218, 23, 'PPL', 'P'),
(129174, 'Walpole', 43.9558296203613, 0.767173952320954, -69.5591735839844, -1.21403660400679, 218, 26, 'PPL', 'P'),
(144590, 'Walpole', 43.0794410705566, 0.751878086600084, -72.4263916015625, -1.26407899878603, 218, 36, 'PPL', 'P'),
(126424, 'Walpole Heights', 42.1416702270508, 0.735510897751703, -71.2249984741211, -1.24311073310135, 218, 23, 'PPL', 'P'),
(43536, 'Walroy', 30.1972198486328, 0.527040911307226, -91.9986114501953, -1.60567867706886, 218, 22, 'PPL', 'P'),
(168462, 'Walsall', 40.2655601501465, 0.702766599779878, -78.8927764892578, -1.37693870577752, 218, 45, 'PPL', 'P'),
(34324, 'Walsburg', 39.3930587768555, 0.687538578087778, -96.811393737793, -1.68967757416911, 218, 20, 'PPL', 'P'),
(187509, 'Walsenburg', 37.6241683959961, 0.656665616834926, -104.779716491699, -1.82875104208635, 218, 7, 'PPL', 'P'),
(833, 'Walser', 39.9130592346191, 0.696614298187632, -82.3547210693359, -1.43736103722146, 218, 41, 'PPL', 'P'),
(69868, 'Walser', 35.7797203063965, 0.624473924789293, -80.1216735839844, -1.39838700624869, 218, 33, 'PPL', 'P'),
(199054, 'Walser Crossing', 46.6191711425781, 0.813658030988715, -103.595832824707, -1.80808837413676, 218, 34, 'PPL', 'P'),
(28899, 'Walsh', 38.0894393920898, 0.664786127630795, -89.850830078125, -1.56819282051324, 218, 18, 'PPL', 'P'),
(38741, 'Walsh', 38.6811103820801, 0.675112734494659, -82.9649963378906, -1.44801235000123, 218, 21, 'PPL', 'P'),
(43537, 'Walsh', 32.3708305358887, 0.564977574456378, -92.913330078125, -1.62164352885556, 218, 22, 'PPL', 'P'),
(62208, 'Walsh', 32.5711097717285, 0.568473106545161, -90.8394393920898, -1.5854473080578, 218, 30, 'PPL', 'P'),
(84194, 'Walsh', 32.4425010681152, 0.566228461220388, -80.7188873291016, -1.40881035243915, 218, 48, 'PPL', 'P'),
(133571, 'Walsh', 46.3455581665039, 0.80888258368004, -86.1841735839844, -1.50419759215085, 218, 27, 'PPL', 'P'),
(168463, 'Walsh', 41.1650009155273, 0.718464802562432, -78.6336135864258, -1.37241545982408, 218, 45, 'PPL', 'P'),
(176850, 'Walsh', 45.1794395446777, 0.788529974260354, -87.7624969482422, -1.5317445315183, 218, 57, 'PPL', 'P'),
(187510, 'Walsh', 37.3861083984375, 0.652510686060238, -102.277778625488, -1.78508398864065, 218, 7, 'PPL', 'P'),
(69869, 'Walsh (historical)', 36.2636108398438, 0.632919407817179, -81.3863906860352, -1.42046048378576, 218, 33, 'PPL', 'P'),
(186012, 'Walsh Landing', 38.5555610656738, 0.672921485549742, -123.299438476563, -2.1519811672762, 218, 6, 'PPL', 'P'),
(186013, 'Walsh Station', 38.5288887023926, 0.672455964991196, -121.333610534668, -2.11767099716243, 218, 6, 'PPL', 'P'),
(28897, 'Walshville', 39.0708312988281, 0.681914647655803, -89.6188888549805, -1.56414468249826, 218, 18, 'PPL', 'P'),
(18489, 'Walsingham', 27.8769397735596, 0.486544384428777, -82.7977828979492, -1.44509392492067, 218, 12, 'PPL', 'P'),
(52487, 'Walston', 38.3852806091309, 0.669949530931268, -75.5052795410156, -1.31781573062944, 218, 25, 'PPL', 'P'),
(168464, 'Walston', 40.9650001525879, 0.714974130742638, -78.995002746582, -1.37872289054982, 218, 45, 'PPL', 'P'),
(98892, 'Walston Farms Colonia', 26.1900005340576, 0.457101740418379, -98.0670013427734, -1.7115920609891, 218, 51, 'PPL', 'P'),
(52490, 'Walston Switch', 38.3869400024414, 0.669978492808123, -75.501106262207, -1.31774289317362, 218, 25, 'PPL', 'P'),
(69870, 'Walstonburg', 35.5944404602051, 0.621240181435664, -77.6972198486328, -1.35607230600453, 218, 33, 'PPL', 'P'),
(107264, 'Waltdon Farms', 37.2224998474121, 0.649655178160428, -80.0472183227539, -1.39708751679479, 218, 53, 'PPL', 'P'),
(6622, 'Walter', 34.1186103820801, 0.595482087372418, -86.6769409179688, -1.51279800457515, 218, 2, 'PPL', 'P'),
(168465, 'Walter Chapel', 40.5894393920898, 0.708419358930653, -79.8266677856445, -1.39323818375519, 218, 45, 'PPL', 'P'),
(91642, 'Walter Crossroad', 36.1166687011719, 0.630354783687433, -82.966667175293, -1.44804151161517, 218, 50, 'PPL', 'P'),
(18490, 'Walter Hamilton Place', 25.5580596923828, 0.446072292053329, -81.1719436645508, -1.41671767718976, 218, 12, 'PPL', 'P'),
(107265, 'Walter Heights', 38.9455604553223, 0.679728258979876, -77.1661071777344, -1.34680264119829, 218, 53, 'PPL', 'P'),
(91643, 'Walter Hill Estates', 35.9555587768555, 0.627542885050473, -86.3797225952148, -1.50761056624584, 218, 50, 'PPL', 'P'),
(186014, 'Walter Springs', 38.6536102294922, 0.6746327662872, -122.356941223145, -2.13553148701305, 218, 6, 'PPL', 'P'),
(84195, 'Walterboro', 32.9049987792969, 0.574300569063445, -80.6669387817383, -1.40790367924604, 218, 48, 'PPL', 'P'),
(91644, 'Walterhill', 35.9500007629395, 0.627445879407767, -86.3777770996094, -1.50757661094194, 218, 50, 'PPL', 'P'),
(177692, 'Walteria', 33.8050003051758, 0.590008558963005, -118.350280761719, -2.06560206995169, 218, 6, 'PPL', 'P'),
(12640, 'Walters', 35.8736114501953, 0.626112634387046, -90.2772216796875, -1.57563475786335, 218, 4, 'PPL', 'P'),
(43538, 'Walters', 31.5472202301025, 0.550602862867052, -91.9958267211914, -1.60563007437897, 218, 22, 'PPL', 'P'),
(62209, 'Walters', 31.6433296203613, 0.552280288169153, -89.1780624389648, -1.55645081010902, 218, 30, 'PPL', 'P'),
(77582, 'Walters', 34.3597183227539, 0.599690214789879, -98.307502746582, -1.71578960234123, 218, 42, 'PPL', 'P'),
(107266, 'Walters', 36.7722206115723, 0.641796322941659, -76.8497161865234, -1.34128057667801, 218, 53, 'PPL', 'P'),
(133574, 'Walters', 42.7638893127441, 0.7463706694658, -83.3413925170898, -1.45458170262018, 218, 27, 'PPL', 'P'),
(138652, 'Walters', 43.6058311462402, 0.761065326570585, -93.6730575561523, -1.63490327476501, 218, 28, 'PPL', 'P'),
(168466, 'Walters', 40.7033309936523, 0.710407142368289, -75.2525024414063, -1.31340393796761, 218, 45, 'PPL', 'P'),
(209090, 'Walters', 47.041389465332, 0.821027130883019, -117.105278015137, -2.04387267282747, 218, 56, 'PPL', 'P'),
(195770, 'Walters Ferry', 43.3405609130859, 0.75643548759451, -116.598609924316, -2.03502964642786, 218, 17, 'PPL', 'P'),
(107267, 'Walters Woods', 38.851390838623, 0.678084689113133, -77.1627807617188, -1.34674458428653, 218, 53, 'PPL', 'P'),
(28900, 'Waltersburg', 37.3788909912109, 0.652384718540678, -88.5641708374023, -1.54573638041141, 218, 18, 'PPL', 'P'),
(79333, 'Waltersburg', 39.980281829834, 0.697787553805866, -79.7641677856445, -1.39214735297269, 218, 45, 'PPL', 'P'),
(38742, 'Waltersville', 37.8647193908691, 0.660864023714408, -83.934440612793, -1.46493234451288, 218, 21, 'PPL', 'P'),
(62210, 'Waltersville', 32.3794403076172, 0.565127843320886, -90.8677825927734, -1.58594199023029, 218, 30, 'PPL', 'P'),
(25794, 'Waltertown', 31.2994403839111, 0.546278288730927, -82.4024963378906, -1.43819487295876, 218, 13, 'PPL', 'P'),
(201742, 'Walterville', 44.0688896179199, 0.769147221530649, -122.802780151367, -2.1433128442441, 218, 43, 'PPL', 'P'),
(186015, 'Walthal', 37.9786109924316, 0.662851807152043, -121.145278930664, -2.114383990587, 218, 6, 'PPL', 'P'),
(62211, 'Walthall', 33.6072196960449, 0.586556636137072, -89.2772216796875, -1.55818146534341, 218, 30, 'PPL', 'P'),
(107268, 'Walthall', 37.3133316040039, 0.651240491378325, -77.4080581665039, -1.35102548258078, 218, 53, 'PPL', 'P'),
(107269, 'Walthall Mill', 37.3194389343262, 0.651347084400956, -77.3711090087891, -1.35038059812282, 218, 53, 'PPL', 'P'),
(121846, 'Waltham', 41.4333305358887, 0.723148037918364, -89.0102767944336, -1.55352239817437, 218, 18, 'PPL', 'P'),
(126426, 'Waltham', 42.3763885498047, 0.739607505298517, -71.2361068725586, -1.24330461122871, 218, 23, 'PPL', 'P'),
(129175, 'Waltham', 44.709171295166, 0.780322244938785, -68.3388900756836, -1.19273863897916, 218, 26, 'PPL', 'P'),
(138654, 'Waltham', 43.8216705322266, 0.764832434511529, -92.8769378662109, -1.62100836493558, 218, 28, 'PPL', 'P'),
(197789, 'Waltham', 47.5697212219238, 0.830248259578391, -110.889999389648, -1.93539559688387, 218, 31, 'PPL', 'P'),
(126427, 'Waltham Highlands', 42.3841705322266, 0.739743326514111, -71.2472229003906, -1.24349862251412, 218, 23, 'PPL', 'P'),
(168467, 'Walther', 40.3286094665527, 0.703867017942299, -80.0547180175781, -1.39721841116237, 218, 45, 'PPL', 'P'),
(143303, 'Walthill', 42.1483306884766, 0.735627144733284, -96.4880599975586, -1.68403433581923, 218, 35, 'PPL', 'P'),
(25795, 'Walthourville', 31.773889541626, 0.554558988666365, -81.6327819824219, -1.42476082315597, 218, 13, 'PPL', 'P'),
(25796, 'Walthrall (historical)', 33.9402809143066, 0.592369651006442, -85.2702789306641, -1.48824712143404, 218, 13, 'PPL', 'P'),
(209814, 'Waltman', 43.0633316040039, 0.751596923367999, -107.195281982422, -1.87091061319702, 218, 59, 'PPL', 'P'),
(18491, 'Walton', 27.2997207641602, 0.476470012209657, -80.2563934326172, -1.40073831117512, 218, 12, 'PPL', 'P'),
(34325, 'Walton', 38.1177787780762, 0.66528074322425, -97.2563934326172, -1.69744428401416, 218, 20, 'PPL', 'P'),
(38743, 'Walton', 38.875560760498, 0.678506533829802, -84.6102828979492, -1.47672801761306, 218, 21, 'PPL', 'P'),
(98895, 'Walton', 32.9383316040039, 0.574882336603573, -94.0466690063477, -1.64142402469407, 218, 51, 'PPL', 'P'),
(107271, 'Walton', 38.6494407653809, 0.674559995410413, -77.4483337402344, -1.3517284239505, 218, 53, 'PPL', 'P'),
(111910, 'Walton', 38.6388893127441, 0.674375837821034, -81.4022216796875, -1.42073678674886, 218, 58, 'PPL', 'P'),
(121848, 'Walton', 41.7150001525879, 0.728064100132596, -89.4383316040039, -1.56099336398037, 218, 18, 'PPL', 'P'),
(123914, 'Walton', 40.660831451416, 0.709665385425674, -86.241943359375, -1.50520586493955, 218, 19, 'PPL', 'P'),
(133572, 'Walton', 44.5208282470703, 0.777035038626272, -85.3994369506836, -1.49050135413874, 218, 27, 'PPL', 'P'),
(143304, 'Walton', 40.7986106872559, 0.712070086731961, -96.5616683959961, -1.68531904472908, 218, 35, 'PPL', 'P'),
(153443, 'Walton', 42.1694412231445, 0.735995593070097, -75.1297225952148, -1.31126102539648, 218, 40, 'PPL', 'P'),
(158154, 'Walton', 40.6391716003418, 0.709287349708937, -83.7655563354492, -1.46198475781838, 218, 41, 'PPL', 'P'),
(168469, 'Walton', 41.7897186279297, 0.72936818353938, -77.7644424438477, -1.35724556162277, 218, 45, 'PPL', 'P'),
(201743, 'Walton', 44.0308303833008, 0.768482962575756, -123.584167480469, -2.15695062587028, 218, 43, 'PPL', 'P'),
(31419, 'Walton (historical)', 39.6680603027344, 0.692338260162373, -87.1500015258789, -1.52105446974467, 218, 19, 'PPL', 'P'),
(84196, 'Walton (historical)', 34.3477783203125, 0.599481822434581, -81.3927764892578, -1.42057193707738, 218, 48, 'PPL', 'P'),
(91645, 'Walton (historical)', 36.2555618286133, 0.632778926069678, -86.7138900756836, -1.51344288903311, 218, 50, 'PPL', 'P'),
(69875, 'Walton Crossroads', 36.3633308410645, 0.634659850168574, -76.6436080932617, -1.33768331183559, 218, 33, 'PPL', 'P'),
(107272, 'Walton Furnace', 36.8836097717285, 0.643740430537417, -80.9347229003906, -1.41257739380107, 218, 53, 'PPL', 'P'),
(158155, 'Walton Hills', 41.3655586242676, 0.721965194920205, -81.561393737793, -1.42351486323997, 218, 41, 'PPL', 'P'),
(133573, 'Walton Junction', 44.5275001525879, 0.777151485344936, -85.4019393920898, -1.49054502998061, 218, 27, 'PPL', 'P'),
(144592, 'Walton Landing', 42.8872184753418, 0.748523169416857, -70.841667175293, -1.23642033981085, 218, 36, 'PPL', 'P'),
(153444, 'Walton Park', 41.3097190856934, 0.720990611119291, -74.2294387817383, -1.2955481086489, 218, 40, 'PPL', 'P'),
(186016, 'Walton Place (historical)', 34.6833305358887, 0.605338313408747, -117.686393737793, -2.05401505552292, 218, 6, 'PPL', 'P'),
(98896, 'Waltonia', 30.0672206878662, 0.52477199792702, -99.293327331543, -1.7329954871959, 218, 51, 'PPL', 'P'),
(194465, 'Waltonia', 40.413890838623, 0.705355458675545, -105.362503051758, -1.83892258639575, 218, 7, 'PPL', 'P'),
(62213, 'Waltonia (historical)', 33.5194396972656, 0.585024586140977, -90.6377792358398, -1.58192767436116, 218, 30, 'PPL', 'P'),
(129178, 'Waltons Mill', 44.851390838623, 0.782804444232793, -69.6502838134766, -1.21562677749368, 218, 26, 'PPL', 'P'),
(69872, 'Waltons Store', 34.7386093139648, 0.606303110092655, -77.5086135864258, -1.35278050573914, 218, 33, 'PPL', 'P'),
(28905, 'Waltonville', 38.2088890075684, 0.666870916711136, -89.0388870239258, -1.55402174087876, 218, 18, 'PPL', 'P'),
(168470, 'Waltonville', 40.2402801513672, 0.70232538056628, -76.6827774047852, -1.33836694528741, 218, 45, 'PPL', 'P'),
(12642, 'Waltreak', 34.9838905334473, 0.61058407496593, -93.6122207641602, -1.6338414724384, 218, 4, 'PPL', 'P'),
(168471, 'Waltrous', 41.7436103820801, 0.728563442836985, -77.5763931274414, -1.35396348189535, 218, 45, 'PPL', 'P'),
(187511, 'Walts Corner', 37.1688919067383, 0.648719543090456, -103.879440307617, -1.81303825849683, 218, 7, 'PPL', 'P'),
(38746, 'Waltz', 38.3166694641113, 0.668752040547114, -83.4441680908203, -1.45637547477241, 218, 21, 'PPL', 'P'),
(133575, 'Waltz', 42.1002807617188, 0.734788515306019, -83.392219543457, -1.45546880157929, 218, 27, 'PPL', 'P'),
(186017, 'Waltz', 34.360279083252, 0.599700001906885, -118.520561218262, -2.06857402457017, 218, 6, 'PPL', 'P'),
(168473, 'Waltz Mill', 40.208610534668, 0.701772641482034, -79.6677780151367, -1.39046503411209, 218, 45, 'PPL', 'P'),
(168472, 'Waltzvale', 40.7897186279297, 0.711914891019437, -78.4052810668945, -1.36843030556888, 218, 45, 'PPL', 'P'),
(141040, 'Walum', 47.269718170166, 0.825012218559186, -98.1941680908203, -1.71381153944157, 218, 34, 'PPL', 'P'),
(209091, 'Walville', 46.5530586242676, 0.812504149867411, -123.353889465332, -2.15293151631119, 218, 56, 'PPL', 'P'),
(143305, 'Walworth', 41.6527786254883, 0.726978129619089, -99.5772171020508, -1.73795029840399, 218, 35, 'PPL', 'P'),
(153446, 'Walworth', 43.1391716003418, 0.752920581008796, -77.2724990844727, -1.34865953026835, 218, 40, 'PPL', 'P'),
(176855, 'Walworth', 42.5311088562012, 0.74230788406483, -88.5994415283203, -1.54635197009739, 218, 57, 'PPL', 'P'),
(121849, 'Walz', 40.1366691589355, 0.700517027607089, -87.5669403076172, -1.52833142426526, 218, 18, 'PPL', 'P'),
(28901, 'Wamac', 38.5088882446289, 0.672106891151314, -89.1405563354492, -1.55579620511308, 218, 18, 'PPL', 'P'),
(98897, 'Wamba', 33.5058288574219, 0.584787032171741, -94.1286087036133, -1.64285414219944, 218, 51, 'PPL', 'P'),
(84197, 'Wambaw Corner', 33.1952781677246, 0.579366900142185, -79.4633331298828, -1.38689679772555, 218, 48, 'PPL', 'P'),
(141041, 'Wamduska (historical)', 47.9272193908691, 0.836487779696338, -98.3874969482422, -1.7171857645427, 218, 34, 'PPL', 'P'),
(34329, 'Wamego', 39.2019386291504, 0.684202902243427, -96.3047180175781, -1.68083441461144, 218, 20, 'PPL', 'P'),
(126429, 'Wamesit', 42.625, 0.743946593662583, -71.2638931274414, -1.24378957286321, 218, 23, 'PPL', 'P'),
(201744, 'Wamic', 45.228328704834, 0.789383251073616, -121.268058776855, -2.11652690315814, 218, 43, 'PPL', 'P'),
(84200, 'Wampee', 33.860279083252, 0.590973355646914, -78.7344436645508, -1.3741752766724, 218, 48, 'PPL', 'P'),
(98898, 'Wampler', 32.7772216796875, 0.572070437966613, -97.7352828979492, -1.70580248193732, 218, 51, 'PPL', 'P'),
(52488, 'Wampler Village', 39.3375015258789, 0.68656892113488, -76.4375, -1.33408604699317, 218, 25, 'PPL', 'P'),
(107274, 'Wamplers Trailer Park', 39.235279083252, 0.684784802941609, -78.1102828979492, -1.36328161623343, 218, 53, 'PPL', 'P'),
(12643, 'Wampoo', 34.5525016784668, 0.603054919090113, -92.0833282470703, -1.60715726410608, 218, 4, 'PPL', 'P'),
(153448, 'Wampsville', 43.0752792358398, 0.751805448881352, -75.7072219848633, -1.3213402911741, 218, 40, 'PPL', 'P'),
(168474, 'Wampum', 40.8880615234375, 0.713631298341993, -80.3383331298828, -1.4021684286805, 218, 45, 'PPL', 'P'),
(126431, 'Wampum Corner', 42.0499992370605, 0.73391093714781, -71.3463897705078, -1.24522941090656, 218, 23, 'PPL', 'P'),
(126430, 'Wampum Rock', 42.0402793884277, 0.733741293786372, -71.3319396972656, -1.24497720955133, 218, 23, 'PPL', 'P'),
(74688, 'Wamsley', 38.8291702270508, 0.67769686627939, -83.2769393920898, -1.45345678337573, 218, 41, 'PPL', 'P'),
(209815, 'Wamsutter', 41.6730613708496, 0.727332130306987, -107.978607177734, -1.88458221696905, 218, 59, 'PPL', 'P'),
(107275, 'Wan', 37.4244384765625, 0.653179672126066, -76.5058288574219, -1.3352786105293, 218, 53, 'PPL', 'P'),
(111911, 'Wana', 39.7036094665527, 0.692958710117335, -80.2986068725586, -1.40147507469069, 218, 58, 'PPL', 'P'),
(153452, 'Wanakah', 42.7461090087891, 0.746060344619779, -78.9033279418945, -1.3771228633669, 218, 40, 'PPL', 'P'),
(153449, 'Wanakena', 44.1338882446289, 0.770281661575995, -74.92138671875, -1.30762487840214, 218, 40, 'PPL', 'P'),
(18493, 'Wanamake', 29.8847198486328, 0.521586757394744, -82.8755569458008, -1.44645133812828, 218, 12, 'PPL', 'P'),
(31420, 'Wanamaker', 39.7044410705566, 0.692973224345276, -86.0097198486328, -1.50115280007656, 218, 19, 'PPL', 'P'),
(38744, 'Wanamaker', 37.5999984741211, 0.656243772118257, -87.6575012207031, -1.52991201037222, 218, 21, 'PPL', 'P'),
(118258, 'Wanamaker', 40.6458282470703, 0.709403530111492, -94.1094436645508, -1.64251964916653, 218, 16, 'PPL', 'P'),
(58121, 'Wanamaker (historical)', 38.9402809143066, 0.679636113606159, -93.1897201538086, -1.62646744569608, 218, 29, 'PPL', 'P'),
(168475, 'Wanamakers', 40.660831451416, 0.709665385425674, -75.8461074829102, -1.32376430039829, 218, 45, 'PPL', 'P'),
(146548, 'Wanamassa', 40.2316703796387, 0.702175111701772, -74.0258331298828, -1.29199451964835, 218, 37, 'PPL', 'P'),
(168476, 'Wanamie', 41.1733283996582, 0.718610144578923, -76.0358276367188, -1.32707554173964, 218, 45, 'PPL', 'P'),
(138658, 'Wanamingo', 44.3044395446777, 0.773258343305404, -92.790283203125, -1.61949595575252, 218, 28, 'PPL', 'P'),
(69873, 'Wananish', 34.3219413757324, 0.599030882683003, -78.5005569458008, -1.37009318335353, 218, 33, 'PPL', 'P'),
(209092, 'Wanapum Village', 46.8613891601563, 0.817885532903107, -119.946113586426, -2.09345460705423, 218, 56, 'PPL', 'P'),
(146547, 'Wanaque', 41.0380592346191, 0.716249252272568, -74.2944412231445, -1.29668261527328, 218, 37, 'PPL', 'P'),
(146550, 'Wanaque-Midvale', 41.0513916015625, 0.716481945972814, -74.2891693115234, -1.29659060305761, 218, 37, 'PPL', 'P'),
(123916, 'Wanatah', 41.4305610656738, 0.723099701544579, -86.8983306884766, -1.51666198500075, 218, 19, 'PPL', 'P'),
(202745, 'Wanblee', 43.5694389343262, 0.760430162650601, -101.660003662109, -1.7743017814933, 218, 49, 'PPL', 'P'),
(28902, 'Wanborough (historical)', 38.3786087036133, 0.669833084212604, -88.091667175293, -1.53748963577988, 218, 18, 'PPL', 'P'),
(69874, 'Wanchese', 35.8424987792969, 0.625569615840779, -75.6388931274414, -1.32014772763796, 218, 33, 'PPL', 'P'),
(28903, 'Wanda', 38.8344383239746, 0.677788811916025, -90.0386123657227, -1.57147023970874, 218, 18, 'PPL', 'P'),
(58122, 'Wanda', 36.8105583190918, 0.642465442165541, -94.1994400024414, -1.64409038157746, 218, 29, 'PPL', 'P'),
(111912, 'Wanda', 37.8586082458496, 0.660757364112751, -81.9280624389648, -1.42991443933943, 218, 58, 'PPL', 'P'),
(138661, 'Wanda', 44.3163909912109, 0.773466935397784, -95.2113876342773, -1.66175219961075, 218, 28, 'PPL', 'P'),
(186018, 'Wanda (historical)', 33.8125, 0.590139453330583, -117.821388244629, -2.05637115413932, 218, 6, 'PPL', 'P'),
(206326, 'Wanda Kay Estates', 40.6194381713867, 0.708942936400963, -111.883888244629, -1.95274222980215, 218, 52, 'PPL', 'P'),
(187512, 'Wandcrest Park', 39.4355583190918, 0.688280335030392, -105.393333435059, -1.839460678094, 218, 7, 'PPL', 'P'),
(77584, 'Wandel', 35.8849983215332, 0.626311372783393, -97.7452774047852, -1.70597691898872, 218, 42, 'PPL', 'P'),
(206329, 'Wander Village', 40.6647186279297, 0.709733229454444, -111.810829162598, -1.95146710827222, 218, 52, 'PPL', 'P'),
(176854, 'Wanderoos', 45.3086090087891, 0.790784406702134, -92.4941711425781, -1.61432782534111, 218, 57, 'PPL', 'P'),
(168477, 'Wandin Junction', 40.6766700744629, 0.709941821546825, -78.961669921875, -1.37814112300969, 218, 45, 'PPL', 'P'),
(84201, 'Wando', 32.9333305358887, 0.574795051498846, -79.8319396972656, -1.39333019597085, 218, 48, 'PPL', 'P'),
(84204, 'Wando Woods', 32.8516693115234, 0.573369794262463, -80.0366668701172, -1.39690335920541, 218, 48, 'PPL', 'P'),
(38745, 'Waneta', 37.4744415283203, 0.654052390015285, -84.0411071777344, -1.4667940272729, 218, 21, 'PPL', 'P'),
(98899, 'Waneta', 31.5677795410156, 0.550961690534427, -95.3499984741211, -1.66417141514498, 218, 51, 'PPL', 'P'),
(111913, 'Waneta', 38.5486106872559, 0.672800178562089, -80.2433319091797, -1.40051034458581, 218, 58, 'PPL', 'P'),
(118259, 'Waneta', 40.6300010681152, 0.709127293727424, -92.2694396972656, -1.61040552168765, 218, 16, 'PPL', 'P'),
(118260, 'Wanetta Corner', 40.624439239502, 0.70903022150569, -92.269172668457, -1.61040086115574, 218, 16, 'PPL', 'P'),
(77585, 'Wanette', 34.9619407653809, 0.610200979243122, -97.0322189331055, -1.69353170089867, 218, 42, 'PPL', 'P'),
(168478, 'Wangaum', 41.4941711425781, 0.724209906824006, -75.2369384765625, -1.31313229553642, 218, 45, 'PPL', 'P'),
(107277, 'Wangle Junction', 36.9775009155273, 0.64537914013517, -80.4674987792969, -1.40442279454325, 218, 53, 'PPL', 'P'),
(52489, 'Wango', 38.3213882446289, 0.668834398803825, -75.4502792358398, -1.31685579421452, 218, 25, 'PPL', 'P'),
(153450, 'Wango', 42.4191703796387, 0.740354189089148, -79.0963897705078, -1.38049242793612, 218, 40, 'PPL', 'P'),
(138665, 'Wangs', 44.4066696166992, 0.77504259465673, -92.9794387817383, -1.62279734339784, 218, 28, 'PPL', 'P'),
(114214, 'Wangum Village', 42.0302810668945, 0.733566790155945, -73.3383331298828, -1.27999538104089, 218, 8, 'PPL', 'P'),
(186019, 'Wanhala', 39.4708290100098, 0.688895924716364, -123.543891906738, -2.15624768450056, 218, 6, 'PPL', 'P'),
(62214, 'Wanilla', 31.6427803039551, 0.552270700789228, -90.1316680908203, -1.57309436849953, 218, 30, 'PPL', 'P'),
(201, 'Wanless', 38.4372215270996, 0.670856070966331, -79.9072189331055, -1.39464406649464, 218, 58, 'PPL', 'P'),
(121850, 'Wanlock', 41.2191696166992, 0.71941022474941, -90.6252822875977, -1.58170956146788, 218, 18, 'PPL', 'P'),
(77586, 'Wann', 36.9152793884277, 0.644293169621663, -95.8041687011719, -1.67209818097155, 218, 42, 'PPL', 'P'),
(143307, 'Wann', 41.146671295166, 0.718144890336487, -96.3555603027344, -1.68172177988666, 218, 35, 'PPL', 'P'),
(190894, 'Wann', 36.2333297729492, 0.632390903498853, -115.112503051758, -2.00909218846519, 218, 39, 'PPL', 'P'),
(12644, 'Wann (historical)', 36.482780456543, 0.636744639248915, -94.5627822875977, -1.65043190076515, 218, 4, 'PPL', 'P'),
(84205, 'Wannamaker (historical)', 34.2183303833008, 0.597222529723812, -79.057502746582, -1.37981372133232, 218, 48, 'PPL', 'P'),
(138666, 'Wannaska', 48.6583290100098, 0.849248049743343, -95.7344436645508, -1.67088124951144, 218, 28, 'PPL', 'P'),
(18494, 'Wannee', 29.7183303833008, 0.518682713384067, -82.9411087036133, -1.44759543213258, 218, 12, 'PPL', 'P'),
(6623, 'Wannville', 34.7775001525879, 0.606981883275489, -85.8777770996094, -1.49884996468197, 218, 2, 'PPL', 'P'),
(206330, 'Wanship', 40.811939239502, 0.71230271385318, -111.406669616699, -1.94441319349293, 218, 52, 'PPL', 'P'),
(169649, 'Wanskuck', 41.853328704834, 0.730478388818807, -71.4372177124023, -1.24681465754543, 218, 47, 'PPL', 'P'),
(197790, 'Wanso (historical)', 48.6372184753418, 0.848879601406531, -104.875, -1.83041405302905, 218, 31, 'PPL', 'P'),
(146551, 'Wantage', 41.2441711425781, 0.71984658369402, -74.5511093139648, -1.3011623185429, 218, 37, 'PPL', 'P'),
(153451, 'Wantagh', 40.6836090087891, 0.710062928797396, -73.5105590820313, -1.28300129096327, 218, 40, 'PPL', 'P'),
(158157, 'Wapakoneta', 40.5677795410156, 0.708041323213917, -84.1936111450195, -1.46945572362438, 218, 41, 'PPL', 'P'),
(77587, 'Wapanucka', 34.3738899230957, 0.59993755587612, -96.4241714477539, -1.68291927027081, 218, 42, 'PPL', 'P'),
(209093, 'Wapato', 46.4477806091309, 0.810666701873311, -120.419166564941, -2.1017109390657, 218, 56, 'PPL', 'P'),
(121851, 'Wapella', 40.2202796936035, 0.701976306726397, -88.9619369506836, -1.55267870874103, 218, 18, 'PPL', 'P'),
(118261, 'Wapello', 41.1813888549805, 0.718750826063507, -91.1852798461914, -1.59148336266847, 218, 16, 'PPL', 'P'),
(195771, 'Wapello', 43.246940612793, 0.754801505107691, -112.25611114502, -1.95923874496529, 218, 17, 'PPL', 'P'),
(195772, 'Wapi', 42.7155609130859, 0.745527179769545, -113.182220458984, -1.97540240172737, 218, 17, 'PPL', 'P'),
(201745, 'Wapinitia', 45.1144409179688, 0.787395534215008, -121.255279541016, -2.11630386341684, 218, 43, 'PPL', 'P'),
(209816, 'Wapiti', 44.4686088562012, 0.77612363832222, -109.436943054199, -1.91003497961332, 218, 59, 'PPL', 'P'),
(14793, 'Waples', 38.8258285522461, 0.677638543051518, -75.3077774047852, -1.31436866807249, 218, 10, 'PPL', 'P'),
(98900, 'Waples', 32.4836082458496, 0.566945916818055, -97.7200012207031, -1.70553576635415, 218, 51, 'PPL', 'P'),
(107276, 'Waples Mill', 38.8738899230957, 0.678477372215865, -77.3372192382813, -1.34978911004471, 218, 53, 'PPL', 'P'),
(14794, 'Waples Pond Acres', 38.8172187805176, 0.67748827418701, -75.3050003051758, -1.31432019854065, 218, 10, 'PPL', 'P'),
(111914, 'Wapocomo', 39.3950004577637, 0.687572466812649, -78.7350006103516, -1.37418499721038, 218, 58, 'PPL', 'P'),
(58123, 'Wappapello', 36.9355583190918, 0.644647103730534, -90.2708282470703, -1.57552317141368, 218, 29, 'PPL', 'P'),
(114215, 'Wapping', 41.827220916748, 0.730022721956294, -72.5536117553711, -1.26629940934489, 218, 8, 'PPL', 'P'),
(126432, 'Wapping', 42.5250015258789, 0.7422012910422, -72.6083297729492, -1.26725441891179, 218, 23, 'PPL', 'P'),
(114216, 'Wapping Mews Elderly Housing', 41.8347206115723, 0.730153616323872, -72.5138931274414, -1.26560618851314, 218, 8, 'PPL', 'P'),
(153454, 'Wappingers Falls', 41.5963897705078, 0.72599395843825, -73.9113922119141, -1.28999714883079, 218, 40, 'PPL', 'P'),
(84208, 'Wappoola', 33.0977783203125, 0.577665206784652, -79.9902801513672, -1.39609375823403, 218, 48, 'PPL', 'P'),
(177325, 'Wapsie', 42.7150001525879, 0.745517392652539, -92.1991729736328, -1.60917913600566, 218, 16, 'PPL', 'P'),
(168480, 'Wapwallopen', 41.0744400024414, 0.71688421645547, -76.1311111450195, -1.32873855268234, 218, 45, 'PPL', 'P'),
(126433, 'Waquoit Village', 41.5900001525879, 0.725882438567603, -70.5216674804688, -1.23083529153079, 218, 23, 'PPL', 'P'),
(111915, 'War', 37.3011093139648, 0.65102717217501, -81.6911087036133, -1.42577881648265, 218, 58, 'PPL', 'P'),
(38747, 'War Creek', 37.5963897705078, 0.656180788358477, -83.4866714477539, -1.45711729829405, 218, 21, 'PPL', 'P'),
(12646, 'War Eagle', 36.2677803039551, 0.632992178693966, -93.9408264160156, -1.63957672300394, 218, 4, 'PPL', 'P'),
(111916, 'War Eagle', 37.5283317565918, 0.654992951933274, -81.9441680908203, -1.43019553599249, 218, 58, 'PPL', 'P'),
(12647, 'War Eagle Cove', 36.2083282470703, 0.631954544554244, -93.98388671875, -1.64032826706356, 218, 4, 'PPL', 'P'),
(138667, 'Warba', 47.1288909912109, 0.822554320610125, -93.2663879394531, -1.62780555098579, 218, 28, 'PPL', 'P'),
(146553, 'Warbasse', 41.083610534668, 0.717044272436984, -74.6999969482422, -1.30376089797654, 218, 37, 'PPL', 'P'),
(202747, 'Warbonnet', 43.9991683959961, 0.767930356649564, -103.132781982422, -1.80000661233475, 218, 49, 'PPL', 'P'),
(38749, 'Warbranch', 36.9566688537598, 0.645015552067347, -83.4502792358398, -1.45648213437406, 218, 21, 'PPL', 'P'),
(12650, 'Warbritton', 34.2763900756836, 0.598235862518587, -92.0308303833008, -1.60624100353303, 218, 4, 'PPL', 'P'),
(52499, 'Warburton Manor', 38.7169418334961, 0.675738111297637, -76.9938888549805, -1.34379686443398, 218, 25, 'PPL', 'P'),
(52491, 'Warburton Oaks', 38.7350006103516, 0.676053296412648, -77.0002822875977, -1.34390845088365, 218, 25, 'PPL', 'P'),
(38748, 'Warco', 37.5441703796387, 0.655269388054424, -82.7758331298828, -1.44471082919786, 218, 21, 'PPL', 'P'),
(861, 'Ward', 35.2372207641602, 0.615005521586707, -94.7252807617188, -1.65326803416803, 218, 42, 'PPL', 'P'),
(6624, 'Ward', 32.3619384765625, 0.564822378743853, -88.2780609130859, -1.54074282020946, 218, 2, 'PPL', 'P'),
(12652, 'Ward', 34.6749992370605, 0.605192904813228, -92.3038864135742, -1.61100673030373, 218, 4, 'PPL', 'P'),
(14795, 'Ward', 38.485279083252, 0.671694833551651, -75.4780578613281, -1.31734062269097, 218, 10, 'PPL', 'P'),
(18495, 'Ward', 30.3038902282715, 0.528902660646273, -84.7030563354492, -1.47834721955583, 218, 12, 'PPL', 'P'),
(43539, 'Ward', 30.7402801513672, 0.536519101626818, -92.7022171020508, -1.61795891232938, 218, 22, 'PPL', 'P'),
(52493, 'Ward', 38.0105590820313, 0.663409406505279, -75.8147201538086, -1.32321648816206, 218, 25, 'PPL', 'P'),
(62215, 'Ward', 30.8666706085205, 0.538725031247245, -88.5472183227539, -1.54544050321431, 218, 30, 'PPL', 'P'),
(84209, 'Ward', 33.857780456543, 0.590929746384064, -81.7300033569336, -1.42645765624451, 218, 48, 'PPL', 'P'),
(98902, 'Ward', 32.464168548584, 0.566606630095179, -97.0272216796875, -1.69344448237297, 218, 51, 'PPL', 'P'),
(111917, 'Ward', 38.2463912963867, 0.667525455128051, -81.3883285522461, -1.4204943059316, 218, 58, 'PPL', 'P'),
(112532, 'Ward', 39.8802795410156, 0.696042184606456, -75.5119400024414, -1.31793197761102, 218, 45, 'PPL', 'P'),
(118265, 'Ward', 41.0294418334961, 0.716098850250006, -92.8863906860352, -1.62117334776511, 218, 16, 'PPL', 'P'),
(121853, 'Ward', 41.1688919067383, 0.718532713170229, -87.628059387207, -1.52939815343989, 218, 18, 'PPL', 'P'),
(171541, 'Ward', 44.1547203063965, 0.770645249643818, -96.4599990844727, -1.68354458049476, 218, 49, 'PPL', 'P'),
(194466, 'Ward', 40.0722198486328, 0.699392174941666, -105.507781982422, -1.84145818206961, 218, 7, 'PPL', 'P'),
(197791, 'Ward', 46.1536102294922, 0.805532460186774, -114.178062438965, -1.9927831231076, 218, 31, 'PPL', 'P'),
(209094, 'Ward', 48.6044387817383, 0.848307487825355, -118.022216796875, -2.05987627360802, 218, 56, 'PPL', 'P'),
(74689, 'Ward (historical)', 39.5013885498047, 0.68942928930368, -81.1483306884766, -1.41630555301107, 218, 41, 'PPL', 'P'),
(91646, 'Ward (historical)', 36.4891700744629, 0.636856159119562, -85.3652801513672, -1.48990520552872, 218, 50, 'PPL', 'P'),
(190895, 'Ward (historical)', 39.0763893127441, 0.682011653298509, -114.870002746582, -2.00485975970279, 218, 39, 'PPL', 'P'),
(6625, 'Ward Acres', 31.1377792358398, 0.543456769424529, -85.3988876342773, -1.49049176675881, 218, 2, 'PPL', 'P'),
(18496, 'Ward Basin', 30.5849990844727, 0.533808935743499, -86.996940612793, -1.51838305285521, 218, 12, 'PPL', 'P'),
(69876, 'Ward Corner', 34.1300010681152, 0.595680892347792, -78.6911087036133, -1.37341893892282, 218, 33, 'PPL', 'P'),
(126435, 'Ward Corner', 42.2563896179199, 0.737513128838251, -71.6319427490234, -1.25021325057054, 218, 23, 'PPL', 'P'),
(193323, 'Ward Cove', 55.4119415283203, 0.967120824591768, -131.722778320313, -2.29899618156406, 218, 1, 'PPL', 'P'),
(98903, 'Ward Creek', 33.3661994934082, 0.582350040037237, -94.6300811767578, -1.65160648796393, 218, 51, 'PPL', 'P'),
(52494, 'Ward Farm Estates', 39.2266693115234, 0.684634534077101, -77.182502746582, -1.34708879785742, 218, 25, 'PPL', 'P'),
(126436, 'Ward Hill', 42.7566719055176, 0.74624470194624, -71.1041717529297, -1.24100190899217, 218, 23, 'PPL', 'P'),
(84210, 'Ward Hills', 33.5333290100098, 0.585267000379201, -81.7030563354492, -1.425987341996, 218, 48, 'PPL', 'P'),
(138669, 'Ward Lee Mobile Home Park', 43.6941719055176, 0.762607163683686, -91.2797164916992, -1.59313159306712, 218, 28, 'PPL', 'P'),
(98904, 'Ward Prairie', 31.7633304595947, 0.554374697918932, -96.1380615234375, -1.67792571006886, 218, 51, 'PPL', 'P'),
(18497, 'Ward Ridge', 29.788330078125, 0.519904438534141, -85.2850036621094, -1.48850411647923, 218, 12, 'PPL', 'P'),
(98905, 'Ward Spring', 30.4566707611084, 0.531569183977229, -97.6391677856445, -1.70412495676668, 218, 51, 'PPL', 'P'),
(77588, 'Ward Springs', 34.8111114501953, 0.607568511084606, -96.0219421386719, -1.67589904447931, 218, 42, 'PPL', 'P'),
(138670, 'Ward Springs', 45.7919387817383, 0.799220102613014, -94.8047180175781, -1.65465447583153, 218, 28, 'PPL', 'P'),
(98906, 'Warda', 30.0550003051758, 0.524558712013218, -96.9136123657227, -1.69146162578335, 218, 51, 'PPL', 'P'),
(195773, 'Wardboro', 42.2558288574219, 0.737503341721245, -111.276390075684, -1.94213938655422, 218, 17, 'PPL', 'P'),
(12655, 'Wardell', 35.538890838623, 0.620270657640821, -90.1783294677734, -1.57390876316087, 218, 4, 'PPL', 'P'),
(58124, 'Wardell', 36.351390838623, 0.634451457813275, -89.8177795410156, -1.56761597982112, 218, 29, 'PPL', 'P'),
(107278, 'Wardell', 37.0311088562012, 0.646314775205142, -81.7947235107422, -1.42758723602087, 218, 53, 'PPL', 'P'),
(44025, 'Warden', 32.5374984741211, 0.567886478736044, -91.496940612793, -1.59692286919496, 218, 22, 'PPL', 'P'),
(111918, 'Warden', 37.8077812194824, 0.659870265153645, -81.1611099243164, -1.41652859275237, 218, 58, 'PPL', 'P'),
(209095, 'Warden', 46.9677810668945, 0.819742421973165, -119.038612365723, -2.0776157227871, 218, 56, 'PPL', 'P'),
(209096, 'Warden Hutterian Brethren', 47.0588912963867, 0.821332595460051, -118.949172973633, -2.07605471091415, 218, 56, 'PPL', 'P'),
(52495, 'Wardens Landing', 39.2161102294922, 0.684450243329668, -76.8219375610352, -1.34079574820157, 218, 25, 'PPL', 'P'),
(111919, 'Wardensville', 39.0750007629395, 0.68198741853259, -78.5980606079102, -1.37179494329009, 218, 58, 'PPL', 'P'),
(98907, 'Wardlaw', 31.5463905334473, 0.550588381928625, -97.0644378662109, -1.69409402736284, 218, 51, 'PPL', 'P'),
(195774, 'Wardner', 47.5227813720703, 0.829429004648055, -116.133056640625, -2.02690420878397, 218, 17, 'PPL', 'P'),
(52496, 'Wardour', 38.9941711425781, 0.680576675524147, -76.4986114501953, -1.33515264300974, 218, 25, 'PPL', 'P'),
(52497, 'Wardour Bluffs', 38.9949989318848, 0.680591123173061, -76.495002746582, -1.33508965924996, 218, 25, 'PPL', 'P'),
(38750, 'Wards', 37.4594383239746, 0.653790534701103, -85.6102828979492, -1.49418131013301, 218, 21, 'PPL', 'P'),
(69877, 'Wards', 34.2655601501465, 0.598046844660219, -78.8388900756836, -1.37599821043856, 218, 33, 'PPL', 'P'),
(158158, 'Wards (historical)', 41.1030616760254, 0.717383758896942, -84.0658264160156, -1.4672254593695, 218, 41, 'PPL', 'P'),
(69878, 'Wards Corner', 34.5344390869141, 0.602739667396075, -78.0722198486328, -1.36261729069951, 218, 33, 'PPL', 'P'),
(107279, 'Wards Corner', 36.9147186279297, 0.644283382504657, -76.273063659668, -1.33121609144444, 218, 53, 'PPL', 'P'),
(129179, 'Wards Cove', 43.8313903808594, 0.765002077872967, -70.607780456543, -1.23233824649198, 218, 26, 'PPL', 'P'),
(12658, 'Wards Crossing', 34.9444389343262, 0.60989551466609, -93.3277816772461, -1.62887707385038, 218, 4, 'PPL', 'P'),
(52498, 'Wards Meadow', 38.7033309936523, 0.675500557328402, -76.654167175293, -1.33786760258302, 218, 25, 'PPL', 'P'),
(6626, 'Wards Mill', 32.9713897705078, 0.575459310453739, -85.3438873291016, -1.48953183034389, 218, 2, 'PPL', 'P'),
(44026, 'Wards Mill (historical)', 32.9869384765625, 0.575730686568818, -92.7394409179688, -1.61860859047731, 218, 22, 'PPL', 'P'),
(172690, 'Wardsboro', 43.0416717529297, 0.751218887651262, -72.7916717529297, -1.27045434011958, 218, 55, 'PPL', 'P'),
(172691, 'Wardsboro Center', 43.0361099243164, 0.751121815429529, -72.8083267211914, -1.27074502415256, 218, 55, 'PPL', 'P'),
(168482, 'Wardsburg', 40.7852783203125, 0.711837393031716, -75.2819366455078, -1.31391766174189, 218, 45, 'PPL', 'P'),
(58125, 'Wardsville', 38.4888916015625, 0.671757883890459, -92.1741714477539, -1.60874277706105, 218, 29, 'PPL', 'P'),
(107280, 'Wardtown', 37.5347213745117, 0.655104471803921, -75.8772201538086, -1.32430731894456, 218, 53, 'PPL', 'P'),
(44027, 'Wardview', 32.9647216796875, 0.575342930314102, -93.7941665649414, -1.63701702572221, 218, 22, 'PPL', 'P'),
(44029, 'Wardville', 31.3091697692871, 0.546448098539933, -92.4063873291016, -1.61279570876599, 218, 22, 'PPL', 'P'),
(69879, 'Wardville', 36.4066696166992, 0.635416254497183, -76.5852813720703, -1.33666531850891, 218, 33, 'PPL', 'P'),
(77589, 'Wardville', 34.6536102294922, 0.604819596207426, -96.0299987792969, -1.67603965938487, 218, 42, 'PPL', 'P'),
(168483, 'Wardville', 40.5833282470703, 0.708312699328996, -77.1438903808594, -1.34641488494358, 218, 45, 'PPL', 'P'),
(62216, 'Wardwell', 31.3427791595459, 0.547034693059537, -89.3755569458008, -1.55989773950791, 218, 30, 'PPL', 'P'),
(153456, 'Wardwell', 43.7675018310547, 0.763887012324551, -76.0686111450195, -1.32764772189984, 218, 40, 'PPL', 'P'),
(74692, 'Wardwood Acres', 39.2419395446777, 0.684901049923191, -84.5913925170898, -1.47639831827011, 218, 41, 'PPL', 'P'),
(6628, 'Ware', 33.4355583190918, 0.583560579910733, -86.8858337402344, -1.51644387210747, 218, 2, 'PPL', 'P'),
(12657, 'Ware', 33.0294418334961, 0.57647251009046, -93.0711135864258, -1.62439737058076, 218, 4, 'PPL', 'P'),
(28906, 'Ware', 37.4477806091309, 0.653587069193821, -89.3938903808594, -1.56021771831288, 218, 18, 'PPL', 'P'),
(38752, 'Ware', 37.208610534668, 0.649412763922204, -84.7688903808594, -1.47949624040815, 218, 21, 'PPL', 'P'),
(58126, 'Ware', 38.2136116027832, 0.666953341546874, -90.6624984741211, -1.58235910645775, 218, 29, 'PPL', 'P'),
(118267, 'Ware', 42.7902793884277, 0.74683126317633, -94.7588882446289, -1.65385459539812, 218, 16, 'PPL', 'P'),
(126438, 'Ware', 42.2597198486328, 0.737571252329042, -72.2402801513672, -1.26083074120447, 218, 23, 'PPL', 'P'),
(192392, 'Ware', 36.1847190856934, 0.631542486954581, -102.709716796875, -1.79262273189639, 218, 51, 'PPL', 'P'),
(197792, 'Ware', 47.184440612793, 0.823523844404968, -109.667221069336, -1.91405408917241, 218, 31, 'PPL', 'P'),
(206331, 'Ware', 40.5988883972168, 0.708584275181157, -111.854721069336, -1.95223316655978, 218, 52, 'PPL', 'P'),
(91647, 'Ware Branch', 35.2594413757324, 0.61539334442045, -85.0880584716797, -1.48506677446026, 218, 50, 'PPL', 'P'),
(126437, 'Ware Center', 42.2638893127441, 0.737644023205829, -72.2736129760742, -1.26141250874459, 218, 23, 'PPL', 'P'),
(98908, 'Ware Colony Colonia', 26.3250007629395, 0.459457938903313, -98.2490005493164, -1.71476854637929, 218, 51, 'PPL', 'P'),
(98909, 'Ware Country Colonia', 26.3320007324219, 0.45958011141832, -98.2480010986328, -1.71475110267415, 218, 51, 'PPL', 'P'),
(98910, 'Ware Country Colonia Number 2', 26.3319396972656, 0.459579046153884, -98.2505569458008, -1.71479571062241, 218, 51, 'PPL', 'P'),
(98915, 'Ware del Norte Colonia', 26.2970008850098, 0.458969248843283, -98.2490005493164, -1.71476854637929, 218, 51, 'PPL', 'P'),
(98911, 'Ware Estates Colonia', 26.2889995574951, 0.458829599333622, -98.2519989013672, -1.71482087749471, 218, 51, 'PPL', 'P'),
(107281, 'Ware Neck', 37.4025001525879, 0.65279677614034, -76.4588928222656, -1.33445942217799, 218, 53, 'PPL', 'P'),
(98912, 'Ware Oaks Colonia', 26.2849998474121, 0.458759791223548, -98.2470016479492, -1.71473365896901, 218, 51, 'PPL', 'P'),
(84212, 'Ware Place', 34.6277809143066, 0.604368789613903, -82.39111328125, -1.43799620114144, 218, 48, 'PPL', 'P'),
(98913, 'Ware Shadows Colonia', 26.298999786377, 0.459004136253563, -98.2470016479492, -1.71473365896901, 218, 51, 'PPL', 'P'),
(84211, 'Ware Shoals', 34.3983306884766, 0.600364127703724, -82.246940612793, -1.43547991338548, 218, 48, 'PPL', 'P'),
(98914, 'Ware West Colonia', 26.3250007629395, 0.459457938903313, -98.2490005493164, -1.71476854637929, 218, 51, 'PPL', 'P'),
(113084, 'Wareham', 41.7625007629395, 0.728893142179937, -70.7222213745117, -1.23433561730954, 218, 23, 'PPL', 'P'),
(107283, 'Wareham (historical)', 37.4741706848145, 0.65404766290435, -76.54638671875, -1.33598647874705, 218, 53, 'PPL', 'P'),
(126440, 'Wareham Center', 41.7666702270508, 0.728965913056724, -70.7266693115234, -1.23441324845532, 218, 23, 'PPL', 'P'),
(114217, 'Warehouse Point', 41.9291687011719, 0.731802046459604, -72.6186065673828, -1.26743378281121, 218, 8, 'PPL', 'P'),
(187513, 'Wareland', 39.0924987792969, 0.682292816530595, -103.215278625488, -1.8014464503781, 218, 7, 'PPL', 'P'),
(25799, 'Wares Crossroads', 33.1063919067383, 0.577815542228187, -85.0747222900391, -1.48483401418099, 218, 13, 'PPL', 'P'),
(107284, 'Wares Crossroads', 38.0794410705566, 0.664611624000368, -77.8802795410156, -1.3592673003643, 218, 53, 'PPL', 'P'),
(107285, 'Wares Wharf', 37.8736114501953, 0.661019219426933, -76.7838897705078, -1.34013168898375, 218, 53, 'PPL', 'P'),
(25800, 'Waresboro', 31.2477798461914, 0.545376642254367, -82.4738922119141, -1.43944096603281, 218, 13, 'PPL', 'P'),
(25801, 'Waresville', 33.2286109924316, 0.579948667682313, -85.2383270263672, -1.48768945550177, 218, 13, 'PPL', 'P'),
(98916, 'Waresville', 29.6047191619873, 0.516699823504935, -99.5219421386719, -1.73698556829911, 218, 51, 'PPL', 'P'),
(71515, 'Waretown', 39.791389465332, 0.69449076011343, -74.195556640625, -1.29495675372885, 218, 37, 'PPL', 'P'),
(25802, 'Warfield', 33.2994384765625, 0.5811848404813, -83.3838882446289, -1.45532339298377, 218, 13, 'PPL', 'P'),
(38751, 'Warfield', 37.8441696166992, 0.660505362494602, -82.4175033569336, -1.43845679485197, 218, 21, 'PPL', 'P'),
(52506, 'Warfield', 39.1197204589844, 0.682767924469065, -76.706672668457, -1.33878399631412, 218, 25, 'PPL', 'P'),
(107286, 'Warfield', 36.8955612182617, 0.643949022629797, -77.8261108398438, -1.35832187817732, 218, 53, 'PPL', 'P'),
(111920, 'Warfield', 38.3866691589355, 0.669973765697188, -81.1838912963867, -1.41692620270312, 218, 58, 'PPL', 'P'),
(192395, 'Warfield', 31.9208297729492, 0.557123579506598, -102.218330383301, -1.78404642107996, 218, 51, 'PPL', 'P'),
(52501, 'Warfield Estates', 39.2788887023926, 0.685545934381154, -77.0233306884766, -1.34431072136631, 218, 25, 'PPL', 'P'),
(52502, 'Warfields Range', 39.1547203063965, 0.683378787044102, -76.8747177124023, -1.34171693562262, 218, 25, 'PPL', 'P'),
(52503, 'Warfieldsburg', 39.5263900756836, 0.689865648248289, -77.0330581665039, -1.3444804978858, 218, 25, 'PPL', 'P'),
(111921, 'Warford (historical)', 37.5374984741211, 0.655152941335761, -80.9049987792969, -1.41205861002072, 218, 58, 'PPL', 'P'),
(79334, 'Warfordsburg', 39.7516708374023, 0.693797539281682, -78.1877822875977, -1.36463423575108, 218, 45, 'PPL', 'P'),
(12659, 'Wargo Landing', 33.8197212219238, 0.590265487429171, -91.1500015258789, -1.59086763982444, 218, 4, 'PPL', 'P'),
(25803, 'Waring', 34.8344383239746, 0.607975641836252, -84.9713897705078, -1.48303052149079, 218, 13, 'PPL', 'P'),
(98917, 'Waring', 29.9505596160889, 0.5227358781156, -98.8027801513672, -1.72443382376546, 218, 51, 'PPL', 'P'),
(168484, 'Waring', 41.6858291625977, 0.7275549703112, -80.4875030517578, -1.40477193496216, 218, 45, 'PPL', 'P'),
(52504, 'Waring (historical)', 39.1599998474121, 0.683470932417818, -77.2516708374023, -1.34829600877956, 218, 25, 'PPL', 'P'),
(52505, 'Warington Hills', 38.5958290100098, 0.673624293761414, -77.1602783203125, -1.34670090844465, 218, 25, 'PPL', 'P'),
(84214, 'Waringville (historical)', 32.935001373291, 0.574824213112782, -80.2777786254883, -1.4011115532019, 218, 48, 'PPL', 'P'),
(197793, 'Warland (historical)', 48.5008316040039, 0.846499201445191, -115.286392211914, -2.01212712684345, 218, 31, 'PPL', 'P'),
(6630, 'Warley', 30.8280601501465, 0.538051151622914, -88.3655624389648, -1.54227000993657, 218, 2, 'PPL', 'P'),
(98918, 'Warlock', 32.839168548584, 0.573151614790158, -94.623893737793, -1.65149849678173, 218, 51, 'PPL', 'P'),
(209097, 'Warm Beach', 48.1708297729492, 0.840739582955676, -122.363327026367, -2.13564294030467, 218, 56, 'PPL', 'P'),
(200268, 'Warm Creek (historical)', 40.8194389343262, 0.712433608220757, -114.983329772949, -2.00683768944439, 218, 39, 'PPL', 'P'),
(195775, 'Warm Lake', 44.6541709899902, 0.779362308523865, -115.66667175293, -2.01876425691214, 218, 17, 'PPL', 'P'),
(18498, 'Warm Mineral Springs', 27.059440612793, 0.472276332441109, -82.2602767944336, -1.43571267366475, 218, 12, 'PPL', 'P'),
(195776, 'Warm River', 44.1150016784668, 0.76995202881207, -111.319999694824, -1.94290051799377, 218, 17, 'PPL', 'P'),
(6631, 'Warm Springs', 33.1227798461914, 0.578101565729261, -86.2038879394531, -1.50454167256369, 218, 2, 'PPL', 'P'),
(12660, 'Warm Springs', 36.480281829834, 0.636701029986065, -91.0513916015625, -1.58914657196998, 218, 4, 'PPL', 'P'),
(25804, 'Warm Springs', 32.8902816772461, 0.574043707176307, -84.6811065673828, -1.47796412383302, 218, 13, 'PPL', 'P'),
(107287, 'Warm Springs', 38.0461082458496, 0.66402985646024, -79.7908325195313, -1.39261274037318, 218, 53, 'PPL', 'P'),
(186021, 'Warm Springs', 34.1072196960449, 0.595283282397043, -117.263061523438, -2.04662651455266, 218, 6, 'PPL', 'P'),
(190898, 'Warm Springs', 39.6533317565918, 0.692081198538154, -114.801666259766, -2.00366706300859, 218, 39, 'PPL', 'P'),
(197794, 'Warm Springs', 46.1813888549805, 0.806017288663223, -112.783889770508, -1.96845021970171, 218, 31, 'PPL', 'P'),
(201746, 'Warm Springs', 44.7636108398438, 0.781272394236698, -121.264999389648, -2.11647350677828, 218, 43, 'PPL', 'P'),
(201747, 'Warm Springs (historical)', 44.0222206115723, 0.768332693711248, -117.461112976074, -2.05008316448953, 218, 43, 'PPL', 'P'),
(186023, 'Warm Springs District', 37.4872207641602, 0.654275429756579, -121.928062438965, -2.12804614013716, 218, 6, 'PPL', 'P'),
(186022, 'Warm Springs Mobile Home Park', 33.5405616760254, 0.585393234214871, -117.172218322754, -2.04504100159768, 218, 6, 'PPL', 'P'),
(138672, 'Warman', 46.0583305358887, 0.803869515823102, -93.2841720581055, -1.62811594241084, 218, 28, 'PPL', 'P'),
(107289, 'Warminster', 37.6872215270996, 0.657766101576374, -78.6980590820313, -1.37354024591047, 218, 53, 'PPL', 'P'),
(168485, 'Warminster', 40.2066688537598, 0.701738752757162, -75.0999984741211, -1.31074224161613, 218, 45, 'PPL', 'P'),
(168486, 'Warminster Heights', 40.186939239502, 0.701394406028215, -75.0819396972656, -1.31042705650112, 218, 45, 'PPL', 'P'),
(168487, 'Warminster Village', 40.2013893127441, 0.701646607383446, -75.1036071777344, -1.31080522537591, 218, 45, 'PPL', 'P'),
(69880, 'Warne', 34.9944381713867, 0.610768165976282, -83.8930587768555, -1.46421009522525, 218, 33, 'PPL', 'P'),
(12662, 'Warner', 33.6380615234375, 0.587094927572404, -92.7975006103516, -1.61962192327208, 218, 4, 'PPL', 'P'),
(74694, 'Warner', 39.5627784729004, 0.690500745589246, -81.418327331543, -1.42101788340191, 218, 41, 'PPL', 'P'),
(77593, 'Warner', 35.4941711425781, 0.619490151704346, -95.3052825927734, -1.66339097578753, 218, 42, 'PPL', 'P'),
(107290, 'Warner', 37.6383285522461, 0.656912758184085, -76.6458282470703, -1.33772206082945, 218, 53, 'PPL', 'P'),
(121855, 'Warner', 41.4102783203125, 0.72274570085668, -90.3758316040039, -1.57735582571782, 218, 18, 'PPL', 'P'),
(144594, 'Warner', 43.2805595397949, 0.755388266074863, -71.8172225952148, -1.25344699392417, 218, 36, 'PPL', 'P'),
(168489, 'Warner', 40.1386108398438, 0.70055091633196, -79.9355621337891, -1.39513874866712, 218, 45, 'PPL', 'P'),
(171544, 'Warner', 45.3258285522461, 0.791084944431149, -98.495002746582, -1.71906209468871, 218, 49, 'PPL', 'P'),
(186024, 'Warner', 34.0608291625977, 0.594473614846632, -117.145561218262, -2.04457574735525, 218, 6, 'PPL', 'P'),
(209098, 'Warner', 47.1533317565918, 0.822980892437728, -117.136390686035, -2.04441569137373, 218, 56, 'PPL', 'P'),
(6632, 'Warner (historical)', 33.9602813720703, 0.592718724846324, -85.4638900756836, -1.49162627338318, 218, 2, 'PPL', 'P'),
(73, 'Warner Junction', 33.8013916015625, 0.589945575203225, -96.5355606079102, -1.68486337786657, 218, 51, 'PPL', 'P'),
(179478, 'Warner Park', 33.3333282470703, 0.581776328559407, -111.855560302734, -1.95224781394578, 218, 5, 'PPL', 'P'),
(25805, 'Warner Robins', 32.6208305358887, 0.569340897586364, -83.5999984741211, -1.45909522803565, 218, 13, 'PPL', 'P'),
(186026, 'Warner Springs', 33.2822189331055, 0.580884302752285, -116.632781982422, -2.03562606135398, 218, 6, 'PPL', 'P'),
(146554, 'Warner Village', 40.2336082458496, 0.702208933847616, -74.7261123657227, -1.30421669799711, 218, 37, 'PPL', 'P'),
(153457, 'Warners', 43.0852813720703, 0.751980019090807, -76.3294372558594, -1.33219999630917, 218, 40, 'PPL', 'P'),
(71516, 'Warners Mill', 39.3138885498047, 0.68615679695619, -74.8066711425781, -1.30562271389462, 218, 37, 'PPL', 'P'),
(44031, 'Warnerton', 30.9899997711182, 0.540877531198301, -90.1830596923828, -1.57399132115466, 218, 22, 'PPL', 'P'),
(168490, 'Warnertown', 41.1613883972168, 0.718401752223625, -75.4563903808594, -1.31696245381617, 218, 45, 'PPL', 'P'),
(143309, 'Warnerville', 41.9599990844727, 0.732340138157854, -97.4458312988281, -1.70075059850749, 218, 35, 'PPL', 'P'),
(153458, 'Warnerville', 42.6602783203125, 0.744562316506609, -74.5077819824219, -1.30040611395137, 218, 40, 'PPL', 'P'),
(186025, 'Warnerville', 37.7324981689453, 0.658556328050827, -120.595558166504, -2.10478955328583, 218, 6, 'PPL', 'P'),
(209099, 'Warnick', 48.9022216796875, 0.853504779850699, -121.988059997559, -2.12909329507778, 218, 56, 'PPL', 'P'),
(44032, 'Warnicott (historical)', 31.4583301544189, 0.549051438374027, -91.5311126708984, -1.59751928412108, 218, 22, 'PPL', 'P'),
(28907, 'Warnock', 38.3955612182617, 0.670128961409712, -90.269172668457, -1.57549427611585, 218, 18, 'PPL', 'P'),
(38753, 'Warnock', 38.4925003051758, 0.67182086765024, -82.9786071777344, -1.44824990397046, 218, 21, 'PPL', 'P'),
(158159, 'Warnock', 40.0224990844727, 0.698524383900464, -80.9375, -1.41262586333291, 218, 41, 'PPL', 'P'),
(12665, 'Warnock Springs', 33.310001373291, 0.581369197807761, -93.1416702270508, -1.62562881626881, 218, 4, 'PPL', 'P'),
(111922, 'Warnocks', 39.4619407653809, 0.688740795582867, -79.0977783203125, -1.38051666270204, 218, 58, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(197795, 'Warr (historical)', 46.8319396972656, 0.817371542812722, -108.822776794434, -1.89931575622575, 218, 31, 'PPL', 'P'),
(77591, 'Warr Acres', 35.5224990844727, 0.619984567560719, -97.6186065673828, -1.70376609580979, 218, 42, 'PPL', 'P'),
(206332, 'Warranty', 40.6411094665527, 0.709321171854782, -111.839721679688, -1.95197137782463, 218, 52, 'PPL', 'P'),
(12663, 'Warren', 33.6124992370605, 0.586648781510789, -92.0644378662109, -1.60682756476312, 218, 4, 'PPL', 'P'),
(25806, 'Warren', 34.3861083984375, 0.600150808500409, -85.0480575561523, -1.4843686267805, 218, 13, 'PPL', 'P'),
(38754, 'Warren', 36.7533302307129, 0.641466623598707, -83.8441696166992, -1.46335681841199, 218, 21, 'PPL', 'P'),
(52507, 'Warren', 39.4761085510254, 0.688988070090081, -76.616943359375, -1.3372179244351, 218, 25, 'PPL', 'P'),
(58127, 'Warren', 39.773609161377, 0.694180435267408, -91.7563934326172, -1.60145117515447, 218, 29, 'PPL', 'P'),
(77592, 'Warren', 34.7830581665039, 0.607078888918195, -99.2080612182617, -1.73150731277876, 218, 42, 'PPL', 'P'),
(91648, 'Warren', 35.2383308410645, 0.615024896083637, -89.4427795410156, -1.56107099512615, 218, 50, 'PPL', 'P'),
(98919, 'Warren', 30.6144409179688, 0.53432279267583, -94.408332824707, -1.64773624910978, 218, 51, 'PPL', 'P'),
(107291, 'Warren', 37.7658309936523, 0.659138095590955, -78.5580596923828, -1.37109679561032, 218, 53, 'PPL', 'P'),
(114218, 'Warren', 41.7427787780762, 0.728548928609045, -73.3491668701172, -1.28018446547829, 218, 8, 'PPL', 'P'),
(121856, 'Warren', 42.4963912963867, 0.74170194833781, -89.9894409179688, -1.57061203604746, 218, 18, 'PPL', 'P'),
(123918, 'Warren', 40.6827812194824, 0.710048481148482, -85.4272232055664, -1.49098631577324, 218, 19, 'PPL', 'P'),
(126442, 'Warren', 42.2125015258789, 0.736747137129717, -72.1916732788086, -1.25998239123922, 218, 23, 'PPL', 'P'),
(129180, 'Warren', 44.1202812194824, 0.770044174185787, -69.2405624389648, -1.20847579049265, 218, 26, 'PPL', 'P'),
(133578, 'Warren', 42.4775009155273, 0.741372248994858, -83.0277786254883, -1.44910810763174, 218, 27, 'PPL', 'P'),
(138673, 'Warren', 48.1966705322266, 0.841190589286281, -96.7724990844727, -1.68899873440725, 218, 28, 'PPL', 'P'),
(141044, 'Warren', 46.7272186279297, 0.8155438153566, -97.0100021362305, -1.69314394464395, 218, 34, 'PPL', 'P'),
(144596, 'Warren', 43.9230613708496, 0.76660203847686, -71.8925018310547, -1.25476086444796, 218, 36, 'PPL', 'P'),
(153460, 'Warren', 44.1497192382813, 0.770557964539091, -76.2019424438477, -1.32997479206036, 218, 40, 'PPL', 'P'),
(158214, 'Warren', 41.2374992370605, 0.719730136975356, -80.8186111450195, -1.41055086136958, 218, 41, 'PPL', 'P'),
(168501, 'Warren', 41.8438911437988, 0.730313672305386, -79.1452789306641, -1.38134570474938, 218, 45, 'PPL', 'P'),
(169650, 'Warren', 41.730281829834, 0.728330815715767, -71.2830581665039, -1.24412406589613, 218, 47, 'PPL', 'P'),
(172694, 'Warren', 44.1119384765625, 0.769898565853187, -72.8563919067383, -1.27158391989593, 218, 55, 'PPL', 'P'),
(179479, 'Warren', 31.4108295440674, 0.548222396326685, -109.877777099609, -1.91772898516061, 218, 5, 'PPL', 'P'),
(189798, 'Warren', 32.6091690063477, 0.569137365500054, -103.146942138672, -1.80025375368391, 218, 38, 'PPL', 'P'),
(194467, 'Warren', 40.9597206115723, 0.714881985368921, -104.891670227051, -1.83070500337814, 218, 7, 'PPL', 'P'),
(195777, 'Warren', 45.2641716003418, 0.790008827613675, -115.675559997559, -2.01891938604564, 218, 17, 'PPL', 'P'),
(197796, 'Warren', 45.060001373291, 0.786445384917095, -108.657783508301, -1.89643608013904, 218, 31, 'PPL', 'P'),
(201748, 'Warren', 45.8191719055176, 0.799695410288566, -122.847778320313, -2.14409821044956, 218, 43, 'PPL', 'P'),
(206334, 'Warren', 41.2836112976074, 0.720534944256778, -112.121391296387, -1.95688744003886, 218, 52, 'PPL', 'P'),
(209100, 'Warren', 47.2822189331055, 0.825230398031491, -122.651107788086, -2.14066566212056, 218, 56, 'PPL', 'P'),
(186028, 'Warren (historical)', 35.167781829834, 0.613793583553639, -119.52555847168, -2.08611453561581, 218, 6, 'PPL', 'P'),
(192393, 'Warren Allen Road Colonia', 31.628999710083, 0.55203018405328, -106.237998962402, -1.85420287262424, 218, 51, 'PPL', 'P'),
(168491, 'Warren Center', 41.9377784729004, 0.731952315324111, -76.1811065673828, -1.32961113741351, 218, 45, 'PPL', 'P'),
(98920, 'Warren City', 32.5547218322754, 0.568187083044087, -94.8958282470703, -1.65624464931842, 218, 51, 'PPL', 'P'),
(84218, 'Warren Crossroads', 34.3333282470703, 0.59922962107935, -80.7872161865234, -1.41000291597529, 218, 48, 'PPL', 'P'),
(146556, 'Warren Glen', 40.6327781677246, 0.709175763259263, -75.1352767944336, -1.31135796446016, 218, 37, 'PPL', 'P'),
(71517, 'Warren Grove', 39.7463912963867, 0.693705393907966, -74.3708267211914, -1.29801579371497, 218, 37, 'PPL', 'P'),
(25808, 'Warren Heights', 33.7286109924316, 0.588675313942284, -84.6986083984375, -1.47826958841006, 218, 13, 'PPL', 'P'),
(31421, 'Warren Hills', 39.7819404602051, 0.694325843862927, -85.9974975585938, -1.50093948087325, 218, 19, 'PPL', 'P'),
(14796, 'Warren Landing', 39.063060760498, 0.681779026177291, -75.4258270263672, -1.31642902264983, 218, 10, 'PPL', 'P'),
(126443, 'Warren Landing', 41.2861099243164, 0.720578553519628, -70.192497253418, -1.22509018726922, 218, 23, 'PPL', 'P'),
(107293, 'Warren Mill', 37.3727798461914, 0.65227805893902, -76.8411102294922, -1.34113037439253, 218, 53, 'PPL', 'P'),
(31422, 'Warren Park', 39.7819404602051, 0.694325843862927, -86.0502777099609, -1.5018606682943, 218, 19, 'PPL', 'P'),
(107294, 'Warren Park', 38.9383316040039, 0.679602091723233, -78.1941680908203, -1.3647456890427, 218, 53, 'PPL', 'P'),
(69888, 'Warren Plains', 36.4425010681152, 0.636041631300161, -78.1605606079102, -1.36415912781261, 218, 33, 'PPL', 'P'),
(146557, 'Warren Point', 40.9269409179688, 0.714309871787745, -74.1083297729492, -1.29343435769171, 218, 37, 'PPL', 'P'),
(98921, 'Warren Springs', 33.0622215270996, 0.577044623671636, -94.3763885498047, -1.64717871633557, 218, 51, 'PPL', 'P'),
(25809, 'Warren Terrace', 34.9330596923828, 0.609696909427798, -85.2877807617188, -1.48855258601107, 218, 13, 'PPL', 'P'),
(107296, 'Warren Woods', 38.8430595397949, 0.677939280517615, -77.32861328125, -1.34963890775923, 218, 53, 'PPL', 'P'),
(168495, 'Warrendale', 40.6533317565918, 0.709534491058097, -80.079719543457, -1.39765477010698, 218, 45, 'PPL', 'P'),
(201749, 'Warrendale', 45.6127815246582, 0.796093218598125, -122.014442443848, -2.12955375563026, 218, 43, 'PPL', 'P'),
(168496, 'Warrenham', 41.9716682434082, 0.732543803402218, -76.1530609130859, -1.32912164840515, 218, 45, 'PPL', 'P'),
(121860, 'Warrenhurst', 41.8227806091309, 0.729945223968573, -88.2141723632813, -1.53962775466105, 218, 18, 'PPL', 'P'),
(176859, 'Warrens', 44.1311111450195, 0.770233192044156, -90.4997177124023, -1.57951804620685, 218, 57, 'PPL', 'P'),
(195778, 'Warrens', 43.3286094665527, 0.756226895502129, -116.539169311523, -2.03399221202522, 218, 17, 'PPL', 'P'),
(25810, 'Warrens (historical)', 34.7511100769043, 0.60652128956496, -85.267219543457, -1.48819372505418, 218, 13, 'PPL', 'P'),
(91650, 'Warrens Bluff', 35.6152801513672, 0.621603902661542, -88.3188934326172, -1.54145548211717, 218, 50, 'PPL', 'P'),
(153463, 'Warrens Corners', 43.2161102294922, 0.754263413409441, -78.754997253418, -1.37453400447123, 218, 40, 'PPL', 'P'),
(79336, 'Warrens Mill', 39.7794418334961, 0.694282234600077, -78.9572219848633, -1.37806349186392, 218, 45, 'PPL', 'P'),
(69883, 'Warrens Trailer Park', 34.7522201538086, 0.60654066406189, -77.4725036621094, -1.35215026866717, 218, 33, 'PPL', 'P'),
(28908, 'Warrensburg', 39.9327812194824, 0.696958511758525, -89.0619430541992, -1.55442414451947, 218, 18, 'PPL', 'P'),
(58130, 'Warrensburg', 38.7627792358398, 0.676538124889097, -93.7358322143555, -1.63599889923747, 218, 29, 'PPL', 'P'),
(91651, 'Warrensburg', 36.1272201538086, 0.630538941276812, -83.0944366455078, -1.45027150955394, 218, 50, 'PPL', 'P'),
(153464, 'Warrensburg', 43.4966697692871, 0.759160101126742, -73.7766723632813, -1.28764584390436, 218, 40, 'PPL', 'P'),
(158164, 'Warrensburg', 40.3058280944824, 0.70346940799155, -83.1686096191406, -1.45156607215983, 218, 41, 'PPL', 'P'),
(69884, 'Warrensville', 36.4605598449707, 0.636356816415172, -81.519172668457, -1.42277796656635, 218, 33, 'PPL', 'P'),
(158165, 'Warrensville', 41.4425010681152, 0.723308093899878, -81.517219543457, -1.42274387810439, 218, 41, 'PPL', 'P'),
(168497, 'Warrensville', 41.3263893127441, 0.721281561468382, -76.9458312988281, -1.34295810184866, 218, 45, 'PPL', 'P'),
(158166, 'Warrensville Heights', 41.435001373291, 0.7231771995323, -81.5363922119141, -1.42307850429536, 218, 41, 'PPL', 'P'),
(6633, 'Warrenton', 34.3566703796387, 0.599637018147105, -86.3594436645508, -1.50725663213697, 218, 2, 'PPL', 'P'),
(12666, 'Warrenton', 33.8388900756836, 0.590600047041112, -91.658332824707, -1.59973969467993, 218, 4, 'PPL', 'P'),
(25811, 'Warrenton', 33.4069404602051, 0.583061104048288, -82.6622161865234, -1.44272783945019, 218, 13, 'PPL', 'P'),
(31425, 'Warrenton', 38.1730613708496, 0.666245606487186, -87.5327835083008, -1.52773527565524, 218, 19, 'PPL', 'P'),
(38756, 'Warrenton', 38.0663909912109, 0.664383857148139, -84.4669418334961, -1.47422624408504, 218, 21, 'PPL', 'P'),
(58132, 'Warrenton', 38.8113899230957, 0.677386541433369, -91.1413879394531, -1.59071730438091, 218, 29, 'PPL', 'P'),
(62219, 'Warrenton', 32.2472190856934, 0.562820147657305, -90.9283294677734, -1.58699873255083, 218, 30, 'PPL', 'P'),
(69885, 'Warrenton', 36.3983306884766, 0.63527071274361, -78.1555633544922, -1.36407190928691, 218, 33, 'PPL', 'P'),
(84219, 'Warrenton', 34.1563911437988, 0.596141486058322, -82.4755630493164, -1.43947012764675, 218, 48, 'PPL', 'P'),
(98922, 'Warrenton', 30.017219543457, 0.523899313327314, -96.7316665649414, -1.68828607249954, 218, 51, 'PPL', 'P'),
(107295, 'Warrenton', 38.7133293151855, 0.675675060958829, -77.7955627441406, -1.35778871332709, 218, 53, 'PPL', 'P'),
(158169, 'Warrenton', 40.1919403076172, 0.701481691132942, -80.6802825927734, -1.40813657268336, 218, 41, 'PPL', 'P'),
(201750, 'Warrenton', 46.1652793884277, 0.805736125431138, -123.922500610352, -2.16285565295532, 218, 43, 'PPL', 'P'),
(126445, 'Warrentown', 41.9219398498535, 0.731675879202961, -70.9175033569336, -1.23774393087262, 218, 23, 'PPL', 'P'),
(158170, 'Warrentown', 40.0688896179199, 0.699334051450875, -81.4886093139648, -1.4222445354, 218, 41, 'PPL', 'P'),
(176862, 'Warrentown', 44.5758285522461, 0.777994975041192, -92.3583297729492, -1.61195694618067, 218, 57, 'PPL', 'P'),
(84220, 'Warrenville', 33.5508308410645, 0.585572464956233, -81.8041687011719, -1.42775208569234, 218, 48, 'PPL', 'P'),
(114220, 'Warrenville', 41.8633308410645, 0.730652959028262, -72.1630630493164, -1.25948304853483, 218, 8, 'PPL', 'P'),
(121861, 'Warrenville', 41.8177795410156, 0.729857938863846, -88.1733322143555, -1.53891495959529, 218, 18, 'PPL', 'P'),
(146559, 'Warrenville', 40.6150016784668, 0.708865504992269, -74.4963912963867, -1.300207308976, 218, 37, 'PPL', 'P'),
(209101, 'Warrenville', 47.6605606079102, 0.831833705954342, -122.769439697266, -2.14273094354592, 218, 56, 'PPL', 'P'),
(197797, 'Warrick', 48.0716705322266, 0.839008927721288, -109.605278015137, -1.91297297892789, 218, 31, 'PPL', 'P'),
(25812, 'Warrick Homes', 31.7891693115234, 0.554825670960023, -82.3461074829102, -1.43721070177792, 218, 13, 'PPL', 'P'),
(18499, 'Warrington', 30.3838901519775, 0.530298922716288, -87.2750015258789, -1.52323613130966, 218, 12, 'PPL', 'P'),
(28909, 'Warrington', 39.6127815246582, 0.691373463478465, -87.9375, -1.53479891097251, 218, 18, 'PPL', 'P'),
(31427, 'Warrington', 39.9075012207031, 0.696517292544926, -85.6338882446289, -1.49459330115364, 218, 19, 'PPL', 'P'),
(84221, 'Warrington', 34.5202789306641, 0.602492526046915, -80.7713928222656, -1.40972674617025, 218, 48, 'PPL', 'P'),
(146560, 'Warrington', 40.9313888549805, 0.714387502933521, -75.0844421386719, -1.310470732343, 218, 37, 'PPL', 'P'),
(168498, 'Warrington', 40.2491683959961, 0.702480509699777, -75.1344375610352, -1.31134331707416, 218, 45, 'PPL', 'P'),
(52508, 'Warrington (historical)', 38.5349998474121, 0.672562624592854, -76.5397186279297, -1.33587009860741, 218, 25, 'PPL', 'P'),
(107300, 'Warrington Heights', 37.2122192382813, 0.649475747681984, -77.4733276367188, -1.35216464973706, 218, 53, 'PPL', 'P'),
(14797, 'Warrington Manor', 38.9333305358887, 0.679514806618506, -75.5638885498047, -1.31883865080414, 218, 10, 'PPL', 'P'),
(6636, 'Warrior', 33.8141708374023, 0.590168614944519, -86.809440612793, -1.51511056050772, 218, 2, 'PPL', 'P'),
(69889, 'Warrior', 35.9713897705078, 0.627819188013569, -81.5686111450195, -1.42364083075953, 218, 33, 'PPL', 'P'),
(168502, 'Warrior Ridge', 40.5424995422363, 0.707600104000318, -78.0322189331055, -1.36191914301975, 218, 45, 'PPL', 'P'),
(168506, 'Warrior Run', 41.0972213745117, 0.717281826406219, -76.8058319091797, -1.34051465154851, 218, 45, 'PPL', 'P'),
(111925, 'Warriormine', 37.292781829834, 0.650881830158519, -81.6972198486328, -1.42588547608431, 218, 58, 'PPL', 'P'),
(168505, 'Warriors Mark', 40.7033309936523, 0.710407142368289, -78.129997253418, -1.36362569664627, 218, 45, 'PPL', 'P'),
(6640, 'Warriorstand', 32.3116683959961, 0.563945000322727, -85.5533294677734, -1.49318728525613, 218, 2, 'PPL', 'P'),
(52512, 'Warrlinda', 38.5680618286133, 0.673139665022047, -76.976936340332, -1.34350098723687, 218, 25, 'PPL', 'P'),
(138677, 'Warroad', 48.9052810668945, 0.853558176230555, -95.3141708374023, -1.66354610492103, 218, 28, 'PPL', 'P'),
(6638, 'Warsaw', 32.9375, 0.574867822375632, -88.2030563354492, -1.53943374337563, 218, 2, 'PPL', 'P'),
(12667, 'Warsaw', 34.952220916748, 0.610031335881684, -92.1549987792969, -1.60840815087009, 218, 4, 'PPL', 'P'),
(25816, 'Warsaw', 34.0180587768555, 0.593727130793083, -84.1902770996094, -1.46939753355457, 218, 13, 'PPL', 'P'),
(38757, 'Warsaw', 38.7833290100098, 0.676896786108903, -84.9016723632813, -1.48181372318873, 218, 21, 'PPL', 'P'),
(58133, 'Warsaw', 38.2430610656738, 0.66746733163726, -93.3816680908203, -1.62981756918934, 218, 29, 'PPL', 'P'),
(62222, 'Warsaw', 34.8308296203613, 0.607912658076472, -89.6861114501953, -1.56531793811649, 218, 30, 'PPL', 'P'),
(69891, 'Warsaw', 34.9991683959961, 0.610850723970074, -78.0913925170898, -1.36295191689048, 218, 33, 'PPL', 'P'),
(84222, 'Warsaw', 33.5083312988281, 0.584830708013619, -79.5505599975586, -1.38841919376269, 218, 48, 'PPL', 'P'),
(98923, 'Warsaw', 32.5499992370605, 0.568104658208349, -96.4199981689453, -1.682846432815, 218, 51, 'PPL', 'P'),
(107297, 'Warsaw', 37.958610534668, 0.662502733312161, -76.7583312988281, -1.33968560950117, 218, 53, 'PPL', 'P'),
(121862, 'Warsaw', 40.3591690063477, 0.704400382529615, -91.434440612793, -1.59583203841246, 218, 18, 'PPL', 'P'),
(123924, 'Warsaw', 41.2380599975586, 0.719739924092362, -85.8530578613281, -1.49841853258538, 218, 19, 'PPL', 'P'),
(138678, 'Warsaw', 44.249439239502, 0.772298406890485, -93.3936080932617, -1.63002596154464, 218, 28, 'PPL', 'P'),
(141046, 'Warsaw', 48.2961082458496, 0.842926104789659, -97.2544403076172, -1.69741019555221, 218, 34, 'PPL', 'P'),
(153466, 'Warsaw', 42.7400016784668, 0.745953751597148, -78.133056640625, -1.36367909302613, 218, 40, 'PPL', 'P'),
(158171, 'Warsaw', 40.3352813720703, 0.703983464660963, -82.0069427490234, -1.43129116046495, 218, 41, 'PPL', 'P'),
(168508, 'Warsaw', 41.4397201538086, 0.723259557789011, -75.6163864135742, -1.31975491137718, 218, 45, 'PPL', 'P'),
(74, 'Warsaw Center', 32.5544395446777, 0.56818215619607, -96.415283203125, -1.68276414113732, 218, 51, 'PPL', 'P'),
(44033, 'Warsaw Ferry', 32.2975006103516, 0.563697725815513, -91.5269393920898, -1.59744644666526, 218, 22, 'PPL', 'P'),
(158172, 'Warsaw Junction', 40.3288917541504, 0.703871944790316, -82.0122222900391, -1.43138330583867, 218, 41, 'PPL', 'P'),
(44035, 'Warsaw Landing', 30.3847198486328, 0.530313403654716, -90.5533294677734, -1.58045374785585, 218, 22, 'PPL', 'P'),
(58134, 'Warson Woods', 38.6072196960449, 0.673823098736788, -90.3833312988281, -1.57748672008539, 218, 29, 'PPL', 'P'),
(28910, 'Wartburg', 38.2905616760254, 0.668296373684601, -90.195556640625, -1.57420943404794, 218, 18, 'PPL', 'P'),
(91653, 'Wartburg', 36.1047210693359, 0.63014625817408, -84.5972213745117, -1.47650005102375, 218, 50, 'PPL', 'P'),
(25814, 'Warthen', 33.1019401550293, 0.577737844503383, -82.8038864135742, -1.44520045136427, 218, 13, 'PPL', 'P'),
(52509, 'Warthen Knolls', 38.872501373291, 0.678453137449946, -76.6047210693359, -1.33700460523178, 218, 25, 'PPL', 'P'),
(28911, 'Wartrace', 37.399169921875, 0.652738652649549, -88.7786102294922, -1.54947905384936, 218, 18, 'PPL', 'P'),
(91652, 'Wartrace', 35.5272216796875, 0.620066992396457, -86.333610534668, -1.50680575896442, 218, 50, 'PPL', 'P'),
(14798, 'Warwick', 38.6030616760254, 0.673750527597084, -75.230827331543, -1.31302563593476, 218, 10, 'PPL', 'P'),
(25815, 'Warwick', 31.8308296203613, 0.555552780516642, -83.9188919067383, -1.46466096839781, 218, 13, 'PPL', 'P'),
(77597, 'Warwick', 35.6858291625977, 0.62283521519154, -97.0038909912109, -1.6930372850423, 218, 42, 'PPL', 'P'),
(107298, 'Warwick', 37.4588890075684, 0.653780947321179, -77.4230575561523, -1.35128727131593, 218, 53, 'PPL', 'P'),
(111924, 'Warwick', 38.2822189331055, 0.668150765352001, -80.0641708374023, -1.3973833939919, 218, 58, 'PPL', 'P'),
(112326, 'Warwick', 39.9986114501953, 0.698107466031812, -97.9069366455078, -1.7087984050056, 218, 20, 'PPL', 'P'),
(112402, 'Warwick', 39.4166717529297, 0.687950702266468, -75.7786102294922, -1.32258625109009, 218, 25, 'PPL', 'P'),
(126446, 'Warwick', 42.6819381713867, 0.744940352223346, -72.3394393920898, -1.26256139643885, 218, 23, 'PPL', 'P'),
(141047, 'Warwick', 47.8549995422363, 0.835227305552403, -98.709716796875, -1.72280956181662, 218, 34, 'PPL', 'P'),
(153468, 'Warwick', 41.2563896179199, 0.720059836318308, -74.3602828979492, -1.29783176928364, 218, 40, 'PPL', 'P'),
(158173, 'Warwick', 40.9222183227539, 0.714227446952007, -81.64111328125, -1.42490623175148, 218, 41, 'PPL', 'P'),
(168511, 'Warwick', 40.1622200012207, 0.700962973931622, -76.3072204589844, -1.33181224005446, 218, 45, 'PPL', 'P'),
(169652, 'Warwick', 41.7000007629395, 0.727802311397441, -71.4166717529297, -1.24645606290465, 218, 47, 'PPL', 'P'),
(177702, 'Warwick', 38.1238899230957, 0.665387402825908, -102.273612976074, -1.78501128434289, 218, 7, 'PPL', 'P'),
(192394, 'Warwick', 30.2030601501465, 0.527142843797949, -103.106941223145, -1.79955560600414, 218, 51, 'PPL', 'P'),
(209102, 'Warwick', 45.7219390869141, 0.79799837746294, -120.997497558594, -2.11180471907126, 218, 56, 'PPL', 'P'),
(6639, 'Warwick (historical)', 31.0097198486328, 0.54122171147968, -85.6336135864258, -1.49458850746368, 218, 2, 'PPL', 'P'),
(107301, 'Warwick Corner', 36.9152793884277, 0.644293169621663, -76.8369369506836, -1.34105753693672, 218, 53, 'PPL', 'P'),
(84223, 'Warwick Estates', 33.8849983215332, 0.591404787743507, -80.3813934326172, -1.40291997274012, 218, 48, 'PPL', 'P'),
(107302, 'Warwick Lawns', 37.1222190856934, 0.647904948692028, -76.5244369506836, -1.33560338302424, 218, 53, 'PPL', 'P'),
(14808, 'Warwick Park', 38.5969390869141, 0.673643668258344, -75.210563659668, -1.312671968142, 218, 10, 'PPL', 'P'),
(107305, 'Warwick Village', 38.834171295166, 0.677784151384118, -77.0647201538086, -1.34503310381199, 218, 53, 'PPL', 'P'),
(91654, 'Warwicktown', 36.2311096191406, 0.632352154504993, -83.8797225952148, -1.46397733494598, 218, 50, 'PPL', 'P'),
(177291, 'Warwood', 40.1166687011719, 0.700167953767206, -80.6999969482422, -1.4084806530962, 218, 58, 'PPL', 'P'),
(177292, 'Warwood Terrace', 40.1186103820801, 0.700201842492078, -80.6972198486328, -1.40843218356436, 218, 58, 'PPL', 'P'),
(133581, 'Wasas', 46.7211112976074, 0.81543722233397, -89.0102767944336, -1.55352239817437, 218, 27, 'PPL', 'P'),
(206339, 'Wasatch Oaks Condominium', 40.5999984741211, 0.708603649678087, -111.793891906738, -1.95117149739122, 218, 52, 'PPL', 'P'),
(206340, 'Wasatch Resort', 40.5702781677246, 0.708084932476767, -111.760276794434, -1.95058480300308, 218, 52, 'PPL', 'P'),
(206342, 'Wasatch Village', 40.6388893127441, 0.709282422860921, -111.857223510742, -1.95227684240166, 218, 52, 'PPL', 'P'),
(206343, 'Wasatch Village Two and Three', 40.6377792358398, 0.709263048363991, -111.855003356934, -1.9522380934078, 218, 52, 'PPL', 'P'),
(121863, 'Wasco', 41.938060760498, 0.731957242172128, -88.4044418334961, -1.54294858338232, 218, 18, 'PPL', 'P'),
(192915, 'Wasco', 35.5941696166992, 0.621235454324729, -119.339996337891, -2.08287586541417, 218, 6, 'PPL', 'P'),
(201751, 'Wasco', 45.5919418334961, 0.795729497372247, -120.696937561035, -2.10655895751408, 218, 43, 'PPL', 'P'),
(176863, 'Wascott', 46.1725006103516, 0.805862159529726, -91.7980575561523, -1.60217835129012, 218, 57, 'PPL', 'P'),
(138681, 'Waseca', 44.0777816772461, 0.769302417243173, -93.5072174072266, -1.63200881813426, 218, 28, 'PPL', 'P'),
(194037, 'Waseck', 41.2169418334961, 0.719371342597495, -123.754173278809, -2.1599177867988, 218, 6, 'PPL', 'P'),
(168515, 'Waseka Acres', 40.1699981689453, 0.701098728568189, -76.9416732788086, -1.34288553070895, 218, 45, 'PPL', 'P'),
(107304, 'Wasena', 37.2644386291504, 0.650387147986036, -79.9613876342773, -1.39558948868162, 218, 53, 'PPL', 'P'),
(133582, 'Wasepi', 41.9408302307129, 0.732005578545913, -85.461669921875, -1.49158752438932, 218, 27, 'PPL', 'P'),
(206344, 'Washakie', 41.9441719055176, 0.732063901773786, -112.21639251709, -1.95854552413355, 218, 52, 'PPL', 'P'),
(209818, 'Washakie Ten', 44.0955581665039, 0.769612675510167, -107.908058166504, -1.88335090443905, 218, 59, 'PPL', 'P'),
(209819, 'Washam', 41.0166702270508, 0.715875943666766, -109.768890380859, -1.91582855340673, 218, 59, 'PPL', 'P'),
(12668, 'Washburn', 35.1683311462402, 0.613803170933564, -94.0933303833008, -1.64223841935542, 218, 4, 'PPL', 'P'),
(58136, 'Washburn', 36.5869407653809, 0.63856257958803, -93.9658279418945, -1.64001308194855, 218, 29, 'PPL', 'P'),
(69894, 'Washburn', 35.3930587768555, 0.617725408008005, -81.8166732788086, -1.42797033174367, 218, 33, 'PPL', 'P'),
(91655, 'Washburn', 36.2900009155273, 0.633380001527709, -83.5911102294922, -1.45894009890215, 218, 50, 'PPL', 'P'),
(111926, 'Washburn', 39.142219543457, 0.683160607571797, -81.0469436645508, -1.41453601562477, 218, 58, 'PPL', 'P'),
(118275, 'Washburn', 42.4116706848145, 0.74022329472157, -92.267219543457, -1.61036677269378, 218, 16, 'PPL', 'P'),
(121864, 'Washburn', 40.9191703796387, 0.714174250309233, -89.2911071777344, -1.55842381300261, 218, 18, 'PPL', 'P'),
(129182, 'Washburn', 46.7900009155273, 0.816639572987113, -68.1580581665039, -1.1895825267713, 218, 26, 'PPL', 'P'),
(176865, 'Washburn', 46.6733283996582, 0.814603253438612, -90.8947219848633, -1.58641217132074, 218, 57, 'PPL', 'P'),
(192396, 'Washburn', 35.1766700744629, 0.613948712687136, -101.572776794434, -1.77277938545616, 218, 51, 'PPL', 'P'),
(199057, 'Washburn', 47.2891693115234, 0.825351705019144, -101.028610229492, -1.76328188721866, 218, 34, 'PPL', 'P'),
(144601, 'Washburn Corner', 43.5244407653809, 0.759644796445137, -72.0808334350586, -1.25804787102339, 218, 36, 'PPL', 'P'),
(129183, 'Washburn Junction', 46.6938896179199, 0.8149621143955, -67.9913864135742, -1.18667355591261, 218, 26, 'PPL', 'P'),
(12672, 'Washington', 36.3836097717285, 0.635013784277445, -90.8755569458008, -1.58607767828783, 218, 4, 'PPL', 'P'),
(13241, 'Washington', 38.8950004577637, 0.678845820552678, -77.0366668701172, -1.34454348164558, 218, 9, 'PPLC', 'P'),
(25817, 'Washington', 33.7366714477539, 0.588815995426868, -82.7394409179688, -1.44407566527787, 218, 13, 'PPL', 'P'),
(31428, 'Washington', 38.6591682434082, 0.674729771929906, -87.1727828979492, -1.52145207969542, 218, 19, 'PPL', 'P'),
(34332, 'Washington', 39.8180618286133, 0.694956280671976, -97.0505599975586, -1.6938518128617, 218, 20, 'PPL', 'P'),
(44036, 'Washington', 30.6161098480225, 0.534351921000253, -92.0569381713867, -1.60669667039555, 218, 22, 'PPL', 'P'),
(58138, 'Washington', 38.5580596923828, 0.672965094812592, -91.0119400024414, -1.58845801167014, 218, 29, 'PPL', 'P'),
(62223, 'Washington', 31.5786094665527, 0.551150708392795, -91.2991714477539, -1.5934711461061, 218, 30, 'PPL', 'P'),
(69895, 'Washington', 35.5463905334473, 0.620401552008398, -77.0524978637695, -1.34481978460868, 218, 33, 'PPL', 'P'),
(77595, 'Washington', 35.0588912963867, 0.611893085220731, -97.4841690063477, -1.70141971773138, 218, 42, 'PPL', 'P'),
(84230, 'Washington', 33.2691688537598, 0.580656535900056, -79.6691665649414, -1.39048926887801, 218, 48, 'PPL', 'P'),
(98924, 'Washington', 30.3250007629395, 0.529271108983086, -96.1563873291016, -1.67824555571578, 218, 51, 'PPL', 'P'),
(107306, 'Washington', 38.7133293151855, 0.675675060958829, -78.1597213745117, -1.36414448042662, 218, 53, 'PPL', 'P'),
(111929, 'Washington', 39.2611083984375, 0.685235609535132, -81.6719436645508, -1.42544432344973, 218, 58, 'PPL', 'P'),
(114221, 'Washington', 41.6313896179199, 0.726604821013287, -73.3111114501953, -1.27952027310242, 218, 8, 'PPL', 'P'),
(118277, 'Washington', 41.2991714477539, 0.720806520108939, -91.6927795410156, -1.60034090329602, 218, 16, 'PPL', 'P'),
(121865, 'Washington', 40.7036094665527, 0.710412002637278, -89.4072189331055, -1.5604503454341, 218, 18, 'PPL', 'P'),
(126448, 'Washington', 42.3658294677734, 0.739423214551083, -73.1166687011719, -1.27612660692534, 218, 23, 'PPL', 'P'),
(129185, 'Washington', 44.273609161377, 0.772720251607153, -69.3677825927734, -1.21069620105151, 218, 26, 'PPL', 'P'),
(133583, 'Washington', 42.7244415283203, 0.745682175744988, -83.0361099243164, -1.44925351622726, 218, 27, 'PPL', 'P'),
(138685, 'Washington', 43.7758293151855, 0.764032354341042, -92.3386077880859, -1.61161273260978, 218, 28, 'PPL', 'P'),
(143314, 'Washington', 41.3974990844727, 0.722522661115386, -96.2077789306641, -1.67914250837092, 218, 35, 'PPL', 'P'),
(144598, 'Washington', 43.1758308410645, 0.753560405460687, -72.0972213745117, -1.25833389452446, 218, 36, 'PPL', 'P'),
(146561, 'Washington', 40.7583312988281, 0.711367078783208, -74.9797210693359, -1.30864300488688, 218, 37, 'PPL', 'P'),
(168517, 'Washington', 40.1738891601563, 0.701166639175986, -80.2463912963867, -1.40056374096567, 218, 45, 'PPL', 'P'),
(169654, 'Washington', 41.6883316040039, 0.727598646153077, -71.5672225952148, -1.24908367079418, 218, 47, 'PPL', 'P'),
(172697, 'Washington', 44.1055603027344, 0.769787245719622, -72.4330596923828, -1.26419537892567, 218, 55, 'PPL', 'P'),
(176870, 'Washington', 45.394718170166, 0.792287295084293, -86.9313888549805, -1.51723895885091, 218, 57, 'PPL', 'P'),
(186029, 'Washington', 39.3594398498535, 0.686951817120606, -120.798057556152, -2.10832383436847, 218, 6, 'PPL', 'P'),
(190899, 'Washington', 39.1552810668945, 0.683388574161108, -117.234169006348, -2.04612224500026, 218, 39, 'PPL', 'P'),
(192848, 'Washington', 37.1305618286133, 0.648050557024628, -113.507499694824, -1.98107959538114, 218, 52, 'PPL', 'P'),
(209106, 'Washington', 47.5002784729004, 0.829036254966296, -120.500282287598, -2.10312667550118, 218, 56, 'ADM1', 'A'),
(79337, 'Washington Boro', 39.9925003051758, 0.698000806430154, -76.4674987792969, -1.33460962446348, 218, 45, 'PPL', 'P'),
(179480, 'Washington Camp', 31.3819408416748, 0.547718193353306, -110.690559387207, -1.93191471218108, 218, 5, 'PPL', 'P'),
(123926, 'Washington Center', 41.0483283996582, 0.71642848301393, -85.5094375610352, -1.49242122696857, 218, 19, 'PPL', 'P'),
(139508, 'Washington Center', 40.4269409179688, 0.705583225527774, -94.1566696166992, -1.64334389752391, 218, 29, 'PPL', 'P'),
(13242, 'Washington City', 38.9000015258789, 0.678933105657405, -77.0166702270508, -1.34419447438472, 218, 9, 'PPL', 'P'),
(91656, 'Washington College', 36.2200012207031, 0.632158276377635, -82.5716705322266, -1.44114751965933, 218, 50, 'PPL', 'P'),
(209103, 'Washington Colony (historical)', 48.7533302307129, 0.850906133838027, -122.481941223145, -2.13771314857804, 218, 56, 'PPL', 'P'),
(107307, 'Washington Corner', 38.1216697692871, 0.665348653832047, -77.4049987792969, -1.35097208620092, 218, 53, 'PPL', 'P'),
(146562, 'Washington Corner', 40.7680587768555, 0.7115368553027, -74.5633316040039, -1.30137563774621, 218, 37, 'PPL', 'P'),
(52514, 'Washington Court', 39.5444412231445, 0.690180700205246, -76.995002746582, -1.34381630550993, 218, 25, 'PPL', 'P'),
(74699, 'Washington Court House', 39.5363883972168, 0.690040151878717, -83.4391708374023, -1.45628825624671, 218, 41, 'PPL', 'P'),
(52515, 'Washington Crest Heights', 39.1483306884766, 0.683267267173455, -76.6791687011719, -1.33830396152763, 218, 25, 'PPL', 'P'),
(146563, 'Washington Crossing', 40.2966690063477, 0.703309551747118, -74.8672180175781, -1.30667945621516, 218, 37, 'PPL', 'P'),
(168519, 'Washington Crossing', 40.2933311462402, 0.703251295098273, -74.8708267211914, -1.30674243997494, 218, 45, 'PPL', 'P'),
(107309, 'Washington Forest', 38.8377799987793, 0.677847135143898, -77.1172180175781, -1.34594936438503, 218, 53, 'PPL', 'P'),
(69906, 'Washington Forks', 35.142219543457, 0.613347437492024, -77.1044387817383, -1.34572632464374, 218, 33, 'PPL', 'P'),
(52516, 'Washington Four', 39.5111083984375, 0.689598932665118, -77.8077774047852, -1.35800189937235, 218, 25, 'PPL', 'P'),
(107310, 'Washington Gardens', 37.0430603027344, 0.646523367297522, -76.3152770996094, -1.33195285496001, 218, 53, 'PPL', 'P'),
(111927, 'Washington Gardens', 39.2319412231445, 0.684726546292763, -81.6730575561523, -1.42546376452569, 218, 58, 'PPL', 'P'),
(52517, 'Washington Grove', 39.139720916748, 0.683116998308947, -77.1755599975586, -1.34696762402782, 218, 25, 'PPL', 'P'),
(158175, 'Washington Hall', 40.5733299255371, 0.708138195698568, -81.0447235107422, -1.41449726663091, 218, 41, 'PPL', 'P'),
(91658, 'Washington Hall (historical)', 36.5200004577637, 0.637394250817812, -87.0055618286133, -1.5185335214568, 218, 50, 'PPL', 'P'),
(209104, 'Washington Harbor', 48.0791702270508, 0.839139822088866, -123.043891906738, -2.14752103824059, 218, 56, 'PPL', 'P'),
(6642, 'Washington Heights', 33.5652809143066, 0.585824666311464, -86.8266677856445, -1.51541123139479, 218, 2, 'PPL', 'P'),
(14800, 'Washington Heights', 38.7125015258789, 0.675660613309916, -75.095832824707, -1.31066953731837, 218, 10, 'PPL', 'P'),
(52518, 'Washington Heights', 38.3722190856934, 0.669721564341957, -75.5736083984375, -1.31900829416557, 218, 25, 'PPL', 'P'),
(69898, 'Washington Heights', 35.5494384765625, 0.620454748651173, -77.0358276367188, -1.34452883425958, 218, 33, 'PPL', 'P'),
(84224, 'Washington Heights', 34.9383316040039, 0.60978892164346, -81.9413909912109, -1.43014706646065, 218, 48, 'PPL', 'P'),
(91661, 'Washington Heights', 36.3055610656738, 0.63365157737987, -82.4250030517578, -1.43858768921955, 218, 50, 'PPL', 'P'),
(107311, 'Washington Heights', 37.2986106872559, 0.65098356291216, -80.0002822875977, -1.39626832844348, 218, 53, 'PPL', 'P'),
(111928, 'Washington Heights', 38.0355606079102, 0.663845765449888, -81.831672668457, -1.42823212047883, 218, 58, 'PPL', 'P'),
(146564, 'Washington Heights', 40.4550018310547, 0.706072980852239, -74.4100036621094, -1.29869956032485, 218, 37, 'PPL', 'P'),
(153472, 'Washington Heights', 41.4700012207031, 0.723788062107337, -74.4161071777344, -1.29880608676845, 218, 40, 'PPL', 'P'),
(168520, 'Washington Heights', 40.246940612793, 0.702441627547862, -76.8963928222656, -1.34209523765547, 218, 45, 'PPL', 'P'),
(172699, 'Washington Heights', 44.0897216796875, 0.769510809598472, -72.4594421386719, -1.26465583947815, 218, 55, 'PPL', 'P'),
(13244, 'Washington Highlands', 38.8319396972656, 0.677745202653175, -76.995002746582, -1.34381630550993, 218, 9, 'PPL', 'P'),
(6643, 'Washington Hill', 32.4080581665039, 0.56562731918333, -86.4677810668945, -1.50914747651092, 218, 2, 'PPL', 'P'),
(168521, 'Washington Hill', 40.252498626709, 0.702538633190568, -75.6305618286133, -1.32000231904245, 218, 45, 'PPL', 'P'),
(153473, 'Washington Hollow', 41.7819404602051, 0.729232428902813, -73.7583312988281, -1.28732573194134, 218, 40, 'PPL', 'P'),
(52520, 'Washington Junction', 39.2724990844727, 0.685434414510507, -77.5319366455078, -1.35318756991176, 218, 25, 'PPL', 'P'),
(129188, 'Washington Junction', 44.5533294677734, 0.777602291938459, -68.3811111450195, -1.19347553565278, 218, 26, 'PPL', 'P'),
(168522, 'Washington Junction', 40.3527793884277, 0.704288862658968, -80.0277786254883, -1.39674823007191, 218, 45, 'PPL', 'P'),
(52521, 'Washington Manor', 39.1697196960449, 0.683640575779256, -76.795280456543, -1.34033049395913, 218, 25, 'PPL', 'P'),
(52522, 'Washington Manor Park', 39.1827812194824, 0.683868542368567, -76.767219543457, -1.33984073863466, 218, 25, 'PPL', 'P'),
(74700, 'Washington Meadows', 39.5844383239746, 0.690878781305983, -82.8861083984375, -1.44663549571766, 218, 41, 'PPL', 'P'),
(195780, 'Washington Mill', 43.892219543457, 0.766063747041528, -115.757499694824, -2.02034950355101, 218, 17, 'PPL', 'P'),
(74701, 'Washington Mills', 39.6474990844727, 0.691979399205485, -84.0469436645508, -1.4668958931846, 218, 41, 'PPL', 'P'),
(118279, 'Washington Mills', 42.3005599975586, 0.738284047394802, -90.7822189331055, -1.58444862264902, 218, 16, 'PPL', 'P'),
(153474, 'Washington Mills', 43.0499992370605, 0.751364229667753, -75.2733306884766, -1.31376745945641, 218, 40, 'PPL', 'P'),
(143318, 'Washington Mobile Home Terrace', 41.1263885498047, 0.717790889648588, -95.8958282470703, -1.67369794183836, 218, 35, 'PPL', 'P'),
(14801, 'Washington Park', 39.6611099243164, 0.69221695317472, -75.5811080932617, -1.31913918853315, 218, 10, 'PPL', 'P'),
(18502, 'Washington Park', 26.8416690826416, 0.468475502222862, -81.0963897705078, -1.41539901297601, 218, 12, 'PPL', 'P'),
(28914, 'Washington Park', 38.6349983215332, 0.674307927213237, -90.0927810668945, -1.57241566189572, 218, 18, 'PPL', 'P'),
(52523, 'Washington Park', 39.2247200012207, 0.684600512194176, -76.0858306884766, -1.32794825962886, 218, 25, 'PPL', 'P'),
(69901, 'Washington Park', 35.7994384765625, 0.624818071781158, -80.2702789306641, -1.40098065883432, 218, 33, 'PPL', 'P'),
(84225, 'Washington Park', 33.9588890075684, 0.592694423501377, -80.9944381713867, -1.41361962189367, 218, 48, 'PPL', 'P'),
(107314, 'Washington Park', 36.9086112976074, 0.644176789482026, -76.2455596923828, -1.33073605665795, 218, 53, 'PPL', 'P'),
(146565, 'Washington Park', 40.5138893127441, 0.707100761295928, -74.3986129760742, -1.29850075534947, 218, 37, 'PPL', 'P'),
(168523, 'Washington Park', 40.1049995422363, 0.699964288522843, -75.379997253418, -1.31562914221643, 218, 45, 'PPL', 'P'),
(179481, 'Washington Park', 34.4244384765625, 0.600819794566236, -111.266937255859, -1.94197440372469, 218, 5, 'PPL', 'P'),
(209105, 'Washington Park', 46.5969390869141, 0.813270008417891, -120.486938476563, -2.10289378206386, 218, 56, 'PPL', 'P'),
(31430, 'Washington Place', 39.7769393920898, 0.6942385587582, -86.0163879394531, -1.5012691802162, 218, 19, 'PPL', 'P'),
(118280, 'Washington Prairie', 43.2702789306641, 0.755208835596419, -91.6136093139648, -1.59895912216443, 218, 16, 'PPL', 'P'),
(107316, 'Washington Springs', 36.8166694641113, 0.642572101767199, -81.7486114501953, -1.42678242873944, 218, 53, 'PPL', 'P'),
(168524, 'Washington Square', 40.148609161377, 0.700725419962387, -75.3077774047852, -1.31436866807249, 218, 45, 'PPL', 'P'),
(206347, 'Washington Terrace', 41.172779083252, 0.718600557198999, -111.975830078125, -1.95434691751698, 218, 52, 'PPL', 'P'),
(206348, 'Washington Terrace Parcel H', 41.1708297729492, 0.718566535316073, -111.988609313965, -1.95456995725827, 218, 52, 'PPL', 'P'),
(84228, 'Washington Town', 33.0958290100098, 0.577631184901726, -80.1805572509766, -1.39941472011335, 218, 48, 'PPL', 'P'),
(179482, 'Washington Trailer Park', 33.4486083984375, 0.583788346762962, -112.006942749023, -1.95488993606325, 218, 5, 'PPL', 'P'),
(146566, 'Washington Valley', 40.8055610656738, 0.712191393719614, -74.5274963378906, -1.30075019436421, 218, 37, 'PPL', 'P'),
(146573, 'Washingtonville', 41.0977783203125, 0.717291546944198, -74.7513885498047, -1.30465785063168, 218, 37, 'PPL', 'P'),
(153476, 'Washingtonville', 41.4277801513672, 0.723051165433712, -74.166389465332, -1.29444769048648, 218, 40, 'PPL', 'P'),
(158204, 'Washingtonville', 40.9002799987793, 0.713844550966281, -80.7641677856445, -1.40960064549263, 218, 41, 'PPL', 'P'),
(168545, 'Washingtonville', 41.0516700744629, 0.716486806241803, -76.6750030517578, -1.33823125722987, 218, 45, 'PPL', 'P'),
(12687, 'Washita', 34.6527786254883, 0.604805081979486, -93.533332824707, -1.63246461815483, 218, 4, 'PPL', 'P'),
(77602, 'Washita', 34.5469398498535, 0.602957846868379, -97.1311111450195, -1.69525769560115, 218, 42, 'PPL', 'P'),
(186030, 'Washoe', 38.3058280944824, 0.668562822951664, -122.734718322754, -2.14212494123987, 218, 6, 'PPL', 'P'),
(193158, 'Washoe', 44.0544395446777, 0.768895020175418, -116.947219848633, -2.04111403741231, 218, 17, 'PPL', 'P'),
(209882, 'Washoe', 45.163890838623, 0.788258598145275, -109.212501525879, -1.90611773596592, 218, 31, 'PPL', 'P'),
(190903, 'Washoe City', 39.3202781677246, 0.686268316826838, -119.808609008789, -2.09105469943791, 218, 39, 'PPL', 'P'),
(209107, 'Washougal', 45.5827789306641, 0.795569574548788, -122.35221862793, -2.13544906217731, 218, 56, 'PPL', 'P'),
(118330, 'Washta', 42.5755615234375, 0.743083729469397, -95.7172164916992, -1.67058057862437, 218, 16, 'PPL', 'P'),
(209108, 'Washtucna', 46.7566719055176, 0.816057872026013, -118.309440612793, -2.06488927488593, 218, 56, 'PPL', 'P'),
(77606, 'Washunga', 36.7836112976074, 0.641995127917033, -96.8377838134766, -1.69013816787964, 218, 42, 'PPL', 'P'),
(98926, 'Wasicek Colonia', 27.9610004425049, 0.488011519873302, -98.0879974365234, -1.71195851195509, 218, 51, 'PPL', 'P'),
(212225, 'Wasilla', 61.5813903808594, 1.07479802010196, -149.439437866211, -2.60821022309487, 218, 1, 'PPL', 'P'),
(25822, 'Wasilla Estates', 33.8394393920898, 0.590609634421036, -84.6958312988281, -1.47822111887822, 218, 13, 'PPL', 'P'),
(138689, 'Wasioja', 44.0802803039551, 0.769346026506023, -92.8191680908203, -1.62000009214687, 218, 28, 'PPL', 'P'),
(38759, 'Wasioto', 36.747501373291, 0.641364890845066, -83.6888885498047, -1.46064665252867, 218, 21, 'PPL', 'P'),
(138691, 'Waskish', 48.1613883972168, 0.840574799863228, -94.5122222900391, -1.64954946233796, 218, 28, 'PPL', 'P'),
(98927, 'Waskom', 32.4786109924316, 0.566858698292355, -94.059440612793, -1.64164693127731, 218, 51, 'PPL', 'P'),
(58162, 'Wasola', 36.7936096191406, 0.642169631547461, -92.5755615234375, -1.61574835546656, 218, 29, 'PPL', 'P'),
(91664, 'Wasp', 35.8544387817383, 0.625778008196078, -82.9322204589844, -1.44744030299908, 218, 50, 'PPL', 'P'),
(111933, 'Wasp', 39.4300003051758, 0.688183329387686, -81.0441665649414, -1.41448754609293, 218, 58, 'PPL', 'P'),
(153477, 'Wassaic', 41.8038902282715, 0.729615524625621, -73.5591735839844, -1.28384977408656, 218, 40, 'PPL', 'P'),
(199059, 'Wassaic', 48.4061088562012, 0.844845977619497, -102.377777099609, -1.78682929126103, 218, 34, 'PPL', 'P'),
(84229, 'Wassamassaw (historical)', 33.1494407653809, 0.578566886550725, -80.1624984741211, -1.39909953499834, 218, 48, 'PPL', 'P'),
(168548, 'Wassergass', 40.5858306884766, 0.708356375170873, -75.2916717529297, -1.31408757141943, 218, 45, 'PPL', 'P'),
(77607, 'Wasseta', 34.079719543457, 0.594803314189584, -96.3099975585938, -1.68092655998516, 218, 42, 'PPL', 'P'),
(158205, 'Wassie (historical)', 41.3480606079102, 0.7216597969222, -80.8983306884766, -1.41194222988109, 218, 41, 'PPL', 'P'),
(28915, 'Wasson', 37.7880592346191, 0.659526051582752, -88.4847183227539, -1.54434967243181, 218, 18, 'PPL', 'P'),
(192397, 'Wasson', 34.2213897705078, 0.597275926103668, -101.758331298828, -1.77601792249975, 218, 51, 'PPL', 'P'),
(118331, 'Wassonville (historical)', 41.4916687011719, 0.724166230982128, -91.8791732788086, -1.6035940877256, 218, 16, 'PPL', 'P'),
(202752, 'Wasta', 44.0686111450195, 0.769142361261659, -102.445281982422, -1.78800747372729, 218, 49, 'PPL', 'P'),
(138693, 'Wastedo', 44.4047203063965, 0.775008572773804, -92.8511123657227, -1.62055762492108, 218, 28, 'PPL', 'P'),
(192398, 'Wastella', 32.5102806091309, 0.567411437376601, -100.649169921875, -1.75665940453596, 218, 51, 'PPL', 'P'),
(18503, 'Wasupa (historical)', 30.2166690826416, 0.52738036447767, -84.3000030517578, -1.47131261269444, 218, 12, 'PPL', 'P'),
(138694, 'Watab', 45.6763916015625, 0.797203423877552, -94.1808319091797, -1.64376560908252, 218, 28, 'PPL', 'P'),
(114223, 'Wataba Lake', 41.3405609130859, 0.721528902554623, -73.4913864135742, -1.2826666647723, 218, 8, 'PPL', 'P'),
(121872, 'Wataga', 41.0252799987793, 0.716026212531274, -90.2797164916992, -1.57567830054718, 218, 18, 'PPL', 'P'),
(139515, 'Wataga', 40.5605583190918, 0.707915289115329, -93.633056640625, -1.63420512708525, 218, 29, 'PPL', 'P'),
(112248, 'Watalula', 35.5733299255371, 0.620871733098852, -93.8272171020508, -1.63759386641432, 218, 4, 'PPL', 'P'),
(38760, 'Watauga', 36.8169403076172, 0.642576828878134, -85.0647201538086, -1.48465944397154, 218, 21, 'PPL', 'P'),
(91665, 'Watauga', 36.3705596923828, 0.634786017425216, -82.2969436645508, -1.4363526312747, 218, 50, 'PPL', 'P'),
(98928, 'Watauga', 32.857780456543, 0.57347645386412, -97.2544403076172, -1.69741019555221, 218, 51, 'PPL', 'P'),
(107317, 'Watauga', 36.6780586242676, 0.640152886232971, -81.9333267211914, -1.43000631839704, 218, 53, 'PPL', 'P'),
(202755, 'Watauga', 45.922779083252, 0.80150369666873, -101.542503356934, -1.77225101429589, 218, 49, 'PPL', 'P'),
(69908, 'Watauga Falls (historical)', 36.2508316040039, 0.632696368075885, -81.8552780151367, -1.42864411149946, 218, 33, 'PPL', 'P'),
(91666, 'Watauga Flats', 36.3786087036133, 0.634926499172718, -82.3116683959961, -1.43660962631989, 218, 50, 'PPL', 'P'),
(91667, 'Watauga Point', 36.3269386291504, 0.63402468624859, -82.2669372558594, -1.43582892064633, 218, 50, 'PPL', 'P'),
(91668, 'Watauga Valley', 36.3847198486328, 0.635033158774375, -82.1416702270508, -1.43364259854943, 218, 50, 'PPL', 'P'),
(74718, 'Watch Farm Acres', 39.0644416809082, 0.681803127785156, -84.3794403076172, -1.47269905435794, 218, 41, 'PPL', 'P'),
(74719, 'Watch Hill', 39.0636100769043, 0.681788613557215, -84.3716735839844, -1.47256349945845, 218, 41, 'PPL', 'P'),
(169656, 'Watch Hill', 41.3136100769043, 0.721058521727088, -71.8502807617188, -1.25402396777433, 218, 47, 'PPL', 'P'),
(192850, 'Watchman Residential Area', 37.2033309936523, 0.649320618548487, -112.97917175293, -1.9718585332648, 218, 52, 'PPL', 'P'),
(77608, 'Watchorn', 36.4199981689453, 0.635648881618402, -96.9963912963867, -1.69290639067472, 218, 42, 'PPL', 'P'),
(146574, 'Watchung', 40.6377792358398, 0.709263048363991, -74.4513931274414, -1.29942194277053, 218, 37, 'PPL', 'P'),
(206350, 'Watchwood', 40.6797218322754, 0.709995084768626, -111.949996948242, -1.95389604434443, 218, 52, 'PPL', 'P'),
(52525, 'Water Acres', 39.3736114501953, 0.687199158206848, -77.7444381713867, -1.35689642120386, 218, 25, 'PPL', 'P'),
(98929, 'Water City Estates Colonia', 27.7700004577637, 0.484677941268309, -97.9499969482422, -1.70954994906522, 218, 51, 'PPL', 'P'),
(91669, 'Water Fork Mill', 36.1144409179688, 0.630315901535518, -82.7430572509766, -1.44413878219571, 218, 50, 'PPL', 'P'),
(153478, 'Water Island', 40.6755599975586, 0.709922447049894, -73.0297164916992, -1.27460900457815, 218, 40, 'PPL', 'P'),
(153479, 'Water Mill', 40.9058303833008, 0.713941423450933, -72.3625030517578, -1.26296393323762, 218, 40, 'PPL', 'P'),
(69910, 'Water Oak', 35.0397186279297, 0.611558459029763, -80.7141723632813, -1.40872806076147, 218, 33, 'PPL', 'P'),
(52526, 'Water Oak Cove', 39.146671295166, 0.6832383052966, -76.5124969482422, -1.33539499066894, 218, 25, 'PPL', 'P'),
(52527, 'Water Oak Forest', 39.1438903808594, 0.683189769185733, -76.5094375610352, -1.33534159428908, 218, 25, 'PPL', 'P'),
(52528, 'Water Oak Point', 39.1505584716797, 0.68330614932537, -76.5108337402344, -1.33536596221306, 218, 25, 'PPL', 'P'),
(84231, 'Water Oaks', 34.8761100769043, 0.608702951129953, -82.0755615234375, -1.43248878400716, 218, 48, 'PPL', 'P'),
(25823, 'Water Pipe', 31.8519401550293, 0.555921228853454, -84.6388931274414, -1.47722736031745, 218, 13, 'PPL', 'P'),
(168549, 'Water Street', 40.5713882446289, 0.708104306973697, -78.1383285522461, -1.36377110524179, 218, 45, 'PPL', 'P'),
(6647, 'Water Valley', 31.8938903808594, 0.556653398416144, -88.3930587768555, -1.542749911565, 218, 2, 'PPL', 'P'),
(28916, 'Water Valley', 37.5586090087891, 0.655521389672573, -89.1752777099609, -1.55640220741913, 218, 18, 'PPL', 'P'),
(38761, 'Water Valley', 36.565559387207, 0.638189404140283, -88.8111114501953, -1.55004630716154, 218, 21, 'PPL', 'P'),
(62227, 'Water Valley', 34.1513900756836, 0.596054200953594, -89.6313934326172, -1.56436292854959, 218, 30, 'PPL', 'P'),
(91672, 'Water Valley', 35.9927787780762, 0.628192496619371, -87.6425018310547, -1.52965022163706, 218, 50, 'PPL', 'P'),
(153480, 'Water Valley', 42.7055587768555, 0.74535260956009, -78.8502807617188, -1.37619701541393, 218, 40, 'PPL', 'P'),
(192399, 'Water Valley', 31.6674995422363, 0.552702132885821, -100.716667175293, -1.75783745384416, 218, 51, 'PPL', 'P'),
(25824, 'Water Valley (historical)', 34.5958290100098, 0.603811123681641, -84.9463882446289, -1.48259416254618, 218, 13, 'PPL', 'P'),
(91671, 'Water Valley (historical)', 36.0338897705078, 0.628910018796065, -87.4550018310547, -1.52637772928957, 218, 50, 'PPL', 'P'),
(62225, 'Water Valley Landing', 34.149169921875, 0.596015451959733, -89.7733306884766, -1.56684020099558, 218, 30, 'PPL', 'P'),
(52530, 'Water View', 39.3591690063477, 0.686947090009672, -77.2683334350586, -1.34858682597059, 218, 25, 'PPL', 'P'),
(107318, 'Water View', 37.7244415283203, 0.658415713145271, -76.6138916015625, -1.3371646612133, 218, 53, 'PPL', 'P'),
(126451, 'Water View Village', 41.9036102294922, 0.731355966977015, -70.7869415283203, -1.2354651970859, 218, 23, 'PPL', 'P'),
(144600, 'Water Village', 43.6824989318848, 0.762403431860295, -71.1849975585938, -1.24241258542159, 218, 36, 'PPL', 'P'),
(113224, 'Waterboro', 42.1719398498535, 0.736039202332947, -79.0699996948242, -1.38003183422559, 218, 40, 'PPL', 'P'),
(129189, 'Waterboro', 43.5355606079102, 0.759838874309576, -70.7155609130859, -1.23421937032796, 218, 26, 'PPL', 'P'),
(129190, 'Waterboro Center', 43.589168548584, 0.760774509379548, -70.7102813720703, -1.23412722495424, 218, 26, 'PPL', 'P'),
(153481, 'Waterburg', 42.5055618286133, 0.741862004319323, -76.6763916015625, -1.33825549199579, 218, 40, 'PPL', 'P'),
(18504, 'Waterbury', 27.4452800750732, 0.479010501442025, -82.3033294677734, -1.43646408456632, 218, 12, 'PPL', 'P'),
(52531, 'Waterbury', 39.0475006103516, 0.68150745032513, -76.6269378662109, -1.3373923614865, 218, 25, 'PPL', 'P'),
(114224, 'Waterbury', 41.5580596923828, 0.725324972372422, -73.0519409179688, -1.27499689399092, 218, 8, 'PPL', 'P'),
(143326, 'Waterbury', 42.4577789306641, 0.741028035423965, -96.7344436645508, -1.68833454203138, 218, 35, 'PPL', 'P'),
(172704, 'Waterbury', 44.3377799987793, 0.773840244003586, -72.7566680908203, -1.26984341096551, 218, 55, 'PPL', 'P'),
(176880, 'Waterbury', 44.3852806091309, 0.774669286050928, -90.5983276367188, -1.58123911406132, 218, 57, 'PPL', 'P'),
(172701, 'Waterbury Center', 44.378059387207, 0.77454325195234, -72.7163925170898, -1.26914046959578, 218, 55, 'PPL', 'P'),
(206351, 'Waterbury Condominium', 40.646671295166, 0.709418244076515, -111.847503662109, -1.95210719904022, 218, 52, 'PPL', 'P'),
(52532, 'Waterbury Heights', 39.0552787780762, 0.681643204961697, -76.6130599975586, -1.33715014698536, 218, 25, 'PPL', 'P'),
(18505, 'Watercolor', 30.3222198486328, 0.529222572872219, -86.1458282470703, -1.50352833976891, 218, 12, 'PPL', 'P'),
(84233, 'Wateree', 33.8069381713867, 0.590042381108849, -80.6374969482422, -1.40738982231371, 218, 48, 'PPL', 'P'),
(107319, 'Waterfall', 38.8622207641602, 0.678273706971501, -77.6719436645508, -1.35563115336996, 218, 53, 'PPL', 'P'),
(168550, 'Waterfall', 40.127498626709, 0.700356971625575, -78.0630569458008, -1.36245736787605, 218, 45, 'PPL', 'P'),
(193324, 'Waterfall', 55.2972183227539, 0.965118526926192, -133.24055480957, -2.32548637861097, 218, 1, 'PPL', 'P'),
(107320, 'Waterfall Lake', 37.3519401550293, 0.651914337713142, -79.9250030517578, -1.39495445791969, 218, 53, 'PPL', 'P'),
(98930, 'Waterfall Road Colonia', 26.1030006408691, 0.455583305833356, -97.9069976806641, -1.70879947027004, 218, 51, 'PPL', 'P'),
(107321, 'Waterfall Village', 38.8677787780762, 0.678370712614208, -77.6691665649414, -1.35558268383812, 218, 53, 'PPL', 'P'),
(790, 'Waterford', 36.0288887023926, 0.628822733691338, -80.4113922119141, -1.40344355021043, 218, 33, 'PPL', 'P'),
(6648, 'Waterford', 31.3525009155273, 0.547204369710489, -85.6013870239258, -1.49402604784145, 218, 2, 'PPL', 'P'),
(25832, 'Waterford', 33.9083290100098, 0.59181198507418, -83.3236083984375, -1.45427131119513, 218, 13, 'PPL', 'P'),
(38762, 'Waterford', 38.038890838623, 0.663903888940679, -85.4372177124023, -1.49116075282464, 218, 21, 'PPL', 'P'),
(44038, 'Waterford', 29.9963893890381, 0.523535758549005, -90.4730606079102, -1.57905279196441, 218, 22, 'PPL', 'P'),
(52533, 'Waterford', 39.2033309936523, 0.684227203588374, -76.9730606079102, -1.34343334294518, 218, 25, 'PPL', 'P'),
(62226, 'Waterford', 34.6474990844727, 0.604712936605769, -89.4572219848633, -1.56132306332332, 218, 30, 'PPL', 'P'),
(84234, 'Waterford', 34.160831451416, 0.596218984046043, -79.833610534668, -1.39335935758479, 218, 48, 'PPL', 'P'),
(107322, 'Waterford', 39.1866683959961, 0.683936386397337, -77.6102828979492, -1.35455496997346, 218, 53, 'PPL', 'P'),
(123950, 'Waterford', 41.6713905334473, 0.727302968693051, -86.8450012207031, -1.51573121019976, 218, 19, 'PPL', 'P'),
(133588, 'Waterford', 42.702220916748, 0.745294352911245, -83.4027786254883, -1.45565309232672, 218, 27, 'PPL', 'P'),
(138697, 'Waterford', 44.4838905334473, 0.776390353905392, -93.1427764892578, -1.62564812418671, 218, 28, 'PPL', 'P'),
(153482, 'Waterford', 42.7924995422363, 0.74687001217019, -73.6816711425781, -1.28598775980968, 218, 40, 'PPL', 'P'),
(158206, 'Waterford', 40.5433311462402, 0.707614618228259, -82.6188888549805, -1.44197163485866, 218, 41, 'PPL', 'P'),
(168552, 'Waterford', 40.2544403076172, 0.702572521915439, -79.1677780151367, -1.38173838785212, 218, 45, 'PPL', 'P'),
(169657, 'Waterford', 42.0125007629395, 0.733256465309923, -71.5388870239258, -1.24858912177975, 218, 47, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(176887, 'Waterford', 42.7630615234375, 0.746356221816887, -88.2141723632813, -1.53962775466105, 218, 57, 'PPL', 'P'),
(186031, 'Waterford', 37.6413917541504, 0.656966221142968, -120.759437561035, -2.10764978829657, 218, 6, 'PPL', 'P'),
(209109, 'Waterford', 46.1533317565918, 0.805527599917785, -123.266670227051, -2.1514092534321, 218, 56, 'PPL', 'P'),
(121873, 'Waterford (historical)', 40.3388900756836, 0.704046448420743, -90.1297225952148, -1.57306041319563, 218, 18, 'PPL', 'P'),
(129192, 'Waterford Flat', 44.1813888549805, 0.771110703623337, -70.7177810668945, -1.23425811932182, 218, 26, 'PPL', 'P'),
(25828, 'Waterford Green', 33.3569412231445, 0.582188452738097, -84.5380630493164, -1.47546754346913, 218, 13, 'PPL', 'P'),
(84235, 'Waterford Heights', 33.4119415283203, 0.583148389153016, -79.1402816772461, -1.38125848622368, 218, 48, 'PPL', 'P'),
(123971, 'Waterford Mills', 41.5430603027344, 0.725063183637267, -85.8305587768555, -1.49802584948264, 218, 19, 'PPL', 'P'),
(25829, 'Waterford Place', 33.0811080932617, 0.57737425643556, -85.0486068725586, -1.48437821416042, 218, 13, 'PPL', 'P'),
(52535, 'Waterford Place', 39.3238906860352, 0.686331367165645, -76.758056640625, -1.3396808158112, 218, 25, 'PPL', 'P'),
(84236, 'Waterford Place', 32.3958282470703, 0.56541386682196, -80.6902770996094, -1.40831100973476, 218, 48, 'PPL', 'P'),
(25830, 'Waterford South', 32.5277786254883, 0.567716835374606, -83.5583267211914, -1.45836791874195, 218, 13, 'PPL', 'P'),
(186032, 'Waterford Village', 38.7272186279297, 0.675917475197054, -121.077781677246, -2.11320594127881, 218, 6, 'PPL', 'P'),
(71521, 'Waterford Works', 39.7230606079102, 0.693298196577293, -74.8494415283203, -1.30636919794817, 218, 37, 'PPL', 'P'),
(84237, 'Waterfored Estates', 33.4716682434082, 0.5841908169827, -79.2769393920898, -1.38364361329596, 218, 48, 'PPL', 'P'),
(25831, 'Waterfront', 34.0247192382813, 0.593843377774665, -84.4124984741211, -1.4732760282081, 218, 13, 'PPL', 'P'),
(38763, 'Watergap', 37.6363906860352, 0.656878936038241, -82.7458267211914, -1.44418711856949, 218, 21, 'PPL', 'P'),
(52536, 'Watergate', 38.9152793884277, 0.679199754661549, -76.4749984741211, -1.33474051883105, 218, 25, 'PPL', 'P'),
(84238, 'Watergate', 33.6936111450195, 0.588064451367247, -78.9802780151367, -1.37846589550463, 218, 48, 'PPL', 'P'),
(91673, 'Waterhaven', 35.7958297729492, 0.624755088021378, -84.168327331543, -1.46901443783176, 218, 50, 'PPL', 'P'),
(6649, 'Waterhouse', 34.2055587768555, 0.596999623140572, -85.4891662597656, -1.49206742601776, 218, 2, 'PPL', 'P'),
(107326, 'Waterlick', 38.9661102294922, 0.680086920199682, -78.2861099243164, -1.36635037675753, 218, 53, 'PPL', 'P'),
(69912, 'Waterlily', 36.3813896179199, 0.634975035283584, -75.9197235107422, -1.3250491424662, 218, 33, 'PPL', 'P'),
(6650, 'Waterloo', 34.9180603027344, 0.609435120692643, -88.0641708374023, -1.53700973415144, 218, 2, 'PPL', 'P'),
(12693, 'Waterloo', 33.5430603027344, 0.585436843477721, -93.2458267211914, -1.6274466900289, 218, 4, 'PPL', 'P'),
(25833, 'Waterloo', 31.5933303833008, 0.551407636858961, -83.4744415283203, -1.45690384593268, 218, 13, 'PPL', 'P'),
(28917, 'Waterloo', 38.3358306884766, 0.669086467001001, -90.1497192382813, -1.57340942045648, 218, 18, 'PPL', 'P'),
(34348, 'Waterloo', 37.6769409179688, 0.657586671097929, -97.940559387207, -1.7093852325518, 218, 20, 'PPL', 'P'),
(38764, 'Waterloo', 38.9722213745117, 0.68019357980134, -84.7897186279297, -1.47985976189694, 218, 21, 'PPL', 'P'),
(44039, 'Waterloo', 30.6944408416748, 0.535719054745845, -91.3572235107422, -1.59448434574282, 218, 22, 'PPL', 'P'),
(52540, 'Waterloo', 38.2311096191406, 0.667258739544879, -76.7794418334961, -1.34005405783798, 218, 25, 'PPL', 'P'),
(77616, 'Waterloo', 35.7252807617188, 0.62352377549138, -97.477783203125, -1.70130826443976, 218, 42, 'PPL', 'P'),
(84239, 'Waterloo', 34.351390838623, 0.599544872773388, -82.059440612793, -1.43220742103799, 218, 48, 'PPL', 'P'),
(91674, 'Waterloo', 36.3016700744629, 0.633583666772073, -85.4663925170898, -1.49166994922506, 218, 50, 'PPL', 'P'),
(98931, 'Waterloo', 30.6386108398438, 0.534744637392498, -97.3880615234375, -1.69974232571879, 218, 51, 'PPL', 'P'),
(107325, 'Waterloo', 37.5955581665039, 0.656166274130536, -77.1680603027344, -1.34683672966025, 218, 53, 'PPL', 'P'),
(111934, 'Waterloo', 38.7308311462402, 0.675980525535862, -81.9347229003906, -1.43003068632101, 218, 58, 'PPL', 'P'),
(118334, 'Waterloo', 42.4927787780762, 0.741638897999002, -92.3427810668945, -1.61168557006559, 218, 16, 'PPL', 'P'),
(123951, 'Waterloo', 41.4319381713867, 0.723123736573417, -85.0199966430664, -1.48387887145603, 218, 19, 'PPL', 'P'),
(133602, 'Waterloo', 42.3530616760254, 0.739200374546871, -84.1402816772461, -1.4685249488234, 218, 27, 'PPL', 'P'),
(139516, 'Waterloo', 40.4494400024414, 0.705975908630506, -91.6686096191406, -1.59991905857935, 218, 29, 'PPL', 'P'),
(143327, 'Waterloo', 41.2869415283203, 0.720593067747569, -96.2852783203125, -1.68049512788857, 218, 35, 'PPL', 'P'),
(144602, 'Waterloo', 43.2894401550293, 0.755543262050306, -71.8552780151367, -1.25411118630003, 218, 36, 'PPL', 'P'),
(146578, 'Waterloo', 40.3561096191406, 0.704346986149759, -73.9875030517578, -1.29132553358253, 218, 37, 'PPL', 'P'),
(153486, 'Waterloo', 42.9047203063965, 0.748828633993889, -76.8630599975586, -1.34151347011534, 218, 40, 'PPL', 'P'),
(158208, 'Waterloo', 40.5152816772461, 0.707125062640875, -81.0708312988281, -1.41495293349342, 218, 41, 'PPL', 'P'),
(168558, 'Waterloo', 41.9888916015625, 0.732844407710261, -76.8550033569336, -1.34137285520979, 218, 45, 'PPL', 'P'),
(176883, 'Waterloo', 43.1838912963867, 0.753701086945271, -88.9883270263672, -1.55313930245156, 218, 57, 'PPL', 'P'),
(186033, 'Waterloo', 38.0347213745117, 0.663831118063893, -121.185829162598, -2.11509172564669, 218, 6, 'PPL', 'P'),
(189799, 'Waterloo', 31.9850006103516, 0.558243571903031, -107.721672058105, -1.88009785316752, 218, 38, 'PPL', 'P'),
(193218, 'Waterloo', 44.4941711425781, 0.776569784383836, -122.824172973633, -2.14368621942893, 218, 43, 'PPL', 'P'),
(197798, 'Waterloo', 45.7219390869141, 0.79799837746294, -112.191390991211, -1.95810916518894, 218, 31, 'PPL', 'P'),
(209110, 'Waterloo', 48.3675003051758, 0.844172131284679, -118.116668701172, -2.06152477032278, 218, 56, 'PPL', 'P'),
(107327, 'Waterloo Heights', 39.0847206115723, 0.682157061894028, -78.0841674804688, -1.36282581621286, 218, 53, 'PPL', 'P'),
(153484, 'Waterloo Mills', 41.3224983215332, 0.721213650860585, -74.5774993896484, -1.30162291225343, 218, 40, 'PPL', 'P'),
(168556, 'Waterloo Mills', 40.0230598449707, 0.69853417101747, -75.4211120605469, -1.31634673097215, 218, 45, 'PPL', 'P'),
(6651, 'Waterloo Springs', 34.3222198486328, 0.599035742951992, -85.5883331298828, -1.4937982144102, 218, 2, 'PPL', 'P'),
(98932, 'Waterman', 31.7102508544922, 0.553448284044234, -94.3905334472656, -1.64742559136862, 218, 51, 'PPL', 'P'),
(118337, 'Waterman', 42.9558296203613, 0.749720659801011, -95.4444427490234, -1.66581977870169, 218, 16, 'PPL', 'P'),
(121875, 'Waterman', 41.771671295166, 0.729053198161451, -88.7736129760742, -1.54939183532366, 218, 18, 'PPL', 'P'),
(168557, 'Waterman', 40.5308303833008, 0.707396438755954, -79.1269378662109, -1.38102559278636, 218, 45, 'PPL', 'P'),
(201754, 'Waterman', 45.8883285522461, 0.800902421473617, -118.540832519531, -2.06892782552099, 218, 43, 'PPL', 'P'),
(209111, 'Waterman', 47.5736083984375, 0.830316103607161, -122.579437255859, -2.13941477535655, 218, 56, 'PPL', 'P'),
(201755, 'Waterman (historical)', 44.6194381713867, 0.778756106480736, -119.889167785645, -2.09246071533542, 218, 43, 'PPL', 'P'),
(153490, 'Waterman Corner', 42.2277793884277, 0.737013786133861, -79.3983306884766, -1.38576229110117, 218, 40, 'PPL', 'P'),
(209113, 'Waterman Point', 47.5847206115723, 0.830510048313546, -122.56861114502, -2.13922582407721, 218, 56, 'PPL', 'P'),
(114227, 'Waterman Point (historical)', 41.5186080932617, 0.724636412072582, -72.0800018310547, -1.25803335679545, 218, 8, 'PPL', 'P'),
(186034, 'Watermans Corner', 32.7811088562012, 0.572138281995383, -115.446937561035, -2.01492917178438, 218, 6, 'PPL', 'P'),
(153487, 'Watermill', 40.9288902282715, 0.714343893670671, -72.3480606079102, -1.26271186504044, 218, 40, 'PPL', 'P'),
(6652, 'Wateroak', 32.8638916015625, 0.573583113465778, -87.4541702270508, -1.52636321506163, 218, 2, 'PPL', 'P'),
(153488, 'Waterport', 43.3169403076172, 0.756023230257765, -78.2516708374023, -1.3657493012995, 218, 40, 'PPL', 'P'),
(153489, 'Waterport Station', 43.3277816772461, 0.756212447853215, -78.2463912963867, -1.36565715592578, 218, 40, 'PPL', 'P'),
(12694, 'Waterproof', 34.9063911437988, 0.609231455448279, -91.7733306884766, -1.60174678603547, 218, 4, 'PPL', 'P'),
(44041, 'Waterproof', 29.562780380249, 0.515967853679327, -90.7949981689453, -1.58467166239032, 218, 22, 'PPL', 'P'),
(25834, 'Waters', 32.7555618286133, 0.571692402249876, -81.6658325195313, -1.42533766384808, 218, 13, 'PPL', 'P'),
(133591, 'Waters', 44.8797187805176, 0.783298860089166, -84.6986083984375, -1.47826958841006, 218, 27, 'PPL', 'P'),
(98933, 'Waters Bluff', 32.5022201538086, 0.567270755892018, -95.1188888549805, -1.66013779135795, 218, 51, 'PPL', 'P'),
(44044, 'Waters Edge', 30.5686092376709, 0.533522878952911, -91.1041717529297, -1.59006775939104, 218, 22, 'PPL', 'P'),
(52541, 'Waters Edge', 39.3977813720703, 0.687621002923516, -76.9736099243164, -1.3434429303251, 218, 25, 'PPL', 'P'),
(84241, 'Waters Edge', 32.9486083984375, 0.57506170050299, -80.1677780151367, -1.39919168037206, 218, 48, 'PPL', 'P'),
(18506, 'Waters Lake', 29.708890914917, 0.518517963581132, -82.732780456543, -1.44395941829629, 218, 12, 'PPL', 'P'),
(62229, 'Waters Landing', 30.7905597686768, 0.537396646495513, -88.4647216796875, -1.54400066517096, 218, 30, 'PPL', 'P'),
(98934, 'Waters Park', 30.4177799224854, 0.530890410794395, -97.7050018310547, -1.70527397761899, 218, 51, 'PPL', 'P'),
(25835, 'Waters Store (historical)', 34.3261108398438, 0.599103653559789, -85.0777816772461, -1.48488741056085, 218, 13, 'PPL', 'P'),
(91675, 'Watershaw', 35.788890838623, 0.624633980770807, -84.1444396972656, -1.46859751996311, 218, 50, 'PPL', 'P'),
(69914, 'Watership Downs', 35.690559387207, 0.622917773185332, -80.307502746582, -1.40163033698225, 218, 33, 'PPL', 'P'),
(168559, 'Waterside', 40.1897201538086, 0.701442942139082, -78.376106262207, -1.36792110916846, 218, 45, 'PPL', 'P'),
(52543, 'Watersman', 38.9597206115723, 0.679975400329035, -76.216667175293, -1.33023178710555, 218, 25, 'PPL', 'P'),
(133592, 'Watersmeet', 46.2677803039551, 0.807525103893399, -89.1777801513672, -1.556445883261, 218, 27, 'PPL', 'P'),
(168560, 'Waterson', 41.1772193908691, 0.71867805518672, -79.2900009155273, -1.38387157988527, 218, 45, 'PPL', 'P'),
(52542, 'Waterspout', 39.4688911437988, 0.68886210257052, -76.7452774047852, -1.33945777606991, 218, 25, 'PPL', 'P'),
(52547, 'Watersville', 39.3675003051758, 0.68709249860519, -77.103889465332, -1.34571673726381, 218, 25, 'PPL', 'P'),
(52544, 'Watersville Acres', 39.3772201538086, 0.687262141966628, -77.1061096191406, -1.34575548625767, 218, 25, 'PPL', 'P'),
(25836, 'Waterton', 33.8869400024414, 0.591438676468378, -83.9794387817383, -1.46571771071835, 218, 13, 'PPL', 'P'),
(187515, 'Waterton', 39.4936103820801, 0.689293534667113, -105.08805847168, -1.83413262485913, 218, 7, 'PPL', 'P'),
(18507, 'Watertown', 30.1922206878662, 0.526953659492013, -82.6147232055664, -1.4418989305609, 218, 12, 'PPL', 'P'),
(74725, 'Watertown', 39.4658317565918, 0.688808706190664, -81.6333312988281, -1.42477041053589, 218, 41, 'PPL', 'P'),
(91677, 'Watertown', 36.1002807617188, 0.630068760186359, -86.1319427490234, -1.50328599210972, 218, 50, 'PPL', 'P'),
(114228, 'Watertown', 41.6061096191406, 0.726163601799688, -73.1186065673828, -1.27616042907118, 218, 8, 'PPL', 'P'),
(121876, 'Watertown', 41.985279083252, 0.732781357371453, -89.2944412231445, -1.55848200307242, 218, 18, 'PPL', 'P'),
(126452, 'Watertown', 42.3708305358887, 0.739510499655811, -71.1833267211914, -1.24238342380765, 218, 23, 'PPL', 'P'),
(133594, 'Watertown', 43.3411102294922, 0.756445074974434, -82.8283309936523, -1.4456270897709, 218, 27, 'PPL', 'P'),
(138699, 'Watertown', 44.9636116027832, 0.784763066056492, -93.8469390869141, -1.63793807998521, 218, 28, 'PPL', 'P'),
(153491, 'Watertown', 43.9747200012207, 0.767503651663906, -75.9111099243164, -1.32489880702266, 218, 40, 'PPL', 'P'),
(171556, 'Watertown', 44.8994407653809, 0.783643073660059, -97.1147232055664, -1.69497167210008, 218, 49, 'PPL', 'P'),
(176888, 'Watertown', 43.1947212219238, 0.753890104803639, -88.728889465332, -1.54861126280816, 218, 57, 'PPL', 'P'),
(28918, 'Watertown (historical)', 38.7216682434082, 0.675820602712402, -88.120002746582, -1.5379841847943, 218, 18, 'PPL', 'P'),
(190904, 'Watertown (historical)', 39.3411102294922, 0.686631904894661, -117.127502441406, -2.04426056224024, 218, 39, 'PPL', 'P'),
(211295, 'Watertown (historical)', 21.3355598449707, 0.37237576705103, -157.966674804688, -2.75703858376897, 218, 15, 'PPL', 'P'),
(153492, 'Watertown Center', 43.9425010681152, 0.766941325199736, -75.9161071777344, -1.32498602554837, 218, 40, 'PPL', 'P'),
(25837, 'Watervale', 33.5280609130859, 0.585175054742566, -82.0583267211914, -1.43218797996203, 218, 13, 'PPL', 'P'),
(52545, 'Watervale', 39.5283317565918, 0.689899536973161, -76.3730621337891, -1.33296139406483, 218, 25, 'PPL', 'P'),
(133598, 'Watervale', 44.5536117553711, 0.777607218786476, -86.2144393920898, -1.50472583015307, 218, 27, 'PPL', 'P'),
(153495, 'Watervale', 42.9500007629395, 0.74961892704737, -75.9824981689453, -1.32614476693866, 218, 40, 'PPL', 'P'),
(12695, 'Watervalley (historical)', 36.310001373291, 0.633729075367591, -91.1311111450195, -1.59053794048149, 218, 4, 'PPL', 'P'),
(38765, 'Waterview', 36.8169403076172, 0.642576828878134, -85.4583282470703, -1.49152920116145, 218, 21, 'PPL', 'P'),
(52546, 'Waterview', 38.246940612793, 0.667535042507975, -75.9033279418945, -1.32476298580707, 218, 25, 'PPL', 'P'),
(107328, 'Waterview', 36.8369407653809, 0.642925902718016, -76.3552780151367, -1.33265100263978, 218, 53, 'PPL', 'P'),
(14802, 'Waterview Acres', 38.6408309936523, 0.674409726545905, -75.5458297729492, -1.31852346568912, 218, 10, 'PPL', 'P'),
(25838, 'Waterville', 34.6238899230957, 0.604300879006106, -85.2483291625977, -1.48786402571123, 218, 13, 'PPL', 'P'),
(34350, 'Waterville', 39.6911087036133, 0.69274053064503, -96.7472229003906, -1.68855758177267, 218, 20, 'PPL', 'P'),
(69915, 'Waterville', 35.771110534668, 0.624323655924785, -83.100830078125, -1.45038309600362, 218, 33, 'PPL', 'P'),
(91678, 'Waterville', 35.1074981689453, 0.612741435185976, -84.8638916015625, -1.48115432450283, 218, 50, 'PPL', 'P'),
(114230, 'Waterville', 41.5902786254883, 0.725887298836592, -73.0513916015625, -1.274987306611, 218, 8, 'PPL', 'P'),
(118339, 'Waterville', 43.2077789306641, 0.754118004813923, -91.2975006103516, -1.59344198449217, 218, 16, 'PPL', 'P'),
(126455, 'Waterville', 42.6749992370605, 0.744819244972775, -72.0680618286133, -1.25782496444015, 218, 23, 'PPL', 'P'),
(129194, 'Waterville', 44.5519409179688, 0.77757805717254, -69.6322174072266, -1.21531145922061, 218, 26, 'PPL', 'P'),
(138702, 'Waterville', 44.2188911437988, 0.771765242040251, -93.5677795410156, -1.63306582677091, 218, 28, 'PPL', 'P'),
(153499, 'Waterville', 41.0116691589355, 0.715788658562039, -72.5358276367188, -1.26598901791984, 218, 40, 'PPL', 'P'),
(158209, 'Waterville', 41.5008316040039, 0.724326153805588, -83.7183303833008, -1.46116050946101, 218, 41, 'PPL', 'P'),
(168562, 'Waterville', 41.3097190856934, 0.720990611119291, -77.3616714477539, -1.35021588160939, 218, 45, 'PPL', 'P'),
(172705, 'Waterville', 44.6902809143066, 0.779992545595833, -72.7694396972656, -1.27006631754875, 218, 55, 'PPL', 'P'),
(176891, 'Waterville', 43.0200004577637, 0.750840652197444, -88.4380569458008, -1.54353527777046, 218, 57, 'PPL', 'P'),
(209112, 'Waterville', 47.6472206115723, 0.831600879096042, -120.069999694824, -2.09561682754327, 218, 56, 'PPL', 'P'),
(144603, 'Waterville Valley', 43.9500007629395, 0.767072219567313, -71.5, -1.24791041517595, 218, 36, 'PPL', 'P'),
(113225, 'Watervliet', 42.7299995422363, 0.745779181387694, -73.7016677856445, -1.28633676707054, 218, 40, 'PPL', 'P'),
(133599, 'Watervliet', 42.1866683959961, 0.736296263957167, -86.2605590820313, -1.50553077059254, 218, 27, 'PPL', 'P'),
(18508, 'Waterway Estates', 26.6408290863037, 0.464970183017072, -81.9091720581055, -1.42958473999648, 218, 12, 'PPL', 'P'),
(146577, 'Waterwitch', 40.4063911437988, 0.705224564307967, -73.9977798461914, -1.29150489748194, 218, 37, 'PPL', 'P'),
(98935, 'Waterwood', 30.8193206787109, 0.537898619071479, -95.2360229492188, -1.66218216696875, 218, 51, 'PPL', 'P'),
(44042, 'Waterwood Estates', 32.4388885498047, 0.56616541088158, -93.9388885498047, -1.63954290085809, 218, 22, 'PPL', 'P'),
(69916, 'Watery Branch', 35.5658302307129, 0.620740838731274, -77.8338928222656, -1.35845769939292, 218, 33, 'PPL', 'P'),
(199062, 'Watford City', 47.8022193908691, 0.834306118131345, -103.282783508301, -1.80262463284435, 218, 34, 'PPL', 'P'),
(69917, 'Watha', 34.6402816772461, 0.604586969086208, -77.9611129760742, -1.36067810995177, 218, 33, 'PPL', 'P'),
(34352, 'Wathena', 39.7591705322266, 0.69392843364926, -94.9494400024414, -1.65718035096742, 218, 20, 'PPL', 'P'),
(158211, 'Watheys', 40.6513900756836, 0.709500602333226, -81.0224990844727, -1.41410937721814, 218, 41, 'PPL', 'P'),
(6653, 'Watkins', 33.3363914489746, 0.58182979151829, -86.6941680908203, -1.51309867546222, 218, 2, 'PPL', 'P'),
(58164, 'Watkins', 38.1236114501953, 0.665382542556918, -92.3811111450195, -1.61235455613142, 218, 29, 'PPL', 'P'),
(69918, 'Watkins', 36.2811088562012, 0.633224805815184, -78.5055618286133, -1.37018053503728, 218, 33, 'PPL', 'P'),
(77609, 'Watkins', 35.9808311462402, 0.627983971106017, -96.0113906860352, -1.67571488688993, 218, 42, 'PPL', 'P'),
(91680, 'Watkins', 35.9238891601563, 0.626990145966227, -85.8550033569336, -1.49845248788928, 218, 50, 'PPL', 'P'),
(98938, 'Watkins', 32.5394401550293, 0.567920367460915, -96.0274963378906, -1.67599598354299, 218, 51, 'PPL', 'P'),
(107329, 'Watkins', 36.952220916748, 0.644937920921571, -78.7627792358398, -1.37466982568683, 218, 53, 'PPL', 'P'),
(111935, 'Watkins', 39.586109161377, 0.690907942919919, -80.8611068725586, -1.41129255173316, 218, 58, 'PPL', 'P'),
(118340, 'Watkins', 41.8911094665527, 0.731137787504711, -91.9861068725586, -1.60546043101753, 218, 16, 'PPL', 'P'),
(121877, 'Watkins', 40.2808303833008, 0.703033115625968, -88.6772232055664, -1.54770951646305, 218, 18, 'PPL', 'P'),
(138705, 'Watkins', 45.3152809143066, 0.790900853420797, -94.408332824707, -1.64773624910978, 218, 28, 'PPL', 'P'),
(158212, 'Watkins', 40.2125015258789, 0.701840552089831, -83.246940612793, -1.45293320590542, 218, 41, 'PPL', 'P'),
(168563, 'Watkins', 40.6261100769043, 0.709059383119627, -78.7613906860352, -1.37464559092091, 218, 45, 'PPL', 'P'),
(187516, 'Watkins', 39.7452812194824, 0.693686019411035, -104.606941223145, -1.82573554478406, 218, 7, 'PPL', 'P'),
(197800, 'Watkins', 47.2427787780762, 0.824542037468733, -105.872779846191, -1.84782859655514, 218, 31, 'PPL', 'P'),
(12696, 'Watkins (historical)', 36.1383285522461, 0.63073281940417, -93.0599975585938, -1.62420335929535, 218, 4, 'PPL', 'P'),
(91679, 'Watkins (historical)', 36.1361083984375, 0.630694070410309, -86.9338912963867, -1.51728263469279, 218, 50, 'PPL', 'P'),
(12697, 'Watkins Corner', 34.4686088562012, 0.601590713122787, -90.9558334350586, -1.58747876733732, 218, 4, 'PPL', 'P'),
(107331, 'Watkins Corner', 36.6669387817383, 0.639958808368531, -76.9830627441406, -1.34360791315464, 218, 53, 'PPL', 'P'),
(28919, 'Watkins Ford', 37.535831451416, 0.655123846300851, -88.6311111450195, -1.54690470918163, 218, 18, 'PPL', 'P'),
(153502, 'Watkins Glen', 42.3805618286133, 0.739680342754331, -76.8736114501953, -1.34169762770472, 218, 40, 'PPL', 'P'),
(52548, 'Watkins Mill', 39.1819381713867, 0.683853828403544, -77.2138900756836, -1.34763661009365, 218, 25, 'PPL', 'P'),
(69922, 'Watkins Mill', 35.0058288574219, 0.610966970951656, -83.3088912963867, -1.454014449308, 218, 33, 'PPL', 'P'),
(138707, 'Watkins Mobile Home Park', 45.3152809143066, 0.790900853420797, -94.408332824707, -1.64773624910978, 218, 28, 'PPL', 'P'),
(52549, 'Watkins Overlook', 39.2369384765625, 0.684813764818464, -77.227783203125, -1.3478790909109, 218, 25, 'PPL', 'P'),
(69919, 'Watkins Village', 34.7024993896484, 0.605672873020688, -77.3511123657227, -1.35003159086196, 218, 33, 'PPL', 'P'),
(52550, 'Watkins Wilderness', 39.3197212219238, 0.686258596288859, -77.253059387207, -1.34832024354548, 218, 25, 'PPL', 'P'),
(25839, 'Watkinsville', 33.8627815246582, 0.591017031488791, -83.4088897705078, -1.45575975192838, 218, 13, 'PPL', 'P'),
(38766, 'Watkinsville', 38.2430610656738, 0.66746733163726, -84.7263870239258, -1.4787544168865, 218, 21, 'PPL', 'P'),
(111936, 'Watoga', 38.1455612182617, 0.665765638279726, -80.1513900756836, -1.39890565687099, 218, 58, 'PPL', 'P'),
(77611, 'Watonga', 35.8447189331055, 0.62560836483464, -98.4127807617188, -1.71762705033533, 218, 42, 'PPL', 'P'),
(6655, 'Watoola', 32.4644393920898, 0.566611357206114, -85.3525009155273, -1.48968216578743, 218, 2, 'PPL', 'P'),
(77613, 'Watova', 36.6172218322754, 0.639091083906356, -95.6555633544922, -1.66950452838592, 218, 42, 'PPL', 'P'),
(189800, 'Watrous', 35.7905616760254, 0.624663142384743, -104.981109619141, -1.83226601525109, 218, 38, 'PPL', 'P'),
(193188, 'Watrous', 46.3258285522461, 0.808538236951092, -102.192497253418, -1.78359554790741, 218, 34, 'PPL', 'P'),
(133603, 'Watrousville', 43.452220916748, 0.758384322301202, -83.523063659668, -1.45775246221403, 218, 27, 'PPL', 'P'),
(121878, 'Watseka', 40.7761116027832, 0.711677403629229, -87.7363891601563, -1.53128886465579, 218, 18, 'PPL', 'P'),
(6656, 'Watseka (historical)', 33.8280601501465, 0.590411029182743, -86.5827789306641, -1.51115456786646, 218, 2, 'PPL', 'P'),
(6658, 'Watson', 33.6336097717285, 0.587017229847601, -86.8794403076172, -1.5163322856578, 218, 2, 'PPL', 'P'),
(12699, 'Watson', 33.8950004577637, 0.591579357952961, -91.2561111450195, -1.59271960204648, 218, 4, 'PPL', 'P'),
(18510, 'Watson', 26.6902809143066, 0.465833280236853, -80.8308334350586, -1.41076418057289, 218, 12, 'PPL', 'P'),
(28920, 'Watson', 39.0252799987793, 0.681119627491387, -88.5697174072266, -1.54583318631704, 218, 18, 'PPL', 'P'),
(31458, 'Watson', 38.3486099243164, 0.669309506742295, -85.6999969482422, -1.49574711569592, 218, 19, 'PPL', 'P'),
(34353, 'Watson', 38.9880599975586, 0.68047001592249, -95.5561065673828, -1.66776867998741, 218, 20, 'PPL', 'P'),
(44043, 'Watson', 30.5755596160889, 0.533644185940564, -90.9530563354492, -1.58743029780548, 218, 22, 'PPL', 'P'),
(62233, 'Watson', 34.7874984741211, 0.607156386905916, -89.688606262207, -1.56536148080032, 218, 30, 'PPL', 'P'),
(69921, 'Watson', 35.0747184753418, 0.6121693216048, -80.4291687011719, -1.40375380847742, 218, 33, 'PPL', 'P'),
(77615, 'Watson', 34.4372215270996, 0.601042900886558, -94.5572204589844, -1.65033482854342, 218, 42, 'PPL', 'P'),
(91684, 'Watson', 35.7527809143066, 0.624003743698839, -86.7125015258789, -1.51341865426719, 218, 50, 'PPL', 'P'),
(98937, 'Watson', 31.8702793121338, 0.556241307526968, -98.7272186279297, -1.72311502639365, 218, 51, 'PPL', 'P'),
(107332, 'Watson', 38.9933280944824, 0.680561961559125, -77.5961074829102, -1.35430756230819, 218, 53, 'PPL', 'P'),
(111937, 'Watson', 39.4636116027832, 0.688769957196804, -80.1602783203125, -1.39906078600448, 218, 58, 'PPL', 'P'),
(118341, 'Watson', 43.0752792358398, 0.751805448881352, -91.3300018310547, -1.59400923780435, 218, 16, 'PPL', 'P'),
(126456, 'Watson', 42.5374984741211, 0.742419403935477, -72.8566665649414, -1.27158871358589, 218, 23, 'PPL', 'P'),
(133605, 'Watson', 46.0191688537598, 0.803186015529333, -87.414436340332, -1.52566972791378, 218, 27, 'PPL', 'P'),
(138711, 'Watson', 45.0097198486328, 0.785567806758886, -95.8011093139648, -1.67204478459169, 218, 28, 'PPL', 'P'),
(139517, 'Watson', 40.4769401550293, 0.706455876837965, -95.6202774047852, -1.66888867238384, 218, 29, 'PPL', 'P'),
(153501, 'Watson', 43.7758293151855, 0.764032354341042, -75.436393737793, -1.31661344655532, 218, 40, 'PPL', 'P'),
(158213, 'Watson', 41.1894416809082, 0.718891374390036, -83.1052780151367, -1.45046072714939, 218, 41, 'PPL', 'P'),
(192851, 'Watson', 39.8819389343262, 0.69607114648331, -109.157783508301, -1.90516272639902, 218, 52, 'PPL', 'P'),
(194038, 'Watson', 40.0538902282715, 0.699072262715721, -122.686668395996, -2.1412863118126, 218, 6, 'PPL', 'P'),
(197801, 'Watson', 46.6691703796387, 0.814530682298907, -111.36833190918, -1.94374407426905, 218, 31, 'PPL', 'P'),
(197802, 'Watson (historical)', 47.5750007629395, 0.830340404952108, -111.27082824707, -1.94204231433249, 218, 31, 'PPL', 'P'),
(201756, 'Watson (historical)', 43.3277816772461, 0.756212447853215, -117.452781677246, -2.04993775589401, 218, 43, 'PPL', 'P'),
(62234, 'Watson Center', 34.7874984741211, 0.607156386905916, -89.6708297729492, -1.56505122253332, 218, 30, 'PPL', 'P'),
(12700, 'Watson Chapel', 34.1891708374023, 0.596713599639498, -92.065559387207, -1.60684713899714, 218, 4, 'PPL', 'P'),
(71525, 'Watson Corner', 39.5686111450195, 0.690602544921914, -75.2900009155273, -1.3140584098055, 218, 37, 'PPL', 'P'),
(25840, 'Watson Crossroads', 31.7294406890869, 0.553783209840825, -85.0177764892578, -1.48384012246217, 218, 13, 'PPL', 'P'),
(69923, 'Watson Crossroads', 35.5855598449707, 0.621085185460222, -78.0480575561523, -1.3621955791409, 218, 33, 'PPL', 'P'),
(52552, 'Watson Estates', 38.5494384765625, 0.672814626211003, -76.581672668457, -1.33660233474913, 218, 25, 'PPL', 'P'),
(84242, 'Watson Estates', 34.5519409179688, 0.603045131973107, -82.7002792358398, -1.44339216498411, 218, 48, 'PPL', 'P'),
(197803, 'Watson Flats (historical)', 47.0855598449707, 0.82179804943957, -106.277778625488, -1.85489715872042, 218, 31, 'PPL', 'P'),
(25841, 'Watson Gap (historical)', 34.9838905334473, 0.61058407496593, -84.2319412231445, -1.47012470969021, 218, 13, 'PPL', 'P'),
(25842, 'Watson Glen', 33.9416694641113, 0.592393885772362, -84.728889465332, -1.47879809272838, 218, 13, 'PPL', 'P'),
(186036, 'Watson Junction', 33.7994384765625, 0.589911486741272, -118.253059387207, -2.06390523686315, 218, 6, 'PPL', 'P'),
(84243, 'Watson Orchard', 34.8611106872559, 0.608441162394798, -82.3300018310547, -1.43692960512486, 218, 48, 'PPL', 'P'),
(52551, 'Watson Place', 39.1163902282715, 0.682709800978274, -76.620002746582, -1.33727132081495, 218, 25, 'PPL', 'P'),
(168565, 'Watson Run', 41.6555595397949, 0.727026665729955, -80.2647171020508, -1.40088358661259, 218, 45, 'PPL', 'P'),
(69924, 'Watson Village', 35.6655616760254, 0.62248148081975, -80.5841674804688, -1.40645904751272, 218, 33, 'PPL', 'P'),
(79353, 'Watsondale (historical)', 39.725830078125, 0.693346532951077, -79.3902816772461, -1.38562180935367, 218, 45, 'PPL', 'P'),
(71524, 'Watsons Corner', 39.526668548584, 0.689870508517279, -75.2574996948242, -1.31349115649331, 218, 37, 'PPL', 'P'),
(168568, 'Watsontown', 41.0844383239746, 0.717058720085898, -76.8641662597656, -1.34153277803325, 218, 45, 'PPL', 'P'),
(6659, 'Watsonville', 31.8675003051758, 0.556192804705615, -87.1650009155273, -1.52131625847982, 218, 2, 'PPL', 'P'),
(98939, 'Watsonville', 32.6147193908691, 0.569234237984706, -97.1322174072266, -1.69527700351905, 218, 51, 'PPL', 'P'),
(153504, 'Watsonville', 42.5847206115723, 0.743243585713829, -74.3899993896484, -1.29835041990594, 218, 40, 'PPL', 'P'),
(186037, 'Watsonville', 36.9102783203125, 0.644205884516935, -121.755828857422, -2.12504009705674, 218, 6, 'PPL', 'P'),
(186038, 'Watsonville Junction', 36.8950004577637, 0.643939235512791, -121.744720458984, -2.12484621892938, 218, 6, 'PPL', 'P'),
(98940, 'Watt', 31.6436100006104, 0.552285181727656, -96.8586120605469, -1.69050168936843, 218, 51, 'PPL', 'P'),
(91685, 'Watt Heights', 35.292781829834, 0.615975245118632, -84.7408294677734, -1.47900648508368, 218, 50, 'PPL', 'P'),
(84244, 'Wattacoo (historical)', 35.0605583190918, 0.61192218025564, -82.5952835083008, -1.44155964383802, 218, 48, 'PPL', 'P'),
(194468, 'Wattenberg', 40.0277786254883, 0.698616529274181, -104.836112976074, -1.82973534642525, 218, 7, 'PPL', 'P'),
(12701, 'Wattensaw', 34.9075012207031, 0.609250829945209, -91.8480606079102, -1.60305106917934, 218, 4, 'PPL', 'P'),
(168571, 'Watters', 40.7580604553223, 0.711362351672273, -80.0322189331055, -1.39682572805963, 218, 45, 'PPL', 'P'),
(98941, 'Watterson', 29.9888896942139, 0.523404864181428, -97.3874969482422, -1.69973247202276, 218, 51, 'PPL', 'P'),
(118342, 'Watterson', 40.6019401550293, 0.708637538402958, -94.2333297729492, -1.64468186965556, 218, 16, 'PPL', 'P'),
(38768, 'Watterson Park', 38.1922187805176, 0.666579966362045, -85.6833267211914, -1.49545616534683, 218, 21, 'PPL', 'P'),
(168570, 'Wattersonville', 40.9811096191406, 0.715255293974723, -79.5541687011719, -1.38848217752247, 218, 45, 'PPL', 'P'),
(192852, 'Wattis', 39.5302810668945, 0.689933558856086, -111.016387939453, -1.93760149321478, 218, 52, 'PPL', 'P'),
(192853, 'Wattis Junction', 39.5341682434082, 0.690001402884856, -110.992782592773, -1.93718950219415, 218, 52, 'PPL', 'P'),
(133607, 'Wattles Park', 42.3005599975586, 0.738284047394802, -85.1108322143555, -1.48546425125296, 218, 27, 'PPL', 'P'),
(153505, 'Wattlesburg', 42.2269401550293, 0.736999138747866, -79.6888885498047, -1.3908334824489, 218, 40, 'PPL', 'P'),
(133608, 'Watton', 46.5374984741211, 0.81223257401525, -88.6063919067383, -1.54647327708504, 218, 27, 'PPL', 'P'),
(129196, 'Wattons Mill', 44.1730613708496, 0.770965361606846, -69.2344436645508, -1.20836899773294, 218, 26, 'PPL', 'P'),
(877, 'Watts', 36.1091690063477, 0.630223889319856, -94.5699996948242, -1.65055786828472, 218, 42, 'PPL', 'P'),
(12702, 'Watts', 35.8183288574219, 0.62514777112411, -92.6591720581055, -1.61720763458587, 218, 4, 'PPL', 'P'),
(38767, 'Watts', 37.4444389343262, 0.653528745965948, -83.3138885498047, -1.4541016678337, 218, 21, 'PPL', 'P'),
(84245, 'Watts', 34.1383285522461, 0.595826234364283, -82.4899978637695, -1.43972206268587, 218, 48, 'PPL', 'P'),
(98942, 'Watts', 29.7566699981689, 0.519351865897463, -97.5669403076172, -1.70286434946469, 218, 51, 'PPL', 'P'),
(107333, 'Watts', 38.1352806091309, 0.665586207801282, -78.3927764892578, -1.36821205951755, 218, 53, 'PPL', 'P'),
(186039, 'Watts', 33.940559387207, 0.592374511275432, -118.241943359375, -2.06371122557774, 218, 6, 'PPL', 'P'),
(201757, 'Watts', 45.5416717529297, 0.794852118951121, -123.167221069336, -2.14967353819164, 218, 43, 'PPL', 'P'),
(69925, 'Watts (historical)', 35.7738914489746, 0.624372192035652, -80.9436111450195, -1.41273252293457, 218, 33, 'PPL', 'P'),
(91686, 'Watts Bar Estates', 35.7369384765625, 0.623727240998662, -84.7197189331055, -1.47863803674687, 218, 50, 'PPL', 'P'),
(6660, 'Watts Crossroads', 33.372501373291, 0.582460028590257, -85.773063659668, -1.4970223703839, 218, 2, 'PPL', 'P'),
(69928, 'Watts Crossroads', 35.4716682434082, 0.619097402022587, -80.4533309936523, -1.40417552003603, 218, 33, 'PPL', 'P'),
(153506, 'Watts Flats', 42.0372200012207, 0.733687897406516, -79.4122161865234, -1.38600463876037, 218, 40, 'PPL', 'P'),
(69926, 'Watts Landing', 34.4213905334473, 0.600766597923462, -77.5911102294922, -1.35422034378249, 218, 33, 'PPL', 'P'),
(107334, 'Wattsboro', 36.8830604553223, 0.643730843157492, -78.2636108398438, -1.3659576936548, 218, 53, 'PPL', 'P'),
(168573, 'Wattsburg', 42.0036087036133, 0.733101269597399, -79.8111114501953, -1.39296667448205, 218, 45, 'PPL', 'P'),
(6661, 'Wattsville', 33.6813888549805, 0.587851132163932, -86.2797164916992, -1.5058651304674, 218, 2, 'PPL', 'P'),
(84246, 'Wattsville', 34.5230598449707, 0.602541062157782, -81.995002746582, -1.43108276810965, 218, 48, 'PPL', 'P'),
(107335, 'Wattsville', 37.9338912963867, 0.662071301215568, -75.5, -1.31772358525572, 218, 53, 'PPL', 'P'),
(111938, 'Wattsville', 38.4958305358887, 0.67187899114103, -80.8611068725586, -1.41129255173316, 218, 58, 'PPL', 'P'),
(158215, 'Wattsville', 40.5733299255371, 0.708138195698568, -80.9330596923828, -1.41254836534519, 218, 41, 'PPL', 'P'),
(133609, 'Wauban Beach', 45.4488906860352, 0.793232783850298, -84.6333312988281, -1.47713028809572, 218, 27, 'PPL', 'P'),
(171558, 'Waubay', 45.3319396972656, 0.791191604032807, -97.3047180175781, -1.69828770713139, 218, 49, 'PPL', 'P'),
(118343, 'Waubeek', 42.165828704834, 0.735932542731289, -91.4649963378906, -1.59636533642075, 218, 16, 'PPL', 'P'),
(176895, 'Waubeka', 43.4749984741211, 0.758781865672924, -87.9902801513672, -1.53572009839357, 218, 57, 'PPL', 'P'),
(138712, 'Waubun', 47.1805610656738, 0.823456133534253, -95.9388885498047, -1.67444948589798, 218, 28, 'PPL', 'P'),
(133610, 'Waucedah', 45.7630615234375, 0.798716099376717, -87.7452774047852, -1.53144399378929, 218, 27, 'PPL', 'P'),
(91687, 'Waucheesi', 35.3572196960449, 0.617099898046973, -84.1758270263672, -1.46914533219934, 218, 50, 'PPL', 'P'),
(18511, 'Wauchula', 27.5469398498535, 0.480784799228776, -81.8116683959961, -1.42788298005992, 218, 12, 'PPL', 'P'),
(18512, 'Wauchula Hills', 27.5763893127441, 0.481298789319162, -81.8194427490234, -1.42801866811746, 218, 12, 'PPL', 'P'),
(118345, 'Waucoma', 43.0561103820801, 0.751470889269411, -92.0330581665039, -1.60627988568495, 218, 16, 'PPL', 'P'),
(121880, 'Wauconda', 42.2588882446289, 0.737556738101101, -88.1391677856445, -1.53831867782722, 218, 18, 'PPL', 'P'),
(209117, 'Wauconda', 48.725830078125, 0.850426165630567, -119.012496948242, -2.07715992276653, 218, 56, 'PPL', 'P'),
(176896, 'Waucousta', 43.6525001525879, 0.761879854389986, -88.2602767944336, -1.54043242878441, 218, 57, 'PPL', 'P'),
(6662, 'Waugh', 32.3650016784668, 0.564875841702737, -86.0449981689453, -1.50176852292059, 218, 2, 'PPL', 'P'),
(107336, 'Waugh', 37.5169410705566, 0.6547941469579, -79.3447189331055, -1.38482658945217, 218, 53, 'PPL', 'P'),
(123952, 'Waugh', 40.0844383239746, 0.699605427565954, -86.3066711425781, -1.50633557787396, 218, 19, 'PPL', 'P'),
(194039, 'Waugh (historical)', 40.5930595397949, 0.708482542427516, -122.435829162598, -2.13690834129662, 218, 6, 'PPL', 'P'),
(69927, 'Waughtown', 36.0694389343262, 0.629530468751026, -80.2041702270508, -1.39982684429204, 218, 33, 'PPL', 'P'),
(77617, 'Wauhillau', 35.8569412231445, 0.625821684037955, -94.773063659668, -1.65410200306339, 218, 42, 'PPL', 'P'),
(176897, 'Waukau', 43.9891700744629, 0.767755853019137, -88.7716674804688, -1.54935788001976, 218, 57, 'PPL', 'P'),
(129197, 'Waukeag', 44.5233306884766, 0.77707871446815, -68.2391662597656, -1.19099813004873, 218, 26, 'PPL', 'P'),
(118346, 'Waukee', 41.6116714477539, 0.726260674021421, -93.8850021362305, -1.63860240551913, 218, 16, 'PPL', 'P'),
(18513, 'Waukeenah', 30.4111099243164, 0.530773997365245, -83.9530563354492, -1.46525725016587, 218, 12, 'PPL', 'P'),
(98943, 'Waukegan', 30.3097190856934, 0.529004393399914, -95.3391723632813, -1.66398246386564, 218, 51, 'PPL', 'P'),
(121882, 'Waukegan', 42.3636093139648, 0.739384465557223, -87.8447189331055, -1.53317957587169, 218, 18, 'PPL', 'P'),
(194040, 'Waukell Flat (historical)', 41.5177803039551, 0.724621964423668, -124.015830993652, -2.16448457543606, 218, 6, 'PPL', 'P'),
(186040, 'Waukena', 36.1386108398438, 0.630737746252187, -119.508613586426, -2.08581879157676, 218, 6, 'PPL', 'P'),
(138714, 'Waukenabo', 46.7400016784668, 0.815766921676922, -93.5999984741211, -1.63362815323508, 218, 28, 'PPL', 'P'),
(176899, 'Waukesha', 43.0116691589355, 0.750695243601926, -88.2313919067383, -1.53992829239006, 218, 57, 'PPL', 'P'),
(77619, 'Waukomis', 36.2802810668945, 0.633210358166271, -97.8977813720703, -1.7086386153402, 218, 42, 'PPL', 'P'),
(118347, 'Waukon', 43.2694396972656, 0.755194188210424, -91.4755630493164, -1.59654976032624, 218, 16, 'PPL', 'P'),
(138716, 'Waukon', 47.3688888549805, 0.826743073530656, -96.1308288574219, -1.67779947623319, 218, 28, 'PPL', 'P'),
(209114, 'Waukon', 47.5397186279297, 0.829724615529054, -117.842216491699, -2.05673467562811, 218, 56, 'PPL', 'P'),
(118348, 'Waukon Junction', 43.1533317565918, 0.753167722357955, -91.1880569458008, -1.59153183220031, 218, 16, 'PPL', 'P'),
(176903, 'Waumandee', 44.3030586242676, 0.773234241697539, -91.7055587768555, -1.60056394303731, 218, 57, 'PPL', 'P'),
(144605, 'Waumbeck Junction', 44.3738899230957, 0.774470481075553, -71.5202789306641, -1.24826434928482, 218, 36, 'PPL', 'P'),
(201758, 'Wauna', 46.1572189331055, 0.805595443946555, -123.404998779297, -2.15382354211831, 218, 43, 'PPL', 'P'),
(209115, 'Wauna', 47.3791694641113, 0.8269225040091, -122.641387939453, -2.14049601875912, 218, 56, 'PPL', 'P'),
(176904, 'Waunakee', 43.1919403076172, 0.753841568692772, -89.4555587768555, -1.56129403486744, 218, 57, 'PPL', 'P'),
(34354, 'Wauneta', 37.1130599975586, 0.647745092447596, -96.3802795410156, -1.68215321198325, 218, 20, 'PPL', 'P'),
(194469, 'Wauneta', 40.2930603027344, 0.703246567987338, -102.254173278809, -1.78467199762002, 218, 7, 'PPL', 'P'),
(199758, 'Wauneta', 40.4183311462402, 0.705432956663266, -101.370826721191, -1.76925469175344, 218, 35, 'PPL', 'P'),
(187517, 'Waunita Hot Springs', 38.5141716003418, 0.672199103104058, -106.507781982422, -1.85891147458956, 218, 7, 'PPL', 'P'),
(176906, 'Waupaca', 44.3580589294434, 0.774194178112458, -89.0858306884766, -1.55484106238812, 218, 57, 'PPL', 'P'),
(118349, 'Waupeton', 42.667781829834, 0.744693277453214, -90.8822174072266, -1.58619392526941, 218, 16, 'PPL', 'P'),
(121892, 'Wauponsee', 41.2744407653809, 0.720374888275264, -88.4944381713867, -1.54451931579325, 218, 18, 'PPL', 'P'),
(176911, 'Waupun', 43.6333312988281, 0.761545294778045, -88.7294387817383, -1.54862085018808, 218, 57, 'PPL', 'P'),
(114231, 'Wauregan', 41.7441711425781, 0.728573229953992, -71.9097213745117, -1.25506140217697, 218, 8, 'PPL', 'P'),
(114232, 'Wauregan Station', 41.7413902282715, 0.728524693843125, -71.8963928222656, -1.25482877505575, 218, 8, 'PPL', 'P'),
(77621, 'Waurika', 34.1669387817383, 0.596325577068673, -97.9972229003906, -1.7103741974226, 218, 42, 'PPL', 'P'),
(143329, 'Wausa', 42.499439239502, 0.741755144980584, -97.5416717529297, -1.70242332998817, 218, 35, 'PPL', 'P'),
(18514, 'Wausau', 30.6319408416748, 0.534628223963348, -85.5888900756836, -1.49380793494818, 218, 12, 'PPL', 'P'),
(176914, 'Wausau', 44.959171295166, 0.78468556806877, -89.629997253418, -1.56433856062562, 218, 57, 'PPL', 'P'),
(176915, 'Wausau Junction', 44.9411087036133, 0.784370316374732, -89.6086120605469, -1.56396531859884, 218, 57, 'PPL', 'P'),
(176918, 'Wausaukee', 45.3708305358887, 0.791870377215641, -87.9522171020508, -1.53505577285965, 218, 57, 'PPL', 'P'),
(158216, 'Wauseon', 41.5491714477539, 0.725169843238925, -84.1416702270508, -1.46854918358932, 218, 41, 'PPL', 'P'),
(209116, 'Wautauga Beach', 47.5863914489746, 0.830539209927482, -122.546943664551, -2.13884765520242, 218, 56, 'PPL', 'P'),
(176922, 'Wautoma', 44.0747184753418, 0.76924895428429, -89.2877807617188, -1.55836575609084, 218, 57, 'PPL', 'P'),
(153507, 'Wautoma Beach', 43.3413887023926, 0.756449935243423, -77.809440612793, -1.35803092782823, 218, 40, 'PPL', 'P'),
(62235, 'Wautubbee', 32.1161117553711, 0.560531893069681, -88.8583297729492, -1.55087042236087, 218, 30, 'PPL', 'P'),
(176925, 'Wauwatosa', 43.0494384765625, 0.751354442550747, -88.0074996948242, -1.53602063612259, 218, 57, 'PPL', 'P'),
(126457, 'Wauwinet', 41.3291702270508, 0.721330097579249, -69.9966735839844, -1.22167241948427, 218, 23, 'PPL', 'P'),
(176927, 'Wauzeka', 43.0852813720703, 0.751980019090807, -90.883056640625, -1.5862085726554, 218, 57, 'PPL', 'P'),
(12703, 'Wave', 34.0275001525879, 0.593891913885532, -92.6883316040039, -1.61771656467019, 218, 4, 'PPL', 'P'),
(153508, 'Wave Crest', 40.5994415283203, 0.708593929140108, -73.7641677856445, -1.28742759785303, 218, 40, 'PPL', 'P'),
(12704, 'Waveland', 35.1236114501953, 0.613022664997089, -93.628059387207, -1.63411790855955, 218, 4, 'PPL', 'P'),
(18515, 'Waveland', 27.2674999237061, 0.475907652455973, -80.2069396972656, -1.39987518066583, 218, 12, 'PPL', 'P'),
(31459, 'Waveland', 39.8769416809082, 0.69598392795761, -87.0444412231445, -1.51921209490255, 218, 19, 'PPL', 'P'),
(62236, 'Waveland', 30.2866706848145, 0.528602122917258, -89.376106262207, -1.55990732688784, 218, 30, 'PPL', 'P'),
(126458, 'Waveland', 42.2916717529297, 0.738128918261305, -70.8805618286133, -1.23709917957271, 218, 23, 'PPL', 'P'),
(133612, 'Waverland Beach', 41.9880599975586, 0.73282989348232, -86.5616683959961, -1.51078611952965, 218, 27, 'PPL', 'P'),
(126459, 'Waverley', 42.3875007629395, 0.739801450004902, -71.1833267211914, -1.24238342380765, 218, 23, 'PPL', 'P'),
(129198, 'Waverley', 44.7949981689453, 0.781820206472927, -69.3811111450195, -1.21092882817272, 218, 26, 'PPL', 'P'),
(6664, 'Waverly', 32.735279083252, 0.571338401561978, -85.5791702270508, -1.49363829158674, 218, 2, 'PPL', 'P'),
(12706, 'Waverly', 35.0469398498535, 0.611684493128351, -90.2388916015625, -1.57496577179752, 218, 4, 'PPL', 'P'),
(18516, 'Waverly', 27.978609085083, 0.488318848663097, -81.6141662597656, -1.42443591750298, 218, 12, 'PPL', 'P'),
(25844, 'Waverly', 31.0955600738525, 0.542719906040418, -81.7227783203125, -1.42633155556689, 218, 13, 'PPL', 'P'),
(28924, 'Waverly', 39.5916709899902, 0.691005015141653, -89.9527816772461, -1.56997221159557, 218, 18, 'PPL', 'P'),
(31460, 'Waverly', 39.5569381713867, 0.690398813098523, -86.2713928222656, -1.50571985502994, 218, 19, 'PPL', 'P'),
(34355, 'Waverly', 38.3938903808594, 0.670099799795776, -95.602783203125, -1.66858334096486, 218, 20, 'PPL', 'P'),
(38769, 'Waverly', 37.7097206115723, 0.658158784679106, -87.8127822875977, -1.53262217625554, 218, 21, 'PPL', 'P'),
(44045, 'Waverly', 32.4461097717285, 0.566291444980168, -91.4113922119141, -1.5954297679298, 218, 22, 'PPL', 'P'),
(52554, 'Waverly', 39.3283309936523, 0.686408865153367, -76.6063919067383, -1.33703376684572, 218, 25, 'PPL', 'P'),
(58166, 'Waverly', 39.2094383239746, 0.684333796611004, -93.5175018310547, -1.63218831519173, 218, 29, 'PPL', 'P'),
(62237, 'Waverly', 33.5675010681152, 0.585863415305324, -88.5038909912109, -1.54468429862278, 218, 30, 'PPL', 'P'),
(69933, 'Waverly', 35.8594398498535, 0.625865293300805, -82.4499969482422, -1.4390239150061, 218, 33, 'PPL', 'P'),
(74727, 'Waverly', 39.1266708374023, 0.682889231456718, -82.9855575561523, -1.44837121095812, 218, 41, 'PPL', 'P'),
(91688, 'Waverly', 36.0838890075684, 0.629782670106257, -87.7947235107422, -1.53230699114053, 218, 50, 'PPL', 'P'),
(98944, 'Waverly', 30.5248603820801, 0.532759317378872, -95.3502502441406, -1.66417580936078, 218, 51, 'PPL', 'P'),
(107340, 'Waverly', 37.035831451416, 0.64639720004088, -77.0955581665039, -1.3455713286683, 218, 53, 'PPL', 'P'),
(111939, 'Waverly', 39.3380584716797, 0.686578641672859, -81.3797225952148, -1.42034410364612, 218, 58, 'PPL', 'P'),
(118351, 'Waverly', 42.725830078125, 0.745706410510907, -92.4752807617188, -1.61399812599816, 218, 16, 'PPL', 'P'),
(133614, 'Waverly', 42.8019409179688, 0.747034795262639, -86.0872192382813, -1.50250541959421, 218, 27, 'PPL', 'P'),
(138718, 'Waverly', 45.0666694641113, 0.786561765056731, -93.9661102294922, -1.64001800879656, 218, 28, 'PPL', 'P'),
(143330, 'Waverly', 40.9174995422363, 0.714145088695296, -96.5280609130859, -1.68473248349899, 218, 35, 'PPL', 'P'),
(153510, 'Waverly', 40.9558296203613, 0.714814074761124, -73.813606262207, -1.28829046204622, 218, 40, 'PPL', 'P'),
(168575, 'Waverly', 41.5263900756836, 0.724772233288176, -75.7058334350586, -1.32131605640818, 218, 45, 'PPL', 'P'),
(171589, 'Waverly', 44.9986114501953, 0.785373928631529, -96.9713897705078, -1.69247003173011, 218, 49, 'PPL', 'P'),
(176930, 'Waverly', 44.7286109924316, 0.780661531661661, -92.2566680908203, -1.61018261510441, 218, 57, 'PPL', 'P'),
(194470, 'Waverly', 40.7363891601563, 0.710984116218454, -105.076110839844, -1.83392409934578, 218, 7, 'PPL', 'P'),
(209119, 'Waverly', 47.3427810668945, 0.826287406668143, -117.226936340332, -2.04599601116459, 218, 56, 'PPL', 'P'),
(176931, 'Waverly Beach', 44.2102813720703, 0.771614973175743, -88.4044418334961, -1.54294858338232, 218, 57, 'PPL', 'P'),
(74730, 'Waverly Gables', 39.1158294677734, 0.682700013861268, -83.0066680908203, -1.44873965929493, 218, 41, 'PPL', 'P'),
(25863, 'Waverly Hall', 32.6833305358887, 0.57043172836886, -84.7383270263672, -1.4789628092418, 218, 13, 'PPL', 'P'),
(201759, 'Waverly Heights', 45.4500007629395, 0.793252158347228, -122.647216796875, -2.14059775151276, 218, 43, 'PPL', 'P'),
(38770, 'Waverly Hills', 38.1238899230957, 0.665387402825908, -85.8408279418945, -1.49820508022401, 218, 21, 'PPL', 'P'),
(52555, 'Waverly Island Estates', 38.7497215270996, 0.676310224878813, -76.1111068725586, -1.32838941226343, 218, 25, 'PPL', 'P'),
(118352, 'Waverly Junction', 42.667781829834, 0.744693277453214, -92.5280609130859, -1.61491931341922, 218, 16, 'PPL', 'P'),
(84248, 'Waverly Mills', 33.4730606079102, 0.584215118327647, -79.1483306884766, -1.38139896797119, 218, 48, 'PPL', 'P'),
(44046, 'Waverly Mobile Home Park', 29.7872200012207, 0.519885064037211, -90.8733291625977, -1.58603879613591, 218, 22, 'PPL', 'P'),
(25845, 'Waverly Park', 34.9719390869141, 0.61037548287355, -85.2494430541992, -1.48788346678719, 218, 13, 'PPL', 'P'),
(25846, 'Waverly Pines Park', 31.2277793884277, 0.545027568414485, -81.4791717529297, -1.42207981888658, 218, 13, 'PPL', 'P'),
(74732, 'Waverly Place', 39.124439239502, 0.682850282725775, -82.9947204589844, -1.44853113378158, 218, 41, 'PPL', 'P'),
(52556, 'Waverly Point', 38.3388900756836, 0.669139863380857, -76.9569396972656, -1.34315197997601, 218, 25, 'PPL', 'P'),
(84249, 'Waverly Square', 34.519718170166, 0.602482738929909, -82.6949996948242, -1.44330001961039, 218, 48, 'PPL', 'P'),
(107342, 'Waverly Village', 38.288330078125, 0.668257424953659, -77.5188903808594, -1.35295986963856, 218, 53, 'PPL', 'P'),
(25848, 'Waverly Way', 34.2461090087891, 0.597707358200261, -83.8986129760742, -1.46430703428893, 218, 13, 'PPL', 'P'),
(25849, 'Waverly Woods', 33.899169921875, 0.591652128829748, -83.3119430541992, -1.4540677125298, 218, 13, 'PPL', 'P'),
(31461, 'Waverly Woods', 39.5513916015625, 0.690302007192899, -86.2697219848633, -1.505690693416, 218, 19, 'PPL', 'P'),
(52557, 'Waverly Woods', 39.3066711425781, 0.68603082943663, -76.8708267211914, -1.34164902501483, 218, 25, 'PPL', 'P'),
(788, 'Waves', 35.5666694641113, 0.62075548611727, -75.4688873291016, -1.31718056670945, 218, 33, 'PPL', 'P'),
(69931, 'Waves Landing', 35.5666694641113, 0.62075548611727, -75.4711074829102, -1.31721931570331, 218, 33, 'PPL', 'P'),
(79344, 'Wawa', 39.901668548584, 0.696415493212257, -75.4599990844727, -1.31702543757595, 218, 45, 'PPL', 'P'),
(123953, 'Wawaka', 41.4569396972656, 0.723560095518026, -85.4822235107422, -1.49194625218816, 218, 19, 'PPL', 'P'),
(153512, 'Wawarsing', 41.7588882446289, 0.72883009184113, -74.357780456543, -1.29778809344177, 218, 40, 'PPL', 'P'),
(123954, 'Wawasee', 41.4238891601563, 0.722983254825915, -85.6958312988281, -1.49567441139816, 218, 19, 'PPL', 'P'),
(123955, 'Wawasee Village', 41.4144401550293, 0.722818338575412, -85.7474975585938, -1.49657615774326, 218, 19, 'PPL', 'P'),
(79345, 'Wawaset', 39.9263916015625, 0.696846991887878, -75.6597213745117, -1.32051124912676, 218, 45, 'PPL', 'P'),
(112250, 'Wawaset Park', 39.7555618286133, 0.693865449889479, -75.5749969482422, -1.31903252893149, 218, 10, 'PPL', 'P'),
(209118, 'Wawawai (historical)', 46.6366691589355, 0.81396342898672, -117.378326416016, -2.04863826644011, 218, 56, 'PPL', 'P'),
(146580, 'Wawayanda', 41.1877784729004, 0.718862345934154, -74.4261093139648, -1.2989806569779, 218, 37, 'PPL', 'P'),
(6663, 'Wawbeek', 31.0277805328369, 0.541536929884205, -87.3608322143555, -1.52473415942283, 218, 2, 'PPL', 'P'),
(144606, 'Wawbeek', 43.6719398498535, 0.762219141112862, -71.2977828979492, -1.24438106094132, 218, 36, 'PPL', 'P'),
(153515, 'Wawbeek', 44.2544403076172, 0.772385691995212, -74.3369369506836, -1.29742430563686, 218, 40, 'PPL', 'P'),
(126460, 'Wawela Park', 42.0438919067383, 0.73380434412518, -71.8375015258789, -1.25380092803304, 218, 23, 'PPL', 'P'),
(138721, 'Wawina', 47.0530586242676, 0.821230796127383, -93.1188888549805, -1.62523120631806, 218, 28, 'PPL', 'P'),
(186041, 'Wawona', 37.5369415283203, 0.655143220797782, -119.655281066895, -2.08837862201654, 218, 6, 'PPL', 'P'),
(123956, 'Wawpecong', 40.5783309936523, 0.708225480803296, -86.0422210693359, -1.50172005338875, 218, 19, 'PPL', 'P'),
(25851, 'Wax', 34.1430587768555, 0.595908792358076, -85.1033325195313, -1.48533335688538, 218, 13, 'PPL', 'P'),
(38771, 'Wax', 37.3541717529297, 0.651953286444085, -86.1222229003906, -1.50311634874828, 218, 21, 'PPL', 'P'),
(98945, 'Waxahachie', 32.3863906860352, 0.565249150308539, -96.8480606079102, -1.69031753177905, 218, 51, 'PPL', 'P'),
(176932, 'Waxdale', 42.6980590820313, 0.745221715192513, -87.8777770996094, -1.53375654972186, 218, 57, 'PPL', 'P'),
(62238, 'Waxhaw', 33.9174995422363, 0.591972041055693, -90.9691696166992, -1.58771152761659, 218, 30, 'PPL', 'P'),
(69932, 'Waxhaw', 34.9244384765625, 0.609546440826208, -80.7436065673828, -1.40924178453575, 218, 33, 'PPL', 'P'),
(44047, 'Waxia', 30.6652793884277, 0.535210091372017, -91.9588928222656, -1.60498545623712, 218, 22, 'PPL', 'P'),
(107343, 'Waxpool', 39.0138893127441, 0.680920822516013, -77.524169921875, -1.35305201501227, 218, 53, 'PPL', 'P'),
(830, 'Way', 39.6411094665527, 0.691867879334838, -81.1836090087891, -1.4169212758551, 218, 41, 'PPL', 'P'),
(62239, 'Way', 32.7438888549805, 0.571488670426485, -90.0330581665039, -1.57137330064506, 218, 30, 'PPL', 'P'),
(25852, 'Way Subdivision', 31.8313903808594, 0.555562567633648, -81.5952835083008, -1.42410635131808, 218, 13, 'PPL', 'P'),
(69935, 'Wayah Depot', 35.1647186279297, 0.613740120594756, -83.5119400024414, -1.45755831777056, 218, 33, 'PPL', 'P'),
(195781, 'Wayan', 42.978328704834, 0.750113342903743, -111.376106262207, -1.94387976232659, 218, 17, 'PPL', 'P'),
(107344, 'Waybay', 36.8427810668945, 0.643027835208739, -77.5969390869141, -1.35432207653613, 218, 53, 'PPL', 'P'),
(52558, 'Waycroft', 38.3180618286133, 0.668776341892061, -75.5558319091797, -1.31869803589858, 218, 25, 'PPL', 'P'),
(25853, 'Waycross', 31.2133293151855, 0.544775367059255, -82.3541717529297, -1.43735144984153, 218, 13, 'PPL', 'P'),
(31472, 'Waycross', 39.3036117553711, 0.685977433056774, -86.3441696166992, -1.50699004971185, 218, 19, 'PPL', 'P'),
(69934, 'Waycross', 34.850830078125, 0.608261731916354, -78.1811065673828, -1.36451772245339, 218, 33, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(91689, 'Waycross', 36.5930595397949, 0.638669372347742, -82.6486129760742, -1.442490418639, 218, 50, 'PPL', 'P'),
(38772, 'Wayland', 37.4449996948242, 0.653538533082955, -82.8052825927734, -1.44522481928824, 218, 21, 'PPL', 'P'),
(98946, 'Wayland', 32.6094398498535, 0.569142092610989, -98.8277816772461, -1.72487018271007, 218, 51, 'PPL', 'P'),
(107345, 'Wayland', 37.538890838623, 0.655177242680708, -77.5763931274414, -1.35396348189535, 218, 53, 'PPL', 'P'),
(113222, 'Wayland', 42.5677795410156, 0.742947908253803, -77.5899963378906, -1.35420090270653, 218, 40, 'PPL', 'P'),
(113356, 'Wayland', 41.7763900756836, 0.729135556418162, -71.4672164916992, -1.24733823501574, 218, 47, 'PPL', 'P'),
(118354, 'Wayland', 41.1472206115723, 0.718154477716411, -91.6605606079102, -1.59977857683185, 218, 16, 'PPL', 'P'),
(121885, 'Wayland', 40.2044410705566, 0.701699870605247, -90.7069396972656, -1.58313475212523, 218, 18, 'PPL', 'P'),
(126461, 'Wayland', 42.3624992370605, 0.739365091060292, -71.3619384765625, -1.24550078702164, 218, 23, 'PPL', 'P'),
(133618, 'Wayland', 42.6738891601563, 0.744799870475844, -85.6447219848633, -1.49478238559104, 218, 27, 'PPL', 'P'),
(138723, 'Wayland', 48.4683303833008, 0.845931948133004, -94.3202819824219, -1.64619947200275, 218, 28, 'PPL', 'P'),
(139518, 'Wayland', 40.3944396972656, 0.705015972215587, -91.5830612182617, -1.5984259573142, 218, 29, 'PPL', 'P'),
(158217, 'Wayland', 41.1605606079102, 0.718387304574711, -81.0713882446289, -1.4149626540314, 218, 41, 'PPL', 'P'),
(168576, 'Wayland', 41.6286087036133, 0.72655628490242, -80.0694427490234, -1.39747540620756, 218, 45, 'PPL', 'P'),
(195782, 'Wayland', 47.1691703796387, 0.823257328558878, -116.469169616699, -2.03277048687514, 218, 17, 'PPL', 'P'),
(169658, 'Wayland (historical)', 41.7780609130859, 0.729164718032098, -71.4686126708984, -1.24736260293972, 218, 47, 'PPL', 'P'),
(107346, 'Wayland Park', 38.0699996948242, 0.664446840907919, -78.6949996948242, -1.37348684953062, 218, 53, 'PPL', 'P'),
(91691, 'Wayland Springs', 35.0616683959961, 0.611941554752571, -87.5747222900391, -1.52846724548085, 218, 50, 'PPL', 'P'),
(206355, 'Wayland Station at Old Farm Condo', 40.6841697692871, 0.710072715914402, -111.871673583984, -1.95252904375689, 218, 52, 'PPL', 'P'),
(107347, 'Waylands Mill', 38.4069404602051, 0.670327566648005, -78.1016693115234, -1.3631312807899, 218, 53, 'PPL', 'P'),
(107348, 'Waylandsburg', 38.4066696166992, 0.67032283953707, -78.102783203125, -1.36315072186585, 218, 53, 'PPL', 'P'),
(18517, 'Waylonzo', 30.1302795410156, 0.525872582537009, -83.8172225952148, -1.46288650416349, 218, 12, 'PPL', 'P'),
(84250, 'Waylyn', 32.8561096191406, 0.573447292250184, -79.9952774047852, -1.39618097675973, 218, 48, 'PPL', 'P'),
(12707, 'Waymack Addition', 34.9272193908691, 0.609594976937075, -92.0152816772461, -1.60596962741795, 218, 4, 'PPL', 'P'),
(143333, 'Waymanns Trailer Court', 42.4577789306641, 0.741028035423965, -98.647216796875, -1.72171873103412, 218, 35, 'PPL', 'P'),
(31462, 'Waymansville', 39.063060760498, 0.681779026177291, -86.0430603027344, -1.50173470077474, 218, 19, 'PPL', 'P'),
(206356, 'Waymark', 40.6958312988281, 0.710276248000711, -111.813888549805, -1.95152050465208, 218, 52, 'PPL', 'P'),
(168577, 'Waymart', 41.5802803039551, 0.725712795206165, -75.4086074829102, -1.31612848492082, 218, 45, 'PPL', 'P'),
(6665, 'Wayne', 32.1055603027344, 0.560347735480302, -87.8008270263672, -1.53241351758413, 218, 2, 'PPL', 'P'),
(25855, 'Wayne', 34.1761093139648, 0.596485633050187, -83.9347229003906, -1.4649372713609, 218, 13, 'PPL', 'P'),
(31463, 'Wayne', 39.8877792358398, 0.696173078974033, -84.9255599975586, -1.48223064105738, 218, 19, 'PPL', 'P'),
(34356, 'Wayne', 39.7147216796875, 0.69315265482372, -97.5416717529297, -1.70242332998817, 218, 20, 'PPL', 'P'),
(52559, 'Wayne', 39.4083290100098, 0.687805093933868, -77.329719543457, -1.34965821567713, 218, 25, 'PPL', 'P'),
(58169, 'Wayne', 36.6375007629395, 0.639445018015228, -93.9619369506836, -1.63994517134075, 218, 29, 'PPL', 'P'),
(77622, 'Wayne', 34.9180603027344, 0.609435120692643, -97.3141708374023, -1.69845268996092, 218, 42, 'PPL', 'P'),
(111940, 'Wayne', 38.2213897705078, 0.667089096183441, -82.442497253418, -1.43889302063853, 218, 58, 'PPL', 'P'),
(121887, 'Wayne', 41.9511108398438, 0.732185009024357, -88.2705612182617, -1.54061192584188, 218, 18, 'PPL', 'P'),
(129199, 'Wayne', 44.3486099243164, 0.774029261861955, -70.0666732788086, -1.22289414463434, 218, 26, 'PPL', 'P'),
(133621, 'Wayne', 42.2813911437988, 0.737949487782861, -83.3863906860352, -1.45536706882565, 218, 27, 'PPL', 'P'),
(143334, 'Wayne', 42.2305603027344, 0.737062322244728, -97.0175018310547, -1.69327483901153, 218, 35, 'PPL', 'P'),
(146581, 'Wayne', 40.9252815246582, 0.714280909910891, -74.2769393920898, -1.29637715069624, 218, 37, 'PPL', 'P'),
(153517, 'Wayne', 42.4708290100098, 0.741255802276194, -77.105827331543, -1.34575055940966, 218, 40, 'PPL', 'P'),
(158219, 'Wayne', 41.3013916015625, 0.7208452691028, -83.4736099243164, -1.45688933170474, 218, 41, 'PPL', 'P'),
(168579, 'Wayne', 40.0438919067383, 0.698897759085293, -75.3880615234375, -1.31576989028004, 218, 45, 'PPL', 'P'),
(176933, 'Wayne', 43.5141716003418, 0.759465565703774, -88.3213882446289, -1.54149902480099, 218, 57, 'PPL', 'P'),
(179483, 'Wayne', 33.5661087036133, 0.585839113960377, -112.408889770508, -1.96190523500673, 218, 5, 'PPL', 'P'),
(186042, 'Wayne', 37.3858299255371, 0.652505825791249, -121.89778137207, -2.12751763581884, 218, 6, 'PPL', 'P'),
(197804, 'Wayne', 47.4419403076172, 0.828018061902531, -110.95832824707, -1.93658816042001, 218, 31, 'PPL', 'P'),
(209120, 'Wayne', 47.7480583190918, 0.833360829102421, -122.209442138672, -2.13295714234532, 218, 56, 'PPL', 'P'),
(121888, 'Wayne Center', 41.9427795410156, 0.732039600428839, -88.1736068725586, -1.53891975328525, 218, 18, 'PPL', 'P'),
(123957, 'Wayne Center', 41.4816703796387, 0.723991727351701, -85.2508316040039, -1.48790770155311, 218, 19, 'PPL', 'P'),
(153518, 'Wayne Center', 43.1508293151855, 0.753124046516078, -76.9591674804688, -1.34319086212793, 218, 40, 'PPL', 'P'),
(28922, 'Wayne City', 38.3452796936035, 0.669251383251504, -88.5877838134766, -1.5461485045901, 218, 18, 'PPL', 'P'),
(79346, 'Wayne Heights', 39.7436103820801, 0.693656857797099, -77.5541687011719, -1.35357559248258, 218, 45, 'PPL', 'P'),
(168581, 'Wayne Junction', 40.0224990844727, 0.698524383900464, -75.1597213745117, -1.31178460286679, 218, 45, 'PPL', 'P'),
(158221, 'Wayne Lakes Park', 40.0230598449707, 0.69853417101747, -84.6619415283203, -1.47762963080011, 218, 41, 'PPL', 'P'),
(79348, 'Waynecastle', 39.7727813720703, 0.694165987618495, -77.6502838134766, -1.35525311765322, 218, 45, 'PPL', 'P'),
(123969, 'Waynedale', 41.0219383239746, 0.715967889303401, -85.1755599975586, -1.48659396418737, 218, 19, 'PPL', 'P'),
(153521, 'Wayneport', 43.0727806091309, 0.751761839618502, -77.3613891601563, -1.35021095476138, 218, 40, 'PPL', 'P'),
(52560, 'Waynes Way', 39.3847198486328, 0.687393036334205, -77.5763931274414, -1.35396348189535, 218, 25, 'PPL', 'P'),
(25858, 'Waynesboro', 33.0897216796875, 0.577524591879095, -82.0158309936523, -1.43144628959845, 218, 13, 'PPL', 'P'),
(62241, 'Waynesboro', 31.6747207641602, 0.552828166984409, -88.646110534668, -1.54716649791679, 218, 30, 'PPL', 'P'),
(91693, 'Waynesboro', 35.3194389343262, 0.616440499361069, -87.7622222900391, -1.53173973782834, 218, 50, 'PPL', 'P'),
(107350, 'Waynesboro', 38.0683288574219, 0.664417679293983, -78.8897171020508, -1.37688530939767, 218, 53, 'PPL', 'P'),
(168590, 'Waynesboro', 40.0950012207031, 0.699789784892415, -76.5175018310547, -1.33548234235269, 218, 45, 'PPL', 'P'),
(484, 'Waynesburg', 39.211109161377, 0.68436295822494, -85.6694412231445, -1.49521381768763, 218, 19, 'PPL', 'P'),
(38774, 'Waynesburg', 37.3327789306641, 0.651579911259256, -84.6716690063477, -1.4777994073196, 218, 21, 'PPL', 'P'),
(79351, 'Waynesburg', 39.8963890075684, 0.696323347838541, -80.179443359375, -1.3993952790374, 218, 45, 'PPL', 'P'),
(158233, 'Waynesburg', 40.667781829834, 0.709786692413327, -81.2574996948242, -1.41821091161297, 218, 41, 'PPL', 'P'),
(158234, 'Waynesfield', 40.6005592346191, 0.708613436795093, -83.9752807617188, -1.46564513957864, 218, 41, 'PPL', 'P'),
(25859, 'Waynesville', 31.2291698455811, 0.545051836469919, -81.789436340332, -1.4274949574891, 218, 13, 'PPL', 'P'),
(31470, 'Waynesville', 39.1150016784668, 0.682685566212354, -85.8916702270508, -1.49909244549922, 218, 19, 'PPL', 'P'),
(58173, 'Waynesville', 37.8286094665527, 0.660233786642441, -92.2005615234375, -1.60920337077158, 218, 29, 'PPL', 'P'),
(69938, 'Waynesville', 35.4886093139648, 0.619393079482613, -82.9888916015625, -1.44842940102794, 218, 33, 'PPL', 'P'),
(74744, 'Waynesville', 39.5297203063965, 0.68992377173908, -84.086669921875, -1.4675892471744, 218, 41, 'PPL', 'P'),
(121890, 'Waynesville', 40.2388916015625, 0.70230114580036, -89.1230621337891, -1.5554908736941, 218, 18, 'PPL', 'P'),
(168591, 'Waynesville', 40.452220916748, 0.706024444741372, -76.8794403076172, -1.34179936045836, 218, 45, 'PPL', 'P'),
(123970, 'Waynetown', 40.0875015258789, 0.699658890524838, -87.0597229003906, -1.51947881048572, 218, 19, 'PPL', 'P'),
(107352, 'Waynewood', 38.7261085510254, 0.675898100700124, -77.0491714477539, -1.34476172769691, 218, 53, 'PPL', 'P'),
(77624, 'Waynoka', 36.582218170166, 0.638480154752292, -98.8794403076172, -1.72577179589711, 218, 42, 'PPL', 'P'),
(84251, 'Waynor (historical)', 33.4097213745117, 0.583109640159155, -81.1322174072266, -1.41602432319996, 218, 48, 'PPL', 'P'),
(31471, 'Wayport', 39.2661094665527, 0.68532289463986, -86.5208282470703, -1.51007332446389, 218, 19, 'PPL', 'P'),
(14803, 'Ways Corner', 39.8247184753418, 0.695072461074531, -75.5013885498047, -1.31774782002164, 218, 10, 'PPL', 'P'),
(290, 'Wayside', 33.878059387207, 0.591283680492935, -87.8913879394531, -1.53399410369109, 218, 2, 'PPL', 'P'),
(25860, 'Wayside', 33.0611114501953, 0.577025249174705, -83.6050033569336, -1.4591825797194, 218, 13, 'PPL', 'P'),
(34359, 'Wayside', 37.1247215270996, 0.647948624533905, -95.8730621337891, -1.67330059820372, 218, 20, 'PPL', 'P'),
(38775, 'Wayside', 38.0250015258789, 0.663661474702455, -85.1052780151367, -1.48536731218928, 218, 21, 'PPL', 'P'),
(62242, 'Wayside', 33.2688903808594, 0.580651675631066, -91.0336074829102, -1.58883618054493, 218, 30, 'PPL', 'P'),
(107353, 'Wayside', 37.3722190856934, 0.652268271822014, -77.1949996948242, -1.3473069107507, 218, 53, 'PPL', 'P'),
(111942, 'Wayside', 37.5919418334961, 0.656103157212701, -80.6888885498047, -1.40828677496884, 218, 58, 'PPL', 'P'),
(126463, 'Wayside', 41.8291702270508, 0.73005674383922, -70.9319381713867, -1.23799586591174, 218, 23, 'PPL', 'P'),
(146583, 'Wayside', 40.2566719055176, 0.702611470646381, -74.0749969482422, -1.29285259015158, 218, 37, 'PPL', 'P'),
(176936, 'Wayside', 44.2552795410156, 0.772400339381208, -87.9524993896484, -1.53506069970767, 218, 57, 'PPL', 'P'),
(192402, 'Wayside', 35.6353912353516, 0.621954907293214, -100.954498291016, -1.76198838987721, 218, 51, 'PPL', 'P'),
(12708, 'Wayside (historical)', 34.351390838623, 0.599544872773388, -93.3116683959961, -1.62859584403927, 218, 4, 'PPL', 'P'),
(44048, 'Wayside (historical)', 30.9716701507568, 0.540557618972355, -91.1944427490234, -1.59164328549193, 218, 22, 'PPL', 'P'),
(52561, 'Wayside Estates', 39.2708282470703, 0.68540525289657, -76.9555587768555, -1.34312787836815, 218, 25, 'PPL', 'P'),
(84252, 'Wayside Forest', 33.5463905334473, 0.585494966968512, -79.0480575561523, -1.37964887166084, 218, 48, 'PPL', 'P'),
(107354, 'Wayside Manor', 36.8397216796875, 0.642974438828883, -76.2011108398438, -1.32996027783241, 218, 53, 'PPL', 'P'),
(129201, 'Wayside Trailer Park', 43.1761093139648, 0.753565265729677, -70.6222229003906, -1.23259031468916, 218, 26, 'PPL', 'P'),
(52562, 'Waysons Corner', 38.8111114501953, 0.677381681164379, -76.7027816772461, -1.33871608570632, 218, 25, 'PPL', 'P'),
(52563, 'Waysons Trailer Park', 38.8136100769043, 0.677425290427229, -76.7055587768555, -1.33876455523816, 218, 25, 'PPL', 'P'),
(12709, 'Wayton', 35.9036102294922, 0.626636211857356, -93.2538909912109, -1.62758743809251, 218, 4, 'PPL', 'P'),
(153522, 'Wayville', 43.0008316040039, 0.750506092585503, -73.7083282470703, -1.28645301405212, 218, 40, 'PPL', 'P'),
(138724, 'Wayzata', 44.9741706848145, 0.784947356803925, -93.5063934326172, -1.63199443706437, 218, 28, 'PPL', 'P'),
(34360, 'Wea', 38.7152786254883, 0.675709082841755, -94.6666717529297, -1.65224511399334, 218, 20, 'PPL', 'P'),
(133625, 'Weadock', 45.6213912963867, 0.796243487462633, -84.6308288574219, -1.47708661225384, 218, 27, 'PPL', 'P'),
(91694, 'Weakley', 35.2644386291504, 0.61548056294615, -87.188606262207, -1.52172824950046, 218, 50, 'PPL', 'P'),
(91696, 'Weakley Hills', 36.0255584716797, 0.628764610200547, -86.4902801513672, -1.50954015961366, 218, 50, 'PPL', 'P'),
(107355, 'Weal', 36.8247184753418, 0.642712583514701, -79.4577789306641, -1.38679985866187, 218, 53, 'PPL', 'P'),
(133626, 'Weale', 43.811939239502, 0.76466259141301, -83.397216796875, -1.45555602010499, 218, 27, 'PPL', 'P'),
(209121, 'Weallup Lake', 48.110279083252, 0.839682774056106, -122.305000305176, -2.13462494697799, 218, 56, 'PPL', 'P'),
(138726, 'Wealthwood', 46.3630599975586, 0.809188048257072, -93.6538925170898, -1.6345687817321, 218, 28, 'PPL', 'P'),
(98949, 'Wealthy', 31.0244407653809, 0.541478639945846, -96.179443359375, -1.67864795935649, 218, 51, 'PPL', 'P'),
(91697, 'Wear Valley', 35.7138900756836, 0.623324970516006, -83.6533279418945, -1.46002600283663, 218, 50, 'PPL', 'P'),
(133627, 'Weare', 43.7463912963867, 0.763518563987739, -86.3394393920898, -1.50690749171806, 218, 27, 'PPL', 'P'),
(144607, 'Weare', 43.0947189331055, 0.752144735604228, -71.7311096191406, -1.25194403896298, 218, 36, 'PPL', 'P'),
(144608, 'Weare Corner', 42.8980598449707, 0.748712387012307, -70.9116668701172, -1.23764206496093, 218, 36, 'PPL', 'P'),
(144610, 'Weares Mill', 42.9025001525879, 0.748789885000028, -70.9016723632813, -1.23746762790953, 218, 36, 'PPL', 'P'),
(168592, 'Weather', 40.9416694641113, 0.714566933411965, -75.82861328125, -1.32345896897931, 218, 45, 'PPL', 'P'),
(98947, 'Weather Heights Number 1 Colonia', 26.1979999542236, 0.457241356638526, -97.9759979248047, -1.71000375171497, 218, 51, 'PPL', 'P'),
(25861, 'Weather Wood', 33.6775016784668, 0.587783288135162, -84.2980575561523, -1.47127865739054, 218, 13, 'PPL', 'P'),
(58175, 'Weatherby', 39.9094390869141, 0.69655111469077, -94.2441711425781, -1.64487108725101, 218, 29, 'PPL', 'P'),
(201760, 'Weatherby', 44.4986114501953, 0.776647282371557, -117.370277404785, -2.04849778469261, 218, 43, 'PPL', 'P'),
(58174, 'Weatherby Lake', 39.2377815246582, 0.684828478783486, -94.6958312988281, -1.65275404407765, 218, 29, 'PPL', 'P'),
(25862, 'Weatherford', 34.267219543457, 0.598075806537073, -83.9175033569336, -1.46463673363189, 218, 13, 'PPL', 'P'),
(77626, 'Weatherford', 35.5261116027832, 0.620047617899527, -98.7072219848633, -1.7227660191328, 218, 42, 'PPL', 'P'),
(98948, 'Weatherford', 32.7591705322266, 0.571755386009657, -97.7969436645508, -1.70687866533382, 218, 51, 'PPL', 'P'),
(91698, 'Weatherford (historical)', 35.1127815246582, 0.61283364713872, -87.8869400024414, -1.53391647254532, 218, 50, 'PPL', 'P'),
(14804, 'Weatherhill Farms', 39.7444381713867, 0.693671305446013, -75.6944427490234, -1.32111725143281, 218, 10, 'PPL', 'P'),
(52564, 'Weatherly', 39.0555610656738, 0.681648131809714, -76.4555587768555, -1.33440123210818, 218, 25, 'PPL', 'P'),
(168593, 'Weatherly', 40.9416694641113, 0.714566933411965, -75.8300018310547, -1.32348320374523, 218, 45, 'PPL', 'P'),
(192403, 'Weatherly', 34.5167999267578, 0.602431805974061, -100.709411621094, -1.75771082053433, 218, 51, 'PPL', 'P'),
(84253, 'Weatherly (historical)', 34.2427787780762, 0.59764923470947, -80.1961135864258, -1.39968622938649, 218, 48, 'PPL', 'P'),
(6667, 'Weatherly Heights', 34.6366691589355, 0.6045239187474, -86.5527801513672, -1.51063099039615, 218, 2, 'PPL', 'P'),
(25864, 'Weatherly Park', 31.750560760498, 0.554151824625206, -82.353889465332, -1.43734652299352, 218, 13, 'PPL', 'P'),
(25865, 'Weatherly Woods', 33.9449996948242, 0.592452009263153, -83.2983322143555, -1.45383015856056, 218, 13, 'PPL', 'P'),
(6668, 'Weathers', 33.3347206115723, 0.581800629904354, -85.9625015258789, -1.50032868487724, 218, 2, 'PPL', 'P'),
(12710, 'Weathers', 35.9594383239746, 0.627610595921188, -93.5202789306641, -1.63223678472357, 218, 4, 'PPL', 'P'),
(77627, 'Weathers', 34.6594390869141, 0.604921328961068, -95.5833282470703, -1.66824378792588, 218, 42, 'PPL', 'P'),
(62243, 'Weathersby', 31.9391708374023, 0.557443691469625, -89.831672668457, -1.56785846063838, 218, 30, 'PPL', 'P'),
(18518, 'Weathersfield', 28.6616706848145, 0.50024052257235, -81.399169921875, -1.42068352352705, 218, 12, 'PPL', 'P'),
(172707, 'Weathersfield Bow', 43.353889465332, 0.756668114715728, -72.4077835083008, -1.2637542262911, 218, 55, 'PPL', 'P'),
(69944, 'Weatherspon (historical)', 36.2108306884766, 0.631998220396121, -80.8974990844727, -1.41192771565315, 218, 33, 'PPL', 'P'),
(209122, 'Weatherwax', 47.3555603027344, 0.826510446409437, -123.64582824707, -2.15802680926679, 218, 56, 'PPL', 'P'),
(69942, 'Weathington Heights', 35.5380592346191, 0.62025614341288, -77.3930587768555, -1.35076369384562, 218, 33, 'PPL', 'P'),
(114234, 'Weatogue', 42.0430603027344, 0.733789829897239, -73.3455581665039, -1.28012148171851, 218, 8, 'PPL', 'P'),
(58176, 'Weaubleau', 37.8905601501465, 0.661315030045013, -93.5416717529297, -1.6326101599084, 218, 29, 'PPL', 'P'),
(6669, 'Weaver', 33.7519416809082, 0.589082511272958, -85.811393737793, -1.49769135644973, 218, 2, 'PPL', 'P'),
(28925, 'Weaver', 39.4180603027344, 0.687974937032388, -87.5994415283203, -1.52889867757744, 218, 18, 'PPL', 'P'),
(34362, 'Weaver', 38.9619407653809, 0.680014149322896, -95.0669403076172, -1.65923111816483, 218, 20, 'PPL', 'P'),
(69943, 'Weaver', 36.0486106872559, 0.629166947262231, -78.8736114501953, -1.37660421274461, 218, 33, 'PPL', 'P'),
(91699, 'Weaver', 36.5269393920898, 0.637515358068384, -82.1849975585938, -1.43439880314096, 218, 50, 'PPL', 'P'),
(98950, 'Weaver', 33.1680603027344, 0.578891858782742, -95.4080581665039, -1.66518474793976, 218, 51, 'PPL', 'P'),
(111943, 'Weaver', 38.9691696166992, 0.680140316579538, -79.9311065673828, -1.39506098436329, 218, 58, 'PPL', 'P'),
(123978, 'Weaver', 40.4652786254883, 0.706252344751656, -85.7291717529297, -1.49625631209634, 218, 19, 'PPL', 'P'),
(138728, 'Weaver', 44.2150001525879, 0.771697331432454, -91.9286117553711, -1.60445695191879, 218, 28, 'PPL', 'P'),
(141053, 'Weaver', 48.5911102294922, 0.848074860704136, -98.7241668701172, -1.72306176317185, 218, 34, 'PPL', 'P'),
(187519, 'Weaver', 37.8833312988281, 0.661188862788371, -106.925003051758, -1.86619335595816, 218, 7, 'PPL', 'P'),
(201761, 'Weaver', 43.0077781677246, 0.750627332994129, -123.309440612793, -2.15215573748565, 218, 43, 'PPL', 'P'),
(25866, 'Weaver (historical)', 33.1019401550293, 0.577737844503383, -84.2972183227539, -1.47126401000455, 218, 13, 'PPL', 'P'),
(189801, 'Weaver (historical)', 35.5716705322266, 0.620842771221997, -108.732498168945, -1.8977400969668, 218, 38, 'PPL', 'P'),
(153523, 'Weaver Corner', 43.1227798461914, 0.752634490928694, -75.9280624389648, -1.32519468421977, 218, 40, 'PPL', 'P'),
(107356, 'Weaver Heights', 37.2516708374023, 0.650164307981824, -79.9908294677734, -1.39610334561395, 218, 53, 'PPL', 'P'),
(168595, 'Weaverland', 40.1366691589355, 0.700517027607089, -76.0586090087891, -1.32747315169039, 218, 45, 'PPL', 'P'),
(158236, 'Weavers', 40.0263900756836, 0.698592294508261, -84.6783294677734, -1.47791565430118, 218, 41, 'PPL', 'P'),
(158237, 'Weavers (historical)', 40.9886093139648, 0.715386188342301, -81.688606262207, -1.42573514064077, 218, 41, 'PPL', 'P'),
(158238, 'Weavers Corners', 41.2016716003418, 0.719104826751406, -82.8247222900391, -1.44556410601112, 218, 41, 'PPL', 'P'),
(69945, 'Weavers Ford', 36.5491714477539, 0.637903380639208, -81.373893737793, -1.42024237089248, 218, 33, 'PPL', 'P'),
(168596, 'Weavers Old Stand', 40.2208290100098, 0.701985894106322, -79.5516662597656, -1.38843850168059, 218, 45, 'PPL', 'P'),
(18519, 'Weavers Station', 25.9430599212646, 0.452791813668249, -81.4700012207031, -1.42191976290507, 218, 12, 'PPL', 'P'),
(107357, 'Weaversville', 38.6369400024414, 0.674341815938108, -77.6291732788086, -1.35488466931641, 218, 53, 'PPL', 'P'),
(168597, 'Weaversville', 40.6886100769043, 0.710150213902123, -75.4541702270508, -1.31692370482231, 218, 45, 'PPL', 'P'),
(38776, 'Weaverton', 37.815559387207, 0.660006019790212, -87.5838928222656, -1.52862730146236, 218, 21, 'PPL', 'P'),
(168602, 'Weavertown', 40.2594413757324, 0.702659807020166, -80.1747207641602, -1.39931285420166, 218, 45, 'PPL', 'P'),
(69946, 'Weaverville', 35.6969413757324, 0.623029159897925, -82.5608291625977, -1.44095830206388, 218, 33, 'PPL', 'P'),
(107358, 'Weaverville', 38.5844383239746, 0.673425488786039, -77.790283203125, -1.35769656795337, 218, 53, 'PPL', 'P'),
(194041, 'Weaverville', 40.7311096191406, 0.710891970844737, -122.940826416016, -2.14572220608229, 218, 6, 'PPL', 'P'),
(153524, 'Webatuck', 41.6541709899902, 0.727002430964036, -73.5561065673828, -1.28379624454865, 218, 40, 'PPL', 'P'),
(6671, 'Webb', 31.2602806091309, 0.545594821726672, -85.2733306884766, -1.48830038465584, 218, 2, 'PPL', 'P'),
(25869, 'Webb', 34.6513900756836, 0.604780847213566, -84.501106262207, -1.47482252585311, 218, 13, 'PPL', 'P'),
(44050, 'Webb', 31.7319393157959, 0.553826819103675, -91.9461135864258, -1.60476241649582, 218, 22, 'PPL', 'P'),
(62244, 'Webb', 33.9472198486328, 0.592490758257014, -90.3441696166992, -1.57680321979162, 218, 30, 'PPL', 'P'),
(69947, 'Webb', 36.0430603027344, 0.629070074777579, -82.2813873291016, -1.43608112200157, 218, 33, 'PPL', 'P'),
(74745, 'Webb', 39.954719543457, 0.697341407744251, -80.7786102294922, -1.40985271368981, 218, 41, 'PPL', 'P'),
(77629, 'Webb', 35.9277801513672, 0.627058056574024, -99.1322174072266, -1.73018358855894, 218, 42, 'PPL', 'P'),
(98953, 'Webb', 27.7922191619873, 0.485065730812538, -99.4225006103516, -1.73524998621671, 218, 51, 'PPL', 'P'),
(111944, 'Webb', 37.9697189331055, 0.662696611439519, -82.4824981689453, -1.43959116831829, 218, 58, 'PPL', 'P'),
(118361, 'Webb', 42.9486083984375, 0.749594625702423, -95.0116729736328, -1.658266521218, 218, 16, 'PPL', 'P'),
(144611, 'Webb', 42.8741683959961, 0.748295402564628, -72.2130584716797, -1.26035563326599, 218, 36, 'PPL', 'P'),
(179484, 'Webb', 33.5525016784668, 0.585601626570169, -112.366386413574, -1.96116341148509, 218, 5, 'PPL', 'P'),
(195784, 'Webb', 47.4883308410645, 0.828827729452943, -115.890556335449, -2.02267178002156, 218, 17, 'PPL', 'P'),
(44049, 'Webb (historical)', 30.7827796936035, 0.537260858569433, -91.7919387817383, -1.60207155853041, 218, 22, 'PPL', 'P'),
(58178, 'Webb (historical)', 37.1388893127441, 0.648195899041119, -90.871940612793, -1.58601456136999, 218, 29, 'PPL', 'P'),
(158239, 'Webb (historical)', 41.514720916748, 0.724568568043812, -83.4230575561523, -1.45600702643559, 218, 41, 'PPL', 'P'),
(6670, 'Webb Addition', 34.6708297729492, 0.605120133936442, -86.0219421386719, -1.50136611927988, 218, 2, 'PPL', 'P'),
(206360, 'Webb and Palmers Addition', 40.7411117553711, 0.711066541054192, -111.883331298828, -1.95273250926417, 218, 52, 'PPL', 'P'),
(91700, 'Webb Chapel', 36.327220916748, 0.634029613096606, -89.3777770996094, -1.55993648850177, 218, 50, 'PPL', 'P'),
(12712, 'Webb City', 35.4680595397949, 0.619034418262806, -93.831672668457, -1.63767163071815, 218, 4, 'PPL', 'P'),
(58179, 'Webb City', 37.1463890075684, 0.648326793408697, -94.4627838134766, -1.64868659814477, 218, 29, 'PPL', 'P'),
(77628, 'Webb City', 36.8069381713867, 0.642402258668679, -96.7083282470703, -1.68787874201081, 218, 42, 'PPL', 'P'),
(129202, 'Webb Hill', 45.5288887023926, 0.794629012630799, -68.3472213745117, -1.19288404757467, 218, 26, 'PPL', 'P'),
(176937, 'Webb Lake', 46.0094413757324, 0.80301623900984, -92.1324996948242, -1.60801546776735, 218, 57, 'PPL', 'P'),
(14806, 'Webb Landing', 38.7113914489746, 0.675641238812985, -75.1805572509766, -1.31214825751364, 218, 10, 'PPL', 'P'),
(14807, 'Webb Manor', 38.9022216796875, 0.678971854651266, -75.4466705322266, -1.31679281045474, 218, 10, 'PPL', 'P'),
(153525, 'Webb Mills', 42.023609161377, 0.733450343437281, -76.8816680908203, -1.34183824261028, 218, 40, 'PPL', 'P'),
(44051, 'Webb Quarters', 31.6725006103516, 0.552789417990548, -92.1563873291016, -1.60843238563601, 218, 22, 'PPL', 'P'),
(74746, 'Webb Summit', 39.5863914489746, 0.690912869767936, -82.3619384765625, -1.43748700474102, 218, 41, 'PPL', 'P'),
(25870, 'Webb Trailer Park', 33.5863914489746, 0.586193114648276, -83.1672210693359, -1.45154183739391, 218, 13, 'PPL', 'P'),
(192404, 'Webb Village', 32.2194404602051, 0.562335319180856, -101.497497558594, -1.77146551493237, 218, 51, 'PPL', 'P'),
(34363, 'Webber', 39.935001373291, 0.696997260752385, -98.0347213745117, -1.71102866926049, 218, 20, 'PPL', 'P'),
(91701, 'Webber City', 35.3466682434082, 0.616915740457594, -87.2822189331055, -1.52336209882922, 218, 50, 'PPL', 'P'),
(77632, 'Webbers Falls', 35.5108299255371, 0.619780902316355, -95.1297225952148, -1.66032687579534, 218, 42, 'PPL', 'P'),
(98955, 'Webberville', 30.2308292388916, 0.52762750582683, -97.5163879394531, -1.70198204419555, 218, 51, 'PPL', 'P'),
(133630, 'Webberville', 42.6669387817383, 0.744678563488191, -84.1741714477539, -1.46911643690151, 218, 27, 'PPL', 'P'),
(38777, 'Webbs', 37.2588882446289, 0.650290275501385, -85.601936340332, -1.49403563522138, 218, 21, 'PPL', 'P'),
(69949, 'Webbs', 35.5302810668945, 0.620120388776313, -80.977783203125, -1.41332893786069, 218, 33, 'PPL', 'P'),
(52571, 'Webbs Corner', 38.7538909912109, 0.6763829957556, -76.5888900756836, -1.33672830226869, 218, 25, 'PPL', 'P'),
(38778, 'Webbs Cross Roads', 37.1091690063477, 0.647677181839799, -85.0536117553711, -1.48446556584418, 218, 21, 'PPL', 'P'),
(153527, 'Webbs Crossing', 42.3663902282715, 0.739433001668089, -77.682502746582, -1.35581544411739, 218, 40, 'PPL', 'P'),
(91702, 'Webbs Jungle', 35.6258316040039, 0.621788060250921, -86.2927780151367, -1.50609309705671, 218, 50, 'PPL', 'P'),
(107360, 'Webbs Mill', 37.3997192382813, 0.652748240029474, -80.208610534668, -1.39990434227977, 218, 53, 'PPL', 'P'),
(12714, 'Webbs Mill (historical)', 35.8183288574219, 0.62514777112411, -90.5666732788086, -1.58068664129318, 218, 4, 'PPL', 'P'),
(91703, 'Webbtown', 36.5002784729004, 0.63705003724692, -85.9686126708984, -1.50043534447889, 218, 50, 'PPL', 'P'),
(107361, 'Webbtown', 39.1413917541504, 0.683146159922883, -77.9416732788086, -1.36033882322889, 218, 53, 'PPL', 'P'),
(38779, 'Webbville', 38.1794395446777, 0.666356926620751, -82.8713912963867, -1.44637863383052, 218, 21, 'PPL', 'P'),
(98956, 'Webbville', 32.0299987792969, 0.559028938108495, -99.2763900756836, -1.7326998763149, 218, 51, 'PPL', 'P'),
(12713, 'Weber', 34.1458282470703, 0.595957128731861, -91.1766662597656, -1.59133302722493, 218, 4, 'PPL', 'P'),
(25871, 'Weber', 31.2369403839111, 0.545187457948431, -83.1399993896484, -1.45106672945544, 218, 13, 'PPL', 'P'),
(113405, 'Weber', 44.8216705322266, 0.782285727031473, -90.0902786254883, -1.57237198605384, 218, 57, 'PPL', 'P'),
(138729, 'Weber', 45.4749984741211, 0.79368845071281, -93.123893737793, -1.62531855800182, 218, 28, 'PPL', 'P'),
(139519, 'Weber', 40.0169410705566, 0.698427378257758, -91.6041717529297, -1.59879440565101, 218, 29, 'PPL', 'P'),
(187520, 'Weber', 37.3125, 0.651225977150384, -108.288612365723, -1.88999282819771, 218, 7, 'PPL', 'P'),
(209123, 'Weber', 47.084171295166, 0.82177381467365, -118.937782287598, -2.07585590593877, 218, 56, 'PPL', 'P'),
(44052, 'Weber City', 30.2291698455811, 0.527598543949975, -90.8888931274414, -1.5863104385671, 218, 22, 'PPL', 'P'),
(107363, 'Weber City', 36.6227798461914, 0.639188089549063, -82.5622177124023, -1.4409825368298, 218, 53, 'PPL', 'P'),
(168603, 'Weber City', 41.5038909912109, 0.724379550185444, -78.2608337402344, -1.36590922412296, 218, 45, 'PPL', 'P'),
(189802, 'Weber City', 34.6336097717285, 0.604470522367544, -103.635833740234, -1.80878652181652, 218, 38, 'PPL', 'P'),
(206361, 'Weber Club A Condominium', 41.2208290100098, 0.719439186626265, -111.951393127441, -1.9539204122684, 218, 52, 'PPL', 'P'),
(153528, 'Weber Corners', 42.7150001525879, 0.745517392652539, -74.6558303833008, -1.30299004599902, 218, 40, 'PPL', 'P'),
(58181, 'Weber Hill', 38.4336090087891, 0.670793020627523, -90.5524978637695, -1.58043923362791, 218, 29, 'PPL', 'P'),
(168604, 'Weber Hills', 42.0699996948242, 0.734260010987692, -80.0625, -1.39735423237796, 218, 45, 'PPL', 'P'),
(146588, 'Weber Park', 40.2449989318848, 0.70240773882299, -74.7736129760742, -1.30504574004445, 218, 37, 'PPL', 'P'),
(14818, 'Weber Tract', 39.8269386291504, 0.695111210068391, -75.5061111450195, -1.31783024485738, 218, 10, 'PPL', 'P'),
(168605, 'Webercroft', 40.2016716003418, 0.701651534231462, -77.0016708374023, -1.34393268564957, 218, 45, 'PPL', 'P'),
(123973, 'Webers Landing', 41.538890838623, 0.724990412760481, -85.394172668457, -1.49040947508113, 218, 19, 'PPL', 'P'),
(52565, 'Webers Ridge', 39.7041702270508, 0.692968497234341, -76.8547210693359, -1.34136792836177, 218, 25, 'PPL', 'P'),
(38780, 'Weberstown', 37.7702789306641, 0.659215726736731, -86.7788925170898, -1.51457739565749, 218, 21, 'PPL', 'P'),
(74747, 'Webertown', 39.2355613708496, 0.684789729789626, -83.8375015258789, -1.46324043827236, 218, 41, 'PPL', 'P'),
(111945, 'Weberwood', 38.3488883972168, 0.669314367011284, -81.6708297729492, -1.42542488237378, 218, 58, 'PPL', 'P'),
(44053, 'Webre', 30.4183292388916, 0.530899998174319, -91.4469375610352, -1.59605015130574, 218, 22, 'PPL', 'P'),
(44054, 'Webre Steib Plantation', 29.958890914917, 0.522881286711118, -90.7077789306641, -1.58314939951123, 218, 22, 'PPL', 'P'),
(18520, 'Webster', 28.6097202301025, 0.499333816089719, -82.0552825927734, -1.43213484989829, 218, 12, 'PPL', 'P'),
(31473, 'Webster', 39.9033317565918, 0.696444521668139, -84.9452819824219, -1.48257485462828, 218, 19, 'PPL', 'P'),
(34364, 'Webster', 39.401668548584, 0.687688846952286, -99.4355621337891, -1.73547795280602, 218, 20, 'PPL', 'P'),
(38781, 'Webster', 37.8888893127441, 0.661285868431077, -86.3388900756836, -1.50689790433814, 218, 21, 'PPL', 'P'),
(52566, 'Webster', 39.5733299255371, 0.690684903178625, -76.1566696166992, -1.32918463216493, 218, 25, 'PPL', 'P'),
(62245, 'Webster', 33.2174987792969, 0.579754722975928, -88.9836120605469, -1.55305701077388, 218, 30, 'PPL', 'P'),
(69950, 'Webster', 35.3461112976074, 0.616906019919615, -83.2194366455078, -1.45245317111894, 218, 33, 'PPL', 'P'),
(91704, 'Webster', 35.8688888549805, 0.626030209551308, -84.6333312988281, -1.47713028809572, 218, 50, 'PPL', 'P'),
(98958, 'Webster', 32.9263916015625, 0.574673944248275, -95.3247222900391, -1.66373026251041, 218, 51, 'PPL', 'P'),
(107364, 'Webster', 37.351390838623, 0.651904750333218, -79.8269424438477, -1.39324297744515, 218, 53, 'PPL', 'P'),
(111947, 'Webster', 39.2966690063477, 0.685856259227175, -80.0455627441406, -1.39705862149696, 218, 58, 'PPL', 'P'),
(118363, 'Webster', 41.3291702270508, 0.721330097579249, -94.2311096191406, -1.6446431206617, 218, 16, 'PPL', 'P'),
(121894, 'Webster', 40.773609161377, 0.711633727787352, -87.603889465332, -1.52897630872322, 218, 18, 'PPL', 'P'),
(126464, 'Webster', 42.0499992370605, 0.73391093714781, -71.8805618286133, -1.25455247209266, 218, 23, 'PPL', 'P'),
(129203, 'Webster', 44.8875007629395, 0.78343468130476, -68.663330078125, -1.19840118524694, 218, 26, 'PPL', 'P'),
(133631, 'Webster', 42.3952789306641, 0.739937204641469, -83.8047180175781, -1.46266825811215, 218, 27, 'PPL', 'P'),
(138730, 'Webster', 44.5297203063965, 0.777190234338797, -93.3525009155273, -1.62930850594697, 218, 28, 'PPL', 'P'),
(141055, 'Webster', 48.2822189331055, 0.842683690551434, -98.8758316040039, -1.72570881213733, 218, 34, 'PPL', 'P'),
(143337, 'Webster', 41.5972213745117, 0.726008472666191, -96.7897186279297, -1.68929927213626, 218, 35, 'PPL', 'P'),
(144612, 'Webster', 43.3288917541504, 0.756231822350146, -71.7183303833008, -1.25172099922169, 218, 36, 'PPL', 'P'),
(153529, 'Webster', 43.2122192382813, 0.754195502801644, -77.4302825927734, -1.35141337199355, 218, 40, 'PPL', 'P'),
(158240, 'Webster', 40.1866683959961, 0.70138967891728, -84.4780578613281, -1.47442025537046, 218, 41, 'PPL', 'P'),
(168607, 'Webster', 40.185001373291, 0.701360583882371, -79.8488922119141, -1.39362607316796, 218, 45, 'PPL', 'P'),
(171569, 'Webster', 45.332218170166, 0.791196464301796, -97.5197219848633, -1.70204023426536, 218, 49, 'PPL', 'P'),
(176939, 'Webster', 45.877498626709, 0.800713403615249, -92.3672180175781, -1.61211207531417, 218, 57, 'PPL', 'P'),
(186045, 'Webster', 38.5622215270996, 0.673037732531324, -121.654167175293, -2.12326576598047, 218, 6, 'PPL', 'P'),
(187521, 'Webster', 39.4575004577637, 0.688663297595146, -105.719718933105, -1.84515717966568, 218, 7, 'PPL', 'P'),
(197805, 'Webster', 46.0550003051758, 0.803811392332311, -104.246673583984, -1.81944768829232, 218, 31, 'PPL', 'P'),
(6672, 'Webster (historical)', 34.9494400024414, 0.609982799770818, -87.6486129760742, -1.52975688123872, 218, 2, 'PPL', 'P'),
(6673, 'Webster Chapel', 33.9169387817383, 0.591962253938687, -85.8552780151367, -1.49845728157924, 218, 2, 'PPL', 'P'),
(118364, 'Webster City', 42.4694404602051, 0.741231567510274, -93.8158264160156, -1.63739506143894, 218, 16, 'PPL', 'P'),
(129204, 'Webster Corner', 44.060001373291, 0.768992092397151, -70.0863876342773, -1.22323822504718, 218, 26, 'PPL', 'P'),
(153533, 'Webster Corners', 42.7816696166992, 0.746680994311822, -78.7461090087891, -1.37437887533774, 218, 40, 'PPL', 'P'),
(14809, 'Webster Farm', 39.7944412231445, 0.694544023335232, -75.5111083984375, -1.31791746338308, 218, 10, 'PPL', 'P'),
(171571, 'Webster Grove Addition', 43.5488891601563, 0.760071501430795, -96.8111114501953, -1.68967264732109, 218, 49, 'PPL', 'P'),
(58183, 'Webster Groves', 38.5924987792969, 0.673566170270623, -90.3572235107422, -1.57703105322288, 218, 29, 'PPL', 'P'),
(28927, 'Webster Hill Estates', 38.3250007629395, 0.668897449142632, -88.9277801513672, -1.55208256013102, 218, 18, 'PPL', 'P'),
(144613, 'Webster Lake', 43.4599990844727, 0.758520076937769, -71.6827774047852, -1.2511004826877, 218, 36, 'PPL', 'P'),
(121895, 'Webster Park', 41.3241691589355, 0.721242812474521, -89.1780624389648, -1.55645081010902, 218, 18, 'PPL', 'P'),
(144614, 'Webster Place', 43.4063911437988, 0.757584441867797, -71.6552810668945, -1.25062058105926, 218, 36, 'PPL', 'P'),
(189803, 'Webster Place', 34.211669921875, 0.59710628274223, -107.878890991211, -1.88284184119668, 218, 38, 'PPL', 'P'),
(111948, 'Webster Springs', 38.4791717529297, 0.671588240529021, -80.4136123657227, -1.40348229920429, 218, 58, 'PPL', 'P'),
(126465, 'Webster Square', 42.2430610656738, 0.737280501717033, -71.8319396972656, -1.2537038558113, 218, 23, 'PPL', 'P'),
(52567, 'Webster Village', 39.5708312988281, 0.690641293915775, -76.154167175293, -1.32914095632305, 218, 25, 'PPL', 'P'),
(153531, 'Websters Corners', 42.7833290100098, 0.746709956188676, -78.7466735839844, -1.37438872903377, 218, 40, 'PPL', 'P'),
(153532, 'Websters Crossing', 42.6697196960449, 0.744727099599058, -77.6352767944336, -1.35499119576002, 218, 40, 'PPL', 'P'),
(79355, 'Websters Mill', 39.8600006103516, 0.695688250497584, -78.0352783203125, -1.3619725393996, 218, 45, 'PPL', 'P'),
(144616, 'Websters Mill', 43.2783317565918, 0.755349383922948, -71.345832824707, -1.24521969036858, 218, 36, 'PPL', 'P'),
(172709, 'Websterville', 44.1605606079102, 0.770747182134541, -72.4700012207031, -1.26484013022558, 218, 55, 'PPL', 'P'),
(69952, 'Webtown', 35.3686103820801, 0.617298703022347, -77.9877777099609, -1.36114349735226, 218, 33, 'PPL', 'P'),
(168608, 'Wech Corners', 41.146110534668, 0.71813510321948, -75.9061126708984, -1.32481158849696, 218, 45, 'PPL', 'P'),
(98959, 'Weches', 31.5438899993896, 0.550544739376261, -95.2275009155273, -1.66203342942187, 218, 51, 'PPL', 'P'),
(201762, 'Wecoma Beach', 44.9888916015625, 0.785204285270091, -124.006393432617, -2.16431985892264, 218, 43, 'PPL', 'P'),
(171575, 'Wecota', 45.1725006103516, 0.788408867009783, -99.1172180175781, -1.72992179982379, 218, 49, 'PPL', 'P'),
(84262, 'Weddell', 34.0869407653809, 0.594929348288172, -80.9333267211914, -1.4125530258771, 218, 48, 'PPL', 'P'),
(201763, 'Wedderburn', 42.4297218322754, 0.740538346678527, -124.413887023926, -2.17143196377175, 218, 43, 'PPL', 'P'),
(12715, 'Weddington', 36.089168548584, 0.629874815479974, -94.4194412231445, -1.64793012723713, 218, 4, 'PPL', 'P'),
(69953, 'Weddington', 35.0222206115723, 0.611253061031758, -80.7611083984375, -1.40954724911278, 218, 33, 'PPL', 'P'),
(31476, 'Weddleville', 38.8386116027832, 0.677861649371839, -86.2202835083008, -1.50482782922282, 218, 19, 'PPL', 'P'),
(177731, 'Wedekind', 39.565559387207, 0.690549281700113, -119.705558776855, -2.08925613359572, 218, 39, 'PPL', 'P'),
(14810, 'Wedge Hills', 39.7097206115723, 0.693065369718992, -75.783332824707, -1.32266867592583, 218, 10, 'PPL', 'P'),
(18521, 'Wedgefield', 28.4874992370605, 0.497200657346079, -81.0774993896484, -1.41506931363306, 218, 12, 'PPL', 'P'),
(84255, 'Wedgefield', 33.8925018310547, 0.591535748690111, -80.5183334350586, -1.40531002666041, 218, 48, 'PPL', 'P'),
(126467, 'Wedgemere', 42.4444389343262, 0.740795208565665, -71.1402816772461, -1.24163214606414, 218, 23, 'PPL', 'P'),
(121896, 'Wedges Corner', 42.3861083984375, 0.739777148659955, -88.0041732788086, -1.53596257921082, 218, 18, 'PPL', 'P'),
(14812, 'Wedgewood', 39.6458282470703, 0.691950237591549, -75.6416702270508, -1.3201961971698, 218, 10, 'PPL', 'P'),
(25874, 'Wedgewood', 33.3883285522461, 0.582736264974326, -84.5491714477539, -1.47566142159649, 218, 13, 'PPL', 'P'),
(84257, 'Wedgewood', 33.8836097717285, 0.591380552977587, -80.5127792358398, -1.40521308759673, 218, 48, 'PPL', 'P'),
(107366, 'Wedgewood', 37.6166687011719, 0.656534722467348, -77.5680618286133, -1.35381807329984, 218, 53, 'PPL', 'P'),
(153534, 'Wedgewood', 42.3419418334961, 0.739006296682431, -76.8869400024414, -1.34193025482594, 218, 40, 'PPL', 'P'),
(107368, 'Wedgewood Farms', 37.1186103820801, 0.647841964932248, -77.3841705322266, -1.35060856471213, 218, 53, 'PPL', 'P'),
(52568, 'Wedgewood Forest', 39.1177787780762, 0.682734035744193, -76.6791687011719, -1.33830396152763, 218, 25, 'PPL', 'P'),
(107369, 'Wedgewood Forest', 37.2569389343262, 0.650256253618459, -80.0494384765625, -1.39712626578865, 218, 53, 'PPL', 'P'),
(84259, 'Wedgewood Grove', 33.9116706848145, 0.591870308302052, -80.3883285522461, -1.40304101341166, 218, 48, 'PPL', 'P'),
(52569, 'Wedgewood Hills', 39.6616706848145, 0.692226740291726, -75.870002746582, -1.324181351425, 218, 25, 'PPL', 'P'),
(91707, 'Wedgewood Hills', 35.9036102294922, 0.626636211857356, -84.0811080932617, -1.46749217495267, 218, 50, 'PPL', 'P'),
(69955, 'Wedgewood Lakes', 36.475830078125, 0.636623332261262, -76.0400009155273, -1.32714837919545, 218, 33, 'PPL', 'P'),
(52570, 'Wedgewood Terrace', 39.600830078125, 0.691164871386085, -77.0411071777344, -1.3446209796333, 218, 25, 'PPL', 'P'),
(206365, 'Wedgewood Willows Condo', 40.6949996948242, 0.71026173377277, -111.883331298828, -1.95273250926417, 218, 52, 'PPL', 'P'),
(6674, 'Wedgeworth', 32.8080596923828, 0.572608662822918, -87.7624969482422, -1.5317445315183, 218, 2, 'PPL', 'P'),
(209124, 'Wedgwood', 47.686939239502, 0.83229409992779, -122.294441223145, -2.13444065623055, 218, 56, 'PPL', 'P'),
(12716, 'Wedington Woods', 36.0944404602051, 0.629966827695636, -94.3099975585938, -1.64601997494527, 218, 4, 'PPL', 'P'),
(6675, 'Wedowee', 33.3088912963867, 0.581349823310831, -85.4847183227539, -1.49198979487198, 218, 2, 'PPL', 'P'),
(121897, 'Wedron', 41.4361114501953, 0.723196574029231, -88.7733306884766, -1.54938690847564, 218, 18, 'PPL', 'P'),
(143341, 'Wee Town', 42.2066688537598, 0.736645337797049, -97.4258270263672, -1.70040145808858, 218, 35, 'PPL', 'P'),
(12718, 'Weed', 35.5402793884277, 0.620294892406741, -90.4269409179688, -1.57824785152494, 218, 4, 'PPL', 'P'),
(38785, 'Weed', 37.0386085510254, 0.646445669572719, -85.4713897705078, -1.49175716775076, 218, 21, 'PPL', 'P'),
(189804, 'Weed', 32.8025016784668, 0.572511657180212, -105.516937255859, -1.84161797173502, 218, 38, 'PPL', 'P'),
(194042, 'Weed', 41.422779083252, 0.722963880328985, -122.38500213623, -2.13602124233752, 218, 6, 'PPL', 'P'),
(197806, 'Weed', 46.6488914489746, 0.814176748190035, -112.254173278809, -1.95920492281945, 218, 31, 'PPL', 'P'),
(6676, 'Weed Crossroad', 31.5186100006104, 0.550103520162663, -86.2230606079102, -1.50487629875466, 218, 2, 'PPL', 'P'),
(190906, 'Weed Heights', 38.9872207641602, 0.680455368536494, -119.208061218262, -2.08057316317763, 218, 39, 'PPL', 'P'),
(153535, 'Weed Mines', 42.0711097717285, 0.734279385484623, -73.5347213745117, -1.28342300252188, 218, 40, 'PPL', 'P'),
(186046, 'Weed Patch', 35.2380599975586, 0.615020168972703, -118.914169311523, -2.07544378176008, 218, 6, 'PPL', 'P'),
(197807, 'Weede (historical)', 46.9199981689453, 0.818908453077806, -107.922218322754, -1.88359804578821, 218, 31, 'PPL', 'P'),
(6677, 'Weeden Heights', 34.8211097717285, 0.607743014715034, -87.6380615234375, -1.52957272364934, 218, 2, 'PPL', 'P'),
(176942, 'Weedens', 43.6877784729004, 0.762495577234012, -87.7719421386719, -1.53190938118978, 218, 57, 'PPL', 'P'),
(98960, 'Weedhaven', 28.7236099243164, 0.501321566237841, -96.4533309936523, -1.68342820035513, 218, 51, 'PPL', 'P'),
(121898, 'Weedman', 40.2813911437988, 0.703042902742974, -88.6030578613281, -1.54641508701522, 218, 18, 'PPL', 'P'),
(38783, 'Weedonia', 38.4988899230957, 0.671932387520887, -83.7566680908203, -1.46182962868489, 218, 21, 'PPL', 'P'),
(107370, 'Weedons Fork', 38.2311096191406, 0.667258739544879, -77.1208267211914, -1.34601234814481, 218, 53, 'PPL', 'P'),
(107371, 'Weedonville', 38.2983283996582, 0.668431928584086, -77.1588897705078, -1.34667667367873, 218, 53, 'PPL', 'P'),
(113351, 'Weeds Corners', 42.0299987792969, 0.733561863307928, -79.9333267211914, -1.39509973335715, 218, 45, 'PPL', 'P'),
(186047, 'Weeds Point', 39.4775009155273, 0.689012371435028, -121.048606872559, -2.11269674487838, 218, 6, 'PPL', 'P'),
(153537, 'Weedsport', 43.0486106872559, 0.751339994901834, -76.5630569458008, -1.33627742909614, 218, 40, 'PPL', 'P'),
(168609, 'Weedville', 41.276668548584, 0.72041377042718, -78.491943359375, -1.36994284790999, 218, 45, 'PPL', 'P'),
(179485, 'Weedville', 33.6138916015625, 0.586673082855735, -112.214721679688, -1.95851636251961, 218, 5, 'PPL', 'P'),
(146584, 'Weehawken', 40.7694396972656, 0.711560956910565, -74.0208282470703, -1.2919071679646, 218, 37, 'PPL', 'P'),
(169659, 'Weekapaug', 41.3308296203613, 0.721359059456103, -71.7555618286133, -1.25237081052766, 218, 47, 'PPL', 'P'),
(169660, 'Weekapaug Beach', 41.3302803039551, 0.721349472076179, -71.6958312988281, -1.25132831611895, 218, 47, 'PPL', 'P'),
(153536, 'Weekes Corner', 42.6661109924316, 0.744664115839278, -76.5844421386719, -1.33665067112291, 218, 40, 'PPL', 'P'),
(18522, 'Weeki Wachee', 28.5152797698975, 0.497685519112042, -82.5730590820313, -1.44117175442525, 218, 12, 'PPL', 'P'),
(18523, 'Weeki Wachee Acres', 28.483060836792, 0.497123192647872, -82.5977783203125, -1.44160318652184, 218, 12, 'PPL', 'P'),
(18524, 'Weeki Wachee Gardens', 28.5333309173584, 0.498000571068998, -82.6297225952148, -1.44216071929605, 218, 12, 'PPL', 'P'),
(18525, 'Weekiwachee Gardens', 28.4938907623291, 0.49731221050624, -82.628059387207, -1.44213169084017, 218, 12, 'PPL', 'P'),
(18526, 'Weekiwachee Woodlands', 28.4822196960449, 0.497108511972362, -82.5986099243164, -1.44161770074979, 218, 12, 'PPL', 'P'),
(111949, 'Weekleys (historical)', 39.1833305358887, 0.683878129748491, -81.4538879394531, -1.42163853309396, 218, 58, 'PPL', 'P'),
(6678, 'Weeks', 31.1505603790283, 0.543679842455337, -86.1163864135742, -1.50301448283658, 218, 2, 'PPL', 'P'),
(12720, 'Weeks', 34.8811111450195, 0.60879023623468, -94.4186096191406, -1.64791561300919, 218, 4, 'PPL', 'P'),
(44057, 'Weeks', 29.8075008392334, 0.520239031435596, -91.8069381713867, -1.60233334726556, 218, 22, 'PPL', 'P'),
(77633, 'Weeks', 33.8683280944824, 0.591113837394415, -95.8338928222656, -1.6726169647519, 218, 42, 'PPL', 'P'),
(84260, 'Weeks', 33.0466690063477, 0.57677318097753, -80.6266708374023, -1.40720087103436, 218, 48, 'PPL', 'P'),
(190907, 'Weeks (historical)', 39.2997207641602, 0.685909522448977, -119.253059387207, -2.08135852938309, 218, 39, 'PPL', 'P'),
(129209, 'Weeks Corner', 44.771671295166, 0.781413075721281, -69.4677810668945, -1.21244150367189, 218, 26, 'PPL', 'P'),
(71526, 'Weeks Landing', 38.9897193908691, 0.680498977799344, -74.8833312988281, -1.30696068602627, 218, 37, 'PPL', 'P'),
(84261, 'Weeks Landing', 33.689998626709, 0.58800140102844, -80.5999984741211, -1.40673535047582, 218, 48, 'PPL', 'P'),
(129207, 'Weeks Mills', 44.3588905334473, 0.774208692340399, -69.543327331543, -1.21376003472759, 218, 26, 'PPL', 'P'),
(186049, 'Weeks Poultry Colony (historical)', 34.2083282470703, 0.597047959514357, -118.578887939453, -2.06959201789685, 218, 6, 'PPL', 'P'),
(98961, 'Weeks Settlement', 31.0855598449707, 0.542545369120477, -93.8380584716797, -1.63778308400977, 218, 51, 'PPL', 'P'),
(186048, 'Weeks Tract', 39.3188896179199, 0.686244082060918, -120.298057556152, -2.0995971881085, 218, 6, 'PPL', 'P'),
(129208, 'Weeksboro', 46.2569389343262, 0.807335886297949, -68.1586074829102, -1.18959211415123, 218, 26, 'PPL', 'P'),
(38784, 'Weeksbury', 37.3277816772461, 0.651492692733556, -82.6883316040039, -1.44318363947075, 218, 21, 'PPL', 'P'),
(71527, 'Weekstown', 39.5919418334961, 0.691009742252587, -74.6033325195313, -1.30207378542598, 218, 37, 'PPL', 'P'),
(69957, 'Weeksville', 36.2052803039551, 0.631901347911469, -76.148063659668, -1.32903442987945, 218, 33, 'PPL', 'P'),
(197808, 'Weeksville', 47.5230598449707, 0.829433864917045, -114.993057250977, -2.00700746596388, 218, 31, 'PPL', 'P'),
(6679, 'Weems', 33.5558280944824, 0.585659683481933, -86.6627807617188, -1.51255086322599, 218, 2, 'PPL', 'P'),
(107372, 'Weems', 37.6547203063965, 0.657198848264187, -76.4441680908203, -1.3342024271328, 218, 53, 'PPL', 'P'),
(158242, 'Weems', 40.2861099243164, 0.703125260999685, -80.7544403076172, -1.40943086897314, 218, 41, 'PPL', 'P'),
(62247, 'Weems (historical)', 31.9083309173584, 0.556905433323807, -88.9644393920898, -1.55272238458291, 218, 30, 'PPL', 'P'),
(52574, 'Weems Creek', 38.9980583190918, 0.680644519552917, -76.5194396972656, -1.33551616449854, 218, 25, 'PPL', 'P'),
(190908, 'Weepah', 37.9302787780762, 0.662008250876761, -117.558609008789, -2.05178479126804, 218, 39, 'PPL', 'P'),
(98962, 'Weeping Mary', 31.5966701507568, 0.55146592679732, -95.1594390869141, -1.66084552641764, 218, 51, 'PPL', 'P'),
(6680, 'Weeping Oaks', 33.3166694641113, 0.581485577947397, -86.8938903808594, -1.51658448701303, 218, 2, 'PPL', 'P'),
(143342, 'Weeping Water', 40.8699989318848, 0.713316046647955, -96.1402816772461, -1.67796445906272, 218, 35, 'PPL', 'P'),
(98963, 'Weesatche', 28.8469390869141, 0.503474066188897, -97.4477767944336, -1.70078455381139, 218, 51, 'PPL', 'P'),
(111951, 'Weese', 38.4819412231445, 0.671636576902806, -80.5561065673828, -1.40596929218826, 218, 58, 'PPL', 'P'),
(126468, 'Weeset', 41.8055610656738, 0.729644686239558, -69.9569396972656, -1.22097893233641, 218, 23, 'PPL', 'P'),
(52572, 'Weestwood Estates', 38.6519393920898, 0.674603604673263, -76.9408264160156, -1.3428707501649, 218, 25, 'PPL', 'P'),
(25877, 'Wefanie', 31.7705593109131, 0.554500865175574, -81.8163909912109, -1.42796540489566, 218, 13, 'PPL', 'P'),
(31477, 'Wegan', 38.8269386291504, 0.677657917548448, -86.019172668457, -1.50131778290609, 218, 19, 'PPL', 'P'),
(153538, 'Wegatchie', 44.3041687011719, 0.773253616194469, -75.5858306884766, -1.31922161336889, 218, 40, 'PPL', 'P'),
(138733, 'Wegdahl', 44.8899993896484, 0.78347829056761, -95.6449966430664, -1.66932010448043, 218, 28, 'PPL', 'P'),
(74748, 'Wegee', 39.9622192382813, 0.697472302111828, -80.7697219848633, -1.40969758455631, 218, 41, 'PPL', 'P'),
(34367, 'Wego-Waco', 37.5208282470703, 0.654861990986669, -97.333610534668, -1.69879197668379, 218, 20, 'PPL', 'P'),
(6682, 'Wegra', 33.6341705322266, 0.587027016964607, -87.1041717529297, -1.52025458931126, 218, 2, 'PPL', 'P'),
(6681, 'Wehadkee', 33.2324981689453, 0.580016511711082, -85.2880630493164, -1.48855751285909, 218, 2, 'PPL', 'P'),
(98964, 'Wehdem', 30.0711097717285, 0.524839875245303, -96.3874969482422, -1.68227917950281, 218, 51, 'PPL', 'P'),
(168615, 'Wehnwood', 40.5369415283203, 0.707503098357612, -78.4027786254883, -1.368386629727, 218, 45, 'PPL', 'P'),
(168610, 'Wehrum', 40.4708290100098, 0.706349217236308, -78.9499969482422, -1.3779373911863, 218, 45, 'PPL', 'P'),
(69958, 'Wehutty', 35.0938911437988, 0.612503947795768, -84.2972183227539, -1.47126401000455, 218, 33, 'PPL', 'P'),
(168611, 'Weidasville', 40.6383285522461, 0.709272635743915, -75.6458282470703, -1.32026876830951, 218, 45, 'PPL', 'P'),
(168612, 'Weiders Crossing', 40.7841682434082, 0.711818018534785, -75.6055603027344, -1.31956596009784, 218, 45, 'PPL', 'P'),
(52573, 'Weidman', 39.1508293151855, 0.683310876436305, -75.9097213745117, -1.32487457225675, 218, 25, 'PPL', 'P'),
(133634, 'Weidman', 43.6875, 0.762490716965023, -84.9688873291016, -1.48298684564891, 218, 27, 'PPL', 'P'),
(168613, 'Weidmanville', 40.2050018310547, 0.701709657722253, -76.2152786254883, -1.33020755233963, 218, 45, 'PPL', 'P'),
(79354, 'Weigelstown', 39.9836082458496, 0.69784561071763, -76.8227767944336, -1.34081039558756, 218, 45, 'PPL', 'P'),
(168614, 'Weigletown', 40.978328704834, 0.715206757863857, -80.2677764892578, -1.40093698299244, 218, 45, 'PPL', 'P'),
(209125, 'Weikel', 46.6327781677246, 0.813895518378923, -120.666107177734, -2.10602086581583, 218, 56, 'PPL', 'P'),
(168616, 'Weikert', 40.8583297729492, 0.713112381403591, -77.2955627441406, -1.34906206706712, 218, 45, 'PPL', 'P'),
(209126, 'Weikswood', 46.8952789306641, 0.818477020981214, -123.452499389648, -2.15465258416566, 218, 56, 'PPL', 'P'),
(44058, 'Weil', 31.3116703033447, 0.546491741092297, -92.5605621337891, -1.61548656673141, 218, 22, 'PPL', 'P'),
(98965, 'Weiland', 33.0144386291504, 0.576210654776278, -96.0638885498047, -1.67663114746297, 218, 51, 'PPL', 'P'),
(158243, 'Weilersville', 40.8397216796875, 0.712787608908656, -81.8616714477539, -1.42875569794914, 218, 41, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(168617, 'Weilersville', 40.5280609130859, 0.707348102382169, -75.6105575561523, -1.31965317862354, 218, 45, 'PPL', 'P'),
(98966, 'Weimar', 29.7027797698975, 0.518411303979474, -96.7802810668945, -1.68913455562284, 218, 51, 'PPL', 'P'),
(186050, 'Weimar', 39.0374984741211, 0.681332880115676, -120.971389770508, -2.11134905220875, 218, 6, 'PPL', 'P'),
(133635, 'Weimer', 44.0163917541504, 0.768230960957607, -86.4561080932617, -1.50894374468753, 218, 27, 'PPL', 'P'),
(168618, 'Weimer', 40.689998626709, 0.710174448668043, -79.0186080932617, -1.37913488157046, 218, 45, 'PPL', 'P'),
(107373, 'Weimertown', 38.5402793884277, 0.672654769966571, -77.746940612793, -1.35694009704574, 218, 53, 'PPL', 'P'),
(168619, 'Weinel Crossroads', 40.6144409179688, 0.708855717875263, -79.6233291625977, -1.38968925528655, 218, 45, 'PPL', 'P'),
(12729, 'Weiner', 35.6202812194824, 0.621691187766269, -90.8983306884766, -1.58647515508052, 218, 4, 'PPL', 'P'),
(98968, 'Weinert', 33.3224983215332, 0.581587310701038, -99.6722183227539, -1.73960838249868, 218, 51, 'PPL', 'P'),
(58186, 'Weingarten', 37.8875007629395, 0.661261633665157, -90.2144393920898, -1.57453900023284, 218, 29, 'PPL', 'P'),
(168620, 'Weintz', 41.3261108398438, 0.721276701199392, -76.1466674804688, -1.32901006195547, 218, 45, 'PPL', 'P'),
(195785, 'Weippe', 46.3761100769043, 0.809415815109301, -115.937217712402, -2.02348617468291, 218, 17, 'PPL', 'P'),
(28929, 'Weir', 39.2677803039551, 0.685352056253796, -87.790283203125, -1.53222949315281, 218, 18, 'PPL', 'P'),
(34368, 'Weir', 37.310001373291, 0.651182367887534, -94.7716674804688, -1.65407763513942, 218, 20, 'PPL', 'P'),
(38787, 'Weir', 37.1230583190918, 0.647919596078024, -87.2125015258789, -1.52214530052717, 218, 21, 'PPL', 'P'),
(62248, 'Weir', 33.2666702270508, 0.580612926637206, -89.2908325195313, -1.55841901931264, 218, 30, 'PPL', 'P'),
(98970, 'Weir', 30.6736106872559, 0.535355499967535, -97.5844421386719, -1.70316981404172, 218, 51, 'PPL', 'P'),
(199765, 'Weir', 42.0380592346191, 0.733702544792511, -101.366386413574, -1.76917719376572, 218, 35, 'PPL', 'P'),
(91708, 'Weir (historical)', 36.2713890075684, 0.633055162453746, -86.1952819824219, -1.50439147027821, 218, 50, 'PPL', 'P'),
(168621, 'Weir Lake', 40.9136085510254, 0.714077178087499, -75.4197235107422, -1.31632249620623, 218, 45, 'PPL', 'P'),
(126469, 'Weir Village', 41.8833312988281, 0.731002032868144, -71.0861129760742, -1.24068672387716, 218, 23, 'PPL', 'P'),
(177293, 'Weircrest', 40.440559387207, 0.705820912655063, -80.5994415283203, -1.40672562993784, 218, 58, 'PPL', 'P'),
(176943, 'Weirgor', 45.689998626709, 0.797440911267759, -91.2677764892578, -1.59292320071182, 218, 57, 'PPL', 'P'),
(144617, 'Weirs Beach', 43.6088905334473, 0.761118722950441, -71.4611129760742, -1.24723170857214, 218, 36, 'PPL', 'P'),
(18527, 'Weirsdale', 28.9816703796387, 0.50582557085241, -81.9244384765625, -1.42985118926354, 218, 12, 'PPL', 'P'),
(177294, 'Weirton', 40.4188919067383, 0.705442743780272, -80.5897216796875, -1.4065559865764, 218, 58, 'PPL', 'P'),
(177295, 'Weirton Heights', 40.4083290100098, 0.705258386453811, -80.539436340332, -1.40567834183917, 218, 58, 'PPL', 'P'),
(177296, 'Weirton Junction', 40.3888893127441, 0.704919099730935, -80.5941696166992, -1.40663361772218, 218, 58, 'PPL', 'P'),
(146586, 'Weirtown', 40.9047203063965, 0.713922048954002, -74.8225021362305, -1.30589901685771, 218, 37, 'PPL', 'P'),
(107374, 'Weirwood', 37.4569396972656, 0.653746925438253, -75.870002746582, -1.324181351425, 218, 53, 'PPL', 'P'),
(111952, 'Weirwood', 37.894718170166, 0.661387601184718, -81.2705612182617, -1.41843887820228, 218, 58, 'PPL', 'P'),
(168625, 'Weis Library', 42.0483283996582, 0.733881775533874, -80.1699981689453, -1.39923042936592, 218, 45, 'PPL', 'P'),
(31478, 'Weisburg', 39.2180595397949, 0.684484265212594, -85.0461120605469, -1.4843346714766, 218, 19, 'PPL', 'P'),
(168622, 'Weisel', 40.4272193908691, 0.705588085796763, -75.2566680908203, -1.31347664226537, 218, 45, 'PPL', 'P'),
(186051, 'Weisel', 33.810001373291, 0.590095844067733, -117.498893737793, -2.05074256317543, 218, 6, 'PPL', 'P'),
(168623, 'Weisenberg', 40.5849990844727, 0.708341860942932, -75.7266693115234, -1.32167971105503, 218, 45, 'PPL', 'P'),
(195786, 'Weiser', 44.2511100769043, 0.772327568504421, -116.968330383301, -2.04148248574912, 218, 17, 'PPL', 'P'),
(168626, 'Weishample', 40.6936111450195, 0.710237499006851, -76.4463882446289, -1.33424117612666, 218, 45, 'PPL', 'P'),
(44064, 'Weiss', 30.6469402313232, 0.534890012698503, -90.9055633544922, -1.58660138891619, 218, 22, 'PPL', 'P'),
(6683, 'Weiss Dam', 34.1744384765625, 0.596456471436251, -85.7416687011719, -1.49647442498962, 218, 2, 'PPL', 'P'),
(143344, 'Weissert', 41.4672203063965, 0.723739525996471, -99.4427795410156, -1.73560392032558, 218, 35, 'PPL', 'P'),
(168627, 'Weissport', 40.8288917541504, 0.712598591050288, -75.6991729736328, -1.3211998094266, 218, 45, 'PPL', 'P'),
(194043, 'Weitchpec', 41.1883316040039, 0.718871999893105, -123.707221984863, -2.15909833213138, 218, 6, 'PPL', 'P'),
(195787, 'Weitz', 43.6694412231445, 0.762175531850012, -116.758613586426, -2.03782223714691, 218, 17, 'PPL', 'P'),
(18528, 'Wekiva', 28.7924995422363, 0.502523916890984, -81.4241714477539, -1.42111988247166, 218, 12, 'PPL', 'P'),
(18531, 'Wekiva Springs', 28.6983299255371, 0.500880347024242, -81.4258270263672, -1.42114877776949, 218, 12, 'PPL', 'P'),
(77634, 'Wekiwa', 36.1530609130859, 0.630989947607417, -96.1727828979492, -1.67853171237491, 218, 42, 'PPL', 'P'),
(18529, 'Wekiwa Springs', 28.6983299255371, 0.500880347024242, -81.4258270263672, -1.42114877776949, 218, 12, 'PPL', 'P'),
(58184, 'Wela Park', 36.874439239502, 0.643580374555903, -94.5552825927734, -1.65030100639758, 218, 29, 'PPL', 'P'),
(168629, 'Welagamika (historical)', 40.7491683959961, 0.711207155959748, -75.3083267211914, -1.31437825545242, 218, 45, 'PPL', 'P'),
(18530, 'Welaka', 29.478889465332, 0.514503681001515, -81.6716690063477, -1.42543952975977, 218, 12, 'PPL', 'P'),
(34370, 'Welborn', 39.1433296203613, 0.683179982068727, -94.6999969482422, -1.65282674837541, 218, 20, 'PPL', 'P'),
(38786, 'Welborn', 37.1983299255371, 0.64923333344376, -84.4977798461914, -1.47476446894135, 218, 21, 'PPL', 'P'),
(31479, 'Welborn Switch', 38.0069389343262, 0.663346223008417, -88.0002822875977, -1.53589466860303, 218, 19, 'PPL', 'P'),
(52575, 'Welbourne', 38.0200004577637, 0.663574189597727, -75.454719543457, -1.31693329220224, 218, 25, 'PPL', 'P'),
(107375, 'Welbourne', 39.0027809143066, 0.680726944388655, -77.8133316040039, -1.35809883843603, 218, 53, 'PPL', 'P'),
(186052, 'Welby', 36.1886100769043, 0.631610397562378, -121.06861114502, -2.11304588529729, 218, 6, 'PPL', 'P'),
(187522, 'Welby', 39.836669921875, 0.695281053166911, -104.958610534668, -1.83187333214836, 218, 7, 'PPL', 'P'),
(206367, 'Welby', 40.5880584716797, 0.708395257322788, -111.990562438965, -1.95460404572023, 218, 52, 'PPL', 'P'),
(6684, 'Welch', 33.0880584716797, 0.577495563423214, -85.3394393920898, -1.48945419919812, 218, 2, 'PPL', 'P'),
(25878, 'Welch', 34.9711112976074, 0.610361035224636, -83.8811111450195, -1.4640015697119, 218, 13, 'PPL', 'P'),
(77636, 'Welch', 36.8736114501953, 0.643565926906989, -95.0955581665039, -1.65973059402728, 218, 42, 'PPL', 'P'),
(111953, 'Welch', 37.4327812194824, 0.653325280458666, -81.584716796875, -1.42392192741259, 218, 58, 'PPL', 'P'),
(138735, 'Welch', 44.5683288574219, 0.777864080673614, -92.7383270263672, -1.61858914940135, 218, 28, 'PPL', 'P'),
(193081, 'Welch', 32.9263916015625, 0.574673944248275, -102.126670837402, -1.78244666021315, 218, 51, 'PPL', 'P'),
(197809, 'Welch', 45.9311103820801, 0.801649105264248, -112.314170837402, -1.96025207776007, 218, 31, 'PPL', 'P'),
(91709, 'Welch Camp', 36.2388916015625, 0.632487975720587, -84.3097229003906, -1.47148225605588, 218, 50, 'PPL', 'P'),
(91710, 'Welch Crossroad', 36.3558311462402, 0.634528955800996, -83.8447189331055, -1.46336640579192, 218, 50, 'PPL', 'P'),
(111954, 'Welch Glade', 38.3972206115723, 0.670157923286567, -80.5641708374023, -1.40611004025187, 218, 58, 'PPL', 'P'),
(153539, 'Welch Hill', 43.6361083984375, 0.761593764309884, -75.4608306884766, -1.3170399518039, 218, 40, 'PPL', 'P'),
(176945, 'Welch Point (historical)', 44.7027816772461, 0.780210725068137, -92.0124969482422, -1.60592102472806, 218, 57, 'PPL', 'P'),
(98971, 'Welch Tract Colonia', 26.2509994506836, 0.458166372353652, -98.1559982299805, -1.71314534969489, 218, 51, 'PPL', 'P'),
(38788, 'Welchburg', 37.3205604553223, 0.651366658634968, -83.9300003051758, -1.46485484652516, 218, 21, 'PPL', 'P'),
(25879, 'Welchell', 34.4033317565918, 0.600451412808451, -83.9663925170898, -1.46549001044515, 218, 13, 'PPL', 'P'),
(201764, 'Welches', 45.3283309936523, 0.791128620273026, -121.959716796875, -2.1285986129053, 218, 43, 'PPL', 'P'),
(91711, 'Welchland', 35.6477813720703, 0.622171155973729, -85.5166702270508, -1.49254746080424, 218, 50, 'PPL', 'P'),
(52576, 'Welchpoole Estates', 38.7319412231445, 0.675999900032792, -76.6455612182617, -1.33771740029754, 218, 25, 'PPL', 'P'),
(107376, 'Welchs', 38.0905609130859, 0.664805701864807, -77.4858322143555, -1.35238289578839, 218, 53, 'PPL', 'P'),
(38789, 'Welchs Creek', 37.3447189331055, 0.651788303614554, -86.5680618286133, -1.51089770597932, 218, 21, 'PPL', 'P'),
(12722, 'Welchs Shop (historical)', 34.0213890075684, 0.593785254283874, -92.6611099243164, -1.61724145673172, 218, 4, 'PPL', 'P'),
(52577, 'Welchs Trailer Park', 39.0911102294922, 0.682268581764675, -76.7813873291016, -1.34008801314188, 218, 25, 'PPL', 'P'),
(71528, 'Welchville', 39.600830078125, 0.691164871386085, -75.4225006103516, -1.31637096573807, 218, 37, 'PPL', 'P'),
(129210, 'Welchville', 44.1336097717285, 0.770276801307006, -70.4644393920898, -1.22983647296396, 218, 26, 'PPL', 'P'),
(121899, 'Welco Corners', 41.6972198486328, 0.727753775286574, -88.041389465332, -1.53661212420069, 218, 18, 'PPL', 'P'),
(38790, 'Welco Station', 37.4866714477539, 0.654265842376655, -82.8361129760742, -1.44576291098649, 218, 21, 'PPL', 'P'),
(12724, 'Welcome', 35.4494400024414, 0.618709446030789, -92.9038925170898, -1.62147881234214, 218, 4, 'PPL', 'P'),
(18532, 'Welcome', 27.8358306884766, 0.485826895541596, -82.1044387817383, -1.43299278724345, 218, 12, 'PPL', 'P'),
(25880, 'Welcome', 33.3963890075684, 0.582876946458909, -84.8736114501953, -1.48132396786427, 218, 13, 'PPL', 'P'),
(38791, 'Welcome', 37.3036117553711, 0.651070848016887, -86.6513900756836, -1.51235205825062, 218, 21, 'PPL', 'P'),
(44060, 'Welcome', 30.059440612793, 0.524636210000939, -90.5911102294922, -1.58111314654175, 218, 22, 'PPL', 'P'),
(69960, 'Welcome', 35.9027786254883, 0.626621697629415, -80.2572174072266, -1.40075269224501, 218, 33, 'PPL', 'P'),
(84264, 'Welcome', 34.8263893127441, 0.60783516008875, -82.4391708374023, -1.43883496372676, 218, 48, 'PPL', 'P'),
(98972, 'Welcome', 30.0276203155518, 0.524080841045117, -96.4887771606445, -1.68404685267635, 218, 51, 'PPL', 'P'),
(107377, 'Welcome', 38.1966705322266, 0.666657664086848, -77.1361083984375, -1.34627906372798, 218, 53, 'PPL', 'P'),
(138737, 'Welcome', 43.6669387817383, 0.762131856008134, -94.6191711425781, -1.65141607194599, 218, 28, 'PPL', 'P'),
(153540, 'Welcome', 42.6236114501953, 0.743922358896663, -75.1449966430664, -1.31152760782159, 218, 40, 'PPL', 'P'),
(158244, 'Welcome', 40.5461082458496, 0.707663087760098, -82.0219421386719, -1.4315529492001, 218, 41, 'PPL', 'P'),
(200273, 'Welcome', 41.1002807617188, 0.717335222786075, -115.103607177734, -2.00893692617364, 218, 39, 'PPL', 'P'),
(209127, 'Welcome', 48.8380584716797, 0.85238492061232, -122.164436340332, -2.13217164298181, 218, 56, 'PPL', 'P'),
(52578, 'Welcome Acres', 38.4805603027344, 0.671612475294941, -77.1044387817383, -1.34572632464374, 218, 25, 'PPL', 'P'),
(84265, 'Welcome Acres', 34.8216705322266, 0.60775280183204, -82.4497222900391, -1.43901912131614, 218, 48, 'PPL', 'P'),
(133636, 'Welcome Corner', 42.6969413757324, 0.745202207537528, -85.291389465332, -1.48861556977085, 218, 27, 'PPL', 'P'),
(44061, 'Welcome Heights', 30.5658302307129, 0.533474376131558, -91.0683288574219, -1.58944218285098, 218, 22, 'PPL', 'P'),
(25881, 'Welcome Hill', 34.5747184753418, 0.603442675344828, -85.3186111450195, -1.48909067770932, 218, 13, 'PPL', 'P'),
(12725, 'Welcome Home', 35.7652816772461, 0.624221923171144, -92.7724990844727, -1.61918556432747, 218, 4, 'PPL', 'P'),
(179486, 'Welcome Home Mobile Park', 33.5158309936523, 0.584961602381196, -112.112503051758, -1.95673231090536, 218, 5, 'PPL', 'P'),
(98973, 'Welcome Valley', 32.2005615234375, 0.562005819574986, -98.1500015258789, -1.71304068746405, 218, 51, 'PPL', 'P'),
(129211, 'Weld', 44.6986083984375, 0.780137887612324, -70.4219436645508, -1.22909478260037, 218, 26, 'PPL', 'P'),
(129212, 'Weld Corner', 44.7200012207031, 0.780511262797153, -70.4588928222656, -1.22973966705833, 218, 26, 'PPL', 'P'),
(34371, 'Welda', 38.1694412231445, 0.666182422990324, -95.2944412231445, -1.66320175819208, 218, 20, 'PPL', 'P'),
(168630, 'Weldbank', 41.7602806091309, 0.728854393186077, -79.0800018310547, -1.38020640443505, 218, 45, 'PPL', 'P'),
(98974, 'Welder', 29.6930599212646, 0.518241660618036, -97.2988891601563, -1.69818597437775, 218, 51, 'PPL', 'P'),
(12726, 'Welders Wood', 34.9255599975586, 0.60956601506022, -92.0066680908203, -1.60581929197442, 218, 4, 'PPL', 'P'),
(14813, 'Weldin Farms', 39.7822189331055, 0.694330704131916, -75.5330581665039, -1.31830055910588, 218, 10, 'PPL', 'P'),
(14814, 'Weldin Park', 39.7783317565918, 0.694262860103146, -75.5347213745117, -1.31832958756177, 218, 10, 'PPL', 'P'),
(14815, 'Weldin Woods', 39.7827796936035, 0.694340491248922, -75.5238876342773, -1.31814050312437, 218, 10, 'PPL', 'P'),
(635, 'Weldon', 39.4786109924316, 0.689031745931958, -77.1180572509766, -1.34596401177103, 218, 25, 'PPL', 'P'),
(12727, 'Weldon', 35.4452781677246, 0.618636808312057, -91.2313919067383, -1.59228816994989, 218, 4, 'PPL', 'P'),
(44062, 'Weldon', 32.8594398498535, 0.573505415740975, -92.7252807617188, -1.61836144912815, 218, 22, 'PPL', 'P'),
(58187, 'Weldon', 38.6908302307129, 0.675282377856097, -90.664436340332, -1.58239292860359, 218, 29, 'PPL', 'P'),
(69961, 'Weldon', 36.4269409179688, 0.635770055448, -77.595832824707, -1.35430276861823, 218, 33, 'PPL', 'P'),
(98975, 'Weldon', 31.021390914917, 0.541425410013558, -95.5711135864258, -1.66803060188062, 218, 51, 'PPL', 'P'),
(107378, 'Weldon', 37.0877799987793, 0.647303873233997, -80.8055572509766, -1.41032302793832, 218, 53, 'PPL', 'P'),
(118372, 'Weldon', 40.8974990844727, 0.713796014855414, -93.7347183227539, -1.63597945816151, 218, 16, 'PPL', 'P'),
(121900, 'Weldon', 40.1211090087891, 0.700245451754928, -88.7452774047852, -1.54889728630923, 218, 18, 'PPL', 'P'),
(133637, 'Weldon', 44.5661087036133, 0.777825331679753, -86.0630569458008, -1.5020837080356, 218, 27, 'PPL', 'P'),
(146587, 'Weldon', 40.9919395446777, 0.715444311833092, -74.5883331298828, -1.30181199669082, 218, 37, 'PPL', 'P'),
(158245, 'Weldon', 41.2769393920898, 0.720418497538114, -80.5472183227539, -1.40581416305476, 218, 41, 'PPL', 'P'),
(168631, 'Weldon', 40.1100006103516, 0.70005157362757, -75.1449966430664, -1.31152760782159, 218, 45, 'PPL', 'P'),
(186053, 'Weldon', 35.665828704834, 0.622486141351658, -118.289436340332, -2.06454013446703, 218, 6, 'PPL', 'P'),
(197810, 'Weldon', 47.6124992370605, 0.830994876789995, -105.891670227051, -1.84815829589809, 218, 31, 'PPL', 'P'),
(25882, 'Weldon (historical)', 31.1094398498535, 0.542962153831074, -83.6877822875977, -1.46062734461077, 218, 13, 'PPL', 'P'),
(58188, 'Weldon Spring', 38.7133293151855, 0.675675060958829, -90.6891708374023, -1.58282462701629, 218, 29, 'PPL', 'P'),
(58189, 'Weldon Spring Heights', 38.7050018310547, 0.675529718942338, -90.6872177124023, -1.58279053855434, 218, 29, 'PPL', 'P'),
(194472, 'Weldona', 40.3461112976074, 0.704172482519331, -103.968612670898, -1.81459460983787, 218, 7, 'PPL', 'P'),
(186054, 'Weldons', 34.3450012207031, 0.599433352902741, -119.296112060547, -2.08210994028466, 218, 6, 'PPL', 'P'),
(25883, 'Weldons Crossroads', 33.1941719055176, 0.579347592224282, -84.0708312988281, -1.46731281105325, 218, 13, 'PPL', 'P'),
(69963, 'Weldons Mill', 36.2902793884277, 0.633384861796698, -78.3208312988281, -1.36695637906358, 218, 33, 'PPL', 'P'),
(121901, 'Weldwood Oaks', 42.0288887023926, 0.733542488810998, -88.3427810668945, -1.54187239998582, 218, 18, 'PPL', 'P'),
(77637, 'Weleetka', 35.3355598449707, 0.616721862330236, -96.1361083984375, -1.67789162160691, 218, 42, 'PPL', 'P'),
(98976, 'Welfare', 29.9214191436768, 0.522227280926422, -98.7863082885742, -1.72414633552578, 218, 51, 'PPL', 'P'),
(12728, 'Welford (historical)', 35.3958282470703, 0.61777374438179, -90.6111068725586, -1.58146215380261, 218, 4, 'PPL', 'P'),
(28930, 'Welge', 37.9563903808594, 0.662463984318301, -89.7125015258789, -1.56577853182702, 218, 18, 'PPL', 'P'),
(18533, 'Welika (historical)', 30.2833309173584, 0.528543832978899, -84.533332824707, -1.47538498547534, 218, 12, 'PPL', 'P'),
(211299, 'Weliweli', 19.9011096954346, 0.347339888985899, -155.9072265625, -2.72109443116839, 218, 15, 'PPL', 'P'),
(291, 'Welka', 31.0133304595947, 0.541284728528974, -87.2008285522461, -1.52194156870377, 218, 2, 'PPL', 'P'),
(74749, 'Wellan (historical)', 39.7763900756836, 0.694228971378275, -82.3119430541992, -1.43661442000985, 218, 41, 'PPL', 'P'),
(121902, 'Welland', 41.6266708374023, 0.726522462756576, -89.0708312988281, -1.55457927365297, 218, 18, 'PPL', 'P'),
(209128, 'Welland', 46.2277793884277, 0.806826956213635, -118.745559692383, -2.07250098875555, 218, 56, 'PPL', 'P'),
(52597, 'Welland at Barstow', 38.5077781677246, 0.672087516654384, -76.6236114501953, -1.33733430457474, 218, 25, 'PPL', 'P'),
(6685, 'Wellborn', 33.6533317565918, 0.587361443418494, -85.8811111450195, -1.49890815475179, 218, 2, 'PPL', 'P'),
(18534, 'Wellborn', 30.2308292388916, 0.52762750582683, -82.8197174072266, -1.44547675432737, 218, 12, 'PPL', 'P'),
(98977, 'Wellborn', 30.5349998474121, 0.532936284433307, -96.3013916015625, -1.68077635769968, 218, 51, 'PPL', 'P'),
(201765, 'Wellen (historical)', 42.4222183227539, 0.740407385731922, -122.759719848633, -2.14256130018448, 218, 43, 'PPL', 'P'),
(6686, 'Weller', 33.3349990844727, 0.581805490173343, -87.147216796875, -1.52100586705478, 218, 2, 'PPL', 'P'),
(107379, 'Weller', 37.329719543457, 0.6515265148794, -82.1763916015625, -1.43424860085548, 218, 53, 'PPL', 'P'),
(118373, 'Weller', 41.1072196960449, 0.717456330036647, -93.0491714477539, -1.624014408016, 218, 16, 'PPL', 'P'),
(187523, 'Weller', 39.4474983215332, 0.688488727385691, -105.620002746582, -1.84341680389331, 218, 7, 'PPL', 'P'),
(52579, 'Weller Estates', 39.3613891601563, 0.686985839003532, -77.2683334350586, -1.34858682597059, 218, 25, 'PPL', 'P'),
(52580, 'Weller Farm', 39.6761093139648, 0.692478741909875, -77.6755599975586, -1.3556942702878, 218, 25, 'PPL', 'P'),
(79356, 'Wellersburg', 39.732780456543, 0.693467839938731, -78.8505630493164, -1.37620194226195, 218, 45, 'PPL', 'P'),
(114235, 'Welles Village', 41.7277793884277, 0.72828713987389, -72.5999984741211, -1.26710901031627, 218, 8, 'PPL', 'P'),
(126470, 'Wellesley', 42.2963905334473, 0.738211276518016, -71.2930603027344, -1.24429863610558, 218, 23, 'PPL', 'P'),
(126471, 'Wellesley Farms', 42.3194389343262, 0.738613547000672, -71.2694396972656, -1.24388637876884, 218, 23, 'PPL', 'P'),
(126472, 'Wellesley Fells', 42.3083305358887, 0.738419668873314, -71.3166732788086, -1.24471076028427, 218, 23, 'PPL', 'P'),
(126473, 'Wellesley Hills', 42.3083305358887, 0.738419668873314, -71.279167175293, -1.24405615528833, 218, 23, 'PPL', 'P'),
(126475, 'Wellfleet', 41.9375, 0.731947455055122, -70.033332824707, -1.22231224393616, 218, 23, 'PPL', 'P'),
(199766, 'Wellfleet', 40.7522201538086, 0.71126041918155, -100.729438781738, -1.7580603604274, 218, 35, 'PPL', 'P'),
(126476, 'Wellfleet by the Sea', 41.9297218322754, 0.731811700418555, -69.9791717529297, -1.22136695490723, 218, 23, 'PPL', 'P'),
(12730, 'Wellford', 33.0516700744629, 0.576860466082257, -91.3180618286133, -1.59380084544906, 218, 4, 'PPL', 'P'),
(84266, 'Wellford', 34.9508285522461, 0.610007034536737, -82.1061096191406, -1.43302194885739, 218, 48, 'PPL', 'P'),
(107380, 'Wellford', 37.8855590820313, 0.661227744940286, -76.76611328125, -1.33982143071676, 218, 53, 'PPL', 'P'),
(111955, 'Wellford', 38.5305595397949, 0.672485126605132, -81.3399963378906, -1.41965074965632, 218, 58, 'PPL', 'P'),
(52581, 'Wellham Crossroads (historical)', 39.1791687011719, 0.68380549202976, -76.6669387817383, -1.33809050916626, 218, 25, 'PPL', 'P'),
(38795, 'Wellhope', 37.3161087036133, 0.651288960910165, -84.3183288574219, -1.47163245834136, 218, 21, 'PPL', 'P'),
(77639, 'Welling', 35.8777809143066, 0.626185405263832, -94.9008331298828, -1.65633200100217, 218, 42, 'PPL', 'P'),
(176946, 'Welling Beach', 43.8705596923828, 0.765685711324791, -88.3638916015625, -1.54224084832263, 218, 57, 'PPL', 'P'),
(902, 'Wellington', 33.5380592346191, 0.585349558372993, -81.977783203125, -1.43078223038063, 218, 48, 'PPL', 'P'),
(6687, 'Wellington', 33.8224983215332, 0.59031395696101, -85.8927764892578, -1.49911175341712, 218, 2, 'PPL', 'P'),
(18535, 'Wellington', 26.6583309173584, 0.465275647594104, -80.2416687011719, -1.40048131612993, 218, 12, 'PPL', 'P'),
(31480, 'Wellington', 39.8716697692871, 0.695891915741948, -86.1436080932617, -1.50348959077505, 218, 19, 'PPL', 'P'),
(34373, 'Wellington', 37.2652816772461, 0.650401861951059, -97.3713912963867, -1.6994513753697, 218, 20, 'PPL', 'P'),
(38793, 'Wellington', 37.9144401550293, 0.66173181475561, -83.5119400024414, -1.45755831777056, 218, 21, 'PPL', 'P'),
(52583, 'Wellington', 38.1563911437988, 0.665954656138095, -75.6097183227539, -1.31963853123754, 218, 25, 'PPL', 'P'),
(58191, 'Wellington', 39.1341705322266, 0.683020125824295, -93.9824981689453, -1.64030403229764, 218, 29, 'PPL', 'P'),
(107382, 'Wellington', 38.7900009155273, 0.677013232827567, -77.5608291625977, -1.35369183946417, 218, 53, 'PPL', 'P'),
(111956, 'Wellington', 38.8333282470703, 0.677769437419095, -81.3424987792969, -1.4196944254982, 218, 58, 'PPL', 'P'),
(121904, 'Wellington', 40.5391693115234, 0.707541980509527, -87.6800003051758, -1.53030469347495, 218, 18, 'PPL', 'P'),
(126478, 'Wellington', 42.4111099243164, 0.740213507604564, -71.0833282470703, -1.24063812118727, 218, 23, 'PPL', 'P'),
(129214, 'Wellington', 45.0397186279297, 0.786091384229196, -69.5977783203125, -1.21471038376258, 218, 26, 'PPL', 'P'),
(133638, 'Wellington', 46.3308296203613, 0.80862552205582, -89.6569366455078, -1.56480874171607, 218, 27, 'PPL', 'P'),
(158247, 'Wellington', 41.1688919067383, 0.718532713170229, -82.2180633544922, -1.43497591014918, 218, 41, 'PPL', 'P'),
(168633, 'Wellington', 40.6822204589844, 0.710038694031476, -75.5038909912109, -1.31779149586352, 218, 45, 'PPL', 'P'),
(190910, 'Wellington', 38.7563896179199, 0.67642660501845, -119.375, -2.08348679456823, 218, 39, 'PPL', 'P'),
(192405, 'Wellington', 34.8561096191406, 0.608353877290071, -100.213333129883, -1.74905261751437, 218, 51, 'PPL', 'P'),
(192855, 'Wellington', 39.5424995422363, 0.690146811480374, -110.734718322754, -1.93268543100055, 218, 52, 'PPL', 'P'),
(194473, 'Wellington', 40.7038917541504, 0.710416929485295, -105.008056640625, -1.8327363294996, 218, 7, 'PPL', 'P'),
(107383, 'Wellington Acres', 39.2472190856934, 0.684993195296908, -78.1527786254883, -1.36402330659702, 218, 53, 'PPL', 'P'),
(52584, 'Wellington Beach', 38.3661117553711, 0.669614971319327, -77.1958312988281, -1.34732142497864, 218, 25, 'PPL', 'P'),
(153541, 'Wellington Corner', 42.9869384765625, 0.750263611768251, -76.2605590820313, -1.33099784539311, 218, 40, 'PPL', 'P'),
(179487, 'Wellington Court', 33.5930595397949, 0.586309494787913, -112.198608398438, -1.9582351327085, 218, 5, 'PPL', 'P'),
(52586, 'Wellington Estates', 38.3933296203613, 0.67009001267877, -75.6055603027344, -1.31956596009784, 218, 25, 'PPL', 'P'),
(84267, 'Wellington Green', 34.2427787780762, 0.59764923470947, -82.1774978637695, -1.43426790877338, 218, 48, 'PPL', 'P'),
(31481, 'Wellington Heights', 39.5175018310547, 0.689710519114792, -85.7633285522461, -1.49685246070636, 218, 19, 'PPL', 'P'),
(107384, 'Wellington Heights', 38.7502784729004, 0.676319945416792, -77.0547180175781, -1.34485853360254, 218, 53, 'PPL', 'P'),
(111957, 'Wellington Heights', 39.1416702270508, 0.683151020191873, -80.0672225952148, -1.3974366572137, 218, 58, 'PPL', 'P'),
(186055, 'Wellington Heights', 34.0361099243164, 0.594042182750039, -118.184722900391, -2.06271254016896, 218, 6, 'PPL', 'P'),
(14816, 'Wellington Hills', 39.7897186279297, 0.694461598499494, -75.7083282470703, -1.321359599092, 218, 10, 'PPL', 'P'),
(25886, 'Wellington Manor', 33.461669921875, 0.584016313352272, -84.4116668701172, -1.47326151398016, 218, 13, 'PPL', 'P'),
(6688, 'Wellington Park', 33.4694404602051, 0.584151934830785, -86.7286071777344, -1.51369975092025, 218, 2, 'PPL', 'P'),
(71534, 'Wellington Park', 39.9952812194824, 0.698049342541021, -74.980827331543, -1.30866231280478, 218, 37, 'PPL', 'P'),
(190912, 'Wellington Springs', 38.7533302307129, 0.676373208638594, -119.191390991211, -2.08028221282854, 218, 39, 'PPL', 'P'),
(52587, 'Wellington Valley', 39.4283294677734, 0.68815416777375, -76.6444396972656, -1.33769782606353, 218, 25, 'PPL', 'P'),
(69965, 'Wellington Way', 36.1213912963867, 0.630437208523171, -80.1205596923828, -1.39836756517274, 218, 33, 'PPL', 'P'),
(84269, 'Wellington West', 34.8888893127441, 0.608925990871247, -82.0058288574219, -1.43127171938899, 218, 48, 'PPL', 'P'),
(14817, 'Wellington Woods', 39.625560760498, 0.691596503219759, -75.6930618286133, -1.32109314982494, 218, 10, 'PPL', 'P'),
(25887, 'Wellington Woods', 32.6444396972656, 0.569752955186026, -83.6958312988281, -1.46076782635827, 218, 13, 'PPL', 'P'),
(52588, 'Wellington Woods', 38.6500015258789, 0.674569782527419, -76.9888916015625, -1.34370964590828, 218, 25, 'PPL', 'P'),
(69966, 'Wellington Woods', 35.0372200012207, 0.611514849766913, -80.6936111450195, -1.40836919980458, 218, 33, 'PPL', 'P'),
(168632, 'Welliversville', 41.0977783203125, 0.717291546944198, -76.4761123657227, -1.33475995990701, 218, 45, 'PPL', 'P'),
(62252, 'Wellman', 31.4583301544189, 0.549051438374027, -90.3605575561523, -1.5770892432927, 218, 30, 'PPL', 'P'),
(74750, 'Wellman', 39.4824981689453, 0.689099589960728, -84.0325012207031, -1.46664382498742, 218, 41, 'PPL', 'P'),
(118374, 'Wellman', 41.464168548584, 0.723686262774669, -91.8380584716797, -1.60287649896988, 218, 16, 'PPL', 'P'),
(192406, 'Wellman', 33.0483283996582, 0.576802142854384, -102.42749786377, -1.78769708230224, 218, 51, 'PPL', 'P'),
(209129, 'Wellpinit', 47.8880615234375, 0.835804345981596, -117.986938476563, -2.059260550764, 218, 56, 'PPL', 'P'),
(84270, 'Wellridge', 34.6222190856934, 0.60427171739217, -81.0747222900391, -1.41502084410122, 218, 48, 'PPL', 'P'),
(34376, 'Wells', 39.1388893127441, 0.683102484081006, -97.5505599975586, -1.70257845912167, 218, 20, 'PPL', 'P'),
(38794, 'Wells', 37.1413917541504, 0.648239574882997, -87.0747222900391, -1.51974059922088, 218, 21, 'PPL', 'P'),
(62251, 'Wells', 32.3208312988281, 0.564104923146186, -90.107780456543, -1.57267745063087, 218, 30, 'PPL', 'P'),
(84271, 'Wells', 33.3713912963867, 0.582440654093327, -80.480827331543, -1.40465542166447, 218, 48, 'PPL', 'P'),
(91713, 'Wells', 35.1822204589844, 0.614045585171788, -89.9169387817383, -1.56934663505551, 218, 50, 'PPL', 'P'),
(107385, 'Wells', 36.9652786254883, 0.645165820931854, -82.6194381713867, -1.44198122223858, 218, 53, 'PPL', 'P'),
(123974, 'Wells', 40.7322196960449, 0.710911345341668, -86.1111068725586, -1.50292233746286, 218, 19, 'PPL', 'P'),
(129216, 'Wells', 43.3219413757324, 0.756110515362493, -70.5813903808594, -1.23187765278145, 218, 26, 'PPL', 'P'),
(133641, 'Wells', 45.7772216796875, 0.798963240725876, -87.0794372558594, -1.51982289089856, 218, 27, 'PPL', 'P'),
(138740, 'Wells', 43.7461090087891, 0.763513637139722, -93.7286071777344, -1.63587279855985, 218, 28, 'PPL', 'P'),
(153542, 'Wells', 43.3958282470703, 0.757400084541336, -74.2900009155273, -1.29660511728555, 218, 40, 'PPL', 'P'),
(168634, 'Wells', 40.8283309936523, 0.712588803933282, -79.1449966430664, -1.38134077790137, 218, 45, 'PPL', 'P'),
(172710, 'Wells', 43.4172210693359, 0.757773459726165, -73.204719543457, -1.27766338403237, 218, 55, 'PPL', 'P'),
(176948, 'Wells', 44.0955581665039, 0.769612675510167, -88.043327331543, -1.53664594634654, 218, 57, 'PPL', 'P'),
(192407, 'Wells', 33.021671295166, 0.576336888611947, -101.920761108398, -1.77885285748014, 218, 51, 'PPL', 'P'),
(193325, 'Wells', 59.4166717529297, 1.03701655266533, -135.933059692383, -2.37247945394207, 218, 1, 'PPL', 'P'),
(200274, 'Wells', 41.1116714477539, 0.71753402776145, -114.963607788086, -2.0064934758735, 218, 39, 'PPL', 'P'),
(206370, 'Wells', 40.6913909912109, 0.71019875001299, -111.815002441406, -1.95153994572804, 218, 52, 'PPL', 'P'),
(25888, 'Wells (historical)', 34.6452789306641, 0.604674187611908, -84.753059387207, -1.47921993744505, 218, 13, 'PPL', 'P'),
(111958, 'Wells (historical)', 39.7827796936035, 0.694340491248922, -80.5924987792969, -1.40660445610824, 218, 58, 'PPL', 'P'),
(129217, 'Wells Beach', 43.3025016784668, 0.755771228639617, -70.5677795410156, -1.23164009881222, 218, 26, 'PPL', 'P'),
(129218, 'Wells Beach Station', 43.3238906860352, 0.756144537245418, -70.5919418334961, -1.23206181037083, 218, 26, 'PPL', 'P'),
(98979, 'Wells Branch', 30.4458293914795, 0.531379966381779, -97.6791687011719, -1.70482310444644, 218, 51, 'PPL', 'P'),
(129219, 'Wells Branch', 43.3736114501953, 0.757012328286621, -70.6002807617188, -1.2322073521244, 218, 26, 'PPL', 'P'),
(153543, 'Wells Bridge', 42.3675003051758, 0.73945237616502, -75.2458267211914, -1.31328742466992, 218, 40, 'PPL', 'P'),
(52590, 'Wells Corner', 38.8241691589355, 0.677609581174663, -76.7286071777344, -1.33916682572082, 218, 25, 'PPL', 'P'),
(153544, 'Wells Corner', 43.0144386291504, 0.750743579975711, -75.4927825927734, -1.31759761773616, 218, 40, 'PPL', 'P'),
(121905, 'Wells Corners', 42.309440612793, 0.738439043370245, -87.8925018310547, -1.53401354476705, 218, 18, 'PPL', 'P'),
(52591, 'Wells Cove', 38.4500007629395, 0.671079110707625, -76.5961074829102, -1.33685426978825, 218, 25, 'PPL', 'P'),
(98983, 'Wells Creek', 31.798059463501, 0.554980833383034, -95.5550003051758, -1.6677493720695, 218, 51, 'PPL', 'P'),
(168645, 'Wells Creek', 40.0377807617188, 0.698791099483635, -78.995002746582, -1.37872289054982, 218, 45, 'PPL', 'P'),
(12732, 'Wells Creek (historical)', 36.0411109924316, 0.629036052894653, -93.0644378662109, -1.62428085728307, 218, 4, 'PPL', 'P'),
(84272, 'Wells Crossroads', 34.0677795410156, 0.594594921834285, -80.1627807617188, -1.39910446184636, 218, 48, 'PPL', 'P'),
(6689, 'Wells Ford', 34.707218170166, 0.605755231277399, -86.3061065673828, -1.50632572417793, 218, 2, 'PPL', 'P'),
(38796, 'Wells Fork', 37.5377807617188, 0.655157868183777, -83.2094421386719, -1.45227873406754, 218, 21, 'PPL', 'P'),
(91714, 'Wells Hill (historical)', 35.1027793884277, 0.612659076929265, -86.5666732788086, -1.51087347121341, 218, 50, 'PPL', 'P'),
(168635, 'Wells Hollow', 41.8597183227539, 0.730589908689454, -76.2452774047852, -1.33073112980994, 218, 45, 'PPL', 'P'),
(71529, 'Wells Mills', 39.7941703796387, 0.694539296224297, -74.2761077880859, -1.2963626364683, 218, 37, 'PPL', 'P'),
(194044, 'Wells Place', 40.1980590820313, 0.701588483892655, -121.931106567383, -2.12809927020091, 218, 6, 'PPL', 'P'),
(172711, 'Wells River', 44.1541709899902, 0.770635662263894, -72.0475006103516, -1.25746610348326, 218, 55, 'PPL', 'P'),
(111959, 'Wells Subdivision', 39.2177810668945, 0.684479404943604, -81.6511077880859, -1.42508066880288, 218, 58, 'PPL', 'P'),
(168636, 'Wells Tannery', 40.0911102294922, 0.699721874284618, -78.1666717529297, -1.36426578741427, 218, 45, 'PPL', 'P'),
(62253, 'Wells Town', 31.0227794647217, 0.541449644779477, -89.4747161865234, -1.5616283947423, 218, 30, 'PPL', 'P'),
(123976, 'Wellsboro', 41.4972190856934, 0.72426310346678, -86.7652816772461, -1.51433984168825, 218, 19, 'PPL', 'P'),
(168639, 'Wellsboro', 41.7486114501953, 0.728650727941713, -77.3008270263672, -1.34915394612473, 218, 45, 'PPL', 'P'),
(168640, 'Wellsboro Junction', 41.7872200012207, 0.72932457427653, -77.304443359375, -1.34921706304256, 218, 45, 'PPL', 'P'),
(38797, 'Wellsburg', 38.7713890075684, 0.676688393753605, -84.1036071777344, -1.4678848580554, 218, 21, 'PPL', 'P'),
(118376, 'Wellsburg', 42.459171295166, 0.741052336768912, -92.9383316040039, -1.62207988780017, 218, 16, 'PPL', 'P'),
(123977, 'Wellsburg', 40.6661109924316, 0.709757530799391, -85.2216720581055, -1.48739877146879, 218, 19, 'PPL', 'P'),
(141062, 'Wellsburg', 47.8316688537598, 0.83482010822173, -99.7611083984375, -1.7411598069917, 218, 34, 'PPL', 'P'),
(153546, 'Wellsburg', 42.0161094665527, 0.733319449069703, -76.7272186279297, -1.3391425909549, 218, 40, 'PPL', 'P'),
(177298, 'Wellsburg', 40.2719383239746, 0.702877919913444, -80.6097183227539, -1.40690499383726, 218, 58, 'PPL', 'P'),
(34378, 'Wellsford', 37.6166687011719, 0.656534722467348, -99.0283279418945, -1.72837037533076, 218, 20, 'PPL', 'P'),
(111960, 'Wellsley', 39.2566719055176, 0.685158178126438, -81.6194381713867, -1.42452792971864, 218, 58, 'PPL', 'P'),
(186056, 'Wellsona', 35.6972198486328, 0.623034020166914, -120.692497253418, -2.10648145952636, 218, 6, 'PPL', 'P'),
(58192, 'Wellston', 38.672779083252, 0.674967325899141, -90.2991714477539, -1.57601785358616, 218, 29, 'PPL', 'P'),
(74751, 'Wellston', 39.1233291625977, 0.682830908228845, -82.5330581665039, -1.44047360674549, 218, 41, 'PPL', 'P'),
(77641, 'Wellston', 35.6941719055176, 0.62298082352414, -97.0630569458008, -1.69406992575497, 218, 42, 'PPL', 'P'),
(133645, 'Wellston', 44.2169418334961, 0.771731220157325, -85.9577789306641, -1.5002462600415, 218, 27, 'PPL', 'P'),
(34380, 'Wellsville', 38.7183303833008, 0.675762346063557, -95.0813903808594, -1.65948331952006, 218, 20, 'PPL', 'P'),
(58193, 'Wellsville', 39.0719413757324, 0.681934022152734, -91.5699996948242, -1.59819799072489, 218, 29, 'PPL', 'P'),
(91715, 'Wellsville', 35.6069412231445, 0.621458360907969, -84.0872192382813, -1.46759883455433, 218, 50, 'PPL', 'P'),
(114236, 'Wellsville', 41.5969390869141, 0.726003545818174, -73.415283203125, -1.28133841317862, 218, 8, 'PPL', 'P'),
(133646, 'Wellsville', 41.8844413757324, 0.731021407365074, -83.8855590820313, -1.46407920085768, 218, 27, 'PPL', 'P'),
(153548, 'Wellsville', 42.8758316040039, 0.74832443102051, -74.2727813720703, -1.29630457955654, 218, 40, 'PPL', 'P'),
(158249, 'Wellsville', 40.6027793884277, 0.708652185788954, -80.649169921875, -1.4075935541371, 218, 41, 'PPL', 'P'),
(168642, 'Wellsville', 40.0513916015625, 0.69902865345287, -76.9369430541992, -1.34280297271516, 218, 45, 'PPL', 'P'),
(187524, 'Wellsville', 38.4866714477539, 0.671719134896598, -105.909439086914, -1.84846842100703, 218, 7, 'PPL', 'P'),
(193240, 'Wellsville', 41.6386108398438, 0.726730855111875, -111.933059692383, -1.95360043346343, 218, 52, 'PPL', 'P'),
(179488, 'Wellton', 32.672779083252, 0.570247570779481, -114.146110534668, -1.99222545717534, 218, 5, 'PPL', 'P'),
(107387, 'Welltown', 39.2533302307129, 0.685099854898565, -78.1344375610352, -1.36370319463399, 218, 53, 'PPL', 'P'),
(107386, 'Wellville', 37.1272201538086, 0.647992233796756, -77.9211120605469, -1.35997996227201, 218, 53, 'PPL', 'P'),
(126479, 'Wellville', 42.6602783203125, 0.744562316506609, -71.9061126708984, -1.25499841841719, 218, 23, 'PPL', 'P'),
(52593, 'Wellwood', 39.485279083252, 0.689148126071595, -76.9897232055664, -1.34372416013622, 218, 25, 'PPL', 'P'),
(71530, 'Wellwood', 39.9527816772461, 0.697307585598407, -75.0494384765625, -1.30985980318893, 218, 37, 'PPL', 'P'),
(91716, 'Wellwood', 35.6158294677734, 0.621613490041466, -89.107780456543, -1.55522415811093, 218, 50, 'PPL', 'P'),
(153550, 'Wellwood', 43.413330078125, 0.757705549118368, -76.2508316040039, -1.33082806887362, 218, 40, 'PPL', 'P'),
(211302, 'WelokÃƒÂ¤', 19.9605598449707, 0.348377489836108, -155.200836181641, -2.70876559321797, 218, 15, 'PPL', 'P'),
(77643, 'Welon', 34.6519393920898, 0.60479043459349, -99.3461074829102, -1.73391667461696, 218, 42, 'PPL', 'P'),
(6690, 'Welona', 32.7666702270508, 0.571886280377234, -86.3361129760742, -1.5068494348063, 218, 2, 'PPL', 'P'),
(12733, 'Welsh', 34.3561096191406, 0.599627231030099, -93.4736099243164, -1.63142225690417, 218, 4, 'PPL', 'P'),
(44065, 'Welsh', 30.2358303070068, 0.527714790931557, -92.8225021362305, -1.62005828221669, 218, 22, 'PPL', 'P'),
(74753, 'Welsh', 39.1505584716797, 0.68330614932537, -82.1730575561523, -1.43419041078566, 218, 41, 'PPL', 'P'),
(158251, 'Welsh Hills', 40.0838890075684, 0.69959584018603, -82.4663925170898, -1.43931007166523, 218, 41, 'PPL', 'P'),
(84273, 'Welsh Neck (historical)', 34.5611114501953, 0.60320518795462, -79.8083267211914, -1.39291807179216, 218, 48, 'PPL', 'P'),
(79359, 'Welsh Run', 39.764720916748, 0.694025306133911, -77.8525009155273, -1.35878247188785, 218, 45, 'PPL', 'P'),
(158253, 'Welshfield', 41.3869400024414, 0.722338370367953, -81.1425018310547, -1.41620382025743, 218, 41, 'PPL', 'P'),
(14819, 'Welshire', 39.7847213745117, 0.694374379973793, -75.5166702270508, -1.31801453560481, 218, 10, 'PPL', 'P'),
(144618, 'Welshs Corner', 43.3344383239746, 0.75632862825577, -71.1316680908203, -1.2414818106206, 218, 36, 'PPL', 'P'),
(74754, 'Welshtown', 39.0275001525879, 0.681158376485248, -81.9958267211914, -1.43109714917954, 218, 41, 'PPL', 'P'),
(168644, 'Welshtown', 40.7586097717285, 0.711371939052197, -75.616943359375, -1.31976463191516, 218, 45, 'PPL', 'P'),
(6697, 'Welti', 34.1391716003418, 0.595840948329306, -86.7388916015625, -1.51387924797772, 218, 2, 'PPL', 'P'),
(118377, 'Welton', 41.9080581665039, 0.731433598122791, -90.5952835083008, -1.58118598399757, 218, 16, 'PPL', 'P'),
(153551, 'Weltonville', 42.1963882446289, 0.736465907318605, -76.246940612793, -1.33076015826582, 218, 40, 'PPL', 'P'),
(77644, 'Welty', 35.624439239502, 0.621763758905974, -96.4049987792969, -1.68258464407984, 218, 42, 'PPL', 'P'),
(194474, 'Welty', 40.3277816772461, 0.703852570293386, -105.017219543457, -1.83289625232306, 218, 7, 'PPL', 'P'),
(168647, 'Weltytown', 40.2083282470703, 0.701767714634017, -79.4461135864258, -1.38659625999653, 218, 45, 'PPL', 'P'),
(91717, 'Welwyn (historical)', 35.8944396972656, 0.626476155875842, -83.9533309936523, -1.46526204385584, 218, 50, 'PPL', 'P'),
(138743, 'Weme', 47.6441688537598, 0.831547615874241, -95.5377807617188, -1.66744883434049, 218, 28, 'PPL', 'P'),
(201766, 'Wemme', 45.3488883972168, 0.791487414650887, -121.964721679688, -2.12868596458906, 218, 43, 'PPL', 'P'),
(44066, 'Wemple', 32.0122184753418, 0.558718613262474, -93.4794387817383, -1.63152398965781, 218, 22, 'PPL', 'P'),
(153554, 'Wemple', 42.5741691589355, 0.74305942812445, -73.7761077880859, -1.28763599020833, 218, 40, 'PPL', 'P'),
(121911, 'Wempletown', 42.3433303833008, 0.739030531448351, -89.2041702270508, -1.55690647697153, 218, 18, 'PPL', 'P'),
(209130, 'Wenas', 46.8727798461914, 0.818084337878481, -120.77278137207, -2.1078826817339, 218, 56, 'PPL', 'P'),
(62254, 'Wenasoga', 34.9869384765625, 0.610637271608705, -88.5905609130859, -1.54619697412194, 218, 30, 'PPL', 'P'),
(209131, 'Wenatchee', 47.4236106872559, 0.827698149676586, -120.309173583984, -2.09979119939391, 218, 56, 'PPL', 'P'),
(209132, 'Wenatchee Heights', 47.3600006103516, 0.826587944397159, -120.286109924316, -2.09938866259515, 218, 56, 'PPL', 'P'),
(206374, 'Wenco Condominium', 40.735279083252, 0.710964741721524, -111.920280456543, -1.95337739372214, 218, 52, 'PPL', 'P'),
(6691, 'Wende', 32.2574996948242, 0.562999578135749, -85.3394393920898, -1.48945419919812, 218, 2, 'PPL', 'P'),
(153552, 'Wende', 42.9341697692871, 0.749342624084274, -78.5469436645508, -1.37090278432491, 218, 40, 'PPL', 'P'),
(111961, 'Wendel', 39.2963905334473, 0.685851398958186, -80.1055603027344, -1.39810577643758, 218, 58, 'PPL', 'P'),
(121906, 'Wendel', 41.5330581665039, 0.724888613427812, -89.2099990844727, -1.55700820972518, 218, 18, 'PPL', 'P'),
(168646, 'Wendel', 40.2955589294434, 0.703290177250188, -79.6866683959961, -1.39079473345504, 218, 45, 'PPL', 'P'),
(194045, 'Wendel', 40.348331451416, 0.704211231513192, -120.232498168945, -2.09845296094615, 218, 6, 'PPL', 'P'),
(28931, 'Wendelin', 38.8333282470703, 0.677769437419095, -88.2727813720703, -1.54065067483574, 218, 18, 'PPL', 'P'),
(158254, 'Wendelin', 40.399169921875, 0.705098530209379, -84.6900024414063, -1.47811938612458, 218, 41, 'PPL', 'P'),
(69974, 'Wendell', 35.7808303833008, 0.624493299286223, -78.370002746582, -1.36781458272486, 218, 33, 'PPL', 'P'),
(126480, 'Wendell', 42.5480613708496, 0.742603761261938, -72.397216796875, -1.26356980238561, 218, 23, 'PPL', 'P'),
(138744, 'Wendell', 46.0355606079102, 0.803472105609435, -96.100830078125, -1.67727589876288, 218, 28, 'PPL', 'P'),
(144619, 'Wendell', 43.3736114501953, 0.757012328286621, -72.2502822875977, -1.26100531141392, 218, 36, 'PPL', 'P'),
(195788, 'Wendell', 42.7758293151855, 0.746579061821099, -114.703330993652, -2.00195078884409, 218, 17, 'PPL', 'P'),
(206375, 'Wendell Circle', 40.6930618286133, 0.710227911626926, -111.878608703613, -1.95265008442844, 218, 52, 'PPL', 'P'),
(126481, 'Wendell Depot', 42.5958290100098, 0.743437463841187, -72.3602828979492, -1.26292518424376, 218, 23, 'PPL', 'P'),
(206376, 'Wendell Way', 40.6925010681152, 0.71021812450992, -111.877777099609, -1.9526355702005, 218, 52, 'PPL', 'P'),
(153553, 'Wendelville', 43.0711097717285, 0.751732678004566, -78.7708282470703, -1.37481030743433, 218, 40, 'PPL', 'P'),
(179489, 'Wenden', 33.8224983215332, 0.59031395696101, -113.540832519531, -1.98166136292127, 218, 5, 'PPL', 'P'),
(201767, 'Wendling', 44.190559387207, 0.77127075960485, -122.797218322754, -2.14321577202236, 218, 43, 'PPL', 'P'),
(38798, 'Wendover', 37.1263885498047, 0.647977719568815, -83.3627777099609, -1.45495494464696, 218, 21, 'PPL', 'P'),
(206377, 'Wendover', 40.7372207641602, 0.710998630446395, -114.036666870117, -1.99031530488348, 218, 52, 'PPL', 'P'),
(209820, 'Wendover', 42.3274993896484, 0.738754228485256, -104.873062133789, -1.83038023088321, 218, 59, 'PPL', 'P'),
(69968, 'Wendover Hills', 35.7969398498535, 0.624774462518308, -80.9188919067383, -1.41230109083798, 218, 33, 'PPL', 'P'),
(98980, 'Wendt', 29.9061107635498, 0.521960099290059, -96.8997192382813, -1.6912191449661, 218, 51, 'PPL', 'P'),
(202758, 'Wendte', 44.2444381713867, 0.772211121785757, -100.66471862793, -1.75693078065104, 218, 49, 'PPL', 'P'),
(98981, 'Wendy Acres Colonia', 27.8740005493164, 0.486493085288279, -97.2009963989258, -1.69647742338041, 218, 51, 'PPL', 'P'),
(186057, 'Wene''me (historical)', 34.1500015258789, 0.596029966187674, -119.197219848633, -2.08038394558218, 218, 6, 'PPL', 'P'),
(74755, 'Wengerlawn', 39.8736114501953, 0.695925804466819, -84.4649963378906, -1.47419228878114, 218, 41, 'PPL', 'P'),
(194046, 'Wengler', 40.9141693115234, 0.714086965204506, -121.907501220703, -2.12768727918028, 218, 6, 'PPL', 'P'),
(126484, 'Wenham', 41.9124984741211, 0.731511096110512, -70.7666702270508, -1.23511139613508, 218, 23, 'PPL', 'P'),
(126485, 'Wenham Neck', 42.5922203063965, 0.743374480081407, -70.8450012207031, -1.23647852988067, 218, 23, 'PPL', 'P'),
(79358, 'Wenksville', 39.9900016784668, 0.697957197167304, -77.3108291625977, -1.34932851633418, 218, 45, 'PPL', 'P'),
(172713, 'Wenlock', 44.7763900756836, 0.781495433977992, -71.7536087036133, -1.25233672206571, 218, 55, 'PPL', 'P'),
(121907, 'Wenmoth Acres', 41.8502807617188, 0.730425192176033, -88.3652801513672, -1.54226508308855, 218, 18, 'PPL', 'P'),
(168648, 'Wennersville', 40.6108283996582, 0.708792667536455, -75.5480575561523, -1.31856234784104, 218, 45, 'PPL', 'P'),
(25890, 'Wenona', 31.9052791595459, 0.556852170102005, -83.7669372558594, -1.46200885942625, 218, 13, 'PPL', 'P'),
(52594, 'Wenona', 38.1388893127441, 0.665649191561063, -75.9505615234375, -1.3255873673225, 218, 25, 'PPL', 'P'),
(69969, 'Wenona', 35.7180595397949, 0.623397741392792, -76.6497192382813, -1.33778997143725, 218, 33, 'PPL', 'P'),
(121908, 'Wenona', 41.0525016784668, 0.716501320469744, -89.0502777099609, -1.55422054585413, 218, 18, 'PPL', 'P'),
(6693, 'Wenonah', 33.4394416809082, 0.583628357360475, -86.896110534668, -1.51662323600689, 218, 2, 'PPL', 'P'),
(28932, 'Wenonah', 39.3269386291504, 0.68638456380842, -89.2888870239258, -1.55838506400875, 218, 18, 'PPL', 'P'),
(71531, 'Wenonah', 39.7944412231445, 0.694544023335232, -75.149169921875, -1.31160044527741, 218, 37, 'PPL', 'P'),
(111962, 'Wenonah', 37.4652786254883, 0.653892467191826, -81.2458267211914, -1.41800717978958, 218, 58, 'PPL', 'P'),
(107388, 'Wenonah (historical)', 37.3411102294922, 0.651725319854774, -80.7494430541992, -1.40934365044744, 218, 53, 'PPL', 'P'),
(118379, 'Wensel Mobile Home Park', 41.3055610656738, 0.720918039979586, -93.0805587768555, -1.62456222025223, 218, 16, 'PPL', 'P'),
(12734, 'Wenstead (historical)', 36.3983306884766, 0.63527071274361, -91.3536071777344, -1.59442122882499, 218, 4, 'PPL', 'P'),
(168649, 'Wentlings Corners', 41.1922187805176, 0.718939843921875, -79.5458297729492, -1.3883366357689, 218, 45, 'PPL', 'P'),
(58194, 'Wentworth', 36.9933280944824, 0.645655376519238, -94.0741729736328, -1.64190405948056, 218, 29, 'PPL', 'P'),
(69970, 'Wentworth', 36.4000015258789, 0.635299874357547, -79.7747192382813, -1.39233151056207, 218, 33, 'PPL', 'P'),
(98982, 'Wentworth', 32.5730590820313, 0.568507128428087, -95.8055572509766, -1.67212241573747, 218, 51, 'PPL', 'P'),
(144620, 'Wentworth', 43.8716697692871, 0.765705085821721, -71.9147186279297, -1.25514862070267, 218, 36, 'PPL', 'P'),
(171577, 'Wentworth', 43.9972190856934, 0.767896334766638, -96.9638900756836, -1.69233913736253, 218, 49, 'PPL', 'P'),
(176950, 'Wentworth', 46.5999984741211, 0.813323404797747, -91.8358306884766, -1.60283761681797, 218, 57, 'PPL', 'P'),
(144621, 'Wentworth Acres', 43.089168548584, 0.752047863119577, -70.7844390869141, -1.23542152124402, 218, 36, 'PPL', 'P'),
(144622, 'Wentworth Hill', 43.791389465332, 0.764303930193203, -71.4136123657227, -1.2464026665248, 218, 36, 'PPL', 'P'),
(144623, 'Wentworth Location', 44.8580589294434, 0.782920824372429, -71.0558319091797, -1.24015821955883, 218, 36, 'PPL', 'P'),
(144625, 'Wentworth Terrace', 43.1238899230957, 0.752653865425624, -70.831672668457, -1.23624590275945, 218, 36, 'PPL', 'P'),
(38799, 'Wentz', 37.0816688537598, 0.64719721363234, -83.0638885498047, -1.44973834470371, 218, 21, 'PPL', 'P'),
(52595, 'Wentz', 39.7083282470703, 0.693041068374045, -76.9166717529297, -1.34244917176434, 218, 25, 'PPL', 'P'),
(58195, 'Wentzville', 38.8113899230957, 0.677386541433369, -90.852783203125, -1.58568020149513, 218, 29, 'PPL', 'P'),
(6695, 'Weogufka', 33.0163917541504, 0.57624474323823, -86.3122177124023, -1.50643238377959, 218, 2, 'PPL', 'P'),
(6696, 'Weogufka (historical)', 32.9444389343262, 0.574988929626204, -86.3652801513672, -1.50735849804866, 218, 2, 'PPL', 'P'),
(6698, 'Weoka', 32.7174987792969, 0.571028076715956, -86.1841735839844, -1.50419759215085, 218, 2, 'PPL', 'P'),
(6699, 'Weoka Mills', 32.6816711425781, 0.570402766492006, -86.3005599975586, -1.50622891827231, 218, 2, 'PPL', 'P'),
(12735, 'Weona', 35.5469398498535, 0.620411139388323, -90.5975036621094, -1.58122473299143, 218, 4, 'PPL', 'P'),
(12736, 'Weona Junction', 35.5074996948242, 0.619722778825564, -90.5997161865234, -1.58126334882724, 218, 4, 'PPL', 'P'),
(194047, 'Weott', 40.3219413757324, 0.703750637802663, -123.920562744141, -2.16282183080947, 218, 6, 'PPL', 'P'),
(179490, 'Wepo Village', 35.8933296203613, 0.626456781378911, -110.373329162598, -1.9263780002748, 218, 5, 'PPL', 'P'),
(126487, 'Wepua Point', 41.3458290100098, 0.721620848191258, -70.4700012207031, -1.22993354518569, 218, 23, 'PPL', 'P'),
(114237, 'Wequetequock', 41.3588905334473, 0.721848814780569, -71.8797225952148, -1.25453782470666, 218, 8, 'PPL', 'P'),
(133647, 'Wequetonsing', 45.4280586242676, 0.792869195782475, -84.9674987792969, -1.48296261088299, 218, 27, 'PPL', 'P'),
(176951, 'Wequiock', 44.5675010681152, 0.7778496330247, -87.8811111450195, -1.53381473979167, 218, 57, 'PPL', 'P'),
(25891, 'Weracoba Heights', 32.4738883972168, 0.566776273456617, -84.9688873291016, -1.48298684564891, 218, 13, 'PPL', 'P'),
(74756, 'Werk Place', 39.142219543457, 0.683160607571797, -84.5924987792969, -1.47641762618801, 218, 41, 'PPL', 'P'),
(168653, 'Werkheiser', 40.785831451416, 0.711847046990667, -75.2663879394531, -1.31364628562681, 218, 45, 'PPL', 'P'),
(176952, 'Werley', 43.0194396972656, 0.750830865080438, -90.7652816772461, -1.58415301176803, 218, 57, 'PPL', 'P'),
(168650, 'Werleys Corner', 40.6330604553223, 0.70918069010728, -75.7238922119141, -1.32163124152319, 218, 45, 'PPL', 'P'),
(111967, 'Werner', 39.0177803039551, 0.68098873312381, -80.0105590820313, -1.3964476923429, 218, 58, 'PPL', 'P'),
(138747, 'Werner', 47.6163902282715, 0.831062787397792, -94.9225006103516, -1.65671016987696, 218, 28, 'PPL', 'P'),
(186058, 'Werner', 37.940559387207, 0.662187681355205, -121.608062744141, -2.1224610918571, 218, 6, 'PPL', 'P'),
(199066, 'Werner', 47.3605613708496, 0.826597731514165, -102.456672668457, -1.78820627870266, 218, 34, 'PPL', 'P'),
(44067, 'Werner Park', 32.4833297729492, 0.566941056549066, -93.7666702270508, -1.63653712409378, 218, 22, 'PPL', 'P'),
(168651, 'Wernersville', 40.3300018310547, 0.703891319287246, -76.0808334350586, -1.32786104110316, 218, 45, 'PPL', 'P'),
(158255, 'Wernerts Corners', 41.7033309936523, 0.727860434888232, -83.5999984741211, -1.45909522803565, 218, 41, 'PPL', 'P'),
(28933, 'Wertenberg', 38.4461097717285, 0.671011200099828, -89.6647186279297, -1.56494456293167, 218, 18, 'PPL', 'P'),
(111963, 'Werth', 38.3549995422363, 0.669421026612942, -80.7541732788086, -1.40942620844123, 218, 58, 'PPL', 'P'),
(146589, 'Wertheins Corner', 40.2516708374023, 0.702524185541654, -74.040283203125, -1.29224672100358, 218, 37, 'PPL', 'P'),
(146590, 'Wertsville', 40.4497184753418, 0.705980768899495, -74.7980575561523, -1.30547237845108, 218, 37, 'PPL', 'P'),
(168654, 'Wertz', 40.4555587768555, 0.706082701390218, -78.2474975585938, -1.36567646384369, 218, 45, 'PPL', 'P'),
(84275, 'Wertz Crossroads', 33.6399993896484, 0.587128749718248, -80.7888870239258, -1.41003207758923, 218, 48, 'PPL', 'P'),
(168675, 'Wertzville', 40.2836112976074, 0.703081651736835, -77.0441665649414, -1.34467437601316, 218, 45, 'PPL', 'P'),
(77645, 'Wes', 36.2119407653809, 0.632017594893051, -96.2688903808594, -1.68020910438749, 218, 42, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(98984, 'Wes-mer Colonia', 26.201000213623, 0.45729372104346, -97.9560012817383, -1.70965474445412, 218, 51, 'PPL', 'P'),
(69972, 'Wescliff', 35.834171295166, 0.625424273824288, -80.2869415283203, -1.40127147602536, 218, 33, 'PPL', 'P'),
(38800, 'Wesco', 37.2924995422363, 0.650876903310502, -87.5116729736328, -1.52736682731843, 218, 21, 'PPL', 'P'),
(58197, 'Wesco', 37.8594398498535, 0.660771878340692, -91.4319381713867, -1.59578836257058, 218, 29, 'PPL', 'P'),
(192408, 'Wesco', 35.4333305358887, 0.618428282798704, -100.76277923584, -1.75864226112558, 218, 51, 'PPL', 'P'),
(14821, 'Wescoats Corner', 38.7516708374023, 0.676344246761739, -75.1647186279297, -1.31187182139249, 218, 10, 'PPL', 'P'),
(71533, 'Wescoatville', 39.639720916748, 0.691843644568918, -74.7202835083008, -1.30411496524347, 218, 37, 'PPL', 'P'),
(18536, 'Wesconnett', 30.2466697692871, 0.527903975237494, -81.7305603027344, -1.42646737678249, 218, 12, 'PPL', 'P'),
(168655, 'Wescosville', 40.5666694641113, 0.708021948716986, -75.5533294677734, -1.3186543600567, 218, 45, 'PPL', 'P'),
(138748, 'Wescott', 44.8197212219238, 0.782251705148547, -93.1055603027344, -1.62499857919684, 218, 28, 'PPL', 'P'),
(143346, 'Wescott', 41.538890838623, 0.724990412760481, -99.2697219848633, -1.73258349617526, 218, 35, 'PPL', 'P'),
(169661, 'Wescott Beach', 41.8863906860352, 0.731055429248, -71.6902770996094, -1.25123137705527, 218, 47, 'PPL', 'P'),
(98985, 'Weser', 28.8649997711182, 0.503789284593422, -97.3672180175781, -1.69937853791388, 218, 51, 'PPL', 'P'),
(187953, 'Weskan', 38.8666687011719, 0.678351338117277, -101.963890075684, -1.77960559996225, 218, 20, 'PPL', 'P'),
(98986, 'Weslaco', 26.1591701507568, 0.456563648720128, -97.9905624389648, -1.71025795044102, 218, 51, 'PPL', 'P'),
(12737, 'Wesley', 36.0272216796875, 0.628793638656429, -93.9199981689453, -1.63921320151514, 218, 4, 'PPL', 'P'),
(25893, 'Wesley', 32.6588897705078, 0.570005156541257, -84.3302764892578, -1.47184098385471, 218, 13, 'PPL', 'P'),
(52596, 'Wesley', 38.2099990844727, 0.666890291208067, -75.3450012207031, -1.31501834622042, 218, 25, 'PPL', 'P'),
(74758, 'Wesley', 39.8008308410645, 0.694655543205879, -82.2169418334961, -1.43495633591517, 218, 41, 'PPL', 'P'),
(77646, 'Wesley', 34.5877799987793, 0.603670641934139, -95.8974990844727, -1.6737271034523, 218, 42, 'PPL', 'P'),
(98987, 'Wesley', 30.0699996948242, 0.524820500748373, -96.5016708374023, -1.68427188978846, 218, 51, 'PPL', 'P'),
(118380, 'Wesley', 43.0883293151855, 0.752033215733581, -93.9899978637695, -1.64043492666522, 218, 16, 'PPL', 'P'),
(121909, 'Wesley', 40.6530609130859, 0.709529763947162, -89.6041717529297, -1.56388782061112, 218, 18, 'PPL', 'P'),
(123979, 'Wesley', 40.0677795410156, 0.699314676953945, -87.0066680908203, -1.5185528293747, 218, 19, 'PPL', 'P'),
(129221, 'Wesley', 44.952220916748, 0.784564261081117, -67.6613922119141, -1.18091407058115, 218, 26, 'PPL', 'P'),
(153555, 'Wesley', 42.3730583190918, 0.739549381807726, -78.9577789306641, -1.3780732124019, 218, 40, 'PPL', 'P'),
(168656, 'Wesley', 41.2280616760254, 0.719565420461935, -79.9613876342773, -1.39558948868162, 218, 45, 'PPL', 'P'),
(62255, 'Wesley (historical)', 33.7744407653809, 0.58947519437569, -88.458610534668, -1.5438940055693, 218, 30, 'PPL', 'P'),
(111964, 'Wesley (historical)', 39.1783294677734, 0.683790844643764, -81.7333297729492, -1.42651571315627, 218, 58, 'PPL', 'P'),
(34381, 'Wesley Center', 39.9588890075684, 0.697414178621037, -98.3247222900391, -1.71609014007024, 218, 20, 'PPL', 'P'),
(12738, 'Wesley Chapel', 35.2688903808594, 0.615558260670953, -92.7324981689453, -1.61848741664771, 218, 4, 'PPL', 'P'),
(18537, 'Wesley Chapel', 28.2394409179688, 0.492871222940965, -82.3280563354492, -1.43689564982097, 218, 12, 'PPL', 'P'),
(52598, 'Wesley Chapel', 39.5547218322754, 0.69036013068369, -76.8797225952148, -1.34180428730638, 218, 25, 'PPL', 'P'),
(69973, 'Wesley Chapel', 35.0069389343262, 0.610986345448587, -80.6747207641602, -1.40803950046163, 218, 33, 'PPL', 'P'),
(74759, 'Wesley Chapel', 39.7452812194824, 0.693686019411035, -82.7324981689453, -1.44395449144828, 218, 41, 'PPL', 'P'),
(168657, 'Wesley Chapel', 40.3886108398438, 0.704914239461946, -78.8625030517578, -1.37641033461725, 218, 45, 'PPL', 'P'),
(75, 'Wesley Grove', 30.6855506896973, 0.535563892322834, -95.7888107299805, -1.67183013380783, 218, 51, 'PPL', 'P'),
(52599, 'Wesley Grove', 39.186939239502, 0.683941113508272, -76.7597198486328, -1.33970984426709, 218, 25, 'PPL', 'P'),
(13245, 'Wesley Heights', 38.9311103820801, 0.679476057624645, -77.0883331298828, -1.34544522799068, 218, 9, 'PPL', 'P'),
(153556, 'Wesley Hills', 41.1591682434082, 0.718363003229764, -74.0702819824219, -1.29277029847389, 218, 40, 'PPL', 'P'),
(209133, 'Wesley Junction', 46.4036102294922, 0.80989578331676, -120.337501525879, -2.10028561525029, 218, 56, 'PPL', 'P'),
(123980, 'Wesley Manor', 40.2963905334473, 0.703304691478129, -86.5119400024414, -1.50991819533039, 218, 19, 'PPL', 'P'),
(18538, 'Wesley Manor Retirement Village', 30.1269397735596, 0.525814292598649, -81.623893737793, -1.42460569402247, 218, 12, 'PPL', 'P'),
(25895, 'Wesley Oaks', 31.1652793884277, 0.543936737631989, -81.3775024414063, -1.42030535465226, 218, 13, 'PPL', 'P'),
(25896, 'Wesley Park', 33.5149993896484, 0.584947088153255, -84.4049987792969, -1.47314513384053, 218, 13, 'PPL', 'P'),
(25897, 'Wesley Station', 33.8452796936035, 0.590711566911759, -84.6519393920898, -1.47745506059065, 218, 13, 'PPL', 'P'),
(639, 'Wesley Woods', 39.4694404602051, 0.688871689950445, -76.4124984741211, -1.33364968804856, 218, 25, 'PPL', 'P'),
(25899, 'Wesleyan', 32.8777809143066, 0.573825527704003, -83.7174987792969, -1.46114599523306, 218, 13, 'PPL', 'P'),
(25900, 'Wesleyan Estates', 32.8938903808594, 0.574106690936088, -83.7227783203125, -1.46123814060678, 218, 13, 'PPL', 'P'),
(25901, 'Wesleyan Hills', 32.917781829834, 0.574523675383767, -83.7225036621094, -1.46123334691682, 218, 13, 'PPL', 'P'),
(38801, 'Wesleyan Park', 37.9916687011719, 0.663079707162327, -84.1933288574219, -1.46945079677637, 218, 21, 'PPL', 'P'),
(25902, 'Wesleyan Woods', 32.8827781677246, 0.573912746229703, -83.7200012207031, -1.46118967107494, 218, 13, 'PPL', 'P'),
(91718, 'Wesleyanna', 35.3627815246582, 0.617196970268706, -84.559440612793, -1.47584065233785, 218, 50, 'PPL', 'P'),
(38802, 'Wesleyville', 38.394718170166, 0.67011424744469, -83.1716690063477, -1.45161946853969, 218, 21, 'PPL', 'P'),
(168658, 'Wesleyville', 42.1402816772461, 0.735486662985783, -80.0152816772461, -1.39653011717864, 218, 45, 'PPL', 'P'),
(200276, 'Weso', 41.0113906860352, 0.71578379829305, -117.690559387207, -2.05408775982068, 218, 39, 'PPL', 'P'),
(6701, 'Wesoda', 34.1111106872559, 0.595351193004841, -86.7994384765625, -1.51493599029827, 218, 2, 'PPL', 'P'),
(69977, 'Wesser', 35.3330612182617, 0.616678253067386, -83.5913925170898, -1.45894502575017, 218, 33, 'PPL', 'P'),
(6700, 'Wessington', 33.002498626709, 0.576002262420979, -86.7777786254883, -1.51455795458153, 218, 2, 'PPL', 'P'),
(171582, 'Wessington', 44.4541702270508, 0.775871636704071, -98.6966705322266, -1.72258186154342, 218, 49, 'PPL', 'P'),
(171583, 'Wessington Springs', 44.0791702270508, 0.769326652009093, -98.5691680908203, -1.72035652413655, 218, 49, 'PPL', 'P'),
(12739, 'Wesson', 33.1152801513672, 0.577970671361684, -92.7624969482422, -1.61901099411802, 218, 4, 'PPL', 'P'),
(62256, 'Wesson', 31.7011108398438, 0.553288760694938, -90.3974990844727, -1.57773399459261, 218, 30, 'PPL', 'P'),
(107389, 'Wesson', 36.7599983215332, 0.641583003738344, -77.8652801513672, -1.35900551162915, 218, 53, 'PPL', 'P'),
(126488, 'Wessonville', 42.2861099243164, 0.738031846039572, -71.6272201538086, -1.2501308257348, 218, 23, 'PPL', 'P'),
(91719, 'Wessyngton (historical)', 36.5013885498047, 0.63706941174385, -87.0041732788086, -1.51850928669088, 218, 50, 'PPL', 'P'),
(107390, 'Wessynton', 38.7188911437988, 0.675772133180563, -77.084716796875, -1.34538211107285, 218, 53, 'PPL', 'P'),
(6702, 'West', 33.2569389343262, 0.580443083538686, -85.4166717529297, -1.49080215818386, 218, 2, 'PPL', 'P'),
(62257, 'West', 33.1969413757324, 0.579395928598067, -89.7772216796875, -1.56690811160338, 218, 30, 'PPL', 'P'),
(91721, 'West', 35.8405609130859, 0.625535793694935, -88.7541732788086, -1.54905254860078, 218, 50, 'PPL', 'P'),
(98988, 'West', 31.8022193908691, 0.555053437812252, -97.0913925170898, -1.6945644747694, 218, 51, 'PPL', 'P'),
(111965, 'West', 39.6783294677734, 0.692517490903736, -80.6699981689453, -1.40795707562589, 218, 58, 'PPL', 'P'),
(12741, 'West (historical)', 35.1247215270996, 0.613042039494019, -92.9438934326172, -1.6221769600219, 218, 4, 'PPL', 'P'),
(126489, 'West Abington', 42.0916709899902, 0.734638246441511, -70.966667175293, -1.23860200137585, 218, 23, 'PPL', 'P'),
(171588, 'West Acres Development', 43.5461082458496, 0.760022965319928, -96.8661117553711, -1.69063258373601, 218, 49, 'PPL', 'P'),
(197811, 'West Acres Trailer Park', 46.7563896179199, 0.816052945177996, -114.10417175293, -1.99149348734973, 218, 31, 'PPL', 'P'),
(126490, 'West Acton', 42.4749984741211, 0.741328573152981, -71.4749984741211, -1.24747405623134, 218, 23, 'PPL', 'P'),
(172714, 'West Addison', 44.0816688537598, 0.769370261271943, -73.3947219848633, -1.28097955222173, 218, 55, 'PPL', 'P'),
(98989, 'West Addition Colonia', 26.2299995422363, 0.457799854808629, -97.5820007324219, -1.70312720346428, 218, 51, 'PPL', 'P'),
(126491, 'West Agawam', 42.0791702270508, 0.734420066969206, -72.6500015258789, -1.26798172820549, 218, 23, 'PPL', 'P'),
(158256, 'West Akron', 41.0744400024414, 0.71688421645547, -81.5477828979492, -1.42327730927074, 218, 41, 'PPL', 'P'),
(153557, 'West Alabama', 43.1263885498047, 0.752697474688474, -78.4580612182617, -1.36935149298994, 218, 40, 'PPL', 'P'),
(138749, 'West Albany', 44.3013916015625, 0.77320514666263, -92.2852783203125, -1.6106819578088, 218, 28, 'PPL', 'P'),
(153558, 'West Albany', 42.6830596923828, 0.744959926457358, -73.7788925170898, -1.28768459289822, 218, 40, 'PPL', 'P'),
(138751, 'West Albion', 45.1958312988281, 0.788816064340456, -94.1347198486328, -1.6429608018011, 218, 28, 'PPL', 'P'),
(153559, 'West Alden', 42.8916702270508, 0.74860086714166, -78.5236129760742, -1.37049558699424, 218, 40, 'PPL', 'P'),
(168661, 'West Alexander', 40.1049995422363, 0.699964288522843, -80.508056640625, -1.40513066276099, 218, 45, 'PPL', 'P'),
(74760, 'West Alexandria', 39.7444381713867, 0.693671305446013, -84.5322189331055, -1.47536554439938, 218, 41, 'PPL', 'P'),
(98990, 'West Alfred Estates Colonia', 27.9090003967285, 0.487103947863316, -98.0139999389648, -1.71066701198446, 218, 51, 'PPL', 'P'),
(153560, 'West Allen', 42.3802795410156, 0.739675415906314, -78.0388870239258, -1.36203552315938, 218, 40, 'PPL', 'P'),
(146591, 'West Allenhurst', 40.2383308410645, 0.702291358683354, -74.0122222900391, -1.29175696567912, 218, 37, 'PPL', 'P'),
(176959, 'West Allis', 43.0166702270508, 0.750782528706653, -88.0069427490234, -1.53601091558461, 218, 57, 'PPL', 'P'),
(153561, 'West Almond', 42.2994384765625, 0.73826447316079, -77.8833312988281, -1.3593205635861, 218, 40, 'PPL', 'P'),
(176955, 'West Almond', 44.2861099243164, 0.772938431079458, -89.4608306884766, -1.5613860470831, 218, 57, 'PPL', 'P'),
(186059, 'West Alpaugh (historical)', 35.8877792358398, 0.62635990889426, -119.508888244629, -2.08582358526672, 218, 6, 'PPL', 'P'),
(98991, 'West Alto Bonito Colonia', 26.3139991760254, 0.459265924988718, -98.6630020141602, -1.72199423504889, 218, 51, 'PPL', 'P'),
(58198, 'West Alton', 38.8650016784668, 0.678322243082368, -90.2225036621094, -1.57467974829645, 218, 29, 'PPL', 'P'),
(144627, 'West Alton', 43.5511093139648, 0.760110250424655, -71.3116683959961, -1.24462340860052, 218, 36, 'PPL', 'P'),
(118382, 'West Amana', 41.8080596923828, 0.729688295502408, -91.9636077880859, -1.6050677479148, 218, 16, 'PPL', 'P'),
(153563, 'West Amboy', 43.3844413757324, 0.757201346144989, -75.9858322143555, -1.32620295700848, 218, 40, 'PPL', 'P'),
(168663, 'West Amity', 40.0394401550293, 0.69882006136049, -80.2222213745117, -1.400141896249, 218, 45, 'PPL', 'P'),
(186060, 'West Anaheim', 33.832218170166, 0.590483600322448, -117.941673278809, -2.05847052402663, 218, 6, 'PPL', 'P'),
(186061, 'West Anaheim Junction', 33.7961082458496, 0.589853363250481, -117.894439697266, -2.05764614251119, 218, 6, 'PPL', 'P'),
(18570, 'West and East Lealman', 27.8208293914795, 0.485565073516928, -82.679443359375, -1.44302851033726, 218, 12, 'PPL', 'P'),
(84277, 'West Anderson', 34.5019416809082, 0.602172480662915, -82.6883316040039, -1.44318363947075, 218, 48, 'PPL', 'P'),
(126492, 'West Andover', 42.6611099243164, 0.74457683073455, -71.1588897705078, -1.24195691855907, 218, 23, 'PPL', 'P'),
(144628, 'West Andover', 43.4441719055176, 0.758243840553701, -71.8772201538086, -1.25449414886478, 218, 36, 'PPL', 'P'),
(158257, 'West Andover', 41.6066703796387, 0.726173388916694, -80.6122207641602, -1.40694866967913, 218, 41, 'PPL', 'P'),
(84278, 'West Andrews', 33.4527816772461, 0.583861184218775, -79.5805587768555, -1.388942771233, 218, 48, 'PPL', 'P'),
(52601, 'West Annapolis', 38.9908294677734, 0.680518352296275, -76.5, -1.33517687777566, 218, 25, 'PPL', 'P'),
(12742, 'West Aplin', 34.9722213745117, 0.610380409721566, -92.9841690063477, -1.62287990139163, 218, 4, 'PPL', 'P'),
(129223, 'West Appleton', 44.3511085510254, 0.774072871124805, -69.2611083984375, -1.20883438513343, 218, 26, 'PPL', 'P'),
(186062, 'West Arcadia', 34.1261100769043, 0.595612981739995, -118.053886413574, -2.06042901269227, 218, 6, 'PPL', 'P'),
(52602, 'West Arlington', 39.336669921875, 0.686554406906939, -76.6952819824219, -1.33858519133875, 218, 25, 'PPL', 'P'),
(107391, 'West Arlington', 38.8938903808594, 0.678826446055747, -77.1686096191406, -1.34684631704017, 218, 53, 'PPL', 'P'),
(172715, 'West Arlington', 43.103328704834, 0.752295004468736, -73.2130584716797, -1.27780892578594, 218, 55, 'PPL', 'P'),
(74761, 'West Arnheim', 38.9338912963867, 0.679524593735512, -83.8736114501953, -1.46387067534432, 218, 41, 'PPL', 'P'),
(69978, 'West Asheville', 35.5777816772461, 0.620949430823655, -82.5838928222656, -1.44136083886265, 218, 33, 'PPL', 'P'),
(114238, 'West Ashford', 41.8566703796387, 0.73053671204668, -72.1788864135742, -1.25975921833987, 218, 8, 'PPL', 'P'),
(71535, 'West Atco', 39.7458305358887, 0.69369560679096, -74.8913879394531, -1.30710130093183, 218, 37, 'PPL', 'P'),
(129224, 'West Athens', 44.9533309936523, 0.784583635578048, -69.7113876342773, -1.2166932403522, 218, 26, 'PPL', 'P'),
(153564, 'West Athens', 42.2861099243164, 0.738031846039572, -73.8424987792969, -1.28879473159862, 218, 40, 'PPL', 'P'),
(168664, 'West Athens', 41.9486083984375, 0.73214133318248, -76.5224990844727, -1.33556956087839, 218, 45, 'PPL', 'P'),
(186063, 'West Athens', 33.9233283996582, 0.592073773809334, -118.30249786377, -2.06476810105634, 218, 6, 'PPL', 'P'),
(31482, 'West Atherton', 39.6088905334473, 0.691305552870668, -87.3708267211914, -1.52490859647423, 218, 19, 'PPL', 'P'),
(71536, 'West Atlantic City', 39.3777809143066, 0.687271929083634, -74.4897232055664, -1.30009092883636, 218, 37, 'PPL', 'P'),
(126493, 'West Auburn', 42.1763916015625, 0.73611690005775, -71.8730621337891, -1.25442157772508, 218, 23, 'PPL', 'P'),
(129225, 'West Auburn', 44.1566696166992, 0.770679271526744, -70.2813873291016, -1.22664161176225, 218, 26, 'PPL', 'P'),
(168665, 'West Auburn', 41.7202796936035, 0.728156245506312, -76.1066665649414, -1.32831191427571, 218, 45, 'PPL', 'P'),
(107392, 'West Augusta', 38.2700004577637, 0.667937512727713, -79.3080596923828, -1.38418676500028, 218, 53, 'PPL', 'P'),
(58199, 'West Aurora', 38.3144416809082, 0.668713158395199, -92.5955581665039, -1.61609736272742, 218, 29, 'PPL', 'P'),
(158258, 'West Austintown', 41.0997200012207, 0.717325435669069, -80.793327331543, -1.41010957557695, 218, 41, 'PPL', 'P'),
(114239, 'West Avon', 41.7897186279297, 0.72936818353938, -72.8638916015625, -1.27171481426351, 218, 8, 'PPL', 'P'),
(153565, 'West Babylon', 40.7180595397949, 0.710664203992508, -73.3547210693359, -1.28028140454197, 218, 40, 'PPL', 'P'),
(31483, 'West Baden Springs', 38.5652809143066, 0.67309112891118, -86.6111068725586, -1.51164898372284, 218, 19, 'PPL', 'P'),
(25903, 'West Bainbridge', 30.9249992370605, 0.539743057863441, -84.5833282470703, -1.4762575702065, 218, 13, 'PPL', 'P'),
(153566, 'West Bainbridge', 42.3138885498047, 0.73851667451602, -75.5438919067383, -1.31848964354328, 218, 40, 'PPL', 'P'),
(186064, 'West Baker (historical)', 35.0436096191406, 0.61162636963756, -117.692779541016, -2.05412650881454, 218, 6, 'PPL', 'P'),
(129226, 'West Baldwin', 43.8330612182617, 0.765031239486904, -70.7783279418945, -1.23531486164236, 218, 26, 'PPL', 'P'),
(52603, 'West Baltimore', 39.2558288574219, 0.685143464161415, -76.6591720581055, -1.33795495426678, 218, 25, 'PPL', 'P'),
(176956, 'West Bancroft', 44.3047218322754, 0.77326327015342, -89.5308303833008, -1.56260777223318, 218, 57, 'PPL', 'P'),
(129227, 'West Bangor', 44.7949981689453, 0.781820206472927, -68.8338928222656, -1.20137806671343, 218, 26, 'PPL', 'P'),
(133648, 'West Bangor', 42.3077812194824, 0.73841008149339, -86.1866683959961, -1.50424113483467, 218, 27, 'PPL', 'P'),
(153567, 'West Bangor', 44.8041687011719, 0.781980262454441, -74.4341735839844, -1.29912140504152, 218, 40, 'PPL', 'P'),
(168666, 'West Bangor', 40.8791694641113, 0.713476102629469, -75.2391662597656, -1.31317117768834, 218, 45, 'PPL', 'P'),
(176957, 'West Baraboo', 43.4744415283203, 0.758772145134945, -89.7702789306641, -1.56678693777378, 218, 57, 'PPL', 'P'),
(172716, 'West Barnet', 44.310001373291, 0.773355415527137, -72.1377792358398, -1.2590417627422, 218, 55, 'PPL', 'P'),
(113083, 'West Barnstable', 41.7055587768555, 0.727899317040147, -70.375, -1.22827546109101, 218, 23, 'PPL', 'P'),
(153568, 'West Barre', 43.1527786254883, 0.753158068399004, -78.2538909912109, -1.36578805029336, 218, 40, 'PPL', 'P'),
(144629, 'West Barrington', 43.204719543457, 0.754064608434067, -71.1050033569336, -1.24101642322011, 218, 36, 'PPL', 'P'),
(169662, 'West Barrington', 41.7436103820801, 0.728563442836985, -71.3419418334961, -1.24515177976079, 218, 47, 'PPL', 'P'),
(158259, 'West Bass Lake', 41.6055603027344, 0.726154014419764, -81.1780624389648, -1.41682446994948, 218, 41, 'PPL', 'P'),
(107395, 'West Bassett', 36.7644386291504, 0.641660501726065, -80.0233306884766, -1.39667059892614, 218, 53, 'PPL', 'P'),
(153569, 'West Batavia', 42.9797210693359, 0.75013764424869, -78.2997207641602, -1.36658793072677, 218, 40, 'PPL', 'P'),
(144630, 'West Bath', 44.1741714477539, 0.770984736103776, -71.9877777099609, -1.2564237422326, 218, 36, 'PPL', 'P'),
(44068, 'West Baton Rouge', 30.4500007629395, 0.531452770548079, -91.2050018310547, -1.59182757623936, 218, 22, 'PPL', 'P'),
(18539, 'West Bay', 30.2916698455811, 0.528689374732472, -85.8597183227539, -1.49853477956696, 218, 12, 'PPL', 'P'),
(14822, 'West Bay Park Mobile Home Park', 38.6636085510254, 0.674807269917627, -75.1436080932617, -1.31150337305568, 218, 10, 'PPL', 'P'),
(153570, 'West Bay Shore', 40.708610534668, 0.710499287742005, -73.2816696166992, -1.27900641617009, 218, 40, 'PPL', 'P'),
(12743, 'West Bayou (historical)', 34.2783317565918, 0.598269751243458, -91.6911087036133, -1.60031174168208, 218, 4, 'PPL', 'P'),
(14823, 'West Beach', 38.5741691589355, 0.673246258044677, -75.1708297729492, -1.31197848099415, 218, 10, 'PPL', 'P'),
(52604, 'West Beach', 38.6949996948242, 0.675355148732884, -76.5338897705078, -1.33576836585377, 218, 25, 'PPL', 'P'),
(209134, 'West Beach', 48.6875, 0.849757179564739, -122.956390380859, -2.14599384851348, 218, 56, 'PPL', 'P'),
(126494, 'West Becket', 42.264720916748, 0.73765853743377, -73.1361083984375, -1.27646589364821, 218, 23, 'PPL', 'P'),
(126495, 'West Bedford', 42.4780616760254, 0.741382036111864, -71.3161087036133, -1.24470090658824, 218, 23, 'PPL', 'P'),
(158260, 'West Bedford', 40.2591705322266, 0.702655079909231, -82.0766677856445, -1.43250809192506, 218, 41, 'PPL', 'P'),
(168668, 'West Beech', 41.0588912963867, 0.716612840340391, -77.5783309936523, -1.3539973040412, 218, 45, 'PPL', 'P'),
(153571, 'West Beekmantown', 44.771110534668, 0.781403288604275, -73.5550003051758, -1.28377693663075, 218, 40, 'PPL', 'P'),
(146593, 'West Belmar', 40.1691703796387, 0.701084280919275, -74.0358276367188, -1.29216895669975, 218, 37, 'PPL', 'P'),
(6703, 'West Bend', 31.8241691589355, 0.55543653353506, -88.1322174072266, -1.53819737083956, 218, 2, 'PPL', 'P'),
(58200, 'West Bend', 37.4575004577637, 0.653756712555259, -93.4608306884766, -1.63119921716287, 218, 29, 'PPL', 'P'),
(69979, 'West Bend', 36.0950012207031, 0.629976614812642, -80.4888916015625, -1.40479616972808, 218, 33, 'PPL', 'P'),
(79361, 'West Bend', 39.9730606079102, 0.697661519707278, -79.9733276367188, -1.39579788103692, 218, 45, 'PPL', 'P'),
(118385, 'West Bend', 42.9569396972656, 0.749740034297941, -94.4408264160156, -1.64830336926391, 218, 16, 'PPL', 'P'),
(176960, 'West Bend', 43.4252815246582, 0.757914141210749, -88.1833267211914, -1.53908939664669, 218, 57, 'PPL', 'P'),
(146594, 'West Bergen', 40.7125015258789, 0.710567198349802, -74.083610534668, -1.29300292559511, 218, 37, 'PPL', 'P'),
(153572, 'West Bergen', 43.0661087036133, 0.751645392899839, -78.004997253418, -1.36144403508128, 218, 40, 'PPL', 'P'),
(172717, 'West Berkshire', 44.9891700744629, 0.78520914553908, -72.8141708374023, -1.27084702322231, 218, 55, 'PPL', 'P'),
(71537, 'West Berlin', 39.8086090087891, 0.694791297842445, -74.9416732788086, -1.30797894566906, 218, 37, 'PPL', 'P'),
(126496, 'West Berlin', 42.3880615234375, 0.739811237121908, -71.6611099243164, -1.25072231381291, 218, 23, 'PPL', 'P'),
(158261, 'West Berlin', 40.2555618286133, 0.702592096149451, -83.0127792358398, -1.44884631889659, 218, 41, 'PPL', 'P'),
(172718, 'West Berlin', 44.2000007629395, 0.771435542697299, -72.6333312988281, -1.2676907778564, 218, 55, 'PPL', 'P'),
(153573, 'West Berne', 42.6288909912109, 0.74401450427038, -74.184440612793, -1.29476274244344, 218, 40, 'PPL', 'P'),
(153574, 'West Bethany', 42.913890838623, 0.748988689975403, -78.192497253418, -1.36471652742877, 218, 40, 'PPL', 'P'),
(168669, 'West Bethany', 40.1624984741211, 0.700967834200612, -79.5994415283203, -1.3892723374179, 218, 45, 'PPL', 'P'),
(107393, 'West Bethel', 37.464168548584, 0.653873092694896, -79.102783203125, -1.3806040143858, 218, 53, 'PPL', 'P'),
(129229, 'West Bethel', 44.4019393920898, 0.774960036662937, -70.8616714477539, -1.23676948022976, 218, 26, 'PPL', 'P'),
(172719, 'West Bethel', 43.8499984741211, 0.765326850367903, -72.6944427490234, -1.26875737387298, 218, 55, 'PPL', 'P'),
(168670, 'West Bingham', 41.9444389343262, 0.732068562305693, -77.8166732788086, -1.3581571616639, 218, 45, 'PPL', 'P'),
(192918, 'West Bishop', 37.3611106872559, 0.652074393694656, -118.454170227051, -2.06741528317988, 218, 6, 'PPL', 'P'),
(209135, 'West Blakely', 47.598331451416, 0.830747602282781, -122.538330078125, -2.13869731975888, 218, 56, 'PPL', 'P'),
(6704, 'West Blocton', 33.1180610656738, 0.57801920747255, -87.125, -1.52061811080006, 218, 2, 'PPL', 'P'),
(153575, 'West Bloomfield', 42.9058303833008, 0.748848008490819, -77.539436340332, -1.35331846427934, 218, 40, 'PPL', 'P'),
(176963, 'West Bloomfield', 44.2208290100098, 0.771799064186095, -88.9716720581055, -1.55284861841858, 218, 57, 'PPL', 'P'),
(98992, 'West Bluff', 30.1761093139648, 0.526672462970414, -93.706672668457, -1.63548996915316, 218, 51, 'PPL', 'P'),
(168671, 'West Bolivar', 40.3938903808594, 0.705006384835662, -79.1566696166992, -1.38154450972476, 218, 45, 'PPL', 'P'),
(172720, 'West Bolton', 44.4455604553223, 0.775721367839564, -72.8983306884766, -1.27231588972154, 218, 55, 'PPL', 'P'),
(199068, 'West Bonetraill', 48.4019393920898, 0.84477320674271, -103.948333740234, -1.814240675729, 218, 34, 'PPL', 'P'),
(129230, 'West Boothbay Harbor', 43.8488883972168, 0.765307475870972, -69.6438903808594, -1.215515191044, 218, 26, 'PPL', 'P'),
(107394, 'West Bottom', 37.7169418334961, 0.658284818777694, -78.2611083984375, -1.36591401781292, 218, 53, 'PPL', 'P'),
(206380, 'West Bountiful', 40.8938903808594, 0.713733031095634, -111.901107788086, -1.95304276753117, 218, 52, 'PPL', 'P'),
(129231, 'West Bowdoin', 44.0472183227539, 0.76876898607683, -70.0252838134766, -1.22217176218866, 218, 26, 'PPL', 'P'),
(168672, 'West Bowmans', 40.7966690063477, 0.71203619800709, -75.6741714477539, -1.32076345048199, 218, 45, 'PPL', 'P'),
(126497, 'West Boxford', 42.7069396972656, 0.745376711167956, -71.0644378662109, -1.24030842184431, 218, 23, 'PPL', 'P'),
(126498, 'West Boylston', 42.3666687011719, 0.739437861937079, -71.7861099243164, -1.2529039753779, 218, 23, 'PPL', 'P'),
(18540, 'West Bradenton', 27.5022201538086, 0.480004293292301, -82.6141662597656, -1.44188921002292, 218, 12, 'PPL', 'P'),
(168673, 'West Bradford', 41.9636116027832, 0.732403188496662, -78.668327331543, -1.37302132897207, 218, 45, 'PPL', 'P'),
(172721, 'West Braintree', 43.9722213745117, 0.767460042401056, -72.7472229003906, -1.26967856129404, 218, 55, 'PPL', 'P'),
(118384, 'West Branch', 41.6713905334473, 0.727302968693051, -91.3463897705078, -1.59429526130543, 218, 16, 'PPL', 'P'),
(133650, 'West Branch', 44.2763900756836, 0.77276878771802, -84.2386093139648, -1.47024108982985, 218, 27, 'PPL', 'P'),
(153577, 'West Branch', 43.371940612793, 0.756983166672684, -75.4824981689453, -1.31741812067869, 218, 40, 'PPL', 'P'),
(168674, 'West Branch', 40.6613883972168, 0.709675105963653, -78.7861099243164, -1.3750770230175, 218, 45, 'PPL', 'P'),
(172722, 'West Branch', 44.4741706848145, 0.776220710543953, -72.7163925170898, -1.26914046959578, 218, 55, 'PPL', 'P'),
(118386, 'West Branch Mobile Home Village', 41.6713905334473, 0.727302968693051, -91.3463897705078, -1.59429526130543, 218, 16, 'PPL', 'P'),
(172723, 'West Brattleboro', 42.8558311462402, 0.747975357180628, -72.6036071777344, -1.26717199407605, 218, 55, 'PPL', 'P'),
(25904, 'West Bremen', 33.7555618286133, 0.58914569476982, -85.1477813720703, -1.48610913571092, 218, 13, 'PPL', 'P'),
(126500, 'West Brewster', 41.7444381713867, 0.728577890485899, -70.1102828979492, -1.22365527607389, 218, 23, 'PPL', 'P'),
(107396, 'West Briar', 37.4877815246582, 0.654285216873586, -79.1327819824219, -1.38112759185611, 218, 53, 'PPL', 'P'),
(126503, 'West Bridgewater', 42.0188903808594, 0.73336798518057, -71.0083312988281, -1.23932917751149, 218, 23, 'PPL', 'P'),
(172724, 'West Bridgewater', 43.5999984741211, 0.760963527237917, -72.7491683959961, -1.26971251659793, 218, 55, 'PPL', 'P'),
(129232, 'West Bridgton', 44.0641708374023, 0.769064863273938, -70.8308334350586, -1.23623125537346, 218, 26, 'PPL', 'P'),
(172725, 'West Bridport', 43.9566688537598, 0.76718859970695, -73.3963928222656, -1.28100871383567, 218, 55, 'PPL', 'P'),
(153578, 'West Brighton', 43.1213912963867, 0.752610256162774, -77.620002746582, -1.3547246133349, 218, 40, 'PPL', 'P'),
(126502, 'West Brimfield', 42.1755599975586, 0.736102385829809, -72.2611083984375, -1.26119426269326, 218, 23, 'PPL', 'P'),
(129233, 'West Bristol', 43.9288902282715, 0.766703771230501, -69.5577774047852, -1.21401223608282, 218, 26, 'PPL', 'P'),
(168677, 'West Bristol', 40.101390838623, 0.699901304763062, -74.8855590820313, -1.30699956817819, 218, 45, 'PPL', 'P'),
(171590, 'West Britton', 45.7922210693359, 0.799225029461031, -97.8375015258789, -1.70758653355156, 218, 49, 'PPL', 'P'),
(25905, 'West Brook', 34.4930610656738, 0.602017484687472, -84.454719543457, -1.47401292488173, 218, 13, 'PPL', 'P'),
(38803, 'West Brook', 36.8047218322754, 0.642363576253846, -87.5113906860352, -1.52736190047041, 218, 21, 'PPL', 'P'),
(69980, 'West Brook', 35.4963912963867, 0.619528900698207, -80.6436080932617, -1.40749648191536, 218, 33, 'PPL', 'P'),
(31484, 'West Brook Downs', 39.2144393920898, 0.684421081715731, -86.6011123657227, -1.51147454667144, 218, 19, 'PPL', 'P'),
(126511, 'West Brookfield', 42.235279083252, 0.737144680501439, -72.1416702270508, -1.25910967335, 218, 23, 'PPL', 'P'),
(153583, 'West Brookfield', 42.8077812194824, 0.747136727753362, -75.4049987792969, -1.31606550116104, 218, 40, 'PPL', 'P'),
(158262, 'West Brookfield', 40.7958297729492, 0.712021550621095, -81.5711135864258, -1.42368450660141, 218, 41, 'PPL', 'P'),
(172748, 'West Brookfield', 44.0208282470703, 0.768308392366301, -72.6725006103516, -1.26837441130822, 218, 55, 'PPL', 'P'),
(129234, 'West Brooklin', 44.2919387817383, 0.773040163833099, -68.6163864135742, -1.19758186373757, 218, 26, 'PPL', 'P'),
(144646, 'West Brookline', 42.7361106872559, 0.745885840989351, -71.6797180175781, -1.25104708630784, 218, 36, 'PPL', 'P'),
(121912, 'West Brooklyn', 41.6927795410156, 0.727676277298853, -89.1469421386719, -1.5559076584047, 218, 18, 'PPL', 'P'),
(129238, 'West Brooksville', 44.3983306884766, 0.774897052903157, -68.7583312988281, -1.20005926934162, 218, 26, 'PPL', 'P'),
(25906, 'West Brow', 34.922779083252, 0.609517478949353, -85.415283203125, -1.49077792341794, 218, 13, 'PPL', 'P'),
(129235, 'West Brownfield', 43.9174995422363, 0.766504966255126, -70.9791717529297, -1.23882024742718, 218, 26, 'PPL', 'P'),
(168678, 'West Brownsville', 40.024169921875, 0.6985535455144, -79.8908309936523, -1.39435804299357, 218, 45, 'PPL', 'P'),
(38806, 'West Buechel', 38.1969413757324, 0.666662391197783, -85.663330078125, -1.49510715808597, 218, 21, 'PPL', 'P'),
(158263, 'West Buffalo (historical)', 41.5158309936523, 0.724587942540742, -84.6941680908203, -1.47819209042233, 218, 41, 'PPL', 'P'),
(58205, 'West Bunker', 37.4550018310547, 0.653713103292409, -91.2152786254883, -1.59200694013878, 218, 29, 'PPL', 'P'),
(172726, 'West Burke', 44.6413917541504, 0.779139268782571, -71.9791717529297, -1.25627353994712, 218, 55, 'PPL', 'P'),
(118388, 'West Burlington', 40.8250007629395, 0.71253068044249, -91.1563873291016, -1.59097909311606, 218, 16, 'PPL', 'P'),
(153579, 'West Burlington', 42.7075004577637, 0.745386498284962, -75.1880569458008, -1.31227915188122, 218, 40, 'PPL', 'P'),
(168682, 'West Burlington', 41.7636108398438, 0.728912516676868, -76.6750030517578, -1.33823125722987, 218, 45, 'PPL', 'P'),
(187525, 'West Burlington', 39.3033294677734, 0.685972506208757, -102.309173583984, -1.78563193403493, 218, 7, 'PPL', 'P'),
(153580, 'West Bush', 43.0830612182617, 0.751941270096946, -74.3786087036133, -1.29815161493056, 218, 40, 'PPL', 'P'),
(292, 'West Butler', 32.0686111450195, 0.55970285102234, -88.3352813720703, -1.54174150561824, 218, 2, 'PPL', 'P'),
(153581, 'West Butler', 43.1786117553711, 0.753608941571554, -76.8083267211914, -1.34055819423233, 218, 40, 'PPL', 'P'),
(186066, 'West Butte', 39.1872215270996, 0.683946040356288, -121.886940002441, -2.12732841822339, 218, 6, 'PPL', 'P'),
(129236, 'West Buxton', 43.6669387817383, 0.762131856008134, -70.6036071777344, -1.23226540903617, 218, 26, 'PPL', 'P'),
(158264, 'West Cairo', 40.8319396972656, 0.712651787693062, -84.0811080932617, -1.46749217495267, 218, 41, 'PPL', 'P'),
(146595, 'West Caldwell', 40.8408317565918, 0.712806983405586, -74.3022232055664, -1.29681843648887, 218, 37, 'PPL', 'P'),
(153582, 'West Cambridge', 42.9894409179688, 0.750307287610128, -73.4811096191406, -1.28248730087288, 218, 40, 'PPL', 'P'),
(153585, 'West Cameron', 42.2238883972168, 0.736945875526064, -77.4197235107422, -1.35122908124611, 218, 40, 'PPL', 'P'),
(168684, 'West Cameron', 40.7552795410156, 0.711313815561406, -76.6397171020508, -1.33761540122779, 218, 45, 'PPL', 'P'),
(153584, 'West Camp', 42.1230583190918, 0.73518605867774, -73.9352798461914, -1.29041406669945, 218, 40, 'PPL', 'P'),
(144631, 'West Campton', 43.8472213745117, 0.765278380836063, -71.666389465332, -1.25081445918662, 218, 36, 'PPL', 'P'),
(144632, 'West Canaan', 43.6494407653809, 0.76182645801013, -72.0966720581055, -1.25832430714454, 218, 36, 'PPL', 'P'),
(158265, 'West Canaan', 40.9449996948242, 0.714625056902756, -81.9938888549805, -1.43106332703369, 218, 41, 'PPL', 'P'),
(153586, 'West Canadice Corners', 42.7369384765625, 0.745900288638265, -77.5524978637695, -1.35354643086865, 218, 40, 'PPL', 'P'),
(153587, 'West Candor', 42.2202796936035, 0.736882891766284, -76.4180603027344, -1.33374676027029, 218, 40, 'PPL', 'P'),
(69984, 'West Canton', 35.5377807617188, 0.620251283143891, -82.8583297729492, -1.44615066724121, 218, 33, 'PPL', 'P'),
(71541, 'West Cape May', 38.9386100769043, 0.679606951992222, -74.9422225952148, -1.30798853304899, 218, 37, 'PPL', 'P'),
(158266, 'West Carlisle', 40.228889465332, 0.702126575590905, -82.1183319091797, -1.43323526806071, 218, 41, 'PPL', 'P'),
(192409, 'West Carlisle', 33.5800018310547, 0.586081594777629, -101.973327636719, -1.77977031647567, 218, 51, 'PPL', 'P'),
(189805, 'West Carlsbad', 32.4261093139648, 0.565942371140286, -104.254173278809, -1.8195785826599, 218, 38, 'PPL', 'P'),
(74762, 'West Carrollton City', 39.6722183227539, 0.692410831302078, -84.2522201538086, -1.47047864379908, 218, 41, 'PPL', 'P'),
(186067, 'West Carson', 33.8216705322266, 0.590299509312096, -118.29167175293, -2.064579149777, 218, 6, 'PPL', 'P'),
(146597, 'West Carteret', 40.5944404602051, 0.708506644035381, -74.2466735839844, -1.29584891269403, 218, 37, 'PPL', 'P'),
(153588, 'West Carthage', 43.9741706848145, 0.767494064283982, -75.6155624389648, -1.31974053030729, 218, 40, 'PPL', 'P'),
(129237, 'West Castine', 44.4199981689453, 0.775275221777948, -68.811393737793, -1.2009853836107, 218, 26, 'PPL', 'P'),
(172727, 'West Castleton', 43.6588897705078, 0.761991374260633, -73.2322235107422, -1.27814341881885, 218, 55, 'PPL', 'P'),
(168687, 'West Catasauqua', 40.6455612182617, 0.709398869579585, -75.4747161865234, -1.31728229946309, 218, 45, 'PPL', 'P'),
(153589, 'West Caton', 42.0811080932617, 0.73445388911505, -77.0641708374023, -1.34502351643207, 218, 40, 'PPL', 'P'),
(118389, 'West Cedar Rapids', 41.9583282470703, 0.732310976543918, -91.6686096191406, -1.59991905857935, 218, 16, 'PPL', 'P'),
(158267, 'West Center', 41.252498626709, 0.719991925710511, -81.6647186279297, -1.42531822277212, 218, 41, 'PPL', 'P'),
(144633, 'West Center Harbor', 43.6811103820801, 0.762379197094376, -71.567497253418, -1.24908846448414, 218, 36, 'PPL', 'P'),
(6705, 'West Centreville', 32.9444389343262, 0.574988929626204, -87.1427764892578, -1.52092836906705, 218, 2, 'PPL', 'P'),
(179491, 'West Chandler', 33.3052787780762, 0.581286772972023, -111.944999694824, -1.95380882581873, 218, 5, 'PPL', 'P'),
(74764, 'West Charleston', 39.9230613708496, 0.696788868397087, -84.1336135864258, -1.46840856868376, 218, 41, 'PPL', 'P'),
(129239, 'West Charleston', 45.0658302307129, 0.786547117670736, -69.0688934326172, -1.20547960110826, 218, 26, 'PPL', 'P'),
(172728, 'West Charleston', 44.8988914489746, 0.783633486280135, -72.0599975585938, -1.25768421637654, 218, 55, 'PPL', 'P'),
(153590, 'West Charlton', 42.959171295166, 0.749778983028884, -74.0274963378906, -1.29202354810424, 218, 40, 'PPL', 'P'),
(18541, 'West Chase', 28.0547199249268, 0.489647233414828, -82.6100006103516, -1.44181650572516, 218, 12, 'PPL', 'P'),
(126505, 'West Chatham', 41.6811103820801, 0.727472612054489, -69.9916687011719, -1.22158506780051, 218, 23, 'PPL', 'P'),
(153591, 'West Chazy', 44.8205604553223, 0.782266352534542, -73.5074996948242, -1.28294789458341, 218, 40, 'PPL', 'P'),
(126506, 'West Chelmsford', 42.6166687011719, 0.743801185067065, -71.4000015258789, -1.24616511255556, 218, 23, 'PPL', 'P'),
(153592, 'West Chenango', 42.2005615234375, 0.736538744774419, -75.9630584716797, -1.32580548021578, 218, 40, 'PPL', 'P'),
(114240, 'West Cheshire', 41.5113906860352, 0.724510444553021, -72.9188919067383, -1.27267475067843, 218, 8, 'PPL', 'P'),
(79370, 'West Chester', 39.9605598449707, 0.697443340234974, -75.605827331543, -1.31957062062974, 218, 45, 'PPL', 'P'),
(84279, 'West Chester', 34.0458297729492, 0.594211826111477, -81.0977783203125, -1.41542324774193, 218, 48, 'PPL', 'P'),
(107397, 'West Chester', 37.2519416809082, 0.650169035092759, -80.0163879394531, -1.39654942509654, 218, 53, 'PPL', 'P'),
(118390, 'West Chester', 41.3388900756836, 0.721499740940687, -91.817497253418, -1.60251763801299, 218, 16, 'PPL', 'P'),
(158268, 'West Chester', 40.2336082458496, 0.702208933847616, -81.3444366455078, -1.41972824764404, 218, 41, 'PPL', 'P'),
(126507, 'West Chesterfield', 42.4027786254883, 0.740068099009046, -72.8763885498047, -1.27193292715679, 218, 23, 'PPL', 'P'),
(144634, 'West Chesterfield', 42.9041709899902, 0.748819046613965, -72.51611328125, -1.265644937507, 218, 36, 'PPL', 'P'),
(107398, 'West Chesterfield Heights', 37.2477798461914, 0.650096397374027, -77.4211120605469, -1.35125331601203, 218, 53, 'PPL', 'P'),
(52605, 'West Chevy Chase Heights', 38.9925003051758, 0.680547513910211, -77.0875015258789, -1.34543071376274, 218, 25, 'PPL', 'P'),
(121913, 'West Chicago', 41.8847198486328, 0.731026267634064, -88.2038879394531, -1.53944825760357, 218, 18, 'PPL', 'P'),
(153593, 'West Chili', 43.0961112976074, 0.752169036949175, -77.789436340332, -1.35768178740932, 218, 40, 'PPL', 'P'),
(126508, 'West Chop', 41.4799995422363, 0.723962565737765, -70.6033325195313, -1.2322606153462, 218, 23, 'PPL', 'P'),
(28935, 'West City', 37.9938888549805, 0.663118456156188, -88.9349975585938, -1.55220852765058, 218, 18, 'PPL', 'P'),
(144635, 'West Claremont', 43.396110534668, 0.757405011389353, -72.3697204589844, -1.26308990075718, 218, 36, 'PPL', 'P'),
(158269, 'West Clarksfield', 41.190559387207, 0.718910882045021, -82.4274978637695, -1.43863123190337, 218, 41, 'PPL', 'P'),
(153594, 'West Clarksville', 42.128059387207, 0.735273343782467, -78.2433319091797, -1.36560375954593, 218, 40, 'PPL', 'P'),
(77648, 'West Cleo', 36.4055595397949, 0.635396880000253, -98.4649963378906, -1.71853838406035, 218, 42, 'PPL', 'P'),
(168689, 'West Clifford', 41.6847190856934, 0.727535595814269, -75.6186065673828, -1.31979366037104, 218, 45, 'PPL', 'P'),
(38804, 'West Clifty', 37.5133285522461, 0.654731096619092, -86.1883316040039, -1.50427016329055, 218, 21, 'PPL', 'P'),
(31485, 'West Clinton', 39.6944389343262, 0.692798654135821, -87.5252838134766, -1.52760438128766, 218, 19, 'PPL', 'P'),
(107399, 'West Club Forest', 37.2638893127441, 0.650377560606112, -80.061393737793, -1.39733492446006, 218, 53, 'PPL', 'P'),
(12744, 'West Cobb', 35.7261085510254, 0.623538223140294, -93.7552795410156, -1.6363383191184, 218, 4, 'PPL', 'P'),
(34384, 'West Coffeyville', 37.038890838623, 0.646450596420736, -95.6697235107422, -1.66975166973508, 218, 20, 'PPL', 'P'),
(153595, 'West Colesville', 42.1433296203613, 0.735539859628557, -75.7491683959961, -1.32207239415776, 218, 40, 'PPL', 'P'),
(31486, 'West College Corner', 39.5675010681152, 0.690583170424984, -84.8161087036133, -1.48032035560747, 218, 19, 'PPL', 'P'),
(197812, 'West College Park', 45.6733283996582, 0.797149960918668, -111.068061828613, -1.93850337271794, 218, 31, 'PPL', 'P'),
(71539, 'West Collingswood', 39.9061088562012, 0.696492991199979, -75.0933303833008, -1.31062586147649, 218, 37, 'PPL', 'P'),
(71540, 'West Collingswood Heights', 39.8941688537598, 0.69628459884468, -75.0969390869141, -1.31068884523627, 218, 37, 'PPL', 'P'),
(186068, 'West Colton', 34.0669403076172, 0.59458027444829, -117.351936340332, -2.04817767272958, 218, 6, 'PPL', 'P'),
(84280, 'West Columbia', 33.9933280944824, 0.593295498959408, -81.0741729736328, -1.41501125672129, 218, 48, 'PPL', 'P'),
(98993, 'West Columbia', 29.1436100006104, 0.508651950427797, -95.6449966430664, -1.66932010448043, 218, 51, 'PPL', 'P'),
(111968, 'West Columbia', 38.9830589294434, 0.680382730817762, -82.063606262207, -1.43228012533575, 218, 58, 'PPL', 'P'),
(186069, 'West Compton', 33.8938903808594, 0.591559983456031, -118.269721984863, -2.06419605405419, 218, 6, 'PPL', 'P'),
(69981, 'West Concord', 35.3877792358398, 0.617633262634288, -80.595832824707, -1.40666264617806, 218, 33, 'PPL', 'P'),
(126509, 'West Concord', 42.4583282470703, 0.741037622803889, -71.3958282470703, -1.24609227509975, 218, 23, 'PPL', 'P'),
(138753, 'West Concord', 44.1536102294922, 0.770625875146888, -92.8994369506836, -1.62140104803831, 218, 28, 'PPL', 'P'),
(144636, 'West Concord', 43.2436103820801, 0.7547433816169, -71.5733337402344, -1.24919033039584, 218, 36, 'PPL', 'P'),
(153596, 'West Conesville', 42.3777809143066, 0.739631806643464, -74.4227828979492, -1.29892260006614, 218, 40, 'PPL', 'P'),
(168691, 'West Conshohocken', 40.0697212219238, 0.699348565678816, -75.3166732788086, -1.31452393036404, 218, 45, 'PPL', 'P'),
(138756, 'West Coon Rapids', 45.1597213745117, 0.788185827268489, -93.3494415283203, -1.62925510956712, 218, 28, 'PPL', 'P'),
(153597, 'West Copake', 42.0958290100098, 0.734710817581215, -73.5827789306641, -1.2842617651072, 218, 40, 'PPL', 'P'),
(62258, 'West Corinth', 34.9413909912109, 0.609842318023316, -88.5308303833008, -1.54515447971323, 218, 30, 'PPL', 'P'),
(129240, 'West Corinth', 44.9541702270508, 0.784598282964043, -69.024169921875, -1.20469902859276, 218, 26, 'PPL', 'P'),
(172729, 'West Corinth', 44.041389465332, 0.768667253323189, -72.3363876342773, -1.26250813321705, 218, 55, 'PPL', 'P'),
(153599, 'West Corners', 43.019718170166, 0.750835725349427, -73.9888916015625, -1.29134976834845, 218, 40, 'PPL', 'P'),
(126510, 'West Corners (historical)', 42.1916694641113, 0.736383549061894, -71.0588912963867, -1.24021161593869, 218, 23, 'PPL', 'P'),
(114241, 'West Cornwall', 41.8713912963867, 0.730793640512845, -73.3622207641602, -1.28041229890955, 218, 8, 'PPL', 'P'),
(153600, 'West Cornwall', 41.4308280944824, 0.723104362076487, -74.0688934326172, -1.29274606370797, 218, 40, 'PPL', 'P'),
(172730, 'West Cornwall', 43.9436111450195, 0.766960699696666, -73.2350006103516, -1.27819188835069, 218, 55, 'PPL', 'P'),
(6707, 'West Corona', 33.708610534668, 0.588326240102402, -87.4983291625977, -1.5271339338811, 218, 2, 'PPL', 'P'),
(186070, 'West Covina', 34.0686111450195, 0.594609436062226, -117.938056945801, -2.05840740710879, 218, 6, 'PPL', 'P'),
(38805, 'West Covington', 39.0888900756836, 0.682229832770814, -84.5338897705078, -1.47539470601332, 218, 21, 'PPL', 'P'),
(158270, 'West Covington', 40.1127815246582, 0.700100109738437, -84.3597183227539, -1.47235484078704, 218, 41, 'PPL', 'P'),
(168694, 'West Covington', 41.752498626709, 0.728718571970483, -77.1533279418945, -1.346579601457, 218, 45, 'PPL', 'P'),
(153601, 'West Coxsackie', 42.3605613708496, 0.739331268914448, -73.8172225952148, -1.28835357896405, 218, 40, 'PPL', 'P'),
(69982, 'West Cramerton', 35.252498626709, 0.615272170590851, -81.0880584716797, -1.41525360438049, 218, 33, 'PPL', 'P'),
(71553, 'West Creek', 39.6344413757324, 0.691751499195202, -74.307502746582, -1.29691058186259, 218, 37, 'PPL', 'P'),
(168695, 'West Creek', 41.4947204589844, 0.72421949420393, -78.2783279418945, -1.36621455554194, 218, 45, 'PPL', 'P'),
(168697, 'West Creek Hills', 40.2649993896484, 0.702756812662872, -76.9233322143555, -1.34256541874592, 218, 45, 'PPL', 'P'),
(52606, 'West Creek Village', 39.6611099243164, 0.69221695317472, -75.8033294677734, -1.32301768318669, 218, 25, 'PPL', 'P'),
(12745, 'West Crossett', 33.1408309936523, 0.578416617686217, -91.9938888549805, -1.60559625223313, 218, 4, 'PPL', 'P'),
(25911, 'West Crossing', 33.7305603027344, 0.58870933582521, -85.2447204589844, -1.48780104195145, 218, 13, 'PPL', 'P'),
(69983, 'West Crossroads', 35.2872200012207, 0.615878172896899, -77.4780578613281, -1.35224720773085, 218, 33, 'PPL', 'P'),
(129241, 'West Cumberland', 43.815559387207, 0.764725774909872, -70.3147201538086, -1.22722337930237, 218, 26, 'PPL', 'P'),
(126512, 'West Cummington', 42.4916687011719, 0.741619523502072, -72.9680633544922, -1.27353295433971, 218, 23, 'PPL', 'P'),
(91722, 'West Cyruston', 35.1358299255371, 0.613235917621377, -86.7508316040039, -1.51408764033302, 218, 50, 'PPL', 'P'),
(52607, 'West Dale Park', 39.1875, 0.683950900625278, -76.6497192382813, -1.33778997143725, 218, 25, 'PPL', 'P'),
(168698, 'West Damascus', 41.7000007629395, 0.727802311397441, -75.1716690063477, -1.31199312838014, 218, 45, 'PPL', 'P'),
(31487, 'West Dana', 39.8030586242676, 0.694694425357794, -87.5244369506836, -1.52758960074361, 218, 19, 'PPL', 'P'),
(153602, 'West Danby', 42.3188896179199, 0.738603959620748, -76.5258331298828, -1.33562775094821, 218, 40, 'PPL', 'P'),
(107400, 'West Dante', 36.978889465332, 0.645403374901089, -82.3216705322266, -1.43678419652935, 218, 53, 'PPL', 'P'),
(38809, 'West Danville', 37.644718170166, 0.657024278054732, -84.790283203125, -1.47986961559298, 218, 21, 'PPL', 'P'),
(172731, 'West Danville', 44.4094390869141, 0.775090931030515, -72.195556640625, -1.26005016868896, 218, 55, 'PPL', 'P'),
(153603, 'West Davenport', 42.4458312988281, 0.740819509910612, -74.9636077880859, -1.30836177507576, 218, 40, 'PPL', 'P'),
(153604, 'West Day', 43.267219543457, 0.755155439216563, -74.0699996948242, -1.29276537162588, 218, 40, 'PPL', 'P'),
(62259, 'West Days', 34.9113883972168, 0.609318673973979, -90.095832824707, -1.57246892511752, 218, 30, 'PPL', 'P'),
(18542, 'West De Land', 29.0155601501465, 0.506417058930516, -81.3333282470703, -1.41953436951669, 218, 12, 'PPL', 'P'),
(176964, 'West De Pere', 44.4455604553223, 0.775721367839564, -88.0752792358398, -1.5372036122788, 218, 57, 'PPL', 'P'),
(146598, 'West Deal', 40.2416687011719, 0.702349615332199, -74.029167175293, -1.29205270971817, 218, 37, 'PPL', 'P'),
(6708, 'West Decatur', 34.6041717529297, 0.603956732014241, -86.9955596923828, -1.51835895124735, 218, 2, 'PPL', 'P'),
(168699, 'West Decatur', 40.9283294677734, 0.714334106553665, -78.2783279418945, -1.36621455554194, 218, 45, 'PPL', 'P'),
(129242, 'West Deer Isle', 44.1683311462402, 0.770882803613053, -68.695556640625, -1.19896364486916, 218, 26, 'PPL', 'P'),
(126513, 'West Deerfield', 42.5327796936035, 0.742337045678766, -72.6311111450195, -1.26765202886254, 218, 23, 'PPL', 'P'),
(18543, 'West Deerfield Beach', 26.3136100769043, 0.459259133927938, -80.1502838134766, -1.39888634895308, 218, 12, 'PPL', 'P'),
(144637, 'West Deering', 43.0647201538086, 0.751621158133919, -71.9052810668945, -1.25498390418925, 218, 36, 'PPL', 'P'),
(153605, 'West Delhi', 42.2994384765625, 0.73826447316079, -75.0086135864258, -1.30914727443928, 218, 40, 'PPL', 'P'),
(98994, 'West Delta', 33.3280601501465, 0.581684382922772, -95.7838897705078, -1.67174424686268, 218, 51, 'PPL', 'P'),
(158273, 'West Delta', 41.5730590820313, 0.725586761107577, -84.0219421386719, -1.46645953423999, 218, 41, 'PPL', 'P'),
(129243, 'West Denmark', 43.9925003051758, 0.767813976509928, -70.8711090087891, -1.23693419674318, 218, 26, 'PPL', 'P'),
(176965, 'West Denmark', 45.5699996948242, 0.795346534807494, -92.5094375610352, -1.61459427460818, 218, 57, 'PPL', 'P'),
(126514, 'West Dennis', 41.6644401550293, 0.727181661705398, -70.1733322143555, -1.22475569423631, 218, 23, 'PPL', 'P'),
(52608, 'West Denton', 38.8888893127441, 0.67873916095102, -75.8394393920898, -1.32364792025865, 218, 25, 'PPL', 'P'),
(144638, 'West Derry', 42.8733291625977, 0.748280755178632, -71.3380584716797, -1.24508400231104, 218, 36, 'PPL', 'P'),
(168701, 'West Derry', 40.3230590820313, 0.703770145457648, -79.3127822875977, -1.38426918983602, 218, 45, 'PPL', 'P'),
(118391, 'West Des Moines', 41.577220916748, 0.725659398826309, -93.7111129760742, -1.63556746714088, 218, 16, 'PPL', 'P'),
(91723, 'West Dickson', 36.0805587768555, 0.629724546615466, -87.399169921875, -1.52540327864671, 218, 50, 'PPL', 'P'),
(126515, 'West Dighton', 41.8433303833008, 0.73030388518838, -71.1958312988281, -1.24260166985898, 218, 23, 'PPL', 'P'),
(114242, 'West District', 41.7438888549805, 0.728568303105975, -72.8861083984375, -1.27210257051823, 218, 8, 'PPL', 'P'),
(18544, 'West Dixie Bend', 26.315559387207, 0.459293155810864, -80.2016677856445, -1.39978316845017, 218, 12, 'PPL', 'P'),
(129244, 'West Dover', 45.1144409179688, 0.787395534215008, -69.2394409179688, -1.20845621625864, 218, 26, 'PPL', 'P'),
(158271, 'West Dover', 41.4777793884277, 0.723923816743904, -81.9602813720703, -1.4304767658036, 218, 41, 'PPL', 'P'),
(172732, 'West Dover', 42.9391708374023, 0.749429909189002, -72.8533325195313, -1.27153052351608, 218, 55, 'PPL', 'P'),
(129245, 'West Dresden', 44.0877799987793, 0.7694769208736, -69.773063659668, -1.21776969006481, 218, 26, 'PPL', 'P'),
(153616, 'West Dryden', 42.5169410705566, 0.742060609557616, -76.4147186279297, -1.33368843704242, 218, 40, 'PPL', 'P'),
(126516, 'West Dudley', 42.0486106872559, 0.73388670238189, -71.9833297729492, -1.25634611108683, 218, 23, 'PPL', 'P'),
(138758, 'West Duluth', 46.7355613708496, 0.8156894236892, -92.1861114501953, -1.60895116941635, 218, 28, 'PPL', 'P'),
(172733, 'West Dummerston', 42.9263916015625, 0.749206869447708, -72.6158294677734, -1.26738531327937, 218, 55, 'PPL', 'P'),
(121915, 'West Dundee', 42.0980606079102, 0.734749766312158, -88.2827835083008, -1.5408252450452, 218, 18, 'PPL', 'P'),
(129246, 'West Durham', 43.9491691589355, 0.767057705339372, -70.1477813720703, -1.22430974791177, 218, 26, 'PPL', 'P'),
(153606, 'West Durham', 42.3905601501465, 0.739854846384758, -74.2361068725586, -1.29566448878854, 218, 40, 'PPL', 'P'),
(126517, 'West Duxbury', 42.0563888549805, 0.734022457018457, -70.7750015258789, -1.2352568047306, 218, 23, 'PPL', 'P'),
(168704, 'West Easton', 40.6786117553711, 0.709975710271696, -75.2372207641602, -1.31313722238444, 218, 45, 'PPL', 'P'),
(153607, 'West Eaton', 42.8544387817383, 0.747951055835681, -75.6563873291016, -1.32045305905694, 218, 40, 'PPL', 'P'),
(18545, 'West Eau Gallie', 28.1355590820313, 0.491058142870839, -80.6719436645508, -1.40799103092979, 218, 12, 'PPL', 'P'),
(69985, 'West Edgecombe', 35.9061088562012, 0.626679821120206, -77.7402801513672, -1.35682385006415, 218, 33, 'PPL', 'P'),
(153608, 'West Edmeston', 42.7633285522461, 0.746360882348794, -75.2786102294922, -1.31385960483012, 218, 40, 'PPL', 'P'),
(52609, 'West Edmondale', 39.2924995422363, 0.685783488350389, -76.7180633544922, -1.33898280128949, 218, 25, 'PPL', 'P'),
(71543, 'West Egg Harbor', 39.5161094665527, 0.689686217769845, -74.6669387817383, -1.30318392412638, 218, 37, 'PPL', 'P'),
(168706, 'West Eldred', 41.9566688537598, 0.732282014667063, -78.4038925170898, -1.36840607080296, 218, 45, 'PPL', 'P'),
(168707, 'West Elizabeth', 40.2708282470703, 0.702858545416513, -79.8994369506836, -1.39450824527905, 218, 45, 'PPL', 'P'),
(52610, 'West Elkridge', 39.2069396972656, 0.684290187348154, -76.7272186279297, -1.3391425909549, 218, 25, 'PPL', 'P'),
(74766, 'West Elkton', 39.5877799987793, 0.690937104533855, -84.554443359375, -1.47575343381215, 218, 41, 'PPL', 'P'),
(153609, 'West Ellery', 42.1952781677246, 0.736446532821675, -79.3983306884766, -1.38576229110117, 218, 40, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(129247, 'West Ellsworth', 44.5572204589844, 0.777670202546256, -68.5469436645508, -1.19636985912548, 218, 26, 'PPL', 'P'),
(153610, 'West Elmira', 42.0780601501465, 0.734400692472276, -76.8455581665039, -1.34120800553831, 218, 40, 'PPL', 'P'),
(58209, 'West Elvins', 37.8308296203613, 0.660272535636302, -90.5444412231445, -1.58029861872235, 218, 29, 'PPL', 'P'),
(123982, 'West Elwood', 40.2797203063965, 0.703013741129038, -85.8605575561523, -1.49854942695295, 218, 19, 'PPL', 'P'),
(689, 'West Ely', 39.7108306884766, 0.693084744215923, -91.5625, -1.59806709635731, 218, 29, 'PPL', 'P'),
(58210, 'West Eminence', 37.1402816772461, 0.648220200386066, -91.3744430541992, -1.59478488347184, 218, 29, 'PPL', 'P'),
(91724, 'West Emory', 35.8800010681152, 0.626224154257693, -84.0905609130859, -1.4676571577822, 218, 50, 'PPL', 'P'),
(6709, 'West End', 33.4902801513672, 0.584515656056662, -86.8658294677734, -1.51609473168856, 218, 2, 'PPL', 'P'),
(12746, 'West End', 34.2236099243164, 0.597314675097529, -92.0599975585938, -1.6067500667754, 218, 4, 'PPL', 'P'),
(13246, 'West End', 38.9069404602051, 0.679054212907976, -77.0500030517578, -1.34477624192485, 218, 9, 'PPL', 'P'),
(25907, 'West End', 33.7380599975586, 0.588840230192788, -84.416389465332, -1.4733439388159, 218, 13, 'PPL', 'P'),
(28936, 'West End', 37.8899993896484, 0.661305242928007, -88.7055587768555, -1.54820406547748, 218, 18, 'PPL', 'P'),
(44071, 'West End', 30.0227794647217, 0.523996352259534, -90.1125030517578, -1.57275987546661, 218, 22, 'PPL', 'P'),
(69986, 'West End', 35.2397193908691, 0.615049130849557, -79.5677795410156, -1.38871973149171, 218, 33, 'PPL', 'P'),
(91726, 'West End', 35.9697189331055, 0.627790026399632, -83.2061080932617, -1.45222054399772, 218, 50, 'PPL', 'P'),
(107406, 'West End', 37.273609161377, 0.65054720396755, -79.9697189331055, -1.39573489727714, 218, 53, 'PPL', 'P'),
(111970, 'West End', 39.3902816772461, 0.687490108555939, -79.771110534668, -1.39226852680229, 218, 58, 'PPL', 'P'),
(129248, 'West End', 43.6505584716797, 0.761845965665115, -70.2750015258789, -1.22653015847063, 218, 26, 'PPL', 'P'),
(146599, 'West End', 40.2861099243164, 0.703125260999685, -73.998893737793, -1.2915243385579, 218, 37, 'PPL', 'P'),
(153612, 'West End', 42.4686088562012, 0.741217053282334, -75.0941696166992, -1.31064050886249, 218, 40, 'PPL', 'P'),
(168709, 'West End', 40.4402809143066, 0.705816052386074, -80.0355606079102, -1.39688405128751, 218, 45, 'PPL', 'P'),
(179492, 'West End', 33.4944381713867, 0.584588227196367, -112.254440307617, -1.95920958335136, 218, 5, 'PPL', 'P'),
(186071, 'West End', 34.1311111450195, 0.595700266844723, -117.493057250977, -2.05064069726374, 218, 6, 'PPL', 'P'),
(197813, 'West End', 45.665828704834, 0.797019066551091, -110.824722290039, -1.93425629656953, 218, 31, 'PPL', 'P'),
(190913, 'West End (historical)', 36.2147216796875, 0.632066131003918, -114.711669921875, -2.00209633059767, 218, 39, 'PPL', 'P'),
(6711, 'West End Anniston', 33.6427803039551, 0.587177285829115, -85.8675003051758, -1.49867060078255, 218, 2, 'PPL', 'P'),
(52611, 'West End Farms', 38.7416687011719, 0.676169676552284, -76.767219543457, -1.33984073863466, 218, 25, 'PPL', 'P'),
(91727, 'West End Heights', 36.2152786254883, 0.632075851541897, -86.3191680908203, -1.50655369076724, 218, 50, 'PPL', 'P'),
(52612, 'West End Park', 39.0858306884766, 0.682176436390958, -77.165283203125, -1.34678826012841, 218, 25, 'PPL', 'P'),
(192410, 'West End Place', 33.5755615234375, 0.586004096789908, -101.949722290039, -1.77935832545504, 218, 51, 'PPL', 'P'),
(129249, 'West Enfield', 45.2433280944824, 0.78964503980877, -68.6502838134766, -1.19817348497373, 218, 26, 'PPL', 'P'),
(146600, 'West Englewood', 40.9019393920898, 0.713873512843136, -74.0036087036133, -1.29160663023558, 218, 37, 'PPL', 'P'),
(168710, 'West Enola', 40.2866706848145, 0.703135048116691, -76.9416732788086, -1.34288553070895, 218, 45, 'PPL', 'P'),
(172734, 'West Enosburg', 44.871940612793, 0.783163105452599, -72.7983322143555, -1.27057058710116, 218, 55, 'PPL', 'P'),
(6712, 'West Ensley', 33.5286102294922, 0.58518464212249, -86.9258270263672, -1.51714188662918, 218, 2, 'PPL', 'P'),
(62261, 'West Enterprise', 32.1722183227539, 0.561511137402503, -88.8249969482422, -1.55028865482074, 218, 30, 'PPL', 'P'),
(192856, 'West Ephraim', 39.375560760498, 0.687233180089773, -111.588333129883, -1.94758381992872, 218, 52, 'PPL', 'P'),
(144639, 'West Epping', 43.0372200012207, 0.751141189926459, -71.1230621337891, -1.24133160833512, 218, 36, 'PPL', 'P'),
(44073, 'West Erath', 29.9605598449707, 0.522910415035541, -92.0436096191406, -1.60646404327433, 218, 22, 'PPL', 'P'),
(126518, 'West Everett', 42.4111099243164, 0.740213507604564, -71.0638885498047, -1.24029883446439, 218, 23, 'PPL', 'P'),
(153613, 'West Exeter', 42.8022193908691, 0.747039655531628, -75.1500015258789, -1.31161495950535, 218, 40, 'PPL', 'P'),
(168711, 'West Export', 40.4219398498535, 0.705495940423046, -79.6361083984375, -1.38991229502784, 218, 45, 'PPL', 'P'),
(6713, 'West Fairfield', 33.4541702270508, 0.583885418984695, -86.9477767944336, -1.51752498235199, 218, 2, 'PPL', 'P'),
(168712, 'West Fairfield', 40.3494415283203, 0.704230606010122, -79.1263885498047, -1.38101600540643, 218, 45, 'PPL', 'P'),
(209136, 'West Fairfield', 47.3708305358887, 0.826776962255527, -117.220283508301, -2.04587989734106, 218, 56, 'PPL', 'P'),
(172735, 'West Fairlee', 43.9091682434082, 0.766359557659608, -72.2636108398438, -1.26123793853514, 218, 55, 'PPL', 'P'),
(172736, 'West Fairlee Center', 43.9433288574219, 0.76695577284865, -72.225830078125, -1.26057853984923, 218, 55, 'PPL', 'P'),
(38807, 'West Fairview', 38.4666709899902, 0.671370061056716, -82.6822204589844, -1.44307697986909, 218, 21, 'PPL', 'P'),
(168713, 'West Fairview', 40.2750015258789, 0.702931382872327, -76.9158325195313, -1.34243452437835, 218, 45, 'PPL', 'P'),
(153614, 'West Falls', 42.7013893127441, 0.745279838683304, -78.682502746582, -1.37326873663734, 218, 40, 'PPL', 'P'),
(168716, 'West Falls', 41.4605598449707, 0.723623279014889, -75.8566665649414, -1.32394859114572, 218, 45, 'PPL', 'P'),
(107404, 'West Falls Church', 38.8908309936523, 0.678773049675891, -77.1847229003906, -1.34712754685128, 218, 53, 'PPL', 'P'),
(126519, 'West Falmouth', 41.6041717529297, 0.726129779653844, -70.6350021362305, -1.23281335443045, 218, 23, 'PPL', 'P'),
(129250, 'West Falmouth (historical)', 43.7400016784668, 0.763407044117092, -70.2955627441406, -1.22688901942751, 218, 26, 'PPL', 'P'),
(129251, 'West Falmouth Corner', 43.7463912963867, 0.763518563987739, -70.3036117553711, -1.22702950117502, 218, 26, 'PPL', 'P'),
(138759, 'West Fargo', 46.8766708374023, 0.818152248486278, -96.8722229003906, -1.69073924333767, 218, 28, 'PPL', 'P'),
(141066, 'West Fargo', 46.875, 0.818123086872342, -96.9000015258789, -1.69122407181412, 218, 34, 'PPL', 'P'),
(14825, 'West Farm', 39.7874984741211, 0.694422849505633, -75.602783203125, -1.319517490566, 218, 10, 'PPL', 'P'),
(187526, 'West Farm', 38.0927810668945, 0.664844450858668, -102.558059692383, -1.78997581608896, 218, 7, 'PPL', 'P'),
(129252, 'West Farmington', 44.6627807617188, 0.779512577388373, -70.1558303833008, -1.22445022965927, 218, 26, 'PPL', 'P'),
(158272, 'West Farmington', 41.3905601501465, 0.722401553864815, -80.9736099243164, -1.41325610040488, 218, 41, 'PPL', 'P'),
(126521, 'West Farms', 42.3097190856934, 0.738443903639234, -72.7152786254883, -1.26912102851983, 218, 23, 'PPL', 'P'),
(146601, 'West Farms', 40.1919403076172, 0.701481691132942, -74.2016677856445, -1.29506341333051, 218, 37, 'PPL', 'P'),
(153615, 'West Farms', 40.8397216796875, 0.712787608908656, -73.878059387207, -1.28941538129067, 218, 40, 'PPL', 'P'),
(79368, 'West Fayetteville', 39.9166717529297, 0.69667734852644, -77.5744400024414, -1.3539293934334, 218, 45, 'PPL', 'P'),
(44075, 'West Ferriday', 31.6402797698975, 0.552227058236865, -91.5730590820313, -1.59825138710474, 218, 22, 'PPL', 'P'),
(79369, 'West Finley', 39.9930610656738, 0.69801059354716, -80.4633331298828, -1.40435009024549, 218, 45, 'PPL', 'P'),
(126522, 'West Fitchburg', 42.5750007629395, 0.743073942352391, -71.841667175293, -1.2538736323308, 218, 23, 'PPL', 'P'),
(172738, 'West Fletcher', 44.7050018310547, 0.780249474061998, -72.9372177124023, -1.27299459632535, 218, 55, 'PPL', 'P'),
(74768, 'West Florence', 39.7438888549805, 0.693661718066088, -84.7605590820313, -1.47935083181263, 218, 41, 'PPL', 'P'),
(168718, 'West Ford City', 40.7599983215332, 0.711396173818117, -79.5633316040039, -1.38864210034593, 218, 45, 'PPL', 'P'),
(25910, 'West Forest', 33.5441703796387, 0.585456217974651, -84.0199966430664, -1.46642557893609, 218, 13, 'PPL', 'P'),
(84281, 'West Forest', 34.9233283996582, 0.609527066329278, -82.0041732788086, -1.43124282409116, 218, 48, 'PPL', 'P'),
(91728, 'West Forest', 35.9472198486328, 0.6273973432969, -84.0516662597656, -1.46697831802034, 218, 50, 'PPL', 'P'),
(52613, 'West Forest Park', 39.3250007629395, 0.686350741662576, -76.6927795410156, -1.33854151549687, 218, 25, 'PPL', 'P'),
(12747, 'West Fork', 35.9241714477539, 0.626995072814244, -94.1883316040039, -1.6438965034501, 218, 4, 'PPL', 'P'),
(31488, 'West Fork', 38.2336082458496, 0.667302348807729, -86.5263900756836, -1.51017039668562, 218, 19, 'PPL', 'P'),
(38808, 'West Fork', 36.7827796936035, 0.641980613689092, -86.2805633544922, -1.50587991101145, 218, 21, 'PPL', 'P'),
(58211, 'West Fork', 37.4916687011719, 0.654353060902355, -91.10888671875, -1.59015005106872, 218, 29, 'PPL', 'P'),
(107405, 'West Fork', 36.624439239502, 0.639217051425917, -79.6311111450195, -1.38982507650214, 218, 53, 'PPL', 'P'),
(197814, 'West Fork', 48.686939239502, 0.849747392447733, -105.911109924316, -1.84849758262096, 218, 31, 'PPL', 'P'),
(202765, 'West Fork', 44.4458312988281, 0.775726094950498, -101.548057556152, -1.77234795335957, 218, 49, 'PPL', 'P'),
(209137, 'West Fork', 48.4577789306641, 0.845747790543625, -118.749168395996, -2.07256397251533, 218, 56, 'PPL', 'P'),
(129254, 'West Forks', 45.3969383239746, 0.792326044078153, -70.0366668701172, -1.22237043400598, 218, 26, 'PPL', 'P'),
(153617, 'West Fort Ann', 43.4097213745117, 0.757642565358588, -73.5741729736328, -1.28411156282172, 218, 40, 'PPL', 'P'),
(118396, 'West Fort Dodge (historical)', 42.4811096191406, 0.741435232754638, -94.2111129760742, -1.64429411340085, 218, 16, 'PPL', 'P'),
(77649, 'West Fort Smith', 35.3969383239746, 0.61779311887872, -94.4397201538086, -1.64828406134601, 218, 42, 'PPL', 'P'),
(77650, 'West Fort Towson', 34.0227813720703, 0.593809555628821, -95.2736129760742, -1.66283823670329, 218, 42, 'PPL', 'P'),
(153639, 'West Fowler', 44.2677803039551, 0.772618518853512, -75.4519424438477, -1.3168848226704, 218, 40, 'PPL', 'P'),
(126523, 'West Foxboro', 42.0750007629395, 0.73434729609242, -71.2708282470703, -1.24391061353476, 218, 23, 'PPL', 'P'),
(28939, 'West Frankfort', 37.8977813720703, 0.661441064143601, -88.9313888549805, -1.5521455438908, 218, 18, 'PPL', 'P'),
(153618, 'West Frankfort', 43.0877799987793, 0.752023628353657, -75.1658325195313, -1.31189126246845, 218, 40, 'PPL', 'P'),
(31489, 'West Franklin', 37.8950004577637, 0.661392528032734, -87.7127838134766, -1.53087687363515, 218, 19, 'PPL', 'P'),
(129255, 'West Franklin', 44.583610534668, 0.778130796256786, -68.2608337402344, -1.19137629892353, 218, 26, 'PPL', 'P'),
(144640, 'West Franklin', 43.4408302307129, 0.758185517325828, -71.6622161865234, -1.25074162173081, 218, 36, 'PPL', 'P'),
(168719, 'West Franklin', 41.6966705322266, 0.72774418790665, -76.6272201538086, -1.33739728833452, 218, 45, 'PPL', 'P'),
(52660, 'West Frederick Highlands', 39.3633308410645, 0.687019727728403, -77.4683303833008, -1.35207743121136, 218, 25, 'PPL', 'P'),
(168720, 'West Freedom', 41.1072196960449, 0.717456330036647, -79.6244430541992, -1.38970869636251, 218, 45, 'PPL', 'P'),
(146602, 'West Freehold', 40.2419395446777, 0.702354342443134, -74.3016662597656, -1.29680871595089, 218, 37, 'PPL', 'P'),
(52614, 'West Friendship', 39.3025016784668, 0.685958058559843, -76.9530563354492, -1.34308420252627, 218, 25, 'PPL', 'P'),
(18546, 'West Frostproof', 27.7333297729492, 0.484037917079335, -81.5833282470703, -1.42389769264667, 218, 12, 'PPL', 'P'),
(129256, 'West Fryeburg', 44.0638885498047, 0.769059936425921, -70.9805603027344, -1.2388444821931, 218, 26, 'PPL', 'P'),
(62262, 'West Fulton', 34.2708282470703, 0.598138790296854, -88.4541702270508, -1.54381650758158, 218, 30, 'PPL', 'P'),
(153619, 'West Fulton', 42.5644416809082, 0.742889651604958, -74.4641723632813, -1.29964498251182, 218, 40, 'PPL', 'P'),
(158274, 'West Fulton', 40.8888893127441, 0.713645745990907, -81.6033325195313, -1.42424683306558, 218, 41, 'PPL', 'P'),
(38810, 'West Future City', 37.063060760498, 0.646872441137404, -88.8099975585938, -1.55002686608559, 218, 21, 'PPL', 'P'),
(153620, 'West Gaines', 43.2799987792969, 0.755378478957857, -78.29638671875, -1.36652974065695, 218, 40, 'PPL', 'P'),
(107419, 'West Galax', 36.6513900756836, 0.639687432253452, -80.9308319091797, -1.41250948319327, 218, 53, 'PPL', 'P'),
(197815, 'West Gallatin', 45.7027816772461, 0.797664017588081, -111.218063354492, -1.94112139322754, 218, 31, 'PPL', 'P'),
(52615, 'West Galloway', 38.7983283996582, 0.677158574844058, -76.0605621337891, -1.32750724015234, 218, 25, 'PPL', 'P'),
(153621, 'West Galway', 43.0036087036133, 0.750554562117342, -74.1016693115234, -1.29331811071012, 218, 40, 'PPL', 'P'),
(84282, 'West Gantt', 34.7855606079102, 0.607122564760073, -82.4124984741211, -1.43836944316822, 218, 48, 'PPL', 'P'),
(38811, 'West Garrett', 37.4844398498535, 0.654226893645713, -82.8349990844727, -1.44574346991054, 218, 21, 'PPL', 'P'),
(69993, 'West Gastonia', 35.2874984741211, 0.615883033165888, -81.2444381713867, -1.41798294502366, 218, 33, 'PPL', 'P'),
(18547, 'West Gate', 26.702220916748, 0.466041672592152, -80.0983276367188, -1.39797954260191, 218, 12, 'PPL', 'P'),
(84283, 'West Gate', 34.5094413757324, 0.602303375030492, -82.7649993896484, -1.44452174476046, 218, 48, 'PPL', 'P'),
(107407, 'West Gate', 38.7827796936035, 0.676887198728979, -77.4977798461914, -1.35259142130174, 218, 53, 'PPL', 'P'),
(79388, 'West Gate Hills', 39.9730606079102, 0.697661519707278, -75.3269424438477, -1.31470316110541, 218, 45, 'PPL', 'P'),
(138760, 'West Gate Mobile Home Park', 44.1536102294922, 0.770625875146888, -92.8994369506836, -1.62140104803831, 218, 28, 'PPL', 'P'),
(107408, 'West Gate of Lomond', 38.7855606079102, 0.676935734839846, -77.4925003051758, -1.35249927592803, 218, 53, 'PPL', 'P'),
(153622, 'West Genesee Terrace', 43.047779083252, 0.751325480673893, -76.2608337402344, -1.33100263908307, 218, 40, 'PPL', 'P'),
(129258, 'West Georgetown', 43.8069381713867, 0.764575306308282, -69.7736129760742, -1.21777927744473, 218, 26, 'PPL', 'P'),
(172739, 'West Georgia', 44.7024993896484, 0.780205798220121, -73.1544418334961, -1.27678587245318, 218, 55, 'PPL', 'P'),
(107409, 'West Ghent', 36.8708305358887, 0.643517390796123, -76.3052825927734, -1.33177841790861, 218, 53, 'PPL', 'P'),
(153623, 'West Ghent', 42.3186111450195, 0.738599099351758, -73.7005615234375, -1.28631745915263, 218, 40, 'PPL', 'P'),
(153624, 'West Gilgo Beach', 40.6127815246582, 0.708826755998408, -73.4199981689453, -1.2814207048563, 218, 40, 'PPL', 'P'),
(197816, 'West Glacier', 48.5, 0.84648468721725, -113.977783203125, -1.98928759101882, 218, 31, 'PPL', 'P'),
(133656, 'West Gladstone', 45.8405609130859, 0.800068718894368, -87.0625, -1.51952728001756, 218, 27, 'PPL', 'P'),
(58215, 'West Glasgow', 39.2161102294922, 0.684450243329668, -92.8763885498047, -1.62099877755565, 218, 29, 'PPL', 'P'),
(52616, 'West Glen', 39.327220916748, 0.686389490656436, -76.7305603027344, -1.33920091418277, 218, 25, 'PPL', 'P'),
(129259, 'West Glenburn', 44.8752784729004, 0.783221362101445, -68.8797225952148, -1.20217794714683, 218, 26, 'PPL', 'P'),
(186073, 'West Glendale', 34.1483306884766, 0.596000804573738, -118.272499084473, -2.06424452358603, 218, 6, 'PPL', 'P'),
(197817, 'West Glendive', 47.1108283996582, 0.822239068916087, -104.749168395996, -1.82821787723612, 218, 31, 'PPL', 'P'),
(153625, 'West Glens Falls', 43.2999992370605, 0.755727552797739, -73.684440612793, -1.28603609618347, 218, 40, 'PPL', 'P'),
(169663, 'West Glocester', 41.9166717529297, 0.731583933566326, -71.7927780151367, -1.25302035551754, 218, 47, 'PPL', 'P'),
(126524, 'West Gloucester', 42.6133308410645, 0.743742928418219, -70.7111129760742, -1.23414173918218, 218, 23, 'PPL', 'P'),
(172740, 'West Glover', 44.728328704834, 0.780656604813644, -72.2244415283203, -1.26055430508331, 218, 55, 'PPL', 'P'),
(144641, 'West Gonic', 43.2786102294922, 0.755354244191937, -70.9830627441406, -1.23888815803498, 218, 36, 'PPL', 'P'),
(129260, 'West Gorham', 43.6936111450195, 0.76259737656668, -70.4925003051758, -1.23032622828842, 218, 26, 'PPL', 'P'),
(79371, 'West Goshen', 39.9680595397949, 0.697574234602551, -75.5730590820313, -1.31899870678565, 218, 45, 'PPL', 'P'),
(114243, 'West Goshen', 41.827220916748, 0.730022721956294, -73.2522201538086, -1.27849242607971, 218, 8, 'PPL', 'P'),
(129261, 'West Gouldsboro', 44.4694404602051, 0.776138152550161, -68.0908279418945, -1.18840913799501, 218, 26, 'PPL', 'P'),
(111971, 'West Grafton', 39.3369407653809, 0.686559134017874, -80.0255584716797, -1.39670948107805, 218, 58, 'PPL', 'P'),
(114244, 'West Granby', 41.9561080932617, 0.732272227550057, -72.8430633544922, -1.27135129277471, 218, 8, 'PPL', 'P'),
(28937, 'West Grand Place', 39.7686080932617, 0.694093150162681, -89.6711120605469, -1.56505614938134, 218, 18, 'PPL', 'P'),
(126525, 'West Granville', 42.077220916748, 0.73438604508628, -72.9438934326172, -1.27311110962304, 218, 23, 'PPL', 'P'),
(153626, 'West Granville', 43.4477806091309, 0.758306824313481, -73.3630599975586, -1.28042694629554, 218, 40, 'PPL', 'P'),
(176966, 'West Granville', 43.1405601501465, 0.752944815774715, -88.0449981689453, -1.53667510796047, 218, 57, 'PPL', 'P'),
(129262, 'West Gray', 43.8591690063477, 0.765486906349416, -70.3758316040039, -1.22828997531895, 218, 26, 'PPL', 'P'),
(153627, 'West Greece', 43.2186088562012, 0.754307022672291, -77.758056640625, -1.35713410833115, 218, 40, 'PPL', 'P'),
(25912, 'West Green', 31.6127796173096, 0.551747090029405, -82.7347183227539, -1.44399324044214, 218, 13, 'PPL', 'P'),
(6718, 'West Greene', 32.9236106872559, 0.574625408137408, -88.0852813720703, -1.53737818248826, 218, 2, 'PPL', 'P'),
(168721, 'West Greene', 42.0141716003418, 0.73328562692386, -79.9408264160156, -1.39523062772473, 218, 45, 'PPL', 'P'),
(84285, 'West Greenville', 34.8430595397949, 0.608126110437842, -82.4297180175781, -1.43866998089723, 218, 48, 'PPL', 'P'),
(153628, 'West Greenville', 42.4116706848145, 0.74022329472157, -74.039436340332, -1.29223194045953, 218, 40, 'PPL', 'P'),
(169664, 'West Greenville', 41.877498626709, 0.730900233535476, -71.5719375610352, -1.24916596247186, 218, 47, 'PPL', 'P'),
(153629, 'West Greenwood', 42.1536102294922, 0.735719290107001, -77.7138900756836, -1.35636325635362, 218, 40, 'PPL', 'P'),
(126526, 'West Groton', 42.6041717529297, 0.743583072173787, -71.6277770996094, -1.25014054627278, 218, 23, 'PPL', 'P'),
(153630, 'West Groton', 42.6041717529297, 0.743583072173787, -76.4458312988281, -1.33423145558868, 218, 40, 'PPL', 'P'),
(172741, 'West Groton', 44.2180595397949, 0.77175072781231, -72.2438888549805, -1.26089372496425, 218, 55, 'PPL', 'P'),
(31491, 'West Grove', 39.8463897705078, 0.695450696528349, -85.0138931274414, -1.48377234501243, 218, 19, 'PPL', 'P'),
(52617, 'West Grove', 39.4988899230957, 0.68938568004083, -76.3891677856445, -1.33324249071788, 218, 25, 'PPL', 'P'),
(79373, 'West Grove', 39.8219413757324, 0.695023991542691, -75.8277816772461, -1.32344445475137, 218, 45, 'PPL', 'P'),
(118397, 'West Grove', 40.7247200012207, 0.71078045097409, -92.5599975585938, -1.61547671303537, 218, 16, 'PPL', 'P'),
(146603, 'West Grove', 40.211109161377, 0.701816250744884, -74.0363922119141, -1.29217881039579, 218, 37, 'PPL', 'P'),
(172742, 'West Guilford', 42.8083305358887, 0.747146315133286, -72.6638870239258, -1.26822407586469, 218, 55, 'PPL', 'P'),
(62263, 'West Gulfport', 30.4038906097412, 0.53064799655617, -89.0941696166992, -1.5549866041417, 218, 30, 'PPL', 'P'),
(114245, 'West Haddam', 41.4302787780762, 0.723094774696562, -72.5599975585938, -1.26641086263651, 218, 8, 'PPL', 'P'),
(71545, 'West Haddonfield', 39.901668548584, 0.696415493212257, -75.0411071777344, -1.30971439459341, 218, 37, 'PPL', 'P'),
(172743, 'West Halifax', 42.7872200012207, 0.746777866796474, -72.771110534668, -1.27009547916269, 218, 55, 'PPL', 'P'),
(121921, 'West Hallock', 40.9208297729492, 0.714203212186088, -89.6391677856445, -1.56449861660713, 218, 18, 'PPL', 'P'),
(168722, 'West Hamburg', 40.5475006103516, 0.707687389105045, -76.0025024414063, -1.32649390735757, 218, 45, 'PPL', 'P'),
(98995, 'West Hamilton (historical)', 31.6395606994629, 0.552214508090228, -93.9240264892578, -1.63928350896792, 218, 51, 'PPL', 'P'),
(79375, 'West Hamilton Heights', 39.9505615234375, 0.697268836604546, -77.6908264160156, -1.35596071955486, 218, 45, 'PPL', 'P'),
(111972, 'West Hamlin', 38.2855606079102, 0.668209088579874, -82.1958312988281, -1.43458788757836, 218, 58, 'PPL', 'P'),
(129263, 'West Hampden', 44.7491683959961, 0.781020326039522, -68.9274978637695, -1.20301178288414, 218, 26, 'PPL', 'P'),
(144642, 'West Hampstead', 42.9036102294922, 0.748809259496959, -71.2172164916992, -1.24297491188576, 218, 36, 'PPL', 'P'),
(25914, 'West Hampton', 33.5275001525879, 0.58516526762556, -82.0683288574219, -1.43236255017149, 218, 13, 'PPL', 'P'),
(107412, 'West Hampton', 37.2552795410156, 0.650227291741605, -79.996940612793, -1.39621000521561, 218, 53, 'PPL', 'P'),
(153631, 'West Hampton Dunes', 40.7758293151855, 0.711672476781212, -72.7158279418945, -1.26913061589975, 218, 40, 'PPL', 'P'),
(126527, 'West Hanover', 42.1194381713867, 0.735122875180878, -70.8833312988281, -1.2371475159465, 218, 23, 'PPL', 'P'),
(153632, 'West Harpersfield', 42.4347190856934, 0.740625565204227, -74.7238922119141, -1.30417794900325, 218, 40, 'PPL', 'P'),
(91730, 'West Harpeth', 35.8424987792969, 0.625569615840779, -86.9000015258789, -1.51669114661468, 218, 50, 'PPL', 'P'),
(129264, 'West Harpswell', 43.7666702270508, 0.76387249809661, -70.0116729736328, -1.22193420821942, 218, 26, 'PPL', 'P'),
(129265, 'West Harrington', 44.5961112976074, 0.77834897572909, -67.8424987792969, -1.18407497647896, 218, 26, 'PPL', 'P'),
(31490, 'West Harrison', 39.2608299255371, 0.685230749266143, -84.8208312988281, -1.48040278044321, 218, 19, 'PPL', 'P'),
(12751, 'West Hartford', 35.0044403076172, 0.610942736185737, -94.4100036621094, -1.64776541072371, 218, 4, 'PPL', 'P'),
(58213, 'West Hartford', 39.4105606079102, 0.68784404266481, -91.6052780151367, -1.59881371356891, 218, 29, 'PPL', 'P'),
(114246, 'West Hartford', 41.7619400024414, 0.728883355062931, -72.7425003051758, -1.2695961364583, 218, 8, 'PPL', 'P'),
(172744, 'West Hartford', 43.7122192382813, 0.762922149061616, -72.4180603027344, -1.26393359019052, 218, 55, 'PPL', 'P'),
(114248, 'West Hartland', 42.0074996948242, 0.733169180205196, -72.9711074829102, -1.27358608440345, 218, 8, 'PPL', 'P'),
(158275, 'West Hartland', 41.2038917541504, 0.719143575745266, -82.5400009155273, -1.44059478057509, 218, 41, 'PPL', 'P'),
(186075, 'West Hartley', 37.940559387207, 0.662187681355205, -121.811668395996, -2.12601468085765, 218, 6, 'PPL', 'P'),
(84286, 'West Hartsville', 34.3655586242676, 0.599792147280602, -80.1091690063477, -1.39816876019736, 218, 48, 'PPL', 'P'),
(121922, 'West Harvey', 41.622501373291, 0.72644969187979, -87.6591720581055, -1.52994117198615, 218, 18, 'PPL', 'P'),
(126528, 'West Harwich', 41.6666717529297, 0.72722061043634, -70.1166687011719, -1.22376672936551, 218, 23, 'PPL', 'P'),
(126529, 'West Hatfield', 42.3708305358887, 0.739510499655811, -72.6374969482422, -1.26776348215416, 218, 23, 'PPL', 'P'),
(62264, 'West Hattiesburg', 31.3188896179199, 0.546617741901371, -89.375, -1.55988801896993, 218, 30, 'PPL', 'P'),
(52618, 'West Hatton', 38.3624992370605, 0.669551920980519, -76.8630599975586, -1.34151347011534, 218, 25, 'PPL', 'P'),
(14826, 'West Haven', 39.7597198486328, 0.693938021029184, -75.591667175293, -1.31932347928058, 218, 10, 'PPL', 'P'),
(52619, 'West Haven', 38.6288909912109, 0.674201334190607, -75.9466705322266, -1.32551945671471, 218, 25, 'PPL', 'P'),
(69987, 'West Haven', 35.4691696166992, 0.619053792759736, -82.5766677856445, -1.44123473818503, 218, 33, 'PPL', 'P'),
(91732, 'West Haven', 35.6058311462402, 0.621438986411039, -87.0755615234375, -1.51975524660687, 218, 50, 'PPL', 'P'),
(114249, 'West Haven', 41.2705612182617, 0.720307177404549, -72.9475021362305, -1.27317409338282, 218, 8, 'PPL', 'P'),
(172745, 'West Haven', 43.6513900756836, 0.761860479893056, -73.3477783203125, -1.28016023071237, 218, 55, 'PPL', 'P'),
(201768, 'West Haven', 45.5177803039551, 0.794435134503441, -122.768333435059, -2.14271163562801, 218, 43, 'PPL', 'P'),
(206384, 'West Haven', 41.2030601501465, 0.719129061517325, -112.050277709961, -1.95564627381283, 218, 52, 'PPL', 'P'),
(98996, 'West Haven Colonia', 26.3229999542236, 0.459423018203519, -98.2030029296875, -1.71396573646868, 218, 51, 'PPL', 'P'),
(153633, 'West Haverstraw', 41.2094383239746, 0.719240381650891, -73.9858322143555, -1.29129637196859, 218, 40, 'PPL', 'P'),
(193184, 'West Havre', 48.5449981689453, 0.847270053422714, -109.732223510742, -1.91518859579678, 218, 31, 'PPL', 'P'),
(126530, 'West Hawley', 42.5275001525879, 0.74224490030505, -72.9472198486328, -1.2731691665348, 218, 23, 'PPL', 'P'),
(168724, 'West Hawley', 41.4777793884277, 0.723923816743904, -75.1730575561523, -1.31201736314606, 218, 45, 'PPL', 'P'),
(168725, 'West Hazleton', 40.958610534668, 0.714862610871991, -75.9963912963867, -1.32638724775591, 218, 45, 'PPL', 'P'),
(153634, 'West Hebron', 43.2305603027344, 0.754515614764671, -73.376106262207, -1.28065464656874, 218, 40, 'PPL', 'P'),
(44078, 'West Heights', 32.4913902282715, 0.567081738033649, -92.1766662597656, -1.60878631974488, 218, 22, 'PPL', 'P'),
(12750, 'West Helena', 34.5505599975586, 0.603021030365241, -90.6416702270508, -1.58199558496895, 218, 4, 'PPL', 'P'),
(153635, 'West Hempstead', 40.704719543457, 0.710431377134208, -73.6505584716797, -1.28544474126341, 218, 40, 'PPL', 'P'),
(144643, 'West Henniker Emerson Station', 43.1699981689453, 0.753458606128019, -71.8436126708984, -1.2539075876347, 218, 36, 'PPL', 'P'),
(153636, 'West Henrietta', 43.0400009155273, 0.751189726037326, -77.6619415283203, -1.35545658316051, 218, 40, 'PPL', 'P'),
(58214, 'West Hermondale', 36.0305595397949, 0.628851895305274, -89.9319381713867, -1.56960842379067, 218, 29, 'PPL', 'P'),
(168729, 'West Hickory', 41.5686111450195, 0.725509129961801, -79.408332824707, -1.38593686131063, 218, 45, 'PPL', 'P'),
(133657, 'West Highland', 42.6361083984375, 0.744140471789941, -83.6622161865234, -1.46018113197013, 218, 27, 'PPL', 'P'),
(121923, 'West Highland Acres', 42.0488891601563, 0.73389156265088, -88.3480606079102, -1.54196454535954, 218, 18, 'PPL', 'P'),
(6715, 'West Highlands', 33.4083290100098, 0.583085338814208, -86.996940612793, -1.51838305285521, 218, 2, 'PPL', 'P'),
(69988, 'West Highlands', 36.098331451416, 0.630034738303433, -80.273063659668, -1.40102926152422, 218, 33, 'PPL', 'P'),
(186076, 'West Highlands', 34.1394386291504, 0.595845608861214, -117.230560302734, -2.04605926124048, 218, 6, 'PPL', 'P'),
(209138, 'West Highlands', 46.2136116027832, 0.806579681706421, -119.180000305176, -2.08008340785316, 218, 56, 'PPL', 'P'),
(98997, 'West Highway Colonia', 26.1599998474121, 0.456578129658556, -98.0005569458008, -1.71043238749242, 218, 51, 'PPL', 'P'),
(6716, 'West Hill', 30.6900005340576, 0.535641556758124, -88.1808319091797, -1.53904585396286, 218, 2, 'PPL', 'P'),
(52620, 'West Hill', 39.6341705322266, 0.691746772084267, -76.8847198486328, -1.34189150583208, 218, 25, 'PPL', 'P'),
(62265, 'West Hill', 33.1022186279297, 0.577742704772373, -89.9147186279297, -1.56930788606165, 218, 30, 'PPL', 'P'),
(114251, 'West Hill', 41.7816696166992, 0.729227701791879, -72.7280578613281, -1.26934406826112, 218, 8, 'PPL', 'P'),
(153637, 'West Hill', 42.815559387207, 0.747272482389928, -74.0127792358398, -1.2917666862171, 218, 40, 'PPL', 'P'),
(158276, 'West Hill', 41.232780456543, 0.719647778718645, -80.5194396972656, -1.40532933457831, 218, 41, 'PPL', 'P'),
(168731, 'West Hill', 40.2030601501465, 0.701675768997382, -77.313606262207, -1.34937698586602, 218, 45, 'PPL', 'P'),
(172747, 'West Hill', 44.8647193908691, 0.783037071354011, -72.6600036621094, -1.26815629841495, 218, 55, 'PPL', 'P'),
(18548, 'West Hills', 29.666109085083, 0.517771279790501, -82.4080581665039, -1.43829194518049, 218, 12, 'PPL', 'P'),
(25917, 'West Hills', 33.5269393920898, 0.585155480508554, -82.0425033569336, -1.43191181015699, 218, 13, 'PPL', 'P'),
(52622, 'West Hills', 39.4472198486328, 0.688483867116702, -77.4336090087891, -1.35147142890531, 218, 25, 'PPL', 'P'),
(91735, 'West Hills', 35.9249992370605, 0.627009520463157, -84.565559387207, -1.47594744509756, 218, 50, 'PPL', 'P'),
(114252, 'West Hills', 41.334171295166, 0.721417382683976, -72.9713897705078, -1.27359101125147, 218, 8, 'PPL', 'P'),
(153638, 'West Hills', 40.8161087036133, 0.712375484729966, -73.4327774047852, -1.2816437445976, 218, 40, 'PPL', 'P'),
(168732, 'West Hills', 40.8241691589355, 0.71251616621455, -79.543327331543, -1.38829295992702, 218, 45, 'PPL', 'P'),
(206387, 'West Hills', 41.2150001525879, 0.719337453872624, -112.005828857422, -1.95487049498729, 218, 52, 'PPL', 'P'),
(168733, 'West Hills Estates', 41.2463912963867, 0.719885332687881, -77.054443359375, -1.34485373991257, 218, 45, 'PPL', 'P'),
(69992, 'West Hillsborough', 36.0744400024414, 0.629617753855754, -79.1197204589844, -1.3808996252668, 218, 33, 'PPL', 'P'),
(91738, 'West Hima', 35.1886100769043, 0.614157105042435, -88.2425003051758, -1.54012217051742, 218, 50, 'PPL', 'P'),
(126531, 'West Hingham', 42.2374992370605, 0.737183429495299, -70.9033279418945, -1.23749652320735, 218, 23, 'PPL', 'P'),
(74769, 'West Holland', 39.5525016784668, 0.690321381689829, -83.2652816772461, -1.45325331786845, 218, 41, 'PPL', 'P'),
(129267, 'West Hollis', 43.6261100769043, 0.761419260679457, -70.6569366455078, -1.23319618383715, 218, 26, 'PPL', 'P'),
(144644, 'West Hollis', 42.7055587768555, 0.74535260956009, -71.6213912963867, -1.25002909298116, 218, 36, 'PPL', 'P'),
(186077, 'West Hollywood', 34.0900001525879, 0.594982744668028, -118.360832214355, -2.06578622754107, 218, 6, 'PPL', 'P'),
(168734, 'West Homestead', 40.3938903808594, 0.705006384835662, -79.9122161865234, -1.39473128502034, 218, 45, 'PPL', 'P'),
(153641, 'West Hoosick', 42.8994407653809, 0.748736488620172, -73.4255599975586, -1.28151777707804, 218, 40, 'PPL', 'P'),
(107413, 'West Hope', 36.9208297729492, 0.644390042106314, -77.3119430541992, -1.34934795741014, 218, 53, 'PPL', 'P'),
(144645, 'West Hopkinton', 43.1919403076172, 0.753841568692772, -71.7486114501953, -1.25224950354001, 218, 36, 'PPL', 'P'),
(194048, 'West Humboldt (historical)', 40.7677803039551, 0.711531995033711, -124.217216491699, -2.16799941544275, 218, 6, 'PPL', 'P'),
(111980, 'West Huntington', 38.4105606079102, 0.670390750144867, -82.48388671875, -1.43961540308421, 218, 58, 'PPL', 'P'),
(6717, 'West Huntsville', 34.7144393920898, 0.605881265375987, -86.6030578613281, -1.51150850197533, 218, 2, 'PPL', 'P'),
(153640, 'West Hurley', 41.9972190856934, 0.732989749726752, -74.1052780151367, -1.2933810944699, 218, 40, 'PPL', 'P'),
(126532, 'West Hyannisport', 41.6361083984375, 0.726687179269997, -70.3208312988281, -1.22733003890403, 218, 23, 'PPL', 'P'),
(158277, 'West Independence', 41.0766716003418, 0.716923165186413, -83.4411087036133, -1.45632207839255, 218, 41, 'PPL', 'P'),
(118400, 'West Iron Hills', 42.142219543457, 0.735520485131627, -90.7916717529297, -1.58461360547855, 218, 16, 'PPL', 'P'),
(38812, 'West Irvine', 37.7013893127441, 0.658013376083587, -83.9908294677734, -1.46591651569372, 218, 21, 'PPL', 'P'),
(107414, 'West Irvington', 37.6591682434082, 0.657276479409962, -76.4308319091797, -1.33396966685353, 218, 53, 'PPL', 'P'),
(133658, 'West Ishpeming', 46.4836082458496, 0.811292012097261, -87.7008285522461, -1.53066821496375, 218, 27, 'PPL', 'P'),
(153642, 'West Islip', 40.7061080932617, 0.710455611900128, -73.3066711425781, -1.2794427751147, 218, 40, 'PPL', 'P'),
(158278, 'West Jackson', 40.4841690063477, 0.706582044094608, -83.3786087036133, -1.45523124761005, 218, 41, 'PPL', 'P'),
(18550, 'West Jacksonville', 30.3400001525879, 0.529532897718241, -81.7225036621094, -1.42632676187693, 218, 12, 'PPL', 'P'),
(172749, 'West Jamaica', 43.0683288574219, 0.751684141893699, -72.851936340332, -1.2715061555921, 218, 55, 'PPL', 'P'),
(6719, 'West Jefferson', 33.649169921875, 0.587288805699762, -87.0686111450195, -1.51963393961922, 218, 2, 'PPL', 'P'),
(69995, 'West Jefferson', 36.4036102294922, 0.635362858117327, -81.4930572509766, -1.42232216654578, 218, 33, 'PPL', 'P'),
(153643, 'West Jefferson', 42.4744415283203, 0.741318852615002, -74.6533279418945, -1.30294637015714, 218, 40, 'PPL', 'P'),
(158279, 'West Jefferson', 41.5719413757324, 0.725567253452592, -84.5566711425781, -1.47579231596406, 218, 41, 'PPL', 'P'),
(107415, 'West Jenningsville', 37.6402816772461, 0.656946846646038, -77.5100021362305, -1.35280474050506, 218, 53, 'PPL', 'P'),
(107416, 'West Jericho', 36.7299995422363, 0.641059426268034, -76.5694427490234, -1.33638888238776, 218, 53, 'PPL', 'P'),
(121924, 'West Jersey', 41.0188903808594, 0.715914692660627, -89.9269409179688, -1.56952120526497, 218, 18, 'PPL', 'P'),
(153644, 'West Jewett', 42.2636108398438, 0.737639162936839, -74.3294372558594, -1.29729341126928, 218, 40, 'PPL', 'P'),
(129268, 'West Jonesport', 44.5288887023926, 0.777175720110856, -67.6216735839844, -1.1802208497494, 218, 26, 'PPL', 'P'),
(168736, 'West Jonestown', 40.4124984741211, 0.705331157330597, -76.4974975585938, -1.33513320193378, 218, 45, 'PPL', 'P'),
(58218, 'West Joplin', 37.084171295166, 0.647240889474217, -94.5197219848633, -1.64968035670553, 218, 29, 'PPL', 'P'),
(206389, 'West Jordan', 40.6097183227539, 0.708773293039525, -111.938331604004, -1.95369244567909, 218, 52, 'PPL', 'P'),
(74771, 'West Junction', 39.2180595397949, 0.684484265212594, -82.7683334350586, -1.44457993483028, 218, 41, 'PPL', 'P'),
(91739, 'West Junction', 35.0661087036133, 0.612019052740292, -90.0966720581055, -1.57248357250352, 218, 50, 'PPL', 'P'),
(111973, 'West Junction', 37.9741706848145, 0.662774309164322, -81.716667175293, -1.42622489596524, 218, 58, 'PPL', 'P'),
(121926, 'West Junction', 42.3147201538086, 0.738531188743961, -89.6588897705078, -1.56484283017802, 218, 18, 'PPL', 'P'),
(193326, 'West Juneau', 58.2949981689453, 1.01743965549216, -134.429443359375, -2.34623639824432, 218, 1, 'PPL', 'P'),
(111974, 'West Junior', 38.9799995422363, 0.680329334437906, -79.9516677856445, -1.39541984532018, 218, 58, 'PPL', 'P'),
(153645, 'West Junius', 42.9505615234375, 0.749628714164376, -76.9738922119141, -1.34344785717312, 218, 40, 'PPL', 'P'),
(18552, 'West Jupiter', 26.9200000762939, 0.469842635968454, -80.1311111450195, -1.39855172276211, 218, 12, 'PPL', 'P'),
(121927, 'West Kankakee', 41.1186103820801, 0.717655135012021, -87.8880615234375, -1.53393604677933, 218, 18, 'PPL', 'P'),
(206390, 'West Kaysville', 41.038890838623, 0.716263766500509, -111.971672058105, -1.95427434637728, 218, 52, 'PPL', 'P'),
(146604, 'West Keansburg', 40.4425010681152, 0.705854801379934, -74.1444396972656, -1.29406459476367, 218, 37, 'PPL', 'P'),
(209139, 'West Kelso', 46.146110534668, 0.805401565819197, -122.921669006348, -2.14538784620743, 218, 56, 'PPL', 'P'),
(153646, 'West Kendall', 43.3358306884766, 0.756352929600717, -78.0761108398438, -1.36268520130731, 218, 40, 'PPL', 'P'),
(177351, 'West Kennebunk', 43.4086112976074, 0.757623190861658, -70.5819396972656, -1.23188724016138, 218, 26, 'PPL', 'P'),
(12752, 'West Kennett', 36.2597198486328, 0.632851497209383, -90.1216735839844, -1.57291993144813, 218, 4, 'PPL', 'P'),
(58216, 'West Keystone', 39.6902809143066, 0.692726082996116, -94.3358306884766, -1.64647084811783, 218, 29, 'PPL', 'P'),
(153647, 'West Kill', 42.2083282470703, 0.736674299673904, -74.3869400024414, -1.29829702352608, 218, 40, 'PPL', 'P'),
(153657, 'West Kilns', 44.4386100769043, 0.77560006085191, -73.9013900756836, -1.28982257862134, 218, 40, 'PPL', 'P'),
(133659, 'West Kinderhook', 41.7819404602051, 0.729232428902813, -85.0541687011719, -1.48447528638216, 218, 27, 'PPL', 'P'),
(62267, 'West King', 31.750560760498, 0.554151824625206, -88.7008285522461, -1.54812150748369, 218, 30, 'PPL', 'P'),
(144655, 'West Kingston', 42.9099998474121, 0.748920779367606, -71.0688934326172, -1.24038618614814, 218, 36, 'PPL', 'P'),
(169666, 'West Kingston', 41.4830589294434, 0.724015962117621, -71.5519409179688, -1.24881695521101, 218, 47, 'PPL', 'P'),
(168737, 'West Kittanning', 40.8102798461914, 0.712273751976325, -79.5297164916992, -1.38805540595779, 218, 45, 'PPL', 'P'),
(201769, 'West Klamath (historical)', 42.1722183227539, 0.736044062601936, -121.816673278809, -2.12610203254141, 218, 43, 'PPL', 'P'),
(91740, 'West Knoxville', 35.9702796936035, 0.627799813516638, -83.9552764892578, -1.46529599915973, 218, 50, 'PPL', 'P'),
(153648, 'West Kortright', 42.4011116027832, 0.740039003974137, -74.8525009155273, -1.30642259432802, 218, 40, 'PPL', 'P'),
(176968, 'West Kraft', 45.4463882446289, 0.793189108008421, -89.7491683959961, -1.56641848943697, 218, 57, 'PPL', 'P'),
(176969, 'West La Crosse', 43.8455581665039, 0.765249352380181, -91.2622222900391, -1.59282626164814, 218, 57, 'PPL', 'P'),
(123990, 'West Lafayette', 40.4258308410645, 0.705563851030843, -86.9080581665039, -1.51683176152024, 218, 19, 'PPL', 'P'),
(158280, 'West Lafayette', 40.2752799987793, 0.702936243141317, -81.751106262207, -1.42682597142327, 218, 41, 'PPL', 'P'),
(18553, 'West Lake', 30.5027809143066, 0.532373957969137, -83.1147232055664, -1.45062557682087, 218, 12, 'PPL', 'P'),
(25918, 'West Lake', 33.6713905334473, 0.587676628533505, -84.79638671875, -1.47997614203658, 218, 13, 'PPL', 'P'),
(91741, 'West Lake Estates', 36.1788902282715, 0.63144075420094, -83.4513931274414, -1.45650157545002, 218, 50, 'PPL', 'P'),
(121928, 'West Lake Forest', 42.2219390869141, 0.736911853643139, -87.8730621337891, -1.53367425804417, 218, 18, 'PPL', 'P'),
(138762, 'West Lake Francis Shores', 45.5077781677246, 0.794260564293987, -93.3372192382813, -1.6290417903638, 218, 28, 'PPL', 'P'),
(6720, 'West Lake Highlands', 33.396671295166, 0.582881873306926, -86.9713897705078, -1.51793710653068, 218, 2, 'PPL', 'P'),
(98998, 'West Lake Hills', 30.297779083252, 0.528796001044616, -97.8016662597656, -1.70696109016956, 218, 51, 'PPL', 'P'),
(209140, 'West Lake Sammamish', 47.5777816772461, 0.830388941062974, -122.099998474121, -2.13104699005347, 218, 56, 'PPL', 'P'),
(209141, 'West Lake Stevens', 47.9936103820801, 0.837646521086631, -122.100563049316, -2.1310568437495, 218, 56, 'PPL', 'P'),
(25919, 'West Lake Village', 33.017219543457, 0.576259190887144, -85.1313934326172, -1.48582311220985, 218, 13, 'PPL', 'P'),
(18554, 'West Lake Wales', 27.8899993896484, 0.486772317728574, -81.6466674804688, -1.42500317081516, 218, 12, 'PPL', 'P'),
(107417, 'West Lakes', 38.5166702270508, 0.672242712366908, -78.021110534668, -1.36172526489239, 218, 53, 'PPL', 'P'),
(168739, 'West Lampeter', 40.0302810668945, 0.698660205116058, -76.2705612182617, -1.33117241560256, 218, 45, 'PPL', 'P'),
(74772, 'West Lancaster', 39.6227798461914, 0.691547967108892, -83.6097183227539, -1.45926487139709, 218, 41, 'PPL', 'P'),
(168740, 'West Lancaster', 40.0366706848145, 0.698771724986705, -76.355827331543, -1.3326605900197, 218, 45, 'PPL', 'P'),
(209931, 'West Lance Creek', 43.0455589294434, 0.751286731680032, -104.692497253418, -1.82722877920726, 218, 59, 'PPL', 'P'),
(107418, 'West Landing', 36.6536102294922, 0.639726181247313, -76.3688888549805, -1.33288855660901, 218, 53, 'PPL', 'P'),
(107420, 'West Langley', 38.9461097717285, 0.6797378463598, -77.1986083984375, -1.34736989451048, 218, 53, 'PPL', 'P'),
(52623, 'West Lanham Hills', 38.9491691589355, 0.679791242739656, -76.878059387207, -1.3417752588505, 218, 25, 'PPL', 'P'),
(193269, 'West Laramie', 41.3088912963867, 0.720976163470377, -105.620002746582, -1.84341680389331, 218, 59, 'PPL', 'P'),
(52624, 'West Laurel', 39.1011085510254, 0.682443085395102, -76.9000015258789, -1.34215822141525, 218, 25, 'PPL', 'P'),
(52625, 'West Laurel Acres', 39.1083297729492, 0.68256911949369, -76.9019393920898, -1.34219204356109, 218, 25, 'PPL', 'P'),
(168742, 'West Laurel Hill', 40.0175018310547, 0.698437165374764, -75.2311096191406, -1.31303056278278, 218, 45, 'PPL', 'P'),
(153649, 'West Laurens', 42.5297203063965, 0.74228364929891, -75.1719436645508, -1.3119979220701, 218, 40, 'PPL', 'P'),
(168744, 'West Lawn', 40.9519386291504, 0.714746164153327, -76.9016723632813, -1.34218738302919, 218, 45, 'PPL', 'P'),
(206391, 'West Layton', 41.0602798461914, 0.716637075106311, -111.998062133789, -1.95473494008781, 218, 52, 'PPL', 'P'),
(118402, 'West Le Mars', 42.7930603027344, 0.746879799287196, -96.225830078125, -1.67945756032787, 218, 16, 'PPL', 'P'),
(58217, 'West Lebanon', 37.6694412231445, 0.657455776730352, -92.6763916015625, -1.61750817231489, 218, 29, 'PPL', 'P'),
(123983, 'West Lebanon', 40.2700004577637, 0.7028440977676, -87.3866729736328, -1.52518516575344, 218, 19, 'PPL', 'P'),
(129269, 'West Lebanon', 43.3822212219238, 0.757162597151128, -70.9511108398438, -1.23833049210271, 218, 26, 'PPL', 'P'),
(144647, 'West Lebanon', 43.649169921875, 0.761821730899195, -72.3108291625977, -1.26206205373446, 218, 36, 'PPL', 'P'),
(153650, 'West Lebanon', 42.4861106872559, 0.741522517859366, -73.466667175293, -1.2822352326757, 218, 40, 'PPL', 'P'),
(158281, 'West Lebanon', 40.7244415283203, 0.710775590705101, -81.6677780151367, -1.42537161915198, 218, 41, 'PPL', 'P'),
(168747, 'West Lebanon', 40.3438911437988, 0.704133733525471, -76.4469375610352, -1.33425076350659, 218, 45, 'PPL', 'P'),
(153651, 'West Lee', 43.309440612793, 0.755892335890188, -75.5500030517578, -1.31859630314494, 218, 40, 'PPL', 'P'),
(168749, 'West Leechburg', 40.6222190856934, 0.70899147251183, -79.6130599975586, -1.38951002454519, 218, 45, 'PPL', 'P'),
(129270, 'West Leeds', 44.292781829834, 0.773054877798122, -70.1688919067383, -1.22467819624858, 218, 26, 'PPL', 'P'),
(62269, 'West Leesburg', 32.4416694641113, 0.566213946992447, -89.789436340332, -1.56712129764864, 218, 30, 'PPL', 'P'),
(168751, 'West Leesport', 40.4391708374023, 0.705796677889143, -75.9730606079102, -1.32598005042524, 218, 45, 'PPL', 'P'),
(107422, 'West Leigh', 38.0680618286133, 0.664413018762075, -78.5783309936523, -1.37145059656114, 218, 53, 'PPL', 'P'),
(158282, 'West Leipsic', 41.1072196960449, 0.717456330036647, -84.0025024414063, -1.46612024751711, 218, 41, 'PPL', 'P'),
(79378, 'West Leisenring', 39.959171295166, 0.697419105469054, -79.6988906860352, -1.39100805265836, 218, 45, 'PPL', 'P'),
(69998, 'West Lenoir', 35.9013900756836, 0.626597462863495, -81.5708312988281, -1.42367957975339, 218, 33, 'PPL', 'P'),
(168752, 'West Lenox', 41.7208290100098, 0.728165832886237, -75.6994400024414, -1.32120446995851, 218, 45, 'PPL', 'P'),
(126533, 'West Leominster', 42.5444412231445, 0.742540577765076, -71.7638931274414, -1.25251621912318, 218, 23, 'PPL', 'P'),
(133660, 'West Leroy', 42.2169418334961, 0.736824635117439, -85.2858276367188, -1.48851849754912, 218, 27, 'PPL', 'P'),
(168753, 'West Leroy', 41.6650009155273, 0.727191448822404, -76.7399978637695, -1.33936563069619, 218, 45, 'PPL', 'P'),
(129271, 'West Levant', 44.9025001525879, 0.783696470039915, -69.0113906860352, -1.20447598885146, 218, 26, 'PPL', 'P'),
(197818, 'West Lewistown', 47.098331451416, 0.822020956022809, -109.464172363281, -1.91051022070984, 218, 31, 'PPL', 'P'),
(107421, 'West Lexington', 37.788890838623, 0.659540565810693, -79.4574966430664, -1.38679493181385, 218, 53, 'PPL', 'P'),
(126534, 'West Leyden', 42.7013893127441, 0.745279838683304, -72.665283203125, -1.26824844378866, 218, 23, 'PPL', 'P'),
(153652, 'West Leyden', 43.4594383239746, 0.758510289820763, -75.4641723632813, -1.31709827503177, 218, 40, 'PPL', 'P'),
(12753, 'West Liberty', 36.2880592346191, 0.633346112802837, -93.7630615234375, -1.63647414033399, 218, 4, 'PPL', 'P'),
(28938, 'West Liberty', 38.853328704834, 0.678118511258977, -88.0844421386719, -1.53736353510226, 218, 18, 'PPL', 'P'),
(38813, 'West Liberty', 37.9213905334473, 0.661853121743264, -83.2597198486328, -1.45315624564672, 218, 21, 'PPL', 'P'),
(52626, 'West Liberty', 39.684440612793, 0.692624150505394, -76.5975036621094, -1.33687863771222, 218, 25, 'PPL', 'P'),
(118403, 'West Liberty', 41.5699996948242, 0.725533364727721, -91.2636108398438, -1.59285049641406, 218, 16, 'PPL', 'P'),
(123985, 'West Liberty', 40.5333290100098, 0.707440048018804, -84.9961090087891, -1.48346195358738, 218, 19, 'PPL', 'P'),
(158285, 'West Liberty', 40.3777809143066, 0.704725221603577, -82.8908309936523, -1.4467179205534, 218, 41, 'PPL', 'P'),
(168756, 'West Liberty', 41.0788917541504, 0.716961914180273, -78.7872161865234, -1.37509633093541, 218, 45, 'PPL', 'P'),
(177300, 'West Liberty', 40.1697196960449, 0.7010938682992, -80.5938873291016, -1.40662869087416, 218, 58, 'PPL', 'P'),
(139520, 'West Liberty (historical)', 40.4869384765625, 0.706630380468393, -93.1308288574219, -1.62543959867336, 218, 29, 'PPL', 'P'),
(168758, 'West Library', 40.2947196960449, 0.703275529864193, -80.0261077880859, -1.39671906845798, 218, 45, 'PPL', 'P'),
(176970, 'West Lima', 43.5463905334473, 0.760027892167945, -90.5302810668945, -1.58005147737319, 218, 57, 'PPL', 'P'),
(62270, 'West Lincoln', 31.4927806854248, 0.549652713569139, -90.5691680908203, -1.580730183977, 218, 30, 'PPL', 'P'),
(143352, 'West Lincoln', 40.8377799987793, 0.712753720183785, -96.730827331543, -1.68827142511355, 218, 35, 'PPL', 'P'),
(172750, 'West Lincoln', 44.1188888549805, 0.77001987284084, -73.0205612182617, -1.27444921491275, 218, 55, 'PPL', 'P'),
(58219, 'West Line', 38.6322212219238, 0.674259457681398, -94.5838928222656, -1.65080034910197, 218, 29, 'PPL', 'P'),
(201770, 'West Linn', 45.3658294677734, 0.791783092110913, -122.611106872559, -2.13996751444079, 218, 43, 'PPL', 'P'),
(18555, 'West Little River', 25.8566703796387, 0.451284031727587, -80.2372207641602, -1.40040368498416, 218, 12, 'PPL', 'P'),
(98999, 'West Livingston', 30.6980590820313, 0.535782204953193, -95.0016708374023, -1.65809195100855, 218, 51, 'PPL', 'P'),
(211305, 'West Loch Estates', 21.374719619751, 0.373059234055285, -158.027221679688, -2.75809532608951, 218, 15, 'PPL', 'P'),
(158286, 'West Lodi', 41.1641693115234, 0.718450288334491, -82.9383316040039, -1.44754696260074, 218, 41, 'PPL', 'P'),
(74773, 'West Logan', 39.538890838623, 0.690083827720594, -82.4286117553711, -1.43865067297933, 218, 41, 'PPL', 'P'),
(111975, 'West Logan', 37.8666687011719, 0.660898045597334, -81.9866714477539, -1.43093735951413, 218, 58, 'PPL', 'P'),
(146605, 'West Long Branch', 40.2902793884277, 0.703198031876471, -74.0180587768555, -1.29185883159081, 218, 37, 'PPL', 'P'),
(209142, 'West Longview', 46.1680603027344, 0.805784661542005, -122.997779846191, -2.14671623095916, 218, 56, 'PPL', 'P'),
(186078, 'West Los Angeles', 34.0463905334473, 0.594221613228483, -118.447219848633, -2.06729397619222, 218, 6, 'PPL', 'P'),
(38814, 'West Louisville', 37.6966705322266, 0.657931017826877, -87.2869415283203, -1.52344452366496, 218, 21, 'PPL', 'P'),
(153653, 'West Lowville', 43.7933311462402, 0.764337818918074, -75.5480575561523, -1.31856234784104, 218, 40, 'PPL', 'P'),
(129272, 'West Lubec', 44.8147201538086, 0.78216442004382, -67.070556640625, -1.17060204452425, 218, 26, 'PPL', 'P'),
(107425, 'West Lynchburg', 37.4030609130859, 0.652806563257346, -79.1783294677734, -1.3819225454415, 218, 53, 'PPL', 'P'),
(126535, 'West Lynn', 42.4652786254883, 0.741158929791543, -70.9819412231445, -1.23886858380096, 218, 23, 'PPL', 'P'),
(138764, 'West Lynn', 44.8491706848145, 0.782765695238932, -94.4783325195313, -1.64895797425985, 218, 28, 'PPL', 'P'),
(25920, 'West Lynne', 33.5097198486328, 0.584854942779538, -82.1208267211914, -1.43327881074453, 218, 13, 'PPL', 'P'),
(52627, 'West Magothy Manor', 39.0661087036133, 0.681832222820065, -76.5027770996094, -1.3352253473075, 218, 25, 'PPL', 'P'),
(153654, 'West Mahopac', 41.3708305358887, 0.722057207135867, -73.7905578613281, -1.28788819156356, 218, 40, 'PPL', 'P'),
(146607, 'West Mahwah', 41.1027793884277, 0.717378832048925, -74.1519393920898, -1.29419548913125, 218, 37, 'PPL', 'P'),
(168762, 'West Manayunk', 40.026668548584, 0.69859715477725, -75.2388916015625, -1.31316638399838, 218, 45, 'PPL', 'P'),
(74774, 'West Manchester', 39.9025001525879, 0.696430007440198, -84.6263885498047, -1.47700911426612, 218, 41, 'PPL', 'P'),
(126536, 'West Manchester', 42.5666694641113, 0.742928533756873, -70.783332824707, -1.23540221332612, 218, 23, 'PPL', 'P'),
(79380, 'West Manheim', 39.7224998474121, 0.693288409460286, -76.9180603027344, -1.34247340653026, 218, 45, 'PPL', 'P'),
(126537, 'West Mansfield', 41.9980583190918, 0.733004397112747, -71.2458267211914, -1.24347425459015, 218, 23, 'PPL', 'P'),
(158288, 'West Mansfield', 40.4019393920898, 0.705146866583164, -83.545280456543, -1.45814021846875, 218, 41, 'PPL', 'P'),
(186079, 'West Manteca', 37.7972183227539, 0.659685907827184, -121.250831604004, -2.11622623227107, 218, 6, 'PPL', 'P'),
(146608, 'West Mantoloking', 40.0441703796387, 0.698902619354283, -74.0736083984375, -1.29282835538566, 218, 37, 'PPL', 'P'),
(186080, 'West March', 33.9033317565918, 0.59172476654848, -117.27693939209, -2.0468687290538, 218, 6, 'PPL', 'P'),
(12755, 'West Marche', 34.8802795410156, 0.608775722006739, -92.4077835083008, -1.61282007668997, 218, 4, 'PPL', 'P'),
(74775, 'West Marietta', 39.413330078125, 0.687892379038595, -81.4713897705078, -1.42194399767099, 218, 41, 'PPL', 'P'),
(69999, 'West Marion', 35.6577796936035, 0.622345659604156, -82.0255584716797, -1.43161606611794, 218, 33, 'PPL', 'P'),
(84288, 'West Marion', 34.1891708374023, 0.596713599639498, -79.4233322143555, -1.38619865004578, 218, 48, 'PPL', 'P'),
(112904, 'West Marks', 34.264720916748, 0.598032197274223, -90.3052825927734, -1.57612451318782, 218, 30, 'PPL', 'P'),
(153655, 'West Martinsburg', 43.7594413757324, 0.763746330839968, -75.5177764892578, -1.31803384352271, 218, 40, 'PPL', 'P'),
(91742, 'West Maryville', 35.7563896179199, 0.62406672745862, -83.9791717529297, -1.46571305018644, 218, 50, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(158289, 'West Massillon', 40.7936096191406, 0.711982801627234, -81.5341720581055, -1.4230397553015, 218, 41, 'PPL', 'P'),
(168763, 'West Mayfield', 40.7799987792969, 0.711745247657999, -80.3386077880859, -1.40217322237046, 218, 45, 'PPL', 'P'),
(107423, 'West McLean', 38.9319381713867, 0.679490505273559, -77.184440612793, -1.34712262000327, 218, 53, 'PPL', 'P'),
(91745, 'West Meade', 35.601390838623, 0.621361488423317, -87.0599975585938, -1.51948360417569, 218, 50, 'PPL', 'P'),
(14827, 'West Meadow', 39.7055587768555, 0.69299273200026, -75.7333297729492, -1.32179595803661, 218, 10, 'PPL', 'P'),
(126538, 'West Meadow', 42.0333290100098, 0.733619986798719, -71.029167175293, -1.23969283215834, 218, 23, 'PPL', 'P'),
(158290, 'West Mecca', 41.3902816772461, 0.722396693595825, -80.7766723632813, -1.40981889154397, 218, 41, 'PPL', 'P'),
(153656, 'West Mecox Village', 40.9172210693359, 0.714140228426307, -72.32861328125, -1.26237244515951, 218, 40, 'PPL', 'P'),
(126539, 'West Medford', 42.4222183227539, 0.740407385731922, -71.1333312988281, -1.24151083907649, 218, 23, 'PPL', 'P'),
(126540, 'West Medway', 42.1416702270508, 0.735510897751703, -71.4250030517578, -1.24660147150017, 218, 23, 'PPL', 'P'),
(18556, 'West Melbourne', 28.0713901519775, 0.489938183763919, -80.6536102294922, -1.40767105212482, 218, 12, 'PPL', 'P'),
(31492, 'West Melcher', 39.788890838623, 0.69444715085058, -87.3472213745117, -1.5244966054536, 218, 19, 'PPL', 'P'),
(12754, 'West Memphis', 35.1463890075684, 0.61342020836881, -90.184440612793, -1.57401542276253, 218, 4, 'PPL', 'P'),
(186081, 'West Menlo Park', 37.4336090087891, 0.65333972810758, -122.201942443848, -2.13282624797775, 218, 6, 'PPL', 'P'),
(158291, 'West Mentor', 41.6622200012207, 0.727142912711537, -81.3402786254883, -1.41965567650434, 218, 41, 'PPL', 'P'),
(206393, 'West Mercur', 40.3147201538086, 0.703624603704075, -112.277496337891, -1.95961198699207, 218, 52, 'PPL', 'P'),
(153660, 'West Meredith', 42.3463897705078, 0.739083927828207, -75.023063659668, -1.30939947579451, 218, 40, 'PPL', 'P'),
(179493, 'West Mesa Trailer Court', 33.4141693115234, 0.583187271304931, -111.849166870117, -1.95213622749611, 218, 5, 'PPL', 'P'),
(79383, 'West Meyersdale', 39.8144416809082, 0.694893097175114, -79.0350036621094, -1.37942103822958, 218, 45, 'PPL', 'P'),
(18557, 'West Miami', 25.7630596160889, 0.449650215688337, -80.29638671875, -1.40143632569683, 218, 12, 'PPL', 'P'),
(153658, 'West Middleburgh', 42.5955581665039, 0.743432736730252, -74.3536071777344, -1.29771525598595, 218, 40, 'PPL', 'P'),
(153659, 'West Middlebury', 42.8624992370605, 0.748091737320264, -78.1516723632813, -1.36400399867912, 218, 40, 'PPL', 'P'),
(168766, 'West Middlesex', 41.1741714477539, 0.718624858543946, -80.45361328125, -1.40418044688405, 218, 45, 'PPL', 'P'),
(123986, 'West Middleton', 40.4394416809082, 0.705801405000078, -86.2161102294922, -1.504754991767, 218, 19, 'PPL', 'P'),
(176972, 'West Middleton', 43.0602798461914, 0.751543660146198, -89.5716705322266, -1.56332056729894, 218, 57, 'PPL', 'P'),
(74776, 'West Middletown', 39.523609161377, 0.689817112137423, -84.4180603027344, -1.47337310042984, 218, 41, 'PPL', 'P'),
(168768, 'West Middletown', 40.2427787780762, 0.70236898982913, -80.4274978637695, -1.40372464686348, 218, 45, 'PPL', 'P'),
(168769, 'West Middletown (historical)', 40.2622184753418, 0.702708276552006, -80.4288864135742, -1.4037488816294, 218, 45, 'PPL', 'P'),
(52628, 'West Middletown Estates', 39.4480590820313, 0.688498514502697, -77.5725021362305, -1.35389557128756, 218, 25, 'PPL', 'P'),
(99000, 'West Midway', 33.1372184753418, 0.57835356734741, -95.0947189331055, -1.65971594664128, 218, 51, 'PPL', 'P'),
(168771, 'West Mifflin', 40.3633308410645, 0.704473020248347, -79.8666687011719, -1.39393633143495, 218, 45, 'PPL', 'P'),
(144648, 'West Milan', 44.5986099243164, 0.77839258499194, -71.3047180175781, -1.24450210161286, 218, 36, 'PPL', 'P'),
(112663, 'West Milford', 39.2008285522461, 0.684183527746496, -80.4044418334961, -1.40332224322277, 218, 58, 'PPL', 'P'),
(146609, 'West Milford', 41.1311111450195, 0.717873314484326, -74.3677825927734, -1.29796266365122, 218, 37, 'PPL', 'P'),
(91746, 'West Mill', 35.9338912963867, 0.627164716175682, -85.1841735839844, -1.48674429963091, 218, 50, 'PPL', 'P'),
(126541, 'West Millbury', 42.1711082458496, 0.736024688105006, -71.8041687011719, -1.25321916049291, 218, 23, 'PPL', 'P'),
(168774, 'West Millcreek', 42.0744400024414, 0.734337508975414, -80.1650009155273, -1.39914321084022, 218, 45, 'PPL', 'P'),
(91747, 'West Millers Cove', 35.7102813720703, 0.623261986756225, -83.8291702270508, -1.46309502967684, 218, 50, 'PPL', 'P'),
(158292, 'West Millgrove', 41.2438888549805, 0.719841656846003, -83.4913864135742, -1.45719958997173, 218, 41, 'PPL', 'P'),
(129273, 'West Mills', 44.7638893127441, 0.781277254505687, -70.0166702270508, -1.22202142674512, 218, 26, 'PPL', 'P'),
(74777, 'West Milton', 39.9625015258789, 0.697477228959845, -84.3280563354492, -1.47180223486085, 218, 41, 'PPL', 'P'),
(153661, 'West Milton', 43.0374984741211, 0.751146050195449, -73.9297180175781, -1.29031699447771, 218, 40, 'PPL', 'P'),
(168773, 'West Milton', 41.0200004577637, 0.715934067157557, -76.871940612793, -1.34166846609078, 218, 45, 'PPL', 'P'),
(172751, 'West Milton', 44.6305618286133, 0.778950250924203, -73.1722183227539, -1.27709613072018, 218, 55, 'PPL', 'P'),
(176973, 'West Milwaukee', 43.0125007629395, 0.750709757829866, -87.9725036621094, -1.53540984012658, 218, 57, 'PPL', 'P'),
(99002, 'West Mineola', 32.6713905334473, 0.570223336013561, -95.5188903808594, -1.66711913499754, 218, 51, 'PPL', 'P'),
(34387, 'West Mineral', 37.2841682434082, 0.650731494714984, -94.9227828979492, -1.65671509672498, 218, 20, 'PPL', 'P'),
(129274, 'West Minot', 44.1711082458496, 0.770931273144893, -70.3663864135742, -1.22812512564747, 218, 26, 'PPL', 'P'),
(14828, 'West Minquadale', 39.7125015258789, 0.693113905829859, -75.567497253418, -1.31890163456392, 218, 10, 'PPL', 'P'),
(44080, 'West Monroe', 32.5183296203613, 0.567551919124103, -92.1474990844727, -1.60827725650251, 218, 22, 'PPL', 'P'),
(133663, 'West Monroe', 41.913890838623, 0.731535397455459, -83.4316711425781, -1.45615736187913, 218, 27, 'PPL', 'P'),
(153662, 'West Monroe', 43.2808303833008, 0.755392993185798, -76.0669403076172, -1.32761856028591, 218, 40, 'PPL', 'P'),
(6721, 'West Monroeville', 31.5155601501465, 0.550050290230375, -87.3536071777344, -1.52460805874522, 218, 2, 'PPL', 'P'),
(168798, 'West Monterey', 41.0486106872559, 0.716433409861947, -79.6616668701172, -1.39035837451043, 218, 45, 'PPL', 'P'),
(111978, 'West Montgomery', 38.1786117553711, 0.666342478971838, -81.3349990844727, -1.41956353113062, 218, 58, 'PPL', 'P'),
(129275, 'West Montville', 44.4799995422363, 0.776322443297594, -69.2988891601563, -1.20949378381933, 218, 26, 'PPL', 'P'),
(71546, 'West Moorestown', 39.9602813720703, 0.697438479965984, -74.9558334350586, -1.30822608701822, 218, 37, 'PPL', 'P'),
(114257, 'West Morris', 41.6886100769043, 0.727603506422067, -73.2627792358398, -1.27867671682714, 218, 8, 'PPL', 'P'),
(168775, 'West Moshannon', 40.8269386291504, 0.712564502588334, -78.3641662597656, -1.36771271681316, 218, 45, 'PPL', 'P'),
(129276, 'West Mount Vernon', 44.4530601501465, 0.775852262207141, -70.0158309936523, -1.22200677935913, 218, 26, 'PPL', 'P'),
(153664, 'West Mount Vernon', 40.9122200012207, 0.71405294332158, -73.8483276367188, -1.28889646435227, 218, 40, 'PPL', 'P'),
(99001, 'West Mountain', 32.6107788085938, 0.569165461849555, -94.9153594970703, -1.65658553393795, 218, 51, 'PPL', 'P'),
(206394, 'West Mountain', 40.0608291625977, 0.699193369966292, -111.787498474121, -1.95105991094155, 218, 52, 'PPL', 'P'),
(123987, 'West Muncie', 40.1708297729492, 0.70111324279613, -85.4813919067383, -1.49193173796022, 218, 19, 'PPL', 'P'),
(107424, 'West Munden', 36.8069381713867, 0.642402258668679, -76.2566680908203, -1.33092993478531, 218, 53, 'PPL', 'P'),
(77652, 'West Muskogee', 35.7369384765625, 0.623727240998662, -95.4116668701172, -1.66524773169954, 218, 42, 'PPL', 'P'),
(91748, 'West Myers', 35.9363899230957, 0.627208325438532, -83.0819396972656, -1.45005339666067, 218, 50, 'PPL', 'P'),
(114253, 'West Mystic', 41.3505592346191, 0.72170340618505, -71.9824981689453, -1.25633159685889, 218, 8, 'PPL', 'P'),
(168777, 'West Nanticoke', 41.2216682434082, 0.71945383401226, -76.0155563354492, -1.32672174078882, 218, 45, 'PPL', 'P'),
(91749, 'West Nashville', 36.1588897705078, 0.631091680361058, -86.8463897705078, -1.51575544496568, 218, 50, 'PPL', 'P'),
(126542, 'West Natick', 42.2777786254883, 0.737886437444053, -71.3791732788086, -1.24580159106677, 218, 23, 'PPL', 'P'),
(126543, 'West New Boston', 42.1019401550293, 0.734817477182873, -73.095832824707, -1.27576295227848, 218, 23, 'PPL', 'P'),
(153665, 'West New Brighton', 40.6344413757324, 0.709204791715145, -74.1125030517578, -1.29350719514752, 218, 40, 'PPL', 'P'),
(168779, 'West New Castle', 41.0038909912109, 0.715652903925472, -80.3647232055664, -1.40262902239103, 218, 45, 'PPL', 'P'),
(31493, 'West New Goshen', 39.5708312988281, 0.690641293915775, -87.4805603027344, -1.52682380877216, 218, 19, 'PPL', 'P'),
(99003, 'West New Hope', 33.2172203063965, 0.579749862706938, -95.0919418334961, -1.65966747710944, 218, 51, 'PPL', 'P'),
(168780, 'West New Kensington', 40.5636100769043, 0.70796855233713, -79.7744369506836, -1.39232658371405, 218, 45, 'PPL', 'P'),
(146611, 'West New York', 40.7877807617188, 0.711881068873593, -74.0147171020508, -1.29180050836294, 218, 37, 'PPL', 'P'),
(153666, 'West Newark', 42.2430610656738, 0.737280501717033, -76.2366714477539, -1.33058092752446, 218, 40, 'PPL', 'P'),
(126544, 'West Newbury', 42.8013916015625, 0.747025207882715, -70.9902801513672, -1.23901412555454, 218, 23, 'PPL', 'P'),
(172752, 'West Newbury', 44.0644416809082, 0.769069590384873, -72.1252822875977, -1.25882364984893, 218, 55, 'PPL', 'P'),
(121931, 'West Newell', 40.2033309936523, 0.701680496108317, -87.6152801513672, -1.52917511369859, 218, 18, 'PPL', 'P'),
(129277, 'West Newfield', 43.6438903808594, 0.761729585525478, -70.9241714477539, -1.23786031101226, 218, 26, 'PPL', 'P'),
(25921, 'West Newnan', 33.3855590820313, 0.582687928600541, -84.8280563354492, -1.48052888112082, 218, 13, 'PPL', 'P'),
(31494, 'West Newton', 39.6530609130859, 0.692076471427219, -86.2827835083008, -1.50591866000531, 218, 19, 'PPL', 'P'),
(126545, 'West Newton', 42.3499984741211, 0.739146911587988, -71.2333297729492, -1.24325614169687, 218, 23, 'PPL', 'P'),
(138765, 'West Newton', 44.2649993896484, 0.772569982742646, -91.9005584716797, -1.60396732975238, 218, 28, 'PPL', 'P'),
(158293, 'West Newton', 40.6538887023926, 0.709544211596076, -83.8927764892578, -1.46420516837724, 218, 41, 'PPL', 'P'),
(168781, 'West Newton', 40.2097206115723, 0.701792015978964, -79.767219543457, -1.39220061619449, 218, 45, 'PPL', 'P'),
(168783, 'West Nicholson', 41.6377792358398, 0.726716340883934, -75.8649978637695, -1.32409399974124, 218, 45, 'PPL', 'P'),
(123988, 'West Noblesville', 40.0480613708496, 0.69897052996208, -86.0208282470703, -1.50134667820392, 218, 19, 'PPL', 'P'),
(107432, 'West Norfolk', 36.8638916015625, 0.643396283545551, -76.3497161865234, -1.33255393041804, 218, 53, 'PPL', 'P'),
(114254, 'West Norfolk', 42.003059387207, 0.733091682217474, -73.2247161865234, -1.27801239129322, 218, 8, 'PPL', 'P'),
(168784, 'West Norriton', 40.1294403076172, 0.700390860350446, -75.3788909912109, -1.31560983429852, 218, 45, 'PPL', 'P'),
(126546, 'West Northfield', 42.726390838623, 0.745716197627913, -72.4647216796875, -1.26474798485186, 218, 23, 'PPL', 'P'),
(114255, 'West Norwalk', 41.1083297729492, 0.717475704533577, -73.4627838134766, -1.28216745522596, 218, 8, 'PPL', 'P'),
(172753, 'West Norwich', 43.7633285522461, 0.763814174868738, -72.3733291625977, -1.26315288451696, 218, 55, 'PPL', 'P'),
(146613, 'West Norwood', 41.0044403076172, 0.715662491305396, -73.9674987792969, -1.29097639316362, 218, 37, 'PPL', 'P'),
(153667, 'West Notch', 42.125560760498, 0.735229734519617, -78.1555633544922, -1.36407190928691, 218, 40, 'PPL', 'P'),
(52629, 'West Nottingham', 39.6694412231445, 0.692362361770239, -76.0766677856445, -1.3277883368054, 218, 25, 'PPL', 'P'),
(144649, 'West Nottingham', 43.1736106872559, 0.753521656466827, -71.1408309936523, -1.24164173344406, 218, 36, 'PPL', 'P'),
(153668, 'West Nyack', 41.0963897705078, 0.717267312178278, -73.9733276367188, -1.29107812591726, 218, 40, 'PPL', 'P'),
(143358, 'West O Trailer Park', 40.8141708374023, 0.712341662584122, -96.7425003051758, -1.68847515693694, 218, 35, 'PPL', 'P'),
(99004, 'West Oakland', 30.0533294677734, 0.524529550399282, -94.121940612793, -1.64273776205981, 218, 51, 'PPL', 'P'),
(186082, 'West Oakland', 37.811939239502, 0.65994283629335, -122.293891906738, -2.13443106885063, 218, 6, 'PPL', 'P'),
(70000, 'West Oaks', 36.0750007629395, 0.62962754097276, -80.3036117553711, -1.40156242637445, 218, 33, 'PPL', 'P'),
(84289, 'West Oaks', 32.9472198486328, 0.57503746573707, -80.2227783203125, -1.40015161678698, 218, 48, 'PPL', 'P'),
(52630, 'West Ocean City', 38.3313903808594, 0.669008969013279, -75.1072235107422, -1.31086834229375, 218, 25, 'PPL', 'P'),
(192412, 'West Odessa', 31.8422203063965, 0.555751585492016, -102.498329162598, -1.78893332168025, 218, 51, 'PPL', 'P'),
(206395, 'West Ogden', 41.2230606079102, 0.719478135357207, -111.990562438965, -1.95460404572023, 218, 52, 'PPL', 'P'),
(118406, 'West Okoboji', 43.353328704834, 0.756658327598722, -95.1622161865234, -1.66089399594948, 218, 16, 'PPL', 'P'),
(129278, 'West Old Town', 44.9847183227539, 0.785131447814277, -68.7805633544922, -1.20044729191244, 218, 26, 'PPL', 'P'),
(133661, 'West Olive', 42.9213905334473, 0.74911958434298, -86.1463928222656, -1.50353819346495, 218, 27, 'PPL', 'P'),
(91751, 'West Oneida', 36.5036087036133, 0.637108160737711, -84.5308303833008, -1.47534130963346, 218, 50, 'PPL', 'P'),
(153669, 'West Oneonta', 42.4722213745117, 0.741280103621141, -75.1175003051758, -1.31104770619316, 218, 40, 'PPL', 'P'),
(70001, 'West Onslow Beach', 34.4477806091309, 0.601227191633991, -77.5077819824219, -1.3527659915112, 218, 33, 'PPL', 'P'),
(126547, 'West Opening', 41.3466682434082, 0.721635495577253, -70.4958267211914, -1.23038428520019, 218, 23, 'PPL', 'P'),
(99006, 'West Orange', 30.0819396972656, 0.525028893103671, -93.758056640625, -1.63638678865024, 218, 51, 'PPL', 'P'),
(126548, 'West Orange', 42.5986099243164, 0.743485999952054, -72.3424987792969, -1.26261479281871, 218, 23, 'PPL', 'P'),
(146614, 'West Orange', 40.7986106872559, 0.712070086731961, -74.2394409179688, -1.29572267885836, 218, 37, 'PPL', 'P'),
(99005, 'West Orange Estates Colonia', 27.9589996337891, 0.487976599173508, -97.9800033569336, -1.71007365969359, 218, 51, 'PPL', 'P'),
(146616, 'West Osbornsville', 40.0436096191406, 0.698892832237277, -74.1202774047852, -1.29364288320506, 218, 37, 'PPL', 'P'),
(144650, 'West Ossipee', 43.8247184753418, 0.764885631154304, -71.2052764892578, -1.24276651953046, 218, 36, 'PPL', 'P'),
(12757, 'West Otis', 33.9530601501465, 0.592592690747736, -94.4361114501953, -1.64822107758623, 218, 4, 'PPL', 'P'),
(126549, 'West Otis', 42.1833305358887, 0.736238007308321, -73.147216796875, -1.27665977177557, 218, 23, 'PPL', 'P'),
(13247, 'West Over View', 38.8680610656738, 0.678375639462224, -76.9638900756836, -1.34327328696367, 218, 9, 'PPL', 'P'),
(31495, 'West Overlook', 39.1713905334473, 0.683669737393193, -86.2547225952148, -1.50542890468085, 218, 19, 'PPL', 'P'),
(168787, 'West Overton', 40.1175003051758, 0.700182467995147, -79.5644378662109, -1.38866140826383, 218, 45, 'PPL', 'P'),
(126550, 'West Oxford', 42.1022186279297, 0.734822337451863, -71.8880615234375, -1.25468336646024, 218, 23, 'PPL', 'P'),
(38815, 'West Paducah', 37.0830612182617, 0.647221514977287, -88.7441711425781, -1.54887797839133, 218, 21, 'PPL', 'P'),
(18558, 'West Palm Beach', 26.7150001525879, 0.466264712333446, -80.0536117553711, -1.39719910324446, 218, 12, 'PPL', 'P'),
(18559, 'West Palm Beach Farms', 26.6786098480225, 0.465629581702976, -80.1294403076172, -1.39852256114818, 218, 12, 'PPL', 'P'),
(129279, 'West Palmyra', 44.832218170166, 0.782469818041824, -69.4088897705078, -1.21141365664917, 218, 26, 'PPL', 'P'),
(12758, 'West Pangburn', 35.4316711425781, 0.618399320921849, -91.8866729736328, -1.60372498209318, 218, 4, 'PPL', 'P'),
(129280, 'West Paris', 44.3241691589355, 0.773602690034351, -70.5744400024414, -1.2317563457938, 218, 26, 'PPL', 'P'),
(126552, 'West Parish', 42.6624984741211, 0.74460106550047, -71.1875, -1.24245626126346, 218, 23, 'PPL', 'P'),
(153670, 'West Parishville', 44.6150016784668, 0.778678675072042, -74.9463882446289, -1.30806123734675, 218, 40, 'PPL', 'P'),
(14829, 'West Park', 39.7555618286133, 0.693865449889479, -75.5991668701172, -1.31945437364816, 218, 10, 'PPL', 'P'),
(18562, 'West Park', 28.0113906860352, 0.488890995533787, -82.5163879394531, -1.4401826563964, 218, 12, 'PPL', 'P'),
(107426, 'West Park', 37.2972183227539, 0.650959261567213, -80.004997253418, -1.39635062012116, 218, 53, 'PPL', 'P'),
(153671, 'West Park', 41.7944412231445, 0.729450608375118, -73.9599990844727, -1.29084549879604, 218, 40, 'PPL', 'P'),
(158295, 'West Park', 40.7830581665039, 0.711798644037855, -81.5299987792969, -1.42296691784569, 218, 41, 'PPL', 'P'),
(168788, 'West Park', 40.4741706848145, 0.70640754046418, -80.0777816772461, -1.39762094796113, 218, 45, 'PPL', 'P'),
(186083, 'West Park', 36.7102813720703, 0.640715279276168, -119.850280761719, -2.09178200873161, 218, 6, 'PPL', 'P'),
(209143, 'West Park', 47.5633316040039, 0.830136739707744, -122.677223205566, -2.14112146214113, 218, 56, 'PPL', 'P'),
(118407, 'West Park Mobile Home Village', 41.9625015258789, 0.732383813999731, -91.720832824707, -1.60083052546243, 218, 16, 'PPL', 'P'),
(143361, 'West Park Plaza Mobile Home Park', 40.8875007629395, 0.713621511224987, -98.4319381713867, -1.71796141021018, 218, 35, 'PPL', 'P'),
(70002, 'West Parkland', 35.7422218322754, 0.623819452951406, -78.6488876342773, -1.37268204224919, 218, 33, 'PPL', 'P'),
(209144, 'West Pasco', 46.2455596923828, 0.807137281059656, -119.181671142578, -2.0801125694671, 218, 56, 'PPL', 'P'),
(146617, 'West Paterson', 40.889720916748, 0.713660260218848, -74.1952819824219, -1.29495196003889, 218, 37, 'PPL', 'P'),
(153672, 'West Patterson', 41.5099983215332, 0.724486143208074, -73.6311111450195, -1.28510532138248, 218, 40, 'PPL', 'P'),
(172754, 'West Pawlet', 43.3536109924316, 0.756663254446739, -73.2525024414063, -1.27849735292772, 218, 55, 'PPL', 'P'),
(153673, 'West Pawling', 41.5869407653809, 0.725829042187747, -73.6605606079102, -1.28561931147287, 218, 40, 'PPL', 'P'),
(111979, 'West Pea Ridge', 38.4091682434082, 0.67036644879992, -82.3438873291016, -1.43717195278406, 218, 58, 'PPL', 'P'),
(126553, 'West Peabody', 42.5458297729492, 0.742564812530995, -70.9944381713867, -1.23908669669424, 218, 23, 'PPL', 'P'),
(99007, 'West Pearsall', 28.8983306884766, 0.504371018844036, -99.107780456543, -1.72975708331036, 218, 51, 'PPL', 'P'),
(126554, 'West Pelham', 42.3777809143066, 0.739631806643464, -72.470832824707, -1.26485464445352, 218, 23, 'PPL', 'P'),
(84290, 'West Pelzer', 34.644718170166, 0.604664400494902, -82.4702835083008, -1.43937798227303, 218, 48, 'PPL', 'P'),
(129282, 'West Pembroke', 44.9474983215332, 0.784481836245379, -67.1786117553711, -1.17248796205019, 218, 26, 'PPL', 'P'),
(168789, 'West Pen Argyl', 40.8572196960449, 0.713093006906661, -75.2708282470703, -1.31372378361453, 218, 45, 'PPL', 'P'),
(168790, 'West Penn', 40.7408294677734, 0.711061614206176, -75.9613876342773, -1.32577631860185, 218, 45, 'PPL', 'P'),
(129283, 'West Penobscot', 44.4741706848145, 0.776220710543953, -68.7797164916992, -1.20043251136839, 218, 26, 'PPL', 'P'),
(18563, 'West Pensacola', 30.4263896942139, 0.531040679658903, -87.2797164916992, -1.52331842298735, 218, 12, 'PPL', 'P'),
(121932, 'West Peoria', 40.6925010681152, 0.71021812450992, -89.6277770996094, -1.56429981163176, 218, 18, 'PPL', 'P'),
(18565, 'West Perrine', 25.6055603027344, 0.446901334100671, -80.3630599975586, -1.40259999393514, 218, 12, 'PPL', 'P'),
(153674, 'West Perry', 42.7200012207031, 0.745604677757266, -78.0330581665039, -1.36193379040574, 218, 40, 'PPL', 'P'),
(153675, 'West Perry Center', 42.7438888549805, 0.746021595625918, -78.0747222900391, -1.36266096654139, 218, 40, 'PPL', 'P'),
(153676, 'West Perrysburg', 42.4797210693359, 0.741410997988719, -79.0469436645508, -1.37962943058488, 218, 40, 'PPL', 'P'),
(179494, 'West Pershing Plaza', 31.5550003051758, 0.550738650793133, -110.348609924316, -1.92594656817821, 218, 5, 'PPL', 'P'),
(153677, 'West Perth', 43.0125007629395, 0.750709757829866, -74.2702789306641, -1.29626090371466, 218, 40, 'PPL', 'P'),
(129284, 'West Peru', 44.521110534668, 0.777039965474289, -70.4677810668945, -1.22989479619183, 218, 26, 'PPL', 'P'),
(144651, 'West Peterborough', 42.8872184753418, 0.748523169416857, -71.9858322143555, -1.2563897869287, 218, 36, 'PPL', 'P'),
(31496, 'West Petersburg', 38.4874992370605, 0.671733582545512, -87.2891693115234, -1.52348340581688, 218, 19, 'PPL', 'P'),
(107429, 'West Petersburg', 37.2069396972656, 0.649383602308267, -77.4638900756836, -1.35199993322364, 218, 53, 'PPL', 'P'),
(70003, 'West Philadelphia', 35.3822212219238, 0.617536256991582, -79.6586074829102, -1.39030497813058, 218, 33, 'PPL', 'P'),
(153678, 'West Phoenix', 43.2255592346191, 0.754428329659944, -76.3050003051758, -1.3317734910606, 218, 40, 'PPL', 'P'),
(153679, 'West Pierrepont', 44.4925003051758, 0.776540622769899, -75.0599975585938, -1.31004409393637, 218, 40, 'PPL', 'P'),
(168794, 'West Pike', 41.7761116027832, 0.729130696149172, -77.7141723632813, -1.35636818320164, 218, 45, 'PPL', 'P'),
(168796, 'West Pikeland', 40.0825004577637, 0.69957160542011, -75.6097183227539, -1.31963853123754, 218, 45, 'PPL', 'P'),
(107430, 'West Piney', 36.8841705322266, 0.643750217654423, -81.0097198486328, -1.41388633747684, 218, 53, 'PPL', 'P'),
(209145, 'West Pioneer', 45.8305587768555, 0.799894148684913, -122.68083190918, -2.14118444590091, 218, 56, 'PPL', 'P'),
(168810, 'West Pittsburg', 40.9327812194824, 0.714411804278468, -80.3636093139648, -1.40260958131507, 218, 45, 'PPL', 'P'),
(186086, 'West Pittsburg', 38.0269393920898, 0.663695296848299, -121.936111450195, -2.12818662188467, 218, 6, 'PPL', 'P'),
(126555, 'West Pittsfield', 42.4308280944824, 0.74055765459643, -73.3102798461914, -1.27950575887448, 218, 23, 'PPL', 'P'),
(168799, 'West Pittston', 41.3274993896484, 0.721300935965312, -75.793327331543, -1.32284311297723, 218, 45, 'PPL', 'P'),
(58225, 'West Plains', 36.7280616760254, 0.64102560412219, -91.8522186279297, -1.60312364031904, 218, 29, 'PPL', 'P'),
(58223, 'West Platte', 39.3902816772461, 0.687490108555939, -94.8397216796875, -1.65526540498559, 218, 29, 'PPL', 'P'),
(153680, 'West Plattsburgh', 44.7136116027832, 0.780399742926506, -73.5686111450195, -1.28401449059999, 218, 40, 'PPL', 'P'),
(144652, 'West Plymouth', 43.7702789306641, 0.763935481856391, -71.7627792358398, -1.25249677804723, 218, 36, 'PPL', 'P'),
(52631, 'West Pocomoke', 38.0972213745117, 0.664921948846389, -75.5830612182617, -1.3191732769951, 218, 25, 'PPL', 'P'),
(6724, 'West Point', 33.8463897705078, 0.590730941408689, -85.8097229003906, -1.49766219483579, 218, 2, 'PPL', 'P'),
(12760, 'West Point', 35.2069396972656, 0.614477017268381, -91.6141662597656, -1.59896884270241, 218, 4, 'PPL', 'P'),
(25926, 'West Point', 32.7933311462402, 0.572351601198698, -83.807502746582, -1.46271686080205, 218, 13, 'PPL', 'P'),
(38816, 'West Point', 37.999439239502, 0.663215328640839, -85.9436111450195, -1.49999898553428, 218, 21, 'PPL', 'P'),
(44082, 'West Point', 29.4638900756836, 0.51424189226636, -89.2108306884766, -1.55702272395312, 218, 22, 'PPL', 'P'),
(62271, 'West Point', 33.6074981689453, 0.586561496406061, -88.6502838134766, -1.5472393353726, 218, 30, 'PPL', 'P'),
(77653, 'West Point', 36.1883316040039, 0.631605537293389, -96.853889465332, -1.69041926453269, 218, 42, 'PPL', 'P'),
(107431, 'West Point', 37.5313911437988, 0.65504634831313, -76.7966690063477, -1.34035472872505, 218, 53, 'PPL', 'P'),
(118408, 'West Point', 40.7166709899902, 0.710639969226589, -91.4499969482422, -1.59610354768559, 218, 16, 'PPL', 'P'),
(121934, 'West Point', 40.2550010681152, 0.702582309032445, -91.182502746582, -1.59143489313663, 218, 18, 'PPL', 'P'),
(129285, 'West Point', 43.746940612793, 0.763528151367663, -69.8649978637695, -1.21937424462158, 218, 26, 'PPL', 'P'),
(138767, 'West Point', 45.5577812194824, 0.795133282183206, -93.3888931274414, -1.62994366986696, 218, 28, 'PPL', 'P'),
(143363, 'West Point', 41.8416709899902, 0.730274923311525, -96.7083282470703, -1.68787874201081, 218, 35, 'PPL', 'P'),
(153681, 'West Point', 41.3913917541504, 0.722416068092756, -73.9563903808594, -1.29078251503626, 218, 40, 'PPL', 'P'),
(158297, 'West Point', 40.6391716003418, 0.709287349708937, -82.7850036621094, -1.44487088517937, 218, 41, 'PPL', 'P'),
(168802, 'West Point', 40.2066688537598, 0.701738752757162, -75.2997207641602, -1.31422805316694, 218, 45, 'PPL', 'P'),
(186084, 'West Point', 38.399169921875, 0.670191945169493, -120.526390075684, -2.1035823423637, 218, 6, 'PPL', 'P'),
(192413, 'West Point', 33.1666717529297, 0.578867624016822, -102.049438476563, -1.7810987012274, 218, 51, 'PPL', 'P'),
(206397, 'West Point', 41.1183280944824, 0.717650208164004, -112.08332824707, -1.95622311450494, 218, 52, 'PPL', 'P'),
(190914, 'West Point (historical)', 36.663330078125, 0.639895824608751, -114.649169921875, -2.00100549981517, 218, 39, 'PPL', 'P'),
(79385, 'West Point Marion', 39.7397193908691, 0.693588947189302, -79.9044418334961, -1.3945955969628, 218, 45, 'PPL', 'P'),
(146619, 'West Point Pleasant', 40.0833282470703, 0.699586053069024, -74.0694427490234, -1.2927556510879, 218, 37, 'PPL', 'P'),
(44081, 'West Pointe A La Hache', 29.5694408416748, 0.516084100660909, -89.8005599975586, -1.56731544209211, 218, 22, 'PPL', 'P'),
(129286, 'West Poland', 44.0355606079102, 0.768565520569548, -70.4391708374023, -1.22939545348744, 218, 26, 'PPL', 'P'),
(62272, 'West Poplarville', 30.8341693878174, 0.538157777935058, -89.5713882446289, -1.56331564045092, 218, 30, 'PPL', 'P'),
(62273, 'West Port (historical)', 33.4869384765625, 0.58445733282879, -88.4550018310547, -1.54383102180952, 218, 30, 'PPL', 'P'),
(99009, 'West Port Arthur', 29.850830078125, 0.520995269316637, -93.976936340332, -1.6402069600759, 218, 51, 'PPL', 'P'),
(209146, 'West Port Madison', 47.7019386291504, 0.832555888662945, -122.53360748291, -2.13861489492314, 218, 56, 'PPL', 'P'),
(146620, 'West Portal', 40.6622200012207, 0.709689620191594, -75.0336074829102, -1.30958350022584, 218, 37, 'PPL', 'P'),
(206399, 'West Portal', 40.1611099243164, 0.700943599434692, -111.249717712402, -1.94167386599567, 218, 52, 'PPL', 'P'),
(153682, 'West Portland', 42.3522186279297, 0.739185660581848, -79.5216674804688, -1.38791492421028, 218, 40, 'PPL', 'P'),
(201771, 'West Portland', 45.4550018310547, 0.793339443451956, -122.731391906738, -2.1420668843281, 218, 43, 'PPL', 'P'),
(201772, 'West Portland Park', 45.4469413757324, 0.793198761967372, -122.72444152832, -2.14194557734045, 218, 43, 'PPL', 'P'),
(74778, 'West Portsmouth', 38.7583312988281, 0.676460493743321, -83.029167175293, -1.44913234239766, 218, 41, 'PPL', 'P'),
(153683, 'West Potsdam', 44.686939239502, 0.77993422236796, -75.0899963378906, -1.31056767140668, 218, 40, 'PPL', 'P'),
(168803, 'West Pottsgrove', 40.2544403076172, 0.702572521915439, -75.6849975585938, -1.32095240176133, 218, 45, 'PPL', 'P'),
(129287, 'West Pownal', 43.9005584716797, 0.7662092887951, -70.2375030517578, -1.22587568663274, 218, 26, 'PPL', 'P'),
(176977, 'West Prairie', 43.4666709899902, 0.758636523656433, -91.0224990844727, -1.58864230241757, 218, 57, 'PPL', 'P'),
(38817, 'West Prestonsburg', 37.6711082458496, 0.657484871765261, -82.7819366455078, -1.44481735564146, 218, 21, 'PPL', 'P'),
(129288, 'West Princeton', 45.1886100769043, 0.788690030241868, -67.5899963378906, -1.1796679775071, 218, 26, 'PPL', 'P'),
(186085, 'West Puente Valley', 34.0516700744629, 0.5943137586022, -117.967498779297, -2.05892126404112, 218, 6, 'PPL', 'P'),
(121936, 'West Pullman', 41.6794395446777, 0.727443450440553, -87.6419372558594, -1.52964036794103, 218, 18, 'PPL', 'P'),
(58227, 'West Quincy', 39.9261093139648, 0.696842065039861, -91.440559387207, -1.59593883117217, 218, 29, 'PPL', 'P'),
(126556, 'West Quincy', 42.2527809143066, 0.737450145078471, -71.033332824707, -1.2397655364561, 218, 23, 'PPL', 'P'),
(70005, 'West Raleigh', 35.7866706848145, 0.624595231776946, -78.6641693115234, -1.37294875783236, 218, 33, 'PPL', 'P'),
(143365, 'West Randolph (historical)', 42.3805618286133, 0.739680342754331, -97.3694381713867, -1.69941728690775, 218, 35, 'PPL', 'P'),
(107434, 'West Raven', 37.084171295166, 0.647240889474217, -81.8625030517578, -1.42877021217708, 218, 53, 'PPL', 'P'),
(168805, 'West Reading', 40.333610534668, 0.703954303047027, -75.9477767944336, -1.32553876463261, 218, 45, 'PPL', 'P'),
(114256, 'West Redding', 41.3263893127441, 0.721281561468382, -73.4347229003906, -1.2816776999015, 218, 8, 'PPL', 'P'),
(14830, 'West Rehoboth', 38.7147216796875, 0.675699362303776, -75.100830078125, -1.31075675584407, 218, 10, 'PPL', 'P'),
(190915, 'West Reno', 39.5152816772461, 0.689671770120932, -119.849998474121, -2.09177708188359, 218, 39, 'PPL', 'P'),
(168807, 'West Renovo', 41.3222198486328, 0.721208790591595, -77.7663879394531, -1.35727951692667, 218, 45, 'PPL', 'P'),
(158299, 'West Richfield', 41.2394409179688, 0.719764025700227, -81.6552810668945, -1.4251535062587, 218, 41, 'PPL', 'P'),
(209151, 'West Richland', 46.3044395446777, 0.80816492834529, -119.360282897949, -2.08322993268109, 218, 56, 'PPL', 'P'),
(153684, 'West Richmondville', 42.6519393920898, 0.744416774753036, -74.6138916015625, -1.30225807617341, 218, 40, 'PPL', 'P'),
(12763, 'West Richwoods', 35.8263893127441, 0.625288452608694, -92.1716690063477, -1.60869910121918, 218, 4, 'PPL', 'P'),
(6725, 'West Ridge', 33.6944389343262, 0.588078899016161, -86.5422210693359, -1.51044669964872, 218, 2, 'PPL', 'P'),
(12762, 'West Ridge', 35.6830596923828, 0.622786878817755, -90.2624969482422, -1.57537776281816, 218, 4, 'PPL', 'P'),
(28941, 'West Ridge', 39.8258285522461, 0.695091835571461, -88.2169418334961, -1.53967609103483, 218, 18, 'PPL', 'P'),
(84291, 'West Ridge', 33.9083290100098, 0.59181198507418, -80.3944396972656, -1.40314767301332, 218, 48, 'PPL', 'P'),
(91755, 'West Ridge', 36.5508308410645, 0.637932342516063, -82.6466674804688, -1.44245646333511, 218, 50, 'PPL', 'P'),
(168808, 'West Ridge', 40.0202789306641, 0.698485634906603, -76.3572235107422, -1.33268495794368, 218, 45, 'PPL', 'P'),
(138768, 'West Ridge Village Mobile Home Park', 43.6097183227539, 0.761133170599355, -94.9944381713867, -1.65796571717288, 218, 28, 'PPL', 'P'),
(153685, 'West Ridgeway', 43.2677803039551, 0.755165226333569, -78.4197235107422, -1.36868237376606, 218, 40, 'PPL', 'P'),
(14831, 'West Riding', 39.7680587768555, 0.694083562782757, -75.6500015258789, -1.32034160576532, 218, 10, 'PPL', 'P'),
(52632, 'West Riding', 39.5116691589355, 0.689608719782124, -76.3361129760742, -1.33231650960686, 218, 25, 'PPL', 'P'),
(144653, 'West Rindge', 42.7633285522461, 0.746360882348794, -72.0319366455078, -1.25719446105207, 218, 36, 'PPL', 'P'),
(52634, 'West River', 38.8502807617188, 0.678065314616203, -76.5963897705078, -1.33685919663627, 218, 25, 'PPL', 'P'),
(209821, 'West River', 44.0986099243164, 0.769665938731969, -107.952781677246, -1.88413147695455, 218, 59, 'PPL', 'P'),
(52635, 'West River Plantation', 38.8230590820313, 0.677590206677733, -76.5477828979492, -1.33601084667102, 218, 25, 'PPL', 'P'),
(52636, 'West Riverdale', 38.9630584716797, 0.68003365697788, -76.9430618286133, -1.34290976547487, 218, 25, 'PPL', 'P'),
(91753, 'West Riverside', 35.6697196960449, 0.622554051959455, -85.7852783203125, -1.49723555642916, 218, 50, 'PPL', 'P'),
(197819, 'West Riverside', 46.8772201538086, 0.818161835866203, -113.888893127441, -1.98773616652579, 218, 31, 'PPL', 'P'),
(25924, 'West Road Acres', 33.5552787780762, 0.585650096102009, -84.4794387817383, -1.47444435697832, 218, 13, 'PPL', 'P'),
(91754, 'West Robbins', 36.3580589294434, 0.634567837952911, -84.6116714477539, -1.47675225237898, 218, 50, 'PPL', 'P'),
(52637, 'West Rock Station', 39.6419410705566, 0.691882393562779, -76.1505584716797, -1.32907797256327, 218, 25, 'PPL', 'P'),
(70009, 'West Rockingham', 34.9430618286133, 0.609871479637252, -79.7872161865234, -1.39254962345535, 218, 33, 'PPL', 'P'),
(129289, 'West Rockport', 44.1819381713867, 0.771120291003261, -69.1358337402344, -1.20664792987848, 218, 26, 'PPL', 'P'),
(25925, 'West Rome', 34.2791709899902, 0.598284398629454, -85.2261123657227, -1.48747626945651, 218, 13, 'PPL', 'P'),
(176978, 'West Rosendale', 43.8224983215332, 0.764846882160443, -88.7249984741211, -1.54854335220036, 218, 57, 'PPL', 'P'),
(126576, 'West Roxbury', 42.2791709899902, 0.737910738789, -71.1500015258789, -1.24180178942558, 218, 23, 'PPL', 'P'),
(126557, 'West Royalston', 42.6944389343262, 0.745158531695651, -72.2472229003906, -1.26095191503406, 218, 23, 'PPL', 'P'),
(144654, 'West Rumney', 43.8136100769043, 0.764691753026946, -71.8711090087891, -1.25438748926313, 218, 36, 'PPL', 'P'),
(172755, 'West Rupert', 43.2386093139648, 0.754656096512173, -73.2433319091797, -1.27833729694621, 218, 55, 'PPL', 'P'),
(28943, 'West Rural Hill', 37.9655609130859, 0.662624040299814, -88.6883316040039, -1.54790339459041, 218, 18, 'PPL', 'P'),
(153686, 'West Rush', 42.976390838623, 0.750079520757899, -77.6997222900391, -1.35611598184641, 218, 40, 'PPL', 'P'),
(74780, 'West Rushville', 39.7638893127441, 0.69401079190597, -82.4475021362305, -1.43898037232228, 218, 41, 'PPL', 'P'),
(38818, 'West Russell', 38.5380592346191, 0.67261602097271, -82.7108306884766, -1.44357632257348, 218, 21, 'PPL', 'P'),
(126558, 'West Rutland', 42.3583297729492, 0.739292320183506, -71.9883270263672, -1.25643332961253, 218, 23, 'PPL', 'P'),
(172756, 'West Rutland', 43.5930595397949, 0.760842419987345, -73.0455627441406, -1.27488557385736, 218, 55, 'PPL', 'P'),
(144656, 'West Rye', 43.0011100769043, 0.750510952854492, -70.7983322143555, -1.23566400206127, 218, 36, 'PPL', 'P'),
(111986, 'West Sabraton', 39.6166687011719, 0.691441307507235, -79.9283294677734, -1.39501251483145, 218, 58, 'PPL', 'P'),
(186087, 'West Sacramento', 38.5805587768555, 0.673357777915324, -121.529167175293, -2.12108410441548, 218, 6, 'PPL', 'P'),
(201778, 'West Saint Helens', 45.857780456543, 0.800369256623383, -122.826110839844, -2.14372004157477, 218, 43, 'PPL', 'P'),
(153687, 'West Saint Johnsville', 42.999439239502, 0.750481791240556, -74.7008285522461, -1.30377541220448, 218, 40, 'PPL', 'P'),
(52638, 'West Saint Marys', 38.1830596923828, 0.666420110117613, -76.4502792358398, -1.33430908673446, 218, 25, 'PPL', 'P'),
(118411, 'West Saint Marys', 41.3080596923828, 0.720961649242436, -93.7394409179688, -1.63606188299725, 218, 16, 'PPL', 'P'),
(99010, 'West Saint Paul', 28.101110458374, 0.49045690096524, -97.6372222900391, -1.70409100146278, 218, 51, 'PPL', 'P'),
(138769, 'West Saint Paul', 44.9161109924316, 0.78393402400915, -93.1013870239258, -1.62492574174103, 218, 28, 'PPL', 'P'),
(28944, 'West Salem', 38.5208282470703, 0.672315283506613, -88.0047225952148, -1.53597216659075, 218, 18, 'PPL', 'P'),
(70006, 'West Salem', 36.0830612182617, 0.629768222457343, -80.2522201538086, -1.40066547371931, 218, 33, 'PPL', 'P'),
(158301, 'West Salem', 40.9713897705078, 0.715085650613285, -82.1100006103516, -1.43308985946519, 218, 41, 'PPL', 'P'),
(176979, 'West Salem', 43.899169921875, 0.766185054029181, -91.0811080932617, -1.58966522259227, 218, 57, 'PPL', 'P'),
(107436, 'West Salem Forest', 37.2658309936523, 0.650411449330983, -80.1272201538086, -1.39848381215432, 218, 53, 'PPL', 'P'),
(79389, 'West Salisbury', 39.7541694641113, 0.693841148544532, -79.0952835083008, -1.38047312001822, 218, 45, 'PPL', 'P'),
(144657, 'West Salisbury', 43.3988914489746, 0.75745354750022, -71.7808303833008, -1.25281183000418, 218, 36, 'PPL', 'P'),
(172758, 'West Salisbury', 43.922779083252, 0.766597111628843, -73.1516723632813, -1.2767375360794, 218, 55, 'PPL', 'P'),
(18566, 'West Samoset', 27.4691696166992, 0.47942745260019, -82.5569381713867, -1.44089039145608, 218, 12, 'PPL', 'P'),
(153688, 'West Sand Lake', 42.6433296203613, 0.744266505888529, -73.6091690063477, -1.28472235881773, 218, 40, 'PPL', 'P'),
(28945, 'West Sandford', 39.5458297729492, 0.690204934971165, -87.5344390869141, -1.52776417095307, 218, 18, 'PPL', 'P'),
(172759, 'West Sandgate', 43.1627807617188, 0.753332638608458, -73.2463912963867, -1.27839069332607, 218, 55, 'PPL', 'P'),
(192917, 'West Saticoy', 34.2852783203125, 0.598390991652084, -119.159439086914, -2.07972454689628, 218, 6, 'PPL', 'P'),
(153689, 'West Saugerties', 42.1124992370605, 0.735001767930307, -74.0486068725586, -1.29239199644105, 218, 40, 'PPL', 'P'),
(168814, 'West Saxonburg', 40.7466697692871, 0.711163546696898, -79.8466720581055, -1.3935873241741, 218, 45, 'PPL', 'P'),
(6727, 'West Sayre', 33.7138900756836, 0.588418385476119, -86.9875030517578, -1.51821833634179, 218, 2, 'PPL', 'P'),
(153690, 'West Sayville', 40.7277793884277, 0.710833847353947, -73.0980606079102, -1.2758018344304, 218, 40, 'PPL', 'P'),
(129290, 'West Scarborough', 43.5702781677246, 0.760444810036597, -70.3883285522461, -1.22850808821223, 218, 26, 'PPL', 'P'),
(18572, 'West Scenic Park', 27.920280456543, 0.4873008220469, -81.6425018310547, -1.4249304665174, 218, 12, 'PPL', 'P'),
(153691, 'West Schuyler', 43.098331451416, 0.752207785943036, -75.1516723632813, -1.31164412111929, 218, 40, 'PPL', 'P'),
(201774, 'West Scio', 44.711109161377, 0.780356067084629, -122.88166809082, -2.14468969852767, 218, 43, 'PPL', 'P'),
(129291, 'West Searsmont', 44.3997192382813, 0.774921287669077, -69.2461090087891, -1.20857259639828, 218, 26, 'PPL', 'P'),
(209147, 'West Seattle', 47.5711097717285, 0.830272494344311, -122.385276794434, -2.13602603602748, 218, 56, 'PPL', 'P'),
(129292, 'West Sebago', 43.9486083984375, 0.767047918222366, -70.7350006103516, -1.23455865705083, 218, 26, 'PPL', 'P'),
(133662, 'West Sebewa', 42.8430595397949, 0.747752450597388, -85.0538864135742, -1.48447035953414, 218, 27, 'PPL', 'P'),
(129293, 'West Seboeis', 45.5291709899902, 0.794633939478816, -68.8791732788086, -1.20216835976691, 218, 26, 'PPL', 'P'),
(192885, 'West Sedona', 34.8672218322754, 0.608547821996456, -111.804718017578, -1.95136044867057, 218, 5, 'PPL', 'P'),
(6728, 'West Selmont', 32.3911094665527, 0.565331508565249, -87.017219543457, -1.51873698696408, 218, 2, 'PPL', 'P'),
(77654, 'West Seneca', 36.836669921875, 0.642921175607081, -94.6197204589844, -1.65142565932592, 218, 42, 'PPL', 'P'),
(153692, 'West Seneca', 42.8499984741211, 0.747873557847959, -78.8000030517578, -1.37531950383475, 218, 40, 'PPL', 'P'),
(153695, 'West Settlement', 42.332218170166, 0.738836586741966, -74.370002746582, -1.29800141264508, 218, 40, 'PPL', 'P'),
(172760, 'West Settlement', 44.6199989318848, 0.778765893597742, -72.7216720581055, -1.2692326149695, 218, 55, 'PPL', 'P'),
(52639, 'West Severna Park', 39.0738906860352, 0.681968044035659, -76.559440612793, -1.3362143121783, 218, 25, 'PPL', 'P'),
(114260, 'West Seymour', 41.3938903808594, 0.722459677355606, -73.0794372558594, -1.27547679561936, 218, 8, 'PPL', 'P'),
(52640, 'West Shadyside', 38.8469390869141, 0.67800699138833, -76.5111083984375, -1.33537075590302, 218, 25, 'PPL', 'P'),
(99011, 'West Sharyland', 26.2722206115723, 0.458536751482254, -98.3283309936523, -1.71615312383002, 218, 51, 'PPL', 'P'),
(153703, 'West Shelby', 43.1591682434082, 0.753269588269651, -78.4372177124023, -1.36898770518504, 218, 40, 'PPL', 'P'),
(91756, 'West Shiloh', 35.148609161377, 0.613458957362671, -88.3833312988281, -1.54258013504551, 218, 50, 'PPL', 'P'),
(153696, 'West Shokan', 41.9672203063965, 0.732466172256442, -74.2874984741211, -1.29656144144368, 218, 40, 'PPL', 'P'),
(512, 'West Shore', 39.1888885498047, 0.683975135391198, -95.476936340332, -1.66638689885582, 218, 20, 'PPL', 'P'),
(52641, 'West Shore', 39.4430618286133, 0.688411295976997, -76.2874984741211, -1.33146802648356, 218, 25, 'PPL', 'P'),
(114258, 'West Shore', 41.2422218322754, 0.719812561811094, -72.9711074829102, -1.27358608440345, 218, 8, 'PPL', 'P'),
(209148, 'West Shore', 48.4225006103516, 0.845132067699599, -122.553062438965, -2.13895444796213, 218, 56, 'PPL', 'P'),
(158303, 'West Shore Cottage Area', 40.7472190856934, 0.711173134076823, -82.3791732788086, -1.43778780878614, 218, 41, 'PPL', 'P'),
(52642, 'West Shoreham', 38.8988914489746, 0.678913731160475, -76.4974975585938, -1.33513320193378, 218, 25, 'PPL', 'P'),
(146621, 'West Shrewsbury', 40.3158302307129, 0.703643978201005, -74.085563659668, -1.29303701405707, 218, 37, 'PPL', 'P'),
(111981, 'West Side', 38.3655586242676, 0.669605317360375, -81.6519393920898, -1.42509518303082, 218, 58, 'PPL', 'P'),
(113269, 'West Side', 41.1022186279297, 0.717369044931919, -80.6894378662109, -1.40829636234877, 218, 41, 'PPL', 'P'),
(201775, 'West Side', 42.1133308410645, 0.735016282158248, -120.492500305176, -2.10299085428559, 218, 43, 'PPL', 'P'),
(206403, 'West Side Estates', 41.2452812194824, 0.71986595819095, -112.104438781738, -1.95659156284175, 218, 52, 'PPL', 'P'),
(38819, 'West Side Heights', 37.2772216796875, 0.650610254306358, -87.523063659668, -1.5275656322938, 218, 21, 'PPL', 'P'),
(114259, 'West Side Hill', 41.5538902282715, 0.725252201495636, -73.0616683959961, -1.27516667051042, 218, 8, 'PPL', 'P'),
(138771, 'West Side Mobile Home Park', 45.3188896179199, 0.790963837180578, -93.8172225952148, -1.63741942936292, 218, 28, 'PPL', 'P'),
(129294, 'West Sidney', 44.3955612182617, 0.774848716529372, -69.8027801513672, -1.2182883406871, 218, 26, 'PPL', 'P'),
(77655, 'West Siloam Springs', 36.1761093139648, 0.631392218090074, -94.5747222900391, -1.65064029312045, 218, 42, 'PPL', 'P'),
(114261, 'West Simsbury', 41.8730583190918, 0.730822735547754, -72.8586120605469, -1.27162266888979, 218, 8, 'PPL', 'P'),
(99012, 'West Sinton', 28.0288906097412, 0.489196426821305, -97.6727828979492, -1.70471165115482, 218, 51, 'PPL', 'P'),
(153697, 'West Slaterville', 42.3938903808594, 0.739912969875549, -76.3633270263672, -1.33279148438728, 218, 40, 'PPL', 'P'),
(201776, 'West Slope', 45.4988899230957, 0.79410543516049, -122.763328552246, -2.14262428394426, 218, 43, 'PPL', 'P'),
(70007, 'West Smithfield', 35.5269393920898, 0.62006206554844, -78.3555603027344, -1.36756251452768, 218, 33, 'PPL', 'P'),
(153698, 'West Somerset', 43.327220916748, 0.756202660736209, -78.6055603027344, -1.37192583765767, 218, 40, 'PPL', 'P'),
(126559, 'West Somerville', 42.3958282470703, 0.739946792021393, -71.1230621337891, -1.24133160833512, 218, 23, 'PPL', 'P'),
(837, 'West Sonora', 39.8888893127441, 0.696192453470963, -84.5411071777344, -1.47552067353288, 218, 41, 'PPL', 'P'),
(209149, 'West Sound', 48.6313896179199, 0.84877786865289, -122.955001831055, -2.14596961374756, 218, 56, 'PPL', 'P'),
(129295, 'West Southport', 43.8230590820313, 0.764856669277449, -69.6791687011719, -1.21613091388803, 218, 26, 'PPL', 'P'),
(153699, 'West Sparta', 42.6269416809082, 0.743980482387454, -77.7733306884766, -1.35740069075626, 218, 40, 'PPL', 'P'),
(209150, 'West Spokane', 47.6605606079102, 0.831833705954342, -117.441108703613, -2.04973402407062, 218, 56, 'PPL', 'P'),
(190916, 'West Spring', 37.7222213745117, 0.65837696415141, -117.269721984863, -2.04674276153424, 218, 39, 'PPL', 'P'),
(168816, 'West Spring Creek', 41.8455581665039, 0.730342767340295, -79.5697174072266, -1.38875355363755, 218, 45, 'PPL', 'P'),
(168817, 'West Spring Mills', 40.0683288574219, 0.699324264333869, -75.2850036621094, -1.3139711912798, 218, 45, 'PPL', 'P'),
(91757, 'West Springbrook', 35.7975006103516, 0.624784249635314, -83.9833297729492, -1.46578562132615, 218, 50, 'PPL', 'P'),
(107435, 'West Springfield', 38.7724990844727, 0.676707768250535, -77.2213897705078, -1.34776750446123, 218, 53, 'PPL', 'P'),
(126560, 'West Springfield', 42.1069412231445, 0.7349047622876, -72.6208267211914, -1.26747253180507, 218, 23, 'PPL', 'P'),
(144669, 'West Springfield', 43.4986114501953, 0.759193989851614, -72.0583267211914, -1.2576550547626, 218, 36, 'PPL', 'P'),
(168818, 'West Springfield', 41.9458312988281, 0.73209286365064, -80.4744415283203, -1.40454396837285, 218, 45, 'PPL', 'P'),
(172761, 'West Springfield', 43.2911109924316, 0.755572423664242, -72.522216796875, -1.2657514639506, 218, 55, 'PPL', 'P'),
(25927, 'West Springs', 33.8544387817383, 0.590871423156191, -84.7058334350586, -1.47839568908767, 218, 13, 'PPL', 'P'),
(84292, 'West Springs', 34.7708282470703, 0.606865436556825, -81.7819366455078, -1.42736406312152, 218, 48, 'PPL', 'P'),
(114263, 'West Stafford', 41.9705581665039, 0.732524428905288, -72.3555603027344, -1.26284275940802, 218, 8, 'PPL', 'P'),
(201777, 'West Stayton', 44.7866706848145, 0.781674864456436, -122.865562438965, -2.14440860187461, 218, 43, 'PPL', 'P'),
(158304, 'West Steels Corners', 41.1808280944824, 0.718741038946501, -81.5366668701172, -1.42308329798532, 218, 41, 'PPL', 'P'),
(153701, 'West Stephentown', 42.5794410705566, 0.743151440340113, -73.4730606079102, -1.28234681912538, 218, 40, 'PPL', 'P'),
(177339, 'West Sterling', 42.4500007629395, 0.740892280787398, -71.8194427490234, -1.25348574291803, 218, 23, 'PPL', 'P'),
(44086, 'West Sterlington', 32.6988906860352, 0.570703304221021, -92.0977783203125, -1.60740946546131, 218, 22, 'PPL', 'P'),
(144658, 'West Stewartstown', 44.9952812194824, 0.785315805140738, -71.5316696166992, -1.24846315426019, 218, 36, 'PPL', 'P'),
(126562, 'West Stockbridge', 42.3458290100098, 0.739074140711201, -73.3666687011719, -1.28048993005532, 218, 23, 'PPL', 'P'),
(126563, 'West Stockbridge Center', 42.3055610656738, 0.738371332499529, -73.4027786254883, -1.28112016712729, 218, 23, 'PPL', 'P'),
(153702, 'West Stockholm', 44.7136116027832, 0.780399742926506, -74.9011077880859, -1.30727094429327, 218, 40, 'PPL', 'P'),
(129296, 'West Stonington', 44.166389465332, 0.770848914888182, -68.6919403076172, -1.19890052795133, 218, 26, 'PPL', 'P'),
(84293, 'West Store Crossroads', 33.7558288574219, 0.589150355301727, -82.0522232055664, -1.43208145351843, 218, 48, 'PPL', 'P'),
(126565, 'West Stoughton', 42.1291694641113, 0.735292718279398, -71.125, -1.24136543048097, 218, 23, 'PPL', 'P'),
(114262, 'West Suffield', 41.9886093139648, 0.732839480862244, -72.692497253418, -1.26872341856908, 218, 8, 'PPL', 'P'),
(58229, 'West Sullivan', 38.1875, 0.666497608105335, -91.1958312988281, -1.59166752025785, 218, 29, 'PPL', 'P'),
(129297, 'West Sullivan', 44.5305595397949, 0.777204881724792, -68.2316665649414, -1.19086723568116, 218, 26, 'PPL', 'P'),
(25928, 'West Summerville', 34.4724998474121, 0.601658623730584, -85.3694381713867, -1.48997777666843, 218, 13, 'PPL', 'P'),
(126566, 'West Summit', 42.6963882446289, 0.745192553578577, -73.0666732788086, -1.27525402219417, 218, 23, 'PPL', 'P'),
(129298, 'West Sumner', 44.3647193908691, 0.77431042509404, -70.4580612182617, -1.22972515283039, 218, 26, 'PPL', 'P'),
(133670, 'West Sumpter', 42.122501373291, 0.735176338139761, -83.5094375610352, -1.45751464192869, 218, 27, 'PPL', 'P'),
(168819, 'West Sunbury', 41.0072212219238, 0.715711027416263, -79.8963928222656, -1.3944551152153, 218, 45, 'PPL', 'P'),
(129299, 'West Surry', 44.5188903808594, 0.777001216480428, -68.607780456543, -1.19743166145209, 218, 26, 'PPL', 'P'),
(126567, 'West Sutton', 42.1138916015625, 0.735026069275254, -71.8000030517578, -1.25314645619515, 218, 23, 'PPL', 'P'),
(172762, 'West Swanton', 44.9688911437988, 0.784855211430208, -73.2127838134766, -1.27780413209598, 218, 55, 'PPL', 'P'),
(144659, 'West Swanzey', 42.8699989318848, 0.748222631687841, -72.3222198486328, -1.26226085870984, 218, 36, 'PPL', 'P'),
(99013, 'West Sweden', 31.1911106109619, 0.544387577515026, -99.4436111450195, -1.73561843455352, 218, 51, 'PPL', 'P'),
(153704, 'West Sweden', 43.149169921875, 0.753095084639223, -77.9875030517578, -1.3611387036623, 218, 40, 'PPL', 'P'),
(176981, 'West Sweden', 45.7058296203613, 0.797717214230855, -92.4966735839844, -1.61437150118299, 218, 57, 'PPL', 'P'),
(153705, 'West Taghkanic', 42.1238899230957, 0.735200572905681, -73.7211074829102, -1.28667605379341, 218, 40, 'PPL', 'P'),
(133664, 'West Tamarack', 47.2574996948242, 0.824798965934898, -88.475830078125, -1.54419454329831, 218, 27, 'PPL', 'P'),
(18567, 'West Tampa', 27.9530601501465, 0.487872935628077, -82.4894409179688, -1.43971234214789, 218, 12, 'PPL', 'P'),
(133665, 'West Tappan', 42.9702796936035, 0.749972861156242, -82.543327331543, -1.44065283748685, 218, 27, 'PPL', 'P'),
(70031, 'West Tarboro', 35.9055595397949, 0.626670233740281, -77.5416717529297, -1.35335747958931, 218, 33, 'PPL', 'P'),
(168821, 'West Tarentum', 40.5963897705078, 0.708540665918307, -79.7705612182617, -1.39225893942237, 218, 45, 'PPL', 'P'),
(126568, 'West Tatnuck', 42.2819404602051, 0.737959075162785, -71.8722229003906, -1.25440693033909, 218, 23, 'PPL', 'P'),
(99014, 'West Tawakoni', 32.8936080932617, 0.574101764088071, -96.029167175293, -1.67602514515693, 218, 51, 'PPL', 'P'),
(99015, 'West Tempe', 30.7572193145752, 0.536814745797331, -95.0408325195313, -1.65877545130232, 218, 51, 'PPL', 'P'),
(31497, 'West Terre Haute', 39.4650001525879, 0.688794191962723, -87.4499969482422, -1.52629037760582, 218, 19, 'PPL', 'P'),
(114283, 'West Thompson', 41.9449996948242, 0.732078349422699, -71.9113922119141, -1.25509056379091, 218, 8, 'PPL', 'P'),
(144660, 'West Thornton', 43.9358291625977, 0.766824878481072, -71.6880569458008, -1.25119262806141, 218, 36, 'PPL', 'P'),
(209822, 'West Thumb', 44.4155616760254, 0.775197790369254, -110.574722290039, -1.92989297343955, 218, 59, 'PPL', 'P'),
(153706, 'West Tiana', 40.8597183227539, 0.713136616169511, -72.5441665649414, -1.26613455967341, 218, 40, 'PPL', 'P'),
(172763, 'West Tinmouth', 43.4188919067383, 0.757802621340102, -73.1197204589844, -1.27617987014714, 218, 55, 'PPL', 'P'),
(126569, 'West Tisbury', 41.3811111450195, 0.722236637614312, -70.6750030517578, -1.23351150211021, 218, 23, 'PPL', 'P'),
(18568, 'West Tocoi', 29.8500003814697, 0.52098078837821, -81.6175003051758, -1.42449410757279, 218, 12, 'PPL', 'P'),
(158305, 'West Toledo', 41.6916694641113, 0.727656902801923, -83.5580596923828, -1.45836325821004, 218, 41, 'PPL', 'P'),
(172764, 'West Topsham', 44.1150016784668, 0.76995202881207, -72.3122177124023, -1.26208628850038, 218, 55, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(168823, 'West Torresdale', 40.0733299255371, 0.699411549438597, -74.9886093139648, -1.30879813402037, 218, 45, 'PPL', 'P'),
(114264, 'West Torrington', 41.8183288574219, 0.72986752624377, -73.144172668457, -1.27660664171182, 218, 8, 'PPL', 'P'),
(126571, 'West Town Landing', 42.5066719055176, 0.741881378816254, -70.8733291625977, -1.23697294573704, 218, 23, 'PPL', 'P'),
(126572, 'West Townsend', 42.6775016784668, 0.744862920814652, -71.7408294677734, -1.25211368232442, 218, 23, 'PPL', 'P'),
(172765, 'West Townshend', 43.084171295166, 0.751960644593877, -72.7122192382813, -1.26906763213997, 218, 55, 'PPL', 'P'),
(153707, 'West Township', 42.6994400024414, 0.745245816800378, -74.1513900756836, -1.29418590175133, 218, 40, 'PPL', 'P'),
(129300, 'West Tremont', 44.2627792358398, 0.772531233748785, -68.39111328125, -1.19365010586224, 218, 26, 'PPL', 'P'),
(129301, 'West Trenton', 44.4355583190918, 0.775546797630109, -68.3974990844727, -1.19376155915386, 218, 26, 'PPL', 'P'),
(146622, 'West Trenton', 40.2638893127441, 0.702737438165942, -74.8188934326172, -1.30583603309793, 218, 37, 'PPL', 'P'),
(71547, 'West Tuckerton', 39.601390838623, 0.691174658503091, -74.353889465332, -1.29772018283397, 218, 37, 'PPL', 'P'),
(71548, 'West Tuckerton Landing', 39.5958290100098, 0.691077586281357, -74.3424987792969, -1.2975213778586, 218, 37, 'PPL', 'P'),
(77658, 'West Tulsa', 36.1349983215332, 0.630674695913379, -96.0022201538086, -1.67555483090842, 218, 42, 'PPL', 'P'),
(52643, 'West Twin River', 39.3797187805176, 0.687305751229478, -76.3583297729492, -1.33270426586158, 218, 25, 'PPL', 'P'),
(28946, 'West Union', 39.2158317565918, 0.684445383060678, -87.6661071777344, -1.5300622126577, 218, 18, 'PPL', 'P'),
(31498, 'West Union', 39.8436088562012, 0.695402160417482, -87.336669921875, -1.52431244786422, 218, 19, 'PPL', 'P'),
(74783, 'West Union', 38.7944412231445, 0.677090730815288, -83.545280456543, -1.45814021846875, 218, 41, 'PPL', 'P'),
(84294, 'West Union', 34.7597198486328, 0.606671558429468, -83.0430603027344, -1.44937482321491, 218, 48, 'PPL', 'P'),
(91759, 'West Union', 36.2919387817383, 0.633413823673553, -88.6505584716797, -1.54724412906256, 218, 50, 'PPL', 'P'),
(111983, 'West Union', 38.2694396972656, 0.667927725610707, -80.1402816772461, -1.39871177874363, 218, 58, 'PPL', 'P'),
(118413, 'West Union', 42.9627799987793, 0.749841966788664, -91.8080596923828, -1.60235292149957, 218, 16, 'PPL', 'P'),
(138772, 'West Union', 45.8008308410645, 0.799375298325538, -95.0830612182617, -1.659512481134, 218, 28, 'PPL', 'P'),
(153708, 'West Union', 42.0950012207031, 0.734696369932302, -77.725830078125, -1.35657164870892, 218, 40, 'PPL', 'P'),
(168824, 'West Union', 40.002498626709, 0.698175310060582, -80.2708282470703, -1.40099024621425, 218, 45, 'PPL', 'P'),
(201779, 'West Union', 45.5666694641113, 0.795288411316703, -122.892776489258, -2.14488357665503, 218, 43, 'PPL', 'P'),
(118414, 'West Union (historical)', 42.190559387207, 0.736364174564964, -92.4463882446289, -1.61349385644576, 218, 16, 'PPL', 'P'),
(143369, 'West Union (historical)', 41.6549987792969, 0.727016878612949, -99.4583282470703, -1.73587529644066, 218, 35, 'PPL', 'P'),
(158306, 'West Union (historical)', 40.8194389343262, 0.712433608220757, -83.6513900756836, -1.45999218069079, 218, 41, 'PPL', 'P'),
(144661, 'West Unity', 43.2880592346191, 0.755519160442441, -72.3169403076172, -1.26216871333612, 218, 36, 'PPL', 'P'),
(158307, 'West Unity', 41.586109161377, 0.725814527959806, -84.4349975585938, -1.47366871131083, 218, 41, 'PPL', 'P'),
(99016, 'West University Place', 29.7177791595459, 0.518673092714629, -95.4336090087891, -1.66563069426429, 218, 51, 'PPL', 'P'),
(126573, 'West Upton', 42.1694412231445, 0.735995593070097, -71.6208267211914, -1.25001923928512, 218, 23, 'PPL', 'P'),
(187527, 'West Vail', 39.6302795410156, 0.69167886147647, -106.414169311523, -1.85727762526079, 218, 7, 'PPL', 'P'),
(25930, 'West Valdosta', 30.815559387207, 0.537832972150609, -83.3150024414063, -1.45412110890965, 218, 13, 'PPL', 'P'),
(12765, 'West Valley', 34.5125007629395, 0.602356771410348, -94.4413909912109, -1.64831322295994, 218, 4, 'PPL', 'P'),
(153710, 'West Valley', 42.4027786254883, 0.740068099009046, -78.6102828979492, -1.3720082624934, 218, 40, 'PPL', 'P'),
(168825, 'West Valley', 40.836109161377, 0.712724558569848, -79.4233322143555, -1.38619865004578, 218, 45, 'PPL', 'P'),
(197820, 'West Valley', 46.1519393920898, 0.805503298572838, -113.021667480469, -1.97260022362838, 218, 31, 'PPL', 'P'),
(209152, 'West Valley', 46.5922203063965, 0.81318765016118, -120.603889465332, -2.10493496188135, 218, 56, 'PPL', 'P'),
(206406, 'West Valley City', 40.6916694641113, 0.710203610281979, -112.000282287598, -1.95477368908167, 218, 52, 'PPL', 'P'),
(38820, 'West Van Lear', 37.7861099243164, 0.659492029699827, -82.7713928222656, -1.44463333121014, 218, 21, 'PPL', 'P'),
(111984, 'West Van Voorhis', 39.6852798461914, 0.692638797891389, -79.9511108398438, -1.3954101247822, 218, 58, 'PPL', 'P'),
(187528, 'West Vancorum', 38.2277793884277, 0.667200616054088, -108.599998474121, -1.89542754103423, 218, 7, 'PPL', 'P'),
(168826, 'West Vandergrift', 40.6005592346191, 0.708613436795093, -79.5838928222656, -1.38900096130282, 218, 45, 'PPL', 'P'),
(186088, 'West Venida', 36.3411102294922, 0.634272027334831, -119.128890991211, -2.07919138204604, 218, 6, 'PPL', 'P'),
(168827, 'West Vernon', 41.5969390869141, 0.726003545818174, -80.2652816772461, -1.40089344030862, 218, 45, 'PPL', 'P'),
(18569, 'West Vero Corridor', 27.6391696929932, 0.482394513660161, -80.4819412231445, -1.40467486274042, 218, 12, 'PPL', 'P'),
(28947, 'West Vienna', 37.4286117553711, 0.65325250958188, -88.9694366455078, -1.55280960310861, 218, 18, 'PPL', 'P'),
(52644, 'West View', 38.7249984741211, 0.675878726203193, -75.9113922119141, -1.32490373387068, 218, 25, 'PPL', 'P'),
(62274, 'West View', 32.3630599975586, 0.564841952977865, -90.4286117553711, -1.57827701313887, 218, 30, 'PPL', 'P'),
(84296, 'West View', 34.9249992370605, 0.609556227943214, -81.9933319091797, -1.43105360649571, 218, 48, 'PPL', 'P'),
(91761, 'West View', 35.961109161377, 0.627639757535125, -83.9649963378906, -1.46546564252117, 218, 50, 'PPL', 'P'),
(107444, 'West View', 38.1686096191406, 0.666167908762383, -79.1725006103516, -1.38182081268785, 218, 53, 'PPL', 'P'),
(146623, 'West View', 40.8650016784668, 0.713228828122255, -74.0280609130859, -1.29203340180027, 218, 37, 'PPL', 'P'),
(158308, 'West View', 41.360279083252, 0.721873049546488, -81.9027786254883, -1.42947315354681, 218, 41, 'PPL', 'P'),
(168828, 'West View', 40.5222206115723, 0.707246169891446, -80.0344390869141, -1.39686447705349, 218, 45, 'PPL', 'P'),
(172766, 'West View', 44.625560760498, 0.778862965819476, -73.1369400024414, -1.27648040787615, 218, 55, 'PPL', 'P'),
(91762, 'West View Park', 36.5625, 0.638136007760427, -82.5772171020508, -1.44124432556496, 218, 50, 'PPL', 'P'),
(52645, 'West View Shores', 39.4291687011719, 0.688168815159745, -75.9966735839844, -1.32639217460393, 218, 25, 'PPL', 'P'),
(158310, 'West View Subdivision', 41.5844383239746, 0.725785366345869, -84.6241683959961, -1.47697036527226, 218, 41, 'PPL', 'P'),
(52646, 'West View Terrace', 39.5794410705566, 0.690791562780283, -77.1755599975586, -1.34696762402782, 218, 25, 'PPL', 'P'),
(107439, 'West View Terrace', 37.3105583190918, 0.651192088425513, -80.0036087036133, -1.39632638535524, 218, 53, 'PPL', 'P'),
(138777, 'West View Terrace', 45.0819396972656, 0.786828280902821, -94.313606262207, -1.64608295870506, 218, 28, 'PPL', 'P'),
(71549, 'West Village', 39.5019416809082, 0.689438943262631, -75.226936340332, -1.31295772532697, 218, 37, 'PPL', 'P'),
(126575, 'West Village', 42.5666694641113, 0.742928533756873, -71.1125030517578, -1.24114731758769, 218, 23, 'PPL', 'P'),
(186089, 'West Village', 35.5680618286133, 0.620779787462217, -121.098609924316, -2.1135694627676, 218, 6, 'PPL', 'P'),
(189806, 'West Village', 35.0525016784668, 0.611781565350084, -107.581672668457, -1.87765440286737, 218, 38, 'PPL', 'P'),
(52647, 'West Vindex', 39.4174995422363, 0.687965149915382, -79.2058334350586, -1.38240258022798, 218, 25, 'PPL', 'P'),
(38821, 'West Viola', 36.855281829834, 0.643246014681043, -88.6627807617188, -1.54745744826588, 218, 21, 'PPL', 'P'),
(111987, 'West Virginia', 38.5002784729004, 0.671956622286806, -80.5002822875977, -1.40499497470345, 218, 58, 'ADM1', 'A'),
(138778, 'West Virginia', 47.5155601501465, 0.829302970549467, -92.5699996948242, -1.61565128324483, 218, 28, 'PPL', 'P'),
(111985, 'West Virginia Central Junction', 39.4713897705078, 0.68890571183337, -79.061393737793, -1.37988163194011, 218, 58, 'PPL', 'P'),
(129307, 'West Waldoboro', 44.0788917541504, 0.769321791740103, -69.3983306884766, -1.21122936590174, 218, 26, 'PPL', 'P'),
(126577, 'West Walpole', 42.1369400024414, 0.73542833975791, -71.2874984741211, -1.24420156388385, 218, 23, 'PPL', 'P'),
(153722, 'West Walworth', 43.146671295166, 0.753051475376373, -77.345832824707, -1.34993944548824, 218, 40, 'PPL', 'P'),
(193266, 'West Warden', 46.9674987792969, 0.819737495125148, -119.060562133789, -2.0779988185099, 218, 56, 'PPL', 'P'),
(172767, 'West Wardsboro', 43.0294418334961, 0.751005435289893, -72.8530578613281, -1.27152572982611, 218, 55, 'PPL', 'P'),
(126578, 'West Ware', 42.2730598449707, 0.737804079187342, -72.3305587768555, -1.26240640046341, 218, 23, 'PPL', 'P'),
(126579, 'West Wareham', 41.7897186279297, 0.72936818353938, -70.7608337402344, -1.23500953022338, 218, 23, 'PPL', 'P'),
(107441, 'West Warm Springs', 38.0563888549805, 0.664209286938684, -79.8063888549805, -1.39288424964632, 218, 53, 'PPL', 'P'),
(126580, 'West Warren', 42.2125015258789, 0.736747137129717, -72.2352828979492, -1.26074352267876, 218, 23, 'PPL', 'P'),
(168831, 'West Warren', 41.9358291625977, 0.731918293441186, -76.2516708374023, -1.33084271625961, 218, 45, 'PPL', 'P'),
(206408, 'West Warren', 41.2502784729004, 0.71995317671665, -112.151672363281, -1.95741594435719, 218, 52, 'PPL', 'P'),
(169668, 'West Warwick', 41.7061080932617, 0.727908904420071, -71.5236129760742, -1.24832253935464, 218, 47, 'PPL', 'P'),
(129302, 'West Washington', 44.2608299255371, 0.772497211865859, -69.4413909912109, -1.21198090996136, 218, 26, 'PPL', 'P'),
(172768, 'West Waterford', 44.3574981689453, 0.774184390995452, -71.9561080932617, -1.25587100314836, 218, 55, 'PPL', 'P'),
(114265, 'West Wauregan', 41.7486114501953, 0.728650727941713, -71.9161071777344, -1.25517285546859, 218, 8, 'PPL', 'P'),
(168832, 'West Wayne', 40.0386085510254, 0.698805547132549, -75.4022216796875, -1.3160170316292, 218, 45, 'PPL', 'P'),
(79396, 'West Waynesburg', 39.9002799987793, 0.696391258446338, -80.20361328125, -1.39981712375407, 218, 45, 'PPL', 'P'),
(206409, 'West Weber', 41.2488899230957, 0.719928941950731, -112.077499389648, -1.9561213817513, 218, 52, 'PPL', 'P'),
(153712, 'West Webster', 43.204719543457, 0.754064608434067, -77.4966735839844, -1.35257211338384, 218, 40, 'PPL', 'P'),
(6729, 'West Wellington', 33.8247184753418, 0.590352705954871, -85.9100036621094, -1.49941242430419, 218, 2, 'PPL', 'P'),
(209153, 'West Wenatchee', 47.4438896179199, 0.828052083785457, -120.35221862793, -2.10054247713743, 218, 56, 'PPL', 'P'),
(200277, 'West Wendover', 40.7391700744629, 0.711032652329321, -114.07250213623, -1.99094074826549, 218, 39, 'PPL', 'P'),
(126581, 'West Whately', 42.271671295166, 0.737779844421423, -72.6813888549805, -1.26852954044172, 218, 23, 'PPL', 'P'),
(38822, 'West Wheatcroft', 37.4880599975586, 0.654290077142575, -87.8711090087891, -1.53364016958222, 218, 21, 'PPL', 'P'),
(158312, 'West Wheeling', 40.0608291625977, 0.699193369966292, -80.7425003051758, -1.40922247661784, 218, 41, 'PPL', 'P'),
(52648, 'West White Plains', 38.5875015258789, 0.673478951744923, -76.966667175293, -1.34332175649551, 218, 25, 'PPL', 'P'),
(31499, 'West Whiteland', 39.5513916015625, 0.690302007192899, -86.0875015258789, -1.50251034644223, 218, 19, 'PPL', 'P'),
(186090, 'West Whittier', 33.9886093139648, 0.593213140702698, -118.056106567383, -2.06046776168613, 218, 6, 'PPL', 'P'),
(71550, 'West Wildwood', 39.0022201538086, 0.680717157271649, -74.8247222900391, -1.30593776585157, 218, 37, 'PPL', 'P'),
(168833, 'West William Penn', 40.8074989318848, 0.712225215865458, -76.2375030517578, -1.3305954417524, 218, 45, 'PPL', 'P'),
(158313, 'West Williamsfield', 41.5333290100098, 0.724893340538747, -80.6083297729492, -1.40688075907134, 218, 41, 'PPL', 'P'),
(111988, 'West Williamson', 37.6758308410645, 0.657567296600999, -82.2922210693359, -1.43627020643896, 218, 58, 'PPL', 'P'),
(114266, 'West Willington', 41.8811111450195, 0.730963283874283, -72.3024978637695, -1.26191664513895, 218, 8, 'PPL', 'P'),
(79391, 'West Willow', 39.9727783203125, 0.697656592859262, -76.288330078125, -1.3314825407115, 218, 45, 'PPL', 'P'),
(168834, 'West Wilmerding', 40.398609161377, 0.705088743092373, -79.8211135864258, -1.39314124469151, 218, 45, 'PPL', 'P'),
(144662, 'West Wilton', 42.8302803039551, 0.747529410856094, -71.8063888549805, -1.25325790948677, 218, 36, 'PPL', 'P'),
(25931, 'West Wind', 33.0936088562012, 0.577592435907865, -85.0138931274414, -1.48377234501243, 218, 13, 'PPL', 'P'),
(144663, 'West Windham', 42.8025016784668, 0.747044582379645, -71.3525009155273, -1.24533607050822, 218, 36, 'PPL', 'P'),
(129303, 'West Windsor', 44.3383293151855, 0.77384983138351, -69.6066665649414, -1.21486551289608, 218, 26, 'PPL', 'P'),
(133667, 'West Windsor', 42.6472206115723, 0.744334416496326, -84.6972198486328, -1.47824535364414, 218, 27, 'PPL', 'P'),
(153713, 'West Windsor', 42.0988883972168, 0.734764213961072, -75.7644424438477, -1.32233897658288, 218, 40, 'PPL', 'P'),
(153714, 'West Winfield', 42.8852806091309, 0.748489347271013, -75.1936111450195, -1.31237609094489, 218, 40, 'PPL', 'P'),
(168835, 'West Winfield', 40.7941703796387, 0.71199258874424, -79.6972198486328, -1.39097889104442, 218, 45, 'PPL', 'P'),
(179495, 'West Winslow', 35.0402793884277, 0.611568246146769, -110.741668701172, -1.9328067379882, 218, 5, 'PPL', 'P'),
(25932, 'West Winter', 33.9608306884766, 0.592728312226249, -83.2983322143555, -1.45383015856056, 218, 13, 'PPL', 'P'),
(129304, 'West Winterport', 44.6208305358887, 0.778780407825683, -68.9530563354492, -1.20345786236672, 218, 26, 'PPL', 'P'),
(25933, 'West Wood', 32.9913902282715, 0.575808384293621, -85.095832824707, -1.4852024625178, 218, 13, 'PPL', 'P'),
(201780, 'West Woodburn', 45.1549987792969, 0.788103402432751, -122.894721984863, -2.14491753195893, 218, 43, 'PPL', 'P'),
(158314, 'West Woodly Addition', 41.5872192382813, 0.725833902456736, -84.6380615234375, -1.47721284608951, 218, 41, 'PPL', 'P'),
(52649, 'West Woods', 38.9791717529297, 0.680314886788993, -76.5466690063477, -1.33599140559506, 218, 25, 'PPL', 'P'),
(107442, 'West Woods', 38.0766716003418, 0.664563287626583, -78.5872192382813, -1.37160572569464, 218, 53, 'PPL', 'P'),
(114267, 'West Woods', 41.8091697692871, 0.729707669999338, -73.4752807617188, -1.28238556811924, 218, 8, 'PPL', 'P'),
(206410, 'West Woods Mobile Homes PUD', 40.8827781677246, 0.713539086389249, -111.916389465332, -1.95330948311434, 218, 52, 'PPL', 'P'),
(114268, 'West Woodstock', 41.9544410705566, 0.732243132515148, -72.0458297729492, -1.25743694186932, 218, 8, 'PPL', 'P'),
(153715, 'West Woodstock', 42.8469390869141, 0.747820161468103, -75.8819427490234, -1.3243897437803, 218, 40, 'PPL', 'P'),
(172770, 'West Woodstock', 43.6169395446777, 0.761259204697943, -72.5425033569336, -1.26610553121753, 218, 55, 'PPL', 'P'),
(126582, 'West Worthington', 42.4230613708496, 0.740422099696945, -72.9869384765625, -1.27386238736655, 218, 23, 'PPL', 'P'),
(126583, 'West Wrentham', 42.0250015258789, 0.733474644782228, -71.4119415283203, -1.24637350491086, 218, 23, 'PPL', 'P'),
(25934, 'West Wyngate', 33.0158309936523, 0.576234956121224, -85.1188888549805, -1.48560486615852, 218, 13, 'PPL', 'P'),
(168836, 'West Wyoming', 41.3197212219238, 0.721165181328745, -75.8463897705078, -1.32376922724631, 218, 45, 'PPL', 'P'),
(168838, 'West Wyomissing', 40.3244400024414, 0.703794247065513, -75.9911117553711, -1.32629510238219, 218, 45, 'PPL', 'P'),
(70011, 'West Yanceyville', 36.4061088562012, 0.635406467380177, -79.3872222900391, -1.38556841297381, 218, 33, 'PPL', 'P'),
(118425, 'West Yards', 43.0424995422363, 0.751233335300176, -91.2005615234375, -1.59175007825164, 218, 16, 'PPL', 'P'),
(126584, 'West Yarmouth', 41.6500015258789, 0.726929660087249, -70.2416687011719, -1.2259483909305, 218, 23, 'PPL', 'P'),
(197821, 'West Yellowstone', 44.6622200012207, 0.779502790271367, -111.103332519531, -1.93911896240391, 218, 31, 'PPL', 'P'),
(28948, 'West York', 39.1711082458496, 0.683664810545176, -87.6736068725586, -1.53019310702528, 218, 18, 'PPL', 'P'),
(79392, 'West York', 39.9524993896484, 0.69730265875039, -76.7516708374023, -1.33956936251958, 218, 45, 'PPL', 'P'),
(74784, 'West Zanesville', 39.9458312988281, 0.697186278610754, -82.0180587768555, -1.43148517175036, 218, 41, 'PPL', 'P'),
(168839, 'West Zollarsville', 40.0252799987793, 0.698572920011331, -80.0891723632813, -1.39781975293651, 218, 45, 'PPL', 'P'),
(133668, 'Westacres', 42.5999984741211, 0.743510234717974, -83.4250030517578, -1.45604098173949, 218, 27, 'PPL', 'P'),
(197822, 'Westana Mobile Home Park', 46.2216682434082, 0.806720296611977, -114.14582824707, -1.99222053032732, 218, 31, 'PPL', 'P'),
(158316, 'Westarado', 40.7738914489746, 0.711638654635368, -81.5455627441406, -1.42323856027688, 218, 41, 'PPL', 'P'),
(91763, 'Westavia Woods', 35.9458312988281, 0.62737310853098, -84.0372161865234, -1.46672611666511, 218, 50, 'PPL', 'P'),
(38823, 'Westbend', 37.9058303833008, 0.661581545891103, -83.9691696166992, -1.46553847997699, 218, 21, 'PPL', 'P'),
(52650, 'Westboro', 38.9891700744629, 0.68048939041942, -77.091667175293, -1.3455034180605, 218, 25, 'PPL', 'P'),
(74785, 'Westboro', 39.2813911437988, 0.685589610223031, -83.9105606079102, -1.46451555980229, 218, 41, 'PPL', 'P'),
(139521, 'Westboro', 40.5347213745117, 0.707464349363751, -95.3188934326172, -1.66362852975677, 218, 29, 'PPL', 'P'),
(176983, 'Westboro', 45.355281829834, 0.791599001100562, -90.2958297729492, -1.57595953035829, 218, 57, 'PPL', 'P'),
(107448, 'Westboro (historical)', 37.0325012207031, 0.646339076550089, -77.8866729736328, -1.35937888681398, 218, 53, 'PPL', 'P'),
(91764, 'Westborough', 35.9436111450195, 0.62733435953712, -84.0558319091797, -1.4670510223181, 218, 50, 'PPL', 'P'),
(126585, 'Westborough', 42.2694396972656, 0.73774089569048, -71.6166687011719, -1.24994666814542, 218, 23, 'PPL', 'P'),
(186091, 'Westborough', 37.6436080932617, 0.657004903557802, -122.457778930664, -2.13729143701943, 218, 6, 'PPL', 'P'),
(91765, 'Westbourne', 36.4936103820801, 0.636933657107283, -84.0294418334961, -1.46659042860757, 218, 50, 'PPL', 'P'),
(107445, 'Westbourne', 37.1958312988281, 0.64918972418091, -77.414436340332, -1.35113680271434, 218, 53, 'PPL', 'P'),
(107446, 'Westbriar', 37.6230583190918, 0.656646242337995, -77.5627822875977, -1.35372592792612, 218, 53, 'PPL', 'P'),
(179496, 'Westbriar', 33.4980583190918, 0.584651410693229, -112.251670837402, -1.95916124697757, 218, 5, 'PPL', 'P'),
(25935, 'Westbridge', 33.5305595397949, 0.585218664005416, -84.4824981689453, -1.47449775335818, 218, 13, 'PPL', 'P'),
(58231, 'Westbridge', 39.5394401550293, 0.690093415100518, -94.5005569458008, -1.64934586367262, 218, 29, 'PPL', 'P'),
(6730, 'Westbrook', 32.3233299255371, 0.564148532409036, -87.3333282470703, -1.52425412463634, 218, 2, 'PPL', 'P'),
(70015, 'Westbrook', 34.4752807617188, 0.601707159841451, -78.4227828979492, -1.36873577014591, 218, 33, 'PPL', 'P'),
(91766, 'Westbrook', 35.060001373291, 0.611912459717662, -86.5972213745117, -1.51140663606364, 218, 50, 'PPL', 'P'),
(107447, 'Westbrook', 37.396671295166, 0.652695043386699, -79.2158279418945, -1.38257701727938, 218, 53, 'PPL', 'P'),
(114269, 'Westbrook', 41.2852783203125, 0.720564039291687, -72.4480590820313, -1.26445716766083, 218, 8, 'PPL', 'P'),
(126587, 'Westbrook', 42.4130592346191, 0.74024752948749, -72.6297225952148, -1.26762779409662, 218, 23, 'PPL', 'P'),
(129305, 'Westbrook', 43.6769409179688, 0.762306426217589, -70.3716735839844, -1.22821740417925, 218, 26, 'PPL', 'P'),
(138779, 'Westbrook', 44.0422210693359, 0.76868176755113, -95.4358291625977, -1.66566944325815, 218, 28, 'PPL', 'P'),
(192414, 'Westbrook', 32.355281829834, 0.564706198341299, -101.013328552246, -1.76301517163549, 218, 51, 'PPL', 'P'),
(206411, 'Westbrook', 40.6375007629395, 0.709258188095001, -111.969436645508, -1.95423533106731, 218, 52, 'PPL', 'P'),
(12766, 'Westbrook (historical)', 33.9402809143066, 0.592369651006442, -93.6397171020508, -1.63432137406683, 218, 4, 'PPL', 'P'),
(25936, 'Westbrook (historical)', 32.2438888549805, 0.562762024166514, -83.0013885498047, -1.44864751392121, 218, 13, 'PPL', 'P'),
(58232, 'Westbrook (historical)', 36.0449981689453, 0.629103896923423, -89.8858337402344, -1.5688037496673, 218, 29, 'PPL', 'P'),
(99018, 'Westbrook (historical)', 30.2683296203613, 0.52828201095423, -98.5252838134766, -1.71959059900704, 218, 51, 'PPL', 'P'),
(12768, 'Westbrook Addition', 34.9527816772461, 0.61004112299869, -92.0747222900391, -1.60700706182059, 218, 4, 'PPL', 'P'),
(70017, 'Westbrook Crossroads', 35.038330078125, 0.611534224263843, -77.9452819824219, -1.36040180698867, 218, 33, 'PPL', 'P'),
(79394, 'Westbrook Park', 39.9352798461914, 0.697002121021375, -75.3086090087891, -1.31438318230043, 218, 45, 'PPL', 'P'),
(74786, 'Westbrook Village', 38.8411102294922, 0.677905258634689, -82.2125015258789, -1.43487883792745, 218, 41, 'PPL', 'P'),
(118417, 'Westbrook Village', 43.0833282470703, 0.751945930628854, -96.1847229003906, -1.67874010473021, 218, 16, 'PPL', 'P'),
(126588, 'Westbrook Village', 42.2999992370605, 0.738274260277796, -71.154167175293, -1.24187449372334, 218, 23, 'PPL', 'P'),
(179497, 'Westbrook Village', 33.6572189331055, 0.587429287447264, -112.277496337891, -1.95961198699207, 218, 5, 'PPL', 'P'),
(25937, 'Westbrooke', 32.4277801513672, 0.565971532754223, -81.8072204589844, -1.42780534891414, 218, 13, 'PPL', 'P'),
(153716, 'Westbrookville', 41.4986114501953, 0.724287404811727, -74.5588912963867, -1.30129813975849, 218, 40, 'PPL', 'P'),
(25938, 'Westbury', 33.8663902282715, 0.591080015248571, -83.4411087036133, -1.45632207839255, 218, 13, 'PPL', 'P'),
(52651, 'Westbury', 39.4474983215332, 0.688488727385691, -76.8230590820313, -1.34081532243558, 218, 25, 'PPL', 'P'),
(99020, 'Westbury', 30.1019401550293, 0.525377966943554, -94.309440612793, -1.6460102544073, 218, 51, 'PPL', 'P'),
(138782, 'Westbury', 46.9172210693359, 0.818859983545967, -95.9094390869141, -1.67393549580759, 218, 28, 'PPL', 'P'),
(153718, 'Westbury', 40.7555618286133, 0.711318742409423, -73.5880584716797, -1.28435391048092, 218, 40, 'PPL', 'P'),
(168841, 'Westbury', 40.1624984741211, 0.700967834200612, -75.1105575561523, -1.31092653236356, 218, 45, 'PPL', 'P'),
(52652, 'Westbury Acres', 38.3644409179688, 0.669585809705391, -75.6638870239258, -1.32058395342452, 218, 25, 'PPL', 'P'),
(153719, 'Westbury South', 40.7522201538086, 0.71126041918155, -73.5622177124023, -1.28390290415031, 218, 40, 'PPL', 'P'),
(176985, 'Westby', 43.6569404602051, 0.761957352377707, -90.8541717529297, -1.58570443626105, 218, 57, 'PPL', 'P'),
(197823, 'Westby', 48.8702812194824, 0.852947313655518, -104.051391601563, -1.81603937472924, 218, 31, 'PPL', 'P'),
(13248, 'Westchester', 38.9258308410645, 0.679383912250928, -77.0800018310547, -1.34529981939516, 218, 9, 'PPL', 'P'),
(18571, 'Westchester', 25.7544403076172, 0.449499780376261, -80.3274993896484, -1.4019793442431, 218, 12, 'PPL', 'P'),
(25939, 'Westchester', 32.476390838623, 0.566819949298495, -81.7947235107422, -1.42758723602087, 218, 13, 'PPL', 'P'),
(44087, 'Westchester', 30.3549995422363, 0.529794686453395, -91.0708312988281, -1.58948585869285, 218, 22, 'PPL', 'P'),
(52654, 'Westchester', 39.4644393920898, 0.688784404845717, -77.543327331543, -1.35338637488713, 218, 25, 'PPL', 'P'),
(74787, 'Westchester', 39.3302803039551, 0.686442887036292, -84.408332824707, -1.47320332391034, 218, 41, 'PPL', 'P'),
(84297, 'Westchester', 32.7133293151855, 0.57095530583917, -79.9611129760742, -1.39558469499166, 218, 48, 'PPL', 'P'),
(107451, 'Westchester', 38.7041702270508, 0.675515204714397, -77.4688873291016, -1.35208715174934, 218, 53, 'PPL', 'P'),
(111989, 'Westchester', 39.4724998474121, 0.688925086330301, -80.1822204589844, -1.39944374856924, 218, 58, 'PPL', 'P'),
(114271, 'Westchester', 41.5505599975586, 0.725194078004844, -72.4124984741211, -1.26383651796878, 218, 8, 'PPL', 'P'),
(121942, 'Westchester', 41.8505592346191, 0.730430052445022, -87.8819427490234, -1.53382925401962, 218, 18, 'PPL', 'P'),
(123993, 'Westchester', 40.4983291625977, 0.706829185443767, -84.8949966430664, -1.48169720989104, 218, 19, 'PPL', 'P'),
(126589, 'Westchester', 42.2999992370605, 0.738274260277796, -71.8291702270508, -1.25365551943752, 218, 23, 'PPL', 'P'),
(153720, 'Westchester', 40.8472213745117, 0.712918503276233, -73.8552780151367, -1.28901777133992, 218, 40, 'PPL', 'P'),
(186092, 'Westchester', 33.9597206115723, 0.592708937729318, -118.399719238281, -2.06646493414488, 218, 6, 'PPL', 'P'),
(107452, 'Westchester Court', 37.2508316040039, 0.650149660595829, -80.029167175293, -1.39677246483783, 218, 53, 'PPL', 'P'),
(31500, 'Westchester Estates', 39.8972206115723, 0.696337862066482, -86.2077789306641, -1.50460958317148, 218, 19, 'PPL', 'P'),
(133669, 'Westchester Heights', 42.9191703796387, 0.74908083534912, -84.3811111450195, -1.47272821597187, 218, 27, 'PPL', 'P'),
(70024, 'Westcliff', 35.709171295166, 0.623242612259295, -80.5325012207031, -1.40555730116762, 218, 33, 'PPL', 'P'),
(99021, 'Westcliff', 31.1149997711182, 0.543059192763294, -97.51611328125, -1.70197725050558, 218, 51, 'PPL', 'P'),
(179498, 'Westcliff Park', 33.6130599975586, 0.586658568627795, -112.15389251709, -1.95745469335105, 218, 5, 'PPL', 'P'),
(84300, 'Westcliffe', 34.8652801513672, 0.608513933271584, -82.4686126708984, -1.43934882065909, 218, 48, 'PPL', 'P'),
(187530, 'Westcliffe', 38.1347198486328, 0.665576420684276, -105.465278625488, -1.84071635854797, 218, 7, 'PPL', 'P'),
(52656, 'Westcliffe Manor', 39.3388900756836, 0.6865931559008, -76.9902801513672, -1.3437338806742, 218, 25, 'PPL', 'P'),
(168842, 'Westcolang', 41.5127792358398, 0.724534679318941, -75.0055618286133, -1.30909401121748, 218, 45, 'PPL', 'P'),
(168844, 'Westcolang Park', 41.5144386291504, 0.724563641195796, -75.0388870239258, -1.30967564559955, 218, 45, 'PPL', 'P'),
(99022, 'Westcott', 30.4127807617188, 0.530803158979181, -95.0477828979492, -1.65889675828997, 218, 51, 'PPL', 'P'),
(169669, 'Westcott', 41.7147216796875, 0.728059239863606, -71.4961090087891, -1.24784250456815, 218, 47, 'PPL', 'P'),
(58233, 'Westcott (historical)', 37.9719390869141, 0.66273536043338, -91.8983306884766, -1.60392844760046, 218, 29, 'PPL', 'P'),
(114272, 'Westcott (historical)', 41.0488891601563, 0.716438270130937, -73.5119400024414, -1.28302539257113, 218, 8, 'PPL', 'P'),
(71552, 'Westcotville', 39.8261108398438, 0.695096762419477, -75.1158294677734, -1.31101854457923, 218, 37, 'PPL', 'P'),
(206416, 'Westcove', 40.6713905334473, 0.709849676173108, -111.96443939209, -1.95414811254161, 218, 52, 'PPL', 'P'),
(187529, 'Westcreek', 39.1525001525879, 0.683340038050241, -105.163063049316, -1.83544170169296, 218, 7, 'PPL', 'P'),
(44089, 'Westdale', 32.1647186279297, 0.561380243034926, -93.4797210693359, -1.63152891650583, 218, 22, 'PPL', 'P'),
(99023, 'Westdale', 27.9658298492432, 0.488095808921803, -97.980827331543, -1.71008804076347, 218, 51, 'PPL', 'P'),
(126590, 'Westdale', 42.0202789306641, 0.73339221994649, -70.9833297729492, -1.23889281856688, 218, 23, 'PPL', 'P'),
(153723, 'Westdale', 43.3877792358398, 0.757259602793835, -75.815559387207, -1.32323113554806, 218, 40, 'PPL', 'P'),
(99024, 'Westdale Estates Number 1 Colonia', 27.9659996032715, 0.488098771688515, -97.9769973754883, -1.71002119542011, 218, 51, 'PPL', 'P'),
(99025, 'Westdale Estates Number 2 Colonia', 27.9699993133545, 0.488168579798589, -97.9769973754883, -1.71002119542011, 218, 51, 'PPL', 'P'),
(99026, 'Westdale Estates Number 3 Colonia', 27.9759998321533, 0.488273308608456, -97.9759979248047, -1.71000375171497, 218, 51, 'PPL', 'P'),
(99027, 'Westdale Estates Number 4 Colonia', 27.9729995727539, 0.488220944203523, -97.9769973754883, -1.71002119542011, 218, 51, 'PPL', 'P'),
(91767, 'Westel', 35.8630599975586, 0.625928476797667, -84.7552795410156, -1.47925868643891, 218, 50, 'PPL', 'P'),
(52657, 'Westelee', 38.839168548584, 0.677871369909818, -76.529167175293, -1.33568594101803, 218, 25, 'PPL', 'P'),
(186093, 'Westend', 35.7069396972656, 0.623203663528352, -117.391387939453, -2.04886623302942, 218, 6, 'PPL', 'P'),
(194049, 'Westend Galatin Place (historical)', 40.0244407653809, 0.698558272625335, -122.518058776855, -2.13834351880806, 218, 6, 'PPL', 'P'),
(107454, 'Westerhouse Woods', 37.4427795410156, 0.653499784089094, -75.9705581665039, -1.32593637458336, 218, 53, 'PPL', 'P'),
(91768, 'Westeria (historical)', 36.329719543457, 0.634073222359456, -86.9413909912109, -1.51741352906037, 218, 50, 'PPL', 'P'),
(153724, 'Westerlea', 43.047779083252, 0.751325480673893, -76.2752838134766, -1.3312548404383, 218, 40, 'PPL', 'P'),
(14832, 'Westerlee', 38.4583282470703, 0.671224452724116, -75.5888900756836, -1.31927500974874, 218, 10, 'PPL', 'P'),
(52658, 'Westerlee', 39.2919387817383, 0.685773701233383, -76.7644424438477, -1.33979226910282, 218, 25, 'PPL', 'P'),
(153725, 'Westerleigh', 40.6211090087891, 0.708972098014899, -74.1322174072266, -1.29385127556036, 218, 40, 'PPL', 'P'),
(153726, 'Westerlo', 42.5149993896484, 0.742026720832745, -74.0458297729492, -1.29234352690921, 218, 40, 'PPL', 'P'),
(203, 'Westerly', 37.9922218322754, 0.663089361121278, -81.3208312988281, -1.41931625662341, 218, 58, 'PPL', 'P'),
(169670, 'Westerly', 41.377498626709, 0.722173587275504, -71.8277816772461, -1.2536312846716, 218, 47, 'PPL', 'P'),
(111990, 'Westerman (historical)', 39.3558311462402, 0.686888833360826, -79.9333267211914, -1.39509973335715, 218, 58, 'PPL', 'P'),
(12769, 'Western', 33.0463905334473, 0.57676832070854, -93.341667175293, -1.62911942150958, 218, 4, 'PPL', 'P'),
(118419, 'Western', 41.8652801513672, 0.730686980911187, -91.6430587768555, -1.59947311225482, 218, 16, 'PPL', 'P'),
(138784, 'Western', 46.1519393920898, 0.805503298572838, -96.1827774047852, -1.67870614942631, 218, 28, 'PPL', 'P'),
(143371, 'Western', 40.3936080932617, 0.705001457987646, -97.1977767944336, -1.69642123068141, 218, 35, 'PPL', 'P'),
(123995, 'Western Acres', 41.5991706848145, 0.726042494549117, -87.083610534668, -1.51989572835438, 218, 19, 'PPL', 'P'),
(118420, 'Western Acres Mobile Home Park', 41.4936103820801, 0.724200119707, -93.4869384765625, -1.63165488402539, 218, 16, 'PPL', 'P'),
(179499, 'Western Acres Mobile Home Park', 33.4527816772461, 0.583861184218775, -112.199722290039, -1.95825457378445, 218, 5, 'PPL', 'P'),
(179500, 'Western Acres Mobile Park', 33.4144401550293, 0.583191998415866, -111.624168395996, -1.94820926331073, 218, 5, 'PPL', 'P'),
(99028, 'Western Estates Number 1 Colonia', 26.3229999542236, 0.459423018203519, -98.3949966430664, -1.71731665891028, 218, 51, 'PPL', 'P'),
(12771, 'Western Grove', 36.100830078125, 0.630078347566283, -92.95361328125, -1.62234660338334, 218, 4, 'PPL', 'P'),
(6734, 'Western Hills', 33.2599983215332, 0.580496479918542, -87.7136077880859, -1.53089125470504, 218, 2, 'PPL', 'P'),
(44093, 'Western Hills', 32.5486106872559, 0.568080423442429, -92.2111129760742, -1.60938752836096, 218, 22, 'PPL', 'P'),
(107456, 'Western Hills', 37.2472190856934, 0.650086610257021, -80.0111083984375, -1.39645727972282, 218, 53, 'PPL', 'P'),
(187531, 'Western Hills', 39.832218170166, 0.695203355442108, -104.996673583984, -1.83253765768228, 218, 7, 'PPL', 'P'),
(6737, 'Western Hills Estates', 33.2558288574219, 0.580423709041756, -87.7149963378906, -1.53091548947096, 218, 2, 'PPL', 'P'),
(118421, 'Western Hills Mobine Estates', 41.7055587768555, 0.727899317040147, -91.6305618286133, -1.59925499936154, 218, 16, 'PPL', 'P'),
(12772, 'Western Hills Subdivision', 36.3199996948242, 0.633903578998018, -92.4049987792969, -1.61277147400007, 218, 4, 'PPL', 'P'),
(209154, 'Western Junction', 46.9091682434082, 0.818719435219438, -122.791107177734, -2.14310911242071, 218, 56, 'PPL', 'P'),
(129308, 'Western Landing', 43.7138900756836, 0.762951310675552, -70.120002746582, -1.22382491943532, 218, 26, 'PPL', 'P'),
(133671, 'Western Location', 46.101390838623, 0.804621059882722, -88.3141708374023, -1.54137305728143, 218, 27, 'PPL', 'P'),
(179501, 'Western Palms Mobile Home Community', 33.4550018310547, 0.583899933212636, -112.205001831055, -1.95834671915817, 218, 5, 'PPL', 'P'),
(158317, 'Western Reserve Estates', 41.2641716003418, 0.720195657533902, -81.4108276367188, -1.42088698903434, 218, 41, 'PPL', 'P'),
(52661, 'Western Run', 39.5149993896484, 0.689666843272915, -76.6797180175781, -1.33831354890756, 218, 25, 'PPL', 'P'),
(52662, 'Western Shore Estates', 38.4861106872559, 0.671709347779592, -76.4974975585938, -1.33513320193378, 218, 25, 'PPL', 'P'),
(52663, 'Western Shores', 38.4913902282715, 0.671801493153309, -76.5116729736328, -1.33538060959905, 218, 25, 'PPL', 'P'),
(121944, 'Western Springs', 41.8097190856934, 0.729717257379262, -87.9005584716797, -1.53415415967261, 218, 18, 'PPL', 'P'),
(158318, 'Western Star', 41.0255584716797, 0.716031072800263, -81.6880569458008, -1.42572555326085, 218, 41, 'PPL', 'P'),
(206423, 'Western Sun', 40.7019386291504, 0.710382841023342, -112.069442749023, -1.95598076684574, 218, 52, 'PPL', 'P'),
(123996, 'Western Village', 40.1080589294434, 0.700017684902699, -85.7172164916992, -1.49604765342493, 218, 19, 'PPL', 'P'),
(118422, 'Western Village Mobile Home Park', 41.5688896179199, 0.72551399023079, -93.7294387817383, -1.6358873127878, 218, 16, 'PPL', 'P'),
(192858, 'Westerner Trailer Park', 37.8624992370605, 0.660825274720548, -109.341667175293, -1.90837210182867, 218, 52, 'PPL', 'P'),
(52664, 'Westernport', 39.485279083252, 0.689148126071595, -79.0449981689453, -1.37959547528098, 218, 25, 'PPL', 'P'),
(153729, 'Westernville', 43.3055610656738, 0.755824625019473, -75.3833312988281, -1.31568733228624, 218, 40, 'PPL', 'P'),
(179502, 'Westerra', 33.5986099243164, 0.586406367272564, -112.189437866211, -1.95807507672698, 218, 5, 'PPL', 'P'),
(28951, 'Westervelt', 39.478889465332, 0.689036606200948, -88.8616714477539, -1.55092874558874, 218, 18, 'PPL', 'P'),
(143375, 'Westerville', 41.396110534668, 0.722498426349466, -99.3805618286133, -1.7345180163911, 218, 35, 'PPL', 'P'),
(158319, 'Westerville', 40.1261100769043, 0.700332736859655, -82.9291687011719, -1.44738703977728, 218, 41, 'PPL', 'P'),
(70033, 'Westerwood', 36.0791702270508, 0.629700311849546, -79.8038864135742, -1.39284057380444, 218, 33, 'PPL', 'P'),
(34389, 'Westfall', 38.9300003051758, 0.679456683127715, -98.0111083984375, -1.7106165450818, 218, 20, 'PPL', 'P'),
(74789, 'Westfall', 39.5580596923828, 0.690418387332535, -82.9991683959961, -1.44860876492735, 218, 41, 'PPL', 'P'),
(197824, 'Westfall', 47.1211090087891, 0.822418499394531, -114.78694152832, -2.0034100679634, 218, 31, 'PPL', 'P'),
(201781, 'Westfall', 43.9919395446777, 0.767804189392922, -117.708061218262, -2.05439322439771, 218, 43, 'PPL', 'P'),
(723, 'Westfield', 33.1258316040039, 0.578154828951063, -90.2608337402344, -1.57534873436228, 218, 30, 'PPL', 'P'),
(6740, 'Westfield', 32.961109161377, 0.575279879975295, -85.9794387817383, -1.50062429575824, 218, 2, 'PPL', 'P'),
(14834, 'Westfield', 39.7180595397949, 0.693210911472565, -75.6416702270508, -1.3201961971698, 218, 10, 'PPL', 'P'),
(25942, 'Westfield', 34.0280609130859, 0.593901701002538, -84.4172210693359, -1.47335845304384, 218, 13, 'PPL', 'P'),
(28952, 'Westfield', 39.4563903808594, 0.688643923098216, -87.9961090087891, -1.53582183114721, 218, 18, 'PPL', 'P'),
(44097, 'Westfield', 29.9841709136963, 0.523322505924717, -91.0794372558594, -1.58963606097834, 218, 22, 'PPL', 'P'),
(58234, 'Westfield', 37.8619384765625, 0.660815487603542, -92.9641723632813, -1.62253089413078, 218, 29, 'PPL', 'P'),
(70035, 'Westfield', 36.4752807617188, 0.636613744881337, -80.4469375610352, -1.40406393358636, 218, 33, 'PPL', 'P'),
(99029, 'Westfield', 30.0197200775146, 0.523942955879678, -95.4019393920898, -1.66507795518005, 218, 51, 'PPL', 'P'),
(107460, 'Westfield', 37.2919387817383, 0.650867116193496, -80.0758285522461, -1.39758685949918, 218, 53, 'PPL', 'P'),
(111995, 'Westfield', 39.1055603027344, 0.682520783119905, -80.4555587768555, -1.40421440218795, 218, 58, 'PPL', 'P'),
(114273, 'Westfield', 41.5847206115723, 0.725790293193886, -72.7011108398438, -1.26887375401261, 218, 8, 'PPL', 'P'),
(118424, 'Westfield', 41.7041702270508, 0.727875082274227, -92.7605590820313, -1.61897717197217, 218, 16, 'PPL', 'P'),
(123998, 'Westfield', 41.6755599975586, 0.727375739569837, -86.3802795410156, -1.50762028678382, 218, 19, 'PPL', 'P'),
(126591, 'Westfield', 42.125, 0.735219947402611, -72.75, -1.26972703082587, 218, 23, 'PPL', 'P'),
(129309, 'Westfield', 46.5702781677246, 0.812804687596426, -67.9230575561523, -1.18548099237647, 218, 26, 'PPL', 'P'),
(146626, 'Westfield', 40.6588897705078, 0.709631496700803, -74.3477783203125, -1.29761352323231, 218, 37, 'PPL', 'P'),
(153730, 'Westfield', 42.3222198486328, 0.738662083111539, -79.5783309936523, -1.38890388908108, 218, 40, 'PPL', 'P'),
(158321, 'Westfield', 40.4322204589844, 0.70567537090149, -82.9819412231445, -1.44830809404028, 218, 41, 'PPL', 'P'),
(168846, 'Westfield', 41.9191703796387, 0.731627542829176, -77.5391693115234, -1.35331380374743, 218, 45, 'PPL', 'P'),
(172771, 'Westfield', 44.8894386291504, 0.783468503450604, -72.4288864135742, -1.26412254146986, 218, 55, 'PPL', 'P'),
(176987, 'Westfield', 43.8836097717285, 0.76591347817702, -89.4933319091797, -1.56195330039529, 218, 57, 'PPL', 'P'),
(186095, 'Westfield', 36.0911102294922, 0.629908704204845, -119.043609619141, -2.0777029413128, 218, 6, 'PPL', 'P'),
(199081, 'Westfield', 46.0294418334961, 0.803365312849722, -100.201942443848, -1.748853812539, 218, 34, 'PPL', 'P'),
(70036, 'Westfield Acres', 36.4305610656738, 0.635833238944862, -79.6944427490234, -1.39093042151258, 218, 33, 'PPL', 'P'),
(158322, 'Westfield Center', 41.0263900756836, 0.716045587028204, -81.9333267211914, -1.43000631839704, 218, 41, 'PPL', 'P'),
(138786, 'Westfield Center (historical)', 43.9502792358398, 0.767077079836303, -92.9649963378906, -1.62254527520066, 218, 28, 'PPL', 'P'),
(121946, 'Westfield Corners', 42.2083282470703, 0.736674299673904, -89.230827331543, -1.55737173121397, 218, 18, 'PPL', 'P'),
(99030, 'Westfield Estates', 29.874719619751, 0.521412220474803, -95.353889465332, -1.66423932575278, 218, 51, 'PPL', 'P'),
(52665, 'Westfield Station', 38.5644416809082, 0.673076481525185, -76.6266708374023, -1.33738770095459, 218, 25, 'PPL', 'P'),
(168847, 'Westfield Terrace', 40.2105598449707, 0.701806663364959, -76.8658294677734, -1.34156180648913, 218, 45, 'PPL', 'P'),
(201782, 'Westfir', 43.7574996948242, 0.763712442115097, -122.495277404785, -2.13794590885732, 218, 43, 'PPL', 'P'),
(114274, 'Westford', 41.920280456543, 0.731646917326107, -72.1766662597656, -1.25972046934601, 218, 8, 'PPL', 'P'),
(126593, 'Westford', 42.5791702270508, 0.743146713229178, -71.4383316040039, -1.24683409862139, 218, 23, 'PPL', 'P'),
(153732, 'Westford', 42.6500015258789, 0.744382952607192, -74.7980575561523, -1.30547237845108, 218, 40, 'PPL', 'P'),
(168850, 'Westford', 41.5574989318848, 0.725315185255416, -80.478889465332, -1.40462159951862, 218, 45, 'PPL', 'P'),
(172773, 'Westford', 44.6119384765625, 0.778625212113159, -73.0091705322266, -1.27425040993737, 218, 55, 'PPL', 'P'),
(126594, 'Westford Station', 42.5969390869141, 0.743456838338117, -71.4358291625977, -1.24679042277951, 218, 23, 'PPL', 'P'),
(25944, 'Westfork', 34.0047187805176, 0.593494303934783, -84.8375015258789, -1.4806937307923, 218, 13, 'PPL', 'P'),
(91771, 'Westfork (historical)', 36.415828704834, 0.635576110741615, -85.1536102294922, -1.48621086846456, 218, 50, 'PPL', 'P'),
(18573, 'Westgate', 25.8380603790283, 0.450959225943138, -80.2513885498047, -1.40065095949137, 218, 12, 'PPL', 'P'),
(25945, 'Westgate', 34.2586097717285, 0.597925537672566, -83.8716735839844, -1.46383685319848, 218, 13, 'PPL', 'P'),
(44098, 'Westgate', 30.0025005340576, 0.523642418150663, -90.2252807617188, -1.57472821782829, 218, 22, 'PPL', 'P'),
(52667, 'Westgate', 38.9569396972656, 0.679926864218168, -76.857780456543, -1.34142132474163, 218, 25, 'PPL', 'P'),
(84305, 'Westgate', 33.9727783203125, 0.592936837739602, -81.1180572509766, -1.4157771818508, 218, 48, 'PPL', 'P'),
(91773, 'Westgate', 36.1688919067383, 0.631266250570513, -85.6069412231445, -1.49412298690513, 218, 50, 'PPL', 'P'),
(107464, 'Westgate', 36.7277793884277, 0.641020677274173, -76.6405563354492, -1.33763004861379, 218, 53, 'PPL', 'P'),
(118428, 'Westgate', 42.7700004577637, 0.746477329067458, -91.9961090087891, -1.60563500122699, 218, 16, 'PPL', 'P'),
(186096, 'Westgate', 34.0508308410645, 0.594299111216205, -118.478332519531, -2.06783699473849, 218, 6, 'PPL', 'P'),
(212226, 'Westgate', 64.8372192382813, 1.13162295354542, -147.795837402344, -2.57952398341308, 218, 1, 'PPL', 'P'),
(99031, 'Westgate Estates Colonia', 26.1459999084473, 0.456333784628541, -98.0080032348633, -1.71056234975362, 218, 51, 'PPL', 'P'),
(14835, 'Westgate Farms', 39.7666702270508, 0.694059328016837, -75.6611099243164, -1.32053548389268, 218, 10, 'PPL', 'P'),
(168851, 'Westgate Hills', 40.6450004577637, 0.709389082462578, -75.4052810668945, -1.31607042800905, 218, 45, 'PPL', 'P'),
(18574, 'Westgate Lake Manor', 26.1230602264404, 0.455933411648161, -80.2063903808594, -1.3998655932859, 218, 12, 'PPL', 'P'),
(25949, 'Westgate Park', 33.9988899230957, 0.593392571181142, -83.4508285522461, -1.45649172175399, 218, 13, 'PPL', 'P'),
(126596, 'Westgate Park', 41.7208290100098, 0.728165832886237, -70.9402770996094, -1.23814140766532, 218, 23, 'PPL', 'P'),
(206427, 'Westglen Village Condominium', 40.6925010681152, 0.71021812450992, -111.946388244629, -1.95383306058465, 218, 52, 'PPL', 'P'),
(179503, 'Westgreen Estates', 33.5652809143066, 0.585824666311464, -112.251388549805, -1.95915632012955, 218, 5, 'PPL', 'P'),
(107465, 'Westgrove', 38.7649993896484, 0.676576873882958, -77.0572204589844, -1.34490220944441, 218, 53, 'PPL', 'P'),
(107466, 'Westham', 37.5888900756836, 0.656049893990899, -77.540283203125, -1.35333324482339, 218, 53, 'PPL', 'P'),
(107481, 'Westhampton', 38.9041709899902, 0.679005876534192, -77.1849975585938, -1.34713234054125, 218, 53, 'PPL', 'P'),
(126597, 'Westhampton', 42.3027801513672, 0.738322796388663, -72.7750015258789, -1.27016338977048, 218, 23, 'PPL', 'P'),
(153734, 'Westhampton', 40.8244400024414, 0.712520893325484, -72.6666717529297, -1.26827267855458, 218, 40, 'PPL', 'P'),
(153735, 'Westhampton Beach', 40.8030586242676, 0.712147717877737, -72.6149978637695, -1.26737079905143, 218, 40, 'PPL', 'P'),
(84306, 'Westhaven', 34.9513893127441, 0.610016821653743, -82.004997253418, -1.43125720516105, 218, 48, 'PPL', 'P'),
(99032, 'Westhaven', 29.8655605316162, 0.521252364230371, -98.2774963378906, -1.71526589171286, 218, 51, 'PPL', 'P'),
(107468, 'Westhaven', 36.8316688537598, 0.642833890502354, -76.3594436645508, -1.33272370693754, 218, 53, 'PPL', 'P'),
(194050, 'Westhaven', 41.0361099243164, 0.716215230389642, -124.110000610352, -2.16612814530281, 218, 6, 'PPL', 'P'),
(209155, 'Westhaven', 46.9086112976074, 0.818709714681459, -124.111938476563, -2.16616196744865, 218, 56, 'PPL', 'P'),
(107469, 'Westhaven Lakes', 36.7386093139648, 0.641209695132542, -76.6069412231445, -1.33704335422564, 218, 53, 'PPL', 'P'),
(107470, 'Westhaven Park', 36.8261108398438, 0.642736884859648, -76.3433303833008, -1.33244247712642, 218, 53, 'PPL', 'P'),
(6742, 'Westhill', 33.2511100769043, 0.580341350785045, -87.6833267211914, -1.53036275038671, 218, 2, 'PPL', 'P'),
(123999, 'Westhill', 41.4647216796875, 0.72369591673362, -87.0972213745117, -1.52013328232361, 218, 19, 'PPL', 'P'),
(158326, 'Westhill Heights', 41.0288887023926, 0.716089196291054, -80.8349990844727, -1.41083688487065, 218, 41, 'PPL', 'P'),
(112605, 'Westhoff', 29.1947193145752, 0.509543976234919, -97.470832824707, -1.7011869574521, 218, 51, 'PPL', 'P'),
(158327, 'Westhope', 41.2983283996582, 0.720791806143916, -83.9411087036133, -1.46504872465252, 218, 41, 'PPL', 'P'),
(199082, 'Westhope', 48.9094390869141, 0.853630747370259, -101.020278930664, -1.76313647862314, 218, 34, 'PPL', 'P'),
(79395, 'Westinghouse Village', 39.8688888549805, 0.695843379631081, -75.29638671875, -1.31416986309712, 218, 45, 'PPL', 'P'),
(637, 'Westlake', 38.3875007629395, 0.669988279925129, -75.5991668701172, -1.31945437364816, 218, 25, 'PPL', 'P'),
(25952, 'Westlake', 32.4888916015625, 0.567038128770799, -83.4836120605469, -1.45706390191419, 218, 13, 'PPL', 'P'),
(44100, 'Westlake', 31.7580604553223, 0.554282718992783, -93.1500015258789, -1.62577422486433, 218, 22, 'PPL', 'P'),
(99033, 'Westlake', 32.9911117553711, 0.575803524024632, -97.1947174072266, -1.69636783430155, 218, 51, 'PPL', 'P'),
(158328, 'Westlake', 41.4552803039551, 0.723531133641172, -81.9180603027344, -1.42973986912998, 218, 41, 'PPL', 'P'),
(193185, 'Westlake', 45.7294387817383, 0.798129271830518, -111.339996337891, -1.94324952525462, 218, 31, 'PPL', 'P'),
(195789, 'Westlake', 46.121940612793, 0.804979721102528, -116.50611114502, -2.03341523817505, 218, 17, 'PPL', 'P'),
(107471, 'Westlake Corner', 37.1230583190918, 0.647919596078024, -79.6997222900391, -1.3910225668863, 218, 53, 'PPL', 'P'),
(143377, 'Westlake Mobile Home Park', 41.4519386291504, 0.723472810413299, -96.5486068725586, -1.68509107813977, 218, 35, 'PPL', 'P'),
(52668, 'Westlake Village', 38.6222190856934, 0.674084887471943, -76.9361114501953, -1.34278845848722, 218, 25, 'PPL', 'P'),
(186100, 'Westlake Village', 34.1458282470703, 0.595957128731861, -118.804718017578, -2.07353349631017, 218, 6, 'PPL', 'P'),
(6743, 'Westland', 33.2380599975586, 0.580113583932816, -87.6786117553711, -1.53028045870903, 218, 2, 'PPL', 'P'),
(31502, 'Westland', 39.5833282470703, 0.690859406809052, -86.845832824707, -1.51574572442771, 218, 19, 'PPL', 'P'),
(74790, 'Westland', 39.5502815246582, 0.690282632695969, -81.8994369506836, -1.42941483031893, 218, 41, 'PPL', 'P'),
(99034, 'Westland', 32.7244415283203, 0.571149250545555, -97.4947204589844, -1.70160387532075, 218, 51, 'PPL', 'P'),
(107474, 'Westland', 37.2655601501465, 0.650406722220049, -80.0072174072266, -1.39638936911502, 218, 53, 'PPL', 'P'),
(133672, 'Westland', 42.3241691589355, 0.738696104994464, -83.4002838134766, -1.4556095496429, 218, 27, 'PPL', 'P'),
(168852, 'Westland', 40.2772216796875, 0.702970131866188, -80.2733306884766, -1.40103392205612, 218, 45, 'PPL', 'P'),
(158330, 'Westland Park', 40.7958297729492, 0.712021550621095, -81.461669921875, -1.42177435430955, 218, 41, 'PPL', 'P'),
(126599, 'Westlands', 42.6152801513672, 0.743776950301145, -71.341667175293, -1.24514698607082, 218, 23, 'PPL', 'P'),
(6744, 'Westlawn', 34.7197189331055, 0.605973410749703, -86.6275024414063, -1.51193514038197, 218, 2, 'PPL', 'P'),
(107475, 'Westlawn', 38.8655586242676, 0.678331963620347, -77.1805572509766, -1.34705484255352, 218, 53, 'PPL', 'P'),
(124000, 'Westlawn', 41.0802803039551, 0.716986148946193, -85.2275009155273, -1.48750050422243, 218, 19, 'PPL', 'P'),
(186102, 'Westley', 37.5494384765625, 0.655361333691059, -121.198059082031, -2.11530517800806, 218, 6, 'PPL', 'P'),
(168853, 'Westline', 41.7752799987793, 0.729116181921232, -78.7724990844727, -1.37483946904827, 218, 45, 'PPL', 'P'),
(34390, 'Westlink Village', 37.6977806091309, 0.657950392323807, -97.4530563354492, -1.70087669918511, 218, 20, 'PPL', 'P'),
(194051, 'Westlund Place', 40.2338905334473, 0.702213860695633, -124.01611328125, -2.16448950228408, 218, 6, 'PPL', 'P'),
(91776, 'Westlyn', 35.9147186279297, 0.626830089984713, -84.0283279418945, -1.46657098753161, 218, 50, 'PPL', 'P'),
(195790, 'Westma', 43.415828704834, 0.757749158381218, -116.541107177734, -2.03402603417106, 218, 17, 'PPL', 'P'),
(143378, 'Westmark', 40.5977783203125, 0.708564900684226, -99.5297164916992, -1.73712125635665, 218, 35, 'PPL', 'P'),
(153736, 'Westmere', 42.6911087036133, 0.74510040820486, -73.8691711425781, -1.28926025215717, 218, 40, 'PPL', 'P'),
(52669, 'Westminister', 39.6472206115723, 0.691974538936496, -75.9688873291016, -1.32590721296942, 218, 25, 'PPL', 'P'),
(91777, 'Westminister Ridge', 35.9094390869141, 0.626737944610997, -83.9908294677734, -1.46591651569372, 218, 50, 'PPL', 'P'),
(13249, 'Westminster', 38.9147186279297, 0.679189967544543, -77.0216674804688, -1.34428169291043, 218, 9, 'PPL', 'P'),
(14836, 'Westminster', 39.7569389343262, 0.693889484918317, -75.647216796875, -1.32029300307543, 218, 10, 'PPL', 'P'),
(52670, 'Westminster', 39.5752792358398, 0.690718925061551, -76.9961090087891, -1.34383561342784, 218, 25, 'PPL', 'P'),
(70043, 'Westminster', 35.4502792358398, 0.618724093416785, -81.8891677856445, -1.42923559957757, 218, 33, 'PPL', 'P'),
(84308, 'Westminster', 34.6647186279297, 0.605013474334784, -83.0966720581055, -1.45031052486391, 218, 48, 'PPL', 'P'),
(99035, 'Westminster', 33.3624992370605, 0.582285458380803, -96.461669921875, -1.6835737421087, 218, 51, 'PPL', 'P'),
(114275, 'Westminster', 41.7094383239746, 0.727967027910862, -72.0186080932617, -1.25696183393085, 218, 8, 'PPL', 'P'),
(126600, 'Westminster', 42.5458297729492, 0.742564812530995, -71.9111099243164, -1.25508563694289, 218, 23, 'PPL', 'P'),
(158331, 'Westminster', 40.6933288574219, 0.710232572158834, -83.9802780151367, -1.46573235810434, 218, 41, 'PPL', 'P'),
(168855, 'Westminster', 41.2783317565918, 0.720442798883061, -75.7758331298828, -1.32253778155826, 218, 45, 'PPL', 'P'),
(172775, 'Westminster', 43.0677795410156, 0.751674554513775, -72.4591674804688, -1.26465104578818, 218, 55, 'PPL', 'P'),
(186103, 'Westminster', 33.7591705322266, 0.5892086785296, -118.005828857422, -2.05959025010695, 218, 6, 'PPL', 'P'),
(187532, 'Westminster', 39.836669921875, 0.695281053166911, -105.036666870117, -1.83323567220399, 218, 7, 'PPL', 'P'),
(28954, 'Westminster (historical)', 39.3597183227539, 0.686956677389596, -88.9891662597656, -1.55315394983756, 218, 18, 'PPL', 'P'),
(153737, 'Westminster Park', 44.3561096191406, 0.774160156229532, -75.9300003051758, -1.32522850636562, 218, 40, 'PPL', 'P'),
(172776, 'Westminster Station', 43.0855598449707, 0.751984879359796, -72.4397201538086, -1.26431162590725, 218, 55, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(172777, 'Westminster West', 43.0638885498047, 0.751606643905978, -72.5411071777344, -1.26608116329356, 218, 55, 'PPL', 'P'),
(195791, 'Westmond', 48.1399993896484, 0.840201491257426, -116.602500915527, -2.03509755703565, 218, 17, 'PPL', 'P'),
(206435, 'Westmond Condominium', 41.1116714477539, 0.71753402776145, -112.053329467773, -1.95569953703463, 218, 52, 'PPL', 'P'),
(14837, 'Westmont', 39.7550010681152, 0.693855662772473, -75.6500015258789, -1.32034160576532, 218, 10, 'PPL', 'P'),
(25954, 'Westmont', 33.4958305358887, 0.584612528541314, -82.1419372558594, -1.43364725908134, 218, 13, 'PPL', 'P'),
(71554, 'Westmont', 39.9097213745117, 0.696556041538786, -75.0483322143555, -1.30984049527103, 218, 37, 'PPL', 'P'),
(107477, 'Westmont', 38.8624992370605, 0.678278567240491, -77.0922164916992, -1.34551300544042, 218, 53, 'PPL', 'P'),
(121948, 'Westmont', 41.7958297729492, 0.729474843141038, -87.9755630493164, -1.53546323650643, 218, 18, 'PPL', 'P'),
(168858, 'Westmont', 40.3480606079102, 0.704206504402257, -76.4700012207031, -1.33465330030535, 218, 45, 'PPL', 'P'),
(186105, 'Westmont', 33.9413909912109, 0.592389025503373, -118.301391601563, -2.06474879313843, 218, 6, 'PPL', 'P'),
(124001, 'Westmoor', 41.0691719055176, 0.716792270818835, -85.210563659668, -1.48720489334144, 218, 19, 'PPL', 'P'),
(114276, 'Westmoor Park', 41.7827796936035, 0.729247076288809, -72.7600021362305, -1.26990160103533, 218, 8, 'PPL', 'P'),
(52671, 'Westmore', 39.0963897705078, 0.682360727138392, -77.1536102294922, -1.34658452830502, 218, 25, 'PPL', 'P'),
(70044, 'Westmore', 35.5019416809082, 0.619625773182858, -79.7149963378906, -1.39128914931141, 218, 33, 'PPL', 'P'),
(172779, 'Westmore', 44.7713890075684, 0.781408148873264, -72.0552825927734, -1.25760192469885, 218, 55, 'PPL', 'P'),
(197825, 'Westmore', 46.4741706848145, 0.81112729558384, -104.644439697266, -1.82639001662194, 218, 31, 'PPL', 'P'),
(34392, 'Westmoreland', 39.3938903808594, 0.687553092315719, -96.413330078125, -1.68273005267536, 218, 20, 'PPL', 'P'),
(38824, 'Westmoreland', 38.045280456543, 0.664015408811326, -84.6344375610352, -1.47714959601362, 218, 21, 'PPL', 'P'),
(91778, 'Westmoreland', 36.561939239502, 0.638126220643421, -86.2480621337891, -1.50531265769927, 218, 50, 'PPL', 'P'),
(107479, 'Westmoreland', 38.0641708374023, 0.664345108154278, -76.5591735839844, -1.33620965164639, 218, 53, 'PPL', 'P'),
(111996, 'Westmoreland', 38.4005584716797, 0.670216179935412, -82.5122222900391, -1.44010995209864, 218, 58, 'PPL', 'P'),
(121949, 'Westmoreland', 42.2750015258789, 0.737837967912214, -89.1624984741211, -1.55617916767783, 218, 18, 'PPL', 'P'),
(144664, 'Westmoreland', 42.9619407653809, 0.749827319402669, -72.4427795410156, -1.26436502228711, 218, 36, 'PPL', 'P'),
(153739, 'Westmoreland', 41.0580596923828, 0.71659832611245, -72.3702774047852, -1.26309962129516, 218, 40, 'PPL', 'P'),
(201784, 'Westmoreland', 45.476390838623, 0.793712752057757, -122.64582824707, -2.14057351674684, 218, 43, 'PPL', 'P'),
(6745, 'Westmoreland (historical)', 34.9458312988281, 0.609919816011037, -87.2138900756836, -1.52216953529309, 218, 2, 'PPL', 'P'),
(168860, 'Westmoreland City', 40.3311080932617, 0.703910627205149, -79.6772232055664, -1.39062988378356, 218, 45, 'PPL', 'P'),
(144665, 'Westmoreland Depot', 43.0019416809082, 0.750525467082433, -72.4338912963867, -1.26420989315361, 218, 36, 'PPL', 'P'),
(91780, 'Westmoreland Heights', 35.9219398498535, 0.626956124083301, -84.004997253418, -1.46616379020094, 218, 50, 'PPL', 'P'),
(52672, 'Westmoreland Hills', 38.9488906860352, 0.679786382470666, -77.105827331543, -1.34575055940966, 218, 25, 'PPL', 'P'),
(52673, 'Westmoreland Park', 38.3536109924316, 0.669396791847022, -75.8388900756836, -1.32363833287873, 218, 25, 'PPL', 'P'),
(13250, 'Westmoreland Terrace', 38.9472198486328, 0.67975722085673, -77.0999984741211, -1.34564882665602, 218, 9, 'PPL', 'P'),
(186106, 'Westmorland', 33.0372200012207, 0.576608264727026, -115.620559692383, -2.01795944963072, 218, 6, 'PPL', 'P'),
(460, 'Westoak', 33.9877815246582, 0.593198693053784, -84.5316696166992, -1.47535595701945, 218, 13, 'PPL', 'P'),
(84309, 'Westoe', 32.9458312988281, 0.575013230971151, -80.2336120605469, -1.40034070122437, 218, 48, 'PPL', 'P'),
(6746, 'Weston', 34.1597213745117, 0.596199609549112, -88.0319366455078, -1.53644714137116, 218, 2, 'PPL', 'P'),
(18575, 'Weston', 26.1000003814697, 0.455530941428423, -80.4000015258789, -1.40324474523505, 218, 12, 'PPL', 'P'),
(25955, 'Weston', 31.975830078125, 0.558083515921517, -84.6149978637695, -1.47681030929075, 218, 13, 'PPL', 'P'),
(38826, 'Weston', 38.2969398498535, 0.668407693818167, -83.9630584716797, -1.46543182037533, 218, 21, 'PPL', 'P'),
(58235, 'Weston', 39.4111099243164, 0.687853630044735, -94.9013900756836, -1.65634172154015, 218, 29, 'PPL', 'P'),
(84310, 'Weston', 33.8727798461914, 0.591191535119219, -80.8169403076172, -1.41052169975564, 218, 48, 'PPL', 'P'),
(99036, 'Weston', 33.3488883972168, 0.582047904411568, -96.6691665649414, -1.68719524171704, 218, 51, 'PPL', 'P'),
(111998, 'Weston', 39.038330078125, 0.681347394343616, -80.4674987792969, -1.40442279454325, 218, 58, 'PPL', 'P'),
(112381, 'Weston', 32.2438888549805, 0.562762024166514, -92.6133270263672, -1.61640748783636, 218, 22, 'PPL', 'P'),
(114277, 'Weston', 41.2008285522461, 0.719090112786383, -73.3811111450195, -1.2807419982525, 218, 8, 'PPL', 'P'),
(118429, 'Weston', 41.3408317565918, 0.721533629665558, -95.7408294677734, -1.67099270280306, 218, 16, 'PPL', 'P'),
(121950, 'Weston', 40.7472190856934, 0.711173134076823, -88.621940612793, -1.54674465320012, 218, 18, 'PPL', 'P'),
(126602, 'Weston', 42.3666687011719, 0.739437861937079, -71.3036117553711, -1.24448279369496, 218, 23, 'PPL', 'P'),
(129312, 'Weston', 45.7330589294434, 0.79819245532738, -67.8786087036133, -1.18470521355093, 218, 26, 'PPL', 'P'),
(133674, 'Weston', 41.7702789306641, 0.729028896816504, -84.0977783203125, -1.46778312530176, 218, 27, 'PPL', 'P'),
(138791, 'Weston', 45.1888885498047, 0.788694890510857, -92.9844436645508, -1.62288469508159, 218, 28, 'PPL', 'P'),
(143380, 'Weston', 41.1941719055176, 0.718973932383828, -96.7425003051758, -1.68847515693694, 218, 35, 'PPL', 'P'),
(146628, 'Weston', 40.5349998474121, 0.70746920963274, -74.5911102294922, -1.30186046622266, 218, 37, 'PPL', 'P'),
(153741, 'Weston', 42.4208297729492, 0.740383150966002, -77.0749969482422, -1.34521246771141, 218, 40, 'PPL', 'P'),
(158332, 'Weston', 41.3447189331055, 0.721601473694328, -83.7972183227539, -1.46253736374458, 218, 41, 'PPL', 'P'),
(168863, 'Weston', 40.9413909912109, 0.714562073142976, -76.1425018310547, -1.32893735765772, 218, 45, 'PPL', 'P'),
(172781, 'Weston', 43.2911109924316, 0.755572423664242, -72.7936096191406, -1.27048816226542, 218, 55, 'PPL', 'P'),
(176994, 'Weston', 44.8908309936523, 0.783492804795551, -89.5475006103516, -1.56289872258227, 218, 57, 'PPL', 'P'),
(187533, 'Weston', 37.1327781677246, 0.648089239439462, -104.848327636719, -1.82994853247051, 218, 7, 'PPL', 'P'),
(193160, 'Weston', 42.0372200012207, 0.733687897406516, -111.978607177734, -1.95439538704882, 218, 17, 'PPL', 'P'),
(201785, 'Weston', 45.8138885498047, 0.799603198335822, -118.423606872559, -2.06688185201353, 218, 43, 'PPL', 'P'),
(209823, 'Weston', 44.6369400024414, 0.779061571057768, -105.335563659668, -1.83845240530529, 218, 59, 'PPL', 'P'),
(13251, 'Weston (historical)', 38.9288902282715, 0.679437308630784, -77.0722198486328, -1.34516399817957, 218, 9, 'PPL', 'P'),
(121951, 'Weston (historical)', 42.3133316040039, 0.738506953978042, -90.2630615234375, -1.57538761651419, 218, 18, 'PPL', 'P'),
(111999, 'Weston Arbors', 39.0400009155273, 0.681376555957553, -80.4480590820313, -1.40408350782037, 218, 58, 'PPL', 'P'),
(204, 'Weston Manor', 39.0463905334473, 0.6814880758282, -80.4958267211914, -1.40491721039962, 218, 58, 'PPL', 'P'),
(153742, 'Weston Mills', 42.0758285522461, 0.734361743741333, -78.3727798461914, -1.3678630522567, 218, 40, 'PPL', 'P'),
(168875, 'Weston Place', 40.8238906860352, 0.71251130594556, -76.2177810668945, -1.33025122818151, 218, 45, 'PPL', 'P'),
(126603, 'Weston Station', 42.3708305358887, 0.739510499655811, -71.2936096191406, -1.2443082234855, 218, 23, 'PPL', 'P'),
(62279, 'Westonia (historical)', 30.3013896942139, 0.52885901809391, -89.5833282470703, -1.56352403280622, 218, 30, 'PPL', 'P'),
(133675, 'Westons Iroquois Beach', 46.4858283996582, 0.811330761091122, -84.6725006103516, -1.47781392154754, 218, 27, 'PPL', 'P'),
(146629, 'Westons Mills', 40.485279083252, 0.706601418591538, -74.4127807617188, -1.29874802985669, 218, 37, 'PPL', 'P'),
(153743, 'Westons Mills', 42.0622215270996, 0.734124256351125, -78.3775024414063, -1.36794547709243, 218, 40, 'PPL', 'P'),
(12773, 'Westor', 34.8408317565918, 0.608087228285926, -90.8636093139648, -1.58586915277447, 218, 4, 'PPL', 'P'),
(6747, 'Westover', 33.3494415283203, 0.582057558370519, -86.5358276367188, -1.51033511319905, 218, 2, 'PPL', 'P'),
(12775, 'Westover', 34.3877792358398, 0.600179970114345, -90.665283203125, -1.58240770914764, 218, 4, 'PPL', 'P'),
(25957, 'Westover', 33.394718170166, 0.582847784844973, -81.9905624389648, -1.43100527012193, 218, 13, 'PPL', 'P'),
(31503, 'Westover', 39.8994407653809, 0.696376611060342, -86.2275009155273, -1.50495379674238, 218, 19, 'PPL', 'P'),
(44101, 'Westover', 30.4908294677734, 0.532165365876757, -91.2744369506836, -1.5930394476934, 218, 22, 'PPL', 'P'),
(52674, 'Westover', 38.1238899230957, 0.665387402825908, -75.706672668457, -1.32133070379418, 218, 25, 'PPL', 'P'),
(58237, 'Westover', 37.9225006103516, 0.661872496240194, -91.227783203125, -1.59222518619011, 218, 29, 'PPL', 'P'),
(70050, 'Westover', 35.9038887023926, 0.626641072126345, -76.6772232055664, -1.33827000622373, 218, 33, 'PPL', 'P'),
(84311, 'Westover', 34.1866683959961, 0.596669923797621, -82.2069396972656, -1.43478176570572, 218, 48, 'PPL', 'P'),
(91781, 'Westover', 35.6108283996582, 0.621526204936739, -88.8766708374023, -1.5511905343239, 218, 50, 'PPL', 'P'),
(99037, 'Westover', 33.4972190856934, 0.584636763307234, -99.0175018310547, -1.72818142405142, 218, 51, 'PPL', 'P'),
(107484, 'Westover', 36.7750015258789, 0.641844859052526, -76.2697219848633, -1.33115776821657, 218, 53, 'PPL', 'P'),
(112000, 'Westover', 39.6344413757324, 0.691751499195202, -79.9700012207031, -1.39573982412515, 218, 58, 'PPL', 'P'),
(153744, 'Westover', 42.1158294677734, 0.735059891421098, -75.975830078125, -1.32602838679902, 218, 40, 'PPL', 'P'),
(168864, 'Westover', 40.7502784729004, 0.711226530456679, -78.6711120605469, -1.37306993166196, 218, 45, 'PPL', 'P'),
(202775, 'Westover', 43.7477798461914, 0.763542798753658, -100.665832519531, -1.756950221727, 218, 49, 'PPL', 'P'),
(107487, 'Westover Heights', 37.5202789306641, 0.654852403606745, -77.5224990844727, -1.35302285339834, 218, 53, 'PPL', 'P'),
(14838, 'Westover Hills', 39.7633285522461, 0.694001004788964, -75.5911102294922, -1.31931375874261, 218, 10, 'PPL', 'P'),
(52676, 'Westover Hills', 38.3797187805176, 0.669852458709535, -75.6122207641602, -1.31968220707942, 218, 25, 'PPL', 'P'),
(99038, 'Westover Hills', 32.7447204589844, 0.571503184654426, -97.413330078125, -1.70018334519531, 218, 51, 'PPL', 'P'),
(107493, 'Westover Hills', 37.5258293151855, 0.654949276091397, -77.4916687011719, -1.35248476170009, 218, 53, 'PPL', 'P'),
(107495, 'Westover Park', 37.1952781677246, 0.649180070221958, -77.3944396972656, -1.35078779545349, 218, 53, 'PPL', 'P'),
(13252, 'Westover Place', 38.9363899230957, 0.679568202998362, -77.0861129760742, -1.34540647899682, 218, 9, 'PPL', 'P'),
(52677, 'Westowne', 39.2874984741211, 0.685696203245661, -76.7186126708984, -1.33899238866942, 218, 25, 'PPL', 'P'),
(25960, 'Westpark', 33.4002799987793, 0.582944857066706, -84.591667175293, -1.47640311196007, 218, 13, 'PPL', 'P'),
(158335, 'Westpark', 41.4541702270508, 0.723511759144241, -81.7949981689453, -1.42759202971083, 218, 41, 'PPL', 'P'),
(31504, 'Westphalia', 38.8627815246582, 0.678283494088508, -87.2255630493164, -1.52237326711648, 218, 19, 'PPL', 'P'),
(34393, 'Westphalia', 38.1819381713867, 0.666400535883601, -95.4899978637695, -1.66661486544513, 218, 20, 'PPL', 'P'),
(52678, 'Westphalia', 38.8452796936035, 0.677978029511475, -76.811393737793, -1.34061172377024, 218, 25, 'PPL', 'P'),
(58238, 'Westphalia', 38.4419403076172, 0.670938429223042, -91.9991683959961, -1.60568839760684, 218, 29, 'PPL', 'P'),
(99039, 'Westphalia', 31.1188907623291, 0.543127103371091, -97.1149978637695, -1.69497646579004, 218, 51, 'PPL', 'P'),
(118430, 'Westphalia', 41.7197189331055, 0.728146458389306, -95.3944396972656, -1.66494706081247, 218, 16, 'PPL', 'P'),
(133676, 'Westphalia', 42.9294395446777, 0.749260066090482, -84.7986068725586, -1.48001489103044, 218, 27, 'PPL', 'P'),
(52679, 'Westphalia Estates', 38.8444404602051, 0.67796338212548, -76.8377838134766, -1.34107231748077, 218, 25, 'PPL', 'P'),
(38827, 'Westplains', 36.8252792358398, 0.642722370631707, -88.5947189331055, -1.54626954526165, 218, 21, 'PPL', 'P'),
(194475, 'Westplains', 40.8647193908691, 0.713223901274238, -103.497222900391, -1.80636730628229, 218, 7, 'PPL', 'P'),
(91784, 'Westpoint', 35.1330604553223, 0.613187581247592, -87.5336074829102, -1.52774965672513, 218, 50, 'PPL', 'P'),
(124002, 'Westpoint', 40.3450012207031, 0.704153108022401, -87.0430603027344, -1.51918799329469, 218, 19, 'PPL', 'P'),
(25961, 'Westport', 33.5569381713867, 0.585679057978863, -82.0694427490234, -1.43238199124745, 218, 13, 'PPL', 'P'),
(28956, 'Westport', 38.827220916748, 0.677662844396465, -87.7597198486328, -1.53169606198646, 218, 18, 'PPL', 'P'),
(31505, 'Westport', 39.1758308410645, 0.683747235380914, -85.5730590820313, -1.49353163198508, 218, 19, 'PPL', 'P'),
(38828, 'Westport', 38.478889465332, 0.671583313681004, -85.4749984741211, -1.49182015151054, 218, 21, 'PPL', 'P'),
(44102, 'Westport', 30.9644393920898, 0.540431418426199, -92.7972183227539, -1.61961699642407, 218, 22, 'PPL', 'P'),
(52680, 'Westport', 39.2619400024414, 0.685250123763073, -76.6358337402344, -1.33754762377805, 218, 25, 'PPL', 'P'),
(58239, 'Westport', 39.0544395446777, 0.681628557575702, -94.5800018310547, -1.65073243849417, 218, 29, 'PPL', 'P'),
(70055, 'Westport', 35.5011100769043, 0.619611258954917, -80.978889465332, -1.41334824577859, 218, 33, 'PPL', 'P'),
(77660, 'Westport', 36.2188911437988, 0.632138901880705, -96.3244400024414, -1.68117862818234, 218, 42, 'PPL', 'P'),
(91785, 'Westport', 35.8963890075684, 0.626510177758768, -88.3172225952148, -1.54142632050323, 218, 50, 'PPL', 'P'),
(114279, 'Westport', 41.1413917541504, 0.71805274496277, -73.3583297729492, -1.28034438830175, 218, 8, 'PPL', 'P'),
(129314, 'Westport', 43.899169921875, 0.766185054029181, -69.7088928222656, -1.21664969766838, 218, 26, 'PPL', 'P'),
(138792, 'Westport', 45.7150001525879, 0.797877270212369, -95.1669387817383, -1.66097642078521, 218, 28, 'PPL', 'P'),
(144667, 'Westport', 42.8416709899902, 0.747728215831468, -72.3480606079102, -1.26271186504044, 218, 36, 'PPL', 'P'),
(153756, 'Westport', 44.1838912963867, 0.771154379465214, -73.4361114501953, -1.28170193466742, 218, 40, 'PPL', 'P'),
(168866, 'Westport', 41.3016700744629, 0.720850129371789, -77.8405609130859, -1.35857407953255, 218, 45, 'PPL', 'P'),
(171598, 'Westport', 45.6488914489746, 0.796723455670092, -98.4966735839844, -1.71909125630265, 218, 49, 'PPL', 'P'),
(176998, 'Westport', 43.2050018310547, 0.754069535282083, -90.64111328125, -1.58198586443097, 218, 57, 'PPL', 'P'),
(186107, 'Westport', 39.6358299255371, 0.691775733961121, -123.781936645508, -2.16040234895914, 218, 6, 'PPL', 'P'),
(201786, 'Westport', 46.1327781677246, 0.805168872118951, -123.373611450195, -2.15327572988208, 218, 43, 'PPL', 'P'),
(209158, 'Westport', 46.8902816772461, 0.818389802455513, -124.102783203125, -2.16600217778325, 218, 56, 'PPL', 'P'),
(126605, 'Westport Factory', 41.6388893127441, 0.726735715380864, -71.0500030517578, -1.24005648680519, 218, 23, 'PPL', 'P'),
(126606, 'Westport Point', 41.5222206115723, 0.72469946241139, -71.0749969482422, -1.24049271259175, 218, 23, 'PPL', 'P'),
(171602, 'Westreville', 42.9241714477539, 0.749168120453847, -97.023063659668, -1.69337191123327, 218, 49, 'PPL', 'P'),
(25962, 'Westridge', 33.8319396972656, 0.590478740053459, -84.6855621337891, -1.47804188813685, 218, 13, 'PPL', 'P'),
(70056, 'Westridge', 35.7324981689453, 0.623649743010941, -79.8305587768555, -1.39330609436299, 218, 33, 'PPL', 'P'),
(186108, 'Westridge', 37.3919410705566, 0.652612485392907, -122.216941833496, -2.1330880367129, 218, 6, 'PPL', 'P'),
(118433, 'Westridge Mobile Home Park', 41.6394386291504, 0.726745302760788, -95.3222198486328, -1.66368658666853, 218, 16, 'PPL', 'P'),
(179504, 'Westridge Park', 33.4597206115723, 0.583982291469347, -112.204437255859, -1.95833686546214, 218, 5, 'PPL', 'P'),
(70059, 'Westry', 35.9630584716797, 0.62767377941805, -77.8983306884766, -1.35958235232126, 218, 33, 'PPL', 'P'),
(91786, 'Westshore Estates', 35.8541717529297, 0.62577334766417, -84.5555572509766, -1.47577287488811, 218, 50, 'PPL', 'P'),
(25964, 'Westside', 34.2755584716797, 0.598221348290646, -83.8411102294922, -1.46330342203214, 218, 13, 'PPL', 'P'),
(31506, 'Westside', 39.0638885498047, 0.681793473826205, -84.9072189331055, -1.48191052909436, 218, 19, 'PPL', 'P'),
(62282, 'Westside', 31.9050006866455, 0.556847309833016, -91.1286087036133, -1.59049426463961, 218, 30, 'PPL', 'P'),
(91787, 'Westside', 35.1883316040039, 0.614152244773446, -87.2133331298828, -1.52215981475511, 218, 50, 'PPL', 'P'),
(118434, 'Westside', 42.0591697692871, 0.734070993129324, -95.0977783203125, -1.65976934302114, 218, 16, 'PPL', 'P'),
(186109, 'Westside', 36.4005584716797, 0.635309594895526, -120.138061523438, -2.0968047305475, 218, 6, 'PPL', 'P'),
(91788, 'Westside Heights', 35.3497200012207, 0.616969003679395, -86.2255630493164, -1.50491997459653, 218, 50, 'PPL', 'P'),
(25965, 'Westside Hills', 33.6952781677246, 0.588093546402157, -84.5713882446289, -1.4760491778512, 218, 13, 'PPL', 'P'),
(143381, 'Westside Mobile Home Park', 41.7783317565918, 0.729169445143033, -96.220832824707, -1.67937034180217, 218, 35, 'PPL', 'P'),
(143382, 'Westside Plaza Mobile Home Park', 40.4402809143066, 0.705816052386074, -99.3694381713867, -1.73432387194763, 218, 35, 'PPL', 'P'),
(107496, 'Westside Village', 36.7397193908691, 0.641229069629472, -78.9458312988281, -1.37786468688854, 218, 53, 'PPL', 'P'),
(79401, 'Westtown', 39.9308280944824, 0.696924423296572, -75.5522232055664, -1.3186350521388, 218, 45, 'PPL', 'P'),
(153746, 'Westtown', 41.336669921875, 0.721460991946826, -74.540283203125, -1.30097336726356, 218, 40, 'PPL', 'P'),
(153747, 'Westvale', 43.0475006103516, 0.751320620404903, -76.220832824707, -1.33030449140331, 218, 40, 'PPL', 'P'),
(14839, 'Westview', 39.7208290100098, 0.69325924784635, -75.6180572509766, -1.31978407299111, 218, 10, 'PPL', 'P'),
(18576, 'Westview', 25.8816699981689, 0.451720357382683, -80.2422180175781, -1.40049090350986, 218, 12, 'PPL', 'P'),
(25966, 'Westview', 34.339168548584, 0.599331553570073, -83.9069366455078, -1.4644523097264, 218, 13, 'PPL', 'P'),
(28957, 'Westview', 38.5369415283203, 0.672596513317725, -90.1016693115234, -1.57257079102922, 218, 18, 'PPL', 'P'),
(38829, 'Westview', 37.7000007629395, 0.657989141317668, -86.4091720581055, -1.50812455633623, 218, 21, 'PPL', 'P'),
(52681, 'Westview', 38.3977813720703, 0.670167710403573, -75.6116714477539, -1.31967261969949, 218, 25, 'PPL', 'P'),
(58240, 'Westview', 36.8369407653809, 0.642925902718016, -94.5199966430664, -1.6496851503955, 218, 29, 'PPL', 'P'),
(70061, 'Westview', 35.5325012207031, 0.620159137770174, -78.3727798461914, -1.3678630522567, 218, 33, 'PPL', 'P'),
(107497, 'Westview', 37.499439239502, 0.654488682380868, -79.1877822875977, -1.38208752827103, 218, 53, 'PPL', 'P'),
(118435, 'Westview', 42.6888885498047, 0.745061659210999, -94.6372222900391, -1.65173112390295, 218, 16, 'PPL', 'P'),
(124003, 'Westview', 41.5863914489746, 0.725819454807822, -85.1827774047852, -1.48671993170693, 218, 19, 'PPL', 'P'),
(126608, 'Westview', 42.1124992370605, 0.735001767930307, -71.4291687011719, -1.24667417579793, 218, 23, 'PPL', 'P'),
(153748, 'Westview', 42.5566711425781, 0.742754030126445, -77.8255615234375, -1.3583122907974, 218, 40, 'PPL', 'P'),
(121952, 'Westview Acres', 40.5638885498047, 0.70797341260612, -90.0508270263672, -1.571683425754, 218, 18, 'PPL', 'P'),
(209825, 'Westview Circle', 42.0641708374023, 0.734158278234051, -105.064170837402, -1.83371570699048, 218, 59, 'PPL', 'P'),
(112001, 'Westview Estates', 38.4150009155273, 0.670468248132588, -82.0408325195313, -1.43188264854306, 218, 58, 'PPL', 'P'),
(84313, 'Westview Heights', 34.9288902282715, 0.609624138551011, -82.0002822875977, -1.43117491348337, 218, 48, 'PPL', 'P'),
(91789, 'Westview Heights', 35.2338905334473, 0.614947398095916, -84.8958282470703, -1.48171172411898, 218, 50, 'PPL', 'P'),
(114281, 'Westview Heights', 41.5352783203125, 0.724927362421673, -73.0947189331055, -1.27574351120253, 218, 8, 'PPL', 'P'),
(168867, 'Westview Heights', 40.9966697692871, 0.715526869826884, -80.3766708374023, -1.40283754790438, 218, 45, 'PPL', 'P'),
(99040, 'Westview Heights Colonia', 26.2350006103516, 0.457887139913357, -98.3870010375977, -1.71717710926916, 218, 51, 'PPL', 'P'),
(107498, 'Westview Hills', 38.7763900756836, 0.676775678858332, -77.2152786254883, -1.34766084485957, 218, 53, 'PPL', 'P'),
(153749, 'Westview Manor', 43.0438919067383, 0.751257636645123, -76.2694396972656, -1.33115284136855, 218, 40, 'PPL', 'P'),
(199775, 'Westview Mobile Park', 42.8294410705566, 0.747514763470098, -103.002777099609, -1.797737599086, 218, 35, 'PPL', 'P'),
(52682, 'Westview Park', 39.2966690063477, 0.685856259227175, -76.7391662597656, -1.33935111646825, 218, 25, 'PPL', 'P'),
(126609, 'Westview Park', 41.6444396972656, 0.726832587865516, -70.9541702270508, -1.23838388848257, 218, 23, 'PPL', 'P'),
(197826, 'Westview Park', 46.9119415283203, 0.81876783817225, -114.04167175293, -1.99040265656724, 218, 31, 'PPL', 'P'),
(206441, 'Westview Terrace', 40.6522216796875, 0.709515116561167, -112.015556335449, -1.95504027150678, 218, 52, 'PPL', 'P'),
(12776, 'Westville', 35.420280456543, 0.618200515946475, -94.2583312988281, -1.64511822860017, 218, 4, 'PPL', 'P'),
(18577, 'Westville', 30.7744407653809, 0.53711531681586, -85.8516693115234, -1.49839429781946, 218, 12, 'PPL', 'P'),
(25968, 'Westville', 32.040828704834, 0.559217955966863, -84.7897186279297, -1.47985976189694, 218, 13, 'PPL', 'P'),
(58241, 'Westville', 39.6427803039551, 0.691897040948775, -92.9077835083008, -1.62154672294994, 218, 29, 'PPL', 'P'),
(62284, 'Westville', 31.8661098480225, 0.556168536650182, -89.9411087036133, -1.56976847977218, 218, 30, 'PPL', 'P'),
(77661, 'Westville', 35.9925003051758, 0.628187636350381, -94.5677795410156, -1.65051911929085, 218, 42, 'PPL', 'P'),
(84316, 'Westville', 34.4566688537598, 0.601382320767488, -80.5991668701172, -1.40672083624788, 218, 48, 'PPL', 'P'),
(99041, 'Westville', 31.0722198486328, 0.542312542262177, -95.188606262207, -1.66135458966001, 218, 51, 'PPL', 'P'),
(114282, 'Westville', 41.3305587768555, 0.721354332345168, -72.9722213745117, -1.27360552547941, 218, 8, 'PPL', 'P'),
(121953, 'Westville', 40.0422210693359, 0.698868597471357, -87.6386108398438, -1.52958231102927, 218, 18, 'PPL', 'P'),
(124004, 'Westville', 41.541389465332, 0.725034022023331, -86.9005584716797, -1.51670086715266, 218, 19, 'PPL', 'P'),
(126611, 'Westville', 42.0722198486328, 0.734298759981553, -72.0611114501953, -1.25770365745249, 218, 23, 'PPL', 'P'),
(133678, 'Westville', 43.357780456543, 0.756736025323525, -85.083610534668, -1.48498914331449, 218, 27, 'PPL', 'P'),
(144668, 'Westville', 42.8274993896484, 0.747480874745227, -71.1175003051758, -1.24123453611339, 218, 36, 'PPL', 'P'),
(146630, 'Westville', 40.8444404602051, 0.712869967165367, -74.3000030517578, -1.29677968749501, 218, 37, 'PPL', 'P'),
(153751, 'Westville', 42.6272201538086, 0.743985342656444, -74.8808288574219, -1.3069170101844, 218, 40, 'PPL', 'P'),
(158339, 'Westville', 40.9013900756836, 0.713863925463211, -80.9941711425781, -1.41361496136177, 218, 41, 'PPL', 'P'),
(168868, 'Westville', 41.2138900756836, 0.719318079375694, -78.8369369506836, -1.37596412197661, 218, 45, 'PPL', 'P'),
(186110, 'Westville', 39.1749992370605, 0.683732721152973, -120.646942138672, -2.10568637278291, 218, 6, 'PPL', 'P'),
(153752, 'Westville Center', 44.9447212219238, 0.78443336671354, -74.3963928222656, -1.29846200635561, 218, 40, 'PPL', 'P'),
(71556, 'Westville Grove', 39.8563919067383, 0.695625266737804, -75.1180572509766, -1.31105742673114, 218, 37, 'PPL', 'P'),
(25969, 'Westward Ho', 33.9597206115723, 0.592708937729318, -84.8147201538086, -1.48029612084155, 218, 13, 'PPL', 'P'),
(107499, 'Westward Lake Estates', 37.2886085510254, 0.650808992702705, -80.1427764892578, -1.39875532142745, 218, 53, 'PPL', 'P'),
(107500, 'Westward Lakes', 37.2877807617188, 0.650794545053791, -80.1477813720703, -1.39884267311121, 218, 53, 'PPL', 'P'),
(107501, 'Westward Park', 37.3477783203125, 0.651841699994411, -79.2522201538086, -1.38321218119937, 218, 53, 'PPL', 'P'),
(192857, 'Westwater', 39.0783309936523, 0.682045542023381, -109.111671447754, -1.90435791911759, 218, 52, 'PPL', 'P'),
(192416, 'Westway', 31.958610534668, 0.557782978192501, -106.577499389648, -1.86012827289161, 218, 51, 'PPL', 'P'),
(192417, 'Westway Number 1 Colonia', 31.9629993438721, 0.557859577363355, -106.579002380371, -1.86015450502835, 218, 51, 'PPL', 'P'),
(192418, 'Westway Number 2 Colonia', 31.9629993438721, 0.557859577363355, -106.581001281738, -1.86018939243863, 218, 51, 'PPL', 'P'),
(192419, 'Westway Number 3 Colonia', 31.9629993438721, 0.557859577363355, -106.572998046875, -1.86004970963945, 218, 51, 'PPL', 'P'),
(192420, 'Westway Number 4 Colonia', 31.9580001831055, 0.557772325548141, -106.575996398926, -1.86010204075488, 218, 51, 'PPL', 'P'),
(192421, 'Westway Number 6 Colonia', 31.9540004730225, 0.557702517438067, -106.573997497559, -1.86006715334459, 218, 51, 'PPL', 'P'),
(192422, 'Westway Number 7 Colonia', 31.9659996032715, 0.557911941768289, -106.577003479004, -1.86011961761807, 218, 51, 'PPL', 'P'),
(44103, 'Westwego', 29.9058303833008, 0.521955205731557, -90.142219543457, -1.5732785260889, 218, 22, 'PPL', 'P'),
(25970, 'Westwick', 33.4850006103516, 0.584423510682946, -82.0547180175781, -1.43212499620225, 218, 13, 'PPL', 'P'),
(52683, 'Westwind', 39.4355583190918, 0.688280335030392, -76.658332824707, -1.33794030688078, 218, 25, 'PPL', 'P'),
(179505, 'Westwind', 33.5986099243164, 0.586406367272564, -112.198333740234, -1.95823033901853, 218, 5, 'PPL', 'P'),
(6753, 'Westwood', 33.586109161377, 0.586188187800259, -86.9252777099609, -1.51713229924925, 218, 2, 'PPL', 'P'),
(12777, 'Westwood', 34.7066688537598, 0.605745643897474, -92.370002746582, -1.61216067800406, 218, 4, 'PPL', 'P'),
(18578, 'Westwood', 30.2408294677734, 0.527802042746771, -81.7602767944336, -1.42698602740478, 218, 12, 'PPL', 'P'),
(31508, 'Westwood', 39.7866706848145, 0.694408401856719, -86.3263931274414, -1.50667979144486, 218, 19, 'PPL', 'P'),
(34395, 'Westwood', 39.0405616760254, 0.681386343074559, -94.6166687011719, -1.65137239610412, 218, 20, 'PPL', 'P'),
(38831, 'Westwood', 38.2799987792969, 0.668112016358141, -85.5827789306641, -1.49370127534652, 218, 21, 'PPL', 'P'),
(44106, 'Westwood', 32.185001373291, 0.561734243722825, -91.3199996948242, -1.5938346675949, 218, 22, 'PPL', 'P'),
(52687, 'Westwood', 38.6563911437988, 0.674681302398066, -76.7399978637695, -1.33936563069619, 218, 25, 'PPL', 'P'),
(58242, 'Westwood', 38.6436080932617, 0.674458196077745, -90.4397201538086, -1.57847089126623, 218, 29, 'PPL', 'P'),
(70066, 'Westwood', 35.9119415283203, 0.626781620452874, -79.9841690063477, -1.39598709863237, 218, 33, 'PPL', 'P'),
(84318, 'Westwood', 33.9486083984375, 0.592514993022933, -81.0808334350586, -1.41512750370288, 218, 48, 'PPL', 'P'),
(91792, 'Westwood', 35.5963897705078, 0.62127420331859, -87.0922164916992, -1.52004593063986, 218, 50, 'PPL', 'P'),
(99042, 'Westwood', 31.0852794647217, 0.542540475561974, -94.1580581665039, -1.64336813228983, 218, 51, 'PPL', 'P'),
(107504, 'Westwood', 37.2791709899902, 0.650644276189284, -79.996940612793, -1.39621000521561, 218, 53, 'PPL', 'P'),
(112291, 'Westwood', 33.4855613708496, 0.584433297799952, -82.0791702270508, -1.43255176776694, 218, 13, 'PPL', 'P'),
(118436, 'Westwood', 40.9655609130859, 0.714983917859644, -91.6236114501953, -1.59913369237388, 218, 16, 'PPL', 'P'),
(126612, 'Westwood', 42.2138900756836, 0.736771371895637, -71.2249984741211, -1.24311073310135, 218, 23, 'PPL', 'P'),
(133680, 'Westwood', 44.8516693115234, 0.782809304501782, -85.101936340332, -1.48530898896141, 218, 27, 'PPL', 'P'),
(146631, 'Westwood', 40.9911117553711, 0.715429864184178, -74.0330581665039, -1.29212062032597, 218, 37, 'PPL', 'P'),
(158340, 'Westwood', 40.7813911437988, 0.711769549002946, -81.9599990844727, -1.43047183895559, 218, 41, 'PPL', 'P'),
(168869, 'Westwood', 40.4291687011719, 0.705622107679689, -80.0400009155273, -1.39696154927523, 218, 45, 'PPL', 'P'),
(194052, 'Westwood', 40.3061103820801, 0.703474334839567, -121.004722595215, -2.11193081974888, 218, 6, 'PPL', 'P'),
(206443, 'Westwood', 40.6480598449707, 0.709442478842435, -111.982780456543, -1.95446822450463, 218, 52, 'PPL', 'P'),
(209157, 'Westwood', 47.6191711425781, 0.831111323508658, -122.574440002441, -2.13932755683085, 218, 56, 'PPL', 'P'),
(74795, 'Westwood Acres', 38.8413887023926, 0.677910118903678, -82.2569427490234, -1.43565448359493, 218, 41, 'PPL', 'P'),
(25975, 'Westwood Estates', 30.8125, 0.537779575770753, -83.3361129760742, -1.45448955724647, 218, 13, 'PPL', 'P'),
(84322, 'Westwood Estates', 33.7444381713867, 0.588951550326353, -78.9577789306641, -1.3780732124019, 218, 48, 'PPL', 'P'),
(91793, 'Westwood Estates', 36.1166687011719, 0.630354783687433, -84.1380615234375, -1.46848619982954, 218, 50, 'PPL', 'P'),
(197827, 'Westwood Estates', 46.4124984741211, 0.810050912450257, -105.836936950684, -1.84720302001508, 218, 31, 'PPL', 'P'),
(91794, 'Westwood Gardens', 35.6300010681152, 0.621860831127707, -88.829719543457, -1.55037107965648, 218, 50, 'PPL', 'P'),
(168870, 'Westwood Heights', 40.6030616760254, 0.70865711263697, -75.541389465332, -1.3184459677014, 218, 45, 'PPL', 'P'),
(25977, 'Westwood Hills', 33.9511108398438, 0.592558668864811, -83.4608306884766, -1.45666629196344, 218, 13, 'PPL', 'P'),
(34396, 'Westwood Hills', 39.038890838623, 0.681357181460623, -94.6097183227539, -1.65125108911646, 218, 20, 'PPL', 'P'),
(91796, 'Westwood Hills', 35.723331451416, 0.623489753608454, -83.9880599975586, -1.46586817931994, 218, 50, 'PPL', 'P'),
(126613, 'Westwood Hills', 42.2777786254883, 0.737886437444053, -71.8291702270508, -1.25365551943752, 218, 23, 'PPL', 'P'),
(91797, 'Westwood Homes', 35.4874992370605, 0.619373704985682, -86.0625, -1.50207398749762, 218, 50, 'PPL', 'P'),
(194053, 'Westwood Junction', 40.4319381713867, 0.705670444053474, -120.945556640625, -2.1108981790362, 218, 6, 'PPL', 'P'),
(18579, 'Westwood Lake', 25.728889465332, 0.449053834051727, -80.3730621337891, -1.4027745641446, 218, 12, 'PPL', 'P'),
(14840, 'Westwood Manor', 39.7999992370605, 0.694641028977938, -75.5013885498047, -1.31774782002164, 218, 10, 'PPL', 'P'),
(206448, 'Westwood Manor Plat One', 41.3277816772461, 0.721305862813329, -111.996673583984, -1.95471070532189, 218, 52, 'PPL', 'P'),
(206449, 'Westwood Manor Plat Two', 41.3233299255371, 0.721228165088526, -111.999443054199, -1.95475904169567, 218, 52, 'PPL', 'P'),
(99044, 'Westwood Park', 29.6677799224854, 0.517800441404437, -95.4427795410156, -1.6657907502458, 218, 51, 'PPL', 'P'),
(107506, 'Westwood Park', 38.8841705322266, 0.678656802694309, -77.2005615234375, -1.34740398297243, 218, 53, 'PPL', 'P'),
(107507, 'Westwood Place', 37.8005599975586, 0.659744231055057, -80.0166702270508, -1.39655435194455, 218, 53, 'PPL', 'P'),
(84324, 'Westwood South', 34.7166709899902, 0.605920214106929, -82.2724990844727, -1.43592599286807, 218, 48, 'PPL', 'P'),
(124005, 'Westwood Square', 40.5588912963867, 0.70788619408042, -85.6944427490234, -1.49565017663224, 218, 19, 'PPL', 'P'),
(25978, 'Westwood Station', 34.0916709899902, 0.595011906281964, -84.6397171020508, -1.47724174138734, 218, 13, 'PPL', 'P'),
(6755, 'Westwood Trailer Court', 33.6041717529297, 0.586503439494298, -86.9263916015625, -1.51715174032521, 218, 2, 'PPL', 'P'),
(99045, 'Westwood Village', 29.4094390869141, 0.513291543231365, -98.6324996948242, -1.72146186914699, 218, 51, 'PPL', 'P'),
(168871, 'Westwood Village', 40.3058280944824, 0.70346940799155, -76.9466705322266, -1.34297274923465, 218, 45, 'PPL', 'P'),
(186113, 'Westwood Village', 34.059440612793, 0.594449380080712, -118.443328857422, -2.06722606558443, 218, 6, 'PPL', 'P'),
(201787, 'Westwood Village', 44.396671295166, 0.774868091026302, -123.932777404785, -2.16303501685473, 218, 43, 'PPL', 'P'),
(91798, 'Westwood-Gray Subdivision', 36.3144416809082, 0.633806573355312, -82.397216796875, -1.43810272758504, 218, 50, 'PPL', 'P'),
(14841, 'Westwoods', 38.4949989318848, 0.671864476913089, -75.371940612793, -1.31548852731087, 218, 10, 'PPL', 'P'),
(99046, 'Westworth', 32.7572212219238, 0.571721364126731, -97.4105606079102, -1.70013500882152, 218, 51, 'PPL', 'P'),
(58243, 'Wet Glaize', 37.9222183227539, 0.661867569392177, -92.5336074829102, -1.61501611932484, 218, 29, 'PPL', 'P'),
(202778, 'Weta', 43.7744407653809, 0.764008119575123, -101.71639251709, -1.77528595267414, 218, 49, 'PPL', 'P'),
(18581, 'Wetappo', 30.1511096954346, 0.526236137315318, -85.3000030517578, -1.48876590521438, 218, 12, 'PPL', 'P'),
(28963, 'Wetaug', 37.3238906860352, 0.651424782125759, -89.1666717529297, -1.55625200513365, 218, 18, 'PPL', 'P'),
(52693, 'Wetherbee', 39.5113906860352, 0.689603859513135, -76.5819396972656, -1.33660699528103, 218, 25, 'PPL', 'P'),
(52689, 'Wetheredsville', 39.3152809143066, 0.686181098301137, -76.70361328125, -1.33873059993426, 218, 25, 'PPL', 'P'),
(58244, 'Wetherhill (historical)', 36.5819396972656, 0.638475294483303, -92.10888671875, -1.60760334358866, 218, 29, 'PPL', 'P'),
(168872, 'Wetherill Junction', 40.7566719055176, 0.711338116906353, -76.20361328125, -1.33000395367429, 218, 45, 'PPL', 'P'),
(168873, 'Wetherills Corner', 40.1241683959961, 0.700298848134784, -75.4361114501953, -1.3166085197073, 218, 45, 'PPL', 'P'),
(74796, 'Wetherington', 39.3636093139648, 0.687024587997393, -84.3775024414063, -1.47266523221209, 218, 41, 'PPL', 'P'),
(52691, 'Wethersfield', 39.0894393920898, 0.682239420150738, -76.6816711425781, -1.33834763736951, 218, 25, 'PPL', 'P'),
(114284, 'Wethersfield', 41.714168548584, 0.728049585904655, -72.6530609130859, -1.26803512458535, 218, 8, 'PPL', 'P'),
(126615, 'Wethersfield', 42.1027793884277, 0.734832124568868, -71.4749984741211, -1.24747405623134, 218, 23, 'PPL', 'P'),
(153754, 'Wethersfield Springs', 42.6858291625977, 0.745008262831143, -78.2061080932617, -1.364954081398, 218, 40, 'PPL', 'P'),
(18582, 'Wethocouchy (historical)', 30.2333297729492, 0.527671148379193, -84.6666717529297, -1.4777121887939, 218, 12, 'PPL', 'P'),
(52692, 'Wetipquin', 38.336669921875, 0.669101114386996, -75.8475036621094, -1.32378866832227, 218, 25, 'PPL', 'P'),
(34399, 'Wetmore', 39.6333312988281, 0.691732124698271, -95.8111114501953, -1.67221935480115, 218, 20, 'PPL', 'P'),
(74797, 'Wetmore', 38.9583282470703, 0.679951098984088, -83.0238876342773, -1.44904019702395, 218, 41, 'PPL', 'P'),
(91801, 'Wetmore', 35.2558288574219, 0.615330294081642, -84.5513916015625, -1.47570017059035, 218, 50, 'PPL', 'P'),
(99047, 'Wetmore', 29.5641708374023, 0.51599212173476, -98.4188919067383, -1.71773370993698, 218, 51, 'PPL', 'P'),
(133681, 'Wetmore', 46.3797187805176, 0.809478798869081, -86.6202774047852, -1.51180903970435, 218, 27, 'PPL', 'P'),
(168874, 'Wetmore', 41.6949996948242, 0.727715026292714, -78.8758316040039, -1.37664296173847, 218, 45, 'PPL', 'P'),
(177396, 'Wetmore', 43.6977806091309, 0.762670147443467, -75.559440612793, -1.31876101965836, 218, 40, 'PPL', 'P'),
(187534, 'Wetmore', 38.2380599975586, 0.667380046532532, -105.084167480469, -1.83406471425133, 218, 7, 'PPL', 'P'),
(133682, 'Wetmore Landing', 46.6166687011719, 0.813614355146838, -87.4649963378906, -1.52655216634097, 218, 27, 'PPL', 'P'),
(168876, 'Wetona', 41.8294410705566, 0.730061470950155, -76.6988906860352, -1.33864817509853, 218, 45, 'PPL', 'P'),
(171603, 'Wetonka', 45.6252784729004, 0.796311331491402, -98.7675018310547, -1.72381810092143, 218, 49, 'PPL', 'P'),
(99048, 'Wetsel', 33.1294403076172, 0.578217812710843, -96.644172668457, -1.68675901593049, 218, 51, 'PPL', 'P'),
(158342, 'Wetsel', 40.9466705322266, 0.714654218516692, -84.4361114501953, -1.47368815238679, 218, 41, 'PPL', 'P'),
(187962, 'Wettick', 37.7966690063477, 0.65967632044726, -100.263893127441, -1.74993505594157, 218, 20, 'PPL', 'P'),
(77663, 'Wetumka', 35.2374992370605, 0.615010381855696, -96.2413864135742, -1.67972906960101, 218, 42, 'PPL', 'P'),
(6756, 'Wetumpka', 32.5436096191406, 0.567993138337702, -86.2119369506836, -1.50468215431119, 218, 2, 'PPL', 'P'),
(18583, 'Wetumpka', 30.482780456543, 0.532024884129255, -84.6230621337891, -1.47695105735436, 218, 12, 'PPL', 'P'),
(28959, 'Wetzel', 39.7061080932617, 0.693002319380185, -87.7061080932617, -1.53076036033746, 218, 18, 'PPL', 'P'),
(133683, 'Wetzel', 44.9313888549805, 0.784200673013294, -85.0302810668945, -1.48405836851351, 218, 27, 'PPL', 'P'),
(197828, 'Wetzel', 48.7533302307129, 0.850906133838027, -113.163887023926, -1.97508242292239, 218, 31, 'PPL', 'P'),
(44109, 'Wetzlar', 31.6452808380127, 0.552314343341592, -92.8569412231445, -1.62065935767472, 218, 22, 'PPL', 'P'),
(112004, 'Wevaco', 38.0019416809082, 0.663259004482716, -81.4250030517578, -1.4211343966996, 218, 58, 'PPL', 'P'),
(118437, 'Wever', 40.7105598449707, 0.710533309624931, -91.230827331543, -1.59227831625386, 218, 16, 'PPL', 'P'),
(52694, 'Weverton', 39.3327789306641, 0.686486496299142, -77.6819381713867, -1.35580559042136, 218, 25, 'PPL', 'P'),
(153757, 'Wevertown', 43.6333312988281, 0.761545294778045, -73.9416732788086, -1.29052565314912, 218, 40, 'PPL', 'P'),
(212227, 'Wevok', 68.871940612793, 1.20204212593124, -166.090286254883, -2.89882235072759, 218, 1, 'PPL', 'P'),
(18584, 'Wewahitchka', 30.1124992370605, 0.525562257690987, -85.2005615234375, -1.48703032313198, 218, 12, 'PPL', 'P'),
(18585, 'Wewahotee', 28.4208297729492, 0.496037055686796, -81.0944366455078, -1.41536492451406, 218, 12, 'PPL', 'P'),
(112007, 'Wewanta', 38.0883293151855, 0.664766753133865, -82.1927795410156, -1.43453462435656, 218, 58, 'PPL', 'P'),
(126616, 'Weweantic', 41.735279083252, 0.728418034241467, -70.7324981689453, -1.23451498120896, 218, 23, 'PPL', 'P'),
(171605, 'Wewela', 43.0105590820313, 0.750675869104995, -99.7805633544922, -1.74149936003069, 218, 49, 'PPL', 'P'),
(77665, 'Wewoka', 35.1586112976074, 0.613633527572125, -96.4930572509766, -1.68412155434493, 218, 42, 'PPL', 'P'),
(25983, 'Wewoka Estates', 33.5544395446777, 0.585635448716013, -84.4519424438477, -1.47396445534989, 218, 13, 'PPL', 'P'),
(52696, 'Wexford', 39.1986083984375, 0.684144778752636, -77.2416687011719, -1.3481214385701, 218, 25, 'PPL', 'P'),
(58245, 'Wexford', 39.5430603027344, 0.690156598597381, -94.3949966430664, -1.6475034888305, 218, 29, 'PPL', 'P'),
(84326, 'Wexford', 34.688060760498, 0.605420871402539, -82.8805618286133, -1.44653868981203, 218, 48, 'PPL', 'P'),
(168878, 'Wexford', 40.6263885498047, 0.709064243388616, -80.0561065673828, -1.39724264592829, 218, 45, 'PPL', 'P'),
(133684, 'Wexford Corner', 44.5127792358398, 0.776894556878771, -85.6961135864258, -1.49567933824618, 218, 27, 'PPL', 'P'),
(91800, 'Wexford Downs', 35.9791717529297, 0.627955009229163, -84.1533279418945, -1.4687526490966, 218, 50, 'PPL', 'P'),
(71558, 'Wexford East', 39.8972206115723, 0.696337862066482, -74.9627838134766, -1.30834739400588, 218, 37, 'PPL', 'P'),
(25979, 'Wexford Estates', 33.7819404602051, 0.589606088743267, -84.7002792358398, -1.47829875002399, 218, 13, 'PPL', 'P'),
(84327, 'Wexford Plantation', 32.1666717529297, 0.561414331496879, -80.7638931274414, -1.40959585180267, 218, 48, 'PPL', 'P'),
(25980, 'Wexwood', 33.5283317565918, 0.585179781853501, -84.4075012207031, -1.4731888096824, 218, 13, 'PPL', 'P'),
(25981, 'Wexwood Glen', 33.6919403076172, 0.588035289753311, -84.5552825927734, -1.47576808119814, 218, 13, 'PPL', 'P'),
(44110, 'Weyanoke', 30.9466705322266, 0.540121293317259, -91.4611129760742, -1.596297558971, 218, 22, 'PPL', 'P'),
(107510, 'Weyanoke', 38.8191719055176, 0.677522362648963, -77.1563873291016, -1.34663299783686, 218, 53, 'PPL', 'P'),
(112005, 'Weyanoke', 37.4152793884277, 0.653019815881634, -81.2611083984375, -1.41827389537275, 218, 58, 'PPL', 'P'),
(168879, 'Weyant', 40.2133293151855, 0.701854999738744, -78.5563888549805, -1.37106763399639, 218, 45, 'PPL', 'P'),
(177000, 'Weyauwega', 44.3213882446289, 0.773554153923484, -88.9336090087891, -1.55218429288466, 218, 57, 'PPL', 'P'),
(25982, 'Weybridge', 33.5522193908691, 0.585596699722153, -84.3238906860352, -1.47172953056309, 218, 13, 'PPL', 'P'),
(121955, 'Weybridge', 41.9708290100098, 0.732529156016222, -88.4169387817383, -1.5431666962756, 218, 18, 'PPL', 'P'),
(172783, 'Weybridge', 44.0663909912109, 0.769103612267798, -73.2161102294922, -1.27786218900774, 218, 55, 'PPL', 'P'),
(172784, 'Weybridge Hill', 44.038330078125, 0.768613856943333, -73.2136077880859, -1.27781851316586, 218, 55, 'PPL', 'P'),
(107511, 'Weyburn (historical)', 38.1908302307129, 0.666555731596126, -78.2458267211914, -1.36564730222975, 218, 53, 'PPL', 'P'),
(52697, 'Weyburn Park', 39.334171295166, 0.686510797644089, -76.5152816772461, -1.33544359335883, 218, 25, 'PPL', 'P'),
(153758, 'Weyer', 42.728328704834, 0.745750019773757, -78.9161071777344, -1.37734590310819, 218, 40, 'PPL', 'P'),
(177003, 'Weyerhaeuser', 45.4236106872559, 0.792791564636699, -91.408332824707, -1.59537637154995, 218, 57, 'PPL', 'P'),
(158343, 'Weyers', 41.3736114501953, 0.722105743246734, -82.7675018310547, -1.44456542060234, 218, 41, 'PPL', 'P'),
(107512, 'Weyers Cave', 38.288330078125, 0.668257424953659, -78.913330078125, -1.37729743357636, 218, 53, 'PPL', 'P'),
(71559, 'Weymouth', 39.5149993896484, 0.689666843272915, -74.779167175293, -1.30514267910813, 218, 37, 'PPL', 'P'),
(126617, 'Weymouth', 42.2208290100098, 0.736892479146208, -70.9402770996094, -1.23814140766532, 218, 23, 'PPL', 'P'),
(158344, 'Weymouth', 41.1855583190918, 0.718823596940293, -81.7944412231445, -1.42758230917285, 218, 41, 'PPL', 'P'),
(126618, 'Weymouth Heights', 42.2299995422363, 0.737052535127722, -70.9458312988281, -1.238238346729, 218, 23, 'PPL', 'P'),
(113086, 'Weymouth Landing', 42.223331451416, 0.736936154988086, -70.9625015258789, -1.23852929707809, 218, 23, 'PPL', 'P'),
(187535, 'Wezel (historical)', 38.7983283996582, 0.677158574844058, -103.454170227051, -1.80561589538073, 218, 7, 'PPL', 'P'),
(138796, 'Whalan', 43.7322196960449, 0.763271222901498, -91.9263916015625, -1.60441820292493, 218, 28, 'PPL', 'P'),
(193327, 'Whale Pass', 56.1152801513672, 0.979396399320379, -133.120834350586, -2.32339686241969, 218, 1, 'PPL', 'P'),
(169672, 'Whale Rock Light (historical)', 41.4441719055176, 0.723337255513814, -71.4238891601563, -1.24658203042421, 218, 47, 'PPL', 'P'),
(70079, 'Whalebone', 35.913330078125, 0.626805855218794, -75.5999984741211, -1.3194688878761, 218, 33, 'PPL', 'P'),
(99049, 'Whalen Acres Colonia', 26.19700050354, 0.457223912933386, -98.2080001831055, -1.71405295499438, 218, 51, 'PPL', 'P'),
(62288, 'Whaley', 33.6236114501953, 0.586842726217174, -90.1061096191406, -1.57264828901694, 218, 30, 'PPL', 'P'),
(70080, 'Whaley', 36.2361106872559, 0.63243943960972, -81.9319381713867, -1.42998208363112, 218, 33, 'PPL', 'P'),
(84328, 'Whaley', 33.4408302307129, 0.583652592126395, -81.2986068725586, -1.41892836721064, 218, 48, 'PPL', 'P'),
(99050, 'Whaley', 33.4636116027832, 0.584050202077144, -94.3349990844727, -1.64645633388988, 218, 51, 'PPL', 'P'),
(107513, 'Whaley', 36.5913887023926, 0.638640210733806, -76.6699981689453, -1.33814390554612, 218, 53, 'PPL', 'P'),
(99051, 'Whaley Corner', 29.4458293914795, 0.513926673861835, -95.6738891601563, -1.66982437403284, 218, 51, 'PPL', 'P'),
(133687, 'Whaley Drain', 42.6533317565918, 0.744441076097983, -84.6763916015625, -1.47788183215534, 218, 27, 'PPL', 'P'),
(14842, 'Whaleys Corners', 38.6522216796875, 0.67460853152128, -75.4305572509766, -1.31651158064362, 218, 10, 'PPL', 'P'),
(14843, 'Whaleys Crossroads', 38.5319404602051, 0.672509228212998, -75.4505615234375, -1.31686072106253, 218, 10, 'PPL', 'P'),
(52698, 'Whaleyville', 38.396671295166, 0.670148335906642, -75.3024978637695, -1.31427652269877, 218, 25, 'PPL', 'P'),
(107514, 'Whaleyville', 36.5880584716797, 0.638582087243015, -76.6849975585938, -1.33840569428127, 218, 53, 'PPL', 'P'),
(153759, 'Whallonsburg', 44.2641716003418, 0.772555535093732, -73.4033279418945, -1.28112975450721, 218, 40, 'PPL', 'P'),
(126620, 'Whalom', 42.5750007629395, 0.743073942352391, -71.7472229003906, -1.25222526877409, 218, 23, 'PPL', 'P'),
(44111, 'Wham', 32.6261100769043, 0.56943304296008, -91.9233322143555, -1.60436480654507, 218, 22, 'PPL', 'P'),
(112006, 'Wharncliffe', 37.5552787780762, 0.655463266181782, -81.9658279418945, -1.43057357170923, 218, 58, 'PPL', 'P'),
(12778, 'Wharton', 36.0247192382813, 0.628749962814551, -93.6302795410156, -1.63415665755341, 218, 4, 'PPL', 'P'),
(99052, 'Wharton', 29.3113899230957, 0.511580262493908, -96.1025009155273, -1.67730506037682, 218, 51, 'PPL', 'P'),
(112008, 'Wharton', 37.9033317565918, 0.661537936628253, -81.6774978637695, -1.42554126251341, 218, 58, 'PPL', 'P'),
(146633, 'Wharton', 40.8930587768555, 0.713718516867693, -74.5822219848633, -1.30170533708916, 218, 37, 'PPL', 'P'),
(158345, 'Wharton', 40.8613891601563, 0.713165777783447, -83.461669921875, -1.45668093934944, 218, 41, 'PPL', 'P'),
(168880, 'Wharton', 41.5316696166992, 0.724864378661893, -78.0199966430664, -1.36170582381643, 218, 45, 'PPL', 'P'),
(79400, 'Wharton Furnace', 39.8250007629395, 0.695077387922547, -79.6363906860352, -1.38991722187586, 218, 45, 'PPL', 'P'),
(107515, 'Wharton Grove (historical)', 37.6552810668945, 0.657208635381193, -76.4558334350586, -1.33440602579814, 218, 53, 'PPL', 'P'),
(118441, 'What Cheer', 41.4013900756836, 0.722590571723183, -92.3544387817383, -1.61188903557287, 218, 16, 'PPL', 'P'),
(126621, 'Whately', 42.4397201538086, 0.740712850308954, -72.6352767944336, -1.2677247331603, 218, 23, 'PPL', 'P'),
(197829, 'Whately', 48.1627807617188, 0.840599101208175, -106.510833740234, -1.85896473781136, 218, 31, 'PPL', 'P'),
(6757, 'Whatley', 31.6505603790283, 0.552406488715309, -87.7050018310547, -1.53074105241956, 218, 2, 'PPL', 'P'),
(99054, 'Whatley', 33.4897193908691, 0.584505868939656, -94.0469436645508, -1.64142881838403, 218, 51, 'PPL', 'P'),
(6758, 'Whatley Cross Road', 32.497501373291, 0.567188397635307, -85.3747177124023, -1.49006992204214, 218, 2, 'PPL', 'P'),
(52699, 'Whayland', 38.3288917541504, 0.668965359750429, -75.6827774047852, -1.32091365276747, 218, 25, 'PPL', 'P'),
(38833, 'Whaynes Corner', 36.649169921875, 0.639648683259592, -89.1216735839844, -1.55546663892818, 218, 21, 'PPL', 'P'),
(206454, 'Wheadon Acres', 40.5605583190918, 0.707915289115329, -111.962219238281, -1.95410936354775, 218, 52, 'PPL', 'P'),
(112009, 'Wheat', 39.6263885498047, 0.691610950868673, -80.5950012207031, -1.40664813195012, 218, 58, 'PPL', 'P'),
(25984, 'Wheat Hill', 32.1058311462402, 0.560352462591237, -81.1563873291016, -1.41644616791663, 218, 13, 'PPL', 'P'),
(74798, 'Wheat Ridge', 38.8841705322266, 0.678656802694309, -83.5033264160156, -1.45740798232703, 218, 41, 'PPL', 'P'),
(187536, 'Wheat Ridge', 39.7661094665527, 0.694049540899831, -105.076667785645, -1.83393381988376, 218, 7, 'PPL', 'P'),
(71561, 'Wheat Road', 39.5116691589355, 0.689608719782124, -74.9741668701172, -1.3085460658232, 218, 37, 'PPL', 'P'),
(168882, 'Wheat Sheaf', 40.1624984741211, 0.700967834200612, -74.7991714477539, -1.30549181952704, 218, 45, 'PPL', 'P'),
(70081, 'Wheat Swamp', 35.3405609130859, 0.616809147434963, -77.6791687011719, -1.35575725404758, 218, 33, 'PPL', 'P'),
(38832, 'Wheatcroft', 37.4900016784668, 0.654323965867446, -87.8627777099609, -1.5334947609867, 218, 21, 'PPL', 'P'),
(84329, 'Wheatfield', 34.2261085510254, 0.597358284360379, -82.1105575561523, -1.43309958000317, 218, 48, 'PPL', 'P'),
(107518, 'Wheatfield', 39.0733299255371, 0.681958256918653, -78.3724975585938, -1.36785812540868, 218, 53, 'PPL', 'P'),
(124006, 'Wheatfield', 41.1930618286133, 0.718954557886898, -87.0555572509766, -1.51940610618796, 218, 19, 'PPL', 'P'),
(52700, 'Wheatfield Way', 39.2455596923828, 0.684964233420053, -76.8097229003906, -1.34058256215631, 218, 25, 'PPL', 'P'),
(179506, 'Wheatfields', 36.2377815246582, 0.632468601223656, -109.128059387207, -1.90464394261867, 218, 5, 'PPL', 'P'),
(192859, 'Wheatgrass', 37.9719390869141, 0.66273536043338, -112.792778015137, -1.96860534883521, 218, 52, 'PPL', 'P'),
(31509, 'Wheatland', 38.6636085510254, 0.674807269917627, -87.309440612793, -1.52383720676769, 218, 19, 'PPL', 'P'),
(58246, 'Wheatland', 37.9461097717285, 0.662284553839857, -93.4008331298828, -1.63015206222226, 218, 29, 'PPL', 'P'),
(71562, 'Wheatland', 39.8950004577637, 0.696299113072621, -74.4341735839844, -1.29912140504152, 218, 37, 'PPL', 'P'),
(77666, 'Wheatland', 35.3977813720703, 0.617807832843743, -97.6519393920898, -1.70434786334992, 218, 42, 'PPL', 'P'),
(99056, 'Wheatland', 32.6158294677734, 0.569253612481636, -97.539436340332, -1.7023843146782, 218, 51, 'PPL', 'P'),
(107516, 'Wheatland', 39.1908302307129, 0.684009024116069, -77.6758270263672, -1.3556989308197, 218, 53, 'PPL', 'P'),
(112010, 'Wheatland', 39.2361106872559, 0.68479931716955, -77.9002838134766, -1.35961644078321, 218, 58, 'PPL', 'P'),
(118438, 'Wheatland', 41.8316688537598, 0.73010035310207, -90.8380584716797, -1.58542320644994, 218, 16, 'PPL', 'P'),
(133689, 'Wheatland', 41.9711112976074, 0.732534082864239, -84.4011077880859, -1.47307722323273, 218, 27, 'PPL', 'P'),
(138798, 'Wheatland', 44.4647216796875, 0.77605579429345, -93.4833297729492, -1.63159190026561, 218, 28, 'PPL', 'P'),
(141076, 'Wheatland', 46.9075012207031, 0.818690340184529, -97.3450012207031, -1.69899078165917, 218, 34, 'PPL', 'P'),
(168886, 'Wheatland', 40.0394401550293, 0.69882006136049, -76.3513870239258, -1.33258309203198, 218, 45, 'PPL', 'P'),
(177005, 'Wheatland', 42.5938911437988, 0.743403641695343, -88.2083282470703, -1.5395257555913, 218, 57, 'PPL', 'P'),
(186115, 'Wheatland', 39.0099983215332, 0.680852911908216, -121.421943664551, -2.11921270111748, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(189807, 'Wheatland', 34.9086112976074, 0.60927020444214, -103.353607177734, -1.80386073906431, 218, 38, 'PPL', 'P'),
(201788, 'Wheatland', 45.0927810668945, 0.787017498498271, -123.048889160156, -2.14760825676629, 218, 43, 'PPL', 'P'),
(209826, 'Wheatland', 42.0544395446777, 0.733988435135531, -104.952217102051, -1.83176174569869, 218, 59, 'PPL', 'P'),
(153761, 'Wheatland Center', 43.0063896179199, 0.750603098228209, -77.8216705322266, -1.3582443801896, 218, 40, 'PPL', 'P'),
(107517, 'Wheatlands', 37.6930618286133, 0.657868034067096, -77.7222213745117, -1.35650866494914, 218, 53, 'PPL', 'P'),
(126623, 'Wheatleigh', 42.3394393920898, 0.738962620840554, -73.2975006103516, -1.27928271913319, 218, 23, 'PPL', 'P'),
(12781, 'Wheatley', 34.9127807617188, 0.609342975318926, -91.1100006103516, -1.59016949214468, 218, 4, 'PPL', 'P'),
(38834, 'Wheatley', 38.6133308410645, 0.673929758338446, -84.976936340332, -1.48312732739641, 218, 21, 'PPL', 'P'),
(153763, 'Wheatley', 40.8055610656738, 0.712191393719614, -73.591667175293, -1.2844168942407, 218, 40, 'PPL', 'P'),
(153764, 'Wheatley Heights', 40.7636108398438, 0.711459224156924, -73.3702774047852, -1.2805529138151, 218, 40, 'PPL', 'P'),
(25985, 'Wheaton', 31.7552795410156, 0.554234182881916, -82.2827835083008, -1.43610548992554, 218, 13, 'PPL', 'P'),
(34405, 'Wheaton', 39.5022201538086, 0.689443803531621, -96.320556640625, -1.68111085073259, 218, 20, 'PPL', 'P'),
(52702, 'Wheaton', 39.0397186279297, 0.681371629109536, -77.0555572509766, -1.34487318098853, 218, 25, 'PPL', 'P'),
(58248, 'Wheaton', 36.7627792358398, 0.64163153984921, -94.0558319091797, -1.64158394751753, 218, 29, 'PPL', 'P'),
(121958, 'Wheaton', 41.8661117553711, 0.730701495139128, -88.1069412231445, -1.53775621820499, 218, 18, 'PPL', 'P'),
(138800, 'Wheaton', 45.8044395446777, 0.799438282085319, -96.498893737793, -1.68422342025662, 218, 28, 'PPL', 'P'),
(197831, 'Wheaton (historical)', 46.5844383239746, 0.813051828945586, -108.850830078125, -1.89980537839216, 218, 31, 'PPL', 'P'),
(52703, 'Wheaton Crest', 39.0486106872559, 0.681526824822061, -77.0569381713867, -1.3448972825964, 218, 25, 'PPL', 'P'),
(52704, 'Wheaton Forest', 39.0380592346191, 0.681342667232682, -77.0475006103516, -1.34473256608298, 218, 25, 'PPL', 'P'),
(52705, 'Wheaton Hills', 39.0455589294434, 0.681473561600259, -77.0605621337891, -1.34496053267229, 218, 25, 'PPL', 'P'),
(186114, 'Wheaton Springs', 35.4622192382813, 0.618932485772083, -115.475280761719, -2.01542385395686, 218, 6, 'PPL', 'P'),
(52706, 'Wheaton Woods', 39.0719413757324, 0.681934022152734, -77.084716796875, -1.34538211107285, 218, 25, 'PPL', 'P'),
(186116, 'Wheatons', 36.0325012207031, 0.628885784030146, -118.701667785645, -2.07173493046798, 218, 6, 'PPL', 'P'),
(31510, 'Wheatonville', 38.1872215270996, 0.666492747836345, -87.4613876342773, -1.52648918258119, 218, 19, 'PPL', 'P'),
(74799, 'Wheatville', 39.688060760498, 0.692687334002256, -84.5761108398438, -1.47613160268694, 218, 41, 'PPL', 'P'),
(153765, 'Wheatville', 43.0961112976074, 0.752169036949175, -78.341667175293, -1.36732003371043, 218, 40, 'PPL', 'P'),
(566, 'Wheel', 36.8555603027344, 0.643250874950033, -88.8036117553711, -1.54991541279397, 218, 21, 'PPL', 'P'),
(91802, 'Wheel', 35.4886093139648, 0.619393079482613, -86.6297225952148, -1.51197388937583, 218, 50, 'PPL', 'P'),
(118440, 'Wheel Estates Mobile Home Park', 41.3083305358887, 0.720966376353371, -93.1083297729492, -1.62504691557063, 218, 16, 'PPL', 'P'),
(179507, 'Wheel Inn Ranch', 33.459171295166, 0.583972704089422, -111.928611755371, -1.95352280231766, 218, 5, 'PPL', 'P'),
(38835, 'Wheel Rim', 37.7261085510254, 0.65844480818018, -83.2669372558594, -1.45328221316628, 218, 21, 'PPL', 'P'),
(84330, 'Wheeland', 34.1569404602051, 0.596151073438246, -81.4391708374023, -1.42138167120682, 218, 48, 'PPL', 'P'),
(6759, 'Wheeler', 34.6525001525879, 0.604800221710496, -87.2497177124023, -1.52279484551704, 218, 2, 'PPL', 'P'),
(12783, 'Wheeler', 36.1141700744629, 0.630311174424583, -94.2588882446289, -1.64512794913815, 218, 4, 'PPL', 'P'),
(28962, 'Wheeler', 39.0466690063477, 0.681492936097189, -88.3163909912109, -1.54141180627529, 218, 18, 'PPL', 'P'),
(38836, 'Wheeler', 36.7252807617188, 0.640977068011323, -83.8430633544922, -1.46333751049409, 218, 21, 'PPL', 'P'),
(62289, 'Wheeler', 34.5802803039551, 0.603539747566562, -88.6074981689453, -1.54649258500294, 218, 30, 'PPL', 'P'),
(107519, 'Wheeler', 36.621940612793, 0.639173442163067, -83.5552825927734, -1.4583147886782, 218, 53, 'PPL', 'P'),
(112012, 'Wheeler', 38.6863899230957, 0.675204879868376, -80.4027786254883, -1.40329321476689, 218, 58, 'PPL', 'P'),
(124008, 'Wheeler', 41.5116691589355, 0.724515304822011, -87.1791687011719, -1.52156353298704, 218, 19, 'PPL', 'P'),
(133693, 'Wheeler', 43.4127807617188, 0.757695961738444, -84.4377822875977, -1.47371731400073, 218, 27, 'PPL', 'P'),
(153766, 'Wheeler', 42.4302787780762, 0.740548067216506, -77.3327789306641, -1.34971161205699, 218, 40, 'PPL', 'P'),
(168887, 'Wheeler', 40.0038909912109, 0.698199611405529, -79.6036071777344, -1.38934504171566, 218, 45, 'PPL', 'P'),
(177009, 'Wheeler', 45.0444412231445, 0.786173809064934, -91.9086074829102, -1.60410781149988, 218, 57, 'PPL', 'P'),
(186117, 'Wheeler', 39.8855590820313, 0.696134329980172, -123.910003662109, -2.16263754006204, 218, 6, 'PPL', 'P'),
(187963, 'Wheeler', 39.7641716003418, 0.694015718753987, -101.712501525879, -1.77521804206634, 218, 20, 'PPL', 'P'),
(192424, 'Wheeler', 35.4452781677246, 0.618636808312057, -100.270561218262, -1.7500514360812, 218, 51, 'PPL', 'P'),
(197832, 'Wheeler', 48.0094413757324, 0.837922824049727, -106.505561828613, -1.85887272559569, 218, 31, 'PPL', 'P'),
(201789, 'Wheeler', 45.6891708374023, 0.797426463618846, -123.879440307617, -2.1621041088957, 218, 43, 'PPL', 'P'),
(209160, 'Wheeler', 47.1308288574219, 0.822588142755969, -119.170829772949, -2.07992335187165, 218, 56, 'PPL', 'P'),
(25986, 'Wheeler (historical)', 34.5688896179199, 0.603340942591187, -84.7483291625977, -1.47913737945126, 218, 13, 'PPL', 'P'),
(112011, 'Wheeler (historical)', 38.8319396972656, 0.677745202653175, -79.7044372558594, -1.39110485856398, 218, 58, 'PPL', 'P'),
(143384, 'Wheeler (historical)', 41.9866714477539, 0.7328056587164, -98.626106262207, -1.72135028269731, 218, 35, 'PPL', 'P'),
(158346, 'Wheeler (historical)', 41.7333297729492, 0.728384012358541, -81.0444412231445, -1.41449233978289, 218, 41, 'PPL', 'P'),
(171608, 'Wheeler (historical)', 43.1583290100098, 0.753254940883655, -98.8422164916992, -1.72512211774919, 218, 49, 'PPL', 'P'),
(209161, 'Wheeler Corner', 47.5508308410645, 0.829918560235439, -117.971389770508, -2.05898917464892, 218, 56, 'PPL', 'P'),
(6760, 'Wheeler Dam Village', 34.7933311462402, 0.607258186238585, -87.378059387207, -1.5250348303099, 218, 2, 'PPL', 'P'),
(153767, 'Wheeler Estates', 42.9030609130859, 0.748799672117034, -73.9388885498047, -1.29047705045923, 218, 40, 'PPL', 'P'),
(211310, 'Wheeler Field', 21.4888896942139, 0.375051877761909, -158.038604736328, -2.75829399790683, 218, 15, 'PPL', 'P'),
(25988, 'Wheeler Heights', 32.8261108398438, 0.572923714779874, -83.5586090087891, -1.45837284558996, 218, 13, 'PPL', 'P'),
(201791, 'Wheeler Heights', 45.685001373291, 0.797353692742059, -123.889442443848, -2.16227867910515, 218, 43, 'PPL', 'P'),
(187537, 'Wheeler Junction', 39.5061111450195, 0.689511714139418, -106.141670227051, -1.85252161902807, 218, 7, 'PPL', 'P'),
(138802, 'Wheeler Landing', 47.725830078125, 0.832972873110624, -91.2900009155273, -1.59331109012459, 218, 28, 'PPL', 'P'),
(179508, 'Wheeler Place', 32.264720916748, 0.563125612234337, -109.082778930664, -1.90385364956519, 218, 5, 'PPL', 'P'),
(112013, 'Wheeler Ridge', 38.4069404602051, 0.670327566648005, -82.029167175293, -1.43167904987772, 218, 58, 'PPL', 'P'),
(186118, 'Wheeler Ridge', 35.0044403076172, 0.610942736185737, -118.948608398438, -2.07604485721811, 218, 6, 'PPL', 'P'),
(99057, 'Wheeler Springs', 31.3766708374023, 0.547626214427157, -95.6463928222656, -1.66934447240441, 218, 51, 'PPL', 'P'),
(177696, 'Wheeler Springs', 34.5080604553223, 0.602279273422627, -119.290557861328, -2.08201300122098, 218, 6, 'PPL', 'P'),
(38837, 'Wheelers Mill', 37.3938903808594, 0.652646507275833, -86.0261077880859, -1.50143882357764, 218, 21, 'PPL', 'P'),
(58250, 'Wheelers Mill', 37.9083290100098, 0.661625155153953, -92.1758270263672, -1.60877167235888, 218, 29, 'PPL', 'P'),
(74801, 'Wheelers Mill', 38.8274993896484, 0.677667704665454, -82.8499984741211, -1.44600525864569, 218, 41, 'PPL', 'P'),
(138803, 'Wheelers Point', 48.8377799987793, 0.852380060343331, -94.6975021362305, -1.65278320569159, 218, 28, 'PPL', 'P'),
(197833, 'Wheelers Trailer Court', 45.6791687011719, 0.797251893409391, -111.073608398438, -1.93860017862356, 218, 31, 'PPL', 'P'),
(38841, 'Wheelersburg', 37.8266716003418, 0.660199964496597, -83.0111083984375, -1.44881715728265, 218, 21, 'PPL', 'P'),
(74800, 'Wheelersburg', 38.730281829834, 0.675970938155937, -82.8555603027344, -1.44610233086742, 218, 41, 'PPL', 'P'),
(91803, 'Wheelerton', 35.0894393920898, 0.612426250070965, -86.836669921875, -1.51558580160425, 218, 50, 'PPL', 'P'),
(153769, 'Wheelertown', 43.3952789306641, 0.757390497161412, -75.063606262207, -1.31010707769615, 218, 40, 'PPL', 'P'),
(6761, 'Wheelerville', 30.6900005340576, 0.535641556758124, -88.1916732788086, -1.53923507155831, 218, 2, 'PPL', 'P'),
(58251, 'Wheelerville', 36.836109161377, 0.642911388490075, -93.6291732788086, -1.6341373496355, 218, 29, 'PPL', 'P'),
(153770, 'Wheelerville', 43.1572189331055, 0.753235566386725, -74.4872207641602, -1.30004725299448, 218, 40, 'PPL', 'P'),
(168888, 'Wheelerville', 41.5744400024414, 0.725610862715442, -76.7852783203125, -1.34015592374967, 218, 45, 'PPL', 'P'),
(118444, 'Wheelerwood', 43.2416687011719, 0.754709492892029, -93.0638885498047, -1.62427126990314, 218, 16, 'PPL', 'P'),
(191027, 'Wheeless', 36.7191696166992, 0.640870408409666, -102.893890380859, -1.79583716733212, 218, 42, 'PPL', 'P'),
(12785, 'Wheeling', 36.3202781677246, 0.633908439267008, -91.8630599975586, -1.60331285791449, 218, 4, 'PPL', 'P'),
(44112, 'Wheeling', 31.7461109161377, 0.554074160189916, -92.8391723632813, -1.62034923256578, 218, 22, 'PPL', 'P'),
(58252, 'Wheeling', 39.7866706848145, 0.694408401856719, -93.3852767944336, -1.62988055294912, 218, 29, 'PPL', 'P'),
(121959, 'Wheeling', 42.1391716003418, 0.735467288488852, -87.9288864135742, -1.53464857552898, 218, 18, 'PPL', 'P'),
(124010, 'Wheeling', 40.3636093139648, 0.704477880517336, -85.4641723632813, -1.4916312002312, 218, 19, 'PPL', 'P'),
(177301, 'Wheeling', 40.0638885498047, 0.699246766346148, -80.7211074829102, -1.40884910143301, 218, 58, 'PPL', 'P'),
(158347, 'Wheeling Creek', 40.0677795410156, 0.699314676953945, -80.7797164916992, -1.40987202160771, 218, 41, 'PPL', 'P'),
(6762, 'Wheeling Crossroad', 33.4094390869141, 0.583104713311138, -86.9199981689453, -1.51704015387554, 218, 2, 'PPL', 'P'),
(177302, 'Wheeling Heights', 40.0444412231445, 0.698907346465217, -80.7125015258789, -1.40869889914753, 218, 58, 'PPL', 'P'),
(158352, 'Wheeling Valley (historical)', 40.1497192382813, 0.700744794459318, -80.9024963378906, -1.41201493417885, 218, 41, 'PPL', 'P'),
(194476, 'Wheelman', 40.0036087036133, 0.698194684557512, -105.373329162598, -1.83911153767509, 218, 7, 'PPL', 'P'),
(99058, 'Wheelock', 30.8974990844727, 0.539263089655981, -96.3897171020508, -1.68231792849667, 218, 51, 'PPL', 'P'),
(129316, 'Wheelock', 47.2247200012207, 0.824226852353722, -68.7438888549805, -1.19980720114444, 218, 26, 'PPL', 'P'),
(168889, 'Wheelock', 41.9797210693359, 0.732684351728747, -79.6699981689453, -1.39050378310595, 218, 45, 'PPL', 'P'),
(172787, 'Wheelock', 44.5880584716797, 0.778208427402561, -72.0888900756836, -1.25818848592894, 218, 55, 'PPL', 'P'),
(199085, 'Wheelock', 48.2963905334473, 0.842931031637675, -103.251937866211, -1.80208627482999, 218, 34, 'PPL', 'P'),
(158350, 'Wheelock (historical)', 41.3444404602051, 0.721596613425338, -81.5166702270508, -1.42273429072447, 218, 41, 'PPL', 'P'),
(129317, 'Wheelock Mill', 46.999439239502, 0.820294961320329, -68.897216796875, -1.20248327856581, 218, 26, 'PPL', 'P'),
(91804, 'Wheelocktown (historical)', 36.3972206115723, 0.63525133824668, -82.543327331543, -1.44065283748685, 218, 50, 'PPL', 'P'),
(126624, 'Wheelockville', 42.0805587768555, 0.734444301735126, -71.6152801513672, -1.2499224333795, 218, 23, 'PPL', 'P'),
(206459, 'Wheelon', 41.8291702270508, 0.73005674383922, -112.055282592773, -1.95573362549658, 218, 52, 'PPL', 'P'),
(38838, 'Wheelwright', 37.3325004577637, 0.651575050990266, -82.7211074829102, -1.4437556864729, 218, 21, 'PPL', 'P'),
(126625, 'Wheelwright', 42.3519401550293, 0.739180800312859, -72.1402816772461, -1.25908543858408, 218, 23, 'PPL', 'P'),
(38839, 'Wheelwright Junction', 37.3530616760254, 0.651933911947155, -82.7169418334961, -1.44368298217514, 218, 21, 'PPL', 'P'),
(209162, 'Whelan', 46.7841682434082, 0.816537773654445, -117.115562438965, -2.04405216988494, 218, 56, 'PPL', 'P'),
(25989, 'Whelchel', 34.3944396972656, 0.600296217095927, -83.8638916015625, -1.46370103198289, 218, 13, 'PPL', 'P'),
(12786, 'Whelen Springs', 33.8308296203613, 0.590459365556528, -93.126106262207, -1.62535717383762, 218, 4, 'PPL', 'P'),
(25990, 'Wheless', 33.4516716003418, 0.583841809721845, -82.0466690063477, -1.43198451445475, 218, 13, 'PPL', 'P'),
(186119, 'Wherry Housing', 34.9230613708496, 0.60952240579737, -117.934440612793, -2.05834429019096, 218, 6, 'PPL', 'P'),
(158351, 'Wherrys Crossroads', 40.6169395446777, 0.708899327138113, -81.1033325195313, -1.41552018680561, 218, 41, 'PPL', 'P'),
(168890, 'Whetham', 41.2688903808594, 0.720278015790613, -77.5911102294922, -1.35422034378249, 218, 45, 'PPL', 'P'),
(84332, 'Whetsell', 33.333610534668, 0.581781255407424, -80.5902786254883, -1.40656570711438, 218, 48, 'PPL', 'P'),
(112014, 'Whetsell (historical)', 39.439998626709, 0.688357833018114, -79.6519393920898, -1.39018859799094, 218, 58, 'PPL', 'P'),
(38840, 'Whetstone', 37.0869407653809, 0.647289225848002, -84.39111328125, -1.47290278618133, 218, 21, 'PPL', 'P'),
(52707, 'Whetstone', 39.1680603027344, 0.683611613902402, -77.1944427490234, -1.34729719021272, 218, 25, 'PPL', 'P'),
(84331, 'Whetstone', 34.8411102294922, 0.608092088554916, -83.1911087036133, -1.45195875526256, 218, 48, 'PPL', 'P'),
(112015, 'Whetstone', 38.5016708374023, 0.671980923631753, -81.0558319091797, -1.41469114475827, 218, 58, 'PPL', 'P'),
(179510, 'Whetstone', 31.9572200775146, 0.557758710137068, -110.34139251709, -1.92582060065865, 218, 5, 'PPL', 'P'),
(209163, 'Whetstone', 46.3933296203613, 0.809716352838316, -117.89582824707, -2.05767037727711, 218, 56, 'PPL', 'P'),
(91805, 'Whetstone (historical)', 36.0291709899902, 0.628827660539355, -84.4930572509766, -1.47468204410561, 218, 50, 'PPL', 'P'),
(84333, 'Whetstone Crossroads', 33.1752815246582, 0.57901789288133, -80.8036117553711, -1.41028907263442, 218, 48, 'PPL', 'P'),
(107520, 'Whetstone Hills', 37.3208312988281, 0.651371385745903, -79.2377777099609, -1.38296011300219, 218, 53, 'PPL', 'P'),
(70082, 'Whichard', 35.6969413757324, 0.623029159897925, -77.2552795410156, -1.34835899253934, 218, 33, 'PPL', 'P'),
(70083, 'Whichard Beach', 35.5041694641113, 0.619664655334773, -77.0233306884766, -1.34431072136631, 218, 33, 'PPL', 'P'),
(38842, 'Whick', 37.4216690063477, 0.653131335752281, -83.376106262207, -1.45518757176818, 218, 21, 'PPL', 'P'),
(38843, 'Whickerville', 37.2002792358398, 0.649267355326685, -85.690559387207, -1.4955823991825, 218, 21, 'PPL', 'P'),
(18586, 'Whidden Corner', 26.7538890838623, 0.466943452226767, -81.0822219848633, -1.4151517384688, 218, 12, 'PPL', 'P'),
(126626, 'Whidden Corner', 42.6263885498047, 0.743970828428503, -71.4208297729492, -1.24652863404436, 218, 23, 'PPL', 'P'),
(153771, 'Whig Corners', 42.7097206115723, 0.745425247278822, -74.8947219848633, -1.30715949100165, 218, 40, 'PPL', 'P'),
(153772, 'Whig Hill', 43.2936096191406, 0.755616032927092, -76.0761108398438, -1.32777861626742, 218, 40, 'PPL', 'P'),
(168891, 'Whig Hill', 41.5608291625977, 0.725373308746207, -79.29638671875, -1.38398303317689, 218, 45, 'PPL', 'P'),
(71563, 'Whig Lane', 39.6394386291504, 0.691838717720902, -75.2291717529297, -1.31299674063694, 218, 37, 'PPL', 'P'),
(25991, 'Whigham', 30.8827800750732, 0.53900619447933, -84.3238906860352, -1.47172953056309, 218, 13, 'PPL', 'P'),
(74802, 'Whigville', 39.8274993896484, 0.695120997185397, -81.373893737793, -1.42024237089248, 218, 41, 'PPL', 'P'),
(112242, 'Whigville', 39.2222213745117, 0.684556902931325, -75.6722183227539, -1.32072936202004, 218, 10, 'PPL', 'P'),
(114286, 'Whigville', 41.7330589294434, 0.728379285247607, -72.942497253418, -1.27308674169906, 218, 8, 'PPL', 'P'),
(138805, 'Whipholt', 47.0488891601563, 0.821158025250596, -94.3649978637695, -1.64697991136019, 218, 28, 'PPL', 'P'),
(146635, 'Whippany', 40.8244400024414, 0.712520893325484, -74.4175033569336, -1.29883045469242, 218, 37, 'PPL', 'P'),
(84334, 'Whipper-Barnoy', 32.8622207641602, 0.573553951851842, -79.9872207641602, -1.39604036185417, 218, 48, 'PPL', 'P'),
(12787, 'Whipple', 35.4219398498535, 0.61822947782333, -92.4619369506836, -1.61376523256083, 218, 4, 'PPL', 'P'),
(74803, 'Whipple', 39.5222206115723, 0.689792877371503, -81.4147186279297, -1.42095489964213, 218, 41, 'PPL', 'P'),
(112016, 'Whipple', 37.961669921875, 0.662556129692017, -81.1661071777344, -1.41661581127807, 218, 58, 'PPL', 'P'),
(169673, 'Whipple', 41.964168548584, 0.732412909034641, -71.6575012207031, -1.25065933005313, 218, 47, 'PPL', 'P'),
(179509, 'Whipple', 34.5566711425781, 0.603127689966899, -112.448890686035, -1.9626033826865, 218, 5, 'PPL', 'P'),
(153773, 'Whipple Corner', 42.4666709899902, 0.74118323113649, -76.5727767944336, -1.33644707245758, 218, 40, 'PPL', 'P'),
(158354, 'Whipple Heights', 40.8161087036133, 0.712375484729966, -81.4338912963867, -1.4212895258331, 218, 41, 'PPL', 'P'),
(209827, 'Whipple Hollow', 43.0974998474121, 0.752193271715095, -105.59806060791, -1.84303384132856, 218, 59, 'PPL', 'P'),
(112017, 'Whipple Junction', 37.9563903808594, 0.662463984318301, -81.1661071777344, -1.41661581127807, 218, 58, 'PPL', 'P'),
(126627, 'Whipples', 42.2027816772461, 0.736577493768279, -72.317497253418, -1.2621784338741, 218, 23, 'PPL', 'P'),
(25992, 'Whipples Crossing', 32.5291709899902, 0.567741136719553, -83.0586090087891, -1.44964619932999, 218, 13, 'PPL', 'P'),
(153774, 'Whippleville', 44.8097190856934, 0.782077134939092, -74.2622222900391, -1.29612028880911, 218, 40, 'PPL', 'P'),
(38844, 'Whippoorwill', 36.8166694641113, 0.642572101767199, -87.0097198486328, -1.5186060925965, 218, 21, 'PPL', 'P'),
(74804, 'Whippoorwill', 38.832218170166, 0.677750062922165, -83.503059387207, -1.45740332179512, 218, 41, 'PPL', 'P'),
(77667, 'Whippoorwill', 36.9122200012207, 0.644239773241807, -96.1297225952148, -1.67778016831529, 218, 42, 'PPL', 'P'),
(52710, 'Whippoorwill Estates', 39.0919418334961, 0.682283095992616, -76.523063659668, -1.33557941457443, 218, 25, 'PPL', 'P'),
(52708, 'Whippoorwill Trailer Park', 39.3824996948242, 0.687354287340345, -76.4430618286133, -1.3341831192149, 218, 25, 'PPL', 'P'),
(107521, 'Whipporwill Hollow', 38.0963897705078, 0.664907434618448, -78.5883331298828, -1.3716251667706, 218, 53, 'PPL', 'P'),
(25993, 'Whipporwill Ridge', 33.3972206115723, 0.58289146068685, -84.4711074829102, -1.4742989483828, 218, 13, 'PPL', 'P'),
(38845, 'Whipps Millgate', 38.2733306884766, 0.667995636218504, -85.5722198486328, -1.49351698459909, 218, 21, 'PPL', 'P'),
(195792, 'Whipsaw Saddle', 45.792781829834, 0.799234816578037, -116.348327636719, -2.03066139644986, 218, 17, 'PPL', 'P'),
(74805, 'Whipstown', 39.6444396972656, 0.691926002825629, -82.1647186279297, -1.43404486903209, 218, 41, 'PPL', 'P'),
(192860, 'Whipup', 38.6916694641113, 0.675297025242093, -111.393333435059, -1.94418043321366, 218, 52, 'PPL', 'P'),
(112018, 'Whirlwind', 37.9272193908691, 0.661954854496905, -82.1430587768555, -1.43366683331535, 218, 58, 'PPL', 'P'),
(12788, 'Whiskerville', 36.1197204589844, 0.630408046909235, -90.8130569458008, -1.58498684750533, 218, 4, 'PPL', 'P'),
(168892, 'Whiskerville', 41.0755615234375, 0.716903790689482, -79.852783203125, -1.39369398377576, 218, 45, 'PPL', 'P'),
(209164, 'Whiskey Bend', 47.9686088562012, 0.837210162142022, -123.581672668457, -2.15690708318646, 218, 56, 'PPL', 'P'),
(52709, 'Whiskey Bottom', 38.9719390869141, 0.680188652953323, -76.5697174072266, -1.33639367607772, 218, 25, 'PPL', 'P'),
(18587, 'Whiskey Creek', 26.5722198486328, 0.463772725922432, -81.8902816772461, -1.42925504065353, 218, 12, 'PPL', 'P'),
(99059, 'Whiskey Ford', 30.0713901519775, 0.524844768803806, -94.440559387207, -1.648298708732, 218, 51, 'PPL', 'P'),
(190918, 'Whiskey Spring (historical)', 38.3716697692871, 0.669711976962033, -118.540000915527, -2.06891331129304, 218, 39, 'PPL', 'P'),
(186120, 'Whiskey Springs', 39.3633308410645, 0.687019727728403, -123.665557861328, -2.15837115599573, 218, 6, 'PPL', 'P'),
(194054, 'Whiskeytown', 40.6388893127441, 0.709282422860921, -122.558609008789, -2.13905125386775, 218, 6, 'PPL', 'P'),
(186121, 'Whisky Falls', 37.2869415283203, 0.650779897667796, -119.438331604004, -2.08459213957867, 218, 6, 'PPL', 'P'),
(158355, 'Whiskyville', 41.3666687011719, 0.721984569417136, -82.210563659668, -1.43484501578161, 218, 41, 'PPL', 'P'),
(74806, 'Whisler', 39.4866714477539, 0.689172427416542, -82.8199996948242, -1.44548168117538, 218, 41, 'PPL', 'P'),
(12789, 'Whisp', 35.8777809143066, 0.626185405263832, -90.2750015258789, -1.57559600886949, 218, 4, 'PPL', 'P'),
(18588, 'Whisper Walk', 26.3958301544189, 0.460694144991814, -80.1883316040039, -1.39955040817089, 218, 12, 'PPL', 'P'),
(91806, 'Whispering Hills', 36.0566711425781, 0.629307628746814, -83.995002746582, -1.46598935314954, 218, 50, 'PPL', 'P'),
(18589, 'Whispering Hills Golf Estates', 28.5949993133545, 0.499076887623554, -80.8222198486328, -1.41061384512936, 218, 12, 'PPL', 'P'),
(52725, 'Whispering Meadows', 39.3833312988281, 0.687368801568286, -76.779167175293, -1.34004926414802, 218, 25, 'PPL', 'P'),
(6769, 'Whispering Oaks', 33.3175010681152, 0.581500092175338, -86.8963928222656, -1.5166281628549, 218, 2, 'PPL', 'P'),
(44114, 'Whispering Oaks', 30.5566692352295, 0.533314486597612, -91.1080627441406, -1.59013566999883, 218, 22, 'PPL', 'P'),
(99060, 'Whispering Oaks Estates Colonia', 27.9130001068115, 0.48717375597339, -97.177001953125, -1.69605864129899, 218, 51, 'PPL', 'P'),
(187538, 'Whispering Pine', 39.9697189331055, 0.697603196479406, -105.485282897949, -1.84106549896688, 218, 7, 'PPL', 'P'),
(25994, 'Whispering Pine Mobile Home Park', 33.5458297729492, 0.585485179851506, -82.1366729736328, -1.43355538002373, 218, 13, 'PPL', 'P'),
(6765, 'Whispering Pines', 31.2416706085205, 0.545270015942223, -85.4797210693359, -1.49190257634628, 218, 2, 'PPL', 'P'),
(18590, 'Whispering Pines', 27.2772197723389, 0.476077295817411, -80.8397216796875, -1.41091930970639, 218, 12, 'PPL', 'P'),
(25998, 'Whispering Pines', 33.3122215270996, 0.581407946801622, -85.103889465332, -1.48534307742336, 218, 13, 'PPL', 'P'),
(52713, 'Whispering Pines', 39.6341705322266, 0.691746772084267, -77.3974990844727, -1.35084119183334, 218, 25, 'PPL', 'P'),
(70090, 'Whispering Pines', 35.2555618286133, 0.615325633549735, -79.3724975585938, -1.38531141792862, 218, 33, 'PPL', 'P'),
(84337, 'Whispering Pines', 34.8066711425781, 0.607491013096885, -82.6466674804688, -1.44245646333511, 218, 48, 'PPL', 'P'),
(91809, 'Whispering Pines', 36.2480583190918, 0.632647965123073, -82.2877807617188, -1.43619270845124, 218, 50, 'PPL', 'P'),
(99061, 'Whispering Pines', 31.7766704559326, 0.554607524777232, -94.5197219848633, -1.64968035670553, 218, 51, 'PPL', 'P'),
(107522, 'Whispering Pines', 38.0633316040039, 0.664330460768283, -78.6247177124023, -1.37226019753253, 218, 53, 'PPL', 'P'),
(177011, 'Whispering Pines', 44.2802810668945, 0.772836698325817, -88.3841705322266, -1.5425947824315, 218, 57, 'PPL', 'P'),
(179512, 'Whispering Pines', 33.730281829834, 0.588704475556221, -109.055557250977, -1.90337854162672, 218, 5, 'PPL', 'P'),
(186123, 'Whispering Pines', 33.086109161377, 0.577461541540288, -116.584999084473, -2.03479209245862, 218, 6, 'PPL', 'P'),
(12790, 'Whispering Pines Addition', 34.9513893127441, 0.610016821653743, -91.9383316040039, -1.60462659528023, 218, 4, 'PPL', 'P'),
(126628, 'Whispering Pines Estates Mobile Home Park', 42.2125015258789, 0.736747137129717, -71.7949981689453, -1.2530591045114, 218, 23, 'PPL', 'P'),
(14844, 'Whispering Pines Mobile Home Park', 39.0941696166992, 0.682321978144531, -75.5175018310547, -1.31802904983275, 218, 10, 'PPL', 'P'),
(12791, 'Whispering Springs', 35.5541687011719, 0.620537306644965, -92.2313919067383, -1.60974146246983, 218, 4, 'PPL', 'P'),
(52716, 'Whispering Woods', 39.6541709899902, 0.692095845924149, -76.4055633544922, -1.33352864737701, 218, 25, 'PPL', 'P'),
(26000, 'Whispering Woods Estates', 33.7344398498535, 0.588777046695925, -84.6830596923828, -1.47799821229498, 218, 13, 'PPL', 'P'),
(52717, 'Whisperren Oaks', 39.4902801513672, 0.689235411176322, -77.2624969482422, -1.3484849600589, 218, 25, 'PPL', 'P'),
(12792, 'Whisperwood', 34.9383316040039, 0.60978892164346, -91.9730606079102, -1.60523273074433, 218, 4, 'PPL', 'P'),
(91810, 'Whisperwood', 35.2050018310547, 0.614443195122537, -84.8130569458008, -1.48026709238567, 218, 50, 'PPL', 'P'),
(26001, 'Whisperwoods', 33.7763900756836, 0.589509216258615, -84.5733337402344, -1.4760831331551, 218, 13, 'PPL', 'P'),
(6766, 'Whistler', 30.7563896179199, 0.536800264858903, -88.1030578613281, -1.53768844075525, 218, 2, 'PPL', 'P'),
(62292, 'Whistler', 31.6969394683838, 0.553215956528638, -88.804443359375, -1.54992992702191, 218, 30, 'PPL', 'P'),
(168893, 'Whistletown', 41.4497184753418, 0.723434061419438, -78.7205581665039, -1.3739329290132, 218, 45, 'PPL', 'P'),
(12793, 'Whistleville', 35.7713890075684, 0.624328516193775, -90.126106262207, -1.57299729627779, 218, 4, 'PPL', 'P'),
(26002, 'Whistleville', 33.9936103820801, 0.593300425807425, -83.7830581665039, -1.46229022239542, 218, 13, 'PPL', 'P'),
(52718, 'Whistling Ridge Estates', 39.6097183227539, 0.691320000519582, -77.0805587768555, -1.34530953993314, 218, 25, 'PPL', 'P'),
(107523, 'Whitacre', 39.332218170166, 0.686476709182136, -78.3274993896484, -1.36707275920321, 218, 53, 'PPL', 'P'),
(12794, 'Whitaker', 35.5699996948242, 0.620813609608061, -90.6430587768555, -1.58201981973487, 218, 4, 'PPL', 'P'),
(31512, 'Whitaker', 39.3797187805176, 0.687305751229478, -86.6074981689453, -1.51158599996306, 218, 19, 'PPL', 'P'),
(38847, 'Whitaker', 37.723331451416, 0.658396338648341, -82.8469390869141, -1.44595186226583, 218, 21, 'PPL', 'P'),
(62291, 'Whitaker', 31.0252799987793, 0.541493287331841, -91.1036071777344, -1.590057905695, 218, 30, 'PPL', 'P'),
(112574, 'Whitaker', 35.4519386291504, 0.618753055293639, -86.6263885498047, -1.51191569930601, 218, 50, 'PPL', 'P'),
(121964, 'Whitaker', 41.2513885498047, 0.719972551213581, -87.727783203125, -1.53113866237031, 218, 18, 'PPL', 'P'),
(168894, 'Whitaker', 40.3983306884766, 0.705083882823384, -79.8899993896484, -1.39434352876563, 218, 45, 'PPL', 'P'),
(201792, 'Whitaker', 44.5586090087891, 0.777694437312176, -122.871940612793, -2.14451992200818, 218, 43, 'PPL', 'P'),
(6767, 'Whitaker (historical)', 31.0033302307129, 0.541110191609033, -85.5755615234375, -1.49357530782696, 218, 2, 'PPL', 'P'),
(206462, 'Whitaker Estates', 40.6599998474121, 0.709650871197733, -111.949722290039, -1.95389125065447, 218, 52, 'PPL', 'P'),
(26003, 'Whitaker Hills', 33.788890838623, 0.58972739573092, -84.6658325195313, -1.47769754140791, 218, 13, 'PPL', 'P'),
(58254, 'Whitaker Place', 36.461669921875, 0.636376190912102, -90.1283264160156, -1.57303604527165, 218, 29, 'PPL', 'P'),
(70092, 'Whitakers', 36.105281829834, 0.630156045291086, -77.7130584716797, -1.35634874212568, 218, 33, 'PPL', 'P'),
(58255, 'Whitakerville', 38.2138900756836, 0.666958201815864, -93.3708267211914, -1.62962835159389, 218, 29, 'PPL', 'P'),
(12795, 'Whitburg (historical)', 35.8499984741211, 0.625700510208356, -90.5972213745117, -1.58121980614341, 218, 4, 'PPL', 'P'),
(112020, 'Whitby', 37.6661109924316, 0.657397653239561, -81.184440612793, -1.41693579008304, 218, 58, 'PPL', 'P'),
(107524, 'Whitby (historical)', 36.6166687011719, 0.639081429947405, -78.208610534668, -1.36499775723988, 218, 53, 'PPL', 'P'),
(38848, 'Whitco', 37.1194381713867, 0.647856412581161, -82.8513870239258, -1.44602949341161, 218, 21, 'PPL', 'P'),
(31514, 'Whitcomb', 39.4483299255371, 0.688503241613632, -84.9369430541992, -1.4824293128747, 218, 19, 'PPL', 'P'),
(177012, 'Whitcomb', 44.7833290100098, 0.781616541228563, -89.1186065673828, -1.55541310939027, 218, 57, 'PPL', 'P'),
(209165, 'Whitcomb', 45.8655586242676, 0.80050501125995, -119.78360748291, -2.0906183404933, 218, 56, 'PPL', 'P'),
(112021, 'Whitcomb (historical)', 37.7769393920898, 0.659331973718313, -80.4283294677734, -1.40373916109143, 218, 58, 'PPL', 'P'),
(197834, 'Whitcomb (historical)', 47.9313888549805, 0.836560550573124, -108.555000305176, -1.89464217482877, 218, 31, 'PPL', 'P'),
(31513, 'Whitcomb Heights', 39.4883308410645, 0.689201389293396, -87.454719543457, -1.52637280244156, 218, 19, 'PPL', 'P'),
(126629, 'Whitcomb Summit', 42.688060760498, 0.745047211562085, -73.0224990844727, -1.27448303705859, 218, 23, 'PPL', 'P'),
(129318, 'Whitcombs Corner', 44.4419403076172, 0.775658184342702, -69.1047210693359, -1.20610491133221, 218, 26, 'PPL', 'P'),
(6768, 'White', 33.7222213745117, 0.588563794071637, -85.6694412231445, -1.49521381768763, 218, 2, 'PPL', 'P'),
(12796, 'White', 33.0138893127441, 0.576201067396353, -91.9955596923828, -1.60562541384706, 218, 4, 'PPL', 'P'),
(26005, 'White', 34.3291702270508, 0.599157049939645, -83.8886108398438, -1.46413246407948, 218, 13, 'PPL', 'P'),
(133695, 'White', 46.7669410705566, 0.816237102767375, -88.8269424438477, -1.55032261012464, 218, 27, 'PPL', 'P'),
(168896, 'White', 40.4813919067383, 0.706533574562768, -79.4233322143555, -1.38619865004578, 218, 45, 'PPL', 'P'),
(171610, 'White', 44.4347190856934, 0.775532150244113, -96.6494369506836, -1.6868508949881, 218, 49, 'PPL', 'P'),
(197836, 'White', 45.8108291625977, 0.799549801955966, -111.322776794434, -1.94294898752561, 218, 31, 'PPL', 'P'),
(199090, 'White', 48.6961097717285, 0.849907448429247, -100.623611450195, -1.75621332505337, 218, 34, 'PPL', 'P'),
(209166, 'White', 47.7077789306641, 0.832657821153667, -122.087501525879, -2.13082887716019, 218, 56, 'PPL', 'P'),
(58258, 'White (historical)', 37.9797210693359, 0.662871181648974, -90.704719543457, -1.58309600313137, 218, 29, 'PPL', 'P'),
(112022, 'White (historical)', 38.7652816772461, 0.676581800730974, -79.5794372558594, -1.38892319699899, 218, 58, 'PPL', 'P'),
(190920, 'White (historical)', 39.9263916015625, 0.696846991887878, -116.165000915527, -2.02746174155818, 218, 39, 'PPL', 'P'),
(197835, 'White (historical)', 47.2916717529297, 0.825395380861021, -106.033332824707, -1.85063077465412, 218, 31, 'PPL', 'P'),
(91812, 'White Acres', 35.4524993896484, 0.618762842410645, -86.8186111450195, -1.51527061648924, 218, 50, 'PPL', 'P'),
(62294, 'White Apple', 31.4569396972656, 0.549027170318593, -91.0741729736328, -1.58954418192073, 218, 30, 'PPL', 'P'),
(28964, 'White Ash', 37.7894401550293, 0.659550153190618, -88.9247207641602, -1.55202916375116, 218, 18, 'PPL', 'P'),
(38849, 'White Ash', 37.5563888549805, 0.655482640678712, -83.7366714477539, -1.46148062142403, 218, 21, 'PPL', 'P'),
(52719, 'White Banks', 39.0074996948242, 0.680809302645366, -76.158332824707, -1.32921366062081, 218, 25, 'PPL', 'P'),
(206465, 'White Barn Country Club', 41.3125, 0.721039147230157, -111.985282897949, -1.95451190034651, 218, 52, 'PPL', 'P'),
(18591, 'White Beach', 27.2399997711182, 0.475427684248514, -82.5263900756836, -1.44035722660585, 218, 12, 'PPL', 'P'),
(77668, 'White Bead', 34.7633285522461, 0.606734542189248, -97.3016662597656, -1.69823444390959, 218, 42, 'PPL', 'P'),
(58256, 'White Bear', 39.6983299255371, 0.692866564743618, -91.460563659668, -1.59628797159108, 218, 29, 'PPL', 'P'),
(138806, 'White Bear Beach', 45.0997200012207, 0.787138605748842, -92.9888916015625, -1.62296232622737, 218, 28, 'PPL', 'P'),
(138807, 'White Bear Lake', 45.0847206115723, 0.786876817013688, -93.0097198486328, -1.62332584771616, 218, 28, 'PPL', 'P'),
(153775, 'White Birches', 40.9677810668945, 0.715022666853505, -73.7830581665039, -1.28775729719598, 218, 40, 'PPL', 'P'),
(195793, 'White Bird', 45.7616691589355, 0.79869179803177, -116.29972076416, -2.02981304648461, 218, 17, 'PPL', 'P'),
(12797, 'White Bluff', 35.2666702270508, 0.615519511677092, -94.3783264160156, -1.64721253848141, 218, 4, 'PPL', 'P'),
(26006, 'White Bluff', 31.9874992370605, 0.558287181165881, -81.1288909912109, -1.4159662662882, 218, 13, 'PPL', 'P'),
(62293, 'White Bluff', 31.3647193908691, 0.547417622334777, -89.9658279418945, -1.57019991186877, 218, 30, 'PPL', 'P'),
(91811, 'White Bluff', 36.1074981689453, 0.630194727705919, -87.220832824707, -1.52229070912268, 218, 50, 'PPL', 'P'),
(84336, 'White Bluff Corssroads', 34.6599998474121, 0.604931116078073, -80.5599975585938, -1.40603720279605, 218, 48, 'PPL', 'P'),
(209167, 'White Bluffs', 46.6666717529297, 0.814487073036057, -119.483612060547, -2.08538243263215, 218, 56, 'PPL', 'P'),
(58257, 'White Branch', 38.2344398498535, 0.66731686303567, -93.3544387817383, -1.62934232809282, 218, 29, 'PPL', 'P'),
(14845, 'White Briar', 39.788330078125, 0.694437363733574, -75.6861114501953, -1.32097184283729, 218, 10, 'PPL', 'P'),
(202780, 'White Butte', 45.940559387207, 0.801814021514751, -102.361938476563, -1.78655285513988, 218, 49, 'PPL', 'P'),
(192861, 'White Canyon', 37.810001373291, 0.659909014147506, -110.43138885498, -1.92739133306958, 218, 52, 'PPL', 'P'),
(62295, 'White Cap', 31.2152805328369, 0.544809422231694, -90.9744415283203, -1.58780353983225, 218, 30, 'PPL', 'P'),
(190921, 'White Caps (historical)', 38.5311088562012, 0.672494713985057, -117.049171447754, -2.04289342849464, 218, 39, 'PPL', 'P'),
(44117, 'White Castle', 30.1697196960449, 0.526560943099767, -91.1469421386719, -1.59081424344459, 218, 22, 'PPL', 'P'),
(209168, 'White Center', 47.5175018310547, 0.829336859274339, -122.353607177734, -2.13547329694323, 218, 56, 'PPL', 'P'),
(91813, 'White Chapel', 35.0494384765625, 0.611728102391201, -90.1172180175781, -1.5728421671443, 218, 50, 'PPL', 'P'),
(112023, 'White Chapel', 38.5033302307129, 0.672009885508608, -81.646110534668, -1.42499345027718, 218, 58, 'PPL', 'P'),
(58259, 'White Church', 36.8502807617188, 0.643158729576316, -91.7861099243164, -1.60196982577676, 218, 29, 'PPL', 'P'),
(153776, 'White Church', 42.3438911437988, 0.739040318565357, -76.3858337402344, -1.33318430064806, 218, 40, 'PPL', 'P'),
(84338, 'White Church Place', 32.9633293151855, 0.575318628969155, -80.1958312988281, -1.39968130253847, 218, 48, 'PPL', 'P'),
(206472, 'White Circle', 40.707218170166, 0.710474986397058, -111.831108093262, -1.95182104238109, 218, 52, 'PPL', 'P'),
(6771, 'White City', 34.0927810668945, 0.595031280778895, -86.7744369506836, -1.51449963135366, 218, 2, 'PPL', 'P'),
(18593, 'White City', 27.3736095428467, 0.477759614678014, -80.3341674804688, -1.40209572438274, 218, 12, 'PPL', 'P'),
(26008, 'White City', 33.7311096191406, 0.588718923205134, -84.804443359375, -1.48011675694213, 218, 13, 'PPL', 'P'),
(34406, 'White City', 38.7955589294434, 0.677110238470273, -96.7355575561523, -1.68835398310734, 218, 20, 'PPL', 'P'),
(38850, 'White City', 37.9527816772461, 0.66240100055852, -87.584716796875, -1.52864168253225, 218, 21, 'PPL', 'P'),
(58261, 'White City', 36.8802795410156, 0.643682307046626, -93.3977813720703, -1.63009879900045, 218, 29, 'PPL', 'P'),
(62296, 'White City', 33.7038917541504, 0.588243881845692, -90.6333312988281, -1.58185004321538, 218, 30, 'PPL', 'P'),
(91814, 'White City', 35.2472190856934, 0.615180025217134, -85.7027816772461, -1.49579571838581, 218, 50, 'PPL', 'P'),
(121966, 'White City', 40.1049995422363, 0.699964288522843, -90.1074981689453, -1.57267252378286, 218, 18, 'PPL', 'P'),
(126630, 'White City', 42.1202812194824, 0.735137589145901, -71.5416717529297, -1.24863772446965, 218, 23, 'PPL', 'P'),
(133697, 'White City', 46.9822196960449, 0.819994423591313, -88.4250030517578, -1.54330744433921, 218, 27, 'PPL', 'P'),
(153777, 'White City', 43.2513885498047, 0.754879136253467, -77.5919418334961, -1.35423485801043, 218, 40, 'PPL', 'P'),
(177014, 'White City', 43.6186103820801, 0.761288366311879, -90.4530563354492, -1.57870365154551, 218, 57, 'PPL', 'P'),
(192425, 'White City', 32.8472213745117, 0.573292163116687, -102.255729675293, -1.78469916186313, 218, 51, 'PPL', 'P'),
(197837, 'White City', 45.3038902282715, 0.790702048445423, -110.685562133789, -1.93182749365538, 218, 31, 'PPL', 'P'),
(201793, 'White City', 42.4375, 0.740674101315094, -122.857780456543, -2.14427278065902, 218, 43, 'PPL', 'P'),
(206467, 'White City', 40.5658302307129, 0.708007301330991, -111.863609313965, -1.95238829569328, 218, 52, 'PPL', 'P'),
(38851, 'White City (historical)', 37.5894393920898, 0.656059481370823, -85.664436340332, -1.49512646600388, 218, 21, 'PPL', 'P'),
(206468, 'White City Subdivision Number 1', 40.5730590820313, 0.708133468587633, -111.865280151367, -1.95241745730722, 218, 52, 'PPL', 'P'),
(206469, 'White City Subdivision Number 2', 40.5625, 0.7079491778402, -111.864440917969, -1.95240280992122, 218, 52, 'PPL', 'P'),
(179513, 'White Clay', 36.064998626709, 0.629452970763305, -109.218063354492, -1.90621480818765, 218, 5, 'PPL', 'P'),
(12798, 'White Cliffs', 33.7969398498535, 0.589867877478422, -94.0599975585938, -1.64165665181529, 218, 4, 'PPL', 'P'),
(31515, 'White Cloud', 38.2280616760254, 0.667205542902105, -86.2244415283203, -1.50490040036252, 218, 19, 'PPL', 'P'),
(34407, 'White Cloud', 39.976390838623, 0.697719643198069, -95.2966690063477, -1.663240640344, 218, 20, 'PPL', 'P'),
(58262, 'White Cloud', 38.021110534668, 0.663593564094658, -93.3730621337891, -1.62966736690386, 218, 29, 'PPL', 'P'),
(118446, 'White Cloud', 40.9841690063477, 0.715308690354579, -95.5227813720703, -1.66718704560533, 218, 16, 'PPL', 'P'),
(133698, 'White Cloud', 43.5502815246582, 0.760095802775742, -85.7719421386719, -1.49700279614989, 218, 27, 'PPL', 'P'),
(179514, 'White Cone', 35.605281829834, 0.621429399031114, -110.067497253418, -1.92104022650196, 218, 5, 'PPL', 'P'),
(153778, 'White Corners', 42.9080581665039, 0.748886890642735, -75.603889465332, -1.3195367984839, 218, 40, 'PPL', 'P'),
(177015, 'White Corners', 43.0675010681152, 0.751669694244785, -91.0777816772461, -1.58960716568051, 218, 57, 'PPL', 'P'),
(74807, 'White Cottage', 39.8716697692871, 0.695891915741948, -82.0977783203125, -1.43287654026187, 218, 41, 'PPL', 'P'),
(153779, 'White Creek', 42.9700012207031, 0.749968000887252, -73.2916717529297, -1.27918098637955, 218, 40, 'PPL', 'P'),
(177016, 'White Creek', 43.8258285522461, 0.764905005651234, -89.8547210693359, -1.56826073112103, 218, 57, 'PPL', 'P'),
(14851, 'White Creek Manor', 38.5536117553711, 0.672887463666816, -75.103889465332, -1.31081015222393, 218, 10, 'PPL', 'P'),
(70093, 'White Cross', 35.9216690063477, 0.626951396972366, -79.1877822875977, -1.38208752827103, 218, 33, 'PPL', 'P'),
(6773, 'White Crossroads', 33.1955604553223, 0.579371826990202, -85.3433303833008, -1.48952210980591, 218, 2, 'PPL', 'P'),
(52721, 'White Crystal Beach', 39.4416694641113, 0.68838699463205, -75.9749984741211, -1.32601387257108, 218, 25, 'PPL', 'P'),
(168898, 'White Deer', 41.0758285522461, 0.71690845122139, -76.875, -1.34172186247064, 218, 45, 'PPL', 'P'),
(192426, 'White Deer', 35.4352798461914, 0.61846230468163, -101.172500610352, -1.76579324812661, 218, 51, 'PPL', 'P'),
(77670, 'White Eagle', 36.6083297729492, 0.638935888193832, -97.0758285522461, -1.69429283233821, 218, 42, 'PPL', 'P'),
(138811, 'White Earth', 47.0966682434082, 0.821991927566927, -95.8430633544922, -1.67277702073341, 218, 28, 'PPL', 'P'),
(199092, 'White Earth', 48.3805618286133, 0.84440009787399, -102.77278137207, -1.79372341637492, 218, 34, 'PPL', 'P'),
(118448, 'White Elm', 40.851390838623, 0.71299127415302, -92.2063903808594, -1.60930510352522, 218, 16, 'PPL', 'P'),
(74808, 'White Eyes Town (historical)', 39.8722190856934, 0.695901503121872, -81.9055633544922, -1.4295217562367, 218, 41, 'PPL', 'P'),
(91816, 'White Fern', 35.639720916748, 0.622030474489145, -88.5952835083008, -1.54627939895768, 218, 50, 'PPL', 'P'),
(52722, 'White Flint Springs', 39.4713897705078, 0.68890571183337, -77.4563903808594, -1.35186903885606, 218, 25, 'PPL', 'P'),
(26010, 'White Forest', 33.9458312988281, 0.592466523491094, -84.7911071777344, -1.47988399666286, 218, 13, 'PPL', 'P'),
(158357, 'White Fox', 41.1841697692871, 0.718799362174373, -82.3536071777344, -1.4373415961455, 218, 41, 'PPL', 'P'),
(367, 'White Hall', 39.040828704834, 0.681391003606466, -75.595832824707, -1.31939618357834, 218, 10, 'PPL', 'P'),
(6772, 'White Hall', 32.3269386291504, 0.564211516168816, -86.7119369506836, -1.51340880057116, 218, 2, 'PPL', 'P'),
(12801, 'White Hall', 34.2738914489746, 0.598192253255737, -92.0908279418945, -1.60728815847365, 218, 4, 'PPL', 'P'),
(28970, 'White Hall', 39.436939239502, 0.688304436638258, -90.4030609130859, -1.57783106681434, 218, 18, 'PPL', 'P'),
(44118, 'White Hall', 30.0791702270508, 0.524980556729887, -90.9013900756836, -1.58652855146038, 218, 22, 'PPL', 'P'),
(52724, 'White Hall', 38.6861114501953, 0.675200019599386, -76.9891662597656, -1.34371443959824, 218, 25, 'PPL', 'P'),
(84339, 'White Hall', 32.7216682434082, 0.571100847592742, -80.690559387207, -1.40831593658278, 218, 48, 'PPL', 'P'),
(99065, 'White Hall', 29.0097198486328, 0.506315126439794, -96.413330078125, -1.68273005267536, 218, 51, 'PPL', 'P'),
(107528, 'White Hall', 39.2911109924316, 0.685759253584469, -78.1483306884766, -1.36394567545124, 218, 53, 'PPL', 'P'),
(126631, 'White Hall', 42.3738899230957, 0.739563896035667, -71.9986114501953, -1.25661282667, 218, 23, 'PPL', 'P'),
(168900, 'White Hall', 41.1163902282715, 0.71761638601816, -76.6319427490234, -1.33747971317025, 218, 45, 'PPL', 'P'),
(186124, 'White Hall', 38.7752799987793, 0.676756304361402, -120.404167175293, -2.10144915033054, 218, 6, 'PPL', 'P'),
(44119, 'White Hall (historical)', 31.5458297729492, 0.550578594811619, -91.4716720581055, -1.59648184971844, 218, 22, 'PPL', 'P'),
(70095, 'White Hall (historical)', 35.1647186279297, 0.613740120594756, -80.9694366455078, -1.41318326294906, 218, 33, 'PPL', 'P'),
(84340, 'White Hall Estates', 33.3055610656738, 0.58129169982004, -79.3005599975586, -1.3840558706327, 218, 48, 'PPL', 'P'),
(52732, 'White Hall Forest', 38.6791687011719, 0.675078845769788, -76.9938888549805, -1.34379686443398, 218, 25, 'PPL', 'P'),
(52726, 'White Hall Terrace', 38.6847190856934, 0.67517571825444, -76.9447174072266, -1.3429386607727, 218, 25, 'PPL', 'P'),
(62297, 'White Harbor', 30.3305606842041, 0.529368147915306, -89.2055587768555, -1.55693071173745, 218, 30, 'PPL', 'P'),
(84341, 'White Harbor', 34.7572212219238, 0.606627949166618, -82.9513931274414, -1.44777492919005, 218, 48, 'PPL', 'P'),
(70096, 'White Hat Landing', 36.1513900756836, 0.630960785993481, -76.3833312988281, -1.33314062480619, 218, 33, 'PPL', 'P'),
(91817, 'White Haven', 35.8891716003418, 0.626384210239207, -86.4458312988281, -1.50876438078812, 218, 50, 'PPL', 'P'),
(168901, 'White Haven', 41.0605583190918, 0.7166419353753, -75.7744369506836, -1.32251341363428, 218, 45, 'PPL', 'P'),
(197838, 'White Haven', 48.3450012207031, 0.843779448181947, -115.516387939453, -2.01614130955453, 218, 31, 'PPL', 'P'),
(168902, 'White Haven Center', 41.0625, 0.716675824100172, -75.7958297729492, -1.32288678881911, 218, 45, 'PPL', 'P'),
(138813, 'White Hawk', 46.3980598449707, 0.809798910832109, -93.8252792358398, -1.63756004426847, 218, 28, 'PPL', 'P'),
(121967, 'White Heath', 40.086109161377, 0.699634589179891, -88.5127792358398, -1.54483942775628, 218, 18, 'PPL', 'P'),
(186125, 'White Heather', 34.5202789306641, 0.602492526046915, -118.30583190918, -2.06482629112615, 218, 6, 'PPL', 'P'),
(26011, 'White Hill', 32.6797218322754, 0.57036874460908, -81.5733337402344, -1.42372325559527, 218, 13, 'PPL', 'P'),
(28968, 'White Hill', 37.3191719055176, 0.651342423869048, -89.0213928222656, -1.55371640945978, 218, 18, 'PPL', 'P'),
(70097, 'White Hill', 35.3816719055176, 0.617526669611658, -79.2808303833008, -1.38371152390376, 218, 33, 'PPL', 'P'),
(91819, 'White Hill', 35.6549987792969, 0.622297123493289, -85.5719375610352, -1.49351205775107, 218, 50, 'PPL', 'P'),
(107529, 'White Hill', 38.0433311462402, 0.6639813869284, -79.0630569458008, -1.379910660396, 218, 53, 'PPL', 'P'),
(168904, 'White Hill', 40.230281829834, 0.702150876935852, -76.9208297729492, -1.34252174290405, 218, 45, 'PPL', 'P'),
(44120, 'White Hills', 30.5977802276611, 0.534032008774307, -91.1388931274414, -1.59067376169708, 218, 22, 'PPL', 'P'),
(114287, 'White Hills', 41.334171295166, 0.721417382683976, -73.1513900756836, -1.27673260923138, 218, 8, 'PPL', 'P'),
(179515, 'White Hills', 35.7380599975586, 0.623746815232674, -114.396667480469, -1.99659850084331, 218, 5, 'PPL', 'P'),
(996, 'White Hollow', 36.3466682434082, 0.634369032977537, -83.8952789306641, -1.46424884421912, 218, 50, 'PPL', 'P'),
(91820, 'White Horn', 36.2844390869141, 0.633282929305975, -83.0561065673828, -1.44960252348812, 218, 50, 'PPL', 'P'),
(84343, 'White Horse', 34.8147201538086, 0.607631494844387, -82.4400024414063, -1.4388494779547, 218, 48, 'PPL', 'P'),
(146636, 'White Horse', 40.190559387207, 0.701457589525077, -74.7027816772461, -1.30380950066644, 218, 37, 'PPL', 'P'),
(168906, 'White Horse', 40.0347213745117, 0.698737703103779, -75.9941711425781, -1.32634849876205, 218, 45, 'PPL', 'P'),
(194055, 'White Horse', 41.3111114501953, 0.721014912464238, -121.397216796875, -2.11878113586283, 218, 6, 'PPL', 'P'),
(202783, 'White Horse', 43.3083305358887, 0.755872961393258, -100.59610748291, -1.75573329026689, 218, 49, 'PPL', 'P'),
(209169, 'White Horse', 48.2688903808594, 0.842451063430216, -121.705001831055, -2.12415299809763, 218, 56, 'PPL', 'P'),
(126632, 'White Horse Beach', 41.9308280944824, 0.731831008336458, -70.5583267211914, -1.23147511598269, 218, 23, 'PPL', 'P'),
(14848, 'White Horse Farm', 38.6916694641113, 0.675297025242093, -75.2533264160156, -1.3134183190375, 218, 10, 'PPL', 'P'),
(84344, 'White Horse Heights', 34.8608283996582, 0.608436235546781, -82.4591674804688, -1.43918397098762, 218, 48, 'PPL', 'P'),
(206471, 'White Horse Village', 41.8636093139648, 0.730657819297251, -111.773063659668, -1.95080797590243, 218, 52, 'PPL', 'P'),
(58264, 'White House', 38.4180603027344, 0.670521644512444, -90.3255615234375, -1.57647844729669, 218, 29, 'PPL', 'P'),
(79403, 'White House', 39.7527809143066, 0.693816913778613, -79.7947235107422, -1.39268065098098, 218, 45, 'PPL', 'P'),
(91821, 'White House', 36.4702796936035, 0.63652645977661, -86.6513900756836, -1.51235205825062, 218, 50, 'PPL', 'P'),
(107530, 'White House', 38.646671295166, 0.674511659036628, -78.5330581665039, -1.37066043666571, 218, 53, 'PPL', 'P'),
(62298, 'White House (historical)', 32.1875, 0.561777852985675, -88.8194427490234, -1.55019171575706, 218, 30, 'PPL', 'P'),
(52727, 'White House Acres', 38.9577789306641, 0.679941511604164, -76.1944427490234, -1.32984389769278, 218, 25, 'PPL', 'P'),
(14849, 'White House Beach Mobile Home Park', 38.6161117553711, 0.673978294449313, -75.133056640625, -1.3113192154663, 218, 10, 'PPL', 'P'),
(52728, 'White House Heights', 38.913330078125, 0.679165732778623, -76.8905563354492, -1.34199337174377, 218, 25, 'PPL', 'P'),
(14850, 'White House Landing', 39.0875015258789, 0.682205598004894, -75.466667175293, -1.31714181771559, 218, 10, 'PPL', 'P'),
(62299, 'White House Landing', 32.9336090087891, 0.574799911767835, -90.7602767944336, -1.58406566008427, 218, 30, 'PPL', 'P'),
(52729, 'White House Park', 39.523609161377, 0.689817112137423, -76.4172210693359, -1.33373211288429, 218, 25, 'PPL', 'P'),
(6774, 'White House Springs', 34.6483306884766, 0.60472745083371, -87.6938934326172, -1.5305471742922, 218, 2, 'PPL', 'P'),
(138814, 'White Iron', 47.9033317565918, 0.836070861827686, -91.7766723632813, -1.60180510926334, 218, 28, 'PPL', 'P'),
(126633, 'White Island Shores', 41.7999992370605, 0.729547614017824, -70.6352767944336, -1.23281814812041, 218, 23, 'PPL', 'P'),
(44121, 'White Kitchen', 30.2277793884277, 0.527574275894542, -89.6772232055664, -1.565162808983, 218, 22, 'PPL', 'P'),
(195794, 'White Knob (historical)', 43.8925018310547, 0.766068673889544, -113.669441223145, -1.98390600824604, 218, 17, 'PPL', 'P'),
(70098, 'White Lake', 34.6402816772461, 0.604586969086208, -78.4841690063477, -1.36980715985245, 218, 33, 'PPL', 'P'),
(133700, 'White Lake', 42.6916694641113, 0.745110195321866, -83.5541687011719, -1.45829534760224, 218, 27, 'PPL', 'P'),
(153781, 'White Lake', 41.6769409179688, 0.727399841177703, -74.8283309936523, -1.30600074961135, 218, 40, 'PPL', 'P'),
(171612, 'White Lake', 43.730281829834, 0.763237400755654, -98.7133331298828, -1.72287267873445, 218, 49, 'PPL', 'P'),
(177017, 'White Lake', 45.1572189331055, 0.788142151426611, -88.7644424438477, -1.54923177934214, 218, 57, 'PPL', 'P'),
(201794, 'White Lake City (historical)', 42.0041694641113, 0.733111056714405, -121.644439697266, -2.12309598946098, 218, 43, 'PPL', 'P'),
(189808, 'White Lakes (historical)', 35.2016716003418, 0.614385071631746, -105.786392211914, -1.84632084790399, 218, 38, 'PPL', 'P'),
(52730, 'White Landing', 38.6699981689453, 0.674918789788274, -76.7024993896484, -1.33871115885831, 218, 25, 'PPL', 'P'),
(70099, 'White Level', 36.1330604553223, 0.630640873767535, -78.1433334350586, -1.36385845692554, 218, 33, 'PPL', 'P'),
(52731, 'White Marsh', 39.3836097717285, 0.687373661837275, -76.432502746582, -1.33399882846747, 218, 25, 'PPL', 'P'),
(107532, 'White Marsh', 37.3422203063965, 0.651744694351704, -76.5216674804688, -1.33555504665045, 218, 53, 'PPL', 'P'),
(52734, 'White Marsh Estates', 38.6183280944824, 0.674016976864146, -76.6236114501953, -1.33733430457474, 218, 25, 'PPL', 'P'),
(52733, 'White Marsh Station', 39.3800010681152, 0.687310678077495, -76.4277801513672, -1.33391640363173, 218, 25, 'PPL', 'P'),
(146637, 'White Meadow Lake', 40.9236106872559, 0.714251748296954, -74.5111083984375, -1.30046417086313, 218, 37, 'PPL', 'P'),
(192862, 'White Mesa', 37.4658317565918, 0.653902121150778, -109.466941833496, -1.91055855708363, 218, 52, 'PPL', 'P'),
(192863, 'White Mesa Village', 37.1336097717285, 0.648103753667403, -109.281387329102, -1.90732002004003, 218, 52, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(107533, 'White Mill', 36.7683296203613, 0.641728412333862, -81.9877777099609, -1.43095666743203, 218, 53, 'PPL', 'P'),
(168907, 'White Mill Crossing', 40.5275001525879, 0.707338315265163, -78.8897171020508, -1.37688530939767, 218, 45, 'PPL', 'P'),
(38852, 'White Mills', 37.5552787780762, 0.655463266181782, -86.0322189331055, -1.50154548317929, 218, 21, 'PPL', 'P'),
(168908, 'White Mills', 41.5261116027832, 0.724767373019187, -75.2038879394531, -1.31255545484431, 218, 45, 'PPL', 'P'),
(38853, 'White Mills Junction', 37.5774993896484, 0.655851089015525, -86.0355606079102, -1.50160380640717, 218, 21, 'PPL', 'P'),
(99066, 'White Mound', 33.5166702270508, 0.584976249767192, -96.5100021362305, -1.68441729838398, 218, 51, 'PPL', 'P'),
(212228, 'White Mountain', 64.6813888549805, 1.12890320028217, -163.405563354492, -2.85196509661208, 218, 1, 'PPL', 'P'),
(179516, 'White Mountain Lakes Estates', 34.355281829834, 0.599612783381185, -109.995277404785, -1.91977975235802, 218, 5, 'PPL', 'P'),
(6778, 'White Oak', 34.2402801513672, 0.59760562544662, -86.2444381713867, -1.50524940762338, 218, 2, 'PPL', 'P'),
(12804, 'White Oak', 35.5761108398438, 0.620920269209719, -93.6761093139648, -1.63495653798681, 218, 4, 'PPL', 'P'),
(26014, 'White Oak', 34.9736099243164, 0.610404644487486, -85.272216796875, -1.48828094357988, 218, 13, 'PPL', 'P'),
(28969, 'White Oak', 39.5097198486328, 0.689574697899198, -89.5711135864258, -1.56331084676096, 218, 18, 'PPL', 'P'),
(38855, 'White Oak', 37.8583297729492, 0.660752503843761, -83.2022171020508, -1.45215263338992, 218, 21, 'PPL', 'P'),
(52738, 'White Oak', 39.0397186279297, 0.681371629109536, -76.9933319091797, -1.343787143896, 218, 25, 'PPL', 'P'),
(58265, 'White Oak', 36.3302803039551, 0.634083009476462, -90.0277786254883, -1.57128115527135, 218, 29, 'PPL', 'P'),
(62302, 'White Oak', 34.6458282470703, 0.604683774991832, -90.3541717529297, -1.57697779000108, 218, 30, 'PPL', 'P'),
(70106, 'White Oak', 34.749439239502, 0.606492127951023, -78.7083282470703, -1.37371947665183, 218, 33, 'PPL', 'P'),
(74811, 'White Oak', 39.0158309936523, 0.680954711240884, -83.8769378662109, -1.46392873225609, 218, 41, 'PPL', 'P'),
(77672, 'White Oak', 36.6202812194824, 0.639144480286213, -95.2638931274414, -1.66266859334185, 218, 42, 'PPL', 'P'),
(84346, 'White Oak', 34.4741706848145, 0.601687785344521, -81.1166687011719, -1.41575294708488, 218, 48, 'PPL', 'P'),
(91825, 'White Oak', 36.0116691589355, 0.628522195962322, -84.6100006103516, -1.47672309076505, 218, 50, 'PPL', 'P'),
(99069, 'White Oak', 33.2890701293945, 0.581003878685229, -95.0099411010742, -1.65823629433963, 218, 51, 'PPL', 'P'),
(107535, 'White Oak', 36.8061103820801, 0.642387811019766, -79.0227813720703, -1.37920771902627, 218, 53, 'PPL', 'P'),
(112026, 'White Oak', 39.1855583190918, 0.683917011900407, -80.9069366455078, -1.41209243216657, 218, 58, 'PPL', 'P'),
(118449, 'White Oak', 41.6749992370605, 0.727365952452831, -93.5341720581055, -1.63247926554082, 218, 16, 'PPL', 'P'),
(133702, 'White Oak', 42.524169921875, 0.742186776814259, -84.1908264160156, -1.46940712093449, 218, 27, 'PPL', 'P'),
(168910, 'White Oak', 40.2050018310547, 0.701709657722253, -76.3925018310547, -1.3333006807877, 218, 45, 'PPL', 'P'),
(177019, 'White Oak', 42.5183296203613, 0.742084844323536, -90.2769393920898, -1.57562983101534, 218, 57, 'PPL', 'P'),
(12806, 'White Oak Bluff', 34.0313911437988, 0.593959824493329, -92.3058319091797, -1.61104068560763, 218, 4, 'PPL', 'P'),
(146638, 'White Oak Bottom', 40.0205612182617, 0.69849056175462, -74.1994400024414, -1.29502453117859, 218, 37, 'PPL', 'P'),
(129321, 'White Oak Corner', 44.1552810668945, 0.770655036760824, -69.290283203125, -1.20934358153385, 218, 26, 'PPL', 'P'),
(52736, 'White Oak Crest', 39.4722213745117, 0.688920226061311, -76.2983322143555, -1.33165711092096, 218, 25, 'PPL', 'P'),
(26015, 'White Oak Estates', 33.6916694641113, 0.588030562642376, -84.8122177124023, -1.48025244499967, 218, 13, 'PPL', 'P'),
(52737, 'White Oak Estates', 39.1847190856934, 0.683902364514411, -76.9688873291016, -1.34336050548937, 218, 25, 'PPL', 'P'),
(70107, 'White Oak Estates', 34.7555618286133, 0.606598987289763, -77.3472213745117, -1.34996368025416, 218, 33, 'PPL', 'P'),
(186127, 'White Oak Estates', 38.0097198486328, 0.663394759119283, -120.27278137207, -2.09915603547393, 218, 6, 'PPL', 'P'),
(14852, 'White Oak Farms', 39.1749992370605, 0.683732721152973, -75.5097198486328, -1.31789322861716, 218, 10, 'PPL', 'P'),
(91826, 'White Oak Flat', 36.211669921875, 0.632012867782117, -87.2611083984375, -1.52299365049241, 218, 50, 'PPL', 'P'),
(91827, 'White Oak Forest', 35.9541702270508, 0.627518650284553, -85.2291717529297, -1.48752966583637, 218, 50, 'PPL', 'P'),
(70108, 'White Oak Heights', 36.1288909912109, 0.630568102890749, -79.7752838134766, -1.3923413642581, 218, 33, 'PPL', 'P'),
(84350, 'White Oak Hills', 34.8708305358887, 0.608610805756236, -82.4716720581055, -1.43940221703895, 218, 48, 'PPL', 'P'),
(38856, 'White Oak Junction', 36.7027816772461, 0.640584384908591, -84.5930633544922, -1.47642747988405, 218, 21, 'PPL', 'P'),
(99070, 'White Oak Junction', 33.146671295166, 0.57851855017694, -95.4569396972656, -1.66603789159496, 218, 51, 'PPL', 'P'),
(112027, 'White Oak Junction', 37.920280456543, 0.661833747246333, -81.1586074829102, -1.41648491691049, 218, 58, 'PPL', 'P'),
(18594, 'White Oak Landing', 30.0980606079102, 0.525310256072838, -85.1130599975586, -1.48550313340487, 218, 12, 'PPL', 'P'),
(107537, 'White Oak Landing', 37.5472183227539, 0.655322584697199, -76.9066696166992, -1.34227460155489, 218, 53, 'PPL', 'P'),
(52740, 'White Oak Manor', 39.0163917541504, 0.68096449835789, -76.9627838134766, -1.34325397904576, 218, 25, 'PPL', 'P'),
(74812, 'White Oak Meadows', 39.2272186279297, 0.684644121457025, -84.5997161865234, -1.47654359370758, 218, 41, 'PPL', 'P'),
(14853, 'White Oak Mobile Home Park', 38.8847198486328, 0.678666390074234, -75.3986129760742, -1.31595404786942, 218, 10, 'PPL', 'P'),
(52741, 'White Oak Ridge', 39.6236114501953, 0.691562481336833, -76.892219543457, -1.34202240019966, 218, 25, 'PPL', 'P'),
(146639, 'White Oak Ridge', 40.7458305358887, 0.711148899310903, -74.334716796875, -1.297385556643, 218, 37, 'PPL', 'P'),
(44122, 'White Oak Run', 30.5930595397949, 0.533949617228083, -91.0152816772461, -1.58851633489801, 218, 22, 'PPL', 'P'),
(99071, 'White Oak Springs', 33.1508293151855, 0.578591121316645, -95.0716705322266, -1.65931367615862, 218, 51, 'PPL', 'P'),
(112028, 'White Oak Springs', 39.4869384765625, 0.689177087948449, -79.5008316040039, -1.38755126956343, 218, 58, 'PPL', 'P'),
(28971, 'White Oak Springs (historical)', 39.8833312988281, 0.696095447828257, -90.8172225952148, -1.58505955180309, 218, 18, 'PPL', 'P'),
(107538, 'White Oak Swamp', 37.5061111450195, 0.654605129099531, -77.2888870239258, -1.34894555376943, 218, 53, 'PPL', 'P'),
(74813, 'White Oak Valley', 38.9199981689453, 0.67928211291826, -83.9269409179688, -1.46480145014531, 218, 41, 'PPL', 'P'),
(52743, 'White Oak Village', 38.6450004577637, 0.674482497422692, -76.8811111450195, -1.3418285220723, 218, 25, 'PPL', 'P'),
(6779, 'White Oaks', 33.7333297729492, 0.588757672198995, -86.6900024414063, -1.51302597116446, 218, 2, 'PPL', 'P'),
(70115, 'White Oaks', 35.2513885498047, 0.615252796093921, -82.7147216796875, -1.44364423318128, 218, 33, 'PPL', 'P'),
(84360, 'White Oaks', 34.5858306884766, 0.603636620051213, -82.6111068725586, -1.44183581364306, 218, 48, 'PPL', 'P'),
(91828, 'White Oaks', 35.461109161377, 0.618913111275153, -86.0619430541992, -1.50206426695964, 218, 50, 'PPL', 'P'),
(107539, 'White Oaks', 38.7616691589355, 0.676518750392166, -77.0697174072266, -1.34512032233769, 218, 53, 'PPL', 'P'),
(126635, 'White Oaks', 42.7308311462402, 0.745793695615635, -73.1980590820313, -1.27754713705078, 218, 23, 'PPL', 'P'),
(189809, 'White Oaks', 33.747501373291, 0.589005013285236, -105.735832214355, -1.84543840947679, 218, 38, 'PPL', 'P'),
(202784, 'White Owl', 44.5922203063965, 0.778281065121293, -102.430282592773, -1.78774568499213, 218, 49, 'PPL', 'P'),
(26016, 'White Path', 34.7502784729004, 0.606506775337019, -84.4130630493164, -1.47328588190414, 218, 13, 'PPL', 'P'),
(121969, 'White Pigeon', 41.8902816772461, 0.731123339855797, -89.89111328125, -1.56889589504102, 218, 18, 'PPL', 'P'),
(133704, 'White Pigeon', 41.7980613708496, 0.72951379187198, -85.6433334350586, -1.49475815082512, 218, 27, 'PPL', 'P'),
(91831, 'White Pine', 36.1074981689453, 0.630194727705919, -83.2869415283203, -1.45363135358519, 218, 50, 'PPL', 'P'),
(107541, 'White Pine', 37.0602798461914, 0.646823905026538, -79.6766662597656, -1.39062016324559, 218, 53, 'PPL', 'P'),
(112029, 'White Pine', 38.9466705322266, 0.679747633476806, -81.0294418334961, -1.41423055104774, 218, 58, 'PPL', 'P'),
(133706, 'White Pine', 46.7538909912109, 0.816009335915146, -89.5838928222656, -1.56353388650225, 218, 27, 'PPL', 'P'),
(168912, 'White Pine', 41.4127807617188, 0.722789376698557, -77.2222213745117, -1.34778201868917, 218, 45, 'PPL', 'P'),
(197839, 'White Pine', 47.7436103820801, 0.833283197956645, -115.481391906738, -2.01553051355852, 218, 31, 'PPL', 'P'),
(52742, 'White Pine Acres', 39.4811096191406, 0.689075355194808, -76.9569396972656, -1.34315197997601, 218, 25, 'PPL', 'P'),
(190927, 'White Pine City (historical)', 39.2194404602051, 0.684508366820459, -115.48388671875, -2.01557405624234, 218, 39, 'PPL', 'P'),
(177021, 'White Pine Haven', 45.5636100769043, 0.795235014936847, -87.7944412231445, -1.53230206429251, 218, 57, 'PPL', 'P'),
(107543, 'White Pine Lodge', 37.3902816772461, 0.652583523516052, -80.5502777099609, -1.40586755943462, 218, 53, 'PPL', 'P'),
(186126, 'White Pines', 38.2661094665527, 0.667869602119916, -120.339721679688, -2.10032436424415, 218, 6, 'PPL', 'P'),
(52750, 'White Pines Trailer Park', 39.4916687011719, 0.689259645942242, -76.8786087036133, -1.34178484623042, 218, 25, 'PPL', 'P'),
(189810, 'White Place', 31.9688892364502, 0.557962375381432, -108.608062744141, -1.89556828909784, 218, 38, 'PPL', 'P'),
(6781, 'White Plains', 32.9922218322754, 0.575822898521562, -85.399169921875, -1.49049669360683, 218, 2, 'PPL', 'P'),
(26017, 'White Plains', 33.4719390869141, 0.584195544093635, -83.0355606079102, -1.44924392884734, 218, 13, 'PPL', 'P'),
(38857, 'White Plains', 37.1836090087891, 0.648976404977594, -87.3836135864258, -1.52513176937358, 218, 21, 'PPL', 'P'),
(52745, 'White Plains', 38.3716697692871, 0.669711976962033, -75.5461120605469, -1.31852839253714, 218, 25, 'PPL', 'P'),
(62303, 'White Plains', 30.5555591583252, 0.533295112100682, -88.9305572509766, -1.55213102966286, 218, 30, 'PPL', 'P'),
(70121, 'White Plains', 36.4455604553223, 0.636095027680017, -80.6336135864258, -1.40732204486396, 218, 33, 'PPL', 'P'),
(84354, 'White Plains', 34.7069396972656, 0.605750371008409, -80.4166717529297, -1.40353569558414, 218, 48, 'PPL', 'P'),
(91829, 'White Plains', 36.166389465332, 0.631222574728636, -85.45361328125, -1.49144690948377, 218, 50, 'PPL', 'P'),
(107542, 'White Plains', 36.6441688537598, 0.639561398154864, -77.958610534668, -1.36063443410989, 218, 53, 'PPL', 'P'),
(153782, 'White Plains', 41.0338897705078, 0.716176481395782, -73.7633285522461, -1.28741295046704, 218, 40, 'PPL', 'P'),
(84355, 'White Plains Crossroad', 34.3250007629395, 0.599084279062859, -81.920280456543, -1.42977861812384, 218, 48, 'PPL', 'P'),
(52746, 'White Plains Village', 38.5791702270508, 0.673333543149405, -76.9472198486328, -1.34298233661458, 218, 25, 'PPL', 'P'),
(44124, 'White Plantation', 29.8161106109619, 0.520389300300103, -90.9116668701172, -1.58670791535979, 218, 22, 'PPL', 'P'),
(52747, 'White Point Beach', 38.2236099243164, 0.667127845177302, -76.6205596923828, -1.33728104135293, 218, 25, 'PPL', 'P'),
(84356, 'White Point Landing', 32.6369400024414, 0.569622060818449, -80.2772216796875, -1.40110183266392, 218, 48, 'PPL', 'P'),
(70122, 'White Pond', 34.4375, 0.601047761155547, -79.1961135864258, -1.38223293686654, 218, 33, 'PPL', 'P'),
(84358, 'White Pond', 34.0933303833008, 0.595040868158819, -78.9263916015625, -1.37752540016567, 218, 48, 'PPL', 'P'),
(107546, 'White Post', 39.0569381713867, 0.681672166838552, -78.103889465332, -1.36317002978376, 218, 53, 'PPL', 'P'),
(107544, 'White Pump', 39.0724983215332, 0.681943742690712, -77.7561111450195, -1.35710015302725, 218, 53, 'PPL', 'P'),
(12819, 'White River', 33.8833312988281, 0.591375692708597, -91.0688934326172, -1.58945203654701, 218, 4, 'PPL', 'P'),
(31516, 'White River', 38.3941688537598, 0.670104660064765, -87.753059387207, -1.53157981500488, 218, 19, 'PPL', 'P'),
(177022, 'White River', 46.535831451416, 0.812203478980341, -90.8505630493164, -1.58564145250127, 218, 57, 'PPL', 'P'),
(186130, 'White River', 35.8111114501953, 0.62502180360455, -118.841941833496, -2.07418317445809, 218, 6, 'PPL', 'P'),
(202785, 'White River', 43.5680618286133, 0.760406127621763, -100.745002746582, -1.75833200285859, 218, 49, 'PPL', 'P'),
(190928, 'White River (historical)', 38.6277809143066, 0.674181959693676, -115.047218322754, -2.0079527549928, 218, 39, 'PPL', 'P'),
(194477, 'White River City', 40.0908317565918, 0.699717014015629, -108.223609924316, -1.88885832157333, 218, 7, 'PPL', 'P'),
(14861, 'White River Estates', 38.5638885498047, 0.673066827566233, -75.6555633544922, -1.32043867798705, 218, 10, 'PPL', 'P'),
(172788, 'White River Junction', 43.6488914489746, 0.761816870630205, -72.3197174072266, -1.26221718286796, 218, 55, 'PPL', 'P'),
(186128, 'White River Summer Home Tract', 35.8494415283203, 0.625690789670378, -118.626106262207, -2.07041613309618, 218, 6, 'PPL', 'P'),
(70123, 'White Road (historical)', 36.1958312988281, 0.631736431660966, -80.0911102294922, -1.39785357508235, 218, 33, 'PPL', 'P'),
(12818, 'White Rock', 36.0794410705566, 0.629705038960481, -94.2522201538086, -1.64501156899852, 218, 4, 'PPL', 'P'),
(34409, 'White Rock', 39.8861083984375, 0.696143917360097, -97.9319381713867, -1.70923476395021, 218, 20, 'PPL', 'P'),
(52749, 'White Rock', 39.4902801513672, 0.689235411176322, -77.4563903808594, -1.35186903885606, 218, 25, 'PPL', 'P'),
(58268, 'White Rock', 39.3344383239746, 0.686515458175997, -93.2844390869141, -1.62812060294274, 218, 29, 'PPL', 'P'),
(70124, 'White Rock', 35.9524993896484, 0.627489488670617, -82.7016677856445, -1.44341639975003, 218, 33, 'PPL', 'P'),
(79404, 'White Rock', 39.8213882446289, 0.69501433758374, -76.0899963378906, -1.32802096392662, 218, 45, 'PPL', 'P'),
(84359, 'White Rock', 34.1450004577637, 0.595942681082947, -81.2758331298828, -1.41853089041794, 218, 48, 'PPL', 'P'),
(91830, 'White Rock', 36.2205581665039, 0.632167996915614, -82.1333312988281, -1.43349705679586, 218, 50, 'PPL', 'P'),
(99077, 'White Rock', 31.5569400787354, 0.550772506228491, -94.0344390869141, -1.6412105723327, 218, 51, 'PPL', 'P'),
(107545, 'White Rock', 37.8902816772461, 0.661310169776024, -79.0608291625977, -1.37987177824408, 218, 53, 'PPL', 'P'),
(121970, 'White Rock', 42.0363883972168, 0.733673383178575, -89.1338882446289, -1.55567982497344, 218, 18, 'PPL', 'P'),
(129319, 'White Rock', 43.752498626709, 0.763625157010369, -70.4683303833008, -1.22990438357176, 218, 26, 'PPL', 'P'),
(133709, 'White Rock', 44.252498626709, 0.772351803270341, -83.6838912963867, -1.46055943400297, 218, 27, 'PPL', 'P'),
(138817, 'White Rock', 44.4563903808594, 0.775910385697932, -92.7669372558594, -1.61908849210574, 218, 28, 'PPL', 'P'),
(169674, 'White Rock', 41.4002799987793, 0.722571197226253, -71.8391723632813, -1.25383008964697, 218, 47, 'PPL', 'P'),
(171616, 'White Rock', 45.9166717529297, 0.801397103646099, -96.5713882446289, -1.68548868809052, 218, 49, 'PPL', 'P'),
(186129, 'White Rock', 38.6272201538086, 0.67417217257667, -121.091110229492, -2.11343856840003, 218, 6, 'PPL', 'P'),
(189812, 'White Rock', 36.0886116027832, 0.629865094941995, -108.269996643066, -1.88966792254472, 218, 38, 'PPL', 'P'),
(26018, 'White Rock (historical)', 33.7563896179199, 0.589160142418733, -82.4408264160156, -1.43886385902459, 218, 13, 'PPL', 'P'),
(74814, 'White Rock (historical)', 39.0152816772461, 0.68094512386096, -81.9875030517578, -1.43095187374207, 218, 41, 'PPL', 'P'),
(200279, 'White Rock (historical)', 41.7419395446777, 0.728534281223049, -116.185279846191, -2.02781567566705, 218, 39, 'PPL', 'P'),
(168913, 'White Rock Acres', 40.1288909912109, 0.700381272970522, -77.0824966430664, -1.34534336207899, 218, 45, 'PPL', 'P'),
(192864, 'White Rock Curve Village', 37.2113914489746, 0.64946130003307, -109.292221069336, -1.90750910447743, 218, 52, 'PPL', 'P'),
(107547, 'White Rock Hill', 37.4030609130859, 0.652806563257346, -79.1397171020508, -1.38124863252765, 218, 53, 'PPL', 'P'),
(52751, 'White Rocks', 39.5277786254883, 0.689889883014209, -77.466667175293, -1.35204840275548, 218, 25, 'PPL', 'P'),
(79405, 'White Rocks', 39.8697204589844, 0.695857893859022, -77.5219421386719, -1.35301313286036, 218, 45, 'PPL', 'P'),
(31519, 'White Rose', 39.0311088562012, 0.681221360245028, -87.2227783203125, -1.52232466442658, 218, 19, 'PPL', 'P'),
(112361, 'White Rose', 37.4211082458496, 0.653121548635275, -85.4611129760742, -1.49157780385135, 218, 21, 'PPL', 'P'),
(38858, 'White Run', 37.4447212219238, 0.653533672813965, -86.6419372558594, -1.51218707542109, 218, 21, 'PPL', 'P'),
(209170, 'White Salmon', 45.7277793884277, 0.798100309953663, -121.485282897949, -2.12031817928597, 218, 56, 'PPL', 'P'),
(62304, 'White Sand', 30.7991695404053, 0.537546915360021, -89.6580581665039, -1.56482831595008, 218, 30, 'PPL', 'P'),
(26019, 'White Sands', 34.3172187805176, 0.598948457847265, -83.8661117553711, -1.46373978097675, 218, 13, 'PPL', 'P'),
(52752, 'White Sands', 38.4244384765625, 0.67063296464601, -76.4761123657227, -1.33475995990701, 218, 25, 'PPL', 'P'),
(189813, 'White Sands', 32.3808288574219, 0.565152078086805, -106.478889465332, -1.85840720503715, 218, 38, 'PPL', 'P'),
(114288, 'White Sands Beach', 41.2833290100098, 0.720530017408762, -72.3047180175781, -1.26195539413281, 218, 8, 'PPL', 'P'),
(211311, 'White Sands Beach Estates', 19.5927791595459, 0.341958505950203, -155.973052978516, -2.72224331886265, 218, 15, 'PPL', 'P'),
(129320, 'White School Corner', 44.8147201538086, 0.78216442004382, -69.7641677856445, -1.21761442777326, 218, 26, 'PPL', 'P'),
(99078, 'White Settlement', 32.7594413757324, 0.571760113120592, -97.4580612182617, -1.70096405086886, 218, 51, 'PPL', 'P'),
(99079, 'White Shed', 33.6324996948242, 0.586997855350671, -96.165283203125, -1.67840081800733, 218, 51, 'PPL', 'P'),
(199096, 'White Shield', 47.6613883972168, 0.831848153603256, -101.844718933105, -1.7775256711509, 218, 34, 'PPL', 'P'),
(189814, 'White Signal', 32.5558280944824, 0.56820639096199, -108.365562438965, -1.89133586033543, 218, 38, 'PPL', 'P'),
(6782, 'White Signboard Crossroad', 33.2497215270996, 0.580317116019125, -85.3841705322266, -1.49023490487167, 218, 2, 'PPL', 'P'),
(186131, 'White Spot', 39.2813911437988, 0.685589610223031, -121.009719848633, -2.11201803827458, 218, 6, 'PPL', 'P'),
(168914, 'White Spring', 40.3997192382813, 0.705108117589303, -76.845832824707, -1.34121279922827, 218, 45, 'PPL', 'P'),
(18596, 'White Springs', 30.4200000762939, 0.530929159788256, -84.915283203125, -1.48205127715797, 218, 12, 'PPL', 'P'),
(168915, 'White Springs', 40.8830604553223, 0.713544013237266, -77.0880584716797, -1.34544043430072, 218, 45, 'PPL', 'P'),
(133710, 'White Star', 43.9805603027344, 0.767605584154629, -84.3658294677734, -1.4724615003887, 218, 27, 'PPL', 'P'),
(52753, 'White Station', 38.5811080932617, 0.673367365295249, -76.9499969482422, -1.34303080614641, 218, 25, 'PPL', 'P'),
(91832, 'White Station', 35.1019401550293, 0.61264442954327, -89.8597183227539, -1.56834794964673, 218, 50, 'PPL', 'P'),
(112030, 'White Stick (historical)', 37.7988891601563, 0.659715069441121, -81.1455612182617, -1.41625721663729, 218, 58, 'PPL', 'P'),
(70125, 'White Stocking', 34.5844383239746, 0.603612318706266, -77.8319396972656, -1.35842361093096, 218, 33, 'PPL', 'P'),
(84361, 'White Stone', 34.9027786254883, 0.609168405109471, -81.8172225952148, -1.4279799191236, 218, 48, 'PPL', 'P'),
(99080, 'White Stone', 30.5205593109131, 0.532684249525645, -97.8300018310547, -1.70745563918399, 218, 51, 'PPL', 'P'),
(107549, 'White Stone', 37.6483306884766, 0.65708732839354, -76.3894424438477, -1.33324728440785, 218, 53, 'PPL', 'P'),
(84362, 'White Stone Springs (historical)', 34.8727798461914, 0.608644827639162, -81.8125, -1.42789749428786, 218, 48, 'PPL', 'P'),
(153784, 'White Store', 42.4858283996582, 0.741517591011349, -75.4038925170898, -1.31604619324313, 218, 40, 'PPL', 'P'),
(26020, 'White Sulphur', 34.3561096191406, 0.599627231030099, -83.7669372558594, -1.46200885942625, 218, 13, 'PPL', 'P'),
(38860, 'White Sulphur', 38.2050018310547, 0.666803072682367, -84.7022171020508, -1.47833257216984, 218, 21, 'PPL', 'P'),
(158358, 'White Sulphur', 40.276668548584, 0.702960477907236, -83.1575012207031, -1.45137219403247, 218, 41, 'PPL', 'P'),
(91833, 'White Sulphur (historical)', 35.0541687011719, 0.611810660384993, -88.2230606079102, -1.53978288379454, 218, 50, 'PPL', 'P'),
(26022, 'White Sulphur Springs', 32.9077796936035, 0.574349105174312, -84.8033294677734, -1.48009731586618, 218, 13, 'PPL', 'P'),
(31520, 'White Sulphur Springs', 38.3855590820313, 0.669954391200257, -87.0919418334961, -1.52004113694989, 218, 19, 'PPL', 'P'),
(44125, 'White Sulphur Springs', 31.601390838623, 0.551548318343544, -92.273063659668, -1.61046877176353, 218, 22, 'PPL', 'P'),
(112031, 'White Sulphur Springs', 37.7963905334473, 0.659671460178271, -80.2977828979492, -1.40146069362081, 218, 58, 'PPL', 'P'),
(153785, 'White Sulphur Springs', 41.7975006103516, 0.729504004754974, -74.8272171020508, -1.3059813085354, 218, 40, 'PPL', 'P'),
(197840, 'White Sulphur Springs', 46.5483283996582, 0.812421591873619, -110.901390075684, -1.93559440185924, 218, 31, 'PPL', 'P'),
(26023, 'White Sulphur Station (historical)', 34.3563919067383, 0.599632157878116, -83.7658309936523, -1.46198955150835, 218, 13, 'PPL', 'P'),
(209171, 'White Swan', 46.3830604553223, 0.809537122096954, -120.730003356934, -2.1071360645223, 218, 56, 'PPL', 'P'),
(52754, 'White Swan Lake', 39.5152816772461, 0.689671770120932, -75.7819366455078, -1.32264430800186, 218, 25, 'PPL', 'P'),
(179517, 'White Tanks', 33.6041717529297, 0.586503439494298, -112.298606872559, -1.95998043532888, 218, 5, 'PPL', 'P'),
(38862, 'White Tower', 38.9249992370605, 0.679369398022987, -84.5133285522461, -1.47503584505643, 218, 21, 'PPL', 'P'),
(126634, 'White Valley', 42.3902816772461, 0.739849986115769, -72.0805587768555, -1.25804307733342, 218, 23, 'PPL', 'P'),
(168916, 'White Valley', 40.415828704834, 0.705389280821389, -79.5986099243164, -1.38925782318996, 218, 45, 'PPL', 'P'),
(38861, 'White Villa', 38.8791694641113, 0.678569517589582, -84.4505615234375, -1.47394035374202, 218, 21, 'PPL', 'P'),
(6783, 'White Water', 32.4638900756836, 0.56660176982619, -86.6355590820313, -1.51207575528752, 218, 2, 'PPL', 'P'),
(186132, 'White Water', 33.9249992370605, 0.592102935423271, -116.637496948242, -2.03570835303166, 218, 6, 'PPL', 'P'),
(74815, 'White Water Park', 39.1974983215332, 0.684125404255705, -84.7799987792969, -1.4796901185355, 218, 41, 'PPL', 'P'),
(44126, 'White Way Subdivision', 32.9930610656738, 0.575837545907557, -93.4594421386719, -1.63117498239696, 218, 22, 'PPL', 'P'),
(138818, 'White Willow', 44.3641700744629, 0.774300837714115, -92.6511077880859, -1.61706688652226, 218, 28, 'PPL', 'P'),
(121972, 'White Willow (historical)', 41.4747200012207, 0.723870420364048, -88.3847198486328, -1.54260436981143, 218, 18, 'PPL', 'P'),
(107551, 'White Wing', 36.5838890075684, 0.638509316366229, -78.7058334350586, -1.37367593396801, 218, 53, 'PPL', 'P'),
(186133, 'White Wolf', 37.8694381713867, 0.660946381971119, -119.649169921875, -2.08827196241489, 218, 6, 'PPL', 'P'),
(158359, 'White Womans Town (historical)', 40.3261108398438, 0.703823408679449, -81.9394378662109, -1.4301129779987, 218, 41, 'PPL', 'P'),
(107552, 'Whitebank', 37.7197189331055, 0.658333288309533, -77.0352783203125, -1.34451924687966, 218, 53, 'PPL', 'P'),
(77675, 'Whitebead', 34.7608299255371, 0.606690932926398, -97.3002777099609, -1.69821020914367, 218, 42, 'PPL', 'P'),
(118452, 'Whitebreast', 41.0394401550293, 0.716273353880433, -93.3625030517578, -1.62948307615643, 218, 16, 'PPL', 'P'),
(52755, 'Whiteburg', 38.185001373291, 0.666453998842485, -75.5380630493164, -1.31838791078964, 218, 25, 'PPL', 'P'),
(62305, 'Whitebury', 33.4294395446777, 0.58345378715102, -88.3763885498047, -1.54245896121591, 218, 30, 'PPL', 'P'),
(199777, 'Whiteclay', 42.996940612793, 0.750438181977706, -102.554168701172, -1.78990790548117, 218, 35, 'PPL', 'P'),
(139524, 'Whitecloud', 40.2088890075684, 0.701777501751023, -94.8963928222656, -1.65625450301445, 218, 29, 'PPL', 'P'),
(58272, 'Whitecorn', 38.8980598449707, 0.678899216932534, -90.3574981689453, -1.57703584691284, 218, 29, 'PPL', 'P'),
(138821, 'Whiteface', 47.1866683959961, 0.823562726556883, -92.3661117553711, -1.61209276739626, 218, 28, 'PPL', 'P'),
(144670, 'Whiteface', 43.8666687011719, 0.765617800716994, -71.3986129760742, -1.24614087778964, 218, 36, 'PPL', 'P'),
(153786, 'Whiteface', 44.3111114501953, 0.773374790024068, -74.003059387207, -1.29159704285566, 218, 40, 'PPL', 'P'),
(192427, 'Whiteface', 33.5999984741211, 0.586430602038484, -102.613327026367, -1.79094041303579, 218, 51, 'PPL', 'P'),
(153792, 'Whiteface Landing', 44.3397216796875, 0.773874132728457, -73.9475021362305, -1.29062738590276, 218, 40, 'PPL', 'P'),
(12825, 'Whitefield', 34.0644416809082, 0.59453666518544, -91.7566680908203, -1.60145596884443, 218, 4, 'PPL', 'P'),
(77677, 'Whitefield', 35.252498626709, 0.615272170590851, -95.2372207641602, -1.6622030727833, 218, 42, 'PPL', 'P'),
(107555, 'Whitefield', 37.2922210693359, 0.650872043041513, -80.0522232055664, -1.39717486847854, 218, 53, 'PPL', 'P'),
(121973, 'Whitefield', 41.148609161377, 0.718178712482331, -89.5047225952148, -1.56215210537066, 218, 18, 'PPL', 'P'),
(129322, 'Whitefield', 44.1699981689453, 0.770911898647962, -69.6258316040039, -1.21520000592899, 218, 26, 'PPL', 'P'),
(144671, 'Whitefield', 44.3730583190918, 0.774455966847613, -71.6105575561523, -1.24984000854376, 218, 36, 'PPL', 'P'),
(118454, 'Whitefield (historical)', 40.9949989318848, 0.715497708212948, -92.0436096191406, -1.60646404327433, 218, 16, 'PPL', 'P'),
(197841, 'Whitefish', 48.4111099243164, 0.844933262724224, -114.336669921875, -1.99555134590269, 218, 31, 'PPL', 'P'),
(177025, 'Whitefish Bay', 43.1133308410645, 0.752469574678191, -87.9000015258789, -1.53414443913463, 218, 57, 'PPL', 'P'),
(212229, 'Whitefish Lake', 60.9333305358887, 1.06348724205726, -155.024993896484, -2.70569656637777, 218, 1, 'PPL', 'P'),
(133711, 'Whitefish Point', 46.7658309936523, 0.816217728270445, -84.9652786254883, -1.48292386188913, 218, 27, 'PPL', 'P'),
(192428, 'Whiteflat', 34.105281829834, 0.5952494602512, -100.889167785645, -1.76084815745649, 218, 51, 'PPL', 'P'),
(52756, 'Whiteford', 39.7088890075684, 0.693050855491051, -76.345832824707, -1.3324861529683, 218, 25, 'PPL', 'P'),
(133713, 'Whiteford Center', 41.776668548584, 0.729140416687151, -83.6830596923828, -1.46054491977503, 218, 27, 'PPL', 'P'),
(153787, 'Whiteford Hollow', 42.4194412231445, 0.740358916200083, -78.7341690063477, -1.37417048298244, 218, 40, 'PPL', 'P'),
(12828, 'Whitehall', 35.148609161377, 0.613458957362671, -92.996940612793, -1.62310280797487, 218, 4, 'PPL', 'P'),
(26024, 'Whitehall', 33.9069404602051, 0.59178775030826, -83.3572235107422, -1.45485800558328, 218, 13, 'PPL', 'P'),
(31521, 'Whitehall', 39.1741714477539, 0.683718273504059, -86.684440612793, -1.51292889894273, 218, 19, 'PPL', 'P'),
(44130, 'Whitehall', 31.6241703033447, 0.551945895004779, -92.0416717529297, -1.60643022112848, 218, 22, 'PPL', 'P'),
(52757, 'Whitehall', 38.5611114501953, 0.673018358034394, -76.0136108398438, -1.32668778548493, 218, 25, 'PPL', 'P'),
(74816, 'Whitehall', 39.9666709899902, 0.697549999836631, -82.8855590820313, -1.44662590833773, 218, 41, 'PPL', 'P'),
(84365, 'Whitehall', 34.0561103820801, 0.594391256589921, -81.147216796875, -1.41628611193512, 218, 48, 'PPL', 'P'),
(99081, 'Whitehall', 30.3022193908691, 0.528873499032337, -95.9733276367188, -1.67505056135601, 218, 51, 'PPL', 'P'),
(107553, 'Whitehall', 37.7336082458496, 0.658575702547758, -77.0430603027344, -1.34465506809525, 218, 53, 'PPL', 'P'),
(112032, 'Whitehall', 39.4211082458496, 0.688028133675162, -80.1827774047852, -1.39945346910722, 218, 58, 'PPL', 'P'),
(133715, 'Whitehall', 43.4099998474121, 0.757647425627577, -86.3486099243164, -1.50706754769957, 218, 27, 'PPL', 'P'),
(146641, 'Whitehall', 40.9644393920898, 0.714964343625632, -74.7397232055664, -1.30445425196634, 218, 37, 'PPL', 'P'),
(153788, 'Whitehall', 43.5555610656738, 0.760187948149458, -73.404167175293, -1.28114440189321, 218, 40, 'PPL', 'P'),
(168920, 'Whitehall', 40.3611106872559, 0.704434271254486, -79.9911117553711, -1.39610827246197, 218, 45, 'PPL', 'P'),
(169678, 'Whitehall', 41.5141716003418, 0.724558980663888, -71.2774963378906, -1.24402699367439, 218, 47, 'PPL', 'P'),
(177027, 'Whitehall', 44.3675003051758, 0.774358961204906, -91.3163909912109, -1.59377168383512, 218, 57, 'PPL', 'P'),
(197842, 'Whitehall', 45.8708305358887, 0.800597023475612, -112.096672058105, -1.95645600794227, 218, 31, 'PPL', 'P'),
(107554, 'Whitehall Acres', 37.7222213745117, 0.65837696415141, -77.8625030517578, -1.35895704209731, 218, 53, 'PPL', 'P'),
(52758, 'Whitehall Beach', 39.0077781677246, 0.680814162914355, -76.438606262207, -1.33410535491107, 218, 25, 'PPL', 'P'),
(153789, 'Whitehall Corners', 41.2747192382813, 0.720379748544254, -73.710563659668, -1.28649202936209, 218, 40, 'PPL', 'P'),
(14854, 'Whitehall Crossroads', 39.2683296203613, 0.68536164363372, -75.5216674804688, -1.31810175413051, 218, 10, 'PPL', 'P'),
(52769, 'Whitehall Estates', 39.0152816772461, 0.68094512386096, -76.4316711425781, -1.33398431423952, 218, 25, 'PPL', 'P'),
(26025, 'Whitehall Forest Estates', 33.684440612793, 0.587904395385734, -84.313606262207, -1.47155003350562, 218, 13, 'PPL', 'P'),
(14855, 'Whitehall Landing', 39.250560760498, 0.68505151852478, -75.476936340332, -1.31732104845695, 218, 10, 'PPL', 'P'),
(52760, 'Whitehall Manor', 38.9824981689453, 0.680372943700756, -77.1102828979492, -1.34582832371349, 218, 25, 'PPL', 'P'),
(70127, 'Whitehall Shores', 36.2924995422363, 0.633423610790559, -76.147216796875, -1.3290196493354, 218, 33, 'PPL', 'P'),
(84366, 'Whitehall Terrace', 32.8733291625977, 0.573747829979199, -79.7486114501953, -1.39187584369956, 218, 48, 'PPL', 'P'),
(52761, 'Whitehaven', 38.2691688537598, 0.667922998499772, -75.791389465332, -1.32280929083139, 218, 25, 'PPL', 'P'),
(91834, 'Whitehaven', 35.0272216796875, 0.611340346136485, -90.029167175293, -1.57130539003727, 218, 50, 'PPL', 'P'),
(186134, 'Whitehawk', 39.7205581665039, 0.693254520735415, -120.550003051758, -2.10399446654239, 218, 6, 'PPL', 'P'),
(6784, 'Whitehead', 34.8880615234375, 0.608911543222333, -87.3272171020508, -1.52414746503469, 218, 2, 'PPL', 'P'),
(62306, 'Whitehead', 33.8486099243164, 0.59076969040255, -90.2986068725586, -1.57600799989013, 218, 30, 'PPL', 'P'),
(70128, 'Whitehead', 36.4672203063965, 0.636473063396754, -81.1530609130859, -1.41638811100487, 218, 33, 'PPL', 'P'),
(91835, 'Whitehead', 35.4799995422363, 0.619242810618105, -86.7888870239258, -1.51475183270889, 218, 50, 'PPL', 'P'),
(99082, 'Whitehead', 32.8680610656738, 0.573655884342565, -96.2600021362305, -1.680053975254, 218, 51, 'PPL', 'P'),
(18597, 'Whitehead Crossroads', 30.7041702270508, 0.535888864554851, -85.7677764892578, -1.49693009185213, 218, 12, 'PPL', 'P'),
(91836, 'Whitehead Hill', 36.2277793884277, 0.632294031014202, -82.1575012207031, -1.43391890151253, 218, 50, 'PPL', 'P'),
(70130, 'Whiteheads Mill (historical)', 35.6927795410156, 0.622956522179193, -80.470832824707, -1.40448098461307, 218, 33, 'PPL', 'P'),
(187539, 'Whitehorn', 38.6438903808594, 0.674463122925762, -105.877777099609, -1.84791581508084, 218, 7, 'PPL', 'P'),
(79407, 'Whitehorse', 39.9897193908691, 0.697952270319288, -75.4688873291016, -1.31718056670945, 218, 45, 'PPL', 'P'),
(189815, 'Whitehorse', 35.8111114501953, 0.62502180360455, -107.747222900391, -1.88054379949205, 218, 38, 'PPL', 'P'),
(202787, 'Whitehorse', 45.2705612182617, 0.790120347484322, -100.886108398438, -1.76079476107664, 218, 49, 'PPL', 'P'),
(6785, 'Whitehouse', 34.1213912963867, 0.595530623483285, -87.7322235107422, -1.53121616035803, 218, 2, 'PPL', 'P'),
(18598, 'Whitehouse', 30.3161106109619, 0.529115946560075, -81.8463897705078, -1.42848898236597, 218, 12, 'PPL', 'P'),
(26026, 'Whitehouse', 33.5430603027344, 0.585436843477721, -84.1374969482422, -1.46847634613351, 218, 13, 'PPL', 'P'),
(38863, 'Whitehouse', 37.8736114501953, 0.661019219426933, -82.6988906860352, -1.44336793021819, 218, 21, 'PPL', 'P'),
(44128, 'Whitehouse', 30.3138904571533, 0.529077197566215, -92.602783203125, -1.61622346340503, 218, 22, 'PPL', 'P'),
(52763, 'Whitehouse', 39.023609161377, 0.681090465877451, -76.9241714477539, -1.34258006613192, 218, 25, 'PPL', 'P'),
(70131, 'Whitehouse', 35.5269393920898, 0.62006206554844, -82.0919418334961, -1.43277467435018, 218, 33, 'PPL', 'P'),
(91837, 'Whitehouse', 35.913890838623, 0.6268156423358, -87.6063919067383, -1.5290199845651, 218, 50, 'PPL', 'P'),
(99083, 'Whitehouse', 32.2266693115234, 0.562461486437498, -95.2252807617188, -1.66199468042801, 218, 51, 'PPL', 'P'),
(146642, 'Whitehouse', 40.6183280944824, 0.708923561904033, -74.7447204589844, -1.30454147049204, 218, 37, 'PPL', 'P'),
(158360, 'Whitehouse', 41.5188903808594, 0.724641338920599, -83.8038864135742, -1.46265374388421, 218, 41, 'PPL', 'P'),
(194056, 'Whitehouse (historical)', 40.6577796936035, 0.709612122203873, -122.432502746582, -2.13685028438486, 218, 6, 'PPL', 'P'),
(113220, 'Whitehouse Crossing', 42.0258293151855, 0.733489092431142, -73.5202789306641, -1.2831709343247, 218, 40, 'PPL', 'P'),
(6786, 'Whitehouse Forks', 30.8077793121338, 0.537697184224529, -87.8141708374023, -1.53264641102146, 218, 2, 'PPL', 'P'),
(107556, 'Whitehouse Landing', 38.646110534668, 0.674501871919622, -78.5350036621094, -1.37069439196961, 218, 53, 'PPL', 'P'),
(133718, 'Whitehouse Landing', 46.5519409179688, 0.812484642212426, -85.1716690063477, -1.48652605357957, 218, 27, 'PPL', 'P'),
(26028, 'Whitehouse Plantation', 32.9000015258789, 0.574213350537745, -83.7238922119141, -1.46125758168274, 218, 13, 'PPL', 'P'),
(84367, 'Whitehouse Plantation', 32.7305603027344, 0.571256043305267, -79.9522171020508, -1.39542943270011, 218, 48, 'PPL', 'P'),
(146643, 'Whitehouse Station', 40.6152801513672, 0.708870365261258, -74.7708282470703, -1.30499713735456, 218, 37, 'PPL', 'P'),
(44129, 'Whitehurst', 32.5397186279297, 0.567925227729905, -93.6602783203125, -1.63468023502372, 218, 22, 'PPL', 'P'),
(52764, 'Whitehurst', 39.1305618286133, 0.682957142064515, -76.8016662597656, -1.34044194725075, 218, 25, 'PPL', 'P'),
(70132, 'Whitehurst', 35.7658309936523, 0.624231510551069, -77.3324966430664, -1.34970668520897, 218, 33, 'PPL', 'P'),
(107557, 'Whitehurst Landing', 36.8236083984375, 0.64269320901777, -76.1877822875977, -1.3297276507112, 218, 53, 'PPL', 'P'),
(31522, 'Whiteland', 39.5499992370605, 0.690277705847952, -86.079719543457, -1.50237452522664, 218, 19, 'PPL', 'P'),
(99084, 'Whiteland', 31.1641693115234, 0.543917363135058, -99.5055618286133, -1.73669967795609, 218, 51, 'PPL', 'P'),
(168924, 'Whiteland Crest', 40.0205612182617, 0.69849056175462, -75.6222229003906, -1.31985677728887, 218, 45, 'PPL', 'P'),
(153791, 'Whitelaw', 43.1322212219238, 0.752799274021143, -75.7911071777344, -1.32280436398337, 218, 40, 'PPL', 'P'),
(177030, 'Whitelaw', 44.144718170166, 0.770470679434363, -87.8213882446289, -1.53277237854102, 218, 57, 'PPL', 'P'),
(187965, 'Whitelaw', 38.4550018310547, 0.671166395812352, -101.678886413574, -1.7746313476782, 218, 20, 'PPL', 'P'),
(52766, 'Whiteley', 38.9469413757324, 0.679752360587741, -76.9283294677734, -1.34265263727162, 218, 25, 'PPL', 'P'),
(14856, 'Whiteleysburg', 38.9575004577637, 0.679936651335174, -75.7319412231445, -1.32177172327069, 218, 10, 'PPL', 'P'),
(52767, 'Whiteleysburg', 38.9566688537598, 0.679922137107233, -75.732780456543, -1.32178637065669, 218, 25, 'PPL', 'P'),
(168928, 'Whitemarsh', 40.121940612793, 0.700259965982869, -75.2169418334961, -1.31278328827557, 218, 45, 'PPL', 'P'),
(52768, 'Whitemarsh Estates', 39.3611106872559, 0.686980978734543, -76.432502746582, -1.33399882846747, 218, 25, 'PPL', 'P'),
(26027, 'Whitemarsh Island', 32.0286102294922, 0.559004703342575, -81.0169372558594, -1.41401230499641, 218, 13, 'PPL', 'P'),
(12829, 'Whitener', 36.1411094665527, 0.630781355515037, -93.8958282470703, -1.63879135679847, 218, 4, 'PPL', 'P'),
(6787, 'Whiteoak', 34.6530609130859, 0.604810008827502, -87.5286102294922, -1.52766243819943, 218, 2, 'PPL', 'P'),
(28972, 'Whiteoak', 38.2280616760254, 0.667205542902105, -89.7261123657227, -1.56601608579626, 218, 18, 'PPL', 'P'),
(31523, 'Whiteoak', 38.4094390869141, 0.670371175910855, -87.1463928222656, -1.52099148598489, 218, 19, 'PPL', 'P'),
(91838, 'Whiteoak', 35.8383293151855, 0.625496844963992, -87.1536102294922, -1.52111745350445, 218, 50, 'PPL', 'P'),
(107558, 'Whiteoak (historical)', 36.7166709899902, 0.640826799146816, -79.3949966430664, -1.38570410103135, 218, 53, 'PPL', 'P'),
(91839, 'Whiteoak Creek Subdivision', 36.2444381713867, 0.632584781626211, -87.9263916015625, -1.53460503284516, 218, 50, 'PPL', 'P'),
(70133, 'Whiteoak Flats', 36.045280456543, 0.62910882377144, -82.3483276367188, -1.43724945077178, 218, 33, 'PPL', 'P'),
(112033, 'Whiteoak Grove', 38.0013885498047, 0.663249350523765, -80.333610534668, -1.40208600384476, 218, 58, 'PPL', 'P'),
(74818, 'Whiteoak Springs (historical)', 38.9458312988281, 0.67973298609081, -83.9236068725586, -1.46474326007549, 218, 41, 'PPL', 'P'),
(187540, 'Whitepine', 38.5416717529297, 0.672679071311518, -106.393058776855, -1.85690917692398, 218, 7, 'PPL', 'P'),
(153796, 'Whiteport', 41.8822212219238, 0.730982658371213, -74.0555572509766, -1.2925133034287, 218, 40, 'PPL', 'P'),
(70134, 'Whitepost', 35.4913902282715, 0.619441615593479, -76.8513870239258, -1.34130973829195, 218, 33, 'PPL', 'P'),
(179518, 'Whiteriver', 33.8369407653809, 0.590566025158186, -109.963607788086, -1.91922701327378, 218, 5, 'PPL', 'P'),
(99085, 'Whiterock', 33.561939239502, 0.585766343083591, -96.470832824707, -1.68373366493216, 218, 51, 'PPL', 'P'),
(187541, 'Whiterock', 37.8658294677734, 0.660883398211339, -104.113891601563, -1.81713020551174, 218, 7, 'PPL', 'P'),
(206476, 'Whiterocks', 40.4680595397949, 0.706300880862523, -109.930000305176, -1.91864045204369, 218, 52, 'PPL', 'P'),
(38864, 'Whites', 37.6305618286133, 0.6567772032846, -84.2994384765625, -1.47130275899841, 218, 21, 'PPL', 'P'),
(62308, 'Whites', 32.0863914489746, 0.560013175868361, -90.192497253418, -1.57415603766809, 218, 30, 'PPL', 'P'),
(74820, 'Whites', 39.704719543457, 0.692978084614265, -82.5911102294922, -1.44148680638221, 218, 41, 'PPL', 'P'),
(153793, 'Whites', 43.0763893127441, 0.751824823378283, -77.7094421386719, -1.35628562520785, 218, 40, 'PPL', 'P'),
(107560, 'Whites (historical)', 38.0377807617188, 0.663884514443749, -77.1847229003906, -1.34712754685128, 218, 53, 'PPL', 'P'),
(112034, 'Whites Addition', 37.8369407653809, 0.660379195237959, -82.0052795410156, -1.43126213200907, 218, 58, 'PPL', 'P'),
(70135, 'Whites Beach', 36.1547203063965, 0.631018909484272, -76.7555618286133, -1.33963727312738, 218, 33, 'PPL', 'P'),
(133719, 'Whites Beach', 43.9294395446777, 0.766713358610425, -83.89111328125, -1.46417613992136, 218, 27, 'PPL', 'P'),
(6788, 'Whites Bluff', 32.269718170166, 0.563212830760037, -87.1819381713867, -1.52161186936082, 218, 2, 'PPL', 'P'),
(6790, 'Whites Chapel', 33.5988883972168, 0.586411227541554, -86.5397186279297, -1.51040302380684, 218, 2, 'PPL', 'P'),
(189816, 'Whites City', 32.1755599975586, 0.561569460630376, -104.376106262207, -1.82170671468698, 218, 38, 'PPL', 'P'),
(197843, 'Whites City', 46.6341705322266, 0.81391981972387, -111.442222595215, -1.94503371002692, 218, 31, 'PPL', 'P'),
(74821, 'Whites Corner', 39.6375007629395, 0.691804895575058, -84.1100006103516, -1.46799644450508, 218, 41, 'PPL', 'P'),
(107561, 'Whites Corner', 38.2516708374023, 0.667617600501767, -77.1908264160156, -1.34723407329489, 218, 53, 'PPL', 'P'),
(129326, 'Whites Corner', 44.6611099243164, 0.779483415774437, -68.9663925170898, -1.203690622646, 218, 26, 'PPL', 'P'),
(172790, 'Whites Corner', 44.4122200012207, 0.775139467141381, -71.8850021362305, -1.25462997008038, 218, 55, 'PPL', 'P'),
(91840, 'Whites Creek', 36.2658309936523, 0.63295815681104, -86.8308334350586, -1.51548393569255, 218, 50, 'PPL', 'P'),
(62309, 'Whites Creek East', 33.5616683959961, 0.585761615972656, -89.2819366455078, -1.55826375702109, 218, 30, 'PPL', 'P'),
(91841, 'Whites Creek Springs (historical)', 36.315559387207, 0.633826081010297, -86.7986068725586, -1.51492147607033, 218, 50, 'PPL', 'P'),
(84369, 'Whites Cross Roads (historical)', 33.9236106872559, 0.592078700657351, -82.1586074829102, -1.43393820943043, 218, 48, 'PPL', 'P'),
(62311, 'Whites Crossing', 30.8480606079102, 0.538400225462796, -89.040283203125, -1.55404610880273, 218, 30, 'PPL', 'P'),
(70137, 'Whites Crossing', 34.2252807617188, 0.597343836711465, -78.7194366455078, -1.37391335477919, 218, 33, 'PPL', 'P'),
(168926, 'Whites Crossing', 41.586109161377, 0.725814527959806, -75.477783203125, -1.317335829001, 218, 45, 'PPL', 'P'),
(206477, 'Whites Crossing', 40.9497184753418, 0.714707415159467, -111.656936645508, -1.94878117715482, 218, 52, 'PPL', 'P'),
(70138, 'Whites Crossroads', 36.1369400024414, 0.63070858463825, -76.8661117553711, -1.34156673333714, 218, 33, 'PPL', 'P'),
(84368, 'Whites Crossroads', 34.1599998474121, 0.596204469818102, -80.019172668457, -1.39659802778643, 218, 48, 'PPL', 'P'),
(18600, 'Whites Ford', 30.0258293151855, 0.524049582191822, -81.5250015258789, -1.42287969931999, 218, 12, 'PPL', 'P'),
(6791, 'Whites Gap', 33.7783317565918, 0.589543104983487, -85.7394409179688, -1.4964355428377, 218, 2, 'PPL', 'P'),
(168927, 'Whites Hill', 40.2397193908691, 0.702315593449274, -79.5672225952148, -1.38871001095373, 218, 45, 'PPL', 'P'),
(26029, 'Whites Lake', 34.0686111450195, 0.594609436062226, -84.6361083984375, -1.47717875762756, 218, 13, 'PPL', 'P'),
(18599, 'Whites Landing', 28.6997203826904, 0.500904615079675, -81.2388916015625, -1.41788613911804, 218, 12, 'PPL', 'P'),
(133720, 'Whites Landing', 44.9072189331055, 0.783778828296626, -84.5725021362305, -1.47606861892716, 218, 27, 'PPL', 'P'),
(158361, 'Whites Landing', 41.4297218322754, 0.723085054158583, -82.9011077880859, -1.44689728445281, 218, 41, 'PPL', 'P'),
(84370, 'Whites Pond Crossroad', 33.9824981689453, 0.59310648110104, -80.3288879394531, -1.40200357900902, 218, 48, 'PPL', 'P'),
(107562, 'Whites Store', 37.0080604553223, 0.645912504722485, -81.6561126708984, -1.42516802048664, 218, 53, 'PPL', 'P'),
(168931, 'Whites Valley', 41.7019386291504, 0.727836133543285, -75.3702774047852, -1.31545949885499, 218, 45, 'PPL', 'P'),
(14857, 'Whites Village', 39.8191719055176, 0.694975655168906, -75.4555587768555, -1.31694793958823, 218, 10, 'PPL', 'P'),
(91842, 'Whites Village', 35.9355583190918, 0.627193811210591, -83.8697204589844, -1.46380276473653, 218, 50, 'PPL', 'P'),
(206478, 'Whites Way', 40.7052803039551, 0.710441164251214, -112.072219848633, -1.95602923637758, 218, 52, 'PPL', 'P'),
(62312, 'Whitesand', 31.601110458374, 0.551543424785041, -89.918327331543, -1.56937086982143, 218, 30, 'PPL', 'P'),
(91843, 'Whitesand', 36.0491714477539, 0.629176734379237, -82.8211135864258, -1.44550112225134, 218, 50, 'PPL', 'P'),
(71568, 'Whitesbog', 39.959171295166, 0.697419105469054, -74.5097198486328, -1.30043993609721, 218, 37, 'PPL', 'P'),
(6799, 'Whitesboro', 34.163330078125, 0.596262593308893, -86.0694427490234, -1.50219516132722, 218, 2, 'PPL', 'P'),
(71564, 'Whitesboro', 39.038890838623, 0.681357181460623, -74.8572235107422, -1.30650501916376, 218, 37, 'PPL', 'P'),
(77679, 'Whitesboro', 34.6925010681152, 0.60549836939026, -94.8850021362305, -1.65605569803907, 218, 42, 'PPL', 'P'),
(99086, 'Whitesboro', 33.6561088562012, 0.587409912950333, -96.9066696166992, -1.69134045195375, 218, 51, 'PPL', 'P'),
(153794, 'Whitesboro', 43.121940612793, 0.752619843542699, -75.2919387817383, -1.31409223195134, 218, 40, 'PPL', 'P'),
(186135, 'Whitesboro', 39.2147216796875, 0.684426008563748, -123.763328552246, -2.1600775764642, 218, 6, 'PPL', 'P'),
(6792, 'Whitesburg', 34.5763893127441, 0.603471836958765, -86.563606262207, -1.51081994167549, 218, 2, 'PPL', 'P'),
(26030, 'Whitesburg', 33.4938888549805, 0.584578639816443, -84.9138870239258, -1.48202690923399, 218, 13, 'PPL', 'P'),
(38865, 'Whitesburg', 37.1183280944824, 0.647837038084231, -82.8269424438477, -1.44560285500498, 218, 21, 'PPL', 'P'),
(91844, 'Whitesburg', 36.271671295166, 0.633060089301763, -83.1399993896484, -1.45106672945544, 218, 50, 'PPL', 'P'),
(168929, 'Whitesburg', 40.7430610656738, 0.711100562937118, -79.3977813720703, -1.38575270372125, 218, 45, 'PPL', 'P'),
(6793, 'Whitesburg Estates', 34.6333312988281, 0.604465662098555, -86.5769424438477, -1.51105270195477, 218, 2, 'PPL', 'P'),
(107563, 'Whiteshop Estates', 38.4530601501465, 0.671132507087481, -78.0622177124023, -1.36244272049006, 218, 53, 'PPL', 'P'),
(6794, 'Whiteside', 34.6333312988281, 0.604465662098555, -86.9513931274414, -1.51758809926982, 218, 2, 'PPL', 'P'),
(34414, 'Whiteside', 38.0074996948242, 0.663356010125423, -98.0147171020508, -1.71067952884158, 218, 20, 'PPL', 'P'),
(58273, 'Whiteside', 39.1852798461914, 0.683912151631417, -91.0166702270508, -1.58854056966393, 218, 29, 'PPL', 'P'),
(91845, 'Whiteside', 34.9872207641602, 0.610642198456721, -85.4977798461914, -1.49221776146129, 218, 50, 'PPL', 'P'),
(168930, 'Whiteside', 40.7999992370605, 0.712094321497881, -78.3536071777344, -1.36752842606573, 218, 45, 'PPL', 'P'),
(153795, 'Whiteside Corners', 43.0647201538086, 0.751621158133919, -74.091667175293, -1.29314354050067, 218, 40, 'PPL', 'P'),
(6795, 'Whitesides Mill', 33.7383308410645, 0.588844957303722, -85.6580581665039, -1.49501514587031, 218, 2, 'PPL', 'P'),
(201795, 'Whiteson', 45.151668548584, 0.78804527894196, -123.195556640625, -2.15016808720607, 218, 43, 'PPL', 'P'),
(192429, 'Whitestar', 34.1627998352051, 0.596253338824105, -100.951568603516, -1.76193725718428, 218, 51, 'PPL', 'P'),
(70141, 'Whiteston', 36.3250007629395, 0.633990864102746, -76.4902801513672, -1.33500723441422, 218, 33, 'PPL', 'P'),
(26033, 'Whitestone', 34.5602798461914, 0.603190673726679, -84.5116729736328, -1.4750069497586, 218, 13, 'PPL', 'P'),
(153797, 'Whitestone', 40.7944412231445, 0.711997315855175, -73.8188934326172, -1.28838274057799, 218, 40, 'PPL', 'P'),
(107564, 'Whitestone Estates', 38.4297218322754, 0.670725176598754, -78.0780563354492, -1.36271915661121, 218, 53, 'PPL', 'P'),
(193328, 'Whitestone Logging Camp', 58.0711097717285, 1.01353206580372, -135.429718017578, -2.36369448445423, 218, 1, 'PPL', 'P'),
(133721, 'Whitestone Point', 44.1086082458496, 0.769840442362396, -83.5658264160156, -1.45849881310953, 218, 27, 'PPL', 'P'),
(31524, 'Whitestown', 39.9972190856934, 0.698083164686865, -86.345832824707, -1.50701907816773, 218, 19, 'PPL', 'P'),
(168932, 'Whitestown', 40.8766708374023, 0.713432493366619, -80.0422210693359, -1.39700029826909, 218, 45, 'PPL', 'P'),
(6796, 'Whitesville', 34.1716690063477, 0.596408135062466, -86.2427825927734, -1.50522051232555, 218, 2, 'PPL', 'P'),
(14858, 'Whitesville', 38.458610534668, 0.671229379572133, -75.4272232055664, -1.31645339057381, 218, 10, 'PPL', 'P'),
(26031, 'Whitesville', 32.8175010681152, 0.572773445915367, -85.0313873291016, -1.48407767643141, 218, 13, 'PPL', 'P'),
(31525, 'Whitesville', 39.9652786254883, 0.697525698491684, -86.833610534668, -1.51553240522439, 218, 19, 'PPL', 'P'),
(38868, 'Whitesville', 37.6830596923828, 0.657693463857642, -86.8713912963867, -1.51619180391029, 218, 21, 'PPL', 'P'),
(84373, 'Whitesville', 33.1472206115723, 0.578528137556865, -80.0616683959961, -1.39733971815002, 218, 48, 'PPL', 'P'),
(107566, 'Whitesville', 36.9049987792969, 0.644113739143219, -78.8874969482422, -1.3768465604038, 218, 53, 'PPL', 'P'),
(112035, 'Whitesville', 37.9747200012207, 0.662783896544246, -81.529167175293, -1.42295240361775, 218, 58, 'PPL', 'P'),
(139525, 'Whitesville', 40.0611114501953, 0.699198296814309, -94.7191696166992, -1.65316137456638, 218, 29, 'PPL', 'P'),
(146645, 'Whitesville', 40.0680618286133, 0.699319603801962, -74.272216796875, -1.29629472586051, 218, 37, 'PPL', 'P'),
(153799, 'Whitesville', 42.0377807617188, 0.733697684523522, -77.7627792358398, -1.35721653316689, 218, 40, 'PPL', 'P'),
(172789, 'Whitesville', 43.3916702270508, 0.757327513401632, -72.5947189331055, -1.26701686494256, 218, 55, 'PPL', 'P'),
(28973, 'Whitesville (historical)', 37.6811103820801, 0.657659441974716, -88.4638900756836, -1.54398615094301, 218, 18, 'PPL', 'P'),
(179519, 'Whitetail', 32.4102783203125, 0.565666068177191, -110.731391906738, -1.93262737408878, 218, 5, 'PPL', 'P'),
(189817, 'Whitetail', 33.228889465332, 0.579953527951302, -105.555282592773, -1.84228722411695, 218, 38, 'PPL', 'P'),
(197844, 'Whitetail', 48.8950004577637, 0.853378745752111, -105.162780761719, -1.83543677484494, 218, 31, 'PPL', 'P'),
(194058, 'Whitethorn', 40.0238914489746, 0.698548685245411, -123.941940307617, -2.16319493967819, 218, 6, 'PPL', 'P'),
(107567, 'Whitethorne', 37.1997184753418, 0.649257568209679, -80.5647201538086, -1.40611962763179, 218, 53, 'PPL', 'P'),
(107568, 'Whitetop', 36.601390838623, 0.638814780943261, -81.6258316040039, -1.42463951616831, 218, 53, 'PPL', 'P'),
(12830, 'Whitetown', 34.6297187805176, 0.604402611759747, -93.745002746582, -1.63615895521898, 218, 4, 'PPL', 'P'),
(70142, 'Whitetown', 36.5380592346191, 0.637709435932823, -79.4475021362305, -1.38662049476245, 218, 33, 'PPL', 'P'),
(84371, 'Whitetown', 33.8580589294434, 0.590934606653053, -82.2094421386719, -1.43482544154759, 218, 48, 'PPL', 'P'),
(107569, 'Whitetown', 38.4911117553711, 0.67179663288432, -77.7797164916992, -1.35751214404788, 218, 53, 'PPL', 'P'),
(74822, 'Whitetree', 39.2133293151855, 0.684401707218801, -84.4238891601563, -1.47347483318348, 218, 41, 'PPL', 'P'),
(12831, 'Whiteville', 36.3175010681152, 0.633859969735168, -92.477783203125, -1.61404180184004, 218, 4, 'PPL', 'P'),
(18601, 'Whiteville', 29.6177806854248, 0.516927790094246, -81.9930572509766, -1.43104881280575, 218, 12, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(44131, 'Whiteville', 30.7880592346191, 0.537353003943149, -92.1474990844727, -1.60827725650251, 218, 22, 'PPL', 'P'),
(70143, 'Whiteville', 34.3386116027832, 0.599321833032094, -78.7033309936523, -1.37363225812613, 218, 33, 'PPL', 'P'),
(91846, 'Whiteville', 35.3263893127441, 0.616561806348722, -89.1494369506836, -1.55595120108852, 218, 50, 'PPL', 'P'),
(107570, 'Whiteville', 37.6022186279297, 0.656282521112118, -78.1677780151367, -1.36428509533217, 218, 53, 'PPL', 'P'),
(126636, 'Whiteville', 42.0374984741211, 0.733692757675505, -71.1875, -1.24245626126346, 218, 23, 'PPL', 'P'),
(158362, 'Whiteville', 41.711669921875, 0.728005976641805, -83.9763870239258, -1.46566444749655, 218, 41, 'PPL', 'P'),
(26032, 'Whitewater', 33.3586082458496, 0.582217547773006, -84.5025024414063, -1.47484689377709, 218, 13, 'PPL', 'P'),
(31526, 'Whitewater', 39.9447212219238, 0.697166904113823, -84.8311080932617, -1.48058214434263, 218, 19, 'PPL', 'P'),
(34413, 'Whitewater', 37.9647216796875, 0.662609392913819, -97.147216796875, -1.69553879225421, 218, 20, 'PPL', 'P'),
(58274, 'Whitewater', 37.2374992370605, 0.649916966895583, -89.7958297729492, -1.56723288409832, 218, 29, 'PPL', 'P'),
(177031, 'Whitewater', 42.833610534668, 0.747587534346885, -88.7322235107422, -1.54866945287797, 218, 57, 'PPL', 'P'),
(187542, 'Whitewater', 38.9911117553711, 0.680523279144291, -108.452781677246, -1.89285812321452, 218, 7, 'PPL', 'P'),
(189818, 'Whitewater', 32.5813903808594, 0.568652537023605, -108.133331298828, -1.88728266231439, 218, 38, 'PPL', 'P'),
(197845, 'Whitewater', 48.7594413757324, 0.851012793439684, -107.626937866211, -1.87844442960474, 218, 31, 'PPL', 'P'),
(26034, 'Whitewater Estates', 33.1011085510254, 0.577723330275443, -85.158332824707, -1.4862932933003, 218, 13, 'PPL', 'P'),
(70145, 'Whitewater Pines', 35.0875015258789, 0.612392427925121, -82.9858322143555, -1.44837600464808, 218, 33, 'PPL', 'P'),
(26035, 'Whitewater Woods', 33.0563888549805, 0.576942824338967, -85.1636123657227, -1.48638543867402, 218, 13, 'PPL', 'P'),
(99087, 'Whiteway', 31.6427803039551, 0.552270700789228, -97.9713897705078, -1.70992332425005, 218, 51, 'PPL', 'P'),
(99088, 'Whitewing Colonia', 26.1630001068115, 0.456630494063489, -98.1009979248047, -1.71218541327997, 218, 51, 'PPL', 'P'),
(38866, 'Whitewood', 37.2836112976074, 0.650721774177005, -85.4361114501953, -1.49114144490674, 218, 21, 'PPL', 'P'),
(107572, 'Whitewood', 37.2355613708496, 0.649883144749739, -81.8572235107422, -1.42867806680336, 218, 53, 'PPL', 'P'),
(177409, 'Whitewood', 40.1394386291504, 0.700565363980873, -74.8622207641602, -1.30659223768946, 218, 45, 'PPL', 'P'),
(202788, 'Whitewood', 44.461109161377, 0.775992743954643, -103.638061523438, -1.80882540396843, 218, 49, 'PPL', 'P'),
(206480, 'Whitewood Estates', 40.6500015258789, 0.709476367567306, -111.976936340332, -1.95436622543488, 218, 52, 'PPL', 'P'),
(99089, 'Whitewright', 33.5127792358398, 0.584908339159395, -96.392219543457, -1.68236160433855, 218, 51, 'PPL', 'P'),
(6797, 'Whitfield', 32.3652801513672, 0.564880701971726, -88.0902786254883, -1.53746540101396, 218, 2, 'PPL', 'P'),
(18603, 'Whitfield', 30.8647193908691, 0.538690976074805, -87.0188903808594, -1.51876614857802, 218, 12, 'PPL', 'P'),
(26036, 'Whitfield', 33.0769386291504, 0.577301485558774, -84.9480590820313, -1.48262332416012, 218, 13, 'PPL', 'P'),
(31528, 'Whitfield', 38.6186103820801, 0.674021903712163, -86.9127807617188, -1.51691418635598, 218, 19, 'PPL', 'P'),
(38867, 'Whitfield', 38.0961112976074, 0.664902574349459, -85.4705581665039, -1.49174265352282, 218, 21, 'PPL', 'P'),
(62314, 'Whitfield', 32.235279083252, 0.562611755302006, -90.0719375610352, -1.57205187409081, 218, 30, 'PPL', 'P'),
(74823, 'Whitfield', 39.6733283996582, 0.692430205799008, -84.2761077880859, -1.47089556166774, 218, 41, 'PPL', 'P'),
(91847, 'Whitfield', 35.7830581665039, 0.624532181438138, -87.6188888549805, -1.52923809745837, 218, 50, 'PPL', 'P'),
(107571, 'Whitfield', 36.5469398498535, 0.637864431908266, -79.4727783203125, -1.38706164739702, 218, 53, 'PPL', 'P'),
(153800, 'Whitfield', 41.8141708374023, 0.729794955104065, -74.2247161865234, -1.29546568381316, 218, 40, 'PPL', 'P'),
(168933, 'Whitfield', 40.3358306884766, 0.703993052040887, -76.0063934326172, -1.32656181796536, 218, 45, 'PPL', 'P'),
(18604, 'Whitfield Estates', 27.4097194671631, 0.478389851749982, -82.5694427490234, -1.44110863750742, 218, 12, 'PPL', 'P'),
(26038, 'Whitfield Farms', 33.4066696166992, 0.583056376937353, -84.5561065673828, -1.47578246226803, 218, 13, 'PPL', 'P'),
(601, 'Whitford', 31.8325004577637, 0.555581942130578, -92.7249984741211, -1.61835652228013, 218, 22, 'PPL', 'P'),
(168934, 'Whitford', 40.0144386291504, 0.698383702415881, -75.6380615234375, -1.32013321341002, 218, 45, 'PPL', 'P'),
(201796, 'Whitford', 45.4722213745117, 0.793639981180971, -122.772216796875, -2.14277941307776, 218, 43, 'PPL', 'P'),
(58276, 'Whitham', 39.5511093139648, 0.690297080344882, -93.1977767944336, -1.62660806060163, 218, 29, 'PPL', 'P'),
(192430, 'Whitharral', 33.7374992370605, 0.588830443075781, -102.326667785645, -1.78593726545391, 218, 51, 'PPL', 'P'),
(34415, 'Whiting', 39.5897216796875, 0.690970993258727, -95.6125030517578, -1.6687529843263, 218, 20, 'PPL', 'P'),
(58277, 'Whiting', 36.788890838623, 0.64208727329075, -89.373893737793, -1.55986871105203, 218, 29, 'PPL', 'P'),
(71565, 'Whiting', 39.9544410705566, 0.697336547475261, -74.3788909912109, -1.29815654177858, 218, 37, 'PPL', 'P'),
(118456, 'Whiting', 42.127498626709, 0.735263556665461, -96.149169921875, -1.67811958819622, 218, 16, 'PPL', 'P'),
(124015, 'Whiting', 41.6797218322754, 0.727448377288569, -87.4944381713867, -1.5270660232733, 218, 19, 'PPL', 'P'),
(129327, 'Whiting', 44.790828704834, 0.78174743559614, -67.1761093139648, -1.17244428620832, 218, 26, 'PPL', 'P'),
(172794, 'Whiting', 43.8638916015625, 0.765569331185154, -73.2008285522461, -1.27759547342457, 218, 55, 'PPL', 'P'),
(177035, 'Whiting', 44.4936103820801, 0.77655999726683, -89.5586090087891, -1.56309260070962, 218, 57, 'PPL', 'P'),
(209828, 'Whiting', 42.0122184753418, 0.733251538461906, -104.959999084473, -1.83189756691428, 218, 59, 'PPL', 'P'),
(91848, 'Whiting (historical)', 36.3333282470703, 0.634136206119237, -82.0541687011719, -1.43211540882233, 218, 50, 'PPL', 'P'),
(172792, 'Whitingham', 42.7891693115234, 0.746811888679399, -72.8855590820313, -1.2720929831383, 218, 55, 'PPL', 'P'),
(114289, 'Whitings Corner', 41.7872200012207, 0.72932457427653, -72.7666702270508, -1.27001798117497, 218, 8, 'PPL', 'P'),
(126637, 'Whitinsville', 42.1111106872559, 0.734977533164387, -71.6666717529297, -1.25081938603464, 218, 23, 'PPL', 'P'),
(197846, 'Whitlash', 48.9083290100098, 0.853611372873329, -111.252220153809, -1.94171754183755, 218, 31, 'PPL', 'P'),
(107573, 'Whitley', 36.8852806091309, 0.643769592151353, -76.7597198486328, -1.33970984426709, 218, 53, 'PPL', 'P'),
(44132, 'Whitley (historical)', 32.1666717529297, 0.561414331496879, -93.9938888549805, -1.64050283727301, 218, 22, 'PPL', 'P'),
(38869, 'Whitley City', 36.723331451416, 0.640943046128397, -84.4705581665039, -1.47428936100288, 218, 21, 'PPL', 'P'),
(186136, 'Whitley Gardens', 35.6591682434082, 0.622369894370076, -120.50666809082, -2.1032381287928, 218, 6, 'PPL', 'P'),
(70147, 'Whitley Heights', 35.5552787780762, 0.620556681141895, -78.3863906860352, -1.36810060622593, 218, 33, 'PPL', 'P'),
(70148, 'Whitley Place', 35.4263916015625, 0.618307175548133, -78.2636108398438, -1.3659576936548, 218, 33, 'PPL', 'P'),
(107578, 'Whitleys Crossroads', 36.8694381713867, 0.643493089451176, -76.7797164916992, -1.34005885152794, 218, 53, 'PPL', 'P'),
(91849, 'Whitleyville', 36.4452781677246, 0.636090100832001, -85.6719436645508, -1.49525749352951, 218, 50, 'PPL', 'P'),
(91850, 'Whitlock', 36.3708305358887, 0.634790744536151, -88.3569412231445, -1.54211954133498, 218, 50, 'PPL', 'P'),
(107574, 'Whitlock', 38.0661087036133, 0.664378930300122, -78.2447204589844, -1.36562799431185, 218, 53, 'PPL', 'P'),
(12836, 'Whitlock (historical)', 34.5750007629395, 0.603447602192845, -92.5355606079102, -1.6150502077868, 218, 4, 'PPL', 'P'),
(179520, 'Whitlock Cienega', 32.5527801513672, 0.568153194319216, -109.33528137207, -1.90826064853705, 218, 5, 'PPL', 'P'),
(107575, 'Whitlock Estates', 37.4630584716797, 0.653853718197965, -77.3308334350586, -1.34967765675309, 218, 53, 'PPL', 'P'),
(26040, 'Whitlock Farms', 34.0336112976074, 0.593998573487189, -84.0100021362305, -1.46625114188469, 218, 13, 'PPL', 'P'),
(186137, 'Whitlock Place', 39.8352813720703, 0.695256818400991, -122.698608398438, -2.1414947041679, 218, 6, 'PPL', 'P'),
(129329, 'Whitlocks Mill', 45.160831451416, 0.788205201765419, -67.2275009155273, -1.17334123886345, 218, 26, 'PPL', 'P'),
(12837, 'Whitlow', 33.2188911437988, 0.579779024320875, -91.9858322143555, -1.60545563732757, 218, 4, 'PPL', 'P'),
(58279, 'Whitlow', 36.5752792358398, 0.638359047501721, -90.3144378662109, -1.57628430285322, 218, 29, 'PPL', 'P'),
(194057, 'Whitlow', 40.3152809143066, 0.703634390821081, -123.796112060547, -2.1606497566244, 218, 6, 'PPL', 'P'),
(209928, 'Whitlow', 46.7213897705078, 0.815442082602959, -117.149169921875, -2.04463873111503, 218, 56, 'PPL', 'P'),
(12838, 'Whitlow Junction', 33.1997184753418, 0.579444398129906, -91.9652786254883, -1.60509690952874, 218, 4, 'PPL', 'P'),
(34417, 'Whitman', 37.3325004577637, 0.651575050990266, -97.1872177124023, -1.69623693993397, 218, 20, 'PPL', 'P'),
(99090, 'Whitman', 30.2405891418457, 0.527797848268054, -96.242073059082, -1.67974105382591, 218, 51, 'PPL', 'P'),
(112036, 'Whitman', 37.8133316040039, 0.659967137638297, -82.0247192382813, -1.43160141873194, 218, 58, 'PPL', 'P'),
(126638, 'Whitman', 42.0805587768555, 0.734444301735126, -70.9361114501953, -1.23806870336756, 218, 23, 'PPL', 'P'),
(138826, 'Whitman', 44.1533317565918, 0.770621014877898, -91.8058319091797, -1.60231403934766, 218, 28, 'PPL', 'P'),
(141081, 'Whitman', 48.1586112976074, 0.840526330331388, -98.1194381713867, -1.7125072562977, 218, 34, 'PPL', 'P'),
(153801, 'Whitman', 42.1952781677246, 0.736446532821675, -75.3758316040039, -1.31555643791867, 218, 40, 'PPL', 'P'),
(199779, 'Whitman', 42.0419387817383, 0.733770255663227, -101.52278137207, -1.77190680072499, 218, 35, 'PPL', 'P'),
(209829, 'Whitman', 42.8877792358398, 0.748532956533863, -104.114440917969, -1.81713979289166, 218, 59, 'PPL', 'P'),
(91851, 'Whitman (historical)', 36.3122215270996, 0.633767824361452, -84.1069412231445, -1.46794304812522, 218, 50, 'PPL', 'P'),
(112037, 'Whitman Junction', 37.8313903808594, 0.660282322753308, -82.0325012207031, -1.43173723994754, 218, 58, 'PPL', 'P'),
(71566, 'Whitman Park', 39.9319381713867, 0.696943797793502, -75.1158294677734, -1.31101854457923, 218, 37, 'PPL', 'P'),
(71567, 'Whitman Square', 39.7458305358887, 0.69369560679096, -75.0347213745117, -1.30960294130179, 218, 37, 'PPL', 'P'),
(126640, 'Whitmanville', 42.5833282470703, 0.743219284368882, -71.9013900756836, -1.25491599358145, 218, 23, 'PPL', 'P'),
(209173, 'Whitmarsh Junction', 48.4658317565918, 0.845888338870154, -122.53556060791, -2.1386489833851, 218, 56, 'PPL', 'P'),
(107576, 'Whitmell', 36.702220916748, 0.640574597791585, -79.5238876342773, -1.38795367320414, 218, 53, 'PPL', 'P'),
(112039, 'Whitmer', 38.8127784729004, 0.677410776199289, -79.5491714477539, -1.38839495899677, 218, 58, 'PPL', 'P'),
(26042, 'Whitmire', 34.2583312988281, 0.597920677403576, -83.9333267211914, -1.46491290343693, 218, 13, 'PPL', 'P'),
(84374, 'Whitmire', 34.5027809143066, 0.60218712804891, -81.6116714477539, -1.42439237481915, 218, 48, 'PPL', 'P'),
(112510, 'Whitmire', 35.9441719055176, 0.627344146654126, -94.6636123657227, -1.65219171761348, 218, 42, 'PPL', 'P'),
(12839, 'Whitmore', 35.0694389343262, 0.612077176231083, -90.5680618286133, -1.5807108760591, 218, 4, 'PPL', 'P'),
(158363, 'Whitmore', 41.3908309936523, 0.72240628097575, -82.8925018310547, -1.44674708216733, 218, 41, 'PPL', 'P'),
(194059, 'Whitmore', 40.6294403076172, 0.709117506610418, -121.915557861328, -2.12782789408583, 218, 6, 'PPL', 'P'),
(186139, 'Whitmore Hot Springs', 37.6324996948242, 0.656811025430444, -118.811393737793, -2.07365000960786, 218, 6, 'PPL', 'P'),
(133723, 'Whitmore Lake', 42.4394416809082, 0.740707990039965, -83.7438888549805, -1.46160658894359, 218, 27, 'PPL', 'P'),
(211312, 'Whitmore Village', 21.5138893127441, 0.375488203417005, -158.023056030273, -2.75802262179175, 218, 15, 'PPL', 'P'),
(70149, 'Whitnel', 35.8880615234375, 0.626364835742277, -81.5236129760742, -1.42285546455407, 218, 33, 'PPL', 'P'),
(38871, 'Whitner', 38.1886100769043, 0.666516982602265, -85.6916732788086, -1.49560184025845, 218, 21, 'PPL', 'P'),
(6800, 'Whitney', 33.8677787780762, 0.591104250014491, -86.291389465332, -1.50606886229079, 218, 2, 'PPL', 'P'),
(18605, 'Whitney', 28.8169403076172, 0.502950488718588, -81.9372177124023, -1.43007422900484, 218, 12, 'PPL', 'P'),
(26043, 'Whitney', 33.7222213745117, 0.588563794071637, -83.7119369506836, -1.46104892301133, 218, 13, 'PPL', 'P'),
(62315, 'Whitney', 33.8477783203125, 0.590755176174609, -90.51611328125, -1.57980420286598, 218, 30, 'PPL', 'P'),
(70150, 'Whitney', 35.4722213745117, 0.619107055981538, -80.1447219848633, -1.39878927673135, 218, 33, 'PPL', 'P'),
(84378, 'Whitney', 34.9841690063477, 0.61058893523492, -81.9266662597656, -1.42989007141546, 218, 48, 'PPL', 'P'),
(133724, 'Whitney', 45.8222198486328, 0.79974860693134, -87.3877792358398, -1.52520447367134, 218, 27, 'PPL', 'P'),
(158364, 'Whitney', 40.0130615234375, 0.698359667387043, -80.9288864135742, -1.41247552788938, 218, 41, 'PPL', 'P'),
(168935, 'Whitney', 40.2533302307129, 0.702553147418509, -79.4105606079102, -1.38597574346254, 218, 45, 'PPL', 'P'),
(186138, 'Whitney', 38.833610534668, 0.677774364267112, -121.30583190918, -2.11718616868598, 218, 6, 'PPL', 'P'),
(190930, 'Whitney', 36.0708312988281, 0.629554770095973, -115.08332824707, -2.00858299206477, 218, 39, 'PPL', 'P'),
(192431, 'Whitney', 34.3502807617188, 0.599525498276458, -101.330001831055, -1.76854216300379, 218, 51, 'PPL', 'P'),
(195795, 'Whitney', 42.0658302307129, 0.734187240110906, -111.836936950684, -1.95192277513474, 218, 17, 'PPL', 'P'),
(199781, 'Whitney', 42.7827796936035, 0.746700368808752, -103.255561828613, -1.80214952490588, 218, 35, 'PPL', 'P'),
(209174, 'Whitney', 48.4480590820313, 0.845578147182187, -122.470283508301, -2.13750968307076, 218, 56, 'PPL', 'P'),
(112038, 'Whitney (historical)', 38.0894393920898, 0.664786127630795, -81.0994415283203, -1.41545227619781, 218, 58, 'PPL', 'P'),
(201797, 'Whitney (historical)', 44.6594390869141, 0.7794542541605, -118.28971862793, -2.06454506131504, 218, 43, 'PPL', 'P'),
(18606, 'Whitney Beach', 27.4294395446777, 0.478734032031361, -82.6805572509766, -1.44304795141321, 218, 12, 'PPL', 'P'),
(129333, 'Whitney Corner', 44.1630592346191, 0.770790791397391, -69.3105621337891, -1.20969751564273, 218, 26, 'PPL', 'P'),
(153802, 'Whitney Estates', 42.7599983215332, 0.746302758858003, -73.7825012207031, -1.287747576658, 218, 40, 'PPL', 'P'),
(84375, 'Whitney Heights', 34.9777793884277, 0.610477415364273, -81.9250030517578, -1.42986104295958, 218, 48, 'PPL', 'P'),
(6801, 'Whitney Junction', 33.8747215270996, 0.59122542384409, -86.2994384765625, -1.50620934403829, 218, 2, 'PPL', 'P'),
(153803, 'Whitney Point', 42.3288917541504, 0.738778529830202, -75.9680633544922, -1.32589283189954, 218, 40, 'PPL', 'P'),
(186140, 'Whitney Portal', 36.589168548584, 0.638601461739945, -118.224998474121, -2.06341548153869, 218, 6, 'PPL', 'P'),
(112290, 'Whitney Station', 34.0255584716797, 0.59385802516066, -84.6800003051758, -1.47794481591512, 218, 13, 'PPL', 'P'),
(126641, 'Whitneys', 42.2402801513672, 0.737231965606166, -71.4069366455078, -1.24628615322711, 218, 23, 'PPL', 'P'),
(52770, 'Whitneys Landing', 39.0741691589355, 0.681972904304649, -76.5883331298828, -1.33671858173071, 218, 25, 'PPL', 'P'),
(114290, 'Whitneyville', 41.3441696166992, 0.721591886314403, -72.9127807617188, -1.27256809107677, 218, 8, 'PPL', 'P'),
(129331, 'Whitneyville', 44.7219390869141, 0.780545084942997, -67.5238876342773, -1.17851416296482, 218, 26, 'PPL', 'P'),
(133726, 'Whitneyville', 42.8716697692871, 0.748251793301778, -85.4588928222656, -1.49153905485748, 218, 27, 'PPL', 'P'),
(168936, 'Whitneyville', 41.7730598449707, 0.729077432927371, -77.2008285522461, -1.34740864350434, 218, 45, 'PPL', 'P'),
(172795, 'Whitneyville', 42.7938919067383, 0.746894313515137, -72.7433319091797, -1.26961065068624, 218, 55, 'PPL', 'P'),
(6802, 'Whiton', 34.3555603027344, 0.599617643650175, -86.07861328125, -1.50235521730873, 218, 2, 'PPL', 'P'),
(52771, 'Whiton', 38.2894401550293, 0.668276799450589, -75.3772201538086, -1.31558067268459, 218, 25, 'PPL', 'P'),
(107577, 'Whits Point', 36.5527801513672, 0.637966364398989, -78.3672180175781, -1.36776598003496, 218, 53, 'PPL', 'P'),
(70151, 'Whitsett', 36.0711097717285, 0.629559630364963, -79.5647201538086, -1.38866633511185, 218, 33, 'PPL', 'P'),
(99092, 'Whitsett', 28.6338901519775, 0.499755660806388, -98.2716674804688, -1.71516415895922, 218, 51, 'PPL', 'P'),
(168938, 'Whitsett', 40.1041717529297, 0.699949840873929, -79.7508316040039, -1.39191459269342, 218, 45, 'PPL', 'P'),
(212230, 'Whitshed', 60.4697189331055, 1.05539569313824, -145.957778930664, -2.5474438112381, 218, 1, 'PPL', 'P'),
(6803, 'Whitsitt', 32.600830078125, 0.568991823746482, -87.5922164916992, -1.52877257689983, 218, 2, 'PPL', 'P'),
(6804, 'Whitson', 33.5686111450195, 0.585882789802255, -87.4077835083008, -1.52555361409025, 218, 2, 'PPL', 'P'),
(70152, 'Whitson', 36.0908317565918, 0.629903843935856, -82.3036117553711, -1.43646901141434, 218, 33, 'PPL', 'P'),
(99093, 'Whitson', 31.333610534668, 0.546874670367537, -97.4402770996094, -1.70065365944381, 218, 51, 'PPL', 'P'),
(209175, 'Whitstran', 46.2355613708496, 0.806962777429229, -119.704437255859, -2.08923655936171, 218, 56, 'PPL', 'P'),
(99094, 'Whitt', 32.9561080932617, 0.575192594870568, -98.0186080932617, -1.71074743944938, 218, 51, 'PPL', 'P'),
(70153, 'Whitt Town', 36.3691711425781, 0.634761782659296, -79.0100021362305, -1.37898467928498, 218, 33, 'PPL', 'P'),
(112045, 'Whittaker', 38.0774993896484, 0.664577735275496, -81.3802795410156, -1.4203538241841, 218, 58, 'PPL', 'P'),
(133727, 'Whittaker', 42.128059387207, 0.735273343782467, -83.5997161865234, -1.45909030118763, 218, 27, 'PPL', 'P'),
(179521, 'Whitted Place', 34.7319412231445, 0.606186729953019, -110.959716796875, -1.93661239518592, 218, 5, 'PPL', 'P'),
(118463, 'Whittemore', 43.061939239502, 0.751572622023052, -94.4266662597656, -1.64805622791475, 218, 16, 'PPL', 'P'),
(133728, 'Whittemore', 44.2336082458496, 0.772022103927389, -83.8030624389648, -1.46263936281433, 218, 27, 'PPL', 'P'),
(153804, 'Whittemore', 42.1394386291504, 0.73547194902076, -76.1230621337891, -1.32859807093484, 218, 40, 'PPL', 'P'),
(118458, 'Whitten', 42.2608299255371, 0.737590626825973, -93.0052795410156, -1.62324834972844, 218, 16, 'PPL', 'P'),
(139526, 'Whitten', 40.1772193908691, 0.701224762666777, -94.273063659668, -1.64537535680342, 218, 29, 'PPL', 'P'),
(62316, 'Whitten Town', 34.7769393920898, 0.606972096158483, -89.0591735839844, -1.55437580814569, 218, 30, 'PPL', 'P'),
(91852, 'Whittens Stand (historical)', 35.0736083984375, 0.61214994710787, -87.7986068725586, -1.53237476859027, 218, 50, 'PPL', 'P'),
(126642, 'Whittenton', 41.9249992370605, 0.731729275582817, -71.0944366455078, -1.24083199931462, 218, 23, 'PPL', 'P'),
(126643, 'Whittenton Junction', 41.9166717529297, 0.731583933566326, -71.1144409179688, -1.24118113973353, 218, 23, 'PPL', 'P'),
(91853, 'Whitthorne', 35.9144401550293, 0.626825229715724, -88.6458282470703, -1.54716157106877, 218, 50, 'PPL', 'P'),
(18607, 'Whittier', 27.8727798461914, 0.486471779999559, -81.0063934326172, -1.41382828056508, 218, 12, 'PPL', 'P'),
(70154, 'Whittier', 35.435001373291, 0.618457444412641, -83.3602828979492, -1.45491140196313, 218, 33, 'PPL', 'P'),
(118459, 'Whittier', 42.0947189331055, 0.734691443084285, -91.4625015258789, -1.59632179373692, 218, 16, 'PPL', 'P'),
(144673, 'Whittier', 43.8319396972656, 0.765011665252892, -71.267219543457, -1.24384762977498, 218, 36, 'PPL', 'P'),
(186142, 'Whittier', 33.9791717529297, 0.593048424189276, -118.031936645508, -2.06004591696946, 218, 6, 'PPL', 'P'),
(209177, 'Whittier', 47.2900009155273, 0.825366219247085, -121.316390991211, -2.11737045943342, 218, 56, 'PPL', 'P'),
(212231, 'Whittier', 60.7730598449707, 1.06068999080629, -148.683883666992, -2.59502331464123, 218, 1, 'PPL', 'P'),
(209176, 'Whittier Heights', 47.6911087036133, 0.832366870804576, -122.371391296387, -2.13578368836828, 218, 56, 'PPL', 'P'),
(186141, 'Whittier Junction', 34.0050010681152, 0.593499230782799, -118.064170837402, -2.06060850974974, 218, 6, 'PPL', 'P'),
(146646, 'Whittier Oaks', 40.3236083984375, 0.703779732837572, -74.3216705322266, -1.2971578563698, 218, 37, 'PPL', 'P'),
(38872, 'Whittinghill', 37.2536087036133, 0.650198130127668, -86.5183334350586, -1.51002978178007, 218, 21, 'PPL', 'P'),
(12840, 'Whittington', 34.6141700744629, 0.604131235644668, -92.8883285522461, -1.62120716991095, 218, 4, 'PPL', 'P'),
(28976, 'Whittington', 38.089168548584, 0.66478140051986, -88.9027786254883, -1.55164620118641, 218, 18, 'PPL', 'P'),
(44136, 'Whittington', 31.1772193908691, 0.544145129987287, -92.3313903808594, -1.61148676509022, 218, 22, 'PPL', 'P'),
(52773, 'Whittington Park', 38.4444389343262, 0.670982038485892, -75.5638885498047, -1.31883865080414, 218, 25, 'PPL', 'P'),
(194060, 'Whittington Place', 40.7088890075684, 0.710504148010995, -121.680557250977, -2.123726359691, 218, 6, 'PPL', 'P'),
(38873, 'Whittle', 37.0219383239746, 0.646154719223628, -84.961669921875, -1.48286087812935, 218, 21, 'PPL', 'P'),
(91854, 'Whittle Springs', 36.0175018310547, 0.628623995294991, -83.9158325195313, -1.46460757201795, 218, 50, 'PPL', 'P'),
(107579, 'Whittles', 36.8863906860352, 0.643788966648283, -79.3880615234375, -1.38558306035981, 218, 53, 'PPL', 'P'),
(107580, 'Whittles Mill', 36.8005599975586, 0.642290938535114, -78.1697235107422, -1.36431905063607, 218, 53, 'PPL', 'P'),
(177037, 'Whittlesey', 45.2230606079102, 0.789291305436981, -90.32861328125, -1.57653171051849, 218, 57, 'PPL', 'P'),
(12842, 'Whitton', 35.5113906860352, 0.619790689433361, -90.2683334350586, -1.57547962872986, 218, 4, 'PPL', 'P'),
(99095, 'Whitton', 32.4824981689453, 0.566926542321125, -95.995002746582, -1.67542886338886, 218, 51, 'PPL', 'P'),
(121976, 'Whitton', 42.225830078125, 0.736979764250936, -90.3083267211914, -1.57617764325157, 218, 18, 'PPL', 'P'),
(70155, 'Whitty (historical)', 36.2877807617188, 0.633341252533848, -81.1272201538086, -1.41593710467426, 218, 33, 'PPL', 'P'),
(91855, 'Whitway', 35.976390838623, 0.627906473118296, -88.751106262207, -1.54899901906287, 218, 50, 'PPL', 'P'),
(91856, 'Whitwell', 35.2013893127441, 0.614380144783729, -85.519172668457, -1.49259113664612, 218, 50, 'PPL', 'P'),
(201798, 'Whitwood Court', 45.5855598449707, 0.795618110659655, -122.77082824707, -2.14275517831184, 218, 43, 'PPL', 'P'),
(26044, 'Whitworth', 34.4838905334473, 0.601857428705959, -83.0950012207031, -1.45028136324998, 218, 13, 'PPL', 'P'),
(99096, 'Whon', 31.4902801513672, 0.549609071016776, -99.3058319091797, -1.73321373324723, 218, 51, 'PPL', 'P'),
(38874, 'Whoopflarea', 37.297779083252, 0.650969048684219, -83.5680618286133, -1.4585378284195, 218, 21, 'PPL', 'P'),
(112040, 'Whorley (historical)', 37.773609161377, 0.659273850227522, -81.1497192382813, -1.41632978777699, 218, 58, 'PPL', 'P'),
(6805, 'Whorton', 34.1305618286133, 0.595690679464798, -85.5066680908203, -1.49237289059479, 218, 2, 'PPL', 'P'),
(70156, 'Whortonsville', 35.0955581665039, 0.612533042830677, -76.6288909912109, -1.33742644994845, 218, 33, 'PPL', 'P'),
(179522, 'Why', 32.2686080932617, 0.563193456263106, -112.738059997559, -1.96765033926831, 218, 5, 'PPL', 'P'),
(112041, 'Whyte', 38.9888916015625, 0.680484530150431, -79.831672668457, -1.39332553543894, 218, 58, 'PPL', 'P'),
(138827, 'Whyte', 47.4516716003418, 0.828187905001051, -91.5619430541992, -1.59805737581933, 218, 28, 'PPL', 'P'),
(126644, 'Wianno', 41.6138916015625, 0.726299423015282, -70.3858337402344, -1.22846454552841, 218, 23, 'PPL', 'P'),
(197847, 'Wibaux', 46.9850006103516, 0.82004295970218, -104.187782287598, -1.81841984126961, 218, 31, 'PPL', 'P'),
(186143, 'Wible Orchard', 35.3177795410156, 0.616411537484214, -119.020278930664, -2.07729574398212, 218, 6, 'PPL', 'P'),
(38875, 'Wiborg', 36.8091697692871, 0.642441207399622, -84.4908294677734, -1.47464316195369, 218, 21, 'PPL', 'P'),
(133730, 'Wic-a-te-wah', 44.3558311462402, 0.774155295960543, -86.2238922119141, -1.5048908129826, 218, 27, 'PPL', 'P'),
(153805, 'Wiccopee', 41.538890838623, 0.724990412760481, -73.8466720581055, -1.28886756905444, 218, 40, 'PPL', 'P'),
(121977, 'Wichert', 41.0572204589844, 0.716583678726455, -87.7041702270508, -1.53072653819162, 218, 18, 'PPL', 'P'),
(34418, 'Wichita', 37.6922187805176, 0.657853320102074, -97.3372192382813, -1.69885496044357, 218, 20, 'PPL', 'P'),
(118460, 'Wichita', 41.7333297729492, 0.728384012358541, -94.603889465332, -1.65114935636282, 218, 16, 'PPL', 'P'),
(99098, 'Wichita Falls', 33.9136085510254, 0.591904130447896, -98.4930572509766, -1.71902813938482, 218, 51, 'PPL', 'P'),
(34419, 'Wichita Heights', 37.7811088562012, 0.659404744595099, -97.335563659668, -1.69882606514575, 218, 20, 'PPL', 'P'),
(190929, 'Wichman', 38.5638885498047, 0.673066827566233, -118.978057861328, -2.0765588473085, 218, 39, 'PPL', 'P'),
(112042, 'Wick', 39.4130592346191, 0.68788765192766, -80.9741668701172, -1.41326582094286, 218, 58, 'PPL', 'P'),
(118461, 'Wick', 41.3447189331055, 0.721601473694328, -93.7386093139648, -1.63604736876931, 218, 16, 'PPL', 'P'),
(158372, 'Wick', 41.5341682434082, 0.724907987924743, -80.6474990844727, -1.40756439252316, 218, 41, 'PPL', 'P'),
(168939, 'Wick', 41.0974998474121, 0.717286686675208, -79.9952774047852, -1.39618097675973, 218, 45, 'PPL', 'P'),
(12844, 'Wick Mill', 35.1630592346191, 0.613711158717901, -90.9358291625977, -1.58712962691841, 218, 4, 'PPL', 'P'),
(195796, 'Wickahoney', 42.4599990844727, 0.741066784417826, -115.982498168945, -2.02427646773639, 218, 17, 'PPL', 'P'),
(146647, 'Wickatunk', 40.3499984741211, 0.704240326548101, -74.2483291625977, -1.29587780799185, 218, 37, 'PPL', 'P'),
(179523, 'Wickchoupai', 32.0038909912109, 0.558573271245982, -111.921112060547, -1.95339190795008, 218, 5, 'PPL', 'P'),
(179524, 'Wickenburg', 33.9686088562012, 0.592864066862815, -112.728889465332, -1.96749028328679, 218, 5, 'PPL', 'P'),
(62317, 'Wicker', 32.2186088562012, 0.562320804952915, -89.5430603027344, -1.56282122459455, 218, 30, 'PPL', 'P'),
(99099, 'Wicker', 30.538330078125, 0.532994407924098, -96.3105621337891, -1.68093641368119, 218, 51, 'PPL', 'P'),
(107582, 'Wicker Corner', 37.5777816772461, 0.655856015863541, -77.232780456543, -1.3479663094366, 218, 53, 'PPL', 'P'),
(168941, 'Wickerham Manor', 40.170280456543, 0.701103655416206, -79.9177780151367, -1.39482835724207, 218, 45, 'PPL', 'P'),
(26045, 'Wickerhill', 33.3830604553223, 0.582644319337691, -84.5516662597656, -1.47570496428031, 218, 13, 'PPL', 'P'),
(209178, 'Wickersham', 48.6552810668945, 0.849194853100569, -122.211669921875, -2.13299602449724, 218, 56, 'PPL', 'P'),
(79410, 'Wickerton', 39.7949981689453, 0.69455374387321, -75.8249969482422, -1.32339585206148, 218, 45, 'PPL', 'P'),
(12845, 'Wickes', 34.3030586242676, 0.598701316498106, -94.3380584716797, -1.64650973026974, 218, 4, 'PPL', 'P'),
(58281, 'Wickes', 38.3930587768555, 0.670085285567835, -90.3536071777344, -1.57696793630505, 218, 29, 'PPL', 'P'),
(197849, 'Wickes', 46.3497200012207, 0.808955221398771, -112.102500915527, -1.95655774069591, 218, 31, 'PPL', 'P'),
(192432, 'Wickett', 31.5699996948242, 0.551000439528288, -103.000556945801, -1.79769885009214, 218, 51, 'PPL', 'P'),
(26046, 'Wickford', 33.9458312988281, 0.592466523491094, -84.3272171020508, -1.47178758747486, 218, 13, 'PPL', 'P'),
(52774, 'Wickford', 39.0372200012207, 0.681328019846686, -77.1083297729492, -1.34579423525154, 218, 25, 'PPL', 'P'),
(169675, 'Wickford', 41.5738906860352, 0.725601275335518, -71.4619369506836, -1.24724608964203, 218, 47, 'PPL', 'P'),
(169676, 'Wickford Junction', 41.5791702270508, 0.725693420709234, -71.491943359375, -1.24776980027039, 218, 47, 'PPL', 'P'),
(112044, 'Wickham', 37.7822189331055, 0.65942411909203, -81.2169418334961, -1.41750304339523, 218, 58, 'PPL', 'P'),
(107583, 'Wickham Corner', 37.9152793884277, 0.661746462141606, -77.7936096191406, -1.35775462486514, 218, 53, 'PPL', 'P'),
(107584, 'Wickham Crossing', 37.7783317565918, 0.65935627506326, -77.4069366455078, -1.35100590834677, 218, 53, 'PPL', 'P'),
(168942, 'Wickhaven', 40.1230583190918, 0.700279473637853, -79.773063659668, -1.39230261526424, 218, 45, 'PPL', 'P'),
(31529, 'Wickliffe', 38.3683280944824, 0.66965365373416, -86.64111328125, -1.5121726943512, 218, 19, 'PPL', 'P'),
(38876, 'Wickliffe', 36.9647216796875, 0.645156100393876, -89.0891723632813, -1.554899385616, 218, 21, 'PPL', 'P'),
(44135, 'Wickliffe', 30.6863899230957, 0.53557853970883, -91.3974990844727, -1.59518728711255, 218, 22, 'PPL', 'P'),
(107585, 'Wickliffe', 39.1661109924316, 0.683577592019476, -77.8925018310547, -1.35948061956762, 218, 53, 'PPL', 'P'),
(158367, 'Wickliffe', 41.1025009155273, 0.717373971779936, -80.728889465332, -1.40898492264861, 218, 41, 'PPL', 'P'),
(26048, 'Wicklow Acres', 33.6866683959961, 0.587943277537649, -84.2188873291016, -1.46989687625896, 218, 13, 'PPL', 'P'),
(52775, 'Wicklow Woods', 39.1830596923828, 0.683873402637557, -76.6513900756836, -1.33781913305118, 218, 25, 'PPL', 'P'),
(206482, 'Wicks', 40.3288917541504, 0.703871944790316, -111.636672973633, -1.94842750936206, 218, 52, 'PPL', 'P'),
(186144, 'Wicks Corner', 39.582218170166, 0.690840032312122, -121.619720458984, -2.12266455736439, 218, 6, 'PPL', 'P'),
(6806, 'Wicksburg', 31.2080593109131, 0.544683388133106, -85.6224975585938, -1.49439449617827, 218, 2, 'PPL', 'P'),
(202790, 'Wicksville', 44.0961112976074, 0.769622329469119, -102.58805847168, -1.79049939355927, 218, 49, 'PPL', 'P'),
(31530, 'Wickville', 39.5952796936035, 0.691067998901433, -87.1430587768555, -1.52093329591507, 218, 19, 'PPL', 'P'),
(62318, 'Wickward (historical)', 32.2722206115723, 0.563256506601914, -89.0833282470703, -1.55479738654625, 218, 30, 'PPL', 'P'),
(133731, 'Wickware', 43.6049995422363, 0.761050812342644, -83.0372161865234, -1.44927282414516, 218, 27, 'PPL', 'P'),
(177041, 'Wickware', 45.351390838623, 0.791531090492764, -91.7861099243164, -1.60196982577676, 218, 57, 'PPL', 'P'),
(14859, 'Wickwood', 39.792781829834, 0.694515061458377, -75.5288925170898, -1.31822785480813, 218, 10, 'PPL', 'P'),
(133732, 'Wico', 46.4658317565918, 0.810981753830267, -89.9633331298828, -1.57015636918495, 218, 27, 'PPL', 'P'),
(52776, 'Wicomico', 38.413330078125, 0.670439086518652, -76.8769378662109, -1.34175568461648, 218, 25, 'PPL', 'P'),
(107586, 'Wicomico', 37.290828704834, 0.650847741696566, -76.5097198486328, -1.3353465211371, 218, 53, 'PPL', 'P'),
(107587, 'Wicomico Church', 37.814998626709, 0.659996232673206, -76.378059387207, -1.33304861259053, 218, 53, 'PPL', 'P'),
(52778, 'Wicomico Ridge', 38.4247207641602, 0.670637891494026, -76.9211120605469, -1.34252666975206, 218, 25, 'PPL', 'P'),
(52779, 'Wicomico Shores', 38.3844413757324, 0.669934883545273, -76.8388900756836, -1.34109162539867, 218, 25, 'PPL', 'P'),
(168943, 'Wiconisco', 40.5733299255371, 0.708138195698568, -76.6916732788086, -1.33852220757897, 218, 45, 'PPL', 'P'),
(209830, 'Widdowfield (historical)', 41.6205596923828, 0.726415803154918, -106.413887023926, -1.85727269841277, 218, 59, 'PPL', 'P'),
(84379, 'Wide Awake', 33.0472183227539, 0.576782768357454, -80.1072235107422, -1.39813480489346, 218, 48, 'PPL', 'P'),
(58280, 'Wide Ford', 37.4313888549805, 0.653300979113719, -90.4552764892578, -1.57874240053937, 218, 29, 'PPL', 'P'),
(179525, 'Wide Ruins', 35.4194412231445, 0.61818586856048, -109.495826721191, -1.91106269347798, 218, 5, 'PPL', 'P'),
(187544, 'Wideawake (historical)', 39.8499984741211, 0.695513680288129, -105.521110534668, -1.84169080919083, 218, 7, 'PPL', 'P'),
(112360, 'Widecreek', 37.6111106872559, 0.656437716824642, -83.5313873291016, -1.45789773765149, 218, 21, 'PPL', 'P'),
(187543, 'Widefield', 38.7333297729492, 0.676024134798712, -104.719436645508, -1.82769896029772, 218, 7, 'PPL', 'P'),
(12846, 'Wideman', 36.1863899230957, 0.631571648568518, -92.0086135864258, -1.60585324727832, 218, 4, 'PPL', 'P'),
(112046, 'Widemouth (historical)', 37.4555587768555, 0.653722823830388, -81.2644424438477, -1.41833208544257, 218, 58, 'PPL', 'P'),
(112047, 'Widen', 38.4661102294922, 0.67136027393971, -80.8574981689453, -1.41122956797338, 218, 58, 'PPL', 'P'),
(12847, 'Widener', 35.0233306884766, 0.611272435528688, -90.6847229003906, -1.58274699587052, 218, 4, 'PPL', 'P'),
(107588, 'Widener Valley', 36.6908302307129, 0.640375792816211, -81.7436065673828, -1.42669507705569, 218, 53, 'PPL', 'P'),
(121978, 'Wideview', 41.9386100769043, 0.731966829552052, -88.3816680908203, -1.54255110658963, 218, 18, 'PPL', 'P'),
(107589, 'Widewater', 38.4647216796875, 0.671336039173791, -77.3255615234375, -1.34958564453743, 218, 53, 'PPL', 'P'),
(107590, 'Widewater Beach', 38.4150009155273, 0.670468248132588, -77.3333282470703, -1.34972119943691, 218, 53, 'PPL', 'P'),
(70159, 'Widgen Woods', 35.1072196960449, 0.612736574916987, -75.9416732788086, -1.32543223818901, 218, 33, 'PPL', 'P'),
(52780, 'Widgeon', 38.2511100769043, 0.667607813384761, -75.7694396972656, -1.32242619510858, 218, 25, 'PPL', 'P'),
(168945, 'Widnoon', 40.961109161377, 0.714906220134841, -79.4674987792969, -1.38696950202331, 218, 45, 'PPL', 'P'),
(52789, 'Widow Woods', 38.4136085510254, 0.670443946787641, -76.6500015258789, -1.33779489828526, 218, 25, 'PPL', 'P'),
(6807, 'Widows Creek Station', 34.9258308410645, 0.609570742171155, -85.7605590820313, -1.49680412433257, 218, 2, 'PPL', 'P'),
(13254, 'Widowsville (historical)', 38.9416694641113, 0.679660348372078, -77.0763931274414, -1.34523683563538, 218, 9, 'PPL', 'P'),
(158369, 'Widowville', 40.749439239502, 0.711211883070683, -82.3166732788086, -1.43669697800365, 218, 41, 'PPL', 'P'),
(192865, 'Widtsoe', 37.832218170166, 0.660296770402221, -111.994720458984, -1.95467661685993, 218, 52, 'PPL', 'P'),
(192866, 'Widtsoe Junction', 37.8311080932617, 0.660277395905291, -112.001937866211, -1.95480258437949, 218, 52, 'PPL', 'P'),
(99100, 'Wied', 29.4386100769043, 0.513800673052761, -97.0558319091797, -1.69394382507736, 218, 51, 'PPL', 'P'),
(12848, 'Wiederkehr Village', 35.4730606079102, 0.619121703367533, -93.7644424438477, -1.63649824194186, 218, 4, 'PPL', 'P'),
(99101, 'Wiedeville', 30.2191696166992, 0.527424007030034, -96.3399963378906, -1.68145013745547, 218, 51, 'PPL', 'P'),
(62321, 'Wiehe', 30.4791698455811, 0.531961867079961, -89.495002746582, -1.56198246200922, 218, 30, 'PPL', 'P'),
(99102, 'Wieland', 33.0147895812988, 0.576216780046785, -96.0598983764648, -1.67656150580047, 218, 51, 'PPL', 'P'),
(58282, 'Wien', 39.660831451416, 0.692212092905731, -92.7841720581055, -1.61938929615086, 218, 29, 'PPL', 'P'),
(177038, 'Wien', 44.9019393920898, 0.783686682922909, -90.0244369506836, -1.57122283204347, 218, 57, 'PPL', 'P'),
(26049, 'Wier (historical)', 34.5291709899902, 0.60264772175944, -84.1761093139648, -1.46915025904735, 218, 13, 'PPL', 'P'),
(99103, 'Wiergate', 30.999439239502, 0.541042281001236, -93.7074966430664, -1.63550435022304, 218, 51, 'PPL', 'P'),
(186145, 'Wiest', 33.0586090087891, 0.576981573332828, -115.44750213623, -2.01493902548041, 218, 6, 'PPL', 'P'),
(168948, 'Wiester', 40.4766693115234, 0.70645114972703, -79.6149978637695, -1.38954384669103, 218, 45, 'PPL', 'P'),
(58283, 'Wiffenberg', 38.4602813720703, 0.671258541186069, -91.4313888549805, -1.59577877519066, 218, 29, 'PPL', 'P'),
(194061, 'Wigdon Place', 40.6752815246582, 0.709917586780905, -123.459999084473, -2.15478347853323, 218, 6, 'PPL', 'P'),
(6808, 'Wiggins', 31.3158302307129, 0.546564345521515, -86.32861328125, -1.50671854043872, 218, 2, 'PPL', 'P'),
(62323, 'Wiggins', 30.858060836792, 0.538574762382737, -89.1352767944336, -1.55570405973936, 218, 30, 'PPL', 'P'),
(84380, 'Wiggins', 32.6044387817383, 0.569054807506262, -80.5438919067383, -1.405756106143, 218, 48, 'PPL', 'P'),
(99104, 'Wiggins', 31.7611103057861, 0.554335948925071, -97.1577835083008, -1.6957232161597, 218, 51, 'PPL', 'P'),
(112048, 'Wiggins', 37.6591682434082, 0.657276479409962, -80.8380584716797, -1.41089028125051, 218, 58, 'PPL', 'P'),
(194478, 'Wiggins', 40.2305603027344, 0.702155737204842, -104.072219848633, -1.81640289621804, 218, 7, 'PPL', 'P'),
(52781, 'Wiggins Corner', 38.8877792358398, 0.67871978645409, -76.3502807617188, -1.33256378411408, 218, 25, 'PPL', 'P'),
(179526, 'Wiggins Crossing', 34.5166702270508, 0.602429542287135, -110.987777709961, -1.93710215051039, 218, 5, 'PPL', 'P'),
(70162, 'Wiggins Crossroads', 36.5180587768555, 0.637360362092941, -76.6374969482422, -1.33757665223393, 218, 33, 'PPL', 'P'),
(14860, 'Wiggins Mill', 39.4033317565918, 0.687717875408168, -75.7052764892578, -1.3213063358702, 218, 10, 'PPL', 'P'),
(70161, 'Wiggins Mill', 35.6894416809082, 0.622898265530348, -77.9469375610352, -1.3604307022865, 218, 33, 'PPL', 'P'),
(6809, 'Wigginsville', 34.7994384765625, 0.607364779261215, -86.9124984741211, -1.51690925950796, 218, 2, 'PPL', 'P'),
(99105, 'Wigginsville', 30.2580604553223, 0.528102780212868, -95.3369369506836, -1.66394344855567, 218, 51, 'PPL', 'P'),
(74824, 'Wiggonsville', 38.9294395446777, 0.679446896010709, -84.0944366455078, -1.46772480207389, 218, 41, 'PPL', 'P'),
(107591, 'Wightman', 36.7900009155273, 0.64210664778768, -78.3030624389648, -1.36664625395464, 218, 53, 'PPL', 'P'),
(118462, 'Wightman', 42.2324981689453, 0.737096144390572, -94.6094436645508, -1.6512462954265, 218, 16, 'PPL', 'P'),
(169677, 'Wightmans Corner', 41.6199989318848, 0.726406016037912, -71.5363922119141, -1.24854557909593, 218, 47, 'PPL', 'P'),
(158370, 'Wightmans Grove', 41.4225006103516, 0.722959020059996, -83.0519409179688, -1.44952981919036, 218, 41, 'PPL', 'P'),
(6810, 'Wiginton', 34.2866706848145, 0.598415292997031, -87.8758316040039, -1.53372259441796, 218, 2, 'PPL', 'P'),
(74825, 'Wigner (historical)', 38.7847213745117, 0.67692108745385, -82.3333282470703, -1.43698766203663, 218, 41, 'PPL', 'P'),
(168946, 'Wigwam', 41.9977798461914, 0.732999536843758, -78.4627838134766, -1.36943391782568, 218, 45, 'PPL', 'P'),
(187545, 'Wigwam', 38.5394401550293, 0.672640122580575, -104.63500213623, -1.82622530010852, 218, 7, 'PPL', 'P'),
(126645, 'Wigwam Beach', 41.6230583190918, 0.726459412417768, -70.8597183227539, -1.23673539176781, 218, 23, 'PPL', 'P'),
(168947, 'Wigwam Lake Estates', 41.0074996948242, 0.715715887685253, -75.2633285522461, -1.31359288924695, 218, 45, 'PPL', 'P'),
(179527, 'Wigwam Villa Mobile Home Park', 33.4686088562012, 0.584137420602844, -112.089721679688, -1.95633470095462, 218, 5, 'PPL', 'P'),
(112049, 'Wikel', 37.5119400024414, 0.654706861853172, -80.6477813720703, -1.40756931937118, 218, 58, 'PPL', 'P'),
(179528, 'Wikieup', 34.7033309936523, 0.605687387248629, -113.610557556152, -1.98287829438138, 218, 5, 'PPL', 'P'),
(26050, 'Wikle Store', 34.7652816772461, 0.606768630651201, -83.5930633544922, -1.4589741873641, 218, 13, 'PPL', 'P'),
(91857, 'Wikles (historical)', 35.9866714477539, 0.62808590359674, -86.8041687011719, -1.51501854829206, 218, 50, 'PPL', 'P'),
(52783, 'Wil-e-lew', 38.3936080932617, 0.670094872947759, -75.4572219848633, -1.31697696804412, 218, 25, 'PPL', 'P'),
(52782, 'Wil-Mar Acres', 39.625560760498, 0.691596503219759, -76.8430633544922, -1.34116446285449, 218, 25, 'PPL', 'P'),
(70167, 'Wil-Mar Park', 35.4247207641602, 0.618278013934196, -80.601936340332, -1.40676917262166, 218, 33, 'PPL', 'P'),
(168949, 'Wila', 40.4838905334473, 0.706577183825618, -77.1738891601563, -1.34693846241389, 218, 45, 'PPL', 'P'),
(58284, 'Wila (historical)', 36.6166687011719, 0.639081429947405, -89.783332824707, -1.56701477120504, 218, 29, 'PPL', 'P'),
(187546, 'Wiladel', 39.7430610656738, 0.693647270417175, -103.009437561035, -1.79785384606758, 218, 7, 'PPL', 'P'),
(168956, 'Wilawana', 41.9874992370605, 0.732820106365314, -76.6175003051758, -1.33722764497308, 218, 45, 'PPL', 'P'),
(70163, 'Wilbanks', 35.7477798461914, 0.623916458594112, -77.7716674804688, -1.35737166230038, 218, 33, 'PPL', 'P'),
(26051, 'Wilbanks Circle', 33.916389465332, 0.591952666558763, -84.783332824707, -1.47974830860532, 218, 13, 'PPL', 'P'),
(26052, 'Wilbanks Corner', 34.4936103820801, 0.602027072067397, -83.5666732788086, -1.45851359365358, 218, 13, 'PPL', 'P'),
(70164, 'Wilbar', 36.2444381713867, 0.632584781626211, -81.2983322143555, -1.41892357352068, 218, 33, 'PPL', 'P'),
(52784, 'Wilber', 39.2138900756836, 0.684411494335807, -77.2986068725586, -1.34911519713086, 218, 25, 'PPL', 'P'),
(133733, 'Wilber', 44.389720916748, 0.774746784038649, -83.4877777099609, -1.45713660621195, 218, 27, 'PPL', 'P'),
(143390, 'Wilber', 40.4813919067383, 0.706533574562768, -96.9602813720703, -1.69227615360275, 218, 35, 'PPL', 'P'),
(52785, 'Wilber Woods', 39.314998626709, 0.686176171453121, -77.517219543457, -1.35293070802462, 218, 25, 'PPL', 'P'),
(74828, 'Wilberforce', 39.7161102294922, 0.693176889589639, -83.8777770996094, -1.46394337964208, 218, 41, 'PPL', 'P'),
(121979, 'Wilbern', 40.9466705322266, 0.714654218516692, -89.3236083984375, -1.55899106631479, 218, 18, 'PPL', 'P'),
(138828, 'Wilbert', 43.5438919067383, 0.759984282905095, -94.5391693115234, -1.65001977658646, 218, 28, 'PPL', 'P'),
(44138, 'Wilbert (historical)', 30.4513893127441, 0.531477005313999, -91.3172225952148, -1.59378619806306, 218, 22, 'PPL', 'P'),
(28977, 'Wilberton', 38.8794403076172, 0.678574244700517, -88.9513931274414, -1.55249468430971, 218, 18, 'PPL', 'P'),
(107592, 'Wilberts Corner', 37.9799995422363, 0.662876041917963, -76.6399993896484, -1.33762032807581, 218, 53, 'PPL', 'P'),
(12849, 'Wilbeth', 35.5344390869141, 0.620192959916018, -90.3397216796875, -1.57672558864585, 218, 4, 'PPL', 'P'),
(70165, 'Wilbon', 35.5974998474121, 0.62129357781552, -78.8372192382813, -1.37596904882462, 218, 33, 'PPL', 'P'),
(197850, 'Wilborn', 46.8836097717285, 0.81827335573685, -112.342216491699, -1.96074156676842, 218, 31, 'PPL', 'P'),
(192433, 'Wilbourn Addition Colonia', 31.5820007324219, 0.551209897148022, -106.263000488281, -1.85463923156885, 218, 51, 'PPL', 'P'),
(70166, 'Wilbourns', 36.4888916015625, 0.636851298850573, -78.7438888549805, -1.37434012634388, 218, 33, 'PPL', 'P'),
(126646, 'Wilbraham', 42.1236114501953, 0.735195712636692, -72.4319381713867, -1.26417580469166, 218, 23, 'PPL', 'P'),
(74827, 'Wilbren', 39.7252807617188, 0.693336945571153, -82.1780624389648, -1.43427776246942, 218, 41, 'PPL', 'P'),
(31532, 'Wilbur', 39.5161094665527, 0.689686217769845, -86.4886093139648, -1.50951099799972, 218, 19, 'PPL', 'P'),
(38878, 'Wilbur', 37.9861106872559, 0.662982701519621, -82.7847213745117, -1.44486595833136, 218, 21, 'PPL', 'P'),
(91858, 'Wilbur', 36.3388900756836, 0.63423327834097, -82.1183319091797, -1.43323526806071, 218, 50, 'PPL', 'P'),
(112050, 'Wilbur', 39.3763885498047, 0.687247627738687, -80.8247222900391, -1.41065752097123, 218, 58, 'PPL', 'P'),
(153806, 'Wilbur', 41.9097213745117, 0.731462626578673, -74.004997253418, -1.2916308650015, 218, 40, 'PPL', 'P'),
(168950, 'Wilbur', 40.1238899230957, 0.700293987865794, -78.908332824707, -1.37721021505066, 218, 45, 'PPL', 'P'),
(201799, 'Wilbur', 43.3211097717285, 0.756096001134552, -123.33943939209, -2.15267931495596, 218, 43, 'PPL', 'P'),
(209179, 'Wilbur', 47.7588882446289, 0.833549846960789, -118.704437255859, -2.07178326684177, 218, 56, 'PPL', 'P'),
(58285, 'Wilbur (historical)', 36.2944412231445, 0.63345749951543, -89.8263931274414, -1.56776631526466, 218, 29, 'PPL', 'P'),
(121980, 'Wilbur Heights', 40.1425018310547, 0.700618826939757, -88.2355575561523, -1.54000099668782, 218, 18, 'PPL', 'P'),
(58286, 'Wilbur Park', 38.5530586242676, 0.672877809707865, -90.309440612793, -1.57619708432752, 218, 29, 'PPL', 'P'),
(186146, 'Wilbur Springs', 39.0394401550293, 0.681366768840547, -122.418609619141, -2.13660780356761, 218, 6, 'PPL', 'P'),
(18608, 'Wilbur-by-the-Sea', 29.1311092376709, 0.508433770955493, -80.9577789306641, -1.41297979744178, 218, 12, 'PPL', 'P'),
(107593, 'Wilburdale', 38.8158302307129, 0.67746403942109, -77.1911087036133, -1.3472390001429, 218, 53, 'PPL', 'P'),
(126648, 'Wilburite Corner', 41.5930595397949, 0.725935834947459, -70.9805603027344, -1.2388444821931, 218, 23, 'PPL', 'P'),
(6811, 'Wilburn', 33.9516716003418, 0.592568455981817, -87.0341720581055, -1.51903286416119, 218, 2, 'PPL', 'P'),
(12850, 'Wilburn', 35.5072212219238, 0.619717918556575, -91.8880615234375, -1.6037492168591, 218, 4, 'PPL', 'P'),
(18609, 'Wilburn', 30.190559387207, 0.526924664325644, -82.5788879394531, -1.44127348717889, 218, 12, 'PPL', 'P'),
(107594, 'Wilburn', 36.8497200012207, 0.64314894245931, -78.2716674804688, -1.36609830856035, 218, 53, 'PPL', 'P'),
(84381, 'Wilburn (historical)', 35.0966682434082, 0.612552417327608, -81.4627838134766, -1.42179379538551, 218, 48, 'PPL', 'P'),
(146648, 'Wilburtha', 40.2519416809082, 0.702528912652589, -74.8327789306641, -1.30607838075713, 218, 37, 'PPL', 'P'),
(77681, 'Wilburton', 34.9186096191406, 0.609444708072567, -95.3088912963867, -1.66345395954732, 218, 42, 'PPL', 'P'),
(168952, 'Wilburton', 40.8180618286133, 0.712409573191919, -76.366943359375, -1.33285460130511, 218, 45, 'PPL', 'P'),
(187968, 'Wilburton', 37.0736083984375, 0.647056532147756, -101.77278137207, -1.77627012385498, 218, 20, 'PPL', 'P'),
(209180, 'Wilburton', 47.603328704834, 0.830834820808481, -122.179718017578, -2.13243835856498, 218, 56, 'PPL', 'P'),
(168953, 'Wilburton Number One', 40.8138885498047, 0.712336735736105, -76.3905563354492, -1.3332667254838, 218, 45, 'PPL', 'P'),
(168954, 'Wilburton Number Two', 40.8180618286133, 0.712409573191919, -76.3666687011719, -1.33284980761515, 218, 45, 'PPL', 'P'),
(58287, 'Wilby', 36.8708305358887, 0.643517390796123, -90.4397201538086, -1.57847089126623, 218, 29, 'PPL', 'P'),
(192434, 'Wilco', 36.0263900756836, 0.628779124428488, -102.292778015137, -1.78534577737581, 218, 51, 'PPL', 'P'),
(62324, 'Wilco Estates', 34.7486114501953, 0.60647768030211, -89.9819412231445, -1.57048114167989, 218, 30, 'PPL', 'P'),
(112051, 'Wilcoe', 37.3811111450195, 0.652423467534538, -81.5641708374023, -1.42356333277181, 218, 58, 'PPL', 'P'),
(6812, 'Wilcox', 31.5083293914795, 0.549924089684218, -86.8763885498047, -1.51627902243599, 218, 2, 'PPL', 'P'),
(18612, 'Wilcox', 29.6108303070068, 0.516806483106593, -82.9216690063477, -1.4472561454097, 218, 12, 'PPL', 'P'),
(91859, 'Wilcox', 35.9355583190918, 0.627193811210591, -89.154167175293, -1.55603375908231, 218, 50, 'PPL', 'P'),
(99107, 'Wilcox', 30.4458293914795, 0.531379966381779, -96.3791732788086, -1.68213390406535, 218, 51, 'PPL', 'P'),
(139527, 'Wilcox', 40.3988914489746, 0.70509366994039, -94.9669418334961, -1.65748581554445, 218, 29, 'PPL', 'P'),
(143389, 'Wilcox', 40.3650016784668, 0.704502181862283, -99.1697235107422, -1.73083819355488, 218, 35, 'PPL', 'P'),
(153807, 'Wilcox', 41.3019409179688, 0.720854856482724, -74.4805603027344, -1.2999310060129, 218, 40, 'PPL', 'P'),
(168955, 'Wilcox', 41.5755615234375, 0.725630436949454, -78.688606262207, -1.37337526308094, 218, 45, 'PPL', 'P'),
(177040, 'Wilcox', 44.9977798461914, 0.785359414403588, -87.8352813720703, -1.53301485935827, 218, 57, 'PPL', 'P'),
(209181, 'Wilcox', 46.810001373291, 0.816988646826995, -117.489440917969, -2.0505775803459, 218, 56, 'PPL', 'P'),
(209831, 'Wilcox', 41.7924995422363, 0.729416719650247, -105.983329772949, -1.8497580567649, 218, 59, 'PPL', 'P'),
(12852, 'Wilcox (historical)', 33.2797203063965, 0.580840693489435, -92.0633316040039, -1.60680825684522, 218, 4, 'PPL', 'P'),
(44137, 'Wilcox (historical)', 30.8199996948242, 0.53791047013833, -91.3869400024414, -1.59500299636512, 218, 22, 'PPL', 'P'),
(18610, 'Wilcox Junction', 29.6113891601563, 0.516816236934085, -82.9402770996094, -1.44758091790464, 218, 12, 'PPL', 'P'),
(189819, 'Wilcox Peak', 33.2808303833008, 0.580860067986365, -108.815826416016, -1.89919444923809, 218, 38, 'PPL', 'P'),
(199782, 'Wilcox Trailer Court', 40.2019386291504, 0.70165619476337, -100.625282287598, -1.75624248666731, 218, 35, 'PPL', 'P'),
(26054, 'Wild (historical)', 34.5552787780762, 0.603103388621952, -83.9277801513672, -1.4648160975313, 218, 13, 'PPL', 'P'),
(168957, 'Wild Acres', 41.2097206115723, 0.719245308498907, -74.9375, -1.30790610821325, 218, 45, 'PPL', 'P'),
(186147, 'Wild Bill Place', 39.2308311462402, 0.684707171795833, -122.780563354492, -2.14292508798938, 218, 6, 'PPL', 'P'),
(38877, 'Wild Cat', 37.2344398498535, 0.649863570515727, -83.6908264160156, -1.46068047467452, 218, 21, 'PPL', 'P'),
(12853, 'Wild Cherry', 36.2638893127441, 0.632924268086169, -92.0566711425781, -1.60669200986364, 218, 4, 'PPL', 'P'),
(186148, 'Wild Crossing', 34.7799987792969, 0.607025492538339, -117.274169921875, -2.04682039268002, 218, 6, 'PPL', 'P'),
(70169, 'Wild Duck Dunes', 36.1980590820313, 0.631775313812881, -75.7663879394531, -1.32237293188678, 218, 33, 'PPL', 'P'),
(26055, 'Wild Fern', 34.2941703796387, 0.598546187364609, -83.7908325195313, -1.46242591045296, 218, 13, 'PPL', 'P'),
(179529, 'Wild Flower', 33.670280456543, 0.587657254036574, -112.080276489258, -1.95616985128314, 218, 5, 'PPL', 'P'),
(209182, 'Wild Goose', 46.5863914489746, 0.813085917407539, -117.917503356934, -2.05804867930996, 218, 56, 'PPL', 'P'),
(52787, 'Wild Goose Landing', 38.5663909912109, 0.67311050340811, -76.6563873291016, -1.33790635157688, 218, 25, 'PPL', 'P'),
(187548, 'Wild Horse', 38.3291702270508, 0.668970220019419, -104.668060302734, -1.82680227395869, 218, 7, 'PPL', 'P'),
(99110, 'Wild Hurst', 31.5233306884766, 0.550185911708887, -95.0180587768555, -1.65837797450962, 218, 51, 'PPL', 'P'),
(18611, 'Wild Island', 27.3724994659424, 0.477740240181084, -81.2038879394531, -1.41727520996397, 218, 12, 'PPL', 'P'),
(52788, 'Wild Lake Estates', 39.4005584716797, 0.687669472455355, -77.0013885498047, -1.34392775880155, 218, 25, 'PPL', 'P'),
(112052, 'Wild Meadow', 37.8638916015625, 0.660849576065495, -80.2383270263672, -1.40042299290206, 218, 58, 'PPL', 'P'),
(99108, 'Wild Peach', 29.0681896209717, 0.507335616479998, -95.6215133666992, -1.66891024398867, 218, 51, 'PPL', 'P'),
(99109, 'Wild Peach Village', 29.0833301544189, 0.507599868639162, -95.6336135864258, -1.66912143266311, 218, 51, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(91860, 'Wild Plum', 35.8841705322266, 0.626296925134479, -85.0027770996094, -1.48357833372702, 218, 50, 'PPL', 'P'),
(141082, 'Wild Rice', 46.7463912963867, 0.815878441547569, -96.8091735839844, -1.68963882517525, 218, 34, 'PPL', 'P'),
(177043, 'Wild Rose', 44.1786117553711, 0.771062234091497, -89.248893737793, -1.55768704948704, 218, 57, 'PPL', 'P'),
(197851, 'Wild Rose (historical)', 48.6394386291504, 0.848918350400392, -106.347221374512, -1.85610916333252, 218, 31, 'PPL', 'P'),
(44139, 'Wilda', 31.298059463501, 0.546254187123062, -92.7397232055664, -1.61861351732532, 218, 22, 'PPL', 'P'),
(107595, 'Wilda', 38.0180587768555, 0.663540300872856, -79.0936126708984, -1.38044395840428, 218, 53, 'PPL', 'P'),
(70170, 'Wildacres', 35.8241691589355, 0.625249703614833, -82.1061096191406, -1.43302194885739, 218, 33, 'PPL', 'P'),
(84382, 'Wildaire', 34.8847198486328, 0.608853219994461, -82.3463897705078, -1.43721562862594, 218, 48, 'PPL', 'P'),
(158371, 'Wildare', 41.3486099243164, 0.721669384302125, -80.811393737793, -1.41042489385001, 218, 41, 'PPL', 'P'),
(186149, 'Wildasin', 33.9888916015625, 0.593218067550714, -118.299171447754, -2.06471004414457, 218, 6, 'PPL', 'P'),
(74829, 'Wildbrook Acres', 39.2427787780762, 0.684915697309186, -84.5202789306641, -1.47515715204408, 218, 41, 'PPL', 'P'),
(44140, 'Wildcat', 32.1386108398438, 0.560924576172413, -91.3622207641602, -1.59457156426852, 218, 22, 'PPL', 'P'),
(112053, 'Wildcat', 38.7533302307129, 0.676373208638594, -80.4383316040039, -1.40391373130088, 218, 58, 'PPL', 'P'),
(168958, 'Wildcat', 41.0252799987793, 0.716026212531274, -79.4800033569336, -1.38718774807464, 218, 45, 'PPL', 'P'),
(192867, 'Wildcat', 39.6508293151855, 0.692037522696276, -110.918327331543, -1.93589001274024, 218, 52, 'PPL', 'P'),
(194479, 'Wildcat', 40.2591705322266, 0.702655079909231, -104.884170532227, -1.83057410901057, 218, 7, 'PPL', 'P'),
(209832, 'Wildcat', 44.6016693115234, 0.778445981371796, -105.675277709961, -1.84438153399819, 218, 59, 'PPL', 'P'),
(12855, 'Wildcat (historical)', 35.2147216796875, 0.614612838483975, -90.4522171020508, -1.57868900415951, 218, 4, 'PPL', 'P'),
(84383, 'Wildcat (historical)', 34.6363906860352, 0.604519058478411, -81.8319396972656, -1.42823678101074, 218, 48, 'PPL', 'P'),
(112054, 'Wildcat (historical)', 38.7444381713867, 0.676218012926069, -80.4555587768555, -1.40421440218795, 218, 58, 'PPL', 'P'),
(107596, 'Wildcat Corner', 38.2802810668945, 0.668116943206157, -77.378059387207, -1.35050190511047, 218, 53, 'PPL', 'P'),
(52790, 'Wildcat Forest', 39.2249984741211, 0.684605372463165, -77.20361328125, -1.34745724619424, 218, 25, 'PPL', 'P'),
(209183, 'Wildcat Lake', 47.6047210693359, 0.830859122153428, -122.765556335449, -2.14266316609617, 218, 56, 'PPL', 'P'),
(6814, 'Wildcat Landing', 31.9650001525879, 0.557894498063149, -88.0919418334961, -1.53749442946984, 218, 2, 'PPL', 'P'),
(77684, 'Wildcat Point', 35.764720916748, 0.624212136054138, -94.9172210693359, -1.65661802450325, 218, 42, 'PPL', 'P'),
(140, 'Wilde Acres', 39.1469383239746, 0.683242965828508, -78.4000015258789, -1.36833816019517, 218, 53, 'PPL', 'P'),
(112055, 'Wildell', 38.711109161377, 0.675636311964969, -79.7808303833008, -1.39243817016373, 218, 58, 'PPL', 'P'),
(511, 'Wilder', 39.0430603027344, 0.681429952337409, -94.8694381713867, -1.65578405560789, 218, 20, 'PPL', 'P'),
(38879, 'Wilder', 39.0563888549805, 0.681662579458627, -84.4869384765625, -1.4745752513459, 218, 21, 'PPL', 'P'),
(84384, 'Wilder', 33.3469390869141, 0.582013882528642, -79.9433288574219, -1.39527430356661, 218, 48, 'PPL', 'P'),
(91861, 'Wilder', 36.2661094665527, 0.63296301708003, -85.0905609130859, -1.48511045030214, 218, 50, 'PPL', 'P'),
(138830, 'Wilder', 43.8266716003418, 0.764919719616257, -95.1972198486328, -1.66150492510354, 218, 28, 'PPL', 'P'),
(144674, 'Wilder', 42.7872200012207, 0.746777866796474, -71.9291687011719, -1.2554008220579, 218, 36, 'PPL', 'P'),
(172796, 'Wilder', 43.672779083252, 0.762233788498857, -72.3091735839844, -1.26203315843664, 218, 55, 'PPL', 'P'),
(195798, 'Wilder', 43.6766700744629, 0.762301699106654, -116.910827636719, -2.04047887349232, 218, 17, 'PPL', 'P'),
(84385, 'Wilder (historical)', 33.3472213745117, 0.582018809376659, -79.9438934326172, -1.39528415726264, 218, 48, 'PPL', 'P'),
(107597, 'Wilder (historical)', 37.0113906860352, 0.645970628213276, -82.2183303833008, -1.43498057068109, 218, 53, 'PPL', 'P'),
(133736, 'Wilder Center', 43.0297203063965, 0.751010295558882, -85.7305603027344, -1.49628054686226, 218, 27, 'PPL', 'P'),
(91862, 'Wilder Chapel', 35.2936096191406, 0.615989692767546, -85.9611129760742, -1.50030445011132, 218, 50, 'PPL', 'P'),
(38880, 'Wilder Park', 38.1952781677246, 0.666633362741901, -85.7652816772461, -1.49688654916831, 218, 21, 'PPL', 'P'),
(186150, 'Wilder Place', 39.8261108398438, 0.695096762419477, -122.630561828613, -2.14030706747978, 218, 6, 'PPL', 'P'),
(52791, 'Wildercroft', 38.9691696166992, 0.680140316579538, -76.8947219848633, -1.34206607604153, 218, 25, 'PPL', 'P'),
(28979, 'Wilderman', 38.4736099243164, 0.671491168307288, -89.9391708374023, -1.56973465762634, 218, 18, 'PPL', 'P'),
(114291, 'Wildermere Beach', 41.1894416809082, 0.718891374390036, -73.0877838134766, -1.27562247053098, 218, 8, 'PPL', 'P'),
(52792, 'Wilderness', 38.2472190856934, 0.667539902776964, -76.5980606079102, -1.3368883582502, 218, 25, 'PPL', 'P'),
(58288, 'Wilderness', 36.788890838623, 0.64208727329075, -91.1919403076172, -1.59159960965005, 218, 29, 'PPL', 'P'),
(107598, 'Wilderness', 38.3255615234375, 0.668907236259638, -77.7261123657227, -1.35657657555694, 218, 53, 'PPL', 'P'),
(209184, 'Wilderness', 47.3800010681152, 0.826937018237041, -122.046943664551, -2.13012100894244, 218, 56, 'PPL', 'P'),
(168959, 'Wilderness Acres', 41.1066703796387, 0.717446742656722, -75.1466674804688, -1.31155676943553, 218, 45, 'PPL', 'P'),
(107599, 'Wilderness Corner', 38.3211097717285, 0.668829538534835, -77.7011108398438, -1.35614021661233, 218, 53, 'PPL', 'P'),
(6815, 'Wilderness Garden', 33.5652809143066, 0.585824666311464, -87.128059387207, -1.52067150717992, 218, 2, 'PPL', 'P'),
(91863, 'Wilderness Shores', 36.1752815246582, 0.63137777044116, -83.4580612182617, -1.45661795558966, 218, 50, 'PPL', 'P'),
(209185, 'Wilderness Village', 47.3894386291504, 0.827101734750462, -122.044441223145, -2.13007733310057, 218, 56, 'PPL', 'P'),
(52793, 'Wilderness Walk', 39.2380599975586, 0.684833339052476, -77.2061080932617, -1.34750078887806, 218, 25, 'PPL', 'P'),
(38881, 'Wilders', 39.0597190856934, 0.681720702949418, -84.4802780151367, -1.47445900436432, 218, 21, 'PPL', 'P'),
(124017, 'Wilders', 41.2666702270508, 0.720239266796752, -86.896110534668, -1.51662323600689, 218, 19, 'PPL', 'P'),
(70171, 'Wilders Grove', 35.7986106872559, 0.624803624132245, -78.5647201538086, -1.37121304259191, 218, 33, 'PPL', 'P'),
(91864, 'Wildersville', 35.7813911437988, 0.624503086403229, -88.3602828979492, -1.54217786456285, 218, 50, 'PPL', 'P'),
(99111, 'Wilderville', 31.1044406890869, 0.542874902015861, -96.8827819824219, -1.6909235340851, 218, 51, 'PPL', 'P'),
(201800, 'Wilderville', 42.3824996948242, 0.739714164900175, -123.465827941895, -2.15488521128687, 218, 43, 'PPL', 'P'),
(129334, 'Wildes Corner', 43.3569412231445, 0.75672137793753, -70.4700012207031, -1.22993354518569, 218, 26, 'PPL', 'P'),
(169679, 'Wildes Corner', 41.7058296203613, 0.727904044151082, -71.418327331543, -1.24648495820248, 218, 47, 'PPL', 'P'),
(129335, 'Wildes District', 43.3624992370605, 0.756818383580236, -70.45361328125, -1.22964752168462, 218, 26, 'PPL', 'P'),
(52794, 'Wildewood', 38.2999992370605, 0.668461090198023, -76.5313873291016, -1.33572469001189, 218, 25, 'PPL', 'P'),
(84386, 'Wildewood', 34.1041717529297, 0.595230085754269, -80.8822174072266, -1.41166100006997, 218, 48, 'PPL', 'P'),
(186151, 'Wildflower', 36.5038909912109, 0.637113087585727, -119.682220458984, -2.088848803107, 218, 6, 'PPL', 'P'),
(77683, 'Wildhorse', 35.9127807617188, 0.626796267838869, -96.8036117553711, -1.68954175295351, 218, 42, 'PPL', 'P'),
(195797, 'Wildhorse', 44.8555603027344, 0.782877215109579, -116.830833435059, -2.03908271129085, 218, 17, 'PPL', 'P'),
(186152, 'Wildhorse Canyon', 34.3880615234375, 0.600184896962362, -117.609169006348, -2.05266722969523, 218, 6, 'PPL', 'P'),
(192435, 'Wildhorse Valley Colonia', 31.5919990539551, 0.55138440077845, -106.209999084473, -1.85371418256421, 218, 51, 'PPL', 'P'),
(38882, 'Wildie', 37.4233283996582, 0.653160297629136, -84.3022232055664, -1.4713513616883, 218, 21, 'PPL', 'P'),
(112056, 'Wilding', 38.9480590820313, 0.679771868242726, -81.686393737793, -1.42569652480496, 218, 58, 'PPL', 'P'),
(91865, 'Wildlife Cove Village', 35.9708290100098, 0.627809400896563, -88.0422210693359, -1.53662663842863, 218, 50, 'PPL', 'P'),
(114292, 'Wildmans Landing', 41.4247207641602, 0.722997769053856, -73.4555587768555, -1.28204135454835, 218, 8, 'PPL', 'P'),
(44141, 'Wildoak', 32.3638916015625, 0.564856467205806, -93.7013931274414, -1.63539782377944, 218, 22, 'PPL', 'P'),
(186153, 'Wildomar', 33.5988883972168, 0.586411227541554, -117.279167175293, -2.04690761120572, 218, 6, 'PPL', 'P'),
(192436, 'Wildorado', 35.2094383239746, 0.614520626531231, -102.199996948242, -1.78372644227498, 218, 51, 'PPL', 'P'),
(121982, 'Wildrose', 41.9275016784668, 0.731772951424695, -88.3322219848633, -1.54168810923839, 218, 18, 'PPL', 'P'),
(199102, 'Wildrose', 48.6305618286133, 0.848763421003976, -103.183891296387, -1.80089863814187, 218, 34, 'PPL', 'P'),
(44142, 'Wilds', 32.4319381713867, 0.566044103893927, -92.1750030517578, -1.608757291289, 218, 22, 'PPL', 'P'),
(138832, 'Wilds', 47.7455596923828, 0.833317219839571, -96.6358337402344, -1.68661347417692, 218, 28, 'PPL', 'P'),
(44143, 'Wildsville', 31.6155605316162, 0.551795626140272, -91.7838897705078, -1.6019310767829, 218, 22, 'PPL', 'P'),
(6816, 'Wildwood', 33.4433288574219, 0.583696201389245, -85.5800018310547, -1.49365280581468, 218, 2, 'PPL', 'P'),
(12857, 'Wildwood', 35.0094413757324, 0.611030021290464, -90.4630584716797, -1.57887822175496, 218, 4, 'PPL', 'P'),
(18613, 'Wildwood', 28.8649997711182, 0.503789284593422, -82.0391693115234, -1.43185362008717, 218, 12, 'PPL', 'P'),
(26060, 'Wildwood', 33.0652809143066, 0.577098020051492, -85.0736083984375, -1.48481457310503, 218, 13, 'PPL', 'P'),
(38884, 'Wildwood', 38.249439239502, 0.667578651770825, -85.5730590820313, -1.49353163198508, 218, 21, 'PPL', 'P'),
(44146, 'Wildwood', 32.0494384765625, 0.559368224831371, -93.6858291625977, -1.63512618134825, 218, 22, 'PPL', 'P'),
(52797, 'Wildwood', 38.3916702270508, 0.670061050801915, -76.5766677856445, -1.33651498306537, 218, 25, 'PPL', 'P'),
(62325, 'Wildwood', 33.6191711425781, 0.586765228229452, -90.2411117553711, -1.57500452079139, 218, 30, 'PPL', 'P'),
(70173, 'Wildwood', 34.7486114501953, 0.60647768030211, -76.8261108398438, -1.34086858565738, 218, 33, 'PPL', 'P'),
(71569, 'Wildwood', 38.9916687011719, 0.68053299968227, -74.8152770996094, -1.3057729161801, 218, 37, 'PPL', 'P'),
(84387, 'Wildwood', 32.9113883972168, 0.574412088934092, -80.0358276367188, -1.39688871181941, 218, 48, 'PPL', 'P'),
(91872, 'Wildwood', 35.8036117553711, 0.624890909236972, -83.8713912963867, -1.46383192635046, 218, 50, 'PPL', 'P'),
(99113, 'Wildwood', 30.523889541626, 0.532742373016436, -94.4413909912109, -1.64831322295994, 218, 51, 'PPL', 'P'),
(107603, 'Wildwood', 37.2433280944824, 0.650018699649224, -79.9611129760742, -1.39558469499166, 218, 53, 'PPL', 'P'),
(121984, 'Wildwood', 42.3427810668945, 0.739020944068427, -87.9980621337891, -1.53585591960917, 218, 18, 'PPL', 'P'),
(124018, 'Wildwood', 41.5947189331055, 0.725964796824313, -85.1894378662109, -1.48683617868851, 218, 19, 'PPL', 'P'),
(129336, 'Wildwood', 44.9058303833008, 0.783754593530706, -69.4647216796875, -1.21238810729203, 218, 26, 'PPL', 'P'),
(133740, 'Wildwood', 42.3663902282715, 0.739433001668089, -86.2947235107422, -1.50612705236061, 218, 27, 'PPL', 'P'),
(138833, 'Wildwood', 47.8905601501465, 0.835847955244446, -93.966667175293, -1.64002772933454, 218, 28, 'PPL', 'P'),
(139528, 'Wildwood', 40.1855583190918, 0.70137030442035, -94.0852813720703, -1.64209793760792, 218, 29, 'PPL', 'P'),
(144675, 'Wildwood', 44.0783309936523, 0.769312004623097, -71.8008270263672, -1.25316083726504, 218, 36, 'PPL', 'P'),
(153809, 'Wildwood', 40.9644393920898, 0.714964343625632, -72.8125, -1.27081786160837, 218, 40, 'PPL', 'P'),
(168961, 'Wildwood', 40.8697204589844, 0.713311186378966, -77.0508270263672, -1.34479062299474, 218, 45, 'PPL', 'P'),
(177045, 'Wildwood', 44.8919410705566, 0.783512179292481, -92.2991714477539, -1.61092443862605, 218, 57, 'PPL', 'P'),
(194062, 'Wildwood', 40.4002799987793, 0.705117904706309, -123.053062438965, -2.1476810942221, 218, 6, 'PPL', 'P'),
(201802, 'Wildwood', 43.7791709899902, 0.764090677568915, -122.824996948242, -2.14370060049881, 218, 43, 'PPL', 'P'),
(206488, 'Wildwood', 41.2547187805176, 0.720030674704372, -111.869171142578, -1.95248536791502, 218, 52, 'PPL', 'P'),
(209188, 'Wildwood', 47.464168548584, 0.828406017894329, -122.673889160156, -2.14106327207131, 218, 56, 'PPL', 'P'),
(62326, 'Wildwood (historical)', 34.3783302307129, 0.600015053863842, -90.4480590820313, -1.57861643301981, 218, 30, 'PPL', 'P'),
(186157, 'Wildwood (historical)', 38.4036102294922, 0.670269443157214, -122.538612365723, -2.1387022466069, 218, 6, 'PPL', 'P'),
(177307, 'Wildwood Acres', 40.0538902282715, 0.699072262715721, -80.6958312988281, -1.40840794879844, 218, 58, 'PPL', 'P'),
(202792, 'Wildwood Addition', 44.0352783203125, 0.768560593721531, -103.274436950684, -1.80247895793272, 218, 49, 'PPL', 'P'),
(52798, 'Wildwood Beach', 39.2536087036133, 0.685104715167555, -76.4238891601563, -1.33384849302393, 218, 25, 'PPL', 'P'),
(107604, 'Wildwood Beach', 37.8063888549805, 0.659845963808698, -76.7405624389648, -1.33937548439223, 218, 53, 'PPL', 'P'),
(71570, 'Wildwood Crest', 38.9747200012207, 0.68023718906419, -74.8338928222656, -1.30609782183309, 218, 37, 'PPL', 'P'),
(26063, 'Wildwood Estates', 32.4936103820801, 0.56712048702751, -83.6938934326172, -1.46073400421243, 218, 13, 'PPL', 'P'),
(91869, 'Wildwood Estates', 36.0424995422363, 0.629060287660573, -86.852783203125, -1.51586703141536, 218, 50, 'PPL', 'P'),
(107605, 'Wildwood Estates', 38.6852798461914, 0.675185505371446, -77.4555587768555, -1.35185452462812, 218, 53, 'PPL', 'P'),
(179530, 'Wildwood Estates', 34.5741691589355, 0.603433087964904, -112.507499694824, -1.9636263028612, 218, 5, 'PPL', 'P'),
(107606, 'Wildwood Farms', 37.1552810668945, 0.648481989121221, -77.3249969482422, -1.34957579084139, 218, 53, 'PPL', 'P'),
(99112, 'Wildwood Forest Colonia', 26.1359996795654, 0.4561592477086, -98.0080032348633, -1.71056234975362, 218, 51, 'PPL', 'P'),
(71572, 'Wildwood Gables', 38.9655609130859, 0.680077332819758, -74.8463897705078, -1.30631593472636, 218, 37, 'PPL', 'P'),
(71573, 'Wildwood Gardens', 39.026668548584, 0.681143862257307, -74.8663864135742, -1.30666494198722, 218, 37, 'PPL', 'P'),
(26064, 'Wildwood Heights', 34.274169921875, 0.598197113524726, -83.8097229003906, -1.46275560979591, 218, 13, 'PPL', 'P'),
(71574, 'Wildwood Highlands Beach', 39.0130615234375, 0.680906374867099, -74.9466705322266, -1.30806616419476, 218, 37, 'PPL', 'P'),
(38883, 'Wildwood Hills', 37.0088882446289, 0.645926952371399, -88.0397186279297, -1.53658296258676, 218, 21, 'PPL', 'P'),
(52799, 'Wildwood Hills', 39.0191688537598, 0.68101296788973, -77.1500015258789, -1.34652154454524, 218, 25, 'PPL', 'P'),
(107607, 'Wildwood Hills', 39.3036117553711, 0.685977433056774, -78.3375015258789, -1.36724732941267, 218, 53, 'PPL', 'P'),
(71575, 'Wildwood Junction', 39.0297203063965, 0.681197125479109, -74.8658294677734, -1.30665522144924, 218, 37, 'PPL', 'P'),
(91870, 'Wildwood Lake', 35.0919418334961, 0.612469925912843, -84.8544387817383, -1.4809893416733, 218, 50, 'PPL', 'P'),
(52800, 'Wildwood Manor', 39.023609161377, 0.681090465877451, -77.1186065673828, -1.34597359915095, 218, 25, 'PPL', 'P'),
(91871, 'Wildwood Mill', 35.7344398498535, 0.623683631735812, -86.004997253418, -1.50107037524082, 218, 50, 'PPL', 'P'),
(70179, 'Wildwood Park', 35.8380584716797, 0.625492117853058, -80.845832824707, -1.41102596930805, 218, 33, 'PPL', 'P'),
(84388, 'Wildwood Park (historical)', 35.1505584716797, 0.613492979245597, -82.4055633544922, -1.43824840249667, 218, 48, 'PPL', 'P'),
(6819, 'Wildwood Shores', 33.0277786254883, 0.576443481634578, -86.5405578613281, -1.51041767119284, 218, 2, 'PPL', 'P'),
(26065, 'Wildwood Springs', 34.0686111450195, 0.594609436062226, -84.4119415283203, -1.47326630767012, 218, 13, 'PPL', 'P'),
(168962, 'Wildwood Springs', 40.5033302307129, 0.706916470548494, -78.601936340332, -1.37186258758178, 218, 45, 'PPL', 'P'),
(158373, 'Wildwood Springs (historical)', 40.0791702270508, 0.699513481929319, -82.9166717529297, -1.447168926884, 218, 41, 'PPL', 'P'),
(121985, 'Wildwood Valley', 42.0622215270996, 0.734124256351125, -88.3736114501953, -1.54241049168407, 218, 18, 'PPL', 'P'),
(144676, 'Wildwood Village', 43.5416717529297, 0.759945533911234, -71.4933319091797, -1.24779403503631, 218, 36, 'PPL', 'P'),
(52802, 'Wildwoods', 38.1755599975586, 0.666289215750036, -75.5347213745117, -1.31832958756177, 218, 25, 'PPL', 'P'),
(58291, 'Wildwoods', 37.9844398498535, 0.662953539905684, -91.3691711425781, -1.59469287125618, 218, 29, 'PPL', 'P'),
(52803, 'Wilelinor Estates', 38.9680595397949, 0.680120942082608, -76.5419387817383, -1.33590884760127, 218, 25, 'PPL', 'P'),
(84389, 'Wiles Crossroads', 33.7097206115723, 0.588345614599333, -80.6669387817383, -1.40790367924604, 218, 48, 'PPL', 'P'),
(52810, 'Wiles Estates', 39.4775009155273, 0.689012371435028, -77.5602798461914, -1.35368225208424, 218, 25, 'PPL', 'P'),
(6821, 'Wiley', 33.5327796936035, 0.585257412999277, -87.4633331298828, -1.52652313788509, 218, 2, 'PPL', 'P'),
(18614, 'Wiley', 28.6736106872559, 0.500448914927649, -80.8288879394531, -1.41073022526899, 218, 12, 'PPL', 'P'),
(26066, 'Wiley', 34.7983283996582, 0.607345404764285, -83.420280456543, -1.45595855690375, 218, 13, 'PPL', 'P'),
(79412, 'Wiley', 39.7222213745117, 0.693283549191297, -76.5436096191406, -1.33593800921521, 218, 45, 'PPL', 'P'),
(107608, 'Wiley', 38.6725006103516, 0.674962465630152, -77.206672668457, -1.34751064257409, 218, 53, 'PPL', 'P'),
(112058, 'Wiley', 39.3302803039551, 0.686442887036292, -81.1255569458008, -1.41590807621838, 218, 58, 'PPL', 'P'),
(133741, 'Wiley', 43.8611106872559, 0.765520795074288, -86.2788925170898, -1.50585074939752, 218, 27, 'PPL', 'P'),
(187549, 'Wiley', 38.1541709899902, 0.665915907144234, -102.719169616699, -1.79278771472592, 218, 7, 'PPL', 'P'),
(74830, 'Wiley (historical)', 39.9333305358887, 0.696968099138449, -84.7641677856445, -1.47941381557241, 218, 41, 'PPL', 'P'),
(26067, 'Wiley Bridge Junction', 34.0825004577637, 0.594851850300451, -84.4269409179688, -1.47352809640528, 218, 13, 'PPL', 'P'),
(209187, 'Wiley City', 46.5516700744629, 0.812479915101491, -120.648063659668, -2.10570594701693, 218, 56, 'PPL', 'P'),
(107609, 'Wiley Court', 37.2949981689453, 0.650920512573352, -80.0652770996094, -1.3974027019098, 218, 53, 'PPL', 'P'),
(12858, 'Wiley Crossing', 35.4605598449707, 0.618903523895229, -90.7399978637695, -1.5837117259754, 218, 4, 'PPL', 'P'),
(112060, 'Wiley Ford', 39.6144409179688, 0.69140242535532, -78.7752838134766, -1.37488807173816, 218, 58, 'PPL', 'P'),
(153810, 'Wiley Shelter', 41.6375007629395, 0.726711480614944, -73.5327835083008, -1.28338918037604, 218, 40, 'PPL', 'P'),
(146649, 'Wileys Corners', 40.2569389343262, 0.702616131178289, -74.0927810668945, -1.29316298157663, 218, 37, 'PPL', 'P'),
(12860, 'Wileys Cove', 35.8375015258789, 0.625482397315079, -92.5736083984375, -1.61571426700461, 218, 4, 'PPL', 'P'),
(153811, 'Wileytown', 42.7133293151855, 0.745488231038603, -75.0372161865234, -1.30964648398562, 218, 40, 'PPL', 'P'),
(112061, 'Wileyville', 39.6305618286133, 0.691683788324487, -80.6736068725586, -1.40802005938567, 218, 58, 'PPL', 'P'),
(153812, 'Wileyville', 42.0275001525879, 0.733518254045078, -77.6969375610352, -1.35606737915652, 218, 40, 'PPL', 'P'),
(195799, 'Wilford', 43.9127807617188, 0.766422607998416, -111.676940917969, -1.94913031757373, 218, 17, 'PPL', 'P'),
(31533, 'Wilfred', 39.1866683959961, 0.683936386397337, -87.3525009155273, -1.52458875082731, 218, 19, 'PPL', 'P'),
(186158, 'Wilfred', 38.3672218322754, 0.669634345816257, -122.71305847168, -2.14174690552313, 218, 6, 'PPL', 'P'),
(70183, 'Wilgrove', 35.2036094665527, 0.61441889377759, -80.670280456543, -1.40796200247391, 218, 33, 'PPL', 'P'),
(74831, 'Wilgus', 38.6216697692871, 0.674075300092019, -82.4574966430664, -1.43915480937368, 218, 41, 'PPL', 'P'),
(168963, 'Wilgus', 40.7838897705078, 0.711813158265796, -78.8858337402344, -1.37681753194792, 218, 45, 'PPL', 'P'),
(14862, 'Wilgus Subdivision', 38.5338897705078, 0.672543250095924, -75.0658264160156, -1.31014582669001, 218, 10, 'PPL', 'P'),
(107610, 'Wilhait', 38.2222213745117, 0.667103610411382, -78.5250015258789, -1.37051982176016, 218, 53, 'PPL', 'P'),
(91873, 'Wilham (historical)', 35.5327796936035, 0.620163998039163, -83.9916687011719, -1.46593116307972, 218, 50, 'PPL', 'P'),
(192437, 'Wilhelm', 35.5283317565918, 0.620086366893387, -101.588607788086, -1.77305568841925, 218, 51, 'PPL', 'P'),
(158374, 'Wilhelm Corner', 41.2655601501465, 0.720219892299822, -80.7747192382813, -1.40978480308201, 218, 41, 'PPL', 'P'),
(52804, 'Wilhelm Park', 39.2747192382813, 0.685473163504367, -76.6641693115234, -1.33804217279248, 218, 25, 'PPL', 'P'),
(58292, 'Wilhelmina', 36.514720916748, 0.637302105444096, -90.182502746582, -1.57398160061669, 218, 29, 'PPL', 'P'),
(112363, 'Wilhelmina', 36.8430595397949, 0.643032695477728, -87.1577835083008, -1.52119029096026, 218, 21, 'PPL', 'P'),
(211313, 'Wilhelmina Rise', 21.2905597686768, 0.371590367556052, -157.797225952148, -2.75408114337843, 218, 15, 'PPL', 'P'),
(44149, 'Wilhite', 32.6166687011719, 0.569268259867632, -92.2802810668945, -1.6105947392831, 218, 22, 'PPL', 'P'),
(91874, 'Wilhite', 36.1194381713867, 0.630403120061218, -85.5069427490234, -1.49237768428475, 218, 50, 'PPL', 'P'),
(58293, 'Wilhite (historical)', 39.0111083984375, 0.680872286405146, -92.5236129760742, -1.61484168227344, 218, 29, 'PPL', 'P'),
(6822, 'Wilhites', 34.310001373291, 0.598822490327704, -86.8927764892578, -1.51656504593707, 218, 2, 'PPL', 'P'),
(38885, 'Wilhoit', 36.8397216796875, 0.642974438828883, -83.3769378662109, -1.45520208599612, 218, 21, 'PPL', 'P'),
(179531, 'Wilhoit', 34.4258308410645, 0.600844095911183, -112.586112976074, -1.96499836345481, 218, 5, 'PPL', 'P'),
(201803, 'Wilhoit', 45.0527801513672, 0.786319350818507, -122.566673278809, -2.13919200193136, 218, 43, 'PPL', 'P'),
(107611, 'Wilhoit (historical)', 38.2708282470703, 0.667951960376627, -78.290283203125, -1.36642321421334, 218, 53, 'PPL', 'P'),
(91875, 'Wilhoit Subdivision', 36.1394386291504, 0.6307521939011, -82.815559387207, -1.44540418318766, 218, 50, 'PPL', 'P'),
(91876, 'Wilhoite Mills', 35.5933303833008, 0.621220806938734, -86.6975021362305, -1.51315686553204, 218, 50, 'PPL', 'P'),
(38886, 'Wilhurst', 37.6327781677246, 0.656815885699433, -83.4147186279297, -1.45586148468202, 218, 21, 'PPL', 'P'),
(52805, 'Wilimot Manor', 39.5155601501465, 0.689676630389921, -76.9775009155273, -1.3435108409329, 218, 25, 'PPL', 'P'),
(118464, 'Wilke', 42.4966697692871, 0.741706808606799, -93.4691696166992, -1.63134475891645, 218, 16, 'PPL', 'P'),
(91877, 'Wilkerson (historical)', 36.0811080932617, 0.62973413399539, -86.6827774047852, -1.51289987048685, 218, 50, 'PPL', 'P'),
(70185, 'Wilkerson Crossroads', 35.7024993896484, 0.623126165540631, -78.1155624389648, -1.36337376160715, 218, 33, 'PPL', 'P'),
(107612, 'Wilkerson Landing', 36.871940612793, 0.643536765293053, -76.5183334350586, -1.33549685658064, 218, 53, 'PPL', 'P'),
(6823, 'Wilkes', 33.454719543457, 0.583895006364619, -86.9300003051758, -1.51721472408499, 218, 2, 'PPL', 'P'),
(91878, 'Wilkes (historical)', 35.7783317565918, 0.624449690023373, -86.9291687011719, -1.51720020985705, 218, 50, 'PPL', 'P'),
(84390, 'Wilkes Crossroads', 34.2058296203613, 0.597004350251507, -80.0391693115234, -1.39694703504729, 218, 48, 'PPL', 'P'),
(168964, 'Wilkes-Barre', 41.2458305358887, 0.719875545570875, -75.8816680908203, -1.32438495009033, 218, 45, 'PPL', 'P'),
(70187, 'Wilkesboro', 36.1458282470703, 0.630863713771747, -81.1608276367188, -1.41652366590435, 218, 33, 'PPL', 'P'),
(201804, 'Wilkesboro', 45.6088905334473, 0.796025307990328, -123.094718933105, -2.14840813719969, 218, 43, 'PPL', 'P'),
(209189, 'Wilkeson', 47.1055603027344, 0.822147123279452, -122.044441223145, -2.13007733310057, 218, 56, 'PPL', 'P'),
(74832, 'Wilkesville', 39.0744400024414, 0.681977631415584, -82.3261108398438, -1.43686169451707, 218, 41, 'PPL', 'P'),
(58294, 'Wilkie', 38.8894386291504, 0.678748748330944, -90.3986129760742, -1.57775343566857, 218, 29, 'PPL', 'P'),
(107613, 'Wilkie (historical)', 37.8852806091309, 0.661222884671296, -79.1600036621094, -1.38160269979458, 218, 53, 'PPL', 'P'),
(12864, 'Wilkins', 35.3305587768555, 0.616634577225509, -93.6138916015625, -1.63387063405233, 218, 4, 'PPL', 'P'),
(84391, 'Wilkins', 32.4847183227539, 0.566965291314986, -80.600830078125, -1.40674986470376, 218, 48, 'PPL', 'P'),
(99114, 'Wilkins', 32.5574989318848, 0.568235552575926, -95.0088882446289, -1.65821791852811, 218, 51, 'PPL', 'P'),
(118465, 'Wilkins', 42.4094390869141, 0.740184345990628, -90.5411071777344, -1.58024042865254, 218, 16, 'PPL', 'P'),
(158375, 'Wilkins', 41.5972213745117, 0.726008472666191, -83.8455581665039, -1.46338105317791, 218, 41, 'PPL', 'P'),
(200281, 'Wilkins', 41.4252815246582, 0.723007556170862, -114.750831604004, -2.00277983089143, 218, 39, 'PPL', 'P'),
(26069, 'Wilkins (historical)', 34.250560760498, 0.597785055925064, -85.0330581665039, -1.48410683804535, 218, 13, 'PPL', 'P'),
(126649, 'Wilkins Four Corners', 42.0105590820313, 0.733222576585052, -71.3061065673828, -1.24452633637878, 218, 23, 'PPL', 'P'),
(158382, 'Wilkins Run', 40.1297187805176, 0.700395720619435, -82.3441696166992, -1.43717687963208, 218, 41, 'PPL', 'P'),
(168968, 'Wilkinsburg', 40.4416694641113, 0.705840287151993, -79.8822174072266, -1.39420770755003, 218, 45, 'PPL', 'P'),
(31534, 'Wilkinson', 39.8858299255371, 0.696139057091107, -85.60888671875, -1.49415694220903, 218, 19, 'PPL', 'P'),
(62334, 'Wilkinson', 31.3902797698975, 0.547863735106879, -90.4094390869141, -1.57794238694791, 218, 30, 'PPL', 'P'),
(70189, 'Wilkinson', 35.6091690063477, 0.621497243059884, -76.6991729736328, -1.33865310194654, 218, 33, 'PPL', 'P'),
(99115, 'Wilkinson', 33.348331451416, 0.582038183873589, -94.9513931274414, -1.65721443942937, 218, 51, 'PPL', 'P'),
(112062, 'Wilkinson', 37.8277816772461, 0.660219338993527, -81.9977798461914, -1.43113123764149, 218, 58, 'PPL', 'P'),
(121986, 'Wilkinson', 42.0066719055176, 0.733154732556282, -88.7827835083008, -1.54955189130517, 218, 18, 'PPL', 'P'),
(138836, 'Wilkinson', 47.2508316040039, 0.824682585795262, -94.6275024414063, -1.65156148054151, 218, 28, 'PPL', 'P'),
(194063, 'Wilkinson', 40.6472206115723, 0.709427831456439, -122.078330993652, -2.13066882117867, 218, 6, 'PPL', 'P'),
(91879, 'Wilkinson Corner', 35.452220916748, 0.618757982141656, -89.3183288574219, -1.55889892094108, 218, 50, 'PPL', 'P'),
(84392, 'Wilkinson Heights', 33.5019416809082, 0.584719188142972, -80.8333282470703, -1.41080772325671, 218, 48, 'PPL', 'P'),
(107614, 'Wilkinson Terrace', 37.4583282470703, 0.653771160204173, -77.5074996948242, -1.35276106466318, 218, 53, 'PPL', 'P'),
(26071, 'Wilkinsons (historical)', 33.0250015258789, 0.576395012102738, -84.1791687011719, -1.46920365542721, 218, 13, 'PPL', 'P'),
(126650, 'Wilkinsonville', 42.1749992370605, 0.736092598712803, -71.720832824707, -1.25176467506356, 218, 23, 'PPL', 'P'),
(6825, 'Wilkinstown', 31.608060836792, 0.551664731772694, -85.9980621337891, -1.50094933456928, 218, 2, 'PPL', 'P'),
(91881, 'Wilkinstown', 35.6286087036133, 0.62183652978276, -88.1538925170898, -1.53857567287241, 218, 50, 'PPL', 'P'),
(84394, 'Wilkinsville', 34.9716682434082, 0.610370755762615, -81.5330581665039, -1.42302031422554, 218, 48, 'PPL', 'P'),
(91880, 'Wilkinsville', 35.4030609130859, 0.61789997821746, -89.8966674804688, -1.5689928341047, 218, 50, 'PPL', 'P'),
(12865, 'Wilkinsville (historical)', 35.6027793884277, 0.621385723189237, -91.1122207641602, -1.59020824113854, 218, 4, 'PPL', 'P'),
(168970, 'Wilko Hill', 40.1969413757324, 0.70156897623767, -79.8563919067383, -1.39375696753554, 218, 45, 'PPL', 'P'),
(84393, 'Wilksburg', 34.7449989318848, 0.606414629963302, -81.3861083984375, -1.42045555693774, 218, 48, 'PPL', 'P'),
(26072, 'Wilkshire Estates', 33.5611114501953, 0.585751895434677, -84.3661117553711, -1.47246642723672, 218, 13, 'PPL', 'P'),
(158376, 'Wilkshire Hills', 40.625560760498, 0.709049795739702, -81.4349975585938, -1.421308833751, 218, 41, 'PPL', 'P'),
(168971, 'Will O Wood', 40.1594390869141, 0.700914437820756, -74.8302764892578, -1.30603470491525, 218, 45, 'PPL', 'P'),
(158377, 'Will-O-Bee on the Lake', 41.6972198486328, 0.727753775286574, -81.4000015258789, -1.420698037755, 218, 41, 'PPL', 'P'),
(187550, 'Will-O-The-Wisp', 39.4613914489746, 0.688731208202943, -105.409721374512, -1.83974670159507, 218, 7, 'PPL', 'P'),
(158378, 'Will-O-Way Beach', 41.6855583190918, 0.727550243200265, -81.4124984741211, -1.42091615064827, 218, 41, 'PPL', 'P'),
(158379, 'Will-O-Wick', 41.6594390869141, 0.727094376600671, -81.4505615234375, -1.42158047618219, 218, 41, 'PPL', 'P'),
(209190, 'Willa', 46.5791702270508, 0.812959883308951, -119.518058776855, -2.08598364124823, 218, 56, 'PPL', 'P'),
(26073, 'Willacoochee', 31.3405609130859, 0.54699597735519, -83.0461120605469, -1.44942808643672, 218, 13, 'PPL', 'P'),
(99116, 'Willacy Acres Colonia', 26.5170001983643, 0.462808961213446, -97.7990036010742, -1.70691461800854, 218, 51, 'PPL', 'P'),
(179532, 'Willaha', 35.7619400024414, 0.624163599943272, -112.263328552246, -1.95936471248485, 218, 5, 'PPL', 'P'),
(38888, 'Willailla', 37.3044395446777, 0.651085295665801, -84.4630584716797, -1.4741584666353, 218, 21, 'PPL', 'P'),
(99118, 'Willamar', 26.4552803039551, 0.461731745842022, -97.6186065673828, -1.70376609580979, 218, 51, 'PPL', 'P'),
(201805, 'Willamette', 45.3444404602051, 0.791409783505111, -122.665832519531, -2.14092265716575, 218, 43, 'PPL', 'P'),
(201806, 'Willamette City', 43.7463912963867, 0.763518563987739, -122.483612060547, -2.13774231019198, 218, 43, 'PPL', 'P'),
(201807, 'Willamette Heights', 45.5352783203125, 0.794740532501446, -122.71639251709, -2.14180509559295, 218, 43, 'PPL', 'P'),
(201808, 'Willamina', 45.0788917541504, 0.786775084260047, -123.484718322754, -2.15521491062983, 218, 43, 'PPL', 'P'),
(18632, 'Willanocha (historical)', 30.2999992370605, 0.528834750038476, -83.9499969482422, -1.46520385378602, 218, 12, 'PPL', 'P'),
(209191, 'Willapa', 46.6749992370605, 0.814632415052548, -123.665000915527, -2.15836143545775, 218, 56, 'PPL', 'P'),
(26074, 'Willard', 33.3072204589844, 0.581320661696894, -83.48388671875, -1.45706869560415, 218, 13, 'PPL', 'P'),
(28980, 'Willard', 37.0863914489746, 0.647279638468078, -89.3522186279297, -1.55949040901918, 218, 18, 'PPL', 'P'),
(34425, 'Willard', 39.0933303833008, 0.682307330758535, -95.9416732788086, -1.67449808858787, 218, 20, 'PPL', 'P'),
(38887, 'Willard', 38.211669921875, 0.666919452822003, -82.897216796875, -1.44682937384502, 218, 21, 'PPL', 'P'),
(58296, 'Willard', 37.3050003051758, 0.651095082782807, -93.4283294677734, -1.63063196385069, 218, 29, 'PPL', 'P'),
(70191, 'Willard', 34.689998626709, 0.605454693548383, -77.9800033569336, -1.36100780929472, 218, 33, 'PPL', 'P'),
(77685, 'Willard', 36.9724998474121, 0.645291855030442, -99.7249984741211, -1.74052956991973, 218, 42, 'PPL', 'P'),
(91883, 'Willard', 36.4472198486328, 0.636123989556872, -86.1833267211914, -1.5041828116068, 218, 50, 'PPL', 'P'),
(107617, 'Willard', 36.9213905334473, 0.64439982922332, -81.2986068725586, -1.41892836721064, 218, 53, 'PPL', 'P'),
(112063, 'Willard', 39.3838882446289, 0.687378522106264, -80.2713928222656, -1.40100009991028, 218, 58, 'PPL', 'P'),
(113403, 'Willard', 44.7350006103516, 0.780773051532308, -90.7191696166992, -1.5833482044866, 218, 57, 'PPL', 'P'),
(118466, 'Willard', 41.0061111450195, 0.715691652919333, -92.5894393920898, -1.6159905699677, 218, 16, 'PPL', 'P'),
(133742, 'Willard', 43.6683311462402, 0.762156157353082, -84.1083297729492, -1.46796728289114, 218, 27, 'PPL', 'P'),
(153814, 'Willard', 42.6822204589844, 0.744945279071363, -76.8688888549805, -1.34161520286898, 218, 40, 'PPL', 'P'),
(158380, 'Willard', 41.0530586242676, 0.716511041007723, -82.7263870239258, -1.44384783184662, 218, 41, 'PPL', 'P'),
(189820, 'Willard', 34.5958290100098, 0.603811123681641, -106.033058166504, -1.85062598096416, 218, 38, 'PPL', 'P'),
(194480, 'Willard', 40.5544395446777, 0.707808496355616, -103.485832214355, -1.80616850130692, 218, 7, 'PPL', 'P'),
(195800, 'Willard', 47.2405586242676, 0.824503288474872, -117.038063049316, -2.04269955036729, 218, 17, 'PPL', 'P'),
(197852, 'Willard', 46.1938896179199, 0.806235468135528, -104.369438171387, -1.82159033454735, 218, 31, 'PPL', 'P'),
(206493, 'Willard', 40.7063903808594, 0.710460538748145, -111.836669921875, -1.95191811460283, 218, 52, 'PPL', 'P'),
(209193, 'Willard', 45.7811088562012, 0.799031084754646, -121.629722595215, -2.12283912757384, 218, 56, 'PPL', 'P'),
(12866, 'Willard (historical)', 35.0475006103516, 0.611694280245357, -91.5683288574219, -1.59816882911095, 218, 4, 'PPL', 'P'),
(107615, 'Willard (historical)', 38.9416694641113, 0.679660348372078, -77.4341735839844, -1.35148128260135, 218, 53, 'PPL', 'P'),
(201810, 'Willard (historical)', 43.6333312988281, 0.761545294778045, -124.126388549805, -2.16641416880388, 218, 43, 'PPL', 'P'),
(107616, 'Willard Park', 36.8849983215332, 0.643764665303336, -76.2563934326172, -1.33092514109535, 218, 53, 'PPL', 'P'),
(52806, 'Willards', 38.3911094665527, 0.670051263684909, -75.3488922119141, -1.31508625682821, 218, 25, 'PPL', 'P'),
(70192, 'Willardville', 36.1388893127441, 0.630742606521176, -78.8572235107422, -1.37631818924353, 218, 33, 'PPL', 'P'),
(186159, 'Willaura Estates', 39.1030616760254, 0.682477173857055, -121.096939086914, -2.11354030115367, 218, 6, 'PPL', 'P'),
(52807, 'Willbrook', 38.6916694641113, 0.675297025242093, -76.9219436645508, -1.34254118398, 218, 25, 'PPL', 'P'),
(179533, 'Willcox', 32.2527809143066, 0.562917219879038, -109.831390380859, -1.91691938418922, 218, 5, 'PPL', 'P'),
(62332, 'Willcox (historical)', 33.9402809143066, 0.592369651006442, -88.4480590820313, -1.54370984797992, 218, 30, 'PPL', 'P'),
(28981, 'Willeford', 37.6561088562012, 0.657223083030106, -88.8516693115234, -1.55075417537929, 218, 18, 'PPL', 'P'),
(91884, 'Willen Gap', 36.4672203063965, 0.636473063396754, -81.7055587768555, -1.42603101783788, 218, 50, 'PPL', 'P'),
(52808, 'Willerburn Acres', 39.0513916015625, 0.681575360932927, -77.1602783203125, -1.34670090844465, 218, 25, 'PPL', 'P'),
(52809, 'Willerle Manor', 38.4972190856934, 0.67190322590695, -76.8233337402344, -1.34082011612554, 218, 25, 'PPL', 'P'),
(138838, 'Willernie', 45.0541687011719, 0.786343585584426, -92.9563903808594, -1.62239507291518, 218, 28, 'PPL', 'P'),
(62333, 'Willet', 33.1202812194824, 0.578057956466411, -90.7508316040039, -1.5839008104128, 218, 30, 'PPL', 'P'),
(153813, 'Willet', 42.4691696166992, 0.74122684039934, -75.9119415283203, -1.32491332125061, 218, 40, 'PPL', 'P'),
(168972, 'Willet', 40.7291717529297, 0.710858148698894, -79.208610534668, -1.38245104975982, 218, 45, 'PPL', 'P'),
(153815, 'Willets', 42.7108306884766, 0.745444621775753, -76.704719543457, -1.33874990785217, 218, 40, 'PPL', 'P'),
(26075, 'Willett', 32.4483299255371, 0.566330193974029, -84.9569396972656, -1.48277832013556, 218, 13, 'PPL', 'P'),
(118467, 'Willett', 41.6972198486328, 0.727753775286574, -95.745002746582, -1.67106554025887, 218, 16, 'PPL', 'P'),
(52811, 'Willett Estates', 39.2247200012207, 0.684600512194176, -77.1208267211914, -1.34601234814481, 218, 25, 'PPL', 'P'),
(91885, 'Willette', 36.4411087036133, 0.636017329955214, -85.8505630493164, -1.49837498990155, 218, 50, 'PPL', 'P'),
(44150, 'Willetts', 31.5083293914795, 0.549924089684218, -91.5272216796875, -1.59745137351328, 218, 22, 'PPL', 'P'),
(74834, 'Willettsville', 39.252498626709, 0.685085340670624, -83.7027816772461, -1.46088913334593, 218, 41, 'PPL', 'P'),
(118468, 'Willey', 41.9791717529297, 0.732674764348823, -94.8219375610352, -1.65495501356055, 218, 16, 'PPL', 'P'),
(194481, 'Willey Lumber Camp', 40.5027809143066, 0.70690688316857, -105.898612976074, -1.84827946972769, 218, 7, 'PPL', 'P'),
(28982, 'Willeys', 39.5969390869141, 0.691096960778288, -89.2333297729492, -1.55741540705585, 218, 18, 'PPL', 'P'),
(70193, 'Willeyton', 36.5050010681152, 0.637132462082658, -76.7330627441406, -1.33924459002465, 218, 33, 'PPL', 'P'),
(58295, 'Willhoit', 36.6833305358887, 0.640244898448633, -92.5066680908203, -1.61454593823439, 218, 29, 'PPL', 'P'),
(112064, 'William', 39.1719398498535, 0.683679324773117, -79.4927825927734, -1.38741078781593, 218, 58, 'PPL', 'P'),
(99119, 'William Penn', 30.3150005340576, 0.529096572063145, -96.2819366455078, -1.6804368046607, 218, 51, 'PPL', 'P'),
(168973, 'William Penn Manor', 40.660831451416, 0.709665385425674, -75.3349990844727, -1.31484377601096, 218, 45, 'PPL', 'P'),
(14863, 'William Ritter Manor', 38.6297187805176, 0.67421578183952, -75.1847229003906, -1.3122209618114, 218, 10, 'PPL', 'P'),
(878, 'Williams', 35.1647186279297, 0.613740120594756, -94.5483322143555, -1.65017969940992, 218, 42, 'PPL', 'P'),
(6828, 'Williams', 32.4500007629395, 0.566359355587965, -88.3058319091797, -1.54122751552786, 218, 2, 'PPL', 'P'),
(26076, 'Williams', 32.1061096191406, 0.560357322860227, -81.2522201538086, -1.41811876623925, 218, 13, 'PPL', 'P'),
(38889, 'Williams', 37.523609161377, 0.654910527097536, -87.8597183227539, -1.53344136460685, 218, 21, 'PPL', 'P'),
(44152, 'Williams', 32.1938896179199, 0.561889372856322, -93.480827331543, -1.63154822442373, 218, 22, 'PPL', 'P'),
(62336, 'Williams', 31.5530605316162, 0.550704795357775, -90.6155624389648, -1.58153991810644, 218, 30, 'PPL', 'P'),
(70196, 'Williams', 35.1858291625977, 0.614108568931568, -77.9741668701172, -1.36090594338303, 218, 33, 'PPL', 'P'),
(84395, 'Williams', 33.0344390869141, 0.57655972861616, -80.8427810668945, -1.41097270608624, 218, 48, 'PPL', 'P'),
(91886, 'Williams', 36.5530586242676, 0.637971224667978, -86.0208282470703, -1.50134667820392, 218, 50, 'PPL', 'P'),
(107618, 'Williams', 37.4011116027832, 0.65277254137442, -76.3280563354492, -1.33217589470131, 218, 53, 'PPL', 'P'),
(112603, 'Williams', 32.021110534668, 0.558873808974998, -99.0180587768555, -1.7281911445894, 218, 51, 'PPL', 'P'),
(118469, 'Williams', 42.4883308410645, 0.741561266853226, -93.5447235107422, -1.6326634231302, 218, 16, 'PPL', 'P'),
(124019, 'Williams', 40.9188919067383, 0.714169390040243, -84.9752807617188, -1.48309843209859, 218, 19, 'PPL', 'P'),
(138840, 'Williams', 48.7683296203613, 0.851167922573181, -94.9550018310547, -1.65727742318915, 218, 28, 'PPL', 'P'),
(146651, 'Williams', 40.0966682434082, 0.699818879927324, -74.1327819824219, -1.29386112925639, 218, 37, 'PPL', 'P'),
(168975, 'Williams', 40.1100006103516, 0.70005157362757, -75.2447204589844, -1.31326811675202, 218, 45, 'PPL', 'P'),
(179534, 'Williams', 35.249439239502, 0.615218774210995, -112.190277099609, -1.95808972411298, 218, 5, 'PPL', 'P'),
(194064, 'Williams', 41.2633285522461, 0.720180943568879, -120.528060913086, -2.10361150397763, 218, 6, 'PPL', 'P'),
(197853, 'Williams', 48.2752799987793, 0.842562583300863, -112.129440307617, -1.95702792178636, 218, 31, 'PPL', 'P'),
(201811, 'Williams', 42.2188911437988, 0.736858657000364, -123.27278137207, -2.15151591303376, 218, 43, 'PPL', 'P'),
(206497, 'Williams', 41.1533317565918, 0.718261137318069, -111.91056060791, -1.9532077503607, 218, 52, 'PPL', 'P'),
(34426, 'Williams (historical)', 37.8166694641113, 0.660025394287142, -99.3333282470703, -1.73369363487566, 218, 20, 'PPL', 'P'),
(143391, 'Williams (historical)', 40.0566711425781, 0.699120798826587, -97.4147186279297, -1.70020757996123, 218, 35, 'PPL', 'P'),
(186161, 'Williams (historical)', 38.4505615234375, 0.671088897824631, -122.877777099609, -2.14462178791987, 218, 6, 'PPL', 'P'),
(177048, 'Williams Bay', 42.5780601501465, 0.743127338732247, -88.5408325195313, -1.54532904992269, 218, 57, 'PPL', 'P'),
(153817, 'Williams Bridge', 40.8772201538086, 0.713442080746543, -73.8666687011719, -1.28921657631529, 218, 40, 'PPL', 'P'),
(200283, 'Williams Cabin', 41.7172203063965, 0.728102849126456, -115.670280456543, -2.01882724067192, 218, 39, 'PPL', 'P'),
(158383, 'Williams Center', 41.4288902282715, 0.723070539930643, -84.6102828979492, -1.47672801761306, 218, 41, 'PPL', 'P'),
(91888, 'Williams Chapel', 35.336669921875, 0.616741236827166, -89.8361129760742, -1.5679359586261, 218, 50, 'PPL', 'P'),
(99122, 'Williams Colonia', 26.2320003509521, 0.457834775508423, -98.2389984130859, -1.71459397616983, 218, 51, 'PPL', 'P'),
(52812, 'Williams Contrivance Estates', 39.1430587768555, 0.683175254957792, -76.9380569458008, -1.34282241379112, 218, 25, 'PPL', 'P'),
(107619, 'Williams Corner', 37.8883285522461, 0.661276081314071, -76.4669418334961, -1.3345999039255, 218, 53, 'PPL', 'P'),
(153818, 'Williams Corner', 42.7127799987793, 0.745478643658678, -77.2536087036133, -1.3483298309254, 218, 40, 'PPL', 'P'),
(168977, 'Williams Corner', 41.8588905334473, 0.73057546104054, -75.831672668457, -1.32351236535917, 218, 45, 'PPL', 'P'),
(44153, 'Williams Corner (historical)', 31.6686096191406, 0.552721507382751, -92.9288864135742, -1.6219150381287, 218, 22, 'PPL', 'P'),
(74835, 'Williams Corners', 39.1725006103516, 0.683689111890123, -84.1608276367188, -1.46888354346418, 218, 41, 'PPL', 'P'),
(153819, 'Williams Corners', 42.8927803039551, 0.74862024163859, -75.6733322143555, -1.32074880309599, 218, 40, 'PPL', 'P'),
(107620, 'Williams Court', 36.7986106872559, 0.642256916652188, -76.3288879394531, -1.33219040892925, 218, 53, 'PPL', 'P'),
(31536, 'Williams Creek', 39.8997192382813, 0.696381471329332, -86.1502838134766, -1.50360610407274, 218, 19, 'PPL', 'P'),
(38890, 'Williams Creek', 38.288330078125, 0.668257424953659, -82.831672668457, -1.44568541299877, 218, 21, 'PPL', 'P'),
(201812, 'Williams Creek (historical)', 42.2708282470703, 0.7377651304564, -123.212501525879, -2.15046383124512, 218, 43, 'PPL', 'P'),
(195801, 'Williams Creek Summit Home Area', 44.1636085510254, 0.770800378777315, -116.120002746582, -2.02667637535272, 218, 17, 'PPL', 'P'),
(70198, 'Williams Cross Roads (historical)', 34.4530601501465, 0.601319337007708, -78.8258285522461, -1.37577024384925, 218, 33, 'PPL', 'P'),
(114294, 'Williams Crossing', 41.6566696166992, 0.727046040226886, -72.1588897705078, -1.25941021107902, 218, 8, 'PPL', 'P'),
(133743, 'Williams Crossing', 46.4402809143066, 0.810535807505734, -86.4391708374023, -1.50864813380654, 218, 27, 'PPL', 'P'),
(70197, 'Williams Crossroads', 35.6555595397949, 0.622306910610296, -78.666389465332, -1.37298750682623, 218, 33, 'PPL', 'P'),
(91890, 'Williams Crossroads', 36.0377807617188, 0.628977929403862, -85.7044372558594, -1.49582461368364, 218, 50, 'PPL', 'P'),
(52813, 'Williams Estates', 39.3405609130859, 0.686622317514736, -76.4052810668945, -1.333523720529, 218, 25, 'PPL', 'P'),
(84405, 'Williams Estates', 34.3305587768555, 0.599181284705565, -79.8927764892578, -1.39439199829746, 218, 48, 'PPL', 'P'),
(107621, 'Williams Fork', 38.2700004577637, 0.667937512727713, -78.5166702270508, -1.37037441316464, 218, 53, 'PPL', 'P'),
(153820, 'Williams Grove', 42.8480606079102, 0.747839735702115, -76.2536087036133, -1.33087653840546, 218, 40, 'PPL', 'P'),
(168978, 'Williams Grove', 40.151668548584, 0.700778816342243, -77.0350036621094, -1.3445144531897, 218, 45, 'PPL', 'P'),
(12867, 'Williams Gulf (historical)', 35.5763893127441, 0.620925129478708, -92.647216796875, -1.61699897591446, 218, 4, 'PPL', 'P'),
(52814, 'Williams Heights', 38.8286094665527, 0.677687079162384, -75.8533325195313, -1.32389040107591, 218, 25, 'PPL', 'P'),
(84397, 'Williams Hill', 33.7238883972168, 0.588592889106546, -79.3152770996094, -1.38431273251984, 218, 48, 'PPL', 'P'),
(12868, 'Williams Junction', 34.8813896179199, 0.608795096503669, -92.7733306884766, -1.61920007855541, 218, 4, 'PPL', 'P'),
(179535, 'Williams Junction', 35.2430610656738, 0.61510745407743, -112.134719848633, -1.95712006716008, 218, 5, 'PPL', 'P'),
(195802, 'Williams Lake Resort', 45.0119400024414, 0.785606555752747, -113.964996337891, -1.98906441811947, 218, 17, 'PPL', 'P'),
(133744, 'Williams Landing', 46.4511108398438, 0.810724825364102, -86.6708297729492, -1.51269134497349, 218, 27, 'PPL', 'P'),
(91891, 'Williams Mill', 36.4038887023926, 0.635367718386317, -83.5811080932617, -1.4587655286927, 218, 50, 'PPL', 'P'),
(107622, 'Williams Mill', 36.6769409179688, 0.640133378577986, -82.5519409179688, -1.44080317293039, 218, 53, 'PPL', 'P'),
(112066, 'Williams Mountain', 38.0258293151855, 0.663675922351368, -81.6694412231445, -1.42540064760786, 218, 58, 'PPL', 'P'),
(121990, 'Williams Park', 42.2541694641113, 0.737474379844391, -88.1833267211914, -1.53908939664669, 218, 18, 'PPL', 'P'),
(18634, 'Williams Point', 28.4480590820313, 0.496512296783321, -80.7630615234375, -1.40958133757473, 218, 12, 'PPL', 'P'),
(91892, 'Williams Springs', 36.3372192382813, 0.634204116727034, -83.5788879394531, -1.45872677969884, 218, 50, 'PPL', 'P'),
(70199, 'Williams Subdivision', 35.0125007629395, 0.61108341767032, -80.5755615234375, -1.40630884522724, 218, 33, 'PPL', 'P'),
(171627, 'Williams Subdivision', 44.9583282470703, 0.784670854103748, -97.165283203125, -1.69585411052727, 218, 49, 'PPL', 'P'),
(91893, 'Williams Subdivision)', 36.1736106872559, 0.631348608827224, -82.7838897705078, -1.44485144410341, 218, 50, 'PPL', 'P'),
(168979, 'Williams Valley Junction', 40.5969390869141, 0.708550253298231, -76.5630569458008, -1.33627742909614, 218, 45, 'PPL', 'P'),
(70200, 'Williams Village', 35.0299987792969, 0.611388815668325, -78.8694381713867, -1.37653137528879, 218, 33, 'PPL', 'P'),
(52815, 'Williams Wharf', 38.4436111450195, 0.670967590836978, -76.5875015258789, -1.33670406750277, 218, 25, 'PPL', 'P'),
(70203, 'Williamsboro', 36.4302787780762, 0.635828312096846, -78.4319381713867, -1.36889555981132, 218, 33, 'PPL', 'P'),
(6831, 'Williamsburg', 33.6144409179688, 0.58668267023566, -87.0533294677734, -1.51936722403605, 218, 2, 'PPL', 'P'),
(14864, 'Williamsburg', 39.5852813720703, 0.690893495271005, -75.6847229003906, -1.32094760807137, 218, 10, 'PPL', 'P'),
(18635, 'Williamsburg', 28.4141693115234, 0.495920808705214, -81.4430618286133, -1.42144958181462, 218, 12, 'PPL', 'P'),
(26080, 'Williamsburg', 31.4980602264404, 0.549744858942856, -84.1152801513672, -1.46808858987879, 218, 13, 'PPL', 'P'),
(28985, 'Williamsburg', 39.7174987792969, 0.693201124355559, -88.5719375610352, -1.5458719353109, 218, 18, 'PPL', 'P'),
(31537, 'Williamsburg', 39.9508285522461, 0.697273497136454, -84.9963912963867, -1.4834668804354, 218, 19, 'PPL', 'P'),
(34427, 'Williamsburg', 38.4805603027344, 0.671612475294941, -95.466667175293, -1.66620766811446, 218, 20, 'PPL', 'P'),
(38891, 'Williamsburg', 36.7433280944824, 0.641292053389252, -84.1597213745117, -1.46886423554628, 218, 21, 'PPL', 'P'),
(52818, 'Williamsburg', 38.7224998474121, 0.675835116940343, -76.0688934326172, -1.32765264874786, 218, 25, 'PPL', 'P'),
(58300, 'Williamsburg', 38.920280456543, 0.679287039766277, -91.7013931274414, -1.60049123873955, 218, 29, 'PPL', 'P'),
(62337, 'Williamsburg', 31.6191692352295, 0.551858609900052, -89.6105575561523, -1.56399927390274, 218, 30, 'PPL', 'P'),
(70207, 'Williamsburg', 36.2827796936035, 0.633253967429121, -79.5977783203125, -1.38924330896201, 218, 33, 'PPL', 'P'),
(74836, 'Williamsburg', 39.0541687011719, 0.681623830464767, -84.0530624389648, -1.46700268594431, 218, 41, 'PPL', 'P'),
(91896, 'Williamsburg', 35.7841682434082, 0.624551555935069, -83.5088882446289, -1.45750505454876, 218, 50, 'PPL', 'P'),
(99123, 'Williamsburg', 29.3891696929932, 0.512937775570062, -96.9588928222656, -1.69225191883683, 218, 51, 'PPL', 'P'),
(107623, 'Williamsburg', 37.2705612182617, 0.650494007324776, -76.7077789306641, -1.33880330423202, 218, 53, 'PPL', 'P'),
(112067, 'Williamsburg', 37.9700012207031, 0.662701538287536, -80.4925003051758, -1.40485915348786, 218, 58, 'PPL', 'P'),
(118472, 'Williamsburg', 41.6611099243164, 0.727123538214607, -92.0088882446289, -1.60585804096828, 218, 16, 'PPL', 'P'),
(126651, 'Williamsburg', 42.3930587768555, 0.739898455647608, -72.7305603027344, -1.269387744103, 218, 23, 'PPL', 'P'),
(129338, 'Williamsburg', 45.3800010681152, 0.792030433197154, -69.1163864135742, -1.20630850999755, 218, 26, 'PPL', 'P'),
(133746, 'Williamsburg', 44.773609161377, 0.781446897867125, -85.4038925170898, -1.49057911844257, 218, 27, 'PPL', 'P'),
(168984, 'Williamsburg', 41.1794395446777, 0.718716804180581, -79.3955612182617, -1.38571395472739, 218, 45, 'PPL', 'P'),
(187551, 'Williamsburg', 38.3819389343262, 0.669891207703395, -105.151390075684, -1.83523796986957, 218, 7, 'PPL', 'P'),
(189821, 'Williamsburg', 33.1161117553711, 0.577985185589625, -107.292778015137, -1.87261223997552, 218, 38, 'PPL', 'P'),
(197854, 'Williamsburg', 45.9919395446777, 0.802710774432808, -112.55638885498, -1.96447957967446, 218, 31, 'PPL', 'P'),
(6832, 'Williamsburg (historical)', 32.1858291625977, 0.561748691371738, -87.7069396972656, -1.5307748745654, 218, 2, 'PPL', 'P'),
(28986, 'Williamsburg (historical)', 39.295280456543, 0.685832024461255, -88.9375, -1.55225220349246, 218, 18, 'PPL', 'P'),
(52819, 'Williamsburg (historical)', 38.8305587768555, 0.67772110104531, -76.008056640625, -1.32659084642125, 218, 25, 'PPL', 'P'),
(177050, 'Williamsburg (historical)', 44.3138885498047, 0.773423259555907, -91.4608306884766, -1.59629263212299, 218, 57, 'PPL', 'P'),
(195803, 'Williamsburg (historical)', 42.9477806091309, 0.749580178053509, -111.26000213623, -1.94185336305315, 218, 17, 'PPL', 'P'),
(201813, 'Williamsburg (historical)', 42.2444381713867, 0.737304536745871, -123.253890991211, -2.15118621369081, 218, 43, 'PPL', 'P'),
(26082, 'Williamsburg Estates', 34.2930603027344, 0.598526812867678, -85.2675018310547, -1.4881986519022, 218, 13, 'PPL', 'P'),
(52821, 'Williamsburg Estates', 38.773609161377, 0.676727142747465, -76.8369369506836, -1.34105753693672, 218, 25, 'PPL', 'P'),
(84401, 'Williamsburg Estates', 34.9319381713867, 0.609677335193786, -81.8736114501953, -1.42896409030444, 218, 48, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(91897, 'Williamsburg Estates', 35.1097183227539, 0.612780184179837, -84.8694381713867, -1.48125113040845, 218, 50, 'PPL', 'P'),
(121992, 'Williamsburg Green', 42.0305595397949, 0.733571650424934, -88.351936340332, -1.54203218965122, 218, 18, 'PPL', 'P'),
(28987, 'Williamsburg Hill', 39.3002815246582, 0.685919309565983, -88.9347229003906, -1.55220373396062, 218, 18, 'PPL', 'P'),
(107625, 'Williamsburg Manor', 37.4713897705078, 0.653999126793484, -79.0972213745117, -1.38050694216406, 218, 53, 'PPL', 'P'),
(70209, 'Williamsburg Manor North', 35.577220916748, 0.620939643706649, -77.3883285522461, -1.35068113585183, 218, 33, 'PPL', 'P'),
(26084, 'Williamsburg Park', 33.5972213745117, 0.586382132506644, -84.4400024414063, -1.47375606299459, 218, 13, 'PPL', 'P'),
(206502, 'Williamsburg Park Condo', 40.5999984741211, 0.708603649678087, -111.873611450195, -1.95256286590274, 218, 52, 'PPL', 'P'),
(52823, 'Williamsburg Square', 39.1558303833008, 0.683398161541032, -77.2694396972656, -1.3486061338885, 218, 25, 'PPL', 'P'),
(70210, 'Williamsburg Square', 36.063060760498, 0.629419148617461, -80.3036117553711, -1.40156242637445, 218, 33, 'PPL', 'P'),
(126652, 'Williamsburg Station', 42.3875007629395, 0.739801450004902, -72.7174987792969, -1.26915977751369, 218, 23, 'PPL', 'P'),
(52822, 'Williamsburg Village', 39.1458282470703, 0.683223591331577, -77.0772171020508, -1.34525121670527, 218, 25, 'PPL', 'P'),
(107626, 'Williamsburg Village', 38.9049987792969, 0.679020324183105, -77.1552810668945, -1.34661368991895, 218, 53, 'PPL', 'P'),
(107627, 'Williamsburg West', 37.2997207641602, 0.65100293740909, -76.754997253418, -1.33962741943135, 218, 53, 'PPL', 'P'),
(158385, 'Williamsburg-On-The-River', 41.4425010681152, 0.723308093899878, -83.7819366455078, -1.4622706481614, 218, 41, 'PPL', 'P'),
(74838, 'Williamsdale', 39.4411087036133, 0.688377207515044, -84.5299987792969, -1.47532679540552, 218, 41, 'PPL', 'P'),
(121993, 'Williamsfield', 40.9225006103516, 0.714232373800024, -90.0144424438477, -1.57104839499207, 218, 18, 'PPL', 'P'),
(158386, 'Williamsfield', 41.5333290100098, 0.724893340538747, -80.5708312988281, -1.40622628723345, 218, 41, 'PPL', 'P'),
(12870, 'Williamson', 33.9241714477539, 0.592088487774357, -94.3102798461914, -1.64602490179329, 218, 4, 'PPL', 'P'),
(26085, 'Williamson', 33.1822204589844, 0.579139000131901, -84.3616714477539, -1.472388929249, 218, 13, 'PPL', 'P'),
(28988, 'Williamson', 38.9855613708496, 0.68042640665964, -89.7638931274414, -1.56667548448216, 218, 18, 'PPL', 'P'),
(79418, 'Williamson', 39.8530616760254, 0.695567143247013, -77.7977828979492, -1.35782746232095, 218, 45, 'PPL', 'P'),
(99124, 'Williamson', 30.225830078125, 0.527540254011616, -97.8222198486328, -1.70731981796839, 218, 51, 'PPL', 'P'),
(112068, 'Williamson', 37.6741714477539, 0.657538334724145, -82.2774963378906, -1.43601321139377, 218, 58, 'PPL', 'P'),
(118474, 'Williamson', 41.0877799987793, 0.71711704331377, -93.2547225952148, -1.62760195232045, 218, 16, 'PPL', 'P'),
(153822, 'Williamson', 43.2238883972168, 0.754399168046008, -77.186393737793, -1.34715670846522, 218, 40, 'PPL', 'P'),
(179536, 'Williamson', 34.689998626709, 0.605454693548383, -112.540283203125, -1.9641984830214, 218, 5, 'PPL', 'P'),
(44154, 'Williamson (historical)', 30.6283302307129, 0.534565206914054, -91.8430633544922, -1.60296385065364, 218, 22, 'PPL', 'P'),
(99125, 'Williamson Addition Colonia', 27.8700008392334, 0.486423277178206, -98.620002746582, -1.72124375625371, 218, 51, 'PPL', 'P'),
(70212, 'Williamson Crossroads', 34.3594398498535, 0.59968535452089, -78.9219436645508, -1.37744776901989, 218, 33, 'PPL', 'P'),
(91901, 'Williamson Estates', 36.0250015258789, 0.628754889662568, -86.8472213745117, -1.51576995919362, 218, 50, 'PPL', 'P'),
(107629, 'Williamson Farms', 37.4736099243164, 0.654037875787344, -77.3525009155273, -1.35005582562788, 218, 53, 'PPL', 'P'),
(112070, 'Williamson Terrace', 37.6749992370605, 0.657552782373058, -82.2649993896484, -1.43579509850049, 218, 58, 'PPL', 'P'),
(38893, 'Williamsport', 37.8205604553223, 0.660093304894939, -82.7291717529297, -1.44389643453651, 218, 21, 'PPL', 'P'),
(44156, 'Williamsport', 30.8950004577637, 0.539219480393131, -91.6672210693359, -1.59989482381343, 218, 22, 'PPL', 'P'),
(52826, 'Williamsport', 39.6005592346191, 0.69116014427515, -77.8208312988281, -1.35822973280361, 218, 25, 'PPL', 'P'),
(91902, 'Williamsport', 35.6866683959961, 0.622849862577535, -87.2194366455078, -1.52226634119871, 218, 50, 'PPL', 'P'),
(112071, 'Williamsport', 39.2013893127441, 0.684193314863502, -79.0283279418945, -1.37930452493189, 218, 58, 'PPL', 'P'),
(124021, 'Williamsport', 40.288330078125, 0.703164009993546, -87.2938919067383, -1.52356583065261, 218, 19, 'PPL', 'P'),
(158393, 'Williamsport', 40.7238883972168, 0.71076593674615, -80.6361083984375, -1.40736558754779, 218, 41, 'PPL', 'P'),
(168986, 'Williamsport', 41.2411117553711, 0.719793187314164, -77.0013885498047, -1.34392775880155, 218, 45, 'PPL', 'P'),
(70213, 'Williamston', 35.8544387817383, 0.625778008196078, -77.0558319091797, -1.34487797467849, 218, 33, 'PPL', 'P'),
(84403, 'Williamston', 34.6183280944824, 0.604203806784373, -82.4780578613281, -1.43951367033057, 218, 48, 'PPL', 'P'),
(133747, 'Williamston', 42.6888885498047, 0.745061659210999, -84.2830581665039, -1.47101686865539, 218, 27, 'PPL', 'P'),
(158390, 'Williamston', 41.1100006103516, 0.717504866147513, -80.6819381713867, -1.40816546798119, 218, 41, 'PPL', 'P'),
(6834, 'Williamstown', 33.7033309936523, 0.588234094728685, -87.3019409179688, -1.52370631240012, 218, 2, 'PPL', 'P'),
(26086, 'Williamstown', 34.980281829834, 0.61052109120615, -84.3536071777344, -1.47224818118539, 218, 13, 'PPL', 'P'),
(31538, 'Williamstown', 39.4527816772461, 0.688580939338435, -85.4691696166992, -1.4917184187569, 218, 19, 'PPL', 'P'),
(34430, 'Williamstown', 39.0627784729004, 0.681774099329274, -95.3324966430664, -1.66386595056795, 218, 20, 'PPL', 'P'),
(38892, 'Williamstown', 38.6380615234375, 0.674361390172121, -84.5605621337891, -1.47586022657186, 218, 21, 'PPL', 'P'),
(71577, 'Williamstown', 39.6861114501953, 0.69265331211933, -74.9955596923828, -1.30891944100803, 218, 37, 'PPL', 'P'),
(112072, 'Williamstown', 39.4005584716797, 0.687669472455355, -81.4483337402344, -1.42154159403028, 218, 58, 'PPL', 'P'),
(118476, 'Williamstown', 41.5699996948242, 0.725533364727721, -91.7322235107422, -1.6010293304378, 218, 16, 'PPL', 'P'),
(126654, 'Williamstown', 42.7119407653809, 0.745463996272683, -73.2041702270508, -1.27765379665244, 218, 23, 'PPL', 'P'),
(139529, 'Williamstown', 40.2408294677734, 0.702334967946204, -91.7969436645508, -1.60215891021416, 218, 29, 'PPL', 'P'),
(153824, 'Williamstown', 43.4238891601563, 0.757889839865802, -75.8902816772461, -1.32453528553387, 218, 40, 'PPL', 'P'),
(158392, 'Williamstown', 40.8338890075684, 0.712685809575988, -83.6508331298828, -1.45998246015281, 218, 41, 'PPL', 'P'),
(168990, 'Williamstown', 40.7441711425781, 0.711119937434048, -75.6252822875977, -1.31991017366873, 218, 45, 'PPL', 'P'),
(172798, 'Williamstown', 44.1216697692871, 0.770068408951707, -72.5419387817383, -1.2660956775215, 218, 55, 'PPL', 'P'),
(71578, 'Williamstown Junction', 39.7466697692871, 0.693710254176955, -74.9288864135742, -1.30775577276972, 218, 37, 'PPL', 'P'),
(14866, 'Williamsville', 38.4599990844727, 0.671253614338053, -75.1336135864258, -1.31132893600428, 218, 10, 'PPL', 'P'),
(28990, 'Williamsville', 39.9541702270508, 0.697331820364327, -89.5486068725586, -1.56291803050017, 218, 18, 'PPL', 'P'),
(58301, 'Williamsville', 36.9711112976074, 0.645267620264523, -90.5494384765625, -1.58038583724805, 218, 29, 'PPL', 'P'),
(62339, 'Williamsville', 32.7588882446289, 0.57175045916164, -89.1436080932617, -1.55584946833488, 218, 30, 'PPL', 'P'),
(70215, 'Williamsville', 36.4447212219238, 0.636080380294022, -79.1094436645508, -1.38072026136738, 218, 33, 'PPL', 'P'),
(107631, 'Williamsville', 38.7211112976074, 0.675810882174423, -78.6761093139648, -1.37315715018766, 218, 53, 'PPL', 'P'),
(126657, 'Williamsville', 42.4749984741211, 0.741328573152981, -72.0794372558594, -1.25802350309941, 218, 23, 'PPL', 'P'),
(133751, 'Williamsville', 42.4388885498047, 0.740698336081013, -84.0966720581055, -1.46776381738386, 218, 27, 'PPL', 'P'),
(153826, 'Williamsville', 42.9638900756836, 0.749861341285594, -78.7380599975586, -1.37423839359024, 218, 40, 'PPL', 'P'),
(168992, 'Williamsville', 41.6294403076172, 0.726570799130361, -78.5752792358398, -1.37139733333934, 218, 45, 'PPL', 'P'),
(172800, 'Williamsville', 42.9466705322266, 0.749560803556579, -72.679443359375, -1.26849558513782, 218, 55, 'PPL', 'P'),
(91903, 'Williamsville (historical)', 36.1383285522461, 0.63073281940417, -87.5016708374023, -1.52719225710897, 218, 50, 'PPL', 'P'),
(143393, 'Williamsville (historical)', 40.1888885498047, 0.701428427911141, -95.539436340332, -1.66747772963832, 218, 35, 'PPL', 'P'),
(172801, 'Williamsville Station', 42.9469413757324, 0.749565530667514, -72.6419372558594, -1.26784098014188, 218, 55, 'PPL', 'P'),
(44155, 'Williana', 31.6700000762939, 0.552745775438185, -92.5661087036133, -1.61558337263703, 218, 22, 'PPL', 'P'),
(52824, 'Williar', 39.5083312988281, 0.689550463133279, -77.4069366455078, -1.35100590834677, 218, 25, 'PPL', 'P'),
(168993, 'Williard', 41.690559387207, 0.727637528304992, -77.2633285522461, -1.34849947428684, 218, 45, 'PPL', 'P'),
(38894, 'Williba', 37.6230583190918, 0.656646242337995, -83.5691680908203, -1.4585571363374, 218, 21, 'PPL', 'P'),
(112073, 'Willibet', 37.6180610656738, 0.656559023812295, -81.1963882446289, -1.41714431559639, 218, 58, 'PPL', 'P'),
(26087, 'Willie', 32.0138893127441, 0.55874777487641, -81.6675033569336, -1.42536682546201, 218, 13, 'PPL', 'P'),
(52825, 'Willie Breeze', 38.6263885498047, 0.67415765834873, -76.5355606079102, -1.33579752746771, 218, 25, 'PPL', 'P'),
(194065, 'Willie Hoaglin Place', 40.1141700744629, 0.700124344504356, -123.33528137207, -2.15260674381626, 218, 6, 'PPL', 'P'),
(84404, 'Willie Towne', 33.5402793884277, 0.585388307366854, -79.4333267211914, -1.38637308709718, 218, 48, 'PPL', 'P'),
(138843, 'Willie''s Mobile Home Park', 45.5586090087891, 0.795147729832119, -94.2102813720703, -1.64427959917291, 218, 28, 'PPL', 'P'),
(12871, 'Williford', 36.2527809143066, 0.632730389958811, -91.355827331543, -1.59445997781885, 218, 4, 'PPL', 'P'),
(18636, 'Williford', 29.7861099243164, 0.51986568954028, -82.791389465332, -1.44498233847099, 218, 12, 'PPL', 'P'),
(26088, 'Williford (historical)', 31.9638900756836, 0.557875123566218, -83.6291732788086, -1.45960442443607, 218, 13, 'PPL', 'P'),
(126658, 'Willimansett', 42.1791687011719, 0.736165369589589, -72.6208267211914, -1.26747253180507, 218, 23, 'PPL', 'P'),
(114293, 'Willimantic', 41.7105598449707, 0.727986602144874, -72.208610534668, -1.26027800212022, 218, 8, 'PPL', 'P'),
(129339, 'Willimantic', 45.3066711425781, 0.79075058455629, -69.4088897705078, -1.21141365664917, 218, 26, 'PPL', 'P'),
(62340, 'Willing', 31.9608306884766, 0.557821727186362, -90.6041717529297, -1.58134111313107, 218, 30, 'PPL', 'P'),
(146652, 'Willingboro', 40.0277786254883, 0.698616529274181, -74.8694381713867, -1.30671820520902, 218, 37, 'PPL', 'P'),
(26089, 'Willingham (historical)', 31.5466709136963, 0.550593275487128, -83.9044418334961, -1.46440876704257, 218, 13, 'PPL', 'P'),
(6835, 'Willingham Estates', 33.4527816772461, 0.583861184218775, -86.2866668701172, -1.50598643745506, 218, 2, 'PPL', 'P'),
(84406, 'Willington', 33.9719390869141, 0.592922190353606, -82.4669418334961, -1.43931965904516, 218, 48, 'PPL', 'P'),
(84407, 'Willington Green', 34.8827781677246, 0.608819331269589, -82.3280563354492, -1.43689564982097, 218, 48, 'PPL', 'P'),
(138844, 'Willington Grove', 43.5783309936523, 0.760585358363126, -91.5788879394531, -1.59835311985838, 218, 28, 'PPL', 'P'),
(114297, 'Willington Hill', 41.875, 0.730856624272626, -72.2644424438477, -1.26125245276308, 218, 8, 'PPL', 'P'),
(12872, 'Willis', 36.378059387207, 0.634916911792793, -92.9863891601563, -1.62291865038549, 218, 4, 'PPL', 'P'),
(18637, 'Willis', 30.5530605316162, 0.533251502837832, -85.1866683959961, -1.48678784231473, 218, 12, 'PPL', 'P'),
(31539, 'Willis', 38.5533294677734, 0.6728825368188, -87.3572235107422, -1.52467117566305, 218, 19, 'PPL', 'P'),
(34431, 'Willis', 39.7249984741211, 0.693332018723137, -95.5055618286133, -1.66688650787632, 218, 20, 'PPL', 'P'),
(44157, 'Willis', 30.7363891601563, 0.536451191019021, -90.0666732788086, -1.57195999503321, 218, 22, 'PPL', 'P'),
(62341, 'Willis', 34.1402816772461, 0.595860322826236, -90.7944412231445, -1.58466194185234, 218, 30, 'PPL', 'P'),
(77686, 'Willis', 33.8855590820313, 0.591414574860513, -96.8288879394531, -1.68998290558808, 218, 42, 'PPL', 'P'),
(91905, 'Willis', 35.4786109924316, 0.619218575852185, -89.2772216796875, -1.55818146534341, 218, 50, 'PPL', 'P'),
(99127, 'Willis', 30.4247207641602, 0.53101155133448, -95.4797210693359, -1.66643550154571, 218, 51, 'PPL', 'P'),
(107634, 'Willis', 36.8683280944824, 0.643473714954245, -82.1141662597656, -1.43316256376295, 218, 53, 'PPL', 'P'),
(133752, 'Willis', 42.1583290100098, 0.735801648363712, -83.5580596923828, -1.45836325821004, 218, 27, 'PPL', 'P'),
(143394, 'Willis', 42.4752807617188, 0.741333500000997, -96.6286087036133, -1.6864873734993, 218, 35, 'PPL', 'P'),
(52828, 'Willis Acres', 39.502498626709, 0.68944866380061, -77.4347229003906, -1.35149086998127, 218, 25, 'PPL', 'P'),
(112074, 'Willis Branch', 37.8936080932617, 0.661368226687788, -81.2627792358398, -1.41830305698669, 218, 58, 'PPL', 'P'),
(71579, 'Willis Corner', 39.4347190856934, 0.688265687644397, -75.376106262207, -1.31556123160863, 218, 37, 'PPL', 'P'),
(129341, 'Willis Corners', 44.1025009155273, 0.769733849339766, -69.1744384765625, -1.20732170963427, 218, 26, 'PPL', 'P'),
(38895, 'Willis Creek', 36.8141708374023, 0.642528492504349, -85.2219390869141, -1.4874034320007, 218, 21, 'PPL', 'P'),
(70217, 'Willis Landing', 34.6458282470703, 0.604683774991832, -77.2119369506836, -1.3476025216317, 218, 33, 'PPL', 'P'),
(129342, 'Willis Mill', 44.3122215270996, 0.773394164520998, -70.679443359375, -1.23358900009794, 218, 26, 'PPL', 'P'),
(186162, 'Willis Palms', 33.827220916748, 0.590396381796748, -116.32861328125, -2.03031731603702, 218, 6, 'PPL', 'P'),
(26090, 'Willis Plaza', 32.4255599975586, 0.565932783760362, -84.9311065673828, -1.48232744696301, 218, 13, 'PPL', 'P'),
(91906, 'Willis Springs', 35.0094413757324, 0.611030021290464, -84.6869430541992, -1.47806598974472, 218, 50, 'PPL', 'P'),
(91907, 'Willis Subdivision)', 36.1749992370605, 0.631372843593143, -82.7866668701172, -1.44489991363525, 218, 50, 'PPL', 'P'),
(107636, 'Willis Wharf', 37.5155601501465, 0.654770045350034, -75.8069381713867, -1.32308066694647, 218, 53, 'PPL', 'P'),
(38896, 'Willisburg', 37.8097190856934, 0.659904087299489, -85.1263885498047, -1.48573576052609, 218, 21, 'PPL', 'P'),
(18638, 'Williston', 29.3872203826904, 0.512903753687136, -82.4469375610352, -1.43897051862625, 218, 12, 'PPL', 'P'),
(52827, 'Williston', 38.8311080932617, 0.677730688425234, -75.8513870239258, -1.32385644577201, 218, 25, 'PPL', 'P'),
(62342, 'Williston', 32.7619400024414, 0.571803722383442, -89.3916702270508, -1.56017896931902, 218, 30, 'PPL', 'P'),
(70218, 'Williston', 34.7891693115234, 0.607185548519853, -76.5055618286133, -1.3352739499974, 218, 33, 'PPL', 'P'),
(84408, 'Williston', 33.4025001525879, 0.582983606060567, -81.420280456543, -1.42105197186387, 218, 48, 'PPL', 'P'),
(91908, 'Williston', 35.1575012207031, 0.613614153075195, -89.3683319091797, -1.5597716388303, 218, 50, 'PPL', 'P'),
(153828, 'Williston', 42.8274993896484, 0.747480874745227, -78.5166702270508, -1.37037441316464, 218, 40, 'PPL', 'P'),
(158394, 'Williston', 41.6036109924316, 0.726119992536838, -83.3399963378906, -1.45455733469621, 218, 41, 'PPL', 'P'),
(168994, 'Williston', 41.8363914489746, 0.730182777937808, -78.1902770996094, -1.36467777843491, 218, 45, 'PPL', 'P'),
(172802, 'Williston', 44.4375, 0.77558068635498, -73.0686111450195, -1.27528784434001, 218, 55, 'PPL', 'P'),
(199107, 'Williston', 48.1469383239746, 0.840322598507997, -103.617500305176, -1.80846654301155, 218, 34, 'PPL', 'P'),
(18639, 'Williston Highlands', 29.3402805328369, 0.5120844987568, -82.5416717529297, -1.44062394218902, 218, 12, 'PPL', 'P'),
(153829, 'Williston Park', 40.7563896179199, 0.711333190058336, -73.6452789306641, -1.2853525958897, 218, 40, 'PPL', 'P'),
(79416, 'Willistown', 39.961109161377, 0.697452927614898, -75.4963912963867, -1.31766060149594, 218, 45, 'PPL', 'P'),
(12873, 'Willisville', 33.5169410705566, 0.584980976878126, -93.2980575561523, -1.62835829007003, 218, 4, 'PPL', 'P'),
(28991, 'Willisville', 37.9838905334473, 0.66294395252576, -89.5894393920898, -1.56363069240787, 218, 18, 'PPL', 'P'),
(31540, 'Willisville', 38.4508285522461, 0.671093558356539, -87.2955627441406, -1.52359499226655, 218, 19, 'PPL', 'P'),
(107639, 'Willisville', 39.0072212219238, 0.680804442376377, -77.8344421386719, -1.35846728677284, 218, 53, 'PPL', 'P'),
(153830, 'Willisville', 44.5933303833008, 0.778300439618224, -74.938606262207, -1.30792541613115, 218, 40, 'PPL', 'P'),
(114296, 'Willisville (historical)', 41.0544395446777, 0.716535142615588, -73.5100021362305, -1.28299157042529, 218, 8, 'PPL', 'P'),
(186163, 'Willits', 39.4097213745117, 0.687829395278815, -123.354438781738, -2.15294110369112, 218, 6, 'PPL', 'P'),
(70219, 'Willits-Ochre Hill', 35.401668548584, 0.617875676872513, -83.1275024414063, -1.45084861656216, 218, 33, 'PPL', 'P'),
(99128, 'Willman', 29.9327793121338, 0.522425553269578, -97.2600021362305, -1.69750726777394, 218, 51, 'PPL', 'P'),
(138845, 'Willmar', 45.121940612793, 0.787526428582585, -95.0430603027344, -1.65881433345423, 218, 28, 'PPL', 'P'),
(139530, 'Willmathsville', 40.3263893127441, 0.703828268948439, -92.4088897705078, -1.61283938460787, 218, 29, 'PPL', 'P'),
(6836, 'Willmay', 33.2180595397949, 0.579764510092934, -86.7977828979492, -1.51490709500044, 218, 2, 'PPL', 'P'),
(168995, 'Willock', 40.351390838623, 0.704264627893048, -79.9619369506836, -1.39559907606154, 218, 45, 'PPL', 'P'),
(195804, 'Willola', 46.5050010681152, 0.811665387282091, -116.56916809082, -2.03451578949553, 218, 17, 'PPL', 'P'),
(186164, 'Willota', 38.2444381713867, 0.667491366666098, -122.105827331543, -2.13114872280711, 218, 6, 'PPL', 'P'),
(158395, 'Willoughbeach', 41.6388893127441, 0.726735715380864, -81.4755630493164, -1.4220168351268, 218, 41, 'PPL', 'P'),
(52829, 'Willoughby', 38.9341697692871, 0.679529454004501, -76.0186080932617, -1.32677500401063, 218, 25, 'PPL', 'P'),
(62343, 'Willoughby', 32.5472183227539, 0.568056122097482, -89.0616683959961, -1.55441935082951, 218, 30, 'PPL', 'P'),
(107637, 'Willoughby', 38.0130615234375, 0.663453082347156, -78.4958267211914, -1.37001062535974, 218, 53, 'PPL', 'P'),
(113369, 'Willoughby', 44.7038917541504, 0.780230099565068, -72.1091690063477, -1.25854242003781, 218, 55, 'PPL', 'P'),
(153831, 'Willoughby', 42.2008285522461, 0.736543405306326, -78.6083297729492, -1.37197417403145, 218, 40, 'PPL', 'P'),
(158396, 'Willoughby', 41.639720916748, 0.726750229608805, -81.4066696166992, -1.42081441789463, 218, 41, 'PPL', 'P'),
(18640, 'Willoughby Acres', 26.2772197723389, 0.458624003297468, -81.7622222900391, -1.42701998270868, 218, 12, 'PPL', 'P'),
(107638, 'Willoughby Beach', 36.9669418334961, 0.645194849387736, -76.2880630493164, -1.3314778801796, 218, 53, 'PPL', 'P'),
(70220, 'Willoughby Condominiums', 35.5652809143066, 0.62073125135135, -77.3861083984375, -1.35064238685797, 218, 33, 'PPL', 'P'),
(52830, 'Willoughby Court', 39.4252815246582, 0.688100971130976, -76.2897186279297, -1.33150677547742, 218, 25, 'PPL', 'P'),
(158397, 'Willoughby Hills', 41.598331451416, 0.726027847163121, -81.4186096191406, -1.42102281024993, 218, 41, 'PPL', 'P'),
(107641, 'Willoughby Terrace', 36.9497184753418, 0.644894245079694, -76.2636108398438, -1.33105110861491, 218, 53, 'PPL', 'P'),
(52831, 'Willoughby Woods', 39.4291687011719, 0.688168815159745, -76.2680587768555, -1.33112873976069, 218, 25, 'PPL', 'P'),
(12874, 'Willow', 34.1336097717285, 0.595743876107573, -92.7461090087891, -1.61872497061694, 218, 4, 'PPL', 'P'),
(18641, 'Willow', 27.6441707611084, 0.482481798764888, -82.3466720581055, -1.43722055547396, 218, 12, 'PPL', 'P'),
(38898, 'Willow', 38.6655616760254, 0.67484135837958, -84.1524963378906, -1.46873813486866, 218, 21, 'PPL', 'P'),
(52832, 'Willow', 39.2011108398438, 0.684188454594513, -76.6172180175781, -1.33722271812506, 218, 25, 'PPL', 'P'),
(77688, 'Willow', 35.0513916015625, 0.611762190853154, -99.5091705322266, -1.73676266171587, 218, 42, 'PPL', 'P'),
(99129, 'Willow', 30.1016693115234, 0.525373239832619, -95.5377807617188, -1.66744883434049, 218, 51, 'PPL', 'P'),
(107640, 'Willow', 37.6902809143066, 0.65781949795623, -79.2413864135742, -1.38302309676197, 218, 53, 'PPL', 'P'),
(121994, 'Willow', 42.2780609130859, 0.73789136429207, -89.9497222900391, -1.56991881521572, 218, 18, 'PPL', 'P'),
(133753, 'Willow', 42.1152801513672, 0.735050304041173, -83.3955612182617, -1.45552712480716, 218, 27, 'PPL', 'P'),
(153834, 'Willow', 42.0763893127441, 0.734371530858339, -74.2283325195313, -1.295528800731, 218, 40, 'PPL', 'P'),
(158400, 'Willow', 41.413890838623, 0.722808751195488, -81.6430587768555, -1.42494018705538, 218, 41, 'PPL', 'P'),
(179537, 'Willow', 33.7147216796875, 0.58843289970406, -110.977783203125, -1.93692771345899, 218, 5, 'PPL', 'P'),
(212232, 'Willow', 61.7472190856934, 1.07769227699563, -150.037506103516, -2.61864848298744, 218, 1, 'PPL', 'P'),
(26091, 'Willow (historical)', 34.6305618286133, 0.60441732572477, -83.9049987792969, -1.46441848758055, 218, 13, 'PPL', 'P'),
(84409, 'Willow Acres', 34.9925003051758, 0.610734343830438, -81.0875015258789, -1.41524388384251, 218, 48, 'PPL', 'P'),
(209833, 'Willow Addition', 41.7991714477539, 0.729533166368911, -110.533889770508, -1.92918031153184, 218, 59, 'PPL', 'P'),
(206504, 'Willow Bay', 40.6519393920898, 0.70951018971315, -111.972221374512, -1.9542839337572, 218, 52, 'PPL', 'P'),
(206505, 'Willow Bay Numbers 3 and 4', 40.6477813720703, 0.709437618573445, -111.972221374512, -1.9542839337572, 218, 52, 'PPL', 'P'),
(153832, 'Willow Beach', 42.7422218322754, 0.745992500591009, -77.5052795410156, -1.35272231566932, 218, 40, 'PPL', 'P'),
(158401, 'Willow Beach', 41.707218170166, 0.727928278917002, -83.476936340332, -1.4569473886165, 218, 41, 'PPL', 'P'),
(52833, 'Willow Beach Colony', 38.6286087036133, 0.67419640734259, -76.5177764892578, -1.33548713604266, 218, 25, 'PPL', 'P'),
(12875, 'Willow Belle', 34.6358299255371, 0.604509271361405, -92.0294418334961, -1.60621676876711, 218, 4, 'PPL', 'P'),
(26092, 'Willow Bend', 33.4883308410645, 0.584481634173737, -84.3705596923828, -1.47254405838249, 218, 13, 'PPL', 'P'),
(70222, 'Willow Bend', 35.3036117553711, 0.616164262977001, -82.4655609130859, -1.43929555743729, 218, 33, 'PPL', 'P'),
(31541, 'Willow Branch', 39.8761100769043, 0.695969413729669, -85.684440612793, -1.49547560642279, 218, 19, 'PPL', 'P'),
(44158, 'Willow Brook', 30.0436096191406, 0.524359907037844, -89.9252777099609, -1.56949217680908, 218, 22, 'PPL', 'P'),
(58302, 'Willow Brook', 39.6319389343262, 0.691707823353324, -94.7955627441406, -1.65449468616612, 218, 29, 'PPL', 'P'),
(146654, 'Willow Brook', 41.2105598449707, 0.719259955884903, -74.3841705322266, -1.2982486871523, 218, 37, 'PPL', 'P'),
(153835, 'Willow Brook', 41.8616714477539, 0.730623997151407, -73.7444381713867, -1.28708325112408, 218, 40, 'PPL', 'P'),
(186165, 'Willow Brook', 33.9161109924316, 0.591947806289774, -118.230560302734, -2.06351255376042, 218, 6, 'PPL', 'P'),
(52837, 'Willow Brook Estates', 38.2094383239746, 0.666880504091061, -76.4905624389648, -1.33501216126224, 218, 25, 'PPL', 'P'),
(153836, 'Willow Brook Park', 42.8819389343262, 0.74843102404314, -73.9208297729492, -1.29016186534422, 218, 40, 'PPL', 'P'),
(179538, 'Willow Canyon', 32.3886108398438, 0.565287899302399, -110.698059082031, -1.93204560654866, 218, 5, 'PPL', 'P'),
(44159, 'Willow Chute', 32.6641693115234, 0.570097301914973, -93.7474975585938, -1.63620249790281, 218, 22, 'PPL', 'P'),
(99130, 'Willow City', 30.4005603790283, 0.53058987306538, -98.7011108398438, -1.72265935953114, 218, 51, 'PPL', 'P'),
(199111, 'Willow City', 48.6044387817383, 0.848307487825355, -100.293891906738, -1.75045863341188, 218, 34, 'PPL', 'P'),
(26095, 'Willow Creek', 33.8186111450195, 0.59024611293224, -84.8802795410156, -1.4814403480039, 218, 13, 'PPL', 'P'),
(44160, 'Willow Creek', 30.5352802276611, 0.532941177991811, -91.0022201538086, -1.5882883683087, 218, 22, 'PPL', 'P'),
(70244, 'Willow Creek', 35.5177803039551, 0.619902209304009, -77.5299987792969, -1.35315374776592, 218, 33, 'PPL', 'P'),
(99131, 'Willow Creek', 31.2861099243164, 0.546045628320195, -96.4361114501953, -1.68312766262611, 218, 51, 'PPL', 'P'),
(121995, 'Willow Creek', 41.8349990844727, 0.730158476592861, -88.4672164916992, -1.54404420785478, 218, 18, 'PPL', 'P'),
(124022, 'Willow Creek', 41.5863914489746, 0.725819454807822, -87.1833267211914, -1.52163610412674, 218, 19, 'PPL', 'P'),
(138848, 'Willow Creek', 43.894718170166, 0.766107356304378, -94.2683334350586, -1.64529279880963, 218, 28, 'PPL', 'P'),
(153837, 'Willow Creek', 42.5208282470703, 0.742128453586386, -76.5758285522461, -1.33650033567938, 218, 40, 'PPL', 'P'),
(177052, 'Willow Creek', 43.207218170166, 0.754108217696917, -88.158332824707, -1.53865317086013, 218, 57, 'PPL', 'P'),
(189822, 'Willow Creek', 36.8894386291504, 0.643842163291058, -106.650283813477, -1.86139860073158, 218, 38, 'PPL', 'P'),
(194066, 'Willow Creek', 40.9397201538086, 0.714532911529039, -123.630279541016, -2.15775543315171, 218, 6, 'PPL', 'P'),
(197855, 'Willow Creek', 45.8252792358398, 0.799802003311196, -111.643890380859, -1.94855347688162, 218, 31, 'PPL', 'P'),
(206509, 'Willow Creek', 41.3547210693359, 0.721776043903782, -111.865280151367, -1.95241745730722, 218, 52, 'PPL', 'P'),
(209834, 'Willow Creek', 43.2849998474121, 0.755465764062584, -109.141387939453, -1.90487656973989, 218, 59, 'PPL', 'P'),
(212233, 'Willow Creek', 61.8083305358887, 1.07875887301221, -161.908325195313, -2.82583336104789, 218, 1, 'PPL', 'P'),
(26096, 'Willow Creek Estates', 33.5688896179199, 0.585887650071244, -84.4316711425781, -1.47361065439907, 218, 13, 'PPL', 'P'),
(206510, 'Willow Creek Estates', 40.5927810668945, 0.708477682158526, -111.813888549805, -1.95152050465208, 218, 52, 'PPL', 'P'),
(206512, 'Willow Creek Hill', 40.5963897705078, 0.708540665918307, -111.797782897949, -1.95123940799902, 218, 52, 'PPL', 'P'),
(206513, 'Willow Creek Hills', 40.5905609130859, 0.708438933164665, -111.818328857422, -1.9515980026398, 218, 52, 'PPL', 'P'),
(206514, 'Willow Creek Meadows', 40.5858306884766, 0.708356375170873, -111.829170227051, -1.95178722023525, 218, 52, 'PPL', 'P'),
(197856, 'Willow Creek Mobile Home Park', 48.1694412231445, 0.840715348189757, -114.288330078125, -1.99470765646935, 218, 31, 'PPL', 'P'),
(84410, 'Willow Creek Siding', 34.0911102294922, 0.595002119164958, -79.6474990844727, -1.39011110000322, 218, 48, 'PPL', 'P'),
(26097, 'Willow Creek Subdivision', 33.4388885498047, 0.583618703401524, -84.8016662597656, -1.4800682874103, 218, 13, 'PPL', 'P'),
(121996, 'Willow Creek Trailer Park', 40.4669418334961, 0.706281373207538, -89.0186080932617, -1.55366780676989, 218, 18, 'PPL', 'P'),
(206518, 'Willow Creek View', 40.6069412231445, 0.708724823507686, -111.799438476563, -1.95126830329685, 218, 52, 'PPL', 'P'),
(158406, 'Willow Crest', 40.973331451416, 0.715119539338157, -80.6508331298828, -1.40762258259298, 218, 41, 'PPL', 'P'),
(197857, 'Willow Crossing', 45.5272216796875, 0.79459991759589, -106.186943054199, -1.8533117789235, 218, 31, 'PPL', 'P'),
(168996, 'Willow Farms Mobile Home Park', 40.2449989318848, 0.70240773882299, -76.774169921875, -1.33996204562232, 218, 45, 'PPL', 'P'),
(44163, 'Willow Glen', 31.2463893890381, 0.545352374198934, -92.4322204589844, -1.61324658193854, 218, 22, 'PPL', 'P'),
(52835, 'Willow Glen', 39.3555603027344, 0.686884106249891, -76.7344436645508, -1.33926869163251, 218, 25, 'PPL', 'P'),
(153840, 'Willow Glen', 42.4897193908691, 0.741585501619146, -76.3283309936523, -1.33218068839127, 218, 40, 'PPL', 'P'),
(158403, 'Willow Glen', 40.5152816772461, 0.707125062640875, -81.4908294677734, -1.42228328439386, 218, 41, 'PPL', 'P'),
(186167, 'Willow Glen', 37.3086090087891, 0.651158066542587, -121.888610839844, -2.12735757983732, 218, 6, 'PPL', 'P'),
(186166, 'Willow Glen (historical)', 37.2119407653809, 0.649470887412995, -119.707221984863, -2.08928516205161, 218, 6, 'PPL', 'P'),
(107642, 'Willow Green', 37.3327789306641, 0.651579911259256, -80.0133285522461, -1.39649602871668, 218, 53, 'PPL', 'P'),
(14867, 'Willow Grove', 39.0708312988281, 0.681914647655803, -75.6286087036133, -1.31996823058049, 218, 10, 'PPL', 'P'),
(38901, 'Willow Grove', 38.788330078125, 0.676984071213631, -84.1719436645508, -1.46907755474959, 218, 21, 'PPL', 'P'),
(44164, 'Willow Grove', 30.0458297729492, 0.524398656031704, -90.6563873291016, -1.58225244685609, 218, 22, 'PPL', 'P'),
(52836, 'Willow Grove', 38.0924987792969, 0.664839524010651, -75.503059387207, -1.31777698163557, 218, 25, 'PPL', 'P'),
(91912, 'Willow Grove', 36.5869407653809, 0.63856257958803, -85.3422164916992, -1.48950266872996, 218, 50, 'PPL', 'P'),
(99132, 'Willow Grove', 31.5499992370605, 0.550651365688406, -97.2955627441406, -1.69812791746598, 218, 51, 'PPL', 'P'),
(107643, 'Willow Grove', 38.8436088562012, 0.677948867897539, -78.5358276367188, -1.3707087730395, 218, 53, 'PPL', 'P'),
(146655, 'Willow Grove', 40.6988906860352, 0.710329644380567, -75.0863876342773, -1.3105046876469, 218, 37, 'PPL', 'P'),
(153845, 'Willow Grove', 43.038330078125, 0.75116056442339, -76.7161102294922, -1.33894871282754, 218, 40, 'PPL', 'P'),
(158405, 'Willow Grove', 40.8858299255371, 0.713592349611051, -80.9005584716797, -1.411981112033, 218, 41, 'PPL', 'P'),
(168998, 'Willow Grove', 40.1438903808594, 0.700643061705677, -75.1161117553711, -1.31102347142724, 218, 45, 'PPL', 'P'),
(190933, 'Willow Grove', 39.0233306884766, 0.681085605608462, -115.268058776855, -2.01180714803848, 218, 39, 'PPL', 'P'),
(112075, 'Willow Grove (historical)', 38.9333305358887, 0.679514806618506, -81.8361129760742, -1.42830961846655, 218, 58, 'PPL', 'P'),
(6841, 'Willow Grove Estates', 33.7941703796387, 0.589819541104637, -86.9313888549805, -1.51723895885091, 218, 2, 'PPL', 'P'),
(84411, 'Willow Heights', 34.9002799987793, 0.609124795846621, -82.3649978637695, -1.43754040112087, 218, 48, 'PPL', 'P'),
(107644, 'Willow Heights', 38.0494384765625, 0.664087979951031, -78.4713897705078, -1.36958412011116, 218, 53, 'PPL', 'P'),
(28994, 'Willow Hill', 38.9958305358887, 0.680605637401002, -88.0224990844727, -1.53628242485774, 218, 18, 'PPL', 'P'),
(107645, 'Willow Hill', 37.2550010681152, 0.650222431472615, -77.0580596923828, -1.34491685683041, 218, 53, 'PPL', 'P'),
(168999, 'Willow Hill', 40.1080589294434, 0.700017684902699, -77.7886123657227, -1.35766740633944, 218, 45, 'PPL', 'P'),
(206522, 'Willow Hill', 40.6186103820801, 0.708928488752049, -111.844169616699, -1.95204900897041, 218, 52, 'PPL', 'P'),
(112076, 'Willow Island', 39.3583297729492, 0.686932442623676, -81.3083267211914, -1.41909801057208, 218, 58, 'PPL', 'P'),
(199785, 'Willow Island', 40.8886108398438, 0.713640885721917, -100.071113586426, -1.74657041822036, 218, 35, 'PPL', 'P'),
(26098, 'Willow Lake', 32.4755592346191, 0.566805435070554, -83.89111328125, -1.46417613992136, 218, 13, 'PPL', 'P'),
(107646, 'Willow Lake', 39.0755615234375, 0.681997205649596, -77.9472198486328, -1.36043562913452, 218, 53, 'PPL', 'P'),
(169000, 'Willow Lake', 40.6463890075684, 0.709413317228498, -76.1750030517578, -1.3295046109699, 218, 45, 'PPL', 'P'),
(171629, 'Willow Lake', 44.627498626709, 0.77889678796532, -97.6366729736328, -1.70408141408286, 218, 49, 'PPL', 'P'),
(212234, 'Willow Lake', 61.7444381713867, 1.07764374088477, -150.036392211914, -2.61862904191148, 218, 1, 'PPL', 'P'),
(12877, 'Willow Lake Subdivision', 34.9958305358887, 0.610792467321229, -92.0505599975586, -1.60658535026198, 218, 4, 'PPL', 'P'),
(107647, 'Willow Lakes', 36.7936096191406, 0.642169631547461, -76.4449996948242, -1.33421694136074, 218, 53, 'PPL', 'P'),
(126661, 'Willow Lane Adult Trailer Park', 42.6938896179199, 0.745148944315727, -73.0769424438477, -1.27543325293553, 218, 23, 'PPL', 'P'),
(189823, 'Willow Mountain', 33.350830078125, 0.582081793136439, -108.676666259766, -1.89676564632394, 218, 38, 'PPL', 'P'),
(18643, 'Willow Oak', 27.9158306121826, 0.487223157611611, -82.0180587768555, -1.43148517175036, 218, 12, 'PPL', 'P'),
(107648, 'Willow Oaks', 36.8486099243164, 0.64312956796238, -77.607780456543, -1.35451129413158, 218, 53, 'PPL', 'P'),
(99133, 'Willow Park', 32.7625007629395, 0.571813509500448, -97.6502838134766, -1.70431896805209, 218, 51, 'PPL', 'P'),
(99134, 'Willow Point', 33.1150016784668, 0.577965811092694, -97.913330078125, -1.70890999145528, 218, 51, 'PPL', 'P'),
(153843, 'Willow Point', 42.1022186279297, 0.734822337451863, -75.9908294677734, -1.32629017553418, 218, 40, 'PPL', 'P'),
(172804, 'Willow Point', 44.0224990844727, 0.768337553980237, -73.4005584716797, -1.28108141813343, 218, 55, 'PPL', 'P'),
(186168, 'Willow Point', 38.4255599975586, 0.670652538880022, -121.551391601563, -2.12147199382825, 218, 6, 'PPL', 'P'),
(200285, 'Willow Point (historical)', 41.2558288574219, 0.720050049201302, -117.60888671875, -2.05266230284722, 218, 39, 'PPL', 'P'),
(194067, 'Willow Ranch', 41.9025001525879, 0.731336592480085, -120.357223510742, -2.10062982882118, 218, 6, 'PPL', 'P'),
(52838, 'Willow Ridge', 39.1202812194824, 0.682777711586071, -77.2611083984375, -1.34846072529298, 218, 25, 'PPL', 'P'),
(71581, 'Willow Ridge', 39.8699989318848, 0.695862754128012, -74.908332824707, -1.30739704497088, 218, 37, 'PPL', 'P'),
(121998, 'Willow Ridge', 41.3383293151855, 0.721489953823681, -88.4238891601563, -1.54328800326325, 218, 18, 'PPL', 'P'),
(153844, 'Willow Ridge Estates', 43.0116691589355, 0.750695243601926, -78.809440612793, -1.37548422034818, 218, 40, 'PPL', 'P'),
(138850, 'Willow Ridge Mobile Home Park', 43.9652786254883, 0.767338868571458, -92.4680633544922, -1.6138721584786, 218, 28, 'PPL', 'P'),
(138851, 'Willow River', 46.3183288574219, 0.808407342583515, -92.8411102294922, -1.62038305471163, 218, 28, 'PPL', 'P'),
(138852, 'Willow River Mobile Home Park', 46.3183288574219, 0.808407342583515, -92.8411102294922, -1.62038305471163, 218, 28, 'PPL', 'P'),
(14868, 'Willow Run', 39.7444381713867, 0.693671305446013, -75.6097183227539, -1.31963853123754, 218, 10, 'PPL', 'P'),
(26100, 'Willow Run', 32.4908294677734, 0.567071950916643, -83.6458282470703, -1.45989510846905, 218, 13, 'PPL', 'P'),
(107650, 'Willow Run', 38.8222198486328, 0.677575559291737, -77.1744384765625, -1.34694804979381, 218, 53, 'PPL', 'P'),
(133754, 'Willow Run', 42.2572212219238, 0.737527643066192, -83.5744400024414, -1.45864914855306, 218, 27, 'PPL', 'P'),
(206525, 'Willow Run Park', 40.6655616760254, 0.709747943419467, -111.976936340332, -1.95436622543488, 218, 52, 'PPL', 'P'),
(38899, 'Willow Shade', 36.8477783203125, 0.643115053734439, -85.607780456543, -1.49413763429113, 218, 21, 'PPL', 'P'),
(18642, 'Willow Sink', 28.4858303070068, 0.497171529021656, -82.54638671875, -1.44070623386671, 218, 12, 'PPL', 'P'),
(99135, 'Willow Spring', 33.7777786254883, 0.589533451024535, -96.7447204589844, -1.6885139059308, 218, 51, 'PPL', 'P'),
(179539, 'Willow Spring', 34.6699981689453, 0.605105619708501, -112.862503051758, -1.96982228029532, 218, 5, 'PPL', 'P'),
(6844, 'Willow Springs', 32.4680595397949, 0.566674540702976, -86.1897201538086, -1.50429439805647, 218, 2, 'PPL', 'P'),
(58304, 'Willow Springs', 36.9922218322754, 0.645636068601335, -91.9697189331055, -1.60517440751646, 218, 29, 'PPL', 'P'),
(70228, 'Willow Springs', 35.5955581665039, 0.621259689090649, -78.7316665649414, -1.37412680714056, 218, 33, 'PPL', 'P'),
(91913, 'Willow Springs', 36.1836090087891, 0.631523112457651, -83.3852767944336, -1.45534762774969, 218, 50, 'PPL', 'P'),
(99138, 'Willow Springs', 30.6644401550293, 0.535195443986022, -95.2227783203125, -1.66195100458613, 218, 51, 'PPL', 'P'),
(107652, 'Willow Springs', 36.7772216796875, 0.641883608046386, -82.2388916015625, -1.43533943163798, 218, 53, 'PPL', 'P'),
(121999, 'Willow Springs', 41.7408294677734, 0.728514906726119, -87.8602828979492, -1.53345121830288, 218, 18, 'PPL', 'P'),
(169001, 'Willow Springs', 41.038330078125, 0.716253979383503, -76.3169403076172, -1.33198188341589, 218, 45, 'PPL', 'P'),
(177053, 'Willow Springs', 43.1388893127441, 0.752915654160779, -88.1841735839844, -1.53910417719074, 218, 57, 'PPL', 'P'),
(179540, 'Willow Springs', 36.1894416809082, 0.631624911790319, -111.393058776855, -1.9441756395237, 218, 5, 'PPL', 'P'),
(186172, 'Willow Springs', 37.9952812194824, 0.663142757501134, -120.258056640625, -2.09889904042874, 218, 6, 'PPL', 'P'),
(209835, 'Willow Springs', 44.3116683959961, 0.773384510562046, -104.138328552246, -1.81755671076031, 218, 59, 'PPL', 'P'),
(143396, 'Willow Springs (historical)', 41.7836112976074, 0.72926159051675, -99.0944366455078, -1.72952418987304, 218, 35, 'PPL', 'P'),
(177303, 'Willow Springs (historical)', 40.1472206115723, 0.700701185196468, -80.7005615234375, -1.40849050679224, 218, 58, 'PPL', 'P'),
(189824, 'Willow Springs (historical)', 36.8205604553223, 0.642640012374996, -103.582496643066, -1.80785561385748, 218, 38, 'PPL', 'P'),
(84412, 'Willow Springs Park', 33.5213890075684, 0.585058608023902, -81.9138870239258, -1.42966703167416, 218, 48, 'PPL', 'P'),
(79419, 'Willow Street', 39.9791717529297, 0.697768179308936, -76.2766723632813, -1.33127907520422, 218, 45, 'PPL', 'P'),
(26101, 'Willow Tree', 34.098331451416, 0.595128153263546, -84.4336090087891, -1.47364447654492, 218, 13, 'PPL', 'P'),
(79420, 'Willow Tree', 39.809440612793, 0.694805812070386, -79.9891662597656, -1.39607431715807, 218, 45, 'PPL', 'P'),
(31545, 'Willow Valley', 38.6938896179199, 0.675335774235953, -86.7197189331055, -1.51354462178675, 218, 19, 'PPL', 'P'),
(179541, 'Willow Valley', 34.9119415283203, 0.609328327932931, -114.605827331543, -2.00024902890753, 218, 5, 'PPL', 'P'),
(186173, 'Willow Valley', 39.2719383239746, 0.685424627393501, -120.980827331543, -2.11151376872217, 218, 6, 'PPL', 'P'),
(77690, 'Willow View', 35.0583305358887, 0.611883298103725, -97.2647171020508, -1.69758955945162, 218, 42, 'PPL', 'P'),
(206529, 'Willow View Estates', 40.5922203063965, 0.70846789504152, -111.934722900391, -1.95362946191931, 218, 52, 'PPL', 'P'),
(70229, 'Willow Wew', 35.3033294677734, 0.616159336128984, -82.4727783203125, -1.43942152495685, 218, 33, 'PPL', 'P'),
(206530, 'Willow Wick Estates', 40.5897216796875, 0.70842428577867, -111.813888549805, -1.95152050465208, 218, 52, 'PPL', 'P'),
(26102, 'Willow Wind', 33.8658294677734, 0.591070228131565, -83.9016723632813, -1.46436043066879, 218, 13, 'PPL', 'P'),
(74840, 'Willow Wood', 38.5611114501953, 0.673018358034394, -82.4680633544922, -1.43933923327917, 218, 41, 'PPL', 'P'),
(84413, 'Willow Wood', 35.0097198486328, 0.611034881559453, -82.0175018310547, -1.43147545121238, 218, 48, 'PPL', 'P'),
(206531, 'Willow Wood', 41.2216682434082, 0.71945383401226, -112.071670532227, -1.95601964899766, 218, 52, 'PPL', 'P'),
(26103, 'Willow Woods', 33.5819396972656, 0.586115416923473, -83.7363891601563, -1.46147569457602, 218, 13, 'PPL', 'P'),
(70230, 'Willow Woods', 34.7955589294434, 0.6072970683905, -77.4199981689453, -1.35123387493608, 218, 33, 'PPL', 'P'),
(107653, 'Willow Woods', 38.8230590820313, 0.677590206677733, -77.2558288574219, -1.34836857991926, 218, 53, 'PPL', 'P'),
(197858, 'Willow Wynn Trailer Park', 47.6002807617188, 0.830781624165707, -114.118057250977, -1.99173583500893, 218, 31, 'PPL', 'P'),
(70231, 'Willowbend', 36.1116714477539, 0.630267565161733, -80.1377792358398, -1.39866810290175, 218, 33, 'PPL', 'P'),
(158411, 'Willowbend', 41.5263900756836, 0.724772233288176, -83.6961135864258, -1.46077275320629, 218, 41, 'PPL', 'P'),
(6845, 'Willowbrook', 34.6566696166992, 0.604872992587283, -86.5369415283203, -1.510354554275, 218, 2, 'PPL', 'P'),
(34433, 'Willowbrook', 38.1019401550293, 0.6650043071031, -97.9916687011719, -1.71027725835892, 218, 20, 'PPL', 'P'),
(52839, 'Willowbrook', 39.1188888549805, 0.682753410241124, -76.5430603027344, -1.33592842183528, 218, 25, 'PPL', 'P'),
(107656, 'Willowbrook', 36.7516708374023, 0.641437661721852, -76.5736083984375, -1.33646158668552, 218, 53, 'PPL', 'P'),
(122001, 'Willowbrook', 41.4577789306641, 0.723574742904022, -87.5363922119141, -1.52779825941502, 218, 18, 'PPL', 'P'),
(153846, 'Willowbrook', 40.6030616760254, 0.70865711263697, -74.1388931274414, -1.29396778885805, 218, 40, 'PPL', 'P'),
(186174, 'Willowbrook', 33.9169387817383, 0.591962253938687, -118.254173278809, -2.06392467793911, 218, 6, 'PPL', 'P'),
(158407, 'Willowbrook (historical)', 40.2188911437988, 0.701952071960478, -81.9388885498047, -1.43010339061877, 218, 41, 'PPL', 'P'),
(6847, 'Willowbrook Estates', 34.6580581665039, 0.604897227353202, -86.5475006103516, -1.51053884502244, 218, 2, 'PPL', 'P'),
(31542, 'Willowbrook Estates', 39.4775009155273, 0.689012371435028, -86.3649978637695, -1.50735357120065, 218, 19, 'PPL', 'P'),
(206533, 'Willowbrook Estates', 40.5052795410156, 0.70695049243142, -111.860282897949, -1.95233023878152, 218, 52, 'PPL', 'P'),
(52846, 'Willowbrook Hills', 38.5602798461914, 0.673003843806453, -76.5713882446289, -1.33642283769166, 218, 25, 'PPL', 'P'),
(179542, 'WillowBrook II', 33.5872192382813, 0.58620756229719, -112.182777404785, -1.9579588297454, 218, 5, 'PPL', 'P'),
(169002, 'Willowburn', 40.0369415283203, 0.69877645209764, -75.3666687011719, -1.31539651509521, 218, 45, 'PPL', 'P'),
(26104, 'Willowcreek', 33.6836090087891, 0.587889881157793, -84.2050018310547, -1.46965452859976, 218, 13, 'PPL', 'P'),
(201814, 'Willowcreek', 44.1147193908691, 0.769947101964054, -117.363327026367, -2.04837647770495, 218, 43, 'PPL', 'P'),
(206535, 'Willowcreek', 40.589168548584, 0.708414631819719, -111.809722900391, -1.95144780035432, 218, 52, 'PPL', 'P'),
(206537, 'Willowcreek East', 40.6055603027344, 0.70870072189982, -111.809997558594, -1.95145259404428, 218, 52, 'PPL', 'P'),
(206538, 'Willowcreek Oaks', 40.6066703796387, 0.708720096396751, -111.805557250977, -1.95137509605656, 218, 52, 'PPL', 'P'),
(26105, 'Willowcrest', 33.0597190856934, 0.577000947829759, -85.0897216796875, -1.48509580291615, 218, 13, 'PPL', 'P'),
(206539, 'Willowcrest', 40.6074981689453, 0.708734544045664, -111.801109313965, -1.95129746491079, 218, 52, 'PPL', 'P'),
(34434, 'Willowdale', 37.5152816772461, 0.654765185081045, -98.3013916015625, -1.71568294273957, 218, 20, 'PPL', 'P'),
(44167, 'Willowdale', 30.0058307647705, 0.523700541641454, -90.1947174072266, -1.57419478666195, 218, 22, 'PPL', 'P'),
(52842, 'Willowdale', 39.1647186279297, 0.683553290674529, -76.6347198486328, -1.33752818270209, 218, 25, 'PPL', 'P'),
(71582, 'Willowdale', 39.8805618286133, 0.696047111454472, -74.9822235107422, -1.30868668072875, 218, 37, 'PPL', 'P'),
(79421, 'Willowdale', 39.8741683959961, 0.695935525004798, -75.7180633544922, -1.32152950876955, 218, 45, 'PPL', 'P'),
(112077, 'Willowdale', 39.0277786254883, 0.681163236754237, -81.6894378662109, -1.42574965486871, 218, 58, 'PPL', 'P'),
(126659, 'Willowdale', 42.6719398498535, 0.744765848592919, -71.3847198486328, -1.24589839697239, 218, 23, 'PPL', 'P'),
(201815, 'Willowdale', 44.8055610656738, 0.782004563799388, -120.941940307617, -2.11083506211836, 218, 43, 'PPL', 'P'),
(12878, 'Willowdale (historical)', 34.7277793884277, 0.606114092234287, -92.1688919067383, -1.60865063168734, 218, 4, 'PPL', 'P'),
(158408, 'Willowdell', 40.3063888549805, 0.703479195108556, -84.4538879394531, -1.47399841065379, 218, 41, 'PPL', 'P'),
(153847, 'Willowemoc', 41.9188919067383, 0.731622682560187, -74.6727828979492, -1.30328592319613, 218, 40, 'PPL', 'P'),
(158409, 'Willowick', 41.6330604553223, 0.726633982627223, -81.4688873291016, -1.42190032182911, 218, 41, 'PPL', 'P'),
(169003, 'Willowmere', 40.1572189331055, 0.700875688826895, -75.2149963378906, -1.31274933297167, 218, 45, 'PPL', 'P'),
(44168, 'Willowood Acres', 30.5563907623291, 0.533309626328623, -91.0672225952148, -1.58942287493307, 218, 22, 'PPL', 'P'),
(52844, 'Willows', 39.538330078125, 0.690074040603588, -76.4361114501953, -1.33406181222725, 218, 25, 'PPL', 'P'),
(62345, 'Willows', 32.0361099243164, 0.559135597710153, -90.896110534668, -1.58643640608666, 218, 30, 'PPL', 'P'),
(126660, 'Willows', 42.5583305358887, 0.7427829920033, -71.5400009155273, -1.24860856285571, 218, 23, 'PPL', 'P'),
(186176, 'Willows', 39.5244407653809, 0.689831626365364, -122.192497253418, -2.13266139830627, 218, 6, 'PPL', 'P'),
(209194, 'Willows', 47.7036094665527, 0.832585050276881, -122.151107788086, -2.13193901586059, 218, 56, 'PPL', 'P'),
(74843, 'Willows (historical)', 39.9327812194824, 0.696958511758525, -83.3333282470703, -1.45444095455657, 218, 41, 'PPL', 'P'),
(206540, 'Willows Condominium', 40.6536102294922, 0.709539351327086, -111.875556945801, -1.95259682120663, 218, 52, 'PPL', 'P'),
(118482, 'Willows Mobile Home Court', 41.7374992370605, 0.728456783235328, -92.7138900756836, -1.61816264415277, 218, 16, 'PPL', 'P'),
(179543, 'Willows West', 33.4980583190918, 0.584651410693229, -112.222778320313, -1.95865697742516, 218, 5, 'PPL', 'P'),
(52845, 'Willowstone', 39.538330078125, 0.690074040603588, -75.8597183227539, -1.32400185436753, 218, 25, 'PPL', 'P'),
(112078, 'Willowton', 37.3488883972168, 0.651861074491341, -80.8863906860352, -1.41173383752579, 218, 58, 'PPL', 'P'),
(38900, 'Willowtown', 37.4519386291504, 0.653659640333526, -85.4219436645508, -1.49089417039952, 218, 21, 'PPL', 'P'),
(62346, 'Willowtown', 31.6319408416748, 0.552081516483292, -89.4749984741211, -1.56163332159032, 218, 30, 'PPL', 'P'),
(190934, 'Willowtown (historical)', 39.4916687011719, 0.689259645942242, -118.970283508301, -2.07642315925096, 218, 39, 'PPL', 'P'),
(74844, 'Willowvale', 38.4116706848145, 0.670410124641797, -82.5127792358398, -1.44011967263662, 218, 41, 'PPL', 'P'),
(99139, 'Willowview', 34.3583297729492, 0.59966598002396, -99.7050018310547, -1.74018056265888, 218, 51, 'PPL', 'P'),
(58306, 'Willowville', 37.8180618286133, 0.660049695632089, -93.9775009155273, -1.64021681377194, 218, 29, 'PPL', 'P'),
(74845, 'Willowville', 39.0955581665039, 0.682346212910451, -84.2483291625977, -1.47041073319129, 218, 41, 'PPL', 'P'),
(186177, 'Willowville', 33.8055610656738, 0.590018346080011, -118.188331604004, -2.06277552392874, 218, 6, 'PPL', 'P'),
(91914, 'Wills', 36.5336112976074, 0.637631804787048, -81.7936096191406, -1.42756779494491, 218, 50, 'PPL', 'P'),
(112079, 'Wills', 38.457218170166, 0.671205078227186, -81.4972229003906, -1.42239487084354, 218, 58, 'PPL', 'P'),
(177056, 'Wills', 46.5391693115234, 0.812261735629187, -91.5391693115234, -1.59765989902663, 218, 57, 'PPL', 'P'),
(6848, 'Wills (historical)', 34.3427810668945, 0.599394603908881, -85.9052810668945, -1.49932999946846, 218, 2, 'PPL', 'P'),
(91915, 'Wills (historical)', 35.0374984741211, 0.611519710035902, -87.3430633544922, -1.52442403431389, 218, 50, 'PPL', 'P'),
(91916, 'Wills Chapel', 35.9425010681152, 0.62731498504019, -87.7161102294922, -1.53093493054692, 218, 50, 'PPL', 'P'),
(107657, 'Wills Corner', 36.8805618286133, 0.643687233894642, -76.5822219848633, -1.33661192212905, 218, 53, 'PPL', 'P'),
(79422, 'Wills Creek', 39.8347206115723, 0.695247031283985, -78.7172164916992, -1.37387460578533, 218, 45, 'PPL', 'P'),
(158412, 'Wills Creek', 40.1800003051758, 0.701273298777644, -81.850830078125, -1.42856648035369, 218, 41, 'PPL', 'P'),
(6849, 'Wills Crossroads', 31.5561103820801, 0.550758025290063, -85.1797180175781, -1.48666653532708, 218, 2, 'PPL', 'P'),
(44169, 'Wills Point', 29.7466697692871, 0.519177328977522, -90.0058288574219, -1.57089805954854, 218, 22, 'PPL', 'P'),
(99140, 'Wills Point', 32.709171295166, 0.570882734699465, -96.008056640625, -1.67565669682011, 218, 51, 'PPL', 'P'),
(158413, 'Wills Town (historical)', 40.1536102294922, 0.700812705067115, -81.9124984741211, -1.42964279690824, 218, 41, 'PPL', 'P'),
(6850, 'Wills Valley', 34.4777793884277, 0.601750769104301, -85.7141723632813, -1.49599452336119, 218, 2, 'PPL', 'P'),
(153848, 'Willsboro', 44.3572196960449, 0.774179530726462, -73.3925018310547, -1.28094080322787, 218, 40, 'PPL', 'P'),
(153849, 'Willsboro Point', 44.4086112976074, 0.775076483381601, -73.3786087036133, -1.28069832241062, 218, 40, 'PPL', 'P'),
(118483, 'Willsburg (historical)', 40.5991706848145, 0.708589202029173, -95.2541732788086, -1.66249894998041, 218, 16, 'PPL', 'P'),
(153851, 'Willseyville', 42.2900009155273, 0.738099756647368, -76.3786087036133, -1.33305819997045, 218, 40, 'PPL', 'P'),
(158415, 'Willshire', 40.7486114501953, 0.71119743542177, -84.7911071777344, -1.47988399666286, 218, 41, 'PPL', 'P'),
(52847, 'Willson Hills', 39.0952796936035, 0.682341352641461, -77.041389465332, -1.34462590648132, 218, 25, 'PPL', 'P'),
(6851, 'Willstown (historical)', 34.3708305358887, 0.599884159496264, -85.8152770996094, -1.49775913389947, 218, 2, 'PPL', 'P'),
(44170, 'Willswood', 29.9261093139648, 0.522309139840428, -90.228889465332, -1.57479120158807, 218, 22, 'PPL', 'P'),
(84415, 'Willtown (historical)', 33.6180610656738, 0.586745853732522, -79.4505615234375, -1.38667389114231, 218, 48, 'PPL', 'P'),
(84416, 'Willtown Bluff', 32.6791687011719, 0.570359090650128, -80.413330078125, -1.40347737235627, 218, 48, 'PPL', 'P'),
(52848, 'Willwood', 39.6986083984375, 0.692871425012607, -76.4841690063477, -1.33490057481257, 218, 25, 'PPL', 'P'),
(209836, 'Willwood', 44.6966705322266, 0.78010406546648, -108.759170532227, -1.89820561752535, 218, 59, 'PPL', 'P'),
(209196, 'Willy Dick Crossing', 46.2941703796387, 0.807985697603928, -120.899719238281, -2.11009816544474, 218, 56, 'PPL', 'P'),
(18644, 'Wilma', 30.1541690826416, 0.526289533695174, -84.9644393920898, -1.48290921450314, 218, 12, 'PPL', 'P'),
(209195, 'Wilma (historical)', 46.6816711425781, 0.814748861771212, -117.148330688477, -2.04462408372903, 218, 56, 'PPL', 'P'),
(44171, 'Wilman', 32.7324981689453, 0.571289865451111, -91.1611099243164, -1.5910615179518, 218, 22, 'PPL', 'P'),
(12879, 'Wilmar', 33.6288909912109, 0.58693487159089, -91.9313888549805, -1.60450542145063, 218, 4, 'PPL', 'P'),
(70232, 'Wilmar', 35.3950004577637, 0.617759296732876, -77.1438903808594, -1.34641488494358, 218, 33, 'PPL', 'P'),
(118484, 'Wilmar', 42.8183288574219, 0.747320818763713, -92.829719543457, -1.62018424973625, 218, 16, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(6852, 'Wilmer', 30.8230590820313, 0.537963866518186, -88.3613891601563, -1.54219717248075, 218, 2, 'PPL', 'P'),
(44172, 'Wilmer', 30.8138904571533, 0.537803843826186, -90.3625030517578, -1.5771231985966, 218, 22, 'PPL', 'P'),
(99141, 'Wilmer', 32.5888900756836, 0.568783431391183, -96.6849975585938, -1.68747154468014, 218, 51, 'PPL', 'P'),
(158417, 'Wilmer', 41.3963890075684, 0.722503286618456, -82.6958312988281, -1.44331453383833, 218, 41, 'PPL', 'P'),
(169005, 'Wilmer', 41.3616714477539, 0.721897350891435, -78.3497161865234, -1.36746051545793, 218, 45, 'PPL', 'P'),
(169006, 'Wilmerding', 40.3908309936523, 0.704952988455806, -79.8102798461914, -1.39295216025411, 218, 45, 'PPL', 'P'),
(52849, 'Wilmers', 39.1549987792969, 0.683383647313091, -76.0491714477539, -1.32730843517697, 218, 25, 'PPL', 'P'),
(192438, 'Wilmeth', 31.9780597686768, 0.558122431362946, -100.120002746582, -1.74742369503362, 218, 51, 'PPL', 'P'),
(122002, 'Wilmette', 42.0722198486328, 0.734298759981553, -87.7227783203125, -1.53105131068655, 218, 18, 'PPL', 'P'),
(14869, 'Wilmington', 39.7458305358887, 0.69369560679096, -75.5469436645508, -1.31854290676508, 218, 10, 'PPL', 'P'),
(26107, 'Wilmington', 31.9816703796387, 0.55818544841224, -80.9972229003906, -1.41366822458357, 218, 13, 'PPL', 'P'),
(31543, 'Wilmington', 39.0625, 0.681769239060285, -84.9466705322266, -1.4825990893942, 218, 19, 'PPL', 'P'),
(34436, 'Wilmington', 38.7444381713867, 0.676218012926069, -95.9591674804688, -1.67480342000685, 218, 20, 'PPL', 'P'),
(70233, 'Wilmington', 34.2255592346191, 0.597348696980454, -77.9449996948242, -1.36039688014066, 218, 33, 'PPL', 'P'),
(74846, 'Wilmington', 39.4452781677246, 0.688449978391831, -83.82861328125, -1.46308530913886, 218, 41, 'PPL', 'P'),
(107658, 'Wilmington', 37.8491706848145, 0.660592647599329, -78.2016677856445, -1.36487658341028, 218, 53, 'PPL', 'P'),
(122003, 'Wilmington', 41.3077812194824, 0.720956788973447, -88.1466674804688, -1.53844957219479, 218, 18, 'PPL', 'P'),
(126662, 'Wilmington', 42.5463905334473, 0.742574599648001, -71.1741714477539, -1.24222363414225, 218, 23, 'PPL', 'P'),
(138856, 'Wilmington', 43.5469398498535, 0.760037479547869, -91.5422210693359, -1.59771316224844, 218, 28, 'PPL', 'P'),
(153852, 'Wilmington', 44.3883285522461, 0.774722482693702, -73.8158264160156, -1.28832921104008, 218, 40, 'PPL', 'P'),
(172805, 'Wilmington', 42.8683280944824, 0.748193470073905, -72.871940612793, -1.27185529601101, 218, 55, 'PPL', 'P'),
(186179, 'Wilmington', 33.7799987792969, 0.589572200018396, -118.261672973633, -2.06405557230669, 218, 6, 'PPL', 'P'),
(70234, 'Wilmington Beach', 34.0186080932617, 0.593736718173007, -77.8988876342773, -1.35959207285924, 218, 33, 'PPL', 'P'),
(26108, 'Wilmington Island', 32.0033302307129, 0.558563484128976, -80.9738922119141, -1.41326102725289, 218, 13, 'PPL', 'P'),
(126663, 'Wilmington Junction', 42.5902786254883, 0.743340591356535, -71.1672210693359, -1.24210232715459, 218, 23, 'PPL', 'P'),
(14871, 'Wilmington Manor', 39.6866683959961, 0.692663032657309, -75.584716796875, -1.31920217229293, 218, 10, 'PPL', 'P'),
(14872, 'Wilmington Manor Gardens', 39.672779083252, 0.692420618419084, -75.581672668457, -1.31914904222918, 218, 10, 'PPL', 'P'),
(26109, 'Wilmington Park', 31.9936103820801, 0.558393840767538, -80.9883270263672, -1.41351296229202, 218, 13, 'PPL', 'P'),
(14873, 'Wilmont', 39.8069381713867, 0.694762136228509, -75.5374984741211, -1.31837805709361, 218, 10, 'PPL', 'P'),
(138858, 'Wilmont', 43.764720916748, 0.763838476213685, -95.8269424438477, -1.67249565776424, 218, 28, 'PPL', 'P'),
(107659, 'Wilmont Farms', 37.2841682434082, 0.650731494714984, -80.0063934326172, -1.39637498804514, 218, 53, 'PPL', 'P'),
(107660, 'Wilmont Park', 37.2827796936035, 0.650707259949064, -80.0033264160156, -1.39632145850723, 218, 53, 'PPL', 'P'),
(177057, 'Wilmoore Heights', 43.8886108398438, 0.766000763281747, -88.8083267211914, -1.54999770447165, 218, 57, 'PPL', 'P'),
(34438, 'Wilmore', 37.3358306884766, 0.651633174481057, -99.209716796875, -1.73153620807659, 218, 20, 'PPL', 'P'),
(38902, 'Wilmore', 37.8619384765625, 0.660815487603542, -84.6616668701172, -1.47762483711015, 218, 21, 'PPL', 'P'),
(112081, 'Wilmore', 37.458610534668, 0.65377608705219, -81.7525024414063, -1.42685033934724, 218, 58, 'PPL', 'P'),
(169010, 'Wilmore', 40.3886108398438, 0.704914239461946, -78.7188873291016, -1.37390376739927, 218, 45, 'PPL', 'P'),
(169011, 'Wilmore Heights', 40.3777809143066, 0.704725221603577, -78.7161102294922, -1.37385529786743, 218, 45, 'PPL', 'P'),
(12881, 'Wilmot', 33.0572204589844, 0.576957338566908, -91.5733337402344, -1.5982561807947, 218, 4, 'PPL', 'P'),
(34439, 'Wilmot', 37.3761100769043, 0.652336182429811, -96.8755569458008, -1.69079743340749, 218, 20, 'PPL', 'P'),
(62347, 'Wilmot', 33.3050003051758, 0.581281912703034, -90.8925018310547, -1.58637342232688, 218, 30, 'PPL', 'P'),
(70237, 'Wilmot', 35.4022216796875, 0.617885330831464, -83.3130569458008, -1.45408715360575, 218, 33, 'PPL', 'P'),
(107661, 'Wilmot', 38.1555595397949, 0.665940141910154, -77.0722198486328, -1.34516399817957, 218, 53, 'PPL', 'P'),
(124025, 'Wilmot', 41.310001373291, 0.720995537967307, -85.6416702270508, -1.49472912236924, 218, 19, 'PPL', 'P'),
(133756, 'Wilmot', 43.4638900756836, 0.758587987545566, -83.1902770996094, -1.45194424103462, 218, 27, 'PPL', 'P'),
(144680, 'Wilmot', 43.4516716003418, 0.758374734921278, -71.9141693115234, -1.25513903332275, 218, 36, 'PPL', 'P'),
(158418, 'Wilmot', 40.6558303833008, 0.709578100320947, -81.6322174072266, -1.42475096945993, 218, 41, 'PPL', 'P'),
(169013, 'Wilmot', 41.5947189331055, 0.725964796824313, -76.3097229003906, -1.33185591589633, 218, 45, 'PPL', 'P'),
(171633, 'Wilmot', 45.4086112976074, 0.792529775901544, -96.8574981689453, -1.69048224829247, 218, 49, 'PPL', 'P'),
(177058, 'Wilmot', 42.5127792358398, 0.741987971838884, -88.1819381713867, -1.53906516188077, 218, 57, 'PPL', 'P'),
(179544, 'Wilmot', 32.1222190856934, 0.560638486092312, -110.843887329102, -1.93459078960245, 218, 5, 'PPL', 'P'),
(144677, 'Wilmot Flat', 43.417781829834, 0.757783246843171, -71.8955612182617, -1.25481426082781, 218, 36, 'PPL', 'P'),
(153854, 'Wilmot Woods', 40.9799995422363, 0.715235919477793, -73.7808303833008, -1.28771841504407, 218, 40, 'PPL', 'P'),
(112080, 'Wilmoth (historical)', 39.0352783203125, 0.681294131121815, -79.9833297729492, -1.39597245124637, 218, 58, 'PPL', 'P'),
(52850, 'Wilna', 39.4833297729492, 0.689114104188669, -76.3741683959961, -1.33298070198273, 218, 25, 'PPL', 'P'),
(158419, 'Wilna', 41.4561080932617, 0.723545581290086, -84.45361328125, -1.47399361696382, 218, 41, 'PPL', 'P'),
(189825, 'Wilna', 32.2069396972656, 0.562117139708551, -108.234169006348, -1.88904261232077, 218, 38, 'PPL', 'P'),
(138861, 'Wilno', 44.4997215270996, 0.776666656868487, -96.2311096191406, -1.67954970570159, 218, 28, 'PPL', 'P'),
(138862, 'Wilpen', 47.440559387207, 0.827993960294666, -92.8277816772461, -1.62015042759041, 218, 28, 'PPL', 'P'),
(169015, 'Wilpen', 40.2811088562012, 0.703037975894958, -79.195556640625, -1.38222321632857, 218, 45, 'PPL', 'P'),
(34440, 'Wilroads', 37.7016716003418, 0.658018302931604, -99.8933334350586, -1.74346756923431, 218, 20, 'PPL', 'P'),
(34441, 'Wilroads Gardens', 37.7241706848145, 0.658410986034336, -99.9327774047852, -1.7441559963761, 218, 20, 'PPL', 'P'),
(107665, 'Wilroy', 36.7863883972168, 0.642043597448873, -76.5338897705078, -1.33576836585377, 218, 53, 'PPL', 'P'),
(107662, 'Wilroy Acres', 36.7480583190918, 0.641374611383045, -76.5605621337891, -1.33623388641231, 218, 53, 'PPL', 'P'),
(197859, 'Wilsall', 45.9938888549805, 0.802744796315734, -110.659439086914, -1.93137156047676, 218, 31, 'PPL', 'P'),
(26110, 'Wilscot', 34.7949981689453, 0.607287281273494, -84.2436065673828, -1.47032830835555, 218, 13, 'PPL', 'P'),
(34442, 'Wilsey', 38.6361083984375, 0.674327301710168, -96.6750030517578, -1.68729710762874, 218, 20, 'PPL', 'P'),
(192439, 'Wilsey', 34.4508285522461, 0.601280388276766, -102.955001831055, -1.7969037633487, 218, 51, 'PPL', 'P'),
(186180, 'Wilseyville', 38.3791694641113, 0.66984287132961, -120.513610839844, -2.1033593026224, 218, 6, 'PPL', 'P'),
(158420, 'Wilseyville (historical)', 41.3499984741211, 0.721693619068044, -84.6711120605469, -1.47778968678162, 218, 41, 'PPL', 'P'),
(26111, 'Wilshire', 33.8202781677246, 0.59027520796715, -84.2111129760742, -1.46976118820142, 218, 13, 'PPL', 'P'),
(124026, 'Wilshire', 40.2755584716797, 0.702941103410306, -86.4886093139648, -1.50951099799972, 218, 19, 'PPL', 'P'),
(206542, 'Wilshire Condominium', 41.1566696166992, 0.718319393966914, -111.934997558594, -1.95363425560928, 218, 52, 'PPL', 'P'),
(79423, 'Wilshire Hills', 39.9766693115234, 0.697724503467059, -76.6363906860352, -1.33755734431603, 218, 45, 'PPL', 'P'),
(70239, 'Wilshire Park', 35.584171295166, 0.621060950694302, -82.6119384765625, -1.441850327871, 218, 33, 'PPL', 'P'),
(112664, 'Wilsie', 38.6855583190918, 0.675190365640435, -80.8861083984375, -1.41172891067777, 218, 58, 'PPL', 'P'),
(177694, 'Wilsie', 32.7999992370605, 0.572467981338335, -115.60221862793, -2.01763933766769, 218, 6, 'PPL', 'P'),
(122005, 'Wilsman', 41.1711082458496, 0.718571395585063, -88.9319381713867, -1.55215513127072, 218, 18, 'PPL', 'P'),
(565, 'Wilson', 37.7805595397949, 0.659395157215175, -87.6580581665039, -1.5299217309102, 218, 21, 'PPL', 'P'),
(6854, 'Wilson', 31.5458297729492, 0.550578594811619, -88.0616683959961, -1.53696605830957, 218, 2, 'PPL', 'P'),
(12884, 'Wilson', 35.2102813720703, 0.614535340496254, -92.929443359375, -1.62192475866667, 218, 4, 'PPL', 'P'),
(14874, 'Wilson', 39.660831451416, 0.692212092905731, -75.7383270263672, -1.32188317656231, 218, 10, 'PPL', 'P'),
(18645, 'Wilson', 28.6430606842041, 0.499915716787901, -80.6966705322266, -1.40842259618444, 218, 12, 'PPL', 'P'),
(34443, 'Wilson', 38.8250007629395, 0.677624095402604, -98.4749984741211, -1.71871295426981, 218, 20, 'PPL', 'P'),
(44173, 'Wilson', 30.9200000762939, 0.539655806048227, -91.1155624389648, -1.59026656436641, 218, 22, 'PPL', 'P'),
(52855, 'Wilson', 39.6580581665039, 0.692163689952919, -77.8488922119141, -1.35871948812807, 218, 25, 'PPL', 'P'),
(70241, 'Wilson', 35.7211112976074, 0.623451004614594, -77.9158325195313, -1.35988781689829, 218, 33, 'PPL', 'P'),
(74847, 'Wilson', 39.8566703796387, 0.695630127006793, -81.0669403076172, -1.41488502288562, 218, 41, 'PPL', 'P'),
(77695, 'Wilson', 35.5074996948242, 0.619722778825564, -96.0344390869141, -1.67611715737259, 218, 42, 'PPL', 'P'),
(84417, 'Wilson', 33.6630592346191, 0.587531219937986, -80.1186065673828, -1.39833347671078, 218, 48, 'PPL', 'P'),
(107664, 'Wilson', 36.9316711425781, 0.644579259701764, -81.2266693115234, -1.41767281991472, 218, 53, 'PPL', 'P'),
(112084, 'Wilson', 38.3852806091309, 0.669949530931268, -81.5936126708984, -1.42407718970414, 218, 58, 'PPL', 'P'),
(114298, 'Wilson', 41.811939239502, 0.729756006373123, -72.6577835083008, -1.26811754942109, 218, 8, 'PPL', 'P'),
(122007, 'Wilson', 42.3722190856934, 0.73953473442173, -88.1397171020508, -1.53832826520714, 218, 18, 'PPL', 'P'),
(124027, 'Wilson', 41.6197204589844, 0.726401155768923, -87.1591720581055, -1.52121452572618, 218, 19, 'PPL', 'P'),
(133757, 'Wilson', 45.7052803039551, 0.797707626850931, -87.4380569458008, -1.52608198525052, 218, 27, 'PPL', 'P'),
(138863, 'Wilson', 43.9599990844727, 0.767246723197741, -91.684440612793, -1.60019536154244, 218, 28, 'PPL', 'P'),
(139531, 'Wilson', 40.0663909912109, 0.699290442188025, -92.3833312988281, -1.61239330512528, 218, 29, 'PPL', 'P'),
(144679, 'Wilson', 42.9169387817383, 0.749041886618177, -71.3683319091797, -1.24561237347132, 218, 36, 'PPL', 'P'),
(153856, 'Wilson', 43.3097190856934, 0.755897196159177, -78.8263931274414, -1.37578009754528, 218, 40, 'PPL', 'P'),
(169017, 'Wilson', 40.6838912963867, 0.710067855645412, -75.2422180175781, -1.31322444091014, 218, 45, 'PPL', 'P'),
(177060, 'Wilson', 44.9536094665527, 0.784588495847037, -92.1733322143555, -1.60872812967506, 218, 57, 'PPL', 'P'),
(186181, 'Wilson', 38.978328704834, 0.68030017282397, -121.624717712402, -2.12275177589009, 218, 6, 'PPL', 'P'),
(192440, 'Wilson', 33.3169403076172, 0.581490305058332, -101.723609924316, -1.7754119201937, 218, 51, 'PPL', 'P'),
(195805, 'Wilson', 43.3613891601563, 0.756799009083305, -116.65193939209, -2.03596042122884, 218, 17, 'PPL', 'P'),
(206544, 'Wilson', 41.2291717529297, 0.719584794958865, -112.024436950684, -1.95519526748223, 218, 52, 'PPL', 'P'),
(209197, 'Wilson', 46.4530601501465, 0.810758847247028, -122.553611755371, -2.13896403534205, 218, 56, 'PPL', 'P'),
(209837, 'Wilson', 43.5008316040039, 0.759232738845474, -110.874443054199, -1.93512408761073, 218, 59, 'PPL', 'P'),
(52856, 'Wilson (historical)', 38.7374992370605, 0.676096905675498, -76.6263885498047, -1.33738277410657, 218, 25, 'PPL', 'P'),
(62348, 'Wilson (historical)', 31.1847190856934, 0.544276024354865, -88.7444381713867, -1.54888263892323, 218, 30, 'PPL', 'P'),
(70242, 'Wilson (historical)', 35.3894386291504, 0.617662224511143, -81.4747161865234, -1.42200205458275, 218, 33, 'PPL', 'P'),
(74848, 'Wilson (historical)', 39.9055595397949, 0.696483403820055, -83.4286117553711, -1.45610396549927, 218, 41, 'PPL', 'P'),
(118485, 'Wilson (historical)', 41.6344413757324, 0.726658084235088, -93.0688934326172, -1.6243586215869, 218, 16, 'PPL', 'P'),
(177304, 'Wilson (historical)', 40.1672210693359, 0.70105025903635, -80.688606262207, -1.40828184812083, 218, 58, 'PPL', 'P'),
(190935, 'Wilson (historical)', 39.1544418334961, 0.683373926775112, -116.693061828613, -2.03667814314262, 218, 39, 'PPL', 'P'),
(70243, 'Wilson Acres', 35.6133308410645, 0.621569880778616, -77.3555603027344, -1.35010922200774, 218, 33, 'PPL', 'P'),
(192442, 'Wilson and Bargo Colonia', 28.67799949646, 0.500525514098502, -100.474998474121, -1.75361953930969, 218, 51, 'PPL', 'P'),
(6855, 'Wilson Bend', 34.0149993896484, 0.593673734413227, -87.1294403076172, -1.52069560878778, 218, 2, 'PPL', 'P'),
(58309, 'Wilson City', 36.9225006103516, 0.644419203720251, -89.2238922119141, -1.55725069054243, 218, 29, 'PPL', 'P'),
(18646, 'Wilson Corner', 28.8080596923828, 0.502795492743145, -81.3630599975586, -1.42005328645509, 218, 12, 'PPL', 'P'),
(31546, 'Wilson Corner', 39.4383316040039, 0.688328737983205, -85.7552795410156, -1.49671197895885, 218, 19, 'PPL', 'P'),
(129343, 'Wilson Corner', 44.6444396972656, 0.779192465425346, -68.5577774047852, -1.19655894356287, 218, 26, 'PPL', 'P'),
(186182, 'Wilson Corner', 35.4686088562012, 0.61904400564273, -120.378059387207, -2.10099348346803, 218, 6, 'PPL', 'P'),
(144689, 'Wilson Corners', 42.7922210693359, 0.746865151901201, -71.1866683959961, -1.24244174703552, 218, 36, 'PPL', 'P'),
(153857, 'Wilson Corners', 42.7347183227539, 0.745861539644404, -76.3936080932617, -1.3333199887056, 218, 40, 'PPL', 'P'),
(79424, 'Wilson Creek', 39.9174995422363, 0.696691796175353, -79.1036071777344, -1.38061839545568, 218, 45, 'PPL', 'P'),
(153858, 'Wilson Creek', 42.2861099243164, 0.738031846039572, -76.1452789306641, -1.32898582718955, 218, 40, 'PPL', 'P'),
(209198, 'Wilson Creek', 47.4233283996582, 0.827693222828569, -119.119720458984, -2.07903132606453, 218, 56, 'PPL', 'P'),
(190938, 'Wilson Creek (historical)', 38.4236106872559, 0.670618516997096, -114.342498779297, -1.99565307865633, 218, 39, 'PPL', 'P'),
(70246, 'Wilson Creek Heights', 35.0816688537598, 0.612290628592453, -77.1055603027344, -1.34574589887775, 218, 33, 'PPL', 'P'),
(84419, 'Wilson Crossroads', 34.2227783203125, 0.597300160869588, -79.8966674804688, -1.39445990890526, 218, 48, 'PPL', 'P'),
(6856, 'Wilson Dam Village Number Three (historical)', 34.8069381713867, 0.607495673628793, -87.6291732788086, -1.52941759451585, 218, 2, 'PPL', 'P'),
(107667, 'Wilson Fork', 36.5613899230957, 0.638116633263496, -78.3066711425781, -1.36670923771442, 218, 53, 'PPL', 'P'),
(91918, 'Wilson Gap', 36.4527816772461, 0.636221061778605, -83.9036102294922, -1.46439425281463, 218, 50, 'PPL', 'P'),
(186183, 'Wilson Grove', 38.5166702270508, 0.672242712366908, -122.853607177734, -2.1441999432032, 218, 6, 'PPL', 'P'),
(28996, 'Wilson Heights', 38.7127799987793, 0.675665473578905, -89.9336090087891, -1.5696375854046, 218, 18, 'PPL', 'P'),
(91919, 'Wilson Heights', 35.2536087036133, 0.615291545087782, -84.7888870239258, -1.479845247669, 218, 50, 'PPL', 'P'),
(107668, 'Wilson Heights', 38.1069412231445, 0.665091592207827, -78.9902801513672, -1.37864046571408, 218, 53, 'PPL', 'P'),
(91920, 'Wilson Hill', 35.4155616760254, 0.618118157689764, -86.8649978637695, -1.51608021746062, 218, 50, 'PPL', 'P'),
(107669, 'Wilson Hill', 36.6402816772461, 0.639493554126095, -83.2827835083008, -1.45355878244548, 218, 53, 'PPL', 'P'),
(12887, 'Wilson Junction', 35.8472213745117, 0.625652040676517, -90.0616683959961, -1.57187264334945, 218, 4, 'PPL', 'P'),
(6858, 'Wilson Lake Shores', 34.8030586242676, 0.607427962758077, -87.5788879394531, -1.52853994977861, 218, 2, 'PPL', 'P'),
(84422, 'Wilson Landing', 33.833610534668, 0.590507901667395, -79.003059387207, -1.37886350545538, 218, 48, 'PPL', 'P'),
(26113, 'Wilson Mill', 34.7169418334961, 0.605924941217864, -84.2480621337891, -1.47040607265938, 218, 13, 'PPL', 'P'),
(52857, 'Wilson Mill', 39.6166687011719, 0.691441307507235, -76.2022171020508, -1.32997958575032, 218, 25, 'PPL', 'P'),
(169018, 'Wilson Mills', 41.5497207641602, 0.725179430618849, -79.9111099243164, -1.39471197710244, 218, 45, 'PPL', 'P'),
(107671, 'Wilson Pines', 36.7383308410645, 0.641204834863552, -76.5505599975586, -1.33605931620286, 218, 53, 'PPL', 'P'),
(18647, 'Wilson Place', 28.8077793121338, 0.502790599184642, -81.3536071777344, -1.41988830362556, 218, 12, 'PPL', 'P'),
(186184, 'Wilson Place', 39.6733283996582, 0.692430205799008, -122.401672363281, -2.13631219268661, 218, 6, 'PPL', 'P'),
(192441, 'Wilson Place', 30.4027805328369, 0.53062862205924, -100.085830688477, -1.7468272801075, 218, 51, 'PPL', 'P'),
(194482, 'Wilson Place', 40.7619400024414, 0.711430062542988, -108.893058776855, -1.90054240822384, 218, 7, 'PPL', 'P'),
(44174, 'Wilson Point', 31.1455593109131, 0.54359255735061, -92.2544403076172, -1.61014373295249, 218, 22, 'PPL', 'P'),
(52858, 'Wilson Point', 39.3158302307129, 0.686190685681062, -76.4180603027344, -1.33374676027029, 218, 25, 'PPL', 'P'),
(44175, 'Wilson Point (historical)', 32.9241714477539, 0.574635195254414, -91.0869369506836, -1.58976695534591, 218, 22, 'PPL', 'P'),
(6859, 'Wilson Quarters', 31.1597194671631, 0.543839698699769, -85.3444366455078, -1.48954141772382, 218, 2, 'PPL', 'P'),
(143402, 'Wilson Ranch', 42.6949996948242, 0.745168318812657, -99.0769424438477, -1.72921885845406, 218, 35, 'PPL', 'P'),
(107672, 'Wilson Springs', 37.9205589294434, 0.661838607515323, -79.4358291625977, -1.38641676293906, 218, 53, 'PPL', 'P'),
(52859, 'Wilson Terrace', 39.4358291625977, 0.688285062141327, -76.9913864135742, -1.3437531885921, 218, 25, 'PPL', 'P'),
(6860, 'Wilson Trailer Park', 31.7630596160889, 0.554369970807997, -85.9625015258789, -1.50032868487724, 218, 2, 'PPL', 'P'),
(212235, 'Wilson Village', 61.2363891601563, 1.06877661287729, -149.81916809082, -2.61483776578364, 218, 1, 'PPL', 'P'),
(186185, 'Wilsona (historical)', 34.6147193908691, 0.604140823024592, -117.768058776855, -2.05544037933833, 218, 6, 'PPL', 'P'),
(186186, 'Wilsona Gardens', 34.667781829834, 0.605066937293668, -117.824722290039, -2.05642934420914, 218, 6, 'PPL', 'P'),
(112085, 'Wilsonburg', 39.2924995422363, 0.685783488350389, -80.3963928222656, -1.40318176147527, 218, 58, 'PPL', 'P'),
(28997, 'Wilsonburg (historical)', 38.7597198486328, 0.676484728509241, -88.2388916015625, -1.54005918675764, 218, 18, 'PPL', 'P'),
(112086, 'Wilsondale', 37.9536094665527, 0.662415448207434, -82.3277816772461, -1.436890856131, 218, 58, 'PPL', 'P'),
(6861, 'Wilsonia', 34.0997200012207, 0.595152388029466, -85.904167175293, -1.4993105583925, 218, 2, 'PPL', 'P'),
(44176, 'Wilsonia', 31.9327793121338, 0.557332138309465, -91.3141708374023, -1.59373293484126, 218, 22, 'PPL', 'P'),
(112087, 'Wilsonia', 39.2061080932617, 0.684275673120213, -79.4497222900391, -1.38665924375631, 218, 58, 'PPL', 'P'),
(186187, 'Wilsonia', 36.7350006103516, 0.641146711372761, -118.955558776855, -2.07616616420577, 218, 6, 'PPL', 'P'),
(107673, 'Wilsons', 37.1391716003418, 0.648200825889136, -77.8661117553711, -1.35902002585709, 218, 53, 'PPL', 'P'),
(6862, 'Wilsons (historical)', 34.0763893127441, 0.594745190698793, -85.9722213745117, -1.50049832823867, 218, 2, 'PPL', 'P'),
(52860, 'Wilsons Choice', 39.702220916748, 0.692934475351415, -76.4980621337891, -1.33514305562982, 218, 25, 'PPL', 'P'),
(107674, 'Wilsons Corner', 37.2905616760254, 0.650843081164658, -77.8766708374023, -1.35920431660452, 218, 53, 'PPL', 'P'),
(169020, 'Wilsons Corner', 40.1455612182617, 0.700672223319613, -75.6069412231445, -1.3195900617057, 218, 45, 'PPL', 'P'),
(58314, 'Wilsons Creek', 37.0974998474121, 0.647473516595435, -93.4038925170898, -1.63020545860211, 218, 29, 'PPL', 'P'),
(44177, 'Wilsons Landing', 29.7211093902588, 0.51873121620542, -91.2938919067383, -1.59337900073239, 218, 22, 'PPL', 'P'),
(71583, 'Wilsons Landing', 39.4283294677734, 0.68815416777375, -74.7130584716797, -1.30398886456585, 218, 37, 'PPL', 'P'),
(84423, 'Wilsons Landing', 33.4483299255371, 0.583783486493972, -80.1619415283203, -1.39908981446036, 218, 48, 'PPL', 'P'),
(70252, 'Wilsons Mills', 35.5838890075684, 0.621056023846285, -78.3561096191406, -1.3675721019076, 218, 33, 'PPL', 'P'),
(129351, 'Wilsons Mills', 44.938060760498, 0.784317119731958, -71.0358276367188, -1.23980907913992, 218, 26, 'PPL', 'P'),
(26115, 'Wilsons Store', 33.3022193908691, 0.581233376592167, -84.9847183227539, -1.48326314861201, 218, 13, 'PPL', 'P'),
(112088, 'Wilsontown', 38.8211097717285, 0.677556184794807, -80.3388900756836, -1.40217814921848, 218, 58, 'PPL', 'P'),
(6863, 'Wilsonville', 33.2341690063477, 0.580045673325019, -86.4836120605469, -1.50942377947402, 218, 2, 'PPL', 'P'),
(26116, 'Wilsonville', 31.4105606079102, 0.548217702505264, -82.6811065673828, -1.44305753879314, 218, 13, 'PPL', 'P'),
(28998, 'Wilsonville', 39.0708312988281, 0.681914647655803, -89.8561096191406, -1.56828496588695, 218, 18, 'PPL', 'P'),
(38904, 'Wilsonville', 38.1272201538086, 0.665445526316699, -85.4069366455078, -1.49063224850631, 218, 21, 'PPL', 'P'),
(58315, 'Wilsonville', 37.6011085510254, 0.656263146615187, -90.6230621337891, -1.58167081247402, 218, 29, 'PPL', 'P'),
(70253, 'Wilsonville', 35.7363891601563, 0.623717653618738, -79.0005569458008, -1.3788198296135, 218, 33, 'PPL', 'P'),
(84424, 'Wilsonville', 32.913890838623, 0.57445576477597, -80.0430603027344, -1.39701494565508, 218, 48, 'PPL', 'P'),
(91921, 'Wilsonville', 35.9730606079102, 0.627848349627505, -83.2388916015625, -1.45279272415792, 218, 50, 'PPL', 'P'),
(114299, 'Wilsonville', 42.0122184753418, 0.733251538461906, -71.8905563354492, -1.25472690914406, 218, 8, 'PPL', 'P'),
(169021, 'Wilsonville', 41.4519386291504, 0.723472810413299, -75.179443359375, -1.31212881643768, 218, 45, 'PPL', 'P'),
(199789, 'Wilsonville', 40.1119384765625, 0.700085395773414, -100.106666564941, -1.74719093475435, 218, 35, 'PPL', 'P'),
(201816, 'Wilsonville', 45.2999992370605, 0.790634137837626, -122.772499084473, -2.14278433992577, 218, 43, 'PPL', 'P'),
(70254, 'Wilsonville (historical)', 35.4386100769043, 0.618520428172421, -81.379997253418, -1.42034889733609, 218, 33, 'PPL', 'P'),
(38905, 'Wilstacy', 37.5336112976074, 0.655085097306991, -83.2527770996094, -1.45303507181712, 218, 21, 'PPL', 'P'),
(14887, 'Wiltbank Landing', 38.8086090087891, 0.677338005322502, -75.2405624389648, -1.31319554561231, 218, 10, 'PPL', 'P'),
(287, 'Wilton', 33.0786094665527, 0.57733064717271, -86.8816680908203, -1.51637116780971, 218, 2, 'PPL', 'P'),
(12893, 'Wilton', 33.7411117553711, 0.588893493414589, -94.148063659668, -1.64319369523843, 218, 4, 'PPL', 'P'),
(38906, 'Wilton', 36.8902816772461, 0.64385687725608, -84.0475006103516, -1.46690561372258, 218, 21, 'PPL', 'P'),
(58316, 'Wilton', 38.7350006103516, 0.676053296412648, -92.35888671875, -1.61196666671865, 218, 29, 'PPL', 'P'),
(70255, 'Wilton', 36.1419410705566, 0.630795869742978, -78.5769424438477, -1.37142636179522, 218, 33, 'PPL', 'P'),
(107675, 'Wilton', 37.5494384765625, 0.655361333691059, -76.4075012207031, -1.33356246952286, 218, 53, 'PPL', 'P'),
(114300, 'Wilton', 41.1952781677246, 0.718993240301731, -73.4383316040039, -1.28174068366128, 218, 8, 'PPL', 'P'),
(118487, 'Wilton', 41.5888900756836, 0.725863064070672, -91.0166702270508, -1.58854056966393, 218, 16, 'PPL', 'P'),
(122009, 'Wilton', 41.3794403076172, 0.722207476000375, -87.9341735839844, -1.53474085406075, 218, 18, 'PPL', 'P'),
(129344, 'Wilton', 44.5927810668945, 0.778290852238299, -70.2286071777344, -1.22572042434119, 218, 26, 'PPL', 'P'),
(138867, 'Wilton', 44.0138893127441, 0.768187285115729, -93.5341720581055, -1.63247926554082, 218, 28, 'PPL', 'P'),
(144681, 'Wilton', 42.8433303833008, 0.747757177708323, -71.7355575561523, -1.25202167010876, 218, 36, 'PPL', 'P'),
(153861, 'Wilton', 43.1800003051758, 0.753633176337474, -73.7447204589844, -1.2870881779721, 218, 40, 'PPL', 'P'),
(177067, 'Wilton', 43.8136100769043, 0.764691753026946, -90.5277786254883, -1.58000780153132, 218, 57, 'PPL', 'P'),
(186188, 'Wilton', 38.4119415283203, 0.670414851752732, -121.271110534668, -2.11658016637994, 218, 6, 'PPL', 'P'),
(193189, 'Wilton', 47.1586112976074, 0.823073037811445, -100.783058166504, -1.75899619523445, 218, 34, 'PPL', 'P'),
(192443, 'Wilton Acres Colonia', 31.6480007171631, 0.552361814188023, -106.273002624512, -1.8548138017783, 218, 51, 'PPL', 'P'),
(122010, 'Wilton Center', 41.351390838623, 0.721717920412991, -87.959716796875, -1.53518666722723, 218, 18, 'PPL', 'P'),
(144682, 'Wilton Center', 42.8327789306641, 0.747573020118944, -71.7774963378906, -1.25275363993436, 218, 36, 'PPL', 'P'),
(52861, 'Wilton Farm Acres', 39.2999992370605, 0.685914382717966, -76.8208312988281, -1.34077644028366, 218, 25, 'PPL', 'P'),
(129345, 'Wilton Intervale', 44.6336097717285, 0.779003447566977, -70.2927780151367, -1.22684041673762, 218, 26, 'PPL', 'P'),
(18648, 'Wilton Manors', 26.1599998474121, 0.456578129658556, -80.1391677856445, -1.39869233766767, 218, 12, 'PPL', 'P'),
(58317, 'Wilton Springs', 39.0752792358398, 0.681992278801579, -93.120002746582, -1.62525064739402, 218, 29, 'PPL', 'P'),
(91922, 'Wilton Springs', 35.8788909912109, 0.626204779760763, -83.1866683959961, -1.45188125727484, 218, 50, 'PPL', 'P'),
(107676, 'Wilton Woods', 38.7886085510254, 0.67698893148262, -77.0950012207031, -1.34556160813032, 218, 53, 'PPL', 'P'),
(52862, 'Wiltondale', 39.3863906860352, 0.687422197948142, -76.6013870239258, -1.33694641516197, 218, 25, 'PPL', 'P'),
(112493, 'Wiltsee', 39.002498626709, 0.680722017540639, -84.1849975585938, -1.46930538818085, 218, 41, 'PPL', 'P'),
(62349, 'Wiltshire', 33.3044395446777, 0.581272125586028, -89.8566665649414, -1.56829468642493, 218, 30, 'PPL', 'P'),
(91923, 'Wiltshire', 36.023609161377, 0.628730588317621, -84.8874969482422, -1.48156631552346, 218, 50, 'PPL', 'P'),
(52863, 'Wilwon Woods', 39.5527801513672, 0.690326241958819, -75.9230575561523, -1.32510733253602, 218, 25, 'PPL', 'P'),
(77700, 'Wilzetta', 35.5502815246582, 0.620469462616195, -96.7352828979492, -1.68834918941738, 218, 42, 'PPL', 'P'),
(62350, 'Wilzone', 32.9347190856934, 0.574819286264766, -90.4986114501953, -1.57949873828895, 218, 30, 'PPL', 'P'),
(18649, 'Wimauma', 27.7122192382813, 0.483669468742523, -82.2991714477539, -1.43639151342661, 218, 12, 'PPL', 'P'),
(99147, 'Wimberley', 29.9972190856934, 0.523550239487432, -98.0983276367188, -1.71213880796089, 218, 51, 'PPL', 'P'),
(18650, 'Wimberly Estates', 29.690559387207, 0.518198018065673, -82.3772201538086, -1.43775372032419, 218, 12, 'PPL', 'P'),
(192444, 'Wimberly Place', 35.3405609130859, 0.616809147434963, -102.682220458984, -1.79214283026796, 218, 51, 'PPL', 'P'),
(52864, 'Wimbledon', 39.5086097717285, 0.689555323402268, -76.4069366455078, -1.33355261582682, 218, 25, 'PPL', 'P'),
(141089, 'Wimbledon', 47.1697196960449, 0.823266915938803, -98.4594421386719, -1.71844144499667, 218, 34, 'PPL', 'P'),
(26119, 'Wimbledon Woods', 32.8583297729492, 0.573486041244045, -83.732780456543, -1.46141271081624, 218, 13, 'PPL', 'P'),
(6864, 'Wimbly', 31.9150009155273, 0.557021846752957, -88.2483291625977, -1.54022390327106, 218, 2, 'PPL', 'P'),
(201817, 'Wimer', 42.538890838623, 0.742443705280424, -123.14778137207, -2.14933425146877, 218, 43, 'PPL', 'P'),
(200286, 'Wimer Place', 41.7983283996582, 0.729518452403888, -119.725280761719, -2.08960034716662, 218, 39, 'PPL', 'P'),
(58318, 'Wimmer', 37.5302810668945, 0.6550269738162, -94.4794387817383, -1.64897728217775, 218, 29, 'PPL', 'P'),
(169022, 'Wimmers', 41.4041709899902, 0.72263910783405, -75.4813919067383, -1.31739881276078, 218, 45, 'PPL', 'P'),
(112089, 'Wimmers Trailer Park', 37.3911094665527, 0.652597971164966, -81.1305618286133, -1.41599542790213, 218, 58, 'PPL', 'P'),
(186189, 'Wimp', 36.500560760498, 0.637054964094936, -119.243057250977, -2.08118395917364, 218, 6, 'PPL', 'P'),
(189826, 'Wimsatt', 32.9580612182617, 0.57522668333252, -105.641937255859, -1.84379963330001, 218, 38, 'PPL', 'P'),
(189827, 'Wimsattville', 32.8055610656738, 0.572565053560068, -108.083892822266, -1.8864197981212, 218, 38, 'PPL', 'P'),
(206549, 'Win Del', 40.6775016784668, 0.709956335774765, -111.849166870117, -1.95213622749611, 218, 52, 'PPL', 'P'),
(124028, 'Winamac', 41.0513916015625, 0.716481945972814, -86.6030578613281, -1.51150850197533, 218, 19, 'PPL', 'P'),
(158421, 'Winameg', 41.6269416809082, 0.726527189867511, -84.0650024414063, -1.46721107829961, 218, 41, 'PPL', 'P'),
(52865, 'Winands Valley Estates', 39.3797187805176, 0.687305751229478, -76.772216796875, -1.33992795716036, 218, 25, 'PPL', 'P'),
(52866, 'Winans (historical)', 39.230281829834, 0.684697584415909, -76.6922225952148, -1.33853179495889, 218, 25, 'PPL', 'P'),
(201818, 'Winberry', 43.9536094665527, 0.767135203327094, -122.711387634277, -2.1417177439092, 218, 43, 'PPL', 'P'),
(62351, 'Winborn', 34.6311111450195, 0.604426913104694, -89.273063659668, -1.5581088942037, 218, 30, 'PPL', 'P'),
(6865, 'Winburn', 33.5080604553223, 0.584825980902684, -86.5469436645508, -1.51052912448446, 218, 2, 'PPL', 'P'),
(169023, 'Winburne', 40.9661102294922, 0.714993505239569, -78.1452789306641, -1.36389241222944, 218, 45, 'PPL', 'P'),
(99150, 'Winchell', 31.4719390869141, 0.549288959053748, -99.1605606079102, -1.73067827073142, 218, 51, 'PPL', 'P'),
(153862, 'Winchell', 41.915828704834, 0.731569219601304, -74.2558288574219, -1.29600870235943, 218, 40, 'PPL', 'P'),
(126665, 'Winchendon', 42.6861114501953, 0.74501318967916, -72.0444412231445, -1.2574127071034, 218, 23, 'PPL', 'P'),
(126666, 'Winchendon Center', 42.6611099243164, 0.74457683073455, -72.0416717529297, -1.25736437072962, 218, 23, 'PPL', 'P'),
(126667, 'Winchendon Springs', 42.6944389343262, 0.745158531695651, -72.0152816772461, -1.25690377701909, 218, 23, 'PPL', 'P'),
(12894, 'Winchester', 33.7744407653809, 0.58947519437569, -91.4744415283203, -1.59653018609222, 218, 4, 'PPL', 'P'),
(26120, 'Winchester', 32.4180603027344, 0.565801889392785, -83.9577789306641, -1.46533967500161, 218, 13, 'PPL', 'P'),
(28999, 'Winchester', 39.6297187805176, 0.691669074359464, -90.4561080932617, -1.57875691476731, 218, 18, 'PPL', 'P'),
(34448, 'Winchester', 39.3222198486328, 0.686302205551709, -95.2666702270508, -1.66271706287369, 218, 20, 'PPL', 'P'),
(38907, 'Winchester', 37.9900016784668, 0.663050612127418, -84.1797180175781, -1.46921324280713, 218, 21, 'PPL', 'P'),
(44180, 'Winchester', 30.5269393920898, 0.532795602948724, -91.0827789306641, -1.58969438420621, 218, 22, 'PPL', 'P'),
(52869, 'Winchester', 39.6705589294434, 0.692381869425224, -75.8702774047852, -1.32418614511496, 218, 25, 'PPL', 'P'),
(62352, 'Winchester', 31.6175003051758, 0.551829481575629, -88.5905609130859, -1.54619697412194, 218, 30, 'PPL', 'P'),
(74851, 'Winchester', 38.9869384765625, 0.680450441688478, -82.5391693115234, -1.44058026634715, 218, 41, 'PPL', 'P'),
(77702, 'Winchester', 36.957218170166, 0.645025139447271, -98.7969436645508, -1.72433195785376, 218, 42, 'PPL', 'P'),
(91925, 'Winchester', 36.5319404602051, 0.637602643173111, -81.9466705322266, -1.43023921183437, 218, 50, 'PPL', 'P'),
(99149, 'Winchester', 29.6149997711182, 0.516879253983379, -95.4694366455078, -1.66625600448824, 218, 51, 'PPL', 'P'),
(107677, 'Winchester', 39.1855583190918, 0.683917011900407, -78.1636123657227, -1.36421239103441, 218, 53, 'PPL', 'P'),
(118496, 'Winchester', 40.8502807617188, 0.712971899656089, -91.8997192382813, -1.60395268236638, 218, 16, 'PPL', 'P'),
(124029, 'Winchester', 40.1719398498535, 0.70113261729306, -84.9813919067383, -1.48320509170025, 218, 19, 'PPL', 'P'),
(126669, 'Winchester', 42.452220916748, 0.740931029781259, -71.1374969482422, -1.24158354337424, 218, 23, 'PPL', 'P'),
(139536, 'Winchester', 40.3177795410156, 0.703678000083931, -91.6111068725586, -1.59891544632255, 218, 29, 'PPL', 'P'),
(144684, 'Winchester', 42.7733306884766, 0.746535452558249, -72.3836135864258, -1.26333238157443, 218, 36, 'PPL', 'P'),
(153863, 'Winchester', 42.8647193908691, 0.748130486314125, -78.7869415283203, -1.37509153724544, 218, 40, 'PPL', 'P'),
(177076, 'Winchester', 46.2219390869141, 0.806725023722912, -89.8977813720703, -1.56901227518065, 218, 57, 'PPL', 'P'),
(186190, 'Winchester', 33.7069396972656, 0.588297078488466, -117.083610534668, -2.04349450395267, 218, 6, 'PPL', 'P'),
(190939, 'Winchester', 36.1300010681152, 0.630587477387679, -115.118057250977, -2.00918912752887, 218, 39, 'PPL', 'P'),
(195806, 'Winchester', 46.2400016784668, 0.80704027541695, -116.623329162598, -2.03546107852445, 218, 17, 'PPL', 'P'),
(201819, 'Winchester', 43.2802810668945, 0.755383405805874, -123.352500915527, -2.15290728154527, 218, 43, 'PPL', 'P'),
(209199, 'Winchester', 47.2491683959961, 0.82465355733938, -119.718612670898, -2.08948396702698, 218, 56, 'PPL', 'P'),
(209838, 'Winchester', 43.8600006103516, 0.765501420577357, -108.160003662109, -1.88774818287293, 218, 59, 'PPL', 'P'),
(201820, 'Winchester Bay', 43.6772193908691, 0.762311286486579, -124.173606872559, -2.16723828400321, 218, 43, 'PPL', 'P'),
(114302, 'Winchester Center', 41.9000015258789, 0.731292983217235, -73.1352767944336, -1.27645137942027, 218, 8, 'PPL', 'P'),
(52870, 'Winchester Estates', 38.9627799987793, 0.680028796708891, -76.1936111450195, -1.32982938346484, 218, 25, 'PPL', 'P'),
(126670, 'Winchester Highlands', 42.4666709899902, 0.74118323113649, -71.1263885498047, -1.24138966524689, 218, 23, 'PPL', 'P'),
(169024, 'Winchester Park', 40.0550003051758, 0.699091637212651, -75.0299987792969, -1.30952051646606, 218, 45, 'PPL', 'P'),
(91927, 'Winchester Springs', 35.2461090087891, 0.615160650720204, -86.1774978637695, -1.50408107885316, 218, 50, 'PPL', 'P'),
(52871, 'Winchester Village', 39.6441688537598, 0.691921275714694, -76.0638885498047, -1.32756529706411, 218, 25, 'PPL', 'P'),
(52872, 'Winchester-on-the-Severn', 39.0149993896484, 0.680940197012943, -76.5111083984375, -1.33537075590302, 218, 25, 'PPL', 'P'),
(153864, 'Wincoma', 40.9033317565918, 0.713897814188083, -73.4261093139648, -1.28152736445796, 218, 40, 'PPL', 'P'),
(70258, 'Wind Blow', 35.1713905334473, 0.61385656731342, -79.6672210693359, -1.39045531357411, 218, 33, 'PPL', 'P'),
(38908, 'Wind Cave', 37.5125007629395, 0.654716648970178, -83.9288864135742, -1.46483540544921, 218, 21, 'PPL', 'P'),
(6866, 'Wind Creek Farms', 32.8261108398438, 0.572923714779874, -85.9413909912109, -1.49996023654042, 218, 2, 'PPL', 'P'),
(169025, 'Wind Gap', 40.8480606079102, 0.712933150662229, -75.2919387817383, -1.31409223195134, 218, 45, 'PPL', 'P'),
(52873, 'Wind Haven Estates', 38.6344413757324, 0.674298206675258, -76.533332824707, -1.33575864531579, 218, 25, 'PPL', 'P'),
(70262, 'Wind Hill (historical)', 35.5538902282715, 0.620532446375976, -80.0999984741211, -1.39800870421585, 218, 33, 'PPL', 'P'),
(177073, 'Wind Lake', 42.8294410705566, 0.747514763470098, -88.1586074829102, -1.53865796455009, 218, 57, 'PPL', 'P'),
(70259, 'Wind Oaks Town Homes', 35.5900001525879, 0.621162683447943, -82.5411071777344, -1.44061408849299, 218, 33, 'PPL', 'P'),
(177074, 'Wind Point', 42.7844390869141, 0.746729330685607, -87.76611328125, -1.53180764843614, 218, 57, 'PPL', 'P'),
(79425, 'Wind Ridge', 39.9127807617188, 0.696609437918642, -80.434440612793, -1.40384582069308, 218, 45, 'PPL', 'P'),
(209839, 'Wind River', 42.9863891601563, 0.750254024388327, -108.883613586426, -1.90037755855236, 218, 59, 'PPL', 'P'),
(169027, 'Windber', 40.2397193908691, 0.702315593449274, -78.8352813720703, -1.37593522667878, 218, 45, 'PPL', 'P'),
(52874, 'Windbrook', 38.7172203063965, 0.675742971566626, -76.945556640625, -1.34295330815869, 218, 25, 'PPL', 'P'),
(126672, 'Windbrook Acres Mobile Home Park', 42.2125015258789, 0.736747137129717, -71.8072204589844, -1.25327242371471, 218, 23, 'PPL', 'P'),
(52875, 'Windcliff', 38.5533294677734, 0.6728825368188, -76.5166702270508, -1.33546782812475, 218, 25, 'PPL', 'P'),
(99152, 'Windcrest', 29.5152797698975, 0.515138811631985, -98.379997253418, -1.71705487017512, 218, 51, 'PPL', 'P'),
(107679, 'Windcrest Manor', 37.3277816772461, 0.651492692733556, -79.2694396972656, -1.38351271892838, 218, 53, 'PPL', 'P'),
(153865, 'Windcrest Park', 43.0377807617188, 0.751150977043465, -76.2958297729492, -1.33161343507908, 218, 40, 'PPL', 'P'),
(133760, 'Winde', 45.9686088562012, 0.802303577102135, -87.0969390869141, -1.52012835547559, 218, 27, 'PPL', 'P'),
(153866, 'Windecker', 43.7991714477539, 0.764439751408797, -75.6127777099609, -1.3196919276174, 218, 40, 'PPL', 'P'),
(52876, 'Windemere', 39.4700012207031, 0.688881477067451, -76.5388870239258, -1.33585558437947, 218, 25, 'PPL', 'P'),
(70260, 'Windemere', 34.2402801513672, 0.59760562544662, -77.8438873291016, -1.35863213644432, 218, 33, 'PPL', 'P'),
(99151, 'Windemere', 30.458890914917, 0.53160793297109, -97.6488876342773, -1.70429460012812, 218, 51, 'PPL', 'P'),
(126673, 'Windemere', 42.3055610656738, 0.738371332499529, -70.8880615234375, -1.23723007394029, 218, 23, 'PPL', 'P'),
(129347, 'Windemere', 44.6313896179199, 0.778964698573117, -69.3244400024414, -1.20993973014387, 218, 26, 'PPL', 'P'),
(179545, 'Windemere', 33.5319404602051, 0.585242765613281, -111.903327941895, -1.95308151652503, 218, 5, 'PPL', 'P'),
(158422, 'Windemere Orchards', 41.5936088562012, 0.725945422327383, -83.45361328125, -1.45654032444388, 218, 41, 'PPL', 'P'),
(122013, 'Windenoak', 41.8652801513672, 0.730686980911187, -88.4661102294922, -1.54402489993688, 218, 18, 'PPL', 'P'),
(26156, 'Winder', 33.9925003051758, 0.593281051310495, -83.7202835083008, -1.46119459792296, 218, 13, 'PPL', 'P'),
(195807, 'Winder', 42.1763916015625, 0.73611690005775, -111.915000915527, -1.95328524834842, 218, 17, 'PPL', 'P'),
(169029, 'Winder Village', 40.1061096191406, 0.699983663019773, -74.8741683959961, -1.30680076320281, 218, 45, 'PPL', 'P'),
(18651, 'Windermere', 28.4952793121338, 0.49733644527216, -81.5350036621094, -1.42305426952944, 218, 12, 'PPL', 'P'),
(91928, 'Windermere', 36.5349998474121, 0.637656039552967, -87.228889465332, -1.52243132402824, 218, 50, 'PPL', 'P'),
(114304, 'Windermere', 41.8777809143066, 0.730905160383492, -72.4847183227539, -1.26509699211272, 218, 8, 'PPL', 'P'),
(52878, 'Windermere Estates', 39.1172218322754, 0.682724315206215, -76.4688873291016, -1.33463385922939, 218, 25, 'PPL', 'P'),
(26121, 'Windermere Woods', 33.5708312988281, 0.585921538796115, -84.4394378662109, -1.47374620929856, 218, 13, 'PPL', 'P'),
(124030, 'Windfall', 40.3630599975586, 0.704468293137412, -85.9563903808594, -1.50022202527558, 218, 19, 'PPL', 'P'),
(158423, 'Windfall', 41.1363906860352, 0.717965459858042, -81.7858276367188, -1.42743197372932, 218, 41, 'PPL', 'P'),
(169030, 'Windfall', 41.7055587768555, 0.727899317040147, -76.774169921875, -1.33996204562232, 218, 45, 'PPL', 'P'),
(26122, 'Windfall Heights', 33.9461097717285, 0.592471383760083, -83.2847213745117, -1.45359260459133, 218, 13, 'PPL', 'P'),
(26123, 'Windfield', 32.4500007629395, 0.566359355587965, -81.745002746582, -1.42671944497966, 218, 13, 'PPL', 'P'),
(26124, 'Windgate Forest', 33.3988914489746, 0.582920622300787, -84.5533294677734, -1.47573399273619, 218, 13, 'PPL', 'P'),
(114305, 'Windham', 41.6997184753418, 0.727797384549424, -72.1575012207031, -1.2593859763131, 218, 8, 'PPL', 'P'),
(118489, 'Windham', 41.6088905334473, 0.726212137910555, -91.7619400024414, -1.6015479810601, 218, 16, 'PPL', 'P'),
(144686, 'Windham', 42.8005599975586, 0.747010693654774, -71.3047180175781, -1.24450210161286, 218, 36, 'PPL', 'P'),
(153867, 'Windham', 42.3072204589844, 0.738400294376384, -74.2525024414063, -1.29595064544767, 218, 40, 'PPL', 'P'),
(158424, 'Windham', 41.2350006103516, 0.719686527712506, -81.0494384765625, -1.41457955830859, 218, 41, 'PPL', 'P'),
(169031, 'Windham', 41.9716682434082, 0.732543803402218, -76.2916717529297, -1.33154086393938, 218, 45, 'PPL', 'P'),
(172812, 'Windham', 43.1791687011719, 0.753618662109533, -72.7263870239258, -1.26931490664718, 218, 55, 'PPL', 'P'),
(197860, 'Windham', 47.0786094665527, 0.821676742451916, -110.139717102051, -1.92230070064589, 218, 31, 'PPL', 'P'),
(52879, 'Windham (historical)', 39.0430603027344, 0.681429952337409, -77.0986099243164, -1.3456245918901, 218, 25, 'PPL', 'P'),
(129348, 'Windham Center', 43.7894401550293, 0.764269908310277, -70.4088897705078, -1.22886694916912, 218, 26, 'PPL', 'P'),
(169032, 'Windham Center', 41.9644393920898, 0.732417636145575, -76.3266677856445, -1.33215165993539, 218, 45, 'PPL', 'P'),
(144687, 'Windham Depot', 42.8413887023926, 0.747723288983452, -71.3002777099609, -1.24442460362514, 218, 36, 'PPL', 'P'),
(129349, 'Windham Hill', 43.797779083252, 0.76441545006385, -70.4261093139648, -1.22916748689813, 218, 26, 'PPL', 'P'),
(52881, 'Windham Manor', 38.3316688537598, 0.669013829282269, -75.5905609130859, -1.31930417136268, 218, 25, 'PPL', 'P'),
(6869, 'Windham Springs', 33.4913902282715, 0.584535030553593, -87.4986114501953, -1.52713886072912, 218, 2, 'PPL', 'P'),
(169033, 'Windham Summit', 41.961109161377, 0.732359512654784, -76.3644409179688, -1.33281092546324, 218, 45, 'PPL', 'P'),
(84425, 'Windhams Crossroads', 34.2005615234375, 0.596912404614872, -80.0338897705078, -1.39685488967357, 218, 48, 'PPL', 'P'),
(26125, 'Windhaven', 33.9416694641113, 0.592393885772362, -84.3099975585938, -1.47148704974584, 218, 13, 'PPL', 'P'),
(26126, 'Windhaven Plantation', 33.5027809143066, 0.584733835528967, -84.2525024414063, -1.4704835706471, 218, 13, 'PPL', 'P'),
(34449, 'Windhorst', 37.7852783203125, 0.659477515471886, -99.6416702270508, -1.73907521764844, 218, 20, 'PPL', 'P'),
(133761, 'Windigo', 47.9119415283203, 0.836221130692194, -89.1566696166992, -1.55607743492419, 218, 27, 'PPL', 'P'),
(52882, 'Winding Brook Village', 39.6577796936035, 0.692158829683929, -75.8011093139648, -1.32297893419283, 218, 25, 'PPL', 'P'),
(52883, 'Winding Brooke', 38.8244400024414, 0.677614308285598, -76.6716690063477, -1.33817306716006, 218, 25, 'PPL', 'P'),
(52884, 'Winding Creek South', 39.6777801513672, 0.692507903523812, -77.6305618286133, -1.35490890408233, 218, 25, 'PPL', 'P'),
(14875, 'Winding Creek Village Mobile Home Park', 38.642219543457, 0.674433961311825, -75.1650009155273, -1.3118767482405, 218, 10, 'PPL', 'P'),
(38909, 'Winding Falls', 38.2830581665039, 0.668165412737997, -85.6438903808594, -1.4947678713631, 218, 21, 'PPL', 'P'),
(112090, 'Winding Gulf', 37.6780586242676, 0.657606178752914, -81.2399978637695, -1.41790544703594, 218, 58, 'PPL', 'P'),
(169036, 'Winding Heights', 40.1922187805176, 0.701486551401932, -76.9725036621094, -1.3434236224072, 218, 45, 'PPL', 'P'),
(169037, 'Winding Hill', 40.1875, 0.701404193145221, -76.9861068725586, -1.34366104321838, 218, 45, 'PPL', 'P'),
(146656, 'Winding River Village', 40.105281829834, 0.699969215370859, -74.100830078125, -1.29330346332413, 218, 37, 'PPL', 'P'),
(112091, 'Winding Road Addition', 39.2627792358398, 0.685264771149068, -81.4572219848633, -1.42169672316377, 218, 58, 'PPL', 'P'),
(153869, 'Winding Ways', 42.8888893127441, 0.748552331030793, -76.4108276367188, -1.33362052643462, 218, 40, 'PPL', 'P'),
(84426, 'Windjammer Village', 33.5819396972656, 0.586115416923473, -79.0144424438477, -1.3790621772727, 218, 48, 'PPL', 'P'),
(91929, 'Windle', 36.336109161377, 0.634184742230103, -85.3786087036133, -1.49013783264994, 218, 50, 'PPL', 'P'),
(91930, 'Windletown', 36.2641716003418, 0.632929194934186, -85.1466674804688, -1.48608969463496, 218, 50, 'PPL', 'P'),
(70263, 'Windmere', 36.4180603027344, 0.635615059472558, -79.6822204589844, -1.39071710230926, 218, 33, 'PPL', 'P'),
(91931, 'Windmere', 36.5055618286133, 0.637142249199664, -82.539436340332, -1.44058492687905, 218, 50, 'PPL', 'P'),
(179546, 'Windmill', 33.5972213745117, 0.586382132506644, -112.228057861328, -1.95874912279888, 218, 5, 'PPL', 'P'),
(189828, 'Windmill', 31.9777793884277, 0.558117537804443, -108.624443054199, -1.89585417944086, 218, 38, 'PPL', 'P'),
(26127, 'Windmill Creek', 33.9874992370605, 0.593193766205767, -84.870002746582, -1.48126098410449, 218, 13, 'PPL', 'P'),
(52885, 'Windmill Farm', 39.0819396972656, 0.682108525783161, -77.2608337402344, -1.34845593160302, 218, 25, 'PPL', 'P'),
(153870, 'Windmill Farm', 41.1474990844727, 0.7181593379854, -73.6813888549805, -1.28598283296166, 218, 40, 'PPL', 'P'),
(84427, 'Windmill Harbor', 32.2166709899902, 0.562286982807071, -80.7777786254883, -1.40983819946187, 218, 48, 'PPL', 'P'),
(107680, 'Windmill Hills', 37.1536102294922, 0.648452827507285, -80.4302825927734, -1.40377324955338, 218, 53, 'PPL', 'P'),
(26128, 'Windmill Plantation', 33.5633316040039, 0.585790644428538, -82.2074966430664, -1.43479148624369, 218, 13, 'PPL', 'P'),
(114308, 'Windmill Springs', 41.9511108398438, 0.732185009024357, -72.7900009155273, -1.27042517850564, 218, 8, 'PPL', 'P'),
(31547, 'Windom', 38.5738906860352, 0.673241397775688, -86.7977828979492, -1.51490709500044, 218, 19, 'PPL', 'P'),
(34450, 'Windom', 38.3838882446289, 0.669925229586321, -97.9097213745117, -1.7088470076955, 218, 20, 'PPL', 'P'),
(70264, 'Windom', 35.9180603027344, 0.626888413212586, -82.254997253418, -1.43562052829104, 218, 33, 'PPL', 'P'),
(99153, 'Windom', 33.5652809143066, 0.585824666311464, -95.998893737793, -1.67549677399665, 218, 51, 'PPL', 'P'),
(112092, 'Windom', 37.5986099243164, 0.656219537352337, -81.570556640625, -1.42367478606343, 218, 58, 'PPL', 'P'),
(138872, 'Windom', 43.8663902282715, 0.765612940448004, -95.1166687011719, -1.66009904236409, 218, 28, 'PPL', 'P'),
(153871, 'Windom', 42.7852783203125, 0.746743978071602, -78.7900009155273, -1.3751449336253, 218, 40, 'PPL', 'P'),
(169038, 'Windom', 40.0077781677246, 0.698267455434299, -76.4002838134766, -1.3334365020033, 218, 45, 'PPL', 'P'),
(112093, 'Windom (historical)', 39.4538917541504, 0.688600313835365, -79.1022186279297, -1.38059416068976, 218, 58, 'PPL', 'P'),
(84428, 'Windom Corner', 33.1338882446289, 0.578295443856619, -79.7125015258789, -1.39124560662759, 218, 48, 'PPL', 'P'),
(70265, 'Windor Hills', 35.3430595397949, 0.616852756697813, -82.4602813720703, -1.43920341206357, 218, 33, 'PPL', 'P'),
(71584, 'Windor Park', 39.9575004577637, 0.697389943855118, -74.1180572509766, -1.2936041342112, 218, 37, 'PPL', 'P'),
(91932, 'Window Cliff Estates', 36.0805587768555, 0.629724546615466, -85.6100006103516, -1.49417638328499, 218, 50, 'PPL', 'P'),
(179547, 'Window Rock', 35.6805610656738, 0.622743269554905, -109.051940917969, -1.90331542470888, 218, 5, 'PPL', 'P'),
(107681, 'Windrift', 38.1875, 0.666497608105335, -78.5208282470703, -1.37044698430434, 218, 53, 'PPL', 'P'),
(91933, 'Windrock', 36.0849990844727, 0.629802044603187, -84.3311080932617, -1.47185549808265, 218, 50, 'PPL', 'P'),
(91934, 'Windrow', 35.7986106872559, 0.624803624132245, -86.5550003051758, -1.51066973939001, 218, 50, 'PPL', 'P'),
(26129, 'Windrush', 34.0208282470703, 0.593775467166868, -84.4355621337891, -1.47367856500687, 218, 13, 'PPL', 'P'),
(52886, 'Windrush Farm', 39.0613899230957, 0.681749864563355, -76.5277786254883, -1.33566170625211, 218, 25, 'PPL', 'P'),
(179548, 'Windsong', 33.6427803039551, 0.587177285829115, -111.928062438965, -1.95351321493773, 218, 5, 'PPL', 'P'),
(112094, 'Windsong Acres', 38.4744415283203, 0.671505682535229, -81.8652801513672, -1.42881868170892, 218, 58, 'PPL', 'P'),
(52887, 'Windsong Farms', 39.3972206115723, 0.68761121580651, -77.1413879394531, -1.3463712091017, 218, 25, 'PPL', 'P'),
(6872, 'Windsong Island', 33.5369415283203, 0.585330050718009, -86.1880569458008, -1.50426536960059, 218, 2, 'PPL', 'P'),
(99154, 'Windsong Village Colonia', 26.1709995269775, 0.456770110283637, -97.818000793457, -1.70724618156425, 218, 51, 'PPL', 'P'),
(18652, 'Windsor', 29.646390914917, 0.517427132798636, -82.186393737793, -1.43442317106494, 218, 12, 'PPL', 'P'),
(26131, 'Windsor', 33.8800010681152, 0.591317569217806, -83.841667175293, -1.46331314257012, 218, 13, 'PPL', 'P'),
(29003, 'Windsor', 39.4408302307129, 0.688372347246055, -88.5947189331055, -1.54626954526165, 218, 18, 'PPL', 'P'),
(38910, 'Windsor', 37.1277809143066, 0.648002020913762, -84.9122161865234, -1.48199774762006, 218, 21, 'PPL', 'P'),
(44182, 'Windsor', 32.6525001525879, 0.56989363667061, -91.8861083984375, -1.60371512839715, 218, 22, 'PPL', 'P'),
(58320, 'Windsor', 38.5322189331055, 0.672514088481987, -93.5219421386719, -1.63226581317945, 218, 29, 'PPL', 'P'),
(70269, 'Windsor', 35.5527801513672, 0.620513071879045, -77.3613891601563, -1.35021095476138, 218, 33, 'PPL', 'P'),
(79426, 'Windsor', 39.9161109924316, 0.696667561409434, -76.584716796875, -1.33665546481287, 218, 45, 'PPL', 'P'),
(84429, 'Windsor', 33.4816703796387, 0.584365387192155, -81.5138931274414, -1.42268582119263, 218, 48, 'PPL', 'P'),
(99155, 'Windsor', 31.5219402313232, 0.550161643653454, -97.341667175293, -1.69893259158935, 218, 51, 'PPL', 'P'),
(107705, 'Windsor', 38.1113891601563, 0.665169223353603, -78.476936340332, -1.36968092601678, 218, 53, 'PPL', 'P'),
(114309, 'Windsor', 41.8525009155273, 0.730463941169893, -72.644172668457, -1.26787999545185, 218, 8, 'PPL', 'P'),
(124031, 'Windsor', 40.1544418334961, 0.700827219295056, -85.2127838134766, -1.4872436423353, 218, 19, 'PPL', 'P'),
(126674, 'Windsor', 42.5116691589355, 0.741968597341954, -73.0583267211914, -1.27510834728254, 218, 23, 'PPL', 'P'),
(129352, 'Windsor', 44.3105583190918, 0.773365136065116, -69.5811080932617, -1.21441943341349, 218, 26, 'PPL', 'P'),
(141091, 'Windsor', 46.8963890075684, 0.818496395478144, -99.0425033569336, -1.72861778299603, 218, 34, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(146657, 'Windsor', 40.2422218322754, 0.702359269291151, -74.581672668457, -1.30169574970924, 218, 37, 'PPL', 'P'),
(153872, 'Windsor', 42.0758285522461, 0.734361743741333, -75.6408309936523, -1.32018154978381, 218, 40, 'PPL', 'P'),
(158427, 'Windsor', 40.8083305358887, 0.712239730093399, -82.4355621337891, -1.43877197996698, 218, 41, 'PPL', 'P'),
(172809, 'Windsor', 43.480281829834, 0.758874077625668, -72.3852767944336, -1.26336141003031, 218, 55, 'PPL', 'P'),
(177077, 'Windsor', 43.2183303833008, 0.754302162403302, -89.3413925170898, -1.55930145773984, 218, 57, 'PPL', 'P'),
(186192, 'Windsor', 38.5472183227539, 0.672775877217142, -122.815277099609, -2.14353095713738, 218, 6, 'PPL', 'P'),
(194483, 'Windsor', 40.4775009155273, 0.706465663954971, -104.900833129883, -1.8308649262016, 218, 7, 'PPL', 'P'),
(26132, 'Windsor At Peachtree', 33.8838882446289, 0.591385413246576, -84.3569412231445, -1.4723063712552, 218, 13, 'PPL', 'P'),
(153873, 'Windsor Beach', 43.2538909912109, 0.754922812095345, -77.5975036621094, -1.35433193023217, 218, 40, 'PPL', 'P'),
(91935, 'Windsor Bluff', 35.9727783203125, 0.627843422779488, -84.8513870239258, -1.4809360784515, 218, 50, 'PPL', 'P'),
(169039, 'Windsor Castle', 40.5391693115234, 0.707541980509527, -75.9336090087891, -1.3252914901254, 218, 45, 'PPL', 'P'),
(84430, 'Windsor City Mobile Home Park', 33.9705581665039, 0.592898088745741, -80.398063659668, -1.40321092308921, 218, 48, 'PPL', 'P'),
(158428, 'Windsor Corners', 40.413890838623, 0.705355458675545, -83.0116729736328, -1.44882701097868, 218, 41, 'PPL', 'P'),
(26133, 'Windsor Court', 33.5069389343262, 0.584806406668672, -82.0105590820313, -1.43135427738278, 218, 13, 'PPL', 'P'),
(107684, 'Windsor Court', 37.250560760498, 0.650144933484894, -80.0144424438477, -1.39651546979264, 218, 53, 'PPL', 'P'),
(138875, 'Windsor Court Mobile Home Community', 44.0208282470703, 0.768308392366301, -92.7513885498047, -1.61881711599066, 218, 28, 'PPL', 'P'),
(186194, 'Windsor Crest', 33.4930610656738, 0.584564192167529, -117.132217407227, -2.04434285391792, 218, 6, 'PPL', 'P'),
(26135, 'Windsor Estates', 33.4011116027832, 0.582959371294647, -84.4277801513672, -1.47354274379127, 218, 13, 'PPL', 'P'),
(52906, 'Windsor Estates', 39.3511085510254, 0.686806408525088, -77.4730606079102, -1.35215998920515, 218, 25, 'PPL', 'P'),
(84431, 'Windsor Estates', 34.084171295166, 0.594881011914387, -80.929443359375, -1.41248524842735, 218, 48, 'PPL', 'P'),
(107686, 'Windsor Estates', 37.2458305358887, 0.650062375491101, -80.017219543457, -1.39656393932448, 218, 53, 'PPL', 'P'),
(112095, 'Windsor Estates', 39.1786117553711, 0.683795771491781, -81.5180587768555, -1.42275852549039, 218, 58, 'PPL', 'P'),
(107687, 'Windsor Farms', 37.5552787780762, 0.655463266181782, -77.4986114501953, -1.35260593552969, 218, 53, 'PPL', 'P'),
(169040, 'Windsor Farms', 40.3224983215332, 0.703760358340642, -76.8758316040039, -1.34173637669858, 218, 45, 'PPL', 'P'),
(26138, 'Windsor Forest', 33.5019416809082, 0.584719188142972, -82.004997253418, -1.43125720516105, 218, 13, 'PPL', 'P'),
(84433, 'Windsor Forest', 34.9041709899902, 0.609192706454418, -81.8888931274414, -1.42923080588761, 218, 48, 'PPL', 'P'),
(107688, 'Windsor Forest', 37.3058280944824, 0.65110953043172, -76.7630615234375, -1.33976816749496, 218, 53, 'PPL', 'P'),
(107689, 'Windsor Great Park', 37.1472206115723, 0.648341307636638, -76.5149993896484, -1.33543866651082, 218, 53, 'PPL', 'P'),
(26139, 'Windsor Heights', 33.8883285522461, 0.591462911234298, -84.3713912963867, -1.47255857261044, 218, 13, 'PPL', 'P'),
(84434, 'Windsor Heights', 34.2680587768555, 0.598090453923069, -80.6413879394531, -1.4074577329215, 218, 48, 'PPL', 'P'),
(118490, 'Windsor Heights', 41.5977783203125, 0.726018193204169, -93.7080612182617, -1.63551420391908, 218, 16, 'PPL', 'P'),
(177305, 'Windsor Heights', 40.1911087036133, 0.701467176905002, -80.6655578613281, -1.40787957763817, 218, 58, 'PPL', 'P'),
(6876, 'Windsor Highlands', 33.4683303833008, 0.584132560333854, -86.7938919067383, -1.51483918439264, 218, 2, 'PPL', 'P'),
(14876, 'Windsor Hills', 39.7999992370605, 0.694641028977938, -75.529167175293, -1.31823264849809, 218, 10, 'PPL', 'P'),
(52888, 'Windsor Hills', 39.3138885498047, 0.68615679695619, -76.6813888549805, -1.33834271052149, 218, 25, 'PPL', 'P'),
(70270, 'Windsor Hills', 35.3305587768555, 0.616634577225509, -80.2055587768555, -1.39985107905796, 218, 33, 'PPL', 'P'),
(107693, 'Windsor Hills', 37.2527809143066, 0.650183682478754, -80.0066680908203, -1.3963797817351, 218, 53, 'PPL', 'P'),
(186193, 'Windsor Hills', 33.9888916015625, 0.593218067550714, -118.353057861328, -2.06565053948353, 218, 6, 'PPL', 'P'),
(58321, 'Windsor Junction', 38.5347213745117, 0.672557764323864, -93.2719421386719, -1.62790249004947, 218, 29, 'PPL', 'P'),
(114310, 'Windsor Locks', 41.9291687011719, 0.731802046459604, -72.6277770996094, -1.26759383879272, 218, 8, 'PPL', 'P'),
(52889, 'Windsor Manor', 38.7244415283203, 0.675869005665214, -76.7852783203125, -1.34015592374967, 218, 25, 'PPL', 'P'),
(169041, 'Windsor Manor', 40.3091697692871, 0.703527731219423, -76.7816696166992, -1.34009293998989, 218, 45, 'PPL', 'P'),
(52890, 'Windsor Mill', 39.3327789306641, 0.686486496299142, -76.7597198486328, -1.33970984426709, 218, 25, 'PPL', 'P'),
(52891, 'Windsor Mill Manor', 39.3325004577637, 0.686481636030153, -76.7319412231445, -1.33922501579064, 218, 25, 'PPL', 'P'),
(158429, 'Windsor Mills', 41.5349998474121, 0.724922502152684, -80.9625015258789, -1.41306222227752, 218, 41, 'PPL', 'P'),
(179549, 'Windsor Mobile Home Park', 33.4127807617188, 0.583163036539011, -111.778060913086, -1.95089519442813, 218, 5, 'PPL', 'P'),
(84436, 'Windsor Oaks', 34.9008293151855, 0.609134383226546, -82.3041687011719, -1.43647873195231, 218, 48, 'PPL', 'P'),
(26140, 'Windsor Park', 30.8913898468018, 0.539156463343837, -83.2938919067383, -1.45375266057284, 218, 13, 'PPL', 'P'),
(52892, 'Windsor Park', 38.8047218322754, 0.677270161293732, -76.8274993896484, -1.3408928204233, 218, 25, 'PPL', 'P'),
(71586, 'Windsor Park', 39.9533309936523, 0.697317172978331, -74.1500015258789, -1.29416166698541, 218, 37, 'PPL', 'P'),
(84437, 'Windsor Park', 34.7008285522461, 0.605643711406751, -79.9241714477539, -1.39493994369175, 218, 48, 'PPL', 'P'),
(91936, 'Windsor Park', 35.978889465332, 0.627950082381146, -84.0002822875977, -1.46608149852325, 218, 50, 'PPL', 'P'),
(107697, 'Windsor Park', 37.2519416809082, 0.650169035092759, -80.0016708374023, -1.3962925632094, 218, 53, 'PPL', 'P'),
(169042, 'Windsor Park', 40.2150001525879, 0.701884161352681, -76.9766693115234, -1.34349632670496, 218, 45, 'PPL', 'P'),
(169043, 'Windsor Pass', 40.1766700744629, 0.701215175286853, -75.1416702270508, -1.31146955090983, 218, 45, 'PPL', 'P'),
(107698, 'Windsor Place', 37.5380592346191, 0.655162728452767, -77.3744430541992, -1.35043878819263, 218, 53, 'PPL', 'P'),
(26142, 'Windsor Spring', 33.3847198486328, 0.582673281214546, -82.0691680908203, -1.43237719755748, 218, 13, 'PPL', 'P'),
(58322, 'Windsor Springs', 38.5666694641113, 0.6731153636771, -90.4116668701172, -1.57798126909982, 218, 29, 'PPL', 'P'),
(26143, 'Windsor Springs Estates', 33.4080581665039, 0.583080611703273, -82.0141677856445, -1.43141726114256, 218, 13, 'PPL', 'P'),
(179550, 'Windsor Square', 33.565559387207, 0.585829526580453, -112.175003051758, -1.95782314168786, 218, 5, 'PPL', 'P'),
(52893, 'Windsor Terrace', 39.3102798461914, 0.68609381319641, -76.7122192382813, -1.33888080221974, 218, 25, 'PPL', 'P'),
(107699, 'Windsor Terrace', 37.0402793884277, 0.646474831186656, -76.3727798461914, -1.33295646721681, 218, 53, 'PPL', 'P'),
(52894, 'Windsor View', 39.5536117553711, 0.69034075618676, -77.1272201538086, -1.34612393459449, 218, 25, 'PPL', 'P'),
(107700, 'Windsor West', 37.2416687011719, 0.649989737772369, -80.0158309936523, -1.39653970455856, 218, 53, 'PPL', 'P'),
(107701, 'Windsor Woods', 36.8294410705566, 0.642795008350439, -76.100830078125, -1.32821004836401, 218, 53, 'PPL', 'P'),
(70273, 'Windsors Crossroads', 36.0694389343262, 0.629530468751026, -80.8319396972656, -1.41078348849079, 218, 33, 'PPL', 'P'),
(114313, 'Windsorville', 41.8908309936523, 0.731132927235721, -72.5358276367188, -1.26598901791984, 218, 8, 'PPL', 'P'),
(129354, 'Windsorville', 44.2994384765625, 0.773171058200677, -69.5516662597656, -1.21390557648116, 218, 26, 'PPL', 'P'),
(52896, 'Windswept Estates', 39.1124992370605, 0.682641890370477, -76.6944427490234, -1.33857054395275, 218, 25, 'PPL', 'P'),
(99156, 'Windthorst', 33.5761108398438, 0.586013684169832, -98.436393737793, -1.71803917451402, 218, 51, 'PPL', 'P'),
(84441, 'Windtree', 34.2358283996582, 0.597527927721817, -82.1624984741211, -1.43400612003823, 218, 48, 'PPL', 'P'),
(52897, 'Windtree Valley', 39.6797218322754, 0.692541792248683, -76.6483306884766, -1.33776573667133, 218, 25, 'PPL', 'P'),
(209201, 'Windust', 46.5361099243164, 0.81220833924933, -118.574440002441, -2.06951438675108, 218, 56, 'PPL', 'P'),
(91938, 'Windvue Estates', 36.2013893127441, 0.631833437303672, -83.2411117553711, -1.45283147315178, 218, 50, 'PPL', 'P'),
(14877, 'Windward', 39.7750015258789, 0.694204736612355, -75.6416702270508, -1.3201961971698, 218, 10, 'PPL', 'P'),
(26145, 'Windward', 31.9744396209717, 0.558059247866084, -81.186393737793, -1.41696987854499, 218, 13, 'PPL', 'P'),
(26146, 'Windward Acres', 31.2416706085205, 0.545270015942223, -81.4486083984375, -1.42154638772024, 218, 13, 'PPL', 'P'),
(52898, 'Windward Cove', 38.9055595397949, 0.679030111300111, -76.1930618286133, -1.32981979608491, 218, 25, 'PPL', 'P'),
(169045, 'Windward Heights', 40.9041709899902, 0.713912461574078, -79.9072189331055, -1.39464406649464, 218, 45, 'PPL', 'P'),
(84442, 'Windward Trail', 34.5955581665039, 0.603806396570706, -82.6094436645508, -1.44180678518718, 218, 48, 'PPL', 'P'),
(26147, 'Windwood', 33.9472198486328, 0.592490758257014, -84.2819366455078, -1.47099729442138, 218, 13, 'PPL', 'P'),
(52900, 'Windwood', 39.2644386291504, 0.685293733025923, -76.7600021362305, -1.3397147711151, 218, 25, 'PPL', 'P'),
(84443, 'Windwood', 33.1069412231445, 0.577825129608111, -80.0824966430664, -1.39770323963881, 218, 48, 'PPL', 'P'),
(91939, 'Windwood', 35.2194404602051, 0.614695196740686, -84.8647232055664, -1.48116883873077, 218, 50, 'PPL', 'P'),
(12896, 'Windwood Circle', 34.9324989318848, 0.609687122310792, -91.9961090087891, -1.60563500122699, 218, 4, 'PPL', 'P'),
(206554, 'Windwood Estates', 40.6369400024414, 0.709248400977995, -111.956390380859, -1.9540076307941, 218, 52, 'PPL', 'P'),
(12897, 'Windwood Heights', 34.9436111450195, 0.609881067017177, -91.9805603027344, -1.60536362511191, 218, 4, 'PPL', 'P'),
(38911, 'Windy', 36.7463912963867, 0.641345516348136, -84.9811096191406, -1.48320016485223, 218, 21, 'PPL', 'P'),
(112096, 'Windy', 39.0280609130859, 0.681168163602254, -81.5283279418945, -1.42293775623175, 218, 58, 'PPL', 'P'),
(26149, 'Windy Acres Trailer Park', 33.4833297729492, 0.584394349069009, -82.1408309936523, -1.43362795116344, 218, 13, 'PPL', 'P'),
(209202, 'Windy Arm', 47.9911117553711, 0.837602911823781, -123.59944152832, -2.1572172082954, 218, 56, 'PPL', 'P'),
(14878, 'Windy Bush', 39.7999992370605, 0.694641028977938, -75.4916687011719, -1.3175781766602, 218, 10, 'PPL', 'P'),
(91940, 'Windy City', 35.7416687011719, 0.623809798992454, -88.9066696166992, -1.55171411179421, 218, 50, 'PPL', 'P'),
(169046, 'Windy City', 41.6188888549805, 0.726386641540982, -78.876106262207, -1.37664775542843, 218, 45, 'PPL', 'P'),
(158431, 'Windy Corner', 40.0263900756836, 0.698592294508261, -83.9263916015625, -1.46479186276538, 218, 41, 'PPL', 'P'),
(26150, 'Windy Creek', 33.8891716003418, 0.59147762519932, -83.4558334350586, -1.45657907343774, 218, 13, 'PPL', 'P'),
(58324, 'Windy Curve', 37.4861106872559, 0.654256055259649, -92.1283264160156, -1.60794263031154, 218, 29, 'PPL', 'P'),
(70275, 'Windy Gap', 36.1183280944824, 0.630383745564288, -80.9897232055664, -1.41353733021599, 218, 33, 'PPL', 'P'),
(79429, 'Windy Gap', 39.7961082458496, 0.694573118370141, -80.4538879394531, -1.40418524057401, 218, 45, 'PPL', 'P'),
(26151, 'Windy Hill', 33.9375, 0.592321114895576, -83.4322204589844, -1.45616694925905, 218, 13, 'PPL', 'P'),
(38912, 'Windy Hill', 37.4197196960449, 0.653097313869356, -86.7052764892578, -1.51329255358958, 218, 21, 'PPL', 'P'),
(52901, 'Windy Hill', 39.3977813720703, 0.687621002923516, -77.3802795410156, -1.35054065410433, 218, 25, 'PPL', 'P'),
(107702, 'Windy Hill', 38.6749992370605, 0.675006074893001, -77.4861068725586, -1.35238768947835, 218, 53, 'PPL', 'P'),
(192445, 'Windy Hill', 36.1211090087891, 0.630432281675155, -102.959167480469, -1.79697646764645, 218, 51, 'PPL', 'P'),
(107703, 'Windy Hill Estates', 37.6091690063477, 0.656403828099771, -77.3869400024414, -1.35065690108591, 218, 53, 'PPL', 'P'),
(26152, 'Windy Hill Manor', 33.5705604553223, 0.58591681168518, -84.4430618286133, -1.47380945937445, 218, 13, 'PPL', 'P'),
(14879, 'Windy Hills', 39.6888885498047, 0.692701781651169, -75.716667175293, -1.32150514084558, 218, 10, 'PPL', 'P'),
(38913, 'Windy Hills', 38.2738914489746, 0.66800542333551, -85.6344375610352, -1.49460288853357, 218, 21, 'PPL', 'P'),
(52902, 'Windy Knolls', 39.110279083252, 0.682603141376616, -76.6172180175781, -1.33722271812506, 218, 25, 'PPL', 'P'),
(14881, 'Windy Mill Park', 39.6944389343262, 0.692798654135821, -75.7236099243164, -1.32162631467518, 218, 10, 'PPL', 'P'),
(52903, 'Windy Oaks', 38.7641716003418, 0.676562426234044, -76.7583312988281, -1.33968560950117, 218, 25, 'PPL', 'P'),
(26153, 'Windy Ridge', 34.9266700744629, 0.60958538955715, -84.2888870239258, -1.47111860140903, 218, 13, 'PPL', 'P'),
(70277, 'Windy Ridge', 35.5813903808594, 0.621012414583435, -77.3455581665039, -1.34993465179828, 218, 33, 'PPL', 'P'),
(26154, 'Windy Ridge Estates', 33.4938888549805, 0.584578639816443, -82.1074981689453, -1.43304618362331, 218, 13, 'PPL', 'P'),
(107711, 'Windy Run', 37.6938896179199, 0.65788248171601, -77.7291717529297, -1.3566299719368, 218, 53, 'PPL', 'P'),
(14882, 'Windy Way', 39.2602806091309, 0.685221161886218, -75.5894393920898, -1.31928459712867, 218, 10, 'PPL', 'P'),
(52904, 'Windyhill', 38.6813888549805, 0.675117594763649, -75.977783203125, -1.32606247526097, 218, 25, 'PPL', 'P'),
(38915, 'Windyville', 37.360279083252, 0.652059879466715, -86.4188919067383, -1.50829419969766, 218, 21, 'PPL', 'P'),
(58325, 'Windyville', 37.7066688537598, 0.658105521457304, -92.9269409179688, -1.6218810828248, 218, 29, 'PPL', 'P'),
(52905, 'Wine Bel Valley', 39.7011108398438, 0.692915100854485, -76.8513870239258, -1.34130973829195, 218, 25, 'PPL', 'P'),
(29005, 'Wine Hill', 37.9488906860352, 0.662333089950723, -89.6744384765625, -1.5651142062931, 218, 18, 'PPL', 'P'),
(84446, 'Wineberg Crossroads', 34.2825012207031, 0.598342522120245, -79.976936340332, -1.3958608647967, 218, 48, 'PPL', 'P'),
(112097, 'Winebrenners Crossroad', 39.4280586242676, 0.688149440662815, -77.8958282470703, -1.35953867647938, 218, 58, 'PPL', 'P'),
(99157, 'Winedale', 30.0869407653809, 0.525116178208399, -96.6405563354492, -1.68669589901265, 218, 51, 'PPL', 'P'),
(107706, 'Winegar Mill', 36.6019401550293, 0.638824368323185, -82.6047210693359, -1.44172436035144, 218, 53, 'PPL', 'P'),
(133763, 'Winegars', 43.9447212219238, 0.766980074193597, -84.3658294677734, -1.4724615003887, 218, 27, 'PPL', 'P'),
(186195, 'Wineland', 36.5416717529297, 0.637772486271631, -119.582778930664, -2.08711322102459, 218, 6, 'PPL', 'P'),
(158432, 'Wineland (historical)', 41.1091690063477, 0.717490351919572, -83.5930633544922, -1.4589741873641, 218, 41, 'PPL', 'P'),
(38916, 'Winesap', 37.2872200012207, 0.650784757936785, -86.01611328125, -1.50126438652624, 218, 21, 'PPL', 'P'),
(91943, 'Winesap', 35.7680587768555, 0.624270392702984, -85.1655578613281, -1.48641939397792, 218, 50, 'PPL', 'P'),
(107707, 'Winesap', 37.4855613708496, 0.654246467879725, -79.1474990844727, -1.38138445374325, 218, 53, 'PPL', 'P'),
(209203, 'Winesap', 47.7597198486328, 0.83356436118873, -120.198890686035, -2.09786639971606, 218, 56, 'PPL', 'P'),
(12898, 'Winesburg', 35.8441696166992, 0.625598777454715, -90.9008331298828, -1.5865188309224, 218, 4, 'PPL', 'P'),
(158433, 'Winesburg', 40.6163902282715, 0.708889739758189, -81.6952819824219, -1.42585165393846, 218, 41, 'PPL', 'P'),
(6881, 'Winetka', 33.436939239502, 0.583584681518598, -86.9113922119141, -1.51688995159006, 218, 2, 'PPL', 'P'),
(70278, 'Winfall', 36.2188911437988, 0.632138901880705, -76.4641723632813, -1.33455156755171, 218, 33, 'PPL', 'P'),
(107708, 'Winfall', 37.2241706848145, 0.649684339774365, -79.0947189331055, -1.38046326632219, 218, 53, 'PPL', 'P'),
(6882, 'Winfield', 33.9288902282715, 0.592170846031068, -87.8172225952148, -1.53269967424326, 218, 2, 'PPL', 'P'),
(12899, 'Winfield', 34.8863906860352, 0.608882381608397, -94.1861114501953, -1.64385775445624, 218, 4, 'PPL', 'P'),
(18653, 'Winfield', 30.2627792358398, 0.528185138469579, -82.6861114501953, -1.44314489047689, 218, 12, 'PPL', 'P'),
(26155, 'Winfield', 33.6061096191406, 0.586537261640142, -82.3969421386719, -1.43809793389508, 218, 13, 'PPL', 'P'),
(34452, 'Winfield', 37.2397193908691, 0.649955715889444, -96.9952774047852, -1.69288694959876, 218, 20, 'PPL', 'P'),
(52920, 'Winfield', 39.4472198486328, 0.688483867116702, -77.0552825927734, -1.34486838729857, 218, 25, 'PPL', 'P'),
(58326, 'Winfield', 38.9972190856934, 0.680629872166922, -90.7383270263672, -1.58368256436146, 218, 29, 'PPL', 'P'),
(91944, 'Winfield', 36.5558280944824, 0.638019561041763, -84.4516677856445, -1.47395966165993, 218, 50, 'PPL', 'P'),
(99158, 'Winfield', 33.1672210693359, 0.578877211396747, -95.1116714477539, -1.66001182383839, 218, 51, 'PPL', 'P'),
(112099, 'Winfield', 38.5330581665039, 0.672528735867983, -81.8936080932617, -1.42931309756529, 218, 58, 'PPL', 'P'),
(118492, 'Winfield', 41.1230583190918, 0.717732766157797, -91.4411087036133, -1.5959484185521, 218, 16, 'PPL', 'P'),
(122015, 'Winfield', 41.8616714477539, 0.730623997151407, -88.1608276367188, -1.53869671354395, 218, 18, 'PPL', 'P'),
(124037, 'Winfield', 41.4052810668945, 0.72265848233098, -87.2752838134766, -1.52324105815768, 218, 19, 'PPL', 'P'),
(146658, 'Winfield', 40.6425018310547, 0.709345473199729, -74.2858276367188, -1.29653227982974, 218, 37, 'PPL', 'P'),
(158434, 'Winfield', 40.5486106872559, 0.707706763601975, -81.5586090087891, -1.42346626055008, 218, 41, 'PPL', 'P'),
(169047, 'Winfield', 40.9091682434082, 0.713999680099778, -76.8555603027344, -1.34138257574776, 218, 45, 'PPL', 'P'),
(187552, 'Winfield', 38.9847183227539, 0.680411692694617, -106.440277099609, -1.8577332921233, 218, 7, 'PPL', 'P'),
(143406, 'Winfield (historical)', 42.6736106872559, 0.744795010206855, -99.6772232055664, -1.73969573418243, 218, 35, 'PPL', 'P'),
(52907, 'Winfield Heights', 39.461109161377, 0.688726281354926, -77.0572204589844, -1.34490220944441, 218, 25, 'PPL', 'P'),
(26158, 'Winfield Hill', 33.6394386291504, 0.587118962601242, -82.4302825927734, -1.43867983459326, 218, 13, 'PPL', 'P'),
(169049, 'Winfield Junction', 40.7083282470703, 0.710494360893989, -79.7030563354492, -1.39108075695612, 218, 45, 'PPL', 'P'),
(52908, 'Winfield Woods', 39.459171295166, 0.688692459209082, -77.0494384765625, -1.34476638822882, 218, 25, 'PPL', 'P'),
(107709, 'Winfields Mill', 36.9477806091309, 0.64486042293385, -77.4958267211914, -1.35255733283979, 218, 53, 'PPL', 'P'),
(38917, 'Winford', 36.9269409179688, 0.644496701707972, -89.0599975585938, -1.55439018921557, 218, 21, 'PPL', 'P'),
(171636, 'Winfred', 43.9972190856934, 0.767896334766638, -97.3619384765625, -1.69928639254017, 218, 49, 'PPL', 'P'),
(12900, 'Winfrey', 35.7344398498535, 0.623683631735812, -94.0994415283203, -1.64234507895707, 218, 4, 'PPL', 'P'),
(107710, 'Winfrey', 38.4452781677246, 0.670996685871887, -77.9763870239258, -1.36094469237689, 218, 53, 'PPL', 'P'),
(6883, 'Wing', 31.0275001525879, 0.541532036325702, -86.6105575561523, -1.51163939634291, 218, 2, 'PPL', 'P'),
(12902, 'Wing', 34.9447212219238, 0.609900441514107, -93.4641723632813, -1.63125754039075, 218, 4, 'PPL', 'P'),
(70279, 'Wing', 35.9447212219238, 0.62735373403405, -82.1458282470703, -1.43371516968914, 218, 33, 'PPL', 'P'),
(122017, 'Wing', 40.8194389343262, 0.712433608220757, -88.4011077880859, -1.5428903933125, 218, 18, 'PPL', 'P'),
(153875, 'Wing', 42.5325012207031, 0.742332185409777, -78.2194366455078, -1.36518670851922, 218, 40, 'PPL', 'P'),
(199116, 'Wing', 47.1408309936523, 0.822762712965423, -100.278610229492, -1.75019191782871, 218, 34, 'PPL', 'P'),
(206556, 'Wing', 40.353889465332, 0.704308237155898, -111.784439086914, -1.95100651456169, 218, 52, 'PPL', 'P'),
(197861, 'Wing (historical)', 48.788890838623, 0.85152678353007, -108.58528137207, -1.89517067914709, 218, 31, 'PPL', 'P'),
(84445, 'Wing Road', 33.4208297729492, 0.583303518286513, -80.0666732788086, -1.39742706983377, 218, 48, 'PPL', 'P'),
(126676, 'Wingaersheek (historical)', 42.6527786254883, 0.744431422139032, -70.6958312988281, -1.23387502359901, 218, 23, 'PPL', 'P'),
(77703, 'Winganon', 36.5538902282715, 0.637985738895919, -95.5608291625977, -1.66785110482314, 218, 42, 'PPL', 'P'),
(6884, 'Wingard', 31.8330593109131, 0.555591695958071, -86.1486129760742, -1.50357694245881, 218, 2, 'PPL', 'P'),
(34455, 'Wingate', 37.4819412231445, 0.654183284382863, -96.6972198486328, -1.68768486388346, 218, 20, 'PPL', 'P'),
(52909, 'Wingate', 38.2819404602051, 0.668145905083012, -76.0822219848633, -1.32788527586908, 218, 25, 'PPL', 'P'),
(58327, 'Wingate', 38.7311096191406, 0.675985385804851, -94.2044372558594, -1.64417760010316, 218, 29, 'PPL', 'P'),
(62353, 'Wingate', 31.2024993896484, 0.544586349200886, -89.0013885498047, -1.55336726904087, 218, 30, 'PPL', 'P'),
(70280, 'Wingate', 34.9841690063477, 0.61058893523492, -80.4494400024414, -1.40410760942824, 218, 33, 'PPL', 'P'),
(124033, 'Wingate', 40.1722183227539, 0.70113747756205, -87.0727767944336, -1.51970664391698, 218, 19, 'PPL', 'P'),
(169051, 'Wingate', 40.9347190856934, 0.714445626424312, -77.8141708374023, -1.35811348582202, 218, 45, 'PPL', 'P'),
(189829, 'Wingate', 35.5144386291504, 0.619843886076136, -108.544166564941, -1.89445309039137, 218, 38, 'PPL', 'P'),
(192446, 'Wingate', 32.0438919067383, 0.559271418925747, -100.109718322754, -1.74724419797615, 218, 51, 'PPL', 'P'),
(126677, 'Wingbrook Estates', 42.0855598449707, 0.734531586839853, -70.8497161865234, -1.23656082155836, 218, 23, 'PPL', 'P'),
(153877, 'Wingdale', 41.6469383239746, 0.726876197128366, -73.5686111450195, -1.28401449059999, 218, 40, 'PPL', 'P'),
(138879, 'Winger', 47.5361099243164, 0.829661631769274, -95.9880599975586, -1.67530768955926, 218, 28, 'PPL', 'P'),
(79430, 'Wingerton', 39.7333297729492, 0.693477427318655, -77.6699981689453, -1.35559719806606, 218, 45, 'PPL', 'P'),
(74858, 'Wingett Run', 39.5366706848145, 0.690045078726733, -81.2433319091797, -1.41796363710576, 218, 41, 'PPL', 'P'),
(179552, 'Wingfield', 34.521110534668, 0.602507040274856, -111.848892211914, -1.95213143380614, 218, 5, 'PPL', 'P'),
(186198, 'Wingfoot', 33.9891700744629, 0.593222927819704, -118.251670837402, -2.06388100209723, 218, 6, 'PPL', 'P'),
(107712, 'Wingina', 37.639720916748, 0.656937059529032, -78.7241668701172, -1.37399591277298, 218, 53, 'PPL', 'P'),
(197862, 'Wingina (historical)', 48.3224983215332, 0.843386698500188, -112.120277404785, -1.9568679989629, 218, 31, 'PPL', 'P'),
(107713, 'Wingmead', 37.6758308410645, 0.657567296600999, -77.6750030517578, -1.35568454974982, 218, 53, 'PPL', 'P'),
(38918, 'Wingo', 36.642219543457, 0.639527376271939, -88.7388916015625, -1.54878583301761, 218, 21, 'PPL', 'P'),
(91947, 'Wingo', 36.0522193908691, 0.629229931022011, -88.584716796875, -1.54609497505219, 218, 50, 'PPL', 'P'),
(186196, 'Wingo', 38.209171295166, 0.666875843559153, -122.425559997559, -2.13672911055526, 218, 6, 'PPL', 'P'),
(187553, 'Wingo', 39.3458290100098, 0.686714263151371, -107.009719848633, -1.86767194299537, 218, 7, 'PPL', 'P'),
(112103, 'Wingrove', 37.9391708374023, 0.662163446589285, -81.163330078125, -1.41656734174623, 218, 58, 'PPL', 'P'),
(52911, 'Wings Landing', 38.7838897705078, 0.676906573225909, -75.9380569458008, -1.32536912127117, 218, 25, 'PPL', 'P'),
(129355, 'Wings Mills', 44.4324989318848, 0.775493401250253, -69.9052810668945, -1.22007731914936, 218, 26, 'PPL', 'P'),
(158435, 'Wingston', 41.269718170166, 0.720292463439526, -83.727783203125, -1.46132549229054, 218, 41, 'PPL', 'P'),
(201821, 'Wingville', 44.8397216796875, 0.782600778988429, -117.920562744141, -2.05810207568981, 218, 43, 'PPL', 'P'),
(34457, 'Winifred', 39.7694396972656, 0.694107664390622, -96.4805603027344, -1.68390344145165, 218, 20, 'PPL', 'P'),
(38919, 'Winifred', 37.9461097717285, 0.662284553839857, -82.8547210693359, -1.44608768348143, 218, 21, 'PPL', 'P'),
(197863, 'Winifred', 47.5577812194824, 0.830039867223092, -109.374168395996, -1.90893935514086, 218, 31, 'PPL', 'P'),
(177306, 'Winifred Knoll', 40.0416717529297, 0.698859010091432, -80.7027816772461, -1.4085292557861, 218, 58, 'PPL', 'P'),
(112104, 'Winifrede', 38.1913909912109, 0.666565518713132, -81.5569381713867, -1.42343709893614, 218, 58, 'PPL', 'P'),
(112105, 'Winifrede Junction', 38.2083282470703, 0.66686112959413, -81.5205612182617, -1.42280220133227, 218, 58, 'PPL', 'P'),
(139537, 'Winigan', 40.0455589294434, 0.698926854120202, -92.9033279418945, -1.62146895864611, 218, 29, 'PPL', 'P'),
(6885, 'Wininger', 34.7427787780762, 0.606375880969442, -86.1594390869141, -1.50376589373815, 218, 2, 'PPL', 'P'),
(107714, 'Wininger', 36.6074981689453, 0.638921373965891, -82.6791687011719, -1.44302371664729, 218, 53, 'PPL', 'P'),
(12903, 'Winington', 36.3558311462402, 0.634528955800996, -92.9075012207031, -1.62154179610192, 218, 4, 'PPL', 'P'),
(192447, 'Wink', 31.7511100769043, 0.55416141200513, -103.159439086914, -1.80047186657718, 218, 51, 'PPL', 'P'),
(122018, 'Winkel', 40.3488883972168, 0.704220952051171, -89.6313934326172, -1.56436292854959, 218, 18, 'PPL', 'P'),
(179553, 'Winkelman', 32.9874992370605, 0.575740473685824, -110.770278930664, -1.93330608069259, 218, 5, 'PPL', 'P'),
(118494, 'Winkelmans', 41.9711112976074, 0.732534082864239, -94.3383331298828, -1.6465145239597, 218, 16, 'PPL', 'P'),
(29007, 'Winkle', 38.1500015258789, 0.665843136267448, -89.4886093139648, -1.56187087555955, 218, 18, 'PPL', 'P'),
(74859, 'Winkle', 39.1150016784668, 0.682685566212354, -83.7216720581055, -1.46121883268888, 218, 41, 'PPL', 'P'),
(158436, 'Winklepleck Grove', 40.5233306884766, 0.707265544388377, -81.6136093139648, -1.424426196965, 218, 41, 'PPL', 'P'),
(34458, 'Winkler', 39.4816703796387, 0.689085142311814, -96.8313903808594, -1.69002658142996, 218, 20, 'PPL', 'P'),
(58335, 'Winkler', 37.8358306884766, 0.660359820741029, -91.5569381713867, -1.59797002413557, 218, 29, 'PPL', 'P'),
(99159, 'Winkler', 31.938060760498, 0.557424316972695, -96.208610534668, -1.67915702259886, 218, 51, 'PPL', 'P'),
(91948, 'Winklers Crossroads', 36.6058311462402, 0.638892278930982, -85.8419418334961, -1.49822452129996, 218, 50, 'PPL', 'P'),
(74861, 'Winklers Mill', 39.6836090087891, 0.692609636277453, -80.9333267211914, -1.4125530258771, 218, 41, 'PPL', 'P'),
(26157, 'Winkles (historical)', 33.9119415283203, 0.591875035412987, -85.2402801513672, -1.48772354396373, 218, 13, 'PPL', 'P'),
(129360, 'Winkumpaugh Corners', 44.6263885498047, 0.778877413468389, -68.6288909912109, -1.19780010978891, 218, 26, 'PPL', 'P'),
(209204, 'Winlock', 46.4913902282715, 0.811427833312856, -122.936668395996, -2.14564963494259, 218, 56, 'PPL', 'P'),
(14883, 'Winmill', 39.026668548584, 0.681143862257307, -75.5169372558594, -1.31801919613672, 218, 10, 'PPL', 'P'),
(6886, 'Winn', 31.6516704559326, 0.552425863212239, -87.9172210693359, -1.53444497686364, 218, 2, 'PPL', 'P'),
(129356, 'Winn', 45.4855613708496, 0.793872808039271, -68.3727798461914, -1.19333012705726, 218, 26, 'PPL', 'P'),
(133765, 'Winn', 43.5233306884766, 0.759625421948206, -84.9016723632813, -1.48181372318873, 218, 27, 'PPL', 'P'),
(6893, 'Winn Crossroads', 34.3377799987793, 0.599307318804153, -86.6163864135742, -1.51174112909655, 218, 2, 'PPL', 'P'),
(91949, 'Winn Springs', 35.0108299255371, 0.611054256056384, -88.209716796875, -1.53954999035722, 218, 50, 'PPL', 'P'),
(70281, 'Winnabow', 34.149169921875, 0.596015451959733, -78.0938873291016, -1.3629954595743, 218, 33, 'PPL', 'P'),
(26159, 'Winndale', 33.8913917541504, 0.591516374193181, -84.8130569458008, -1.48026709238567, 218, 13, 'PPL', 'P'),
(122019, 'Winnebago', 42.2661094665527, 0.737682772199689, -89.2411117553711, -1.55755122827144, 218, 18, 'PPL', 'P'),
(138882, 'Winnebago', 43.7677803039551, 0.763891872593541, -94.1655578613281, -1.64349902665741, 218, 28, 'PPL', 'P'),
(143405, 'Winnebago', 42.2358283996582, 0.737154267881363, -96.4722213745117, -1.68375789969808, 218, 35, 'PPL', 'P'),
(177082, 'Winnebago', 44.0758285522461, 0.76926832878122, -88.5250015258789, -1.54505274695959, 218, 57, 'PPL', 'P'),
(177083, 'Winnebago Heights', 43.9002799987793, 0.766204428526111, -88.3424987792969, -1.5418674731378, 218, 57, 'PPL', 'P'),
(177084, 'Winnebago Mission', 44.3461112976074, 0.773985652599104, -90.7547225952148, -1.58396872102059, 218, 57, 'PPL', 'P'),
(177085, 'Winnebago Park', 43.8852806091309, 0.765942639790956, -88.3525009155273, -1.54204204334726, 218, 57, 'PPL', 'P'),
(91951, 'Winnebago Subdivision', 35.8611106872559, 0.625894454914741, -85.0513916015625, -1.48442681685032, 218, 50, 'PPL', 'P'),
(29008, 'Winneberger', 38.8797187805176, 0.678579104969506, -90.5852813720703, -1.58101141378811, 218, 18, 'PPL', 'P'),
(177086, 'Winneboujou', 46.5175018310547, 0.811883566754395, -91.600830078125, -1.59873608242314, 218, 57, 'PPL', 'P'),
(177087, 'Winneconne', 44.1108283996582, 0.769879191356257, -88.7125015258789, -1.54832523930708, 218, 57, 'PPL', 'P'),
(129358, 'Winnecook', 44.6544418334961, 0.7793670356348, -69.3883285522461, -1.21105479569228, 218, 26, 'PPL', 'P'),
(197864, 'Winnecook', 46.4000015258789, 0.80983279955698, -109.663330078125, -1.91398617856461, 218, 31, 'PPL', 'P'),
(126678, 'Winnecunnet', 41.976390838623, 0.732626228237956, -71.1305618286133, -1.2414625027027, 218, 23, 'PPL', 'P'),
(129359, 'Winnegance', 43.8722190856934, 0.765714673201645, -69.8197174072266, -1.2185839515681, 218, 26, 'PPL', 'P'),
(158437, 'Winnemac (historical)', 40.5741691589355, 0.708152843084564, -83.3899993896484, -1.45543005258543, 218, 41, 'PPL', 'P'),
(200287, 'Winnemucca', 40.9730606079102, 0.715114812227222, -117.734718322754, -2.05485847864015, 218, 39, 'PPL', 'P'),
(58328, 'Winner', 39.3325004577637, 0.686481636030153, -94.4916687011719, -1.64919073453912, 218, 29, 'PPL', 'P'),
(91950, 'Winner', 36.3969383239746, 0.635246411398664, -82.1091690063477, -1.43307534523725, 218, 50, 'PPL', 'P'),
(138886, 'Winner', 48.5977783203125, 0.848191240843773, -95.4397201538086, -1.66573735386595, 218, 28, 'PPL', 'P'),
(171640, 'Winner', 43.3766708374023, 0.757065724666477, -99.8586120605469, -1.74286156692826, 218, 49, 'PPL', 'P'),
(122024, 'Winneshiek', 42.3444404602051, 0.739049905945282, -89.5272216796875, -1.5625447884734, 218, 18, 'PPL', 'P'),
(122028, 'Winnetka', 42.1080589294434, 0.734924269942585, -87.7358322143555, -1.53127914411781, 218, 18, 'PPL', 'P'),
(186197, 'Winnetka', 34.2133293151855, 0.597135244619085, -118.571113586426, -2.06945632983931, 218, 6, 'PPL', 'P'),
(143413, 'Winnetoon', 42.5125007629395, 0.741983111569895, -97.960563659668, -1.70973437297071, 218, 35, 'PPL', 'P'),
(197865, 'Winnett', 47.0027809143066, 0.820353284548202, -108.351387023926, -1.89108845267016, 218, 31, 'PPL', 'P'),
(44186, 'Winnfield', 31.9252796173096, 0.557201243941887, -92.6394424438477, -1.61686328785692, 218, 22, 'PPL', 'P'),
(144691, 'Winniconic', 43.0222206115723, 0.750879401191304, -70.8763885498047, -1.2370263421169, 218, 36, 'PPL', 'P'),
(144692, 'Winnicut Mills', 43.0108299255371, 0.75068059621593, -70.8744430541992, -1.236992386813, 218, 36, 'PPL', 'P'),
(99160, 'Winnie', 29.8199996948242, 0.520457177618387, -94.3838882446289, -1.64730961070315, 218, 51, 'PPL', 'P'),
(107715, 'Winnie', 37.0730590820313, 0.647046944767832, -78.1324996948242, -1.36366937248815, 218, 53, 'PPL', 'P'),
(70282, 'Winningham Farm', 35.7172203063965, 0.623383094006797, -79.7838897705078, -1.39249156654358, 218, 33, 'PPL', 'P'),
(99161, 'Winningkoff', 33.1111106872559, 0.577897900484897, -96.5633316040039, -1.68534807318497, 218, 51, 'PPL', 'P'),
(114314, 'Winnipauk', 41.1463890075684, 0.71813996348847, -73.4222183227539, -1.28145945385016, 218, 8, 'PPL', 'P'),
(114315, 'Winnipauk Village', 41.1294403076172, 0.717844152870389, -73.4175033569336, -1.28137716217248, 218, 8, 'PPL', 'P'),
(58330, 'Winnipeg', 37.6044387817383, 0.656321270105978, -92.3019409179688, -1.61097277499983, 218, 29, 'PPL', 'P'),
(138887, 'Winnipeg Junction', 46.8958282470703, 0.818486608361138, -96.2463912963867, -1.67981642128476, 218, 28, 'PPL', 'P'),
(144693, 'Winnipesaukee', 43.6741714477539, 0.762258089843804, -71.335563659668, -1.24504045962722, 218, 36, 'PPL', 'P'),
(144694, 'Winnisquam', 43.5013885498047, 0.759242459383453, -71.5124969482422, -1.24812852806922, 218, 36, 'PPL', 'P'),
(126679, 'Winnmere', 42.4922218322754, 0.741629177461023, -71.1805572509766, -1.24233508743386, 218, 23, 'PPL', 'P'),
(44187, 'Winnsboro', 32.1630592346191, 0.561351281158071, -91.7205581665039, -1.60082573177247, 218, 22, 'PPL', 'P'),
(84447, 'Winnsboro', 34.3805618286133, 0.600054002594784, -81.086669921875, -1.41522936961457, 218, 48, 'PPL', 'P'),
(99162, 'Winnsboro', 32.957218170166, 0.575211969367498, -95.2900009155273, -1.66312426020436, 218, 51, 'PPL', 'P'),
(84448, 'Winnsboro Mills', 34.3616714477539, 0.599724303251832, -81.085563659668, -1.41521006169667, 218, 48, 'PPL', 'P'),
(58332, 'Winnwood Gardens', 39.1805610656738, 0.683829793374707, -94.5119400024414, -1.64954453548994, 218, 29, 'PPL', 'P'),
(179554, 'Winnwood Homes', 33.4488906860352, 0.583793273610978, -112.341667175293, -1.9607319793885, 218, 5, 'PPL', 'P'),
(26160, 'Winokur', 31.0380592346191, 0.541716327073135, -82.0202789306641, -1.43152392074422, 218, 13, 'PPL', 'P'),
(12904, 'Winona', 34.8972206115723, 0.609071399466765, -90.5336074829102, -1.58010953428496, 218, 4, 'PPL', 'P'),
(58333, 'Winona', 37.0097198486328, 0.64594146659934, -91.3233337402344, -1.59389285766472, 218, 29, 'PPL', 'P'),
(62355, 'Winona', 33.4819412231445, 0.584370114303089, -89.7280578613281, -1.56605004110016, 218, 30, 'PPL', 'P'),
(84449, 'Winona', 34.3666687011719, 0.599811521777533, -82.3836135864258, -1.43786530677386, 218, 48, 'PPL', 'P'),
(91953, 'Winona', 36.3766708374023, 0.634892677026874, -84.4502792358398, -1.47393542689401, 218, 50, 'PPL', 'P'),
(99163, 'Winona', 32.4894409179688, 0.567047716150724, -95.1669387817383, -1.66097642078521, 218, 51, 'PPL', 'P'),
(107716, 'Winona', 36.8800010681152, 0.643677446777636, -76.2683334350586, -1.33113353345065, 218, 53, 'PPL', 'P'),
(112106, 'Winona', 38.0463905334473, 0.664034783308257, -80.9925003051758, -1.41358579974783, 218, 58, 'PPL', 'P'),
(124034, 'Winona', 41.2361106872559, 0.719705902209436, -86.5694427490234, -1.51092180758719, 218, 19, 'PPL', 'P'),
(133766, 'Winona', 46.874439239502, 0.818113299755336, -88.9072189331055, -1.55172369917413, 218, 27, 'PPL', 'P'),
(138888, 'Winona', 44.0499992370605, 0.768817522187697, -91.6391677856445, -1.59940520164702, 218, 28, 'PPL', 'P'),
(144695, 'Winona', 43.6661109924316, 0.762117408359221, -71.5586090087891, -1.24893333535065, 218, 36, 'PPL', 'P'),
(153878, 'Winona', 43.7188911437988, 0.763038595780279, -75.9863891601563, -1.32621267754646, 218, 40, 'PPL', 'P'),
(158438, 'Winona', 40.8280601501465, 0.712584076822347, -80.8963928222656, -1.41190840773524, 218, 41, 'PPL', 'P'),
(187969, 'Winona', 39.0633316040039, 0.681783753288226, -101.24388885498, -1.7670392080426, 218, 20, 'PPL', 'P'),
(192875, 'Winona', 35.2050018310547, 0.614443195122537, -111.407501220703, -1.94442770772087, 218, 5, 'PPL', 'P'),
(195808, 'Winona', 46.1322212219238, 0.805159151580973, -116.106941223145, -2.0264484087634, 218, 17, 'PPL', 'P'),
(209207, 'Winona', 46.9458312988281, 0.819359326250357, -117.799438476563, -2.05598805841651, 218, 56, 'PPL', 'P'),
(44188, 'Winona (historical)', 32.0963897705078, 0.560187679498789, -92.6605606079102, -1.61723186935179, 218, 22, 'PPL', 'P'),
(74860, 'Winona (historical)', 39.5922203063965, 0.691014602521577, -82.3388900756836, -1.43708473425836, 218, 41, 'PPL', 'P'),
(112107, 'Winona (historical)', 39.3844413757324, 0.687388176065216, -80.0611114501953, -1.39732999761204, 218, 58, 'PPL', 'P'),
(124035, 'Winona Lake', 41.2272186279297, 0.719550706496912, -85.8219375610352, -1.49787538088106, 218, 19, 'PPL', 'P'),
(169053, 'Winona Lakes', 41.0833282470703, 0.717039345588967, -75.0694427490234, -1.31020894360784, 218, 45, 'PPL', 'P'),
(26161, 'Winona Park', 31.228889465332, 0.545046942911416, -82.3874969482422, -1.43793308422361, 218, 13, 'PPL', 'P'),
(12905, 'Winona Springs (historical)', 36.3327789306641, 0.634126618739312, -93.6813888549805, -1.63504868336053, 218, 4, 'PPL', 'P'),
(172814, 'Winooski', 44.4913902282715, 0.776521248272969, -73.1861114501953, -1.27733861153743, 218, 55, 'PPL', 'P'),
(52912, 'Winpenny Tell', 39.4727783203125, 0.68892994659929, -77.4499969482422, -1.35175745240639, 218, 25, 'PPL', 'P'),
(12907, 'Winrock', 35.1380615234375, 0.613274866352319, -92.9436111450195, -1.62217203317389, 218, 4, 'PPL', 'P'),
(77704, 'Winrock Farms', 34.5155601501465, 0.602410167790205, -96.8394393920898, -1.69016706317746, 218, 42, 'PPL', 'P'),
(99164, 'Winscott', 32.5561103820801, 0.568211317810006, -97.5488891601563, -1.70254929750773, 218, 51, 'PPL', 'P'),
(126680, 'Winsegansett Heights', 41.5972213745117, 0.726008472666191, -70.8630599975586, -1.23679371499568, 218, 23, 'PPL', 'P'),
(171642, 'Winship', 45.922779083252, 0.80150369666873, -98.5183334350586, -1.71946929201939, 218, 49, 'PPL', 'P'),
(143408, 'Winside', 42.1763916015625, 0.73611690005775, -97.1747207641602, -1.69601882704069, 218, 35, 'PPL', 'P'),
(567, 'Winslow', 38.4536094665527, 0.671142094467406, -82.6819381713867, -1.44307205302108, 218, 21, 'PPL', 'P'),
(6887, 'Winslow', 32.5161094665527, 0.567513170130242, -86.7699966430664, -1.51442213336594, 218, 2, 'PPL', 'P'),
(12908, 'Winslow', 35.8008308410645, 0.624842373126105, -94.1347198486328, -1.6429608018011, 218, 4, 'PPL', 'P'),
(31548, 'Winslow', 38.3822212219238, 0.669896134551412, -87.2127838134766, -1.52215022737518, 218, 19, 'PPL', 'P'),
(70283, 'Winslow', 36.1794395446777, 0.631450341580865, -76.1988906860352, -1.32992152883855, 218, 33, 'PPL', 'P'),
(71587, 'Winslow', 39.6572189331055, 0.692149042566923, -74.8627777099609, -1.30660195822744, 218, 37, 'PPL', 'P'),
(91954, 'Winslow', 35.9913902282715, 0.628168261853451, -84.456672668457, -1.47404701334368, 218, 50, 'PPL', 'P'),
(99165, 'Winslow', 31.9958305358887, 0.558432589761399, -97.123893737793, -1.69513172808159, 218, 51, 'PPL', 'P'),
(112108, 'Winslow', 38.3066711425781, 0.668577536916687, -82.3077774047852, -1.43654171571209, 218, 58, 'PPL', 'P'),
(122025, 'Winslow', 42.4925003051758, 0.741634037730013, -89.7922210693359, -1.56716990033854, 218, 18, 'PPL', 'P'),
(129361, 'Winslow', 44.5469398498535, 0.777490772067812, -69.6216735839844, -1.21512743478929, 218, 26, 'PPL', 'P'),
(139538, 'Winslow', 40.0102806091309, 0.698311131276176, -94.4622192382813, -1.64867674444874, 218, 29, 'PPL', 'P'),
(143409, 'Winslow', 41.6091690063477, 0.726216998179544, -96.5041732788086, -1.68431556563034, 218, 35, 'PPL', 'P'),
(169054, 'Winslow', 40.9244384765625, 0.714266195945868, -78.8841705322266, -1.37678850349204, 218, 45, 'PPL', 'P'),
(179555, 'Winslow', 35.024169921875, 0.611287082914684, -110.696670532227, -1.93202137178274, 218, 5, 'PPL', 'P'),
(209205, 'Winslow', 47.6263885498047, 0.831237291028219, -122.519996643066, -2.13837734095391, 218, 56, 'PPL', 'P'),
(126681, 'Winslow Estates', 42.0819396972656, 0.734468403342991, -70.914436340332, -1.23769040133471, 218, 23, 'PPL', 'P'),
(129362, 'Winslow Hill', 44.0950012207031, 0.769602954972188, -69.4608306884766, -1.21232019668424, 218, 26, 'PPL', 'P'),
(107717, 'Winslow Hills', 38.7936096191406, 0.677076216587347, -77.1205596923828, -1.34600768761291, 218, 53, 'PPL', 'P'),
(71588, 'Winslow Junction', 39.6650009155273, 0.692284863782517, -74.8477783203125, -1.30634016949228, 218, 37, 'PPL', 'P'),
(206557, 'Winslow Park', 40.6944389343262, 0.710251946655764, -111.883331298828, -1.95273250926417, 218, 52, 'PPL', 'P'),
(179556, 'Winslow West', 35.0322189331055, 0.611427564662186, -110.752220153809, -1.93299089557758, 218, 5, 'PPL', 'P'),
(126682, 'Winslows', 42.1708297729492, 0.736019827836017, -71.2111129760742, -1.24286838544215, 218, 23, 'PPL', 'P'),
(126683, 'Winslows Crossing', 42.1088905334473, 0.734938784170526, -70.8675003051758, -1.2368712129834, 218, 23, 'PPL', 'P'),
(129363, 'Winslows Mills', 44.1202812194824, 0.770044174185787, -69.4102783203125, -1.21143789141509, 218, 26, 'PPL', 'P'),
(52913, 'Winsome Heights', 39.5852813720703, 0.690893495271005, -76.9027786254883, -1.34220669094709, 218, 25, 'PPL', 'P'),
(112109, 'Winsor Court', 38.4527816772461, 0.671127646818492, -81.980827331543, -1.43083536044438, 218, 58, 'PPL', 'P'),
(189831, 'Winsor Creek Summer Home', 35.8141708374023, 0.625075199984406, -105.67138671875, -1.84431362339039, 218, 38, 'PPL', 'P'),
(195809, 'Winsper', 44.1305618286133, 0.770223604664231, -112.514442443848, -1.9637474766908, 218, 17, 'PPL', 'P'),
(79431, 'Winstead', 39.7588882446289, 0.693923506801243, -79.9283294677734, -1.39501251483145, 218, 45, 'PPL', 'P'),
(91955, 'Winstead (historical)', 35.7775001525879, 0.624435175795432, -86.4019393920898, -1.50799832250056, 218, 50, 'PPL', 'P'),
(70285, 'Winstead Crossroads', 35.8413887023926, 0.625550241343849, -77.9308319091797, -1.36014960563344, 218, 33, 'PPL', 'P'),
(70286, 'Winsteadville', 35.4644393920898, 0.618971234765944, -76.6361083984375, -1.33755241746801, 218, 33, 'PPL', 'P'),
(114316, 'Winsted', 41.9211082458496, 0.73166136497502, -73.0605621337891, -1.27514736259251, 218, 8, 'PPL', 'P'),
(138893, 'Winsted', 44.9638900756836, 0.784767926325481, -94.0472183227539, -1.64143361207399, 218, 28, 'PPL', 'P'),
(52914, 'Winsten Estates', 39.313060760498, 0.686142349307277, -76.7727813720703, -1.3399378108564, 218, 25, 'PPL', 'P'),
(18654, 'Winston', 28.0313892364502, 0.489240036084155, -82.0149993896484, -1.43143177537051, 218, 12, 'PPL', 'P'),
(26162, 'Winston', 33.7249984741211, 0.588612263603477, -84.8249969482422, -1.48047548474097, 218, 13, 'PPL', 'P'),
(38920, 'Winston', 37.7055587768555, 0.658086146960374, -84.0822219848633, -1.46751161602863, 218, 21, 'PPL', 'P'),
(62359, 'Winston', 33.2702789306641, 0.580675910396986, -88.8361129760742, -1.55048266610615, 218, 30, 'PPL', 'P'),
(107718, 'Winston', 38.4099998474121, 0.670380963027861, -78.0097198486328, -1.36152645991702, 218, 53, 'PPL', 'P'),
(112428, 'Winston', 39.8699989318848, 0.695862754128012, -94.1397171020508, -1.6430480203268, 218, 29, 'PPL', 'P'),
(122027, 'Winston', 42.3344383239746, 0.738875335735827, -90.3636093139648, -1.5771425065145, 218, 18, 'PPL', 'P'),
(189830, 'Winston', 33.3466682434082, 0.582009155417707, -107.646667480469, -1.87878877633369, 218, 38, 'PPL', 'P'),
(197866, 'Winston', 46.4766693115234, 0.81117090484669, -111.658058166504, -1.94880075138884, 218, 31, 'PPL', 'P'),
(201822, 'Winston', 43.122501373291, 0.752629630659705, -123.411392211914, -2.15393512856799, 218, 43, 'PPL', 'P'),
(209206, 'Winston', 46.4858283996582, 0.811330761091122, -122.52082824707, -2.13839185518185, 218, 56, 'PPL', 'P'),
(38921, 'Winston Park', 39.0416717529297, 0.681405717571489, -84.5025024414063, -1.47484689377709, 218, 21, 'PPL', 'P'),
(146660, 'Winston Park', 40.1575012207031, 0.700880615674912, -74.2397232055664, -1.29572760570637, 218, 37, 'PPL', 'P'),
(107719, 'Winston Terrace', 37.2533302307129, 0.650193269858679, -76.7380599975586, -1.33933180855035, 218, 53, 'PPL', 'P'),
(70288, 'Winston-Salem', 36.0997200012207, 0.630058973069353, -80.2444381713867, -1.40052965250372, 218, 33, 'PPL', 'P'),
(62358, 'Winstonville', 33.9099998474121, 0.591841146688116, -90.7513885498047, -1.58391053095077, 218, 30, 'PPL', 'P'),
(112110, 'Winter', 38.5094413757324, 0.672116545110266, -81.7474975585938, -1.42676298766349, 218, 58, 'PPL', 'P'),
(138896, 'Winter', 47.5272216796875, 0.829506502635777, -91.4902801513672, -1.59680662221337, 218, 28, 'PPL', 'P'),
(177090, 'Winter', 45.8197212219238, 0.79970499766849, -91.0116729736328, -1.58845335113823, 218, 57, 'PPL', 'P'),
(18655, 'Winter Beach', 27.7188892364502, 0.483785882171673, -80.4208297729492, -1.40360826672385, 218, 12, 'PPL', 'P'),
(18656, 'Winter Garden', 28.5650005340576, 0.498553310153244, -81.5863876342773, -1.42395108902653, 218, 12, 'PPL', 'P'),
(186203, 'Winter Gardens', 32.8311080932617, 0.573010933305575, -116.932502746582, -2.04085717552517, 218, 6, 'PPL', 'P'),
(129375, 'Winter Harbor', 44.3952789306641, 0.774843789681355, -68.083610534668, -1.18828317047545, 218, 26, 'PPL', 'P'),
(107720, 'Winter Harbor Haven', 37.3758316040039, 0.652331322160822, -76.2641677856445, -1.33106082915289, 218, 53, 'PPL', 'P'),
(18657, 'Winter Haven', 28.0219402313232, 0.489075119833652, -81.7330627441406, -1.42651105262437, 218, 12, 'PPL', 'P'),
(99166, 'Winter Haven', 28.6194400787354, 0.499503459451157, -99.8572235107422, -1.74283733216234, 218, 51, 'PPL', 'P'),
(99167, 'Winter Hill', 31.6597194671631, 0.552566344959741, -94.8230590820313, -1.65497458779456, 218, 51, 'PPL', 'P'),
(126684, 'Winter Hill', 42.3958282470703, 0.739946792021393, -71.0994415283203, -1.24091935099838, 218, 23, 'PPL', 'P'),
(18658, 'Winter Park', 28.5997200012207, 0.499159279169778, -81.3394393920898, -1.41964102911834, 218, 12, 'PPL', 'P'),
(70289, 'Winter Park', 34.2102813720703, 0.59708204797631, -77.8869400024414, -1.35938354734588, 218, 33, 'PPL', 'P'),
(84450, 'Winter Park', 33.9174995422363, 0.591972041055693, -80.4105606079102, -1.40342903598249, 218, 48, 'PPL', 'P'),
(187554, 'Winter Park', 39.8916702270508, 0.69624098958183, -105.762496948242, -1.84590379687728, 218, 7, 'PPL', 'P'),
(192868, 'Winter Quarters', 39.7205581665039, 0.693254520735415, -111.186943054199, -1.94057824152322, 218, 52, 'PPL', 'P'),
(52915, 'Winter Run', 39.4313888549805, 0.688207564153606, -77.4730606079102, -1.35215998920515, 218, 25, 'PPL', 'P'),
(18659, 'Winter Springs', 28.6986103057861, 0.500885240582745, -81.3083267211914, -1.41909801057208, 218, 12, 'PPL', 'P'),
(52916, 'Winter Springs', 39.4652786254883, 0.688799052231713, -77.251106262207, -1.34828615508352, 218, 25, 'PPL', 'P'),
(99168, 'Winter Valley Estates', 30.1277809143066, 0.525828973274158, -94.8861083984375, -1.65607500595698, 218, 51, 'PPL', 'P'),
(52917, 'Winterberry', 39.5805587768555, 0.690811070435267, -76.9038925170898, -1.34222613202305, 218, 25, 'PPL', 'P'),
(52918, 'Winterborn', 39.413890838623, 0.687902166155601, -77.4933319091797, -1.35251379015597, 218, 25, 'PPL', 'P'),
(6890, 'Winterboro', 33.3213882446289, 0.581567936204108, -86.1969375610352, -1.50442036557603, 218, 2, 'PPL', 'P'),
(169056, 'Winterburn', 41.1800003051758, 0.718726591297587, -78.6022186279297, -1.37186751442979, 218, 45, 'PPL', 'P'),
(14884, 'Winterbury', 39.7611083984375, 0.693962255795104, -75.658332824707, -1.32048701436084, 218, 10, 'PPL', 'P'),
(179557, 'Wintercone Park', 33.4494400024414, 0.583802860990903, -111.818328857422, -1.9515980026398, 218, 5, 'PPL', 'P'),
(84451, 'Wintercrest', 34.9644393920898, 0.610244588505972, -81.0663909912109, -1.4148754355057, 218, 48, 'PPL', 'P'),
(158439, 'Winterdale', 40.3699989318848, 0.704589400387983, -80.7088928222656, -1.40863591538775, 218, 41, 'PPL', 'P'),
(169057, 'Winterdale', 41.9569396972656, 0.732286741777998, -75.3502807617188, -1.31511049159413, 218, 45, 'PPL', 'P'),
(99169, 'Winterfield', 33.0744400024414, 0.577257876295924, -95.3647232055664, -1.66442841019018, 218, 51, 'PPL', 'P'),
(70293, 'Wintergreen', 35.2291717529297, 0.614865039839205, -77.3024978637695, -1.34918310773866, 218, 33, 'PPL', 'P'),
(107721, 'Wintergreen', 37.8847198486328, 0.66121309755429, -78.8997192382813, -1.37705987960712, 218, 53, 'PPL', 'P'),
(107722, 'Winterham', 37.3675003051758, 0.652185913565303, -77.9316711425781, -1.36016425301944, 218, 53, 'PPL', 'P'),
(186200, 'Winterhaven', 32.7394409179688, 0.571411039280709, -114.633888244629, -2.000738784232, 218, 6, 'PPL', 'P'),
(186201, 'Winterhaven Village', 38.7180595397949, 0.675757618952622, -121.079170227051, -2.11323017604473, 218, 6, 'PPL', 'P'),
(209209, 'Wintermutes Corner', 47.8497200012207, 0.835135160178686, -122.21639251709, -2.13307844933298, 218, 56, 'PPL', 'P'),
(107723, 'Winterpock', 37.3458290100098, 0.651807678111485, -77.7197189331055, -1.35646498910727, 218, 53, 'PPL', 'P'),
(129366, 'Winterport', 44.6377792358398, 0.779076218443764, -68.8455581665039, -1.20158166537876, 218, 26, 'PPL', 'P'),
(29009, 'Winterrowd', 38.9408302307129, 0.679645700986083, -88.375, -1.54243472644999, 218, 18, 'PPL', 'P'),
(99170, 'Winters', 31.9563903808594, 0.557744229198641, -99.9619369506836, -1.74466492646041, 218, 51, 'PPL', 'P'),
(186202, 'Winters', 38.5250015258789, 0.672388120962426, -121.969718933105, -2.12877318311476, 218, 6, 'PPL', 'P'),
(126685, 'Winters Corner', 42.0708312988281, 0.734274525215633, -71.0652770996094, -1.24032306923031, 218, 23, 'PPL', 'P'),
(199792, 'Winters Mobile Home Park', 40.5286102294922, 0.707357689762093, -101.640281677246, -1.77395756792241, 218, 35, 'PPL', 'P'),
(52919, 'Winters Run', 39.5263900756836, 0.689865648248289, -76.3930587768555, -1.33331040132568, 218, 25, 'PPL', 'P'),
(158441, 'Winters Station', 41.2769393920898, 0.720418497538114, -83.2355575561523, -1.4527345340881, 218, 41, 'PPL', 'P'),
(179558, 'Wintersburg', 33.4244384765625, 0.583366502046293, -112.867218017578, -1.96990457197301, 218, 5, 'PPL', 'P'),
(186204, 'Wintersburg', 33.7158317565918, 0.58845227420099, -117.996940612793, -2.05943512097345, 218, 6, 'PPL', 'P'),
(52921, 'Winterseat', 38.3658294677734, 0.66961004447131, -76.5880584716797, -1.33671378804075, 218, 25, 'PPL', 'P'),
(84452, 'Winterseat', 33.9794387817383, 0.593053084721184, -82.2019424438477, -1.43469454718002, 218, 48, 'PPL', 'P'),
(118498, 'Winterset', 41.3308296203613, 0.721359059456103, -94.0136108398438, -1.6408470508439, 218, 16, 'PPL', 'P'),
(158442, 'Winterset', 40.103889465332, 0.699944914025912, -81.4166717529297, -1.42098898810409, 218, 41, 'PPL', 'P'),
(169058, 'Winterset', 40.5022201538086, 0.706897096051564, -78.688606262207, -1.37337526308094, 218, 45, 'PPL', 'P'),
(79432, 'Winterstown', 39.8352813720703, 0.695256818400991, -76.6183319091797, -1.33724215920102, 218, 45, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(139539, 'Wintersville', 40.2683296203613, 0.702814936153663, -93.3266677856445, -1.62885763277442, 218, 29, 'PPL', 'P'),
(158443, 'Wintersville', 40.3752784729004, 0.7046815457617, -80.7038879394531, -1.408548563704, 218, 41, 'PPL', 'P'),
(169059, 'Wintersville', 40.4247207641602, 0.705544476533913, -76.2652816772461, -1.33108027022885, 218, 45, 'PPL', 'P'),
(14885, 'Winterthur', 39.8027801513672, 0.694689565088804, -75.5919418334961, -1.31932827297055, 218, 10, 'PPL', 'P'),
(112288, 'Winterthur Woods', 33.4708290100098, 0.584176169596704, -84.4697189331055, -1.47427471361688, 218, 13, 'PPL', 'P'),
(153879, 'Winterton', 41.5227813720703, 0.724709249528396, -74.470832824707, -1.29976122949341, 218, 40, 'PPL', 'P'),
(26164, 'Winterville', 33.9669418334961, 0.592834971827906, -83.2783279418945, -1.45348101814165, 218, 13, 'PPL', 'P'),
(70294, 'Winterville', 35.5288887023926, 0.620096087431366, -77.4013900756836, -1.35090910244114, 218, 33, 'PPL', 'P'),
(107724, 'Winterville', 37.8383293151855, 0.660403430003879, -75.642219543457, -1.32020578454973, 218, 53, 'PPL', 'P'),
(112446, 'Winterville', 33.5016708374023, 0.584714461032037, -91.0583267211914, -1.58926761264152, 218, 30, 'PPL', 'P'),
(129368, 'Winterville', 46.9702796936035, 0.819786031236015, -68.5716705322266, -1.19680142438013, 218, 26, 'PPL', 'P'),
(201823, 'Winterville', 43.1247215270996, 0.752668379653565, -124.367500305176, -2.17062236280037, 218, 43, 'PPL', 'P'),
(186205, 'Winterwarm', 33.3408317565918, 0.581907289506011, -117.221389770508, -2.04589920525896, 218, 6, 'PPL', 'P'),
(26165, 'Winterwood', 31.5686092376709, 0.550976171472854, -84.2322235107422, -1.47012963653823, 218, 13, 'PPL', 'P'),
(190941, 'Winterwood (historical)', 36.1483306884766, 0.630907389613625, -115.048889160156, -2.00798191660674, 218, 39, 'PPL', 'P'),
(12913, 'Winthrop', 33.8316688537598, 0.590474012942524, -94.3544387817383, -1.64679562061276, 218, 4, 'PPL', 'P'),
(58336, 'Winthrop', 39.5597190856934, 0.69044734920939, -95.1072235107422, -1.65993419269261, 218, 29, 'PPL', 'P'),
(114317, 'Winthrop', 41.3616714477539, 0.721897350891435, -72.4891662597656, -1.26517462325849, 218, 8, 'PPL', 'P'),
(118500, 'Winthrop', 42.473331451416, 0.741299478118072, -91.7341690063477, -1.6010632857417, 218, 16, 'PPL', 'P'),
(124036, 'Winthrop', 40.3699989318848, 0.704589400387983, -87.23388671875, -1.52251854255394, 218, 19, 'PPL', 'P'),
(126686, 'Winthrop', 42.375, 0.739583270532597, -70.9833297729492, -1.23889281856688, 218, 23, 'PPL', 'P'),
(129370, 'Winthrop', 44.3050003051758, 0.77326813042241, -69.9775009155273, -1.2213377932933, 218, 26, 'PPL', 'P'),
(138897, 'Winthrop', 44.5430603027344, 0.777423061197097, -94.3661117553711, -1.64699935243615, 218, 28, 'PPL', 'P'),
(153880, 'Winthrop', 44.7947196960449, 0.781815346203937, -74.7872161865234, -1.30528316085563, 218, 40, 'PPL', 'P'),
(209208, 'Winthrop', 48.4780616760254, 0.846101791231524, -120.184997558594, -2.09762391889881, 218, 56, 'PPL', 'P'),
(52922, 'Winthrop (historical)', 38.5525016784668, 0.672868089169886, -77.2322235107422, -1.34795658889863, 218, 25, 'PPL', 'P'),
(194068, 'Winthrop (historical)', 40.7936096191406, 0.711982801627234, -122.190826416016, -2.13263223669234, 218, 6, 'PPL', 'P'),
(126687, 'Winthrop Beach', 42.3777809143066, 0.739631806643464, -70.9736099243164, -1.23872317520544, 218, 23, 'PPL', 'P'),
(129371, 'Winthrop Center', 44.3047218322754, 0.77326327015342, -69.9219436645508, -1.2203681363404, 218, 26, 'PPL', 'P'),
(122029, 'Winthrop Harbor', 42.478889465332, 0.741396483760778, -87.8236083984375, -1.53281112753488, 218, 18, 'PPL', 'P'),
(122030, 'Winthrop Harbor Station', 42.478889465332, 0.741396483760778, -87.8450012207031, -1.53318450271971, 218, 18, 'PPL', 'P'),
(126688, 'Winthrop Highlands', 42.3875007629395, 0.739801450004902, -70.9722213745117, -1.23869894043953, 218, 23, 'PPL', 'P'),
(133769, 'Winthrop Junction', 46.4761085510254, 0.811161117729684, -87.6869430541992, -1.53042586730455, 218, 27, 'PPL', 'P'),
(6892, 'Winton', 34.5116691589355, 0.602342257182408, -86.7508316040039, -1.51408764033302, 218, 2, 'PPL', 'P'),
(70296, 'Winton', 36.3955612182617, 0.635222376369826, -76.9322204589844, -1.34272054787942, 218, 33, 'PPL', 'P'),
(138899, 'Winton', 47.9263916015625, 0.836473332047424, -91.8005599975586, -1.602222027132, 218, 28, 'PPL', 'P'),
(169060, 'Winton', 41.4816703796387, 0.723991727351701, -75.5491714477539, -1.318581788917, 218, 45, 'PPL', 'P'),
(186206, 'Winton', 37.3894386291504, 0.652568809551029, -120.61222076416, -2.10508037047687, 218, 6, 'PPL', 'P'),
(209210, 'Winton', 47.7355613708496, 0.833142716209144, -120.73999786377, -2.1073105015737, 218, 56, 'PPL', 'P'),
(209840, 'Winton (historical)', 41.7472190856934, 0.728626426596766, -109.16667175293, -1.90531785553251, 218, 59, 'PPL', 'P'),
(74862, 'Winton Place', 39.1741714477539, 0.683718273504059, -84.5158309936523, -1.4750795208983, 218, 41, 'PPL', 'P'),
(74863, 'Winton Terrace', 39.1822204589844, 0.683858755251561, -84.5119400024414, -1.47501161029051, 218, 41, 'PPL', 'P'),
(91956, 'Winton Town', 35.4730606079102, 0.619121703367533, -85.916389465332, -1.49952387759581, 218, 50, 'PPL', 'P'),
(74864, 'Wintondale', 39.2144393920898, 0.684421081715731, -84.5147171020508, -1.47506007982235, 218, 41, 'PPL', 'P'),
(71590, 'Wintringham Park', 39.9716682434082, 0.697637218362331, -74.2077789306641, -1.29517007293216, 218, 37, 'PPL', 'P'),
(34460, 'Winway', 37.3255615234375, 0.651453943739695, -95.2583312988281, -1.66257152112012, 218, 20, 'PPL', 'P'),
(84454, 'Winwright (historical)', 32.8816719055176, 0.5738934383118, -80.2880630493164, -1.40129105025937, 218, 48, 'PPL', 'P'),
(118501, 'Wiota', 41.4002799987793, 0.722571197226253, -94.8866729736328, -1.65608485965301, 218, 16, 'PPL', 'P'),
(177094, 'Wiota', 42.6366691589355, 0.744150258906947, -89.9524993896484, -1.56996728474756, 218, 57, 'PPL', 'P'),
(197867, 'Wiota (historical)', 48.0974998474121, 0.839459734314812, -106.260833740234, -1.85460141468137, 218, 31, 'PPL', 'P'),
(141094, 'Wirch', 46.0774993896484, 0.804204075435043, -98.9436111450195, -1.72689178829355, 218, 34, 'PPL', 'P'),
(6894, 'Wiregrass Hills', 31.1616706848145, 0.543873753872208, -85.3822174072266, -1.49020081640972, 218, 2, 'PPL', 'P'),
(169061, 'Wireton', 40.5641708374023, 0.707978339454136, -80.2291717529297, -1.40026320323665, 218, 45, 'PPL', 'P'),
(91957, 'Wirmingham', 36.4847183227539, 0.636778461394759, -85.188606262207, -1.48682166446057, 218, 50, 'PPL', 'P'),
(138901, 'Wirock', 43.8869400024414, 0.765971601667811, -95.7033309936523, -1.67033823096517, 218, 28, 'PPL', 'P'),
(31549, 'Wirt', 38.809440612793, 0.677352519550443, -85.45361328125, -1.49144690948377, 218, 19, 'PPL', 'P'),
(77705, 'Wirt', 34.2308311462402, 0.597440709196117, -97.5313873291016, -1.7022438329307, 218, 42, 'PPL', 'P'),
(138902, 'Wirt', 47.7305603027344, 0.833055431104416, -93.959716796875, -1.63990642234689, 218, 28, 'PPL', 'P'),
(153881, 'Wirt', 42.1349983215332, 0.735394451033039, -78.1513900756836, -1.3639990718311, 218, 40, 'PPL', 'P'),
(31550, 'Wirt Station', 38.8113899230957, 0.677386541433369, -85.4397201538086, -1.49120442866652, 218, 19, 'PPL', 'P'),
(12910, 'Wirth', 36.4505615234375, 0.636182312784745, -91.3802795410156, -1.59488674938354, 218, 4, 'PPL', 'P'),
(107725, 'Wirtz', 37.0763893127441, 0.647105068258623, -79.8897171020508, -1.39433860191761, 218, 53, 'PPL', 'P'),
(84455, 'Wisacky', 34.1480598449707, 0.595996077462803, -80.1936111450195, -1.39964255354461, 218, 48, 'PPL', 'P'),
(129373, 'Wiscasset', 44.0027809143066, 0.767993406988372, -69.6661071777344, -1.21590294729872, 218, 26, 'PPL', 'P'),
(169062, 'Wiscasset', 41.1025009155273, 0.717373971779936, -75.335563659668, -1.31485362970699, 218, 45, 'PPL', 'P'),
(38923, 'Wiscoal', 37.2372207641602, 0.649912106626594, -83.0561065673828, -1.44960252348812, 218, 21, 'PPL', 'P'),
(18660, 'Wiscon', 28.5405597686768, 0.498126738325641, -82.4622192382813, -1.43923723420942, 218, 12, 'PPL', 'P'),
(177101, 'Wisconsin', 44.5002784729004, 0.776676377406466, -90.0002822875977, -1.57080125364291, 218, 57, 'ADM1', 'A'),
(177097, 'Wisconsin Dells', 43.627498626709, 0.761443495445376, -89.7708282470703, -1.56679652515371, 218, 57, 'PPL', 'P'),
(177098, 'Wisconsin Junction', 45.6561088562012, 0.796849423189653, -88.9111099243164, -1.55179160978193, 218, 57, 'PPL', 'P'),
(177099, 'Wisconsin Rapids', 44.3836097717285, 0.774640124436991, -89.8172225952148, -1.56760625928315, 218, 57, 'PPL', 'P'),
(118502, 'Wiscotta', 41.5802803039551, 0.725712795206165, -94.1900024414063, -1.64392566506404, 218, 16, 'PPL', 'P'),
(153883, 'Wiscoy', 42.5022201538086, 0.741803681091451, -78.0800018310547, -1.36275311191511, 218, 40, 'PPL', 'P'),
(38922, 'Wisdom', 37.0038909912109, 0.645839733845699, -85.7200012207031, -1.49609625611483, 218, 21, 'PPL', 'P'),
(58337, 'Wisdom', 38.1669387817383, 0.666138747148446, -93.4766693115234, -1.63147565328403, 218, 29, 'PPL', 'P'),
(197868, 'Wisdom', 45.6180610656738, 0.796185363971841, -113.449996948242, -1.98007598312435, 218, 31, 'PPL', 'P'),
(26167, 'Wisdom Woods', 33.4069404602051, 0.583061104048288, -84.5930633544922, -1.47642747988405, 218, 13, 'PPL', 'P'),
(26168, 'Wisdoms Store (historical)', 32.8527793884277, 0.573389168759393, -84.9663925170898, -1.48294330296509, 218, 13, 'PPL', 'P'),
(70299, 'Wise', 36.4863891601563, 0.636807623008695, -78.1711120605469, -1.36434328540199, 218, 33, 'PPL', 'P'),
(99171, 'Wise', 32.5133285522461, 0.567464634019376, -96.0350036621094, -1.67612701106862, 218, 51, 'PPL', 'P'),
(112634, 'Wise', 36.975830078125, 0.645349978521233, -82.5758285522461, -1.44122009079904, 218, 53, 'PPL', 'P'),
(118503, 'Wise', 42.4824981689453, 0.741459467520558, -92.0227813720703, -1.60610052178553, 218, 16, 'PPL', 'P'),
(133770, 'Wise', 43.728328704834, 0.763203312293701, -84.647216796875, -1.47737263575492, 218, 27, 'PPL', 'P'),
(12911, 'Wise (historical)', 33.6591682434082, 0.587463309330189, -92.9319381713867, -1.6219683013505, 218, 4, 'PPL', 'P'),
(26169, 'Wise (historical)', 33.8583297729492, 0.590939333763988, -82.9688873291016, -1.44808026060903, 218, 13, 'PPL', 'P'),
(44189, 'Wise (historical)', 32.6958312988281, 0.570649907841165, -92.7305603027344, -1.61845359450186, 218, 22, 'PPL', 'P'),
(84456, 'Wise (historical)', 33.6908302307129, 0.588015915256381, -81.9250030517578, -1.42986104295958, 218, 48, 'PPL', 'P'),
(70300, 'Wise Forks', 35.2177810668945, 0.614666234863831, -77.5105590820313, -1.35281446104304, 218, 33, 'PPL', 'P'),
(62360, 'Wise Gap', 33.8988914489746, 0.591647268560758, -88.331672668457, -1.54167852185846, 218, 30, 'PPL', 'P'),
(197869, 'Wise River', 45.791389465332, 0.79921051523309, -112.948608398438, -1.97132510209845, 218, 31, 'PPL', 'P'),
(52923, 'Wiseburg', 39.621940612793, 0.691533319722897, -76.6580581665039, -1.33793551319082, 218, 25, 'PPL', 'P'),
(112112, 'Wiseburg', 38.9799995422363, 0.680329334437906, -81.584716796875, -1.42392192741259, 218, 58, 'PPL', 'P'),
(12912, 'Wiseman', 36.2344398498535, 0.632410277995784, -91.8152770996094, -1.60247888901913, 218, 4, 'PPL', 'P'),
(212236, 'Wiseman', 67.4100036621094, 1.17652651268524, -150.107498168945, -2.61987007497946, 218, 1, 'PPL', 'P'),
(192449, 'Wiseman Estates Colonia', 31.6469993591309, 0.552344337193369, -106.281997680664, -1.85497079512456, 218, 51, 'PPL', 'P'),
(70301, 'Wisemans View', 35.9036102294922, 0.626636211857356, -81.9055633544922, -1.4295217562367, 218, 33, 'PPL', 'P'),
(38924, 'Wisemantown', 37.6786117553711, 0.657615832711866, -84.0063934326172, -1.46618815812491, 218, 21, 'PPL', 'P'),
(31551, 'Wiser', 39.6122207641602, 0.691363676361459, -86.2936096191406, -1.50610761128465, 218, 19, 'PPL', 'P'),
(44190, 'Wises (historical)', 31.2338905334473, 0.545134228016143, -92.341667175293, -1.61166612898963, 218, 22, 'PPL', 'P'),
(38925, 'Wises Landing', 38.5730590820313, 0.673226883547747, -85.408332824707, -1.49065661643029, 218, 21, 'PPL', 'P'),
(107727, 'Wiseville (historical)', 37.4972190856934, 0.654449933387007, -77.5677795410156, -1.35381314645182, 218, 53, 'PPL', 'P'),
(58338, 'Wishart', 37.5088882446289, 0.654653598631371, -93.4594421386719, -1.63117498239696, 218, 29, 'PPL', 'P'),
(107728, 'Wishart', 37.8838882446289, 0.661198583326349, -75.4947204589844, -1.317631439882, 218, 53, 'PPL', 'P'),
(169063, 'Wishaw', 41.042781829834, 0.716331677108306, -78.9086074829102, -1.37721500874062, 218, 45, 'PPL', 'P'),
(141096, 'Wishek', 46.2569389343262, 0.807335886297949, -99.5566711425781, -1.73759170376321, 218, 34, 'PPL', 'P'),
(26170, 'Wishing Well Hills', 33.6666717529297, 0.587594270276794, -84.2925033569336, -1.47118171832686, 218, 13, 'PPL', 'P'),
(179559, 'Wishing Well Trailer Park', 33.3063888549805, 0.581306147468953, -111.827781677246, -1.95176298546933, 218, 5, 'PPL', 'P'),
(209211, 'Wishkah', 47.1180610656738, 0.822365302751756, -123.77082824707, -2.16020847083178, 218, 56, 'PPL', 'P'),
(209212, 'Wishram', 45.6575012207031, 0.7968737245346, -120.965560913086, -2.11124731945511, 218, 56, 'PPL', 'P'),
(209213, 'Wishram Heights', 45.6636085510254, 0.79698031755723, -120.972778320313, -2.11137328697467, 218, 56, 'PPL', 'P'),
(169066, 'Wismer', 40.4155616760254, 0.705384620289481, -75.1149978637695, -1.31100403035129, 218, 45, 'PPL', 'P'),
(169064, 'Wismer PO', 40.4083290100098, 0.705258386453811, -75.102783203125, -1.31079084430602, 218, 45, 'PPL', 'P'),
(44191, 'Wisner', 31.9808292388916, 0.558170767736731, -91.6555633544922, -1.59969135830615, 218, 22, 'PPL', 'P'),
(62361, 'Wisner', 31.8416690826416, 0.555741964822578, -89.4705581665039, -1.56155582360259, 218, 30, 'PPL', 'P'),
(133772, 'Wisner', 43.6163902282715, 0.761249617318019, -83.5841674804688, -1.45881892507255, 218, 27, 'PPL', 'P'),
(138906, 'Wisner', 48.3069381713867, 0.843115122648027, -93.6761093139648, -1.63495653798681, 218, 28, 'PPL', 'P'),
(143410, 'Wisner', 41.9872207641602, 0.732815246096324, -96.9138870239258, -1.69146641947331, 218, 35, 'PPL', 'P'),
(153884, 'Wisner', 41.2708282470703, 0.720311837936457, -74.3269424438477, -1.29724986858546, 218, 40, 'PPL', 'P'),
(141098, 'Wisner (historical)', 46.521671295166, 0.811956337631182, -97.8138885498047, -1.70717440937287, 218, 34, 'PPL', 'P'),
(197870, 'Wisner Crossing', 45.7769393920898, 0.798958313877859, -111.081390380859, -1.93873599983915, 218, 31, 'PPL', 'P'),
(169065, 'Wissahickon', 40.017219543457, 0.698432238526747, -75.209716796875, -1.31265718759795, 218, 45, 'PPL', 'P'),
(14886, 'Wisseman Acres', 38.9055595397949, 0.679030111300111, -75.4555587768555, -1.31694793958823, 218, 10, 'PPL', 'P'),
(169067, 'Wissingers', 41.4819412231445, 0.723996454462636, -76.6941680908203, -1.33856575026279, 218, 45, 'PPL', 'P'),
(169068, 'Wissingertown', 40.3419418334961, 0.704099711642545, -78.8477783203125, -1.37615333957206, 218, 45, 'PPL', 'P'),
(169069, 'Wissinoming', 40.0222206115723, 0.698519523631475, -75.063606262207, -1.31010707769615, 218, 45, 'PPL', 'P'),
(77706, 'Wister', 34.9672203063965, 0.610293124616839, -94.7244415283203, -1.65325338678204, 218, 42, 'PPL', 'P'),
(186207, 'Wister', 33.3152809143066, 0.581461343181478, -115.602500915527, -2.01764426451571, 218, 6, 'PPL', 'P'),
(6895, 'Wisteria Commons', 33.4069404602051, 0.583061104048288, -86.7925033569336, -1.51481494962672, 218, 2, 'PPL', 'P'),
(158444, 'Wisterman', 41.1236114501953, 0.717742420116748, -84.2377777099609, -1.47022657560191, 218, 41, 'PPL', 'P'),
(52924, 'Wistmans Delight', 39.5149993896484, 0.689666843272915, -77.5319366455078, -1.35318756991176, 218, 25, 'PPL', 'P'),
(38926, 'Wiswell', 36.5833282470703, 0.638499529249223, -88.3880615234375, -1.5426626930393, 218, 21, 'PPL', 'P'),
(133774, 'Witbeck', 46.3152809143066, 0.808354145940741, -88.0041732788086, -1.53596257921082, 218, 27, 'PPL', 'P'),
(201824, 'Witch Hazel', 45.500560760498, 0.794134596774426, -122.930000305176, -2.14553325480295, 218, 43, 'PPL', 'P'),
(133775, 'Witch Lake', 46.2755584716797, 0.807660858529966, -88.0188903808594, -1.53621944109796, 218, 27, 'PPL', 'P'),
(77708, 'Witcher', 35.5938911437988, 0.62123059405574, -97.4225006103516, -1.70034340117682, 218, 42, 'PPL', 'P'),
(112113, 'Witcher', 38.2252807617188, 0.667157006791238, -81.51611328125, -1.42272457018649, 218, 58, 'PPL', 'P'),
(12921, 'Witcherville', 35.1375007629395, 0.613265079235313, -94.2641677856445, -1.64522009451187, 218, 4, 'PPL', 'P'),
(44192, 'Witchwood (historical)', 31.0258293151855, 0.541502874711765, -92.3222198486328, -1.6113267091087, 218, 22, 'PPL', 'P'),
(192450, 'Witco', 31.1561107635498, 0.543776714939989, -101.344436645508, -1.76879409804291, 218, 51, 'PPL', 'P'),
(129376, 'Witham Corner', 44.7133293151855, 0.780394816078489, -69.9475021362305, -1.22081421582299, 218, 26, 'PPL', 'P'),
(107729, 'Withams', 37.9455604553223, 0.662274966459932, -75.5774993896484, -1.31907620477337, 218, 53, 'PPL', 'P'),
(74865, 'Withamsville', 39.0622215270996, 0.681764378791296, -84.288330078125, -1.47110888087105, 218, 41, 'PPL', 'P'),
(91958, 'Withamtown', 36.5466690063477, 0.637859704797331, -86.3038864135742, -1.50628697518407, 218, 50, 'PPL', 'P'),
(177102, 'Withee', 44.9563903808594, 0.784637031957904, -90.5975036621094, -1.58122473299143, 218, 57, 'PPL', 'P'),
(84458, 'Witherbee', 33.1616706848145, 0.578780338912095, -79.8300018310547, -1.39329637382501, 218, 48, 'PPL', 'P'),
(153885, 'Witherbee', 44.0875015258789, 0.769472060604611, -73.533332824707, -1.28339876775596, 218, 40, 'PPL', 'P'),
(52925, 'Withernsea', 38.9305610656738, 0.679466470244721, -76.5819396972656, -1.33660699528103, 218, 25, 'PPL', 'P'),
(26171, 'Withers', 30.8547191619873, 0.538516439154864, -82.9033279418945, -1.44693603344667, 218, 13, 'PPL', 'P'),
(99173, 'Withers', 29.3500003814697, 0.512254142118239, -98.5783309936523, -1.72051644696001, 218, 51, 'PPL', 'P'),
(107730, 'Withers', 36.7261085510254, 0.640991515660237, -82.1047210693359, -1.43299771409147, 218, 53, 'PPL', 'P'),
(112114, 'Withers', 38.8997192382813, 0.678928178809388, -80.9647216796875, -1.41310097127138, 218, 58, 'PPL', 'P'),
(58340, 'Withers Mill', 39.7152786254883, 0.693162375361698, -91.4805603027344, -1.59663697885194, 218, 29, 'PPL', 'P'),
(91959, 'Withers Subdivision', 36.186939239502, 0.631581235948442, -83.4191665649414, -1.4559391158278, 218, 50, 'PPL', 'P'),
(12914, 'Witherspoon', 34.1588897705078, 0.596185095321172, -92.9888916015625, -1.62296232622737, 218, 4, 'PPL', 'P'),
(70304, 'Witherspoon Crossroad', 35.6733283996582, 0.622617035719235, -81.1500015258789, -1.41633471462501, 218, 33, 'PPL', 'P'),
(153887, 'Withey', 42.2455596923828, 0.737324110979883, -77.9875030517578, -1.3611387036623, 218, 40, 'PPL', 'P'),
(18661, 'Withla', 28.3397197723389, 0.494621419119851, -81.8711090087891, -1.42892041446256, 218, 12, 'PPL', 'P'),
(26172, 'Withmere', 33.9633293151855, 0.592771921489099, -84.3263931274414, -1.47177320640497, 218, 13, 'PPL', 'P'),
(38927, 'Withrow', 37.8349990844727, 0.660345306513088, -85.4725036621094, -1.49177660882672, 218, 21, 'PPL', 'P'),
(138907, 'Withrow', 45.1241683959961, 0.7875653107345, -92.897216796875, -1.62136229904445, 218, 28, 'PPL', 'P'),
(209214, 'Withrow', 47.7050018310547, 0.832609351621828, -119.807502746582, -2.09103539152001, 218, 56, 'PPL', 'P'),
(169070, 'Witinski Villa', 41.1800003051758, 0.718726591297587, -75.9480590820313, -1.32554369148063, 218, 45, 'PPL', 'P'),
(169071, 'Witmer', 40.0480613708496, 0.69897052996208, -76.211669921875, -1.33014456857985, 218, 45, 'PPL', 'P'),
(124038, 'Witmer Manor', 41.5374984741211, 0.724966111415534, -85.3863906860352, -1.49027365386553, 218, 19, 'PPL', 'P'),
(138908, 'Witoka', 43.9333305358887, 0.766781269218222, -91.620002746582, -1.5990707086141, 218, 28, 'PPL', 'P'),
(29010, 'Witt', 39.2563896179199, 0.685153251278421, -89.3480606079102, -1.55941783787948, 218, 18, 'PPL', 'P'),
(38932, 'Witt', 37.6730613708496, 0.657518960227214, -84.0266723632813, -1.46654209223378, 218, 21, 'PPL', 'P'),
(91960, 'Witt', 36.1500015258789, 0.630936551227561, -83.2830581665039, -1.45356357613545, 218, 50, 'PPL', 'P'),
(107732, 'Witt', 36.6805610656738, 0.640196562074848, -79.4000015258789, -1.38579145271511, 218, 53, 'PPL', 'P'),
(189832, 'Witt', 34.8405609130859, 0.608082501174992, -106.05249786377, -1.85096526768703, 218, 38, 'PPL', 'P'),
(26173, 'Witt Acres', 33.7980613708496, 0.589887451712434, -84.6105575561523, -1.47673281130303, 218, 13, 'PPL', 'P'),
(91961, 'Witt Acres', 36.1511116027832, 0.630955925724491, -83.2852783203125, -1.45360232512931, 218, 50, 'PPL', 'P'),
(38928, 'Witt Springs', 37.7297210693359, 0.658507858518988, -84.029167175293, -1.46658563491761, 218, 21, 'PPL', 'P'),
(58341, 'Witte Ford (historical)', 38.410831451416, 0.670395477255802, -91.5766677856445, -1.59831437086452, 218, 29, 'PPL', 'P'),
(202797, 'Witten', 43.4394416809082, 0.758161282559908, -100.079170227051, -1.74671103312592, 218, 49, 'PPL', 'P'),
(58342, 'Wittenberg', 37.6525001525879, 0.657160099270326, -89.5244369506836, -1.5624961857835, 218, 29, 'PPL', 'P'),
(79434, 'Wittenberg', 39.7822189331055, 0.694330704131916, -78.9225006103516, -1.37745748955787, 218, 45, 'PPL', 'P'),
(153886, 'Wittenberg', 42.0250015258789, 0.733474644782228, -74.1961135864258, -1.29496647426683, 218, 40, 'PPL', 'P'),
(177105, 'Wittenberg', 44.827220916748, 0.782382599516124, -89.1694412231445, -1.55630034150743, 218, 57, 'PPL', 'P'),
(74867, 'Wittens', 39.5900001525879, 0.690975853527716, -80.9800033569336, -1.41336768685455, 218, 41, 'PPL', 'P'),
(107734, 'Wittens Fort', 37.1177787780762, 0.647827450704307, -81.5722198486328, -1.42370381451931, 218, 53, 'PPL', 'P'),
(107733, 'Wittens Mills', 37.1652793884277, 0.648656492751648, -81.478889465332, -1.42207489203857, 218, 53, 'PPL', 'P'),
(38929, 'Wittensville', 37.8627815246582, 0.660830201568564, -82.7997207641602, -1.44512774706651, 218, 21, 'PPL', 'P'),
(12915, 'Witter', 35.9375, 0.627227699935462, -93.6833267211914, -1.63508250550637, 218, 4, 'PPL', 'P'),
(186208, 'Witter Springs (historical)', 39.1911087036133, 0.684013884385058, -122.992500305176, -2.14662408558545, 218, 6, 'PPL', 'P'),
(74866, 'Wittes Corners', 39.6588897705078, 0.69217820418086, -84.1577835083008, -1.46883041340043, 218, 41, 'PPL', 'P'),
(77709, 'Witteville', 35.0863914489746, 0.612373053428191, -94.6505584716797, -1.65196388418222, 218, 42, 'PPL', 'P'),
(99174, 'Witting', 29.5100002288818, 0.515046666258268, -97.0555572509766, -1.6939390313874, 218, 51, 'PPL', 'P'),
(52926, 'Wittman', 38.7936096191406, 0.677076216587347, -76.2944412231445, -1.33158920031316, 218, 25, 'PPL', 'P'),
(179560, 'Wittmann', 33.7763900756836, 0.589509216258615, -112.527778625488, -1.96398023697007, 218, 5, 'PPL', 'P'),
(169072, 'Wittmer', 40.521671295166, 0.707236582511522, -79.9486083984375, -1.39536644894033, 218, 45, 'PPL', 'P'),
(12917, 'Witts Springs', 35.7680587768555, 0.624270392702984, -92.8666687011719, -1.62082913419422, 218, 4, 'PPL', 'P'),
(31552, 'Witts Station', 39.7122192382813, 0.693108978981842, -84.8616714477539, -1.48111557550897, 218, 19, 'PPL', 'P'),
(12918, 'Wittsburg', 35.2188911437988, 0.614685609360761, -90.7016677856445, -1.58304273990957, 218, 4, 'PPL', 'P'),
(58343, 'Witty', 36.8558311462402, 0.643255602060968, -92.8936080932617, -1.62129931528467, 218, 29, 'PPL', 'P'),
(70306, 'Wittys Crossroads', 36.2680587768555, 0.632997038962955, -79.8438873291016, -1.3935387214842, 218, 33, 'PPL', 'P'),
(177108, 'Witwen', 43.2852783203125, 0.755470624331574, -89.8872222900391, -1.56882798443322, 218, 57, 'PPL', 'P'),
(52927, 'Wivell Estates', 39.6688919067383, 0.692352774390314, -77.3733291625977, -1.35041934711668, 218, 25, 'PPL', 'P'),
(12919, 'Wiville', 35.1480598449707, 0.613449369982746, -91.2408294677734, -1.59245288646331, 218, 4, 'PPL', 'P'),
(133777, 'Wixom', 42.5247192382813, 0.742196364194183, -83.5363922119141, -1.45798508933525, 218, 27, 'PPL', 'P'),
(99175, 'Wixon Valley', 30.7619400024414, 0.536897137343555, -96.3186111450195, -1.6810768954287, 218, 51, 'PPL', 'P'),
(91962, 'Wixtown', 36.541389465332, 0.637767559423614, -86.1386108398438, -1.50340237224935, 218, 50, 'PPL', 'P'),
(99176, 'Wizard Wells', 33.2002792358398, 0.579454185246912, -97.9700012207031, -1.70989908948413, 218, 51, 'PPL', 'P'),
(133778, 'Wobic', 46.5027809143066, 0.81162663828823, -87.9527816772461, -1.53506562655569, 218, 27, 'PPL', 'P'),
(29012, 'Woburn', 38.958610534668, 0.679956025832105, -89.3463897705078, -1.55938867626554, 218, 18, 'PPL', 'P'),
(126690, 'Woburn', 42.4791717529297, 0.741401410608794, -71.1527786254883, -1.24185025895742, 218, 23, 'PPL', 'P'),
(199122, 'Woburn', 48.8286094665527, 0.852220004361817, -102.418891906738, -1.78754688001676, 218, 34, 'PPL', 'P'),
(52928, 'Woburn Estates', 39.5116691589355, 0.689608719782124, -77.7958297729492, -1.357793373859, 218, 25, 'PPL', 'P'),
(126691, 'Woburn Highlands', 42.4736099243164, 0.741304338387061, -71.1436080932617, -1.2416902029759, 218, 23, 'PPL', 'P'),
(169073, 'Woddale', 40.0911102294922, 0.699721874284618, -79.5250015258789, -1.3879731142801, 218, 45, 'PPL', 'P'),
(99177, 'Woden', 31.503059387207, 0.54983211075807, -94.5263900756836, -1.64979673684517, 218, 51, 'PPL', 'P'),
(118505, 'Woden', 43.2330589294434, 0.754559224027522, -93.9088897705078, -1.63901932338778, 218, 16, 'PPL', 'P'),
(38930, 'Wofford', 36.7825012207031, 0.641975753420103, -84.1352767944336, -1.46843759713965, 218, 21, 'PPL', 'P'),
(186209, 'Wofford Heights', 35.7069396972656, 0.623203663528352, -118.455276489258, -2.06743459109778, 218, 6, 'PPL', 'P'),
(26174, 'Woffords Settlement (historical)', 34.4805603027344, 0.601799305215168, -83.5025024414063, -1.45739360125714, 218, 13, 'PPL', 'P'),
(18662, 'Woftoka (historical)', 29.8833293914795, 0.521562489339311, -82.6999969482422, -1.44338723813609, 218, 12, 'PPL', 'P'),
(199123, 'Wogansport', 47.0347213745117, 0.820910750743382, -100.873611450195, -1.76057664818336, 218, 34, 'PPL', 'P'),
(186210, 'Wokodot (historical)', 39.2638893127441, 0.685284145645999, -121.016670227051, -2.11213934526223, 218, 6, 'PPL', 'P'),
(143414, 'Wolbach', 41.3969383239746, 0.72251287399838, -98.3938903808594, -1.71729735099237, 218, 35, 'PPL', 'P'),
(77710, 'Wolco', 36.538330078125, 0.637714163043758, -96.0711135864258, -1.67675724814059, 218, 42, 'PPL', 'P'),
(34461, 'Wolcott', 39.1888885498047, 0.683975135391198, -94.8013916015625, -1.65459641891977, 218, 20, 'PPL', 'P'),
(114318, 'Wolcott', 41.6022186279297, 0.726095691191891, -72.9872207641602, -1.27386731421457, 218, 8, 'PPL', 'P'),
(124039, 'Wolcott', 40.7580604553223, 0.711362351672273, -87.0416717529297, -1.51916375852877, 218, 19, 'PPL', 'P'),
(153888, 'Wolcott', 43.2205581665039, 0.754341044555217, -76.8152770996094, -1.34067950121998, 218, 40, 'PPL', 'P'),
(172816, 'Wolcott', 44.5463905334473, 0.777481184687888, -72.4588928222656, -1.26464625209822, 218, 55, 'PPL', 'P'),
(187555, 'Wolcott', 39.7027816772461, 0.692944262468421, -106.678062438965, -1.86188342920803, 218, 7, 'PPL', 'P'),
(133779, 'Wolcott Mills', 42.7688903808594, 0.746457954570528, -82.9269409179688, -1.44734815762536, 218, 27, 'PPL', 'P'),
(153889, 'Wolcottsburg', 43.0580596923828, 0.751504911152337, -78.6372222900391, -1.37247844358386, 218, 40, 'PPL', 'P'),
(153890, 'Wolcottsville', 43.1113891601563, 0.75243568595332, -78.5183334350586, -1.37040344162052, 218, 40, 'PPL', 'P'),
(124040, 'Wolcottville', 41.5258293151855, 0.72476244617117, -85.3666687011719, -1.48992944029464, 218, 19, 'PPL', 'P'),
(38931, 'Wolf', 38.3791694641113, 0.66984287132961, -83.0994415283203, -1.4503588612377, 218, 21, 'PPL', 'P'),
(62362, 'Wolf', 32.4408302307129, 0.566199299606452, -89.4044418334961, -1.56040187590226, 218, 30, 'PPL', 'P'),
(77711, 'Wolf', 35.0875015258789, 0.612392427925121, -96.658332824707, -1.68700615727965, 218, 42, 'PPL', 'P'),
(118506, 'Wolf', 42.1355590820313, 0.735404238150045, -94.0272216796875, -1.64108460481314, 218, 16, 'PPL', 'P'),
(138909, 'Wolf', 47.4505615234375, 0.828168530504121, -92.6086120605469, -1.61632519615867, 218, 28, 'PPL', 'P'),
(158445, 'Wolf', 40.3216705322266, 0.703745910691728, -81.5716705322266, -1.42369422713939, 218, 41, 'PPL', 'P'),
(186212, 'Wolf', 39.0586090087891, 0.681701328452488, -121.137222290039, -2.11424337568145, 218, 6, 'PPL', 'P'),
(187971, 'Wolf', 38.0322189331055, 0.663787442222015, -101.098609924316, -1.76450361236874, 218, 20, 'PPL', 'P'),
(209841, 'Wolf', 44.771671295166, 0.781413075721281, -107.238327026367, -1.87166189094053, 218, 59, 'PPL', 'P'),
(52929, 'Wolf Acres', 39.0708312988281, 0.681914647655803, -77.0086135864258, -1.34405385947917, 218, 25, 'PPL', 'P'),
(91963, 'Wolf Acres', 36.2013893127441, 0.631833437303672, -83.2222213745117, -1.45250177380883, 218, 50, 'PPL', 'P'),
(12920, 'Wolf Bayou', 35.6547203063965, 0.6222922632243, -91.9105606079102, -1.60414189996183, 218, 4, 'PPL', 'P'),
(38933, 'Wolf Coal', 37.3983306884766, 0.652724005263554, -83.3777770996094, -1.45521673338211, 218, 21, 'PPL', 'P'),
(6896, 'Wolf Creek', 33.5291709899902, 0.585194429239496, -86.3819427490234, -1.5076493152397, 218, 2, 'PPL', 'P'),
(29013, 'Wolf Creek', 37.6266708374023, 0.656709292676803, -89.0527801513672, -1.55426422169601, 218, 18, 'PPL', 'P'),
(34462, 'Wolf Creek', 39.0344390869141, 0.681279483735819, -98.477783203125, -1.7187615569597, 218, 20, 'PPL', 'P'),
(38934, 'Wolf Creek', 38.1027793884277, 0.665018954489095, -86.3897171020508, -1.50778500329724, 218, 21, 'PPL', 'P'),
(70307, 'Wolf Creek', 35.0136108398438, 0.61110279216725, -84.3038864135742, -1.47138039014418, 218, 33, 'PPL', 'P'),
(74868, 'Wolf Creek', 39.4794387817383, 0.689046193580872, -81.7322235107422, -1.42649640523837, 218, 41, 'PPL', 'P'),
(91966, 'Wolf Creek', 35.6452789306641, 0.622127480131851, -84.8555603027344, -1.48100891590731, 218, 50, 'PPL', 'P'),
(99178, 'Wolf Creek', 30.6455593109131, 0.534865911090638, -95.142219543457, -1.66054498868862, 218, 51, 'PPL', 'P'),
(171646, 'Wolf Creek', 43.3474998474121, 0.756556594845081, -97.6233291625977, -1.70384852064553, 218, 49, 'PPL', 'P'),
(177109, 'Wolf Creek', 45.5561103820801, 0.795104120569269, -92.7225036621094, -1.61831297959631, 218, 57, 'PPL', 'P'),
(197871, 'Wolf Creek', 47.0061111450195, 0.820411408038993, -112.068328857422, -1.95596132576979, 218, 31, 'PPL', 'P'),
(201826, 'Wolf Creek', 43.9500007629395, 0.767072219567313, -123.377777099609, -2.15334843417984, 218, 43, 'PPL', 'P'),
(206559, 'Wolf Creek', 41.3333282470703, 0.721402668718953, -111.826393127441, -1.95173875070341, 218, 52, 'PPL', 'P'),
(70308, 'Wolf Creek Acres', 36.4013900756836, 0.635324109123467, -79.654167175293, -1.39022748014285, 218, 33, 'PPL', 'P'),
(206560, 'Wolf Creek Village', 41.3277816772461, 0.721305862813329, -111.824722290039, -1.95170958908948, 218, 52, 'PPL', 'P'),
(133780, 'Wolf Crossing', 43.042781829834, 0.751238262148193, -84.2455596923828, -1.4703623968175, 218, 27, 'PPL', 'P'),
(179561, 'Wolf Crossing', 35.3944396972656, 0.61774950961587, -111.107498168945, -1.93919166670167, 218, 5, 'PPL', 'P'),
(52931, 'Wolf Den Spring', 39.3405609130859, 0.686622317514736, -77.2305603027344, -1.34792756044274, 218, 25, 'PPL', 'P'),
(177602, 'Wolf Estates', 40.0449981689453, 0.698917067003196, -80.6986083984375, -1.40845641833028, 218, 58, 'PPL', 'P'),
(70309, 'Wolf Ford', 35.3430595397949, 0.616852756697813, -82.7300033569336, -1.44391094876445, 218, 33, 'PPL', 'P'),
(107735, 'Wolf Glade', 36.6977806091309, 0.640497099803864, -80.8808288574219, -1.41163676530406, 218, 53, 'PPL', 'P'),
(52930, 'Wolf Hill', 39.5766716003418, 0.690743226406498, -76.845832824707, -1.34121279922827, 218, 25, 'PPL', 'P'),
(153892, 'Wolf Hill', 42.6041717529297, 0.743583072173787, -74.0108337402344, -1.2917327309132, 218, 40, 'PPL', 'P'),
(58344, 'Wolf Island', 36.7391700744629, 0.641219482249548, -89.2102813720703, -1.55701313657319, 218, 29, 'PPL', 'P'),
(122034, 'Wolf Lake', 40.086669921875, 0.699644376296897, -90.1452789306641, -1.57333192246876, 218, 18, 'PPL', 'P'),
(126693, 'Wolf Lake', 41.7041702270508, 0.727875082274227, -70.8499984741211, -1.23656574840637, 218, 23, 'PPL', 'P'),
(133782, 'Wolf Lake', 43.2547187805176, 0.754937259744258, -86.1097183227539, -1.50289810269694, 218, 27, 'PPL', 'P'),
(138910, 'Wolf Lake', 46.8030586242676, 0.816867472997397, -95.3522186279297, -1.66421016413884, 218, 28, 'PPL', 'P'),
(118508, 'Wolf Lake Addition', 41.9952812194824, 0.732955927580908, -92.8855590820313, -1.62115883353717, 218, 16, 'PPL', 'P'),
(153893, 'Wolf Lake Landing', 43.6011085510254, 0.760982901734847, -75.0205612182617, -1.30935579995264, 218, 40, 'PPL', 'P'),
(38935, 'Wolf Lick', 37.0188903808594, 0.646101522580854, -86.9561080932617, -1.51767039094751, 218, 21, 'PPL', 'P'),
(195810, 'Wolf Lodge', 47.6413917541504, 0.831499146342401, -116.615829467773, -2.03533018415687, 218, 17, 'PPL', 'P'),
(206561, 'Wolf Lodge Condominium', 41.3247184753418, 0.721252399854445, -111.829719543457, -1.95179680761518, 218, 52, 'PPL', 'P'),
(70310, 'Wolf Mountain', 35.2158317565918, 0.614632212980905, -82.9866714477539, -1.44839065203408, 218, 33, 'PPL', 'P'),
(12923, 'Wolf Pen (historical)', 36.1780586242676, 0.631426239972999, -93.5686111450195, -1.63308034099885, 218, 4, 'PPL', 'P'),
(197872, 'Wolf Point', 48.0905609130859, 0.83933862706424, -105.639999389648, -1.84376581115417, 218, 31, 'PPL', 'P'),
(153894, 'Wolf Pond', 44.649169921875, 0.779275023419138, -74.0669403076172, -1.29271197524602, 218, 40, 'PPL', 'P'),
(84460, 'Wolf Pond Cross Roads', 34.8161087036133, 0.607655729610306, -80.5272216796875, -1.40546515579391, 218, 48, 'PPL', 'P'),
(70311, 'Wolf Ridge', 35.1652793884277, 0.613749907711762, -82.9361114501953, -1.44750821360688, 218, 33, 'PPL', 'P'),
(91967, 'Wolf River', 36.5416717529297, 0.637772486271631, -84.9602813720703, -1.48283664336343, 218, 50, 'PPL', 'P'),
(38936, 'Wolf River Dock', 36.6261100769043, 0.639246213039854, -85.208610534668, -1.48717080487948, 218, 21, 'PPL', 'P'),
(112116, 'Wolf Run', 39.9072189331055, 0.696512365696909, -80.565559387207, -1.40613427501779, 218, 58, 'PPL', 'P'),
(158447, 'Wolf Run', 40.4672203063965, 0.706286233476527, -80.8894424438477, -1.41178710074759, 218, 41, 'PPL', 'P'),
(169076, 'Wolf Run', 41.8713912963867, 0.730793640512845, -78.5461120605469, -1.37088827009697, 218, 45, 'PPL', 'P'),
(6897, 'Wolf Springs', 34.5950012207031, 0.603796676032727, -87.4727783203125, -1.52668798755657, 218, 2, 'PPL', 'P'),
(62363, 'Wolf Springs', 32.2980613708496, 0.563707512932519, -88.6894378662109, -1.54792270250832, 218, 30, 'PPL', 'P'),
(206562, 'Wolf Star', 41.3308296203613, 0.721359059456103, -111.821937561035, -1.95166098639958, 218, 52, 'PPL', 'P'),
(112117, 'Wolf Summit', 39.2808303833008, 0.685579823106025, -80.4611129760742, -1.40431134125163, 218, 58, 'PPL', 'P'),
(107737, 'Wolf Trap', 36.7133293151855, 0.640768475918943, -78.8288879394531, -1.37582364022911, 218, 53, 'PPL', 'P'),
(158448, 'Wolfcale', 40.8880615234375, 0.713631298341993, -84.7608337402344, -1.47935562550259, 218, 41, 'PPL', 'P'),
(112118, 'Wolfcreek', 37.6652793884277, 0.65738313901162, -80.6241683959961, -1.40715719519249, 218, 58, 'PPL', 'P'),
(169078, 'Wolfdale', 40.1927795410156, 0.701496338518938, -80.2880630493164, -1.40129105025937, 218, 45, 'PPL', 'P'),
(52934, 'Wolfe', 39.5305595397949, 0.689938419125076, -77.5208282470703, -1.3529936917844, 218, 25, 'PPL', 'P'),
(112119, 'Wolfe', 37.3072204589844, 0.651133831776668, -81.3288879394531, -1.41945687152896, 218, 58, 'PPL', 'P'),
(58346, 'Wolfe (historical)', 38.0077781677246, 0.663360870394412, -94.529167175293, -1.64984520637701, 218, 29, 'PPL', 'P'),
(99179, 'Wolfe City', 33.3705596923828, 0.582426139865386, -96.0686111450195, -1.67671357229871, 218, 51, 'PPL', 'P'),
(62364, 'Wolfe Creek (historical)', 33.4916687011719, 0.584539890822582, -88.658332824707, -1.5473798171201, 218, 30, 'PPL', 'P'),
(52932, 'Wolfe Mill', 39.6733283996582, 0.692430205799008, -78.7249984741211, -1.37401042700093, 218, 25, 'PPL', 'P'),
(144696, 'Wolfeboro', 43.5838890075684, 0.760682364005832, -71.2077789306641, -1.24281019537233, 218, 36, 'PPL', 'P'),
(144697, 'Wolfeboro Center', 43.6194381713867, 0.761302813960793, -71.1722183227539, -1.24218954568029, 218, 36, 'PPL', 'P'),
(144698, 'Wolfeboro Falls', 43.5919418334961, 0.760822912332361, -71.2061080932617, -1.2427810337584, 218, 36, 'PPL', 'P'),
(71596, 'Wolfert', 39.7838897705078, 0.694359865745853, -75.2613906860352, -1.31355906710111, 218, 37, 'PPL', 'P'),
(52933, 'Wolfes Overlook', 39.5205612182617, 0.689763915494648, -77.5536117553711, -1.3535658719446, 218, 25, 'PPL', 'P'),
(31553, 'Wolff', 39.4330596923828, 0.688236725767542, -86.3952789306641, -1.50788207551897, 218, 19, 'PPL', 'P'),
(192451, 'Wolfforth', 33.5058288574219, 0.584787032171741, -102.008613586426, -1.78038617247775, 218, 51, 'PPL', 'P'),
(158449, 'Wolfhurst', 40.0691719055176, 0.699338978298892, -80.7838897705078, -1.40994485906353, 218, 41, 'PPL', 'P'),
(31554, 'Wolfington', 39.8305587768555, 0.695174393565253, -86.2163925170898, -1.50475991861502, 218, 19, 'PPL', 'P'),
(124041, 'Wolflake', 41.3349990844727, 0.72143183033289, -85.4958267211914, -1.49218367299934, 218, 19, 'PPL', 'P'),
(18663, 'Wolfolk', 27.7999992370605, 0.485201518738618, -81.6302795410156, -1.42471714731409, 218, 12, 'PPL', 'P'),
(107738, 'Wolford', 37.3644409179688, 0.652132517185447, -81.9913864135742, -1.43101965119182, 218, 53, 'PPL', 'P'),
(138913, 'Wolford', 46.5455589294434, 0.812373255499834, -93.978889465332, -1.64024104853786, 218, 28, 'PPL', 'P'),
(141100, 'Wolford', 48.4986114501953, 0.84646045245133, -99.7038879394531, -1.74016112158292, 218, 34, 'PPL', 'P'),
(186213, 'Wolforts (historical)', 35.3783302307129, 0.617468346383785, -119.928329467773, -2.09314421562919, 218, 6, 'PPL', 'P'),
(74869, 'Wolfpen', 39.0752792358398, 0.681992278801579, -82.0777816772461, -1.43252753300102, 218, 41, 'PPL', 'P'),
(38938, 'Wolfpit', 37.3527793884277, 0.651928985099138, -82.4230575561523, -1.43855373391565, 218, 21, 'PPL', 'P'),
(209215, 'Wolfred', 48.225830078125, 0.841699519370596, -117.136108398438, -2.04441076452572, 218, 56, 'PPL', 'P'),
(107739, 'Wolfrun (historical)', 36.6966705322266, 0.640477725306933, -82.2483291625977, -1.4355041481514, 218, 53, 'PPL', 'P'),
(122035, 'Wolfs', 41.6958312988281, 0.727729540520654, -88.2608337402344, -1.54044214932239, 218, 18, 'PPL', 'P'),
(169080, 'Wolfs Corners', 41.415828704834, 0.722842573341332, -79.3874969482422, -1.38557320666378, 218, 45, 'PPL', 'P'),
(169079, 'Wolfs Crossroads', 40.8302803039551, 0.712622825816207, -76.7394409179688, -1.33935591015821, 218, 45, 'PPL', 'P'),
(52935, 'Wolfs Den', 39.5733299255371, 0.690684903178625, -77.2638931274414, -1.34850932798287, 218, 25, 'PPL', 'P'),
(26176, 'Wolfs Head', 34.3111114501953, 0.598841864824635, -83.8986129760742, -1.46430703428893, 218, 13, 'PPL', 'P'),
(52936, 'Wolfs Mill', 39.6583290100098, 0.692168417063854, -77.1224975585938, -1.34604150975875, 218, 25, 'PPL', 'P'),
(169088, 'Wolfs Store', 40.9599990844727, 0.714886845637911, -77.3850021362305, -1.35062307894007, 218, 45, 'PPL', 'P'),
(169081, 'Wolfsburg', 40.0463905334473, 0.698941368348143, -78.5299987792969, -1.37060704028586, 218, 45, 'PPL', 'P'),
(107741, 'Wolfsnare Plantation', 36.8586082458496, 0.643304071592807, -76.0441665649414, -1.32722108349321, 218, 53, 'PPL', 'P'),
(52937, 'Wolfsville', 39.5741691589355, 0.69069955056462, -77.5508270263672, -1.35351726925471, 218, 25, 'PPL', 'P'),
(52938, 'Wolfsville Crossing', 39.5327796936035, 0.689977168118936, -77.5952835083008, -1.35429318123831, 218, 25, 'PPL', 'P'),
(84461, 'Wolfton', 33.5883293151855, 0.58622693679412, -80.9819412231445, -1.4134015090004, 218, 48, 'PPL', 'P'),
(6898, 'Wolftown', 34.5136108398438, 0.602376145907279, -87.1061096191406, -1.52028841145711, 218, 2, 'PPL', 'P'),
(107740, 'Wolftown', 38.3555603027344, 0.669430813729948, -78.3477783203125, -1.36742669331209, 218, 53, 'PPL', 'P'),
(70313, 'Wolfville (historical)', 34.9530601501465, 0.61004598326768, -80.7541732788086, -1.40942620844123, 218, 33, 'PPL', 'P'),
(187556, 'Wolhurst', 39.5705604553223, 0.69063656680484, -105.032783508301, -1.83316789475425, 218, 7, 'PPL', 'P'),
(126694, 'Wollaston', 42.2638893127441, 0.737644023205829, -71.022216796875, -1.23957152517069, 218, 23, 'PPL', 'P'),
(209216, 'Wollochet', 47.2688903808594, 0.824997770910272, -122.582778930664, -2.13947309858442, 218, 56, 'PPL', 'P'),
(12926, 'Wolquarry', 35.8974990844727, 0.626529552255698, -91.9094390869141, -1.60412232572782, 218, 4, 'PPL', 'P'),
(199125, 'Wolseth', 48.4463882446289, 0.845548985568251, -101.123611450195, -1.76493997131335, 218, 34, 'PPL', 'P'),
(171648, 'Wolsey', 44.4077796936035, 0.77506196915366, -98.4744415283203, -1.71870323373183, 218, 49, 'PPL', 'P'),
(197873, 'Wolsey', 46.7763900756836, 0.816402019017878, -110.816673278809, -1.93411581482203, 218, 31, 'PPL', 'P'),
(99180, 'Wolters Village', 32.8238906860352, 0.572884965786014, -98.0663909912109, -1.71158140834474, 218, 51, 'PPL', 'P'),
(38939, 'Wolverine', 37.5808296203613, 0.655909212506316, -83.408332824707, -1.4557500313904, 218, 21, 'PPL', 'P'),
(91968, 'Wolverine', 36.3074989318848, 0.633685399525714, -89.164436340332, -1.55621298982368, 218, 50, 'PPL', 'P'),
(133784, 'Wolverine', 47.269718170166, 0.825012218559186, -88.4194412231445, -1.54321037211747, 218, 27, 'PPL', 'P'),
(195811, 'Wolverine', 43.2813911437988, 0.755402780302804, -111.935279846191, -1.95363918245729, 218, 17, 'PPL', 'P'),
(133785, 'Wolverine Lake', 42.5566711425781, 0.742754030126445, -83.4738922119141, -1.45689425855275, 218, 27, 'PPL', 'P'),
(138915, 'Wolverton', 46.5633316040039, 0.812683447187801, -96.7333297729492, -1.68831510095542, 218, 28, 'PPL', 'P'),
(169082, 'Wolverton', 40.9205589294434, 0.714198485075153, -76.7136077880859, -1.33890503698566, 218, 45, 'PPL', 'P'),
(12925, 'Wolverton (historical)', 35.7625007629395, 0.624173387060278, -89.9100036621094, -1.56922559438397, 218, 4, 'PPL', 'P'),
(29015, 'Womac', 39.2713890075684, 0.685415040013576, -89.7880630493164, -1.56709732919883, 218, 18, 'PPL', 'P'),
(44194, 'Womack', 32.188060760498, 0.561787640102681, -93.2422180175781, -1.62738370626912, 218, 22, 'PPL', 'P'),
(58347, 'Womack', 37.6811103820801, 0.657659441974716, -90.1963882446289, -1.57422394827588, 218, 29, 'PPL', 'P'),
(91969, 'Womack', 35.7516708374023, 0.623984369201909, -85.8247222900391, -1.49792398357095, 218, 50, 'PPL', 'P'),
(99181, 'Womack', 31.8369407653809, 0.555659440118299, -97.4958267211914, -1.70162318323866, 218, 51, 'PPL', 'P'),
(6900, 'Womack (historical)', 33.7027816772461, 0.588224507348761, -86.0208282470703, -1.50134667820392, 218, 2, 'PPL', 'P'),
(179562, 'Womack East', 33.3469390869141, 0.582013882528642, -111.85417175293, -1.95222357917986, 218, 5, 'PPL', 'P'),
(6899, 'Womack Hill', 31.8530597686768, 0.555940769797953, -88.188606262207, -1.5391815420204, 218, 2, 'PPL', 'P'),
(107744, 'Womacks', 37.0733299255371, 0.647051671878767, -78.6963882446289, -1.37351108429654, 218, 53, 'PPL', 'P'),
(169083, 'Womelsdorf', 40.3616714477539, 0.704444058371492, -76.184440612793, -1.32966932748332, 218, 45, 'PPL', 'P'),
(212237, 'Womens Bay', 57.6822204589844, 1.00674466687051, -152.668609619141, -2.66456990229589, 218, 1, 'PPL', 'P'),
(34467, 'Womer', 39.9736099243164, 0.697671107087203, -98.7102813720703, -1.72281941551265, 218, 20, 'PPL', 'P'),
(12928, 'Wona (historical)', 33.3911094665527, 0.582784801085193, -93.9594421386719, -1.63990162865693, 218, 4, 'PPL', 'P'),
(144700, 'Wonalancet', 43.9072189331055, 0.766325535776682, -71.3511123657227, -1.2453118357423, 218, 36, 'PPL', 'P'),
(38940, 'Wonder', 37.6336097717285, 0.656830399927374, -82.6066665649414, -1.44175831565534, 218, 21, 'PPL', 'P'),
(201827, 'Wonder', 42.3644409179688, 0.739398979785164, -123.534439086914, -2.15608270167103, 218, 43, 'PPL', 'P'),
(122036, 'Wonder Center', 42.3888893127441, 0.739825684770822, -88.3444366455078, -1.54190129528365, 218, 18, 'PPL', 'P'),
(74870, 'Wonder Hills', 39.2941703796387, 0.685812649964325, -82.1252822875977, -1.43335657504836, 218, 41, 'PPL', 'P'),
(122037, 'Wonder Lake', 42.3852806091309, 0.739762701011041, -88.3472213745117, -1.54194989797354, 218, 18, 'PPL', 'P'),
(212238, 'Wonder Park', 61.223331451416, 1.06854871286701, -149.783325195313, -2.61421218924358, 218, 1, 'PPL', 'P'),
(179564, 'Wonder Rift', 33.3502807617188, 0.582072205756515, -112.018890380859, -1.9550984615766, 218, 5, 'PPL', 'P'),
(179563, 'Wonder Valley', 34.3175010681152, 0.598953384695282, -111.291389465332, -1.94240117528938, 218, 5, 'PPL', 'P'),
(129377, 'Wonderland', 44.2333297729492, 0.7720172436584, -68.3199996948242, -1.1924089396362, 218, 26, 'PPL', 'P'),
(158450, 'Wonderland (historical)', 40.0027809143066, 0.698180236908599, -82.8708267211914, -1.44636878013449, 218, 41, 'PPL', 'P'),
(26177, 'Wonderland Estates', 33.9855613708496, 0.593159944059923, -83.3611068725586, -1.45492578303302, 218, 13, 'PPL', 'P'),
(107742, 'Wonderland Forest', 36.8002815246582, 0.642286078266124, -76.4966735839844, -1.3351188208639, 218, 53, 'PPL', 'P'),
(12929, 'Wonderview', 35.3277816772461, 0.616586107693669, -92.7297210693359, -1.61843894711587, 218, 4, 'PPL', 'P'),
(187557, 'Wondervu', 39.9255599975586, 0.696832477659937, -105.394439697266, -1.8394799860119, 218, 7, 'PPL', 'P'),
(18664, 'Wonderwood', 30.3686103820801, 0.530032240422631, -81.413330078125, -1.42093066487621, 218, 12, 'PPL', 'P'),
(177112, 'Wonewoc', 43.6527786254883, 0.761884714658975, -90.2233276367188, -1.57469412936634, 218, 57, 'PPL', 'P'),
(38941, 'Wonnie', 37.8091697692871, 0.659894499919565, -83.154167175293, -1.45131400396266, 218, 21, 'PPL', 'P'),
(34464, 'Wonsevu', 38.1508293151855, 0.665857583916361, -96.7719421386719, -1.68898901386927, 218, 20, 'PPL', 'P'),
(44195, 'Wood', 31.8999996185303, 0.556760024728288, -93.1616668701172, -1.62597782352967, 218, 22, 'PPL', 'P'),
(58348, 'Wood', 39.9516716003418, 0.697288211101476, -94.4530563354492, -1.64851682162528, 218, 29, 'PPL', 'P'),
(91970, 'Wood', 35.5766716003418, 0.620930056326725, -84.4844436645508, -1.47453170866207, 218, 50, 'PPL', 'P'),
(107743, 'Wood', 36.7916717529297, 0.642135809401617, -82.5391693115234, -1.44058026634715, 218, 53, 'PPL', 'P'),
(112120, 'Wood', 38.7713890075684, 0.676688393753605, -81.9155578613281, -1.4296961932881, 218, 58, 'PPL', 'P'),
(112469, 'Wood', 36.1841697692871, 0.631532899574657, -78.057502746582, -1.36236042881237, 218, 33, 'PPL', 'P'),
(113021, 'Wood', 42.6575012207031, 0.74451384697477, -91.3324966430664, -1.59405278048818, 218, 16, 'PPL', 'P'),
(169086, 'Wood', 40.1405601501465, 0.700584938214886, -74.8472213745117, -1.30633044895431, 218, 45, 'PPL', 'P'),
(193161, 'Wood', 44.125560760498, 0.770136319559504, -116.906112670898, -2.04039658181464, 218, 17, 'PPL', 'P'),
(202798, 'Wood', 43.496940612793, 0.759164828237677, -100.476936340332, -1.75365336145554, 218, 49, 'PPL', 'P'),
(200289, 'Wood (historical)', 40.9027786254883, 0.713888160229131, -115.037780761719, -2.00778803847938, 218, 39, 'PPL', 'P'),
(52939, 'Wood Acres', 38.9680595397949, 0.680120942082608, -77.123893737793, -1.34606587768272, 218, 25, 'PPL', 'P'),
(91971, 'Wood Acres', 36.1805610656738, 0.631469915814877, -83.3791732788086, -1.45524110130609, 218, 50, 'PPL', 'P'),
(14888, 'Wood Branch', 38.6669387817383, 0.674865393408418, -75.3611068725586, -1.31529944287347, 218, 10, 'PPL', 'P'),
(99182, 'Wood Colonia', 26.2980003356934, 0.458986692548423, -98.1729965209961, -1.71344202584032, 218, 51, 'PPL', 'P'),
(133786, 'Wood Creek Farms', 42.5077781677246, 0.741900686734157, -83.3288879394531, -1.45436345656885, 218, 27, 'PPL', 'P'),
(206563, 'Wood Creek Glen Condominium', 40.6808280944824, 0.710014392686529, -111.876937866211, -1.9526209228145, 218, 52, 'PPL', 'P'),
(91972, 'Wood Creek West', 35.9463882446289, 0.627382829068959, -84.1347198486328, -1.46842787660167, 218, 50, 'PPL', 'P'),
(122038, 'Wood Dale', 41.9633293151855, 0.732398261648645, -87.978889465332, -1.5355212934182, 218, 18, 'PPL', 'P'),
(118509, 'Wood Dale Mobile Home Park', 41.5097198486328, 0.724481282939085, -90.6636123657227, -1.58237854753371, 218, 16, 'PPL', 'P'),
(52943, 'Wood Duck Isle', 38.3747215270996, 0.669765240183835, -75.1374969482422, -1.31139671345402, 218, 25, 'PPL', 'P'),
(126695, 'Wood End', 42.0202789306641, 0.73339221994649, -70.1888885498047, -1.22502720350944, 218, 23, 'PPL', 'P'),
(84462, 'Wood Forest', 34.9883308410645, 0.610661572953652, -81.0699996948242, -1.41493841926548, 218, 48, 'PPL', 'P'),
(52940, 'Wood Haven Park', 38.5116691589355, 0.672155427262181, -76.9544372558594, -1.34310830413414, 218, 25, 'PPL', 'P'),
(58350, 'Wood Heights', 39.3394393920898, 0.686602743280724, -94.1624984741211, -1.64344563027755, 218, 29, 'PPL', 'P'),
(99184, 'Wood Hi', 28.7942600250244, 0.502554643112061, -96.8415222167969, -1.69020341532634, 218, 51, 'PPL', 'P'),
(58349, 'Wood Hill', 37.7438888549805, 0.658755133026202, -93.0386123657227, -1.62383011726857, 218, 29, 'PPL', 'P'),
(169087, 'Wood Hill', 41.2127799987793, 0.719298704878763, -79.7466735839844, -1.39184202155371, 218, 45, 'PPL', 'P'),
(192869, 'Wood Hill', 39.6111106872559, 0.691344301864529, -110.811668395996, -1.93402846313828, 218, 52, 'PPL', 'P'),
(206566, 'Wood Hollow Condo', 40.7200012207031, 0.71069809271738, -111.858062744141, -1.95229148978766, 218, 52, 'PPL', 'P'),
(206570, 'Wood Hollow Ranchettes', 40.4738883972168, 0.706402613616164, -111.943893432617, -1.95378951790083, 218, 52, 'PPL', 'P'),
(44196, 'Wood Junction', 32.3419418334961, 0.564473371482998, -92.4113922119141, -1.61288306044975, 218, 22, 'PPL', 'P'),
(44197, 'Wood Lake', 29.8072204589844, 0.520234137877093, -89.7641677856445, -1.56668027817212, 218, 22, 'PPL', 'P'),
(84464, 'Wood Lake', 32.2122192382813, 0.562209285082268, -80.7055587768555, -1.40857772531794, 218, 48, 'PPL', 'P'),
(138918, 'Wood Lake', 44.6527786254883, 0.779338007178918, -95.5380630493164, -1.66745376118851, 218, 28, 'PPL', 'P'),
(199793, 'Wood Lake', 42.6386108398438, 0.744184147631818, -100.237777709961, -1.749479255921, 218, 35, 'PPL', 'P'),
(158452, 'Wood Lake Mobile Home Park', 41.5361099243164, 0.724941876649614, -83.4797210693359, -1.45699599130639, 218, 41, 'PPL', 'P'),
(70317, 'Wood Lee', 36.0094413757324, 0.628483313810407, -80.4736099243164, -1.40452945414491, 218, 33, 'PPL', 'P'),
(14920, 'Wood Mill', 39.7166709899902, 0.693186676706645, -75.6750030517578, -1.32077796470993, 218, 10, 'PPL', 'P'),
(84465, 'Wood Oak Park', 32.9938888549805, 0.575851993556471, -80.1688919067383, -1.39921112144802, 218, 48, 'PPL', 'P'),
(197874, 'Wood Place', 45.7227783203125, 0.798013024848936, -106.423606872559, -1.85744234177421, 218, 31, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(52941, 'Wood Point', 39.6605606079102, 0.692207365794796, -77.7388916015625, -1.35679961529823, 218, 25, 'PPL', 'P'),
(186214, 'Wood Ranch', 36.749439239502, 0.64139871299091, -120.638061523438, -2.10553137680747, 218, 6, 'PPL', 'P'),
(14889, 'Wood Ridge', 39.7527809143066, 0.693816913778613, -75.7188873291016, -1.32154388983944, 218, 10, 'PPL', 'P'),
(52942, 'Wood Ridge', 39.2024993896484, 0.684212689360433, -76.9819412231445, -1.34358833892062, 218, 25, 'PPL', 'P'),
(169089, 'Wood Ridge Manor', 40.2405586242676, 0.702330240835269, -76.6755599975586, -1.33824097776785, 218, 45, 'PPL', 'P'),
(29016, 'Wood River', 38.8611106872559, 0.678254332474571, -90.0975036621094, -1.57249808673146, 218, 18, 'PPL', 'P'),
(143417, 'Wood River', 40.8205604553223, 0.712453182454769, -98.5997161865234, -1.72088968898678, 218, 35, 'PPL', 'P'),
(212239, 'Wood River', 59.0691719055176, 1.03095153617781, -158.441116333008, -2.76531915054635, 218, 1, 'PPL', 'P'),
(169684, 'Wood River Junction', 41.4361114501953, 0.723196574029231, -71.6949996948242, -1.25131380189101, 218, 47, 'PPL', 'P'),
(169090, 'Wood Run', 40.0774993896484, 0.699484320315383, -79.8891677856445, -1.39432901453768, 218, 45, 'PPL', 'P'),
(44198, 'Wood Springs', 32.0644416809082, 0.559630080145553, -93.9047164916992, -1.63894648593197, 218, 22, 'PPL', 'P'),
(62367, 'Wood Springs', 33.438060760498, 0.58360425575261, -89.3594436645508, -1.5596165096968, 218, 30, 'PPL', 'P'),
(99185, 'Wood Springs', 32.4747200012207, 0.566790787684558, -95.4047164916992, -1.66512642471188, 218, 51, 'PPL', 'P'),
(179565, 'Wood Springs', 35.8125, 0.625046038370469, -109.461387634277, -1.91046161801995, 218, 5, 'PPL', 'P'),
(179566, 'Wood Trap', 34.607780456543, 0.604019715774021, -112.798889160156, -1.96871200843687, 218, 5, 'PPL', 'P'),
(26184, 'Wood Valley', 34.1497192382813, 0.596025039339658, -84.3108291625977, -1.47150156397378, 218, 13, 'PPL', 'P'),
(84466, 'Wood Valley', 33.4949989318848, 0.584598014313373, -81.7641677856445, -1.42705393801258, 218, 48, 'PPL', 'P'),
(26183, 'Wood Valley Estates', 33.3763885498047, 0.582527872619027, -84.6505584716797, -1.47743095898279, 218, 13, 'PPL', 'P'),
(201828, 'Wood Village', 45.5344390869141, 0.794725885115451, -122.417503356934, -2.1365884956497, 218, 43, 'PPL', 'P'),
(186217, 'Wood Vista', 39.2425003051758, 0.684910837040197, -120.031387329102, -2.09494291462942, 218, 6, 'PPL', 'P'),
(71591, 'Wood-Lynne', 39.9172210693359, 0.696686935906364, -75.0966720581055, -1.31068418470437, 218, 37, 'PPL', 'P'),
(52984, 'Wood-N-Dale Estates', 38.4594383239746, 0.671243827221047, -76.7555618286133, -1.33963727312738, 218, 25, 'PPL', 'P'),
(146661, 'Wood-Ridge', 40.8455581665039, 0.712889474820351, -74.0883331298828, -1.29308535043085, 218, 37, 'PPL', 'P'),
(186215, 'Woodacre', 38.0127792358398, 0.663448155499139, -122.644172668457, -2.14054462144902, 218, 6, 'PPL', 'P'),
(146663, 'Woodair Estates', 40.0883293151855, 0.699673338173751, -74.4000015258789, -1.29852499011539, 218, 37, 'PPL', 'P'),
(6906, 'Woodaire Estates', 33.6577796936035, 0.58743907456427, -86.6822204589844, -1.51289014994887, 218, 2, 'PPL', 'P'),
(52944, 'Woodale Homes', 39.4669418334961, 0.688828080687594, -76.309440612793, -1.33185098904832, 218, 25, 'PPL', 'P'),
(77714, 'Woodall', 35.8347206115723, 0.625433861204212, -95.0680618286133, -1.65925069239884, 218, 42, 'PPL', 'P'),
(6907, 'Woodall Place', 34.5508308410645, 0.603025757476176, -86.2574996948242, -1.50547737421269, 218, 2, 'PPL', 'P'),
(70318, 'Woodard', 35.915828704834, 0.626849464481644, -76.8616714477539, -1.34148923534942, 218, 33, 'PPL', 'P'),
(153895, 'Woodard', 43.1413917541504, 0.752959330002656, -76.1944427490234, -1.32984389769278, 218, 40, 'PPL', 'P'),
(129378, 'Woodard (historical)', 45.4069404602051, 0.792500614287608, -68.584716796875, -1.19702912465333, 218, 26, 'PPL', 'P'),
(77715, 'Woodard Corner', 35.5219383239746, 0.619974780443713, -96.1586074829102, -1.67828430470964, 218, 42, 'PPL', 'P'),
(26185, 'Woodard Estates', 32.5258293151855, 0.56768281349168, -83.6252822875977, -1.45953651382827, 218, 13, 'PPL', 'P'),
(44207, 'Woodardville', 32.2597198486328, 0.563038327129609, -93.2799987792969, -1.62804310495502, 218, 22, 'PPL', 'P'),
(12931, 'Woodberry', 33.582218170166, 0.586120277192462, -92.5158309936523, -1.61470586105785, 218, 4, 'PPL', 'P'),
(52945, 'Woodberry', 39.3316688537598, 0.686467121802212, -76.6497192382813, -1.33778997143725, 218, 25, 'PPL', 'P'),
(84467, 'Woodberry', 34.8591690063477, 0.608407273669927, -82.2916717529297, -1.43626061905904, 218, 48, 'PPL', 'P'),
(52946, 'Woodberry Beach', 38.3227806091309, 0.668858700148772, -76.8580627441406, -1.34142625158964, 218, 25, 'PPL', 'P'),
(634, 'Woodbine', 39.3597183227539, 0.686956677389596, -77.0627822875977, -1.34499928166615, 218, 25, 'PPL', 'P'),
(14891, 'Woodbine', 39.8125, 0.694859208450242, -75.529167175293, -1.31823264849809, 218, 10, 'PPL', 'P'),
(26186, 'Woodbine', 30.9636096954346, 0.540416937487772, -81.7227783203125, -1.42633155556689, 218, 13, 'PPL', 'P'),
(34465, 'Woodbine', 38.7961082458496, 0.677119825850197, -96.9583282470703, -1.6922420651408, 218, 20, 'PPL', 'P'),
(38944, 'Woodbine', 36.9047203063965, 0.644108878874229, -84.0888900756836, -1.46762799616826, 218, 21, 'PPL', 'P'),
(70321, 'Woodbine', 35.6511116027832, 0.62222927946452, -80.4291687011719, -1.40375380847742, 218, 33, 'PPL', 'P'),
(71592, 'Woodbine', 39.2416687011719, 0.684896322812256, -74.815559387207, -1.30577784302811, 218, 37, 'PPL', 'P'),
(91973, 'Woodbine', 36.1202812194824, 0.630417834026241, -86.7433319091797, -1.51395674596544, 218, 50, 'PPL', 'P'),
(99186, 'Woodbine', 33.6105613708496, 0.586614959364945, -97.0152816772461, -1.69323609001767, 218, 51, 'PPL', 'P'),
(107745, 'Woodbine', 38.6674995422363, 0.674875180525424, -77.4402770996094, -1.35158780904495, 218, 53, 'PPL', 'P'),
(112122, 'Woodbine', 38.2986106872559, 0.668436855432103, -80.6147232055664, -1.40699234552101, 218, 58, 'PPL', 'P'),
(118510, 'Woodbine', 41.7383308410645, 0.728471297463269, -95.7024993896484, -1.67032371673723, 218, 16, 'PPL', 'P'),
(122039, 'Woodbine', 42.3422203063965, 0.739011156951421, -90.1452789306641, -1.57333192246876, 218, 18, 'PPL', 'P'),
(169093, 'Woodbine', 40.0033302307129, 0.698189824288523, -75.6822204589844, -1.32090393222949, 218, 45, 'PPL', 'P'),
(52947, 'Woodbine Acres', 39.413890838623, 0.687902166155601, -77.0472183227539, -1.34472763923496, 218, 25, 'PPL', 'P'),
(107748, 'Woodbine Acres', 37.3466682434082, 0.65182232549748, -79.2108306884766, -1.38248979875368, 218, 53, 'PPL', 'P'),
(107749, 'Woodbine Forest', 38.6622200012207, 0.674783035151707, -77.4488906860352, -1.35173814448848, 218, 53, 'PPL', 'P'),
(71593, 'Woodbine Junction', 39.2347183227539, 0.684775015824603, -74.7930603027344, -1.30538515992538, 218, 37, 'PPL', 'P'),
(107750, 'Woodbine Village', 37.417781829834, 0.653063491723512, -79.232780456543, -1.38287289447649, 218, 53, 'PPL', 'P'),
(107751, 'Woodbine Woods', 38.6716690063477, 0.674947951402211, -77.4480590820313, -1.35172363026054, 218, 53, 'PPL', 'P'),
(177126, 'Woodboro', 45.6074981689453, 0.796001006645381, -89.5541687011719, -1.5630151027219, 218, 57, 'PPL', 'P'),
(146664, 'Woodbourne', 41.2044410705566, 0.719153163125191, -74.6433334350586, -1.30277193310574, 218, 37, 'PPL', 'P'),
(153896, 'Woodbourne', 41.7597198486328, 0.728844606069071, -74.5944366455078, -1.30191852313443, 218, 40, 'PPL', 'P'),
(169094, 'Woodbourne', 40.1922187805176, 0.701486551401932, -74.8891677856445, -1.30706255193797, 218, 45, 'PPL', 'P'),
(99187, 'Woodbranch', 30.1808300018311, 0.526754854516638, -95.188606262207, -1.66135458966001, 218, 51, 'PPL', 'P'),
(84469, 'Woodbriar', 34.8638916015625, 0.608489698505665, -82.4486083984375, -1.43899968024018, 218, 48, 'PPL', 'P'),
(26189, 'Woodbridge', 34.1691703796387, 0.596364525799616, -83.9466705322266, -1.46514579687425, 218, 13, 'PPL', 'P'),
(52948, 'Woodbridge', 39.4755592346191, 0.688978482710157, -77.0716705322266, -1.34515441079964, 218, 25, 'PPL', 'P'),
(70324, 'Woodbridge', 36.0958290100098, 0.629991062461556, -80.165283203125, -1.39914813768824, 218, 33, 'PPL', 'P'),
(84471, 'Woodbridge', 34.9708290100098, 0.610356108376619, -81.1033325195313, -1.41552018680561, 218, 48, 'PPL', 'P'),
(107753, 'Woodbridge', 37.2802810668945, 0.650663650686214, -80.0869369506836, -1.39778073762654, 218, 53, 'PPL', 'P'),
(114320, 'Woodbridge', 41.3525009155273, 0.721737294909922, -73.0088882446289, -1.27424548308936, 218, 8, 'PPL', 'P'),
(146665, 'Woodbridge', 40.5574989318848, 0.707861892735473, -74.2850036621094, -1.29651789875985, 218, 37, 'PPL', 'P'),
(186216, 'Woodbridge', 38.1541709899902, 0.665915907144234, -121.300277709961, -2.11708922962231, 218, 6, 'PPL', 'P'),
(52949, 'Woodbridge Center', 39.4294395446777, 0.68817354227068, -76.3252792358398, -1.33212742516947, 218, 25, 'PPL', 'P'),
(206567, 'Woodbridge Condominium', 40.6644401550293, 0.709728369185455, -111.843063354492, -1.9520297010525, 218, 52, 'PPL', 'P'),
(129379, 'Woodbridge Corner', 45.8702812194824, 0.800587436095688, -68.3302764892578, -1.19258830353562, 218, 26, 'PPL', 'P'),
(179567, 'Woodbridge Crossing', 33.3847198486328, 0.582673281214546, -111.795829772949, -1.95120531953707, 218, 5, 'PPL', 'P'),
(146666, 'Woodbridge Oaks', 40.5825004577637, 0.708298251680082, -74.3338928222656, -1.29737117557312, 218, 37, 'PPL', 'P'),
(70328, 'Woodbridge Run', 35.667781829834, 0.622520229813611, -80.5208282470703, -1.40535356934423, 218, 33, 'PPL', 'P'),
(52950, 'Woodbridge Valley', 39.2975006103516, 0.685870773455116, -76.7641677856445, -1.33978747541286, 218, 25, 'PPL', 'P'),
(79436, 'Woodbridgetown', 39.7744407653809, 0.694194949495349, -79.8019409179688, -1.39280661850054, 218, 45, 'PPL', 'P'),
(14892, 'Woodbrook', 39.7938919067383, 0.694534435955307, -75.5583267211914, -1.3187415785824, 218, 10, 'PPL', 'P'),
(52951, 'Woodbrook', 39.3794403076172, 0.687300890960489, -76.6275024414063, -1.33740221518253, 218, 25, 'PPL', 'P'),
(107755, 'Woodbrook', 38.0858306884766, 0.664723143871015, -78.4663925170898, -1.36949690158546, 218, 53, 'PPL', 'P'),
(29018, 'Woodburn', 39.0475006103516, 0.68150745032513, -90.0119400024414, -1.5710047191502, 218, 18, 'PPL', 'P'),
(38942, 'Woodburn', 36.8424987792969, 0.643022908360722, -86.5274963378906, -1.51018970460353, 218, 21, 'PPL', 'P'),
(52953, 'Woodburn', 38.973331451416, 0.68021295429827, -77.1269378662109, -1.34611900774647, 218, 25, 'PPL', 'P'),
(70329, 'Woodburn', 34.2363891601563, 0.597537714838823, -78.0047225952148, -1.36143924139132, 218, 33, 'PPL', 'P'),
(74873, 'Woodburn', 39.1297187805176, 0.682942428099492, -84.4766693115234, -1.47439602060454, 218, 41, 'PPL', 'P'),
(107756, 'Woodburn', 39.0900001525879, 0.682249207267745, -77.6194381713867, -1.35471475963886, 218, 53, 'PPL', 'P'),
(118511, 'Woodburn', 41.0119400024414, 0.715793385672974, -93.5988922119141, -1.63360884531718, 218, 16, 'PPL', 'P'),
(124042, 'Woodburn', 41.1252784729004, 0.717771515151657, -84.8533325195313, -1.4809700337554, 218, 19, 'PPL', 'P'),
(169095, 'Woodburn', 41.7572212219238, 0.728800996806221, -75.9058303833008, -1.32480666164895, 218, 45, 'PPL', 'P'),
(201829, 'Woodburn', 45.1438903808594, 0.787909524305393, -122.85417175293, -2.14420979689924, 218, 43, 'PPL', 'P'),
(91974, 'Woodburn (historical)', 36.1833305358887, 0.631518252188662, -83.8133316040039, -1.46281859355569, 218, 50, 'PPL', 'P'),
(84475, 'Woodburn Hills', 34.9430618286133, 0.609871479637252, -81.9088897705078, -1.42957981314846, 218, 48, 'PPL', 'P'),
(52954, 'Woodburn on the Potomac', 39.523609161377, 0.689817112137423, -77.8166732788086, -1.3581571616639, 218, 25, 'PPL', 'P'),
(192452, 'Woodburn Place', 34.7188911437988, 0.60595896310079, -101.124168395996, -1.76494969185132, 218, 51, 'PPL', 'P'),
(362, 'Woodbury', 39.038890838623, 0.681357181460623, -75.5538864135742, -1.31866408059468, 218, 10, 'PPL', 'P'),
(26191, 'Woodbury', 32.9836082458496, 0.575672563078027, -84.5827789306641, -1.47624798282658, 218, 13, 'PPL', 'P'),
(29019, 'Woodbury', 39.1958312988281, 0.684096309220796, -88.3030624389648, -1.54117917915407, 218, 18, 'PPL', 'P'),
(31556, 'Woodbury', 39.9086112976074, 0.696536667041856, -85.8949966430664, -1.49915050241099, 218, 19, 'PPL', 'P'),
(38943, 'Woodbury', 37.1833305358887, 0.648971544708605, -86.6338882446289, -1.51204659367359, 218, 21, 'PPL', 'P'),
(71595, 'Woodbury', 39.8380584716797, 0.695305287932831, -75.1530609130859, -1.31166835588521, 218, 37, 'PPL', 'P'),
(84476, 'Woodbury', 33.7627792358398, 0.58927166228938, -79.246940612793, -1.38312003582565, 218, 48, 'PPL', 'P'),
(91975, 'Woodbury', 35.8274993896484, 0.625307827105624, -86.0716705322266, -1.50223404347913, 218, 50, 'PPL', 'P'),
(99188, 'Woodbury', 32.0494384765625, 0.559368224831371, -97.2305603027344, -1.69699341084161, 218, 51, 'PPL', 'P'),
(114322, 'Woodbury', 41.5444412231445, 0.725087285245132, -73.2094421386719, -1.2777458088681, 218, 8, 'PPL', 'P'),
(133788, 'Woodbury', 42.7611083984375, 0.746322133354934, -85.0744400024414, -1.48482908733298, 218, 27, 'PPL', 'P'),
(138922, 'Woodbury', 44.9238891601563, 0.784069778645717, -92.9591674804688, -1.62244354244702, 218, 28, 'PPL', 'P'),
(153898, 'Woodbury', 41.3644409179688, 0.72194568726522, -74.1063919067383, -1.29340053554586, 218, 40, 'PPL', 'P'),
(169096, 'Woodbury', 40.226390838623, 0.702082966328055, -78.366943359375, -1.367761186345, 218, 45, 'PPL', 'P'),
(172818, 'Woodbury', 44.4408302307129, 0.775638809845771, -72.4169387817383, -1.2639140159565, 218, 55, 'PPL', 'P'),
(52955, 'Woodbury Acres', 38.9105606079102, 0.679117396404839, -76.1747207641602, -1.32949968412189, 218, 25, 'PPL', 'P'),
(71615, 'Woodbury Gardens', 39.8416709899902, 0.695368338271638, -75.1374969482422, -1.31139671345402, 218, 37, 'PPL', 'P'),
(71597, 'Woodbury Heights', 39.8169403076172, 0.694936706437964, -75.1555633544922, -1.31171203172708, 218, 37, 'PPL', 'P'),
(91976, 'Woodby Hill', 36.2011108398438, 0.631828577034683, -82.2405624389648, -1.43536859325191, 218, 50, 'PPL', 'P'),
(52956, 'Woodbyran Farms', 39.0872192382813, 0.682200671156878, -77.3102798461914, -1.34931892895426, 218, 25, 'PPL', 'P'),
(91977, 'Woodchase', 35.8883285522461, 0.626369496274184, -84.1908264160156, -1.46940712093449, 218, 50, 'PPL', 'P'),
(212240, 'Woodchopper', 65.0511093139648, 1.13535603960344, -151.00944519043, -2.63561202018291, 218, 1, 'PPL', 'P'),
(169099, 'Woodchoppertown', 40.3486099243164, 0.704216091782181, -75.7174987792969, -1.32151965507352, 218, 45, 'PPL', 'P'),
(44201, 'Woodchuck', 32.3291702270508, 0.564250464899759, -93.6033325195313, -1.6336863433049, 218, 22, 'PPL', 'P'),
(107758, 'Woodchuck Heights', 39.1888885498047, 0.683975135391198, -78.2291717529297, -1.36535661819677, 218, 53, 'PPL', 'P'),
(26192, 'Woodcliff', 32.7405586242676, 0.571430546935694, -81.7633285522461, -1.42703929062658, 218, 13, 'PPL', 'P'),
(107759, 'Woodcliff', 37.2452812194824, 0.650052788111177, -79.942497253418, -1.39525978933867, 218, 53, 'PPL', 'P'),
(143422, 'Woodcliff', 41.3816719055176, 0.722246424731318, -96.4713897705078, -1.68374338547014, 218, 35, 'PPL', 'P'),
(146668, 'Woodcliff Lake', 41.0233306884766, 0.715992190648348, -74.0669403076172, -1.29271197524602, 218, 37, 'PPL', 'P'),
(153900, 'Woodcliff Park', 40.9666709899902, 0.715003292356575, -72.7544403076172, -1.2698045288136, 218, 40, 'PPL', 'P'),
(112125, 'Woodcliffe Chase', 38.4502792358398, 0.671083970976615, -81.9805603027344, -1.43083069991247, 218, 58, 'PPL', 'P'),
(26193, 'Woodcliffe Estates', 34.3008308410645, 0.59866243434619, -85.1055603027344, -1.4853722390373, 218, 13, 'PPL', 'P'),
(169101, 'Woodcock', 41.7547187805176, 0.728757320964343, -80.0858306884766, -1.39776142970863, 218, 45, 'PPL', 'P'),
(169102, 'Woodcock Grange', 41.7169418334961, 0.728097988857467, -80.1044387817383, -1.39808620220357, 218, 45, 'PPL', 'P'),
(26233, 'Woodcraft', 33.0800018310547, 0.577354948517657, -84.7186126708984, -1.47861872882896, 218, 13, 'PPL', 'P'),
(14893, 'Woodcreek', 39.7388916015625, 0.693574499540388, -75.6958312988281, -1.32114148619873, 218, 10, 'PPL', 'P'),
(84478, 'Woodcreek', 35.0066719055176, 0.610981684916679, -81.9483337402344, -1.43026824029025, 218, 48, 'PPL', 'P'),
(99189, 'Woodcreek', 30.0280609130859, 0.524088530922764, -98.1108322143555, -1.71235705401222, 218, 51, 'PPL', 'P'),
(179568, 'Woodcreek', 33.3833312988281, 0.582649046448626, -111.870002746582, -1.95249988214296, 218, 5, 'PPL', 'P'),
(206572, 'Woodcreek Condo', 40.6861114501953, 0.710106604639273, -111.875556945801, -1.95259682120663, 218, 52, 'PPL', 'P'),
(206573, 'Woodcreek Glen Condo', 40.6852798461914, 0.710092090411332, -111.875556945801, -1.95259682120663, 218, 52, 'PPL', 'P'),
(6908, 'Woodcrest', 33.5952796936035, 0.586348243781773, -86.7152786254883, -1.51346712379903, 218, 2, 'PPL', 'P'),
(14895, 'Woodcrest', 39.7208290100098, 0.69325924784635, -75.602783203125, -1.319517490566, 218, 10, 'PPL', 'P'),
(26195, 'Woodcrest', 33.6500015258789, 0.587303319927703, -84.2808303833008, -1.47097798650347, 218, 13, 'PPL', 'P'),
(31558, 'Woodcrest', 39.4375, 0.688314223755264, -86.3947219848633, -1.50787235498099, 218, 19, 'PPL', 'P'),
(52959, 'Woodcrest', 39.4861106872559, 0.689162640299536, -76.3841705322266, -1.33315527219218, 218, 25, 'PPL', 'P'),
(70331, 'Woodcrest', 35.3899993896484, 0.617672011628149, -80.2091674804688, -1.39991406281774, 218, 33, 'PPL', 'P'),
(71600, 'Woodcrest', 39.8722190856934, 0.695901503121872, -74.998893737793, -1.30897763107784, 218, 37, 'PPL', 'P'),
(79437, 'Woodcrest', 39.978889465332, 0.697763252460919, -75.5744400024414, -1.31902280839351, 218, 45, 'PPL', 'P'),
(122041, 'Woodcrest', 41.4894409179688, 0.724127348830213, -90.2536087036133, -1.57522263368466, 218, 18, 'PPL', 'P'),
(186218, 'Woodcrest', 33.8822212219238, 0.591356318211667, -117.356391906738, -2.04825543703341, 218, 6, 'PPL', 'P'),
(71601, 'Woodcrest Acres', 39.8591690063477, 0.695673736269643, -74.9819412231445, -1.30868175388074, 218, 37, 'PPL', 'P'),
(99190, 'Woodcrest Acres', 30.2283306121826, 0.52758389656398, -94.1797180175781, -1.64374616800657, 218, 51, 'PPL', 'P'),
(14896, 'Woodcrest Estates', 38.6030616760254, 0.673750527597084, -75.4349975585938, -1.31658907863135, 218, 10, 'PPL', 'P'),
(52960, 'Woodcrest Gardens', 39.1958312988281, 0.684096309220796, -76.6208267211914, -1.33728570188484, 218, 25, 'PPL', 'P'),
(91978, 'Woodcrest Hills', 36.2061080932617, 0.631915795560383, -83.3983306884766, -1.45557546118095, 218, 50, 'PPL', 'P'),
(52961, 'Woodcrest Shores', 39.5644416809082, 0.690529774045128, -75.8641662597656, -1.3240794855133, 218, 25, 'PPL', 'P'),
(26196, 'Woodcrest Subdivision', 31.5541706085205, 0.550724169854706, -83.9458312988281, -1.46513114948826, 218, 13, 'PPL', 'P'),
(52963, 'Woodcroft', 39.392219543457, 0.687523930701783, -76.538330078125, -1.33584586384149, 218, 25, 'PPL', 'P'),
(14897, 'Wooddale', 39.7661094665527, 0.694049540899831, -75.6372222900391, -1.32011856602403, 218, 10, 'PPL', 'P'),
(91981, 'Wooddale', 36.0149993896484, 0.628580319453113, -83.7597198486328, -1.46188289190669, 218, 50, 'PPL', 'P'),
(169104, 'Wooddale', 41.0813903808594, 0.717005523443123, -75.1780624389648, -1.31210471482982, 218, 45, 'PPL', 'P'),
(177121, 'Wooddale', 45.685001373291, 0.797353692742059, -91.4608306884766, -1.59629263212299, 218, 57, 'PPL', 'P'),
(52964, 'Wooddale Farms', 39.5583305358887, 0.69042311444347, -76.5988922119141, -1.33690287247814, 218, 25, 'PPL', 'P'),
(14898, 'Wooded Acres', 38.6172218322754, 0.673997668946243, -75.5508270263672, -1.31861068421482, 218, 10, 'PPL', 'P'),
(52965, 'Wooded Acres', 39.476390838623, 0.688992996938098, -77.4683303833008, -1.35207743121136, 218, 25, 'PPL', 'P'),
(91979, 'Wooded Acres', 35.9766693115234, 0.627911333387286, -84.029167175293, -1.46658563491761, 218, 50, 'PPL', 'P'),
(107761, 'Wooded Acres', 37.3202781677246, 0.651361731786951, -80.0627822875977, -1.39735915922598, 218, 53, 'PPL', 'P'),
(74874, 'Wooded Hills', 39.9683303833008, 0.697578961713486, -82.5683288574219, -1.44108919643146, 218, 41, 'PPL', 'P'),
(99191, 'Wooded Hills', 32.5237503051758, 0.567646527921828, -97.2688903808594, -1.69766239690744, 218, 51, 'PPL', 'P'),
(118514, 'Wooded Lake Mobile Home Park', 41.2177810668945, 0.719385989983491, -95.8652801513672, -1.67316477698813, 218, 16, 'PPL', 'P'),
(52966, 'Wooded Valley Estates', 38.7447204589844, 0.676222939774086, -76.6205596923828, -1.33728104135293, 218, 25, 'PPL', 'P'),
(209842, 'Woodedge', 41.5175018310547, 0.724617104154679, -106.144996643066, -1.85257967593984, 218, 59, 'PPL', 'P'),
(14899, 'Wooden Bridge', 39.0308303833008, 0.681216499976039, -75.5252838134766, -1.31816487104834, 218, 10, 'PPL', 'P'),
(12932, 'Wooden Hills', 36.3369407653809, 0.634199256458044, -93.0602798461914, -1.62420828614336, 218, 4, 'PPL', 'P'),
(133789, 'Wooden Shoe Village', 43.978889465332, 0.767576422540693, -84.3561096191406, -1.47229185702726, 218, 27, 'PPL', 'P'),
(14900, 'Woodenhawk', 38.7916717529297, 0.677042394441503, -75.690559387207, -1.32104947398306, 218, 10, 'PPL', 'P'),
(52967, 'Woodenhawk Pines', 38.7705612182617, 0.676673946104691, -75.7225036621094, -1.32160700675727, 218, 25, 'PPL', 'P'),
(52968, 'Woodensburg', 39.5055618286133, 0.689502126759494, -76.8344421386719, -1.3410139942529, 218, 25, 'PPL', 'P'),
(146670, 'Woodfern', 40.5086097717285, 0.707008615922211, -74.758056640625, -1.30477423077132, 218, 37, 'PPL', 'P'),
(26199, 'Woodfield', 33.0194396972656, 0.576297939881005, -85.0936126708984, -1.48516371352394, 218, 13, 'PPL', 'P'),
(52971, 'Woodfield', 38.3202781677246, 0.668815024306894, -75.5805587768555, -1.31912960115323, 218, 25, 'PPL', 'P'),
(84483, 'Woodfield', 34.9747200012207, 0.610424018984416, -82.0122222900391, -1.43138330583867, 218, 48, 'PPL', 'P'),
(84484, 'Woodfield Heights', 34.7902793884277, 0.607204923016783, -82.383056640625, -1.43785558623589, 218, 48, 'PPL', 'P'),
(91980, 'Woodfield Park', 35.9055595397949, 0.626670233740281, -83.8313903808594, -1.4631337786707, 218, 50, 'PPL', 'P'),
(26200, 'Woodfield Subdivision', 32.5702781677246, 0.56845859231722, -83.584716796875, -1.45882851245248, 218, 13, 'PPL', 'P'),
(84487, 'Woodfields', 34.1808280944824, 0.596567991306898, -82.1191711425781, -1.4332499154467, 218, 48, 'PPL', 'P'),
(70338, 'Woodfin', 35.6333312988281, 0.621918954618498, -82.5822219848633, -1.44133167724871, 218, 33, 'PPL', 'P'),
(84488, 'Woodfin', 35.1124992370605, 0.612828720290704, -82.0886077880859, -1.43271648428036, 218, 48, 'PPL', 'P'),
(6913, 'Woodfin Mill', 34.9625015258789, 0.610210766360128, -86.9191665649414, -1.5170256396476, 218, 2, 'PPL', 'P'),
(26201, 'Woodfin Mill', 33.110279083252, 0.577883386256956, -84.2311096191406, -1.47011019546227, 218, 13, 'PPL', 'P'),
(6915, 'Woodford', 32.5038909912109, 0.567299917505954, -88.0063934326172, -1.53600132820468, 218, 2, 'PPL', 'P'),
(70339, 'Woodford', 36.3450012207031, 0.634339937942628, -81.5908279418945, -1.42402858701425, 218, 33, 'PPL', 'P'),
(77721, 'Woodford', 34.3386116027832, 0.599321833032094, -97.2841720581055, -1.69792911249061, 218, 42, 'PPL', 'P'),
(84489, 'Woodford', 33.6672210693359, 0.587603857656718, -81.1094436645508, -1.41562684640727, 218, 48, 'PPL', 'P'),
(107762, 'Woodford', 38.1130599975586, 0.665198384967539, -77.4091720581055, -1.35104492365674, 218, 53, 'PPL', 'P'),
(122043, 'Woodford', 40.8466682434082, 0.712908849317282, -89.0280609130859, -1.55383278959942, 218, 18, 'PPL', 'P'),
(172820, 'Woodford', 42.8802795410156, 0.748402062166286, -73.0800018310547, -1.27548664931539, 218, 55, 'PPL', 'P'),
(177122, 'Woodford', 42.648609161377, 0.744358651262245, -89.8625030517578, -1.56839655233663, 218, 57, 'PPL', 'P'),
(186219, 'Woodford', 35.2127799987793, 0.614578949759104, -118.551666259766, -2.06911690995838, 218, 6, 'PPL', 'P'),
(92006, 'Woodford (historical)', 36.4916687011719, 0.636899768382412, -87.1791687011719, -1.52156353298704, 218, 50, 'PPL', 'P'),
(107763, 'Woodford Corner', 37.1788902282715, 0.648894046720884, -79.4297180175781, -1.3863101033374, 218, 53, 'PPL', 'P'),
(38946, 'Woodford Village', 38.0422210693359, 0.66396201243147, -84.7252807617188, -1.4787351089686, 218, 21, 'PPL', 'P'),
(129380, 'Woodfords', 43.6733283996582, 0.762243375878782, -70.2819366455078, -1.22665119914217, 218, 26, 'PPL', 'P'),
(186220, 'Woodfords', 38.7777786254883, 0.676799913624252, -119.820831298828, -2.09126801864122, 218, 6, 'PPL', 'P'),
(129381, 'Woodfords Corner', 43.670280456543, 0.762190179236007, -70.2847213745117, -1.22669980183206, 218, 26, 'PPL', 'P'),
(169106, 'Woodfort', 40.3294410705566, 0.70388153217024, -76.4508285522461, -1.33431867411438, 218, 45, 'PPL', 'P'),
(31557, 'Woodgate', 39.3847198486328, 0.687393036334205, -87.3852767944336, -1.52516079782946, 218, 19, 'PPL', 'P'),
(153901, 'Woodgate', 43.5202789306641, 0.759572158726405, -75.1552810668945, -1.31170710487907, 218, 40, 'PPL', 'P'),
(169107, 'Woodgate', 40.2555618286133, 0.702592096149451, -75.5699996948242, -1.31894531040579, 218, 45, 'PPL', 'P'),
(146671, 'Woodglen', 40.7191696166992, 0.710683578489439, -74.8880615234375, -1.30704324402007, 218, 37, 'PPL', 'P'),
(169108, 'Woodglen', 40.0363883972168, 0.698766798138688, -79.7997207641602, -1.39276786950668, 218, 45, 'PPL', 'P'),
(179569, 'Woodglen', 33.3530616760254, 0.582120741867381, -111.871391296387, -1.95252411690888, 218, 5, 'PPL', 'P'),
(52972, 'Woodglen Farms', 39.4933280944824, 0.689288607819097, -76.8388900756836, -1.34109162539867, 218, 25, 'PPL', 'P'),
(6916, 'Woodhaven', 33.7700004577637, 0.589397696387968, -86.6266708374023, -1.51192062615402, 218, 2, 'PPL', 'P'),
(44204, 'Woodhaven', 30.5261096954346, 0.532781122010297, -90.5541687011719, -1.58046839524185, 218, 22, 'PPL', 'P'),
(52973, 'Woodhaven', 38.9936103820801, 0.680566888407141, -77.1336135864258, -1.34623552104416, 218, 25, 'PPL', 'P'),
(84490, 'Woodhaven', 32.7358283996582, 0.571347988941902, -79.9211120605469, -1.39488654731189, 218, 48, 'PPL', 'P'),
(107765, 'Woodhaven', 36.8074989318848, 0.642412045785685, -76.1994400024414, -1.32993111621848, 218, 53, 'PPL', 'P'),
(133790, 'Woodhaven', 42.1388893127441, 0.735462361640836, -83.2416687011719, -1.45284119368976, 218, 27, 'PPL', 'P'),
(153902, 'Woodhaven', 40.6891708374023, 0.710160001019129, -73.8583297729492, -1.28907103456172, 218, 40, 'PPL', 'P'),
(91982, 'Woodhaven (historical)', 36.1902809143066, 0.631639559176315, -87.4416732788086, -1.52614510216836, 218, 50, 'PPL', 'P'),
(26204, 'Woodhaven Downs', 34.0136108398438, 0.593649499647307, -83.9922180175781, -1.46594075045964, 218, 13, 'PPL', 'P'),
(26205, 'Woodhaven Estates', 33.535831451416, 0.585310676221078, -84.1894378662109, -1.46938288616857, 218, 13, 'PPL', 'P'),
(26206, 'Woodhaven High Ridge', 33.9575004577637, 0.592670188735458, -83.4458312988281, -1.45640450322829, 218, 13, 'PPL', 'P'),
(158453, 'Woodhaven Mobile Home Park', 40.5055618286133, 0.706955419279437, -84.5319366455078, -1.47536061755136, 218, 41, 'PPL', 'P'),
(107766, 'Woodhaven Shores', 37.4916687011719, 0.654353060902355, -77.1288909912109, -1.34615309620842, 218, 53, 'PPL', 'P'),
(206577, 'Woodhaven Village', 40.660831451416, 0.709665385425674, -111.930557250977, -1.95355675762155, 218, 52, 'PPL', 'P'),
(206578, 'Woodhaven Village Number 5', 40.670280456543, 0.709830301676177, -111.931938171387, -1.95358085922942, 218, 52, 'PPL', 'P'),
(197875, 'Woodhawk (historical)', 47.7150001525879, 0.832783855252255, -109.199996948242, -1.90589948991459, 218, 31, 'PPL', 'P'),
(58353, 'Woodhill', 39.1769409179688, 0.683766609877844, -94.5377807617188, -1.64999554182055, 218, 29, 'PPL', 'P'),
(169109, 'Woodhill', 40.2916717529297, 0.703222333221418, -74.9397201538086, -1.30794485720711, 218, 45, 'PPL', 'P'),
(91983, 'Woodhill (historical)', 35.8063888549805, 0.624939378768812, -88.6222229003906, -1.54674958004814, 218, 50, 'PPL', 'P'),
(58354, 'Woodhine Heights', 38.5694389343262, 0.673163700050885, -90.4338912963867, -1.57836915851259, 218, 29, 'PPL', 'P'),
(52974, 'Woodholme', 39.1294403076172, 0.682937567830503, -76.5877838134766, -1.33670899435078, 218, 25, 'PPL', 'P'),
(52975, 'Woodhome Heights', 39.3697204589844, 0.687131247599051, -76.5458297729492, -1.33597675820907, 218, 25, 'PPL', 'P'),
(169110, 'Woodhouse', 41.7333297729492, 0.728384012358541, -75.9138870239258, -1.3249472765545, 218, 45, 'PPL', 'P'),
(107767, 'Woodhouse Corner', 36.7644386291504, 0.641660501726065, -76.0149993896484, -1.32671202025085, 218, 53, 'PPL', 'P'),
(122045, 'Woodhull', 41.1788902282715, 0.718707216800657, -90.3158264160156, -1.57630853761914, 218, 18, 'PPL', 'P'),
(153904, 'Woodhull', 42.0802803039551, 0.734439441466136, -77.4088897705078, -1.35103999680872, 218, 40, 'PPL', 'P'),
(177123, 'Woodhull', 43.7775001525879, 0.764061515954979, -88.5730590820313, -1.54589150954491, 218, 57, 'PPL', 'P'),
(12933, 'Woodiel Acres', 34.978328704834, 0.610487002744197, -91.9822235107422, -1.60539265356779, 218, 4, 'PPL', 'P'),
(179570, 'Woodin', 35.8488883972168, 0.625681135711426, -112.254997253418, -1.95921930388934, 218, 5, 'PPL', 'P'),
(197876, 'Woodin', 45.8113899230957, 0.799559589072972, -112.708061218262, -1.967126761798, 218, 31, 'PPL', 'P'),
(70345, 'Woodington', 35.1738891601563, 0.61390017657627, -77.6358337402344, -1.35500091629799, 218, 33, 'PPL', 'P'),
(158456, 'Woodington', 40.1783294677734, 0.701244137163707, -84.6777801513672, -1.47790606692126, 218, 41, 'PPL', 'P'),
(153906, 'Woodinville', 41.5705604553223, 0.725543151844727, -73.6305618286133, -1.28509573400256, 218, 40, 'PPL', 'P'),
(209217, 'Woodinville', 47.7544403076172, 0.833472215815014, -122.162216186523, -2.13213289398795, 218, 56, 'PPL', 'P'),
(26209, 'Woodlake', 33.3955612182617, 0.582862498809996, -82.0772171020508, -1.43251767930498, 218, 13, 'PPL', 'P'),
(38947, 'Woodlake', 38.2105598449707, 0.666900078325073, -84.7536087036133, -1.47922952482497, 218, 21, 'PPL', 'P'),
(91985, 'Woodlake', 36.2427787780762, 0.632555819749356, -86.584716796875, -1.51118839001231, 218, 50, 'PPL', 'P'),
(99192, 'Woodlake', 31.0286102294922, 0.541551410822632, -95.0327835083008, -1.65863496955482, 218, 51, 'PPL', 'P'),
(186222, 'Woodlake', 36.4136085510254, 0.635537361747755, -119.097778320313, -2.07864836349978, 218, 6, 'PPL', 'P'),
(186223, 'Woodlake Junction', 36.413890838623, 0.635542288595771, -119.115829467773, -2.07896341545673, 218, 6, 'PPL', 'P'),
(107769, 'Woodlake Park', 36.6494407653809, 0.639653410370527, -79.3833312988281, -1.38550050236602, 218, 53, 'PPL', 'P'),
(112602, 'Woodlake Park', 33.6994400024414, 0.588166184120889, -96.5586090087891, -1.68526564834923, 218, 51, 'PPL', 'P'),
(6919, 'Woodland', 33.3741683959961, 0.582489123625167, -85.3997192382813, -1.49050628098675, 218, 2, 'PPL', 'P'),
(12934, 'Woodland', 35.524169921875, 0.620013729174656, -93.5205612182617, -1.63224171157159, 218, 4, 'PPL', 'P'),
(13255, 'Woodland', 38.8616714477539, 0.678264119591577, -76.970832824707, -1.34339446079327, 218, 9, 'PPL', 'P'),
(14902, 'Woodland', 38.5999984741211, 0.6736970646382, -75.658332824707, -1.32048701436084, 218, 10, 'PPL', 'P'),
(26212, 'Woodland', 32.7872200012207, 0.572244941597041, -84.5619430541992, -1.47588432817973, 218, 13, 'PPL', 'P'),
(44206, 'Woodland', 29.5847206115723, 0.516350782954566, -89.8252792358398, -1.5677468741887, 218, 22, 'PPL', 'P'),
(52977, 'Woodland', 38.8394393920898, 0.677876097020753, -76.0258331298828, -1.32690110468824, 218, 25, 'PPL', 'P'),
(58355, 'Woodland', 39.7527809143066, 0.693816913778613, -91.5936126708984, -1.59861011490358, 218, 29, 'PPL', 'P'),
(62373, 'Woodland', 34.1599998474121, 0.596204469818102, -88.898063659668, -1.55156390950873, 218, 30, 'PPL', 'P'),
(70347, 'Woodland', 36.3313903808594, 0.634102383973393, -77.2130584716797, -1.34762209586571, 218, 33, 'PPL', 'P'),
(84494, 'Woodland', 33.0377807617188, 0.576618051844032, -79.9066696166992, -1.39463447911472, 218, 48, 'PPL', 'P'),
(91986, 'Woodland', 35.5644416809082, 0.620716603965355, -89.0988922119141, -1.55506902897743, 218, 50, 'PPL', 'P'),
(99194, 'Woodland', 33.8069381713867, 0.590042381108849, -95.2736129760742, -1.66283823670329, 218, 51, 'PPL', 'P'),
(118515, 'Woodland', 40.6961097717285, 0.710281108269701, -93.5977783203125, -1.63358940424122, 218, 16, 'PPL', 'P'),
(122047, 'Woodland', 41.1622200012207, 0.718416266451566, -87.5491714477539, -1.52802129915632, 218, 18, 'PPL', 'P'),
(124043, 'Woodland', 41.5644416809082, 0.725436359085014, -86.1772232055664, -1.5040762851632, 218, 19, 'PPL', 'P'),
(126696, 'Woodland', 42.336109161377, 0.738904497349763, -71.2425003051758, -1.24341619767838, 218, 23, 'PPL', 'P'),
(129382, 'Woodland', 45.1569404602051, 0.788137291157622, -67.4052810668945, -1.17644408784951, 218, 26, 'PPL', 'P'),
(133793, 'Woodland', 42.7266693115234, 0.745721057896903, -85.1336135864258, -1.48586186120371, 218, 27, 'PPL', 'P'),
(138926, 'Woodland', 46.8461112976074, 0.817618883898963, -92.0822219848633, -1.60713795618817, 218, 28, 'PPL', 'P'),
(153908, 'Woodland', 42.0530586242676, 0.733964333527666, -74.3322219848633, -1.29734201395918, 218, 40, 'PPL', 'P'),
(158461, 'Woodland', 40.478889465332, 0.706489898720891, -83.2574996948242, -1.45311749665286, 218, 41, 'PPL', 'P'),
(169112, 'Woodland', 40.6944389343262, 0.710251946655764, -77.6252822875977, -1.35481675870862, 218, 45, 'PPL', 'P'),
(177124, 'Woodland', 43.3702812194824, 0.75695420479583, -88.5186080932617, -1.54494116050992, 218, 57, 'PPL', 'P'),
(186224, 'Woodland', 38.6786117553711, 0.675069125231809, -121.772216796875, -2.12532612055781, 218, 6, 'PPL', 'P'),
(195813, 'Woodland', 46.3111114501953, 0.808281375063954, -116.067497253418, -2.02575998162162, 218, 17, 'PPL', 'P'),
(206579, 'Woodland', 40.5813903808594, 0.708278877183152, -111.226387023926, -1.941266668665, 218, 52, 'PPL', 'P'),
(209218, 'Woodland', 45.9047203063965, 0.801188511553719, -122.742782592773, -2.14226568930348, 218, 56, 'PPL', 'P'),
(12935, 'Woodland (historical)', 34.5327796936035, 0.60271070551922, -92.5094375610352, -1.61459427460818, 218, 4, 'PPL', 'P'),
(70348, 'Woodland (historical)', 35.3177795410156, 0.616411537484214, -81.0458297729492, -1.41451657454881, 218, 33, 'PPL', 'P'),
(26214, 'Woodland Acres', 33.5805587768555, 0.586091315315608, -83.954719543457, -1.46528627862176, 218, 13, 'PPL', 'P'),
(52981, 'Woodland Acres', 38.3047218322754, 0.668543515033761, -76.5144424438477, -1.33542894597284, 218, 25, 'PPL', 'P'),
(70349, 'Woodland Acres', 35.8083305358887, 0.624973267493683, -77.0666732788086, -1.34506719227394, 218, 33, 'PPL', 'P'),
(84496, 'Woodland Acres', 34.6691703796387, 0.605091172059587, -82.9972229003906, -1.44857480962345, 218, 48, 'PPL', 'P'),
(91988, 'Woodland Acres', 35.9000015258789, 0.626573228097575, -84.0350036621094, -1.4666875008293, 218, 50, 'PPL', 'P'),
(107768, 'Woodland Acres', 38.9124984741211, 0.679151218550683, -77.1455612182617, -1.34644404655751, 218, 53, 'PPL', 'P'),
(122048, 'Woodland Acres', 41.9211082458496, 0.73166136497502, -89.1333312988281, -1.55567010443546, 218, 18, 'PPL', 'P'),
(112126, 'Woodland Addition', 39.0666694641113, 0.681842009937071, -80.4438934326172, -1.40401080352261, 218, 58, 'PPL', 'P'),
(122049, 'Woodland Addition', 41.2991714477539, 0.720806520108939, -88.8333282470703, -1.55043406341626, 218, 18, 'PPL', 'P'),
(14903, 'Woodland Beach', 39.3333282470703, 0.686496083679067, -75.4749984741211, -1.31728722631111, 218, 10, 'PPL', 'P'),
(52983, 'Woodland Beach', 38.9322204589844, 0.679495432121575, -76.5536117553711, -1.33611257942466, 218, 25, 'PPL', 'P'),
(133795, 'Woodland Beach', 42.0819396972656, 0.734468403342991, -86.1916732788086, -1.50432848651843, 218, 27, 'PPL', 'P'),
(129383, 'Woodland Center', 46.8852806091309, 0.818302517350786, -68.1425018310547, -1.18931101749817, 218, 26, 'PPL', 'P'),
(12936, 'Woodland Corner', 35.9666709899902, 0.627736829756858, -90.0366668701172, -1.57143628440484, 218, 4, 'PPL', 'P'),
(177125, 'Woodland Corner', 46.1433296203613, 0.80535302970833, -92.2383270263672, -1.60986250314138, 218, 57, 'PPL', 'P'),
(14904, 'Woodland Court Mobile Home Park', 39.3066711425781, 0.68603082943663, -75.5833282470703, -1.31917793752701, 218, 10, 'PPL', 'P'),
(91989, 'Woodland Cove', 35.7683296203613, 0.624275119813919, -84.6430587768555, -1.47730006461521, 218, 50, 'PPL', 'P'),
(84498, 'Woodland Estates', 32.9805603027344, 0.575619366435253, -80.1986083984375, -1.39972977207031, 218, 48, 'PPL', 'P'),
(91990, 'Woodland Estates', 36.0999984741211, 0.630063833338342, -85.4763870239258, -1.49184438627646, 218, 50, 'PPL', 'P'),
(206582, 'Woodland Estates', 41.1566696166992, 0.718319393966914, -111.912498474121, -1.95324157250654, 218, 52, 'PPL', 'P'),
(206583, 'Woodland Estates East', 40.6399993896484, 0.709301797357851, -111.936393737793, -1.95365862353325, 218, 52, 'PPL', 'P'),
(53015, 'Woodland Farms', 38.7625007629395, 0.676533264620107, -76.095832824707, -1.32812282983831, 218, 25, 'PPL', 'P'),
(84499, 'Woodland Forest', 34.2041702270508, 0.596975388374653, -80.6736068725586, -1.40802005938567, 218, 48, 'PPL', 'P'),
(158457, 'Woodland Forest', 41.5422210693359, 0.725048536251272, -83.4261093139648, -1.45606028965739, 218, 41, 'PPL', 'P'),
(12937, 'Woodland Heights', 34.7936096191406, 0.607263046507574, -92.3983306884766, -1.61265509386043, 218, 4, 'PPL', 'P'),
(14905, 'Woodland Heights', 38.5633316040039, 0.673057107028254, -75.5749969482422, -1.31903252893149, 218, 10, 'PPL', 'P'),
(52985, 'Woodland Heights', 39.690559387207, 0.692730943265106, -77.2855606079102, -1.34888749685766, 218, 25, 'PPL', 'P'),
(91994, 'Woodland Heights', 35.7561111450195, 0.624061867189631, -87.477783203125, -1.52677533924032, 218, 50, 'PPL', 'P'),
(99195, 'Woodland Heights', 31.6777801513672, 0.552881563364265, -98.9644393920898, -1.72725530978234, 218, 51, 'PPL', 'P'),
(169113, 'Woodland Heights', 41.4097213745117, 0.722735980318701, -79.7119369506836, -1.39123575293156, 218, 45, 'PPL', 'P'),
(179571, 'Woodland Heights', 33.3902816772461, 0.582770353436279, -111.757499694824, -1.95053633347124, 218, 5, 'PPL', 'P'),
(12939, 'Woodland Hills', 34.6083297729492, 0.604029303153945, -92.4513931274414, -1.61358120812951, 218, 4, 'PPL', 'P'),
(26217, 'Woodland Hills', 34.9791717529297, 0.610501716709219, -85.3127822875977, -1.48898894495568, 218, 13, 'PPL', 'P'),
(38948, 'Woodland Hills', 38.2402801513672, 0.667418795526393, -85.524169921875, -1.49267835517182, 218, 21, 'PPL', 'P'),
(52986, 'Woodland Hills', 38.7030601501465, 0.675495830217467, -76.5652770996094, -1.33631617809, 218, 25, 'PPL', 'P'),
(70350, 'Woodland Hills', 35.3616714477539, 0.617177595771776, -82.5369415283203, -1.44054138419523, 218, 33, 'PPL', 'P'),
(74875, 'Woodland Hills', 39.790828704834, 0.694480972996424, -84.0752792358398, -1.46739044219903, 218, 41, 'PPL', 'P'),
(84505, 'Woodland Hills', 34.0347213745117, 0.59401794798412, -81.1272201538086, -1.41593710467426, 218, 48, 'PPL', 'P'),
(99197, 'Woodland Hills', 31.9019393920898, 0.556793880163646, -97.333610534668, -1.69879197668379, 218, 51, 'PPL', 'P'),
(118516, 'Woodland Hills', 41.5533294677734, 0.725242414378629, -93.4619369506836, -1.63121852508078, 218, 16, 'PPL', 'P'),
(122052, 'Woodland Hills', 41.7991714477539, 0.729533166368911, -89.6486129760742, -1.56466346627861, 218, 18, 'PPL', 'P'),
(124044, 'Woodland Hills', 41.6452789306641, 0.726847235251511, -85.4319381713867, -1.49106860745092, 218, 19, 'PPL', 'P'),
(186225, 'Woodland Hills', 34.1683311462402, 0.59634987841362, -118.605003356934, -2.07004781791742, 218, 6, 'PPL', 'P'),
(206585, 'Woodland Hills', 40.0130615234375, 0.698359667387043, -111.675277709961, -1.94910128911785, 218, 52, 'PPL', 'P'),
(26219, 'Woodland Hills Mobile Home Park', 33.6166687011719, 0.586721552387575, -84.4216690063477, -1.47343608418962, 218, 13, 'PPL', 'P'),
(206587, 'Woodland Hills One', 41.1563911437988, 0.718314533697925, -111.915557861328, -1.9532949688864, 218, 52, 'PPL', 'P'),
(206588, 'Woodland Hills Two', 41.1588897705078, 0.718358142960775, -111.919998168945, -1.95337246687412, 218, 52, 'PPL', 'P'),
(122053, 'Woodland Junction', 40.6972198486328, 0.710300482766631, -87.730827331543, -1.53119179243406, 218, 18, 'PPL', 'P'),
(129384, 'Woodland Junction', 45.170280456543, 0.788370118015922, -67.4072189331055, -1.17647790999535, 218, 26, 'PPL', 'P'),
(84507, 'Woodland Landing', 33.0455589294434, 0.576753806480599, -79.9158325195313, -1.39479440193818, 218, 48, 'PPL', 'P'),
(6928, 'Woodland Landing (historical)', 34.7400016784668, 0.606327411437602, -87.8269424438477, -1.5328693176047, 218, 2, 'PPL', 'P'),
(6929, 'Woodland Mills', 34.4741706848145, 0.601687785344521, -86.6947174072266, -1.51310826284215, 218, 2, 'PPL', 'P'),
(91995, 'Woodland Mills', 36.4883308410645, 0.636841511733567, -89.1149978637695, -1.55535012563049, 218, 50, 'PPL', 'P'),
(118517, 'Woodland Mobile Home Park', 41.1902809143066, 0.718906021776031, -91.1999969482422, -1.59174022455561, 218, 16, 'PPL', 'P'),
(38949, 'Woodland Park', 37.2466697692871, 0.650077022877097, -83.1777801513672, -1.45172612814134, 218, 21, 'PPL', 'P'),
(74876, 'Woodland Park', 39.1972198486328, 0.684120543986716, -84.0686111450195, -1.46727406205939, 218, 41, 'PPL', 'P'),
(107773, 'Woodland Park', 38.9172210693359, 0.679233643386421, -78.1800003051758, -1.36449841453549, 218, 53, 'PPL', 'P'),
(112128, 'Woodland Park', 39.2902793884277, 0.685744739356528, -81.5122222900391, -1.42265665957869, 218, 58, 'PPL', 'P'),
(124046, 'Woodland Park', 41.5544395446777, 0.72526178887556, -85.2397232055664, -1.48771382342575, 218, 19, 'PPL', 'P'),
(126697, 'Woodland Park', 42.226390838623, 0.736989551367942, -71.8313903808594, -1.25369426843138, 218, 23, 'PPL', 'P'),
(133796, 'Woodland Park', 43.7147216796875, 0.762965824903493, -85.8613891601563, -1.4985639411809, 218, 27, 'PPL', 'P'),
(144701, 'Woodland Park', 42.8708305358887, 0.748237145915782, -71.5124969482422, -1.24812852806922, 218, 36, 'PPL', 'P'),
(146672, 'Woodland Park', 40.7027816772461, 0.710397554988364, -74.3791732788086, -1.2981614686266, 218, 37, 'PPL', 'P'),
(169114, 'Woodland Park', 41.2936096191406, 0.720709447887206, -77.057502746582, -1.34490713629243, 218, 45, 'PPL', 'P'),
(187558, 'Woodland Park', 38.9938888549805, 0.680571748676131, -105.05638885498, -1.83357988577488, 218, 7, 'PPL', 'P'),
(195814, 'Woodland Park', 47.4861106872559, 0.828788980459082, -115.901107788086, -2.02285593761094, 218, 17, 'PPL', 'P'),
(209219, 'Woodland Park', 45.9905586242676, 0.802686672824943, -122.47444152832, -2.13758225421047, 218, 56, 'PPL', 'P'),
(52987, 'Woodland Point', 38.2761116027832, 0.668044172329371, -76.8819427490234, -1.34184303630024, 218, 25, 'PPL', 'P'),
(52988, 'Woodland Run', 39.4730606079102, 0.688934873447307, -76.290283203125, -1.33151662917346, 218, 25, 'PPL', 'P'),
(122054, 'Woodland Shores', 41.8147201538086, 0.72980454248399, -89.561393737793, -1.56314120339952, 218, 18, 'PPL', 'P'),
(26221, 'Woodland Springs', 34.0161094665527, 0.593693108910157, -83.8974990844727, -1.46428759321298, 218, 13, 'PPL', 'P'),
(14907, 'Woodland Station', 38.6330604553223, 0.674274105067393, -75.6511077880859, -1.32036091368322, 218, 10, 'PPL', 'P'),
(118518, 'Woodland Terraces Mobile Home Park', 42.4972190856934, 0.741716395986723, -92.3000030517578, -1.61093895285399, 218, 16, 'PPL', 'P'),
(70352, 'Woodland Trace', 35.351390838623, 0.616998165293332, -82.4397201538086, -1.43884455110669, 218, 33, 'PPL', 'P'),
(44211, 'Woodland View', 30.5450000762939, 0.533110821353249, -91.0058288574219, -1.58835135206848, 218, 22, 'PPL', 'P'),
(79438, 'Woodland View', 39.9980583190918, 0.698097812072861, -76.7347183227539, -1.33927348532248, 218, 45, 'PPL', 'P'),
(52989, 'Woodland Village', 39.2013893127441, 0.684193314863502, -76.7844390869141, -1.34014127636368, 218, 25, 'PPL', 'P'),
(84511, 'Woodland Village', 34.7694396972656, 0.606841201790906, -82.2480621337891, -1.43549948761949, 218, 48, 'PPL', 'P'),
(52990, 'Woodland Way', 39.5361099243164, 0.690035291609727, -77.5777816772461, -1.35398771666127, 218, 25, 'PPL', 'P'),
(26222, 'Woodlands', 33.8777809143066, 0.591278820223946, -83.4444427490234, -1.45638026846237, 218, 13, 'PPL', 'P'),
(52991, 'Woodlands', 39.3855590820313, 0.687407683720201, -76.8166732788086, -1.34070386914396, 218, 25, 'PPL', 'P'),
(91997, 'Woodlands', 36.0055618286133, 0.628415602939692, -84.9180603027344, -1.48209974668981, 218, 50, 'PPL', 'P'),
(107774, 'Woodlands', 37.3450012207031, 0.651793230462571, -79.2941665649414, -1.38394428418303, 218, 53, 'PPL', 'P'),
(112129, 'Woodlands', 39.8066711425781, 0.694757475696601, -80.8172225952148, -1.41052662660366, 218, 58, 'PPL', 'P'),
(144702, 'Woodlands', 43.5311088562012, 0.759761176584773, -71.2694396972656, -1.24388637876884, 218, 36, 'PPL', 'P'),
(153917, 'Woodlands', 41.023609161377, 0.715997050917338, -73.8349990844727, -1.28866383723105, 218, 40, 'PPL', 'P'),
(186226, 'Woodlands', 34.2449989318848, 0.597687983703331, -116.800559997559, -2.03855434013058, 218, 6, 'PPL', 'P'),
(58356, 'Woodlandville', 39.0622215270996, 0.681764378791296, -92.4836120605469, -1.61414353459368, 218, 29, 'PPL', 'P'),
(146673, 'Woodlane', 40.0116691589355, 0.698335366042096, -74.8019409179688, -1.30554015590082, 218, 37, 'PPL', 'P'),
(6937, 'Woodlawn', 34.8375015258789, 0.608029104795136, -87.6036071777344, -1.5289713818752, 218, 2, 'PPL', 'P'),
(12947, 'Woodlawn', 34.9222183227539, 0.609507691832347, -91.873893737793, -1.60350194235189, 218, 4, 'PPL', 'P'),
(18665, 'Woodlawn', 29.9311103820801, 0.522396424945155, -81.3441696166992, -1.41972358711214, 218, 12, 'PPL', 'P'),
(26223, 'Woodlawn', 33.7038917541504, 0.588243881845692, -82.4441680908203, -1.43892218225246, 218, 13, 'PPL', 'P'),
(29023, 'Woodlawn', 38.3300018310547, 0.66898473424736, -89.0325012207031, -1.55391028758714, 218, 18, 'PPL', 'P'),
(34466, 'Woodlawn', 39.7833290100098, 0.694350078628847, -95.8644409179688, -1.67315012960213, 218, 20, 'PPL', 'P'),
(38952, 'Woodlawn', 37.813060760498, 0.659962410527362, -85.3652801513672, -1.48990520552872, 218, 21, 'PPL', 'P'),
(44218, 'Woodlawn', 30.061939239502, 0.524679819263789, -92.0769424438477, -1.60704581081446, 218, 22, 'PPL', 'P'),
(52995, 'Woodlawn', 38.9494400024414, 0.679795969850591, -76.8916702270508, -1.34201281281973, 218, 25, 'PPL', 'P'),
(58357, 'Woodlawn', 39.5783309936523, 0.690772188283352, -92.2125015258789, -1.60941176312688, 218, 29, 'PPL', 'P'),
(62381, 'Woodlawn', 32.8608283996582, 0.573529650506895, -90.2805633544922, -1.57569308109123, 218, 30, 'PPL', 'P'),
(70354, 'Woodlawn', 35.7852783203125, 0.624570930431999, -82.0405578613281, -1.43187785485309, 218, 33, 'PPL', 'P'),
(74877, 'Woodlawn', 39.2519416809082, 0.685075620132646, -84.4702835083008, -1.47428456731292, 218, 41, 'PPL', 'P'),
(84514, 'Woodlawn', 33.6258316040039, 0.586881475211034, -82.1322174072266, -1.4334776157199, 218, 48, 'PPL', 'P'),
(92003, 'Woodlawn', 35.1691703796387, 0.613817818319559, -87.727783203125, -1.53113866237031, 218, 50, 'PPL', 'P'),
(99199, 'Woodlawn', 32.6680603027344, 0.57016521252277, -94.3455581665039, -1.64664062463732, 218, 51, 'PPL', 'P'),
(107780, 'Woodlawn', 37.2944412231445, 0.650910792035373, -80.0911102294922, -1.39785357508235, 218, 53, 'PPL', 'P'),
(133798, 'Woodlawn', 45.9444389343262, 0.801881732385466, -87.3002777099609, -1.52367728394423, 218, 27, 'PPL', 'P'),
(143423, 'Woodlawn', 40.8800010681152, 0.71349061685741, -96.7788925170898, -1.68911032085692, 218, 35, 'PPL', 'P'),
(153911, 'Woodlawn', 42.797779083252, 0.746962157543907, -78.8469390869141, -1.37613869218606, 218, 40, 'PPL', 'P'),
(169117, 'Woodlawn', 40.6133308410645, 0.708836343378333, -75.523063659668, -1.31812612205448, 218, 45, 'PPL', 'P'),
(169680, 'Woodlawn', 41.8666687011719, 0.730711215677107, -71.3997192382813, -1.24616018570755, 218, 47, 'PPL', 'P'),
(177128, 'Woodlawn', 45.4322204589844, 0.792941833501207, -88.8213882446289, -1.55022567106096, 218, 57, 'PPL', 'P'),
(209220, 'Woodlawn', 47.0008316040039, 0.820319262665276, -123.879722595215, -2.16210903574371, 218, 56, 'PPL', 'P'),
(211315, 'Woodlawn', 21.3177795410156, 0.372065442205008, -157.805282592773, -2.75422175828399, 218, 15, 'PPL', 'P'),
(12942, 'Woodlawn (historical)', 33.517219543457, 0.584985837147116, -93.121940612793, -1.62528446953986, 218, 4, 'PPL', 'P'),
(26225, 'Woodlawn Acres', 33.5805587768555, 0.586091315315608, -84.2652816772461, -1.47070661038839, 218, 13, 'PPL', 'P'),
(44220, 'Woodlawn Acres', 30.3827800750732, 0.530279548219358, -91.003059387207, -1.5883030156947, 218, 22, 'PPL', 'P'),
(12943, 'Woodlawn Addition', 35.0291709899902, 0.611374368019411, -92.0663909912109, -1.60686165322508, 218, 4, 'PPL', 'P'),
(18666, 'Woodlawn Beach', 30.3880596160889, 0.530371693593075, -86.9908294677734, -1.51827639325355, 218, 12, 'PPL', 'P'),
(133799, 'Woodlawn Beach', 42.4219398498535, 0.740402525462933, -85.4175033569336, -1.4908166724118, 218, 27, 'PPL', 'P'),
(12944, 'Woodlawn Estates', 34.922779083252, 0.609517478949353, -91.998893737793, -1.60568360391688, 218, 4, 'PPL', 'P'),
(26226, 'Woodlawn Estates', 32.4952812194824, 0.567149648641446, -84.915283203125, -1.48205127715797, 218, 13, 'PPL', 'P'),
(44222, 'Woodlawn Estates', 30.3938903808594, 0.530473459636229, -91.0233306884766, -1.58865681664551, 218, 22, 'PPL', 'P'),
(71603, 'Woodlawn Estates', 39.9736099243164, 0.697671107087203, -74.2050018310547, -1.29512160340033, 218, 37, 'PPL', 'P'),
(143424, 'Woodlawn Estates', 40.836669921875, 0.712734345686854, -96.7191696166992, -1.68806795960626, 218, 35, 'PPL', 'P'),
(52997, 'Woodlawn Farms', 38.7252807617188, 0.67588365305121, -76.6402816772461, -1.33762525492383, 218, 25, 'PPL', 'P'),
(107782, 'Woodlawn Farms', 38.7155609130859, 0.675714009689772, -77.5730590820313, -1.35390529182554, 218, 53, 'PPL', 'P'),
(31559, 'Woodlawn Grove', 38.5780601501465, 0.673314168652474, -86.4580612182617, -1.50897783314949, 218, 19, 'PPL', 'P'),
(6939, 'Woodlawn Heights', 33.5333290100098, 0.585267000379201, -86.7472229003906, -1.51402465657324, 218, 2, 'PPL', 'P'),
(52998, 'Woodlawn Heights', 39.1925010681152, 0.684038185730005, -76.6494369506836, -1.33778504458923, 218, 25, 'PPL', 'P'),
(124047, 'Woodlawn Heights', 40.1188888549805, 0.700206702761067, -85.6936111450195, -1.4956356624043, 218, 19, 'PPL', 'P'),
(107784, 'Woodlawn Manor', 38.711109161377, 0.675636311964969, -77.1191711425781, -1.34598345284699, 218, 53, 'PPL', 'P'),
(107785, 'Woodlawn Meadows', 38.7236099243164, 0.675854491437274, -77.4508285522461, -1.35177196663433, 218, 53, 'PPL', 'P'),
(138929, 'Woodlawn Mobile Home Court', 45.9305610656738, 0.801639517884324, -95.4958267211914, -1.66671659819877, 218, 28, 'PPL', 'P'),
(38953, 'Woodlawn Park', 38.2613906860352, 0.667787243863205, -85.6291732788086, -1.49451100947596, 218, 21, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(77717, 'Woodlawn Park', 35.5113906860352, 0.619790689433361, -97.6497192382813, -1.70430911435606, 218, 42, 'PPL', 'P'),
(107786, 'Woodlawn Park', 36.7261085510254, 0.640991515660237, -78.945556640625, -1.37785989319858, 218, 53, 'PPL', 'P'),
(92005, 'Woodlawn Subdivision', 35.0402793884277, 0.611568246146769, -86.5763931274414, -1.51104311457484, 218, 50, 'PPL', 'P'),
(26227, 'Woodlawn Terrace', 32.0924987792969, 0.560119768890991, -81.1788864135742, -1.41683885101936, 218, 13, 'PPL', 'P'),
(107787, 'Woodlawn Terrace', 37.524169921875, 0.654920314214542, -77.3022232055664, -1.3491783140487, 218, 53, 'PPL', 'P'),
(53000, 'Woodlea', 39.4438896179199, 0.688425743625911, -76.352783203125, -1.33260745995595, 218, 25, 'PPL', 'P'),
(107788, 'Woodlea', 38.5902786254883, 0.673527421276762, -77.334716796875, -1.34974543420283, 218, 53, 'PPL', 'P'),
(792, 'Woodleaf', 35.7688903808594, 0.624284906930925, -80.5911102294922, -1.40658022134232, 218, 33, 'PPL', 'P'),
(53001, 'Woodleaf', 39.4808311462402, 0.689070494925819, -76.8580627441406, -1.34142625158964, 218, 25, 'PPL', 'P'),
(179572, 'Woodleaf', 33.5222206115723, 0.585073122251843, -111.90389251709, -1.95309137022106, 218, 5, 'PPL', 'P'),
(186228, 'Woodleaf', 39.5175018310547, 0.689710519114792, -121.190559387207, -2.11517428364048, 218, 6, 'PPL', 'P'),
(179573, 'Woodleaf II', 33.5933303833008, 0.586314221898847, -111.962501525879, -1.95411429039576, 218, 5, 'PPL', 'P'),
(107789, 'Woodlee', 38.1661109924316, 0.666124299499533, -79.0580596923828, -1.3798234418703, 218, 53, 'PPL', 'P'),
(53002, 'Woodleigh', 39.2030601501465, 0.684222476477439, -76.8730621337891, -1.3416880403248, 218, 25, 'PPL', 'P'),
(70359, 'Woodley', 35.8933296203613, 0.626456781378911, -76.3499984741211, -1.33255885726606, 218, 33, 'PPL', 'P'),
(107790, 'Woodley', 38.8638916015625, 0.678302868585438, -77.1944427490234, -1.34729719021272, 218, 53, 'PPL', 'P'),
(53003, 'Woodley Gardens', 39.098331451416, 0.682394615863263, -77.1730575561523, -1.34692394818595, 218, 25, 'PPL', 'P'),
(107792, 'Woodley Hills', 38.7238883972168, 0.675859351706263, -77.1022186279297, -1.34568757564988, 218, 53, 'PPL', 'P'),
(107793, 'Woodley North', 38.8691711425781, 0.678395013959155, -77.1911087036133, -1.3472390001429, 218, 53, 'PPL', 'P'),
(13256, 'Woodley Park', 38.9286117553711, 0.679432448361795, -77.0561065673828, -1.34488276836846, 218, 9, 'PPL', 'P'),
(99200, 'Woodloch', 30.2177791595459, 0.527399738974601, -95.4138870239258, -1.6652864806934, 218, 51, 'PPL', 'P'),
(53004, 'Woodlore', 39.0011100769043, 0.680697782774719, -76.5516662597656, -1.33607862412076, 218, 25, 'PPL', 'P'),
(74879, 'Woodlyn', 39.5699996948242, 0.690626779687834, -83.1141662597656, -1.45061585628289, 218, 41, 'PPL', 'P'),
(79440, 'Woodlyn', 39.8877792358398, 0.696173078974033, -75.350830078125, -1.31512007897406, 218, 45, 'PPL', 'P'),
(53005, 'Woodlyn Heights', 39.6944389343262, 0.692798654135821, -76.0930633544922, -1.32807449346453, 218, 25, 'PPL', 'P'),
(53006, 'Woodlyn Meadows', 39.4902801513672, 0.689235411176322, -76.416389465332, -1.33371759865635, 218, 25, 'PPL', 'P'),
(38954, 'Woodman', 37.521110534668, 0.654866917834686, -82.0447235107422, -1.43195055915085, 218, 21, 'PPL', 'P'),
(112130, 'Woodman', 37.9119415283203, 0.661688205492761, -80.315559387207, -1.4017709518878, 218, 58, 'PPL', 'P'),
(144703, 'Woodman', 43.6347198486328, 0.761569529543964, -70.9833297729492, -1.23889281856688, 218, 36, 'PPL', 'P'),
(177129, 'Woodman', 43.0900001525879, 0.752062377347518, -90.8011093139648, -1.58477832199198, 218, 57, 'PPL', 'P'),
(186229, 'Woodman', 39.771110534668, 0.694136826004559, -123.388893127441, -2.15354244546526, 218, 6, 'PPL', 'P'),
(107795, 'Woodman Terrace', 37.646671295166, 0.657058366516685, -77.4911117553711, -1.35247504116211, 218, 53, 'PPL', 'P'),
(209221, 'Woodmans', 48.0158309936523, 0.838034343920374, -122.831939697266, -2.14382177432841, 218, 56, 'PPL', 'P'),
(129386, 'Woodmans Mills', 44.3655586242676, 0.774325072480035, -69.2536087036133, -1.20870349076585, 218, 26, 'PPL', 'P'),
(71605, 'Woodmansie', 39.8677787780762, 0.695824005134151, -74.4669418334961, -1.29969331888561, 218, 37, 'PPL', 'P'),
(124048, 'Woodmar', 41.5849990844727, 0.725795153462875, -87.4902801513672, -1.5269934521336, 218, 19, 'PPL', 'P'),
(53007, 'Woodmark', 39.273609161377, 0.685453789007437, -76.9355621337891, -1.34277887110729, 218, 25, 'PPL', 'P'),
(18667, 'Woodmere', 27.0202808380127, 0.471592865436854, -82.3908309936523, -1.43799127429342, 218, 12, 'PPL', 'P'),
(26229, 'Woodmere', 33.8772201538086, 0.59126903310694, -84.477783203125, -1.47441546168049, 218, 13, 'PPL', 'P'),
(44223, 'Woodmere', 29.857780456543, 0.521116576304291, -90.0802764892578, -1.57219741584439, 218, 22, 'PPL', 'P'),
(107796, 'Woodmere', 37.1994400024414, 0.64925270794069, -77.3827819824219, -1.35058432994621, 218, 53, 'PPL', 'P'),
(144704, 'Woodmere', 42.7833290100098, 0.746709956188676, -72.0086135864258, -1.25678739687945, 218, 36, 'PPL', 'P'),
(146674, 'Woodmere', 40.0880584716797, 0.699668611062817, -74.3211135864258, -1.29714813583182, 218, 37, 'PPL', 'P'),
(153912, 'Woodmere', 40.6319389343262, 0.709161115873268, -73.7130584716797, -1.28653557204591, 218, 40, 'PPL', 'P'),
(158458, 'Woodmere', 41.4622192382813, 0.723652240891743, -81.480827331543, -1.42210871418441, 218, 41, 'PPL', 'P'),
(6945, 'Woodmont', 33.4486083984375, 0.583788346762962, -86.9930572509766, -1.51831527540547, 218, 2, 'PPL', 'P'),
(53010, 'Woodmont', 39.6316719055176, 0.691703162821417, -78.304443359375, -1.3666703555625, 218, 25, 'PPL', 'P'),
(107797, 'Woodmont', 38.9005584716797, 0.678942826195384, -77.0952835083008, -1.34556653497833, 218, 53, 'PPL', 'P'),
(112131, 'Woodmont', 39.6283302307129, 0.691644839593544, -78.3111114501953, -1.36678673570214, 218, 58, 'PPL', 'P'),
(114324, 'Woodmont', 41.2280616760254, 0.719565420461935, -72.991943359375, -1.2739497390503, 218, 8, 'PPL', 'P'),
(169118, 'Woodmont', 40.1575012207031, 0.700880615674912, -75.0727767944336, -1.31026713367766, 218, 45, 'PPL', 'P'),
(209222, 'Woodmont Beach', 47.3616714477539, 0.826617106011095, -122.310829162598, -2.13472667973163, 218, 56, 'PPL', 'P'),
(107798, 'Woodmont Manor', 37.228328704834, 0.649756910914069, -80.0166702270508, -1.39655435194455, 218, 53, 'PPL', 'P'),
(53013, 'Woodmoor', 39.6127815246582, 0.691373463478465, -77.7591705322266, -1.35715354940711, 218, 25, 'PPL', 'P'),
(187559, 'Woodmoor', 39.101390838623, 0.682448012243119, -104.846939086914, -1.82992429770459, 218, 7, 'PPL', 'P'),
(53014, 'Woodmore', 38.9211082458496, 0.67930148741519, -76.8033294677734, -1.34047097570663, 218, 25, 'PPL', 'P'),
(92008, 'Woodmore', 35.0369415283203, 0.611509989497924, -85.2244415283203, -1.48744710784258, 218, 50, 'PPL', 'P'),
(112132, 'Woodpeck', 37.6933288574219, 0.657872694599004, -81.1963882446289, -1.41714431559639, 218, 58, 'PPL', 'P'),
(26230, 'Woodpin Estates', 34.2180595397949, 0.597217802612877, -85.1463928222656, -1.486084900945, 218, 13, 'PPL', 'P'),
(146675, 'Woodport', 40.985279083252, 0.71532806485151, -74.6108322143555, -1.30220467979355, 218, 37, 'PPL', 'P'),
(13257, 'Woodridge', 38.9311103820801, 0.679476057624645, -76.9713897705078, -1.34340418133124, 218, 9, 'PPL', 'P'),
(53019, 'Woodridge', 38.5291709899902, 0.672460891839213, -76.5972213745117, -1.33687371086421, 218, 25, 'PPL', 'P'),
(84519, 'Woodridge', 35.0616683959961, 0.611941554752571, -82.1152801513672, -1.43318200483891, 218, 48, 'PPL', 'P'),
(107799, 'Woodridge', 37.8969383239746, 0.661426350178578, -78.436393737793, -1.36897332411515, 218, 53, 'PPL', 'P'),
(122059, 'Woodridge', 42.1527786254883, 0.73570477587906, -87.8091735839844, -1.53255919249576, 218, 18, 'PPL', 'P'),
(153913, 'Woodridge', 41.7105598449707, 0.727986602144874, -74.5747222900391, -1.30157444272159, 218, 40, 'PPL', 'P'),
(206595, 'Woodridge', 40.6361083984375, 0.709233886750054, -111.855003356934, -1.9522380934078, 218, 52, 'PPL', 'P'),
(53017, 'Woodridge Acres', 38.5586090087891, 0.672974682192516, -76.7819366455078, -1.3400976005218, 218, 25, 'PPL', 'P'),
(206596, 'Woodridge Country Estates', 40.5683288574219, 0.708050910593841, -111.869171142578, -1.95248536791502, 218, 52, 'PPL', 'P'),
(26231, 'Woodridge Estates', 32.0052795410156, 0.558597506011902, -80.9622192382813, -1.4130572954295, 218, 13, 'PPL', 'P'),
(169119, 'Woodridge Estates', 40.3205604553223, 0.703726536194798, -76.8616714477539, -1.34148923534942, 218, 45, 'PPL', 'P'),
(179574, 'Woodridge Lakes', 33.4388885498047, 0.583618703401524, -111.802223205566, -1.95131690598674, 218, 5, 'PPL', 'P'),
(53018, 'Woodridge Manor', 39.5055618286133, 0.689502126759494, -76.3777770996094, -1.33304368574251, 218, 25, 'PPL', 'P'),
(26232, 'Woodridge North', 33.8838882446289, 0.591385413246576, -83.4111099243164, -1.45579850092224, 218, 13, 'PPL', 'P'),
(206599, 'Woodridge Terrace', 40.7008285522461, 0.710363466526411, -111.79167175293, -1.95113274839736, 218, 52, 'PPL', 'P'),
(206600, 'Woodridge Twin Homes', 41.0013885498047, 0.715609228083595, -111.902778625488, -1.95307192914511, 218, 52, 'PPL', 'P'),
(179575, 'Woodridge VI', 33.6583290100098, 0.587448661944194, -112.169441223145, -1.95772606946613, 218, 5, 'PPL', 'P'),
(143425, 'Woodriver Valley Mobile Park', 40.8205604553223, 0.712453182454769, -98.5997161865234, -1.72088968898678, 218, 35, 'PPL', 'P'),
(12945, 'Woodrow', 35.663330078125, 0.622442532088808, -92.0805587768555, -1.60710892773229, 218, 4, 'PPL', 'P'),
(38955, 'Woodrow', 37.7413902282715, 0.658711523763352, -86.3197174072266, -1.50656327814717, 218, 21, 'PPL', 'P'),
(70363, 'Woodrow', 35.4761085510254, 0.619174900010308, -82.8899993896484, -1.44670340632546, 218, 33, 'PPL', 'P'),
(84521, 'Woodrow', 34.0947189331055, 0.595065102924739, -80.378059387207, -1.4028617826703, 218, 48, 'PPL', 'P'),
(92010, 'Woodrow', 36.5166702270508, 0.637336127327022, -82.4644393920898, -1.43927598320328, 218, 50, 'PPL', 'P'),
(112135, 'Woodrow', 39.4991683959961, 0.689390540309819, -78.4366683959961, -1.36897811780511, 218, 58, 'PPL', 'P'),
(138930, 'Woodrow', 46.3883285522461, 0.809629067733589, -94.0741729736328, -1.64190405948056, 218, 28, 'PPL', 'P'),
(153914, 'Woodrow', 40.5433311462402, 0.707614618228259, -74.1980590820313, -1.29500042957073, 218, 40, 'PPL', 'P'),
(169120, 'Woodrow', 40.2838897705078, 0.703086512005824, -80.3652801513672, -1.402638742929, 218, 45, 'PPL', 'P'),
(187560, 'Woodrow', 39.9883308410645, 0.697928035553368, -103.591110229492, -1.80800594930102, 218, 7, 'PPL', 'P'),
(192976, 'Woodrow', 33.4466705322266, 0.583754524617118, -101.843612670898, -1.77750636323299, 218, 51, 'PPL', 'P'),
(212241, 'Woodrow', 60.1916694641113, 1.05054281442087, -149.375, -2.60708557016653, 218, 1, 'PPL', 'P'),
(513, 'Woodruff', 39.9927787780762, 0.698005666699144, -99.4261093139648, -1.73531296997649, 218, 20, 'PPL', 'P'),
(58359, 'Woodruff', 39.4438896179199, 0.688425743625911, -94.8163909912109, -1.65485820765492, 218, 29, 'PPL', 'P'),
(79441, 'Woodruff', 39.8441696166992, 0.695411947534488, -80.3183288574219, -1.40181928826159, 218, 45, 'PPL', 'P'),
(84522, 'Woodruff', 34.7394409179688, 0.606317624320596, -82.0372161865234, -1.43181953162522, 218, 48, 'PPL', 'P'),
(112134, 'Woodruff', 39.771671295166, 0.694146613121564, -80.5380630493164, -1.40565437338936, 218, 58, 'PPL', 'P'),
(122060, 'Woodruff', 40.5380592346191, 0.707522606012597, -89.2313919067383, -1.55738158491, 218, 18, 'PPL', 'P'),
(124049, 'Woodruff', 41.5733299255371, 0.725591488218512, -85.3288879394531, -1.48927004160874, 218, 19, 'PPL', 'P'),
(146676, 'Woodruff', 40.0602798461914, 0.699183782586368, -74.4625015258789, -1.29961582089789, 218, 37, 'PPL', 'P'),
(177133, 'Woodruff', 45.8963890075684, 0.801043102958201, -89.6988906860352, -1.56554097785779, 218, 57, 'PPL', 'P'),
(179576, 'Woodruff', 34.7813911437988, 0.607049793883286, -110.042778015137, -1.92060879440537, 218, 5, 'PPL', 'P'),
(195815, 'Woodruff', 42.0361099243164, 0.733668522909586, -112.213890075684, -1.95850184829167, 218, 17, 'PPL', 'P'),
(206601, 'Woodruff', 41.5219383239746, 0.724694535563373, -111.161666870117, -1.94013708888864, 218, 52, 'PPL', 'P'),
(209223, 'Woodruff', 47.8727798461914, 0.835537630398425, -122.008331298828, -2.1294470960286, 218, 56, 'PPL', 'P'),
(6949, 'Woodruff (historical)', 33.8138885498047, 0.590163688096502, -85.892219543457, -1.49910203287915, 218, 2, 'PPL', 'P'),
(122061, 'Woodruff Corners', 42.2775001525879, 0.737881577175064, -89.4266662597656, -1.56078976531503, 218, 18, 'PPL', 'P'),
(153915, 'Woodruff Heights', 42.8797187805176, 0.74839227504928, -73.9327774047852, -1.29037039085757, 218, 40, 'PPL', 'P'),
(209224, 'Woodruff Mill', 45.8574981689453, 0.800364329775367, -121.148330688477, -2.1144372538088, 218, 56, 'PPL', 'P'),
(31560, 'Woodruff Place', 39.7775001525879, 0.694248345875206, -86.1283264160156, -1.50322287519188, 218, 19, 'PPL', 'P'),
(18668, 'Woodruff Springs', 28.8077793121338, 0.502790599184642, -81.3450012207031, -1.41973810134008, 218, 12, 'PPL', 'P'),
(190943, 'Woodruffs (historical)', 38.9186096191406, 0.67925787815234, -118.195281982422, -2.06289683091639, 218, 39, 'PPL', 'P'),
(146677, 'Woodruffs Gap', 41.0713882446289, 0.716830953233669, -74.6555633544922, -1.30298538546711, 218, 37, 'PPL', 'P'),
(18669, 'Woodruffs Subdivision', 28.7827796936035, 0.502354273529546, -81.2699966430664, -1.41842902450625, 218, 12, 'PPL', 'P'),
(70364, 'Woodrun', 35.3250007629395, 0.616537571582802, -80.0713882446289, -1.39750936151146, 218, 33, 'PPL', 'P'),
(18670, 'Woods', 30.3472194671631, 0.529658898527315, -84.9802780151367, -1.48318565062429, 218, 12, 'PPL', 'P'),
(29025, 'Woods', 38.9444389343262, 0.679708684745863, -90.1216735839844, -1.57291993144813, 218, 18, 'PPL', 'P'),
(38957, 'Woods', 36.8608283996582, 0.643342820586668, -83.1788864135742, -1.45174543605925, 218, 21, 'PPL', 'P'),
(53045, 'Woods', 39.482780456543, 0.689104516808745, -77.4630584716797, -1.3519854189957, 218, 25, 'PPL', 'P'),
(77719, 'Woods', 35.4352798461914, 0.61846230468163, -97.2644424438477, -1.69758476576166, 218, 42, 'PPL', 'P'),
(92011, 'Woods', 35.8455581665039, 0.625623012220635, -85.9458312988281, -1.50003773452815, 218, 50, 'PPL', 'P'),
(99202, 'Woods', 32.0083312988281, 0.558650769233704, -94.2480621337891, -1.64493899785881, 218, 51, 'PPL', 'P'),
(133800, 'Woods', 43.7555618286133, 0.763678619969253, -84.8883285522461, -1.48158082975141, 218, 27, 'PPL', 'P'),
(153916, 'Woods', 43.8830604553223, 0.765903890797096, -74.6047210693359, -1.3020980201919, 218, 40, 'PPL', 'P'),
(177361, 'Woods', 46.6800003051758, 0.814719700157275, -97.188606262207, -1.69626117469989, 218, 34, 'PPL', 'P'),
(187973, 'Woods', 37.170280456543, 0.648743777856376, -101.105278015137, -1.76461999250837, 218, 20, 'PPL', 'P'),
(201830, 'Woods', 45.214168548584, 0.789136109724456, -123.95361328125, -2.16339867150158, 218, 43, 'PPL', 'P'),
(12948, 'Woods (historical)', 36.3680610656738, 0.634742408162366, -94.1511077880859, -1.64324682530218, 218, 4, 'PPL', 'P'),
(84523, 'Woods (historical)', 34.8441696166992, 0.608145484934772, -82.3555603027344, -1.43737568460745, 218, 48, 'PPL', 'P'),
(107800, 'Woods Acres', 37.6258316040039, 0.656694645290807, -77.6930618286133, -1.35599973486483, 218, 53, 'PPL', 'P'),
(112136, 'Woods and Irons', 38.4555587768555, 0.671176116350331, -81.9613876342773, -1.43049607372151, 218, 58, 'PPL', 'P'),
(112137, 'Woods and Irons East', 38.4552803039551, 0.671171256081342, -81.9569396972656, -1.43041844257573, 218, 58, 'PPL', 'P'),
(112138, 'Woods and Irons South', 38.4527816772461, 0.671127646818492, -81.9613876342773, -1.43049607372151, 218, 58, 'PPL', 'P'),
(18671, 'Woods and Lakes', 29.125560760498, 0.508336931760355, -81.8744430541992, -1.42897860453238, 218, 12, 'PPL', 'P'),
(53020, 'Woods At Bay Country', 39.3683280944824, 0.687106946254104, -76.3702774047852, -1.33291279137493, 218, 25, 'PPL', 'P'),
(197877, 'Woods Bay', 48.0016708374023, 0.837787202571215, -114.049438476563, -1.99053821146672, 218, 31, 'PPL', 'P'),
(6950, 'Woods Bluff', 31.9355602264404, 0.557380674420331, -88.0616683959961, -1.53696605830957, 218, 2, 'PPL', 'P'),
(53021, 'Woods Corner', 38.8216705322266, 0.677565971911813, -76.9211120605469, -1.34252666975206, 218, 25, 'PPL', 'P'),
(107801, 'Woods Corner', 37.5811080932617, 0.655914072775305, -78.649169921875, -1.37268696909721, 218, 53, 'PPL', 'P'),
(126700, 'Woods Corner', 42.4755592346191, 0.741338360269987, -71.2144393920898, -1.24292644235392, 218, 23, 'PPL', 'P'),
(153919, 'Woods Corner', 42.0313911437988, 0.733586164652875, -77.2949981689453, -1.34905221337108, 218, 40, 'PPL', 'P'),
(169681, 'Woods Corner', 41.6236114501953, 0.72646906637672, -71.5444412231445, -1.24868606084343, 218, 47, 'PPL', 'P'),
(133801, 'Woods Corners', 43.0761108398438, 0.751819963109293, -85.0749969482422, -1.48483880787095, 218, 27, 'PPL', 'P'),
(153918, 'Woods Corners', 42.8619384765625, 0.748081950203258, -75.1919403076172, -1.31234692933096, 218, 40, 'PPL', 'P'),
(209225, 'Woods Creek', 47.8788909912109, 0.835644290000082, -121.897216796875, -2.1275077821228, 218, 56, 'PPL', 'P'),
(206602, 'Woods Cross', 40.8716697692871, 0.713345208261891, -111.891387939453, -1.95287312416973, 218, 52, 'PPL', 'P'),
(107802, 'Woods Crossing', 37.2036094665527, 0.649325478817476, -79.9888916015625, -1.39606952346811, 218, 53, 'PPL', 'P'),
(186230, 'Woods Crossing', 37.9402809143066, 0.662182821086216, -120.433326721191, -2.10195808041486, 218, 6, 'PPL', 'P'),
(195816, 'Woods Crossing', 43.774169921875, 0.764003392464188, -111.629722595215, -1.94830620237441, 218, 17, 'PPL', 'P'),
(197878, 'Woods Crossing', 47.8777809143066, 0.835624915503152, -111.267219543457, -1.94197933057271, 218, 31, 'PPL', 'P'),
(70367, 'Woods Crossroads', 35.3258285522461, 0.616552019231716, -78.4958267211914, -1.37001062535974, 218, 33, 'PPL', 'P'),
(84524, 'Woods Crossroads', 32.9850006103516, 0.575696864422974, -81.3477783203125, -1.41978657087192, 218, 48, 'PPL', 'P'),
(107804, 'Woods Crossroads', 37.4777793884277, 0.654110646664131, -76.616943359375, -1.3372179244351, 218, 53, 'PPL', 'P'),
(14908, 'Woods Edge', 38.7005615234375, 0.675452220954617, -75.1675033569336, -1.31192042408238, 218, 10, 'PPL', 'P'),
(44224, 'Woods Edge', 30.516939163208, 0.532621066028783, -91.0363922119141, -1.58888478323482, 218, 22, 'PPL', 'P'),
(53024, 'Woods Edge', 38.3605613708496, 0.669518098834675, -75.6986083984375, -1.32118995573057, 218, 25, 'PPL', 'P'),
(153920, 'Woods Falls', 44.9266700744629, 0.784118314756583, -73.6374969482422, -1.2852167746741, 218, 40, 'PPL', 'P'),
(14909, 'Woods Haven', 38.9305610656738, 0.679466470244721, -75.4138870239258, -1.31622063029453, 218, 10, 'PPL', 'P'),
(126701, 'Woods Hole', 41.5263900756836, 0.724772233288176, -70.6736068725586, -1.23348713418624, 218, 23, 'PPL', 'P'),
(153921, 'Woods Lake', 43.8522186279297, 0.765365599361763, -74.9516677856445, -1.30815338272046, 218, 40, 'PPL', 'P'),
(53025, 'Woods Landing', 39.0302810668945, 0.681206912596115, -76.4347229003906, -1.33403757746133, 218, 25, 'PPL', 'P'),
(209843, 'Woods Landing', 41.1105613708496, 0.717514653264519, -106.01277923584, -1.85027204685528, 218, 59, 'PPL', 'P'),
(14910, 'Woods Manor', 39.1297187805176, 0.682942428099492, -75.519172668457, -1.31805821144669, 218, 10, 'PPL', 'P'),
(14911, 'Woods Manor East', 39.1308288574219, 0.682961802596422, -75.5088882446289, -1.31787871438922, 218, 10, 'PPL', 'P'),
(74881, 'Woods Mill', 38.936939239502, 0.679577790378286, -82.3397216796875, -1.4370992484863, 218, 41, 'PPL', 'P'),
(107803, 'Woods Mill', 37.8447189331055, 0.660514949874526, -78.8225021362305, -1.37571218693749, 218, 53, 'PPL', 'P'),
(144705, 'Woods Mill', 43.0416717529297, 0.751218887651262, -72.1547164916992, -1.2593373736232, 218, 36, 'PPL', 'P'),
(153922, 'Woods Mill', 44.1213912963867, 0.770063548682718, -75.57861328125, -1.31909564584933, 218, 40, 'PPL', 'P'),
(71608, 'Woods Mills', 39.6213912963867, 0.691523732342973, -75.2588882446289, -1.31351539125923, 218, 37, 'PPL', 'P'),
(153923, 'Woods Mills', 44.6925010681152, 0.780031294589693, -73.6147232055664, -1.28481929788141, 218, 40, 'PPL', 'P'),
(107805, 'Woods of Ilda', 38.8280601501465, 0.67767749178246, -77.2563934326172, -1.34837843361529, 218, 53, 'PPL', 'P'),
(53026, 'Woods of Shannon', 39.1500015258789, 0.683296428787391, -76.5788879394531, -1.33655373205923, 218, 25, 'PPL', 'P'),
(189833, 'Woods Place', 35.3616714477539, 0.617177595771776, -103.359718322754, -1.80396739866597, 218, 38, 'PPL', 'P'),
(197880, 'Woods Place', 47.502498626709, 0.829075003960157, -108.144996643066, -1.88748626097972, 218, 31, 'PPL', 'P'),
(12949, 'Woods Point Landing', 36.2941703796387, 0.633452772404495, -92.1722183227539, -1.6087086885991, 218, 4, 'PPL', 'P'),
(146678, 'Woods Tavern', 40.5022201538086, 0.706897096051564, -74.6449966430664, -1.30280096156162, 218, 37, 'PPL', 'P'),
(71609, 'Woods Upper Mill', 39.5, 0.68940505453776, -75.3783264160156, -1.31559998060249, 218, 37, 'PPL', 'P'),
(26234, 'Woods Valley', 33.6788902282715, 0.587807522901082, -84.7788925170898, -1.4796708106176, 218, 13, 'PPL', 'P'),
(92013, 'Woods Valley', 36.3016700744629, 0.633583666772073, -87.4086074829102, -1.52556799516014, 218, 50, 'PPL', 'P'),
(38958, 'Woodsbend', 37.9116706848145, 0.661683478381826, -83.3405609130859, -1.45456718839224, 218, 21, 'PPL', 'P'),
(53027, 'Woodsboro', 39.5330581665039, 0.689982028387926, -77.3150024414063, -1.34940135378999, 218, 25, 'PPL', 'P'),
(99203, 'Woodsboro', 28.2380599975586, 0.492847121333099, -97.3197174072266, -1.69854949586654, 218, 51, 'PPL', 'P'),
(53028, 'Woodsbrook', 39.5583305358887, 0.69042311444347, -76.4899978637695, -1.33500230756621, 218, 25, 'PPL', 'P'),
(153924, 'Woodsburgh', 40.6238899230957, 0.709020634125766, -73.7088928222656, -1.28646286774815, 218, 40, 'PPL', 'P'),
(53029, 'Woodsdale', 39.4619407653809, 0.688740795582867, -76.3055572509766, -1.33178321159857, 218, 25, 'PPL', 'P'),
(70371, 'Woodsdale', 36.4897193908691, 0.636865746499486, -78.9599990844727, -1.37811196139576, 218, 33, 'PPL', 'P'),
(74882, 'Woodsdale', 39.434440612793, 0.688260827375408, -84.475830078125, -1.47438137321854, 218, 41, 'PPL', 'P'),
(107806, 'Woodsdale', 36.6283302307129, 0.639284962033714, -82.2294387817383, -1.43517444880845, 218, 53, 'PPL', 'P'),
(177308, 'Woodsdale', 40.077220916748, 0.699479460046394, -80.6936111450195, -1.40836919980458, 218, 58, 'PPL', 'P'),
(53030, 'Woodsdale Meadows', 39.461109161377, 0.688726281354926, -76.3088912963867, -1.33184140166839, 218, 25, 'PPL', 'P'),
(74883, 'Woodsdale Park', 39.4277801513672, 0.688144580393826, -84.4875030517578, -1.47458510504193, 218, 41, 'PPL', 'P'),
(84525, 'Woodsen', 33.9944381713867, 0.593314873456339, -81.126106262207, -1.4159176635983, 218, 48, 'PPL', 'P'),
(74884, 'Woodsfield', 39.7625007629395, 0.693986557140051, -81.1155624389648, -1.41573363916698, 218, 41, 'PPL', 'P'),
(14912, 'Woodshade', 39.6541709899902, 0.692095845924149, -75.6833267211914, -1.32092324014739, 218, 10, 'PPL', 'P'),
(44225, 'Woodshire Village', 30.423059463501, 0.530982556168112, -91.0086135864258, -1.58839995475837, 218, 22, 'PPL', 'P'),
(14913, 'Woodside', 39.0713882446289, 0.681924368193782, -75.5686111450195, -1.31892107563987, 218, 10, 'PPL', 'P'),
(29026, 'Woodside', 39.7200012207031, 0.693244800197436, -89.6788864135742, -1.56519183743888, 218, 18, 'PPL', 'P'),
(38961, 'Woodside', 37.4075012207031, 0.652884061245068, -82.3341674804688, -1.43700230942262, 218, 21, 'PPL', 'P'),
(44226, 'Woodside', 30.8430595397949, 0.538312940358068, -91.8199996948242, -1.60256131385487, 218, 22, 'PPL', 'P'),
(53032, 'Woodside', 39.0033302307129, 0.68073653176858, -77.0380630493164, -1.34456784956955, 218, 25, 'PPL', 'P'),
(58360, 'Woodside', 36.7416687011719, 0.641263091512398, -91.3880615234375, -1.59502257059913, 218, 29, 'PPL', 'P'),
(62385, 'Woodside', 33.0152816772461, 0.5762253687413, -90.9744415283203, -1.58780353983225, 218, 30, 'PPL', 'P'),
(70374, 'Woodside', 34.4191703796387, 0.600727848929602, -77.6474990844727, -1.35520451496333, 218, 33, 'PPL', 'P'),
(84526, 'Woodside', 34.853889465332, 0.60831512829621, -82.4330596923828, -1.4387283041251, 218, 48, 'PPL', 'P'),
(126702, 'Woodside', 42.3300018310547, 0.738797904327133, -71.6297225952148, -1.25017450157668, 218, 23, 'PPL', 'P'),
(153927, 'Woodside', 40.8983306884766, 0.713810529083355, -73.790283203125, -1.2878833978736, 218, 40, 'PPL', 'P'),
(158462, 'Woodside', 41.3522186279297, 0.721732368061905, -83.4663925170898, -1.45676336418518, 218, 41, 'PPL', 'P'),
(169124, 'Woodside', 40.121940612793, 0.700259965982869, -76.7819366455078, -1.3400976005218, 218, 45, 'PPL', 'P'),
(179577, 'Woodside', 33.3902816772461, 0.582770353436279, -111.765281677246, -1.95067215468683, 218, 5, 'PPL', 'P'),
(186231, 'Woodside', 37.4300003051758, 0.6532767443478, -122.252777099609, -2.13371348009491, 218, 6, 'PPL', 'P'),
(192870, 'Woodside', 39.2655601501465, 0.685313307259935, -110.34806060791, -1.92593698079829, 218, 52, 'PPL', 'P'),
(195817, 'Woodside', 46.2063903808594, 0.806453647607833, -116.61833190918, -2.03537385999875, 218, 17, 'PPL', 'P'),
(197881, 'Woodside', 46.3133316040039, 0.808320124057815, -114.154167175293, -1.9923660720809, 218, 31, 'PPL', 'P'),
(195818, 'Woodside (historical)', 46.2733306884766, 0.807621976378051, -116.599166870117, -2.03503936696584, 218, 17, 'PPL', 'P'),
(197882, 'Woodside Crossing', 46.3127784729004, 0.808310470098863, -114.144172668457, -1.9921916350295, 218, 31, 'PPL', 'P'),
(53034, 'Woodside Estates', 39.2938919067383, 0.685807789695336, -77.0263900756836, -1.34436411774616, 218, 25, 'PPL', 'P'),
(53035, 'Woodside Forest', 39.0088882446289, 0.680833537411286, -77.0350036621094, -1.3445144531897, 218, 25, 'PPL', 'P'),
(186232, 'Woodside Glens', 37.440559387207, 0.653461035095233, -122.255561828613, -2.1337620827848, 218, 6, 'PPL', 'P'),
(206605, 'Woodside Heights', 40.6836090087891, 0.710062928797396, -111.837783813477, -1.95193755567879, 218, 52, 'PPL', 'P'),
(186233, 'Woodside Highlands', 37.389720916748, 0.652573736399046, -122.246673583984, -2.1336069536513, 218, 6, 'PPL', 'P'),
(14914, 'Woodside Hills', 39.7874984741211, 0.694422849505633, -75.4902801513672, -1.31755394189428, 218, 10, 'PPL', 'P'),
(70375, 'Woodside Hills', 35.5538902282715, 0.620532446375976, -82.6719436645508, -1.44289761596968, 218, 33, 'PPL', 'P'),
(14915, 'Woodside Manor', 39.5888900756836, 0.690956479030786, -75.7249984741211, -1.3216505494411, 218, 10, 'PPL', 'P'),
(84527, 'Woodside Manor', 33.0022201538086, 0.575997402151989, -80.1302795410156, -1.39853720853417, 218, 48, 'PPL', 'P'),
(118520, 'Woodside Mobile Estates', 40.9636116027832, 0.714949895976718, -91.5577774047852, -1.59798467152157, 218, 16, 'PPL', 'P'),
(53036, 'Woodside Park', 39.0063896179199, 0.680789928148436, -77.0305633544922, -1.34443695520198, 218, 25, 'PPL', 'P'),
(107807, 'Woodside Park', 37.3097190856934, 0.651177441039517, -80.0369415283203, -1.39690815289537, 218, 53, 'PPL', 'P'),
(124050, 'Woodside Park', 40.2905616760254, 0.703202958724488, -86.5269393920898, -1.51017998406555, 218, 19, 'PPL', 'P'),
(53037, 'Woodside Square', 39.1402816772461, 0.683126785425953, -76.6477813720703, -1.3377561492914, 218, 25, 'PPL', 'P'),
(53038, 'Woodside View', 38.7458305358887, 0.676242314271016, -76.6161117553711, -1.33720341020716, 218, 25, 'PPL', 'P'),
(26235, 'Woodsmill', 33.4083290100098, 0.583085338814208, -84.5994415283203, -1.47653880001761, 218, 13, 'PPL', 'P'),
(26236, 'Woodsmoke', 33.3474998474121, 0.582023669645648, -84.8555603027344, -1.48100891590731, 218, 13, 'PPL', 'P'),
(12950, 'Woodson', 34.5291709899902, 0.60264772175944, -92.2108306884766, -1.60938260151295, 218, 4, 'PPL', 'P'),
(29028, 'Woodson', 39.6288909912109, 0.69165462671055, -90.2188873291016, -1.57461663137862, 218, 18, 'PPL', 'P'),
(99205, 'Woodson', 33.014720916748, 0.576215581624294, -99.0538864135742, -1.72881645481335, 218, 51, 'PPL', 'P'),
(107808, 'Woodson', 37.7511100769043, 0.65888116712479, -79.0680618286133, -1.37999801207975, 218, 53, 'PPL', 'P'),
(201831, 'Woodson', 46.1147193908691, 0.80485368700394, -123.323059082031, -2.15239342461294, 218, 43, 'PPL', 'P'),
(38962, 'Woodson Bend Resort', 36.9458312988281, 0.644826401050924, -84.6041717529297, -1.47662135801141, 218, 21, 'PPL', 'P'),
(58362, 'Woodson Terrace', 38.7249984741211, 0.675878726203193, -90.3583297729492, -1.57705036114078, 218, 29, 'PPL', 'P'),
(192453, 'Woodsons', 29.0061092376709, 0.5062521093905, -103.294441223145, -1.80282809835163, 218, 51, 'PPL', 'P'),
(38964, 'Woodsonville', 37.2627792358398, 0.650358186109182, -85.8883285522461, -1.49903412227135, 218, 21, 'PPL', 'P'),
(53039, 'Woodspring', 39.3916702270508, 0.687514343321858, -77.2569427490234, -1.34838802099522, 218, 25, 'PPL', 'P'),
(179578, 'Woodspring Trading Post', 35.8311080932617, 0.625370810865404, -109.433891296387, -1.90998171639151, 218, 5, 'PPL', 'P'),
(569, 'Woodstock', 37.2613906860352, 0.650333951343262, -84.5166702270508, -1.4750941682843, 218, 21, 'PPL', 'P'),
(6951, 'Woodstock', 33.2066688537598, 0.579565705117559, -87.1500015258789, -1.52105446974467, 218, 2, 'PPL', 'P'),
(26237, 'Woodstock', 34.101390838623, 0.595181549643402, -84.5194396972656, -1.47514250465808, 218, 13, 'PPL', 'P'),
(31564, 'Woodstock', 39.8274993896484, 0.695120997185397, -86.1847229003906, -1.50420717953077, 218, 19, 'PPL', 'P'),
(53040, 'Woodstock', 39.3286094665527, 0.686413725422356, -76.8722229003906, -1.3416733929388, 218, 25, 'PPL', 'P'),
(58363, 'Woodstock', 38.7311096191406, 0.675985385804851, -90.2927780151367, -1.57590626713649, 218, 29, 'PPL', 'P'),
(79443, 'Woodstock', 39.9386100769043, 0.697060244512166, -77.5838928222656, -1.35409437626293, 218, 45, 'PPL', 'P'),
(84528, 'Woodstock', 32.9630584716797, 0.575313901858221, -80.0888900756836, -1.39781482608849, 218, 48, 'PPL', 'P'),
(92014, 'Woodstock', 35.2730598449707, 0.615631031547739, -89.9822235107422, -1.5704860685279, 218, 50, 'PPL', 'P'),
(99208, 'Woodstock', 33.5580596923828, 0.585698632212876, -94.4627838134766, -1.64868659814477, 218, 51, 'PPL', 'P'),
(107811, 'Woodstock', 38.8816719055176, 0.678613193431459, -78.5061111450195, -1.37019012241721, 218, 53, 'PPL', 'P'),
(114325, 'Woodstock', 41.9483299255371, 0.73213647291349, -71.9744415283203, -1.25619098195333, 218, 8, 'PPL', 'P'),
(122062, 'Woodstock', 42.3147201538086, 0.738531188743961, -88.4486083984375, -1.54371943535984, 218, 18, 'PPL', 'P'),
(138936, 'Woodstock', 44.0091705322266, 0.768104926859019, -96.1002807617188, -1.67726631138296, 218, 28, 'PPL', 'P'),
(144706, 'Woodstock', 43.9775009155273, 0.767552187774773, -71.6855621337891, -1.25114908537759, 218, 36, 'PPL', 'P'),
(146679, 'Woodstock', 40.9952812194824, 0.715502635060964, -74.5263900756836, -1.3007308864463, 218, 37, 'PPL', 'P'),
(153929, 'Woodstock', 42.040828704834, 0.733750881166296, -74.1186065673828, -1.29361372159112, 218, 40, 'PPL', 'P'),
(158463, 'Woodstock', 40.1738891601563, 0.701166639175986, -83.5274963378906, -1.4578298270437, 218, 41, 'PPL', 'P'),
(172822, 'Woodstock', 43.6241683959961, 0.761385371954585, -72.5188903808594, -1.26569340703884, 218, 55, 'PPL', 'P'),
(177135, 'Woodstock', 43.4724998474121, 0.758738256410074, -90.4272232055664, -1.57825277837296, 218, 57, 'PPL', 'P'),
(201832, 'Woodstock', 45.4791717529297, 0.793761288168624, -122.607223510742, -2.13989973699105, 218, 43, 'PPL', 'P'),
(206603, 'Woodstock', 40.6411094665527, 0.709321171854782, -111.855560302734, -1.95224781394578, 218, 52, 'PPL', 'P'),
(26238, 'Woodstock (historical)', 30.8305606842041, 0.538094794175277, -81.9538879394531, -1.43036517935393, 218, 13, 'PPL', 'P'),
(14916, 'Woodstock Court', 39.1583290100098, 0.683441770803882, -75.5494384765625, -1.3185864494489, 218, 10, 'PPL', 'P'),
(6952, 'Woodstock Junction', 33.2152786254883, 0.579715973982067, -87.165283203125, -1.52132118532784, 218, 2, 'PPL', 'P'),
(114326, 'Woodstock Valley', 41.9408302307129, 0.732005578545913, -72.0722198486328, -1.25789753557985, 218, 8, 'PPL', 'P'),
(206604, 'Woodstock Village', 40.6383285522461, 0.709272635743915, -111.851387023926, -1.95217497648997, 218, 52, 'PPL', 'P'),
(34469, 'Woodston', 39.4552803039551, 0.688624548601285, -99.0952835083008, -1.72953897041709, 218, 20, 'PPL', 'P'),
(44227, 'Woodstone', 32.4136085510254, 0.565724191667981, -93.6930618286133, -1.63525241518392, 218, 22, 'PPL', 'P'),
(92017, 'Woodstone Estates', 36.4658317565918, 0.636448828630834, -82.5022201538086, -1.43993538188918, 218, 50, 'PPL', 'P'),
(71610, 'Woodstown', 39.6513900756836, 0.692047309813282, -75.32861328125, -1.31473232271934, 218, 37, 'PPL', 'P'),
(26241, 'Woodstown (historical)', 33.4388885498047, 0.583618703401524, -83.9563903808594, -1.46531544023569, 218, 13, 'PPL', 'P'),
(26242, 'Woodstream', 33.6797218322754, 0.587822037129023, -84.1902770996094, -1.46939753355457, 218, 13, 'PPL', 'P'),
(53041, 'Woodstream', 39.0605583190918, 0.681735350335414, -76.0991668701172, -1.32818101990813, 218, 25, 'PPL', 'P'),
(71612, 'Woodstream', 39.9019393920898, 0.696420220323192, -74.9477767944336, -1.30808547211267, 218, 37, 'PPL', 'P'),
(79444, 'Woodstream', 39.9911117553711, 0.697976571664235, -76.6908264160156, -1.33850742703492, 218, 45, 'PPL', 'P'),
(153931, 'Woodstream Farms', 43.0050010681152, 0.750578863462289, -78.7191696166992, -1.37390869424728, 218, 40, 'PPL', 'P'),
(6953, 'Woodsvale', 31.2508296966553, 0.545429872186655, -85.4138870239258, -1.49075355549397, 218, 2, 'PPL', 'P'),
(126703, 'Woodsville', 42.5733299255371, 0.743044780738455, -71.625, -1.25009207674094, 218, 23, 'PPL', 'P'),
(144708, 'Woodsville', 44.1522216796875, 0.770601640380968, -72.0377807617188, -1.25729646012182, 218, 36, 'PPL', 'P'),
(146680, 'Woodsville', 40.3802795410156, 0.704768830866427, -74.8291702270508, -1.30601539699735, 218, 37, 'PPL', 'P'),
(153932, 'Woodsville', 42.5758285522461, 0.743088390001305, -77.7319412231445, -1.35667830831058, 218, 40, 'PPL', 'P'),
(53042, 'Woodsworth Estates', 39.3888893127441, 0.687465807210992, -77.2972183227539, -1.34909096236494, 218, 25, 'PPL', 'P'),
(114328, 'Woodtick', 41.5788917541504, 0.725688560440245, -72.9786071777344, -1.27371697877103, 218, 8, 'PPL', 'P'),
(84529, 'Woodvale', 34.9291687011719, 0.609628998820001, -80.9883270263672, -1.41351296229202, 218, 48, 'PPL', 'P'),
(107812, 'Woodvale', 37.3499984741211, 0.651880448988271, -77.3436126708984, -1.34990069649438, 218, 53, 'PPL', 'P'),
(122064, 'Woodvale', 41.0238914489746, 0.716001977765354, -90.644172668457, -1.58203926081083, 218, 18, 'PPL', 'P'),
(169125, 'Woodvale', 40.3352813720703, 0.703983464660963, -78.9038925170898, -1.37713271706293, 218, 45, 'PPL', 'P'),
(53043, 'Woodvalley', 39.1655616760254, 0.683568004639552, -76.8547210693359, -1.34136792836177, 218, 25, 'PPL', 'P'),
(206607, 'Woodview Estates', 40.6436080932617, 0.709364781117632, -112.040000915527, -1.95546690991341, 218, 52, 'PPL', 'P'),
(206606, 'Woodview Heights', 40.6458282470703, 0.709403530111492, -112.039169311523, -1.95545239568547, 218, 52, 'PPL', 'P'),
(107813, 'Woodview Hills', 37.5180587768555, 0.654813654612884, -77.225830078125, -1.34784500244895, 218, 53, 'PPL', 'P'),
(158464, 'Woodview Park', 40.2622184753418, 0.702708276552006, -83.3572235107422, -1.45485800558328, 218, 41, 'PPL', 'P'),
(6954, 'Woodville', 34.6277809143066, 0.604368789613903, -86.2744369506836, -1.50577298509369, 218, 2, 'PPL', 'P'),
(12951, 'Woodville', 34.1230583190918, 0.595559718518194, -91.690559387207, -1.60030215430216, 218, 4, 'PPL', 'P'),
(18672, 'Woodville', 30.3138904571533, 0.529077197566215, -84.2474975585938, -1.47039621896335, 218, 12, 'PPL', 'P'),
(26244, 'Woodville', 33.6713905334473, 0.587676628533505, -83.1061096191406, -1.45047524137733, 218, 13, 'PPL', 'P'),
(38963, 'Woodville', 37.0966682434082, 0.647459002367494, -88.8733291625977, -1.55113221109602, 218, 21, 'PPL', 'P'),
(44229, 'Woodville', 32.4575004577637, 0.566490249955543, -92.6983337402344, -1.61789113487964, 218, 22, 'PPL', 'P'),
(53044, 'Woodville', 39.4099998474121, 0.687834255547804, -77.1780624389648, -1.3470112998697, 218, 25, 'PPL', 'P'),
(58364, 'Woodville', 39.6202812194824, 0.691504357846042, -92.3361129760742, -1.61156918992596, 218, 29, 'PPL', 'P'),
(62386, 'Woodville', 31.1044406890869, 0.542874902015861, -91.2994384765625, -1.59347580663801, 218, 30, 'PPL', 'P'),
(70378, 'Woodville', 36.5016708374023, 0.637074338591867, -80.4800033569336, -1.40464104059458, 218, 33, 'PPL', 'P'),
(71613, 'Woodville', 39.9883308410645, 0.697928035553368, -74.1477813720703, -1.29412291799155, 218, 37, 'PPL', 'P'),
(77722, 'Woodville', 33.9697189331055, 0.592883441359746, -96.6533279418945, -1.68691880559589, 218, 42, 'PPL', 'P'),
(84531, 'Woodville', 34.6500015258789, 0.604756612447646, -82.3888931274414, -1.43795745214758, 218, 48, 'PPL', 'P'),
(92019, 'Woodville', 35.7666702270508, 0.624246157937064, -89.4366683959961, -1.56096433552449, 218, 50, 'PPL', 'P'),
(99206, 'Woodville', 30.7749996185303, 0.537125070643352, -94.415283203125, -1.64785755609743, 218, 51, 'PPL', 'P'),
(107814, 'Woodville', 38.6066703796387, 0.673813511356864, -78.1755599975586, -1.36442091654777, 218, 53, 'PPL', 'P'),
(112139, 'Woodville', 38.1613883972168, 0.666041874663795, -81.892219543457, -1.42928886279937, 218, 58, 'PPL', 'P'),
(114329, 'Woodville', 41.704719543457, 0.727884669654152, -73.2975006103516, -1.27928271913319, 218, 8, 'PPL', 'P'),
(122065, 'Woodville', 40.1883316040039, 0.701418707373162, -91.1827774047852, -1.59143968682659, 218, 18, 'PPL', 'P'),
(124051, 'Woodville', 41.5627784729004, 0.725407330629133, -87.041389465332, -1.51915883168075, 218, 19, 'PPL', 'P'),
(126704, 'Woodville', 42.2374992370605, 0.737183429495299, -71.5625, -1.24900124595844, 218, 23, 'PPL', 'P'),
(133805, 'Woodville', 43.665828704834, 0.762112481511204, -85.6811065673828, -1.49541741635297, 218, 27, 'PPL', 'P'),
(153934, 'Woodville', 42.6697196960449, 0.744727099599058, -77.3644409179688, -1.35026421798318, 218, 40, 'PPL', 'P'),
(158465, 'Woodville', 41.4513893127441, 0.723463223033375, -83.3658294677734, -1.45500820786876, 218, 41, 'PPL', 'P'),
(169126, 'Woodville', 40.3819389343262, 0.704797792743282, -80.0908279418945, -1.39784864823433, 218, 45, 'PPL', 'P'),
(169683, 'Woodville', 41.4594383239746, 0.723603704780876, -71.7191696166992, -1.25173564660768, 218, 47, 'PPL', 'P'),
(177136, 'Woodville', 44.9530601501465, 0.784578908467113, -92.2911071777344, -1.61078369056244, 218, 57, 'PPL', 'P'),
(186238, 'Woodville', 37.9447212219238, 0.662260319073937, -122.705276489258, -2.14161108430754, 218, 6, 'PPL', 'P'),
(195819, 'Woodville', 43.4169387817383, 0.757768532878149, -112.141937255859, -1.95724603467964, 218, 17, 'PPL', 'P'),
(197883, 'Woodville', 46.0522193908691, 0.803762856221444, -112.445281982422, -1.96254039892672, 218, 31, 'PPL', 'P'),
(202801, 'Woodville', 44.2911109924316, 0.773025716184185, -103.754722595215, -1.81086152377985, 218, 49, 'PPL', 'P'),
(29030, 'Woodville (historical)', 38.2569389343262, 0.667709546138402, -90.272216796875, -1.5755474061796, 218, 18, 'PPL', 'P'),
(84532, 'Woodville Acres', 33.4625015258789, 0.584030827580213, -79.1361083984375, -1.38118564876787, 218, 48, 'PPL', 'P'),
(158466, 'Woodville Gardens', 41.5919418334961, 0.725916327292474, -83.4505615234375, -1.45648706122208, 218, 41, 'PPL', 'P'),
(31563, 'Woodville Hills', 39.1502799987793, 0.68330128905638, -86.3833312988281, -1.50767355000562, 218, 19, 'PPL', 'P'),
(53053, 'Woodville Meadows', 39.4099998474121, 0.687834255547804, -77.1788864135742, -1.34702568093959, 218, 25, 'PPL', 'P'),
(53046, 'Woodville Terrace', 39.389720916748, 0.687480321438933, -77.190559387207, -1.34722941276298, 218, 25, 'PPL', 'P'),
(6955, 'Woodward', 33.4352798461914, 0.583555719641743, -86.9580612182617, -1.51770447940946, 218, 2, 'PPL', 'P'),
(26245, 'Woodward', 33.8005599975586, 0.589931060975284, -84.4161071777344, -1.47333901196788, 218, 13, 'PPL', 'P'),
(53047, 'Woodward', 39.4330596923828, 0.688236725767542, -76.6727828979492, -1.33819250823601, 218, 25, 'PPL', 'P'),
(77723, 'Woodward', 36.4336090087891, 0.635886435587637, -99.3899993896484, -1.73468273290452, 218, 42, 'PPL', 'P'),
(84533, 'Woodward', 34.5272216796875, 0.602613699876514, -81.1716690063477, -1.4167128834998, 218, 48, 'PPL', 'P'),
(99207, 'Woodward', 28.5333309173584, 0.498000571068998, -99.320556640625, -1.73347072829242, 218, 51, 'PPL', 'P'),
(118521, 'Woodward', 41.8569412231445, 0.730541439157615, -93.9216690063477, -1.63924236312908, 218, 16, 'PPL', 'P'),
(169127, 'Woodward', 40.898609161377, 0.713815389352345, -77.3563919067383, -1.35012373623568, 218, 45, 'PPL', 'P'),
(186237, 'Woodward', 38.3111114501953, 0.668655034904408, -121.643058776855, -2.12307188785311, 218, 6, 'PPL', 'P'),
(138939, 'Woodward Brook', 45.6761093139648, 0.797198497029535, -93.5849990844727, -1.63336636449993, 218, 28, 'PPL', 'P'),
(6958, 'Woodward Junction', 33.4216690063477, 0.583318165672508, -86.9338912963867, -1.51728263469279, 218, 2, 'PPL', 'P'),
(197884, 'Woodward Place', 45.1327781677246, 0.787715579599008, -111.76277923584, -1.95062847884496, 218, 31, 'PPL', 'P'),
(53048, 'Woodward Square', 39.3188896179199, 0.686244082060918, -76.4702835083008, -1.33465822715337, 218, 25, 'PPL', 'P'),
(62388, 'Woodwards', 31.6936092376709, 0.553157833037847, -88.6638870239258, -1.54747675618378, 218, 30, 'PPL', 'P'),
(79446, 'Woodwards Corner', 39.9747200012207, 0.697690481584133, -75.7247161865234, -1.32164562259308, 218, 45, 'PPL', 'P'),
(99209, 'Woodway', 31.5058307647705, 0.549880480421369, -97.204719543457, -1.696542404511, 218, 51, 'PPL', 'P'),
(107815, 'Woodway', 36.7316703796387, 0.64108858788197, -82.9922180175781, -1.4484874579397, 218, 53, 'PPL', 'P'),
(209226, 'Woodway', 47.7963905334473, 0.834204385377704, -122.38166809082, -2.1359630522677, 218, 56, 'PPL', 'P'),
(84535, 'Woodwind', 34.9824981689453, 0.610559773620983, -81.0833282470703, -1.4151710463867, 218, 48, 'PPL', 'P'),
(53049, 'Woodwind Estates', 38.6049995422363, 0.673784349742928, -76.5519409179688, -1.33608341781073, 218, 25, 'PPL', 'P'),
(26246, 'Woodwind South', 31.8277797698975, 0.555499550584354, -81.6055603027344, -1.4242857152175, 218, 13, 'PPL', 'P'),
(26247, 'Woodwind Station', 34.0999984741211, 0.595157248298456, -84.5644378662109, -1.47592787086355, 218, 13, 'PPL', 'P'),
(44230, 'Woodworth', 31.146390914917, 0.543607071578551, -92.4972229003906, -1.61438108856292, 218, 22, 'PPL', 'P'),
(70381, 'Woodworth', 36.5380592346191, 0.637709435932823, -78.3791732788086, -1.36797463870637, 218, 33, 'PPL', 'P'),
(122066, 'Woodworth', 40.6597213745117, 0.709646010928744, -87.845832824707, -1.53319901694765, 218, 18, 'PPL', 'P'),
(141107, 'Woodworth', 47.1425018310547, 0.82279187457936, -99.3027801513672, -1.73316047002543, 218, 34, 'PPL', 'P'),
(158468, 'Woodworth', 40.9880599975586, 0.715376600962376, -80.6636123657227, -1.40784562233427, 218, 41, 'PPL', 'P'),
(177143, 'Woodworth', 42.5580596923828, 0.742778264892365, -88.001106262207, -1.53590904967291, 218, 57, 'PPL', 'P'),
(186240, 'Woodworth', 38.332218170166, 0.669023416662193, -122.759170532227, -2.14255171280455, 218, 6, 'PPL', 'P'),
(197885, 'Woodworth', 47.1063919067383, 0.822161637507393, -113.301666259766, -1.97748712422868, 218, 31, 'PPL', 'P'),
(29032, 'Woody', 39.2636108398438, 0.685279285377009, -90.4850006103516, -1.57926118431971, 218, 18, 'PPL', 'P'),
(92020, 'Woody', 36.0666694641113, 0.629482132377241, -85.0638885498047, -1.4846449297436, 218, 50, 'PPL', 'P'),
(186239, 'Woody', 35.7041702270508, 0.623155327154568, -118.83332824707, -2.07403283901456, 218, 6, 'PPL', 'P'),
(6959, 'Woody Acres', 33.6313896179199, 0.58697848085374, -86.4611129760742, -1.50903109637129, 218, 2, 'PPL', 'P'),
(26248, 'Woody Acres', 32.5194396972656, 0.567571293621033, -83.7138900756836, -1.46108301147328, 218, 13, 'PPL', 'P'),
(187561, 'Woody Creek', 39.2702789306641, 0.685395665516646, -106.885559082031, -1.86550492881637, 218, 7, 'PPL', 'P'),
(29033, 'Woodyard', 39.8655586242676, 0.69578525614029, -87.6561126708984, -1.5298877756063, 218, 18, 'PPL', 'P'),
(53050, 'Woodyard', 38.785831451416, 0.676940461950781, -76.8430633544922, -1.34116446285449, 218, 25, 'PPL', 'P'),
(112140, 'Woodyard (historical)', 38.6683311462402, 0.674889694753365, -81.4805603027344, -1.4221040536525, 218, 58, 'PPL', 'P'),
(12952, 'Woodyardville', 34.6655616760254, 0.605028188299807, -92.2697219848633, -1.61041044853566, 218, 4, 'PPL', 'P'),
(153935, 'Woodybrook', 41.2350006103516, 0.719686527712506, -73.8894424438477, -1.28961405310799, 218, 40, 'PPL', 'P'),
(169131, 'Woodycrest', 40.813060760498, 0.712322288087192, -77.9027786254883, -1.35965998346703, 218, 45, 'PPL', 'P'),
(112142, 'Woodzell', 38.5227813720703, 0.672349371968566, -80.3147201538086, -1.40175630450181, 218, 58, 'PPL', 'P'),
(153936, 'Wooglin', 42.252498626709, 0.737445218230454, -79.4655609130859, -1.38693567987746, 218, 40, 'PPL', 'P'),
(62389, 'Wool Market', 30.4675006866455, 0.531758201835597, -88.9958267211914, -1.55327019681914, 218, 30, 'PPL', 'P'),
(92022, 'Woolardtown', 36.0247192382813, 0.628749962814551, -83.5791702270508, -1.45873170654685, 218, 50, 'PPL', 'P'),
(77726, 'Woolaroc', 36.660831451416, 0.639852215345901, -96.1141662597656, -1.67750865904215, 218, 42, 'PPL', 'P'),
(38965, 'Woolcott', 38.732780456543, 0.676014547418787, -84.1002807617188, -1.46782680114364, 218, 21, 'PPL', 'P'),
(53051, 'Wooldlawn Heights', 39.6263885498047, 0.691610950868673, -76.0749969482422, -1.32775917519146, 218, 25, 'PPL', 'P'),
(58365, 'Wooldridge', 38.9061088562012, 0.679039698680036, -92.523063659668, -1.61483209489352, 218, 29, 'PPL', 'P'),
(92021, 'Wooldridge', 36.5766716003418, 0.638383348846668, -84.1838912963867, -1.46928608026295, 218, 50, 'PPL', 'P'),
(197886, 'Wooley', 47.7649993896484, 0.833656506562447, -104.105278015137, -1.8169798700682, 218, 31, 'PPL', 'P'),
(124052, 'Wooley Corner', 40.0108299255371, 0.6983207186561, -87.165283203125, -1.52132118532784, 218, 19, 'PPL', 'P'),
(6960, 'Wooley Springs (historical)', 34.9027786254883, 0.609168405109471, -86.7916717529297, -1.51480043539878, 218, 2, 'PPL', 'P'),
(195820, 'Wooleys', 42.4519386291504, 0.740926102933242, -111.386108398438, -1.94405433253604, 218, 17, 'PPL', 'P'),
(38967, 'Wooleyville', 37.3791694641113, 0.652389578809667, -85.246940612793, -1.48783979094531, 218, 21, 'PPL', 'P'),
(6961, 'Woolfolk', 33.4172210693359, 0.583240534526732, -85.9983291625977, -1.50095399510119, 218, 2, 'PPL', 'P'),
(26249, 'Woolfolk (historical)', 32.3630599975586, 0.564841952977865, -84.9716720581055, -1.48303544833881, 218, 13, 'PPL', 'P'),
(53052, 'Woolford', 38.502498626709, 0.671995371280667, -76.1836090087891, -1.32965481325538, 218, 25, 'PPL', 'P'),
(38966, 'Woollum', 37.019718170166, 0.646115970229767, -83.817497253418, -1.46289129785345, 218, 21, 'PPL', 'P'),
(26250, 'Woollys (historical)', 34.2380599975586, 0.597566876452759, -84.9930572509766, -1.48340869036558, 218, 13, 'PPL', 'P'),
(169132, 'Woolrich', 41.1947212219238, 0.718983519763753, -77.3766708374023, -1.35047767034455, 218, 45, 'PPL', 'P'),
(209227, 'Woolridge', 47.5938911437988, 0.83067010429506, -122.171669006348, -2.13229787681748, 218, 56, 'PPL', 'P'),
(12953, 'Woolsey', 35.8852806091309, 0.62631629963141, -94.168327331543, -1.64354736303119, 218, 4, 'PPL', 'P'),
(26251, 'Woolsey', 33.3622207641602, 0.582280598111813, -84.4122161865234, -1.47327110136009, 218, 13, 'PPL', 'P'),
(70382, 'Woolsey', 35.6191711425781, 0.621671813269339, -82.5561065673828, -1.44087587722814, 218, 33, 'PPL', 'P'),
(107817, 'Woolsey', 38.8697204589844, 0.678404601339079, -77.6358337402344, -1.35500091629799, 218, 53, 'PPL', 'P'),
(186241, 'Woolsey', 38.4838905334473, 0.671670598785732, -122.81861114502, -2.14358914720719, 218, 6, 'PPL', 'P'),
(200290, 'Woolsey', 40.2811088562012, 0.703037975894958, -118.363609313965, -2.06583469707291, 218, 39, 'PPL', 'P'),
(186242, 'Woolsey Flat', 39.4113883972168, 0.687858490313724, -120.866943359375, -2.10952611844259, 218, 6, 'PPL', 'P'),
(26252, 'Woolsey Woods', 33.3422203063965, 0.581931524271931, -84.4119415283203, -1.47326630767012, 218, 13, 'PPL', 'P'),
(118522, 'Woolstock', 42.5666694641113, 0.742928533756873, -93.8436126708984, -1.63788002307345, 218, 16, 'PPL', 'P'),
(12955, 'Woolum', 35.7108306884766, 0.623271574136149, -92.6636123657227, -1.61728513257359, 218, 4, 'PPL', 'P'),
(12956, 'Woolverton (historical)', 35.4427795410156, 0.618593199049207, -92.5541687011719, -1.61537498028173, 218, 4, 'PPL', 'P'),
(129389, 'Woolwich', 43.9186096191406, 0.766524340752057, -69.8016662597656, -1.21826889961115, 218, 26, 'PPL', 'P'),
(107818, 'Woolwine', 36.7897186279297, 0.642101720939664, -80.2774963378906, -1.40110662635388, 218, 53, 'PPL', 'P'),
(62390, 'Woolworth', 31.6330604553223, 0.55210105742779, -90.2733306884766, -1.57556684725556, 218, 30, 'PPL', 'P'),
(92023, 'Woolworth', 36.2186088562012, 0.632133975032688, -87.7197189331055, -1.5309979143067, 218, 50, 'PPL', 'P'),
(169685, 'Woonsocket', 42.0027809143066, 0.733086821948485, -71.5152816772461, -1.24817713075912, 218, 47, 'PPL', 'P'),
(171653, 'Woonsocket', 44.0536117553711, 0.768880572526504, -98.2752838134766, -1.71522727587705, 218, 49, 'PPL', 'P'),
(99210, 'Woosley', 32.8820686340332, 0.573900362530634, -95.8834381103516, -1.67348169315784, 218, 51, 'PPL', 'P'),
(112141, 'Woosley', 37.5202789306641, 0.654852403606745, -81.5886077880859, -1.42398983802039, 218, 58, 'PPL', 'P'),
(12957, 'Wooster', 35.2019386291504, 0.614389732163653, -92.4558334350586, -1.61365870611723, 218, 4, 'PPL', 'P'),
(26253, 'Wooster', 33.1416702270508, 0.578431265072213, -84.6302795410156, -1.47707702487392, 218, 13, 'PPL', 'P'),
(99211, 'Wooster', 29.7555599212646, 0.519332491400533, -95.0347213745117, -1.65866879170066, 218, 51, 'PPL', 'P'),
(124053, 'Wooster', 41.209171295166, 0.719235721118983, -85.7427825927734, -1.49649386606558, 218, 19, 'PPL', 'P'),
(133806, 'Wooster', 43.5105590820313, 0.759402515364967, -85.873893737793, -1.49878218723223, 218, 27, 'PPL', 'P'),
(158469, 'Wooster', 40.8050003051758, 0.712181606602608, -81.9352798461914, -1.43004040685899, 218, 41, 'PPL', 'P'),
(158470, 'Wooster Heights', 40.7677803039551, 0.711531995033711, -82.4652786254883, -1.43929063058927, 218, 41, 'PPL', 'P'),
(122067, 'Woosung', 41.9033317565918, 0.731351106708026, -89.5408325195313, -1.56278234244263, 218, 18, 'PPL', 'P'),
(6962, 'Wootens (historical)', 32.2636108398438, 0.563106237737406, -87.5736083984375, -1.52844780440489, 218, 2, 'PPL', 'P'),
(70386, 'Wootens Crossroads', 35.3652801513672, 0.617240579531556, -77.6069412231445, -1.35449664674559, 218, 33, 'PPL', 'P'),
(38968, 'Wooton', 37.1788902282715, 0.648894046720884, -83.3022232055664, -1.45389806916836, 218, 21, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(114330, 'Wopowog', 41.5230598449707, 0.724714109797385, -72.4855575561523, -1.26511163949871, 218, 8, 'PPL', 'P'),
(169133, 'Wopsononock', 40.5680618286133, 0.708046250061933, -78.4516677856445, -1.36923990654027, 218, 45, 'PPL', 'P'),
(58366, 'Worcester', 39.273609161377, 0.685453789007437, -91.7538909912109, -1.60140749931259, 218, 29, 'PPL', 'P'),
(126705, 'Worcester', 42.2625007629395, 0.737619788439909, -71.8027801513672, -1.25319492572699, 218, 23, 'PPL', 'P'),
(153937, 'Worcester', 42.5913887023926, 0.743359965853466, -74.7508316040039, -1.3046481300937, 218, 40, 'PPL', 'P'),
(169134, 'Worcester', 40.2011108398438, 0.701641747114456, -75.3469390869141, -1.31505216836626, 218, 45, 'PPL', 'P'),
(172824, 'Worcester', 44.3736114501953, 0.774465620806564, -72.5502777099609, -1.26624121927507, 218, 55, 'PPL', 'P'),
(177139, 'Worcester', 45.6036109924316, 0.795933162616611, -90.2919387817383, -1.57589161975049, 218, 57, 'PPL', 'P'),
(169136, 'Wordan Place', 41.3633308410645, 0.72192631276829, -76.029167175293, -1.32695929475806, 218, 45, 'PPL', 'P'),
(12958, 'Worden', 35.2941703796387, 0.615999479884552, -91.4911117553711, -1.59682113644131, 218, 4, 'PPL', 'P'),
(29034, 'Worden', 38.9313888549805, 0.679480917893634, -89.8388900756836, -1.56798442815794, 218, 18, 'PPL', 'P'),
(34470, 'Worden', 38.7822189331055, 0.676877411611973, -95.3341674804688, -1.66389511218189, 218, 20, 'PPL', 'P'),
(133807, 'Worden', 42.3877792358398, 0.739806310273891, -83.6449966430664, -1.45988059424111, 218, 27, 'PPL', 'P'),
(197887, 'Worden', 45.9599990844727, 0.802153308237627, -108.160278320313, -1.8877529765629, 218, 31, 'PPL', 'P'),
(201833, 'Worden', 42.0455589294434, 0.733833439160089, -121.865280151367, -2.12695038250665, 218, 43, 'PPL', 'P'),
(177141, 'Worden (historical)', 44.8866691589355, 0.783420167076819, -90.8816680908203, -1.58618433788948, 218, 57, 'PPL', 'P'),
(84537, 'Workman', 33.7341690063477, 0.588772319584991, -79.9677810668945, -1.39570107513129, 218, 48, 'PPL', 'P'),
(186243, 'Workman', 33.9297218322754, 0.592185360259009, -118.167221069336, -2.06240707559193, 218, 6, 'PPL', 'P'),
(126710, 'Workmans Circle Camp', 42.2491683959961, 0.737387094739663, -71.4375, -1.24681958439345, 218, 23, 'PPL', 'P'),
(26255, 'Workmore', 31.9349994659424, 0.557370887303325, -82.9394378662109, -1.44756627051864, 218, 13, 'PPL', 'P'),
(58368, 'Worland', 38.1877784729004, 0.666502468374324, -94.591667175293, -1.65093603715951, 218, 29, 'PPL', 'P'),
(209844, 'Worland', 44.0169410705566, 0.768240548337531, -107.954719543457, -1.8841652991004, 218, 59, 'PPL', 'P'),
(107819, 'Worlds', 36.8522186279297, 0.64319255172216, -79.5911102294922, -1.38912692882238, 218, 53, 'PPL', 'P'),
(38969, 'Worley', 36.6994400024414, 0.640526061680718, -84.5338897705078, -1.47539470601332, 218, 21, 'PPL', 'P'),
(70387, 'Worley', 35.8055610656738, 0.624924931119898, -82.7911071777344, -1.44497741162298, 218, 33, 'PPL', 'P'),
(112143, 'Worley', 39.707218170166, 0.693021693877115, -80.1486129760742, -1.39885718733915, 218, 58, 'PPL', 'P'),
(195821, 'Worley', 47.4008293151855, 0.827300539725837, -116.916107177734, -2.04057101886604, 218, 17, 'PPL', 'P'),
(26258, 'Worley Crossroads', 34.378059387207, 0.600010326752907, -84.4633331298828, -1.47416326032526, 218, 13, 'PPL', 'P'),
(79448, 'Worleytown', 39.7444381713867, 0.693671305446013, -77.7769393920898, -1.35746367451604, 218, 45, 'PPL', 'P'),
(169137, 'Worman', 40.3152809143066, 0.703634390821081, -75.6947174072266, -1.32112204512277, 218, 45, 'PPL', 'P'),
(169138, 'Wormleysburg', 40.2627792358398, 0.702718063669012, -76.9141693115234, -1.34240549592246, 218, 45, 'PPL', 'P'),
(143427, 'Worms', 41.0972213745117, 0.717281826406219, -98.2686080932617, -1.71511076257936, 218, 35, 'PPL', 'P'),
(197888, 'Wormser (historical)', 45.9772186279297, 0.802453845966643, -109.999717712402, -1.91985725034575, 218, 31, 'PPL', 'P'),
(26256, 'Wormsloe', 31.976390838623, 0.558093303038523, -81.0627822875977, -1.41481245174592, 218, 13, 'PPL', 'P'),
(114331, 'Wormwood Hill', 41.8222198486328, 0.729935436851567, -72.195556640625, -1.26005016868896, 218, 8, 'PPL', 'P'),
(26257, 'Worner (historical)', 31.8936100006104, 0.556648504857641, -84.458610534668, -1.47408083548952, 218, 13, 'PPL', 'P'),
(126708, 'Woronoco', 42.163890838623, 0.735898720585445, -72.8300018310547, -1.2711233261854, 218, 23, 'PPL', 'P'),
(126709, 'Woronoco Heights', 42.1597213745117, 0.735825949708659, -72.875, -1.27190869239087, 218, 23, 'PPL', 'P'),
(79447, 'Worrell', 39.952220916748, 0.697297798481401, -75.3916702270508, -1.31583287403982, 218, 45, 'PPL', 'P'),
(107820, 'Worrell', 36.7255592346191, 0.640981928280313, -77.2163925170898, -1.34768028593553, 218, 53, 'PPL', 'P'),
(70388, 'Worry', 35.8269386291504, 0.625298039988618, -81.7375030517578, -1.42658855061209, 218, 33, 'PPL', 'P'),
(107821, 'Worsham', 37.2299995422363, 0.649786072528006, -78.4433288574219, -1.36909436478669, 218, 53, 'PPL', 'P'),
(192977, 'Worsham', 31.3627796173096, 0.547383766899419, -103.529716491699, -1.80693442643642, 218, 51, 'PPL', 'P'),
(44231, 'Worsham Crossing', 31.7605590820313, 0.554326328255633, -92.7238922119141, -1.61833721436223, 218, 22, 'PPL', 'P'),
(107822, 'Worshams', 37.5352783203125, 0.6551141923419, -77.894172668457, -1.35950978118155, 218, 53, 'PPL', 'P'),
(158473, 'Worstville', 41.0816688537598, 0.717010383712113, -84.6705627441406, -1.4777800994017, 218, 41, 'PPL', 'P'),
(194069, 'Worswick', 40.6119384765625, 0.708812042033386, -124.190559387207, -2.16753416120031, 218, 6, 'PPL', 'P'),
(146681, 'Wortendyke', 40.997501373291, 0.715541384054825, -74.1505584716797, -1.29417138752339, 218, 37, 'PPL', 'P'),
(205, 'Worth', 37.4147186279297, 0.653010028764628, -81.3899993896484, -1.42052346754554, 218, 58, 'PPL', 'P'),
(26259, 'Worth', 31.750560760498, 0.554151824625206, -83.6758270263672, -1.46041868593936, 218, 13, 'PPL', 'P'),
(122069, 'Worth', 41.6897201538086, 0.727622880918997, -87.7972183227539, -1.53235053382435, 218, 18, 'PPL', 'P'),
(133808, 'Worth', 43.9252815246582, 0.76664078747072, -83.9655609130859, -1.46547549621721, 218, 27, 'PPL', 'P'),
(139540, 'Worth', 40.4049987792969, 0.70520026296302, -94.4438934326172, -1.64835689880182, 218, 29, 'PPL', 'P'),
(153939, 'Worth', 43.7841682434082, 0.764177896094615, -75.878059387207, -1.32432196633055, 218, 40, 'PPL', 'P'),
(186244, 'Worth', 36.0525016784668, 0.629234857870028, -118.936111450195, -2.07582674432484, 218, 6, 'PPL', 'P'),
(53068, 'Worth Acres', 39.475830078125, 0.688983209821092, -76.9141693115234, -1.34240549592246, 218, 25, 'PPL', 'P'),
(153940, 'Worth Center', 43.7425003051758, 0.763450653379942, -75.8547210693359, -1.32391463584183, 218, 40, 'PPL', 'P'),
(58367, 'Wortham', 37.8444404602051, 0.660510089605537, -90.6086120605469, -1.58141861111879, 218, 29, 'PPL', 'P'),
(62391, 'Wortham', 30.5544395446777, 0.533275571156184, -89.1324996948242, -1.55565559020752, 218, 30, 'PPL', 'P'),
(99212, 'Wortham', 31.7877807617188, 0.554801436194103, -96.4622192382813, -1.68358332948862, 218, 51, 'PPL', 'P'),
(84538, 'Worthams Ferry', 33.9236106872559, 0.592078700657351, -78.6708297729492, -1.37306500481395, 218, 48, 'PPL', 'P'),
(12959, 'Worthen', 35.2436103820801, 0.615117041457354, -93.0224990844727, -1.62354888745746, 218, 4, 'PPL', 'P'),
(99213, 'Worthing', 29.4130592346191, 0.513354726728227, -97.0147171020508, -1.69322623632164, 218, 51, 'PPL', 'P'),
(171658, 'Worthing', 43.3291702270508, 0.756236682619135, -96.7624969482422, -1.68882416419779, 218, 49, 'PPL', 'P'),
(186245, 'Worthing (historical)', 36.186939239502, 0.631581235948442, -119.082496643066, -2.0783816479166, 218, 6, 'PPL', 'P'),
(31567, 'Worthington', 39.125, 0.682860069842781, -86.9794387817383, -1.51807758827818, 218, 19, 'PPL', 'P'),
(38973, 'Worthington', 38.315559387207, 0.668732666050184, -85.5616683959961, -1.49333282700971, 218, 21, 'PPL', 'P'),
(53057, 'Worthington', 39.2416687011719, 0.684896322812256, -76.7863922119141, -1.34017536482563, 218, 25, 'PPL', 'P'),
(112144, 'Worthington', 39.4524993896484, 0.688576012490419, -80.2605590820313, -1.40081101547288, 218, 58, 'PPL', 'P'),
(118525, 'Worthington', 42.3963890075684, 0.739956579138399, -91.1197204589844, -1.59033913550612, 218, 16, 'PPL', 'P'),
(138941, 'Worthington', 43.6199989318848, 0.761312601077799, -95.5961074829102, -1.66846682766717, 218, 28, 'PPL', 'P'),
(139542, 'Worthington', 40.4083290100098, 0.705258386453811, -92.688606262207, -1.61772135836015, 218, 29, 'PPL', 'P'),
(153942, 'Worthington', 41.0308303833008, 0.716123085015926, -73.8361129760742, -1.288683278307, 218, 40, 'PPL', 'P'),
(158474, 'Worthington', 40.0930595397949, 0.699755896167544, -83.0180587768555, -1.4489384642703, 218, 41, 'PPL', 'P'),
(169143, 'Worthington', 40.8375015258789, 0.712748859914795, -79.6322174072266, -1.38984438442005, 218, 45, 'PPL', 'P'),
(118526, 'Worthington Acres', 41.9294395446777, 0.731806773570538, -91.628059387207, -1.59921132351966, 218, 16, 'PPL', 'P'),
(126713, 'Worthington Center', 42.3972206115723, 0.73997109336634, -72.9361114501953, -1.27297528840744, 218, 23, 'PPL', 'P'),
(53058, 'Worthington Club Estates', 39.4677810668945, 0.68884272807359, -76.7361068725586, -1.3392977200884, 218, 25, 'PPL', 'P'),
(126711, 'Worthington Corners', 42.4102783203125, 0.740198993376623, -72.9361114501953, -1.27297528840744, 218, 23, 'PPL', 'P'),
(26261, 'Worthington Estates', 33.6547203063965, 0.587385678184413, -84.8022232055664, -1.48007800794827, 218, 13, 'PPL', 'P'),
(53059, 'Worthington Glen', 39.4538917541504, 0.688600313835365, -76.7916717529297, -1.34026751019935, 218, 25, 'PPL', 'P'),
(53060, 'Worthington Greens', 39.4663887023926, 0.688818426728643, -76.7480621337891, -1.3395063787598, 218, 25, 'PPL', 'P'),
(53061, 'Worthington Heights', 39.5277786254883, 0.689889883014209, -76.3227767944336, -1.33208374932759, 218, 25, 'PPL', 'P'),
(38971, 'Worthington Hills', 38.3088912963867, 0.668616285910547, -85.5269393920898, -1.49272669154561, 218, 21, 'PPL', 'P'),
(53062, 'Worthington Manor', 39.5224990844727, 0.689797737640492, -76.7080612182617, -1.33880823108004, 218, 25, 'PPL', 'P'),
(53063, 'Worthington Meadows', 39.464168548584, 0.688779677734782, -76.8111114501953, -1.34060679692222, 218, 25, 'PPL', 'P'),
(112145, 'Worthington Meadows', 39.2847213745117, 0.685647733713822, -81.5077819824219, -1.42257916159097, 218, 58, 'PPL', 'P'),
(53064, 'Worthington Park', 39.4597206115723, 0.688702046589006, -76.7763900756836, -1.34000079461618, 218, 25, 'PPL', 'P'),
(53065, 'Worthington Place South', 39.4244384765625, 0.688086257165953, -76.783332824707, -1.34012196844578, 218, 25, 'PPL', 'P'),
(53066, 'Worthington Ridge', 39.4705581665039, 0.688891197605429, -76.7386093139648, -1.33934139593027, 218, 25, 'PPL', 'P'),
(53067, 'Worthington Run', 39.4583282470703, 0.68867774524406, -76.7916717529297, -1.34026751019935, 218, 25, 'PPL', 'P'),
(18673, 'Worthington Springs', 29.9291706085205, 0.522362569509798, -82.4236068725586, -1.43856332129557, 218, 12, 'PPL', 'P'),
(70389, 'Worthingtons Crossroads', 35.5316696166992, 0.620144623542233, -77.3491668701172, -1.34999763555806, 218, 33, 'PPL', 'P'),
(14917, 'Worthland', 39.8083305358887, 0.694786437573456, -75.4499969482422, -1.3168508673665, 218, 10, 'PPL', 'P'),
(129391, 'Worthley Pond', 44.4680595397949, 0.776114050942296, -70.3888931274414, -1.22851794190826, 218, 26, 'PPL', 'P'),
(26262, 'Worthville', 33.389720916748, 0.582760566319273, -83.92138671875, -1.46470451108163, 218, 13, 'PPL', 'P'),
(38972, 'Worthville', 38.6097183227539, 0.673866707999638, -85.067497253418, -1.48470791350338, 218, 21, 'PPL', 'P'),
(70390, 'Worthville', 35.8019409179688, 0.624861747623036, -79.7802810668945, -1.3924285827838, 218, 33, 'PPL', 'P'),
(169145, 'Worthville', 41.0244407653809, 0.716011565145279, -79.1383285522461, -1.38122439776173, 218, 45, 'PPL', 'P'),
(74886, 'Wortley', 39.9588890075684, 0.697414178621037, -81.9786071777344, -1.43079661145052, 218, 41, 'PPL', 'P'),
(212242, 'Wortmanns', 61.1111106872559, 1.06659009104331, -145.816390991211, -2.54497612617203, 218, 1, 'PPL', 'P'),
(53069, 'Worton', 39.2744407653809, 0.685468303235378, -76.0924987792969, -1.3280646397685, 218, 25, 'PPL', 'P'),
(53072, 'Worton Heights', 39.2794418334961, 0.685555588340105, -76.1388931274414, -1.32887437389794, 218, 25, 'PPL', 'P'),
(202803, 'Wounded Knee', 43.1405601501465, 0.752944815774715, -102.365280151367, -1.78661117836776, 218, 49, 'PPL', 'P'),
(169147, 'Woxall', 40.3105583190918, 0.703551965985343, -75.4491729736328, -1.31683648629661, 218, 45, 'PPL', 'P'),
(53070, 'Woytych', 39.0011100769043, 0.680697782774719, -76.5538864135742, -1.33611737311462, 218, 25, 'PPL', 'P'),
(12965, 'Wranes (historical)', 35.1591682434082, 0.613643248110104, -91.5130615234375, -1.59720423216412, 218, 4, 'PPL', 'P'),
(14918, 'Wrange Hill Estates', 39.5916709899902, 0.691005015141653, -75.6999969482422, -1.32121419049649, 218, 10, 'PPL', 'P'),
(193329, 'Wrangell', 56.4708290100098, 0.9856018975554, -132.376663208008, -2.31040862578338, 218, 1, 'PPL', 'P'),
(71616, 'Wrangell Brook Park', 39.9599990844727, 0.697433553117968, -74.2841720581055, -1.29650338453191, 218, 37, 'PPL', 'P'),
(14919, 'Wrangle Hill', 39.5791702270508, 0.690786835669348, -75.6577835083008, -1.32047742698092, 218, 10, 'PPL', 'P'),
(84540, 'Wrangle Town (historical)', 33.2172203063965, 0.579749862706938, -79.8141708374023, -1.39302007086191, 218, 48, 'PPL', 'P'),
(179579, 'Wranglers Roost', 33.9241714477539, 0.592088487774357, -112.112503051758, -1.95673231090536, 218, 5, 'PPL', 'P'),
(12961, 'Wrape (historical)', 35.271671295166, 0.61560679678182, -91.0247192382813, -1.58868105141143, 218, 4, 'PPL', 'P'),
(26266, 'Wray', 31.6222190856934, 0.55191183983234, -83.0550003051758, -1.44958321557021, 218, 13, 'PPL', 'P'),
(193143, 'Wray', 40.0758285522461, 0.699455158701447, -102.222778320313, -1.78412405222573, 218, 7, 'PPL', 'P'),
(38974, 'Wray Gap', 36.7880592346191, 0.642072759062809, -84.8516693115234, -1.48094100529951, 218, 21, 'PPL', 'P'),
(26263, 'Wrayswood', 33.6933288574219, 0.588059524519231, -83.3147201538086, -1.45411618206164, 218, 13, 'PPL', 'P'),
(34471, 'Wreford', 38.961669921875, 0.680009422211961, -96.8483276367188, -1.69032219231096, 218, 20, 'PPL', 'P'),
(6963, 'Wren', 34.4341697692871, 0.600989637664756, -87.2936096191406, -1.5235609038046, 218, 2, 'PPL', 'P'),
(62392, 'Wren', 33.9716682434082, 0.592917463242672, -88.5997161865234, -1.54635676378735, 218, 30, 'PPL', 'P'),
(107824, 'Wren', 37.1186103820801, 0.647841964932248, -78.8499984741211, -1.37619208856592, 218, 53, 'PPL', 'P'),
(118527, 'Wren', 42.6455612182617, 0.744305454619471, -96.2861099243164, -1.68050964211651, 218, 16, 'PPL', 'P'),
(158477, 'Wren', 40.8008308410645, 0.712108835725822, -84.7752838134766, -1.47960782685782, 218, 41, 'PPL', 'P'),
(201834, 'Wren', 44.5877799987793, 0.778203567133572, -123.427223205566, -2.15421143153108, 218, 43, 'PPL', 'P'),
(206608, 'Wren Circle Condominium', 40.6647186279297, 0.709733229454444, -111.81861114502, -1.95160292948782, 218, 52, 'PPL', 'P'),
(206609, 'Wren Hollow', 40.6641693115234, 0.70972364207452, -111.818061828613, -1.95159334210789, 218, 52, 'PPL', 'P'),
(206610, 'Wren Lane East', 40.6366691589355, 0.70924367386706, -111.820831298828, -1.95164167848168, 218, 52, 'PPL', 'P'),
(206611, 'Wren Lane West', 40.6358299255371, 0.709229026481065, -111.820831298828, -1.95164167848168, 218, 52, 'PPL', 'P'),
(92024, 'Wrencoe', 36.0125007629395, 0.628536710190263, -86.70361328125, -1.5132635251337, 218, 50, 'PPL', 'P'),
(195822, 'Wrencoe', 48.228889465332, 0.841752915750452, -116.701942443848, -2.03683313911806, 218, 17, 'PPL', 'P'),
(70391, 'Wrendale', 35.9861106872559, 0.628076116479734, -77.6458282470703, -1.35517535334939, 218, 33, 'PPL', 'P'),
(26264, 'Wrens', 33.2075004577637, 0.5795802193455, -82.3919372558594, -1.43801058221133, 218, 13, 'PPL', 'P'),
(26265, 'Wrens Station', 33.1936111450195, 0.579337805107276, -82.4005584716797, -1.43816105081292, 218, 13, 'PPL', 'P'),
(138944, 'Wrenshall', 46.6169395446777, 0.813619082257773, -92.3822174072266, -1.61237386404932, 218, 28, 'PPL', 'P'),
(126714, 'Wrentham', 42.0666694641113, 0.734201887496901, -71.32861328125, -1.24491915263957, 218, 23, 'PPL', 'P'),
(12962, 'Wrenton', 35.607780456543, 0.621473008293964, -91.7063903808594, -1.60057845726525, 218, 4, 'PPL', 'P'),
(84544, 'Wrenwood', 33.9402809143066, 0.592369651006442, -81.2033309936523, -1.41726548942599, 218, 48, 'PPL', 'P'),
(6964, 'Wright', 34.9086112976074, 0.60927020444214, -87.9899978637695, -1.53571517154556, 218, 2, 'PPL', 'P'),
(12963, 'Wright', 34.435001373291, 0.601004151892697, -92.0661087036133, -1.60685672637706, 218, 4, 'PPL', 'P'),
(18674, 'Wright', 30.4555606842041, 0.531549809480299, -86.6383285522461, -1.51212409166131, 218, 12, 'PPL', 'P'),
(34472, 'Wright', 37.7805595397949, 0.659395157215175, -99.8916702270508, -1.74343854077843, 218, 20, 'PPL', 'P'),
(44232, 'Wright', 30.0072193145752, 0.523724776407373, -92.4286117553711, -1.61318359817876, 218, 22, 'PPL', 'P'),
(62393, 'Wright', 33.8844413757324, 0.591395067205528, -90.9986114501953, -1.58822538454892, 218, 30, 'PPL', 'P'),
(92025, 'Wright', 36.4372215270996, 0.635949485926444, -89.4186096191406, -1.56064915040948, 218, 50, 'PPL', 'P'),
(107825, 'Wright', 37.1652793884277, 0.648656492751648, -79.9738922119141, -1.39580773473295, 218, 53, 'PPL', 'P'),
(112146, 'Wright', 37.8277816772461, 0.660219338993527, -81.101936340332, -1.41549581888163, 218, 58, 'PPL', 'P'),
(118528, 'Wright', 41.2491683959961, 0.71993380221972, -92.5258331298828, -1.61488043126731, 218, 16, 'PPL', 'P'),
(133810, 'Wright', 43.1108283996582, 0.752425898836314, -85.8086090087891, -1.49764275375984, 218, 27, 'PPL', 'P'),
(138947, 'Wright', 46.6691703796387, 0.814530682298907, -93.0066680908203, -1.62327258449436, 218, 28, 'PPL', 'P'),
(153943, 'Wright', 43.8002815246582, 0.764459125905728, -73.3811111450195, -1.2807419982525, 218, 40, 'PPL', 'P'),
(192454, 'Wright', 34.2519416809082, 0.597809157532929, -101.828330993652, -1.77723964764982, 218, 51, 'PPL', 'P'),
(209845, 'Wright', 43.746940612793, 0.763528151367663, -105.470001220703, -1.84079878338371, 218, 59, 'PPL', 'P'),
(12964, 'Wright (historical)', 34.1627807617188, 0.596253005928969, -93.5374984741211, -1.63253732245259, 218, 4, 'PPL', 'P'),
(195823, 'Wright (historical)', 47.9811096191406, 0.837428341614326, -116.730827331543, -2.03733727551241, 218, 17, 'PPL', 'P'),
(53071, 'Wright Acres', 39.4094390869141, 0.687824468430798, -76.9072189331055, -1.34228418893481, 218, 25, 'PPL', 'P'),
(58369, 'Wright City', 38.8274993896484, 0.677667704665454, -91.0199966430664, -1.58859862657569, 218, 29, 'PPL', 'P'),
(77727, 'Wright City', 34.060001373291, 0.594459167197718, -95.003059387207, -1.65811618577447, 218, 42, 'PPL', 'P'),
(99215, 'Wright City', 32.1969413757324, 0.561942636078123, -94.9863891601563, -1.65782523542538, 218, 51, 'PPL', 'P'),
(199797, 'Wright City Trailer Court', 42.0430603027344, 0.733789829897239, -101.043327331543, -1.7635387491058, 218, 35, 'PPL', 'P'),
(129392, 'Wright Corner', 44.0913887023926, 0.769539904633381, -70.5366668701172, -1.23109708026595, 218, 26, 'PPL', 'P'),
(6965, 'Wright Crossroads', 32.5327796936035, 0.567804120479333, -85.4700012207031, -1.49173293298484, 218, 2, 'PPL', 'P'),
(26267, 'Wright Mill', 34.9099998474121, 0.609294439208059, -84.1922225952148, -1.46943148885846, 218, 13, 'PPL', 'P'),
(70392, 'Wright Place', 35.3452796936035, 0.616891505691674, -83.6036071777344, -1.45915821179543, 218, 33, 'PPL', 'P'),
(189834, 'Wright Place', 36.5019416809082, 0.637079065702802, -106.675559997559, -1.86183975336615, 218, 38, 'PPL', 'P'),
(194070, 'Wright Place', 41.2777786254883, 0.72043314492411, -123.677223205566, -2.15857475466107, 218, 6, 'PPL', 'P'),
(153944, 'Wright Settlement', 43.2508316040039, 0.754869415715488, -75.415283203125, -1.31624499821851, 218, 40, 'PPL', 'P'),
(107826, 'Wright Shop', 37.4430618286133, 0.65350471093711, -79.0891723632813, -1.38036646041656, 218, 53, 'PPL', 'P'),
(206615, 'Wright Subdivision 1-5', 40.6911087036133, 0.710193823164973, -111.952499389648, -1.95393972018631, 218, 52, 'PPL', 'P'),
(206616, 'Wright Subdivision 11', 40.6830596923828, 0.710053341417472, -111.959167480469, -1.95405610032594, 218, 52, 'PPL', 'P'),
(206617, 'Wright Subdivision 6, 8, 10', 40.688060760498, 0.710140626522199, -111.955001831055, -1.95398339602818, 218, 52, 'PPL', 'P'),
(12966, 'Wright Town', 35.4066696166992, 0.61796296197724, -94.2944412231445, -1.64574846567214, 218, 4, 'PPL', 'P'),
(169149, 'Wrighter Corner', 41.8388900756836, 0.730226387200658, -75.4727783203125, -1.31724847731725, 218, 45, 'PPL', 'P'),
(12967, 'Wrightland', 34.8372192382813, 0.608024177947119, -90.79638671875, -1.58469589715624, 218, 4, 'PPL', 'P'),
(29035, 'Wrights', 39.3758316040039, 0.687237907200708, -90.2941665649414, -1.57593050190241, 218, 18, 'PPL', 'P'),
(38975, 'Wrights', 37.3125, 0.651225977150384, -85.4000015258789, -1.49051120783477, 218, 21, 'PPL', 'P'),
(53073, 'Wrights', 38.582218170166, 0.673386739792179, -76.2347183227539, -1.3305468390625, 218, 25, 'PPL', 'P'),
(169150, 'Wrights', 41.7447204589844, 0.728582817333916, -78.2438888549805, -1.36561348008391, 218, 45, 'PPL', 'P'),
(112147, 'Wrights (historical)', 39.7066688537598, 0.693012106497191, -79.54638671875, -1.38834635630688, 218, 58, 'PPL', 'P'),
(12968, 'Wrights Corner', 35.355281829834, 0.617066075901129, -91.6227798461914, -1.59911917814594, 218, 4, 'PPL', 'P'),
(29036, 'Wrights Corner', 39.1294403076172, 0.682937567830503, -88.8663864135742, -1.55101103726643, 218, 18, 'PPL', 'P'),
(31569, 'Wrights Corner', 39.1355590820313, 0.683044360590215, -84.9572219848633, -1.48278324698358, 218, 19, 'PPL', 'P'),
(107828, 'Wrights Corner', 37.4991683959961, 0.654483955269933, -77.1383285522461, -1.34631781272185, 218, 53, 'PPL', 'P'),
(153946, 'Wrights Corner', 42.8586082458496, 0.748023826712467, -78.1041717529297, -1.36317495663177, 218, 40, 'PPL', 'P'),
(133813, 'Wrights Corners', 42.2036094665527, 0.736591941417193, -84.9619369506836, -1.48286553866126, 218, 27, 'PPL', 'P'),
(153948, 'Wrights Corners', 43.2177810668945, 0.754292575023377, -76.35888671875, -1.33271398639956, 218, 40, 'PPL', 'P'),
(169151, 'Wrights Corners', 41.8822212219238, 0.730982658371213, -78.4933319091797, -1.36996708267591, 218, 45, 'PPL', 'P'),
(177144, 'Wrights Corners', 44.0699996948242, 0.769166596027579, -91.4611129760742, -1.596297558971, 218, 57, 'PPL', 'P'),
(53074, 'Wrights Crossing', 39.6394386291504, 0.691838717720902, -78.929443359375, -1.37757866338747, 218, 25, 'PPL', 'P'),
(14929, 'Wrights Crossroads', 39.151668548584, 0.6833255238223, -75.7305603027344, -1.32174762166283, 218, 10, 'PPL', 'P'),
(107829, 'Wrights Fork', 37.9544410705566, 0.662429962435375, -77.3111114501953, -1.3493334431822, 218, 53, 'PPL', 'P'),
(6966, 'Wrights Landing', 34.8925018310547, 0.608989041210054, -87.9938888549805, -1.53578308215335, 218, 2, 'PPL', 'P'),
(26268, 'Wrights Mill', 32.610279083252, 0.569156739996985, -83.6547164916992, -1.46005023760255, 218, 13, 'PPL', 'P'),
(71618, 'Wrights Mill', 39.6847190856934, 0.692629010774383, -75.1763916015625, -1.31207555321588, 218, 37, 'PPL', 'P'),
(53075, 'Wrights Trailer Village', 39.4869384765625, 0.689177087948449, -76.1961135864258, -1.32987305930671, 218, 25, 'PPL', 'P'),
(169152, 'Wrights View', 41.3777809143066, 0.722178514123521, -76.51611328125, -1.33545810758677, 218, 45, 'PPL', 'P'),
(53076, 'Wrights Wharf', 38.711669921875, 0.675646099081975, -75.9086074829102, -1.32485513118079, 218, 25, 'PPL', 'P'),
(26269, 'Wrightsboro', 33.5502815246582, 0.585562877576309, -82.5691680908203, -1.44110384381745, 218, 13, 'PPL', 'P'),
(70393, 'Wrightsboro', 34.288330078125, 0.598444254873886, -77.92138671875, -1.35998475596197, 218, 33, 'PPL', 'P'),
(99216, 'Wrightsboro', 29.3736095428467, 0.512666199717901, -97.5647201538086, -1.70282560047083, 218, 51, 'PPL', 'P'),
(38976, 'Wrightsburg', 37.5913887023926, 0.656093503253749, -87.4030609130859, -1.52547118925451, 218, 21, 'PPL', 'P'),
(79453, 'Wrightsdale', 39.750560760498, 0.693778164784752, -76.1350021362305, -1.32880646329014, 218, 45, 'PPL', 'P'),
(74890, 'Wrightstown', 39.4761085510254, 0.688988070090081, -81.9736099243164, -1.43070939292482, 218, 41, 'PPL', 'P'),
(138951, 'Wrightstown', 46.2738914489746, 0.807631763495057, -95.1858291625977, -1.66130612012817, 218, 28, 'PPL', 'P'),
(146682, 'Wrightstown', 40.0361099243164, 0.698761937869699, -74.6183319091797, -1.30233557416113, 218, 37, 'PPL', 'P'),
(169153, 'Wrightstown', 40.2666702270508, 0.702785974276809, -74.9836120605469, -1.30871091549467, 218, 45, 'PPL', 'P'),
(177145, 'Wrightstown', 44.3258285522461, 0.773631651911206, -88.1627807617188, -1.53873080200591, 218, 57, 'PPL', 'P'),
(12969, 'Wrightsville', 34.6022186279297, 0.603922643552288, -92.216667175293, -1.60948446742464, 218, 4, 'PPL', 'P'),
(26270, 'Wrightsville', 32.7291717529297, 0.571231808539347, -82.7200012207031, -1.443736378555, 218, 13, 'PPL', 'P'),
(58371, 'Wrightsville', 36.4730606079102, 0.636574995887477, -89.9958267211914, -1.57072348933908, 218, 29, 'PPL', 'P'),
(70395, 'Wrightsville', 34.2205581665039, 0.597261411875727, -77.817497253418, -1.35817154273379, 218, 33, 'PPL', 'P'),
(74887, 'Wrightsville', 38.7027816772461, 0.675490969948478, -83.5122222900391, -1.45756324461858, 218, 41, 'PPL', 'P'),
(107830, 'Wrightsville', 38.0283317565918, 0.663719598193246, -77.331672668457, -1.34969230413908, 218, 53, 'PPL', 'P'),
(146684, 'Wrightsville', 40.1813888549805, 0.701297533543564, -74.5097198486328, -1.30043993609721, 218, 37, 'PPL', 'P'),
(169156, 'Wrightsville', 40.0255584716797, 0.69857778028032, -76.5302810668945, -1.33570538209399, 218, 45, 'PPL', 'P'),
(172826, 'Wrightsville', 44.3113899230957, 0.773379650293057, -72.5791702270508, -1.26674548882748, 218, 55, 'PPL', 'P'),
(70396, 'Wrightsville Beach', 34.2083282470703, 0.597047959514357, -77.7966690063477, -1.35780802124499, 218, 33, 'PPL', 'P'),
(74889, 'Wrightville', 39.8608283996582, 0.695702698146498, -83.2477798461914, -1.45294785329142, 218, 41, 'PPL', 'P'),
(114332, 'Wrightville', 41.8286094665527, 0.730046956722214, -73.1494369506836, -1.27669852076943, 218, 8, 'PPL', 'P'),
(186247, 'Wrightwood', 34.3608283996582, 0.59970958928681, -117.632499694824, -2.05307442702591, 218, 6, 'PPL', 'P'),
(38977, 'Wrigley', 38.0183296203613, 0.663545027983791, -83.2713928222656, -1.45335997747011, 218, 21, 'PPL', 'P'),
(92026, 'Wrigley', 35.9008293151855, 0.626587675746489, -87.3475036621094, -1.52450153230161, 218, 50, 'PPL', 'P'),
(26271, 'Wriley', 32.848331451416, 0.573311537613617, -83.158332824707, -1.45138670826041, 218, 13, 'PPL', 'P'),
(112148, 'Wriston', 38.0130615234375, 0.663453082347156, -81.20361328125, -1.41727041627401, 218, 58, 'PPL', 'P'),
(177148, 'Wuertsburg', 44.9602813720703, 0.784704942565701, -90.0988922119141, -1.57252232149738, 218, 57, 'PPL', 'P'),
(403, 'Wulfert', 26.4799995422363, 0.462163177938615, -82.1780624389648, -1.43427776246942, 218, 12, 'PPL', 'P'),
(186248, 'Wunpost', 35.9311103820801, 0.627116180064815, -120.86222076416, -2.10944369360685, 218, 6, 'PPL', 'P'),
(153958, 'Wurlitzer Park Village', 43.0605583190918, 0.751548520415187, -78.8530578613281, -1.37624548494577, 218, 40, 'PPL', 'P'),
(107832, 'Wurno', 37.0713882446289, 0.647017783153895, -80.7236099243164, -1.40889277727489, 218, 53, 'PPL', 'P'),
(153949, 'Wurtemburg', 41.8958282470703, 0.731220145761421, -73.8675003051758, -1.28923109054323, 218, 40, 'PPL', 'P'),
(169157, 'Wurtemburg', 40.8563919067383, 0.713078559257747, -80.2508316040039, -1.40064123895339, 218, 45, 'PPL', 'P'),
(38978, 'Wurtland', 38.5502815246582, 0.672829340176025, -82.7780609130859, -1.44474971134977, 218, 21, 'PPL', 'P'),
(153950, 'Wurtsboro', 41.5766716003418, 0.725649811446384, -74.4875030517578, -1.3000521798425, 218, 40, 'PPL', 'P'),
(153951, 'Wurtsboro Hills', 41.5911102294922, 0.725901813064533, -74.5061111450195, -1.30037695233743, 218, 40, 'PPL', 'P'),
(197889, 'Wurtz Hill', 48.9038887023926, 0.853533874885608, -114.389442443848, -1.99647240016569, 218, 31, 'PPL', 'P'),
(53077, 'Wuthering Heights', 38.7552795410156, 0.676407230521519, -76.5749969482422, -1.33648582145144, 218, 25, 'PPL', 'P'),
(99217, 'Wuthrich Hill', 30.6258296966553, 0.534521564361691, -97.3602828979492, -1.69925749724234, 218, 51, 'PPL', 'P'),
(139543, 'Wyaconda', 40.389720916748, 0.704933613958876, -91.9269409179688, -1.60442779030485, 218, 29, 'PPL', 'P'),
(169158, 'Wyalusing', 41.6680603027344, 0.72724484520226, -76.2622222900391, -1.33102687384899, 218, 45, 'PPL', 'P'),
(177149, 'Wyalusing', 42.9438896179199, 0.749512267445712, -91.1413879394531, -1.59071730438091, 218, 57, 'PPL', 'P'),
(153952, 'Wyandale', 42.5552787780762, 0.742729728781499, -78.7658309936523, -1.37472308890863, 218, 40, 'PPL', 'P'),
(153953, 'Wyandanch', 40.7538909912109, 0.711289580795486, -73.3608322143555, -1.28038806414363, 218, 40, 'PPL', 'P'),
(124054, 'Wyandot', 40.3452796936035, 0.70415796829139, -86.7494430541992, -1.5140634055671, 218, 19, 'PPL', 'P'),
(158478, 'Wyandot', 40.7313919067383, 0.710896897692754, -83.1197204589844, -1.45071279534657, 218, 41, 'PPL', 'P'),
(31570, 'Wyandotte', 38.2286109924316, 0.667215130282029, -86.2947235107422, -1.50612705236061, 218, 19, 'PPL', 'P'),
(38979, 'Wyandotte', 38.0497207641602, 0.664092906799048, -84.272216796875, -1.47082765105994, 218, 21, 'PPL', 'P'),
(44233, 'Wyandotte', 29.6897201538086, 0.518183370679677, -91.1711120605469, -1.59123608816125, 218, 22, 'PPL', 'P'),
(77729, 'Wyandotte', 36.7933311462402, 0.642164771278471, -94.7249984741211, -1.65326310732002, 218, 42, 'PPL', 'P'),
(133815, 'Wyandotte', 42.214168548584, 0.736776232164626, -83.1500015258789, -1.4512412996649, 218, 27, 'PPL', 'P'),
(139544, 'Wyandotte', 40.1300010681152, 0.700400647467452, -93.5449981689453, -1.63266821682016, 218, 29, 'PPL', 'P'),
(186249, 'Wyandotte', 39.4580612182617, 0.688673084712152, -121.466667175293, -2.11999327363298, 218, 6, 'PPL', 'P'),
(12970, 'Wyandotte (historical)', 34.3888893127441, 0.600199344611275, -92.720832824707, -1.61828381798237, 218, 4, 'PPL', 'P'),
(74891, 'Wyandotte (historical)', 39.6277809143066, 0.69163525221362, -82.8008270263672, -1.44514705498441, 218, 41, 'PPL', 'P'),
(122072, 'Wyanet', 41.3652801513672, 0.721960334651216, -89.5838928222656, -1.56353388650225, 218, 18, 'PPL', 'P'),
(138954, 'Wyanett', 45.5869407653809, 0.79564221226752, -93.4505615234375, -1.63101998642151, 218, 28, 'PPL', 'P'),
(169161, 'Wyano', 40.1972198486328, 0.701573836506659, -79.6975021362305, -1.39098381789244, 218, 45, 'PPL', 'P'),
(12971, 'Wyanoke', 35.103889465332, 0.612678451426196, -90.1900024414063, -1.57411249498426, 218, 4, 'PPL', 'P'),
(70397, 'Wyanoke', 36.5436096191406, 0.637806308417475, -76.9119415283203, -1.34236661377055, 218, 33, 'PPL', 'P'),
(209846, 'Wyarno', 44.8133316040039, 0.7821401852779, -106.773330688477, -1.86354617383462, 218, 59, 'PPL', 'P'),
(6967, 'Wyatt', 33.6988906860352, 0.588156596740964, -87.0783309936523, -1.51980358298066, 218, 2, 'PPL', 'P'),
(44234, 'Wyatt', 32.1552810668945, 0.561215526521505, -92.7030563354492, -1.61797355971538, 218, 22, 'PPL', 'P'),
(58372, 'Wyatt', 36.9091682434082, 0.644186510020005, -89.2225036621094, -1.55722645577651, 218, 29, 'PPL', 'P'),
(62398, 'Wyatt', 33.2330589294434, 0.580026298828089, -90.2202835083008, -1.57464099930259, 218, 30, 'PPL', 'P'),
(70399, 'Wyatt', 35.9372215270996, 0.627222839666473, -78.5430603027344, -1.37083500687517, 218, 33, 'PPL', 'P'),
(112149, 'Wyatt', 39.435001373291, 0.688270614492414, -80.3536071777344, -1.40243501110561, 218, 58, 'PPL', 'P'),
(124055, 'Wyatt', 41.5258293151855, 0.72476244617117, -86.1694412231445, -1.5039404639476, 218, 19, 'PPL', 'P'),
(92027, 'Wyatt (historical)', 35.8347206115723, 0.625433861204212, -85.0908279418945, -1.48511511083405, 218, 50, 'PPL', 'P'),
(107831, 'Wyatt (historical)', 37.1519393920898, 0.648423665893348, -79.8333282470703, -1.39335443073677, 218, 53, 'PPL', 'P'),
(44235, 'Wyatt Subdivision', 30.5958309173584, 0.533997986891381, -91.1527786254883, -1.59091610935628, 218, 22, 'PPL', 'P'),
(92028, 'Wyatt Village', 36.3222198486328, 0.633942327991879, -83.2822189331055, -1.45354892874945, 218, 50, 'PPL', 'P'),
(62395, 'Wyatte', 34.6416702270508, 0.604611203852128, -89.6941680908203, -1.56545855302205, 218, 30, 'PPL', 'P'),
(153954, 'Wyatts', 42.8511085510254, 0.74789293234489, -74.0100021362305, -1.29171821668526, 218, 40, 'PPL', 'P'),
(92029, 'Wyatts Chapel', 36.5511093139648, 0.637937202785052, -87.7461090087891, -1.53145850801723, 218, 50, 'PPL', 'P'),
(70398, 'Wyatts Crossroads', 34.4188919067383, 0.600722988660612, -78.8225021362305, -1.37571218693749, 218, 33, 'PPL', 'P'),
(138956, 'Wyattville', 43.9408302307129, 0.7669121635858, -91.7900009155273, -1.60203773638456, 218, 28, 'PPL', 'P'),
(169162, 'Wyattville', 41.4502792358398, 0.723443848536444, -79.8969421386719, -1.39446470259522, 218, 45, 'PPL', 'P'),
(77731, 'Wybark', 35.8113899230957, 0.625026663873539, -95.3313903808594, -1.66384664265005, 218, 42, 'PPL', 'P'),
(126716, 'Wyben', 42.1722183227539, 0.736044062601936, -72.7777786254883, -1.27021185930232, 218, 23, 'PPL', 'P'),
(12972, 'Wycamp', 34.5547218322754, 0.603093668083973, -90.7155609130859, -1.58328522072682, 218, 4, 'PPL', 'P'),
(107833, 'Wyche', 36.6258316040039, 0.639241352770864, -77.7955627441406, -1.35778871332709, 218, 53, 'PPL', 'P'),
(29038, 'Wyckles', 39.8530616760254, 0.695567143247013, -89.0288925170898, -1.55384730382736, 218, 18, 'PPL', 'P'),
(29039, 'Wyckles Corners', 39.8438911437988, 0.695407087265499, -89.0288925170898, -1.55384730382736, 218, 18, 'PPL', 'P'),
(146685, 'Wyckoff', 41.0094413757324, 0.715749776410124, -74.1733322143555, -1.29456886431608, 218, 37, 'PPL', 'P'),
(153955, 'Wyckoff', 42.8419418334961, 0.747732942942403, -76.5277786254883, -1.33566170625211, 218, 40, 'PPL', 'P'),
(146686, 'Wyckoff Mills', 40.2033309936523, 0.701680496108317, -74.2561111450195, -1.29601362920745, 218, 37, 'PPL', 'P'),
(146688, 'Wyckoffs Mills', 40.2797203063965, 0.703013741129038, -74.4861068725586, -1.30002781191852, 218, 37, 'PPL', 'P'),
(112150, 'Wyco', 37.5988883972168, 0.656224397621327, -81.3430633544922, -1.41970427919423, 218, 58, 'PPL', 'P'),
(186250, 'Wycoff (historical)', 38.8591690063477, 0.6782204437497, -121.944442749023, -2.12833203048018, 218, 6, 'PPL', 'P'),
(169163, 'Wycombe', 40.2822189331055, 0.703057350391888, -75.019172668457, -1.30933156518672, 218, 45, 'PPL', 'P'),
(209847, 'Wycross', 41.6805610656738, 0.727463024674565, -104.189437866211, -1.81844873656744, 218, 59, 'PPL', 'P'),
(169164, 'Wydnor', 40.5816688537598, 0.708283737452141, -75.3880615234375, -1.31576989028004, 218, 45, 'PPL', 'P'),
(12973, 'Wye', 34.9391708374023, 0.609803569029455, -92.6416702270508, -1.61690217000884, 218, 4, 'PPL', 'P'),
(197890, 'Wye', 46.9530601501465, 0.819485493506999, -114.120559692383, -1.99177951085081, 218, 31, 'PPL', 'P'),
(53078, 'Wye Acres', 38.8944396972656, 0.678836033435672, -76.1805572509766, -1.32960155003358, 218, 25, 'PPL', 'P'),
(53079, 'Wye Creek', 39.3813896179199, 0.687334912843414, -77.4875030517578, -1.35241205740233, 218, 25, 'PPL', 'P'),
(53083, 'Wye Harbor', 38.9652786254883, 0.680072405971741, -76.1686096191406, -1.32939302452023, 218, 25, 'PPL', 'P'),
(53080, 'Wye Heights', 38.8808288574219, 0.678598479466437, -76.0991668701172, -1.32818101990813, 218, 25, 'PPL', 'P'),
(53081, 'Wye Landing', 38.892219543457, 0.678797284441811, -76.1030578613281, -1.32824893051593, 218, 25, 'PPL', 'P'),
(53082, 'Wye Mills', 38.9411087036133, 0.679650561255072, -76.0808334350586, -1.32786104110316, 218, 25, 'PPL', 'P'),
(53090, 'Wye River Farms', 38.9500007629395, 0.679805756967597, -76.1624984741211, -1.32928636491857, 218, 25, 'PPL', 'P'),
(169165, 'Wyebrooke', 40.1058311462402, 0.699978802750784, -75.8349990844727, -1.32357042227093, 218, 45, 'PPL', 'P'),
(139545, 'Wyeth', 40.0250015258789, 0.698568059742341, -94.8019409179688, -1.65460600629969, 218, 29, 'PPL', 'P'),
(186251, 'Wyeth', 36.5194396972656, 0.637384463700806, -119.265830993652, -2.08158143596633, 218, 6, 'PPL', 'P'),
(6968, 'Wyeth City', 34.3455581665039, 0.59944307344072, -86.2819366455078, -1.50590387946126, 218, 2, 'PPL', 'P'),
(38980, 'Wyett', 38.1097183227539, 0.665140061739667, -83.2536087036133, -1.45304958604506, 218, 21, 'PPL', 'P'),
(177151, 'Wyeville', 44.0283317565918, 0.768439353312905, -90.3844375610352, -1.5775060280033, 218, 57, 'PPL', 'P'),
(153956, 'Wykagyl', 40.9413909912109, 0.714562073142976, -73.7994384765625, -1.288043187539, 218, 40, 'PPL', 'P'),
(153957, 'Wykagyl Park', 40.9416694641113, 0.714566933411965, -73.7858276367188, -1.28780563356977, 218, 40, 'PPL', 'P'),
(146689, 'Wykertown', 41.1738891601563, 0.718619931695929, -74.7005615234375, -1.30377075167258, 218, 37, 'PPL', 'P'),
(138958, 'Wykoff', 43.707218170166, 0.762834863956888, -92.2680587768555, -1.61038142007978, 218, 28, 'PPL', 'P'),
(138959, 'Wykoff Mobile Home Park I', 43.7105598449707, 0.762893187184761, -92.2633285522461, -1.61029886208599, 218, 28, 'PPL', 'P'),
(138960, 'Wykoff Mobile Home Park II', 43.707218170166, 0.762834863956888, -92.2633285522461, -1.61029886208599, 218, 28, 'PPL', 'P'),
(6969, 'Wylam', 33.5058288574219, 0.584787032171741, -86.9252777099609, -1.51713229924925, 218, 2, 'PPL', 'P'),
(169166, 'Wylandville', 40.1938896179199, 0.701515713015868, -80.1338882446289, -1.39860019229395, 218, 45, 'PPL', 'P'),
(6970, 'Wylaunee', 31.999439239502, 0.558495573521179, -85.0947189331055, -1.48518302144185, 218, 2, 'PPL', 'P'),
(186252, 'Wyldewood', 38.1458282470703, 0.665770298811634, -120.453056335449, -2.1023024271438, 218, 6, 'PPL', 'P'),
(99218, 'Wyldwood', 30.1291694641113, 0.525853208040078, -97.4725036621094, -1.70121611906604, 218, 51, 'PPL', 'P'),
(12975, 'Wyles (historical)', 34.9597206115723, 0.610162230249262, -90.706672668457, -1.58313009159333, 218, 4, 'PPL', 'P'),
(58373, 'Wylie', 36.6599998474121, 0.63983770111796, -94.3327789306641, -1.64641758489602, 218, 29, 'PPL', 'P'),
(99220, 'Wylie', 32.3727798461914, 0.565011596339304, -99.7750015258789, -1.74140228780895, 218, 51, 'PPL', 'P'),
(138962, 'Wylie', 47.9619407653809, 0.837093782002385, -96.352783203125, -1.68167331035482, 218, 28, 'PPL', 'P'),
(169167, 'Wylie', 40.2783317565918, 0.702989506363118, -79.8791732788086, -1.39415457748628, 218, 45, 'PPL', 'P'),
(12977, 'Wylie Spur', 35.1986083984375, 0.614331608672863, -90.2486114501953, -1.57513541515896, 218, 4, 'PPL', 'P'),
(107834, 'Wylliesburg', 36.855281829834, 0.643246014681043, -78.5905609130859, -1.37166404892251, 218, 53, 'PPL', 'P'),
(112151, 'Wylo', 37.6763916015625, 0.657577083718005, -81.8472213745117, -1.42850349659391, 218, 58, 'PPL', 'P'),
(12978, 'Wyloe (historical)', 33.7483291625977, 0.58901946093415, -92.9452819824219, -1.62220119478782, 218, 4, 'PPL', 'P'),
(26272, 'Wyloway', 33.8944396972656, 0.591569570835955, -84.1716690063477, -1.46907276105963, 218, 13, 'PPL', 'P'),
(12979, 'Wyman', 36.0750007629395, 0.62962754097276, -94.0691680908203, -1.6418167077968, 218, 4, 'PPL', 'P'),
(38981, 'Wyman', 37.6322212219238, 0.656806165161455, -87.3324966430664, -1.5242396104084, 218, 21, 'PPL', 'P'),
(118533, 'Wyman', 41.1922187805176, 0.718939843921875, -91.4738922119141, -1.5965205987123, 218, 16, 'PPL', 'P'),
(129393, 'Wyman', 44.5077781677246, 0.776807271774043, -67.8597183227539, -1.18437551420798, 218, 26, 'PPL', 'P'),
(133817, 'Wyman', 43.4550018310547, 0.758432858412069, -85.0430603027344, -1.4842814082548, 218, 27, 'PPL', 'P'),
(138964, 'Wyman', 47.5325012207031, 0.829598648009493, -92.1074981689453, -1.60757910882274, 218, 28, 'PPL', 'P'),
(153959, 'Wyman Corner', 42.1997184753418, 0.736524030809396, -75.76611328125, -1.32236813819682, 218, 40, 'PPL', 'P'),
(26274, 'Wymberly', 33.5055618286133, 0.584782371639834, -82.1497192382813, -1.43378308029694, 218, 13, 'PPL', 'P'),
(26275, 'Wymberly on the Marsh', 31.9844398498535, 0.558233784786025, -81.0644378662109, -1.41484134704375, 218, 13, 'PPL', 'P'),
(26276, 'Wymberly-On-The-Marsh', 31.1774997711182, 0.54415002354579, -81.3816680908203, -1.42037805895002, 218, 13, 'PPL', 'P'),
(112153, 'Wymer', 38.8933296203613, 0.678816658938741, -79.6188888549805, -1.38961175729883, 218, 58, 'PPL', 'P'),
(209229, 'Wymer', 46.8261108398438, 0.817269810059081, -120.458610534668, -2.10239936620748, 218, 56, 'PPL', 'P'),
(179580, 'Wymola', 32.6580581665039, 0.569990642313316, -111.40389251709, -1.94436472396109, 218, 5, 'PPL', 'P'),
(143430, 'Wymore', 40.1222190856934, 0.700264826251858, -96.6622161865234, -1.68707393472939, 218, 35, 'PPL', 'P'),
(112154, 'Wymps Gap', 39.7200012207031, 0.693244800197436, -79.7505569458008, -1.39190979900346, 218, 58, 'PPL', 'P'),
(53084, 'Wyn Lea at Fair Hill', 39.6963882446289, 0.692832676018747, -75.9047164916992, -1.32478722057299, 218, 25, 'PPL', 'P'),
(209228, 'Wynaco', 47.3161087036133, 0.825821886109598, -122.138328552246, -2.13171597611929, 218, 56, 'PPL', 'P'),
(153960, 'Wynantskill', 42.6966705322266, 0.745197480426593, -73.6447219848633, -1.28534287535172, 218, 40, 'PPL', 'P'),
(177153, 'Wynbrooke', 43.1955604553223, 0.753904752189634, -89.2808303833008, -1.55824444910319, 218, 57, 'PPL', 'P'),
(129395, 'Wynburg (historical)', 43.815559387207, 0.764725774909872, -69.8536071777344, -1.21917543964621, 218, 26, 'PPL', 'P'),
(169168, 'Wyncote', 40.0944404602051, 0.699779997775409, -75.149169921875, -1.31160044527741, 218, 45, 'PPL', 'P'),
(112155, 'Wyndal', 38.2144393920898, 0.666967789195788, -81.1822204589844, -1.41689704108918, 218, 58, 'PPL', 'P'),
(107836, 'Wyndale', 36.6805610656738, 0.640196562074848, -82.07861328125, -1.43254204722896, 218, 53, 'PPL', 'P'),
(107837, 'Wyndham', 37.6983299255371, 0.657959979703731, -77.6127777099609, -1.35459851265728, 218, 53, 'PPL', 'P'),
(26277, 'Wyndham Farms', 34.1272201538086, 0.595632356236926, -84.2816696166992, -1.47099263388947, 218, 13, 'PPL', 'P'),
(79450, 'Wyndham Hills', 39.9397201538086, 0.697079619009096, -76.73388671875, -1.33925897109454, 218, 45, 'PPL', 'P'),
(53085, 'Wyndham Woods', 39.1105613708496, 0.682608068224633, -76.904167175293, -1.34223092571301, 218, 25, 'PPL', 'P'),
(141111, 'Wyndmere', 46.2666702270508, 0.807505729396469, -97.1319427490234, -1.69527220982909, 218, 34, 'PPL', 'P'),
(169169, 'Wyndmoor', 40.0811080932617, 0.699547304075163, -75.1897201538086, -1.3123081803371, 218, 45, 'PPL', 'P'),
(169170, 'Wyndmoor Estates', 40.103328704834, 0.699935126908906, -75.0666732788086, -1.31016060723406, 218, 45, 'PPL', 'P'),
(79451, 'Wyndom', 39.9094390869141, 0.69655111469077, -75.3099975585938, -1.31440741706635, 218, 45, 'PPL', 'P'),
(107838, 'Wyndover Woods', 36.589168548584, 0.638601461739945, -79.4602813720703, -1.38684353450374, 218, 53, 'PPL', 'P'),
(53086, 'Wynfield', 39.2944412231445, 0.68581737707526, -76.9416732788086, -1.34288553070895, 218, 25, 'PPL', 'P'),
(26278, 'Wynford Chase', 33.9222183227539, 0.592054399312404, -84.6391677856445, -1.47723215400742, 218, 13, 'PPL', 'P'),
(53087, 'Wyngate', 39.0105590820313, 0.680862699025222, -77.1224975585938, -1.34604150975875, 218, 25, 'PPL', 'P'),
(107839, 'Wyngate', 38.107780456543, 0.665106239593823, -78.508056640625, -1.3702240777211, 218, 53, 'PPL', 'P'),
(107840, 'Wynkoop Mobile Home Park', 39.1188888549805, 0.682753410241124, -77.8688888549805, -1.35906849538893, 218, 53, 'PPL', 'P'),
(112156, 'Wynkoop Spring', 39.4361114501953, 0.688289988989344, -77.8611068725586, -1.35893267417333, 218, 58, 'PPL', 'P'),
(107841, 'Wynmere', 37.2461090087891, 0.650067235760091, -80.0219421386719, -1.39664636416022, 218, 53, 'PPL', 'P'),
(169171, 'Wynmere Downs', 40.1888885498047, 0.701428427911141, -75.1800003051758, -1.31213853697566, 218, 45, 'PPL', 'P'),
(92030, 'Wynn', 36.4702796936035, 0.63652645977661, -84.0516662597656, -1.46697831802034, 218, 50, 'PPL', 'P'),
(169172, 'Wynn Wood Manor', 40.0138893127441, 0.698374115035956, -76.351936340332, -1.3325926794119, 218, 45, 'PPL', 'P'),
(92031, 'Wynnburg', 36.3286094665527, 0.634053847862526, -89.4733276367188, -1.56160415997638, 218, 50, 'PPL', 'P'),
(12981, 'Wynne', 35.2244415283203, 0.614782481845413, -90.7866668701172, -1.5845262537948, 218, 4, 'PPL', 'P'),
(53088, 'Wynne', 38.1097183227539, 0.665140061739667, -76.4055633544922, -1.33352864737701, 218, 25, 'PPL', 'P'),
(169173, 'Wynnebrook Manor', 40.0016708374023, 0.698160862411668, -75.279167175293, -1.3138693253681, 218, 45, 'PPL', 'P'),
(31571, 'Wynnedale', 39.8311080932617, 0.695183980945178, -86.1975021362305, -1.50443021927207, 218, 19, 'PPL', 'P'),
(79452, 'Wynnefield', 39.9897193908691, 0.697952270319288, -75.2380599975586, -1.31315186977043, 218, 45, 'PPL', 'P'),
(169174, 'Wynnefield Heights', 40.0033302307129, 0.698189824288523, -75.2050018310547, -1.31257489592027, 218, 45, 'PPL', 'P'),
(18675, 'Wynnehaven Beach', 30.4099998474121, 0.530754622868315, -86.7822189331055, -1.51463545256925, 218, 12, 'PPL', 'P'),
(14922, 'Wynnewood', 39.8224983215332, 0.69503371208067, -75.5013885498047, -1.31774782002164, 218, 10, 'PPL', 'P'),
(53089, 'Wynnewood', 39.2347183227539, 0.684775015824603, -76.6972198486328, -1.33861901348459, 218, 25, 'PPL', 'P'),
(77732, 'Wynnewood', 34.6433296203613, 0.604640165728982, -97.1641693115234, -1.69583466945132, 218, 42, 'PPL', 'P'),
(107842, 'Wynnewood', 36.8705596923828, 0.643512663685188, -76.4277801513672, -1.33391640363173, 218, 53, 'PPL', 'P'),
(169175, 'Wynnewood', 40.0027809143066, 0.698180236908599, -75.271110534668, -1.31372871046255, 218, 45, 'PPL', 'P'),
(26279, 'Wynngate', 33.5194396972656, 0.585024586140977, -82.0899963378906, -1.43274071904628, 218, 13, 'PPL', 'P'),
(18676, 'Wynnlum', 30.9708309173584, 0.54054297158636, -85.5899963378906, -1.49382724286608, 218, 12, 'PPL', 'P'),
(26280, 'Wynnmeade', 33.4055595397949, 0.583037002440423, -84.6125030517578, -1.47676676660692, 218, 13, 'PPL', 'P'),
(31572, 'Wynnsboro (historical)', 38.2869415283203, 0.668233190187739, -86.2563934326172, -1.50545806629478, 218, 19, 'PPL', 'P'),
(26281, 'Wynnton', 32.4674987792969, 0.56666475358597, -84.9508285522461, -1.4826716605339, 218, 13, 'PPL', 'P'),
(6971, 'Wynnville', 34.0808296203613, 0.594822688686514, -86.3936080932617, -1.50785291390504, 218, 2, 'PPL', 'P'),
(186253, 'Wynola', 33.0974998474121, 0.577660346515662, -116.644721984863, -2.03583445370928, 218, 6, 'PPL', 'P'),
(77733, 'Wynona', 36.5461082458496, 0.637849917680325, -96.3269424438477, -1.68122230402421, 218, 42, 'PPL', 'P'),
(29040, 'Wynoose', 38.5986099243164, 0.673672829872281, -88.2219390869141, -1.53976330956053, 218, 18, 'PPL', 'P'),
(143428, 'Wynot', 42.7402801513672, 0.745958611866138, -97.1688919067383, -1.69591709428705, 218, 35, 'PPL', 'P'),
(26283, 'Wynterhall', 33.9533309936523, 0.592597417858671, -84.3413925170898, -1.47203499514013, 218, 13, 'PPL', 'P'),
(194071, 'Wyntoon', 41.1916694641113, 0.718930256541951, -122.063331604004, -2.13040703244352, 218, 6, 'PPL', 'P'),
(18677, 'Wynwood', 28.7894401550293, 0.502470520511128, -81.2525024414063, -1.41812369308727, 218, 12, 'PPL', 'P'),
(70404, 'Wyo', 36.0491714477539, 0.629176734379237, -80.5638885498047, -1.40610511340385, 218, 33, 'PPL', 'P'),
(186254, 'Wyo', 39.7705612182617, 0.694127238624634, -122.190277099609, -2.13262264931241, 218, 6, 'PPL', 'P'),
(169176, 'Wyoanna', 41.4305610656738, 0.723099701544579, -75.8338928222656, -1.32355111435303, 218, 45, 'PPL', 'P'),
(177154, 'Wyocena', 43.4958305358887, 0.759145453740747, -89.3083267211914, -1.55872435073162, 218, 57, 'PPL', 'P'),
(209848, 'Wyocolo', 41.0044403076172, 0.715662491305396, -106.171943664551, -1.85304999018835, 218, 59, 'PPL', 'P'),
(209849, 'Wyodak', 44.291389465332, 0.773030576453175, -105.379173278809, -1.83921353674484, 218, 59, 'PPL', 'P'),
(12983, 'Wyola', 35.8586082458496, 0.625850779072864, -94.0583267211914, -1.64162749020135, 218, 4, 'PPL', 'P'),
(169177, 'Wyola', 40.0080604553223, 0.698272382282315, -75.4188919067383, -1.31630798197829, 218, 45, 'PPL', 'P'),
(197891, 'Wyola', 45.1294403076172, 0.787657322950163, -107.392501831055, -1.87435274890594, 218, 31, 'PPL', 'P'),
(112157, 'Wyoma', 38.7633285522461, 0.676547712269021, -82.1288909912109, -1.43341955880814, 218, 58, 'PPL', 'P'),
(126717, 'Wyoma', 42.4855613708496, 0.741512930479441, -70.9583282470703, -1.23845645962227, 218, 23, 'PPL', 'P'),
(153961, 'Wyomanock', 42.517219543457, 0.742065469826605, -73.3608322143555, -1.28038806414363, 218, 40, 'PPL', 'P'),
(14923, 'Wyoming', 39.1180610656738, 0.68273896259221, -75.5591735839844, -1.31875635912645, 218, 10, 'PPL', 'P'),
(38982, 'Wyoming', 38.2197189331055, 0.667059934569505, -83.6986083984375, -1.46081629589011, 218, 21, 'PPL', 'P'),
(74892, 'Wyoming', 39.2311096191406, 0.684712032064823, -84.4658279418945, -1.47420680300909, 218, 41, 'PPL', 'P'),
(112158, 'Wyoming', 37.582218170166, 0.655933447272236, -81.601936340332, -1.42422246514161, 218, 58, 'PPL', 'P'),
(118534, 'Wyoming', 42.0591697692871, 0.734070993129324, -91.0072174072266, -1.5883755868344, 218, 16, 'PPL', 'P'),
(122074, 'Wyoming', 41.0616683959961, 0.716661309872231, -89.773063659668, -1.56683554046368, 218, 18, 'PPL', 'P'),
(126718, 'Wyoming', 42.4541702270508, 0.740965051664185, -71.0694427490234, -1.24039577352807, 218, 23, 'PPL', 'P'),
(133819, 'Wyoming', 47.417781829834, 0.827596416922945, -88.0824966430664, -1.53732957979836, 218, 27, 'PPL', 'P'),
(138965, 'Wyoming', 45.3363914489746, 0.79126930175761, -92.996940612793, -1.62310280797487, 218, 28, 'PPL', 'P'),
(143429, 'Wyoming', 40.7355613708496, 0.710969668569541, -95.9191665649414, -1.67410527232709, 218, 35, 'PPL', 'P'),
(146690, 'Wyoming', 40.7291717529297, 0.710858148698894, -74.2916717529297, -1.29663427889949, 218, 37, 'PPL', 'P'),
(153962, 'Wyoming', 42.8263893127441, 0.747461500248297, -78.0899963378906, -1.36292754896651, 218, 40, 'PPL', 'P'),
(169179, 'Wyoming', 40.0222206115723, 0.698519523631475, -75.1449966430664, -1.31152760782159, 218, 45, 'PPL', 'P'),
(169687, 'Wyoming', 41.5152816772461, 0.724578355160818, -71.7019424438477, -1.25143497572061, 218, 47, 'PPL', 'P'),
(177157, 'Wyoming', 43.1261100769043, 0.752692614419485, -90.1116714477539, -1.57274536123867, 218, 57, 'PPL', 'P'),
(209851, 'Wyoming', 43.0002784729004, 0.750496438626551, -107.500282287598, -1.87623387274192, 218, 59, 'ADM1', 'A'),
(58374, 'Wyoming (historical)', 38.7874984741211, 0.67696955698569, -94.272216796875, -1.64536057625937, 218, 29, 'PPL', 'P'),
(112159, 'Wyoming (historical)', 38.9736099243164, 0.680217814567259, -79.4277801513672, -1.38627628119156, 218, 58, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(112160, 'Wyoming City', 37.5097198486328, 0.654668112859312, -81.9286117553711, -1.42992402671936, 218, 58, 'PPL', 'P'),
(74893, 'Wyoming Meadows', 39.2402801513672, 0.684872088046336, -84.495002746582, -1.47471599940951, 218, 41, 'PPL', 'P'),
(169181, 'Wyomissing', 40.3294410705566, 0.70388153217024, -75.9655609130859, -1.32584915605766, 218, 45, 'PPL', 'P'),
(169188, 'Wyomissing Hills', 40.3375015258789, 0.704022213654824, -75.9800033569336, -1.32610122425484, 218, 45, 'PPL', 'P'),
(209852, 'Wyopo', 42.8555603027344, 0.747970630069693, -108.688606262207, -1.89697403867924, 218, 59, 'PPL', 'P'),
(139546, 'Wyreka', 40.5294418334961, 0.707372203990034, -93.2647171020508, -1.62777638937185, 218, 29, 'PPL', 'P'),
(92033, 'Wyricktown', 36.0555610656738, 0.629288254249884, -83.7330627441406, -1.46141763766425, 218, 50, 'PPL', 'P'),
(84546, 'Wyses Ferry', 34.1138916015625, 0.595399729115707, -81.5955581665039, -1.42411114500804, 218, 48, 'PPL', 'P'),
(169185, 'Wyside', 41.3147201538086, 0.721077896224018, -78.0808334350586, -1.36276762614305, 218, 45, 'PPL', 'P'),
(38984, 'Wysox', 37.2730598449707, 0.650537616587626, -86.9077835083008, -1.51682696783028, 218, 21, 'PPL', 'P'),
(169186, 'Wysox', 41.7744407653809, 0.729101534535236, -76.3997192382813, -1.33342664830726, 218, 45, 'PPL', 'P'),
(107848, 'Wythe', 37.003059387207, 0.645825219617758, -76.378059387207, -1.33304861259053, 218, 53, 'PPL', 'P'),
(107844, 'Wytheville', 36.9483299255371, 0.644870010313774, -81.0849990844727, -1.41520020800064, 218, 53, 'PPL', 'P'),
(122078, 'Wyton', 40.1294403076172, 0.700390860350446, -87.6433334350586, -1.529664735865, 218, 18, 'PPL', 'P'),
(129396, 'Wytopitlock', 45.6405601501465, 0.796578047074574, -68.0761108398438, -1.18815227610788, 218, 26, 'PPL', 'P'),
(197892, 'X Crossing', 47.7033309936523, 0.832580190007892, -107.781936645508, -1.88114966864004, 218, 31, 'PPL', 'P'),
(62396, 'X-Prairie', 33.1469383239746, 0.578523210708848, -88.4647216796875, -1.54400066517096, 218, 30, 'PPL', 'P'),
(206618, 'Xanadu', 40.6672210693359, 0.709776905296321, -111.911109924316, -1.95321733774062, 218, 52, 'PPL', 'P'),
(34474, 'Xavier', 39.2772216796875, 0.685516839346245, -94.9088897705078, -1.65647261590773, 218, 20, 'PPL', 'P'),
(29041, 'Xenia', 38.6358299255371, 0.674322441441178, -88.6347198486328, -1.54696769294141, 218, 18, 'PPL', 'P'),
(34475, 'Xenia', 37.9952812194824, 0.663142757501134, -94.9861068725586, -1.65782030857736, 218, 20, 'PPL', 'P'),
(74895, 'Xenia', 39.6847190856934, 0.692629010774383, -83.9297180175781, -1.46484991967715, 218, 41, 'PPL', 'P'),
(118537, 'Xenia', 42.3111114501953, 0.738468204984181, -93.0805587768555, -1.62456222025223, 218, 16, 'PPL', 'P'),
(194484, 'Xenia', 40.1611099243164, 0.700943599434692, -103.344436645508, -1.8037006830828, 218, 7, 'PPL', 'P'),
(92032, 'Xenophon', 36.4908294677734, 0.636885120996416, -83.3263931274414, -1.45431991388503, 218, 50, 'PPL', 'P'),
(99221, 'XX Farms Colonia', 26.3360004425049, 0.459649919528394, -97.4929962158203, -1.70157378160044, 218, 51, 'PPL', 'P'),
(12984, 'Y City', 34.7347183227539, 0.606235199484858, -94.0769424438477, -1.64195239585434, 218, 4, 'PPL', 'P'),
(209853, 'Y-O Ranch', 42.0308303833008, 0.733576377535869, -104.939437866211, -1.83153870595739, 218, 59, 'PPL', 'P'),
(197893, 'Yaak', 48.8330612182617, 0.85229770208662, -115.707778930664, -2.01948171250981, 218, 31, 'PPL', 'P'),
(201835, 'Yachats', 44.3113899230957, 0.773379650293057, -124.103607177734, -2.16601655885313, 218, 43, 'PPL', 'P'),
(26284, 'Yacht Club Estates', 34.1136093139648, 0.595394802267691, -84.6552810668945, -1.47751338381853, 218, 13, 'PPL', 'P'),
(84547, 'Yacht Club Estates', 32.4058303833008, 0.565588437031415, -80.6661071777344, -1.4078891650181, 218, 48, 'PPL', 'P'),
(84548, 'Yacht Cove', 34.0708312988281, 0.594648185056087, -81.2324981689453, -1.41777455266836, 218, 48, 'PPL', 'P'),
(112633, 'Yacht Haven', 38.7019386291504, 0.675476255983455, -77.1127777099609, -1.34587186639731, 218, 53, 'PPL', 'P'),
(209230, 'Yacht Haven', 48.5852813720703, 0.847973127950495, -123.166938781738, -2.14966861134363, 218, 56, 'PPL', 'P'),
(158481, 'Yacht Point Cottage Area', 40.7422218322754, 0.711085915551123, -82.3666687011719, -1.43756956273481, 218, 41, 'PPL', 'P'),
(209231, 'Yacolt', 45.8661117553711, 0.800514665218902, -122.404998779297, -2.13637024959837, 218, 56, 'PPL', 'P'),
(153964, 'Yaddo', 43.0675010681152, 0.751669694244785, -73.7586135864258, -1.28733065878935, 218, 40, 'PPL', 'P'),
(38983, 'Yaden', 36.7402801513672, 0.641238856746478, -84.1022186279297, -1.46786062328948, 218, 21, 'PPL', 'P'),
(70405, 'Yadkin', 35.7211112976074, 0.623451004614594, -80.399169921875, -1.40323023100711, 218, 33, 'PPL', 'P'),
(107845, 'Yadkin', 36.7633285522461, 0.641641127229135, -76.3622207641602, -1.33277217646938, 218, 53, 'PPL', 'P'),
(12985, 'Yadkin (historical)', 36.3747215270996, 0.634858655143948, -91.2444381713867, -1.59251587022309, 218, 4, 'PPL', 'P'),
(70408, 'Yadkin Junction', 35.670280456543, 0.622563839076461, -80.4594421386719, -1.40428217963769, 218, 33, 'PPL', 'P'),
(70410, 'Yadkin Valley', 36.0222206115723, 0.628706353551701, -81.4902801513672, -1.42227369701394, 218, 33, 'PPL', 'P'),
(70414, 'Yadkinville', 36.1344413757324, 0.6306649753754, -80.6597213745117, -1.40777771172648, 218, 33, 'PPL', 'P'),
(92034, 'Yager', 35.7313919067383, 0.623630435093038, -85.8144378662109, -1.49774448651348, 218, 50, 'PPL', 'P'),
(194072, 'Yager Junction', 40.5483283996582, 0.707701836753959, -123.823333740234, -2.16112486456288, 218, 6, 'PPL', 'P'),
(153965, 'Yagerville', 41.8452796936035, 0.730337907071305, -74.413330078125, -1.29875761723661, 218, 40, 'PPL', 'P'),
(129397, 'Yagger', 44.2108306884766, 0.771624560555668, -70.6352767944336, -1.23281814812041, 218, 26, 'PPL', 'P'),
(34476, 'Yaggy', 38.0969390869141, 0.664917021998373, -98.0086135864258, -1.71057300239798, 218, 20, 'PPL', 'P'),
(189835, 'Yah-ta-hey', 35.628059387207, 0.621826942402836, -108.779716491699, -1.89856421216613, 218, 38, 'PPL', 'P'),
(107846, 'Yahley Mills Estates', 37.4558296203613, 0.653727550941323, -77.2861099243164, -1.34889708423759, 218, 53, 'PPL', 'P'),
(77734, 'Yahola', 35.7625007629395, 0.624173387060278, -95.6066665649414, -1.6686511184146, 218, 42, 'PPL', 'P'),
(209233, 'Yakima', 46.6022186279297, 0.813362153791607, -120.504722595215, -2.1032041734889, 218, 56, 'PPL', 'P'),
(197894, 'Yakt', 48.5455589294434, 0.84727984053972, -115.967781066895, -2.02401960584925, 218, 31, 'PPL', 'P'),
(197895, 'Yakt (historical)', 48.0269393920898, 0.838228222047732, -115.005561828613, -2.00722571201521, 218, 31, 'PPL', 'P'),
(193331, 'Yakutat', 59.5469398498535, 1.03929015986696, -139.72721862793, -2.43870001971133, 218, 1, 'PPL', 'P'),
(18678, 'Yalaha', 28.7383308410645, 0.501578494704006, -81.8088912963867, -1.42783451052808, 218, 12, 'PPL', 'P'),
(18679, 'Yalaka (historical)', 28.3999996185303, 0.495673500908487, -81.1666717529297, -1.4166256649741, 218, 12, 'PPL', 'P'),
(186257, 'Yaldora', 33.232780456543, 0.580021438559099, -117.392776489258, -2.04889046779534, 218, 6, 'PPL', 'P'),
(12986, 'Yale', 35.6711082458496, 0.622578286725375, -93.6505584716797, -1.63451059166228, 218, 4, 'PPL', 'P'),
(29043, 'Yale', 39.1197204589844, 0.682767924469065, -88.0247192382813, -1.5363211738516, 218, 18, 'PPL', 'P'),
(34477, 'Yale', 37.4838905334473, 0.654217306265788, -94.6416702270508, -1.65180875504873, 218, 20, 'PPL', 'P'),
(77735, 'Yale', 36.1141700744629, 0.630311174424583, -96.6988906860352, -1.68771402549739, 218, 42, 'PPL', 'P'),
(107847, 'Yale', 36.8455581665039, 0.643076304740578, -77.2877807617188, -1.34892624585152, 218, 53, 'PPL', 'P'),
(118538, 'Yale', 41.776668548584, 0.729140416687151, -94.357780456543, -1.64685394384063, 218, 16, 'PPL', 'P'),
(133822, 'Yale', 43.1300010681152, 0.752760525027282, -82.7983322143555, -1.44510351230059, 218, 27, 'PPL', 'P'),
(153966, 'Yale', 42.8063888549805, 0.747112426408415, -76.920280456543, -1.34251215552412, 218, 40, 'PPL', 'P'),
(158482, 'Yale', 41.0625, 0.716675824100172, -81.0986099243164, -1.41543776196987, 218, 41, 'PPL', 'P'),
(171660, 'Yale', 44.4338912963867, 0.7755177025952, -97.9897232055664, -1.71024330305503, 218, 49, 'PPL', 'P'),
(209235, 'Yale', 45.9955596923828, 0.80277395792967, -122.378890991211, -2.13591458273586, 218, 56, 'PPL', 'P'),
(84549, 'Yale (historical)', 33.2811088562012, 0.580864928255355, -81.3330612182617, -1.41952970898478, 218, 48, 'PPL', 'P'),
(209870, 'Yale (historical)', 46.8622207641602, 0.817900047131048, -116.695556640625, -2.03672168582644, 218, 17, 'PPL', 'P'),
(192871, 'Yale Crossing', 37.8650016784668, 0.660868950562425, -113.748062133789, -1.98527820199771, 218, 52, 'PPL', 'P'),
(144709, 'Yale Estates', 43.5299987792969, 0.759741802087843, -71.3466720581055, -1.24523433775458, 218, 36, 'PPL', 'P'),
(114333, 'Yalesville', 41.4936103820801, 0.724200119707, -72.8241729736328, -1.27102159343176, 218, 8, 'PPL', 'P'),
(153967, 'Yaleville', 44.767219543457, 0.781335377996478, -74.9927825927734, -1.30887097147619, 218, 40, 'PPL', 'P'),
(133824, 'Yalmar', 46.4061088562012, 0.80993939257961, -87.2411117553711, -1.52264464323156, 218, 27, 'PPL', 'P'),
(58375, 'Yama', 36.2599983215332, 0.632856357478372, -89.9430618286133, -1.56980256823413, 218, 29, 'PPL', 'P'),
(38985, 'Yamacraw', 36.7169418334961, 0.64083152625775, -84.5374984741211, -1.4754576897731, 218, 21, 'PPL', 'P'),
(70416, 'Yamacraw', 34.4947204589844, 0.602046446564327, -78.1108322143555, -1.36329120361336, 218, 33, 'PPL', 'P'),
(62399, 'Yamacraw (historical)', 30.6324996948242, 0.534637977790841, -89.8000030517578, -1.56730572155413, 218, 30, 'PPL', 'P'),
(18680, 'Yamassee (historical)', 30.6666698455811, 0.53523435942745, -84.9499969482422, -1.48265714630596, 218, 12, 'PPL', 'P'),
(18681, 'Yamato', 26.4094390869141, 0.460931665671535, -80.0902786254883, -1.39783906085441, 218, 12, 'PPL', 'P'),
(201836, 'Yamhill', 45.3416709899902, 0.791361447131327, -123.186111450195, -2.1500032375346, 218, 43, 'PPL', 'P'),
(118539, 'Yampa', 41.0099983215332, 0.715759496948103, -92.2236099243164, -1.60960564125424, 218, 16, 'PPL', 'P'),
(194485, 'Yampa', 40.1525001525879, 0.700793330570184, -106.908058166504, -1.86589761191911, 218, 7, 'PPL', 'P'),
(179581, 'Yampai', 35.4894409179688, 0.619407593710554, -113.199722290039, -1.9757078663044, 218, 5, 'PPL', 'P'),
(6973, 'Yampertown', 34.0052795410156, 0.593504091051789, -87.8563919067383, -1.53338330769508, 218, 2, 'PPL', 'P'),
(38986, 'Yancey', 36.7686080932617, 0.641733272602851, -83.3208312988281, -1.45422284166329, 218, 21, 'PPL', 'P'),
(99222, 'Yancey', 29.1391696929932, 0.508574452440076, -99.1447219848633, -1.73040183461027, 218, 51, 'PPL', 'P'),
(26285, 'Yancey (historical)', 34.1541709899902, 0.596102737064461, -85.2911071777344, -1.48861064292283, 218, 13, 'PPL', 'P'),
(92035, 'Yancey (historical)', 35.2891693115234, 0.615912194779825, -84.5875015258789, -1.47633040766231, 218, 50, 'PPL', 'P'),
(107850, 'Yancey Mills', 38.0466690063477, 0.664039643577246, -78.7255630493164, -1.37402028069696, 218, 53, 'PPL', 'P'),
(209854, 'Yanceys', 44.9308280944824, 0.784190885896288, -110.435562133789, -1.92746417052539, 218, 59, 'PPL', 'P'),
(70418, 'Yanceyville', 36.4038887023926, 0.635367718386317, -79.3363876342773, -1.38468118085665, 218, 33, 'PPL', 'P'),
(107849, 'Yanceyville', 37.938060760498, 0.662144072092355, -77.9824981689453, -1.36105135197855, 218, 53, 'PPL', 'P'),
(12992, 'Yancopin', 33.940559387207, 0.592374511275432, -91.2186126708984, -1.5920651302086, 218, 4, 'PPL', 'P'),
(143434, 'Yancton (historical)', 40.0777816772461, 0.6994892471634, -95.4194412231445, -1.66538341975708, 218, 35, 'PPL', 'P'),
(6974, 'Yancy', 34.1719398498535, 0.596412862173401, -85.9772186279297, -1.50058554676437, 218, 2, 'PPL', 'P'),
(12987, 'Yancy', 33.834171295166, 0.590517688784401, -93.8097229003906, -1.63728853499534, 218, 4, 'PPL', 'P'),
(58376, 'Yancy Mills', 37.7911109924316, 0.659579314804554, -91.8338928222656, -1.60280379467212, 218, 29, 'PPL', 'P'),
(187562, 'Yankee', 39.8263893127441, 0.695101622688467, -105.623329162598, -1.84347486080507, 218, 7, 'PPL', 'P'),
(189836, 'Yankee', 36.9449996948242, 0.644811886822983, -104.327499389648, -1.82085836472174, 218, 38, 'PPL', 'P'),
(190944, 'Yankee Blade', 39.5319404602051, 0.689962520732941, -117.050277709961, -2.04291273641255, 218, 39, 'PPL', 'P'),
(158483, 'Yankee Crossing', 40.922779083252, 0.714237234069013, -80.9075012207031, -1.4121022858626, 218, 41, 'PPL', 'P'),
(197896, 'Yankee Flat (historical)', 45.1588897705078, 0.788171313040548, -112.994438171387, -1.97212498253186, 218, 31, 'PPL', 'P'),
(192920, 'Yankee Hill', 39.7036094665527, 0.692958710117335, -121.521110534668, -2.12094348950992, 218, 6, 'PPL', 'P'),
(143438, 'Yankee Hill (historical)', 40.7638893127441, 0.711464084425914, -96.7305603027344, -1.68826676458164, 218, 35, 'PPL', 'P'),
(158484, 'Yankee Hills', 41.2341690063477, 0.719672013484565, -80.5494384765625, -1.40585291204862, 218, 41, 'PPL', 'P'),
(186259, 'Yankee Jims', 39.0294418334961, 0.681192265210119, -120.860557556152, -2.10941466515097, 218, 6, 'PPL', 'P'),
(153968, 'Yankee Lake', 41.5833282470703, 0.725765991848939, -74.5447235107422, -1.30105086525128, 218, 40, 'PPL', 'P'),
(158485, 'Yankee Lake', 41.2666702270508, 0.720239266796752, -80.5677795410156, -1.40617302401165, 218, 41, 'PPL', 'P'),
(126719, 'Yankee Orchards', 42.4511108398438, 0.740911655284329, -73.1986083984375, -1.27755672443071, 218, 23, 'PPL', 'P'),
(34478, 'Yankee Run', 38.6513900756836, 0.674594017293339, -98.0166702270508, -1.71071361730353, 218, 20, 'PPL', 'P'),
(31573, 'Yankee Town', 39.6955604553223, 0.692818228369833, -84.9855575561523, -1.483277795998, 218, 19, 'PPL', 'P'),
(74898, 'Yankeeburg', 39.3802795410156, 0.687315538346484, -81.3433303833008, -1.41970893972614, 218, 41, 'PPL', 'P'),
(18682, 'Yankeetown', 29.0297203063965, 0.506664200279676, -82.7161102294922, -1.4436684679472, 218, 12, 'PPL', 'P'),
(31574, 'Yankeetown', 37.9174995422363, 0.661785211135467, -87.2977828979492, -1.52363374126041, 218, 19, 'PPL', 'P'),
(74902, 'Yankeetown', 39.2425003051758, 0.684910837040197, -83.0569381713867, -1.44961703771606, 218, 41, 'PPL', 'P'),
(92037, 'Yankeetown', 35.9883308410645, 0.628114865473595, -85.4230575561523, -1.49091361147548, 218, 50, 'PPL', 'P'),
(107851, 'Yankeetown', 38.6847190856934, 0.67517571825444, -78.9480590820313, -1.37790356904046, 218, 53, 'PPL', 'P'),
(138968, 'Yankeetown', 45.4911117553711, 0.793969680523923, -96.7397232055664, -1.6884266874051, 218, 28, 'PPL', 'P'),
(158486, 'Yankeetown (historical)', 40.3583297729492, 0.704385735143619, -81.4438934326172, -1.42146409604256, 218, 41, 'PPL', 'P'),
(171662, 'Yankton', 42.8711090087891, 0.748242006184772, -97.3969421386719, -1.69989732169423, 218, 49, 'PPL', 'P'),
(201838, 'Yankton', 45.8669395446777, 0.800529112867815, -122.885559082031, -2.14475760913547, 218, 43, 'PPL', 'P'),
(114334, 'Yantic', 41.5597190856934, 0.725353934249277, -72.1241683959961, -1.25880420877297, 218, 8, 'PPL', 'P'),
(99228, 'Yantis', 32.9302787780762, 0.574741788277044, -95.5747222900391, -1.6680935856404, 218, 51, 'PPL', 'P'),
(29044, 'Yantisville', 39.5363883972168, 0.690040151878717, -88.8833312988281, -1.55130678130548, 218, 18, 'PPL', 'P'),
(6975, 'Yantley', 32.2458305358887, 0.562795912891385, -88.3794403076172, -1.54251222443771, 218, 2, 'PPL', 'P'),
(112162, 'Yantus (historical)', 37.9647216796875, 0.662609392913819, -82.0586090087891, -1.43219290681005, 218, 58, 'PPL', 'P'),
(77738, 'Yanush', 34.7097206115723, 0.605798907119276, -95.313606262207, -1.663536251225, 218, 42, 'PPL', 'P'),
(153973, 'Yaphank', 40.836669921875, 0.712734345686854, -72.9175033569336, -1.27265051591251, 218, 40, 'PPL', 'P'),
(201839, 'Yaquina', 44.6022186279297, 0.778455568751721, -124.007499694824, -2.16433916684055, 218, 43, 'PPL', 'P'),
(6977, 'Yarbo', 31.5436096191406, 0.550539845817759, -88.2777786254883, -1.54073789336144, 218, 2, 'PPL', 'P'),
(12988, 'Yarbo Place', 35.3572196960449, 0.617099898046973, -90.5194396972656, -1.57986225977774, 218, 4, 'PPL', 'P'),
(99223, 'Yarboro', 30.336669921875, 0.52947477422745, -95.9552764892578, -1.67473550939905, 218, 51, 'PPL', 'P'),
(99224, 'Yarborough', 27.2061100006104, 0.474836196170407, -97.3763885498047, -1.6995385938954, 218, 51, 'PPL', 'P'),
(84550, 'Yarborough Crossroads', 34.2441711425781, 0.597673536054417, -80.0213928222656, -1.39663677678029, 218, 48, 'PPL', 'P'),
(12989, 'Yarborough Landing', 33.7205581665039, 0.588534765615755, -94.0180587768555, -1.64092468198968, 218, 4, 'PPL', 'P'),
(12990, 'Yarbro', 35.9791717529297, 0.627955009229163, -89.9102783203125, -1.56923038807393, 218, 4, 'PPL', 'P'),
(6976, 'Yarbrough', 32.7158317565918, 0.570998981681047, -85.1991729736328, -1.48700608836606, 218, 2, 'PPL', 'P'),
(62400, 'Yarbrough', 34.1875, 0.596684438025561, -90.290283203125, -1.57586272445266, 218, 30, 'PPL', 'P'),
(189837, 'Yarbrough Place', 31.6822204589844, 0.552959061351986, -108.717216491699, -1.89747338138363, 218, 38, 'PPL', 'P'),
(26286, 'Yarbroughs Mill', 34.4272193908691, 0.600868330677103, -84.774169921875, -1.47958838578186, 218, 13, 'PPL', 'P'),
(99225, 'Yard', 31.8613395690918, 0.556085279576603, -95.9709014892578, -1.67500821709468, 218, 51, 'PPL', 'P'),
(12991, 'Yardelle', 36.0669403076172, 0.629486859488176, -93.0038909912109, -1.62322411496252, 218, 4, 'PPL', 'P'),
(169189, 'Yardley', 40.2455596923828, 0.702417525939996, -74.8463897705078, -1.30631593472636, 218, 45, 'PPL', 'P'),
(209234, 'Yardley', 47.6672210693359, 0.831949952935924, -117.332496643066, -2.0478383860067, 218, 56, 'PPL', 'P'),
(107852, 'Yardley Square', 37.3144416809082, 0.651259865875255, -79.9511108398438, -1.3954101247822, 218, 53, 'PPL', 'P'),
(146691, 'Yardley Village', 40.769718170166, 0.711565817179555, -74.413330078125, -1.29875761723661, 218, 37, 'PPL', 'P'),
(107853, 'Yards', 37.2922210693359, 0.650872043041513, -81.3102798461914, -1.41913209903403, 218, 53, 'PPL', 'P'),
(112163, 'Yards', 37.2922210693359, 0.650872043041513, -81.3102798461914, -1.41913209903403, 218, 58, 'PPL', 'P'),
(113179, 'Yardville', 40.1811103820801, 0.701292673274574, -74.6647186279297, -1.30314517513252, 218, 37, 'PPL', 'P'),
(146692, 'Yardville Heights', 40.1833305358887, 0.701331422268435, -74.6861114501953, -1.30351855031735, 218, 37, 'PPL', 'P'),
(133826, 'Yargerville', 41.8383293151855, 0.730216600083652, -83.5319366455078, -1.45790732503142, 218, 27, 'PPL', 'P'),
(74903, 'Yarico', 38.6616706848145, 0.674773447771783, -82.408332824707, -1.43829673887046, 218, 41, 'PPL', 'P'),
(118542, 'Yarmouth', 41.0263900756836, 0.716045587028204, -91.3233337402344, -1.59389285766472, 218, 16, 'PPL', 'P'),
(126720, 'Yarmouth', 41.7055587768555, 0.727899317040147, -70.2291717529297, -1.22573027803722, 218, 23, 'PPL', 'P'),
(129398, 'Yarmouth', 43.8005599975586, 0.764463986174717, -70.1872177124023, -1.2249980418955, 218, 26, 'PPL', 'P'),
(186260, 'Yarmouth (historical)', 37.6866683959961, 0.657756447617422, -121.347221374512, -2.11790855113167, 218, 6, 'PPL', 'P'),
(129399, 'Yarmouth Junction', 43.8136100769043, 0.764691753026946, -70.1941680908203, -1.22511934888316, 218, 26, 'PPL', 'P'),
(126721, 'Yarmouth Port', 41.7019386291504, 0.727836133543285, -70.25, -1.22609379952602, 218, 23, 'PPL', 'P'),
(126722, 'Yarmouth Station', 41.6980590820313, 0.72776842267257, -70.2583312988281, -1.22623920812153, 218, 23, 'PPL', 'P'),
(77737, 'Yarnaby', 33.790828704834, 0.589761217876764, -96.2566680908203, -1.67999578518418, 218, 42, 'PPL', 'P'),
(192455, 'Yarnall', 35.2105598449707, 0.614540200765243, -101.538063049316, -1.77217351630816, 218, 51, 'PPL', 'P'),
(38987, 'Yarnallton', 38.1061096191406, 0.665077077979886, -84.585563659668, -1.47629658551647, 218, 21, 'PPL', 'P'),
(169191, 'Yarnell', 40.9977798461914, 0.715546244323814, -77.8111114501953, -1.35806008944217, 218, 45, 'PPL', 'P'),
(177160, 'Yarnell', 45.7269401550293, 0.798085662567668, -91.4191665649414, -1.59556545598734, 218, 57, 'PPL', 'P'),
(179582, 'Yarnell', 34.2216682434082, 0.597280786372657, -112.746673583984, -1.96780067471184, 218, 5, 'PPL', 'P'),
(197899, 'Yarnell', 48.4708290100098, 0.845975557395854, -115.291389465332, -2.01221434536915, 218, 31, 'PPL', 'P'),
(99226, 'Yarrelton', 30.9505596160889, 0.540189170635543, -97.079719543457, -1.69436074294601, 218, 51, 'PPL', 'P'),
(139548, 'Yarrow', 40.0938911437988, 0.699770410395485, -92.6802825927734, -1.61757608292268, 218, 29, 'PPL', 'P'),
(209236, 'Yarrow Point', 47.6463890075684, 0.831586364868101, -122.216110229492, -2.13307352248496, 218, 56, 'PPL', 'P'),
(53091, 'Yarrowsburg', 39.374439239502, 0.687213605855761, -77.6838912963867, -1.35583967888331, 218, 25, 'PPL', 'P'),
(26287, 'Yates', 33.4633293151855, 0.584045275229127, -84.8949966430664, -1.48169720989104, 218, 13, 'PPL', 'P'),
(58377, 'Yates', 39.3102798461914, 0.68609381319641, -92.5991668701172, -1.6161603464872, 218, 29, 'PPL', 'P'),
(70420, 'Yates', 36.2897186279297, 0.633375074679692, -81.4591674804688, -1.42173067846767, 218, 33, 'PPL', 'P'),
(99227, 'Yates', 30.5877799987793, 0.533857471854366, -99.5930633544922, -1.7382268676832, 218, 51, 'PPL', 'P'),
(133827, 'Yates', 42.6736106872559, 0.744795010206855, -83.095832824707, -1.45029587747792, 218, 27, 'PPL', 'P'),
(189838, 'Yates', 36.1302795410156, 0.630592337656668, -103.900833129883, -1.81341163368166, 218, 38, 'PPL', 'P'),
(197897, 'Yates', 46.9511108398438, 0.819451471624074, -104.129997253418, -1.8174113021648, 218, 31, 'PPL', 'P'),
(92038, 'Yates (historical)', 35.1624984741211, 0.613701371600895, -87.6744384765625, -1.53020762125322, 218, 50, 'PPL', 'P'),
(112164, 'Yates (historical)', 39.295280456543, 0.685832024461255, -80.0244369506836, -1.39668990684404, 218, 58, 'PPL', 'P'),
(34479, 'Yates Center', 37.8811111450195, 0.66115011379451, -95.7330627441406, -1.67085714790357, 218, 20, 'PPL', 'P'),
(153969, 'Yates Center', 43.3377799987793, 0.756386951483643, -78.3891677856445, -1.36814907575777, 218, 40, 'PPL', 'P'),
(122079, 'Yates City', 40.7786102294922, 0.711721012892079, -90.0147171020508, -1.57105318868203, 218, 18, 'PPL', 'P'),
(158489, 'Yates Corners', 41.4630584716797, 0.723666888277739, -81.2888870239258, -1.4187587238492, 218, 41, 'PPL', 'P'),
(112165, 'Yates Crossing', 38.4413909912109, 0.670928841843117, -82.1900024414063, -1.43448615482472, 218, 58, 'PPL', 'P'),
(26288, 'Yates Crossroads', 33.3677787780762, 0.58237760375452, -85.2322235107422, -1.48758292905817, 218, 13, 'PPL', 'P'),
(70421, 'Yates Hill', 34.9347190856934, 0.609725871304652, -79.7977828979492, -1.39273404736084, 218, 33, 'PPL', 'P'),
(107854, 'Yates Village', 38.7849998474121, 0.67692594772284, -77.182502746582, -1.34708879785742, 218, 53, 'PPL', 'P'),
(169192, 'Yatesboro', 40.7999992370605, 0.712094321497881, -79.3344421386719, -1.38464722555276, 218, 45, 'PPL', 'P'),
(92039, 'Yateston', 35.8872184753418, 0.626350121777254, -85.5933303833008, -1.4938854329359, 218, 50, 'PPL', 'P'),
(6978, 'Yatesville', 33.6041717529297, 0.586503439494298, -86.1197204589844, -1.5030726729064, 218, 2, 'PPL', 'P'),
(26289, 'Yatesville', 32.9136085510254, 0.574450837927953, -84.1427764892578, -1.46856849150722, 218, 13, 'PPL', 'P'),
(29045, 'Yatesville', 39.8458290100098, 0.695440909411343, -90.0602798461914, -1.57184840858353, 218, 18, 'PPL', 'P'),
(38988, 'Yatesville', 38.1477813720703, 0.665804387273587, -82.6861114501953, -1.44314489047689, 218, 21, 'PPL', 'P'),
(74904, 'Yatesville', 39.6777801513672, 0.692507903523812, -83.4494400024414, -1.45646748698807, 218, 41, 'PPL', 'P'),
(153972, 'Yatesville', 42.6719398498535, 0.744765848592919, -77.1377792358398, -1.34630822534192, 218, 40, 'PPL', 'P'),
(169194, 'Yatesville', 40.8250007629395, 0.71253068044249, -76.1716690063477, -1.32944642090008, 218, 45, 'PPL', 'P'),
(107855, 'Yatesville (historical)', 36.8605613708496, 0.64333816005476, -78.3655624389648, -1.36773708473713, 218, 53, 'PPL', 'P'),
(44236, 'Yattan', 30.601110458374, 0.534090132265098, -91.3211135864258, -1.59385410867086, 218, 22, 'PPL', 'P'),
(118541, 'Yatton (historical)', 41.4636116027832, 0.72367654223669, -91.583610534668, -1.59843554469412, 218, 16, 'PPL', 'P'),
(84551, 'Yauhannah', 33.6319389343262, 0.586988068233665, -79.188606262207, -1.38210190934091, 218, 48, 'PPL', 'P'),
(70422, 'Yaupon Beach', 33.9047203063965, 0.591749001314399, -78.07861328125, -1.36272887714919, 218, 33, 'PPL', 'P'),
(179583, 'Yava', 34.4719390869141, 0.601648836613578, -112.889717102051, -1.97029725507574, 218, 5, 'PPL', 'P'),
(179585, 'Yavapai Hills', 34.5616683959961, 0.603214908492599, -112.382781982422, -1.96144956814422, 218, 5, 'PPL', 'P'),
(112166, 'Yawkey', 38.2249984741211, 0.667152079943222, -81.9649963378906, -1.43055905748129, 218, 58, 'PPL', 'P'),
(44237, 'Yawn (historical)', 30.6172199249268, 0.534371295497183, -90.5936126708984, -1.58115682238363, 218, 22, 'PPL', 'P'),
(62401, 'Yazoo City', 32.8549995422363, 0.573427917753254, -90.4055633544922, -1.57787474265622, 218, 30, 'PPL', 'P'),
(62403, 'Yazoo Junction', 32.8880615234375, 0.574004958182447, -90.3894424438477, -1.57759337968705, 218, 30, 'PPL', 'P'),
(179586, 'Yazzi', 36.5791702270508, 0.638426958109518, -109.223609924316, -1.90631161409328, 218, 5, 'PPL', 'P'),
(18683, 'Ybel', 26.4241695404053, 0.461188760585269, -82.0711135864258, -1.43241115286138, 218, 12, 'PPL', 'P'),
(18684, 'Ybor City', 27.9647197723389, 0.488076434424872, -82.4352798461914, -1.43876705311896, 218, 12, 'PPL', 'P'),
(194073, 'Ydaloom (historical)', 40.7788887023926, 0.711725873161069, -122.219718933105, -2.13313650624474, 218, 6, 'PPL', 'P'),
(38989, 'Yeaddiss', 37.0686111450195, 0.646969313622056, -83.2177810668945, -1.45242427582111, 218, 21, 'PPL', 'P'),
(79461, 'Yeadon', 39.9388885498047, 0.697065104781155, -75.2558288574219, -1.31346199487937, 218, 45, 'PPL', 'P'),
(38990, 'Yeager', 37.3916702270508, 0.652607758281972, -82.5216674804688, -1.44027480177011, 218, 21, 'PPL', 'P'),
(53092, 'Yeager', 39.3972206115723, 0.68761121580651, -77.3047180175781, -1.34922185673252, 218, 25, 'PPL', 'P'),
(77739, 'Yeager', 35.1575012207031, 0.613614153075195, -96.3391723632813, -1.68143575638558, 218, 42, 'PPL', 'P'),
(122081, 'Yeager', 41.2077789306641, 0.719211419774036, -87.7022171020508, -1.53069244972967, 218, 18, 'PPL', 'P'),
(124056, 'Yeagers Curve', 40.6986083984375, 0.710324717532551, -87.4391708374023, -1.52610142632648, 218, 19, 'PPL', 'P'),
(169196, 'Yeagertown', 40.6430587768555, 0.709355193737707, -77.5808334350586, -1.35404097988307, 218, 45, 'PPL', 'P'),
(158487, 'Yeagleys Corners', 40.8338890075684, 0.712685809575988, -81.1016693115234, -1.41549115834973, 218, 41, 'PPL', 'P'),
(79455, 'Yeakle Mill', 39.7338905334473, 0.693487214435661, -78.0347213745117, -1.36196281886162, 218, 45, 'PPL', 'P'),
(58378, 'Yeakley', 37.2050018310547, 0.649349780162423, -93.5091705322266, -1.63204290659621, 218, 29, 'PPL', 'P'),
(58379, 'Yeakley (historical)', 37.2069396972656, 0.649383602308267, -93.4861068725586, -1.63164036979745, 218, 29, 'PPL', 'P'),
(38991, 'Yeaman', 37.5177803039551, 0.654808794343895, -86.5774993896484, -1.51106242249275, 218, 21, 'PPL', 'P'),
(92042, 'Yeary Mill', 36.579719543457, 0.638436545489442, -83.4441680908203, -1.45637547477241, 218, 50, 'PPL', 'P'),
(70423, 'Yeatesville', 35.5283317565918, 0.620086366893387, -76.7405624389648, -1.33937548439223, 218, 33, 'PPL', 'P'),
(58380, 'Yeatman', 38.5433311462402, 0.672708033188372, -90.6119384765625, -1.58147666803055, 218, 29, 'PPL', 'P'),
(124057, 'Yeddo', 40.0113906860352, 0.698330505773106, -87.2600021362305, -1.52297434257451, 218, 19, 'PPL', 'P'),
(18685, 'Yeehaw', 27.6833305358887, 0.483165265769144, -80.8666687011719, -1.4113896239549, 218, 12, 'PPL', 'P'),
(18686, 'Yeehaw Junction', 27.7000007629395, 0.483456216118235, -80.9044418334961, -1.41204888948274, 218, 12, 'PPL', 'P'),
(197898, 'Yegen', 45.7236099243164, 0.798027539076877, -108.621940612793, -1.89581050359898, 218, 31, 'PPL', 'P'),
(92041, 'Yell', 35.3691711425781, 0.617308490139353, -86.7869415283203, -1.51471787740499, 218, 50, 'PPL', 'P'),
(190945, 'Yelland (historical)', 39.3416709899902, 0.686641692011667, -114.483612060547, -1.99811597003243, 218, 39, 'PPL', 'P'),
(209237, 'Yellepit', 46.0611114501953, 0.803918051933968, -118.95027923584, -2.07607401883205, 218, 56, 'PPL', 'P'),
(6979, 'Yelling Settlement', 30.621940612793, 0.534453687043407, -87.8363876342773, -1.53303416727617, 218, 2, 'PPL', 'P'),
(31575, 'Yellow Bank', 39.4375, 0.688314223755264, -85.0691680908203, -1.48473707511731, 218, 19, 'PPL', 'P'),
(53093, 'Yellow Bank', 38.2605590820313, 0.667772729635265, -76.8011093139648, -1.34043222671277, 218, 25, 'PPL', 'P'),
(12995, 'Yellow Banks', 35.4869384765625, 0.619363917868676, -90.4438934326172, -1.57854372872205, 218, 4, 'PPL', 'P'),
(122082, 'Yellow Banks', 40.730281829834, 0.710877523195824, -91.0811080932617, -1.58966522259227, 218, 18, 'PPL', 'P'),
(192872, 'Yellow Banks', 38.4249992370605, 0.670642751763016, -112.987777709961, -1.97200873555028, 218, 52, 'PPL', 'P'),
(12996, 'Yellow Bayou', 33.4080581665039, 0.583080611703273, -91.2538909912109, -1.59268085305262, 218, 4, 'PPL', 'P'),
(44238, 'Yellow Bayou', 30.9911098480225, 0.540896905695231, -91.8405609130859, -1.60292017481176, 218, 22, 'PPL', 'P'),
(6980, 'Yellow Bluff', 31.9675006866455, 0.557938140615512, -87.4680633544922, -1.52660569587888, 218, 2, 'PPL', 'P'),
(18687, 'Yellow Bluff', 29.2758293151855, 0.510959612801865, -81.6425018310547, -1.4249304665174, 218, 12, 'PPL', 'P'),
(18688, 'Yellow Bluff Fort', 30.3994407653809, 0.530570332120881, -81.5561065673828, -1.4234225847082, 218, 12, 'PPL', 'P'),
(107856, 'Yellow Branch', 37.2558288574219, 0.650236879121529, -79.184440612793, -1.38202920504315, 218, 53, 'PPL', 'P'),
(38992, 'Yellow Creek', 36.5872192382813, 0.63856743985702, -83.7808303833008, -1.4622513402435, 218, 21, 'PPL', 'P'),
(70424, 'Yellow Creek', 35.413890838623, 0.618088996075828, -83.8319396972656, -1.46314336605062, 218, 33, 'PPL', 'P'),
(92044, 'Yellow Creek', 36.2786102294922, 0.633181196552334, -87.5686111450195, -1.52836058587919, 218, 50, 'PPL', 'P'),
(122100, 'Yellow Creek', 42.3055610656738, 0.738371332499529, -89.8563919067383, -1.56828989273497, 218, 18, 'PPL', 'P'),
(158488, 'Yellow Creek', 40.5744400024414, 0.708157570195499, -80.6677780151367, -1.40791832663203, 218, 41, 'PPL', 'P'),
(169197, 'Yellow Creek', 40.1302795410156, 0.700405507736442, -78.331672668457, -1.36714559665903, 218, 45, 'PPL', 'P'),
(26290, 'Yellow Dirt', 33.413890838623, 0.583182411035941, -85.0408325195313, -1.48424252610289, 218, 13, 'PPL', 'P'),
(195824, 'Yellow Dog (historical)', 46.9791717529297, 0.819941226948539, -117.032783508301, -2.04260740499357, 218, 17, 'PPL', 'P'),
(70426, 'Yellow Gap', 35.6861114501953, 0.622840142039557, -81.6513900756836, -1.4250855956509, 218, 33, 'PPL', 'P'),
(169199, 'Yellow Hammer', 41.5999984741211, 0.72605694219803, -79.3097229003906, -1.38421579345616, 218, 45, 'PPL', 'P'),
(179587, 'Yellow Hammer Mill', 32.3633308410645, 0.5648466800888, -109.288063049316, -1.90743653333773, 218, 5, 'PPL', 'P'),
(129401, 'Yellow Head', 43.8574981689453, 0.76545774473548, -69.4938888549805, -1.2128971705344, 218, 26, 'PPL', 'P'),
(169198, 'Yellow House', 40.3230590820313, 0.703770145457648, -75.754997253418, -1.3221741269114, 218, 45, 'PPL', 'P'),
(84553, 'Yellow House (historical)', 32.8925018310547, 0.574082456170168, -79.9250030517578, -1.39495445791969, 218, 48, 'PPL', 'P'),
(84554, 'Yellow House Landing', 32.9083290100098, 0.574358692554236, -79.9250030517578, -1.39495445791969, 218, 48, 'PPL', 'P'),
(18689, 'Yellow Jacket', 29.4630603790283, 0.514227411327933, -83.0013885498047, -1.44864751392121, 218, 12, 'PPL', 'P'),
(187563, 'Yellow Jacket', 37.5344390869141, 0.655099544955905, -108.716667175293, -1.89746379400371, 218, 7, 'PPL', 'P'),
(62404, 'Yellow Lake', 34.4680595397949, 0.601581125742863, -90.192497253418, -1.57415603766809, 218, 30, 'PPL', 'P'),
(177161, 'Yellow Lake', 45.9366683959961, 0.801746110906954, -92.3899993896484, -1.61250968526492, 218, 57, 'PPL', 'P'),
(153978, 'Yellow Mills', 43.0605583190918, 0.751548520415187, -77.2572174072266, -1.34839281468518, 218, 40, 'PPL', 'P'),
(6982, 'Yellow Pine', 31.4055595397949, 0.548130417400536, -88.4297180175781, -1.54338973601689, 218, 2, 'PPL', 'P'),
(44239, 'Yellow Pine', 32.4769401550293, 0.566829536678419, -93.3241729736328, -1.6288140900906, 218, 22, 'PPL', 'P'),
(195825, 'Yellow Pine', 44.9650001525879, 0.784787300822411, -115.492782592773, -2.01572931853389, 218, 17, 'PPL', 'P'),
(53106, 'Yellow Pine Estates', 39.4480590820313, 0.688498514502697, -76.9577789306641, -1.34316662736201, 218, 25, 'PPL', 'P'),
(118545, 'Yellow River', 43.0877799987793, 0.752023628353657, -91.1877822875977, -1.59152703851035, 218, 16, 'PPL', 'P'),
(26291, 'Yellow River (historical)', 33.874439239502, 0.591220496996073, -84.0827789306641, -1.4675213365666, 218, 13, 'PPL', 'P'),
(38993, 'Yellow Rock', 37.5708312988281, 0.655734708875888, -83.8050003051758, -1.46267318496017, 218, 21, 'PPL', 'P'),
(112167, 'Yellow Spring', 39.1822204589844, 0.683858755251561, -78.5097198486328, -1.37025310617699, 218, 58, 'PPL', 'P'),
(169200, 'Yellow Spring', 40.517219543457, 0.707158884786719, -78.2069396972656, -1.36496859562594, 218, 45, 'PPL', 'P'),
(53094, 'Yellow Springs', 39.4794387817383, 0.689046193580872, -77.4602813720703, -1.35193694946386, 218, 25, 'PPL', 'P'),
(74905, 'Yellow Springs', 39.8063888549805, 0.694752548848585, -83.8869400024414, -1.46410330246554, 218, 41, 'PPL', 'P'),
(92046, 'Yellow Springs', 36.5033302307129, 0.637103300468721, -83.3944396972656, -1.45550755057315, 218, 50, 'PPL', 'P'),
(107857, 'Yellow Sulphur', 37.1713905334473, 0.648763152353306, -80.3969421386719, -1.4031913488552, 218, 53, 'PPL', 'P'),
(107858, 'Yellow Sulphur Springs', 37.1783294677734, 0.648884259603878, -80.3974990844727, -1.40320106939317, 218, 53, 'PPL', 'P'),
(107859, 'Yellow Tavern', 37.6347198486328, 0.656849774424305, -77.4591674804688, -1.3519175083879, 218, 53, 'PPL', 'P'),
(124061, 'Yellowbanks', 41.3216705322266, 0.721199203211671, -85.6788864135742, -1.49537866735911, 218, 19, 'PPL', 'P'),
(74906, 'Yellowbud', 39.5041694641113, 0.689477825414547, -83.0097198486328, -1.44879292251673, 218, 41, 'PPL', 'P'),
(202806, 'Yellowhorse Ford', 45.2802810668945, 0.79028999084576, -100.796669006348, -1.75923374920369, 218, 49, 'PPL', 'P'),
(194074, 'Yellowjacket', 40.2405586242676, 0.702330240835269, -121.690002441406, -2.12389120936248, 218, 6, 'PPL', 'P'),
(195826, 'Yellowjacket', 44.9797210693359, 0.785044229288577, -114.530830383301, -1.99894008523176, 218, 17, 'PPL', 'P'),
(194075, 'Yellowjacket Place', 40.1694412231445, 0.70108900803021, -123.32250213623, -2.15238370407496, 218, 6, 'PPL', 'P'),
(6983, 'Yellowleaf Creek Estates', 33.3111114501953, 0.581388572304691, -86.5875015258789, -1.5112369927022, 218, 2, 'PPL', 'P'),
(169201, 'Yellowood', 40.1286087036133, 0.700376346122505, -74.8644409179688, -1.30663098668332, 218, 45, 'PPL', 'P'),
(99229, 'Yellowpine', 31.2591705322266, 0.545575447229742, -93.8244400024414, -1.63754539688248, 218, 51, 'PPL', 'P'),
(31576, 'Yellowstone', 38.9988899230957, 0.680659033780858, -86.3424987792969, -1.50696088809792, 218, 19, 'PPL', 'P'),
(107860, 'Yellowstone', 37.2341690063477, 0.649858843404792, -79.9416732788086, -1.39524540826878, 218, 53, 'PPL', 'P'),
(177162, 'Yellowstone', 42.7983283996582, 0.746971744923831, -89.9702835083008, -1.5702776761726, 218, 57, 'PPL', 'P'),
(74907, 'Yellowtown', 39.7013893127441, 0.692919961123474, -82.0683288574219, -1.43236255017149, 218, 41, 'PPL', 'P'),
(12997, 'Yellville', 36.2261085510254, 0.632264869400265, -92.6847229003906, -1.6176535809104, 218, 4, 'PPL', 'P'),
(209238, 'Yelm', 46.9422187805176, 0.819296275911549, -122.604721069336, -2.13985606114918, 218, 56, 'PPL', 'P'),
(114335, 'Yelping Hill', 41.9047203063965, 0.731375341473946, -73.2991714477539, -1.27931188074712, 218, 8, 'PPL', 'P'),
(158491, 'Yelverton', 40.5486106872559, 0.707706763601975, -83.7102813720703, -1.4610200277135, 218, 41, 'PPL', 'P'),
(18692, 'Yelvington', 29.6311092376709, 0.517160417215464, -81.524169921875, -1.42286518509205, 218, 12, 'PPL', 'P'),
(38994, 'Yelvington', 37.8555603027344, 0.660704167469976, -86.9672164916992, -1.51786426907486, 218, 21, 'PPL', 'P'),
(84555, 'Yemassee', 32.689998626709, 0.570548108508496, -80.850830078125, -1.41111318783375, 218, 48, 'PPL', 'P'),
(31577, 'Yenne', 38.547779083252, 0.672785664334148, -86.7936096191406, -1.51483425754463, 218, 19, 'PPL', 'P'),
(84556, 'Yenome', 33.1833305358887, 0.579158374628832, -81.3469390869141, -1.41977192348592, 218, 48, 'PPL', 'P'),
(18690, 'Yent Place', 29.8636093139648, 0.521218309057932, -84.7002792358398, -1.47829875002399, 218, 12, 'PPL', 'P'),
(53095, 'Yeoho', 39.5713882446289, 0.690651014453754, -76.7219390869141, -1.33905044558118, 218, 25, 'PPL', 'P'),
(209239, 'Yeomalt', 47.6347198486328, 0.831382699623737, -122.492782592773, -2.13790236617349, 218, 56, 'PPL', 'P'),
(124058, 'Yeoman', 40.667781829834, 0.709786692413327, -86.7241668701172, -1.51362225293253, 218, 19, 'PPL', 'P'),
(26292, 'Yeomans', 31.8352794647217, 0.555630444951931, -84.4669418334961, -1.47422624408504, 218, 13, 'PPL', 'P'),
(29046, 'Yeomans', 39.6505584716797, 0.692032795585341, -90.0408325195313, -1.5715089887026, 218, 18, 'PPL', 'P'),
(118547, 'Yeomans', 42.5847206115723, 0.743243585713829, -96.4147186279297, -1.68275428744128, 218, 16, 'PPL', 'P'),
(70427, 'Yeopim Station', 36.1427803039551, 0.630810517128973, -76.524169921875, -1.33559872249233, 218, 33, 'PPL', 'P'),
(122084, 'Yeoward Addition', 41.7580604553223, 0.728815644192216, -89.6605606079102, -1.56487199179196, 218, 18, 'PPL', 'P'),
(207, 'Yerba', 37.4927787780762, 0.654372435399286, -81.6241683959961, -1.42461048771243, 218, 58, 'PPL', 'P'),
(189839, 'Yerba', 34.1566696166992, 0.596146346327311, -103.379173278809, -1.80430695170495, 218, 38, 'PPL', 'P'),
(77742, 'Yerby', 35.000560760498, 0.610875025315021, -94.6777801513672, -1.65243899212069, 218, 42, 'PPL', 'P'),
(190946, 'Yerington', 38.9858283996582, 0.680431067191547, -119.16194152832, -2.07976822273815, 218, 39, 'PPL', 'P'),
(38997, 'Yerkes', 37.2772216796875, 0.650610254306358, -83.3011093139648, -1.4538786280924, 218, 21, 'PPL', 'P'),
(169202, 'Yerkes', 40.1697196960449, 0.7010938682992, -75.4638900756836, -1.31709334818375, 218, 45, 'PPL', 'P'),
(6984, 'Yerkwood', 33.6877784729004, 0.587962652034579, -87.0800018310547, -1.5198327445946, 218, 2, 'PPL', 'P'),
(186262, 'Yermo', 34.9049987792969, 0.609207154103332, -116.819442749023, -2.03888390631547, 218, 6, 'PPL', 'P'),
(193333, 'Yes Bay (historical)', 55.9097213745117, 0.975808721857879, -131.800003051758, -2.30034400739175, 218, 1, 'PPL', 'P'),
(209240, 'Yesler Terrace', 47.6011085510254, 0.83079607181462, -122.314720153809, -2.13479459033943, 218, 56, 'PPL', 'P'),
(189840, 'Yeso', 34.4391708374023, 0.601076922769484, -104.609443664551, -1.82577922062593, 218, 38, 'PPL', 'P'),
(38995, 'Yesse', 36.8530616760254, 0.643207265687183, -86.1972198486328, -1.50442529242405, 218, 21, 'PPL', 'P'),
(209241, 'Yethonat', 46.4047203063965, 0.809915157813691, -120.395278930664, -2.10129402119705, 218, 56, 'PPL', 'P'),
(186263, 'Yettem', 36.4863891601563, 0.636807623008695, -119.258613586426, -2.08145546844677, 218, 6, 'PPL', 'P'),
(118548, 'Yetter', 42.3161087036133, 0.738555423509881, -94.845832824707, -1.65537206458725, 218, 16, 'PPL', 'P'),
(92047, 'Yettland Park', 35.8763885498047, 0.626161103918885, -83.57861328125, -1.45872198600887, 218, 50, 'PPL', 'P'),
(77743, 'Yewed', 36.6822204589844, 0.640225523951703, -98.4097213745117, -1.71757365395547, 218, 42, 'PPL', 'P'),
(212243, 'Yistletaw', 64.8225021362305, 1.13136609165828, -157.372497558594, -2.7466682344842, 218, 1, 'PPL', 'P'),
(18691, 'Yniestra', 30.5016708374023, 0.532354583472207, -87.1602783203125, -1.52123383364409, 218, 12, 'PPL', 'P'),
(197901, 'Ynot (historical)', 48.836669921875, 0.852360685846401, -107.675559997559, -1.8792930458861, 218, 31, 'PPL', 'P'),
(190948, 'Yoacham (historical)', 37.6588897705078, 0.657271619140973, -114.493057250977, -1.99828081970391, 218, 39, 'PPL', 'P'),
(99230, 'Yoakum', 29.2875003814697, 0.511163311335742, -97.1516723632813, -1.69561655655804, 218, 51, 'PPL', 'P'),
(92048, 'Yoakum Crossroad', 36.4986114501953, 0.637020942212011, -83.7755584716797, -1.46215932802784, 218, 50, 'PPL', 'P'),
(12998, 'Yocana', 34.5875015258789, 0.60366578166515, -94.0541687011719, -1.64155491906165, 218, 4, 'PPL', 'P'),
(34481, 'Yocemento', 38.9072189331055, 0.679059073176966, -99.4236068725586, -1.73526929413461, 218, 20, 'PPL', 'P'),
(31578, 'Yockey', 38.7880592346191, 0.676979344102696, -86.4930572509766, -1.5095886291455, 218, 19, 'PPL', 'P'),
(62405, 'Yocona', 34.2780609130859, 0.598265024132523, -89.4147186279297, -1.56058123980168, 218, 30, 'PPL', 'P'),
(12999, 'Yocum', 36.4194412231445, 0.635639161080423, -93.4130630493164, -1.63036551458363, 218, 4, 'PPL', 'P'),
(38996, 'Yocum', 37.9833297729492, 0.662934165408754, -83.3249969482422, -1.45429554596105, 218, 21, 'PPL', 'P'),
(107861, 'Yocum', 38.6463890075684, 0.674506732188612, -77.5047225952148, -1.35271259513134, 218, 53, 'PPL', 'P'),
(169203, 'Yocum Estates', 40.5602798461914, 0.707910428846339, -75.1416702270508, -1.31146955090983, 218, 45, 'PPL', 'P'),
(169204, 'Yocumtown', 40.1583290100098, 0.700895063323825, -76.8041687011719, -1.34048562309263, 218, 45, 'PPL', 'P'),
(13008, 'Yoder', 34.4538917541504, 0.601333851235649, -91.4880599975586, -1.59676787321951, 218, 4, 'PPL', 'P'),
(34482, 'Yoder', 37.9402809143066, 0.662182821086216, -97.8680572509766, -1.70811983155985, 218, 20, 'PPL', 'P'),
(38998, 'Yoder', 38.0605583190918, 0.66428205781547, -85.3450012207031, -1.48955127141985, 218, 21, 'PPL', 'P'),
(124059, 'Yoder', 40.9311103820801, 0.714382642664532, -85.1766662597656, -1.48661327210527, 218, 19, 'PPL', 'P'),
(158492, 'Yoder', 40.6872215270996, 0.710125979136203, -84.0711135864258, -1.46731773790127, 218, 41, 'PPL', 'P'),
(187564, 'Yoder', 38.8394393920898, 0.677876097020753, -104.221389770508, -1.8190064024997, 218, 7, 'PPL', 'P'),
(201840, 'Yoder', 45.1383285522461, 0.78781245208366, -122.680557250977, -2.14117965221094, 218, 43, 'PPL', 'P'),
(209855, 'Yoder', 41.9169387817383, 0.731588594098234, -104.295280456543, -1.82029603825757, 218, 59, 'PPL', 'P'),
(79456, 'Yoe', 39.9088897705078, 0.696541527310846, -76.6372222900391, -1.33757185854397, 218, 45, 'PPL', 'P'),
(13001, 'Yoestown', 35.4286117553711, 0.618345924541993, -94.1780624389648, -1.64371727270874, 218, 4, 'PPL', 'P'),
(197903, 'Yogo Crossing', 46.8555603027344, 0.817783800149466, -110.315826416016, -1.92537438801801, 218, 31, 'PPL', 'P'),
(169205, 'Yohoghany', 40.2880592346191, 0.703159282882611, -79.7636108398438, -1.39213763243471, 218, 45, 'PPL', 'P'),
(209242, 'Yokeko Point', 48.413890838623, 0.844981798835091, -122.616668701172, -2.14006458666253, 218, 56, 'PPL', 'P'),
(62406, 'Yokena', 32.1749992370605, 0.56155967351337, -90.9419403076172, -1.58723628652006, 218, 30, 'PPL', 'P'),
(92049, 'Yokley', 35.415828704834, 0.618122818221672, -87.1086120605469, -1.52033208729899, 218, 50, 'PPL', 'P'),
(186265, 'Yokohl', 36.3255615234375, 0.634000651219752, -119.081390380859, -2.0783623399987, 218, 6, 'PPL', 'P'),
(99232, 'Yokum', 29.1608295440674, 0.508952488156813, -97.5630569458008, -1.70279657201495, 218, 51, 'PPL', 'P'),
(112168, 'Yokum', 38.9749984741211, 0.680242049333179, -80.0627822875977, -1.39735915922598, 218, 58, 'PPL', 'P'),
(99231, 'Yokum-Hall Colonia', 26.2849998474121, 0.458759791223548, -98.1210021972656, -1.71253455369888, 218, 51, 'PPL', 'P'),
(138971, 'Yola', 47.2322196960449, 0.824357746721299, -95.0119400024414, -1.65827118174991, 218, 28, 'PPL', 'P'),
(6985, 'Yolande', 33.3066711425781, 0.58131107431697, -87.1913909912109, -1.52177685219035, 218, 2, 'PPL', 'P'),
(186270, 'Yolano', 38.4102783203125, 0.67038582329685, -121.704437255859, -2.1241431444016, 218, 6, 'PPL', 'P'),
(58383, 'Yolo', 38.4327812194824, 0.67077857297861, -93.5386123657227, -1.63255676352854, 218, 29, 'PPL', 'P'),
(186266, 'Yolo', 38.7319412231445, 0.675999900032792, -121.806671142578, -2.12592746233195, 218, 6, 'PPL', 'P'),
(112169, 'Yolyn', 37.8291702270508, 0.660243573759447, -81.8613891601563, -1.42875077110112, 218, 58, 'PPL', 'P'),
(209243, 'Yoman', 47.1866683959961, 0.823562726556883, -122.705001831055, -2.14160629061758, 218, 56, 'PPL', 'P'),
(26293, 'Yonah', 34.6411094665527, 0.604601416735122, -83.7536087036133, -1.46177623230503, 218, 13, 'PPL', 'P'),
(201841, 'Yoncalla', 43.5986099243164, 0.760939292471997, -123.282218933105, -2.15168062954718, 218, 43, 'PPL', 'P'),
(158493, 'Yondota', 41.6383285522461, 0.726725928263858, -83.3122177124023, -1.45407250621976, 218, 41, 'PPL', 'P'),
(84557, 'Yonges Island', 32.6933288574219, 0.570606231999288, -80.230827331543, -1.40029209853448, 218, 48, 'PPL', 'P'),
(26294, 'Yonkers', 32.3661117553711, 0.564895216199667, -83.216667175293, -1.45240483474515, 218, 13, 'PPL', 'P'),
(53096, 'Yonkers', 39.6949996948242, 0.692808441252827, -78.649169921875, -1.37268696909721, 218, 25, 'PPL', 'P'),
(77744, 'Yonkers', 36.0527801513672, 0.629239718139017, -95.2605590820313, -1.66261040327203, 218, 42, 'PPL', 'P'),
(153974, 'Yonkers', 40.9311103820801, 0.714382642664532, -73.899169921875, -1.28978382962748, 218, 40, 'PPL', 'P'),
(58384, 'Yonkerville', 36.9161109924316, 0.644307683849604, -94.0091705322266, -1.64076955285618, 218, 29, 'PPL', 'P'),
(201842, 'Yonna', 42.2680587768555, 0.737716794082615, -121.46639251709, -2.11998847994302, 218, 43, 'PPL', 'P'),
(194076, 'Yontocket', 41.9077796936035, 0.731428737853802, -124.197776794434, -2.16766012871987, 218, 6, 'PPL', 'P'),
(186268, 'Yorba', 33.8652801513672, 0.591060640751641, -117.808059692383, -2.0561385270181, 218, 6, 'PPL', 'P'),
(186269, 'Yorba Linda', 33.8886108398438, 0.591467838082314, -117.812217712402, -2.0562110981578, 218, 6, 'PPL', 'P'),
(169206, 'Yordy', 40.8083305358887, 0.712239730093399, -76.6369400024414, -1.33756693169595, 218, 45, 'PPL', 'P'),
(70428, 'Yorick', 34.6694412231445, 0.605095899170522, -78.6419372558594, -1.37256073526154, 218, 33, 'PPL', 'P'),
(6986, 'York', 32.4861106872559, 0.566989592659933, -88.29638671875, -1.54106266585638, 218, 2, 'PPL', 'P'),
(18693, 'York', 29.1499996185303, 0.508763470298444, -82.3002777099609, -1.43641082134452, 218, 12, 'PPL', 'P'),
(26295, 'York', 34.9352798461914, 0.609735658421658, -83.3891677856445, -1.45541553835749, 218, 13, 'PPL', 'P'),
(29048, 'York', 39.1713905334473, 0.683669737393193, -87.6391677856445, -1.52959203156725, 218, 18, 'PPL', 'P'),
(38999, 'York', 38.565559387207, 0.673095989180169, -83.04638671875, -1.44943288012668, 218, 21, 'PPL', 'P'),
(79458, 'York', 39.9625015258789, 0.697477228959845, -76.7280578613281, -1.33915723834089, 218, 45, 'PPL', 'P'),
(84558, 'York', 34.9941711425781, 0.610763505444374, -81.2422180175781, -1.4179441960298, 218, 48, 'PPL', 'P'),
(112170, 'York', 38.9058303833008, 0.679034838411046, -82.1255569458008, -1.43336136873832, 218, 58, 'PPL', 'P'),
(118549, 'York', 42.6344413757324, 0.744111376755032, -91.4430618286133, -1.59598250701405, 218, 16, 'PPL', 'P'),
(124060, 'York', 41.6883316040039, 0.727598646153077, -84.8225021362305, -1.48043194205715, 218, 19, 'PPL', 'P'),
(133829, 'York', 42.1016693115234, 0.734812750071938, -83.7350006103516, -1.4614514598101, 218, 27, 'PPL', 'P'),
(138973, 'York', 47.1269416809082, 0.822520298727199, -91.7033309936523, -1.6005250608854, 218, 28, 'PPL', 'P'),
(139549, 'York', 40.4077796936035, 0.705248799073887, -95.2652816772461, -1.66269282810777, 218, 29, 'PPL', 'P'),
(141114, 'York', 48.3127784729004, 0.84321705513875, -99.5730590820313, -1.73787772726429, 218, 34, 'PPL', 'P'),
(143439, 'York', 40.8680610656738, 0.713282224502111, -97.591667175293, -1.70329591471934, 218, 35, 'PPL', 'P'),
(153977, 'York', 43.2000007629395, 0.753982250177356, -76.9436111450195, -1.34291935285479, 218, 40, 'PPL', 'P'),
(158495, 'York', 41.3591690063477, 0.721853675049558, -82.892219543457, -1.44674215531932, 218, 41, 'PPL', 'P'),
(177163, 'York', 44.4500007629395, 0.775798865827285, -91.1449966430664, -1.59078028814069, 218, 57, 'PPL', 'P'),
(177648, 'York', 32.8936080932617, 0.574101764088071, -109.202217102051, -1.90593823890845, 218, 5, 'PPL', 'P'),
(193159, 'York', 45.9091682434082, 0.801266142699495, -115.478607177734, -2.01548191086862, 218, 17, 'PPL', 'P'),
(197904, 'York', 46.7216682434082, 0.815446942871949, -111.751106262207, -1.95042474702157, 218, 31, 'PPL', 'P'),
(209244, 'York', 47.709171295166, 0.832682122498614, -122.152496337891, -2.13196325062651, 218, 56, 'PPL', 'P'),
(212244, 'York', 65.4936065673828, 1.14307907360661, -167.684173583984, -2.92664093252623, 218, 1, 'PPL', 'P'),
(158496, 'York (historical)', 41.4505615234375, 0.723448775384461, -80.6352767944336, -1.40735107331985, 218, 41, 'PPL', 'P'),
(14924, 'York Beach', 38.5094413757324, 0.672116545110266, -75.0533294677734, -1.30992771379673, 218, 10, 'PPL', 'P'),
(129402, 'York Beach', 43.1713905334473, 0.753482907472966, -70.6094436645508, -1.23236727494786, 218, 26, 'PPL', 'P'),
(118550, 'York Center', 41.3761100769043, 0.722149352509584, -95.5555572509766, -1.66775909260748, 218, 16, 'PPL', 'P'),
(122085, 'York Center', 41.8569412231445, 0.730541439157615, -87.9877777099609, -1.53567642255169, 218, 18, 'PPL', 'P'),
(158497, 'York Center', 40.4077796936035, 0.705248799073887, -83.4533309936523, -1.45653539759586, 218, 41, 'PPL', 'P'),
(177164, 'York Center', 43.2391700744629, 0.754665883629179, -89.0702819824219, -1.55456968627304, 218, 57, 'PPL', 'P'),
(129403, 'York Cliffs', 43.1911087036133, 0.753827054464831, -70.6033325195313, -1.2322606153462, 218, 26, 'PPL', 'P'),
(129404, 'York Corner', 43.1508293151855, 0.753124046516078, -70.6666717529297, -1.2333660935147, 218, 26, 'PPL', 'P'),
(79459, 'York Furnace', 39.8722190856934, 0.695901503121872, -76.3816680908203, -1.33311159635031, 218, 45, 'PPL', 'P'),
(129406, 'York Harbor', 43.1366691589355, 0.752876905166918, -70.646110534668, -1.23300723255781, 218, 26, 'PPL', 'P'),
(169208, 'York Haven', 40.1108283996582, 0.700066021276484, -76.7161102294922, -1.33894871282754, 218, 45, 'PPL', 'P'),
(107864, 'York Haven Anchorage', 37.1441688537598, 0.648288044414836, -76.3836135864258, -1.3331455516542, 218, 53, 'PPL', 'P'),
(129407, 'York Heights', 43.148609161377, 0.753085297522217, -70.6425018310547, -1.23294424879803, 218, 26, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(129408, 'York Landing', 43.7286109924316, 0.763208239141717, -70.2094421386719, -1.22538593130827, 218, 26, 'PPL', 'P'),
(107868, 'York manor', 38.7861099243164, 0.67694532221977, -77.1624984741211, -1.34673965743851, 218, 53, 'PPL', 'P'),
(6987, 'York Mountain', 33.8083305358887, 0.590066682453796, -86.9625015258789, -1.51778197739718, 218, 2, 'PPL', 'P'),
(53097, 'York Ridge', 39.4111099243164, 0.687853630044735, -76.6402816772461, -1.33762525492383, 218, 25, 'PPL', 'P'),
(107866, 'York River Farms', 37.2563896179199, 0.650246666238535, -76.4530563354492, -1.3343575562663, 218, 53, 'PPL', 'P'),
(79460, 'York Run', 39.8325004577637, 0.695208282290125, -79.7797164916992, -1.39241872908777, 218, 45, 'PPL', 'P'),
(79474, 'York Run Junction', 39.8169403076172, 0.694936706437964, -79.8030624389648, -1.39282619273455, 218, 45, 'PPL', 'P'),
(169210, 'York Springs', 40.0088882446289, 0.698286829931229, -77.1158294677734, -1.34592512961911, 218, 45, 'PPL', 'P'),
(84561, 'York Terrace', 34.7216682434082, 0.606007432632629, -81.2072219848633, -1.41733340003379, 218, 48, 'PPL', 'P'),
(107867, 'York Terrace', 37.2627792358398, 0.650358186109182, -76.6616668701172, -1.3379984969506, 218, 53, 'PPL', 'P'),
(14925, 'York Towne', 39.7638893127441, 0.69401079190597, -75.7333297729492, -1.32179595803661, 218, 10, 'PPL', 'P'),
(129409, 'York Village', 43.1436080932617, 0.75299801241749, -70.6513900756836, -1.23309937793152, 218, 26, 'PPL', 'P'),
(79464, 'Yorkana', 39.976390838623, 0.697719643198069, -76.5844421386719, -1.33665067112291, 218, 45, 'PPL', 'P'),
(44241, 'Yorkdale', 30.5577793121338, 0.533333861094543, -91.1213912963867, -1.59036829712005, 218, 22, 'PPL', 'P'),
(84562, 'Yorkdale', 34.9063911437988, 0.609231455448279, -80.9291687011719, -1.41248045473739, 218, 48, 'PPL', 'P'),
(53098, 'Yorke (historical)', 38.8872184753418, 0.678709999337084, -76.0749969482422, -1.32775917519146, 218, 25, 'PPL', 'P'),
(146693, 'Yorketown', 40.3077812194824, 0.703503496453503, -74.3380584716797, -1.29744387987087, 218, 37, 'PPL', 'P'),
(122088, 'Yorkfield', 41.8633308410645, 0.730652959028262, -87.9483337402344, -1.53498799540991, 218, 18, 'PPL', 'P'),
(53099, 'Yorkland', 39.5355606079102, 0.690025704229803, -76.9341735839844, -1.34275463634137, 218, 25, 'PPL', 'P'),
(53100, 'Yorkleigh', 39.3866691589355, 0.687427058217131, -76.6063919067383, -1.33703376684572, 218, 25, 'PPL', 'P'),
(14926, 'Yorklyn', 39.8080596923828, 0.694781710462521, -75.6758270263672, -1.32079234577982, 218, 10, 'PPL', 'P'),
(79466, 'Yorklyn', 39.9922218322754, 0.697995946161165, -76.6466674804688, -1.33773670821545, 218, 45, 'PPL', 'P'),
(14927, 'Yorklyn Ridge', 39.8005599975586, 0.694650816094944, -75.6750030517578, -1.32077796470993, 218, 10, 'PPL', 'P'),
(129411, 'Yorks Corner', 44.4991683959961, 0.776657002909536, -69.0066680908203, -1.20439356401572, 218, 26, 'PPL', 'P'),
(6988, 'Yorks Mill', 34.7447204589844, 0.606409769694313, -85.6736068725586, -1.49528652198539, 218, 2, 'PPL', 'P'),
(14928, 'Yorkshire', 39.6527786254883, 0.692071544579202, -75.7416687011719, -1.32194149979019, 218, 10, 'PPL', 'P'),
(79467, 'Yorkshire', 39.9661102294922, 0.697540212719625, -76.6611099243164, -1.33798877641262, 218, 45, 'PPL', 'P'),
(107869, 'Yorkshire', 38.7930603027344, 0.677066629207423, -77.4480590820313, -1.35172363026054, 218, 53, 'PPL', 'P'),
(118554, 'Yorkshire', 41.5205612182617, 0.724670500534535, -95.579719543457, -1.6681808041661, 218, 16, 'PPL', 'P'),
(153979, 'Yorkshire', 42.5299987792969, 0.7422885095679, -78.4730606079102, -1.3696132817251, 218, 40, 'PPL', 'P'),
(158505, 'Yorkshire', 40.3252792358398, 0.703808894451508, -84.4955596923828, -1.47472571994749, 218, 41, 'PPL', 'P'),
(107870, 'Yorkshire Acres', 38.7836112976074, 0.67690171295692, -77.4408264160156, -1.35159739642487, 218, 53, 'PPL', 'P'),
(53101, 'Yorkshire Knolls', 38.8911094665527, 0.678777909944881, -76.8861083984375, -1.341915740598, 218, 25, 'PPL', 'P'),
(206628, 'Yorkshire Meadows Condominium', 41.1602783203125, 0.718382377726694, -111.936393737793, -1.95365862353325, 218, 52, 'PPL', 'P'),
(107871, 'Yorkshire Park', 38.7930603027344, 0.677066629207423, -77.4652786254883, -1.35202416798956, 218, 53, 'PPL', 'P'),
(107872, 'Yorkshire Village', 38.7902793884277, 0.677018093096556, -77.4555587768555, -1.35185452462812, 218, 53, 'PPL', 'P'),
(143, 'Yorktown', 37.2386093139648, 0.649936341392513, -76.5100021362305, -1.33535144798512, 218, 53, 'PPL', 'P'),
(13003, 'Yorktown', 34.0208282470703, 0.593775467166868, -91.8166732788086, -1.60250325694311, 218, 4, 'PPL', 'P'),
(26296, 'Yorktown', 33.9488906860352, 0.59251991987095, -84.022216796875, -1.46646432792995, 218, 13, 'PPL', 'P'),
(39001, 'Yorktown', 37.4427795410156, 0.653499784089094, -82.5250015258789, -1.44033299183993, 218, 21, 'PPL', 'P'),
(53104, 'Yorktown', 39.3836097717285, 0.687373661837275, -76.6069412231445, -1.33704335422564, 218, 25, 'PPL', 'P'),
(70432, 'Yorktown', 36.0574989318848, 0.629322076395728, -80.0694427490234, -1.39747540620756, 218, 33, 'PPL', 'P'),
(71619, 'Yorktown', 39.6124992370605, 0.691368536630448, -75.3052825927734, -1.31432512538867, 218, 37, 'PPL', 'P'),
(92050, 'Yorktown', 35.9272193908691, 0.627048269457018, -86.4811096191406, -1.50938010363214, 218, 50, 'PPL', 'P'),
(99233, 'Yorktown', 28.9808292388916, 0.505810890176901, -97.5025024414063, -1.70173969653635, 218, 51, 'PPL', 'P'),
(118555, 'Yorktown', 40.7333297729492, 0.710930719838598, -95.1566696166992, -1.66079719004385, 218, 16, 'PPL', 'P'),
(122089, 'Yorktown', 41.5697212219238, 0.725528504458731, -89.8499984741211, -1.56817830628529, 218, 18, 'PPL', 'P'),
(124066, 'Yorktown', 40.1736106872559, 0.701161778906997, -85.4941711425781, -1.49215477770151, 218, 19, 'PPL', 'P'),
(153981, 'Yorktown', 41.2955589294434, 0.720743469770131, -73.8086090087891, -1.28820324352052, 218, 40, 'PPL', 'P'),
(158506, 'Yorktown', 40.4466705322266, 0.705927572256721, -81.5155563354492, -1.42271484964851, 218, 41, 'PPL', 'P'),
(153982, 'Yorktown Heights', 41.2708282470703, 0.720311837936457, -73.7780609130859, -1.28767007867028, 218, 40, 'PPL', 'P'),
(92052, 'Yorktown Woods', 35.038330078125, 0.611534224263843, -85.1055603027344, -1.4853722390373, 218, 50, 'PPL', 'P'),
(26297, 'Yorkville', 33.9241714477539, 0.592088487774357, -84.9955596923828, -1.48345236620746, 218, 13, 'PPL', 'P'),
(31581, 'Yorkville', 39.2044410705566, 0.684246578085304, -84.9674987792969, -1.48296261088299, 218, 19, 'PPL', 'P'),
(92053, 'Yorkville', 36.0994415283203, 0.630054112800363, -89.1188888549805, -1.55541803623829, 218, 50, 'PPL', 'P'),
(107873, 'Yorkville', 37.1508293151855, 0.648404291396418, -76.4283294677734, -1.33392599101165, 218, 53, 'PPL', 'P'),
(122091, 'Yorkville', 41.6411094665527, 0.726774464374725, -88.4472198486328, -1.54369520059392, 218, 18, 'PPL', 'P'),
(133831, 'Yorkville', 42.3752784729004, 0.739588130801587, -85.4016723632813, -1.4905403694487, 218, 27, 'PPL', 'P'),
(153984, 'Yorkville', 43.1127815246582, 0.752459987298267, -75.2713928222656, -1.31373363731056, 218, 40, 'PPL', 'P'),
(158507, 'Yorkville', 40.1544418334961, 0.700827219295056, -80.710563659668, -1.40866507700169, 218, 41, 'PPL', 'P'),
(177168, 'Yorkville', 42.7419395446777, 0.745987573742992, -88.0266723632813, -1.53635526231356, 218, 57, 'PPL', 'P'),
(186271, 'Yorkville', 38.8980598449707, 0.678899216932534, -123.213333129883, -2.15047834547306, 218, 6, 'PPL', 'P'),
(187565, 'Yorkville', 38.2922210693359, 0.668325335561456, -105.28971862793, -1.83765225855578, 218, 7, 'PPL', 'P'),
(84563, 'Yorkwood', 34.8041687011719, 0.607447337255008, -82.5466690063477, -1.44071116071472, 218, 48, 'PPL', 'P'),
(39000, 'Yosemite', 37.3466682434082, 0.65182232549748, -84.8247222900391, -1.48047069105101, 218, 21, 'PPL', 'P'),
(186272, 'Yosemite Forks', 37.3672218322754, 0.652181053296314, -119.630828857422, -2.08795185045186, 218, 6, 'PPL', 'P'),
(186273, 'Yosemite Junction', 37.8908309936523, 0.661319757155948, -120.48722076416, -2.10289870891187, 218, 6, 'PPL', 'P'),
(186274, 'Yosemite Lakes', 37.1911087036133, 0.649107299345172, -119.771667480469, -2.090409948138, 218, 6, 'PPL', 'P'),
(186275, 'Yosemite Lakes Park', 37.1819381713867, 0.648947243363658, -119.767219543457, -2.09033231699223, 218, 6, 'PPL', 'P'),
(186278, 'Yosemite Village', 37.7452812194824, 0.658779434371149, -119.597221374512, -2.08736528922177, 218, 6, 'PPL', 'P'),
(186276, 'Yosemite West', 37.6474990844727, 0.657072814165599, -119.717498779297, -2.08946452595102, 218, 6, 'PPL', 'P'),
(74911, 'Yost', 39.9086112976074, 0.696536667041856, -82.3327789306641, -1.4369780746567, 218, 41, 'PPL', 'P'),
(77745, 'Yost', 36.2008285522461, 0.631823650186666, -97.0111083984375, -1.69316325256186, 218, 42, 'PPL', 'P'),
(107874, 'Yost', 38.0522193908691, 0.664136516061898, -79.5405578613281, -1.38824462355324, 218, 53, 'PPL', 'P'),
(206633, 'Yost', 41.9608306884766, 0.732354652385795, -113.541389465332, -1.98167108345925, 218, 52, 'PPL', 'P'),
(99234, 'Yost Road Colonia', 26.1119995117188, 0.455740365758644, -97.6289978027344, -1.70394745708002, 218, 51, 'PPL', 'P'),
(107875, 'Yostland Heights', 37.2363891601563, 0.649897592398653, -79.9944381713867, -1.39616632937373, 218, 53, 'PPL', 'P'),
(153988, 'Yosts', 42.9116706848145, 0.748949940981542, -74.458610534668, -1.29954791029009, 218, 40, 'PPL', 'P'),
(169212, 'Yostville', 41.2966690063477, 0.720762844267062, -75.5550003051758, -1.31868352167064, 218, 45, 'PPL', 'P'),
(186277, 'You Bet', 39.209171295166, 0.684329136079096, -120.898887634277, -2.1100836512168, 218, 6, 'PPL', 'P'),
(834, 'Youba', 39.2150001525879, 0.684430868832737, -81.745002746582, -1.42671944497966, 218, 41, 'PPL', 'P'),
(99235, 'Youens', 30.3152809143066, 0.529101465621648, -95.3744430541992, -1.66459805355161, 218, 51, 'PPL', 'P'),
(99236, 'Yougeen', 28.3233299255371, 0.494335362329263, -97.7044372558594, -1.70526412392296, 218, 51, 'PPL', 'P'),
(26298, 'Youman', 31.2597198486328, 0.545585034609666, -82.2544403076172, -1.43561080775306, 218, 13, 'PPL', 'P'),
(18694, 'Youmans', 28.0249996185303, 0.489128516213508, -82.0683288574219, -1.43236255017149, 218, 12, 'PPL', 'P'),
(153986, 'Youmans Corner', 42.4033317565918, 0.740077752967998, -75.2552795410156, -1.31345240749945, 218, 40, 'PPL', 'P'),
(6990, 'Younds Landing', 32.8216705322266, 0.572846216792153, -85.8541717529297, -1.49843797366133, 218, 2, 'PPL', 'P'),
(13005, 'Young', 33.5744400024414, 0.585984522555896, -93.1808319091797, -1.62631231656258, 218, 4, 'PPL', 'P'),
(31583, 'Young', 39.610279083252, 0.691329787636588, -86.3375015258789, -1.50687366957222, 218, 19, 'PPL', 'P'),
(62407, 'Young', 30.9977798461914, 0.541013319124382, -89.3691711425781, -1.55978628621629, 218, 30, 'PPL', 'P'),
(99237, 'Young', 31.8419399261475, 0.555746691933513, -96.079719543457, -1.67690745042607, 218, 51, 'PPL', 'P'),
(112171, 'Young', 38.6388893127441, 0.674375837821034, -81.6769409179688, -1.42553154197543, 218, 58, 'PPL', 'P'),
(179590, 'Young', 34.101390838623, 0.595181549643402, -110.96305847168, -1.9366707184138, 218, 5, 'PPL', 'P'),
(201843, 'Young', 44.8247184753418, 0.782338923674247, -122.864166259766, -2.14438423395064, 218, 43, 'PPL', 'P'),
(92054, 'Young (historical)', 35.8680610656738, 0.626015761902394, -85.4738922119141, -1.49180084359264, 218, 50, 'PPL', 'P'),
(26299, 'Young Acres', 33.0233306884766, 0.576365850488802, -85.100830078125, -1.4852896810435, 218, 13, 'PPL', 'P'),
(6991, 'Young America', 31.2583293914795, 0.545560766554233, -85.3763885498047, -1.49009908365608, 218, 2, 'PPL', 'P'),
(124067, 'Young America', 40.5686111450195, 0.708055837441858, -86.3466720581055, -1.50703372555373, 218, 19, 'PPL', 'P'),
(177170, 'Young America', 43.4516716003418, 0.758374734921278, -88.1858291625977, -1.53913307248856, 218, 57, 'PPL', 'P'),
(179588, 'Young America Homes', 33.4761085510254, 0.584268314970421, -112.152221679688, -1.95742553173711, 218, 5, 'PPL', 'P'),
(179589, 'Young America West', 33.4927787780762, 0.584559265319512, -112.26000213623, -1.95930665557309, 218, 5, 'PPL', 'P'),
(92055, 'Young Bend', 35.9208297729492, 0.626936749586371, -85.7272186279297, -1.49622222363439, 218, 50, 'PPL', 'P'),
(107876, 'Young Corner', 38.1347198486328, 0.665576420684276, -77.3630599975586, -1.35024011637531, 218, 53, 'PPL', 'P'),
(13009, 'Young Gravelly', 34.9152793884277, 0.609386584581776, -93.658332824707, -1.63464627971982, 218, 4, 'PPL', 'P'),
(26301, 'Young Harris', 34.9330596923828, 0.609696909427798, -83.8472213745117, -1.46341008163379, 218, 13, 'PPL', 'P'),
(206631, 'Young Haven Circle', 40.7011108398438, 0.710368393374428, -111.821670532227, -1.95165632586767, 218, 52, 'PPL', 'P'),
(74912, 'Young Hickory', 39.7794418334961, 0.694282234600077, -81.7494430541992, -1.42679694296739, 218, 41, 'PPL', 'P'),
(153987, 'Young Hickory', 42.0527801513672, 0.733959473258677, -77.60888671875, -1.35453060204949, 218, 40, 'PPL', 'P'),
(44242, 'Young Landing', 31.7688903808594, 0.554471736851151, -91.5591735839844, -1.59800903944554, 218, 22, 'PPL', 'P'),
(53105, 'Young Mans Fancy', 39.7108306884766, 0.693084744215923, -76.7961120605469, -1.34034500818707, 218, 25, 'PPL', 'P'),
(189842, 'Young Place', 35.2694396972656, 0.615567848050877, -105.761390686035, -1.84588448895938, 218, 38, 'PPL', 'P'),
(13010, 'Young Subdivision', 35.0208282470703, 0.611228759686811, -91.8686065673828, -1.60340966382012, 218, 4, 'PPL', 'P'),
(192888, 'Youngberg', 33.4575004577637, 0.583943542475486, -111.490280151367, -1.94587247261224, 218, 5, 'PPL', 'P'),
(6994, 'Youngblood', 31.8449993133545, 0.555800088313369, -86.0694427490234, -1.50219516132722, 218, 2, 'PPL', 'P'),
(92057, 'Youngblood (historical)', 35.9563903808594, 0.627557399278414, -85.9127807617188, -1.49946089383603, 218, 50, 'PPL', 'P'),
(107877, 'Youngblood Acres', 37.1416702270508, 0.648244435151986, -77.329719543457, -1.34965821567713, 218, 53, 'PPL', 'P'),
(26302, 'Youngblood Corners (historical)', 32.8855590820313, 0.573961282340569, -83.1902770996094, -1.45194424103462, 218, 13, 'PPL', 'P'),
(192457, 'Youngblood Place', 30.3225002288818, 0.529227466430722, -103.166107177734, -1.80058824671682, 218, 51, 'PPL', 'P'),
(26303, 'Youngcane (historical)', 34.8325004577637, 0.607941819690408, -84.0788879394531, -1.46745342595881, 218, 13, 'PPL', 'P'),
(169214, 'Youngdale', 41.1500015258789, 0.718203013827277, -77.3649978637695, -1.35027393852116, 218, 45, 'PPL', 'P'),
(39002, 'Younger Creek', 37.7566719055176, 0.658978239346523, -85.7236099243164, -1.49615923987461, 218, 21, 'PPL', 'P'),
(58385, 'Youngers', 39.0511093139648, 0.681570434084911, -92.1244430541992, -1.6078748528618, 218, 29, 'PPL', 'P'),
(107878, 'Youngers Store', 36.8355598449707, 0.642901801110151, -78.9680633544922, -1.37825270945937, 218, 53, 'PPL', 'P'),
(26304, 'Youngs', 33.9477806091309, 0.59250054537402, -85.2233276367188, -1.48742766676662, 218, 13, 'PPL', 'P'),
(44243, 'Youngs', 29.9675006866455, 0.523031555575626, -92.1161117553711, -1.60772944426628, 218, 22, 'PPL', 'P'),
(62408, 'Youngs', 33.8530616760254, 0.590847388127353, -89.5344390869141, -1.56267075599296, 218, 30, 'PPL', 'P'),
(74913, 'Youngs', 38.898609161377, 0.678908804312458, -83.2061080932617, -1.45222054399772, 218, 41, 'PPL', 'P'),
(84565, 'Youngs', 34.6705589294434, 0.605115406825507, -82.0808334350586, -1.43258079622282, 218, 48, 'PPL', 'P'),
(153990, 'Youngs', 43.2063903808594, 0.754093770048003, -76.1669387817383, -1.32936386290629, 218, 40, 'PPL', 'P'),
(107879, 'Youngs (historical)', 37.1150016784668, 0.647778981172467, -81.6069412231445, -1.42430981682536, 218, 53, 'PPL', 'P'),
(112172, 'Youngs Bottom', 38.4622192382813, 0.671292363331913, -81.4266662597656, -1.42116342515549, 218, 58, 'PPL', 'P'),
(31584, 'Youngs Corner', 39.3541717529297, 0.686859871483971, -85.057502746582, -1.48453347645198, 218, 19, 'PPL', 'P'),
(129413, 'Youngs Corner', 44.1272201538086, 0.770165281436359, -70.2716674804688, -1.22647196840081, 218, 26, 'PPL', 'P'),
(158508, 'Youngs Corners', 41.1361083984375, 0.717960533010026, -81.7352828979492, -1.42654980161823, 218, 41, 'PPL', 'P'),
(31585, 'Youngs Creek', 38.4766693115234, 0.671544564687144, -86.4955596923828, -1.50963230498737, 218, 19, 'PPL', 'P'),
(39003, 'Youngs Creek', 36.8652801513672, 0.643420518311471, -84.2411117553711, -1.47028476567173, 218, 21, 'PPL', 'P'),
(92058, 'Youngs Crossing', 35.7394409179688, 0.623770916840539, -88.8475036621094, -1.55068147108153, 218, 50, 'PPL', 'P'),
(153991, 'Youngs Crossing', 42.9044418334961, 0.7488237737249, -75.0788879394531, -1.31037379327932, 218, 40, 'PPL', 'P'),
(186279, 'Youngs Hill (historical)', 39.4769401550293, 0.689002584318022, -121.066673278809, -2.11301206315145, 218, 6, 'PPL', 'P'),
(70435, 'Youngs Mountain', 35.4647216796875, 0.618976161613961, -82.1847229003906, -1.434394009451, 218, 33, 'PPL', 'P'),
(199798, 'Youngs Trailer Court', 40.2344398498535, 0.702223448075557, -100.416938781738, -1.75260620651492, 218, 35, 'PPL', 'P'),
(13263, 'Youngsborough (historical)', 38.9124984741211, 0.679151218550683, -77.0094375610352, -1.34406824054906, 218, 9, 'PPL', 'P'),
(79470, 'Youngsburg', 39.9500007629395, 0.69725904948754, -75.8197174072266, -1.32330370668776, 218, 45, 'PPL', 'P'),
(122093, 'Youngsdale', 41.9905586242676, 0.73287350274517, -88.3405609130859, -1.54183365099196, 218, 18, 'PPL', 'P'),
(99239, 'Youngsport', 30.9572200775146, 0.540305417617125, -97.7188873291016, -1.70551632527819, 218, 51, 'PPL', 'P'),
(13011, 'Youngstown', 33.4233283996582, 0.583347127549363, -91.7936096191406, -1.60210072014434, 218, 4, 'PPL', 'P'),
(18695, 'Youngstown', 30.3641700744629, 0.529954742434909, -85.4383316040039, -1.4911801939006, 218, 12, 'PPL', 'P'),
(26305, 'Youngstown', 34.8797187805176, 0.608765934889733, -83.978889465332, -1.46570812333842, 218, 13, 'PPL', 'P'),
(31586, 'Youngstown', 39.3622207641602, 0.687000353231473, -87.3822174072266, -1.52510740144961, 218, 19, 'PPL', 'P'),
(112173, 'Youngstown', 38.0919418334961, 0.664829803472673, -81.144172668457, -1.41623298187137, 218, 58, 'PPL', 'P'),
(122094, 'Youngstown', 40.6605606079102, 0.709660658314739, -90.6172180175781, -1.58156881340427, 218, 18, 'PPL', 'P'),
(139551, 'Youngstown', 40.1747207641602, 0.701181153403927, -92.6819381713867, -1.61760497822051, 218, 29, 'PPL', 'P'),
(146694, 'Youngstown', 40.8419418334961, 0.712826357902517, -74.5702819824219, -1.30149694473387, 218, 37, 'PPL', 'P'),
(153992, 'Youngstown', 43.2472190856934, 0.754806365376681, -79.0502777099609, -1.3796876206547, 218, 40, 'PPL', 'P'),
(158509, 'Youngstown', 41.0997200012207, 0.717325435669069, -80.6497192382813, -1.40760314151702, 218, 41, 'PPL', 'P'),
(169216, 'Youngstown', 40.2797203063965, 0.703013741129038, -79.3658294677734, -1.38519503778899, 218, 45, 'PPL', 'P'),
(186280, 'Youngstown', 38.1738891601563, 0.6662600541361, -121.241943359375, -2.11607110313757, 218, 6, 'PPL', 'P'),
(13012, 'Youngstown (historical)', 34.1444396972656, 0.595932893965941, -91.7063903808594, -1.60057845726525, 218, 4, 'PPL', 'P'),
(153993, 'Youngstown Estates', 43.2366714477539, 0.754622274366329, -79.0475006103516, -1.37963915112286, 218, 40, 'PPL', 'P'),
(70438, 'Youngsville', 36.0247192382813, 0.628749962814551, -78.4747161865234, -1.36964217702292, 218, 33, 'PPL', 'P'),
(74914, 'Youngsville', 38.922779083252, 0.679330649029127, -83.567497253418, -1.45852797472346, 218, 41, 'PPL', 'P'),
(153994, 'Youngsville', 41.8083305358887, 0.729693022613343, -74.8866729736328, -1.30701900925415, 218, 40, 'PPL', 'P'),
(169219, 'Youngsville', 41.8522186279297, 0.730459014321877, -79.3188934326172, -1.38437584943768, 218, 45, 'PPL', 'P'),
(189843, 'Youngsville', 36.1875, 0.631591023065448, -106.55583190918, -1.85975010401682, 218, 38, 'PPL', 'P'),
(62409, 'Youngton', 32.4474983215332, 0.566315679746088, -90.6202774047852, -1.58162220978412, 218, 30, 'PPL', 'P'),
(6995, 'Youngtown', 34.4166717529297, 0.600684239666751, -87.3908309936523, -1.52525773689314, 218, 2, 'PPL', 'P'),
(39004, 'Youngtown', 37.1813888549805, 0.648937655983734, -86.7186126708984, -1.51352531386885, 218, 21, 'PPL', 'P'),
(129412, 'Youngtown', 44.2686080932617, 0.772632966502426, -69.0980606079102, -1.20598866435063, 218, 26, 'PPL', 'P'),
(179591, 'Youngtown', 33.5938911437988, 0.586324009015853, -112.302223205566, -1.96004355224671, 218, 5, 'PPL', 'P'),
(199129, 'Youngtown', 46.9425010681152, 0.819301202759566, -101.407501220703, -1.76989478252144, 218, 34, 'PPL', 'P'),
(92059, 'Youngville', 36.5852813720703, 0.638533617711176, -86.8258285522461, -1.5153965840088, 218, 50, 'PPL', 'P'),
(26306, 'Youngwood', 31.1700000762939, 0.544019129178213, -81.3858337402344, -1.42045076324778, 218, 13, 'PPL', 'P'),
(169220, 'Youngwood', 40.2402801513672, 0.70232538056628, -79.5769424438477, -1.38887965431516, 218, 45, 'PPL', 'P'),
(58386, 'Yount', 37.605281829834, 0.656335984071001, -90.0388870239258, -1.5714750333987, 218, 29, 'PPL', 'P'),
(169222, 'Yount', 40.061939239502, 0.699212744463222, -78.4727783203125, -1.36960835487708, 218, 45, 'PPL', 'P'),
(92060, 'Yount Town', 36.4427795410156, 0.636046491569151, -83.2377777099609, -1.45277328308196, 218, 50, 'PPL', 'P'),
(124068, 'Yountsville', 40.0247192382813, 0.698563132894325, -86.9800033569336, -1.51808744197421, 218, 19, 'PPL', 'P'),
(186281, 'Yountville', 38.401668548584, 0.670235554432343, -122.359718322754, -2.13557995654489, 218, 6, 'PPL', 'P'),
(26307, 'Youth', 33.7852783203125, 0.589664345392113, -83.8561096191406, -1.46356521076729, 218, 13, 'PPL', 'P'),
(70436, 'Yow Mill', 35.5522193908691, 0.620503284762039, -79.7227783203125, -1.39142497052701, 218, 33, 'PPL', 'P'),
(99240, 'Yowell', 33.3452796936035, 0.581984920651787, -95.8600006103516, -1.67307263161441, 218, 51, 'PPL', 'P'),
(26308, 'Ypsilanti', 32.7425003051758, 0.571464435660565, -84.413330078125, -1.47329054243604, 218, 13, 'PPL', 'P'),
(133832, 'Ypsilanti', 42.2411117553711, 0.737246479834107, -83.6130599975586, -1.45932319462496, 218, 27, 'PPL', 'P'),
(141118, 'Ypsilanti', 46.7819404602051, 0.81649889150253, -98.5627822875977, -1.72024507084493, 218, 34, 'PPL', 'P'),
(194077, 'Yreka', 41.7355613708496, 0.728422961089484, -122.633331298828, -2.14035540385356, 218, 6, 'PPL', 'P'),
(197905, 'Yreka', 46.8613891601563, 0.817885532903107, -113.330001831055, -1.97798167324311, 218, 31, 'PPL', 'P'),
(189844, 'Yrisarri', 34.9663887023926, 0.610278610388898, -106.290832519531, -1.85512499215168, 218, 38, 'PPL', 'P'),
(44244, 'Yscloskey', 29.8416690826416, 0.520835379782692, -89.6883316040039, -1.56535668711036, 218, 22, 'PPL', 'P'),
(186282, 'Ysidora (historical)', 33.2597198486328, 0.580491619649553, -117.362777709961, -2.04836689032503, 218, 6, 'PPL', 'P'),
(192458, 'Ysleta', 31.6983299255371, 0.553240224584072, -106.324440002441, -1.85571155338177, 218, 51, 'PPL', 'P'),
(99241, 'Yturria', 26.5680599212646, 0.463700121493214, -97.7705612182617, -1.70641820478135, 218, 51, 'PPL', 'P'),
(856, 'Yuba', 33.809440612793, 0.590086056950727, -96.2041702270508, -1.67907952461114, 218, 42, 'PPL', 'P'),
(39006, 'Yuba', 37.5761108398438, 0.655826854249605, -87.8386077880859, -1.53307291627003, 218, 21, 'PPL', 'P'),
(133835, 'Yuba', 44.8233299255371, 0.782314688908327, -85.4591674804688, -1.49154384854745, 218, 27, 'PPL', 'P'),
(177171, 'Yuba', 43.538890838623, 0.759896997800367, -90.4297180175781, -1.57829632105678, 218, 57, 'PPL', 'P'),
(186286, 'Yuba (historical)', 39.1191711425781, 0.68275833708914, -121.569442749023, -2.12178704578521, 218, 6, 'PPL', 'P'),
(186283, 'Yuba City', 39.1405601501465, 0.683131645694942, -121.615829467773, -2.12259664675659, 218, 6, 'PPL', 'P'),
(186285, 'Yuba Pass', 39.3230590820313, 0.686316852937704, -120.599166870117, -2.10485253704561, 218, 6, 'PPL', 'P'),
(186287, 'Yucaipa', 34.0336112976074, 0.593998573487189, -117.042221069336, -2.04277212150699, 218, 6, 'PPL', 'P'),
(58387, 'Yucatan', 38.8544387817383, 0.678137885755907, -91.7502822875977, -1.60134451555281, 218, 29, 'PPL', 'P'),
(138978, 'Yucatan', 43.6805610656738, 0.762369609714451, -91.688606262207, -1.6002680658402, 218, 28, 'PPL', 'P'),
(44245, 'Yucatan Landing', 32.079719543457, 0.559896729149697, -91.1538925170898, -1.59093555043224, 218, 22, 'PPL', 'P'),
(6996, 'Yucca', 34.7991714477539, 0.607360118729308, -85.8066711425781, -1.49760893161399, 218, 2, 'PPL', 'P'),
(179592, 'Yucca', 34.8722190856934, 0.608635040522156, -114.148612976074, -1.99226913301722, 218, 5, 'PPL', 'P'),
(6997, 'Yucca (historical)', 34.771110534668, 0.606870363404842, -85.82861328125, -1.49799189417875, 218, 2, 'PPL', 'P'),
(99242, 'Yucca Acres Colonia', 27.9179992675781, 0.487261007788604, -97.9010009765625, -1.7086948080392, 218, 51, 'PPL', 'P'),
(186288, 'Yucca Grove', 35.4025001525879, 0.617890191100454, -115.791389465332, -2.02094099162912, 218, 6, 'PPL', 'P'),
(186289, 'Yucca Inn', 34.4097213745117, 0.600562932679098, -117.588607788086, -2.05230836873835, 218, 6, 'PPL', 'P'),
(186290, 'Yucca Valley', 34.1141700744629, 0.595404589384697, -116.43138885498, -2.03211108818924, 218, 6, 'PPL', 'P'),
(70437, 'Yucca Village', 34.7677803039551, 0.606812239914051, -76.5577774047852, -1.33618528372242, 218, 33, 'PPL', 'P'),
(99243, 'Yucote Acres', 33.0997200012207, 0.577699095509523, -96.4786071777344, -1.6838693529897, 218, 51, 'PPL', 'P'),
(13015, 'Yukon', 33.7969398498535, 0.589867877478422, -91.478889465332, -1.596607817238, 218, 4, 'PPL', 'P'),
(18700, 'Yukon', 30.2344398498535, 0.527690522876124, -81.6983337402344, -1.42590491716026, 218, 12, 'PPL', 'P'),
(26309, 'Yukon', 34.6272201538086, 0.604359002496897, -84.4680633544922, -1.47424581831906, 218, 13, 'PPL', 'P'),
(58388, 'Yukon', 37.2730598449707, 0.650537616587626, -91.8480606079102, -1.60305106917934, 218, 29, 'PPL', 'P'),
(77746, 'Yukon', 35.5066719055176, 0.619708331176651, -97.7622222900391, -1.70627266302777, 218, 42, 'PPL', 'P'),
(92061, 'Yukon', 35.0747184753418, 0.6121693216048, -86.6658325195313, -1.51260412644779, 218, 50, 'PPL', 'P'),
(112174, 'Yukon', 37.3191719055176, 0.651342423869048, -81.6963882446289, -1.42587096185637, 218, 58, 'PPL', 'P'),
(169223, 'Yukon', 40.2125015258789, 0.701840552089831, -79.6830596923828, -1.39073174969526, 218, 45, 'PPL', 'P'),
(197906, 'Yukon Saddle', 46.7097206115723, 0.815238417358595, -113.813056945801, -1.98641257546403, 218, 31, 'PPL', 'P'),
(153995, 'Yulan', 41.5224990844727, 0.724704322680379, -74.9333267211914, -1.30783327075744, 218, 40, 'PPL', 'P'),
(18696, 'Yulee', 30.6316699981689, 0.534623496852414, -81.6066665649414, -1.4243050231354, 218, 12, 'PPL', 'P'),
(18697, 'Yulee Heights', 30.6072196960449, 0.534196758577242, -81.5977783203125, -1.4241498940019, 218, 12, 'PPL', 'P'),
(186291, 'Yulupa (historical)', 38.3416709899902, 0.669188399491723, -122.504440307617, -2.13810583168077, 218, 6, 'PPL', 'P'),
(92062, 'Yum Yum', 35.3452796936035, 0.616891505691674, -89.3638916015625, -1.55969414084257, 218, 50, 'PPL', 'P'),
(144, 'Yuma', 36.6150016784668, 0.639052334912496, -82.6125030517578, -1.44186018156704, 218, 53, 'PPL', 'P'),
(34485, 'Yuma', 39.5911102294922, 0.690995228024647, -97.7494430541992, -1.70604962328648, 218, 20, 'PPL', 'P'),
(39005, 'Yuma', 37.2802810668945, 0.650663650686214, -85.2416687011719, -1.48774777872965, 218, 21, 'PPL', 'P'),
(92063, 'Yuma', 35.8474998474121, 0.625656900945506, -88.336669921875, -1.54176574038416, 218, 50, 'PPL', 'P'),
(133836, 'Yuma', 44.3466682434082, 0.773995373137083, -85.7547225952148, -1.49670225842088, 218, 27, 'PPL', 'P'),
(179593, 'Yuma', 32.7252807617188, 0.57116389793155, -114.623611450195, -2.00055942033258, 218, 5, 'PPL', 'P'),
(194486, 'Yuma', 40.1222190856934, 0.700264826251858, -102.724716186523, -1.79288452063155, 218, 7, 'PPL', 'P'),
(13013, 'Yuma (historical)', 34.8358306884766, 0.607999943181199, -91.4977798461914, -1.59693751658095, 218, 4, 'PPL', 'P'),
(206632, 'Yuma View', 40.711109161377, 0.710542897004855, -111.832778930664, -1.95185020399503, 218, 52, 'PPL', 'P'),
(186292, 'Yuman (historical)', 39.5125007629395, 0.689623234010065, -121.556938171387, -2.12156879973387, 218, 6, 'PPL', 'P'),
(211316, 'Yung Hee Village', 20.8613891601563, 0.364099927384581, -156.45556640625, -2.73066476686169, 218, 15, 'PPL', 'P'),
(6998, 'Yupon', 30.4086093902588, 0.530730354812881, -87.8169403076172, -1.53269474739524, 218, 2, 'PPL', 'P'),
(186293, 'Yupu (historical)', 39.1333312988281, 0.6830054784383, -121.616668701172, -2.12261129414259, 218, 6, 'PPL', 'P'),
(143441, 'Yutan', 41.2449989318848, 0.719861031342934, -96.3969421386719, -1.68244402917429, 218, 35, 'PPL', 'P'),
(122095, 'Yuton', 40.5333290100098, 0.707440048018804, -89.0602798461914, -1.55439511606359, 218, 18, 'PPL', 'P'),
(99248, 'Yvonne Colonia', 26.2110004425049, 0.457468257963401, -98.2009963989258, -1.71393071590035, 218, 51, 'PPL', 'P'),
(99244, 'Yznaga', 26.3161106109619, 0.459302776480302, -97.8133316040039, -1.70716468883489, 218, 51, 'PPL', 'P'),
(99245, 'Yznaga Number 1 Colonia', 26.3099994659424, 0.459196116878644, -97.8290023803711, -1.70743819547885, 218, 51, 'PPL', 'P'),
(99246, 'Yznaga Number 2 Colonia', 26.3279991149902, 0.459510270018733, -97.802001953125, -1.70696694912396, 218, 51, 'PPL', 'P'),
(99247, 'Zabcikville', 31.0450000762939, 0.54183746761322, -97.166389465332, -1.69587341844518, 218, 51, 'PPL', 'P'),
(44246, 'Zacarter', 29.6652793884277, 0.517756798852074, -91.0297164916992, -1.58876826993713, 218, 22, 'PPL', 'P'),
(107880, 'Zacata', 38.1199989318848, 0.665319492218111, -76.7825012207031, -1.34010745421783, 218, 53, 'PPL', 'P'),
(99249, 'Zacatal Colonia', 26.0830001831055, 0.455234231993474, -97.870002746582, -1.70815378686375, 218, 51, 'PPL', 'P'),
(99256, 'Zacha Junction', 32.8647193908691, 0.573597561114692, -96.6688919067383, -1.68719044802708, 218, 51, 'PPL', 'P'),
(39007, 'Zachariah', 37.7050018310547, 0.658076426422395, -83.6836090087891, -1.46055450715496, 218, 21, 'PPL', 'P'),
(44247, 'Zachary', 30.6483306884766, 0.534914280753937, -91.1563873291016, -1.59097909311606, 218, 22, 'PPL', 'P'),
(92064, 'Zacharytown', 36.1391716003418, 0.630747533369193, -83.727783203125, -1.46132549229054, 218, 50, 'PPL', 'P'),
(177173, 'Zachow', 44.7322196960449, 0.780724515421441, -88.3636093139648, -1.54223592147461, 218, 57, 'PPL', 'P'),
(13014, 'Zack', 35.958610534668, 0.627596148272275, -92.6661071777344, -1.61732867525742, 218, 4, 'PPL', 'P'),
(107881, 'Zack', 37.9927787780762, 0.663099081659257, -79.3611068725586, -1.38511261295325, 218, 53, 'PPL', 'P'),
(112175, 'Zackville', 38.9741706848145, 0.680227601684265, -81.4702835083008, -1.42192468975309, 218, 58, 'PPL', 'P'),
(112176, 'Zada', 37.8252792358398, 0.66017566315165, -81.4097213745117, -1.42086768111643, 218, 58, 'PPL', 'P'),
(58389, 'Zadock', 36.9888916015625, 0.645577945110544, -89.9372177124023, -1.56970056916438, 218, 29, 'PPL', 'P'),
(13021, 'Zadock (historical)', 35.5675010681152, 0.620770000345211, -93.3694381713867, -1.62960411682797, 218, 4, 'PPL', 'P'),
(84566, 'Zadok (historical)', 35.0791702270508, 0.612247019329603, -81.2783279418945, -1.41857443310177, 218, 48, 'PPL', 'P'),
(77748, 'Zafra', 34.5083312988281, 0.602284000533562, -94.4883270263672, -1.64913241131125, 218, 42, 'PPL', 'P'),
(39008, 'Zag', 37.9866714477539, 0.662992488636627, -83.3649978637695, -1.45499369364082, 218, 21, 'PPL', 'P'),
(193187, 'Zahl', 48.5733299255371, 0.847764535858115, -103.691673278809, -1.80976110561743, 218, 34, 'PPL', 'P'),
(74915, 'Zahns Corners', 39.0605583190918, 0.681735350335414, -82.9625015258789, -1.44796880731741, 218, 41, 'PPL', 'P'),
(26310, 'Zaidee', 32.3738899230957, 0.565030970836234, -82.529167175293, -1.44040569613769, 218, 13, 'PPL', 'P'),
(143442, 'Zaks Trailer Court', 42.4577789306641, 0.741028035423965, -98.647216796875, -1.72171873103412, 218, 35, 'PPL', 'P'),
(74916, 'Zaleski', 39.2822189331055, 0.685604057871945, -82.3949966430664, -1.43806397859118, 218, 41, 'PPL', 'P'),
(177309, 'Zalia', 40.4622192382813, 0.7061989483718, -80.5941696166992, -1.40663361772218, 218, 58, 'PPL', 'P'),
(58390, 'Zalma', 37.144718170166, 0.64829763179476, -90.0761108398438, -1.57212471154663, 218, 29, 'PPL', 'P'),
(62410, 'Zama', 32.9749984741211, 0.575522294213519, -89.379997253418, -1.55997523749563, 218, 30, 'PPL', 'P'),
(13016, 'Zama (historical)', 33.6688919067383, 0.587633019270655, -93.1694412231445, -1.62611351158721, 218, 4, 'PPL', 'P'),
(187581, 'Zamara', 37.1538887023926, 0.648457687776274, -104.919998168945, -1.83119941923452, 218, 7, 'PPL', 'P'),
(186294, 'Zamora', 38.7966690063477, 0.677129612967203, -121.880828857422, -2.12722175862173, 218, 6, 'PPL', 'P'),
(189845, 'Zamora', 35.1022186279297, 0.612649289812259, -106.355003356934, -1.85624498454811, 218, 38, 'PPL', 'P'),
(99250, 'Zamora Acres Colonia', 28.4349994659424, 0.496284363483524, -99.2269973754883, -1.73183781107004, 218, 51, 'PPL', 'P'),
(192459, 'Zamora Lands Colonia', 28.6749992370605, 0.500473149693569, -100.473999023438, -1.75360209560455, 218, 51, 'PPL', 'P'),
(6999, 'Zana', 33.0269393920898, 0.576428834248582, -85.7127838134766, -1.49597028859527, 218, 2, 'PPL', 'P'),
(18699, 'Zana', 27.1197204589844, 0.473328414229745, -80.6197204589844, -1.40707956404671, 218, 12, 'PPL', 'P'),
(7000, 'Zana (historical)', 33.0280609130859, 0.576448408482594, -85.7211074829102, -1.49611556403273, 218, 2, 'PPL', 'P'),
(39009, 'Zandale', 38.0052795410156, 0.663317261131562, -84.5122222900391, -1.47501653713852, 218, 21, 'PPL', 'P'),
(177174, 'Zander', 44.313060760498, 0.773408811906993, -87.7052764892578, -1.53074584610952, 218, 57, 'PPL', 'P'),
(192873, 'Zane', 37.9252815246582, 0.661921032351061, -113.582496643066, -1.98238853905692, 218, 52, 'PPL', 'P'),
(77749, 'Zaneis', 34.1725006103516, 0.596422649290407, -97.498893737793, -1.70167671277657, 218, 42, 'PPL', 'P'),
(169225, 'Zaner', 41.1302795410156, 0.717858800256385, -76.3586120605469, -1.33270919270959, 218, 45, 'PPL', 'P'),
(158512, 'Zanesfield', 40.3383293151855, 0.704036661303737, -83.6772232055664, -1.46044305386334, 218, 41, 'PPL', 'P'),
(29051, 'Zanesville', 39.3222198486328, 0.686302205551709, -89.6530609130859, -1.56474109742438, 218, 18, 'PPL', 'P'),
(74917, 'Zanesville', 39.9402809143066, 0.697089406126102, -82.0133285522461, -1.43140261375657, 218, 41, 'PPL', 'P'),
(124069, 'Zanesville', 40.9172210693359, 0.714140228426307, -85.2805633544922, -1.48842661849151, 218, 19, 'PPL', 'P'),
(74918, 'Zanesville Terrace', 39.8994407653809, 0.696376611060342, -82.0338897705078, -1.43176147471346, 218, 41, 'PPL', 'P'),
(118556, 'Zaneta', 42.3936080932617, 0.739908043027532, -92.5519409179688, -1.61533609812982, 218, 16, 'PPL', 'P'),
(209247, 'Zangar Junction', 46.0755615234375, 0.804170253289199, -118.842498779297, -2.07419289499607, 218, 56, 'PPL', 'P'),
(58391, 'Zanoni', 36.6861114501953, 0.6402934345595, -92.331672668457, -1.61149169193823, 218, 29, 'PPL', 'P'),
(107883, 'Zanoni', 37.3886108398438, 0.652554361902116, -76.4877777099609, -1.33496355857235, 218, 53, 'PPL', 'P'),
(186296, 'Zante', 36.1147193908691, 0.630320761804507, -119.044723510742, -2.07772238238875, 218, 6, 'PPL', 'P'),
(199130, 'Zap', 47.2863883972168, 0.825303168908277, -101.922218322754, -1.77887829066855, 218, 34, 'PPL', 'P'),
(99251, 'Zapata', 26.9069404602051, 0.469614702668657, -99.271110534668, -1.73260773094118, 218, 51, 'PPL', 'P'),
(99253, 'Zapata Ranch', 26.3566703796387, 0.460010677987559, -97.8288879394531, -1.70743619810803, 218, 51, 'PPL', 'P'),
(99254, 'Zapata Ranch Colonia', 26.3560009002686, 0.459998993368276, -97.8300018310547, -1.70745563918399, 218, 51, 'PPL', 'P'),
(62411, 'Zaphyr Hill', 32.7747192382813, 0.572026762124736, -89.2430572509766, -1.55758518357534, 218, 30, 'PPL', 'P'),
(112177, 'Zar (historical)', 39.6300010681152, 0.69167400120748, -79.5652770996094, -1.38867605564983, 218, 58, 'PPL', 'P'),
(70439, 'Zara', 34.4341697692871, 0.600989637664756, -78.3633270263672, -1.36769806942716, 218, 33, 'PPL', 'P'),
(34486, 'Zarah', 39.0072212219238, 0.680804442376377, -94.8236083984375, -1.65498417517448, 218, 20, 'PPL', 'P'),
(99255, 'Zarate Colonia', 26.3199996948242, 0.459370653798585, -98.6370010375977, -1.72154043239914, 218, 51, 'PPL', 'P'),
(146695, 'Zarephath', 40.5363883972168, 0.70749344439866, -74.5749969482422, -1.30157923641155, 218, 37, 'PPL', 'P'),
(99258, 'Zavalla', 31.1583309173584, 0.543815463933849, -94.4261093139648, -1.64804650737677, 218, 51, 'PPL', 'P'),
(186298, 'Zayante', 37.0919418334961, 0.647376510952729, -122.042503356934, -2.13004351095472, 218, 6, 'PPL', 'P'),
(195827, 'Zaza', 46.0622215270996, 0.803937426430899, -116.845283508301, -2.03933491264608, 218, 17, 'PPL', 'P'),
(74920, 'Zeal (historical)', 39.1963882446289, 0.684106029758775, -82.2961120605469, -1.43633811704676, 218, 41, 'PPL', 'P'),
(34487, 'Zeandale', 39.1594390869141, 0.683461145300812, -96.4263916015625, -1.68295801926467, 218, 20, 'PPL', 'P'),
(118557, 'Zearing', 42.1611099243164, 0.735850184474579, -93.2969436645508, -1.62833884899408, 218, 16, 'PPL', 'P'),
(122096, 'Zearing', 41.4455604553223, 0.723361490279734, -89.3172225952148, -1.55887961302317, 218, 18, 'PPL', 'P'),
(77750, 'Zeb', 35.8216705322266, 0.625206094351983, -95.054443359375, -1.65901300527155, 218, 42, 'PPL', 'P'),
(13017, 'Zeb (historical)', 35.9388885498047, 0.627251934701382, -92.7680587768555, -1.61910806633975, 218, 4, 'PPL', 'P'),
(133837, 'Zeba', 46.8025016784668, 0.816857752459418, -88.414436340332, -1.54312302043372, 218, 27, 'PPL', 'P'),
(26311, 'Zebina', 33.1644401550293, 0.57882867528588, -82.353889465332, -1.43734652299352, 218, 13, 'PPL', 'P'),
(79473, 'Zebleys Corner', 39.8347206115723, 0.695247031283985, -75.498893737793, -1.31770427733782, 218, 45, 'PPL', 'P'),
(70440, 'Zebra (historical)', 36.3141708374023, 0.633801846244377, -81.0627822875977, -1.41481245174592, 218, 33, 'PPL', 'P'),
(26313, 'Zebulon', 33.1022186279297, 0.577742704772373, -84.3427810668945, -1.47205922990605, 218, 13, 'PPL', 'P'),
(39010, 'Zebulon', 37.5333290100098, 0.655080170458974, -82.466667175293, -1.43931486535519, 218, 21, 'PPL', 'P'),
(70441, 'Zebulon', 35.8241691589355, 0.625249703614833, -78.3150024414063, -1.36685464630994, 218, 33, 'PPL', 'P'),
(13018, 'Zebulon (historical)', 34.3097190856934, 0.598817563479688, -93.6305618286133, -1.63416158440142, 218, 4, 'PPL', 'P'),
(169226, 'Zediker', 40.1719398498535, 0.70113261729306, -80.1750030517578, -1.39931778104968, 218, 45, 'PPL', 'P'),
(186299, 'Zediker', 36.7572212219238, 0.641534534206504, -119.523063659668, -2.08607099293199, 218, 6, 'PPL', 'P'),
(186300, 'Zee Estates', 38.7638893127441, 0.676557499386027, -121.047218322754, -2.11267251011246, 218, 6, 'PPL', 'P'),
(133838, 'Zeeland', 42.8125, 0.747219086010072, -86.0186080932617, -1.50130792921006, 218, 27, 'PPL', 'P'),
(141120, 'Zeeland', 45.9700012207031, 0.802327878447082, -99.8302764892578, -1.74236701791383, 218, 34, 'PPL', 'P'),
(107882, 'Zeiger', 39.1988906860352, 0.684149705600652, -78.2572174072266, -1.36584610720512, 218, 53, 'PPL', 'P'),
(26314, 'Zeigler', 32.7516708374023, 0.571624491642079, -81.7302780151367, -1.42646244993447, 218, 13, 'PPL', 'P'),
(29053, 'Zeigler', 37.8994407653809, 0.661470026020456, -89.0519409179688, -1.55424957431002, 218, 18, 'PPL', 'P'),
(79475, 'Zeigler', 39.7555618286133, 0.693865449889479, -76.6080627441406, -1.33706292845966, 218, 45, 'PPL', 'P'),
(124070, 'Zeigler', 41.6983299255371, 0.727773149783504, -86.4336090087891, -1.5085510615848, 218, 19, 'PPL', 'P'),
(62416, 'Zeiglerville', 32.9502792358398, 0.575090862116926, -90.1699981689453, -1.57376335456535, 218, 30, 'PPL', 'P'),
(39011, 'Zekes Point', 37.350830078125, 0.651894963216212, -83.8888931274414, -1.4641373909275, 218, 21, 'PPL', 'P'),
(53117, 'Zekiah Valley', 38.5705604553223, 0.673183274284897, -76.857780456543, -1.34142132474163, 218, 25, 'PPL', 'P'),
(112183, 'Zela', 38.285831451416, 0.668213815690809, -80.9499969482422, -1.41284397622619, 218, 58, 'PPL', 'P'),
(39018, 'Zelda', 38.1949996948242, 0.666628502472912, -82.6047210693359, -1.44172436035144, 218, 21, 'PPL', 'P'),
(169227, 'Zelienople', 40.7944412231445, 0.711997315855175, -80.1369400024414, -1.39865345551576, 218, 45, 'PPL', 'P'),
(58394, 'Zell', 37.9524993896484, 0.662396073710504, -90.1427764892578, -1.57328824662688, 218, 29, 'PPL', 'P'),
(171667, 'Zell', 44.8969383239746, 0.783599397818182, -98.7280578613281, -1.72312967377965, 218, 49, 'PPL', 'P'),
(99259, 'Zella', 28.562780380249, 0.498514561159383, -98.7927780151367, -1.724259253556, 218, 51, 'PPL', 'P'),
(62412, 'Zelleria', 32.9636116027832, 0.575323555817172, -90.3494415283203, -1.57689523200729, 218, 30, 'PPL', 'P'),
(13019, 'Zellner (historical)', 33.813060760498, 0.590149240447589, -91.2652816772461, -1.592879658028, 218, 4, 'PPL', 'P'),
(26315, 'Zellobee', 32.2961082458496, 0.563673424470566, -84.6205596923828, -1.47690738151248, 218, 13, 'PPL', 'P'),
(18701, 'Zellwood', 28.7308292388916, 0.501447567046915, -81.6013870239258, -1.42421287776168, 218, 12, 'PPL', 'P'),
(31587, 'Zelma', 38.9338912963867, 0.679524593735512, -86.3019409179688, -1.50625301988017, 218, 19, 'PPL', 'P'),
(53107, 'Zeman', 39.1152801513672, 0.682690426481343, -76.6066665649414, -1.33703856053568, 218, 25, 'PPL', 'P'),
(84567, 'Zemp', 34.2705612182617, 0.598134129764946, -80.3269424438477, -1.40196962370512, 218, 48, 'PPL', 'P'),
(138979, 'Zemple', 47.3230590820313, 0.825943193097251, -93.7852783203125, -1.63686189658871, 218, 28, 'PPL', 'P'),
(62413, 'Zemuly', 32.9491691589355, 0.575071487619996, -89.7216720581055, -1.56593858780854, 218, 30, 'PPL', 'P'),
(77752, 'Zena', 36.4961090087891, 0.636977266370133, -94.8533325195313, -1.65550295895483, 218, 42, 'PPL', 'P'),
(153996, 'Zena', 42.0166702270508, 0.73332923618671, -74.0766677856445, -1.29288175176551, 218, 40, 'PPL', 'P'),
(201844, 'Zena', 45.0088882446289, 0.785553292530945, -123.128326416016, -2.14899469842978, 218, 43, 'PPL', 'P'),
(58392, 'Zenar', 37.0950012207031, 0.647429907332585, -92.9702835083008, -1.62263755373243, 218, 29, 'PPL', 'P'),
(31588, 'Zenas', 39.1199989318848, 0.682772784738054, -85.4749984741211, -1.49182015151054, 218, 19, 'PPL', 'P'),
(34489, 'Zenda', 37.4422187805176, 0.653489996972088, -98.2816696166992, -1.71533872916867, 218, 20, 'PPL', 'P'),
(58393, 'Zenda', 37.0175018310547, 0.646077287814934, -92.6936111450195, -1.6178087100439, 218, 29, 'PPL', 'P'),
(107884, 'Zenda', 38.5052795410156, 0.672043907391534, -78.769172668457, -1.3747814121365, 218, 53, 'PPL', 'P'),
(177175, 'Zenda', 42.5119400024414, 0.741973324452889, -88.4816665649414, -1.54429640921001, 218, 57, 'PPL', 'P'),
(195828, 'Zenda', 42.3777809143066, 0.739631806643464, -112.057777404785, -1.95577716818041, 218, 17, 'PPL', 'P'),
(194078, 'Zenia', 40.2055587768555, 0.701719378260232, -123.490829467773, -2.15532157023148, 218, 6, 'PPL', 'P'),
(179595, 'Zeniff', 34.577220916748, 0.603486351186706, -110.377502441406, -1.92645083773062, 218, 5, 'PPL', 'P'),
(26316, 'Zenith', 32.6116714477539, 0.569181041341932, -83.977783203125, -1.46568881542052, 218, 13, 'PPL', 'P'),
(29054, 'Zenith', 38.5486106872559, 0.672800178562089, -88.6224975585938, -1.5467543737381, 218, 18, 'PPL', 'P'),
(34490, 'Zenith', 37.957218170166, 0.662478431967214, -98.4916687011719, -1.7190039046189, 218, 20, 'PPL', 'P'),
(92065, 'Zenith', 36.4275016784668, 0.635779842565006, -84.7369384765625, -1.47893857447588, 218, 50, 'PPL', 'P'),
(112178, 'Zenith', 37.5038909912109, 0.654566380105671, -80.5316696166992, -1.40554278693968, 218, 58, 'PPL', 'P'),
(169229, 'Zenith', 41.0305595397949, 0.716118357904991, -76.1891708374023, -1.32975188547712, 218, 45, 'PPL', 'P'),
(199132, 'Zenith', 46.8794403076172, 0.818200584860063, -103.09610748291, -1.79936652156675, 218, 34, 'PPL', 'P'),
(209246, 'Zenith', 47.3866691589355, 0.827053398376677, -122.321937561035, -2.13492055785899, 218, 56, 'PPL', 'P'),
(133841, 'Zenith Heights', 45.3061103820801, 0.790740797439283, -85.0355606079102, -1.48415051388722, 218, 27, 'PPL', 'P'),
(169230, 'Zenners', 40.753059387207, 0.711275066567545, -75.9574966430664, -1.32570840799405, 218, 45, 'PPL', 'P'),
(74921, 'Zeno', 39.7983283996582, 0.694611867364001, -81.7336120605469, -1.42652064000429, 218, 41, 'PPL', 'P'),
(169231, 'Zeno', 40.7780609130859, 0.711711425512155, -80.0183334350586, -1.39658338040044, 218, 45, 'PPL', 'P'),
(29055, 'Zenobia', 39.5286102294922, 0.68990439724215, -89.5336074829102, -1.56265624176501, 218, 18, 'PPL', 'P'),
(107888, 'Zenobia', 36.7513885498047, 0.641432734873836, -82.2074966430664, -1.43479148624369, 218, 53, 'PPL', 'P'),
(200291, 'Zenobia', 40.1563911437988, 0.700861241177981, -119.739166259766, -2.08984269482581, 218, 39, 'PPL', 'P'),
(44250, 'Zenoria', 31.7461109161377, 0.554074160189916, -92.336669921875, -1.61157891046393, 218, 22, 'PPL', 'P'),
(118558, 'Zenorsville', 42.1072196960449, 0.73490962255659, -93.7177810668945, -1.63568384728051, 218, 16, 'PPL', 'P'),
(13020, 'Zent', 34.9836082458496, 0.610579148117914, -91.1630630493164, -1.59109560641375, 218, 4, 'PPL', 'P'),
(79476, 'Zentmyer', 39.8416709899902, 0.695368338271638, -77.6408309936523, -1.35508813482369, 218, 45, 'PPL', 'P'),
(186301, 'Zentner', 35.7030601501465, 0.623135952657637, -119.168327331543, -2.07987967602977, 218, 6, 'PPL', 'P'),
(202807, 'Zeona', 45.1933288574219, 0.788772388498579, -102.91194152832, -1.79615221928907, 218, 49, 'PPL', 'P'),
(70442, 'Zephyr', 36.3675003051758, 0.63473262104536, -80.8144378662109, -1.41047802391376, 218, 33, 'PPL', 'P'),
(99260, 'Zephyr', 31.6758308410645, 0.552847541481339, -98.7944412231445, -1.72428828201189, 218, 51, 'PPL', 'P'),
(190949, 'Zephyr Cove', 39.0022201538086, 0.680717157271649, -119.955001831055, -2.09360973618773, 218, 39, 'PPL', 'P'),
(18703, 'Zephyrhills', 28.2333297729492, 0.492764563339307, -82.1813888549805, -1.43433581938118, 218, 12, 'PPL', 'P'),
(107885, 'Zepp', 39.0066719055176, 0.680794854996452, -78.4980621337891, -1.3700496406697, 218, 53, 'PPL', 'P'),
(169232, 'Zerbe', 40.6569404602051, 0.709597474817877, -76.3466720581055, -1.3325008003543, 218, 45, 'PPL', 'P'),
(169233, 'Zerby', 40.8461112976074, 0.712899128779303, -77.5213928222656, -1.35300354548043, 218, 45, 'PPL', 'P'),
(138981, 'Zerkel', 47.3108291625977, 0.825729740735881, -95.3813934326172, -1.66471936053927, 218, 28, 'PPL', 'P'),
(62414, 'Zero', 32.2999992370605, 0.563741335078363, -88.6505584716797, -1.54724412906256, 218, 30, 'PPL', 'P'),
(118559, 'Zero', 40.9833297729492, 0.715294042968584, -93.1269378662109, -1.62537168806556, 218, 16, 'PPL', 'P'),
(197907, 'Zero', 46.6691703796387, 0.814530682298907, -105.488059997559, -1.84111396849872, 218, 31, 'PPL', 'P'),
(58395, 'Zeta (historical)', 36.9555587768555, 0.644996177570416, -89.8680572509766, -1.56849349140031, 218, 29, 'PPL', 'P'),
(26317, 'Zetella', 33.2408294677734, 0.580161920306601, -84.3822174072266, -1.47274752388978, 218, 13, 'PPL', 'P'),
(26318, 'Zetto', 31.5933303833008, 0.551407636858961, -84.9369430541992, -1.4824293128747, 218, 13, 'PPL', 'P'),
(62415, 'Zetus', 31.5636100769043, 0.550888919657641, -90.5294418334961, -1.5800368299872, 218, 30, 'PPL', 'P'),
(107886, 'Zeus', 38.4027786254883, 0.670254928929273, -78.2219390869141, -1.3652303843611, 218, 53, 'PPL', 'P'),
(112179, 'Zevely', 39.4874992370605, 0.689186875065455, -79.6752777099609, -1.39059592847967, 218, 58, 'PPL', 'P'),
(58396, 'Zewapeta', 37.1694412231445, 0.64872913047038, -89.4591674804688, -1.56135701862722, 218, 29, 'PPL', 'P'),
(189846, 'Zia Pueblo', 35.5069389343262, 0.619712991708558, -106.719718933105, -1.86261047218562, 218, 38, 'PPL', 'P'),
(26319, 'Zidon (historical)', 34.3058280944824, 0.598749652871891, -83.2361068725586, -1.45274412146803, 218, 13, 'PPL', 'P'),
(53108, 'Ziegler Estates', 39.5255584716797, 0.689851134020348, -77.4291687011719, -1.35139393091759, 218, 25, 'PPL', 'P'),
(169234, 'Zieglersville', 40.2769393920898, 0.702965205018171, -75.4802780151367, -1.31737937168483, 218, 45, 'PPL', 'P'),
(138982, 'Ziemer''s Mobile Home Park', 43.5622215270996, 0.76030419513104, -93.8111114501953, -1.63731276976126, 218, 28, 'PPL', 'P'),
(122097, 'Zier Cors', 42.1538887023926, 0.735724150375991, -89.8236083984375, -1.56771771257477, 218, 18, 'PPL', 'P'),
(139552, 'Zig', 40.1269416809082, 0.700347251087596, -92.76611328125, -1.61907411103585, 218, 29, 'PPL', 'P'),
(112180, 'Zigler', 38.6141700744629, 0.673944405724441, -79.4002838134766, -1.38579637956313, 218, 58, 'PPL', 'P'),
(201845, 'Zigzag', 45.3441696166992, 0.791405056394177, -121.941940307617, -2.12828835463831, 218, 43, 'PPL', 'P'),
(53109, 'Zihlman', 39.6680603027344, 0.692338260162373, -78.915283203125, -1.37733152203831, 218, 25, 'PPL', 'P'),
(192460, 'Ziler', 32.273609161377, 0.563280741367834, -101.404441833496, -1.76984138614158, 218, 51, 'PPL', 'P'),
(209248, 'Zillah', 46.4022216796875, 0.80987154855084, -120.260833740234, -2.09894750996058, 218, 56, 'PPL', 'P'),
(39012, 'Zilpo', 38.0744400024414, 0.66452433889564, -83.4933319091797, -1.45723354527563, 218, 21, 'PPL', 'P'),
(133844, 'Zilwaukee', 43.476390838623, 0.758806167017871, -83.9205627441406, -1.46469013001174, 218, 27, 'PPL', 'P'),
(138983, 'Zim', 47.3069381713867, 0.825661830128084, -92.6030578613281, -1.61622825709499, 218, 28, 'PPL', 'P'),
(7001, 'Zimco', 31.7027797698975, 0.553317889019361, -87.878059387207, -1.53376147656987, 218, 2, 'PPL', 'P'),
(74922, 'Zimmer', 39.9066696166992, 0.696502778316985, -82.8983306884766, -1.44684881492097, 218, 41, 'PPL', 'P'),
(34491, 'Zimmerdale', 38.1027793884277, 0.665018954489095, -97.3897171020508, -1.69977122101662, 218, 20, 'PPL', 'P'),
(7002, 'Zimmerman', 32.6155586242676, 0.569248885370701, -87.3824996948242, -1.52511232829762, 218, 2, 'PPL', 'P'),
(44256, 'Zimmerman', 31.4155597686768, 0.548304954320478, -92.7027816772461, -1.61796876602542, 218, 22, 'PPL', 'P'),
(74923, 'Zimmerman', 39.7277793884277, 0.693380554834003, -84.057502746582, -1.46708018393203, 218, 41, 'PPL', 'P'),
(169235, 'Zimmerman', 40.0483283996582, 0.698975190493987, -79.1091690063477, -1.38071546767742, 218, 45, 'PPL', 'P'),
(70448, 'Zimmerman (historical)', 36.0830612182617, 0.629768222457343, -80.9938888549805, -1.41361003451375, 218, 33, 'PPL', 'P'),
(138985, 'Zimmerman Terrace', 45.4486083984375, 0.793227857002281, -93.583610534668, -1.63334212973401, 218, 28, 'PPL', 'P'),
(13023, 'Zinc', 36.2852783203125, 0.633297576691971, -92.9141693115234, -1.62165817624156, 218, 4, 'PPL', 'P'),
(77753, 'Zincville', 36.9913902282715, 0.645621554373394, -94.8086090087891, -1.65472238643933, 218, 42, 'PPL', 'P'),
(209249, 'Zindel (historical)', 46.1158294677734, 0.804873061500871, -116.997779846191, -2.0419964758395, 218, 56, 'PPL', 'P'),
(186302, 'Zinfandel', 38.482780456543, 0.671651224288801, -122.441108703613, -2.13700048667034, 218, 6, 'PPL', 'P');
INSERT INTO `dsb_loc_cities` (`city_id`, `city`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`, `fk_country_id`, `fk_state_id`, `feature_code`, `feature_class`) VALUES
(26320, 'Zingara', 33.7477798461914, 0.589009873554226, -83.9741668701172, -1.46562569850269, 218, 13, 'PPL', 'P'),
(112181, 'Zinnia', 39.2272186279297, 0.684644121457025, -80.603889465332, -1.40680326108362, 218, 58, 'PPL', 'P'),
(169244, 'Zinns Mill', 40.2924995422363, 0.703236780870332, -76.4288864135742, -1.33393571154963, 218, 45, 'PPL', 'P'),
(187567, 'Zinzer', 37.5602798461914, 0.655550551286509, -106.093887329102, -1.85168765013272, 218, 7, 'PPL', 'P'),
(7004, 'Zion', 33.4211082458496, 0.583308378555502, -87.8775024414063, -1.53375175603189, 218, 2, 'PPL', 'P'),
(13024, 'Zion', 36.0802803039551, 0.629719686346477, -91.7697219848633, -1.60168380227569, 218, 4, 'PPL', 'P'),
(26322, 'Zion', 31.8636093139648, 0.556124894097818, -82.1800003051758, -1.43431158461526, 218, 13, 'PPL', 'P'),
(39015, 'Zion', 36.7533302307129, 0.641466623598707, -87.1694412231445, -1.52139375646755, 218, 21, 'PPL', 'P'),
(44251, 'Zion', 31.7827796936035, 0.554714151089376, -92.4894409179688, -1.61424526734732, 218, 22, 'PPL', 'P'),
(53110, 'Zion', 39.6755599975586, 0.692469154529951, -75.9652786254883, -1.32584422920964, 218, 25, 'PPL', 'P'),
(58397, 'Zion', 37.4216690063477, 0.653131335752281, -90.3099975585938, -1.5762068048655, 218, 29, 'PPL', 'P'),
(62417, 'Zion', 34.2058296203613, 0.597004350251507, -88.8861083984375, -1.55135525083732, 218, 30, 'PPL', 'P'),
(70443, 'Zion', 35.3461112976074, 0.616906019919615, -81.5602798461914, -1.42349542216401, 218, 33, 'PPL', 'P'),
(77754, 'Zion', 35.7825012207031, 0.62452246090016, -94.6347198486328, -1.65168744806107, 218, 42, 'PPL', 'P'),
(84568, 'Zion', 34.2597198486328, 0.597944912169496, -79.3180618286133, -1.38436133520974, 218, 48, 'PPL', 'P'),
(92066, 'Zion', 35.598331451416, 0.621308092043461, -87.1436080932617, -1.52094288329499, 218, 50, 'PPL', 'P'),
(107887, 'Zion', 37.9980583190918, 0.663191227032974, -78.2341690063477, -1.36544383672247, 218, 53, 'PPL', 'P'),
(112182, 'Zion', 38.7733306884766, 0.676722282478476, -80.2647171020508, -1.40088358661259, 218, 58, 'PPL', 'P'),
(122098, 'Zion', 42.4461097717285, 0.740824370179601, -87.8327789306641, -1.53297118351639, 218, 18, 'PPL', 'P'),
(146696, 'Zion', 40.440559387207, 0.705820912655063, -74.7388916015625, -1.3044397377384, 218, 37, 'PPL', 'P'),
(169237, 'Zion', 40.9141693115234, 0.714086965204506, -77.6849975585938, -1.35585898680122, 218, 45, 'PPL', 'P'),
(177176, 'Zion', 43.996940612793, 0.767891474497649, -88.6619415283203, -1.54744280087988, 218, 57, 'PPL', 'P'),
(177327, 'Zion', 41.2005615234375, 0.719085452254475, -94.2986068725586, -1.6458211699699, 218, 16, 'PPL', 'P'),
(70444, 'Zion (historical)', 36.0436096191406, 0.629079662157503, -80.8988876342773, -1.41195195041907, 218, 33, 'PPL', 'P'),
(77755, 'Zion (historical)', 35.9561080932617, 0.627552472430397, -97.6522216796875, -1.70435279019793, 218, 42, 'PPL', 'P'),
(53111, 'Zion Acres', 39.6752815246582, 0.692464294260961, -75.9688873291016, -1.32590721296942, 218, 25, 'PPL', 'P'),
(7005, 'Zion City', 33.5819396972656, 0.586115416923473, -86.7300033569336, -1.51372411884423, 218, 2, 'PPL', 'P'),
(44252, 'Zion City', 30.5177803039551, 0.532635746704292, -91.1363906860352, -1.59063008585521, 218, 22, 'PPL', 'P'),
(107889, 'Zion Crossroads', 37.9708290100098, 0.662715985936449, -78.2200012207031, -1.36519656221525, 218, 53, 'PPL', 'P'),
(76, 'Zion Grove', 31.874719619751, 0.556318805514689, -94.7825012207031, -1.65426671957681, 218, 51, 'PPL', 'P'),
(70445, 'Zion Grove', 35.3363914489746, 0.616736376558177, -79.6025009155273, -1.38932573379775, 218, 33, 'PPL', 'P'),
(92067, 'Zion Grove', 35.7625007629395, 0.624173387060278, -83.4422225952148, -1.45634151946851, 218, 50, 'PPL', 'P'),
(169238, 'Zion Grove', 40.9025001525879, 0.713883299960142, -76.2088928222656, -1.33009609904801, 218, 45, 'PPL', 'P'),
(7006, 'Zion Heights', 33.5574989318848, 0.585688845095869, -86.8341674804688, -1.51554212576237, 218, 2, 'PPL', 'P'),
(169239, 'Zion Heights', 41.8463897705078, 0.730357281568236, -76.2483291625977, -1.33078439303174, 218, 45, 'PPL', 'P'),
(7007, 'Zion Hill', 32.5272216796875, 0.567707114836627, -88.0736083984375, -1.53717445066486, 218, 2, 'PPL', 'P'),
(13026, 'Zion Hill', 35.660831451416, 0.622398922825958, -92.8050003051758, -1.61975281763966, 218, 4, 'PPL', 'P'),
(18704, 'Zion Hill', 30.4805603027344, 0.531986135135394, -84.3230590820313, -1.47171501633515, 218, 12, 'PPL', 'P'),
(39016, 'Zion Hill', 38.1199989318848, 0.665319492218111, -84.6377792358398, -1.4772079192415, 218, 21, 'PPL', 'P'),
(62420, 'Zion Hill', 31.8377799987793, 0.555674087504295, -89.5666732788086, -1.56323334877324, 218, 30, 'PPL', 'P'),
(84569, 'Zion Hill', 34.9833297729492, 0.610574287848924, -81.8655624389648, -1.42882360855694, 218, 48, 'PPL', 'P'),
(92069, 'Zion Hill', 35.3980598449707, 0.617812693112732, -84.521110534668, -1.47517166627202, 218, 50, 'PPL', 'P'),
(99261, 'Zion Hill', 30.8352794647217, 0.538177152431988, -93.9713897705078, -1.64011015417028, 218, 51, 'PPL', 'P'),
(169240, 'Zion Hill', 41.1394386291504, 0.718018656500817, -79.5055618286133, -1.38763382755723, 218, 45, 'PPL', 'P'),
(44253, 'Zion Hill (historical)', 32.0091705322266, 0.558665416619699, -92.6399993896484, -1.6168730083949, 218, 22, 'PPL', 'P'),
(192874, 'Zion Lodge', 37.2508316040039, 0.650149660595829, -112.955558776855, -1.97144640908611, 218, 52, 'PPL', 'P'),
(39017, 'Zion Station', 38.7527809143066, 0.676363621258669, -84.7094421386719, -1.47845867284745, 218, 21, 'PPL', 'P'),
(206634, 'Zion Summit Condominium', 40.7738914489746, 0.711638654635368, -111.891387939453, -1.95287312416973, 218, 52, 'PPL', 'P'),
(169241, 'Zionhill', 40.4841690063477, 0.706582044094608, -75.394172668457, -1.31587654988169, 218, 45, 'PPL', 'P'),
(206635, 'Zions Park', 40.7083282470703, 0.710494360893989, -111.841667175293, -1.95200533312853, 218, 52, 'PPL', 'P'),
(169242, 'Zions View', 40.0527801513672, 0.69905288821879, -76.7686080932617, -1.33986497340058, 218, 45, 'PPL', 'P'),
(31589, 'Zionsville', 39.9508285522461, 0.697273497136454, -86.2619400024414, -1.50555487220041, 218, 19, 'PPL', 'P'),
(169243, 'Zionsville', 40.4797210693359, 0.706504412948832, -75.5055618286133, -1.31782065747745, 218, 45, 'PPL', 'P'),
(74924, 'Ziontown', 39.8536109924316, 0.695576730626937, -82.3622207641602, -1.43749193158903, 218, 41, 'PPL', 'P'),
(107891, 'Ziontown', 37.5877799987793, 0.656030519493969, -77.5611114501953, -1.35369676631218, 218, 53, 'PPL', 'P'),
(70446, 'Zionville', 36.3347206115723, 0.634160507464184, -81.7433319091797, -1.42669028336573, 218, 33, 'PPL', 'P'),
(99262, 'Zionville', 30.2016696929932, 0.527118575742516, -96.4911117553711, -1.68408759904103, 218, 51, 'PPL', 'P'),
(7008, 'Zip City', 34.954719543457, 0.610074945144534, -87.6699981689453, -1.5301301232655, 218, 2, 'PPL', 'P'),
(99263, 'Zipp', 29.559440612793, 0.515909563740968, -98.01611328125, -1.71070389676556, 218, 51, 'PPL', 'P'),
(99264, 'Zipperlandville', 31.0686092376709, 0.542249525212883, -97.0550003051758, -1.69392931084942, 218, 51, 'PPL', 'P'),
(53112, 'Zipprian Estates', 39.5466690063477, 0.690219582357161, -76.9138870239258, -1.34240056907445, 218, 25, 'PPL', 'P'),
(70447, 'Zirconia', 35.2416687011719, 0.615083152732483, -82.416389465332, -1.43843735377601, 218, 33, 'PPL', 'P'),
(107892, 'Zirkle', 38.4938888549805, 0.671845102416159, -78.8550033569336, -1.37627944024967, 218, 53, 'PPL', 'P'),
(26321, 'Zirkle (historical)', 31.3541698455811, 0.547233498034912, -82.0458297729492, -1.43196986706876, 218, 13, 'PPL', 'P'),
(192461, 'Zita', 35.1313896179199, 0.613158419633655, -101.853889465332, -1.77768572713241, 218, 51, 'PPL', 'P'),
(112184, 'Zitko Terrace', 39.9555587768555, 0.697356055130246, -80.7513885498047, -1.40937760575134, 218, 58, 'PPL', 'P'),
(177177, 'Zittau', 44.2166709899902, 0.77172649304639, -88.7861099243164, -1.54960994821693, 218, 57, 'PPL', 'P'),
(53113, 'Zittlestown', 39.485279083252, 0.689148126071595, -77.6241683959961, -1.35479731763266, 218, 25, 'PPL', 'P'),
(7009, 'Zoar', 31.5313892364502, 0.550326559903957, -86.1069412231445, -1.50284963316511, 218, 2, 'PPL', 'P'),
(14939, 'Zoar', 38.6469383239746, 0.674516319568536, -75.2975006103516, -1.31418930417307, 218, 10, 'PPL', 'P'),
(31590, 'Zoar', 38.2691688537598, 0.667922998499772, -87.0730590820313, -1.519711570765, 218, 19, 'PPL', 'P'),
(44254, 'Zoar', 32.1791687011719, 0.561632444390156, -92.3794403076172, -1.61232539451748, 218, 22, 'PPL', 'P'),
(126724, 'Zoar', 42.6525001525879, 0.744426561870043, -72.9319381713867, -1.27290245095163, 218, 23, 'PPL', 'P'),
(153998, 'Zoar', 43.8586082458496, 0.76547711923241, -75.9227828979492, -1.32510253884606, 218, 40, 'PPL', 'P'),
(158513, 'Zoar', 40.6141700744629, 0.708850990764328, -81.4225006103516, -1.42109072085773, 218, 41, 'PPL', 'P'),
(177178, 'Zoar', 45.0149993896484, 0.785659952132603, -88.8988876342773, -1.55157829057861, 218, 57, 'PPL', 'P'),
(107893, 'Zoar (historical)', 37.3624992370605, 0.652098628460576, -77.8236083984375, -1.35827820233545, 218, 53, 'PPL', 'P'),
(84570, 'Zoar Heights', 34.9652786254883, 0.610259235891968, -82.1980590820313, -1.43462676973027, 218, 48, 'PPL', 'P'),
(158514, 'Zoarville', 40.5844383239746, 0.708332073825926, -81.3894424438477, -1.42051374700756, 218, 41, 'PPL', 'P'),
(58398, 'Zodiac', 37.6469383239746, 0.657063027048593, -94.0919418334961, -1.6422141845895, 218, 29, 'PPL', 'P'),
(39020, 'Zoe', 37.6802787780762, 0.657644927746775, -83.6841735839844, -1.46056436085099, 218, 21, 'PPL', 'P'),
(77756, 'Zoe', 34.7677803039551, 0.606812239914051, -94.628059387207, -1.65157120107949, 218, 42, 'PPL', 'P'),
(18705, 'Zolfo Springs', 27.4930591583252, 0.479844403758356, -81.7961120605469, -1.42761147078679, 218, 12, 'PPL', 'P'),
(107894, 'Zollman (historical)', 37.7299995422363, 0.658512718787977, -79.4824981689453, -1.38723129075846, 218, 53, 'PPL', 'P'),
(44255, 'Zona', 30.7480602264404, 0.536654889552899, -90.0811080932617, -1.57221193007233, 218, 22, 'PPL', 'P'),
(112185, 'Zona', 38.7219390869141, 0.675825329823337, -81.4558334350586, -1.42167248839786, 218, 58, 'PPL', 'P'),
(158515, 'Zone', 41.6227798461914, 0.726454552148779, -84.3280563354492, -1.47180223486085, 218, 41, 'PPL', 'P'),
(39019, 'Zoneton', 38.0633316040039, 0.664330460768283, -85.6705627441406, -1.49523339192164, 218, 21, 'PPL', 'P'),
(34492, 'Zook', 38.0577812194824, 0.664233588283631, -99.086669921875, -1.72938863497355, 218, 20, 'PPL', 'P'),
(169245, 'Zooks Corner', 40.0794410705566, 0.699518209040254, -76.2522201538086, -1.33085230363954, 218, 45, 'PPL', 'P'),
(58399, 'Zora', 38.2863883972168, 0.668223536228788, -93.0963897705078, -1.62483852321533, 218, 29, 'PPL', 'P'),
(79477, 'Zora', 39.7308311462402, 0.693433818055805, -77.3688888549805, -1.35034184912895, 218, 45, 'PPL', 'P'),
(99265, 'Zorn', 29.7527809143066, 0.51928398857918, -97.9477767944336, -1.70951120007136, 218, 51, 'PPL', 'P'),
(197908, 'Zortman', 47.917781829834, 0.836323063182916, -108.52555847168, -1.89412831789644, 218, 31, 'PPL', 'P'),
(107895, 'Zouave Hills', 38.8069381713867, 0.677308843708566, -77.5480575561523, -1.35346893288093, 218, 53, 'PPL', 'P'),
(92070, 'Zu Zu', 35.3902816772461, 0.617676938476166, -89.3566665649414, -1.55956804016496, 218, 50, 'PPL', 'P'),
(18706, 'Zuber', 29.266939163208, 0.510804450378854, -82.1811065673828, -1.43433089253317, 218, 12, 'PPL', 'P'),
(74926, 'Zuber (historical)', 39.8250007629395, 0.695077387922547, -83.0325012207031, -1.44919053246748, 218, 41, 'PPL', 'P'),
(7010, 'Zubers', 33.2319412231445, 0.580006791173104, -86.3008270263672, -1.50623357880421, 218, 2, 'PPL', 'P'),
(158516, 'Zuck', 40.378059387207, 0.704730081872567, -82.2363891601563, -1.4352957557961, 218, 41, 'PPL', 'P'),
(169246, 'Zucksville', 40.7186088562012, 0.710673791372433, -75.2447204589844, -1.31326811675202, 218, 45, 'PPL', 'P'),
(99266, 'Zuehl', 29.485279083252, 0.514615200872162, -98.1658325195313, -1.71331699042714, 218, 51, 'PPL', 'P'),
(44257, 'Zugg (historical)', 30.6480598449707, 0.534909553643002, -91.6091690063477, -1.59888162417671, 218, 22, 'PPL', 'P'),
(39021, 'Zula', 36.767219543457, 0.641709037836932, -84.9794387817383, -1.48317100323829, 218, 21, 'PPL', 'P'),
(7011, 'Zula (historical)', 33.7350006103516, 0.588786833812931, -85.9902801513672, -1.50081351335369, 218, 2, 'PPL', 'P'),
(26323, 'Zula (historical)', 34.4566688537598, 0.601382320767488, -85.1858291625977, -1.48677319492873, 218, 13, 'PPL', 'P'),
(107896, 'Zulla', 38.922779083252, 0.679330649029127, -77.7852783203125, -1.35760921626962, 218, 53, 'PPL', 'P'),
(79478, 'Zullinger', 39.7700004577637, 0.694117451507628, -77.629997253418, -1.3548990503863, 218, 45, 'PPL', 'P'),
(7012, 'Zulu', 32.9347190856934, 0.574819286264766, -87.146110534668, -1.52098655913687, 218, 2, 'PPL', 'P'),
(124071, 'Zulu', 41.0369415283203, 0.716229744617583, -84.892219543457, -1.4816487403592, 218, 19, 'PPL', 'P'),
(62421, 'Zumbro', 33.7794418334961, 0.589562479480417, -90.6761093139648, -1.58259666042698, 218, 30, 'PPL', 'P'),
(138988, 'Zumbro Falls', 44.2833290100098, 0.772889894968591, -92.4219436645508, -1.61306721803912, 218, 28, 'PPL', 'P'),
(138990, 'Zumbro Ridge Estates', 44.0805587768555, 0.769350886775012, -92.4522171020508, -1.6135955891994, 218, 28, 'PPL', 'P'),
(138992, 'Zumbrota', 44.2941703796387, 0.773079112564041, -92.6688919067383, -1.61737727794731, 218, 28, 'PPL', 'P'),
(99267, 'Zummo', 30.0405597686768, 0.524306677105556, -94.0686111450195, -1.64180698725882, 218, 51, 'PPL', 'P'),
(201846, 'Zumwalt', 45.6308288574219, 0.796408203976054, -116.969169616699, -2.04149713313512, 218, 43, 'PPL', 'P'),
(209250, 'Zumwalt', 46.461109161377, 0.810899328994529, -117.683891296387, -2.05397137968105, 218, 56, 'PPL', 'P'),
(107897, 'Zuni', 36.8658294677734, 0.643430105691395, -76.8311080932617, -1.34095580418308, 218, 53, 'PPL', 'P'),
(187568, 'Zuni', 39.8033294677734, 0.694699152468729, -105.021110534668, -1.83296416293086, 218, 7, 'PPL', 'P'),
(189849, 'Zuni', 35.5341682434082, 0.620188232805083, -108.635833740234, -1.89605298441624, 218, 38, 'PPL', 'P'),
(7013, 'Zuni (historical)', 33.8880615234375, 0.59145825070239, -85.727783203125, -1.49623207733042, 218, 2, 'PPL', 'P'),
(189850, 'Zuni Pueblo', 35.0724983215332, 0.612130572610939, -108.849998474121, -1.89979086416422, 218, 38, 'PPL', 'P'),
(99268, 'Zunkerville', 28.708890914917, 0.501064671061189, -97.9913864135742, -1.71027233151091, 218, 51, 'PPL', 'P'),
(34493, 'Zurich', 39.2344398498535, 0.684770155555613, -99.4377822875977, -1.73551670179988, 218, 20, 'PPL', 'P'),
(153999, 'Zurich', 43.1505584716797, 0.753119319405143, -77.0436096191406, -1.34466465547518, 218, 40, 'PPL', 'P'),
(186303, 'Zurich', 37.1827812194824, 0.648961957328681, -118.259170532227, -2.06401189646481, 218, 6, 'PPL', 'P'),
(197909, 'Zurich', 48.5844383239746, 0.847958413985472, -109.029716491699, -1.90292753529611, 218, 31, 'PPL', 'P'),
(14930, 'Zurkow Development', 39.1650009155273, 0.683558217522546, -75.5599975585938, -1.31877074019634, 218, 10, 'PPL', 'P'),
(26324, 'Zuta', 31.3205604553223, 0.546646903515308, -81.5841674804688, -1.42391234003267, 218, 13, 'PPL', 'P'),
(133845, 'Zutphen', 42.8258285522461, 0.747451713131291, -85.8819427490234, -1.49892266897973, 218, 27, 'PPL', 'P'),
(186304, 'Zuver', 38.9741706848145, 0.680227601684265, -120.598892211914, -2.10484774335565, 218, 6, 'PPL', 'P'),
(118560, 'Zwingle', 42.297779083252, 0.738235511283935, -90.6875, -1.58279546540236, 218, 16, 'PPL', 'P'),
(44258, 'Zwolle', 31.6313896179199, 0.552071895813854, -93.6438903808594, -1.63439421152264, 218, 22, 'PPL', 'P'),
(34494, 'Zyba', 37.4347190856934, 0.65335910260451, -97.3888931274414, -1.69975683994673, 218, 20, 'PPL', 'P'),
(44259, 'Zylks', 33.0016708374023, 0.575987814772065, -94.0113906860352, -1.64080830185004, 218, 22, 'PPL', 'P'),
(126725, 'Zylonite', 42.6519393920898, 0.744416774753036, -73.1083297729492, -1.27598106517176, 218, 23, 'PPL', 'P'),
(186305, 'Zzyzx', 35.1427803039551, 0.61335722460903, -116.103889465332, -2.0263951455416, 218, 6, 'PPL', 'P');

CREATE TABLE `dsb_loc_countries` (
  `country_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `iso3166` char(2) NOT NULL,
  `country` varchar(200) NOT NULL,
  `prefered_input` enum('z','s') NOT NULL DEFAULT 's',
  `num_states` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`country_id`),
  KEY `iso3166` (`iso3166`),
  KEY `country` (`country`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_loc_countries` (`country_id`, `iso3166`, `country`, `prefered_input`, `num_states`) VALUES
(1, 'AF', 'Afghanistan', 's', 0),
(2, 'AL', 'Albania', 's', 0),
(3, 'AG', 'Algeria', 's', 0),
(4, 'AN', 'Andorra', 's', 0),
(5, 'AO', 'Angola', 's', 0),
(6, 'AV', 'Anguilla', 's', 0),
(7, 'AC', 'Antigua and Barbuda', 's', 0),
(8, 'AR', 'Argentina', 's', 0),
(9, 'AM', 'Armenia', 's', 0),
(10, 'AA', 'Aruba', 's', 0),
(11, 'AS', 'Australia', 's', 0),
(12, 'AU', 'Austria', 's', 0),
(13, 'AJ', 'Azerbaijan', 's', 0),
(14, 'BA', 'Bahrain', 's', 0),
(15, 'BG', 'Bangladesh', 's', 0),
(16, 'BB', 'Barbados', 's', 0),
(17, 'BO', 'Belarus', 's', 0),
(18, 'BE', 'Belgium', 's', 0),
(19, 'BH', 'Belize', 's', 0),
(20, 'BN', 'Benin', 's', 0),
(21, 'BD', 'Bermuda', 's', 0),
(22, 'BT', 'Bhutan', 's', 0),
(23, 'BL', 'Bolivia', 's', 0),
(24, 'BK', 'Bosnia and Herzegovina', 's', 0),
(25, 'BC', 'Botswana', 's', 0),
(26, 'BR', 'Brazil', 's', 0),
(27, 'VI', 'British Virgin Islands', 's', 0),
(28, 'BX', 'Brunei', 's', 0),
(29, 'BU', 'Bulgaria', 's', 0),
(30, 'UV', 'Burkina Faso', 's', 0),
(31, 'BY', 'Burundi', 's', 0),
(32, 'CB', 'Cambodia', 's', 0),
(33, 'CM', 'Cameroon', 's', 0),
(34, 'CA', 'Canada', 's', 0),
(35, 'CV', 'Cape Verde', 's', 0),
(36, 'CJ', 'Cayman Islands', 's', 0),
(37, 'CT', 'Central African Republic', 's', 0),
(38, 'CD', 'Chad', 's', 0),
(39, 'CI', 'Chile', 's', 0),
(40, 'CH', 'China', 's', 0),
(41, 'KT', 'Christmas Island', 's', 0),
(42, 'CK', 'Cocos (Keeling) Islands', 's', 0),
(43, 'CO', 'Colombia', 's', 0),
(44, 'CN', 'Comoros', 's', 0),
(45, 'CF', 'Congo (Brazzaville)', 's', 0),
(46, 'CG', 'Congo (Kinshasa)', 's', 0),
(47, 'CW', 'Cook Islands', 's', 0),
(48, 'CS', 'Costa Rica', 's', 0),
(49, 'IV', 'Cote D''Ivoire', 's', 0),
(50, 'HR', 'Croatia', 's', 0),
(51, 'CU', 'Cuba', 's', 0),
(52, 'CY', 'Cyprus', 's', 0),
(53, 'EZ', 'Czech Republic', 's', 0),
(54, 'DA', 'Denmark', 's', 0),
(55, 'DJ', 'Djibouti', 's', 0),
(56, 'DO', 'Dominica', 's', 0),
(57, 'DR', 'Dominican Republic', 's', 0),
(58, 'TT', 'East Timor', 's', 0),
(59, 'EC', 'Ecuador', 's', 0),
(60, 'EG', 'Egypt', 's', 0),
(61, 'ES', 'El Salvador', 's', 0),
(62, 'EK', 'Equatorial Guinea', 's', 0),
(63, 'ER', 'Eritrea', 's', 0),
(64, 'EN', 'Estonia', 's', 0),
(65, 'ET', 'Ethiopia', 's', 0),
(66, 'FK', 'Falkland Islands (Islas Malvinas)', 's', 0),
(67, 'FO', 'Faroe Islands', 's', 0),
(68, 'FJ', 'Fiji', 's', 0),
(69, 'FI', 'Finland', 's', 0),
(70, 'FR', 'France', 's', 0),
(71, 'FG', 'French Guiana', 's', 0),
(72, 'FP', 'French Polynesia', 's', 0),
(73, 'GB', 'Gabon', 's', 0),
(74, 'GZ', 'Gaza Strip', 's', 0),
(75, 'GG', 'Georgia', 's', 0),
(76, 'GM', 'Germany', 's', 0),
(77, 'GH', 'Ghana', 's', 0),
(78, 'GI', 'Gibraltar', 's', 0),
(79, 'GR', 'Greece', 's', 0),
(80, 'GL', 'Greenland', 's', 0),
(81, 'GJ', 'Grenada', 's', 0),
(82, 'GP', 'Guadeloupe', 's', 0),
(83, 'GT', 'Guatemala', 's', 0),
(84, 'GK', 'Guernsey', 's', 0),
(85, 'GV', 'Guinea', 's', 0),
(86, 'PU', 'Guinea-Bissau', 's', 0),
(87, 'GY', 'Guyana', 's', 0),
(88, 'HA', 'Haiti', 's', 0),
(89, 'HO', 'Honduras', 's', 0),
(90, 'HK', 'Hong Kong', 's', 0),
(91, 'HU', 'Hungary', 's', 0),
(92, 'IC', 'Iceland', 's', 0),
(93, 'IN', 'India', 's', 0),
(94, 'ID', 'Indonesia', 's', 0),
(95, 'IR', 'Iran', 's', 0),
(96, 'IZ', 'Iraq', 's', 0),
(97, 'EI', 'Ireland', 's', 0),
(98, 'IM', 'Isle of Man', 's', 0),
(99, 'IS', 'Israel', 's', 0),
(100, 'IT', 'Italy', 's', 0),
(101, 'JM', 'Jamaica', 's', 0),
(102, 'JA', 'Japan', 's', 0),
(103, 'JE', 'Jersey', 's', 0),
(104, 'JO', 'Jordan', 's', 0),
(105, 'KZ', 'Kazakhstan', 's', 0),
(106, 'KE', 'Kenya', 's', 0),
(107, 'KR', 'Kiribati', 's', 0),
(108, 'KU', 'Kuwait', 's', 0),
(109, 'KG', 'Kyrgyzstan', 's', 0),
(110, 'LA', 'Laos', 's', 0),
(111, 'LG', 'Latvia', 's', 0),
(112, 'LE', 'Lebanon', 's', 0),
(113, 'LT', 'Lesotho', 's', 0),
(114, 'LI', 'Liberia', 's', 0),
(115, 'LY', 'Libya', 's', 0),
(116, 'LS', 'Liechtenstein', 's', 0),
(117, 'LH', 'Lithuania', 's', 0),
(118, 'LU', 'Luxembourg', 's', 0),
(119, 'MC', 'Macau', 's', 0),
(120, 'MK', 'Macedonia', 's', 0),
(121, 'MA', 'Madagascar', 's', 0),
(122, 'MI', 'Malawi', 's', 0),
(123, 'MY', 'Malaysia', 's', 0),
(124, 'MV', 'Maldives', 's', 0),
(125, 'ML', 'Mali', 's', 0),
(126, 'MT', 'Malta', 's', 0),
(127, 'MB', 'Martinique', 's', 0),
(128, 'MR', 'Mauritania', 's', 0),
(129, 'MP', 'Mauritius', 's', 0),
(130, 'MF', 'Mayotte', 's', 0),
(131, 'MX', 'Mexico', 's', 0),
(132, 'MD', 'Moldova', 's', 0),
(133, 'MN', 'Monaco', 's', 0),
(134, 'MG', 'Mongolia', 's', 0),
(135, 'MH', 'Montserrat', 's', 0),
(136, 'MO', 'Morocco', 's', 0),
(137, 'MZ', 'Mozambique', 's', 0),
(138, 'BM', 'Myanmar (Burma)', 's', 0),
(139, 'WA', 'Namibia', 's', 0),
(140, 'NR', 'Nauru', 's', 0),
(141, 'NP', 'Nepal', 's', 0),
(142, 'NL', 'Netherlands', 's', 0),
(143, 'NT', 'Netherlands Antilles', 's', 0),
(144, 'NC', 'New Caledonia', 's', 0),
(145, 'NZ', 'New Zealand', 's', 0),
(146, 'NU', 'Nicaragua', 's', 0),
(147, 'NG', 'Niger', 's', 0),
(148, 'NI', 'Nigeria', 's', 0),
(149, 'NE', 'Niue', 's', 0),
(150, 'NF', 'Norfolk Island', 's', 0),
(151, 'KN', 'North Korea', 's', 0),
(152, 'NO', 'Norway', 's', 0),
(153, 'MU', 'Oman', 's', 0),
(154, 'PK', 'Pakistan', 's', 0),
(155, 'PM', 'Panama', 's', 0),
(156, 'PP', 'Papua New Guinea', 's', 0),
(157, 'PA', 'Paraguay', 's', 0),
(158, 'PE', 'Peru', 's', 0),
(159, 'RP', 'Philippines', 's', 0),
(160, 'PC', 'Pitcairn Islands', 's', 0),
(161, 'PL', 'Poland', 's', 0),
(162, 'PO', 'Portugal', 's', 0),
(163, 'QA', 'Qatar', 's', 0),
(164, 'RE', 'Reunion', 's', 0),
(165, 'RO', 'Romania', 's', 0),
(166, 'RS', 'Russia', 's', 0),
(167, 'RW', 'Rwanda', 's', 0),
(168, 'SH', 'Saint Helena', 's', 0),
(169, 'SC', 'Saint Kitts and Nevis', 's', 0),
(170, 'ST', 'Saint Lucia', 's', 0),
(171, 'SB', 'Saint Pierre and Miquelon', 's', 0),
(172, 'VC', 'Saint Vincent and the Grenadines', 's', 0),
(173, 'WS', 'Samoa', 's', 0),
(174, 'SM', 'San Marino', 's', 0),
(175, 'TP', 'Sao Tome and Principe', 's', 0),
(176, 'SA', 'Saudi Arabia', 's', 0),
(177, 'SG', 'Senegal', 's', 0),
(178, 'YI', 'Serbia and Montenegro', 's', 0),
(179, 'SE', 'Seychelles', 's', 0),
(180, 'SL', 'Sierra Leone', 's', 0),
(181, 'SN', 'Singapore', 's', 0),
(182, 'LO', 'Slovakia', 's', 0),
(183, 'SI', 'Slovenia', 's', 0),
(184, 'BP', 'Solomon Islands', 's', 0),
(185, 'SO', 'Somalia', 's', 0),
(186, 'SF', 'South Africa', 's', 0),
(187, 'SX', 'South Georgia and the South Sandw', 's', 0),
(188, 'KS', 'South Korea', 's', 0),
(189, 'SP', 'Spain', 's', 0),
(190, 'PG', 'Spratly Islands', 's', 0),
(191, 'CE', 'Sri Lanka', 's', 0),
(192, 'SU', 'Sudan', 's', 0),
(193, 'NS', 'Suriname', 's', 0),
(194, 'SV', 'Svalbard', 's', 0),
(195, 'WZ', 'Swaziland', 's', 0),
(196, 'SW', 'Sweden', 's', 0),
(197, 'SZ', 'Switzerland', 's', 0),
(198, 'SY', 'Syria', 's', 0),
(199, 'TW', 'Taiwan', 's', 0),
(200, 'TI', 'Tajikistan', 's', 0),
(201, 'TZ', 'Tanzania', 's', 0),
(202, 'TH', 'Thailand', 's', 0),
(203, 'BF', 'The Bahamas', 's', 0),
(204, 'GA', 'The Gambia', 's', 0),
(205, 'TO', 'Togo', 's', 0),
(206, 'TL', 'Tokelau', 's', 0),
(207, 'TN', 'Tonga', 's', 0),
(208, 'TD', 'Trinidad and Tobago', 's', 0),
(209, 'TS', 'Tunisia', 's', 0),
(210, 'TU', 'Turkey', 's', 0),
(211, 'TX', 'Turkmenistan', 's', 0),
(212, 'TK', 'Turks and Caicos Islands', 's', 0),
(213, 'TV', 'Tuvalu', 's', 0),
(214, 'UG', 'Uganda', 's', 0),
(215, 'UP', 'Ukraine', 's', 0),
(216, 'AE', 'United Arab Emirates', 's', 0),
(217, 'UK', 'United Kingdom', 's', 0),
(218, 'US', 'United States', 's', 59),
(219, 'UY', 'Uruguay', 's', 0),
(220, 'UZ', 'Uzbekistan', 's', 0),
(221, 'NH', 'Vanuatu', 's', 0),
(222, 'VE', 'Venezuela', 's', 0),
(223, 'VM', 'Vietnam', 's', 0),
(224, 'WF', 'Wallis and Futuna', 's', 0),
(225, 'WE', 'West Bank', 's', 0),
(226, 'WI', 'Western Sahara', 's', 0),
(227, 'YM', 'Yemen', 's', 0),
(228, 'ZA', 'Zambia', 's', 0),
(229, 'ZI', 'Zimbabwe', 's', 0);

CREATE TABLE `dsb_loc_states` (
  `state_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fk_country_id` int(2) unsigned NOT NULL DEFAULT '0',
  `iso3166` char(2) NOT NULL,
  `state` varchar(200) NOT NULL,
  `num_cities` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`state_id`),
  KEY `cid_state` (`fk_country_id`,`state`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_loc_states` (`state_id`, `fk_country_id`, `iso3166`, `state`, `num_cities`) VALUES
(1, 218, 'AK', 'Alaska', 696),
(2, 218, 'AL', 'Alabama', 5304),
(3, 218, 'AS', 'American Samoa', 0),
(4, 218, 'AR', 'Arkansas', 4328),
(5, 218, 'AZ', 'Arizona', 1994),
(6, 218, 'CA', 'California', 6415),
(7, 218, 'CO', 'Colorado', 1613),
(8, 218, 'CT', 'Connecticut', 1060),
(9, 218, 'DC', 'District of Columbia', 177),
(10, 218, 'DE', 'Delaware', 1588),
(11, 218, 'FM', 'Federated States Of Micronesia', 0),
(12, 218, 'FL', 'Florida', 3441),
(13, 218, 'GA', 'Georgia', 6759),
(14, 218, 'GU', 'Guam', 0),
(15, 218, 'HI', 'Hawaii', 529),
(16, 218, 'IA', 'Iowa', 2504),
(17, 218, 'ID', 'Idaho', 1327),
(18, 218, 'IL', 'Illinois', 4094),
(19, 218, 'IN', 'Indiana', 3443),
(20, 218, 'KS', 'Kansas', 1674),
(21, 218, 'KY', 'Kentucky', 4479),
(22, 218, 'LA', 'Louisiana', 3614),
(23, 218, 'MA', 'Massachusetts', 2297),
(24, 218, 'MH', 'Marshall Islands', 0),
(25, 218, 'MD', 'Maryland', 8247),
(26, 218, 'ME', 'Maine', 2135),
(27, 218, 'MI', 'Michigan', 2848),
(28, 218, 'MN', 'Minnesota', 2363),
(29, 218, 'MO', 'Missouri', 4397),
(30, 218, 'MS', 'Mississippi', 3152),
(31, 218, 'MT', 'Montana', 2041),
(32, 218, 'MP', 'Northern Mariana Islands', 0),
(33, 218, 'NC', 'North Carolina', 5324),
(34, 218, 'ND', 'North Dakota', 889),
(35, 218, 'NE', 'Nebraska', 1252),
(36, 218, 'NH', 'New Hampshire', 997),
(37, 218, 'NJ', 'New Jersey', 2572),
(38, 218, 'NM', 'New Mexico', 1699),
(39, 218, 'NV', 'Nevada', 1096),
(40, 218, 'NY', 'New York', 6242),
(41, 218, 'OH', 'Ohio', 5934),
(42, 218, 'OK', 'Oklahoma', 1921),
(43, 218, 'OR', 'Oregon', 1545),
(44, 218, 'PW', 'Palau', 0),
(45, 218, 'PA', 'Pennsylvania', 9749),
(46, 218, 'PR', 'Puerto Rico', 0),
(47, 218, 'RI', 'Rhode Island', 397),
(48, 218, 'SC', 'South Carolina', 4302),
(49, 218, 'SD', 'South Dakota', 983),
(50, 218, 'TN', 'Tennessee', 6570),
(51, 218, 'TX', 'Texas', 8500),
(52, 218, 'UT', 'Utah', 1973),
(53, 218, 'VA', 'Virginia', 7938),
(54, 218, 'VI', 'Virgin Islands', 0),
(55, 218, 'VT', 'Vermont', 886),
(56, 218, 'WA', 'Washington', 2565),
(57, 218, 'WI', 'Wisconsin', 2436),
(58, 218, 'WV', 'West Virginia', 4143),
(59, 218, 'WY', 'Wyoming', 584);

CREATE TABLE `dsb_loc_zips` (
  `zip_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `zipcode` varchar(10) NOT NULL DEFAULT '0',
  `fk_country_id` int(10) unsigned NOT NULL DEFAULT '0',
  `fk_state_id` int(10) unsigned NOT NULL DEFAULT '0',
  `fk_city_id` int(10) unsigned NOT NULL DEFAULT '0',
  `latitude` double NOT NULL DEFAULT '0',
  `rad_latitude` double NOT NULL DEFAULT '0',
  `longitude` double NOT NULL DEFAULT '0',
  `rad_longitude` double NOT NULL DEFAULT '0',
  PRIMARY KEY (`zip_id`),
  KEY `zipcode` (`zipcode`),
  KEY `cityid_zipcode` (`fk_city_id`,`zipcode`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(1, '00501', 218, 40, 87929, 40.8147, 0.71235089821373, -73.0451, -1.27487749744851),
(2, '00544', 218, 40, 87929, 40.8128, 0.712317736957942, -73.048, -1.27492811199682),
(3, '00601', 218, 46, 0, 18.165, 0.31703905862477, -66.724, -1.1645534901007),
(4, '00602', 218, 46, 0, 18.3825, 0.320835149747858, -67.1871, -1.17263610986668),
(5, '00603', 218, 46, 0, 18.4351, 0.321753192934407, -67.1536, -1.17205142456726),
(6, '00604', 218, 46, 0, 18.5022, 0.322924308862495, -67.1363, -1.17174948260667),
(7, '00605', 218, 46, 0, 18.437, 0.321786354190195, -67.1543, -1.17206364187203),
(8, '00606', 218, 46, 0, 18.1866, 0.317416049743201, -66.9803, -1.16902676897356),
(9, '00610', 218, 46, 0, 18.2863, 0.319156143007439, -67.1435, -1.17187514631281),
(10, '00611', 218, 46, 191076, 18.2867, 0.319163124324447, -66.7998, -1.16587644967371),
(11, '00612', 218, 46, 0, 18.4687, 0.322339623563077, -66.7311, -1.16467740847759),
(12, '00613', 218, 46, 0, 18.4746, 0.322442597988944, -66.7216, -1.16451160219865),
(13, '00614', 218, 46, 0, 18.4567, 0.322130184052837, -66.7357, -1.16475769362318),
(14, '00616', 218, 46, 0, 18.4252, 0.321580405338459, -66.6768, -1.16372969469376),
(15, '00617', 218, 46, 0, 18.458, 0.322152873333113, -66.5388, -1.161321140326),
(16, '00622', 218, 46, 0, 18.0157, 0.314433282051542, -67.1708, -1.17235162119861),
(17, '00623', 218, 46, 0, 18.0843, 0.315630577918411, -67.1524, -1.17203048061624),
(18, '00624', 218, 46, 0, 18.0612, 0.3152274068612, -66.7209, -1.16449938489388),
(19, '00627', 218, 46, 0, 18.4867, 0.322653782828436, -66.846, -1.16668279178813),
(20, '00631', 218, 46, 0, 18.1828, 0.317349727231625, -66.8327, -1.16645066299761),
(21, '00636', 218, 46, 189383, 18.1647, 0.317033822637014, -67.0789, -1.17074766361602),
(22, '00637', 218, 46, 0, 18.084, 0.315625341930655, -66.9666, -1.16878765886603),
(23, '00638', 218, 46, 0, 18.3382, 0.320061968889224, -66.47, -1.16012035380063),
(24, '00641', 218, 46, 0, 18.2714, 0.318896088948892, -66.7056, -1.16423234951833),
(25, '00646', 218, 46, 101468, 18.4671, 0.322311698295045, -66.2669, -1.15657559008983),
(26, '00647', 218, 46, 188525, 17.9702, 0.313639157241885, -66.9368, -1.16826755074894),
(27, '00650', 218, 46, 16048, 18.3641, 0.320514009165491, -66.5621, -1.16172780204172),
(28, '00652', 218, 46, 0, 18.4647, 0.322269810392997, -66.5706, -1.16187615502814),
(29, '00653', 218, 46, 0, 17.9717, 0.313665337180665, -66.9073, -1.1677526786196),
(30, '00656', 218, 46, 0, 18.0237, 0.314572908391702, -66.7911, -1.16572460602878),
(31, '00659', 218, 46, 0, 18.4877, 0.322671236120956, -66.8255, -1.16632499929147),
(32, '00660', 218, 46, 0, 18.1424, 0.316644614213819, -67.1265, -1.17157844033997),
(33, '00662', 218, 46, 0, 18.4997, 0.322880675631195, -67.0232, -1.16977551522266),
(34, '00664', 218, 46, 0, 18.2202, 0.318002480371871, -66.5931, -1.16226885410984),
(35, '00667', 218, 46, 0, 18.0422, 0.314895794303321, -67.0568, -1.17036194585133),
(36, '00669', 218, 46, 0, 18.2953, 0.319313222640119, -66.884, -1.16734601690389),
(37, '00670', 218, 46, 0, 18.2944, 0.319297514676851, -67.145, -1.17190132625159),
(38, '00674', 218, 46, 0, 18.4307, 0.321676398447319, -66.4839, -1.16036295456666),
(39, '00676', 218, 46, 0, 18.3966, 0.321081241172389, -67.1137, -1.17135503819572),
(40, '00677', 218, 46, 24340, 18.3405, 0.32010211146202, -67.2525, -1.17377755519749),
(41, '00678', 218, 46, 0, 18.476, 0.322467032598472, -66.9364, -1.16826056943193),
(42, '00680', 218, 46, 0, 18.2039, 0.317717991703796, -67.1437, -1.17187863697132),
(43, '00681', 218, 46, 0, 18.2032, 0.317705774399032, -67.1438, -1.17188038230057),
(44, '00682', 218, 46, 0, 18.203, 0.317702283740528, -67.14, -1.17181405978899),
(45, '00683', 218, 46, 0, 18.0847, 0.315637559235419, -67.046, -1.17017345029212),
(46, '00685', 218, 46, 0, 18.338, 0.32005847823072, -66.9959, -1.16929904033687),
(47, '00687', 218, 46, 0, 18.3266, 0.319859510695993, -66.4054, -1.15899287110384),
(48, '00688', 218, 46, 0, 18.4289, 0.321644982520783, -66.6121, -1.16260046666771),
(49, '00690', 218, 46, 17931, 18.4973, 0.322838787729147, -67.0971, -1.17106531353989),
(50, '00692', 218, 46, 0, 18.417, 0.321437288339796, -66.3223, -1.15754250249544),
(51, '00693', 218, 46, 0, 18.4428, 0.32188758328681, -66.3997, -1.15889338733648),
(52, '00694', 218, 46, 0, 18.4424, 0.321880601969802, -66.3997, -1.15889338733648),
(53, '00698', 218, 46, 0, 18.0367, 0.314799801194461, -66.8625, -1.16697077111471),
(54, '00703', 218, 46, 0, 18.259, 0.318679668121645, -66.1049, -1.1537481567016),
(55, '00704', 218, 46, 0, 18.2524, 0.318564476391013, -66.1018, -1.15369405149479),
(56, '00705', 218, 46, 0, 18.1422, 0.316641123555315, -66.2666, -1.15657035410207),
(57, '00707', 218, 46, 0, 18.0098, 0.314330307625675, -65.8994, -1.15016150508875),
(58, '00714', 218, 46, 158783, 17.9707, 0.313647883888145, -66.0623, -1.15300464644025),
(59, '00715', 218, 46, 0, 18.0116, 0.314361723552211, -66.5874, -1.16216937034247),
(60, '00716', 218, 46, 0, 18.0127, 0.314380922173983, -66.6144, -1.16264060924051),
(61, '00717', 218, 46, 0, 18.0126, 0.314379176844731, -66.6143, -1.16263886391126),
(62, '00718', 218, 46, 0, 18.2128, 0.317873326007223, -65.7363, -1.14731487307875),
(63, '00719', 218, 46, 0, 18.3023, 0.319435395687758, -66.2452, -1.15619685364215),
(64, '00720', 218, 46, 0, 18.2314, 0.318197957248094, -66.3902, -1.15872758105754),
(65, '00721', 218, 46, 337, 18.3728, 0.320665852810414, -65.774, -1.14797286220675),
(66, '00723', 218, 46, 0, 18.0073, 0.314286674394375, -66.0152, -1.15218259636256),
(67, '00725', 218, 46, 0, 18.2348, 0.318257298442662, -66.0394, -1.15260496604154),
(68, '00726', 218, 46, 0, 18.2341, 0.318245081137898, -66.0391, -1.15259973005379),
(69, '00727', 218, 46, 0, 18.2347, 0.31825555311341, -66.0391, -1.15259973005379),
(70, '00728', 218, 46, 0, 18.0127, 0.314380922173983, -66.6147, -1.16264584522827),
(71, '00729', 218, 46, 0, 18.3792, 0.320777553882542, -65.9071, -1.15029589544115),
(72, '00730', 218, 46, 0, 18.0126, 0.314379176844731, -66.6141, -1.16263537325275),
(73, '00731', 218, 46, 0, 18.0153, 0.314426300734534, -66.6193, -1.16272613037386),
(74, '00732', 218, 46, 0, 18.0372, 0.314808527840721, -66.6127, -1.16261093864323),
(75, '00733', 218, 46, 0, 18.0212, 0.314529275160402, -66.6219, -1.16277150893441),
(76, '00734', 218, 46, 0, 17.9873, 0.313937608543976, -66.6093, -1.16255159744866),
(77, '00735', 218, 46, 0, 18.26, 0.318697121414165, -65.6397, -1.14562888502132),
(78, '00736', 218, 46, 0, 18.1159, 0.316182101962041, -66.1624, -1.1547517210215),
(79, '00737', 218, 46, 0, 18.1161, 0.316185592620545, -66.163, -1.15476219299701),
(80, '00738', 218, 46, 0, 18.3352, 0.320009609011664, -65.66, -1.14598318685948),
(81, '00739', 218, 46, 0, 18.1791, 0.317285150049301, -66.1596, -1.15470285180244),
(82, '00740', 218, 46, 0, 18.335, 0.32000611835316, -65.6325, -1.14550322131518),
(83, '00741', 218, 46, 0, 18.1676, 0.317084437185322, -65.7443, -1.14745449941891),
(84, '00742', 218, 46, 0, 18.2377, 0.31830791299097, -65.6282, -1.14542817215734),
(85, '00744', 218, 46, 187260, 18.2144, 0.317901251275255, -65.7928, -1.14830098410613),
(86, '00745', 218, 46, 71335, 18.3806, 0.32080198849207, -65.8382, -1.14909336358653),
(87, '00751', 218, 46, 184738, 17.9863, 0.313920155251456, -66.2877, -1.15693861857425),
(88, '00754', 218, 46, 184839, 18.1915, 0.317501570876548, -65.9617, -1.15124884521274),
(89, '00757', 218, 46, 0, 17.9673, 0.313588542693577, -66.4035, -1.15895970984805),
(90, '00765', 218, 46, 0, 18.1317, 0.316457863983856, -65.4555, -1.14241398853915),
(91, '00766', 218, 46, 0, 18.1313, 0.316450882666848, -66.4912, -1.16049036360205),
(92, '00767', 218, 46, 0, 18.0515, 0.315058109923756, -65.8794, -1.14981243923835),
(93, '00769', 218, 46, 0, 18.0814, 0.315579963370103, -66.3601, -1.15820223695269),
(94, '00771', 218, 46, 0, 18.1808, 0.317314820646585, -65.8693, -1.1496361609839),
(95, '00772', 218, 46, 0, 18.4328, 0.321713050361611, -65.8806, -1.14983338318938),
(96, '00773', 218, 46, 0, 18.3779, 0.320754864602266, -65.7207, -1.14704260171544),
(97, '00775', 218, 46, 1913, 18.3131, 0.319623891246974, -65.3052, -1.1397907586734),
(98, '00777', 218, 46, 0, 18.2287, 0.31815083335829, -65.9168, -1.1504651923786),
(99, '00778', 218, 46, 0, 18.2559, 0.318625562914833, -65.9777, -1.15152809789306),
(100, '00780', 218, 46, 0, 18.0498, 0.315028439326473, -66.5519, -1.16154977845801),
(101, '00782', 218, 46, 0, 18.222, 0.318033896298407, -66.2253, -1.155849533121),
(102, '00783', 218, 46, 0, 18.344, 0.32016319798584, -66.3125, -1.15737146022874),
(103, '00784', 218, 46, 0, 17.9778, 0.313771802265037, -66.1113, -1.15385985777373),
(104, '00785', 218, 46, 0, 17.9781, 0.313777038252793, -66.111, -1.15385462178597),
(105, '00786', 218, 46, 48763, 18.1569, 0.316897686955358, -66.233, -1.1559839234734),
(106, '00791', 218, 46, 0, 18.1548, 0.316861035041067, -65.8197, -1.14877047767491),
(107, '00792', 218, 46, 0, 18.1543, 0.316852308394807, -65.8193, -1.1487634963579),
(108, '00794', 218, 46, 0, 18.1877, 0.317435248364973, -66.3094, -1.15731735502193),
(109, '00795', 218, 46, 0, 18.0544, 0.315108724472064, -66.505, -1.16073121903883),
(110, '00801', 218, 54, 11761, 18.3473, 0.320220793851156, -64.9454, -1.13351106402473),
(111, '00802', 218, 54, 11761, 18.3498, 0.320264427082455, -64.9337, -1.13330686050224),
(112, '00803', 218, 54, 11761, 18.3497, 0.320262681753203, -64.9338, -1.13330860583149),
(113, '00804', 218, 54, 11761, 18.3502, 0.320271408399464, -64.9346, -1.13332256846551),
(114, '00805', 218, 54, 11761, 18.3498, 0.320264427082455, -64.9342, -1.1333155871485),
(115, '00820', 218, 54, 0, 17.746, 0.309726129058914, -64.7075, -1.12935892573423),
(116, '00821', 218, 54, 0, 17.7463, 0.30973136504667, -64.707, -1.12935019908797),
(117, '00822', 218, 54, 0, 17.7465, 0.309734855705174, -64.7075, -1.12935892573423),
(118, '00823', 218, 54, 0, 17.7459, 0.309724383729662, -64.7073, -1.12935543507573),
(119, '00824', 218, 54, 0, 17.7468, 0.30974009169293, -64.7076, -1.12936067106348),
(120, '00830', 218, 54, 31032, 18.3354, 0.320013099670168, -64.7917, -1.13082849296441),
(121, '00831', 218, 54, 31032, 18.3354, 0.320013099670168, -64.793, -1.13085118224469),
(122, '00840', 218, 54, 0, 17.7134, 0.309157151722764, -64.8816, -1.13239754396195),
(123, '00841', 218, 54, 0, 17.7136, 0.309160642381268, -64.8815, -1.1323957986327),
(124, '00850', 218, 54, 0, 17.7337, 0.309511453560918, -64.7999, -1.13097160996307),
(125, '00851', 218, 54, 0, 17.7338, 0.30951319889017, -64.7995, -1.13096462864607),
(126, '00901', 218, 46, 97796, 18.4673, 0.322315188953549, -66.1092, -1.15382320585944),
(127, '00902', 218, 46, 97796, 18.4465, 0.321952160469134, -66.0983, -1.15363296497097),
(128, '00906', 218, 46, 97796, 18.4079, 0.321278463377864, -66.0639, -1.15303257170828),
(129, '00907', 218, 46, 97796, 18.4531, 0.322067352199766, -66.0765, -1.15325248319403),
(130, '00908', 218, 46, 97796, 18.4461, 0.321945179152126, -66.0795, -1.15330484307159),
(131, '00909', 218, 46, 97796, 18.4449, 0.321924235201102, -66.0692, -1.15312507415864),
(132, '00910', 218, 46, 97796, 18.4407, 0.321850931372518, -66.0684, -1.15311111152462),
(133, '00911', 218, 46, 97796, 18.4523, 0.32205338956575, -66.0578, -1.15292610662391),
(134, '00912', 218, 46, 97796, 18.448, 0.321978340407914, -66.0599, -1.1529627585382),
(135, '00913', 218, 46, 97796, 18.4511, 0.322032445614726, -66.0448, -1.15269921382115),
(136, '00914', 218, 46, 97796, 18.4454, 0.321932961847362, -66.0154, -1.15218608702106),
(137, '00915', 218, 46, 97796, 18.4394, 0.321828242092242, -66.0491, -1.15277426297899),
(138, '00916', 218, 46, 97796, 18.3779, 0.320754864602266, -66.1639, -1.15477790096028),
(139, '00917', 218, 46, 97796, 18.4239, 0.321557716058183, -66.052, -1.15282487752729),
(140, '00918', 218, 46, 97796, 18.4169, 0.321435543010544, -66.062, -1.15299941045249),
(141, '00919', 218, 46, 97796, 18.4128, 0.321363984511212, -66.0655, -1.15306049697631),
(142, '00920', 218, 46, 97796, 18.4079, 0.321278463377864, -66.0879, -1.15345145072876),
(143, '00921', 218, 46, 97796, 18.3907, 0.320978266746521, -66.0904, -1.15349508396006),
(144, '00922', 218, 46, 97796, 18.4078, 0.321276718048612, -66.0921, -1.15352475455734),
(145, '00923', 218, 46, 97796, 18.412, 0.321350021877196, -66.0372, -1.152566568798),
(146, '00924', 218, 46, 97796, 18.4048, 0.321224358171052, -66.0131, -1.15214594444827),
(147, '00925', 218, 46, 97796, 18.4021, 0.321177234281249, -66.0511, -1.15280916956403),
(148, '00926', 218, 46, 97796, 18.3756, 0.32071472202947, -66.0577, -1.15292436129466),
(149, '00927', 218, 46, 97796, 18.3884, 0.320938124173725, -66.0748, -1.15322281259675),
(150, '00928', 218, 46, 97796, 18.3919, 0.320999210697545, -66.0624, -1.1530063917695),
(151, '00929', 218, 46, 97796, 18.4012, 0.321161526317981, -66.0263, -1.15237632790953),
(152, '00930', 218, 46, 97796, 18.4086, 0.321290680682628, -66.0646, -1.15304478901305),
(153, '00931', 218, 46, 97796, 18.4081, 0.321281954036368, -66.0645, -1.15304304368379),
(154, '00933', 218, 46, 97796, 18.4683, 0.322332642246069, -66.1064, -1.15377433664038),
(155, '00934', 218, 46, 0, 18.4143, 0.321390164449992, -66.1294, -1.15417576236834),
(156, '00935', 218, 46, 97796, 18.4086, 0.321290680682628, -66.0644, -1.15304129835454),
(157, '00936', 218, 46, 97796, 18.383, 0.320843876394118, -66.0647, -1.1530465343423),
(158, '00937', 218, 46, 97796, 18.4081, 0.321281954036368, -66.0644, -1.15304129835454),
(159, '00938', 218, 46, 97796, 18.4081, 0.321281954036368, -66.0639, -1.15303257170828),
(160, '00939', 218, 46, 97796, 18.408, 0.321280208707116, -66.0644, -1.15304129835454),
(161, '00940', 218, 46, 97796, 18.4086, 0.321290680682628, -66.064, -1.15303431703753),
(162, '00949', 218, 46, 0, 18.4527, 0.322060370882758, -66.1774, -1.1550135204093),
(163, '00950', 218, 46, 0, 18.448, 0.321978340407914, -66.1735, -1.15494545256847),
(164, '00951', 218, 46, 0, 18.4443, 0.32191376322559, -66.2548, -1.15636440525034),
(165, '00952', 218, 46, 0, 18.4255, 0.321585641326215, -66.1855, -1.15515489207871),
(166, '00953', 218, 46, 0, 18.3896, 0.320959068124749, -66.2496, -1.15627364812924),
(167, '00954', 218, 46, 0, 18.3901, 0.320967794771009, -66.2501, -1.1562823747755),
(168, '00955', 218, 46, 97796, 18.408, 0.321280208707116, -66.0644, -1.15304129835454),
(169, '00956', 218, 46, 0, 18.1793, 0.317288640707805, -66.1137, -1.15390174567578),
(170, '00957', 218, 46, 0, 18.1798, 0.317297367354065, -66.1136, -1.15390000034652),
(171, '00958', 218, 46, 0, 18.1798, 0.317297367354065, -66.1138, -1.15390349100503),
(172, '00959', 218, 46, 0, 18.1798, 0.317297367354065, -66.1134, -1.15389650968802),
(173, '00960', 218, 46, 0, 18.1795, 0.317292131366309, -66.1132, -1.15389301902952),
(174, '00961', 218, 46, 0, 18.1799, 0.317299112683317, -66.1138, -1.15390349100503),
(175, '00962', 218, 46, 0, 18.4451, 0.321927725859606, -66.1393, -1.15434854996429),
(176, '00963', 218, 46, 0, 18.445, 0.321925980530354, -66.1392, -1.15434680463503),
(177, '00965', 218, 46, 0, 18.3862, 0.320899726930181, -66.1146, -1.15391745363904),
(178, '00966', 218, 46, 0, 18.3866, 0.320906708247189, -66.1142, -1.15391047232204),
(179, '00968', 218, 46, 0, 18.3869, 0.320911944234945, -66.114, -1.15390698166353),
(180, '00969', 218, 46, 0, 18.3866, 0.320906708247189, -66.1143, -1.15391221765129),
(181, '00970', 218, 46, 0, 18.386, 0.320896236271677, -66.1141, -1.15390872699278),
(182, '00971', 218, 46, 0, 18.3862, 0.320899726930181, -66.1139, -1.15390523633428),
(183, '00975', 218, 46, 97796, 18.4088, 0.321294171341132, -66.0644, -1.15304129835454),
(184, '00976', 218, 46, 0, 18.3629, 0.320493065214467, -66.0178, -1.15222797492311),
(185, '00977', 218, 46, 0, 18.3631, 0.320496555872971, -66.0178, -1.15222797492311),
(186, '00978', 218, 46, 0, 18.3702, 0.320620474249862, -66.0118, -1.15212325516799),
(187, '00979', 218, 46, 1366, 18.4086, 0.321290680682628, -65.981, -1.15158569375838),
(188, '00981', 218, 46, 1366, 18.4088, 0.321294171341132, -65.9814, -1.15159267507539),
(189, '00982', 218, 46, 1366, 18.4084, 0.321287190024124, -65.9815, -1.15159442040464),
(190, '00983', 218, 46, 1366, 18.4085, 0.321288935353376, -65.9811, -1.15158743908763),
(191, '00984', 218, 46, 1366, 18.4087, 0.32129242601188, -65.981, -1.15158569375838),
(192, '00985', 218, 46, 1366, 18.4082, 0.32128369936562, -65.9811, -1.15158743908763),
(193, '00986', 218, 46, 1366, 18.4084, 0.321287190024124, -65.9809, -1.15158394842913),
(194, '00987', 218, 46, 1366, 18.4083, 0.321285444694872, -65.9811, -1.15158743908763),
(195, '00988', 218, 46, 1366, 18.4079, 0.321278463377864, -65.9812, -1.15158918441688),
(196, '01001', 218, 23, 34513, 42.0707, 0.734272233618778, -72.6246, -1.26753838794387),
(197, '01002', 218, 23, 62514, 42.373, 0.739548363947557, -72.506, -1.26546842745101),
(198, '01003', 218, 23, 62514, 42.4042, 0.74009290667418, -72.5296, -1.26588032515448),
(199, '01004', 218, 23, 62514, 42.384, 0.739740350165277, -72.5139, -1.26560630846192),
(200, '01005', 218, 23, 124184, 42.4339, 0.740611269462022, -72.1153, -1.25864942606347),
(201, '01007', 218, 23, 124219, 42.2789, 0.737906009121431, -72.4103, -1.26379814735685),
(202, '01008', 218, 23, 19329, 42.1435, 0.73554283331423, -72.9303, -1.27287385946722),
(203, '01009', 218, 23, 7593, 42.2088, 0.736682533315782, -72.3443, -1.26264623005053),
(204, '01010', 218, 23, 45096, 42.1285, 0.735281033926431, -72.197, -1.26007536006235),
(205, '01011', 218, 23, 8056, 42.2847, 0.738007238218046, -72.9687, -1.27354406589999),
(206, '01012', 218, 23, 1534, 42.3856, 0.739768275433308, -72.8354, -1.27121754200708),
(207, '01013', 218, 23, 20028, 42.1628, 0.735879681859865, -72.6052, -1.26719979406899),
(208, '01014', 218, 23, 20028, 42.1754, 0.736099593345616, -72.5731, -1.2666395433791),
(209, '01020', 218, 23, 20028, 42.1754, 0.736099593345616, -72.5719, -1.26661859942807),
(210, '01021', 218, 23, 20028, 42.1761, 0.73611181065038, -72.5726, -1.26663081673284),
(211, '01022', 218, 23, 20028, 42.1961, 0.736460876500779, -72.5597, -1.26640566925933),
(212, '01026', 218, 23, 124606, 42.4003, 0.740024838833352, -72.8498, -1.27146886941937),
(213, '01027', 218, 23, 124757, 42.2719, 0.737783836073791, -72.6974, -1.26880898763933),
(214, '01028', 218, 23, 124716, 42.0682, 0.734228600387479, -72.5061, -1.26547017278026),
(215, '01029', 218, 23, 124729, 42.1587, 0.735808123360533, -73.0427, -1.27483560954646),
(216, '01030', 218, 23, 124824, 42.0718, 0.73429143224055, -72.6736, -1.26839359927735),
(217, '01031', 218, 23, 115732, 42.3145, 0.738527346335141, -72.2037, -1.26019229712223),
(218, '01032', 218, 23, 419, 42.4431, 0.740771839753205, -72.8065, -1.27071314185325),
(219, '01033', 218, 23, 55021, 42.2589, 0.737556943271032, -72.5176, -1.26567088564424),
(220, '01034', 218, 23, 55048, 42.0731, 0.734314121520826, -72.8946, -1.27225077692426),
(221, '01035', 218, 23, 27352, 42.3594, 0.739310999169286, -72.5738, -1.26665176068386),
(222, '01036', 218, 23, 2956, 42.0633, 0.734143079254131, -72.4313, -1.26416466649977),
(223, '01037', 218, 23, 2971, 42.3495, 0.739138211573339, -72.2003, -1.26013295592766),
(224, '01038', 218, 23, 9378, 42.384, 0.739740350165277, -72.6086, -1.26725913526355),
(225, '01039', 218, 23, 72861, 42.38, 0.739670536995197, -72.6946, -1.26876011842027),
(226, '01040', 218, 23, 125098, 42.2026, 0.736574322902159, -72.6312, -1.26765357967451),
(227, '01041', 218, 23, 125098, 42.2077, 0.736663334694011, -72.6099, -1.26728182454383),
(228, '01050', 218, 23, 9621, 42.2691, 0.737734966854735, -72.8651, -1.27173590479492),
(229, '01053', 218, 23, 3719, 42.3531, 0.73920104342641, -72.7023, -1.26889450877267),
(230, '01054', 218, 23, 22638, 42.4763, 0.741351289064867, -72.4833, -1.26507223771081),
(231, '01056', 218, 23, 37000, 42.1728, 0.736054214785065, -72.4708, -1.26485407155431),
(232, '01057', 218, 23, 110500, 42.0974, 0.734738236529061, -72.3241, -1.26229367354163),
(233, '01059', 218, 23, 125581, 42.4134, 0.740253476965363, -72.5297, -1.26588207048373),
(234, '01060', 218, 23, 49904, 42.3249, 0.738708860577348, -72.6578, -1.26811783725554),
(235, '01061', 218, 23, 49904, 42.3226, 0.738668718004552, -72.6899, -1.26867808794543),
(236, '01062', 218, 23, 2502, 42.3289, 0.738778673747428, -72.6946, -1.26876011842027),
(237, '01063', 218, 23, 49904, 42.3182, 0.738591923517464, -72.6424, -1.26784905655073),
(238, '01066', 218, 23, 125624, 42.4087, 0.740171446490519, -72.6262, -1.26756631321191),
(239, '01068', 218, 23, 125713, 42.3444, 0.739049199781487, -72.0476, -1.25746783815987),
(240, '01069', 218, 23, 337, 42.1679, 0.735968693651717, -72.3177, -1.2621819724695),
(241, '01070', 218, 23, 11247, 42.5378, 0.742424666554844, -72.9325, -1.27291225671076),
(242, '01071', 218, 23, 5580, 42.1692, 0.735991382931993, -72.8637, -1.27171147018539),
(243, '01072', 218, 23, 126097, 42.4684, 0.74121340805396, -72.4307, -1.26415419452426),
(244, '01073', 218, 23, 51571, 42.2245, 0.736956550008346, -72.7243, -1.26927848120811),
(245, '01074', 218, 23, 126133, 42.3851, 0.739759548787049, -72.0987, -1.25835970140764),
(246, '01075', 218, 23, 126162, 42.2356, 0.737150281555317, -72.5827, -1.26680709498729),
(247, '01077', 218, 23, 24991, 42.052, 0.733945857048655, -72.7698, -1.27007260601777),
(248, '01079', 218, 23, 126344, 42.1892, 0.736340448782392, -72.3288, -1.26237570401647),
(249, '01080', 218, 23, 62020, 42.1794, 0.736169406515696, -72.3725, -1.2631384128996),
(250, '01081', 218, 23, 38725, 42.0587, 0.734062794108539, -72.229, -1.26063386542298),
(251, '01082', 218, 23, 6627, 42.2627, 0.737623265782608, -72.2636, -1.26123774934417),
(252, '01083', 218, 23, 12663, 42.2097, 0.73669824127905, -72.1962, -1.26006139742833),
(253, '01084', 218, 23, 126507, 42.4081, 0.740160974515007, -72.8868, -1.2721146412426),
(254, '01085', 218, 23, 723, 42.1291, 0.735291505901943, -72.7467, -1.26966943496056),
(255, '01086', 218, 23, 723, 42.1393, 0.735469529485646, -72.7565, -1.26984047722725),
(256, '01088', 218, 23, 126529, 42.3854, 0.739764784774804, -72.6394, -1.26779669667317),
(257, '01089', 218, 23, 107435, 42.1157, 0.735057631782176, -72.6403, -1.26781240463644),
(258, '01090', 218, 23, 107435, 42.1228, 0.735181550159067, -72.6527, -1.26802882546368),
(259, '01092', 218, 23, 126580, 42.2104, 0.736710458583814, -72.2351, -1.26074033050736),
(260, '01093', 218, 23, 126621, 42.435, 0.740630468083794, -72.6467, -1.26792410570856),
(261, '01094', 218, 23, 38838, 42.3522, 0.739185335463142, -72.1401, -1.25908226771796),
(262, '01095', 218, 23, 126646, 42.1236, 0.735195512793083, -72.4427, -1.2643636340345),
(263, '01096', 218, 23, 6831, 42.3976, 0.739977714943548, -72.7456, -1.26965023633879),
(264, '01097', 218, 23, 126708, 42.163, 0.735883172518369, -72.8377, -1.27125768457987),
(265, '01098', 218, 23, 31567, 42.3062, 0.738382484007225, -72.8765, -1.27193487232965),
(266, '01101', 218, 23, 349, 42.099, 0.734766161797093, -72.5878, -1.26689610677914),
(267, '01102', 218, 23, 349, 42.1146, 0.735038433160404, -72.5395, -1.26605311275043),
(268, '01103', 218, 23, 349, 42.103, 0.734835974967173, -72.5904, -1.26694148533969),
(269, '01104', 218, 23, 349, 42.1302, 0.735310704523715, -72.5741, -1.26665699667162),
(270, '01105', 218, 23, 349, 42.0995, 0.734774888443353, -72.5789, -1.26674077247571),
(271, '01106', 218, 23, 49058, 42.0498, 0.733907459805112, -72.5674, -1.26654005961173),
(272, '01107', 218, 23, 349, 42.1204, 0.73513966225702, -72.6053, -1.26720153939824),
(273, '01108', 218, 23, 349, 42.0838, 0.73450087175079, -72.5563, -1.26634632806476),
(274, '01109', 218, 23, 349, 42.1177, 0.735092538367216, -72.5488, -1.26621542837086),
(275, '01111', 218, 23, 349, 42.1175, 0.735089047708712, -72.5482, -1.26620495639535),
(276, '01114', 218, 23, 349, 42.103, 0.734835974967173, -72.591, -1.2669519573152),
(277, '01115', 218, 23, 349, 42.1027, 0.734830738979417, -72.5921, -1.26697115593698),
(278, '01116', 218, 23, 49058, 42.048, 0.733876043878576, -72.5698, -1.26658194751378),
(279, '01118', 218, 23, 349, 42.0943, 0.734684131322249, -72.5272, -1.26583843725243),
(280, '01119', 218, 23, 349, 42.1265, 0.735246127341391, -72.5078, -1.26549984337754),
(281, '01128', 218, 23, 349, 42.0949, 0.734694603297761, -72.4968, -1.26530785715983),
(282, '01129', 218, 23, 349, 42.1206, 0.735143152915524, -72.4879, -1.2651525228564),
(283, '01133', 218, 23, 349, 42.1037, 0.734848192271937, -72.5927, -1.26698162791249),
(284, '01138', 218, 23, 349, 42.0868, 0.734553231628349, -72.5625, -1.26645453847839),
(285, '01139', 218, 23, 349, 42.1167, 0.735075085074696, -72.5471, -1.26618575777358),
(286, '01144', 218, 23, 349, 42.1015, 0.734809795028393, -72.5914, -1.26695893863221),
(287, '01151', 218, 23, 125139, 42.1521, 0.735692931629902, -72.5049, -1.26544922882924),
(288, '01152', 218, 23, 349, 42.1523, 0.735696422288406, -72.5097, -1.26553300463333),
(289, '01199', 218, 23, 349, 42.1201, 0.735134426269264, -72.6053, -1.26720153939824),
(290, '01201', 218, 23, 28268, 42.4549, 0.740977788604941, -73.2505, -1.27846240373211),
(291, '01202', 218, 23, 28268, 42.4581, 0.741033639141005, -73.3239, -1.27974347540307),
(292, '01203', 218, 23, 28268, 42.4513, 0.740914956751869, -73.2613, -1.27865089929132),
(293, '01220', 218, 23, 14941, 42.6198, 0.743855836541479, -73.1207, -1.27619696636302),
(294, '01222', 218, 23, 124135, 42.0574, 0.734040104828263, -73.3168, -1.27961955702618),
(295, '01223', 218, 23, 124209, 42.3835, 0.739731623519017, -73.1434, -1.27659315610322),
(296, '01224', 218, 23, 44780, 42.4888, 0.741569455221367, -73.1931, -1.27746058474146),
(297, '01225', 218, 23, 72084, 42.5584, 0.742784204380755, -73.1586, -1.27685844614952),
(298, '01226', 218, 23, 8391, 42.4707, 0.741253550626756, -73.1621, -1.27691953267334),
(299, '01227', 218, 23, 8391, 42.4732, 0.741297183858056, -73.1647, -1.2769649112339),
(300, '01229', 218, 23, 2741, 42.2875, 0.738056107437102, -73.3436, -1.28008730526571),
(301, '01230', 218, 23, 124961, 42.206, 0.736633664096727, -73.3579, -1.28033688734875),
(302, '01235', 218, 23, 120039, 42.4313, 0.74056589090147, -73.1069, -1.27595611092624),
(303, '01236', 218, 23, 125110, 42.2499, 0.737399863638352, -73.3682, -1.2805166562617),
(304, '01237', 218, 23, 116400, 42.512, 0.741974371607829, -73.2433, -1.27833674002596),
(305, '01238', 218, 23, 3715, 42.3109, 0.738464514482069, -73.2456, -1.27837688259876),
(306, '01240', 218, 23, 425, 42.3629, 0.739372085693106, -73.2731, -1.27885684814306),
(307, '01242', 218, 23, 125227, 42.3316, 0.738825797637232, -73.2483, -1.27842400648856),
(308, '01243', 218, 23, 113705, 42.3467, 0.739089342354283, -73.0086, -1.27424045227153),
(309, '01244', 218, 23, 125426, 42.1137, 0.735022725197136, -73.2679, -1.27876609102195),
(310, '01245', 218, 23, 4284, 42.2025, 0.736572577572907, -73.2266, -1.27804527004088),
(311, '01247', 218, 23, 125578, 42.6948, 0.745164833480475, -73.1156, -1.27610795457117),
(312, '01252', 218, 23, 125610, 42.1979, 0.736492292427315, -73.4363, -1.28170522548231),
(313, '01253', 218, 23, 17462, 42.1843, 0.736254927649044, -73.0997, -1.2758304472201),
(314, '01254', 218, 23, 5381, 42.4011, 0.740038801467368, -73.3495, -1.28019027969158),
(315, '01255', 218, 23, 126028, 42.1181, 0.735099519684224, -73.1197, -1.2761795130705),
(316, '01256', 218, 23, 11814, 42.5771, 0.743110580950878, -73.0318, -1.27464536865799),
(317, '01257', 218, 23, 5785, 42.0781, 0.734401387983426, -73.3941, -1.28096869653797),
(318, '01258', 218, 23, 126153, 42.1167, 0.735075085074696, -73.4749, -1.28237892257358),
(319, '01259', 218, 23, 126225, 42.067, 0.734207656436455, -73.2893, -1.27913959148188),
(320, '01260', 218, 23, 57631, 42.2801, 0.737926953072454, -73.2782, -1.27894585993491),
(321, '01262', 218, 23, 25139, 42.3062, 0.738382484007225, -73.3165, -1.27961432103842),
(322, '01263', 218, 23, 25139, 42.2871, 0.738049126120094, -73.3208, -1.27968937019626),
(323, '01264', 218, 23, 126381, 42.2458, 0.73732830513902, -73.2045, -1.27765955227619),
(324, '01266', 218, 23, 126562, 42.3367, 0.738914809429083, -73.3811, -1.28074180373521),
(325, '01267', 218, 23, 6834, 42.701, 0.745273043894099, -73.2102, -1.27775903604355),
(326, '01270', 218, 23, 18652, 42.3326, 0.738843250929752, -73.2538, -1.27851999959742),
(327, '01301', 218, 23, 2861, 42.6027, 0.743557385239388, -72.5992, -1.26709507431387),
(328, '01302', 218, 23, 2861, 42.6532, 0.744438776511645, -72.6081, -1.26725040861729),
(329, '01330', 218, 23, 124131, 42.5258, 0.742215227044605, -72.7846, -1.27033091474706),
(330, '01331', 218, 23, 31693, 42.5876, 0.743293840522337, -72.2264, -1.26058848686243),
(331, '01337', 218, 23, 124240, 42.6643, 0.744632508058617, -72.5403, -1.26606707538444),
(332, '01338', 218, 23, 63266, 42.5975, 0.743466628118284, -72.7417, -1.26958216849796),
(333, '01339', 218, 23, 100696, 42.6366, 0.744149051855814, -72.8756, -1.27191916436638),
(334, '01340', 218, 23, 124558, 42.7093, 0.745417906222014, -72.7171, -1.26915281750197),
(335, '01341', 218, 23, 8215, 42.5142, 0.742012768851373, -72.6886, -1.26865539866515),
(336, '01342', 218, 23, 8455, 42.5524, 0.742679484625635, -72.5875, -1.26689087079138),
(337, '01343', 218, 23, 32265, 42.6424, 0.74425028095243, -72.9863, -1.27385124384834),
(338, '01344', 218, 23, 124792, 42.6064, 0.743621962421712, -72.4096, -1.26378593005209),
(339, '01346', 218, 23, 3039, 42.6805, 0.74491525139744, -72.8415, -1.27132400709145),
(340, '01347', 218, 23, 125190, 42.5585, 0.742785949710007, -72.5169, -1.26565866833948),
(341, '01349', 218, 23, 126376, 42.5782, 0.74312977957265, -72.4911, -1.26520837339246),
(342, '01350', 218, 23, 125455, 42.7162, 0.745538333940402, -72.9468, -1.2731618387938),
(343, '01351', 218, 23, 4275, 42.5394, 0.742452591822876, -72.5301, -1.26588905180074),
(344, '01354', 218, 23, 37457, 42.6775, 0.74486289151988, -72.4478, -1.26445264582635),
(345, '01355', 218, 23, 10782, 42.4865, 0.741529312648571, -72.3394, -1.26256070891719),
(346, '01360', 218, 23, 37457, 42.6987, 0.745232901321303, -72.4495, -1.26448231642363),
(347, '01364', 218, 23, 4797, 42.6037, 0.743574838531908, -72.3067, -1.26198998625178),
(348, '01366', 218, 23, 125803, 42.4749, 0.741326854455339, -72.2027, -1.26017484382971),
(349, '01367', 218, 23, 105922, 42.6889, 0.745061859054607, -72.9344, -1.27294541796655),
(350, '01368', 218, 23, 125996, 42.6832, 0.744962375287244, -72.1964, -1.26006488808683),
(351, '01369', 218, 23, 126070, 42.637, 0.744156033172822, -72.7265, -1.26931687845166),
(352, '01370', 218, 23, 126077, 42.5973, 0.743463137459781, -72.7333, -1.26943556084079),
(353, '01373', 218, 23, 126149, 42.4769, 0.741361761040379, -72.6108, -1.2672975325071),
(354, '01375', 218, 23, 51821, 42.4601, 0.741068545726044, -72.5637, -1.26647548242941),
(355, '01376', 218, 23, 126376, 42.6055, 0.743606254458444, -72.5474, -1.26619099376133),
(356, '01378', 218, 23, 14798, 42.6762, 0.744840202239604, -72.3462, -1.26267939130632),
(357, '01379', 218, 23, 69974, 42.5596, 0.742805148331779, -72.3874, -1.26339846695814),
(358, '01380', 218, 23, 126481, 42.5706, 0.742997134549498, -72.4055, -1.26371437155275),
(359, '01420', 218, 23, 35904, 42.5778, 0.743122798255642, -71.8012, -1.25316734688295),
(360, '01430', 218, 23, 124125, 42.6547, 0.744464956450425, -71.9247, -1.25532282850917),
(361, '01431', 218, 23, 92351, 42.6775, 0.74486289151988, -71.8116, -1.25334886112516),
(362, '01432', 218, 23, 124162, 42.5612, 0.742833073599811, -71.5767, -1.24924908271223),
(363, '01436', 218, 23, 19030, 42.6066, 0.743625453080216, -72.0689, -1.25783959329054),
(364, '01438', 218, 23, 124744, 42.5627, 0.742859253538591, -72.0404, -1.25734217445372),
(365, '01440', 218, 23, 9048, 42.5736, 0.743049494427058, -71.9933, -1.25652012437603),
(366, '01441', 218, 23, 13249, 42.5735, 0.743047749097806, -71.9961, -1.25656899359509),
(367, '01450', 218, 23, 113503, 42.6091, 0.743669086311516, -71.5558, -1.24888430889856),
(368, '01451', 218, 23, 9370, 42.5006, 0.741775404073102, -71.5755, -1.2492281387612),
(369, '01452', 218, 23, 125114, 42.4858, 0.741517095343807, -72.0063, -1.25674701717879),
(370, '01453', 218, 23, 125230, 42.5272, 0.742239661654133, -71.7558, -1.25237496740255),
(371, '01460', 218, 23, 3815, 42.5401, 0.74246480912764, -71.4845, -1.24763988914189),
(372, '01462', 218, 23, 10233, 42.5888, 0.743314784473361, -71.731, -1.25194212574805),
(373, '01463', 218, 23, 4951, 42.6703, 0.744737227813736, -71.5932, -1.2495370620388),
(374, '01464', 218, 23, 5825, 42.5614, 0.742836564258315, -71.6487, -1.25050571977366),
(375, '01467', 218, 23, 126259, 42.4829, 0.741466480795499, -71.6175, -1.24996117704704),
(376, '01468', 218, 23, 91273, 42.5518, 0.742669012650123, -72.0669, -1.2578046867055),
(377, '01469', 218, 23, 14757, 42.6561, 0.744489391059953, -71.6927, -1.25127366464454),
(378, '01470', 218, 23, 113503, 42.6065, 0.743623707750964, -71.5715, -1.24915832559112),
(379, '01471', 218, 23, 113503, 42.6076, 0.743642906372736, -71.5712, -1.24915308960337),
(380, '01472', 218, 23, 126526, 42.6084, 0.743656869006752, -71.6284, -1.25015141793551),
(381, '01473', 218, 23, 13249, 42.5432, 0.742518914334452, -71.9068, -1.25501041457306),
(382, '01474', 218, 23, 126572, 42.6722, 0.744770389069524, -71.7455, -1.25219519848959),
(383, '01475', 218, 23, 126665, 42.6756, 0.744829730264092, -72.0456, -1.25743293157483),
(384, '01477', 218, 23, 126667, 42.6973, 0.745208466711775, -72.018, -1.25695122070128),
(385, '01501', 218, 23, 13306, 42.2058, 0.736630173438223, -71.8376, -1.25380264673068),
(386, '01503', 218, 23, 376, 42.3741, 0.739567562569329, -71.6352, -1.25027010032464),
(387, '01504', 218, 23, 99958, 42.027, 0.733509524735657, -71.5295, -1.24842528730528),
(388, '01505', 218, 23, 1075, 42.3318, 0.738829288295736, -71.7341, -1.25199623095486),
(389, '01506', 218, 23, 13444, 42.2034, 0.736588285536175, -72.1018, -1.25841380661445),
(390, '01507', 218, 23, 45636, 42.1478, 0.735617882472066, -71.9412, -1.25561080783574),
(391, '01508', 218, 23, 124489, 42.1532, 0.735712130251674, -71.9906, -1.25647300048623),
(392, '01509', 218, 23, 124490, 42.1734, 0.736064686760577, -71.9786, -1.25626356097599),
(393, '01510', 218, 23, 1630, 42.417, 0.740316308818435, -71.6839, -1.25112007567036),
(394, '01515', 218, 23, 124689, 42.2187, 0.73685532091173, -72.0525, -1.25755335929321),
(395, '01516', 218, 23, 2088, 42.0918, 0.734640498090949, -71.7158, -1.25167683570175),
(396, '01517', 218, 23, 124733, 42.473, 0.741293693199552, -71.8391, -1.25382882666946),
(397, '01518', 218, 23, 124841, 42.1209, 0.735148388903279, -72.1096, -1.2585499422961),
(398, '01519', 218, 23, 27298, 42.2015, 0.736555124280387, -71.6868, -1.25117069021867),
(399, '01520', 218, 23, 27452, 42.3439, 0.739040473135227, -71.8485, -1.25399288761915),
(400, '01521', 218, 23, 9533, 42.0408, 0.733750380172432, -72.1501, -1.25925680064316),
(401, '01522', 218, 23, 3409, 42.3741, 0.739567562569329, -71.8682, -1.25433671748179),
(402, '01523', 218, 23, 16841, 42.4787, 0.741393176966915, -71.6837, -1.25111658501186),
(403, '01524', 218, 23, 66314, 42.2353, 0.737145045567561, -71.9179, -1.25520414612003),
(404, '01525', 218, 23, 3793, 42.1003, 0.734788851077369, -71.6407, -1.2503660934335),
(405, '01526', 218, 23, 125308, 42.0918, 0.734640498090949, -71.748, -1.25223883172089),
(406, '01527', 218, 23, 125432, 42.1976, 0.736487056439559, -71.77, -1.25262280415633),
(407, '01529', 218, 23, 4227, 42.0271, 0.733511270064909, -71.5826, -1.24935205713809),
(408, '01531', 218, 23, 125538, 42.3236, 0.738686171297072, -72.1403, -1.25908575837647),
(409, '01532', 218, 23, 125677, 42.3148, 0.738532582322897, -71.6496, -1.25052142773693),
(410, '01534', 218, 23, 125679, 42.1472, 0.735607410496554, -71.6529, -1.25057902360224),
(411, '01535', 218, 23, 125593, 42.2679, 0.737714022903711, -72.0775, -1.25798969160621),
(412, '01536', 218, 23, 125618, 42.23, 0.737052543117205, -71.7029, -1.25145168822824),
(413, '01537', 218, 23, 125637, 42.1659, 0.735933787066677, -71.8916, -1.25474512452676),
(414, '01538', 218, 23, 125664, 42.0915, 0.734635262103193, -71.6406, -1.25036434810425),
(415, '01540', 218, 23, 4828, 42.1146, 0.735038433160404, -71.8689, -1.25434893478655),
(416, '01541', 218, 23, 5231, 42.4508, 0.740906230105609, -71.8833, -1.25460026219884),
(417, '01542', 218, 23, 61567, 42.1976, 0.736487056439559, -71.9056, -1.25498947062203),
(418, '01543', 218, 23, 17882, 42.3745, 0.739574543886337, -71.9518, -1.25579581273646),
(419, '01545', 218, 23, 38203, 42.2851, 0.738014219535054, -71.7223, -1.25179028210313),
(420, '01546', 218, 23, 38203, 42.2925, 0.738143373899702, -71.7474, -1.25222835974538),
(421, '01550', 218, 23, 24977, 42.076, 0.734364736069134, -72.0334, -1.25722000140608),
(422, '01560', 218, 23, 111460, 42.1762, 0.736113555979632, -71.6934, -1.2512858819493),
(423, '01561', 218, 23, 126172, 42.4424, 0.740759622448441, -71.6893, -1.25121432344997),
(424, '01562', 218, 23, 5995, 42.246, 0.737331795797525, -71.9924, -1.25650441641277),
(425, '01564', 218, 23, 25116, 42.4313, 0.74056589090147, -71.7729, -1.25267341870464),
(426, '01566', 218, 23, 25189, 42.1096, 0.734951166697804, -72.0767, -1.2579757289722),
(427, '01568', 218, 23, 6489, 42.1722, 0.736043742809553, -71.6051, -1.24974475621979),
(428, '01569', 218, 23, 126396, 42.0775, 0.734390916007914, -71.6317, -1.25020901380082),
(429, '01570', 218, 23, 18520, 42.052, 0.733945857048655, -71.8829, -1.25459328088183),
(430, '01571', 218, 23, 2116, 42.0575, 0.734041850157515, -71.912, -1.25510117169416),
(431, '01580', 218, 23, 91764, 42.2831, 0.737979312950014, -71.6013, -1.24967843370822),
(432, '01581', 218, 23, 91764, 42.2658, 0.737677370989419, -71.6181, -1.24997164902255),
(433, '01582', 218, 23, 91764, 42.1724, 0.736047233468057, -71.6178, -1.24996641303479),
(434, '01583', 218, 23, 126498, 42.3592, 0.739307508510782, -71.7872, -1.25292300078767),
(435, '01585', 218, 23, 126511, 42.2376, 0.737185188140357, -72.1473, -1.2592079314241),
(436, '01586', 218, 23, 126541, 42.1241, 0.735204239439343, -71.6449, -1.25043939726209),
(437, '01588', 218, 23, 126637, 42.1199, 0.73513093561076, -71.6725, -1.25092110813564),
(438, '01590', 218, 23, 12229, 42.138, 0.735446840205371, -71.7533, -1.25233133417125),
(439, '01601', 218, 23, 58366, 42.2693, 0.737738457513239, -71.8085, -1.25329475591835),
(440, '01602', 218, 23, 58366, 42.2715, 0.737776854756783, -71.845, -1.25393180109533),
(441, '01603', 218, 23, 58366, 42.2427, 0.737274199932209, -71.8377, -1.25380439205993),
(442, '01604', 218, 23, 58366, 42.2536, 0.737464440820676, -71.773, -1.25267516403389),
(443, '01605', 218, 23, 58366, 42.2877, 0.738059598095606, -71.7958, -1.25307309910334),
(444, '01606', 218, 23, 58366, 42.3122, 0.738487203762345, -71.7987, -1.25312371365165),
(445, '01607', 218, 23, 58366, 42.2299, 0.737050797787953, -71.7938, -1.2530381925183),
(446, '01608', 218, 23, 58366, 42.2616, 0.737604067160836, -71.8013, -1.2531690922122),
(447, '01609', 218, 23, 58366, 42.2753, 0.737843177268359, -71.8199, -1.25349372345308),
(448, '01610', 218, 23, 58366, 42.2486, 0.737377174358076, -71.8104, -1.25332791717414),
(449, '01611', 218, 23, 8055, 42.2417, 0.737256746639689, -71.8711, -1.2543873320301),
(450, '01612', 218, 23, 17550, 42.3004, 0.738281254910609, -71.9089, -1.25504706648735),
(451, '01613', 218, 23, 58366, 42.2647, 0.737658172367647, -71.7958, -1.25307309910334),
(452, '01614', 218, 23, 58366, 42.2622, 0.737614539136348, -71.8031, -1.25320050813874),
(453, '01615', 218, 23, 58366, 42.2699, 0.737748929488751, -71.8093, -1.25330871855236),
(454, '01653', 218, 23, 58366, 42.2918, 0.738131156594938, -71.7814, -1.25282177169106),
(455, '01654', 218, 23, 58366, 42.2698, 0.737747184159499, -71.8089, -1.25330173723536),
(456, '01655', 218, 23, 58366, 42.2779, 0.737888555828911, -71.7597, -1.25244303524337),
(457, '01701', 218, 23, 124885, 42.3164, 0.738560507590929, -71.4324, -1.2467305726016),
(458, '01702', 218, 23, 124885, 42.2706, 0.737761146793515, -71.4218, -1.24654556770089),
(459, '01703', 218, 23, 124885, 42.3198, 0.738619848785496, -71.4405, -1.24687194427101),
(460, '01704', 218, 23, 124885, 42.3196, 0.738616358126992, -71.4408, -1.24687718025876),
(461, '01705', 218, 23, 124885, 42.3198, 0.738619848785496, -71.4405, -1.24687194427101),
(462, '01718', 218, 23, 126405, 42.5172, 0.742065128728933, -71.4112, -1.24636056280017),
(463, '01719', 218, 23, 0, 42.485, 0.741503132709791, -71.5161, -1.24819141318552),
(464, '01720', 218, 23, 29062, 42.4774, 0.741370487686639, -71.446, -1.24696793737987),
(465, '01721', 218, 23, 13301, 42.2545, 0.737480148783944, -71.4607, -1.24722450077991),
(466, '01730', 218, 23, 146, 42.4922, 0.741628796415934, -71.2759, -1.24399913232223),
(467, '01731', 218, 23, 0, 42.4528, 0.740941136690649, -71.2799, -1.24406894549231),
(468, '01740', 218, 23, 19382, 42.4364, 0.740654902693322, -71.6078, -1.2497918801096),
(469, '01741', 218, 23, 1358, 42.5293, 0.742276313568424, -71.3486, -1.24526798668843),
(470, '01742', 218, 23, 698, 42.457, 0.741014440519232, -71.3725, -1.24568512037965),
(471, '01745', 218, 23, 27156, 42.2822, 0.737963604986747, -71.5198, -1.24825599036784),
(472, '01746', 218, 23, 125096, 42.1998, 0.736525453683103, -71.4347, -1.24677071517439),
(473, '01747', 218, 23, 41406, 42.1266, 0.735247872670643, -71.536, -1.24853873370666),
(474, '01748', 218, 23, 116079, 42.2198, 0.736874519533502, -71.5312, -1.24845495790257),
(475, '01749', 218, 23, 16505, 42.391, 0.739862523212916, -71.5586, -1.24893317811761),
(476, '01752', 218, 23, 22884, 42.352, 0.739181844804638, -71.5448, -1.24869232268084),
(477, '01754', 218, 23, 4057, 42.4319, 0.740576362876982, -71.4541, -1.24710930904928),
(478, '01756', 218, 23, 56203, 42.0956, 0.734706820602525, -71.5474, -1.24873770124139),
(479, '01757', 218, 23, 10480, 42.1488, 0.735635335764586, -71.5239, -1.24832754886717),
(480, '01760', 218, 23, 125517, 42.289, 0.738082287375882, -71.3546, -1.24537270644355),
(481, '01770', 218, 23, 126082, 42.2327, 0.737099667007009, -71.3802, -1.24581951073206),
(482, '01772', 218, 23, 126221, 42.2937, 0.738164317850726, -71.5312, -1.24845495790257),
(483, '01773', 218, 23, 3781, 42.4247, 0.740450699170838, -71.3129, -1.24464490414546),
(484, '01775', 218, 23, 126272, 42.4272, 0.740494332402138, -71.5128, -1.2481338173202),
(485, '01776', 218, 23, 126281, 42.3831, 0.739724642202009, -71.4293, -1.24667646739479),
(486, '01778', 218, 23, 38772, 42.3471, 0.739096323671291, -71.3589, -1.24544775560138),
(487, '01784', 218, 23, 6954, 42.2321, 0.737089195031497, -71.5585, -1.24893143278836),
(488, '01801', 218, 23, 29012, 42.4852, 0.741506623368295, -71.1569, -1.24192219051235),
(489, '01803', 218, 23, 1239, 42.5085, 0.74191328508401, -71.2014, -1.24269886202949),
(490, '01805', 218, 23, 1239, 42.5061, 0.741871397181962, -71.1963, -1.24260985023764),
(491, '01806', 218, 23, 29012, 42.5062, 0.741873142511214, -71.126, -1.24138288377349),
(492, '01807', 218, 23, 29012, 42.5061, 0.741871397181962, -71.1262, -1.24138637443199),
(493, '01808', 218, 23, 29012, 42.5062, 0.741873142511214, -71.1258, -1.24137939311498),
(494, '01810', 218, 23, 14988, 42.6479, 0.74434627406129, -71.1619, -1.24200945697495),
(495, '01812', 218, 23, 14988, 42.6485, 0.744356746036802, -71.182, -1.2423602681546),
(496, '01813', 218, 23, 29012, 42.5063, 0.741874887840466, -71.1256, -1.24137590245648),
(497, '01815', 218, 23, 29012, 42.5062, 0.741873142511214, -71.1254, -1.24137241179797),
(498, '01821', 218, 23, 124249, 42.5487, 0.742614907443311, -71.2486, -1.24352265743643),
(499, '01822', 218, 23, 124249, 42.5411, 0.74248226242016, -71.2628, -1.24377049419022),
(500, '01824', 218, 23, 124498, 42.595, 0.743422994886985, -71.3566, -1.24540761302859),
(501, '01826', 218, 23, 124658, 42.6775, 0.74486289151988, -71.3144, -1.24467108408424),
(502, '01827', 218, 23, 124670, 42.6711, 0.744751190447752, -71.4955, -1.24783187535961),
(503, '01830', 218, 23, 16381, 42.7802, 0.746655344661678, -71.0837, -1.24064460949989),
(504, '01831', 218, 23, 16381, 42.7847, 0.746733884478018, -71.086, -1.24068475207269),
(505, '01832', 218, 23, 16381, 42.7794, 0.746641382027662, -71.1178, -1.24123976677482),
(506, '01833', 218, 23, 2693, 42.7294, 0.745768717401665, -70.9886, -1.23898480138125),
(507, '01834', 218, 23, 16295, 42.7546, 0.746208540373168, -71.0286, -1.23968293308204),
(508, '01835', 218, 23, 16381, 42.7576, 0.746260900250727, -71.086, -1.24068475207269),
(509, '01840', 218, 23, 3696, 42.7081, 0.74539696227099, -71.1635, -1.24203738224298),
(510, '01841', 218, 23, 3696, 42.7114, 0.745454558136306, -71.1665, -1.24208974212054),
(511, '01842', 218, 23, 3696, 42.7065, 0.745369037002958, -71.1613, -1.24199898499944),
(512, '01843', 218, 23, 3696, 42.6896, 0.745074076359371, -71.1624, -1.24201818362121),
(513, '01844', 218, 23, 125407, 42.7286, 0.745754754767649, -71.1802, -1.24232885222807),
(514, '01845', 218, 23, 113073, 42.6847, 0.744988555226024, -71.1066, -1.2410442898986),
(515, '01850', 218, 23, 10211, 42.6558, 0.744484155072197, -71.3049, -1.2445052778053),
(516, '01851', 218, 23, 10211, 42.6301, 0.744035605454435, -71.3322, -1.2449817526911),
(517, '01852', 218, 23, 10211, 42.6337, 0.744098437307506, -71.2972, -1.2443708874529),
(518, '01853', 218, 23, 10211, 42.6562, 0.744491136389205, -71.3034, -1.24447909786652),
(519, '01854', 218, 23, 10211, 42.6488, 0.744361982024558, -71.3355, -1.24503934855641),
(520, '01860', 218, 23, 17098, 42.8334, 0.747583859823739, -71.0055, -1.23927976202483),
(521, '01862', 218, 23, 125590, 42.5733, 0.743044258439302, -71.2842, -1.24414399465014),
(522, '01863', 218, 23, 125598, 42.6325, 0.744077493356483, -71.3876, -1.2459486650967),
(523, '01864', 218, 23, 125646, 42.5817, 0.743190866096469, -71.0956, -1.24085230368088),
(524, '01865', 218, 23, 125700, 42.533, 0.742340890750748, -71.2682, -1.24386474196982),
(525, '01866', 218, 23, 23951, 42.5252, 0.742204755069093, -71.2276, -1.24315613829351),
(526, '01867', 218, 23, 33727, 42.5275, 0.742244897641889, -71.1091, -1.2410879231299),
(527, '01876', 218, 23, 126327, 42.6013, 0.74353295062986, -71.2226, -1.24306887183091),
(528, '01879', 218, 23, 126379, 42.6716, 0.744759917094012, -71.415, -1.24642688531175),
(529, '01880', 218, 23, 831, 42.5013, 0.741787621377866, -71.0687, -1.24038281011209),
(530, '01885', 218, 23, 126497, 42.7086, 0.74540568891725, -71.0569, -1.24017686126036),
(531, '01886', 218, 23, 114274, 42.5894, 0.743325256448873, -71.4372, -1.24681434840569),
(532, '01887', 218, 23, 14869, 42.5575, 0.742768496417487, -71.1731, -1.24220493385118),
(533, '01888', 218, 23, 29012, 42.4867, 0.741532803307075, -71.1551, -1.24189077458582),
(534, '01889', 218, 23, 125646, 42.5721, 0.743023314488278, -71.1094, -1.24109315911766),
(535, '01890', 218, 23, 12894, 42.4528, 0.740941136690649, -71.1471, -1.24175114824566),
(536, '01899', 218, 23, 14988, 42.6489, 0.74436372735381, -71.1815, -1.24235154150834),
(537, '01901', 218, 23, 3914, 42.4632, 0.741122650932856, -70.9452, -1.23822732848588),
(538, '01902', 218, 23, 3914, 42.4702, 0.741244823980496, -70.9436, -1.23819940321785),
(539, '01903', 218, 23, 3914, 42.4634, 0.74112614159136, -70.9479, -1.23827445237569),
(540, '01904', 218, 23, 3914, 42.4885, 0.741564219233611, -70.9636, -1.23854846906825),
(541, '01905', 218, 23, 3914, 42.4654, 0.7411610481764, -70.974, -1.23872998331046),
(542, '01906', 218, 23, 126033, 42.464, 0.741136613566872, -71.0121, -1.23939495375547),
(543, '01907', 218, 23, 126299, 42.4734, 0.74130067451656, -70.9078, -1.23757457534564),
(544, '01908', 218, 23, 116975, 42.4263, 0.74047862443887, -70.9257, -1.23788698928174),
(545, '01910', 218, 23, 3914, 42.4742, 0.741314637150576, -70.9627, -1.23853276110498),
(546, '01913', 218, 23, 124106, 42.8543, 0.747948633637406, -70.9375, -1.23809293813348),
(547, '01915', 218, 23, 7444, 42.5609, 0.742827837612055, -70.8719, -1.23694800214417),
(548, '01921', 218, 23, 124283, 42.6758, 0.744833220922596, -71.0045, -1.23926230873231),
(549, '01922', 218, 23, 124365, 42.759, 0.746285334860255, -70.9329, -1.23801265298789),
(550, '01923', 218, 23, 119312, 42.5692, 0.74297269993997, -70.9453, -1.23822907381513),
(551, '01929', 218, 23, 8781, 42.6293, 0.744021642820419, -70.7797, -1.23533880857383),
(552, '01930', 218, 23, 65078, 42.6243, 0.743934376357819, -70.6728, -1.23347305160345),
(553, '01931', 218, 23, 65078, 42.6315, 0.744060040063963, -70.6831, -1.2336528205164),
(554, '01936', 218, 23, 2950, 42.6369, 0.74415428784357, -70.8558, -1.2366670041346),
(555, '01937', 218, 23, 125045, 42.5892, 0.743321765790369, -70.9765, -1.23877361654176),
(556, '01938', 218, 23, 125144, 42.6817, 0.744936195348464, -70.847, -1.23651341516042),
(557, '01940', 218, 23, 14160, 42.5369, 0.742408958591576, -71.0276, -1.23966547978952),
(558, '01944', 218, 23, 585, 42.578, 0.743126288914146, -70.7686, -1.23514507702686),
(559, '01945', 218, 23, 27795, 42.4979, 0.741728280183298, -70.8652, -1.23683106508429),
(560, '01949', 218, 23, 4185, 42.5938, 0.743402050935961, -71.0133, -1.23941589770649),
(561, '01950', 218, 23, 125552, 42.8111, 0.747194651400544, -70.8776, -1.23704748591153),
(562, '01951', 218, 23, 33420, 42.7948, 0.746910162732469, -70.8407, -1.23640345941755),
(563, '01952', 218, 23, 28524, 42.8502, 0.747877075138074, -70.8589, -1.23672110934141),
(564, '01960', 218, 23, 28209, 42.5337, 0.742353108055512, -70.9706, -1.23867064211589),
(565, '01961', 218, 23, 28209, 42.5334, 0.742347872067756, -70.9703, -1.23866540612813),
(566, '01965', 218, 23, 125888, 42.5582, 0.742780713722251, -70.8323, -1.23625685176038),
(567, '01966', 218, 23, 11639, 42.6594, 0.744546986925269, -70.6175, -1.2325078845271),
(568, '01969', 218, 23, 117618, 42.7187, 0.745581967171702, -70.8967, -1.23738084379866),
(569, '01970', 218, 23, 126, 42.5162, 0.742047675436413, -70.903, -1.23749079954154),
(570, '01971', 218, 23, 126, 42.5268, 0.742232680337125, -70.8694, -1.23690436891287),
(571, '01982', 218, 23, 74351, 42.62, 0.743859327199983, -70.8632, -1.23679615849925),
(572, '01983', 218, 23, 126354, 42.6407, 0.744220610355146, -70.9473, -1.23826398040017),
(573, '01984', 218, 23, 126483, 42.6036, 0.743573093202656, -70.8888, -1.23724296278776),
(574, '01985', 218, 23, 126544, 42.7917, 0.746856057525658, -70.9748, -1.23874394594447),
(575, '02018', 218, 23, 124077, 42.1756, 0.736103084004121, -70.8893, -1.23725168943402),
(576, '02019', 218, 23, 79738, 42.0688, 0.734239072362991, -71.4767, -1.24750375346023),
(577, '02020', 218, 23, 124298, 42.0855, 0.734530542348074, -70.6473, -1.23302799264419),
(578, '02021', 218, 23, 19763, 42.1666, 0.735946004371441, -71.132, -1.24148760352861),
(579, '02025', 218, 23, 45880, 42.2413, 0.737249765322681, -70.8117, -1.23589731393447),
(580, '02026', 218, 23, 115227, 42.2435, 0.737288162566225, -71.1669, -1.24209672343755),
(581, '02027', 218, 23, 115227, 42.2466, 0.737342267773036, -71.1795, -1.2423166349233),
(582, '02030', 218, 23, 8583, 42.2373, 0.737179952152601, -71.2838, -1.24413701333313);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(583, '02031', 218, 23, 124719, 42.0141, 0.73328437726215, -71.1857, -1.24242484533693),
(584, '02032', 218, 23, 124747, 42.1537, 0.735720856897934, -71.2177, -1.24298335069757),
(585, '02035', 218, 23, 21272, 42.0652, 0.734176240509919, -71.2417, -1.24340222971804),
(586, '02038', 218, 23, 2595, 42.0922, 0.734647479407957, -71.4031, -1.24621919113076),
(587, '02040', 218, 23, 32623, 42.1789, 0.736160679869436, -70.7496, -1.23481346446898),
(588, '02041', 218, 23, 124968, 42.072, 0.734294922899054, -70.6536, -1.23313794838707),
(589, '02043', 218, 23, 125079, 42.226, 0.736982729947126, -70.8883, -1.2372342361415),
(590, '02044', 218, 23, 125079, 42.2425, 0.737270709273705, -70.891, -1.2372813600313),
(591, '02045', 218, 23, 3279, 42.2287, 0.73702985383693, -70.8363, -1.23632666493046),
(592, '02047', 218, 23, 125122, 42.1384, 0.735453821522378, -70.692, -1.23380815481983),
(593, '02048', 218, 23, 3975, 42.0217, 0.733417022285301, -71.2202, -1.24302698392887),
(594, '02050', 218, 23, 30448, 42.1289, 0.735288015243439, -70.7372, -1.23459704364173),
(595, '02051', 218, 23, 125345, 42.1458, 0.735582975887026, -70.7245, -1.23437538682673),
(596, '02052', 218, 23, 66763, 42.1807, 0.736192095795972, -71.3041, -1.24449131517129),
(597, '02053', 218, 23, 73428, 42.1443, 0.735556795948246, -71.4094, -1.24632914687364),
(598, '02054', 218, 23, 125438, 42.1672, 0.735956476346953, -71.3591, -1.24545124625989),
(599, '02055', 218, 23, 60909, 42.2407, 0.737239293347169, -70.7628, -1.23504384793024),
(600, '02056', 218, 23, 61085, 42.1162, 0.735066358428436, -71.3308, -1.24495731808157),
(601, '02059', 218, 23, 125630, 42.1429, 0.735532361338718, -70.7703, -1.23517474762414),
(602, '02060', 218, 23, 125653, 42.1903, 0.736359647404164, -71.2029, -1.24272504196827),
(603, '02061', 218, 23, 125693, 42.1583, 0.735801142043525, -70.8202, -1.23604566692089),
(604, '02062', 218, 23, 4648, 42.1862, 0.736288088904832, -71.2022, -1.24271282466351),
(605, '02065', 218, 23, 125720, 42.0765, 0.734373462715394, -70.6674, -1.23337880382384),
(606, '02066', 218, 23, 126042, 42.2004, 0.736535925658615, -70.747, -1.23476808590843),
(607, '02067', 218, 23, 24789, 42.1122, 0.734996545258356, -71.1782, -1.24229394564303),
(608, '02070', 218, 23, 126079, 42.0338, 0.733628207124792, -71.3865, -1.24592946647493),
(609, '02071', 218, 23, 126227, 42.1013, 0.734806304369889, -71.2716, -1.24392408316439),
(610, '02072', 218, 23, 126269, 42.1248, 0.735216456744107, -71.1094, -1.24109315911766),
(611, '02081', 218, 23, 28895, 42.1457, 0.735581230557774, -71.2538, -1.24361341455754),
(612, '02090', 218, 23, 6753, 42.2162, 0.73681168768043, -71.2079, -1.24281230843087),
(613, '02093', 218, 23, 126714, 42.0597, 0.734080247401059, -71.3406, -1.24512836034827),
(614, '02101', 218, 23, 1061, 42.3702, 0.739499494728501, -71.0277, -1.23966722511878),
(615, '02102', 218, 23, 1061, 42.3621, 0.73935812305909, -71.0499, -1.24005468821272),
(616, '02103', 218, 23, 1061, 42.3624, 0.739363359046846, -71.0503, -1.24006166952973),
(617, '02104', 218, 23, 1061, 42.362, 0.739356377729838, -71.0501, -1.24005817887122),
(618, '02105', 218, 23, 1061, 42.3622, 0.739359868388342, -71.0498, -1.24005294288347),
(619, '02106', 218, 23, 1061, 42.3576, 0.73927958324275, -71.0576, -1.24018907856512),
(620, '02107', 218, 23, 1061, 42.3548, 0.739230714023694, -71.059, -1.24021351317465),
(621, '02108', 218, 23, 1061, 42.3573, 0.739274347254994, -71.0693, -1.24039328208761),
(622, '02109', 218, 23, 1061, 42.3611, 0.73934066976657, -71.06, -1.24023096646717),
(623, '02110', 218, 23, 1061, 42.3557, 0.739246421986962, -71.0525, -1.24010006677327),
(624, '02111', 218, 23, 1061, 42.3516, 0.73917486348763, -71.0607, -1.24024318377193),
(625, '02112', 218, 23, 1061, 42.336, 0.738902592124319, -71.0182, -1.23950141883984),
(626, '02113', 218, 23, 1061, 42.3652, 0.739412228265902, -71.0555, -1.24015242665083),
(627, '02114', 218, 23, 1061, 42.3617, 0.739351141742082, -71.0663, -1.24034092221005),
(628, '02115', 218, 23, 1061, 42.3418, 0.739003821220935, -71.0971, -1.24087848361966),
(629, '02116', 218, 23, 1061, 42.3485, 0.739120758280819, -71.0733, -1.24046309525769),
(630, '02117', 218, 23, 1061, 42.3418, 0.739003821220935, -71.0734, -1.24046484058694),
(631, '02118', 218, 23, 1061, 42.3377, 0.738932262721603, -71.0738, -1.24047182190395),
(632, '02119', 218, 23, 1061, 42.3242, 0.738696643272584, -71.0865, -1.24069347871895),
(633, '02120', 218, 23, 1061, 42.3324, 0.738839760271248, -71.0962, -1.24086277565639),
(634, '02121', 218, 23, 1061, 42.3079, 0.738412154604509, -71.0821, -1.24061668423186),
(635, '02122', 218, 23, 1061, 42.2961, 0.738206205752774, -71.0555, -1.24015242665083),
(636, '02123', 218, 23, 1061, 42.3469, 0.739092833012787, -71.0874, -1.24070918668222),
(637, '02124', 218, 23, 1061, 42.2873, 0.738052616778598, -71.0715, -1.24043167933115),
(638, '02125', 218, 23, 1061, 42.3164, 0.738560507590929, -71.0621, -1.24026761838146),
(639, '02126', 218, 23, 125360, 42.2736, 0.737813506671075, -71.0918, -1.2407859811693),
(640, '02127', 218, 23, 1061, 42.3354, 0.738892120148807, -71.0464, -1.2399936016889),
(641, '02128', 218, 23, 1061, 42.3848, 0.739754312799293, -71.0178, -1.23949443752283),
(642, '02129', 218, 23, 29458, 42.3773, 0.739623413105393, -71.0673, -1.24035837550257),
(643, '02130', 218, 23, 125152, 42.3119, 0.738481967774589, -71.1103, -1.24110886708092),
(644, '02131', 218, 23, 125990, 42.2845, 0.738003747559542, -71.1275, -1.24140906371227),
(645, '02132', 218, 23, 126576, 42.2786, 0.737900773133675, -71.1581, -1.24194313446338),
(646, '02133', 218, 23, 1061, 42.3561, 0.73925340330397, -71.0661, -1.24033743155154),
(647, '02134', 218, 23, 124104, 42.3556, 0.73924467665771, -71.1321, -1.24148934885786),
(648, '02135', 218, 23, 212, 42.3503, 0.739152174207354, -71.1558, -1.24190299189058),
(649, '02136', 218, 23, 3310, 42.2537, 0.737466186149928, -71.1278, -1.24141429970002),
(650, '02137', 218, 23, 125926, 42.2372, 0.737178206823349, -71.1314, -1.24147713155309),
(651, '02138', 218, 23, 1302, 42.3788, 0.739649593044173, -71.1304, -1.24145967826057),
(652, '02139', 218, 23, 1302, 42.3648, 0.739405246948894, -71.105, -1.24101636463057),
(653, '02140', 218, 23, 1302, 42.3925, 0.739888703151696, -71.1295, -1.24144397029731),
(654, '02141', 218, 23, 1302, 42.3703, 0.739501240057753, -71.0816, -1.2406079575856),
(655, '02142', 218, 23, 1302, 42.3639, 0.739389538985626, -71.0853, -1.24067253476793),
(656, '02143', 218, 23, 5947, 42.3819, 0.739703698250985, -71.1017, -1.24095876876525),
(657, '02144', 218, 23, 5947, 42.399, 0.740002149553076, -71.1215, -1.24130434395715),
(658, '02145', 218, 23, 5947, 42.3908, 0.739859032554412, -71.0938, -1.24082088775434),
(659, '02148', 218, 23, 56057, 42.4294, 0.740532729645682, -71.0585, -1.24020478652839),
(660, '02149', 218, 23, 20957, 42.411, 0.740211589063315, -71.0512, -1.240077377493),
(661, '02150', 218, 23, 1509, 42.3963, 0.739955025663272, -71.0346, -1.23978765283716),
(662, '02151', 218, 23, 68172, 42.4165, 0.740307582172175, -71.0064, -1.2392954699881),
(663, '02152', 218, 23, 12913, 42.3749, 0.739581525203345, -70.9814, -1.2388591376751),
(664, '02153', 218, 23, 49404, 42.423, 0.740421028573554, -71.1088, -1.24108268714214),
(665, '02155', 218, 23, 49404, 42.4192, 0.740354706061979, -71.111, -1.24112108438569),
(666, '02156', 218, 23, 126539, 42.4234, 0.740428009890562, -71.1304, -1.24145967826057),
(667, '02163', 218, 23, 1061, 42.3667, 0.739438408204682, -71.1218, -1.2413095799449),
(668, '02169', 218, 23, 17745, 42.2408, 0.737241038676421, -71.0138, -1.23942462435275),
(669, '02170', 218, 23, 17745, 42.2674, 0.737705296257451, -71.0172, -1.23948396554732),
(670, '02171', 218, 23, 17745, 42.2837, 0.737989784925526, -71.0246, -1.23961311991196),
(671, '02176', 218, 23, 4153, 42.4583, 0.741037129799508, -71.0605, -1.24023969311343),
(672, '02177', 218, 23, 4153, 42.4548, 0.740976043275689, -71.0591, -1.2402152585039),
(673, '02180', 218, 23, 98312, 42.4818, 0.741447282173727, -71.0955, -1.24085055835163),
(674, '02184', 218, 23, 124293, 42.2098, 0.736699986608302, -70.9988, -1.23916282496495),
(675, '02185', 218, 23, 124293, 42.2024, 0.736570832243655, -71.0035, -1.23924485543979),
(676, '02186', 218, 23, 4232, 42.2525, 0.737445242198904, -71.0769, -1.24052592711076),
(677, '02187', 218, 23, 125446, 42.2645, 0.737654681709143, -71.0797, -1.24057479632981),
(678, '02188', 218, 23, 71559, 42.2114, 0.736727911876334, -70.9576, -1.23844374931313),
(679, '02189', 218, 23, 71559, 42.2124, 0.736745365168854, -70.9319, -1.23799519969537),
(680, '02190', 218, 23, 71559, 42.1712, 0.736026289517033, -70.9478, -1.23827270704643),
(681, '02191', 218, 23, 71559, 42.2406, 0.737237548017917, -70.945, -1.23822383782738),
(682, '02196', 218, 23, 1061, 42.3487, 0.739124248939323, -71.0606, -1.24024143844268),
(683, '02199', 218, 23, 1061, 42.3471, 0.739096323671291, -71.0821, -1.24061668423186),
(684, '02201', 218, 23, 1061, 42.359, 0.739304017852278, -71.0573, -1.24018384257737),
(685, '02202', 218, 23, 1061, 42.3633, 0.739379067010114, -71.0669, -1.24035139418556),
(686, '02203', 218, 23, 1061, 42.3638, 0.739387793656374, -71.0672, -1.24035663017331),
(687, '02204', 218, 23, 1061, 42.3644, 0.739398265631886, -71.0721, -1.24044215130666),
(688, '02205', 218, 23, 1061, 42.3582, 0.739290055218262, -71.0606, -1.24024143844268),
(689, '02206', 218, 23, 1061, 42.3475, 0.739103304988299, -71.0399, -1.23988015528752),
(690, '02207', 218, 23, 1061, 42.3552, 0.739237695340702, -71.0547, -1.24013846401681),
(691, '02208', 218, 23, 1061, 42.3576, 0.73927958324275, -71.0571, -1.24018035191886),
(692, '02209', 218, 23, 1061, 42.3569, 0.739267365937986, -71.0574, -1.24018558790662),
(693, '02210', 218, 23, 1061, 42.3471, 0.739096323671291, -71.0422, -1.23992029786032),
(694, '02211', 218, 23, 1061, 42.3581, 0.73928830988901, -71.0573, -1.24018384257737),
(695, '02212', 218, 23, 1061, 42.358, 0.739286564559758, -71.0575, -1.24018733323587),
(696, '02215', 218, 23, 1061, 42.346, 0.739077125049519, -71.1032, -1.24098494870403),
(697, '02216', 218, 23, 1061, 42.358, 0.739286564559758, -71.0568, -1.24017511593111),
(698, '02217', 218, 23, 1061, 42.3494, 0.739136466244087, -71.0748, -1.24048927519647),
(699, '02222', 218, 23, 1061, 42.3631, 0.73937557635161, -71.0672, -1.24035663017331),
(700, '02228', 218, 23, 124682, 42.3583, 0.739291800547514, -71.0607, -1.24024318377193),
(701, '02238', 218, 23, 1302, 42.376, 0.739600723825117, -71.119, -1.24126071072585),
(702, '02239', 218, 23, 1302, 42.3762, 0.739604214483621, -71.1187, -1.24125547473809),
(703, '02241', 218, 23, 1061, 42.355, 0.739234204682198, -71.0564, -1.2401681346141),
(704, '02266', 218, 23, 1061, 42.3503, 0.739152174207354, -71.0595, -1.24022223982091),
(705, '02269', 218, 23, 17745, 42.2509, 0.737417316930872, -71.0024, -1.23922565681802),
(706, '02283', 218, 23, 1061, 42.3489, 0.739127739597827, -71.0561, -1.24016289862634),
(707, '02284', 218, 23, 1061, 42.3487, 0.739124248939323, -71.0552, -1.24014719066307),
(708, '02293', 218, 23, 1061, 42.3582, 0.739290055218262, -71.0602, -1.24023445712567),
(709, '02295', 218, 23, 1061, 42.3499, 0.739145192890347, -71.0765, -1.24051894579375),
(710, '02297', 218, 23, 1061, 42.3588, 0.739300527193774, -71.06, -1.24023096646717),
(711, '02301', 218, 23, 19523, 42.0886, 0.734584647554885, -71.0377, -1.23984175804398),
(712, '02302', 218, 23, 19523, 42.0849, 0.734520070372562, -71, -1.23918376891597),
(713, '02303', 218, 23, 19523, 42.0821, 0.734471201153506, -71.016, -1.23946302159629),
(714, '02304', 218, 23, 19523, 42.081, 0.734452002531734, -71.0254, -1.23962708254598),
(715, '02305', 218, 23, 19523, 42.0806, 0.734445021214726, -71.0253, -1.23962533721673),
(716, '02322', 218, 23, 7208, 42.1246, 0.735212966085603, -71.0462, -1.2399901110304),
(717, '02324', 218, 23, 19494, 41.9781, 0.732656058731432, -70.9749, -1.23874569127372),
(718, '02325', 218, 23, 19494, 41.9887, 0.732841063632143, -70.9708, -1.23867413277439),
(719, '02327', 218, 23, 124346, 42.0432, 0.73379226807448, -70.8352, -1.23630746630869),
(720, '02330', 218, 23, 7933, 41.881, 0.730961344027745, -70.7698, -1.23516602097788),
(721, '02331', 218, 23, 124672, 42.0325, 0.733605517844517, -70.6923, -1.23381339080759),
(722, '02332', 218, 23, 124672, 42.0396, 0.733729436221408, -70.7099, -1.23412056875594),
(723, '02333', 218, 23, 124685, 42.0298, 0.733558393954713, -70.9438, -1.23820289387635),
(724, '02334', 218, 23, 2193, 42.0244, 0.733464146175105, -71.1275, -1.24140906371227),
(725, '02337', 218, 23, 8746, 42.0121, 0.73324947067711, -70.9613, -1.23850832649545),
(726, '02338', 218, 23, 21675, 41.9996, 0.73303130452061, -70.8503, -1.23657101102574),
(727, '02339', 218, 23, 2963, 42.132, 0.735342120450251, -70.8465, -1.23650468851416),
(728, '02340', 218, 23, 2963, 42.1136, 0.735020979867884, -70.8129, -1.23591825788549),
(729, '02341', 218, 23, 2964, 42.0589, 0.734066284767043, -70.8659, -1.23684328238905),
(730, '02343', 218, 23, 21986, 42.1473, 0.735609155825806, -71.0108, -1.23937226447519),
(731, '02344', 218, 23, 30510, 41.8935, 0.731179510184245, -70.9191, -1.23777179755111),
(732, '02345', 218, 23, 125313, 41.9032, 0.731348807121688, -70.5511, -1.23134898590377),
(733, '02346', 218, 23, 30510, 41.884, 0.731013703905305, -70.8868, -1.23720805620272),
(734, '02347', 218, 23, 16832, 41.8323, 0.730111368682024, -70.9541, -1.23838266278931),
(735, '02348', 218, 23, 30510, 41.876, 0.730874077565145, -70.9436, -1.23819940321785),
(736, '02349', 218, 23, 30510, 41.8732, 0.73082520834609, -70.9119, -1.23764613384497),
(737, '02350', 218, 23, 125454, 42.0167, 0.733329755822701, -70.8479, -1.23652912312369),
(738, '02351', 218, 23, 29060, 42.117, 0.735080321062452, -70.9549, -1.23839662542332),
(739, '02355', 218, 23, 125596, 41.9202, 0.731645513094527, -70.7985, -1.23566693047321),
(740, '02356', 218, 23, 49860, 42.0582, 0.734054067462279, -71.1148, -1.24118740689726),
(741, '02357', 218, 23, 49860, 42.0582, 0.734054067462279, -71.078, -1.24054512573253),
(742, '02358', 218, 23, 125639, 42.0974, 0.734738236529061, -70.7871, -1.23546796293848),
(743, '02359', 218, 23, 17567, 42.0613, 0.734108172669091, -70.8054, -1.23578735819159),
(744, '02360', 218, 23, 14433, 41.8999, 0.731291211256372, -70.6302, -1.2327295413421),
(745, '02361', 218, 23, 14433, 41.9238, 0.731708344947599, -70.6571, -1.23319903491089),
(746, '02362', 218, 23, 14433, 41.9585, 0.732313974198041, -70.6639, -1.23331771730002),
(747, '02364', 218, 23, 3542, 41.9944, 0.732940547399507, -70.7368, -1.23459006232473),
(748, '02366', 218, 23, 126143, 41.843, 0.730298118911987, -70.7453, -1.23473841531114),
(749, '02367', 218, 23, 125856, 41.9576, 0.732298266234773, -70.8066, -1.23580830214262),
(750, '02368', 218, 23, 5293, 42.1738, 0.736071668077585, -71.049, -1.24003898024945),
(751, '02370', 218, 23, 187, 42.1314, 0.735331648474739, -70.91, -1.23761297258918),
(752, '02375', 218, 23, 126152, 42.0274, 0.733516506052665, -71.1019, -1.24096225942376),
(753, '02379', 218, 23, 126503, 42.0213, 0.733410040968293, -71.0167, -1.23947523890106),
(754, '02381', 218, 23, 126632, 41.9307, 0.731828772665986, -70.5626, -1.23154969876775),
(755, '02382', 218, 23, 34417, 42.0826, 0.734479927799766, -70.9373, -1.23808944747497),
(756, '02420', 218, 23, 3748, 42.4571, 0.741016185848484, -71.2166, -1.24296415207579),
(757, '02421', 218, 23, 3748, 42.4452, 0.740808491667497, -71.2363, -1.24330798193844),
(758, '02445', 218, 23, 53672, 42.3289, 0.738778673747428, -71.1309, -1.24146840490683),
(759, '02446', 218, 23, 53672, 42.3432, 0.739028255830463, -71.1227, -1.24132528790817),
(760, '02447', 218, 23, 124331, 42.3335, 0.73885895889302, -71.1203, -1.24128340000612),
(761, '02451', 218, 23, 121846, 42.3989, 0.740000404223824, -71.2589, -1.24370242634939),
(762, '02452', 218, 23, 121846, 42.3948, 0.739928845724492, -71.217, -1.2429711333928),
(763, '02453', 218, 23, 121846, 42.37, 0.739496004069997, -71.2354, -1.24329227397517),
(764, '02454', 218, 23, 121846, 42.3764, 0.739607705142125, -71.2394, -1.24336208714525),
(765, '02455', 218, 23, 0, 42.3583, 0.739291800547514, -71.0603, -1.24023620245493),
(766, '02456', 218, 23, 710, 42.3318, 0.738829288295736, -71.2068, -1.2427931098091),
(767, '02457', 218, 23, 15070, 42.2982, 0.738242857667066, -71.2603, -1.24372686095892),
(768, '02458', 218, 23, 4570, 42.3535, 0.739208024743418, -71.1886, -1.24247545988524),
(769, '02459', 218, 23, 125557, 42.3113, 0.738471495799077, -71.1952, -1.24259065161587),
(770, '02460', 218, 23, 4572, 42.3523, 0.739187080792394, -71.2076, -1.24280707244311),
(771, '02461', 218, 23, 125559, 42.3159, 0.738551780944668, -71.2069, -1.24279485513835),
(772, '02462', 218, 23, 125560, 42.3317, 0.738827542966484, -71.2562, -1.24365530245958),
(773, '02464', 218, 23, 125561, 42.3125, 0.738492439750101, -71.2191, -1.24300778530709),
(774, '02465', 218, 23, 31494, 42.3501, 0.739148683548851, -71.2264, -1.24313519434249),
(775, '02466', 218, 23, 15052, 42.3446, 0.739052690439991, -71.2477, -1.24350694947316),
(776, '02467', 218, 23, 20014, 42.3189, 0.738604140822228, -71.157, -1.24192393584161),
(777, '02468', 218, 23, 126410, 42.3269, 0.738743767162388, -71.2316, -1.24322595146359),
(778, '02471', 218, 23, 18507, 42.3696, 0.739489022752989, -71.1781, -1.24229220031378),
(779, '02472', 218, 23, 18507, 42.3715, 0.739522184008777, -71.1782, -1.24229394564303),
(780, '02474', 218, 23, 15026, 42.4225, 0.740412301927294, -71.1564, -1.24191346386609),
(781, '02475', 218, 23, 26394, 42.4206, 0.740379140671507, -71.181, -1.24234281486208),
(782, '02476', 218, 23, 15026, 42.4137, 0.740258712953119, -71.1774, -1.24227998300901),
(783, '02477', 218, 23, 18507, 42.3736, 0.739558835923069, -71.1537, -1.24186633997629),
(784, '02478', 218, 23, 303, 42.395, 0.739932336382996, -71.1818, -1.2423567774961),
(785, '02479', 218, 23, 126459, 42.3879, 0.739808418006104, -71.1889, -1.24248069587299),
(786, '02481', 218, 23, 126473, 42.3158, 0.738550035615417, -71.2654, -1.24381587275077),
(787, '02482', 218, 23, 126470, 42.2918, 0.738131156594938, -71.2985, -1.24439357673318),
(788, '02492', 218, 23, 4495, 42.2777, 0.737885065170407, -71.2446, -1.24345284426635),
(789, '02493', 218, 23, 6746, 42.3661, 0.73942793622917, -71.3024, -1.244461644574),
(790, '02494', 218, 23, 125524, 42.3011, 0.738293472215373, -71.2312, -1.24321897014658),
(791, '02495', 218, 23, 125568, 42.3315, 0.73882405230798, -71.2071, -1.24279834579685),
(792, '02532', 218, 23, 124364, 41.7512, 0.728695906658656, -70.5902, -1.2320314096413),
(793, '02534', 218, 23, 124457, 41.6665, 0.727217612782217, -70.613, -1.23242934471076),
(794, '02535', 218, 23, 124520, 41.3356, 0.721442318287368, -70.7471, -1.23476983123768),
(795, '02536', 218, 23, 113059, 41.5829, 0.72575851752755, -70.5635, -1.23156540673102),
(796, '02537', 218, 23, 124735, 41.7273, 0.72827877296743, -70.4385, -1.22938374516603),
(797, '02538', 218, 23, 124748, 41.7817, 0.729228232080515, -70.6503, -1.23308035252175),
(798, '02539', 218, 23, 124773, 41.3888, 0.722370833449429, -70.53, -1.2309807214316),
(799, '02540', 218, 23, 15986, 41.563, 0.725411197006403, -70.6231, -1.23260562296521),
(800, '02541', 218, 23, 15986, 41.5547, 0.725266334678488, -70.6302, -1.2327295413421),
(801, '02542', 218, 23, 124364, 41.6578, 0.727065769137294, -70.5788, -1.23183244210657),
(802, '02543', 218, 23, 126701, 41.526, 0.724765425183165, -70.665, -1.23333691592179),
(803, '02552', 218, 23, 125396, 41.3546, 0.721773930845247, -70.7403, -1.23465114884854),
(804, '02553', 218, 23, 125473, 41.7166, 0.728092022737466, -70.612, -1.23241189141824),
(805, '02554', 218, 23, 49743, 41.2763, 0.720407338040935, -70.0917, -1.22333094332011),
(806, '02556', 218, 23, 125614, 41.6471, 0.72687901890733, -70.6275, -1.2326824174523),
(807, '02557', 218, 23, 125702, 41.454, 0.723508788121729, -70.5625, -1.2315479534385),
(808, '02558', 218, 23, 125742, 41.746, 0.728605149537553, -70.6592, -1.23323568682518),
(809, '02559', 218, 23, 76970, 41.6906, 0.727638237131948, -70.6165, -1.23249043123458),
(810, '02561', 218, 23, 24592, 41.771, 0.729041481850551, -70.5369, -1.23110114914999),
(811, '02562', 218, 23, 126010, 41.7952, 0.729463851529534, -70.528, -1.23094581484656),
(812, '02563', 218, 23, 121362, 41.7248, 0.72823513973613, -70.4807, -1.23012027411037),
(813, '02564', 218, 23, 126100, 41.2629, 0.720173463921168, -69.982, -1.22141631713067),
(814, '02565', 218, 23, 71393, 41.6395, 0.726746373884179, -70.6445, -1.23297912342513),
(815, '02568', 218, 23, 126406, 41.4495, 0.72343024830539, -70.6049, -1.23228797304134),
(816, '02571', 218, 23, 113084, 41.7501, 0.728676708036885, -70.7106, -1.2341327860607),
(817, '02573', 218, 23, 126508, 41.4451, 0.723353453818302, -70.6008, -1.23221641454201),
(818, '02574', 218, 23, 126519, 41.6015, 0.726083148768421, -70.64, -1.23290058360879),
(819, '02575', 218, 23, 126569, 41.4011, 0.722585508947424, -70.6286, -1.23270161607407),
(820, '02576', 218, 23, 126579, 41.7726, 0.729069407118583, -70.7587, -1.23497228943091),
(821, '02584', 218, 23, 49743, 41.2641, 0.720194407872192, -70.0564, -1.22271484209416),
(822, '02601', 218, 23, 199417, 41.6525, 0.726973266686938, -70.2955, -1.22688792433567),
(823, '02630', 218, 23, 124181, 41.6997, 0.727797062093879, -70.3005, -1.22697519079827),
(824, '02631', 218, 23, 15318, 41.7517, 0.728704633304917, -70.0742, -1.22302551070101),
(825, '02632', 218, 23, 1459, 41.6588, 0.727083222429814, -70.3466, -1.22777978758344),
(826, '02633', 218, 23, 13522, 41.6868, 0.727571914620372, -69.9799, -1.22137966521638),
(827, '02634', 218, 23, 1459, 41.6566, 0.72704482518627, -70.3511, -1.22785832739978),
(828, '02635', 218, 23, 124582, 41.6273, 0.726533443715435, -70.4377, -1.22936978253201),
(829, '02636', 218, 23, 1459, 41.6408, 0.726769063164455, -70.3343, -1.22756511208545),
(830, '02637', 218, 23, 124604, 41.7014, 0.727826732691163, -70.2785, -1.22659121836283),
(831, '02638', 218, 23, 20549, 41.7317, 0.728355567454518, -70.1969, -1.22516702969321),
(832, '02639', 218, 23, 124635, 41.6631, 0.72715827158765, -70.1346, -1.22407968956922),
(833, '02641', 218, 23, 124697, 41.7388, 0.728479485831409, -70.1576, -1.22448111529717),
(834, '02642', 218, 23, 101617, 41.8261, 0.7300031582684, -69.9886, -1.2215315088613),
(835, '02643', 218, 23, 124728, 41.7897, 0.729367858420674, -69.9634, -1.2210916858898),
(836, '02644', 218, 23, 2544, 41.6827, 0.72750035612104, -70.5139, -1.23069972342203),
(837, '02645', 218, 23, 125036, 41.7011, 0.727821496703407, -70.0612, -1.22279861789825),
(838, '02646', 218, 23, 125037, 41.6712, 0.727299643257061, -70.0747, -1.22303423734727),
(839, '02647', 218, 23, 125130, 41.6352, 0.726671324726343, -70.3112, -1.22716194102824),
(840, '02648', 218, 23, 125348, 41.6704, 0.727285680623045, -70.4098, -1.2288828356707),
(841, '02649', 218, 23, 125350, 41.6119, 0.726264663010628, -70.4833, -1.23016565267092),
(842, '02650', 218, 23, 125597, 41.7018, 0.727833714008171, -69.9695, -1.22119815097417),
(843, '02651', 218, 23, 125608, 41.8505, 0.730429018605887, -69.9748, -1.22129065342453),
(844, '02652', 218, 23, 125663, 41.7933, 0.729430690273746, -70.2421, -1.22595591851511),
(845, '02653', 218, 23, 28158, 41.7816, 0.729226486751263, -69.9791, -1.22136570258236),
(846, '02655', 218, 23, 125750, 41.6339, 0.726648635446067, -70.3842, -1.22843603138219),
(847, '02657', 218, 23, 125899, 42.0532, 0.733966800999679, -70.1884, -1.22501867670679),
(848, '02659', 218, 23, 126145, 41.6801, 0.727454977560489, -70.0231, -1.22213364745324),
(849, '02660', 218, 23, 71411, 41.7059, 0.727905272507503, -70.1597, -1.22451776721147),
(850, '02661', 218, 23, 126169, 41.6791, 0.727437524267969, -70.0408, -1.22244257073084),
(851, '02662', 218, 23, 126185, 41.748, 0.728640056122593, -69.9895, -1.22154721682457),
(852, '02663', 218, 23, 126210, 41.7415, 0.728526609721213, -70.0597, -1.22277243795947),
(853, '02664', 218, 23, 126218, 41.6696, 0.727271717989029, -70.1971, -1.22517052035171),
(854, '02666', 218, 23, 74574, 41.9907, 0.732875970217183, -70.0472, -1.22255427180297),
(855, '02667', 218, 23, 126475, 41.932, 0.731851461946262, -70.0891, -1.22328556475956),
(856, '02668', 218, 23, 113083, 41.7024, 0.727844185983683, -70.3559, -1.22794210320388),
(857, '02669', 218, 23, 126505, 41.6791, 0.727437524267969, -69.9994, -1.22172000442052),
(858, '02670', 218, 23, 126514, 41.661, 0.727121619673358, -70.1645, -1.22460154301556),
(859, '02671', 218, 23, 126528, 41.6668, 0.727222848769973, -70.1095, -1.22364161192696),
(860, '02672', 218, 23, 126532, 41.6371, 0.726704485982131, -70.3226, -1.22736090856296),
(861, '02673', 218, 23, 126584, 41.6573, 0.727057042491034, -70.2351, -1.22583374546747),
(862, '02675', 218, 23, 126721, 41.7049, 0.727887819214983, -70.2216, -1.22559812601845),
(863, '02702', 218, 23, 124140, 41.7949, 0.729458615541778, -71.0633, -1.24028856233249),
(864, '02703', 218, 23, 124147, 41.9281, 0.731783394105434, -71.3085, -1.24456810965838),
(865, '02712', 218, 23, 45640, 41.9657, 0.732439637904184, -71.2393, -1.243360341816),
(866, '02713', 218, 23, 124613, 41.4226, 0.722960754736603, -70.9326, -1.23800741700013),
(867, '02714', 218, 23, 32207, 41.5707, 0.725545587358807, -71.0063, -1.23929372465885),
(868, '02715', 218, 23, 75657, 41.8177, 0.729856550611233, -71.137, -1.24157486999121),
(869, '02717', 218, 23, 124704, 41.7683, 0.728994357960748, -70.9684, -1.23863224487234),
(870, '02718', 218, 23, 124743, 41.8718, 0.730800773736562, -71.0198, -1.23952934410787),
(871, '02719', 218, 23, 46961, 41.6383, 0.726725429933155, -70.8899, -1.23726216140953),
(872, '02720', 218, 23, 32423, 41.7176, 0.728109476029986, -71.1385, -1.24160104992999),
(873, '02721', 218, 23, 32423, 41.6862, 0.72756144264486, -71.1568, -1.2419204451831),
(874, '02722', 218, 23, 32423, 41.701, 0.727819751374155, -71.1556, -1.24189950123208),
(875, '02723', 218, 23, 32423, 41.6928, 0.727676634375492, -71.1317, -1.24148236754085),
(876, '02724', 218, 23, 32423, 41.6844, 0.727530026718324, -71.1779, -1.24228870965527),
(877, '02725', 218, 23, 5946, 41.725, 0.728238630394634, -71.1774, -1.24227998300901),
(878, '02726', 218, 23, 5946, 41.7545, 0.728753502523972, -71.1492, -1.24178780015995),
(879, '02738', 218, 23, 630, 41.7059, 0.727905272507503, -70.7555, -1.23491643889485),
(880, '02739', 218, 23, 125361, 41.6582, 0.727072750454302, -70.8072, -1.23581877411813),
(881, '02740', 218, 23, 120755, 41.635, 0.726667834067839, -70.9426, -1.23818194992533),
(882, '02741', 218, 23, 120755, 41.636, 0.726685287360359, -70.9404, -1.23814355268179),
(883, '02742', 218, 23, 120755, 41.6363, 0.726690523348115, -70.9276, -1.23792015053753),
(884, '02743', 218, 23, 124082, 41.6944, 0.727704559643524, -70.9139, -1.23768104043001),
(885, '02744', 218, 23, 120755, 41.611, 0.72624895504736, -70.9186, -1.23776307090485),
(886, '02745', 218, 23, 120755, 41.6937, 0.72769234233876, -70.9387, -1.2381138820845),
(887, '02746', 218, 23, 120755, 41.6627, 0.727151290270642, -70.9358, -1.23806326753619),
(888, '02747', 218, 23, 125604, 41.6405, 0.726763827176699, -70.9881, -1.23897607473499),
(889, '02748', 218, 23, 126148, 41.5959, 0.725985410330309, -70.9534, -1.23837044548454),
(890, '02760', 218, 23, 125585, 41.9747, 0.732596717536864, -71.3267, -1.24488575958224),
(891, '02761', 218, 23, 125585, 41.9811, 0.732708418608992, -71.3327, -1.24499047933736),
(892, '02762', 218, 23, 23999, 42.0124, 0.733254706664866, -71.33, -1.24494335544756),
(893, '02763', 218, 23, 124148, 41.9685, 0.73248850712324, -71.3089, -1.24457509097538),
(894, '02764', 218, 23, 125606, 41.8573, 0.730547700995023, -71.1478, -1.24176336555042),
(895, '02766', 218, 23, 4646, 41.9718, 0.732546102988556, -71.1876, -1.24245800659272),
(896, '02767', 218, 23, 68105, 41.9296, 0.731809574044214, -71.0459, -1.23998487504264),
(897, '02768', 218, 23, 125921, 41.9317, 0.731846225958506, -71.0433, -1.23993949648209),
(898, '02769', 218, 23, 5345, 41.8478, 0.730381894716083, -71.2541, -1.24361865054529),
(899, '02770', 218, 23, 28433, 41.7609, 0.7288652035961, -70.8444, -1.23646803659987),
(900, '02771', 218, 23, 126056, 41.841, 0.730263212326947, -71.3239, -1.24483689036318),
(901, '02777', 218, 23, 28742, 41.7422, 0.728538827025977, -71.2109, -1.24286466830843),
(902, '02779', 218, 23, 372, 41.8261, 0.7300031582684, -71.0819, -1.24061319357336),
(903, '02780', 218, 23, 126319, 41.9049, 0.731378477718972, -71.1023, -1.24096924074076),
(904, '02783', 218, 23, 126319, 42.0209, 0.733403059651285, -71.0556, -1.24015417198008),
(905, '02790', 218, 23, 25961, 41.6092, 0.726217539120825, -71.0856, -1.24067777075568),
(906, '02791', 218, 23, 126606, 41.5243, 0.724735754585881, -71.075, -1.24049276585497),
(907, '02801', 218, 47, 13260, 41.5434, 0.725069112473012, -71.1378, -1.24158883262522),
(908, '02802', 218, 47, 7043, 41.9531, 0.732219726418433, -71.4568, -1.24715643293908),
(909, '02804', 218, 47, 169263, 41.4286, 0.723065474491723, -71.7759, -1.2527257785822),
(910, '02806', 218, 47, 19071, 41.7431, 0.728554534989245, -71.3182, -1.24473740659582),
(911, '02807', 218, 47, 0, 41.1769, 0.718672480764453, -71.5703, -1.2491373816401),
(912, '02808', 218, 47, 1076, 41.4049, 0.722651831459, -71.7496, -1.25226675698892),
(913, '02809', 218, 47, 15330, 41.685, 0.727540498693836, -71.2681, -1.24386299664057),
(914, '02812', 218, 47, 1366, 41.4653, 0.723706010327205, -71.6651, -1.25079195377099),
(915, '02813', 218, 47, 29458, 41.3829, 0.722267859023561, -71.6639, -1.25077100981996),
(916, '02814', 218, 47, 147767, 41.9005, 0.731301683231884, -71.6824, -1.25109389573158),
(917, '02815', 218, 47, 70667, 41.7926, 0.729418472968982, -71.6543, -1.25060345821177),
(918, '02816', 218, 47, 13605, 41.6897, 0.72762252916868, -71.5903, -1.2494864474905),
(919, '02817', 218, 47, 0, 41.6323, 0.726620710178035, -71.6824, -1.25109389573158),
(920, '02818', 218, 47, 148460, 41.6495, 0.726920906809378, -71.4764, -1.24749851747247),
(921, '02822', 218, 47, 27125, 41.556, 0.725289023958763, -71.6272, -1.25013047398448),
(922, '02823', 218, 47, 169374, 41.7333, 0.72838349272255, -71.547, -1.24873071992438),
(923, '02824', 218, 47, 2544, 41.946, 0.732095808041541, -71.7007, -1.2514132909847),
(924, '02825', 218, 47, 35967, 41.7851, 0.729287573275083, -71.7281, -1.25189151119974),
(925, '02826', 218, 47, 2741, 41.9853, 0.732781722437575, -71.6276, -1.25013745530149),
(926, '02827', 218, 47, 115859, 41.6988, 0.727781354130612, -71.7362, -1.25203288286916),
(927, '02828', 218, 47, 2868, 41.874, 0.730839170980106, -71.5545, -1.24886161961828),
(928, '02829', 218, 47, 745, 41.8845, 0.731022430551565, -71.5952, -1.24957196862384),
(929, '02830', 218, 47, 2996, 41.975, 0.73260195352462, -71.6567, -1.25064534611382),
(930, '02831', 218, 47, 665, 41.742, 0.728535336367473, -71.5732, -1.24918799618841),
(931, '02832', 218, 47, 113571, 41.5115, 0.724512352441626, -71.7205, -1.25175886617659),
(932, '02833', 218, 47, 116079, 41.4717, 0.723817711399332, -71.7781, -1.25276417582574),
(933, '02835', 218, 47, 3399, 41.5193, 0.724648488123282, -71.375, -1.24572875361095),
(934, '02836', 218, 47, 9843, 41.4447, 0.723346472501294, -71.6282, -1.250147927277),
(935, '02837', 218, 47, 55947, 41.5108, 0.724500135136862, -71.1686, -1.24212639403484),
(936, '02838', 218, 47, 30417, 41.966, 0.73244487389194, -71.4742, -1.24746012022893),
(937, '02839', 218, 47, 49216, 41.9475, 0.732121987980321, -71.6491, -1.25051270109067),
(938, '02840', 218, 47, 10799, 41.4972, 0.724262770358591, -71.2992, -1.24440579403794),
(939, '02841', 218, 47, 10799, 41.6189, 0.726386836058268, -71.3076, -1.24455240169511),
(940, '02842', 218, 47, 14224, 41.5151, 0.724575184294698, -71.285, -1.24415795728416),
(941, '02852', 218, 47, 169517, 41.5861, 0.725814368063614, -71.4631, -1.24726638868196),
(942, '02854', 218, 47, 169517, 41.5361, 0.724941703437617, -71.4424, -1.2469051055268),
(943, '02857', 218, 47, 125653, 41.842, 0.730280665619467, -71.6314, -1.25020377781307),
(944, '02858', 218, 47, 4710, 41.9619, 0.732373315392609, -71.6459, -1.25045685055461),
(945, '02859', 218, 47, 169536, 41.9645, 0.73241869395316, -71.7175, -1.25170650629903),
(946, '02860', 218, 47, 169537, 41.8725, 0.730812991041326, -71.3922, -1.2460289502423),
(947, '02861', 218, 47, 169537, 41.8804, 0.730950872052233, -71.3555, -1.24538841440681),
(948, '02862', 218, 47, 169537, 41.8729, 0.730819972358334, -71.374, -1.24571130031843),
(949, '02863', 218, 47, 63588, 41.8885, 0.731092243721645, -71.3938, -1.24605687551033),
(950, '02864', 218, 47, 20409, 41.9503, 0.732170857199377, -71.4299, -1.2466869393703),
(951, '02865', 218, 47, 3781, 41.9085, 0.731441309572044, -71.4403, -1.24686845361251),
(952, '02871', 218, 47, 37775, 41.5973, 0.726009844939837, -71.2521, -1.24358374396025),
(953, '02872', 218, 47, 0, 41.6152, 0.726322258875944, -71.3168, -1.24471297198629),
(954, '02873', 218, 47, 5479, 41.5184, 0.724632780160014, -71.7692, -1.25260884152231),
(955, '02874', 218, 47, 169594, 41.5102, 0.72448966316135, -71.4507, -1.24704996785471),
(956, '02875', 218, 47, 169597, 41.4558, 0.723540204048265, -71.6394, -1.25034340415323),
(957, '02876', 218, 47, 169607, 42.0011, 0.73305748445939, -71.5912, -1.24950215545376),
(958, '02877', 218, 47, 825, 41.5323, 0.724875380926041, -71.5473, -1.24873595591214),
(959, '02878', 218, 47, 169631, 41.6299, 0.726578822275987, -71.1834, -1.24238470276413),
(960, '02879', 218, 47, 831, 41.4219, 0.722948537431839, -71.5318, -1.24846542987808),
(961, '02880', 218, 47, 831, 41.423, 0.722967736053611, -71.4849, -1.24764687045889),
(962, '02881', 218, 47, 3542, 41.4727, 0.723835164691852, -71.5351, -1.2485230257434),
(963, '02882', 218, 47, 169498, 41.4289, 0.723070710479479, -71.4673, -1.24733969251054),
(964, '02883', 218, 47, 169540, 41.4519, 0.723472136207438, -71.5009, -1.24792612313921),
(965, '02885', 218, 47, 12663, 41.7244, 0.728228158419122, -71.2655, -1.24381761808002),
(966, '02886', 218, 47, 14798, 41.7028, 0.727851167300691, -71.4445, -1.24694175744109),
(967, '02887', 218, 47, 14798, 41.7025, 0.727845931312935, -71.4224, -1.2465560396764),
(968, '02888', 218, 47, 14798, 41.7496, 0.728667981390625, -71.4118, -1.24637103477569),
(969, '02889', 218, 47, 14798, 41.7113, 0.727999520287111, -71.3881, -1.24595739174296),
(970, '02891', 218, 47, 203, 41.3581, 0.721835017369067, -71.8067, -1.25326333999181),
(971, '02892', 218, 47, 144655, 41.4995, 0.724302912931387, -71.5955, -1.2495772046116),
(972, '02893', 218, 47, 169668, 41.7024, 0.727844185983683, -71.5142, -1.24815825192973),
(973, '02894', 218, 47, 169684, 41.4437, 0.723329019208774, -71.7074, -1.25153022804458),
(974, '02895', 218, 47, 169685, 41.9971, 0.732987671289311, -71.5181, -1.24822631977056),
(975, '02896', 218, 47, 169523, 41.9868, 0.732807902376355, -71.5584, -1.24892968745911),
(976, '02898', 218, 47, 14923, 41.5213, 0.724683394708322, -71.6743, -1.25095252406217),
(977, '02901', 218, 47, 966, 41.8254, 0.729990940963636, -71.4111, -1.24635881747092),
(978, '02902', 218, 47, 966, 41.8252, 0.729987450305132, -71.4118, -1.24637103477569),
(979, '02903', 218, 47, 966, 41.8206, 0.729907165159541, -71.4129, -1.24639023339746),
(980, '02904', 218, 47, 966, 41.8587, 0.73057213560455, -71.4369, -1.24680911241794),
(981, '02905', 218, 47, 966, 41.7891, 0.729357386445162, -71.4034, -1.24622442711852),
(982, '02906', 218, 47, 966, 41.8362, 0.730179436522852, -71.3946, -1.24607083814434),
(983, '02907', 218, 47, 966, 41.8, 0.72954762733363, -71.4256, -1.24661189021246),
(984, '02908', 218, 47, 966, 41.8381, 0.73021259777864, -71.4365, -1.24680213110093),
(985, '02909', 218, 47, 966, 41.8188, 0.729875749233005, -71.4499, -1.2470360052207),
(986, '02910', 218, 47, 35412, 41.7773, 0.729151437593427, -71.4368, -1.24680736708869),
(987, '02911', 218, 47, 169519, 41.8517, 0.730449962556911, -71.4699, -1.2473850710711),
(988, '02912', 218, 47, 966, 41.8241, 0.72996825168336, -71.4013, -1.24618777520423),
(989, '02914', 218, 47, 169357, 41.8129, 0.729772774807137, -71.372, -1.24567639373339),
(990, '02915', 218, 47, 5423, 41.7713, 0.729046717838307, -71.3555, -1.24538841440681),
(991, '02916', 218, 47, 105944, 41.8412, 0.730266702985451, -71.3622, -1.2455053514667),
(992, '02917', 218, 47, 5916, 41.8847, 0.731025921210069, -71.5123, -1.24812509067394),
(993, '02918', 218, 47, 966, 41.822, 0.729931599769069, -71.4198, -1.24651066111585),
(994, '02919', 218, 47, 327, 41.8299, 0.730069480779976, -71.5014, -1.24793484978547),
(995, '02920', 218, 47, 35412, 41.7722, 0.729062425801575, -71.4721, -1.24742346831464),
(996, '02921', 218, 47, 35412, 41.7629, 0.72890011018114, -71.5056, -1.24800815361406),
(997, '02940', 218, 47, 966, 41.8222, 0.729935090427573, -71.4198, -1.24651066111585),
(998, '03031', 218, 36, 62514, 42.8612, 0.748069061355794, -71.6087, -1.24980758807286),
(999, '03032', 218, 36, 13306, 42.9955, 0.750413038541222, -71.3491, -1.24527671333469),
(1000, '03033', 218, 36, 53672, 42.7402, 0.74595721296088, -71.6766, -1.25099266663497),
(1001, '03034', 218, 36, 143584, 43.0518, 0.751395658910095, -71.3043, -1.24449480582979),
(1002, '03036', 218, 36, 8056, 42.9665, 0.749906893058144, -71.2405, -1.24338128576702),
(1003, '03037', 218, 36, 8455, 43.1414, 0.752959473919882, -71.2452, -1.24346331624186),
(1004, '03038', 218, 36, 40058, 42.8887, 0.748549026900092, -71.2996, -1.24441277535495),
(1005, '03040', 218, 36, 143746, 43.0453, 0.751282212508715, -71.2511, -1.24356629066773),
(1006, '03041', 218, 36, 143750, 42.8926, 0.74861709474092, -71.298, -1.24438485008692),
(1007, '03042', 218, 36, 127444, 43.0471, 0.751313628435251, -71.0791, -1.2405643243543),
(1008, '03043', 218, 36, 143839, 43.0036, 0.750554410210634, -71.8645, -1.25427214029947),
(1009, '03044', 218, 36, 2605, 42.9735, 0.750029066105783, -71.1116, -1.2411315563612),
(1010, '03045', 218, 36, 143876, 43.0148, 0.750749887086857, -71.5738, -1.24919846816392),
(1011, '03046', 218, 36, 40717, 43.1029, 0.752287522157864, -71.6166, -1.24994546908377),
(1012, '03047', 218, 36, 2861, 42.9511, 0.749638112353336, -71.9079, -1.25502961319483),
(1013, '03048', 218, 36, 2868, 42.74, 0.745953722302376, -71.7694, -1.25261233218082),
(1014, '03049', 218, 36, 9537, 42.7483, 0.746098584630292, -71.5753, -1.2492246481027),
(1015, '03051', 218, 36, 16505, 42.7713, 0.746500010358251, -71.421, -1.24653160506687),
(1016, '03052', 218, 36, 27727, 42.8447, 0.747781082029215, -71.4566, -1.24715294228058),
(1017, '03053', 218, 36, 49032, 42.8667, 0.748165054464653, -71.3781, -1.24578285881776),
(1018, '03054', 218, 36, 144140, 42.8626, 0.748093495965321, -71.5148, -1.24816872390524),
(1019, '03055', 218, 36, 10480, 42.8295, 0.747515791982911, -71.6585, -1.25067676204036),
(1020, '03057', 218, 36, 144165, 42.8984, 0.748718323837536, -71.6788, -1.25103106387851),
(1021, '03060', 218, 36, 17237, 42.7584, 0.746274862884743, -71.4682, -1.24735540047381),
(1022, '03061', 218, 36, 17237, 42.7487, 0.7461055659473, -71.4916, -1.24776380751878),
(1023, '03062', 218, 36, 17237, 42.7286, 0.745754754767649, -71.4966, -1.24785107398138),
(1024, '03063', 218, 36, 17237, 42.7708, 0.746491283711991, -71.5139, -1.24815301594197),
(1025, '03064', 218, 36, 17237, 42.7655, 0.746398781261635, -71.4678, -1.2473484191568),
(1026, '03070', 218, 36, 30620, 42.9776, 0.750100624605115, -71.6972, -1.25135220446088),
(1027, '03071', 218, 36, 144192, 42.7746, 0.746557606223566, -71.8863, -1.2546526220764),
(1028, '03073', 218, 36, 30685, 42.8332, 0.747580369165235, -71.2247, -1.24310552374521),
(1029, '03076', 218, 36, 4936, 42.7354, 0.745873437156785, -71.3249, -1.2448543436557),
(1030, '03077', 218, 36, 24225, 43.0351, 0.751104188925012, -71.1919, -1.24253305575055),
(1031, '03079', 218, 36, 126, 42.7906, 0.746836858903886, -71.2198, -1.24302000261186),
(1032, '03082', 218, 36, 144098, 42.9014, 0.748770683715095, -71.7817, -1.25282700767881),
(1033, '03084', 218, 36, 12281, 42.8268, 0.747468668093108, -71.8447, -1.25392656510757),
(1034, '03086', 218, 36, 287, 42.8413, 0.747721740834647, -71.7413, -1.25212189466101),
(1035, '03087', 218, 36, 114305, 42.8046, 0.747081204999165, -71.3028, -1.24446862589101),
(1036, '03101', 218, 36, 585, 42.991, 0.750334498724882, -71.4663, -1.24732223921802),
(1037, '03102', 218, 36, 585, 42.9745, 0.750046519398303, -71.5069, -1.24803084289433),
(1038, '03103', 218, 36, 585, 42.9682, 0.749936563655428, -71.4376, -1.2468213297227),
(1039, '03104', 218, 36, 585, 43.0056, 0.750589316795673, -71.4457, -1.24696270139211),
(1040, '03105', 218, 36, 585, 42.969, 0.749950526289443, -71.4193, -1.24650193446959),
(1041, '03106', 218, 36, 143980, 43.059, 0.751521322616238, -71.4489, -1.24701855192818),
(1042, '03107', 218, 36, 585, 43.0044, 0.750568372844649, -71.4646, -1.24729256862074),
(1043, '03108', 218, 36, 585, 42.9485, 0.749592733792785, -71.4401, -1.246864962954),
(1044, '03109', 218, 36, 585, 42.9754, 0.750062227361571, -71.4145, -1.24641815866549),
(1045, '03110', 218, 36, 146, 42.9442, 0.749517684634949, -71.5194, -1.24824900905083),
(1046, '03111', 218, 36, 585, 42.9373, 0.749397256916561, -71.4528, -1.247086619769),
(1047, '03215', 218, 36, 144603, 43.9502, 0.767075696910012, -71.4997, -1.24790517918819),
(1048, '03216', 218, 36, 14988, 43.4326, 0.758041872701689, -71.7749, -1.25270832528968),
(1049, '03217', 218, 36, 13301, 43.6939, 0.76260241803715, -71.6326, -1.25022472176409),
(1050, '03218', 218, 36, 143492, 43.3694, 0.756938824614429, -71.2916, -1.24427314901479),
(1051, '03220', 218, 36, 303, 43.4695, 0.758685899195675, -71.4758, -1.24748804549696),
(1052, '03221', 218, 36, 1076, 43.3053, 0.7558200685639, -71.9912, -1.25648347246174),
(1053, '03222', 218, 36, 15330, 43.606, 0.761068273624647, -71.7377, -1.25205906280794),
(1054, '03223', 218, 36, 15412, 43.8775, 0.765806842543812, -71.6779, -1.25101535591524),
(1055, '03224', 218, 36, 13477, 43.3403, 0.756430933802098, -71.5645, -1.24903615254348),
(1056, '03225', 218, 36, 143597, 43.3781, 0.757090668259352, -71.2317, -1.24322769679284),
(1057, '03226', 218, 36, 143600, 43.7174, 0.763012570411369, -71.4949, -1.24782140338409),
(1058, '03227', 218, 36, 143604, 43.8332, 0.765033661685178, -71.4793, -1.24754913202078),
(1059, '03229', 218, 36, 143659, 43.2486, 0.75483046687802, -71.7646, -1.25252855637672),
(1060, '03230', 218, 36, 64114, 43.5143, 0.759467806700569, -71.8667, -1.25431053754301),
(1061, '03231', 218, 36, 127314, 43.4817, 0.758898829364418, -71.7677, -1.25258266158353),
(1062, '03232', 218, 36, 127349, 43.691, 0.762551803488843, -71.7561, -1.2523802033903),
(1063, '03233', 218, 36, 8723, 43.4175, 0.757778327984638, -71.99, -1.25646252851072),
(1064, '03234', 218, 36, 29731, 43.2133, 0.754214365652066, -71.3523, -1.24533256387075),
(1065, '03235', 218, 36, 2595, 43.4468, 0.758289709455472, -71.654, -1.25059822222402),
(1066, '03237', 218, 36, 143865, 43.4175, 0.757778327984638, -71.4076, -1.2462977309471),
(1067, '03238', 218, 36, 21418, 43.9824, 0.767637692929154, -71.894, -1.2547870124288),
(1068, '03240', 218, 36, 27298, 43.5747, 0.760521985568773, -71.9715, -1.2561396425991),
(1069, '03241', 218, 36, 940, 43.7129, 0.762934030595029, -71.8771, -1.25449205178522),
(1070, '03242', 218, 36, 143951, 43.1731, 0.753512743292764, -71.8192, -1.25348150614831),
(1071, '03243', 218, 36, 858, 43.5146, 0.759473042688325, -71.7589, -1.25242907260936),
(1072, '03244', 218, 36, 3145, 43.1311, 0.752779705006926, -71.9287, -1.25539264167925),
(1073, '03245', 218, 36, 143973, 43.6982, 0.762677467194986, -71.5542, -1.24885638363053),
(1074, '03246', 218, 36, 9914, 43.5485, 0.760064709304751, -71.4363, -1.24679864044243),
(1075, '03247', 218, 36, 9914, 43.5615, 0.76029160210751, -71.4364, -1.24680038577168),
(1076, '03249', 218, 36, 127565, 43.5471, 0.760040274695223, -71.4076, -1.2462977309471),
(1077, '03251', 218, 36, 3781, 44.0485, 0.768791355564722, -71.6592, -1.25068897934512),
(1078, '03252', 218, 36, 144070, 43.4733, 0.758752221707251, -71.5397, -1.24860331088899),
(1079, '03253', 218, 36, 37168, 43.5991, 0.76094784590626, -71.4853, -1.2476538517759),
(1080, '03254', 218, 36, 144168, 43.6685, 0.762159104407144, -71.3781, -1.24578285881776),
(1081, '03255', 218, 36, 33420, 43.3216, 0.756104557231975, -72.0276, -1.25711877230947),
(1082, '03256', 218, 36, 117003, 43.616, 0.761242806549847, -71.4692, -1.24737285376633),
(1083, '03257', 218, 36, 4547, 43.4171, 0.75777134666763, -71.9938, -1.25652885102229),
(1084, '03258', 218, 36, 143624, 43.2787, 0.75535581098287, -71.4079, -1.24630296693486),
(1085, '03259', 218, 36, 144246, 43.8606, 0.765511881900225, -71.3782, -1.24578460414702),
(1086, '03260', 218, 36, 144248, 43.3637, 0.756839340847065, -71.94, -1.25558986388472),
(1087, '03261', 218, 36, 14320, 43.1932, 0.753863554472415, -71.1893, -1.24248767719),
(1088, '03262', 218, 36, 113843, 44.0341, 0.768540028152435, -71.6863, -1.25116196357241),
(1089, '03263', 218, 36, 28268, 43.3004, 0.755734547430553, -71.3288, -1.24492241149653),
(1090, '03264', 218, 36, 14433, 43.7526, 0.763626926308071, -71.6926, -1.25127191931529),
(1091, '03266', 218, 36, 144392, 43.786, 0.764209866278237, -71.8563, -1.2541290233008),
(1092, '03268', 218, 36, 28524, 43.3317, 0.756280835486427, -71.458, -1.24717737689011),
(1093, '03269', 218, 36, 144413, 43.5442, 0.759989660146915, -71.6229, -1.25005542482665),
(1094, '03272', 218, 36, 144486, 43.2953, 0.755645535638701, -71.9969, -1.25658295622911),
(1095, '03273', 218, 36, 126205, 43.3204, 0.756083613280952, -71.9343, -1.25549038011736),
(1096, '03274', 218, 36, 144510, 43.8623, 0.765541552497509, -71.8051, -1.25323541472378),
(1097, '03275', 218, 36, 144532, 43.1496, 0.753102590918545, -71.4475, -1.24699411731865),
(1098, '03276', 218, 36, 12322, 43.4477, 0.75830541741874, -71.5974, -1.24961036586739),
(1099, '03278', 218, 36, 12662, 43.2865, 0.755491946664525, -71.7606, -1.25245874320664),
(1100, '03279', 218, 36, 12663, 43.9648, 0.767330514980803, -71.8845, -1.25462120614986),
(1101, '03280', 218, 36, 12671, 43.1659, 0.75338707958662, -72.0728, -1.25790766113137),
(1102, '03281', 218, 36, 133627, 43.0832, 0.751943692295221, -71.7268, -1.25186882191947),
(1103, '03282', 218, 36, 58194, 43.8636, 0.765564241777785, -71.9292, -1.25540136832551),
(1104, '03284', 218, 36, 349, 43.4878, 0.75900529444879, -72.0533, -1.25756732192723),
(1105, '03287', 218, 36, 12881, 43.4441, 0.758242585565668, -71.911, -1.25508371840164),
(1106, '03289', 218, 36, 144694, 43.4897, 0.759038455704578, -71.5264, -1.24837118209847),
(1107, '03290', 218, 36, 4651, 43.0929, 0.752112989232664, -71.1221, -1.24131481593266),
(1108, '03291', 218, 36, 52629, 43.1714, 0.75348307269548, -71.1364, -1.24156439801569),
(1109, '03293', 218, 36, 569, 43.9771, 0.767545190478798, -71.6857, -1.2511514915969),
(1110, '03298', 218, 36, 12322, 43.6376, 0.761619797668278, -71.5294, -1.24842354197603),
(1111, '03299', 218, 36, 12322, 43.6376, 0.761619797668278, -71.5296, -1.24842703263454),
(1112, '03301', 218, 36, 698, 43.2004, 0.753989218178558, -71.5422, -1.24864694412029),
(1113, '03302', 218, 36, 698, 43.2317, 0.754535506234433, -71.5604, -1.24896459404415),
(1114, '03303', 218, 36, 698, 43.2843, 0.755453549420982, -71.6079, -1.24979362543885),
(1115, '03304', 218, 36, 34937, 43.1376, 0.752893151408306, -71.5446, -1.24868883202234),
(1116, '03305', 218, 36, 698, 43.2084, 0.754128844518718, -71.538, -1.2485736402917),
(1117, '03307', 218, 36, 88686, 43.2852, 0.75546925738425, -71.4678, -1.2473484191568),
(1118, '03431', 218, 36, 16697, 42.9371, 0.749393766258057, -72.286, -1.26162870309662),
(1119, '03435', 218, 36, 16697, 42.9282, 0.74923843195463, -72.2777, -1.26148384076871),
(1120, '03440', 218, 36, 39122, 43.0339, 0.751083244973988, -71.9467, -1.2557068009446),
(1121, '03441', 218, 36, 143475, 42.7831, 0.746705959209986, -72.4341, -1.26421353571882),
(1122, '03442', 218, 36, 26498, 43.0027, 0.750538702247366, -71.9231, -1.25529490324113),
(1123, '03443', 218, 36, 1534, 42.8891, 0.7485560082171, -72.4602, -1.2646690666536),
(1124, '03444', 218, 36, 2113, 42.8984, 0.748718323837536, -72.043, -1.25738755301427),
(1125, '03445', 218, 36, 28723, 42.9938, 0.750383367943938, -72.1912, -1.25997413096573),
(1126, '03446', 218, 36, 144536, 42.8536, 0.747936416332642, -72.259, -1.26115746419858),
(1127, '03447', 218, 36, 143826, 42.7521, 0.746164907141868, -72.1462, -1.25918873280233),
(1128, '03448', 218, 36, 143868, 43.0402, 0.751193200716863, -72.2648, -1.2612586932952),
(1129, '03449', 218, 36, 9313, 42.9667, 0.749910383716648, -71.9572, -1.25589006051606),
(1130, '03450', 218, 36, 2996, 42.9428, 0.749493250025421, -72.0902, -1.25821134842122),
(1131, '03451', 218, 36, 120039, 42.8018, 0.747032335780109, -72.4997, -1.26535847170813),
(1132, '03452', 218, 36, 143999, 42.8155, 0.747271445887632, -72.0316, -1.25718858547955),
(1133, '03455', 218, 36, 22884, 42.9105, 0.748929508677027, -72.1784, -1.25975072882148),
(1134, '03456', 218, 36, 4004, 43.1303, 0.75276574237291, -72.215, -1.26038951932771),
(1135, '03457', 218, 36, 4506, 43.0042, 0.750564882186145, -72.1465, -1.25919396879009),
(1136, '03458', 218, 36, 144308, 42.8884, 0.748543790912336, -71.9442, -1.2556631677133),
(1137, '03461', 218, 36, 144366, 42.7478, 0.746089857984032, -72.017, -1.25693376740876),
(1138, '03462', 218, 36, 144494, 42.9055, 0.748842242214427, -72.4023, -1.26365852101669),
(1139, '03464', 218, 36, 51715, 43.0892, 0.752048412050341, -72.0877, -1.25816771518992),
(1140, '03465', 218, 36, 199, 42.8255, 0.747445978812832, -72.1829, -1.25982926863782),
(1141, '03466', 218, 36, 126507, 42.8726, 0.748268028890521, -72.5161, -1.26564470570546),
(1142, '03467', 218, 36, 34392, 42.9534, 0.749678254926132, -72.4219, -1.26400060555008),
(1143, '03468', 218, 36, 144651, 42.8737, 0.748287227512293, -71.9666, -1.25605412146575),
(1144, '03469', 218, 36, 144659, 42.8627, 0.748095241294573, -72.3288, -1.26237570401647),
(1145, '03470', 218, 36, 12894, 42.7777, 0.746611711430378, -72.3606, -1.26293071871861),
(1146, '03561', 218, 36, 3815, 44.3077, 0.773315248985892, -71.7724, -1.25266469205838),
(1147, '03570', 218, 36, 376, 44.4755, 0.776243911470738, -71.1774, -1.24227998300901),
(1148, '03574', 218, 36, 548, 44.2889, 0.772987127086517, -71.6592, -1.25068897934512),
(1149, '03575', 218, 36, 19463, 44.258, 0.77244782034765, -71.4416, -1.24689114289278),
(1150, '03576', 218, 36, 45895, 44.8936, 0.783541133073326, -71.4987, -1.24788772589567),
(1151, '03579', 218, 36, 143808, 44.7771, 0.781507824494753, -71.1758, -1.24225205774098),
(1152, '03580', 218, 36, 102096, 44.2288, 0.771938184206068, -71.7495, -1.25226501165967),
(1153, '03581', 218, 36, 27295, 44.401, 0.774943641178002, -71.1923, -1.24254003706756),
(1154, '03582', 218, 36, 94633, 44.5993, 0.778404629084707, -71.5134, -1.24814428929571),
(1155, '03583', 218, 36, 3409, 44.3953, 0.774844157410639, -71.4338, -1.24675500721113),
(1156, '03584', 218, 36, 16841, 44.4896, 0.776490002895269, -71.5684, -1.24910422038431);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(1157, '03585', 218, 36, 10116, 44.2119, 0.771643223562481, -71.9081, -1.25503310385333),
(1158, '03587', 218, 36, 176, 44.3957, 0.774851138727647, -71.4342, -1.24676198852813),
(1159, '03588', 218, 36, 23084, 44.6403, 0.779120214078025, -71.1505, -1.24181048944023),
(1160, '03589', 218, 36, 37311, 44.3449, 0.773964511467633, -71.5513, -1.24880576908222),
(1161, '03590', 218, 36, 144247, 44.7194, 0.780500769516352, -71.4662, -1.24732049388877),
(1162, '03592', 218, 36, 5099, 45.1127, 0.787365149464446, -71.2553, -1.24363959449632),
(1163, '03595', 218, 36, 144576, 44.2714, 0.772681694467418, -71.5396, -1.24860156555974),
(1164, '03597', 218, 36, 144658, 44.9948, 0.785307406276345, -71.5316, -1.24846193921958),
(1165, '03598', 218, 36, 12825, 44.3727, 0.774449712999688, -71.6164, -1.24994197842527),
(1166, '03601', 218, 36, 18728, 43.2437, 0.754744945744672, -72.3878, -1.26340544827515),
(1167, '03602', 218, 36, 143456, 43.1569, 0.753229999953941, -72.3055, -1.26196904230076),
(1168, '03603', 218, 36, 29458, 43.237, 0.754628008684788, -72.4254, -1.2640616920739),
(1169, '03604', 218, 36, 143727, 43.1281, 0.752727345129366, -72.3926, -1.26348922407925),
(1170, '03605', 218, 36, 144053, 43.2126, 0.754202148347302, -72.1595, -1.25942086159285),
(1171, '03607', 218, 36, 144461, 43.1774, 0.7535877924506, -72.3327, -1.2624437718573),
(1172, '03608', 218, 36, 28895, 43.0704, 0.751720290150966, -72.4059, -1.26372135286976),
(1173, '03609', 218, 36, 144252, 43.1414, 0.752959473919882, -72.4482, -1.26445962714336),
(1174, '03740', 218, 36, 19093, 44.1825, 0.771130096762395, -71.9518, -1.25579581273646),
(1175, '03741', 218, 36, 306, 43.6625, 0.762054384652024, -72.0034, -1.25669640263049),
(1176, '03743', 218, 36, 26794, 43.3684, 0.756921371321909, -72.3454, -1.26266542867231),
(1177, '03745', 218, 36, 59112, 43.529, 0.759724370100612, -72.3668, -1.26303892913223),
(1178, '03746', 218, 36, 143670, 43.4971, 0.759167610069226, -72.2798, -1.261520492683),
(1179, '03748', 218, 36, 27104, 43.6302, 0.76149064330363, -72.1345, -1.25898452927985),
(1180, '03749', 218, 36, 143801, 43.5905, 0.760797747590588, -72.1116, -1.25858484888114),
(1181, '03750', 218, 36, 314, 43.7158, 0.762984645143337, -72.2132, -1.26035810340117),
(1182, '03751', 218, 36, 143857, 43.4296, 0.757989512824129, -72.0711, -1.25787799053409),
(1183, '03752', 218, 36, 419, 43.289, 0.755535579895825, -72.1161, -1.25866338869748),
(1184, '03753', 218, 36, 16267, 43.5274, 0.75969644483258, -72.1359, -1.25900896388938),
(1185, '03754', 218, 36, 55113, 43.376, 0.75705401634506, -72.1327, -1.25895311335331),
(1186, '03755', 218, 36, 2963, 43.7097, 0.762878180058965, -72.2725, -1.2613930836476),
(1187, '03756', 218, 36, 3708, 43.6355, 0.761583145753986, -72.2541, -1.26107194306523),
(1188, '03765', 218, 36, 16381, 44.0429, 0.768693617126611, -72.0611, -1.25770345760889),
(1189, '03766', 218, 36, 3708, 43.6431, 0.761715790777137, -72.253, -1.26105274444346),
(1190, '03768', 218, 36, 144095, 43.773, 0.763982973475478, -72.167, -1.25955176128675),
(1191, '03769', 218, 36, 144096, 43.7939, 0.764347747289145, -72.0637, -1.25774883616944),
(1192, '03770', 218, 36, 33252, 43.5175, 0.759523657236632, -72.2796, -1.26151700202449),
(1193, '03771', 218, 36, 10560, 44.2707, 0.772669477162654, -72.0246, -1.25706641243191),
(1194, '03773', 218, 36, 10799, 43.369, 0.756931843297421, -72.1603, -1.25943482422686),
(1195, '03774', 218, 36, 144233, 44.0856, 0.769438872717212, -72.0252, -1.25707688440742),
(1196, '03777', 218, 36, 144278, 43.895, 0.766112275162911, -72.0668, -1.25780294137625),
(1197, '03779', 218, 36, 42553, 43.9767, 0.76753820916179, -72.0965, -1.25832130416409),
(1198, '03780', 218, 36, 28249, 44.0016, 0.767972796145537, -72.0026, -1.25668243999647),
(1199, '03781', 218, 36, 11247, 43.3791, 0.757108121551872, -72.1804, -1.25978563540652),
(1200, '03782', 218, 36, 144530, 43.3989, 0.757453696743767, -72.0887, -1.25818516848244),
(1201, '03784', 218, 36, 58217, 43.6486, 0.761811783885997, -72.3037, -1.26193762637422),
(1202, '03785', 218, 36, 126703, 44.1481, 0.770529703499709, -72.0337, -1.25722523739384),
(1203, '03801', 218, 36, 37775, 43.0669, 0.751659203627146, -70.783, -1.23539640443915),
(1204, '03802', 218, 36, 37775, 43.0779, 0.751851189844865, -70.7562, -1.23492865619961),
(1205, '03803', 218, 36, 37775, 43.0693, 0.751701091529194, -70.7993, -1.23568089310722),
(1206, '03804', 218, 36, 37775, 43.0778, 0.751849444515613, -70.7573, -1.23494785482138),
(1207, '03805', 218, 36, 144384, 43.2354, 0.754600083416756, -70.8212, -1.23606312021341),
(1208, '03809', 218, 36, 14977, 43.474, 0.758764439012015, -71.241, -1.24339001241328),
(1209, '03810', 218, 36, 143460, 43.4823, 0.75890930133993, -71.248, -1.24351218546092),
(1210, '03811', 218, 36, 18953, 42.8381, 0.747665890298583, -71.1604, -1.24198327703617),
(1211, '03812', 218, 36, 19076, 44.0879, 0.769479015290008, -71.2799, -1.24406894549231),
(1212, '03813', 218, 36, 143598, 43.857, 0.765449050047153, -71.1095, -1.24109490444691),
(1213, '03814', 218, 36, 143603, 43.7486, 0.763557113137991, -71.1048, -1.24101287397206),
(1214, '03815', 218, 36, 143605, 43.2586, 0.755004999803219, -71.1159, -1.24120660551904),
(1215, '03816', 218, 36, 143606, 43.6571, 0.761960136872416, -71.2526, -1.24359247060651),
(1216, '03817', 218, 36, 143628, 43.8937, 0.766089585882635, -71.2405, -1.24338128576702),
(1217, '03818', 218, 36, 8215, 43.9239, 0.766616675316737, -71.1353, -1.24154519939392),
(1218, '03819', 218, 36, 1964, 42.9217, 0.74912498555325, -71.1172, -1.24122929479931),
(1219, '03820', 218, 36, 8583, 43.191, 0.753825157228871, -70.8925, -1.23730753997008),
(1220, '03821', 218, 36, 8583, 43.1895, 0.753798977290091, -70.9033, -1.2374960355293),
(1221, '03822', 218, 36, 8583, 43.2219, 0.754364463967737, -70.842, -1.23642614869782),
(1222, '03824', 218, 36, 8632, 43.1275, 0.752716873153854, -70.9434, -1.23819591255935),
(1223, '03825', 218, 36, 19071, 43.2113, 0.754179459067026, -71.0277, -1.23966722511878),
(1224, '03826', 218, 36, 143753, 42.8895, 0.748562989534108, -71.1365, -1.24156614334495),
(1225, '03827', 218, 36, 109000, 42.9144, 0.748997576517855, -70.9805, -1.23884342971184),
(1226, '03830', 218, 36, 143774, 43.6005, 0.760972280515788, -70.9869, -1.23895513078396),
(1227, '03832', 218, 36, 143786, 43.9088, 0.766353130599686, -71.0842, -1.24065333614615),
(1228, '03833', 218, 36, 27125, 42.9776, 0.750100624605115, -70.9668, -1.23860431960431),
(1229, '03835', 218, 36, 8849, 43.3856, 0.757221567953252, -71.0591, -1.2402152585039),
(1230, '03836', 218, 36, 29850, 43.8244, 0.764880072711003, -71.0877, -1.24071442266997),
(1231, '03837', 218, 36, 0, 43.4326, 0.758041872701689, -71.3401, -1.24511963370201),
(1232, '03838', 218, 36, 47441, 44.1004, 0.769697181446507, -71.208, -1.24281405376012),
(1233, '03839', 218, 36, 28433, 43.2733, 0.755261563203262, -70.9955, -1.23910522909963),
(1234, '03840', 218, 36, 9223, 43.0385, 0.751163530119579, -70.8462, -1.23649945252641),
(1235, '03841', 218, 36, 47803, 42.8819, 0.748430344510956, -71.179, -1.24230790827704),
(1236, '03842', 218, 36, 2957, 42.9337, 0.749334425063489, -70.8234, -1.23610151745695),
(1237, '03843', 218, 36, 2957, 42.9423, 0.749484523379161, -70.826, -1.2361468960175),
(1238, '03844', 218, 36, 143924, 42.9255, 0.749191308064826, -70.8869, -1.23720980153197),
(1239, '03845', 218, 36, 103090, 44.0787, 0.769318444998825, -71.1302, -1.24145618760207),
(1240, '03846', 218, 36, 3384, 44.1844, 0.771163258018183, -71.1883, -1.24247022389748),
(1241, '03847', 218, 36, 131542, 44.0743, 0.769241650511737, -71.1321, -1.24148934885786),
(1242, '03848', 218, 36, 3542, 42.9194, 0.749084842980454, -71.065, -1.24031823292977),
(1243, '03849', 218, 36, 3938, 43.8923, 0.766065151273107, -71.1143, -1.241178680251),
(1244, '03850', 218, 36, 144139, 43.6931, 0.762588455403134, -71.2936, -1.24430805559983),
(1245, '03851', 218, 36, 4232, 43.441, 0.758188480358857, -71.0167, -1.23947523890106),
(1246, '03852', 218, 36, 144157, 43.5058, 0.759319453714149, -70.977, -1.23878234318802),
(1247, '03853', 218, 36, 144160, 43.6237, 0.76137719690225, -71.279, -1.24405323752904),
(1248, '03854', 218, 36, 4520, 43.0688, 0.751692364882934, -70.721, -1.23431430030291),
(1249, '03855', 218, 36, 144187, 43.4408, 0.758184989700353, -71.1489, -1.24178256417219),
(1250, '03856', 218, 36, 144203, 43.0365, 0.75112862353454, -70.9391, -1.23812086340151),
(1251, '03857', 218, 36, 49799, 43.0756, 0.751811047272069, -70.9422, -1.23817496860832),
(1252, '03858', 218, 36, 4570, 42.8685, 0.748196470391189, -71.0462, -1.2399901110304),
(1253, '03859', 218, 36, 144215, 42.8678, 0.748184253086425, -71.0664, -1.2403426675393),
(1254, '03860', 218, 36, 82623, 44.0403, 0.768648238566059, -71.1337, -1.24151727412589),
(1255, '03862', 218, 36, 73711, 42.9741, 0.750039538081295, -70.8241, -1.23611373476172),
(1256, '03864', 218, 36, 67536, 43.6942, 0.762607654024906, -71.1109, -1.24111933905644),
(1257, '03865', 218, 36, 144331, 42.8398, 0.747695560895867, -71.0915, -1.24078074518155),
(1258, '03866', 218, 36, 28433, 43.3005, 0.755736292759805, -70.9787, -1.2388120137853),
(1259, '03867', 218, 36, 28433, 43.3041, 0.755799124612876, -70.9892, -1.23899527335676),
(1260, '03868', 218, 36, 28433, 43.35, 0.756600230739542, -70.9683, -1.23863049954309),
(1261, '03869', 218, 36, 144384, 43.2287, 0.754483146356873, -70.832, -1.23625161577262),
(1262, '03870', 218, 36, 11742, 43.0059, 0.750594552783429, -70.7667, -1.23511191577107),
(1263, '03871', 218, 36, 144398, 42.9914, 0.75034148004189, -70.7611, -1.23501417733296),
(1264, '03872', 218, 36, 144415, 43.5516, 0.760118814511562, -71.0175, -1.23948920153507),
(1265, '03873', 218, 36, 144416, 42.9305, 0.749278574527426, -71.1866, -1.2424405533002),
(1266, '03874', 218, 36, 24727, 42.891, 0.748589169472888, -70.8559, -1.23666874946385),
(1267, '03875', 218, 36, 18083, 43.8518, 0.765358292926049, -71.1758, -1.24225205774098),
(1268, '03878', 218, 36, 144459, 43.2526, 0.754900280048099, -70.8734, -1.23697418208295),
(1269, '03882', 218, 36, 27055, 43.7177, 0.763017806399125, -71.0035, -1.23924485543979),
(1270, '03883', 218, 36, 144491, 43.8403, 0.76515758006207, -71.3127, -1.24464141348696),
(1271, '03884', 218, 36, 57753, 43.2346, 0.75458612078274, -71.1338, -1.24151901945514),
(1272, '03885', 218, 36, 144521, 43.0152, 0.750756868403865, -70.8969, -1.23738433445717),
(1273, '03886', 218, 36, 106805, 43.8745, 0.765754482666252, -71.2831, -1.24412479602837),
(1274, '03887', 218, 36, 455, 43.4638, 0.758586415428311, -71.0759, -1.24050847381824),
(1275, '03890', 218, 36, 144650, 43.8369, 0.765098238867502, -71.2008, -1.24268839005398),
(1276, '03894', 218, 36, 144696, 43.5879, 0.760752369030036, -71.2222, -1.24306189051391),
(1277, '03896', 218, 36, 144698, 43.5867, 0.760731425079012, -71.2104, -1.24285594166217),
(1278, '03897', 218, 36, 144700, 43.9074, 0.766328695990158, -71.3489, -1.24527322267618),
(1279, '03901', 218, 26, 400, 43.2897, 0.755547797200589, -70.8544, -1.23664256952507),
(1280, '03902', 218, 26, 127033, 43.2105, 0.75416549643301, -70.614, -1.23244679800328),
(1281, '03903', 218, 26, 124781, 43.132, 0.752795412970194, -70.7884, -1.23549065221875),
(1282, '03904', 218, 26, 127885, 43.096, 0.752167094439476, -70.7419, -1.23467907411658),
(1283, '03905', 218, 26, 127883, 43.088, 0.752027468099317, -70.6989, -1.23392858253822),
(1284, '03906', 218, 26, 128285, 43.3053, 0.7558200685639, -70.7423, -1.23468605543358),
(1285, '03907', 218, 26, 128420, 43.2553, 0.754947403937903, -70.6045, -1.23228099172434),
(1286, '03908', 218, 26, 128868, 43.2314, 0.754530270246677, -70.7836, -1.23540687641466),
(1287, '03909', 218, 26, 6986, 43.1538, 0.753175894747129, -70.6531, -1.23312922174081),
(1288, '03910', 218, 26, 14924, 43.1756, 0.753556376524064, -70.6157, -1.23247646860056),
(1289, '03911', 218, 26, 129406, 43.1364, 0.752872207457282, -70.6383, -1.23287091301151),
(1290, '04001', 218, 26, 29062, 43.5673, 0.760392831204126, -70.9145, -1.23769151240552),
(1291, '04002', 218, 26, 71641, 43.4935, 0.759104778216154, -70.7066, -1.23406297289062),
(1292, '04003', 218, 26, 126807, 43.6824, 0.762401705173171, -70.1539, -1.22441653811485),
(1293, '04004', 218, 26, 126823, 43.6654, 0.762104999200332, -70.6022, -1.23224084915154),
(1294, '04005', 218, 26, 126879, 43.4744, 0.758771420329023, -70.4535, -1.22964554455383),
(1295, '04006', 218, 26, 126877, 43.4456, 0.758268765504448, -70.3462, -1.22777280626644),
(1296, '04007', 218, 26, 126879, 43.4654, 0.758614340696343, -70.4436, -1.22947275695788),
(1297, '04008', 218, 26, 126920, 44.0105, 0.768128130448964, -69.8934, -1.2198699554134),
(1298, '04009', 218, 26, 126947, 44.055, 0.768904801966102, -70.7177, -1.23425670443759),
(1299, '04010', 218, 26, 26621, 44.1873, 0.77121387256649, -70.7457, -1.23474539662815),
(1300, '04011', 218, 26, 19602, 43.9021, 0.766236193539803, -69.9657, -1.2211318284626),
(1301, '04013', 218, 26, 127004, 43.7995, 0.764445485727256, -70.0714, -1.22297664148195),
(1302, '04014', 218, 26, 127037, 43.4087, 0.757624739010463, -70.4762, -1.23004173429403),
(1303, '04015', 218, 26, 100553, 43.9874, 0.767724959391754, -70.5381, -1.23112209310101),
(1304, '04016', 218, 26, 127080, 44.1732, 0.770967781141959, -70.873, -1.23696720076594),
(1305, '04017', 218, 26, 127095, 43.7341, 0.763304040396452, -70.1282, -1.22396798849709),
(1306, '04019', 218, 26, 127121, 43.6974, 0.76266350456097, -70.1033, -1.22353340151334),
(1307, '04020', 218, 26, 59112, 43.8036, 0.764517044226588, -70.8097, -1.23586240734943),
(1308, '04021', 218, 26, 127190, 43.8112, 0.76464968924974, -70.2637, -1.22633290963354),
(1309, '04022', 218, 26, 8477, 43.9773, 0.767548681137302, -70.7968, -1.23563725987592),
(1310, '04024', 218, 26, 0, 43.8823, 0.765890618347908, -70.6942, -1.23384655206338),
(1311, '04027', 218, 26, 3708, 43.3823, 0.757163972087936, -70.9482, -1.23827968836344),
(1312, '04028', 218, 26, 0, 43.7664, 0.763867781744846, -70.9204, -1.23779448683139),
(1313, '04029', 218, 26, 0, 43.8346, 0.765058096294706, -70.6101, -1.23237873016245),
(1314, '04030', 218, 26, 127391, 43.5826, 0.760659866579681, -70.7104, -1.2341292954022),
(1315, '04032', 218, 26, 16142, 43.8547, 0.765408907474357, -70.1044, -1.22355260013511),
(1316, '04033', 218, 26, 16142, 43.8564, 0.765438578071641, -70.1006, -1.22348627762354),
(1317, '04034', 218, 26, 16142, 43.8573, 0.765454286034909, -70.1035, -1.22353689217184),
(1318, '04037', 218, 26, 41022, 44.0133, 0.76817699966802, -70.9667, -1.23860257427506),
(1319, '04038', 218, 26, 27295, 43.6982, 0.762677467194986, -70.4562, -1.22969266844363),
(1320, '04039', 218, 26, 21530, 43.8839, 0.76591854361594, -70.3463, -1.22777455159569),
(1321, '04040', 218, 26, 9353, 44.1062, 0.769798410543123, -70.6684, -1.23339625711636),
(1322, '04041', 218, 26, 9518, 43.8885, 0.765998828761531, -70.8412, -1.23641218606381),
(1323, '04042', 218, 26, 127766, 43.6308, 0.761501115279142, -70.6404, -1.2329075649258),
(1324, '04043', 218, 26, 127859, 43.3755, 0.7570452896988, -70.5275, -1.2309370882003),
(1325, '04046', 218, 26, 127863, 43.3942, 0.757371666268923, -70.4537, -1.22964903521233),
(1326, '04047', 218, 26, 128482, 43.8052, 0.76454496949462, -70.8903, -1.23726914272654),
(1327, '04048', 218, 26, 22668, 43.6807, 0.762372034575887, -70.7562, -1.23492865619961),
(1328, '04049', 218, 26, 127952, 43.7238, 0.763124271483497, -70.6782, -1.23356729938306),
(1329, '04050', 218, 26, 3855, 43.6908, 0.762548312830339, -70.1565, -1.2244619166754),
(1330, '04051', 218, 26, 73289, 44.1889, 0.771241797834522, -70.9495, -1.23830237764372),
(1331, '04053', 218, 26, 128125, 43.8469, 0.765272771792702, -69.9997, -1.22172524040827),
(1332, '04054', 218, 26, 4301, 43.3293, 0.756238947584379, -70.6041, -1.23227401040733),
(1333, '04055', 218, 26, 17231, 43.9433, 0.766955269191624, -70.5944, -1.23210471346988),
(1334, '04056', 218, 26, 71169, 43.6496, 0.761829237178517, -70.9208, -1.23780146814839),
(1335, '04057', 218, 26, 128290, 44.0437, 0.768707579760627, -70.7357, -1.23457086370295),
(1336, '04061', 218, 26, 128369, 43.6506, 0.761846690471037, -70.7288, -1.23445043598457),
(1337, '04062', 218, 26, 114305, 43.8069, 0.764574640091904, -70.4211, -1.22908005787618),
(1338, '04063', 218, 26, 104895, 43.5024, 0.759260112519581, -70.3876, -1.22849537257676),
(1339, '04064', 218, 26, 128424, 43.5164, 0.75950445861486, -70.3874, -1.22849188191826),
(1340, '04066', 218, 26, 128443, 43.7765, 0.764044059999298, -69.9559, -1.2209607861959),
(1341, '04068', 218, 26, 5186, 43.8401, 0.765154089403566, -70.9417, -1.23816624196206),
(1342, '04069', 218, 26, 172421, 43.8978, 0.766161144381967, -70.2156, -1.22549340626333),
(1343, '04070', 218, 26, 68579, 43.5978, 0.760925156625984, -70.3318, -1.22752147885415),
(1344, '04071', 218, 26, 24225, 43.9163, 0.766484030293586, -70.446, -1.22951464485993),
(1345, '04072', 218, 26, 277, 43.5196, 0.759560309150924, -70.4508, -1.22959842066402),
(1346, '04073', 218, 26, 188, 43.4357, 0.758095977908501, -70.7618, -1.23502639463772),
(1347, '04074', 218, 26, 68579, 43.5794, 0.760604016043617, -70.3451, -1.22775360764466),
(1348, '04075', 218, 26, 128772, 43.7674, 0.763885235037366, -70.555, -1.2314170537446),
(1349, '04076', 218, 26, 128791, 43.5182, 0.759535874541396, -70.8542, -1.23663907886657),
(1350, '04077', 218, 26, 128878, 43.8733, 0.765733538715228, -70.5144, -1.23070845006829),
(1351, '04078', 218, 26, 121512, 43.8206, 0.764813750199427, -70.1106, -1.22366081054874),
(1352, '04079', 218, 26, 0, 43.8256, 0.764901016662027, -69.952, -1.22089271835507),
(1353, '04081', 218, 26, 128944, 44.1419, 0.770421493086085, -70.806, -1.2357978301671),
(1354, '04082', 218, 26, 114095, 43.7347, 0.763314512371964, -70.4406, -1.22942039708032),
(1355, '04083', 218, 26, 25059, 43.4642, 0.758593396745319, -70.7932, -1.23557442802285),
(1356, '04084', 218, 26, 57699, 43.7444, 0.763483809309408, -70.4134, -1.22894566752378),
(1357, '04085', 218, 26, 128988, 43.7441, 0.763478573321652, -70.6419, -1.23293374486458),
(1358, '04086', 218, 26, 129086, 43.9367, 0.766840077460993, -69.9665, -1.22114579109661),
(1359, '04087', 218, 26, 113224, 43.5559, 0.760193863669398, -70.7411, -1.23466511148256),
(1360, '04088', 218, 26, 790, 44.2189, 0.771765396610121, -70.4766, -1.23004871561104),
(1361, '04090', 218, 26, 34376, 43.3041, 0.755799124612876, -70.5764, -1.23179055420453),
(1362, '04091', 218, 26, 129226, 43.8315, 0.765003991087895, -70.7445, -1.23472445267713),
(1363, '04092', 218, 26, 6730, 43.6847, 0.762441847745967, -70.3557, -1.22793861254537),
(1364, '04093', 218, 26, 31939, 43.6505, 0.761844945141785, -70.6206, -1.23256198973391),
(1365, '04094', 218, 26, 177351, 43.4269, 0.757942388934326, -70.6295, -1.23271732403733),
(1366, '04095', 218, 26, 129277, 43.65, 0.761836218495525, -70.9211, -1.23780670413615),
(1367, '04096', 218, 26, 118542, 43.7972, 0.76440534315446, -70.1788, -1.2248511250986),
(1368, '04097', 218, 26, 0, 43.8459, 0.765255318500182, -70.2357, -1.22584421744298),
(1369, '04098', 218, 26, 6730, 43.677, 0.762307457393563, -70.3632, -1.22806951223927),
(1370, '04101', 218, 26, 5188, 43.6607, 0.762022968725488, -70.2597, -1.22626309646346),
(1371, '04102', 218, 26, 5188, 43.6646, 0.762091036566316, -70.2942, -1.2268652350554),
(1372, '04103', 218, 26, 5188, 43.6886, 0.762509915586795, -70.2885, -1.22676575128803),
(1373, '04104', 218, 26, 5188, 43.663, 0.762063111298284, -70.2641, -1.22633989095055),
(1374, '04105', 218, 26, 15986, 43.7435, 0.76346810134614, -70.2831, -1.22667150350843),
(1375, '04106', 218, 26, 128922, 43.622, 0.761347526304966, -70.2897, -1.22678669523906),
(1376, '04107', 218, 26, 127031, 43.6082, 0.761106670868191, -70.2333, -1.22580232954093),
(1377, '04108', 218, 26, 128498, 43.6605, 0.762019478066984, -70.1919, -1.22507976323061),
(1378, '04109', 218, 26, 5188, 43.6769, 0.762305712064311, -70.2018, -1.22525255082656),
(1379, '04110', 218, 26, 127193, 43.7583, 0.763726410075435, -70.2039, -1.22528920274085),
(1380, '04112', 218, 26, 5188, 43.6671, 0.762134669797616, -70.2075, -1.22535203459392),
(1381, '04116', 218, 26, 128922, 43.659, 0.761993298128204, -70.2674, -1.22639748681586),
(1382, '04122', 218, 26, 5188, 43.6512, 0.761857162446549, -70.33, -1.22749006292761),
(1383, '04123', 218, 26, 5188, 43.6597, 0.762005515432968, -70.3063, -1.22707641989489),
(1384, '04124', 218, 26, 5188, 43.6511, 0.761855417117297, -70.3296, -1.2274830816106),
(1385, '04210', 218, 26, 13306, 44.0928, 0.769564536423356, -70.2454, -1.22601351438042),
(1386, '04211', 218, 26, 13306, 44.0839, 0.769409202119928, -70.2493, -1.22608158222125),
(1387, '04212', 218, 26, 13306, 44.0844, 0.769417928766188, -70.2491, -1.22607809156275),
(1388, '04216', 218, 26, 14988, 44.7468, 0.780978989731399, -70.9067, -1.23755537672386),
(1389, '04217', 218, 26, 220, 44.4472, 0.775749983292424, -70.6922, -1.23381164547834),
(1390, '04219', 218, 26, 126981, 44.3828, 0.774625991254139, -70.6164, -1.23248868590532),
(1391, '04220', 218, 26, 126983, 44.2839, 0.772899860623917, -70.37, -1.22818819462841),
(1392, '04221', 218, 26, 19763, 44.4182, 0.775243837809345, -70.322, -1.22735043658745),
(1393, '04222', 218, 26, 8632, 43.9311, 0.766742339022881, -70.1479, -1.22431181835973),
(1394, '04223', 218, 26, 1964, 44.0321, 0.768505121567395, -70.2757, -1.22654234914378),
(1395, '04224', 218, 26, 127258, 44.5429, 0.777420263386582, -70.4534, -1.22964379922457),
(1396, '04225', 218, 26, 8610, 44.5868, 0.778186462928208, -70.2137, -1.22546024500754),
(1397, '04226', 218, 26, 127314, 44.6035, 0.778477932913291, -70.7284, -1.23444345466756),
(1398, '04227', 218, 26, 127330, 44.5922, 0.778280710707815, -70.3017, -1.2269961347493),
(1399, '04228', 218, 26, 127354, 44.4, 0.774926187885482, -70.128, -1.22396449783858),
(1400, '04230', 218, 26, 127375, 44.0228, 0.76834280594696, -70.3857, -1.22846221132097),
(1401, '04231', 218, 26, 98312, 44.2513, 0.772330883287767, -70.8836, -1.23715220566665),
(1402, '04234', 218, 26, 127393, 44.5923, 0.778282456037067, -70.3012, -1.22698740810304),
(1403, '04236', 218, 26, 115859, 44.1908, 0.77127495909031, -70.1445, -1.22425247716516),
(1404, '04237', 218, 26, 2963, 44.4967, 0.776613921272161, -70.7261, -1.23440331209476),
(1405, '04238', 218, 26, 940, 44.2109, 0.771625770269961, -70.3802, -1.22836621821211),
(1406, '04239', 218, 26, 9722, 44.4844, 0.776399245774166, -70.1942, -1.2251199058034),
(1407, '04240', 218, 26, 3747, 44.0984, 0.769662274861467, -70.1862, -1.22498027946324),
(1408, '04241', 218, 26, 3747, 44.0898, 0.769512176545796, -70.173, -1.22474989600198),
(1409, '04243', 218, 26, 3747, 44.0889, 0.769496468582528, -70.172, -1.22473244270946),
(1410, '04250', 218, 26, 10116, 44.0263, 0.768403892470779, -70.1092, -1.22363637593921),
(1411, '04252', 218, 26, 127970, 44.0044, 0.768021665364593, -70.0623, -1.22281781652002),
(1412, '04253', 218, 26, 36928, 44.4184, 0.775247328467849, -70.1995, -1.22521240825376),
(1413, '04254', 218, 26, 127987, 44.4745, 0.776226458178218, -70.1866, -1.22498726078025),
(1414, '04255', 218, 26, 2869, 44.3216, 0.773557849751919, -70.6292, -1.23271208804958),
(1415, '04256', 218, 26, 128109, 44.1052, 0.769780957250603, -70.37, -1.22818819462841),
(1416, '04257', 218, 26, 37178, 44.558, 0.777683808103633, -70.5359, -1.23108369585747),
(1417, '04258', 218, 26, 60909, 44.0591, 0.768976360465434, -70.4144, -1.2289631208163),
(1418, '04259', 218, 26, 4270, 44.2302, 0.771962618815596, -70.0614, -1.22280210855676),
(1419, '04260', 218, 26, 128235, 43.9595, 0.767238012530447, -70.2246, -1.22565048589601),
(1420, '04261', 218, 26, 30664, 44.4087, 0.775078031530406, -70.7939, -1.23558664532761),
(1421, '04262', 218, 26, 128320, 44.5251, 0.777109594779727, -70.2113, -1.22541835710549),
(1422, '04263', 218, 26, 3719, 44.2944, 0.773083120195376, -70.1314, -1.22402383903315),
(1423, '04265', 218, 26, 128333, 44.2728, 0.772706129076945, -70.0523, -1.22264328359482),
(1424, '04266', 218, 26, 128363, 44.3312, 0.77372540136011, -70.2562, -1.22620200993964),
(1425, '04267', 218, 26, 128370, 44.2074, 0.771564683746141, -70.7208, -1.23431080964441),
(1426, '04268', 218, 26, 33458, 44.2124, 0.771651950208741, -70.5387, -1.23113256507652),
(1427, '04270', 218, 26, 4828, 44.0949, 0.769601188337648, -70.5342, -1.23105402526018),
(1428, '04271', 218, 26, 11069, 44.2187, 0.771761905951617, -70.4767, -1.23005046094029),
(1429, '04274', 218, 26, 30868, 44.0405, 0.768651729224563, -70.4156, -1.22898406476732),
(1430, '04275', 218, 26, 33833, 44.6893, 0.779975425411502, -70.6374, -1.23285520504824),
(1431, '04276', 218, 26, 105944, 44.5465, 0.777483095239654, -70.5521, -1.23136643919629),
(1432, '04278', 218, 26, 128704, 44.5907, 0.778254530769036, -70.702, -1.23398268774503),
(1433, '04280', 218, 26, 128711, 44.1109, 0.769880441017967, -70.102, -1.22351071223307),
(1434, '04281', 218, 26, 128917, 44.2235, 0.771845681755712, -70.5176, -1.23076430060435),
(1435, '04282', 218, 26, 6415, 44.2635, 0.77254381345651, -70.1898, -1.22504311131632),
(1436, '04283', 218, 26, 129110, 44.2575, 0.77243909370139, -70.2418, -1.22595068252735),
(1437, '04284', 218, 26, 6665, 44.3548, 0.774137299063581, -70.0792, -1.22311277716361),
(1438, '04285', 218, 26, 129211, 44.7066, 0.780277367372097, -70.4524, -1.22962634593205),
(1439, '04286', 218, 26, 107393, 44.4176, 0.775233365833833, -70.8433, -1.2364488379781),
(1440, '04287', 218, 26, 196056, 43.9812, 0.76761674897813, -70.0928, -1.22335014194188),
(1441, '04288', 218, 26, 129274, 44.059, 0.768974615136182, -70.4146, -1.2289666114748),
(1442, '04289', 218, 26, 129280, 44.3281, 0.773671296153298, -70.5371, -1.23110463980849),
(1443, '04290', 218, 26, 33609, 44.4736, 0.77621075021495, -70.4507, -1.22959667533477),
(1444, '04291', 218, 26, 129286, 44.0413, 0.768665691858579, -70.446, -1.22951464485993),
(1445, '04292', 218, 26, 18216, 44.3743, 0.77447763826772, -70.4829, -1.23015867135391),
(1446, '04294', 218, 26, 287, 44.5965, 0.778355759865651, -70.2247, -1.22565223122526),
(1447, '04330', 218, 26, 7193, 44.3526, 0.774098901820037, -69.7319, -1.21705124867143),
(1448, '04332', 218, 26, 7193, 44.3362, 0.77381266782271, -69.7441, -1.21726417884018),
(1449, '04333', 218, 26, 7193, 44.3057, 0.773280342400852, -69.7822, -1.21792914928519),
(1450, '04336', 218, 26, 7193, 44.3365, 0.773817903810466, -69.7446, -1.21727290548644),
(1451, '04338', 218, 26, 7193, 44.3183, 0.773500253886603, -69.7768, -1.21783490150558),
(1452, '04341', 218, 26, 127152, 44.2741, 0.772728818357221, -69.4948, -1.21291307301496),
(1453, '04342', 218, 26, 20675, 44.0805, 0.76934986092536, -69.7373, -1.21714549645104),
(1454, '04343', 218, 26, 127396, 44.3134, 0.773414732753255, -69.9769, -1.22132730533882),
(1455, '04344', 218, 26, 27149, 44.2561, 0.772414659091863, -69.7815, -1.21791693198042),
(1456, '04345', 218, 26, 115683, 44.2311, 0.771978326778864, -69.7798, -1.21788726138314),
(1457, '04346', 218, 26, 5293, 44.2445, 0.772212200898631, -69.7625, -1.21758531942254),
(1458, '04347', 218, 26, 32679, 44.2804, 0.772838774100097, -69.7915, -1.21809146490562),
(1459, '04348', 218, 26, 3409, 44.1975, 0.771391896150194, -69.4738, -1.21254655387204),
(1460, '04349', 218, 26, 127866, 44.4365, 0.77556323306246, -70.0732, -1.22300805740849),
(1461, '04350', 218, 26, 27727, 44.1612, 0.77075834163172, -69.9484, -1.220829886502),
(1462, '04351', 218, 26, 585, 44.3311, 0.773723656030858, -69.8687, -1.21943885908816),
(1463, '04352', 218, 26, 4411, 44.5076, 0.776804162160628, -69.9898, -1.22155245281233),
(1464, '04353', 218, 26, 12825, 44.2049, 0.771521050514841, -69.6134, -1.21498303350782),
(1465, '04354', 218, 26, 28171, 44.3821, 0.774613773949375, -69.4313, -1.21180478893994),
(1466, '04355', 218, 26, 128635, 44.4083, 0.775071050213398, -69.9379, -1.22064662693054),
(1467, '04357', 218, 26, 5381, 44.0869, 0.769461561997488, -69.8028, -1.2182886871111),
(1468, '04358', 218, 26, 128879, 44.3957, 0.774851138727647, -69.5834, -1.21445943473222),
(1469, '04359', 218, 26, 128889, 44.2038, 0.771501851893069, -69.7813, -1.21791344132192),
(1470, '04360', 218, 26, 6557, 44.5334, 0.777254457107643, -69.9837, -1.22144598772796),
(1471, '04363', 218, 26, 18652, 44.3063, 0.773290814376364, -69.5759, -1.21432853503832),
(1472, '04364', 218, 26, 12913, 44.3071, 0.77330477701038, -69.9721, -1.22124352953472),
(1473, '04401', 218, 26, 34662, 44.8161, 0.782188502903031, -68.7792, -1.20042349688768),
(1474, '04402', 218, 26, 34662, 44.8319, 0.782464264924846, -68.7876, -1.20057010454485),
(1475, '04406', 218, 26, 26325, 45.3069, 0.790754578871819, -69.5561, -1.21398295984643),
(1476, '04408', 218, 26, 474, 44.9244, 0.784078694482941, -68.3361, -1.1926899429721),
(1477, '04410', 218, 26, 1076, 45.0885, 0.786942779785463, -68.9079, -1.202669735635),
(1478, '04411', 218, 26, 694, 44.9131, 0.783881472277465, -68.6248, -1.1977287085226),
(1479, '04412', 218, 26, 7666, 44.7876, 0.781691084066212, -68.7532, -1.19996971128217),
(1480, '04413', 218, 26, 19558, 45.5775, 0.795477439827716, -67.7253, -1.18202947190092),
(1481, '04414', 218, 26, 1195, 45.3083, 0.790779013481347, -69.0316, -1.20482870791972),
(1482, '04415', 218, 26, 126977, 45.3511, 0.7915260144012, -69.0589, -1.20530518280551),
(1483, '04416', 218, 26, 80024, 44.5764, 0.778004948686, -68.7918, -1.20064340837344),
(1484, '04417', 218, 26, 1239, 45.1785, 0.788513576112258, -68.4378, -1.19446494282138),
(1485, '04418', 218, 26, 32623, 45.0803, 0.7867996627868, -68.5943, -1.19719638310075),
(1486, '04419', 218, 26, 7911, 44.8007, 0.781919722198224, -69.0065, -1.20439063027747),
(1487, '04420', 218, 26, 72033, 44.3951, 0.774840666752135, -68.7899, -1.20061024711765),
(1488, '04421', 218, 26, 72033, 44.3913, 0.774774344240559, -68.8045, -1.20086506518844),
(1489, '04422', 218, 26, 8039, 45.0693, 0.78660767656908, -69.0866, -1.20578863900831),
(1490, '04423', 218, 26, 127165, 45.054, 0.786340641193525, -68.5455, -1.19634466242577),
(1491, '04424', 218, 26, 59197, 45.6586, 0.796892901851083, -67.8669, -1.18450085812174),
(1492, '04426', 218, 26, 0, 45.1857, 0.788639239818402, -69.2271, -1.20824082660737),
(1493, '04427', 218, 26, 743, 44.9804, 0.785056078864057, -69.0107, -1.20446393410605),
(1494, '04428', 218, 26, 127406, 44.8011, 0.781926703515232, -68.5616, -1.19662566043534),
(1495, '04429', 218, 26, 27452, 44.7622, 0.781247770436206, -68.6411, -1.19801319719068),
(1496, '04430', 218, 26, 127362, 45.6277, 0.796353595112217, -68.5726, -1.19681764665306),
(1497, '04431', 218, 26, 127369, 44.5843, 0.778142829696908, -68.6641, -1.19841462291864),
(1498, '04434', 218, 26, 314, 44.7856, 0.781656177481172, -69.1333, -1.206603707769),
(1499, '04435', 218, 26, 27125, 44.9655, 0.78479602480551, -69.1092, -1.20618308341927),
(1500, '04438', 218, 26, 2594, 44.5963, 0.778352269207147, -68.9268, -1.20299960286363),
(1501, '04441', 218, 26, 2868, 45.5022, 0.794163206900964, -69.4684, -1.21245230609243),
(1502, '04442', 218, 26, 127637, 45.4752, 0.793691968002925, -69.6966, -1.21643514744548),
(1503, '04443', 218, 26, 16297, 45.214, 0.789133167996716, -69.4069, -1.21137892860245),
(1504, '04444', 218, 26, 2956, 44.7528, 0.781083709486518, -68.8417, -1.20151432767018),
(1505, '04448', 218, 26, 95018, 45.2394, 0.789576481626723, -68.6593, -1.19833084711454),
(1506, '04449', 218, 26, 16505, 44.9457, 0.784450449613615, -68.9422, -1.20326838356843),
(1507, '04450', 218, 26, 127852, 44.9161, 0.783933832155025, -68.9282, -1.20302403747316),
(1508, '04451', 218, 26, 27631, 45.6052, 0.795960896030518, -68.2299, -1.19083640330648),
(1509, '04453', 218, 26, 103428, 45.2103, 0.789068590814392, -68.823, -1.20118795110006),
(1510, '04454', 218, 26, 127915, 45.5357, 0.794747892200382, -67.5334, -1.17868018506634),
(1511, '04455', 218, 26, 3715, 45.3724, 0.791897769531875, -68.2908, -1.19189930882094),
(1512, '04456', 218, 26, 127933, 44.8739, 0.783197303210683, -68.9432, -1.20328583686095),
(1513, '04457', 218, 26, 3781, 45.3645, 0.791759888520968, -68.5048, -1.19563431342021),
(1514, '04459', 218, 26, 128090, 45.5476, 0.794955586381369, -68.3099, -1.19223266670807),
(1515, '04460', 218, 26, 73428, 45.6179, 0.796182552845521, -68.4989, -1.19553133899434),
(1516, '04461', 218, 26, 10480, 44.945, 0.784438232308851, -68.6342, -1.19789276947229),
(1517, '04462', 218, 26, 128145, 45.6577, 0.796877193887815, -68.7041, -1.19911275461944),
(1518, '04463', 218, 26, 503, 45.2483, 0.78973181593015, -68.9848, -1.20401189382978),
(1519, '04464', 218, 26, 110500, 45.3039, 0.790702218994259, -69.4787, -1.21263207500538),
(1520, '04467', 218, 26, 128422, 45.0142, 0.785646000151232, -68.7357, -1.19966427866307),
(1521, '04468', 218, 26, 4772, 44.9297, 0.784171196933296, -68.6546, -1.1982488166397),
(1522, '04469', 218, 26, 128438, 44.9003, 0.78365807013321, -68.6747, -1.19859962781935),
(1523, '04471', 218, 26, 28156, 45.8935, 0.800992680264018, -67.8476, -1.1841640095761),
(1524, '04472', 218, 26, 23671, 44.5354, 0.777289363692683, -68.7458, -1.19984055691752),
(1525, '04473', 218, 26, 128438, 44.8901, 0.783480046549506, -68.6759, -1.19862057177037),
(1526, '04474', 218, 26, 128440, 44.7153, 0.78042921101702, -68.7798, -1.2004339688632),
(1527, '04475', 218, 26, 128484, 45.183, 0.788592115928598, -68.5904, -1.19712831525992),
(1528, '04476', 218, 26, 128512, 44.471, 0.776165371654398, -68.7096, -1.1992087477283),
(1529, '04478', 218, 26, 5481, 45.3978, 0.792341083161882, -70.0191, -1.22206383428316),
(1530, '04479', 218, 26, 106041, 45.1309, 0.787682799388309, -69.3094, -1.20967723258176),
(1531, '04481', 218, 26, 128777, 45.2718, 0.790141968304369, -69.1171, -1.20632096443017),
(1532, '04485', 218, 26, 128808, 45.503, 0.79417716953498, -69.4688, -1.21245928740944),
(1533, '04487', 218, 26, 349, 45.3941, 0.792276505979558, -68.1006, -1.18857969258365),
(1534, '04488', 218, 26, 128991, 44.8759, 0.783232209795723, -69.0884, -1.20582005493485),
(1535, '04489', 218, 26, 12131, 44.9136, 0.783890198923725, -68.6862, -1.19880034068333),
(1536, '04490', 218, 26, 126354, 45.4523, 0.793292287604219, -67.7194, -1.18192649747505),
(1537, '04491', 218, 26, 69774, 45.5581, 0.795138845952829, -67.4455, -1.17714604065384),
(1538, '04492', 218, 26, 129158, 45.3471, 0.791456201231121, -67.6959, -1.18151634510083),
(1539, '04493', 218, 26, 129249, 45.2734, 0.790169893572401, -68.5864, -1.19705850208984),
(1540, '04495', 218, 26, 6886, 45.4537, 0.793316722213746, -68.3309, -1.19259918585099),
(1541, '04496', 218, 26, 129366, 44.6581, 0.77943088268488, -68.9159, -1.20280936197516),
(1542, '04497', 218, 26, 129396, 45.6987, 0.797592778881133, -68.1011, -1.18858841922991),
(1543, '04530', 218, 26, 19093, 43.9128, 0.766422943769766, -69.8226, -1.21863426230299),
(1544, '04535', 218, 26, 126751, 44.3362, 0.77381266782271, -69.7451, -1.2172816321327),
(1545, '04536', 218, 26, 13338, 43.8547, 0.765408907474357, -69.6108, -1.21493765494727),
(1546, '04537', 218, 26, 126912, 43.8881, 0.765991847444523, -69.6199, -1.2150964799092),
(1547, '04538', 218, 26, 126913, 43.8503, 0.765332112987269, -69.6268, -1.21521690762759),
(1548, '04539', 218, 26, 15330, 43.9557, 0.767171690018872, -69.4993, -1.2129916128313),
(1549, '04541', 218, 26, 127081, 43.891, 0.766042461992831, -69.4975, -1.21296019690476),
(1550, '04543', 218, 26, 127213, 44.0303, 0.768473705640859, -69.4892, -1.21281533457684),
(1551, '04544', 218, 26, 127321, 43.8229, 0.764853892772223, -69.5946, -1.21465491160845),
(1552, '04547', 218, 26, 2610, 44.055, 0.768904801966102, -69.0941, -1.20591953870221),
(1553, '04548', 218, 26, 2693, 43.8066, 0.764569404104148, -69.7627, -1.21758881008105),
(1554, '04549', 218, 26, 0, 43.898, 0.766164635040471, -69.6269, -1.21521865295684),
(1555, '04551', 218, 26, 1103, 44.0097, 0.768114167814948, -69.4391, -1.21194092462159),
(1556, '04552', 218, 26, 128249, 43.8191, 0.764787570260647, -69.666, -1.21590107669437),
(1557, '04553', 218, 26, 10795, 44.0648, 0.769075844232797, -69.5472, -1.213827625543),
(1558, '04554', 218, 26, 128237, 43.8584, 0.765473484656681, -69.507, -1.2131260031837),
(1559, '04555', 218, 26, 128267, 44.106, 0.769794919884619, -69.4769, -1.21260065907885),
(1560, '04556', 218, 26, 127410, 43.9783, 0.767566134429822, -69.6116, -1.21495161758128),
(1561, '04558', 218, 26, 128502, 43.8916, 0.766052933968343, -69.5283, -1.21349775831437),
(1562, '04562', 218, 26, 128533, 43.769, 0.763913160305398, -69.8143, -1.21848939997508),
(1563, '04563', 218, 26, 75594, 43.9914, 0.767794772561833, -69.2655, -1.20891103304013),
(1564, '04564', 218, 26, 11702, 43.9167, 0.766491011610594, -69.4675, -1.21243659812916),
(1565, '04565', 218, 26, 128775, 43.7795, 0.764096419876858, -69.8486, -1.21908804790851),
(1566, '04567', 218, 26, 128831, 43.7259, 0.763160923397789, -69.8396, -1.21893096827583),
(1567, '04568', 218, 26, 113217, 43.8719, 0.7657091041057, -69.562, -1.2140859342723),
(1568, '04570', 218, 26, 0, 43.8083, 0.764599074701432, -69.6312, -1.21529370211468),
(1569, '04571', 218, 26, 129102, 43.898, 0.766164635040471, -69.6754, -1.21606513764406),
(1570, '04572', 218, 26, 129164, 44.044, 0.768712815748382, -69.5423, -1.21374210440965),
(1571, '04573', 218, 26, 28895, 43.9455, 0.766993666435168, -69.5515, -1.21390267470084),
(1572, '04574', 218, 26, 12671, 44.2746, 0.772737545003481, -69.3911, -1.21110316658064),
(1573, '04575', 218, 26, 129230, 43.8489, 0.765307678377742, -69.6507, -1.21563404131881),
(1574, '04576', 218, 26, 18161, 43.8194, 0.764792806248403, -69.6661, -1.21590282202362),
(1575, '04578', 218, 26, 129373, 43.9979, 0.767908218963213, -69.672, -1.21600579644949),
(1576, '04579', 218, 26, 129389, 43.9648, 0.767330514980803, -69.7877, -1.21802514239405),
(1577, '04605', 218, 26, 579, 44.5502, 0.777547672421978, -68.417, -1.19410191433696),
(1578, '04606', 218, 26, 34507, 44.584, 0.778137593709152, -67.7038, -1.18165422611174),
(1579, '04607', 218, 26, 127597, 44.4781, 0.77628929003129, -68.0685, -1.18801944189376),
(1580, '04609', 218, 26, 44585, 44.3857, 0.774676605802447, -68.2104, -1.19049606410234),
(1581, '04611', 218, 26, 34707, 44.4891, 0.776481276249009, -67.5895, -1.17965931477671),
(1582, '04612', 218, 26, 39360, 44.2399, 0.772131915753039, -68.3607, -1.19311929396809),
(1583, '04613', 218, 26, 126885, 44.3855, 0.774673115143943, -68.0431, -1.18757612826375),
(1584, '04614', 218, 26, 7554, 44.3178, 0.773491527240343, -68.6318, -1.19785088157024),
(1585, '04615', 218, 26, 126903, 44.3827, 0.774624245924887, -68.5957, -1.19722081771027),
(1586, '04616', 218, 26, 85331, 44.2493, 0.772295976702727, -68.5502, -1.19642669290062),
(1587, '04617', 218, 26, 1170, 44.3743, 0.77447763826772, -68.731, -1.19958224818822),
(1588, '04619', 218, 26, 71989, 45.1812, 0.788560700002062, -67.2813, -1.17428021002206),
(1589, '04622', 218, 26, 63647, 44.6018, 0.778448262316007, -67.9247, -1.18550965842939),
(1590, '04623', 218, 26, 127138, 44.708, 0.780301801981625, -67.7746, -1.18288991922215),
(1591, '04624', 218, 26, 20247, 44.4194, 0.775264781760369, -67.9905, -1.1866580850772),
(1592, '04625', 218, 26, 127170, 44.2487, 0.772285504727215, -68.2606, -1.19137221938684),
(1593, '04626', 218, 26, 15698, 44.691, 0.780005096008786, -67.2182, -1.17317890726405),
(1594, '04627', 218, 26, 127239, 44.2347, 0.772041158631936, -68.646, -1.19809871832403),
(1595, '04628', 218, 26, 127249, 44.8549, 0.782865690652805, -67.2781, -1.174224359486),
(1596, '04629', 218, 26, 127320, 44.4175, 0.775231620504581, -68.5231, -1.19595370867333),
(1597, '04630', 218, 26, 127357, 44.7074, 0.780291330006113, -67.4625, -1.17744274662667),
(1598, '04631', 218, 26, 8671, 44.9083, 0.78379769647337, -66.9945, -1.16927460572734),
(1599, '04634', 218, 26, 2595, 44.6257, 0.778865396007234, -68.2203, -1.19066885169829),
(1600, '04635', 218, 26, 127532, 44.1128, 0.769913602273755, -68.3542, -1.19300584756671),
(1601, '04637', 218, 26, 127602, 45.1854, 0.788634003830646, -67.6014, -1.17986700895769),
(1602, '04640', 218, 26, 9313, 44.5039, 0.776739584978304, -68.2425, -1.19105631479223),
(1603, '04642', 218, 26, 127685, 44.3368, 0.773823139798222, -68.7998, -1.20078303471359),
(1604, '04643', 218, 26, 13897, 44.5976, 0.778374958487423, -67.8137, -1.18357234295968),
(1605, '04644', 218, 26, 127788, 44.4133, 0.775158316675998, -68.2506, -1.19119768646164),
(1606, '04645', 218, 26, 127811, 44.0492, 0.768803572869486, -68.6281, -1.19778630438792),
(1607, '04646', 218, 26, 127815, 44.2599, 0.772480981603438, -68.2258, -1.19076484480715),
(1608, '04648', 218, 26, 3452, 44.6665, 0.779577490342047, -67.5882, -1.17963662549643),
(1609, '04649', 218, 26, 127840, 44.5775, 0.778024147307772, -67.6032, -1.17989842488423),
(1610, '04650', 218, 26, 127976, 44.2893, 0.772994108403525, -68.7129, -1.19926634359361),
(1611, '04652', 218, 26, 128017, 44.8639, 0.783022770285484, -66.9934, -1.16925540710557),
(1612, '04653', 218, 26, 126834, 44.1577, 0.7706972551079, -68.4368, -1.19444748952886),
(1613, '04654', 218, 26, 128031, 44.7229, 0.780561856040172, -67.4638, -1.17746543590695),
(1614, '04655', 218, 26, 128033, 44.6714, 0.779663011475395, -67.4076, -1.17648456086733),
(1615, '04656', 218, 26, 128057, 44.2612, 0.772503670883714, -68.3145, -1.19231295185367),
(1616, '04657', 218, 26, 128111, 45.0188, 0.785726285296823, -67.3858, -1.17610407909039),
(1617, '04658', 218, 26, 128135, 44.5284, 0.777167190645043, -67.885, -1.18481676271635),
(1618, '04660', 218, 26, 0, 44.3161, 0.773461856643059, -68.3649, -1.19319259779667),
(1619, '04662', 218, 26, 128379, 44.2916, 0.773034250976321, -68.2847, -1.19179284373657),
(1620, '04664', 218, 26, 28723, 44.5204, 0.777027564304884, -68.1967, -1.19025695399482),
(1621, '04665', 218, 26, 17463, 44.3186, 0.773505489874359, -68.2076, -1.19044719488328),
(1622, '04666', 218, 26, 17567, 44.9512, 0.784546442722475, -67.1604, -1.1721701069564),
(1623, '04667', 218, 26, 11148, 44.9846, 0.785129382692641, -67.109, -1.17127300772087),
(1624, '04668', 218, 26, 5231, 45.2269, 0.789358315470223, -67.5651, -1.17923345443922),
(1625, '04669', 218, 26, 128612, 44.4237, 0.775339830918205, -68.0338, -1.18741381264332),
(1626, '04671', 218, 26, 128668, 45.0629, 0.786495975496953, -67.1684, -1.17230973329656),
(1627, '04672', 218, 26, 128732, 44.4306, 0.775460258636593, -68.2838, -1.1917771357733),
(1628, '04673', 218, 26, 128748, 44.33, 0.773704457409086, -68.7089, -1.19919653042353),
(1629, '04674', 218, 26, 128761, 44.3166, 0.773470583289319, -68.3647, -1.19318910713817),
(1630, '04675', 218, 26, 128762, 44.303, 0.773233218511048, -68.2408, -1.19102664419495),
(1631, '04676', 218, 26, 11850, 44.3427, 0.77392611422409, -68.6468, -1.19811268095804),
(1632, '04677', 218, 26, 18119, 44.4935, 0.776558070736097, -68.1807, -1.1899777013145),
(1633, '04679', 218, 26, 128953, 44.279, 0.772814339490569, -68.33, -1.19258347788773),
(1634, '04680', 218, 26, 117905, 44.4981, 0.776638355881689, -67.9451, -1.1858657055968),
(1635, '04681', 218, 26, 28706, 44.1833, 0.771144059396411, -68.675, -1.19860486380711),
(1636, '04683', 218, 26, 12218, 44.2202, 0.771788085890396, -68.7076, -1.19917384114326),
(1637, '04684', 218, 26, 106741, 44.4937, 0.776561561394601, -68.5299, -1.19607239106246),
(1638, '04685', 218, 26, 129040, 44.1586, 0.770712963071168, -68.4381, -1.19447017880913),
(1639, '04686', 218, 26, 638, 44.8156, 0.782179776256771, -67.5834, -1.17955284969234),
(1640, '04690', 218, 26, 129300, 44.2513, 0.772330883287767, -68.3891, -1.19361496747565),
(1641, '04691', 218, 26, 34415, 44.7912, 0.781753915919284, -67.1766, -1.17245285029522),
(1642, '04693', 218, 26, 129375, 44.3776, 0.774535234133036, -68.0669, -1.18799151662573),
(1643, '04694', 218, 26, 31717, 45.1544, 0.788092951762528, -67.4062, -1.1764601262578),
(1644, '04730', 218, 26, 127775, 46.1221, 0.804982502934077, -67.8375, -1.18398773132165),
(1645, '04732', 218, 26, 13301, 46.6257, 0.81377198104712, -68.4201, -1.19415601954377),
(1646, '04733', 218, 26, 126862, 45.8049, 0.799446318546751, -68.3954, -1.19372492321853),
(1647, '04734', 218, 26, 19318, 46.5021, 0.811614754091655, -67.8694, -1.18454449135304),
(1648, '04735', 218, 26, 19494, 46.4187, 0.810159149495492, -67.848, -1.18417099089311),
(1649, '04736', 218, 26, 127039, 46.8475, 0.817643121328044, -68.0125, -1.18704205751264),
(1650, '04737', 218, 26, 127118, 46.6207, 0.81368471458452, -69.5219, -1.21338605724225),
(1651, '04738', 218, 26, 127186, 46.7554, 0.816035673086957, -68.0973, -1.18852209671833),
(1652, '04739', 218, 26, 15848, 47.0397, 0.820997644150377, -68.5898, -1.19711784328441),
(1653, '04740', 218, 26, 2193, 46.6557, 0.814295579822719, -67.9375, -1.18573306057365),
(1654, '04741', 218, 26, 0, 47.445, 0.82807146360871, -69.2092, -1.20792841267126),
(1655, '04742', 218, 26, 127500, 46.7689, 0.816271292535976, -67.8331, -1.18391093683457),
(1656, '04743', 218, 26, 127504, 47.2519, 0.824701232823109, -68.5913, -1.19714402322319),
(1657, '04744', 218, 26, 127505, 47.2401, 0.824495283971373, -68.5806, -1.19695727299322),
(1658, '04745', 218, 26, 127535, 46.6811, 0.814738893452725, -68.3331, -1.19263758309454),
(1659, '04746', 218, 26, 41155, 47.2972, 0.825491866974262, -68.1585, -1.18959023822056),
(1660, '04747', 218, 26, 127808, 46.0115, 0.803052168781371, -68.2734, -1.1915956215311),
(1661, '04750', 218, 26, 10107, 46.9089, 0.818714753488768, -67.8247, -1.1837643291774),
(1662, '04751', 218, 26, 10107, 46.929, 0.819065564668419, -67.9133, -1.18531069089467),
(1663, '04756', 218, 26, 128040, 46.8845, 0.818288893151282, -67.9475, -1.18590759349885),
(1664, '04757', 218, 26, 30422, 46.6537, 0.814260673237679, -68.1851, -1.19005449580159),
(1665, '04758', 218, 26, 4007, 46.5169, 0.81187306282095, -67.8665, -1.18449387680473),
(1666, '04759', 218, 26, 128085, 46.6256, 0.813770235717868, -68.4203, -1.19415951020228),
(1667, '04760', 218, 26, 588, 46.3085, 0.808235796659794, -67.8412, -1.18405230850398),
(1668, '04761', 218, 26, 128238, 46.1279, 0.805083732030692, -67.9699, -1.18629854725129),
(1669, '04762', 218, 26, 96519, 46.9668, 0.819725299125673, -68.1186, -1.18889385184901),
(1670, '04763', 218, 26, 23561, 46.1063, 0.804706740912261, -68.0973, -1.18852209671833),
(1671, '04764', 218, 26, 42466, 46.4034, 0.809892114119937, -68.5509, -1.19643891020538),
(1672, '04765', 218, 26, 23785, 45.9978, 0.802813058673848, -68.4436, -1.19456617191799),
(1673, '04766', 218, 26, 128517, 46.8442, 0.817585525462728, -68.198, -1.19027964327509),
(1674, '04768', 218, 26, 42669, 46.7894, 0.816629085032635, -68.5431, -1.19630277452373),
(1675, '04769', 218, 26, 105450, 46.6798, 0.814716204172449, -68.0098, -1.18699493362284),
(1676, '04770', 218, 26, 42723, 46.9622, 0.819645013980081, -68.608, -1.19743549320827),
(1677, '04772', 218, 26, 128718, 47.2348, 0.824402781521018, -68.3401, -1.19275975614218),
(1678, '04773', 218, 26, 121342, 47.3194, 0.825879330068205, -68.2251, -1.19075262750238),
(1679, '04774', 218, 26, 11751, 47.103, 0.822102437566889, -69.0508, -1.2051638111361),
(1680, '04775', 218, 26, 11906, 46.6568, 0.81431477844449, -68.406, -1.19390992811924),
(1681, '04776', 218, 26, 128799, 45.8144, 0.79961212482569, -68.3106, -1.19224488401284),
(1682, '04777', 218, 26, 128800, 45.8985, 0.801079946726617, -68.4932, -1.19543185522698),
(1683, '04779', 218, 26, 28619, 47.1694, 0.823261336190213, -68.3019, -1.19209304036792),
(1684, '04780', 218, 26, 128841, 46.1668, 0.805762665109718, -68.2707, -1.19154849764129),
(1685, '04781', 218, 26, 129171, 47.1486, 0.822898307705799, -68.636, -1.19792418539883),
(1686, '04782', 218, 26, 117886, 45.8634, 0.800467336159167, -68.5061, -1.19565700270049),
(1687, '04783', 218, 26, 38390, 47.0572, 0.821303076769476, -68.2546, -1.19126749963172),
(1688, '04785', 218, 26, 12525, 47.1637, 0.82316185242285, -67.9436, -1.18583952565802),
(1689, '04786', 218, 26, 12668, 46.7856, 0.816562762521059, -68.1491, -1.18942617727087),
(1690, '04787', 218, 26, 723, 46.6035, 0.813384517953177, -67.933, -1.18565452075731),
(1691, '04788', 218, 26, 26164, 46.9705, 0.819789876307997, -68.5714, -1.19679670270204),
(1692, '04841', 218, 26, 187, 44.108, 0.769829826469659, -69.1132, -1.20625289658935),
(1693, '04843', 218, 26, 1304, 44.2082, 0.771578646380157, -69.0693, -1.20548669704772),
(1694, '04846', 218, 26, 47449, 44.1306, 0.77022427088061, -69.096, -1.205952699958),
(1695, '04847', 218, 26, 665, 44.2566, 0.772423385738122, -69.1469, -1.20684107254727),
(1696, '04848', 218, 26, 127813, 44.3057, 0.773280342400852, -68.9213, -1.20290360975477),
(1697, '04849', 218, 26, 33086, 44.312, 0.773390298143727, -69.0906, -1.20585845217839),
(1698, '04850', 218, 26, 127961, 44.297, 0.773128498755928, -69.1094, -1.20618657407777),
(1699, '04851', 218, 26, 128088, 44.0491, 0.768801827540234, -68.6279, -1.19778281372942),
(1700, '04852', 218, 26, 42134, 43.7652, 0.763846837793822, -69.3131, -1.20974180976408),
(1701, '04853', 218, 26, 61095, 44.1543, 0.770637913913332, -68.8655, -1.20192971603215),
(1702, '04854', 218, 26, 128453, 44.0799, 0.769339388949849, -69.0862, -1.20578165769131),
(1703, '04855', 218, 26, 128582, 44.0434, 0.768702343772871, -69.1465, -1.20683409123026),
(1704, '04856', 218, 26, 11639, 44.1765, 0.771025377007275, -69.088, -1.20581307361784),
(1705, '04857', 218, 26, 0, 44.0012, 0.767965814828529, -69.2016, -1.20779576764811),
(1706, '04858', 218, 26, 128936, 44.0434, 0.768702343772871, -69.1462, -1.2068288552425),
(1707, '04859', 218, 26, 128970, 44.0136, 0.768182235655776, -69.1725, -1.20728787683578),
(1708, '04860', 218, 26, 129060, 43.9671, 0.767370657553599, -69.211, -1.2079598285978),
(1709, '04861', 218, 26, 6315, 44.0845, 0.76941967409544, -69.1791, -1.20740306856641),
(1710, '04862', 218, 26, 455, 44.2585, 0.77245654699391, -69.258, -1.20878013334623),
(1711, '04863', 218, 26, 129154, 44.0491, 0.768801827540234, -68.8187, -1.20111290194222),
(1712, '04864', 218, 26, 12663, 44.1191, 0.77002355801663, -69.2461, -1.20857243916525),
(1713, '04865', 218, 26, 129289, 44.1901, 0.771262741785546, -69.1548, -1.20697895355817),
(1714, '04901', 218, 26, 25838, 44.5525, 0.777587814994774, -69.6317, -1.21530242876094),
(1715, '04903', 218, 26, 25838, 44.5394, 0.777359176862762, -69.6349, -1.215358279297),
(1716, '04910', 218, 26, 7043, 44.5771, 0.778017165990764, -69.4656, -1.21240343687337),
(1717, '04911', 218, 26, 31652, 44.7968, 0.781851654357396, -69.894, -1.21988042738892),
(1718, '04912', 218, 26, 7182, 44.953, 0.784577858649011, -69.6637, -1.21586093412157),
(1719, '04915', 218, 26, 7375, 44.4208, 0.775289216369897, -69.0038, -1.20434350638766),
(1720, '04917', 218, 26, 53397, 44.4526, 0.775844231072031, -69.8593, -1.21927479813847),
(1721, '04918', 218, 26, 126857, 44.5471, 0.777493567215166, -69.893, -1.2198629740964),
(1722, '04920', 218, 26, 777, 45.1258, 0.787593787596457, -69.8568, -1.21923116490718),
(1723, '04921', 218, 26, 1162, 44.5185, 0.776994403049096, -69.1015, -1.20604869306686),
(1724, '04922', 218, 26, 53752, 44.6642, 0.779537347769251, -69.3323, -1.21007691298046);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(1725, '04923', 218, 26, 1302, 45.0514, 0.786295262632973, -69.4287, -1.21175941037939),
(1726, '04924', 218, 26, 306, 44.7557, 0.781134324034826, -69.5527, -1.21392361865186),
(1727, '04925', 218, 26, 127035, 45.2391, 0.789571245638967, -69.9196, -1.22032723167743),
(1728, '04926', 218, 26, 0, 44.4786, 0.77629801667755, -69.5173, -1.21330577209665),
(1729, '04927', 218, 26, 1630, 44.5976, 0.778374958487423, -69.5075, -1.21313472982996),
(1730, '04928', 218, 26, 127156, 44.9328, 0.784225302140108, -69.2146, -1.20802266045087),
(1731, '04929', 218, 26, 2034, 44.7623, 0.781249515765458, -69.3118, -1.20971912048381),
(1732, '04930', 218, 26, 2038, 45.0237, 0.785811806430171, -69.2885, -1.20931245876809),
(1733, '04932', 218, 26, 127262, 44.7005, 0.780170902287725, -69.1021, -1.20605916504237),
(1734, '04933', 218, 26, 127367, 44.8208, 0.782270533377874, -69.2227, -1.20816403212028),
(1735, '04935', 218, 26, 127388, 44.4474, 0.775753473950928, -69.6061, -1.21485562447242),
(1736, '04936', 218, 26, 15957, 45.1806, 0.78855022802655, -70.4929, -1.23033320427911),
(1737, '04937', 218, 26, 2367, 44.6041, 0.778488404888803, -69.6335, -1.21533384468747),
(1738, '04938', 218, 26, 8849, 44.6712, 0.779659520816891, -70.1474, -1.22430309171347),
(1739, '04939', 218, 26, 2663, 45.0386, 0.786071860488718, -69.1611, -1.20708890930105),
(1740, '04940', 218, 26, 127471, 44.621, 0.77878336553239, -70.0756, -1.22304994531054),
(1741, '04941', 218, 26, 29850, 44.4639, 0.776041453277507, -69.3079, -1.20965105264298),
(1742, '04942', 218, 26, 745, 45.066, 0.786550080703765, -69.6196, -1.21509124392144),
(1743, '04943', 218, 26, 165, 44.8861, 0.783410233379427, -69.4546, -1.21221145065565),
(1744, '04944', 218, 26, 94928, 44.6639, 0.779532111781495, -69.6337, -1.21533733534598),
(1745, '04945', 218, 26, 127816, 45.6725, 0.79713550261711, -70.2666, -1.22638352418185),
(1746, '04947', 218, 26, 88287, 45.0603, 0.786450596936401, -70.3211, -1.22733472862418),
(1747, '04949', 218, 26, 3751, 44.3667, 0.774344993244568, -69.3407, -1.21022352063763),
(1748, '04950', 218, 26, 3938, 44.7977, 0.781867362320664, -69.8781, -1.21960292003785),
(1749, '04951', 218, 26, 10560, 44.5895, 0.778233586818012, -69.0438, -1.20504163808846),
(1750, '04952', 218, 26, 33340, 44.4106, 0.775111192786194, -69.1516, -1.20692310302211),
(1751, '04953', 218, 26, 10799, 44.8343, 0.782506152826894, -69.2698, -1.20898608219797),
(1752, '04954', 218, 26, 128240, 44.8831, 0.783357873501867, -70.091, -1.22331872601535),
(1753, '04955', 218, 26, 4554, 44.6764, 0.779750277937995, -69.9822, -1.22141980778918),
(1754, '04956', 218, 26, 128247, 44.8054, 0.782001752673067, -70.1132, -1.22370618910929),
(1755, '04957', 218, 26, 128271, 44.6741, 0.779710135365199, -69.8536, -1.21917531437111),
(1756, '04958', 218, 26, 128275, 44.951, 0.784542952063971, -69.9457, -1.2207827626122),
(1757, '04961', 218, 26, 128240, 45.0129, 0.785623310870956, -70.0846, -1.22320702494322),
(1758, '04962', 218, 26, 128365, 44.4786, 0.77629801667755, -69.6243, -1.21517327439629),
(1759, '04963', 218, 26, 4710, 44.5466, 0.777484840568906, -69.7211, -1.21686275311222),
(1760, '04964', 218, 26, 128432, 44.9435, 0.784412052370072, -70.6528, -1.23312398575305),
(1761, '04965', 218, 26, 4846, 44.8607, 0.78296691974942, -69.3736, -1.21079773396154),
(1762, '04966', 218, 26, 11173, 44.8441, 0.782677195093589, -70.3792, -1.22834876491959),
(1763, '04967', 218, 26, 28268, 44.7725, 0.781427539349161, -69.3991, -1.2112427929208),
(1764, '04969', 218, 26, 14433, 44.7666, 0.781324564923294, -69.2296, -1.20828445983867),
(1765, '04970', 218, 26, 105575, 44.9854, 0.785143345326657, -70.6605, -1.23325837610545),
(1766, '04971', 218, 26, 57331, 44.9212, 0.784022843946877, -69.6188, -1.21507728128743),
(1767, '04972', 218, 26, 5647, 44.5137, 0.776910627245, -68.8127, -1.2010081821871),
(1768, '04973', 218, 26, 128764, 44.663, 0.779516403818227, -69.3332, -1.21009262094373),
(1769, '04974', 218, 26, 128766, 44.4699, 0.776146173032626, -68.9222, -1.20291931771804),
(1770, '04975', 218, 26, 11896, 44.6255, 0.77886190534873, -69.5901, -1.21457637179211),
(1771, '04976', 218, 26, 128826, 44.7598, 0.781205882534158, -69.7146, -1.21674930671084),
(1772, '04978', 218, 26, 5916, 44.6197, 0.778760676252114, -69.8037, -1.21830439507437),
(1773, '04979', 218, 26, 117834, 44.9505, 0.784534225417711, -69.8539, -1.21918055035887),
(1774, '04981', 218, 26, 129004, 44.5328, 0.777243985132131, -68.8616, -1.20186164819133),
(1775, '04982', 218, 26, 132, 45.0941, 0.787040518223575, -70.4708, -1.22994748651442),
(1776, '04983', 218, 26, 12158, 44.8688, 0.783108291418832, -70.2333, -1.22580232954093),
(1777, '04984', 218, 26, 12281, 44.697, 0.780109815763905, -70.2811, -1.22663659692339),
(1778, '04985', 218, 26, 129254, 45.427, 0.792850719303464, -69.9799, -1.22137966521638),
(1779, '04986', 218, 26, 126344, 44.581, 0.778085233831592, -69.243, -1.20851833395843),
(1780, '04987', 218, 26, 199, 44.6794, 0.779802637815554, -69.2529, -1.20869112155438),
(1781, '04988', 218, 26, 6476, 44.6122, 0.778629776558214, -69.3412, -1.21023224728389),
(1782, '04989', 218, 26, 129143, 44.4311, 0.775468985282853, -69.6545, -1.21570036383039),
(1783, '04992', 218, 26, 129252, 44.6624, 0.779505931842715, -70.1539, -1.22441653811485),
(1784, '05001', 218, 55, 172788, 43.6613, 0.762033440701, -72.3559, -1.26284868824377),
(1785, '05009', 218, 55, 172788, 43.6504, 0.761843199812533, -72.3231, -1.26227622024911),
(1786, '05030', 218, 55, 171692, 43.4469, 0.758291454784724, -72.4224, -1.26400933219634),
(1787, '05031', 218, 55, 29152, 43.7289, 0.763213283275348, -72.6189, -1.26743890417651),
(1788, '05032', 218, 55, 220, 43.8075, 0.764585112067416, -72.6715, -1.26835694736306),
(1789, '05033', 218, 55, 1076, 44.0095, 0.768110677156445, -72.1566, -1.25937024704454),
(1790, '05034', 218, 55, 19494, 43.5728, 0.760488824312985, -72.6175, -1.26741446956698),
(1791, '05035', 218, 55, 171779, 43.6085, 0.761111906855947, -72.6868, -1.26862398273861),
(1792, '05036', 218, 55, 13444, 44.0309, 0.768484177616371, -72.594, -1.26700431719276),
(1793, '05037', 218, 55, 1191, 43.4595, 0.758511366270476, -72.4926, -1.26523455333124),
(1794, '05038', 218, 55, 1509, 43.9855, 0.767691798135966, -72.4463, -1.26442646588757),
(1795, '05039', 218, 55, 743, 44.0358, 0.768569698749719, -72.2955, -1.26179450937556),
(1796, '05040', 218, 55, 127327, 44.0589, 0.76897286980693, -72.2052, -1.26021847706101),
(1797, '05041', 218, 55, 148521, 43.9545, 0.767150746067848, -72.5464, -1.26617354046881),
(1798, '05042', 218, 55, 171974, 44.5651, 0.777807726480525, -72.0346, -1.25724094535711),
(1799, '05043', 218, 55, 171978, 43.8177, 0.764763135651119, -72.1993, -1.26011550263514),
(1800, '05045', 218, 55, 99, 43.9059, 0.766302516051378, -72.1579, -1.25939293632482),
(1801, '05046', 218, 55, 113503, 44.2341, 0.772030686656424, -72.2625, -1.2612185507224),
(1802, '05047', 218, 55, 2998, 43.661, 0.762028204713244, -72.3396, -1.26256419957569),
(1803, '05048', 218, 55, 165, 43.5921, 0.76082567285862, -72.4088, -1.26377196741807),
(1804, '05049', 218, 55, 172106, 43.546, 0.760021076073451, -72.4251, -1.26405645608615),
(1805, '05050', 218, 55, 172235, 44.2605, 0.77249145357895, -72.0566, -1.25762491779255),
(1806, '05051', 218, 55, 33420, 44.1083, 0.769835062457415, -72.121, -1.25874890983083),
(1807, '05052', 218, 55, 151206, 43.5924, 0.760830908846376, -72.3515, -1.26277189375668),
(1808, '05053', 218, 55, 172336, 43.721, 0.763075402264441, -72.4968, -1.26530785715983),
(1809, '05054', 218, 55, 172345, 43.8429, 0.765202958622622, -72.1856, -1.25987639252762),
(1810, '05055', 218, 55, 23480, 43.7164, 0.762995117118849, -72.3091, -1.26203187415383),
(1811, '05056', 218, 55, 14433, 43.2864, 0.755490201335273, -72.4774, -1.26496926328494),
(1812, '05058', 218, 55, 172418, 43.8917, 0.766054679297595, -72.2659, -1.26127789191697),
(1813, '05059', 218, 55, 172434, 43.6557, 0.761935702262889, -72.4296, -1.26413499590248),
(1814, '05060', 218, 55, 5293, 43.931, 0.766740593693629, -72.6487, -1.2679590122936),
(1815, '05061', 218, 55, 172439, 43.9313, 0.766745829681385, -72.5898, -1.26693101336418),
(1816, '05062', 218, 55, 33727, 43.4982, 0.759186808690997, -72.5952, -1.26702526114379),
(1817, '05065', 218, 55, 24789, 43.7765, 0.764044059999298, -72.4159, -1.26389588579496),
(1818, '05067', 218, 55, 172564, 43.6909, 0.762550058159591, -72.5375, -1.26601820616539),
(1819, '05068', 218, 55, 172569, 43.795, 0.764366945910917, -72.5307, -1.26589952377625),
(1820, '05069', 218, 55, 172570, 44.2282, 0.771927712230556, -72.124, -1.25880126970839),
(1821, '05070', 218, 55, 172573, 43.8322, 0.765016208392658, -72.3772, -1.26322044337444),
(1822, '05071', 218, 55, 114099, 43.5571, 0.760214807620422, -72.5342, -1.26596061030007),
(1823, '05072', 218, 55, 57753, 43.8776, 0.765808587873064, -72.3668, -1.26303892913223),
(1824, '05073', 218, 55, 172628, 43.6293, 0.761474935340362, -72.4631, -1.2647196812019),
(1825, '05074', 218, 55, 0, 43.82, 0.764803278223915, -72.2306, -1.26066179069102),
(1826, '05075', 218, 55, 133385, 43.8199, 0.764801532894663, -72.2748, -1.2614332262204),
(1827, '05076', 218, 55, 127327, 44.0641, 0.769063626928033, -72.2232, -1.26053263632637),
(1828, '05077', 218, 55, 121752, 43.916, 0.76647879430583, -72.4691, -1.26482440095702),
(1829, '05079', 218, 55, 172671, 43.9561, 0.767178671335879, -72.3247, -1.26230414551714),
(1830, '05081', 218, 55, 172711, 44.148, 0.770527958170457, -72.044, -1.25740500630679),
(1831, '05083', 218, 55, 172735, 43.9355, 0.766819133509969, -72.2497, -1.26099514857815),
(1832, '05084', 218, 55, 12751, 43.7133, 0.762941011912037, -72.4047, -1.26370040891874),
(1833, '05085', 218, 55, 126544, 44.0657, 0.769091552196065, -72.1234, -1.25879079773288),
(1834, '05086', 218, 55, 172764, 44.1342, 0.770287102733681, -72.2545, -1.26107892438224),
(1835, '05088', 218, 55, 511, 43.6731, 0.762239389552736, -72.3151, -1.26213659390895),
(1836, '05089', 218, 55, 18652, 43.4775, 0.758825525535835, -72.3923, -1.26348398809149),
(1837, '05091', 218, 55, 569, 43.6253, 0.761405122170282, -72.5168, -1.26565692301022),
(1838, '05101', 218, 55, 171732, 43.134, 0.752830319555234, -72.4518, -1.26452245899643),
(1839, '05141', 218, 55, 124371, 43.1516, 0.753137497503585, -72.5679, -1.26654878625799),
(1840, '05142', 218, 55, 53919, 43.3693, 0.756937079285177, -72.6058, -1.2672102660445),
(1841, '05143', 218, 55, 8056, 43.2795, 0.755369773616886, -72.5756, -1.2666831766104),
(1842, '05144', 218, 55, 0, 43.2857, 0.755477984030509, -72.6325, -1.26767626895478),
(1843, '05146', 218, 55, 27298, 43.1478, 0.753071174992009, -72.6251, -1.26754711459013),
(1844, '05148', 218, 55, 49032, 43.2265, 0.754444749113329, -72.7988, -1.27057875150085),
(1845, '05149', 218, 55, 37000, 43.3957, 0.757397846207703, -72.7011, -1.26887356482165),
(1846, '05150', 218, 55, 104735, 43.3331, 0.756305270095955, -72.5276, -1.26584541856944),
(1847, '05151', 218, 55, 67691, 43.3954, 0.757392610219947, -72.5009, -1.26537941565916),
(1848, '05152', 218, 55, 33609, 43.1122, 0.752449837778299, -73.013, -1.27431724675862),
(1849, '05153', 218, 55, 172427, 43.4149, 0.757732949424086, -72.6039, -1.26717710478871),
(1850, '05154', 218, 55, 172501, 43.1345, 0.752839046201494, -72.5052, -1.26545446481699),
(1851, '05155', 218, 55, 172556, 43.1147, 0.752493471009599, -72.9195, -1.27268536390801),
(1852, '05156', 218, 55, 349, 43.2965, 0.755666479589725, -72.4818, -1.26504605777203),
(1853, '05158', 218, 55, 13249, 43.0758, 0.751814537930573, -72.456, -1.26459576282501),
(1854, '05159', 218, 55, 172776, 43.0854, 0.751982089538765, -72.4396, -1.26430952882768),
(1855, '05161', 218, 55, 6746, 43.2839, 0.755446568103974, -72.7932, -1.27048101306274),
(1856, '05201', 218, 55, 26498, 42.8818, 0.748428599181704, -73.1983, -1.27755134186257),
(1857, '05250', 218, 55, 15026, 43.0681, 0.75168014757817, -73.1519, -1.27674150908964),
(1858, '05251', 218, 55, 101475, 43.5988, 0.760942609918504, -72.9844, -1.27381808259255),
(1859, '05252', 218, 55, 124677, 43.0614, 0.751563210518286, -73.1369, -1.27647970970184),
(1860, '05253', 218, 55, 171941, 43.225, 0.754418569174549, -73.0197, -1.2744341838185),
(1861, '05254', 218, 55, 585, 43.1624, 0.7533259930628, -73.0716, -1.27534000970029),
(1862, '05255', 218, 55, 150500, 43.1939, 0.753875771777179, -73.0669, -1.27525797922544),
(1863, '05257', 218, 55, 172312, 42.9296, 0.749262866564158, -73.2436, -1.27834197601372),
(1864, '05260', 218, 55, 128352, 42.8199, 0.74734824037472, -73.2497, -1.27844844109809),
(1865, '05261', 218, 55, 172421, 42.7965, 0.746939833329753, -73.2248, -1.27801385411434),
(1866, '05262', 218, 55, 172506, 42.9461, 0.749550845890737, -73.2175, -1.27788644507895),
(1867, '05301', 218, 55, 171775, 42.8444, 0.747775846041459, -72.6871, -1.26862921872637),
(1868, '05302', 218, 55, 171775, 42.8543, 0.747948633637406, -72.6552, -1.26807245869498),
(1869, '05303', 218, 55, 171775, 42.8553, 0.747966086929926, -72.5595, -1.26640217860083),
(1870, '05304', 218, 55, 171775, 42.8841, 0.7484687417545, -72.556, -1.26634109207701),
(1871, '05340', 218, 55, 34907, 43.1098, 0.752407949876251, -72.8813, -1.27201864813374),
(1872, '05341', 218, 55, 127332, 42.9606, 0.749803918632276, -72.7865, -1.27036407600285),
(1873, '05342', 218, 55, 3395, 42.7693, 0.746465103773211, -72.799, -1.27058224215935),
(1874, '05343', 218, 55, 22217, 43.1119, 0.752444601790543, -72.8382, -1.27126641122613),
(1875, '05344', 218, 55, 66631, 42.8594, 0.748037645429258, -72.7265, -1.26931687845166),
(1876, '05345', 218, 55, 151072, 42.9832, 0.750198363043227, -72.6587, -1.2681335452188),
(1877, '05346', 218, 55, 24157, 42.958, 0.749758540071724, -72.5639, -1.26647897308791),
(1878, '05350', 218, 55, 172443, 42.7716, 0.746505246346007, -72.9504, -1.27322467064687),
(1879, '05351', 218, 55, 172559, 42.9697, 0.749962743594207, -72.7018, -1.26888578212641),
(1880, '05352', 218, 55, 98270, 42.7884, 0.746798461660342, -73.0799, -1.2754848720282),
(1881, '05353', 218, 55, 52159, 43.0641, 0.75161033440809, -72.6675, -1.26828713419298),
(1882, '05354', 218, 55, 6535, 42.7624, 0.746344676054823, -72.5269, -1.26583320126468),
(1883, '05355', 218, 55, 172690, 43.0201, 0.750842389537213, -72.8066, -1.2707148871825),
(1884, '05356', 218, 55, 129244, 42.9597, 0.749788210669008, -72.8715, -1.27184760586705),
(1885, '05357', 218, 55, 172733, 42.9265, 0.749208761357346, -72.6159, -1.26738654429895),
(1886, '05358', 218, 55, 172743, 42.7888, 0.74680544297735, -72.7483, -1.26969736022859),
(1887, '05359', 218, 55, 172765, 43.1644, 0.75336089964784, -72.7188, -1.26918248809925),
(1888, '05360', 218, 55, 172767, 43.0634, 0.751598117103326, -72.9234, -1.27275343174883),
(1889, '05361', 218, 55, 172792, 42.784, 0.746721667173254, -72.8739, -1.2718894937691),
(1890, '05362', 218, 55, 14865, 42.9478, 0.749580516488021, -72.6595, -1.26814750785282),
(1891, '05363', 218, 55, 14869, 42.882, 0.748432089840208, -72.8982, -1.27231360877733),
(1892, '05401', 218, 55, 1239, 44.4816, 0.77635037655511, -73.2159, -1.27785851981092),
(1893, '05402', 218, 55, 1239, 44.5055, 0.776767510246336, -73.1263, -1.27629470480113),
(1894, '05403', 218, 55, 172542, 44.453, 0.775851212389039, -73.1805, -1.27724067325571),
(1895, '05404', 218, 55, 172814, 44.4949, 0.776582505345625, -73.1849, -1.2773174677428),
(1896, '05405', 218, 55, 1239, 44.4782, 0.776291035360542, -73.2007, -1.27759322976461),
(1897, '05406', 218, 55, 1239, 44.488, 0.776462077627237, -73.2265, -1.27804352471163),
(1898, '05407', 218, 55, 172542, 44.4475, 0.77575521928018, -73.1733, -1.27711500954957),
(1899, '05439', 218, 55, 100962, 44.5504, 0.777551163080482, -73.1827, -1.27727907049925),
(1900, '05440', 218, 55, 146742, 44.9592, 0.784686069062635, -73.2797, -1.27897203987369),
(1901, '05441', 218, 55, 44555, 44.9322, 0.784214830164596, -73.0918, -1.27569256620919),
(1902, '05442', 218, 55, 171729, 44.7716, 0.781411831385893, -72.6609, -1.26817194246235),
(1903, '05443', 218, 55, 15330, 44.1353, 0.770306301355453, -73.0819, -1.27551977861324),
(1904, '05444', 218, 55, 1302, 44.6552, 0.779380268136572, -72.8557, -1.27157184384523),
(1905, '05445', 218, 55, 8042, 44.3237, 0.773594501666211, -73.2797, -1.27897203987369),
(1906, '05446', 218, 55, 100962, 44.5455, 0.777465641947134, -73.2036, -1.27764384431292),
(1907, '05447', 218, 55, 148413, 44.9291, 0.784160724957784, -72.7102, -1.26903238978358),
(1908, '05448', 218, 55, 155079, 44.8013, 0.781930194173736, -72.9171, -1.27264347600596),
(1909, '05449', 218, 55, 100962, 44.5444, 0.777446443325362, -73.1478, -1.27666995059031),
(1910, '05450', 218, 55, 171994, 44.9065, 0.783766280546834, -72.8157, -1.27087371214444),
(1911, '05451', 218, 55, 8781, 44.5087, 0.7768233607824, -73.0672, -1.2752632152132),
(1912, '05452', 218, 55, 171998, 44.5029, 0.776722131685784, -73.0887, -1.27563846100238),
(1913, '05453', 218, 55, 171998, 44.4907, 0.776509201517041, -73.0801, -1.27548836268671),
(1914, '05454', 218, 55, 13733, 44.6974, 0.780116797080914, -73.019, -1.27442196651374),
(1915, '05455', 218, 55, 2367, 44.7824, 0.781600326945109, -73.0165, -1.27437833328244),
(1916, '05456', 218, 55, 0, 44.2128, 0.771658931525749, -73.2683, -1.27877307233896),
(1917, '05457', 218, 55, 2595, 45.0047, 0.785480193872292, -72.8343, -1.27119834338531),
(1918, '05458', 218, 55, 41155, 44.7167, 0.780453645626548, -73.3004, -1.27933332302885),
(1919, '05459', 218, 55, 172117, 44.954, 0.784595311941531, -72.9999, -1.27408860862661),
(1920, '05460', 218, 55, 36409, 44.9789, 0.785029898925278, -73.1063, -1.27594563895073),
(1921, '05461', 218, 55, 172122, 44.3074, 0.773310012998136, -73.1213, -1.27620743833853),
(1922, '05462', 218, 55, 9621, 44.319, 0.773512471191367, -72.9894, -1.27390534905515),
(1923, '05463', 218, 55, 172151, 44.8695, 0.783120508723596, -73.3412, -1.28004541736367),
(1924, '05464', 218, 55, 9742, 44.6642, 0.779537347769251, -72.7819, -1.27028379085726),
(1925, '05465', 218, 55, 3419, 44.4937, 0.776561561394601, -72.9731, -1.27362086038707),
(1926, '05466', 218, 55, 3455, 44.5423, 0.77740979141107, -73.2113, -1.27777823466532),
(1927, '05468', 218, 55, 4232, 44.6394, 0.779104506114757, -73.1359, -1.27646225640932),
(1928, '05469', 218, 55, 49547, 44.2523, 0.772348336580287, -73.123, -1.27623710893581),
(1929, '05470', 218, 55, 4289, 44.9025, 0.783696467376754, -72.6382, -1.26777575272215),
(1930, '05471', 218, 55, 172265, 44.8632, 0.78301055298072, -72.5939, -1.26700257186351),
(1931, '05472', 218, 55, 4528, 44.1173, 0.769992142090094, -73.175, -1.27714468014685),
(1932, '05473', 218, 55, 0, 44.2551, 0.772397205799343, -73.2551, -1.2785426888777),
(1933, '05474', 218, 55, 172328, 44.853, 0.782832529397017, -73.2786, -1.27895284125192),
(1934, '05476', 218, 55, 152081, 44.995, 0.785310896934849, -72.6721, -1.26836741933857),
(1935, '05477', 218, 55, 5381, 44.396, 0.774856374715403, -72.9936, -1.27397865288373),
(1936, '05478', 218, 55, 57331, 44.8123, 0.782122180391455, -73.0786, -1.27546218274793),
(1937, '05479', 218, 55, 57331, 44.8112, 0.782102981769683, -73.0853, -1.27557911980781),
(1938, '05481', 218, 55, 172485, 44.8074, 0.782036659258107, -73.1394, -1.27652334293314),
(1939, '05482', 218, 55, 31106, 44.3907, 0.774763872265047, -73.2142, -1.27782884921363),
(1940, '05483', 218, 55, 57525, 44.884, 0.783373581465135, -72.933, -1.27292098335702),
(1941, '05485', 218, 55, 172521, 44.9056, 0.783750572583566, -72.9815, -1.27376746804424),
(1942, '05486', 218, 55, 172551, 44.8666, 0.783069894175288, -73.2531, -1.27850778229266),
(1943, '05487', 218, 55, 172593, 44.2258, 0.771885824328508, -72.9925, -1.27395945426196),
(1944, '05488', 218, 55, 51889, 44.9226, 0.784047278556405, -73.1054, -1.27592993098746),
(1945, '05489', 218, 55, 172660, 44.6215, 0.77879209217865, -72.9077, -1.27247941505627),
(1946, '05490', 218, 55, 172661, 44.5288, 0.777174171962051, -72.8958, -1.27227172087528),
(1947, '05491', 218, 55, 28857, 44.1663, 0.770847353423572, -73.2511, -1.27847287570762),
(1948, '05492', 218, 55, 25838, 44.7161, 0.780443173651036, -72.7537, -1.2697916080082),
(1949, '05494', 218, 55, 114274, 44.6293, 0.778928227860305, -73.0047, -1.2741723844307),
(1950, '05495', 218, 55, 18638, 44.4407, 0.775636536891044, -73.0984, -1.27580775793982),
(1951, '05501', 218, 23, 14988, 42.649, 0.744365472683062, -71.1817, -1.24235503216685),
(1952, '05544', 218, 23, 14988, 42.6493, 0.744370708670818, -71.1814, -1.24234979617909),
(1953, '05601', 218, 55, 23162, 44.2035, 0.771496615905313, -72.5569, -1.26635680004027),
(1954, '05602', 218, 55, 23162, 44.2566, 0.772423385738122, -72.5737, -1.26665001535461),
(1955, '05603', 218, 55, 23162, 44.2623, 0.772522869505486, -72.582, -1.26679487768252),
(1956, '05604', 218, 55, 23162, 44.2572, 0.772433857713634, -72.5896, -1.26692752270568),
(1957, '05609', 218, 55, 23162, 44.2869, 0.772952220501477, -72.6036, -1.26717186880096),
(1958, '05620', 218, 55, 23162, 44.2615, 0.77250890687147, -72.5816, -1.26678789636552),
(1959, '05633', 218, 55, 23162, 44.2614, 0.772507161542218, -72.5812, -1.26678091504851),
(1960, '05640', 218, 55, 171670, 44.3573, 0.774180932294881, -72.509, -1.26552078732857),
(1961, '05641', 218, 55, 124184, 44.1975, 0.771391896150194, -72.5008, -1.2653776703299),
(1962, '05647', 218, 55, 7814, 44.4008, 0.774940150519498, -72.2965, -1.26181196266808),
(1963, '05648', 218, 55, 71989, 44.3973, 0.774879063995679, -72.4779, -1.2649779899312),
(1964, '05649', 218, 55, 148408, 44.1591, 0.770721689717428, -72.4443, -1.26439155930253),
(1965, '05650', 218, 55, 171934, 44.3542, 0.774126827088069, -72.4406, -1.2643269821202),
(1966, '05651', 218, 55, 171961, 44.2492, 0.772294231373475, -72.4751, -1.26492912071214),
(1967, '05652', 218, 55, 2217, 44.7436, 0.780923139195335, -72.6215, -1.26748428273706),
(1968, '05653', 218, 55, 171986, 44.6925, 0.780031275947566, -72.4896, -1.26518219345368),
(1969, '05654', 218, 55, 55037, 44.1523, 0.770603007328292, -72.4754, -1.2649343566999),
(1970, '05655', 218, 55, 3310, 44.6308, 0.778954407799085, -72.568, -1.26655053158725),
(1971, '05656', 218, 55, 364, 44.6354, 0.779034692944677, -72.6728, -1.26837963664334),
(1972, '05657', 218, 55, 172182, 44.5426, 0.777415027398826, -72.5253, -1.26580527599664),
(1973, '05658', 218, 55, 30448, 44.3157, 0.773454875326051, -72.362, -1.26295515332814),
(1974, '05660', 218, 55, 172270, 44.2539, 0.772376261848319, -72.7484, -1.26969910555784),
(1975, '05661', 218, 55, 4337, 44.5608, 0.777732677322689, -72.5995, -1.26710031030162),
(1976, '05662', 218, 55, 4344, 44.4411, 0.775643518208052, -72.7154, -1.26912314690468),
(1977, '05663', 218, 55, 37457, 44.1478, 0.770524467511953, -72.6611, -1.26817543312085),
(1978, '05664', 218, 55, 172357, 44.1716, 0.770939855873927, -72.651, -1.2679991548664),
(1979, '05665', 218, 55, 67270, 44.6707, 0.779650794170631, -72.5991, -1.26709332898462),
(1980, '05666', 218, 55, 172333, 44.2568, 0.772426876396626, -72.4836, -1.26507747369856),
(1981, '05667', 218, 55, 11247, 44.2438, 0.772199983593867, -72.4079, -1.2637562594548),
(1982, '05669', 218, 55, 33833, 44.0697, 0.769161365366145, -72.7277, -1.26933782240268),
(1983, '05670', 218, 55, 126133, 44.178, 0.771051556946055, -72.5053, -1.26545621014624),
(1984, '05671', 218, 55, 18504, 44.3404, 0.773885971651294, -72.7601, -1.26990330908033),
(1985, '05672', 218, 55, 111564, 44.5004, 0.776678498454485, -72.6463, -1.26791712439156),
(1986, '05673', 218, 55, 172679, 44.1886, 0.771236561846766, -72.8424, -1.27133971505472),
(1987, '05674', 218, 55, 12663, 44.1272, 0.770164929686042, -72.8787, -1.27197326957319),
(1988, '05675', 218, 55, 12671, 44.0672, 0.769117732134845, -72.4221, -1.26400409620859),
(1989, '05676', 218, 55, 18504, 44.3389, 0.773859791712514, -72.7528, -1.26977590004493),
(1990, '05677', 218, 55, 172701, 44.3919, 0.774784816216071, -72.7173, -1.26915630816047),
(1991, '05678', 218, 55, 172709, 44.1611, 0.770756596302468, -72.4703, -1.26484534490805),
(1992, '05679', 218, 55, 6834, 44.1054, 0.769784447909107, -72.5429, -1.26611245394499),
(1993, '05680', 218, 55, 34461, 44.5355, 0.777291109021935, -72.4845, -1.26509318166183),
(1994, '05681', 218, 55, 362, 44.4447, 0.775706350061124, -72.4077, -1.2637527687963),
(1995, '05682', 218, 55, 58366, 44.4125, 0.775144354041982, -72.5732, -1.26664128870835),
(1996, '05701', 218, 55, 17882, 43.6089, 0.761118888172955, -72.9732, -1.27362260571633),
(1997, '05702', 218, 55, 17882, 43.6086, 0.761113652185199, -72.9797, -1.27373605211771),
(1998, '05730', 218, 55, 303, 43.4227, 0.757869085105742, -72.8169, -1.27089465609546),
(1999, '05731', 218, 55, 642, 43.6183, 0.761282949122643, -73.2858, -1.27907850495806),
(2000, '05732', 218, 55, 171755, 43.6134, 0.761197427989295, -73.2105, -1.27776427203131),
(2001, '05733', 218, 55, 7653, 43.7878, 0.764241282204773, -73.0862, -1.27559482777108),
(2002, '05734', 218, 55, 0, 43.9457, 0.766997157093672, -73.3534, -1.28025834753241),
(2003, '05735', 218, 55, 29414, 43.6066, 0.761078745600159, -73.1881, -1.27737331827886),
(2004, '05736', 218, 55, 171838, 43.5963, 0.760898976687204, -73.0227, -1.27448654369606),
(2005, '05737', 218, 55, 171856, 43.7096, 0.762876434729713, -72.9624, -1.27343411015711),
(2006, '05738', 218, 55, 171893, 43.5455, 0.760012349427191, -72.9055, -1.27244101781273),
(2007, '05739', 218, 55, 35500, 43.349, 0.756582777447022, -72.9655, -1.27348821536392),
(2008, '05740', 218, 55, 171959, 43.9739, 0.767489339942734, -73.1058, -1.27593691230447),
(2009, '05741', 218, 55, 171968, 43.5259, 0.7596702648938, -73.2045, -1.27765955227619),
(2010, '05742', 218, 55, 113317, 43.4334, 0.758055835335705, -72.8777, -1.27195581628067),
(2011, '05743', 218, 55, 54696, 43.5942, 0.760862324772912, -73.2686, -1.27877830832672),
(2012, '05744', 218, 55, 2502, 43.5966, 0.76090421267496, -73.0457, -1.27488796942402),
(2013, '05745', 218, 55, 102037, 43.8275, 0.764934177917815, -73.0542, -1.27503632241044),
(2014, '05746', 218, 55, 172038, 43.7341, 0.763304040396452, -72.7446, -1.26963278304627),
(2015, '05747', 218, 55, 55048, 44.0065, 0.768058317278885, -72.8413, -1.27132051643295),
(2016, '05748', 218, 55, 9313, 43.9182, 0.766517191549374, -72.9194, -1.27268361857875),
(2017, '05750', 218, 55, 113585, 43.6053, 0.761056056319883, -73.2281, -1.27807144997966),
(2018, '05751', 218, 55, 172178, 43.654, 0.761906031665605, -72.7897, -1.27041992653892),
(2019, '05753', 218, 55, 30497, 44.0123, 0.7681595463755, -73.165, -1.27697014722165),
(2020, '05757', 218, 55, 172248, 43.4807, 0.758881376071898, -73.1175, -1.27614111582695),
(2021, '05758', 218, 55, 10633, 43.4387, 0.758148337786061, -72.7869, -1.27037105731986),
(2022, '05759', 218, 55, 172316, 43.5739, 0.760508022934757, -72.9695, -1.273558028534),
(2023, '05760', 218, 55, 33507, 43.7851, 0.764194158314969, -73.2749, -1.27888826406959),
(2024, '05761', 218, 55, 172385, 43.3022, 0.755765963357089, -73.141, -1.27655126820117),
(2025, '05762', 218, 55, 28268, 43.7577, 0.763715938099923, -72.8538, -1.27153868258945),
(2026, '05763', 218, 55, 132642, 43.7659, 0.763859055098586, -72.9695, -1.273558028534),
(2027, '05764', 218, 55, 172419, 43.5182, 0.759535874541396, -73.237, -1.27822678428309),
(2028, '05765', 218, 55, 5236, 43.6567, 0.761953155555408, -73.0361, -1.27472041781583),
(2029, '05766', 218, 55, 172459, 43.997, 0.767892510999945, -72.9863, -1.27385124384834),
(2030, '05767', 218, 55, 28433, 43.8704, 0.76568292416692, -72.8275, -1.27107966099617),
(2031, '05768', 218, 55, 11731, 43.2608, 0.755043397046763, -73.2238, -1.27799640082182),
(2032, '05769', 218, 55, 28524, 43.9234, 0.766607948670477, -73.0816, -1.27551454262549),
(2033, '05770', 218, 55, 133109, 43.8802, 0.765853966433616, -73.3063, -1.27943629745472),
(2034, '05772', 218, 55, 25139, 43.7706, 0.76394108557343, -72.7868, -1.27036931199061),
(2035, '05773', 218, 55, 38730, 43.472, 0.758729532426975, -72.9781, -1.27370812684967),
(2036, '05774', 218, 55, 34376, 43.4343, 0.758071543298973, -73.1974, -1.2775356338993),
(2037, '05775', 218, 55, 172754, 43.3603, 0.756779999652497, -73.2262, -1.27803828872387),
(2038, '05776', 218, 55, 172755, 43.2636, 0.755092266265819, -73.1909, -1.27742218749792),
(2039, '05777', 218, 55, 126558, 43.5963, 0.760898976687204, -73.046, -1.27489320541178),
(2040, '05778', 218, 55, 34415, 43.8826, 0.765895854335664, -73.2106, -1.27776601736056),
(2041, '05819', 218, 55, 172489, 44.4344, 0.775526581148168, -72.0403, -1.25734042912447),
(2042, '05820', 218, 55, 18772, 44.883, 0.783356128172615, -72.2185, -1.26045060585153),
(2043, '05821', 218, 55, 171709, 44.3201, 0.773531669813139, -72.0792, -1.2580193622035),
(2044, '05822', 218, 55, 7286, 44.75, 0.781034840267463, -72.1817, -1.25980832468679),
(2045, '05823', 218, 55, 171726, 45.0061, 0.78550462848182, -72.1432, -1.25913637292477),
(2046, '05824', 218, 55, 698, 44.4508, 0.775812815145495, -71.8483, -1.25398939696064),
(2047, '05825', 218, 55, 13605, 44.8721, 0.783165887284148, -72.2383, -1.26079618104342),
(2048, '05826', 218, 55, 171888, 44.6436, 0.779177809943341, -72.3562, -1.26285392423152),
(2049, '05827', 218, 55, 171889, 44.6584, 0.779436118672636, -72.4173, -1.26392032040449),
(2050, '05828', 218, 55, 1964, 44.4388, 0.775603375635256, -72.1145, -1.25863546342945),
(2051, '05829', 218, 55, 2031, 44.9389, 0.78433176722448, -72.134, -1.25897580263359),
(2052, '05830', 218, 55, 171902, 45.0021, 0.78543481531174, -72.1045, -1.25846093050425),
(2053, '05832', 218, 55, 171932, 44.6044, 0.778493640876559, -71.9216, -1.25526872330235),
(2054, '05833', 218, 55, 171935, 44.8228, 0.782305439962914, -71.9857, -1.25638747935288),
(2055, '05836', 218, 55, 171950, 44.5202, 0.77702407364638, -72.3071, -1.26199696756879),
(2056, '05837', 218, 55, 2170, 44.6558, 0.779390740112084, -71.8237, -1.25356004596465),
(2057, '05838', 218, 55, 171975, 44.4385, 0.7755981396475, -71.9456, -1.25568760232283),
(2058, '05839', 218, 55, 2753, 44.6911, 0.780006841338038, -72.2152, -1.26039300998621),
(2059, '05840', 218, 55, 55021, 44.5708, 0.777907210247889, -71.7588, -1.25242732728011),
(2060, '05841', 218, 55, 2866, 44.5817, 0.778097451136356, -72.2986, -1.26184861458237),
(2061, '05842', 218, 55, 172080, 44.5417, 0.777399319435558, -72.2152, -1.26039300998621),
(2062, '05843', 218, 55, 2971, 44.5074, 0.776800671502124, -72.3576, -1.26287835884105),
(2063, '05845', 218, 55, 172146, 44.8143, 0.782157086976495, -72.2841, -1.26159554184083),
(2064, '05846', 218, 55, 172149, 44.764, 0.781279186362742, -71.8139, -1.25338900369796),
(2065, '05847', 218, 55, 10211, 44.7916, 0.781760897236292, -72.4571, -1.26461496144678),
(2066, '05848', 218, 55, 172208, 44.3548, 0.774137299063581, -71.9072, -1.25501739589007),
(2067, '05849', 218, 55, 33157, 44.5337, 0.777259693095399, -72.0005, -1.25664578808218),
(2068, '05850', 218, 55, 131857, 44.5362, 0.777303326326699, -72.0118, -1.25684301028765),
(2069, '05851', 218, 55, 150437, 44.535, 0.777282382375675, -72.0039, -1.25670512927675),
(2070, '05853', 218, 55, 4319, 44.895, 0.783565567682854, -71.9674, -1.25606808409977),
(2071, '05855', 218, 55, 10799, 44.9412, 0.784371909797276, -72.2038, -1.26019404245148),
(2072, '05857', 218, 55, 165212, 44.9894, 0.785213158496737, -72.2524, -1.26104227246795),
(2073, '05858', 218, 55, 67244, 44.5631, 0.777772819895485, -71.7778, -1.25275893983799),
(2074, '05859', 218, 55, 172346, 44.944, 0.784420779016332, -72.4671, -1.26478949437198),
(2075, '05860', 218, 55, 28158, 44.8065, 0.782020951294839, -72.2021, -1.2601643718542),
(2076, '05861', 218, 55, 172383, 44.3767, 0.774519526169768, -72.0282, -1.25712924428498),
(2077, '05862', 218, 55, 172386, 44.3331, 0.773758562615898, -72.2071, -1.2602516383168),
(2078, '05863', 218, 55, 172490, 44.455, 0.775886118974079, -72.0126, -1.25685697292167),
(2079, '05866', 218, 55, 5785, 44.6403, 0.779120214078025, -72.1246, -1.2588117416839),
(2080, '05867', 218, 55, 12229, 44.6628, 0.779512913159723, -72.0397, -1.25732995714896),
(2081, '05868', 218, 55, 199, 44.9468, 0.784469648235387, -72.3932, -1.26349969605476),
(2082, '05871', 218, 55, 172726, 44.6977, 0.780122033068669, -71.9304, -1.25542231227653),
(2083, '05872', 218, 55, 74764, 44.8666, 0.783069894175288, -72.0506, -1.25752019803743),
(2084, '05873', 218, 55, 38809, 44.4629, 0.776023999984987, -72.2237, -1.26054136297263),
(2085, '05874', 218, 55, 723, 44.8769, 0.783249663088243, -72.4677, -1.26479996634749),
(2086, '05875', 218, 55, 172740, 44.6961, 0.780094107800638, -72.2661, -1.26128138257547),
(2087, '05901', 218, 55, 79619, 44.9425, 0.784394599077552, -71.6827, -1.25109913171934),
(2088, '05902', 218, 55, 171725, 45.0074, 0.785527317762096, -71.5181, -1.24822631977056),
(2089, '05903', 218, 55, 306, 44.9751, 0.784963576413702, -71.5845, -1.24938521839388),
(2090, '05904', 218, 55, 102246, 44.4156, 0.775198459248793, -71.7197, -1.25174490354258),
(2091, '05905', 218, 55, 172085, 44.732, 0.780720681002103, -71.626, -1.25010953003346),
(2092, '05906', 218, 55, 10233, 44.4778, 0.776284054043534, -71.7109, -1.2515913145684),
(2093, '05907', 218, 55, 4646, 44.9462, 0.784459176259875, -71.8293, -1.25365778440276),
(2094, '06001', 218, 8, 7208, 41.7924, 0.729414982310478, -72.8575, -1.27160325977177),
(2095, '06002', 218, 8, 7544, 41.8312, 0.730092170060252, -72.7286, -1.26935353036595),
(2096, '06006', 218, 8, 18652, 41.8523, 0.730460434532423, -72.6441, -1.26787872714801),
(2097, '06010', 218, 8, 15330, 41.6821, 0.727489884145528, -72.9319, -1.27290178473525),
(2098, '06011', 218, 8, 15330, 41.6762, 0.727386909719661, -72.9477, -1.27317754675707),
(2099, '06013', 218, 8, 1239, 41.758, 0.728814589047792, -72.9492, -1.27320372669585),
(2100, '06016', 218, 8, 177533, 41.9084, 0.731439564242792, -72.5447, -1.26614386987153),
(2101, '06018', 218, 8, 306, 42.0245, 0.733465891504357, -73.3297, -1.27984470449969),
(2102, '06019', 218, 8, 19763, 41.8357, 0.730170709876592, -72.896, -1.27227521153379),
(2103, '06020', 218, 8, 177574, 41.8615, 0.730621004823606, -72.9129, -1.27257017217737),
(2104, '06021', 218, 8, 45895, 42.0017, 0.733067956434902, -73.097, -1.27578332333029),
(2105, '06022', 218, 8, 1706, 41.8371, 0.73019514448612, -72.9241, -1.2727656490536),
(2106, '06023', 218, 8, 70767, 41.6132, 0.726287352290904, -72.72, -1.26920343205028),
(2107, '06024', 218, 8, 113228, 42.0127, 0.733259942652622, -73.2858, -1.27907850495806),
(2108, '06025', 218, 8, 113273, 41.6899, 0.727626019827184, -72.5332, -1.26594315700755),
(2109, '06026', 218, 8, 113244, 41.9322, 0.731854952604766, -72.7457, -1.26965198166804),
(2110, '06027', 218, 8, 113265, 41.9961, 0.732970217996791, -72.9063, -1.27245498044674),
(2111, '06028', 218, 8, 113321, 41.8626, 0.730640203445378, -72.6038, -1.26717535945946),
(2112, '06029', 218, 8, 35744, 41.914, 0.731537302680903, -72.4451, -1.26440552193654),
(2113, '06030', 218, 8, 8849, 41.7112, 0.727997774957859, -72.839, -1.27128037386015),
(2114, '06031', 218, 8, 113423, 41.9536, 0.732228453064693, -73.3401, -1.28002621874189),
(2115, '06032', 218, 8, 8849, 41.7277, 0.728285754284438, -72.8369, -1.27124372194586),
(2116, '06033', 218, 8, 113471, 41.707, 0.727924471129275, -72.5641, -1.26648246374642),
(2117, '06034', 218, 8, 8849, 41.7056, 0.727900036519747, -72.8741, -1.2718929844276),
(2118, '06035', 218, 8, 55021, 41.954, 0.732235434381701, -72.7977, -1.27055955287908),
(2119, '06037', 218, 8, 376, 41.6207, 0.726418251984804, -72.7688, -1.27005515272525),
(2120, '06039', 218, 8, 16832, 41.9544, 0.732242415698709, -73.4366, -1.28171046147007),
(2121, '06040', 218, 8, 585, 41.7773, 0.729151437593427, -72.5251, -1.26580178533814),
(2122, '06041', 218, 8, 585, 41.7759, 0.729127002983899, -72.5224, -1.26575466144834),
(2123, '06043', 218, 8, 19382, 41.7741, 0.729095587057363, -72.4379, -1.2642798582304),
(2124, '06045', 218, 8, 585, 41.7763, 0.729133984300907, -72.5217, -1.26574244414357),
(2125, '06049', 218, 8, 4153, 41.9312, 0.731837499312246, -72.5268, -1.26583145593542),
(2126, '06050', 218, 8, 113772, 41.6765, 0.727392145707417, -72.7795, -1.27024190295521),
(2127, '06051', 218, 8, 113772, 41.6663, 0.727214122123713, -72.7706, -1.27008656865179),
(2128, '06052', 218, 8, 113772, 41.6593, 0.727091949076074, -72.8009, -1.27061540341514),
(2129, '06053', 218, 8, 113772, 41.6864, 0.727564933303364, -72.7906, -1.27043563450218),
(2130, '06057', 218, 8, 28028, 41.8539, 0.730488359800455, -73.0084, -1.27423696161303),
(2131, '06058', 218, 8, 61085, 41.9885, 0.732837572973639, -73.1961, -1.27751294461902),
(2132, '06059', 218, 8, 23408, 41.9014, 0.731317391195152, -72.8904, -1.27217747309567),
(2133, '06060', 218, 8, 113821, 42.012, 0.733247725347858, -72.8424, -1.27133971505472),
(2134, '06061', 218, 8, 113910, 41.9166, 0.731582681241455, -73.0649, -1.2752230726404),
(2135, '06062', 218, 8, 23999, 41.672, 0.727313605891077, -72.8648, -1.27173066880716),
(2136, '06063', 218, 8, 177476, 41.9171, 0.731591407887715, -72.9774, -1.27369590954491),
(2137, '06064', 218, 8, 113944, 41.905, 0.731380223048224, -72.6787, -1.2684826110692),
(2138, '06065', 218, 8, 5429, 41.9575, 0.732296520905521, -73.0121, -1.27430153879535),
(2139, '06066', 218, 8, 0, 41.8454, 0.730340006814035, -72.4648, -1.26474935179919),
(2140, '06067', 218, 8, 5486, 41.6623, 0.727144308953634, -72.6686, -1.26830633281475),
(2141, '06068', 218, 8, 28524, 42.0189, 0.733368153066245, -73.4009, -1.28108737892711),
(2142, '06069', 218, 8, 24789, 41.8642, 0.73066812871341, -73.4555, -1.28204032869869),
(2143, '06070', 218, 8, 114067, 41.8758, 0.730870586906641, -72.8223, -1.27098890387507),
(2144, '06071', 218, 8, 106389, 41.995, 0.732951019375019, -72.4502, -1.2644945337284),
(2145, '06072', 218, 8, 114077, 41.9826, 0.732734598547771, -72.4916, -1.26521710003872),
(2146, '06073', 218, 8, 114090, 41.6632, 0.727160016916902, -72.5748, -1.26666921397638),
(2147, '06074', 218, 8, 114096, 41.835, 0.730158492571828, -72.5584, -1.26638297997905),
(2148, '06075', 218, 8, 12102, 41.9882, 0.732832336985883, -72.2884, -1.26167059099867),
(2149, '06076', 218, 8, 61863, 41.9768, 0.732633369451156, -72.2843, -1.26159903249934),
(2150, '06077', 218, 8, 71431, 41.9931, 0.732917858119231, -72.2622, -1.26121331473465),
(2151, '06078', 218, 8, 114141, 41.9905, 0.732872479558679, -72.6449, -1.26789268978203),
(2152, '06079', 218, 8, 114148, 42.0298, 0.733558393954713, -73.3934, -1.28095647923321),
(2153, '06080', 218, 8, 114141, 41.9816, 0.732717145255251, -72.6506, -1.26799217354939),
(2154, '06081', 218, 8, 91228, 41.9066, 0.731408148316256, -72.7683, -1.27004642607899),
(2155, '06082', 218, 8, 27104, 41.9873, 0.732816629022615, -72.5622, -1.26644930249063),
(2156, '06083', 218, 8, 27104, 41.998, 0.733003379252579, -72.575, -1.26667270463488),
(2157, '06084', 218, 8, 114172, 41.8709, 0.730785065773294, -72.371, -1.26311223296082),
(2158, '06085', 218, 8, 25657, 41.751, 0.728692416000152, -72.8906, -1.27218096375418),
(2159, '06087', 218, 8, 25657, 41.7572, 0.728800626413776, -72.8879, -1.27213383986437),
(2160, '06088', 218, 8, 124753, 41.9178, 0.731603625192479, -72.6019, -1.26714219820367),
(2161, '06089', 218, 8, 114233, 41.8391, 0.73023005107116, -72.823, -1.27100112117983),
(2162, '06090', 218, 8, 114244, 41.9538, 0.732231943723197, -72.8604, -1.27165387432008),
(2163, '06091', 218, 8, 114248, 41.951, 0.732183074504141, -72.9356, -1.27296636191758),
(2164, '06092', 218, 8, 114261, 41.8566, 0.730535483690259, -72.8517, -1.27150203067515),
(2165, '06093', 218, 8, 114262, 42.0115, 0.733238998701598, -72.7348, -1.26946174077957),
(2166, '06094', 218, 8, 114302, 41.9005, 0.731301683231884, -73.1426, -1.2765791934692),
(2167, '06095', 218, 8, 18652, 41.8605, 0.730603551531086, -72.6673, -1.26828364353448),
(2168, '06096', 218, 8, 114310, 41.9274, 0.731771176800671, -72.6458, -1.2679083977453),
(2169, '06098', 218, 8, 114316, 41.922, 0.731676929021063, -73.0676, -1.27527019653021),
(2170, '06101', 218, 8, 2998, 41.7887, 0.729350405128154, -72.6657, -1.26825571826644),
(2171, '06102', 218, 8, 2998, 41.7662, 0.728957706046456, -72.6727, -1.26837789131408),
(2172, '06103', 218, 8, 2998, 41.7676, 0.728982140655984, -72.6757, -1.26843025119164),
(2173, '06104', 218, 8, 2998, 41.7893, 0.729360877103666, -72.6659, -1.26825920892495),
(2174, '06105', 218, 8, 2998, 41.7693, 0.729011811253268, -72.7016, -1.26888229146791),
(2175, '06106', 218, 8, 2998, 41.748, 0.728640056122593, -72.6949, -1.26876535440803),
(2176, '06107', 218, 8, 12751, 41.7561, 0.728781427792004, -72.7578, -1.26986316650753),
(2177, '06108', 218, 8, 113262, 41.773, 0.729076388435591, -72.6213, -1.26748079207856),
(2178, '06109', 218, 8, 52691, 41.7046, 0.727882583227227, -72.6677, -1.26829062485148),
(2179, '06110', 218, 8, 12751, 41.7319, 0.728359058113022, -72.7356, -1.26947570341359),
(2180, '06111', 218, 8, 23359, 41.6874, 0.727582386595884, -72.7307, -1.26939018228024),
(2181, '06112', 218, 8, 2998, 41.7929, 0.729423708956738, -72.6953, -1.26877233572503),
(2182, '06114', 218, 8, 2998, 41.7383, 0.728470759185149, -72.679, -1.26848784705696),
(2183, '06115', 218, 8, 2998, 41.7642, 0.728922799461416, -72.6735, -1.2683918539481),
(2184, '06117', 218, 8, 12751, 41.7886, 0.729348659798902, -72.75, -1.26972703082587),
(2185, '06118', 218, 8, 113262, 41.7453, 0.728592932232789, -72.6087, -1.26726088059281),
(2186, '06119', 218, 8, 12751, 41.7615, 0.728875675571612, -72.7269, -1.26932385976866),
(2187, '06120', 218, 8, 2998, 41.7861, 0.729305026567603, -72.6732, -1.26838661796034),
(2188, '06123', 218, 8, 2998, 41.7655, 0.728945488741692, -72.6839, -1.26857336819031),
(2189, '06126', 218, 8, 2998, 41.7657, 0.728948979400196, -72.6834, -1.26856464154405),
(2190, '06127', 218, 8, 12751, 41.7659, 0.7289524700587, -72.6841, -1.26857685884881),
(2191, '06128', 218, 8, 113262, 41.7813, 0.729221250763507, -72.6229, -1.26750871734659),
(2192, '06129', 218, 8, 52691, 41.7097, 0.727971595019079, -72.6615, -1.26818241443786),
(2193, '06131', 218, 8, 23359, 41.6874, 0.727582386595884, -72.7307, -1.26939018228024),
(2194, '06132', 218, 8, 2998, 41.7662, 0.728957706046456, -72.6839, -1.26857336819031),
(2195, '06133', 218, 8, 12751, 41.7522, 0.728713359951176, -72.7042, -1.26892767002846),
(2196, '06134', 218, 8, 2998, 41.7656, 0.728947234070944, -72.6841, -1.26857685884881),
(2197, '06137', 218, 8, 12751, 41.5838, 0.725774225490818, -72.8681, -1.27178826467248),
(2198, '06138', 218, 8, 113262, 41.7617, 0.728879166230116, -72.6161, -1.26739003495745),
(2199, '06140', 218, 8, 2998, 41.7897, 0.729367858420674, -72.666, -1.2682609542542),
(2200, '06141', 218, 8, 2998, 41.7897, 0.729367858420674, -72.667, -1.26827840754672),
(2201, '06142', 218, 8, 2998, 41.7771, 0.729147946934923, -72.6953, -1.26877233572503),
(2202, '06143', 218, 8, 2998, 41.7901, 0.729374839737682, -72.6673, -1.26828364353448),
(2203, '06144', 218, 8, 2998, 41.7904, 0.729380075725438, -72.6669, -1.26827666221747),
(2204, '06145', 218, 8, 2998, 41.7894, 0.729362622432918, -72.6665, -1.26826968090046),
(2205, '06146', 218, 8, 2998, 41.7895, 0.72936436776217, -72.666, -1.2682609542542),
(2206, '06147', 218, 8, 2998, 41.7917, 0.729402765005714, -72.666, -1.2682609542542),
(2207, '06150', 218, 8, 2998, 41.7658, 0.728950724729448, -72.6726, -1.26837614598483),
(2208, '06151', 218, 8, 2998, 41.766, 0.728954215387952, -72.6723, -1.26837090999708),
(2209, '06152', 218, 8, 2998, 41.7575, 0.728805862401532, -72.6904, -1.26868681459169),
(2210, '06153', 218, 8, 2998, 41.688, 0.727592858571396, -72.7308, -1.26939192760949),
(2211, '06154', 218, 8, 2998, 41.7725, 0.729067661789331, -72.7056, -1.26895210463799),
(2212, '06155', 218, 8, 2998, 41.7581, 0.728816334377044, -72.7435, -1.2696135844245),
(2213, '06156', 218, 8, 2998, 41.7594, 0.72883902365732, -72.7319, -1.26941112623126),
(2214, '06160', 218, 8, 2998, 41.7728, 0.729072897777087, -72.7044, -1.26893116068697),
(2215, '06161', 218, 8, 2998, 41.6992, 0.727788335447619, -72.666, -1.2682609542542),
(2216, '06167', 218, 8, 2998, 41.7652, 0.728940252753936, -72.6836, -1.26856813220255),
(2217, '06176', 218, 8, 2998, 41.7662, 0.728957706046456, -72.6718, -1.26836218335082),
(2218, '06180', 218, 8, 2998, 41.7563, 0.728784918450508, -72.7646, -1.26998184889667),
(2219, '06183', 218, 8, 2998, 41.7636, 0.728912327485904, -72.6853, -1.26859780279983),
(2220, '06199', 218, 8, 2998, 41.9266, 0.731757214166655, -72.6548, -1.26806547737798),
(2221, '06226', 218, 8, 114293, 41.7129, 0.728027445555143, -72.2087, -1.26027956358483),
(2222, '06230', 218, 8, 29060, 41.8458, 0.730346988131043, -72.015, -1.25689886082372),
(2223, '06231', 218, 8, 177440, 41.6279, 0.726543915690947, -72.3641, -1.26299180524243),
(2224, '06232', 218, 8, 14988, 41.732, 0.728360803442274, -72.3749, -1.26318030080164),
(2225, '06233', 218, 8, 177470, 41.8734, 0.730828699004594, -71.8618, -1.25422501640966),
(2226, '06234', 218, 8, 1157, 41.7828, 0.729247430702287, -71.9541, -1.25583595530925),
(2227, '06235', 218, 8, 518, 41.8077, 0.729682017686033, -72.117, -1.25867909666075),
(2228, '06237', 218, 8, 1716, 41.7006, 0.727812770057147, -72.3053, -1.26196555164226),
(2229, '06238', 218, 8, 13605, 41.7811, 0.729217760105003, -72.3301, -1.26239839329675),
(2230, '06239', 218, 8, 113098, 41.8005, 0.72955635397989, -71.8734, -1.25442747460289),
(2231, '06241', 218, 8, 29612, 41.8536, 0.730483123812699, -71.8602, -1.25419709114163),
(2232, '06242', 218, 8, 113335, 41.8924, 0.731160311562473, -72.0919, -1.2582410190185),
(2233, '06243', 218, 8, 113271, 41.8496, 0.730413310642619, -71.8065, -1.25325984933331),
(2234, '06244', 218, 8, 113327, 41.9853, 0.732781722437575, -71.9756, -1.25621120109843),
(2235, '06245', 218, 8, 113414, 42.0132, 0.733268669298882, -71.9392, -1.2555759012507),
(2236, '06246', 218, 8, 113502, 41.9703, 0.732519923049776, -71.8946, -1.25479748440432),
(2237, '06247', 218, 8, 2957, 41.7662, 0.728957706046456, -72.0631, -1.25773836419393),
(2238, '06248', 218, 8, 940, 41.6854, 0.727547480010844, -72.4038, -1.26368470095547),
(2239, '06249', 218, 8, 3708, 41.623, 0.7264583945576, -72.2617, -1.26120458808839),
(2240, '06250', 218, 8, 113672, 41.7647, 0.728931526107676, -72.2052, -1.26021847706101),
(2241, '06251', 218, 8, 113674, 41.8154, 0.729816408038437, -72.2873, -1.2616513923769),
(2242, '06254', 218, 8, 113819, 41.6181, 0.726372873424252, -72.1457, -1.25918000615607),
(2243, '06255', 218, 8, 0, 41.9874, 0.732818374351867, -71.8991, -1.25487602422066),
(2244, '06256', 218, 8, 113841, 41.7566, 0.728790154438264, -72.1381, -1.25904736113292),
(2245, '06258', 218, 8, 50510, 41.9073, 0.73142036562102, -71.9591, -1.25592322177185),
(2246, '06259', 218, 8, 113935, 41.8741, 0.730840916309358, -72.0115, -1.2568377742999),
(2247, '06260', 218, 8, 5256, 41.9178, 0.731603625192479, -71.8965, -1.2548306456601),
(2248, '06262', 218, 8, 113965, 42.0218, 0.733418767614553, -71.9445, -1.25566840370106),
(2249, '06263', 218, 8, 874, 41.8393, 0.730233541729664, -71.907, -1.25501390523156),
(2250, '06264', 218, 8, 5690, 41.6838, 0.727519554742812, -72.081, -1.25805077813003),
(2251, '06265', 218, 8, 114093, 41.8524, 0.730462179861675, -72.3018, -1.26190446511844),
(2252, '06266', 218, 8, 114095, 41.672, 0.727313605891077, -72.1707, -1.25961633846907),
(2253, '06267', 218, 8, 114099, 41.927, 0.731764195483663, -71.9579, -1.25590227782083),
(2254, '06268', 218, 8, 0, 41.8049, 0.729633148466978, -72.2538, -1.26106670707748),
(2255, '06269', 218, 8, 0, 41.811, 0.729739613551349, -72.247, -1.26094802468834),
(2256, '06277', 218, 8, 6317, 41.9749, 0.732600208195368, -71.8367, -1.25378693876741),
(2257, '06278', 218, 8, 728, 41.8725, 0.730812991041326, -72.1623, -1.2594697308119),
(2258, '06279', 218, 8, 84406, 41.8815, 0.730970070674005, -72.2661, -1.26128138257547),
(2259, '06280', 218, 8, 114305, 41.7007, 0.727814515386399, -72.148, -1.25922014872887),
(2260, '06281', 218, 8, 569, 41.9449, 0.732076609419769, -71.9828, -1.25633686480457),
(2261, '06282', 218, 8, 114326, 41.932, 0.731851461946262, -72.1042, -1.2584556945165),
(2262, '06320', 218, 8, 4547, 41.3503, 0.721698881687411, -72.1067, -1.2584993277478),
(2263, '06330', 218, 8, 62687, 41.6118, 0.726262917681377, -72.0712, -1.25787973586334),
(2264, '06331', 218, 8, 13477, 41.6922, 0.72766616239998, -72.0056, -1.25673479987403),
(2265, '06332', 218, 8, 45575, 41.7248, 0.72823513973613, -71.9092, -1.25505230247511),
(2266, '06333', 218, 8, 0, 41.3764, 0.722154412622182, -72.2311, -1.26067051733728),
(2267, '06334', 218, 8, 0, 41.5414, 0.725034205887973, -72.1747, -1.25968615163915),
(2268, '06335', 218, 8, 113461, 41.4345, 0.72316844891759, -72.0697, -1.25785355592456),
(2269, '06336', 218, 8, 102246, 41.579, 0.725690449686722, -72.1971, -1.2600771053916),
(2270, '06337', 218, 8, 113470, 41.561, 0.725376290421363, -71.8913, -1.254739888539),
(2271, '06338', 218, 8, 0, 41.4703, 0.723793276789804, -71.9515, -1.2557905767487),
(2272, '06339', 218, 8, 116447, 41.4456, 0.723362180464562, -71.9973, -1.25658993754611),
(2273, '06340', 218, 8, 113503, 41.3504, 0.721700627016663, -72.0445, -1.25741373295305),
(2274, '06349', 218, 8, 113503, 41.4001, 0.722568055654904, -72.0902, -1.25821134842122),
(2275, '06350', 218, 8, 2963, 41.6435, 0.726816187054259, -72.0658, -1.25778548808373),
(2276, '06351', 218, 8, 113591, 41.6038, 0.726123291341217, -71.977, -1.25623563570796),
(2277, '06353', 218, 8, 125472, 41.4492, 0.723425012317634, -72.1305, -1.25891471610977),
(2278, '06354', 218, 8, 113744, 41.7145, 0.728055370823175, -71.871, -1.25438558670084),
(2279, '06355', 218, 8, 23299, 41.359, 0.721850725332335, -71.9774, -1.25624261702497),
(2280, '06357', 218, 8, 28054, 41.3207, 0.721182264228821, -72.21, -1.26030225286511),
(2281, '06359', 218, 8, 113836, 41.4622, 0.723651905120393, -71.8729, -1.25441874795663),
(2282, '06360', 218, 8, 23480, 41.5329, 0.724885852901553, -72.0611, -1.25770345760889),
(2283, '06365', 218, 8, 5220, 41.5128, 0.724535041721902, -72.0002, -1.25664055209442),
(2284, '06370', 218, 8, 4701, 41.4702, 0.723791531460552, -72.1887, -1.25993049773443),
(2285, '06371', 218, 8, 113864, 41.331, 0.721362033141776, -72.3094, -1.26203711014159),
(2286, '06372', 218, 8, 113867, 41.3906, 0.722402249375965, -71.9606, -1.25594940171063),
(2287, '06373', 218, 8, 17416, 41.6925, 0.727671398387736, -71.8116, -1.25334886112516),
(2288, '06374', 218, 8, 11247, 41.6795, 0.727444505584977, -71.9199, -1.25523905270507),
(2289, '06375', 218, 8, 14455, 41.3999, 0.7225645649964, -72.1174, -1.25868607797776),
(2290, '06376', 218, 8, 114088, 41.2929, 0.720697062696767, -72.2575, -1.2611312842598),
(2291, '06377', 218, 8, 25116, 41.7301, 0.728327642186486, -71.8196, -1.25348848746532),
(2292, '06378', 218, 8, 28706, 41.346, 0.721623832529575, -71.9108, -1.25508022774314),
(2293, '06379', 218, 8, 113895, 41.3728, 0.72209158076911, -71.8492, -1.25400510492391),
(2294, '06380', 218, 8, 114149, 41.5672, 0.725484500834987, -72.053, -1.25756208593947),
(2295, '06382', 218, 8, 114197, 41.4596, 0.723606526559841, -72.113, -1.25860928349067);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(2296, '06383', 218, 8, 28861, 41.6033, 0.726114564694957, -72.0446, -1.25741547828231),
(2297, '06384', 218, 8, 114209, 41.5757, 0.725632853821406, -71.8848, -1.25462644213762),
(2298, '06385', 218, 8, 790, 41.3444, 0.721595907261544, -72.1487, -1.25923236603363),
(2299, '06386', 218, 8, 790, 41.3363, 0.721454535592132, -72.1357, -1.25900547323087),
(2300, '06387', 218, 8, 114231, 41.745, 0.728587696245033, -71.9106, -1.25507673708463),
(2301, '06388', 218, 8, 114253, 41.342, 0.721554019359496, -71.9809, -1.25630370354879),
(2302, '06389', 218, 8, 114334, 41.5599, 0.725357091799591, -72.1222, -1.25876985378185),
(2303, '06390', 218, 40, 148815, 41.2723, 0.720337524870856, -71.9808, -1.25630195821953),
(2304, '06401', 218, 8, 154076, 41.3431, 0.721573217981268, -73.073, -1.27536444430982),
(2305, '06403', 218, 8, 177482, 41.4344, 0.723166703588338, -73.0624, -1.2751794394091),
(2306, '06404', 218, 8, 177310, 41.3619, 0.721901339880643, -73.2128, -1.2778044146041),
(2307, '06405', 218, 8, 15309, 41.2774, 0.720426536662707, -72.7971, -1.27054908090356),
(2308, '06408', 218, 8, 72084, 41.5485, 0.725158124264864, -72.9227, -1.27274121444407),
(2309, '06409', 218, 8, 177588, 41.3459, 0.721622087200324, -72.4196, -1.26396046297729),
(2310, '06410', 218, 8, 72084, 41.5068, 0.724430321966782, -72.9079, -1.27248290571477),
(2311, '06411', 218, 8, 72084, 41.4988, 0.724290695626623, -72.9013, -1.27236771398414),
(2312, '06412', 218, 8, 8056, 41.4046, 0.722646595471244, -72.4667, -1.26478251305497),
(2313, '06413', 218, 8, 1630, 41.2905, 0.720655174794719, -72.5309, -1.26590301443476),
(2314, '06414', 218, 8, 177613, 41.5678, 0.725494972810499, -72.5582, -1.26637948932055),
(2315, '06415', 218, 8, 100962, 41.5492, 0.725170341569628, -72.3302, -1.262400138626),
(2316, '06416', 218, 8, 1893, 41.6107, 0.726243719059605, -72.6658, -1.2682574635957),
(2317, '06417', 218, 8, 64158, 41.3752, 0.722133468671158, -72.4939, -1.26525724261152),
(2318, '06418', 218, 8, 2031, 41.3242, 0.721243350752641, -73.0802, -1.27549010801596),
(2319, '06419', 218, 8, 113608, 41.3716, 0.722070636818086, -72.5716, -1.26661336344032),
(2320, '06420', 218, 8, 126, 41.4889, 0.724117908030675, -72.2724, -1.26139133831835),
(2321, '06422', 218, 8, 8632, 41.4602, 0.723616998535353, -72.6905, -1.26868855992094),
(2322, '06423', 218, 8, 113252, 41.4709, 0.723803748765316, -72.3994, -1.26360790646838),
(2323, '06424', 218, 8, 2169, 41.5754, 0.72562761783365, -72.5072, -1.26548937140203),
(2324, '06426', 218, 8, 8781, 41.3649, 0.721953699758202, -72.4131, -1.26384701657591),
(2325, '06430', 218, 8, 2367, 41.1687, 0.71852936376579, -73.2676, -1.2787608550342),
(2326, '06431', 218, 8, 2367, 41.2188, 0.719403773721039, -73.253, -1.27850603696341),
(2327, '06432', 218, 8, 2367, 41.1924, 0.718943006798512, -73.2402, -1.27828263481915),
(2328, '06436', 218, 8, 113494, 41.1242, 0.717752692248652, -73.3147, -1.27958290511189),
(2329, '06437', 218, 8, 16297, 41.3143, 0.721070563156693, -72.6973, -1.26880724231007),
(2330, '06438', 218, 8, 32657, 41.4647, 0.723695538351693, -72.5173, -1.26566564965648),
(2331, '06439', 218, 8, 113513, 41.4193, 0.722903158871287, -72.401, -1.26363583173641),
(2332, '06440', 218, 8, 113548, 41.4339, 0.723157976942079, -73.3546, -1.28027929148343),
(2333, '06441', 218, 8, 113556, 41.4631, 0.723667613083661, -72.5749, -1.26667095930563),
(2334, '06442', 218, 8, 113589, 41.3444, 0.721595907261544, -72.4441, -1.26438806864402),
(2335, '06443', 218, 8, 3938, 41.3033, 0.720878576938974, -72.612, -1.26731847645812),
(2336, '06444', 218, 8, 630, 41.5645, 0.725437376945183, -72.9283, -1.27283895288218),
(2337, '06447', 218, 8, 22884, 41.6385, 0.726728920591659, -72.4584, -1.26463765072706),
(2338, '06450', 218, 8, 33252, 41.5341, 0.724906796852577, -72.7983, -1.27057002485459),
(2339, '06451', 218, 8, 33252, 41.5356, 0.724932976791357, -72.8229, -1.27099937585058),
(2340, '06454', 218, 8, 33252, 41.5404, 0.725016752595452, -72.8016, -1.2706276207199),
(2341, '06455', 218, 8, 113705, 41.5169, 0.724606600221234, -72.7191, -1.26918772408701),
(2342, '06456', 218, 8, 113702, 41.5548, 0.72526808000774, -72.5543, -1.26631142147972),
(2343, '06457', 218, 8, 14224, 41.5505, 0.725193030849904, -72.6639, -1.26822430233991),
(2344, '06459', 218, 8, 14224, 41.5481, 0.725151142947856, -72.6548, -1.26806547737798),
(2345, '06460', 218, 8, 10480, 41.2197, 0.719419481684307, -73.0503, -1.27496825456961),
(2346, '06467', 218, 8, 42099, 41.5655, 0.725454830237703, -72.902, -1.27237993128891),
(2347, '06468', 218, 8, 10560, 41.3311, 0.721363778471028, -73.2252, -1.27802083543135),
(2348, '06469', 218, 8, 113742, 41.5062, 0.72441984999127, -72.4503, -1.26449627905765),
(2349, '06470', 218, 8, 839, 41.394, 0.722461590570533, -73.3145, -1.27957941445338),
(2350, '06471', 218, 8, 113810, 41.3422, 0.721557510018, -72.7766, -1.27019128840691),
(2351, '06472', 218, 8, 113846, 41.3923, 0.722431919973249, -72.7839, -1.2703186974423),
(2352, '06473', 218, 8, 61095, 41.3804, 0.722224225792262, -72.8616, -1.2716748182711),
(2353, '06474', 218, 8, 113839, 41.5873, 0.725835312014638, -72.3989, -1.26359917982212),
(2354, '06475', 218, 8, 113868, 41.2894, 0.720635976172947, -72.3867, -1.26338624965338),
(2355, '06477', 218, 8, 4797, 41.2818, 0.720503331149795, -73.0281, -1.27458079147567),
(2356, '06478', 218, 8, 4828, 41.4249, 0.723000897309399, -73.1341, -1.27643084048279),
(2357, '06479', 218, 8, 73917, 41.579, 0.725690449686722, -72.899, -1.27232757141135),
(2358, '06480', 218, 8, 5188, 41.5813, 0.725730592259518, -72.6161, -1.26739003495745),
(2359, '06481', 218, 8, 0, 41.5333, 0.724892834218561, -72.6985, -1.2688281862611),
(2360, '06482', 218, 8, 31072, 41.4114, 0.72276527786038, -73.2488, -1.27843273313482),
(2361, '06483', 218, 8, 5745, 41.3971, 0.722515695777345, -73.0974, -1.2757903046473),
(2362, '06484', 218, 8, 38184, 41.3037, 0.720885558255982, -73.1339, -1.27642734982428),
(2363, '06487', 218, 8, 114079, 41.4717, 0.723817711399332, -73.2526, -1.2784990556464),
(2364, '06488', 218, 8, 114100, 41.4734, 0.723847381996616, -73.2206, -1.27794055028576),
(2365, '06489', 218, 8, 114103, 41.6063, 0.726166924572517, -72.8738, -1.27188774843984),
(2366, '06490', 218, 8, 18161, 41.1425, 0.718072087501767, -73.2885, -1.27912562884786),
(2367, '06491', 218, 8, 6080, 41.384, 0.722287057645333, -73.1858, -1.27733317570607),
(2368, '06492', 218, 8, 38730, 41.4598, 0.723610017218345, -72.8182, -1.27091734537574),
(2369, '06493', 218, 8, 38730, 41.4889, 0.724117908030675, -72.8197, -1.27094352531451),
(2370, '06494', 218, 8, 38730, 41.4716, 0.72381596607008, -72.8182, -1.27091734537574),
(2371, '06495', 218, 8, 38730, 41.457, 0.723561147999289, -72.824, -1.27101857447235),
(2372, '06497', 218, 8, 14683, 41.2073, 0.719203060857059, -73.1343, -1.27643433114129),
(2373, '06498', 218, 8, 6730, 41.2886, 0.720622013538931, -72.455, -1.26457830953249),
(2374, '06501', 218, 8, 4528, 41.3079, 0.720958862084566, -72.9242, -1.27276739438285),
(2375, '06502', 218, 8, 4528, 41.3083, 0.720965843401574, -72.9247, -1.27277612102911),
(2376, '06503', 218, 8, 4528, 41.3083, 0.720965843401574, -72.9243, -1.2727691397121),
(2377, '06504', 218, 8, 4528, 41.2939, 0.720714515989286, -72.9617, -1.27342189285235),
(2378, '06505', 218, 8, 4528, 41.3084, 0.720967588730826, -72.9249, -1.27277961168761),
(2379, '06506', 218, 8, 4528, 41.3077, 0.720955371426062, -72.9248, -1.27277786635836),
(2380, '06507', 218, 8, 4528, 41.3075, 0.720951880767558, -72.9244, -1.27277088504135),
(2381, '06508', 218, 8, 4528, 41.3071, 0.72094489945055, -72.9251, -1.27278310234612),
(2382, '06509', 218, 8, 4528, 41.3171, 0.721119432375749, -72.9264, -1.27280579162639),
(2383, '06510', 218, 8, 4528, 41.307, 0.720943154121298, -72.9248, -1.27277786635836),
(2384, '06511', 218, 8, 4528, 41.3257, 0.721269530691421, -72.938, -1.27300824981962),
(2385, '06512', 218, 8, 2170, 41.2776, 0.720430027321211, -72.8733, -1.27187902179358),
(2386, '06513', 218, 8, 4528, 41.316, 0.721100233753977, -72.8712, -1.27184236987929),
(2387, '06514', 218, 8, 55147, 41.3645, 0.721946718441194, -72.9376, -1.27300126850262),
(2388, '06515', 218, 8, 4528, 41.3275, 0.721300946617957, -72.967, -1.2735143953027),
(2389, '06516', 218, 8, 14826, 41.2701, 0.720299127627312, -72.9653, -1.27348472470542),
(2390, '06517', 218, 8, 55147, 41.3501, 0.721695391028907, -72.9115, -1.27254573756785),
(2391, '06518', 218, 8, 55147, 41.4149, 0.7228263643842, -72.9129, -1.27257017217737),
(2392, '06519', 218, 8, 4528, 41.2952, 0.720737205269562, -72.937, -1.2729907965271),
(2393, '06520', 218, 8, 4528, 41.3102, 0.720999004657362, -72.9295, -1.2728598968332),
(2394, '06521', 218, 8, 4528, 41.3103, 0.721000749986613, -72.9244, -1.27277088504135),
(2395, '06524', 218, 8, 7428, 41.4128, 0.722789712469908, -72.9961, -1.27402228611503),
(2396, '06525', 218, 8, 26188, 41.3577, 0.721828036052059, -73.0122, -1.2743032841246),
(2397, '06530', 218, 8, 4528, 41.3178, 0.721131649680513, -72.9267, -1.27281102761415),
(2398, '06531', 218, 8, 4528, 41.3181, 0.721136885668269, -72.9276, -1.27282673557742),
(2399, '06532', 218, 8, 4528, 41.3172, 0.721121177705001, -72.9269, -1.27281451827265),
(2400, '06533', 218, 8, 4528, 41.3173, 0.721122923034253, -72.9266, -1.2728092822849),
(2401, '06534', 218, 8, 4528, 41.3174, 0.721124668363505, -72.9278, -1.27283022623592),
(2402, '06535', 218, 8, 4528, 41.3174, 0.721124668363505, -72.9268, -1.2728127729434),
(2403, '06536', 218, 8, 4528, 41.3176, 0.721128159022009, -72.9265, -1.27280753695564),
(2404, '06537', 218, 8, 4528, 41.4294, 0.723079437125739, -72.9107, -1.27253177493383),
(2405, '06538', 218, 8, 4528, 41.4292, 0.723075946467235, -72.9113, -1.27254224690934),
(2406, '06540', 218, 8, 4528, 41.3073, 0.720948390109054, -72.9246, -1.27277437569986),
(2407, '06601', 218, 8, 1130, 41.1763, 0.718662008788941, -73.201, -1.27759846575237),
(2408, '06602', 218, 8, 1130, 41.1768, 0.718670735435201, -73.2001, -1.2775827577891),
(2409, '06604', 218, 8, 1130, 41.1811, 0.718745784593037, -73.2053, -1.2776735149102),
(2410, '06605', 218, 8, 1130, 41.1647, 0.71845955059571, -73.217, -1.27787771843269),
(2411, '06606', 218, 8, 1130, 41.2107, 0.719262402051627, -73.2099, -1.2777538000558),
(2412, '06607', 218, 8, 1130, 41.1771, 0.718675971422957, -73.1654, -1.27697712853866),
(2413, '06608', 218, 8, 1130, 41.1877, 0.718860976323668, -73.181, -1.27724939990197),
(2414, '06610', 218, 8, 1130, 41.2047, 0.719157682296508, -73.1697, -1.2770521776965),
(2415, '06611', 218, 8, 98642, 41.255, 0.720035582910261, -73.2075, -1.27771191215375),
(2416, '06612', 218, 8, 2193, 41.256, 0.720053036202781, -73.2886, -1.27912737417712),
(2417, '06614', 218, 8, 14683, 41.2285, 0.719573070658482, -73.1333, -1.27641687784877),
(2418, '06615', 218, 8, 14683, 41.187, 0.718848759018904, -73.1391, -1.27651810694538),
(2419, '06650', 218, 8, 1130, 41.1767, 0.718668990105949, -73.2007, -1.27759322976461),
(2420, '06673', 218, 8, 1130, 41.1828, 0.718775455190321, -73.1465, -1.27664726131003),
(2421, '06699', 218, 8, 1130, 41.1912, 0.718922062847488, -73.137, -1.27648145503109),
(2422, '06701', 218, 8, 18504, 41.5581, 0.725325675873056, -73.0515, -1.27498919852064),
(2423, '06702', 218, 8, 18504, 41.5558, 0.72528553330026, -73.0407, -1.27480070296142),
(2424, '06703', 218, 8, 18504, 41.5277, 0.724795095780449, -73.0081, -1.27423172562527),
(2425, '06704', 218, 8, 18504, 41.5781, 0.725674741723454, -73.0338, -1.27468027524303),
(2426, '06705', 218, 8, 18504, 41.5472, 0.725135434984588, -72.994, -1.27398563420074),
(2427, '06706', 218, 8, 18504, 41.5361, 0.724941703437617, -73.0265, -1.27455286620764),
(2428, '06708', 218, 8, 18504, 41.5532, 0.725240154739708, -73.0666, -1.27525274323769),
(2429, '06710', 218, 8, 18504, 41.5691, 0.725517662090775, -73.0457, -1.27488796942402),
(2430, '06712', 218, 8, 5238, 41.4938, 0.724203429164023, -72.9734, -1.27362609637483),
(2431, '06716', 218, 8, 34461, 41.5913, 0.725905125184718, -72.974, -1.27363656835034),
(2432, '06720', 218, 8, 18504, 41.5556, 0.725282042641756, -73.0399, -1.27478674032741),
(2433, '06721', 218, 8, 18504, 41.5584, 0.725330911860811, -73.06, -1.27513755150706),
(2434, '06722', 218, 8, 18504, 41.5557, 0.725283787971008, -73.0393, -1.27477626835189),
(2435, '06723', 218, 8, 18504, 41.556, 0.725289023958763, -73.0395, -1.2747797590104),
(2436, '06724', 218, 8, 18504, 41.5564, 0.725296005275772, -73.04, -1.27478848565666),
(2437, '06725', 218, 8, 18504, 41.5551, 0.725273315995496, -73.0411, -1.27480768427843),
(2438, '06726', 218, 8, 18504, 41.5554, 0.725278551983252, -73.0414, -1.27481292026619),
(2439, '06749', 218, 8, 18504, 41.5033, 0.724369235442963, -73.1532, -1.27676419836992),
(2440, '06750', 218, 8, 71736, 41.7139, 0.728044898847663, -73.2538, -1.27851999959742),
(2441, '06751', 218, 8, 548, 41.6412, 0.726776044481463, -73.2134, -1.27781488657962),
(2442, '06752', 218, 8, 19494, 41.5294, 0.724824766377733, -73.3625, -1.28041717249434),
(2443, '06753', 218, 8, 54205, 41.8279, 0.730034574194936, -73.3325, -1.27989357371874),
(2444, '06754', 218, 8, 113006, 41.7626, 0.728894874193384, -73.3605, -1.2803822659093),
(2445, '06755', 218, 8, 113462, 41.6489, 0.726910434833866, -73.4833, -1.28252553023075),
(2446, '06756', 218, 8, 419, 41.8475, 0.730376658728327, -73.231, -1.27812206452797),
(2447, '06757', 218, 8, 3501, 41.7361, 0.728432361941605, -73.4528, -1.28199320480889),
(2448, '06758', 218, 8, 9948, 41.6857, 0.7275527159986, -73.2357, -1.27820409500281),
(2449, '06759', 218, 8, 27727, 41.7485, 0.728648782768853, -73.191, -1.27742393282717),
(2450, '06762', 218, 8, 30497, 41.5309, 0.724850946316513, -73.1166, -1.27612540786369),
(2451, '06763', 218, 8, 4333, 41.6894, 0.727617293180924, -73.1964, -1.27751818060678),
(2452, '06770', 218, 8, 110604, 41.492, 0.724172013237487, -73.0496, -1.27495603726485),
(2453, '06776', 218, 8, 113788, 41.5825, 0.725751536210542, -73.4116, -1.28127412915707),
(2454, '06777', 218, 8, 0, 41.689, 0.727610311863916, -73.3479, -1.28016235442355),
(2455, '06778', 218, 8, 37457, 41.7067, 0.727919235141519, -73.1077, -1.27597007356026),
(2456, '06779', 218, 8, 4721, 41.5919, 0.72591559716023, -73.0865, -1.27560006375884),
(2457, '06781', 218, 8, 113900, 41.6697, 0.727273463318281, -73.0309, -1.27462966069473),
(2458, '06782', 218, 8, 14433, 41.6661, 0.727210631465209, -73.0475, -1.27491938535056),
(2459, '06783', 218, 8, 33833, 41.5565, 0.725297750605024, -73.2991, -1.27931063374858),
(2460, '06784', 218, 8, 18065, 41.5757, 0.725632853821406, -73.4975, -1.28277336698453),
(2461, '06785', 218, 8, 114086, 41.7018, 0.727833714008171, -73.4421, -1.28180645457893),
(2462, '06786', 218, 8, 38513, 41.6758, 0.727379928402653, -73.0086, -1.27424045227153),
(2463, '06787', 218, 8, 6315, 41.6733, 0.727336295171353, -73.0844, -1.27556341184454),
(2464, '06790', 218, 8, 114179, 41.8127, 0.729769284148633, -73.1177, -1.27614460648546),
(2465, '06791', 218, 8, 113537, 41.7681, 0.728990867302243, -73.0704, -1.27531906574926),
(2466, '06793', 218, 8, 12671, 41.6385, 0.726728920591659, -73.2947, -1.27923383926149),
(2467, '06794', 218, 8, 0, 41.6485, 0.726903453516858, -73.3237, -1.27973998474457),
(2468, '06795', 218, 8, 18507, 41.6056, 0.726154707267753, -73.1237, -1.27624932624058),
(2469, '06796', 218, 8, 114241, 41.8646, 0.730675110030418, -73.3324, -1.27989182838949),
(2470, '06798', 218, 8, 362, 41.5556, 0.725282042641756, -73.2067, -1.27769794951973),
(2471, '06801', 218, 8, 220, 41.3814, 0.722241679084781, -73.3984, -1.28104374569581),
(2472, '06804', 218, 8, 13444, 41.465, 0.723700774339449, -73.3967, -1.28101407509852),
(2473, '06807', 218, 8, 113022, 41.0522, 0.716496055187216, -73.593, -1.28444015642019),
(2474, '06810', 218, 8, 64114, 41.3884, 0.722363852132421, -73.4576, -1.28207698061299),
(2475, '06811', 218, 8, 64114, 41.4244, 0.722992170663139, -73.4727, -1.28234052533004),
(2476, '06812', 218, 8, 30629, 41.4734, 0.723847381996616, -73.4965, -1.28275591369201),
(2477, '06813', 218, 8, 64114, 41.3963, 0.722501733143329, -73.4541, -1.28201589408917),
(2478, '06814', 218, 8, 64114, 41.3761, 0.722149176634426, -73.4861, -1.2825743994498),
(2479, '06816', 218, 8, 64114, 41.4091, 0.722725135287584, -73.4067, -1.28118860802372),
(2480, '06817', 218, 8, 64114, 41.3951, 0.722480789192305, -73.4543, -1.28201938474767),
(2481, '06820', 218, 8, 20468, 41.079, 0.716963803426751, -73.482, -1.28250284095047),
(2482, '06824', 218, 8, 2367, 41.1689, 0.718532854424294, -73.2676, -1.2787608550342),
(2483, '06825', 218, 8, 2367, 41.1927, 0.718948242786268, -73.2406, -1.27828961613616),
(2484, '06828', 218, 8, 2367, 41.2187, 0.719402028391787, -73.2517, -1.27848334768313),
(2485, '06829', 218, 8, 2693, 41.257, 0.720070489495301, -73.4321, -1.28163192165373),
(2486, '06830', 218, 8, 32630, 41.0356, 0.716206330531385, -73.6289, -1.28506672962165),
(2487, '06831', 218, 8, 32630, 41.0615, 0.716658370807652, -73.6568, -1.28555367648296),
(2488, '06832', 218, 8, 32630, 41.0265, 0.716047505569454, -73.6289, -1.28506672962165),
(2489, '06836', 218, 8, 32630, 41.0258, 0.71603528826469, -73.6261, -1.2850178604026),
(2490, '06838', 218, 8, 113494, 41.1244, 0.717756182907156, -73.3152, -1.27959163175815),
(2491, '06840', 218, 8, 4519, 41.152, 0.718237893780706, -73.495, -1.28272973375323),
(2492, '06842', 218, 8, 4519, 41.1471, 0.718152372647359, -73.4956, -1.28274020572874),
(2493, '06850', 218, 8, 17325, 41.1257, 0.717778872187432, -73.4407, -1.2817820199694),
(2494, '06851', 218, 8, 17325, 41.1321, 0.71789057325956, -73.4051, -1.28116068275569),
(2495, '06852', 218, 8, 17325, 41.0935, 0.71721687616829, -73.4201, -1.28142248214349),
(2496, '06853', 218, 8, 17325, 41.0684, 0.716778798526039, -73.4391, -1.28175409470137),
(2497, '06854', 218, 8, 17325, 41.0926, 0.717201168205022, -73.4308, -1.28160923237345),
(2498, '06855', 218, 8, 17325, 41.101, 0.717347775862189, -73.3991, -1.28105596300057),
(2499, '06856', 218, 8, 17325, 41.1105, 0.717513582141129, -73.4214, -1.28144517142376),
(2500, '06857', 218, 8, 17325, 41.0946, 0.717236074790062, -73.4327, -1.28164239362924),
(2501, '06858', 218, 8, 17325, 41.1284, 0.717825996077236, -73.4435, -1.28183088918846),
(2502, '06859', 218, 8, 17325, 41.1392, 0.718014491636451, -73.4053, -1.28116417341419),
(2503, '06860', 218, 8, 17325, 41.0844, 0.717058051206358, -73.4766, -1.28240859317087),
(2504, '06870', 218, 8, 113863, 41.0325, 0.716152225324573, -73.5664, -1.28397589883916),
(2505, '06875', 218, 8, 0, 41.324, 0.721239860094137, -73.3711, -1.28056727081001),
(2506, '06876', 218, 8, 113971, 41.3203, 0.721175282911813, -73.3556, -1.28029674477595),
(2507, '06877', 218, 8, 24320, 41.2978, 0.720782583830114, -73.4988, -1.28279605626481),
(2508, '06878', 218, 8, 5423, 41.0354, 0.716202839872881, -73.5825, -1.28425689684873),
(2509, '06879', 218, 8, 24320, 41.2733, 0.720354978163376, -73.4997, -1.28281176422808),
(2510, '06880', 218, 8, 25961, 41.143, 0.718080814148027, -73.3477, -1.28015886376505),
(2511, '06881', 218, 8, 25961, 41.1413, 0.718051143550743, -73.3614, -1.28039797387257),
(2512, '06883', 218, 8, 6746, 41.2172, 0.719375848453007, -73.3694, -1.28053760021273),
(2513, '06888', 218, 8, 25961, 41.1229, 0.717730002968376, -73.3476, -1.28015711843579),
(2514, '06889', 218, 8, 25961, 41.1408, 0.718042416904483, -73.3621, -1.28041019117733),
(2515, '06890', 218, 8, 18161, 41.1432, 0.718084304806531, -73.2889, -1.27913261016487),
(2516, '06896', 218, 8, 11513, 41.3006, 0.72083145304917, -73.4058, -1.28117290006045),
(2517, '06897', 218, 8, 287, 41.2027, 0.719122775711468, -73.4366, -1.28171046147007),
(2518, '06901', 218, 8, 98270, 41.0532, 0.716513508479736, -73.5395, -1.28350640527037),
(2519, '06902', 218, 8, 98270, 41.0542, 0.716530961772256, -73.5424, -1.28355701981868),
(2520, '06903', 218, 8, 98270, 41.1357, 0.717953405112631, -73.5685, -1.28401255075345),
(2521, '06904', 218, 8, 98270, 41.0542, 0.716530961772256, -73.5392, -1.28350116928261),
(2522, '06905', 218, 8, 98270, 41.0853, 0.717073759169626, -73.5429, -1.28356574646494),
(2523, '06906', 218, 8, 98270, 41.0695, 0.716797997147811, -73.5234, -1.2832254072608),
(2524, '06907', 218, 8, 98270, 41.0978, 0.717291925326126, -73.5216, -1.28319399133426),
(2525, '06910', 218, 8, 98270, 41.0418, 0.716314540945009, -73.5491, -1.28367395687856),
(2526, '06911', 218, 8, 98270, 41.0382, 0.716251709091937, -73.5602, -1.28386768842553),
(2527, '06912', 218, 8, 98270, 41.0532, 0.716513508479736, -73.5384, -1.2834872066486),
(2528, '06913', 218, 8, 98270, 41.0541, 0.716529216443004, -73.5393, -1.28350291461187),
(2529, '06914', 218, 8, 98270, 41.0964, 0.717267490716598, -73.5527, -1.28373678873163),
(2530, '06920', 218, 8, 98270, 41.0541, 0.716529216443004, -73.5383, -1.28348546131935),
(2531, '06921', 218, 8, 98270, 41.0499, 0.71645591261442, -73.538, -1.28348022533159),
(2532, '06922', 218, 8, 98270, 41.0564, 0.7165693590158, -73.5148, -1.28307530894513),
(2533, '06925', 218, 8, 98270, 41.041, 0.716300578310993, -73.5584, -1.283836272499),
(2534, '06926', 218, 8, 98270, 41.0426, 0.716328503579025, -73.5489, -1.28367046622006),
(2535, '06927', 218, 8, 98270, 41.0429, 0.716333739566781, -73.5498, -1.28368617418333),
(2536, '06928', 218, 8, 98270, 41.0413, 0.716305814298749, -73.558, -1.28382929118199),
(2537, '07001', 218, 37, 44517, 40.5797, 0.708249374471543, -74.2783, -1.2964008977841),
(2538, '07002', 218, 37, 144798, 40.6657, 0.709750357628258, -74.1195, -1.29362931493194),
(2539, '07003', 218, 37, 7544, 40.807, 0.712216507861326, -74.1875, -1.29481613882329),
(2540, '07004', 218, 37, 2367, 40.8838, 0.713556920726858, -74.3074, -1.29690878859643),
(2541, '07005', 218, 37, 144862, 40.9301, 0.714365008170531, -74.4178, -1.29883563209064),
(2542, '07006', 218, 37, 1290, 40.8472, 0.712918130220628, -74.2792, -1.29641660574737),
(2543, '07007', 218, 37, 1290, 40.8379, 0.712755814600192, -74.2777, -1.29639042580859),
(2544, '07008', 218, 37, 144951, 40.5838, 0.708320932970875, -74.2336, -1.29562073560846),
(2545, '07009', 218, 37, 1414, 40.856, 0.713071719194803, -74.23, -1.29555790375539),
(2546, '07010', 218, 37, 145004, 40.821, 0.712460853956605, -73.9891, -1.29135340558734),
(2547, '07011', 218, 37, 15559, 40.8795, 0.713481871569022, -74.1442, -1.29406041125718),
(2548, '07012', 218, 37, 15559, 40.8485, 0.712940819500904, -74.1594, -1.29432570130348),
(2549, '07013', 218, 37, 15559, 40.8688, 0.713295121339059, -74.1707, -1.29452292350896),
(2550, '07014', 218, 37, 15559, 40.8337, 0.712682510771609, -74.138, -1.29395220084356),
(2551, '07015', 218, 37, 15559, 40.8905, 0.713673857786741, -74.132, -1.29384748108844),
(2552, '07016', 218, 37, 72234, 40.6559, 0.709579315361563, -74.3053, -1.29687213668214),
(2553, '07017', 218, 37, 145126, 40.7719, 0.711603897293876, -74.2075, -1.29516520467369),
(2554, '07018', 218, 37, 145126, 40.7553, 0.711314172638045, -74.2178, -1.29534497358665),
(2555, '07019', 218, 37, 145126, 40.7613, 0.711418892393165, -74.2099, -1.29520709257574),
(2556, '07020', 218, 37, 2228, 40.8345, 0.712696473405624, -73.9735, -1.29108113422403),
(2557, '07021', 218, 37, 145181, 40.827, 0.712565573711725, -74.2809, -1.29644627634466),
(2558, '07022', 218, 37, 500, 40.8177, 0.712403258091289, -74.0042, -1.29161695030439),
(2559, '07023', 218, 37, 145207, 40.6414, 0.709326242620023, -74.385, -1.29826316409598),
(2560, '07024', 218, 37, 102055, 40.8496, 0.712960018122676, -73.9767, -1.29113698476009),
(2561, '07026', 218, 37, 9050, 40.8802, 0.713494088873786, -74.1083, -1.29343383805571),
(2562, '07027', 218, 37, 54919, 40.6515, 0.709502520874475, -74.3231, -1.297182805289),
(2563, '07028', 218, 37, 16217, 40.8045, 0.712172874630026, -74.2055, -1.29513029808865),
(2564, '07029', 218, 37, 9353, 40.7471, 0.711171055639382, -74.1513, -1.29418432963407),
(2565, '07030', 218, 37, 3171, 40.7464, 0.711158838334618, -74.0352, -1.29215800237251),
(2566, '07031', 218, 37, 145906, 40.7917, 0.711949472485771, -74.1314, -1.29383700911292),
(2567, '07032', 218, 37, 95258, 40.7516, 0.711249595455721, -74.1061, -1.29339544081217),
(2568, '07033', 218, 37, 13136, 40.6749, 0.709910927919442, -74.2933, -1.2966626971719),
(2569, '07034', 218, 37, 145553, 40.8809, 0.71350630617855, -74.382, -1.29821080421842),
(2570, '07035', 218, 37, 13147, 40.924, 0.714258543086159, -74.3045, -1.29685817404813),
(2571, '07036', 218, 37, 3784, 40.6243, 0.709027791317932, -74.2268, -1.29550205321933),
(2572, '07039', 218, 37, 3825, 40.7897, 0.711914565900731, -74.3214, -1.29715313469171),
(2573, '07040', 218, 37, 3982, 40.7282, 0.710841188410755, -74.2674, -1.29621065689564),
(2574, '07041', 218, 37, 120631, 40.7237, 0.710762648594415, -74.3009, -1.29679534219505),
(2575, '07042', 218, 37, 17169, 40.8133, 0.712326463604202, -74.2174, -1.29533799226964),
(2576, '07043', 218, 37, 17169, 40.843, 0.712844826392044, -74.2004, -1.2950412862968),
(2577, '07044', 218, 37, 12546, 40.8319, 0.712651094845073, -74.2428, -1.29578130589965),
(2578, '07045', 218, 37, 125472, 40.9086, 0.713989762381352, -74.3662, -1.29793504219661),
(2579, '07046', 218, 37, 82515, 40.8894, 0.713654659164969, -74.4399, -1.29922134985533),
(2580, '07047', 218, 37, 145908, 40.7923, 0.711959944461283, -74.0215, -1.29191889226498),
(2581, '07050', 218, 37, 4797, 40.7686, 0.71154630142856, -74.2376, -1.29569054877854),
(2582, '07051', 218, 37, 4797, 40.7682, 0.711539320111552, -74.2359, -1.29566087818126),
(2583, '07052', 218, 37, 99006, 40.7874, 0.711874423327935, -74.2585, -1.29605532259221),
(2584, '07054', 218, 37, 145999, 40.8615, 0.713167712303663, -74.4128, -1.29874836562804),
(2585, '07055', 218, 37, 56810, 40.8583, 0.713111861767599, -74.1312, -1.29383351845442),
(2586, '07057', 218, 37, 146541, 40.8533, 0.713024595304999, -74.1074, -1.29341813009245),
(2587, '07058', 218, 37, 137476, 40.8732, 0.713371915826146, -74.3491, -1.29763659089452),
(2588, '07059', 218, 37, 12663, 40.6317, 0.70915694568258, -74.5098, -1.30044133500247),
(2589, '07060', 218, 37, 11247, 40.6139, 0.708846277075725, -74.4254, -1.29896827711379),
(2590, '07061', 218, 37, 11247, 40.6153, 0.708870711685253, -74.4165, -1.29881294281036),
(2591, '07062', 218, 37, 11247, 40.6312, 0.70914821903632, -74.4017, -1.29855463408107),
(2592, '07063', 218, 37, 11247, 40.6007, 0.708615893614462, -74.4443, -1.29929814434241),
(2593, '07064', 218, 37, 146097, 40.5664, 0.708017245681028, -74.2541, -1.29597852810512),
(2594, '07065', 218, 37, 146132, 40.6074, 0.708732830674345, -74.2825, -1.29647420161269),
(2595, '07066', 218, 37, 1590, 40.6206, 0.708963214135609, -74.3099, -1.29695242182773),
(2596, '07067', 218, 37, 145026, 40.591, 0.708446596677018, -74.3155, -1.29705016026585),
(2597, '07068', 218, 37, 11685, 40.8204, 0.712450381981093, -74.3029, -1.29683024878009),
(2598, '07069', 218, 37, 146574, 40.6376, 0.709259920108448, -74.4512, -1.2994185720608),
(2599, '07070', 218, 37, 5589, 40.8287, 0.712595244309009, -74.112, -1.29349841523804),
(2600, '07071', 218, 37, 103886, 40.8089, 0.712249669117114, -74.122, -1.29367294816324),
(2601, '07072', 218, 37, 144943, 40.8355, 0.712713926698144, -74.0817, -1.29296958047468),
(2602, '07073', 218, 37, 145129, 40.8367, 0.712734870649168, -74.1032, -1.29334482626386),
(2603, '07074', 218, 37, 145805, 40.8391, 0.712776758551216, -74.0581, -1.29255768277121),
(2604, '07075', 218, 37, 14889, 40.8477, 0.712926856866888, -74.0873, -1.29306731891279),
(2605, '07076', 218, 37, 146275, 40.6223, 0.708992884732893, -74.377, -1.29812353775582),
(2606, '07077', 218, 37, 146287, 40.5549, 0.707816532817048, -74.2637, -1.29614607971331),
(2607, '07078', 218, 37, 146302, 40.7367, 0.710989541397174, -74.3283, -1.2972735624101),
(2608, '07079', 218, 37, 146351, 40.748, 0.711186763602649, -74.2599, -1.29607975720174),
(2609, '07080', 218, 37, 146353, 40.5796, 0.708247629142291, -74.4155, -1.29879548951784),
(2610, '07081', 218, 37, 349, 40.6999, 0.71034726023244, -74.3238, -1.29719502259376),
(2611, '07082', 218, 37, 146463, 40.9261, 0.714295195000451, -74.3443, -1.29755281509042),
(2612, '07083', 218, 37, 455, 40.6951, 0.710263484428344, -74.2703, -1.29626127144394),
(2613, '07086', 218, 37, 146584, 40.7683, 0.711541065440804, -74.0302, -1.29207073590991),
(2614, '07087', 218, 37, 12457, 40.7678, 0.711532338794544, -74.0297, -1.29206200926365),
(2615, '07088', 218, 37, 146519, 40.7181, 0.710664910156303, -74.2848, -1.29651434418548),
(2616, '07090', 218, 37, 723, 40.6489, 0.709457142313923, -74.3468, -1.29759644832172),
(2617, '07091', 218, 37, 723, 40.6956, 0.710272211074604, -74.3838, -1.29824222014496),
(2618, '07092', 218, 37, 145848, 40.6763, 0.709935362528969, -74.3583, -1.2977971611857),
(2619, '07093', 218, 37, 146611, 40.7889, 0.711900603266715, -74.0132, -1.29177402993707),
(2620, '07094', 218, 37, 146283, 40.7905, 0.711928528534747, -74.0616, -1.29261876929503),
(2621, '07095', 218, 37, 26188, 40.5574, 0.707860166048348, -74.2855, -1.29652656149025),
(2622, '07096', 218, 37, 146283, 40.7811, 0.71176446758506, -74.0648, -1.2926746198311),
(2623, '07097', 218, 37, 145508, 40.7515, 0.711247850126469, -74.0542, -1.29248961493038),
(2624, '07099', 218, 37, 95258, 40.753, 0.711274030065249, -74.1211, -1.29365724019997),
(2625, '07101', 218, 37, 10792, 40.7241, 0.710769629911423, -74.1735, -1.29457179272801),
(2626, '07102', 218, 37, 10792, 40.7333, 0.710930200202606, -74.1732, -1.29456655674026),
(2627, '07103', 218, 37, 10792, 40.7386, 0.711022702652962, -74.1947, -1.29494180252944),
(2628, '07104', 218, 37, 10792, 40.7669, 0.711516630831276, -74.1678, -1.29447230896065),
(2629, '07105', 218, 37, 10792, 40.7233, 0.710755667277407, -74.1382, -1.29395569150206),
(2630, '07106', 218, 37, 10792, 40.7418, 0.711078553189026, -74.2301, -1.29555964908464),
(2631, '07107', 218, 37, 10792, 40.7605, 0.711404929759149, -74.1892, -1.29484580942058),
(2632, '07108', 218, 37, 10792, 40.7222, 0.710736468655635, -74.2018, -1.29506572090633),
(2633, '07109', 218, 37, 263, 40.7932, 0.711975652424551, -74.164, -1.29440598644907),
(2634, '07110', 218, 37, 145937, 40.8175, 0.712399767432786, -74.1607, -1.29434839058376),
(2635, '07111', 218, 37, 3366, 40.7247, 0.710780101886935, -74.2309, -1.29557361171866),
(2636, '07112', 218, 37, 10792, 40.7118, 0.710554954413427, -74.2114, -1.29523327251452),
(2637, '07114', 218, 37, 10792, 40.7166, 0.710638730217523, -74.1733, -1.29456830206951),
(2638, '07175', 218, 37, 10792, 40.7362, 0.710980814750914, -74.173, -1.29456306608175),
(2639, '07182', 218, 37, 10792, 40.7311, 0.710891802959062, -74.1742, -1.29458401003278),
(2640, '07184', 218, 37, 10792, 40.7229, 0.710748685960399, -74.2151, -1.29529784969684),
(2641, '07188', 218, 37, 10792, 40.731, 0.71089005762981, -74.174, -1.29458051937427),
(2642, '07189', 218, 37, 10792, 40.7966, 0.712034993619119, -74.1595, -1.29432744663273),
(2643, '07191', 218, 37, 10792, 40.7007, 0.710361222866456, -74.1703, -1.29451594219195),
(2644, '07192', 218, 37, 10792, 40.7312, 0.710893548288314, -74.1745, -1.29458924602053),
(2645, '07193', 218, 37, 10792, 40.7309, 0.710888312300558, -74.1746, -1.29459099134979),
(2646, '07194', 218, 37, 10792, 40.7006, 0.710359477537204, -74.1698, -1.29450721554569),
(2647, '07195', 218, 37, 10792, 40.7308, 0.710886566971306, -74.1744, -1.29458750069128),
(2648, '07197', 218, 37, 10792, 40.7685, 0.711544556099308, -74.1692, -1.29449674357018),
(2649, '07198', 218, 37, 10792, 40.7352, 0.710963361458394, -74.1402, -1.2939905980871),
(2650, '07199', 218, 37, 10792, 40.7274, 0.710827225776739, -74.1719, -1.29454386745998),
(2651, '07201', 218, 37, 8719, 40.6656, 0.709748612299006, -74.1779, -1.2946485872151),
(2652, '07202', 218, 37, 8719, 40.6544, 0.709553135422783, -74.2193, -1.29537115352543),
(2653, '07203', 218, 37, 5552, 40.6516, 0.709504266203727, -74.2621, -1.29611815444528),
(2654, '07204', 218, 37, 146224, 40.6655, 0.709746866969754, -74.2669, -1.29620193024938),
(2655, '07205', 218, 37, 36430, 40.6957, 0.710273956403856, -74.2303, -1.29556313974315),
(2656, '07206', 218, 37, 8719, 40.6535, 0.709537427459515, -74.1886, -1.29483533744507),
(2657, '07207', 218, 37, 8719, 40.6702, 0.709828897444598, -74.2169, -1.29532926562338),
(2658, '07208', 218, 37, 8719, 40.673, 0.709877766663654, -74.2276, -1.29551601585334),
(2659, '07302', 218, 37, 145508, 40.7226, 0.710743449972643, -74.0483, -1.29238664050452),
(2660, '07303', 218, 37, 145508, 40.7169, 0.710643966205279, -74.0454, -1.29233602595621),
(2661, '07304', 218, 37, 145508, 40.7166, 0.710638730217523, -74.0734, -1.29282471814677),
(2662, '07305', 218, 37, 145508, 40.7025, 0.710392638792992, -74.0885, -1.29308826286382),
(2663, '07306', 218, 37, 145508, 40.7327, 0.710919728227094, -74.0656, -1.29268858246511),
(2664, '07307', 218, 37, 145508, 40.7479, 0.711185018273397, -74.0508, -1.29243027373582),
(2665, '07308', 218, 37, 145508, 40.7345, 0.71095114415363, -74.059, -1.29257339073448),
(2666, '07309', 218, 37, 145508, 40.7122, 0.710561935730435, -74.0614, -1.29261527863653),
(2667, '07310', 218, 37, 145508, 40.7323, 0.710912746910086, -74.0417, -1.29227144877389),
(2668, '07311', 218, 37, 145508, 40.7215, 0.710724251350871, -74.045, -1.2923290446392),
(2669, '07399', 218, 37, 145508, 40.728, 0.710837697752251, -74.0781, -1.29290674862161),
(2670, '07401', 218, 37, 7060, 41.033, 0.716160951970833, -74.1345, -1.29389111431974),
(2671, '07403', 218, 37, 13040, 41.0134, 0.715818867437442, -74.3325, -1.29734686623868),
(2672, '07405', 218, 37, 1257, 40.9883, 0.715380789795192, -74.3827, -1.29822302152319),
(2673, '07407', 218, 37, 80874, 40.9044, 0.713916458552769, -74.1192, -1.29362407894418),
(2674, '07410', 218, 37, 113417, 40.9355, 0.714459255950139, -74.1176, -1.29359615367615),
(2675, '07416', 218, 37, 2595, 41.118, 0.717644481835028, -74.5973, -1.30196849809797),
(2676, '07417', 218, 37, 145260, 41.0097, 0.715754290255119, -74.2091, -1.29519312994172),
(2677, '07418', 218, 37, 2749, 41.2447, 0.719855813997305, -74.4845, -1.29999976670172),
(2678, '07419', 218, 37, 2948, 41.1521, 0.718239639109958, -74.5663, -1.30142744602985),
(2679, '07420', 218, 37, 9374, 41.0292, 0.716094629459258, -74.2974, -1.29673425567123),
(2680, '07421', 218, 37, 65527, 41.1562, 0.71831119760929, -74.3679, -1.29796471279389),
(2681, '07422', 218, 37, 16431, 41.1919, 0.718934280152252, -74.4454, -1.29931734296419),
(2682, '07423', 218, 37, 0, 40.9995, 0.715576266671415, -74.1015, -1.29331515566658),
(2683, '07424', 218, 37, 103722, 40.8865, 0.713604044616661, -74.2177, -1.2953432282574),
(2684, '07428', 218, 37, 37116, 41.1847, 0.718808616446109, -74.5497, -1.30113772137402),
(2685, '07430', 218, 37, 145674, 41.0757, 0.716906207561435, -74.1569, -1.29428206807218),
(2686, '07432', 218, 37, 33269, 40.9952, 0.715501217513579, -74.1423, -1.29402725000139),
(2687, '07435', 218, 37, 37415, 41.0615, 0.716658370807652, -74.4361, -1.29915502734375),
(2688, '07436', 218, 37, 4710, 41.0287, 0.716085902812997, -74.234, -1.29562771692547),
(2689, '07438', 218, 37, 4694, 41.0179, 0.715897407253782, -74.5159, -1.30054780008684),
(2690, '07439', 218, 37, 145957, 41.0766, 0.716921915524703, -74.5961, -1.30194755414694),
(2691, '07440', 218, 37, 146019, 40.9476, 0.71467044078963, -74.2952, -1.29669585842769),
(2692, '07442', 218, 37, 146088, 40.9987, 0.715562304037399, -74.2869, -1.29655099609978),
(2693, '07444', 218, 37, 146090, 40.9657, 0.714986345384241, -74.3075, -1.29691053392569),
(2694, '07446', 218, 37, 5291, 41.0572, 0.716583321649816, -74.1464, -1.29409880850072),
(2695, '07450', 218, 37, 5393, 40.982, 0.715270834052316, -74.1125, -1.2935071418843),
(2696, '07451', 218, 37, 5393, 40.9781, 0.715202766211488, -74.12, -1.2936380415782),
(2697, '07452', 218, 37, 78351, 40.9591, 0.714871153653609, -74.1261, -1.29374450666257),
(2698, '07456', 218, 37, 42810, 41.0869, 0.717101684437658, -74.2827, -1.29647769227119),
(2699, '07457', 218, 37, 5416, 40.9911, 0.715429659014248, -74.3112, -1.29697511110801),
(2700, '07458', 218, 37, 146248, 41.0511, 0.716476856565444, -74.0957, -1.29321392656996),
(2701, '07460', 218, 37, 38390, 41.0979, 0.717293670655378, -74.5242, -1.30069266241476),
(2702, '07461', 218, 37, 106745, 41.2456, 0.719871521960573, -74.5979, -1.30197897007348),
(2703, '07462', 218, 37, 6535, 41.1821, 0.718763237885557, -74.5043, -1.30034534189361),
(2704, '07463', 218, 37, 146537, 41.0124, 0.715801414144922, -74.1261, -1.29374450666257),
(2705, '07465', 218, 37, 146547, 41.0543, 0.716532707101508, -74.2821, -1.29646722029568),
(2706, '07470', 218, 37, 6665, 40.9448, 0.714621571570574, -74.2463, -1.29584239242347),
(2707, '07474', 218, 37, 6665, 40.9486, 0.71468789408215, -74.2463, -1.29584239242347),
(2708, '07477', 218, 37, 6665, 40.9487, 0.714689639411402, -74.2457, -1.29583192044795),
(2709, '07480', 218, 37, 112663, 41.0936, 0.717218621497542, -74.3707, -1.29801358201295),
(2710, '07481', 218, 37, 146685, 40.9981, 0.715551832061887, -74.1667, -1.29445311033888),
(2711, '07495', 218, 37, 145674, 41.0814, 0.717005691328799, -74.1868, -1.29480392151853),
(2712, '07498', 218, 37, 145674, 41.0887, 0.717133100364194, -74.1441, -1.29405866592793),
(2713, '07501', 218, 37, 146006, 40.9138, 0.714080519502456, -74.1723, -1.29455084877699),
(2714, '07502', 218, 37, 146006, 40.9208, 0.714202692550096, -74.1942, -1.29493307588318),
(2715, '07503', 218, 37, 146006, 40.897, 0.713787304188121, -74.1569, -1.29428206807218),
(2716, '07504', 218, 37, 146006, 40.9123, 0.714054339563676, -74.1458, -1.29408833652521),
(2717, '07505', 218, 37, 146006, 40.9158, 0.714115426087496, -74.1724, -1.29455259410624),
(2718, '07506', 218, 37, 13124, 40.9561, 0.71481879377605, -74.1599, -1.29433442794974),
(2719, '07507', 218, 37, 13124, 40.9565, 0.714825775093058, -74.1594, -1.29432570130348),
(2720, '07508', 218, 37, 145362, 40.9491, 0.71469662072841, -74.1848, -1.29476901493349),
(2721, '07509', 218, 37, 146006, 40.9129, 0.714064811539188, -74.1715, -1.29453688614297),
(2722, '07510', 218, 37, 146006, 40.9105, 0.71402292363714, -74.1723, -1.29455084877699),
(2723, '07511', 218, 37, 146461, 40.9048, 0.713923439869777, -74.2225, -1.29542700406149),
(2724, '07512', 218, 37, 146461, 40.9039, 0.713907731906509, -74.2196, -1.29537638951318),
(2725, '07513', 218, 37, 146006, 40.9073, 0.713967073101076, -74.1501, -1.29416338568305),
(2726, '07514', 218, 37, 146006, 40.9231, 0.714242835122891, -74.1462, -1.29409531784222),
(2727, '07522', 218, 37, 146006, 40.9259, 0.714291704341947, -74.1795, -1.29467651248313),
(2728, '07524', 218, 37, 146006, 40.9311, 0.714382461463051, -74.1566, -1.29427683208443),
(2729, '07533', 218, 37, 146006, 40.8976, 0.713797776163633, -74.1541, -1.29423319885313),
(2730, '07538', 218, 37, 145362, 40.9372, 0.714488926547423, -74.1891, -1.29484406409133),
(2731, '07543', 218, 37, 146006, 40.9059, 0.713942638491548, -74.1469, -1.29410753514698),
(2732, '07544', 218, 37, 146006, 40.9329, 0.714413877389587, -74.1567, -1.29427857741368),
(2733, '07601', 218, 37, 135744, 40.8873, 0.713618007250678, -74.0499, -1.29241456577255),
(2734, '07602', 218, 37, 135744, 40.8891, 0.713649423177213, -74.0466, -1.29235696990723),
(2735, '07603', 218, 37, 910, 40.8751, 0.713405077081934, -74.0283, -1.29203757465412),
(2736, '07604', 218, 37, 145388, 40.8628, 0.713190401583939, -74.0752, -1.2928561340733),
(2737, '07605', 218, 37, 16881, 40.8629, 0.713192146913191, -73.9866, -1.29130977235604),
(2738, '07606', 218, 37, 146356, 40.8661, 0.713247997449255, -74.0485, -1.29239013116302),
(2739, '07607', 218, 37, 30467, 40.9028, 0.713888533284737, -74.0625, -1.2926344772583),
(2740, '07608', 218, 37, 146444, 40.8594, 0.713131060389371, -74.0627, -1.2926379679168),
(2741, '07620', 218, 37, 7073, 40.9575, 0.714843228385578, -73.9266, -1.29026257480484),
(2742, '07621', 218, 37, 144828, 40.9239, 0.714256797756908, -73.9983, -1.29151397587852),
(2743, '07624', 218, 37, 141517, 40.9701, 0.715063139871329, -73.9601, -1.29084726010426),
(2744, '07626', 218, 37, 145062, 40.9425, 0.714581428997778, -73.9633, -1.29090311064032),
(2745, '07627', 218, 37, 145093, 40.955, 0.714799595154278, -73.9603, -1.29085075076276),
(2746, '07628', 218, 37, 115345, 40.9445, 0.714616335582818, -73.992, -1.29140402013564),
(2747, '07630', 218, 37, 8753, 40.9743, 0.715136443699913, -74.0295, -1.29205851860514),
(2748, '07631', 218, 37, 2297, 40.8943, 0.713740180298317, -73.9756, -1.29111778613832),
(2749, '07632', 218, 37, 145172, 40.8832, 0.713546448751346, -73.9549, -1.29075650298315),
(2750, '07640', 218, 37, 145383, 40.9911, 0.715429659014248, -73.98, -1.29119458062541),
(2751, '07641', 218, 37, 76048, 40.9604, 0.714893842933885, -73.9891, -1.29135340558734),
(2752, '07642', 218, 37, 3147, 41.0055, 0.715680986426535, -74.0445, -1.29232031799294),
(2753, '07643', 218, 37, 145620, 40.8493, 0.71295478213492, -74.0419, -1.29227493943239),
(2754, '07644', 218, 37, 112, 40.8789, 0.71347139959351, -74.0797, -1.29293467388964),
(2755, '07645', 218, 37, 89122, 41.0485, 0.716431478004892, -74.0399, -1.29224003284735),
(2756, '07646', 218, 37, 113788, 40.935, 0.714450529303879, -74.022, -1.29192761891124),
(2757, '07647', 218, 37, 145930, 41.0103, 0.715764762230631, -73.9516, -1.29069890711784),
(2758, '07648', 218, 37, 4648, 40.9947, 0.715492490867319, -73.9563, -1.29078093759268),
(2759, '07649', 218, 37, 145966, 40.9533, 0.714769924556994, -74.0342, -1.29214054907999),
(2760, '07650', 218, 37, 50170, 40.8511, 0.712986198061456, -73.9986, -1.29151921186628),
(2761, '07652', 218, 37, 145990, 40.9473, 0.714665204801874, -74.0693, -1.29275315964744),
(2762, '07653', 218, 37, 145990, 40.9452, 0.714628552887582, -74.0715, -1.29279155689098),
(2763, '07656', 218, 37, 120970, 41.0325, 0.716152225324573, -74.041, -1.29225923146912),
(2764, '07657', 218, 37, 24320, 40.832, 0.712652840174325, -74.0019, -1.29157680773159),
(2765, '07660', 218, 37, 146164, 40.8575, 0.713097899133583, -74.0223, -1.291932854899),
(2766, '07661', 218, 37, 50858, 40.927, 0.714310902963719, -74.0392, -1.29222781554259),
(2767, '07662', 218, 37, 146199, 40.9051, 0.713928675857533, -74.0908, -1.29312840543661),
(2768, '07663', 218, 37, 146249, 40.9028, 0.713888533284737, -74.0976, -1.29324708782575),
(2769, '07666', 218, 37, 146438, 40.8921, 0.713701783054773, -74.01, -1.291718179401),
(2770, '07670', 218, 37, 146441, 40.9215, 0.71421490985486, -73.9638, -1.29091183728658),
(2771, '07675', 218, 37, 6753, 41.0023, 0.715625135890471, -74.0307, -1.29207946255617),
(2772, '07676', 218, 37, 0, 41.0095, 0.715750799596615, -74.022, -1.29192761891124),
(2773, '07677', 218, 37, 146668, 41.0236, 0.715996891021146, -74.0605, -1.29259957067326),
(2774, '07701', 218, 37, 5307, 40.3546, 0.704320638325304, -74.0768, -1.29288405934134),
(2775, '07702', 218, 37, 38203, 40.3259, 0.703819728829981, -74.0575, -1.2925472107957),
(2776, '07703', 218, 37, 0, 40.3165, 0.703655667880294, -74.0388, -1.29222083422558),
(2777, '07704', 218, 37, 54696, 40.3597, 0.704409650117155, -74.0406, -1.29225225015211),
(2778, '07709', 218, 37, 14968, 40.2358, 0.702247187173934, -74.0027, -1.29159077036561),
(2779, '07710', 218, 37, 144717, 40.2138, 0.701863214738496, -74.2617, -1.29611117312827),
(2780, '07711', 218, 37, 14968, 40.2366, 0.70226114980795, -74.0061, -1.29165011156018),
(2781, '07712', 218, 37, 112841, 40.238, 0.702285584417478, -74.0368, -1.29218592764054),
(2782, '07715', 218, 37, 44737, 40.1808, 0.701287256085337, -74.0259, -1.29199568675207),
(2783, '07716', 218, 37, 144772, 40.4055, 0.705209010914569, -74.0378, -1.29220338093306),
(2784, '07717', 218, 37, 0, 40.1921, 0.701484478290813, -74.0166, -1.29183337113163),
(2785, '07718', 218, 37, 144814, 40.4168, 0.705406233120044, -74.0895, -1.29310571615634),
(2786, '07719', 218, 37, 44737, 40.1737, 0.701163337708446, -74.0556, -1.29251404953991),
(2787, '07720', 218, 37, 144876, 40.2019, 0.701655520557508, -74.0127, -1.29176530329081),
(2788, '07721', 218, 37, 145006, 40.4371, 0.705760534958199, -74.2272, -1.29550903453633),
(2789, '07722', 218, 37, 145028, 40.3107, 0.703554438783678, -74.182, -1.29472014571443),
(2790, '07723', 218, 37, 145083, 40.2501, 0.70249676925697, -74.0013, -1.29156633575608),
(2791, '07724', 218, 37, 145135, 40.3007, 0.703379905858479, -74.0707, -1.29277759425696),
(2792, '07726', 218, 37, 145175, 40.301, 0.703385141846235, -74.333, -1.29735559288495),
(2793, '07727', 218, 37, 27149, 40.1997, 0.701617123313965, -74.1611, -1.29435537190077),
(2794, '07728', 218, 37, 145271, 40.2452, 0.702411248123622, -74.2768, -1.29637471784532),
(2795, '07730', 218, 37, 145399, 40.4229, 0.705512698204416, -74.1778, -1.29464684188585),
(2796, '07731', 218, 37, 9597, 40.1482, 0.700718278749187, -74.2097, -1.29520360191724),
(2797, '07732', 218, 37, 3119, 40.4025, 0.705156651037009, -73.9982, -1.29151223054927),
(2798, '07733', 218, 37, 145454, 40.3841, 0.704835510454642, -74.1706, -1.29452117817971),
(2799, '07734', 218, 37, 145518, 40.439, 0.705793696213987, -74.1273, -1.29376545061359),
(2800, '07735', 218, 37, 145529, 40.4383, 0.705781478909223, -74.1919, -1.29489293331038),
(2801, '07737', 218, 37, 145596, 40.414, 0.705357363900988, -74.0601, -1.29259258935625),
(2802, '07738', 218, 37, 145611, 40.3379, 0.704029168340221, -74.1237, -1.29370261876052),
(2803, '07739', 218, 37, 145623, 40.3357, 0.703990771096677, -74.0418, -1.29227319410314),
(2804, '07740', 218, 37, 113, 40.2967, 0.703310092688399, -73.9925, -1.2914127467819),
(2805, '07746', 218, 37, 66631, 40.3171, 0.703666139855806, -74.2635, -1.29614258905481),
(2806, '07747', 218, 37, 136763, 40.4052, 0.705203774926813, -74.2257, -1.29548285459756),
(2807, '07748', 218, 37, 14224, 40.396, 0.705043204635629, -74.111, -1.29348096194552),
(2808, '07750', 218, 37, 145782, 40.332, 0.703926193914353, -73.9966, -1.29148430528124),
(2809, '07751', 218, 37, 23183, 40.3537, 0.704304930362036, -74.2717, -1.29628570605347),
(2810, '07752', 218, 37, 145858, 40.3893, 0.704926267575746, -74.086, -1.29304462963252),
(2811, '07753', 218, 37, 89346, 40.2087, 0.701774202946644, -74.0587, -1.29256815474672),
(2812, '07754', 218, 37, 89346, 40.2004, 0.701629340618729, -74.0335, -1.29212833177522),
(2813, '07755', 218, 37, 4709, 40.266, 0.702774276608037, -74.0232, -1.29194856286227),
(2814, '07756', 218, 37, 125721, 40.2124, 0.701838780128968, -74.0096, -1.291711198084),
(2815, '07757', 218, 37, 145956, 40.3158, 0.70364345057553, -74.0172, -1.29184384310715),
(2816, '07758', 218, 37, 146094, 40.4296, 0.705629635264299, -74.1078, -1.29342511140945),
(2817, '07760', 218, 37, 146241, 40.3704, 0.704596400347119, -74.0032, -1.29159949701187),
(2818, '07762', 218, 37, 14657, 40.1548, 0.700833470479819, -74.0372, -1.29219290895755),
(2819, '07763', 218, 37, 146443, 40.278, 0.702983716118276, -74.3341, -1.29737479150672),
(2820, '07764', 218, 37, 146605, 40.2897, 0.703187919640759, -74.0189, -1.29187351370443),
(2821, '07765', 218, 37, 146647, 40.3513, 0.704263042459988, -74.2497, -1.29590173361803),
(2822, '07777', 218, 37, 145454, 40.3458, 0.704167049351128, -74.1905, -1.29486849870085),
(2823, '07799', 218, 37, 145135, 40.363, 0.704467245982471, -74.0778, -1.29290151263386),
(2824, '07801', 218, 37, 8583, 40.9439, 0.714605863607306, -74.5225, -1.30066299181747),
(2825, '07802', 218, 37, 8583, 40.8554, 0.713061247219291, -74.5723, -1.30153216578497),
(2826, '07803', 218, 37, 145777, 40.8788, 0.713469654264258, -74.5961, -1.30194755414694),
(2827, '07806', 218, 37, 0, 40.9261, 0.714295195000451, -74.5768, -1.30161070560131),
(2828, '07820', 218, 37, 144726, 40.9124, 0.714056084892928, -74.8291, -1.30601417130409),
(2829, '07821', 218, 37, 14988, 40.9671, 0.715010779993769, -74.7665, -1.30492159519234),
(2830, '07822', 218, 37, 7193, 41.1423, 0.718068596843263, -74.6967, -1.30370335537445),
(2831, '07823', 218, 37, 13361, 40.8288, 0.712596989638261, -75.0653, -1.3101366389973),
(2832, '07825', 218, 37, 39401, 40.9841, 0.715307485966608, -74.9473, -1.30807715047995),
(2833, '07826', 218, 37, 1085, 41.1913, 0.71892380817674, -74.7495, -1.3046248892195),
(2834, '07827', 218, 37, 4275, 41.3028, 0.720869850292714, -74.7607, -1.30482036609572),
(2835, '07828', 218, 37, 144915, 40.8864, 0.71360229928741, -74.7502, -1.30463710652427),
(2836, '07829', 218, 37, 139742, 40.8317, 0.712647604186569, -75.0069, -1.30911736671413),
(2837, '07830', 218, 37, 144934, 40.7146, 0.710603823632483, -74.8179, -1.30581869442787),
(2838, '07831', 218, 37, 144967, 40.7351, 0.710961616129142, -74.9418, -1.30798115737109),
(2839, '07832', 218, 37, 1716, 40.9855, 0.715331920576136, -75.0698, -1.31021517881364),
(2840, '07833', 218, 37, 8461, 40.893, 0.713717491018041, -75.065, -1.31013140300954),
(2841, '07834', 218, 37, 145095, 40.8857, 0.713590081982646, -74.4843, -1.29999627604321),
(2842, '07836', 218, 37, 2477, 40.8509, 0.712982707402952, -74.7083, -1.30390581356768),
(2843, '07837', 218, 37, 0, 40.9722, 0.715099791785621, -74.6383, -1.30268408309128),
(2844, '07838', 218, 37, 47607, 40.8856, 0.713588336653394, -74.9307, -1.30778742582412),
(2845, '07839', 218, 37, 145330, 40.9739, 0.715129462382905, -74.8217, -1.30588501693944),
(2846, '07840', 218, 37, 145347, 40.8541, 0.713038557939015, -74.8427, -1.30625153608236),
(2847, '07842', 218, 37, 16419, 40.9434, 0.714597136961046, -74.4957, -1.30019524357794),
(2848, '07843', 218, 37, 145459, 40.9381, 0.714504634510691, -74.6703, -1.30324258845192),
(2849, '07844', 218, 37, 665, 40.9114, 0.714038631600408, -74.9681, -1.30844017896436),
(2850, '07845', 218, 37, 145491, 40.83, 0.712617933589285, -74.629, -1.30252176747085),
(2851, '07846', 218, 37, 145512, 40.9671, 0.715010779993769, -74.8741, -1.30679956946749),
(2852, '07847', 218, 37, 145527, 40.8893, 0.713652913835717, -74.6236, -1.30242751969124),
(2853, '07848', 218, 37, 3594, 41.096, 0.71726050939959, -74.6937, -1.30365099549689),
(2854, '07849', 218, 37, 145554, 40.9549, 0.714797849825026, -74.6131, -1.30224426011978),
(2855, '07850', 218, 37, 145572, 40.902, 0.713874570650721, -74.6599, -1.30306107420971),
(2856, '07851', 218, 37, 16862, 41.2018, 0.7191070677482, -74.8346, -1.30611016441295),
(2857, '07852', 218, 37, 22609, 40.8851, 0.713579610007134, -74.6577, -1.30302267696617),
(2858, '07853', 218, 37, 145649, 40.7943, 0.711994851046323, -74.7858, -1.30525844373798),
(2859, '07855', 218, 37, 110425, 41.0544, 0.71653445243076, -74.8626, -1.30659885660351),
(2860, '07856', 218, 37, 145822, 40.9255, 0.714284723024939, -74.6351, -1.30262823255522),
(2861, '07857', 218, 37, 145866, 40.8976, 0.713797776163633, -74.704, -1.30383076440984),
(2862, '07860', 218, 37, 4570, 41.0604, 0.71663917218588, -74.7991, -1.30549057252849),
(2863, '07863', 218, 37, 4828, 40.8127, 0.71231599162869, -74.9675, -1.30842970698885),
(2864, '07865', 218, 37, 146096, 40.7862, 0.711853479376911, -74.9037, -1.30731618692608),
(2865, '07866', 218, 37, 105829, 40.9439, 0.714605863607306, -74.4801, -1.29992297221463),
(2866, '07869', 218, 37, 5293, 40.8461, 0.712898931598856, -74.5761, -1.30159848829654);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(2867, '07870', 218, 37, 146273, 40.8225, 0.712487033895385, -74.7602, -1.30481163944946),
(2868, '07871', 218, 37, 25003, 41.0416, 0.716311050286505, -74.6245, -1.30244322765451),
(2869, '07874', 218, 37, 38360, 40.9189, 0.714169531294308, -74.7008, -1.30377491387378),
(2870, '07875', 218, 37, 12131, 41.0353, 0.716201094543629, -74.8782, -1.30687112796682),
(2871, '07876', 218, 37, 146416, 40.8557, 0.713066483207047, -74.6523, -1.30292842918656),
(2872, '07877', 218, 37, 146428, 41.0872, 0.717106920425414, -74.8271, -1.30597926471905),
(2873, '07878', 218, 37, 4409, 40.8723, 0.713356207862878, -74.477, -1.29986886700782),
(2874, '07879', 218, 37, 52168, 40.9557, 0.714811812459042, -74.8091, -1.30566510545369),
(2875, '07880', 218, 37, 6557, 40.8727, 0.713363189179886, -74.8897, -1.3070718408308),
(2876, '07881', 218, 37, 146543, 41.2033, 0.71913324768698, -74.8157, -1.30578029718432),
(2877, '07882', 218, 37, 12671, 40.7588, 0.711375259161865, -75.005, -1.30908420545835),
(2878, '07885', 218, 37, 12778, 40.9151, 0.714103208782732, -74.6003, -1.30202085797553),
(2879, '07890', 218, 37, 1085, 41.1466, 0.718143646001099, -74.7501, -1.30463536119501),
(2880, '07901', 218, 37, 6151, 40.715, 0.710610804949491, -74.3633, -1.2978844276483),
(2881, '07902', 218, 37, 6151, 40.7152, 0.710614295607995, -74.3651, -1.29791584357484),
(2882, '07920', 218, 37, 144793, 40.6856, 0.710097678149405, -74.5683, -1.30146235261489),
(2883, '07921', 218, 37, 144809, 40.6548, 0.709560116739791, -74.6539, -1.30295635445459),
(2884, '07922', 218, 37, 144831, 40.6769, 0.709945834504481, -74.4319, -1.29908172351517),
(2885, '07924', 218, 37, 144835, 40.722, 0.710732977997131, -74.5863, -1.30177651188025),
(2886, '07926', 218, 37, 1167, 40.7989, 0.712075136191915, -74.5722, -1.30153042045572),
(2887, '07927', 218, 37, 63563, 40.8231, 0.712497505870897, -74.4534, -1.29945696930435),
(2888, '07928', 218, 37, 13522, 40.7318, 0.710904020263826, -74.4037, -1.29858954066611),
(2889, '07930', 218, 37, 8056, 40.7914, 0.711944236498015, -74.6781, -1.30337872413358),
(2890, '07931', 218, 37, 145209, 40.7032, 0.710404856097756, -74.6401, -1.30271549901782),
(2891, '07932', 218, 37, 145238, 40.7767, 0.711687673097972, -74.3916, -1.29837835582661),
(2892, '07933', 218, 37, 16211, 40.71, 0.710523538486892, -74.4662, -1.2996803714486),
(2893, '07934', 218, 37, 2726, 40.7221, 0.710734723326383, -74.6708, -1.30325131509818),
(2894, '07935', 218, 37, 47659, 40.7395, 0.71103841061623, -74.4462, -1.2993313055982),
(2895, '07936', 218, 37, 145119, 40.8176, 0.712401512762037, -74.3659, -1.29792980620885),
(2896, '07938', 218, 37, 127943, 40.6606, 0.709661345836406, -74.5862, -1.30177476655099),
(2897, '07939', 218, 37, 764, 40.6781, 0.709966778455505, -74.5669, -1.30143791800536),
(2898, '07940', 218, 37, 3938, 40.7574, 0.711350824552337, -74.4188, -1.29885308538316),
(2899, '07945', 218, 37, 145730, 40.7821, 0.71178192087758, -74.5979, -1.30197897007348),
(2900, '07946', 218, 37, 49512, 40.6835, 0.710061026235113, -74.5134, -1.30050416685554),
(2901, '07950', 218, 37, 145814, 40.8425, 0.712836099745784, -74.4775, -1.29987759365408),
(2902, '07960', 218, 37, 30565, 40.7951, 0.712008813680339, -74.4901, -1.30009750513983),
(2903, '07961', 218, 37, 30565, 40.7683, 0.711541065440804, -74.4492, -1.29938366547576),
(2904, '07962', 218, 37, 30565, 40.808, 0.712233961153846, -74.4993, -1.30025807543101),
(2905, '07963', 218, 37, 30565, 40.7966, 0.712034993619119, -74.4781, -1.29988806562959),
(2906, '07970', 218, 37, 56401, 40.8199, 0.712441655334833, -74.573, -1.30154438308973),
(2907, '07974', 218, 37, 4553, 40.6988, 0.710328061610668, -74.4042, -1.29859826731237),
(2908, '07976', 218, 37, 145889, 40.7331, 0.710926709544102, -74.4814, -1.2999456614949),
(2909, '07977', 218, 37, 146013, 40.711, 0.710540991779411, -74.6585, -1.30303663960019),
(2910, '07978', 218, 37, 146072, 40.643, 0.709354167888055, -74.6364, -1.3026509218355),
(2911, '07979', 218, 37, 30886, 40.7134, 0.710582879681459, -74.7119, -1.30396864542075),
(2912, '07980', 218, 37, 146402, 40.6804, 0.710006921028301, -74.4913, -1.30011844909085),
(2913, '07981', 218, 37, 146635, 40.8217, 0.712473071261369, -74.4219, -1.29890719058997),
(2914, '07983', 218, 37, 146635, 40.8229, 0.712494015212393, -74.4186, -1.29884959472465),
(2915, '07999', 218, 37, 146635, 40.8236, 0.712506232517157, -74.4368, -1.29916724464852),
(2916, '08001', 218, 37, 44328, 39.5628, 0.690501121308013, -75.3469, -1.31505148617092),
(2917, '08002', 218, 37, 8052, 39.9317, 0.69693964091862, -75.0209, -1.30936171280941),
(2918, '08003', 218, 37, 8052, 39.8815, 0.696063485634119, -74.9723, -1.30851348279294),
(2919, '08004', 218, 37, 18950, 39.7672, 0.694068574299089, -74.8474, -1.3063335665572),
(2920, '08005', 218, 37, 70489, 39.7579, 0.693906258678654, -74.2502, -1.29591046026429),
(2921, '08006', 218, 37, 70494, 39.7519, 0.693801538923534, -74.1135, -1.29352459517682),
(2922, '08007', 218, 37, 19071, 39.8648, 0.695772015649036, -75.0565, -1.30998305002312),
(2923, '08008', 218, 37, 15143, 39.6219, 0.691532610895941, -74.197, -1.29498194510223),
(2924, '08009', 218, 37, 376, 39.7583, 0.693913239995661, -74.9352, -1.30786596564045),
(2925, '08010', 218, 37, 7444, 40.0586, 0.6991544637394, -74.9134, -1.30748548386352),
(2926, '08011', 218, 37, 799, 39.9745, 0.697686641838473, -74.7156, -1.30403322260308),
(2927, '08012', 218, 37, 894, 39.7863, 0.69440193218622, -75.046, -1.30979979045166),
(2928, '08014', 218, 37, 1130, 39.8063, 0.694750998036619, -75.3389, -1.31491185983076),
(2929, '08015', 218, 37, 70582, 39.963, 0.697485928974494, -74.5663, -1.30142744602985),
(2930, '08016', 218, 37, 1239, 40.0699, 0.699351685944876, -74.842, -1.3062393187776),
(2931, '08018', 218, 37, 70623, 39.7126, 0.6931156245275, -74.8986, -1.30722717513423),
(2932, '08019', 218, 37, 19964, 39.7711, 0.694136642139917, -74.4496, -1.29939064679277),
(2933, '08020', 218, 37, 20074, 39.803, 0.694693402171303, -75.2165, -1.31277557682631),
(2934, '08021', 218, 37, 70669, 39.8081, 0.694782413963155, -75.0045, -1.30907547881209),
(2935, '08022', 218, 37, 1718, 40.0772, 0.699479094980271, -74.6929, -1.30363703286287),
(2936, '08023', 218, 37, 54385, 39.6833, 0.692604243056666, -75.492, -1.31758395891556),
(2937, '08025', 218, 37, 70801, 39.699, 0.692878259749229, -75.186, -1.31224325140446),
(2938, '08026', 218, 37, 70860, 39.8354, 0.695258888848949, -74.9685, -1.30844716028137),
(2939, '08027', 218, 37, 41075, 39.8262, 0.695098318557766, -75.2751, -1.31379833976798),
(2940, '08028', 218, 37, 70866, 39.6956, 0.692818918554661, -75.1242, -1.31116463792672),
(2941, '08029', 218, 37, 29901, 39.8396, 0.695332192677533, -75.0676, -1.3101767815701),
(2942, '08030', 218, 37, 70873, 39.8865, 0.696150752096718, -75.1185, -1.31106515415936),
(2943, '08031', 218, 37, 70529, 39.8681, 0.695829611514351, -75.0911, -1.31058693394431),
(2944, '08032', 218, 37, 70904, 39.7367, 0.693536248877231, -75.0757, -1.31031815323951),
(2945, '08033', 218, 37, 70914, 39.8956, 0.69630957705865, -75.0411, -1.30971426931832),
(2946, '08034', 218, 37, 8052, 39.9071, 0.696510289922629, -75.0042, -1.30907024282433),
(2947, '08035', 218, 37, 70908, 39.8791, 0.696021597732071, -75.0652, -1.31013489366805),
(2948, '08036', 218, 37, 70918, 39.9878, 0.697918770628989, -74.8285, -1.30600369932858),
(2949, '08037', 218, 37, 70923, 39.6301, 0.691675727894605, -74.7705, -1.30499140836242),
(2950, '08038', 218, 37, 70929, 39.5041, 0.689476613037092, -75.4624, -1.31706734145697),
(2951, '08039', 218, 37, 21759, 39.6853, 0.692639149641706, -75.2666, -1.31364998678156),
(2952, '08041', 218, 37, 145510, 40.0229, 0.698531381196439, -74.6882, -1.30355500238803),
(2953, '08042', 218, 37, 145513, 40.0128, 0.698355102941987, -74.6693, -1.3032251351594),
(2954, '08043', 218, 37, 146534, 39.8454, 0.695433421774149, -74.9581, -1.30826564603916),
(2955, '08045', 218, 37, 71019, 39.8678, 0.695824375526595, -75.0308, -1.30953450040536),
(2956, '08046', 218, 37, 146652, 40.0274, 0.698609921012778, -74.8829, -1.30695315844166),
(2957, '08048', 218, 37, 16965, 39.9578, 0.69739517185339, -74.8031, -1.30556038569857),
(2958, '08049', 218, 37, 3947, 39.8538, 0.695580029431316, -75.0377, -1.30965492812375),
(2959, '08050', 218, 37, 71066, 39.7021, 0.692932364956041, -74.2562, -1.29601518001941),
(2960, '08051', 218, 37, 3977, 39.7889, 0.694447310746772, -75.181, -1.31215598494186),
(2961, '08052', 218, 37, 71077, 39.9538, 0.69732535868331, -74.995, -1.30890967253315),
(2962, '08053', 218, 37, 49253, 39.864, 0.695758053015019, -74.8909, -1.30709278478182),
(2963, '08054', 218, 37, 71142, 39.9479, 0.697222384257443, -74.9126, -1.3074715212295),
(2964, '08055', 218, 37, 49404, 39.865, 0.695775506307539, -74.8191, -1.30583963837889),
(2965, '08056', 218, 37, 71117, 39.7859, 0.694394950869212, -75.2496, -1.31335328080872),
(2966, '08057', 218, 37, 30556, 39.9694, 0.697597630046622, -74.9532, -1.30818012490581),
(2967, '08059', 218, 37, 49632, 39.8819, 0.696070466951127, -75.0914, -1.31059216993207),
(2968, '08060', 218, 37, 10633, 40.0026, 0.698177079358284, -74.7871, -1.30528113301825),
(2969, '08061', 218, 37, 17210, 39.8027, 0.694688166183547, -75.2008, -1.31250156013375),
(2970, '08062', 218, 37, 71149, 39.7217, 0.693274449489432, -75.2246, -1.31291694849573),
(2971, '08063', 218, 37, 71155, 39.8637, 0.695752817027264, -75.177, -1.31208617177178),
(2972, '08064', 218, 37, 30639, 39.9577, 0.697393426524138, -74.6292, -1.30252525812935),
(2973, '08065', 218, 37, 4846, 40.0029, 0.69818231534604, -75.0123, -1.30921161449374),
(2974, '08066', 218, 37, 71242, 39.8232, 0.695045958680206, -75.2089, -1.31264293180316),
(2975, '08067', 218, 37, 71249, 39.7371, 0.693543230194239, -75.4049, -1.31606377713707),
(2976, '08068', 218, 37, 71250, 39.9619, 0.697466730352722, -74.6812, -1.30343282934039),
(2977, '08069', 218, 37, 71258, 39.7185, 0.693218598953368, -75.463, -1.31707781343248),
(2978, '08070', 218, 37, 71262, 39.6478, 0.691984651172208, -75.518, -1.31803774452108),
(2979, '08071', 218, 37, 339, 39.7284, 0.693391386549315, -75.1279, -1.31122921510905),
(2980, '08072', 218, 37, 5264, 39.5568, 0.690396401552893, -75.4035, -1.31603934252754),
(2981, '08073', 218, 37, 146139, 40.0098, 0.698302743064427, -74.868, -1.30669310438311),
(2982, '08074', 218, 37, 24311, 39.7226, 0.6932901574527, -75.1658, -1.31189069489555),
(2983, '08075', 218, 37, 5423, 40.0286, 0.698630864963802, -74.953, -1.30817663424731),
(2984, '08076', 218, 37, 5429, 40.0123, 0.698346376295727, -75.0147, -1.30925350239579),
(2985, '08077', 218, 37, 5429, 39.9967, 0.698074104932416, -74.9913, -1.30884509535082),
(2986, '08078', 218, 37, 71350, 39.8502, 0.695517197578244, -75.0732, -1.31027452000821),
(2987, '08079', 218, 37, 126, 39.5504, 0.690284700480765, -75.452, -1.31688582721476),
(2988, '08080', 218, 37, 5743, 39.7566, 0.693883569398378, -75.1168, -1.31103548356208),
(2989, '08081', 218, 37, 71392, 39.7426, 0.693639223303098, -74.986, -1.30875259290047),
(2990, '08083', 218, 37, 71406, 39.8446, 0.695419459140133, -75.0306, -1.30953100974686),
(2991, '08084', 218, 37, 14683, 39.8299, 0.695162895740089, -75.0152, -1.30926222904205),
(2992, '08085', 218, 37, 71461, 39.753, 0.693820737545306, -75.3204, -1.31458897391914),
(2993, '08086', 218, 37, 71475, 39.8371, 0.695288559446233, -75.1843, -1.31221358080717),
(2994, '08087', 218, 37, 71483, 39.5898, 0.690972360206051, -74.3539, -1.29772036669861),
(2995, '08088', 218, 37, 71509, 39.8629, 0.695738854393248, -74.6732, -1.30329320300023),
(2996, '08089', 218, 37, 71521, 39.7158, 0.693171475063564, -74.8204, -1.30586232765917),
(2997, '08090', 218, 37, 6693, 39.7948, 0.69455028517264, -75.1501, -1.31161667820299),
(2998, '08091', 218, 37, 71537, 39.8063, 0.694750998036619, -74.9256, -1.30769841403226),
(2999, '08092', 218, 37, 71553, 39.656, 0.692127768170871, -74.291, -1.29662255459911),
(3000, '08093', 218, 37, 12776, 39.8633, 0.695745835710256, -75.1317, -1.31129553762062),
(3001, '08094', 218, 37, 6834, 39.6731, 0.692426219472962, -74.9875, -1.30877877283925),
(3002, '08095', 218, 37, 567, 39.6582, 0.692166165414415, -74.8656, -1.30665121648107),
(3003, '08096', 218, 37, 362, 39.8253, 0.695082610594498, -75.1321, -1.31130251893763),
(3004, '08097', 218, 37, 71597, 39.8145, 0.694894115035282, -75.1492, -1.31160097023972),
(3005, '08098', 218, 37, 71610, 39.6535, 0.692084134939571, -75.3288, -1.3147355815763),
(3006, '08099', 218, 37, 70529, 39.8672, 0.695813903551083, -75.0949, -1.31065325645589),
(3007, '08101', 218, 37, 1304, 39.9436, 0.697147335099607, -75.1238, -1.31115765660972),
(3008, '08102', 218, 37, 1304, 39.9476, 0.697217148269687, -75.1154, -1.31101104895255),
(3009, '08103', 218, 37, 1304, 39.936, 0.697014690076455, -75.1118, -1.31094821709948),
(3010, '08104', 218, 37, 1304, 39.9172, 0.696686568177081, -75.1084, -1.31088887590491),
(3011, '08105', 218, 37, 1304, 39.9477, 0.697218893598939, -75.0873, -1.31052061143274),
(3012, '08106', 218, 37, 15055, 39.8929, 0.696262453168846, -75.0738, -1.31028499198372),
(3013, '08107', 218, 37, 71197, 39.9066, 0.696501563276369, -75.0839, -1.31046127023817),
(3014, '08108', 218, 37, 70681, 39.9148, 0.696644680275033, -75.066, -1.31014885630206),
(3015, '08109', 218, 37, 112470, 39.9499, 0.697257290842483, -75.0502, -1.30987309428025),
(3016, '08110', 218, 37, 71260, 39.9653, 0.69752607154729, -75.0557, -1.30996908738911),
(3017, '08201', 218, 37, 70450, 39.4434, 0.688417198181131, -74.5122, -1.30048322290452),
(3018, '08202', 218, 37, 13310, 39.092, 0.682284111189623, -74.7298, -1.30428105935686),
(3019, '08203', 218, 37, 70569, 39.4005, 0.687668451932026, -74.3827, -1.29822302152319),
(3020, '08204', 218, 37, 70614, 38.9691, 0.680139101538922, -74.9264, -1.30771237666628),
(3021, '08205', 218, 37, 70450, 39.4202, 0.688012281794669, -74.4996, -1.30026331141877),
(3022, '08210', 218, 37, 70609, 39.0894, 0.682238732629071, -74.8325, -1.30607351249866),
(3023, '08212', 218, 37, 70610, 38.9368, 0.679575360190528, -74.9653, -1.30839130974531),
(3024, '08213', 218, 37, 70683, 39.5006, 0.689415526513272, -74.607, -1.30213779503541),
(3025, '08214', 218, 37, 70735, 39.1921, 0.68403118577087, -74.8209, -1.30587105430543),
(3026, '08215', 218, 37, 70775, 39.5265, 0.689867566789539, -74.6217, -1.30239435843545),
(3027, '08217', 218, 37, 15933, 39.5772, 0.6907524487203, -74.7191, -1.3040943091269),
(3028, '08218', 218, 37, 419, 39.1416, 0.683149794498612, -74.8619, -1.30658663929874),
(3029, '08219', 218, 37, 27325, 39.0412, 0.68139748392961, -74.8977, -1.30721146717096),
(3030, '08220', 218, 37, 71026, 39.4965, 0.68934396801394, -74.4331, -1.29910266746619),
(3031, '08221', 218, 37, 3793, 39.346, 0.686717247489689, -74.5822, -1.30170495338091),
(3032, '08223', 218, 37, 71088, 39.2586, 0.685191829723446, -74.6567, -1.30300522367365),
(3033, '08224', 218, 37, 71162, 39.6043, 0.69122543294759, -74.4605, -1.29958088768124),
(3034, '08225', 218, 37, 37457, 39.3701, 0.68713787183942, -74.5552, -1.30123371448288),
(3035, '08226', 218, 37, 17371, 39.2667, 0.685333201392857, -74.5929, -1.30189170361088),
(3036, '08230', 218, 37, 365, 39.1972, 0.684120197562721, -74.7226, -1.30415539565071),
(3037, '08231', 218, 37, 71212, 39.4661, 0.688813387921334, -74.4589, -1.29955296241321),
(3038, '08232', 218, 37, 14431, 39.4012, 0.68768066923679, -74.557, -1.30126513040941),
(3039, '08234', 218, 37, 0, 39.4157, 0.687933741978329, -74.5753, -1.30158452566253),
(3040, '08240', 218, 37, 24061, 39.4826, 0.689101367247913, -74.5662, -1.3014257007006),
(3041, '08241', 218, 37, 50539, 39.5224, 0.689796008290207, -74.5118, -1.30047624158751),
(3042, '08242', 218, 37, 71335, 39.0204, 0.681034455445195, -74.8706, -1.30673848294367),
(3043, '08243', 218, 37, 71363, 39.1444, 0.683198663717668, -74.7016, -1.3037888765078),
(3044, '08244', 218, 37, 71408, 39.3218, 0.686294877810706, -74.6003, -1.30202085797553),
(3045, '08245', 218, 37, 71411, 39.173, 0.683697827883739, -74.8078, -1.30564241617341),
(3046, '08246', 218, 37, 71417, 39.179, 0.683802547638858, -74.7589, -1.30478895016919),
(3047, '08247', 218, 37, 71441, 39.0529, 0.681601687452094, -74.7622, -1.3048465460345),
(3048, '08248', 218, 37, 71450, 39.1955, 0.684090526965437, -74.659, -1.30304536624645),
(3049, '08250', 218, 37, 57948, 39.2906, 0.685750335084084, -74.7589, -1.30478895016919),
(3050, '08251', 218, 37, 401, 39.0211, 0.681046672749959, -74.9367, -1.30789214557923),
(3051, '08252', 218, 37, 6799, 39.0383, 0.681346869381302, -74.8609, -1.30656918600622),
(3052, '08260', 218, 37, 6816, 38.9881, 0.680470714096801, -74.8211, -1.30587454496393),
(3053, '08270', 218, 37, 634, 39.2529, 0.685092345956082, -74.7974, -1.30546090193121),
(3054, '08302', 218, 37, 1132, 39.4378, 0.68831945974302, -75.2297, -1.31300596028758),
(3055, '08310', 218, 37, 70589, 39.5248, 0.689837896192255, -74.9113, -1.30744883194923),
(3056, '08311', 218, 37, 1435, 39.3318, 0.686469410735906, -75.2011, -1.31250679612151),
(3057, '08312', 218, 37, 608, 39.6693, 0.692359896961387, -75.0856, -1.31049094083545),
(3058, '08313', 218, 37, 0, 39.5335, 0.689989739837178, -75.2317, -1.31304086687262),
(3059, '08314', 218, 37, 46278, 39.2038, 0.684235389293353, -74.9715, -1.30849952015893),
(3060, '08315', 218, 37, 70745, 39.2712, 0.685411741209197, -75.1045, -1.31082080806408),
(3061, '08316', 218, 37, 20633, 39.2728, 0.685439666477229, -74.9772, -1.30859900392629),
(3062, '08317', 218, 37, 8569, 39.4082, 0.687802842284429, -74.8184, -1.30582742107413),
(3063, '08318', 218, 37, 32348, 39.5622, 0.690490649332501, -75.169, -1.31194654543162),
(3064, '08319', 218, 37, 70795, 39.3649, 0.687047114718316, -74.7968, -1.30545042995569),
(3065, '08320', 218, 37, 70804, 39.3791, 0.687294951472099, -75.223, -1.31288902322769),
(3066, '08321', 218, 37, 70831, 39.238, 0.684832291897535, -75.1719, -1.31199715997993),
(3067, '08322', 218, 37, 21289, 39.6305, 0.691682709211613, -75.0464, -1.30980677176867),
(3068, '08323', 218, 37, 32630, 39.39, 0.687485192360566, -75.339, -1.31491360516001),
(3069, '08324', 218, 37, 70944, 39.2465, 0.684980644883954, -74.9938, -1.30888872858212),
(3070, '08326', 218, 37, 71011, 39.5247, 0.689836150863003, -74.9392, -1.30793577881053),
(3071, '08327', 218, 37, 3721, 39.6177, 0.691459307067357, -75.0025, -1.30904057222705),
(3072, '08328', 218, 37, 37031, 39.5748, 0.690710560818252, -75.0585, -1.31001795660816),
(3073, '08329', 218, 37, 71096, 39.2861, 0.685671795267744, -74.9936, -1.30888523792362),
(3074, '08330', 218, 37, 71099, 39.4331, 0.688237429268176, -74.7002, -1.30376444189827),
(3075, '08332', 218, 37, 4227, 39.3817, 0.687340330032651, -75.0447, -1.30977710117139),
(3076, '08340', 218, 37, 71124, 39.4442, 0.688431160815147, -74.8646, -1.30663376318855),
(3077, '08341', 218, 37, 71125, 39.5198, 0.689750629729655, -74.9486, -1.30809983976022),
(3078, '08342', 218, 37, 71126, 39.4903, 0.689235757600317, -74.8321, -1.30606653118165),
(3079, '08343', 218, 37, 4273, 39.6403, 0.691853751478308, -75.1632, -1.311845316335),
(3080, '08344', 218, 37, 71169, 39.5601, 0.690453997418209, -74.9805, -1.30865659979161),
(3081, '08345', 218, 37, 10799, 39.2905, 0.685748589754832, -75.1491, -1.31159922491047),
(3082, '08346', 218, 37, 4572, 39.563, 0.690504611966517, -74.8563, -1.30648890086063),
(3083, '08347', 218, 37, 42306, 39.496, 0.68933524136768, -75.0883, -1.31053806472526),
(3084, '08348', 218, 37, 71303, 39.2355, 0.684788658666235, -75.0072, -1.30912260270189),
(3085, '08349', 218, 37, 71304, 39.2477, 0.685001588834979, -75.0367, -1.30963747483123),
(3086, '08350', 218, 37, 5374, 39.4877, 0.689190379039765, -74.8822, -1.3069409411369),
(3087, '08352', 218, 37, 71344, 39.475, 0.688968722224762, -75.1308, -1.31127982965736),
(3088, '08353', 218, 37, 5817, 39.4573, 0.688659798947159, -75.2953, -1.31415089627689),
(3089, '08360', 218, 37, 6571, 39.4828, 0.689104857906417, -75.0105, -1.30918019856721),
(3090, '08361', 218, 37, 6571, 39.4859, 0.689158963113229, -75.026, -1.30945072460127),
(3091, '08362', 218, 37, 6571, 39.4644, 0.68878371732405, -74.9975, -1.30895330576445),
(3092, '08401', 218, 37, 70469, 39.3638, 0.687027916096544, -74.44, -1.29922309518458),
(3093, '08402', 218, 37, 71081, 39.327, 0.68638563493181, -74.5112, -1.300465769612),
(3094, '08403', 218, 37, 71045, 39.3142, 0.686162232787555, -74.5269, -1.30073978630456),
(3095, '08404', 218, 37, 70469, 39.3632, 0.687017444121032, -74.4273, -1.29900143836958),
(3096, '08405', 218, 37, 70469, 39.3645, 0.687040133401308, -74.4228, -1.29892289855324),
(3097, '08406', 218, 37, 71500, 39.3418, 0.686643943661105, -74.4812, -1.2999421708364),
(3098, '08501', 218, 37, 14969, 40.1694, 0.70108828855061, -74.5809, -1.30168226410064),
(3099, '08502', 218, 37, 144811, 40.4676, 0.706292860380057, -74.6334, -1.30259856195794),
(3100, '08504', 218, 37, 144849, 40.4041, 0.705184576305041, -74.7032, -1.30381680177583),
(3101, '08505', 218, 37, 144869, 40.1371, 0.700524547202216, -74.712, -1.30397039075),
(3102, '08510', 218, 37, 26799, 40.1897, 0.701442590388765, -74.4172, -1.29882516011512),
(3103, '08511', 218, 37, 101060, 40.0469, 0.698950260216917, -74.5561, -1.30124942244614),
(3104, '08512', 218, 37, 113036, 40.3146, 0.703622506624506, -74.4869, -1.30004165460376),
(3105, '08514', 218, 37, 54249, 40.1646, 0.701004512746515, -74.4526, -1.29944300667033),
(3106, '08515', 218, 37, 145069, 40.1525, 0.700793327907023, -74.6539, -1.30295635445459),
(3107, '08518', 218, 37, 2502, 40.1165, 0.700165009376305, -74.8052, -1.30559703761286),
(3108, '08520', 218, 37, 145426, 40.2649, 0.702755077986265, -74.5336, -1.30085672336445),
(3109, '08525', 218, 37, 3228, 40.3858, 0.704865181051926, -74.7665, -1.30492159519234),
(3110, '08526', 218, 37, 145485, 40.1645, 0.701002767417262, -74.4969, -1.30021618752896),
(3111, '08527', 218, 37, 3384, 40.1215, 0.700252275838905, -74.2983, -1.2967499636345),
(3112, '08528', 218, 37, 3542, 40.3772, 0.704715082736254, -74.6145, -1.30226869472931),
(3113, '08530', 218, 37, 131682, 40.3686, 0.704564984420583, -74.9314, -1.30779964312888),
(3114, '08533', 218, 37, 145878, 40.069, 0.699335977981608, -74.5201, -1.30062110391543),
(3115, '08534', 218, 37, 4945, 40.3324, 0.703933175231361, -74.7774, -1.30511183608081),
(3116, '08535', 218, 37, 146023, 40.2216, 0.701999350420151, -74.4389, -1.29920389656281),
(3117, '08536', 218, 37, 146053, 40.3347, 0.703973317804157, -74.5793, -1.30165433883261),
(3118, '08540', 218, 37, 5231, 40.3496, 0.704233371862704, -74.6718, -1.3032687683907),
(3119, '08541', 218, 37, 5231, 40.3486, 0.704215918570184, -74.6593, -1.3030506022342),
(3120, '08542', 218, 37, 5231, 40.352, 0.704275259764752, -74.6598, -1.30305932888046),
(3121, '08543', 218, 37, 5231, 40.3133, 0.70359981734423, -74.6542, -1.30296159044235),
(3122, '08544', 218, 37, 5231, 40.3466, 0.704181011985144, -74.6565, -1.30300173301515),
(3123, '08550', 218, 37, 146114, 40.2967, 0.703310092688399, -74.6137, -1.30225473209529),
(3124, '08551', 218, 37, 146174, 40.4396, 0.705804168189499, -74.8373, -1.30615728830275),
(3125, '08553', 218, 37, 5486, 40.412, 0.705322457315948, -74.6454, -1.30280800146818),
(3126, '08554', 218, 37, 146216, 40.1136, 0.700114394827997, -74.7808, -1.30517117727538),
(3127, '08555', 218, 37, 5534, 40.2171, 0.701920810603812, -74.4748, -1.29983046976427),
(3128, '08556', 218, 37, 5556, 40.4224, 0.705503971558156, -74.9922, -1.30886080331409),
(3129, '08557', 218, 37, 146285, 40.4461, 0.705917614590879, -74.9434, -1.30800908263912),
(3130, '08558', 218, 37, 38236, 40.4165, 0.705400997132288, -74.6967, -1.30370335537445),
(3131, '08559', 218, 37, 510, 40.434, 0.705706429751387, -74.9564, -1.30823597544188),
(3132, '08560', 218, 37, 18352, 40.2984, 0.703339763285683, -74.8566, -1.30649413684839),
(3133, '08561', 218, 37, 18652, 40.2446, 0.70240077614811, -74.5873, -1.30179396517277),
(3134, '08562', 218, 37, 74890, 40.0635, 0.699239984872748, -74.6052, -1.30210637910887),
(3135, '08570', 218, 37, 113036, 40.3163, 0.70365217722179, -74.5137, -1.3005094028433),
(3136, '08601', 218, 37, 6381, 40.2192, 0.701957462518103, -74.762, -1.304843055376),
(3137, '08602', 218, 37, 6381, 40.2198, 0.701967934493615, -74.5759, -1.30159499763804),
(3138, '08603', 218, 37, 6381, 40.2192, 0.701957462518103, -74.7675, -1.30493904848486),
(3139, '08604', 218, 37, 6381, 40.2199, 0.701969679822867, -74.7671, -1.30493206716785),
(3140, '08605', 218, 37, 6381, 40.2197, 0.701966189164363, -74.7664, -1.30491984986309),
(3141, '08606', 218, 37, 6381, 40.2198, 0.701967934493615, -74.5754, -1.30158627099178),
(3142, '08607', 218, 37, 6381, 40.2192, 0.701957462518103, -74.7669, -1.30492857650935),
(3143, '08608', 218, 37, 6381, 40.2199, 0.701969679822867, -74.7631, -1.30486225399777),
(3144, '08609', 218, 37, 6381, 40.2233, 0.702029021017435, -74.7425, -1.30450271617186),
(3145, '08610', 218, 37, 6381, 40.2006, 0.701632831277232, -74.716, -1.30404020392008),
(3146, '08611', 218, 37, 6381, 40.2073, 0.701749768337116, -74.7521, -1.30467026778005),
(3147, '08618', 218, 37, 6381, 40.2394, 0.702310019027006, -74.7819, -1.30519037589715),
(3148, '08619', 218, 37, 6381, 40.2391, 0.70230478303925, -74.6948, -1.30367019411866),
(3149, '08620', 218, 37, 6381, 40.1782, 0.701241877524786, -74.6626, -1.30310819809952),
(3150, '08625', 218, 37, 6381, 40.2055, 0.70171835241058, -74.7561, -1.30474008095013),
(3151, '08628', 218, 37, 6381, 40.2676, 0.702802201876069, -74.8232, -1.30591119687822),
(3152, '08629', 218, 37, 6381, 40.2197, 0.701966189164363, -74.7312, -1.30430549396639),
(3153, '08638', 218, 37, 6381, 40.2498, 0.702491533269214, -74.761, -1.30482560208348),
(3154, '08640', 218, 37, 6381, 40.0102, 0.698309724381435, -74.6306, -1.30254969273888),
(3155, '08641', 218, 37, 6381, 40.0299, 0.698653554244078, -74.5715, -1.30151820315095),
(3156, '08645', 218, 37, 6381, 40.2197, 0.701966189164363, -74.768, -1.30494777513112),
(3157, '08646', 218, 37, 6381, 40.2198, 0.701967934493615, -74.7663, -1.30491810453384),
(3158, '08647', 218, 37, 6381, 40.2196, 0.701964443835111, -74.7685, -1.30495650177738),
(3159, '08648', 218, 37, 6381, 40.2757, 0.70294357354548, -74.7218, -1.3041414330167),
(3160, '08650', 218, 37, 6381, 40.1394, 0.700564689775012, -74.6282, -1.30250780483683),
(3161, '08666', 218, 37, 6381, 40.2199, 0.701969679822867, -74.7688, -1.30496173776514),
(3162, '08677', 218, 37, 6381, 40.2049, 0.701707880435068, -74.754, -1.30470342903584),
(3163, '08690', 218, 37, 6381, 40.2249, 0.702056946285467, -74.66, -1.30306281953897),
(3164, '08691', 218, 37, 6381, 40.2234, 0.702030766346687, -74.6211, -1.30238388645994),
(3165, '08695', 218, 37, 6381, 40.2198, 0.701967934493615, -74.7661, -1.30491461387533),
(3166, '08701', 218, 37, 3637, 40.0846, 0.699608249344919, -74.2067, -1.29515124203968),
(3167, '08720', 218, 37, 18807, 40.1424, 0.700617049652572, -74.1108, -1.29347747128701),
(3168, '08721', 218, 37, 13338, 39.9044, 0.696463166032825, -74.1592, -1.29432221064498),
(3169, '08722', 218, 37, 13340, 39.9312, 0.69693091427236, -74.1951, -1.29494878384644),
(3170, '08723', 218, 37, 0, 40.0514, 0.699028800033257, -74.1214, -1.29366247618772),
(3171, '08724', 218, 37, 0, 40.0856, 0.699625702637439, -74.1154, -1.29355775643261),
(3172, '08730', 218, 37, 144898, 40.1072, 0.70000269375587, -74.0643, -1.29266589318484),
(3173, '08731', 218, 37, 70826, 39.8453, 0.695431676444897, -74.1996, -1.29502732366278),
(3174, '08732', 218, 37, 70977, 39.9973, 0.698084576907928, -74.1205, -1.29364676822446),
(3175, '08733', 218, 37, 145561, 40.0153, 0.698398736173287, -74.2845, -1.29650910819773),
(3176, '08734', 218, 37, 71012, 39.8622, 0.695726637088484, -74.1673, -1.29446358231439),
(3177, '08735', 218, 37, 71017, 39.9778, 0.697744237703789, -74.1012, -1.29330991967882),
(3178, '08736', 218, 37, 145680, 40.1215, 0.700252275838905, -74.0617, -1.29262051462428),
(3179, '08738', 218, 37, 145687, 40.0232, 0.698536617184195, -74.0564, -1.29252801217393),
(3180, '08739', 218, 37, 145904, 40.002, 0.698166607382772, -74.064, -1.29266065719708),
(3181, '08740', 218, 37, 71207, 39.9262, 0.69684364780976, -74.1372, -1.29393823820954),
(3182, '08741', 218, 37, 50374, 39.934, 0.696979783491416, -74.1677, -1.2944705636314),
(3183, '08742', 218, 37, 146078, 40.0802, 0.699531454857831, -74.0641, -1.29266240252633),
(3184, '08750', 218, 37, 146281, 40.1337, 0.700465206007648, -74.0426, -1.29228715673715),
(3185, '08751', 218, 37, 71367, 39.9512, 0.697279980122759, -74.0762, -1.29287358736582),
(3186, '08752', 218, 37, 71370, 39.9226, 0.696780815956688, -74.0796, -1.29293292856039),
(3187, '08753', 218, 37, 71479, 39.9764, 0.697719803094261, -74.1737, -1.29457528338652),
(3188, '08754', 218, 37, 71479, 39.9808, 0.697796597581349, -74.1578, -1.29429777603545),
(3189, '08755', 218, 37, 71479, 40.0015, 0.698157880736512, -74.2227, -1.29543049472),
(3190, '08756', 218, 37, 71479, 39.9431, 0.697138608453347, -74.2515, -1.29593314954457),
(3191, '08757', 218, 37, 71479, 39.9748, 0.697691877826229, -74.2498, -1.29590347894729),
(3192, '08758', 218, 37, 71515, 39.7922, 0.694504906612088, -74.1911, -1.29487897067637),
(3193, '08759', 218, 37, 0, 39.9498, 0.697255545513231, -74.3637, -1.29789140896531),
(3194, '08801', 218, 37, 44379, 40.6302, 0.7091307657438, -74.8853, -1.30699504634371),
(3195, '08802', 218, 37, 44465, 40.6772, 0.709951070492237, -75.0222, -1.30938440208969),
(3196, '08803', 218, 37, 144790, 40.5221, 0.707244064822394, -75.0063, -1.30910689473862),
(3197, '08804', 218, 37, 44887, 40.6463, 0.709411763753371, -75.0779, -1.31035655048305),
(3198, '08805', 218, 37, 144872, 40.5689, 0.708060878912328, -74.5403, -1.30097366042433),
(3199, '08807', 218, 37, 19494, 40.5908, 0.708443106018514, -74.6221, -1.30240133975246),
(3200, '08808', 218, 37, 34998, 40.7249, 0.710783592545439, -75.048, -1.3098346970367),
(3201, '08809', 218, 37, 1630, 40.6519, 0.709509502191483, -74.9266, -1.30771586732478),
(3202, '08810', 218, 37, 1992, 40.3765, 0.704702865431491, -74.5137, -1.3005094028433),
(3203, '08812', 218, 37, 145104, 40.6012, 0.708624620260722, -74.4819, -1.29995438814116),
(3204, '08816', 218, 37, 145115, 40.4304, 0.705643597898315, -74.4061, -1.29863142856815),
(3205, '08817', 218, 37, 15893, 40.5167, 0.707149817042787, -74.3966, -1.29846562228921),
(3206, '08818', 218, 37, 15893, 40.5172, 0.707158543689047, -74.3961, -1.29845689564295),
(3207, '08820', 218, 37, 15893, 40.5754, 0.708174325313707, -74.366, -1.2979315515381),
(3208, '08821', 218, 37, 145229, 40.5188, 0.707186468957078, -74.6877, -1.30354627574177),
(3209, '08822', 218, 37, 16031, 40.5192, 0.707193450274086, -74.8508, -1.30639290775177),
(3210, '08823', 218, 37, 47255, 40.4412, 0.705832093457531, -74.5424, -1.30101031233862),
(3211, '08824', 218, 37, 145523, 40.4226, 0.70550746221666, -74.5465, -1.30108187083795),
(3212, '08825', 218, 37, 2608, 40.5233, 0.707265008773418, -75.048, -1.3098346970367),
(3213, '08826', 218, 37, 145298, 40.7012, 0.710369949512716, -74.928, -1.30774030193431),
(3214, '08827', 218, 37, 2957, 40.6774, 0.709954561150741, -74.9669, -1.30841923501334),
(3215, '08828', 218, 37, 145404, 40.3779, 0.704727300041018, -74.4209, -1.29888973729745),
(3216, '08829', 218, 37, 36402, 40.6688, 0.70980446283507, -74.8932, -1.30713292735462),
(3217, '08830', 218, 37, 145494, 40.5718, 0.708111493460635, -74.3178, -1.29709030283864),
(3218, '08831', 218, 37, 0, 40.349, 0.704222899887192, -74.4415, -1.29924927512336),
(3219, '08832', 218, 37, 145522, 40.5127, 0.707080003872707, -74.3047, -1.29686166470663),
(3220, '08833', 218, 37, 3708, 40.6437, 0.709366385192819, -74.8258, -1.30595657543877),
(3221, '08834', 218, 37, 30356, 40.607, 0.708725849357337, -75.0557, -1.30996908738911),
(3222, '08835', 218, 37, 30417, 40.5395, 0.707547752112241, -74.5919, -1.30187425031836),
(3223, '08836', 218, 37, 27817, 40.5972, 0.708554807090642, -74.5558, -1.30124418645839),
(3224, '08837', 218, 37, 15893, 40.5045, 0.706936886874043, -74.354, -1.29772211202786),
(3225, '08840', 218, 37, 145739, 40.5419, 0.707589640014289, -74.3581, -1.2977936705272),
(3226, '08844', 218, 37, 48155, 40.4775, 0.706465647976005, -74.6271, -1.30248860621506),
(3227, '08846', 218, 37, 49457, 40.5753, 0.708172579984455, -74.5003, -1.30027552872353),
(3228, '08848', 218, 37, 10480, 40.594, 0.708498956554578, -75.092, -1.31060264190758),
(3229, '08850', 218, 37, 602, 40.4498, 0.705982191773202, -74.4369, -1.29916898997777),
(3230, '08852', 218, 37, 145788, 40.3922, 0.704976882124054, -74.5444, -1.30104521892366),
(3231, '08853', 218, 37, 145865, 40.5091, 0.707017172019635, -74.7164, -1.30404718523709),
(3232, '08854', 218, 37, 50442, 40.5545, 0.70780955150004, -74.4607, -1.29958437833974),
(3233, '08855', 218, 37, 50442, 40.4992, 0.706844384423688, -74.399, -1.29850751019126),
(3234, '08857', 218, 37, 145959, 40.3995, 0.705104291159449, -74.3232, -1.29718455061825),
(3235, '08858', 218, 37, 145965, 40.6937, 0.710239049818816, -74.7938, -1.30539807007813),
(3236, '08859', 218, 37, 145998, 40.4613, 0.706182904637182, -74.3109, -1.29696987512025),
(3237, '08861', 218, 37, 146025, 40.5205, 0.707216139554362, -74.2784, -1.29640264311336),
(3238, '08862', 218, 37, 146025, 40.5198, 0.707203922249598, -74.2716, -1.29628396072422),
(3239, '08863', 218, 37, 40944, 40.5359, 0.707484920259169, -74.3149, -1.29703968829033),
(3240, '08865', 218, 37, 23863, 40.6893, 0.710162255331729, -75.1693, -1.31195178141937),
(3241, '08867', 218, 37, 146049, 40.5931, 0.70848324859131, -74.9069, -1.30737203746214),
(3242, '08868', 218, 37, 14457, 40.5653, 0.707998047059256, -74.9421, -1.30798639335884),
(3243, '08869', 218, 37, 121167, 40.5724, 0.708121965436147, -74.639, -1.30269630039605),
(3244, '08870', 218, 37, 146149, 40.5687, 0.708057388253824, -74.7375, -1.30441544970926),
(3245, '08871', 218, 37, 146268, 40.4661, 0.706266680441277, -74.3221, -1.29716535199648),
(3246, '08872', 218, 37, 146268, 40.4637, 0.70622479253923, -74.3457, -1.29757724969995),
(3247, '08873', 218, 37, 5946, 40.5028, 0.706907216276759, -74.5044, -1.30034708722286),
(3248, '08875', 218, 37, 5946, 40.5158, 0.707134109079519, -74.5452, -1.30105918155768),
(3249, '08876', 218, 37, 5947, 40.5582, 0.707874128682364, -74.6578, -1.30302442229542),
(3250, '08877', 218, 37, 51564, 40.5662, 0.708013755022524, -74.614, -1.30225996808305),
(3251, '08878', 218, 37, 146335, 40.481, 0.706526734499825, -74.2789, -1.29641136975962),
(3252, '08879', 218, 37, 146335, 40.4671, 0.706284133733797, -74.2759, -1.29635900988206),
(3253, '08880', 218, 37, 146340, 40.5534, 0.707790352878269, -74.5313, -1.30081658079165),
(3254, '08882', 218, 37, 51564, 40.4453, 0.705903651956863, -74.3823, -1.29821604020618),
(3255, '08884', 218, 37, 146367, 40.3878, 0.704900087636966, -74.3929, -1.29840104510689),
(3256, '08885', 218, 37, 6052, 40.5741, 0.708151636033431, -74.8351, -1.30611889105921),
(3257, '08886', 218, 37, 31223, 40.6937, 0.710239049818816, -75.1094, -1.31090632919743),
(3258, '08887', 218, 37, 146453, 40.5312, 0.707402889784326, -74.7766, -1.30509787344679),
(3259, '08888', 218, 37, 6785, 40.6236, 0.709015574013169, -74.7413, -1.30448177222084),
(3260, '08889', 218, 37, 146643, 40.6011, 0.70862287493147, -74.7611, -1.30482734741273),
(3261, '08890', 218, 37, 146695, 40.5364, 0.707493646905429, -74.5752, -1.30158278033328),
(3262, '08896', 218, 37, 121167, 40.572, 0.708114984119139, -74.6418, -1.3027451696151),
(3263, '08899', 218, 37, 15893, 40.5176, 0.707165525006054, -74.3958, -1.2984516596552),
(3264, '08901', 218, 37, 30623, 40.4878, 0.70664541688896, -74.4494, -1.29938715613427),
(3265, '08902', 218, 37, 0, 40.4547, 0.70606771290655, -74.482, -1.29995613347042),
(3266, '08903', 218, 37, 30623, 40.5103, 0.707038115970659, -74.4469, -1.29934352290297),
(3267, '08904', 218, 37, 16433, 40.5001, 0.706860092386956, -74.4248, -1.29895780513828),
(3268, '08905', 218, 37, 30623, 40.4509, 0.706001390394974, -74.4802, -1.29992471754388),
(3269, '08906', 218, 37, 30623, 40.4878, 0.70664541688896, -74.4463, -1.29933305092745),
(3270, '08922', 218, 37, 30623, 40.511, 0.707050333275423, -74.3493, -1.29764008155302),
(3271, '08933', 218, 37, 30623, 40.4875, 0.706640180901204, -74.445, -1.29931036164718),
(3272, '08988', 218, 37, 30623, 40.5202, 0.707210903566606, -74.4156, -1.29879723484709),
(3273, '08989', 218, 37, 30623, 40.5203, 0.707212648895858, -74.4151, -1.29878850820083),
(3274, '09007', 218, 0, 0, 0, 0, 0, 0),
(3275, '09009', 218, 0, 0, 0, 0, 0, 0),
(3276, '09012', 218, 0, 0, 0, 0, 0, 0),
(3277, '09013', 218, 0, 0, 0, 0, 0, 0),
(3278, '09014', 218, 0, 0, 0, 0, 0, 0),
(3279, '09021', 218, 0, 0, 0, 0, 0, 0),
(3280, '09028', 218, 0, 0, 0, 0, 0, 0),
(3281, '09029', 218, 0, 0, 0, 0, 0, 0),
(3282, '09031', 218, 0, 0, 0, 0, 0, 0),
(3283, '09033', 218, 0, 0, 0, 0, 0, 0),
(3284, '09034', 218, 0, 0, 0, 0, 0, 0),
(3285, '09036', 218, 0, 0, 0, 0, 0, 0),
(3286, '09037', 218, 0, 0, 0, 0, 0, 0),
(3287, '09042', 218, 0, 0, 0, 0, 0, 0),
(3288, '09045', 218, 0, 0, 0, 0, 0, 0),
(3289, '09046', 218, 0, 0, 0, 0, 0, 0),
(3290, '09050', 218, 0, 0, 0, 0, 0, 0),
(3291, '09053', 218, 0, 0, 0, 0, 0, 0),
(3292, '09054', 218, 0, 0, 0, 0, 0, 0),
(3293, '09056', 218, 0, 0, 0, 0, 0, 0),
(3294, '09058', 218, 0, 0, 0, 0, 0, 0),
(3295, '09059', 218, 0, 0, 0, 0, 0, 0),
(3296, '09060', 218, 0, 0, 0, 0, 0, 0),
(3297, '09063', 218, 0, 0, 0, 0, 0, 0),
(3298, '09067', 218, 0, 0, 0, 0, 0, 0),
(3299, '09069', 218, 0, 0, 0, 0, 0, 0),
(3300, '09072', 218, 0, 0, 0, 0, 0, 0),
(3301, '09074', 218, 0, 0, 0, 0, 0, 0),
(3302, '09076', 218, 0, 0, 0, 0, 0, 0),
(3303, '09080', 218, 0, 0, 0, 0, 0, 0),
(3304, '09081', 218, 0, 0, 0, 0, 0, 0),
(3305, '09086', 218, 0, 0, 0, 0, 0, 0),
(3306, '09089', 218, 0, 0, 0, 0, 0, 0),
(3307, '09090', 218, 0, 0, 0, 0, 0, 0),
(3308, '09094', 218, 0, 0, 0, 0, 0, 0),
(3309, '09095', 218, 0, 0, 0, 0, 0, 0),
(3310, '09096', 218, 0, 0, 0, 0, 0, 0),
(3311, '09098', 218, 0, 0, 0, 0, 0, 0),
(3312, '09099', 218, 0, 0, 0, 0, 0, 0),
(3313, '09100', 218, 0, 0, 0, 0, 0, 0),
(3314, '09102', 218, 0, 0, 0, 0, 0, 0),
(3315, '09103', 218, 0, 0, 0, 0, 0, 0),
(3316, '09104', 218, 0, 0, 0, 0, 0, 0),
(3317, '09106', 218, 0, 0, 0, 0, 0, 0),
(3318, '09107', 218, 0, 0, 0, 0, 0, 0),
(3319, '09110', 218, 0, 0, 0, 0, 0, 0),
(3320, '09111', 218, 0, 0, 0, 0, 0, 0),
(3321, '09112', 218, 0, 0, 0, 0, 0, 0),
(3322, '09114', 218, 0, 0, 0, 0, 0, 0),
(3323, '09123', 218, 0, 0, 0, 0, 0, 0),
(3324, '09126', 218, 0, 0, 0, 0, 0, 0),
(3325, '09128', 218, 0, 0, 0, 0, 0, 0),
(3326, '09131', 218, 0, 0, 0, 0, 0, 0),
(3327, '09136', 218, 0, 0, 0, 0, 0, 0),
(3328, '09137', 218, 0, 0, 0, 0, 0, 0),
(3329, '09138', 218, 0, 0, 0, 0, 0, 0),
(3330, '09139', 218, 0, 0, 0, 0, 0, 0),
(3331, '09140', 218, 0, 0, 0, 0, 0, 0),
(3332, '09142', 218, 0, 0, 0, 0, 0, 0),
(3333, '09143', 218, 0, 0, 0, 0, 0, 0),
(3334, '09154', 218, 0, 0, 0, 0, 0, 0),
(3335, '09157', 218, 0, 0, 0, 0, 0, 0),
(3336, '09164', 218, 0, 0, 0, 0, 0, 0),
(3337, '09165', 218, 0, 0, 0, 0, 0, 0),
(3338, '09166', 218, 0, 0, 0, 0, 0, 0),
(3339, '09169', 218, 0, 0, 0, 0, 0, 0),
(3340, '09172', 218, 0, 0, 0, 0, 0, 0),
(3341, '09173', 218, 0, 0, 0, 0, 0, 0),
(3342, '09175', 218, 0, 0, 0, 0, 0, 0),
(3343, '09177', 218, 0, 0, 0, 0, 0, 0),
(3344, '09178', 218, 0, 0, 0, 0, 0, 0),
(3345, '09180', 218, 0, 0, 0, 0, 0, 0),
(3346, '09182', 218, 0, 0, 0, 0, 0, 0),
(3347, '09183', 218, 0, 0, 0, 0, 0, 0),
(3348, '09185', 218, 0, 0, 0, 0, 0, 0),
(3349, '09186', 218, 0, 0, 0, 0, 0, 0),
(3350, '09189', 218, 0, 0, 0, 0, 0, 0),
(3351, '09211', 218, 0, 0, 0, 0, 0, 0),
(3352, '09212', 218, 0, 0, 0, 0, 0, 0),
(3353, '09213', 218, 0, 0, 0, 0, 0, 0),
(3354, '09214', 218, 0, 0, 0, 0, 0, 0),
(3355, '09220', 218, 0, 0, 0, 0, 0, 0),
(3356, '09222', 218, 0, 0, 0, 0, 0, 0),
(3357, '09225', 218, 0, 0, 0, 0, 0, 0),
(3358, '09226', 218, 0, 0, 0, 0, 0, 0),
(3359, '09227', 218, 0, 0, 0, 0, 0, 0),
(3360, '09229', 218, 0, 0, 0, 0, 0, 0),
(3361, '09234', 218, 0, 0, 0, 0, 0, 0),
(3362, '09237', 218, 0, 0, 0, 0, 0, 0),
(3363, '09239', 218, 0, 0, 0, 0, 0, 0),
(3364, '09244', 218, 0, 0, 0, 0, 0, 0),
(3365, '09245', 218, 0, 0, 0, 0, 0, 0),
(3366, '09250', 218, 0, 0, 0, 0, 0, 0),
(3367, '09252', 218, 0, 0, 0, 0, 0, 0),
(3368, '09262', 218, 0, 0, 0, 0, 0, 0),
(3369, '09263', 218, 0, 0, 0, 0, 0, 0),
(3370, '09264', 218, 0, 0, 0, 0, 0, 0),
(3371, '09265', 218, 0, 0, 0, 0, 0, 0),
(3372, '09266', 218, 0, 0, 0, 0, 0, 0),
(3373, '09267', 218, 0, 0, 0, 0, 0, 0),
(3374, '09269', 218, 0, 0, 0, 0, 0, 0),
(3375, '09275', 218, 0, 0, 0, 0, 0, 0),
(3376, '09302', 218, 0, 0, 0, 0, 0, 0),
(3377, '09303', 218, 0, 0, 0, 0, 0, 0),
(3378, '09304', 218, 0, 0, 0, 0, 0, 0),
(3379, '09305', 218, 0, 0, 0, 0, 0, 0),
(3380, '09309', 218, 0, 0, 0, 0, 0, 0),
(3381, '09310', 218, 0, 0, 0, 0, 0, 0),
(3382, '09311', 218, 0, 0, 0, 0, 0, 0),
(3383, '09314', 218, 0, 0, 0, 0, 0, 0),
(3384, '09315', 218, 0, 0, 0, 0, 0, 0),
(3385, '09316', 218, 0, 0, 0, 0, 0, 0),
(3386, '09317', 218, 0, 0, 0, 0, 0, 0),
(3387, '09318', 218, 0, 0, 0, 0, 0, 0),
(3388, '09320', 218, 0, 0, 0, 0, 0, 0),
(3389, '09321', 218, 0, 0, 0, 0, 0, 0),
(3390, '09340', 218, 0, 0, 0, 0, 0, 0),
(3391, '09345', 218, 0, 0, 0, 0, 0, 0),
(3392, '09350', 218, 0, 0, 0, 0, 0, 0),
(3393, '09351', 218, 0, 0, 0, 0, 0, 0),
(3394, '09352', 218, 0, 0, 0, 0, 0, 0),
(3395, '09353', 218, 0, 0, 0, 0, 0, 0),
(3396, '09354', 218, 0, 0, 0, 0, 0, 0),
(3397, '09355', 218, 0, 0, 0, 0, 0, 0),
(3398, '09356', 218, 0, 0, 0, 0, 0, 0),
(3399, '09360', 218, 0, 0, 0, 0, 0, 0),
(3400, '09361', 218, 0, 0, 0, 0, 0, 0),
(3401, '09363', 218, 0, 0, 0, 0, 0, 0),
(3402, '09364', 218, 0, 0, 0, 0, 0, 0),
(3403, '09365', 218, 0, 0, 0, 0, 0, 0),
(3404, '09395', 218, 0, 0, 0, 0, 0, 0),
(3405, '09396', 218, 0, 0, 0, 0, 0, 0),
(3406, '09409', 218, 0, 0, 0, 0, 0, 0),
(3407, '09419', 218, 0, 0, 0, 0, 0, 0),
(3408, '09420', 218, 0, 0, 0, 0, 0, 0),
(3409, '09421', 218, 0, 0, 0, 0, 0, 0),
(3410, '09447', 218, 0, 0, 0, 0, 0, 0),
(3411, '09448', 218, 0, 0, 0, 0, 0, 0),
(3412, '09449', 218, 0, 0, 0, 0, 0, 0),
(3413, '09454', 218, 0, 0, 0, 0, 0, 0),
(3414, '09456', 218, 0, 0, 0, 0, 0, 0),
(3415, '09459', 218, 0, 0, 0, 0, 0, 0),
(3416, '09461', 218, 0, 0, 0, 0, 0, 0),
(3417, '09463', 218, 0, 0, 0, 0, 0, 0),
(3418, '09464', 218, 0, 0, 0, 0, 0, 0),
(3419, '09468', 218, 0, 0, 0, 0, 0, 0),
(3420, '09469', 218, 0, 0, 0, 0, 0, 0),
(3421, '09470', 218, 0, 0, 0, 0, 0, 0),
(3422, '09494', 218, 0, 0, 0, 0, 0, 0),
(3423, '09496', 218, 0, 0, 0, 0, 0, 0),
(3424, '09498', 218, 0, 0, 0, 0, 0, 0),
(3425, '09499', 218, 0, 0, 0, 0, 0, 0),
(3426, '09501', 218, 0, 0, 0, 0, 0, 0),
(3427, '09502', 218, 0, 0, 0, 0, 0, 0),
(3428, '09503', 218, 0, 0, 0, 0, 0, 0),
(3429, '09504', 218, 0, 0, 0, 0, 0, 0),
(3430, '09505', 218, 0, 0, 0, 0, 0, 0),
(3431, '09506', 218, 0, 0, 0, 0, 0, 0),
(3432, '09507', 218, 0, 0, 0, 0, 0, 0),
(3433, '09508', 218, 0, 0, 0, 0, 0, 0),
(3434, '09509', 218, 0, 0, 0, 0, 0, 0),
(3435, '09510', 218, 0, 0, 0, 0, 0, 0),
(3436, '09511', 218, 0, 0, 0, 0, 0, 0),
(3437, '09517', 218, 0, 0, 0, 0, 0, 0),
(3438, '09521', 218, 0, 0, 0, 0, 0, 0),
(3439, '09524', 218, 0, 0, 0, 0, 0, 0),
(3440, '09532', 218, 0, 0, 0, 0, 0, 0),
(3441, '09534', 218, 0, 0, 0, 0, 0, 0),
(3442, '09543', 218, 0, 0, 0, 0, 0, 0),
(3443, '09544', 218, 0, 0, 0, 0, 0, 0),
(3444, '09545', 218, 0, 0, 0, 0, 0, 0),
(3445, '09549', 218, 0, 0, 0, 0, 0, 0),
(3446, '09550', 218, 0, 0, 0, 0, 0, 0),
(3447, '09551', 218, 0, 0, 0, 0, 0, 0),
(3448, '09554', 218, 0, 0, 0, 0, 0, 0),
(3449, '09556', 218, 0, 0, 0, 0, 0, 0),
(3450, '09557', 218, 0, 0, 0, 0, 0, 0),
(3451, '09564', 218, 0, 0, 0, 0, 0, 0),
(3452, '09565', 218, 0, 0, 0, 0, 0, 0),
(3453, '09566', 218, 0, 0, 0, 0, 0, 0),
(3454, '09567', 218, 0, 0, 0, 0, 0, 0),
(3455, '09568', 218, 0, 0, 0, 0, 0, 0),
(3456, '09569', 218, 0, 0, 0, 0, 0, 0),
(3457, '09570', 218, 0, 0, 0, 0, 0, 0),
(3458, '09573', 218, 0, 0, 0, 0, 0, 0),
(3459, '09574', 218, 0, 0, 0, 0, 0, 0),
(3460, '09575', 218, 0, 0, 0, 0, 0, 0),
(3461, '09576', 218, 0, 0, 0, 0, 0, 0),
(3462, '09577', 218, 0, 0, 0, 0, 0, 0),
(3463, '09578', 218, 0, 0, 0, 0, 0, 0),
(3464, '09579', 218, 0, 0, 0, 0, 0, 0),
(3465, '09581', 218, 0, 0, 0, 0, 0, 0),
(3466, '09582', 218, 0, 0, 0, 0, 0, 0),
(3467, '09586', 218, 0, 0, 0, 0, 0, 0),
(3468, '09587', 218, 0, 0, 0, 0, 0, 0),
(3469, '09588', 218, 0, 0, 0, 0, 0, 0),
(3470, '09589', 218, 0, 0, 0, 0, 0, 0),
(3471, '09590', 218, 0, 0, 0, 0, 0, 0),
(3472, '09591', 218, 0, 0, 0, 0, 0, 0),
(3473, '09593', 218, 0, 0, 0, 0, 0, 0),
(3474, '09594', 218, 0, 0, 0, 0, 0, 0),
(3475, '09595', 218, 0, 0, 0, 0, 0, 0),
(3476, '09596', 218, 0, 0, 0, 0, 0, 0),
(3477, '09599', 218, 0, 0, 0, 0, 0, 0),
(3478, '09601', 218, 0, 0, 0, 0, 0, 0),
(3479, '09602', 218, 0, 0, 0, 0, 0, 0),
(3480, '09603', 218, 0, 0, 0, 0, 0, 0),
(3481, '09604', 218, 0, 0, 0, 0, 0, 0),
(3482, '09609', 218, 0, 0, 0, 0, 0, 0),
(3483, '09610', 218, 0, 0, 0, 0, 0, 0),
(3484, '09612', 218, 0, 0, 0, 0, 0, 0),
(3485, '09613', 218, 0, 0, 0, 0, 0, 0),
(3486, '09617', 218, 0, 0, 0, 0, 0, 0),
(3487, '09618', 218, 0, 0, 0, 0, 0, 0),
(3488, '09619', 218, 0, 0, 0, 0, 0, 0),
(3489, '09620', 218, 0, 0, 0, 0, 0, 0),
(3490, '09621', 218, 0, 0, 0, 0, 0, 0),
(3491, '09622', 218, 0, 0, 0, 0, 0, 0),
(3492, '09623', 218, 0, 0, 0, 0, 0, 0),
(3493, '09624', 218, 0, 0, 0, 0, 0, 0),
(3494, '09625', 218, 0, 0, 0, 0, 0, 0),
(3495, '09626', 218, 0, 0, 0, 0, 0, 0),
(3496, '09627', 218, 0, 0, 0, 0, 0, 0),
(3497, '09628', 218, 0, 0, 0, 0, 0, 0),
(3498, '09630', 218, 0, 0, 0, 0, 0, 0),
(3499, '09631', 218, 0, 0, 0, 0, 0, 0),
(3500, '09636', 218, 0, 0, 0, 0, 0, 0),
(3501, '09638', 218, 0, 0, 0, 0, 0, 0),
(3502, '09642', 218, 0, 0, 0, 0, 0, 0),
(3503, '09643', 218, 0, 0, 0, 0, 0, 0),
(3504, '09644', 218, 0, 0, 0, 0, 0, 0),
(3505, '09645', 218, 0, 0, 0, 0, 0, 0),
(3506, '09647', 218, 0, 0, 0, 0, 0, 0),
(3507, '09649', 218, 0, 0, 0, 0, 0, 0),
(3508, '09703', 218, 0, 0, 0, 0, 0, 0),
(3509, '09704', 218, 0, 0, 0, 0, 0, 0),
(3510, '09705', 218, 0, 0, 0, 0, 0, 0),
(3511, '09706', 218, 0, 0, 0, 0, 0, 0),
(3512, '09707', 218, 0, 0, 0, 0, 0, 0),
(3513, '09708', 218, 0, 0, 0, 0, 0, 0),
(3514, '09709', 218, 0, 0, 0, 0, 0, 0),
(3515, '09710', 218, 0, 0, 0, 0, 0, 0),
(3516, '09711', 218, 0, 0, 0, 0, 0, 0),
(3517, '09713', 218, 0, 0, 0, 0, 0, 0),
(3518, '09714', 218, 0, 0, 0, 0, 0, 0),
(3519, '09715', 218, 0, 0, 0, 0, 0, 0),
(3520, '09716', 218, 0, 0, 0, 0, 0, 0),
(3521, '09717', 218, 0, 0, 0, 0, 0, 0),
(3522, '09718', 218, 0, 0, 0, 0, 0, 0),
(3523, '09720', 218, 0, 0, 0, 0, 0, 0),
(3524, '09721', 218, 0, 0, 0, 0, 0, 0),
(3525, '09722', 218, 0, 0, 0, 0, 0, 0),
(3526, '09723', 218, 0, 0, 0, 0, 0, 0),
(3527, '09724', 218, 0, 0, 0, 0, 0, 0),
(3528, '09725', 218, 0, 0, 0, 0, 0, 0),
(3529, '09726', 218, 0, 0, 0, 0, 0, 0),
(3530, '09727', 218, 0, 0, 0, 0, 0, 0),
(3531, '09728', 218, 0, 0, 0, 0, 0, 0),
(3532, '09729', 218, 0, 0, 0, 0, 0, 0),
(3533, '09730', 218, 0, 0, 0, 0, 0, 0),
(3534, '09731', 218, 0, 0, 0, 0, 0, 0),
(3535, '09732', 218, 0, 0, 0, 0, 0, 0),
(3536, '09733', 218, 0, 0, 0, 0, 0, 0),
(3537, '09734', 218, 0, 0, 0, 0, 0, 0),
(3538, '09735', 218, 0, 0, 0, 0, 0, 0),
(3539, '09777', 218, 0, 0, 0, 0, 0, 0),
(3540, '09779', 218, 0, 0, 0, 0, 0, 0),
(3541, '09780', 218, 0, 0, 0, 0, 0, 0),
(3542, '09782', 218, 0, 0, 0, 0, 0, 0),
(3543, '09783', 218, 0, 0, 0, 0, 0, 0),
(3544, '09784', 218, 0, 0, 0, 0, 0, 0),
(3545, '09789', 218, 0, 0, 0, 0, 0, 0),
(3546, '09790', 218, 0, 0, 0, 0, 0, 0),
(3547, '09791', 218, 0, 0, 0, 0, 0, 0),
(3548, '09792', 218, 0, 0, 0, 0, 0, 0),
(3549, '09793', 218, 0, 0, 0, 0, 0, 0),
(3550, '09797', 218, 0, 0, 0, 0, 0, 0),
(3551, '09802', 218, 0, 0, 0, 0, 0, 0),
(3552, '09803', 218, 0, 0, 0, 0, 0, 0),
(3553, '09804', 218, 0, 0, 0, 0, 0, 0),
(3554, '09805', 218, 0, 0, 0, 0, 0, 0),
(3555, '09808', 218, 0, 0, 0, 0, 0, 0),
(3556, '09809', 218, 0, 0, 0, 0, 0, 0),
(3557, '09810', 218, 0, 0, 0, 0, 0, 0),
(3558, '09811', 218, 0, 0, 0, 0, 0, 0),
(3559, '09812', 218, 0, 0, 0, 0, 0, 0),
(3560, '09813', 218, 0, 0, 0, 0, 0, 0),
(3561, '09814', 218, 0, 0, 0, 0, 0, 0),
(3562, '09815', 218, 0, 0, 0, 0, 0, 0),
(3563, '09816', 218, 0, 0, 0, 0, 0, 0),
(3564, '09819', 218, 0, 0, 0, 0, 0, 0),
(3565, '09821', 218, 0, 0, 0, 0, 0, 0),
(3566, '09822', 218, 0, 0, 0, 0, 0, 0),
(3567, '09823', 218, 0, 0, 0, 0, 0, 0),
(3568, '09824', 218, 0, 0, 0, 0, 0, 0),
(3569, '09825', 218, 0, 0, 0, 0, 0, 0),
(3570, '09826', 218, 0, 0, 0, 0, 0, 0),
(3571, '09827', 218, 0, 0, 0, 0, 0, 0),
(3572, '09828', 218, 0, 0, 0, 0, 0, 0),
(3573, '09829', 218, 0, 0, 0, 0, 0, 0),
(3574, '09830', 218, 0, 0, 0, 0, 0, 0),
(3575, '09831', 218, 0, 0, 0, 0, 0, 0),
(3576, '09832', 218, 0, 0, 0, 0, 0, 0),
(3577, '09833', 218, 0, 0, 0, 0, 0, 0),
(3578, '09834', 218, 0, 0, 0, 0, 0, 0),
(3579, '09835', 218, 0, 0, 0, 0, 0, 0),
(3580, '09836', 218, 0, 0, 0, 0, 0, 0),
(3581, '09837', 218, 0, 0, 0, 0, 0, 0),
(3582, '09838', 218, 0, 0, 0, 0, 0, 0),
(3583, '09839', 218, 0, 0, 0, 0, 0, 0),
(3584, '09841', 218, 0, 0, 0, 0, 0, 0),
(3585, '09842', 218, 0, 0, 0, 0, 0, 0),
(3586, '09843', 218, 0, 0, 0, 0, 0, 0),
(3587, '09844', 218, 0, 0, 0, 0, 0, 0),
(3588, '09852', 218, 0, 0, 0, 0, 0, 0),
(3589, '09853', 218, 0, 0, 0, 0, 0, 0),
(3590, '09854', 218, 0, 0, 0, 0, 0, 0),
(3591, '09855', 218, 0, 0, 0, 0, 0, 0),
(3592, '09858', 218, 0, 0, 0, 0, 0, 0),
(3593, '09865', 218, 0, 0, 0, 0, 0, 0),
(3594, '09866', 218, 0, 0, 0, 0, 0, 0),
(3595, '09868', 218, 0, 0, 0, 0, 0, 0),
(3596, '09871', 218, 0, 0, 0, 0, 0, 0),
(3597, '09880', 218, 0, 0, 0, 0, 0, 0),
(3598, '09882', 218, 0, 0, 0, 0, 0, 0),
(3599, '09888', 218, 0, 0, 0, 0, 0, 0),
(3600, '09889', 218, 0, 0, 0, 0, 0, 0),
(3601, '09890', 218, 0, 0, 0, 0, 0, 0),
(3602, '09892', 218, 0, 0, 0, 0, 0, 0),
(3603, '09894', 218, 0, 0, 0, 0, 0, 0),
(3604, '09898', 218, 0, 0, 0, 0, 0, 0),
(3605, '10001', 218, 40, 676, 40.7496, 0.711214688870681, -73.9971, -1.2914930319275),
(3606, '10002', 218, 40, 676, 40.7162, 0.710631748900515, -73.9859, -1.29129755505127),
(3607, '10003', 218, 40, 676, 40.7322, 0.710911001580834, -73.9897, -1.29136387756285),
(3608, '10004', 218, 40, 676, 40.7043, 0.710424054719528, -74.0118, -1.29174959532754),
(3609, '10005', 218, 40, 676, 40.7057, 0.710448489329056, -74.0095, -1.29170945275474),
(3610, '10006', 218, 40, 676, 40.7084, 0.71049561321886, -74.0134, -1.29177752059557),
(3611, '10007', 218, 40, 676, 40.7135, 0.710584625010711, -74.0076, -1.29167629149896),
(3612, '10008', 218, 40, 676, 40.7142, 0.710596842315475, -74.0085, -1.29169199946222),
(3613, '10009', 218, 40, 676, 40.7266, 0.710813263142723, -73.9805, -1.29120330727167),
(3614, '10010', 218, 40, 676, 40.7389, 0.711027938640718, -73.9855, -1.29129057373426),
(3615, '10011', 218, 40, 676, 40.7426, 0.711092515823042, -74.0005, -1.29155237312206),
(3616, '10012', 218, 40, 676, 40.7252, 0.710788828533195, -73.9972, -1.29149477725675),
(3617, '10013', 218, 40, 676, 40.7203, 0.710703307399847, -74.0048, -1.2916274222799),
(3618, '10014', 218, 40, 676, 40.7347, 0.710954634812134, -74.0056, -1.29164138491392),
(3619, '10015', 218, 40, 676, 40.7137, 0.710588115669215, -74.0104, -1.29172516071801),
(3620, '10016', 218, 40, 676, 40.7458, 0.711148366359106, -73.9792, -1.29118061799139),
(3621, '10017', 218, 40, 676, 40.7524, 0.711263558089737, -73.9744, -1.29109684218729),
(3622, '10018', 218, 40, 676, 40.7546, 0.711301955333281, -73.9934, -1.29142845474517),
(3623, '10019', 218, 40, 676, 40.7651, 0.71148521490474, -73.9865, -1.29130802702678);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(3624, '10020', 218, 40, 676, 40.7585, 0.711370023174109, -73.9787, -1.29117189134513),
(3625, '10021', 218, 40, 676, 40.7683, 0.711541065440804, -73.9615, -1.29087169471379),
(3626, '10022', 218, 40, 676, 40.7586, 0.711371768503361, -73.9678, -1.29098165045666),
(3627, '10023', 218, 40, 676, 40.7753, 0.711663238488444, -73.9826, -1.29123995918596),
(3628, '10024', 218, 40, 676, 40.786, 0.711849988718407, -73.9774, -1.29114920206485),
(3629, '10025', 218, 40, 676, 40.798, 0.712059428228647, -73.9681, -1.29098688644442),
(3630, '10026', 218, 40, 676, 40.8023, 0.712134477386482, -73.953, -1.29072334172737),
(3631, '10027', 218, 40, 676, 40.8111, 0.712288066360658, -73.9537, -1.29073555903213),
(3632, '10028', 218, 40, 676, 40.7772, 0.711696399744232, -73.9536, -1.29073381370288),
(3633, '10029', 218, 40, 676, 40.7919, 0.711952963144275, -73.9463, -1.29060640466748),
(3634, '10030', 218, 40, 676, 40.8187, 0.712420711383809, -73.9424, -1.29053833682666),
(3635, '10031', 218, 40, 676, 40.8255, 0.712539393772945, -73.9492, -1.29065701921579),
(3636, '10032', 218, 40, 676, 40.839, 0.712775013221964, -73.9417, -1.29052611952189),
(3637, '10033', 218, 40, 676, 40.8491, 0.712951291476416, -73.9358, -1.29042314509602),
(3638, '10034', 218, 40, 676, 40.8667, 0.713258469424767, -73.9201, -1.29014912840346),
(3639, '10035', 218, 40, 676, 40.8021, 0.712130986727978, -73.9381, -1.29046328766882),
(3640, '10036', 218, 40, 676, 40.7597, 0.711390967125133, -73.9903, -1.29137434953836),
(3641, '10037', 218, 40, 676, 40.8129, 0.712319482287194, -73.9379, -1.29045979701032),
(3642, '10038', 218, 40, 676, 40.7099, 0.71052179315764, -74.0033, -1.29160124234112),
(3643, '10039', 218, 40, 676, 40.8264, 0.712555101736213, -73.9385, -1.29047026898583),
(3644, '10040', 218, 40, 676, 40.8578, 0.713103135121339, -73.9303, -1.29032715198716),
(3645, '10041', 218, 40, 676, 40.7047, 0.710431036036536, -74.0109, -1.29173388736427),
(3646, '10043', 218, 40, 676, 40.7592, 0.711382240478873, -73.9737, -1.29108462488253),
(3647, '10044', 218, 40, 676, 40.7631, 0.711450308319701, -73.9485, -1.29064480191103),
(3648, '10045', 218, 40, 676, 40.6868, 0.710118622100429, -74.0089, -1.29169898077923),
(3649, '10046', 218, 40, 676, 40.7134, 0.710582879681459, -74.0098, -1.2917146887425),
(3650, '10047', 218, 40, 676, 40.7111, 0.710542737108664, -74.012, -1.29175308598604),
(3651, '10048', 218, 40, 676, 40.7153, 0.710616040937247, -74.0069, -1.29166407419419),
(3652, '10055', 218, 40, 676, 40.7581, 0.711363041857101, -73.9681, -1.29098688644442),
(3653, '10060', 218, 40, 676, 40.7505, 0.711230396833949, -73.9982, -1.29151223054927),
(3654, '10069', 218, 40, 676, 40.7718, 0.711602151964624, -73.9876, -1.29132722564856),
(3655, '10072', 218, 40, 676, 40.7546, 0.711301955333281, -74.0004, -1.29155062779281),
(3656, '10079', 218, 40, 676, 40.714, 0.710593351656971, -74.0061, -1.29165011156018),
(3657, '10080', 218, 40, 676, 40.6993, 0.710336788256928, -73.9816, -1.29122250589344),
(3658, '10081', 218, 40, 676, 40.7141, 0.710595096986223, -74.0064, -1.29165534754793),
(3659, '10082', 218, 40, 676, 40.7761, 0.71167720112246, -73.9844, -1.29127137511249),
(3660, '10087', 218, 40, 676, 40.753, 0.711274030065249, -73.9751, -1.29110905949206),
(3661, '10090', 218, 40, 676, 40.7551, 0.711310681979541, -73.993, -1.29142147342816),
(3662, '10094', 218, 40, 676, 40.7146, 0.710603823632483, -74.0059, -1.29164662090167),
(3663, '10095', 218, 40, 676, 40.7473, 0.711174546297885, -73.9885, -1.29134293361182),
(3664, '10096', 218, 40, 676, 40.7145, 0.710602078303231, -74.0064, -1.29165534754793),
(3665, '10098', 218, 40, 676, 40.7142, 0.710596842315475, -74.0106, -1.29172865137652),
(3666, '10099', 218, 40, 676, 40.7503, 0.711226906175445, -73.9979, -1.29150699456151),
(3667, '10101', 218, 40, 676, 40.7657, 0.711495686880252, -73.9873, -1.2913219896608),
(3668, '10102', 218, 40, 676, 40.7633, 0.711453798978205, -73.9811, -1.29121377924718),
(3669, '10103', 218, 40, 676, 40.7598, 0.711392712454385, -73.9764, -1.29113174877233),
(3670, '10104', 218, 40, 676, 40.7608, 0.711410165746905, -73.9794, -1.29118410864989),
(3671, '10105', 218, 40, 676, 40.7626, 0.711441581673441, -73.9779, -1.29115792871111),
(3672, '10106', 218, 40, 676, 40.7646, 0.711476488258481, -73.9803, -1.29119981661316),
(3673, '10107', 218, 40, 676, 40.7656, 0.711493941551, -73.987, -1.29131675367304),
(3674, '10108', 218, 40, 676, 40.7603, 0.711401439100645, -73.9908, -1.29138307618462),
(3675, '10109', 218, 40, 676, 40.7607, 0.711408420417653, -73.9906, -1.29137958552612),
(3676, '10110', 218, 40, 676, 40.7266, 0.710813263142723, -73.979, -1.29117712733289),
(3677, '10111', 218, 40, 676, 40.7596, 0.711389221795881, -73.9805, -1.29120330727167),
(3678, '10112', 218, 40, 676, 40.7598, 0.711392712454385, -73.9808, -1.29120854325942),
(3679, '10113', 218, 40, 676, 40.7415, 0.71107331720127, -74.0007, -1.29155586378057),
(3680, '10114', 218, 40, 676, 40.742, 0.71108204384753, -74.0012, -1.29156459042683),
(3681, '10115', 218, 40, 676, 40.8121, 0.712305519653178, -73.9536, -1.29073381370288),
(3682, '10116', 218, 40, 676, 40.8116, 0.712296793006918, -73.9537, -1.29073555903213),
(3683, '10117', 218, 40, 676, 40.7502, 0.711225160846193, -73.9926, -1.29141449211116),
(3684, '10118', 218, 40, 676, 40.7497, 0.711216434199933, -73.9979, -1.29150699456151),
(3685, '10119', 218, 40, 676, 40.7504, 0.711228651504697, -73.9982, -1.29151223054927),
(3686, '10120', 218, 40, 676, 40.7505, 0.711230396833949, -73.9981, -1.29151048522002),
(3687, '10121', 218, 40, 676, 40.7507, 0.711233887492453, -73.9974, -1.29149826791525),
(3688, '10122', 218, 40, 676, 40.7506, 0.711232142163201, -73.9978, -1.29150524923226),
(3689, '10123', 218, 40, 676, 40.7499, 0.711219924858437, -73.998, -1.29150873989076),
(3690, '10124', 218, 40, 676, 40.7584, 0.711368277844857, -73.9691, -1.29100433973694),
(3691, '10125', 218, 40, 676, 40.7516, 0.711249595455721, -74.0007, -1.29155586378057),
(3692, '10126', 218, 40, 676, 40.7584, 0.711368277844857, -73.973, -1.29107240757777),
(3693, '10128', 218, 40, 676, 40.7819, 0.711778430219076, -73.9525, -1.29071461508111),
(3694, '10129', 218, 40, 676, 40.7552, 0.711312427308793, -73.9914, -1.29139354816013),
(3695, '10130', 218, 40, 676, 40.7519, 0.711254831443477, -74.0004, -1.29155062779281),
(3696, '10131', 218, 40, 676, 40.7835, 0.711806355487107, -73.9474, -1.29062560328925),
(3697, '10132', 218, 40, 676, 40.7854, 0.711839516742895, -73.9815, -1.29122076056418),
(3698, '10133', 218, 40, 676, 40.7761, 0.71167720112246, -73.9838, -1.29126090313698),
(3699, '10138', 218, 40, 676, 40.755, 0.711308936650289, -73.99, -1.2913691135506),
(3700, '10149', 218, 40, 676, 40.7659, 0.711499177538756, -73.9873, -1.2913219896608),
(3701, '10150', 218, 40, 676, 40.7585, 0.711370023174109, -73.9692, -1.29100608506619),
(3702, '10151', 218, 40, 676, 40.7634, 0.711455544307457, -73.9732, -1.29107589823627),
(3703, '10152', 218, 40, 676, 40.7587, 0.711373513832613, -73.9718, -1.29105146362674),
(3704, '10153', 218, 40, 676, 40.7631, 0.711450308319701, -73.9732, -1.29107589823627),
(3705, '10154', 218, 40, 676, 40.7585, 0.711370023174109, -73.9687, -1.29099735841993),
(3706, '10155', 218, 40, 676, 40.7613, 0.711418892393165, -73.9682, -1.29098863177367),
(3707, '10156', 218, 40, 676, 40.7459, 0.711150111688358, -73.9778, -1.29115618338186),
(3708, '10157', 218, 40, 676, 40.7452, 0.711137894383594, -73.9785, -1.29116840068663),
(3709, '10158', 218, 40, 676, 40.7582, 0.711364787186353, -73.9688, -1.29099910374918),
(3710, '10159', 218, 40, 676, 40.7391, 0.711031429299222, -73.9846, -1.291274865771),
(3711, '10160', 218, 40, 676, 40.7393, 0.711034919957726, -73.9848, -1.2912783564295),
(3712, '10161', 218, 40, 676, 40.7483, 0.711191999590405, -74.0045, -1.29162218629214),
(3713, '10162', 218, 40, 676, 40.7683, 0.711541065440804, -73.9601, -1.29084726010426),
(3714, '10163', 218, 40, 676, 40.7541, 0.711293228687021, -73.9709, -1.29103575566347),
(3715, '10164', 218, 40, 676, 40.7533, 0.711279266053005, -73.9758, -1.29112127679682),
(3716, '10165', 218, 40, 676, 40.7523, 0.711261812760485, -73.9788, -1.29117363667438),
(3717, '10166', 218, 40, 676, 40.7535, 0.711282756711509, -73.9772, -1.29114571140635),
(3718, '10167', 218, 40, 676, 40.754, 0.711291483357769, -73.9739, -1.29108811554103),
(3719, '10168', 218, 40, 676, 40.7505, 0.711230396833949, -73.9762, -1.29112825811383),
(3720, '10169', 218, 40, 676, 40.7976, 0.712052446911639, -73.9461, -1.29060291400898),
(3721, '10170', 218, 40, 676, 40.7525, 0.711265303418989, -73.9756, -1.29111778613832),
(3722, '10171', 218, 40, 676, 40.7565, 0.711335116589069, -73.9747, -1.29110207817505),
(3723, '10172', 218, 40, 676, 40.7389, 0.711027938640718, -73.9868, -1.29131326301454),
(3724, '10173', 218, 40, 676, 40.7537, 0.711286247370013, -73.9787, -1.29117189134513),
(3725, '10174', 218, 40, 676, 40.7519, 0.711254831443477, -73.9755, -1.29111604080907),
(3726, '10175', 218, 40, 676, 40.7539, 0.711289738028517, -73.9803, -1.29119981661316),
(3727, '10176', 218, 40, 676, 40.7554, 0.711315917967297, -73.98, -1.29119458062541),
(3728, '10177', 218, 40, 676, 40.7381, 0.711013976006702, -73.9874, -1.29132373499005),
(3729, '10178', 218, 40, 676, 40.7507, 0.711233887492453, -73.979, -1.29117712733289),
(3730, '10179', 218, 40, 676, 40.7538, 0.711287992699265, -73.9748, -1.2911038235043),
(3731, '10184', 218, 40, 676, 40.7137, 0.710588115669215, -74.0061, -1.29165011156018),
(3732, '10185', 218, 40, 676, 40.7602, 0.711399693771393, -73.9914, -1.29139354816013),
(3733, '10196', 218, 40, 676, 40.7145, 0.710602078303231, -74.0068, -1.29166232886494),
(3734, '10197', 218, 40, 676, 40.7585, 0.711370023174109, -73.968, -1.29098514111517),
(3735, '10199', 218, 40, 676, 40.7261, 0.710804536496463, -73.979, -1.29117712733289),
(3736, '10203', 218, 40, 676, 40.7122, 0.710561935730435, -74.0108, -1.29173214203502),
(3737, '10211', 218, 40, 676, 40.7315, 0.71089878427607, -73.9898, -1.2913656228921),
(3738, '10212', 218, 40, 676, 40.7096, 0.710516557169884, -74.0105, -1.29172690604726),
(3739, '10213', 218, 40, 676, 40.7172, 0.710649202193035, -74.0074, -1.29167280084045),
(3740, '10242', 218, 40, 676, 40.7138, 0.710589860998467, -74.0107, -1.29173039670577),
(3741, '10249', 218, 40, 676, 40.7136, 0.710586370339963, -74.0101, -1.29171992473026),
(3742, '10256', 218, 40, 676, 40.7096, 0.710516557169884, -74.011, -1.29173563269352),
(3743, '10257', 218, 40, 676, 40.7147, 0.710605568961735, -74.0066, -1.29165883820644),
(3744, '10258', 218, 40, 676, 40.7137, 0.710588115669215, -74.0062, -1.29165185688943),
(3745, '10259', 218, 40, 676, 40.7534, 0.711281011382257, -73.9753, -1.29111255015056),
(3746, '10260', 218, 40, 676, 40.7055, 0.710444998670552, -74.0119, -1.29175134065679),
(3747, '10261', 218, 40, 676, 40.7532, 0.711277520723753, -73.9753, -1.29111255015056),
(3748, '10265', 218, 40, 676, 40.7052, 0.710439762682796, -74.0116, -1.29174610466904),
(3749, '10268', 218, 40, 676, 40.7054, 0.7104432533413, -74.0117, -1.29174784999829),
(3750, '10269', 218, 40, 676, 40.703, 0.710401365439252, -74.0077, -1.29167803682821),
(3751, '10270', 218, 40, 676, 40.7054, 0.7104432533413, -74.0089, -1.29169898077923),
(3752, '10271', 218, 40, 676, 40.7058, 0.710450234658308, -74.009, -1.29170072610848),
(3753, '10272', 218, 40, 676, 40.7605, 0.711404929759149, -74.0037, -1.29160822365813),
(3754, '10273', 218, 40, 676, 40.7099, 0.71052179315764, -74.0032, -1.29159949701187),
(3755, '10274', 218, 40, 676, 40.7053, 0.710441508012048, -74.0103, -1.29172341538876),
(3756, '10275', 218, 40, 676, 40.7033, 0.710406601427008, -74.014, -1.29178799257108),
(3757, '10276', 218, 40, 676, 40.733, 0.71092496421485, -73.9885, -1.29134293361182),
(3758, '10277', 218, 40, 676, 40.7188, 0.710677127461067, -74.0161, -1.29182464448537),
(3759, '10278', 218, 40, 676, 40.7144, 0.710600332973979, -74.01, -1.291718179401),
(3760, '10279', 218, 40, 676, 40.7138, 0.710589860998467, -74.0104, -1.29172516071801),
(3761, '10280', 218, 40, 676, 40.7087, 0.710500849206616, -74.0167, -1.29183511646089),
(3762, '10281', 218, 40, 676, 40.7134, 0.710582879681459, -74.0107, -1.29173039670577),
(3763, '10282', 218, 40, 676, 40.7141, 0.710595096986223, -74.01, -1.291718179401),
(3764, '10285', 218, 40, 676, 40.7123, 0.710563681059687, -74.0153, -1.29181068185136),
(3765, '10286', 218, 40, 676, 40.7057, 0.710448489329056, -74.0117, -1.29174784999829),
(3766, '10292', 218, 40, 676, 40.7098, 0.710520047828388, -74.003, -1.29159600635336),
(3767, '10301', 218, 40, 0, 40.6222, 0.708991139403641, -74.0997, -1.29328373974004),
(3768, '10302', 218, 40, 0, 40.6302, 0.7091307657438, -74.1379, -1.2939504555143),
(3769, '10303', 218, 40, 0, 40.6296, 0.709120293768288, -74.1604, -1.294343154596),
(3770, '10304', 218, 40, 0, 40.6028, 0.708652545528754, -74.0914, -1.29313887741213),
(3771, '10305', 218, 40, 0, 40.5941, 0.70850070188383, -74.0773, -1.2928927859876),
(3772, '10306', 218, 40, 0, 40.5693, 0.708067860229336, -74.119, -1.29362058828568),
(3773, '10307', 218, 40, 0, 40.5092, 0.707018917348887, -74.2406, -1.2957429086561),
(3774, '10308', 218, 40, 0, 40.5513, 0.707753700963977, -74.1499, -1.29415989502454),
(3775, '10309', 218, 40, 0, 40.5302, 0.707385436491806, -74.2134, -1.29526817909956),
(3776, '10310', 218, 40, 0, 40.632, 0.709162181670336, -74.1163, -1.29357346439587),
(3777, '10311', 218, 40, 0, 40.6043, 0.708678725467534, -74.1827, -1.2947323630192),
(3778, '10312', 218, 40, 0, 40.542, 0.707591385343541, -74.1786, -1.29466080451987),
(3779, '10313', 218, 40, 0, 40.6148, 0.708861985038993, -74.1235, -1.29369912810202),
(3780, '10314', 218, 40, 0, 40.6052, 0.708694433430802, -74.149, -1.29414418706128),
(3781, '10451', 218, 40, 147395, 40.8199, 0.712441655334833, -73.9214, -1.29017181768374),
(3782, '10452', 218, 40, 147395, 40.8378, 0.71275406927094, -73.9215, -1.29017356301299),
(3783, '10453', 218, 40, 147395, 40.8524, 0.713008887341732, -73.9122, -1.29001124739255),
(3784, '10454', 218, 40, 147395, 40.8069, 0.712214762532074, -73.9164, -1.29008455122114),
(3785, '10455', 218, 40, 147395, 40.8144, 0.712345662225974, -73.9057, -1.28989780099117),
(3786, '10456', 218, 40, 147395, 40.8305, 0.712626660235545, -73.9072, -1.28992398092995),
(3787, '10457', 218, 40, 147395, 40.8464, 0.712904167586612, -73.8991, -1.28978260926054),
(3788, '10458', 218, 40, 147395, 40.8624, 0.713183420266931, -73.8894, -1.2896133123231),
(3789, '10459', 218, 40, 147395, 40.8255, 0.712539393772945, -73.895, -1.28971105076121),
(3790, '10460', 218, 40, 147395, 40.8403, 0.71279770250224, -73.8793, -1.28943703406865),
(3791, '10461', 218, 40, 147395, 40.8444, 0.712869261001572, -73.8418, -1.28878253559915),
(3792, '10462', 218, 40, 147395, 40.8424, 0.712834354416532, -73.8581, -1.28906702426722),
(3793, '10463', 218, 40, 147395, 40.882, 0.713525504800322, -73.9066, -1.28991350895444),
(3794, '10464', 218, 40, 147395, 40.8648, 0.713225308168979, -73.8086, -1.28820308628749),
(3795, '10465', 218, 40, 147395, 40.8229, 0.712494015212393, -73.8255, -1.28849804693107),
(3796, '10466', 218, 40, 147395, 40.8906, 0.713675603115993, -73.8463, -1.28886107541549),
(3797, '10467', 218, 40, 147395, 40.8825, 0.713534231446582, -73.8689, -1.28925551982644),
(3798, '10468', 218, 40, 147395, 40.8668, 0.713260214754019, -73.9, -1.28979831722381),
(3799, '10469', 218, 40, 147395, 40.8694, 0.713305593314571, -73.8478, -1.28888725535427),
(3800, '10470', 218, 40, 147395, 40.9007, 0.713851881370445, -73.8595, -1.28909145887675),
(3801, '10471', 218, 40, 147395, 40.8999, 0.713837918736429, -73.9052, -1.28988907434491),
(3802, '10472', 218, 40, 147395, 40.8296, 0.712610952272277, -73.8699, -1.28927297311896),
(3803, '10473', 218, 40, 147395, 40.8177, 0.712403258091289, -73.8581, -1.28906702426722),
(3804, '10474', 218, 40, 147395, 40.8114, 0.712293302348414, -73.8846, -1.289529536519),
(3805, '10475', 218, 40, 147395, 40.8772, 0.713441728996226, -73.8282, -1.28854517082088),
(3806, '10499', 218, 40, 147395, 40.8271, 0.712567319040977, -73.8233, -1.28845964968753),
(3807, '10501', 218, 40, 146789, 41.2937, 0.720711025330782, -73.7627, -1.28740198016082),
(3808, '10502', 218, 40, 146854, 41.0161, 0.715865991327246, -73.842, -1.28878602625765),
(3809, '10503', 218, 40, 0, 41.0254, 0.716028306947682, -73.8683, -1.28924504785093),
(3810, '10504', 218, 40, 146869, 41.1316, 0.7178818466133, -73.6932, -1.28618897633069),
(3811, '10505', 218, 40, 146976, 41.3421, 0.721555764688748, -73.7439, -1.28707385826145),
(3812, '10506', 218, 40, 146, 41.2001, 0.719077397150916, -73.6405, -1.28526918781488),
(3813, '10507', 218, 40, 99734, 41.2308, 0.719613213231278, -73.6881, -1.28609996453883),
(3814, '10509', 218, 40, 15318, 41.4233, 0.722972972041367, -73.5986, -1.2845378948583),
(3815, '10510', 218, 40, 147356, 41.1454, 0.718122702050075, -73.8355, -1.28867257985627),
(3816, '10511', 218, 40, 15362, 41.2589, 0.720103650751088, -73.9412, -1.29051739287563),
(3817, '10512', 218, 40, 7911, 41.4489, 0.723419776329878, -73.6767, -1.28590099700411),
(3818, '10514', 218, 40, 147719, 41.1708, 0.718566015680081, -73.7702, -1.28753287985472),
(3819, '10516', 218, 40, 1686, 41.4527, 0.723486098841453, -73.9099, -1.28997110481976),
(3820, '10517', 218, 40, 148122, 41.2989, 0.720801782451886, -73.8623, -1.28914032809581),
(3821, '10518', 218, 40, 148128, 41.2687, 0.720274693017784, -73.6007, -1.28457454677259),
(3822, '10519', 218, 40, 148130, 41.3465, 0.721632559175835, -73.6587, -1.28558683773875),
(3823, '10520', 218, 40, 0, 41.2214, 0.719449152281591, -73.8863, -1.28955920711629),
(3824, '10521', 218, 40, 0, 41.2359, 0.71970222502313, -73.9236, -1.29021021492728),
(3825, '10522', 218, 40, 148309, 41.0124, 0.715801414144922, -73.8654, -1.28919443330262),
(3826, '10523', 218, 40, 148671, 41.0533, 0.716515253808988, -73.815, -1.28831478735961),
(3827, '10524', 218, 40, 27246, 41.3674, 0.721997332989502, -73.9213, -1.29017007235448),
(3828, '10526', 218, 40, 149190, 41.2985, 0.720794801134878, -73.6638, -1.2856758495306),
(3829, '10527', 218, 40, 102371, 41.3187, 0.721147357643781, -73.7652, -1.28744561339212),
(3830, '10528', 218, 40, 9353, 40.98, 0.715235927467276, -73.7234, -1.28671606576479),
(3831, '10530', 218, 40, 122787, 41.0226, 0.715979437728626, -73.808, -1.28819261431197),
(3832, '10532', 218, 40, 13124, 41.104, 0.717400135739749, -73.7961, -1.28798492013099),
(3833, '10533', 218, 40, 3366, 41.0412, 0.716304068969497, -73.8539, -1.28899372043864),
(3834, '10535', 218, 40, 22248, 41.3364, 0.721456280921384, -73.7997, -1.28804775198406),
(3835, '10536', 218, 40, 149957, 41.2562, 0.720056526861285, -73.6774, -1.28591321430887),
(3836, '10537', 218, 40, 150132, 41.3371, 0.721468498226148, -73.8857, -1.28954873514077),
(3837, '10538', 218, 40, 14089, 40.9363, 0.714473218584155, -73.7564, -1.28729202441795),
(3838, '10540', 218, 40, 22679, 41.3393, 0.721506895469692, -73.7211, -1.28667592319199),
(3839, '10541', 218, 40, 150471, 41.3783, 0.72218757387797, -73.7518, -1.28721173927235),
(3840, '10542', 218, 40, 150472, 41.3722, 0.722081108793598, -73.7624, -1.28739674417307),
(3841, '10543', 218, 40, 150495, 40.9532, 0.714768179227742, -73.7357, -1.28693074126278),
(3842, '10545', 218, 40, 56117, 41.183, 0.718778945848825, -73.8302, -1.28858007740592),
(3843, '10546', 218, 40, 624, 41.1983, 0.71904598122438, -73.8002, -1.28805647863032),
(3844, '10547', 218, 40, 150802, 41.3157, 0.721094997766221, -73.8495, -1.28891692595155),
(3845, '10548', 218, 40, 4299, 41.2438, 0.719840106034037, -73.9339, -1.29038998384024),
(3846, '10549', 218, 40, 150898, 41.1995, 0.719066925175404, -73.7272, -1.28678238827636),
(3847, '10550', 218, 40, 4411, 40.9077, 0.713974054418084, -73.8343, -1.28865163590525),
(3848, '10551', 218, 40, 4411, 40.9009, 0.713855372028949, -73.8248, -1.28848582962631),
(3849, '10552', 218, 40, 4411, 40.9241, 0.714260288415411, -73.8264, -1.28851375489434),
(3850, '10553', 218, 40, 4411, 40.9083, 0.713984526393596, -73.8219, -1.288435215078),
(3851, '10557', 218, 40, 4411, 40.9092, 0.714000234356864, -73.8469, -1.288871547391),
(3852, '10558', 218, 40, 4411, 40.9121, 0.714050848905172, -73.8376, -1.28870923177057),
(3853, '10560', 218, 40, 30685, 41.3283, 0.721314909251973, -73.6076, -1.28469497449098),
(3854, '10562', 218, 40, 151459, 41.1759, 0.718655027471933, -73.8447, -1.28883315014746),
(3855, '10566', 218, 40, 151618, 41.2846, 0.720552200368851, -73.9172, -1.29009851385515),
(3856, '10567', 218, 40, 0, 41.2778, 0.720433517979715, -73.8749, -1.28936023958156),
(3857, '10570', 218, 40, 14431, 41.1327, 0.717901045235072, -73.7856, -1.28780166055953),
(3858, '10571', 218, 40, 14431, 41.1255, 0.717775381528928, -73.8078, -1.28818912365347),
(3859, '10572', 218, 40, 14431, 41.1349, 0.717939442478616, -73.7948, -1.28796223085071),
(3860, '10573', 218, 40, 151843, 41.0118, 0.71579094216941, -73.6789, -1.28593939424765),
(3861, '10576', 218, 40, 151890, 41.2219, 0.719457878927851, -73.5707, -1.28405094799699),
(3862, '10577', 218, 40, 151934, 41.0429, 0.716333739566781, -73.715, -1.28656945810762),
(3863, '10578', 218, 40, 151935, 41.32, 0.721170046924057, -73.6786, -1.28593415825989),
(3864, '10579', 218, 40, 151942, 41.3921, 0.722428429314745, -73.8431, -1.28880522487942),
(3865, '10580', 218, 40, 11742, 40.9844, 0.715312721954364, -73.6904, -1.28614010711163),
(3866, '10583', 218, 40, 42987, 40.9901, 0.715412205721728, -73.7998, -1.28804949731331),
(3867, '10587', 218, 40, 152521, 41.3274, 0.721299201288705, -73.7387, -1.28698310114034),
(3868, '10588', 218, 40, 152560, 41.3304, 0.721351561166264, -73.8313, -1.28859927602769),
(3869, '10589', 218, 40, 106389, 41.3364, 0.721456280921384, -73.6934, -1.28619246698919),
(3870, '10590', 218, 40, 74362, 41.2523, 0.719988459020457, -73.5411, -1.2835343305384),
(3871, '10591', 218, 40, 18287, 41.0779, 0.716944604804979, -73.8548, -1.28900942840191),
(3872, '10594', 218, 40, 84021, 41.1145, 0.717583395311209, -73.7754, -1.28762363697582),
(3873, '10595', 218, 40, 6494, 41.0908, 0.717169752278486, -73.7779, -1.28766727020712),
(3874, '10596', 218, 40, 153372, 41.2539, 0.720016384288489, -73.9594, -1.29083504279949),
(3875, '10597', 218, 40, 153410, 41.2965, 0.720759894549838, -73.6, -1.28456232946783),
(3876, '10598', 218, 40, 153982, 41.2946, 0.72072673329405, -73.7966, -1.28799364677725),
(3877, '10601', 218, 40, 6780, 41.0317, 0.716138262690557, -73.7651, -1.28744386806287),
(3878, '10602', 218, 40, 6780, 41.0327, 0.716155715983077, -73.7666, -1.28747004800165),
(3879, '10603', 218, 40, 6780, 41.0517, 0.716487328540956, -73.7777, -1.28766377954862),
(3880, '10604', 218, 40, 31490, 41.0416, 0.716311050286505, -73.7493, -1.28716810604105),
(3881, '10605', 218, 40, 6780, 41.009, 0.715742072950355, -73.7478, -1.28714192610227),
(3882, '10606', 218, 40, 6780, 41.0283, 0.71607892149599, -73.7792, -1.2876899594874),
(3883, '10607', 218, 40, 6780, 41.0407, 0.716295342323237, -73.8111, -1.28824671951879),
(3884, '10610', 218, 40, 6780, 41.0227, 0.715981183057878, -73.8135, -1.28828860742083),
(3885, '10650', 218, 40, 6780, 41.0579, 0.71659553895458, -73.7421, -1.28704244233491),
(3886, '10701', 218, 40, 26294, 40.9429, 0.714588410314786, -73.8802, -1.28945274203191),
(3887, '10702', 218, 40, 26294, 40.9306, 0.714373734816791, -73.8994, -1.2897878452483),
(3888, '10703', 218, 40, 26294, 40.9563, 0.714822284434554, -73.8812, -1.28947019532443),
(3889, '10704', 218, 40, 26294, 40.9197, 0.714183493928324, -73.8622, -1.28913858276656),
(3890, '10705', 218, 40, 26294, 40.9184, 0.714160804648048, -73.8919, -1.2896569455544),
(3891, '10706', 218, 40, 0, 40.9887, 0.7153877711122, -73.8739, -1.28934278628904),
(3892, '10707', 218, 40, 57948, 40.9578, 0.714848464373333, -73.8256, -1.28849979226033),
(3893, '10708', 218, 40, 147399, 40.9384, 0.714509870498447, -73.8227, -1.28844917771202),
(3894, '10709', 218, 40, 148565, 40.9537, 0.714776905874002, -73.8079, -1.28819086898272),
(3895, '10710', 218, 40, 26294, 40.9657, 0.714986345384241, -73.8467, -1.2888680567325),
(3896, '10801', 218, 40, 151042, 40.917, 0.71413637003852, -73.7841, -1.28777548062075),
(3897, '10802', 218, 40, 151042, 40.9115, 0.71404037692966, -73.7823, -1.28774406469421),
(3898, '10803', 218, 40, 4936, 40.902, 0.713874570650721, -73.8072, -1.28817865167796),
(3899, '10804', 218, 40, 151042, 40.9495, 0.714703602045418, -73.7855, -1.28779991523028),
(3900, '10805', 218, 40, 151042, 40.9004, 0.713846645382689, -73.781, -1.28772137541394),
(3901, '10901', 218, 40, 152982, 41.127, 0.717801561467708, -74.1107, -1.29347572595776),
(3902, '10910', 218, 40, 7142, 41.3889, 0.722372578778681, -74.1658, -1.29443740237561),
(3903, '10911', 218, 40, 108119, 41.3045, 0.720899520889998, -73.994, -1.29143892672068),
(3904, '10912', 218, 40, 44735, 41.2478, 0.719909919204117, -74.3049, -1.29686515536513),
(3905, '10913', 218, 40, 147240, 41.0634, 0.71669153206344, -73.9607, -1.29085773207977),
(3906, '10914', 218, 40, 933, 41.3822, 0.722255641718797, -74.1797, -1.29468000314164),
(3907, '10915', 218, 40, 147467, 41.5442, 0.725083075107028, -74.3623, -1.29786697435578),
(3908, '10916', 218, 40, 147554, 41.4378, 0.723226044782906, -74.2514, -1.29593140421532),
(3909, '10917', 218, 40, 147705, 41.3304, 0.721351561166264, -74.1319, -1.29384573575918),
(3910, '10918', 218, 40, 8056, 41.3533, 0.721751241564971, -74.2637, -1.29614607971331),
(3911, '10919', 218, 40, 29475, 41.5128, 0.724535041721902, -74.3784, -1.29814797236535),
(3912, '10920', 218, 40, 147985, 41.1485, 0.718176807256887, -73.9434, -1.29055579011918),
(3913, '10921', 218, 40, 16048, 41.3284, 0.721316654581225, -74.3487, -1.29762960957751),
(3914, '10922', 218, 40, 148921, 41.3373, 0.721471988884652, -73.9864, -1.29130628169753),
(3915, '10923', 218, 40, 27243, 41.2037, 0.719140229003988, -74.0024, -1.29158553437785),
(3916, '10924', 218, 40, 419, 41.3947, 0.722473807875297, -74.319, -1.29711124678967),
(3917, '10925', 218, 40, 149312, 41.2202, 0.719428208330567, -74.2934, -1.29666444250116),
(3918, '10926', 218, 40, 87610, 41.3078, 0.720957116755314, -74.1514, -1.29418607496332),
(3919, '10927', 218, 40, 149524, 41.1972, 0.719026782602608, -73.9694, -1.29100957572469),
(3920, '10928', 218, 40, 149614, 41.3661, 0.721974643709226, -73.9703, -1.29102528368796),
(3921, '10930', 218, 40, 21917, 41.3528, 0.721742514918711, -74.1273, -1.29376545061359),
(3922, '10931', 218, 40, 149624, 41.1235, 0.717740474943888, -74.1698, -1.29450721554569),
(3923, '10932', 218, 40, 3254, 41.4792, 0.723948611093232, -74.4657, -1.29967164480234),
(3924, '10933', 218, 40, 364, 41.3659, 0.721971153050722, -74.5072, -1.30039595644192),
(3925, '10940', 218, 40, 14224, 41.4544, 0.723515769438737, -74.4113, -1.29872218568926),
(3926, '10941', 218, 40, 14224, 41.465, 0.723700774339449, -74.4214, -1.29889846394371),
(3927, '10943', 218, 40, 14224, 41.442, 0.72329934861149, -74.4217, -1.29890369993146),
(3928, '10950', 218, 40, 10560, 41.3363, 0.721454535592132, -74.1866, -1.29480043086003),
(3929, '10952', 218, 40, 150814, 41.1164, 0.717616556566997, -74.0775, -1.2928962766461),
(3930, '10953', 218, 40, 128209, 41.4006, 0.722576782301164, -74.0791, -1.29292420191413),
(3931, '10954', 218, 40, 150957, 41.098, 0.71729541598463, -74.0094, -1.29170770742549),
(3932, '10956', 218, 40, 28020, 41.1474, 0.718157608635115, -73.9965, -1.29148255995198),
(3933, '10958', 218, 40, 117003, 41.344, 0.721588925944536, -74.4504, -1.29940460942679),
(3934, '10959', 218, 40, 113788, 41.235, 0.719686517059862, -74.4135, -1.2987605829328),
(3935, '10960', 218, 40, 151316, 41.0925, 0.71719942287577, -73.9303, -1.29032715198716),
(3936, '10962', 218, 40, 82782, 41.0465, 0.716396571419852, -73.9648, -1.2909292905791),
(3937, '10963', 218, 40, 132475, 41.4662, 0.723721718290473, -74.5389, -1.3009492258148),
(3938, '10964', 218, 40, 11056, 41.0105, 0.715768252889134, -73.9231, -1.29020148828102),
(3939, '10965', 218, 40, 42519, 41.063, 0.716684550746432, -74.0201, -1.29189445765545),
(3940, '10968', 218, 40, 42553, 41.0394, 0.716272653042961, -73.9208, -1.29016134570822),
(3941, '10969', 218, 40, 17608, 41.3687, 0.722020022269778, -74.2396, -1.29572545536358),
(3942, '10970', 218, 40, 24061, 41.1864, 0.718838287043392, -74.0453, -1.29233428062696),
(3943, '10973', 218, 40, 79141, 41.3766, 0.722157903280686, -74.4861, -1.30002769196975),
(3944, '10974', 218, 40, 152611, 41.1587, 0.71835483084059, -74.1504, -1.2941686216708),
(3945, '10975', 218, 40, 152792, 41.2576, 0.720080961470812, -74.1725, -1.29455433943549),
(3946, '10976', 218, 40, 152806, 41.0296, 0.716101610776265, -73.9272, -1.29027304678035),
(3947, '10977', 218, 40, 826, 41.1184, 0.717651463152036, -74.044, -1.29231159134668),
(3948, '10979', 218, 40, 152906, 41.1813, 0.718749275251541, -74.3189, -1.29710950146041),
(3949, '10980', 218, 40, 12143, 41.2286, 0.719574815987734, -73.9999, -1.29154190114655),
(3950, '10981', 218, 40, 133302, 41.3217, 0.721199717521341, -74.288, -1.29657019472155),
(3951, '10982', 218, 40, 133352, 41.1055, 0.717426315678529, -74.0983, -1.29325930513051),
(3952, '10983', 218, 40, 111665, 41.0294, 0.716098120117762, -73.9514, -1.29069541645933),
(3953, '10984', 218, 40, 153101, 41.2051, 0.719164663613516, -74.0171, -1.29184209777789),
(3954, '10985', 218, 40, 153106, 41.5805, 0.725716629625502, -74.3638, -1.29789315429456),
(3955, '10986', 218, 40, 153155, 41.2598, 0.720119358714356, -73.9911, -1.29138831217238),
(3956, '10987', 218, 40, 14769, 41.1973, 0.71902852793186, -74.2153, -1.29530134035535),
(3957, '10988', 218, 40, 25657, 41.3019, 0.720854142329446, -74.5626, -1.30136286884752),
(3958, '10989', 218, 40, 153325, 41.1227, 0.717726512309872, -73.9445, -1.29057498874095),
(3959, '10990', 218, 40, 14798, 41.2634, 0.720182190567428, -74.3645, -1.29790537159932),
(3960, '10992', 218, 40, 146572, 41.4258, 0.723016605272667, -74.1593, -1.29432395597423),
(3961, '10993', 218, 40, 153633, 41.2048, 0.719159427625759, -73.9818, -1.29122599655194),
(3962, '10994', 218, 40, 153668, 41.1008, 0.717344285203685, -73.975, -1.29110731416281),
(3963, '10996', 218, 40, 6722, 41.3857, 0.722316728242617, -73.9846, -1.291274865771),
(3964, '10997', 218, 40, 6722, 41.3628, 0.721917047843911, -74.0275, -1.2920236120201),
(3965, '10998', 218, 40, 79401, 41.3234, 0.721229388118625, -74.5464, -1.3010801255087),
(3966, '11001', 218, 40, 113441, 40.722, 0.710732977997131, -73.7047, -1.28638968919466),
(3967, '11002', 218, 40, 113441, 40.7217, 0.710727742009375, -73.7077, -1.28644204907222),
(3968, '11003', 218, 40, 32351, 40.6989, 0.71032980693992, -73.7046, -1.28638794386541),
(3969, '11004', 218, 40, 2736, 40.7461, 0.711153602346862, -73.7109, -1.28649789960829),
(3970, '11005', 218, 40, 113441, 40.7549, 0.711307191321037, -73.7123, -1.28652233421782),
(3971, '11010', 218, 40, 148960, 40.7017, 0.710378676158976, -73.6749, -1.28586958107757),
(3972, '11020', 218, 40, 65163, 40.7853, 0.711837771413643, -73.7256, -1.28675446300833),
(3973, '11021', 218, 40, 65163, 40.7871, 0.711869187340179, -73.7268, -1.28677540695936),
(3974, '11022', 218, 40, 65163, 40.7873, 0.711872677998683, -73.7277, -1.28679111492262),
(3975, '11023', 218, 40, 65163, 40.7987, 0.712071645533411, -73.7346, -1.28691154264101),
(3976, '11024', 218, 40, 65163, 40.8127, 0.71231599162869, -73.7404, -1.28701277173763),
(3977, '11025', 218, 40, 65163, 40.8005, 0.712103061459946, -73.7289, -1.28681205887365),
(3978, '11026', 218, 40, 65163, 40.7873, 0.711872677998683, -73.728, -1.28679635091038),
(3979, '11027', 218, 40, 65163, 40.7995, 0.712085608167427, -73.7365, -1.2869447038968),
(3980, '11030', 218, 40, 150503, 40.7975, 0.712050701582387, -73.6843, -1.28603364202726),
(3981, '11040', 218, 40, 151027, 40.744, 0.71111695043257, -73.6785, -1.28593241293064),
(3982, '11041', 218, 40, 151027, 40.7303, 0.710877840325046, -73.6835, -1.28601967939324),
(3983, '11042', 218, 40, 151027, 40.7583, 0.711366532515605, -73.6979, -1.28627100680553),
(3984, '11043', 218, 40, 151027, 40.7585, 0.711370023174109, -73.693, -1.28618548567218),
(3985, '11044', 218, 40, 151027, 40.7345, 0.71095114415363, -73.6881, -1.28609996453883),
(3986, '11050', 218, 40, 151861, 40.834, 0.712687746759365, -73.6961, -1.28623959087899),
(3987, '11051', 218, 40, 151861, 40.8397, 0.712787230526728, -73.6945, -1.28621166561096),
(3988, '11052', 218, 40, 151861, 40.844, 0.712862279684564, -73.7, -1.28630765871982),
(3989, '11053', 218, 40, 151861, 40.8407, 0.712804683819248, -73.7013, -1.2863303480001),
(3990, '11054', 218, 40, 151861, 40.8309, 0.712633641552553, -73.6842, -1.28603189669801),
(3991, '11055', 218, 40, 151861, 40.8404, 0.712799447831492, -73.7024, -1.28634954662187),
(3992, '11096', 218, 40, 27, 40.6175, 0.708909108928797, -73.7467, -1.2871227274805),
(3993, '11099', 218, 40, 151027, 40.7355, 0.71096859744615, -73.6887, -1.28611043651435),
(3994, '11101', 218, 40, 0, 40.7467, 0.711164074322373, -73.9387, -1.29047375964433),
(3995, '11102', 218, 40, 18949, 40.7712, 0.711591679989112, -73.9254, -1.29024163085382),
(3996, '11103', 218, 40, 18949, 40.7632, 0.711452053648952, -73.9126, -1.29001822870956),
(3997, '11104', 218, 40, 6166, 40.7449, 0.711132658395838, -73.9199, -1.29014563774496),
(3998, '11105', 218, 40, 18949, 40.776, 0.711675455793208, -73.9103, -1.28997808613677),
(3999, '11106', 218, 40, 18949, 40.7609, 0.711411911076157, -73.9325, -1.29036554923071),
(4000, '11109', 218, 40, 0, 40.745, 0.71113440372509, -73.9497, -1.29066574586205),
(4001, '11120', 218, 40, 0, 40.7444, 0.711123931749578, -73.9486, -1.29064654724028),
(4002, '11201', 218, 40, 1157, 40.6952, 0.710265229757596, -73.9909, -1.29138482151387),
(4003, '11202', 218, 40, 1157, 40.6955, 0.710270465745352, -73.9934, -1.29142845474517),
(4004, '11203', 218, 40, 1157, 40.6498, 0.709472850277191, -73.9341, -1.29039347449874),
(4005, '11204', 218, 40, 1157, 40.6186, 0.708928307550569, -73.9859, -1.29129755505127),
(4006, '11205', 218, 40, 1157, 40.6939, 0.71024254047732, -73.9653, -1.29093801722536),
(4007, '11206', 218, 40, 1157, 40.7022, 0.710387402805236, -73.9422, -1.29053484616815),
(4008, '11207', 218, 40, 1157, 40.6708, 0.70983936942011, -73.8962, -1.28973199471223),
(4009, '11208', 218, 40, 1157, 40.6742, 0.709898710614678, -73.8731, -1.28932882365502),
(4010, '11209', 218, 40, 1157, 40.6246, 0.709033027305688, -74.031, -1.29208469854392),
(4011, '11210', 218, 40, 1157, 40.6278, 0.709088877841752, -73.9464, -1.29060814999673),
(4012, '11211', 218, 40, 1157, 40.7119, 0.710556699742679, -73.9526, -1.29071636041036),
(4013, '11212', 218, 40, 1157, 40.6632, 0.709706724396958, -73.9139, -1.29004091798984),
(4014, '11213', 218, 40, 1157, 40.6711, 0.709844605407866, -73.9358, -1.29042314509602),
(4015, '11214', 218, 40, 1157, 40.5994, 0.708593204334186, -73.9969, -1.29148954126899),
(4016, '11215', 218, 40, 1157, 40.6668, 0.70976955625003, -73.9847, -1.29127661110025),
(4017, '11216', 218, 40, 1157, 40.6803, 0.710005175699049, -73.9492, -1.29065701921579),
(4018, '11217', 218, 40, 1157, 40.6825, 0.710043572942593, -73.9799, -1.29119283529615),
(4019, '11218', 218, 40, 1157, 40.6437, 0.709366385192819, -73.9769, -1.29114047541859),
(4020, '11219', 218, 40, 1157, 40.6332, 0.70918312562136, -73.9976, -1.29150175857376),
(4021, '11220', 218, 40, 1157, 40.6395, 0.709293081364236, -74.0153, -1.29181068185136),
(4022, '11221', 218, 40, 1157, 40.692, 0.710209379221533, -73.927, -1.29026955612185),
(4023, '11222', 218, 40, 1157, 40.7261, 0.710804536496463, -73.9458, -1.29059767802122),
(4024, '11223', 218, 40, 1157, 40.5986, 0.70857924170017, -73.9736, -1.29108287955328),
(4025, '11224', 218, 40, 1157, 40.5762, 0.708188287947723, -73.993, -1.29142147342816),
(4026, '11225', 218, 40, 1157, 40.6639, 0.709718941701722, -73.9558, -1.29077221094642),
(4027, '11226', 218, 40, 1157, 40.6461, 0.709408273094867, -73.9567, -1.29078791890969),
(4028, '11228', 218, 40, 1157, 40.6177, 0.708912599587301, -74.0122, -1.29175657664455),
(4029, '11229', 218, 40, 1157, 40.6023, 0.708643818882494, -73.9483, -1.29064131125252),
(4030, '11230', 218, 40, 1157, 40.6227, 0.708999866049901, -73.9652, -1.29093627189611),
(4031, '11231', 218, 40, 1157, 40.6785, 0.709973759772513, -74.0037, -1.29160822365813),
(4032, '11232', 218, 40, 1157, 40.6543, 0.709551390093531, -74.0057, -1.29164313024317),
(4033, '11233', 218, 40, 1157, 40.6722, 0.709863804029638, -73.9234, -1.29020672426878),
(4034, '11234', 218, 40, 1157, 40.619, 0.708935288867577, -73.9224, -1.29018927097626),
(4035, '11235', 218, 40, 1157, 40.5844, 0.708331404946387, -73.9507, -1.29068319915457),
(4036, '11236', 218, 40, 1157, 40.6412, 0.709322751961519, -73.9044, -1.2898751117109),
(4037, '11237', 218, 40, 1157, 40.7028, 0.710397874780748, -73.9206, -1.29015785504972),
(4038, '11238', 218, 40, 1157, 40.6802, 0.710003430369797, -73.9638, -1.29091183728658),
(4039, '11239', 218, 40, 1157, 40.6499, 0.709474595606443, -73.8802, -1.28945274203191),
(4040, '11240', 218, 40, 1157, 40.6221, 0.708989394074389, -73.9945, -1.29144765336694),
(4041, '11241', 218, 40, 1157, 40.6947, 0.710256503111336, -73.9903, -1.29137434953836),
(4042, '11242', 218, 40, 1157, 40.6943, 0.710249521794328, -73.9913, -1.29139180283088),
(4043, '11243', 218, 40, 1157, 40.682, 0.710034846296333, -73.9802, -1.29119807128391),
(4044, '11244', 218, 40, 1157, 40.6823, 0.710040082284089, -73.9802, -1.29119807128391),
(4045, '11245', 218, 40, 1157, 40.6945, 0.710253012452832, -73.9879, -1.29133246163631),
(4046, '11247', 218, 40, 1157, 40.6753, 0.709917909236449, -73.9641, -1.29091707327434),
(4047, '11248', 218, 40, 1157, 40.6995, 0.710340278915432, -73.9928, -1.29141798276966),
(4048, '11249', 218, 40, 1157, 40.75, 0.711221670187689, -73.9983, -1.29151397587852),
(4049, '11251', 218, 40, 1157, 40.7017, 0.710378676158976, -73.9685, -1.29099386776143),
(4050, '11252', 218, 40, 1157, 40.6253, 0.709045244610452, -74.0318, -1.29209866117794),
(4051, '11254', 218, 40, 1157, 40.6983, 0.710319334964408, -73.9921, -1.2914057654649),
(4052, '11255', 218, 40, 1157, 40.6954, 0.7102687204161, -73.9898, -1.2913656228921),
(4053, '11256', 218, 40, 1157, 40.6938, 0.710240795148068, -73.9911, -1.29138831217238),
(4054, '11351', 218, 40, 113299, 40.7816, 0.711773194231319, -73.8322, -1.28861498399096),
(4055, '11352', 218, 40, 113299, 40.751, 0.711239123480209, -73.8219, -1.288435215078),
(4056, '11354', 218, 40, 113299, 40.7688, 0.711549792087064, -73.8268, -1.28852073621135),
(4057, '11355', 218, 40, 113299, 40.7511, 0.711240868809461, -73.8208, -1.28841601645623),
(4058, '11356', 218, 40, 147942, 40.7859, 0.711848243389155, -73.844, -1.28882093284269),
(4059, '11357', 218, 40, 26033, 40.7862, 0.711853479376911, -73.8119, -1.2882606821528),
(4060, '11358', 218, 40, 113299, 40.7606, 0.711406675088401, -73.7959, -1.28798142947248),
(4061, '11359', 218, 40, 25, 40.7918, 0.711951217815023, -73.7779, -1.28766727020712),
(4062, '11360', 218, 40, 25, 40.779, 0.711727815670768, -73.7799, -1.28770217679216),
(4063, '11361', 218, 40, 25, 40.764, 0.711466016282969, -73.7742, -1.2876026930248),
(4064, '11362', 218, 40, 125252, 40.7603, 0.711401439100645, -73.7335, -1.28689234401924),
(4065, '11363', 218, 40, 125252, 40.7723, 0.711610878610884, -73.7467, -1.2871227274805),
(4066, '11364', 218, 40, 113857, 40.7467, 0.711164074322373, -73.7606, -1.28736532824653),
(4067, '11365', 218, 40, 35999, 40.7389, 0.711027938640718, -73.7917, -1.2879081256439),
(4068, '11366', 218, 40, 35999, 40.7277, 0.710832461764495, -73.797, -1.28800062809426),
(4069, '11367', 218, 40, 113299, 40.7301, 0.710874349666542, -73.8194, -1.2883915818467),
(4070, '11368', 218, 40, 1779, 40.752, 0.711256576772729, -73.8537, -1.28899022978014),
(4071, '11369', 218, 40, 148440, 40.7621, 0.711432855027181, -73.8734, -1.28933405964278),
(4072, '11370', 218, 40, 148440, 40.7632, 0.711452053648952, -73.8918, -1.28965520022515),
(4073, '11371', 218, 40, 113299, 40.7743, 0.711645785195924, -73.8745, -1.28935325826455),
(4074, '11372', 218, 40, 3386, 40.7512, 0.711242614138713, -73.8838, -1.28951557388499),
(4075, '11373', 218, 40, 13723, 40.7369, 0.710993032055678, -73.8796, -1.2894422700564),
(4076, '11374', 218, 40, 152035, 40.7257, 0.710797555179455, -73.862, -1.28913509210805),
(4077, '11375', 218, 40, 2525, 40.7197, 0.710692835424335, -73.8461, -1.28885758475698),
(4078, '11377', 218, 40, 14913, 40.7442, 0.711120441091074, -73.9053, -1.28989081967417),
(4079, '11378', 218, 40, 150601, 40.7243, 0.710773120569927, -73.9042, -1.28987162105239),
(4080, '11379', 218, 40, 132084, 40.7173, 0.710650947522287, -73.8835, -1.28951033789723),
(4081, '11380', 218, 40, 13723, 40.7436, 0.711109969115562, -73.884, -1.28951906454349),
(4082, '11381', 218, 40, 113299, 40.7156, 0.710621276925003, -73.8801, -1.28945099670266),
(4083, '11385', 218, 40, 5393, 40.7038, 0.710415328073268, -73.8914, -1.28964821890814),
(4084, '11386', 218, 40, 5393, 40.7011, 0.710368204183464, -73.8971, -1.2897477026755),
(4085, '11390', 218, 40, 113299, 40.7861, 0.711851734047659, -73.8137, -1.28829209807934),
(4086, '11405', 218, 40, 22217, 40.6987, 0.710326316281416, -73.7873, -1.28783133115681),
(4087, '11411', 218, 40, 147536, 40.6946, 0.710254757782084, -73.7385, -1.28697961048184),
(4088, '11412', 218, 40, 57331, 40.6972, 0.710300136342636, -73.7599, -1.28735311094177),
(4089, '11413', 218, 40, 152841, 40.6724, 0.709867294688142, -73.7528, -1.28722919256487),
(4090, '11414', 218, 40, 149722, 40.6597, 0.709645637873138, -73.8434, -1.28881046086718),
(4091, '11415', 218, 40, 150008, 40.707, 0.710471178609332, -73.8294, -1.2885661147719),
(4092, '11416', 218, 40, 151512, 40.6842, 0.710073243539877, -73.8518, -1.28895706852435),
(4093, '11417', 218, 40, 151512, 40.6766, 0.709940598516725, -73.8462, -1.28885933008624),
(4094, '11418', 218, 40, 24309, 40.698, 0.710314098976652, -73.833, -1.28862894662497),
(4095, '11419', 218, 40, 0, 40.6885, 0.710148292697713, -73.8228, -1.28845092304127),
(4096, '11420', 218, 40, 152755, 40.6735, 0.709886493309914, -73.8164, -1.28833922196914),
(4097, '11421', 218, 40, 6916, 40.6912, 0.710195416587517, -73.8585, -1.28907400558423),
(4098, '11422', 218, 40, 5546, 40.6636, 0.709713705713966, -73.7367, -1.2869481945553),
(4099, '11423', 218, 40, 9537, 40.715, 0.710610804949491, -73.7685, -1.28750320925744),
(4100, '11424', 218, 40, 22217, 40.7093, 0.710511321182128, -73.8292, -1.2885626241134),
(4101, '11425', 218, 40, 22217, 40.6766, 0.709940598516725, -73.7735, -1.28759047572004),
(4102, '11426', 218, 40, 147118, 40.7342, 0.710945908165874, -73.7215, -1.286682904509),
(4103, '11427', 218, 40, 151958, 40.7286, 0.710848169727763, -73.7487, -1.28715763406554),
(4104, '11428', 218, 40, 151958, 40.7201, 0.710699816741343, -73.7444, -1.28708258490771),
(4105, '11429', 218, 40, 151958, 40.7094, 0.71051306651138, -73.7403, -1.28701102640837),
(4106, '11430', 218, 40, 22217, 40.6624, 0.709692761762942, -73.8086, -1.28820308628749),
(4107, '11431', 218, 40, 22217, 40.7153, 0.710616040937247, -73.7937, -1.28794303222894),
(4108, '11432', 218, 40, 22217, 40.7142, 0.710596842315475, -73.7943, -1.28795350420445),
(4109, '11433', 218, 40, 22217, 40.6972, 0.710300136342636, -73.7895, -1.28786972840036),
(4110, '11434', 218, 40, 22217, 40.6764, 0.709937107858222, -73.777, -1.28765156224386),
(4111, '11435', 218, 40, 22217, 40.6992, 0.710335042927676, -73.8104, -1.28823450221402),
(4112, '11436', 218, 40, 22217, 40.6762, 0.709933617199717, -73.7967, -1.2879953921065),
(4113, '11439', 218, 40, 22217, 40.72, 0.710698071412091, -73.7907, -1.28789067235138),
(4114, '11451', 218, 40, 22217, 40.7007, 0.710361222866456, -73.7999, -1.28805124264256),
(4115, '11484', 218, 40, 22217, 40.6627, 0.709697997750698, -73.7365, -1.2869447038968),
(4116, '11499', 218, 40, 22217, 40.648, 0.709441434350655, -73.7871, -1.28782784049831),
(4117, '11501', 218, 40, 4236, 40.7464, 0.711158838334618, -73.6403, -1.28526569715638),
(4118, '11507', 218, 40, 13268, 40.7706, 0.7115812080136, -73.6516, -1.28546291936186),
(4119, '11509', 218, 40, 15047, 40.5891, 0.70841343542123, -73.7273, -1.28678413360562),
(4120, '11510', 218, 40, 722, 40.6563, 0.709586296678571, -73.6093, -1.28472464508826),
(4121, '11514', 218, 40, 147594, 40.7501, 0.711223415516941, -73.6125, -1.28478049562433),
(4122, '11516', 218, 40, 45551, 40.6244, 0.709029536647184, -73.7222, -1.28669512181376),
(4123, '11518', 218, 40, 148527, 40.6388, 0.709280864059472, -73.6675, -1.28574042671292),
(4124, '11520', 218, 40, 16142, 40.6536, 0.709539172788767, -73.5857, -1.28431274738479),
(4125, '11530', 218, 40, 2657, 40.7258, 0.710799300508707, -73.642, -1.28529536775366),
(4126, '11531', 218, 40, 2657, 40.7236, 0.710760903265163, -73.6331, -1.28514003345024),
(4127, '11535', 218, 40, 2657, 40.7238, 0.710764393923667, -73.6337, -1.28515050542575),
(4128, '11536', 218, 40, 2657, 40.7257, 0.710797555179455, -73.645, -1.28534772763122),
(4129, '11542', 218, 40, 47449, 40.8654, 0.713235780144491, -73.6256, -1.28500913375634),
(4130, '11545', 218, 40, 149147, 40.824, 0.712513213834165, -73.5956, -1.28448553498074),
(4131, '11547', 218, 40, 149181, 40.8278, 0.712579536345741, -73.643, -1.28531282104618),
(4132, '11548', 218, 40, 87458, 40.8127, 0.71231599162869, -73.6252, -1.28500215243933),
(4133, '11549', 218, 40, 94830, 40.7065, 0.710462451963072, -73.6188, -1.2848904513672),
(4134, '11550', 218, 40, 94830, 40.7027, 0.710396129451496, -73.6182, -1.28487997939169),
(4135, '11551', 218, 40, 94830, 40.7051, 0.710438017353544, -73.628, -1.28505102165839),
(4136, '11552', 218, 40, 153635, 40.6964, 0.71028617370862, -73.6436, -1.2853232930217),
(4137, '11553', 218, 40, 123867, 40.7016, 0.710376930829724, -73.5912, -1.28440874049365),
(4138, '11554', 218, 40, 148493, 40.7129, 0.710574153035199, -73.5557, -1.28378914860919),
(4139, '11555', 218, 40, 123867, 40.709, 0.710506085194372, -73.5932, -1.28444364707869),
(4140, '11556', 218, 40, 123867, 40.7015, 0.710375185500472, -73.6174, -1.28486601675767),
(4141, '11557', 218, 40, 102751, 40.6401, 0.709303553339747, -73.6934, -1.28619246698919),
(4142, '11558', 218, 40, 122876, 40.605, 0.708690942772297, -73.6551, -1.28552400588568),
(4143, '11559', 218, 40, 3696, 40.6129, 0.708828823783205, -73.7303, -1.28683649348318),
(4144, '11560', 218, 40, 49022, 40.8805, 0.713499324861542, -73.5928, -1.28443666576168),
(4145, '11561', 218, 40, 49041, 40.5882, 0.708397727457962, -73.6565, -1.2855484404952),
(4146, '11563', 218, 40, 103881, 40.6571, 0.709600259312587, -73.6731, -1.28583816515103),
(4147, '11564', 218, 40, 103881, 40.6589, 0.709631675239123, -73.6742, -1.28585736377281),
(4148, '11565', 218, 40, 150492, 40.6749, 0.709910927919442, -73.6743, -1.28585910910206),
(4149, '11566', 218, 40, 33257, 40.6703, 0.70983064277385, -73.5546, -1.28376994998742),
(4150, '11568', 218, 40, 151378, 40.7824, 0.711787156865335, -73.6029, -1.28461294401613),
(4151, '11569', 218, 40, 105362, 40.5911, 0.70844834200627, -73.5807, -1.28422548092219),
(4152, '11570', 218, 40, 152174, 40.6651, 0.709739885652746, -73.6382, -1.28522904524209),
(4153, '11571', 218, 40, 152174, 40.6561, 0.709582806020067, -73.6468, -1.28537914355776),
(4154, '11572', 218, 40, 151350, 40.6363, 0.709237230828172, -73.639, -1.2852430078761),
(4155, '11575', 218, 40, 5534, 40.6783, 0.709970269114009, -73.5899, -1.28438605121338),
(4156, '11576', 218, 40, 28468, 40.7955, 0.712015794997347, -73.6471, -1.28538437954552),
(4157, '11577', 218, 40, 152227, 40.7845, 0.711823808779627, -73.64, -1.28526046116862),
(4158, '11579', 218, 40, 152445, 40.8446, 0.712872751660076, -73.6434, -1.28531980236319),
(4159, '11580', 218, 40, 52347, 40.6741, 0.709896965285426, -73.7058, -1.28640888781644),
(4160, '11581', 218, 40, 52347, 40.6522, 0.709514738179239, -73.7118, -1.28651360757156),
(4161, '11582', 218, 40, 52347, 40.662, 0.709685780445934, -73.7031, -1.28636176392663),
(4162, '11583', 218, 40, 52347, 40.6647, 0.709732904335738, -73.7052, -1.28639841584092),
(4163, '11588', 218, 40, 123867, 40.7026, 0.710394384122244, -73.5916, -1.28441572181066),
(4164, '11590', 218, 40, 25938, 40.7563, 0.711331625930565, -73.5769, -1.28415915841062),
(4165, '11592', 218, 40, 152174, 40.6638, 0.70971719637247, -73.6386, -1.2852360265591),
(4166, '11593', 218, 40, 25938, 40.7562, 0.711329880601313, -73.5869, -1.28433369133582),
(4167, '11594', 218, 40, 25938, 40.7553, 0.711314172638045, -73.5876, -1.28434590864058),
(4168, '11595', 218, 40, 25938, 40.7572, 0.711347333893833, -73.5731, -1.28409283589904),
(4169, '11596', 218, 40, 153829, 40.7586, 0.711371768503361, -73.6427, -1.28530758505843),
(4170, '11597', 218, 40, 25938, 40.7634, 0.711455544307457, -73.5235, -1.28322715259005),
(4171, '11598', 218, 40, 18667, 40.6327, 0.7091743989751, -73.7137, -1.28654676882734),
(4172, '11599', 218, 40, 2657, 40.7276, 0.710830716435243, -73.6314, -1.28511036285295),
(4173, '11690', 218, 40, 148747, 40.6013, 0.708626365589974, -73.7632, -1.28741070680708),
(4174, '11691', 218, 40, 148747, 40.6008, 0.708617638943714, -73.7602, -1.28735834692952),
(4175, '11692', 218, 40, 146880, 40.5926, 0.70847452194505, -73.7954, -1.28797270282622),
(4176, '11693', 218, 40, 148747, 40.591, 0.708446596677018, -73.8128, -1.28827639011607),
(4177, '11694', 218, 40, 152163, 40.5779, 0.708217958545007, -73.8436, -1.28881395152568),
(4178, '11695', 218, 40, 148747, 40.5583, 0.707875874011616, -73.9129, -1.29002346469732),
(4179, '11697', 218, 40, 45029, 40.5603, 0.707910780596656, -73.9153, -1.29006535259936),
(4180, '11701', 218, 40, 146806, 40.6866, 0.710115131441925, -73.4115, -1.28127238382782),
(4181, '11702', 218, 40, 118698, 40.6948, 0.710258248440588, -73.3251, -1.27976441935409),
(4182, '11703', 218, 40, 151131, 40.7335, 0.71093369086111, -73.3203, -1.27968064355),
(4183, '11704', 218, 40, 153565, 40.7173, 0.710650947522287, -73.3581, -1.28034037800725),
(4184, '11705', 218, 40, 15140, 40.7431, 0.711101242469302, -73.0543, -1.27503806773969),
(4185, '11706', 218, 40, 70505, 40.7339, 0.710940672178118, -73.2568, -1.27857235947498),
(4186, '11707', 218, 40, 153565, 40.8009, 0.712110042776954, -73.2439, -1.27834721200147),
(4187, '11708', 218, 40, 146806, 40.6703, 0.70983064277385, -73.4164, -1.28135790496117),
(4188, '11709', 218, 40, 13338, 40.9069, 0.713960091784068, -73.5592, -1.28385023513301),
(4189, '11710', 218, 40, 29190, 40.6767, 0.709942343845977, -73.5365, -1.28345404539281),
(4190, '11713', 218, 40, 147127, 40.7696, 0.71156375472108, -72.9448, -1.27312693220876),
(4191, '11714', 218, 40, 53458, 40.7393, 0.711034919957726, -73.4873, -1.28259534340083),
(4192, '11715', 218, 40, 26553, 40.7477, 0.711181527614894, -73.0377, -1.27474834308386),
(4193, '11716', 218, 40, 15279, 40.7696, 0.71156375472108, -73.1119, -1.27604337738884),
(4194, '11717', 218, 40, 1106, 40.7817, 0.711774939560571, -73.2438, -1.27834546667222),
(4195, '11718', 218, 40, 147375, 40.7199, 0.710696326082839, -73.2668, -1.27874689240018);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(4196, '11719', 218, 40, 13445, 40.7768, 0.711689418427224, -72.9157, -1.27261904139643),
(4197, '11720', 218, 40, 147691, 40.8681, 0.713282904034295, -73.0852, -1.27557737447856),
(4198, '11721', 218, 40, 147692, 40.8909, 0.713680839103749, -73.3739, -1.28061614002907),
(4199, '11722', 218, 40, 147701, 40.7868, 0.711863951352423, -73.1985, -1.27755483252107),
(4200, '11724', 218, 40, 147923, 40.868, 0.713281158705043, -73.4513, -1.28196702487011),
(4201, '11725', 218, 40, 147968, 40.8419, 0.712825627770272, -73.2806, -1.27898774783696),
(4202, '11726', 218, 40, 148031, 40.6809, 0.710015647674561, -73.3952, -1.28098789515974),
(4203, '11727', 218, 40, 148033, 40.8848, 0.713574374019378, -73.0059, -1.27419332838173),
(4204, '11729', 218, 40, 2011, 40.7614, 0.711420637722417, -73.3277, -1.27980979791465),
(4205, '11730', 218, 40, 148476, 40.7316, 0.710900529605322, -73.183, -1.27728430648701),
(4206, '11731', 218, 40, 127368, 40.8658, 0.713242761461499, -73.3174, -1.27963002900169),
(4207, '11732', 218, 40, 148503, 40.8441, 0.712864025013816, -73.5365, -1.28345404539281),
(4208, '11733', 218, 40, 148534, 40.9331, 0.714417368048091, -73.1074, -1.2759648375725),
(4209, '11735', 218, 40, 27149, 40.7238, 0.710764393923667, -73.4517, -1.28197400618712),
(4210, '11736', 218, 40, 27149, 40.7319, 0.710905765593078, -73.4456, -1.28186754110275),
(4211, '11737', 218, 40, 27149, 40.7335, 0.71093369086111, -73.448, -1.2819094290048),
(4212, '11738', 218, 40, 148761, 40.8361, 0.712724398673656, -73.0432, -1.27484433619272),
(4213, '11739', 218, 40, 149257, 40.7258, 0.710799300508707, -73.1596, -1.27687589944204),
(4214, '11740', 218, 40, 47690, 40.8591, 0.713125824401615, -73.3625, -1.28041717249434),
(4215, '11741', 218, 40, 21986, 40.7988, 0.712073390862663, -73.0756, -1.27540982287037),
(4216, '11742', 218, 40, 87929, 40.8126, 0.712314246299438, -73.0436, -1.27485131750973),
(4217, '11743', 218, 40, 9621, 40.8669, 0.713261960083271, -73.4099, -1.28124445855979),
(4218, '11745', 218, 40, 5923, 40.8553, 0.713059501890039, -73.2011, -1.27760021108162),
(4219, '11746', 218, 40, 149769, 40.819, 0.712425947371565, -73.3685, -1.28052189224946),
(4220, '11747', 218, 40, 27871, 40.7934, 0.711979143083055, -73.4, -1.28107167096384),
(4221, '11749', 218, 40, 16564, 40.8311, 0.712637132211057, -73.0304, -1.27462093404847),
(4222, '11750', 218, 40, 149769, 40.8449, 0.712877987647832, -73.4051, -1.28116068275569),
(4223, '11751', 218, 40, 149850, 40.7338, 0.710938926848866, -73.2149, -1.2778410665184),
(4224, '11752', 218, 40, 149851, 40.754, 0.711291483357769, -73.1831, -1.27728605181626),
(4225, '11753', 218, 40, 3419, 40.7879, 0.711883149974195, -73.5368, -1.28345928138057),
(4226, '11754', 218, 40, 731, 40.8845, 0.713569138031622, -73.2429, -1.27832975870895),
(4227, '11755', 218, 40, 16786, 40.8568, 0.713085681828819, -73.1155, -1.27610620924191),
(4228, '11756', 218, 40, 150238, 40.7257, 0.710797555179455, -73.5163, -1.28310148888391),
(4229, '11757', 218, 40, 120369, 40.6902, 0.710177963294997, -73.3742, -1.28062137601682),
(4230, '11758', 218, 40, 150602, 40.6824, 0.710041827613341, -73.4575, -1.28207523528373),
(4231, '11760', 218, 40, 16564, 40.8171, 0.712392786115778, -73.2124, -1.2777974332871),
(4232, '11762', 218, 40, 150604, 40.6833, 0.710057535576609, -73.4474, -1.28189895702928),
(4233, '11763', 218, 40, 49404, 40.8194, 0.712432928688573, -72.9847, -1.27382331858031),
(4234, '11764', 218, 40, 150748, 40.9473, 0.714665204801874, -72.9924, -1.27395770893271),
(4235, '11765', 218, 40, 112461, 40.868, 0.713281158705043, -73.5656, -1.28396193620514),
(4236, '11766', 218, 40, 4406, 40.9299, 0.714361517512027, -73.0144, -1.27434168136815),
(4237, '11767', 218, 40, 150989, 40.8431, 0.712846571721296, -73.1473, -1.27666122394405),
(4238, '11768', 218, 40, 4635, 40.9047, 0.713921694540524, -73.3273, -1.27980281659764),
(4239, '11769', 218, 40, 4701, 40.738, 0.71101223067745, -73.1307, -1.27637149928822),
(4240, '11770', 218, 40, 71203, 40.6474, 0.709430962375143, -73.153, -1.27676070771141),
(4241, '11771', 218, 40, 4830, 40.8642, 0.713214836193467, -73.5241, -1.28323762456556),
(4242, '11772', 218, 40, 151585, 40.7703, 0.711575972025844, -73.001, -1.27410780724838),
(4243, '11773', 218, 40, 153043, 40.8266, 0.712558592394717, -73.5023, -1.28285714278863),
(4244, '11774', 218, 40, 27149, 40.7277, 0.710832461764495, -73.4441, -1.28184136116397),
(4245, '11775', 218, 40, 27871, 40.7909, 0.711935509851755, -73.4161, -1.28135266897341),
(4246, '11776', 218, 40, 151852, 40.9122, 0.714052594234424, -73.0476, -1.27492113067981),
(4247, '11777', 218, 40, 151851, 40.9465, 0.714651242167858, -73.0608, -1.27515151414107),
(4248, '11778', 218, 40, 5490, 40.9526, 0.71475770725223, -72.9395, -1.2730344297584),
(4249, '11779', 218, 40, 152195, 40.825, 0.712530667126685, -73.1166, -1.27612540786369),
(4250, '11780', 218, 40, 11756, 40.8813, 0.713513287495558, -73.1585, -1.27685670082027),
(4251, '11782', 218, 40, 152387, 40.7326, 0.710917982897842, -73.081, -1.27550407064998),
(4252, '11783', 218, 40, 14571, 40.6798, 0.709996449052789, -73.4918, -1.28267388321717),
(4253, '11784', 218, 40, 97961, 40.8703, 0.713321301277838, -73.0416, -1.27481641092469),
(4254, '11786', 218, 40, 133109, 40.9489, 0.714693130069906, -72.8946, -1.27225077692426),
(4255, '11787', 218, 40, 5923, 40.8528, 0.713015868658739, -73.2091, -1.27773983742178),
(4256, '11788', 218, 40, 149520, 40.8165, 0.712382314140265, -73.2125, -1.27779917861635),
(4257, '11789', 218, 40, 152664, 40.9552, 0.714803085812782, -72.9784, -1.27371336283743),
(4258, '11790', 218, 40, 152955, 40.9051, 0.713928675857533, -73.128, -1.27632437539841),
(4259, '11791', 218, 40, 153043, 40.8169, 0.712389295457273, -73.5037, -1.28288157739816),
(4260, '11792', 218, 40, 71513, 40.9538, 0.714778651203254, -72.8409, -1.27131353511594),
(4261, '11793', 218, 40, 153451, 40.6861, 0.710106404795665, -73.5109, -1.2830072411043),
(4262, '11794', 218, 40, 152955, 40.9043, 0.713914713223517, -73.1266, -1.27629994078889),
(4263, '11795', 218, 40, 153642, 40.7097, 0.710518302499136, -73.2992, -1.27931237907783),
(4264, '11796', 218, 40, 153690, 40.735, 0.71095987079989, -73.1015, -1.27586186314663),
(4265, '11797', 218, 40, 362, 40.815, 0.712356134201486, -73.4699, -1.28229165611098),
(4266, '11798', 218, 40, 153953, 40.7534, 0.711281011382257, -73.3664, -1.28048524033517),
(4267, '11801', 218, 40, 9478, 40.7646, 0.711476488258481, -73.5188, -1.28314512211521),
(4268, '11802', 218, 40, 9478, 40.7671, 0.71152012148978, -73.5331, -1.28339470419824),
(4269, '11803', 218, 40, 5102, 40.7784, 0.711717343695256, -73.4792, -1.28245397173142),
(4270, '11804', 218, 40, 89640, 40.766, 0.711500922868008, -73.4569, -1.28206476330822),
(4271, '11805', 218, 40, 0, 40.7643, 0.711471252270725, -73.5254, -1.28326031384584),
(4272, '11815', 218, 40, 9478, 40.7662, 0.711504413526512, -73.5133, -1.28304912900635),
(4273, '11819', 218, 40, 9478, 40.766, 0.711500922868008, -73.5297, -1.28333536300367),
(4274, '11853', 218, 40, 3419, 40.7881, 0.711886640632699, -73.5421, -1.28355178383092),
(4275, '11854', 218, 40, 9478, 40.7532, 0.711277520723753, -73.5042, -1.28289030404442),
(4276, '11855', 218, 40, 9478, 40.762, 0.711431109697929, -73.5241, -1.28323762456556),
(4277, '11901', 218, 40, 152125, 40.9267, 0.714305666975963, -72.653, -1.26803406145144),
(4278, '11930', 218, 40, 146788, 40.9759, 0.715164368967945, -72.1335, -1.25896707598733),
(4279, '11931', 218, 40, 146841, 40.9487, 0.714689639411402, -72.5994, -1.26709856497237),
(4280, '11932', 218, 40, 147359, 40.96, 0.714886861616877, -72.3051, -1.26196206098375),
(4281, '11933', 218, 40, 45326, 40.9261, 0.714295195000451, -72.7481, -1.26969386957009),
(4282, '11934', 218, 40, 147688, 40.7974, 0.712048956253135, -72.7956, -1.27052290096478),
(4283, '11935', 218, 40, 148161, 41.0129, 0.715810140791182, -72.4742, -1.26491341274887),
(4284, '11937', 218, 40, 2169, 41.0013, 0.715607682597951, -72.1811, -1.25979785271128),
(4285, '11939', 218, 40, 64359, 41.1283, 0.717824250747984, -72.3426, -1.26261655945325),
(4286, '11940', 218, 40, 148497, 40.8085, 0.712242687800106, -72.7531, -1.26978113603269),
(4287, '11941', 218, 40, 8671, 40.8308, 0.712631896223301, -72.7314, -1.269402399585),
(4288, '11942', 218, 40, 148520, 40.8493, 0.71295478213492, -72.5749, -1.26667095930563),
(4289, '11944', 218, 40, 149290, 41.1036, 0.717393154422741, -72.3695, -1.26308605302204),
(4290, '11946', 218, 40, 149425, 40.875, 0.713403331752682, -72.5173, -1.26566564965648),
(4291, '11947', 218, 40, 55539, 40.9439, 0.714605863607306, -72.5831, -1.2668140763043),
(4292, '11948', 218, 40, 14092, 40.9655, 0.714982854725737, -72.5481, -1.2662032110661),
(4293, '11949', 218, 40, 150524, 40.8541, 0.713038557939015, -72.791, -1.27044261581919),
(4294, '11950', 218, 40, 150609, 40.8073, 0.712221743849082, -72.8434, -1.27135716834724),
(4295, '11951', 218, 40, 150610, 40.764, 0.711466016282969, -72.8457, -1.27139731092003),
(4296, '11952', 218, 40, 150612, 40.9947, 0.715492490867319, -72.5372, -1.26601297017763),
(4297, '11953', 218, 40, 150707, 40.8785, 0.713464418276502, -72.9542, -1.27329099315845),
(4298, '11954', 218, 40, 56342, 41.0428, 0.716331994237529, -71.9495, -1.25575567016366),
(4299, '11955', 218, 40, 150858, 40.8046, 0.712174619959278, -72.8231, -1.27100286650908),
(4300, '11956', 218, 40, 151052, 40.9933, 0.715468056257791, -72.4763, -1.26495006466317),
(4301, '11957', 218, 40, 28156, 41.1467, 0.718145391330351, -72.2772, -1.26147511412245),
(4302, '11958', 218, 40, 151615, 41.0424, 0.716325012920521, -72.4593, -1.26465335869033),
(4303, '11959', 218, 40, 151965, 40.822, 0.712478307249125, -72.6021, -1.26714568886218),
(4304, '11960', 218, 40, 152040, 40.8103, 0.712274103726642, -72.6967, -1.26879677033456),
(4305, '11961', 218, 40, 5385, 40.9064, 0.713951365137808, -72.8779, -1.27195930693918),
(4306, '11962', 218, 40, 152288, 40.9517, 0.714741999288962, -72.2861, -1.26163044842587),
(4307, '11963', 218, 40, 152286, 41.0022, 0.715623390561219, -72.3163, -1.26215753785998),
(4308, '11964', 218, 40, 152517, 41.0673, 0.716759599904267, -72.3376, -1.26252929299065),
(4309, '11965', 218, 40, 152518, 41.071, 0.716824177086591, -72.355, -1.2628329802805),
(4310, '11967', 218, 40, 5825, 40.7939, 0.711987869729315, -72.8684, -1.27179350066024),
(4311, '11968', 218, 40, 51571, 40.9055, 0.713935657174541, -72.411, -1.26381036466161),
(4312, '11969', 218, 40, 51571, 40.9687, 0.715038705261801, -72.358, -1.26288534015806),
(4313, '11970', 218, 40, 152735, 40.9369, 0.714483690559667, -72.5778, -1.26672157385394),
(4314, '11971', 218, 40, 152793, 41.0559, 0.71656063236954, -72.4172, -1.26391857507524),
(4315, '11972', 218, 40, 152823, 40.8206, 0.712453872639597, -72.7072, -1.26898002990602),
(4316, '11973', 218, 40, 6489, 40.852, 0.713001906024723, -72.8868, -1.2721146412426),
(4317, '11975', 218, 40, 153420, 40.9529, 0.714762943239986, -72.2514, -1.26102481917543),
(4318, '11976', 218, 40, 153479, 40.9294, 0.714352790865767, -72.3517, -1.26277538441518),
(4319, '11977', 218, 40, 107467, 40.8196, 0.712436419347077, -72.666, -1.2682609542542),
(4320, '11978', 218, 40, 153735, 40.8142, 0.71234217156747, -72.6453, -1.26789967109904),
(4321, '11980', 218, 40, 153973, 40.8387, 0.712769777234208, -72.9314, -1.27289305808899),
(4322, '12007', 218, 40, 146736, 42.749, 0.746110801935056, -73.7981, -1.28801982671603),
(4323, '12008', 218, 40, 146779, 42.8547, 0.747955614954414, -73.9021, -1.2898349691381),
(4324, '12009', 218, 40, 26361, 42.6975, 0.745211957370279, -74.0225, -1.2919363455575),
(4325, '12010', 218, 40, 18842, 42.9419, 0.749477542062153, -74.1915, -1.29488595199337),
(4326, '12015', 218, 40, 7182, 42.2635, 0.737637228416623, -73.8123, -1.28826766346981),
(4327, '12016', 218, 40, 146924, 42.9293, 0.749257630576402, -74.3167, -1.29707110421687),
(4328, '12017', 218, 40, 34623, 42.3162, 0.738557016932424, -73.4543, -1.28201938474767),
(4329, '12018', 218, 40, 146930, 42.6133, 0.7437423901401, -73.5817, -1.28424293421471),
(4330, '12019', 218, 40, 146982, 42.9213, 0.749118004236242, -73.8548, -1.28900942840191),
(4331, '12020', 218, 40, 146983, 43.0069, 0.750612006075949, -73.8606, -1.28911065749852),
(4332, '12022', 218, 40, 376, 42.6936, 0.745143889529451, -73.3696, -1.28054109087123),
(4333, '12023', 218, 40, 113160, 42.5994, 0.743499789374072, -74.1222, -1.29367643882174),
(4334, '12024', 218, 40, 34958, 42.4035, 0.740080689369416, -73.6105, -1.28474558903929),
(4335, '12025', 218, 40, 147384, 43.0602, 0.751542266567262, -74.198, -1.29499939839475),
(4336, '12027', 218, 40, 147488, 42.9163, 0.749030737773642, -73.9021, -1.2898349691381),
(4337, '12028', 218, 40, 35081, 42.9609, 0.749809154620032, -73.4503, -1.28194957157759),
(4338, '12029', 218, 40, 306, 42.3939, 0.739913137761224, -73.403, -1.2811240308414),
(4339, '12031', 218, 40, 1358, 42.7481, 0.746095093971788, -74.4565, -1.29951107451116),
(4340, '12032', 218, 40, 177370, 43.1679, 0.75342198617166, -74.5031, -1.30032439794259),
(4341, '12033', 218, 40, 0, 42.5389, 0.742443865176616, -73.7076, -1.28644030374297),
(4342, '12035', 218, 40, 147700, 42.7161, 0.74553658861115, -74.3578, -1.29778843453944),
(4343, '12036', 218, 40, 19947, 42.5402, 0.742466554456892, -74.6559, -1.30299126103963),
(4344, '12037', 218, 40, 13522, 42.3574, 0.739276092584246, -73.5858, -1.28431449271404),
(4345, '12040', 218, 40, 0, 42.6352, 0.744124617246286, -73.3548, -1.28028278214194),
(4346, '12041', 218, 40, 848, 42.561, 0.742829582941307, -73.9795, -1.29118585397915),
(4347, '12042', 218, 40, 20102, 42.3747, 0.739578034544841, -73.8652, -1.28919094264412),
(4348, '12043', 218, 40, 147901, 42.6806, 0.744916996726692, -74.4863, -1.30003118262825),
(4349, '12045', 218, 40, 147906, 42.4733, 0.741298929187308, -73.795, -1.28796572150922),
(4350, '12046', 218, 40, 147910, 42.4876, 0.741548511270343, -73.9266, -1.29026257480484),
(4351, '12047', 218, 40, 147913, 42.7734, 0.746536662272543, -73.7148, -1.28656596744912),
(4352, '12050', 218, 40, 130308, 42.3172, 0.738574470224944, -73.7491, -1.28716461538255),
(4353, '12051', 218, 40, 148087, 42.3561, 0.73925340330397, -73.8068, -1.28817167036095),
(4354, '12052', 218, 40, 148125, 42.5471, 0.742586982175279, -73.6906, -1.28614359777013),
(4355, '12053', 218, 40, 148246, 42.744, 0.746023535472456, -74.1892, -1.29484580942058),
(4356, '12054', 218, 40, 2021, 42.6159, 0.743787768700652, -73.8417, -1.2887807902699),
(4357, '12055', 218, 40, 148319, 42.5413, 0.742485753078664, -73.9901, -1.29137085887986),
(4358, '12056', 218, 40, 148343, 42.7852, 0.746742611124278, -74.0785, -1.29291372993862),
(4359, '12057', 218, 40, 148386, 42.9386, 0.749419946196837, -73.3424, -1.28006636131469),
(4360, '12058', 218, 40, 32287, 42.3518, 0.739178354146134, -73.9041, -1.28986987572314),
(4361, '12059', 218, 40, 148414, 42.6184, 0.743831401931951, -74.0598, -1.2925873533685),
(4362, '12060', 218, 40, 148424, 42.4273, 0.74049607773139, -73.4889, -1.28262326866886),
(4363, '12061', 218, 40, 148457, 42.5949, 0.743421249557733, -73.6924, -1.28617501369667),
(4364, '12062', 218, 40, 148498, 42.5324, 0.742330418775236, -73.5029, -1.28286761476414),
(4365, '12063', 218, 40, 148530, 42.5681, 0.742953501318198, -73.6127, -1.28478398628283),
(4366, '12064', 218, 40, 148564, 42.5599, 0.742810384319535, -74.6476, -1.30284639871172),
(4367, '12065', 218, 40, 147868, 42.8502, 0.747877075138074, -73.786, -1.28780864187654),
(4368, '12066', 218, 40, 148706, 42.7688, 0.746456377126951, -74.2608, -1.29609546516501),
(4369, '12067', 218, 40, 148786, 42.5639, 0.742880197489614, -73.9119, -1.2900060114048),
(4370, '12068', 218, 40, 75848, 42.9536, 0.749681745584636, -74.3476, -1.29761041095574),
(4371, '12069', 218, 40, 148916, 42.9424, 0.749486268708413, -74.2838, -1.29649689089296),
(4372, '12070', 218, 40, 148919, 42.9606, 0.749803918632276, -74.2515, -1.29593314954457),
(4373, '12071', 218, 40, 72620, 42.5892, 0.743321765790369, -74.3917, -1.29838010115587),
(4374, '12072', 218, 40, 149016, 42.9418, 0.749475796732901, -74.3797, -1.29817066164563),
(4375, '12073', 218, 40, 149041, 42.6629, 0.744608073449089, -74.2326, -1.29560328231594),
(4376, '12074', 218, 40, 149042, 43.0336, 0.751078008986232, -74.0388, -1.29222083422558),
(4377, '12075', 218, 40, 36085, 42.2916, 0.738127665936434, -73.7045, -1.28638619853616),
(4378, '12076', 218, 40, 47429, 42.4094, 0.740183663795283, -74.3923, -1.29839057313138),
(4379, '12077', 218, 40, 47494, 42.5956, 0.743433466862497, -73.7938, -1.28794477755819),
(4380, '12078', 218, 40, 102315, 43.0548, 0.751448018787655, -74.3385, -1.2974515859938),
(4381, '12082', 218, 40, 27298, 42.7684, 0.746449395809943, -73.4515, -1.28197051552862),
(4382, '12083', 218, 40, 2868, 42.4155, 0.740290128879655, -74.0119, -1.29175134065679),
(4383, '12084', 218, 40, 149351, 42.6996, 0.745248609284571, -73.8996, -1.2897913359068),
(4384, '12085', 218, 40, 149352, 42.7015, 0.745281770540359, -73.9695, -1.29101132105395),
(4385, '12086', 218, 40, 27355, 42.9735, 0.750029066105783, -74.1523, -1.29420178292659),
(4386, '12087', 218, 40, 149444, 42.4228, 0.74041753791505, -73.8858, -1.28955048047003),
(4387, '12089', 218, 40, 149688, 42.8621, 0.748084769319062, -73.3282, -1.27981852456091),
(4388, '12090', 218, 40, 149689, 42.8999, 0.748744503776315, -73.3512, -1.28021995028886),
(4389, '12092', 218, 40, 149729, 42.71, 0.745430123526778, -74.3633, -1.2978844276483),
(4390, '12093', 218, 40, 3409, 42.4977, 0.741724789524794, -74.7236, -1.30417284894323),
(4391, '12094', 218, 40, 756, 42.9331, 0.749323953087978, -73.5061, -1.2829234653002),
(4392, '12095', 218, 40, 3440, 43.0087, 0.750643422002485, -74.3719, -1.29803452596397),
(4393, '12106', 218, 40, 27626, 42.3929, 0.739895684468704, -73.7094, -1.28647171966951),
(4394, '12107', 218, 40, 30266, 42.6697, 0.744726755838224, -74.1196, -1.29363106026119),
(4395, '12108', 218, 40, 125190, 43.5724, 0.760481842995977, -74.4147, -1.29878152688382),
(4396, '12110', 218, 40, 3678, 42.7465, 0.746067168703756, -73.766, -1.28745957602614),
(4397, '12111', 218, 40, 3678, 42.7454, 0.746047970081984, -73.7469, -1.28712621813901),
(4398, '12115', 218, 40, 150481, 42.454, 0.740962080641673, -73.5898, -1.28438430588412),
(4399, '12116', 218, 40, 42000, 42.5422, 0.742501461041932, -74.8986, -1.30722717513423),
(4400, '12117', 218, 40, 10367, 43.1048, 0.752320683413652, -74.2622, -1.29611989977453),
(4401, '12118', 218, 40, 42057, 42.9136, 0.748983613883839, -73.7042, -1.2863809625484),
(4402, '12120', 218, 40, 150663, 42.4358, 0.74064443071781, -74.1441, -1.29405866592793),
(4403, '12121', 218, 40, 4153, 42.8442, 0.747772355382955, -73.6184, -1.28488347005019),
(4404, '12122', 218, 40, 150710, 42.5968, 0.743454410813521, -74.3326, -1.29734861156794),
(4405, '12123', 218, 40, 14288, 42.5183, 0.742084327350705, -73.6246, -1.28499168046382),
(4406, '12124', 218, 40, 30619, 42.4457, 0.740817218313757, -73.7884, -1.28785052977858),
(4407, '12125', 218, 40, 30637, 42.4825, 0.741459499478491, -73.3749, -1.28063359332159),
(4408, '12128', 218, 40, 4572, 42.7251, 0.745693668243829, -73.7526, -1.28722570190637),
(4409, '12130', 218, 40, 151116, 42.4492, 0.740878304837577, -73.6583, -1.28557985642174),
(4410, '12131', 218, 40, 151142, 42.4882, 0.741558983245855, -74.4303, -1.29905379824714),
(4411, '12132', 218, 40, 125597, 42.4724, 0.74128322122404, -73.6322, -1.28512432548697),
(4412, '12133', 218, 40, 151230, 42.9284, 0.749241922613134, -73.3436, -1.28008730526571),
(4413, '12134', 218, 40, 71188, 43.2377, 0.754640225989552, -74.11, -1.293463508653),
(4414, '12136', 218, 40, 151369, 42.4682, 0.741209917395456, -73.5546, -1.28376994998742),
(4415, '12137', 218, 40, 89801, 42.8541, 0.747945142978902, -74.1144, -1.29354030314009),
(4416, '12138', 218, 40, 14402, 42.7437, 0.7460182994847, -73.407, -1.28119384401148),
(4417, '12139', 218, 40, 151744, 43.4221, 0.75785861313023, -74.5265, -1.30073280498755),
(4418, '12140', 218, 40, 151803, 42.6953, 0.745173560126735, -73.5781, -1.28418010236164),
(4419, '12141', 218, 40, 151951, 42.7351, 0.745868201169029, -74.1852, -1.2947759962505),
(4420, '12143', 218, 40, 151989, 42.4729, 0.7412919478703, -73.8209, -1.28841776178548),
(4421, '12144', 218, 40, 57137, 42.6329, 0.74408447467349, -73.7222, -1.28669512181376),
(4422, '12147', 218, 40, 152047, 42.5242, 0.742187301776573, -74.1476, -1.29411975245175),
(4423, '12148', 218, 40, 61522, 42.8397, 0.747693815566615, -73.8585, -1.28907400558423),
(4424, '12149', 218, 40, 132828, 42.6351, 0.744122871917034, -74.5644, -1.30139428477406),
(4425, '12150', 218, 40, 152239, 42.8743, 0.748297699487805, -74.0452, -1.29233253529771),
(4426, '12151', 218, 40, 17861, 42.934, 0.749339661051245, -73.7931, -1.28793256025343),
(4427, '12153', 218, 40, 97827, 42.6361, 0.744140325209554, -73.4942, -1.28271577111922),
(4428, '12154', 218, 40, 152393, 42.8975, 0.748702615874268, -73.5861, -1.2843197287018),
(4429, '12155', 218, 40, 152398, 42.5477, 0.742597454150791, -74.8234, -1.30591468753673),
(4430, '12156', 218, 40, 152406, 42.4872, 0.741541529953335, -73.7334, -1.28689059868999),
(4431, '12157', 218, 40, 152404, 42.6656, 0.744655197338893, -74.3119, -1.29698732841277),
(4432, '12158', 218, 40, 57474, 42.5521, 0.742674248637879, -73.8194, -1.2883915818467),
(4433, '12159', 218, 40, 152608, 42.6437, 0.744272970232706, -73.8761, -1.28938118353258),
(4434, '12160', 218, 40, 152610, 42.7611, 0.746321986774547, -74.3744, -1.29807815919527),
(4435, '12161', 218, 40, 152679, 42.5379, 0.742426411884096, -73.8931, -1.28967788950542),
(4436, '12164', 218, 40, 152815, 43.5589, 0.760246223546958, -74.3572, -1.29777796256393),
(4437, '12165', 218, 40, 152822, 42.323, 0.73867569932156, -73.5449, -1.28360065304998),
(4438, '12166', 218, 40, 152830, 42.8393, 0.747686834249607, -74.4584, -1.29954423576695),
(4439, '12167', 218, 40, 98270, 42.4107, 0.740206353075559, -74.6184, -1.30233676257014),
(4440, '12168', 218, 40, 152902, 42.537, 0.742410703920828, -73.3844, -1.28079939960053),
(4441, '12169', 218, 40, 152902, 42.5638, 0.742878452160362, -73.367, -1.28049571231068),
(4442, '12170', 218, 40, 12131, 42.9831, 0.750196617713975, -73.6683, -1.28575438934694),
(4443, '12172', 218, 40, 152965, 42.2864, 0.73803690881533, -73.7395, -1.28699706377436),
(4444, '12173', 218, 40, 152978, 42.3847, 0.739752567470041, -73.7722, -1.28756778643976),
(4445, '12174', 218, 40, 152980, 42.3541, 0.73921849671893, -73.7315, -1.2868574374342),
(4446, '12175', 218, 40, 6151, 42.5334, 0.742347872067756, -74.5379, -1.30093177252228),
(4447, '12176', 218, 40, 31269, 42.3599, 0.739319725815546, -73.9496, -1.2906640005328),
(4448, '12177', 218, 40, 153192, 42.9528, 0.74966778295062, -74.2926, -1.29665047986714),
(4449, '12179', 218, 40, 199, 42.7342, 0.745852493205761, -73.6754, -1.28587830772383),
(4450, '12180', 218, 40, 199, 42.7199, 0.745602911122726, -73.6595, -1.28560080037276),
(4451, '12181', 218, 40, 199, 42.7306, 0.745789661352689, -73.6899, -1.28613138046537),
(4452, '12182', 218, 40, 199, 42.7785, 0.746625674064394, -73.6609, -1.28562523498229),
(4453, '12183', 218, 40, 199, 42.7436, 0.746016554155448, -73.6952, -1.28622388291573),
(4454, '12184', 218, 40, 153319, 42.4101, 0.740195881100047, -73.6738, -1.2858503824558),
(4455, '12185', 218, 40, 34238, 42.8905, 0.748580442826628, -73.5423, -1.28355527448943),
(4456, '12186', 218, 40, 153406, 42.6481, 0.744349764719794, -73.9351, -1.29041092779126),
(4457, '12187', 218, 40, 143309, 42.6139, 0.743752862115612, -74.474, -1.29981650713026),
(4458, '12188', 218, 40, 790, 42.8042, 0.747074223682157, -73.6954, -1.28622737357423),
(4459, '12189', 218, 40, 113225, 42.7287, 0.745756500096901, -73.7142, -1.2865554954736),
(4460, '12190', 218, 40, 34376, 43.474, 0.758764439012015, -74.2737, -1.29632061263851),
(4461, '12192', 218, 40, 153601, 42.3659, 0.739424445570666, -73.8266, -1.28851724555285),
(4462, '12193', 218, 40, 153726, 42.537, 0.742410703920828, -74.0463, -1.29235173391948),
(4463, '12194', 218, 40, 62262, 42.5396, 0.74245608248138, -74.4538, -1.29946395062135),
(4464, '12195', 218, 40, 58217, 42.4932, 0.741646249708455, -73.4478, -1.28190593834629),
(4465, '12196', 218, 40, 153688, 42.6281, 0.744000698869395, -73.6326, -1.28513130680398),
(4466, '12197', 218, 40, 58366, 42.5931, 0.743389833631197, -74.7484, -1.30460569059773),
(4467, '12198', 218, 40, 153960, 42.6854, 0.745000772530788, -73.6426, -1.28530583972918),
(4468, '12201', 218, 40, 18772, 42.6475, 0.744339292744282, -73.7538, -1.28724664585739),
(4469, '12202', 218, 40, 18772, 42.6417, 0.744238063647666, -73.7668, -1.28747353866015),
(4470, '12203', 218, 40, 18772, 42.6788, 0.744885580800156, -73.8346, -1.28865687189301),
(4471, '12204', 218, 40, 18772, 42.6848, 0.744990300555276, -73.7382, -1.28697437449408),
(4472, '12205', 218, 40, 18772, 42.7138, 0.745496446038354, -73.8205, -1.28841078046847),
(4473, '12206', 218, 40, 18772, 42.6708, 0.744745954459996, -73.7791, -1.28768821415815),
(4474, '12207', 218, 40, 18772, 42.6501, 0.744384671304834, -73.7547, -1.28726235382066),
(4475, '12208', 218, 40, 18772, 42.6557, 0.744482409742945, -73.8059, -1.28815596239768),
(4476, '12209', 218, 40, 18772, 42.6423, 0.744248535623178, -73.7856, -1.28780166055953),
(4477, '12210', 218, 40, 18772, 42.6574, 0.744512080340229, -73.7575, -1.28731122303972),
(4478, '12211', 218, 40, 18772, 42.7055, 0.745351583710438, -73.7694, -1.28751891722071),
(4479, '12212', 218, 40, 18772, 42.679, 0.74488907145866, -73.8394, -1.2887406476971),
(4480, '12214', 218, 40, 18772, 42.6898, 0.745077567017875, -73.8501, -1.28892739792706),
(4481, '12220', 218, 40, 18772, 42.6652, 0.744648216021885, -73.8812, -1.28947019532443),
(4482, '12222', 218, 40, 18772, 42.6931, 0.745135162883191, -73.8377, -1.28871097709982),
(4483, '12223', 218, 40, 18772, 42.6516, 0.744410851243614, -73.7584, -1.28732693100299),
(4484, '12224', 218, 40, 18772, 42.6658, 0.744658687997397, -73.8425, -1.28879475290391),
(4485, '12225', 218, 40, 18772, 42.6798, 0.744903034092676, -73.8391, -1.28873541170935),
(4486, '12226', 218, 40, 18772, 42.6837, 0.744971101933504, -73.8092, -1.288213558263),
(4487, '12227', 218, 40, 18772, 42.6879, 0.745044405762087, -73.8474, -1.28888027403726),
(4488, '12228', 218, 40, 18772, 42.6436, 0.744271224903454, -73.7568, -1.28729900573495),
(4489, '12229', 218, 40, 18772, 42.6507, 0.744395143280346, -73.8112, -1.28824846484804),
(4490, '12230', 218, 40, 18772, 42.6521, 0.744419577889873, -73.7587, -1.28733216699074),
(4491, '12231', 218, 40, 18772, 42.6569, 0.744503353693969, -73.7628, -1.28740372549007),
(4492, '12232', 218, 40, 18772, 42.6525, 0.744426559206882, -73.757, -1.28730249639346),
(4493, '12233', 218, 40, 18772, 42.6522, 0.744421323219125, -73.7588, -1.28733391231999),
(4494, '12234', 218, 40, 18772, 42.6726, 0.744777370386532, -73.7389, -1.28698659179885),
(4495, '12235', 218, 40, 18772, 42.652, 0.744417832560621, -73.7584, -1.28732693100299),
(4496, '12236', 218, 40, 18772, 42.6521, 0.744419577889873, -73.7586, -1.28733042166149),
(4497, '12237', 218, 40, 18772, 42.6449, 0.74429391418373, -73.8004, -1.28805996928882),
(4498, '12238', 218, 40, 18772, 42.6525, 0.744426559206882, -73.7585, -1.28732867633224),
(4499, '12239', 218, 40, 18772, 42.6516, 0.744410851243614, -73.7585, -1.28732867633224),
(4500, '12240', 218, 40, 18772, 42.6516, 0.744410851243614, -73.7585, -1.28732867633224),
(4501, '12241', 218, 40, 18772, 42.6326, 0.744079238685734, -73.7604, -1.28736183758803),
(4502, '12242', 218, 40, 18772, 42.652, 0.744417832560621, -73.7587, -1.28733216699074),
(4503, '12243', 218, 40, 18772, 42.6555, 0.744478919084441, -73.7497, -1.28717508735806),
(4504, '12244', 218, 40, 18772, 42.652, 0.744417832560621, -73.7587, -1.28733216699074),
(4505, '12245', 218, 40, 18772, 42.6728, 0.744780861045036, -73.7753, -1.28762189164657),
(4506, '12246', 218, 40, 18772, 42.6881, 0.745047896420591, -73.8212, -1.28842299777324),
(4507, '12247', 218, 40, 18772, 42.6858, 0.745007753847796, -73.7308, -1.28684522012944),
(4508, '12248', 218, 40, 18772, 42.6527, 0.744430049865385, -73.7565, -1.2872937697472),
(4509, '12249', 218, 40, 18772, 42.6957, 0.745180541443743, -73.9935, -1.29143020007442),
(4510, '12250', 218, 40, 18772, 42.6739, 0.744800059666808, -73.7374, -1.28696041186007),
(4511, '12252', 218, 40, 18772, 42.6517, 0.744412596572865, -73.7581, -1.28732169501523),
(4512, '12255', 218, 40, 18772, 42.6519, 0.744416087231369, -73.7582, -1.28732344034448),
(4513, '12256', 218, 40, 18772, 42.6518, 0.744414341902118, -73.758, -1.28731994968598),
(4514, '12257', 218, 40, 18772, 42.6517, 0.744412596572865, -73.759, -1.2873374029785),
(4515, '12260', 218, 40, 18772, 42.6728, 0.744780861045036, -73.7752, -1.28762014631732),
(4516, '12261', 218, 40, 18772, 42.6776, 0.744864636849132, -73.7819, -1.2877370833772),
(4517, '12262', 218, 40, 18772, 42.7182, 0.745573240525442, -73.8288, -1.28855564279639),
(4518, '12288', 218, 40, 18772, 42.7286, 0.745754754767649, -73.8503, -1.28893088858557),
(4519, '12301', 218, 40, 152395, 42.8154, 0.74726970055838, -73.939, -1.29047899563209),
(4520, '12302', 218, 40, 152395, 42.8584, 0.748020192136738, -73.9557, -1.29077046561717),
(4521, '12303', 218, 40, 152395, 42.7838, 0.74671817651475, -73.9388, -1.29047550497358),
(4522, '12304', 218, 40, 152395, 42.7825, 0.746695487234474, -73.9079, -1.28993619823472),
(4523, '12305', 218, 40, 152395, 42.8144, 0.74725224726586, -73.9429, -1.29054706347292),
(4524, '12306', 218, 40, 152395, 42.7896, 0.746819405611366, -73.9858, -1.29129580972202),
(4525, '12307', 218, 40, 152395, 42.8046, 0.747081204999165, -73.9351, -1.29041092779126),
(4526, '12308', 218, 40, 152395, 42.8184, 0.74732206043594, -73.9212, -1.29016832702523),
(4527, '12309', 218, 40, 152395, 42.8053, 0.747093422303929, -73.8825, -1.28949288460471),
(4528, '12325', 218, 40, 152395, 42.8689, 0.748203451708197, -73.9328, -1.29037078521846),
(4529, '12345', 218, 40, 152395, 42.8145, 0.747253992595112, -73.94, -1.29049644892461),
(4530, '12401', 218, 40, 3542, 41.9289, 0.73179735673945, -74.0116, -1.29174610466904),
(4531, '12402', 218, 40, 3542, 41.931, 0.731834008653742, -74.0308, -1.29208120788542),
(4532, '12404', 218, 40, 124077, 41.7955, 0.72946908751729, -74.2384, -1.29570451141256),
(4533, '12405', 218, 40, 146702, 42.3358, 0.738899101465815, -74.0955, -1.29321043591146),
(4534, '12406', 218, 40, 146863, 42.1051, 0.734872626881464, -74.5297, -1.30078865552362),
(4535, '12407', 218, 40, 13301, 42.238, 0.737192169457365, -74.3056, -1.2968773726699),
(4536, '12409', 218, 40, 108122, 42.0322, 0.733600281856761, -74.1895, -1.29485104540833),
(4537, '12410', 218, 40, 147200, 42.0705, 0.734268742960274, -74.4632, -1.29962801157104),
(4538, '12411', 218, 40, 29235, 41.8786, 0.730919456125697, -74.0422, -1.29228017542015),
(4539, '12412', 218, 40, 147270, 42.0047, 0.733120316312462, -74.2616, -1.29610942779902),
(4540, '12413', 218, 40, 1288, 42.2882, 0.738068324741866, -73.9799, -1.29119283529615),
(4541, '12414', 218, 40, 147647, 42.221, 0.736895463484526, -73.8741, -1.28934627694754),
(4542, '12416', 218, 40, 143624, 42.089, 0.734591628871893, -74.2678, -1.29621763821264),
(4543, '12417', 218, 40, 147995, 41.9092, 0.731453526876808, -73.9908, -1.29138307618462),
(4544, '12418', 218, 40, 148050, 42.3787, 0.739647847714921, -74.1238, -1.29370436408977),
(4545, '12419', 218, 40, 148066, 41.8507, 0.730432509264391, -74.1133, -1.29352110451831),
(4546, '12420', 218, 40, 148091, 41.6715, 0.727304879244817, -74.3852, -1.29826665475449),
(4547, '12421', 218, 40, 2033, 42.2698, 0.737747184159499, -74.5322, -1.30083228875492),
(4548, '12422', 218, 40, 8632, 42.4082, 0.740162719844259, -74.1862, -1.29479344954302),
(4549, '12423', 218, 40, 148436, 42.3911, 0.739864268542168, -74.1373, -1.29393998353879),
(4550, '12424', 218, 40, 148479, 42.2767, 0.737867611877887, -74.2101, -1.29521058323424),
(4551, '12427', 218, 40, 148630, 42.184, 0.736249691661288, -74.1312, -1.29383351845442),
(4552, '12428', 218, 40, 148636, 41.7199, 0.728149618602782, -74.4078, -1.29866109916544),
(4553, '12429', 218, 40, 148704, 41.8394, 0.730235287058915, -73.9927, -1.29141623744041),
(4554, '12430', 218, 40, 148850, 42.1996, 0.736521963024599, -74.5146, -1.30052511080657),
(4555, '12431', 218, 40, 145271, 42.3737, 0.739560581252321, -74.0576, -1.29254895612495),
(4556, '12432', 218, 40, 32551, 42.02, 0.733387351688017, -73.9609, -1.29086122273827),
(4557, '12433', 218, 40, 72685, 42.0088, 0.733191874811794, -74.1524, -1.29420352825584),
(4558, '12434', 218, 40, 149219, 42.3855, 0.739766530104057, -74.5286, -1.30076945690185),
(4559, '12435', 218, 40, 131120, 41.7142, 0.728050134835419, -74.4932, -1.30015161034664),
(4560, '12436', 218, 40, 149380, 42.1961, 0.736460876500779, -74.1168, -1.29358219104213),
(4561, '12438', 218, 40, 149383, 42.2088, 0.736682533315782, -74.6014, -1.3020400565973),
(4562, '12439', 218, 40, 149569, 42.2787, 0.737902518462927, -74.2292, -1.29554394112137),
(4563, '12440', 218, 40, 21902, 41.8198, 0.729893202525525, -74.1279, -1.2937759225891),
(4564, '12441', 218, 40, 149622, 42.1437, 0.735546323972734, -74.4904, -1.30010274112758),
(4565, '12442', 218, 40, 3284, 42.2137, 0.73676805444913, -74.2015, -1.29506048491857),
(4566, '12443', 218, 40, 3300, 41.9234, 0.731701363630591, -74.0658, -1.29269207312362),
(4567, '12444', 218, 40, 27563, 42.2721, 0.737787326732295, -74.317, -1.29707634020463),
(4568, '12446', 218, 40, 150000, 41.7811, 0.729217760105003, -74.288, -1.29657019472155),
(4569, '12448', 218, 40, 150113, 42.0719, 0.734293177569802, -74.2094, -1.29519836592948),
(4570, '12449', 218, 40, 150116, 41.9965, 0.732977199313799, -74.001, -1.29156109976832),
(4571, '12450', 218, 40, 27675, 42.1359, 0.735410188291079, -74.264, -1.29615131570107),
(4572, '12451', 218, 40, 3719, 42.3085, 0.738422626580021, -73.9423, -1.2905365914974),
(4573, '12452', 218, 40, 3748, 42.2403, 0.737232312030161, -74.3658, -1.2979280608796),
(4574, '12453', 218, 40, 0, 42.0946, 0.734689367310005, -73.9357, -1.29042139976677),
(4575, '12454', 218, 40, 14178, 42.2916, 0.738127665936434, -74.1459, -1.29409008185446),
(4576, '12455', 218, 40, 150565, 42.0797, 0.734429313251458, -74.5872, -1.30179221984351),
(4577, '12456', 218, 40, 150900, 41.9799, 0.732687474657968, -74.0339, -1.29213531309223),
(4578, '12457', 218, 40, 150915, 42.0424, 0.733778305440464, -74.2616, -1.29610942779902),
(4579, '12458', 218, 40, 150958, 41.8138, 0.729788482770405, -74.4119, -1.29873265766477),
(4580, '12459', 218, 40, 151029, 42.214, 0.736773290436886, -74.6825, -1.30345551862067),
(4581, '12460', 218, 40, 4679, 42.4098, 0.740190645112291, -74.1477, -1.294121497781),
(4582, '12461', 218, 40, 151383, 41.9198, 0.731638531777519, -74.2353, -1.29565040620575),
(4583, '12463', 218, 40, 151528, 42.1714, 0.736029780175537, -74.0242, -1.29196601615479),
(4584, '12464', 218, 40, 151687, 41.997, 0.732985925960059, -74.3349, -1.29738875414073),
(4585, '12465', 218, 40, 953, 42.1316, 0.735335139133243, -74.4808, -1.29993518951939),
(4586, '12466', 218, 40, 151847, 41.9047, 0.731374987060468, -73.979, -1.29117712733289),
(4587, '12468', 218, 40, 11393, 42.2972, 0.738225404374546, -74.398, -1.29849005689874),
(4588, '12469', 218, 40, 151907, 42.4408, 0.740731697180409, -74.234, -1.29562771692547),
(4589, '12470', 218, 40, 151937, 42.269, 0.737733221525483, -74.007, -1.29166581952344),
(4590, '12471', 218, 40, 152107, 41.8343, 0.730146275267064, -74.0377, -1.29220163560381),
(4591, '12472', 218, 40, 117607, 41.8485, 0.730394112020847, -74.0737, -1.29282995413452),
(4592, '12473', 218, 40, 79060, 42.2734, 0.737810016012571, -74.0697, -1.29276014096444),
(4593, '12474', 218, 40, 33833, 42.2885, 0.738073560729622, -74.5616, -1.301345415555),
(4594, '12475', 218, 40, 42889, 42.0192, 0.733373389054001, -74.0094, -1.29170770742549),
(4595, '12477', 218, 40, 152372, 42.0729, 0.734310630862322, -73.9811, -1.29121377924718),
(4596, '12480', 218, 40, 152493, 42.1161, 0.735064613099184, -74.3936, -1.29841326241165),
(4597, '12481', 218, 40, 152545, 41.979, 0.7326717666947, -74.2175, -1.29533973759889),
(4598, '12482', 218, 40, 152688, 42.2727, 0.737797798707807, -73.951, -1.29068843514233),
(4599, '12483', 218, 40, 18173, 41.6652, 0.727194923501941, -74.4303, -1.29905379824714),
(4600, '12484', 218, 40, 91055, 41.8695, 0.730760631163766, -74.1779, -1.2946485872151),
(4601, '12485', 218, 40, 31288, 42.1952, 0.736445168537511, -74.1334, -1.29387191569796),
(4602, '12486', 218, 40, 153135, 41.8394, 0.730235287058915, -74.0554, -1.29251055888141),
(4603, '12487', 218, 40, 153255, 41.8649, 0.730680346018174, -73.992, -1.29140402013564),
(4604, '12489', 218, 40, 153512, 41.7587, 0.728826806352556, -74.3578, -1.29778843453944),
(4605, '12490', 218, 40, 153584, 42.1188, 0.735111736988988, -73.933, -1.29037427587697),
(4606, '12491', 218, 40, 153640, 42.0075, 0.733169185531518, -74.106, -1.29339369548292),
(4607, '12492', 218, 40, 153647, 42.2175, 0.736834376960706, -74.4133, -1.2987570922743),
(4608, '12493', 218, 40, 14829, 41.811, 0.729739613551349, -74.0042, -1.29161695030439),
(4609, '12494', 218, 40, 153696, 41.9459, 0.73209406271229, -74.2907, -1.29661731861135),
(4610, '12495', 218, 40, 12874, 42.0918, 0.734640498090949, -74.2022, -1.29507270222334),
(4611, '12496', 218, 40, 114305, 42.3058, 0.738375502690217, -74.2191, -1.29536766286692),
(4612, '12498', 218, 40, 569, 42.036, 0.733666604368336, -74.1143, -1.29353855781083),
(4613, '12501', 218, 40, 118615, 41.8489, 0.730401093337855, -73.5394, -1.28350465994112),
(4614, '12502', 218, 40, 146811, 42.0866, 0.734549740969845, -73.6607, -1.28562174432379),
(4615, '12503', 218, 40, 146813, 42.0399, 0.733734672209164, -73.6283, -1.28505625764614),
(4616, '12504', 218, 40, 0, 42.0143, 0.733287867920654, -73.8991, -1.28978260926054),
(4617, '12506', 218, 40, 146989, 41.8761, 0.730875822894397, -73.6917, -1.28616279639191),
(4618, '12507', 218, 40, 112954, 41.996, 0.732968472667539, -73.9233, -1.29020497893952),
(4619, '12508', 218, 40, 34, 41.5057, 0.72441112334501, -73.9577, -1.29080537220221),
(4620, '12510', 218, 40, 53485, 41.6716, 0.727306624574069, -73.7621, -1.28739150818531),
(4621, '12511', 218, 40, 53899, 41.5287, 0.724812549072969, -73.9631, -1.29089961998182),
(4622, '12512', 218, 40, 1509, 41.5532, 0.725240154739708, -73.9669, -1.29096594249339),
(4623, '12513', 218, 40, 147845, 42.2242, 0.73695131402059, -73.7344, -1.28690805198251),
(4624, '12514', 218, 40, 147875, 41.8282, 0.730039810182692, -73.788, -1.28784354846158),
(4625, '12515', 218, 40, 147883, 41.6972, 0.72775342886258, -74.0603, -1.29259608001476),
(4626, '12516', 218, 40, 148032, 42.1158, 0.735059377111428, -73.5559, -1.2837926392677),
(4627, '12517', 218, 40, 148026, 42.1406, 0.735492218765922, -73.5033, -1.28287459608115),
(4628, '12518', 218, 40, 54205, 41.4332, 0.723145759637315, -74.0428, -1.29229064739566),
(4629, '12520', 218, 40, 0, 41.4424, 0.723306329928498, -74.0165, -1.29183162580238),
(4630, '12521', 218, 40, 148102, 42.1584, 0.735802887372777, -73.6111, -1.2847560610148),
(4631, '12522', 218, 40, 148322, 41.7183, 0.72812169333475, -73.6029, -1.28461294401613),
(4632, '12523', 218, 40, 35731, 42.0721, 0.734296668228306, -73.7907, -1.28789067235138),
(4633, '12524', 218, 40, 148818, 41.5396, 0.725002789961437, -73.9017, -1.28982798782109),
(4634, '12525', 218, 40, 115683, 41.6638, 0.727170488892414, -74.1522, -1.29420003759734),
(4635, '12526', 218, 40, 27253, 42.1185, 0.735106501001232, -73.8588, -1.28907924157199),
(4636, '12527', 218, 40, 149163, 41.5191, 0.724644997464778, -73.9382, -1.29046503299807),
(4637, '12528', 218, 40, 3108, 41.7227, 0.728198487821838, -73.992, -1.29140402013564),
(4638, '12529', 218, 40, 3147, 42.1777, 0.736139735918412, -73.5201, -1.28316781139548),
(4639, '12530', 218, 40, 149670, 42.2243, 0.736953059349842, -73.6761, -1.28589052502859),
(4640, '12531', 218, 40, 36475, 41.5328, 0.724884107572301, -73.6696, -1.28577707862721),
(4641, '12533', 218, 40, 149695, 41.5744, 0.72561016454113, -73.7981, -1.28801982671603),
(4642, '12534', 218, 40, 16505, 42.2484, 0.737373683699572, -73.7736, -1.28759222104929),
(4643, '12537', 218, 40, 149744, 41.5809, 0.72572361094251, -73.9274, -1.29027653743886),
(4644, '12538', 218, 40, 3310, 41.7829, 0.729249176031539, -73.9034, -1.28985765841838),
(4645, '12540', 218, 40, 150098, 41.6502, 0.726933124114142, -73.7437, -1.28707036760294),
(4646, '12541', 218, 40, 3825, 42.1416, 0.735509672058442, -73.7787, -1.28768123284114),
(4647, '12542', 218, 40, 66631, 41.6085, 0.726205321816061, -73.9887, -1.29134642427033),
(4648, '12543', 218, 40, 104077, 41.4893, 0.724124889347683, -74.2151, -1.29529784969684),
(4649, '12544', 218, 40, 150665, 42.2535, 0.737462695491424, -73.6686, -1.28575962533469),
(4650, '12545', 218, 40, 4211, 41.7965, 0.72948654080981, -73.6926, -1.28617850435517),
(4651, '12546', 218, 40, 33288, 41.9992, 0.733024323203602, -73.5407, -1.28352734922139),
(4652, '12547', 218, 40, 4232, 41.657, 0.727051806503278, -73.9784, -1.29116665535737),
(4653, '12548', 218, 40, 78755, 41.6538, 0.726995955967214, -74.1132, -1.29351935918906),
(4654, '12549', 218, 40, 4289, 41.5226, 0.724706083988597, -74.2361, -1.29566436883976),
(4655, '12550', 218, 40, 30662, 41.5099, 0.724484427173594, -74.053, -1.29246867097936),
(4656, '12551', 218, 40, 30662, 41.5377, 0.724969628705649, -74.0473, -1.292369187212),
(4657, '12552', 218, 40, 30662, 41.5382, 0.724978355351909, -74.0477, -1.29237616852901),
(4658, '12553', 218, 40, 49791, 41.4744, 0.723864835289136, -74.0488, -1.29239536715078),
(4659, '12555', 218, 40, 0, 41.508, 0.724451265917806, -74.012, -1.29175308598604),
(4660, '12561', 218, 40, 151039, 41.741, 0.728517883074953, -74.0938, -1.29318076531417),
(4661, '12563', 218, 40, 428, 41.5, 0.724311639577647, -73.5773, -1.28416613972762),
(4662, '12564', 218, 40, 151599, 41.5665, 0.725472283530223, -73.5903, -1.28439303253038),
(4663, '12565', 218, 40, 151685, 42.2496, 0.737394627650596, -73.6485, -1.28540881415504),
(4664, '12566', 218, 40, 151714, 41.6053, 0.726149471279997, -74.3029, -1.29683024878009),
(4665, '12567', 218, 40, 151733, 42.0475, 0.733867317232316, -73.5982, -1.28453091354129),
(4666, '12568', 218, 40, 151771, 41.6142, 0.726304805583424, -74.0601, -1.29259258935625),
(4667, '12569', 218, 40, 5149, 41.7452, 0.728591186903537, -73.8183, -1.28837238322493),
(4668, '12570', 218, 40, 151889, 41.646, 0.726859820285559, -73.6721, -1.28582071185851),
(4669, '12571', 218, 40, 152008, 42.0012, 0.733059229788642, -73.8758, -1.28937594754483),
(4670, '12572', 218, 40, 152065, 41.9267, 0.731758959495907, -73.8959, -1.28972675872448),
(4671, '12574', 218, 40, 152067, 41.9147, 0.731549519985667, -73.9513, -1.29069367113008),
(4672, '12575', 218, 40, 152161, 41.4712, 0.723808984753072, -74.1468, -1.29410578981773),
(4673, '12577', 218, 40, 152324, 41.4332, 0.723145759637315, -74.122, -1.29367294816324),
(4674, '12578', 218, 40, 152329, 41.7974, 0.729502248773078, -73.7899, -1.28787670971736),
(4675, '12580', 218, 40, 152859, 41.8449, 0.730331280167775, -73.9111, -1.28999204877078),
(4676, '12581', 218, 40, 25081, 41.8889, 0.731099225038653, -73.6651, -1.28569853881087),
(4677, '12582', 218, 40, 152964, 41.5422, 0.725048168521988, -73.728, -1.28679635091038),
(4678, '12583', 218, 40, 98560, 42.0596, 0.734078502071807, -73.9136, -1.29003568200208),
(4679, '12584', 218, 40, 153317, 41.4664, 0.723725208948977, -74.0482, -1.29238489517527),
(4680, '12585', 218, 40, 153358, 41.72, 0.728151363932034, -73.7006, -1.28631813069533),
(4681, '12586', 218, 40, 25769, 41.5612, 0.725379781079867, -74.1743, -1.29458575536203),
(4682, '12588', 218, 40, 153432, 41.6333, 0.726638163470555, -74.3786, -1.29815146302385),
(4683, '12589', 218, 40, 153438, 41.6162, 0.726339712168464, -74.1485, -1.29413546041502),
(4684, '12590', 218, 40, 153454, 41.5945, 0.725960975720781, -73.8886, -1.28959934968908),
(4685, '12592', 218, 40, 153477, 41.7824, 0.729240449385279, -73.5482, -1.28365824891529),
(4686, '12593', 218, 40, 153597, 42.0954, 0.734703329944021, -73.5833, -1.28427085948274),
(4687, '12594', 218, 40, 153877, 41.6696, 0.727271717989029, -73.556, -1.28379438459695),
(4688, '12601', 218, 40, 11355, 41.7016, 0.727830223349667, -73.9149, -1.29005837128236),
(4689, '12602', 218, 40, 11355, 41.7069, 0.727922725800023, -73.9291, -1.29030620803614),
(4690, '12603', 218, 40, 11355, 41.6748, 0.727362475110133, -73.8773, -1.28940212748361),
(4691, '12604', 218, 40, 11355, 41.6857, 0.7275527159986, -73.8937, -1.28968836148093),
(4692, '12701', 218, 40, 588, 41.652, 0.726964540040678, -74.6945, -1.3036649581309),
(4693, '12719', 218, 40, 53346, 41.4806, 0.72397304570276, -74.9092, -1.30741218003494),
(4694, '12720', 218, 40, 220, 41.6638, 0.727170488892414, -74.9059, -1.30735458416962),
(4695, '12721', 218, 40, 71849, 41.5539, 0.725252372044472, -74.4539, -1.29946569595061),
(4696, '12722', 218, 40, 71970, 41.5901, 0.725884181233694, -74.3824, -1.29821778553543),
(4697, '12723', 218, 40, 147532, 41.7797, 0.729193325495475, -74.9836, -1.30871070499842),
(4698, '12724', 218, 40, 147533, 41.837, 0.730193399156868, -74.9468, -1.30806842383369),
(4699, '12725', 218, 40, 35258, 41.9738, 0.732581009573596, -74.5414, -1.3009928590461),
(4700, '12726', 218, 40, 147903, 41.6959, 0.727730739582304, -74.9813, -1.30867056242562),
(4701, '12727', 218, 40, 147904, 41.6427, 0.726802224420243, -74.9684, -1.30844541495212),
(4702, '12729', 218, 40, 148149, 41.4824, 0.724004461629296, -74.6285, -1.30251304082459),
(4703, '12732', 218, 40, 15910, 41.5288, 0.724814294402221, -74.8911, -1.30709627544033),
(4704, '12733', 218, 40, 35849, 41.7357, 0.728425380624597, -74.6131, -1.30224426011978),
(4705, '12734', 218, 40, 8879, 41.7263, 0.72826131967491, -74.7638, -1.30487447130254),
(4706, '12736', 218, 40, 119710, 41.8489, 0.730401093337855, -75.0237, -1.30941058202847),
(4707, '12737', 218, 40, 149150, 41.4747, 0.723870071276892, -74.7903, -1.30533698355432),
(4708, '12738', 218, 40, 149151, 41.6363, 0.726690523348115, -74.595, -1.30192835552517),
(4709, '12739', 218, 40, 149186, 41.4325, 0.723133542332551, -74.61, -1.30219015491297),
(4710, '12740', 218, 40, 16257, 41.8887, 0.731095734380149, -74.5232, -1.30067520912224),
(4711, '12741', 218, 40, 65357, 41.8246, 0.72997697832962, -75.0974, -1.31069688968719),
(4712, '12742', 218, 40, 2992, 41.7163, 0.72808678674971, -74.7277, -1.30424440744257),
(4713, '12743', 218, 40, 3113, 41.5283, 0.724805567755961, -74.8501, -1.30638069044701),
(4714, '12745', 218, 40, 122836, 41.7862, 0.729306771896855, -75.0269, -1.30946643256453),
(4715, '12746', 218, 40, 102999, 41.4127, 0.722787967140656, -74.6416, -1.3027416789566),
(4716, '12747', 218, 40, 103035, 41.7686, 0.728999593948504, -74.656, -1.30299300636889),
(4717, '12748', 218, 40, 9742, 41.7747, 0.729106059032875, -74.9148, -1.30750991847305),
(4718, '12749', 218, 40, 149960, 41.6904, 0.727634746473444, -74.844, -1.30627422536264),
(4719, '12750', 218, 40, 149988, 41.7818, 0.729229977409767, -74.9334, -1.30783454971392),
(4720, '12751', 218, 40, 150010, 41.6812, 0.72747417618226, -74.6757, -1.30333683623153),
(4721, '12752', 218, 40, 150114, 41.6857, 0.7275527159986, -74.9927, -1.30886952996035),
(4722, '12754', 218, 40, 3751, 41.8013, 0.729570316613906, -74.7469, -1.30457951065895),
(4723, '12758', 218, 40, 150331, 41.9143, 0.731542538668659, -74.7572, -1.30475927957191),
(4724, '12759', 218, 40, 150341, 41.7743, 0.729099077715867, -74.6535, -1.30294937313759),
(4725, '12760', 218, 40, 150374, 41.8687, 0.73074666852975, -75.0802, -1.31039669305585),
(4726, '12762', 218, 40, 150810, 41.686, 0.727557951986356, -74.8046, -1.30558656563735),
(4727, '12763', 218, 40, 56418, 41.6934, 0.727687106351004, -74.5286, -1.30076945690185),
(4728, '12764', 218, 40, 150964, 41.5887, 0.725859746624166, -74.9793, -1.30863565584058),
(4729, '12765', 218, 40, 150991, 41.8527, 0.730467415849431, -74.6199, -1.30236294250892),
(4730, '12766', 218, 40, 37450, 41.8097, 0.729716924271073, -74.9981, -1.30896377773996),
(4731, '12767', 218, 40, 151344, 41.8443, 0.730320808192263, -75.0073, -1.30912434803114),
(4732, '12768', 218, 40, 23766, 41.869, 0.730751904517506, -74.7204, -1.30411699840717),
(4733, '12769', 218, 40, 151684, 41.6518, 0.726961049382174, -74.4388, -1.29920215123356),
(4734, '12770', 218, 40, 151827, 41.4548, 0.723522750755745, -74.8518, -1.30641036104429),
(4735, '12771', 218, 40, 151853, 41.375, 0.722129978012654, -74.6681, -1.30320419120838),
(4736, '12775', 218, 40, 5463, 41.6149, 0.726317022888188, -74.584, -1.30173636930745),
(4737, '12776', 218, 40, 24518, 41.967, 0.73246232718446, -74.9308, -1.30778917115337),
(4738, '12777', 218, 40, 0, 41.5943, 0.725957485062277, -74.7164, -1.30404718523709),
(4739, '12778', 218, 40, 51490, 41.6653, 0.727196668831193, -74.8196, -1.30584836502515),
(4740, '12779', 218, 40, 152709, 41.708, 0.727941924421795, -74.6375, -1.30267012045727),
(4741, '12780', 218, 40, 152808, 41.4314, 0.723114343710779, -74.7205, -1.30411874373642),
(4742, '12781', 218, 40, 91138, 41.6195, 0.72639730803378, -74.4488, -1.29937668415875),
(4743, '12782', 218, 40, 57789, 41.8213, 0.729919382464305, -74.5371, -1.30091780988827),
(4744, '12783', 218, 40, 12232, 41.7414, 0.728524864391961, -74.7917, -1.30536141816384),
(4745, '12784', 218, 40, 14747, 41.6681, 0.727245538050249, -74.6258, -1.30246591693478),
(4746, '12785', 218, 40, 153716, 41.4985, 0.724285459638867, -74.5594, -1.30130701831146),
(4747, '12786', 218, 40, 70098, 41.6512, 0.726950577406662, -74.8719, -1.30676117222394),
(4748, '12787', 218, 40, 26021, 41.7898, 0.729369603749926, -74.829, -1.30601242597484),
(4749, '12788', 218, 40, 146664, 41.8065, 0.729661073735009, -74.6093, -1.30217793760821),
(4750, '12789', 218, 40, 13257, 41.6957, 0.7277272489238, -74.5833, -1.30172415200269),
(4751, '12790', 218, 40, 153950, 41.5905, 0.725891162550702, -74.5239, -1.300687426427),
(4752, '12791', 218, 40, 70438, 41.8025, 0.72959126056493, -74.8862, -1.30701075430698),
(4753, '12792', 218, 40, 153995, 41.5229, 0.724711319976353, -74.928, -1.30774030193431),
(4754, '12801', 218, 40, 149169, 43.3181, 0.756043470708156, -73.6593, -1.28559730971426),
(4755, '12803', 218, 40, 152715, 43.2888, 0.755532089237321, -73.6376, -1.28521857326658),
(4756, '12804', 218, 40, 151960, 43.3255, 0.756172625072803, -73.6795, -1.28594986622316),
(4757, '12808', 218, 40, 146716, 43.7361, 0.763338946981492, -73.7581, -1.28732169501523),
(4758, '12809', 218, 40, 15022, 43.2209, 0.754347010675217, -73.4897, -1.28263723130288),
(4759, '12810', 218, 40, 31693, 43.4938, 0.75911001420391, -73.8969, -1.289744212017),
(4760, '12811', 218, 40, 146963, 43.6152, 0.761228843915831, -74.0248, -1.2919764881303),
(4761, '12812', 218, 40, 147262, 43.8377, 0.765112201501518, -74.4269, -1.29899445705257),
(4762, '12814', 218, 40, 147278, 43.5596, 0.760258440851722, -73.6628, -1.28565839623808);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(4763, '12815', 218, 40, 147337, 43.6933, 0.762591946061638, -73.7235, -1.28671781109404),
(4764, '12816', 218, 40, 1302, 43.0294, 0.751004705157648, -73.3819, -1.28075576636923),
(4765, '12817', 218, 40, 45721, 43.6347, 0.76156918311997, -73.8061, -1.28815945305619),
(4766, '12819', 218, 40, 35275, 43.6373, 0.761614561680522, -73.4379, -1.28173315075034),
(4767, '12820', 218, 40, 147860, 43.4727, 0.758741749731739, -73.641, -1.28527791446114),
(4768, '12821', 218, 40, 130316, 43.4605, 0.758528819562996, -73.37, -1.28054807218824),
(4769, '12822', 218, 40, 743, 43.2446, 0.75476065370794, -73.8388, -1.28873017572159),
(4770, '12823', 218, 40, 148060, 43.1945, 0.753886243752691, -73.4245, -1.28149927663058),
(4771, '12824', 218, 40, 148288, 43.5123, 0.759432900115529, -73.6932, -1.28618897633069),
(4772, '12827', 218, 40, 148901, 43.4175, 0.757778327984638, -73.5195, -1.28315733941997),
(4773, '12828', 218, 40, 148907, 43.2719, 0.755237128593734, -73.5835, -1.28427435014125),
(4774, '12831', 218, 40, 149045, 43.1828, 0.753682040230207, -73.693, -1.28618548567218),
(4775, '12832', 218, 40, 55048, 43.4055, 0.757568888474399, -73.2643, -1.27870325916888),
(4776, '12833', 218, 40, 149283, 43.1289, 0.752741307763382, -73.857, -1.28904782564545),
(4777, '12834', 218, 40, 32630, 43.0924, 0.752104262586404, -73.5011, -1.2828361988376),
(4778, '12835', 218, 40, 27352, 43.3159, 0.756005073464612, -73.9073, -1.28992572625921),
(4779, '12836', 218, 40, 16318, 43.7896, 0.764272698131309, -73.4998, -1.28281350955733),
(4780, '12837', 218, 40, 2957, 43.4651, 0.758609104708587, -73.2724, -1.27884463083829),
(4781, '12838', 218, 40, 2998, 43.3348, 0.756334940693239, -73.4025, -1.28111530419514),
(4782, '12839', 218, 40, 149742, 43.307, 0.755849739161184, -73.5781, -1.28418010236164),
(4783, '12841', 218, 40, 149748, 43.6395, 0.761652958924065, -73.5073, -1.28294440925123),
(4784, '12842', 218, 40, 22151, 43.7484, 0.763553622479487, -74.2604, -1.296088483848),
(4785, '12843', 218, 40, 482, 43.5953, 0.760881523394684, -74.0782, -1.29290849395086),
(4786, '12844', 218, 40, 0, 43.4888, 0.75902274774131, -73.6296, -1.28507894692642),
(4787, '12845', 218, 40, 131640, 43.4236, 0.75788479306901, -73.7096, -1.28647521032801),
(4788, '12846', 218, 40, 150119, 43.3145, 0.755980638855084, -73.8182, -1.28837063789568),
(4789, '12847', 218, 40, 60680, 43.9491, 0.76705649828824, -74.4468, -1.29934177757371),
(4790, '12848', 218, 40, 150703, 43.1003, 0.752242143597312, -73.5256, -1.28326380450434),
(4791, '12849', 218, 40, 150704, 43.4513, 0.758368249271812, -73.3005, -1.2793350683581),
(4792, '12850', 218, 40, 663, 43.0839, 0.751955909599985, -73.9484, -1.29064305658177),
(4793, '12851', 218, 40, 37221, 43.7718, 0.763962029524454, -73.9947, -1.29145114402545),
(4794, '12852', 218, 40, 49796, 44.0157, 0.768218887570068, -74.131, -1.29383002779592),
(4795, '12853', 218, 40, 151171, 43.7113, 0.762906105326997, -73.9153, -1.29006535259936),
(4796, '12854', 218, 40, 151194, 43.5092, 0.759378794908717, -73.3338, -1.27991626299902),
(4797, '12855', 218, 40, 151214, 44.0017, 0.767974541474789, -73.8013, -1.28807567725209),
(4798, '12856', 218, 40, 56579, 43.7381, 0.763373853566532, -74.0495, -1.29240758445554),
(4799, '12857', 218, 40, 151385, 43.8622, 0.765539807168257, -74.0642, -1.29266414785558),
(4800, '12858', 218, 40, 151545, 43.8793, 0.765838258470348, -73.4012, -1.28109261491486),
(4801, '12859', 218, 40, 151868, 43.1671, 0.753408023537644, -73.8892, -1.28960982166459),
(4802, '12860', 218, 40, 30886, 43.6984, 0.76268095785349, -73.7586, -1.28733042166149),
(4803, '12861', 218, 40, 151941, 43.7508, 0.763595510381535, -73.4164, -1.28135790496117),
(4804, '12862', 218, 40, 152117, 43.6616, 0.762038676688756, -73.8974, -1.28975293866326),
(4805, '12863', 218, 40, 152155, 43.0615, 0.751564955847538, -73.9241, -1.29021894157354),
(4806, '12864', 218, 40, 152279, 43.7281, 0.763199320641332, -74.3061, -1.29688609931616),
(4807, '12865', 218, 40, 126, 43.1517, 0.753139242832837, -73.3451, -1.28011348520449),
(4808, '12866', 218, 40, 90618, 43.0789, 0.751868643137385, -73.7768, -1.28764807158535),
(4809, '12870', 218, 40, 152413, 43.8489, 0.765307678377742, -73.7674, -1.28748401063566),
(4810, '12871', 218, 40, 152421, 43.0954, 0.752156622463964, -73.6054, -1.28465657724743),
(4811, '12872', 218, 40, 504, 43.8817, 0.765880146372396, -73.7252, -1.28674748169132),
(4812, '12873', 218, 40, 152567, 43.1285, 0.752734326446375, -73.3063, -1.27943629745472),
(4813, '12874', 218, 40, 138111, 43.7021, 0.762745535035814, -73.5189, -1.28314686744446),
(4814, '12878', 218, 40, 69146, 43.4278, 0.757958096897593, -73.9659, -1.29094848920087),
(4815, '12879', 218, 40, 49796, 44.0166, 0.768234595533336, -74.1303, -1.29381781049115),
(4816, '12883', 218, 40, 153133, 43.8469, 0.765272771792702, -73.4292, -1.28158130710542),
(4817, '12884', 218, 40, 153383, 43.0877, 0.752022232111561, -73.5936, -1.2844506283957),
(4818, '12885', 218, 40, 28908, 43.5011, 0.759237423239305, -73.7878, -1.28784005780307),
(4819, '12886', 218, 40, 153757, 43.4354, 0.758090741920745, -73.7182, -1.28662530864368),
(4820, '12887', 218, 40, 12826, 43.5433, 0.759973952183647, -73.4062, -1.28117988137746),
(4821, '12901', 218, 40, 151778, 44.6975, 0.780118542410165, -73.4666, -1.28223406024567),
(4822, '12903', 218, 40, 151778, 44.7095, 0.780327981920405, -73.4733, -1.28235099730555),
(4823, '12910', 218, 40, 34544, 44.962, 0.784734938281691, -73.4066, -1.28118686269447),
(4824, '12911', 218, 40, 149970, 44.5311, 0.777214314534847, -73.5011, -1.2828361988376),
(4825, '12912', 218, 40, 146914, 44.4387, 0.775601630306004, -73.6733, -1.28584165580954),
(4826, '12913', 218, 40, 13040, 44.4012, 0.774947131836506, -74.0702, -1.2927688676107),
(4827, '12914', 218, 40, 129883, 44.9505, 0.784534225417711, -74.5983, -1.30198595139049),
(4828, '12915', 218, 40, 147327, 44.8581, 0.782921541188868, -74.0339, -1.29213531309223),
(4829, '12916', 218, 40, 108395, 44.8297, 0.782425867681302, -74.5268, -1.30073804097531),
(4830, '12917', 218, 40, 35064, 44.9265, 0.784115346397232, -74.1794, -1.29467476715388),
(4831, '12918', 218, 40, 147521, 44.6746, 0.779718862011459, -73.6674, -1.28573868138367),
(4832, '12919', 218, 40, 100677, 44.9485, 0.784499318832671, -73.452, -1.28197924217487),
(4833, '12920', 218, 40, 147735, 44.9262, 0.784110110409477, -74.0796, -1.29293292856039),
(4834, '12921', 218, 40, 147748, 44.8909, 0.783494009183523, -73.4664, -1.28223056958716),
(4835, '12922', 218, 40, 147788, 44.301, 0.773198311926008, -74.6978, -1.30372255399622),
(4836, '12923', 218, 40, 122367, 44.9515, 0.784551678710231, -73.9341, -1.29039347449874),
(4837, '12924', 218, 40, 149970, 44.4723, 0.776188060934674, -73.5909, -1.2844035045059),
(4838, '12926', 218, 40, 147999, 44.935, 0.784263699383652, -74.3031, -1.2968337394386),
(4839, '12927', 218, 40, 145052, 44.222, 0.771819501816932, -74.833, -1.30608223914492),
(4840, '12928', 218, 40, 15678, 43.9524, 0.767114094153556, -73.5112, -1.28301247709206),
(4841, '12929', 218, 40, 148181, 44.7202, 0.780514732150368, -73.7216, -1.28668464983825),
(4842, '12930', 218, 40, 148294, 44.7199, 0.780509496162612, -74.5368, -1.30091257390051),
(4843, '12932', 218, 40, 27070, 44.2272, 0.771910258938036, -73.6277, -1.28504578567063),
(4844, '12933', 218, 40, 148632, 44.894, 0.783548114390334, -73.8367, -1.2886935238073),
(4845, '12934', 218, 40, 148633, 44.8284, 0.782403178401026, -73.8585, -1.28907400558423),
(4846, '12935', 218, 40, 148634, 44.8426, 0.782651015154809, -73.7227, -1.28670384846002),
(4847, '12936', 218, 40, 8781, 44.2628, 0.772531596151746, -73.3746, -1.28062835733383),
(4848, '12937', 218, 40, 148904, 44.9548, 0.784609274575547, -74.4873, -1.30004863592077),
(4849, '12939', 218, 40, 149024, 44.432, 0.775484693246121, -74.1813, -1.29470792840967),
(4850, '12941', 218, 40, 9722, 44.3534, 0.774112864454053, -73.7144, -1.28655898613211),
(4851, '12942', 218, 40, 16697, 44.2549, 0.772393715140839, -73.7834, -1.28776326331598),
(4852, '12943', 218, 40, 149965, 44.2033, 0.771493125246809, -73.7734, -1.28758873039078),
(4853, '12944', 218, 40, 149970, 44.5165, 0.776959496464056, -73.4856, -1.28256567280355),
(4854, '12945', 218, 40, 150103, 44.3681, 0.774369427854096, -74.2513, -1.29592965888607),
(4855, '12946', 218, 40, 16806, 44.2827, 0.772878916672893, -73.9878, -1.29133071630706),
(4856, '12949', 218, 40, 3698, 44.7584, 0.78118144792463, -74.6623, -1.30310296211176),
(4857, '12950', 218, 40, 3744, 44.3171, 0.773479309935579, -73.5809, -1.2842289715807),
(4858, '12952', 218, 40, 150439, 44.7175, 0.780467608260564, -73.9194, -1.2901369110987),
(4859, '12953', 218, 40, 3960, 44.8505, 0.782788896165717, -74.2833, -1.2964881642467),
(4860, '12955', 218, 40, 150439, 44.7905, 0.78174169861452, -73.9619, -1.29087867603079),
(4861, '12956', 218, 40, 150784, 44.0777, 0.769300991706305, -73.5181, -1.28313290481044),
(4862, '12957', 218, 40, 150805, 44.8656, 0.783052440882768, -74.5739, -1.301560091053),
(4863, '12958', 218, 40, 150835, 44.963, 0.78475239157421, -73.5847, -1.28429529409227),
(4864, '12959', 218, 40, 150836, 44.9637, 0.784764608878974, -73.695, -1.28622039225722),
(4865, '12960', 218, 40, 4325, 44.0394, 0.768632530602791, -73.5129, -1.28304214768934),
(4866, '12961', 218, 40, 150856, 44.0533, 0.768875131368818, -73.5353, -1.28343310144179),
(4867, '12962', 218, 40, 27951, 44.6887, 0.77996495343599, -73.5762, -1.28414694110585),
(4868, '12964', 218, 40, 151044, 44.1453, 0.770480834280653, -73.607, -1.28468450251547),
(4869, '12965', 218, 40, 151104, 44.7188, 0.78049029754084, -74.6521, -1.30292493852806),
(4870, '12966', 218, 40, 128281, 44.7798, 0.781554948384557, -74.4547, -1.29947965858462),
(4871, '12967', 218, 40, 151223, 44.7605, 0.781218099838922, -74.6527, -1.30293541050357),
(4872, '12969', 218, 40, 128453, 44.7176, 0.780469353589816, -74.0812, -1.29296085382842),
(4873, '12970', 218, 40, 151594, 44.4346, 0.775530071806672, -74.2768, -1.29637471784532),
(4874, '12972', 218, 40, 33609, 44.5853, 0.778160282989428, -73.5283, -1.28331092839415),
(4875, '12973', 218, 40, 151691, 44.2311, 0.771978326778864, -74.5686, -1.30146758860264),
(4876, '12974', 218, 40, 151849, 44.0452, 0.768733759699406, -73.4612, -1.28213981246606),
(4877, '12975', 218, 40, 151855, 44.526, 0.777125302742995, -73.4096, -1.28123922257203),
(4878, '12976', 218, 40, 151968, 44.493, 0.776549344089837, -74.1229, -1.2936886561265),
(4879, '12977', 218, 40, 151992, 44.3, 0.773180858633488, -74.0856, -1.29303764831551),
(4880, '12978', 218, 40, 57124, 44.6079, 0.778554727400379, -73.8025, -1.28809662120312),
(4881, '12979', 218, 40, 152245, 44.9885, 0.785197450533469, -73.3691, -1.28053236422497),
(4882, '12980', 218, 40, 152309, 44.6595, 0.779455317294408, -74.5126, -1.30049020422153),
(4883, '12981', 218, 40, 24673, 44.6798, 0.779809619132562, -73.8228, -1.28845092304127),
(4884, '12983', 218, 40, 152362, 44.3452, 0.773969747455389, -74.1355, -1.29390856761226),
(4885, '12985', 218, 40, 152417, 44.5602, 0.777722205347177, -73.7573, -1.28730773238121),
(4886, '12986', 218, 40, 153226, 44.2343, 0.772034177314928, -74.4632, -1.29962801157104),
(4887, '12987', 218, 40, 153299, 44.3272, 0.77365558819003, -73.84, -1.28875111967261),
(4888, '12989', 218, 40, 133508, 44.4692, 0.776133955727862, -74.0409, -1.29225748613987),
(4889, '12992', 218, 40, 153591, 44.7807, 0.781570656347825, -73.5051, -1.28290601200768),
(4890, '12993', 218, 40, 25961, 44.1791, 0.771070755567827, -73.4342, -1.28166857356802),
(4891, '12995', 218, 40, 153774, 44.8097, 0.782076801830903, -74.2619, -1.29611466378678),
(4892, '12996', 218, 40, 153848, 44.3667, 0.774344993244568, -73.3989, -1.28105247234207),
(4893, '12997', 218, 40, 14869, 44.3909, 0.774767362923551, -73.8423, -1.28879126224541),
(4894, '12998', 218, 40, 84458, 44.0899, 0.769513921875048, -73.5385, -1.28348895197785),
(4895, '13020', 218, 40, 146840, 42.8178, 0.747311588460428, -76.0727, -1.32771908588189),
(4896, '13021', 218, 40, 13306, 42.9221, 0.749131966870258, -76.5576, -1.33618218742481),
(4897, '13022', 218, 40, 13306, 42.9223, 0.749135457528762, -76.5519, -1.33608270365745),
(4898, '13024', 218, 40, 13306, 42.9222, 0.74913371219951, -76.5526, -1.33609492096221),
(4899, '13026', 218, 40, 474, 42.7438, 0.746020044813952, -76.6522, -1.3378332688972),
(4900, '13027', 218, 40, 146978, 43.1651, 0.753373116952604, -76.3366, -1.3323250097779),
(4901, '13028', 218, 40, 147171, 43.2662, 0.755137644826371, -75.987, -1.32622333871293),
(4902, '13029', 218, 40, 79926, 43.2256, 0.754429041150061, -76.1394, -1.32888322049297),
(4903, '13030', 218, 40, 1130, 43.1606, 0.753294577136265, -75.9867, -1.32621810272518),
(4904, '13031', 218, 40, 113180, 43.0425, 0.751233343289659, -76.2869, -1.33145758113966),
(4905, '13032', 218, 40, 147572, 43.0866, 0.752003033489789, -75.7669, -1.32238186902929),
(4906, '13033', 218, 40, 7954, 43.1939, 0.753875771777179, -76.5638, -1.33629039783843),
(4907, '13034', 218, 40, 29419, 42.926, 0.749200034711086, -76.7216, -1.33904452739808),
(4908, '13035', 218, 40, 119059, 42.9453, 0.749536883256721, -75.8388, -1.32363676076148),
(4909, '13036', 218, 40, 77996, 43.2892, 0.755539070554329, -76.1512, -1.32908916934471),
(4910, '13037', 218, 40, 147800, 43.0567, 0.751481180043442, -75.8746, -1.32426158863369),
(4911, '13039', 218, 40, 32068, 43.1588, 0.753263161209729, -76.1374, -1.32884831390793),
(4912, '13040', 218, 40, 147817, 42.5616, 0.742840054916819, -75.9293, -1.32521628373453),
(4913, '13041', 218, 40, 1601, 43.1725, 0.753502271317252, -76.13, -1.32871915954328),
(4914, '13042', 218, 40, 1620, 43.2378, 0.754641971318804, -75.8837, -1.32442041359562),
(4915, '13043', 218, 40, 113178, 43.0417, 0.751219380655643, -75.7451, -1.32200138725236),
(4916, '13044', 218, 40, 148002, 43.2661, 0.755135899497119, -76.0089, -1.32660556581912),
(4917, '13045', 218, 40, 29554, 42.5883, 0.743306057827101, -76.1821, -1.32962847608357),
(4918, '13051', 218, 40, 148255, 42.879, 0.748379729962649, -75.914, -1.32494924835898),
(4919, '13052', 218, 40, 0, 42.7316, 0.745807114645209, -75.9073, -1.32483231129909),
(4920, '13053', 218, 40, 8610, 42.4872, 0.741541529953335, -76.2939, -1.3315797541873),
(4921, '13054', 218, 40, 86636, 43.133, 0.752812866262714, -75.6249, -1.31990350149146),
(4922, '13056', 218, 40, 148472, 42.6744, 0.744808786313068, -76.0983, -1.3281658901704),
(4923, '13057', 218, 40, 148542, 43.0738, 0.751779631345533, -76.0545, -1.32740143595803),
(4924, '13060', 218, 40, 27064, 43.0251, 0.750929655999812, -76.4198, -1.33377712371556),
(4925, '13061', 218, 40, 148699, 42.864, 0.748117930574849, -75.7491, -1.32207120042244),
(4926, '13062', 218, 40, 314, 42.4802, 0.741419356905695, -76.391, -1.33327446889099),
(4927, '13063', 218, 40, 2358, 42.8552, 0.747964341600674, -75.9842, -1.32617446949388),
(4928, '13064', 218, 40, 54696, 43.3181, 0.756043470708156, -76.7047, -1.33874956675449),
(4929, '13065', 218, 40, 2426, 42.82, 0.747349985703972, -76.8135, -1.34064848498066),
(4930, '13066', 218, 40, 2428, 43.0276, 0.750973289231112, -76.0123, -1.32666490701369),
(4931, '13068', 218, 40, 148980, 42.5026, 0.741810310658142, -76.3568, -1.33267756628681),
(4932, '13069', 218, 40, 2628, 43.3185, 0.756050452025164, -76.4129, -1.33365669599718),
(4933, '13071', 218, 40, 9080, 42.6716, 0.744759917094012, -76.5409, -1.33589071743973),
(4934, '13072', 218, 40, 2693, 42.7631, 0.746356893359587, -75.7536, -1.32214974023878),
(4935, '13073', 218, 40, 113503, 42.5864, 0.743272896571313, -76.3915, -1.33328319553725),
(4936, '13074', 218, 40, 55163, 43.3141, 0.755973657538076, -76.5713, -1.33642129753233),
(4937, '13076', 218, 40, 16375, 43.3521, 0.756636882653834, -76.1497, -1.32906298940593),
(4938, '13077', 218, 40, 22029, 42.6762, 0.744840202239604, -76.1894, -1.32975588511897),
(4939, '13078', 218, 40, 3401, 42.9846, 0.750222797652755, -76.0758, -1.3277731910887),
(4940, '13080', 218, 40, 3460, 43.0709, 0.751729016797226, -76.4589, -1.33445954745309),
(4941, '13081', 218, 40, 150022, 42.6637, 0.744622036083105, -76.627, -1.33739344592569),
(4942, '13082', 218, 40, 36734, 43.0829, 0.751938456307465, -75.9726, -1.32597201130064),
(4943, '13083', 218, 40, 116356, 43.6467, 0.761778622630209, -76.0604, -1.3275044103839),
(4944, '13084', 218, 40, 36766, 42.8887, 0.748549026900092, -76.1051, -1.32828457255954),
(4945, '13087', 218, 40, 30356, 42.7039, 0.745323658442406, -76.1579, -1.32920610640459),
(4946, '13088', 218, 40, 3824, 43.1118, 0.752442856461291, -76.1953, -1.32985885954484),
(4947, '13089', 218, 40, 3824, 43.1383, 0.75290536871307, -76.2267, -1.33040689292996),
(4948, '13090', 218, 40, 3824, 43.1496, 0.753102590918545, -76.223, -1.33034231574764),
(4949, '13092', 218, 40, 10143, 42.651, 0.744400379268102, -76.4221, -1.33381726628836),
(4950, '13093', 218, 40, 150429, 43.4988, 0.759197280666509, -76.3864, -1.3331941837454),
(4951, '13101', 218, 40, 33227, 42.6004, 0.743517242666592, -76.0822, -1.32788489216083),
(4952, '13102', 218, 40, 73416, 42.5543, 0.742712645881423, -76.2929, -1.33156230089478),
(4953, '13103', 218, 40, 82230, 43.3227, 0.756123755853747, -76.0977, -1.32815541819489),
(4954, '13104', 218, 40, 120492, 42.9916, 0.750344970700394, -75.9712, -1.32594757669112),
(4955, '13107', 218, 40, 49213, 43.4577, 0.75847995034394, -76.1451, -1.32898270426033),
(4956, '13108', 218, 40, 37053, 42.9794, 0.750132040531651, -76.3357, -1.33230930181464),
(4957, '13110', 218, 40, 3993, 42.8889, 0.748552517558596, -76.2835, -1.33139823994509),
(4958, '13111', 218, 40, 150595, 43.2341, 0.75457739413648, -76.6183, -1.33724160228077),
(4959, '13112', 218, 40, 4163, 43.1048, 0.752320683413652, -76.4173, -1.33373349048426),
(4960, '13113', 218, 40, 10448, 43.1658, 0.753385334257368, -76.5369, -1.33582090426965),
(4961, '13114', 218, 40, 37178, 43.4606, 0.758530564892248, -76.2349, -1.33055000992863),
(4962, '13115', 218, 40, 150782, 43.399, 0.757455442073019, -76.4924, -1.33504423275251),
(4963, '13116', 218, 40, 150789, 43.077, 0.751835481881597, -76.0102, -1.32662825509939),
(4964, '13117', 218, 40, 23157, 43.0097, 0.750660875295005, -76.7031, -1.33872164148646),
(4965, '13118', 218, 40, 76631, 42.75, 0.746128255227576, -76.4376, -1.33408779232242),
(4966, '13119', 218, 40, 132183, 42.974, 0.750037792752043, -76.4425, -1.33417331345577),
(4967, '13120', 218, 40, 150977, 42.9628, 0.74984231587582, -76.16, -1.32924275831888),
(4968, '13121', 218, 40, 4528, 43.48, 0.758869158767134, -76.3153, -1.33195325464723),
(4969, '13122', 218, 40, 151057, 42.8538, 0.747939906991146, -75.9151, -1.32496844698075),
(4970, '13123', 218, 40, 151135, 43.2299, 0.754504090307897, -75.7491, -1.32207120042244),
(4971, '13124', 218, 40, 151243, 42.4383, 0.74068806394911, -75.4727, -1.31724711036992),
(4972, '13126', 218, 40, 33527, 43.4525, 0.758389193222836, -76.503, -1.33522923765322),
(4973, '13129', 218, 40, 2693, 42.6661, 0.744663923985153, -75.7592, -1.32224747867689),
(4974, '13131', 218, 40, 4862, 43.4085, 0.757621248351958, -76.109, -1.32835264040036),
(4975, '13132', 218, 40, 113206, 43.2559, 0.754957875913415, -76.2351, -1.33055350058713),
(4976, '13134', 218, 40, 151662, 42.9669, 0.749913874375152, -75.686, -1.32096989766443),
(4977, '13135', 218, 40, 23865, 43.2475, 0.754811268256248, -76.3027, -1.33173334316148),
(4978, '13136', 218, 40, 680, 42.6148, 0.74376857007888, -75.8541, -1.32390379613703),
(4979, '13137', 218, 40, 23999, 43.1522, 0.753147969479097, -76.4464, -1.33424138129659),
(4980, '13138', 218, 40, 151823, 42.9036, 0.748809080958639, -76.016, -1.32672948419601),
(4981, '13139', 218, 40, 5177, 42.7387, 0.745931033022101, -76.6002, -1.33692569768616),
(4982, '13140', 218, 40, 121091, 43.0343, 0.751090226290996, -76.6366, -1.33756099753389),
(4983, '13141', 218, 40, 97229, 42.738, 0.745918815717337, -76.1555, -1.32916421850254),
(4984, '13142', 218, 40, 11424, 43.5567, 0.760207826303414, -76.1281, -1.3286859982875),
(4985, '13143', 218, 40, 152005, 43.2349, 0.754591356770496, -76.7321, -1.33922778696954),
(4986, '13144', 218, 40, 5374, 43.5622, 0.760303819412274, -76.0136, -1.32668759629396),
(4987, '13145', 218, 40, 24653, 43.6533, 0.761893814360841, -76.1169, -1.32849052141127),
(4988, '13146', 218, 40, 24690, 43.1045, 0.752315447425896, -76.7604, -1.33972171514786),
(4989, '13147', 218, 40, 152425, 42.7718, 0.746508737004511, -76.5642, -1.33629737915544),
(4990, '13148', 218, 40, 152468, 42.91, 0.748920782030767, -76.7928, -1.3402872018255),
(4991, '13152', 218, 40, 152589, 42.9142, 0.748994085859351, -76.3967, -1.33337395265835),
(4992, '13153', 218, 40, 152593, 42.9926, 0.750362423992914, -76.4546, -1.33438449829526),
(4993, '13154', 218, 40, 133175, 43.1316, 0.752788431653186, -76.7622, -1.33975313107439),
(4994, '13155', 218, 40, 152752, 42.666, 0.744662178655901, -75.7599, -1.32225969598165),
(4995, '13156', 218, 40, 25116, 43.3156, 0.755999837476856, -76.702, -1.33870244286469),
(4996, '13157', 218, 40, 98409, 43.2075, 0.75411313655545, -75.7275, -1.32169420930401),
(4997, '13158', 218, 40, 57947, 42.6936, 0.745143889529451, -76.013, -1.32667712431845),
(4998, '13159', 218, 40, 18388, 42.8212, 0.747370929654996, -76.1452, -1.32898444958959),
(4999, '13160', 218, 40, 6474, 42.8416, 0.747726976822403, -76.6899, -1.3384912580252),
(5000, '13162', 218, 40, 153368, 43.1918, 0.753839119862887, -75.7283, -1.32170817193802),
(5001, '13163', 218, 40, 153448, 43.0798, 0.751884351100653, -75.7076, -1.32134688878286),
(5002, '13164', 218, 40, 153457, 43.0924, 0.752104262586404, -76.3105, -1.33186947884313),
(5003, '13165', 218, 40, 6650, 42.9092, 0.748906819396751, -76.8773, -1.34176200504344),
(5004, '13166', 218, 40, 153537, 43.0558, 0.751465472080175, -76.5581, -1.33619091407107),
(5005, '13167', 218, 40, 44080, 43.2864, 0.755490201335273, -76.075, -1.32775922845469),
(5006, '13201', 218, 40, 57818, 43.043, 0.751242069935919, -76.1512, -1.32908916934471),
(5007, '13202', 218, 40, 57818, 43.0445, 0.751268249874699, -76.1513, -1.32909091467396),
(5008, '13203', 218, 40, 57818, 43.0604, 0.751545757225766, -76.1373, -1.32884656857868),
(5009, '13204', 218, 40, 57818, 43.0481, 0.751331081727771, -76.1779, -1.32955517225499),
(5010, '13205', 218, 40, 57818, 43.0086, 0.750641676673233, -76.1459, -1.32899666689435),
(5011, '13206', 218, 40, 57818, 43.07, 0.751713308833958, -76.1091, -1.32835438572962),
(5012, '13207', 218, 40, 57818, 43.0196, 0.750833662890953, -76.1677, -1.32937714867128),
(5013, '13208', 218, 40, 57818, 43.0747, 0.751795339308801, -76.1493, -1.32905600808892),
(5014, '13209', 218, 40, 57818, 43.0791, 0.751872133795889, -76.241, -1.330656475013),
(5015, '13210', 218, 40, 57818, 43.0356, 0.751112915571272, -76.1271, -1.32866854499498),
(5016, '13211', 218, 40, 57818, 43.0983, 0.752207237012272, -76.1323, -1.32875930211608),
(5017, '13212', 218, 40, 57818, 43.1286, 0.752736071775626, -76.1359, -1.32882213396915),
(5018, '13214', 218, 40, 57818, 43.0391, 0.751174002095091, -76.0758, -1.3277731910887),
(5019, '13215', 218, 40, 57818, 42.9962, 0.750425255845986, -76.2216, -1.33031788113811),
(5020, '13217', 218, 40, 57818, 43.0508, 0.751378205617575, -76.1216, -1.32857255188612),
(5021, '13218', 218, 40, 57818, 43.0479, 0.751327591069267, -76.148, -1.32903331880864),
(5022, '13219', 218, 40, 57818, 43.0383, 0.751160039461076, -76.2202, -1.33029344652858),
(5023, '13220', 218, 40, 57818, 43.1266, 0.752701165190587, -76.1327, -1.32876628343309),
(5024, '13221', 218, 40, 57818, 43.0467, 0.751306647118243, -76.1494, -1.32905775341817),
(5025, '13224', 218, 40, 57818, 43.0406, 0.751200182033871, -76.1022, -1.32823395801123),
(5026, '13225', 218, 40, 57818, 43.1275, 0.752716873153854, -76.1322, -1.32875755678683),
(5027, '13235', 218, 40, 57818, 43.0482, 0.751332827057023, -76.148, -1.32903331880864),
(5028, '13244', 218, 40, 57818, 43.0385, 0.751163530119579, -76.1373, -1.32884656857868),
(5029, '13250', 218, 40, 57818, 43.1229, 0.752636588008263, -76.1315, -1.32874533948206),
(5030, '13251', 218, 40, 57818, 43.1229, 0.752636588008263, -76.132, -1.32875406612832),
(5031, '13252', 218, 40, 57818, 43.0513, 0.751386932263835, -76.1559, -1.32917119981955),
(5032, '13260', 218, 40, 57818, 43.0416, 0.751217635326391, -76.1442, -1.32896699629707),
(5033, '13261', 218, 40, 57818, 43.0435, 0.751250796582179, -76.1512, -1.32908916934471),
(5034, '13290', 218, 40, 57818, 43.0479, 0.751327591069267, -76.1479, -1.32903157347939),
(5035, '13301', 218, 40, 146744, 43.417, 0.757769601338378, -75.2143, -1.31273717958277),
(5036, '13302', 218, 40, 118607, 43.5055, 0.759314217726393, -75.9914, -1.32630013320002),
(5037, '13303', 218, 40, 7203, 43.3045, 0.755806105929884, -75.4346, -1.31658213992491),
(5038, '13304', 218, 40, 147011, 43.2526, 0.754900280048099, -75.1917, -1.31234273517182),
(5039, '13305', 218, 40, 134153, 43.8864, 0.765962176847239, -75.4276, -1.31645996687728),
(5040, '13308', 218, 40, 147260, 43.2408, 0.754694331196364, -75.649, -1.32032412584119),
(5041, '13309', 218, 40, 29261, 43.4849, 0.758954679900482, -75.3338, -1.3148228480389),
(5042, '13310', 218, 40, 147301, 42.8965, 0.748685162581748, -75.5731, -1.31899942093893),
(5043, '13312', 218, 40, 147339, 43.6887, 0.762511660916047, -75.2921, -1.31409504574082),
(5044, '13313', 218, 40, 19494, 42.8772, 0.748348314036113, -75.2504, -1.31336724344274),
(5045, '13314', 218, 40, 13444, 42.808, 0.747140546193733, -75.3419, -1.31496421970832),
(5046, '13315', 218, 40, 147481, 42.748, 0.746093348642536, -75.1581, -1.31175630454315),
(5047, '13316', 218, 40, 1304, 43.3377, 0.756385555241546, -75.755, -1.3221741748483),
(5048, '13317', 218, 40, 147564, 42.9022, 0.748784646349111, -74.5733, -1.30154961907749),
(5049, '13318', 218, 40, 19837, 42.9397, 0.749439144818609, -75.2872, -1.31400952460747),
(5050, '13319', 218, 40, 147710, 43.0253, 0.750933146658316, -75.2669, -1.31365522276932),
(5051, '13320', 218, 40, 8055, 42.7972, 0.746952050634517, -74.7534, -1.30469295706033),
(5052, '13321', 218, 40, 147832, 43.0923, 0.752102517257152, -75.3749, -1.31554017836147),
(5053, '13322', 218, 40, 70667, 42.9733, 0.750025575447279, -75.2444, -1.31326252368762),
(5054, '13323', 218, 40, 1630, 43.0577, 0.751498633335962, -75.3759, -1.31555763165399),
(5055, '13324', 218, 40, 127134, 43.4602, 0.75852358357524, -74.9339, -1.30784327636018),
(5056, '13325', 218, 40, 148001, 43.5784, 0.760586562751097, -75.5644, -1.318847577294),
(5057, '13326', 218, 40, 26853, 42.7147, 0.745512154001622, -74.904, -1.30732142291383),
(5058, '13327', 218, 40, 148120, 43.8909, 0.766040716663579, -75.3837, -1.31569376733565),
(5059, '13328', 218, 40, 148226, 42.9948, 0.750400821236458, -75.431, -1.31651930807184),
(5060, '13329', 218, 40, 148312, 43.1005, 0.752245634255816, -74.7749, -1.30506820284951),
(5061, '13331', 218, 40, 148385, 43.8173, 0.764756154334111, -74.8769, -1.30684843868654),
(5062, '13332', 218, 40, 2153, 42.7453, 0.746046224752732, -75.5681, -1.31891215447633),
(5063, '13333', 218, 40, 27039, 42.8328, 0.747573387848227, -74.7597, -1.3048029128032),
(5064, '13334', 218, 40, 8676, 42.8302, 0.747528009287675, -75.6553, -1.32043408158407),
(5065, '13335', 218, 40, 148607, 42.6976, 0.745213702699531, -75.2389, -1.31316653057876),
(5066, '13337', 218, 40, 148871, 42.7362, 0.745887399790801, -74.9924, -1.3088642939726),
(5067, '13338', 218, 40, 148893, 43.5017, 0.759247895214817, -75.1603, -1.31179470178669),
(5068, '13339', 218, 40, 148924, 42.9312, 0.74929079183219, -74.6264, -1.3024763889103),
(5069, '13340', 218, 40, 2594, 43.0404, 0.751196691375367, -75.0816, -1.31042112766537),
(5070, '13341', 218, 40, 21287, 43.0365, 0.75112862353454, -75.3921, -1.31584037499282),
(5071, '13342', 218, 40, 149064, 42.6378, 0.744169995806838, -75.226, -1.31294138310525),
(5072, '13343', 218, 40, 60054, 43.7229, 0.763108563520229, -75.2604, -1.31354177636794),
(5073, '13345', 218, 40, 41208, 43.6831, 0.762413922477935, -75.3132, -1.31446331021299),
(5074, '13346', 218, 40, 2950, 42.8212, 0.747370929654996, -75.5452, -1.31851247407762),
(5075, '13348', 218, 40, 115968, 42.663, 0.744609818778341, -75.0471, -1.30981898907344),
(5076, '13350', 218, 40, 32738, 43.0284, 0.750987251865128, -74.9874, -1.30877702751),
(5077, '13352', 218, 40, 94928, 43.2758, 0.755305196434562, -75.1765, -1.31207744512552),
(5078, '13353', 218, 40, 149656, 43.4715, 0.758720805780715, -74.7282, -1.30425313408883),
(5079, '13354', 218, 40, 149666, 43.2366, 0.75462102736778, -75.2651, -1.31362380684278),
(5080, '13355', 218, 40, 22083, 42.8157, 0.747274936546136, -75.4566, -1.31696611236035),
(5081, '13357', 218, 40, 149796, 43.0118, 0.750697527209297, -75.0439, -1.30976313853737),
(5082, '13360', 218, 40, 120123, 43.7282, 0.763201065970584, -74.738, -1.30442417635552),
(5083, '13361', 218, 40, 81815, 42.8953, 0.748664218630724, -74.8155, -1.30577680652582),
(5084, '13362', 218, 40, 150063, 42.9863, 0.750252468250038, -75.5175, -1.31802901787482),
(5085, '13363', 218, 40, 120322, 43.296, 0.755657752943465, -75.5201, -1.31807439643537),
(5086, '13364', 218, 40, 150236, 42.8088, 0.747154508827748, -75.2531, -1.31341436733254),
(5087, '13365', 218, 40, 103722, 43.0442, 0.751263013886943, -74.8605, -1.30656220468922),
(5088, '13367', 218, 40, 136601, 43.7884, 0.764251754180285, -75.4853, -1.31746702185568),
(5089, '13368', 218, 40, 150442, 43.6189, 0.761293421098155, -75.3644, -1.31535691879001),
(5090, '13401', 218, 40, 150630, 43.2708, 0.755217929971962, -75.6889, -1.32102051221274),
(5091, '13402', 218, 40, 3938, 42.9155, 0.749016775139627, -75.4931, -1.31760315753733),
(5092, '13403', 218, 40, 17020, 43.15, 0.753109572235553, -75.2534, -1.3134196033203),
(5093, '13404', 218, 40, 27815, 43.7378, 0.763368617578776, -75.4695, -1.31719125983386),
(5094, '13406', 218, 40, 110425, 43.1394, 0.752924567334842, -74.9711, -1.30849253884192),
(5095, '13407', 218, 40, 10551, 43.0083, 0.750636440685477, -75.0071, -1.30912085737264),
(5096, '13408', 218, 40, 4337, 42.9082, 0.748889366104231, -75.6746, -1.3207709301297),
(5097, '13409', 218, 40, 150939, 42.9841, 0.750214071006495, -75.5925, -1.31933801481381),
(5098, '13410', 218, 40, 150979, 42.9327, 0.749316971770969, -74.612, -1.30222506149801),
(5099, '13411', 218, 40, 17254, 42.6237, 0.743923904382307, -75.333, -1.31480888540489),
(5100, '13413', 218, 40, 28028, 43.0689, 0.751694110212186, -75.2916, -1.31408631909456),
(5101, '13415', 218, 40, 30639, 42.5765, 0.743100108975366, -75.328, -1.31472161894229),
(5102, '13416', 218, 40, 10799, 43.1895, 0.753798977290091, -75.0166, -1.30928666365158),
(5103, '13417', 218, 40, 137106, 43.1026, 0.752282286170108, -75.2925, -1.31410202705783),
(5104, '13418', 218, 40, 125593, 42.8528, 0.747922453698626, -75.3777, -1.31558904758053),
(5105, '13420', 218, 40, 78879, 43.7509, 0.763597255710787, -74.92, -1.30760067559415),
(5106, '13421', 218, 40, 10986, 43.0827, 0.751934965648961, -75.6514, -1.32036601374324),
(5107, '13424', 218, 40, 112629, 43.1535, 0.753170658759373, -75.3339, -1.31482459336816),
(5108, '13425', 218, 40, 151448, 42.9375, 0.749400747575065, -75.4631, -1.31707955876173),
(5109, '13426', 218, 40, 33507, 43.5617, 0.760295092766014, -75.9905, -1.32628442523675),
(5110, '13428', 218, 40, 151525, 42.912, 0.748955688615807, -74.5726, -1.30153740177272),
(5111, '13431', 218, 40, 30868, 43.1921, 0.753844355850643, -75.0717, -1.31024834006943),
(5112, '13433', 218, 40, 151856, 43.5816, 0.760642413287161, -75.3366, -1.31487171725796),
(5113, '13435', 218, 40, 5238, 43.3072, 0.755853229819688, -75.1473, -1.31156780898393),
(5114, '13436', 218, 40, 151984, 43.8716, 0.765703868117944, -74.5527, -1.30119008125158),
(5115, '13437', 218, 40, 11515, 43.5956, 0.76088675938244, -75.8106, -1.32314457791241),
(5116, '13438', 218, 40, 113208, 43.3309, 0.756266872852411, -75.2023, -1.31252774007253),
(5117, '13439', 218, 40, 152079, 42.8518, 0.747905000406106, -74.9871, -1.30877179152224),
(5118, '13440', 218, 40, 490, 43.2238, 0.754397625223525, -75.4516, -1.31687884589775),
(5119, '13441', 218, 40, 490, 43.2137, 0.754221346969074, -75.4091, -1.31613708096566),
(5120, '13442', 218, 40, 490, 43.2193, 0.754319085407185, -75.4497, -1.31684568464197),
(5121, '13449', 218, 40, 490, 43.2255, 0.754427295820809, -75.4891, -1.31753334436725),
(5122, '13450', 218, 40, 152211, 42.7884, 0.746798461660342, -74.7434, -1.30451842413513),
(5123, '13452', 218, 40, 152300, 42.999, 0.750474125065042, -74.6794, -1.30340141341385),
(5124, '13454', 218, 40, 152323, 43.2302, 0.754509326295653, -74.7957, -1.30543123133392),
(5125, '13455', 218, 40, 152355, 42.9144, 0.748997576517855, -75.3792, -1.31561522751931),
(5126, '13456', 218, 40, 152374, 43.007, 0.750613751405201, -75.2569, -1.31348068984412),
(5127, '13457', 218, 40, 152419, 42.7799, 0.746650108673922, -75.0282, -1.30948912184481),
(5128, '13459', 218, 40, 106167, 42.795, 0.746913653390973, -74.6174, -1.30231930927762),
(5129, '13460', 218, 40, 38186, 42.6816, 0.744934450019212, -75.4972, -1.31767471603666),
(5130, '13461', 218, 40, 11910, 43.0717, 0.751742979431242, -75.5977, -1.31942877193492),
(5131, '13464', 218, 40, 452, 42.6911, 0.745100256298151, -75.6352, -1.32008327040442),
(5132, '13465', 218, 40, 152654, 42.9109, 0.748936489994035, -75.5177, -1.31803250853332),
(5133, '13468', 218, 40, 152839, 42.8421, 0.747735703468663, -74.8426, -1.30624979075311),
(5134, '13469', 218, 40, 152936, 43.2226, 0.754376681272501, -75.2859, -1.3139868353272),
(5135, '13470', 218, 40, 14683, 43.1885, 0.753781523997571, -74.6345, -1.30261776057971),
(5136, '13471', 218, 40, 153048, 43.3946, 0.757378647585931, -75.6123, -1.31968359000571),
(5137, '13472', 218, 40, 153098, 43.8394, 0.765141872098802, -74.9964, -1.30893410714268),
(5138, '13473', 218, 40, 25588, 43.6565, 0.761949664896905, -75.4279, -1.31646520286503),
(5139, '13475', 218, 40, 153346, 42.8679, 0.748185998415677, -74.8497, -1.30637370913),
(5140, '13476', 218, 40, 6535, 43.0755, 0.751809301942817, -75.5325, -1.31829081726262),
(5141, '13477', 218, 40, 114205, 43.0476, 0.751322355081511, -75.5245, -1.31815119092246),
(5142, '13478', 218, 40, 12546, 43.1397, 0.752929803322598, -75.5842, -1.3191931524859),
(5143, '13479', 218, 40, 74701, 43.0573, 0.751491652018954, -75.2726, -1.31375470653668),
(5144, '13480', 218, 40, 25838, 42.9312, 0.74929079183219, -75.3793, -1.31561697284856),
(5145, '13482', 218, 40, 118388, 42.6941, 0.745152616175711, -75.1933, -1.31237066043985),
(5146, '13483', 218, 40, 44089, 43.4131, 0.75770153349755, -75.8164, -1.32324580700903),
(5147, '13484', 218, 40, 153607, 42.8546, 0.747953869625162, -75.6606, -1.32052658403442),
(5148, '13485', 218, 40, 153608, 42.7877, 0.746786244355578, -75.3169, -1.31452788739532),
(5149, '13486', 218, 40, 153729, 43.3506, 0.756610702715054, -75.3229, -1.31463260715044),
(5150, '13488', 218, 40, 114274, 42.506, 0.74186965185271, -75.1064, -1.31085396931987),
(5151, '13489', 218, 40, 126534, 43.4715, 0.758720805780715, -75.5292, -1.3182332213973),
(5152, '13490', 218, 40, 34392, 43.1115, 0.752437620473535, -75.4157, -1.31625227269629),
(5153, '13491', 218, 40, 153714, 42.8848, 0.748480959059264, -75.1902, -1.31231655523304),
(5154, '13492', 218, 40, 6799, 43.1168, 0.752530122923891, -75.3097, -1.31440222368917),
(5155, '13493', 218, 40, 6834, 43.4227, 0.757869085105742, -75.8882, -1.32449895341196),
(5156, '13494', 218, 40, 31557, 43.5376, 0.759874468416283, -75.1192, -1.31107737146412),
(5157, '13495', 218, 40, 26297, 43.1111, 0.752430639156527, -75.2752, -1.31380008509724),
(5158, '13501', 218, 40, 31360, 43.0851, 0.751976853551009, -75.2354, -1.31310544405494),
(5159, '13502', 218, 40, 31360, 43.109, 0.752393987242236, -75.2292, -1.31299723364132),
(5160, '13503', 218, 40, 31360, 43.1025, 0.752280540840856, -75.2323, -1.31305133884813),
(5161, '13504', 218, 40, 31360, 43.0893, 0.752050157379593, -75.1885, -1.31228688463576),
(5162, '13505', 218, 40, 31360, 43.1011, 0.752256106231328, -75.2326, -1.31305657483589),
(5163, '13599', 218, 40, 31360, 43.0964, 0.752174075756484, -75.228, -1.31297628969029),
(5164, '13601', 218, 40, 18507, 43.9785, 0.767569625088326, -75.9095, -1.32487070854264),
(5165, '13602', 218, 40, 16073, 44.0483, 0.768787864906218, -75.7495, -1.32207818173944),
(5166, '13603', 218, 40, 18507, 44.0336, 0.768531301506175, -75.7594, -1.32225096933539),
(5167, '13605', 218, 40, 14941, 43.8103, 0.764633981286472, -76.0236, -1.32686212921916),
(5168, '13606', 218, 40, 146705, 43.8593, 0.765489192619949, -76.0102, -1.32662825509939),
(5169, '13607', 218, 40, 146749, 44.332, 0.773739363994126, -75.9184, -1.32502604284606),
(5170, '13608', 218, 40, 146832, 44.1992, 0.771421566747478, -75.6112, -1.31966439138394),
(5171, '13611', 218, 40, 263, 43.7887, 0.764256990168041, -76.1138, -1.32843641620446),
(5172, '13612', 218, 40, 129848, 44.0075, 0.768075770571405, -75.7963, -1.32289499582938),
(5173, '13613', 218, 40, 147341, 44.8598, 0.782951211786152, -74.7254, -1.30420426486977),
(5174, '13614', 218, 40, 77916, 44.5424, 0.777411536740322, -75.6878, -1.32100131359096),
(5175, '13615', 218, 40, 1195, 44.0068, 0.768063553266641, -75.9859, -1.32620414009116),
(5176, '13616', 218, 40, 147528, 44.0252, 0.768384693849008, -75.8553, -1.32392474008805),
(5177, '13617', 218, 40, 19763, 44.596, 0.778347033219391, -75.1695, -1.31195527207788),
(5178, '13618', 218, 40, 147588, 44.1282, 0.770182382978562, -76.333, -1.33226217792483),
(5179, '13619', 218, 40, 7932, 43.9785, 0.767569625088326, -75.6208, -1.31983194299213),
(5180, '13620', 218, 40, 147632, 43.8883, 0.765995338103027, -75.4574, -1.31698007499437),
(5181, '13621', 218, 40, 127092, 44.8614, 0.782979137054184, -75.0728, -1.3102675386912),
(5182, '13622', 218, 40, 35219, 44.0651, 0.769081080220553, -76.1268, -1.32866330900722),
(5183, '13623', 218, 40, 147799, 44.4423, 0.775664462159076, -75.7575, -1.3222178080796),
(5184, '13624', 218, 40, 608, 44.2377, 0.772093518509495, -76.0803, -1.32785173090504),
(5185, '13625', 218, 40, 93382, 44.3221, 0.773566576398179, -74.8252, -1.30594610346326),
(5186, '13626', 218, 40, 39891, 43.8938, 0.766091331211887, -75.7068, -1.32133292614884),
(5187, '13627', 218, 40, 134961, 43.9301, 0.766724885730361, -75.5891, -1.31927867361925),
(5188, '13628', 218, 40, 148242, 44.0342, 0.768541773481687, -75.6797, -1.32085994192155),
(5189, '13630', 218, 40, 148210, 44.4813, 0.776345140567354, -75.3004, -1.31423990806874),
(5190, '13631', 218, 40, 8477, 43.8993, 0.766187324320747, -75.5828, -1.31916871787637),
(5191, '13632', 218, 40, 148274, 44.1382, 0.770356915903761, -76.0654, -1.32759167684649),
(5192, '13633', 218, 40, 148213, 44.5387, 0.777346959557998, -75.42, -1.31632732185412),
(5193, '13634', 218, 40, 2038, 44.0072, 0.768070534583649, -76.068, -1.32763705540705),
(5194, '13635', 218, 40, 8695, 44.2975, 0.773137225402188, -75.2658, -1.31363602414755),
(5195, '13636', 218, 40, 35747, 43.7405, 0.76341574146858, -76.1209, -1.32856033458135),
(5196, '13637', 218, 40, 148716, 44.0882, 0.769484251277764, -75.8055, -1.32305556612056),
(5197, '13638', 218, 40, 148771, 44.0202, 0.768297427386408, -75.7457, -1.32201185922787),
(5198, '13639', 218, 40, 148796, 44.2425, 0.772177294313591, -75.1422, -1.31147879719208),
(5199, '13640', 218, 40, 0, 44.2478, 0.772269796763947, -75.1393, -1.31142818264378),
(5200, '13641', 218, 40, 124839, 44.2761, 0.772763724942261, -76.009, -1.32660731114837),
(5201, '13642', 218, 40, 149207, 44.3356, 0.773802195847198, -75.467, -1.31714762660256),
(5202, '13643', 218, 40, 32614, 44.0339, 0.768536537493931, -75.7195, -1.32155458296385),
(5203, '13645', 218, 40, 149378, 44.308, 0.773320484973648, -75.4497, -1.31684568464197),
(5204, '13646', 218, 40, 421, 44.4385, 0.7755981396475, -75.6773, -1.3208180540195),
(5205, '13647', 218, 40, 149441, 44.3218, 0.773561340410423, -74.8248, -1.30593912214625),
(5206, '13648', 218, 40, 2996, 44.1462, 0.770496542243921, -75.3023, -1.31427306932453),
(5207, '13649', 218, 40, 3052, 44.923, 0.784054259873413, -74.7261, -1.30421648217453),
(5208, '13650', 218, 40, 23, 43.8484, 0.765298951731482, -76.2291, -1.33044878083201),
(5209, '13651', 218, 40, 149565, 43.8676, 0.765634054947865, -76.193, -1.32981871697204),
(5210, '13652', 218, 40, 36382, 44.4689, 0.776128719740106, -75.2346, -1.31309148142093),
(5211, '13654', 218, 40, 149584, 44.617, 0.77871355236231, -75.407, -1.31610042905136),
(5212, '13655', 218, 40, 149657, 44.9819, 0.785082258802837, -74.6552, -1.30297904373487),
(5213, '13656', 218, 40, 150085, 44.1856, 0.771184201969206, -75.9496, -1.32557058557269),
(5214, '13657', 218, 40, 22668, 44.0294, 0.768457997677591, -76.048, -1.32728798955665),
(5215, '13658', 218, 40, 10116, 44.7257, 0.780610725259228, -75.3213, -1.3146046818824),
(5216, '13659', 218, 40, 16945, 43.7908, 0.764293642082333, -75.8284, -1.32345524651927),
(5217, '13660', 218, 40, 3944, 44.7478, 0.780996443023919, -75.1342, -1.31133917085192),
(5218, '13661', 218, 40, 37044, 43.713, 0.762935775924281, -76.08, -1.32784649491729),
(5219, '13662', 218, 40, 116768, 44.9292, 0.784162470287036, -74.8971, -1.30720099519544),
(5220, '13664', 218, 40, 30565, 44.5848, 0.778151556343168, -75.6467, -1.32028398326839),
(5221, '13665', 218, 40, 4485, 44.0965, 0.76962911360568, -75.4778, -1.31733612216178),
(5222, '13666', 218, 40, 151087, 44.1964, 0.771372697528422, -74.9812, -1.30866881709637),
(5223, '13667', 218, 40, 61085, 44.8003, 0.781912740881216, -74.9918, -1.30885382199708),
(5224, '13668', 218, 40, 4648, 44.7484, 0.781006914999431, -74.9965, -1.30893585247193),
(5225, '13669', 218, 40, 145957, 44.6953, 0.780080145166622, -75.4851, -1.31746353119717),
(5226, '13670', 218, 40, 113880, 44.1835, 0.771147550054915, -75.0802, -1.31039669305585),
(5227, '13671', 218, 40, 42466, 44.2871, 0.772955711159981, -75.6205, -1.31982670700437),
(5228, '13672', 218, 40, 151554, 44.5341, 0.777266674412407, -74.7755, -1.30507867482502),
(5229, '13673', 218, 40, 4983, 44.1552, 0.7706536218766, -75.7095, -1.32138005003865),
(5230, '13674', 218, 40, 151696, 43.7347, 0.763314512371964, -76.059, -1.32747997577437),
(5231, '13675', 218, 40, 117356, 44.2802, 0.772835283441593, -75.8481, -1.32379907638191),
(5232, '13676', 218, 40, 73969, 44.6723, 0.779678719438663, -74.9833, -1.30870546901066),
(5233, '13677', 218, 40, 151945, 44.5142, 0.77691935389126, -75.186, -1.31224325140446),
(5234, '13678', 218, 40, 57107, 44.8418, 0.782637052520793, -74.9815, -1.30867405308413),
(5235, '13679', 218, 40, 61503, 44.3017, 0.773210529230772, -75.809, -1.32311665264438),
(5236, '13680', 218, 40, 152045, 44.5906, 0.778252785439784, -75.3183, -1.31455232200485),
(5237, '13681', 218, 40, 5378, 44.4136, 0.775163552663754, -75.3899, -1.31580197774927),
(5238, '13682', 218, 40, 17841, 43.8488, 0.765305933048489, -75.8593, -1.32399455325813),
(5239, '13683', 218, 40, 152199, 44.9729, 0.784925179170158, -74.7318, -1.3043159659419),
(5240, '13684', 218, 40, 5580, 44.3605, 0.774236782830945, -75.0445, -1.30977361051288),
(5241, '13685', 218, 40, 152283, 43.9447, 0.766979703801152, -76.1118, -1.32840150961942),
(5242, '13687', 218, 40, 152700, 44.4994, 0.776661045161965, -74.8567, -1.30649588217764),
(5243, '13688', 218, 40, 0, 43.8907, 0.766037226005075, -75.7917, -1.32281471068379),
(5244, '13690', 218, 40, 152880, 44.1523, 0.770603007328292, -75.033, -1.30957289764891),
(5245, '13691', 218, 40, 153099, 44.1988, 0.77141458543047, -75.7963, -1.32289499582938),
(5246, '13692', 218, 40, 153119, 44.2874, 0.772960947147737, -76.0272, -1.32692496107223),
(5247, '13693', 218, 40, 153120, 44.0806, 0.769351606254612, -76.201, -1.3299583433122),
(5248, '13694', 218, 40, 153412, 44.8633, 0.783012298309972, -75.2012, -1.31250854145076),
(5249, '13695', 218, 40, 153449, 44.2116, 0.771637987574725, -75.0844, -1.31046999688443),
(5250, '13696', 218, 40, 153702, 44.7324, 0.780727662319111, -74.8871, -1.30702646227025),
(5251, '13697', 218, 40, 12913, 44.7477, 0.780994697694667, -74.806, -1.30561100024688),
(5252, '13699', 218, 40, 73969, 44.6691, 0.779622868902599, -74.9861, -1.30875433822972),
(5253, '13730', 218, 40, 570, 42.229, 0.737035089824685, -75.5263, -1.31818260684899),
(5254, '13731', 218, 40, 146815, 42.131, 0.735324667157731, -74.7843, -1.3052322637992),
(5255, '13732', 218, 40, 146834, 42.0566, 0.734026142194247, -76.1374, -1.32884831390793),
(5256, '13733', 218, 40, 19017, 42.2941, 0.738171299167734, -75.4828, -1.31742338862438),
(5257, '13734', 218, 40, 7286, 42.0774, 0.734389170678662, -76.4065, -1.33354499492505),
(5258, '13736', 218, 40, 44780, 42.3247, 0.738705369918844, -76.285, -1.33142441988387),
(5259, '13737', 218, 40, 0, 42.0805, 0.734443275885474, -76.0972, -1.32814669154863),
(5260, '13738', 218, 40, 147248, 42.5673, 0.742939538684182, -76.1243, -1.32861967577592),
(5261, '13739', 218, 40, 79834, 42.3613, 0.739344160425074, -74.8035, -1.30556736701558),
(5262, '13740', 218, 40, 147307, 42.2743, 0.737825723975839, -74.748, -1.30459870928072),
(5263, '13743', 218, 40, 63407, 42.2155, 0.736799470375666, -76.3375, -1.33234071774117),
(5264, '13744', 218, 40, 147629, 42.2252, 0.73696876731311, -75.9284, -1.32520057577126),
(5265, '13745', 218, 40, 147761, 42.2871, 0.738049126120094, -75.9092, -1.32486547255488),
(5266, '13746', 218, 40, 147763, 42.2421, 0.737263727956697, -75.8491, -1.32381652967443),
(5267, '13747', 218, 40, 147943, 42.4908, 0.741604361806407, -74.983, -1.30870023302291),
(5268, '13748', 218, 40, 54178, 42.0702, 0.734263506972518, -75.8187, -1.32328594958182),
(5269, '13749', 218, 40, 148034, 42.0151, 0.733301830554669, -75.7907, -1.32279725739127),
(5270, '13750', 218, 40, 1977, 42.4494, 0.740881795496081, -74.8402, -1.30620790285106),
(5271, '13751', 218, 40, 148194, 42.4572, 0.741017931177737, -74.8981, -1.30721844848797),
(5272, '13752', 218, 40, 148212, 42.1682, 0.735973929639473, -74.9065, -1.30736505614513),
(5273, '13753', 218, 40, 20537, 42.2809, 0.737940915706471, -74.9122, -1.3074645399125),
(5274, '13754', 218, 40, 2030, 42.0591, 0.734069775425547, -75.4428, -1.31672525692358),
(5275, '13755', 218, 40, 40694, 42.0677, 0.734219873741219, -75.0377, -1.30965492812375),
(5276, '13756', 218, 40, 148420, 41.9806, 0.732699691962732, -75.0962, -1.31067594573617),
(5277, '13757', 218, 40, 148495, 42.4139, 0.740262203611623, -74.8878, -1.30703867957501),
(5278, '13758', 218, 40, 148514, 42.5586, 0.742787695039259, -75.718, -1.32152840302507),
(5279, '13760', 218, 40, 35772, 42.1152, 0.735048905135916, -76.0466, -1.32726355494712),
(5280, '13761', 218, 40, 35772, 42.1008, 0.734797577723629, -76.0485, -1.32729671620291),
(5281, '13762', 218, 40, 148690, 42.1092, 0.734944185380796, -76.0243, -1.32687434652393),
(5282, '13763', 218, 40, 35772, 42.0948, 0.734692857968509, -76.0648, -1.32758120487098),
(5283, '13774', 218, 40, 148822, 41.9638, 0.732406476648396, -75.1756, -1.31206173716225),
(5284, '13775', 218, 40, 2595, 42.3379, 0.738935753380107, -75.1612, -1.31181040974996),
(5285, '13776', 218, 40, 36088, 42.4692, 0.741227370687976, -75.3247, -1.31466402307697),
(5286, '13777', 218, 40, 149138, 42.239, 0.737209622749885, -76.0103, -1.32663000042865),
(5287, '13778', 218, 40, 115859, 42.3313, 0.738820561649476, -75.769, -1.32241852094358),
(5288, '13780', 218, 40, 16297, 42.4129, 0.740244750319103, -75.5024, -1.31776547315777),
(5289, '13782', 218, 40, 55147, 42.2177, 0.73683786761921, -75.0134, -1.30923081311551),
(5290, '13783', 218, 40, 9313, 41.9537, 0.732230198393945, -75.2827, -1.31393098479114),
(5291, '13784', 218, 40, 149462, 42.4189, 0.740349470074223, -76.2319, -1.33049765005107),
(5292, '13786', 218, 40, 149471, 42.4551, 0.740981279263445, -74.6929, -1.30363703286287),
(5293, '13787', 218, 40, 149473, 42.1761, 0.73611181065038, -75.6247, -1.31990001083296),
(5294, '13788', 218, 40, 844, 42.3825, 0.739714170226497, -74.6799, -1.30341014006011),
(5295, '13790', 218, 40, 55594, 42.1235, 0.735193767463831, -75.9714, -1.32595106734962),
(5296, '13794', 218, 40, 150016, 42.4, 0.740019602845596, -76.021, -1.32681675065861),
(5297, '13795', 218, 40, 14059, 42.0671, 0.734209401765707, -75.7974, -1.32291419445115),
(5298, '13796', 218, 40, 82032, 42.5342, 0.742361834701772, -75.0915, -1.31059391526132),
(5299, '13797', 218, 40, 55943, 42.3347, 0.738879902844043, -76.0475, -1.32727926291039),
(5300, '13801', 218, 40, 14191, 42.519, 0.742096544655469, -75.7766, -1.32255116596674),
(5301, '13802', 218, 40, 66570, 42.1999, 0.736527199012355, -76.0585, -1.32747124912811),
(5302, '13803', 218, 40, 17017, 42.4664, 0.74117850146892, -76.0184, -1.32677137209806),
(5303, '13804', 218, 40, 10349, 42.263, 0.737628501770363, -75.2101, -1.31266387575419),
(5304, '13806', 218, 40, 150683, 42.3795, 0.739661810348937, -74.9783, -1.30861820254806),
(5305, '13807', 218, 40, 10480, 42.6197, 0.743854091212227, -74.9864, -1.30875957421748),
(5306, '13808', 218, 40, 4333, 42.5489, 0.742618398101815, -75.2446, -1.31326601434613),
(5307, '13809', 218, 40, 150916, 42.4049, 0.740105123978943, -75.4052, -1.31606901312483),
(5308, '13810', 218, 40, 150921, 42.6134, 0.743744135469352, -75.132, -1.31130077360838),
(5309, '13811', 218, 40, 151063, 42.2254, 0.736972257971614, -76.1995, -1.32993216337342),
(5310, '13812', 218, 40, 17278, 42.0188, 0.733366407736993, -76.3794, -1.33307201069776),
(5311, '13813', 218, 40, 30667, 42.157, 0.735778452763249, -75.5304, -1.31825416534833),
(5312, '13814', 218, 40, 151235, 42.6165, 0.743798240676164, -75.5276, -1.31820529612927),
(5313, '13815', 218, 40, 23480, 42.5309, 0.742304238836456, -75.5247, -1.31815468158096),
(5314, '13820', 218, 40, 4795, 42.457, 0.741014440519232, -75.0705, -1.3102273961184),
(5315, '13825', 218, 40, 33530, 42.3959, 0.739948044346264, -75.1741, -1.31203555722347),
(5316, '13826', 218, 40, 151491, 42.1042, 0.734856918918196, -75.6324, -1.32003440118536),
(5317, '13827', 218, 40, 117195, 42.1065, 0.734897061490992, -76.2542, -1.33088685847426),
(5318, '13830', 218, 40, 4828, 42.4408, 0.740731697180409, -75.599, -1.31945146121519),
(5319, '13832', 218, 40, 14433, 42.6304, 0.744040841442191, -75.6215, -1.31984416029689),
(5320, '13833', 218, 40, 151844, 42.1939, 0.736422479257235, -75.8018, -1.32299098893824),
(5321, '13834', 218, 40, 151874, 42.5095, 0.74193073837653, -74.9636, -1.30836163914802),
(5322, '13835', 218, 40, 152081, 42.413, 0.740246495648355, -76.2285, -1.3304383088565),
(5323, '13837', 218, 40, 152540, 42.0383, 0.733706746941132, -75.0685, -1.31019248953336),
(5324, '13838', 218, 40, 5844, 42.3078, 0.738410409275257, -75.3921, -1.31584037499282),
(5325, '13839', 218, 40, 152571, 42.2235, 0.736939096715826, -75.325, -1.31466925906473),
(5326, '13840', 218, 40, 24913, 42.1013, 0.734806304369889, -76.367, -1.33285558987051),
(5327, '13841', 218, 40, 152632, 42.4483, 0.740862596874309, -75.8872, -1.32448150011944),
(5328, '13842', 218, 40, 152738, 42.3786, 0.739646102385669, -74.7267, -1.30422695415005),
(5329, '13843', 218, 40, 152746, 42.5359, 0.742391505299056, -75.3473, -1.31505846748792);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(5330, '13844', 218, 40, 74359, 42.616, 0.743789514029903, -75.7161, -1.32149524176928),
(5331, '13845', 218, 40, 153139, 42.0566, 0.734026142194247, -76.3483, -1.33252921330039),
(5332, '13846', 218, 40, 25557, 42.3623, 0.739361613717594, -75.0547, -1.30995163409659),
(5333, '13847', 218, 40, 98637, 42.2036, 0.736591776194679, -75.2796, -1.31387687958432),
(5334, '13848', 218, 40, 153221, 42.2161, 0.736809942351178, -75.7272, -1.32168897331625),
(5335, '13849', 218, 40, 25636, 42.327, 0.73874551249164, -75.3196, -1.31457501128512),
(5336, '13850', 218, 40, 91574, 42.0779, 0.734397897324922, -76.0375, -1.32710472998519),
(5337, '13851', 218, 40, 91574, 42.0353, 0.733654387063572, -76.0192, -1.32678533473207),
(5338, '13856', 218, 40, 18491, 42.172, 0.736040252151049, -75.1311, -1.31128506564511),
(5339, '13859', 218, 40, 153543, 42.3635, 0.739382557668618, -75.2517, -1.31338993272302),
(5340, '13860', 218, 40, 153603, 42.4458, 0.740818963643009, -74.9638, -1.30836512980653),
(5341, '13861', 218, 40, 153669, 42.4473, 0.740845143581789, -75.1104, -1.31092378248995),
(5342, '13862', 218, 40, 153803, 42.3302, 0.738801363027704, -75.969, -1.32590917944757),
(5343, '13863', 218, 40, 62333, 42.4484, 0.740864342203561, -75.9018, -1.32473631819023),
(5344, '13864', 218, 40, 153851, 42.2768, 0.737869357207139, -76.3787, -1.33305979339299),
(5345, '13865', 218, 40, 18652, 42.0746, 0.734340301459606, -75.6392, -1.3201530835745),
(5346, '13901', 218, 40, 147211, 42.1427, 0.735528870680214, -75.8835, -1.32441692293712),
(5347, '13902', 218, 40, 147211, 42.1083, 0.734928477417528, -75.8672, -1.32413243426904),
(5348, '13903', 218, 40, 147211, 42.0843, 0.73450959839705, -75.9149, -1.32496495632224),
(5349, '13904', 218, 40, 147211, 42.1133, 0.735015743880128, -75.8743, -1.32425635264593),
(5350, '13905', 218, 40, 147211, 42.1138, 0.735024470526388, -75.9278, -1.32519010379575),
(5351, '14001', 218, 40, 215, 43.0193, 0.750828426903197, -78.5108, -1.37027195837476),
(5352, '14003', 218, 40, 112706, 43.0848, 0.751971617563253, -78.3941, -1.36823515913769),
(5353, '14004', 218, 40, 796, 42.9003, 0.748751485093323, -78.524, -1.37050234183603),
(5354, '14005', 218, 40, 7048, 42.9182, 0.74906389902943, -78.2538, -1.36578646219714),
(5355, '14006', 218, 40, 31649, 42.6339, 0.74410192796601, -79.0497, -1.37967753771376),
(5356, '14008', 218, 40, 7132, 43.3133, 0.75595969490406, -78.6259, -1.37228083234381),
(5357, '14009', 218, 40, 18897, 42.5717, 0.74301633317127, -78.405, -1.36842540002615),
(5358, '14010', 218, 40, 146902, 42.7716, 0.746505246346007, -78.8647, -1.37644867859757),
(5359, '14011', 218, 40, 7188, 42.8354, 0.747618766408779, -78.2796, -1.36623675714415),
(5360, '14012', 218, 40, 19053, 43.3385, 0.756399517875563, -78.5331, -1.37066116679796),
(5361, '14013', 218, 40, 147030, 43.0721, 0.75174996074825, -78.3904, -1.36817058195536),
(5362, '14020', 218, 40, 7293, 42.9971, 0.750440963809254, -78.1942, -1.36474624596295),
(5363, '14021', 218, 40, 7293, 43.017, 0.750788284330401, -78.1616, -1.3641772686268),
(5364, '14024', 218, 40, 34861, 42.5761, 0.743093127658358, -78.2588, -1.36587372865974),
(5365, '14025', 218, 40, 1061, 42.6364, 0.74414556119731, -78.7418, -1.37430366894687),
(5366, '14026', 218, 40, 53606, 42.9411, 0.749463579428137, -78.6854, -1.37331930324875),
(5367, '14027', 218, 40, 129914, 42.5829, 0.743211810047493, -79.0134, -1.37904398319529),
(5368, '14028', 218, 40, 58842, 43.3213, 0.75609932124422, -78.7229, -1.37397380171824),
(5369, '14029', 218, 40, 1459, 42.4798, 0.741412375588687, -78.2501, -1.36572188501482),
(5370, '14030', 218, 40, 53978, 42.5693, 0.742974445269222, -78.5029, -1.37013407736386),
(5371, '14031', 218, 40, 1592, 42.9823, 0.750182655079959, -78.6189, -1.37215865929617),
(5372, '14032', 218, 40, 130228, 43.0333, 0.751072772998476, -78.6339, -1.37242045868397),
(5373, '14033', 218, 40, 147929, 42.6559, 0.744485900401449, -78.6833, -1.37328265133445),
(5374, '14034', 218, 40, 308, 42.4994, 0.741754460122078, -78.8803, -1.37672094996088),
(5375, '14035', 218, 40, 147947, 42.4973, 0.741717808207786, -78.8545, -1.37627065501387),
(5376, '14036', 218, 40, 148039, 42.9721, 0.750004631496255, -78.383, -1.36804142759072),
(5377, '14037', 218, 40, 72227, 42.8172, 0.747301116484916, -78.4556, -1.36930853662766),
(5378, '14038', 218, 40, 8299, 42.9489, 0.749599715109793, -78.476, -1.36966458379507),
(5379, '14039', 218, 40, 847, 42.8349, 0.747610039762519, -78.1724, -1.36436576418602),
(5380, '14040', 218, 40, 148189, 42.8938, 0.748638038691944, -78.3788, -1.36796812376213),
(5381, '14041', 218, 40, 1992, 42.4253, 0.74046117114635, -78.9807, -1.37847326052989),
(5382, '14042', 218, 40, 148250, 42.4738, 0.741307655833568, -78.5125, -1.37030162897205),
(5383, '14043', 218, 40, 54420, 42.9056, 0.748843987543679, -78.7054, -1.37366836909914),
(5384, '14047', 218, 40, 2031, 42.6937, 0.745145634858703, -78.9888, -1.3786146321993),
(5385, '14048', 218, 40, 32273, 42.48, 0.741415866247191, -79.3287, -1.38454700632683),
(5386, '14051', 218, 40, 148403, 43.0273, 0.750968053243356, -78.7107, -1.3737608715495),
(5387, '14052', 218, 40, 148406, 42.7693, 0.746465103773211, -78.6013, -1.37185148134782),
(5388, '14054', 218, 40, 148415, 42.9135, 0.748981868554587, -78.1349, -1.36371126571652),
(5389, '14055', 218, 40, 143747, 42.5558, 0.742738825820203, -78.6099, -1.37200157966349),
(5390, '14056', 218, 40, 124731, 42.9954, 0.75041129321197, -78.316, -1.36687205699188),
(5391, '14057', 218, 40, 2217, 42.6484, 0.74435500070755, -78.8687, -1.37651849176765),
(5392, '14058', 218, 40, 316, 43.0866, 0.752003033489789, -78.1574, -1.36410396479822),
(5393, '14059', 218, 40, 101709, 42.8317, 0.747554189226455, -78.6424, -1.37256881167039),
(5394, '14060', 218, 40, 148754, 42.4451, 0.740806746338245, -78.3501, -1.36746721426681),
(5395, '14061', 218, 40, 101889, 42.5931, 0.743389833631197, -79.0859, -1.38030934690298),
(5396, '14062', 218, 40, 35957, 42.453, 0.740944627349153, -79.1575, -1.38155900264741),
(5397, '14063', 218, 40, 2600, 42.4263, 0.74047862443887, -79.3388, -1.38472328458128),
(5398, '14065', 218, 40, 29850, 42.4837, 0.741480443429515, -78.3675, -1.36777090155666),
(5399, '14066', 218, 40, 2644, 42.6369, 0.74415428784357, -78.1896, -1.36466596081736),
(5400, '14067', 218, 40, 149068, 43.2075, 0.75411313655545, -78.5673, -1.37125806940214),
(5401, '14068', 218, 40, 149110, 43.0232, 0.750896494744024, -78.7528, -1.37449565516459),
(5402, '14069', 218, 40, 2749, 42.6019, 0.743543422605372, -78.6395, -1.37251819712208),
(5403, '14070', 218, 40, 149211, 42.4522, 0.740930664715137, -78.9372, -1.37771404230527),
(5404, '14072', 218, 40, 16260, 43.014, 0.750735924452841, -78.9607, -1.37812419467949),
(5405, '14075', 218, 40, 2948, 42.7304, 0.745786170694185, -78.8334, -1.3759023905417),
(5406, '14080', 218, 40, 9533, 42.6421, 0.744245044964674, -78.5386, -1.37075715990682),
(5407, '14081', 218, 40, 27519, 42.5549, 0.742723117856935, -79.1231, -1.38095860938473),
(5408, '14082', 218, 40, 149883, 42.6563, 0.744492881718457, -78.3821, -1.36802571962745),
(5409, '14083', 218, 40, 149884, 42.6719, 0.744765153081768, -78.4315, -1.36888791227793),
(5410, '14085', 218, 40, 3614, 42.7198, 0.745601165793474, -78.9345, -1.37766691841546),
(5411, '14086', 218, 40, 16841, 42.9018, 0.748777665032103, -78.655, -1.37278872315614),
(5412, '14091', 218, 40, 150197, 42.541, 0.742480517090908, -78.8695, -1.37653245440167),
(5413, '14092', 218, 40, 3747, 43.1694, 0.75344816611044, -78.9883, -1.37860590555304),
(5414, '14094', 218, 40, 36937, 43.164, 0.753353918330832, -78.6904, -1.37340656971135),
(5415, '14095', 218, 40, 36937, 43.171, 0.753476091378472, -78.6883, -1.37336991779705),
(5416, '14098', 218, 40, 150437, 43.338, 0.756390791229303, -78.3795, -1.3679803410669),
(5417, '14101', 218, 40, 128031, 42.4066, 0.740134794576227, -78.5168, -1.37037667812988),
(5418, '14102', 218, 40, 131935, 42.8394, 0.747688579578859, -78.5531, -1.37101023264836),
(5419, '14103', 218, 40, 10432, 43.2181, 0.754298141456161, -78.3852, -1.36807982483426),
(5420, '14105', 218, 40, 73458, 43.211, 0.75417422307927, -78.4901, -1.3699106752196),
(5421, '14107', 218, 40, 150794, 43.1912, 0.753828647887375, -78.9834, -1.37852038441969),
(5422, '14108', 218, 40, 151072, 43.2808, 0.755392462897162, -78.7131, -1.37380275945155),
(5423, '14109', 218, 40, 0, 43.133, 0.752812866262714, -79.0369, -1.37945413556951),
(5424, '14110', 218, 40, 151145, 42.6852, 0.744997281872284, -78.7768, -1.37491453418507),
(5425, '14111', 218, 40, 151167, 42.5868, 0.743279877888321, -78.9073, -1.37719218885892),
(5426, '14112', 218, 40, 151182, 42.6979, 0.745218938687287, -78.9857, -1.37856052699249),
(5427, '14113', 218, 40, 151218, 42.6729, 0.744782606374288, -78.3371, -1.36724032146405),
(5428, '14120', 218, 40, 151268, 43.0497, 0.751359006995803, -78.8588, -1.3763457041717),
(5429, '14125', 218, 40, 23561, 43.0777, 0.751847699186361, -78.2736, -1.36613203738903),
(5430, '14126', 218, 40, 37502, 43.3358, 0.756352393985759, -78.7187, -1.37390049788966),
(5431, '14127', 218, 40, 23667, 42.7647, 0.746384818627619, -78.7465, -1.37438569942171),
(5432, '14129', 218, 40, 123417, 42.4707, 0.741253550626756, -79.0057, -1.37890959284288),
(5433, '14130', 218, 40, 28249, 42.5545, 0.742716136539927, -78.1445, -1.36387881732471),
(5434, '14131', 218, 40, 33722, 43.2308, 0.754519798271165, -78.9134, -1.37729865394329),
(5435, '14132', 218, 40, 17956, 43.1475, 0.753065939004253, -78.8757, -1.37664066481529),
(5436, '14133', 218, 40, 5646, 42.4977, 0.741724789524794, -78.3781, -1.36795590645737),
(5437, '14134', 218, 40, 31076, 42.5406, 0.7424735357739, -78.513, -1.37031035561831),
(5438, '14135', 218, 40, 11906, 42.4862, 0.741524076660815, -79.2398, -1.3829954086218),
(5439, '14136', 218, 40, 24872, 42.5348, 0.742372306677284, -79.1645, -1.38168117569505),
(5440, '14138', 218, 40, 90909, 42.3981, 0.739986441589808, -79.1001, -1.38055718365677),
(5441, '14139', 218, 40, 106427, 42.7178, 0.745566259208434, -78.537, -1.37072923463879),
(5442, '14140', 218, 40, 152831, 42.8035, 0.747062006377393, -78.6634, -1.37293533081331),
(5443, '14141', 218, 40, 6035, 42.524, 0.742183811118069, -78.7018, -1.37360553724607),
(5444, '14143', 218, 40, 12102, 42.9801, 0.750144257836415, -78.079, -1.36273562666465),
(5445, '14144', 218, 40, 152900, 43.1977, 0.753942094288754, -79.0436, -1.37957107262939),
(5446, '14145', 218, 40, 152976, 42.723, 0.745657016329537, -78.4304, -1.36886871365616),
(5447, '14150', 218, 40, 153164, 43.0018, 0.750522994284098, -78.8596, -1.37635966680572),
(5448, '14151', 218, 40, 153164, 43.0166, 0.750781303013393, -78.8792, -1.37670175133911),
(5449, '14166', 218, 40, 153336, 42.4517, 0.740921938068877, -79.4166, -1.38608115073933),
(5450, '14167', 218, 40, 153354, 42.7366, 0.745894381107809, -78.3155, -1.36686333034562),
(5451, '14168', 218, 40, 28861, 42.5172, 0.742065128728933, -78.9912, -1.37865652010135),
(5452, '14169', 218, 40, 133559, 42.7685, 0.746451141139195, -78.5289, -1.37058786296937),
(5453, '14170', 218, 40, 153614, 42.7034, 0.745314931796147, -78.6719, -1.37308368379973),
(5454, '14171', 218, 40, 12765, 42.4174, 0.740323290135443, -78.6373, -1.37247979987854),
(5455, '14172', 218, 40, 565, 43.2999, 0.755725820784293, -78.8336, -1.3759058812002),
(5456, '14173', 218, 40, 14928, 42.527, 0.742236170995629, -78.4714, -1.36958429864948),
(5457, '14174', 218, 40, 13011, 43.2472, 0.754806032268492, -79.0246, -1.37923946007151),
(5458, '14201', 218, 40, 26642, 42.8959, 0.748674690606236, -78.8853, -1.37680821642348),
(5459, '14202', 218, 40, 26642, 42.8876, 0.74852982827832, -78.8772, -1.37666684475407),
(5460, '14203', 218, 40, 26642, 42.8807, 0.748409400559932, -78.8699, -1.37653943571868),
(5461, '14204', 218, 40, 26642, 42.8827, 0.748444307144972, -78.8619, -1.37639980937852),
(5462, '14205', 218, 40, 26642, 42.8927, 0.748618840070172, -78.871, -1.37655863434045),
(5463, '14206', 218, 40, 26642, 42.8796, 0.748390201938161, -78.8147, -1.37557601397157),
(5464, '14207', 218, 40, 26642, 42.946, 0.749549100561485, -78.8962, -1.37699845731195),
(5465, '14208', 218, 40, 26642, 42.915, 0.749008048493367, -78.8517, -1.37622178579481),
(5466, '14209', 218, 40, 26642, 42.9161, 0.749027247115138, -78.8644, -1.37644344260982),
(5467, '14210', 218, 40, 26642, 42.8648, 0.748131893208865, -78.8267, -1.37578545348181),
(5468, '14211', 218, 40, 26642, 42.9085, 0.748894602091987, -78.823, -1.37572087629949),
(5469, '14212', 218, 40, 26642, 42.8939, 0.748639784021196, -78.8201, -1.37567026175118),
(5470, '14213', 218, 40, 26642, 42.9162, 0.74902899244439, -78.8909, -1.37690595486159),
(5471, '14214', 218, 40, 26642, 42.9421, 0.749481032720657, -78.8375, -1.37597394904103),
(5472, '14215', 218, 40, 26642, 42.9337, 0.749334425063489, -78.8102, -1.37549747415524),
(5473, '14216', 218, 40, 26642, 42.9492, 0.749604951097549, -78.8609, -1.376382356086),
(5474, '14217', 218, 40, 26642, 42.9693, 0.749955762277199, -78.8741, -1.37661273954726),
(5475, '14218', 218, 40, 26642, 42.8199, 0.74734824037472, -78.8192, -1.37565455378791),
(5476, '14219', 218, 40, 26642, 42.7882, 0.746794971001838, -78.8243, -1.37574356557977),
(5477, '14220', 218, 40, 26642, 42.8447, 0.747781082029215, -78.8189, -1.37564931780016),
(5478, '14221', 218, 40, 26642, 42.9808, 0.750156475141179, -78.7346, -1.37417800524073),
(5479, '14222', 218, 40, 26642, 42.9182, 0.74906389902943, -78.8754, -1.37663542882754),
(5480, '14223', 218, 40, 26642, 42.9712, 0.749988923532987, -78.8435, -1.37607866879615),
(5481, '14224', 218, 40, 26642, 42.8375, 0.747655418323071, -78.7536, -1.37450961779861),
(5482, '14225', 218, 40, 26642, 42.929, 0.749252394588646, -78.7592, -1.37460735623672),
(5483, '14226', 218, 40, 26642, 42.9683, 0.74993830898468, -78.7987, -1.37529676129126),
(5484, '14227', 218, 40, 26642, 42.8785, 0.748371003316389, -78.745, -1.37435951948293),
(5485, '14228', 218, 40, 26642, 43.0089, 0.750646912660989, -78.7821, -1.37500703663542),
(5486, '14231', 218, 40, 26642, 42.9779, 0.750105860592871, -78.7359, -1.374200694521),
(5487, '14233', 218, 40, 26642, 42.8726, 0.748268028890521, -78.8692, -1.37652721841391),
(5488, '14240', 218, 40, 26642, 42.8808, 0.748411145889184, -78.811, -1.37551143678925),
(5489, '14241', 218, 40, 26642, 42.9287, 0.74924715860089, -78.7511, -1.37446598456731),
(5490, '14260', 218, 40, 26642, 43.0002, 0.750495069016066, -78.7844, -1.37504717920822),
(5491, '14261', 218, 40, 26642, 43.0028, 0.750540447576618, -78.7825, -1.37501401795243),
(5492, '14263', 218, 40, 26642, 42.8727, 0.748269774219773, -78.8689, -1.37652198242616),
(5493, '14264', 218, 40, 26642, 42.8845, 0.748475723071508, -78.8263, -1.37577847216481),
(5494, '14265', 218, 40, 26642, 42.9791, 0.750126804543895, -78.7505, -1.37445551259179),
(5495, '14267', 218, 40, 26642, 42.9182, 0.74906389902943, -78.8753, -1.37663368349828),
(5496, '14269', 218, 40, 26642, 42.866, 0.748152837159889, -78.8701, -1.37654292637718),
(5497, '14270', 218, 40, 26642, 42.8676, 0.748180762427921, -78.8301, -1.37584479467638),
(5498, '14272', 218, 40, 26642, 42.8725, 0.748266283561269, -78.8696, -1.37653419973092),
(5499, '14273', 218, 40, 26642, 42.8715, 0.748248830268749, -78.872, -1.37657608763297),
(5500, '14276', 218, 40, 26642, 42.8581, 0.748014956148982, -78.9151, -1.37732832454058),
(5501, '14280', 218, 40, 26642, 42.8861, 0.74850364833954, -78.8714, -1.37656561565746),
(5502, '14301', 218, 40, 151094, 43.0949, 0.752147895817704, -79.0422, -1.37954663801986),
(5503, '14302', 218, 40, 151094, 43.0897, 0.752057138696601, -79.0632, -1.37991315716278),
(5504, '14303', 218, 40, 151094, 43.0873, 0.752015250794553, -79.0386, -1.37948380616679),
(5505, '14304', 218, 40, 151094, 43.0911, 0.752081573306128, -78.9624, -1.37815386527677),
(5506, '14305', 218, 40, 151094, 43.1158, 0.752512669631371, -79.029, -1.3793162545586),
(5507, '14410', 218, 40, 146704, 43.1921, 0.753844355850643, -77.8576, -1.35887146770074),
(5508, '14411', 218, 40, 7043, 43.2408, 0.754694331196364, -78.2015, -1.36487365499835),
(5509, '14413', 218, 40, 14977, 43.2108, 0.754170732420766, -76.9817, -1.34358412878252),
(5510, '14414', 218, 40, 7208, 42.897, 0.748693889228008, -77.7371, -1.35676834595208),
(5511, '14415', 218, 40, 147128, 42.755, 0.746215521690176, -77.0198, -1.34424909922753),
(5512, '14416', 218, 40, 134227, 43.0768, 0.751831991223093, -77.9857, -1.36110723447254),
(5513, '14418', 218, 40, 144884, 42.6127, 0.743731918164588, -77.2124, -1.34761060336687),
(5514, '14420', 218, 40, 147388, 43.2125, 0.75420040301805, -77.926, -1.3600652729091),
(5515, '14422', 218, 40, 7810, 43.0764, 0.751825009906085, -78.068, -1.36254364044693),
(5516, '14423', 218, 40, 1296, 42.944, 0.749514193976445, -77.842, -1.35859919633743),
(5517, '14424', 218, 40, 130071, 42.8436, 0.747761883407443, -77.3032, -1.34919536232768),
(5518, '14425', 218, 40, 8849, 42.9549, 0.749704434864912, -77.3346, -1.34974339571281),
(5519, '14427', 218, 40, 77984, 42.641, 0.744225846342902, -78.0469, -1.36217537597476),
(5520, '14428', 218, 40, 45792, 43.0823, 0.751927984331953, -77.8479, -1.35870217076329),
(5521, '14429', 218, 40, 8087, 43.1929, 0.753858318484659, -78.0645, -1.36248255392311),
(5522, '14430', 218, 40, 35257, 43.2329, 0.754556450185456, -77.9283, -1.3601054154819),
(5523, '14432', 218, 40, 147871, 42.9648, 0.74987722246086, -77.146, -1.34645170474355),
(5524, '14433', 218, 40, 8151, 43.0798, 0.751884351100653, -76.872, -1.34166950259308),
(5525, '14435', 218, 40, 147975, 42.7228, 0.745653525671033, -77.6758, -1.35569845912061),
(5526, '14437', 218, 40, 130421, 42.5704, 0.742993643890994, -77.7319, -1.35667758883098),
(5527, '14441', 218, 40, 20675, 42.6874, 0.745035679115827, -76.9549, -1.34311638054298),
(5528, '14443', 218, 40, 148416, 42.8897, 0.748566480192612, -77.4466, -1.35169816447504),
(5529, '14445', 218, 40, 143766, 43.1118, 0.752442856461291, -77.4906, -1.35246610934592),
(5530, '14449', 218, 40, 109011, 43.2337, 0.754570412819472, -77.1482, -1.34649010198709),
(5531, '14450', 218, 40, 32409, 43.0882, 0.752030958757821, -77.4324, -1.35145032772126),
(5532, '14452', 218, 40, 27142, 43.2427, 0.754727492452152, -78.0893, -1.36291539557761),
(5533, '14453', 218, 40, 29796, 43.0119, 0.750699272538549, -77.4667, -1.35204897565469),
(5534, '14454', 218, 40, 32546, 42.7918, 0.74685780285491, -77.7734, -1.35740190047056),
(5535, '14456', 218, 40, 2687, 42.8611, 0.748067316026542, -76.998, -1.34386861745059),
(5536, '14461', 218, 40, 27295, 42.8052, 0.747091676974677, -77.132, -1.34620735864827),
(5537, '14462', 218, 40, 16295, 42.6813, 0.744929214031456, -77.7492, -1.35697953079158),
(5538, '14463', 218, 40, 29976, 42.7945, 0.746904926744713, -77.0678, -1.34508685726849),
(5539, '14464', 218, 40, 9306, 43.3154, 0.755996346818352, -77.9193, -1.35994833584922),
(5540, '14466', 218, 40, 72876, 42.7722, 0.746515718321519, -77.5576, -1.35363547994475),
(5541, '14467', 218, 40, 16406, 43.0504, 0.751371224300567, -77.6079, -1.35451338055851),
(5542, '14468', 218, 40, 9513, 43.2951, 0.755642044980197, -77.7901, -1.35769337045564),
(5543, '14469', 218, 40, 7544, 42.8751, 0.748311662121821, -77.4572, -1.35188316937575),
(5544, '14470', 218, 40, 16468, 43.2193, 0.754319085407185, -78.0505, -1.36223820782783),
(5545, '14471', 218, 40, 162801, 42.7615, 0.746328968091555, -77.4954, -1.35254988515001),
(5546, '14472', 218, 40, 149679, 42.9706, 0.749978451557475, -77.5943, -1.35427601578024),
(5547, '14475', 218, 40, 9664, 42.9335, 0.749330934404986, -77.5096, -1.3527977219038),
(5548, '14476', 218, 40, 16702, 43.336, 0.756355884644263, -78.047, -1.36217712130401),
(5549, '14477', 218, 40, 3501, 43.343, 0.756478057691902, -78.14, -1.36380027750837),
(5550, '14478', 218, 40, 150009, 42.5888, 0.743314784473361, -77.124, -1.34606773230811),
(5551, '14479', 218, 40, 150067, 43.2386, 0.75465593395282, -78.3083, -1.36673766663948),
(5552, '14480', 218, 40, 16832, 42.8367, 0.747641455689055, -77.7044, -1.35619762328668),
(5553, '14481', 218, 40, 66314, 42.7748, 0.746561096882071, -77.9069, -1.35973191502197),
(5554, '14482', 218, 40, 33011, 42.9804, 0.750149493824171, -77.9814, -1.36103218531471),
(5555, '14485', 218, 40, 66371, 42.8903, 0.748576952168124, -77.612, -1.35458493905784),
(5556, '14486', 218, 40, 3793, 42.8924, 0.748613604082416, -77.9196, -1.35995357183697),
(5557, '14487', 218, 40, 30358, 42.8103, 0.747180688766528, -77.6694, -1.35558675804848),
(5558, '14488', 218, 40, 150335, 42.8219, 0.74738314695976, -77.6391, -1.35505792328513),
(5559, '14489', 218, 40, 764, 43.0859, 0.751990816185025, -76.9971, -1.34385290948733),
(5560, '14502', 218, 40, 82216, 43.0877, 0.752022232111561, -77.3316, -1.34969103583525),
(5561, '14504', 218, 40, 585, 42.9711, 0.749987178203735, -77.2283, -1.34788811071794),
(5562, '14505', 218, 40, 630, 43.1554, 0.753203820015161, -77.1719, -1.34690374501981),
(5563, '14506', 218, 40, 56203, 42.9972, 0.750442709138506, -77.4991, -1.35261446233234),
(5564, '14507', 218, 40, 49457, 42.7041, 0.74532714910091, -77.2667, -1.3485583171507),
(5565, '14508', 218, 40, 10614, 43.3282, 0.756219748962607, -78.0004, -1.36136379787259),
(5566, '14510', 218, 40, 78784, 42.7002, 0.745259081260083, -77.8745, -1.35916642834432),
(5567, '14511', 218, 40, 56427, 42.9945, 0.750395585248702, -77.8593, -1.35890113829802),
(5568, '14512', 218, 40, 17231, 42.6567, 0.744499863035465, -77.4128, -1.35110824318787),
(5569, '14513', 218, 40, 10792, 43.0555, 0.751460236092419, -77.0939, -1.34554238820326),
(5570, '14514', 218, 40, 151160, 43.1128, 0.752460309753811, -77.7926, -1.35773700368694),
(5571, '14515', 218, 40, 151196, 43.2532, 0.754910752023611, -77.7311, -1.35666362619696),
(5572, '14516', 218, 40, 151250, 43.1962, 0.753915914349975, -76.9072, -1.34228385848978),
(5573, '14517', 218, 40, 151314, 42.5892, 0.743321765790369, -77.9088, -1.35976507627776),
(5574, '14518', 218, 40, 151335, 42.9329, 0.749320462429473, -77.0103, -1.34408329294859),
(5575, '14519', 218, 40, 33502, 43.2359, 0.754608810063016, -77.3046, -1.34921979693721),
(5576, '14520', 218, 40, 151412, 43.2266, 0.754446494442581, -77.3059, -1.34924248621748),
(5577, '14521', 218, 40, 132491, 42.6723, 0.744772134398776, -76.8063, -1.34052282127452),
(5578, '14522', 218, 40, 4846, 43.068, 0.751678402248918, -77.2255, -1.34783924149888),
(5579, '14525', 218, 40, 132544, 42.8981, 0.74871308784978, -78.031, -1.3618978686237),
(5580, '14526', 218, 40, 23832, 43.1421, 0.752971691224646, -77.4574, -1.35188666003426),
(5581, '14527', 218, 40, 151636, 42.6595, 0.744548732254521, -77.0611, -1.3449699202086),
(5582, '14529', 218, 40, 67691, 42.5363, 0.742398486616064, -77.6284, -1.35487117305517),
(5583, '14530', 218, 40, 11148, 42.7376, 0.745911834400329, -78.0181, -1.36167272115019),
(5584, '14532', 218, 40, 23858, 42.9639, 0.749861514497592, -77.0441, -1.34467321423576),
(5585, '14533', 218, 40, 151699, 42.8458, 0.747800280650986, -77.8895, -1.35942822773212),
(5586, '14534', 218, 40, 132642, 43.0705, 0.751722035480218, -77.5156, -1.35290244165892),
(5587, '14536', 218, 40, 56998, 42.5516, 0.742665521991619, -78.0796, -1.36274609864016),
(5588, '14537', 218, 40, 61404, 43.0355, 0.75111117024202, -77.1575, -1.34665241760752),
(5589, '14538', 218, 40, 151926, 43.2811, 0.755397698884918, -77.1747, -1.34695261423887),
(5590, '14539', 218, 40, 152053, 42.8359, 0.747627493055039, -77.8802, -1.35926591211169),
(5591, '14541', 218, 40, 5532, 42.7636, 0.746365620005847, -76.8461, -1.34121746231681),
(5592, '14542', 218, 40, 17851, 43.1553, 0.753202074685909, -76.8734, -1.34169393720261),
(5593, '14543', 218, 40, 11732, 42.9954, 0.75041129321197, -77.6658, -1.35552392619541),
(5594, '14544', 218, 40, 31020, 42.746, 0.746058442057496, -77.2426, -1.34813769280097),
(5595, '14545', 218, 40, 31093, 42.6645, 0.744635998717121, -77.7157, -1.35639484549216),
(5596, '14546', 218, 40, 5699, 43.0328, 0.751064046352216, -77.7666, -1.35728321808142),
(5597, '14547', 218, 40, 152466, 42.9057, 0.748845732872931, -77.1279, -1.34613580014893),
(5598, '14548', 218, 40, 106246, 42.9666, 0.749908638387396, -77.2379, -1.34805566232613),
(5599, '14549', 218, 40, 18083, 42.6972, 0.745206721382523, -78.0224, -1.36174777030802),
(5600, '14550', 218, 40, 14623, 42.6718, 0.744763407752516, -78.0943, -1.36300266204021),
(5601, '14551', 218, 40, 133157, 43.2246, 0.754411587857541, -77.0493, -1.34476397135687),
(5602, '14555', 218, 40, 152648, 43.265, 0.755116700875347, -76.9887, -1.34370630183016),
(5603, '14556', 218, 40, 152663, 42.6783, 0.744876854153896, -77.8277, -1.35834961425439),
(5604, '14557', 218, 40, 152687, 43.0488, 0.751343299032535, -78.0658, -1.36250524320339),
(5605, '14558', 218, 40, 152742, 42.8558, 0.747974813576186, -77.6755, -1.35569322313286),
(5606, '14559', 218, 40, 152821, 43.1905, 0.753816430582611, -77.8093, -1.35802847367202),
(5607, '14560', 218, 40, 117883, 42.7137, 0.745494700709102, -77.5546, -1.35358312006719),
(5608, '14561', 218, 40, 196, 42.8237, 0.747414562886296, -77.0986, -1.3456244186781),
(5609, '14563', 218, 40, 784, 43.2228, 0.754380171931005, -77.3719, -1.3503944035238),
(5610, '14564', 218, 40, 12551, 42.9801, 0.750144257836415, -77.4251, -1.35132291868586),
(5611, '14568', 218, 40, 143305, 43.1405, 0.752943765956614, -77.2894, -1.34895450689091),
(5612, '14569', 218, 40, 6638, 42.7387, 0.745931033022101, -78.1637, -1.36421392054109),
(5613, '14571', 218, 40, 153488, 43.3474, 0.75655485217899, -78.2481, -1.36568697842977),
(5614, '14572', 218, 40, 38772, 42.5404, 0.742470045115396, -77.5882, -1.35416955069586),
(5615, '14580', 218, 40, 18520, 43.2218, 0.754362718638485, -77.4661, -1.35203850367918),
(5616, '14585', 218, 40, 153575, 42.9082, 0.748889366104231, -77.5505, -1.35351156156786),
(5617, '14586', 218, 40, 153636, 43.0444, 0.751266504545447, -77.6798, -1.35576827229069),
(5618, '14588', 218, 40, 26074, 42.6826, 0.744951903311732, -76.8729, -1.34168521055635),
(5619, '14589', 218, 40, 12870, 43.247, 0.754802541609988, -77.1807, -1.34705733399399),
(5620, '14590', 218, 40, 34461, 43.2464, 0.754792069634476, -76.8331, -1.34099056951406),
(5621, '14591', 218, 40, 14923, 42.828, 0.747489612044132, -78.0871, -1.36287699833406),
(5622, '14592', 218, 40, 6986, 42.8714, 0.748247084939497, -77.8854, -1.35935666923279),
(5623, '14601', 218, 40, 28433, 43.169, 0.753441184793432, -77.6028, -1.35442436876666),
(5624, '14602', 218, 40, 28433, 43.1691, 0.753442930122684, -77.6026, -1.35442087810815),
(5625, '14603', 218, 40, 28433, 43.163, 0.753336465038312, -77.6032, -1.35443135008366),
(5626, '14604', 218, 40, 28433, 43.157, 0.753231745283193, -77.6055, -1.35447149265646),
(5627, '14605', 218, 40, 28433, 43.1676, 0.753416750183904, -77.5999, -1.35437375421835),
(5628, '14606', 218, 40, 28433, 43.1693, 0.753446420781188, -77.6882, -1.35591487994786),
(5629, '14607', 218, 40, 28433, 43.1506, 0.753120044211065, -77.5902, -1.3542044572809),
(5630, '14608', 218, 40, 28433, 43.1548, 0.753193348039649, -77.6268, -1.35484324778713),
(5631, '14609', 218, 40, 28433, 43.1759, 0.75356161251182, -77.5614, -1.35370180245633),
(5632, '14610', 218, 40, 28433, 43.1423, 0.75297518188315, -77.5479, -1.35346618300731),
(5633, '14611', 218, 40, 28433, 43.1476, 0.753067684333505, -77.6435, -1.35513471777222),
(5634, '14612', 218, 40, 28433, 43.257, 0.754977074535187, -77.6677, -1.3555570874512),
(5635, '14613', 218, 40, 28433, 43.1814, 0.753657605620679, -77.6354, -1.35499334610281),
(5636, '14614', 218, 40, 28433, 43.1533, 0.753167168100869, -77.608, -1.35451512588776),
(5637, '14615', 218, 40, 28433, 43.2054, 0.754076484641158, -77.6509, -1.35526387213686),
(5638, '14616', 218, 40, 28433, 43.2327, 0.754552959526953, -77.655, -1.3553354306362),
(5639, '14617', 218, 40, 28433, 43.2208, 0.754345265345965, -77.5968, -1.35431964901154),
(5640, '14618', 218, 40, 28433, 43.1168, 0.752530122923891, -77.5572, -1.35362849862775),
(5641, '14619', 218, 40, 28433, 43.1354, 0.752854754164762, -77.6448, -1.35515740705249),
(5642, '14620', 218, 40, 28433, 43.1337, 0.752825083567478, -77.6018, -1.35440691547414),
(5643, '14621', 218, 40, 28433, 43.1849, 0.753718692144499, -77.6023, -1.3544156421204),
(5644, '14622', 218, 40, 28433, 43.216, 0.754261489541869, -77.5622, -1.35371576509035),
(5645, '14623', 218, 40, 28433, 43.082, 0.751922748344197, -77.6323, -1.35493924089599),
(5646, '14624', 218, 40, 28433, 43.1198, 0.752582482801451, -77.7323, -1.35668457014799),
(5647, '14625', 218, 40, 28433, 43.1477, 0.753069429662757, -77.5066, -1.35274536202624),
(5648, '14626', 218, 40, 28433, 43.2113, 0.754179459067026, -77.7046, -1.35620111394519),
(5649, '14627', 218, 40, 28433, 43.1211, 0.752605172081727, -77.67, -1.355597230024),
(5650, '14638', 218, 40, 28433, 43.1579, 0.753247453246461, -77.605, -1.3544627660102),
(5651, '14639', 218, 40, 28433, 43.1551, 0.753198584027405, -77.6038, -1.35444182205918),
(5652, '14642', 218, 40, 28433, 43.1219, 0.752619134715743, -77.6248, -1.35480834120209),
(5653, '14643', 218, 40, 28433, 43.1578, 0.753245707917209, -77.6077, -1.3545098899),
(5654, '14644', 218, 40, 28433, 43.1546, 0.753189857381145, -77.6048, -1.3544592753517),
(5655, '14645', 218, 40, 28433, 43.1555, 0.753205565344413, -77.6046, -1.35445578469319),
(5656, '14646', 218, 40, 28433, 43.1533, 0.753167168100869, -77.6047, -1.35445753002244),
(5657, '14647', 218, 40, 28433, 43.1566, 0.753224763966185, -77.6098, -1.3545465418143),
(5658, '14649', 218, 40, 28433, 43.1576, 0.753242217258705, -77.6031, -1.35442960475441),
(5659, '14650', 218, 40, 28433, 43.161, 0.753301558453273, -77.6197, -1.35471932941024),
(5660, '14651', 218, 40, 28433, 43.1606, 0.753294577136265, -77.6218, -1.35475598132453),
(5661, '14652', 218, 40, 28433, 43.1525, 0.753153205466853, -77.7315, -1.35667060751397),
(5662, '14653', 218, 40, 28433, 43.1541, 0.753181130734885, -77.626, -1.35482928515312),
(5663, '14660', 218, 40, 28433, 43.0873, 0.752015250794553, -77.6499, -1.35524641884434),
(5664, '14664', 218, 40, 28433, 43.1549, 0.753195093368901, -77.6044, -1.35445229403469),
(5665, '14673', 218, 40, 28433, 43.1572, 0.753235235941697, -77.6147, -1.35463206294764),
(5666, '14683', 218, 40, 28433, 43.087, 0.752010014806797, -77.5983, -1.35434582895032),
(5667, '14692', 218, 40, 28433, 43.0856, 0.751985580197269, -77.5993, -1.35436328224284),
(5668, '14694', 218, 40, 28433, 43.0867, 0.752004778819041, -77.5978, -1.35433710230406),
(5669, '14701', 218, 40, 3399, 42.0948, 0.734692857968509, -79.253, -1.38322579208307),
(5670, '14702', 218, 40, 3399, 42.0971, 0.734733000541305, -79.2352, -1.38291512347621),
(5671, '14703', 218, 40, 3399, 42.0963, 0.734719037907289, -79.2363, -1.38293432209798),
(5672, '14704', 218, 40, 3399, 42.0964, 0.734720783236541, -79.2365, -1.38293781275649),
(5673, '14706', 218, 40, 146758, 42.1026, 0.734828993650165, -78.4923, -1.36994907246315),
(5674, '14707', 218, 40, 14969, 42.0884, 0.734581156896381, -78.0618, -1.36243543003331),
(5675, '14708', 218, 40, 7066, 42.0172, 0.733338482468961, -78.0246, -1.36178616755157),
(5676, '14709', 218, 40, 44378, 42.3121, 0.738485458433093, -78.0222, -1.36174427964952),
(5677, '14710', 218, 40, 15040, 42.0772, 0.734385680020158, -79.3742, -1.38534113113648),
(5678, '14711', 218, 40, 7375, 42.3399, 0.738970659965147, -78.1187, -1.36342852237769),
(5679, '14712', 218, 40, 147137, 42.1518, 0.735687695642146, -79.3608, -1.38510725701672),
(5680, '14714', 218, 40, 842, 42.2866, 0.738040399473834, -78.2556, -1.36581787812367),
(5681, '14715', 218, 40, 1034, 42.0783, 0.73440487864193, -78.1562, -1.36408302084719),
(5682, '14716', 218, 40, 26612, 42.3872, 0.73979620070134, -79.4368, -1.38643370724823),
(5683, '14717', 218, 40, 147576, 42.3738, 0.739562326581573, -78.209, -1.36500455469225),
(5684, '14718', 218, 40, 15457, 42.3483, 0.739117267622315, -79.295, -1.3839588303689),
(5685, '14719', 218, 40, 147650, 42.3297, 0.738792636381444, -78.8689, -1.37652198242616),
(5686, '14720', 218, 40, 147681, 42.1077, 0.734918005442016, -79.2802, -1.38370052163961),
(5687, '14721', 218, 40, 19923, 42.0131, 0.73326692396963, -78.2694, -1.36605873356045),
(5688, '14722', 218, 40, 26767, 42.209, 0.736686023974287, -79.4661, -1.38694508871907),
(5689, '14723', 218, 40, 58979, 42.3118, 0.738480222445337, -79.1409, -1.38126927799158),
(5690, '14724', 218, 40, 147897, 42.0516, 0.733938875731648, -79.6686, -1.39047938045435),
(5691, '14726', 218, 40, 147980, 42.24, 0.737227076042405, -79.0614, -1.37988174123625),
(5692, '14727', 218, 40, 1912, 42.2079, 0.736666825352515, -78.2668, -1.3660133549999),
(5693, '14728', 218, 40, 148285, 42.2401, 0.737228821371657, -79.4013, -1.38581411536377),
(5694, '14729', 218, 40, 148506, 42.4077, 0.740153993197999, -78.7259, -1.3740261615958),
(5695, '14730', 218, 40, 148521, 42.1724, 0.736047233468057, -78.9478, -1.37789904720598),
(5696, '14731', 218, 40, 148642, 42.2913, 0.738122429948678, -78.6607, -1.3728882069235),
(5697, '14732', 218, 40, 35744, 42.2164, 0.736815178338934, -79.1048, -1.38063921413161),
(5698, '14733', 218, 40, 148741, 42.1278, 0.735268816621667, -79.191, -1.38214368794683),
(5699, '14735', 218, 40, 27166, 42.455, 0.740979533934193, -78.0874, -1.36288223432182),
(5700, '14736', 218, 40, 148795, 42.1081, 0.734924986759024, -79.7316, -1.39157893788311),
(5701, '14737', 218, 40, 21289, 42.3336, 0.738860704222271, -78.4328, -1.36891060155821),
(5702, '14738', 218, 40, 148995, 42.0521, 0.733947602377907, -79.1362, -1.38118724751674),
(5703, '14739', 218, 40, 2610, 42.2053, 0.736621446791963, -78.1398, -1.36379678684987),
(5704, '14740', 218, 40, 127559, 42.1977, 0.736488801768811, -79.2253, -1.38274233588026),
(5705, '14741', 218, 40, 149259, 42.2165, 0.736816923668186, -78.6107, -1.37201554229751),
(5706, '14742', 218, 40, 47686, 42.1202, 0.735136171598516, -79.3077, -1.38418048718391),
(5707, '14743', 218, 40, 120039, 42.1918, 0.736385827342944, -78.4004, -1.36834511488056),
(5708, '14744', 218, 40, 116085, 42.4143, 0.740269184928631, -78.1687, -1.36430118700369),
(5709, '14745', 218, 40, 109, 42.473, 0.741293693199552, -78.1365, -1.36373919098455),
(5710, '14747', 218, 40, 3499, 42.1563, 0.735766235458486, -79.1023, -1.38059558090031),
(5711, '14748', 218, 40, 150015, 42.1493, 0.735644062410846, -78.6388, -1.37250597981732),
(5712, '14750', 218, 40, 3637, 42.0979, 0.734746963175321, -79.3239, -1.38446323052273),
(5713, '14751', 218, 40, 3732, 42.2931, 0.738153845875214, -79.0168, -1.37910332438986),
(5714, '14752', 218, 40, 150266, 42.3527, 0.739194062109402, -79.3243, -1.38447021183974),
(5715, '14753', 218, 40, 10107, 42.0382, 0.73370500161188, -78.6379, -1.37249027185405),
(5716, '14754', 218, 40, 150312, 42.0216, 0.733415276956049, -78.1829, -1.36454902375747),
(5717, '14755', 218, 40, 36925, 42.2487, 0.737378919687328, -78.8001, -1.37532119590078),
(5718, '14756', 218, 40, 10298, 42.197, 0.736476584464047, -79.4228, -1.38618936115295),
(5719, '14757', 218, 40, 71100, 42.2525, 0.737445242198904, -79.4985, -1.38751057539671),
(5720, '14758', 218, 40, 151112, 42.0123, 0.733252961335614, -79.4499, -1.38666234538024),
(5721, '14760', 218, 40, 30732, 42.0811, 0.734453747860986, -78.4256, -1.36878493785206),
(5722, '14766', 218, 40, 11013, 42.3522, 0.739185335463142, -78.8295, -1.37583432270087),
(5723, '14767', 218, 40, 28181, 42.1836, 0.73624271034428, -79.4467, -1.38660649484418),
(5724, '14769', 218, 40, 5188, 42.3769, 0.739616431788385, -79.4729, -1.3870637711082),
(5725, '14770', 218, 40, 151875, 42.0355, 0.733657877722076, -78.3312, -1.36713734703818),
(5726, '14772', 218, 40, 5293, 42.1492, 0.735642317081594, -78.985, -1.37854830968772),
(5727, '14774', 218, 40, 5372, 42.0902, 0.734612572822917, -78.1565, -1.36408825683495),
(5728, '14775', 218, 40, 5404, 42.2623, 0.7376162844656, -79.7063, -1.39113736958236),
(5729, '14777', 218, 40, 137860, 42.3875, 0.739801436689096, -78.2404, -1.36555258807737),
(5730, '14778', 218, 40, 0, 42.0798, 0.73443105858071, -78.4751, -1.3696488758318),
(5731, '14779', 218, 40, 152313, 42.1586, 0.735806378031281, -78.7178, -1.37388478992639),
(5732, '14781', 218, 40, 18065, 42.1595, 0.735822085994549, -79.5965, -1.38922099806367),
(5733, '14782', 218, 40, 152587, 42.2749, 0.737836195951351, -79.2467, -1.38311583634019),
(5734, '14783', 218, 40, 133261, 42.1084, 0.73493022274678, -78.9049, -1.37715030095687),
(5735, '14784', 218, 40, 510, 42.3269, 0.738743767162388, -79.3651, -1.38518230617455),
(5736, '14785', 218, 40, 126272, 42.1551, 0.735745291507462, -79.4052, -1.3858821832046),
(5737, '14786', 218, 40, 153594, 42.1262, 0.735240891353635, -78.2291, -1.3653553658719),
(5738, '14787', 218, 40, 723, 42.3254, 0.738717587223608, -79.5698, -1.38875499515338),
(5739, '14788', 218, 40, 146629, 42.0623, 0.734125625961611, -78.3791, -1.36797335974989),
(5740, '14801', 218, 40, 34507, 42.1089, 0.73493894939304, -77.2318, -1.34794919724176),
(5741, '14802', 218, 40, 71641, 42.2535, 0.737462695491424, -77.7859, -1.35762006662706),
(5742, '14803', 218, 40, 146753, 42.2554, 0.737495856747212, -77.7876, -1.35764973722434),
(5743, '14804', 218, 40, 7068, 42.3255, 0.73871933255286, -77.824, -1.35828503707207),
(5744, '14805', 218, 40, 7073, 42.3633, 0.739379067010114, -76.732, -1.33922604164029),
(5745, '14806', 218, 40, 14988, 42.1547, 0.735738310190454, -77.8044, -1.35794295253868),
(5746, '14807', 218, 40, 146862, 42.4296, 0.740536220304186, -77.6706, -1.35560770199951),
(5747, '14808', 218, 40, 7187, 42.5522, 0.742675993967131, -77.4794, -1.35227063246969),
(5748, '14809', 218, 40, 7207, 42.4112, 0.740215079721819, -77.4488, -1.35173656171858),
(5749, '14810', 218, 40, 19093, 42.3415, 0.738998585233179, -77.3184, -1.34946065237398),
(5750, '14812', 218, 40, 147076, 42.3093, 0.738436589214037, -76.9863, -1.34366441392811),
(5751, '14813', 218, 40, 303, 42.2314, 0.737076977726733, -78.018, -1.36167097582094),
(5752, '14814', 218, 40, 147197, 42.1464, 0.735593447862538, -76.9442, -1.34292963031302),
(5753, '14815', 218, 40, 1076, 42.3933, 0.739902665785712, -77.0829, -1.34535040198554),
(5754, '14816', 218, 40, 147348, 42.1725, 0.736048978797309, -76.7275, -1.33914750182395),
(5755, '14817', 218, 40, 147418, 42.3678, 0.739457606826454, -76.3647, -1.33281544729771),
(5756, '14818', 218, 40, 31918, 42.4366, 0.740658393351826, -76.8286, -1.34091202969772),
(5757, '14819', 218, 40, 806, 42.2002, 0.736532435000111, -77.4648, -1.3520158143989),
(5758, '14820', 218, 40, 147544, 42.2304, 0.737059524434213, -77.3388, -1.34981669954139),
(5759, '14821', 218, 40, 1317, 42.2417, 0.737256746639689, -77.198, -1.34735927595458),
(5760, '14822', 218, 40, 147571, 42.4548, 0.740976043275689, -77.7876, -1.35764973722434),
(5761, '14823', 218, 40, 134543, 42.2608, 0.73759010452682, -77.5863, -1.35413638944008),
(5762, '14824', 218, 40, 147659, 42.2778, 0.737886810499659, -76.7018, -1.33869895220619),
(5763, '14825', 218, 40, 119104, 42.0471, 0.733860335915308, -76.6188, -1.33725032892703),
(5764, '14826', 218, 40, 147909, 42.4961, 0.741696864256762, -77.5122, -1.35284310046435),
(5765, '14827', 218, 40, 148021, 42.1801, 0.73618162382046, -77.1405, -1.34635571163469),
(5766, '14830', 218, 40, 8235, 42.1456, 0.735579485228522, -77.054, -1.34484600183171),
(5767, '14831', 218, 40, 8235, 42.1476, 0.735614391813562, -77.0569, -1.34489661638002),
(5768, '14836', 218, 40, 8391, 42.544, 0.742532876968467, -77.9228, -1.36000942237304),
(5769, '14837', 218, 40, 2134, 42.5253, 0.742206500398345, -76.9719, -1.34341308651582),
(5770, '14838', 218, 40, 2319, 42.1966, 0.736469603147039, -76.685, -1.33840573689185),
(5771, '14839', 218, 40, 2869, 42.1441, 0.735553305289742, -77.6419, -1.35510679250419),
(5772, '14840', 218, 40, 149422, 42.4517, 0.740921938068877, -77.1846, -1.34712540183482),
(5773, '14841', 218, 40, 3049, 42.5014, 0.741789366707118, -76.8714, -1.34165903061757),
(5774, '14842', 218, 40, 120035, 42.5934, 0.743395069618953, -76.9462, -1.34296453689806),
(5775, '14843', 218, 40, 149703, 42.3288, 0.738776928418176, -77.6563, -1.35535811991647),
(5776, '14844', 218, 40, 149706, 42.1611, 0.735850011262581, -76.8789, -1.34178993031147),
(5777, '14845', 218, 40, 149706, 42.1791, 0.73616417052794, -76.8395, -1.34110227058618),
(5778, '14846', 218, 40, 9616, 42.5558, 0.742738825820203, -78.004, -1.36142662972566),
(5779, '14847', 218, 40, 125143, 42.6138, 0.74375111678636, -76.7324, -1.3392330229573),
(5780, '14850', 218, 40, 22194, 42.4471, 0.740841652923285, -76.4957, -1.33510182861783),
(5781, '14851', 218, 40, 22194, 42.4481, 0.740859106215805, -76.5043, -1.3352519269335),
(5782, '14852', 218, 40, 22194, 42.5049, 0.741850453230938, -76.4712, -1.33467422295109),
(5783, '14853', 218, 40, 22194, 42.4406, 0.740728206521906, -76.4868, -1.3349464943144),
(5784, '14854', 218, 40, 3395, 42.5049, 0.741850453230938, -76.6092, -1.33708277731884),
(5785, '14855', 218, 40, 738, 42.1033, 0.734841210954928, -77.5312, -1.35317471302223),
(5786, '14856', 218, 40, 149949, 42.335, 0.738885138831799, -77.3186, -1.34946414303249),
(5787, '14857', 218, 40, 16824, 42.5171, 0.742063383399681, -76.9293, -1.34266957625447),
(5788, '14858', 218, 40, 76413, 42.059, 0.734068030096295, -77.1491, -1.34650580995036),
(5789, '14859', 218, 40, 16930, 42.0916, 0.734637007432445, -76.5782, -1.33654172525072),
(5790, '14860', 218, 40, 112, 42.6025, 0.743553894580884, -76.8431, -1.34116510243925),
(5791, '14861', 218, 40, 150418, 42.1359, 0.735410188291079, -76.7286, -1.33916670044572),
(5792, '14863', 218, 40, 150658, 42.4581, 0.741033639141005, -76.7127, -1.33888919309465),
(5793, '14864', 218, 40, 4224, 42.2652, 0.737666899013907, -76.8406, -1.34112146920795),
(5794, '14865', 218, 40, 150831, 42.3462, 0.739080615708023, -76.8375, -1.34106736400114),
(5795, '14867', 218, 40, 71169, 42.3558, 0.739248167316214, -76.5999, -1.3369204616984),
(5796, '14869', 218, 40, 14343, 42.3503, 0.739152174207354, -76.7785, -1.34003761974247),
(5797, '14870', 218, 40, 151524, 42.1552, 0.735747036836714, -77.116, -1.34592810596795),
(5798, '14871', 218, 40, 11203, 42.0511, 0.733930149085387, -76.8661, -1.34156652816721),
(5799, '14872', 218, 40, 443, 42.2267, 0.73699494725189, -76.8517, -1.34131520075493),
(5800, '14873', 218, 40, 0, 42.5255, 0.742209991056849, -77.2511, -1.34828604578739),
(5801, '14874', 218, 40, 151924, 42.5331, 0.74234263608, -77.169, -1.3468531304715),
(5802, '14876', 218, 40, 151999, 42.434, 0.740613014791274, -76.9515, -1.34305703934842),
(5803, '14877', 218, 40, 30954, 42.0745, 0.734338556130354, -77.6664, -1.35553439817092),
(5804, '14878', 218, 40, 152160, 42.4698, 0.741237842663488, -76.9321, -1.34271844547353),
(5805, '14879', 218, 40, 74217, 42.3081, 0.738415645263013, -77.1852, -1.34713587381033),
(5806, '14880', 218, 40, 133027, 42.1678, 0.735966948322465, -77.982, -1.36104265729022),
(5807, '14881', 218, 40, 152603, 42.3944, 0.739921864407484, -76.3572, -1.33268454760381),
(5808, '14882', 218, 40, 9985, 42.5663, 0.742922085391662, -76.5412, -1.33589595342748),
(5809, '14883', 218, 40, 5995, 42.2216, 0.736905935460038, -76.4832, -1.33488366246133),
(5810, '14884', 218, 40, 797, 42.4561, 0.740998732555964, -77.8982, -1.35958007137705),
(5811, '14885', 218, 40, 153198, 42.0635, 0.734146569912635, -77.5648, -1.3537611436509),
(5812, '14886', 218, 40, 153206, 42.5177, 0.742073855375193, -76.6472, -1.3377460024346),
(5813, '14887', 218, 40, 25631, 42.401, 0.740037056138116, -77.0686, -1.3451008199025),
(5814, '14889', 218, 40, 153343, 42.2145, 0.736782017083146, -76.579, -1.33655568788474),
(5815, '14891', 218, 40, 153502, 42.3758, 0.739597233166613, -76.9119, -1.34236588896463),
(5816, '14892', 218, 40, 6664, 42.0144, 0.733289613249906, -76.5346, -1.33578076169685),
(5817, '14893', 218, 40, 6665, 42.4666, 0.741181992127424, -77.1094, -1.34581291423732),
(5818, '14894', 218, 40, 38797, 42.0114, 0.733237253372346, -76.7287, -1.33916844577497),
(5819, '14895', 218, 40, 34380, 42.1149, 0.73504366914816, -77.9419, -1.36034278026017),
(5820, '14897', 218, 40, 6796, 42.0369, 0.733682312331604, -77.7777, -1.35747694962839),
(5821, '14898', 218, 40, 122045, 42.0778, 0.73439615199567, -77.408, -1.35102446738377),
(5822, '14901', 218, 40, 54613, 42.0995, 0.734774888443353, -76.8076, -1.3405455105548),
(5823, '14902', 218, 40, 54613, 42.1051, 0.734872626881464, -76.815, -1.34067466491944),
(5824, '14903', 218, 40, 54613, 42.1289, 0.735288015243439, -76.8492, -1.34127156752363),
(5825, '14904', 218, 40, 54613, 42.0718, 0.73429143224055, -76.8033, -1.34047046139696),
(5826, '14905', 218, 40, 54613, 42.0873, 0.734561958274609, -76.8398, -1.34110750657394),
(5827, '14925', 218, 40, 54613, 42.1137, 0.735022725197136, -76.7595, -1.33970600718459),
(5828, '15001', 218, 45, 158602, 40.6058, 0.708704905406313, -80.2842, -1.40122362732963),
(5829, '15003', 218, 45, 158676, 40.5969, 0.708549571102886, -80.2173, -1.40005600206005),
(5830, '15004', 218, 45, 158815, 40.3827, 0.704811075845114, -80.392, -1.40310509226328),
(5831, '15005', 218, 45, 19014, 40.643, 0.709354167888055, -80.2017, -1.39978373069674),
(5832, '15006', 218, 45, 158875, 40.6312, 0.70914821903632, -79.8818, -1.39420042241961),
(5833, '15007', 218, 45, 15086, 40.6507, 0.709488558240459, -79.932, -1.39507657770411),
(5834, '15009', 218, 45, 7346, 40.6967, 0.710291409696376, -80.3341, -1.40209454662638),
(5835, '15010', 218, 45, 134153, 40.7617, 0.711425873710173, -80.3416, -1.40222544632028),
(5836, '15012', 218, 45, 154252, 40.1222, 0.700264493143669, -79.8451, -1.39355988658412),
(5837, '15014', 218, 45, 159420, 40.608, 0.708743302649857, -79.7427, -1.39177266943008),
(5838, '15015', 218, 45, 0, 40.6362, 0.70923548549892, -80.0816, -1.39768759026509),
(5839, '15017', 218, 45, 1134, 40.3558, 0.704341582276328, -80.1142, -1.39825656760124),
(5840, '15018', 218, 45, 1223, 40.2658, 0.702770785949533, -79.7979, -1.39273609117718),
(5841, '15019', 218, 45, 108417, 40.3697, 0.704584183042355, -80.2984, -1.40147146408341),
(5842, '15020', 218, 45, 159668, 40.2368, 0.702264640466454, -79.9511, -1.39540993559124),
(5843, '15021', 218, 45, 159672, 40.3813, 0.704786641235586, -80.3915, -1.40309636561702),
(5844, '15022', 218, 45, 159981, 40.1412, 0.700596105701548, -79.9038, -1.39458439485505),
(5845, '15024', 218, 45, 160059, 40.5668, 0.708024226998036, -79.8329, -1.39334695641538),
(5846, '15025', 218, 45, 160101, 40.2975, 0.703324055322415, -79.915, -1.39477987173127),
(5847, '15026', 218, 45, 1630, 40.514, 0.707102693152983, -80.3573, -1.40249946301284),
(5848, '15027', 218, 45, 8215, 40.664, 0.709720687030974, -80.234, -1.40034747204513),
(5849, '15028', 218, 45, 0, 40.2985, 0.703341508614935, -79.8013, -1.39279543237175),
(5850, '15030', 218, 45, 15664, 40.5839, 0.708322678300127, -79.7806, -1.39243414921659),
(5851, '15031', 218, 45, 0, 40.3536, 0.704303185032784, -80.1588, -1.39903498444763),
(5852, '15032', 218, 45, 108773, 40.6376, 0.709259920108448, -79.8433, -1.39352847065759),
(5853, '15033', 218, 45, 160847, 40.1775, 0.701229660220022, -79.8631, -1.39387404584948),
(5854, '15034', 218, 45, 160895, 40.352, 0.704275259764752, -79.8906, -1.39435401139378),
(5855, '15035', 218, 45, 161088, 40.3833, 0.704821547820626, -79.808, -1.39291236943163),
(5856, '15036', 218, 45, 161260, 40.3519, 0.7042735144355, -80.4787, -1.40461829272476),
(5857, '15037', 218, 45, 8719, 40.2679, 0.702807437863825, -79.862, -1.39385484722771),
(5858, '15038', 218, 45, 161337, 40.2524, 0.702536911829766, -79.9234, -1.39492647938844),
(5859, '15042', 218, 45, 29850, 40.6824, 0.710041827613341, -80.2232, -1.40015897648592),
(5860, '15043', 218, 45, 2693, 40.6883, 0.710144802039209, -80.3552, -1.40246281109855),
(5861, '15044', 218, 45, 16206, 40.625, 0.709040008622696, -79.9537, -1.39545531415179),
(5862, '15045', 218, 45, 162074, 40.3278, 0.703852890085769, -79.8914, -1.3943679740278),
(5863, '15046', 218, 45, 8292, 40.5515, 0.707757191622481, -80.2167, -1.40004553008454),
(5864, '15047', 218, 45, 47696, 40.3124, 0.703584109380962, -79.7976, -1.39273085518943),
(5865, '15049', 218, 45, 162493, 40.5551, 0.707820023475552, -79.8057, -1.39287222685884),
(5866, '15050', 218, 45, 162815, 40.5836, 0.708317442312371, -80.459, -1.40427446286212),
(5867, '15051', 218, 45, 16542, 40.5651, 0.707994556400752, -79.8599, -1.39381819531342),
(5868, '15052', 218, 45, 3343, 40.6707, 0.709837624090858, -80.4296, -1.40376133606203),
(5869, '15053', 218, 45, 3430, 40.3806, 0.704774423930822, -80.3621, -1.40258323881694),
(5870, '15054', 218, 45, 163568, 40.3628, 0.704463755323967, -80.4096, -1.40341227021163),
(5871, '15055', 218, 45, 3696, 40.3052, 0.703458445674819, -80.1281, -1.39849916836727),
(5872, '15056', 218, 45, 163697, 40.5658, 0.708006773705516, -80.2095, -1.39991986637839),
(5873, '15057', 218, 45, 815, 40.3637, 0.704479463287235, -80.232, -1.40031256546009),
(5874, '15059', 218, 45, 10461, 40.6621, 0.709687525775186, -80.4731, -1.40452055428665),
(5875, '15060', 218, 45, 41, 40.367, 0.704537059152551, -80.2955, -1.40142084953511),
(5876, '15061', 218, 45, 164697, 40.6712, 0.709846350737118, -80.2931, -1.40137896163306),
(5877, '15062', 218, 45, 164701, 40.1545, 0.700828234492063, -79.881, -1.39418645978559),
(5878, '15063', 218, 45, 164709, 40.1958, 0.701549055473137, -79.9303, -1.39504690710682),
(5879, '15064', 218, 45, 4319, 40.3546, 0.704320638325304, -80.1468, -1.39882554493739),
(5880, '15065', 218, 45, 165028, 40.6263, 0.709062697902972, -79.7233, -1.3914340755552),
(5881, '15066', 218, 45, 137067, 40.7357, 0.710972088104654, -80.2909, -1.40134056438951),
(5882, '15067', 218, 45, 165115, 40.2066, 0.701737551032352, -79.9519, -1.39542389822525),
(5883, '15068', 218, 45, 165141, 40.5755, 0.708176070642959, -79.7219, -1.39140964094567),
(5884, '15069', 218, 45, 165141, 40.5696, 0.708073096217092, -79.751, -1.391917531758),
(5885, '15071', 218, 45, 4701, 40.4163, 0.705397506473784, -80.1915, -1.39960570711303),
(5886, '15072', 218, 45, 61429, 40.1376, 0.700533273848476, -79.8566, -1.3937605994481),
(5887, '15074', 218, 45, 28433, 40.7072, 0.710474669267836, -80.2701, -1.4009775359051),
(5888, '15075', 218, 45, 166730, 40.5863, 0.708364566202175, -79.8263, -1.39323176468475),
(5889, '15076', 218, 45, 166747, 40.6077, 0.708738066662101, -79.8364, -1.3934080429392),
(5890, '15077', 218, 45, 167147, 40.6203, 0.708957978147853, -80.4255, -1.4036897775627),
(5891, '15078', 218, 45, 167253, 40.3593, 0.704402668800147, -80.3874, -1.40302480711769),
(5892, '15081', 218, 45, 167371, 40.5738, 0.708146400045675, -80.237, -1.40039983192269),
(5893, '15082', 218, 45, 38424, 40.4149, 0.705373071864256, -80.1963, -1.39968948291713),
(5894, '15083', 218, 45, 167792, 40.235, 0.702233224539918, -79.8047, -1.39285477356632),
(5895, '15084', 218, 45, 6241, 40.6102, 0.708781699893401, -79.7742, -1.39232244814446),
(5896, '15085', 218, 45, 6373, 40.3847, 0.704845982430154, -79.7375, -1.39168191230898),
(5897, '15086', 218, 45, 168495, 40.6661, 0.709757338945266, -80.0924, -1.39787608582431);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(5898, '15087', 218, 45, 18520, 40.1854, 0.701367541230929, -79.8484, -1.39361748244944),
(5899, '15088', 218, 45, 168707, 40.272, 0.702878996363156, -79.8967, -1.39446047647815),
(5900, '15089', 218, 45, 31494, 40.2128, 0.701845761445976, -79.7658, -1.39217584048729),
(5901, '15090', 218, 45, 52695, 40.617, 0.708900382282537, -80.0643, -1.3973856483045),
(5902, '15091', 218, 45, 6816, 40.5944, 0.708505937871586, -79.966, -1.39566998964979),
(5903, '15095', 218, 45, 168495, 40.6444, 0.709378602497583, -80.1082, -1.39815184784612),
(5904, '15096', 218, 45, 168495, 40.6529, 0.709526955484003, -80.0931, -1.39788830312907),
(5905, '15101', 218, 45, 158646, 40.5676, 0.708038189632052, -79.9691, -1.3957240948566),
(5906, '15102', 218, 45, 159180, 40.3237, 0.703781331586438, -80.0381, -1.39692837204047),
(5907, '15104', 218, 45, 604, 40.4049, 0.705198538939057, -79.8636, -1.39388277249574),
(5908, '15106', 218, 45, 19794, 40.404, 0.705182830975789, -80.0967, -1.39795113498214),
(5909, '15108', 218, 45, 160412, 40.5093, 0.707020662678139, -80.1804, -1.39941197556606),
(5910, '15110', 218, 45, 54509, 40.3704, 0.704596400347119, -79.8528, -1.39369427693653),
(5911, '15112', 218, 45, 161108, 40.4032, 0.705168868341773, -79.8385, -1.39344469485349),
(5912, '15116', 218, 45, 162117, 40.5366, 0.707497137563933, -79.9623, -1.39560541246746),
(5913, '15120', 218, 45, 3212, 40.3943, 0.705013534038345, -79.9046, -1.39459835748906),
(5914, '15122', 218, 45, 168771, 40.367, 0.704537059152551, -79.8956, -1.39444127785638),
(5915, '15123', 218, 45, 168771, 40.3367, 0.704008224389197, -79.9506, -1.39540120894498),
(5916, '15126', 218, 45, 22138, 40.4478, 0.705947285188162, -80.2413, -1.40047488108053),
(5917, '15127', 218, 45, 60380, 40.585, 0.708341876921899, -80.0555, -1.39723205933032),
(5918, '15129', 218, 45, 38294, 40.2976, 0.703325800651667, -80.003, -1.39631576147302),
(5919, '15130', 218, 45, 164401, 40.3398, 0.704062329596008, -79.8429, -1.39352148934058),
(5920, '15131', 218, 45, 164401, 40.3412, 0.704086764205537, -79.8115, -1.39297345595545),
(5921, '15132', 218, 45, 164401, 40.3402, 0.704069310913017, -79.8411, -1.39349007341404),
(5922, '15133', 218, 45, 164401, 40.3341, 0.703962845828645, -79.8635, -1.39388102716649),
(5923, '15134', 218, 45, 164401, 40.3413, 0.704088509534788, -79.8442, -1.39354417862086),
(5924, '15135', 218, 45, 164401, 40.3045, 0.703446228370055, -79.8145, -1.39302581583301),
(5925, '15136', 218, 45, 164395, 40.4709, 0.706350456245373, -80.089, -1.39781674462974),
(5926, '15137', 218, 45, 165363, 40.3911, 0.704957683502282, -79.8368, -1.39341502425621),
(5927, '15139', 218, 45, 14338, 40.5194, 0.70719694093259, -79.8366, -1.39341153359771),
(5928, '15140', 218, 45, 140711, 40.4057, 0.705212501573073, -79.7765, -1.39236259071726),
(5929, '15142', 218, 45, 166198, 40.3781, 0.704730790699522, -80.1217, -1.39838746729514),
(5930, '15143', 218, 45, 167012, 40.5519, 0.707764172939489, -80.1535, -1.39894248199727),
(5931, '15144', 218, 45, 6023, 40.5379, 0.707519826844209, -79.7848, -1.39250745304517),
(5932, '15145', 218, 45, 25603, 40.4121, 0.7053242026452, -79.8245, -1.39320034875821),
(5933, '15146', 218, 45, 4273, 40.4264, 0.705573784728236, -79.7636, -1.39213744324375),
(5934, '15147', 218, 45, 12546, 40.492, 0.706718720717544, -79.8333, -1.39335393773239),
(5935, '15148', 218, 45, 169006, 40.3937, 0.705003062062834, -79.8001, -1.39277448842073),
(5936, '15189', 218, 45, 167012, 40.5392, 0.707542516124485, -80.1805, -1.39941372089531),
(5937, '15201', 218, 45, 140779, 40.4738, 0.706401070793681, -79.9517, -1.39542040756675),
(5938, '15202', 218, 45, 140779, 40.5007, 0.706870564362467, -80.0671, -1.39743451752355),
(5939, '15203', 218, 45, 140779, 40.4251, 0.70555109544796, -79.9775, -1.39587070251377),
(5940, '15204', 218, 45, 140779, 40.4521, 0.706022334345998, -80.0538, -1.39720238873304),
(5941, '15205', 218, 45, 140779, 40.4355, 0.705732609690167, -80.0749, -1.39757065320521),
(5942, '15206', 218, 45, 140779, 40.4688, 0.706313804331081, -79.9146, -1.39477289041426),
(5943, '15207', 218, 45, 140779, 40.3971, 0.705062403257401, -79.9308, -1.39505563375308),
(5944, '15208', 218, 45, 140779, 40.4537, 0.70605025961403, -79.8987, -1.39449538306319),
(5945, '15209', 218, 45, 140779, 40.4954, 0.706778061912112, -79.9764, -1.39585150389199),
(5946, '15210', 218, 45, 140779, 40.4088, 0.705266606779885, -79.986, -1.39601905550018),
(5947, '15211', 218, 45, 140779, 40.4297, 0.705631380593551, -80.0129, -1.39648854906897),
(5948, '15212', 218, 45, 140779, 40.4669, 0.706280643075293, -80.0108, -1.39645189715468),
(5949, '15213', 218, 45, 140779, 40.4433, 0.705868745371823, -79.9562, -1.39549894738309),
(5950, '15214', 218, 45, 140779, 40.482, 0.706544187792345, -80.0162, -1.39654614493429),
(5951, '15215', 218, 45, 140779, 40.4995, 0.706849620411444, -79.9171, -1.39481652364556),
(5952, '15216', 218, 45, 140779, 40.4007, 0.705125235110473, -80.0347, -1.39686903084591),
(5953, '15217', 218, 45, 140779, 40.4311, 0.705655815203079, -79.9258, -1.39496836729048),
(5954, '15218', 218, 45, 140779, 40.4245, 0.705540623472448, -79.8878, -1.39430514217473),
(5955, '15219', 218, 45, 140779, 40.4452, 0.705901906627611, -79.9786, -1.39588990113554),
(5956, '15220', 218, 45, 140779, 40.426, 0.705566803411228, -80.0484, -1.39710814095343),
(5957, '15221', 218, 45, 140779, 40.4361, 0.705743081665679, -79.8667, -1.39393687770256),
(5958, '15222', 218, 45, 140779, 40.4484, 0.705957757163674, -79.99, -1.39608886867026),
(5959, '15223', 218, 45, 140779, 40.5032, 0.706914197593767, -79.9545, -1.39546927678581),
(5960, '15224', 218, 45, 140779, 40.464, 0.706230028526985, -79.9469, -1.39533663176265),
(5961, '15225', 218, 45, 140779, 40.5045, 0.706936886874043, -80.1182, -1.39832638077132),
(5962, '15226', 218, 45, 140779, 40.3952, 0.705029242001613, -80.0151, -1.39652694631251),
(5963, '15227', 218, 45, 140779, 40.3771, 0.704713337407002, -79.9735, -1.39580088934369),
(5964, '15228', 218, 45, 140779, 40.378, 0.70472904537027, -80.0393, -1.3969493159915),
(5965, '15229', 218, 45, 140779, 40.5164, 0.707144581055031, -80.0391, -1.39694582533299),
(5966, '15230', 218, 45, 140779, 40.5096, 0.707025898665895, -80.0788, -1.39763872104604),
(5967, '15231', 218, 45, 140779, 40.5021, 0.706894998971995, -80.1918, -1.39961094310079),
(5968, '15232', 218, 45, 140779, 40.4524, 0.706027570333754, -79.9327, -1.39508879500887),
(5969, '15233', 218, 45, 140779, 40.456, 0.706090402186826, -80.0255, -1.39670846055472),
(5970, '15234', 218, 45, 140779, 40.3698, 0.704585928371607, -80.0164, -1.39654963559279),
(5971, '15235', 218, 45, 140779, 40.4601, 0.706161960686158, -79.8338, -1.39336266437865),
(5972, '15236', 218, 45, 140779, 40.3463, 0.704175775997388, -79.9779, -1.39587768383077),
(5973, '15237', 218, 45, 140779, 40.5501, 0.707732757012953, -80.0387, -1.39693884401599),
(5974, '15238', 218, 45, 140779, 40.5314, 0.70740638044283, -79.8793, -1.39415678918831),
(5975, '15239', 218, 45, 140779, 40.482, 0.706544187792345, -79.7474, -1.39185469990493),
(5976, '15240', 218, 45, 140779, 40.4458, 0.705912378603123, -79.9627, -1.39561239378447),
(5977, '15241', 218, 45, 140779, 40.3342, 0.703964591157897, -80.0789, -1.39764046637529),
(5978, '15242', 218, 45, 140779, 40.4202, 0.705465574314612, -80.0469, -1.39708196101465),
(5979, '15243', 218, 45, 140779, 40.3742, 0.704662722858695, -80.0716, -1.39751305733989),
(5980, '15244', 218, 45, 140779, 40.4438, 0.705877472018083, -80.1434, -1.39876620374282),
(5981, '15250', 218, 45, 140779, 40.4447, 0.705893179981351, -79.9522, -1.39542913421301),
(5982, '15251', 218, 45, 140779, 40.4448, 0.705894925310603, -79.9524, -1.39543262487151),
(5983, '15252', 218, 45, 140779, 40.44, 0.705811149506507, -79.9973, -1.39621627770566),
(5984, '15253', 218, 45, 140779, 40.4595, 0.706151488710646, -80.0221, -1.39664911936015),
(5985, '15254', 218, 45, 140779, 40.4395, 0.705802422860247, -79.9967, -1.39620580573015),
(5986, '15255', 218, 45, 140779, 40.4594, 0.706149743381394, -80.0222, -1.39665086468941),
(5987, '15257', 218, 45, 140779, 40.4405, 0.705819876152767, -79.997, -1.3962110417179),
(5988, '15258', 218, 45, 140779, 40.4402, 0.705814640165011, -79.9973, -1.39621627770566),
(5989, '15259', 218, 45, 140779, 40.4404, 0.705818130823515, -79.9968, -1.3962075510594),
(5990, '15260', 218, 45, 140779, 40.444, 0.705880962676587, -79.9562, -1.39549894738309),
(5991, '15261', 218, 45, 140779, 40.4418, 0.705842565433043, -79.9564, -1.39550243804159),
(5992, '15262', 218, 45, 140779, 40.4712, 0.706355692233129, -79.99, -1.39608886867026),
(5993, '15263', 218, 45, 140779, 40.4428, 0.705860018725563, -80.0236, -1.39667529929893),
(5994, '15264', 218, 45, 140779, 40.4437, 0.705875726688831, -79.9551, -1.39547974876132),
(5995, '15265', 218, 45, 140779, 40.4418, 0.705842565433043, -80.0001, -1.39626514692472),
(5996, '15267', 218, 45, 140779, 40.4684, 0.706306823014073, -80.0372, -1.39691266407721),
(5997, '15268', 218, 45, 140779, 40.487, 0.706631454254944, -79.7339, -1.39161908045591),
(5998, '15270', 218, 45, 140779, 40.4048, 0.705196793609805, -80.0351, -1.39687601216291),
(5999, '15272', 218, 45, 140779, 40.442, 0.705846056091547, -80.0046, -1.39634368674106),
(6000, '15274', 218, 45, 140779, 40.4434, 0.705870490701075, -79.9551, -1.39547974876132),
(6001, '15275', 218, 45, 140779, 40.4381, 0.705777988250719, -80.0932, -1.39789004845832),
(6002, '15276', 218, 45, 140779, 40.4385, 0.705784969567727, -80.0937, -1.39789877510458),
(6003, '15277', 218, 45, 140779, 40.44, 0.705811149506507, -80.0976, -1.39796684294541),
(6004, '15278', 218, 45, 140779, 40.5092, 0.707018917348887, -80.0789, -1.39764046637529),
(6005, '15279', 218, 45, 140779, 40.4679, 0.706298096367813, -80.0378, -1.39692313605272),
(6006, '15281', 218, 45, 140779, 40.441, 0.705828602799027, -79.9991, -1.3962476936322),
(6007, '15282', 218, 45, 140779, 40.4357, 0.705736100348671, -79.9923, -1.39612901124306),
(6008, '15283', 218, 45, 140779, 40.4199, 0.705460338326856, -80.0471, -1.39708545167315),
(6009, '15285', 218, 45, 140779, 40.4389, 0.705791950884735, -79.9766, -1.3958549945505),
(6010, '15286', 218, 45, 140779, 40.4587, 0.70613752607663, -80.0301, -1.39678874570031),
(6011, '15290', 218, 45, 140779, 40.5087, 0.707010190702627, -80.079, -1.39764221170454),
(6012, '15295', 218, 45, 140779, 40.4406, 0.705821621482019, -79.9961, -1.39619533375464),
(6013, '15301', 218, 45, 12671, 40.1742, 0.701172064354706, -80.2531, -1.40068082993226),
(6014, '15310', 218, 45, 77774, 39.8216, 0.695018033412174, -80.4609, -1.40430762411791),
(6015, '15311', 218, 45, 7091, 40.0506, 0.699014837399241, -80.2023, -1.39979420267225),
(6016, '15312', 218, 45, 158839, 40.2716, 0.702872015046148, -80.4483, -1.40408771263215),
(6017, '15313', 218, 45, 44669, 40.0637, 0.699243475531252, -80.0257, -1.39671195121323),
(6018, '15314', 218, 45, 357, 40.1189, 0.700206897278353, -80.009, -1.39642048122814),
(6019, '15315', 218, 45, 29249, 39.7605, 0.693951637239205, -79.9844, -1.39599113023215),
(6020, '15316', 218, 45, 77908, 39.7247, 0.693326809366991, -80.2602, -1.40080474830915),
(6021, '15317', 218, 45, 159793, 40.268, 0.702809183193077, -80.15, -1.39888139547346),
(6022, '15320', 218, 45, 77972, 39.8912, 0.696232782571562, -79.9713, -1.39576249210014),
(6023, '15321', 218, 45, 7972, 40.3189, 0.703697555782342, -80.1915, -1.39960570711303),
(6024, '15322', 218, 45, 848, 39.9635, 0.697494655620754, -80.0525, -1.39717969945276),
(6025, '15323', 218, 45, 1607, 40.1303, 0.70040586481308, -80.3906, -1.40308065765375),
(6026, '15324', 218, 45, 160247, 40.0999, 0.699875284720474, -80.0651, -1.39739961093851),
(6027, '15325', 218, 45, 78098, 39.9479, 0.697222384257443, -79.9655, -1.39566126300353),
(6028, '15327', 218, 45, 78135, 39.7559, 0.693871352093614, -79.9945, -1.3961674084866),
(6029, '15329', 218, 45, 558, 40.0974, 0.699831651489174, -80.2927, -1.40137198031605),
(6030, '15330', 218, 45, 161247, 40.1933, 0.701505422241837, -80.1292, -1.39851836698904),
(6031, '15331', 218, 45, 579, 40.1069, 0.699997457768114, -80.0198, -1.39660897678736),
(6032, '15332', 218, 45, 161622, 40.2572, 0.702620687633861, -80.005, -1.39635066805806),
(6033, '15333', 218, 45, 35990, 40.0276, 0.698613411671282, -80.0339, -1.39685506821189),
(6034, '15334', 218, 45, 78318, 39.8643, 0.695763289002776, -80.0032, -1.39631925213153),
(6035, '15336', 218, 45, 161981, 40.2645, 0.702748096669257, -80.0072, -1.39638906530161),
(6036, '15337', 218, 45, 2830, 39.8968, 0.696330521009674, -80.3972, -1.40319584938439),
(6037, '15338', 218, 45, 2866, 39.8157, 0.694915058986306, -79.95, -1.39539073696947),
(6038, '15339', 218, 45, 65498, 40.2991, 0.703351980590447, -80.1527, -1.39892851936326),
(6039, '15340', 218, 45, 3077, 40.2939, 0.703261223469343, -80.3108, -1.40168788491066),
(6040, '15341', 218, 45, 21986, 39.8446, 0.695419459140133, -80.3416, -1.40222544632028),
(6041, '15342', 218, 45, 3246, 40.2432, 0.702376341538582, -80.2158, -1.40002982212127),
(6042, '15344', 218, 45, 3409, 39.9184, 0.696707512128104, -80.0573, -1.39726347525686),
(6043, '15345', 218, 45, 10308, 40.0252, 0.698571523769234, -80.098, -1.39797382426242),
(6044, '15346', 218, 45, 78703, 39.9368, 0.697028652710471, -80.0755, -1.39758112518072),
(6045, '15347', 218, 45, 164423, 40.217, 0.701919065274559, -80.2285, -1.40025147893627),
(6046, '15348', 218, 45, 14244, 39.9902, 0.697960658531036, -79.9936, -1.39615170052334),
(6047, '15349', 218, 45, 78784, 39.7575, 0.693899277361646, -80.0286, -1.39676256576153),
(6048, '15350', 218, 45, 76667, 40.2928, 0.703242024847571, -80.2019, -1.39978722135524),
(6049, '15351', 218, 45, 78805, 39.8781, 0.696004144439551, -79.9242, -1.39494044202245),
(6050, '15352', 218, 45, 78818, 39.7561, 0.693874842752118, -80.4598, -1.40428842549613),
(6051, '15353', 218, 45, 30667, 39.9721, 0.697644753936425, -80.3055, -1.40159538246031),
(6052, '15354', 218, 45, 78946, 39.762, 0.693977817177985, -80.2775, -1.40110669026975),
(6053, '15357', 218, 45, 79019, 39.9463, 0.697194458989411, -79.9964, -1.39620056974239),
(6054, '15358', 218, 45, 166448, 40.0557, 0.699103849191093, -79.9984, -1.39623547632743),
(6055, '15359', 218, 45, 5512, 39.905, 0.696473638008337, -80.2881, -1.40129169517046),
(6056, '15360', 218, 45, 166915, 40.105, 0.699964296512326, -80.0199, -1.39661072211661),
(6057, '15361', 218, 45, 51581, 40.3278, 0.703852890085769, -80.2592, -1.40078729501663),
(6058, '15362', 218, 45, 79179, 39.762, 0.693977817177985, -80.2776, -1.401108435599),
(6059, '15363', 218, 45, 69161, 40.251, 0.702512477220238, -80.199, -1.39973660680693),
(6060, '15364', 218, 45, 6199, 39.9531, 0.697313141378547, -80.2256, -1.40020086438796),
(6061, '15365', 218, 45, 106833, 40.1597, 0.700918991613167, -80.3785, -1.40286947281426),
(6062, '15366', 218, 45, 111838, 40.1582, 0.700892811674387, -79.9722, -1.39577820006341),
(6063, '15367', 218, 45, 18431, 40.2707, 0.70285630708288, -80.0594, -1.39730012717115),
(6064, '15368', 218, 45, 133517, 40.0181, 0.698447605392343, -79.9875, -1.39604523543896),
(6065, '15370', 218, 45, 484, 39.8974, 0.696340992985186, -80.1746, -1.39931074646945),
(6066, '15376', 218, 45, 168661, 40.1114, 0.700075997584454, -80.4895, -1.40480678828398),
(6067, '15377', 218, 45, 79369, 39.9836, 0.697845466800405, -80.4437, -1.40400742748656),
(6068, '15378', 218, 45, 6743, 40.2766, 0.702959281508748, -80.2721, -1.40101244249014),
(6069, '15379', 218, 45, 74776, 40.2451, 0.70240950279437, -80.4256, -1.40369152289195),
(6070, '15380', 218, 45, 79425, 39.8884, 0.696183913352506, -80.4699, -1.40446470375058),
(6071, '15401', 218, 45, 6475, 39.9006, 0.696396843521249, -79.7282, -1.39151959668854),
(6072, '15410', 218, 45, 77760, 39.8884, 0.696183913352506, -79.8924, -1.39438542732032),
(6073, '15411', 218, 45, 34507, 39.7762, 0.694225653931769, -79.3045, -1.38412463664784),
(6074, '15412', 218, 45, 158626, 40.0791, 0.699512256236059, -79.8561, -1.39375187280184),
(6075, '15413', 218, 45, 7064, 39.9877, 0.697917025299736, -79.8685, -1.39396829362909),
(6076, '15415', 218, 45, 77916, 39.9798, 0.697779144288829, -79.8278, -1.39325794462353),
(6077, '15416', 218, 45, 26621, 39.8573, 0.695641115955136, -79.7122, -1.39124034400822),
(6078, '15417', 218, 45, 1191, 40.0114, 0.698330668332459, -79.8879, -1.39430688750398),
(6079, '15419', 218, 45, 19701, 40.0631, 0.69923300355574, -79.8912, -1.39436448336929),
(6080, '15420', 218, 45, 77969, 39.9577, 0.697393426524138, -79.8675, -1.39395084033657),
(6081, '15421', 218, 45, 93174, 39.8446, 0.695419459140133, -79.6165, -1.38957006391407),
(6082, '15422', 218, 45, 1540, 39.9799, 0.697780889618081, -79.8111, -1.39296647463845),
(6083, '15423', 218, 45, 160202, 40.0677, 0.699313288701332, -79.9038, -1.39458439485505),
(6084, '15424', 218, 45, 1736, 39.8113, 0.694838264499219, -79.3593, -1.38508107707794),
(6085, '15425', 218, 45, 160359, 40.0171, 0.698430152099823, -79.5889, -1.38908835304051),
(6086, '15427', 218, 45, 160626, 40.0563, 0.699114321166605, -79.9379, -1.39517955212998),
(6087, '15428', 218, 45, 1989, 40.0742, 0.699426735102712, -79.6685, -1.3904776351251),
(6088, '15429', 218, 45, 160737, 40.0032, 0.698187551333796, -79.9361, -1.39514813620344),
(6089, '15430', 218, 45, 160782, 40.0306, 0.698665771548842, -79.6643, -1.39040433129652),
(6090, '15431', 218, 45, 2127, 39.9772, 0.697733765728277, -79.6183, -1.3896014798406),
(6091, '15432', 218, 45, 160955, 40.0797, 0.699522728211571, -79.8668, -1.39393862303181),
(6092, '15433', 218, 45, 78174, 39.984, 0.697852448117413, -79.9654, -1.39565951767427),
(6093, '15434', 218, 45, 27066, 40.0793, 0.699515746894563, -79.8745, -1.39407301338421),
(6094, '15435', 218, 45, 46951, 39.9431, 0.697138608453347, -79.8495, -1.39363668107121),
(6095, '15436', 218, 45, 78228, 39.821, 0.695007561436662, -79.7522, -1.39193847570902),
(6096, '15437', 218, 45, 8849, 39.7934, 0.694525850563112, -79.5658, -1.3886851819833),
(6097, '15438', 218, 45, 161569, 40.1006, 0.699887502025238, -79.8392, -1.39345691215826),
(6098, '15439', 218, 45, 75897, 39.7423, 0.693633987315342, -79.8249, -1.39320733007522),
(6099, '15440', 218, 45, 78337, 39.7367, 0.693536248877231, -79.5665, -1.38869739928807),
(6100, '15442', 218, 45, 127644, 40.0106, 0.698316705698443, -79.8148, -1.39303105182077),
(6101, '15443', 218, 45, 78471, 39.9317, 0.69693964091862, -79.8832, -1.39422485702913),
(6102, '15444', 218, 45, 162705, 40.0105, 0.698314960369191, -79.9061, -1.39462453742784),
(6103, '15445', 218, 45, 78489, 39.8752, 0.695953529891243, -79.7, -1.39102741383948),
(6104, '15446', 218, 45, 48442, 40.0191, 0.698465058684863, -79.3924, -1.38565878106035),
(6105, '15447', 218, 45, 3368, 39.9436, 0.697147335099607, -79.9366, -1.3951568628497),
(6106, '15448', 218, 45, 163087, 40.1329, 0.700451243373632, -79.7419, -1.39175870679607),
(6107, '15449', 218, 45, 78546, 39.9615, 0.697459749035714, -79.7824, -1.39246556514312),
(6108, '15450', 218, 45, 16750, 39.9684, 0.697580176754102, -79.941, -1.39523365733679),
(6109, '15451', 218, 45, 78578, 39.7465, 0.693707291143926, -79.842, -1.39350578137731),
(6110, '15454', 218, 45, 78599, 39.8616, 0.695716165112972, -79.87, -1.39399447356787),
(6111, '15455', 218, 45, 78607, 39.9984, 0.6981037755297, -79.6414, -1.39000465089781),
(6112, '15456', 218, 45, 78610, 39.9227, 0.69678256128594, -79.6676, -1.39046192716183),
(6113, '15458', 218, 45, 78706, 39.8865, 0.696150752096718, -79.8604, -1.39382692195968),
(6114, '15459', 218, 45, 78687, 39.768, 0.694082536933105, -79.4558, -1.38676531980611),
(6115, '15460', 218, 45, 882, 39.8066, 0.694756234024375, -79.9102, -1.39469609592717),
(6116, '15461', 218, 45, 66665, 39.8466, 0.695454365725173, -79.9032, -1.39457392287953),
(6117, '15462', 218, 45, 164462, 40.0634, 0.699238239543496, -79.3581, -1.38506013312691),
(6118, '15463', 218, 45, 37172, 39.9642, 0.697506872925518, -79.8773, -1.39412188260327),
(6119, '15464', 218, 45, 49496, 39.9649, 0.697519090230282, -79.457, -1.38678626375713),
(6120, '15465', 218, 45, 78777, 39.9406, 0.697094975222047, -79.6466, -1.39009540801892),
(6121, '15466', 218, 45, 4567, 40.0738, 0.699419753785704, -79.8881, -1.39431037816248),
(6122, '15467', 218, 45, 78821, 39.7886, 0.694442074759016, -79.9099, -1.39469085993942),
(6123, '15468', 218, 45, 10782, 39.9251, 0.696824449187988, -79.8373, -1.39342375090247),
(6124, '15469', 218, 45, 78848, 40.0287, 0.698632610293054, -79.4065, -1.38590487248488),
(6125, '15470', 218, 45, 78875, 39.8278, 0.695126243825798, -79.4508, -1.38667805334351),
(6126, '15472', 218, 45, 122, 39.9218, 0.696766853322672, -79.7165, -1.39131539316606),
(6127, '15473', 218, 45, 165859, 40.0851, 0.699616975991179, -79.7528, -1.39194894768453),
(6128, '15474', 218, 45, 78968, 39.7348, 0.693503087621443, -79.8997, -1.39451283635571),
(6129, '15475', 218, 45, 5356, 39.9631, 0.697487674303746, -79.8788, -1.39414806254205),
(6130, '15476', 218, 45, 79053, 39.8702, 0.695866263428643, -79.921, -1.39488459148639),
(6131, '15477', 218, 45, 24518, 40.0784, 0.699500038931295, -79.8643, -1.39389498980051),
(6132, '15478', 218, 45, 5916, 39.8079, 0.694778923304651, -79.7988, -1.39275179914045),
(6133, '15479', 218, 45, 12000, 40.1452, 0.700665918871628, -79.7354, -1.39164526039469),
(6134, '15480', 218, 45, 79148, 39.9945, 0.698035707688872, -79.7578, -1.39203621414713),
(6135, '15482', 218, 45, 167571, 40.0629, 0.699229512897236, -79.7618, -1.39210602731721),
(6136, '15483', 218, 45, 6092, 40.0817, 0.699557634796611, -79.851, -1.39366286100999),
(6137, '15484', 218, 45, 79288, 39.8929, 0.696262453168846, -79.7869, -1.39254410495946),
(6138, '15485', 218, 45, 79313, 39.8158, 0.694916804315558, -79.3327, -1.38461681949691),
(6139, '15486', 218, 45, 6518, 40.0338, 0.698721622084906, -79.6607, -1.39034149944345),
(6140, '15488', 218, 45, 28900, 39.9878, 0.697918770628989, -79.7774, -1.39237829868052),
(6141, '15489', 218, 45, 79378, 39.9543, 0.69733408532957, -79.6995, -1.39101868719322),
(6142, '15490', 218, 45, 6768, 40.0637, 0.699243475531252, -79.5048, -1.38762053113959),
(6143, '15492', 218, 45, 168942, 40.1235, 0.700287182423945, -79.7729, -1.39229975886418),
(6144, '15501', 218, 45, 5946, 40.0148, 0.698390009527027, -79.1239, -1.38097257201874),
(6145, '15502', 218, 45, 3090, 40.0103, 0.698311469710687, -79.0782, -1.38017495655058),
(6146, '15510', 218, 45, 5946, 40.0093, 0.698294016418167, -79.0783, -1.38017670187983),
(6147, '15520', 218, 45, 158540, 40.1106, 0.700062034950438, -79.0688, -1.38001089560089),
(6148, '15521', 218, 45, 158665, 40.1938, 0.701514148888097, -78.63, -1.37235239084314),
(6149, '15522', 218, 45, 146, 40.0146, 0.698386518868523, -78.5058, -1.37018469191216),
(6150, '15530', 218, 45, 376, 39.921, 0.696752890688656, -78.9541, -1.37800900294886),
(6151, '15531', 218, 45, 7613, 40.1601, 0.700925972930175, -79.0289, -1.37931450922935),
(6152, '15532', 218, 45, 7637, 39.786, 0.694396696198464, -79.0165, -1.3790980884021),
(6153, '15533', 218, 45, 13424, 39.9885, 0.697930987933753, -78.2446, -1.36562589190596),
(6154, '15534', 218, 45, 77951, 39.9231, 0.696789542602948, -78.7093, -1.37373643693997),
(6155, '15535', 218, 45, 78042, 39.8313, 0.695187330349617, -78.4512, -1.36923174214058),
(6156, '15536', 218, 45, 78103, 39.9308, 0.696923932955352, -78.2135, -1.36508309450858),
(6157, '15537', 218, 45, 20957, 40.0119, 0.698339394978719, -78.3739, -1.36788260262878),
(6158, '15538', 218, 45, 2376, 39.8948, 0.696295614424634, -78.8306, -1.37585352132264),
(6159, '15539', 218, 45, 161635, 40.1215, 0.700252275838905, -78.5856, -1.37157746465526),
(6160, '15540', 218, 45, 78288, 39.8664, 0.695799940917067, -79.247, -1.38312107232795),
(6161, '15541', 218, 45, 102130, 40.0085, 0.698280053784151, -78.8957, -1.37698973066569),
(6162, '15542', 218, 45, 9065, 39.866, 0.695792959600059, -79.0633, -1.37991490249203),
(6163, '15544', 218, 45, 21530, 40.1342, 0.700473932653908, -79.0935, -1.38044199192614),
(6164, '15545', 218, 45, 78498, 39.8114, 0.694840009828471, -78.7283, -1.37406804949785),
(6165, '15546', 218, 45, 163137, 40.1422, 0.700613558994068, -79.0476, -1.37964088579947),
(6166, '15547', 218, 45, 163139, 40.1593, 0.700912010296159, -79.0668, -1.37997598901585),
(6167, '15548', 218, 45, 163226, 40.1016, 0.699904955317758, -78.9374, -1.37771753296377),
(6168, '15549', 218, 45, 113314, 40.0278, 0.698616902329786, -79.0137, -1.37904921918304),
(6169, '15550', 218, 45, 164172, 39.9699, 0.697606356692882, -78.6536, -1.37276428854661),
(6170, '15551', 218, 45, 78686, 39.8699, 0.695861027440887, -79.2938, -1.38393788641788),
(6171, '15552', 218, 45, 78738, 39.8096, 0.694808593901935, -79.0296, -1.37932672653411),
(6172, '15553', 218, 45, 30619, 39.9856, 0.697880373385445, -78.772, -1.37483075838097),
(6173, '15554', 218, 45, 73670, 40.1183, 0.700196425302841, -78.5952, -1.37174501626345),
(6174, '15555', 218, 45, 166257, 40.0892, 0.699688534490511, -79.0797, -1.38020113648936),
(6175, '15557', 218, 45, 5481, 39.9166, 0.696676096201569, -79.1559, -1.38153107737938),
(6176, '15558', 218, 45, 28524, 39.753, 0.693820737545306, -79.0869, -1.3803268001955),
(6177, '15559', 218, 45, 166919, 40.0448, 0.698913608302625, -78.6682, -1.3730191066174),
(6178, '15560', 218, 45, 167050, 40.0175, 0.698437133416831, -78.9069, -1.37718520754191),
(6179, '15561', 218, 45, 167211, 40.0994, 0.699866558074214, -79.0914, -1.38040534001184),
(6180, '15562', 218, 45, 79189, 39.742, 0.693628751327586, -79.0945, -1.38045944521865),
(6181, '15563', 218, 45, 167671, 40.2441, 0.70239204950185, -78.8437, -1.37608215945465),
(6182, '15564', 218, 45, 79356, 39.7323, 0.693459454390143, -78.8505, -1.37620084184379),
(6183, '15565', 218, 45, 79389, 39.7545, 0.693846917484086, -79.0952, -1.38047166252342),
(6184, '15601', 218, 45, 29951, 40.295, 0.703280422091115, -79.5416, -1.38826281230432),
(6185, '15605', 218, 45, 29951, 40.3472, 0.704191483960656, -79.5189, -1.38786662256412),
(6186, '15606', 218, 45, 29951, 40.3011, 0.703386887175487, -79.5389, -1.38821568841452),
(6187, '15610', 218, 45, 726, 40.1248, 0.700309871704221, -79.4637, -1.38690320081702),
(6188, '15611', 218, 45, 79490, 40.3062, 0.703475898967338, -79.6552, -1.39024550633459),
(6189, '15612', 218, 45, 158670, 40.1288, 0.7003796848743, -79.5633, -1.388641548752),
(6190, '15613', 218, 45, 158725, 40.5405, 0.707565205404761, -79.6051, -1.38937109637934),
(6191, '15615', 218, 45, 158745, 40.362, 0.704449792689951, -79.7374, -1.39168016697973),
(6192, '15616', 218, 45, 158762, 40.2427, 0.702367614892322, -79.5539, -1.38847748780232),
(6193, '15617', 218, 45, 112831, 40.2679, 0.702807437863825, -79.6601, -1.39033102746794),
(6194, '15618', 218, 45, 158852, 40.5281, 0.707348784577514, -79.467, -1.38696079668233),
(6195, '15619', 218, 45, 159395, 40.3159, 0.703645195904782, -79.5037, -1.38760133251782),
(6196, '15620', 218, 45, 159427, 40.3009, 0.703383396516983, -79.3068, -1.38416477922064),
(6197, '15621', 218, 45, 1298, 40.2104, 0.701803873543928, -79.4853, -1.38728019193545),
(6198, '15622', 218, 45, 1480, 40.0245, 0.698559306464471, -79.2871, -1.383820949358),
(6199, '15623', 218, 45, 85832, 40.3657, 0.704514369872275, -79.6225, -1.38967478366919),
(6200, '15624', 218, 45, 8275, 40.3643, 0.704489935262747, -79.4694, -1.38700268458438),
(6201, '15625', 218, 45, 130422, 40.2583, 0.702639886255633, -79.6758, -1.3906050441605),
(6202, '15626', 218, 45, 46278, 40.4139, 0.705355618571736, -79.573, -1.38881084568945),
(6203, '15627', 218, 45, 40058, 40.3329, 0.703941901877621, -79.3027, -1.38409322072131),
(6204, '15628', 218, 45, 20625, 40.0984, 0.699849104781694, -79.3824, -1.38548424813515),
(6205, '15629', 218, 45, 161142, 40.5992, 0.708589713675682, -79.5617, -1.38861362348397),
(6206, '15630', 218, 45, 161230, 40.5263, 0.707317368650978, -79.4929, -1.3874128369586),
(6207, '15631', 218, 45, 109132, 40.092, 0.699737403709567, -79.5863, -1.38904297447996),
(6208, '15632', 218, 45, 161455, 40.4186, 0.70543764904658, -79.6275, -1.38976205013178),
(6209, '15633', 218, 45, 161705, 40.357, 0.704362526227352, -79.5228, -1.38793469040495),
(6210, '15634', 218, 45, 149241, 40.3239, 0.703784822244941, -79.6047, -1.38936411506233),
(6211, '15635', 218, 45, 162429, 40.3513, 0.704263042459988, -79.4967, -1.38747915947018),
(6212, '15636', 218, 45, 162470, 40.3549, 0.70432587431306, -79.6164, -1.38956831858481),
(6213, '15637', 218, 45, 162625, 40.2633, 0.702727152718233, -79.7138, -1.39126826927626),
(6214, '15638', 218, 45, 162858, 40.2661, 0.702776021937289, -79.3989, -1.38577222746173),
(6215, '15639', 218, 45, 162913, 40.2026, 0.701667737862272, -79.5871, -1.38905693711398),
(6216, '15640', 218, 45, 9633, 40.2259, 0.702074399577987, -79.7337, -1.3916155897974),
(6217, '15641', 218, 45, 3310, 40.6305, 0.709136001731556, -79.5906, -1.3891180236378),
(6218, '15642', 218, 45, 36581, 40.3301, 0.703893032658565, -79.7177, -1.39133633711708),
(6219, '15644', 218, 45, 60417, 40.3307, 0.703903504634077, -79.6135, -1.38951770403651),
(6220, '15646', 218, 45, 9782, 40.0653, 0.699271400799284, -79.3163, -1.38433058549958),
(6221, '15647', 218, 45, 163589, 40.3432, 0.704121670790576, -79.7255, -1.39147247279874),
(6222, '15650', 218, 45, 110029, 40.3077, 0.703502078906118, -79.3869, -1.38556278795149),
(6223, '15655', 218, 45, 163605, 40.2098, 0.701793401568416, -79.1865, -1.38206514813049),
(6224, '15656', 218, 45, 163685, 40.6308, 0.709141237719312, -79.6026, -1.38932746314804),
(6225, '15658', 218, 45, 123067, 40.2468, 0.702439173391654, -79.2128, -1.38252416972376),
(6226, '15660', 218, 45, 163991, 40.2546, 0.702575309073309, -79.7549, -1.39198559959883),
(6227, '15661', 218, 45, 164031, 40.3205, 0.703725481050374, -79.3589, -1.38507409576093),
(6228, '15662', 218, 45, 164069, 40.3342, 0.703964591157897, -79.4786, -1.38716325487557),
(6229, '15663', 218, 45, 3938, 40.2494, 0.702484551952206, -79.6886, -1.39082844630475),
(6230, '15664', 218, 45, 56059, 40.3236, 0.703779586257185, -79.6709, -1.39051952302715),
(6231, '15665', 218, 45, 22847, 40.3338, 0.703957609840889, -79.6666, -1.39044447386931),
(6232, '15666', 218, 45, 118, 40.1499, 0.700747949346471, -79.5393, -1.38822266973153),
(6233, '15668', 218, 45, 164978, 40.4483, 0.705956011834422, -79.6801, -1.39068009331833),
(6234, '15670', 218, 45, 104605, 40.4135, 0.705348637254728, -79.3812, -1.38546330418412),
(6235, '15671', 218, 45, 165114, 40.3523, 0.704280495752508, -79.3159, -1.38432360418257),
(6236, '15672', 218, 45, 165172, 40.2209, 0.701987133115387, -79.6059, -1.38938505901335),
(6237, '15673', 218, 45, 165281, 40.5929, 0.708479757932806, -79.5585, -1.38855777294791),
(6238, '15674', 218, 45, 165393, 40.2077, 0.701756749654124, -79.4982, -1.38750533940896),
(6239, '15675', 218, 45, 265, 40.3305, 0.703900013975573, -79.6402, -1.38998370694679),
(6240, '15676', 218, 45, 166040, 40.2408, 0.702334453636534, -79.4509, -1.38667979867276),
(6241, '15677', 218, 45, 11485, 40.1772, 0.701224424232266, -79.2276, -1.38278247845306),
(6242, '15678', 218, 45, 166491, 40.2876, 0.703151267726468, -79.7301, -1.39155275794433),
(6243, '15679', 218, 45, 166717, 40.1527, 0.700796818565527, -79.6368, -1.38992436575222),
(6244, '15680', 218, 45, 31053, 40.5227, 0.707254536797906, -79.4945, -1.38744076222663),
(6245, '15681', 218, 45, 166841, 40.4891, 0.706668106169236, -79.4482, -1.38663267478296),
(6246, '15682', 218, 45, 166921, 40.6845, 0.710078479527633, -79.6621, -1.39036593405297),
(6247, '15683', 218, 45, 24714, 40.1031, 0.699931135256538, -79.5901, -1.38910929699154),
(6248, '15684', 218, 45, 167240, 40.4617, 0.70618988595419, -79.5148, -1.38779506406479),
(6249, '15685', 218, 45, 13212, 40.1513, 0.700772383955999, -79.5408, -1.38824884967031),
(6250, '15686', 218, 45, 167466, 40.6222, 0.708991139403641, -79.4454, -1.3865838055639),
(6251, '15687', 218, 45, 167545, 40.1335, 0.700461715349144, -79.298, -1.38401119024646),
(6252, '15688', 218, 45, 167874, 40.1593, 0.700912010296159, -79.5693, -1.38874626850712),
(6253, '15689', 218, 45, 43430, 40.2179, 0.701934773237827, -79.4881, -1.3873290611545),
(6254, '15690', 218, 45, 168322, 40.5988, 0.708582732358674, -79.5702, -1.38876197647039),
(6255, '15691', 218, 45, 111961, 40.2927, 0.703240279518319, -79.6873, -1.39080575702448),
(6256, '15692', 218, 45, 168860, 40.3307, 0.703903504634077, -79.6769, -1.39062424278227),
(6257, '15693', 218, 45, 6800, 40.2527, 0.702542147817521, -79.4091, -1.38595025104543),
(6258, '15695', 218, 45, 169161, 40.1973, 0.701575235411917, -79.6975, -1.39098378060818),
(6259, '15696', 218, 45, 13011, 40.2797, 0.70301338671556, -79.3663, -1.38520325012558),
(6260, '15697', 218, 45, 26306, 40.239, 0.702303037709998, -79.5772, -1.38888414951803),
(6261, '15698', 218, 45, 13015, 40.215, 0.70188415868952, -79.6862, -1.39078655840271),
(6262, '15701', 218, 45, 116129, 40.6206, 0.708963214135609, -79.1584, -1.38157471061068),
(6263, '15705', 218, 45, 116129, 40.6146, 0.708858494380489, -79.155, -1.38151536941611),
(6264, '15710', 218, 45, 158669, 40.6298, 0.709123784426792, -78.8577, -1.37632650554993),
(6265, '15711', 218, 45, 29102, 41.1711, 0.718571251667837, -78.9134, -1.37729865394329),
(6266, '15712', 218, 45, 7137, 40.782, 0.711780175548327, -78.8547, -1.37627414567237),
(6267, '15713', 218, 45, 154140, 40.5643, 0.707980593766736, -79.2622, -1.38338636237425),
(6268, '15714', 218, 45, 165382, 40.6628, 0.70969974307995, -78.7824, -1.37501227262318),
(6269, '15715', 218, 45, 71824, 40.9701, 0.715063139871329, -78.8796, -1.37670873265612),
(6270, '15716', 218, 45, 159261, 40.4685, 0.706308568343325, -79.1992, -1.38228680494549),
(6271, '15717', 218, 45, 19321, 40.4393, 0.705798932201743, -79.2499, -1.38317168687625),
(6272, '15720', 218, 45, 159603, 40.5329, 0.70743256038161, -79.0632, -1.37991315716278),
(6273, '15721', 218, 45, 19652, 40.8134, 0.712328208933454, -78.7906, -1.37515538962184),
(6274, '15722', 218, 45, 159836, 40.5942, 0.708502447213082, -78.7084, -1.3737207289767),
(6275, '15723', 218, 45, 8027, 40.705, 0.710436272024292, -79.1578, -1.38156423863517),
(6276, '15724', 218, 45, 75420, 40.768, 0.711535829453048, -78.8504, -1.37619909651454),
(6277, '15725', 218, 45, 26799, 40.4997, 0.706853111069947, -79.3669, -1.38521372210109),
(6278, '15727', 218, 45, 0, 40.5493, 0.707718794378937, -79.3086, -1.38419619514717),
(6279, '15728', 218, 45, 147897, 40.6709, 0.709841114749362, -79.0121, -1.37902129391501),
(6280, '15729', 218, 45, 160318, 40.6977, 0.710308862988896, -78.9008, -1.37707874245754),
(6281, '15730', 218, 45, 78074, 40.9667, 0.715003798676761, -78.926, -1.37751856542904),
(6282, '15731', 218, 45, 59108, 40.5019, 0.706891508313491, -79.1737, -1.38184174598623),
(6283, '15732', 218, 45, 20345, 40.6845, 0.710078479527633, -79.2173, -1.3826027095401),
(6284, '15733', 218, 45, 148212, 40.9831, 0.715290032674088, -78.9758, -1.37838773939654),
(6285, '15734', 218, 45, 2053, 40.7165, 0.710636984888271, -79.0073, -1.37893751811092),
(6286, '15736', 218, 45, 161261, 40.6934, 0.71023381383106, -79.3418, -1.38477564445884),
(6287, '15737', 218, 45, 145162, 40.6016, 0.70863160157773, -78.747, -1.37439442606797),
(6288, '15738', 218, 45, 161349, 40.6951, 0.710263484428344, -78.7868, -1.37508906711027),
(6289, '15739', 218, 45, 20922, 40.6777, 0.709959797138497, -79.1651, -1.38169164767056),
(6290, '15740', 218, 45, 47316, 40.9646, 0.714967146762469, -79.0338, -1.37940003036269),
(6291, '15741', 218, 45, 54959, 40.8091, 0.712253159775618, -78.8636, -1.3764294799758),
(6292, '15742', 218, 45, 162080, 40.8596, 0.713134551047875, -78.8552, -1.37628287231863),
(6293, '15744', 218, 45, 2950, 40.9213, 0.714211419196356, -79.0947, -1.38046293587716),
(6294, '15745', 218, 45, 162578, 40.6206, 0.708963214135609, -78.9157, -1.37733879651609),
(6295, '15746', 218, 45, 3147, 40.7513, 0.711244359467965, -78.8857, -1.37681519774049),
(6296, '15747', 218, 45, 32789, 40.7504, 0.711228651504697, -79.1465, -1.38136701642969),
(6297, '15748', 218, 45, 162786, 40.5384, 0.707528553490469, -79.1651, -1.38169164767056),
(6298, '15750', 218, 45, 3466, 40.4777, 0.706469138634509, -79.1814, -1.38197613633864),
(6299, '15751', 218, 45, 163198, 40.8885, 0.713638951201701, -78.9624, -1.37815386527677),
(6300, '15752', 218, 45, 3501, 40.5412, 0.707577422709525, -79.2836, -1.38375986283418),
(6301, '15753', 218, 45, 0, 40.8162, 0.71237707815251, -78.6289, -1.37233319222137),
(6302, '15754', 218, 45, 0, 40.5437, 0.707621055940825, -79.157, -1.38155027600115),
(6303, '15756', 218, 45, 17070, 40.5715, 0.708106257472879, -79.3003, -1.38405133281926),
(6304, '15757', 218, 45, 164122, 40.9101, 0.714015942320132, -78.7271, -1.37404710554683),
(6305, '15758', 218, 45, 41980, 40.8737, 0.713380642472406, -79.0456, -1.37960597921443),
(6306, '15759', 218, 45, 164235, 40.7857, 0.711844752730651, -79.03, -1.37933370785112),
(6307, '15760', 218, 45, 164270, 40.6455, 0.709397801119355, -78.8133, -1.37555157936205),
(6308, '15761', 218, 45, 164472, 40.6373, 0.709254684120692, -78.8827, -1.37676283786293),
(6309, '15762', 218, 45, 165252, 40.5914, 0.708453577994026, -78.8136, -1.3755568153498),
(6310, '15763', 218, 45, 10856, 40.9002, 0.713843154724185, -79.1207, -1.38091672148268),
(6311, '15764', 218, 45, 165523, 40.9998, 0.715581502659171, -79.04, -1.37950824077632),
(6312, '15765', 218, 45, 165793, 40.5653, 0.707998047059256, -79.0084, -1.37895671673269),
(6313, '15767', 218, 45, 166236, 40.9456, 0.71463553420459, -78.976, -1.37839123005504),
(6314, '15770', 218, 45, 5403, 40.9952, 0.715501217513579, -79.1504, -1.38143508427052),
(6315, '15771', 218, 45, 166565, 40.8209, 0.712459108627353, -79.0064, -1.37892181014765),
(6316, '15772', 218, 45, 166675, 40.8931, 0.713719236347293, -78.9326, -1.37763375715968),
(6317, '15773', 218, 45, 33852, 40.6088, 0.708757265283873, -78.7367, -1.37421465715502),
(6318, '15774', 218, 45, 167095, 40.6426, 0.709347186571047, -79.2791, -1.38368132301784),
(6319, '15775', 218, 45, 106456, 40.6556, 0.709574079373807, -78.7798, -1.37496689406263),
(6320, '15776', 218, 45, 167460, 41.0209, 0.715949767131342, -79.0865, -1.3803198188785),
(6321, '15777', 218, 45, 167563, 40.6987, 0.710326316281416, -78.9759, -1.37838948472579),
(6322, '15778', 218, 45, 167956, 40.9672, 0.715012525323021, -79.1994, -1.382290295604),
(6323, '15779', 218, 45, 168004, 40.417, 0.705409723778548, -79.223, -1.38270219330747),
(6324, '15780', 218, 45, 28841, 40.9222, 0.714227127159623, -79.0832, -1.38026222301318),
(6325, '15781', 218, 45, 52487, 40.9653, 0.714979364067233, -78.9952, -1.37872633327142),
(6326, '15783', 218, 45, 58217, 40.6027, 0.708650800199502, -79.3544, -1.38499555594459),
(6327, '15784', 218, 45, 26262, 41.0248, 0.71601783497217, -79.1403, -1.38125880601607),
(6328, '15801', 218, 45, 26988, 41.1216, 0.7177073136881, -78.7631, -1.37467542407755),
(6329, '15821', 218, 45, 0, 41.3182, 0.721138630997521, -78.3324, -1.36715829098921),
(6330, '15822', 218, 45, 159461, 41.3206, 0.721180518899569, -78.6874, -1.37335420983379),
(6331, '15823', 218, 45, 147388, 41.2963, 0.720756403891334, -78.7299, -1.37409597476588),
(6332, '15824', 218, 45, 129951, 41.2472, 0.719899447228605, -78.7925, -1.37518855087763),
(6333, '15825', 218, 45, 26617, 41.1599, 0.718375774791614, -79.0806, -1.38021684445263),
(6334, '15827', 218, 45, 159718, 41.293, 0.720698808026018, -78.5047, -1.37016549329039),
(6335, '15828', 218, 45, 72109, 41.3265, 0.721283493325437, -79.1489, -1.38140890433174),
(6336, '15829', 218, 45, 160439, 41.1917, 0.718930789493748, -79.1735, -1.38183825532773),
(6337, '15831', 218, 45, 160624, 41.3536, 0.721756477552727, -78.6068, -1.37194747445668),
(6338, '15832', 218, 45, 2103, 41.3667, 0.721985115684738, -78.1646, -1.36422962850436),
(6339, '15834', 218, 45, 161362, 41.5112, 0.72450711645387, -78.234, -1.36544088700524),
(6340, '15840', 218, 45, 161529, 41.1441, 0.718100012769799, -78.8083, -1.37546431289945),
(6341, '15841', 218, 45, 161706, 41.258, 0.720087942787821, -78.5018, -1.37011487874208),
(6342, '15845', 218, 45, 145512, 41.4934, 0.724196447847015, -78.681, -1.37324250876166),
(6343, '15846', 218, 45, 122953, 41.3534, 0.721752986894223, -78.6145, -1.37208186480908),
(6344, '15847', 218, 45, 163418, 41.1625, 0.718421153352166, -79.0833, -1.38026396834243),
(6345, '15848', 218, 45, 164067, 41.0391, 0.716267417055205, -78.7404, -1.37427923433734),
(6346, '15849', 218, 45, 23832, 41.1629, 0.718428134669174, -78.5602, -1.37113415102525),
(6347, '15851', 218, 45, 24299, 41.095, 0.71724305610707, -78.8872, -1.37684137767927),
(6348, '15853', 218, 45, 28416, 41.4246, 0.722995661321643, -78.7337, -1.37416229727746),
(6349, '15856', 218, 45, 83352, 41.0919, 0.717188950900258, -78.6341, -1.37242394934247),
(6350, '15857', 218, 45, 24606, 41.4312, 0.723110853052275, -78.5495, -1.37094740079529),
(6351, '15860', 218, 45, 28611, 41.3601, 0.721869923954107, -78.9893, -1.37862335884556),
(6352, '15861', 218, 45, 0, 41.383, 0.722269604352813, -78.051, -1.36224693447409),
(6353, '15863', 218, 45, 167703, 41.0129, 0.715810140791182, -78.8379, -1.37598093035804),
(6354, '15864', 218, 45, 6150, 41.0917, 0.717185460241754, -79.1696, -1.3817701874869),
(6355, '15865', 218, 45, 51906, 41.0508, 0.716471620577688, -78.8201, -1.37567026175118),
(6356, '15866', 218, 45, 52208, 41.0251, 0.716023070959926, -78.7855, -1.37506637782999),
(6357, '15868', 218, 45, 168609, 41.2676, 0.720255494396012, -78.4962, -1.37001714030397),
(6358, '15870', 218, 45, 6812, 41.5715, 0.725559549992823, -78.6225, -1.37222149114924),
(6359, '15901', 218, 45, 3440, 40.3253, 0.703809256854469, -78.9122, -1.37727770999227),
(6360, '15902', 218, 45, 3440, 40.3091, 0.703526513515646, -78.8931, -1.37694435210514),
(6361, '15904', 218, 45, 3440, 40.2863, 0.703128578446192, -78.8681, -1.37650801979214),
(6362, '15905', 218, 45, 3440, 40.3076, 0.703500333576866, -78.9408, -1.37777687415834),
(6363, '15906', 218, 45, 3440, 40.3493, 0.704228135874948, -78.9366, -1.37770357032976),
(6364, '15907', 218, 45, 3440, 40.3264, 0.703828455476241, -78.9167, -1.37735624980861),
(6365, '15909', 218, 45, 3440, 40.3587, 0.704392196824636, -78.876, -1.37664590080305),
(6366, '15915', 218, 45, 3440, 40.3078, 0.70350382423537, -78.8597, -1.37636141213497),
(6367, '15920', 218, 45, 39144, 40.4433, 0.705868745371823, -79.0095, -1.37897591535446),
(6368, '15921', 218, 45, 19135, 40.3157, 0.703641705246278, -78.6965, -1.37351303479572),
(6369, '15922', 218, 45, 113201, 40.519, 0.707189959615582, -78.8711, -1.3765603796697),
(6370, '15923', 218, 45, 1034, 40.3948, 0.705022260684605, -79.1524, -1.38146999085556),
(6371, '15924', 218, 45, 159733, 40.1585, 0.700898047662143, -78.7101, -1.37375039957399),
(6372, '15925', 218, 45, 19836, 40.4083, 0.705257880133625, -78.6403, -1.3725321597561),
(6373, '15926', 218, 45, 1465, 40.1014, 0.699901464659254, -78.8107, -1.3755062008015),
(6374, '15927', 218, 45, 160313, 40.5439, 0.707624546599329, -78.7879, -1.37510826573204),
(6375, '15928', 218, 45, 160667, 40.2279, 0.702109306163027, -78.9329, -1.37763899314743),
(6376, '15929', 218, 45, 160802, 40.4663, 0.706270171099781, -79.0024, -1.37885199697757),
(6377, '15930', 218, 45, 160952, 40.2944, 0.703269950115603, -78.7217, -1.37395285776722),
(6378, '15931', 218, 45, 161176, 40.4848, 0.7065930570114, -78.7297, -1.37409248410738),
(6379, '15934', 218, 45, 40808, 40.2797, 0.70301338671556, -78.8025, -1.37536308380283),
(6380, '15935', 218, 45, 162770, 40.2054, 0.701716607081328, -78.9245, -1.37749238549026),
(6381, '15936', 218, 45, 162820, 40.15, 0.700749694675723, -78.9131, -1.37729341795554),
(6382, '15937', 218, 45, 9752, 40.208, 0.70176198564188, -78.9898, -1.37863208549182),
(6383, '15938', 218, 45, 22665, 40.4224, 0.705503971558156, -78.6269, -1.37229828563633),
(6384, '15940', 218, 45, 3869, 40.5077, 0.706992737410107, -78.6409, -1.37254263173161),
(6385, '15942', 218, 45, 56289, 40.3953, 0.705030987330865, -78.8555, -1.37628810830639),
(6386, '15943', 218, 45, 165010, 40.4708, 0.706348710916121, -78.837, -1.37596522239477),
(6387, '15944', 218, 45, 56485, 40.378, 0.70472904537027, -79.0718, -1.38006325547845),
(6388, '15945', 218, 45, 67602, 40.3519, 0.7042735144355, -78.8798, -1.37671222331462),
(6389, '15946', 218, 45, 42669, 40.3831, 0.704818057162122, -78.6797, -1.37321981948138),
(6390, '15948', 218, 45, 166418, 40.4905, 0.706692540778764, -78.7648, -1.37470509467483),
(6391, '15949', 218, 45, 11625, 40.4162, 0.705395761144532, -79.1393, -1.38124135272355),
(6392, '15951', 218, 45, 113341, 40.3388, 0.704044876303489, -78.7797, -1.37496514873338),
(6393, '15952', 218, 45, 42954, 40.2971, 0.703317074005407, -78.7705, -1.37480457844219),
(6394, '15953', 218, 45, 166974, 40.21, 0.70179689222692, -78.8969, -1.37701067461671),
(6395, '15954', 218, 45, 33926, 40.3998, 0.705109527147205, -79.0281, -1.37930054659533),
(6396, '15955', 218, 45, 167184, 40.3304, 0.703898268646321, -78.7348, -1.37418149589923),
(6397, '15956', 218, 45, 38288, 40.3654, 0.704509133884519, -78.7909, -1.3751606256096),
(6398, '15957', 218, 45, 167696, 40.5576, 0.707863656706852, -78.9182, -1.37738242974739),
(6399, '15958', 218, 45, 79233, 40.3756, 0.704687157468223, -78.7608, -1.37463528150475),
(6400, '15959', 218, 45, 167977, 40.269, 0.702826636485597, -78.9157, -1.37733879651609),
(6401, '15960', 218, 45, 168140, 40.4977, 0.706818204484908, -78.8678, -1.37650278380438),
(6402, '15961', 218, 45, 168386, 40.4776, 0.706467393305257, -78.9097, -1.37723407676097),
(6403, '15962', 218, 45, 34438, 40.3882, 0.704907068953974, -78.7184, -1.3738952619019),
(6404, '15963', 218, 45, 169027, 40.223, 0.702023785029679, -78.8109, -1.37550969146),
(6405, '16001', 218, 45, 1257, 40.858, 0.713106625779843, -79.9025, -1.39456170557477),
(6406, '16002', 218, 45, 1257, 40.862, 0.713176438949923, -79.8967, -1.39446047647815),
(6407, '16003', 218, 45, 1257, 40.8576, 0.713099644462835, -79.895, -1.39443080588087),
(6408, '16016', 218, 45, 159417, 41.1081, 0.717471694239081, -79.8992, -1.39450410970945),
(6409, '16017', 218, 45, 159417, 41.0913, 0.717178478924746, -79.9079, -1.39465595335438),
(6410, '16018', 218, 45, 159417, 41.0913, 0.717178478924746, -79.9078, -1.39465420802512),
(6411, '16020', 218, 45, 159417, 41.1131, 0.717558960701681, -79.9036, -1.39458090419654),
(6412, '16021', 218, 45, 15305, 41.0723, 0.716846866366867, -79.9853, -1.39600683819542),
(6413, '16022', 218, 45, 35024, 41.0553, 0.716550160394028, -79.7292, -1.39153704998106),
(6414, '16023', 218, 45, 7814, 40.7747, 0.711652766512932, -79.7618, -1.39210602731721),
(6415, '16024', 218, 45, 159746, 40.74, 0.71104713726249, -80.0362, -1.39689521078469),
(6416, '16025', 218, 45, 58986, 40.9517, 0.714741999288962, -79.7631, -1.39212871659749),
(6417, '16027', 218, 45, 160362, 40.8165, 0.712382314140265, -80.0134, -1.39649727571523),
(6418, '16028', 218, 45, 161021, 41.2222, 0.719463114915607, -79.439, -1.38647210449178),
(6419, '16029', 218, 45, 161027, 40.8804, 0.71349757953229, -79.8476, -1.39360351981542),
(6420, '16030', 218, 45, 80820, 41.1353, 0.717946423795623, -79.7983, -1.39274307249419),
(6421, '16033', 218, 45, 161427, 40.7538, 0.711287992699265, -80.0707, -1.39749734937662),
(6422, '16034', 218, 45, 161582, 40.8595, 0.713132805718623, -79.7371, -1.39167493099197),
(6423, '16035', 218, 45, 35957, 41.1059, 0.717433296995537, -80.0064, -1.39637510266759),
(6424, '16036', 218, 45, 161795, 41.1552, 0.71829374431677, -79.6536, -1.39021758106656),
(6425, '16037', 218, 45, 745, 40.7998, 0.712090844155182, -80.1275, -1.39848869639176),
(6426, '16038', 218, 45, 2996, 41.136, 0.717958641100387, -80.0045, -1.3963419414118),
(6427, '16039', 218, 45, 9438, 40.8373, 0.71274534262468, -79.812, -1.39298218260171),
(6428, '16040', 218, 45, 131316, 41.1054, 0.717424570349277, -79.836, -1.39340106162219),
(6429, '16041', 218, 45, 163229, 41.0087, 0.715736836962599, -79.7075, -1.39115831353338),
(6430, '16045', 218, 45, 164087, 40.852, 0.713001906024723, -79.9158, -1.39479383436528),
(6431, '16046', 218, 45, 96016, 40.6979, 0.7103123536474, -80.0662, -1.39741880956028),
(6432, '16048', 218, 45, 117063, 41.0473, 0.716410534053868, -79.8136, -1.39301010786975),
(6433, '16049', 218, 45, 4872, 41.1064, 0.717442023641797, -79.6937, -1.39091745809661),
(6434, '16050', 218, 45, 28229, 41.0431, 0.716337230225285, -79.7565, -1.39201352486686),
(6435, '16051', 218, 45, 5187, 40.9608, 0.714900824250893, -80.1533, -1.39893899133877),
(6436, '16052', 218, 45, 5238, 40.9084, 0.713986271722848, -80.0753, -1.39757763452222),
(6437, '16053', 218, 45, 83252, 40.8121, 0.712305519653178, -79.9804, -1.39592131706207),
(6438, '16054', 218, 45, 17916, 41.1614, 0.718401954730394, -79.653, -1.39020710909104),
(6439, '16055', 218, 45, 166881, 40.7124, 0.710565426388939, -79.7497, -1.39189484247772),
(6440, '16056', 218, 45, 166897, 40.7249, 0.710783592545439, -79.8388, -1.39344993084125),
(6441, '16057', 218, 45, 167244, 41.0616, 0.716660116136904, -80.0534, -1.39719540741603),
(6442, '16058', 218, 45, 168104, 41.1855, 0.718822579080125, -79.6134, -1.38951595870725),
(6443, '16059', 218, 45, 34233, 40.7048, 0.710432781365788, -79.9195, -1.39485841154761),
(6444, '16061', 218, 45, 168819, 41.0167, 0.715876463302758, -79.8754, -1.39408872134748),
(6445, '16063', 218, 45, 169227, 40.7582, 0.711364787186353, -80.1297, -1.3985270936353),
(6446, '16066', 218, 45, 0, 40.7067, 0.710465942621576, -80.109, -1.39816581048014),
(6447, '16101', 218, 45, 4520, 40.9907, 0.71542267769724, -80.3368, -1.40214167051618),
(6448, '16102', 218, 45, 4520, 40.9742, 0.715134698370661, -80.3745, -1.40279965964418),
(6449, '16103', 218, 45, 4520, 40.9894, 0.715399988416964, -80.2947, -1.40140688690109),
(6450, '16105', 218, 45, 4520, 41.0313, 0.716131281373549, -80.3466, -1.40231271278288),
(6451, '16107', 218, 45, 4520, 40.9891, 0.715394752429208, -80.2949, -1.4014103775596),
(6452, '16108', 218, 45, 4520, 40.9897, 0.71540522440472, -80.2946, -1.40140514157184),
(6453, '16110', 218, 45, 13260, 41.6296, 0.726573586288231, -80.2147, -1.4000106234995),
(6454, '16111', 218, 45, 62617, 41.5343, 0.724910287511081, -80.2776, -1.401108435599),
(6455, '16112', 218, 45, 418, 40.9739, 0.715129462382905, -80.493, -1.4048678748078),
(6456, '16113', 218, 45, 1590, 41.2788, 0.720450971272235, -80.4238, -1.40366010696542),
(6457, '16114', 218, 45, 113374, 41.4343, 0.723164958259086, -80.3301, -1.4020247334563),
(6458, '16115', 218, 45, 1971, 40.7648, 0.711479978916984, -80.4646, -1.40437220130023),
(6459, '16116', 218, 45, 27051, 41.0369, 0.716229019811661, -80.4853, -1.40473348445539),
(6460, '16117', 218, 45, 161324, 40.8615, 0.713167712303663, -80.2771, -1.40109970895274),
(6461, '16120', 218, 45, 161383, 40.8392, 0.712778503880468, -80.4618, -1.40432333208117),
(6462, '16121', 218, 45, 59889, 41.2119, 0.719283346002651, -80.4898, -1.40481202427173),
(6463, '16123', 218, 45, 161701, 40.8149, 0.712354388872234, -80.2008, -1.39976802273347),
(6464, '16124', 218, 45, 2600, 41.3223, 0.721210189496853, -80.2628, -1.4008501268697);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(6465, '16125', 218, 45, 2868, 41.3948, 0.722475553204549, -80.3776, -1.40285376485099),
(6466, '16127', 218, 45, 16293, 41.1645, 0.718456059937206, -80.0872, -1.3977853287032),
(6467, '16130', 218, 45, 27352, 41.4355, 0.72318590221011, -80.2662, -1.40090946806427),
(6468, '16131', 218, 45, 162485, 41.5528, 0.7252331734227, -80.4383, -1.40391317970695),
(6469, '16132', 218, 45, 81577, 41.0077, 0.715719383670079, -80.4967, -1.40493245199012),
(6470, '16133', 218, 45, 155863, 41.2786, 0.720447480613731, -80.087, -1.3977818380447),
(6471, '16134', 218, 45, 3399, 41.5378, 0.724971374034901, -80.4778, -1.40460258476149),
(6472, '16136', 218, 45, 163430, 40.8336, 0.712680765442356, -80.325, -1.40193572166445),
(6473, '16137', 218, 45, 17095, 41.2445, 0.719852323338801, -80.2284, -1.40024973360702),
(6474, '16140', 218, 45, 120755, 41.097, 0.71727796269211, -80.5048, -1.40507382365953),
(6475, '16141', 218, 45, 165124, 40.8352, 0.712708690710388, -80.4011, -1.40326391722521),
(6476, '16142', 218, 45, 165183, 41.1204, 0.717686369737076, -80.335, -1.40211025458964),
(6477, '16143', 218, 45, 11424, 41.0868, 0.717099939108406, -80.4407, -1.403955067609),
(6478, '16145', 218, 45, 166861, 41.3487, 0.721670956419379, -80.0844, -1.39773645948415),
(6479, '16146', 218, 45, 24789, 41.2323, 0.719639393170058, -80.4938, -1.40488183744181),
(6480, '16148', 218, 45, 9439, 41.2334, 0.71965859179183, -80.4617, -1.40432158675192),
(6481, '16150', 218, 45, 38174, 41.2675, 0.72025374906676, -80.455, -1.40420464969204),
(6482, '16151', 218, 45, 167083, 41.4451, 0.723353453818302, -80.2071, -1.39987797847634),
(6483, '16153', 218, 45, 83848, 41.3256, 0.721267785362169, -80.1146, -1.39826354891825),
(6484, '16154', 218, 45, 168026, 41.3297, 0.7213393438615, -80.4443, -1.40401789946207),
(6485, '16155', 218, 45, 168375, 41.0738, 0.716873046305647, -80.507, -1.40511222090308),
(6486, '16156', 218, 45, 168396, 41.0886, 0.717131355034942, -80.2198, -1.40009963529135),
(6487, '16157', 218, 45, 168474, 40.8928, 0.713714000359537, -80.3423, -1.40223766362504),
(6488, '16159', 218, 45, 168766, 41.1841, 0.718798144470597, -80.4517, -1.40414705382672),
(6489, '16160', 218, 45, 168810, 40.9331, 0.714417368048091, -80.3641, -1.40261814540197),
(6490, '16161', 218, 45, 31509, 41.2016, 0.719103577089696, -80.4949, -1.40490103606358),
(6491, '16172', 218, 45, 165183, 41.1223, 0.717719530992864, -80.3327, -1.40207011201685),
(6492, '16201', 218, 45, 163385, 40.819, 0.712425947371565, -79.5269, -1.38800624890428),
(6493, '16210', 218, 45, 18746, 40.903, 0.713892023943241, -79.5084, -1.38768336299266),
(6494, '16211', 218, 45, 159203, 40.7864, 0.711856970035415, -79.2013, -1.38232345685979),
(6495, '16212', 218, 45, 159727, 40.7535, 0.711282756711509, -79.5842, -1.38900632256567),
(6496, '16213', 218, 45, 159748, 41.127, 0.717801561467708, -79.5587, -1.38856126360641),
(6497, '16214', 218, 45, 72110, 41.2102, 0.719253675405367, -79.3819, -1.38547552148889),
(6498, '16215', 218, 45, 163385, 40.8164, 0.712380568811014, -79.5223, -1.38792596375869),
(6499, '16216', 218, 45, 20102, 40.9841, 0.715307485966608, -79.3765, -1.38538127370928),
(6500, '16217', 218, 45, 35365, 41.3355, 0.721440572958116, -79.1904, -1.38213321597132),
(6501, '16218', 218, 45, 160493, 40.9298, 0.714359772182775, -79.5899, -1.38910580633303),
(6502, '16220', 218, 45, 35453, 41.3892, 0.722377814766437, -79.2711, -1.38354169667768),
(6503, '16221', 218, 45, 160600, 41.2193, 0.719412500367299, -79.5063, -1.38764671107837),
(6504, '16222', 218, 45, 1992, 40.8804, 0.71349757953229, -79.2421, -1.3830355511946),
(6505, '16223', 218, 45, 160811, 40.9694, 0.715050922566565, -79.3569, -1.38503918917589),
(6506, '16224', 218, 45, 0, 41.0639, 0.716700258709699, -79.2714, -1.38354693266543),
(6507, '16225', 218, 45, 8891, 41.2653, 0.720215351823216, -79.2495, -1.38316470555925),
(6508, '16226', 218, 45, 2515, 40.766, 0.711500922868008, -79.527, -1.38800799423353),
(6509, '16228', 218, 45, 161708, 40.7594, 0.711385731137377, -79.537, -1.38818252715873),
(6510, '16229', 218, 45, 16142, 40.7173, 0.710650947522287, -79.6574, -1.39028390357813),
(6511, '16230', 218, 45, 3018, 41.0175, 0.715890425936774, -79.2797, -1.38369179499335),
(6512, '16232', 218, 45, 30266, 41.2359, 0.71970222502313, -79.5418, -1.38826630296283),
(6513, '16233', 218, 45, 55846, 41.3605, 0.721876905271115, -79.2952, -1.38396232102741),
(6514, '16234', 218, 45, 10107, 41.1364, 0.717965622417395, -79.2959, -1.38397453833217),
(6515, '16235', 218, 45, 164046, 41.3113, 0.721018203279133, -79.3829, -1.38549297478141),
(6516, '16236', 218, 45, 164379, 40.7818, 0.711776684889823, -79.522, -1.38792072777093),
(6517, '16238', 218, 45, 150524, 40.7866, 0.711860460693919, -79.5216, -1.38791374645392),
(6518, '16239', 218, 45, 164231, 41.471, 0.723805494094568, -79.1265, -1.38101795057929),
(6519, '16240', 218, 45, 17058, 40.9756, 0.715159132980189, -79.253, -1.38322579208307),
(6520, '16242', 218, 45, 165089, 41.0038, 0.715651315829251, -79.3306, -1.38458016758261),
(6521, '16244', 218, 45, 0, 40.8002, 0.71209782547219, -79.272, -1.38355740464095),
(6522, '16245', 218, 45, 4694, 41.0079, 0.715722874328583, -79.2961, -1.38397802899068),
(6523, '16246', 218, 45, 37734, 40.7931, 0.711973907095299, -79.1803, -1.38195693771687),
(6524, '16248', 218, 45, 166493, 41.0397, 0.716277889030717, -79.503, -1.38758911521305),
(6525, '16249', 218, 45, 166731, 40.7995, 0.712085608167427, -79.3231, -1.38444926788871),
(6526, '16250', 218, 45, 24592, 40.7798, 0.711741778304784, -79.2281, -1.38279120509932),
(6527, '16253', 218, 45, 5735, 40.9548, 0.714796104495774, -79.343, -1.38479658840986),
(6528, '16254', 218, 45, 167145, 41.2464, 0.719885484594589, -79.4313, -1.38633771413937),
(6529, '16255', 218, 45, 38252, 41.1087, 0.717482166214593, -79.494, -1.38743203558037),
(6530, '16256', 218, 45, 167260, 40.8269, 0.712563828382473, -79.1644, -1.3816794303658),
(6531, '16257', 218, 45, 51520, 41.3333, 0.721402175714572, -79.3555, -1.38501475456636),
(6532, '16258', 218, 45, 167678, 41.2596, 0.720115868055852, -79.2343, -1.38289941551294),
(6533, '16259', 218, 45, 91273, 40.9486, 0.71468789408215, -79.4539, -1.38673215855032),
(6534, '16260', 218, 45, 168400, 41.3701, 0.722044456879306, -79.2584, -1.38332003986267),
(6535, '16261', 218, 45, 168945, 40.9615, 0.714913041555657, -79.4692, -1.38699919392588),
(6536, '16262', 218, 45, 31567, 40.8388, 0.71277152256346, -79.63, -1.38980568336308),
(6537, '16263', 218, 45, 169192, 40.7994, 0.712083862838174, -79.3336, -1.38463252746017),
(6538, '16301', 218, 45, 37496, 41.4309, 0.723105617064519, -79.7027, -1.39107453772928),
(6539, '16311', 218, 45, 1361, 41.4783, 0.723932903129964, -80.0308, -1.39680096300508),
(6540, '16312', 218, 45, 159969, 41.9344, 0.73189334984831, -79.304, -1.38411591000158),
(6541, '16313', 218, 45, 8087, 41.813, 0.729774520136389, -79.1618, -1.38163405180525),
(6542, '16314', 218, 45, 160232, 41.5179, 0.724624053513754, -80.0483, -1.39710639562418),
(6543, '16316', 218, 45, 160349, 41.6113, 0.726254191035116, -80.3095, -1.40166519563039),
(6544, '16317', 218, 45, 26853, 41.4998, 0.724308148919143, -79.8737, -1.39405905075019),
(6545, '16319', 218, 45, 46070, 41.337, 0.721466752896896, -79.7205, -1.39138520633614),
(6546, '16321', 218, 45, 161066, 41.5528, 0.7252331734227, -79.3916, -1.38564481842633),
(6547, '16322', 218, 45, 161366, 41.5611, 0.725378035750615, -79.3757, -1.38536731107526),
(6548, '16323', 218, 45, 2595, 41.3956, 0.722489515838565, -79.8349, -1.39338186300042),
(6549, '16326', 218, 45, 155377, 41.3686, 0.722018276940526, -79.4142, -1.38603926283728),
(6550, '16327', 218, 45, 162346, 41.6308, 0.726594530239255, -79.956, -1.39549545672459),
(6551, '16328', 218, 45, 162951, 41.6516, 0.72695755872367, -79.7248, -1.39146025549398),
(6552, '16329', 218, 45, 16560, 41.8451, 0.730334770826279, -79.2724, -1.38356438595795),
(6553, '16331', 218, 45, 30269, 41.2899, 0.720644702819207, -79.5892, -1.38909358902827),
(6554, '16332', 218, 45, 163782, 41.3791, 0.722201536511986, -79.3711, -1.38528702592967),
(6555, '16333', 218, 45, 37000, 41.7344, 0.728402691344321, -78.918, -1.37737893908889),
(6556, '16334', 218, 45, 10300, 41.33, 0.721344579849256, -79.4445, -1.38656809760064),
(6557, '16335', 218, 45, 4140, 41.6412, 0.726776044481463, -80.1484, -1.39885347020542),
(6558, '16340', 218, 45, 28268, 41.938, 0.731956181701382, -79.387, -1.38556453328074),
(6559, '16341', 218, 45, 14431, 41.587, 0.725830076026882, -79.5719, -1.38879164706768),
(6560, '16342', 218, 45, 5163, 41.341, 0.721536566066976, -79.9334, -1.39510101231364),
(6561, '16343', 218, 45, 13196, 41.4099, 0.7227390979216, -79.7472, -1.39185120924642),
(6562, '16344', 218, 45, 166697, 41.47, 0.723788040802048, -79.6906, -1.39086335288979),
(6563, '16345', 218, 45, 5580, 41.9299, 0.73181481003197, -79.1267, -1.3810214412378),
(6564, '16346', 218, 45, 18037, 41.3869, 0.722337672193641, -79.7039, -1.39109548168031),
(6565, '16347', 218, 45, 5785, 41.702, 0.727837204666675, -79.0345, -1.37941224766746),
(6566, '16350', 218, 45, 12174, 41.9835, 0.732750306511039, -79.341, -1.38476168182482),
(6567, '16351', 218, 45, 167949, 41.6842, 0.72752653605982, -79.406, -1.38589614583862),
(6568, '16352', 218, 45, 167968, 41.8473, 0.730373168069823, -79.1469, -1.3813739977467),
(6569, '16353', 218, 45, 167969, 41.4947, 0.724219137127291, -79.4569, -1.38678451842788),
(6570, '16354', 218, 45, 18352, 41.6272, 0.726531698386184, -79.6872, -1.39080401169523),
(6571, '16360', 218, 45, 84067, 41.6795, 0.727444505584977, -79.8752, -1.39408523068897),
(6572, '16361', 218, 45, 168147, 41.3851, 0.722306256267105, -79.3227, -1.38444228657171),
(6573, '16362', 218, 45, 31360, 41.4836, 0.72402540558032, -79.9336, -1.39510450297214),
(6574, '16364', 218, 45, 12548, 41.3728, 0.72209158076911, -79.5078, -1.38767289101715),
(6575, '16365', 218, 45, 12663, 41.8536, 0.730483123812699, -79.1587, -1.38157994659844),
(6576, '16366', 218, 45, 12663, 41.8434, 0.730305100228995, -79.1437, -1.38131814721064),
(6577, '16367', 218, 45, 12663, 41.8468, 0.730364441423563, -79.1463, -1.38136352577119),
(6578, '16368', 218, 45, 12663, 41.8474, 0.730374913399075, -79.1467, -1.3813705070882),
(6579, '16369', 218, 45, 12663, 41.847, 0.730367932082067, -79.1465, -1.38136701642969),
(6580, '16370', 218, 45, 168729, 41.5586, 0.725334402519315, -79.5294, -1.38804988213558),
(6581, '16371', 218, 45, 70438, 41.8545, 0.730498831775967, -79.3193, -1.38438294537714),
(6582, '16372', 218, 45, 1631, 41.1993, 0.7190634345169, -79.8731, -1.39404857877468),
(6583, '16373', 218, 45, 161355, 41.1785, 0.718700406032485, -79.7086, -1.39117751215515),
(6584, '16374', 218, 45, 163294, 41.2837, 0.720536492405583, -79.7465, -1.39183899194166),
(6585, '16375', 218, 45, 9962, 41.2222, 0.719463114915607, -79.6344, -1.38988247785017),
(6586, '16388', 218, 45, 4140, 41.6466, 0.72687029226107, -80.1465, -1.39882030894964),
(6587, '16401', 218, 45, 7043, 41.8833, 0.731001486600541, -80.3787, -1.40287296347277),
(6588, '16402', 218, 45, 129716, 41.9692, 0.732500724428004, -79.4776, -1.38714580158305),
(6589, '16403', 218, 45, 159759, 41.8017, 0.729577297930914, -80.0594, -1.39730012717115),
(6590, '16404', 218, 45, 1459, 41.725, 0.728238630394634, -79.8955, -1.39443953252713),
(6591, '16405', 218, 45, 1718, 41.9412, 0.732012032237446, -79.5784, -1.38890509346906),
(6592, '16406', 218, 45, 160356, 41.7615, 0.728875675571612, -80.3696, -1.40271413851083),
(6593, '16407', 218, 45, 54208, 41.925, 0.731729288898623, -79.6573, -1.39028215824888),
(6594, '16410', 218, 45, 108724, 41.9179, 0.731605370521731, -80.3173, -1.40180133131204),
(6595, '16411', 218, 45, 27039, 41.982, 0.732724126572259, -80.435, -1.40385558384164),
(6596, '16412', 218, 45, 161225, 41.8884, 0.731090498392393, -80.144, -1.39877667571834),
(6597, '16413', 218, 45, 2254, 41.9017, 0.731322627182908, -79.7438, -1.39179186805185),
(6598, '16415', 218, 45, 500, 42.0402, 0.73373990819692, -80.2374, -1.4004068132397),
(6599, '16416', 218, 45, 2663, 41.8163, 0.729832116001705, -79.4446, -1.38656984292989),
(6600, '16417', 218, 45, 2718, 41.9869, 0.732809647705607, -80.3122, -1.40171231952019),
(6601, '16420', 218, 45, 131071, 41.7705, 0.729032755204291, -79.5489, -1.38839022133972),
(6602, '16421', 218, 45, 162433, 42.1712, 0.736026289517033, -79.9406, -1.39522667601978),
(6603, '16422', 218, 45, 162449, 41.6611, 0.72712336500261, -80.3179, -1.40181180328755),
(6604, '16423', 218, 45, 9930, 42.0208, 0.733401314322033, -80.3406, -1.40220799302776),
(6605, '16424', 218, 45, 22688, 41.6489, 0.726910434833866, -80.4303, -1.4037735533668),
(6606, '16426', 218, 45, 164387, 41.9929, 0.732914367460727, -80.142, -1.3987417691333),
(6607, '16427', 218, 45, 4216, 41.8731, 0.730823463016838, -79.9682, -1.39570838689333),
(6608, '16428', 218, 45, 49855, 42.2023, 0.736569086914403, -79.8289, -1.3932771432453),
(6609, '16430', 218, 45, 104735, 42.0003, 0.733043521825374, -80.4286, -1.40374388276951),
(6610, '16432', 218, 45, 11557, 41.778, 0.729163654898191, -79.8027, -1.39281986698128),
(6611, '16433', 218, 45, 166779, 41.7192, 0.728137401298018, -80.1442, -1.39878016637684),
(6612, '16434', 218, 45, 167435, 41.8238, 0.729963015695604, -79.6864, -1.39079004906121),
(6613, '16435', 218, 45, 74384, 41.7989, 0.729528428711858, -80.3692, -1.40270715719383),
(6614, '16436', 218, 45, 6001, 41.8451, 0.730334770826279, -79.5625, -1.38862758611799),
(6615, '16438', 218, 45, 12457, 41.9223, 0.731682165008819, -79.8542, -1.39371871154606),
(6616, '16440', 218, 45, 34257, 41.9443, 0.732066137444258, -79.9778, -1.39587593850152),
(6617, '16441', 218, 45, 790, 41.9511, 0.732184819833393, -79.9885, -1.39606268873148),
(6618, '16442', 218, 45, 168573, 42.0271, 0.733511270064909, -79.8262, -1.3932300193555),
(6619, '16443', 218, 45, 107435, 41.9395, 0.731982361640162, -80.472, -1.40450135566488),
(6620, '16444', 218, 45, 161225, 41.8736, 0.730832189663098, -80.1321, -1.39856898153735),
(6621, '16475', 218, 45, 7043, 41.8941, 0.731189982159756, -80.3778, -1.4028572555095),
(6622, '16501', 218, 45, 15943, 42.1235, 0.735193767463831, -80.0844, -1.39773645948415),
(6623, '16502', 218, 45, 15943, 42.1109, 0.73497385597808, -80.101, -1.39802618413998),
(6624, '16503', 218, 45, 15943, 42.1262, 0.735240891353635, -80.063, -1.39736295902422),
(6625, '16504', 218, 45, 15943, 42.1103, 0.734963384002568, -80.0505, -1.39714479286772),
(6626, '16505', 218, 45, 15943, 42.0945, 0.734687621980753, -80.1676, -1.39918857342181),
(6627, '16506', 218, 45, 15943, 42.0719, 0.734293177569802, -80.1512, -1.39890233942448),
(6628, '16507', 218, 45, 15943, 42.1333, 0.735364809730527, -80.0831, -1.39771377020387),
(6629, '16508', 218, 45, 15943, 42.098, 0.734748708504573, -80.0916, -1.39786212319029),
(6630, '16509', 218, 45, 15943, 42.0722, 0.734298413557558, -80.0636, -1.39737343099973),
(6631, '16510', 218, 45, 15943, 42.1248, 0.735216456744107, -79.9974, -1.39621802303491),
(6632, '16511', 218, 45, 15943, 42.1582, 0.735799396714273, -80.0126, -1.39648331308122),
(6633, '16512', 218, 45, 15943, 42.1081, 0.734924986759024, -79.9563, -1.39550069271234),
(6634, '16514', 218, 45, 15943, 42.1078, 0.734919750771268, -79.9573, -1.39551814600486),
(6635, '16515', 218, 45, 15943, 42.1071, 0.734907533466504, -79.9564, -1.39550243804159),
(6636, '16522', 218, 45, 15943, 42.1242, 0.735205984768595, -80.0826, -1.39770504355761),
(6637, '16530', 218, 45, 15943, 42.1301, 0.735308959194463, -80.0824, -1.39770155289911),
(6638, '16531', 218, 45, 15943, 42.157, 0.735778452763249, -80.0132, -1.39649378505673),
(6639, '16532', 218, 45, 15943, 42.1254, 0.735226928719619, -80.0817, -1.39768933559434),
(6640, '16533', 218, 45, 15943, 42.1282, 0.735275797938675, -80.0609, -1.39732630710993),
(6641, '16534', 218, 45, 15943, 42.122, 0.735167587525052, -80.0857, -1.39775914876442),
(6642, '16538', 218, 45, 15943, 42.1272, 0.735258344646155, -80.0843, -1.39773471415489),
(6643, '16541', 218, 45, 15943, 42.1227, 0.735179804829815, -80.0861, -1.39776613008143),
(6644, '16544', 218, 45, 15943, 42.1103, 0.734963384002568, -80.102, -1.3980436374325),
(6645, '16546', 218, 45, 15943, 42.1089, 0.73493894939304, -80.0506, -1.39714653819697),
(6646, '16550', 218, 45, 15943, 42.1356, 0.735404952303323, -80.0887, -1.39781150864198),
(6647, '16553', 218, 45, 15943, 42.1262, 0.735240891353635, -80.0839, -1.39772773283789),
(6648, '16554', 218, 45, 15943, 42.1274, 0.735261835304659, -80.0838, -1.39772598750863),
(6649, '16563', 218, 45, 15943, 42.1257, 0.735232164707375, -79.9844, -1.39599113023215),
(6650, '16565', 218, 45, 15943, 42.0691, 0.734244308350747, -80.1007, -1.39802094815222),
(6651, '16601', 218, 45, 14978, 40.5181, 0.707174251652314, -78.406, -1.36844285331867),
(6652, '16602', 218, 45, 14978, 40.5015, 0.706884526996483, -78.3872, -1.3681147314193),
(6653, '16603', 218, 45, 14978, 40.5153, 0.707125382433259, -78.3772, -1.3679401984941),
(6654, '16611', 218, 45, 34524, 40.5575, 0.7078619113776, -78.0967, -1.36304454994226),
(6655, '16613', 218, 45, 15040, 40.5574, 0.707860166048348, -78.5421, -1.37081824643064),
(6656, '16614', 218, 45, 158886, 40.2627, 0.702716680742721, -78.4217, -1.36871687001124),
(6657, '16616', 218, 45, 177401, 40.7602, 0.711399693771393, -78.5087, -1.37023530646047),
(6658, '16617', 218, 45, 294, 40.601, 0.708621129602218, -78.3362, -1.36722461350078),
(6659, '16619', 218, 45, 159298, 40.688, 0.710139566051453, -78.4402, -1.36903975592286),
(6660, '16620', 218, 45, 159525, 40.8374, 0.712747087953932, -78.3546, -1.36754575408315),
(6661, '16621', 218, 45, 0, 40.2005, 0.70163108594798, -78.1409, -1.36381598547164),
(6662, '16622', 218, 45, 7856, 40.3068, 0.70348637094285, -78.032, -1.36191532191622),
(6663, '16623', 218, 45, 19837, 40.291, 0.703210608921035, -78.0272, -1.36183154611212),
(6664, '16624', 218, 45, 160033, 40.5784, 0.708226685191267, -78.6101, -1.37200507032199),
(6665, '16625', 218, 45, 160137, 40.2905, 0.703201882274775, -78.4526, -1.3692561767501),
(6666, '16627', 218, 45, 154783, 40.7513, 0.711244359467965, -78.5342, -1.37068036541973),
(6667, '16629', 218, 45, 160470, 40.5364, 0.707493646905429, -78.5157, -1.37035747950811),
(6668, '16630', 218, 45, 112625, 40.4638, 0.706226537868482, -78.5863, -1.37158968196002),
(6669, '16631', 218, 45, 477, 40.2759, 0.702947064203984, -78.3386, -1.36726650140283),
(6670, '16633', 218, 45, 35545, 40.1606, 0.700934699576435, -78.2316, -1.3653989991032),
(6671, '16634', 218, 45, 2116, 40.2225, 0.702015058383419, -78.1667, -1.36426628041865),
(6672, '16635', 218, 45, 160942, 40.4247, 0.705544114130952, -78.4334, -1.36892107353372),
(6673, '16636', 218, 45, 115359, 40.6057, 0.708703160077061, -78.5052, -1.37017421993665),
(6674, '16637', 218, 45, 143757, 40.3344, 0.703968081816401, -78.433, -1.36891409221671),
(6675, '16638', 218, 45, 161391, 40.3335, 0.703952373853133, -78.1993, -1.3648352577548),
(6676, '16639', 218, 45, 161525, 40.6622, 0.709689271104438, -78.4875, -1.36986529665905),
(6677, '16640', 218, 45, 161688, 40.7055, 0.710444998670552, -78.47, -1.36955986403995),
(6678, '16641', 218, 45, 161957, 40.481, 0.706526734499825, -78.5511, -1.37097532606332),
(6679, '16644', 218, 45, 2722, 40.6876, 0.710132584734445, -78.4401, -1.3690380105936),
(6680, '16645', 218, 45, 162086, 40.7979, 0.712057682899395, -78.5003, -1.3700886988033),
(6681, '16646', 218, 45, 16375, 40.6651, 0.709739885652746, -78.713, -1.3738010141223),
(6682, '16647', 218, 45, 32744, 40.392, 0.70497339146555, -78.1152, -1.36336743585387),
(6683, '16648', 218, 45, 162764, 40.4378, 0.705772752262963, -78.3899, -1.3681618553091),
(6684, '16650', 218, 45, 3228, 40.1101, 0.700053308304178, -78.3024, -1.36663469221361),
(6685, '16651', 218, 45, 162867, 40.8259, 0.712546375089953, -78.3518, -1.36749688486409),
(6686, '16652', 218, 45, 88028, 40.4957, 0.706783297899868, -78.0144, -1.36160814396786),
(6687, '16654', 218, 45, 88028, 40.4846, 0.706589566352896, -78.0109, -1.36154705744404),
(6688, '16655', 218, 45, 162968, 40.2482, 0.702463608001182, -78.5411, -1.37080079313812),
(6689, '16656', 218, 45, 163032, 40.8297, 0.712612697601529, -78.5663, -1.37124061610962),
(6690, '16657', 218, 45, 0, 40.339, 0.704048366961993, -78.1858, -1.36459963830578),
(6691, '16659', 218, 45, 164041, 40.1776, 0.701231405549274, -78.377, -1.3679367078356),
(6692, '16660', 218, 45, 164357, 40.4527, 0.70603280632151, -78.0816, -1.3627810052252),
(6693, '16661', 218, 45, 164112, 40.8286, 0.712593498979757, -78.441, -1.36905371855687),
(6694, '16662', 218, 45, 27815, 40.3106, 0.703552693454426, -78.3259, -1.36704484458783),
(6695, '16663', 218, 45, 164773, 40.7862, 0.711853479376911, -78.3676, -1.36777264688591),
(6696, '16664', 218, 45, 49772, 40.192, 0.701482732961561, -78.4242, -1.36876050324254),
(6697, '16665', 218, 45, 30664, 40.3923, 0.704978627453306, -78.4378, -1.36899786802081),
(6698, '16666', 218, 45, 165592, 40.8524, 0.713008887341732, -78.2701, -1.36607095086521),
(6699, '16667', 218, 45, 165597, 40.159, 0.700906774308403, -78.5077, -1.37021785316795),
(6700, '16668', 218, 45, 4902, 40.6325, 0.709170908316596, -78.6507, -1.3727136739983),
(6701, '16669', 218, 45, 14402, 40.5717, 0.708109748131383, -78.0473, -1.36218235729177),
(6702, '16670', 218, 45, 166258, 40.259, 0.702652103560397, -78.508, -1.37022308915571),
(6703, '16671', 218, 45, 37858, 40.803, 0.712146694691246, -78.4, -1.36833813356355),
(6704, '16672', 218, 45, 166467, 40.1618, 0.700955643527459, -78.255, -1.36580740614816),
(6705, '16673', 218, 45, 37952, 40.3347, 0.703973317804157, -78.397, -1.36828577368599),
(6706, '16674', 218, 45, 5445, 40.183, 0.701325653328881, -78.1154, -1.36337092651238),
(6707, '16675', 218, 45, 166788, 40.6665, 0.709764320262274, -78.6819, -1.37325821672493),
(6708, '16677', 218, 45, 127, 40.9011, 0.713858862687453, -78.0849, -1.36283860109052),
(6709, '16678', 218, 45, 18004, 40.2143, 0.701871941384756, -78.2481, -1.36568697842977),
(6710, '16679', 218, 45, 0, 40.1569, 0.700870122394111, -78.2023, -1.36488761763236),
(6711, '16680', 218, 45, 0, 40.7613, 0.711418892393165, -78.4008, -1.36835209619757),
(6712, '16681', 218, 45, 0, 40.7991, 0.712078626850419, -78.4254, -1.36878144719356),
(6713, '16682', 218, 45, 111513, 40.271, 0.702861543070636, -78.4587, -1.36936264183447),
(6714, '16683', 218, 45, 167534, 40.6192, 0.708938779526081, -78.1387, -1.36377758822809),
(6715, '16684', 218, 45, 12332, 40.6358, 0.709228504181912, -78.3, -1.36659280431156),
(6716, '16685', 218, 45, 43366, 40.2656, 0.702767295291029, -78.1059, -1.36320512023344),
(6717, '16686', 218, 45, 25631, 40.6719, 0.709858568041882, -78.2485, -1.36569395974678),
(6718, '16689', 218, 45, 107319, 40.077, 0.699475604321767, -78.0533, -1.36228707704689),
(6719, '16691', 218, 45, 168636, 40.0901, 0.699704242453779, -78.1411, -1.36381947613014),
(6720, '16692', 218, 45, 6747, 40.7791, 0.71172956100002, -78.7478, -1.37440838870199),
(6721, '16693', 218, 45, 6831, 40.4619, 0.706193376612694, -78.2026, -1.36489285362012),
(6722, '16694', 218, 45, 44195, 40.1658, 0.701025456697538, -78.1382, -1.36376886158183),
(6723, '16695', 218, 45, 362, 40.2107, 0.701809109531684, -78.3584, -1.36761207659472),
(6724, '16698', 218, 45, 162867, 40.8249, 0.712528921797433, -78.351, -1.36748292223008),
(6725, '16699', 218, 45, 112625, 40.4626, 0.706205593917458, -78.5867, -1.37159666327703),
(6726, '16701', 218, 45, 1076, 41.9536, 0.732228453064693, -78.6458, -1.37262815286496),
(6727, '16720', 218, 45, 7197, 41.6394, 0.726744628554927, -78.0033, -1.36141441242089),
(6728, '16724', 218, 45, 1897, 41.6987, 0.72777960880136, -78.3697, -1.3678092988002),
(6729, '16725', 218, 45, 75595, 41.906, 0.731397676340744, -78.6518, -1.37273287262008),
(6730, '16726', 218, 45, 35483, 41.8142, 0.729795464087413, -78.614, -1.37207313816282),
(6731, '16727', 218, 45, 160749, 41.9813, 0.732711909267495, -78.5526, -1.3710015060021),
(6732, '16728', 218, 45, 0, 41.5766, 0.725648561784674, -78.9093, -1.37722709544396),
(6733, '16729', 218, 45, 160936, 41.9506, 0.732176093187133, -78.5047, -1.37016549329039),
(6734, '16730', 218, 45, 161129, 41.8089, 0.729702961637057, -78.4195, -1.36867847276769),
(6735, '16731', 218, 45, 15910, 41.9489, 0.732146422589849, -78.3817, -1.36801873831044),
(6736, '16732', 218, 45, 9105, 41.857, 0.730542465007266, -78.5739, -1.37137326113277),
(6737, '16733', 218, 45, 162536, 41.7054, 0.727896545861243, -78.5828, -1.3715285954362),
(6738, '16734', 218, 45, 65931, 41.5491, 0.725168596240376, -78.8813, -1.3767384032534),
(6739, '16735', 218, 45, 27590, 41.6638, 0.727170488892414, -78.8087, -1.37547129421646),
(6740, '16738', 218, 45, 163749, 41.8692, 0.73075539517601, -78.6612, -1.37289693356976),
(6741, '16740', 218, 45, 164856, 41.7246, 0.728231649077626, -78.6384, -1.37249899850031),
(6742, '16743', 218, 45, 166145, 41.8188, 0.729875749233005, -78.2834, -1.36630307965573),
(6743, '16744', 218, 45, 166419, 41.8967, 0.731235360720308, -78.5205, -1.37044125531221),
(6744, '16745', 218, 45, 17817, 41.926, 0.731746742191143, -78.4947, -1.36999096036519),
(6745, '16746', 218, 45, 166691, 41.7723, 0.729064171130827, -78.1433, -1.36385787337368),
(6746, '16748', 218, 45, 167137, 41.9628, 0.732389023355877, -78.1942, -1.36474624596295),
(6747, '16749', 218, 45, 68857, 41.8075, 0.729678527027529, -78.45, -1.36921079818955),
(6748, '16750', 218, 45, 168119, 41.8856, 0.731041629173337, -78.3281, -1.36708324183137),
(6749, '16801', 218, 45, 25096, 40.7934, 0.711979143083055, -77.8444, -1.35864108423947),
(6750, '16802', 218, 45, 18408, 40.8695, 0.713307338643823, -77.834, -1.35845956999727),
(6751, '16803', 218, 45, 25096, 40.8037, 0.71215891199601, -77.8969, -1.35955738209677),
(6752, '16804', 218, 45, 25096, 40.7923, 0.711959944461283, -77.8389, -1.35854509113061),
(6753, '16805', 218, 45, 25096, 40.788, 0.711884895303447, -77.8999, -1.35960974197433),
(6754, '16820', 218, 45, 158517, 40.8644, 0.713218326851971, -77.392, -1.35074521470345),
(6755, '16821', 218, 45, 7065, 40.9731, 0.715115499748889, -78.2184, -1.36516861564193),
(6756, '16822', 218, 45, 7360, 41.0953, 0.717248292094826, -77.5242, -1.35305253997459),
(6757, '16823', 218, 45, 253, 40.8987, 0.713816974785405, -77.7706, -1.3573530312515),
(6758, '16825', 218, 45, 159222, 40.9842, 0.71530923129586, -78.3085, -1.36674115729798),
(6759, '16826', 218, 45, 13397, 41.0646, 0.716712476014463, -77.5977, -1.3543353569748),
(6760, '16827', 218, 45, 159348, 40.7809, 0.711760976926556, -77.7914, -1.35771605973592),
(6761, '16828', 218, 45, 159942, 40.8449, 0.712877987647832, -77.6852, -1.3558625200703),
(6762, '16829', 218, 45, 1592, 41.0877, 0.717115647071674, -77.8718, -1.35911930445452),
(6763, '16830', 218, 45, 13564, 41.0214, 0.715958493777602, -78.4422, -1.3690746625079),
(6764, '16832', 218, 45, 39823, 40.8668, 0.713260214754019, -77.7366, -1.35675961930582),
(6765, '16833', 218, 45, 160609, 40.9742, 0.715134698370661, -78.5258, -1.37053375776256),
(6766, '16834', 218, 45, 160904, 41.0242, 0.716007362996658, -78.1087, -1.36325398945249),
(6767, '16835', 218, 45, 21138, 40.9142, 0.714087500819464, -77.9329, -1.36018570062749),
(6768, '16836', 218, 45, 127535, 41.146, 0.718133174025587, -78.2445, -1.3656241465767),
(6769, '16837', 218, 45, 162093, 40.9361, 0.714469727925651, -78.4795, -1.36972567031889),
(6770, '16838', 218, 45, 162172, 40.9991, 0.715569285354407, -78.6048, -1.37191256787164),
(6771, '16839', 218, 45, 162199, 41.0081, 0.715726364987087, -78.1331, -1.36367984978998),
(6772, '16840', 218, 45, 162515, 40.9399, 0.714536050437227, -78.2164, -1.36513370905689),
(6773, '16841', 218, 45, 3251, 41.0152, 0.715850283363978, -77.6581, -1.35538953584301),
(6774, '16843', 218, 45, 60367, 41.0006, 0.715595465293187, -78.4646, -1.36946561626034),
(6775, '16844', 218, 45, 95234, 40.8631, 0.713195637571695, -77.9398, -1.36030612834588),
(6776, '16845', 218, 45, 163232, 41.1374, 0.717983075709915, -78.0159, -1.36163432390664),
(6777, '16847', 218, 45, 163469, 40.9932, 0.71546631092854, -78.1677, -1.36428373371117),
(6778, '16848', 218, 45, 244, 41.016, 0.715864245997994, -77.5316, -1.35318169433924),
(6779, '16849', 218, 45, 163578, 40.9747, 0.715143425016921, -78.1293, -1.36361352727841),
(6780, '16850', 218, 45, 163683, 40.7991, 0.712078626850419, -78.0506, -1.36223995315709),
(6781, '16851', 218, 45, 120333, 40.8109, 0.712284575702154, -77.8149, -1.35812621211014),
(6782, '16852', 218, 45, 156296, 40.9418, 0.714569211693014, -77.4981, -1.35259700903982),
(6783, '16853', 218, 45, 164564, 40.9424, 0.714579683668526, -77.7906, -1.3577020971019),
(6784, '16854', 218, 45, 56271, 40.8923, 0.713705273713277, -77.476, -1.35221129127513),
(6785, '16855', 218, 45, 4237, 40.9994, 0.715574521342163, -78.363, -1.36769236174032),
(6786, '16856', 218, 45, 164674, 40.9128, 0.714063066209936, -77.7778, -1.35747869495765),
(6787, '16858', 218, 45, 164797, 41.0156, 0.715857264680986, -78.2234, -1.36525588210453),
(6788, '16859', 218, 45, 164809, 41.0216, 0.715961984436106, -78.0233, -1.36176347827129),
(6789, '16860', 218, 45, 17218, 40.9672, 0.715012525323021, -78.1838, -1.36456473172074),
(6790, '16861', 218, 45, 165154, 40.8834, 0.71354993940985, -78.4865, -1.36984784336653),
(6791, '16863', 218, 45, 82748, 40.9051, 0.713928675857533, -78.5015, -1.37010964275433),
(6792, '16864', 218, 45, 165579, 41.0858, 0.717082485815886, -77.659, -1.35540524380628),
(6793, '16865', 218, 45, 165828, 40.7259, 0.710801045837959, -77.9453, -1.36040212145474),
(6794, '16866', 218, 45, 165884, 40.8948, 0.713748906944577, -78.2134, -1.36508134917933),
(6795, '16868', 218, 45, 165939, 40.7317, 0.710902274934574, -77.8878, -1.35939855713484),
(6796, '16870', 218, 45, 166138, 40.7999, 0.712092589484434, -78.0282, -1.36184899940464),
(6797, '16871', 218, 45, 166174, 41.2112, 0.719271128697887, -78.0253, -1.36179838485633),
(6798, '16872', 218, 45, 166335, 40.9533, 0.714769924556994, -77.4019, -1.3509180022994),
(6799, '16873', 218, 45, 167077, 41.0695, 0.716797997147811, -78.3579, -1.36760334994846),
(6800, '16874', 218, 45, 167293, 41.0297, 0.716103356105517, -77.9477, -1.36044400935678),
(6801, '16875', 218, 45, 51622, 40.8624, 0.713183420266931, -77.5744, -1.35392869525909),
(6802, '16876', 218, 45, 38729, 40.9615, 0.714913041555657, -78.2929, -1.36646888593467),
(6803, '16877', 218, 45, 168505, 40.7348, 0.710956380141386, -78.0837, -1.3628176571395),
(6804, '16878', 218, 45, 6708, 40.9468, 0.714656478155614, -78.361, -1.36765745515528),
(6805, '16879', 218, 45, 169023, 40.9713, 0.715084083822353, -78.1585, -1.36412316341999),
(6806, '16881', 218, 45, 6917, 41.0202, 0.715937549826578, -78.3257, -1.36704135392932),
(6807, '16882', 218, 45, 6955, 40.9277, 0.714323120268483, -77.3096, -1.34930706339981),
(6808, '16901', 218, 45, 123976, 41.7477, 0.728634820134837, -77.2992, -1.3491255491576),
(6809, '16910', 218, 45, 53143, 41.7048, 0.727886073885731, -76.8306, -1.34094693628276),
(6810, '16911', 218, 45, 58487, 41.6629, 0.727154780929146, -77.1232, -1.34605376967409),
(6811, '16912', 218, 45, 936, 41.6771, 0.727402617682929, -77.0654, -1.34504496936644),
(6812, '16914', 218, 45, 160307, 41.8492, 0.730406329325611, -76.7926, -1.340283711167),
(6813, '16915', 218, 45, 160458, 41.7722, 0.729062425801575, -78.018, -1.36167097582094),
(6814, '16917', 218, 45, 15652, 41.7587, 0.728826806352556, -77.0673, -1.34507813062223),
(6815, '16918', 218, 45, 160490, 41.9333, 0.731874151226538, -77.498, -1.35259526371057),
(6816, '16920', 218, 45, 54597, 41.989, 0.732846299619899, -77.3141, -1.34938560321615),
(6817, '16921', 218, 45, 54893, 41.6785, 0.727427052292457, -77.5227, -1.35302636003581),
(6818, '16922', 218, 45, 161946, 41.7331, 0.728380002064046, -77.6447, -1.35515566172324),
(6819, '16923', 218, 45, 130966, 41.9162, 0.731575699924447, -77.8843, -1.35933747061102),
(6820, '16925', 218, 45, 9113, 41.9524, 0.732207509113669, -76.7812, -1.34008474363227),
(6821, '16926', 218, 45, 162198, 41.6679, 0.727242047391745, -76.7188, -1.33899565817903),
(6822, '16927', 218, 45, 162471, 41.953, 0.732217981089181, -77.7019, -1.35615399005538),
(6823, '16928', 218, 45, 3570, 41.956, 0.732270340966741, -77.4381, -1.35154981148862),
(6824, '16929', 218, 45, 3698, 41.9977, 0.732998143264823, -77.1233, -1.34605551500334),
(6825, '16930', 218, 45, 3751, 41.5675, 0.725489736822743, -77.1304, -1.34617943338023),
(6826, '16932', 218, 45, 164140, 41.7872, 0.729324225189374, -76.9611, -1.34322459095661),
(6827, '16933', 218, 45, 3975, 41.8076, 0.729680272356781, -77.0762, -1.34523346492565),
(6828, '16935', 218, 45, 164511, 41.8925, 0.731162056891724, -77.3084, -1.34928611944878),
(6829, '16936', 218, 45, 33288, 41.9567, 0.732282558271505, -76.9863, -1.34366441392811),
(6830, '16937', 218, 45, 10509, 41.9031, 0.731347061792436, -77.7543, -1.35706854258343),
(6831, '16938', 218, 45, 4333, 41.5333, 0.724892834218561, -77.3144, -1.3493908392039),
(6832, '16939', 218, 45, 164792, 41.6783, 0.727423561633953, -77.0174, -1.34420721132548),
(6833, '16940', 218, 45, 4506, 41.974, 0.7325845002321, -77.2254, -1.34783749616963),
(6834, '16941', 218, 45, 130966, 41.9818, 0.732720635913755, -77.7693, -1.35733034197123),
(6835, '16942', 218, 45, 11010, 41.9855, 0.732785213096079, -77.348, -1.34997726983257),
(6836, '16943', 218, 45, 166769, 41.8444, 0.730322553521515, -77.546, -1.35343302175152),
(6837, '16945', 218, 45, 6205, 41.8051, 0.729636639125481, -76.8571, -1.34140944853453),
(6838, '16946', 218, 45, 25513, 41.9121, 0.731504141425115, -77.1461, -1.3464534500728),
(6839, '16947', 218, 45, 199, 41.7833, 0.729256157348547, -76.7912, -1.34025927655747),
(6840, '16948', 218, 45, 38625, 41.9037, 0.731357533767948, -77.7649, -1.35725354748414),
(6841, '16950', 218, 45, 723, 41.9163, 0.731577445253699, -77.5515, -1.35352901486038),
(6842, '17001', 218, 45, 1314, 40.2399, 0.702318745673266, -76.9207, -1.3425194779388),
(6843, '17002', 218, 45, 29086, 40.6035, 0.708664762833518, -77.7246, -1.35655017979558),
(6844, '17003', 218, 45, 34568, 40.329, 0.703873834036793, -76.5221, -1.33556259554035),
(6845, '17004', 218, 45, 263, 40.6063, 0.708713632052573, -77.7222, -1.35650829189354),
(6846, '17005', 218, 45, 159155, 40.6023, 0.708643818882494, -76.8112, -1.34060834240787),
(6847, '17006', 218, 45, 159274, 40.3083, 0.70351255088163, -77.5138, -1.35287102573238),
(6848, '17007', 218, 45, 1026, 40.1454, 0.700669409530132, -77.1152, -1.34591414333393),
(6849, '17008', 218, 45, 159407, 40.1688, 0.701077816575098, -76.9759, -1.3434828996859),
(6850, '17009', 218, 45, 53752, 40.6356, 0.709225013523408, -77.5691, -1.35383619280873),
(6851, '17010', 218, 45, 29381, 40.2768, 0.702962772167252, -76.5808, -1.33658710381127),
(6852, '17011', 218, 45, 1314, 40.2388, 0.702299547051494, -76.9305, -1.3426905202055),
(6853, '17012', 218, 45, 1314, 40.1831, 0.701327398658134, -76.9919, -1.34376215236622),
(6854, '17013', 218, 45, 1358, 40.2049, 0.701707880435068, -77.1977, -1.34735403996683),
(6855, '17014', 218, 45, 160234, 40.6592, 0.709636911226878, -77.1046, -1.34572913843322),
(6856, '17016', 218, 45, 54205, 40.2749, 0.702929610911464, -76.4097, -1.33360084546111),
(6857, '17017', 218, 45, 160640, 40.6503, 0.709481576923451, -76.8778, -1.3417707316897),
(6858, '17018', 218, 45, 93643, 40.3721, 0.704626070944403, -76.9333, -1.34273938942455),
(6859, '17019', 218, 45, 119378, 40.0982, 0.69984561412319, -77.0235, -1.34431367640985),
(6860, '17020', 218, 45, 160940, 40.3936, 0.705001316733581, -77.0487, -1.34475349938136),
(6861, '17021', 218, 45, 127392, 40.3616, 0.704442811372943, -77.6745, -1.35567576984034),
(6862, '17022', 218, 45, 27070, 40.1504, 0.700756675992731, -76.5996, -1.33691522571065),
(6863, '17023', 218, 45, 161290, 40.5496, 0.707724030366693, -76.8125, -1.34063103168814),
(6864, '17024', 218, 45, 161318, 40.3635, 0.704475972628731, -77.2674, -1.34857053445547),
(6865, '17025', 218, 45, 8769, 40.2893, 0.703180938323751, -76.9588, -1.34318444838381),
(6866, '17026', 218, 45, 29848, 40.4494, 0.705975210456194, -76.4318, -1.3339865632258),
(6867, '17027', 218, 45, 16267, 40.1551, 0.700838706467575, -77.0029, -1.34395413858394),
(6868, '17028', 218, 45, 21522, 40.3722, 0.704627816273655, -76.7025, -1.33871116951095),
(6869, '17029', 218, 45, 55048, 40.5441, 0.707628037257833, -77.6039, -1.35444356738843),
(6870, '17030', 218, 45, 36169, 40.6111, 0.708797407856669, -76.7174, -1.3389712235695),
(6871, '17031', 218, 45, 55071, 40.376, 0.70469413878523, -77.3222, -1.34952697488556),
(6872, '17032', 218, 45, 21675, 40.4787, 0.706486591927029, -76.8653, -1.3415525655332),
(6873, '17033', 218, 45, 162637, 40.2758, 0.702945318874732, -76.6483, -1.33776520105637),
(6874, '17034', 218, 45, 162690, 40.2092, 0.701782929592904, -76.7861, -1.34017026476562),
(6875, '17035', 218, 45, 36486, 40.4333, 0.705694212446623, -77.5866, -1.35414162542783),
(6876, '17036', 218, 45, 162907, 40.2701, 0.702845835107369, -76.7079, -1.33880541729056),
(6877, '17037', 218, 45, 162958, 40.4326, 0.705681995141859, -77.3522, -1.35005057366116),
(6878, '17038', 218, 45, 22301, 40.4134, 0.705346891925476, -76.485, -1.33491507838786),
(6879, '17039', 218, 45, 163392, 40.3006, 0.703378160529227, -76.2493, -1.33080133734091),
(6880, '17040', 218, 45, 110017, 40.3086, 0.703517786869386, -77.3367, -1.3497800476271),
(6881, '17041', 218, 45, 95640, 40.2204, 0.701978406469127, -76.5398, -1.33587151881796),
(6882, '17042', 218, 45, 3708, 40.3349, 0.703976808462661, -76.4245, -1.33385915419041),
(6883, '17043', 218, 45, 156114, 40.2469, 0.702440918720906, -76.9002, -1.34216168544214),
(6884, '17044', 218, 45, 36868, 40.604, 0.708673489479778, -77.5721, -1.35388855268629),
(6885, '17045', 218, 45, 3824, 40.5761, 0.708186542618471, -76.9888, -1.34370804715941),
(6886, '17046', 218, 45, 3708, 40.3603, 0.704420122092667, -76.4334, -1.33401448849383),
(6887, '17047', 218, 45, 164043, 40.3669, 0.704535313823299, -77.4377, -1.35154283017161),
(6888, '17048', 218, 45, 156275, 40.5673, 0.708032953644296, -76.7043, -1.33874258543749),
(6889, '17049', 218, 45, 164337, 40.6533, 0.709533936801011, -77.2811, -1.34880964456299),
(6890, '17050', 218, 45, 27864, 40.2142, 0.701870196055504, -77.0089, -1.34405885833906),
(6891, '17051', 218, 45, 164416, 40.497, 0.706805987180144, -77.7413, -1.35684164978067),
(6892, '17052', 218, 45, 0, 40.3796, 0.704756970638302, -77.9736, -1.36089604963305),
(6893, '17053', 218, 45, 10343, 40.3349, 0.703976808462661, -76.9849, -1.34363997931858),
(6894, '17054', 218, 45, 4039, 40.496, 0.706788533887624, -77.7298, -1.35664093691669),
(6895, '17055', 218, 45, 27864, 40.2203, 0.701976661139875, -76.9998, -1.34390003337713),
(6896, '17056', 218, 45, 37178, 40.5379, 0.707519826844209, -77.3539, -1.35008024425844),
(6897, '17057', 218, 45, 14224, 40.2037, 0.701686936484044, -76.735, -1.33927840151785),
(6898, '17058', 218, 45, 30506, 40.5691, 0.708064369570832, -77.4049, -1.35097036217696),
(6899, '17059', 218, 45, 164555, 40.5709, 0.708095785497368, -77.3873, -1.35066318422861),
(6900, '17060', 218, 45, 429, 40.4465, 0.705924595907886, -77.902, -1.35964639388862),
(6901, '17061', 218, 45, 30514, 40.5417, 0.707586149355785, -76.9547, -1.34311288988448),
(6902, '17062', 218, 45, 37206, 40.5501, 0.707732757012953, -77.1517, -1.34655118851091),
(6903, '17063', 218, 45, 30524, 40.7156, 0.710621276925003, -77.5892, -1.35418700398838),
(6904, '17064', 218, 45, 164844, 40.2477, 0.702454881354922, -76.4702, -1.33465676965857),
(6905, '17065', 218, 45, 164848, 40.1178, 0.700187698656581, -77.1898, -1.34721615895592),
(6906, '17066', 218, 45, 4410, 40.3844, 0.704840746442398, -77.8836, -1.35932525330626),
(6907, '17067', 218, 45, 164992, 40.3798, 0.704760461296806, -76.3176, -1.33199339722002),
(6908, '17068', 218, 45, 56480, 40.4183, 0.705432413058824, -77.1901, -1.34722139494368),
(6909, '17069', 218, 45, 117000, 40.4549, 0.706071203565054, -76.9713, -1.34340261454031),
(6910, '17070', 218, 45, 156707, 40.2286, 0.702121523467791, -76.8753, -1.3417270984584),
(6911, '17071', 218, 45, 165126, 40.2808, 0.703032585337332, -77.5781, -1.35399327244141),
(6912, '17072', 218, 45, 165143, 40.2727, 0.70289121366792, -76.9866, -1.34366964991587),
(6913, '17073', 218, 45, 165208, 40.3447, 0.704147850729356, -76.2203, -1.33029519185783),
(6914, '17074', 218, 45, 10799, 40.4757, 0.706434232049469, -77.1396, -1.34634000367142),
(6915, '17075', 218, 45, 165223, 40.3912, 0.704959428831534, -77.8371, -1.35851367520408),
(6916, '17076', 218, 45, 49999, 40.6104, 0.708785190551905, -77.3187, -1.34946588836174),
(6917, '17077', 218, 45, 37534, 40.4023, 0.705153160378505, -76.5354, -1.33579472433087),
(6918, '17078', 218, 45, 4846, 40.2998, 0.703364197895211, -76.5879, -1.33671102218817),
(6919, '17080', 218, 45, 165916, 40.6408, 0.709315770644511, -76.8022, -1.34045126277519),
(6920, '17081', 218, 45, 11247, 40.2036, 0.701685191154792, -77.2904, -1.34897196018343),
(6921, '17082', 218, 45, 5184, 40.5348, 0.707465721637397, -77.3894, -1.3506998361429),
(6922, '17083', 218, 45, 61458, 40.2801, 0.703020368032568, -76.4386, -1.33410524561494),
(6923, '17084', 218, 45, 33736, 40.678, 0.709965033126253, -77.6048, -1.3544592753517),
(6924, '17085', 218, 45, 166422, 40.2769, 0.702964517496504, -76.384, -1.33315229584335),
(6925, '17086', 218, 45, 24305, 40.6982, 0.710317589635156, -77.1245, -1.34607645895437),
(6926, '17087', 218, 45, 5374, 40.3612, 0.704435830055935, -76.2626, -1.33103346613143),
(6927, '17088', 218, 45, 166917, 40.2973, 0.703320564663911, -76.2953, -1.33160418879683),
(6928, '17089', 218, 45, 1314, 40.2541, 0.702566582427049, -76.9251, -1.34259627242589),
(6929, '17090', 218, 45, 167114, 40.34, 0.704065820254513, -77.1769, -1.34699101148241),
(6930, '17091', 218, 45, 1314, 40.2402, 0.702323981661022, -76.92, -1.34250726063404),
(6931, '17093', 218, 45, 6147, 40.2953, 0.703285658078871, -76.9291, -1.34266608559597),
(6932, '17094', 218, 45, 52074, 40.5657, 0.708005028376264, -77.2388, -1.3480713702894),
(6933, '17097', 218, 45, 168943, 40.5735, 0.708141164057919, -76.6889, -1.33847380473268),
(6934, '17098', 218, 45, 6834, 40.5796, 0.708247629142291, -76.629, -1.33742835251073),
(6935, '17099', 218, 45, 169196, 40.6417, 0.709331478607779, -77.579, -1.35400898040468),
(6936, '17101', 218, 45, 2994, 40.2627, 0.702716680742721, -76.8822, -1.34184752617678),
(6937, '17102', 218, 45, 2994, 40.2714, 0.702868524387644, -76.8878, -1.3419452646149),
(6938, '17103', 218, 45, 2994, 40.2737, 0.70290866696044, -76.8627, -1.34150718697265),
(6939, '17104', 218, 45, 2994, 40.2592, 0.702655594218901, -76.8587, -1.34143737380257),
(6940, '17105', 218, 45, 2994, 40.299, 0.703350235261195, -76.8013, -1.34043555481192),
(6941, '17106', 218, 45, 2994, 40.2318, 0.702177374003855, -76.8195, -1.34075320473578),
(6942, '17107', 218, 45, 2994, 40.2959, 0.703296130054383, -76.8766, -1.34174978773867),
(6943, '17108', 218, 45, 2994, 40.2817, 0.7030482933006, -76.849, -1.34126807686512),
(6944, '17109', 218, 45, 2994, 40.2905, 0.703201882274775, -76.8259, -1.34086490580791),
(6945, '17110', 218, 45, 2994, 40.3059, 0.703470662979583, -76.8763, -1.34174455175092),
(6946, '17111', 218, 45, 2994, 40.2662, 0.702777767266541, -76.7946, -1.34031861775204),
(6947, '17112', 218, 45, 2994, 40.3373, 0.704018696364709, -76.786, -1.34016851943637),
(6948, '17113', 218, 45, 2994, 40.234, 0.702215771247399, -76.8274, -1.34089108574669),
(6949, '17120', 218, 45, 2994, 40.2658, 0.702770785949533, -76.8821, -1.34184578084753),
(6950, '17121', 218, 45, 2994, 40.3136, 0.703605053331986, -76.8745, -1.34171313582438),
(6951, '17122', 218, 45, 2994, 40.2649, 0.702755077986265, -76.8811, -1.34182832755501),
(6952, '17123', 218, 45, 2994, 40.2643, 0.702744606010753, -76.8806, -1.34181960090875),
(6953, '17124', 218, 45, 2994, 40.265, 0.702756823315517, -76.8811, -1.34182832755501),
(6954, '17125', 218, 45, 2994, 40.2646, 0.702749841998509, -76.8805, -1.3418178555795),
(6955, '17126', 218, 45, 2994, 40.2641, 0.702741115352249, -76.8809, -1.34182483689651),
(6956, '17127', 218, 45, 2994, 40.2648, 0.702753332657013, -76.8801, -1.34181087426249),
(6957, '17128', 218, 45, 2994, 40.2644, 0.702746351340005, -76.8811, -1.34182832755501),
(6958, '17129', 218, 45, 2994, 40.2649, 0.702755077986265, -76.8805, -1.3418178555795),
(6959, '17130', 218, 45, 2994, 40.273, 0.702896449655676, -76.8892, -1.34196969922442),
(6960, '17140', 218, 45, 2994, 40.2602, 0.702673047511421, -76.8114, -1.34061183306637),
(6961, '17177', 218, 45, 2994, 40.2915, 0.703219335567295, -76.8126, -1.3406327770174),
(6962, '17201', 218, 45, 26754, 39.9289, 0.696890771699564, -77.6597, -1.35541746111104),
(6963, '17210', 218, 45, 158672, 40.1945, 0.701526366192861, -77.6539, -1.35531623201442),
(6964, '17211', 218, 45, 77801, 39.7654, 0.694037158372553, -78.4049, -1.3684236546969),
(6965, '17212', 218, 45, 77866, 39.8772, 0.695988436476283, -78.0272, -1.36183154611212),
(6966, '17213', 218, 45, 34851, 40.2561, 0.702601489012089, -77.7751, -1.35743157106784),
(6967, '17214', 218, 45, 77888, 39.7288, 0.693398367866323, -77.4697, -1.35210133553225),
(6968, '17215', 218, 45, 159683, 40.0641, 0.69925045684826, -77.9046, -1.35969177244917),
(6969, '17217', 218, 45, 698, 40.2544, 0.702571818414805, -77.7004, -1.3561278101166),
(6970, '17219', 218, 45, 160882, 40.2193, 0.701959207847355, -77.6975, -1.35607719556829),
(6971, '17220', 218, 45, 46686, 40.1797, 0.701268057463566, -77.748, -1.35695858684055),
(6972, '17221', 218, 45, 161539, 40.0682, 0.699322015347592, -77.8214, -1.35823965851152),
(6973, '17222', 218, 45, 2428, 39.8968, 0.696330521009674, -77.5322, -1.35319216631475),
(6974, '17223', 218, 45, 161748, 40.0604, 0.699185879665936, -77.9704, -1.36084019909699),
(6975, '17224', 218, 45, 78289, 39.9563, 0.69736899191461, -77.8994, -1.35960101532807),
(6976, '17225', 218, 45, 29941, 39.788, 0.694431602783504, -77.7508, -1.35700745605961),
(6977, '17228', 218, 45, 21759, 39.9763, 0.697718057765009, -78.0843, -1.36282812911501),
(6978, '17229', 218, 45, 162942, 40.119, 0.700208642607605, -77.9912, -1.3612032275814),
(6979, '17231', 218, 45, 78609, 39.8589, 0.695669041223168, -77.8583, -1.3588836850055),
(6980, '17232', 218, 45, 164065, 40.095, 0.699789763587126, -77.6324, -1.35494098622525),
(6981, '17233', 218, 45, 78707, 39.9324, 0.696951858223384, -77.9946, -1.36126256877597),
(6982, '17235', 218, 45, 630, 39.8584, 0.695660314576908, -77.6984, -1.35609290353156),
(6983, '17236', 218, 45, 78730, 39.8075, 0.694771941987643, -77.9122, -1.35982441747233),
(6984, '17237', 218, 45, 78761, 39.8415, 0.695365353933321, -77.5583, -1.35364769724952),
(6985, '17238', 218, 45, 4496, 39.8813, 0.696059994975615, -78.1408, -1.36381424014238),
(6986, '17239', 218, 45, 165046, 40.1322, 0.700439026068868, -77.8558, -1.3588400517742),
(6987, '17240', 218, 45, 4565, 40.1163, 0.700161518717801, -77.6029, -1.35442611409591),
(6988, '17241', 218, 45, 4573, 40.1692, 0.701084797892106, -77.3832, -1.35059162572928),
(6989, '17243', 218, 45, 165555, 40.2434, 0.702379832197086, -77.892, -1.35947186096342),
(6990, '17244', 218, 45, 165574, 40.0759, 0.699456405699995, -77.6523, -1.35528830674639),
(6991, '17246', 218, 45, 166021, 40.058, 0.699143991763889, -77.6749, -1.35568275115734),
(6992, '17247', 218, 45, 17745, 39.8009, 0.694656750257011, -77.5752, -1.35394265789311),
(6993, '17249', 218, 45, 0, 40.2425, 0.702364124233818, -77.9006, -1.35962195927909),
(6994, '17250', 218, 45, 79061, 39.7354, 0.693513559596955, -77.5238, -1.35304555865758),
(6995, '17251', 218, 45, 33833, 40.1086, 0.700027128365398, -77.6575, -1.3553790638675),
(6996, '17252', 218, 45, 11761, 39.9119, 0.696594065726725, -77.805, -1.35795342451419),
(6997, '17253', 218, 45, 11788, 40.2119, 0.701830053482708, -78.0078, -1.36149295223723),
(6998, '17254', 218, 45, 5690, 39.9681, 0.697574940766346, -77.5838, -1.35409275620878),
(6999, '17255', 218, 45, 167023, 40.1797, 0.701268057463566, -77.866, -1.3590180753579),
(7000, '17256', 218, 45, 5759, 39.778, 0.694257069858304, -77.6704, -1.355604211341),
(7001, '17257', 218, 45, 167152, 40.0418, 0.698861248425065, -77.5534, -1.35356217611617),
(7002, '17260', 218, 45, 167156, 40.3221, 0.703753406318406, -77.8474, -1.35869344411703),
(7003, '17261', 218, 45, 79162, 39.8371, 0.695288559446233, -77.477, -1.35222874456765),
(7004, '17262', 218, 45, 111505, 40.1507, 0.700761911980487, -77.743, -1.35687132037795),
(7005, '17263', 218, 45, 6059, 39.7246, 0.69332506403774, -77.7196, -1.35646291333298),
(7006, '17264', 218, 45, 38534, 40.165, 0.701011494063522, -77.984, -1.36107756387526),
(7007, '17265', 218, 45, 0, 40.0534, 0.699063706618297, -77.7729, -1.3573931738243),
(7008, '17266', 218, 45, 111905, 40.1061, 0.699983495134098, -77.5261, -1.35308570123038),
(7009, '17267', 218, 45, 79334, 39.7736, 0.694180275371217, -78.2011, -1.36486667368134),
(7010, '17268', 218, 45, 25858, 39.7638, 0.694009233104521, -77.5721, -1.35388855268629),
(7011, '17270', 218, 45, 12870, 39.8527, 0.695560830809544, -77.7997, -1.35786092206383),
(7012, '17271', 218, 45, 28994, 40.1096, 0.700044581657918, -77.7951, -1.35778063691824),
(7013, '17272', 218, 45, 79478, 39.7691, 0.694101735554877, -77.6269, -1.35484499311639),
(7014, '17301', 218, 45, 77757, 39.8877, 0.696171696047742, -76.9938, -1.34379531362201),
(7015, '17302', 218, 45, 77770, 39.7657, 0.694042394360309, -76.3738, -1.33297427225965),
(7016, '17303', 218, 45, 77795, 39.9228, 0.696784306615192, -77.2991, -1.34912380382835),
(7017, '17304', 218, 45, 77803, 39.9764, 0.697719803094261, -77.2347, -1.34799981179006),
(7018, '17306', 218, 45, 77847, 39.9838, 0.697848957458909, -77.2507, -1.34827906447038),
(7019, '17307', 218, 45, 77868, 39.9324, 0.696951858223384, -77.2935, -1.34902606539024),
(7020, '17309', 218, 45, 77921, 39.8709, 0.695878480733407, -76.4498, -1.33430072249116),
(7021, '17310', 218, 45, 77980, 39.8882, 0.696180422694002, -77.3582, -1.35015529341628),
(7022, '17311', 218, 45, 0, 39.8219, 0.69502326939993, -76.8451, -1.34120000902429),
(7023, '17312', 218, 45, 78087, 39.9472, 0.697210166952679, -76.5107, -1.33536362800563),
(7024, '17313', 218, 45, 78109, 39.9023, 0.696426514118533, -76.647, -1.33774251177609),
(7025, '17314', 218, 45, 2022, 39.7303, 0.693424547805103, -76.3291, -1.332194110084),
(7026, '17315', 218, 45, 8583, 40.0089, 0.698287035101159, -76.8589, -1.34144086446107),
(7027, '17316', 218, 45, 70767, 39.9601, 0.697435314426186, -77.0211, -1.3442717885078),
(7028, '17317', 218, 45, 78176, 39.971, 0.697625555314653, -76.5199, -1.33552419829681),
(7029, '17318', 218, 45, 161357, 40.0175, 0.698437133416831, -76.7305, -1.33919986170151),
(7030, '17319', 218, 45, 0, 40.1549, 0.700835215809071, -76.7961, -1.34034479769082),
(7031, '17320', 218, 45, 2367, 39.7563, 0.693878333410622, -77.3764, -1.35047294334014),
(7032, '17321', 218, 45, 78248, 39.758, 0.693908004007906, -76.4393, -1.3341174629197),
(7033, '17322', 218, 45, 8869, 39.8567, 0.695630643979624, -76.5685, -1.33637242831328);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(7034, '17323', 218, 45, 16137, 40.0747, 0.699435461748972, -77.0281, -1.34439396155544),
(7035, '17324', 218, 45, 161970, 40.0116, 0.698334158990963, -77.1943, -1.34729469877226),
(7036, '17325', 218, 45, 72658, 39.8505, 0.695522433566, -77.2592, -1.3484274174568),
(7037, '17326', 218, 45, 72658, 39.8298, 0.695161150410837, -77.235, -1.34800504777782),
(7038, '17327', 218, 45, 78351, 39.7982, 0.694609626367207, -76.7254, -1.33911084990966),
(7039, '17329', 218, 45, 2748, 39.7475, 0.693724744436446, -76.895, -1.34207092832104),
(7040, '17331', 218, 45, 2963, 39.7879, 0.694429857454252, -76.9674, -1.34333454669948),
(7041, '17332', 218, 45, 2963, 39.7995, 0.694632315647483, -76.9869, -1.34367488590362),
(7042, '17333', 218, 45, 2963, 39.8238, 0.695056430655718, -76.992, -1.34376389769547),
(7043, '17334', 218, 45, 2963, 39.8044, 0.694717836780831, -76.9726, -1.34342530382059),
(7044, '17337', 218, 45, 88058, 40.0147, 0.698388264197775, -77.203, -1.34744654241718),
(7045, '17339', 218, 45, 163754, 40.1347, 0.700482659300168, -76.8781, -1.34177596767745),
(7046, '17340', 218, 45, 78631, 39.7539, 0.693836445508574, -77.1066, -1.34576404501826),
(7047, '17342', 218, 45, 22725, 39.8538, 0.695580029431316, -76.7082, -1.33881065327831),
(7048, '17343', 218, 45, 78713, 39.8648, 0.695772015649036, -77.3338, -1.34972943307879),
(7049, '17344', 218, 45, 78715, 39.8053, 0.694733544744099, -77.0201, -1.34425433521528),
(7050, '17345', 218, 45, 585, 40.0728, 0.699402300493184, -76.7277, -1.33915099248245),
(7051, '17347', 218, 45, 164917, 40.0556, 0.699102103861841, -76.693, -1.33854536323201),
(7052, '17349', 218, 45, 71160, 39.7408, 0.693607807376562, -76.6831, -1.33837257563606),
(7053, '17350', 218, 45, 78825, 39.8813, 0.696059994975615, -77.0677, -1.34508511193923),
(7054, '17352', 218, 45, 78827, 39.765, 0.694030177055545, -76.5017, -1.33520654837295),
(7055, '17353', 218, 45, 78886, 39.8827, 0.696084429585142, -77.3858, -1.35063700428983),
(7056, '17354', 218, 45, 78978, 39.8512, 0.695534650870764, -76.8805, -1.3418178555795),
(7057, '17355', 218, 45, 78997, 39.7596, 0.693935929275937, -76.6974, -1.3386221577191),
(7058, '17356', 218, 45, 363, 39.904, 0.696456184715817, -76.6084, -1.33706881468482),
(7059, '17358', 218, 45, 24541, 40.073, 0.699405791151688, -76.9276, -1.34263990565719),
(7060, '17360', 218, 45, 79108, 39.8577, 0.695648097272144, -76.7691, -1.33987355879278),
(7061, '17361', 218, 45, 38203, 39.7632, 0.693998761129009, -76.6777, -1.33827832785646),
(7062, '17362', 218, 45, 31191, 39.8742, 0.695936076598723, -76.8646, -1.34154034822843),
(7063, '17363', 218, 45, 79204, 39.759, 0.693925457300426, -76.6026, -1.33696758558821),
(7064, '17364', 218, 45, 6316, 39.9274, 0.696864591760784, -76.884, -1.34187894210332),
(7065, '17365', 218, 45, 34380, 40.0568, 0.699123047812865, -76.9358, -1.34278302265585),
(7066, '17366', 218, 45, 18652, 39.9223, 0.696775579968932, -76.576, -1.33650332800718),
(7067, '17368', 218, 45, 12969, 40.0182, 0.698449350721595, -76.5305, -1.33570920319752),
(7068, '17370', 218, 45, 169208, 40.1189, 0.700206897278353, -76.7786, -1.34003936507172),
(7069, '17371', 218, 45, 0, 39.9034, 0.696445712740305, -76.7891, -1.34022262464318),
(7070, '17372', 218, 45, 169210, 40.0063, 0.698241656540608, -77.1099, -1.34582164088358),
(7071, '17375', 218, 45, 165762, 39.9726, 0.697653480582685, -77.2324, -1.34795966921727),
(7072, '17401', 218, 45, 6986, 39.9623, 0.69747371166973, -76.7274, -1.3391457564947),
(7073, '17402', 218, 45, 6986, 39.9777, 0.697742492374537, -76.6834, -1.33837781162382),
(7074, '17403', 218, 45, 6986, 39.9505, 0.697267762817995, -76.7105, -1.33885079585111),
(7075, '17404', 218, 45, 6986, 39.9683, 0.69757843142485, -76.775, -1.33997653321865),
(7076, '17405', 218, 45, 6986, 39.9713, 0.697630791302409, -76.6789, -1.33829927180748),
(7077, '17406', 218, 45, 6986, 40.0032, 0.698187551333796, -76.6039, -1.33699027486848),
(7078, '17407', 218, 45, 6986, 39.8841, 0.69610886419467, -76.7109, -1.33885777716812),
(7079, '17415', 218, 45, 6986, 39.9649, 0.697519090230282, -76.7323, -1.33923127762804),
(7080, '17501', 218, 45, 215, 40.1558, 0.700850923772339, -76.2045, -1.33001942983602),
(7081, '17502', 218, 45, 19017, 40.121, 0.700243549192645, -76.6511, -1.33781407027543),
(7082, '17503', 218, 45, 0, 39.9364, 0.697021671393463, -76.0851, -1.32793550670914),
(7083, '17504', 218, 45, 158963, 40.0233, 0.698538362513446, -76.3285, -1.33218363810849),
(7084, '17505', 218, 45, 159240, 40.0511, 0.699023564045501, -76.1805, -1.32960055081554),
(7085, '17506', 218, 45, 7548, 40.1169, 0.700171990693313, -76.0537, -1.32738747332401),
(7086, '17507', 218, 45, 53606, 40.1943, 0.701522875534357, -76.0151, -1.32671377623274),
(7087, '17508', 218, 45, 1190, 40.1263, 0.700336051643001, -76.2119, -1.33014858420067),
(7088, '17509', 218, 45, 1572, 39.9202, 0.69673892805464, -76.0288, -1.32695288634026),
(7089, '17512', 218, 45, 1716, 40.0383, 0.698800161901246, -76.4828, -1.33487668114432),
(7090, '17516', 218, 45, 78067, 39.9403, 0.697089739234291, -76.3422, -1.33242274821602),
(7091, '17517', 218, 45, 2033, 40.2424, 0.702362378904566, -76.1359, -1.32882213396915),
(7092, '17518', 218, 45, 78144, 39.8213, 0.695012797424418, -76.243, -1.33069138159804),
(7093, '17519', 218, 45, 161042, 40.1276, 0.700358740923277, -76.0239, -1.32686736520692),
(7094, '17520', 218, 45, 161105, 40.1005, 0.699885756695986, -76.3505, -1.33256761054393),
(7095, '17521', 218, 45, 54610, 40.2029, 0.701672973850028, -76.3484, -1.33253095862964),
(7096, '17522', 218, 45, 161392, 40.1809, 0.70128900141459, -76.1834, -1.32965116536385),
(7097, '17527', 218, 45, 78316, 40.0047, 0.698213731272576, -76.0032, -1.32650608205175),
(7098, '17528', 218, 45, 55006, 40.1253, 0.700318598350481, -76.0078, -1.32658636719735),
(7099, '17529', 218, 45, 659, 40.0376, 0.698787944596482, -76.1056, -1.3282932992058),
(7100, '17532', 218, 45, 78480, 39.863, 0.6957405997225, -76.2918, -1.33154310227301),
(7101, '17533', 218, 45, 162827, 40.235, 0.702233224539918, -76.2671, -1.33111200594777),
(7102, '17534', 218, 45, 3355, 40.0535, 0.699065451947549, -76.1243, -1.32861967577592),
(7103, '17535', 218, 45, 78563, 40.0067, 0.698248637857615, -76.0457, -1.32724784698385),
(7104, '17536', 218, 45, 14059, 39.8496, 0.695506725602732, -76.0854, -1.32794074269689),
(7105, '17537', 218, 45, 78581, 39.9896, 0.697950186555524, -76.2431, -1.33069312692729),
(7106, '17538', 218, 45, 71011, 40.0896, 0.699695515807519, -76.4139, -1.33367414928969),
(7107, '17540', 218, 45, 10041, 40.0965, 0.699815943525906, -76.189, -1.32974890380196),
(7108, '17543', 218, 45, 163852, 40.1649, 0.70100974873427, -76.2937, -1.3315762635288),
(7109, '17545', 218, 45, 95977, 40.1696, 0.701091779209114, -76.4128, -1.33365495066792),
(7110, '17547', 218, 45, 3993, 40.0614, 0.699203332958456, -76.5588, -1.33620313137583),
(7111, '17549', 218, 45, 10335, 40.1549, 0.700835215809071, -76.0883, -1.3279913572452),
(7112, '17550', 218, 45, 4064, 40.0721, 0.69939008318842, -76.5811, -1.33659233979903),
(7113, '17551', 218, 45, 27906, 39.999, 0.698114247505212, -76.3608, -1.33274737945689),
(7114, '17552', 218, 45, 14269, 40.1065, 0.699990476451106, -76.5074, -1.33530603214031),
(7115, '17554', 218, 45, 23262, 40.0409, 0.698845540461797, -76.4264, -1.33389231544619),
(7116, '17555', 218, 45, 165022, 40.11, 0.700051562974926, -75.9621, -1.32578875172918),
(7117, '17557', 218, 45, 23337, 40.0997, 0.69987179406197, -76.0775, -1.32780286168599),
(7118, '17560', 218, 45, 4553, 39.9105, 0.696569631117197, -76.2189, -1.33027075724831),
(7119, '17562', 218, 45, 11064, 39.9823, 0.697822777520129, -76.0978, -1.32815716352414),
(7120, '17563', 218, 45, 78914, 39.7651, 0.694031922384797, -76.1825, -1.32963545740058),
(7121, '17564', 218, 45, 165836, 39.8816, 0.69606523096337, -76.3673, -1.33286082585827),
(7122, '17565', 218, 45, 78933, 39.9012, 0.696407315496761, -76.3276, -1.33216793014522),
(7123, '17566', 218, 45, 14458, 39.8802, 0.696040796353843, -76.1486, -1.32904379078415),
(7124, '17567', 218, 45, 166333, 40.2105, 0.70180561887318, -76.1206, -1.3285550985936),
(7125, '17568', 218, 45, 79013, 39.9461, 0.697190968330907, -76.2334, -1.33052382998985),
(7126, '17569', 218, 45, 166390, 40.2782, 0.70298720677678, -76.125, -1.32863189308068),
(7127, '17570', 218, 45, 166432, 40.1291, 0.700384920862057, -76.5706, -1.33640908022757),
(7128, '17572', 218, 45, 166634, 40.0151, 0.698395245514783, -76.1477, -1.32902808282089),
(7129, '17573', 218, 45, 166634, 40.0264, 0.698592467720258, -76.1694, -1.32940681926857),
(7130, '17575', 218, 45, 51446, 40.0727, 0.699400555163932, -76.431, -1.33397260059179),
(7131, '17576', 218, 45, 79149, 40.0373, 0.698782708608726, -76.2011, -1.32996008864145),
(7132, '17577', 218, 45, 167334, 40.0151, 0.698395245514783, -76.1548, -1.32915200119778),
(7133, '17578', 218, 45, 6079, 40.2282, 0.702114542150783, -76.1743, -1.32949234040192),
(7134, '17579', 218, 45, 28710, 39.9666, 0.697548760827566, -76.1804, -1.32959880548629),
(7135, '17580', 218, 45, 34112, 40.1175, 0.700182462668825, -76.2133, -1.33017301881019),
(7136, '17581', 218, 45, 167901, 40.1573, 0.700877103711119, -76.0508, -1.3273368587757),
(7137, '17582', 218, 45, 79337, 39.9944, 0.69803396235962, -76.4531, -1.33435831835648),
(7138, '17583', 218, 45, 79391, 39.9723, 0.697648244594929, -76.2879, -1.33147503443218),
(7139, '17584', 218, 45, 79419, 39.963, 0.697485928974494, -76.2714, -1.3311870551056),
(7140, '17585', 218, 45, 169071, 40.0477, 0.698964222850933, -76.2121, -1.33015207485917),
(7141, '17601', 218, 45, 16841, 40.0726, 0.69939880983468, -76.3254, -1.33212953290168),
(7142, '17602', 218, 45, 16841, 40.0298, 0.698651808914826, -76.2648, -1.33107186337497),
(7143, '17603', 218, 45, 16841, 40.0292, 0.698641336939314, -76.3436, -1.33244718282554),
(7144, '17604', 218, 45, 16841, 40.0982, 0.69984561412319, -76.2778, -1.33129875617773),
(7145, '17605', 218, 45, 16841, 40.0154, 0.698400481502539, -76.2508, -1.33082751727969),
(7146, '17606', 218, 45, 16841, 40.0775, 0.699484330968027, -76.3108, -1.33187471483089),
(7147, '17607', 218, 45, 16841, 40.0337, 0.698719876755654, -76.3495, -1.33255015725141),
(7148, '17608', 218, 45, 16841, 40.0334, 0.698714640767898, -76.3487, -1.33253619461739),
(7149, '17699', 218, 45, 16841, 40.0415, 0.698856012437309, -76.3009, -1.33170192723494),
(7150, '17701', 218, 45, 38893, 41.2464, 0.719885484594589, -77.0165, -1.34419150336221),
(7151, '17702', 218, 45, 38893, 41.2286, 0.719574815987734, -77.0145, -1.34415659677717),
(7152, '17703', 218, 45, 38893, 41.2411, 0.719792982144233, -77.0016, -1.34393144930367),
(7153, '17705', 218, 45, 38893, 41.2384, 0.71974585825443, -77.0373, -1.34455453184663),
(7154, '17720', 218, 45, 158722, 41.2381, 0.719740622266674, -77.0479, -1.34473953674734),
(7155, '17721', 218, 45, 99563, 41.186, 0.718831305726385, -77.3203, -1.34949381362977),
(7156, '17722', 218, 45, 159353, 41.4226, 0.722960754736603, -76.9981, -1.34387036277985),
(7157, '17723', 218, 45, 159768, 41.4056, 0.722664048763764, -77.4558, -1.35185873476622),
(7158, '17724', 218, 45, 19763, 41.6562, 0.727037843869262, -76.8517, -1.34131520075493),
(7159, '17726', 218, 45, 159857, 41.1225, 0.717723021651368, -77.4327, -1.35145556370901),
(7160, '17727', 218, 45, 45542, 41.4983, 0.724281968980363, -77.491, -1.35247309066293),
(7161, '17728', 218, 45, 0, 41.3204, 0.721177028241065, -77.0304, -1.34443410412824),
(7162, '17729', 218, 45, 160565, 41.5044, 0.724388434064734, -77.7363, -1.35675438331807),
(7163, '17730', 218, 45, 160771, 41.1083, 0.717475184897585, -76.8774, -1.34176375037269),
(7164, '17731', 218, 45, 160994, 41.4119, 0.72277400450664, -76.5831, -1.33662724638407),
(7165, '17735', 218, 45, 2894, 41.6144, 0.726308296241928, -76.8666, -1.34157525481347),
(7166, '17737', 218, 45, 48332, 41.2404, 0.71978076483947, -76.7261, -1.33912306721442),
(7167, '17738', 218, 45, 162954, 41.3612, 0.721889122575879, -77.7714, -1.35736699388552),
(7168, '17739', 218, 45, 163150, 41.4053, 0.722658812776008, -77.4558, -1.35185873476622),
(7169, '17740', 218, 45, 163151, 41.2008, 0.71908961445568, -77.2687, -1.34859322373574),
(7170, '17742', 218, 45, 150100, 41.2323, 0.719639393170058, -76.5847, -1.3366551716521),
(7171, '17744', 218, 45, 3784, 41.2702, 0.720300872956564, -77.1593, -1.34668383353406),
(7172, '17745', 218, 45, 163897, 41.1356, 0.717951659783379, -77.448, -1.35172259908457),
(7173, '17747', 218, 45, 163935, 41.0284, 0.716080666825242, -77.3179, -1.34945192572772),
(7174, '17748', 218, 45, 164371, 41.16, 0.718377520120866, -77.3617, -1.3502163799401),
(7175, '17749', 218, 45, 164372, 41.0717, 0.716836394391355, -76.8186, -1.34073749677252),
(7176, '17750', 218, 45, 110245, 41.056, 0.716562377698792, -77.4443, -1.35165802190224),
(7177, '17751', 218, 45, 164589, 41.1071, 0.717454240946561, -77.4881, -1.35242247611462),
(7178, '17752', 218, 45, 4289, 41.1713, 0.718574742326341, -76.8764, -1.34174629708017),
(7179, '17754', 218, 45, 164746, 41.255, 0.720035582910261, -76.9241, -1.34257881913337),
(7180, '17756', 218, 45, 164958, 41.2007, 0.719087869126428, -76.7873, -1.34019120871664),
(7181, '17758', 218, 45, 164959, 41.3716, 0.722070636818086, -76.4996, -1.33516989645865),
(7182, '17759', 218, 45, 30668, 41.2381, 0.719740622266674, -77.0468, -1.34472033812557),
(7183, '17760', 218, 45, 23407, 41.3497, 0.721688409711899, -77.7024, -1.35616271670164),
(7184, '17762', 218, 45, 165899, 41.2796, 0.720464933906251, -76.7116, -1.33886999447288),
(7185, '17763', 218, 45, 965, 41.5078, 0.724447775259302, -76.9646, -1.34328567748043),
(7186, '17764', 218, 45, 166406, 41.3281, 0.721311418593468, -77.7411, -1.35683815912216),
(7187, '17765', 218, 45, 166539, 41.5541, 0.725255862702976, -76.8941, -1.34205522035777),
(7188, '17767', 218, 45, 97761, 41.0863, 0.717091212462146, -77.4644, -1.3520088330819),
(7189, '17768', 218, 45, 157655, 41.5331, 0.724889343560057, -76.7454, -1.33945991576006),
(7190, '17769', 218, 45, 167236, 41.4983, 0.724281968980363, -77.4909, -1.35247134533367),
(7191, '17771', 218, 45, 168058, 41.4224, 0.722957264078099, -76.9983, -1.34387385343835),
(7192, '17772', 218, 45, 168102, 41.1017, 0.717359993166953, -76.7711, -1.33990846537782),
(7193, '17773', 218, 45, 74588, 41.0283, 0.71607892149599, -77.3173, -1.34944145375221),
(7194, '17774', 218, 45, 168215, 41.2445, 0.719852323338801, -76.5219, -1.33555910488185),
(7195, '17776', 218, 45, 25838, 41.3355, 0.721440572958116, -77.3445, -1.34991618330875),
(7196, '17777', 218, 45, 168568, 41.0891, 0.717140081681202, -76.8623, -1.34150020565564),
(7197, '17778', 218, 45, 25961, 41.3093, 0.720983296694094, -77.9695, -1.36082449113372),
(7198, '17779', 218, 45, 169132, 41.1878, 0.718862721652921, -77.3729, -1.35041185681632),
(7199, '17801', 218, 45, 25240, 40.8643, 0.713216581522719, -76.7872, -1.34018946338739),
(7200, '17810', 218, 45, 18807, 41.1182, 0.717647972493532, -77.0219, -1.34428575114182),
(7201, '17812', 218, 45, 159004, 40.7666, 0.71151139484352, -77.2463, -1.3482022699833),
(7202, '17813', 218, 45, 71768, 40.7542, 0.711294974016273, -77.1715, -1.3468967637028),
(7203, '17814', 218, 45, 358, 41.1368, 0.717972603734403, -76.4128, -1.33365495066792),
(7204, '17815', 218, 45, 159321, 41.0077, 0.715719383670079, -76.448, -1.33426930656462),
(7205, '17820', 218, 45, 53908, 40.954, 0.714782141861758, -76.4586, -1.33445431146534),
(7206, '17821', 218, 45, 1964, 40.9659, 0.714989836042745, -76.5978, -1.33688380978411),
(7207, '17822', 218, 45, 1964, 40.9612, 0.714907805567901, -76.6122, -1.3371351371964),
(7208, '17823', 218, 45, 160856, 40.7556, 0.711319408625801, -76.7641, -1.33978629233018),
(7209, '17824', 218, 45, 161346, 40.8628, 0.713190401583939, -76.5539, -1.33611761024249),
(7210, '17827', 218, 45, 27213, 40.7636, 0.71145903496596, -76.941, -1.34287377977696),
(7211, '17828', 218, 45, 162163, 40.749, 0.711204216895169, -76.5163, -1.33546136644374),
(7212, '17829', 218, 45, 162480, 40.8644, 0.713218326851971, -77.2399, -1.34809056891117),
(7213, '17830', 218, 45, 9440, 40.6897, 0.710169236648737, -76.7887, -1.34021564332617),
(7214, '17831', 218, 45, 162906, 40.7745, 0.711649275854428, -76.9621, -1.34324204424913),
(7215, '17832', 218, 45, 30430, 40.8055, 0.712190327922546, -76.4648, -1.33456252187896),
(7216, '17833', 218, 45, 163440, 40.8026, 0.712139713374238, -76.9639, -1.34327346017566),
(7217, '17834', 218, 45, 163455, 40.792, 0.711954708473527, -76.4719, -1.33468644025585),
(7218, '17835', 218, 45, 145582, 40.9525, 0.714755961922978, -77.194, -1.3472894627845),
(7219, '17836', 218, 45, 163679, 40.71, 0.710523538486892, -76.6272, -1.3373969365842),
(7220, '17837', 218, 45, 3750, 40.9588, 0.714865917665853, -76.8986, -1.34213376017411),
(7221, '17839', 218, 45, 163786, 41.0007, 0.715597210622439, -76.4538, -1.33437053566124),
(7222, '17840', 218, 45, 163919, 40.7729, 0.711621350586396, -76.4392, -1.33411571759045),
(7223, '17841', 218, 45, 4073, 40.7041, 0.710420564061024, -77.3132, -1.34936989525288),
(7224, '17842', 218, 45, 17130, 40.7934, 0.711979143083055, -77.0271, -1.34437650826292),
(7225, '17843', 218, 45, 159004, 40.8153, 0.712361370189242, -76.9719, -1.34341308651582),
(7226, '17844', 218, 45, 164553, 40.9174, 0.714143351355528, -77.0459, -1.3447046301623),
(7227, '17845', 218, 45, 164635, 40.8644, 0.713218326851971, -77.2392, -1.3480783516064),
(7228, '17846', 218, 45, 4227, 41.1213, 0.717702077700344, -76.5295, -1.335691749905),
(7229, '17847', 218, 45, 4232, 41.0144, 0.715836320729962, -76.8459, -1.34121397165831),
(7230, '17850', 218, 45, 164727, 40.9716, 0.715089319810109, -76.8497, -1.34128029416989),
(7231, '17851', 218, 45, 4363, 40.7987, 0.712071645533411, -76.418, -1.33374570778903),
(7232, '17853', 218, 45, 164893, 40.6985, 0.710322825622912, -77.0075, -1.34403442372953),
(7233, '17855', 218, 45, 17254, 40.8799, 0.71348885288603, -76.9867, -1.34367139524512),
(7234, '17856', 218, 45, 28021, 41.0305, 0.716117318739533, -76.9118, -1.34236414363537),
(7235, '17857', 218, 45, 144259, 40.8962, 0.713773341554105, -76.7973, -1.34036574164184),
(7236, '17858', 218, 45, 165411, 40.8803, 0.713495834203038, -76.4022, -1.33346994576721),
(7237, '17859', 218, 45, 30739, 41.0782, 0.716949840792735, -76.4145, -1.33368462126521),
(7238, '17860', 218, 45, 165756, 40.8349, 0.712703454722632, -76.6412, -1.33764128267948),
(7239, '17861', 218, 45, 165758, 40.7702, 0.711574226696592, -77.0834, -1.3453591286318),
(7240, '17862', 218, 45, 165818, 40.8571, 0.713090917816575, -77.0683, -1.34509558391475),
(7241, '17864', 218, 45, 166153, 40.6821, 0.710036591625585, -76.9176, -1.34246537273199),
(7242, '17865', 218, 45, 166176, 40.9956, 0.715508198830587, -76.7903, -1.3402435685942),
(7243, '17866', 218, 45, 0, 40.788, 0.711884895303447, -76.5552, -1.33614029952276),
(7244, '17867', 218, 45, 166336, 40.7131, 0.710577643693703, -76.7351, -1.3392801468471),
(7245, '17868', 218, 45, 5423, 40.9567, 0.714829265751562, -76.6279, -1.33740915388896),
(7246, '17870', 218, 45, 166988, 40.8193, 0.712431183359321, -76.8527, -1.34133265404745),
(7247, '17872', 218, 45, 83583, 40.788, 0.711884895303447, -76.5607, -1.33623629263162),
(7248, '17876', 218, 45, 167045, 40.8502, 0.712970490098188, -76.8242, -1.34083523521063),
(7249, '17877', 218, 45, 146326, 40.8792, 0.713476635581266, -76.6677, -1.33810379493126),
(7250, '17878', 218, 45, 12131, 41.1528, 0.718251856414722, -76.3738, -1.33297427225965),
(7251, '17880', 218, 45, 167818, 40.9432, 0.714593646302542, -77.0756, -1.34522299295014),
(7252, '17881', 218, 45, 168043, 40.7819, 0.711778430219076, -76.6755, -1.33823993061291),
(7253, '17882', 218, 45, 168065, 40.8025, 0.712137968044986, -77.2053, -1.34748668498998),
(7254, '17883', 218, 45, 18446, 40.9387, 0.714515106486203, -76.9879, -1.34369233919614),
(7255, '17884', 218, 45, 146572, 41.0519, 0.71649081919946, -76.6748, -1.33822771330815),
(7256, '17885', 218, 45, 168616, 40.8585, 0.713115352426103, -77.2951, -1.34905399065827),
(7257, '17886', 218, 45, 74777, 41.0197, 0.715928823180318, -76.87, -1.34163459600804),
(7258, '17887', 218, 45, 168898, 41.0763, 0.716916679536947, -76.8749, -1.34172011714139),
(7259, '17888', 218, 45, 77681, 40.8148, 0.712352643542982, -76.3759, -1.33301092417394),
(7260, '17889', 218, 45, 6882, 40.9182, 0.714157313989544, -76.8627, -1.34150718697265),
(7261, '17901', 218, 45, 11354, 40.6846, 0.710080224856885, -76.2035, -1.3300019765435),
(7262, '17920', 218, 45, 158754, 40.8189, 0.712424202042313, -76.3403, -1.33238958696023),
(7263, '17921', 218, 45, 13301, 40.7802, 0.711748759621792, -76.3402, -1.33238784163098),
(7264, '17922', 218, 45, 13306, 40.5934, 0.708488484579066, -76.1544, -1.32914501988077),
(7265, '17923', 218, 45, 0, 40.675, 0.709912673248693, -76.3253, -1.33212778757243),
(7266, '17925', 218, 45, 19523, 40.749, 0.711204216895169, -76.0686, -1.32764752738256),
(7267, '17927', 218, 45, 26746, 40.8037, 0.71215891199601, -76.3405, -1.33239307761873),
(7268, '17929', 218, 45, 160541, 40.6306, 0.709137747060808, -76.1943, -1.32984140625232),
(7269, '17930', 218, 45, 160592, 40.7114, 0.710547973096419, -76.1393, -1.32888147516372),
(7270, '17931', 218, 45, 161802, 40.783, 0.711797628840847, -76.2343, -1.33053953795311),
(7271, '17932', 218, 45, 161802, 40.7839, 0.711813336804115, -76.2303, -1.33046972478303),
(7272, '17933', 218, 45, 161892, 40.6023, 0.708643818882494, -76.2392, -1.33062505908646),
(7273, '17934', 218, 45, 162037, 40.7989, 0.712075136191915, -76.2174, -1.33024457730953),
(7274, '17935', 218, 45, 162058, 40.7926, 0.711965180449039, -76.2831, -1.33139125862809),
(7275, '17936', 218, 45, 2785, 40.7501, 0.711223415516941, -76.3377, -1.33234420839968),
(7276, '17938', 218, 45, 162569, 40.6515, 0.709502520874475, -76.5061, -1.33528334286003),
(7277, '17941', 218, 45, 163401, 40.7255, 0.710794064520951, -76.606, -1.33702692678278),
(7278, '17942', 218, 45, 163548, 40.5876, 0.708387255482451, -76.1364, -1.32883086061541),
(7279, '17943', 218, 45, 163629, 40.7635, 0.711457289636709, -76.3829, -1.33313309722158),
(7280, '17944', 218, 45, 163885, 40.6737, 0.709889983968418, -76.277, -1.33128479354371),
(7281, '17945', 218, 45, 163924, 40.6916, 0.710202397904525, -76.2601, -1.33098983290013),
(7282, '17946', 218, 45, 36973, 40.806, 0.712199054568806, -76.2468, -1.33075770410961),
(7283, '17948', 218, 45, 164125, 40.8125, 0.712312500970186, -76.1401, -1.32889543779773),
(7284, '17949', 218, 45, 164127, 40.7943, 0.711994851046323, -76.2448, -1.33072279752457),
(7285, '17951', 218, 45, 0, 40.6791, 0.709984231748025, -76.2433, -1.33069661758579),
(7286, '17952', 218, 45, 0, 40.7585, 0.711370023174109, -76.0561, -1.32742936122606),
(7287, '17953', 218, 45, 73458, 40.7279, 0.710835952422998, -76.0851, -1.32793550670914),
(7288, '17954', 218, 45, 73497, 40.6895, 0.710165745990233, -76.2611, -1.33100728619265),
(7289, '17957', 218, 45, 10705, 40.5929, 0.708479757932806, -76.5194, -1.33551547165055),
(7290, '17959', 218, 45, 28042, 40.7253, 0.710790573862447, -76.1173, -1.32849750272828),
(7291, '17960', 218, 45, 165164, 40.6836, 0.710062771564365, -75.9984, -1.32642230624766),
(7292, '17961', 218, 45, 165582, 40.6503, 0.709481576923451, -76.0936, -1.32808385969556),
(7293, '17963', 218, 45, 557, 40.5523, 0.707771154256497, -76.3862, -1.33319069308689),
(7294, '17964', 218, 45, 339, 40.7054, 0.7104432533413, -76.5138, -1.33541773321244),
(7295, '17965', 218, 45, 166132, 40.6983, 0.710319334964408, -76.1654, -1.32933700609849),
(7296, '17966', 218, 45, 61485, 40.5606, 0.707916016584412, -76.3307, -1.33222203535204),
(7297, '17967', 218, 45, 166501, 40.8504, 0.712973980756692, -76.2332, -1.33052033933134),
(7298, '17968', 218, 45, 28490, 40.6399, 0.709300062681243, -76.6118, -1.33712815587939),
(7299, '17970', 218, 45, 5605, 40.7186, 0.710673636802563, -76.1918, -1.32979777302102),
(7300, '17972', 218, 45, 166943, 40.6247, 0.70903477263494, -76.1775, -1.32954819093798),
(7301, '17974', 218, 45, 166994, 40.6958, 0.710275701733108, -76.2371, -1.33058840717217),
(7302, '17976', 218, 45, 14609, 40.8164, 0.712380568811014, -76.2054, -1.33003513779929),
(7303, '17978', 218, 45, 18173, 40.6375, 0.709258174779196, -76.6468, -1.33773902111759),
(7304, '17979', 218, 45, 74469, 40.5777, 0.708214467886503, -76.1918, -1.32979777302102),
(7305, '17980', 218, 45, 140972, 40.5909, 0.708444851347766, -76.5379, -1.33583835756217),
(7306, '17981', 218, 45, 25561, 40.6364, 0.709238976157424, -76.3869, -1.33320291039166),
(7307, '17982', 218, 45, 52241, 40.769, 0.711553282745568, -76.0396, -1.32714138189948),
(7308, '17983', 218, 45, 6510, 40.6444, 0.709378602497583, -76.5437, -1.33593958665878),
(7309, '17985', 218, 45, 76, 40.9059, 0.713942638491548, -76.1635, -1.3293038448427),
(7310, '18001', 218, 45, 0, 40.5822, 0.708293007702843, -75.4717, -1.3172296570774),
(7311, '18002', 218, 45, 0, 40.5824, 0.708296498361347, -75.4718, -1.31723140240666),
(7312, '18003', 218, 45, 0, 40.644, 0.709371621180575, -75.435, -1.31658912124192),
(7313, '18010', 218, 45, 158535, 40.8643, 0.713216581522719, -75.1764, -1.31207569979627),
(7314, '18011', 218, 45, 158581, 40.5125, 0.707076513214203, -75.6041, -1.31954047300705),
(7315, '18012', 218, 45, 158733, 40.8078, 0.712230470495342, -75.772, -1.32247088082114),
(7316, '18013', 218, 45, 34662, 40.868, 0.713281158705043, -75.2092, -1.31264816779092),
(7317, '18014', 218, 45, 19093, 40.7574, 0.711350824552337, -75.4036, -1.3160410878568),
(7318, '18015', 218, 45, 548, 40.6025, 0.708647309540998, -75.3674, -1.31540927866757),
(7319, '18016', 218, 45, 548, 40.6263, 0.709062697902972, -75.374, -1.31552447039821),
(7320, '18017', 218, 45, 548, 40.6503, 0.709481576923451, -75.3586, -1.3152556896934),
(7321, '18018', 218, 45, 548, 40.6262, 0.70906095257372, -75.4067, -1.31609519306361),
(7322, '18020', 218, 45, 548, 40.6256, 0.709050480598208, -75.3708, -1.31546861986214),
(7323, '18025', 218, 45, 548, 40.6265, 0.709066188561476, -75.3681, -1.31542149597234),
(7324, '18030', 218, 45, 159408, 40.8012, 0.71211527876471, -75.6605, -1.32052483870517),
(7325, '18031', 218, 45, 159487, 40.5563, 0.707840967426576, -75.6583, -1.32048644146163),
(7326, '18032', 218, 45, 159868, 40.6521, 0.709512992849987, -75.4666, -1.31714064528555),
(7327, '18034', 218, 45, 8000, 40.5493, 0.707718794378937, -75.4263, -1.316437277597),
(7328, '18035', 218, 45, 54017, 40.7519, 0.711254831443477, -75.5411, -1.31844091557829),
(7329, '18036', 218, 45, 160401, 40.5129, 0.707083494531211, -75.3962, -1.31591193349215),
(7330, '18037', 218, 45, 160409, 40.6744, 0.709902201273182, -75.5194, -1.31806217913061),
(7331, '18038', 218, 45, 1961, 40.7909, 0.711935509851755, -75.4857, -1.31747400317268),
(7332, '18039', 218, 45, 8632, 40.5828, 0.708303479678355, -75.2269, -1.31295709106852),
(7333, '18040', 218, 45, 2193, 40.6998, 0.710345514903188, -75.2199, -1.31283491802088),
(7334, '18041', 218, 45, 148459, 40.4169, 0.705407978449296, -75.5114, -1.31792255279045),
(7335, '18042', 218, 45, 2193, 40.6864, 0.710111640783421, -75.2413, -1.31320841848081),
(7336, '18043', 218, 45, 2193, 40.6886, 0.710150038026965, -75.2211, -1.31285586197191),
(7337, '18044', 218, 45, 2193, 40.6867, 0.710116876771177, -75.2201, -1.31283840867939),
(7338, '18045', 218, 45, 2193, 40.6886, 0.710150038026965, -75.2341, -1.31308275477467),
(7339, '18046', 218, 45, 161137, 40.546, 0.707661198513621, -75.5617, -1.3188004534042),
(7340, '18049', 218, 45, 94052, 40.5351, 0.707470957625153, -75.5029, -1.31777419980403),
(7341, '18050', 218, 45, 161686, 40.8643, 0.713216581522719, -75.2076, -1.31262024252289),
(7342, '18051', 218, 45, 161698, 40.5949, 0.708514664517846, -75.6523, -1.32038172170651),
(7343, '18052', 218, 45, 12826, 40.6465, 0.709415254411875, -75.4961, -1.31765551741489),
(7344, '18053', 218, 45, 162012, 40.6911, 0.710193671258265, -75.659, -1.32049865876639),
(7345, '18054', 218, 45, 162236, 40.3421, 0.704102472168805, -75.4388, -1.3166554437535),
(7346, '18055', 218, 45, 162587, 40.5819, 0.708287771715087, -75.3336, -1.3148193573804),
(7347, '18056', 218, 45, 48009, 40.412, 0.705322457315948, -75.7604, -1.32226842262791),
(7348, '18058', 218, 45, 163462, 40.9303, 0.714368498829035, -75.4793, -1.31736230210056),
(7349, '18059', 218, 45, 163626, 40.727, 0.710820244459731, -75.5341, -1.31831874253065),
(7350, '18060', 218, 45, 163798, 40.509, 0.707015426690383, -75.4474, -1.31680554206917),
(7351, '18062', 218, 45, 164109, 40.5292, 0.707367983199286, -75.5617, -1.3188004534042),
(7352, '18063', 218, 45, 66652, 40.783, 0.711797628840847, -75.1861, -1.31224499673371),
(7353, '18064', 218, 45, 37361, 40.7474, 0.711176291627137, -75.3206, -1.31459246457764),
(7354, '18065', 218, 45, 156683, 40.6966, 0.710289664367124, -75.6101, -1.31964519276216),
(7355, '18066', 218, 45, 165176, 40.6744, 0.709902201273182, -75.7415, -1.32193855539929),
(7356, '18067', 218, 45, 49904, 40.7006, 0.710359477537204, -75.4857, -1.31747400317268),
(7357, '18068', 218, 45, 165515, 40.4868, 0.70662796359644, -75.52, -1.31807265110612),
(7358, '18069', 218, 45, 165564, 40.6176, 0.708910854258049, -75.5941, -1.31936594008185),
(7359, '18070', 218, 45, 17483, 40.4353, 0.705729119031663, -75.5407, -1.31843393426128),
(7360, '18071', 218, 45, 120952, 40.8091, 0.712253159775618, -75.6179, -1.31978132844382),
(7361, '18072', 218, 45, 165772, 40.859, 0.713124079072363, -75.2572, -1.31348592583188),
(7362, '18073', 218, 45, 165819, 40.3876, 0.704896596978462, -75.4785, -1.31734833946654),
(7363, '18074', 218, 45, 165846, 40.3206, 0.703727226379626, -75.514, -1.317967931351),
(7364, '18076', 218, 45, 970, 40.3766, 0.704704610760743, -75.4861, -1.31748098448969),
(7365, '18077', 218, 45, 146172, 40.5607, 0.707917761913664, -75.2387, -1.31316303992026),
(7366, '18078', 218, 45, 166928, 40.6774, 0.709954561150741, -75.6075, -1.31959981420161),
(7367, '18079', 218, 45, 167233, 40.7452, 0.711137894383594, -75.6541, -1.32041313763304),
(7368, '18080', 218, 45, 167238, 40.7353, 0.710965106787646, -75.6151, -1.31973245922476),
(7369, '18081', 218, 45, 12093, 40.5559, 0.707833986109568, -75.29, -1.31405839382653),
(7370, '18083', 218, 45, 167627, 40.7553, 0.711314172638045, -75.2611, -1.3135539936727),
(7371, '18084', 218, 45, 167750, 40.3245, 0.703795294220453, -75.4543, -1.31692596978756),
(7372, '18085', 218, 45, 167872, 40.7406, 0.711057609238002, -75.2552, -1.31345101924684),
(7373, '18086', 218, 45, 168035, 40.7368, 0.710991286726426, -75.547, -1.31854389000416),
(7374, '18087', 218, 45, 168048, 40.5506, 0.707741483659213, -75.5981, -1.31943575325193),
(7375, '18088', 218, 45, 168458, 40.7604, 0.711403184429897, -75.5652, -1.31886153992802),
(7376, '18091', 218, 45, 169025, 40.8292, 0.712603970955269, -75.3093, -1.31439524237217),
(7377, '18092', 218, 45, 31589, 40.4533, 0.706043278297022, -75.5082, -1.31786670225438),
(7378, '18098', 218, 45, 94052, 40.5306, 0.707392417808814, -75.499, -1.3177061319632),
(7379, '18099', 218, 45, 94052, 40.5365, 0.707495392234681, -75.498, -1.31768867867068),
(7380, '18101', 218, 45, 14969, 40.6018, 0.708635092236234, -75.4708, -1.31721394911414),
(7381, '18102', 218, 45, 14969, 40.6077, 0.708738066662101, -75.4789, -1.31735532078355),
(7382, '18103', 218, 45, 14969, 40.5923, 0.708469285957294, -75.4748, -1.31728376228422),
(7383, '18104', 218, 45, 14969, 40.6021, 0.70864032822399, -75.5297, -1.31824194804356),
(7384, '18105', 218, 45, 14969, 40.5664, 0.708017245681028, -75.5406, -1.31843218893203),
(7385, '18106', 218, 45, 14969, 40.5571, 0.707854930060592, -75.5674, -1.31889993717156),
(7386, '18109', 218, 45, 14969, 40.5825, 0.708298243690599, -75.4715, -1.3172261664189),
(7387, '18175', 218, 45, 14969, 40.6045, 0.708682216126038, -75.5386, -1.31839728234699),
(7388, '18195', 218, 45, 14969, 40.5818, 0.708286026385835, -75.4717, -1.3172296570774),
(7389, '18201', 218, 45, 30043, 40.9611, 0.714906060238649, -75.9793, -1.32608894836053),
(7390, '18202', 218, 45, 30043, 40.9607, 0.714899078921641, -75.9799, -1.32609942033604),
(7391, '18210', 218, 45, 158580, 40.9955, 0.715506453501335, -75.5729, -1.31899593028042),
(7392, '18211', 218, 45, 158703, 40.7426, 0.711092515823042, -75.8276, -1.32344128388525),
(7393, '18212', 218, 45, 124131, 40.8352, 0.712708690710388, -75.7096, -1.3213817953679),
(7394, '18214', 218, 45, 19061, 40.8242, 0.712516704492669, -76.0481, -1.3272897348859),
(7395, '18216', 218, 45, 159001, 40.9291, 0.714347554878011, -75.9126, -1.32492481374945),
(7396, '18218', 218, 45, 1663, 40.8208, 0.712457363298101, -75.9121, -1.32491608710319),
(7397, '18219', 218, 45, 160374, 40.9907, 0.71542267769724, -76.0602, -1.32750091972539),
(7398, '18220', 218, 45, 72302, 40.8394, 0.712781994538972, -76.0716, -1.32769988726012),
(7399, '18221', 218, 45, 2105, 41.0047, 0.715667023792519, -75.9068, -1.32482358465283),
(7400, '18222', 218, 45, 160913, 41.0346, 0.716188877238865, -75.952, -1.32561247347473),
(7401, '18223', 218, 45, 161180, 40.9829, 0.715286542015584, -75.9588, -1.32573115586387),
(7402, '18224', 218, 45, 40997, 41.0165, 0.715872972644254, -75.8999, -1.32470315693444),
(7403, '18225', 218, 45, 162441, 40.9813, 0.715258616747552, -75.9715, -1.32595281267887),
(7404, '18229', 218, 45, 163160, 40.8773, 0.713443474325478, -75.7361, -1.32184430761968),
(7405, '18230', 218, 45, 163199, 40.924, 0.714258543086159, -75.9392, -1.32538907133048),
(7406, '18231', 218, 45, 163267, 40.9008, 0.713853626699697, -76.0063, -1.32656018725857),
(7407, '18232', 218, 45, 163579, 40.8325, 0.712661566820585, -75.8828, -1.32440470563235),
(7408, '18234', 218, 45, 0, 40.9928, 0.715459329611532, -75.9611, -1.32577129843666),
(7409, '18235', 218, 45, 163707, 40.8445, 0.712871006330824, -75.6975, -1.32117061052841),
(7410, '18237', 218, 45, 164332, 40.8924, 0.713707019042529, -76.0035, -1.32651131803951),
(7411, '18239', 218, 45, 164653, 40.9895, 0.715401733746216, -75.9841, -1.32617272416462),
(7412, '18240', 218, 45, 165071, 40.8655, 0.713237525473743, -75.8136, -1.32319693778997),
(7413, '18241', 218, 45, 165410, 40.9389, 0.714518597144707, -76.1882, -1.32973494116794),
(7414, '18242', 218, 45, 10986, 40.9067, 0.713956601125564, -76.1317, -1.32874883014057),
(7415, '18244', 218, 45, 165721, 40.8216, 0.712471325932117, -75.6732, -1.32074649552017),
(7416, '18245', 218, 45, 166250, 40.8438, 0.71285878902606, -75.9844, -1.32617796015238),
(7417, '18246', 218, 45, 152158, 40.9518, 0.714743744618214, -76.1634, -1.32930209951345),
(7418, '18247', 218, 45, 28504, 41.032, 0.716143498678313, -76.0063, -1.32656018725857),
(7419, '18248', 218, 45, 167109, 40.8955, 0.713761124249341, -76.1136, -1.32843292554596),
(7420, '18249', 218, 45, 138334, 40.991, 0.715427913684996, -76.0743, -1.32774701114992),
(7421, '18250', 218, 45, 25227, 40.8253, 0.712535903114441, -75.8717, -1.32421097408538),
(7422, '18251', 218, 45, 167828, 41.0013, 0.715607682597951, -76.0771, -1.32779588036898),
(7423, '18252', 218, 45, 167855, 40.7984, 0.712066409545655, -75.9719, -1.32595979399588),
(7424, '18254', 218, 45, 168040, 40.9156, 0.714111935428992, -75.9656, -1.325849838253),
(7425, '18255', 218, 45, 52564, 40.9415, 0.714563975705258, -75.8274, -1.32343779322675),
(7426, '18256', 218, 45, 6746, 40.9408, 0.714551758400495, -76.1421, -1.32893034438277),
(7427, '18301', 218, 45, 161133, 41.0241, 0.716005617667406, -75.1869, -1.31225895936772),
(7428, '18320', 218, 45, 158690, 41.0508, 0.716471620577688, -75.221, -1.31285411664265),
(7429, '18321', 218, 45, 44616, 41.0109, 0.715775234206143, -75.2924, -1.31410028172858),
(7430, '18322', 218, 45, 159548, 40.953, 0.714764688569238, -75.3593, -1.31526790699816),
(7431, '18323', 218, 45, 159618, 41.1876, 0.718859230994417, -75.2661, -1.3136412601353),
(7432, '18324', 218, 45, 159693, 41.1659, 0.718480494546734, -74.9545, -1.30820281418609),
(7433, '18325', 218, 45, 159780, 41.244, 0.719843596692541, -75.2269, -1.31295709106852),
(7434, '18326', 218, 45, 115152, 41.1601, 0.718379265450118, -75.2517, -1.31338993272302),
(7435, '18327', 218, 45, 160720, 40.988, 0.715375553807436, -75.1468, -1.31155908233767),
(7436, '18328', 218, 45, 160808, 41.2303, 0.719604486585018, -74.9474, -1.3080788958092),
(7437, '18330', 218, 45, 161236, 40.9828, 0.715284796686332, -75.4512, -1.31687186458075),
(7438, '18331', 218, 45, 2713, 40.9555, 0.714808321800538, -75.5028, -1.31777245447477),
(7439, '18332', 218, 45, 3064, 41.0788, 0.716960312768247, -75.2819, -1.31391702215712),
(7440, '18333', 218, 45, 163445, 40.9564, 0.714824029763806, -75.5043, -1.31779863441355),
(7441, '18334', 218, 45, 22735, 41.0931, 0.717209894851282, -75.4304, -1.31650883609633),
(7442, '18335', 218, 45, 164273, 41.0815, 0.71700743665805, -75.166, -1.31189418555406),
(7443, '18336', 218, 45, 123144, 41.3654, 0.721962426404462, -74.7056, -1.30385868967788),
(7444, '18337', 218, 45, 10480, 41.326, 0.721274766679177, -74.7997, -1.305501044504),
(7445, '18340', 218, 45, 164638, 41.3877, 0.722351634827657, -74.7898, -1.30532825690806),
(7446, '18341', 218, 45, 164675, 41.0006, 0.715595465293187, -75.1376, -1.31139851204649),
(7447, '18342', 218, 45, 164935, 41.1774, 0.718681207410713, -75.2614, -1.31355922966046),
(7448, '18343', 218, 45, 23210, 40.8937, 0.713729708322805, -75.112, -1.31095170775798),
(7449, '18344', 218, 45, 164899, 41.1197, 0.717674152432312, -75.3574, -1.31523474574237),
(7450, '18346', 218, 45, 166094, 41.1098, 0.717501364836365, -75.4193, -1.31631510454936),
(7451, '18347', 218, 45, 166084, 41.1529, 0.718253601743974, -75.5619, -1.3188039440627),
(7452, '18348', 218, 45, 0, 41.1055, 0.717426315678529, -75.4764, -1.31731168755225),
(7453, '18349', 218, 45, 166086, 41.0978, 0.717291925326126, -75.3625, -1.31532375753423),
(7454, '18350', 218, 45, 166091, 41.1192, 0.717665425786052, -75.4424, -1.31671827560657),
(7455, '18351', 218, 45, 5188, 40.9266, 0.714303921646711, -75.1024, -1.31078415614979),
(7456, '18352', 218, 45, 166369, 40.9918, 0.715441876319012, -75.2784, -1.3138559356333),
(7457, '18353', 218, 45, 166902, 40.9277, 0.714323120268483, -75.3817, -1.31565886075061),
(7458, '18354', 218, 45, 121398, 40.9215, 0.71421490985486, -75.2818, -1.31391527682787),
(7459, '18355', 218, 45, 166955, 41.0772, 0.716932387500215, -75.337, -1.31487869857497),
(7460, '18356', 218, 45, 167073, 41.0096, 0.715752544925867, -75.1115, -1.31094298111172),
(7461, '18357', 218, 45, 18100, 41.2277, 0.719559108024466, -75.2381, -1.31315256794475),
(7462, '18360', 218, 45, 167698, 40.9892, 0.71539649775846, -75.2247, -1.31291869382498),
(7463, '18370', 218, 45, 61950, 41.0888, 0.717134845693446, -75.3633, -1.31533772016824),
(7464, '18371', 218, 45, 167859, 41.1717, 0.718581723643349, -74.9385, -1.30792356150577),
(7465, '18372', 218, 45, 31288, 41.0449, 0.716368646151821, -75.3194, -1.31457152062662),
(7466, '18373', 218, 45, 0, 41.1465, 0.718141900671847, -75.0082, -1.30914005599441),
(7467, '18401', 218, 45, 124097, 41.635, 0.726667834067839, -75.3651, -1.31536913609478),
(7468, '18403', 218, 45, 158742, 41.4947, 0.724219137127291, -75.556, -1.31870096963684),
(7469, '18405', 218, 45, 158968, 41.5914, 0.72590687051397, -75.1136, -1.31097963302601),
(7470, '18407', 218, 45, 19772, 41.5751, 0.725622381845894, -75.5002, -1.31772707591422),
(7471, '18410', 218, 45, 160070, 41.4771, 0.72391195917894, -75.6846, -1.3209454630549),
(7472, '18411', 218, 45, 160130, 41.4844, 0.724039368214336, -75.7084, -1.32136085141687),
(7473, '18413', 218, 45, 695, 41.6488, 0.726908689504614, -75.5993, -1.31945669720295),
(7474, '18414', 218, 45, 8391, 41.5308, 0.724849200987261, -75.7324, -1.32177973043735),
(7475, '18415', 218, 45, 1957, 41.7368, 0.728444579246369, -75.1338, -1.31133218953492),
(7476, '18416', 218, 45, 13723, 41.3754, 0.722136959329662, -75.5483, -1.31856657928443),
(7477, '18417', 218, 45, 161395, 41.7966, 0.729488286139062, -75.2071, -1.31261151587663),
(7478, '18419', 218, 45, 148724, 41.5624, 0.725400725030891, -75.7836, -1.32267333901437),
(7479, '18420', 218, 45, 161682, 41.5974, 0.726011590269089, -75.7085, -1.32136259674613),
(7480, '18421', 218, 45, 16058, 41.6512, 0.726950577406662, -75.4689, -1.31718078785835),
(7481, '18424', 218, 45, 127597, 41.2477, 0.719908173874865, -75.5711, -1.31896451435389),
(7482, '18425', 218, 45, 32621, 41.449, 0.72342152165913, -75.0376, -1.3096531827945),
(7483, '18426', 218, 45, 65223, 41.365, 0.721955445087454, -75.2478, -1.31332186488219),
(7484, '18427', 218, 45, 9306, 41.3982, 0.722534894399117, -75.3504, -1.31511257269474),
(7485, '18428', 218, 45, 76047, 41.4791, 0.72394686576398, -75.1818, -1.31216994757587),
(7486, '18430', 218, 45, 162632, 41.7639, 0.72891756347366, -75.5095, -1.31788939153466),
(7487, '18431', 218, 45, 162803, 41.5695, 0.725524643407783, -75.256, -1.31346498188085),
(7488, '18433', 218, 45, 95178, 41.5318, 0.724866654279781, -75.5412, -1.31844266090754),
(7489, '18434', 218, 45, 626, 41.4734, 0.723847381996616, -75.5705, -1.31895404237837),
(7490, '18435', 218, 45, 163483, 41.5099, 0.724484427173594, -75.0758, -1.31031989856876),
(7491, '18436', 218, 45, 163501, 41.4048, 0.722650086129748, -75.3346, -1.31483681067292),
(7492, '18437', 218, 45, 16776, 41.8629, 0.730645439433134, -75.2959, -1.3141613682524),
(7493, '18438', 218, 45, 16832, 41.4422, 0.723302839269994, -75.2194, -1.31282619137462),
(7494, '18439', 218, 45, 3637, 41.8137, 0.729786737441153, -75.3694, -1.31544418525261),
(7495, '18440', 218, 45, 163473, 41.5566, 0.725299495934276, -75.7541, -1.32215846688504),
(7496, '18441', 218, 45, 66327, 41.6693, 0.727266482001273, -75.6393, -1.32015482890375),
(7497, '18443', 218, 45, 164559, 41.6552, 0.727020390576742, -75.0828, -1.3104420716164),
(7498, '18444', 218, 45, 4344, 41.3483, 0.721663975102371, -75.5486, -1.31857181527219),
(7499, '18445', 218, 45, 37415, 41.2883, 0.720616777551175, -75.4012, -1.31599919995475),
(7500, '18446', 218, 45, 23378, 41.6256, 0.726503773118152, -75.7836, -1.32267333901437),
(7501, '18447', 218, 45, 10976, 41.4693, 0.723775823497284, -75.601, -1.31948636780023),
(7502, '18448', 218, 45, 10976, 41.4493, 0.723426757646886, -75.5798, -1.31911635799881),
(7503, '18449', 218, 45, 117152, 41.8138, 0.729788482770405, -75.4478, -1.31681252338618),
(7504, '18451', 218, 45, 165747, 41.3828, 0.722266113694309, -75.2203, -1.31284189933789),
(7505, '18452', 218, 45, 165770, 41.4767, 0.723904977861932, -75.5908, -1.31930834421653),
(7506, '18453', 218, 45, 56949, 41.7337, 0.728390474039557, -75.3905, -1.31581244972479),
(7507, '18454', 218, 45, 166189, 41.8209, 0.729912401147297, -75.4206, -1.31633779382964),
(7508, '18455', 218, 45, 166202, 41.8636, 0.730657656737898, -75.3839, -1.31569725799415),
(7509, '18456', 218, 45, 166220, 41.5775, 0.725664269747942, -75.3238, -1.3146483151137),
(7510, '18457', 218, 45, 24550, 41.4708, 0.723802003436064, -75.0423, -1.30973521326934),
(7511, '18458', 218, 45, 167166, 41.4185, 0.722889196237271, -74.911, -1.30744359596147),
(7512, '18459', 218, 45, 114080, 41.5052, 0.724402396698751, -75.4121, -1.31618944084322),
(7513, '18460', 218, 45, 167398, 41.2758, 0.720398611394675, -75.3948, -1.31588749888262),
(7514, '18461', 218, 45, 31211, 41.9188, 0.731621078484999, -75.3225, -1.31462562583343),
(7515, '18462', 218, 45, 167570, 41.9035, 0.731354043109444, -75.4401, -1.31667813303377),
(7516, '18463', 218, 45, 25116, 41.3567, 0.721810582759539, -75.3531, -1.31515969658454),
(7517, '18464', 218, 45, 12254, 41.413, 0.722793203128412, -75.1688, -1.31194305477311),
(7518, '18465', 218, 45, 6317, 41.8314, 0.730095660718756, -75.5333, -1.31830477989663),
(7519, '18466', 218, 45, 167987, 41.1824, 0.718768473873313, -75.3762, -1.31556286764175),
(7520, '18469', 218, 45, 168145, 41.6673, 0.727231575416233, -75.152, -1.31164983945878),
(7521, '18470', 218, 45, 168171, 41.7092, 0.727962868372819, -75.5486, -1.31857181527219),
(7522, '18471', 218, 45, 6664, 41.5237, 0.724725282610369, -75.705, -1.32130151022231),
(7523, '18472', 218, 45, 168577, 41.5835, 0.725768989503062, -75.4096, -1.31614580761192),
(7524, '18473', 218, 45, 38852, 41.5285, 0.724809058414465, -75.201, -1.31250505079226),
(7525, '18501', 218, 45, 5701, 41.3736, 0.722105543403126, -75.6841, -1.32093673640864),
(7526, '18502', 218, 45, 5701, 41.4107, 0.722753060555616, -75.6676, -1.32064875708206),
(7527, '18503', 218, 45, 5701, 41.4116, 0.722768768518884, -75.6643, -1.32059116121675),
(7528, '18504', 218, 45, 5701, 41.414, 0.722810656420932, -75.688, -1.32100480424947),
(7529, '18505', 218, 45, 5701, 41.3915, 0.722417957339233, -75.6651, -1.32060512385076),
(7530, '18507', 218, 45, 164774, 41.3648, 0.72195195442895, -75.7119, -1.32142193794069),
(7531, '18508', 218, 45, 5701, 41.4381, 0.723231280770662, -75.6615, -1.32054229199769),
(7532, '18509', 218, 45, 5701, 41.4271, 0.723039294552943, -75.6474, -1.32029620057316),
(7533, '18510', 218, 45, 5701, 41.4078, 0.722702446007308, -75.6464, -1.32027874728064),
(7534, '18512', 218, 45, 5701, 41.4274, 0.723044530540699, -75.6223, -1.31985812293091),
(7535, '18514', 218, 45, 5701, 41.4073, 0.722693719361048, -75.6451, -1.32025605800036),
(7536, '18515', 218, 45, 5701, 41.4495, 0.72343024830539, -75.6639, -1.32058417989974),
(7537, '18517', 218, 45, 6252, 41.3893, 0.722379560095689, -75.7156, -1.32148651512302),
(7538, '18518', 218, 45, 78879, 41.3705, 0.722051438196314, -75.7363, -1.32184779827818),
(7539, '18519', 218, 45, 160785, 41.4638, 0.723679830388425, -75.6237, -1.31988255754044),
(7540, '18522', 218, 45, 5701, 41.4315, 0.723116089040031, -75.6442, -1.32024035003709),
(7541, '18540', 218, 45, 5701, 41.3736, 0.722105543403126, -75.6573, -1.32046898816911),
(7542, '18577', 218, 45, 5701, 41.4232, 0.722971226712115, -75.5993, -1.31945669720295),
(7543, '18601', 218, 45, 15143, 41.0672, 0.716757854575015, -76.1754, -1.32951153902369),
(7544, '18602', 218, 45, 53, 41.1852, 0.718817343092369, -75.7475, -1.3220432751544),
(7545, '18603', 218, 45, 400, 41.0579, 0.71659553895458, -76.248, -1.33077864806064),
(7546, '18610', 218, 45, 147237, 41.0994, 0.717319850594157, -75.5691, -1.31892960776885),
(7547, '18611', 218, 45, 159754, 41.1986, 0.719051217212136, -76.3061, -1.33179268435605),
(7548, '18612', 218, 45, 1953, 41.3331, 0.721398685056068, -75.9618, -1.32578351574143),
(7549, '18614', 218, 45, 160976, 41.5246, 0.724740990573637, -76.3988, -1.33341060457264),
(7550, '18615', 218, 45, 64659, 41.447, 0.72338661507409, -75.8556, -1.32392997607581),
(7551, '18616', 218, 45, 40966, 41.5143, 0.724561221660682, -76.5948, -1.33683144990655),
(7552, '18617', 218, 45, 162092, 41.174, 0.718621866216145, -76.0744, -1.32774875647917),
(7553, '18618', 218, 45, 162492, 41.3413, 0.721541802054732, -76.0202, -1.32680278802459),
(7554, '18619', 218, 45, 162715, 41.4339, 0.723157976942079, -76.7107, -1.33885428650961),
(7555, '18621', 218, 45, 162921, 41.2247, 0.719506748146906, -76.0132, -1.32668061497695),
(7556, '18622', 218, 45, 162934, 41.1991, 0.719059943858396, -76.1988, -1.32991994606866),
(7557, '18623', 218, 45, 163479, 41.6755, 0.727374692414897, -76.1371, -1.32884307792017),
(7558, '18624', 218, 45, 163509, 41.0602, 0.716635681527376, -75.6071, -1.3195928328846),
(7559, '18625', 218, 45, 163512, 41.5145, 0.724564712319186, -75.8413, -1.32368039399278),
(7560, '18626', 218, 45, 122986, 41.4238, 0.722981698687627, -76.4943, -1.3350773940083),
(7561, '18627', 218, 45, 78603, 41.3166, 0.721110705729489, -76.0227, -1.32684642125589),
(7562, '18628', 218, 45, 55996, 41.4573, 0.723566383987045, -76.2953, -1.33160418879683),
(7563, '18629', 218, 45, 164456, 41.4924, 0.724178994554495, -76.1559, -1.32917119981955),
(7564, '18630', 218, 45, 164490, 41.6503, 0.726934869443394, -76.0261, -1.32690576245046),
(7565, '18631', 218, 45, 156490, 41.0303, 0.716113828081029, -76.3056, -1.33178395770979),
(7566, '18632', 218, 45, 17129, 41.4703, 0.723793276789804, -76.3793, -1.3330702653685),
(7567, '18634', 218, 45, 49742, 41.1984, 0.719047726553632, -76.0041, -1.32652179001502),
(7568, '18635', 218, 45, 165059, 41.0519, 0.71649081919946, -76.216, -1.3302201427),
(7569, '18636', 218, 45, 165402, 41.4174, 0.722869997615499, -76.0765, -1.32778540839347),
(7570, '18640', 218, 45, 128551, 41.3178, 0.721131649680513, -75.7914, -1.32280947469603),
(7571, '18641', 218, 45, 128551, 41.3301, 0.721346325178508, -75.7457, -1.32201185922787),
(7572, '18642', 218, 45, 160974, 41.3472, 0.721644776480599, -75.7648, -1.322345217115),
(7573, '18643', 218, 45, 128551, 41.3296, 0.721337598532248, -75.8138, -1.32320042844848),
(7574, '18644', 218, 45, 14923, 41.3179, 0.721133395009765, -75.8561, -1.32393870272207),
(7575, '18651', 218, 45, 14433, 41.2444, 0.719850578009549, -75.9467, -1.32551997102438),
(7576, '18653', 218, 45, 33721, 41.3944, 0.722468571887541, -75.8219, -1.32334180011789),
(7577, '18654', 218, 45, 167069, 41.3496, 0.721686664382647, -76.0495, -1.32731416949543),
(7578, '18655', 218, 45, 167120, 41.1524, 0.718244875097715, -76.1449, -1.32897921360183),
(7579, '18656', 218, 45, 167816, 41.327, 0.721292219971697, -76.1592, -1.32922879568487),
(7580, '18657', 218, 45, 168093, 41.5425, 0.725053404509744, -75.9486, -1.32555313228017),
(7581, '18660', 218, 45, 168480, 41.1612, 0.71839846407189, -76.0113, -1.32664745372117),
(7582, '18661', 218, 45, 91817, 41.0644, 0.716708985355959, -75.7857, -1.32270999092867),
(7583, '18690', 218, 45, 1953, 41.3381, 0.721485951518668, -75.9679, -1.3258899808258),
(7584, '18701', 218, 45, 0, 41.2444, 0.719850578009549, -75.8846, -1.32443612155889),
(7585, '18702', 218, 45, 0, 41.2364, 0.71971095166939, -75.8788, -1.32433489246227),
(7586, '18703', 218, 45, 0, 41.2436, 0.719836615375533, -75.8862, -1.32446404682692),
(7587, '18704', 218, 45, 3542, 41.2751, 0.720386394089912, -75.8947, -1.32461239981334),
(7588, '18705', 218, 45, 0, 41.2695, 0.7202886556518, -75.8475, -1.3237886044064),
(7589, '18706', 218, 45, 0, 41.2071, 0.719199570198555, -75.9235, -1.32511505463791),
(7590, '18707', 218, 45, 10681, 41.1439, 0.718096522111295, -75.9232, -1.32510981865016),
(7591, '18708', 218, 45, 106169, 41.3079, 0.720958862084566, -75.9446, -1.32548331911009),
(7592, '18709', 218, 45, 37003, 41.2843, 0.720546964381095, -75.8944, -1.32460716382558),
(7593, '18710', 218, 45, 0, 41.2482, 0.719916900521125, -75.8802, -1.3243593270718),
(7594, '18711', 218, 45, 0, 41.2485, 0.719922136508881, -75.8808, -1.32436979904731),
(7595, '18761', 218, 45, 0, 41.2433, 0.719831379387777, -75.8854, -1.32445008419291),
(7596, '18762', 218, 45, 0, 41.2357, 0.719698734364626, -75.8987, -1.32468221298342),
(7597, '18763', 218, 45, 0, 41.2454, 0.719868031302069, -75.8892, -1.32451640670448),
(7598, '18764', 218, 45, 0, 41.2199, 0.719422972342811, -75.7941, -1.32285659858583),
(7599, '18765', 218, 45, 0, 41.2197, 0.719419481684307, -75.7937, -1.32284961726883),
(7600, '18766', 218, 45, 0, 41.2449, 0.719859304655809, -75.8822, -1.32439423365684),
(7601, '18767', 218, 45, 0, 41.2506, 0.719958788423173, -75.8741, -1.32425286198743);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(7602, '18768', 218, 45, 0, 41.2468, 0.719892465911597, -75.8821, -1.32439248832759),
(7603, '18769', 218, 45, 0, 41.2539, 0.720016384288489, -75.8685, -1.32415512354932),
(7604, '18773', 218, 45, 0, 41.2466, 0.719888975253093, -75.8863, -1.32446579215617),
(7605, '18774', 218, 45, 0, 41.2412, 0.719794727473485, -75.8909, -1.32454607730176),
(7606, '18801', 218, 45, 4299, 41.8325, 0.730114859340528, -75.877, -1.32430347653574),
(7607, '18810', 218, 45, 7182, 41.9632, 0.732396004672884, -76.5228, -1.33557481284512),
(7608, '18812', 218, 45, 159437, 41.9552, 0.732256378332725, -75.9273, -1.32518137714949),
(7609, '18813', 218, 45, 1157, 41.7515, 0.728701142646413, -75.8068, -1.32307825540084),
(7610, '18814', 218, 45, 1239, 41.7798, 0.729195070824727, -76.6079, -1.33706008803856),
(7611, '18815', 218, 45, 159778, 41.7311, 0.728345095479006, -76.235, -1.33055175525788),
(7612, '18816', 218, 45, 160806, 41.7466, 0.728615621513065, -75.8991, -1.32468919430043),
(7613, '18817', 218, 45, 161130, 41.8586, 0.730570390275298, -76.6146, -1.33717702509845),
(7614, '18818', 218, 45, 27220, 41.9055, 0.731388949694484, -76.0462, -1.32725657363011),
(7615, '18820', 218, 45, 2709, 41.8034, 0.729606968528198, -75.6444, -1.3202438406956),
(7616, '18821', 218, 45, 32614, 41.9733, 0.732572282927336, -75.7455, -1.32200836856937),
(7617, '18822', 218, 45, 162379, 41.9636, 0.732402985989893, -75.7481, -1.32205374712992),
(7618, '18823', 218, 45, 149462, 41.7777, 0.729158418910435, -75.6802, -1.32086866856781),
(7619, '18824', 218, 45, 162825, 41.6947, 0.72770979563128, -75.8048, -1.3230433488158),
(7620, '18825', 218, 45, 3384, 41.8702, 0.73077284846853, -75.6107, -1.31965566473768),
(7621, '18826', 218, 45, 16734, 41.7684, 0.72899610329, -75.7822, -1.32264890440485),
(7622, '18827', 218, 45, 116400, 41.9571, 0.732289539588513, -75.5863, -1.31922980440019),
(7623, '18828', 218, 45, 22591, 41.7639, 0.72891756347366, -76.097, -1.32814320089012),
(7624, '18829', 218, 45, 163660, 41.845, 0.730333025497027, -76.1756, -1.32951502968219),
(7625, '18830', 218, 45, 163868, 41.9613, 0.732362843417097, -76.1064, -1.32830726183981),
(7626, '18831', 218, 45, 23084, 41.8969, 0.731238851378812, -76.5361, -1.33580694163563),
(7627, '18832', 218, 45, 4272, 41.7113, 0.727999520287111, -76.4743, -1.3347283281579),
(7628, '18833', 218, 45, 30614, 41.6013, 0.726079658109917, -76.4426, -1.33417505878502),
(7629, '18834', 218, 45, 113788, 41.8765, 0.730882804211405, -75.7268, -1.32168199199924),
(7630, '18837', 218, 45, 490, 41.8717, 0.73079902840731, -76.2962, -1.3316198967601),
(7631, '18839', 218, 45, 31020, 41.7754, 0.729118276337639, -76.0491, -1.32730718817842),
(7632, '18840', 218, 45, 5677, 41.9852, 0.732779977108323, -76.5279, -1.33566382463697),
(7633, '18842', 218, 45, 167365, 41.7531, 0.728729067914444, -75.6031, -1.31952301971452),
(7634, '18843', 218, 45, 167384, 41.7967, 0.729490031468314, -75.8914, -1.32455480394802),
(7635, '18844', 218, 45, 6035, 41.7102, 0.727980321665339, -75.8989, -1.32468570364192),
(7636, '18845', 218, 45, 51694, 41.7723, 0.729064171130827, -76.1694, -1.32940681926857),
(7637, '18846', 218, 45, 167719, 41.5948, 0.725966211708537, -76.2671, -1.33111200594777),
(7638, '18847', 218, 45, 167791, 41.9469, 0.732111516004809, -75.603, -1.31952127438527),
(7639, '18848', 218, 45, 34149, 41.7724, 0.729065916460079, -76.4484, -1.33427628788163),
(7640, '18850', 218, 45, 168160, 41.842, 0.730280665619467, -76.4746, -1.33473356414566),
(7641, '18851', 218, 45, 168491, 41.9469, 0.732111516004809, -76.1977, -1.32990074744688),
(7642, '18853', 218, 45, 169158, 41.6673, 0.727231575416233, -76.2621, -1.33102473948517),
(7643, '18854', 218, 45, 38984, 41.7856, 0.729296299921343, -76.3599, -1.33273167149362),
(7644, '18901', 218, 45, 8586, 40.3171, 0.703666139855806, -75.1196, -1.31108435278113),
(7645, '18910', 218, 45, 144809, 40.4256, 0.70555982209422, -75.1794, -1.31212805967383),
(7646, '18911', 218, 45, 159312, 40.3727, 0.704636542919915, -75.2538, -1.31342658463731),
(7647, '18912', 218, 45, 793, 40.2969, 0.703313583346903, -75.0579, -1.31000748463265),
(7648, '18913', 218, 45, 159845, 40.3825, 0.70480758518661, -75.0436, -1.30975790254962),
(7649, '18914', 218, 45, 159958, 40.2831, 0.703072727910128, -75.1967, -1.31243000163442),
(7650, '18915', 218, 45, 35330, 40.26, 0.702669556852917, -75.248, -1.31332535554069),
(7651, '18916', 218, 45, 160647, 40.3596, 0.704407904787903, -75.1391, -1.31142469198527),
(7652, '18917', 218, 45, 2113, 40.3727, 0.704636542919915, -75.2, -1.31248759749974),
(7653, '18918', 218, 45, 35678, 40.321, 0.703734207696634, -75.3804, -1.31563617147033),
(7654, '18920', 218, 45, 161410, 40.4921, 0.706720466046796, -75.0785, -1.31036702245856),
(7655, '18921', 218, 45, 8879, 40.5339, 0.70745001367413, -75.1787, -1.31211584236906),
(7656, '18922', 218, 45, 8927, 40.2977, 0.703327545980919, -75.0569, -1.30999003134013),
(7657, '18923', 218, 45, 21252, 40.2421, 0.70235714291681, -75.0161, -1.30927793700532),
(7658, '18924', 218, 45, 102096, 40.3018, 0.703399104480251, -75.3281, -1.31472336427154),
(7659, '18925', 218, 45, 161933, 40.2787, 0.70299593342304, -75.0651, -1.3101331483388),
(7660, '18926', 218, 45, 16178, 40.3814, 0.704788386564838, -75.0933, -1.31062533118786),
(7661, '18927', 218, 45, 30086, 40.3203, 0.70372199039187, -75.2461, -1.31329219428491),
(7662, '18928', 218, 45, 162754, 40.336, 0.703996007084433, -75.0471, -1.30981898907344),
(7663, '18929', 218, 45, 81769, 40.2524, 0.702536911829766, -75.0851, -1.31048221418919),
(7664, '18930', 218, 45, 163363, 40.5086, 0.707008445373375, -75.2381, -1.31315256794475),
(7665, '18931', 218, 45, 163496, 40.3558, 0.704341582276328, -75.0428, -1.3097439399156),
(7666, '18932', 218, 45, 163836, 40.2941, 0.703264714127847, -75.259, -1.31351734175841),
(7667, '18933', 218, 45, 164059, 40.3758, 0.704690648126726, -75.0274, -1.30947515921079),
(7668, '18934', 218, 45, 4145, 40.3468, 0.704184502643648, -75.0703, -1.3102239054599),
(7669, '18935', 218, 45, 164569, 40.4331, 0.705690721788119, -75.3973, -1.31593113211392),
(7670, '18936', 218, 45, 164741, 40.2485, 0.702468843988938, -75.2436, -1.31324856105361),
(7671, '18938', 218, 45, 254, 40.3547, 0.704322383654556, -74.993, -1.30887476594811),
(7672, '18940', 218, 45, 839, 40.2464, 0.702432192074646, -74.9432, -1.30800559198061),
(7673, '18942', 218, 45, 165609, 40.4631, 0.706214320563717, -75.161, -1.31180691909146),
(7674, '18943', 218, 45, 165817, 40.2631, 0.702723662059729, -74.996, -1.30892712582567),
(7675, '18944', 218, 45, 165839, 40.3692, 0.704575456396095, -75.2556, -1.31345800056384),
(7676, '18946', 218, 45, 5077, 40.2949, 0.703278676761863, -75.0129, -1.30922208646925),
(7677, '18947', 218, 45, 165984, 40.4166, 0.70540274246154, -75.1173, -1.31104421020834),
(7678, '18949', 218, 45, 166068, 40.3807, 0.704776169260074, -75.1439, -1.31150846778937),
(7679, '18950', 218, 45, 17683, 40.4119, 0.705320711986697, -75.067, -1.31016630959458),
(7680, '18951', 218, 45, 14457, 40.4452, 0.705901906627611, -75.3545, -1.31518413119407),
(7681, '18953', 218, 45, 68172, 40.5158, 0.707134109079519, -75.1618, -1.31182088172547),
(7682, '18954', 218, 45, 166442, 40.2152, 0.701887649348024, -75.0027, -1.30904406288555),
(7683, '18955', 218, 45, 166455, 40.475, 0.706422014744705, -75.3221, -1.31461864451642),
(7684, '18956', 218, 45, 166741, 40.2635, 0.702730643376737, -75.0279, -1.30948388585705),
(7685, '18957', 218, 45, 166826, 40.2983, 0.703338017956431, -75.4535, -1.31691200715354),
(7686, '18958', 218, 45, 166828, 40.295, 0.703280422091115, -75.4381, -1.31664322644873),
(7687, '18960', 218, 45, 5730, 40.3525, 0.704283986411012, -75.2976, -1.31419103884968),
(7688, '18962', 218, 45, 31129, 40.347, 0.704187993302152, -75.2701, -1.31371107330538),
(7689, '18963', 218, 45, 167317, 40.3827, 0.704811075845114, -75.0141, -1.30924303042028),
(7690, '18964', 218, 45, 167335, 40.3018, 0.703399104480251, -75.3253, -1.31467449505248),
(7691, '18966', 218, 45, 51571, 40.1897, 0.701442590388765, -75.0032, -1.30905278953181),
(7692, '18968', 218, 45, 167454, 40.4428, 0.705860018725563, -75.4394, -1.31666591572901),
(7693, '18969', 218, 45, 91264, 40.3211, 0.703735953025886, -75.3618, -1.31531154022946),
(7694, '18970', 218, 45, 168081, 40.413, 0.705339910608468, -75.3792, -1.31561522751931),
(7695, '18971', 218, 45, 168148, 40.4066, 0.705228209536341, -75.3957, -1.31590320684589),
(7696, '18972', 218, 45, 168223, 40.5373, 0.707509354868697, -75.1268, -1.31121001648728),
(7697, '18974', 218, 45, 107289, 40.2075, 0.70175325899562, -75.08, -1.31039320239734),
(7698, '18976', 218, 45, 18499, 40.2405, 0.702329217648778, -75.131, -1.31128332031586),
(7699, '18977', 218, 45, 146563, 40.2927, 0.703240279518319, -74.884, -1.30697235706343),
(7700, '18979', 218, 45, 169147, 40.3142, 0.703615525307498, -75.4562, -1.31695913104335),
(7701, '18980', 218, 45, 169163, 40.2733, 0.702901685643432, -75.0212, -1.30936694879717),
(7702, '18981', 218, 45, 169241, 40.4841, 0.706580839706636, -75.3947, -1.31588575355337),
(7703, '18991', 218, 45, 107289, 40.2182, 0.701940009225584, -75.0734, -1.31027801066671),
(7704, '19001', 218, 45, 29060, 40.1276, 0.700358740923277, -75.1285, -1.31123968708456),
(7705, '19002', 218, 45, 122135, 40.1668, 0.701042909990058, -75.2069, -1.31260802521812),
(7706, '19003', 218, 45, 18903, 39.9946, 0.698037453018124, -75.3024, -1.31427481465378),
(7707, '19004', 218, 45, 0, 40.0125, 0.698349866954231, -75.2332, -1.3130670468114),
(7708, '19006', 218, 45, 162929, 40.1277, 0.700360486252529, -75.0624, -1.31008602444899),
(7709, '19007', 218, 45, 15330, 40.1119, 0.700084724230713, -74.8619, -1.30658663929874),
(7710, '19008', 218, 45, 77930, 39.9729, 0.697658716570441, -75.359, -1.31526267101041),
(7711, '19009', 218, 45, 159613, 40.1338, 0.7004669513369, -75.0634, -1.31010347774151),
(7712, '19010', 218, 45, 19614, 40.0146, 0.698386518868523, -75.3406, -1.31494153042804),
(7713, '19012', 218, 45, 45665, 40.0596, 0.699171917031921, -75.1054, -1.31083651602735),
(7714, '19013', 218, 45, 8056, 39.8474, 0.695468328359188, -75.3762, -1.31556286764175),
(7715, '19014', 218, 45, 0, 39.8642, 0.695761543673524, -75.4337, -1.31656643196165),
(7716, '19015', 218, 45, 13445, 39.8668, 0.695806922234075, -75.3869, -1.31574961787171),
(7717, '19016', 218, 45, 8056, 39.845, 0.695426440457141, -75.3723, -1.31549479980092),
(7718, '19017', 218, 45, 78022, 39.8899, 0.696210093291286, -75.4714, -1.31722442108965),
(7719, '19018', 218, 45, 54104, 39.9215, 0.696761617334916, -75.3009, -1.314248634715),
(7720, '19019', 218, 45, 4983, 40.1164, 0.700163264047053, -75.0144, -1.30924826640803),
(7721, '19020', 218, 45, 159130, 40.106, 0.699981749804846, -74.9285, -1.30774902858057),
(7722, '19021', 218, 45, 143681, 40.0909, 0.699718205087795, -74.8995, -1.30724288309749),
(7723, '19022', 218, 45, 78101, 39.8676, 0.695820884868091, -75.3393, -1.31491884114776),
(7724, '19023', 218, 45, 15733, 39.9182, 0.6967040214696, -75.2708, -1.31372329061015),
(7725, '19025', 218, 45, 160901, 40.1383, 0.70054549115324, -75.2227, -1.31288378723994),
(7726, '19026', 218, 45, 78143, 39.9493, 0.697246818866971, -75.3054, -1.31432717453134),
(7727, '19027', 218, 45, 8725, 40.0208, 0.698494729282147, -75.137, -1.31138804007098),
(7728, '19028', 218, 45, 2222, 39.979, 0.697765181654813, -75.4539, -1.31691898847055),
(7729, '19029', 218, 45, 78220, 39.8667, 0.695805176904823, -75.2954, -1.31415264160614),
(7730, '19030', 218, 45, 161485, 40.1754, 0.70119300830573, -74.846, -1.30630913194768),
(7731, '19031', 218, 45, 161694, 40.1067, 0.69999396710961, -75.2129, -1.31271274497324),
(7732, '19032', 218, 45, 78284, 39.895, 0.696299105083138, -75.2791, -1.31386815293806),
(7733, '19033', 218, 45, 2511, 39.891, 0.696229291913058, -75.3285, -1.31473034558855),
(7734, '19034', 218, 45, 47163, 40.1352, 0.700491385946428, -75.2077, -1.31262198785214),
(7735, '19035', 218, 45, 162068, 40.0462, 0.698938042912153, -75.2858, -1.31398508999795),
(7736, '19036', 218, 45, 78357, 39.9031, 0.696440476752549, -75.2939, -1.31412646166736),
(7737, '19037', 218, 45, 0, 39.9036, 0.696449203398809, -75.4443, -1.31675143686236),
(7738, '19038', 218, 45, 70871, 40.1003, 0.699882266037482, -75.169, -1.31194654543162),
(7739, '19039', 218, 45, 36151, 39.9384, 0.697056577978503, -75.4643, -1.31710050271276),
(7740, '19040', 218, 45, 162502, 40.1759, 0.70120173495199, -75.107, -1.31086444129538),
(7741, '19041', 218, 45, 13902, 40.029, 0.69863784628081, -75.2995, -1.31422420010547),
(7742, '19043', 218, 45, 36475, 39.9003, 0.696391607533494, -75.3097, -1.31440222368917),
(7743, '19044', 218, 45, 162851, 40.1818, 0.701304709377858, -75.1513, -1.31163762215401),
(7744, '19046', 218, 45, 163132, 40.1021, 0.699913681964018, -75.1112, -1.31093774512396),
(7745, '19047', 218, 45, 163569, 40.1648, 0.701008003405018, -74.9424, -1.3079916293466),
(7746, '19048', 218, 45, 47163, 40.1741, 0.701170319025454, -74.9234, -1.30766001678872),
(7747, '19049', 218, 45, 47163, 40.1773, 0.701226169561518, -74.9198, -1.30759718493565),
(7748, '19050', 218, 45, 22564, 39.9378, 0.697046106002991, -75.2728, -1.31375819719519),
(7749, '19052', 218, 45, 78612, 39.8953, 0.696304341070894, -75.4463, -1.3167863434474),
(7750, '19053', 218, 45, 0, 40.1529, 0.700800309224031, -74.982, -1.30868277973039),
(7751, '19054', 218, 45, 150238, 40.1688, 0.701077816575098, -74.8223, -1.30589548891495),
(7752, '19055', 218, 45, 150238, 40.1476, 0.700707806773675, -74.8372, -1.3061555429735),
(7753, '19056', 218, 45, 150238, 40.1498, 0.700746204017219, -74.8857, -1.30700202766072),
(7754, '19057', 218, 45, 150238, 40.1425, 0.700618794981824, -74.8595, -1.3065447513967),
(7755, '19058', 218, 45, 150238, 40.1532, 0.700805545211787, -74.853, -1.30643130499532),
(7756, '19059', 218, 45, 150238, 40.1551, 0.700838706467575, -74.8772, -1.3068536746743),
(7757, '19061', 218, 45, 78678, 39.8348, 0.695248416873437, -75.4497, -1.31684568464197),
(7758, '19063', 218, 45, 4146, 39.9166, 0.696676096201569, -75.4103, -1.31615802491668),
(7759, '19064', 218, 45, 349, 39.9298, 0.696906479662832, -75.3377, -1.31489091587973),
(7760, '19065', 218, 45, 4146, 39.9176, 0.696693549494088, -75.3908, -1.31581768571254),
(7761, '19066', 218, 45, 0, 40.0024, 0.69817358869978, -75.2507, -1.3133724794305),
(7762, '19067', 218, 45, 4337, 40.1935, 0.701508912900341, -74.7691, -1.30496697375289),
(7763, '19070', 218, 45, 10614, 39.9067, 0.696503308605621, -75.3236, -1.3146448244552),
(7764, '19072', 218, 45, 165016, 40.0162, 0.698414444136555, -75.2603, -1.31354003103869),
(7765, '19073', 218, 45, 49811, 39.9839, 0.697850702788161, -75.4141, -1.31622434742826),
(7766, '19074', 218, 45, 4648, 39.8882, 0.696180422694002, -75.2981, -1.31419976549594),
(7767, '19075', 218, 45, 137287, 40.1134, 0.700110904169493, -75.1869, -1.31225895936772),
(7768, '19076', 218, 45, 33698, 39.8848, 0.696121081499434, -75.3081, -1.31437429842114),
(7769, '19078', 218, 45, 79028, 39.8784, 0.696009380427307, -75.3227, -1.31462911649193),
(7770, '19079', 218, 45, 51345, 39.9031, 0.696440476752549, -75.2701, -1.31371107330538),
(7771, '19080', 218, 45, 6665, 40.0436, 0.698892664351601, -75.3884, -1.31577579781049),
(7772, '19081', 218, 45, 79242, 39.8968, 0.696330521009674, -75.3448, -1.31501483425662),
(7773, '19082', 218, 45, 79303, 39.9583, 0.69740389849965, -75.2735, -1.31377041449995),
(7774, '19083', 218, 45, 78436, 39.9767, 0.697725039082017, -75.3105, -1.31441618632319),
(7775, '19085', 218, 45, 62175, 40.0259, 0.698583741073998, -75.3652, -1.31537088142403),
(7776, '19086', 218, 45, 38730, 39.89, 0.696211838620538, -75.3703, -1.31545989321588),
(7777, '19087', 218, 45, 6665, 40.0367, 0.698772236633214, -75.3804, -1.31563617147033),
(7778, '19088', 218, 45, 6665, 40.0465, 0.698943278899909, -75.3571, -1.31522950975462),
(7779, '19089', 218, 45, 6665, 40.044, 0.698899645668609, -75.3874, -1.31575834451797),
(7780, '19090', 218, 45, 14867, 40.1449, 0.700660682883872, -75.1227, -1.31113845798794),
(7781, '19091', 218, 45, 4146, 39.9191, 0.696719729432868, -75.3888, -1.3157827791275),
(7782, '19092', 218, 45, 4983, 39.9545, 0.697337575988074, -75.1835, -1.31219961817316),
(7783, '19093', 218, 45, 4983, 39.9544, 0.697335830658822, -75.1827, -1.31218565553914),
(7784, '19094', 218, 45, 74879, 39.8754, 0.695957020549747, -75.3462, -1.31503926886615),
(7785, '19095', 218, 45, 169168, 40.0869, 0.699648391917715, -75.1507, -1.3116271501785),
(7786, '19096', 218, 45, 14922, 40.0021, 0.698168352712024, -75.2727, -1.31375645186594),
(7787, '19098', 218, 45, 36475, 39.9041, 0.696457930045069, -75.3093, -1.31439524237217),
(7788, '19099', 218, 45, 4983, 39.9522, 0.697297433415279, -75.164, -1.31185927896902),
(7789, '19101', 218, 45, 4983, 40.0071, 0.698255619174623, -75.1347, -1.31134789749818),
(7790, '19102', 218, 45, 4983, 39.9541, 0.697330594671066, -75.1647, -1.31187149627378),
(7791, '19103', 218, 45, 4983, 39.9623, 0.69747371166973, -75.1997, -1.31248236151198),
(7792, '19104', 218, 45, 4983, 39.9615, 0.697459749035714, -75.1994, -1.31247712552422),
(7793, '19105', 218, 45, 4983, 39.9535, 0.697320122695554, -75.1551, -1.31170394466559),
(7794, '19106', 218, 45, 4983, 39.9503, 0.697264272159491, -75.1476, -1.31157304497169),
(7795, '19107', 218, 45, 4983, 39.9513, 0.697281725452011, -75.1585, -1.31176328586016),
(7796, '19108', 218, 45, 4983, 40.0592, 0.699164935714912, -75.2023, -1.31252774007253),
(7797, '19109', 218, 45, 4983, 39.9517, 0.697288706769019, -75.1586, -1.31176503118941),
(7798, '19110', 218, 45, 4983, 39.9529, 0.697309650720042, -75.1649, -1.31187498693229),
(7799, '19111', 218, 45, 4983, 40.0581, 0.699145737093141, -75.0821, -1.31042985431163),
(7800, '19112', 218, 45, 4983, 39.8913, 0.696234527900814, -75.1796, -1.31213155033233),
(7801, '19113', 218, 45, 4983, 39.8694, 0.695852300794627, -75.2868, -1.31400254329047),
(7802, '19114', 218, 45, 4983, 40.0629, 0.699229512897236, -75.0007, -1.30900915630051),
(7803, '19115', 218, 45, 4983, 40.092, 0.699737403709567, -75.0422, -1.30973346794009),
(7804, '19116', 218, 45, 4983, 40.1182, 0.700194679973589, -75.0165, -1.30928491832233),
(7805, '19118', 218, 45, 4983, 40.0888, 0.699681553173503, -75.1953, -1.31240556702489),
(7806, '19119', 218, 45, 4983, 40.072, 0.699388337859168, -75.2112, -1.31268307437596),
(7807, '19120', 218, 45, 4983, 40.0329, 0.698705914121638, -75.1196, -1.31108435278113),
(7808, '19121', 218, 45, 4983, 39.9804, 0.697789616264341, -75.1728, -1.31201286794319),
(7809, '19122', 218, 45, 4983, 39.9768, 0.697726784411269, -75.1462, -1.31154861036216),
(7810, '19123', 218, 45, 4983, 39.9642, 0.697506872925518, -75.1485, -1.31158875293496),
(7811, '19124', 218, 45, 4983, 40.0164, 0.698417934795059, -75.0969, -1.31068816304093),
(7812, '19125', 218, 45, 4983, 39.9766, 0.697723293752765, -75.1253, -1.3111838365485),
(7813, '19126', 218, 45, 4983, 40.0537, 0.699068942606053, -75.1378, -1.311402002705),
(7814, '19127', 218, 45, 4983, 40.027, 0.69860293969577, -75.223, -1.31288902322769),
(7815, '19128', 218, 45, 4983, 40.0418, 0.698861248425065, -75.2257, -1.3129361471175),
(7816, '19129', 218, 45, 4983, 40.011, 0.698323687015451, -75.1841, -1.31221009014867),
(7817, '19130', 218, 45, 4983, 39.9681, 0.697574940766346, -75.1735, -1.31202508524796),
(7818, '19131', 218, 45, 4983, 39.9821, 0.697819286861625, -75.2183, -1.31280699275285),
(7819, '19132', 218, 45, 4983, 39.9959, 0.6980601422984, -75.1678, -1.31192560148059),
(7820, '19133', 218, 45, 4983, 39.9926, 0.698002546433084, -75.1417, -1.31147007054582),
(7821, '19134', 218, 45, 4983, 39.9911, 0.697976366494304, -75.1112, -1.31093774512396),
(7822, '19135', 218, 45, 4983, 40.0246, 0.698561051793722, -75.0499, -1.30986785829249),
(7823, '19136', 218, 45, 4983, 40.0431, 0.698883937705341, -75.0248, -1.30942978065024),
(7824, '19137', 218, 45, 4983, 39.9958, 0.698058396969148, -75.0989, -1.31072306962597),
(7825, '19138', 218, 45, 4983, 40.0558, 0.699105594520345, -75.1599, -1.31178772046969),
(7826, '19139', 218, 45, 4983, 39.9621, 0.697470221011226, -75.2302, -1.31301468693384),
(7827, '19140', 218, 45, 4983, 40.0124, 0.698348121624979, -75.1436, -1.31150323180161),
(7828, '19141', 218, 45, 4983, 40.0365, 0.69876874597471, -75.1455, -1.3115363930574),
(7829, '19142', 218, 45, 4983, 39.9215, 0.696761617334916, -75.2345, -1.31308973609167),
(7830, '19143', 218, 45, 4983, 39.9437, 0.697149080428859, -75.2284, -1.3129832710073),
(7831, '19144', 218, 45, 4983, 40.0336, 0.698718131426402, -75.1749, -1.31204951985749),
(7832, '19145', 218, 45, 4983, 39.9221, 0.696772089310428, -75.1847, -1.31222056212418),
(7833, '19146', 218, 45, 4983, 39.9384, 0.697056577978503, -75.1831, -1.31219263685615),
(7834, '19147', 218, 45, 4983, 39.9369, 0.697030398039723, -75.1553, -1.31170743532409),
(7835, '19148', 218, 45, 4983, 39.9197, 0.69673020140838, -75.1572, -1.31174059657988),
(7836, '19149', 218, 45, 4983, 40.0369, 0.698775727291718, -75.0676, -1.3101767815701),
(7837, '19150', 218, 45, 4983, 40.0723, 0.699393573846924, -75.1719, -1.31199715997993),
(7838, '19151', 218, 45, 4983, 39.9757, 0.697707585789497, -75.2543, -1.31343531128357),
(7839, '19152', 218, 45, 4983, 40.0569, 0.699124793142117, -75.047, -1.30981724374418),
(7840, '19153', 218, 45, 4983, 39.8867, 0.696154242755222, -75.2305, -1.31301992292159),
(7841, '19154', 218, 45, 4983, 40.0885, 0.699676317185747, -74.9841, -1.30871943164468),
(7842, '19155', 218, 45, 4983, 40.096, 0.699807216879646, -74.9791, -1.30863216518208),
(7843, '19160', 218, 45, 4983, 40.0124, 0.698348121624979, -75.1463, -1.31155035569141),
(7844, '19161', 218, 45, 4983, 40.062, 0.699213804933968, -75.0799, -1.31039145706809),
(7845, '19162', 218, 45, 4983, 39.9551, 0.697348047963586, -75.1825, -1.31218216488064),
(7846, '19170', 218, 45, 4983, 39.9548, 0.69734281197583, -75.1825, -1.31218216488064),
(7847, '19171', 218, 45, 4983, 39.9534, 0.697318377366303, -75.156, -1.31171965262886),
(7848, '19172', 218, 45, 4983, 39.9477, 0.697218893598939, -75.1492, -1.31160097023972),
(7849, '19173', 218, 45, 4983, 39.9531, 0.697313141378547, -75.1695, -1.31195527207788),
(7850, '19175', 218, 45, 4983, 39.9512, 0.697279980122759, -75.1519, -1.31164809412953),
(7851, '19177', 218, 45, 4983, 39.9494, 0.697248564196223, -75.1515, -1.31164111281252),
(7852, '19178', 218, 45, 4983, 39.9541, 0.697330594671066, -75.1828, -1.31218740086839),
(7853, '19179', 218, 45, 4983, 40.0318, 0.698686715499866, -75.1763, -1.31207395446701),
(7854, '19181', 218, 45, 4983, 39.9506, 0.697269508147247, -75.1472, -1.31156606365468),
(7855, '19182', 218, 45, 4983, 39.9487, 0.697236346891459, -75.152, -1.31164983945878),
(7856, '19183', 218, 45, 4983, 39.9531, 0.697313141378547, -75.1709, -1.31197970668741),
(7857, '19184', 218, 45, 4983, 39.9548, 0.69734281197583, -75.1825, -1.31218216488064),
(7858, '19185', 218, 45, 4983, 39.8898, 0.696208347962034, -75.17, -1.31196399872414),
(7859, '19187', 218, 45, 4983, 39.953, 0.697311396049294, -75.1665, -1.31190291220032),
(7860, '19188', 218, 45, 4983, 39.9646, 0.697513854242526, -75.1609, -1.31180517376221),
(7861, '19191', 218, 45, 4983, 39.9521, 0.697295688086027, -75.1666, -1.31190465752957),
(7862, '19192', 218, 45, 4983, 39.9545, 0.697337575988074, -75.183, -1.3121908915269),
(7863, '19193', 218, 45, 4983, 39.9545, 0.697337575988074, -75.1827, -1.31218565553914),
(7864, '19194', 218, 45, 4983, 39.9546, 0.697339321317326, -75.1839, -1.31220659949016),
(7865, '19196', 218, 45, 4983, 39.9544, 0.697335830658822, -75.1827, -1.31218565553914),
(7866, '19197', 218, 45, 4983, 39.9543, 0.69733408532957, -75.1829, -1.31218914619764),
(7867, '19244', 218, 45, 4983, 39.9523, 0.697299178744531, -75.1497, -1.31160969688598),
(7868, '19255', 218, 45, 4983, 39.9522, 0.697297433415279, -75.1639, -1.31185753363977),
(7869, '19301', 218, 45, 23730, 40.0413, 0.698852521778806, -75.4863, -1.3174844751482),
(7870, '19310', 218, 45, 77806, 39.9472, 0.697210166952679, -75.9739, -1.32599470058092),
(7871, '19311', 218, 45, 15065, 39.8227, 0.695037232033946, -75.7765, -1.32254942063748),
(7872, '19312', 218, 45, 44793, 40.0332, 0.698711150109394, -75.4613, -1.3170481428352),
(7873, '19316', 218, 45, 159456, 40.0488, 0.698983421472705, -75.8331, -1.32353727699411),
(7874, '19317', 218, 45, 77997, 39.8558, 0.695614936016356, -75.6077, -1.31960330486012),
(7875, '19318', 218, 45, 13522, 39.8569, 0.695634134638128, -75.8214, -1.32333307347163),
(7876, '19319', 218, 45, 78026, 39.9273, 0.696862846431532, -75.5162, -1.31800632859454),
(7877, '19320', 218, 45, 29524, 39.9852, 0.697873392068437, -75.8131, -1.32318821114371),
(7878, '19330', 218, 45, 78049, 39.873, 0.695915132647699, -75.9001, -1.32470664759295),
(7879, '19331', 218, 45, 78065, 39.8818, 0.696068721621875, -75.5199, -1.31807090577687),
(7880, '19333', 218, 45, 13657, 40.0433, 0.698887428363845, -75.4244, -1.31640411634121),
(7881, '19335', 218, 45, 160879, 40.0179, 0.698444114733839, -75.7153, -1.32148127913526),
(7882, '19339', 218, 45, 78065, 39.8996, 0.69637939022873, -75.5078, -1.31785972093737),
(7883, '19340', 218, 45, 78065, 39.8846, 0.69611759084093, -75.5206, -1.31808312308163),
(7884, '19341', 218, 45, 161458, 40.0386, 0.698805397889002, -75.6361, -1.32009897836768),
(7885, '19342', 218, 45, 78349, 39.8944, 0.696288633107626, -75.501, -1.31774103854824),
(7886, '19343', 218, 45, 145306, 40.0939, 0.699770564965355, -75.7498, -1.3220834177272),
(7887, '19344', 218, 45, 162804, 40.0849, 0.699613485332675, -75.8964, -1.32464207041062),
(7888, '19345', 218, 45, 41468, 39.9009, 0.696402079509005, -75.6729, -1.32074125953242),
(7889, '19346', 218, 45, 78547, 39.795, 0.694553775831144, -75.8869, -1.32447626413168),
(7890, '19347', 218, 45, 78548, 39.8862, 0.696145516108962, -75.6456, -1.32026478464662),
(7891, '19348', 218, 45, 78552, 39.8602, 0.695691730503444, -75.7025, -1.32125787699101),
(7892, '19350', 218, 45, 78582, 39.7579, 0.693906258678654, -75.7911, -1.32280423870827),
(7893, '19351', 218, 45, 10065, 39.7229, 0.693295393440456, -75.8752, -1.3242720606092),
(7894, '19352', 218, 45, 0, 39.7716, 0.694145368786177, -75.8928, -1.32457923855755),
(7895, '19353', 218, 45, 163845, 40.0663, 0.699288854091804, -75.665, -1.32060337852151),
(7896, '19354', 218, 45, 164085, 40.0606, 0.69918937032444, -75.7519, -1.32212006964149),
(7897, '19355', 218, 45, 3963, 40.0353, 0.698747802023686, -75.5437, -1.31848629413884),
(7898, '19357', 218, 45, 10443, 39.8534, 0.695573048114308, -75.6412, -1.32018799015953),
(7899, '19358', 218, 45, 78755, 39.9625, 0.697477202328234, -75.8036, -1.32302240486477),
(7900, '19360', 218, 45, 4547, 39.7662, 0.694051121006569, -75.8881, -1.32449720808271),
(7901, '19362', 218, 45, 4651, 39.7552, 0.69385913478885, -76.0698, -1.32766847133358),
(7902, '19363', 218, 45, 4828, 39.7872, 0.694417640149488, -75.9621, -1.32578875172918),
(7903, '19365', 218, 45, 78904, 39.9617, 0.697463239694218, -75.9232, -1.32510981865016),
(7904, '19366', 218, 45, 78963, 39.8998, 0.696382880887233, -75.6263, -1.31992793610099),
(7905, '19367', 218, 45, 33663, 39.9688, 0.69758715807111, -75.9254, -1.3251482158937),
(7906, '19369', 218, 45, 79076, 39.9821, 0.697819286861625, -75.8912, -1.32455131328952),
(7907, '19370', 218, 45, 57715, 39.851, 0.69553116021226, -75.8205, -1.32331736550836),
(7908, '19371', 218, 45, 167780, 40.1001, 0.699878775378978, -75.8787, -1.32433314713302),
(7909, '19372', 218, 45, 6318, 39.9897, 0.697951931884776, -75.7049, -1.32129976489306),
(7910, '19373', 218, 45, 351, 39.9054, 0.696480619325345, -75.536, -1.31835190378644),
(7911, '19374', 218, 45, 79270, 39.8347, 0.695246671544185, -75.7602, -1.32226493196941),
(7912, '19375', 218, 45, 25657, 39.9048, 0.696470147349833, -75.7301, -1.32173958786456),
(7913, '19376', 218, 45, 168412, 40.0218, 0.698512182574667, -75.8242, -1.32338194269068),
(7914, '19380', 218, 45, 79370, 39.9802, 0.697786125605837, -75.6032, -1.31952476504378),
(7915, '19381', 218, 45, 79370, 39.9611, 0.697452767718706, -75.6041, -1.31954047300705),
(7916, '19382', 218, 45, 79370, 39.9429, 0.697135117794843, -75.5955, -1.31939037469137),
(7917, '19383', 218, 45, 79370, 39.9599, 0.697431823767682, -75.6059, -1.31957188893358),
(7918, '19390', 218, 45, 31491, 39.8241, 0.695061666643474, -75.8409, -1.32367341267577),
(7919, '19395', 218, 45, 79401, 39.9372, 0.697035634027479, -75.5439, -1.31848978479734),
(7920, '19397', 218, 45, 0, 39.9852, 0.697873392068437, -75.5106, -1.31790859015643),
(7921, '19398', 218, 45, 0, 39.8481, 0.695480545663952, -75.7018, -1.32124565968624),
(7922, '19399', 218, 45, 0, 39.9853, 0.697875137397689, -75.5112, -1.31791906213194),
(7923, '19401', 218, 45, 23403, 40.1284, 0.700372703557293, -75.3381, -1.31489789719674),
(7924, '19403', 218, 45, 23403, 40.146, 0.700679881505644, -75.3714, -1.31547909183765),
(7925, '19404', 218, 45, 23403, 40.1426, 0.700620540311076, -75.37, -1.31545465722813),
(7926, '19405', 218, 45, 1130, 40.1088, 0.700030619023902, -75.3413, -1.3149537477328),
(7927, '19406', 218, 45, 163345, 40.0935, 0.699763583648346, -75.3691, -1.31543894926486),
(7928, '19407', 218, 45, 15055, 40.1159, 0.700154537400793, -75.446, -1.31678110745964),
(7929, '19408', 218, 45, 86657, 40.1548, 0.700833470479819, -75.4134, -1.31621213012349),
(7930, '19409', 218, 45, 161514, 40.1581, 0.700891066345135, -75.3873, -1.31575659918872),
(7931, '19415', 218, 45, 86657, 40.159, 0.700906774308403, -75.4091, -1.31613708096566),
(7932, '19420', 218, 45, 18900, 40.1522, 0.700788091919267, -75.457, -1.31697309367736),
(7933, '19421', 218, 45, 159234, 40.1063, 0.699986985792602, -75.6422, -1.32020544345205),
(7934, '19422', 218, 45, 70556, 40.1539, 0.700817762516551, -75.2771, -1.31383324635302),
(7935, '19423', 218, 45, 13510, 40.2146, 0.701877177372512, -75.3757, -1.31555414099549),
(7936, '19424', 218, 45, 70556, 40.1459, 0.700678136176392, -75.2673, -1.31366220408633),
(7937, '19425', 218, 45, 160040, 40.0919, 0.699735658380315, -75.6354, -1.32008676106292),
(7938, '19426', 218, 45, 8182, 40.1885, 0.701421646437741, -75.4402, -1.31667987836303),
(7939, '19428', 218, 45, 160368, 40.0788, 0.699507020248303, -75.3056, -1.31433066518984),
(7940, '19429', 218, 45, 160368, 40.0793, 0.699515746894563, -75.3018, -1.31426434267827),
(7941, '19430', 218, 45, 108728, 40.2136, 0.701859724079992, -75.4172, -1.31627845263507),
(7942, '19432', 218, 45, 160764, 40.078, 0.699493057614287, -75.5344, -1.3183239785184),
(7943, '19435', 218, 45, 32485, 40.3035, 0.703428775077535, -75.5374, -1.31837633839596),
(7944, '19436', 218, 45, 162347, 40.2058, 0.701723588398336, -75.2469, -1.31330615691892),
(7945, '19437', 218, 45, 162350, 40.1827, 0.701320417341125, -75.2587, -1.31351210577066),
(7946, '19438', 218, 45, 162444, 40.2659, 0.702772531278785, -75.3853, -1.31572169260368),
(7947, '19440', 218, 45, 9378, 40.2716, 0.702872015046148, -75.2927, -1.31410551771633),
(7948, '19441', 218, 45, 162444, 40.2782, 0.70298720677678, -75.3875, -1.31576008984723),
(7949, '19442', 218, 45, 163333, 40.135, 0.700487895287924, -75.583, -1.31917220853487),
(7950, '19443', 218, 45, 163459, 40.2469, 0.702440918720906, -75.3398, -1.31492756779402),
(7951, '19444', 218, 45, 0, 40.0872, 0.699653627905471, -75.251, -1.31337771541825),
(7952, '19446', 218, 45, 103524, 40.2378, 0.702282093758974, -75.2909, -1.3140741017898),
(7953, '19450', 218, 45, 163680, 40.2641, 0.702741115352249, -75.419, -1.3163098685616),
(7954, '19451', 218, 45, 164141, 40.2652, 0.702760313974021, -75.355, -1.31519285784033),
(7955, '19452', 218, 45, 164680, 40.0596, 0.699171917031921, -75.266, -1.31363951480605),
(7956, '19453', 218, 45, 82446, 40.1379, 0.700538509836232, -75.5022, -1.31776198249926),
(7957, '19454', 218, 45, 165366, 40.2173, 0.701924301262316, -75.2564, -1.31347196319786),
(7958, '19455', 218, 45, 165366, 40.2111, 0.701816090848692, -75.2754, -1.31380357575574),
(7959, '19456', 218, 45, 37485, 40.1341, 0.700472187324656, -75.4568, -1.31696960301886),
(7960, '19457', 218, 45, 89776, 40.2067, 0.701739296361604, -75.5932, -1.31935023211858),
(7961, '19460', 218, 45, 4990, 40.1144, 0.700128357462013, -75.5461, -1.31852818204089),
(7962, '19462', 218, 45, 166075, 40.1085, 0.700025383036146, -75.2771, -1.31383324635302),
(7963, '19464', 218, 45, 121099, 40.2526, 0.70254040248827, -75.6155, -1.31973944054177),
(7964, '19465', 218, 45, 121099, 40.2207, 0.701983642456883, -75.649, -1.32032412584119),
(7965, '19468', 218, 45, 166711, 40.1968, 0.701566508765657, -75.5175, -1.31802901787482),
(7966, '19470', 218, 45, 57372, 40.1752, 0.701189517647226, -75.7331, -1.32179194774212),
(7967, '19472', 218, 45, 166883, 40.3406, 0.704076292230025, -75.5762, -1.31905352614574),
(7968, '19473', 218, 45, 166948, 40.2492, 0.702481061293702, -75.4639, -1.31709352139575),
(7969, '19474', 218, 45, 167220, 40.2236, 0.702034257005191, -75.3988, -1.3159573120527),
(7970, '19475', 218, 45, 57670, 40.1747, 0.701180791000966, -75.5704, -1.31895229704912),
(7971, '19477', 218, 45, 167480, 40.1858, 0.701374522547937, -75.225, -1.31292392981273),
(7972, '19478', 218, 45, 167484, 40.2751, 0.702933101569968, -75.4592, -1.31701149092091),
(7973, '19480', 218, 45, 0, 40.0793, 0.699515746894563, -75.6934, -1.32109905202908),
(7974, '19481', 218, 45, 25680, 40.0922, 0.699740894368071, -75.4743, -1.31727503563796),
(7975, '19482', 218, 45, 25680, 40.0971, 0.699826415501418, -75.47, -1.31719998648012),
(7976, '19483', 218, 45, 25680, 40.0824, 0.699569852101375, -75.4145, -1.31623132874526),
(7977, '19484', 218, 45, 25680, 40.1133, 0.700109158840241, -75.4017, -1.31600792660101),
(7978, '19485', 218, 45, 25680, 40.113, 0.700103922852485, -75.4013, -1.316000945284),
(7979, '19486', 218, 45, 6722, 40.2078, 0.701758494983376, -75.3027, -1.31428005064153),
(7980, '19487', 218, 45, 163345, 40.0954, 0.699796744904134, -75.383, -1.31568155003089),
(7981, '19488', 218, 45, 23403, 40.1217, 0.700255766497409, -75.3401, -1.31493280378178),
(7982, '19489', 218, 45, 23403, 40.1307, 0.700412846130088, -75.3009, -1.314248634715),
(7983, '19490', 218, 45, 58366, 40.1981, 0.701589198045933, -75.3475, -1.31506195814643),
(7984, '19492', 218, 45, 0, 40.2885, 0.703166975689735, -75.4899, -1.31754730700127),
(7985, '19493', 218, 45, 25680, 40.0555, 0.699100358532589, -75.5583, -1.31874111220963),
(7986, '19494', 218, 45, 25680, 40.0558, 0.699105594520345, -75.5581, -1.31873762155113),
(7987, '19495', 218, 45, 25680, 40.0553, 0.699096867874085, -75.5587, -1.31874809352664),
(7988, '19496', 218, 45, 25680, 40.0969, 0.699822924842914, -75.4696, -1.31719300516311),
(7989, '19501', 218, 45, 44283, 40.2435, 0.702381577526338, -76.056, -1.32742761589681),
(7990, '19503', 218, 45, 158897, 40.4011, 0.705132216427481, -75.5878, -1.31925598433897),
(7991, '19504', 218, 45, 58559, 40.3708, 0.704603381664127, -75.5704, -1.31895229704912),
(7992, '19505', 218, 45, 159024, 40.3706, 0.704599891005623, -75.6291, -1.31997680532004),
(7993, '19506', 218, 45, 159153, 40.4349, 0.705722137714655, -76.1143, -1.32844514285072),
(7994, '19507', 218, 45, 220, 40.4898, 0.706680323474, -76.2965, -1.33162513274785),
(7995, '19508', 218, 45, 159242, 40.2682, 0.702812673851581, -75.8202, -1.3233121295206),
(7996, '19510', 218, 45, 159299, 40.4418, 0.705842565433043, -75.8811, -1.32437503503507),
(7997, '19511', 218, 45, 75186, 40.3527, 0.704287477069516, -76.1326, -1.32876453810383),
(7998, '19512', 218, 45, 159419, 40.335, 0.703978553791913, -75.6399, -1.32016530087926),
(7999, '19516', 218, 45, 147692, 40.4871, 0.706633199584196, -76.0077, -1.32658462186809),
(8000, '19518', 218, 45, 93803, 40.2655, 0.702765549961777, -75.7356, -1.32183558097342),
(8001, '19519', 218, 45, 2153, 40.3167, 0.703659158538798, -75.7376, -1.32187048755846),
(8002, '19520', 218, 45, 161342, 40.1569, 0.700870122394111, -75.787, -1.32273268020894),
(8003, '19522', 218, 45, 2491, 40.4487, 0.70596299315143, -75.7936, -1.32284787193957),
(8004, '19523', 218, 45, 161991, 40.2025, 0.70166599253302, -75.8361, -1.32358963687167),
(8005, '19525', 218, 45, 36088, 40.3067, 0.703484625613598, -75.5957, -1.31939386534988),
(8006, '19526', 218, 45, 2948, 40.5554, 0.707825259463308, -75.9845, -1.32617970548163),
(8007, '19529', 218, 45, 48600, 40.6332, 0.70918312562136, -75.8772, -1.32430696719424),
(8008, '19530', 218, 45, 163465, 40.5187, 0.707184723627826, -75.7735, -1.32249706075992),
(8009, '19533', 218, 45, 163693, 40.441, 0.705828602799027, -75.9738, -1.32599295525167),
(8010, '19534', 218, 45, 163729, 40.5726, 0.708125456094651, -75.8881, -1.32449720808271),
(8011, '19535', 218, 45, 0, 40.3796, 0.704756970638302, -75.7633, -1.32231903717622),
(8012, '19536', 218, 45, 0, 40.4805, 0.706518007853565, -75.7578, -1.32222304406736),
(8013, '19538', 218, 45, 164311, 40.5421, 0.707593130672793, -75.6894, -1.321029238859),
(8014, '19539', 218, 45, 164488, 40.5164, 0.707144581055031, -75.6312, -1.32001345723434),
(8015, '19540', 218, 45, 164692, 40.2837, 0.70308319988564, -75.9864, -1.32621286673742),
(8016, '19541', 218, 45, 164694, 40.4773, 0.706462157317501, -76.0134, -1.32668410563546),
(8017, '19542', 218, 45, 0, 40.2622, 0.702707954096461, -75.7674, -1.32239059567555),
(8018, '19543', 218, 45, 17178, 40.166, 0.701028947356042, -75.8866, -1.32447102814393),
(8019, '19544', 218, 45, 49613, 40.4192, 0.705448121022092, -76.296, -1.33161640610159),
(8020, '19545', 218, 45, 165088, 40.344, 0.704135633424592, -75.6319, -1.3200256745391),
(8021, '19547', 218, 45, 165519, 40.3832, 0.704819802491374, -75.7891, -1.32276933212323),
(8022, '19548', 218, 45, 165928, 40.2831, 0.703072727910128, -75.6912, -1.32106065478553),
(8023, '19549', 218, 45, 157220, 40.5823, 0.708294753032095, -76.0276, -1.32693194238924),
(8024, '19550', 218, 45, 166382, 40.4577, 0.70612007278411, -76.2448, -1.33072279752457),
(8025, '19551', 218, 45, 166553, 40.3493, 0.704228135874948, -76.1376, -1.32885180456643),
(8026, '19554', 218, 45, 167067, 40.5123, 0.707073022555699, -76.1047, -1.32827759124253),
(8027, '19555', 218, 45, 167163, 40.4955, 0.706779807241364, -75.9539, -1.32564563473052),
(8028, '19557', 218, 45, 51755, 40.6189, 0.708933543538325, -75.8185, -1.32328245892332),
(8029, '19559', 218, 45, 167680, 40.4906, 0.706694286108016, -76.1836, -1.32965465602235),
(8030, '19560', 218, 45, 12281, 40.4043, 0.705188066963545, -75.9123, -1.32491957776169),
(8031, '19562', 218, 45, 6363, 40.5016, 0.706886272325735, -75.7019, -1.3212474050155),
(8032, '19564', 218, 45, 168391, 40.5243, 0.707282462065938, -75.8738, -1.32424762599967),
(8033, '19565', 218, 45, 168651, 40.3243, 0.703791803561949, -76.0857, -1.32794597868465),
(8034, '19567', 218, 45, 169083, 40.3876, 0.704896596978462, -76.214, -1.33018523611496),
(8035, '19601', 218, 45, 33727, 40.3484, 0.70421242791168, -75.9403, -1.32540826995225),
(8036, '19602', 218, 45, 33727, 40.33, 0.703891287329313, -75.9187, -1.32503127883382),
(8037, '19603', 218, 45, 33727, 40.3755, 0.704685412138971, -75.9293, -1.32521628373453),
(8038, '19604', 218, 45, 33727, 40.3545, 0.704318892996052, -75.9107, -1.32489165249366),
(8039, '19605', 218, 45, 33727, 40.3831, 0.704818057162122, -75.9323, -1.32526864361209),
(8040, '19606', 218, 45, 33727, 40.3233, 0.70377435026943, -75.8682, -1.32414988756156),
(8041, '19607', 218, 45, 33727, 40.3038, 0.703434011065291, -75.9557, -1.32567705065706),
(8042, '19608', 218, 45, 33727, 40.314, 0.703612034648994, -76.0217, -1.32682896796337),
(8043, '19609', 218, 45, 33727, 40.3263, 0.703826710146989, -75.9954, -1.3263699463701),
(8044, '19610', 218, 45, 33727, 40.3334, 0.703950628523881, -75.9716, -1.32595455800812),
(8045, '19611', 218, 45, 33727, 40.3249, 0.703802275537461, -75.9419, -1.32543619522028),
(8046, '19612', 218, 45, 33727, 40.3681, 0.704556257774323, -75.9116, -1.32490736045693),
(8047, '19640', 218, 45, 33727, 40.3393, 0.704053602949749, -75.9266, -1.32516915984473),
(8048, '19701', 218, 10, 7325, 39.6102, 0.691328407373458, -75.6894, -1.321029238859),
(8049, '19702', 218, 10, 10792, 39.6356, 0.691771721003464, -75.7019, -1.3212474050155),
(8050, '19703', 218, 10, 13549, 39.8032, 0.694696892829807, -75.4639, -1.31709352139575),
(8051, '19706', 218, 10, 13644, 39.5717, 0.69065645561144, -75.6007, -1.31948113181248),
(8052, '19707', 218, 10, 13958, 39.7789, 0.694272777821572, -75.6889, -1.32102051221274),
(8053, '19708', 218, 10, 14059, 39.4966, 0.689345713343192, -75.6838, -1.32093150042088),
(8054, '19709', 218, 10, 14224, 39.4869, 0.689176416405749, -75.6857, -1.32096466167667),
(8055, '19710', 218, 10, 14260, 39.7956, 0.694564247806655, -75.5837, -1.31918442583964),
(8056, '19711', 218, 10, 10792, 39.7071, 0.69301963141864, -75.7344, -1.32181463702239),
(8057, '19712', 218, 10, 10792, 39.6844, 0.692623441678438, -75.7167, -1.32150571374479),
(8058, '19713', 218, 10, 10792, 39.6683, 0.692342443668867, -75.7205, -1.32157203625637),
(8059, '19714', 218, 10, 10792, 39.7144, 0.693147040454036, -75.7393, -1.32190015815574),
(8060, '19715', 218, 10, 10792, 39.7147, 0.693152276441792, -75.7394, -1.32190190348499),
(8061, '19716', 218, 10, 10792, 39.714, 0.693140059137028, -75.7394, -1.32190190348499),
(8062, '19717', 218, 10, 10792, 39.7149, 0.693155767100296, -75.7393, -1.32190015815574),
(8063, '19718', 218, 10, 10792, 39.6706, 0.692382586241662, -75.7049, -1.32129976489306),
(8064, '19720', 218, 10, 4520, 39.6767, 0.692489051326034, -75.5976, -1.31942702660567),
(8065, '19721', 218, 10, 4520, 39.6667, 0.692314518400835, -75.5705, -1.31895404237837),
(8066, '19725', 218, 10, 10792, 39.6843, 0.692621696349186, -75.7354, -1.32183209031491),
(8067, '19726', 218, 10, 10792, 39.6842, 0.692619951019934, -75.7357, -1.32183732630267),
(8068, '19730', 218, 10, 14343, 39.4552, 0.688623147032867, -75.6583, -1.32048644146163),
(8069, '19731', 218, 10, 14439, 39.5168, 0.689698269852095, -75.5772, -1.31907097943826),
(8070, '19732', 218, 10, 187, 39.7924, 0.694508397270592, -75.5708, -1.31895927836613),
(8071, '19733', 218, 10, 14539, 39.5553, 0.690370221614113, -75.6508, -1.32035554176773),
(8072, '19734', 218, 10, 14757, 39.3986, 0.687635290676238, -75.6806, -1.32087564988482),
(8073, '19735', 218, 10, 14885, 39.8035, 0.694702128817563, -75.615, -1.31973071389551),
(8074, '19736', 218, 10, 14926, 39.8026, 0.694686420854295, -75.6684, -1.32066271971608),
(8075, '19801', 218, 10, 14869, 39.7375, 0.693550211511247, -75.5507, -1.31860846718648),
(8076, '19802', 218, 10, 14869, 39.7566, 0.693883569398378, -75.531, -1.31826463732384),
(8077, '19803', 218, 10, 14869, 39.7936, 0.694529341221615, -75.5338, -1.31831350654289),
(8078, '19804', 218, 10, 14869, 39.7209, 0.693260486855416, -75.6126, -1.31968882599346),
(8079, '19805', 218, 10, 14869, 39.7436, 0.693656676595618, -75.5905, -1.31930310822877),
(8080, '19806', 218, 10, 14869, 39.7587, 0.69392022131267, -75.5651, -1.31885979459877),
(8081, '19807', 218, 10, 14869, 39.7852, 0.694382733564448, -75.612, -1.31967835401795),
(8082, '19808', 218, 10, 14869, 39.7346, 0.693499596962939, -75.6663, -1.32062606780179),
(8083, '19809', 218, 10, 14869, 39.7724, 0.694159331420193, -75.4958, -1.31765028142714),
(8084, '19810', 218, 10, 14869, 39.8185, 0.694963928205362, -75.5059, -1.31782655968159),
(8085, '19850', 218, 10, 14869, 39.7288, 0.693398367866323, -75.5377, -1.31838157438372),
(8086, '19880', 218, 10, 14869, 39.7286, 0.693394877207819, -75.5374, -1.31837633839596),
(8087, '19884', 218, 10, 14869, 39.7463, 0.693703800485422, -75.547, -1.31854389000416),
(8088, '19885', 218, 10, 14869, 39.7455, 0.693689837851406, -75.5464, -1.31853341802864),
(8089, '19886', 218, 10, 14869, 39.746, 0.693698564497666, -75.5466, -1.31853690868715),
(8090, '19887', 218, 10, 14869, 39.8191, 0.694974400180874, -75.5084, -1.31787019291289),
(8091, '19889', 218, 10, 14869, 39.7389, 0.693574646120775, -75.5501, -1.31859799521097),
(8092, '19890', 218, 10, 14869, 39.7379, 0.693557192828255, -75.5534, -1.31865559107628),
(8093, '19891', 218, 10, 14869, 39.6789, 0.692527448569578, -75.6936, -1.32110254268758),
(8094, '19892', 218, 10, 14869, 39.6856, 0.692644385629462, -75.6132, -1.31969929796898),
(8095, '19893', 218, 10, 14869, 39.7497, 0.69376314167999, -75.5544, -1.3186730443688),
(8096, '19894', 218, 10, 14869, 39.7484, 0.693740452399714, -75.5452, -1.31851247407762),
(8097, '19895', 218, 10, 14869, 39.7433, 0.693651440607862, -75.5487, -1.31857356060144),
(8098, '19896', 218, 10, 14869, 39.7555, 0.693864370776606, -75.5275, -1.31820355080002),
(8099, '19897', 218, 10, 14869, 39.798, 0.694606135708703, -75.5461, -1.31852818204089),
(8100, '19898', 218, 10, 14869, 39.7452, 0.69368460186365, -75.548, -1.31856134329668),
(8101, '19899', 218, 10, 14869, 39.736, 0.693524031572467, -75.547, -1.31854389000416),
(8102, '19901', 218, 10, 8583, 39.1511, 0.683315600777552, -75.5314, -1.31827161864085),
(8103, '19902', 218, 10, 0, 39.1237, 0.682837380562506, -75.4769, -1.31732041419851),
(8104, '19903', 218, 10, 8583, 39.2111, 0.684362798328749, -75.5706, -1.31895578770763),
(8105, '19904', 218, 10, 8583, 39.1571, 0.683420320532672, -75.5262, -1.31818086151974),
(8106, '19905', 218, 10, 8583, 39.1592, 0.683456972446963, -75.5172, -1.31802378188706),
(8107, '19906', 218, 10, 8583, 39.158, 0.68343602849594, -75.5249, -1.31815817223947),
(8108, '19930', 218, 10, 13370, 38.5292, 0.672461398159399, -75.0645, -1.31012267636328),
(8109, '19931', 218, 10, 220, 38.5675, 0.673129859262913, -75.625, -1.31990524682071),
(8110, '19933', 218, 10, 1134, 38.7373, 0.676093428332799, -75.5924, -1.31933626948456),
(8111, '19934', 218, 10, 0, 39.1147, 0.682680300929826, -75.548, -1.31856134329668),
(8112, '19936', 218, 10, 13532, 39.2182, 0.68448671670564, -75.5879, -1.31925772966822),
(8113, '19938', 218, 10, 608, 39.3019, 0.685947557289559, -75.7098, -1.3213852860264),
(8114, '19939', 218, 10, 13624, 38.5557, 0.672923910411178, -75.2195, -1.31282793670387),
(8115, '19940', 218, 10, 2021, 38.4574, 0.671208251756467, -75.5737, -1.31900989291444),
(8116, '19941', 218, 10, 13721, 38.7788, 0.676817739972377, -75.3649, -1.31536564543627),
(8117, '19943', 218, 10, 8869, 39.0116, 0.68088086647102, -75.5723, -1.31898545830491),
(8118, '19944', 218, 10, 13758, 38.4595, 0.671244903670759, -75.0536, -1.30993243547482),
(8119, '19945', 218, 10, 13800, 38.5216, 0.672328753136248, -75.2027, -1.31253472138954),
(8120, '19946', 218, 10, 13802, 39.0169, 0.680973368921376, -75.4795, -1.31736579275906),
(8121, '19947', 218, 10, 2693, 38.6913, 0.675290576876882, -75.3842, -1.31570249398191),
(8122, '19950', 218, 10, 2869, 38.8069, 0.677308177492187, -75.5939, -1.31936244942334),
(8123, '19951', 218, 10, 13890, 38.6581, 0.67471112756522, -75.1774, -1.31209315308879),
(8124, '19952', 218, 10, 13897, 38.9392, 0.679617248092576, -75.5806, -1.31913032063283),
(8125, '19953', 218, 10, 13898, 39.1525, 0.68334003538708, -75.6928, -1.32108858005356),
(8126, '19954', 218, 10, 3246, 38.917, 0.679229784998633, -75.5049, -1.31780910638907),
(8127, '19955', 218, 10, 14041, 39.2271, 0.684642051009068, -75.6667, -1.32063304911879),
(8128, '19956', 218, 10, 14092, 38.5524, 0.672866314545862, -75.5694, -1.3189348437566),
(8129, '19958', 218, 10, 14105, 38.7449, 0.676226073355951, -75.1591, -1.31177375783567),
(8130, '19960', 218, 10, 3781, 38.8551, 0.678149426191649, -75.4312, -1.31652279873035),
(8131, '19961', 218, 10, 762, 39.1655, 0.683566928189839, -75.4489, -1.31683172200795),
(8132, '19962', 218, 10, 3947, 39.0717, 0.681929809351468, -75.5238, -1.31813897361769),
(8133, '19963', 218, 10, 10480, 38.9047, 0.679015109500638, -75.4298, -1.31649836412082),
(8134, '19964', 218, 10, 14180, 39.1034, 0.682483078724351, -75.7294, -1.32172737055979),
(8135, '19966', 218, 10, 14244, 38.6109, 0.673887332158279, -75.1949, -1.31239858570788),
(8136, '19967', 218, 10, 4227, 38.5645, 0.673077499385353, -75.1163, -1.31102675691582),
(8137, '19968', 218, 10, 4232, 38.7801, 0.676840429252653, -75.2824, -1.31392574880338),
(8138, '19969', 218, 10, 14288, 38.7515, 0.676341265086583, -75.1877, -1.31227292200174),
(8139, '19970', 218, 10, 365, 38.5477, 0.672784284071018, -75.1008, -1.31075623088176),
(8140, '19971', 218, 10, 14474, 38.7119, 0.675650114702793, -75.1009, -1.31075797621101),
(8141, '19973', 218, 10, 14571, 38.6451, 0.674484234762461, -75.6106, -1.31965391940842),
(8142, '19975', 218, 10, 14578, 38.4631, 0.671307735523831, -75.1416, -1.31146832521657),
(8143, '19977', 218, 10, 452, 39.2904, 0.68574684442558, -75.6059, -1.31957188893358),
(8144, '19979', 218, 10, 12571, 39.0423, 0.681416682551382, -75.5704, -1.31895229704912),
(8145, '19980', 218, 10, 14913, 39.0707, 0.681912356058949, -75.5681, -1.31891215447633),
(8146, '20001', 218, 9, 12671, 38.9083, 0.67907794135371, -77.0183, -1.34422291928875),
(8147, '20002', 218, 9, 12671, 38.9041, 0.679004637525126, -76.9908, -1.34374295374445),
(8148, '20003', 218, 9, 12671, 38.8815, 0.678610193114175, -76.9942, -1.34380229493902),
(8149, '20004', 218, 9, 12671, 38.8945, 0.678837085916934, -77.0298, -1.34442363215273),
(8150, '20005', 218, 9, 12671, 38.9044, 0.679009873512882, -77.0307, -1.344439340116),
(8151, '20006', 218, 9, 12671, 38.8978, 0.67889468178225, -77.0413, -1.34462434501671),
(8152, '20007', 218, 9, 12671, 38.9131, 0.679161717157805, -77.0744, -1.34520204899912),
(8153, '20008', 218, 9, 12671, 38.9351, 0.679545689593244, -77.0594, -1.34494024961132),
(8154, '20009', 218, 9, 12671, 38.9192, 0.679268182242177, -77.04, -1.34460165573643),
(8155, '20010', 218, 9, 12671, 38.9327, 0.679503801691196, -77.0299, -1.34442537748198),
(8156, '20011', 218, 9, 12671, 38.9529, 0.679856358200099, -77.0177, -1.34421244731324),
(8157, '20012', 218, 9, 12671, 38.9764, 0.680266510574318, -77.0268, -1.34437127227517),
(8158, '20013', 218, 9, 12671, 38.8972, 0.678884209806738, -77.0423, -1.34464179830923),
(8159, '20015', 218, 9, 12671, 38.9656, 0.680078015015102, -77.0657, -1.34505020535419),
(8160, '20016', 218, 9, 12671, 38.9403, 0.679636446714348, -77.0888, -1.3454533764114),
(8161, '20017', 218, 9, 12671, 38.9377, 0.679591068153796, -76.9935, -1.34379007763425),
(8162, '20018', 218, 9, 12671, 38.9272, 0.679407808582337, -76.9755, -1.3434759183689),
(8163, '20019', 218, 9, 12671, 38.8908, 0.678772508734611, -76.9392, -1.34284236385042),
(8164, '20020', 218, 9, 12671, 38.862, 0.678269853910036, -76.9728, -1.34342879447909),
(8165, '20022', 218, 9, 12671, 38.9037, 0.678997656208118, -76.9909, -1.3437446990737),
(8166, '20023', 218, 9, 12671, 38.8818, 0.678615429101931, -76.9945, -1.34380753092677),
(8167, '20024', 218, 9, 12671, 38.8775, 0.678540379944095, -77.0181, -1.34421942863024),
(8168, '20026', 218, 9, 12671, 38.8778, 0.678545615931851, -77.0175, -1.34420895665473),
(8169, '20027', 218, 9, 12671, 38.9129, 0.679158226499301, -77.0749, -1.34521077564538),
(8170, '20029', 218, 9, 12671, 38.8929, 0.678809160648903, -76.9422, -1.34289472372798),
(8171, '20030', 218, 9, 12671, 38.8622, 0.67827334456854, -76.9742, -1.34345322908862);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(8172, '20032', 218, 9, 12671, 38.8359, 0.677814322975266, -77.0001, -1.34390526936489),
(8173, '20033', 218, 9, 12671, 38.9067, 0.679050016085678, -77.0421, -1.34463830765072),
(8174, '20035', 218, 9, 12671, 38.9062, 0.679041289439418, -77.0416, -1.34462958100446),
(8175, '20036', 218, 9, 12671, 38.9065, 0.679046525427174, -77.0418, -1.34463307166297),
(8176, '20037', 218, 9, 12671, 38.9011, 0.678952277647566, -77.0513, -1.34479887794191),
(8177, '20038', 218, 9, 12671, 38.9038, 0.67899940153737, -77.0323, -1.34446726538403),
(8178, '20039', 218, 9, 12671, 38.9533, 0.679863339517107, -77.0241, -1.34432414838536),
(8179, '20040', 218, 9, 12671, 38.9665, 0.68009372297837, -77.0278, -1.34438872556769),
(8180, '20041', 218, 9, 12671, 38.8329, 0.677761963097706, -77.2128, -1.34761758468388),
(8181, '20042', 218, 9, 12671, 38.9178, 0.679243747632649, -76.9944, -1.34380578559752),
(8182, '20043', 218, 9, 12671, 38.9039, 0.679001146866622, -77.0323, -1.34446726538403),
(8183, '20044', 218, 9, 12671, 38.8946, 0.678838831246186, -77.0266, -1.34436778161666),
(8184, '20045', 218, 9, 12671, 38.8949, 0.678844067233943, -77.0278, -1.34438872556769),
(8185, '20046', 218, 9, 12671, 38.9599, 0.679978531247739, -77.0884, -1.3454463950944),
(8186, '20047', 218, 9, 12671, 38.9595, 0.679971549930731, -77.0878, -1.34543592311888),
(8187, '20049', 218, 9, 12671, 38.8958, 0.67885977519721, -77.0202, -1.34425608054454),
(8188, '20050', 218, 9, 12671, 38.9054, 0.679027326805402, -76.9865, -1.34366790458661),
(8189, '20051', 218, 9, 12671, 38.8971, 0.678882464477486, -77.0261, -1.3443590549704),
(8190, '20052', 218, 9, 12671, 38.8979, 0.678896427111502, -77.0462, -1.34470986615006),
(8191, '20053', 218, 9, 12671, 38.8827, 0.678631137065199, -77.0096, -1.34407107564383),
(8192, '20055', 218, 9, 12671, 38.9019, 0.678966240281582, -77.0215, -1.34427876982481),
(8193, '20056', 218, 9, 12671, 38.9059, 0.679036053451662, -76.9846, -1.34363474333083),
(8194, '20057', 218, 9, 12671, 38.9077, 0.679067469378198, -77.0744, -1.34520204899912),
(8195, '20058', 218, 9, 12671, 39.0262, 0.681135684541811, -77.138, -1.34631207840339),
(8196, '20059', 218, 9, 12671, 38.9218, 0.679313560802729, -77.0195, -1.34424386323977),
(8197, '20060', 218, 9, 12671, 38.9184, 0.679254219608161, -77.0223, -1.34429273245883),
(8198, '20061', 218, 9, 12671, 38.9168, 0.679226294340129, -76.9943, -1.34380404026827),
(8199, '20062', 218, 9, 12671, 38.9, 0.678933079025794, -77.0379, -1.34456500382214),
(8200, '20063', 218, 9, 12671, 38.9051, 0.679022090817646, -77.046, -1.34470637549155),
(8201, '20064', 218, 9, 12671, 38.9352, 0.679547434922496, -76.998, -1.34386861745059),
(8202, '20065', 218, 9, 12671, 38.8841, 0.678655571674727, -77.0283, -1.34439745221395),
(8203, '20066', 218, 9, 12671, 38.9171, 0.679231530327885, -76.9944, -1.34380578559752),
(8204, '20067', 218, 9, 12671, 38.8978, 0.67889468178225, -77.0422, -1.34464005297998),
(8205, '20068', 218, 9, 12671, 38.8999, 0.678931333696542, -77.0436, -1.3446644875895),
(8206, '20069', 218, 9, 12671, 38.88, 0.678584013175395, -77.2311, -1.34793697993699),
(8207, '20070', 218, 9, 12671, 38.8795, 0.678575286529135, -77.2313, -1.3479404705955),
(8208, '20071', 218, 9, 12671, 38.9046, 0.679013364171386, -77.0335, -1.34448820933505),
(8209, '20073', 218, 9, 12671, 38.8968, 0.67887722848973, -77.024, -1.34432240305611),
(8210, '20074', 218, 9, 12671, 38.9178, 0.679243747632649, -76.9944, -1.34380578559752),
(8211, '20075', 218, 9, 12671, 38.9176, 0.679240256974145, -76.9945, -1.34380753092677),
(8212, '20076', 218, 9, 12671, 38.959, 0.679962823284471, -77.088, -1.34543941377739),
(8213, '20077', 218, 9, 12671, 38.9176, 0.679240256974145, -76.9946, -1.34380927625603),
(8214, '20078', 218, 9, 12671, 38.916, 0.679212331706113, -76.9944, -1.34380578559752),
(8215, '20080', 218, 9, 12671, 38.8998, 0.67892958836729, -77.0271, -1.34437650826292),
(8216, '20081', 218, 9, 12671, 38.8998, 0.67892958836729, -77.0274, -1.34438174425068),
(8217, '20082', 218, 9, 12671, 38.8937, 0.678823123282919, -77.012, -1.34411296354587),
(8218, '20088', 218, 9, 12671, 38.968, 0.68011990291715, -77.0588, -1.34492977763581),
(8219, '20090', 218, 9, 12671, 38.8779, 0.678547361261103, -77.0175, -1.34420895665473),
(8220, '20091', 218, 9, 12671, 38.9025, 0.678976712257094, -77.0257, -1.3443520736534),
(8221, '20097', 218, 9, 12671, 38.886, 0.678688732930515, -77.0062, -1.34401173444926),
(8222, '20098', 218, 9, 12671, 38.917, 0.679229784998633, -76.9948, -1.34381276691453),
(8223, '20099', 218, 9, 12671, 38.8955, 0.678854539209454, -77.0371, -1.34455104118812),
(8224, '20101', 218, 53, 0, 38.99, 0.680503875352589, -77.4506, -1.35176797764512),
(8225, '20102', 218, 53, 0, 38.9555, 0.679901736760651, -77.4518, -1.35178892159614),
(8226, '20103', 218, 53, 0, 38.9967, 0.680620812412473, -77.4518, -1.35178892159614),
(8227, '20104', 218, 53, 0, 39.3233, 0.686321057749486, -77.5352, -1.35324452619231),
(8228, '20105', 218, 53, 99341, 38.9542, 0.679879047480375, -77.5978, -1.35433710230406),
(8229, '20106', 218, 53, 99403, 38.6715, 0.674945001684987, -77.9955, -1.36127827673924),
(8230, '20107', 218, 53, 18900, 38.9793, 0.680317125122626, -77.5236, -1.35304206799908),
(8231, '20108', 218, 53, 22841, 38.7488, 0.676294141196779, -77.484, -1.35235091761529),
(8232, '20109', 218, 53, 22841, 38.8002, 0.677191240432304, -77.5445, -1.35340684181274),
(8233, '20110', 218, 53, 22841, 38.748, 0.676280178562763, -77.4764, -1.35221827259213),
(8234, '20111', 218, 53, 22841, 38.7372, 0.676091683003547, -77.4204, -1.35124088821102),
(8235, '20112', 218, 53, 22841, 38.695, 0.675355154059206, -77.437, -1.35153061286685),
(8236, '20113', 218, 53, 22841, 38.7858, 0.676939913020017, -77.4591, -1.35191633063154),
(8237, '20115', 218, 53, 4011, 38.8122, 0.677400679942543, -77.9155, -1.35988201333764),
(8238, '20116', 218, 53, 4011, 38.8666, 0.678350139055628, -77.8561, -1.35884528776196),
(8239, '20117', 218, 53, 17130, 39.0093, 0.680840723898224, -77.7466, -1.35693415223102),
(8240, '20118', 218, 53, 17130, 38.9674, 0.680109430941638, -77.735, -1.35673169403779),
(8241, '20119', 218, 53, 19851, 38.6538, 0.674636078407384, -77.6408, -1.35508759388241),
(8242, '20120', 218, 53, 1472, 38.8511, 0.678079613021569, -77.4626, -1.35197741715536),
(8243, '20121', 218, 53, 1472, 38.8179, 0.677500163709907, -77.4682, -1.35207515559347),
(8244, '20122', 218, 53, 1472, 38.8551, 0.678149426191649, -77.4777, -1.35224096187241),
(8245, '20124', 218, 53, 15559, 38.7799, 0.676836938594149, -77.3881, -1.35067714686262),
(8246, '20128', 218, 53, 104983, 38.7521, 0.676351737062095, -77.965, -1.36074595131738),
(8247, '20129', 218, 53, 105021, 39.1489, 0.683277203534008, -77.6198, -1.35472107473949),
(8248, '20130', 218, 53, 11069, 39.0328, 0.681250876272443, -77.9422, -1.36034801624792),
(8249, '20131', 218, 53, 105216, 39.0565, 0.681664519305165, -77.7409, -1.35683466846366),
(8250, '20132', 218, 53, 105506, 39.1628, 0.683519804300035, -77.7279, -1.3566077756609),
(8251, '20134', 218, 53, 105506, 39.1414, 0.683146303840108, -77.7108, -1.35630932435881),
(8252, '20135', 218, 53, 100025, 39.0902, 0.682252695263087, -77.8399, -1.35856254442313),
(8253, '20136', 218, 53, 1144, 38.7232, 0.675847336908268, -77.5364, -1.35326547014333),
(8254, '20137', 218, 53, 45116, 38.8256, 0.67763455406231, -77.7139, -1.35636342956562),
(8255, '20138', 218, 53, 45326, 38.6317, 0.674250360642693, -77.6708, -1.35561119265801),
(8256, '20139', 218, 53, 112610, 38.657, 0.674691928943448, -77.7173, -1.35642277076019),
(8257, '20140', 218, 53, 105607, 38.9209, 0.679297852839461, -77.8622, -1.35895175284633),
(8258, '20141', 218, 53, 11700, 39.1229, 0.68282341792849, -77.7872, -1.35764275590733),
(8259, '20142', 218, 53, 11700, 39.1329, 0.682997950853689, -77.7698, -1.35733906861749),
(8260, '20143', 218, 53, 100574, 38.848, 0.678025507814757, -77.5668, -1.35379605023594),
(8261, '20144', 218, 53, 101369, 38.9146, 0.679187897096585, -77.9208, -1.359974515788),
(8262, '20146', 218, 53, 18929, 39.0181, 0.680994312872399, -77.4612, -1.35195298254583),
(8263, '20147', 218, 53, 18929, 39.0339, 0.681270074894215, -77.4885, -1.35242945743163),
(8264, '20148', 218, 53, 18929, 38.9972, 0.680629539058733, -77.5292, -1.35313980643719),
(8265, '20149', 218, 53, 18929, 39.0412, 0.68139748392961, -77.4815, -1.35230728438399),
(8266, '20151', 218, 53, 63606, 38.8887, 0.678735856820319, -77.4551, -1.35184651746146),
(8267, '20152', 218, 53, 63606, 38.9079, 0.679070960036702, -77.5178, -1.35294083890246),
(8268, '20153', 218, 53, 63606, 38.8867, 0.678700950235279, -77.44, -1.35158297274441),
(8269, '20155', 218, 53, 2644, 38.7868, 0.676957366312537, -77.6562, -1.35535637458722),
(8270, '20156', 218, 53, 2644, 38.7914, 0.677037651458128, -77.6256, -1.35482230383611),
(8271, '20158', 218, 53, 2950, 39.1306, 0.682957808280893, -77.6614, -1.35544713170832),
(8272, '20159', 218, 53, 2950, 39.1376, 0.683079981328533, -77.6642, -1.35549600092738),
(8273, '20160', 218, 53, 3781, 39.1157, 0.682697754222346, -77.6949, -1.35603181700774),
(8274, '20163', 218, 53, 25116, 38.9905, 0.680512601998849, -77.4473, -1.3517103817798),
(8275, '20164', 218, 53, 25116, 39.0156, 0.6809506796411, -77.3933, -1.35076790398373),
(8276, '20165', 218, 53, 25116, 39.051, 0.681568526196306, -77.3934, -1.35076964931298),
(8277, '20166', 218, 53, 25116, 38.9981, 0.680645247022001, -77.4327, -1.35145556370901),
(8278, '20167', 218, 53, 25116, 39.0146, 0.68093322634858, -77.3949, -1.35079582925176),
(8279, '20168', 218, 53, 102678, 38.8136, 0.677425114552071, -77.6363, -1.35500905406607),
(8280, '20169', 218, 53, 102678, 38.8719, 0.678442641505984, -77.661, -1.35544015039132),
(8281, '20170', 218, 53, 9440, 38.978, 0.68029443584235, -77.3875, -1.35066667488711),
(8282, '20171', 218, 53, 9440, 38.9243, 0.679357194034029, -77.4018, -1.35091625697015),
(8283, '20172', 218, 53, 9440, 38.9676, 0.680112921600142, -77.381, -1.35055322848573),
(8284, '20175', 218, 53, 3721, 39.0847, 0.682156702154228, -77.6068, -1.35449418193674),
(8285, '20176', 218, 53, 3721, 39.2006, 0.684179538757289, -77.5337, -1.35321834625353),
(8286, '20177', 218, 53, 3721, 39.1075, 0.682554637223682, -77.5665, -1.35379081424818),
(8287, '20178', 218, 53, 3721, 39.1159, 0.68270124488085, -77.5642, -1.35375067167539),
(8288, '20180', 218, 53, 103843, 39.2743, 0.685465846416009, -77.6394, -1.35506315927289),
(8289, '20181', 218, 53, 104686, 38.6679, 0.674882169831915, -77.5346, -1.3532340542168),
(8290, '20182', 218, 53, 104686, 38.7005, 0.675451147168065, -77.5771, -1.35397581914889),
(8291, '20184', 218, 53, 107069, 38.9719, 0.680187970757978, -77.8549, -1.35882434381093),
(8292, '20185', 218, 53, 107069, 38.9938, 0.680570197864165, -77.8854, -1.35935666923279),
(8293, '20186', 218, 53, 6633, 38.6965, 0.675381333997986, -77.852, -1.35877372926263),
(8294, '20187', 218, 53, 6633, 38.7244, 0.675868280859292, -77.7179, -1.3564332427357),
(8295, '20188', 218, 53, 6633, 38.7069, 0.675562848240193, -77.8383, -1.3585346191551),
(8296, '20189', 218, 53, 0, 39.0092, 0.680838978568972, -77.4422, -1.35162136998795),
(8297, '20190', 218, 53, 105660, 38.9572, 0.679931407357935, -77.342, -1.34987255007745),
(8298, '20191', 218, 53, 105660, 38.9392, 0.679617248092576, -77.3458, -1.34993887258903),
(8299, '20192', 218, 53, 9440, 38.9468, 0.679749893115728, -77.3658, -1.35028793843943),
(8300, '20193', 218, 53, 105660, 38.9595, 0.679971549930731, -77.3376, -1.34979575559037),
(8301, '20194', 218, 53, 105660, 38.9782, 0.680297926500854, -77.3401, -1.34983938882167),
(8302, '20195', 218, 53, 105660, 38.9484, 0.679777818383759, -77.3299, -1.34966136523796),
(8303, '20196', 218, 53, 105660, 38.9259, 0.679385119302061, -77.3976, -1.35084295314156),
(8304, '20197', 218, 53, 790, 39.1928, 0.684043403075634, -77.6342, -1.35497240215178),
(8305, '20198', 218, 53, 25430, 38.8632, 0.67829079786106, -77.7734, -1.35740190047056),
(8306, '20199', 218, 53, 0, 39.3235, 0.68632454840799, -77.5355, -1.35324976218006),
(8307, '20201', 218, 9, 12671, 38.887, 0.678706186223035, -77.0164, -1.34418975803296),
(8308, '20202', 218, 9, 12671, 38.8639, 0.678303015165824, -77.0587, -1.34492803230655),
(8309, '20203', 218, 9, 12671, 38.9051, 0.679022090817646, -77.0459, -1.3447046301623),
(8310, '20204', 218, 9, 12671, 38.8862, 0.678692223589019, -77.0147, -1.34416008743568),
(8311, '20206', 218, 9, 12671, 38.8449, 0.677971402607945, -77.1154, -1.34591763399244),
(8312, '20207', 218, 9, 12671, 38.9047, 0.679015109500638, -76.9866, -1.34366964991587),
(8313, '20208', 218, 9, 12671, 38.8964, 0.678870247172722, -77.0115, -1.34410423689961),
(8314, '20210', 218, 9, 12671, 38.8923, 0.678798688673391, -77.0143, -1.34415310611867),
(8315, '20211', 218, 9, 12671, 38.9002, 0.678936569684298, -77.0082, -1.3440466410343),
(8316, '20212', 218, 9, 12671, 38.8971, 0.678882464477486, -77.0086, -1.34405362235131),
(8317, '20213', 218, 9, 12671, 38.8917, 0.678788216697879, -77.0136, -1.34414088881391),
(8318, '20214', 218, 9, 12671, 38.9168, 0.679226294340129, -76.995, -1.34381625757303),
(8319, '20215', 218, 9, 12671, 38.8923, 0.678798688673391, -77.0138, -1.34414437947241),
(8320, '20216', 218, 9, 12671, 38.892, 0.678793452685635, -77.014, -1.34414787013091),
(8321, '20217', 218, 9, 12671, 38.8946, 0.678838831246186, -77.0131, -1.34413216216765),
(8322, '20218', 218, 9, 12671, 38.8921, 0.678795198014887, -76.942, -1.34289123306948),
(8323, '20219', 218, 9, 12671, 38.8831, 0.678638118382207, -77.0144, -1.34415485144792),
(8324, '20220', 218, 9, 12671, 38.8989, 0.678913880404022, -77.0329, -1.34447773735954),
(8325, '20221', 218, 9, 12671, 38.8957, 0.678858029867958, -77.0288, -1.34440617886021),
(8326, '20222', 218, 9, 12671, 38.8975, 0.678889445794494, -77.0329, -1.34447773735954),
(8327, '20223', 218, 9, 12671, 38.8979, 0.678896427111502, -77.0343, -1.34450217196907),
(8328, '20224', 218, 9, 12671, 38.8923, 0.678798688673391, -77.0278, -1.34438872556769),
(8329, '20226', 218, 9, 12671, 38.8975, 0.678889445794494, -77.0344, -1.34450391729832),
(8330, '20227', 218, 9, 12671, 38.8954, 0.678852793880202, -77.0313, -1.34444981209151),
(8331, '20228', 218, 9, 12671, 38.8853, 0.678676515625751, -77.0318, -1.34445853873777),
(8332, '20229', 218, 9, 12671, 38.8916, 0.678786471368627, -77.0306, -1.34443759478674),
(8333, '20230', 218, 9, 12671, 38.9035, 0.678994165549614, -77.0338, -1.34449344532281),
(8334, '20231', 218, 9, 12671, 38.8575, 0.678191314093697, -77.0522, -1.34481458590517),
(8335, '20232', 218, 9, 12671, 38.9188, 0.679261200925169, -77.0379, -1.34456500382214),
(8336, '20233', 218, 9, 12671, 38.8452, 0.677976638595701, -76.9292, -1.34266783092522),
(8337, '20235', 218, 9, 12671, 38.9122, 0.679146009194537, -77.0442, -1.34467495956502),
(8338, '20237', 218, 9, 12671, 38.8952, 0.678849303221699, -77.0371, -1.34455104118812),
(8339, '20238', 218, 9, 12671, 38.9035, 0.678994165549614, -77.0444, -1.34467845022352),
(8340, '20239', 218, 9, 12671, 38.8799, 0.678582267846143, -77.0317, -1.34445679340852),
(8341, '20240', 218, 9, 12671, 38.8937, 0.678823123282919, -77.042, -1.34463656232147),
(8342, '20241', 218, 9, 12671, 38.8959, 0.678861520526462, -77.051, -1.34479364195415),
(8343, '20242', 218, 9, 12671, 38.9606, 0.679990748552503, -77.0419, -1.34463481699222),
(8344, '20244', 218, 9, 12671, 38.9178, 0.679243747632649, -76.9941, -1.34380054960977),
(8345, '20245', 218, 9, 12671, 38.8915, 0.678784726039375, -77.0439, -1.34466972357726),
(8346, '20250', 218, 9, 12671, 38.8852, 0.678674770296499, -77.0312, -1.34444806676226),
(8347, '20251', 218, 9, 12671, 38.8846, 0.678664298320987, -77.0252, -1.34434334700714),
(8348, '20254', 218, 9, 12671, 38.8827, 0.678631137065199, -77.0185, -1.34422640994725),
(8349, '20260', 218, 9, 12671, 38.878, 0.678549106590355, -77.0183, -1.34422291928875),
(8350, '20261', 218, 9, 12671, 38.8842, 0.678657317003979, -77.0191, -1.34423688192276),
(8351, '20262', 218, 9, 12671, 38.9175, 0.679238511644893, -76.9948, -1.34381276691453),
(8352, '20265', 218, 9, 12671, 38.8837, 0.678648590357719, -77.0193, -1.34424037258127),
(8353, '20266', 218, 9, 12671, 38.8833, 0.678641609040711, -77.019, -1.34423513659351),
(8354, '20268', 218, 9, 12671, 38.8998, 0.67892958836729, -77.0306, -1.34443759478674),
(8355, '20270', 218, 9, 12671, 38.9004, 0.678940060342802, -77.0226, -1.34429796844658),
(8356, '20277', 218, 9, 12671, 38.8837, 0.678648590357719, -77.0194, -1.34424211791052),
(8357, '20289', 218, 9, 12671, 38.8839, 0.678652081016223, -77.0198, -1.34424909922753),
(8358, '20299', 218, 9, 12671, 38.9178, 0.679243747632649, -76.9938, -1.34379531362201),
(8359, '20301', 218, 9, 12671, 38.8917, 0.678788216697879, -77.0201, -1.34425433521528),
(8360, '20303', 218, 9, 12671, 38.9176, 0.679240256974145, -76.9947, -1.34381102158528),
(8361, '20306', 218, 9, 12671, 38.9718, 0.680186225428726, -77.0364, -1.34453882388336),
(8362, '20307', 218, 9, 12671, 38.9735, 0.68021589602601, -77.0277, -1.34438698023844),
(8363, '20310', 218, 9, 12671, 38.8709, 0.678425188213464, -77.0556, -1.34487392709974),
(8364, '20314', 218, 9, 12671, 38.8979, 0.678896427111502, -77.0108, -1.34409201959485),
(8365, '20315', 218, 9, 12671, 38.9337, 0.679521254983716, -77.016, -1.34418277671595),
(8366, '20317', 218, 9, 12671, 38.9418, 0.679662626653128, -77.0111, -1.34409725558261),
(8367, '20318', 218, 9, 12671, 38.866, 0.678339667080116, -77.0116, -1.34410598222887),
(8368, '20319', 218, 9, 12671, 38.8618, 0.678266363251532, -77.0169, -1.34419848467922),
(8369, '20330', 218, 9, 12671, 38.8706, 0.678419952225708, -77.0556, -1.34487392709974),
(8370, '20332', 218, 9, 12671, 38.8332, 0.677767199085462, -77.0212, -1.34427353383706),
(8371, '20336', 218, 9, 12671, 38.8368, 0.677830030938534, -77.018, -1.34421768330099),
(8372, '20337', 218, 9, 12671, 38.895, 0.678845812563195, -77.0363, -1.34453707855411),
(8373, '20338', 218, 9, 12671, 38.8956, 0.678856284538707, -77.0364, -1.34453882388336),
(8374, '20340', 218, 9, 12671, 38.8482, 0.678028998473261, -77.0154, -1.34417230474044),
(8375, '20350', 218, 9, 12671, 38.8706, 0.678419952225708, -77.0553, -1.34486869111199),
(8376, '20355', 218, 9, 12671, 38.8953, 0.67885104855095, -77.0368, -1.34454580520037),
(8377, '20370', 218, 9, 12671, 38.8766, 0.678524671980828, -76.9946, -1.34380927625603),
(8378, '20372', 218, 9, 12671, 38.9005, 0.678941805672054, -77.051, -1.34479364195415),
(8379, '20373', 218, 9, 0, 38.8616, 0.678262872593028, -77.0023, -1.34394366660843),
(8380, '20374', 218, 9, 0, 38.8303, 0.677716584537154, -77.0166, -1.34419324869146),
(8381, '20375', 218, 9, 12671, 38.9398, 0.679627720068088, -77.0895, -1.34546559371617),
(8382, '20376', 218, 9, 0, 38.9168, 0.679226294340129, -76.995, -1.34381625757303),
(8383, '20380', 218, 9, 12671, 38.876, 0.678514200005315, -76.9945, -1.34380753092677),
(8384, '20388', 218, 9, 0, 38.8763, 0.678519435993072, -76.994, -1.34379880428051),
(8385, '20389', 218, 9, 12671, 38.8433, 0.677943477339913, -76.9317, -1.34271146415652),
(8386, '20390', 218, 9, 12671, 38.8809, 0.678599721138663, -76.9959, -1.3438319655363),
(8387, '20391', 218, 9, 0, 38.8762, 0.67851769066382, -76.9934, -1.343788332305),
(8388, '20392', 218, 9, 12671, 38.9367, 0.679573614861276, -77.0595, -1.34494199494057),
(8389, '20393', 218, 9, 12671, 38.9427, 0.679678334616396, -77.0822, -1.34533818468077),
(8390, '20394', 218, 9, 12671, 38.9392, 0.679617248092576, -77.0892, -1.34546035772841),
(8391, '20395', 218, 9, 12671, 38.8629, 0.678285561873304, -76.9734, -1.3434392664546),
(8392, '20398', 218, 9, 0, 38.8762, 0.67851769066382, -76.9943, -1.34380404026827),
(8393, '20401', 218, 9, 12671, 38.8985, 0.678906899087014, -77.0095, -1.34406933031457),
(8394, '20402', 218, 9, 12671, 38.8989, 0.678913880404022, -77.0089, -1.34405885833906),
(8395, '20403', 218, 9, 12671, 38.8872, 0.678709676881539, -77.0158, -1.34417928605745),
(8396, '20404', 218, 9, 12671, 38.8986, 0.678908644416266, -77.0092, -1.34406409432682),
(8397, '20405', 218, 9, 12671, 38.902, 0.678967985610834, -77.0232, -1.3443084404221),
(8398, '20406', 218, 9, 12671, 38.8583, 0.678205276727713, -77.0517, -1.34480585925891),
(8399, '20407', 218, 9, 12671, 38.8857, 0.678683496942759, -77.0227, -1.34429971377584),
(8400, '20408', 218, 9, 12671, 38.8928, 0.678807415319651, -77.0227, -1.34429971377584),
(8401, '20409', 218, 9, 12671, 38.8551, 0.678149426191649, -76.9404, -1.34286330780145),
(8402, '20410', 218, 9, 12671, 38.8842, 0.678657317003979, -77.0228, -1.34430145910509),
(8403, '20411', 218, 9, 12671, 38.8842, 0.678657317003979, -77.0221, -1.34428924180032),
(8404, '20412', 218, 9, 12671, 38.8953, 0.67885104855095, -77.023, -1.34430494976359),
(8405, '20413', 218, 9, 12671, 38.896, 0.678863265855714, -77.0227, -1.34429971377584),
(8406, '20414', 218, 9, 12671, 38.8843, 0.678659062333231, -77.0225, -1.34429622311733),
(8407, '20415', 218, 9, 12671, 38.896, 0.678863265855714, -77.0429, -1.34465227028474),
(8408, '20416', 218, 9, 12671, 38.8848, 0.678667788979491, -77.0163, -1.34418801270371),
(8409, '20418', 218, 9, 12671, 38.8916, 0.678786471368627, -77.0455, -1.34469764884529),
(8410, '20419', 218, 9, 12671, 38.9038, 0.67899940153737, -77.0336, -1.3444899546643),
(8411, '20420', 218, 9, 12671, 38.9039, 0.679001146866622, -77.0281, -1.34439396155544),
(8412, '20421', 218, 9, 12671, 38.9035, 0.678994165549614, -77.0336, -1.3444899546643),
(8413, '20422', 218, 9, 12671, 38.9327, 0.679503801691196, -77.0312, -1.34444806676226),
(8414, '20423', 218, 9, 12671, 38.8919, 0.678791707356383, -77.0285, -1.34440094287245),
(8415, '20424', 218, 9, 12671, 38.8973, 0.67888595513599, -77.0316, -1.34445504807926),
(8416, '20425', 218, 9, 12671, 38.898, 0.678898172440754, -77.025, -1.34433985634863),
(8417, '20426', 218, 9, 12671, 38.9014, 0.678957513635322, -77.0066, -1.34401871576627),
(8418, '20427', 218, 9, 12671, 38.9004, 0.678940060342802, -77.0401, -1.34460340106568),
(8419, '20428', 218, 9, 12671, 38.9149, 0.679193133084341, -77.0454, -1.34469590351604),
(8420, '20429', 218, 9, 12671, 38.8931, 0.678812651307407, -77.0433, -1.34465925160175),
(8421, '20431', 218, 9, 12671, 38.8976, 0.678891191123746, -77.0431, -1.34465576094324),
(8422, '20433', 218, 9, 12671, 38.9068, 0.67905176141493, -77.0423, -1.34464179830923),
(8423, '20434', 218, 9, 12671, 38.8956, 0.678856284538707, -77.0385, -1.34457547579765),
(8424, '20435', 218, 9, 12671, 38.9152, 0.679198369072097, -77.076, -1.34522997426715),
(8425, '20436', 218, 9, 12671, 38.8965, 0.678871992501975, -77.0224, -1.34429447778808),
(8426, '20437', 218, 9, 12671, 38.9024, 0.678974966927842, -77.0484, -1.3447482633936),
(8427, '20439', 218, 9, 12671, 38.9038, 0.67899940153737, -77.0324, -1.34446901071328),
(8428, '20440', 218, 9, 12671, 38.9142, 0.679180915779577, -77.0448, -1.34468543154053),
(8429, '20441', 218, 9, 12671, 38.9232, 0.679337995412257, -77.0362, -1.34453533322486),
(8430, '20442', 218, 9, 12671, 38.8954, 0.678852793880202, -77.0174, -1.34420721132548),
(8431, '20444', 218, 9, 12671, 38.8975, 0.678889445794494, -77.009, -1.34406060366831),
(8432, '20447', 218, 9, 12671, 38.8849, 0.678669534308743, -77.0253, -1.34434509233639),
(8433, '20451', 218, 9, 12671, 38.8945, 0.678837085916934, -77.0464, -1.34471335680856),
(8434, '20453', 218, 9, 12671, 38.8711, 0.678428678871968, -77.0558, -1.34487741775825),
(8435, '20456', 218, 9, 12671, 38.8978, 0.67889468178225, -77.0413, -1.34462434501671),
(8436, '20460', 218, 9, 12671, 38.8776, 0.678542125273347, -77.018, -1.34421768330099),
(8437, '20463', 218, 9, 12671, 38.8963, 0.67886850184347, -77.0257, -1.3443520736534),
(8438, '20468', 218, 9, 12671, 38.8947, 0.678840576575439, -77.0372, -1.34455278651738),
(8439, '20469', 218, 9, 12671, 38.8969, 0.678878973818982, -77.0415, -1.34462783567521),
(8440, '20470', 218, 9, 12671, 38.8955, 0.678854539209454, -77.0365, -1.34454056921261),
(8441, '20472', 218, 9, 12671, 38.8858, 0.678685242272011, -77.0187, -1.34422990060576),
(8442, '20500', 218, 9, 12671, 38.8988, 0.67891213507477, -77.0418, -1.34463307166297),
(8443, '20501', 218, 9, 12671, 38.899, 0.678915625733274, -77.0328, -1.34447599203029),
(8444, '20502', 218, 9, 12671, 38.8986, 0.678908644416266, -77.0335, -1.34448820933505),
(8445, '20503', 218, 9, 12671, 38.8993, 0.67892086172103, -77.0387, -1.34457896645616),
(8446, '20504', 218, 9, 12671, 38.8976, 0.678891191123746, -77.0426, -1.34464703429698),
(8447, '20505', 218, 9, 12671, 38.8968, 0.67887722848973, -77.0402, -1.34460514639494),
(8448, '20506', 218, 9, 12671, 38.899, 0.678915625733274, -77.0379, -1.34456500382214),
(8449, '20507', 218, 9, 12671, 38.903, 0.678985438903354, -77.0407, -1.3446138730412),
(8450, '20508', 218, 9, 12671, 38.8997, 0.678927843038038, -77.0392, -1.34458769310242),
(8451, '20509', 218, 9, 12671, 38.8953, 0.67885104855095, -77.0365, -1.34454056921261),
(8452, '20510', 218, 9, 12671, 38.8898, 0.678755055442091, -77.0112, -1.34409900091186),
(8453, '20515', 218, 9, 12671, 38.8897, 0.678753310112839, -77.0109, -1.3440937649241),
(8454, '20520', 218, 9, 12671, 38.8929, 0.678809160648903, -77.0479, -1.34473953674734),
(8455, '20521', 218, 9, 12671, 38.9005, 0.678941805672054, -77.0513, -1.34479887794191),
(8456, '20522', 218, 9, 12671, 38.8927, 0.678805669990399, -77.0484, -1.3447482633936),
(8457, '20523', 218, 9, 12671, 38.895, 0.678845812563195, -77.0461, -1.3447081208208),
(8458, '20524', 218, 9, 12671, 38.9023, 0.67897322159859, -77.032, -1.34446202939627),
(8459, '20525', 218, 9, 12671, 38.9009, 0.678948786989062, -77.0287, -1.34440443353096),
(8460, '20526', 218, 9, 12671, 38.9022, 0.678971476269338, -77.0437, -1.34466623291876),
(8461, '20527', 218, 9, 12671, 38.901, 0.678950532318314, -77.0279, -1.34439047089694),
(8462, '20530', 218, 9, 12671, 38.8934, 0.678817887295163, -77.0249, -1.34433811101938),
(8463, '20531', 218, 9, 12671, 38.8941, 0.678830104599927, -77.0204, -1.34425957120304),
(8464, '20532', 218, 9, 12671, 38.9037, 0.678997656208118, -77.0177, -1.34421244731324),
(8465, '20533', 218, 9, 12671, 38.901, 0.678950532318314, -77.0315, -1.34445330275001),
(8466, '20534', 218, 9, 12671, 38.8933, 0.678816141965911, -77.0126, -1.34412343552139),
(8467, '20535', 218, 9, 12671, 38.894, 0.678828359270675, -77.0246, -1.34433287503162),
(8468, '20536', 218, 9, 12671, 38.9015, 0.678959258964574, -77.0174, -1.34420721132548),
(8469, '20537', 218, 9, 12671, 38.8938, 0.678824868612171, -77.0251, -1.34434160167788),
(8470, '20538', 218, 9, 12671, 38.9013, 0.67895576830607, -77.0176, -1.34421070198398),
(8471, '20539', 218, 9, 12671, 38.8976, 0.678891191123746, -77.031, -1.34444457610375),
(8472, '20540', 218, 9, 12671, 38.8879, 0.678721894186303, -77.0059, -1.3440064984615),
(8473, '20541', 218, 9, 12671, 38.8874, 0.678713167540043, -77.0054, -1.34399777181524),
(8474, '20542', 218, 9, 12671, 38.9407, 0.679643428031356, -77.0292, -1.34441316017722),
(8475, '20543', 218, 9, 12671, 38.8897, 0.678753310112839, -77.0055, -1.34399951714449),
(8476, '20544', 218, 9, 12671, 38.9057, 0.679032562793158, -77.0386, -1.3445772211269),
(8477, '20546', 218, 9, 12671, 38.8824, 0.678625901077443, -76.9918, -1.34376040703697),
(8478, '20547', 218, 9, 12671, 38.8878, 0.678720148857051, -77.0154, -1.34417230474044),
(8479, '20548', 218, 9, 12671, 38.8978, 0.67889468178225, -77.0175, -1.34420895665473),
(8480, '20549', 218, 9, 12671, 38.8952, 0.678849303221699, -77.0189, -1.34423339126426),
(8481, '20550', 218, 9, 12671, 38.8979, 0.678896427111502, -77.0426, -1.34464703429698),
(8482, '20551', 218, 9, 12671, 38.8916, 0.678786471368627, -77.0445, -1.34468019555277),
(8483, '20552', 218, 9, 12671, 38.9011, 0.678952277647566, -77.0279, -1.34439047089694),
(8484, '20553', 218, 9, 12671, 38.8879, 0.678721894186303, -77.0235, -1.34431367640985),
(8485, '20554', 218, 9, 12671, 38.9154, 0.679201859730601, -77.0432, -1.3446575062725),
(8486, '20555', 218, 9, 12671, 38.894, 0.678828359270675, -77.0423, -1.34464179830923),
(8487, '20557', 218, 9, 12671, 38.8819, 0.678617174431183, -76.9926, -1.34377436967099),
(8488, '20558', 218, 9, 12671, 38.895, 0.678845812563195, -77.0363, -1.34453707855411),
(8489, '20559', 218, 9, 12671, 38.8873, 0.678711422210791, -77.0059, -1.3440064984615),
(8490, '20560', 218, 9, 12671, 38.8887, 0.678735856820319, -77.0251, -1.34434160167788),
(8491, '20565', 218, 9, 12671, 38.9048, 0.67901685482989, -76.9864, -1.34366615925736),
(8492, '20566', 218, 9, 12671, 38.9004, 0.678940060342802, -77.0491, -1.34476048069836),
(8493, '20570', 218, 9, 12671, 38.8994, 0.678922607050282, -77.0396, -1.34459467441942),
(8494, '20571', 218, 9, 12671, 38.9008, 0.67894704165981, -77.0348, -1.34451089861533),
(8495, '20572', 218, 9, 12671, 38.9024, 0.678974966927842, -77.0301, -1.34442886814048),
(8496, '20573', 218, 9, 12671, 38.9002, 0.678936569684298, -77.0084, -1.3440501316928),
(8497, '20575', 218, 9, 12671, 38.8993, 0.67892086172103, -77.0377, -1.34456151316364),
(8498, '20576', 218, 9, 12671, 38.8985, 0.678906899087014, -77.031, -1.34444457610375),
(8499, '20577', 218, 9, 12671, 38.9028, 0.67898194824485, -77.0376, -1.34455976783438),
(8500, '20578', 218, 9, 12671, 38.8972, 0.678884209806738, -77.01, -1.34407805696083),
(8501, '20579', 218, 9, 12671, 38.9033, 0.67899067489111, -77.0447, -1.34468368621128),
(8502, '20580', 218, 9, 12671, 38.8935, 0.678819632624415, -77.0226, -1.34429796844658),
(8503, '20581', 218, 9, 12671, 38.8937, 0.678823123282919, -77.0435, -1.34466274226025),
(8504, '20585', 218, 9, 12671, 38.8878, 0.678720148857051, -77.0247, -1.34433462036088),
(8505, '20586', 218, 9, 12671, 38.9022, 0.678971476269338, -77.0468, -1.34472033812557),
(8506, '20590', 218, 9, 12671, 38.8813, 0.678606702455671, -77.0247, -1.34433462036088),
(8507, '20591', 218, 9, 12671, 38.887, 0.678706186223035, -77.0227, -1.34429971377584),
(8508, '20593', 218, 9, 12671, 38.8647, 0.67831697779984, -77.0142, -1.34415136078942),
(8509, '20594', 218, 9, 12671, 38.8871, 0.678707931552287, -77.0229, -1.34430320443434),
(8510, '20597', 218, 9, 12671, 38.895, 0.678845812563195, -77.037, -1.34454929585887),
(8511, '20599', 218, 9, 12671, 38.853, 0.678112774277357, -76.9365, -1.34279523996062),
(8512, '20601', 218, 25, 52455, 38.6283, 0.674191019448126, -76.8758, -1.34173582510466),
(8513, '20602', 218, 25, 52455, 38.6008, 0.673711053903827, -76.9027, -1.34220531867344),
(8514, '20603', 218, 25, 52455, 38.6296, 0.674213708728402, -76.9676, -1.34333803735799),
(8515, '20604', 218, 25, 52455, 38.6197, 0.674040921132454, -76.8909, -1.34199936982171),
(8516, '20606', 218, 25, 44260, 38.2522, 0.667626836131375, -76.7382, -1.33933425205391),
(8517, '20607', 218, 25, 44275, 38.6726, 0.674964200306759, -77.0205, -1.34426131653229),
(8518, '20608', 218, 25, 44417, 38.5813, 0.673370714699688, -76.7123, -1.33888221177765),
(8519, '20609', 218, 25, 44519, 38.2788, 0.668091093712405, -76.7236, -1.33907943398312),
(8520, '20610', 218, 25, 44611, 38.5305, 0.672484087439675, -76.6149, -1.3371822610862),
(8521, '20611', 218, 25, 44699, 38.4669, 0.671374058035407, -76.9833, -1.34361205405055),
(8522, '20612', 218, 25, 19194, 38.5094, 0.672115822967504, -76.68, -1.33831847042925),
(8523, '20613', 218, 25, 13415, 38.6798, 0.675089864012903, -76.8169, -1.34070782617523),
(8524, '20615', 218, 25, 45177, 38.4213, 0.670578187896497, -76.5489, -1.33603034377989),
(8525, '20616', 218, 25, 45203, 38.6297, 0.674215454057653, -77.0765, -1.34523870091341),
(8526, '20617', 218, 25, 45205, 38.5554, 0.672918674423422, -76.8229, -1.34081254593035),
(8527, '20618', 218, 25, 45271, 38.2775, 0.66806840443213, -76.7969, -1.34035876032483),
(8528, '20619', 218, 25, 19701, 38.3008, 0.668475066147844, -76.5181, -1.33549278237027),
(8529, '20620', 218, 25, 15401, 38.2368, 0.667358055426568, -76.5239, -1.33559401146689),
(8530, '20621', 218, 25, 45618, 38.3301, 0.668986447618679, -76.7934, -1.34029767380101),
(8531, '20622', 218, 25, 45634, 38.498, 0.671916855432777, -76.7641, -1.33978629233018),
(8532, '20623', 218, 25, 45665, 38.7482, 0.676283669221267, -76.8295, -1.34092773766098),
(8533, '20624', 218, 25, 461, 38.343, 0.669211595092186, -76.7315, -1.33921731499403),
(8534, '20625', 218, 25, 0, 38.2625, 0.66780660504433, -76.8455, -1.3412069903413),
(8535, '20626', 218, 25, 45936, 38.2378, 0.667375508719088, -76.7681, -1.33985610550026),
(8536, '20627', 218, 25, 1738, 38.3047, 0.668543133988672, -76.6342, -1.33751910963184),
(8537, '20628', 218, 25, 46175, 38.1424, 0.665710464612685, -76.3288, -1.33218887409625),
(8538, '20629', 218, 25, 26982, 38.3382, 0.66912781928809, -76.453, -1.33435657302722),
(8539, '20630', 218, 25, 46673, 38.1736, 0.666255007339307, -76.4723, -1.33469342157286),
(8540, '20632', 218, 25, 32440, 38.43, 0.670730031541421, -76.9704, -1.34338690657704),
(8541, '20634', 218, 25, 47608, 38.2567, 0.667705375947715, -76.4933, -1.33505994071578),
(8542, '20635', 218, 25, 16401, 38.3326, 0.669030080849978, -76.7862, -1.34017201009487),
(8543, '20636', 218, 25, 3203, 38.3552, 0.669424525260929, -76.573, -1.33645096812962),
(8544, '20637', 218, 25, 48332, 38.524, 0.672370641038296, -76.7752, -1.33998002387715),
(8545, '20639', 218, 25, 48393, 38.6082, 0.673840208268475, -76.6007, -1.33693442433242),
(8546, '20640', 218, 25, 48442, 38.5957, 0.673622042111976, -77.1551, -1.34661052970548),
(8547, '20643', 218, 25, 48473, 38.4916, 0.671805154360649, -77.1598, -1.34669256018032),
(8548, '20645', 218, 25, 0, 38.3059, 0.668564077939696, -76.9207, -1.3425194779388),
(8549, '20646', 218, 25, 48763, 38.5243, 0.672375877026051, -76.9736, -1.34344275711311),
(8550, '20650', 218, 25, 951, 38.2946, 0.668366855734221, -76.6509, -1.33781057961692),
(8551, '20653', 218, 25, 48923, 38.2717, 0.667967175335514, -76.4668, -1.334597428464),
(8552, '20656', 218, 25, 14150, 38.3515, 0.669359948078605, -76.679, -1.33830101713673),
(8553, '20657', 218, 25, 49113, 38.3637, 0.669572878247349, -76.4271, -1.33390453275096),
(8554, '20658', 218, 25, 3985, 38.5611, 0.673018158190785, -77.1642, -1.34676935466741),
(8555, '20659', 218, 25, 4145, 38.4369, 0.670850459259808, -76.7253, -1.33910910458041),
(8556, '20660', 218, 25, 42170, 38.3753, 0.66977533644058, -76.6953, -1.33858550580481),
(8557, '20661', 218, 25, 49675, 38.3563, 0.669443723882701, -76.8967, -1.34210059891832),
(8558, '20662', 218, 25, 49739, 38.4113, 0.670403654971298, -77.1889, -1.34720045099265),
(8559, '20664', 218, 25, 4565, 38.3563, 0.669443723882701, -76.9435, -1.34291741300826),
(8560, '20667', 218, 25, 50192, 38.2174, 0.667019461551681, -76.4492, -1.33429025051565),
(8561, '20670', 218, 25, 0, 38.2808, 0.668126000297445, -76.421, -1.33379806766659),
(8562, '20674', 218, 25, 14426, 38.1425, 0.665712209941937, -76.5098, -1.33534792004236),
(8563, '20675', 218, 25, 50510, 38.5743, 0.673248541652049, -77.032, -1.34446202939627),
(8564, '20676', 218, 25, 50539, 38.4934, 0.671836570287185, -76.5315, -1.33572665649004),
(8565, '20677', 218, 25, 50540, 38.5082, 0.67209487901648, -77.0426, -1.34464703429698),
(8566, '20678', 218, 25, 50606, 38.5309, 0.672491068756683, -76.587, -1.3366953142249),
(8567, '20680', 218, 25, 5385, 38.1178, 0.665281113616695, -76.3718, -1.33293936567461),
(8568, '20682', 218, 25, 50945, 38.3483, 0.669304097542542, -76.9204, -1.34251424195105),
(8569, '20684', 218, 25, 0, 38.1509, 0.665858817599105, -76.414, -1.33367589461895),
(8570, '20685', 218, 25, 51169, 38.4492, 0.671065134757804, -76.5035, -1.33523796429948),
(8571, '20686', 218, 25, 0, 38.1871, 0.666490626788327, -76.4349, -1.33404066843261),
(8572, '20687', 218, 25, 5690, 38.0757, 0.664546330001605, -76.3491, -1.3325431759344),
(8573, '20688', 218, 25, 51530, 38.3357, 0.66908418605679, -76.4521, -1.33434086506396),
(8574, '20689', 218, 25, 51821, 38.6587, 0.674721599540732, -76.5867, -1.33669007823714),
(8575, '20690', 218, 25, 43283, 38.1662, 0.66612585297466, -76.5442, -1.33594831330504),
(8576, '20692', 218, 25, 52340, 38.1705, 0.666200902132496, -76.5046, -1.33525716292125),
(8577, '20693', 218, 25, 12723, 38.4815, 0.671628876106198, -77.0905, -1.34548304700869),
(8578, '20695', 218, 25, 6780, 38.5982, 0.673665675343275, -76.9855, -1.34365045129409),
(8579, '20697', 218, 25, 0, 39.0341, 0.681273565552719, -76.9073, -1.34228560381904),
(8580, '20701', 218, 25, 0, 39.1204, 0.68277978469719, -76.7912, -1.34025927655747),
(8581, '20703', 218, 25, 48830, 38.9762, 0.680263019915814, -76.8385, -1.34108481729366),
(8582, '20704', 218, 25, 44743, 39.0397, 0.68137130399083, -76.9089, -1.34231352908707),
(8583, '20705', 218, 25, 44743, 39.043, 0.681428899856146, -76.9076, -1.34229083980679),
(8584, '20706', 218, 25, 48830, 38.9663, 0.680090232319866, -76.8541, -1.34135708865697),
(8585, '20707', 218, 25, 14092, 39.0992, 0.682409774895767, -76.8709, -1.34165030397131),
(8586, '20708', 218, 25, 14092, 39.0672, 0.681851269535129, -76.8458, -1.34121222632906),
(8587, '20709', 218, 25, 14092, 39.0653, 0.681818108279341, -76.8393, -1.34109877992768),
(8588, '20710', 218, 25, 44866, 38.9419, 0.67966437198238, -76.9294, -1.34267132158373),
(8589, '20711', 218, 25, 49084, 38.8075, 0.677318649467699, -76.6526, -1.33784025021421),
(8590, '20712', 218, 25, 49668, 38.9422, 0.679669607970136, -76.9632, -1.3432612428709),
(8591, '20714', 218, 25, 17301, 38.7071, 0.675566338898697, -76.5369, -1.33582090426965),
(8592, '20715', 218, 25, 39466, 38.9779, 0.680292690513098, -76.7616, -1.33974265909888),
(8593, '20716', 218, 25, 39466, 38.9277, 0.679416535228597, -76.7687, -1.33986657747577),
(8594, '20717', 218, 25, 39466, 39.0065, 0.680791854679168, -76.7796, -1.34005681836424),
(8595, '20718', 218, 25, 39466, 38.9827, 0.680376466317194, -76.7572, -1.33966586461179),
(8596, '20719', 218, 25, 39466, 38.9594, 0.679969804601479, -76.7375, -1.33932203474915),
(8597, '20720', 218, 25, 39466, 38.9754, 0.680249057281798, -76.7901, -1.3402400779357),
(8598, '20721', 218, 25, 39466, 38.9212, 0.679303088827217, -76.8095, -1.34057867181058),
(8599, '20722', 218, 25, 1106, 38.9392, 0.679617248092576, -76.9511, -1.34305005803141),
(8600, '20723', 218, 25, 14092, 39.1324, 0.682989224207429, -76.8606, -1.34147053505835),
(8601, '20724', 218, 25, 14092, 39.095, 0.682336471067183, -76.8187, -1.34073924210177),
(8602, '20725', 218, 25, 14092, 39.1042, 0.682497041358367, -76.8447, -1.34119302770729),
(8603, '20726', 218, 25, 14092, 39.0928, 0.682298073823639, -76.8531, -1.34133963536445),
(8604, '20731', 218, 25, 45383, 38.8839, 0.678652081016223, -76.9117, -1.34236239830612),
(8605, '20732', 218, 25, 45689, 38.6648, 0.674828064625103, -76.5355, -1.33579646966012),
(8606, '20733', 218, 25, 45791, 38.8016, 0.677215675041832, -76.5273, -1.33565335266146),
(8607, '20735', 218, 25, 1630, 38.7565, 0.676428531549182, -76.9039, -1.34222626262447),
(8608, '20736', 218, 25, 50150, 38.6956, 0.675365626034718, -76.6161, -1.33720320503723),
(8609, '20737', 218, 25, 5416, 38.9605, 0.679989003223251, -76.9183, -1.34247759003675),
(8610, '20738', 218, 25, 5416, 38.9642, 0.680053580405575, -76.9276, -1.34263990565719),
(8611, '20740', 218, 25, 13567, 38.9982, 0.680646992351253, -76.9276, -1.34263990565719),
(8612, '20741', 218, 25, 13567, 38.9957, 0.680603359119953, -76.9351, -1.34277080535109),
(8613, '20742', 218, 25, 13567, 38.9921, 0.680540527266881, -76.9528, -1.34307972862869),
(8614, '20743', 218, 25, 45383, 38.8859, 0.678686987601263, -76.9021, -1.34219484669793),
(8615, '20744', 218, 25, 47163, 38.7551, 0.676404096939654, -76.9829, -1.34360507273354),
(8616, '20745', 218, 25, 50162, 38.8074, 0.677316904138447, -76.9899, -1.34372724578118),
(8617, '20746', 218, 25, 51793, 38.8386, 0.67786144686507, -76.9174, -1.34246188207349),
(8618, '20747', 218, 25, 46611, 38.8542, 0.678133718228381, -76.8849, -1.34189465006659),
(8619, '20748', 218, 25, 51971, 38.8166, 0.677477474429631, -76.941, -1.34287377977696),
(8620, '20749', 218, 25, 47163, 38.7348, 0.6760497951015, -77.0037, -1.34396810121796),
(8621, '20750', 218, 25, 50162, 38.8034, 0.677247090968368, -76.9923, -1.34376913368323),
(8622, '20751', 218, 25, 46218, 38.7834, 0.676898025117969, -76.5525, -1.33609317563296),
(8623, '20752', 218, 25, 51793, 38.8489, 0.678041215778025, -76.9245, -1.34258580045038),
(8624, '20753', 218, 25, 46611, 38.8586, 0.678210512715469, -76.8872, -1.34193479263938),
(8625, '20754', 218, 25, 32273, 38.7335, 0.676027105821224, -76.659, -1.33795195128633),
(8626, '20755', 218, 25, 0, 39.1062, 0.682531947943407, -76.7398, -1.33936217732194),
(8627, '20757', 218, 25, 51971, 38.8095, 0.677353556052739, -76.9492, -1.34301689677562),
(8628, '20758', 218, 25, 2610, 38.7345, 0.676044559113744, -76.5943, -1.33682272326029),
(8629, '20759', 218, 25, 2628, 39.1523, 0.683336544728576, -76.9305, -1.3426905202055),
(8630, '20762', 218, 25, 0, 38.8023, 0.677227892346596, -76.8818, -1.34184054485978),
(8631, '20763', 218, 25, 38115, 39.141, 0.683139322523101, -76.8268, -1.34088061377118),
(8632, '20764', 218, 25, 14590, 38.836, 0.677816068304518, -76.5109, -1.33536711866413),
(8633, '20765', 218, 25, 47338, 38.8437, 0.677950458656921, -76.5511, -1.33606874102343),
(8634, '20768', 218, 25, 47662, 39.0009, 0.680694116241056, -76.8763, -1.34174455175092),
(8635, '20769', 218, 25, 47501, 38.9796, 0.680322361110382, -76.8052, -1.34050362265275),
(8636, '20770', 218, 25, 47662, 38.9974, 0.680633029717237, -76.8813, -1.34183181821352),
(8637, '20771', 218, 25, 47662, 39.0063, 0.680788364020664, -76.8685, -1.34160841606926),
(8638, '20772', 218, 25, 52318, 38.8227, 0.677583939514003, -76.7909, -1.34025404056971),
(8639, '20773', 218, 25, 52318, 38.8152, 0.677453039820103, -76.7534, -1.33959954210022),
(8640, '20774', 218, 25, 52318, 38.8826, 0.678629391735947, -76.7646, -1.33979501897644),
(8641, '20775', 218, 25, 52318, 38.7839, 0.676906751764229, -76.7682, -1.33985785082951),
(8642, '20776', 218, 25, 9373, 38.8683, 0.678379809652912, -76.6242, -1.33734457670664),
(8643, '20777', 218, 25, 3108, 39.1804, 0.683826982248386, -76.9682, -1.3433485093335),
(8644, '20778', 218, 25, 52634, 38.8325, 0.677754981780698, -76.5617, -1.33625374592414),
(8645, '20779', 218, 25, 52166, 38.7687, 0.676641461717926, -76.5764, -1.33651030932419),
(8646, '20781', 218, 25, 36543, 38.9484, 0.679777818383759, -76.9378, -1.34281792924089),
(8647, '20782', 218, 25, 36543, 38.9649, 0.680065797710338, -76.9636, -1.34326822418791),
(8648, '20783', 218, 25, 36543, 38.9931, 0.680557980559401, -76.9713, -1.34340261454031),
(8649, '20784', 218, 25, 36543, 38.9515, 0.679831923590571, -76.8925, -1.34202729508974),
(8650, '20785', 218, 25, 36543, 38.9175, 0.679238511644893, -76.8838, -1.34187545144482),
(8651, '20787', 218, 25, 36543, 38.9984, 0.680650483009757, -76.9697, -1.34337468927228),
(8652, '20788', 218, 25, 36543, 38.9644, 0.680057071064079, -76.9658, -1.34330662143145),
(8653, '20790', 218, 25, 45383, 38.8538, 0.678126736911373, -76.9309, -1.34269750152251),
(8654, '20791', 218, 25, 45383, 38.8187, 0.677514126343923, -76.9422, -1.34289472372798),
(8655, '20792', 218, 25, 52318, 38.8156, 0.677460021137111, -76.75, -1.33954020090565),
(8656, '20794', 218, 25, 626, 39.1558, 0.683397631252396, -76.8094, -1.34057692648133),
(8657, '20797', 218, 25, 0, 39.094, 0.682319017774663, -76.8415, -1.34113717717122),
(8658, '20799', 218, 25, 45383, 38.8809, 0.678599721138663, -76.8548, -1.34136930596174),
(8659, '20810', 218, 25, 7439, 38.9805, 0.68033806907365, -77.1002, -1.34565234394613),
(8660, '20811', 218, 25, 7439, 38.9805, 0.68033806907365, -77.1003, -1.34565408927538),
(8661, '20812', 218, 25, 47452, 38.9729, 0.680205424050498, -77.129, -1.34615499877071),
(8662, '20813', 218, 25, 7439, 38.9841, 0.680400900926721, -77.0805, -1.34530851408349),
(8663, '20814', 218, 25, 7439, 39.0006, 0.6806888802533, -77.105, -1.34573611975023),
(8664, '20815', 218, 25, 13056, 38.9812, 0.680350286378414, -77.0809, -1.3453154954005),
(8665, '20816', 218, 25, 7439, 38.958, 0.679945369991951, -77.1154, -1.34591763399244),
(8666, '20817', 218, 25, 7439, 38.997, 0.680626048400229, -77.1448, -1.34643076079252),
(8667, '20818', 218, 25, 45293, 38.9749, 0.680240330635538, -77.1609, -1.34671175880209),
(8668, '20824', 218, 25, 7439, 38.9833, 0.680386938292705, -77.0938, -1.345540642874),
(8669, '20825', 218, 25, 13056, 38.9951, 0.680592887144441, -77.0726, -1.34517063307258),
(8670, '20827', 218, 25, 7439, 39.0142, 0.680926245031572, -77.1607, -1.34670826814359),
(8671, '20830', 218, 25, 4784, 39.1578, 0.683432537837436, -77.0741, -1.34519681301136),
(8672, '20832', 218, 25, 4784, 39.1507, 0.683308619460544, -77.0733, -1.34518285037735),
(8673, '20833', 218, 25, 45142, 39.188, 0.683959627271538, -77.0577, -1.34491057901403),
(8674, '20837', 218, 25, 50520, 39.1309, 0.682963044268649, -77.4027, -1.35093196493341),
(8675, '20838', 218, 25, 19061, 39.2208, 0.684532095266192, -77.378, -1.35050086860817),
(8676, '20839', 218, 25, 44669, 39.1792, 0.683806038297362, -77.4194, -1.3512234349185),
(8677, '20841', 218, 25, 1070, 39.1911, 0.68401373247835, -77.3159, -1.34941701914268),
(8678, '20842', 218, 25, 46310, 39.2001, 0.684170812111029, -77.4151, -1.35114838576066),
(8679, '20847', 218, 25, 5479, 39.0837, 0.682139248861708, -77.1527, -1.34656864180343),
(8680, '20848', 218, 25, 5479, 39.0753, 0.68199264120454, -77.117, -1.34594555926047),
(8681, '20849', 218, 25, 5479, 39.084, 0.682144484849464, -77.1542, -1.34659482174221),
(8682, '20850', 218, 25, 5479, 39.0873, 0.68220208071478, -77.1748, -1.34695435956812),
(8683, '20851', 218, 25, 5479, 39.076, 0.682004858509304, -77.1252, -1.34608867625913),
(8684, '20852', 218, 25, 5479, 39.0481, 0.681517911647998, -77.1225, -1.34604155236933),
(8685, '20853', 218, 25, 5479, 39.0958, 0.682350433701199, -77.095, -1.34556158682503),
(8686, '20854', 218, 25, 50553, 39.0397, 0.68137130399083, -77.2027, -1.34744130642943),
(8687, '20855', 218, 25, 46293, 39.1347, 0.683029366780225, -77.1424, -1.34638887289047),
(8688, '20857', 218, 25, 5479, 39.081, 0.682092124971904, -77.1539, -1.34658958575445),
(8689, '20859', 218, 25, 50553, 39.0254, 0.681121721907795, -77.1973, -1.34734705864982),
(8690, '20860', 218, 25, 51214, 39.1489, 0.683277203534008, -77.028, -1.34439221622619),
(8691, '20861', 218, 25, 7180, 39.1568, 0.683415084544916, -77.017, -1.34420023000847),
(8692, '20862', 218, 25, 45102, 39.1809, 0.683835708894646, -77.0207, -1.3442648071908),
(8693, '20866', 218, 25, 45265, 39.098, 0.682388830944743, -76.9347, -1.34276382403408),
(8694, '20868', 218, 25, 51592, 39.1225, 0.682816436611482, -76.9744, -1.34345671974712),
(8695, '20871', 218, 25, 26799, 39.256, 0.685146451162894, -77.28, -1.34879044594122),
(8696, '20872', 218, 25, 1957, 39.2825, 0.685608963414672, -77.2143, -1.34764376462266),
(8697, '20874', 218, 25, 27253, 39.1692, 0.683631505372163, -77.2692, -1.348601950382),
(8698, '20875', 218, 25, 27253, 39.178, 0.683785094346338, -77.2607, -1.34845359739558),
(8699, '20876', 218, 25, 27253, 39.1912, 0.684015477807602, -77.2342, -1.3479910851438),
(8700, '20877', 218, 25, 47335, 39.1394, 0.683111397255069, -77.1911, -1.3472388482362),
(8701, '20878', 218, 25, 47335, 39.1088, 0.682577326503958, -77.2385, -1.34806613430164),
(8702, '20879', 218, 25, 47335, 39.1711, 0.683664666627951, -77.1846, -1.34712540183482),
(8703, '20880', 218, 25, 52517, 39.1398, 0.683118378572077, -77.1753, -1.34696308621438),
(8704, '20882', 218, 25, 47335, 39.2329, 0.684743280105683, -77.1723, -1.34691072633682),
(8705, '20883', 218, 25, 47335, 39.1437, 0.683186446412904, -77.2019, -1.34742734379541),
(8706, '20884', 218, 25, 47335, 39.1414, 0.683146303840108, -77.194, -1.3472894627845),
(8707, '20885', 218, 25, 47335, 39.1348, 0.683031112109477, -77.2261, -1.34784971347439),
(8708, '20886', 218, 25, 49572, 39.1714, 0.683669902615707, -77.2095, -1.34755998881856),
(8709, '20889', 218, 25, 7439, 39.0091, 0.68083723323972, -77.0975, -1.34560522005633),
(8710, '20891', 218, 25, 22347, 39.0262, 0.681135684541811, -77.0733, -1.34518285037735),
(8711, '20892', 218, 25, 7439, 39.0111, 0.68087213982476, -77.0988, -1.3456279093366),
(8712, '20894', 218, 25, 7439, 39.0043, 0.680753457435624, -77.0965, -1.34558776676381),
(8713, '20895', 218, 25, 22347, 39.0288, 0.681181063102363, -77.0791, -1.34528407947396),
(8714, '20896', 218, 25, 47364, 39.0345, 0.681280546869727, -77.0945, -1.34555286017877),
(8715, '20897', 218, 25, 0, 39.0903, 0.682254440592339, -77.056, -1.34488090841675),
(8716, '20898', 218, 25, 47335, 39.1436, 0.683184701083652, -77.2013, -1.3474168718199),
(8717, '20899', 218, 25, 47335, 39.1446, 0.683202154376172, -77.2166, -1.34768390719545),
(8718, '20901', 218, 25, 51446, 39.0194, 0.681017002152675, -77.0096, -1.34407107564383),
(8719, '20902', 218, 25, 51446, 39.0416, 0.681404465246618, -77.0479, -1.34473953674734),
(8720, '20903', 218, 25, 51446, 39.0188, 0.681006530177163, -76.9823, -1.34359460075803),
(8721, '20904', 218, 25, 51446, 39.0802, 0.682078162337888, -76.9827, -1.34360158207504),
(8722, '20905', 218, 25, 51446, 39.1036, 0.682486569382855, -76.9908, -1.34374295374445),
(8723, '20906', 218, 25, 51446, 39.0828, 0.68212354089844, -77.0592, -1.34493675895281),
(8724, '20907', 218, 25, 51446, 38.9965, 0.680617321753969, -77.0336, -1.3444899546643),
(8725, '20908', 218, 25, 51446, 39.103, 0.682476097407343, -77.0765, -1.34523870091341),
(8726, '20910', 218, 25, 51446, 39.0019, 0.680711569533576, -77.0354, -1.34452137059084),
(8727, '20911', 218, 25, 51446, 38.9958, 0.680605104449205, -77.0316, -1.34445504807926),
(8728, '20912', 218, 25, 51918, 38.9845, 0.680407882243729, -77.0076, -1.34403616905879),
(8729, '20913', 218, 25, 51918, 38.9821, 0.680365994341682, -77.0027, -1.34395064792544),
(8730, '20914', 218, 25, 51446, 39.0716, 0.681928064022216, -77.0035, -1.34396461055945),
(8731, '20915', 218, 25, 51446, 39.0433, 0.681434135843902, -77.0477, -1.34473604608884),
(8732, '20916', 218, 25, 51446, 39.0827, 0.682121795569188, -77.0783, -1.34527011683995),
(8733, '20918', 218, 25, 51446, 39.0211, 0.681046672749959, -77.0152, -1.34416881408194),
(8734, '20997', 218, 25, 51446, 38.9942, 0.680577179181173, -77.0267, -1.34436952694592),
(8735, '21001', 218, 25, 7017, 39.5114, 0.689604022072488, -76.186, -1.3296965439244),
(8736, '21005', 218, 25, 0, 39.4824, 0.689097876589409, -76.1251, -1.32863363840994),
(8737, '21009', 218, 25, 44263, 39.4733, 0.688939051627478, -76.2997, -1.33168098328392),
(8738, '21010', 218, 25, 47747, 39.404, 0.687729538455846, -76.2873, -1.33146456245667),
(8739, '21012', 218, 25, 26395, 39.0475, 0.681507439672486, -76.4983, -1.33514720717838),
(8740, '21013', 218, 25, 722, 39.5007, 0.689417271842524, -76.4945, -1.3350808846668),
(8741, '21014', 218, 25, 189, 39.5322, 0.689967050556902, -76.3363, -1.33231977379015),
(8742, '21015', 218, 25, 189, 39.5336, 0.68999148516643, -76.311, -1.33187820548939),
(8743, '21017', 218, 25, 499, 39.4737, 0.688946032944486, -76.2396, -1.33063204040347),
(8744, '21018', 218, 25, 642, 39.5052, 0.689495811658864, -76.3863, -1.33319243841614);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(8745, '21020', 218, 25, 44944, 39.5256, 0.689851858826271, -76.8185, -1.34073575144326),
(8746, '21022', 218, 25, 45152, 39.4077, 0.687794115638169, -76.6686, -1.33811950289452),
(8747, '21023', 218, 25, 1257, 39.5372, 0.690054317019502, -76.7305, -1.33919986170151),
(8748, '21027', 218, 25, 1501, 39.3542, 0.686860364488352, -76.374, -1.33297776291815),
(8749, '21028', 218, 25, 45792, 39.5631, 0.690506357295769, -76.2473, -1.33076643075587),
(8750, '21029', 218, 25, 848, 39.2022, 0.684207464025321, -76.9508, -1.34304482204365),
(8751, '21030', 218, 25, 45876, 39.4776, 0.689014100785313, -76.6482, -1.33776345572712),
(8752, '21031', 218, 25, 48347, 39.495, 0.68931778807516, -76.6702, -1.33814742816256),
(8753, '21032', 218, 25, 46135, 39.0458, 0.681477769075202, -76.5939, -1.33681574194328),
(8754, '21034', 218, 25, 1971, 39.645, 0.691935781953152, -76.2256, -1.33038769430819),
(8755, '21035', 218, 25, 46200, 38.9385, 0.679605030787812, -76.63, -1.33744580580325),
(8756, '21036', 218, 25, 1992, 39.241, 0.684884651775095, -76.9978, -1.34386512679209),
(8757, '21037', 218, 25, 2228, 38.9226, 0.679327523436745, -76.5395, -1.3358662828302),
(8758, '21040', 218, 25, 2230, 39.4291, 0.688167616098096, -76.3024, -1.33172810717372),
(8759, '21041', 218, 25, 46870, 39.2721, 0.685427449172465, -76.8349, -1.34102198544059),
(8760, '21042', 218, 25, 46870, 39.273, 0.685443157135733, -76.8677, -1.34159445343525),
(8761, '21043', 218, 25, 46870, 39.2657, 0.685315748100337, -76.8452, -1.34120175435355),
(8762, '21044', 218, 25, 1716, 39.2139, 0.684411667547804, -76.8802, -1.34181261959174),
(8763, '21045', 218, 25, 1716, 39.2057, 0.684268550549141, -76.8318, -1.34096788023378),
(8764, '21046', 218, 25, 1716, 39.1727, 0.683692591895983, -76.8513, -1.34130821943792),
(8765, '21047', 218, 25, 47008, 39.525, 0.689841386850759, -76.4318, -1.3339865632258),
(8766, '21048', 218, 25, 47070, 39.5023, 0.689445197110556, -76.9073, -1.34228560381904),
(8767, '21050', 218, 25, 2524, 39.5732, 0.69068263555022, -76.3974, -1.33338616996312),
(8768, '21051', 218, 25, 47154, 39.473, 0.688933815639722, -76.449, -1.33428675985715),
(8769, '21052', 218, 25, 47161, 39.2055, 0.684265059890637, -76.4463, -1.33423963596734),
(8770, '21053', 218, 25, 40997, 39.6935, 0.692782266640369, -76.7174, -1.3389712235695),
(8771, '21054', 218, 25, 47349, 39.0364, 0.681313708125515, -76.673, -1.33819629738161),
(8772, '21055', 218, 25, 27246, 39.4053, 0.687752227736121, -76.7611, -1.33973393245262),
(8773, '21056', 218, 25, 47406, 39.0754, 0.681994386533792, -76.4314, -1.33397958190879),
(8774, '21057', 218, 25, 47442, 39.4536, 0.688595221764835, -76.5096, -1.33534442938385),
(8775, '21060', 218, 25, 47444, 39.1613, 0.683493624361255, -76.5924, -1.3367895620045),
(8776, '21061', 218, 25, 47444, 39.1612, 0.683491879032003, -76.6149, -1.3371822610862),
(8777, '21062', 218, 25, 47444, 39.1662, 0.683579145494603, -76.6024, -1.3369640949297),
(8778, '21065', 218, 25, 48347, 39.4812, 0.689076932638385, -76.6442, -1.33769364255704),
(8779, '21071', 218, 25, 47524, 39.4888, 0.689209577661537, -76.7789, -1.34004460105947),
(8780, '21074', 218, 25, 47803, 39.633, 0.691726342442913, -76.8035, -1.34047395205546),
(8781, '21075', 218, 25, 46864, 39.2123, 0.684383742279773, -76.7143, -1.33891711836269),
(8782, '21076', 218, 25, 2963, 39.1592, 0.683456972446963, -76.7173, -1.33896947824025),
(8783, '21077', 218, 25, 47876, 39.1574, 0.683425556520428, -76.7035, -1.33872862280347),
(8784, '21078', 218, 25, 47941, 39.5799, 0.690799572610104, -76.1513, -1.32909091467396),
(8785, '21080', 218, 25, 48004, 39.3514, 0.686811495269297, -76.9132, -1.3423885782449),
(8786, '21082', 218, 25, 48420, 39.4801, 0.689057734016613, -76.4681, -1.33462011774428),
(8787, '21084', 218, 25, 48503, 39.6118, 0.69135633264149, -76.4722, -1.33469167624361),
(8788, '21085', 218, 25, 947, 39.4324, 0.688225211963412, -76.355, -1.33264615036027),
(8789, '21087', 218, 25, 41617, 39.4474, 0.688487011351211, -76.4215, -1.33380679431285),
(8790, '21088', 218, 25, 48957, 39.7089, 0.693051047345176, -76.7818, -1.34009521560778),
(8791, '21090', 218, 25, 48966, 39.2085, 0.684317419768197, -76.6614, -1.33799383918838),
(8792, '21092', 218, 25, 49045, 39.4772, 0.689007119468306, -76.5266, -1.33564113535669),
(8793, '21093', 218, 25, 0, 39.4362, 0.688291534474988, -76.6418, -1.33765175465499),
(8794, '21094', 218, 25, 0, 39.4238, 0.688075113647741, -76.6253, -1.33736377532841),
(8795, '21098', 218, 25, 2963, 39.1956, 0.684092272294689, -76.7235, -1.33907768865387),
(8796, '21102', 218, 25, 585, 39.6441, 0.691920073989884, -76.6963, -1.33860295909733),
(8797, '21104', 218, 25, 49257, 39.3181, 0.686230300628383, -76.9231, -1.34256136584085),
(8798, '21105', 218, 25, 49285, 39.712, 0.693105152551988, -76.6533, -1.33785246751897),
(8799, '21106', 218, 25, 17056, 38.8784, 0.678556087907363, -76.5089, -1.33533221207909),
(8800, '21108', 218, 25, 27906, 39.0957, 0.682348688371947, -76.6216, -1.33729919814609),
(8801, '21111', 218, 25, 49547, 39.5726, 0.690672163574708, -76.5983, -1.33689253643037),
(8802, '21113', 218, 25, 50051, 39.0747, 0.681982169229028, -76.7022, -1.33870593352319),
(8803, '21114', 218, 25, 20372, 39.0073, 0.680805817313184, -76.6828, -1.33836733964831),
(8804, '21117', 218, 25, 50154, 39.4272, 0.688134454842308, -76.773, -1.33994162663361),
(8805, '21120', 218, 25, 50219, 39.6403, 0.691853751478308, -76.6811, -1.33833766905102),
(8806, '21122', 218, 25, 17543, 39.1268, 0.682891485769317, -76.5122, -1.33538980794441),
(8807, '21123', 218, 25, 17543, 39.1124, 0.68264015835703, -76.5529, -1.33610015694997),
(8808, '21128', 218, 25, 50320, 39.4043, 0.687734774443602, -76.4481, -1.33427105189388),
(8809, '21130', 218, 25, 50329, 39.4702, 0.688884946420666, -76.1999, -1.32993914469043),
(8810, '21131', 218, 25, 23865, 39.5003, 0.689410290525516, -76.5716, -1.33642653352009),
(8811, '21132', 218, 25, 50638, 39.6975, 0.692852079810449, -76.4351, -1.33404415909112),
(8812, '21133', 218, 25, 50708, 39.3752, 0.687226883631271, -76.8051, -1.3405018773235),
(8813, '21136', 218, 25, 50765, 39.4642, 0.688780226665546, -76.811, -1.34060485174936),
(8814, '21139', 218, 25, 5384, 39.4092, 0.687820295576949, -76.649, -1.33777741836113),
(8815, '21140', 218, 25, 50849, 38.9514, 0.679830178261319, -76.5838, -1.33663946368883),
(8816, '21144', 218, 25, 51296, 39.1273, 0.682900212415577, -76.6873, -1.33844587946465),
(8817, '21146', 218, 25, 51310, 39.0817, 0.682104342276668, -76.5651, -1.33631308711871),
(8818, '21150', 218, 25, 38223, 39.175, 0.683732734468779, -76.8689, -1.34161539738627),
(8819, '21152', 218, 25, 0, 39.5459, 0.690206160664426, -76.6709, -1.33815964546732),
(8820, '21153', 218, 25, 6080, 39.4201, 0.688010536465417, -76.7114, -1.33886650381438),
(8821, '21154', 218, 25, 51768, 39.6538, 0.692089370927327, -76.3492, -1.33254492126365),
(8822, '21155', 218, 25, 52320, 39.5663, 0.690562207831832, -76.8014, -1.34043730014117),
(8823, '21156', 218, 25, 52313, 39.4361, 0.688289789145736, -76.3995, -1.33342282187741),
(8824, '21157', 218, 25, 13249, 39.5736, 0.690689616867228, -77.002, -1.34393843062067),
(8825, '21158', 218, 25, 13249, 39.5778, 0.690762920695812, -77.0299, -1.34442537748198),
(8826, '21160', 218, 25, 52756, 39.7067, 0.693012650101632, -76.3191, -1.3320195771588),
(8827, '21161', 218, 25, 367, 39.6479, 0.69198639650146, -76.6021, -1.33695885894195),
(8828, '21162', 218, 25, 52731, 39.3942, 0.68755849618915, -76.4147, -1.33368811192371),
(8829, '21163', 218, 25, 569, 39.3497, 0.686781824672013, -76.8449, -1.34119651836579),
(8830, '21201', 218, 25, 34657, 39.2946, 0.685820148254164, -76.623, -1.33732363275562),
(8831, '21202', 218, 25, 34657, 39.2971, 0.685863781485464, -76.608, -1.33706183336782),
(8832, '21203', 218, 25, 34657, 39.2973, 0.685867272143968, -76.6084, -1.33706881468482),
(8833, '21204', 218, 25, 52161, 39.4039, 0.687727793126594, -76.6082, -1.33706532402632),
(8834, '21205', 218, 25, 34657, 39.3012, 0.685935339984796, -76.5701, -1.33640035358131),
(8835, '21206', 218, 25, 34657, 39.3381, 0.686579366478781, -76.5484, -1.33602161713363),
(8836, '21207', 218, 25, 47754, 39.3299, 0.686436249480118, -76.7487, -1.33951751162537),
(8837, '21208', 218, 25, 50367, 39.3775, 0.687267026204067, -76.7277, -1.33915099248245),
(8838, '21209', 218, 25, 34657, 39.3621, 0.68699824549926, -76.6666, -1.33808459630948),
(8839, '21210', 218, 25, 34657, 39.3532, 0.686842911195833, -76.6348, -1.33752958160735),
(8840, '21211', 218, 25, 34657, 39.3307, 0.686450212114134, -76.6361, -1.33755227088763),
(8841, '21212', 218, 25, 34657, 39.3577, 0.686921451012172, -76.6104, -1.33710372126986),
(8842, '21213', 218, 25, 34657, 39.3124, 0.686130816861019, -76.5805, -1.33658186782352),
(8843, '21214', 218, 25, 34657, 39.3528, 0.686835929878825, -76.5632, -1.33627992586292),
(8844, '21215', 218, 25, 34657, 39.3449, 0.686698048867917, -76.6802, -1.33832196108776),
(8845, '21216', 218, 25, 34657, 39.3103, 0.686094164946727, -76.6732, -1.33819978804012),
(8846, '21217', 218, 25, 34657, 39.3064, 0.686026097105899, -76.6382, -1.33758892280192),
(8847, '21218', 218, 25, 34657, 39.3271, 0.686387380261062, -76.6036, -1.33698503888073),
(8848, '21219', 218, 25, 51587, 39.2298, 0.684689174898871, -76.4454, -1.33422392800407),
(8849, '21220', 218, 25, 17116, 39.341, 0.686629981027089, -76.4113, -1.33362877072914),
(8850, '21221', 218, 25, 8781, 39.3051, 0.686003407825623, -76.4453, -1.33422218267482),
(8851, '21222', 218, 25, 46718, 39.2649, 0.685301785466321, -76.4988, -1.33515593382464),
(8852, '21223', 218, 25, 34657, 39.2862, 0.685673540596996, -76.6505, -1.33780359829991),
(8853, '21224', 218, 25, 34657, 39.2831, 0.685619435390184, -76.5592, -1.33621011269284),
(8854, '21225', 218, 25, 1157, 39.2204, 0.684525113949184, -76.6197, -1.3372660368903),
(8855, '21226', 218, 25, 46151, 39.2248, 0.684601908436272, -76.5776, -1.33653125327521),
(8856, '21227', 218, 25, 47767, 39.2432, 0.684923049018639, -76.6758, -1.33824516660067),
(8857, '21228', 218, 25, 45500, 39.2793, 0.685553112878609, -76.7418, -1.33939708390698),
(8858, '21229', 218, 25, 34657, 39.283, 0.685617690060933, -76.6763, -1.33825389324693),
(8859, '21230', 218, 25, 34657, 39.271, 0.685408250550693, -76.6266, -1.33738646460869),
(8860, '21231', 218, 25, 34657, 39.2889, 0.6857206644868, -76.5923, -1.33678781667525),
(8861, '21233', 218, 25, 34657, 39.2913, 0.685762552388848, -76.6046, -1.33700249217325),
(8862, '21234', 218, 25, 28193, 39.3914, 0.687509626970094, -76.5345, -1.3357790163676),
(8863, '21235', 218, 25, 34657, 39.3106, 0.686099400934483, -76.7265, -1.33913004853143),
(8864, '21236', 218, 25, 4651, 39.3894, 0.687474720385055, -76.4875, -1.33495871161916),
(8865, '21237', 218, 25, 5546, 39.3352, 0.686528751930473, -76.4958, -1.33510357394708),
(8866, '21239', 218, 25, 34657, 39.3586, 0.68693715897544, -76.59, -1.33674767410246),
(8867, '21240', 218, 25, 34657, 39.1782, 0.683788585004842, -76.6645, -1.33804794439519),
(8868, '21241', 218, 25, 34657, 39.3069, 0.686034823752159, -76.7343, -1.33926618421308),
(8869, '21244', 218, 25, 52890, 39.3368, 0.686556677198505, -76.7644, -1.33979152831794),
(8870, '21250', 218, 25, 34657, 39.2545, 0.685120271224114, -76.7092, -1.33882810657083),
(8871, '21251', 218, 25, 34657, 39.3412, 0.686633471685593, -76.5833, -1.33663073704257),
(8872, '21252', 218, 25, 34657, 39.3932, 0.68754104289663, -76.6113, -1.33711942923313),
(8873, '21263', 218, 25, 34657, 39.292, 0.685774769693612, -76.6123, -1.33713688252565),
(8874, '21264', 218, 25, 34657, 39.2945, 0.685818402924912, -76.623, -1.33732363275562),
(8875, '21265', 218, 25, 34657, 39.2876, 0.685697975206524, -76.6185, -1.33724509293928),
(8876, '21268', 218, 25, 34657, 39.2472, 0.684992862188718, -76.65, -1.33779487165365),
(8877, '21270', 218, 25, 34657, 39.358, 0.686926686999928, -76.706, -1.33877225603477),
(8878, '21273', 218, 25, 34657, 39.2885, 0.685713683169792, -76.6133, -1.33715433581817),
(8879, '21274', 218, 25, 34657, 39.2925, 0.685783496339872, -76.613, -1.33714909983042),
(8880, '21275', 218, 25, 34657, 39.2901, 0.685741608437824, -76.6128, -1.33714560917191),
(8881, '21278', 218, 25, 34657, 39.3188, 0.686242517933147, -76.616, -1.33720145970798),
(8882, '21279', 218, 25, 34657, 39.2975, 0.685870762802472, -76.6086, -1.33707230534333),
(8883, '21280', 218, 25, 34657, 39.2972, 0.685865526814716, -76.6082, -1.33706532402632),
(8884, '21281', 218, 25, 34657, 39.289, 0.685722409816052, -76.5697, -1.3363933722643),
(8885, '21282', 218, 25, 34657, 39.387, 0.687432832483007, -76.7238, -1.33908292464163),
(8886, '21283', 218, 25, 34657, 39.2916, 0.685767788376604, -76.6047, -1.3370042375025),
(8887, '21284', 218, 25, 34657, 39.4017, 0.68768939588305, -76.5994, -1.33691173505214),
(8888, '21285', 218, 25, 34657, 39.409, 0.687816804918445, -76.6008, -1.33693616966167),
(8889, '21286', 218, 25, 52161, 39.4054, 0.687753973065374, -76.5805, -1.33658186782352),
(8890, '21287', 218, 25, 34657, 39.3018, 0.685945811960307, -76.5623, -1.33626421789965),
(8891, '21288', 218, 25, 34657, 39.2912, 0.685760807059596, -76.6056, -1.33701994546577),
(8892, '21289', 218, 25, 34657, 39.3112, 0.686109872909995, -76.7268, -1.33913528451919),
(8893, '21290', 218, 25, 34657, 39.2926, 0.685785241669124, -76.6237, -1.33733585006038),
(8894, '21297', 218, 25, 34657, 39.2977, 0.685874253460976, -76.6078, -1.33705834270931),
(8895, '21298', 218, 25, 34657, 39.3008, 0.685928358667788, -76.6107, -1.33710895725762),
(8896, '21401', 218, 25, 26382, 38.9997, 0.680673172290032, -76.5107, -1.33536362800563),
(8897, '21402', 218, 25, 26382, 38.9877, 0.680463732779793, -76.4866, -1.33494300365589),
(8898, '21403', 218, 25, 26382, 38.9498, 0.679802252993287, -76.489, -1.33498489155794),
(8899, '21404', 218, 25, 26382, 38.9765, 0.68026825590357, -76.5007, -1.33518909508043),
(8900, '21405', 218, 25, 26382, 39.0313, 0.681224696333663, -76.5467, -1.33599194653634),
(8901, '21411', 218, 25, 26382, 38.9712, 0.680175753453214, -76.5031, -1.33523098298247),
(8902, '21412', 218, 25, 26382, 39.1216, 0.682800728648214, -76.5287, -1.33567778727098),
(8903, '21501', 218, 25, 20409, 39.6509, 0.69203875637902, -78.7566, -1.37456197767617),
(8904, '21502', 218, 25, 20409, 39.6392, 0.691834552856536, -78.7956, -1.37524265608444),
(8905, '21503', 218, 25, 20409, 39.6502, 0.692026539074256, -78.7569, -1.37456721366392),
(8906, '21504', 218, 25, 20409, 39.6604, 0.692204562657959, -78.7455, -1.37436824612919),
(8907, '21505', 218, 25, 20409, 39.6604, 0.692204562657959, -78.745, -1.37435951948293),
(8908, '21520', 218, 25, 7022, 39.6422, 0.691886912734096, -79.3056, -1.38414383526961),
(8909, '21521', 218, 25, 7286, 39.5544, 0.690354513650845, -79.079, -1.3801889191846),
(8910, '21522', 218, 25, 44849, 39.5878, 0.690937453621011, -79.2051, -1.38238977937136),
(8911, '21523', 218, 25, 29235, 39.5043, 0.689480103695596, -79.1143, -1.38080502041055),
(8912, '21524', 218, 25, 46005, 39.6924, 0.692763068018597, -78.7931, -1.37519902285314),
(8913, '21528', 218, 25, 46787, 39.6483, 0.691993377818468, -78.9059, -1.37716775424939),
(8914, '21529', 218, 25, 15923, 39.7195, 0.693236052245888, -78.7748, -1.37487962760003),
(8915, '21530', 218, 25, 21150, 39.6904, 0.692728161433557, -78.6998, -1.37357063066103),
(8916, '21531', 218, 25, 27220, 39.6633, 0.692255177206267, -79.4047, -1.38587345655834),
(8917, '21532', 218, 25, 47316, 39.655, 0.692110314878351, -78.9262, -1.37752205608755),
(8918, '21536', 218, 25, 47588, 39.6972, 0.692846843822693, -79.1597, -1.38159739989096),
(8919, '21538', 218, 25, 48723, 39.3901, 0.687486937689818, -79.1831, -1.38200580693592),
(8920, '21539', 218, 25, 49030, 39.6001, 0.691152129119006, -79.0113, -1.379007331281),
(8921, '21540', 218, 25, 3901, 39.4795, 0.689047262041101, -79.0564, -1.37979447477365),
(8922, '21541', 218, 25, 37130, 39.5576, 0.690410364186909, -79.3494, -1.38490828948199),
(8923, '21542', 218, 25, 10461, 39.5894, 0.690965378889043, -78.9486, -1.37791300984),
(8924, '21543', 218, 25, 49469, 39.6346, 0.691754267710945, -78.9501, -1.37793918977878),
(8925, '21545', 218, 25, 37303, 39.6961, 0.692827645200921, -78.8815, -1.37674189391191),
(8926, '21550', 218, 25, 4710, 39.4041, 0.687731283785098, -79.3884, -1.38558896789027),
(8927, '21555', 218, 25, 28129, 39.598, 0.691115477204715, -78.5604, -1.37113764168375),
(8928, '21556', 218, 25, 50436, 39.5693, 0.690614567709392, -78.8393, -1.37600536496757),
(8929, '21557', 218, 25, 50721, 39.516, 0.689684307218079, -78.9084, -1.37721138748069),
(8930, '21560', 218, 25, 51604, 39.5647, 0.690534282563801, -78.717, -1.37387082729238),
(8931, '21561', 218, 25, 51889, 39.496, 0.68933524136768, -79.2608, -1.38336192776472),
(8932, '21562', 218, 25, 52664, 39.4847, 0.689138019162205, -79.0386, -1.37948380616679),
(8933, '21601', 218, 25, 2193, 38.7737, 0.676728728180525, -76.0676, -1.32763007409004),
(8934, '21606', 218, 25, 2193, 38.7746, 0.676744436143793, -76.0703, -1.32767719797984),
(8935, '21607', 218, 25, 26444, 39.122, 0.682807709965222, -75.8424, -1.32369959261455),
(8936, '21609', 218, 25, 548, 38.738, 0.676105645637563, -75.9531, -1.32563167209651),
(8937, '21610', 218, 25, 44814, 39.3671, 0.68708551196186, -76.0659, -1.32760040349275),
(8938, '21612', 218, 25, 44982, 38.7526, 0.676360463708355, -76.2989, -1.3316670206499),
(8939, '21613', 218, 25, 1302, 38.5548, 0.67290820244791, -76.0955, -1.32811702095135),
(8940, '21617', 218, 25, 1472, 39.0439, 0.681444607819414, -76.0666, -1.32761262079752),
(8941, '21619', 218, 25, 8056, 38.9663, 0.680090232319866, -76.2935, -1.33157277287029),
(8942, '21620', 218, 25, 45721, 39.2205, 0.684526859278436, -76.0819, -1.32787965617307),
(8943, '21622', 218, 25, 45787, 38.4461, 0.671011029550992, -76.1624, -1.32928464622093),
(8944, '21623', 218, 25, 13548, 39.1474, 0.683251023595228, -75.9788, -1.32608022171427),
(8945, '21624', 218, 25, 1586, 38.838, 0.677850974889558, -76.2783, -1.33130748282399),
(8946, '21625', 218, 25, 924, 38.863, 0.678287307202556, -75.9974, -1.32640485295514),
(8947, '21626', 218, 25, 46075, 38.3236, 0.668873001217299, -76.1116, -1.32839801896092),
(8948, '21627', 218, 25, 46101, 38.2386, 0.667389471353104, -76.0525, -1.32736652937299),
(8949, '21628', 218, 25, 46138, 39.2372, 0.684818329263519, -75.9218, -1.32508538404063),
(8950, '21629', 218, 25, 8484, 38.8793, 0.678571795870631, -75.8329, -1.32353378633561),
(8951, '21631', 218, 25, 46759, 38.5929, 0.67357317289292, -75.9345, -1.32530704085563),
(8952, '21632', 218, 25, 13750, 38.7052, 0.675533177642909, -75.7758, -1.32253720333272),
(8953, '21634', 218, 25, 47076, 38.309, 0.668618183146508, -76.2138, -1.33018174545645),
(8954, '21635', 218, 25, 9031, 39.346, 0.686717247489689, -75.8766, -1.32429649521873),
(8955, '21636', 218, 25, 13828, 38.8984, 0.678905153757762, -76.1848, -1.32967559997338),
(8956, '21638', 218, 25, 47589, 38.9234, 0.679341486070761, -76.1912, -1.3297873010455),
(8957, '21639', 218, 25, 2866, 38.9766, 0.680270001232822, -75.8095, -1.32312537929064),
(8958, '21640', 218, 25, 23, 39.0667, 0.681842542888869, -75.815, -1.3232213723995),
(8959, '21641', 218, 25, 3145, 38.9162, 0.679215822364617, -75.9418, -1.32543444989103),
(8960, '21643', 218, 25, 48406, 38.6406, 0.674405694946121, -75.8686, -1.32415686887857),
(8961, '21644', 218, 25, 9660, 39.1245, 0.682851343196521, -75.8907, -1.32454258664326),
(8962, '21645', 218, 25, 48643, 39.3053, 0.686006898484127, -75.9627, -1.3257992237047),
(8963, '21647', 218, 25, 430, 38.82, 0.677536815624199, -76.2812, -1.3313580973723),
(8964, '21648', 218, 25, 3938, 38.5034, 0.672011103212385, -76.2311, -1.33048368741705),
(8965, '21649', 218, 25, 14180, 39.1097, 0.682593034467226, -75.7685, -1.32240979429732),
(8966, '21650', 218, 25, 4034, 39.3112, 0.686109872909995, -75.8195, -1.32329991221584),
(8967, '21651', 218, 25, 49512, 39.2584, 0.685188339064942, -75.8393, -1.32364548740774),
(8968, '21652', 218, 25, 49754, 38.7369, 0.676086447015791, -76.2913, -1.33153437562675),
(8969, '21653', 218, 25, 49796, 38.784, 0.676908497093481, -76.2268, -1.33040863825921),
(8970, '21654', 218, 25, 4828, 38.6859, 0.675196329097274, -76.1701, -1.32941903657333),
(8971, '21655', 218, 25, 5220, 38.7332, 0.676021869833468, -75.9036, -1.32476773411677),
(8972, '21656', 218, 25, 11399, 39.1436, 0.683184701083652, -75.9804, -1.3261081469823),
(8973, '21657', 218, 25, 50663, 38.9857, 0.680428826194753, -75.9077, -1.3248392926161),
(8974, '21658', 218, 25, 5262, 38.9412, 0.679652154677616, -76.1481, -1.32903506413789),
(8975, '21659', 218, 25, 50787, 38.5791, 0.673332317456144, -75.8118, -1.32316552186344),
(8976, '21660', 218, 25, 28415, 38.9429, 0.6796818252749, -75.8876, -1.32448848143645),
(8977, '21661', 218, 25, 50942, 39.136, 0.683052056060501, -76.2297, -1.33045925280752),
(8978, '21662', 218, 25, 51095, 38.7139, 0.675685021287833, -76.1978, -1.32990249277614),
(8979, '21663', 218, 25, 51180, 38.7865, 0.676952130324781, -76.224, -1.33035976904016),
(8980, '21664', 218, 25, 51271, 38.6079, 0.673834972280719, -75.9489, -1.32555836826792),
(8981, '21665', 218, 25, 14604, 38.7401, 0.676142297551855, -76.3255, -1.33213127823093),
(8982, '21666', 218, 25, 51694, 38.9348, 0.679540453605488, -76.3373, -1.33233722708267),
(8983, '21667', 218, 25, 51703, 39.3302, 0.686441485467874, -76.0563, -1.32743285188456),
(8984, '21668', 218, 25, 51781, 39.2088, 0.684322655755953, -75.8127, -1.32318122982671),
(8985, '21669', 218, 25, 51963, 38.4733, 0.671485759107534, -76.2734, -1.33122196169064),
(8986, '21670', 218, 25, 51974, 39.1353, 0.683039838755737, -75.768, -1.32240106765106),
(8987, '21671', 218, 25, 52090, 38.6954, 0.675362135376214, -76.3352, -1.33230057516838),
(8988, '21672', 218, 25, 38553, 38.272, 0.66797241132327, -76.0655, -1.32759342217575),
(8989, '21673', 218, 25, 52173, 38.6552, 0.674660513016912, -76.0574, -1.32745205050634),
(8990, '21675', 218, 25, 34455, 38.2919, 0.668319731844417, -76.0919, -1.32805418909827),
(8991, '21676', 218, 25, 52926, 38.8022, 0.677226147017344, -76.2818, -1.33136856934781),
(8992, '21677', 218, 25, 53052, 38.5117, 0.6721559655403, -76.1896, -1.32975937577747),
(8993, '21678', 218, 25, 53069, 39.2977, 0.685874253460976, -76.1115, -1.32839627363166),
(8994, '21679', 218, 25, 53082, 38.8805, 0.678592739821655, -75.8321, -1.32351982370159),
(8995, '21681', 218, 25, 28415, 38.9385, 0.679605030787812, -75.8897, -1.32452513335074),
(8996, '21682', 218, 25, 28415, 38.9397, 0.679625974738836, -75.8889, -1.32451117071673),
(8997, '21683', 218, 25, 28415, 38.9399, 0.67962946539734, -75.8898, -1.32452687867999),
(8998, '21684', 218, 25, 28415, 38.9624, 0.680022164479039, -75.8923, -1.32457051191129),
(8999, '21685', 218, 25, 28415, 38.9397, 0.679625974738836, -75.8895, -1.32452164269224),
(9000, '21686', 218, 25, 28415, 38.9475, 0.679762110420492, -75.8847, -1.32443786688814),
(9001, '21687', 218, 25, 28415, 38.9402, 0.679634701385096, -75.8897, -1.32452513335074),
(9002, '21688', 218, 25, 28415, 38.9473, 0.679758619761987, -75.8849, -1.32444135754664),
(9003, '21690', 218, 25, 45721, 39.2197, 0.68451289664442, -76.0701, -1.32767370732134),
(9004, '21701', 218, 25, 32485, 39.412, 0.687869164796005, -77.4091, -1.35104366600554),
(9005, '21702', 218, 25, 32485, 39.4482, 0.688500973985227, -77.4511, -1.35177670429138),
(9006, '21703', 218, 25, 32485, 39.3949, 0.687570713493914, -77.4469, -1.3517034004628),
(9007, '21704', 218, 25, 32485, 39.3738, 0.687202449021743, -77.3909, -1.35072601608168),
(9008, '21705', 218, 25, 32485, 39.4139, 0.687902326051793, -77.4084, -1.35103144870078),
(9009, '21709', 218, 25, 32485, 39.4282, 0.688151908134828, -77.4169, -1.3511798016872),
(9010, '21710', 218, 25, 44283, 39.3033, 0.685971991899087, -77.4558, -1.35185873476622),
(9011, '21711', 218, 25, 44828, 39.669, 0.692354660973631, -78.0041, -1.36142837505491),
(9012, '21713', 218, 25, 44938, 39.5239, 0.689822188228987, -77.6668, -1.35554137948793),
(9013, '21714', 218, 25, 44980, 39.4152, 0.687925015332069, -77.5042, -1.35270347412419),
(9014, '21715', 218, 25, 1191, 39.3859, 0.687413633861235, -77.6605, -1.35543142374506),
(9015, '21716', 218, 25, 19602, 39.3164, 0.686200630031099, -77.6229, -1.35477517994631),
(9016, '21717', 218, 25, 45214, 39.3115, 0.686115108897751, -77.4414, -1.35160740735394),
(9017, '21718', 218, 25, 45242, 39.3914, 0.687509626970094, -77.6298, -1.35489560766469),
(9018, '21719', 218, 25, 26723, 39.7111, 0.69308944458872, -77.4919, -1.35248879862619),
(9019, '21720', 218, 25, 45511, 39.6447, 0.691930545965396, -77.5859, -1.35412940812307),
(9020, '21721', 218, 25, 45758, 39.6497, 0.692017812427996, -77.6296, -1.35489211700619),
(9021, '21722', 218, 25, 8119, 39.6608, 0.692211543974967, -77.9188, -1.35993960920296),
(9022, '21723', 218, 25, 20225, 39.3248, 0.686347237688266, -77.0134, -1.3441373981554),
(9023, '21727', 218, 25, 46891, 39.6931, 0.692775285323361, -77.3275, -1.34961947733592),
(9024, '21733', 218, 25, 20999, 39.5442, 0.690176490067142, -77.7624, -1.35720991425284),
(9025, '21734', 218, 25, 47325, 39.6093, 0.69131269941019, -77.7087, -1.35627267244452),
(9026, '21736', 218, 25, 47352, 39.4079, 0.687797606296673, -77.6587, -1.35540000781852),
(9027, '21737', 218, 25, 47488, 39.2621, 0.685252916247266, -77.0057, -1.344003007803),
(9028, '21738', 218, 25, 2749, 39.2782, 0.685533914256837, -77.0162, -1.34418626737446),
(9029, '21740', 218, 25, 29973, 39.6414, 0.69187295010008, -77.7177, -1.3564297520772),
(9030, '21741', 218, 25, 29973, 39.6438, 0.691914838002128, -77.72, -1.35646989464999),
(9031, '21742', 218, 25, 29973, 39.6567, 0.692139985475635, -77.71, -1.35629536172479),
(9032, '21746', 218, 25, 29973, 39.5639, 0.690520319929784, -77.7204, -1.356476875967),
(9033, '21747', 218, 25, 29973, 39.6362, 0.691782192978976, -77.7475, -1.35694986019429),
(9034, '21748', 218, 25, 29973, 39.6361, 0.691780447649724, -77.7474, -1.35694811486504),
(9035, '21749', 218, 25, 29973, 39.6358, 0.691775211661969, -77.7474, -1.35694811486504),
(9036, '21750', 218, 25, 9313, 39.7031, 0.692949818248561, -78.1898, -1.36466945147586),
(9037, '21754', 218, 25, 48431, 39.3324, 0.686479882711418, -77.2995, -1.34913078514536),
(9038, '21755', 218, 25, 3409, 39.3678, 0.687097729266624, -77.5664, -1.35378906891893),
(9039, '21756', 218, 25, 48587, 39.4644, 0.68878371732405, -77.6975, -1.35607719556829),
(9040, '21757', 218, 25, 48645, 39.5706, 0.690637256989668, -77.2787, -1.34876775666094),
(9041, '21758', 218, 25, 3570, 39.3579, 0.686924941670676, -77.6938, -1.35601261838597),
(9042, '21759', 218, 25, 48767, 39.5775, 0.690757684708056, -77.2649, -1.34852690122417),
(9043, '21762', 218, 25, 48934, 39.4843, 0.689131037845197, -77.2466, -1.34820750597105),
(9044, '21764', 218, 25, 3793, 39.5781, 0.690768156683568, -77.119, -1.34598046584551),
(9045, '21765', 218, 25, 10116, 39.3361, 0.686544459893741, -77.0693, -1.34511303720727),
(9046, '21766', 218, 25, 112378, 39.6588, 0.692176637389927, -78.4027, -1.36838525745336),
(9047, '21767', 218, 25, 49318, 39.6968, 0.692839862505685, -77.7465, -1.35693240690177),
(9048, '21769', 218, 25, 14224, 39.4397, 0.688352620998808, -77.5501, -1.35350458025085),
(9049, '21770', 218, 25, 4274, 39.3499, 0.686785315330517, -77.2504, -1.34827382848263),
(9050, '21771', 218, 25, 23207, 39.4017, 0.68768939588305, -77.2225, -1.34778688162132),
(9051, '21773', 218, 25, 10718, 39.5304, 0.689935634630366, -77.5526, -1.35354821348215),
(9052, '21774', 218, 25, 4548, 39.3825, 0.687354292666667, -77.273, -1.34866827289358),
(9053, '21775', 218, 25, 49786, 39.5545, 0.690356258980097, -77.304, -1.3492093249617),
(9054, '21776', 218, 25, 49791, 39.4949, 0.689316042745909, -77.1492, -1.34650755527961),
(9055, '21777', 218, 25, 50500, 39.279, 0.685547876890853, -77.5322, -1.35319216631475),
(9056, '21778', 218, 25, 5491, 39.6139, 0.691392984555782, -77.3384, -1.34980971822438),
(9057, '21779', 218, 25, 50994, 39.4374, 0.688312478426012, -77.6603, -1.35542793308655),
(9058, '21780', 218, 25, 51131, 39.6818, 0.692578063117886, -77.4644, -1.3520088330819),
(9059, '21781', 218, 25, 11756, 39.5624, 0.690494139991005, -77.7581, -1.357134865095),
(9060, '21782', 218, 25, 24795, 39.4474, 0.688487011351211, -77.7526, -1.35703887198614),
(9061, '21783', 218, 25, 51500, 39.6104, 0.691331898031962, -77.5276, -1.35311188116916),
(9062, '21784', 218, 25, 51906, 39.3395, 0.686603801088309, -76.9696, -1.34337294394303),
(9063, '21787', 218, 25, 51935, 39.6847, 0.692628677666194, -77.2553, -1.34835934961598),
(9064, '21788', 218, 25, 52083, 39.6045, 0.691228923606094, -77.4084, -1.35103144870078),
(9065, '21790', 218, 25, 52241, 39.2687, 0.685368107977897, -77.4981, -1.35259700903982),
(9066, '21791', 218, 25, 52305, 39.5125, 0.68962322069426, -77.2128, -1.34761758468388),
(9067, '21792', 218, 25, 25657, 39.4744, 0.68895825024925, -77.1855, -1.34714110979808),
(9068, '21793', 218, 25, 25781, 39.4854, 0.689150236466969, -77.3457, -1.34993712725978),
(9069, '21794', 218, 25, 52614, 39.2961, 0.685846328192944, -76.9727, -1.34342704914984),
(9070, '21795', 218, 25, 38893, 39.6048, 0.69123415959385, -77.8047, -1.35794818852643),
(9071, '21797', 218, 25, 634, 39.3128, 0.686137798178027, -77.0667, -1.34506765864671),
(9072, '21798', 218, 25, 53027, 39.5346, 0.69000893845895, -77.3024, -1.34918139969366),
(9073, '21801', 218, 25, 28524, 38.3616, 0.669536226333057, -75.5922, -1.31933277882606),
(9074, '21802', 218, 25, 28524, 38.3396, 0.669152253897618, -75.5343, -1.31832223318915),
(9075, '21803', 218, 25, 28524, 38.3616, 0.669536226333057, -75.6595, -1.32050738541265),
(9076, '21804', 218, 25, 28524, 38.358, 0.669473394479985, -75.5367, -1.3183641210912),
(9077, '21810', 218, 25, 18798, 38.2868, 0.668230720052565, -75.6882, -1.32100829490797),
(9078, '21811', 218, 25, 376, 38.3476, 0.669291880237778, -75.1785, -1.31211235171056),
(9079, '21813', 218, 25, 44848, 38.4282, 0.670698615614885, -75.1807, -1.3121507489541),
(9080, '21814', 218, 25, 44851, 38.2925, 0.668330203819929, -75.8948, -1.32461414514259),
(9081, '21817', 218, 25, 32181, 37.9877, 0.66301044025985, -75.8448, -1.3237414805166),
(9082, '21821', 218, 25, 46217, 38.3216, 0.668838094632259, -75.6093, -1.31963123012815),
(9083, '21822', 218, 25, 2217, 38.2805, 0.668120764309689, -75.6564, -1.32045328020584),
(9084, '21824', 218, 25, 2346, 37.9826, 0.662921428467998, -76.0422, -1.32718676046003),
(9085, '21826', 218, 25, 16149, 38.325, 0.668897435826827, -75.6232, -1.31987383089418),
(9086, '21829', 218, 25, 47426, 38.0946, 0.664876197230232, -75.394, -1.3158735362486),
(9087, '21830', 218, 25, 940, 38.4106, 0.670391437666534, -75.6855, -1.32096117101817),
(9088, '21835', 218, 25, 48963, 38.5362, 0.672583571207039, -75.9523, -1.32561770946249),
(9089, '21836', 218, 25, 628, 38.3335, 0.669045788813246, -75.8053, -1.32305207546206),
(9090, '21837', 218, 25, 49228, 38.4593, 0.671241413012255, -75.7561, -1.32219337347008),
(9091, '21838', 218, 25, 0, 38.0162, 0.663507859096668, -75.7324, -1.32177973043735),
(9092, '21840', 218, 25, 49742, 38.265, 0.66785023827563, -75.9029, -1.324755516812),
(9093, '21841', 218, 25, 10792, 38.2409, 0.6674296139259, -75.2842, -1.31395716472992),
(9094, '21842', 218, 25, 17371, 38.3845, 0.669935906731764, -75.0774, -1.31034782383679),
(9095, '21843', 218, 25, 17371, 38.336, 0.669089422044546, -75.0851, -1.31048221418919),
(9096, '21849', 218, 25, 50242, 38.3806, 0.669867838890936, -75.4914, -1.31757348694005),
(9097, '21850', 218, 25, 50447, 38.3947, 0.670113930315467, -75.4123, -1.31619293150172),
(9098, '21851', 218, 25, 50491, 38.067, 0.664394486356681, -75.5409, -1.31843742491978),
(9099, '21852', 218, 25, 5204, 38.3507, 0.669345985444589, -75.4052, -1.31606901312483),
(9100, '21853', 218, 25, 50608, 38.2015, 0.666741954200614, -75.6951, -1.32112872262636),
(9101, '21856', 218, 25, 50660, 38.3341, 0.669056260788758, -75.8073, -1.3230869820471),
(9102, '21857', 218, 25, 5344, 38.0454, 0.664017495238251, -75.6692, -1.32067668235009),
(9103, '21861', 218, 25, 31103, 38.5399, 0.672648148389363, -75.719, -1.32154585631759),
(9104, '21862', 218, 25, 51418, 38.3973, 0.670159308876019, -75.2158, -1.31276335952155),
(9105, '21863', 218, 25, 192, 38.1816, 0.666394633679467, -75.3915, -1.3158299030173),
(9106, '21864', 218, 25, 510, 38.0429, 0.663973862006951, -75.4131, -1.31620689413574),
(9107, '21865', 218, 25, 52273, 38.2685, 0.66791132479945, -75.7908, -1.32279900272052),
(9108, '21866', 218, 25, 52281, 37.9724, 0.662743404884295, -76.0078, -1.32658636719735),
(9109, '21867', 218, 25, 52312, 38.1043, 0.665045494167675, -75.7914, -1.32280947469603),
(9110, '21869', 218, 25, 6557, 38.4643, 0.671328679474855, -75.9006, -1.32471537423921),
(9111, '21870', 218, 25, 25890, 38.1227, 0.665366634750042, -75.9901, -1.32627744391974),
(9112, '21871', 218, 25, 6747, 38.0991, 0.664954737046572, -75.7427, -1.32195949935031),
(9113, '21872', 218, 25, 52698, 38.3986, 0.670181998156295, -75.3004, -1.31423990806874),
(9114, '21874', 218, 25, 52806, 38.4032, 0.670262283301886, -75.3508, -1.31511955401174),
(9115, '21875', 218, 25, 2021, 38.4481, 0.671045936136032, -75.5813, -1.31914253793759),
(9116, '21890', 218, 25, 6747, 38.1521, 0.665879761550129, -75.6885, -1.32101353089573),
(9117, '21901', 218, 25, 49855, 39.5894, 0.690965378889043, -75.955, -1.32566483335229),
(9118, '21902', 218, 25, 50326, 39.5547, 0.690359749638601, -76.0739, -1.32774002983291),
(9119, '21903', 218, 25, 4963, 39.5686, 0.690602350404628, -76.0468, -1.32726704560562),
(9120, '21904', 218, 25, 50536, 39.6277, 0.691633839992557, -76.0776, -1.32780460701524),
(9121, '21911', 218, 25, 14485, 39.6913, 0.692743869396825, -76.047, -1.32727053626413),
(9122, '21912', 218, 25, 14798, 39.4306, 0.688193796036876, -75.8052, -1.32305033013281),
(9123, '21913', 218, 25, 45516, 39.4154, 0.687928505990573, -75.8666, -1.32412196229353),
(9124, '21914', 218, 25, 29458, 39.5736, 0.690689616867228, -75.9786, -1.32607673105576),
(9125, '21915', 218, 25, 45690, 39.5067, 0.689521991597644, -75.85, -1.3238322376377),
(9126, '21916', 218, 25, 15515, 39.6469, 0.69196894320894, -75.8734, -1.32424064468267),
(9127, '21917', 218, 25, 45935, 39.6567, 0.692139985475635, -76.0748, -1.32775573779618),
(9128, '21918', 218, 25, 45962, 39.6777, 0.692506504618554, -76.155, -1.32915549185628),
(9129, '21919', 218, 25, 46754, 39.4337, 0.688247901243688, -75.9493, -1.32556534958493),
(9130, '21920', 218, 25, 46849, 39.6573, 0.692150457451147, -75.8269, -1.32342906658049),
(9131, '21921', 218, 25, 15918, 39.6243, 0.691574498797989, -75.8511, -1.32385143625947),
(9132, '21922', 218, 25, 15918, 39.6068, 0.69126906617889, -75.8334, -1.32354251298187),
(9133, '21930', 218, 25, 2693, 39.3663, 0.687071549327844, -75.8867, -1.32447277347318),
(9134, '22002', 218, 53, 99403, 38.6834, 0.675152695865974, -77.9264, -1.36007225422611),
(9135, '22003', 218, 53, 44379, 38.8301, 0.67771309387865, -77.2154, -1.34766296324443),
(9136, '22009', 218, 53, 35064, 38.7804, 0.676845665240409, -77.2721, -1.34865256493031),
(9137, '22015', 218, 53, 35064, 38.7894, 0.677002744873088, -77.2809, -1.34880615390449),
(9138, '22026', 218, 53, 101536, 38.5947, 0.673604588819456, -77.3365, -1.34977655696859),
(9139, '22027', 218, 53, 101559, 38.895, 0.678845812563195, -77.2222, -1.34778164563357),
(9140, '22030', 218, 53, 13733, 38.8462, 0.677994091888221, -77.3248, -1.34957235344611),
(9141, '22031', 218, 53, 13733, 38.8559, 0.678163388825665, -77.2601, -1.34844312542007),
(9142, '22032', 218, 53, 13733, 38.8186, 0.677512381014671, -77.2917, -1.3489946494637),
(9143, '22033', 218, 53, 13733, 38.8791, 0.678568305212127, -77.3888, -1.35068936416739),
(9144, '22034', 218, 53, 13733, 38.8595, 0.678226220678736, -77.2598, -1.34843788943232),
(9145, '22035', 218, 53, 13733, 38.8383, 0.677856210877314, -77.3401, -1.34983938882167),
(9146, '22036', 218, 53, 13733, 38.8593, 0.678222730020232, -77.2598, -1.34843788943232),
(9147, '22037', 218, 53, 13733, 38.8538, 0.678126736911373, -77.298, -1.34910460520658),
(9148, '22038', 218, 53, 13733, 38.8296, 0.67770436723239, -77.3649, -1.35027223047616),
(9149, '22039', 218, 53, 101810, 38.7576, 0.676447730170954, -77.3124, -1.34935593261886),
(9150, '22040', 218, 53, 101865, 38.8833, 0.678641609040711, -77.1742, -1.34694388759261),
(9151, '22041', 218, 53, 101865, 38.8487, 0.678037725119521, -77.144, -1.34641679815851),
(9152, '22042', 218, 53, 101865, 38.865, 0.678322213787596, -77.1931, -1.34727375482123),
(9153, '22043', 218, 53, 101865, 38.9018, 0.67896449495233, -77.1929, -1.34727026416273),
(9154, '22044', 218, 53, 101865, 38.8566, 0.678175606130429, -77.1577, -1.34665590826603),
(9155, '22046', 218, 53, 101865, 38.8871, 0.678707931552287, -77.1801, -1.34704686201848),
(9156, '22047', 218, 53, 101865, 38.8852, 0.678674770296499, -77.1751, -1.34695959555588),
(9157, '22060', 218, 53, 0, 38.7054, 0.675536668301413, -77.1411, -1.3463661836102),
(9158, '22066', 218, 53, 47606, 39.0011, 0.68069760689956, -77.3013, -1.34916220107189),
(9159, '22067', 218, 53, 9228, 38.9381, 0.679598049470804, -77.1657, -1.34679553460619),
(9160, '22079', 218, 53, 3870, 38.6984, 0.675414495253774, -77.2083, -1.34753904486754),
(9161, '22081', 218, 53, 37170, 38.8738, 0.678475802761772, -77.2373, -1.34804519035062),
(9162, '22082', 218, 53, 37170, 38.8733, 0.678467076115512, -77.2373, -1.34804519035062),
(9163, '22092', 218, 53, 9440, 38.9696, 0.680147828185182, -77.386, -1.35064049494833),
(9164, '22093', 218, 53, 18929, 39.0419, 0.681409701234374, -77.4813, -1.35230379372548),
(9165, '22095', 218, 53, 9440, 38.9695, 0.68014608285593, -77.3858, -1.35063700428983),
(9166, '22096', 218, 53, 105660, 38.9524, 0.679847631553839, -77.3448, -1.34992141929651),
(9167, '22101', 218, 53, 73416, 38.9311, 0.679475876423164, -77.1773, -1.34699799279942),
(9168, '22102', 218, 53, 73416, 38.9528, 0.679854612870847, -77.2348, -1.34800155711932),
(9169, '22103', 218, 53, 107423, 38.9496, 0.679798762334783, -77.2273, -1.34787065742542),
(9170, '22106', 218, 53, 73416, 38.9382, 0.679599794800056, -77.1774, -1.34699973812867),
(9171, '22107', 218, 53, 73416, 38.9356, 0.679554416239504, -77.1787, -1.34702242740895),
(9172, '22108', 218, 53, 73416, 38.9351, 0.679545689593244, -77.1786, -1.3470206820797),
(9173, '22109', 218, 53, 73416, 38.9327, 0.679503801691196, -77.1825, -1.34708874992052),
(9174, '22116', 218, 53, 37170, 38.8609, 0.678250655288264, -77.2596, -1.34843439877381),
(9175, '22118', 218, 53, 37170, 38.839, 0.677868428182078, -77.3374, -1.34979226493186),
(9176, '22119', 218, 53, 37170, 38.8736, 0.678472312103268, -77.237, -1.34803995436286),
(9177, '22120', 218, 53, 37170, 38.8734, 0.678468821444764, -77.243, -1.34814467411798),
(9178, '22121', 218, 53, 4411, 38.719, 0.675774033079685, -77.1089, -1.34580418759106),
(9179, '22122', 218, 53, 23359, 38.7394, 0.676130080247091, -77.1817, -1.34707478728651),
(9180, '22124', 218, 53, 23580, 38.8911, 0.678777744722367, -77.3229, -1.34953919219032),
(9181, '22125', 218, 53, 104877, 38.6813, 0.675116043951683, -77.2609, -1.34845708805409),
(9182, '22134', 218, 53, 50660, 38.523, 0.672353187745776, -77.3021, -1.34917616370591),
(9183, '22135', 218, 53, 50660, 38.5226, 0.672346206428768, -77.29, -1.34896497886642),
(9184, '22150', 218, 53, 349, 38.7769, 0.676784578716589, -77.1868, -1.34716379907836),
(9185, '22151', 218, 53, 349, 38.8033, 0.677245345639116, -77.2083, -1.34753904486754),
(9186, '22152', 218, 53, 349, 38.7779, 0.676802032009109, -77.2366, -1.34803297304585),
(9187, '22153', 218, 53, 349, 38.7462, 0.676248762636227, -77.2375, -1.34804868100912),
(9188, '22156', 218, 53, 349, 38.7738, 0.676730473509777, -77.1848, -1.34712889249332),
(9189, '22158', 218, 53, 349, 38.81, 0.677362282698999, -77.2543, -1.34834189632346),
(9190, '22159', 218, 53, 349, 38.8003, 0.677192985761556, -77.1827, -1.34709224057903),
(9191, '22160', 218, 53, 349, 38.8112, 0.677383226650023, -77.221, -1.34776070168254),
(9192, '22161', 218, 53, 349, 38.7888, 0.676992272897577, -77.188, -1.34718474302938),
(9193, '22172', 218, 53, 98617, 38.5527, 0.672871550533618, -77.3311, -1.34968230918899),
(9194, '22180', 218, 53, 6557, 38.9037, 0.678997656208118, -77.2587, -1.34841869081054),
(9195, '22181', 218, 53, 6557, 38.8996, 0.678926097708786, -77.2909, -1.34898068682969),
(9196, '22182', 218, 53, 6557, 38.9261, 0.679388609960565, -77.2628, -1.34849024930987),
(9197, '22183', 218, 53, 6557, 38.8983, 0.67890340842851, -77.2535, -1.34832793368944),
(9198, '22184', 218, 53, 6557, 38.9413, 0.679653900006868, -77.253, -1.34831920704318),
(9199, '22185', 218, 53, 6557, 38.9007, 0.678945296330558, -77.2598, -1.34843788943232),
(9200, '22191', 218, 53, 26188, 38.6381, 0.674362061714821, -77.2729, -1.34866652756433),
(9201, '22192', 218, 53, 26188, 38.6826, 0.675138733231959, -77.3088, -1.34929310076579),
(9202, '22193', 218, 53, 26188, 38.6473, 0.674522632006005, -77.3497, -1.35000694042986),
(9203, '22194', 218, 53, 26188, 38.6353, 0.674313192495765, -77.2618, -1.34847279601735),
(9204, '22195', 218, 53, 26188, 38.6582, 0.674712872894472, -77.2502, -1.34827033782412),
(9205, '22199', 218, 53, 3870, 38.7043, 0.675517469679641, -77.2282, -1.34788636538868),
(9206, '22201', 218, 53, 15026, 38.8859, 0.678686987601263, -77.0981, -1.34561569203184),
(9207, '22202', 218, 53, 15026, 38.8671, 0.678358865701888, -77.0853, -1.34539228988759),
(9208, '22203', 218, 53, 15026, 38.8723, 0.678449622822992, -77.1157, -1.34592286998019),
(9209, '22204', 218, 53, 15026, 38.8602, 0.6782384379835, -77.0955, -1.34557031347129),
(9210, '22205', 218, 53, 15026, 38.883, 0.678636373052955, -77.1387, -1.34632429570815),
(9211, '22206', 218, 53, 15026, 38.8428, 0.677934750693653, -77.0915, -1.34550050030121),
(9212, '22207', 218, 53, 15026, 38.9024, 0.678974966927842, -77.1292, -1.34615848942921),
(9213, '22209', 218, 53, 15026, 38.8911, 0.678777744722367, -77.0812, -1.34532073138825),
(9214, '22210', 218, 53, 15026, 38.8872, 0.678709676881539, -77.0927, -1.34552144425223),
(9215, '22211', 218, 53, 0, 38.8842, 0.678657317003979, -77.0796, -1.34529280612022),
(9216, '22212', 218, 53, 15026, 38.8594, 0.678224475349484, -77.0908, -1.34548828299644),
(9217, '22213', 218, 53, 15026, 38.8922, 0.678796943344139, -77.1544, -1.34659831240071),
(9218, '22214', 218, 53, 15026, 38.855, 0.678147680862397, -77.0735, -1.34518634103585),
(9219, '22215', 218, 53, 15026, 38.8597, 0.67822971133724, -77.0514, -1.34480062327116),
(9220, '22216', 218, 53, 15026, 38.8915, 0.678784726039375, -77.0841, -1.34537134593656),
(9221, '22217', 218, 53, 15026, 38.8543, 0.678135463557633, -77.0944, -1.34555111484952),
(9222, '22218', 218, 53, 15026, 38.8858, 0.678685242272011, -77.0998, -1.34564536262912),
(9223, '22219', 218, 53, 15026, 38.8891, 0.678742838137327, -77.072, -1.34516016109707),
(9224, '22222', 218, 53, 15026, 38.8557, 0.678159898167161, -77.0501, -1.34477793399088),
(9225, '22223', 218, 53, 15026, 38.8863, 0.678693968918271, -77.0939, -1.34554238820326),
(9226, '22225', 218, 53, 15026, 38.8561, 0.678166879484169, -77.0589, -1.34493152296506),
(9227, '22226', 218, 53, 15026, 38.8838, 0.678650335686971, -77.0972, -1.34559998406857),
(9228, '22227', 218, 53, 15026, 38.8557, 0.678159898167161, -77.0542, -1.34484949249021),
(9229, '22229', 218, 53, 15026, 38.8769, 0.678529907968583, -77.0802, -1.34530327809573),
(9230, '22230', 218, 53, 15026, 38.8679, 0.678372828335904, -77.1162, -1.34593159662645),
(9231, '22234', 218, 53, 15026, 38.8853, 0.678676515625751, -77.0959, -1.3455772947883),
(9232, '22240', 218, 53, 15026, 38.8566, 0.678175606130429, -77.0546, -1.34485647380722),
(9233, '22241', 218, 53, 15026, 38.8583, 0.678205276727713, -77.0539, -1.34484425650246),
(9234, '22242', 218, 53, 15026, 38.8582, 0.67820353139846, -77.0528, -1.34482505788069),
(9235, '22243', 218, 53, 15026, 38.861, 0.678252400617516, -77.0519, -1.34480934991742),
(9236, '22244', 218, 53, 15026, 38.8545, 0.678138954216137, -77.0518, -1.34480760458817),
(9237, '22245', 218, 53, 15026, 38.8518, 0.678091830326333, -77.0522, -1.34481458590517),
(9238, '22246', 218, 53, 15026, 38.8577, 0.678194804752201, -77.0526, -1.34482156722218),
(9239, '22301', 218, 53, 34524, 38.8184, 0.677508890356167, -77.0635, -1.34501180811065),
(9240, '22302', 218, 53, 34524, 38.828, 0.677676441964358, -77.0855, -1.34539578054609),
(9241, '22303', 218, 53, 34524, 38.7922, 0.677051614092144, -77.0827, -1.34534691132703),
(9242, '22304', 218, 53, 34524, 38.8174, 0.677491437063647, -77.1224, -1.34603980704007),
(9243, '22305', 218, 53, 34524, 38.8362, 0.677819558963022, -77.066, -1.34505544134195),
(9244, '22306', 218, 53, 34524, 38.7615, 0.676515798011782, -77.0959, -1.3455772947883),
(9245, '22307', 218, 53, 34524, 38.7739, 0.676732218839029, -77.0682, -1.34509383858549),
(9246, '22308', 218, 53, 34524, 38.7324, 0.676007907199452, -77.0632, -1.34500657212289),
(9247, '22309', 218, 53, 34524, 38.7262, 0.675899696785828, -77.1103, -1.34582862220058),
(9248, '22310', 218, 53, 34524, 38.7739, 0.676732218839029, -77.1333, -1.34623004792854),
(9249, '22311', 218, 53, 34524, 38.8363, 0.677821304292274, -77.1284, -1.34614452679519),
(9250, '22312', 218, 53, 34524, 38.8202, 0.677540306282703, -77.1514, -1.34654595252315),
(9251, '22313', 218, 53, 34524, 38.7735, 0.676725237522021, -77.1702, -1.34687407442253),
(9252, '22314', 218, 53, 34524, 38.8072, 0.677313413479943, -77.0606, -1.34496119356234),
(9253, '22315', 218, 53, 34524, 38.7554, 0.67640933292741, -77.1516, -1.34654944318166),
(9254, '22320', 218, 53, 34524, 38.8064, 0.677299450845927, -77.0566, -1.34489138039226),
(9255, '22321', 218, 53, 34524, 38.8207, 0.677549032928963, -77.086, -1.34540450719235),
(9256, '22331', 218, 53, 34524, 38.8044, 0.677264544260888, -77.0583, -1.34492105098955),
(9257, '22332', 218, 53, 34524, 38.8052, 0.677278506894904, -77.0584, -1.3449227963188),
(9258, '22333', 218, 53, 34524, 38.8139, 0.677430350539827, -77.1118, -1.34585480213936),
(9259, '22334', 218, 53, 34524, 38.8054, 0.677281997553408, -77.0595, -1.34494199494057),
(9260, '22336', 218, 53, 34524, 38.8052, 0.677278506894904, -77.0472, -1.34472731944258),
(9261, '22401', 218, 53, 29848, 38.2882, 0.668255154662093, -77.5058, -1.35273139939222),
(9262, '22402', 218, 53, 29848, 38.2565, 0.667701885289211, -77.5678, -1.35381350352846),
(9263, '22403', 218, 53, 29848, 38.3494, 0.669323296164314, -77.4766, -1.35222176325064),
(9264, '22404', 218, 53, 29848, 38.2988, 0.668440159562804, -77.4585, -1.35190585865603),
(9265, '22405', 218, 53, 29848, 38.3299, 0.668982956960175, -77.4446, -1.35166325789),
(9266, '22406', 218, 53, 29848, 38.3943, 0.670106948998459, -77.5539, -1.35357090276243),
(9267, '22407', 218, 53, 29848, 38.2691, 0.667921796774962, -77.5471, -1.35345222037329),
(9268, '22408', 218, 53, 29848, 38.2574, 0.667717593252479, -77.4725, -1.35215020475131),
(9269, '22412', 218, 53, 29848, 38.2997, 0.668455867526072, -77.4871, -1.3524050228221),
(9270, '22427', 218, 53, 15294, 38.0476, 0.664055892481795, -77.35, -1.35001217641761),
(9271, '22428', 218, 53, 15294, 38.0491, 0.664082072420574, -77.3481, -1.34997901516183),
(9272, '22430', 218, 53, 0, 38.3797, 0.669852130927668, -77.3643, -1.35026175850065),
(9273, '22432', 218, 53, 1234, 37.8674, 0.660910809169701, -76.3427, -1.33243147486228),
(9274, '22433', 218, 53, 80054, 38.3684, 0.669654908722192, -77.8846, -1.35934270659878),
(9275, '22435', 218, 53, 53800, 37.9785, 0.662849869968666, -76.5804, -1.33658012249427),
(9276, '22436', 218, 53, 100501, 37.9764, 0.662813218054375, -76.9418, -1.34288774241097),
(9277, '22437', 218, 53, 100638, 37.7845, 0.659463931219798, -76.7583, -1.33968506323356),
(9278, '22438', 218, 53, 100677, 38.0292, 0.663734751899428, -76.9634, -1.3432647335294),
(9279, '22442', 218, 53, 100974, 38.1441, 0.665740135209969, -76.6361, -1.33755227088763),
(9280, '22443', 218, 53, 100999, 38.2371, 0.667363291414324, -76.9723, -1.34342006783283),
(9281, '22446', 218, 53, 1763, 38.1989, 0.666696575640062, -77.3888, -1.35068936416739),
(9282, '22448', 218, 53, 26907, 38.3135, 0.668696722962847, -77.0865, -1.34541323383861),
(9283, '22451', 218, 53, 101450, 38.2318, 0.667270788963968, -77.2164, -1.34768041653695),
(9284, '22454', 218, 53, 101563, 37.8347, 0.660340086504299, -76.8481, -1.34125236890185),
(9285, '22456', 218, 53, 2239, 37.906, 0.661584506260971, -76.3654, -1.33282766460248),
(9286, '22460', 218, 53, 101889, 37.8681, 0.660923026474465, -76.5978, -1.33688380978411),
(9287, '22463', 218, 53, 102181, 38.4781, 0.67156953491163, -77.4931, -1.35250974257722),
(9288, '22469', 218, 53, 16318, 38.0486, 0.664073345774314, -76.668, -1.33810903091901),
(9289, '22471', 218, 53, 102648, 38.3994, 0.670195960790311, -77.5818, -1.35405784962374),
(9290, '22472', 218, 53, 36329, 37.9498, 0.662348960473344, -76.6631, -1.33802350978566),
(9291, '22473', 218, 53, 27406, 37.904, 0.661549599675931, -76.4348, -1.33403892310336),
(9292, '22476', 218, 53, 103039, 38.0232, 0.663630032144308, -77.0481, -1.34474302740584),
(9293, '22480', 218, 53, 3366, 37.6647, 0.657373026775908, -76.4151, -1.33369509324072),
(9294, '22481', 218, 53, 9753, 38.211, 0.666907760479553, -77.1395, -1.34633825834217),
(9295, '22482', 218, 53, 48660, 37.7092, 0.658149698293046, -76.3807, -1.33309469997803),
(9296, '22485', 218, 53, 103348, 38.3001, 0.66846284884308, -77.1476, -1.34647963001158),
(9297, '22488', 218, 53, 103386, 38.0441, 0.663994805957975, -76.5885, -1.33672149416368),
(9298, '22501', 218, 53, 32959, 38.017, 0.663521821730684, -77.5152, -1.35289546034191),
(9299, '22503', 218, 53, 16841, 37.7628, 0.659085194772115, -76.5015, -1.33520305771444),
(9300, '22504', 218, 53, 88433, 37.7668, 0.659155007942195, -76.7041, -1.33873909477898),
(9301, '22507', 218, 53, 55951, 37.7772, 0.659336522184402, -76.514, -1.33542122387094),
(9302, '22508', 218, 53, 901, 38.3103, 0.668640872426784, -77.78, -1.35751709220119),
(9303, '22509', 218, 53, 3869, 38.0674, 0.664401467673689, -76.9747, -1.34346195573488),
(9304, '22511', 218, 53, 103832, 37.978, 0.662841143322407, -76.5143, -1.3354264598587),
(9305, '22513', 218, 53, 104206, 37.7336, 0.658575558630532, -76.4829, -1.33487842647357),
(9306, '22514', 218, 53, 10480, 37.9704, 0.662708498299255, -77.2761, -1.34872237810039),
(9307, '22517', 218, 53, 104324, 37.7298, 0.658509236118957, -76.538, -1.33584010289142),
(9308, '22520', 218, 53, 104372, 38.1476, 0.665801221733789, -76.7269, -1.33913702984844),
(9309, '22523', 218, 53, 104398, 37.7886, 0.659535489719129, -76.6291, -1.33743009783999),
(9310, '22524', 218, 53, 10633, 38.1343, 0.665569092943274, -76.6595, -1.33796067793259),
(9311, '22526', 218, 53, 104680, 38.2705, 0.66794623138449, -77.0566, -1.34489138039226),
(9312, '22528', 218, 53, 104790, 37.7922, 0.659598321572201, -76.5511, -1.33606874102343),
(9313, '22529', 218, 53, 104936, 38.0027, 0.663272239647649, -76.6687, -1.33812124822378),
(9314, '22530', 218, 53, 104959, 37.9105, 0.66166304607731, -76.2841, -1.33140871192061);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(9315, '22534', 218, 53, 105087, 38.0862, 0.664729589573064, -77.6602, -1.3554261877573),
(9316, '22535', 218, 53, 5184, 38.1698, 0.666188684827732, -77.1913, -1.3472423388947),
(9317, '22538', 218, 53, 0, 38.1558, 0.665944338732452, -77.3027, -1.34918663568142),
(9318, '22539', 218, 53, 11529, 37.8647, 0.660863685279897, -76.2909, -1.33152739430974),
(9319, '22542', 218, 53, 105671, 38.2868, 0.668230720052565, -77.9085, -1.35975984029),
(9320, '22544', 218, 53, 105870, 38.1842, 0.666440012240019, -77.0628, -1.34499959080589),
(9321, '22545', 218, 53, 42889, 38.5038, 0.672018084529393, -77.5158, -1.35290593231742),
(9322, '22546', 218, 53, 105967, 38.0046, 0.663305400903437, -77.5437, -1.35339287917873),
(9323, '22547', 218, 53, 106096, 38.2501, 0.667590184217083, -77.3118, -1.34934546064335),
(9324, '22548', 218, 53, 68710, 37.8233, 0.660141118969571, -76.7014, -1.33869197088918),
(9325, '22552', 218, 53, 25003, 37.9913, 0.663073272112922, -77.2302, -1.34792127197372),
(9326, '22553', 218, 53, 106466, 38.2369, 0.66735980075582, -77.6326, -1.35494447688375),
(9327, '22554', 218, 53, 12102, 38.4584, 0.671225705048987, -77.4357, -1.35150792358657),
(9328, '22555', 218, 53, 12102, 38.422, 0.670590405201261, -77.4091, -1.35104366600554),
(9329, '22556', 218, 53, 12102, 38.4584, 0.671225705048987, -77.4354, -1.35150268759882),
(9330, '22558', 218, 53, 14683, 38.1463, 0.665778532453513, -76.8427, -1.34115812112225),
(9331, '22560', 218, 53, 106815, 37.9247, 0.661910882831094, -76.8638, -1.34152638559442),
(9332, '22565', 218, 53, 12309, 38.1331, 0.66554814899225, -77.5222, -1.35301763338955),
(9333, '22567', 218, 53, 25657, 38.2253, 0.667157342562588, -77.9125, -1.35982965346008),
(9334, '22570', 218, 53, 12557, 37.9489, 0.662333252510076, -76.6049, -1.337007728161),
(9335, '22572', 218, 53, 6638, 37.958, 0.662492077472008, -76.7588, -1.33969378987982),
(9336, '22576', 218, 53, 6679, 37.692, 0.657849501661703, -76.4251, -1.33386962616592),
(9337, '22577', 218, 53, 5647, 38.0637, 0.664336890491366, -76.5594, -1.33621360335135),
(9338, '22578', 218, 53, 84361, 37.6476, 0.657074575473817, -76.3575, -1.33268978359157),
(9339, '22579', 218, 53, 107587, 37.7871, 0.659509309780349, -76.359, -1.33271596353035),
(9340, '22580', 218, 53, 6914, 38.1003, 0.664975680997596, -77.5332, -1.35320961960727),
(9341, '22581', 218, 53, 107880, 38.12, 0.665319510860238, -76.782, -1.34009870626629),
(9342, '22601', 218, 53, 12894, 39.1779, 0.683783349017086, -78.168, -1.36428896969893),
(9343, '22602', 218, 53, 12894, 39.1657, 0.683570418848343, -78.1473, -1.36392768654376),
(9344, '22603', 218, 53, 12894, 39.2071, 0.684292985158669, -78.165, -1.36423660982137),
(9345, '22604', 218, 53, 12894, 39.185, 0.683907267393978, -78.1537, -1.36403938761589),
(9346, '22610', 218, 53, 647, 38.82, 0.677536815624199, -78.2737, -1.36613378271829),
(9347, '22611', 218, 53, 7422, 39.1506, 0.683306874131292, -77.9769, -1.36095364549837),
(9348, '22620', 218, 53, 34943, 39.0782, 0.682043255752848, -78.0505, -1.36223820782783),
(9349, '22622', 218, 53, 100280, 39.2537, 0.685106308590098, -78.0665, -1.36251746050815),
(9350, '22623', 218, 53, 100750, 38.8528, 0.678109283618853, -78.1348, -1.36370952038727),
(9351, '22624', 218, 53, 100872, 39.2455, 0.684963191591435, -78.0911, -1.36294681150414),
(9352, '22625', 218, 53, 101204, 39.3142, 0.686162232787555, -78.3275, -1.36707276985586),
(9353, '22626', 218, 53, 0, 38.9793, 0.680317125122626, -78.4029, -1.36838874811186),
(9354, '22627', 218, 53, 2497, 38.7324, 0.676007907199452, -78.0653, -1.36249651655713),
(9355, '22630', 218, 53, 102141, 38.9277, 0.679416535228597, -78.1726, -1.36436925484452),
(9356, '22637', 218, 53, 811, 39.2753, 0.685483299708529, -78.353, -1.36751782881512),
(9357, '22638', 218, 53, 12894, 39.174, 0.683715281176259, -78.1749, -1.36440939741732),
(9358, '22639', 218, 53, 109, 38.8213, 0.677559504904475, -77.9927, -1.36122940752018),
(9359, '22640', 218, 53, 103030, 38.8041, 0.677259308273132, -78.1413, -1.36382296678865),
(9360, '22641', 218, 53, 28710, 39.0599, 0.681723860499733, -78.3628, -1.36768887108181),
(9361, '22642', 218, 53, 3784, 38.9232, 0.679337995412257, -78.1006, -1.36311261778308),
(9362, '22643', 218, 53, 469, 38.9402, 0.679634701385096, -77.993, -1.36123464350794),
(9363, '22644', 218, 53, 104069, 38.9831, 0.680383447634201, -78.5127, -1.37030511963055),
(9364, '22645', 218, 53, 14224, 39.0287, 0.681179317773111, -78.2788, -1.36622279451014),
(9365, '22646', 218, 53, 624, 39.0698, 0.681896648095681, -78.038, -1.36202004167133),
(9366, '22649', 218, 53, 14224, 39.001, 0.680695861570308, -78.2514, -1.36574457429509),
(9367, '22650', 218, 53, 28421, 38.765, 0.676576884535602, -78.3775, -1.36794543448186),
(9368, '22652', 218, 53, 21241, 38.8447, 0.677967911949441, -78.4212, -1.36870814336498),
(9369, '22654', 218, 53, 0, 39.0822, 0.682113068922928, -78.4594, -1.36937485913924),
(9370, '22655', 218, 53, 106560, 39.0893, 0.68223698729982, -78.2041, -1.3649190335589),
(9371, '22656', 218, 53, 61884, 39.2064, 0.684280767853905, -78.0958, -1.36302884197899),
(9372, '22657', 218, 53, 28710, 38.9898, 0.680500384694085, -78.3596, -1.36763302054575),
(9373, '22660', 218, 53, 106950, 38.9481, 0.679772582396003, -78.4301, -1.3688634776684),
(9374, '22663', 218, 53, 107546, 39.053, 0.681603432781346, -78.099, -1.36308469251505),
(9375, '22664', 218, 53, 569, 38.8775, 0.678540379944095, -78.5111, -1.37027719436252),
(9376, '22701', 218, 53, 1918, 38.4732, 0.671484013778282, -78.0164, -1.3616430505529),
(9377, '22709', 218, 53, 99493, 38.322, 0.668845075949267, -78.2629, -1.36594528715907),
(9378, '22711', 218, 53, 99609, 38.4515, 0.6711052773306, -78.2817, -1.36627340905845),
(9379, '22712', 218, 53, 99709, 38.5773, 0.673300901529609, -77.7796, -1.35751011088418),
(9380, '22713', 218, 53, 1061, 38.5177, 0.67226068529542, -78.0954, -1.36302186066198),
(9381, '22714', 218, 53, 100139, 38.5227, 0.67234795175802, -77.8955, -1.35953294748724),
(9382, '22715', 218, 53, 13042, 38.4106, 0.670391437666534, -78.1659, -1.36425231778464),
(9383, '22716', 218, 53, 29414, 38.6044, 0.673773885756899, -78.1185, -1.36342503171919),
(9384, '22718', 218, 53, 2261, 38.469, 0.671410709949699, -77.8192, -1.35820126126797),
(9385, '22719', 218, 53, 101758, 38.5579, 0.672962307654722, -78.3076, -1.36672544933471),
(9386, '22720', 218, 53, 102325, 38.492, 0.671812135677657, -77.6654, -1.3555169448784),
(9387, '22721', 218, 53, 102387, 38.4226, 0.670600877176773, -78.3677, -1.36777439221516),
(9388, '22722', 218, 53, 3032, 38.469, 0.671410709949699, -78.1793, -1.3644861919044),
(9389, '22723', 218, 53, 3219, 38.3545, 0.669412307956165, -78.3827, -1.36803619160296),
(9390, '22724', 218, 53, 103177, 38.6437, 0.674459800152933, -77.8995, -1.35960276065732),
(9391, '22725', 218, 53, 3732, 38.4526, 0.671124475952371, -78.1588, -1.36412839940774),
(9392, '22726', 218, 53, 103677, 38.391, 0.670049353133143, -77.8286, -1.35836532221766),
(9393, '22727', 218, 53, 3938, 38.3752, 0.669773591111328, -78.3199, -1.36694012483271),
(9394, '22728', 218, 53, 10461, 38.6338, 0.674287012556985, -77.7206, -1.35648036662551),
(9395, '22729', 218, 53, 104313, 38.3781, 0.669824205659636, -78.0027, -1.36140394044538),
(9396, '22730', 218, 53, 104860, 38.3766, 0.669798025720856, -78.1253, -1.36354371410833),
(9397, '22731', 218, 53, 714, 38.3543, 0.669408817297661, -78.2738, -1.36613552804754),
(9398, '22732', 218, 53, 105541, 38.3191, 0.668794461400959, -78.1795, -1.36448968256291),
(9399, '22733', 218, 53, 42739, 38.3332, 0.66904055282549, -78.0395, -1.36204622161011),
(9400, '22734', 218, 53, 74045, 38.5361, 0.672581825877787, -77.8075, -1.35799705774549),
(9401, '22735', 218, 53, 105662, 38.4586, 0.671229195707491, -78.1361, -1.36373220966754),
(9402, '22736', 218, 53, 37918, 38.394, 0.670101713010703, -77.6933, -1.35600389173971),
(9403, '22737', 218, 53, 105790, 38.5879, 0.67348590643032, -78.0267, -1.36182281946586),
(9404, '22738', 218, 53, 17824, 38.2651, 0.667851983604882, -78.2476, -1.36567825178352),
(9405, '22739', 218, 53, 5947, 38.5219, 0.672333989124004, -77.6097, -1.35454479648504),
(9406, '22740', 218, 53, 130, 38.6297, 0.674215454057653, -78.2563, -1.36583009542844),
(9407, '22741', 218, 53, 106575, 38.445, 0.67099183092922, -77.8805, -1.35927114809944),
(9408, '22742', 218, 53, 106701, 38.4569, 0.671199525110207, -77.7095, -1.35628663507853),
(9409, '22743', 218, 53, 31282, 38.5148, 0.672210070747112, -78.3539, -1.36753353677839),
(9410, '22746', 218, 53, 107154, 38.645, 0.674482489433209, -78.0258, -1.36180711150259),
(9411, '22747', 218, 53, 12671, 38.7183, 0.67576181577492, -78.1658, -1.36425057245538),
(9412, '22748', 218, 53, 6898, 38.3559, 0.669436742565693, -78.3482, -1.36743405301102),
(9413, '22749', 218, 53, 6954, 38.6496, 0.6745627745788, -78.1724, -1.36436576418602),
(9414, '22801', 218, 53, 41275, 38.4421, 0.670941216380912, -78.8729, -1.37659179559624),
(9415, '22802', 218, 53, 41275, 38.5061, 0.672058227102189, -78.9414, -1.37778734613385),
(9416, '22803', 218, 53, 41275, 38.4495, 0.67107037074556, -78.8696, -1.37653419973092),
(9417, '22807', 218, 53, 41275, 38.4362, 0.670838241955044, -78.874, -1.37661099421801),
(9418, '22810', 218, 53, 99665, 38.7986, 0.677163315164272, -78.7997, -1.37531421458378),
(9419, '22811', 218, 53, 99851, 38.7964, 0.677124917920728, -78.9674, -1.37824113173937),
(9420, '22812', 218, 53, 19494, 38.3845, 0.669935906731764, -78.9726, -1.37833188886047),
(9421, '22815', 218, 53, 34998, 38.6081, 0.673838462939223, -78.8, -1.37531945057153),
(9422, '22820', 218, 53, 101190, 38.7238, 0.67585780888378, -79.0143, -1.37905969115856),
(9423, '22821', 218, 53, 1992, 38.4206, 0.670565970591733, -78.9544, -1.37801423893661),
(9424, '22824', 218, 53, 27051, 38.816, 0.677467002454119, -78.572, -1.37134009987698),
(9425, '22827', 218, 53, 15918, 38.4091, 0.670365257727754, -78.619, -1.37216040462542),
(9426, '22830', 218, 53, 102147, 38.635, 0.674307956508009, -78.9832, -1.37851689376119),
(9427, '22831', 218, 53, 3161, 38.4839, 0.671670764008246, -79.0079, -1.37894799008643),
(9428, '22832', 218, 53, 103258, 38.4541, 0.671150655891151, -78.7644, -1.37469811335782),
(9429, '22833', 218, 53, 103419, 38.5515, 0.672850606582594, -78.7358, -1.37419894919175),
(9430, '22834', 218, 53, 41810, 38.5584, 0.672971034300982, -78.8954, -1.37698449467793),
(9431, '22835', 218, 53, 33155, 38.663, 0.674796648698568, -78.4546, -1.36929108333514),
(9432, '22840', 218, 53, 104117, 38.4047, 0.670288463240666, -78.7224, -1.37396507507198),
(9433, '22841', 218, 53, 104433, 38.352, 0.669368674724865, -78.9524, -1.37797933235157),
(9434, '22842', 218, 53, 30580, 38.7531, 0.676369190354615, -78.6402, -1.37253041442684),
(9435, '22843', 218, 53, 104469, 38.3685, 0.669656654051444, -79.1656, -1.38170037431682),
(9436, '22844', 218, 53, 4548, 38.6454, 0.674489470750217, -78.6745, -1.37312906236028),
(9437, '22845', 218, 53, 104981, 38.7904, 0.677020198165608, -78.8236, -1.375731348275),
(9438, '22846', 218, 53, 105173, 38.376, 0.669787553745344, -78.8027, -1.37536657446134),
(9439, '22847', 218, 53, 105523, 38.7247, 0.675873516847048, -78.7126, -1.37379403280529),
(9440, '22848', 218, 53, 5149, 38.3851, 0.669946378707275, -78.8978, -1.37702638257998),
(9441, '22849', 218, 53, 14609, 38.488, 0.671742322507578, -78.6204, -1.37218483923495),
(9442, '22850', 218, 53, 106292, 38.5586, 0.672974524959486, -78.8962, -1.37699845731195),
(9443, '22851', 218, 53, 196, 38.5491, 0.672808718680546, -78.4983, -1.37005379221826),
(9444, '22853', 218, 53, 106932, 38.6313, 0.674243379325685, -78.7776, -1.37492849681909),
(9445, '22901', 218, 53, 29461, 38.0567, 0.664214717443726, -78.4959, -1.37001190431622),
(9446, '22902', 218, 53, 29461, 38.0199, 0.663572436278992, -78.4775, -1.36969076373385),
(9447, '22903', 218, 53, 29461, 38.0348, 0.663832490337539, -78.5178, -1.3703941314224),
(9448, '22904', 218, 53, 29461, 37.9984, 0.663197190489813, -78.4708, -1.36957382667397),
(9449, '22905', 218, 53, 29461, 38.0241, 0.663645740107576, -78.491, -1.36992638318287),
(9450, '22906', 218, 53, 29461, 38.0288, 0.66372777058242, -78.4766, -1.36967505577058),
(9451, '22907', 218, 53, 29461, 37.9526, 0.6623978296924, -78.4913, -1.36993161917063),
(9452, '22908', 218, 53, 29461, 38.0352, 0.663839471654547, -78.5162, -1.37036620615437),
(9453, '22909', 218, 53, 29461, 38.0444, 0.664000041945731, -78.4731, -1.36961396924676),
(9454, '22910', 218, 53, 29461, 38.0188, 0.66355323765722, -78.5975, -1.37178515883624),
(9455, '22911', 218, 53, 29461, 38.0703, 0.664452082221997, -78.4341, -1.36893329083848),
(9456, '22920', 218, 53, 570, 37.9525, 0.662396084363148, -78.8449, -1.37610310340568),
(9457, '22922', 218, 53, 31674, 37.6837, 0.657704639333787, -78.9076, -1.37719742484668),
(9458, '22923', 218, 53, 99621, 38.1654, 0.666111890340644, -78.3625, -1.36768363509406),
(9459, '22924', 218, 53, 7298, 37.9966, 0.663165774563277, -78.7197, -1.37391795118218),
(9460, '22931', 218, 53, 101126, 37.9072, 0.661605450211995, -78.7216, -1.37395111243797),
(9461, '22932', 218, 53, 101224, 38.0693, 0.664434628929477, -78.7024, -1.37361600922159),
(9462, '22935', 218, 53, 20727, 38.2665, 0.66787641821441, -78.5755, -1.3714011864008),
(9463, '22936', 218, 53, 101588, 38.1397, 0.665663340722881, -78.4887, -1.36988624061007),
(9464, '22937', 218, 53, 101746, 37.8038, 0.659800779765432, -78.6255, -1.3722738510268),
(9465, '22938', 218, 53, 8812, 37.8569, 0.660727549598241, -78.7568, -1.37456546833467),
(9466, '22939', 218, 53, 101939, 38.0879, 0.664759260170348, -78.9666, -1.37822716910535),
(9467, '22940', 218, 53, 35995, 38.1536, 0.665905941488908, -78.5784, -1.37145180094911),
(9468, '22942', 218, 53, 2788, 38.135, 0.665581310248038, -78.1852, -1.36458916633027),
(9469, '22943', 218, 53, 2869, 38.0449, 0.664008768591991, -78.7895, -1.37513619100007),
(9470, '22945', 218, 53, 9678, 38.0567, 0.664214717443726, -78.5966, -1.37176945087298),
(9471, '22946', 218, 53, 16697, 37.9243, 0.661903901514086, -78.5584, -1.37110273509871),
(9472, '22947', 218, 53, 103314, 37.9987, 0.663202426477569, -78.3743, -1.36788958394579),
(9473, '22948', 218, 53, 103761, 38.3306, 0.668995174264938, -78.1141, -1.3633482372321),
(9474, '22949', 218, 53, 103845, 37.8017, 0.65976412785114, -78.8787, -1.37669302469285),
(9475, '22952', 218, 53, 103886, 38.0233, 0.66363177747356, -78.9327, -1.37763550248893),
(9476, '22953', 218, 53, 73327, 38.2452, 0.667504663083735, -78.1124, -1.36331856663482),
(9477, '22954', 218, 53, 104052, 37.8128, 0.659957859398112, -78.9681, -1.37825334904413),
(9478, '22957', 218, 53, 0, 38.1997, 0.666710538274078, -78.1187, -1.36342852237769),
(9479, '22958', 218, 53, 104595, 37.9096, 0.661647338114042, -78.8742, -1.37661448487651),
(9480, '22959', 218, 53, 104714, 37.9551, 0.6624414629237, -78.6939, -1.37346765623517),
(9481, '22960', 218, 53, 4797, 38.2427, 0.667461029852435, -78.1107, -1.36328889603753),
(9482, '22963', 218, 53, 4846, 37.9154, 0.661748567210658, -78.3224, -1.36698375806401),
(9483, '22964', 218, 53, 105291, 37.7154, 0.658257908706669, -79.0207, -1.37917139223068),
(9484, '22965', 218, 53, 105527, 38.2807, 0.668124254968193, -78.4308, -1.36887569497317),
(9485, '22967', 218, 53, 11685, 37.915, 0.66174158589365, -78.9522, -1.37797584169307),
(9486, '22968', 218, 53, 24559, 38.2198, 0.667061349453729, -78.3844, -1.36806586220024),
(9487, '22969', 218, 53, 106069, 37.776, 0.659315578233378, -78.6996, -1.37356714000253),
(9488, '22971', 218, 53, 28601, 37.7694, 0.659200386502746, -78.8109, -1.37550969146),
(9489, '22972', 218, 53, 5946, 38.2097, 0.666885071199277, -78.2366, -1.3654862655658),
(9490, '22973', 218, 53, 106532, 38.2953, 0.668379073038984, -78.4393, -1.36902404795959),
(9491, '22974', 218, 53, 199, 37.9411, 0.662197116828421, -78.2351, -1.36546008562702),
(9492, '22976', 218, 53, 138, 37.9216, 0.661856777624282, -78.9457, -1.37786239529169),
(9493, '22980', 218, 53, 25858, 38.0711, 0.664466044856013, -78.8994, -1.37705430784801),
(9494, '22987', 218, 53, 367, 38.1176, 0.665277622958191, -78.662, -1.37291089620378),
(9495, '22989', 218, 53, 0, 38.214, 0.666960120357113, -78.0505, -1.36223820782783),
(9496, '23001', 218, 53, 99287, 37.28, 0.650658745143486, -76.4407, -1.33414189752923),
(9497, '23002', 218, 53, 99396, 37.3694, 0.652219069494769, -77.9181, -1.35992739189819),
(9498, '23003', 218, 53, 53227, 37.438, 0.653416365361637, -76.5759, -1.33650158267793),
(9499, '23004', 218, 53, 31676, 37.668, 0.657430622641224, -78.4114, -1.36853710109828),
(9500, '23005', 218, 53, 13301, 37.7494, 0.658851320652347, -77.473, -1.35215893139757),
(9501, '23009', 218, 53, 99569, 37.7546, 0.658942077773451, -77.1679, -1.34683393184973),
(9502, '23011', 218, 53, 99626, 37.4722, 0.654013267965819, -76.8058, -1.34051409462826),
(9503, '23014', 218, 53, 31761, 37.676, 0.657570248981384, -77.8958, -1.359538183475),
(9504, '23015', 218, 53, 53382, 38.0096, 0.663392667366037, -77.6509, -1.35526387213686),
(9505, '23017', 218, 53, 240, 37.3975, 0.652709507014579, -76.5727, -1.33644573214186),
(9506, '23018', 218, 53, 112621, 37.2703, 0.650489448206043, -76.4554, -1.33439846092927),
(9507, '23021', 218, 53, 7583, 37.3924, 0.652620495222728, -76.3726, -1.33295332830862),
(9508, '23022', 218, 53, 100152, 37.7367, 0.658629663837344, -78.2674, -1.36602382697541),
(9509, '23023', 218, 53, 100278, 37.778, 0.659350484818418, -76.9364, -1.34279349463137),
(9510, '23024', 218, 53, 100349, 38.0384, 0.663895322190611, -77.7123, -1.35633550429759),
(9511, '23025', 218, 53, 35140, 37.4211, 0.65312140471805, -76.3833, -1.33314007853858),
(9512, '23027', 218, 53, 1385, 37.6403, 0.656947166438422, -78.1334, -1.36368508577774),
(9513, '23030', 218, 53, 100697, 37.3766, 0.652344733200913, -77.0704, -1.34513223582904),
(9514, '23031', 218, 53, 100806, 37.5985, 0.656217618811088, -76.4478, -1.33426581590612),
(9515, '23032', 218, 53, 100821, 37.6722, 0.657503926469808, -76.6772, -1.3382696012102),
(9516, '23035', 218, 53, 100947, 37.4675, 0.653931237490975, -76.38, -1.33308248267327),
(9517, '23038', 218, 53, 1716, 37.8065, 0.659847903655236, -78.0875, -1.36288397965107),
(9518, '23039', 218, 53, 39964, 37.6479, 0.657079811461573, -77.7988, -1.35784521410056),
(9519, '23040', 218, 53, 20409, 37.5115, 0.654699182361853, -78.2449, -1.36563112789371),
(9520, '23043', 218, 53, 101379, 37.5545, 0.65544967394021, -76.3565, -1.33267233029905),
(9521, '23045', 218, 53, 64211, 37.436, 0.653381458776597, -76.2812, -1.3313580973723),
(9522, '23047', 218, 53, 20638, 37.8473, 0.66055999799005, -77.5065, -1.35274361669699),
(9523, '23050', 218, 53, 2141, 37.4861, 0.654255868731846, -76.4306, -1.33396561927478),
(9524, '23054', 218, 53, 21079, 37.6838, 0.657706384663039, -77.8848, -1.35934619725728),
(9525, '23055', 218, 53, 102042, 37.7708, 0.659224821112274, -78.2168, -1.3651406903739),
(9526, '23056', 218, 53, 35967, 37.4532, 0.65368165540794, -76.3847, -1.33316451314811),
(9527, '23058', 218, 53, 2745, 37.6636, 0.657353828154136, -77.4849, -1.35236662557855),
(9528, '23059', 218, 53, 2745, 37.7173, 0.658291069962457, -77.5764, -1.35396360184413),
(9529, '23060', 218, 53, 2745, 37.66, 0.657290996301064, -77.5284, -1.35312584380317),
(9530, '23061', 218, 53, 65078, 37.4367, 0.653393676081361, -76.5462, -1.33598321989008),
(9531, '23062', 218, 53, 102313, 37.2582, 0.650278263366551, -76.4944, -1.33507913933755),
(9532, '23063', 218, 53, 102327, 37.7068, 0.658107810390998, -77.9781, -1.36097458944939),
(9533, '23064', 218, 53, 102493, 37.5007, 0.654510686802638, -76.3012, -1.3317071632227),
(9534, '23065', 218, 53, 2907, 37.8004, 0.659741438570865, -77.9348, -1.36021886188328),
(9535, '23066', 218, 53, 102539, 37.5005, 0.654507196144134, -76.2889, -1.3314924877247),
(9536, '23067', 218, 53, 36237, 37.815, 0.659996256641656, -78.0139, -1.3615994173216),
(9537, '23068', 218, 53, 102564, 37.494, 0.654393749742754, -76.3401, -1.33238609630172),
(9538, '23069', 218, 53, 2963, 37.7779, 0.659348739489166, -77.3112, -1.34933498866784),
(9539, '23070', 218, 53, 36293, 37.5439, 0.655264669039499, -76.4266, -1.3338958061047),
(9540, '23071', 218, 53, 102646, 37.5621, 0.655582318963362, -76.4793, -1.3348155946205),
(9541, '23072', 218, 53, 3020, 37.3064, 0.651119512066012, -76.5186, -1.33550150901653),
(9542, '23075', 218, 53, 36415, 37.5444, 0.655273395685759, -77.324, -1.3495583908121),
(9543, '23076', 218, 53, 36517, 37.4709, 0.653990578685543, -76.3263, -1.33214524086495),
(9544, '23079', 218, 53, 22217, 37.7246, 0.658418478997853, -76.6918, -1.33852441928099),
(9545, '23081', 218, 53, 3399, 37.2243, 0.649686596750125, -76.7829, -1.34011441422955),
(9546, '23083', 218, 53, 103189, 37.3192, 0.651342914210268, -78.1159, -1.36337965315864),
(9547, '23084', 218, 53, 103290, 37.8623, 0.660821797377849, -78.0447, -1.36213697873122),
(9548, '23085', 218, 53, 103353, 37.729, 0.658495273484941, -76.8445, -1.34118953704878),
(9549, '23086', 218, 53, 103350, 37.6795, 0.657631335505203, -77.0673, -1.34507813062223),
(9550, '23089', 218, 53, 103513, 37.3991, 0.652737432282611, -76.8848, -1.34189290473734),
(9551, '23090', 218, 53, 88575, 37.3256, 0.651454615282395, -76.7395, -1.33935694133419),
(9552, '23091', 218, 53, 103729, 37.6677, 0.657425386653468, -76.8099, -1.34058565312759),
(9553, '23092', 218, 53, 36943, 37.5893, 0.656057048519905, -76.4983, -1.33514720717838),
(9554, '23093', 218, 53, 36978, 38.0913, 0.664818601364916, -78.0198, -1.36170239174747),
(9555, '23101', 218, 53, 3937, 37.5217, 0.654877205945556, -77.9643, -1.36073373401261),
(9556, '23102', 218, 53, 103937, 37.7021, 0.658025779916154, -77.8374, -1.35851891119183),
(9557, '23103', 218, 53, 0, 37.6548, 0.657200239179961, -77.7231, -1.3565239998568),
(9558, '23105', 218, 53, 103963, 37.251, 0.650152599660408, -77.8237, -1.35827980108431),
(9559, '23106', 218, 53, 103967, 37.7109, 0.65817936889033, -77.1925, -1.34726328284572),
(9560, '23107', 218, 53, 104037, 37.2794, 0.650648273167974, -76.4028, -1.33348041774272),
(9561, '23108', 218, 53, 56120, 37.5888, 0.656048321873644, -76.7253, -1.33910910458041),
(9562, '23109', 218, 53, 42009, 37.4412, 0.653472215897701, -76.3604, -1.33274039813988),
(9563, '23110', 218, 53, 104065, 37.6392, 0.65692796781665, -76.7813, -1.34008648896152),
(9564, '23111', 218, 53, 4145, 37.6332, 0.65682324806153, -77.3573, -1.35013958545301),
(9565, '23112', 218, 53, 49469, 37.4317, 0.653306409618761, -77.6484, -1.35522023890557),
(9566, '23113', 218, 53, 49469, 37.4944, 0.654400731059762, -77.6406, -1.35508410322391),
(9567, '23114', 218, 53, 49469, 37.4945, 0.654402476389014, -77.6406, -1.35508410322391),
(9568, '23115', 218, 53, 104281, 37.8276, 0.660216168127407, -76.9448, -1.34294010228853),
(9569, '23116', 218, 53, 4145, 37.6278, 0.656729000281922, -77.3557, -1.35011166018498),
(9570, '23117', 218, 53, 10518, 37.8381, 0.660399427698866, -77.9775, -1.36096411747388),
(9571, '23119', 218, 53, 37258, 37.4497, 0.65362056888412, -76.3037, -1.331750796454),
(9572, '23120', 218, 53, 60956, 37.417, 0.653049846218718, -77.7703, -1.35734779526375),
(9573, '23123', 218, 53, 28019, 37.6469, 0.657062358169053, -78.2899, -1.36641652605711),
(9574, '23124', 218, 53, 112615, 37.5534, 0.655430475318439, -77.0926, -1.34551969892298),
(9575, '23125', 218, 53, 23349, 37.3488, 0.651859531668858, -76.2815, -1.33136333336005),
(9576, '23126', 218, 53, 839, 37.8764, 0.66106788880238, -77.1179, -1.34596126722374),
(9577, '23127', 218, 53, 76729, 37.3635, 0.652116095068901, -76.7696, -1.33988228543904),
(9578, '23128', 218, 53, 82617, 37.468, 0.653939964137235, -76.3803, -1.33308771866103),
(9579, '23129', 218, 53, 104896, 37.6993, 0.657976910697098, -77.7815, -1.35754327213997),
(9580, '23130', 218, 53, 104957, 37.3997, 0.652747904258123, -76.2785, -1.33131097348249),
(9581, '23131', 218, 53, 37540, 37.3149, 0.651267865052432, -76.5139, -1.33541947854169),
(9582, '23138', 218, 53, 105400, 37.3767, 0.652346478530165, -76.299, -1.33166876597915),
(9583, '23139', 218, 53, 5207, 37.5423, 0.655236743771467, -77.8783, -1.3592327508559),
(9584, '23140', 218, 53, 105484, 37.4164, 0.653039374243206, -77.1142, -1.34589669004141),
(9585, '23141', 218, 53, 5264, 37.5056, 0.654596207935985, -77.1507, -1.34653373521839),
(9586, '23146', 218, 53, 5479, 37.7032, 0.658044978537926, -77.7053, -1.35621333124995),
(9587, '23147', 218, 53, 90552, 37.3668, 0.652173690934217, -77.0411, -1.3446208543582),
(9588, '23148', 218, 53, 0, 37.9164, 0.661766020503178, -77.0777, -1.34525964486443),
(9589, '23149', 218, 53, 31060, 37.5781, 0.655861571643681, -76.6076, -1.33705485205081),
(9590, '23150', 218, 53, 106022, 37.5155, 0.654768995531933, -77.2781, -1.34875728468543),
(9591, '23153', 218, 53, 31072, 37.7803, 0.659390627391214, -77.9657, -1.36075816862214),
(9592, '23154', 218, 53, 5686, 37.389, 0.65256115402816, -76.455, -1.33439147961226),
(9593, '23155', 218, 53, 51296, 37.2941, 0.650904836568017, -76.4155, -1.33370207455773),
(9594, '23156', 218, 53, 106127, 37.5894, 0.656058793849156, -76.7259, -1.33911957655592),
(9595, '23160', 218, 53, 0, 37.6514, 0.657140897985393, -77.8228, -1.35826409312104),
(9596, '23161', 218, 53, 51694, 37.7061, 0.658095593086234, -76.9361, -1.34278825864361),
(9597, '23162', 218, 53, 106666, 37.6755, 0.657561522335124, -77.2911, -1.34898417748819),
(9598, '23163', 218, 53, 106744, 37.3524, 0.65192236352193, -76.31, -1.33186075219687),
(9599, '23168', 218, 53, 106946, 37.3936, 0.652641439173752, -76.8261, -1.34086839646642),
(9600, '23169', 218, 53, 106954, 37.5981, 0.65621063749408, -76.4601, -1.33448049140412),
(9601, '23170', 218, 53, 106982, 38.0516, 0.664125705651874, -78.0734, -1.36263788822654),
(9602, '23173', 218, 53, 0, 37.5775, 0.655851099668169, -77.5347, -1.35323579954605),
(9603, '23175', 218, 53, 107072, 37.6542, 0.657189767204449, -76.6147, -1.3371787704277),
(9604, '23176', 218, 53, 107218, 37.5662, 0.655653877462694, -76.4291, -1.333939439336),
(9605, '23177', 218, 53, 6611, 37.7652, 0.659127082674163, -77.0095, -1.34406933031457),
(9606, '23178', 218, 53, 107281, 37.4021, 0.652789792160171, -76.4589, -1.33445954745309),
(9607, '23180', 218, 53, 52529, 37.7004, 0.65799610931887, -76.6187, -1.33724858359778),
(9608, '23181', 218, 53, 6722, 37.5542, 0.655444437952455, -76.8103, -1.3405926344446),
(9609, '23183', 218, 53, 52731, 37.3421, 0.651742594608975, -76.5215, -1.33555212356484),
(9610, '23184', 218, 53, 52776, 37.2908, 0.650847240702701, -76.51, -1.33535141070086),
(9611, '23185', 218, 53, 6831, 37.2659, 0.650412653718955, -76.7104, -1.33884905052186),
(9612, '23186', 218, 53, 6831, 37.2719, 0.650517373474075, -76.6815, -1.33834465036803),
(9613, '23187', 218, 53, 6831, 37.2706, 0.650494684193799, -76.7072, -1.33879319998579),
(9614, '23188', 218, 53, 6831, 37.3269, 0.651477304562671, -76.7588, -1.33969378987982),
(9615, '23190', 218, 53, 0, 37.4815, 0.654175583586255, -76.6186, -1.33724683826853),
(9616, '23191', 218, 53, 58391, 37.4154, 0.653021920950686, -76.5309, -1.33571618451453),
(9617, '23192', 218, 53, 23162, 37.8101, 0.659910735508308, -77.594, -1.35427077979248),
(9618, '23218', 218, 53, 5381, 37.5395, 0.655187874552411, -77.4367, -1.35152537687909),
(9619, '23219', 218, 53, 5381, 37.5383, 0.655166930601387, -77.4391, -1.35156726478114),
(9620, '23220', 218, 53, 5381, 37.55, 0.655371134123871, -77.457, -1.35187967871725),
(9621, '23221', 218, 53, 5381, 37.5566, 0.655486325854502, -77.4889, -1.35243643874863),
(9622, '23222', 218, 53, 5381, 37.5708, 0.655734162608286, -77.4296, -1.3514014585022),
(9623, '23223', 218, 53, 5381, 37.5389, 0.655177402576899, -77.4118, -1.35109078989535),
(9624, '23224', 218, 53, 5381, 37.4999, 0.654496724168621, -77.474, -1.35217638469009),
(9625, '23225', 218, 53, 5381, 37.5171, 0.654796920799965, -77.5044, -1.35270696478269),
(9626, '23226', 218, 53, 5381, 37.5728, 0.655769069193325, -77.5157, -1.35290418698817),
(9627, '23227', 218, 53, 5381, 37.6221, 0.656629516514559, -77.4409, -1.35159868070768),
(9628, '23228', 218, 53, 5381, 37.6249, 0.656678385733614, -77.4953, -1.35254813982076),
(9629, '23229', 218, 53, 5381, 37.6022, 0.656282195993412, -77.5589, -1.35365816922503),
(9630, '23230', 218, 53, 5381, 37.5917, 0.656098936421952, -77.498, -1.35259526371057),
(9631, '23231', 218, 53, 5381, 37.478, 0.654114497062435, -77.3517, -1.3500418470149),
(9632, '23232', 218, 53, 5381, 37.3993, 0.652740922941115, -77.4847, -1.35236313492005),
(9633, '23233', 218, 53, 5381, 37.6213, 0.656615553880543, -77.6139, -1.35461810031363),
(9634, '23234', 218, 53, 5381, 37.4525, 0.653669438103176, -77.4755, -1.35220256462887),
(9635, '23235', 218, 53, 5381, 37.513, 0.654725362300633, -77.5651, -1.35376637963865),
(9636, '23236', 218, 53, 5381, 37.4768, 0.654093553111411, -77.5856, -1.35412417213531),
(9637, '23237', 218, 53, 5381, 37.4008, 0.652767102879895, -77.4626, -1.35197741715536),
(9638, '23238', 218, 53, 5381, 37.6178, 0.656554467356723, -77.6154, -1.35464428025241),
(9639, '23240', 218, 53, 5381, 37.5535, 0.655432220647691, -77.4604, -1.35193901991182),
(9640, '23241', 218, 53, 5381, 37.5827, 0.655941856789273, -77.4204, -1.35124088821102),
(9641, '23242', 218, 53, 5381, 37.6183, 0.656563194002983, -77.6148, -1.35463380827689),
(9642, '23249', 218, 53, 5381, 37.4979, 0.654461817583582, -77.4673, -1.3520594476302),
(9643, '23250', 218, 53, 5381, 37.5032, 0.654554320033937, -77.3377, -1.34979750091962),
(9644, '23255', 218, 53, 5381, 37.5887, 0.656046576544393, -77.5675, -1.3538082675407),
(9645, '23260', 218, 53, 5381, 37.5491, 0.655355426160603, -77.4581, -1.35189887733902),
(9646, '23261', 218, 53, 5381, 37.5491, 0.655355426160603, -77.4576, -1.35189015069276),
(9647, '23269', 218, 53, 5381, 37.5592, 0.655531704415054, -77.4641, -1.35200359709414),
(9648, '23270', 218, 53, 5381, 37.5599, 0.655543921719818, -77.4469, -1.3517034004628),
(9649, '23272', 218, 53, 5381, 37.541, 0.655214054491191, -77.4359, -1.35151141424508),
(9650, '23273', 218, 53, 5381, 37.5844, 0.655971527386557, -77.4942, -1.35252894119899),
(9651, '23274', 218, 53, 5381, 37.5425, 0.655240234429971, -77.4439, -1.35165104058524),
(9652, '23275', 218, 53, 5381, 37.5597, 0.655540431061314, -77.4469, -1.3517034004628),
(9653, '23276', 218, 53, 5381, 37.5601, 0.655547412378322, -77.4467, -1.35169990980429),
(9654, '23278', 218, 53, 5381, 37.5602, 0.655549157707574, -77.4468, -1.35170165513354),
(9655, '23279', 218, 53, 5381, 37.5891, 0.656053557861401, -77.4928, -1.35250450658946),
(9656, '23280', 218, 53, 5381, 37.5457, 0.655296084966035, -77.3303, -1.34966834655497),
(9657, '23282', 218, 53, 5381, 37.5582, 0.655514251122534, -77.4636, -1.35199487044788),
(9658, '23284', 218, 53, 5381, 37.5487, 0.655348444843595, -77.4582, -1.35190062266827),
(9659, '23285', 218, 53, 5381, 37.5393, 0.655184383893907, -77.4369, -1.3515288675376),
(9660, '23286', 218, 53, 5381, 37.56, 0.65554566704907, -77.4464, -1.35169467381654),
(9661, '23288', 218, 53, 5381, 37.5998, 0.656240308091364, -77.5455, -1.35342429510526),
(9662, '23289', 218, 53, 5381, 37.6238, 0.656659187111843, -77.5321, -1.3531904209855),
(9663, '23290', 218, 53, 5381, 37.5486, 0.655346699514343, -77.474, -1.35217638469009),
(9664, '23291', 218, 53, 5381, 37.5421, 0.655233253112963, -77.4437, -1.35164754992673),
(9665, '23292', 218, 53, 5381, 37.5427, 0.655243725088475, -77.4436, -1.35164580459748),
(9666, '23293', 218, 53, 5381, 37.4438, 0.653517594458253, -77.3208, -1.34950254027603),
(9667, '23294', 218, 53, 5381, 37.632, 0.656802304110506, -77.5452, -1.35341905911751),
(9668, '23295', 218, 53, 5381, 37.554, 0.655440947293951, -77.4608, -1.35194600122882),
(9669, '23297', 218, 53, 5381, 37.4019, 0.652786301501667, -77.457, -1.35187967871725),
(9670, '23298', 218, 53, 5381, 37.5404, 0.655203582515679, -77.4321, -1.3514450917335),
(9671, '23301', 218, 53, 99284, 37.7051, 0.658078139793714, -75.6643, -1.32059116121675),
(9672, '23302', 218, 53, 0, 37.8572, 0.660732785585997, -75.5174, -1.31802727254557),
(9673, '23303', 218, 53, 62617, 37.9009, 0.661495494469119, -75.5081, -1.31786495692513),
(9674, '23304', 218, 53, 44619, 36.9954, 0.64569153809231, -76.5757, -1.33649809201942),
(9675, '23306', 218, 53, 245, 37.5844, 0.655971527386557, -75.875, -1.3242685699507),
(9676, '23307', 218, 53, 99936, 37.4362, 0.653384949435101, -75.8978, -1.32466650502015),
(9677, '23308', 218, 53, 99999, 37.8229, 0.660134137652563, -75.611, -1.31966090072543),
(9678, '23310', 218, 53, 100483, 37.2695, 0.650475485572027, -76.0168, -1.32674344683003),
(9679, '23313', 218, 53, 88, 37.2059, 0.649365456167758, -75.9738, -1.32599295525167),
(9680, '23314', 218, 53, 1380, 36.9442, 0.644797929515289, -76.5273, -1.33565335266146),
(9681, '23315', 218, 53, 35158, 36.7443, 0.641309016340552, -76.833, -1.3409888241848),
(9682, '23316', 218, 53, 100722, 37.2773, 0.650611621253682, -75.9594, -1.32574162783938),
(9683, '23320', 218, 53, 54018, 36.7349, 0.641144955390865, -76.2388, -1.33061807776945),
(9684, '23321', 218, 53, 54018, 36.7972, 0.642232295514857, -76.4251, -1.33386962616592),
(9685, '23322', 218, 53, 54018, 36.5801, 0.638443185708778, -76.3093, -1.33184853489211),
(9686, '23323', 218, 53, 54018, 36.761, 0.641600486325635, -76.3395, -1.33237562432621),
(9687, '23324', 218, 53, 54018, 36.8027, 0.642328288623717, -76.2699, -1.33116087516682),
(9688, '23325', 218, 53, 54018, 36.814, 0.642525510829193, -76.2404, -1.33064600303748),
(9689, '23326', 218, 53, 54018, 36.7658, 0.641684262129731, -76.2522, -1.33085195188922),
(9690, '23327', 218, 53, 54018, 36.7415, 0.641260147121497, -76.2301, -1.33046623412453),
(9691, '23328', 218, 53, 54018, 36.7299, 0.641057688928265, -76.2266, -1.33040514760071),
(9692, '23336', 218, 53, 0, 37.9285, 0.661977205342669, -75.3762, -1.31556286764175),
(9693, '23337', 218, 53, 0, 37.8621, 0.660818306719345, -75.4633, -1.31708304942024),
(9694, '23341', 218, 53, 101151, 37.5789, 0.655875534277697, -75.7948, -1.3228688158906),
(9695, '23345', 218, 53, 101317, 37.5672, 0.655671330755214, -75.8873, -1.32448324544869),
(9696, '23347', 218, 53, 20780, 37.2766, 0.650599403948918, -75.9592, -1.32573813718088),
(9697, '23350', 218, 53, 101788, 37.5358, 0.655123297370088, -75.827, -1.32343081190974),
(9698, '23354', 218, 53, 102110, 37.4626, 0.653845716357628, -75.8889, -1.32451117071673),
(9699, '23356', 218, 53, 102429, 38.0015, 0.663251295696625, -75.4153, -1.31624529137928),
(9700, '23357', 218, 53, 32623, 37.7612, 0.659057269504083, -75.6722, -1.32072904222765),
(9701, '23358', 218, 53, 102543, 37.5791, 0.655879024936201, -75.7953, -1.32287754253686),
(9702, '23359', 218, 53, 107, 37.8494, 0.660596649904342, -75.5511, -1.31861544850349),
(9703, '23389', 218, 53, 102607, 37.6401, 0.656943675779918, -75.7458, -1.32201360455712),
(9704, '23395', 218, 53, 36501, 37.9707, 0.662713734287011, -75.4754, -1.31729423425973),
(9705, '23396', 218, 53, 165420, 37.9342, 0.662076689110033, -75.576, -1.31905003548723),
(9706, '23397', 218, 53, 103112, 36.8548, 0.643237605164006, -76.721, -1.33903405542257),
(9707, '23398', 218, 53, 3401, 37.5082, 0.654641586496537, -75.8701, -1.32418304881735),
(9708, '23399', 218, 53, 0, 37.9156, 0.661752057869162, -75.6335, -1.32005359980713),
(9709, '23401', 218, 53, 22331, 37.6398, 0.656938439792162, -75.746, -1.32201709521562),
(9710, '23404', 218, 53, 14137, 37.6451, 0.657030942242517, -75.6693, -1.32067842767935),
(9711, '23405', 218, 53, 103910, 37.4059, 0.652856114671747, -75.9131, -1.32493354039571),
(9712, '23407', 218, 53, 103991, 37.8331, 0.660312161236267, -75.5756, -1.31904305417023),
(9713, '23408', 218, 53, 56093, 37.4365, 0.653390185422857, -75.8978, -1.32466650502015),
(9714, '23409', 218, 53, 132028, 37.8764, 0.66106788880238, -75.65, -1.32034157913371),
(9715, '23410', 218, 53, 104181, 37.6405, 0.656950657096926, -75.7465, -1.32202582186188),
(9716, '23412', 218, 53, 104320, 37.8323, 0.660298198602251, -75.5678, -1.31890691848857),
(9717, '23413', 218, 53, 104572, 37.4362, 0.653384949435101, -75.8975, -1.3246612690324),
(9718, '23414', 218, 53, 119, 37.8325, 0.660301689260755, -75.5684, -1.31891739046408),
(9719, '23415', 218, 53, 112622, 37.9618, 0.662558399983583, -75.5131, -1.31795222338773),
(9720, '23416', 218, 53, 165420, 37.954, 0.662422264301928, -75.6164, -1.31975514850504),
(9721, '23417', 218, 53, 104951, 37.7153, 0.658256163377417, -75.7544, -1.32216370287279),
(9722, '23418', 218, 53, 104952, 37.6593, 0.657278778996301, -75.6854, -1.32095942568892),
(9723, '23419', 218, 53, 105016, 37.2867, 0.65077568220337, -75.9224, -1.32509585601614),
(9724, '23420', 218, 53, 4838, 37.5792, 0.655880770265453, -75.7951, -1.32287405187835),
(9725, '23421', 218, 53, 105071, 37.7881, 0.659526763072869, -75.6568, -1.32046026152285),
(9726, '23422', 218, 53, 105502, 37.5793, 0.655882515594705, -75.7955, -1.32288103319536),
(9727, '23423', 218, 53, 83188, 37.5794, 0.655884260923957, -75.7955, -1.32288103319536),
(9728, '23424', 218, 53, 57140, 36.955, 0.644986425074504, -76.543, -1.33592736935402),
(9729, '23426', 218, 53, 188, 37.9215, 0.66185503229503, -75.6846, -1.3209454630549),
(9730, '23427', 218, 53, 106059, 37.9222, 0.661867249599794, -75.6853, -1.32095768035966),
(9731, '23429', 218, 53, 51267, 37.2771, 0.650608130595178, -75.9606, -1.3257625717904),
(9732, '23430', 218, 53, 5916, 36.9824, 0.645464645289551, -76.6156, -1.33719447839097),
(9733, '23431', 218, 53, 5916, 36.9823, 0.645462899960299, -76.618, -1.33723636629302),
(9734, '23432', 218, 53, 61919, 36.8354, 0.642899011289119, -76.5607, -1.33623629263162),
(9735, '23433', 218, 53, 61919, 36.877, 0.643625068257949, -76.5095, -1.3353426840546),
(9736, '23434', 218, 53, 61919, 36.7331, 0.641113539464329, -76.5997, -1.3369169710399),
(9737, '23435', 218, 53, 61919, 36.8525, 0.64319746259121, -76.4701, -1.33465502432932),
(9738, '23436', 218, 53, 61919, 36.8942, 0.643925264889292, -76.5117, -1.33538108129815),
(9739, '23437', 218, 53, 61919, 36.627, 0.639261745127963, -76.793, -1.34029069248401),
(9740, '23438', 218, 53, 61919, 36.5608, 0.638106337163143, -76.7171, -1.33896598758174),
(9741, '23439', 218, 53, 61919, 36.703, 0.640588195359479, -76.6383, -1.33759066813117),
(9742, '23440', 218, 53, 31286, 37.8303, 0.660263292017211, -75.9964, -1.32638739966262),
(9743, '23441', 218, 53, 106824, 37.7169, 0.658284088645449, -75.7749, -1.32252149536945),
(9744, '23442', 218, 53, 12280, 37.8941, 0.661376812079983, -75.5594, -1.3187603108314),
(9745, '23443', 218, 53, 14757, 37.2774, 0.650613366582934, -75.9597, -1.32574686382714),
(9746, '23450', 218, 53, 107180, 36.8457, 0.643078780202075, -76.0921, -1.32805767975678),
(9747, '23451', 218, 53, 107180, 36.8628, 0.643377231504166, -76.0119, -1.32665792569668),
(9748, '23452', 218, 53, 107180, 36.8376, 0.642937408532663, -76.0936, -1.32808385969556),
(9749, '23453', 218, 53, 107180, 36.7765, 0.641871012359695, -76.0771, -1.32779588036898),
(9750, '23454', 218, 53, 107180, 36.8341, 0.642876322008843, -76.0258, -1.32690052646271),
(9751, '23455', 218, 53, 107180, 36.888, 0.643817054475668, -76.146, -1.3289984122236),
(9752, '23456', 218, 53, 107180, 36.7758, 0.641858795054931, -76.0765, -1.32778540839347),
(9753, '23457', 218, 53, 107180, 36.6201, 0.639141317409575, -76.0585, -1.32747124912811),
(9754, '23458', 218, 53, 107180, 36.8545, 0.64323236917625, -75.9765, -1.32604007914147),
(9755, '23459', 218, 53, 107180, 36.9246, 0.644455844981898, -76.012, -1.32665967102593),
(9756, '23460', 218, 53, 107180, 36.8139, 0.64252376549994, -76.0223, -1.32683943993889),
(9757, '23461', 218, 53, 107180, 36.8011, 0.642300363355685, -76.008, -1.32658985785585),
(9758, '23462', 218, 53, 107180, 36.8382, 0.642947880508175, -76.1519, -1.32910138664947),
(9759, '23463', 218, 53, 107180, 36.7983, 0.642251494136629, -76.1802, -1.32959531482778),
(9760, '23464', 218, 53, 107180, 36.7997, 0.642275928746157, -76.1753, -1.32950979369444),
(9761, '23465', 218, 53, 107180, 36.7994, 0.642270692758401, -76.176, -1.3295220109992),
(9762, '23466', 218, 53, 107180, 36.8388, 0.642958352483687, -76.153, -1.32912058527124),
(9763, '23467', 218, 53, 107180, 36.7999, 0.642279419404661, -76.1756, -1.32951502968219),
(9764, '23468', 218, 53, 107180, 36.8528, 0.643202698578966, -75.9787, -1.32607847638502),
(9765, '23471', 218, 53, 107180, 36.8903, 0.643857197048464, -76.1465, -1.32900713886986),
(9766, '23479', 218, 53, 107180, 36.8469, 0.643099724153099, -76.0924, -1.32806291574453),
(9767, '23480', 218, 53, 107213, 37.6059, 0.656346773175736, -75.6908, -1.32105367346852),
(9768, '23482', 218, 53, 107280, 37.5088, 0.654652058472049, -75.8708, -1.32419526612211),
(9769, '23483', 218, 53, 6661, 37.9623, 0.662567126629843, -75.5135, -1.31795920470474),
(9770, '23486', 218, 53, 107636, 37.5084, 0.654645077155041, -75.8708, -1.32419526612211),
(9771, '23487', 218, 53, 18652, 36.8136, 0.642518529512184, -76.7418, -1.33939708390698),
(9772, '23488', 218, 53, 107729, 37.9622, 0.662565381300591, -75.513, -1.31795047805848),
(9773, '23501', 218, 53, 61085, 36.8961, 0.64395842614508, -76.209, -1.33009796965236),
(9774, '23502', 218, 53, 61085, 36.8544, 0.643230623846998, -76.2139, -1.33018349078571),
(9775, '23503', 218, 53, 61085, 36.9422, 0.644763022930249, -76.2529, -1.33086416919398),
(9776, '23504', 218, 53, 61085, 36.8591, 0.643312654321842, -76.2672, -1.33111375127702),
(9777, '23505', 218, 53, 61085, 36.9141, 0.644272585410439, -76.288, -1.33147677976143),
(9778, '23506', 218, 53, 61085, 36.8567, 0.643270766419794, -76.2127, -1.33016254683468),
(9779, '23507', 218, 53, 61085, 36.8643, 0.643403411442946, -76.2999, -1.33168447394242),
(9780, '23508', 218, 53, 61085, 36.8868, 0.643796110524644, -76.2998, -1.33168272861317),
(9781, '23509', 218, 53, 61085, 36.8786, 0.643652993525981, -76.2619, -1.33102124882666),
(9782, '23510', 218, 53, 61085, 36.8531, 0.643207934566722, -76.2904, -1.33151866766348),
(9783, '23511', 218, 53, 61085, 36.9393, 0.644712408381941, -76.3101, -1.33186249752613),
(9784, '23512', 218, 53, 61085, 36.9213, 0.644398249116582, -76.3158, -1.33196198129349),
(9785, '23513', 218, 53, 61085, 36.8894, 0.643841489085196, -76.2382, -1.33060760579394),
(9786, '23514', 218, 53, 61085, 36.8524, 0.643195717261958, -76.2921, -1.33154833826077),
(9787, '23515', 218, 53, 61085, 36.9196, 0.644368578519299, -76.3011, -1.33170541789345),
(9788, '23517', 218, 53, 61085, 36.8691, 0.643487187247041, -76.2924, -1.33155357424852),
(9789, '23518', 218, 53, 61085, 36.9162, 0.644309237324731, -76.2192, -1.33027599323606),
(9790, '23519', 218, 53, 61085, 36.9217, 0.64440523043359, -76.1891, -1.32975064913121),
(9791, '23520', 218, 53, 61085, 36.8471, 0.643103214811603, -76.2854, -1.33143140120088),
(9792, '23521', 218, 53, 61085, 36.9177, 0.644335417263511, -76.1564, -1.32917992646581),
(9793, '23523', 218, 53, 61085, 36.8312, 0.642825707460536, -76.2713, -1.33118530977635),
(9794, '23529', 218, 53, 61085, 36.8859, 0.643780402561376, -76.3117, -1.33189042279416),
(9795, '23530', 218, 53, 61085, 36.8528, 0.643202698578966, -76.2925, -1.33155531957777),
(9796, '23541', 218, 53, 61085, 36.856, 0.64325854911503, -76.2134, -1.33017476413945),
(9797, '23551', 218, 53, 61085, 36.8468, 0.643097978823847, -76.285, -1.33142441988387),
(9798, '23601', 218, 53, 104648, 37.058, 0.646784114204059, -76.4619, -1.33451190733065),
(9799, '23602', 218, 53, 104648, 37.1271, 0.647990136717187, -76.5216, -1.33555386889409),
(9800, '23603', 218, 53, 104648, 37.1925, 0.649131582047991, -76.5648, -1.33630785113095),
(9801, '23604', 218, 53, 0, 36.9785, 0.645396577448723, -76.4272, -1.33390627808021),
(9802, '23605', 218, 53, 104648, 37.0202, 0.646124379746805, -76.4374, -1.33408430166391),
(9803, '23606', 218, 53, 104648, 37.0739, 0.647061621555126, -76.5, -1.33517687777566),
(9804, '23607', 218, 53, 104648, 36.9885, 0.645571110373923, -76.4198, -1.33377712371556),
(9805, '23608', 218, 53, 104648, 37.1451, 0.648304295982546, -76.5392, -1.33586104684244),
(9806, '23609', 218, 53, 104648, 36.9763, 0.645358180205179, -76.4292, -1.33394118466525),
(9807, '23612', 218, 53, 104648, 37.0681, 0.64696039245851, -76.4934, -1.33506168604503),
(9808, '23628', 218, 53, 104648, 37.1462, 0.648323494604318, -76.5811, -1.33659233979903),
(9809, '23630', 218, 53, 2957, 37.0023, 0.645811965810698, -76.4102, -1.33360957210737),
(9810, '23631', 218, 53, 2957, 37.0051, 0.645860835029754, -76.4118, -1.3336374973754),
(9811, '23651', 218, 53, 0, 37.0063, 0.645881778980778, -76.3127, -1.33190787608668),
(9812, '23653', 218, 53, 2957, 37.006, 0.645876542993022, -76.4121, -1.33364273336316),
(9813, '23661', 218, 53, 2957, 37.0074, 0.64590097760255, -76.3836, -1.33314531452634),
(9814, '23662', 218, 53, 105395, 37.1335, 0.648101837789314, -76.3845, -1.33316102248961),
(9815, '23663', 218, 53, 2957, 37.0335, 0.64635650853732, -76.3156, -1.33195849063498),
(9816, '23664', 218, 53, 2957, 37.0565, 0.646757934265279, -76.2947, -1.33159371682132),
(9817, '23665', 218, 53, 2957, 37.081, 0.647185539932017, -76.3729, -1.33295856429638),
(9818, '23666', 218, 53, 2957, 37.0483, 0.646614817266615, -76.4122, -1.33364447869241),
(9819, '23667', 218, 53, 2957, 37.0082, 0.645914940236565, -76.3874, -1.33321163703792),
(9820, '23668', 218, 53, 2957, 37.0203, 0.646126125076057, -76.3382, -1.33235293504594),
(9821, '23669', 218, 53, 2957, 37.0439, 0.646538022779527, -76.3402, -1.33238784163098),
(9822, '23670', 218, 53, 2957, 37.0563, 0.646754443606775, -76.4104, -1.33361306276588),
(9823, '23681', 218, 53, 2957, 37.0889, 0.647323420942925, -76.3675, -1.33286431651677),
(9824, '23690', 218, 53, 143, 37.2253, 0.649704050042645, -76.5235, -1.33558703014988),
(9825, '23691', 218, 53, 143, 37.2437, 0.650025190625012, -76.5549, -1.33613506353501),
(9826, '23692', 218, 53, 143, 37.174, 0.648808696136372, -76.4584, -1.33445082080683),
(9827, '23693', 218, 53, 143, 37.117, 0.647813858462735, -76.4329, -1.33400576184757),
(9828, '23694', 218, 53, 36773, 37.2291, 0.649770372554221, -76.5481, -1.33601638114587),
(9829, '23696', 218, 53, 14571, 37.1893, 0.649075731511927, -76.4312, -1.33397609125029),
(9830, '23701', 218, 53, 37775, 36.8105, 0.642464424305373, -76.3672, -1.33285908052901),
(9831, '23702', 218, 53, 37775, 36.8032, 0.642337015269977, -76.3269, -1.33215571284046),
(9832, '23703', 218, 53, 37775, 36.8666, 0.643443554015741, -76.3845, -1.33316102248961),
(9833, '23704', 218, 53, 37775, 36.8298, 0.642801272851008, -76.3149, -1.33194627333022),
(9834, '23705', 218, 53, 37775, 36.8386, 0.642954861825183, -76.3407, -1.33239656827724),
(9835, '23707', 218, 53, 37775, 36.8352, 0.642895520630615, -76.3451, -1.33247336276432),
(9836, '23708', 218, 53, 37775, 36.8282, 0.642773347582976, -76.3149, -1.33194627333022),
(9837, '23709', 218, 53, 37775, 36.8128, 0.642504566878169, -76.3086, -1.33183631758734),
(9838, '23801', 218, 53, 102055, 37.2361, 0.649892545601861, -77.3319, -1.349696271823),
(9839, '23803', 218, 53, 14402, 37.214, 0.64950682783717, -77.4138, -1.35112569648039),
(9840, '23804', 218, 53, 14402, 37.2286, 0.649761645907961, -77.4028, -1.35093371026267),
(9841, '23805', 218, 53, 14402, 37.1754, 0.6488331307459, -77.3786, -1.35051134058368),
(9842, '23806', 218, 53, 14402, 37.2276, 0.649744192615441, -77.402, -1.35091974762865),
(9843, '23821', 218, 53, 34519, 36.8366, 0.642919955240143, -77.8513, -1.35876151195786),
(9844, '23822', 218, 53, 725, 37.1629, 0.648614964589401, -77.5867, -1.35414337075708),
(9845, '23824', 218, 53, 99958, 37.0774, 0.647122708078945, -78.0005, -1.36136554320184),
(9846, '23827', 218, 53, 100111, 36.5824, 0.638483328281574, -77.1998, -1.34739069188112),
(9847, '23828', 218, 53, 1085, 36.5857, 0.638540924146889, -77.2901, -1.34896672419567),
(9848, '23829', 218, 53, 75328, 36.7356, 0.641157172695629, -77.2373, -1.34804519035062),
(9849, '23830', 218, 53, 572, 37.0334, 0.646354763208068, -77.3677, -1.35032109969522),
(9850, '23831', 218, 53, 8056, 37.3449, 0.65179146382803, -77.4134, -1.35111871516338),
(9851, '23832', 218, 53, 1534, 37.3891, 0.652562899357412, -77.5725, -1.3538955340033),
(9852, '23833', 218, 53, 0, 37.2147, 0.649519045141934, -77.6751, -1.35568624181585),
(9853, '23834', 218, 53, 1711, 37.2718, 0.650515628144823, -77.4041, -1.35095639954294),
(9854, '23836', 218, 53, 8056, 37.35, 0.651880475619882, -77.3269, -1.3496090053604),
(9855, '23837', 218, 53, 1839, 36.7064, 0.640647536554047, -77.0572, -1.34490185236777),
(9856, '23838', 218, 53, 1534, 37.3262, 0.651465087257907, -77.6074, -1.35450465391225),
(9857, '23839', 218, 53, 64189, 36.9983, 0.645742152640618, -76.9614, -1.34322982694436),
(9858, '23840', 218, 53, 20499, 37.0044, 0.64584861772499, -77.6394, -1.35506315927289),
(9859, '23841', 218, 53, 101424, 37.0813, 0.647190775919773, -77.551, -1.35352028821412),
(9860, '23842', 218, 53, 35587, 37.1496, 0.648382835798885, -77.2389, -1.34807311561865),
(9861, '23843', 218, 53, 101456, 36.8377, 0.642939153861915, -77.7943, -1.35776667428422),
(9862, '23844', 218, 53, 101505, 36.6843, 0.640261818789356, -77.3618, -1.35021812526935),
(9863, '23845', 218, 53, 8683, 36.543, 0.637795668556288, -77.9845, -1.36108629052152),
(9864, '23846', 218, 53, 64460, 37.0605, 0.646827747435358, -76.8217, -1.34079160197933),
(9865, '23847', 218, 53, 15935, 36.6933, 0.640418898422035, -77.5441, -1.35339986049573),
(9866, '23850', 218, 53, 32456, 37.1506, 0.648400289091405, -77.7449, -1.35690448163374),
(9867, '23851', 218, 53, 2595, 36.6749, 0.640097757839668, -76.9407, -1.3428685437892),
(9868, '23856', 218, 53, 21295, 36.7131, 0.64076447361393, -77.5539, -1.35357090276243),
(9869, '23857', 218, 53, 29874, 36.5421, 0.63777996059302, -77.8735, -1.3591489750518),
(9870, '23860', 218, 53, 3228, 37.2865, 0.650772191544866, -77.2877, -1.34892483629362),
(9871, '23866', 218, 53, 36587, 36.9137, 0.644265604093431, -76.8771, -1.34175851438493),
(9872, '23867', 218, 53, 103158, 36.8148, 0.642539473463208, -77.4727, -1.35215369540981),
(9873, '23868', 218, 53, 3698, 36.7569, 0.641528927826304, -77.8512, -1.35875976662861),
(9874, '23870', 218, 53, 103158, 36.8153, 0.642548200109468, -77.4696, -1.352099590203),
(9875, '23872', 218, 53, 104121, 37.0076, 0.645904468261053, -77.7252, -1.3565606517711),
(9876, '23873', 218, 53, 104195, 36.8066, 0.642396356464545, -77.9573, -1.36061156096498),
(9877, '23874', 218, 53, 104650, 36.612, 0.638999945740164, -77.0957, -1.34557380412979),
(9878, '23875', 218, 53, 105468, 37.2326, 0.649831459078041, -77.266, -1.34854609984594),
(9879, '23876', 218, 53, 50721, 36.9536, 0.644961990464977, -77.8341, -1.35846131532652),
(9880, '23878', 218, 53, 106104, 36.8052, 0.642371921855017, -77.0215, -1.34427876982481),
(9881, '23879', 218, 53, 106310, 36.5917, 0.638645643902009, -77.5418, -1.35335971792294),
(9882, '23881', 218, 53, 31191, 37.2117, 0.649466685264374, -77.0693, -1.34511303720727),
(9883, '23882', 218, 53, 69146, 36.9367, 0.64466702982139, -77.4256, -1.35133164533212),
(9884, '23883', 218, 53, 106741, 37.1281, 0.648007590009707, -76.7526, -1.3395855794662);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(9885, '23884', 218, 53, 106745, 36.9146, 0.644281312056699, -77.279, -1.3487729926487),
(9886, '23885', 218, 53, 38454, 37.1969, 0.649208376535079, -77.5519, -1.35353599617739),
(9887, '23887', 218, 53, 107078, 36.5621, 0.638129026443419, -77.8272, -1.35834088760813),
(9888, '23888', 218, 53, 831, 36.972, 0.645283131047344, -76.9876, -1.34368710320839),
(9889, '23889', 218, 53, 25802, 36.8955, 0.643947954169568, -77.7445, -1.35689750031673),
(9890, '23890', 218, 53, 6664, 37.036, 0.64640014176862, -77.0953, -1.34556682281278),
(9891, '23891', 218, 53, 6664, 37.0339, 0.646363489854328, -77.0952, -1.34556507748353),
(9892, '23893', 218, 53, 6780, 36.6331, 0.639368210212335, -77.9132, -1.35984187076485),
(9893, '23894', 218, 53, 107673, 37.1122, 0.64773008265864, -77.8369, -1.35851018454557),
(9894, '23897', 218, 53, 12986, 36.8328, 0.642853632728567, -77.2781, -1.34875728468543),
(9895, '23898', 218, 53, 107897, 36.8324, 0.642846651411559, -76.8414, -1.34113543184197),
(9896, '23899', 218, 53, 26794, 37.2274, 0.649740701956937, -76.9648, -1.34328916813893),
(9897, '23901', 218, 53, 2420, 37.2961, 0.650939743153057, -78.3962, -1.36827181105198),
(9898, '23909', 218, 53, 2420, 37.2974, 0.650962432433333, -78.3964, -1.36827530171048),
(9899, '23915', 218, 53, 99660, 36.6348, 0.639397880809619, -78.2995, -1.3665840776653),
(9900, '23917', 218, 53, 100110, 36.6588, 0.639816759830097, -78.3793, -1.36797685040839),
(9901, '23919', 218, 53, 100113, 36.5827, 0.63848856426933, -78.1091, -1.3632609707695),
(9902, '23920', 218, 53, 100223, 36.7352, 0.641150191378621, -77.9694, -1.36082274580447),
(9903, '23921', 218, 53, 793, 37.5999, 0.656242053420616, -78.6171, -1.37212724336963),
(9904, '23922', 218, 53, 92927, 37.1875, 0.649044315585391, -78.2036, -1.36491030691264),
(9905, '23923', 218, 53, 100702, 37.0882, 0.647311203638161, -78.6581, -1.37284282836295),
(9906, '23924', 218, 53, 100707, 36.7973, 0.642234040844109, -78.4626, -1.3694307096753),
(9907, '23927', 218, 53, 848, 36.6068, 0.63890918861906, -78.5359, -1.37071003601701),
(9908, '23930', 218, 53, 101187, 37.1776, 0.648871527989444, -78.1232, -1.36350706219403),
(9909, '23934', 218, 53, 35464, 37.1622, 0.648602747284637, -78.6416, -1.37255484903637),
(9910, '23936', 218, 53, 32242, 37.5218, 0.654878951274808, -78.4763, -1.36966981978283),
(9911, '23937', 218, 53, 101497, 36.9549, 0.644984679745253, -78.5422, -1.37081999175989),
(9912, '23938', 218, 53, 27007, 36.9058, 0.644127723082523, -78.0068, -1.36147549894471),
(9913, '23939', 218, 53, 2343, 37.3188, 0.65133593289326, -78.766, -1.37472603862585),
(9914, '23941', 218, 53, 2558, 36.9176, 0.644333671934259, -78.4858, -1.36983562606177),
(9915, '23942', 218, 53, 105, 37.1318, 0.64807216719203, -78.3053, -1.36668530676192),
(9916, '23943', 218, 53, 102580, 37.2407, 0.649972830747452, -78.4579, -1.36934867920046),
(9917, '23944', 218, 53, 103276, 36.9611, 0.645092890158876, -78.1247, -1.36353324213281),
(9918, '23947', 218, 53, 16724, 36.99, 0.645597290312703, -78.222, -1.365231447495),
(9919, '23950', 218, 53, 16751, 36.6969, 0.640481730275107, -78.0922, -1.36296601012592),
(9920, '23952', 218, 53, 10233, 36.9176, 0.644333671934259, -78.2934, -1.36647761258093),
(9921, '23954', 218, 53, 104178, 37.0959, 0.647445593990564, -78.3824, -1.3680309556152),
(9922, '23955', 218, 53, 0, 37.1231, 0.647920323547107, -78.0754, -1.36267279481158),
(9923, '23958', 218, 53, 105047, 37.2614, 0.650334113902615, -78.6421, -1.37256357568263),
(9924, '23959', 218, 53, 11170, 37.1033, 0.647574748355212, -78.8028, -1.37536831979059),
(9925, '23960', 218, 53, 5238, 37.3155, 0.651278337027944, -78.5513, -1.37097881672182),
(9926, '23962', 218, 53, 5293, 36.9713, 0.64527091374258, -78.7096, -1.37374167292773),
(9927, '23963', 218, 53, 111074, 37.1974, 0.649217103181339, -78.813, -1.37554634337429),
(9928, '23964', 218, 53, 5318, 36.7676, 0.641715678056267, -78.6357, -1.37245187461051),
(9929, '23966', 218, 53, 5367, 37.2892, 0.65081931543467, -78.2791, -1.36622803049789),
(9930, '23967', 218, 53, 106058, 36.9035, 0.644087580509727, -78.6189, -1.37215865929617),
(9931, '23968', 218, 53, 106312, 36.7305, 0.641068160903777, -78.5288, -1.37058611764012),
(9932, '23970', 218, 53, 281, 36.7279, 0.641022782343225, -78.1324, -1.36366763248522),
(9933, '23974', 218, 53, 6554, 36.9915, 0.645623470251482, -78.2273, -1.36532394994536),
(9934, '23976', 218, 53, 107834, 36.8385, 0.642953116495931, -78.6132, -1.37205917552881),
(9935, '24001', 218, 53, 5436, 37.2711, 0.650503410840058, -79.9418, -1.3952476199708),
(9936, '24002', 218, 53, 5436, 37.278, 0.650623838558446, -79.9588, -1.39554432594364),
(9937, '24003', 218, 53, 5436, 37.2709, 0.650499920181555, -79.9418, -1.3952476199708),
(9938, '24004', 218, 53, 5436, 37.271, 0.650501665510807, -79.9419, -1.39524936530006),
(9939, '24005', 218, 53, 5436, 37.2715, 0.650510392157067, -79.9418, -1.3952476199708),
(9940, '24006', 218, 53, 5436, 37.2712, 0.650505156169311, -79.9421, -1.39525285595856),
(9941, '24007', 218, 53, 5436, 37.2711, 0.650503410840058, -79.9421, -1.39525285595856),
(9942, '24008', 218, 53, 5436, 37.271, 0.650501665510807, -79.9421, -1.39525285595856),
(9943, '24009', 218, 53, 5436, 37.2712, 0.650505156169311, -79.9418, -1.3952476199708),
(9944, '24010', 218, 53, 5436, 37.2716, 0.650512137486319, -79.9416, -1.3952441293123),
(9945, '24011', 218, 53, 5436, 37.2704, 0.650491193535295, -79.942, -1.39525111062931),
(9946, '24012', 218, 53, 5436, 37.3022, 0.651046208237429, -79.9253, -1.39495964064422),
(9947, '24013', 218, 53, 5436, 37.2681, 0.650451050962499, -79.9271, -1.39499105657076),
(9948, '24014', 218, 53, 5436, 37.2306, 0.649796552493001, -79.9372, -1.39516733482521),
(9949, '24015', 218, 53, 5436, 37.2564, 0.650246847440015, -79.9793, -1.3959021184403),
(9950, '24016', 218, 53, 5436, 37.2726, 0.650529590778838, -79.9512, -1.39541168092049),
(9951, '24017', 218, 53, 5436, 37.2933, 0.650890873934001, -79.9884, -1.39606094340223),
(9952, '24018', 218, 53, 5436, 37.2261, 0.649718012676661, -80.0274, -1.39674162181051),
(9953, '24019', 218, 53, 5436, 37.3342, 0.651604713598067, -79.9647, -1.39564730036951),
(9954, '24020', 218, 53, 5436, 37.2457, 0.650060097210052, -80.0322, -1.39682539761461),
(9955, '24022', 218, 53, 5436, 37.2713, 0.650506901498563, -79.9421, -1.39525285595856),
(9956, '24023', 218, 53, 5436, 37.2694, 0.650473740242775, -79.9541, -1.3954622954688),
(9957, '24024', 218, 53, 5436, 37.2791, 0.650643037180218, -79.9349, -1.39512719225242),
(9958, '24025', 218, 53, 5436, 37.2728, 0.650533081437342, -79.9534, -1.39545007816403),
(9959, '24026', 218, 53, 5436, 37.2732, 0.650540062754351, -79.9531, -1.39544484217628),
(9960, '24027', 218, 53, 5436, 37.2732, 0.650540062754351, -79.9532, -1.39544658750553),
(9961, '24028', 218, 53, 5436, 37.2794, 0.650648273167974, -79.9435, -1.39527729056809),
(9962, '24029', 218, 53, 5436, 37.2729, 0.650534826766594, -79.9536, -1.39545356882254),
(9963, '24030', 218, 53, 5436, 37.2733, 0.650541808083602, -79.9536, -1.39545356882254),
(9964, '24031', 218, 53, 5436, 37.273, 0.650536572095846, -79.9532, -1.39544658750553),
(9965, '24032', 218, 53, 5436, 37.2786, 0.650634310533958, -79.9339, -1.3951097389599),
(9966, '24033', 218, 53, 5436, 37.2735, 0.650545298742106, -79.9535, -1.39545182349329),
(9967, '24034', 218, 53, 5436, 37.279, 0.650641291850966, -79.9353, -1.39513417356942),
(9968, '24035', 218, 53, 5436, 37.2794, 0.650648273167974, -79.9307, -1.39505388842383),
(9969, '24036', 218, 53, 5436, 37.2793, 0.650646527838722, -79.9339, -1.3951097389599),
(9970, '24037', 218, 53, 5436, 37.2788, 0.650637801192462, -79.9347, -1.39512370159391),
(9971, '24038', 218, 53, 5436, 37.2729, 0.650534826766594, -79.9531, -1.39544484217628),
(9972, '24040', 218, 53, 5436, 37.2784, 0.650630819875454, -79.9336, -1.39510450297214),
(9973, '24042', 218, 53, 5436, 37.2734, 0.650543553412855, -79.9406, -1.39522667601978),
(9974, '24043', 218, 53, 5436, 37.267, 0.650431852340727, -79.9223, -1.39490728076666),
(9975, '24044', 218, 53, 5436, 37.2784, 0.650630819875454, -79.9332, -1.39509752165513),
(9976, '24045', 218, 53, 5436, 37.2713, 0.650506901498563, -79.9413, -1.39523889332454),
(9977, '24048', 218, 53, 5436, 37.2242, 0.649684851420873, -80.0512, -1.39715701017248),
(9978, '24050', 218, 53, 5436, 37.3457, 0.651805426462046, -79.9557, -1.39549022073683),
(9979, '24053', 218, 53, 18891, 36.5883, 0.638586302707441, -80.5301, -1.40551539196029),
(9980, '24054', 218, 53, 99568, 36.6295, 0.639305378359263, -80.0119, -1.39647109577645),
(9981, '24055', 218, 53, 7292, 36.753, 0.641460859985476, -79.9857, -1.39601381951243),
(9982, '24058', 218, 53, 99819, 37.1335, 0.648101837789314, -80.6605, -1.40779130130489),
(9983, '24059', 218, 53, 99845, 37.1531, 0.648443922322705, -80.1254, -1.39845204447746),
(9984, '24060', 218, 53, 79821, 37.2317, 0.649815751114773, -80.4158, -1.40352048062526),
(9985, '24061', 218, 53, 79821, 37.2553, 0.650227648818243, -80.4315, -1.40379449731782),
(9986, '24062', 218, 53, 79821, 37.2298, 0.649782589858985, -80.4143, -1.40349430068648),
(9987, '24063', 218, 53, 79821, 37.2282, 0.649754664590953, -80.4176, -1.40355189655179),
(9988, '24064', 218, 53, 992, 37.3777, 0.652363931822684, -79.8228, -1.39317067816093),
(9989, '24065', 218, 53, 100062, 37.1686, 0.648714448356764, -79.9635, -1.39562635641849),
(9990, '24066', 218, 53, 15362, 37.5224, 0.65488942325032, -79.6814, -1.39070278259861),
(9991, '24067', 218, 53, 15401, 37.0401, 0.646471700267952, -80.0661, -1.39741706423103),
(9992, '24068', 218, 53, 29472, 37.1427, 0.648262408080498, -80.3996, -1.40323773728643),
(9993, '24069', 218, 53, 26723, 36.5867, 0.638558377439409, -79.6617, -1.39035895273597),
(9994, '24070', 218, 53, 15461, 37.3576, 0.652013120643034, -80.1766, -1.39934565305449),
(9995, '24072', 218, 53, 0, 37.034, 0.64636523518358, -80.2387, -1.40042950251997),
(9996, '24073', 218, 53, 29472, 37.1362, 0.648148961679118, -80.4034, -1.40330405979801),
(9997, '24076', 218, 53, 100861, 36.5958, 0.638717202401341, -80.4287, -1.40374562809876),
(9998, '24077', 218, 53, 1638, 37.3648, 0.652138784349177, -79.9052, -1.39460882946457),
(9999, '24078', 218, 53, 1706, 36.7241, 0.64095645983165, -79.9167, -1.39480954232855),
(10000, '24079', 218, 53, 101070, 37.0773, 0.647120962749694, -80.1538, -1.39894771798503),
(10001, '24082', 218, 53, 101196, 36.6174, 0.639094193519772, -80.1221, -1.39839444861215),
(10002, '24083', 218, 53, 1951, 37.4154, 0.653021920950686, -79.9152, -1.39478336238977),
(10003, '24084', 218, 53, 2113, 37.1067, 0.64763408954978, -80.6849, -1.40821716164237),
(10004, '24085', 218, 53, 54519, 37.661, 0.657308449593584, -79.8361, -1.39340280695145),
(10005, '24086', 218, 53, 101670, 37.2837, 0.65072332232581, -80.6185, -1.40705826301905),
(10006, '24087', 218, 53, 29718, 37.2158, 0.649538243763706, -80.1789, -1.39938579562728),
(10007, '24088', 218, 53, 101919, 36.9296, 0.644543111444498, -80.018, -1.39657756086082),
(10008, '24089', 218, 53, 101924, 36.704, 0.640605648651999, -79.9414, -1.3952406386538),
(10009, '24090', 218, 53, 29793, 37.4963, 0.65443389231555, -79.8767, -1.39411141062775),
(10010, '24091', 218, 53, 2508, 36.9127, 0.644248150800911, -80.3173, -1.40180133131204),
(10011, '24092', 218, 53, 0, 37.0058, 0.645873052334518, -79.7702, -1.39225263497438),
(10012, '24093', 218, 53, 102273, 37.3756, 0.652327279908393, -80.8692, -1.4114338034538),
(10013, '24094', 218, 53, 102322, 37.3986, 0.652728705636351, -80.6665, -1.40789602106001),
(10014, '24095', 218, 53, 102337, 37.2217, 0.649641218189573, -79.758, -1.39203970480564),
(10015, '24101', 218, 53, 2973, 37.1709, 0.64875459092956, -79.7401, -1.39172729086953),
(10016, '24102', 218, 53, 9426, 36.8384, 0.642951371166679, -80.0049, -1.39634892272881),
(10017, '24104', 218, 53, 9603, 37.0642, 0.646892324617682, -79.5466, -1.38835007876692),
(10018, '24105', 218, 53, 22157, 36.9024, 0.644068381887955, -80.5802, -1.40638980191553),
(10019, '24111', 218, 53, 30470, 37.2562, 0.650243356781511, -80.4311, -1.40378751600081),
(10020, '24112', 218, 53, 27817, 36.6853, 0.640279272081876, -79.8652, -1.39391069776378),
(10021, '24113', 218, 53, 27817, 36.6806, 0.640197241607032, -79.854, -1.39371522088755),
(10022, '24114', 218, 53, 27817, 36.687, 0.64030894267916, -79.863, -1.39387230052023),
(10023, '24115', 218, 53, 27817, 36.6867, 0.640303706691404, -79.8629, -1.39387055519098),
(10024, '24120', 218, 53, 0, 36.724, 0.640954714502397, -80.4034, -1.40330405979801),
(10025, '24121', 218, 53, 104332, 37.1031, 0.647571257696708, -79.6612, -1.39035022608971),
(10026, '24122', 218, 53, 89122, 37.4279, 0.653240087107186, -79.7066, -1.39114260557011),
(10027, '24124', 218, 53, 37356, 37.3316, 0.651559335037515, -80.8074, -1.41035518997607),
(10028, '24126', 218, 53, 4562, 37.0873, 0.647295495674893, -80.6525, -1.40765167496473),
(10029, '24127', 218, 53, 4520, 37.5012, 0.654519413448897, -80.1103, -1.39818849976041),
(10030, '24128', 218, 53, 10799, 37.3161, 0.651288809003456, -80.4819, -1.40467414326082),
(10031, '24129', 218, 53, 17264, 37.1511, 0.648409015737665, -80.6178, -1.40704604571428),
(10032, '24130', 218, 53, 112629, 37.661, 0.657308449593584, -79.8366, -1.39341153359771),
(10033, '24131', 218, 53, 105028, 37.5687, 0.655697510693994, -80.2512, -1.40064766867647),
(10034, '24132', 218, 53, 23776, 37.1514, 0.648414251725421, -80.6176, -1.40704255505578),
(10035, '24133', 218, 53, 105100, 36.6859, 0.640289744057388, -80.146, -1.39881158230338),
(10036, '24134', 218, 53, 105139, 37.3254, 0.651451124623892, -80.7305, -1.40901303178128),
(10037, '24136', 218, 53, 17567, 37.3815, 0.65243025433426, -80.5651, -1.40612625719848),
(10038, '24137', 218, 53, 105165, 37.0356, 0.646393160451612, -79.5923, -1.38914769423508),
(10039, '24138', 218, 53, 37679, 37.059, 0.646801567496579, -80.3184, -1.40182052993381),
(10040, '24139', 218, 53, 50447, 37.0095, 0.645937629516841, -79.4809, -1.38720339744836),
(10041, '24141', 218, 53, 266, 37.1248, 0.647949994144391, -80.5675, -1.40616814510053),
(10042, '24142', 218, 53, 266, 37.1512, 0.648410761066917, -80.618, -1.40704953637279),
(10043, '24143', 218, 53, 266, 37.125, 0.647953484802895, -80.576, -1.40631649808695),
(10044, '24146', 218, 53, 61503, 37.0057, 0.645871307005266, -79.7698, -1.39224565365737),
(10045, '24147', 218, 53, 90286, 37.3804, 0.652411055712488, -80.814, -1.4104703817067),
(10046, '24148', 218, 53, 11587, 36.6143, 0.63904008831296, -79.8662, -1.3939281510563),
(10047, '24149', 218, 53, 105714, 37.0207, 0.646133106393065, -80.4376, -1.40390096240219),
(10048, '24150', 218, 53, 105721, 37.337, 0.651653582817123, -80.6867, -1.40824857756891),
(10049, '24151', 218, 53, 5489, 37.0025, 0.645815456469202, -79.8937, -1.39440811660059),
(10050, '24153', 218, 53, 126, 37.2897, 0.65082804208093, -80.0823, -1.39769980756986),
(10051, '24155', 218, 53, 126, 37.2919, 0.650866439324473, -80.0636, -1.39737343099973),
(10052, '24156', 218, 53, 126, 37.2872, 0.65078440884963, -80.0561, -1.39724253130583),
(10053, '24157', 218, 53, 126, 37.2907, 0.650845495373449, -80.0646, -1.39739088429225),
(10054, '24161', 218, 53, 106033, 36.9902, 0.645600780971207, -79.5477, -1.38836927738869),
(10055, '24162', 218, 53, 51369, 37.1393, 0.64820306688593, -80.3221, -1.40188510711614),
(10056, '24165', 218, 53, 5995, 36.5799, 0.638439695050274, -80.0447, -1.39704356377111),
(10057, '24167', 218, 53, 38354, 37.2457, 0.650060097210052, -80.7666, -1.40964309564125),
(10058, '24168', 218, 53, 106535, 36.7389, 0.641214768560945, -79.9404, -1.39522318536127),
(10059, '24171', 218, 53, 12169, 36.6341, 0.639385663504855, -80.2485, -1.40060054478667),
(10060, '24174', 218, 53, 62000, 37.3327, 0.651578533659287, -79.6891, -1.39083717295101),
(10061, '24175', 218, 53, 52208, 37.3995, 0.652744413599619, -79.8793, -1.39415678918831),
(10062, '24176', 218, 53, 62120, 37.0368, 0.646414104402636, -79.6304, -1.38981266468009),
(10063, '24177', 218, 53, 12549, 36.7235, 0.640945987856138, -80.4036, -1.40330755045651),
(10064, '24178', 218, 53, 107167, 37.4272, 0.653227869802422, -79.7073, -1.39115482287488),
(10065, '24179', 218, 53, 34282, 37.2776, 0.650616857241438, -79.8805, -1.39417773313933),
(10066, '24184', 218, 53, 107725, 37.0625, 0.646862654020398, -79.7011, -1.39104661246125),
(10067, '24185', 218, 53, 107818, 36.8085, 0.642429517720333, -80.2783, -1.40112065290376),
(10068, '24201', 218, 53, 15330, 36.6138, 0.6390313616667, -82.1705, -1.43414577301),
(10069, '24202', 218, 53, 15330, 36.6529, 0.63971378540423, -82.2019, -1.43469380639513),
(10070, '24203', 218, 53, 15330, 36.5963, 0.638725929047601, -82.1882, -1.4344546962876),
(10071, '24209', 218, 53, 15330, 36.6137, 0.639029616337448, -82.1683, -1.43410737576646),
(10072, '24210', 218, 53, 44263, 36.7089, 0.640691169785346, -81.9791, -1.43080521282168),
(10073, '24211', 218, 53, 44263, 36.7093, 0.640698151102354, -81.9772, -1.4307720515659),
(10074, '24212', 218, 53, 44263, 36.7097, 0.640705132419362, -81.9778, -1.43078252354141),
(10075, '24215', 218, 53, 14988, 36.9954, 0.64569153809231, -82.5344, -1.44049702615801),
(10076, '24216', 218, 53, 99433, 36.9055, 0.644122487094767, -82.7832, -1.44483940533697),
(10077, '24217', 218, 53, 34726, 37.0848, 0.647251862443593, -82.1925, -1.43452974544544),
(10078, '24218', 218, 53, 79, 36.7557, 0.64150798387528, -83.038, -1.44928650427105),
(10079, '24219', 218, 53, 99926, 36.8694, 0.643492423234797, -82.7731, -1.44466312708252),
(10080, '24220', 218, 53, 99933, 37.1545, 0.648468356932233, -82.2376, -1.43531688893809),
(10081, '24221', 218, 53, 13392, 36.6328, 0.639362974224579, -83.0079, -1.4487611601662),
(10082, '24224', 218, 53, 39682, 36.8872, 0.643803091841652, -82.2875, -1.43618780823483),
(10083, '24225', 218, 53, 1620, 36.9835, 0.645483843911323, -82.1343, -1.43351396382078),
(10084, '24226', 218, 53, 100907, 37.1279, 0.648004099351203, -82.3367, -1.43704651022682),
(10085, '24228', 218, 53, 100913, 37.15, 0.648389817115893, -82.4578, -1.43916010395098),
(10086, '24230', 218, 53, 100955, 36.9431, 0.644778730893517, -82.4678, -1.43933463687618),
(10087, '24236', 218, 53, 1957, 36.6398, 0.639485147272218, -81.8023, -1.42771947070416),
(10088, '24237', 218, 53, 86219, 37.0404, 0.646476936255708, -82.274, -1.43595218878581),
(10089, '24239', 218, 53, 1977, 37.0575, 0.646775387557799, -82.1215, -1.43329056167652),
(10090, '24243', 218, 53, 8610, 36.7939, 0.642174699649542, -82.9176, -1.44718512785165),
(10091, '24244', 218, 53, 46699, 36.7166, 0.64082556013775, -82.812, -1.44534206016154),
(10092, '24245', 218, 53, 72355, 36.8264, 0.64274193165644, -82.5361, -1.44052669675529),
(10093, '24246', 218, 53, 101612, 36.8477, 0.643113686787115, -82.757, -1.44438212907295),
(10094, '24248', 218, 53, 2347, 36.628, 0.639279198420483, -83.5139, -1.45759252618129),
(10095, '24250', 218, 53, 102049, 36.7562, 0.64151671052154, -82.6233, -1.44204862386303),
(10096, '24251', 218, 53, 2677, 36.6333, 0.639371700870839, -82.5735, -1.44117944989554),
(10097, '24256', 218, 53, 102682, 37.223, 0.649663907469849, -82.286, -1.43616162829605),
(10098, '24258', 218, 53, 102848, 36.6458, 0.639589867027338, -82.4084, -1.4382979113005),
(10099, '24260', 218, 53, 36483, 37.0314, 0.646319856623028, -82.0017, -1.43119965723263),
(10100, '24263', 218, 53, 3455, 36.6866, 0.640301961362152, -83.1099, -1.45054139600324),
(10101, '24265', 218, 53, 103299, 36.8322, 0.642843160753055, -82.9661, -1.44803161253887),
(10102, '24266', 218, 53, 3708, 36.8991, 0.64401078602264, -82.085, -1.43265351649955),
(10103, '24269', 218, 53, 4073, 37.0821, 0.647204738553789, -82.3825, -1.43784587102423),
(10104, '24270', 218, 53, 104190, 36.7292, 0.641045471623501, -82.2499, -1.43553156443608),
(10105, '24271', 218, 53, 23381, 36.753, 0.641460859985476, -82.422, -1.43853527607877),
(10106, '24272', 218, 53, 30672, 37.0266, 0.646236080818932, -82.3461, -1.4372105711765),
(10107, '24273', 218, 53, 4646, 36.9373, 0.644677501796902, -82.6237, -1.44205560518004),
(10108, '24277', 218, 53, 105177, 36.7569, 0.641528927826304, -83.0305, -1.44915560457715),
(10109, '24279', 218, 53, 105426, 36.9398, 0.644721135028201, -82.5954, -1.44156167700172),
(10110, '24280', 218, 53, 5546, 36.965, 0.645160957999704, -81.8977, -1.42938451481056),
(10111, '24281', 218, 53, 5540, 36.6441, 0.639560196430054, -83.3379, -1.45452074669778),
(10112, '24282', 218, 53, 11748, 36.8352, 0.642895520630615, -83.0532, -1.44955179431735),
(10113, '24283', 218, 53, 11759, 36.9387, 0.644701936406429, -82.3574, -1.43740779338198),
(10114, '24285', 218, 53, 106598, 36.9706, 0.645258696437816, -82.8149, -1.44539267470985),
(10115, '24289', 218, 53, 38573, 37.0189, 0.646101690466529, -82.2298, -1.43518075325643),
(10116, '24290', 218, 53, 44052, 36.623, 0.639191931957883, -82.5603, -1.44094906643427),
(10117, '24292', 218, 53, 107568, 36.6152, 0.639055796276228, -81.5773, -1.42379247988717),
(10118, '24293', 218, 53, 70299, 36.9734, 0.645307565656871, -82.5666, -1.44105902217715),
(10119, '24301', 218, 53, 11424, 37.053, 0.646696847741459, -80.7692, -1.4096884742018),
(10120, '24311', 218, 53, 7186, 36.8574, 0.643282983724558, -81.3894, -1.42051300622267),
(10121, '24312', 218, 53, 99555, 36.8211, 0.642649429206084, -80.8678, -1.41140936884427),
(10122, '24313', 218, 53, 99645, 36.9126, 0.644246405471659, -80.8064, -1.41033773668355),
(10123, '24314', 218, 53, 99664, 36.9514, 0.644923593221433, -81.0878, -1.41524909319866),
(10124, '24315', 218, 53, 7530, 37.1394, 0.648204812215182, -81.0145, -1.41396976685695),
(10125, '24316', 218, 53, 100214, 36.9392, 0.644710663052689, -81.6487, -1.42503864497309),
(10126, '24317', 218, 53, 15414, 36.5997, 0.638785270242169, -80.6716, -1.40798503285186),
(10127, '24318', 218, 53, 19923, 37.0098, 0.645942865504597, -81.3648, -1.42008365522668),
(10128, '24319', 218, 53, 100787, 36.8011, 0.642300363355685, -81.6804, -1.42559191434598),
(10129, '24322', 218, 53, 13617, 36.7974, 0.642235786173362, -81.1044, -1.41553881785449),
(10130, '24323', 218, 53, 92, 36.8751, 0.643591907002161, -81.2105, -1.41739061219085),
(10131, '24324', 218, 53, 35628, 36.9671, 0.645197609913996, -80.8213, -1.41059779074209),
(10132, '24325', 218, 53, 101532, 36.8222, 0.642668627827856, -80.6146, -1.40699019517822),
(10133, '24326', 218, 53, 35733, 36.7294, 0.641048962282005, -81.1939, -1.41710088753502),
(10134, '24327', 218, 53, 2293, 36.7666, 0.641698224763747, -81.8548, -1.42863576856145),
(10135, '24328', 218, 53, 101871, 36.6615, 0.639863883719901, -80.6944, -1.40838296792131),
(10136, '24330', 218, 53, 102134, 36.7317, 0.641089104854801, -81.0295, -1.41423156624475),
(10137, '24333', 218, 53, 102159, 36.6635, 0.639898790304941, -80.9212, -1.41234137466484),
(10138, '24340', 218, 53, 102252, 36.7889, 0.642087433186942, -81.7723, -1.42719587192856),
(10139, '24343', 218, 53, 81577, 36.7623, 0.641623175605911, -80.7364, -1.40911600620715),
(10140, '24347', 218, 53, 65656, 36.9755, 0.645344217571163, -80.6437, -1.40749808599055),
(10141, '24348', 218, 53, 3320, 36.6206, 0.639150044055836, -81.1449, -1.41624567620155),
(10142, '24350', 218, 53, 3375, 36.8195, 0.642621503938052, -81.0059, -1.41381966854127),
(10143, '24351', 218, 53, 103495, 36.5786, 0.638417005769998, -80.7807, -1.40988918706578),
(10144, '24352', 218, 53, 88463, 36.711, 0.640727821699638, -80.5185, -1.40531293376705),
(10145, '24354', 218, 53, 630, 36.8367, 0.642921700569395, -81.5185, -1.422766226287),
(10146, '24360', 218, 53, 104073, 36.9509, 0.644914866575173, -81.0767, -1.41505536165169),
(10147, '24361', 218, 53, 23017, 36.7664, 0.641694734105243, -81.8545, -1.4286305325737),
(10148, '24363', 218, 53, 104518, 36.6107, 0.638977256459888, -81.3873, -1.42047635430838),
(10149, '24366', 218, 53, 105844, 37.2295, 0.649777353871229, -81.1929, -1.4170834342425),
(10150, '24368', 218, 53, 105952, 36.8959, 0.643954935486576, -81.2736, -1.41849191494886),
(10151, '24370', 218, 53, 106013, 36.8756, 0.643600633648421, -81.7608, -1.42699515906458),
(10152, '24373', 218, 53, 106119, 36.8165, 0.642569144060492, -81.6485, -1.42503515431459),
(10153, '24374', 218, 53, 38318, 36.7869, 0.642052526601902, -81.1942, -1.41710612352278),
(10154, '24375', 218, 53, 12174, 36.7718, 0.641788981884851, -81.3925, -1.42056711142948),
(10155, '24377', 218, 53, 31288, 36.976, 0.645352944217423, -81.6416, -1.4249147265962),
(10156, '24378', 218, 53, 129106, 36.6914, 0.640385737166247, -81.4375, -1.42135250959288),
(10157, '24379', 218, 53, 107207, 36.6502, 0.639666661514426, -81.4674, -1.42187436303923),
(10158, '24380', 218, 53, 12872, 36.865, 0.64341562874771, -80.4922, -1.40485391217378),
(10159, '24381', 218, 53, 6936, 36.7162, 0.640818578820742, -80.8061, -1.41033250069579),
(10160, '24382', 218, 53, 107844, 36.9469, 0.644845053405093, -81.0879, -1.41525083852791),
(10161, '24401', 218, 53, 25106, 38.1533, 0.665900705501153, -79.0788, -1.38018542852609),
(10162, '24402', 218, 53, 25106, 38.1624, 0.666059530463084, -79.0673, -1.37998471566211),
(10163, '24407', 218, 53, 25106, 38.1589, 0.665998443939264, -79.0623, -1.37989744919951),
(10164, '24411', 218, 53, 99552, 38.1019, 0.665003606265627, -79.3179, -1.38435851076761),
(10165, '24412', 218, 53, 99584, 38.0542, 0.664171084212426, -79.8437, -1.3935354519746),
(10166, '24413', 218, 53, 34869, 38.5305, 0.672484087439675, -79.6021, -1.38931873650178),
(10167, '24415', 218, 53, 29321, 37.9282, 0.661971969354913, -79.3191, -1.38437945471863),
(10168, '24416', 218, 53, 1223, 37.7323, 0.658552869350256, -79.3539, -1.38498682929833),
(10169, '24421', 218, 53, 45792, 38.2192, 0.667050877478217, -79.2039, -1.38236883542034),
(10170, '24422', 218, 53, 100898, 37.8201, 0.660085268433507, -79.8247, -1.39320383941672),
(10171, '24426', 218, 53, 15652, 37.7835, 0.659446477927277, -79.9893, -1.3960766513655),
(10172, '24430', 218, 53, 101162, 38.1083, 0.665115307337755, -79.3345, -1.38464823542344),
(10173, '24431', 218, 53, 101193, 38.1638, 0.666083965072612, -78.8352, -1.37593380646823),
(10174, '24432', 218, 53, 8455, 38.1666, 0.666132834291668, -79.4096, -1.38595897769169),
(10175, '24433', 218, 53, 101448, 38.3951, 0.670120911632475, -79.4865, -1.38730113588647),
(10176, '24435', 218, 53, 2367, 37.8785, 0.661104540716672, -79.3032, -1.38410194736757),
(10177, '24437', 218, 53, 64837, 38.2168, 0.667008989576169, -78.9443, -1.37783796068216),
(10178, '24438', 218, 53, 102276, 37.7533, 0.658919388493175, -79.8192, -1.39310784630786),
(10179, '24439', 218, 53, 419, 37.9709, 0.662717224945515, -79.4852, -1.3872784466062),
(10180, '24440', 218, 53, 2868, 37.9802, 0.66287954056595, -79.131, -1.38109649039563),
(10181, '24441', 218, 53, 102505, 38.2686, 0.667913070128702, -78.8263, -1.37577847216481),
(10182, '24442', 218, 53, 0, 38.3014, 0.668485538123356, -79.4255, -1.38623648504276),
(10183, '24445', 218, 53, 9587, 37.9739, 0.662769584823075, -79.9, -1.39451807234347),
(10184, '24448', 218, 53, 22174, 37.7973, 0.659687333364053, -79.7922, -1.39263660740982),
(10185, '24450', 218, 53, 3748, 37.78, 0.659385391403458, -79.4454, -1.3865838055639),
(10186, '24457', 218, 53, 103847, 37.7881, 0.659526763072869, -79.8839, -1.3942370743339),
(10187, '24458', 218, 53, 4087, 38.3041, 0.66853266201316, -79.5226, -1.38793119974644),
(10188, '24459', 218, 53, 10459, 38.0271, 0.663698099985136, -79.284, -1.38376684415118),
(10189, '24460', 218, 53, 66848, 38.0279, 0.663712062619152, -79.6491, -1.39013904125022),
(10190, '24463', 218, 53, 4245, 38.0653, 0.664364815759398, -79.1098, -1.38072648059421),
(10191, '24464', 218, 53, 104350, 37.8435, 0.660493675478474, -79.0688, -1.38001089560089),
(10192, '24465', 218, 53, 4284, 38.3793, 0.66984514961066, -79.6407, -1.38999243359305),
(10193, '24467', 218, 53, 104468, 38.2599, 0.667761226483779, -78.9619, -1.37814513863051),
(10194, '24468', 218, 53, 104538, 38.2889, 0.668267371966857, -79.6621, -1.39036593405297),
(10195, '24469', 218, 53, 254, 38.1981, 0.666682613006046, -78.9064, -1.37717648089565),
(10196, '24471', 218, 53, 50539, 38.321, 0.668827622656747, -78.8139, -1.37556205133756),
(10197, '24472', 218, 53, 105577, 37.9395, 0.662169191560389, -79.137, -1.38120121015075),
(10198, '24473', 218, 53, 0, 37.8991, 0.661464078542583, -79.3946, -1.38569717830389),
(10199, '24474', 218, 53, 5731, 37.8035, 0.659795543777676, -79.8517, -1.39367507831476),
(10200, '24476', 218, 53, 106556, 37.9255, 0.661924845465109, -79.2023, -1.3823409101523),
(10201, '24477', 218, 53, 106664, 38.0206, 0.663584653583756, -79.0304, -1.37934068916813),
(10202, '24479', 218, 53, 106774, 38.1403, 0.665673812698393, -79.2022, -1.38233916482305),
(10203, '24482', 218, 53, 12546, 38.2007, 0.666727991566598, -79.0039, -1.37887817691635),
(10204, '24483', 218, 53, 107139, 37.8085, 0.659882810240276, -79.2216, -1.38267775869794),
(10205, '24484', 218, 53, 6631, 38.1451, 0.665757588502489, -79.826, -1.39322652869699),
(10206, '24485', 218, 53, 107392, 38.2986, 0.6684366689043, -79.3152, -1.38431138687781),
(10207, '24486', 218, 53, 107512, 38.2644, 0.667839766300118, -78.8995, -1.37705605317727),
(10208, '24487', 218, 53, 14865, 38.177, 0.666314348533875, -79.6738, -1.39057013757546),
(10209, '24501', 218, 53, 16971, 37.4, 0.652753140245879, -79.1727, -1.38182429269371),
(10210, '24502', 218, 53, 16971, 37.3612, 0.652075952496105, -79.2184, -1.38262190816188),
(10211, '24503', 218, 53, 16971, 37.4371, 0.653400657398369, -79.2029, -1.38235138212782),
(10212, '24504', 218, 53, 16971, 37.4069, 0.652873567964267, -79.1284, -1.38105111183508),
(10213, '24505', 218, 53, 16971, 37.414, 0.652997486341159, -79.144, -1.38132338319839),
(10214, '24506', 218, 53, 16971, 37.3566, 0.651995667350514, -79.17, -1.38177716880391),
(10215, '24512', 218, 53, 16971, 37.242, 0.649995520027728, -79.1121, -1.38076662316701),
(10216, '24513', 218, 53, 16971, 37.4012, 0.652774084196903, -79.1915, -1.38215241459309),
(10217, '24514', 218, 53, 16971, 37.3646, 0.652135293690673, -79.2173, -1.3826027095401),
(10218, '24515', 218, 53, 16971, 37.3473, 0.651833351730078, -79.1581, -1.38156947462292),
(10219, '24517', 218, 53, 99384, 37.1194, 0.647855746364783, -79.2927, -1.38391868779611),
(10220, '24520', 218, 53, 14977, 36.7132, 0.640766218943182, -78.8503, -1.37619735118529),
(10221, '24521', 218, 53, 62514, 37.5721, 0.655756851888561, -79.0576, -1.37981541872467),
(10222, '24522', 218, 53, 99445, 37.3475, 0.651836842388582, -78.8264, -1.37578021749406),
(10223, '24523', 218, 53, 146, 37.3379, 0.651669290780391, -79.523, -1.38793818106345),
(10224, '24526', 218, 53, 39384, 37.5371, 0.655145986650364, -79.3993, -1.38577920877873),
(10225, '24527', 218, 53, 905, 36.7069, 0.640656263200307, -79.3783, -1.38541268963581),
(10226, '24528', 218, 53, 100240, 37.0529, 0.646695102412207, -78.9452, -1.37785366864543),
(10227, '24529', 218, 53, 100330, 36.5996, 0.638783524912917, -78.62, -1.37217785791794),
(10228, '24530', 218, 53, 100426, 36.7789, 0.641912900261743, -79.6353, -1.38989818581344),
(10229, '24531', 218, 53, 13522, 36.8265, 0.642743676985692, -79.3984, -1.38576350081547),
(10230, '24533', 218, 53, 695, 37.6338, 0.656833720037042, -79.0644, -1.3799341011138),
(10231, '24534', 218, 53, 20113, 36.8763, 0.643612850953185, -78.787, -1.37509255776877),
(10232, '24535', 218, 53, 15565, 36.5865, 0.638554886780905, -79.0326, -1.37937908641167),
(10233, '24536', 218, 53, 100969, 37.4767, 0.654091807782159, -79.3222, -1.38443355992545),
(10234, '24538', 218, 53, 698, 37.3448, 0.651789718498778, -78.993, -1.37868793602788),
(10235, '24539', 218, 53, 8349, 36.872, 0.643537801795349, -78.9712, -1.37830745425095),
(10236, '24540', 218, 53, 1964, 36.6176, 0.639097684178276, -79.3919, -1.38565005441409),
(10237, '24541', 218, 53, 1964, 36.5752, 0.63835766457543, -79.4354, -1.3864092726387),
(10238, '24543', 218, 53, 1964, 36.5845, 0.638519980195865, -79.5155, -1.38780728136955),
(10239, '24544', 218, 53, 1964, 36.5829, 0.638492054927834, -79.4088, -1.38594501505767),
(10240, '24549', 218, 53, 35638, 36.7422, 0.64127236442626, -79.4616, -1.38686654890273),
(10241, '24550', 218, 53, 101784, 37.2594, 0.650299207317575, -79.2345, -1.38290290617145),
(10242, '24551', 218, 53, 2517, 37.3571, 0.652004393996774, -79.2814, -1.38372146559063),
(10243, '24553', 218, 53, 2726, 37.5436, 0.655259433051743, -78.8415, -1.37604376221111),
(10244, '24554', 218, 53, 21403, 37.115, 0.647778951877695, -79.2818, -1.38372844690764),
(10245, '24555', 218, 53, 2722, 37.6345, 0.656845937341806, -79.4538, -1.38673041322107),
(10246, '24556', 218, 53, 60069, 37.3657, 0.652154492312445, -79.3922, -1.38565529040184),
(10247, '24557', 218, 53, 16287, 36.9525, 0.644942791843205, -79.3626, -1.38513867294325),
(10248, '24558', 218, 53, 21675, 36.7638, 0.641649355544691, -78.9306, -1.37759885057464),
(10249, '24562', 218, 53, 48319, 37.7658, 0.659137554649675, -78.591, -1.37167171243486),
(10250, '24563', 218, 53, 103037, 37.0933, 0.647400215430013, -79.2976, -1.38400420892946),
(10251, '24565', 218, 53, 3406, 36.8624, 0.643370250187158, -79.1855, -1.38204769483797),
(10252, '24566', 218, 53, 88234, 36.7234, 0.640944242526886, -79.2596, -1.3833409838137),
(10253, '24569', 218, 53, 3855, 37.0651, 0.64690803258095, -79.1158, -1.38083120034933),
(10254, '24570', 218, 53, 10217, 37.3437, 0.651770519877006, -79.4532, -1.38671994124556),
(10255, '24571', 218, 53, 103884, 37.1466, 0.648330475921326, -79.365, -1.3851805608453),
(10256, '24572', 218, 53, 103916, 37.4496, 0.653618823554868, -79.1153, -1.38082247370307),
(10257, '24574', 218, 53, 10560, 37.5182, 0.654816119421737, -79.1862, -1.38205991214273),
(10258, '24576', 218, 53, 96438, 37.0931, 0.647396724771509, -78.9001, -1.37706652515278),
(10259, '24577', 218, 53, 104575, 36.9424, 0.644766513588753, -78.9678, -1.37824811305638),
(10260, '24578', 218, 53, 4485, 37.6677, 0.657425386653468, -79.5492, -1.38839545732747),
(10261, '24579', 218, 53, 104579, 37.5886, 0.656044831215141, -79.5052, -1.3876275124566),
(10262, '24580', 218, 53, 4506, 36.5565, 0.638031288005307, -78.672, -1.37308542912898),
(10263, '24581', 218, 53, 4648, 37.6226, 0.656638243160819, -78.7574, -1.37457594031018),
(10264, '24585', 218, 53, 105657, 36.9421, 0.644761277600997, -78.9675, -1.37824287706862),
(10265, '24586', 218, 53, 5403, 36.5928, 0.638664842523781, -79.309, -1.38420317646418),
(10266, '24588', 218, 53, 105965, 37.2952, 0.650924035189789, -79.1483, -1.38139843235623),
(10267, '24589', 218, 53, 31093, 36.7696, 0.641750584641307, -78.7596, -1.37461433755373),
(10268, '24590', 218, 53, 5699, 37.8121, 0.659945642093348, -78.5114, -1.37028243035028),
(10269, '24592', 218, 53, 31156, 36.71, 0.640710368407118, -78.9048, -1.37714855562762),
(10270, '24593', 218, 53, 106470, 37.3693, 0.652217324165517, -78.9101, -1.37724105807798),
(10271, '24594', 218, 53, 106753, 36.6289, 0.639294906383751, -79.1889, -1.38210703603254),
(10272, '24595', 218, 53, 91186, 37.5614, 0.655570101658598, -79.0802, -1.38020986313562),
(10273, '24597', 218, 53, 107133, 36.7923, 0.64214677438151, -79.124, -1.38097431734799),
(10274, '24598', 218, 53, 107179, 36.607, 0.638912679277564, -78.7663, -1.37473127461361),
(10275, '24599', 218, 53, 107712, 37.6227, 0.656639988490071, -78.7577, -1.37458117629794),
(10276, '24601', 218, 53, 99406, 37.191, 0.649105402109211, -81.6387, -1.42486411204789),
(10277, '24602', 218, 53, 19039, 37.1761, 0.648845348050664, -81.6665, -1.42534931357995),
(10278, '24603', 218, 53, 7474, 37.318, 0.651321970259244, -82.2282, -1.4351528279884),
(10279, '24604', 218, 53, 812, 37.2088, 0.649416070716066, -81.5583, -1.42346086732929),
(10280, '24605', 218, 53, 15266, 37.2447, 0.650042643917532, -81.2804, -1.418610597338),
(10281, '24606', 218, 53, 100041, 37.2821, 0.650695397057778, -81.3806, -1.4203594172485),
(10282, '24607', 218, 53, 100149, 37.2995, 0.650999084347625, -82.3094, -1.43657003534102),
(10283, '24608', 218, 53, 100364, 37.1144, 0.647768479902184, -81.5267, -1.42290934328566),
(10284, '24609', 218, 53, 1408, 37.0727, 0.647040677604102, -81.782, -1.427365168866),
(10285, '24612', 218, 53, 93, 37.0913, 0.647365308844973, -81.7917, -1.42753446580345),
(10286, '24613', 218, 53, 101868, 37.2663, 0.650419635035963, -81.3306, -1.4194867526225),
(10287, '24614', 218, 53, 36219, 37.2772, 0.65060987592443, -82.0937, -1.43280536014447),
(10288, '24618', 218, 53, 102621, 37.2773, 0.650611621253682, -82.0988, -1.43289437193632),
(10289, '24619', 218, 53, 102959, 37.2282, 0.649754664590953, -81.52, -1.42279240622578),
(10290, '24620', 218, 53, 3300, 37.4148, 0.653011448975174, -82.0161, -1.43145098464492),
(10291, '24622', 218, 53, 103192, 37.2272, 0.649737211298433, -81.812, -1.4278887676416),
(10292, '24624', 218, 53, 103253, 37.2025, 0.64930611497319, -81.9863, -1.43093087652783),
(10293, '24627', 218, 53, 104072, 37.1831, 0.648967521098304, -82.2153, -1.43492768051489),
(10294, '24628', 218, 53, 42012, 37.3015, 0.651033990932665, -82.1751, -1.43422605815559),
(10295, '24630', 218, 53, 104737, 37.1346, 0.648121036411086, -81.5132, -1.42267372383664),
(10296, '24631', 218, 53, 4723, 37.2186, 0.649587112982762, -81.9846, -1.43090120593054),
(10297, '24634', 218, 53, 0, 37.299, 0.650990357701365, -81.9067, -1.42954159444324),
(10298, '24635', 218, 53, 5158, 37.3061, 0.651114276078257, -81.3378, -1.41961241632864),
(10299, '24637', 218, 53, 105428, 37.0951, 0.647431631356549, -81.8082, -1.42782244513003),
(10300, '24639', 218, 53, 28373, 37.2709, 0.650499920181555, -82.1033, -1.43297291175266),
(10301, '24640', 218, 53, 37876, 37.1064, 0.647628853562024, -81.8661, -1.42883299076693),
(10302, '24641', 218, 53, 68201, 37.0921, 0.647379271478989, -81.8048, -1.42776310393546),
(10303, '24646', 218, 53, 105922, 37.1237, 0.647930795522619, -82.0358, -1.43179481450756),
(10304, '24647', 218, 53, 106247, 37.1572, 0.648515480822037, -81.8729, -1.42895167315607),
(10305, '24649', 218, 53, 106775, 37.0821, 0.647204738553789, -81.9192, -1.42975976059974),
(10306, '24651', 218, 53, 25361, 37.1187, 0.647843529060019, -81.5137, -1.4226824504829),
(10307, '24656', 218, 53, 107105, 37.1622, 0.648602747284637, -82.1268, -1.43338306412688),
(10308, '24657', 218, 53, 38866, 37.2642, 0.650382983121671, -81.8863, -1.42918554727583),
(10309, '24658', 218, 53, 107738, 37.3538, 0.651946798131458, -81.9895, -1.43098672706389),
(10310, '24701', 218, 58, 15266, 37.2621, 0.650346331207379, -81.2216, -1.41758434373783),
(10311, '24712', 218, 58, 7182, 37.4559, 0.653728779297744, -80.9948, -1.4136259369943),
(10312, '24714', 218, 58, 108149, 37.4955, 0.654419929681534, -81.1854, -1.4169525345486),
(10313, '24715', 218, 58, 108340, 37.3379, 0.651669290780391, -81.3345, -1.41955482046333),
(10314, '24716', 218, 58, 19624, 37.5373, 0.655149477308868, -81.3798, -1.42034545461448),
(10315, '24719', 218, 58, 108713, 37.4909, 0.654339644535942, -81.3227, -1.41934887161159),
(10316, '24724', 218, 58, 21295, 37.33, 0.651531409769483, -81.308, -1.41909230821155),
(10317, '24726', 218, 58, 9440, 37.5191, 0.654831827385005, -81.3461, -1.41975727865656),
(10318, '24729', 218, 58, 32748, 37.4395, 0.653442545300417, -81.2437, -1.41797006150252),
(10319, '24731', 218, 58, 27606, 37.4126, 0.65297305173163, -81.1414, -1.41618458967773),
(10320, '24732', 218, 58, 109928, 37.345, 0.651793209157282, -80.9281, -1.41246180238322),
(10321, '24733', 218, 58, 110033, 37.4478, 0.653587407628333, -81.2148, -1.41746566134869),
(10322, '24736', 218, 58, 17050, 37.4191, 0.65308649813301, -81.245, -1.41799275078279),
(10323, '24737', 218, 58, 110502, 37.3538, 0.651946798131458, -81.2516, -1.41810794251342),
(10324, '24738', 218, 58, 110614, 37.258, 0.650274772708047, -81.2223, -1.41759656104259),
(10325, '24739', 218, 58, 56634, 37.3334, 0.651590750964051, -80.9663, -1.41312851815748),
(10326, '24740', 218, 58, 5231, 37.3689, 0.652210342848509, -81.0944, -1.41536428492929),
(10327, '24747', 218, 58, 11629, 37.3892, 0.652564644686664, -81.2356, -1.41782868983311),
(10328, '24751', 218, 58, 52934, 37.3068, 0.651126493383021, -81.3285, -1.41945010070821),
(10329, '24801', 218, 58, 6684, 37.4311, 0.653295937643249, -81.5803, -1.42384483976473),
(10330, '24808', 218, 58, 107982, 37.3334, 0.651590750964051, -81.441, -1.4214135961167),
(10331, '24811', 218, 58, 15065, 37.4161, 0.65303413825545, -81.7852, -1.42742101940207),
(10332, '24813', 218, 58, 108100, 37.3408, 0.651719905328699, -81.7378, -1.42659373333662),
(10333, '24815', 218, 58, 108194, 37.2688, 0.650463268267263, -81.6669, -1.42535629489696),
(10334, '24816', 218, 58, 85069, 37.4639, 0.653868405637904, -81.6988, -1.42591305492834),
(10335, '24817', 218, 58, 34955, 37.3526, 0.651925854180434, -81.8009, -1.42769503609463),
(10336, '24818', 218, 58, 108352, 37.5829, 0.655945347447777, -81.6668, -1.42535454956771),
(10337, '24820', 218, 58, 108482, 37.4415, 0.653477451885457, -81.5959, -1.42411711112804),
(10338, '24821', 218, 58, 108495, 37.3356, 0.651629148207595, -81.6728, -1.42545926932282),
(10339, '24822', 218, 58, 100873, 37.6483, 0.657086792778581, -81.6924, -1.42580135385622),
(10340, '24823', 218, 58, 20126, 37.6699, 0.657463783897012, -81.7284, -1.42642967238693),
(10341, '24824', 218, 58, 108650, 37.3874, 0.652533228760128, -81.6533, -1.42511893011869),
(10342, '24825', 218, 58, 64064, 37.4246, 0.65318249124187, -81.3419, -1.41968397482798),
(10343, '24826', 218, 58, 108764, 37.285, 0.650746011606086, -81.6185, -1.42451155553899),
(10344, '24827', 218, 58, 35483, 37.7411, 0.658706458324432, -81.6652, -1.42532662429967),
(10345, '24828', 218, 58, 29610, 37.4716, 0.654002795990307, -81.66, -1.42523586717857),
(10346, '24829', 218, 58, 109024, 37.4411, 0.653470470568449, -81.5955, -1.42411012981103),
(10347, '24830', 218, 58, 94000, 37.3353, 0.651623912219839, -81.5396, -1.42313449075917),
(10348, '24831', 218, 58, 159, 37.3533, 0.651938071485198, -81.4541, -1.42164223424871),
(10349, '24832', 218, 58, 8766, 37.3373, 0.651658818804879, -81.7157, -1.42620801557193),
(10350, '24834', 218, 58, 109170, 37.5664, 0.655657368121198, -81.6193, -1.42452551817301),
(10351, '24836', 218, 58, 16182, 37.3631, 0.652109113751893, -81.5523, -1.42335614757417),
(10352, '24839', 218, 58, 2963, 37.5546, 0.655451419269462, -81.823, -1.42808075385932),
(10353, '24841', 218, 58, 109591, 37.4011, 0.652772338867651, -81.5786, -1.42381516916745),
(10354, '24842', 218, 58, 36364, 37.4449, 0.653536793080025, -81.5953, -1.42410663915253),
(10355, '24843', 218, 58, 9428, 37.4792, 0.654135441013459, -81.6768, -1.4255290824929),
(10356, '24844', 218, 58, 109769, 37.447, 0.653573444994317, -81.8069, -1.42779975584975),
(10357, '24845', 218, 58, 109771, 37.5392, 0.655182638564655, -81.7954, -1.42759904298577),
(10358, '24846', 218, 58, 166, 37.5297, 0.655016832285716, -81.8883, -1.42922045386087),
(10359, '24847', 218, 58, 109802, 37.5733, 0.655777795839586, -81.4183, -1.4210174063765),
(10360, '24848', 218, 58, 109838, 37.2935, 0.650894364592505, -81.4258, -1.4211483060704),
(10361, '24849', 218, 58, 76225, 37.6665, 0.657404442702444, -81.5562, -1.423424215415),
(10362, '24850', 218, 58, 109875, 37.3315, 0.651557589708263, -81.8344, -1.42827972139405),
(10363, '24851', 218, 58, 36665, 37.5887, 0.656046576544393, -81.8351, -1.42829193869881),
(10364, '24852', 218, 58, 3513, 37.4144, 0.653004467658166, -81.4323, -1.42126175247178),
(10365, '24853', 218, 58, 9856, 37.4257, 0.653201689863642, -81.5074, -1.42257249474003),
(10366, '24854', 218, 58, 109998, 37.7483, 0.658832122030576, -81.5701, -1.42366681618103),
(10367, '24855', 218, 58, 22439, 37.4085, 0.652901493232299, -81.4255, -1.42114307008264),
(10368, '24856', 218, 58, 169, 37.3449, 0.65179146382803, -81.4184, -1.42101915170575),
(10369, '24857', 218, 58, 110229, 37.6977, 0.657948985429066, -81.6769, -1.42553082782216),
(10370, '24859', 218, 58, 10308, 37.6154, 0.656512579454675, -81.5781, -1.42380644252119),
(10371, '24860', 218, 58, 110323, 37.6801, 0.657641807480715, -81.591, -1.42403158999469),
(10372, '24861', 218, 58, 110331, 37.3802, 0.652407565053984, -81.3594, -1.41998940744707),
(10373, '24862', 218, 58, 10551, 37.4968, 0.65444261896181, -81.9025, -1.42946829061466),
(10374, '24866', 218, 58, 56522, 37.265, 0.650396945755687, -81.6188, -1.42451679152675),
(10375, '24867', 218, 58, 177, 37.5443, 0.655271650356507, -81.4733, -1.4219773374651),
(10376, '24868', 218, 58, 110698, 37.3801, 0.652405819724732, -81.4093, -1.42086032674382),
(10377, '24869', 218, 58, 110688, 37.5243, 0.654922584506108, -81.7994, -1.42766885615585),
(10378, '24870', 218, 58, 104883, 37.7366, 0.658627918508092, -81.5532, -1.42337185553744),
(10379, '24871', 218, 58, 110806, 37.3494, 0.65187000364437, -81.4659, -1.42184818310045),
(10380, '24872', 218, 58, 37581, 37.4835, 0.654210490171295, -81.8963, -1.42936008020103),
(10381, '24873', 218, 58, 30790, 37.3604, 0.65206198986209, -81.6664, -1.4253475682507),
(10382, '24874', 218, 58, 5077, 37.5556, 0.655468872561982, -81.5274, -1.42292156059043),
(10383, '24877', 218, 58, 5207, 37.4007, 0.652765357550643, -81.4201, -1.42104882230304),
(10384, '24878', 218, 58, 183, 37.4332, 0.653332589557541, -81.6345, -1.42479080821931),
(10385, '24879', 218, 58, 111063, 37.3426, 0.651751321255234, -81.7826, -1.42737564084151),
(10386, '24880', 218, 58, 111164, 37.5546, 0.655451419269462, -81.5265, -1.42290585262716),
(10387, '24881', 218, 58, 111181, 37.4503, 0.653631040859632, -81.7055, -1.42602999198823),
(10388, '24882', 218, 58, 111399, 37.6149, 0.656503852808415, -81.7697, -1.42715049336801),
(10389, '24883', 218, 58, 111421, 37.3239, 0.651424944685112, -81.4767, -1.42203667865966),
(10390, '24884', 218, 58, 111519, 37.262, 0.650344585878127, -81.5705, -1.42367379749803),
(10391, '24887', 218, 58, 111641, 37.3698, 0.652226050811777, -81.3, -1.41895268187139),
(10392, '24888', 218, 58, 57889, 37.4409, 0.653466979909945, -81.5961, -1.42412060178655),
(10393, '24889', 218, 58, 111762, 37.4746, 0.654055155867867, -81.6681, -1.42537723884798),
(10394, '24892', 218, 58, 111915, 37.3027, 0.651054934883689, -81.6798, -1.42558144237046),
(10395, '24894', 218, 58, 111925, 37.2932, 0.650889128604749, -81.6975, -1.42589036564807),
(10396, '24895', 218, 58, 112051, 37.4405, 0.653459998592937, -81.5961, -1.42412060178655),
(10397, '24896', 218, 58, 0, 37.5366, 0.655137260004104, -81.5772, -1.42379073455792),
(10398, '24897', 218, 58, 205, 37.4144, 0.653004467658166, -81.3902, -1.42052696885669),
(10399, '24898', 218, 58, 14923, 37.5778, 0.655856335655925, -81.585, -1.42392687023957),
(10400, '24899', 218, 58, 13015, 37.3192, 0.651342914210268, -81.6963, -1.42586942169704),
(10401, '24901', 218, 58, 3750, 37.8025, 0.659778090485156, -80.4407, -1.403955067609),
(10402, '24902', 218, 58, 109143, 37.7789, 0.659366192781686, -80.4544, -1.40419417771653),
(10403, '24910', 218, 58, 74956, 37.7274, 0.658467348216909, -80.6401, -1.40743525413748),
(10404, '24915', 218, 58, 108003, 38.4548, 0.671162873195915, -79.7556, -1.39199781690359),
(10405, '24916', 218, 58, 44465, 37.8345, 0.660336595845795, -80.5731, -1.40626588353864),
(10406, '24917', 218, 58, 0, 38.0015, 0.663251295696625, -80.092, -1.3978691045073),
(10407, '24918', 218, 58, 7245, 37.5114, 0.654697437032601, -80.7578, -1.40948950666708),
(10408, '24919', 218, 58, 108078, 37.6748, 0.65754930503036, -80.8904, -1.41180381325522),
(10409, '24920', 218, 58, 15101, 38.5807, 0.673360242724176, -79.7149, -1.39128746789803),
(10410, '24924', 218, 58, 7746, 38.1917, 0.666570911933918, -80.1435, -1.39876794907208),
(10411, '24925', 218, 58, 1290, 37.756, 0.658966512382979, -80.3473, -1.40232493008764),
(10412, '24927', 218, 58, 7947, 38.453, 0.67113145726938, -79.8963, -1.39445349516115),
(10413, '24931', 218, 58, 20333, 37.8802, 0.661134211313956, -80.588, -1.40652593759719),
(10414, '24934', 218, 58, 108976, 38.3582, 0.669476885138489, -79.8293, -1.39328412456231),
(10415, '24935', 218, 58, 2524, 37.5521, 0.655407786038163, -80.8319, -1.4107827956428),
(10416, '24936', 218, 58, 35966, 37.7418, 0.658718675629196, -80.5734, -1.4062711195264),
(10417, '24938', 218, 58, 13800, 37.9087, 0.661631630150774, -80.3576, -1.4025046990006),
(10418, '24941', 218, 58, 109309, 37.52, 0.654847535348272, -80.3747, -1.40280315030269),
(10419, '24942', 218, 58, 109368, 37.6241, 0.656664423099598, -80.3705, -1.4027298464741),
(10420, '24943', 218, 58, 109450, 37.8448, 0.66051636475875, -80.7421, -1.40921548997451),
(10421, '24944', 218, 58, 70889, 38.3936, 0.670094731693695, -79.7855, -1.39251967034994),
(10422, '24945', 218, 58, 2868, 37.5316, 0.655049993541504, -80.6683, -1.40792743698654),
(10423, '24946', 218, 58, 3145, 38.1923, 0.66658138390943, -80.2799, -1.4011485781718),
(10424, '24950', 218, 58, 109956, 37.9421, 0.662214570120941, -80.59, -1.40656084418223),
(10425, '24951', 218, 58, 110124, 37.6761, 0.657571994310636, -80.8861, -1.41172876409739),
(10426, '24954', 218, 58, 110297, 38.2216, 0.667092765380265, -80.0898, -1.39783070726375),
(10427, '24957', 218, 58, 22927, 37.906, 0.661584506260971, -80.4267, -1.40371072151372),
(10428, '24958', 218, 58, 110374, 37.9006, 0.661490258481363, -80.7279, -1.40896765322073),
(10429, '24961', 218, 58, 33393, 38.0011, 0.663244314379617, -80.092, -1.3978691045073),
(10430, '24962', 218, 58, 110852, 37.6719, 0.657498690482052, -80.7091, -1.40863953132136),
(10431, '24963', 218, 58, 110870, 37.3984, 0.652725214977847, -80.7974, -1.41018065705087),
(10432, '24966', 218, 58, 37897, 38.067, 0.664394486356681, -80.378, -1.402860746168),
(10433, '24970', 218, 58, 111197, 37.7521, 0.658898444542151, -80.4661, -1.40439838123901),
(10434, '24974', 218, 58, 111326, 37.6617, 0.657320666898348, -80.4079, -1.40338259961435),
(10435, '24976', 218, 58, 111406, 37.6685, 0.657439349287484, -80.524, -1.40540892687591),
(10436, '24977', 218, 58, 98144, 37.8697, 0.660950951742497, -80.6648, -1.40786635046272),
(10437, '24981', 218, 58, 111652, 37.6479, 0.657079811461573, -80.7418, -1.40921025398676),
(10438, '24983', 218, 58, 455, 37.5623, 0.655585809621866, -80.5115, -1.40519076071941),
(10439, '24984', 218, 58, 111893, 37.4644, 0.653877132284164, -80.4612, -1.40431286010566),
(10440, '24985', 218, 58, 290, 37.631, 0.656784850817986, -80.7013, -1.4085033956397),
(10441, '24986', 218, 58, 26021, 37.7954, 0.659654172108265, -80.2982, -1.40146797342491),
(10442, '24991', 218, 58, 6831, 37.9516, 0.66238037639988, -80.5141, -1.40523613927997),
(10443, '24993', 218, 58, 112118, 37.6281, 0.656734236269678, -80.6059, -1.4068383515333),
(10444, '25002', 218, 58, 107952, 38.1814, 0.666391143020963, -81.3294, -1.41946580867148),
(10445, '25003', 218, 58, 92227, 38.2598, 0.667759481154526, -81.7921, -1.42754144712045),
(10446, '25004', 218, 58, 107972, 37.7843, 0.659460440561293, -81.1189, -1.41579189059603),
(10447, '25005', 218, 58, 107979, 38.5631, 0.673053064775825, -81.2641, -1.41832610866992),
(10448, '25007', 218, 58, 7164, 37.8409, 0.660448296917922, -81.4346, -1.42130189504457);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(10449, '25008', 218, 58, 108027, 37.9166, 0.661769511161682, -81.3671, -1.42012379779948),
(10450, '25009', 218, 58, 728, 38.1901, 0.666542986665887, -81.7134, -1.42616787299913),
(10451, '25010', 218, 58, 7236, 37.8259, 0.660186497530123, -81.5882, -1.42398272077564),
(10452, '25011', 218, 58, 19038, 38.3313, 0.669007391569702, -81.6015, -1.42421484956615),
(10453, '25015', 218, 58, 53404, 38.2352, 0.667330130158536, -81.5309, -1.42298264711424),
(10454, '25018', 218, 58, 108179, 38.3028, 0.668509972732884, -81.2121, -1.41741853745889),
(10455, '25019', 218, 58, 108213, 38.3718, 0.66971424991676, -81.1058, -1.41556325246402),
(10456, '25021', 218, 58, 108232, 37.8771, 0.661080106107144, -81.7077, -1.42606838923177),
(10457, '25022', 218, 58, 26538, 37.8788, 0.661109776704428, -81.8282, -1.42817151098042),
(10458, '25024', 218, 58, 108268, 38.1553, 0.665935612086192, -81.6222, -1.42457613272132),
(10459, '25025', 218, 58, 19346, 38.3032, 0.668516954049892, -81.3844, -1.42042573976007),
(10460, '25026', 218, 58, 959, 38.4361, 0.670836496625793, -81.4612, -1.4217661526256),
(10461, '25028', 218, 58, 108291, 37.9566, 0.66246764286248, -81.726, -1.42638778448489),
(10462, '25030', 218, 58, 108298, 38.4074, 0.67033558713047, -81.213, -1.41743424542215),
(10463, '25031', 218, 58, 63058, 38.1505, 0.665851836282097, -81.2872, -1.41872927972713),
(10464, '25033', 218, 58, 26642, 38.6022, 0.673735488513355, -81.9115, -1.42962537024734),
(10465, '25035', 218, 58, 108441, 38.1956, 0.666638979774746, -81.4861, -1.42220073960935),
(10466, '25036', 218, 58, 29390, 38.1947, 0.666623271811478, -81.2958, -1.41887937804281),
(10467, '25039', 218, 58, 1414, 38.22, 0.667064840112233, -81.4327, -1.42126873378879),
(10468, '25040', 218, 58, 108560, 38.1236, 0.66538234271331, -81.2343, -1.41780600055283),
(10469, '25043', 218, 58, 1601, 38.4569, 0.671199525110207, -81.0435, -1.41447591234002),
(10470, '25044', 218, 58, 29500, 37.8997, 0.661474550518095, -81.3196, -1.41929476640478),
(10471, '25045', 218, 58, 108617, 38.4763, 0.671538118985094, -81.3405, -1.41965954021845),
(10472, '25046', 218, 58, 1632, 38.589, 0.673505105052092, -81.2897, -1.41877291295843),
(10473, '25047', 218, 58, 75474, 37.7929, 0.659610538876965, -81.9946, -1.43107573885574),
(10474, '25048', 218, 58, 75498, 37.9392, 0.662163955572633, -81.4578, -1.42170681143104),
(10475, '25049', 218, 58, 63857, 38.1241, 0.66539106935957, -81.5711, -1.42368426947355),
(10476, '25051', 218, 58, 0, 38.1532, 0.665898960171901, -81.7151, -1.42619754359642),
(10477, '25053', 218, 58, 1964, 37.9992, 0.663211153123829, -81.8655, -1.42882251879142),
(10478, '25054', 218, 58, 1987, 38.1438, 0.665734899222213, -81.453, -1.42162303562694),
(10479, '25057', 218, 58, 108827, 38.1239, 0.665387578701066, -81.2602, -1.4182580408291),
(10480, '25059', 218, 58, 2047, 38.2673, 0.667890380848426, -81.1806, -1.41686875874451),
(10481, '25060', 218, 58, 8569, 37.9672, 0.662652647763191, -81.4926, -1.42231418601073),
(10482, '25061', 218, 58, 46689, 38.1768, 0.666310857875371, -81.4672, -1.42187087238072),
(10483, '25062', 218, 58, 35637, 37.8737, 0.661020764912576, -81.4305, -1.42123033654524),
(10484, '25063', 218, 58, 64286, 38.5693, 0.673161275189449, -80.9732, -1.41324894587587),
(10485, '25064', 218, 58, 2127, 38.3681, 0.669649672734436, -81.7412, -1.42665307453119),
(10486, '25067', 218, 58, 108995, 38.2184, 0.667036914844201, -81.444, -1.42146595599426),
(10487, '25070', 218, 58, 2253, 38.5369, 0.672595788511803, -81.9283, -1.42991858556167),
(10488, '25071', 218, 58, 78207, 38.4381, 0.670871403210832, -81.4705, -1.42192846824604),
(10489, '25075', 218, 58, 109111, 38.1294, 0.665483571809926, -81.4592, -1.42173124604056),
(10490, '25076', 218, 58, 8784, 37.8664, 0.660893355877181, -81.9122, -1.4296375875521),
(10491, '25079', 218, 58, 109161, 38.4746, 0.67150844838781, -81.3869, -1.42046937299137),
(10492, '25081', 218, 58, 35967, 38.0902, 0.664799402743144, -81.7715, -1.42718190929454),
(10493, '25082', 218, 58, 109276, 38.5699, 0.673171747164961, -82.0258, -1.43162028158236),
(10494, '25083', 218, 58, 27233, 38.1376, 0.665626688808589, -81.3825, -1.42039257850429),
(10495, '25085', 218, 58, 109332, 38.1682, 0.6661607595597, -81.1939, -1.41710088753502),
(10496, '25086', 218, 58, 2722, 38.2106, 0.666900779162545, -81.4207, -1.42105929427855),
(10497, '25088', 218, 58, 47441, 38.3522, 0.669372165383369, -81.2318, -1.41776236732153),
(10498, '25090', 218, 58, 109388, 38.1528, 0.665891978854893, -81.2154, -1.4174761333242),
(10499, '25093', 218, 58, 2785, 37.9947, 0.66313261330749, -81.6822, -1.42562333027251),
(10500, '25095', 218, 58, 109492, 38.6771, 0.675042740123099, -81.9489, -1.43027812338758),
(10501, '25102', 218, 58, 55157, 38.1867, 0.666483645471319, -81.3661, -1.42010634450696),
(10502, '25103', 218, 58, 36273, 38.1137, 0.665209555117363, -81.3779, -1.42031229335869),
(10503, '25106', 218, 58, 23, 38.833, 0.677763708426958, -82.1385, -1.43358726764936),
(10504, '25107', 218, 58, 109633, 38.2032, 0.666771624797898, -81.6122, -1.42440159979612),
(10505, '25108', 218, 58, 109639, 37.9608, 0.662540946691063, -81.8529, -1.42860260730567),
(10506, '25109', 218, 58, 109704, 38.5331, 0.672529466000227, -81.8615, -1.42875270562134),
(10507, '25110', 218, 58, 109749, 38.2093, 0.666878089882269, -81.3726, -1.42021979090834),
(10508, '25111', 218, 58, 109796, 38.36, 0.669508301065025, -81.1646, -1.41658950606419),
(10509, '25112', 218, 58, 60388, 38.3781, 0.669824205659636, -81.7626, -1.42702657499112),
(10510, '25113', 218, 58, 109807, 38.5243, 0.672375877026051, -81.0292, -1.41422633025699),
(10511, '25114', 218, 58, 9743, 37.9489, 0.662333252510076, -81.7813, -1.42735295156124),
(10512, '25115', 218, 58, 109907, 38.1124, 0.665186865837087, -81.1599, -1.41650747558935),
(10513, '25118', 218, 58, 3526, 38.1261, 0.66542597594461, -81.3256, -1.4193994861599),
(10514, '25119', 218, 58, 27625, 38.0303, 0.663753950521199, -81.2657, -1.41835403393796),
(10515, '25121', 218, 58, 36776, 37.9072, 0.661605450211995, -81.9234, -1.42983306442832),
(10516, '25122', 218, 58, 103627, 38.0744, 0.664523640721329, -81.4542, -1.42164397957797),
(10517, '25123', 218, 58, 3732, 38.7456, 0.676238290660715, -81.9555, -1.43039331511821),
(10518, '25124', 218, 58, 3751, 38.632, 0.674255596630449, -81.7672, -1.42710686013671),
(10519, '25125', 218, 58, 110147, 38.3364, 0.669096403361554, -81.1648, -1.41659299672269),
(10520, '25126', 218, 58, 3852, 38.1874, 0.666495862776083, -81.3482, -1.41979393057085),
(10521, '25130', 218, 58, 3938, 38.0618, 0.664303729235578, -81.82, -1.42802839398176),
(10522, '25132', 218, 58, 56059, 38.2544, 0.667665233374919, -81.3757, -1.42027389611515),
(10523, '25133', 218, 58, 110337, 38.4853, 0.671695198617774, -81.1241, -1.41588264771713),
(10524, '25134', 218, 58, 17102, 38.1517, 0.665872780233121, -81.4496, -1.42156369443237),
(10525, '25136', 218, 58, 4289, 38.1804, 0.666373689728443, -81.3232, -1.41935759825785),
(10526, '25139', 218, 58, 27963, 38.1499, 0.665841364306585, -81.3276, -1.41943439274494),
(10527, '25140', 218, 58, 110601, 37.8995, 0.661471059859591, -81.5259, -1.42289538065164),
(10528, '25141', 218, 58, 677, 38.6253, 0.674138659570566, -81.0286, -1.41421585828148),
(10529, '25142', 218, 58, 110613, 38.1577, 0.66597749998824, -81.7305, -1.42646632430123),
(10530, '25143', 218, 58, 110667, 38.4101, 0.670382711020274, -81.8301, -1.42820467223621),
(10531, '25147', 218, 58, 110747, 38.1069, 0.665090872728227, -81.4487, -1.42154798646911),
(10532, '25148', 218, 58, 110772, 38.0607, 0.664284530613806, -81.5672, -1.42361620163272),
(10533, '25149', 218, 58, 33532, 37.96, 0.662526984057047, -81.8186, -1.42800395937223),
(10534, '25150', 218, 58, 110795, 38.5281, 0.672442199537627, -81.1562, -1.41644289840702),
(10535, '25152', 218, 58, 678, 38.0533, 0.664155376249158, -81.2697, -1.41842384710804),
(10536, '25154', 218, 58, 37660, 38.12, 0.665319510860238, -81.7064, -1.4260456999515),
(10537, '25156', 218, 58, 110895, 38.4078, 0.670342568447478, -81.4801, -1.42209601985423),
(10538, '25159', 218, 58, 110943, 38.4713, 0.671450852522494, -81.8083, -1.42782419045928),
(10539, '25160', 218, 58, 110960, 38.283, 0.668164397540989, -81.2855, -1.41869960912985),
(10540, '25161', 218, 58, 105436, 38.0976, 0.664928557107792, -81.3235, -1.41936283424561),
(10541, '25162', 218, 58, 11392, 38.2093, 0.666878089882269, -81.3864, -1.42046064634511),
(10542, '25164', 218, 58, 110999, 38.4704, 0.671435144559226, -81.2204, -1.4175633997868),
(10543, '25165', 218, 58, 819, 38.1612, 0.66603858651206, -81.6573, -1.42518874328877),
(10544, '25168', 218, 58, 111074, 38.5589, 0.672979760947242, -81.8955, -1.42934611756702),
(10545, '25169', 218, 58, 50814, 38.1563, 0.665953065378712, -81.7854, -1.42742451006057),
(10546, '25173', 218, 58, 42839, 38.0975, 0.66492681177854, -81.2481, -1.4180468559896),
(10547, '25174', 218, 58, 5457, 37.8368, 0.66037673841859, -81.4895, -1.42226008080392),
(10548, '25177', 218, 58, 57331, 38.3798, 0.66985387625692, -81.8268, -1.4281470763709),
(10549, '25180', 218, 58, 24697, 37.7845, 0.659463931219798, -81.4307, -1.42123382720375),
(10550, '25181', 218, 58, 90682, 38.0902, 0.664799402743144, -81.6436, -1.42494963318124),
(10551, '25182', 218, 58, 24789, 38.159, 0.666000189268516, -81.4474, -1.42152529718883),
(10552, '25183', 218, 58, 111360, 37.9201, 0.661830597685502, -81.8294, -1.42819245493145),
(10553, '25185', 218, 58, 590, 38.2378, 0.667375508719088, -81.2331, -1.41778505660181),
(10554, '25186', 218, 58, 111438, 38.1808, 0.666380671045451, -81.3075, -1.41908358156529),
(10555, '25187', 218, 58, 5980, 38.7126, 0.675662332007557, -82.011, -1.43136197285307),
(10556, '25193', 218, 58, 25305, 38.0151, 0.663488660474896, -81.5337, -1.4230315163333),
(10557, '25201', 218, 58, 111650, 38.3335, 0.669045788813246, -81.4932, -1.42232465798624),
(10558, '25202', 218, 58, 111730, 38.34, 0.669159235214626, -81.8455, -1.42847345294102),
(10559, '25203', 218, 58, 25603, 38.0439, 0.663991315299471, -81.8622, -1.4287649229261),
(10560, '25204', 218, 58, 111761, 37.9291, 0.661987677318181, -81.6275, -1.42466863517167),
(10561, '25205', 218, 58, 111781, 38.0361, 0.663855179617815, -81.7809, -1.42734597024423),
(10562, '25206', 218, 58, 12520, 37.9573, 0.662479860167244, -81.6967, -1.42587640301405),
(10563, '25208', 218, 58, 12778, 37.9027, 0.661526910395655, -81.676, -1.42551511985889),
(10564, '25209', 218, 58, 6796, 37.9733, 0.662759112847563, -81.5284, -1.42293901388295),
(10565, '25211', 218, 58, 112047, 38.4661, 0.671360095401391, -80.8571, -1.41122261861431),
(10566, '25213', 218, 58, 6882, 38.4993, 0.671939544713053, -81.8792, -1.42906162889894),
(10567, '25214', 218, 58, 112104, 38.1628, 0.666066511780092, -81.563, -1.42354289780414),
(10568, '25231', 218, 58, 107922, 38.6234, 0.674105498314778, -81.5668, -1.42360922031571),
(10569, '25234', 218, 58, 108024, 38.836, 0.677816068304518, -81.1722, -1.41672215108734),
(10570, '25235', 218, 58, 39772, 38.6777, 0.675053212098611, -81.0903, -1.41529272642996),
(10571, '25239', 218, 58, 35393, 38.8567, 0.678177351459681, -81.8162, -1.42796207147018),
(10572, '25241', 218, 58, 15, 38.8055, 0.67728374288266, -81.796, -1.42760951496128),
(10573, '25243', 218, 58, 109306, 38.6976, 0.675400532619758, -81.4264, -1.42115877804591),
(10574, '25244', 218, 58, 21361, 38.7976, 0.677145861871752, -81.5755, -1.42376106396063),
(10575, '25245', 218, 58, 109367, 38.6831, 0.675147459878219, -81.6864, -1.4256966341011),
(10576, '25247', 218, 58, 2998, 39.001, 0.680695861570308, -81.98, -1.43082092078495),
(10577, '25248', 218, 58, 109932, 38.6212, 0.674067101071234, -81.6215, -1.42456391541655),
(10578, '25250', 218, 58, 110012, 38.8673, 0.678362356360392, -82.0801, -1.4325679953662),
(10579, '25251', 218, 58, 0, 38.6104, 0.673878605512019, -81.2457, -1.41800496808756),
(10580, '25252', 218, 58, 33011, 38.9558, 0.679906972748407, -81.5722, -1.42370346809532),
(10581, '25253', 218, 58, 110086, 38.9902, 0.680507366011093, -81.9505, -1.43030604865561),
(10582, '25256', 218, 58, 3784, 38.6945, 0.675346427412946, -81.2209, -1.41757212643306),
(10583, '25258', 218, 58, 110157, 38.8577, 0.678194804752201, -80.9555, -1.41294002259827),
(10584, '25259', 218, 58, 95830, 38.668, 0.674883915161167, -81.2982, -1.41892126594485),
(10585, '25260', 218, 58, 17048, 39.0186, 0.681003039518659, -82.0308, -1.43170754804496),
(10586, '25261', 218, 58, 37210, 38.8565, 0.678173860801177, -81.0752, -1.41502918171291),
(10587, '25262', 218, 58, 624, 38.8837, 0.678648590357719, -81.8606, -1.42873699765807),
(10588, '25264', 218, 58, 110539, 38.8627, 0.6782820712148, -81.8788, -1.42905464758193),
(10589, '25265', 218, 58, 4528, 38.9866, 0.680444534158021, -81.9591, -1.43045614697128),
(10590, '25266', 218, 58, 4570, 38.5979, 0.673660439355519, -81.1562, -1.41644289840702),
(10591, '25267', 218, 58, 23400, 38.892, 0.678793452685635, -80.9566, -1.41295922122004),
(10592, '25268', 218, 58, 110777, 38.7417, 0.676170222819887, -81.0971, -1.41541140881909),
(10593, '25270', 218, 58, 111086, 38.8437, 0.677950458656921, -81.4498, -1.42156718509088),
(10594, '25271', 218, 58, 5404, 38.8161, 0.677468747783371, -81.7071, -1.42605791725626),
(10595, '25275', 218, 58, 51218, 38.907, 0.679055252073434, -81.6403, -1.42489203731593),
(10596, '25276', 218, 58, 5995, 38.799, 0.67717029648128, -81.3513, -1.41984803577766),
(10597, '25279', 218, 58, 111529, 38.7429, 0.676191166770911, -81.6182, -1.42450631955124),
(10598, '25281', 218, 58, 0, 38.6496, 0.6745627745788, -81.1916, -1.41706074496223),
(10599, '25283', 218, 58, 111822, 38.4995, 0.671943035371557, -81.1542, -1.41640799182198),
(10600, '25285', 218, 58, 111902, 38.5795, 0.673339298773152, -81.0868, -1.41523163990614),
(10601, '25286', 218, 58, 18491, 38.5804, 0.67335500673642, -81.4176, -1.42100518907174),
(10602, '25287', 218, 58, 84280, 38.9311, 0.679475876423164, -82.0703, -1.4323969530995),
(10603, '25301', 218, 58, 8039, 38.3516, 0.669361693407857, -81.6319, -1.42474542965876),
(10604, '25302', 218, 58, 8039, 38.373, 0.669735193867784, -81.6221, -1.42457438739206),
(10605, '25303', 218, 58, 8039, 38.3595, 0.669499574418765, -81.6827, -1.42563205691877),
(10606, '25304', 218, 58, 8039, 38.3191, 0.668794461400959, -81.5895, -1.42400541005591),
(10607, '25305', 218, 58, 8039, 38.3595, 0.669499574418765, -81.5712, -1.4236860148028),
(10608, '25306', 218, 58, 8039, 38.2963, 0.668396526331504, -81.5519, -1.42334916625716),
(10609, '25309', 218, 58, 8039, 38.3457, 0.66925871898199, -81.7321, -1.42649424956926),
(10610, '25311', 218, 58, 8039, 38.3506, 0.669344240115337, -81.5919, -1.42404729795796),
(10611, '25312', 218, 58, 8039, 38.3881, 0.669998738584835, -81.6677, -1.42537025753097),
(10612, '25313', 218, 58, 8039, 38.4245, 0.670634038432561, -81.7697, -1.42715049336801),
(10613, '25314', 218, 58, 8039, 38.3378, 0.669120837971082, -81.6577, -1.42519572460577),
(10614, '25315', 218, 58, 8039, 38.2348, 0.667323148841528, -81.5526, -1.42336138356193),
(10615, '25317', 218, 58, 8039, 38.3599, 0.669506555735773, -81.5711, -1.42368426947355),
(10616, '25320', 218, 58, 8039, 38.508, 0.672091388357976, -81.6406, -1.42489727330368),
(10617, '25321', 218, 58, 8039, 38.3511, 0.669352966761597, -81.6307, -1.42472448570774),
(10618, '25322', 218, 58, 8039, 38.3519, 0.669366929395613, -81.6304, -1.42471924971998),
(10619, '25323', 218, 58, 8039, 38.3518, 0.669365184066361, -81.6304, -1.42471924971998),
(10620, '25324', 218, 58, 8039, 38.3512, 0.669354712090849, -81.6308, -1.42472623103699),
(10621, '25325', 218, 58, 8039, 38.3517, 0.669363438737109, -81.6301, -1.42471401373222),
(10622, '25326', 218, 58, 8039, 38.3311, 0.669003900911198, -81.597, -1.42413630974981),
(10623, '25327', 218, 58, 8039, 38.3498, 0.669330277481321, -81.6325, -1.42475590163427),
(10624, '25328', 218, 58, 8039, 38.3518, 0.669365184066361, -81.6306, -1.42472274037848),
(10625, '25329', 218, 58, 8039, 38.3518, 0.669365184066361, -81.6305, -1.42472099504923),
(10626, '25330', 218, 58, 8039, 38.3499, 0.669332022810573, -81.6332, -1.42476811893904),
(10627, '25331', 218, 58, 8039, 38.3505, 0.669342494786085, -81.6284, -1.42468434313494),
(10628, '25332', 218, 58, 8039, 38.3498, 0.669330277481321, -81.628, -1.42467736181793),
(10629, '25333', 218, 58, 8039, 38.35, 0.669333768139825, -81.6328, -1.42476113762203),
(10630, '25334', 218, 58, 8039, 38.3502, 0.669337258798329, -81.6278, -1.42467387115943),
(10631, '25335', 218, 58, 8039, 38.3508, 0.669347730773841, -81.633, -1.42476462828053),
(10632, '25336', 218, 58, 8039, 38.3498, 0.669330277481321, -81.6283, -1.42468259780569),
(10633, '25337', 218, 58, 8039, 38.3501, 0.669335513469077, -81.6284, -1.42468434313494),
(10634, '25338', 218, 58, 8039, 38.3498, 0.669330277481321, -81.6284, -1.42468434313494),
(10635, '25339', 218, 58, 8039, 38.3516, 0.669361693407857, -81.6296, -1.42470528708596),
(10636, '25350', 218, 58, 8039, 38.3505, 0.669342494786085, -81.6284, -1.42468434313494),
(10637, '25356', 218, 58, 8039, 38.4478, 0.671040700148276, -81.7525, -1.42685029673666),
(10638, '25357', 218, 58, 8039, 38.4218, 0.670586914542757, -81.6907, -1.42577168325893),
(10639, '25358', 218, 58, 8039, 38.3336, 0.669047534142498, -81.7464, -1.42674383165229),
(10640, '25360', 218, 58, 8039, 38.4545, 0.671157637208159, -81.6666, -1.4253510589092),
(10641, '25361', 218, 58, 8039, 38.3653, 0.66960080351538, -81.5514, -1.4233404396109),
(10642, '25362', 218, 58, 8039, 38.3965, 0.670145346242003, -81.5863, -1.42394955951985),
(10643, '25364', 218, 58, 8039, 38.3191, 0.668794461400959, -81.5984, -1.42416074435934),
(10644, '25365', 218, 58, 8039, 38.2339, 0.66730744087826, -81.5743, -1.42374012000961),
(10645, '25375', 218, 58, 8039, 38.3521, 0.669370420054117, -81.6301, -1.42471401373222),
(10646, '25387', 218, 58, 8039, 38.3508, 0.669347730773841, -81.6305, -1.42472099504923),
(10647, '25389', 218, 58, 8039, 38.3706, 0.669693305965736, -81.6723, -1.42545054267656),
(10648, '25392', 218, 58, 8039, 38.3502, 0.669337258798329, -81.6283, -1.42468259780569),
(10649, '25396', 218, 58, 8039, 38.3504, 0.669340749456833, -81.63, -1.42471226840297),
(10650, '25401', 218, 58, 27815, 39.4619, 0.68874008409275, -77.9661, -1.36076514993915),
(10651, '25402', 218, 58, 27815, 39.4607, 0.688719140141726, -77.9696, -1.36082623646297),
(10652, '25410', 218, 58, 34644, 39.3286, 0.686413560199842, -77.7796, -1.35751011088418),
(10653, '25411', 218, 58, 108185, 39.6259, 0.691602424066021, -78.2255, -1.36529253401882),
(10654, '25413', 218, 58, 7775, 39.3061, 0.686020861118143, -78.0358, -1.36198164442779),
(10655, '25414', 218, 58, 108548, 39.2909, 0.68575557107184, -77.8629, -1.35896397015109),
(10656, '25419', 218, 58, 109163, 39.5754, 0.690721032793764, -77.8927, -1.35948407826819),
(10657, '25420', 218, 58, 109347, 39.3748, 0.687219902314263, -78.1371, -1.36374966296006),
(10658, '25421', 218, 58, 109400, 39.3801, 0.687312404764619, -78.1414, -1.3638247121179),
(10659, '25422', 218, 58, 109454, 39.6151, 0.691413928506806, -78.3903, -1.36816883662611),
(10660, '25423', 218, 58, 2944, 39.3136, 0.686151760812043, -77.7986, -1.35784172344206),
(10661, '25425', 218, 58, 109564, 39.2915, 0.685766043047352, -77.7613, -1.35719071563107),
(10662, '25427', 218, 58, 109610, 39.5672, 0.6905779157951, -78.1002, -1.36310563646608),
(10663, '25428', 218, 58, 27, 39.3557, 0.686886544427132, -78.0431, -1.36210905346319),
(10664, '25429', 218, 58, 109917, 39.3877, 0.687445049787771, -77.8856, -1.3593601598913),
(10665, '25430', 218, 58, 109917, 39.3406, 0.686622999710081, -77.9427, -1.36035674289418),
(10666, '25431', 218, 58, 110088, 39.4901, 0.689232266941813, -78.562, -1.37116556695179),
(10667, '25432', 218, 58, 4227, 39.2939, 0.6858079309494, -77.7856, -1.3576148306393),
(10668, '25434', 218, 58, 37604, 39.47, 0.688881455762162, -78.4449, -1.3691217863977),
(10669, '25437', 218, 58, 110952, 39.4509, 0.688548097875031, -78.5653, -1.3712231628171),
(10670, '25438', 218, 58, 111054, 39.3007, 0.685926613338535, -77.8627, -1.35896047949259),
(10671, '25440', 218, 58, 11587, 39.2971, 0.685863781485464, -78.0724, -1.36262043493402),
(10672, '25441', 218, 58, 111128, 39.228, 0.684657758972336, -77.9228, -1.36000942237304),
(10673, '25442', 218, 58, 111368, 39.3589, 0.686942394963196, -77.8399, -1.35856254442313),
(10674, '25443', 218, 58, 111370, 39.4277, 0.688143181488568, -77.8161, -1.35814715606116),
(10675, '25444', 218, 58, 111427, 39.3993, 0.687647507981002, -78.5073, -1.37021087185094),
(10676, '25446', 218, 58, 111599, 39.2402, 0.684870689141079, -77.9725, -1.36087685101128),
(10677, '25501', 218, 58, 107942, 38.1706, 0.666202647461748, -81.9978, -1.43113158939181),
(10678, '25502', 218, 58, 34575, 38.6604, 0.674751270138016, -82.1295, -1.43343018801668),
(10679, '25503', 218, 58, 7180, 38.6, 0.673697091269811, -82.1114, -1.43311428342207),
(10680, '25504', 218, 58, 99621, 38.3944, 0.670108694327711, -82.2838, -1.43612323105251),
(10681, '25505', 218, 58, 707, 38.0333, 0.663806310398759, -82.018, -1.43148414590071),
(10682, '25506', 218, 58, 100130, 38.2314, 0.66726380764696, -82.2127, -1.43488230195434),
(10683, '25507', 218, 58, 35202, 38.3876, 0.669990011938575, -82.5577, -1.44090368787372),
(10684, '25508', 218, 58, 108547, 37.9549, 0.662437972265196, -82.0029, -1.43122060118366),
(10685, '25510', 218, 58, 20406, 38.4197, 0.670550262628465, -82.0698, -1.43238822645324),
(10686, '25511', 218, 58, 108977, 38.0382, 0.663891831532107, -82.3454, -1.43719835387174),
(10687, '25512', 218, 58, 109001, 38.1914, 0.666565675946162, -82.3276, -1.43688768526488),
(10688, '25514', 218, 58, 109250, 38.1185, 0.665293330921458, -82.5959, -1.44157040364798),
(10689, '25515', 218, 58, 109301, 38.7005, 0.675451147168065, -82.1191, -1.43324867377448),
(10690, '25517', 218, 58, 9080, 38.0741, 0.664518404733573, -82.4683, -1.43934336352244),
(10691, '25519', 218, 58, 109401, 38.0139, 0.663467716523872, -82.5212, -1.44026664269674),
(10692, '25520', 218, 58, 2749, 38.5912, 0.673543502295636, -82.1925, -1.43452974544544),
(10693, '25521', 218, 58, 109490, 38.2461, 0.667520371047003, -81.9903, -1.43100068969791),
(10694, '25523', 218, 58, 9306, 38.2789, 0.668092839041657, -82.1025, -1.43295894911864),
(10695, '25524', 218, 58, 21769, 38.0297, 0.663743478545687, -82.0819, -1.43259941129273),
(10696, '25526', 218, 58, 3302, 38.4363, 0.670839987284297, -82.0005, -1.43117871328161),
(10697, '25529', 218, 58, 95234, 38.1516, 0.665871034903869, -81.8591, -1.42871081771929),
(10698, '25530', 218, 58, 9845, 38.3851, 0.669946378707275, -82.5719, -1.44115152462751),
(10699, '25534', 218, 58, 109957, 38.0688, 0.664425902283217, -82.2651, -1.43579685448239),
(10700, '25535', 218, 58, 110043, 38.3062, 0.668569313927452, -82.4453, -1.43894193779448),
(10701, '25537', 218, 58, 110080, 38.509, 0.672108841650496, -82.2924, -1.43627332936818),
(10702, '25540', 218, 58, 110428, 38.1412, 0.665689520661661, -82.1393, -1.43360123028338),
(10703, '25541', 218, 58, 4232, 38.4366, 0.670845223272052, -82.1419, -1.43364660884393),
(10704, '25544', 218, 58, 37347, 38.2275, 0.667195739806132, -82.1352, -1.43352967178405),
(10705, '25545', 218, 58, 17415, 38.4334, 0.670789372735989, -82.2283, -1.43515457331765),
(10706, '25547', 218, 58, 110844, 37.9319, 0.662036546537237, -82.0002, -1.43117347729385),
(10707, '25550', 218, 58, 17683, 38.8628, 0.678283816544052, -82.1302, -1.43344240532145),
(10708, '25555', 218, 58, 5227, 38.2459, 0.667516880388499, -82.5797, -1.44128766030916),
(10709, '25557', 218, 58, 11465, 38.0828, 0.664670248378497, -82.1611, -1.43398171206031),
(10710, '25559', 218, 58, 111265, 38.3367, 0.66910163934931, -82.2314, -1.43520867852447),
(10711, '25560', 218, 58, 111319, 38.4517, 0.671108767989104, -81.9024, -1.4294665452854),
(10712, '25562', 218, 58, 31122, 38.3267, 0.668927106424111, -82.4753, -1.43946553657008),
(10713, '25564', 218, 58, 111450, 38.2686, 0.667913070128702, -81.8855, -1.42917158464182),
(10714, '25565', 218, 58, 111517, 38.0771, 0.664570764611133, -81.9909, -1.43101116167342),
(10715, '25567', 218, 58, 111591, 38.196, 0.666645961091754, -81.8921, -1.42928677637245),
(10716, '25569', 218, 58, 111678, 38.4414, 0.670928999076148, -81.9527, -1.43034444589916),
(10717, '25570', 218, 58, 6665, 38.2252, 0.667155597233337, -82.4476, -1.43898208036728),
(10718, '25571', 218, 58, 111972, 38.2834, 0.668171378857997, -82.1672, -1.43408817714468),
(10719, '25572', 218, 58, 6954, 38.1586, 0.665993207951508, -81.8928, -1.42929899367721),
(10720, '25573', 218, 58, 112166, 38.2371, 0.667363291414324, -81.9568, -1.43041600439849),
(10721, '25601', 218, 58, 3843, 37.8662, 0.660889865218677, -81.9894, -1.43098498173464),
(10722, '25606', 218, 58, 107904, 37.7689, 0.659191659856486, -81.8374, -1.42833208127161),
(10723, '25607', 218, 58, 107977, 37.7878, 0.659521527085113, -81.7959, -1.42760776963203),
(10724, '25608', 218, 58, 108066, 37.5872, 0.656020396605613, -81.9483, -1.43026765141207),
(10725, '25611', 218, 58, 7724, 37.6904, 0.657821576393671, -81.8695, -1.4288923319615),
(10726, '25612', 218, 58, 19971, 37.7663, 0.659146281295934, -81.9881, -1.43096229245436),
(10727, '25614', 218, 58, 498, 37.8478, 0.66056872463631, -81.9909, -1.43101116167342),
(10728, '25617', 218, 58, 108800, 37.7136, 0.658226492780133, -81.7872, -1.42745592598711),
(10729, '25621', 218, 58, 2713, 37.578, 0.655859826314429, -81.8772, -1.4290267223139),
(10730, '25623', 218, 58, 2956, 37.6423, 0.656982073023461, -81.9419, -1.43015595033994),
(10731, '25624', 218, 58, 109623, 37.8485, 0.660580941941074, -81.9919, -1.43102861496594),
(10732, '25625', 218, 58, 27452, 37.831, 0.660275509321975, -82.0427, -1.43191524222595),
(10733, '25628', 218, 58, 109981, 37.7133, 0.658221256792377, -81.7871, -1.42745418065785),
(10734, '25630', 218, 58, 10195, 37.7955, 0.659655917437517, -81.715, -1.42619579826717),
(10735, '25632', 218, 58, 110227, 37.7767, 0.659327795538142, -81.9512, -1.43031826596038),
(10736, '25634', 218, 58, 82230, 37.7348, 0.658596502581556, -81.8186, -1.42800395937223),
(10737, '25635', 218, 58, 110262, 37.7428, 0.658736128921716, -81.8749, -1.42898657974111),
(10738, '25636', 218, 58, 96275, 37.8123, 0.659949132751852, -81.9947, -1.43107748418499),
(10739, '25637', 218, 58, 110541, 37.8416, 0.660460514222686, -82.0089, -1.43132532093878),
(10740, '25638', 218, 58, 14353, 37.7264, 0.658449894924389, -82.0188, -1.43149810853473),
(10741, '25639', 218, 58, 96954, 37.8476, 0.660565233977806, -81.9918, -1.43102686963669),
(10742, '25644', 218, 58, 111297, 37.7001, 0.657990873331114, -81.9583, -1.43044218433727),
(10743, '25645', 218, 58, 111546, 37.7259, 0.658441168278129, -82.0027, -1.43121711052515),
(10744, '25646', 218, 58, 111551, 37.8374, 0.660387210394103, -81.965, -1.43055912139715),
(10745, '25647', 218, 58, 74494, 37.786, 0.659490111158577, -81.9744, -1.43072318234684),
(10746, '25649', 218, 58, 43469, 37.8986, 0.661455351896323, -81.9928, -1.43104432292921),
(10747, '25650', 218, 58, 111855, 37.6386, 0.656917495841138, -81.875, -1.42898832507036),
(10748, '25651', 218, 58, 112006, 37.551, 0.655388587416391, -81.9782, -1.43078950485842),
(10749, '25652', 218, 58, 34417, 37.793, 0.659612284206217, -82.052, -1.43207755784639),
(10750, '25653', 218, 58, 31534, 37.836, 0.660362775784574, -82.0216, -1.43154697775378),
(10751, '25654', 218, 58, 112169, 37.7946, 0.659640209474249, -81.8887, -1.42922743517788),
(10752, '25661', 218, 58, 12870, 37.6755, 0.657561522335124, -82.2774, -1.43601152998038),
(10753, '25665', 218, 58, 108309, 37.7138, 0.658229983438637, -82.3092, -1.43656654468252),
(10754, '25666', 218, 58, 79919, 37.9212, 0.661849796307274, -82.2704, -1.43588935693274),
(10755, '25667', 218, 58, 108553, 37.705, 0.658076394464462, -82.2681, -1.43584921435995),
(10756, '25669', 218, 58, 35455, 37.9425, 0.662221551437949, -82.4463, -1.438959391087),
(10757, '25670', 218, 58, 108836, 37.7239, 0.658406261693089, -82.1269, -1.43338480945613),
(10758, '25671', 218, 58, 108866, 37.8799, 0.6611289753262, -82.1899, -1.43448436688489),
(10759, '25672', 218, 58, 0, 37.5812, 0.655915676850493, -82.1058, -1.43301654498396),
(10760, '25674', 218, 58, 103301, 37.8403, 0.66043782494241, -82.4095, -1.43831710992227),
(10761, '25676', 218, 58, 36846, 37.8072, 0.65986012096, -82.2701, -1.43588412094499),
(10762, '25678', 218, 58, 110321, 37.6493, 0.657104246071101, -82.1278, -1.4334005174194),
(10763, '25682', 218, 58, 37143, 37.5964, 0.656180966896796, -82.0572, -1.43216831496749),
(10764, '25685', 218, 58, 110604, 37.8076, 0.659867102277008, -82.2706, -1.43589284759125),
(10765, '25686', 218, 58, 839, 37.6493, 0.657104246071101, -82.1282, -1.43340749873641),
(10766, '25687', 218, 58, 33441, 37.7401, 0.658689005031912, -82.3316, -1.43695749843496),
(10767, '25688', 218, 58, 110680, 37.6263, 0.656702820343142, -82.1487, -1.43376529123307),
(10768, '25690', 218, 58, 5274, 37.7026, 0.658034506562414, -82.1276, -1.4333970267609),
(10769, '25691', 218, 58, 111060, 37.65, 0.657116463375865, -82.2202, -1.43501320164824),
(10770, '25692', 218, 58, 111072, 37.6493, 0.657104246071101, -82.1328, -1.433487783882),
(10771, '25694', 218, 58, 111694, 37.6031, 0.65629790395668, -82.1114, -1.43311428342207),
(10772, '25696', 218, 58, 38668, 37.6807, 0.657652279456227, -82.0663, -1.43232713992942),
(10773, '25697', 218, 58, 6585, 37.5525, 0.655414767355171, -82.1265, -1.43337782813912),
(10774, '25699', 218, 58, 112086, 37.9572, 0.662478114837992, -82.3687, -1.43760501558745),
(10775, '25701', 218, 58, 9621, 38.4039, 0.67027450060665, -82.4348, -1.43875867822302),
(10776, '25702', 218, 58, 9621, 38.4293, 0.670717814236657, -82.3706, -1.43763817684324),
(10777, '25703', 218, 58, 9621, 38.4213, 0.670578187896497, -82.4186, -1.4384759348842),
(10778, '25704', 218, 58, 9621, 38.3768, 0.66980151637936, -82.5153, -1.44016366827088),
(10779, '25705', 218, 58, 9621, 38.4105, 0.670389692337282, -82.3668, -1.43757185433167),
(10780, '25706', 218, 58, 9621, 38.3985, 0.670180252827043, -82.4484, -1.43899604300129),
(10781, '25707', 218, 58, 9621, 38.3986, 0.670181998156295, -82.4487, -1.43900127898905),
(10782, '25708', 218, 58, 9621, 38.4232, 0.670611349152285, -82.4397, -1.43884419935637),
(10783, '25709', 218, 58, 9621, 38.4233, 0.670613094481537, -82.4401, -1.43885118067338),
(10784, '25710', 218, 58, 9621, 38.4236, 0.670618330469293, -82.4402, -1.43885292600263),
(10785, '25711', 218, 58, 9621, 38.398, 0.670171526180783, -82.449, -1.4390065149768),
(10786, '25712', 218, 58, 9621, 38.3986, 0.670181998156295, -82.449, -1.4390065149768),
(10787, '25713', 218, 58, 9621, 38.3981, 0.670173271510035, -82.4482, -1.43899255234279),
(10788, '25714', 218, 58, 9621, 38.3979, 0.670169780851531, -82.4494, -1.43901349629381),
(10789, '25715', 218, 58, 9621, 38.3977, 0.670166290193027, -82.4482, -1.43899255234279),
(10790, '25716', 218, 58, 9621, 38.3983, 0.670176762168539, -82.4485, -1.43899778833054),
(10791, '25717', 218, 58, 9621, 38.424, 0.670625311786301, -82.4401, -1.43885118067338),
(10792, '25718', 218, 58, 9621, 38.4235, 0.670616585140041, -82.4399, -1.43884769001487),
(10793, '25719', 218, 58, 9621, 38.4237, 0.670620075798545, -82.4405, -1.43885816199039),
(10794, '25720', 218, 58, 9621, 38.3979, 0.670169780851531, -82.4484, -1.43899604300129),
(10795, '25721', 218, 58, 9621, 38.4235, 0.670616585140041, -82.4403, -1.43885467133188),
(10796, '25722', 218, 58, 9621, 38.4237, 0.670620075798545, -82.44, -1.43884943534413),
(10797, '25723', 218, 58, 9621, 38.424, 0.670625311786301, -82.4399, -1.43884769001487),
(10798, '25724', 218, 58, 9621, 38.4232, 0.670611349152285, -82.4396, -1.43884245402712),
(10799, '25725', 218, 58, 9621, 38.3985, 0.670180252827043, -82.4491, -1.43900826030606),
(10800, '25726', 218, 58, 9621, 38.4158, 0.670482194787638, -82.4753, -1.43946553657008),
(10801, '25727', 218, 58, 9621, 38.4159, 0.67048394011689, -82.4751, -1.43946204591158),
(10802, '25728', 218, 58, 9621, 38.3979, 0.670169780851531, -82.449, -1.4390065149768),
(10803, '25729', 218, 58, 9621, 38.3976, 0.670164544863775, -82.4488, -1.4390030243183),
(10804, '25755', 218, 58, 9621, 38.4191, 0.670539790652953, -82.4447, -1.43893146581897),
(10805, '25770', 218, 58, 9621, 38.3392, 0.66914527258061, -82.5178, -1.44020730150218),
(10806, '25771', 218, 58, 9621, 38.3392, 0.66914527258061, -82.518, -1.44021079216068),
(10807, '25772', 218, 58, 9621, 38.4165, 0.670494412092402, -82.476, -1.43947775387484),
(10808, '25773', 218, 58, 9621, 38.4156, 0.670478704129134, -82.4756, -1.43947077255784),
(10809, '25774', 218, 58, 9621, 38.4157, 0.670480449458386, -82.4759, -1.43947600854559),
(10810, '25775', 218, 58, 9621, 38.4162, 0.670489176104646, -82.4752, -1.43946379124083),
(10811, '25776', 218, 58, 9621, 38.4157, 0.670480449458386, -82.4756, -1.43947077255784),
(10812, '25777', 218, 58, 9621, 38.4156, 0.670478704129134, -82.476, -1.43947775387484),
(10813, '25778', 218, 58, 9621, 38.4162, 0.670489176104646, -82.4761, -1.4394794992041),
(10814, '25779', 218, 58, 9621, 38.3389, 0.669140036592854, -82.5176, -1.44020381084367),
(10815, '25801', 218, 58, 34721, 37.7858, 0.659486620500073, -81.1906, -1.41704329166971),
(10816, '25802', 218, 58, 34721, 37.7941, 0.659631482827989, -81.218, -1.41752151188475),
(10817, '25810', 218, 58, 107944, 37.5888, 0.656048321873644, -81.3503, -1.41983058248514),
(10818, '25811', 218, 58, 107978, 37.5968, 0.656187948213804, -81.3429, -1.4197014281205),
(10819, '25812', 218, 58, 107992, 38.135, 0.665581310248038, -81.0935, -1.41534857696602),
(10820, '25813', 218, 58, 7346, 37.7748, 0.659294634282354, -81.1014, -1.41548645797693),
(10821, '25816', 218, 58, 71855, 37.7355, 0.65860871988632, -81.1329, -1.41603623669131),
(10822, '25817', 218, 58, 108297, 37.7813, 0.659408080683734, -81.4172, -1.42099820775473),
(10823, '25818', 218, 58, 694, 37.8615, 0.660807834743833, -81.1963, -1.41714277543707),
(10824, '25820', 218, 58, 63388, 37.493, 0.654376296450234, -81.1134, -1.41569589748717),
(10825, '25823', 218, 58, 1659, 37.6764, 0.657577230298392, -81.214, -1.41745169871467),
(10826, '25825', 218, 58, 108680, 37.6493, 0.657104246071101, -81.1213, -1.41583377849808),
(10827, '25826', 218, 58, 75531, 37.5737, 0.655784777156593, -81.358, -1.41996497283755),
(10828, '25827', 218, 58, 26876, 37.7381, 0.658654098446872, -81.2312, -1.41775189534602),
(10829, '25831', 218, 58, 108791, 37.8823, 0.661170863228248, -80.9727, -1.41324021922961),
(10830, '25832', 218, 58, 20460, 37.7384, 0.658659334434628, -81.1326, -1.41603100070355),
(10831, '25833', 218, 58, 2081, 37.9904, 0.663057564149654, -81.2124, -1.41742377344664),
(10832, '25836', 218, 58, 54555, 37.7833, 0.659442987268773, -81.2665, -1.41836799657197),
(10833, '25837', 218, 58, 2234, 38.0516, 0.664125705651874, -81.0365, -1.41435373929238),
(10834, '25839', 218, 58, 2365, 37.7879, 0.659523272414365, -81.3904, -1.42053045951519),
(10835, '25840', 218, 58, 2428, 38.0545, 0.664176320200182, -81.1035, -1.41552310989122),
(10836, '25841', 218, 58, 2482, 37.545, 0.655283867661271, -81.1166, -1.41575174802323),
(10837, '25843', 218, 58, 36085, 37.6125, 0.656461964906367, -81.0988, -1.41544107941638),
(10838, '25844', 218, 58, 109384, 37.7441, 0.658758818201992, -81.395, -1.42061074466078),
(10839, '25845', 218, 58, 109389, 37.6513, 0.657139152656141, -81.5284, -1.42293901388295),
(10840, '25846', 218, 58, 72676, 37.8983, 0.661450115908567, -81.1608, -1.41652318355261),
(10841, '25847', 218, 58, 109391, 37.787, 0.659507564451097, -81.1337, -1.41605019932532),
(10842, '25848', 218, 58, 109392, 37.7319, 0.658545888033249, -81.4417, -1.42142581342147),
(10843, '25849', 218, 58, 109394, 37.7299, 0.658510981448209, -81.28, -1.41860361602099),
(10844, '25851', 218, 58, 16368, 37.7982, 0.659703041327321, -81.2615, -1.41828073010937),
(10845, '25853', 218, 58, 16401, 37.6346, 0.656847682671058, -81.3142, -1.41920051862517),
(10846, '25854', 218, 58, 9481, 38.1119, 0.665178139190827, -80.9477, -1.41280388691661),
(10847, '25855', 218, 58, 3152, 37.9425, 0.662221551437949, -81.1507, -1.41634690529816),
(10848, '25856', 218, 58, 109876, 37.6529, 0.657167077924173, -81.201, -1.41722480591192),
(10849, '25857', 218, 58, 3466, 37.6255, 0.656688857709127, -81.2114, -1.41740632015412),
(10850, '25859', 218, 58, 88271, 37.8906, 0.661315725556163, -81.1825, -1.4169019200003),
(10851, '25860', 218, 58, 9973, 37.8277, 0.660217913456659, -81.1469, -1.41628058278659),
(10852, '25862', 218, 58, 9985, 38.1089, 0.665125779313267, -81.0315, -1.41426647282979),
(10853, '25864', 218, 58, 110049, 37.8707, 0.660968405035017, -80.996, -1.41364688094533),
(10854, '25865', 218, 58, 3735, 37.7151, 0.658252672718913, -81.3374, -1.41960543501164),
(10855, '25866', 218, 58, 110152, 38.0107, 0.663411865987809, -81.145, -1.4162474215308),
(10856, '25868', 218, 58, 10194, 38.0525, 0.664141413615142, -80.8971, -1.4119207503151),
(10857, '25870', 218, 58, 60730, 37.6616, 0.657318921569096, -81.397, -1.42064565124582),
(10858, '25871', 218, 58, 110237, 37.7701, 0.65921260380751, -81.2086, -1.41735745093507),
(10859, '25873', 218, 58, 110238, 37.7572, 0.658987456334003, -81.209, -1.41736443225208),
(10860, '25875', 218, 58, 110355, 37.6771, 0.657589447603156, -81.4672, -1.42187087238072),
(10861, '25876', 218, 58, 111302, 37.6355, 0.656863390634326, -81.4473, -1.42152355185958),
(10862, '25878', 218, 58, 41, 37.7171, 0.658287579303953, -81.2448, -1.41798926012429),
(10863, '25879', 218, 58, 42112, 37.9762, 0.662809727395871, -81.1194, -1.41580061724229),
(10864, '25880', 218, 58, 4376, 37.8944, 0.661382048067739, -81.1682, -1.41665233791726),
(10865, '25882', 218, 58, 110583, 37.5855, 0.655990726008329, -81.3853, -1.42044144772334),
(10866, '25901', 218, 58, 4679, 37.9833, 0.662933645772762, -81.1441, -1.41623171356753),
(10867, '25902', 218, 58, 104889, 37.5689, 0.655701001352498, -81.2319, -1.41776411265078),
(10868, '25904', 218, 58, 110837, 37.9099, 0.661652574101798, -81.2642, -1.41832785399918),
(10869, '25906', 218, 58, 110912, 37.8343, 0.660333105187291, -81.1228, -1.41585995843686),
(10870, '25907', 218, 58, 110995, 37.8587, 0.660758965524777, -81.0538, -1.41465568125298),
(10871, '25908', 218, 58, 110997, 37.6576, 0.657249108399017, -81.2365, -1.41784439779637),
(10872, '25909', 218, 58, 558, 37.8349, 0.660343577162803, -81.2071, -1.41733127099629),
(10873, '25911', 218, 58, 185, 37.7582, 0.659004909626523, -81.1674, -1.41663837528325),
(10874, '25912', 218, 58, 5291, 37.9696, 0.662694535665239, -80.7732, -1.40975828737188),
(10875, '25913', 218, 58, 111057, 37.6977, 0.657948985429066, -81.4817, -1.42212394512226),
(10876, '25914', 218, 58, 111082, 37.9723, 0.662741659555043, -81.1484, -1.41630676272537),
(10877, '25915', 218, 58, 111099, 37.6235, 0.656653951124087, -81.284, -1.41867342919107),
(10878, '25916', 218, 58, 97716, 37.6791, 0.657624354188195, -81.5013, -1.42246602965565),
(10879, '25917', 218, 58, 111306, 37.9695, 0.662692790335987, -81.1579, -1.41647256900431),
(10880, '25918', 218, 58, 111347, 37.6996, 0.657982146684854, -81.1392, -1.41614619243418),
(10881, '25919', 218, 58, 31135, 37.7956, 0.659657662766769, -81.1831, -1.41691239197581),
(10882, '25920', 218, 58, 111424, 37.6777, 0.657599919578667, -81.2735, -1.41849016961961),
(10883, '25921', 218, 58, 68915, 37.7074, 0.65811828236651, -81.2556, -1.4181777556835),
(10884, '25922', 218, 58, 111487, 37.4453, 0.653543774397033, -81.1124, -1.41567844419465),
(10885, '25926', 218, 58, 5999, 37.7875, 0.659516291097357, -81.193, -1.41708517957176),
(10886, '25927', 218, 58, 111522, 37.8163, 0.660018945921932, -81.1597, -1.41650398493084),
(10887, '25928', 218, 58, 61884, 37.5761, 0.655826665058641, -81.3312, -1.41949722459801),
(10888, '25931', 218, 58, 111594, 38.0028, 0.663273984976901, -81.1604, -1.41651620223561),
(10889, '25932', 218, 58, 111626, 37.7372, 0.658638390483604, -81.3431, -1.419704918779),
(10890, '25934', 218, 58, 12285, 37.8609, 0.660797362768321, -81.0988, -1.41544107941638),
(10891, '25936', 218, 58, 69406, 37.949, 0.662334997839328, -81.0519, -1.41462251999719),
(10892, '25938', 218, 58, 12551, 38.1419, 0.665701737966425, -81.0358, -1.41434152198762),
(10893, '25942', 218, 58, 904, 38.0464, 0.664034948530771, -80.993, -1.41359452106777),
(10894, '25943', 218, 58, 112150, 37.5986, 0.65621936414034, -81.343, -1.41970317344975),
(10895, '25951', 218, 58, 3161, 37.6674, 0.657420150665712, -80.8852, -1.41171305613412),
(10896, '25958', 218, 58, 108551, 37.9902, 0.66305407349115, -80.6921, -1.40834282534852),
(10897, '25961', 218, 58, 1889, 38.0481, 0.664064619128054, -80.7208, -1.40884373484384),
(10898, '25962', 218, 58, 111039, 37.9698, 0.662698026323743, -80.7673, -1.40965531294602),
(10899, '25965', 218, 58, 40808, 37.8473, 0.66055999799005, -80.8033, -1.41028363147673),
(10900, '25966', 218, 58, 109463, 37.7964, 0.659671625400785, -80.832, -1.41078454097206),
(10901, '25967', 218, 58, 3160, 37.9825, 0.662919683138746, -80.7166, -1.40877043101525),
(10902, '25969', 218, 58, 109891, 37.6105, 0.656427058321327, -81.0184, -1.41403783469777),
(10903, '25971', 218, 58, 110082, 37.4987, 0.654475780217598, -80.9899, -1.41354041586096),
(10904, '25972', 218, 58, 10047, 38.0386, 0.663898812849115, -80.748, -1.40931846440038),
(10905, '25976', 218, 58, 110376, 37.8679, 0.660919535815961, -80.8514, -1.41112313484694),
(10906, '25977', 218, 58, 110377, 37.8075, 0.659865356947756, -80.9097, -1.41214066180086),
(10907, '25978', 218, 58, 110663, 37.6265, 0.656706311001646, -80.9365, -1.41260841004039),
(10908, '25979', 218, 58, 110916, 37.5141, 0.654744560922405, -80.9231, -1.41237453592062),
(10909, '25981', 218, 58, 111028, 38.0535, 0.664158866907662, -80.6738, -1.4080234300954),
(10910, '25984', 218, 58, 11731, 37.9478, 0.662314053888304, -80.6926, -1.40835155199478),
(10911, '25985', 218, 58, 57416, 37.7597, 0.659031089565303, -80.8661, -1.41137969824699),
(10912, '25986', 218, 58, 111500, 37.8704, 0.66096316904726, -80.8098, -1.41039707787811),
(10913, '25988', 218, 58, 98641, 37.5831, 0.655948838106281, -80.9228, -1.41236929993287),
(10914, '25989', 218, 58, 903, 37.6838, 0.657706384663039, -81.0332, -1.41429614342707),
(10915, '26003', 218, 58, 12785, 40.0694, 0.699342959298616, -80.6904, -1.40831315475123),
(10916, '26030', 218, 58, 34729, 40.2261, 0.702077890236491, -80.6516, -1.40763596700146),
(10917, '26031', 218, 58, 29202, 40.0084, 0.698278308454899, -80.7239, -1.40889784005065),
(10918, '26032', 218, 58, 7428, 40.2049, 0.701707880435068, -80.5599, -1.40603550007738),
(10919, '26033', 218, 58, 806, 39.8266, 0.695105299874774, -80.5662, -1.40614545582026),
(10920, '26034', 218, 58, 8056, 40.6128, 0.708827078453953, -80.5618, -1.40606866133317),
(10921, '26035', 218, 58, 80420, 40.3659, 0.704517860530779, -80.5659, -1.4061402198325),
(10922, '26036', 218, 58, 1953, 39.9772, 0.697733765728277, -80.5603, -1.40604248139439),
(10923, '26037', 218, 58, 177219, 40.33, 0.703891287329313, -80.5833, -1.40644390712235),
(10924, '26038', 218, 58, 0, 39.9545, 0.697337575988074, -80.7427, -1.40922596195003),
(10925, '26039', 218, 58, 109385, 39.8338, 0.695230963580917, -80.6614, -1.40780700926815),
(10926, '26040', 218, 58, 110362, 39.9869, 0.697903062665721, -80.7314, -1.40902873974455),
(10927, '26041', 218, 58, 73561, 39.9219, 0.696768598651924, -80.737, -1.40912647818266),
(10928, '26047', 218, 58, 156707, 40.4924, 0.706725702034552, -80.5983, -1.40670570651015),
(10929, '26050', 218, 58, 4567, 40.6152, 0.708868966356001, -80.6021, -1.40677202902172),
(10930, '26055', 218, 58, 5236, 39.7203, 0.693250014879904, -80.7518, -1.40938478691196),
(10931, '26056', 218, 58, 177254, 40.5315, 0.707408125772082, -80.5805, -1.40639503790329),
(10932, '26058', 218, 58, 5833, 40.1851, 0.701362305243173, -80.6747, -1.40803913805867),
(10933, '26059', 218, 58, 74567, 40.0903, 0.699707733112283, -80.6213, -1.4071071322381),
(10934, '26060', 218, 58, 6504, 40.0942, 0.699775800953111, -80.5712, -1.40623272228286),
(10935, '26062', 218, 58, 177294, 40.4154, 0.705381798510516, -80.5653, -1.40612974785699),
(10936, '26070', 218, 58, 38797, 40.2755, 0.702940082886976, -80.5873, -1.40651372029243),
(10937, '26074', 218, 58, 12753, 40.1673, 0.701051636636318, -80.596, -1.40666556393735),
(10938, '26075', 218, 58, 26139, 40.192, 0.701482732961561, -80.6664, -1.40789427573075),
(10939, '26101', 218, 58, 23761, 39.2658, 0.685317493429589, -81.5363, -1.42307689489385),
(10940, '26102', 218, 58, 23761, 39.2406, 0.684877670458087, -81.518, -1.42275749964074),
(10941, '26103', 218, 58, 23761, 39.2483, 0.68501206081049, -81.5579, -1.42345388601228),
(10942, '26104', 218, 58, 23761, 39.2857, 0.685664813950736, -81.5261, -1.42289887131015),
(10943, '26105', 218, 58, 6557, 39.3248, 0.686347237688266, -81.5423, -1.42318161464897),
(10944, '26106', 218, 58, 23761, 39.3231, 0.686317567090982, -81.5027, -1.42249046426518),
(10945, '26120', 218, 58, 60906, 39.1709, 0.683661175969447, -81.4934, -1.42232814864475),
(10946, '26121', 218, 58, 60906, 39.1716, 0.683673393274211, -81.4933, -1.4223264033155),
(10947, '26133', 218, 58, 263, 39.1224, 0.68281469128223, -81.671, -1.42542785339629),
(10948, '26134', 218, 58, 303, 39.3777, 0.687270516862571, -81.2667, -1.41837148723048),
(10949, '26135', 218, 58, 108176, 39.4659, 0.68880989726283, -81.1083, -1.41560688569532),
(10950, '26136', 218, 58, 39380, 38.9865, 0.680442788828769, -81.139, -1.41614270177568),
(10951, '26137', 218, 58, 753, 38.9981, 0.680645247022001, -81.0682, -1.41490700866527),
(10952, '26138', 218, 58, 108368, 39.0293, 0.681189789748623, -81.1919, -1.41706598094998),
(10953, '26141', 218, 58, 35429, 38.9604, 0.679987257893999, -81.2601, -1.41825629549984),
(10954, '26142', 218, 58, 1986, 39.2042, 0.684242370610361, -81.4906, -1.42227927942569),
(10955, '26143', 218, 58, 8719, 39.0616, 0.681753531097017, -81.3987, -1.42067532184311),
(10956, '26146', 218, 58, 47287, 39.4901, 0.689232266941813, -81.0128, -1.41394009625966),
(10957, '26147', 218, 58, 47588, 38.9208, 0.679296107510209, -81.093, -1.41533985031976),
(10958, '26148', 218, 58, 110244, 39.0789, 0.682055473057612, -81.1887, -1.41701013041392),
(10959, '26149', 218, 58, 110422, 39.4937, 0.689295098794884, -80.9077, -1.41210575521582),
(10960, '26150', 218, 58, 60906, 39.1935, 0.684055620380398, -81.5212, -1.4228133501768),
(10961, '26151', 218, 58, 4417, 38.8909, 0.678774254063863, -81.1256, -1.41590882765591),
(10962, '26152', 218, 58, 96405, 39.0052, 0.680769165398892, -81.2285, -1.41770477145621),
(10963, '26155', 218, 58, 110635, 39.6587, 0.692174892060675, -80.8587, -1.41125054388234),
(10964, '26159', 218, 58, 110805, 39.606, 0.691255103544874, -80.9295, -1.41248623699275),
(10965, '26160', 218, 58, 4839, 38.968, 0.68011990291715, -81.427, -1.42116925002142),
(10966, '26161', 218, 58, 37655, 39.1809, 0.683835708894646, -81.2536, -1.41814284909846),
(10967, '26162', 218, 58, 110969, 39.5796, 0.690794336622348, -80.7768, -1.40982111922496),
(10968, '26164', 218, 58, 30930, 38.9546, 0.679886028797383, -81.7618, -1.4270126123571),
(10969, '26167', 218, 58, 11482, 39.5782, 0.69076990201282, -80.7471, -1.40930275643711),
(10970, '26169', 218, 58, 11639, 39.0755, 0.681996131863044, -81.5705, -1.42367379749803),
(10971, '26170', 218, 58, 24606, 39.3946, 0.687565477506158, -81.2015, -1.41723353255818),
(10972, '26173', 218, 58, 18065, 39.0178, 0.680989076884644, -81.6894, -1.42574899397866),
(10973, '26175', 218, 58, 111409, 39.5604, 0.690459233405965, -80.9993, -1.41370447681064),
(10974, '26178', 218, 58, 12002, 39.0681, 0.681866977498397, -81.0676, -1.41489653668976),
(10975, '26180', 218, 58, 12598, 39.1847, 0.683902031406222, -81.3647, -1.42008190989743),
(10976, '26181', 218, 58, 12671, 39.2516, 0.685069656675806, -81.6369, -1.42483269612136),
(10977, '26184', 218, 58, 6664, 39.3239, 0.686331529724998, -81.4226, -1.42109245553433),
(10978, '26186', 218, 58, 112061, 39.6677, 0.692331971693355, -80.6392, -1.40741954617421),
(10979, '26187', 218, 58, 6834, 39.3921, 0.687521844274858, -81.454, -1.42164048891946),
(10980, '26201', 218, 58, 108405, 38.9829, 0.680379956975698, -80.2247, -1.40018515642469),
(10981, '26202', 218, 58, 35876, 38.251, 0.667605892180351, -80.6418, -1.40746492473476),
(10982, '26203', 218, 58, 109106, 38.5434, 0.672709234913182, -80.5677, -1.40617163575904),
(10983, '26205', 218, 58, 101162, 38.3336, 0.669047534142498, -80.64, -1.40743350880823),
(10984, '26206', 218, 58, 108714, 38.3607, 0.669520518369789, -80.4442, -1.40401615413282),
(10985, '26208', 218, 58, 108458, 38.3786, 0.669832932305896, -80.5868, -1.40650499364617),
(10986, '26209', 218, 58, 133151, 38.3886, 0.670007465231095, -80.067, -1.3974327721943),
(10987, '26210', 218, 58, 18746, 38.9156, 0.679205350389105, -80.3042, -1.40157269318003),
(10988, '26215', 218, 58, 1620, 38.8374, 0.677840502914046, -80.3419, -1.40223068230803),
(10989, '26217', 218, 58, 26950, 38.5797, 0.673342789431656, -80.4222, -1.40363218169738),
(10990, '26218', 218, 58, 109286, 38.8363, 0.677821304292274, -80.2583, -1.40077158705337),
(10991, '26219', 218, 58, 109288, 38.8359, 0.677814322975266, -80.2588, -1.40078031369962),
(10992, '26222', 218, 58, 109509, 38.678, 0.675058448086367, -80.3967, -1.40318712273813),
(10993, '26224', 218, 58, 41301, 38.8948, 0.67884232190469, -79.8501, -1.39364715304672),
(10994, '26228', 218, 58, 109908, 38.7606, 0.676500090048514, -80.3732, -1.40277697036391),
(10995, '26229', 218, 58, 110191, 39.0109, 0.680868649166256, -80.3027, -1.40154651324125),
(10996, '26230', 218, 58, 11179, 38.6597, 0.674739052833252, -80.2026, -1.39979943866),
(10997, '26234', 218, 58, 111157, 38.7678, 0.676625753754658, -80.3029, -1.40155000389975),
(10998, '26236', 218, 58, 14578, 38.7181, 0.675758325116417, -80.3102, -1.40167741293515),
(10999, '26237', 218, 58, 111655, 38.835, 0.677798615011998, -80.1581, -1.39902276714287),
(11000, '26238', 218, 58, 31401, 39.0673, 0.681853014864381, -80.1197, -1.3983525607101),
(11001, '26241', 218, 58, 8723, 38.924, 0.679351958046273, -79.8537, -1.3937099848998),
(11002, '26250', 218, 58, 108154, 39.025, 0.681114740590787, -79.938, -1.39518129745923),
(11003, '26253', 218, 58, 7444, 38.8466, 0.678001073205229, -79.8707, -1.39400669087264),
(11004, '26254', 218, 58, 15293, 38.9485, 0.679779563713012, -79.6396, -1.38997323497128),
(11005, '26257', 218, 58, 35303, 38.9041, 0.679004637525126, -80.0027, -1.39631052548527),
(11006, '26259', 218, 58, 108783, 38.799, 0.67717029648128, -79.8963, -1.39445349516115),
(11007, '26260', 218, 58, 20476, 39.1304, 0.682954317622389, -79.4685, -1.38698697662111),
(11008, '26261', 218, 58, 24311, 38.2234, 0.667124181306801, -80.5405, -1.40569690620249),
(11009, '26263', 218, 58, 8607, 38.9439, 0.67969927856742, -79.4357, -1.38641450862646),
(11010, '26264', 218, 58, 15838, 38.6492, 0.674555793261792, -79.774, -1.39231895748596),
(11011, '26266', 218, 58, 111809, 38.4305, 0.670738758187681, -80.5017, -1.40501971845272);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(11012, '26267', 218, 58, 109072, 38.9421, 0.679667862640884, -80.0907, -1.39784641522702),
(11013, '26268', 218, 58, 65028, 38.8188, 0.677515871673175, -79.705, -1.39111468030208),
(11014, '26269', 218, 58, 164, 39.1279, 0.682910684391089, -79.601, -1.38929953788001),
(11015, '26270', 218, 58, 102621, 38.9165, 0.679221058352373, -79.5327, -1.38810747800089),
(11016, '26271', 218, 58, 21835, 39.0659, 0.681828580254853, -79.6118, -1.38948803343922),
(11017, '26273', 218, 58, 109768, 38.6348, 0.674304465849505, -79.9551, -1.39547974876132),
(11018, '26275', 218, 58, 109892, 39.0363, 0.681311962796262, -79.956, -1.39549545672459),
(11019, '26276', 218, 58, 95298, 39.0195, 0.681018747481927, -79.752, -1.39193498505052),
(11020, '26278', 218, 58, 110236, 38.813, 0.677414642576559, -80.0301, -1.39678874570031),
(11021, '26280', 218, 58, 429, 38.7304, 0.675973000614412, -80.0256, -1.39671020588397),
(11022, '26282', 218, 58, 110505, 38.5135, 0.672187381466836, -80.1634, -1.39911526959322),
(11023, '26283', 218, 58, 4299, 39.1137, 0.682662847637306, -79.7857, -1.39252316100844),
(11024, '26285', 218, 58, 4646, 38.9314, 0.67948111241092, -79.9653, -1.39565777234502),
(11025, '26287', 218, 58, 4894, 39.0955, 0.682345197713443, -79.679, -1.39066089469656),
(11026, '26288', 218, 58, 111948, 38.477, 0.671550336289858, -80.4094, -1.40340877955313),
(11027, '26289', 218, 58, 152005, 39.0195, 0.681018747481927, -79.5652, -1.38867471000779),
(11028, '26291', 218, 58, 0, 38.3889, 0.670012701218851, -80.067, -1.3974327721943),
(11029, '26292', 218, 58, 6310, 39.1439, 0.683189937071408, -79.4983, -1.38750708473821),
(11030, '26293', 218, 58, 111817, 38.7984, 0.677159824505768, -79.9244, -1.39494393268096),
(11031, '26294', 218, 58, 6505, 38.5206, 0.672311299843728, -80.0375, -1.39691790006496),
(11032, '26296', 218, 58, 112039, 38.7659, 0.67659259249887, -79.601, -1.38929953788001),
(11033, '26298', 218, 58, 108181, 38.4741, 0.67149972174155, -80.3328, -1.4020718573461),
(11034, '26301', 218, 58, 26799, 39.2751, 0.685479809050025, -80.3382, -1.40216610512571),
(11035, '26302', 218, 58, 26799, 39.2685, 0.685364617319393, -80.3092, -1.40165995964263),
(11036, '26306', 218, 58, 26799, 39.2805, 0.685574056829633, -80.3318, -1.40205440405358),
(11037, '26320', 218, 58, 7066, 39.426, 0.688113510891284, -80.827, -1.41069727450946),
(11038, '26321', 218, 58, 107964, 39.0903, 0.682254440592339, -80.4707, -1.4044786663846),
(11039, '26323', 218, 58, 107989, 39.2578, 0.68517786708943, -80.2896, -1.40131787510924),
(11040, '26325', 218, 58, 13306, 39.0871, 0.682198590056276, -80.8973, -1.41192424097361),
(11041, '26327', 218, 58, 7416, 39.1323, 0.682987478878177, -80.9299, -1.41249321830976),
(11042, '26328', 218, 58, 34856, 39.2633, 0.68527386019829, -80.7355, -1.40910029824388),
(11043, '26330', 218, 58, 1130, 39.2911, 0.685759061730344, -80.2544, -1.40070351921254),
(11044, '26332', 218, 58, 15330, 39.2952, 0.685830620229676, -80.5146, -1.40524486592623),
(11045, '26334', 218, 58, 77937, 39.2205, 0.684526859278436, -80.1498, -1.39887790481495),
(11046, '26335', 218, 58, 1248, 38.6952, 0.67535864471771, -80.6538, -1.407674364245),
(11047, '26337', 218, 58, 1288, 39.2339, 0.684760733398203, -81.151, -1.41635214128592),
(11048, '26338', 218, 58, 1304, 39.0967, 0.682366141664467, -80.6107, -1.40692212733739),
(11049, '26339', 218, 58, 655, 39.4234, 0.688068132330733, -80.6212, -1.40710538690885),
(11050, '26342', 218, 58, 108716, 39.0074, 0.680807562642436, -80.8677, -1.41140762351502),
(11051, '26343', 218, 58, 1860, 38.8437, 0.677950458656921, -80.407, -1.40336689165108),
(11052, '26346', 218, 58, 64494, 39.2998, 0.685910905375267, -81.0581, -1.41473073041082),
(11053, '26347', 218, 58, 16031, 39.2717, 0.685420467855457, -80.1251, -1.39844680848971),
(11054, '26348', 218, 58, 2511, 39.4674, 0.68883607720161, -80.5242, -1.40541241753442),
(11055, '26349', 218, 58, 9041, 39.2258, 0.684619361728792, -80.1309, -1.39854803758632),
(11056, '26350', 218, 58, 94473, 38.8789, 0.678564814553623, -80.7169, -1.40877566700301),
(11057, '26351', 218, 58, 2748, 38.9359, 0.67955965222726, -80.8351, -1.41083864617887),
(11058, '26354', 218, 58, 27298, 39.3408, 0.686626490368585, -80.0223, -1.39665261001866),
(11059, '26361', 218, 58, 36233, 39.3682, 0.687104710583632, -80.3181, -1.40181529394606),
(11060, '26362', 218, 58, 2996, 39.2091, 0.684327891743709, -81.0509, -1.41460506670467),
(11061, '26366', 218, 58, 3032, 39.281, 0.685582783475893, -80.3426, -1.4022428996128),
(11062, '26369', 218, 58, 3068, 39.3327, 0.686485118699174, -80.3356, -1.40212072656516),
(11063, '26372', 218, 58, 65757, 38.9582, 0.679948860650455, -80.3617, -1.40257625749993),
(11064, '26374', 218, 58, 3320, 39.4432, 0.688413707522627, -79.8894, -1.39433306744276),
(11065, '26375', 218, 58, 60378, 39.2795, 0.685556603537113, -80.5767, -1.40632871539172),
(11066, '26376', 218, 58, 30148, 38.7507, 0.676327302452567, -80.4778, -1.40460258476149),
(11067, '26377', 218, 58, 3392, 39.4985, 0.68937887459898, -80.6418, -1.40746492473476),
(11068, '26378', 218, 58, 109824, 39.1161, 0.682704735539354, -80.4343, -1.40384336653687),
(11069, '26384', 218, 58, 33091, 38.9635, 0.680041363100811, -80.7173, -1.40878264832002),
(11070, '26385', 218, 58, 36973, 39.1555, 0.68339239526464, -80.3445, -1.40227606086858),
(11071, '26386', 218, 58, 110224, 39.3777, 0.687270516862571, -80.3513, -1.40239474325772),
(11072, '26404', 218, 58, 4131, 39.347, 0.686734700782209, -80.3116, -1.40170184754468),
(11073, '26405', 218, 58, 110485, 39.2245, 0.684596672448516, -79.9073, -1.39464548137886),
(11074, '26407', 218, 58, 49687, 39.3621, 0.68699824549926, -80.9104, -1.41215287910562),
(11075, '26408', 218, 58, 27966, 39.2003, 0.684174302769533, -80.2695, -1.40096706392959),
(11076, '26410', 218, 58, 4565, 39.4024, 0.687701613187814, -79.8283, -1.39326667126979),
(11077, '26411', 218, 58, 110637, 39.1764, 0.683757169078307, -80.7134, -1.40871458047919),
(11078, '26412', 218, 58, 10999, 38.8904, 0.678765527417603, -80.5691, -1.40619607036856),
(11079, '26415', 218, 58, 56840, 39.2854, 0.68565957796298, -80.9666, -1.41313375414524),
(11080, '26416', 218, 58, 89865, 39.1514, 0.683320836765308, -80.0401, -1.39696327862551),
(11081, '26419', 218, 58, 557, 39.5683, 0.690597114416872, -80.6503, -1.40761327772118),
(11082, '26421', 218, 58, 11428, 39.1907, 0.684006751161342, -80.9138, -1.41221222030019),
(11083, '26422', 218, 58, 24299, 39.2886, 0.685715428499044, -80.4349, -1.40385383851239),
(11084, '26424', 218, 58, 5556, 39.2689, 0.685371598636401, -80.1636, -1.39911876025173),
(11085, '26425', 218, 58, 111220, 39.2247, 0.68460016310702, -79.6617, -1.39035895273597),
(11086, '26426', 218, 58, 126, 39.2834, 0.68562467137794, -80.5607, -1.4060494627114),
(11087, '26430', 218, 58, 74203, 38.8903, 0.678763782088351, -80.7424, -1.40922072596227),
(11088, '26431', 218, 58, 111381, 39.3926, 0.687530570921118, -80.2989, -1.40148019072967),
(11089, '26434', 218, 58, 5825, 39.3981, 0.687626564029978, -80.7652, -1.40961866103172),
(11090, '26435', 218, 58, 5863, 39.2835, 0.685626416707192, -80.0692, -1.39747116943784),
(11091, '26436', 218, 58, 61815, 39.2414, 0.684891633092103, -80.8083, -1.41037089793933),
(11092, '26437', 218, 58, 5916, 39.504, 0.68947486770784, -80.5659, -1.4061402198325),
(11093, '26438', 218, 58, 111493, 39.3463, 0.686722483477445, -80.3177, -1.40180831262905),
(11094, '26440', 218, 58, 351, 39.331, 0.68645544810189, -79.9037, -1.39458264952579),
(11095, '26443', 218, 58, 199, 39.0839, 0.682142739520212, -80.7569, -1.40947379870381),
(11096, '26444', 218, 58, 31326, 39.3347, 0.686520025284214, -79.7607, -1.39208682869544),
(11097, '26447', 218, 58, 25781, 38.8493, 0.678048197095033, -80.5036, -1.40505287970851),
(11098, '26448', 218, 58, 721, 39.4092, 0.687820295576949, -80.4843, -1.40471603116287),
(11099, '26451', 218, 58, 112663, 39.2026, 0.684214445342329, -80.4036, -1.40330755045651),
(11100, '26452', 218, 58, 6746, 39.0431, 0.681430645185398, -80.468, -1.4044315424948),
(11101, '26456', 218, 58, 28946, 39.2955, 0.685835856217432, -80.7754, -1.40979668461543),
(11102, '26461', 218, 58, 112085, 39.2922, 0.685778260352116, -80.3963, -1.40318014142112),
(11103, '26463', 218, 58, 6967, 39.4349, 0.688268845194712, -80.3531, -1.40242615918426),
(11104, '26501', 218, 58, 17178, 39.6331, 0.691728087772165, -80.0871, -1.39778358337395),
(11105, '26502', 218, 58, 17178, 39.6464, 0.69196021656268, -79.9222, -1.39490553543741),
(11106, '26503', 218, 58, 17178, 39.6359, 0.69177695699122, -79.9499, -1.39538899164021),
(11107, '26504', 218, 58, 17178, 39.67, 0.692372114266151, -79.9754, -1.39583405059947),
(11108, '26505', 218, 58, 17178, 39.637, 0.691796155612992, -79.9528, -1.39543960618852),
(11109, '26506', 218, 58, 17178, 39.618, 0.691464543055114, -79.9731, -1.39579390802668),
(11110, '26507', 218, 58, 17178, 39.6155, 0.691420909823814, -79.914, -1.39476241843875),
(11111, '26508', 218, 58, 17178, 39.5894, 0.690965378889043, -79.8952, -1.39443429653937),
(11112, '26519', 218, 58, 107933, 39.4929, 0.689281136160869, -79.64, -1.38998021628828),
(11113, '26520', 218, 58, 108026, 39.4951, 0.689319533404412, -79.8148, -1.39303105182077),
(11114, '26521', 218, 58, 19311, 39.6967, 0.692838117176433, -80.234, -1.40034747204513),
(11115, '26522', 218, 58, 1050, 39.5971, 0.691099769241447, -80.0154, -1.39653218230027),
(11116, '26524', 218, 58, 108353, 39.5428, 0.690152055457614, -79.8009, -1.39278845105474),
(11117, '26525', 218, 58, 108391, 39.6438, 0.691914838002128, -79.6267, -1.38974808749777),
(11118, '26527', 218, 58, 19837, 39.6634, 0.692256922535519, -80.0587, -1.39728790986638),
(11119, '26529', 218, 58, 108690, 39.6553, 0.692115550866107, -80.2344, -1.40035445336214),
(11120, '26531', 218, 58, 108837, 39.607, 0.691272556837394, -79.8918, -1.39437495534481),
(11121, '26533', 218, 58, 109129, 39.6999, 0.692893967712497, -80.0689, -1.39746593345009),
(11122, '26534', 218, 58, 55048, 39.6437, 0.691913092672876, -79.9845, -1.3959928755614),
(11123, '26535', 218, 58, 32727, 39.654, 0.692092861585832, -79.5306, -1.3880708260866),
(11124, '26537', 218, 58, 78562, 39.4721, 0.688918107676454, -79.6818, -1.39070976391562),
(11125, '26541', 218, 58, 110255, 39.7072, 0.693021376747892, -79.9932, -1.39614471920633),
(11126, '26542', 218, 58, 66665, 39.5828, 0.690850187158412, -79.7997, -1.39276750710372),
(11127, '26543', 218, 58, 11002, 39.7, 0.692895713041749, -80.0698, -1.39748164141336),
(11128, '26544', 218, 58, 110859, 39.7107, 0.693082463271712, -80.1603, -1.39906116438641),
(11129, '26546', 218, 58, 111013, 39.7, 0.692895713041749, -80.0696, -1.39747815075485),
(11130, '26547', 218, 58, 33736, 39.5133, 0.689637183328275, -79.8166, -1.39306246774731),
(11131, '26554', 218, 58, 27132, 39.477, 0.689003628809801, -80.1518, -1.39891281139999),
(11132, '26555', 218, 58, 27132, 39.4713, 0.688904145042438, -80.1507, -1.39889361277822),
(11133, '26559', 218, 58, 108096, 39.5013, 0.689427743818036, -80.1734, -1.39928980251842),
(11134, '26560', 218, 58, 150, 39.5358, 0.690029882409974, -80.1479, -1.39884474355916),
(11135, '26561', 218, 58, 71824, 39.591, 0.690993304157075, -80.5722, -1.40625017557538),
(11136, '26562', 218, 58, 7796, 39.6692, 0.692358151632135, -80.3974, -1.40319934004289),
(11137, '26563', 218, 58, 1366, 39.4801, 0.689057734016613, -80.2733, -1.40103338644116),
(11138, '26566', 218, 58, 8175, 39.4351, 0.688272335853216, -80.1318, -1.39856374554959),
(11139, '26568', 218, 58, 2311, 39.4264, 0.688120492208292, -80.3466, -1.40231271278288),
(11140, '26570', 218, 58, 500, 39.6242, 0.691572753468737, -80.2618, -1.40083267357718),
(11141, '26571', 218, 58, 8849, 39.5148, 0.689663363267055, -80.25, -1.40062672472545),
(11142, '26572', 218, 58, 109262, 39.4792, 0.689042026053345, -80.3104, -1.40168090359365),
(11143, '26574', 218, 58, 2812, 39.5568, 0.690396401552893, -80.1783, -1.39937532365177),
(11144, '26575', 218, 58, 109754, 39.6958, 0.692822409213165, -80.4696, -1.40445946776283),
(11145, '26576', 218, 58, 36551, 39.4971, 0.689354439989452, -80.2567, -1.40074366178533),
(11146, '26578', 218, 58, 109970, 39.4469, 0.688478284704951, -80.1765, -1.39934390772523),
(11147, '26581', 218, 58, 3815, 39.6653, 0.692290083791307, -80.575, -1.40629904479443),
(11148, '26582', 218, 58, 37042, 39.5287, 0.689905964033083, -80.3444, -1.40227431553933),
(11149, '26585', 218, 58, 56223, 39.6134, 0.691384257909522, -80.4396, -1.40393586898723),
(11150, '26586', 218, 58, 0, 39.5203, 0.689759356375915, -80.1126, -1.39822864233321),
(11151, '26587', 218, 58, 111033, 39.5221, 0.689790772302451, -80.2987, -1.40147670007117),
(11152, '26588', 218, 58, 111144, 39.5307, 0.689940870618122, -80.1228, -1.39840666591691),
(11153, '26589', 218, 58, 111883, 39.6401, 0.691850260819804, -80.3277, -1.40198284555425),
(11154, '26590', 218, 58, 111911, 39.7046, 0.692975998187341, -80.315, -1.40176118873925),
(11155, '26591', 218, 58, 31567, 39.4545, 0.688610929728103, -80.2984, -1.40147146408341),
(11156, '26601', 218, 58, 12229, 38.6718, 0.674950237672743, -80.6871, -1.40825555888592),
(11157, '26610', 218, 58, 108236, 38.4766, 0.67154335497285, -80.7586, -1.40950346930109),
(11158, '26611', 218, 58, 1435, 38.84, 0.677885881474598, -80.8468, -1.41104284970135),
(11159, '26612', 218, 58, 26746, 38.6226, 0.674091535680762, -80.5685, -1.40618559839305),
(11160, '26615', 218, 58, 156, 38.8407, 0.677898098779362, -80.7225, -1.40887340544112),
(11161, '26617', 218, 58, 108862, 38.4686, 0.671403728632691, -80.8746, -1.41152805123341),
(11162, '26618', 218, 58, 54613, 38.6617, 0.674773959418292, -80.986, -1.41347234802013),
(11163, '26619', 218, 58, 29747, 38.7997, 0.677182513786044, -80.766, -1.40963262366574),
(11164, '26621', 218, 58, 2487, 38.7366, 0.676081211028036, -80.6099, -1.40690816470338),
(11165, '26623', 218, 58, 109268, 38.6288, 0.674199746094385, -80.8776, -1.41158041111097),
(11166, '26624', 218, 58, 87208, 38.684, 0.675163167841486, -80.7722, -1.40974083407936),
(11167, '26627', 218, 58, 109602, 38.7551, 0.676404096939654, -80.6513, -1.4076307310137),
(11168, '26629', 218, 58, 110132, 38.5647, 0.673080990043857, -80.7095, -1.40864651263836),
(11169, '26631', 218, 58, 37352, 38.7743, 0.676739200156037, -80.5847, -1.40646834173187),
(11170, '26634', 218, 58, 11143, 38.8077, 0.677322140126203, -80.9147, -1.41222792826346),
(11171, '26636', 218, 58, 5546, 38.7815, 0.676864863862181, -80.8981, -1.41193820360762),
(11172, '26638', 218, 58, 111385, 38.7656, 0.676587356511114, -80.9934, -1.41360150238478),
(11173, '26639', 218, 58, 111565, 38.5708, 0.673187455128229, -80.9024, -1.41201325276546),
(11174, '26641', 218, 58, 112664, 38.6863, 0.675203310414282, -80.8733, -1.41150536195313),
(11175, '26651', 218, 58, 28728, 38.2836, 0.668174869516501, -80.8442, -1.4109974711408),
(11176, '26656', 218, 58, 62858, 38.2697, 0.667932268750474, -81.1313, -1.41600831142328),
(11177, '26660', 218, 58, 7856, 38.3255, 0.668906162473087, -80.7061, -1.4085871714438),
(11178, '26662', 218, 58, 108479, 38.2605, 0.66777169845929, -80.7348, -1.40908808093912),
(11179, '26667', 218, 58, 112641, 38.2488, 0.667567494936807, -81.0145, -1.41396976685695),
(11180, '26671', 218, 58, 47429, 38.2973, 0.668413979624024, -80.966, -1.41312328216973),
(11181, '26674', 218, 58, 109858, 38.1902, 0.666544731995138, -81.1243, -1.41588613837564),
(11182, '26675', 218, 58, 109942, 38.2354, 0.66733362081704, -80.936, -1.41259968339413),
(11183, '26676', 218, 58, 110073, 38.1272, 0.665445174566382, -80.7383, -1.40914916746294),
(11184, '26678', 218, 58, 73581, 38.1804, 0.666373689728443, -80.9067, -1.4120883019233),
(11185, '26679', 218, 58, 4385, 38.1934, 0.666600582531202, -80.8035, -1.41028712213524),
(11186, '26680', 218, 58, 110598, 38.1094, 0.665134505959527, -80.8893, -1.41178461463345),
(11187, '26681', 218, 58, 110623, 38.1972, 0.666666905042778, -80.6802, -1.40813513116753),
(11188, '26684', 218, 58, 110965, 38.1455, 0.665764569819497, -80.8833, -1.41167989487833),
(11189, '26690', 218, 58, 57811, 38.2762, 0.668045715151854, -81.0675, -1.4148947913605),
(11190, '26691', 218, 58, 25513, 38.3934, 0.670091241035191, -80.6741, -1.40802866608316),
(11191, '26704', 218, 58, 7193, 39.3001, 0.685916141363023, -78.5931, -1.37170836434916),
(11192, '26705', 218, 58, 474, 39.2917, 0.685769533705856, -79.5992, -1.38926812195347),
(11193, '26707', 218, 58, 360, 38.9864, 0.680441043499517, -79.1469, -1.3813739977467),
(11194, '26710', 218, 58, 1239, 39.366, 0.687066313340088, -78.9122, -1.37727770999227),
(11195, '26711', 218, 58, 108484, 39.2707, 0.685403014562937, -78.4967, -1.37002586695023),
(11196, '26714', 218, 58, 20544, 39.1798, 0.683816510272874, -78.6385, -1.37250074382956),
(11197, '26716', 218, 58, 35719, 39.29, 0.685739863108572, -79.5108, -1.38772525089471),
(11198, '26717', 218, 58, 101692, 39.3595, 0.686952866938708, -79.1653, -1.38169513832907),
(11199, '26719', 218, 58, 109247, 39.4811, 0.689075187309133, -78.7737, -1.37486042897826),
(11200, '26720', 218, 58, 109426, 39.2446, 0.684947483628167, -79.3515, -1.38494494139628),
(11201, '26722', 218, 58, 13846, 39.4972, 0.689356185318704, -78.6276, -1.37231050294109),
(11202, '26726', 218, 58, 48647, 39.4381, 0.688324695730776, -78.9803, -1.37846627921288),
(11203, '26731', 218, 58, 110005, 39.1613, 0.683493624361255, -79.0451, -1.37959725256817),
(11204, '26734', 218, 58, 17081, 39.2353, 0.684785168007731, -79.0951, -1.38046991719417),
(11205, '26739', 218, 58, 110561, 39.2124, 0.684385487609025, -79.2528, -1.38322230142456),
(11206, '26743', 218, 58, 110625, 39.3218, 0.686294877810706, -79.0451, -1.37959725256817),
(11207, '26750', 218, 58, 4996, 39.5097, 0.689574351475204, -78.9967, -1.3787525132102),
(11208, '26753', 218, 58, 111112, 39.6407, 0.691860732795316, -78.7728, -1.37484472101499),
(11209, '26755', 218, 58, 17799, 39.1794, 0.683809528955866, -78.6939, -1.37346765623517),
(11210, '26757', 218, 58, 97626, 39.3453, 0.686705030184925, -78.7575, -1.37457768563943),
(11211, '26761', 218, 58, 111354, 39.2695, 0.685382070611913, -78.7016, -1.37360204658757),
(11212, '26763', 218, 58, 349, 39.4669, 0.68882735055535, -78.6999, -1.37357237599029),
(11213, '26764', 218, 58, 111687, 39.4461, 0.688464322070935, -79.5436, -1.38829771888936),
(11214, '26767', 218, 58, 112060, 39.6146, 0.691405201860546, -78.7624, -1.37466320677278),
(11215, '26801', 218, 58, 7221, 39.0684, 0.681872213486153, -78.7862, -1.37507859513476),
(11216, '26802', 218, 58, 13415, 38.6402, 0.674398713629113, -79.2022, -1.38233916482305),
(11217, '26804', 218, 58, 29475, 38.6153, 0.673964126645366, -79.554, -1.38847923313157),
(11218, '26807', 218, 58, 2595, 38.6191, 0.674030449156942, -79.3846, -1.38552264537869),
(11219, '26808', 218, 58, 109651, 39.2109, 0.684359307670245, -78.4365, -1.36897517874053),
(11220, '26810', 218, 58, 36972, 38.9104, 0.679114593268002, -78.8016, -1.37534737583956),
(11221, '26812', 218, 58, 110322, 38.8785, 0.678557833236615, -78.8927, -1.37693737078813),
(11222, '26814', 218, 58, 5429, 38.6991, 0.675426712558538, -79.4957, -1.38746170617766),
(11223, '26815', 218, 58, 12174, 38.4969, 0.671897656811005, -79.2735, -1.38358358457972),
(11224, '26817', 218, 58, 44880, 39.376, 0.687240846265287, -78.3868, -1.36810775010229),
(11225, '26818', 218, 58, 8891, 39.0453, 0.681469042428942, -78.9955, -1.37873156925918),
(11226, '26823', 218, 58, 108488, 39.1361, 0.683053801389753, -78.4846, -1.36981468211074),
(11227, '26824', 218, 58, 27584, 39.3295, 0.68642926816311, -78.8288, -1.37582210539611),
(11228, '26833', 218, 58, 4063, 39.0919, 0.682282365860371, -79.2026, -1.38234614614006),
(11229, '26836', 218, 58, 4307, 39.056, 0.681655792658905, -78.9712, -1.37830745425095),
(11230, '26838', 218, 58, 96212, 38.8035, 0.67724883629762, -79.0657, -1.37995679039408),
(11231, '26845', 218, 58, 50065, 39.1475, 0.68325276892448, -78.9522, -1.37797584169307),
(11232, '26847', 218, 58, 14402, 38.9941, 0.680575433851921, -79.1244, -1.380981298665),
(11233, '26851', 218, 58, 111919, 39.0757, 0.681999622521548, -78.5967, -1.37177119620223),
(11234, '26852', 218, 58, 111015, 39.2642, 0.685289568161558, -78.9007, -1.37707699712829),
(11235, '26855', 218, 58, 108442, 38.9502, 0.679809234310295, -79.2722, -1.38356089529945),
(11236, '26865', 218, 58, 112167, 39.1837, 0.683884578113702, -78.4956, -1.37000666832846),
(11237, '26866', 218, 58, 111807, 38.7955, 0.67710920995746, -79.2589, -1.38332876650893),
(11238, '26884', 218, 58, 111339, 38.8435, 0.677946967998417, -79.3824, -1.38548424813515),
(11239, '26886', 218, 58, 110763, 38.8181, 0.677503654368411, -79.4777, -1.3871475469123),
(11240, '27006', 218, 33, 7029, 36.0053, 0.628411033168314, -80.4329, -1.40381893192735),
(11241, '27007', 218, 33, 18891, 36.3814, 0.634975216485065, -80.6004, -1.40674235842444),
(11242, '27009', 218, 33, 53395, 36.2345, 0.632411327813885, -80.0822, -1.3976980622406),
(11243, '27010', 218, 33, 62902, 36.163, 0.631163417398709, -80.3693, -1.40270890252308),
(11244, '27011', 218, 33, 29261, 36.1383, 0.630732321073467, -80.6564, -1.40771974280555),
(11245, '27012', 218, 33, 63723, 36.0324, 0.628884017395605, -80.3956, -1.40316792411635),
(11246, '27013', 218, 33, 1620, 35.7474, 0.623909829027421, -80.6761, -1.4080635726682),
(11247, '27014', 218, 33, 63895, 35.8119, 0.625035566394957, -80.558, -1.40600233882159),
(11248, '27016', 218, 33, 64114, 36.4677, 0.636481435629536, -80.2522, -1.40066512196899),
(11249, '27017', 218, 33, 35597, 36.3911, 0.635144513422508, -80.7168, -1.40877392167376),
(11250, '27018', 218, 33, 2157, 36.2011, 0.631828387843719, -80.528, -1.40547874004599),
(11251, '27019', 218, 33, 65006, 36.2473, 0.632634729958141, -80.2245, -1.40018166576619),
(11252, '27020', 218, 33, 65346, 36.114, 0.630308206065232, -80.8141, -1.41047212703595),
(11253, '27021', 218, 33, 9863, 36.2872, 0.633331116329686, -80.3586, -1.40252215229312),
(11254, '27022', 218, 33, 66284, 36.5142, 0.637293013731714, -80.2162, -1.40003680343828),
(11255, '27023', 218, 33, 10065, 36.0975, 0.630020226738653, -80.4202, -1.40359727511234),
(11256, '27024', 218, 33, 66512, 36.4971, 0.636994562429622, -80.8478, -1.41106030299387),
(11257, '27025', 218, 33, 3938, 36.3893, 0.635113097495973, -79.9682, -1.39570838689333),
(11258, '27027', 218, 33, 66685, 36.4151, 0.635563392442987, -79.9719, -1.39577296407565),
(11259, '27028', 218, 33, 66895, 35.8985, 0.626547021527184, -80.5561, -1.4059691775658),
(11260, '27030', 218, 33, 23207, 36.4935, 0.636931730576551, -80.6283, -1.40722930528574),
(11261, '27031', 218, 33, 6780, 36.429, 0.635805993209014, -80.6633, -1.40784017052394),
(11262, '27040', 218, 33, 67712, 36.1668, 0.631229739910285, -80.3794, -1.40288518077753),
(11263, '27041', 218, 33, 67739, 36.4511, 0.636191710973705, -80.4908, -1.40482947756425),
(11264, '27042', 218, 33, 67749, 36.3487, 0.634404493819663, -80.0575, -1.39726696591536),
(11265, '27043', 218, 33, 11234, 36.2589, 0.632837188151372, -80.4426, -1.40398822886479),
(11266, '27045', 218, 33, 68443, 36.2282, 0.63230137207101, -80.2934, -1.40138419762082),
(11267, '27046', 218, 33, 127, 36.4923, 0.636910786625527, -80.0892, -1.39782023528824),
(11268, '27047', 218, 33, 5853, 36.301, 0.633571971766462, -80.5763, -1.40632173407471),
(11269, '27048', 218, 33, 61897, 36.4624, 0.63638893317918, -79.9069, -1.39463850006186),
(11270, '27049', 218, 33, 69429, 36.4972, 0.636996307758874, -80.6326, -1.40730435444358),
(11271, '27050', 218, 33, 69431, 36.2335, 0.632393874521365, -80.3959, -1.40317316010411),
(11272, '27051', 218, 33, 38727, 36.1757, 0.631385074213713, -80.1629, -1.39910654294696),
(11273, '27052', 218, 33, 52472, 36.2945, 0.633458525365082, -80.1365, -1.39864577602444),
(11274, '27053', 218, 33, 723, 36.434, 0.635893259671614, -80.3202, -1.40185194586035),
(11275, '27054', 218, 33, 792, 35.7902, 0.624656829947275, -80.6105, -1.40691863667889),
(11276, '27055', 218, 33, 70414, 36.1334, 0.630646799940119, -80.6635, -1.40784366118245),
(11277, '27094', 218, 33, 68443, 36.237, 0.632454961045185, -80.2993, -1.40148717204668),
(11278, '27098', 218, 33, 68443, 36.227, 0.632280428119986, -80.3036, -1.40156222120452),
(11279, '27099', 218, 33, 68443, 36.2275, 0.632289154766246, -80.3044, -1.40157618383853),
(11280, '27101', 218, 33, 70288, 36.1036, 0.630126691823025, -80.2155, -1.40002458613351),
(11281, '27102', 218, 33, 70288, 36.1108, 0.630252355529168, -80.2002, -1.39975755075796),
(11282, '27103', 218, 33, 70288, 36.0658, 0.629466957365771, -80.3181, -1.40181529394606),
(11283, '27104', 218, 33, 70288, 36.0958, 0.629990556141369, -80.3243, -1.40192350435968),
(11284, '27105', 218, 33, 70288, 36.151, 0.63095397788847, -80.2351, -1.4003666706669),
(11285, '27106', 218, 33, 70288, 36.1387, 0.630739302390475, -80.3159, -1.40177689670251),
(11286, '27107', 218, 33, 70288, 36.0613, 0.629388417549431, -80.1836, -1.39946782610213),
(11287, '27108', 218, 33, 70288, 36.0889, 0.629870128422982, -80.2472, -1.40057785550639),
(11288, '27109', 218, 33, 70288, 36.1241, 0.630484484319684, -80.2853, -1.4012428259514),
(11289, '27110', 218, 33, 70288, 36.1023, 0.630104002542749, -80.2293, -1.40026544157029),
(11290, '27111', 218, 33, 70288, 36.0974, 0.630018481409401, -80.2437, -1.40051676898257),
(11291, '27113', 218, 33, 70288, 36.1004, 0.630070841286961, -80.2461, -1.40055865688462),
(11292, '27114', 218, 33, 70288, 36.1006, 0.630074331945465, -80.2463, -1.40056214754313),
(11293, '27115', 218, 33, 70288, 36.0985, 0.630037680031173, -80.2488, -1.40060578077443),
(11294, '27116', 218, 33, 70288, 36.0976, 0.630021972067905, -80.2451, -1.4005412035921),
(11295, '27117', 218, 33, 70288, 36.0782, 0.629683378193018, -80.2378, -1.40041379455671),
(11296, '27120', 218, 33, 70288, 36.1067, 0.630180797029837, -80.2427, -1.40049931569005),
(11297, '27127', 218, 33, 70288, 36.0461, 0.629123127503128, -80.2648, -1.40088503345474),
(11298, '27130', 218, 33, 70288, 36.0591, 0.629350020305887, -80.32, -1.40184845520185),
(11299, '27150', 218, 33, 70288, 36.1025, 0.630107493201253, -80.2069, -1.39987448781784),
(11300, '27151', 218, 33, 70288, 36.1056, 0.630161598408065, -80.2037, -1.39981863728178),
(11301, '27152', 218, 33, 70288, 36.1029, 0.630114474518261, -80.2066, -1.39986925183008),
(11302, '27155', 218, 33, 70288, 36.1048, 0.630147635774049, -80.2044, -1.39983085458654),
(11303, '27156', 218, 33, 70288, 36.102, 0.630098766554993, -80.2071, -1.39987797847634),
(11304, '27157', 218, 33, 70288, 36.0595, 0.629357001622895, -80.3202, -1.40185194586035),
(11305, '27198', 218, 33, 70288, 36.1027, 0.630110983859757, -80.2221, -1.40013977786414),
(11306, '27199', 218, 33, 70288, 36.1001, 0.630065605299205, -80.2492, -1.40061276209143),
(11307, '27201', 218, 33, 62455, 36.0299, 0.628840384164305, -79.4855, -1.38728368259395),
(11308, '27202', 218, 33, 62505, 36.187, 0.631582296419188, -79.506, -1.38764147509061),
(11309, '27203', 218, 33, 62596, 35.7117, 0.623286746484459, -79.814, -1.39301708918675),
(11310, '27204', 218, 33, 62596, 35.6654, 0.622478659040786, -79.8049, -1.39285826422482),
(11311, '27205', 218, 33, 62596, 35.7116, 0.623285001155207, -79.814, -1.39301708918675),
(11312, '27207', 218, 33, 53, 35.6957, 0.62300749380414, -79.5076, -1.38766940035864),
(11313, '27208', 218, 33, 15192, 35.5747, 0.620895645409227, -79.5214, -1.38791025579542),
(11314, '27209', 218, 33, 7495, 35.359, 0.617130970212675, -79.7902, -1.39260170082478),
(11315, '27212', 218, 33, 63002, 36.5301, 0.637570521082781, -79.304, -1.38411591000158),
(11316, '27213', 218, 33, 63051, 35.647, 0.622157518458419, -79.4147, -1.38604798948354),
(11317, '27214', 218, 33, 63240, 36.2056, 0.631906927660059, -79.7022, -1.39106581108302),
(11318, '27215', 218, 33, 1239, 36.0829, 0.629765408667862, -79.454, -1.38673390387957),
(11319, '27216', 218, 33, 1239, 36.0842, 0.629788097948138, -79.4128, -1.38601482822775),
(11320, '27217', 218, 33, 1239, 36.1272, 0.630538589526495, -79.4154, -1.3860602067883),
(11321, '27220', 218, 33, 1239, 36.095, 0.629976593507353, -79.4378, -1.38645116054075),
(11322, '27228', 218, 33, 1267, 35.7723, 0.624344416011168, -79.1406, -1.38126404200382),
(11323, '27229', 218, 33, 63407, 35.2226, 0.614750341112955, -79.7912, -1.3926191541173),
(11324, '27230', 218, 33, 63543, 35.7519, 0.623988368843761, -79.7315, -1.39157719255386),
(11325, '27231', 218, 33, 1414, 36.1937, 0.631699233479072, -79.1628, -1.38165150509777),
(11326, '27233', 218, 33, 20102, 35.9327, 0.627143924131366, -79.7008, -1.3910413764735),
(11327, '27235', 218, 33, 8175, 36.0969, 0.630009754763141, -80.0071, -1.39638731997236),
(11328, '27237', 218, 33, 64080, 35.434, 0.618439967151671, -79.1773, -1.38190457783931),
(11329, '27239', 218, 33, 8484, 35.6013, 0.621359902990257, -80.0875, -1.39779056469096),
(11330, '27242', 218, 33, 64327, 35.3324, 0.616666712631645, -79.6276, -1.38976379546104),
(11331, '27243', 218, 33, 64452, 36.0695, 0.629531534548095, -79.2026, -1.38234614614006),
(11332, '27244', 218, 33, 2280, 36.1312, 0.630608402696575, -79.5085, -1.38768510832191),
(11333, '27247', 218, 33, 64573, 35.4326, 0.618415532542143, -79.7864, -1.3925353783132),
(11334, '27248', 218, 33, 21289, 35.7464, 0.623892375734901, -79.699, -1.39100996054696),
(11335, '27249', 218, 33, 2712, 36.126, 0.630517645575471, -79.5867, -1.38904995579697),
(11336, '27252', 218, 33, 65105, 35.5558, 0.6205657781806, -79.3486, -1.38489432684797),
(11337, '27253', 218, 33, 2802, 36.0207, 0.628679813873121, -79.3685, -1.38524164736912),
(11338, '27256', 218, 33, 65281, 35.5599, 0.620637336679932, -79.2817, -1.38372670157839),
(11339, '27258', 218, 33, 65433, 36.0616, 0.629393653537187, -79.3396, -1.38473724721529),
(11340, '27259', 218, 33, 3106, 35.4612, 0.618914696708213, -79.5704, -1.3887654671289),
(11341, '27260', 218, 33, 3101, 35.9688, 0.627773987991336, -80.0005, -1.39627212824172),
(11342, '27261', 218, 33, 3101, 35.9764, 0.627906633014488, -79.999, -1.39624594830294),
(11343, '27262', 218, 33, 3101, 35.9652, 0.627711156138265, -80.0205, -1.39662119409212),
(11344, '27263', 218, 33, 3101, 35.9278, 0.627058402998019, -79.9608, -1.39557923252868),
(11345, '27264', 218, 33, 3101, 35.981, 0.62798691816008, -79.9985, -1.39623722165668),
(11346, '27265', 218, 33, 3101, 36.0131, 0.62854716884997, -79.9996, -1.39625642027846),
(11347, '27278', 218, 33, 48155, 36.079, 0.629697340827034, -79.0921, -1.38041755731661),
(11348, '27281', 218, 33, 65916, 35.1743, 0.613907347084242, -79.5776, -1.38889113083504),
(11349, '27282', 218, 33, 3399, 36, 0.628318530717959, -79.9302, -1.39504516177757),
(11350, '27283', 218, 33, 95234, 35.9515, 0.627472046030741, -79.6379, -1.38994356437399),
(11351, '27284', 218, 33, 66073, 36.1145, 0.630316932711492, -80.0912, -1.39785514187328),
(11352, '27285', 218, 33, 66073, 36.1144, 0.63031518738224, -80.0778, -1.39762126775352),
(11353, '27288', 218, 33, 2217, 36.5062, 0.637153387391554, -79.7459, -1.39182851996615),
(11354, '27289', 218, 33, 2217, 36.5053, 0.637137679428286, -79.7422, -1.39176394278382),
(11355, '27291', 218, 33, 55831, 36.4136, 0.635537212504207, -79.1904, -1.38213321597132),
(11356, '27292', 218, 33, 3748, 35.8205, 0.625185664710629, -80.2568, -1.40074540711459),
(11357, '27293', 218, 33, 3748, 35.8618, 0.625906485691702, -80.2551, -1.4007157365173),
(11358, '27294', 218, 33, 3748, 35.8234, 0.625236279258937, -80.2541, -1.40069828322478),
(11359, '27295', 218, 33, 3748, 35.8089, 0.624983206517397, -80.2572, -1.40075238843159),
(11360, '27298', 218, 33, 3751, 35.8979, 0.626536549551672, -79.5048, -1.38762053113959),
(11361, '27299', 218, 33, 3793, 35.7907, 0.624665556593535, -80.3789, -1.40287645413127),
(11362, '27301', 218, 33, 66735, 36.1134, 0.63029773408972, -79.671, -1.3905212683564),
(11363, '27302', 218, 33, 66760, 36.0914, 0.629913761654281, -79.2857, -1.38379651474847),
(11364, '27305', 218, 33, 4232, 36.5128, 0.637268579122185, -79.2179, -1.38261318151562),
(11365, '27306', 218, 33, 4369, 35.2327, 0.614926619367406, -80.0012, -1.39628434554649),
(11366, '27310', 218, 33, 4694, 36.1672, 0.631236721227293, -79.9858, -1.39601556484168),
(11367, '27311', 218, 33, 4936, 36.4777, 0.636655968554736, -79.4693, -1.38700093925513),
(11368, '27312', 218, 33, 30845, 35.7634, 0.62418908170774, -79.136, -1.38118375685823),
(11369, '27313', 218, 33, 67869, 35.9515, 0.627472046030741, -79.7555, -1.39199607157434),
(11370, '27314', 218, 33, 57051, 36.294, 0.633449798718822, -79.1976, -1.38225887967746),
(11371, '27315', 218, 33, 966, 36.5178, 0.637355845584785, -79.428, -1.38628011827406),
(11372, '27316', 218, 33, 68077, 35.7326, 0.623651520298126, -79.6516, -1.39018267448152),
(11373, '27317', 218, 33, 68081, 35.8118, 0.625033821065705, -79.8039, -1.3928408109323),
(11374, '27320', 218, 33, 24279, 36.3511, 0.634446381721711, -79.6712, -1.39052475901491),
(11375, '27321', 218, 33, 24279, 36.3218, 0.633935000250876, -79.6281, -1.3897725221073),
(11376, '27322', 218, 33, 24279, 36.3567, 0.634544120159822, -79.6635, -1.3903903686625),
(11377, '27323', 218, 33, 24279, 36.3169, 0.633849479117529, -79.6579, -1.39029263022439),
(11378, '27325', 218, 33, 14501, 35.4291, 0.618354446018323, -79.5826, -1.38897839729764),
(11379, '27326', 218, 33, 68435, 36.4382, 0.635966563500198, -79.5465, -1.38834833343767),
(11380, '27330', 218, 33, 188, 35.4626, 0.618939131317741, -79.1709, -1.38179287676718),
(11381, '27331', 218, 33, 188, 35.4771, 0.61919220405928, -79.1812, -1.38197264568013),
(11382, '27332', 218, 33, 188, 35.4626, 0.618939131317741, -79.171, -1.38179462209643),
(11383, '27340', 218, 33, 68575, 35.9481, 0.627412704836174, -79.3208, -1.38440912531592),
(11384, '27341', 218, 33, 68620, 35.3976, 0.617804667303945, -79.784, -1.39249349041116),
(11385, '27342', 218, 33, 38144, 36.0747, 0.629622291669198, -79.6256, -1.389728888876),
(11386, '27343', 218, 33, 68648, 36.5117, 0.637249380500414, -79.0844, -1.3802831669642),
(11387, '27344', 218, 33, 68799, 35.7254, 0.623525856591982, -79.4649, -1.38692414476804),
(11388, '27349', 218, 33, 68889, 35.9142, 0.626821038219748, -79.4291, -1.38629931689583),
(11389, '27350', 218, 33, 68915, 35.8175, 0.625133304833069, -79.8931, -1.39439764462508),
(11390, '27351', 218, 33, 5976, 35.6678, 0.622520546942833, -80.2674, -1.4009304120153),
(11391, '27355', 218, 33, 69050, 35.8037, 0.624892449396294, -79.538, -1.38819998045125),
(11392, '27356', 218, 33, 6054, 35.3996, 0.617839573888985, -79.7824, -1.39246556514312),
(11393, '27357', 218, 33, 69121, 36.2381, 0.632474159666957, -79.9795, -1.3959056090988),
(11394, '27358', 218, 33, 6148, 36.2029, 0.631859803770255, -79.8949, -1.39442906055162),
(11395, '27359', 218, 33, 69284, 36.0342, 0.628915433322141, -79.3682, -1.38523641138136),
(11396, '27360', 218, 33, 6316, 35.8806, 0.626234607591077, -80.0816, -1.39768759026509),
(11397, '27361', 218, 33, 6316, 35.8766, 0.626164794420998, -80.1003, -1.39801396683521),
(11398, '27370', 218, 33, 398, 35.8691, 0.626033894727098, -79.9475, -1.39534710373817),
(11399, '27371', 218, 33, 199, 35.3604, 0.617155404822203, -79.8959, -1.39444651384414),
(11400, '27373', 218, 33, 69854, 36.0102, 0.628496554301662, -80.1395, -1.398698135902),
(11401, '27374', 218, 33, 12723, 35.9107, 0.626759951695928, -80.2544, -1.40070351921254),
(11402, '27375', 218, 33, 58194, 36.3338, 0.634144439761116, -79.6553, -1.39024725166384),
(11403, '27376', 218, 33, 6709, 35.2553, 0.615321063778357, -79.5909, -1.38912325962555),
(11404, '27377', 218, 33, 70151, 36.0341, 0.628913687992889, -79.6017, -1.38931175518477),
(11405, '27379', 218, 33, 70418, 36.4072, 0.63542551143208, -79.338, -1.38470932194726),
(11406, '27401', 218, 33, 2866, 36.0704, 0.629547242511363, -79.7715, -1.39227532425466),
(11407, '27402', 218, 33, 2866, 36.0715, 0.629566441133135, -79.7942, -1.39267151399486),
(11408, '27403', 218, 33, 2866, 36.0649, 0.629451249402503, -79.8238, -1.39318813145345),
(11409, '27404', 218, 33, 2866, 36.0852, 0.629805551240658, -79.8315, -1.39332252180585),
(11410, '27405', 218, 33, 2866, 36.1187, 0.630390236540076, -79.7677, -1.39220900174308),
(11411, '27406', 218, 33, 2866, 36.018, 0.628632689983318, -79.7708, -1.39226310694989),
(11412, '27407', 218, 33, 2866, 36.0295, 0.628833402847297, -79.8707, -1.39400669087264),
(11413, '27408', 218, 33, 2866, 36.1063, 0.630173815712829, -79.8154, -1.39304152379628),
(11414, '27409', 218, 33, 2866, 36.0911, 0.629908525666525, -79.9269, -1.39498756591226),
(11415, '27410', 218, 33, 2866, 36.1019, 0.630097021225741, -79.8868, -1.39428768888221),
(11416, '27411', 218, 33, 2866, 36.0744, 0.629617055681442, -79.7769, -1.39236957203426),
(11417, '27412', 218, 33, 2866, 36.0662, 0.629473938682779, -79.8075, -1.39290364278537),
(11418, '27413', 218, 33, 2866, 36.0705, 0.629548987840615, -79.8105, -1.39295600266293),
(11419, '27415', 218, 33, 2866, 36.0821, 0.629751446033846, -79.6441, -1.39005177478762),
(11420, '27416', 218, 33, 2866, 36.0037, 0.628383107900283, -79.7655, -1.39217060449954),
(11421, '27417', 218, 33, 2866, 36.0683, 0.629510590597071, -79.9518, -1.395422152896),
(11422, '27419', 218, 33, 2866, 35.9787, 0.627946775587284, -79.7092, -1.39118798413066),
(11423, '27420', 218, 33, 2866, 36.0632, 0.629421578805219, -79.8464, -1.3935825758644),
(11424, '27425', 218, 33, 2866, 36.1277, 0.630547316172755, -79.9436, -1.39527903589734),
(11425, '27427', 218, 33, 2866, 36.0689, 0.629521062572583, -79.7667, -1.39219154845056),
(11426, '27429', 218, 33, 2866, 36.0935, 0.629950413568573, -79.815, -1.39303454247927),
(11427, '27435', 218, 33, 2866, 36.0646, 0.629446013414747, -79.8242, -1.39319511277046),
(11428, '27438', 218, 33, 2866, 36.0556, 0.629288933782067, -79.8054, -1.39286699087108),
(11429, '27455', 218, 33, 2866, 36.1515, 0.63096270453473, -79.8163, -1.39305723175955),
(11430, '27480', 218, 33, 2866, 36.0786, 0.629690359510026, -79.8267, -1.39323874600176),
(11431, '27495', 218, 33, 2866, 36.1081, 0.630205231639364, -79.7352, -1.39164176973618),
(11432, '27498', 218, 33, 2866, 36.071, 0.629557714486875, -79.7662, -1.3921828218043),
(11433, '27499', 218, 33, 2866, 36.0711, 0.629559459816127, -79.7661, -1.39218107647505),
(11434, '27501', 218, 33, 62529, 35.5069, 0.619712312176375, -78.7406, -1.37428272499585),
(11435, '27502', 218, 33, 7125, 35.7125, 0.623300709118475, -78.8209, -1.3756842243852),
(11436, '27503', 218, 33, 62658, 36.1603, 0.631116293508906, -78.8972, -1.37701591060447),
(11437, '27504', 218, 33, 642, 35.3929, 0.617722636829101, -78.5467, -1.37089853157623),
(11438, '27505', 218, 33, 34998, 35.4565, 0.618832666233369, -79.0546, -1.37976305884711),
(11439, '27506', 218, 33, 63287, 35.4084, 0.61799316286316, -78.7421, -1.37430890493463),
(11440, '27507', 218, 33, 1230, 36.3648, 0.634685491829234, -78.5323, -1.37064720416394),
(11441, '27508', 218, 33, 7778, 35.9688, 0.627773987991336, -78.1945, -1.36475148195071),
(11442, '27509', 218, 33, 63330, 36.1362, 0.630695669159175, -78.7604, -1.37462830018774),
(11443, '27510', 218, 33, 63474, 35.9125, 0.626791367622464, -79.0793, -1.38019415517235),
(11444, '27511', 218, 33, 7935, 35.7582, 0.624098324586636, -78.7783, -1.37494071412385),
(11445, '27512', 218, 33, 7935, 35.7695, 0.624295546792112, -78.7966, -1.37526010937696),
(11446, '27513', 218, 33, 7935, 35.8053, 0.624920374664326, -78.795, -1.37523218410893),
(11447, '27514', 218, 33, 1489, 35.9369, 0.62721722795995, -79.0397, -1.37950300478856),
(11448, '27515', 218, 33, 1489, 35.9135, 0.626808820914984, -79.0562, -1.37979098411514),
(11449, '27516', 218, 33, 1489, 35.9187, 0.626899578036087, -79.1211, -1.38092370279969),
(11450, '27517', 218, 33, 1489, 35.9369, 0.62721722795995, -79.0399, -1.37950649544707),
(11451, '27518', 218, 33, 7935, 35.7585, 0.624103560574392, -78.7777, -1.37493024214834),
(11452, '27519', 218, 33, 7935, 35.788, 0.624618432703731, -78.781, -1.37498783801365),
(11453, '27520', 218, 33, 608, 35.6364, 0.621972513557707, -78.4476, -1.3691689102875),
(11454, '27521', 218, 33, 697, 35.4081, 0.617987926875404, -78.6729, -1.37310113709225),
(11455, '27522', 218, 33, 64018, 36.1196, 0.630405944503344, -78.6893, -1.37338737108957),
(11456, '27523', 218, 33, 7125, 35.7129, 0.623307690435483, -78.8205, -1.37567724306819),
(11457, '27524', 218, 33, 21253, 35.4492, 0.618705257197974, -78.4268, -1.36880588180309),
(11458, '27525', 218, 33, 21288, 36.096, 0.629994046799873, -78.4517, -1.36924046878684),
(11459, '27526', 218, 33, 0, 35.5936, 0.621225512637854, -78.78, -1.37497038472113),
(11460, '27529', 218, 33, 9061, 35.6868, 0.622852159500712, -78.6082, -1.37197190906621),
(11461, '27530', 218, 33, 13828, 35.3812, 0.617518433306618, -77.9817, -1.36103742130246),
(11462, '27531', 218, 33, 13828, 35.3436, 0.616862189507868, -77.9655, -1.36075467796364),
(11463, '27532', 218, 33, 13828, 35.3813, 0.61752017863587, -77.9541, -1.36055571042891),
(11464, '27533', 218, 33, 13828, 35.3817, 0.617527159952878, -77.9544, -1.36056094641667),
(11465, '27534', 218, 33, 13828, 35.3713, 0.61734564571067, -77.9279, -1.36009843416489),
(11466, '27536', 218, 33, 23, 36.3257, 0.634003068091704, -78.4065, -1.36845157996493),
(11467, '27537', 218, 33, 23, 36.3253, 0.633996086774696, -78.4069, -1.36845856128194),
(11468, '27539', 218, 33, 7125, 35.7128, 0.623305945106231, -78.8214, -1.37569295103146),
(11469, '27540', 218, 33, 3200, 35.6256, 0.621784017998492, -78.8366, -1.37595824107776),
(11470, '27541', 218, 33, 65815, 36.2014, 0.631833623831475, -79.075, -1.38011910601452),
(11471, '27542', 218, 33, 66054, 35.5912, 0.621183624735806, -78.1255, -1.36354720476683),
(11472, '27543', 218, 33, 41619, 35.4796, 0.61923583729058, -78.8217, -1.37569818701921),
(11473, '27544', 218, 33, 31, 36.2224, 0.632200142974394, -78.4399, -1.3690345199351),
(11474, '27545', 218, 33, 66132, 35.7863, 0.624588762106447, -78.4845, -1.36981293678149),
(11475, '27546', 218, 33, 66367, 35.3969, 0.617792449999181, -78.8117, -1.37552365409402),
(11476, '27549', 218, 33, 33143, 36.0894, 0.629878855069242, -78.3012, -1.36661374826258),
(11477, '27551', 218, 33, 3937, 36.4335, 0.635884533025354, -78.0028, -1.36140568577463),
(11478, '27552', 218, 33, 66580, 35.4167, 0.618138025191076, -78.9346, -1.37766866374472),
(11479, '27553', 218, 33, 10293, 36.4729, 0.63657219275064, -78.2984, -1.36656487904353),
(11480, '27555', 218, 33, 66791, 35.5623, 0.620679224581979, -78.2047, -1.36492950553441),
(11481, '27556', 218, 33, 17130, 36.3538, 0.634493505611515, -78.3962, -1.36827181105198),
(11482, '27557', 218, 33, 49457, 35.7912, 0.624674283239795, -78.1899, -1.36467119680511),
(11483, '27559', 218, 33, 60925, 35.6717, 0.622588614783661, -79.1697, -1.38177193281615),
(11484, '27560', 218, 33, 4337, 35.8272, 0.625302601770512, -78.8335, -1.37590413587095),
(11485, '27562', 218, 33, 4530, 35.6968, 0.623026692425912, -78.9331, -1.37764248380594),
(11486, '27563', 218, 33, 67226, 36.4444, 0.636074773913822, -78.1952, -1.36476369925547),
(11487, '27564', 218, 33, 64018, 36.123, 0.630465285697912, -78.6733, -1.37310811840925),
(11488, '27565', 218, 33, 4828, 36.3082, 0.633697635472605, -78.5906, -1.37166473111786),
(11489, '27568', 218, 33, 5046, 35.5086, 0.619741982773659, -78.2427, -1.36559273065017),
(11490, '27569', 218, 33, 5231, 35.4643, 0.618968801915025, -78.1626, -1.36419472191932),
(11491, '27570', 218, 33, 11587, 36.4359, 0.635926420927402, -78.2369, -1.36549150155355),
(11492, '27571', 218, 33, 68340, 35.9239, 0.626990335157191, -78.4565, -1.36932424459093),
(11493, '27572', 218, 33, 68402, 36.1976, 0.631767301319899, -79.0067, -1.3789270461354),
(11494, '27573', 218, 33, 68418, 36.3939, 0.635193382641564, -78.9861, -1.37856750830949),
(11495, '27574', 218, 33, 68418, 36.3947, 0.63520734527558, -78.9868, -1.37857972561426),
(11496, '27576', 218, 33, 5731, 35.5398, 0.620286525500281, -78.2853, -1.36633624091152),
(11497, '27577', 218, 33, 5916, 35.5118, 0.619797833309722, -78.3474, -1.36742009037701),
(11498, '27581', 218, 33, 69096, 36.1998, 0.631805698563443, -78.7236, -1.37398601902301),
(11499, '27582', 218, 33, 25174, 36.4474, 0.636127133791381, -78.5694, -1.37129472131643),
(11500, '27583', 218, 33, 25505, 36.2347, 0.632414818472389, -78.9657, -1.37821146114209),
(11501, '27584', 218, 33, 69587, 36.4946, 0.636950929198323, -78.4226, -1.36873257797451),
(11502, '27586', 218, 33, 31375, 36.4264, 0.635760614648462, -78.0043, -1.36143186571341),
(11503, '27587', 218, 33, 69832, 35.9636, 0.627683230870233, -78.519, -1.37041507537343),
(11504, '27588', 218, 33, 69832, 35.9706, 0.627805403917872, -78.5204, -1.37043950998296),
(11505, '27589', 218, 33, 6633, 36.4006, 0.635310319701448, -78.1553, -1.36406731288392),
(11506, '27591', 218, 33, 69974, 35.7945, 0.62473187910511, -78.39, -1.36816360063835),
(11507, '27592', 218, 33, 99135, 35.5677, 0.620773472361587, -78.7074, -1.37370327568419),
(11508, '27593', 218, 33, 70252, 35.6028, 0.621386082929037, -78.3438, -1.36735725852393),
(11509, '27594', 218, 33, 70299, 36.4861, 0.636802576211903, -78.1713, -1.36434656556424),
(11510, '27596', 218, 33, 70438, 36.0254, 0.628761844347965, -78.4647, -1.36946736158959),
(11511, '27597', 218, 33, 26312, 35.846, 0.625630723669887, -78.3384, -1.36726301074433),
(11512, '27599', 218, 33, 1489, 35.9271, 0.627046185693255, -79.041, -1.37952569406884),
(11513, '27601', 218, 33, 185, 35.7735, 0.624365359962191, -78.633, -1.3724047507207),
(11514, '27602', 218, 33, 185, 35.7488, 0.623934263636949, -78.6371, -1.37247630922003),
(11515, '27603', 218, 33, 185, 35.7128, 0.623305945106231, -78.6587, -1.37285330033846),
(11516, '27604', 218, 33, 185, 35.8304, 0.625358452306576, -78.5771, -1.37142911166884),
(11517, '27605', 218, 33, 185, 35.7892, 0.624639376654755, -78.6531, -1.37275556190035),
(11518, '27606', 218, 33, 185, 35.7551, 0.624044219379824, -78.7194, -1.37391271519442),
(11519, '27607', 218, 33, 185, 35.8036, 0.624890704067042, -78.697, -1.37352176144198),
(11520, '27608', 218, 33, 185, 35.808, 0.624967498554129, -78.6466, -1.37264211549897),
(11521, '27609', 218, 33, 185, 35.8492, 0.625686574205951, -78.6314, -1.37237682545267),
(11522, '27610', 218, 33, 185, 35.7628, 0.624178609732228, -78.5836, -1.37154255807022),
(11523, '27611', 218, 33, 185, 35.7183, 0.623401938215091, -78.7326, -1.37414309865569),
(11524, '27612', 218, 33, 185, 35.853, 0.625752896717527, -78.6873, -1.37335246450453),
(11525, '27613', 218, 33, 185, 35.9001, 0.626574946795216, -78.7057, -1.3736736050869),
(11526, '27614', 218, 33, 185, 35.9403, 0.627276569154518, -78.6312, -1.37237333479417),
(11527, '27615', 218, 33, 185, 35.8914, 0.626423103150293, -78.6374, -1.37248154520779),
(11528, '27616', 218, 33, 185, 35.8667, 0.62599200682505, -78.5355, -1.37070305470001),
(11529, '27617', 218, 33, 185, 35.7717, 0.624333944035656, -78.6384, -1.37249899850031),
(11530, '27619', 218, 33, 185, 35.8515, 0.625726716778747, -78.6324, -1.37239427874519),
(11531, '27620', 218, 33, 185, 35.764, 0.624199553683252, -78.5853, -1.3715722286675),
(11532, '27621', 218, 33, 185, 35.7743, 0.624379322596207, -78.634, -1.37242220401322),
(11533, '27622', 218, 33, 185, 35.8509, 0.625716244803235, -78.6917, -1.37342925899162),
(11534, '27623', 218, 33, 185, 35.8606, 0.625885541740678, -78.7902, -1.37514840830484),
(11535, '27624', 218, 33, 185, 35.8432, 0.625581854450832, -78.6343, -1.37242744000098),
(11536, '27625', 218, 33, 185, 35.8204, 0.625183919381377, -78.5716, -1.37133311855998),
(11537, '27626', 218, 33, 185, 35.776, 0.624408993193491, -78.6338, -1.37241871335472),
(11538, '27627', 218, 33, 185, 35.7692, 0.624290310804356, -78.7142, -1.37382195807332),
(11539, '27628', 218, 33, 185, 35.8049, 0.624913393347318, -78.6459, -1.37262989819421),
(11540, '27629', 218, 33, 185, 35.8201, 0.625178683393621, -78.5713, -1.37132788257222),
(11541, '27634', 218, 33, 185, 35.777, 0.624426446486011, -78.64, -1.37252692376834),
(11542, '27635', 218, 33, 185, 35.8199, 0.625175192735117, -78.5712, -1.37132613724297),
(11543, '27636', 218, 33, 185, 35.7948, 0.624737115092866, -78.6928, -1.37344845761339),
(11544, '27640', 218, 33, 185, 35.787, 0.624600979411211, -78.637, -1.37247456389078),
(11545, '27650', 218, 33, 185, 35.7893, 0.624641121984007, -78.6654, -1.37297023739835),
(11546, '27656', 218, 33, 185, 35.8507, 0.625712754144731, -78.692, -1.37343449497938),
(11547, '27658', 218, 33, 185, 35.8498, 0.625697046181463, -78.5941, -1.37172581764168),
(11548, '27661', 218, 33, 185, 35.8929, 0.626449283089073, -78.5605, -1.37113938701301),
(11549, '27668', 218, 33, 185, 35.8429, 0.625576618463076, -78.6339, -1.37242045868397),
(11550, '27675', 218, 33, 185, 35.904, 0.626643014636044, -78.743, -1.37432461289789),
(11551, '27676', 218, 33, 185, 35.7735, 0.624365359962191, -78.6336, -1.37241522269621),
(11552, '27690', 218, 33, 185, 35.8328, 0.625400340208624, -78.6666, -1.37299118134937),
(11553, '27695', 218, 33, 185, 35.8007, 0.624840089518734, -78.7125, -1.37379228747604),
(11554, '27697', 218, 33, 185, 35.7803, 0.624484042351327, -78.6236, -1.37224068977101),
(11555, '27698', 218, 33, 185, 35.7754, 0.624398521217979, -78.6391, -1.37251121580507),
(11556, '27699', 218, 33, 185, 35.6692, 0.622544981552361, -78.6653, -1.3729684920691),
(11557, '27701', 218, 33, 8632, 35.9966, 0.628259189523391, -78.8989, -1.37704558120175),
(11558, '27702', 218, 33, 8632, 36.0518, 0.629222611270492, -78.8803, -1.37672094996088),
(11559, '27703', 218, 33, 8632, 35.9752, 0.627885689063464, -78.8387, -1.37599489299205),
(11560, '27704', 218, 33, 8632, 36.0351, 0.628931141285409, -78.8687, -1.37651849176765),
(11561, '27705', 218, 33, 8632, 36.0173, 0.628620472678554, -78.95, -1.37793744444952),
(11562, '27706', 218, 33, 8632, 35.9969, 0.628264425511147, -78.9407, -1.37777512882909),
(11563, '27707', 218, 33, 8632, 35.9622, 0.627658796260705, -78.9382, -1.37773149559779),
(11564, '27708', 218, 33, 8632, 35.9997, 0.628313294730203, -78.9394, -1.37775243954881),
(11565, '27709', 218, 33, 8632, 35.913, 0.626800094268724, -78.8522, -1.37623051244107),
(11566, '27710', 218, 33, 8632, 35.9995, 0.628309804071699, -78.94, -1.37776291152432),
(11567, '27711', 218, 33, 8632, 35.9143, 0.626822783548999, -78.8654, -1.37646089590234),
(11568, '27712', 218, 33, 8632, 36.0869, 0.629835221837942, -78.9275, -1.37754474536782),
(11569, '27713', 218, 33, 8632, 35.9162, 0.626855944804787, -78.918, -1.37737893908889),
(11570, '27715', 218, 33, 8632, 36.0144, 0.628569858130246, -78.9568, -1.37805612683866),
(11571, '27717', 218, 33, 8632, 35.9566, 0.627561057822593, -78.9518, -1.37796886037606),
(11572, '27722', 218, 33, 8632, 35.9942, 0.628217301621343, -78.8988, -1.3770438358725),
(11573, '27801', 218, 33, 5489, 35.9364, 0.62720850131369, -77.7719, -1.35737572053178),
(11574, '27802', 218, 33, 5489, 35.8662, 0.62598328017879, -77.8384, -1.35853636448435),
(11575, '27803', 218, 33, 5489, 35.9319, 0.62712996149735, -77.8322, -1.35842815407073),
(11576, '27804', 218, 33, 5489, 35.9731, 0.627849037149172, -77.8304, -1.35839673814419);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(11577, '27805', 218, 33, 62625, 36.0996, 0.630056878652945, -77.0436, -1.3446644875895),
(11578, '27806', 218, 33, 474, 35.3015, 0.616127405892778, -76.791, -1.34025578589897),
(11579, '27807', 218, 33, 7216, 35.7814, 0.624503240973099, -78.1141, -1.3633482372321),
(11580, '27808', 218, 33, 19093, 35.4777, 0.619202676034792, -76.8139, -1.34065546629767),
(11581, '27809', 218, 33, 62744, 36.0359, 0.628945103919425, -77.7352, -1.3567351846963),
(11582, '27810', 218, 33, 62833, 35.5418, 0.620321432085321, -76.6213, -1.33729396215833),
(11583, '27811', 218, 33, 0, 35.5803, 0.620993383847338, -77.4911, -1.35247483599218),
(11584, '27812', 218, 33, 220, 35.8068, 0.624946554603106, -77.3768, -1.35047992465715),
(11585, '27813', 218, 33, 842, 35.6526, 0.62225525689653, -77.9388, -1.36028867505336),
(11586, '27814', 218, 33, 63013, 35.3679, 0.617286304516102, -76.9209, -1.34252296859731),
(11587, '27816', 218, 33, 63498, 36.102, 0.630098766554993, -78.0629, -1.36245462865508),
(11588, '27817', 218, 33, 63675, 35.5139, 0.619834485224014, -77.1063, -1.3457588090305),
(11589, '27818', 218, 33, 39860, 36.5026, 0.637090555538482, -77.0152, -1.34416881408194),
(11590, '27819', 218, 33, 63869, 35.8174, 0.625131559503817, -77.4576, -1.35189015069276),
(11591, '27820', 218, 33, 8215, 36.4427, 0.636045103316538, -77.2584, -1.34841345482279),
(11592, '27821', 218, 33, 32309, 35.3268, 0.616568974193533, -76.8943, -1.34205871101628),
(11593, '27822', 218, 33, 64507, 35.806, 0.62493259196909, -77.8632, -1.35896920613885),
(11594, '27823', 218, 33, 27104, 36.1786, 0.631435688762021, -77.6691, -1.35558152206073),
(11595, '27824', 218, 33, 64540, 35.24, 0.615054028402802, -75.9911, -1.32629489721226),
(11596, '27825', 218, 33, 64585, 35.8338, 0.625417793501144, -77.1723, -1.34691072633682),
(11597, '27826', 218, 33, 2367, 35.5701, 0.620815360263635, -76.242, -1.33067392830552),
(11598, '27827', 218, 33, 64652, 35.6985, 0.623056363023196, -77.5143, -1.35287975237864),
(11599, '27828', 218, 33, 2420, 35.5927, 0.621209804674586, -77.5891, -1.35418525865913),
(11600, '27829', 218, 33, 2573, 35.6741, 0.622630502685709, -77.6388, -1.35505268729737),
(11601, '27830', 218, 33, 2605, 35.5348, 0.620199259037681, -77.978, -1.36097284412014),
(11602, '27831', 218, 33, 64973, 36.4736, 0.636584410055404, -77.5969, -1.35432139434079),
(11603, '27832', 218, 33, 2675, 36.4895, 0.636861917406471, -77.6201, -1.35472631072725),
(11604, '27833', 218, 33, 2868, 35.6, 0.621337213709981, -77.3748, -1.35044501807211),
(11605, '27834', 218, 33, 2868, 35.601, 0.621354667002501, -77.3897, -1.35070507213066),
(11606, '27835', 218, 33, 2868, 35.6075, 0.621468113403881, -77.3701, -1.35036298759726),
(11607, '27836', 218, 33, 2868, 35.6035, 0.621398300233801, -77.3609, -1.35020241730608),
(11608, '27837', 218, 33, 65255, 35.5769, 0.620934042652771, -77.2337, -1.34798235849754),
(11609, '27839', 218, 33, 21675, 36.3266, 0.634018776054972, -77.5909, -1.35421667458567),
(11610, '27840', 218, 33, 2950, 35.944, 0.627341146336842, -77.2082, -1.34753729953829),
(11611, '27841', 218, 33, 65417, 35.9082, 0.626716318464628, -77.2775, -1.34874681270992),
(11612, '27842', 218, 33, 21837, 36.5236, 0.637457074681401, -77.8691, -1.35907218056472),
(11613, '27843', 218, 33, 3170, 35.9843, 0.628044514025396, -77.4414, -1.35160740735394),
(11614, '27844', 218, 33, 16470, 36.255, 0.632769120310544, -77.9243, -1.36003560231182),
(11615, '27845', 218, 33, 3384, 36.3919, 0.635158476056524, -77.4225, -1.35127754012531),
(11616, '27846', 218, 33, 3401, 35.8134, 0.625061746333737, -76.9053, -1.342250697234),
(11617, '27847', 218, 33, 66041, 36.1806, 0.63147059534706, -77.2194, -1.34773277641451),
(11618, '27849', 218, 33, 66341, 36.0622, 0.629404125512699, -77.1896, -1.34721266829742),
(11619, '27850', 218, 33, 3815, 36.5163, 0.637329665646005, -77.9462, -1.360417829418),
(11620, '27851', 218, 33, 66516, 35.6357, 0.621960296252943, -78.0123, -1.36157149205357),
(11621, '27852', 218, 33, 66546, 35.7513, 0.623977896868249, -77.6707, -1.35560944732876),
(11622, '27853', 218, 33, 66621, 36.5245, 0.637472782644669, -77.2942, -1.349038282695),
(11623, '27854', 218, 33, 66863, 36.4054, 0.635394095505544, -77.2329, -1.34796839586353),
(11624, '27855', 218, 33, 10713, 36.4391, 0.635982271463466, -77.0975, -1.34560522005633),
(11625, '27856', 218, 33, 10729, 35.9649, 0.627705920150509, -77.9569, -1.36060457964797),
(11626, '27857', 218, 33, 67322, 35.9518, 0.627477282018497, -77.2597, -1.34843614410306),
(11627, '27858', 218, 33, 2868, 35.5876, 0.621120792882734, -77.3484, -1.34998425114958),
(11628, '27860', 218, 33, 67585, 35.6326, 0.621906191046131, -76.7143, -1.33891711836269),
(11629, '27861', 218, 33, 67620, 35.8198, 0.625173447405865, -77.3122, -1.34935244196036),
(11630, '27862', 218, 33, 11133, 36.4917, 0.636900314650015, -77.1913, -1.3472423388947),
(11631, '27863', 218, 33, 5005, 35.4927, 0.619464475422591, -77.9804, -1.36101473202219),
(11632, '27864', 218, 33, 67797, 35.7898, 0.624649848630267, -77.6394, -1.35506315927289),
(11633, '27865', 218, 33, 14423, 35.6035, 0.621398300233801, -76.8296, -1.34092948299024),
(11634, '27866', 218, 33, 268, 36.5246, 0.637474527973921, -77.5141, -1.35287626172014),
(11635, '27867', 218, 33, 67954, 36.3631, 0.63465582123195, -77.2389, -1.34807311561865),
(11636, '27868', 218, 33, 5318, 36.0383, 0.628986991821472, -77.907, -1.35973366035122),
(11637, '27869', 218, 33, 68195, 36.2707, 0.633043137003107, -77.287, -1.34891261898886),
(11638, '27870', 218, 33, 68268, 36.4528, 0.636221381570989, -77.6583, -1.35539302650151),
(11639, '27871', 218, 33, 68280, 35.8225, 0.625220571295669, -77.2522, -1.34830524440916),
(11640, '27872', 218, 33, 68420, 36.2033, 0.631866785087263, -77.2424, -1.34813420214247),
(11641, '27873', 218, 33, 5658, 35.6556, 0.62230761677409, -77.7725, -1.35738619250729),
(11642, '27874', 218, 33, 68588, 36.1312, 0.630608402696575, -77.4211, -1.35125310551578),
(11643, '27875', 218, 33, 5701, 35.58, 0.620988147859582, -76.4489, -1.33428501452789),
(11644, '27876', 218, 33, 5709, 36.4884, 0.636842718784699, -77.4424, -1.35162486064646),
(11645, '27877', 218, 33, 51296, 36.5132, 0.637275560439194, -77.1896, -1.34721266829742),
(11646, '27878', 218, 33, 24795, 35.8689, 0.626030404068594, -77.8344, -1.35846655131427),
(11647, '27879', 218, 33, 5863, 35.5745, 0.620892154750723, -77.2782, -1.34875903001468),
(11648, '27880', 218, 33, 11960, 35.7345, 0.623684681553914, -78.0995, -1.36309341916131),
(11649, '27881', 218, 33, 5993, 35.8964, 0.626510369612893, -77.5418, -1.35335971792294),
(11650, '27882', 218, 33, 69013, 35.9366, 0.627211991972194, -78.116, -1.36338139848789),
(11651, '27883', 218, 33, 69063, 35.6055, 0.621433206818841, -77.8206, -1.3582256958775),
(11652, '27884', 218, 33, 899, 35.7131, 0.623311181093987, -77.2707, -1.34862813032078),
(11653, '27885', 218, 33, 69275, 35.4039, 0.61791462304682, -76.2745, -1.33124116031242),
(11654, '27886', 218, 33, 25343, 35.9033, 0.62663079733128, -77.5479, -1.35346618300731),
(11655, '27887', 218, 33, 69410, 36.2513, 0.63270454312822, -77.4859, -1.35238407887107),
(11656, '27888', 218, 33, 69870, 35.5814, 0.62101258246911, -77.7064, -1.35623252987172),
(11657, '27889', 218, 33, 12671, 35.5469, 0.620410443877172, -77.0394, -1.34459118376092),
(11658, '27890', 218, 33, 635, 36.4223, 0.635689056149131, -77.608, -1.35451512588776),
(11659, '27891', 218, 33, 70092, 36.0999, 0.630062114640701, -77.7211, -1.35648909327177),
(11660, '27892', 218, 33, 70213, 35.8529, 0.625751151388275, -77.0691, -1.34510954654876),
(11661, '27893', 218, 33, 565, 35.7307, 0.623618359042338, -77.92, -1.35996055315398),
(11662, '27894', 218, 33, 565, 35.7316, 0.623634067005606, -77.9241, -1.36003211165331),
(11663, '27895', 218, 33, 565, 35.7596, 0.624122759196164, -77.941, -1.3603270722969),
(11664, '27896', 218, 33, 565, 35.7552, 0.624045964709077, -77.9443, -1.36038466816222),
(11665, '27897', 218, 33, 6917, 36.3294, 0.634067645274028, -77.2129, -1.34761933001313),
(11666, '27906', 218, 33, 64474, 36.2852, 0.633296209744647, -76.2154, -1.33020967072449),
(11667, '27907', 218, 33, 64474, 36.2961, 0.633486450633114, -76.2201, -1.33029170119933),
(11668, '27909', 218, 33, 64474, 36.2931, 0.633434090755554, -76.2345, -1.33054302861162),
(11669, '27910', 218, 33, 62449, 36.2878, 0.633341588305198, -76.9847, -1.34363648866008),
(11670, '27915', 218, 33, 7208, 35.3526, 0.617019269140547, -75.5034, -1.31778292645029),
(11671, '27916', 218, 33, 62649, 36.3031, 0.633608623680753, -75.9095, -1.32487070854264),
(11672, '27917', 218, 33, 62711, 36.3585, 0.634575536086358, -75.9933, -1.32633329445581),
(11673, '27919', 218, 33, 13361, 36.3136, 0.633791883252213, -76.514, -1.33542122387094),
(11674, '27920', 218, 33, 31939, 35.2656, 0.615500832691312, -75.5285, -1.31822100409254),
(11675, '27921', 218, 33, 1304, 36.2934, 0.63343932674331, -76.1475, -1.32902459216238),
(11676, '27922', 218, 33, 39831, 36.3184, 0.633875659056308, -76.8588, -1.34143911913182),
(11677, '27923', 218, 33, 63784, 36.3448, 0.634336425978835, -75.9375, -1.32535940073319),
(11678, '27924', 218, 33, 20163, 36.1812, 0.631481067322572, -76.8508, -1.34129949279166),
(11679, '27925', 218, 33, 1716, 35.9184, 0.626894342048331, -76.2511, -1.33083275326745),
(11680, '27926', 218, 33, 63904, 36.5031, 0.637099282184742, -76.5836, -1.33663597303033),
(11681, '27927', 218, 33, 63917, 36.3489, 0.634407984478167, -75.8187, -1.32328594958182),
(11682, '27928', 218, 33, 1884, 35.8109, 0.625018113102437, -76.4531, -1.33435831835648),
(11683, '27929', 218, 33, 64084, 36.4163, 0.635584336394011, -76.014, -1.32669457761097),
(11684, '27930', 218, 33, 0, 36.154, 0.63100633776603, -76.313, -1.33191311207443),
(11685, '27932', 218, 33, 35708, 36.1173, 0.630365801930548, -76.6433, -1.33767793459377),
(11686, '27935', 218, 33, 64576, 36.4233, 0.635706509441651, -76.86, -1.34146006308284),
(11687, '27936', 218, 33, 2620, 35.2387, 0.615031339122526, -75.6211, -1.31983717897988),
(11688, '27937', 218, 33, 865, 36.502, 0.63708008356297, -76.7863, -1.34017375542412),
(11689, '27938', 218, 33, 29876, 36.3892, 0.635111352166721, -76.7203, -1.33902183811781),
(11690, '27939', 218, 33, 65138, 36.2389, 0.632488122300973, -75.9014, -1.32472933687322),
(11691, '27941', 218, 33, 65365, 36.0887, 0.629866637764478, -75.817, -1.32325627898454),
(11692, '27942', 218, 33, 65395, 36.2904, 0.63338696686575, -76.7714, -1.33991370136557),
(11693, '27943', 218, 33, 65424, 35.2289, 0.61486029685583, -75.6262, -1.31992619077174),
(11694, '27944', 218, 33, 65521, 36.1335, 0.630648545269371, -76.4484, -1.33427628788163),
(11695, '27946', 218, 33, 65657, 36.3541, 0.634498741599271, -76.6397, -1.3376151027407),
(11696, '27947', 218, 33, 65940, 36.1744, 0.631362384933437, -75.8524, -1.32387412553975),
(11697, '27948', 218, 33, 66082, 36.0217, 0.628697267165641, -75.6808, -1.32087914054332),
(11698, '27949', 218, 33, 66128, 36.1071, 0.630187778346845, -75.7227, -1.32161043349991),
(11699, '27950', 218, 33, 66146, 36.5374, 0.637697930118176, -76.0391, -1.32713265525322),
(11700, '27953', 218, 33, 66594, 35.8109, 0.625018113102437, -75.9183, -1.32502429751681),
(11701, '27954', 218, 33, 66597, 35.916, 0.626852454146283, -75.6762, -1.32079885539773),
(11702, '27956', 218, 33, 10294, 36.3909, 0.635141022764005, -76.0059, -1.32655320594156),
(11703, '27957', 218, 33, 66780, 36.0821, 0.629751446033846, -76.7665, -1.33982818023223),
(11704, '27958', 218, 33, 67061, 36.4958, 0.636971873149347, -76.1379, -1.32885704055419),
(11705, '27959', 218, 33, 67099, 35.9336, 0.627159632094634, -75.6154, -1.31973769521252),
(11706, '27960', 218, 33, 67429, 35.1207, 0.612971850605172, -75.9671, -1.32587601819178),
(11707, '27962', 218, 33, 14433, 35.859, 0.625857616472647, -76.7447, -1.33944769845529),
(11708, '27964', 218, 33, 61386, 36.0771, 0.629664179571246, -75.7977, -1.32291943043891),
(11709, '27965', 218, 33, 67929, 36.2655, 0.632952379882004, -75.8826, -1.32440121497385),
(11710, '27966', 218, 33, 67962, 36.1196, 0.630405944503344, -75.8332, -1.32353902232336),
(11711, '27967', 218, 33, 67963, 36.2253, 0.632250757522702, -76.9323, -1.34272193613203),
(11712, '27968', 218, 33, 68333, 35.5826, 0.621033526420134, -75.4674, -1.31715460791957),
(11713, '27969', 218, 33, 68335, 36.4616, 0.636374970545164, -76.8131, -1.34064150366366),
(11714, '27970', 218, 33, 5536, 35.876, 0.626154322445486, -76.6144, -1.33717353443994),
(11715, '27972', 218, 33, 68502, 35.5482, 0.620433133157448, -75.4687, -1.31717729719984),
(11716, '27973', 218, 33, 68714, 36.3755, 0.634872242059197, -76.0849, -1.32793201605063),
(11717, '27974', 218, 33, 5817, 36.2419, 0.632540482178533, -76.0784, -1.32781856964925),
(11718, '27976', 218, 33, 68936, 36.5131, 0.637273815109942, -76.3498, -1.33255539323917),
(11719, '27978', 218, 33, 69177, 35.7501, 0.623956952917225, -75.8074, -1.32308872737635),
(11720, '27979', 218, 33, 25240, 36.419, 0.635631460283815, -76.5655, -1.33632006843572),
(11721, '27980', 218, 33, 25629, 36.2514, 0.632706288457472, -76.6318, -1.33747722172979),
(11722, '27981', 218, 33, 69874, 35.8375, 0.625482370683468, -75.6404, -1.32017402752552),
(11723, '27982', 218, 33, 788, 35.5523, 0.62050469165678, -75.4665, -1.3171388999563),
(11724, '27983', 218, 33, 18652, 35.997, 0.628266170840399, -76.9457, -1.3429558102518),
(11725, '27985', 218, 33, 70278, 36.2104, 0.631990703464155, -76.455, -1.33439147961226),
(11726, '27986', 218, 33, 6892, 36.387, 0.635072954923177, -76.9407, -1.3428685437892),
(11727, '28001', 218, 33, 39054, 35.3565, 0.617087336981375, -80.2034, -1.39981340129402),
(11728, '28002', 218, 33, 39054, 35.3553, 0.617066393030351, -80.1938, -1.39964584968583),
(11729, '28006', 218, 33, 402, 35.3962, 0.617780232694417, -81.1152, -1.4157273134137),
(11730, '28007', 218, 33, 62532, 35.0214, 0.611238738657942, -80.0857, -1.39775914876442),
(11731, '28009', 218, 33, 62656, 35.407, 0.617968728253632, -80.1161, -1.39828972885703),
(11732, '28010', 218, 33, 62713, 35.719, 0.623414155519855, -80.8983, -1.41194169426613),
(11733, '28012', 218, 33, 303, 35.2418, 0.615085444329338, -81.0402, -1.41441831647471),
(11734, '28016', 218, 33, 62898, 35.283, 0.615804519981159, -81.2796, -1.41859663470398),
(11735, '28017', 218, 33, 1026, 35.2557, 0.615328045095365, -81.6457, -1.42498628509553),
(11736, '28018', 218, 33, 1060, 35.4971, 0.619541269909679, -81.7947, -1.42758682568101),
(11737, '28019', 218, 33, 63448, 35.3544, 0.617050685067083, -81.8747, -1.4289830890826),
(11738, '28020', 218, 33, 63492, 35.524, 0.620010763478466, -81.5988, -1.42416772567635),
(11739, '28021', 218, 33, 54017, 35.3804, 0.617504470672602, -81.3768, -1.42029309473692),
(11740, '28023', 218, 33, 1556, 35.5692, 0.620799652300367, -80.5897, -1.40655560819447),
(11741, '28024', 218, 33, 63737, 35.2397, 0.615048792415046, -81.7441, -1.4267036890795),
(11742, '28025', 218, 33, 698, 35.4014, 0.617870989815521, -80.5828, -1.40643518047609),
(11743, '28026', 218, 33, 698, 35.3767, 0.617439893490278, -80.5357, -1.4056131303984),
(11744, '28027', 218, 33, 698, 35.4087, 0.617998398850916, -80.6451, -1.40752252060008),
(11745, '28031', 218, 33, 29550, 35.4803, 0.619248054595344, -80.8621, -1.41130988507691),
(11746, '28032', 218, 33, 64006, 35.24, 0.615054028402802, -81.0787, -1.41509026823673),
(11747, '28033', 218, 33, 64058, 35.3994, 0.617836083230481, -81.3467, -1.41976775063207),
(11748, '28034', 218, 33, 1953, 35.3276, 0.616582936827549, -81.1811, -1.41687748539077),
(11749, '28035', 218, 33, 8406, 35.4991, 0.619576176494719, -80.8493, -1.41108648293265),
(11750, '28036', 218, 33, 8406, 35.4916, 0.619445276800819, -80.8594, -1.4112627611871),
(11751, '28037', 218, 33, 2033, 35.5131, 0.619820522589998, -81.0171, -1.4140151454175),
(11752, '28038', 218, 33, 54522, 35.1995, 0.614347170055744, -81.543, -1.42319383195374),
(11753, '28039', 218, 33, 64366, 35.6808, 0.622747439745593, -80.4326, -1.40381369593959),
(11754, '28040', 218, 33, 64494, 35.3843, 0.61757253851343, -81.7529, -1.42685727805367),
(11755, '28041', 218, 33, 747, 35.5884, 0.62113475551675, -80.4651, -1.40438092794649),
(11756, '28042', 218, 33, 47008, 35.4296, 0.618363172664583, -81.5019, -1.42247650163117),
(11757, '28043', 218, 33, 16058, 35.3334, 0.616684165924164, -81.8707, -1.42891327591252),
(11758, '28052', 218, 33, 64977, 35.2483, 0.615198890730717, -81.216, -1.41748660529971),
(11759, '28053', 218, 33, 64977, 35.1925, 0.614224997008105, -81.2343, -1.41780600055283),
(11760, '28054', 218, 33, 64977, 35.2503, 0.615233797315757, -81.1484, -1.41630676272537),
(11761, '28055', 218, 33, 64977, 35.2208, 0.614718925186419, -81.2533, -1.41813761311071),
(11762, '28056', 218, 33, 64977, 35.2121, 0.614567081541495, -81.1448, -1.41624393087229),
(11763, '28070', 218, 33, 30129, 35.4154, 0.6181153359108, -80.8447, -1.41100619778706),
(11764, '28071', 218, 33, 2759, 35.477, 0.619190458730028, -80.3489, -1.40235285535567),
(11765, '28072', 218, 33, 65140, 35.6086, 0.621487312025653, -80.4433, -1.40400044616955),
(11766, '28073', 218, 33, 2894, 35.2038, 0.61442221921358, -81.4792, -1.42208031189096),
(11767, '28074', 218, 33, 2992, 35.2425, 0.615097661634102, -81.8755, -1.42899705171662),
(11768, '28075', 218, 33, 2994, 35.3361, 0.616731289813968, -80.6631, -1.40783667986544),
(11769, '28076', 218, 33, 16406, 35.2579, 0.615366442338909, -81.7964, -1.42761649627829),
(11770, '28077', 218, 33, 3107, 35.4036, 0.617909387059064, -81.2038, -1.41727367513097),
(11771, '28078', 218, 33, 30129, 35.4156, 0.618118826569304, -80.8689, -1.41142856746604),
(11772, '28079', 218, 33, 65858, 35.0983, 0.612580896852726, -80.6294, -1.40724850390752),
(11773, '28080', 218, 33, 65878, 35.4543, 0.618794268989826, -81.1122, -1.41567495353614),
(11774, '28081', 218, 33, 66030, 35.4847, 0.619324849082432, -80.6248, -1.40716821876192),
(11775, '28082', 218, 33, 66030, 35.4771, 0.61919220405928, -80.6255, -1.40718043606669),
(11776, '28083', 218, 33, 66030, 35.4852, 0.619333575728692, -80.6023, -1.40677551968023),
(11777, '28086', 218, 33, 22385, 35.2462, 0.615162238816425, -81.3639, -1.42006794726341),
(11778, '28088', 218, 33, 9978, 35.5439, 0.620358083999613, -80.6123, -1.40695005260543),
(11779, '28089', 218, 33, 66254, 35.316, 0.616380478634317, -81.6557, -1.42516081802073),
(11780, '28090', 218, 33, 14097, 35.4255, 0.618291614165251, -81.5703, -1.42367030683953),
(11781, '28091', 218, 33, 66365, 34.9673, 0.610294515532613, -79.9883, -1.39605919807298),
(11782, '28092', 218, 33, 22680, 35.4779, 0.619206166693296, -81.2341, -1.41780250989433),
(11783, '28093', 218, 33, 22680, 35.4721, 0.619104937596681, -81.2549, -1.41816553837874),
(11784, '28097', 218, 33, 36939, 35.2635, 0.61546418077702, -80.4266, -1.40370897618447),
(11785, '28098', 218, 33, 10211, 35.2694, 0.615567155202888, -81.1052, -1.4155527804885),
(11786, '28101', 218, 33, 66695, 35.257, 0.615350734375641, -81.0788, -1.41509201356598),
(11787, '28102', 218, 33, 66719, 34.8134, 0.607608453813794, -79.9764, -1.39585150389199),
(11788, '28103', 218, 33, 66644, 34.9914, 0.610715139882344, -80.3679, -1.40268446791355),
(11789, '28104', 218, 33, 4038, 35.0821, 0.612298153513903, -80.6779, -1.40809498859473),
(11790, '28105', 218, 33, 4038, 35.1191, 0.612943925337141, -80.7228, -1.40887864142888),
(11791, '28106', 218, 33, 4038, 35.1223, 0.612999775873204, -80.7107, -1.40866745658939),
(11792, '28107', 218, 33, 10461, 35.247, 0.615176201450441, -80.5319, -1.40554680788682),
(11793, '28108', 218, 33, 4237, 34.9319, 0.609676668977407, -80.6759, -1.40806008200969),
(11794, '28109', 218, 33, 66885, 35.4836, 0.61930565046066, -80.3216, -1.40187638046988),
(11795, '28110', 218, 33, 10560, 35.01, 0.611039771123215, -80.5494, -1.40585224050592),
(11796, '28111', 218, 33, 10560, 34.9854, 0.610610420127224, -80.5497, -1.40585747649368),
(11797, '28112', 218, 33, 10560, 34.938, 0.609783134061779, -80.5414, -1.40571261416576),
(11798, '28114', 218, 33, 66945, 35.2527, 0.615275685217805, -81.717, -1.42623070485221),
(11799, '28115', 218, 33, 4315, 35.5754, 0.620907862713991, -80.819, -1.4105576481693),
(11800, '28117', 218, 33, 4315, 35.5843, 0.621063197017418, -80.8103, -1.41040580452437),
(11801, '28119', 218, 33, 23197, 34.9455, 0.609914033755678, -80.145, -1.39879412901086),
(11802, '28120', 218, 33, 10633, 35.3072, 0.616226889660142, -81.0327, -1.41428741678081),
(11803, '28123', 218, 33, 67001, 35.5433, 0.620347612024101, -80.847, -1.41104634035986),
(11804, '28124', 218, 33, 118, 35.4106, 0.618031560106704, -80.4196, -1.40358680313683),
(11805, '28125', 218, 33, 67025, 35.6425, 0.622078978642079, -80.7167, -1.40877217634451),
(11806, '28126', 218, 33, 4567, 35.2788, 0.615731216152575, -80.7362, -1.40911251554865),
(11807, '28127', 218, 33, 4547, 35.398, 0.617811648620953, -80.2063, -1.39986401584233),
(11808, '28128', 218, 33, 4648, 35.2277, 0.614839352904806, -80.1232, -1.39841364723392),
(11809, '28129', 218, 33, 67370, 35.2417, 0.615083699000086, -80.3314, -1.40204742273657),
(11810, '28130', 218, 33, 67639, 35.2929, 0.615977307577107, -80.9309, -1.41251067160228),
(11811, '28133', 218, 33, 67647, 35.0168, 0.61115845351235, -80.2629, -1.40085187219896),
(11812, '28134', 218, 33, 5077, 35.0796, 0.612254520282603, -80.8875, -1.41175319870691),
(11813, '28135', 218, 33, 67913, 35.0071, 0.610989156574907, -80.2038, -1.39982038261103),
(11814, '28136', 218, 33, 770, 35.4123, 0.618061230703988, -81.62, -1.42453773547777),
(11815, '28137', 218, 33, 24305, 35.4602, 0.618897243415693, -80.2697, -1.40097055458809),
(11816, '28138', 218, 33, 11640, 35.5414, 0.620314450768313, -80.4307, -1.4037805346838),
(11817, '28139', 218, 33, 68454, 35.3652, 0.617239180626299, -81.9586, -1.43044742032502),
(11818, '28144', 218, 33, 28524, 35.6633, 0.622442007126494, -80.4731, -1.40452055428665),
(11819, '28145', 218, 33, 28524, 35.6603, 0.622389647248934, -80.4464, -1.40405455137637),
(11820, '28146', 218, 33, 28524, 35.6299, 0.621859067156328, -80.4287, -1.40374562809876),
(11821, '28147', 218, 33, 28524, 35.6647, 0.622466441736022, -80.5341, -1.40558520513037),
(11822, '28150', 218, 33, 59, 35.3029, 0.616151840502306, -81.5517, -1.42334567559866),
(11823, '28151', 218, 33, 59, 35.289, 0.615909239736279, -81.5418, -1.42317288800271),
(11824, '28152', 218, 33, 59, 35.2562, 0.615336771741625, -81.5617, -1.42352020852386),
(11825, '28159', 218, 33, 5995, 35.6933, 0.622965605902092, -80.4343, -1.40384336653687),
(11826, '28160', 218, 33, 68995, 35.3584, 0.617120498237163, -81.9264, -1.42988542430588),
(11827, '28163', 218, 33, 69057, 35.2502, 0.615232051986505, -80.404, -1.40331453177352),
(11828, '28164', 218, 33, 196, 35.3617, 0.617178094102479, -81.0868, -1.41523163990614),
(11829, '28166', 218, 33, 25573, 35.7003, 0.623087778949732, -80.8895, -1.41178810529195),
(11830, '28167', 218, 33, 38631, 35.4911, 0.61943655015456, -81.9651, -1.4305608667264),
(11831, '28168', 218, 33, 52327, 35.4914, 0.619441786142315, -81.4159, -1.42097551847445),
(11832, '28169', 218, 33, 6587, 35.3616, 0.617176348773227, -81.4305, -1.42123033654524),
(11833, '28170', 218, 33, 18472, 34.964, 0.610236919667297, -80.0707, -1.39749734937662),
(11834, '28173', 218, 33, 62238, 34.9265, 0.609582421197799, -80.7355, -1.40910029824388),
(11835, '28174', 218, 33, 34455, 34.9861, 0.610622637431988, -80.4487, -1.40409469394916),
(11836, '28201', 218, 33, 8042, 35.1944, 0.614258158263892, -80.8266, -1.41069029319245),
(11837, '28202', 218, 33, 8042, 35.2279, 0.61484284356331, -80.8452, -1.41101492443332),
(11838, '28203', 218, 33, 8042, 35.2091, 0.614514721663936, -80.8581, -1.41124007190683),
(11839, '28204', 218, 33, 8042, 35.2149, 0.614615950760551, -80.8285, -1.41072345444824),
(11840, '28205', 218, 33, 8042, 35.2216, 0.614732887820435, -80.7894, -1.41004103071071),
(11841, '28206', 218, 33, 8042, 35.2518, 0.615259977254537, -80.8238, -1.41064142397339),
(11842, '28207', 218, 33, 8042, 35.1959, 0.614284338202672, -80.8287, -1.41072694510674),
(11843, '28208', 218, 33, 8042, 35.2338, 0.614945817989178, -80.9049, -1.41205688599676),
(11844, '28209', 218, 33, 8042, 35.1783, 0.613977160254321, -80.8548, -1.41118247604151),
(11845, '28210', 218, 33, 8042, 35.1332, 0.613190016761672, -80.8595, -1.41126450651635),
(11846, '28211', 218, 33, 8042, 35.1651, 0.613746776793058, -80.7923, -1.41009164525901),
(11847, '28212', 218, 33, 8042, 35.1923, 0.6142215063496, -80.714, -1.4087250524547),
(11848, '28213', 218, 33, 8042, 35.2908, 0.615940655662815, -80.7811, -1.40989616838279),
(11849, '28214', 218, 33, 8042, 35.2682, 0.615546211251864, -80.9583, -1.41298889181733),
(11850, '28215', 218, 33, 8042, 35.2436, 0.615116860255874, -80.7227, -1.40887689609963),
(11851, '28216', 218, 33, 8042, 35.2864, 0.615863861175727, -80.8803, -1.41162753500077),
(11852, '28217', 218, 33, 8042, 35.1536, 0.613546063929079, -80.9274, -1.41244958507846),
(11853, '28218', 218, 33, 8042, 35.2203, 0.614710198540159, -80.7878, -1.41001310544268),
(11854, '28219', 218, 33, 8042, 35.2059, 0.614458871127872, -80.9423, -1.41270963913701),
(11855, '28220', 218, 33, 8042, 35.1768, 0.613950980315541, -80.8508, -1.41111266287143),
(11856, '28221', 218, 33, 8042, 35.3691, 0.617307248467126, -80.7582, -1.40949648798408),
(11857, '28222', 218, 33, 8042, 35.1906, 0.614191835752317, -80.8049, -1.41031155674477),
(11858, '28223', 218, 33, 8042, 35.3283, 0.616595154132313, -80.7598, -1.40952441325212),
(11859, '28224', 218, 33, 8042, 35.1505, 0.613491958722267, -80.8763, -1.41155772183069),
(11860, '28225', 218, 33, 8042, 35.22, 0.614704962552403, -80.7876, -1.41000961478417),
(11861, '28226', 218, 33, 8042, 35.1081, 0.612751939119421, -80.8057, -1.41032551937878),
(11862, '28227', 218, 33, 8042, 35.1926, 0.614226742337356, -80.6821, -1.40816829242332),
(11863, '28228', 218, 33, 8042, 35.0982, 0.612579151523474, -80.771, -1.40971989012834),
(11864, '28229', 218, 33, 8042, 35.1893, 0.614169146472041, -80.7458, -1.40928006715684),
(11865, '28230', 218, 33, 8042, 35.2146, 0.614610714772795, -80.8283, -1.41071996378973),
(11866, '28231', 218, 33, 8042, 35.1944, 0.614258158263892, -80.8266, -1.41069029319245),
(11867, '28232', 218, 33, 8042, 35.2153, 0.614622932077559, -80.8279, -1.41071298247272),
(11868, '28233', 218, 33, 8042, 35.2148, 0.614614205431299, -80.8285, -1.41072345444824),
(11869, '28234', 218, 33, 8042, 35.1987, 0.614333207421728, -80.8544, -1.4111754947245),
(11870, '28235', 218, 33, 8042, 35.2146, 0.614610714772795, -80.8278, -1.41071123714347),
(11871, '28236', 218, 33, 8042, 35.2917, 0.615956363626083, -81.0142, -1.41396453086919),
(11872, '28237', 218, 33, 8042, 35.2145, 0.614608969443543, -80.8276, -1.41070774648497),
(11873, '28240', 218, 33, 8042, 35.2375, 0.615010395171502, -80.9198, -1.41231694005531),
(11874, '28241', 218, 33, 8042, 35.2281, 0.614846334221814, -80.8445, -1.41100270712856),
(11875, '28242', 218, 33, 8042, 35.2136, 0.614593261480275, -80.8631, -1.41132733836943),
(11876, '28243', 218, 33, 8042, 35.2247, 0.614786993027247, -80.8373, -1.41087704342241),
(11877, '28244', 218, 33, 8042, 35.2282, 0.614848079551066, -80.8447, -1.41100619778706),
(11878, '28246', 218, 33, 8042, 35.228, 0.614844588892562, -80.8445, -1.41100270712856),
(11879, '28247', 218, 33, 8042, 35.105, 0.612697833912609, -80.8225, -1.41061873469312),
(11880, '28250', 218, 33, 8042, 35.2223, 0.614745105125199, -80.8385, -1.41089798737344),
(11881, '28253', 218, 33, 8042, 35.3237, 0.616514868986721, -80.782, -1.40991187634606),
(11882, '28254', 218, 33, 8042, 35.2202, 0.614708453210907, -80.929, -1.41247751034649),
(11883, '28255', 218, 33, 8042, 35.2111, 0.614549628248975, -80.8668, -1.41139191555175),
(11884, '28256', 218, 33, 8042, 35.2845, 0.615830699919939, -80.7297, -1.40899906914727),
(11885, '28258', 218, 33, 8042, 35.2201, 0.614706707881655, -80.9313, -1.41251765291929),
(11886, '28260', 218, 33, 8042, 35.2283, 0.614849824880318, -80.8444, -1.4110009617993),
(11887, '28261', 218, 33, 8042, 35.2284, 0.61485157020957, -80.8441, -1.41099572581155),
(11888, '28262', 218, 33, 8042, 35.3199, 0.616448546475145, -80.7408, -1.40919280069424),
(11889, '28265', 218, 33, 8042, 35.2277, 0.614839352904806, -80.844, -1.4109939804823),
(11890, '28266', 218, 33, 8042, 35.2287, 0.614856806197326, -80.8443, -1.41099921647005),
(11891, '28269', 218, 33, 8042, 35.3169, 0.616396186597585, -80.8063, -1.41033599135429),
(11892, '28270', 218, 33, 8042, 35.1174, 0.612914254739857, -80.7602, -1.40953139456912),
(11893, '28271', 218, 33, 8042, 35.0651, 0.612001447541064, -80.8051, -1.41031504740327),
(11894, '28272', 218, 33, 8042, 35.2279, 0.61484284356331, -80.8439, -1.41099223515304),
(11895, '28273', 218, 33, 8042, 35.1372, 0.613259829931752, -80.9356, -1.41259270207712),
(11896, '28274', 218, 33, 8042, 35.1881, 0.614148202521017, -80.8348, -1.41083341019111),
(11897, '28275', 218, 33, 8042, 35.228, 0.614844588892562, -80.8441, -1.41099572581155),
(11898, '28277', 218, 33, 8042, 35.0658, 0.612013664845828, -80.8053, -1.41031853806177),
(11899, '28278', 218, 33, 8042, 35.0983, 0.612580896852726, -81.0249, -1.41415128109915),
(11900, '28280', 218, 33, 8042, 35.228, 0.614844588892562, -80.8443, -1.41099921647005),
(11901, '28281', 218, 33, 8042, 35.2273, 0.614832371587798, -80.8438, -1.41099048982379),
(11902, '28282', 218, 33, 8042, 35.2277, 0.614839352904806, -80.8443, -1.41099921647005),
(11903, '28283', 218, 33, 8042, 35.1945, 0.614259903593144, -80.8267, -1.4106920385217),
(11904, '28284', 218, 33, 8042, 35.2274, 0.61483411691705, -80.8439, -1.41099223515304),
(11905, '28285', 218, 33, 8042, 35.2276, 0.614837607575555, -80.8448, -1.41100794311631),
(11906, '28286', 218, 33, 8042, 35.2278, 0.614841098234058, -80.844, -1.4109939804823),
(11907, '28287', 218, 33, 8042, 35.1311, 0.61315336484738, -80.8552, -1.41118945735852),
(11908, '28288', 218, 33, 8042, 35.2268, 0.614823644941538, -80.8436, -1.41098699916529),
(11909, '28289', 218, 33, 8042, 35.229, 0.614862042185082, -80.844, -1.4109939804823),
(11910, '28290', 218, 33, 8042, 35.2368, 0.614998177866738, -80.9152, -1.41223665490972),
(11911, '28296', 218, 33, 8042, 35.2142, 0.614603733455787, -80.827, -1.41069727450946),
(11912, '28297', 218, 33, 8042, 35.2765, 0.61569107357978, -80.8561, -1.41120516532179),
(11913, '28299', 218, 33, 8042, 35.2194, 0.614694490576891, -80.8122, -1.41043896578016),
(11914, '28301', 218, 33, 2428, 35.0658, 0.612013664845828, -78.8669, -1.37648707584112),
(11915, '28302', 218, 33, 2428, 35.0343, 0.611463886131449, -78.9321, -1.37762503051342),
(11916, '28303', 218, 33, 2428, 35.0836, 0.612324333452683, -78.9614, -1.37813641198425),
(11917, '28304', 218, 33, 2428, 35.0335, 0.611449923497433, -78.9707, -1.37829872760469),
(11918, '28305', 218, 33, 2428, 35.0542, 0.611811206652596, -78.9063, -1.3771747355664),
(11919, '28306', 218, 33, 2428, 35.0089, 0.611020572501443, -78.9309, -1.37760408656239),
(11920, '28307', 218, 33, 181646, 35.1315, 0.613160346164388, -78.9914, -1.37866001075985),
(11921, '28308', 218, 33, 0, 35.1665, 0.613771211402586, -79.0046, -1.37889039422111),
(11922, '28309', 218, 33, 2428, 35.0717, 0.612116639271695, -78.8994, -1.37705430784801),
(11923, '28310', 218, 33, 181646, 35.139, 0.613291245858288, -79.0012, -1.37883105302654),
(11924, '28311', 218, 33, 2428, 35.1292, 0.613120203591592, -78.8992, -1.37705081718951),
(11925, '28314', 218, 33, 2428, 35.059, 0.611894982456692, -79.0034, -1.37886945027009),
(11926, '28315', 218, 33, 7017, 35.1454, 0.613402946930415, -79.425, -1.3862277583965),
(11927, '28318', 218, 33, 62633, 34.9917, 0.6107203758701, -78.5773, -1.37143260232734),
(11928, '28319', 218, 33, 19061, 34.3856, 0.600141935273762, -79.0626, -1.37990268518727),
(11929, '28320', 218, 33, 62997, 34.5307, 0.602674408018406, -78.7967, -1.37526185470622),
(11930, '28323', 218, 33, 63294, 35.2926, 0.615972071589351, -78.833, -1.37589540922469),
(11931, '28325', 218, 33, 63371, 34.9977, 0.610825095625219, -77.989, -1.36116483033786),
(11932, '28326', 218, 33, 806, 35.3445, 0.616877897471136, -79.2261, -1.38275629851428),
(11933, '28327', 218, 33, 7932, 35.2855, 0.615848153212459, -79.3911, -1.38563609178007),
(11934, '28328', 218, 33, 1630, 35.0004, 0.610872219515023, -78.3374, -1.36724555745181),
(11935, '28329', 218, 33, 1630, 35, 0.610865238198015, -78.332, -1.3671513096722),
(11936, '28330', 218, 33, 924, 34.9141, 0.609366000370552, -79.8238, -1.39318813145345),
(11937, '28331', 218, 33, 20409, 35.0006, 0.610875710173527, -78.9724, -1.37832839820197),
(11938, '28332', 218, 33, 2113, 34.6569, 0.604877013534423, -78.7267, -1.37404012422982),
(11939, '28333', 218, 33, 2116, 35.2933, 0.615984288894115, -78.0224, -1.36174777030802),
(11940, '28334', 218, 33, 2135, 35.3119, 0.616308920134986, -78.6162, -1.37211153540637),
(11941, '28335', 218, 33, 2135, 35.3064, 0.616212927026126, -78.6093, -1.37199110768798),
(11942, '28337', 218, 33, 27070, 34.6264, 0.604344688112564, -78.6029, -1.37187940661585),
(11943, '28338', 218, 33, 64497, 35.0675, 0.612043335443112, -79.7557, -1.39199956223284),
(11944, '28339', 218, 33, 8778, 35.3266, 0.616565483535029, -78.6729, -1.37310113709225),
(11945, '28340', 218, 33, 27132, 34.5025, 0.602182225169344, -79.1148, -1.38081374705681),
(11946, '28341', 218, 33, 64654, 35.1074, 0.612739721814657, -78.1029, -1.36315276035588),
(11947, '28342', 218, 33, 8837, 35.1901, 0.614183109106057, -78.6519, -1.37273461794933),
(11948, '28343', 218, 33, 2709, 34.7901, 0.607201792098079, -79.5525, -1.38845305319279),
(11949, '28344', 218, 33, 65084, 35.195, 0.614268630239404, -78.6621, -1.37291264153303),
(11950, '28345', 218, 33, 9305, 34.89, 0.608945376020822, -79.7081, -1.39116878550889),
(11951, '28347', 218, 33, 27449, 35.0407, 0.611575587203577, -79.5596, -1.38857697156968),
(11952, '28348', 218, 33, 65746, 34.9679, 0.610304987508125, -78.9452, -1.37785366864543),
(11953, '28349', 218, 33, 16700, 34.9621, 0.61020375841151, -77.9601, -1.36066043018403),
(11954, '28350', 218, 33, 3619, 35.2432, 0.615109878938866, -79.3092, -1.38420666712269),
(11955, '28351', 218, 33, 16858, 34.872, 0.608631216755463, -79.5497, -1.38840418397373),
(11956, '28352', 218, 33, 66276, 34.7658, 0.606777677089845, -79.4694, -1.38700268458438),
(11957, '28353', 218, 33, 66276, 34.7738, 0.606917303430004, -79.4634, -1.38689796482926),
(11958, '28355', 218, 33, 66322, 35.3958, 0.617773251377409, -79.1897, -1.38212099866655),
(11959, '28356', 218, 33, 3784, 35.2291, 0.614863787514334, -78.7958, -1.37524614674295),
(11960, '28357', 218, 33, 66521, 34.8905, 0.608954102667082, -79.078, -1.38017146589208),
(11961, '28358', 218, 33, 16965, 34.6276, 0.604365632063589, -79.0055, -1.37890610218438),
(11962, '28359', 218, 33, 16965, 34.6252, 0.604323744161541, -79.0106, -1.37899511397623),
(11963, '28360', 218, 33, 16965, 34.6182, 0.604201571113901, -79.0088, -1.3789636980497),
(11964, '28361', 218, 33, 66701, 35.0683, 0.612057298077128, -79.3355, -1.38466568871596),
(11965, '28362', 218, 33, 3993, 34.3676, 0.599827776008403, -79.1218, -1.38093592010445),
(11966, '28363', 218, 33, 49262, 34.9933, 0.610748301138132, -79.6203, -1.38963638642564),
(11967, '28364', 218, 33, 66677, 34.7387, 0.606304692862554, -79.3403, -1.38474946452006),
(11968, '28365', 218, 33, 590, 35.1963, 0.61429131951968, -78.0673, -1.36253142314217),
(11969, '28366', 218, 33, 67205, 35.0183, 0.61118463345113, -78.5018, -1.37011487874208),
(11970, '28367', 218, 33, 4593, 35.1697, 0.61382706193865, -79.7228, -1.39142534890894),
(11971, '28368', 218, 33, 67498, 35.3594, 0.617137951529683, -79.1092, -1.3807160086187),
(11972, '28369', 218, 33, 67526, 34.4272, 0.600867992242592, -79.0235, -1.37922026144974),
(11973, '28370', 218, 33, 23951, 35.1803, 0.614012066839361, -79.4616, -1.38686654890273),
(11974, '28371', 218, 33, 50219, 34.9001, 0.609121654275273, -79.0073, -1.37893751811092),
(11975, '28372', 218, 33, 17567, 34.6818, 0.605311600518169, -79.1944, -1.3822030291414),
(11976, '28373', 218, 33, 67781, 35.1039, 0.612678635290838, -79.4714, -1.38703759116942),
(11977, '28374', 218, 33, 23951, 35.1875, 0.614137730545505, -79.4707, -1.38702537386466),
(11978, '28375', 218, 33, 57050, 34.4758, 0.601716222259061, -79.0383, -1.37947857017903),
(11979, '28376', 218, 33, 68060, 34.9874, 0.610645326712264, -79.2067, -1.38241770463939),
(11980, '28377', 218, 33, 5321, 34.8128, 0.607597981838282, -79.1852, -1.38204245885021),
(11981, '28378', 218, 33, 11547, 34.8566, 0.608362436050655, -79.0492, -1.3796688110675),
(11982, '28379', 218, 33, 24462, 34.936, 0.609748227476739, -79.7614, -1.39209904600021),
(11983, '28380', 218, 33, 24462, 34.9395, 0.609809314000559, -79.7623, -1.39211475396347),
(11984, '28382', 218, 33, 5561, 34.9518, 0.610023989498554, -78.514, -1.37032780891083),
(11985, '28383', 218, 33, 24550, 34.5365, 0.602775637115022, -79.2927, -1.38391868779611),
(11986, '28384', 218, 33, 51181, 34.8047, 0.60745661016887, -78.9729, -1.37833712484823),
(11987, '28385', 218, 33, 68494, 35.0179, 0.611177652134122, -78.5039, -1.37015153065638),
(11988, '28386', 218, 33, 5777, 34.9054, 0.609214156725629, -79.1646, -1.3816829210243),
(11989, '28387', 218, 33, 51575, 35.1747, 0.613914328401249, -79.3887, -1.38559420387802),
(11990, '28388', 218, 33, 51575, 35.1831, 0.614060936058417, -79.4021, -1.38582807799779),
(11991, '28390', 218, 33, 14657, 35.1761, 0.613938763010777, -78.9753, -1.37837901275028),
(11992, '28391', 218, 33, 6065, 35.023, 0.611266663925974, -78.7032, -1.3736299718556),
(11993, '28392', 218, 33, 69309, 34.7324, 0.606194737119679, -78.7933, -1.37520251351165),
(11994, '28393', 218, 33, 12408, 34.9577, 0.610126963924422, -78.2065, -1.36496092146095),
(11995, '28394', 218, 33, 779, 35.2429, 0.61510464295111, -79.2262, -1.38275804384353),
(11996, '28395', 218, 33, 12580, 35.1605, 0.613666491647466, -78.7374, -1.37422687445978),
(11997, '28396', 218, 33, 69838, 34.908, 0.609259535286181, -79.384, -1.38551217340318),
(11998, '28398', 218, 33, 6638, 35.0003, 0.610870474185771, -78.09, -1.36292761288237),
(11999, '28399', 218, 33, 903, 34.787, 0.607147686891267, -78.7212, -1.37394413112096),
(12000, '28401', 218, 33, 14869, 34.2292, 0.597412240323643, -77.9355, -1.36023107918804),
(12001, '28402', 218, 33, 14869, 34.2368, 0.597544885346795, -77.95, -1.36048415192958),
(12002, '28403', 218, 33, 14869, 34.2026, 0.596947982742613, -77.881, -1.3592798747457),
(12003, '28404', 218, 33, 14869, 33.9258, 0.592116911373092, -78.071, -1.36259600032449),
(12004, '28405', 218, 33, 14869, 34.2633, 0.598007397598573, -77.8401, -1.35856603508164),
(12005, '28406', 218, 33, 14869, 34.175, 0.596466271869062, -77.885, -1.35934968791578),
(12006, '28407', 218, 33, 14869, 34.1576, 0.596162584579215, -77.8926, -1.35948233293894),
(12007, '28408', 218, 33, 14869, 34.2258, 0.597352899129075, -77.9452, -1.36040037612548),
(12008, '28409', 218, 33, 14869, 34.1631, 0.596258577688075, -77.8722, -1.35912628577153),
(12009, '28410', 218, 33, 14869, 34.1263, 0.595616296523341, -77.9541, -1.36055571042891),
(12010, '28411', 218, 33, 14869, 34.2256, 0.597349408470571, -77.9454, -1.36040386678399),
(12011, '28412', 218, 33, 14869, 34.1446, 0.595935691776456, -77.913, -1.35983838010634),
(12012, '28420', 218, 33, 18928, 34.0549, 0.594370131437417, -78.5192, -1.37041856603193),
(12013, '28421', 218, 33, 18953, 34.5267, 0.602604594848326, -78.1734, -1.36438321747854),
(12014, '28422', 218, 33, 26567, 33.987, 0.593185052875313, -78.2209, -1.36521224887323),
(12015, '28423', 218, 33, 19382, 34.1775, 0.596509905100362, -78.3943, -1.36823864979619),
(12016, '28424', 218, 33, 19602, 34.2926, 0.598518779069407, -78.7074, -1.37370327568419),
(12017, '28425', 218, 33, 63301, 34.5507, 0.603023473868805, -77.9356, -1.36023282451729),
(12018, '28428', 218, 33, 63451, 34.0368, 0.594054226842806, -77.8988, -1.35959054335256),
(12019, '28429', 218, 33, 63500, 34.3261, 0.599103464368825, -77.9097, -1.35978078424103),
(12020, '28430', 218, 33, 26750, 34.2888, 0.598452456557832, -78.9256, -1.37751158411204),
(12021, '28431', 218, 33, 63595, 34.322, 0.599031905869494, -78.8257, -1.37576800018929),
(12022, '28432', 218, 33, 8087, 34.176, 0.596483725161582, -78.7959, -1.3752478920722),
(12023, '28433', 218, 33, 54064, 34.519, 0.602470204495923, -78.6451, -1.37261593556019),
(12024, '28434', 218, 33, 8249, 34.4523, 0.601306069884842, -78.4394, -1.36902579328884),
(12025, '28435', 218, 33, 59179, 34.4089, 0.600548596989477, -78.1042, -1.36317544963616),
(12026, '28436', 218, 33, 64178, 34.3382, 0.599314649208317, -78.1858, -1.36459963830578),
(12027, '28438', 218, 33, 2343, 34.4125, 0.600611428842549, -78.8948, -1.37697402270242),
(12028, '28439', 218, 33, 64599, 34.3054, 0.598742181213663, -79.0024, -1.37885199697757),
(12029, '28441', 218, 33, 2663, 34.8218, 0.607755061470961, -78.331, -1.36713385637968),
(12030, '28442', 218, 33, 65321, 34.295, 0.598560666971455, -78.5978, -1.371790394824),
(12031, '28443', 218, 33, 47803, 34.3954, 0.600312977540458, -77.6526, -1.35529354273415),
(12032, '28444', 218, 33, 65393, 34.7234, 0.606037657486999, -78.1928, -1.36472181135342),
(12033, '28445', 218, 33, 13981, 34.3886, 0.600194295151322, -77.5983, -1.35434582895032),
(12034, '28446', 218, 33, 65865, 34.827, 0.607845818592065, -78.3475, -1.36742183570626),
(12035, '28447', 218, 33, 3375, 34.6967, 0.605571654576717, -78.1633, -1.36420693922408),
(12036, '28448', 218, 33, 3492, 34.4806, 0.601799998063157, -78.3153, -1.36685983968712),
(12037, '28449', 218, 33, 66156, 33.9961, 0.593343877837244, -77.9099, -1.35978427489953),
(12038, '28450', 218, 33, 66195, 34.3135, 0.598883552883074, -78.5072, -1.37020912652169),
(12039, '28451', 218, 33, 10032, 34.2151, 0.597166148899112, -78.039, -1.36203749496386),
(12040, '28452', 218, 33, 3863, 33.9586, 0.592689379367746, -78.5482, -1.37092471151501),
(12041, '28453', 218, 33, 3947, 34.8941, 0.609016934520153, -78.0406, -1.36206542023189),
(12042, '28454', 218, 33, 3980, 34.6021, 0.60392057310433, -77.7671, -1.35729194472768),
(12043, '28455', 218, 33, 67103, 34.1123, 0.595371950428062, -78.6541, -1.37277301519287),
(12044, '28456', 218, 33, 68231, 34.3486, 0.599496163450524, -78.267, -1.3660168456584),
(12045, '28457', 218, 33, 5490, 34.4132, 0.600623646147313, -77.9161, -1.35989248531315),
(12046, '28458', 218, 33, 5540, 34.8255, 0.607819638653285, -78.0265, -1.36181932880736),
(12047, '28459', 218, 33, 68682, 33.9051, 0.591755628217929, -78.4835, -1.36979548348897),
(12048, '28460', 218, 33, 68887, 34.5304, 0.60266917203065, -77.3873, -1.35066318422861),
(12049, '28461', 218, 33, 18161, 33.9709, 0.592904054865742, -78.0351, -1.36196942712303),
(12050, '28462', 218, 33, 12224, 33.9151, 0.591930161143129, -78.3054, -1.36668705209117),
(12051, '28463', 218, 33, 69297, 34.1482, 0.595998523629528, -78.8764, -1.37665288212006),
(12052, '28464', 218, 33, 69338, 34.7702, 0.606854471576932, -78.0113, -1.36155403876105),
(12053, '28465', 218, 33, 67355, 33.9158, 0.591942378447893, -78.1328, -1.36367461380223),
(12054, '28466', 218, 33, 721, 34.737, 0.60627502226527, -77.9966, -1.36129747536101),
(12055, '28467', 218, 33, 63351, 33.9008, 0.591680579060094, -78.5791, -1.37146401825388),
(12056, '28468', 218, 33, 18241, 33.885, 0.591404817038279, -78.5123, -1.37029813831354),
(12057, '28469', 218, 33, 67424, 33.921, 0.592033135568997, -78.4599, -1.3693835857855),
(12058, '28470', 218, 33, 68682, 33.9577, 0.592673671404478, -78.3936, -1.36822643249143),
(12059, '28471', 218, 33, 69917, 34.6191, 0.604217279077169, -78.0153, -1.36162385193113),
(12060, '28472', 218, 33, 12831, 34.334, 0.599241345379733, -78.7036, -1.37363695317261),
(12061, '28478', 218, 33, 26074, 34.6677, 0.605065509093638, -78.0676, -1.36253665912993),
(12062, '28479', 218, 33, 70281, 34.2046, 0.596982889327652, -78.1074, -1.36323130017222),
(12063, '28480', 218, 33, 70396, 34.2094, 0.597066665131748, -77.7983, -1.3578364874543),
(12064, '28501', 218, 33, 3551, 35.2723, 0.615617769751196, -77.5991, -1.35435979158433),
(12065, '28502', 218, 33, 3551, 35.2635, 0.61546418077702, -77.576, -1.35395662052712),
(12066, '28503', 218, 33, 3551, 35.2786, 0.615727725494072, -77.5826, -1.35407181225775),
(12067, '28504', 218, 33, 3551, 35.2758, 0.615678856275016, -77.5902, -1.3542044572809),
(12068, '28508', 218, 33, 13268, 35.1155, 0.612881093484069, -77.8508, -1.3587527853116),
(12069, '28509', 218, 33, 14970, 35.1463, 0.613418654893683, -76.7989, -1.34039366690987),
(12070, '28510', 218, 33, 62553, 34.9795, 0.610507445701357, -76.8273, -1.34088934041744),
(12071, '28511', 218, 33, 62617, 34.8931, 0.608999481227633, -76.3394, -1.33237387899696),
(12072, '28512', 218, 33, 15047, 34.6998, 0.605625759783528, -76.7811, -1.34008299830302),
(12073, '28513', 218, 33, 62647, 35.4684, 0.619040360414357, -77.4209, -1.35124961485728),
(12074, '28515', 218, 33, 62752, 35.1343, 0.613209215383444, -76.7598, -1.33971124317234),
(12075, '28516', 218, 33, 53378, 34.7293, 0.606140631912867, -76.6533, -1.33785246751897),
(12076, '28518', 218, 33, 62933, 34.9168, 0.609413124260356, -77.8202, -1.35821871456049),
(12077, '28519', 218, 33, 1132, 35.1218, 0.612991049226944, -77.0211, -1.3442717885078),
(12078, '28520', 218, 33, 63561, 34.9978, 0.610826840954471, -76.2376, -1.33059713381843),
(12079, '28521', 218, 33, 58988, 34.8264, 0.607835346616553, -77.7456, -1.3569166989385),
(12080, '28522', 218, 33, 63857, 35.0037, 0.610929815380339, -77.5204, -1.35298621746301),
(12081, '28523', 218, 33, 63978, 35.207, 0.614478069749644, -77.2933, -1.34902257473173),
(12082, '28524', 218, 33, 20476, 34.7974, 0.607329201133475, -76.461, -1.33449619936738),
(12083, '28525', 218, 33, 46232, 35.1273, 0.613087042335804, -77.7259, -1.35657286907586),
(12084, '28526', 218, 33, 8583, 35.2646, 0.615483379398792, -77.361, -1.35020416263533),
(12085, '28527', 218, 33, 64561, 35.2417, 0.615083699000086, -77.0258, -1.34435381898265),
(12086, '28528', 218, 33, 65078, 34.6866, 0.605395376322265, -76.5273, -1.33565335266146),
(12087, '28529', 218, 33, 65145, 35.1395, 0.613299972504547, -76.8205, -1.3407706580283),
(12088, '28530', 218, 33, 65252, 35.3812, 0.617518433306618, -77.431, -1.35142589311173),
(12089, '28531', 218, 33, 65378, 34.725, 0.606065582755031, -76.5683, -1.33636893765477),
(12090, '28532', 218, 33, 65428, 34.8922, 0.608983773264365, -76.9008, -1.34217215741766),
(12091, '28533', 218, 33, 26770, 34.9042, 0.609193212774605, -76.9012, -1.34217913873466),
(12092, '28537', 218, 33, 65660, 35.2676, 0.615535739276352, -76.5387, -1.33585232019618),
(12093, '28538', 218, 33, 65736, 35.4276, 0.618328266079543, -77.5487, -1.35348014564133),
(12094, '28539', 218, 33, 22085, 34.6927, 0.605501841406637, -77.2063, -1.3475041382825),
(12095, '28540', 218, 33, 3395, 34.7664, 0.606788149065357, -77.4339, -1.35147650766004),
(12096, '28541', 218, 33, 3395, 34.7649, 0.606761969126577, -77.4044, -1.3509616355307),
(12097, '28542', 218, 33, 0, 34.6996, 0.605622269125024, -77.353, -1.35006453629517),
(12098, '28543', 218, 33, 0, 34.7342, 0.606226153046214, -77.3778, -1.35049737794967),
(12099, '28544', 218, 33, 14230, 34.7258, 0.606079545389047, -77.321, -1.34950603093454),
(12100, '28545', 218, 33, 0, 34.6856, 0.605377923029745, -77.3417, -1.3498673140897),
(12101, '28546', 218, 33, 3395, 34.7739, 0.606919048759256, -77.3803, -1.35054101118097),
(12102, '28547', 218, 33, 0, 34.7056, 0.605726988880144, -77.3501, -1.35001392174687),
(12103, '28551', 218, 33, 3584, 35.3078, 0.616237361635654, -77.792, -1.35772653171143),
(12104, '28552', 218, 33, 66513, 35.3068, 0.616219908343134, -76.5721, -1.33643526016635),
(12105, '28553', 218, 33, 66642, 34.731, 0.606170302510151, -76.5108, -1.33536537333488),
(12106, '28554', 218, 33, 66675, 35.4819, 0.619275979863376, -77.5866, -1.35414162542783),
(12107, '28555', 218, 33, 4063, 34.8401, 0.608074456724076, -77.246, -1.34819703399554),
(12108, '28556', 218, 33, 27880, 35.112, 0.612820006960249, -76.6957, -1.33859248712182),
(12109, '28557', 218, 33, 66951, 34.7257, 0.606077800059795, -76.7603, -1.3397199698186),
(12110, '28560', 218, 33, 67139, 35.0961, 0.612542499609182, -77.0268, -1.34437127227517),
(12111, '28561', 218, 33, 67139, 35.1001, 0.612612312779262, -77.0804, -1.34530676875424),
(12112, '28562', 218, 33, 67139, 35.0941, 0.612507593024142, -77.1007, -1.34566107059239),
(12113, '28563', 218, 33, 67139, 35.1362, 0.613242376639232, -77.0034, -1.3439628652302),
(12114, '28564', 218, 33, 67139, 35.0731, 0.612141073881223, -77.0242, -1.34432589371462),
(12115, '28570', 218, 33, 10799, 34.7692, 0.606837018284412, -76.8726, -1.34167997456859),
(12116, '28571', 218, 33, 67519, 35.0322, 0.611427234217158, -76.6952, -1.33858376047556),
(12117, '28572', 218, 33, 56911, 35.0524, 0.61177979072606, -77.7455, -1.35691495360925),
(12118, '28573', 218, 33, 67915, 35.0024, 0.610907126100063, -77.2314, -1.34794221592475),
(12119, '28574', 218, 33, 68201, 34.8296, 0.607891197152617, -77.579, -1.35400898040468),
(12120, '28575', 218, 33, 68500, 34.6851, 0.605369196383485, -76.9019, -1.34219135603943),
(12121, '28577', 218, 33, 68621, 34.896, 0.609050095775941, -76.3932, -1.33331286613453),
(12122, '28578', 218, 33, 18039, 35.2078, 0.61449203238366, -77.9168, -1.35990470261792),
(12123, '28579', 218, 33, 452, 34.8017, 0.607404250291311, -76.5117, -1.33538108129815),
(12124, '28580', 218, 33, 192, 35.4467, 0.618661623966674, -77.6778, -1.35573336570565),
(12125, '28581', 218, 33, 985, 34.8591, 0.608406069281955, -76.4257, -1.33388009814143),
(12126, '28582', 218, 33, 12121, 34.751, 0.606519368360549, -77.1536, -1.3465843497667),
(12127, '28583', 218, 33, 6104, 35.138, 0.613273792565768, -76.7414, -1.33939010258998),
(12128, '28584', 218, 33, 69276, 34.698, 0.605594343856993, -77.068, -1.34509034792699),
(12129, '28585', 218, 33, 6381, 35.0682, 0.612055552747875, -77.4114, -1.35108380857834),
(12130, '28586', 218, 33, 69774, 35.3028, 0.616150095173054, -77.1481, -1.34648835665784),
(12131, '28587', 218, 33, 69776, 35.1848, 0.614090606655701, -76.664, -1.33803921774893),
(12132, '28589', 218, 33, 18638, 34.7891, 0.607184338805559, -76.5058, -1.33527810687228),
(12133, '28590', 218, 33, 26164, 35.5326, 0.620160861794137, -77.3926, -1.35075568667896),
(12134, '28594', 218, 33, 64524, 34.6665, 0.605044565142614, -77.0201, -1.34425433521528),
(12135, '28601', 218, 33, 3077, 35.7454, 0.623874922442381, -81.3286, -1.41945184603746),
(12136, '28602', 218, 33, 3077, 35.7134, 0.623316417081743, -81.3506, -1.4198358184729),
(12137, '28603', 218, 33, 3077, 35.758, 0.624094833928132, -81.3304, -1.419483261964),
(12138, '28604', 218, 33, 62696, 36.1777, 0.631419980798753, -81.8095, -1.4278451344103),
(12139, '28605', 218, 33, 63014, 36.1169, 0.63035882061354, -81.6797, -1.42557969704121),
(12140, '28606', 218, 33, 63058, 36.2263, 0.632268210815222, -81.099, -1.41544457007488),
(12141, '28607', 218, 33, 7601, 36.208, 0.631948815562107, -81.6792, -1.42557097039495),
(12142, '28608', 218, 33, 7601, 36.2096, 0.631976740830139, -81.6698, -1.42540690944526);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(12143, '28609', 218, 33, 15461, 35.6765, 0.622672390587757, -81.04, -1.4144148258162),
(12144, '28610', 218, 33, 26794, 35.7074, 0.623211697326623, -81.1447, -1.41624218554304),
(12145, '28611', 218, 33, 63818, 35.9923, 0.628184140365555, -81.7146, -1.42618881695016),
(12146, '28612', 218, 33, 0, 35.8189, 0.625157739442597, -81.6186, -1.42451330086824),
(12147, '28613', 218, 33, 63880, 35.7108, 0.623271038521191, -81.2101, -1.41738363087385),
(12148, '28615', 218, 33, 35429, 36.4385, 0.635971799487954, -81.4173, -1.42099995308398),
(12149, '28616', 218, 33, 64056, 36.0925, 0.629932960276053, -81.8534, -1.42861133395193),
(12150, '28617', 218, 33, 64064, 36.4759, 0.6366245526282, -81.3798, -1.42034545461448),
(12151, '28618', 218, 33, 0, 36.1937, 0.631699233479072, -81.5278, -1.42292854190743),
(12152, '28619', 218, 33, 15817, 35.7554, 0.624049455367581, -81.6067, -1.42430560668726),
(12153, '28621', 218, 33, 35739, 36.2566, 0.632797045578576, -80.8522, -1.41113709748096),
(12154, '28622', 218, 33, 64482, 36.1734, 0.631344931640917, -81.9574, -1.430426476374),
(12155, '28623', 218, 33, 64548, 36.5251, 0.637483254620181, -80.9752, -1.41328385246091),
(12156, '28624', 218, 33, 2432, 36.1319, 0.630620620001339, -81.4146, -1.42095282919418),
(12157, '28625', 218, 33, 6061, 35.7825, 0.624522439594871, -80.8872, -1.41174796271916),
(12158, '28626', 218, 33, 2491, 36.4052, 0.63539060484704, -81.4914, -1.42229324205971),
(12159, '28627', 218, 33, 65027, 36.4415, 0.636024159365514, -81.0159, -1.41399420146647),
(12160, '28628', 218, 33, 65031, 35.7226, 0.623476987372926, -81.7816, -1.42735818754899),
(12161, '28629', 218, 33, 65048, 36.3453, 0.634345152625095, -81.3809, -1.42036465323625),
(12162, '28630', 218, 33, 65139, 35.8022, 0.624866269457514, -81.4436, -1.42145897467725),
(12163, '28631', 218, 33, 532, 36.5438, 0.637809631190304, -81.4319, -1.42125477115477),
(12164, '28633', 218, 33, 66320, 35.9065, 0.626686647867344, -81.5351, -1.42305595094283),
(12165, '28634', 218, 33, 745, 35.9553, 0.627538368542317, -80.7733, -1.40976003270114),
(12166, '28635', 218, 33, 32724, 36.3573, 0.634554592135334, -81.1259, -1.41591406364367),
(12167, '28636', 218, 33, 65567, 35.7995, 0.62481914556771, -81.4205, -1.42105580362004),
(12168, '28637', 218, 33, 65608, 35.7182, 0.623400192885839, -81.4255, -1.42114307008264),
(12169, '28638', 218, 33, 16505, 35.8448, 0.625609779718863, -81.4942, -1.42234211127876),
(12170, '28640', 218, 33, 3409, 36.4235, 0.635710000100155, -81.4667, -1.42186214573446),
(12171, '28641', 218, 33, 65990, 35.8841, 0.626295694114897, -81.7413, -1.42665481986044),
(12172, '28642', 218, 33, 3455, 36.2322, 0.632371185241089, -80.8416, -1.41095209258025),
(12173, '28643', 218, 33, 9985, 36.5284, 0.637540850485497, -81.547, -1.42326364512382),
(12174, '28644', 218, 33, 66270, 36.4443, 0.636073028584569, -81.2531, -1.4181341224522),
(12175, '28645', 218, 33, 66320, 35.8989, 0.626554002844192, -81.5333, -1.42302453501629),
(12176, '28646', 218, 33, 41810, 36.0675, 0.629496627963055, -81.8744, -1.42897785309485),
(12177, '28647', 218, 33, 66395, 35.9591, 0.627604691053893, -81.9429, -1.43017340363246),
(12178, '28649', 218, 33, 66725, 36.3224, 0.633945472226388, -81.1901, -1.41703456502345),
(12179, '28650', 218, 33, 66569, 35.5746, 0.620893900079975, -81.2059, -1.41731032704526),
(12180, '28651', 218, 33, 37204, 36.271, 0.633048372990863, -81.2838, -1.41866993853257),
(12181, '28652', 218, 33, 33298, 36.0987, 0.630041170689677, -81.9868, -1.43093960317409),
(12182, '28653', 218, 33, 23157, 36.0653, 0.629458230719511, -81.9031, -1.42947876259017),
(12183, '28654', 218, 33, 66949, 36.0994, 0.630053387994441, -81.1785, -1.41683210683022),
(12184, '28655', 218, 33, 10596, 35.7362, 0.623714352151198, -81.6944, -1.42583626044126),
(12185, '28656', 218, 33, 67285, 36.2027, 0.631856313111751, -81.0782, -1.41508154159047),
(12186, '28657', 218, 33, 56523, 36.0226, 0.628712975128909, -81.9495, -1.43028859536309),
(12187, '28658', 218, 33, 4570, 35.6603, 0.622389647248934, -81.2333, -1.41778854726031),
(12188, '28659', 218, 33, 67285, 36.2321, 0.632369439911837, -81.1119, -1.41566971754839),
(12189, '28660', 218, 33, 37518, 35.9556, 0.627543604530073, -80.8532, -1.41115455077348),
(12190, '28661', 218, 33, 428, 35.9993, 0.628306313413195, -81.5642, -1.42356384175516),
(12191, '28662', 218, 33, 5073, 36.0281, 0.628808968237769, -81.8916, -1.42927804972619),
(12192, '28663', 218, 33, 50416, 36.5617, 0.638122045126411, -81.2825, -1.41864724925229),
(12193, '28664', 218, 33, 67901, 36.0273, 0.628795005603753, -82.0079, -1.43130786764626),
(12194, '28665', 218, 33, 68011, 36.2172, 0.63210938585329, -81.3889, -1.42050427957641),
(12195, '28666', 218, 33, 65840, 35.6469, 0.622155773129167, -81.2609, -1.41827025813386),
(12196, '28667', 218, 33, 68185, 35.7761, 0.624410738522743, -81.4303, -1.42122684588674),
(12197, '28668', 218, 33, 68274, 36.4039, 0.635367915566764, -81.0046, -1.413796979261),
(12198, '28669', 218, 33, 68275, 36.1879, 0.631598004382456, -81.0005, -1.41372542076167),
(12199, '28670', 218, 33, 68363, 36.1966, 0.631749848027379, -80.9293, -1.41248274633425),
(12200, '28671', 218, 33, 68452, 35.7523, 0.623995350160769, -81.5223, -1.42283254879857),
(12201, '28672', 218, 33, 28557, 36.4749, 0.63660709933568, -81.3802, -1.42035243593149),
(12202, '28673', 218, 33, 68737, 35.5925, 0.621206314016082, -80.9994, -1.41370622213989),
(12203, '28674', 218, 33, 67285, 36.1702, 0.631289081104853, -81.1427, -1.416207278958),
(12204, '28675', 218, 33, 25003, 36.5056, 0.637142915416042, -81.118, -1.41577618263276),
(12205, '28676', 218, 33, 69075, 36.3953, 0.635217817251092, -80.8909, -1.41181253990148),
(12206, '28677', 218, 33, 6061, 35.7886, 0.624628904679243, -80.8798, -1.41161880835451),
(12207, '28678', 218, 33, 12143, 35.8521, 0.625737188754259, -81.0396, -1.4144078444992),
(12208, '28679', 218, 33, 12174, 36.2599, 0.632854641443892, -81.8421, -1.42841411174645),
(12209, '28680', 218, 33, 10596, 35.7415, 0.623806854601553, -81.6984, -1.42590607361134),
(12210, '28681', 218, 33, 25360, 35.9073, 0.62670061050136, -81.1853, -1.41695078921935),
(12211, '28682', 218, 33, 18311, 35.5823, 0.621028290432378, -80.9632, -1.41307441295067),
(12212, '28683', 218, 33, 69406, 36.3635, 0.634662802548958, -80.9408, -1.41268345919823),
(12213, '28684', 218, 33, 43366, 36.3249, 0.633989105457688, -81.6053, -1.42428117207773),
(12214, '28685', 218, 33, 69601, 36.3448, 0.634336425978835, -81.0295, -1.41423156624475),
(12215, '28687', 218, 33, 6061, 35.7781, 0.624445645107783, -80.9105, -1.41215462443487),
(12216, '28688', 218, 33, 69660, 35.8297, 0.625346235001812, -80.9011, -1.41199056348518),
(12217, '28689', 218, 33, 6461, 36.0396, 0.629009681101748, -80.9106, -1.41215636976412),
(12218, '28690', 218, 33, 69750, 35.7402, 0.623784165321277, -81.5629, -1.42354115247488),
(12219, '28691', 218, 33, 69754, 36.2082, 0.631952306220611, -81.8828, -1.42912446075201),
(12220, '28692', 218, 33, 18451, 36.2761, 0.633137384782715, -81.7868, -1.4274489446701),
(12221, '28693', 218, 33, 69884, 36.4614, 0.63637147988666, -81.5566, -1.42343119673201),
(12222, '28694', 218, 33, 6719, 36.4014, 0.635324282335464, -81.4935, -1.422329893974),
(12223, '28697', 218, 33, 70187, 36.138, 0.630727085085711, -81.1582, -1.41647780499206),
(12224, '28698', 218, 33, 70446, 36.3296, 0.634071135932532, -81.7405, -1.42664085722642),
(12225, '28699', 218, 33, 28555, 35.8426, 0.62557138247532, -81.0097, -1.41388599105285),
(12226, '28701', 218, 33, 7048, 35.7062, 0.623190753375599, -82.6389, -1.44232089522634),
(12227, '28702', 218, 33, 7068, 35.3889, 0.617652823659021, -83.6335, -1.45967993996668),
(12228, '28704', 218, 33, 7142, 35.4724, 0.619110173584437, -82.5208, -1.44025966137974),
(12229, '28705', 218, 33, 15087, 35.9768, 0.627913614331496, -82.1246, -1.43334466688334),
(12230, '28707', 218, 33, 62685, 35.447, 0.61866685995443, -83.0844, -1.45009633704398),
(12231, '28708', 218, 33, 62686, 35.2255, 0.614800955661262, -82.8877, -1.4466632744053),
(12232, '28709', 218, 33, 62719, 35.7631, 0.624183845719984, -82.4338, -1.4387412249305),
(12233, '28710', 218, 33, 62733, 35.4319, 0.618403315237379, -82.545, -1.44068203105872),
(12234, '28711', 218, 33, 34836, 35.6051, 0.621426225501833, -82.3137, -1.43664508449886),
(12235, '28712', 218, 33, 63134, 35.2008, 0.61436985933602, -82.7371, -1.4440348085518),
(12236, '28713', 218, 33, 63256, 35.3998, 0.617843064547489, -83.4673, -1.45677920274986),
(12237, '28714', 218, 33, 1248, 35.8876, 0.626356780638717, -82.2637, -1.43577241987286),
(12238, '28715', 218, 33, 15419, 35.5401, 0.620291761488037, -82.6827, -1.44308534943872),
(12239, '28716', 218, 33, 19763, 35.5291, 0.620099775270317, -82.8431, -1.44588485755891),
(12240, '28717', 218, 33, 63495, 35.0801, 0.612263246928863, -83.0817, -1.45004921315417),
(12241, '28718', 218, 33, 63564, 35.1366, 0.61324935795624, -82.6832, -1.44309407608498),
(12242, '28719', 218, 33, 5, 35.4713, 0.619090974962665, -83.3415, -1.45458357855085),
(12243, '28720', 218, 33, 63665, 35.438, 0.618509780321751, -82.2443, -1.43543382599797),
(12244, '28721', 218, 33, 8151, 35.5391, 0.620274308195517, -82.9149, -1.44713800396185),
(12245, '28722', 218, 33, 1718, 35.2429, 0.61510464295111, -82.1883, -1.43445644161686),
(12246, '28723', 218, 33, 64074, 35.285, 0.615839426566199, -83.1791, -1.45174916384562),
(12247, '28724', 218, 33, 15726, 35.3292, 0.616610862095581, -82.3758, -1.43772893396434),
(12248, '28725', 218, 33, 29642, 35.3685, 0.617296776491614, -83.2521, -1.45302325419957),
(12249, '28726', 218, 33, 64345, 35.2833, 0.615809755968915, -82.4188, -1.4384794255427),
(12250, '28727', 218, 33, 0, 35.3929, 0.617722636829101, -82.343, -1.43715646596969),
(12251, '28728', 218, 33, 64545, 35.5403, 0.620295252146541, -82.6444, -1.4424168883352),
(12252, '28729', 218, 33, 8785, 35.3194, 0.616439819828885, -82.6041, -1.44171352064665),
(12253, '28730', 218, 33, 500, 35.5228, 0.619989819527442, -82.4111, -1.4383450351903),
(12254, '28731', 218, 33, 2479, 35.2739, 0.615645695019228, -82.4176, -1.43845848159168),
(12255, '28732', 218, 33, 16032, 35.4231, 0.618249726263203, -82.4981, -1.43986347163953),
(12256, '28733', 218, 33, 0, 35.4319, 0.618403315237379, -83.8256, -1.46303271745976),
(12257, '28734', 218, 33, 2595, 35.1828, 0.614055700070661, -83.3775, -1.45521189708157),
(12258, '28735', 218, 33, 65008, 35.4743, 0.619143334840224, -82.3088, -1.43655956336551),
(12259, '28736', 218, 33, 2748, 35.195, 0.614268630239404, -83.086, -1.45012426231201),
(12260, '28737', 218, 33, 2749, 35.6778, 0.622695079868033, -82.0029, -1.43122060118366),
(12261, '28738', 218, 33, 13906, 35.4776, 0.61920093070554, -83.0037, -1.44868785633762),
(12262, '28739', 218, 33, 65498, 35.3204, 0.616457273121405, -82.489, -1.4397046466776),
(12263, '28740', 218, 33, 55069, 36.0109, 0.628508771606426, -82.3134, -1.4366398485111),
(12264, '28741', 218, 33, 3119, 35.0536, 0.611800734677084, -83.2081, -1.45225530932869),
(12265, '28742', 218, 33, 65762, 35.3633, 0.617206019370511, -82.5707, -1.44113058067648),
(12266, '28743', 218, 33, 9587, 35.863, 0.625927429642726, -82.8625, -1.4462234514338),
(12267, '28744', 218, 33, 2595, 35.1812, 0.614027774802629, -83.3816, -1.4552834555809),
(12268, '28745', 218, 33, 66180, 35.5264, 0.620052651380514, -82.974, -1.44816949354978),
(12269, '28746', 218, 33, 66183, 35.4548, 0.618802995636086, -82.1908, -1.43450007484816),
(12270, '28747', 218, 33, 66191, 35.1426, 0.613354077711359, -82.9355, -1.44749754178776),
(12271, '28748', 218, 33, 66314, 35.627, 0.62180845260802, -82.71, -1.44356182432451),
(12272, '28749', 218, 33, 66428, 35.8459, 0.625628978340635, -82.0957, -1.43284026672951),
(12273, '28750', 218, 33, 3914, 35.2284, 0.61485157020957, -82.2238, -1.43507603350131),
(12274, '28751', 218, 33, 66565, 35.5211, 0.619960148930158, -83.0644, -1.44974727119358),
(12275, '28752', 218, 33, 630, 35.6761, 0.622665409270749, -82.0173, -1.43147192859595),
(12276, '28753', 218, 33, 4011, 35.8366, 0.6254666627202, -82.7093, -1.44354960701975),
(12277, '28754', 218, 33, 4007, 35.8762, 0.62615781310399, -82.5376, -1.44055287669407),
(12278, '28755', 218, 33, 4181, 35.9077, 0.626707591818368, -82.2161, -1.43494164314891),
(12279, '28756', 218, 33, 56253, 35.3417, 0.61682902825208, -82.171, -1.43415449965626),
(12280, '28757', 218, 33, 66932, 35.6461, 0.622141810495151, -82.3041, -1.43647753289067),
(12281, '28758', 218, 33, 4432, 35.3784, 0.617469564087562, -82.4757, -1.43947251788709),
(12282, '28760', 218, 33, 17231, 35.3924, 0.617713910182841, -82.5007, -1.43990885020009),
(12283, '28761', 218, 33, 677, 35.6663, 0.622494367004054, -81.9107, -1.42961140761332),
(12284, '28762', 218, 33, 67456, 35.6276, 0.621818924583532, -82.1555, -1.4338839736222),
(12285, '28763', 218, 33, 11013, 35.0481, 0.611704741568225, -83.3975, -1.45556096293197),
(12286, '28765', 218, 33, 67679, 35.9289, 0.627077601619791, -82.1154, -1.43318409659215),
(12287, '28766', 218, 33, 11139, 35.2819, 0.615785321359387, -82.6565, -1.44262807317469),
(12288, '28768', 218, 33, 23986, 35.2564, 0.615340262400129, -82.669, -1.44284623933119),
(12289, '28770', 218, 33, 11586, 35.6167, 0.621628683695064, -82.3205, -1.43676376688799),
(12290, '28771', 218, 33, 68277, 35.3485, 0.616947710641216, -83.8752, -1.46389840076875),
(12291, '28772', 218, 33, 68397, 35.1419, 0.613341860406595, -82.837, -1.44577839247454),
(12292, '28773', 218, 33, 31060, 35.2456, 0.615151766840913, -82.3103, -1.43658574330429),
(12293, '28774', 218, 33, 68547, 35.1055, 0.612706560558869, -82.9787, -1.44825152402462),
(12294, '28775', 218, 33, 68578, 35.0119, 0.611072932379003, -83.3353, -1.45447536813723),
(12295, '28776', 218, 33, 68841, 35.4834, 0.619302159802156, -82.5225, -1.44028933197702),
(12296, '28777', 218, 33, 6038, 35.9142, 0.626821038219748, -82.0703, -1.4323969530995),
(12297, '28778', 218, 33, 69271, 35.6019, 0.621370374965769, -82.4099, -1.43832409123928),
(12298, '28779', 218, 33, 69292, 35.3783, 0.61746781875831, -83.2113, -1.45231115986476),
(12299, '28781', 218, 33, 6363, 35.2569, 0.615348989046389, -83.6952, -1.46075680811516),
(12300, '28782', 218, 33, 18385, 35.2163, 0.614640385370079, -82.2241, -1.43508126948907),
(12301, '28783', 218, 33, 69639, 35.2498, 0.615225070669497, -83.1214, -1.45074210886721),
(12302, '28784', 218, 33, 52243, 35.2305, 0.614888222123862, -82.4329, -1.43872551696723),
(12303, '28785', 218, 33, 25859, 35.5734, 0.620872956128951, -83.0108, -1.44881177471451),
(12304, '28786', 218, 33, 25859, 35.4979, 0.619555232543695, -82.9955, -1.44854473933895),
(12305, '28787', 218, 33, 69946, 35.7217, 0.623461279409658, -82.5472, -1.44072042830226),
(12306, '28788', 218, 33, 18520, 35.3526, 0.617019269140547, -83.2147, -1.45237050105933),
(12307, '28789', 218, 33, 18607, 35.4564, 0.618830920904118, -83.287, -1.45363237410852),
(12308, '28790', 218, 33, 70447, 35.234, 0.614949308647682, -82.4155, -1.43842182967739),
(12309, '28791', 218, 33, 65498, 35.3528, 0.617022759799051, -82.496, -1.43982681972524),
(12310, '28792', 218, 33, 65498, 35.3384, 0.616771432386764, -82.45, -1.43902396826932),
(12311, '28793', 218, 33, 65498, 35.3266, 0.616565483535029, -82.4791, -1.43953185908166),
(12312, '28801', 218, 33, 62601, 35.5965, 0.621276127186162, -82.5554, -1.44086354530093),
(12313, '28802', 218, 33, 62601, 35.4971, 0.619541269909679, -82.5401, -1.44059650992537),
(12314, '28803', 218, 33, 62601, 35.5457, 0.620389499926148, -82.5237, -1.44031027592804),
(12315, '28804', 218, 33, 62601, 35.6361, 0.621967277569951, -82.558, -1.44090892386148),
(12316, '28805', 218, 33, 62601, 35.5955, 0.621258673893642, -82.5018, -1.43992804882186),
(12317, '28806', 218, 33, 62601, 35.5812, 0.621009091810606, -82.6078, -1.44177809782897),
(12318, '28810', 218, 33, 62601, 35.5694, 0.620803142958871, -82.6139, -1.44188456291334),
(12319, '28813', 218, 33, 62601, 35.5532, 0.620520399620048, -82.5117, -1.44010083641781),
(12320, '28814', 218, 33, 62601, 35.6361, 0.621967277569951, -82.569, -1.4411009100792),
(12321, '28815', 218, 33, 62601, 35.5743, 0.620888664092219, -82.5491, -1.44075358955805),
(12322, '28816', 218, 33, 62601, 35.583, 0.621040507737142, -82.6045, -1.44172050196366),
(12323, '28901', 218, 33, 7102, 35.1905, 0.614190090423064, -83.8024, -1.4626278010733),
(12324, '28902', 218, 33, 63118, 35.046, 0.611668089653933, -83.9346, -1.46493512634443),
(12325, '28903', 218, 33, 64071, 34.9913, 0.610713394553092, -84.1677, -1.46900348883083),
(12326, '28904', 218, 33, 65448, 35.0274, 0.611343458413062, -83.8067, -1.46270285023113),
(12327, '28905', 218, 33, 10300, 35.1316, 0.61316209149364, -83.9485, -1.46517772711046),
(12328, '28906', 218, 33, 23277, 35.0641, 0.611983994248544, -84.0553, -1.46704173875159),
(12329, '28909', 218, 33, 69880, 35.0001, 0.610866983527267, -83.9137, -1.46457035253077),
(12330, '29001', 218, 48, 79502, 33.8597, 0.590963248737524, -80.2118, -1.39996000895119),
(12331, '29002', 218, 48, 58538, 34.1577, 0.596164329908467, -81.2583, -1.41822487957331),
(12332, '29003', 218, 48, 79648, 33.2988, 0.581173696963088, -81.0323, -1.4142804354638),
(12333, '29006', 218, 48, 79678, 33.8868, 0.591436232964815, -81.5312, -1.422987883102),
(12334, '29009', 218, 48, 79788, 34.4313, 0.600939550741924, -80.372, -1.40275602641288),
(12335, '29010', 218, 48, 44848, 34.2166, 0.597192328837892, -80.2521, -1.40066337663974),
(12336, '29014', 218, 48, 79819, 34.5726, 0.603405700974992, -80.9855, -1.41346362137387),
(12337, '29015', 218, 48, 26538, 34.3209, 0.599012707247722, -81.1322, -1.41602401938654),
(12338, '29016', 218, 48, 79848, 34.1913, 0.596750760537137, -80.977, -1.41331526838745),
(12339, '29018', 218, 48, 7625, 33.3473, 0.582020181650305, -80.6857, -1.40823112427639),
(12340, '29020', 218, 48, 1304, 34.2787, 0.59827617830338, -80.5911, -1.406580042804),
(12341, '29030', 218, 48, 806, 33.6078, 0.58656676435175, -80.6375, -1.40738987557693),
(12342, '29031', 218, 48, 1358, 34.6857, 0.605379668358997, -81.6396, -1.42487982001116),
(12343, '29032', 218, 48, 45475, 34.3383, 0.599316394537569, -80.4915, -1.40484169486902),
(12344, '29033', 218, 48, 35179, 33.9631, 0.592767919184086, -81.0697, -1.41493318860405),
(12345, '29036', 218, 48, 26757, 34.1254, 0.595600588560073, -81.3552, -1.41991610361849),
(12346, '29037', 218, 48, 80263, 34.2332, 0.597482053493723, -81.8417, -1.42840713042944),
(12347, '29038', 218, 48, 29548, 33.369, 0.582398918097988, -80.9626, -1.41306394097516),
(12348, '29039', 218, 48, 924, 33.4577, 0.583947025144507, -80.8926, -1.41184221049877),
(12349, '29040', 218, 48, 72267, 34.0035, 0.593473032201892, -80.483, -1.4046933418826),
(12350, '29041', 218, 48, 80627, 33.6025, 0.586474261901395, -80.2651, -1.4008902694425),
(12351, '29042', 218, 48, 8477, 33.3195, 0.581534980118251, -81.1388, -1.41613921111718),
(12352, '29044', 218, 48, 64381, 33.9164, 0.591952850423405, -80.7131, -1.40870934449144),
(12353, '29045', 218, 48, 2254, 34.1813, 0.596576227611938, -80.7984, -1.41019811034339),
(12354, '29046', 218, 48, 8728, 34.1164, 0.595443508927393, -80.1802, -1.39940848490756),
(12355, '29047', 218, 48, 80870, 33.5318, 0.585240314120235, -80.5719, -1.40624493958762),
(12356, '29048', 218, 48, 80908, 33.3868, 0.582709586704843, -80.2992, -1.40148542671743),
(12357, '29051', 218, 48, 81146, 33.8438, 0.590685741386457, -80.0877, -1.39779405534946),
(12358, '29052', 218, 48, 2640, 33.8514, 0.590818386409608, -80.7638, -1.4095942264222),
(12359, '29053', 218, 48, 2675, 33.8284, 0.59041696068165, -81.1184, -1.41578316394977),
(12360, '29054', 218, 48, 2713, 33.9504, 0.592546262369083, -81.3837, -1.42041352245531),
(12361, '29055', 218, 48, 47606, 34.5712, 0.603381266365464, -80.9013, -1.41199405414369),
(12362, '29056', 218, 48, 72727, 33.7865, 0.589685667725064, -79.8312, -1.3933172858181),
(12363, '29058', 218, 48, 81476, 34.4854, 0.601883773867252, -80.6803, -1.40813687649678),
(12364, '29059', 218, 48, 13972, 33.3243, 0.581618755922346, -80.4122, -1.40345764877218),
(12365, '29061', 218, 48, 3235, 33.9332, 0.59224606573774, -80.844, -1.4109939804823),
(12366, '29062', 218, 48, 9577, 34.1134, 0.595391149049834, -80.547, -1.40581035260387),
(12367, '29063', 218, 48, 81731, 34.1194, 0.595495868804953, -81.1967, -1.41714975675408),
(12368, '29065', 218, 48, 30203, 34.2463, 0.597710691625734, -81.2643, -1.41832959932843),
(12369, '29067', 218, 48, 3505, 34.4968, 0.60208274140198, -80.5215, -1.40536529364461),
(12370, '29069', 218, 48, 244, 34.1809, 0.59656924629493, -80.0576, -1.39726871124461),
(12371, '29070', 218, 48, 30315, 33.9094, 0.591830677375765, -81.45, -1.42157067574938),
(12372, '29071', 218, 48, 3748, 33.9809, 0.593078587790941, -81.2365, -1.41784439779637),
(12373, '29072', 218, 48, 3748, 33.9698, 0.59288485624397, -81.2454, -1.4179997320998),
(12374, '29073', 218, 48, 3748, 33.925, 0.592102948739076, -81.2148, -1.41746566134869),
(12375, '29074', 218, 48, 3761, 34.454, 0.601335740482126, -80.7936, -1.41011433453929),
(12376, '29075', 218, 48, 82121, 34.2054, 0.596996851961668, -81.2867, -1.41872055308087),
(12377, '29078', 218, 48, 888, 34.2204, 0.597258651349468, -80.7145, -1.40873377910096),
(12378, '29079', 218, 48, 3910, 34.2819, 0.598332028839444, -80.0369, -1.39690742808945),
(12379, '29080', 218, 48, 16971, 34.039, 0.59409262408635, -80.1097, -1.3981780277849),
(12380, '29081', 218, 48, 80847, 33.1105, 0.577887241981582, -81.0235, -1.41412684648963),
(12381, '29082', 218, 48, 82146, 33.0571, 0.576955236161018, -80.5229, -1.40538972825414),
(12382, '29101', 218, 48, 82308, 34.4779, 0.601752874173353, -80.2551, -1.4007157365173),
(12383, '29102', 218, 48, 10288, 33.6935, 0.588062511520709, -80.2165, -1.40004203942603),
(12384, '29104', 218, 48, 82296, 33.9863, 0.593172835570549, -80.2081, -1.39989543176886),
(12385, '29105', 218, 48, 82445, 33.7563, 0.589158578290962, -81.5582, -1.42345912200004),
(12386, '29106', 218, 48, 588, 34.352, 0.599555504645092, -81.2989, -1.41893348324962),
(12387, '29107', 218, 48, 82558, 33.489, 0.584493313200381, -81.0329, -1.41429090743931),
(12388, '29108', 218, 48, 17269, 34.2789, 0.598279668961884, -81.6162, -1.4244714129662),
(12389, '29111', 218, 48, 37409, 33.7796, 0.589565240006677, -80.0171, -1.39656185289755),
(12390, '29112', 218, 48, 82617, 33.6892, 0.587987462362874, -81.1275, -1.4159419889117),
(12391, '29113', 218, 48, 33458, 33.4494, 0.583802162816591, -81.1193, -1.41579887191304),
(12392, '29114', 218, 48, 82748, 33.9277, 0.59215007262888, -79.9047, -1.39460010281831),
(12393, '29115', 218, 48, 82782, 33.5042, 0.584758603246684, -80.8609, -1.41128894112588),
(12394, '29116', 218, 48, 82782, 33.4831, 0.584390338774513, -80.8139, -1.41046863637745),
(12395, '29117', 218, 48, 82782, 33.4983, 0.584655628820816, -80.847, -1.41104634035986),
(12396, '29118', 218, 48, 82782, 33.5333, 0.585266494059014, -80.8757, -1.41154724985518),
(12397, '29122', 218, 48, 11115, 34.1693, 0.596366788101698, -81.4174, -1.42100169841323),
(12398, '29123', 218, 48, 82913, 33.7771, 0.589521606775377, -81.2563, -1.41818997298827),
(12399, '29125', 218, 48, 17636, 33.7384, 0.588846164354855, -80.4623, -1.40433205872743),
(12400, '29126', 218, 48, 83093, 34.325, 0.599084265747054, -81.4441, -1.42146770132351),
(12401, '29127', 218, 48, 558, 34.1819, 0.59658669958745, -81.5204, -1.42279938754279),
(12402, '29128', 218, 48, 5349, 34.0903, 0.594987977992623, -80.5028, -1.40503891707449),
(12403, '29129', 218, 48, 83281, 33.7356, 0.588797295135799, -81.6586, -1.42521143256904),
(12404, '29130', 218, 48, 11587, 34.3263, 0.59910695502733, -80.7627, -1.40957502780042),
(12405, '29132', 218, 48, 83296, 34.3065, 0.598761379835435, -81.1251, -1.41590010100965),
(12406, '29133', 218, 48, 83402, 33.3674, 0.582370992829956, -80.8343, -1.41082468354485),
(12407, '29135', 218, 48, 11758, 33.6646, 0.587558111366883, -80.7822, -1.40991536700456),
(12408, '29137', 218, 48, 83453, 33.6362, 0.587062437859317, -81.2941, -1.41884970744552),
(12409, '29138', 218, 48, 31060, 34.004, 0.593481758848152, -81.772, -1.4271906359408),
(12410, '29142', 218, 48, 61670, 33.4897, 0.584505530505145, -80.458, -1.4042570095696),
(12411, '29143', 218, 48, 31076, 33.8346, 0.590525171095273, -80.0828, -1.39770853421612),
(12412, '29145', 218, 48, 83649, 34.2142, 0.597150440935844, -81.7438, -1.42669845309174),
(12413, '29146', 218, 48, 349, 33.4981, 0.584652138162313, -81.2796, -1.41859663470398),
(12414, '29147', 218, 48, 83818, 34.1132, 0.59538765839133, -80.9554, -1.41293827726902),
(12415, '29148', 218, 48, 83896, 33.5895, 0.586247369098635, -80.3403, -1.40220275704),
(12416, '29150', 218, 48, 6154, 33.9194, 0.592005210300965, -80.3579, -1.40250993498835),
(12417, '29151', 218, 48, 6154, 33.9078, 0.591802752107733, -80.3635, -1.40260767342646),
(12418, '29152', 218, 48, 0, 33.9858, 0.593164108924289, -80.4846, -1.40472126715063),
(12419, '29153', 218, 48, 6154, 33.9412, 0.592385692077899, -80.3258, -1.40194968429846),
(12420, '29154', 218, 48, 6154, 33.8938, 0.591558406012454, -80.4198, -1.40359029379534),
(12421, '29160', 218, 48, 28742, 33.734, 0.588769369867767, -81.0991, -1.41544631540413),
(12422, '29161', 218, 48, 84046, 34.1368, 0.5957995560948, -79.936, -1.39514639087419),
(12423, '29162', 218, 48, 84093, 33.8821, 0.591354202489971, -80.0075, -1.39639430128936),
(12424, '29163', 218, 48, 6520, 33.4083, 0.583084832494022, -80.4684, -1.40443852381181),
(12425, '29164', 218, 48, 84178, 33.6528, 0.587352162515148, -81.4326, -1.42126698845953),
(12426, '29166', 218, 48, 861, 33.8862, 0.591425760989303, -81.7399, -1.42663038525091),
(12427, '29168', 218, 48, 18521, 33.904, 0.591736429596158, -80.499, -1.40497259456292),
(12428, '29169', 218, 48, 84280, 33.9671, 0.592837732354166, -81.1098, -1.4156330656341),
(12429, '29170', 218, 48, 84280, 33.949, 0.592521827759555, -81.1413, -1.41618284434848),
(12430, '29171', 218, 48, 84280, 33.9713, 0.59291103618275, -81.0765, -1.41505187099318),
(12431, '29172', 218, 48, 84280, 33.9001, 0.59166836175533, -81.0921, -1.41532414235649),
(12432, '29175', 218, 48, 12776, 34.4472, 0.601217058092991, -80.5992, -1.40672141447341),
(12433, '29176', 218, 48, 903, 34.47, 0.601614993162445, -81.1193, -1.41579887191304),
(12434, '29177', 218, 48, 12817, 34.1565, 0.596143385957443, -81.2834, -1.41866295721556),
(12435, '29178', 218, 48, 26041, 34.5016, 0.602166517206076, -81.6184, -1.42450981020974),
(12436, '29180', 218, 48, 44187, 34.3742, 0.599942967739035, -81.0864, -1.41522465858913),
(12437, '29201', 218, 48, 1716, 33.9962, 0.593345623166496, -81.0307, -1.41425251019577),
(12438, '29202', 218, 48, 1716, 33.9715, 0.592914526841254, -80.9744, -1.4132698898269),
(12439, '29203', 218, 48, 1716, 34.0642, 0.594532447057852, -81.0236, -1.41412859181888),
(12440, '29204', 218, 48, 1716, 34.0271, 0.593884929905362, -81.0009, -1.41373240207868),
(12441, '29205', 218, 48, 1716, 33.9897, 0.593232176765117, -80.9967, -1.41365909825009),
(12442, '29206', 218, 48, 1716, 34.0314, 0.593959979063198, -80.9631, -1.41307266762142),
(12443, '29207', 218, 48, 1716, 34.0625, 0.594502776460568, -80.9674, -1.41314771677926),
(12444, '29208', 218, 48, 1716, 33.9757, 0.592987830669838, -81.0077, -1.41385108446781),
(12445, '29209', 218, 48, 1716, 33.967, 0.592835987024914, -80.9353, -1.41258746608937),
(12446, '29210', 218, 48, 1716, 34.041, 0.59412753067139, -81.0975, -1.4154183901361),
(12447, '29211', 218, 48, 1716, 34.0227, 0.593808135418275, -81.2904, -1.4187851302632),
(12448, '29212', 218, 48, 1716, 34.0708, 0.594647638788484, -81.1916, -1.41706074496223),
(12449, '29214', 218, 48, 1716, 33.9992, 0.593397983044056, -81.0348, -1.4143240686951),
(12450, '29215', 218, 48, 1716, 34.0293, 0.593923327148906, -81.0001, -1.41371843944466),
(12451, '29216', 218, 48, 1716, 33.997, 0.593359585800512, -81.036, -1.41434501264613),
(12452, '29217', 218, 48, 1716, 34.0085, 0.593560298664492, -81.0366, -1.41435548462164),
(12453, '29218', 218, 48, 1716, 34.0046, 0.593492230823664, -81.035, -1.4143275593536),
(12454, '29219', 218, 48, 1716, 34.0647, 0.594541173704112, -80.9208, -1.41233439334783),
(12455, '29220', 218, 48, 1716, 34.0078, 0.593548081359728, -81.0344, -1.41431708737809),
(12456, '29221', 218, 48, 1716, 34.0485, 0.594258430365289, -81.1084, -1.41560863102457),
(12457, '29222', 218, 48, 1716, 33.9853, 0.593155382278029, -81.0286, -1.41421585828148),
(12458, '29223', 218, 48, 1716, 34.0891, 0.594967034041599, -80.9225, -1.41236406394511),
(12459, '29224', 218, 48, 1716, 34.0565, 0.594398056705449, -80.8426, -1.41096954587277),
(12460, '29225', 218, 48, 1716, 33.9974, 0.59336656711752, -81.0281, -1.41420713163522),
(12461, '29226', 218, 48, 1716, 34.0338, 0.594001866965246, -81.1065, -1.41557546976878),
(12462, '29227', 218, 48, 1716, 34.034, 0.59400535762375, -81.1058, -1.41556325246402),
(12463, '29228', 218, 48, 1716, 33.9202, 0.592019172934981, -81.0897, -1.41528225445445),
(12464, '29229', 218, 48, 1716, 34.1298, 0.595677383047161, -80.8942, -1.4118701357668),
(12465, '29230', 218, 48, 1716, 34.1405, 0.595864133277124, -81.0652, -1.41485464878771),
(12466, '29240', 218, 48, 1716, 34.0293, 0.593923327148906, -81.007, -1.41383886716305),
(12467, '29250', 218, 48, 1716, 34.0026, 0.593457324238624, -81.0052, -1.41380745123651),
(12468, '29260', 218, 48, 1716, 34.0266, 0.593876203259103, -80.9653, -1.41311106486497),
(12469, '29290', 218, 48, 1716, 33.9161, 0.591947614435649, -80.8733, -1.41150536195313),
(12470, '29292', 218, 48, 1716, 33.9088, 0.591820205400253, -81.078, -1.41507805093196),
(12471, '29301', 218, 48, 83737, 34.9346, 0.609723792867211, -81.9648, -1.43055563073865),
(12472, '29302', 218, 48, 83737, 34.9546, 0.61007285871761, -81.8665, -1.42883997208394),
(12473, '29303', 218, 48, 83737, 34.9905, 0.610699431919076, -81.9622, -1.4305102521781),
(12474, '29304', 218, 48, 83737, 34.9595, 0.610158379850958, -81.9041, -1.42949621588269),
(12475, '29305', 218, 48, 83737, 34.9905, 0.610699431919076, -81.956, -1.43040204176447),
(12476, '29306', 218, 48, 83737, 34.9292, 0.609629545087603, -81.9071, -1.42954857576025),
(12477, '29307', 218, 48, 83737, 35.0001, 0.610866983527267, -81.7443, -1.426707179738),
(12478, '29316', 218, 48, 83737, 35.0564, 0.61184960389614, -81.9653, -1.43056435738491),
(12479, '29318', 218, 48, 83737, 35.0168, 0.61115845351235, -82.0284, -1.43166566014292),
(12480, '29319', 218, 48, 83737, 34.9445, 0.609896580463158, -81.9282, -1.42991684023242),
(12481, '29320', 218, 48, 7137, 34.9583, 0.610137435899934, -81.9959, -1.43109842813602),
(12482, '29321', 218, 48, 26642, 34.7234, 0.606037657486999, -81.6848, -1.42566870883306),
(12483, '29322', 218, 48, 80121, 35.12, 0.612959633300408, -82.1276, -1.4333970267609),
(12484, '29323', 218, 48, 80306, 35.1234, 0.613018974494976, -81.911, -1.42961664360108),
(12485, '29324', 218, 48, 15559, 34.9848, 0.610599948151712, -81.8242, -1.42810169781034),
(12486, '29325', 218, 48, 1630, 34.4687, 0.601592303882169, -81.885, -1.42916285799556),
(12487, '29329', 218, 48, 39874, 34.9984, 0.610837312929983, -81.8438, -1.42844378234374),
(12488, '29330', 218, 48, 224, 35.0319, 0.611421998229402, -81.8175, -1.42798476075046),
(12489, '29331', 218, 48, 80573, 34.6561, 0.604863050900407, -81.8756, -1.42899879704587),
(12490, '29332', 218, 48, 80576, 34.2802, 0.59830235824216, -81.9833, -1.43087851665027),
(12491, '29333', 218, 48, 20677, 35.0046, 0.610945523343607, -81.8756, -1.42899879704587),
(12492, '29334', 218, 48, 2130, 34.914, 0.6093642550413, -82.1318, -1.43347033058948),
(12493, '29335', 218, 48, 80887, 34.6712, 0.605126595617458, -81.9067, -1.42954159444324),
(12494, '29336', 218, 48, 80935, 34.9499, 0.609990828242766, -82.0156, -1.43144225799866),
(12495, '29338', 218, 48, 80994, 34.9341, 0.609715066220951, -81.9788, -1.43079997683393),
(12496, '29340', 218, 48, 81153, 35.0627, 0.611959559639016, -81.6444, -1.42496359581526),
(12497, '29341', 218, 48, 81153, 35.0927, 0.612483158414614, -81.6761, -1.42551686518814),
(12498, '29342', 218, 48, 81153, 34.9876, 0.610648817370768, -81.6579, -1.42519921526428),
(12499, '29346', 218, 48, 2741, 34.9411, 0.609837239268591, -81.8372, -1.4283285906131),
(12500, '29348', 218, 48, 81287, 35.0824, 0.612303389501659, -82.1257, -1.43336386550511),
(12501, '29349', 218, 48, 22166, 35.062, 0.611947342334252, -82.0608, -1.43223114682056),
(12502, '29351', 218, 48, 55589, 34.4127, 0.600614919501053, -81.8164, -1.42796556212869),
(12503, '29353', 218, 48, 3455, 34.8331, 0.607952283676437, -81.6831, -1.42563903823578),
(12504, '29355', 218, 48, 81875, 34.35, 0.599520598060052, -81.7662, -1.42708940684419),
(12505, '29356', 218, 48, 16843, 35.17, 0.613832297926406, -82.1821, -1.43434823120323),
(12506, '29360', 218, 48, 82032, 34.499, 0.602121138645524, -82.0241, -1.43159061098508),
(12507, '29364', 218, 48, 3836, 34.7877, 0.607159904196031, -81.4608, -1.4217591713086),
(12508, '29365', 218, 48, 60722, 34.9731, 0.610395744629229, -82.152, -1.43382288709838),
(12509, '29368', 218, 48, 17056, 35.0718, 0.612118384600947, -81.8753, -1.42899356105811),
(12510, '29369', 218, 48, 10581, 34.8745, 0.608674849986762, -82.0221, -1.43155570440004),
(12511, '29370', 218, 48, 23262, 34.3378, 0.599307667891309, -81.9579, -1.43043520302026),
(12512, '29372', 218, 48, 82812, 34.9, 0.609119908946021, -81.7597, -1.42697596044281),
(12513, '29373', 218, 48, 82813, 34.9167, 0.609411378931104, -81.7463, -1.42674208632304),
(12514, '29374', 218, 48, 33582, 34.7884, 0.607172121500795, -81.8602, -1.42873001634106),
(12515, '29375', 218, 48, 83247, 34.8594, 0.608411305269711, -82.1125, -1.43313348204384),
(12516, '29376', 218, 48, 5500, 34.8586, 0.608397342635695, -81.9504, -1.43030430332636),
(12517, '29377', 218, 48, 83815, 34.9338, 0.609709830233195, -82.0991, -1.43289960792408),
(12518, '29378', 218, 48, 62110, 34.9833, 0.610573768212932, -81.9885, -1.43096927377137),
(12519, '29379', 218, 48, 455, 34.7168, 0.605922465756367, -81.6202, -1.42454122613628),
(12520, '29384', 218, 48, 6650, 34.3327, 0.599218656099457, -82.0852, -1.43265700715805),
(12521, '29385', 218, 48, 12730, 34.9557, 0.610092057339382, -82.0957, -1.43284026672951),
(12522, '29386', 218, 48, 84361, 34.8854, 0.60886509087523, -81.8073, -1.42780673716676),
(12523, '29388', 218, 48, 513, 34.7605, 0.606685174639489, -82.0448, -1.43195189414024),
(12524, '29390', 218, 48, 2130, 34.9356, 0.609741246159731, -82.1375, -1.43356981435684),
(12525, '29391', 218, 48, 2130, 34.938, 0.609783134061779, -82.1426, -1.43365882614869),
(12526, '29395', 218, 48, 3455, 34.8591, 0.608406069281955, -81.7414, -1.42665656518969),
(12527, '29401', 218, 48, 8039, 32.7782, 0.572087512877205, -79.9372, -1.39516733482521),
(12528, '29402', 218, 48, 8039, 32.7762, 0.572052606292165, -79.931, -1.39505912441159),
(12529, '29403', 218, 48, 8039, 32.7974, 0.572422616093588, -79.9484, -1.39536281170143),
(12530, '29404', 218, 48, 0, 32.8954, 0.574133038760543, -80.068, -1.39745022548682),
(12531, '29405', 218, 48, 208, 32.8597, 0.573509956217581, -79.9862, -1.39602254615869),
(12532, '29406', 218, 48, 8039, 32.9182, 0.574530973829997, -80.026, -1.39671718720098),
(12533, '29407', 218, 48, 8039, 32.7977, 0.572427852081344, -80.0097, -1.39643269853291),
(12534, '29409', 218, 48, 8039, 32.7949, 0.572378982862288, -79.9606, -1.39557574187018),
(12535, '29410', 218, 48, 208, 33.1923, 0.579314921309714, -80.031, -1.39680445366358),
(12536, '29412', 218, 48, 8039, 32.7359, 0.571349238603612, -79.9564, -1.39550243804159),
(12537, '29413', 218, 48, 8039, 32.7916, 0.572321386996973, -79.9311, -1.39506086974084),
(12538, '29414', 218, 48, 8039, 32.8196, 0.572810079187531, -80.0547, -1.3972180966963),
(12539, '29415', 218, 48, 208, 33.0261, 0.576414184092899, -80.0459, -1.39706450772213),
(12540, '29416', 218, 48, 8039, 32.8775, 0.573820624824436, -80.0567, -1.39725300328134),
(12541, '29417', 218, 48, 8039, 32.79, 0.572293461728941, -80.0334, -1.39684634156563),
(12542, '29418', 218, 48, 208, 32.8959, 0.574141765406803, -80.0504, -1.39714304753847),
(12543, '29419', 218, 48, 208, 32.9369, 0.57485735040012, -80.1043, -1.39808378000529),
(12544, '29420', 218, 48, 208, 32.9227, 0.574609513646337, -80.1011, -1.39802792946923),
(12545, '29422', 218, 48, 8039, 32.6847, 0.570455630026591, -79.9543, -1.3954657861273),
(12546, '29423', 218, 48, 8039, 32.8448, 0.573249902159033, -79.9788, -1.39589339179404),
(12547, '29424', 218, 48, 8039, 32.7839, 0.572186996644569, -79.9373, -1.39516908015446),
(12548, '29425', 218, 48, 8039, 32.7862, 0.572227139217365, -79.9468, -1.3953348864334),
(12549, '29426', 218, 48, 79489, 32.7662, 0.571878073366966, -80.3734, -1.40278046102241),
(12550, '29429', 218, 48, 79627, 32.9499, 0.57508424320288, -79.6823, -1.39071849056188),
(12551, '29430', 218, 48, 79784, 33.2013, 0.579472000942393, -79.7883, -1.39256853956899),
(12552, '29431', 218, 48, 79867, 33.3201, 0.581545452093763, -79.9913, -1.39611155795054),
(12553, '29432', 218, 48, 1085, 33.2514, 0.580346410897642, -80.8173, -1.41052797757201),
(12554, '29433', 218, 48, 80128, 33.056, 0.576936037539245, -80.6205, -1.40709316960409),
(12555, '29434', 218, 48, 80482, 33.1323, 0.578267723758517, -79.8994, -1.39450760036796),
(12556, '29435', 218, 48, 35393, 32.94, 0.574911455606932, -80.4811, -1.40466018062681),
(12557, '29436', 218, 48, 80572, 33.3003, 0.581199876901868, -80.2023, -1.39979420267225),
(12558, '29437', 218, 48, 20633, 33.1424, 0.578444002012969, -80.3777, -1.40285551018025),
(12559, '29438', 218, 48, 80841, 32.5671, 0.568403122826245, -80.3101, -1.4016756676059),
(12560, '29439', 218, 48, 81029, 32.6587, 0.570001844421072, -79.9346, -1.39512195626466),
(12561, '29440', 218, 48, 2693, 33.3754, 0.582510619170115, -79.2701, -1.38352424338516),
(12562, '29442', 218, 48, 2693, 33.3853, 0.582683406766063, -79.2856, -1.38379476941922),
(12563, '29445', 218, 48, 36141, 32.9934, 0.575843461427497, -80.0278, -1.39674860312752),
(12564, '29446', 218, 48, 2850, 32.6547, 0.569932031250992, -80.5136, -1.40522741263371),
(12565, '29447', 218, 48, 2894, 33.1045, 0.577782522226463, -80.5952, -1.40665160130333),
(12566, '29448', 218, 48, 81448, 33.1852, 0.579191002932822, -80.5772, -1.40633744203798),
(12567, '29449', 218, 48, 3203, 32.7178, 0.571033334009001, -80.2623, -1.40084140022344),
(12568, '29450', 218, 48, 81658, 33.0219, 0.576340880264316, -79.792, -1.39263311675132),
(12569, '29451', 218, 48, 16566, 32.7947, 0.572375492203784, -79.7712, -1.3922700882669),
(12570, '29452', 218, 48, 81756, 32.7702, 0.571947886537046, -80.4546, -1.40419766837503),
(12571, '29453', 218, 48, 3399, 33.1963, 0.579384734479794, -79.6931, -1.39090698612109),
(12572, '29455', 218, 48, 81790, 32.6926, 0.570593511037498, -80.0951, -1.39792320971411),
(12573, '29456', 218, 48, 81927, 33.0159, 0.576236160509196, -80.1036, -1.39807156270053),
(12574, '29457', 218, 48, 81790, 32.7479, 0.571558678113851, -80.0341, -1.39685855887039),
(12575, '29458', 218, 48, 82312, 33.1023, 0.577744124982919, -79.4699, -1.38701141123064),
(12576, '29461', 218, 48, 82444, 33.1494, 0.578566175060608, -80.0274, -1.39674162181051),
(12577, '29464', 218, 48, 118, 32.8207, 0.572829277809303, -79.8463, -1.39358083053515),
(12578, '29465', 218, 48, 118, 32.7935, 0.57235454825276, -79.8631, -1.39387404584948),
(12579, '29466', 218, 48, 118, 32.7944, 0.572370256216028, -79.8626, -1.39386531920322),
(12580, '29468', 218, 48, 5077, 33.415, 0.583201769553905, -80.0881, -1.39780103666647),
(12581, '29469', 218, 48, 83037, 33.2223, 0.579838520085312, -80.0425, -1.39700516652756),
(12582, '29470', 218, 48, 83207, 32.79, 0.572293461728941, -80.222, -1.40013803253489),
(12583, '29471', 218, 48, 28389, 33.1773, 0.579053121921915, -80.6817, -1.40816131110631),
(12584, '29472', 218, 48, 5391, 33.0955, 0.577625442593783, -80.3162, -1.40178213269027),
(12585, '29474', 218, 48, 83399, 32.9432, 0.574967306142996, -80.5774, -1.40634093269648),
(12586, '29475', 218, 48, 68435, 33.011, 0.576150639375848, -80.8214, -1.41059953607135),
(12587, '29476', 218, 48, 5585, 33.3966, 0.582880628971538, -79.9714, -1.39576423742939),
(12588, '29477', 218, 48, 14538, 33.1866, 0.57921543754235, -80.5778, -1.40634791401349),
(12589, '29479', 218, 48, 51183, 33.4072, 0.58306563387225, -79.9278, -1.39500327387552),
(12590, '29481', 218, 48, 83686, 33.0997, 0.577698746422367, -80.81, -1.41040056853662),
(12591, '29482', 218, 48, 83887, 32.763, 0.571822222830902, -79.8396, -1.39346389347526),
(12592, '29483', 218, 48, 6150, 33.0166, 0.57624837781396, -80.2109, -1.39994430098792),
(12593, '29484', 218, 48, 6150, 33.0137, 0.576197763265652, -80.201, -1.39977151339197),
(12594, '29485', 218, 48, 6150, 32.9767, 0.575551991442414, -80.181, -1.39942244754157),
(12595, '29487', 218, 48, 84176, 32.6525, 0.569893634007449, -80.1852, -1.39949575137016),
(12596, '29488', 218, 48, 84195, 32.9082, 0.574356440904798, -80.6617, -1.40781224525591),
(12597, '29492', 218, 48, 8039, 32.9542, 0.575159292360715, -79.8866, -1.3942841982237),
(12598, '29493', 218, 48, 878, 33.0344, 0.576559046420815, -80.8432, -1.41098001784828),
(12599, '29501', 218, 48, 2502, 34.1832, 0.596609388867726, -79.7851, -1.39251268903293),
(12600, '29502', 218, 48, 2502, 34.1929, 0.596778685805169, -79.792, -1.39263311675132),
(12601, '29503', 218, 48, 2502, 34.1949, 0.596813592390209, -79.8024, -1.39281463099352),
(12602, '29504', 218, 48, 2502, 34.1814, 0.59657797294119, -79.7804, -1.39243065855808),
(12603, '29505', 218, 48, 2502, 34.128, 0.595645967120625, -79.749, -1.39188262517296),
(12604, '29506', 218, 48, 2502, 34.207, 0.5970247772297, -79.7164, -1.39131364783681),
(12605, '29510', 218, 48, 7102, 33.4465, 0.583751548268283, -79.5562, -1.38851763037511),
(12606, '29511', 218, 48, 79629, 33.9906, 0.593247884728385, -79.1941, -1.38219779315364),
(12607, '29512', 218, 48, 29199, 34.6158, 0.604159683211853, -79.6841, -1.39074990648841),
(12608, '29516', 218, 48, 44876, 34.452, 0.601300833897086, -79.6515, -1.39018092915226),
(12609, '29518', 218, 48, 7826, 33.8016, 0.589949212442115, -79.8005, -1.39278146973774),
(12610, '29519', 218, 48, 1439, 34.0308, 0.593949507087686, -79.3554, -1.38501300923711),
(12611, '29520', 218, 48, 58977, 34.6922, 0.605493114760377, -79.9038, -1.39458439485505),
(12612, '29525', 218, 48, 1632, 34.5774, 0.603489476779087, -79.5427, -1.38828201092609),
(12613, '29526', 218, 48, 8215, 33.8316, 0.590472811217714, -79.0443, -1.37958328993415),
(12614, '29527', 218, 48, 8215, 33.8258, 0.590371582121098, -79.0735, -1.38009292607574),
(12615, '29528', 218, 48, 8215, 33.8389, 0.590600220253109, -79.0608, -1.37987126926073),
(12616, '29530', 218, 48, 80535, 34.0022, 0.593450342921616, -79.7463, -1.39183550128315),
(12617, '29532', 218, 48, 1971, 34.2992, 0.598633970800039, -79.87, -1.39399447356787),
(12618, '29536', 218, 48, 20585, 34.4156, 0.60066553404936, -79.3657, -1.38519277815006),
(12619, '29540', 218, 48, 1971, 34.3002, 0.598651424092559, -79.8762, -1.39410268398149),
(12620, '29541', 218, 48, 27055, 34.1184, 0.595478415512433, -79.7736, -1.39231197616895),
(12621, '29542', 218, 48, 0, 34.3009, 0.598663641397323, -79.2634, -1.38340730632527),
(12622, '29543', 218, 48, 47154, 34.2894, 0.598462928533344, -79.2448, -1.3830826750844),
(12623, '29544', 218, 48, 81159, 34.1263, 0.595616296523341, -79.1218, -1.38093592010445),
(12624, '29545', 218, 48, 81331, 34.2133, 0.597134732972576, -79.0617, -1.379886977224),
(12625, '29546', 218, 48, 36207, 33.8459, 0.590722393300749, -79.3146, -1.38430091490229),
(12626, '29547', 218, 48, 21686, 34.511, 0.602330578155763, -79.4044, -1.38586822057059),
(12627, '29550', 218, 48, 27395, 34.3711, 0.599888862532223, -80.0811, -1.39767886361883),
(12628, '29551', 218, 48, 27395, 34.3693, 0.599857446605687, -80.0836, -1.39772249685013),
(12629, '29554', 218, 48, 81490, 33.7504, 0.589055603865094, -79.4465, -1.38660300418567),
(12630, '29555', 218, 48, 756, 33.8186, 0.590245918414954, -79.4534, -1.38672343190406),
(12631, '29556', 218, 48, 81892, 33.6766, 0.587767550877122, -79.8263, -1.39323176468475),
(12632, '29560', 218, 48, 9930, 33.8674, 0.591097639089928, -79.7597, -1.39206937540292),
(12633, '29563', 218, 48, 3614, 34.3445, 0.599424604951192, -79.1635, -1.38166372240253),
(12634, '29564', 218, 48, 3658, 33.462, 0.584022074302343, -79.8354, -1.39339058964668),
(12635, '29565', 218, 48, 76340, 34.3368, 0.599290214598789, -79.4339, -1.38638309269992),
(12636, '29566', 218, 48, 3805, 33.8825, 0.591361183806979, -78.6373, -1.37247979987854),
(12637, '29567', 218, 48, 3807, 34.4055, 0.600489255794909, -79.3038, -1.38411241934308),
(12638, '29568', 218, 48, 82171, 33.8866, 0.59143274230631, -78.7472, -1.37439791672648),
(12639, '29569', 218, 48, 82183, 34.0237, 0.593825588710795, -78.909, -1.37722185945621),
(12640, '29570', 218, 48, 82313, 34.6636, 0.604993950594307, -79.5449, -1.38832040816964),
(12641, '29571', 218, 48, 630, 34.1794, 0.59654306635615, -79.397, -1.38573906620594),
(12642, '29572', 218, 48, 82547, 33.7615, 0.589249335412066, -78.7984, -1.3752915253035),
(12643, '29573', 218, 48, 10526, 34.5172, 0.602438788569387, -79.4727, -1.3870602804497),
(12644, '29574', 218, 48, 4459, 34.2053, 0.596995106632416, -79.2553, -1.38326593465586),
(12645, '29575', 218, 48, 82547, 33.6283, 0.586924556848409, -78.9868, -1.37857972561426),
(12646, '29576', 218, 48, 82540, 33.5872, 0.586207226525839, -79.0074, -1.37893926344017),
(12647, '29577', 218, 48, 82547, 33.7022, 0.588214355165633, -78.9128, -1.37728818196778),
(12648, '29578', 218, 48, 82547, 33.727, 0.588647196820127, -78.8435, -1.37607866879615),
(12649, '29579', 218, 48, 82547, 33.6552, 0.587394050417196, -78.9441, -1.37783447002366),
(12650, '29580', 218, 48, 4514, 33.5998, 0.586427138011591, -79.5648, -1.38866772869078),
(12651, '29581', 218, 48, 17278, 34.2289, 0.597407004335887, -79.1511, -1.38144730157528),
(12652, '29582', 218, 48, 82639, 33.8265, 0.590383799425862, -78.6791, -1.37320934750587),
(12653, '29583', 218, 48, 82837, 33.9927, 0.593284536642676, -79.5695, -1.38874975916563),
(12654, '29584', 218, 48, 37602, 34.5626, 0.603231168049792, -80.0743, -1.3975601812297),
(12655, '29585', 218, 48, 82885, 33.4533, 0.583870230657419, -79.1367, -1.381195974163),
(12656, '29587', 218, 48, 82547, 33.6165, 0.586718607996674, -78.9889, -1.37861637752855),
(12657, '29588', 218, 48, 82547, 33.6744, 0.587729153633578, -79.0132, -1.37904049253678),
(12658, '29589', 218, 48, 83199, 34.189, 0.596710617964341, -79.2595, -1.38333923848445),
(12659, '29590', 218, 48, 83456, 33.5645, 0.585811036785637, -79.8269, -1.39324223666026),
(12660, '29591', 218, 48, 5701, 33.9173, 0.591968558386673, -79.741, -1.3917429988328),
(12661, '29592', 218, 48, 5727, 34.2539, 0.597843336648886, -79.4569, -1.38678451842788),
(12662, '29593', 218, 48, 5941, 34.4418, 0.601122810313383, -79.8407, -1.39348309209704),
(12663, '29594', 218, 48, 18288, 34.6442, 0.60465535671942, -79.5868, -1.38905170112622),
(12664, '29596', 218, 48, 721, 34.7272, 0.606103979998575, -79.8594, -1.39380946866716),
(12665, '29597', 218, 48, 82639, 33.8117, 0.590125490696567, -78.7011, -1.37359331994131),
(12666, '29598', 218, 48, 82639, 33.8038, 0.589987609685659, -78.718, -1.3738882805849),
(12667, '29601', 218, 48, 2868, 34.8481, 0.608214083064236, -82.4053, -1.43824380609368),
(12668, '29602', 218, 48, 2868, 34.7309, 0.606168557180899, -82.3747, -1.43770973534257),
(12669, '29603', 218, 48, 2868, 34.8497, 0.608242008332268, -82.3965, -1.43809021711951),
(12670, '29604', 218, 48, 2868, 34.8342, 0.607971482298209, -82.3948, -1.43806054652222),
(12671, '29605', 218, 48, 2868, 34.7998, 0.607371089035523, -82.3927, -1.43802389460793),
(12672, '29606', 218, 48, 2868, 34.855, 0.608334510782623, -82.3195, -1.43674631359547),
(12673, '29607', 218, 48, 2868, 34.8291, 0.607882470506357, -82.3406, -1.43711457806764),
(12674, '29608', 218, 48, 2868, 34.9025, 0.609163542177321, -82.4088, -1.4383048926175),
(12675, '29609', 218, 48, 2868, 34.8942, 0.609018679849405, -82.4008, -1.43816526627734),
(12676, '29610', 218, 48, 2868, 34.9327, 0.609690631611423, -82.4718, -1.43940445004626),
(12677, '29611', 218, 48, 2868, 34.8525, 0.608290877551324, -82.4508, -1.43903793090334),
(12678, '29612', 218, 48, 2868, 34.849, 0.608229791027504, -82.4039, -1.43821937148416),
(12679, '29613', 218, 48, 2868, 34.7158, 0.605905012463848, -82.3848, -1.43788601359702),
(12680, '29614', 218, 48, 2868, 34.913, 0.60934680174878, -82.4074, -1.43828045800798),
(12681, '29615', 218, 48, 2868, 34.8678, 0.608557912926879, -82.3128, -1.43662937653559),
(12682, '29616', 218, 48, 2868, 34.8525, 0.608290877551324, -82.3945, -1.43805531053447),
(12683, '29617', 218, 48, 2868, 34.9192, 0.609455012162404, -82.48, -1.43954756704492),
(12684, '29620', 218, 48, 18708, 34.1778, 0.596515141088118, -82.3801, -1.43780398312218),
(12685, '29621', 218, 48, 7099, 34.5259, 0.60259063221431, -82.6429, -1.44239070839642),
(12686, '29622', 218, 48, 7099, 34.4967, 0.602080996072728, -82.6582, -1.44265774377198),
(12687, '29623', 218, 48, 7099, 34.5184, 0.602459732520411, -82.7181, -1.44370319599392),
(12688, '29624', 218, 48, 7099, 34.4799, 0.601787780758393, -82.6827, -1.44308534943872),
(12689, '29625', 218, 48, 7099, 34.5363, 0.602772146456518, -82.7317, -1.44394056077219),
(12690, '29626', 218, 48, 7099, 34.4415, 0.601117574325627, -82.7539, -1.44432802386614),
(12691, '29627', 218, 48, 19183, 34.5195, 0.602478931142183, -82.5041, -1.43996819139465),
(12692, '29628', 218, 48, 80083, 34.0921, 0.595019393919159, -82.5904, -1.44147441053912),
(12693, '29630', 218, 48, 1462, 34.7429, 0.606377996691138, -82.7974, -1.44508724209075),
(12694, '29631', 218, 48, 80368, 34.6824, 0.605322072493681, -82.8167, -1.44542409063639),
(12695, '29632', 218, 48, 80368, 34.6844, 0.605356979078721, -82.8125, -1.4453507868078),
(12696, '29633', 218, 48, 80368, 34.6972, 0.605580381222977, -82.8929, -1.44675403152641),
(12697, '29634', 218, 48, 80368, 34.675, 0.605192918129034, -82.8229, -1.44553230105001),
(12698, '29635', 218, 48, 1620, 35.0489, 0.611718704202241, -82.6419, -1.4423732551039),
(12699, '29636', 218, 48, 80450, 34.7682, 0.606819564991892, -82.3521, -1.43731529093162),
(12700, '29638', 218, 48, 80708, 34.373, 0.599922023788011, -82.2747, -1.43596440609058),
(12701, '29639', 218, 48, 80756, 34.3386, 0.599321630525325, -82.383, -1.43785459767049),
(12702, '29640', 218, 48, 2155, 34.8325, 0.607941811700925, -82.5891, -1.44145172125885),
(12703, '29641', 218, 48, 2155, 34.8415, 0.608098891333604, -82.5973, -1.44159483825751),
(12704, '29642', 218, 48, 2155, 34.8071, 0.607498498070918, -82.5649, -1.44102935157987),
(12705, '29643', 218, 48, 54697, 34.5263, 0.602597613531318, -83.043, -1.44937377073365),
(12706, '29644', 218, 48, 81099, 34.682, 0.605315091176673, -82.2208, -1.43502367362375),
(12707, '29645', 218, 48, 81297, 34.5904, 0.603716369581847, -82.148, -1.4337530739283),
(12708, '29646', 218, 48, 2869, 34.185, 0.596640804794262, -82.1535, -1.43384906703716);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(12709, '29647', 218, 48, 2869, 34.1904, 0.596735052573869, -82.1527, -1.43383510440315),
(12710, '29648', 218, 48, 2869, 34.1898, 0.596724580598357, -82.1589, -1.43394331481677),
(12711, '29649', 218, 48, 2869, 34.2205, 0.59726039667872, -82.1618, -1.43399392936508),
(12712, '29650', 218, 48, 2874, 34.9033, 0.609177504811337, -82.2632, -1.4357636932266),
(12713, '29651', 218, 48, 2874, 34.9666, 0.610282298227849, -82.2574, -1.43566246412998),
(12714, '29652', 218, 48, 2874, 34.9404, 0.609825021963827, -82.2064, -1.43477234621147),
(12715, '29653', 218, 48, 3178, 34.2843, 0.598373916741492, -82.22, -1.43500971098974),
(12716, '29654', 218, 48, 81625, 34.4473, 0.601218803422243, -82.4019, -1.43818446489912),
(12717, '29655', 218, 48, 30154, 34.3102, 0.598825957017759, -82.6681, -1.44283053136792),
(12718, '29656', 218, 48, 81925, 34.6111, 0.604077652737009, -82.7605, -1.44444321559677),
(12719, '29657', 218, 48, 3751, 34.7885, 0.607173866830047, -82.6961, -1.44331922355848),
(12720, '29658', 218, 48, 27747, 34.7592, 0.606662485359213, -83.2344, -1.45271433092197),
(12721, '29659', 218, 48, 82190, 34.258, 0.597914895148218, -82.5836, -1.44135572814999),
(12722, '29661', 218, 48, 3993, 35.0585, 0.611886255810432, -82.5121, -1.44010781773481),
(12723, '29662', 218, 48, 10354, 34.7797, 0.607020277855872, -82.3028, -1.43645484361039),
(12724, '29664', 218, 48, 0, 34.8039, 0.607442647534854, -83.2566, -1.45310179401591),
(12725, '29665', 218, 48, 30664, 34.7176, 0.605936428390383, -82.9031, -1.44693205511011),
(12726, '29666', 218, 48, 82604, 34.1718, 0.596410421332998, -82.0185, -1.43149287254697),
(12727, '29667', 218, 48, 23401, 34.7605, 0.606685174639489, -82.7715, -1.44463520181449),
(12728, '29669', 218, 48, 30794, 34.6538, 0.604822908327611, -82.4915, -1.4397482799089),
(12729, '29670', 218, 48, 11133, 34.6461, 0.604688517975207, -82.7689, -1.44458982325393),
(12730, '29671', 218, 48, 11179, 34.8913, 0.608968065301097, -82.7243, -1.44381140640755),
(12731, '29672', 218, 48, 18037, 34.6866, 0.605395376322265, -82.958, -1.44789024086946),
(12732, '29673', 218, 48, 4996, 34.7224, 0.606020204194479, -82.4211, -1.4385195681155),
(12733, '29675', 218, 48, 5374, 34.705, 0.605716516904632, -83.0208, -1.44898630763971),
(12734, '29676', 218, 48, 126, 34.8364, 0.608009879541753, -82.9315, -1.44742772861768),
(12735, '29677', 218, 48, 5651, 34.5936, 0.60377222011791, -82.7382, -1.44405400717357),
(12736, '29678', 218, 48, 18037, 34.6946, 0.605535002662425, -82.9426, -1.44762146016465),
(12737, '29679', 218, 48, 18037, 34.687, 0.605402357639273, -82.9473, -1.44770349063949),
(12738, '29680', 218, 48, 38223, 34.7203, 0.605983552280187, -82.2684, -1.4358544503477),
(12739, '29681', 218, 48, 38223, 34.7443, 0.606402431300666, -82.2574, -1.43566246412998),
(12740, '29682', 218, 48, 5870, 34.8271, 0.607847563921317, -82.8293, -1.44564400212214),
(12741, '29683', 218, 48, 60, 35.0314, 0.611413271583142, -82.495, -1.43980936643272),
(12742, '29684', 218, 48, 18189, 34.3938, 0.600285052272426, -82.6715, -1.44288987256249),
(12743, '29685', 218, 48, 12218, 34.9194, 0.609458502820908, -82.8215, -1.44550786644048),
(12744, '29686', 218, 48, 83961, 34.8997, 0.609114672958265, -82.9821, -1.44831086521919),
(12745, '29687', 218, 48, 83975, 34.9342, 0.609716811550203, -82.3213, -1.43677772952201),
(12746, '29688', 218, 48, 43351, 35.0648, 0.611996211553308, -82.3544, -1.43735543350442),
(12747, '29689', 218, 48, 84067, 34.5361, 0.602768655798014, -82.8685, -1.44632817118892),
(12748, '29690', 218, 48, 6377, 35.0037, 0.610929815380339, -82.4338, -1.4387412249305),
(12749, '29691', 218, 48, 84183, 34.7676, 0.606809093016381, -83.0644, -1.44974727119358),
(12750, '29692', 218, 48, 84211, 34.3911, 0.600237928382622, -82.2469, -1.43547920455852),
(12751, '29693', 218, 48, 13249, 34.6426, 0.604627431451388, -83.0888, -1.45017313153106),
(12752, '29695', 218, 48, 3178, 34.288, 0.598438493923816, -82.2481, -1.43550014850955),
(12753, '29696', 218, 48, 28946, 34.7705, 0.606859707564688, -83.0457, -1.44942089462345),
(12754, '29697', 218, 48, 70213, 34.6192, 0.604219024406421, -82.4986, -1.43987219828579),
(12755, '29698', 218, 48, 2868, 34.8101, 0.607550857948478, -82.3324, -1.43697146106898),
(12756, '29702', 218, 48, 79821, 35.1166, 0.612900292105841, -81.5146, -1.42269815844617),
(12757, '29703', 218, 48, 15294, 35.1437, 0.613373276333131, -81.2201, -1.41755816379905),
(12758, '29704', 218, 48, 15461, 34.8487, 0.608224555039748, -80.9341, -1.41256652213834),
(12759, '29706', 218, 48, 8056, 34.7093, 0.605791566062468, -81.2071, -1.41733127099629),
(12760, '29708', 218, 48, 81090, 35.0071, 0.610989156574907, -80.9451, -1.41275850835606),
(12761, '29709', 218, 48, 1534, 34.7357, 0.606252332984994, -80.0928, -1.39788306714131),
(12762, '29710', 218, 48, 20113, 35.1061, 0.612717032534381, -81.1827, -1.4169054106588),
(12763, '29712', 218, 48, 13713, 34.8283, 0.607868507872341, -81.0115, -1.41391740697939),
(12764, '29714', 218, 48, 81089, 34.7002, 0.605632741100536, -80.9147, -1.41222792826346),
(12765, '29715', 218, 48, 81090, 35.0241, 0.611285862547746, -80.9632, -1.41307441295067),
(12766, '29716', 218, 48, 81090, 35.0065, 0.610978684599395, -80.9431, -1.41272360177102),
(12767, '29717', 218, 48, 3079, 34.9717, 0.610371310019701, -81.4281, -1.42118844864319),
(12768, '29718', 218, 48, 3409, 34.5858, 0.603636084436255, -80.4195, -1.40358505780758),
(12769, '29720', 218, 48, 16841, 34.7122, 0.605842180610776, -80.7763, -1.4098123925787),
(12770, '29721', 218, 48, 16841, 34.7468, 0.606446064531966, -80.7202, -1.40883326286833),
(12771, '29722', 218, 48, 16841, 34.7463, 0.606437337885706, -80.7202, -1.40883326286833),
(12772, '29724', 218, 48, 81996, 34.7761, 0.6069574460028, -81.0108, -1.41390518967462),
(12773, '29726', 218, 48, 82315, 34.8712, 0.608617254121447, -81.2217, -1.41758608906708),
(12774, '29727', 218, 48, 82492, 34.7483, 0.606472244470746, -80.25, -1.40062672472545),
(12775, '29728', 218, 48, 82819, 34.7708, 0.606864943552444, -80.3924, -1.40311207358029),
(12776, '29729', 218, 48, 5372, 34.7767, 0.606967917978312, -81.026, -1.41417047972093),
(12777, '29730', 218, 48, 5463, 34.9278, 0.609605110478075, -81.022, -1.41410066655085),
(12778, '29731', 218, 48, 5463, 34.9658, 0.610268335593833, -81.0517, -1.41461902933869),
(12779, '29732', 218, 48, 5463, 34.9695, 0.610332912776157, -81.0603, -1.41476912765436),
(12780, '29733', 218, 48, 5463, 34.8882, 0.608913960094286, -81.0228, -1.41411462918486),
(12781, '29734', 218, 48, 5463, 34.8883, 0.608915705423538, -81.0226, -1.41411113852636),
(12782, '29741', 218, 48, 42889, 34.7042, 0.605702554270616, -80.2054, -1.39984830787906),
(12783, '29742', 218, 48, 24789, 34.9116, 0.609322367139252, -81.3458, -1.4197520426688),
(12784, '29743', 218, 48, 452, 35.0322, 0.611427234217158, -81.4147, -1.42095457452343),
(12785, '29744', 218, 48, 84138, 34.8584, 0.608393851977191, -80.8461, -1.41103063239659),
(12786, '29745', 218, 48, 6986, 35.0054, 0.610959485977623, -81.2075, -1.4173382523133),
(12787, '29801', 218, 48, 58423, 33.5633, 0.585790092834613, -81.7076, -1.42606664390252),
(12788, '29802', 218, 48, 58423, 33.5618, 0.585763912895833, -81.7229, -1.42633367927807),
(12789, '29803', 218, 48, 58423, 33.5053, 0.584777801868456, -81.7232, -1.42633891526583),
(12790, '29804', 218, 48, 58423, 33.5334, 0.585268239388267, -81.572, -1.42369997743681),
(12791, '29805', 218, 48, 58423, 33.6964, 0.588113126069017, -81.6339, -1.4247803362438),
(12792, '29808', 218, 48, 58423, 33.2465, 0.580260889764295, -81.651, -1.42507878754589),
(12793, '29809', 218, 48, 82570, 33.4161, 0.583220968175677, -81.6883, -1.42572979535688),
(12794, '29810', 218, 48, 7060, 33.0075, 0.576089552852028, -81.3071, -1.41907660024828),
(12795, '29812', 218, 48, 79663, 33.2453, 0.580239945813271, -81.3623, -1.42004002199538),
(12796, '29813', 218, 48, 36423, 33.2437, 0.580212020545239, -81.3633, -1.4200574752879),
(12797, '29816', 218, 48, 19093, 33.5022, 0.584723696661644, -81.8662, -1.42883473609618),
(12798, '29817', 218, 48, 7522, 33.3568, 0.582185987929244, -81.2739, -1.41849715093662),
(12799, '29819', 218, 48, 694, 34.1107, 0.59534402516003, -82.2343, -1.43525929307277),
(12800, '29821', 218, 48, 80344, 33.6432, 0.587184610906956, -82.1468, -1.43373212997728),
(12801, '29822', 218, 48, 8122, 33.4995, 0.58467657277184, -81.8948, -1.42933390026225),
(12802, '29824', 218, 48, 2219, 33.7854, 0.589666469103292, -81.9295, -1.42993952951269),
(12803, '29826', 218, 48, 2260, 33.3787, 0.582568215035431, -81.3791, -1.42033323730972),
(12804, '29827', 218, 48, 13733, 32.9575, 0.575216888226031, -81.2369, -1.41785137911338),
(12805, '29828', 218, 48, 81248, 33.5226, 0.585079743829051, -81.8286, -1.42817849229743),
(12806, '29829', 218, 48, 55037, 33.561, 0.585749950261817, -81.8265, -1.42814184038314),
(12807, '29831', 218, 48, 3384, 33.3462, 0.582000983028533, -81.8081, -1.42782069980077),
(12808, '29832', 218, 48, 327, 33.8337, 0.590509463132005, -81.8045, -1.4277578679477),
(12809, '29834', 218, 48, 9983, 33.5135, 0.58492091886712, -81.848, -1.42851708617232),
(12810, '29835', 218, 48, 10388, 33.9115, 0.591867329290057, -82.2935, -1.43629252798995),
(12811, '29836', 218, 48, 882, 33.0982, 0.577672566483587, -81.5259, -1.42289538065164),
(12812, '29838', 218, 48, 10550, 33.7068, 0.588294640311225, -82.2178, -1.43497131374619),
(12813, '29839', 218, 48, 82459, 33.5048, 0.584769075222196, -81.5984, -1.42416074435934),
(12814, '29840', 218, 48, 4363, 33.9884, 0.593209487484841, -82.4455, -1.43894542845298),
(12815, '29841', 218, 48, 82619, 33.5088, 0.584838888392276, -81.9337, -1.43001283334128),
(12816, '29842', 218, 48, 79716, 33.4056, 0.583037708604218, -81.8815, -1.42910177147174),
(12817, '29843', 218, 48, 82749, 33.1739, 0.578993780727347, -81.1548, -1.41641846379749),
(12818, '29844', 218, 48, 23766, 33.786, 0.589676941078804, -82.2178, -1.43497131374619),
(12819, '29845', 218, 48, 83078, 33.8175, 0.590226719793182, -82.2349, -1.43526976504828),
(12820, '29846', 218, 48, 6199, 33.0364, 0.576593953005855, -81.2229, -1.4176070330181),
(12821, '29847', 218, 48, 6381, 33.6772, 0.587778022852634, -81.8118, -1.4278852769831),
(12822, '29848', 218, 48, 199, 33.9676, 0.592846459000426, -82.2861, -1.43616337362531),
(12823, '29849', 218, 48, 84112, 33.0567, 0.57694825484401, -81.213, -1.41743424542215),
(12824, '29850', 218, 48, 12532, 33.6087, 0.586582472315018, -81.8074, -1.42780848249601),
(12825, '29851', 218, 48, 84220, 33.5166, 0.584975024073931, -81.8216, -1.42805631924979),
(12826, '29853', 218, 48, 18638, 33.4001, 0.582941715495358, -81.4238, -1.42111339948536),
(12827, '29856', 218, 48, 18652, 33.48, 0.584336233567701, -81.5266, -1.42290759795641),
(12828, '29860', 218, 48, 82619, 33.502, 0.58472020600314, -81.9652, -1.43056261205566),
(12829, '29861', 218, 48, 82619, 33.5175, 0.584990732037199, -81.9557, -1.43039680577672),
(12830, '29899', 218, 48, 10388, 33.9096, 0.591834168034269, -82.2928, -1.43628031068519),
(12831, '29901', 218, 48, 53378, 32.4151, 0.565750222363214, -80.6574, -1.40773719609807),
(12832, '29902', 218, 48, 53378, 32.4288, 0.565989332470737, -80.6995, -1.40847197971316),
(12833, '29903', 218, 48, 53378, 32.4238, 0.565902066008137, -80.7258, -1.40893100130644),
(12834, '29904', 218, 48, 53378, 32.4572, 0.566485005978304, -80.8008, -1.41023999824543),
(12835, '29905', 218, 48, 53378, 32.3439, 0.564507547935794, -80.668, -1.40792220099879),
(12836, '29906', 218, 48, 53378, 32.4312, 0.566031220372785, -80.6704, -1.40796408890083),
(12837, '29907', 218, 48, 0, 32.4287, 0.565987587141485, -80.7001, -1.40848245168868),
(12838, '29909', 218, 48, 82751, 32.262, 0.563078123278411, -80.8715, -1.41147394602659),
(12839, '29910', 218, 48, 1018, 32.2625, 0.563086849924671, -80.8711, -1.41146696470959),
(12840, '29911', 218, 48, 80011, 32.9287, 0.574714233401457, -81.1845, -1.41693682658534),
(12841, '29912', 218, 48, 0, 32.4891, 0.56704176600969, -80.9896, -1.4135351798732),
(12842, '29913', 218, 48, 80566, 32.9159, 0.574490831257202, -81.0771, -1.41506234296869),
(12843, '29914', 218, 48, 847, 32.5562, 0.568212881937778, -80.6904, -1.40831315475123),
(12844, '29915', 218, 48, 0, 32.2276, 0.562477730015725, -80.7017, -1.40851037695671),
(12845, '29916', 218, 48, 80797, 32.6274, 0.569455556365198, -81.0462, -1.41452303622983),
(12846, '29918', 218, 48, 35796, 32.7553, 0.571687832478499, -81.235, -1.41781821785759),
(12847, '29920', 218, 48, 0, 32.356, 0.564718732775285, -80.4995, -1.40498132120918),
(12848, '29921', 218, 48, 2635, 32.759, 0.571752409660822, -81.2388, -1.41788454036917),
(12849, '29922', 218, 48, 9064, 32.8795, 0.573855531409476, -81.1192, -1.41579712658378),
(12850, '29923', 218, 48, 9105, 32.8602, 0.573518682863841, -81.239, -1.41788803102767),
(12851, '29924', 218, 48, 2957, 32.8661, 0.573621657289708, -81.1132, -1.41569240682866),
(12852, '29925', 218, 48, 81584, 32.164, 0.561367700611456, -80.7535, -1.40941445750924),
(12853, '29926', 218, 48, 81584, 32.2371, 0.562643536294664, -80.7338, -1.4090706276466),
(12854, '29927', 218, 48, 81447, 32.2804, 0.563399263860778, -81.0709, -1.41495413255507),
(12855, '29928', 218, 48, 81584, 32.1634, 0.561357228635944, -80.7529, -1.40940398553373),
(12856, '29929', 218, 48, 81745, 32.951, 0.575103441824652, -80.8865, -1.41173574541439),
(12857, '29931', 218, 48, 82135, 32.5524, 0.568146559426202, -80.7431, -1.40923294326703),
(12858, '29932', 218, 48, 33155, 32.8645, 0.573593732021676, -81.2273, -1.41768382750519),
(12859, '29933', 218, 48, 82396, 32.948, 0.575051081947092, -81.0317, -1.41426996348829),
(12860, '29934', 218, 48, 17628, 32.581, 0.568645723592273, -81.1904, -1.4170398010112),
(12861, '29935', 218, 48, 5184, 32.3843, 0.5652126609536, -80.6921, -1.40834282534852),
(12862, '29936', 218, 48, 61539, 32.4825, 0.566926574279058, -80.984, -1.41343744143509),
(12863, '29938', 218, 48, 81584, 32.1638, 0.561364209952952, -80.7538, -1.409419693497),
(12864, '29939', 218, 48, 11826, 32.6819, 0.570406760807535, -81.2431, -1.41795958952701),
(12865, '29940', 218, 48, 24727, 32.5223, 0.567621215321352, -80.7463, -1.4092887938031),
(12866, '29941', 218, 48, 57525, 32.6015, 0.569003516088931, -80.7938, -1.41011782519779),
(12867, '29943', 218, 48, 25494, 32.4828, 0.566931810266814, -81.116, -1.41574127604772),
(12868, '29944', 218, 48, 84146, 32.8553, 0.573433161730493, -81.0769, -1.41505885231019),
(12869, '29945', 218, 48, 84555, 32.6174, 0.569281023439999, -80.7388, -1.4091578941092),
(12870, '30002', 218, 13, 18999, 33.7727, 0.589444812288289, -84.2629, -1.47066504227873),
(12871, '30003', 218, 13, 23394, 33.6458, 0.587229989467508, -84.0133, -1.46630870046575),
(12872, '30004', 218, 13, 18815, 34.1221, 0.595542992694757, -84.2974, -1.47126718087067),
(12873, '30005', 218, 13, 18815, 34.0792, 0.594794246445652, -84.2043, -1.46964227933706),
(12874, '30006', 218, 13, 3993, 33.9506, 0.592549753027587, -84.5413, -1.47552403891628),
(12875, '30007', 218, 13, 3993, 33.9667, 0.592830751037158, -84.5491, -1.47566017459794),
(12876, '30008', 218, 13, 3993, 33.9025, 0.591710249657378, -84.5845, -1.47627802115314),
(12877, '30009', 218, 13, 18815, 34.0997, 0.59515203894231, -84.258, -1.47057952114538),
(12878, '30010', 218, 13, 23394, 33.9678, 0.59284994965893, -84.2177, -1.46987615345683),
(12879, '30011', 218, 13, 13306, 34.0219, 0.593794172784259, -83.8266, -1.46305017075228),
(12880, '30012', 218, 13, 20220, 33.7053, 0.588268460372445, -84.0062, -1.46618478208886),
(12881, '30013', 218, 13, 20220, 33.6405, 0.587137487017153, -83.964, -1.46544825314452),
(12882, '30014', 218, 13, 15652, 33.5904, 0.586263077061903, -83.8342, -1.46318281577543),
(12883, '30015', 218, 13, 15652, 33.6032, 0.586486479206159, -83.8545, -1.46353711761359),
(12884, '30016', 218, 13, 15652, 33.5286, 0.585184463584171, -83.9474, -1.46515852848869),
(12885, '30017', 218, 13, 2826, 33.8886, 0.59146764889135, -83.9633, -1.46543603583975),
(12886, '30018', 218, 13, 9753, 33.716, 0.588455210602408, -83.7989, -1.46256671454948),
(12887, '30019', 218, 13, 20436, 33.9766, 0.593003538633105, -83.8752, -1.46389840076875),
(12888, '30021', 218, 13, 20075, 33.809, 0.590078366806763, -84.2383, -1.47023569128274),
(12889, '30022', 218, 13, 18815, 34.0304, 0.593942525770678, -84.2423, -1.47030550445282),
(12890, '30023', 218, 13, 18815, 34.0688, 0.594612732203444, -84.2718, -1.47082037658216),
(12891, '30024', 218, 13, 25276, 34.0649, 0.594544664362616, -84.0846, -1.46755312022242),
(12892, '30025', 218, 13, 24947, 33.6533, 0.587360889161408, -83.6853, -1.46058402051921),
(12893, '30026', 218, 13, 0, 33.9777, 0.593022737254877, -84.1498, -1.46869107489472),
(12894, '30028', 218, 13, 20417, 34.2088, 0.597056193156236, -84.135, -1.46843276616543),
(12895, '30029', 218, 13, 0, 33.978, 0.593027973242633, -84.1494, -1.46868409357772),
(12896, '30030', 218, 13, 2007, 33.7714, 0.589422123008013, -84.2931, -1.47119213171283),
(12897, '30031', 218, 13, 2007, 33.7705, 0.589406415044745, -84.283, -1.47101585345838),
(12898, '30032', 218, 13, 2007, 33.7387, 0.588851400342611, -84.2671, -1.47073834610731),
(12899, '30033', 218, 13, 2007, 33.814, 0.590165633269363, -84.2799, -1.47096174825157),
(12900, '30034', 218, 13, 2007, 33.691, 0.58801887828941, -84.2467, -1.47038229893991),
(12901, '30035', 218, 13, 2007, 33.7286, 0.588675122088159, -84.2099, -1.46974001777517),
(12902, '30036', 218, 13, 2007, 33.7727, 0.589444812288289, -84.292, -1.47117293309106),
(12903, '30037', 218, 13, 2007, 33.6911, 0.588020623618662, -84.2527, -1.47048701869503),
(12904, '30038', 218, 13, 22698, 33.6793, 0.587814674766926, -84.1593, -1.46885688117366),
(12905, '30039', 218, 13, 24939, 33.7961, 0.589853219333256, -84.0283, -1.46657049985355),
(12906, '30040', 218, 13, 20417, 34.2499, 0.597773523478806, -84.1748, -1.46912740720772),
(12907, '30041', 218, 13, 20417, 34.2031, 0.596956709388872, -84.0731, -1.46735240735844),
(12908, '30042', 218, 13, 3698, 33.9224, 0.592057570178524, -84.0744, -1.46737509663872),
(12909, '30043', 218, 13, 3698, 34.0067, 0.593528882737956, -84.0031, -1.46613067688205),
(12910, '30044', 218, 13, 3698, 33.9224, 0.592057570178524, -84.0725, -1.46734193538293),
(12911, '30045', 218, 13, 3698, 33.9342, 0.59226351903026, -83.9597, -1.46537320398668),
(12912, '30046', 218, 13, 3698, 33.939, 0.592347294834356, -83.9597, -1.46537320398668),
(12913, '30047', 218, 13, 22664, 33.8729, 0.591193632198787, -84.1115, -1.46802261379121),
(12914, '30048', 218, 13, 22664, 33.9016, 0.59169454169411, -84.1269, -1.46829139449602),
(12915, '30049', 218, 13, 3698, 33.659, 0.587460372928771, -84.2606, -1.47062489970593),
(12916, '30052', 218, 13, 22725, 33.81, 0.590095820099283, -83.8897, -1.46415147351029),
(12917, '30054', 218, 13, 4828, 33.6795, 0.58781816542543, -83.8737, -1.46387222082997),
(12918, '30055', 218, 13, 3975, 33.4969, 0.584631194211289, -83.75, -1.46171324854525),
(12919, '30056', 218, 13, 23357, 33.4833, 0.584393829433017, -83.6629, -1.46019306676676),
(12920, '30058', 218, 13, 22698, 33.7289, 0.588680358075915, -84.1256, -1.46826870521574),
(12921, '30060', 218, 13, 3993, 33.9354, 0.592284462981284, -84.5294, -1.47531634473529),
(12922, '30061', 218, 13, 3993, 33.9229, 0.592066296824784, -84.5461, -1.47560781472038),
(12923, '30062', 218, 13, 3993, 34.0006, 0.593422417653584, -84.4667, -1.47422202329429),
(12924, '30063', 218, 13, 3993, 33.9294, 0.592179743226164, -84.523, -1.47520464366317),
(12925, '30064', 218, 13, 3993, 33.9389, 0.592345549505103, -84.6152, -1.47681383723351),
(12926, '30065', 218, 13, 3993, 34.0469, 0.594230505097257, -84.443, -1.47380838026157),
(12927, '30066', 218, 13, 3993, 34.0341, 0.594007102953002, -84.5065, -1.47491666433659),
(12928, '30067', 218, 13, 3993, 33.929, 0.592172761909156, -84.4666, -1.47422027796504),
(12929, '30068', 218, 13, 3993, 33.9686, 0.592863912292946, -84.4389, -1.47373682176224),
(12930, '30069', 218, 13, 3993, 33.9167, 0.591958086411161, -84.5195, -1.47514355713935),
(12931, '30070', 218, 13, 24088, 33.5722, 0.58594542713804, -83.8964, -1.46426841057017),
(12932, '30071', 218, 13, 23394, 33.937, 0.592312388249316, -84.2004, -1.46957421149623),
(12933, '30072', 218, 13, 890, 33.7913, 0.58976944352916, -84.2061, -1.4696736952636),
(12934, '30074', 218, 13, 24252, 33.745, 0.588961356085487, -84.1366, -1.46846069143346),
(12935, '30075', 218, 13, 5564, 34.0465, 0.594223523780249, -84.3789, -1.47268962421104),
(12936, '30076', 218, 13, 5564, 34.0251, 0.593850023320323, -84.3128, -1.47153596157548),
(12937, '30077', 218, 13, 5564, 34.0404, 0.594117058695878, -84.3549, -1.47227074519056),
(12938, '30078', 218, 13, 24939, 33.8547, 0.590875982274924, -84.008, -1.4662161980154),
(12939, '30079', 218, 13, 24714, 33.7907, 0.589758971553648, -84.2594, -1.47060395575491),
(12940, '30080', 218, 13, 452, 33.8742, 0.591216321479063, -84.5092, -1.47496378822639),
(12941, '30081', 218, 13, 452, 33.868, 0.59110811106544, -84.5175, -1.47510865055431),
(12942, '30082', 218, 13, 452, 33.8613, 0.590991174005556, -84.5387, -1.47547866035573),
(12943, '30083', 218, 13, 25153, 33.7913, 0.58976944352916, -84.2003, -1.46957246616698),
(12944, '30084', 218, 13, 6399, 33.8493, 0.590781734495317, -84.2247, -1.46999832650447),
(12945, '30085', 218, 13, 6399, 33.8546, 0.590874236945672, -84.2231, -1.46997040123644),
(12946, '30086', 218, 13, 25153, 33.8025, 0.589964920405383, -84.1046, -1.46790218607282),
(12947, '30087', 218, 13, 25153, 33.8044, 0.589998081661171, -84.1404, -1.46852701394504),
(12948, '30088', 218, 13, 25153, 33.7603, 0.589228391461042, -84.1775, -1.46917453109753),
(12949, '30090', 218, 13, 3993, 33.9702, 0.592891837560978, -84.5522, -1.47571427980475),
(12950, '30091', 218, 13, 23394, 33.9428, 0.592413617345931, -84.1743, -1.46911868056146),
(12951, '30092', 218, 13, 23394, 33.9743, 0.592963396060309, -84.2384, -1.47023743661199),
(12952, '30093', 218, 13, 23394, 33.9044, 0.591743410913166, -84.1806, -1.46922863630434),
(12953, '30094', 218, 13, 20220, 33.5996, 0.586423647353087, -84.0602, -1.46712725988494),
(12954, '30095', 218, 13, 20699, 33.9771, 0.593012265279365, -84.1501, -1.46869631088248),
(12955, '30096', 218, 13, 20699, 33.9856, 0.593160618265785, -84.1644, -1.46894589296552),
(12956, '30097', 218, 13, 20699, 34.0285, 0.59390936451489, -84.1412, -1.46854097657905),
(12957, '30098', 218, 13, 20699, 34.0261, 0.593867476612843, -84.1473, -1.46864744166342),
(12958, '30099', 218, 13, 20699, 33.9773, 0.593015755937869, -84.1498, -1.46869107489472),
(12959, '30101', 218, 13, 18728, 34.0379, 0.594073425464578, -84.7098, -1.47846491870589),
(12960, '30102', 218, 13, 18728, 34.0987, 0.59513458564979, -84.6139, -1.47679114795323),
(12961, '30103', 218, 13, 18733, 34.3507, 0.599532815364816, -84.9141, -1.48203062636772),
(12962, '30104', 218, 13, 18889, 34.0612, 0.594480087180293, -85.0781, -1.48489296634099),
(12963, '30105', 218, 13, 18914, 34.4233, 0.600799924401764, -85.1667, -1.48643932805825),
(12964, '30106', 218, 13, 18974, 33.8356, 0.590542624387793, -84.6312, -1.47709308991383),
(12965, '30107', 218, 13, 19032, 34.3348, 0.599255308013749, -84.3465, -1.4721241375334),
(12966, '30108', 218, 13, 19409, 33.5355, 0.585304891302558, -85.2566, -1.4880083790558),
(12967, '30109', 218, 13, 19410, 33.57, 0.585907029894496, -85.083, -1.48497848747434),
(12968, '30110', 218, 13, 1103, 33.74, 0.588874089622887, -85.1359, -1.48590176664864),
(12969, '30111', 218, 13, 1594, 33.8064, 0.590032988246211, -84.6077, -1.47668293753961),
(12970, '30112', 218, 13, 1380, 33.579, 0.586064109527176, -85.0909, -1.48511636848524),
(12971, '30113', 218, 13, 15362, 33.8362, 0.590553096363305, -85.1907, -1.48685820707873),
(12972, '30114', 218, 13, 19763, 34.2475, 0.597731635576758, -84.5225, -1.47519591701691),
(12973, '30115', 218, 13, 19763, 34.2067, 0.597019541241944, -84.3999, -1.47305614335396),
(12974, '30116', 218, 13, 1380, 33.5752, 0.5859977870156, -85.017, -1.48382657016802),
(12975, '30117', 218, 13, 1380, 33.5878, 0.586217698501351, -85.1228, -1.48567312851663),
(12976, '30118', 218, 13, 1380, 33.5727, 0.5859541537843, -85.1058, -1.48537642254379),
(12977, '30119', 218, 13, 1380, 33.5865, 0.586195009221075, -85.1301, -1.48580053755202),
(12978, '30120', 218, 13, 1385, 34.1795, 0.596544811685402, -84.8543, -1.48098691947502),
(12979, '30121', 218, 13, 1385, 34.2297, 0.597420966969903, -84.7891, -1.47984896480272),
(12980, '30122', 218, 13, 22697, 33.7762, 0.589505898812109, -84.6379, -1.47721002697371),
(12981, '30123', 218, 13, 19837, 34.248, 0.597740362223018, -84.8566, -1.48102706204782),
(12982, '30124', 218, 13, 1401, 34.1257, 0.595605824547829, -85.3484, -1.48961059130913),
(12983, '30125', 218, 13, 19892, 34.0087, 0.593563789322995, -85.2554, -1.48798743510477),
(12984, '30126', 218, 13, 22799, 33.8136, 0.590158651952355, -84.5506, -1.47568635453672),
(12985, '30127', 218, 13, 24105, 33.8813, 0.591340239855955, -84.6878, -1.47808094627045),
(12986, '30129', 218, 13, 20235, 34.2606, 0.597960273708769, -85.3368, -1.4894081331159),
(12987, '30132', 218, 13, 1953, 33.994, 0.593307225922952, -84.8598, -1.48108291258388),
(12988, '30133', 218, 13, 2090, 33.7356, 0.588797295135799, -84.7041, -1.47836543493853),
(12989, '30134', 218, 13, 2090, 33.7575, 0.589179522241986, -84.7419, -1.47902516939578),
(12990, '30135', 218, 13, 2090, 33.6953, 0.588093927447245, -84.745, -1.47907927460259),
(12991, '30137', 218, 13, 8753, 34.1158, 0.595433036951881, -84.7595, -1.47933234734413),
(12992, '30138', 218, 13, 20924, 34.0008, 0.593425908312088, -85.2688, -1.48822130922454),
(12993, '30139', 218, 13, 2379, 34.4569, 0.601386355030434, -84.7392, -1.47897804550598),
(12994, '30140', 218, 13, 8869, 33.884, 0.591387363745759, -85.2192, -1.48735562591555),
(12995, '30141', 218, 13, 9518, 33.8686, 0.591118583040952, -84.7683, -1.47948593631831),
(12996, '30142', 218, 13, 3200, 34.172, 0.596413911991502, -84.4982, -1.47477180200867),
(12997, '30143', 218, 13, 738, 34.4631, 0.601494565444058, -84.4055, -1.47315388179207),
(12998, '30144', 218, 13, 22345, 34.0346, 0.594015829599262, -84.5835, -1.47626056786062),
(12999, '30145', 218, 13, 3542, 34.2403, 0.597605971870614, -84.9651, -1.48292074428623),
(13000, '30146', 218, 13, 3708, 34.227, 0.597373843080099, -84.4598, -1.47410159557591),
(13001, '30147', 218, 13, 22681, 34.1711, 0.596398204028234, -85.1883, -1.48681631917669),
(13002, '30148', 218, 13, 30423, 34.4549, 0.601351448445394, -84.2679, -1.47075230874133),
(13003, '30149', 218, 13, 23209, 34.2972, 0.598599064214999, -85.2809, -1.48843249406403),
(13004, '30150', 218, 13, 4417, 33.6243, 0.586854743678329, -85.1844, -1.48674825133586),
(13005, '30151', 218, 13, 4506, 31.2326, 0.545111703958381, -82.3442, -1.43717740992071),
(13006, '30152', 218, 13, 22345, 34.9906, 0.610701177248328, -84.6809, -1.47796051855207),
(13007, '30153', 218, 13, 24465, 34.0002, 0.593415436336576, -85.0691, -1.48473588670831),
(13008, '30154', 218, 13, 2090, 33.7457, 0.58897357339025, -84.7449, -1.47907752927334),
(13009, '30156', 218, 13, 22345, 34.0254, 0.593855259308079, -84.613, -1.47677543998996),
(13010, '30157', 218, 13, 1953, 33.8762, 0.591251228064103, -84.8659, -1.48118937766826),
(13011, '30160', 218, 13, 22345, 34.0259, 0.593863985954339, -84.6122, -1.47676147735595),
(13012, '30161', 218, 13, 490, 34.2432, 0.597656586418922, -85.1104, -1.48545670768938),
(13013, '30162', 218, 13, 490, 34.2462, 0.597708946296482, -85.1289, -1.485779593601),
(13014, '30163', 218, 13, 490, 34.2468, 0.597719418271994, -85.1285, -1.48577261228399),
(13015, '30164', 218, 13, 490, 34.275, 0.598211601121056, -85.2281, -1.48751096021898),
(13016, '30165', 218, 13, 490, 34.2794, 0.598288395608144, -85.2385, -1.48769247446119),
(13017, '30168', 218, 13, 18974, 33.7749, 0.589483209531833, -84.5704, -1.47603192972861),
(13018, '30170', 218, 13, 24511, 33.4183, 0.583259365419221, -85.1737, -1.48656150110589),
(13019, '30171', 218, 13, 24576, 34.3464, 0.59945776620698, -84.7362, -1.47892568562842),
(13020, '30172', 218, 13, 5777, 34.3444, 0.599422859621941, -85.0843, -1.48500117675461),
(13021, '30173', 218, 13, 24872, 34.1484, 0.596002014288032, -85.1399, -1.48597157981872),
(13022, '30175', 218, 13, 25316, 34.5427, 0.602883847528645, -84.5271, -1.4752762021625),
(13023, '30176', 218, 13, 25320, 33.7523, 0.589088765120882, -85.2936, -1.48865415087904),
(13024, '30177', 218, 13, 987, 34.459, 0.601423006944726, -84.3165, -1.4716005387578),
(13025, '30178', 218, 13, 25360, 34.121, 0.595523794072985, -84.9724, -1.48304815332163),
(13026, '30179', 218, 13, 12281, 33.8069, 0.590041714892471, -85.0204, -1.48388591136259),
(13027, '30180', 218, 13, 25734, 33.7073, 0.588303366957485, -84.9334, -1.48236747491335),
(13028, '30182', 218, 13, 6587, 33.6434, 0.58718810156546, -85.2322, -1.48758251871831),
(13029, '30183', 218, 13, 25771, 34.3344, 0.599248326696741, -84.5912, -1.47639495821303),
(13030, '30184', 218, 13, 6768, 34.2691, 0.598108626695189, -84.7162, -1.47857661977802),
(13031, '30185', 218, 13, 6792, 33.5144, 0.584936626830388, -84.9175, -1.48208996756228),
(13032, '30187', 218, 13, 18654, 33.6724, 0.587694247048539, -84.8378, -1.48069894014845),
(13033, '30188', 218, 13, 569, 34.1163, 0.595441763598141, -84.4585, -1.47407890629563),
(13034, '30189', 218, 13, 569, 34.1261, 0.595612805864837, -84.5646, -1.475930700632),
(13035, '30204', 218, 13, 19061, 33.0542, 0.57690462161271, -84.1591, -1.46885339051516),
(13036, '30205', 218, 13, 1162, 33.2652, 0.580587266334418, -84.4652, -1.47419584335551),
(13037, '30206', 218, 13, 698, 33.0965, 0.577642895886303, -84.4654, -1.47419933401402),
(13038, '30212', 218, 13, 8810, 33.2685, 0.580644862199734, -84.2819, -1.47099665483661),
(13039, '30213', 218, 13, 20978, 33.5759, 0.586010004320364, -84.5945, -1.47645255407834),
(13040, '30214', 218, 13, 2428, 33.4824, 0.584378121469749, -84.4853, -1.47454665453517),
(13041, '30215', 218, 13, 2428, 33.3851, 0.582679916107559, -84.4453, -1.47384852283437),
(13042, '30216', 218, 13, 21156, 33.2429, 0.580198057911223, -83.8962, -1.46426491991167),
(13043, '30217', 218, 13, 2595, 33.3107, 0.581381391144075, -85.1082, -1.48541831044584),
(13044, '30218', 218, 13, 21361, 33.1047, 0.577786012884967, -84.6312, -1.47709308991383),
(13045, '30219', 218, 13, 21427, 33.1543, 0.578651696193956, -85.2029, -1.48707113724748),
(13046, '30220', 218, 13, 21522, 33.2247, 0.57988040798736, -84.8168, -1.48033242100553),
(13047, '30222', 218, 13, 2868, 33.0244, 0.576384513495615, -84.7224, -1.47868483019164),
(13048, '30223', 218, 13, 9242, 33.2926, 0.581065486549464, -84.2656, -1.47071216616853),
(13049, '30224', 218, 13, 9242, 33.2069, 0.579569739380505, -84.2334, -1.47015017014939),
(13050, '30228', 218, 13, 2957, 33.4011, 0.582959168787878, -84.2812, -1.47098443753184),
(13051, '30229', 218, 13, 21721, 33.2349, 0.580058431571064, -84.5686, -1.47600051380208),
(13052, '30230', 218, 13, 21980, 33.1628, 0.578800049180375, -84.9421, -1.48251931855828),
(13053, '30232', 218, 13, 22166, 33.4572, 0.583938298498247, -84.4523, -1.47397069588201),
(13054, '30233', 218, 13, 3384, 33.2918, 0.581051523915448, -83.9655, -1.4654744330833),
(13055, '30234', 218, 13, 22250, 33.3247, 0.581625737239354, -84.034, -1.46666998362091),
(13056, '30236', 218, 13, 3452, 33.5116, 0.584887757611332, -84.3195, -1.47165289863536),
(13057, '30237', 218, 13, 3452, 33.5224, 0.585076253170547, -84.3531, -1.47223932926403),
(13058, '30238', 218, 13, 3452, 33.4935, 0.584571853016721, -84.3876, -1.47284146785597),
(13059, '30240', 218, 13, 103428, 33.0302, 0.576485742592231, -85.037, -1.48417563601842),
(13060, '30241', 218, 13, 103428, 33.1001, 0.577705727739375, -85.026, -1.4839836498007),
(13061, '30248', 218, 13, 901, 33.3578, 0.582203441221764, -84.106, -1.46792662068235),
(13062, '30250', 218, 13, 22755, 33.4403, 0.58364333785466, -84.3178, -1.47162322803808),
(13063, '30251', 218, 13, 22784, 33.2089, 0.579604645965545, -84.7444, -1.47906880262708),
(13064, '30252', 218, 13, 14191, 33.4679, 0.58412504872821, -84.0503, -1.46695447228899),
(13065, '30253', 218, 13, 14191, 33.4456, 0.583735840305015, -84.182, -1.46925307091387),
(13066, '30256', 218, 13, 23022, 32.9809, 0.575625295270998, -84.3272, -1.47178728898776),
(13067, '30257', 218, 13, 4230, 33.1293, 0.578215363880957, -84.1996, -1.46956024886222),
(13068, '30258', 218, 13, 23143, 32.9692, 0.575421091748515, -84.4566, -1.47404574503984),
(13069, '30259', 218, 13, 4318, 33.273, 0.580723402016073, -84.7507, -1.47917875836996),
(13070, '30260', 218, 13, 587, 33.5868, 0.586200245208831, -84.3259, -1.47176459970749),
(13071, '30261', 218, 13, 103428, 33.061, 0.577023304001845, -84.8912, -1.48163094596901),
(13072, '30263', 218, 13, 23360, 33.3934, 0.582824778435474, -84.8229, -1.4804388860899),
(13073, '30264', 218, 13, 23360, 33.3728, 0.582465240609564, -84.8109, -1.48022944657966),
(13074, '30265', 218, 13, 23360, 33.4026, 0.582985348726658, -84.7067, -1.47841081349908),
(13075, '30266', 218, 13, 23663, 33.1734, 0.578985054081087, -84.2125, -1.46978539633572),
(13076, '30268', 218, 13, 4844, 33.534, 0.585278711363778, -84.6894, -1.47810887153849),
(13077, '30269', 218, 13, 23799, 33.3956, 0.582863175679018, -84.5639, -1.47591848332723),
(13078, '30271', 218, 13, 23360, 33.3796, 0.582583922998699, -84.788, -1.47982976618095),
(13079, '30272', 218, 13, 5318, 33.6078, 0.58656676435175, -84.5107, -1.47498996816517),
(13080, '30273', 218, 13, 11547, 33.5792, 0.58606760018568, -84.2761, -1.47089542573999),
(13081, '30274', 218, 13, 5416, 33.5536, 0.585620795897169, -84.402, -1.47309279526825),
(13082, '30275', 218, 13, 17996, 33.4279, 0.583426917027412, -84.8567, -1.48102880737707),
(13083, '30276', 218, 13, 24740, 33.2869, 0.580966002782101, -84.5914, -1.47639844887153),
(13084, '30277', 218, 13, 24795, 33.3821, 0.582627556229999, -84.6357, -1.47717162973016),
(13085, '30281', 218, 13, 25139, 33.5567, 0.585674901103981, -84.2162, -1.46984997351805),
(13086, '30284', 218, 13, 25248, 33.3396, 0.581885791297901, -84.2915, -1.4711642064448),
(13087, '30285', 218, 13, 25433, 32.9679, 0.575398402468239, -84.2451, -1.47035437367187),
(13088, '30286', 218, 13, 6315, 32.9063, 0.57432327964901, -84.335, -1.47192342466942),
(13089, '30287', 218, 13, 587, 33.5531, 0.585612069250909, -84.4009, -1.47307359664648),
(13090, '30288', 218, 13, 20215, 33.6539, 0.58737136113692, -84.3315, -1.4718623381456),
(13091, '30289', 218, 13, 25588, 33.3252, 0.581634463885614, -84.6318, -1.47710356188934),
(13092, '30290', 218, 13, 25631, 33.4757, 0.584261184409866, -84.589, -1.47635656096948),
(13093, '30291', 218, 13, 12457, 33.5826, 0.586126941380248, -84.5452, -1.47559210675711),
(13094, '30292', 218, 13, 12870, 33.2081, 0.579590683331529, -84.3615, -1.4723859369212),
(13095, '30293', 218, 13, 362, 32.9753, 0.575527556832886, -84.591, -1.47639146755452),
(13096, '30294', 218, 13, 20853, 33.6381, 0.587095599115105, -84.2549, -1.47052541593857),
(13097, '30295', 218, 13, 26312, 33.0981, 0.577670821154335, -84.3046, -1.47139284457681),
(13098, '30296', 218, 13, 5416, 33.5657, 0.585831980736661, -84.4334, -1.47364082865338),
(13099, '30297', 218, 13, 2536, 33.614, 0.586674974765374, -84.3769, -1.472654717626),
(13100, '30298', 218, 13, 2536, 33.6188, 0.58675875056947, -84.3543, -1.47226027321505),
(13101, '30301', 218, 13, 7187, 33.8553, 0.590886454250436, -84.3961, -1.47298982084239),
(13102, '30302', 218, 13, 7187, 33.7542, 0.58912192637667, -84.3893, -1.47287113845325),
(13103, '30303', 218, 13, 7187, 33.7531, 0.589102727754898, -84.3899, -1.47288161042876),
(13104, '30304', 218, 13, 7187, 33.6489, 0.58728409467432, -84.3914, -1.47290779036754),
(13105, '30305', 218, 13, 7187, 33.832, 0.590479792534722, -84.3868, -1.47282750522195),
(13106, '30306', 218, 13, 7187, 33.7885, 0.589720574310104, -84.3494, -1.47217475208171),
(13107, '30307', 218, 13, 7187, 33.7684, 0.589369763130453, -84.3317, -1.4718658288041),
(13108, '30308', 218, 13, 7187, 33.7712, 0.589418632349509, -84.3776, -1.47266693493077),
(13109, '30309', 218, 13, 7187, 33.7857, 0.589671705091048, -84.3853, -1.47280132528317),
(13110, '30310', 218, 13, 7187, 33.7275, 0.588655923466388, -84.4252, -1.47349771165472),
(13111, '30311', 218, 13, 7187, 33.7244, 0.588601818259576, -84.471, -1.47429707245213),
(13112, '30312', 218, 13, 7187, 33.7449, 0.588959610756234, -84.38, -1.47270882283282),
(13113, '30313', 218, 13, 7187, 33.7647, 0.589305185948129, -84.3948, -1.47296713156211),
(13114, '30314', 218, 13, 7187, 33.7579, 0.589186503558994, -84.4283, -1.47355181686153),
(13115, '30315', 218, 13, 7187, 33.7082, 0.588319074920753, -84.3843, -1.47278387199065),
(13116, '30316', 218, 13, 7187, 33.7213, 0.588547713052764, -84.3269, -1.47178205300001),
(13117, '30317', 218, 13, 7187, 33.7501, 0.589050367877338, -84.3157, -1.47158657612378),
(13118, '30318', 218, 13, 7187, 33.7881, 0.589713592993096, -84.4437, -1.47382059756634),
(13119, '30319', 218, 13, 7187, 33.878, 0.591282643990639, -84.3334, -1.47189549940139),
(13120, '30320', 218, 13, 7187, 33.6378, 0.587090363127349, -84.4311, -1.47360068608058),
(13121, '30321', 218, 13, 7187, 33.7538, 0.589114945059662, -84.3898, -1.47287986509951),
(13122, '30322', 218, 13, 7187, 33.7927, 0.589793878138688, -84.3235, -1.47172271180544),
(13123, '30324', 218, 13, 7187, 33.8183, 0.590240682427198, -84.3607, -1.47237197428718),
(13124, '30325', 218, 13, 7187, 33.7924, 0.589788642150932, -84.448, -1.47389564672417),
(13125, '30326', 218, 13, 7187, 33.8481, 0.590760790544293, -84.3601, -1.47236150231167),
(13126, '30327', 218, 13, 7187, 33.8685, 0.591116837711699, -84.4276, -1.47353959955676),
(13127, '30328', 218, 13, 7187, 33.9345, 0.592268755018016, -84.3851, -1.47279783462467),
(13128, '30329', 218, 13, 7187, 33.8263, 0.590380308767358, -84.3214, -1.47168605989115),
(13129, '30330', 218, 13, 7187, 33.7073, 0.588303366957485, -84.4325, -1.47362512069011),
(13130, '30331', 218, 13, 7187, 33.715, 0.588437757309888, -84.5328, -1.47537568592986),
(13131, '30332', 218, 13, 7187, 33.7761, 0.589504153482857, -84.3993, -1.47304567137845),
(13132, '30333', 218, 13, 7187, 33.7937, 0.589811331431208, -84.3204, -1.47166860659863),
(13133, '30334', 218, 13, 7187, 33.7307, 0.588711774002451, -84.4096, -1.47322544029141),
(13134, '30336', 218, 13, 7187, 33.7494, 0.589038150572574, -84.5495, -1.47566715591495),
(13135, '30337', 218, 13, 7187, 33.6447, 0.587210790845736, -84.4656, -1.47420282467252),
(13136, '30338', 218, 13, 7187, 33.9404, 0.592371729443883, -84.318, -1.47162671869658),
(13137, '30339', 218, 13, 7187, 33.8733, 0.591200613515795, -84.4612, -1.47412603018543),
(13138, '30340', 218, 13, 7187, 33.8991, 0.59165090846281, -84.247, -1.47038753492766),
(13139, '30341', 218, 13, 7187, 33.9008, 0.591680579060094, -84.3058, -1.47141378852784),
(13140, '30342', 218, 13, 7187, 33.8815, 0.591343730514459, -84.3725, -1.47257792313892),
(13141, '30343', 218, 13, 7187, 33.7537, 0.58911319973041, -84.3894, -1.4728728837825),
(13142, '30344', 218, 13, 7187, 33.7491, 0.589032914584818, -84.3889, -1.47286415713624),
(13143, '30345', 218, 13, 7187, 33.8497, 0.590788715812325, -84.283, -1.47101585345838),
(13144, '30346', 218, 13, 7187, 33.925, 0.592102948739076, -84.3423, -1.47205083370481),
(13145, '30347', 218, 13, 7187, 33.8299, 0.59044314062043, -84.3352, -1.47192691532792),
(13146, '30348', 218, 13, 7187, 33.8351, 0.590533897741533, -84.3895, -1.47287462911175),
(13147, '30349', 218, 13, 7187, 33.6124, 0.586647049497342, -84.4949, -1.47471420614336),
(13148, '30350', 218, 13, 7187, 33.9773, 0.593015755937869, -84.3276, -1.47179427030477),
(13149, '30353', 218, 13, 7187, 33.7532, 0.58910447308415, -84.3893, -1.47287113845325),
(13150, '30354', 218, 13, 7187, 33.6642, 0.587551130049875, -84.3925, -1.47292698898931),
(13151, '30355', 218, 13, 7187, 33.8368, 0.590563568338817, -84.3693, -1.47252207260285),
(13152, '30356', 218, 13, 7187, 33.9472, 0.592490411833019, -84.3321, -1.47187281012111),
(13153, '30357', 218, 13, 7187, 33.7981, 0.589888125918295, -84.3865, -1.47282226923419),
(13154, '30358', 218, 13, 7187, 33.9327, 0.59223733909148, -84.3857, -1.47280830660018),
(13155, '30359', 218, 13, 7187, 33.8226, 0.590315731585034, -84.3223, -1.47170176785441),
(13156, '30360', 218, 13, 7187, 33.9313, 0.592212904481952, -84.2773, -1.47091636969102),
(13157, '30361', 218, 13, 7187, 33.7895, 0.589738027602624, -84.3813, -1.47273151211309),
(13158, '30362', 218, 13, 7187, 33.9024, 0.591708504328126, -84.274, -1.4708587738257),
(13159, '30364', 218, 13, 7187, 33.6745, 0.58773089896283, -84.4614, -1.47412952084394),
(13160, '30366', 218, 13, 7187, 33.8875, 0.591448450269578, -84.2907, -1.47115024381078),
(13161, '30368', 218, 13, 7187, 33.6488, 0.587282349345068, -84.3912, -1.47290429970904),
(13162, '30369', 218, 13, 7187, 33.8033, 0.589978883039399, -84.4728, -1.47432848837867),
(13163, '30370', 218, 13, 7187, 33.7537, 0.58911319973041, -84.3898, -1.47287986509951),
(13164, '30371', 218, 13, 7187, 33.763, 0.589275515350845, -84.4231, -1.47346105974043),
(13165, '30374', 218, 13, 7187, 33.5788, 0.586060618868672, -84.3932, -1.47293920629408),
(13166, '30375', 218, 13, 7187, 33.7732, 0.589453538934549, -84.3865, -1.47282226923419),
(13167, '30376', 218, 13, 7187, 33.8195, 0.590261626378222, -84.3562, -1.47229343447084),
(13168, '30377', 218, 13, 7187, 33.7923, 0.58978689682168, -84.4483, -1.47390088271193),
(13169, '30378', 218, 13, 7187, 33.7546, 0.589128907693678, -84.5482, -1.47564446663467),
(13170, '30379', 218, 13, 7187, 33.7707, 0.589409905703249, -84.3771, -1.47265820828451),
(13171, '30380', 218, 13, 7187, 33.6489, 0.58728409467432, -84.3914, -1.47290779036754),
(13172, '30384', 218, 13, 7187, 33.8965, 0.591605529902258, -84.4496, -1.4739235719922),
(13173, '30385', 218, 13, 7187, 33.6723, 0.587692501719287, -84.4431, -1.47381012559082),
(13174, '30386', 218, 13, 7187, 33.8717, 0.591172688247763, -84.4611, -1.47412428485618),
(13175, '30387', 218, 13, 7187, 33.7748, 0.589481464202581, -84.3871, -1.47283274120971),
(13176, '30388', 218, 13, 7187, 33.6485, 0.587277113357312, -84.3916, -1.47291128102605),
(13177, '30389', 218, 13, 7187, 33.6488, 0.587282349345068, -84.3912, -1.47290429970904),
(13178, '30390', 218, 13, 7187, 33.7744, 0.589474482885573, -84.3871, -1.47283274120971),
(13179, '30392', 218, 13, 7187, 33.7541, 0.589120181047418, -84.3893, -1.47287113845325),
(13180, '30394', 218, 13, 7187, 33.7538, 0.589114945059662, -84.3899, -1.47288161042876),
(13181, '30396', 218, 13, 7187, 33.6485, 0.587277113357312, -84.3922, -1.47292175300156),
(13182, '30398', 218, 13, 7187, 33.6489, 0.58728409467432, -84.3915, -1.47290953569679),
(13183, '30399', 218, 13, 7187, 33.7712, 0.589418632349509, -84.3863, -1.47281877857569),
(13184, '30401', 218, 13, 25279, 32.5968, 0.568921485614088, -82.3364, -1.43704127423906),
(13185, '30410', 218, 13, 18756, 32.1973, 0.56194889525237, -82.5629, -1.44099444499483),
(13186, '30411', 218, 13, 7039, 32.1539, 0.561191422357005, -82.7782, -1.44475213887437),
(13187, '30412', 218, 13, 18821, 32.0802, 0.559905114698285, -82.4796, -1.43954058572792),
(13188, '30413', 218, 13, 15101, 32.8764, 0.573801426202664, -82.4918, -1.43975351589666),
(13189, '30414', 218, 13, 7390, 32.1518, 0.561154770442713, -81.9742, -1.43071969168834),
(13190, '30415', 218, 13, 19542, 32.3696, 0.564956097553556, -81.6731, -1.42546450531058),
(13191, '30417', 218, 13, 20077, 32.1619, 0.561331048697164, -81.9096, -1.42959220899155),
(13192, '30420', 218, 13, 15569, 32.2582, 0.563011800766835, -82.1245, -1.43334292155408),
(13193, '30421', 218, 13, 308, 32.1786, 0.561622518682247, -82.1083, -1.43306017821526),
(13194, '30423', 218, 13, 1947, 32.151, 0.561140807808697, -81.8374, -1.42833208127161),
(13195, '30424', 218, 13, 8583, 32.5772, 0.568579401080697, -81.7152, -1.42619928892567),
(13196, '30425', 218, 13, 9050, 32.5983, 0.568947665552868, -82.0733, -1.43244931297706),
(13197, '30426', 218, 13, 2718, 33.0431, 0.576710890065738, -81.9947, -1.43107748418499),
(13198, '30427', 218, 13, 21431, 31.9362, 0.557391840575413, -81.9258, -1.42987495233037),
(13199, '30428', 218, 13, 2749, 32.1109, 0.560440930778647, -82.6639, -1.44275722753934),
(13200, '30429', 218, 13, 21669, 32.1558, 0.561224583612793, -81.9337, -1.43001283334128),
(13201, '30434', 218, 13, 3876, 33.0019, 0.575991814413917, -82.405, -1.43823857010593),
(13202, '30436', 218, 13, 764, 32.2038, 0.56206234165375, -82.3233, -1.43681263610705),
(13203, '30438', 218, 13, 22841, 32.0898, 0.560072666306476, -82.0526, -1.4320880298219),
(13204, '30439', 218, 13, 23059, 32.3989, 0.565467479024391, -82.0618, -1.43224860011308),
(13205, '30441', 218, 13, 23069, 32.8954, 0.574133038760543, -82.198, -1.4346257385543),
(13206, '30442', 218, 13, 23098, 32.8044, 0.572544789141228, -81.9399, -1.4301210437549),
(13207, '30445', 218, 13, 4411, 32.1792, 0.561632990657759, -82.5957, -1.44156691298948),
(13208, '30446', 218, 13, 23359, 32.6795, 0.570364872905487, -81.5808, -1.42385356641099),
(13209, '30447', 218, 13, 23403, 32.5066, 0.567347198628789, -82.4948, -1.43980587577422),
(13210, '30448', 218, 13, 23491, 32.4906, 0.56706794594847, -82.3473, -1.43723151512753),
(13211, '30449', 218, 13, 122, 32.521, 0.567598526041076, -81.5329, -1.42301755369928),
(13212, '30450', 218, 13, 24085, 32.568, 0.568418830789513, -81.9052, -1.42951541450446),
(13213, '30451', 218, 13, 11424, 32.3906, 0.565322616696475, -81.9563, -1.43040727775223),
(13214, '30452', 218, 13, 24272, 32.3187, 0.564067724964291, -81.8755, -1.42899705171662),
(13215, '30453', 218, 13, 24279, 32.0811, 0.559920822661553, -82.1206, -1.43327485371326),
(13216, '30454', 218, 13, 5478, 32.3668, 0.564907228334501, -82.746, -1.44419014285523),
(13217, '30455', 218, 13, 24475, 32.6567, 0.569966937836032, -81.7417, -1.42666180117745),
(13218, '30456', 218, 13, 715, 32.976, 0.57553977413765, -81.7586, -1.42695676182104),
(13219, '30457', 218, 13, 24956, 32.3754, 0.565057326650172, -82.5934, -1.44152677041668),
(13220, '30458', 218, 13, 25098, 32.4438, 0.566251131858536, -81.7823, -1.42737040485376),
(13221, '30459', 218, 13, 25098, 32.4482, 0.566327926345624, -81.7833, -1.42738785814628),
(13222, '30460', 218, 13, 25098, 32.4461, 0.566291274431332, -81.7448, -1.42671590638426),
(13223, '30461', 218, 13, 25098, 32.5174, 0.567535694188004, -81.7092, -1.42609456917055),
(13224, '30464', 218, 13, 25134, 32.4538, 0.566425664783736, -82.2241, -1.43508126948907),
(13225, '30467', 218, 13, 6205, 32.7483, 0.571565659430859, -81.638, -1.42485189474313),
(13226, '30470', 218, 13, 18287, 32.2939, 0.563634883309797, -82.5242, -1.4403190025743),
(13227, '30471', 218, 13, 25616, 32.6495, 0.569841274129889, -82.1554, -1.43388222829295),
(13228, '30473', 218, 13, 25673, 32.038, 0.559168585753943, -82.5147, -1.44015319629537),
(13229, '30474', 218, 13, 25728, 32.2141, 0.562242110566705, -82.4096, -1.43831885525152),
(13230, '30475', 218, 13, 25728, 32.2123, 0.562210694640169, -82.4035, -1.43821239016715),
(13231, '30477', 218, 13, 6589, 32.8657, 0.5736146759727, -82.4044, -1.43822809813042),
(13232, '30499', 218, 13, 24279, 32.085, 0.559988890502381, -82.1186, -1.43323994712822),
(13233, '30501', 218, 13, 2644, 34.2878, 0.598435003265312, -83.8195, -1.46292625237539),
(13234, '30502', 218, 13, 20019, 34.1757, 0.596478489173826, -83.9059, -1.46443421684911),
(13235, '30503', 218, 13, 2644, 34.3731, 0.599923769117263, -83.8242, -1.46300828285023),
(13236, '30504', 218, 13, 2644, 34.2647, 0.598031832208101, -83.8869, -1.46410260429123),
(13237, '30506', 218, 13, 2644, 34.3721, 0.599906315824743, -83.8679, -1.46377099173335),
(13238, '30507', 218, 13, 2644, 34.255, 0.597862535270658, -83.7751, -1.4621513261875),
(13239, '30510', 218, 13, 18828, 34.4327, 0.600963985351451, -83.6395, -1.4597846597218),
(13240, '30511', 218, 13, 722, 34.521, 0.602505111080963, -83.5306, -1.45788399616638),
(13241, '30512', 218, 13, 19321, 34.8772, 0.608721973876566, -84.0223, -1.46646578009843),
(13242, '30513', 218, 13, 992, 34.8432, 0.608128561930888, -84.3385, -1.47198451119324),
(13243, '30514', 218, 13, 19321, 34.8731, 0.608650415377235, -83.9512, -1.46522485100026),
(13244, '30515', 218, 13, 7769, 34.1321, 0.595717525619957, -84.0269, -1.46654606524402),
(13245, '30516', 218, 13, 19415, 34.4002, 0.600396753344553, -83.0468, -1.44944009324523),
(13246, '30517', 218, 13, 19449, 34.1311, 0.595700072327437, -83.7607, -1.46189999877521),
(13247, '30518', 218, 13, 7769, 34.1239, 0.595574408621293, -84.0332, -1.4666560209869),
(13248, '30519', 218, 13, 7769, 34.1014, 0.595181709539594, -83.9764, -1.46566467397177),
(13249, '30520', 218, 13, 19760, 34.2841, 0.598370426082988, -83.1035, -1.45042969493111),
(13250, '30521', 218, 13, 19796, 34.3816, 0.600072122103682, -83.2889, -1.45366553536431),
(13251, '30522', 218, 13, 0, 34.6128, 0.604107323334293, -84.5343, -1.47540186586864),
(13252, '30523', 218, 13, 20066, 34.6121, 0.604095106029529, -83.5227, -1.45774611515547),
(13253, '30525', 218, 13, 608, 34.8657, 0.608521261012587, -83.3985, -1.45557841622449),
(13254, '30527', 218, 13, 13559, 34.4786, 0.601765091478117, -83.7907, -1.46242359755081),
(13255, '30528', 218, 13, 1620, 34.627, 0.604355160088077, -83.8023, -1.46262605574404),
(13256, '30529', 218, 13, 1726, 34.1892, 0.596714108622845, -83.5153, -1.45761696079082),
(13257, '30530', 218, 13, 1726, 34.2076, 0.597035249205212, -83.4117, -1.45580879968575),
(13258, '30531', 218, 13, 20254, 34.514, 0.602382938033323, -83.5248, -1.45778276706976),
(13259, '30533', 218, 13, 20441, 34.5324, 0.60270407861569, -83.9858, -1.46582873492145),
(13260, '30534', 218, 13, 20489, 34.3912, 0.600239673711874, -84.0966, -1.46776255973266),
(13261, '30535', 218, 13, 20545, 34.5892, 0.603695425630823, -83.5812, -1.45876713276788),
(13262, '30537', 218, 13, 2042, 34.9922, 0.61072910251636, -83.3176, -1.45416644485963),
(13263, '30538', 218, 13, 20769, 34.4962, 0.602072269426468, -83.2578, -1.45312273796693),
(13264, '30539', 218, 13, 20752, 34.684, 0.605349997761713, -84.4719, -1.4743127804154),
(13265, '30540', 218, 13, 20858, 34.6865, 0.605393630993013, -84.4842, -1.47452745591339),
(13266, '30541', 218, 13, 2316, 34.9072, 0.609245572652165, -84.4988, -1.47478227398418),
(13267, '30542', 218, 13, 21161, 34.1862, 0.596661748745285, -83.9083, -1.46447610475116),
(13268, '30543', 218, 13, 21394, 34.2913, 0.598496089789131, -83.6724, -1.4603588730457),
(13269, '30544', 218, 13, 20545, 34.5803, 0.603540091327395, -83.5843, -1.4588212379747),
(13270, '30545', 218, 13, 16401, 34.7007, 0.605641467746796, -83.7261, -1.46129611485402),
(13271, '30546', 218, 13, 21859, 34.9094, 0.609283969895708, -83.7133, -1.46107271270977),
(13272, '30547', 218, 13, 22029, 34.3596, 0.599688149668244, -83.4861, -1.45710732464924),
(13273, '30548', 218, 13, 22067, 34.0694, 0.594623204178956, -83.8715, -1.46383382358642),
(13274, '30549', 218, 13, 3409, 34.1118, 0.595363223781802, -83.5778, -1.45870779157332);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(13275, '30552', 218, 13, 16824, 34.7531, 0.606556020274841, -83.397, -1.45555223628571),
(13276, '30553', 218, 13, 22587, 34.4365, 0.601030307863027, -83.1056, -1.4504663468454),
(13277, '30554', 218, 13, 22773, 34.3953, 0.600311232211206, -83.6852, -1.46058227518996),
(13278, '30555', 218, 13, 22947, 34.9797, 0.610510936359861, -84.3716, -1.47256221517565),
(13279, '30557', 218, 13, 882, 34.5302, 0.602665681372146, -83.1462, -1.45117495052171),
(13280, '30558', 218, 13, 4063, 34.256, 0.597879988563178, -83.5567, -1.45833952710115),
(13281, '30559', 218, 13, 23113, 34.9415, 0.609844220585599, -84.2643, -1.47068947688826),
(13282, '30560', 218, 13, 10596, 34.8716, 0.608624235438455, -84.2444, -1.47034215636711),
(13283, '30562', 218, 13, 23241, 34.9189, 0.609449776174648, -83.3865, -1.45536897671425),
(13284, '30563', 218, 13, 23207, 34.5596, 0.603178808172232, -83.4641, -1.4567233522138),
(13285, '30564', 218, 13, 23287, 34.4282, 0.600885445535112, -83.9124, -1.46454766325049),
(13286, '30565', 218, 13, 23378, 34.0779, 0.594771557165376, -83.4184, -1.45592573674564),
(13287, '30566', 218, 13, 4723, 34.2371, 0.597550121334551, -83.895, -1.46424397596064),
(13288, '30567', 218, 13, 4941, 34.2086, 0.597052702497732, -83.7472, -1.4616643793262),
(13289, '30568', 218, 13, 0, 34.9597, 0.610161870509462, -83.3929, -1.45548067778638),
(13290, '30571', 218, 13, 0, 34.7433, 0.606384978008146, -83.7158, -1.46111634594107),
(13291, '30572', 218, 13, 25194, 34.7318, 0.606184265144167, -84.0694, -1.46728783017612),
(13292, '30573', 218, 13, 25322, 34.7242, 0.606051620121015, -83.3826, -1.45530090887342),
(13293, '30575', 218, 13, 25324, 34.2179, 0.597215018118168, -83.7334, -1.46142352388942),
(13294, '30576', 218, 13, 25490, 34.7995, 0.607365853047767, -83.4477, -1.45643711821647),
(13295, '30577', 218, 13, 25519, 34.574, 0.603430135584519, -83.3176, -1.45416644485963),
(13296, '30580', 218, 13, 6420, 34.6888, 0.605433773565809, -83.5249, -1.45778451239901),
(13297, '30581', 218, 13, 6820, 34.7998, 0.607371089035523, -83.4477, -1.45643711821647),
(13298, '30582', 218, 13, 26301, 34.9101, 0.609296187200472, -83.8517, -1.46348824839453),
(13299, '30596', 218, 13, 18828, 34.4671, 0.601564378614138, -83.5745, -1.458650195708),
(13300, '30597', 218, 13, 20441, 34.5281, 0.602629029457854, -83.9836, -1.46579033767791),
(13301, '30598', 218, 13, 25518, 34.5902, 0.603712878923343, -83.3551, -1.45482094332913),
(13302, '30599', 218, 13, 1726, 34.206, 0.59700732393718, -83.4611, -1.45667099233624),
(13303, '30601', 218, 13, 7182, 33.9741, 0.592959905401806, -83.364, -1.45497627763255),
(13304, '30602', 218, 13, 7182, 33.9031, 0.59172072163289, -83.3185, -1.4541821528229),
(13305, '30603', 218, 13, 7182, 33.9598, 0.59271032331877, -83.3766, -1.4551961891183),
(13306, '30604', 218, 13, 7182, 34.0042, 0.593485249506656, -83.4951, -1.45726440428192),
(13307, '30605', 218, 13, 7182, 33.9253, 0.592108184726832, -83.3376, -1.45451551071003),
(13308, '30606', 218, 13, 7182, 33.95, 0.592539281052075, -83.4243, -1.45602871117151),
(13309, '30607', 218, 13, 7182, 33.9929, 0.59328802730118, -83.4207, -1.45596587931843),
(13310, '30608', 218, 13, 7182, 33.9613, 0.59273650325755, -83.3785, -1.45522935037409),
(13311, '30609', 218, 13, 7182, 33.9356, 0.592287953639788, -83.4295, -1.45611946829261),
(13312, '30612', 218, 13, 7182, 33.9551, 0.592628292843927, -83.3942, -1.45550336706666),
(13313, '30619', 218, 13, 18918, 33.8486, 0.590769517190553, -83.2852, -1.45360095818198),
(13314, '30620', 218, 13, 548, 33.9257, 0.59211516604384, -83.7497, -1.4617080125575),
(13315, '30621', 218, 13, 812, 33.833, 0.590497245827242, -83.4716, -1.4568542519077),
(13316, '30622', 218, 13, 19375, 33.9189, 0.591996483654705, -83.5269, -1.45781941898405),
(13317, '30623', 218, 13, 15290, 33.737, 0.588821729745327, -83.5199, -1.45769724593641),
(13318, '30624', 218, 13, 7625, 34.0948, 0.595066517808963, -82.8203, -1.44548692248946),
(13319, '30625', 218, 13, 19617, 33.5315, 0.585235078132479, -83.3421, -1.45459405052637),
(13320, '30627', 218, 13, 1361, 33.9644, 0.592790608464362, -82.9378, -1.44753768436055),
(13321, '30628', 218, 13, 1683, 34.0383, 0.594080406781586, -83.2126, -1.45233384914503),
(13322, '30629', 218, 13, 1723, 34.0671, 0.59458306160616, -83.125, -1.45080494072029),
(13323, '30630', 218, 13, 1860, 33.9019, 0.591699777681866, -83.1889, -1.45192020611231),
(13324, '30631', 218, 13, 15662, 33.55, 0.585557964044098, -82.8958, -1.44680464607472),
(13325, '30633', 218, 13, 1961, 34.1617, 0.596234143078547, -83.2405, -1.45282079600634),
(13326, '30634', 218, 13, 20569, 34.1825, 0.596597171562962, -82.9452, -1.4476668387252),
(13327, '30635', 218, 13, 20830, 34.1095, 0.595323081209006, -82.8623, -1.4462199607753),
(13328, '30638', 218, 13, 8849, 33.7709, 0.589413396361753, -83.4231, -1.45600776722048),
(13329, '30639', 218, 13, 21287, 34.2749, 0.598209855791805, -83.1748, -1.45167411468778),
(13330, '30641', 218, 13, 2769, 33.7785, 0.589546041384905, -83.5658, -1.45849835206308),
(13331, '30642', 218, 13, 2866, 33.5561, 0.585664429128469, -83.1688, -1.45156939493266),
(13332, '30643', 218, 13, 9368, 34.3576, 0.599653243083204, -82.9228, -1.44727588497275),
(13333, '30645', 218, 13, 3107, 33.8202, 0.590273843682986, -83.5029, -1.45740053996357),
(13334, '30646', 218, 13, 3279, 34.0198, 0.593757520869967, -83.3142, -1.45410710366506),
(13335, '30647', 218, 13, 22137, 34.1728, 0.596427874625518, -83.2937, -1.4537493111684),
(13336, '30648', 218, 13, 3748, 33.871, 0.591160470942999, -83.0765, -1.44995845603307),
(13337, '30650', 218, 13, 3938, 33.5929, 0.586306710293203, -83.4767, -1.45694326369955),
(13338, '30655', 218, 13, 10560, 33.7916, 0.589774679516916, -83.7146, -1.46109540199005),
(13339, '30656', 218, 13, 10560, 33.8502, 0.590797442458585, -83.719, -1.46117219647713),
(13340, '30660', 218, 13, 24228, 33.727, 0.588647196820127, -82.7632, -1.44449033948657),
(13341, '30662', 218, 13, 24557, 34.2881, 0.598440239253068, -83.1136, -1.45060597318556),
(13342, '30663', 218, 13, 5590, 33.6165, 0.586718607996674, -83.6055, -1.45919124777612),
(13343, '30664', 218, 13, 24789, 33.5661, 0.585838962053669, -82.8789, -1.44650968543113),
(13344, '30665', 218, 13, 5853, 33.5313, 0.585231587473975, -83.0803, -1.45002477854465),
(13345, '30666', 218, 13, 25100, 33.9647, 0.592795844452118, -83.5972, -1.4590463854482),
(13346, '30667', 218, 13, 983, 33.7711, 0.589416887020257, -83.1083, -1.4505134707352),
(13347, '30668', 218, 13, 25491, 33.7796, 0.589565240006677, -82.8181, -1.44544852524592),
(13348, '30669', 218, 13, 25655, 33.6433, 0.587186356236208, -83.0868, -1.45013822494602),
(13349, '30671', 218, 13, 22922, 33.7707, 0.589409905703249, -83.1087, -1.45052045205221),
(13350, '30673', 218, 13, 12671, 33.7317, 0.588729227294971, -82.7453, -1.44417792555046),
(13351, '30677', 218, 13, 25839, 33.8492, 0.590779989166065, -83.4148, -1.45586290489257),
(13352, '30678', 218, 13, 6780, 33.4558, 0.583913863888719, -83.0815, -1.45004572249567),
(13353, '30680', 218, 13, 26156, 33.9993, 0.593399728373308, -83.7213, -1.46121233904993),
(13354, '30683', 218, 13, 26164, 33.9577, 0.592673671404478, -83.2905, -1.45369346063234),
(13355, '30701', 218, 13, 1294, 34.4961, 0.602070524097216, -84.9311, -1.48232733234056),
(13356, '30703', 218, 13, 1294, 34.5021, 0.602175243852336, -84.9535, -1.482718286093),
(13357, '30705', 218, 13, 19964, 34.755, 0.606589181530629, -84.7905, -1.47987339941225),
(13358, '30707', 218, 13, 20026, 34.8459, 0.608175685820692, -85.3281, -1.48925628947097),
(13359, '30708', 218, 13, 8084, 34.8807, 0.608783060400386, -84.6683, -1.47774060706632),
(13360, '30710', 218, 13, 20147, 34.9401, 0.609819785976071, -84.9368, -1.48242681610792),
(13361, '30711', 218, 13, 15660, 34.9409, 0.609833748610087, -84.7599, -1.47933932866114),
(13362, '30719', 218, 13, 8391, 34.7693, 0.606838763613664, -84.97, -1.48300626541958),
(13363, '30720', 218, 13, 8391, 34.7609, 0.606692155956497, -84.9769, -1.48312669313797),
(13364, '30721', 218, 13, 8391, 34.7839, 0.607093581684456, -84.9325, -1.48235176695008),
(13365, '30722', 218, 13, 8391, 34.7624, 0.606718335895277, -84.9506, -1.48266767154469),
(13366, '30724', 218, 13, 20940, 34.8228, 0.607772514763481, -84.7632, -1.47939692452646),
(13367, '30725', 218, 13, 21150, 34.9384, 0.609790115378787, -85.3343, -1.4893644998846),
(13368, '30726', 218, 13, 2830, 34.9768, 0.610460321811553, -85.1414, -1.4859977597575),
(13369, '30728', 218, 13, 36766, 34.7106, 0.605814255342744, -85.2862, -1.48852499651439),
(13370, '30730', 218, 13, 22786, 34.4028, 0.600442131905105, -85.3999, -1.49050943587391),
(13371, '30731', 218, 13, 23043, 34.5029, 0.602189206486351, -85.4925, -1.49212561076125),
(13372, '30732', 218, 13, 4718, 34.5629, 0.603236404037548, -84.7005, -1.47830260308546),
(13373, '30733', 218, 13, 23999, 34.412, 0.600602702196289, -85.0389, -1.48420879727421),
(13374, '30734', 218, 13, 11465, 34.5333, 0.602719786578958, -84.7359, -1.47892044964066),
(13375, '30735', 218, 13, 24289, 34.592, 0.603744294849878, -84.9264, -1.48224530186571),
(13376, '30736', 218, 13, 5403, 34.9322, 0.609681904965163, -85.151, -1.48616531136569),
(13377, '30738', 218, 13, 24347, 34.7783, 0.606995843246344, -85.4441, -1.49128087140329),
(13378, '30739', 218, 13, 5468, 34.8988, 0.609098964994997, -85.2843, -1.4884918352586),
(13379, '30740', 218, 13, 24474, 34.7709, 0.606866688881696, -85.0559, -1.48450550324704),
(13380, '30741', 218, 13, 24541, 34.9559, 0.610095547997886, -85.2918, -1.4886227349525),
(13381, '30742', 218, 13, 21237, 34.9519, 0.610025734827806, -85.2484, -1.48786526205713),
(13382, '30746', 218, 13, 25208, 34.5728, 0.603409191633496, -85.0248, -1.48396270584967),
(13383, '30747', 218, 13, 6150, 34.4844, 0.601866320574733, -85.3454, -1.48955823143157),
(13384, '30750', 218, 13, 22740, 34.975, 0.610428905885017, -85.3571, -1.48976243495405),
(13385, '30751', 218, 13, 25375, 34.987, 0.610638345395256, -84.7385, -1.47896582820122),
(13386, '30752', 218, 13, 6381, 34.871, 0.608613763462943, -85.5095, -1.49242231673409),
(13387, '30753', 218, 13, 25570, 34.54, 0.602836723638841, -85.307, -1.4888880249988),
(13388, '30755', 218, 13, 25586, 34.8419, 0.608105872650612, -85.0443, -1.48430304505381),
(13389, '30756', 218, 13, 25699, 34.8973, 0.609072785056217, -84.9757, -1.48310574918695),
(13390, '30757', 218, 13, 6816, 34.9763, 0.610451595165293, -85.4371, -1.49115869835565),
(13391, '30802', 218, 13, 18885, 33.5393, 0.585371213814134, -82.3156, -1.43667824575464),
(13392, '30803', 218, 13, 18985, 33.1929, 0.579325393285226, -82.5279, -1.44038357975663),
(13393, '30805', 218, 13, 19370, 33.343, 0.581945132492469, -82.1288, -1.43341797071192),
(13394, '30806', 218, 13, 19394, 33.528, 0.585173991608659, -82.5143, -1.44014621497836),
(13395, '30807', 218, 13, 19711, 33.4565, 0.583926081193483, -82.6461, -1.44244655893249),
(13396, '30808', 218, 13, 20502, 33.4608, 0.584001130351319, -82.4972, -1.43984776367627),
(13397, '30809', 218, 13, 15, 33.5409, 0.585399139082166, -82.1389, -1.43359424896637),
(13398, '30810', 218, 13, 2709, 33.2334, 0.580032251632284, -82.6002, -1.44164545280582),
(13399, '30811', 218, 13, 21509, 33.0925, 0.577573082716224, -82.2249, -1.43509523212309),
(13400, '30812', 218, 13, 21514, 33.3734, 0.582475712585075, -82.027, -1.43164122553339),
(13401, '30813', 218, 13, 21640, 33.4642, 0.584060471545886, -82.207, -1.43478281818698),
(13402, '30814', 218, 13, 16360, 33.4155, 0.583210496200165, -82.3127, -1.43662763120634),
(13403, '30815', 218, 13, 3066, 33.3426, 0.581938151175461, -82.071, -1.43240917040427),
(13404, '30816', 218, 13, 16724, 33.1724, 0.578967600788567, -82.1812, -1.43433252323996),
(13405, '30817', 218, 13, 22680, 33.8229, 0.59032096757279, -82.492, -1.43975700655516),
(13406, '30818', 218, 13, 4038, 33.2173, 0.579751253622712, -82.2855, -1.43615290164979),
(13407, '30819', 218, 13, 23054, 33.4594, 0.583976695741791, -82.5903, -1.44147266520987),
(13408, '30820', 218, 13, 4252, 33.1876, 0.57923289083487, -82.67, -1.44286369262371),
(13409, '30821', 218, 13, 4648, 33.4591, 0.583971459754035, -82.7064, -1.44349899247144),
(13410, '30822', 218, 13, 11143, 32.8115, 0.572668707518119, -81.9394, -1.43011231710864),
(13411, '30823', 218, 13, 6053, 33.2085, 0.579597664648537, -82.4599, -1.43919675586527),
(13412, '30824', 218, 13, 25465, 33.4694, 0.58415122866699, -82.4984, -1.43986870762729),
(13413, '30828', 218, 13, 6633, 33.4087, 0.58309181381103, -82.6618, -1.44272057562505),
(13414, '30830', 218, 13, 25858, 33.0905, 0.577538176131184, -82.0161, -1.43145098464492),
(13415, '30833', 218, 13, 26264, 33.2081, 0.579590683331529, -82.3887, -1.43795408143785),
(13416, '30901', 218, 13, 7193, 33.4608, 0.584001130351319, -81.9722, -1.4306847851033),
(13417, '30903', 218, 13, 7193, 33.4713, 0.584184389922778, -81.9675, -1.43060275462845),
(13418, '30904', 218, 13, 7193, 33.4734, 0.58422104183707, -82.0131, -1.43139862476736),
(13419, '30905', 218, 13, 7193, 33.4055, 0.583035963274966, -82.117, -1.43321202186018),
(13420, '30906', 218, 13, 7193, 33.4001, 0.582941715495358, -82.0323, -1.43173372798374),
(13421, '30907', 218, 13, 7193, 33.5157, 0.584959316110664, -82.1063, -1.43302527163022),
(13422, '30909', 218, 13, 7193, 33.4782, 0.584304817641166, -82.068, -1.43235681052671),
(13423, '30910', 218, 13, 7193, 33.4718, 0.584193116569038, -81.99, -1.43099545371015),
(13424, '30911', 218, 13, 7193, 33.4323, 0.5835037115145, -81.9561, -1.43040378709372),
(13425, '30912', 218, 13, 7193, 33.4706, 0.584172172618014, -81.991, -1.43101290700267),
(13426, '30913', 218, 13, 7193, 33.5273, 0.585161774303895, -82.1113, -1.43311253809282),
(13427, '30914', 218, 13, 7193, 33.4696, 0.584154719325494, -82.0212, -1.43153999643677),
(13428, '30916', 218, 13, 7193, 33.4209, 0.583304743979773, -82.0207, -1.43153126979051),
(13429, '30917', 218, 13, 7193, 33.5169, 0.584980260061687, -82.0581, -1.43218402293076),
(13430, '30919', 218, 13, 7193, 33.4697, 0.584156464654746, -82.0671, -1.43234110256344),
(13431, '30999', 218, 13, 7193, 33.4576, 0.583945279815255, -81.9946, -1.43107573885574),
(13432, '31001', 218, 13, 18708, 31.9892, 0.55831686507897, -83.3109, -1.45404950779974),
(13433, '31002', 218, 13, 18746, 32.5319, 0.567788766929543, -82.5934, -1.44152677041668),
(13434, '31003', 218, 13, 14969, 32.5976, 0.568935448248104, -83.2234, -1.45252234470425),
(13435, '31004', 218, 13, 19380, 33.0864, 0.577466617631852, -83.9194, -1.46466983629813),
(13436, '31005', 218, 13, 19386, 32.5551, 0.568193683316006, -83.6206, -1.45945479249317),
(13437, '31006', 218, 13, 1257, 32.5544, 0.568181466011242, -84.2414, -1.47028979648955),
(13438, '31007', 218, 13, 19682, 32.1749, 0.561557941499924, -83.927, -1.46480248132128),
(13439, '31008', 218, 13, 7810, 32.6459, 0.569778442276817, -83.7549, -1.4617987696786),
(13440, '31009', 218, 13, 19689, 32.3362, 0.56437315758339, -83.0429, -1.4493720254044),
(13441, '31010', 218, 13, 20244, 31.953, 0.557685055889748, -83.7838, -1.46230316983243),
(13442, '31011', 218, 13, 19971, 32.2091, 0.562154844104106, -83.1265, -1.45083112065907),
(13443, '31012', 218, 13, 8056, 32.3271, 0.564214332621459, -83.1659, -1.45151878038435),
(13444, '31013', 218, 13, 20104, 32.3383, 0.564409809497682, -83.7315, -1.46139036263363),
(13445, '31014', 218, 13, 20138, 32.3882, 0.565280728794427, -83.3479, -1.45469527962298),
(13446, '31015', 218, 13, 20244, 31.9505, 0.557641422658448, -83.7642, -1.46196108529903),
(13447, '31016', 218, 13, 20406, 32.775, 0.572031662341141, -84.1854, -1.46931241210843),
(13448, '31017', 218, 13, 1964, 32.6048, 0.569061111954247, -83.2486, -1.45296216767575),
(13449, '31018', 218, 13, 20481, 32.9839, 0.575677655148558, -82.6026, -1.44168734070787),
(13450, '31019', 218, 13, 2038, 32.4384, 0.566156884078929, -83.0606, -1.449680948682),
(13451, '31020', 218, 13, 20685, 32.8149, 0.572728048712687, -83.5512, -1.45824353399229),
(13452, '31021', 218, 13, 2113, 32.5415, 0.567956318537735, -82.9104, -1.44705946414551),
(13453, '31022', 218, 13, 2116, 32.5113, 0.567429229103632, -83.0915, -1.45022025542087),
(13454, '31023', 218, 13, 20777, 32.1979, 0.561959367227882, -83.1803, -1.45177010779664),
(13455, '31024', 218, 13, 20783, 33.3246, 0.581623991910102, -83.3449, -1.45464291974542),
(13456, '31025', 218, 13, 2260, 32.3442, 0.56451278392355, -83.7413, -1.46156140490033),
(13457, '31026', 218, 13, 20783, 33.3013, 0.581217330194388, -83.3792, -1.45524156767886),
(13458, '31027', 218, 13, 20750, 32.5504, 0.568111652841162, -82.8683, -1.44632468053042),
(13459, '31028', 218, 13, 1459, 32.6304, 0.569507916242758, -83.6772, -1.4604426488498),
(13460, '31029', 218, 13, 21226, 33.0328, 0.576531121152783, -83.9374, -1.46498399556349),
(13461, '31030', 218, 13, 21241, 32.5496, 0.568097690207146, -83.8844, -1.46405897105993),
(13462, '31031', 218, 13, 2785, 32.9006, 0.574223795881646, -83.3172, -1.45415946354262),
(13463, '31032', 218, 13, 21530, 33.0023, 0.575998795730925, -83.5467, -1.45816499417595),
(13464, '31033', 218, 13, 21667, 33.0068, 0.576077335547264, -83.3699, -1.45507925205842),
(13465, '31034', 218, 13, 2971, 33.0544, 0.576908112271214, -83.2326, -1.45268291499543),
(13466, '31035', 218, 13, 9353, 32.8768, 0.573808407519672, -82.7441, -1.44415698159944),
(13467, '31036', 218, 13, 3015, 32.2817, 0.563421953141053, -83.4745, -1.45690486645601),
(13468, '31037', 218, 13, 3052, 32.0608, 0.559566520823398, -82.9391, -1.44756037364083),
(13469, '31038', 218, 13, 3145, 33.1774, 0.579054867251167, -83.7084, -1.46098719157642),
(13470, '31039', 218, 13, 3251, 32.5969, 0.56892323094334, -84.248, -1.47040498822018),
(13471, '31040', 218, 13, 2113, 32.5453, 0.56802264104931, -82.9007, -1.44689016720806),
(13472, '31041', 218, 13, 22126, 32.3764, 0.565074779942692, -84.2059, -1.46967020460509),
(13473, '31042', 218, 13, 22183, 32.8078, 0.572604130335796, -83.1724, -1.45163222678573),
(13474, '31044', 218, 13, 9742, 32.6808, 0.570387562185763, -83.3336, -1.45444569753995),
(13475, '31045', 218, 13, 9764, 33.3375, 0.58184913938361, -82.7372, -1.44403655388105),
(13476, '31046', 218, 13, 22311, 32.9988, 0.575937709207105, -83.7745, -1.46214085421199),
(13477, '31047', 218, 13, 16694, 32.5029, 0.567282621446465, -83.6308, -1.45963281607687),
(13478, '31049', 218, 13, 22417, 32.7193, 0.571059513947781, -82.5329, -1.44047084621923),
(13479, '31050', 218, 13, 3570, 32.6329, 0.569551549474058, -83.9621, -1.46541509188873),
(13480, '31051', 218, 13, 22665, 32.147, 0.561070994638617, -83.8778, -1.4639437793293),
(13481, '31052', 218, 13, 22711, 32.7866, 0.572234120534373, -83.797, -1.46253355329369),
(13482, '31054', 218, 13, 17070, 32.8461, 0.573272591439309, -83.2019, -1.45214709891507),
(13483, '31055', 218, 13, 4113, 32.065, 0.559639824651982, -82.898, -1.44684304331826),
(13484, '31057', 218, 13, 22897, 32.4553, 0.566451844722516, -83.9401, -1.46503111945329),
(13485, '31058', 218, 13, 22921, 32.509, 0.567389086530837, -84.376, -1.47263900966274),
(13486, '31059', 218, 13, 23097, 33.0874, 0.577484070924372, -83.2439, -1.45288013720091),
(13487, '31060', 218, 13, 23084, 31.9311, 0.557302828783561, -83.0684, -1.44981708436366),
(13488, '31061', 218, 13, 23097, 33.0872, 0.577480580265868, -83.2432, -1.45286791989614),
(13489, '31062', 218, 13, 23097, 33.0847, 0.577436947034568, -83.2393, -1.45279985205532),
(13490, '31063', 218, 13, 23157, 32.3011, 0.56376054701594, -84.0241, -1.46649719602497),
(13491, '31064', 218, 13, 588, 33.3351, 0.581807251481562, -83.7602, -1.46189127212895),
(13492, '31065', 218, 13, 4299, 32.5644, 0.568355998936441, -83.1595, -1.45140707931222),
(13493, '31066', 218, 13, 23292, 32.8396, 0.57315914503793, -83.89, -1.46415670949804),
(13494, '31067', 218, 13, 23595, 32.8689, 0.573670526508764, -82.8767, -1.44647128818758),
(13495, '31068', 218, 13, 23609, 32.2939, 0.563634883309797, -84.0665, -1.46723721562781),
(13496, '31069', 218, 13, 11148, 32.4587, 0.566511185917083, -83.7315, -1.46139036263363),
(13497, '31070', 218, 13, 23951, 32.1937, 0.561886063399298, -83.7599, -1.4618860361412),
(13498, '31071', 218, 13, 5075, 32.0777, 0.559861481466985, -83.502, -1.4573848320003),
(13499, '31072', 218, 13, 11243, 32.0071, 0.558629279015077, -83.6172, -1.4593954512986),
(13500, '31073', 218, 13, 11247, 32.2115, 0.562196732006154, -83.1976, -1.45207204975723),
(13501, '31075', 218, 13, 24287, 32.3336, 0.564327779022838, -82.8832, -1.44658473458896),
(13502, '31076', 218, 13, 5360, 32.5617, 0.568308875046638, -84.0926, -1.46769274656258),
(13503, '31077', 218, 13, 24300, 32.008, 0.558644986978345, -83.1995, -1.45210521101302),
(13504, '31078', 218, 13, 5441, 32.7209, 0.571087439215813, -84.0167, -1.46636804166032),
(13505, '31079', 218, 13, 17824, 31.9485, 0.557606516073408, -83.4553, -1.45656976323962),
(13506, '31081', 218, 13, 11731, 32.4261, 0.565942208580933, -84.2888, -1.471117082555),
(13507, '31082', 218, 13, 24644, 32.9838, 0.575675909819306, -82.8096, -1.4453001722595),
(13508, '31083', 218, 13, 5690, 31.9828, 0.558205164006843, -82.8685, -1.44632817118892),
(13509, '31084', 218, 13, 18040, 31.9308, 0.557297592795805, -83.5534, -1.45828193123583),
(13510, '31085', 218, 13, 24765, 33.4002, 0.58294346082461, -83.6635, -1.46020353874228),
(13511, '31086', 218, 13, 24909, 32.8765, 0.573803171531916, -84.0618, -1.46715518515297),
(13512, '31087', 218, 13, 25003, 33.2773, 0.580798451173909, -82.9716, -1.44812760564773),
(13513, '31088', 218, 13, 25805, 32.5962, 0.568911013638576, -83.6388, -1.45977244241703),
(13514, '31089', 218, 13, 6270, 32.9383, 0.574881785009648, -82.8112, -1.44532809752753),
(13515, '31090', 218, 13, 25529, 32.8458, 0.573267355451554, -83.0965, -1.45030752188347),
(13516, '31091', 218, 13, 25636, 32.261, 0.563060669985891, -83.7466, -1.46165390735068),
(13517, '31092', 218, 13, 6557, 32.0922, 0.560114554208524, -83.7957, -1.46251086401341),
(13518, '31093', 218, 13, 25805, 32.6363, 0.569610890668625, -83.6422, -1.4598317836116),
(13519, '31094', 218, 13, 25814, 33.0117, 0.576162856680612, -82.8212, -1.44550263045273),
(13520, '31095', 218, 13, 25805, 32.6208, 0.569340364634566, -83.5998, -1.45909176400876),
(13521, '31096', 218, 13, 12969, 32.7247, 0.571153761727388, -82.7239, -1.44380442509054),
(13522, '31097', 218, 13, 6978, 32.9233, 0.574619985621849, -84.1642, -1.46894240230701),
(13523, '31098', 218, 13, 25805, 32.6093, 0.569139651770587, -83.5954, -1.45901496952167),
(13524, '31099', 218, 13, 25805, 32.6426, 0.569720846411501, -83.6342, -1.45969215727144),
(13525, '31106', 218, 13, 7187, 33.7874, 0.589701375688332, -84.3549, -1.47227074519056),
(13526, '31107', 218, 13, 7187, 33.7621, 0.589259807387577, -84.3529, -1.47223583860553),
(13527, '31119', 218, 13, 7187, 33.8577, 0.590928342152484, -84.3455, -1.47210668424088),
(13528, '31126', 218, 13, 7187, 33.8478, 0.590755554556537, -84.361, -1.47237721027494),
(13529, '31131', 218, 13, 7187, 33.7054, 0.588270205701697, -84.549, -1.47565842926869),
(13530, '31132', 218, 13, 7187, 33.749, 0.589031169255566, -84.3876, -1.47284146785597),
(13531, '31139', 218, 13, 7187, 33.7483, 0.589018951950802, -84.388, -1.47284844917298),
(13532, '31141', 218, 13, 7187, 33.7624, 0.589265043375333, -84.4225, -1.47345058776491),
(13533, '31145', 218, 13, 7187, 33.851, 0.5908114050926, -84.2812, -1.47098443753184),
(13534, '31146', 218, 13, 7187, 33.9258, 0.592116911373092, -84.3415, -1.4720368710708),
(13535, '31150', 218, 13, 7187, 33.9811, 0.593082078449445, -84.3345, -1.47191469802316),
(13536, '31156', 218, 13, 7187, 33.9622, 0.592752211220818, -84.3657, -1.47245924074978),
(13537, '31191', 218, 13, 7187, 33.7919, 0.589779915504672, -84.4483, -1.47390088271193),
(13538, '31192', 218, 13, 7187, 33.6237, 0.586844271702817, -84.5329, -1.47537743125911),
(13539, '31193', 218, 13, 7187, 33.7599, 0.589221410144034, -84.3854, -1.47280307061242),
(13540, '31195', 218, 13, 7187, 33.805, 0.590008553636683, -84.4749, -1.47436514029296),
(13541, '31196', 218, 13, 7187, 33.8054, 0.590015534953691, -84.475, -1.47436688562221),
(13542, '31197', 218, 13, 7187, 33.8056, 0.590019025612195, -84.4752, -1.47437037628071),
(13543, '31198', 218, 13, 7187, 33.805, 0.590008553636683, -84.4752, -1.47437037628071),
(13544, '31199', 218, 13, 7187, 33.8053, 0.590013789624439, -84.4751, -1.47436863095146),
(13545, '31201', 218, 13, 3937, 32.8352, 0.573082350550842, -83.6335, -1.45967993996668),
(13546, '31202', 218, 13, 3937, 32.8347, 0.573073623904582, -83.6328, -1.45966772266191),
(13547, '31203', 218, 13, 3937, 32.8651, 0.573604203997188, -83.6937, -1.46073062817638),
(13548, '31204', 218, 13, 3937, 32.843, 0.573218486232498, -83.6774, -1.4604461395083),
(13549, '31205', 218, 13, 3937, 32.75, 0.571595330028143, -83.6606, -1.46015292419397),
(13550, '31206', 218, 13, 3937, 32.8027, 0.572515118543944, -83.6645, -1.4602209920348),
(13551, '31207', 218, 13, 3937, 32.8301, 0.57299333875899, -83.6537, -1.46003249647558),
(13552, '31208', 218, 13, 3937, 32.8316, 0.57301951869777, -83.6382, -1.45976197044152),
(13553, '31209', 218, 13, 3937, 32.8763, 0.573799680873412, -83.665, -1.46022971868106),
(13554, '31210', 218, 13, 3937, 32.8742, 0.57376302895912, -83.7405, -1.46154744226631),
(13555, '31211', 218, 13, 3937, 32.8645, 0.573593732021676, -83.6046, -1.45917553981285),
(13556, '31212', 218, 13, 3937, 32.8343, 0.573066642587574, -83.6325, -1.45966248667416),
(13557, '31213', 218, 13, 3937, 32.8229, 0.572867675052847, -83.6459, -1.45989636079392),
(13558, '31216', 218, 13, 3937, 32.7315, 0.571272444116524, -83.684, -1.46056133123893),
(13559, '31217', 218, 13, 3937, 32.8391, 0.57315041839167, -83.5422, -1.45808645435961),
(13560, '31220', 218, 13, 3937, 32.8843, 0.573939307213571, -83.8364, -1.46322121301897),
(13561, '31221', 218, 13, 3937, 32.8817, 0.573893928653019, -83.8183, -1.46290530842436),
(13562, '31294', 218, 13, 3937, 32.8352, 0.573082350550842, -83.6317, -1.45964852404014),
(13563, '31295', 218, 13, 3937, 32.8113, 0.572665216859615, -83.5695, -1.4585629292454),
(13564, '31296', 218, 13, 3937, 32.8105, 0.572651254225599, -83.5695, -1.4585629292454),
(13565, '31297', 218, 13, 3937, 32.8062, 0.572576205067764, -83.6929, -1.46071666554236),
(13566, '31298', 218, 13, 3937, 32.8409, 0.573181834318206, -83.6323, -1.45965899601565),
(13567, '31299', 218, 13, 3937, 32.8371, 0.57311551180663, -83.6572, -1.4600935829994),
(13568, '31301', 218, 13, 14968, 31.7748, 0.554574879162694, -81.5986, -1.42416423501785),
(13569, '31302', 218, 13, 13040, 32.1201, 0.560601501069831, -81.2992, -1.41893871923737),
(13570, '31303', 218, 13, 20123, 32.5181, 0.567547911492768, -81.3169, -1.41924764251498),
(13571, '31304', 218, 13, 8292, 31.4965, 0.549717627854394, -81.3736, -1.42023724420086),
(13572, '31305', 218, 13, 20468, 31.3776, 0.547642431373773, -81.4249, -1.42113259810713),
(13573, '31307', 218, 13, 2217, 32.174, 0.561542233536656, -81.3903, -1.42052871418594),
(13574, '31308', 218, 13, 20849, 32.1722, 0.56151081761012, -81.4804, -1.42210125584199),
(13575, '31309', 218, 13, 21138, 31.8839, 0.55647903337662, -81.4121, -1.42090919596288),
(13576, '31310', 218, 13, 21967, 31.8322, 0.555576698153339, -81.599, -1.42417121633485),
(13577, '31312', 218, 13, 21653, 32.3175, 0.564046781013268, -81.3941, -1.42059503669752),
(13578, '31313', 218, 13, 21967, 31.8465, 0.555826280236374, -81.6039, -1.4242567374682),
(13579, '31314', 218, 13, 21240, 32.0387, 0.559180803058707, -81.507, -1.42256551342302),
(13580, '31315', 218, 13, 21240, 31.888, 0.556550591875952, -81.6025, -1.42423230285867),
(13581, '31316', 218, 13, 22769, 31.7295, 0.553784245011541, -81.7368, -1.4265762800441),
(13582, '31318', 218, 13, 23035, 32.143, 0.561001181468537, -81.378, -1.42031403868795),
(13583, '31319', 218, 13, 10448, 31.4193, 0.548370233671854, -81.4246, -1.42112736211937),
(13584, '31320', 218, 13, 41, 31.8225, 0.555407401215896, -81.3949, -1.42060899933153),
(13585, '31321', 218, 13, 17567, 32.1347, 0.560856319140622, -81.6255, -1.42463372858663),
(13586, '31322', 218, 13, 24072, 32.117, 0.560547395863019, -81.2526, -1.41812539580594),
(13587, '31323', 218, 13, 24302, 31.7267, 0.553735375792485, -81.4688, -1.42189879764876),
(13588, '31324', 218, 13, 24309, 31.8745, 0.556314972426933, -81.2856, -1.4187013544591),
(13589, '31326', 218, 13, 24340, 32.2857, 0.563491766311133, -81.2234, -1.41761575966436),
(13590, '31327', 218, 13, 448, 31.4419, 0.548764678082805, -81.2638, -1.41832087268217),
(13591, '31328', 218, 13, 25627, 32.0054, 0.558599608417793, -80.852, -1.41113360682246),
(13592, '31329', 218, 13, 349, 32.3685, 0.564936898931785, -81.3099, -1.41912546946734),
(13593, '31331', 218, 13, 14757, 31.3794, 0.547673847300309, -81.422, -1.42108198355882),
(13594, '31333', 218, 13, 25795, 31.774, 0.554560916528678, -81.6328, -1.42476113762203),
(13595, '31401', 218, 13, 24690, 32.0691, 0.559711383151314, -81.105, -1.41554928983),
(13596, '31402', 218, 13, 24690, 32.0945, 0.56015469678132, -81.3319, -1.41950944190278),
(13597, '31403', 218, 13, 24690, 32.045, 0.559290758801583, -81.1095, -1.41562782964634),
(13598, '31404', 218, 13, 24690, 32.0452, 0.559294249460087, -81.0691, -1.41492271662854),
(13599, '31405', 218, 13, 24690, 32.0396, 0.559196511021975, -81.1305, -1.41599434878926),
(13600, '31406', 218, 13, 24690, 31.9922, 0.55836922495653, -81.0943, -1.41536253960004),
(13601, '31407', 218, 13, 24690, 32.1496, 0.561116373199169, -81.1645, -1.41658776073494),
(13602, '31408', 218, 13, 24690, 32.1733, 0.561530016231892, -81.206, -1.41731207237452),
(13603, '31409', 218, 13, 24690, 32.0105, 0.558688620209645, -81.1542, -1.41640799182198),
(13604, '31410', 218, 13, 24690, 32.0122, 0.558718290806929, -80.9511, -1.41286322811118),
(13605, '31411', 218, 13, 24690, 31.9424, 0.557500050989037, -81.0354, -1.41433454067061),
(13606, '31412', 218, 13, 24690, 32.0774, 0.559856245479229, -81.0927, -1.41533461433201),
(13607, '31414', 218, 13, 24690, 32.0515, 0.559404205202963, -81.0519, -1.41462251999719),
(13608, '31415', 218, 13, 24690, 32.075, 0.559814357577181, -81.1299, -1.41598387681375),
(13609, '31416', 218, 13, 24690, 32.0049, 0.558590881771533, -81.0955, -1.41538348355106),
(13610, '31418', 218, 13, 24690, 32.153, 0.561175714393737, -81.1952, -1.4171235768153),
(13611, '31419', 218, 13, 24690, 31.9815, 0.558182474726566, -81.1826, -1.41690366532955),
(13612, '31420', 218, 13, 24690, 31.9809, 0.558172002751055, -81.1483, -1.41630501739611),
(13613, '31421', 218, 13, 24690, 32.0829, 0.559952238588089, -81.1208, -1.41582505185182),
(13614, '31422', 218, 13, 24690, 32.1533, 0.561180950381493, -81.1947, -1.41711485016904),
(13615, '31498', 218, 13, 24690, 32.0801, 0.559903369369033, -81.1075, -1.4155929230613),
(13616, '31499', 218, 13, 24690, 32.0804, 0.559908605356789, -81.1072, -1.41558768707354),
(13617, '31501', 218, 13, 25853, 31.2211, 0.544910991094402, -82.3552, -1.43736939613843),
(13618, '31502', 218, 13, 25853, 31.2127, 0.544764383437234, -82.3615, -1.43747935188131),
(13619, '31503', 218, 13, 25853, 31.2176, 0.544849904570582, -82.3731, -1.43768181007454),
(13620, '31510', 218, 13, 7066, 31.5406, 0.550487318054524, -82.4635, -1.43925958771834),
(13621, '31512', 218, 13, 18836, 31.5115, 0.549979427242193, -83.0145, -1.44887635189683),
(13622, '31513', 218, 13, 767, 31.7754, 0.554585351138206, -82.3522, -1.43731703626087),
(13623, '31515', 218, 13, 767, 31.7781, 0.55463247502801, -82.3488, -1.43725769506631),
(13624, '31516', 218, 13, 19309, 31.2986, 0.546263621264697, -82.252, -1.43556821635038),
(13625, '31518', 218, 13, 15330, 31.4167, 0.548324855111302, -82.2665, -1.43582128909192),
(13626, '31519', 218, 13, 19599, 31.6266, 0.551988301211239, -82.8929, -1.44675403152641),
(13627, '31520', 218, 13, 19602, 31.1784, 0.5441657355038, -81.4918, -1.42230022337672),
(13628, '31521', 218, 13, 19602, 31.1576, 0.543802707019385, -81.489, -1.42225135415766),
(13629, '31522', 218, 13, 24613, 31.1644, 0.543921389408521, -81.3844, -1.42042573976007),
(13630, '31523', 218, 13, 19602, 31.1737, 0.544083705028956, -81.4991, -1.42242763241211),
(13631, '31524', 218, 13, 19602, 31.1428, 0.54354439829009, -81.4707, -1.42193195890454),
(13632, '31525', 218, 13, 19602, 31.2335, 0.545127411921649, -81.4997, -1.42243810438762),
(13633, '31527', 218, 13, 0, 31.0709, 0.542289506557906, -81.4091, -1.42085683608532),
(13634, '31532', 218, 13, 8484, 31.7833, 0.554723232149114, -82.6584, -1.44266123443048),
(13635, '31533', 218, 13, 2088, 31.5106, 0.549963719278925, -82.849, -1.44598783198478),
(13636, '31534', 218, 13, 2088, 31.5055, 0.549874707487074, -82.8514, -1.44602971988683),
(13637, '31535', 218, 13, 2088, 31.5084, 0.549925322035381, -82.8504, -1.44601226659431),
(13638, '31537', 218, 13, 21168, 30.839, 0.538242088022531, -82.0095, -1.43133579291429),
(13639, '31539', 218, 13, 21801, 31.8686, 0.556211998001065, -82.6007, -1.44165417945208),
(13640, '31542', 218, 13, 3171, 31.1866, 0.544308852502464, -82.1192, -1.43325041910373),
(13641, '31543', 218, 13, 22066, 31.3126, 0.546507967359976, -81.9657, -1.43057133870192),
(13642, '31544', 218, 13, 3395, 31.8366, 0.555653492640427, -82.9498, -1.44774712387079),
(13643, '31545', 218, 13, 9762, 31.6123, 0.551738719128203, -81.8849, -1.4291611126663),
(13644, '31546', 218, 13, 9762, 31.4711, 0.549274314224387, -81.7813, -1.42735295156124),
(13645, '31547', 218, 13, 16730, 30.8345, 0.538163548206192, -81.7755, -1.42725172246462),
(13646, '31548', 218, 13, 9871, 30.7941, 0.537458435188386, -81.7104, -1.42611551312157),
(13647, '31549', 218, 13, 22777, 31.9108, 0.556948526945407, -82.7739, -1.44467708971653),
(13648, '31550', 218, 13, 22847, 30.6848, 0.535550790315956, -82.3524, -1.43732052691938),
(13649, '31551', 218, 13, 23053, 31.4792, 0.549415685893799, -82.2179, -1.43497305907545),
(13650, '31552', 218, 13, 624, 31.2741, 0.545836015597959, -82.6381, -1.44230693259233),
(13651, '31553', 218, 13, 23302, 31.2198, 0.544888301814126, -81.9584, -1.43044392966652),
(13652, '31554', 218, 13, 23377, 31.4219, 0.548415612232406, -82.5948, -1.44155120502621),
(13653, '31555', 218, 13, 23604, 31.6648, 0.5526550169855, -82.0133, -1.43140211542587),
(13654, '31556', 218, 13, 23605, 31.4096, 0.548200936734411, -82.1124, -1.43313173671459),
(13655, '31557', 218, 13, 428, 31.3749, 0.547595307483969, -82.1064, -1.43302701695947),
(13656, '31558', 218, 13, 24606, 30.757, 0.536810918035896, -81.5633, -1.42354813379189),
(13657, '31560', 218, 13, 24720, 31.4874, 0.549558802892463, -82.0198, -1.43151556182725),
(13658, '31561', 218, 13, 24726, 31.1948, 0.544451969501127, -81.3343, -1.41955132980482),
(13659, '31562', 218, 13, 14538, 30.5226, 0.532719866269221, -82.0376, -1.4318262304341),
(13660, '31563', 218, 13, 25268, 31.6648, 0.5526550169855, -82.191, -1.43450356550666),
(13661, '31564', 218, 13, 25800, 31.2446, 0.54532114346862, -82.4728, -1.43942190333878),
(13662, '31565', 218, 13, 6664, 31.0289, 0.541556468272068, -81.5676, -1.42362318294973),
(13663, '31566', 218, 13, 25859, 31.2476, 0.54537350334618, -81.822, -1.4280633005668),
(13664, '31567', 218, 13, 25912, 31.6099, 0.551696831226156, -82.7411, -1.44410462172188),
(13665, '31568', 218, 13, 903, 31.1078, 0.542933533051892, -81.7299, -1.42645585232571),
(13666, '31569', 218, 13, 634, 30.9005, 0.539315465512508, -81.6676, -1.42536851220172),
(13667, '31598', 218, 13, 9762, 31.5053, 0.549871216828569, -81.8247, -1.4281104244566),
(13668, '31599', 218, 13, 9762, 31.4811, 0.549448847149587, -81.8016, -1.42770725339939),
(13669, '31601', 218, 13, 6492, 30.827, 0.538032648512292, -83.2814, -1.45353463567041),
(13670, '31602', 218, 13, 6492, 30.8701, 0.538784885419902, -83.2867, -1.45362713812076),
(13671, '31603', 218, 13, 6492, 30.8705, 0.538791866736909, -83.2831, -1.45356430626769),
(13672, '31604', 218, 13, 6492, 30.8816, 0.538985598283881, -83.2779, -1.45347354914659),
(13673, '31605', 218, 13, 6492, 30.9343, 0.539905386799682, -83.2208, -1.4524769661437),
(13674, '31606', 218, 13, 6492, 30.812, 0.537770849124493, -83.167, -1.45153797900612),
(13675, '31620', 218, 13, 18743, 31.1383, 0.54346585847375, -83.4259, -1.45605663643954),
(13676, '31622', 218, 13, 18771, 31.391, 0.54787630549354, -83.1968, -1.45205808712322),
(13677, '31623', 218, 13, 15022, 31.0661, 0.54220573075381, -82.7585, -1.44440830901173),
(13678, '31624', 218, 13, 19001, 31.2898, 0.546110032290522, -82.7215, -1.44376253718849),
(13679, '31625', 218, 13, 7274, 31.0044, 0.54112886260533, -83.5173, -1.45765186737586),
(13680, '31626', 218, 13, 1061, 30.7931, 0.537440981895866, -83.788, -1.46237647366101),
(13681, '31627', 218, 13, 7972, 31.1083, 0.542942259698152, -83.4218, -1.45598507794021),
(13682, '31629', 218, 13, 2047, 30.7454, 0.536608459842665, -83.6783, -1.46046184747157),
(13683, '31630', 218, 13, 20690, 30.9481, 0.540146242236457, -82.8813, -1.44655157333318),
(13684, '31631', 218, 13, 8846, 30.7894, 0.537376404713542, -82.6079, -1.44177984315822),
(13685, '31632', 218, 13, 21670, 30.9831, 0.540757107474655, -83.3695, -1.45507227074141),
(13686, '31634', 218, 13, 22030, 31.037, 0.54169783994148, -82.7513, -1.44428264530558),
(13687, '31635', 218, 13, 16822, 31.0386, 0.541725765209512, -83.0718, -1.44987642555823),
(13688, '31636', 218, 13, 16802, 30.6874, 0.535596168876508, -83.2025, -1.45215757089058),
(13689, '31637', 218, 13, 425, 31.2705, 0.545773183744887, -83.4666, -1.4567669854451),
(13690, '31638', 218, 13, 23197, 30.9035, 0.539367825390068, -83.4974, -1.45730454685471),
(13691, '31639', 218, 13, 10729, 31.2009, 0.544558434585499, -83.2405, -1.45282079600634),
(13692, '31641', 218, 13, 10735, 31.0423, 0.541790342391836, -83.0773, -1.44997241866709),
(13693, '31642', 218, 13, 4924, 31.3009, 0.546303763837493, -82.8545, -1.44608382509364),
(13694, '31643', 218, 13, 11443, 30.7849, 0.537297864897202, -83.5605, -1.45840584961272),
(13695, '31645', 218, 13, 24224, 31.075, 0.542361065057238, -83.1985, -1.4520877577205),
(13696, '31646', 218, 13, 14538, 30.5724, 0.533589040236714, -82.1124, -1.43313173671459),
(13697, '31647', 218, 13, 25000, 31.1784, 0.5441657355038, -83.4347, -1.45621022541371),
(13698, '31648', 218, 13, 25097, 30.7034, 0.535875421556827, -82.8477, -1.44596514270451),
(13699, '31649', 218, 13, 510, 31.0331, 0.541629772100652, -83.0068, -1.44874196154443),
(13700, '31650', 218, 13, 26073, 31.3382, 0.546954771648487, -83.0507, -1.44950816108605),
(13701, '31698', 218, 13, 6492, 30.8644, 0.538685401652538, -83.2871, -1.45363411943777),
(13702, '31699', 218, 13, 6492, 30.9735, 0.540589555866464, -83.2047, -1.45219596813413),
(13703, '31701', 218, 13, 18772, 31.5736, 0.551063276707682, -84.1637, -1.46893367566075),
(13704, '31702', 218, 13, 18772, 31.601, 0.551541496922728, -84.202, -1.46960213676427),
(13705, '31703', 218, 13, 18772, 31.5755, 0.55109643796347, -84.1541, -1.46876612405256),
(13706, '31704', 218, 13, 18772, 31.5523, 0.550691521577007, -84.0537, -1.46701381348356),
(13707, '31705', 218, 13, 18772, 31.5568, 0.550770061393347, -84.0894, -1.46763689602652),
(13708, '31706', 218, 13, 18772, 31.5783, 0.551145307182525, -84.1554, -1.46878881333284),
(13709, '31707', 218, 13, 18772, 31.5784, 0.551147052511777, -84.2222, -1.46995469327317),
(13710, '31708', 218, 13, 18772, 31.5929, 0.551400125253317, -84.1426, -1.46856541118858),
(13711, '31709', 218, 13, 18837, 32.0741, 0.559798649613913, -84.2251, -1.47000530782148),
(13712, '31710', 218, 13, 18837, 32.0724, 0.559768979016629, -84.2266, -1.47003148776026),
(13713, '31711', 218, 13, 18848, 32.1953, 0.56191398866733, -84.1423, -1.46856017520082),
(13714, '31712', 218, 13, 18888, 31.8413, 0.55573552311527, -83.7254, -1.46128389754926),
(13715, '31713', 218, 13, 15026, 31.442, 0.548766423412057, -84.7239, -1.47871101013042),
(13716, '31714', 218, 13, 18929, 31.7032, 0.553325223418266, -83.6529, -1.46001853384156),
(13717, '31715', 218, 13, 18957, 30.8193, 0.537898258159888, -84.5188, -1.47513133983458),
(13718, '31716', 218, 13, 19013, 31.3765, 0.547623232752001, -84.1638, -1.46893542099),
(13719, '31717', 218, 13, 19017, 30.9036, 0.53936957071932, -84.569, -1.47600749511908),
(13720, '31718', 218, 13, 19017, 30.906, 0.539411458621368, -84.5777, -1.47615933876401),
(13721, '31719', 218, 13, 18837, 32.0738, 0.559793413626157, -84.2255, -1.47001228913848),
(13722, '31720', 218, 13, 19082, 30.8964, 0.539243907013176, -83.741, -1.46155616891257),
(13723, '31721', 218, 13, 18772, 31.5786, 0.551150543170281, -84.2217, -1.46994596662691),
(13724, '31722', 218, 13, 376, 31.1254, 0.543240711000243, -83.7036, -1.46090341577233),
(13725, '31723', 218, 13, 7524, 31.3776, 0.547642431373773, -84.934, -1.48237794688886),
(13726, '31724', 218, 13, 1018, 31.5516, 0.550679304272243, -84.9016, -1.48181246021122),
(13727, '31725', 218, 13, 19502, 30.9452, 0.540095627688149, -84.6778, -1.47790641334525),
(13728, '31726', 218, 13, 19526, 31.8294, 0.555527828934283, -84.3622, -1.47239815422596),
(13729, '31727', 218, 13, 13444, 31.4414, 0.548755951436545, -83.5033, -1.45740752128058),
(13730, '31728', 218, 13, 1288, 30.8768, 0.538901822479785, -84.2089, -1.46972256448265),
(13731, '31729', 218, 13, 1299, 30.7485, 0.536662565049476, -84.3117, -1.4715167629537),
(13732, '31730', 218, 13, 706, 31.2303, 0.545071561385585, -84.2081, -1.46970860184864),
(13733, '31732', 218, 13, 1429, 31.1862, 0.544301871185456, -85.0039, -1.48359793203601),
(13734, '31733', 218, 13, 8079, 31.5481, 0.550618217748423, -83.5556, -1.45832032847937),
(13735, '31734', 218, 13, 20102, 30.876, 0.538887859845769, -84.4445, -1.47383456020035),
(13736, '31735', 218, 13, 20127, 31.9638, 0.557873551448963, -83.9685, -1.46552679296086),
(13737, '31736', 218, 13, 1693, 31.6562, 0.552504918669829, -84.8787, -1.48141277981251),
(13738, '31737', 218, 13, 20190, 31.173, 0.544071487724192, -84.7309, -1.47883318317806),
(13739, '31738', 218, 13, 20230, 31.0325, 0.54161930012514, -83.8601, -1.4636348560517),
(13740, '31739', 218, 13, 1793, 31.1234, 0.543205804415203, -84.1555, -1.46879055866209),
(13741, '31740', 218, 13, 20430, 31.7694, 0.554480631383087, -84.7939, -1.47993274060682),
(13742, '31741', 218, 13, 1957, 31.3467, 0.547103124634907, -84.7309, -1.47883318317806),
(13743, '31742', 218, 13, 1989, 31.7669, 0.554436998151787, -84.4321, -1.4736181393731),
(13744, '31743', 218, 13, 26922, 31.9738, 0.558048084374163, -84.0281, -1.46656700919505),
(13745, '31744', 218, 13, 20611, 31.3176, 0.546595233822576, -83.9169, -1.46462620306683),
(13746, '31745', 218, 13, 20624, 31.04, 0.54175019981904, -84.88, -1.48143546909279),
(13747, '31746', 218, 13, 15893, 31.5603, 0.550831147917166, -84.7395, -1.47898328149373),
(13748, '31747', 218, 13, 15921, 31.1852, 0.544284417892936, -83.7469, -1.46165914333844),
(13749, '31749', 218, 13, 20909, 31.366, 0.547439973180541, -83.3472, -1.45468306231822),
(13750, '31750', 218, 13, 8893, 31.7155, 0.553539898916262, -83.2566, -1.45310179401591),
(13751, '31751', 218, 13, 2557, 31.6053, 0.551616546080564, -85.0462, -1.4843362063096),
(13752, '31752', 218, 13, 21262, 30.8759, 0.538886114516517, -84.585, -1.4762867477994),
(13753, '31753', 218, 13, 9023, 31.2134, 0.544776600741998, -83.9711, -1.46557217152141),
(13754, '31754', 218, 13, 2693, 31.8654, 0.556156147465001, -85.1027, -1.48532231733698),
(13755, '31756', 218, 13, 21770, 31.2144, 0.544794054034518, -83.9714, -1.46557740750917),
(13756, '31757', 218, 13, 6316, 30.8682, 0.538751724164114, -83.909, -1.46448832205592),
(13757, '31758', 218, 13, 6316, 30.8394, 0.538249069339539, -83.9784, -1.46569958055681),
(13758, '31759', 218, 13, 3362, 30.982, 0.540737908852883, -84.7865, -1.47980358624217),
(13759, '31760', 218, 13, 22184, 31.6559, 0.552499682682073, -83.4103, -1.45578436507623),
(13760, '31761', 218, 13, 22216, 31.1862, 0.544301871185456, -85.0037, -1.4835944413775),
(13761, '31762', 218, 13, 22603, 31.5233, 0.550185376093928, -84.506, -1.47490793769033),
(13762, '31763', 218, 13, 3721, 31.679, 0.552902853739284, -84.1497, -1.46868932956547),
(13763, '31764', 218, 13, 10047, 31.9535, 0.557693782536008, -84.0834, -1.4675321762714),
(13764, '31765', 218, 13, 23032, 31.1291, 0.543305288182567, -84.1389, -1.46850083400626),
(13765, '31766', 218, 13, 4319, 31.5331, 0.550356418360624, -84.6268, -1.47701629542674),
(13766, '31767', 218, 13, 4333, 31.8152, 0.5552799921805, -85.0373, -1.48418087200617),
(13767, '31768', 218, 13, 17197, 31.1695, 0.544010401200373, -83.7849, -1.4623223684542),
(13768, '31769', 218, 13, 23299, 31.5624, 0.550867799831458, -83.2697, -1.45333043214792),
(13769, '31770', 218, 13, 4570, 31.3224, 0.546679009626672, -84.4563, -1.47404050905209),
(13770, '31771', 218, 13, 23397, 31.2383, 0.545211187725745, -83.7128, -1.46106398606351),
(13771, '31772', 218, 13, 23561, 31.7838, 0.554731958795374, -83.9655, -1.4654744330833),
(13772, '31773', 218, 13, 23593, 30.8537, 0.538498651422574, -84.2028, -1.46961609939828),
(13773, '31774', 218, 13, 23594, 31.595, 0.551436777167608, -83.2545, -1.45306514210162),
(13774, '31775', 218, 13, 4787, 31.3825, 0.54772795250712, -83.5832, -1.45880203935292),
(13775, '31776', 218, 13, 17197, 31.1558, 0.543771291092849, -83.7929, -1.46246199479436),
(13776, '31777', 218, 13, 23776, 31.894, 0.556655311631071, -84.5067, -1.47492015499509),
(13777, '31778', 218, 13, 23788, 30.959, 0.540336483124924, -83.7378, -1.46150031837651),
(13778, '31779', 218, 13, 4936, 31.1269, 0.543266890939023, -84.1534, -1.4687539067478),
(13779, '31780', 218, 13, 17647, 32.0316, 0.559056884681816, -84.3938, -1.47294967826959),
(13780, '31781', 218, 13, 24102, 31.5117, 0.549982917900697, -83.7906, -1.46242185222156),
(13781, '31782', 218, 13, 24157, 31.4641, 0.549152141176748, -83.9822, -1.46576590306838),
(13782, '31783', 218, 13, 24229, 31.7872, 0.554791299989941, -83.5312, -1.45789446814189),
(13783, '31784', 218, 13, 24632, 31.2537, 0.545479968430552, -84.0432, -1.4668305539121),
(13784, '31785', 218, 13, 24683, 31.7156, 0.553541644245514, -84.3478, -1.47214682681367),
(13785, '31786', 218, 13, 24805, 31.7604, 0.554323551750407, -84.6097, -1.47671784412465),
(13786, '31787', 218, 13, 12002, 31.9045, 0.556838571202531, -84.2497, -1.47043465881747),
(13787, '31788', 218, 13, 17197, 31.1695, 0.544010401200373, -83.7854, -1.46233109510046),
(13788, '31789', 218, 13, 18216, 31.5442, 0.550550149907595, -83.7161, -1.46112158192882),
(13789, '31790', 218, 13, 6199, 31.6518, 0.552428124182741, -83.5913, -1.45894341102234),
(13790, '31791', 218, 13, 25305, 31.5327, 0.550349437043616, -83.8452, -1.46337480199315),
(13791, '31792', 218, 13, 6316, 30.8365, 0.538198454791231, -83.972, -1.46558787948468),
(13792, '31793', 218, 13, 25489, 31.4652, 0.54917133979852, -83.5028, -1.45739879463432),
(13793, '31794', 218, 13, 25489, 31.4579, 0.549043930763124, -83.5115, -1.45755063827924),
(13794, '31795', 218, 13, 25626, 31.4681, 0.549221954346828, -83.5394, -1.45803758514055),
(13795, '31796', 218, 13, 14798, 31.8323, 0.555578443482591, -83.9228, -1.4647291774927),
(13796, '31797', 218, 13, 25991, 30.9391, 0.539989162603778, -84.3178, -1.47162322803808),
(13797, '31798', 218, 13, 26266, 31.5951, 0.55143852249686, -83.1105, -1.45055186797875),
(13798, '31799', 218, 13, 6316, 30.8363, 0.538194964132727, -83.9793, -1.46571528852007),
(13799, '31801', 218, 13, 7630, 32.5466, 0.568045330329586, -84.688, -1.47808443692896),
(13800, '31803', 218, 13, 1223, 32.315, 0.564003147781968, -84.5135, -1.47503883738423),
(13801, '31804', 218, 13, 19849, 32.6403, 0.569680703838705, -84.9013, -1.48180722422346),
(13802, '31805', 218, 13, 1937, 32.2885, 0.563540635530189, -84.7836, -1.47975297169386),
(13803, '31806', 218, 13, 2263, 32.2992, 0.563727385760152, -84.0646, -1.46720405437203),
(13804, '31807', 218, 13, 15923, 32.633, 0.56955329480331, -84.7942, -1.47993797659458),
(13805, '31808', 218, 13, 21242, 32.5947, 0.568884833699796, -84.9694, -1.48299579344407),
(13806, '31810', 218, 13, 2687, 32.585, 0.568715536762352, -84.6181, -1.47686445178181),
(13807, '31811', 218, 13, 2950, 32.7256, 0.571169469690656, -84.9942, -1.48342863509856),
(13808, '31812', 218, 13, 9806, 32.6034, 0.569036677344719, -84.4576, -1.47406319833236),
(13809, '31814', 218, 13, 22752, 32.1455, 0.561044814699837, -84.9046, -1.48186482008878),
(13810, '31815', 218, 13, 22779, 32.0517, 0.559407695861466, -84.7922, -1.47990307000954),
(13811, '31816', 218, 13, 585, 32.8559, 0.573443633706005, -84.6183, -1.47686794244032),
(13812, '31820', 218, 13, 10461, 32.5577, 0.568239061876558, -84.8427, -1.48078446128179),
(13813, '31821', 218, 13, 4786, 32.1461, 0.561055286675349, -84.9043, -1.48185958410102),
(13814, '31822', 218, 13, 5053, 32.8986, 0.574188889296607, -84.9237, -1.48219817797591),
(13815, '31823', 218, 13, 23922, 32.7847, 0.572200959278585, -84.8205, -1.48039699818785),
(13816, '31824', 218, 13, 5220, 32.0834, 0.559960965234349, -84.5444, -1.47557814412309),
(13817, '31825', 218, 13, 5374, 32.0893, 0.560063939660216, -84.6606, -1.47760621671391),
(13818, '31826', 218, 13, 5817, 32.7982, 0.572436578727604, -84.7452, -1.4790827652611),
(13819, '31827', 218, 13, 25312, 32.7009, 0.570738373365414, -84.4876, -1.47458679710796),
(13820, '31829', 218, 13, 25666, 32.5573, 0.56823208055955, -84.7363, -1.47892743095767),
(13821, '31830', 218, 13, 6631, 32.8846, 0.573944543201327, -84.6874, -1.47807396495345),
(13822, '31831', 218, 13, 25863, 32.691, 0.570565585769466, -84.7399, -1.47899026281074),
(13823, '31832', 218, 13, 6746, 31.9614, 0.557831663546916, -84.5674, -1.47597956985105),
(13824, '31833', 218, 13, 6722, 32.89, 0.574038790980935, -85.1397, -1.48596808916022),
(13825, '31836', 218, 13, 6917, 32.7932, 0.572349312265004, -84.5725, -1.4760685816429),
(13826, '31900', 218, 13, 1718, 32.4605, 0.566542601843619, -84.9879, -1.48331867935569),
(13827, '31901', 218, 13, 1718, 32.4726, 0.566753786683111, -84.979, -1.48316334505226),
(13828, '31902', 218, 13, 1718, 32.4981, 0.567198845642369, -84.9735, -1.4830673519434),
(13829, '31903', 218, 13, 1718, 32.4249, 0.565921264629909, -84.9457, -1.48258215041135),
(13830, '31904', 218, 13, 1718, 32.517, 0.567528712870996, -84.9796, -1.48317381702777),
(13831, '31905', 218, 13, 21228, 32.3589, 0.564769347323593, -84.959, -1.48281427920186),
(13832, '31906', 218, 13, 1718, 32.4684, 0.566680482854527, -84.9495, -1.48264847292292),
(13833, '31907', 218, 13, 1718, 32.4783, 0.566853270450474, -84.9036, -1.48184736679626),
(13834, '31908', 218, 13, 1718, 32.5325, 0.567799238905055, -84.9368, -1.48242681610792),
(13835, '31909', 218, 13, 1718, 32.5359, 0.567858580099623, -84.9238, -1.48219992330516),
(13836, '31914', 218, 13, 1718, 32.558, 0.568244297864314, -85.005, -1.48361713065778),
(13837, '31917', 218, 13, 1718, 32.4823, 0.566923083620554, -84.8302, -1.48056629512529),
(13838, '31993', 218, 13, 1718, 32.4815, 0.566909120986538, -84.9786, -1.48315636373525),
(13839, '31994', 218, 13, 1718, 32.4812, 0.566903884998782, -84.9829, -1.48323141289309),
(13840, '31995', 218, 13, 21228, 32.4879, 0.567020822058666, -84.9698, -1.48300277476108);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(13841, '31997', 218, 13, 1718, 32.4816, 0.56691086631579, -84.8302, -1.48056629512529),
(13842, '31998', 218, 13, 1718, 32.468, 0.566673501537519, -84.9492, -1.48264323693517),
(13843, '31999', 218, 13, 1718, 32.4609, 0.566549583160627, -84.9873, -1.48330820738018),
(13844, '32003', 218, 12, 17435, 30.1075, 0.525475004544193, -81.7136, -1.42617136365764),
(13845, '32004', 218, 12, 17698, 30.2394, 0.527777093827573, -81.3855, -1.42044493838184),
(13846, '32006', 218, 12, 0, 30.1578, 0.526352905157946, -81.7037, -1.42599857606169),
(13847, '32007', 218, 12, 15290, 29.7738, 0.519650840830288, -81.6367, -1.42482920546285),
(13848, '32008', 218, 12, 15309, 30.0494, 0.524460968248784, -82.9577, -1.4478850048817),
(13849, '32009', 218, 12, 15360, 30.3206, 0.529194301180193, -81.8955, -1.42934611756702),
(13850, '32011', 218, 12, 15400, 30.5574, 0.533327240848915, -81.8333, -1.42826052277228),
(13851, '32013', 218, 12, 8418, 30.1888, 0.526893957226064, -83.2903, -1.45368996997383),
(13852, '32024', 218, 12, 9930, 30.1894, 0.526904429201576, -82.6392, -1.4423261312141),
(13853, '32025', 218, 12, 9930, 30.1865, 0.526853814653268, -82.6365, -1.44227900732429),
(13854, '32026', 218, 12, 17751, 30.064, 0.524715786319575, -82.2368, -1.43530292630407),
(13855, '32030', 218, 12, 15797, 30.1053, 0.525436607300649, -81.7782, -1.42729884635443),
(13856, '32033', 218, 12, 15918, 29.7793, 0.519746833939147, -81.4365, -1.42133505630036),
(13857, '32034', 218, 12, 16008, 30.6375, 0.534725249579763, -81.4607, -1.42175742597934),
(13858, '32035', 218, 12, 16008, 30.6711, 0.535311680208433, -81.4627, -1.42179233256438),
(13859, '32038', 218, 12, 16105, 30.0237, 0.524012418631022, -82.3403, -1.43710934207989),
(13860, '32040', 218, 12, 16218, 30.2902, 0.528663721087586, -82.1623, -1.43400265601134),
(13861, '32041', 218, 12, 18696, 30.6324, 0.534636237787911, -81.5736, -1.42372790270485),
(13862, '32042', 218, 12, 2802, 29.968, 0.523040270237661, -82.1236, -1.43332721359082),
(13863, '32043', 218, 12, 16272, 30.0142, 0.523846612352082, -81.726, -1.42638778448489),
(13864, '32044', 218, 12, 2957, 29.8484, 0.520952856452276, -82.1462, -1.43372165800177),
(13865, '32046', 218, 12, 3140, 30.6873, 0.535594423547256, -81.925, -1.42986098969635),
(13866, '32050', 218, 12, 17130, 30.0722, 0.524858903318239, -81.8633, -1.42878412154787),
(13867, '32052', 218, 12, 738, 30.5193, 0.532662270403905, -82.9509, -1.44776632249256),
(13868, '32053', 218, 12, 16612, 30.5649, 0.533458140542815, -83.2461, -1.45291853444445),
(13869, '32054', 218, 12, 16770, 30.0205, 0.523956568094958, -82.3402, -1.43710759675063),
(13870, '32055', 218, 12, 9930, 30.1871, 0.52686428662878, -82.6338, -1.44223188343449),
(13871, '32056', 218, 12, 9930, 30.1903, 0.526920137164844, -82.6382, -1.44230867792158),
(13872, '32058', 218, 12, 16861, 30.0812, 0.525015982950918, -82.1076, -1.4330479609105),
(13873, '32059', 218, 12, 3715, 30.3675, 0.530012860599378, -83.2652, -1.45325189233158),
(13874, '32060', 218, 12, 3822, 30.2535, 0.528023185252104, -83.0395, -1.44931268420983),
(13875, '32061', 218, 12, 16964, 30.0679, 0.524783854160403, -82.5526, -1.44081467608187),
(13876, '32062', 218, 12, 17061, 30.2949, 0.52874575156243, -82.9905, -1.44845747287635),
(13877, '32063', 218, 12, 16979, 30.2827, 0.528532821393687, -82.1266, -1.43337957346838),
(13878, '32064', 218, 12, 3822, 30.2944, 0.52873702491617, -82.9857, -1.44837369707226),
(13879, '32065', 218, 12, 17435, 30.1359, 0.525970678051759, -81.7753, -1.42724823180612),
(13880, '32066', 218, 12, 17056, 30.054, 0.524541253394376, -83.1757, -1.45168982265105),
(13881, '32067', 218, 12, 17435, 30.0343, 0.524197423531733, -81.7889, -1.42748559658439),
(13882, '32068', 218, 12, 17130, 30.0759, 0.524923480500563, -81.8767, -1.42901799566764),
(13883, '32071', 218, 12, 17333, 30.0362, 0.524230584787521, -82.9292, -1.44738758604488),
(13884, '32072', 218, 12, 4785, 30.2054, 0.527183681881895, -82.4312, -1.43869584636995),
(13885, '32073', 218, 12, 17435, 30.1526, 0.526262148036842, -81.7351, -1.42654660944682),
(13886, '32079', 218, 12, 17571, 29.9823, 0.523289852320696, -81.807, -1.427801501179),
(13887, '32080', 218, 12, 17892, 29.8326, 0.52067709443046, -81.2737, -1.41849366027812),
(13888, '32082', 218, 12, 17698, 30.2114, 0.527288401637015, -81.3865, -1.42046239167437),
(13889, '32083', 218, 12, 17751, 30.0921, 0.525206223839386, -82.1958, -1.43458734131076),
(13890, '32084', 218, 12, 17892, 29.8852, 0.521595137617009, -81.3116, -1.41915514006462),
(13891, '32085', 218, 12, 17892, 29.8859, 0.521607354921773, -81.3417, -1.41968048416947),
(13892, '32086', 218, 12, 17892, 29.8289, 0.520612517248137, -81.3214, -1.41932618233132),
(13893, '32087', 218, 12, 17964, 30.2065, 0.527202880503667, -82.4309, -1.43869061038219),
(13894, '32091', 218, 12, 18187, 29.9492, 0.522712148338286, -82.1092, -1.43307588617853),
(13895, '32092', 218, 12, 17892, 29.9548, 0.522809886776397, -81.527, -1.42291457927342),
(13896, '32094', 218, 12, 6685, 30.181, 0.526757821544409, -82.8584, -1.44615189293447),
(13897, '32095', 218, 12, 17892, 29.9173, 0.5221553883069, -81.3389, -1.41963161495042),
(13898, '32096', 218, 12, 18595, 30.335, 0.52944562859248, -82.758, -1.44439958236547),
(13899, '32097', 218, 12, 18696, 30.6147, 0.534327314510308, -81.5868, -1.42395828616611),
(13900, '32099', 218, 12, 3395, 30.34, 0.52953289505508, -81.8305, -1.42821165355322),
(13901, '32102', 218, 12, 15042, 29.1568, 0.508882159345483, -81.5464, -1.4232531731483),
(13902, '32105', 218, 12, 15095, 29.1871, 0.509410994108837, -81.4217, -1.42107674757107),
(13903, '32110', 218, 12, 15381, 29.4641, 0.514245556136861, -81.2447, -1.41798751479504),
(13904, '32111', 218, 12, 15419, 29.1651, 0.509027021673398, -82.2185, -1.43498353105096),
(13905, '32112', 218, 12, 15666, 29.4328, 0.513699268080987, -81.5115, -1.42264405323936),
(13906, '32113', 218, 12, 15532, 29.3861, 0.512884199320306, -82.123, -1.4333167416153),
(13907, '32114', 218, 12, 15743, 29.2001, 0.509637886911596, -81.0442, -1.41448812964479),
(13908, '32115', 218, 12, 15743, 29.2108, 0.50982463714156, -81.0227, -1.41411288385561),
(13909, '32116', 218, 12, 15743, 29.2161, 0.509917139591915, -81.0057, -1.41381617788277),
(13910, '32117', 218, 12, 15743, 29.2352, 0.510250497479046, -81.0488, -1.41456841479038),
(13911, '32118', 218, 12, 15743, 29.2079, 0.509774022593252, -81.0006, -1.41372716609092),
(13912, '32119', 218, 12, 15743, 29.1408, 0.508602906665164, -81.0125, -1.41393486027191),
(13913, '32120', 218, 12, 15743, 29.196, 0.509566328412264, -81.0492, -1.41457539610739),
(13914, '32121', 218, 12, 15743, 29.1937, 0.509526185839469, -81.054, -1.41465917191148),
(13915, '32122', 218, 12, 15743, 29.1483, 0.508733806359063, -81.0306, -1.41425076486652),
(13916, '32123', 218, 12, 17711, 29.1491, 0.508747768993079, -81.0302, -1.41424378354951),
(13917, '32124', 218, 12, 15743, 29.1293, 0.508402193801184, -81.1215, -1.41583726915658),
(13918, '32125', 218, 12, 15743, 29.235, 0.510247006820542, -81.0583, -1.41473422106932),
(13919, '32126', 218, 12, 15743, 29.2282, 0.510128324431407, -81.0059, -1.41381966854127),
(13920, '32127', 218, 12, 17711, 29.1075, 0.50802171202425, -80.9797, -1.41336239227725),
(13921, '32128', 218, 12, 17711, 29.1292, 0.508400448471932, -81.1215, -1.41583726915658),
(13922, '32129', 218, 12, 17711, 29.1495, 0.508754750310087, -81.0256, -1.41416349840392),
(13923, '32130', 218, 12, 15750, 29.1267, 0.508356815240632, -81.3275, -1.41943264741569),
(13924, '32131', 218, 12, 15862, 29.6639, 0.517732723982346, -81.5629, -1.42354115247488),
(13925, '32132', 218, 12, 2228, 28.9749, 0.505707405436105, -80.9098, -1.41214240713011),
(13926, '32133', 218, 12, 15870, 29.0196, 0.506487567611747, -81.9082, -1.42956777438202),
(13927, '32134', 218, 12, 16088, 29.3676, 0.512561313408687, -81.8855, -1.42917158464182),
(13928, '32135', 218, 12, 17493, 29.5458, 0.515671490135741, -81.2267, -1.41767335552968),
(13929, '32136', 218, 12, 16024, 29.4482, 0.513968048785794, -81.1211, -1.41583028783957),
(13930, '32137', 218, 12, 17493, 29.5382, 0.515538845112589, -81.2278, -1.41769255415145),
(13931, '32138', 218, 12, 16264, 29.7272, 0.518837517398858, -81.9187, -1.42975103395348),
(13932, '32139', 218, 12, 2693, 29.4186, 0.513451431327204, -81.5809, -1.42385531174024),
(13933, '32140', 218, 12, 16035, 29.7607, 0.519422202698276, -81.8827, -1.42912271542276),
(13934, '32141', 218, 12, 2228, 28.9436, 0.505161117380231, -80.8955, -1.41189282504707),
(13935, '32142', 218, 12, 17493, 29.4789, 0.514503864866156, -81.2142, -1.41745518937318),
(13936, '32145', 218, 12, 16375, 29.6737, 0.517903766249041, -81.4655, -1.42184120178344),
(13937, '32147', 218, 12, 16470, 29.6223, 0.517006667013516, -81.8137, -1.42791843823888),
(13938, '32148', 218, 12, 16552, 29.6409, 0.517331298254387, -81.9043, -1.42949970654119),
(13939, '32149', 218, 12, 15886, 29.6169, 0.516912419233909, -81.8978, -1.42938626013981),
(13940, '32151', 218, 12, 16024, 29.4705, 0.514357257208989, -81.1299, -1.41598387681375),
(13941, '32157', 218, 12, 16776, 29.4763, 0.514458486305605, -81.5751, -1.42375408264363),
(13942, '32158', 218, 12, 16759, 28.9282, 0.504892336675424, -81.9292, -1.42993429352494),
(13943, '32159', 218, 12, 16759, 28.9279, 0.504887100687668, -81.9225, -1.42981735646505),
(13944, '32160', 218, 12, 16785, 29.7722, 0.519622915562256, -82.0106, -1.43135499153606),
(13945, '32162', 218, 12, 16759, 28.9159, 0.504677661177428, -81.923, -1.42982608311131),
(13946, '32164', 218, 12, 17493, 29.5335, 0.515456814637745, -81.2274, -1.41768557283444),
(13947, '32168', 218, 12, 17266, 29.0003, 0.506150719066112, -81.016, -1.41399594679573),
(13948, '32169', 218, 12, 17266, 29.0012, 0.50616642702938, -80.8788, -1.41160135506199),
(13949, '32170', 218, 12, 17266, 29.0338, 0.50673540436553, -80.9185, -1.41229425077503),
(13950, '32173', 218, 12, 17446, 29.2947, 0.511288968383983, -81.0949, -1.41537301157555),
(13951, '32174', 218, 12, 17446, 29.2872, 0.511158068690083, -81.1237, -1.41587566640012),
(13952, '32175', 218, 12, 17446, 29.285, 0.511119671446539, -81.0566, -1.41470455047204),
(13953, '32176', 218, 12, 17446, 29.3264, 0.511842237756865, -81.0562, -1.41469756915503),
(13954, '32177', 218, 12, 11052, 29.6418, 0.517347006217655, -81.6609, -1.42525157514184),
(13955, '32178', 218, 12, 11052, 29.6483, 0.517460452619035, -81.6374, -1.42484142276762),
(13956, '32179', 218, 12, 17383, 29.0767, 0.507484150614635, -81.9044, -1.42950145187044),
(13957, '32180', 218, 12, 17596, 29.2244, 0.510062001919831, -81.4674, -1.42187436303923),
(13958, '32181', 218, 12, 17689, 29.4708, 0.514362493196745, -81.6164, -1.4244749036247),
(13959, '32182', 218, 12, 23662, 29.48, 0.514523063487928, -81.941, -1.43014024237667),
(13960, '32183', 218, 12, 17383, 29.0423, 0.506883757351949, -81.9303, -1.42995349214671),
(13961, '32185', 218, 12, 17741, 29.7278, 0.51884798937437, -81.9609, -1.43048756289782),
(13962, '32187', 218, 12, 17947, 29.5716, 0.516121785082755, -81.5614, -1.4235149725361),
(13963, '32189', 218, 12, 5671, 29.5657, 0.516018810656887, -81.6357, -1.42481175217034),
(13964, '32190', 218, 12, 18040, 29.3423, 0.512119745107932, -81.5083, -1.42258820270329),
(13965, '32192', 218, 12, 18167, 29.3404, 0.512086583852144, -82.0939, -1.43280885080297),
(13966, '32193', 218, 12, 18530, 29.4808, 0.514537026121944, -81.6719, -1.42544356135956),
(13967, '32195', 218, 12, 18527, 28.9808, 0.505810379861973, -81.9141, -1.42967074880789),
(13968, '32198', 218, 12, 15743, 29.1959, 0.509564583083012, -81.0496, -1.4145823774244),
(13969, '32201', 218, 12, 3395, 30.2739, 0.528379232419511, -81.7632, -1.42703704696663),
(13970, '32202', 218, 12, 3395, 30.3282, 0.529326946203344, -81.6523, -1.42510147682617),
(13971, '32203', 218, 12, 3395, 30.3388, 0.529511951104056, -81.6713, -1.42543308938405),
(13972, '32204', 218, 12, 3395, 30.3245, 0.52926236902102, -81.6804, -1.42559191434598),
(13973, '32205', 218, 12, 3395, 30.3194, 0.529173357229169, -81.7311, -1.42647679627674),
(13974, '32206', 218, 12, 3395, 30.3518, 0.529738843906815, -81.6461, -1.42499326641254),
(13975, '32207', 218, 12, 3395, 30.2928, 0.528709099648138, -81.631, -1.42472972169549),
(13976, '32208', 218, 12, 3395, 30.3913, 0.530428248961353, -81.6839, -1.4256530008698),
(13977, '32209', 218, 12, 3395, 30.3569, 0.529827855698667, -81.6956, -1.42585720439228),
(13978, '32210', 218, 12, 3395, 30.2628, 0.52818550087254, -81.7482, -1.42677524757883),
(13979, '32211', 218, 12, 3395, 30.3457, 0.529632378822443, -81.5818, -1.42387101970351),
(13980, '32212', 218, 12, 3395, 30.2105, 0.527272693673747, -81.6873, -1.42571234206436),
(13981, '32214', 218, 12, 3395, 30.2191, 0.527422791989418, -81.6873, -1.42571234206436),
(13982, '32215', 218, 12, 3395, 30.2382, 0.527756149876549, -81.8745, -1.4289795984241),
(13983, '32216', 218, 12, 3395, 30.2147, 0.527345997502331, -81.585, -1.42392687023957),
(13984, '32217', 218, 12, 3395, 30.2379, 0.527750913888793, -81.6157, -1.42446268631994),
(13985, '32218', 218, 12, 3395, 30.4792, 0.531962393373856, -81.6986, -1.42590956426984),
(13986, '32219', 218, 12, 3395, 30.4105, 0.530763352177736, -81.8095, -1.4278451344103),
(13987, '32220', 218, 12, 3395, 30.3314, 0.529382796739408, -81.8134, -1.42791320225113),
(13988, '32221', 218, 12, 3395, 30.2927, 0.528707354318886, -81.8142, -1.42792716488514),
(13989, '32222', 218, 12, 3395, 30.2259, 0.527541474378554, -81.8161, -1.42796032614093),
(13990, '32223', 218, 12, 3395, 30.1575, 0.52634766917019, -81.6249, -1.42462325661112),
(13991, '32224', 218, 12, 3395, 30.2854, 0.528579945283491, -81.465, -1.42183247513718),
(13992, '32225', 218, 12, 3395, 30.3508, 0.529721390614295, -81.5029, -1.42249395492369),
(13993, '32226', 218, 12, 3395, 30.4691, 0.531786115119404, -81.5481, -1.42328284374559),
(13994, '32227', 218, 12, 3395, 30.3824, 0.530272914657925, -81.4135, -1.4209336305724),
(13995, '32228', 218, 12, 3395, 30.3883, 0.530375889083793, -81.4329, -1.42127222444729),
(13996, '32229', 218, 12, 3395, 30.4107, 0.53076684283624, -81.5785, -1.42381342383819),
(13997, '32230', 218, 12, 3395, 30.2909, 0.52867593839235, -81.4011, -1.42071720974516),
(13998, '32231', 218, 12, 3395, 30.2918, 0.528691646355618, -81.6343, -1.42478731756081),
(13999, '32232', 218, 12, 3395, 30.2919, 0.52869339168487, -81.6345, -1.42479080821931),
(14000, '32233', 218, 12, 15047, 30.3373, 0.529485771165276, -81.4158, -1.4209737731452),
(14001, '32234', 218, 12, 3395, 30.218, 0.527403593367647, -81.9965, -1.43110890011153),
(14002, '32235', 218, 12, 3395, 30.2926, 0.528705608989634, -81.6353, -1.42480477085333),
(14003, '32236', 218, 12, 3395, 30.3058, 0.528935992450898, -81.7293, -1.4264453803502),
(14004, '32237', 218, 12, 3395, 30.2402, 0.527791056461589, -81.6188, -1.42451679152675),
(14005, '32238', 218, 12, 3395, 30.219, 0.527421046660166, -81.7611, -1.42700039505234),
(14006, '32239', 218, 12, 3395, 30.3332, 0.529414212665944, -81.5806, -1.42385007575249),
(14007, '32240', 218, 12, 16591, 30.279, 0.528468244211363, -81.4116, -1.42090046931662),
(14008, '32241', 218, 12, 3395, 30.1716, 0.526593760594721, -81.6284, -1.42468434313494),
(14009, '32244', 218, 12, 3395, 30.2252, 0.52752925707379, -81.7574, -1.42693581787001),
(14010, '32245', 218, 12, 3395, 30.2487, 0.527939409448009, -81.5527, -1.42336312889118),
(14011, '32246', 218, 12, 3395, 30.3035, 0.528895849878102, -81.5124, -1.42265976120263),
(14012, '32247', 218, 12, 3395, 30.2992, 0.528820800720266, -81.6348, -1.42479604420707),
(14013, '32250', 218, 12, 16591, 30.2855, 0.528581690612743, -81.4084, -1.42084461878055),
(14014, '32254', 218, 12, 3395, 30.337, 0.52948053517752, -81.7316, -1.426485522923),
(14015, '32255', 218, 12, 3395, 30.2837, 0.528550274686207, -81.5465, -1.42325491847756),
(14016, '32256', 218, 12, 3395, 30.205, 0.527176700564887, -81.544, -1.42321128524626),
(14017, '32257', 218, 12, 3395, 30.1917, 0.526944571774372, -81.6039, -1.4242567374682),
(14018, '32258', 218, 12, 3395, 30.1482, 0.526185353549754, -81.5803, -1.42384483976473),
(14019, '32259', 218, 12, 3395, 30.0907, 0.525181789229858, -81.6259, -1.42464070990364),
(14020, '32260', 218, 12, 3395, 30.0771, 0.524944424451587, -81.5804, -1.42384658509398),
(14021, '32266', 218, 12, 17252, 30.3144, 0.529086090766569, -81.4066, -1.42081320285402),
(14022, '32267', 218, 12, 3395, 30.3802, 0.530234517414381, -81.4139, -1.42094061188941),
(14023, '32276', 218, 12, 3395, 30.328, 0.52932345554484, -81.6475, -1.42501770102207),
(14024, '32277', 218, 12, 3395, 30.3619, 0.529915122161266, -81.5814, -1.4238640383865),
(14025, '32290', 218, 12, 3395, 30.3317, 0.529388032727164, -81.6556, -1.42515907269148),
(14026, '32301', 218, 12, 18274, 30.4297, 0.531098455394118, -84.217, -1.46986393615206),
(14027, '32302', 218, 12, 18274, 30.4434, 0.531337565501642, -84.2837, -1.47102807076314),
(14028, '32303', 218, 12, 18274, 30.4837, 0.532040933190195, -84.3243, -1.47173667443945),
(14029, '32304', 218, 12, 18274, 30.4274, 0.531058312821323, -84.3214, -1.47168605989115),
(14030, '32305', 218, 12, 18274, 30.1967, 0.527031838236972, -84.267, -1.47073660077806),
(14031, '32306', 218, 12, 18274, 30.443, 0.531330584184634, -84.3008, -1.47132652206524),
(14032, '32307', 218, 12, 18274, 30.429, 0.531086238089355, -84.288, -1.47110311992098),
(14033, '32308', 218, 12, 18274, 30.5024, 0.532367309760318, -84.2122, -1.46978016034797),
(14034, '32309', 218, 12, 18274, 30.5964, 0.534007919257193, -84.041, -1.46679215666855),
(14035, '32310', 218, 12, 18274, 30.4004, 0.530587073923284, -84.3232, -1.47171747581768),
(14036, '32311', 218, 12, 18274, 30.4224, 0.530971046358723, -84.1738, -1.4691099539152),
(14037, '32312', 218, 12, 18274, 30.5285, 0.532822840695089, -84.2619, -1.47064758898621),
(14038, '32313', 218, 12, 18274, 30.441, 0.531295677599594, -84.2905, -1.47114675315228),
(14039, '32314', 218, 12, 18274, 30.4398, 0.53127473364857, -84.3343, -1.47191120736465),
(14040, '32315', 218, 12, 18274, 30.4649, 0.53171281129082, -84.2854, -1.47105774136043),
(14041, '32316', 218, 12, 18274, 30.4476, 0.531410869330226, -84.3275, -1.47179252497552),
(14042, '32317', 218, 12, 18274, 30.568, 0.533512245749627, -84.1142, -1.46806973768101),
(14043, '32318', 218, 12, 18274, 30.4379, 0.531241572392782, -84.2806, -1.47097396555633),
(14044, '32320', 218, 12, 15013, 29.7237, 0.518776430875039, -84.9988, -1.48350892024416),
(14045, '32321', 218, 12, 15330, 30.4198, 0.530925667798171, -84.9786, -1.48315636373525),
(14046, '32322', 218, 12, 15442, 29.9404, 0.52255855936411, -84.6317, -1.47710181656008),
(14047, '32323', 218, 12, 16840, 29.8802, 0.52150787115441, -84.5963, -1.47648397000488),
(14048, '32324', 218, 12, 15508, 30.6928, 0.535690416656116, -84.8409, -1.48075304535526),
(14049, '32326', 218, 12, 15662, 30.176, 0.526670555081809, -84.375, -1.47262155637022),
(14050, '32327', 218, 12, 15662, 30.1969, 0.527035328895476, -84.2672, -1.47074009143657),
(14051, '32328', 218, 12, 15871, 29.7083, 0.518507650170231, -84.8514, -1.48093630492672),
(14052, '32329', 218, 12, 15013, 29.7269, 0.518832281411102, -84.9943, -1.48343038042782),
(14053, '32330', 218, 12, 2866, 30.5702, 0.533550642993171, -84.7431, -1.47904611334681),
(14054, '32331', 218, 12, 2868, 30.4662, 0.531735500571096, -83.6333, -1.45967644930817),
(14055, '32332', 218, 12, 16287, 30.6146, 0.534325569181056, -84.6618, -1.47762716066494),
(14056, '32333', 218, 12, 3010, 30.6209, 0.534435524923932, -84.4193, -1.47339473722885),
(14057, '32334', 218, 12, 16497, 30.2129, 0.527314581575795, -84.8048, -1.48012298149529),
(14058, '32335', 218, 12, 18211, 30.02, 0.523947841448698, -84.9791, -1.48316509038151),
(14059, '32336', 218, 12, 9971, 30.3016, 0.528862688622314, -83.9378, -1.4649909768805),
(14060, '32337', 218, 12, 10141, 30.477, 0.531923996130312, -84.0224, -1.46646752542768),
(14061, '32340', 218, 12, 3938, 30.4657, 0.531726773924836, -83.4129, -1.45582974363678),
(14062, '32341', 218, 12, 3938, 30.4689, 0.5317826244609, -83.4152, -1.45586988620957),
(14063, '32343', 218, 12, 41, 30.4912, 0.532171832884095, -84.4618, -1.47413650216095),
(14064, '32344', 218, 12, 588, 30.546, 0.533128273314188, -83.8676, -1.4637657557456),
(14065, '32345', 218, 12, 588, 30.5424, 0.533065441461116, -83.8709, -1.46382335161091),
(14066, '32346', 218, 12, 17520, 30.022, 0.523982748033738, -84.3915, -1.47290953569679),
(14067, '32347', 218, 12, 11148, 30.1097, 0.525513401787737, -83.5825, -1.45878982204816),
(14068, '32348', 218, 12, 11148, 30.1086, 0.525494203165965, -83.582, -1.4587810954019),
(14069, '32350', 218, 12, 17634, 30.6065, 0.534184197511644, -83.3382, -1.45452598268554),
(14070, '32351', 218, 12, 17745, 30.5833, 0.533779281125182, -84.5822, -1.47623787858035),
(14071, '32352', 218, 12, 17745, 30.6832, 0.535522865047924, -84.8274, -1.48051742590624),
(14072, '32353', 218, 12, 17745, 30.5757, 0.53364663610203, -84.5928, -1.47642288348106),
(14073, '32355', 218, 12, 17911, 30.1628, 0.526440171620546, -84.2072, -1.46969289388537),
(14074, '32356', 218, 12, 126, 29.7935, 0.519994670692931, -83.3838, -1.45532185282445),
(14075, '32357', 218, 12, 5759, 30.2877, 0.528620087856287, -83.6319, -1.45965201469865),
(14076, '32358', 218, 12, 18117, 30.1231, 0.525747275907504, -84.5247, -1.47523431426045),
(14077, '32359', 218, 12, 18194, 29.6767, 0.517956126126601, -83.3784, -1.45522760504484),
(14078, '32360', 218, 12, 18300, 30.3506, 0.529717899955791, -84.8191, -1.48037256357832),
(14079, '32361', 218, 12, 18466, 30.3579, 0.529845308991187, -83.9873, -1.46585491486023),
(14080, '32362', 218, 12, 6954, 30.3116, 0.529037221547513, -84.2635, -1.47067551425424),
(14081, '32395', 218, 12, 18274, 30.429, 0.531086238089355, -84.2591, -1.47059871976715),
(14082, '32399', 218, 12, 18274, 30.429, 0.531086238089355, -84.2583, -1.47058475713314),
(14083, '32401', 218, 12, 17523, 30.1606, 0.526401774377002, -85.6513, -1.49489719361342),
(14084, '32402', 218, 12, 17523, 30.1895, 0.526906174530828, -85.6762, -1.49533178059717),
(14085, '32403', 218, 12, 17523, 30.0939, 0.525237639765922, -85.6335, -1.49458652500656),
(14086, '32404', 218, 12, 17523, 30.1822, 0.526778765495433, -85.5601, -1.4933054533356),
(14087, '32405', 218, 12, 17523, 30.204, 0.527159247272367, -85.6593, -1.49503681995358),
(14088, '32406', 218, 12, 17523, 30.1568, 0.526335451865426, -85.738, -1.4964103940749),
(14089, '32407', 218, 12, 17524, 30.2025, 0.527133067333587, -85.8184, -1.4978136387935),
(14090, '32408', 218, 12, 17523, 30.1594, 0.526380830425978, -85.7638, -1.49686068902191),
(14091, '32409', 218, 12, 17523, 30.3119, 0.529042457535269, -85.6408, -1.49471393404196),
(14092, '32410', 218, 12, 17100, 29.9431, 0.522605683253914, -85.4088, -1.49066477017733),
(14093, '32411', 218, 12, 17523, 30.1513, 0.526239458756566, -85.7275, -1.49622713450344),
(14094, '32412', 218, 12, 17523, 30.1561, 0.526323234560662, -85.6482, -1.49484308840661),
(14095, '32413', 218, 12, 17524, 30.242, 0.527822472388125, -85.905, -1.49932509392573),
(14096, '32417', 218, 12, 17523, 30.1839, 0.526808436092716, -85.8092, -1.49765306850232),
(14097, '32420', 218, 12, 14964, 30.6416, 0.534796808079094, -85.3791, -1.49014640738949),
(14098, '32421', 218, 12, 14976, 30.5197, 0.532669251720913, -85.2124, -1.48723694352642),
(14099, '32422', 218, 12, 15022, 30.7466, 0.536629403793689, -86.072, -1.50223979377656),
(14100, '32423', 218, 12, 15103, 30.9577, 0.540313793844649, -85.0823, -1.48496627016957),
(14101, '32424', 218, 12, 15257, 30.4419, 0.531311385562862, -85.0479, -1.48436587690689),
(14102, '32425', 218, 12, 15284, 30.7931, 0.537440981895866, -85.6801, -1.49539984843799),
(14103, '32426', 218, 12, 15420, 30.9435, 0.540065957090865, -85.3564, -1.48975021764929),
(14104, '32427', 218, 12, 15454, 30.8172, 0.537861606245597, -85.8024, -1.49753438611318),
(14105, '32428', 218, 12, 15516, 30.6712, 0.535313425537685, -85.5711, -1.49349743955332),
(14106, '32430', 218, 12, 848, 30.3636, 0.52994479275855, -85.1851, -1.48676046864062),
(14107, '32431', 218, 12, 1797, 30.7963, 0.53749683243193, -85.3722, -1.4900259796711),
(14108, '32432', 218, 12, 1938, 30.7133, 0.536048209152774, -85.0744, -1.48482838915866),
(14109, '32433', 218, 12, 0, 30.7223, 0.536205288785454, -86.1193, -1.50306533451275),
(14110, '32434', 218, 12, 17195, 30.7434, 0.536573553257625, -86.315, -1.50648094385891),
(14111, '32435', 218, 12, 0, 30.7192, 0.536151183578642, -86.123, -1.50312991169508),
(14112, '32437', 218, 12, 15880, 30.4324, 0.531145579283922, -85.9129, -1.49946297493664),
(14113, '32438', 218, 12, 2573, 30.4809, 0.53199206397114, -85.4232, -1.49091609758962),
(14114, '32439', 218, 12, 16142, 30.4581, 0.531594128901685, -86.2163, -1.50475830388719),
(14115, '32440', 218, 12, 16254, 30.9598, 0.54035044575894, -85.5143, -1.49250609253819),
(14116, '32442', 218, 12, 16262, 30.7034, 0.535875421556827, -85.0272, -1.48400459375172),
(14117, '32443', 218, 12, 2869, 30.8679, 0.538746488176358, -85.1687, -1.48647423464329),
(14118, '32444', 218, 12, 16973, 30.2378, 0.527749168559541, -85.6435, -1.49476105793176),
(14119, '32445', 218, 12, 3960, 30.9729, 0.540579083890952, -85.1753, -1.48658942637393),
(14120, '32446', 218, 12, 10308, 30.7753, 0.537130313289011, -85.2302, -1.48754761213327),
(14121, '32447', 218, 12, 10308, 30.8541, 0.538505632739582, -85.2298, -1.48754063081626),
(14122, '32448', 218, 12, 10308, 30.6593, 0.535105731356697, -85.1872, -1.48679712055491),
(14123, '32449', 218, 12, 9859, 30.2719, 0.528344325834471, -85.1977, -1.48698038012637),
(14124, '32452', 218, 12, 17288, 30.9809, 0.540718710231111, -85.6174, -1.49430552699699),
(14125, '32454', 218, 12, 17684, 30.3695, 0.530047767184418, -86.1146, -1.50298330403791),
(14126, '32455', 218, 12, 17696, 30.7672, 0.536988941619599, -85.953, -1.50016285196669),
(14127, '32456', 218, 12, 17714, 29.817, 0.520404823067149, -85.3022, -1.48880424919471),
(14128, '32457', 218, 12, 17714, 29.8112, 0.520303593970534, -85.3036, -1.48882868380424),
(14129, '32459', 218, 12, 17981, 30.3623, 0.529922103478274, -86.2344, -1.5050742084818),
(14130, '32460', 218, 12, 18110, 30.7146, 0.53607089843305, -84.9325, -1.48235176695008),
(14131, '32461', 218, 12, 17855, 30.2535, 0.528023185252104, -85.9489, -1.50009129346735),
(14132, '32462', 218, 12, 6535, 30.5038, 0.532391744369846, -85.867, -1.49866186880997),
(14133, '32463', 218, 12, 18514, 30.633, 0.534646709763423, -85.587, -1.49377494690439),
(14134, '32464', 218, 12, 12776, 30.7708, 0.537051773472671, -85.8542, -1.49843846666572),
(14135, '32465', 218, 12, 18584, 30.0566, 0.524586631954928, -85.1591, -1.4863066830351),
(14136, '32466', 218, 12, 13011, 30.3373, 0.529485771165276, -85.5229, -1.49265619085386),
(14137, '32501', 218, 12, 17579, 30.4211, 0.530948357078447, -87.2202, -1.52227966424796),
(14138, '32502', 218, 12, 17579, 30.4202, 0.530932649115179, -87.2241, -1.52234773208879),
(14139, '32503', 218, 12, 17579, 30.4538, 0.531519079743849, -87.2104, -1.52210862198126),
(14140, '32504', 218, 12, 17579, 30.4883, 0.532121218335787, -87.1874, -1.5217071962533),
(14141, '32505', 218, 12, 17579, 30.4447, 0.531360254781918, -87.2577, -1.52293416271746),
(14142, '32506', 218, 12, 17579, 30.4323, 0.53114383395467, -87.3154, -1.52394121769586),
(14143, '32507', 218, 12, 17579, 30.3687, 0.530033804550402, -87.3331, -1.52425014097346),
(14144, '32508', 218, 12, 17579, 30.3504, 0.529714409297287, -87.2783, -1.52329370054337),
(14145, '32509', 218, 12, 17579, 30.4203, 0.530934394444431, -87.2239, -1.52234424143028),
(14146, '32511', 218, 12, 17579, 30.3932, 0.530461410217141, -87.3538, -1.52461142412862),
(14147, '32512', 218, 12, 17579, 30.5037, 0.532389999040594, -87.1755, -1.52149950207232),
(14148, '32513', 218, 12, 17579, 30.4614, 0.531651724767001, -87.2144, -1.52217843515134),
(14149, '32514', 218, 12, 17579, 30.5239, 0.532742555549497, -87.2346, -1.52253099166025),
(14150, '32516', 218, 12, 17579, 30.4245, 0.531007698273015, -87.2957, -1.52359738783321),
(14151, '32520', 218, 12, 17579, 30.4564, 0.531564458304401, -87.2611, -1.52299350391202),
(14152, '32521', 218, 12, 17579, 30.3747, 0.530138524305522, -87.276, -1.52325355797057),
(14153, '32522', 218, 12, 17579, 30.4209, 0.530944866419943, -87.2243, -1.52235122274729),
(14154, '32523', 218, 12, 17579, 30.5177, 0.532634345135873, -87.218, -1.52224126700441),
(14155, '32524', 218, 12, 17579, 30.4845, 0.532054895824211, -87.1909, -1.52176828277712),
(14156, '32526', 218, 12, 17579, 30.4788, 0.531955412056848, -87.3239, -1.52408957068228),
(14157, '32530', 218, 12, 15071, 30.6189, 0.534400618338892, -87.0273, -1.51891292412086),
(14158, '32531', 218, 12, 7221, 30.7901, 0.537388622018306, -86.6057, -1.51155461599445),
(14159, '32533', 218, 12, 15424, 30.6313, 0.534617039166139, -87.3332, -1.52425188630271),
(14160, '32534', 218, 12, 17579, 30.5269, 0.532794915427057, -87.2791, -1.52330766317738),
(14161, '32535', 218, 12, 15480, 30.97, 0.540528469342644, -87.3115, -1.52387314985503),
(14162, '32536', 218, 12, 15669, 30.7621, 0.536899929827748, -86.5617, -1.51078667112358),
(14163, '32537', 218, 12, 17137, 30.7619, 0.536896439169244, -86.6045, -1.51153367204343),
(14164, '32538', 218, 12, 17550, 30.9763, 0.54063842508552, -86.3127, -1.50644080128611),
(14165, '32539', 218, 12, 15669, 30.7625, 0.536906911144756, -86.5682, -1.51090011752496),
(14166, '32540', 218, 12, 15784, 30.3916, 0.530433484949109, -86.4834, -1.50942007831926),
(14167, '32541', 218, 12, 15784, 30.3978, 0.530541695362732, -86.48, -1.5093607371247),
(14168, '32542', 218, 12, 0, 30.4638, 0.531693612669049, -86.538, -1.51037302809085),
(14169, '32544', 218, 12, 0, 30.7626, 0.536908656474008, -86.5686, -1.51090709884196),
(14170, '32547', 218, 12, 16104, 30.4469, 0.531398652025462, -86.624, -1.51187401124757),
(14171, '32548', 218, 12, 16104, 30.4122, 0.53079302277502, -86.616, -1.51173438490741),
(14172, '32549', 218, 12, 16104, 30.4126, 0.530800004092028, -86.615, -1.51171693161489),
(14173, '32550', 218, 12, 17149, 30.3822, 0.530269423999421, -86.3533, -1.50714940496242),
(14174, '32559', 218, 12, 17579, 30.4646, 0.531707575303065, -87.3398, -1.52436707803334),
(14175, '32560', 218, 12, 16243, 30.5818, 0.533753101186402, -87.2919, -1.52353106532164),
(14176, '32561', 218, 12, 16299, 30.3818, 0.530262442682413, -87.0904, -1.52001422687887),
(14177, '32562', 218, 12, 16299, 30.369, 0.530039040538158, -87.1762, -1.52151171937708),
(14178, '32563', 218, 12, 16299, 30.4077, 0.53071448295868, -86.9876, -1.51822002840782),
(14179, '32564', 218, 12, 3208, 30.7087, 0.535967924007183, -86.8473, -1.51577133146727),
(14180, '32565', 218, 12, 9722, 30.9159, 0.539584246217315, -87.1451, -1.52096892197971),
(14181, '32566', 218, 12, 17243, 30.4229, 0.530979773004983, -86.8925, -1.51656022028917),
(14182, '32567', 218, 12, 16858, 30.9321, 0.539866989556138, -86.4216, -1.50834146484153),
(14183, '32568', 218, 12, 17065, 30.9003, 0.539311974854004, -87.4579, -1.52642831187995),
(14184, '32569', 218, 12, 17042, 30.4118, 0.530786041458012, -86.7169, -1.51349542212267),
(14185, '32570', 218, 12, 4232, 30.6333, 0.534651945751179, -87.0465, -1.51924802733724),
(14186, '32571', 218, 12, 4232, 30.6083, 0.53421561343818, -87.149, -1.52103698982054),
(14187, '32572', 218, 12, 4232, 30.6314, 0.534618784495391, -87.0496, -1.51930213254406),
(14188, '32573', 218, 12, 17579, 30.4205, 0.530937885102935, -87.2242, -1.52234947741804),
(14189, '32574', 218, 12, 17579, 30.4071, 0.530704010983168, -87.2144, -1.52217843515134),
(14190, '32575', 218, 12, 17579, 30.421, 0.530946611749195, -87.2245, -1.52235471340579),
(14191, '32576', 218, 12, 17579, 30.4207, 0.530941375761439, -87.2243, -1.52235122274729),
(14192, '32577', 218, 12, 17160, 30.7213, 0.536187835492934, -87.3239, -1.52408957068228),
(14193, '32578', 218, 12, 17277, 30.5054, 0.532419669637878, -86.4565, -1.50895058475048),
(14194, '32579', 218, 12, 18052, 30.4443, 0.53135327346491, -86.5717, -1.51096120404878),
(14195, '32580', 218, 12, 18421, 30.5078, 0.532461557539926, -86.4965, -1.50964871645128),
(14196, '32581', 218, 12, 17579, 30.4206, 0.530939630432187, -87.2246, -1.52235645873505),
(14197, '32582', 218, 12, 17579, 30.4204, 0.530936139773683, -87.224, -1.52234598675953),
(14198, '32583', 218, 12, 4232, 30.5877, 0.53385607561227, -87.0235, -1.51884660160929),
(14199, '32588', 218, 12, 17277, 30.5251, 0.532763499500521, -86.4734, -1.50924554539406),
(14200, '32589', 218, 12, 17579, 30.4206, 0.530939630432187, -87.2247, -1.5223582040643),
(14201, '32590', 218, 12, 17579, 30.4203, 0.530934394444431, -87.2248, -1.52235994939355),
(14202, '32591', 218, 12, 17579, 30.4206, 0.530939630432187, -87.2239, -1.52234424143028),
(14203, '32592', 218, 12, 17579, 30.4208, 0.530943121090691, -87.224, -1.52234598675953),
(14204, '32593', 218, 12, 17579, 30.4205, 0.530937885102935, -87.2243, -1.52235122274729),
(14205, '32594', 218, 12, 17579, 30.4203, 0.530934394444431, -87.2249, -1.5223616947228),
(14206, '32595', 218, 12, 17579, 30.4207, 0.530941375761439, -87.2249, -1.5223616947228),
(14207, '32596', 218, 12, 17579, 30.4209, 0.530944866419943, -87.2249, -1.5223616947228),
(14208, '32597', 218, 12, 17579, 30.4208, 0.530943121090691, -87.2249, -1.5223616947228),
(14209, '32598', 218, 12, 17579, 30.42, 0.530929158456675, -87.2242, -1.52234947741804),
(14210, '32601', 218, 12, 2644, 29.6492, 0.517476160582303, -82.3089, -1.43656130869476),
(14211, '32602', 218, 12, 2644, 29.662, 0.517699562726558, -82.4494, -1.43901349629381),
(14212, '32603', 218, 12, 2644, 29.6551, 0.51757913500817, -82.3476, -1.43723675111528),
(14213, '32604', 218, 12, 2644, 29.6524, 0.517532011118367, -82.3437, -1.43716868327445),
(14214, '32605', 218, 12, 2644, 29.6769, 0.517959616785105, -82.3724, -1.43766959276978),
(14215, '32606', 218, 12, 2644, 29.6965, 0.518301701318496, -82.4092, -1.43831187393451),
(14216, '32607', 218, 12, 2644, 29.6457, 0.517415074058483, -82.4152, -1.43841659368963),
(14217, '32608', 218, 12, 2644, 29.6042, 0.516690762418905, -82.3991, -1.43813559568006),
(14218, '32609', 218, 12, 2644, 29.6919, 0.518221416172904, -82.2973, -1.43635885050153),
(14219, '32610', 218, 12, 2644, 29.6394, 0.517305118315607, -82.3441, -1.43717566459146),
(14220, '32611', 218, 12, 2644, 29.6451, 0.517404602082971, -82.3492, -1.43726467638331),
(14221, '32612', 218, 12, 2644, 29.6542, 0.517563427044902, -82.3507, -1.43729085632209),
(14222, '32613', 218, 12, 2644, 29.6648, 0.517748431945614, -82.3246, -1.43683532538732),
(14223, '32614', 218, 12, 2644, 29.6088, 0.516771047564497, -82.3725, -1.43767133809903),
(14224, '32615', 218, 12, 14953, 29.7873, 0.519886460279307, -82.4796, -1.43954058572792),
(14225, '32616', 218, 12, 14953, 29.7792, 0.519745088609895, -82.4801, -1.43954931237417),
(14226, '32617', 218, 12, 15007, 29.2947, 0.511288968383983, -82.1069, -1.43303574360573),
(14227, '32618', 218, 12, 15020, 29.5421, 0.515606912953417, -82.5132, -1.44012701635659),
(14228, '32619', 218, 12, 219, 29.6152, 0.516882748636625, -82.8137, -1.44537173075883),
(14229, '32621', 218, 12, 15335, 29.4541, 0.514071023211662, -82.6344, -1.44224235541),
(14230, '32622', 218, 12, 15336, 29.9256, 0.522300250634815, -82.2854, -1.43615115632054),
(14231, '32625', 218, 12, 15470, 29.1721, 0.509149194721038, -83.0143, -1.44887286123833),
(14232, '32626', 218, 12, 15514, 29.4834, 0.514582404682496, -82.8642, -1.44625312203109),
(14233, '32627', 218, 12, 2644, 29.647, 0.517437763338759, -82.326, -1.43685975999685),
(14234, '32628', 218, 12, 15675, 29.6362, 0.517249267779544, -83.1091, -1.45052743336922),
(14235, '32631', 218, 12, 15850, 29.4263, 0.513585821679607, -82.2137, -1.43489975524686),
(14236, '32633', 218, 12, 15963, 29.4847, 0.514605093962772, -82.2259, -1.43511268541561),
(14237, '32634', 218, 12, 2367, 29.3716, 0.512631126578767, -82.2779, -1.43602025662664),
(14238, '32635', 218, 12, 2644, 29.6514, 0.517514557825847, -82.3254, -1.43684928802134),
(14239, '32639', 218, 12, 16303, 29.2533, 0.510566402073657, -82.7229, -1.44378697179802),
(14240, '32640', 218, 12, 13124, 29.5923, 0.516483068237918, -82.1106, -1.43310032078806),
(14241, '32641', 218, 12, 2644, 29.6515, 0.517516303155099, -82.3248, -1.43683881604583),
(14242, '32643', 218, 12, 16427, 29.8262, 0.520565393358333, -82.5973, -1.44159483825751),
(14243, '32644', 218, 12, 15514, 29.479, 0.514505610195408, -82.8613, -1.44620250748278),
(14244, '32648', 218, 12, 16496, 29.5509, 0.515760501927592, -83.2566, -1.45310179401591),
(14245, '32653', 218, 12, 2644, 29.6643, 0.517739705299354, -82.3249, -1.43684056137508),
(14246, '32654', 218, 12, 16563, 29.5885, 0.516416745726342, -82.1263, -1.43337433748062),
(14247, '32655', 218, 12, 16427, 29.8218, 0.520488598871245, -82.5914, -1.44149186383164),
(14248, '32656', 218, 12, 16722, 29.7962, 0.520041794582734, -81.9873, -1.43094832982035),
(14249, '32658', 218, 12, 16751, 29.8454, 0.520900496574716, -82.4048, -1.43823507944742),
(14250, '32662', 218, 12, 16925, 29.5116, 0.515074587531559, -82.1002, -1.43291880654585),
(14251, '32663', 218, 12, 10211, 29.3304, 0.511912050926945, -82.1987, -1.43463795585906),
(14252, '32664', 218, 12, 4100, 29.446, 0.51392965154225, -82.2295, -1.43517551726868),
(14253, '32666', 218, 12, 4153, 29.7433, 0.519118515408429, -82.0103, -1.43134975554831),
(14254, '32667', 218, 12, 17110, 29.4438, 0.513891254298706, -82.2966, -1.43634663319677),
(14255, '32668', 218, 12, 10611, 29.2746, 0.510938157204332, -82.3612, -1.43747411589355),
(14256, '32669', 218, 12, 17269, 29.6474, 0.517444744655767, -82.5997, -1.44163672615956),
(14257, '32680', 218, 12, 4772, 29.6252, 0.517057281561824, -83.1044, -1.45044540289438),
(14258, '32681', 218, 12, 17432, 29.416, 0.513406052766652, -82.2159, -1.43493815249041),
(14259, '32683', 218, 12, 17463, 29.324, 0.511800349854817, -82.7736, -1.44467185372878),
(14260, '32686', 218, 12, 17772, 29.3581, 0.512395507129747, -82.2506, -1.43554378174085),
(14261, '32692', 218, 12, 18255, 29.3294, 0.511894597634425, -83.144, -1.45113655327817),
(14262, '32693', 218, 12, 6381, 29.6119, 0.516825152771309, -82.8134, -1.44536649477107),
(14263, '32694', 218, 12, 6601, 29.7857, 0.519858535011275, -82.1707, -1.4341492636685),
(14264, '32696', 218, 12, 18638, 29.3898, 0.512948776502629, -82.4554, -1.43911821604893),
(14265, '32697', 218, 12, 18673, 29.9312, 0.522397989072927, -82.4241, -1.43857192799306),
(14266, '32701', 218, 12, 14975, 28.6654, 0.500305611401183, -81.3705, -1.42018313899405),
(14267, '32702', 218, 12, 14978, 29.0126, 0.506365394564107, -81.6234, -1.42459707667234),
(14268, '32703', 218, 12, 15015, 28.6614, 0.500235798231103, -81.4992, -1.42242937774136),
(14269, '32704', 218, 12, 15015, 28.6148, 0.499422474799673, -81.4994, -1.42243286839987),
(14270, '32706', 218, 12, 15457, 28.9677, 0.505581741729961, -81.2389, -1.41788628569842),
(14271, '32707', 218, 12, 15458, 28.6624, 0.500253251523623, -81.3128, -1.41917608401565),
(14272, '32708', 218, 12, 18659, 28.6842, 0.500633733300557, -81.2834, -1.41866295721556),
(14273, '32709', 218, 12, 15524, 28.5377, 0.498076825946386, -81.0216, -1.41409368523384),
(14274, '32710', 218, 12, 15542, 28.6126, 0.49938407755613, -81.4992, -1.42242937774136),
(14275, '32712', 218, 12, 15015, 28.7128, 0.501132897466628, -81.5202, -1.42279589688428),
(14276, '32713', 218, 12, 15753, 28.8848, 0.504134863780058, -81.3061, -1.41905914695576),
(14277, '32714', 218, 12, 14975, 28.6656, 0.500309102059687, -81.4111, -1.42089174267036),
(14278, '32715', 218, 12, 14975, 28.6661, 0.500317828705947, -81.3588, -1.41997893547156),
(14279, '32716', 218, 12, 14975, 28.666, 0.500316083376695, -81.4023, -1.42073815369618),
(14280, '32718', 218, 12, 15458, 28.6632, 0.500267214157639, -81.3235, -1.41936283424561),
(14281, '32719', 218, 12, 18659, 28.6816, 0.500588354740006, -81.2747, -1.41851111357064),
(14282, '32720', 218, 12, 0, 29.0301, 0.506670827183206, -81.3256, -1.4193994861599),
(14283, '32721', 218, 12, 0, 29.0281, 0.506635920598166, -81.2933, -1.41883574481151),
(14284, '32722', 218, 12, 2749, 29.082, 0.507576653064991, -81.3536, -1.41988817835046),
(14285, '32724', 218, 12, 0, 29.0393, 0.506831397474389, -81.2828, -1.41865248524005),
(14286, '32725', 218, 12, 15778, 28.9001, 0.504401899155613, -81.2419, -1.41793864557598),
(14287, '32726', 218, 12, 15957, 28.8618, 0.503733438052099, -81.6176, -1.42449584757572),
(14288, '32727', 218, 12, 15957, 28.8317, 0.503208093947249, -81.6592, -1.42522190454455),
(14289, '32728', 218, 12, 15778, 28.8697, 0.503871319063007, -81.2397, -1.41790024833244),
(14290, '32730', 218, 12, 15458, 28.6517, 0.500066501293659, -81.3443, -1.41972586273002),
(14291, '32732', 218, 12, 2687, 28.7447, 0.501689657498014, -81.119, -1.41579363592528),
(14292, '32733', 218, 12, 16236, 28.6261, 0.499619697005149, -81.2628, -1.41830341938965),
(14293, '32735', 218, 12, 16260, 28.9104, 0.504581668068569, -81.7535, -1.42686775002918),
(14294, '32736', 218, 12, 15957, 28.8541, 0.503599047699696, -81.6856, -1.42568267146708),
(14295, '32738', 218, 12, 15778, 28.9091, 0.504558978788293, -81.1929, -1.4170834342425),
(14296, '32739', 218, 12, 15778, 28.9096, 0.504567705434553, -81.2086, -1.41735745093507),
(14297, '32744', 218, 12, 16790, 28.9838, 0.505862739739532, -81.2317, -1.41776062199228),
(14298, '32746', 218, 12, 16812, 28.7536, 0.501844991801441, -81.3418, -1.41968222949872),
(14299, '32747', 218, 12, 390, 28.8236, 0.503066722277838, -81.3186, -1.41927731311226),
(14300, '32750', 218, 12, 3863, 28.7027, 0.500956619212176, -81.3623, -1.42004002199538),
(14301, '32751', 218, 12, 16989, 28.6262, 0.499621442334401, -81.3573, -1.41995275553278),
(14302, '32752', 218, 12, 3863, 28.7129, 0.50113464279588, -81.394, -1.42059329136826),
(14303, '32753', 218, 12, 15753, 28.8831, 0.504105193182774, -81.3092, -1.41911325216257),
(14304, '32754', 218, 12, 17143, 28.6883, 0.500705291799889, -80.8646, -1.41135351830821),
(14305, '32756', 218, 12, 17201, 28.8063, 0.502764780317243, -81.6417, -1.42491647192545),
(14306, '32757', 218, 12, 17201, 28.8057, 0.502754308341731, -81.6534, -1.42512067544794),
(14307, '32759', 218, 12, 4679, 28.8652, 0.503792779246667, -80.8634, -1.41133257435718),
(14308, '32762', 218, 12, 17465, 28.6578, 0.500172966378031, -81.1818, -1.41688970269553),
(14309, '32763', 218, 12, 17426, 28.9466, 0.505213477257791, -81.3002, -1.41895617252989),
(14310, '32764', 218, 12, 17461, 28.8473, 0.50348036531056, -81.1419, -1.41619331632399),
(14311, '32765', 218, 12, 17465, 28.6497, 0.500031594708619, -81.209, -1.41736443225208),
(14312, '32766', 218, 12, 17465, 28.637, 0.499809937893616, -81.1111, -1.41565575491437),
(14313, '32767', 218, 12, 17481, 29.0011, 0.506164681700128, -81.5098, -1.42261438264207),
(14314, '32768', 218, 12, 14433, 28.6969, 0.500855390115561, -81.5578, -1.42345214068303),
(14315, '32771', 218, 12, 188, 28.7965, 0.502593738050547, -81.297, -1.41890032199383),
(14316, '32772', 218, 12, 188, 28.7695, 0.502122499152509, -81.2486, -1.41805558263586),
(14317, '32773', 218, 12, 188, 28.7652, 0.502047449994673, -81.2758, -1.41853031219241),
(14318, '32774', 218, 12, 17426, 28.9491, 0.505257110489091, -81.2987, -1.41892999259111),
(14319, '32775', 218, 12, 18012, 28.7661, 0.502063157957941, -80.871, -1.41146521938033),
(14320, '32776', 218, 12, 18119, 28.8043, 0.502729873732203, -81.5327, -1.42301406304078),
(14321, '32777', 218, 12, 18284, 28.7634, 0.502016034068137, -81.6276, -1.42467038050092),
(14322, '32778', 218, 12, 18291, 28.8003, 0.502660060562123, -81.7358, -1.42655882675158),
(14323, '32779', 218, 12, 3863, 28.7029, 0.50096010987068, -81.4209, -1.42106278493705),
(14324, '32780', 218, 12, 18352, 28.5723, 0.498680709867576, -80.822, -1.41061000804686),
(14325, '32781', 218, 12, 18352, 28.5332, 0.497998286130046, -80.81, -1.41040056853662),
(14326, '32782', 218, 12, 18352, 28.6254, 0.499607479700385, -80.8919, -1.411829993194),
(14327, '32783', 218, 12, 18352, 28.5427, 0.498164092408986, -80.8553, -1.41119120268777),
(14328, '32784', 218, 12, 18403, 28.9265, 0.50486266607814, -81.6651, -1.42532487897042),
(14329, '32789', 218, 12, 18658, 28.5992, 0.499150203436362, -81.3559, -1.41992832092325),
(14330, '32790', 218, 12, 18658, 28.5885, 0.498963453206399, -81.3307, -1.41948849795175),
(14331, '32791', 218, 12, 3863, 28.7037, 0.500974072504696, -81.4196, -1.42104009565678),
(14332, '32792', 218, 12, 18658, 28.5955, 0.499085626254039, -81.3047, -1.41903471234623),
(14333, '32793', 218, 12, 18658, 28.6607, 0.500223580926339, -81.4832, -1.42215012506104),
(14334, '32794', 218, 12, 16989, 28.6281, 0.499654603590189, -81.3663, -1.42010983516546),
(14335, '32795', 218, 12, 16812, 28.7594, 0.501946220898057, -81.3346, -1.41955656579258),
(14336, '32796', 218, 12, 18352, 28.6245, 0.499591771737117, -80.843, -1.41097652718978),
(14337, '32798', 218, 12, 18701, 28.725, 0.501345827635371, -81.5888, -1.42399319275115),
(14338, '32799', 218, 12, 0, 28.6301, 0.499689510175229, -81.3579, -1.41996322750829),
(14339, '32801', 218, 12, 10999, 28.5412, 0.498137912470206, -81.3741, -1.42024597084712),
(14340, '32802', 218, 12, 10999, 28.5425, 0.498160601750481, -81.3741, -1.42024597084712),
(14341, '32803', 218, 12, 10999, 28.5583, 0.498436363772297, -81.3558, -1.419926575594),
(14342, '32804', 218, 12, 10999, 28.5759, 0.498743541720648, -81.3955, -1.42061947130704),
(14343, '32805', 218, 12, 10999, 28.5298, 0.497938944935478, -81.4074, -1.42082716548803),
(14344, '32806', 218, 12, 10999, 28.5127, 0.497640493633387, -81.3568, -1.41994402888652),
(14345, '32807', 218, 12, 10999, 28.5576, 0.498424146467533, -81.3025, -1.41899631510269),
(14346, '32808', 218, 12, 10999, 28.5755, 0.49873656040364, -81.441, -1.4214135961167),
(14347, '32809', 218, 12, 10999, 28.4717, 0.49692490864007, -81.3907, -1.42053569550295),
(14348, '32810', 218, 12, 10999, 28.6182, 0.499481815994241, -81.4418, -1.42142755875072),
(14349, '32811', 218, 12, 10999, 28.5206, 0.497778374644295, -81.444, -1.42146595599426),
(14350, '32812', 218, 12, 10999, 28.491, 0.497261757185704, -81.3271, -1.41942566609868),
(14351, '32814', 218, 12, 10999, 28.5561, 0.498397966528753, -81.3494, -1.41981487452188),
(14352, '32815', 218, 12, 10999, 28.5921, 0.499026285059471, -80.6543, -1.40768309089126),
(14353, '32816', 218, 12, 10999, 28.6047, 0.499246196545222, -81.2051, -1.41729636441125),
(14354, '32817', 218, 12, 10999, 28.5811, 0.498834298841751, -81.253, -1.41813237712295),
(14355, '32818', 218, 12, 10999, 28.5784, 0.498787174951947, -81.4966, -1.42238399918081),
(14356, '32819', 218, 12, 10999, 28.4612, 0.49674164906861, -81.4759, -1.42202271602565),
(14357, '32820', 218, 12, 10999, 28.5884, 0.498961707877147, -81.1229, -1.41586170376611),
(14358, '32821', 218, 12, 10999, 28.3807, 0.495336659020755, -81.4703, -1.42192497758754),
(14359, '32822', 218, 12, 10999, 28.5035, 0.497479923342204, -81.2913, -1.41880083822647),
(14360, '32824', 218, 12, 10999, 28.4012, 0.495694451517414, -81.3575, -1.41995624619129),
(14361, '32825', 218, 12, 10999, 28.5479, 0.498254849530089, -81.2521, -1.41811666915968),
(14362, '32826', 218, 12, 10999, 28.5787, 0.498792410939704, -81.1848, -1.41694206257309),
(14363, '32827', 218, 12, 10999, 28.4273, 0.496149982452184, -81.3178, -1.41926335047825),
(14364, '32828', 218, 12, 10999, 28.5471, 0.498240886896073, -81.1829, -1.4169089013173),
(14365, '32829', 218, 12, 10999, 28.4683, 0.496865567445502, -81.2409, -1.41792119228346),
(14366, '32830', 218, 12, 10999, 28.371, 0.495167362083311, -81.5594, -1.42348006595106),
(14367, '32831', 218, 12, 10999, 28.475, 0.496982504505385, -81.1727, -1.4167308777336),
(14368, '32832', 218, 12, 10999, 28.379, 0.495306988423471, -81.1873, -1.41698569580439),
(14369, '32833', 218, 12, 10999, 28.5335, 0.498003522117802, -81.1, -1.4154620233674),
(14370, '32834', 218, 12, 10999, 28.5297, 0.497937199606226, -81.172, -1.41671866042884),
(14371, '32835', 218, 12, 10999, 28.5157, 0.497692853510947, -81.4822, -1.42213267176852),
(14372, '32836', 218, 12, 10999, 28.4259, 0.496125547842656, -81.5049, -1.42252886150873),
(14373, '32837', 218, 12, 10999, 28.3921, 0.495535626555482, -81.415, -1.42095981051118),
(14374, '32839', 218, 12, 10999, 28.487, 0.497191944015625, -81.4037, -1.42076258830571),
(14375, '32853', 218, 12, 10999, 28.5561, 0.498397966528753, -81.3498, -1.41982185583888),
(14376, '32854', 218, 12, 10999, 28.5664, 0.498577735441708, -81.3899, -1.42052173286893),
(14377, '32855', 218, 12, 10999, 28.5126, 0.497638748304135, -81.3889, -1.42050427957641),
(14378, '32856', 218, 12, 10999, 28.5113, 0.497616059023859, -81.3727, -1.42022153623759),
(14379, '32857', 218, 12, 10999, 28.5583, 0.498436363772297, -81.2968, -1.41889683133533),
(14380, '32858', 218, 12, 10999, 28.5532, 0.498347351980445, -81.4489, -1.42155147712761),
(14381, '32859', 218, 12, 10999, 28.4618, 0.496752121044122, -81.3847, -1.42043097574783),
(14382, '32860', 218, 12, 10999, 28.6219, 0.499546393176565, -81.4287, -1.42119892061871),
(14383, '32861', 218, 12, 10999, 28.5179, 0.497731250754491, -81.4456, -1.42149388126229),
(14384, '32862', 218, 12, 10999, 28.5375, 0.498073335287882, -81.3791, -1.42033323730972),
(14385, '32867', 218, 12, 10999, 28.5678, 0.498602170051236, -81.2534, -1.41813935843996),
(14386, '32868', 218, 12, 10999, 28.5905, 0.498998359791439, -81.4942, -1.42234211127876),
(14387, '32869', 218, 12, 10999, 28.5908, 0.499003595779195, -81.4934, -1.42232814864475),
(14388, '32872', 218, 12, 10999, 28.5422, 0.498155365762726, -81.3733, -1.4202320082131),
(14389, '32877', 218, 12, 10999, 28.5426, 0.498162347079734, -81.3745, -1.42025295216413),
(14390, '32878', 218, 12, 10999, 28.5294, 0.49793196361847, -81.1734, -1.41674309503837),
(14391, '32885', 218, 12, 10999, 28.5378, 0.498078571275638, -81.3795, -1.42034021862673),
(14392, '32886', 218, 12, 10999, 28.5427, 0.498164092408986, -81.3796, -1.42034196395598),
(14393, '32887', 218, 12, 10999, 28.3809, 0.495340149679259, -81.4702, -1.42192323225828),
(14394, '32890', 218, 12, 10999, 28.4615, 0.496746885056366, -81.3851, -1.42043795706484),
(14395, '32891', 218, 12, 10999, 28.5559, 0.498394475870249, -81.3496, -1.41981836518038),
(14396, '32893', 218, 12, 10999, 28.4288, 0.496176162390964, -81.3073, -1.41908009090679),
(14397, '32896', 218, 12, 10999, 28.5382, 0.498085552592646, -81.3795, -1.42034021862673),
(14398, '32897', 218, 12, 10999, 28.5406, 0.498127440494694, -81.3796, -1.42034196395598),
(14399, '32898', 218, 12, 10999, 28.5405, 0.498125695165442, -81.3788, -1.42032800132196),
(14400, '32899', 218, 12, 10999, 28.6142, 0.499412002824161, -80.6773, -1.40808451661922),
(14401, '32901', 218, 12, 10438, 28.0747, 0.489995951509652, -80.6298, -1.40725548522452),
(14402, '32902', 218, 12, 10438, 27.9967, 0.488634594693096, -80.6496, -1.40760106041642),
(14403, '32903', 218, 12, 16528, 28.1174, 0.490741207100254, -80.5825, -1.40642994448833),
(14404, '32904', 218, 12, 10438, 28.0715, 0.489940100973588, -80.6947, -1.40838820390907);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(14405, '32905', 218, 12, 17485, 28.0093, 0.488854506178848, -80.5945, -1.40663938399857),
(14406, '32906', 218, 12, 17485, 28.0093, 0.488854506178848, -80.6274, -1.40721359732248),
(14407, '32907', 218, 12, 17485, 28.0152, 0.488957480604715, -80.6829, -1.40818225505733),
(14408, '32908', 218, 12, 17485, 27.9802, 0.488346615366517, -80.6898, -1.40830268277572),
(14409, '32909', 218, 12, 17485, 27.9595, 0.487985332211355, -80.6451, -1.40752252060008),
(14410, '32910', 218, 12, 17485, 27.9978, 0.488653793314868, -80.6911, -1.408325372056),
(14411, '32911', 218, 12, 17485, 28.0168, 0.488985405872747, -80.6856, -1.40822937894714),
(14412, '32912', 218, 12, 10438, 28.0789, 0.490069255338236, -80.6024, -1.40677726500948),
(14413, '32919', 218, 12, 10438, 28.0774, 0.490043075399456, -80.6292, -1.40724501324901),
(14414, '32920', 218, 12, 15425, 28.3898, 0.495495483982686, -80.6046, -1.40681566225302),
(14415, '32922', 218, 12, 15570, 28.3645, 0.495053915681932, -80.7476, -1.40931148308337),
(14416, '32923', 218, 12, 15570, 28.2627, 0.493277170503401, -80.7057, -1.40858019012679),
(14417, '32924', 218, 12, 15570, 28.2622, 0.493268443857141, -80.7066, -1.40859589809006),
(14418, '32925', 218, 12, 0, 28.2303, 0.492711683825755, -80.6226, -1.40712982151838),
(14419, '32926', 218, 12, 15570, 28.3907, 0.495511191945954, -80.7894, -1.41004103071071),
(14420, '32927', 218, 12, 15570, 28.4702, 0.49689872870129, -80.7965, -1.4101649490876),
(14421, '32931', 218, 12, 15571, 28.3288, 0.49443083313897, -80.6123, -1.40695005260543),
(14422, '32932', 218, 12, 15571, 28.3189, 0.494258045543022, -80.6114, -1.40693434464216),
(14423, '32934', 218, 12, 10438, 28.1392, 0.491121688877188, -80.6933, -1.40836376929954),
(14424, '32935', 218, 12, 10438, 28.1395, 0.491126924864944, -80.6588, -1.4077616307076),
(14425, '32936', 218, 12, 10438, 28.1408, 0.49114961414522, -80.6517, -1.40763771233071),
(14426, '32937', 218, 12, 17997, 28.1732, 0.491715100822866, -80.598, -1.40670047052239),
(14427, '32940', 218, 12, 10438, 28.2256, 0.492629653350911, -80.6887, -1.40828348415395),
(14428, '32941', 218, 12, 10438, 28.0776, 0.49004656605796, -80.6286, -1.4072345412735),
(14429, '32948', 218, 12, 16003, 27.7685, 0.484651753340045, -80.5999, -1.40673363177818),
(14430, '32949', 218, 12, 104, 27.9276, 0.487428572179968, -80.5319, -1.40554680788682),
(14431, '32950', 218, 12, 16991, 27.9835, 0.488404211231833, -80.5919, -1.40659400543802),
(14432, '32951', 218, 12, 17085, 28.0127, 0.488913847373416, -80.5288, -1.40549270268001),
(14433, '32952', 218, 12, 17099, 28.3449, 0.494711831148541, -80.6763, -1.4080670633267),
(14434, '32953', 218, 12, 17099, 28.3995, 0.49566478092013, -80.7042, -1.40855401018801),
(14435, '32954', 218, 12, 17099, 28.3101, 0.494104456568847, -80.6643, -1.40785762381646),
(14436, '32955', 218, 12, 5478, 28.3136, 0.494165543092667, -80.7238, -1.4088960947214),
(14437, '32956', 218, 12, 5478, 28.3194, 0.494266772189282, -80.7285, -1.40897812519624),
(14438, '32957', 218, 12, 11685, 27.8285, 0.485698950891242, -80.4928, -1.40486438414929),
(14439, '32958', 218, 12, 18022, 27.7863, 0.4849624219469, -80.4808, -1.40465494463905),
(14440, '32959', 218, 12, 18055, 28.4597, 0.49671546912983, -80.8264, -1.41068680253395),
(14441, '32960', 218, 12, 18444, 27.6481, 0.482550376920644, -80.4183, -1.40356411385656),
(14442, '32961', 218, 12, 18444, 27.6323, 0.482274614898829, -80.3791, -1.40287994478977),
(14443, '32962', 218, 12, 18444, 27.5915, 0.481562520564015, -80.4101, -1.40342099685789),
(14444, '32963', 218, 12, 18444, 27.6507, 0.482595755481196, -80.3592, -1.40253262426863),
(14445, '32964', 218, 12, 18444, 27.64, 0.482409005251233, -80.3993, -1.40323250129868),
(14446, '32965', 218, 12, 18444, 27.6458, 0.482510234347848, -80.3946, -1.40315047082383),
(14447, '32966', 218, 12, 18444, 27.6384, 0.482381079983201, -80.4741, -1.40453800757917),
(14448, '32967', 218, 12, 18444, 27.7031, 0.483510308009241, -80.4566, -1.40423257496007),
(14449, '32968', 218, 12, 18444, 27.5968, 0.481655023014371, -80.4506, -1.40412785520495),
(14450, '32969', 218, 12, 18444, 27.6378, 0.482370608007689, -80.3972, -1.40319584938439),
(14451, '32970', 218, 12, 18463, 27.7505, 0.484337594074686, -80.4466, -1.40405804203487),
(14452, '32971', 218, 12, 18655, 27.713, 0.483683095605189, -80.42, -1.40359378445384),
(14453, '32976', 218, 12, 18022, 27.8772, 0.486548926236963, -80.5174, -1.40529373514528),
(14454, '32978', 218, 12, 18022, 27.7948, 0.48511077493332, -80.4847, -1.40472301247988),
(14455, '33001', 218, 12, 0, 24.824, 0.433260533515072, -80.8155, -1.41049656164548),
(14456, '33002', 218, 12, 16415, 25.8991, 0.452024568303263, -80.3033, -1.40155698521676),
(14457, '33004', 218, 12, 0, 26.0573, 0.454785679179918, -80.1377, -1.39866671997546),
(14458, '33008', 218, 12, 0, 25.9858, 0.453537768764743, -80.1422, -1.3987452597918),
(14459, '33009', 218, 12, 0, 25.9851, 0.453525551459979, -80.1499, -1.3988796501442),
(14460, '33010', 218, 12, 16415, 25.8319, 0.450851707045923, -80.2763, -1.40108574631872),
(14461, '33011', 218, 12, 16415, 25.8246, 0.450724298010528, -80.2833, -1.40120791936636),
(14462, '33012', 218, 12, 16415, 25.8649, 0.451427665699081, -80.2994, -1.40148891737593),
(14463, '33013', 218, 12, 16415, 25.8604, 0.451349125882742, -80.2714, -1.40100022518538),
(14464, '33014', 218, 12, 16415, 25.901, 0.452057729559051, -80.3054, -1.40159363713105),
(14465, '33015', 218, 12, 16415, 25.9397, 0.452733171979573, -80.3146, -1.40175420742224),
(14466, '33016', 218, 12, 16415, 25.8925, 0.451909376572632, -80.3326, -1.4020683666876),
(14467, '33017', 218, 12, 16415, 25.9412, 0.452759351918353, -80.3192, -1.40183449256783),
(14468, '33018', 218, 12, 16415, 25.9259, 0.452492316542798, -80.3736, -1.40278395168091),
(14469, '33019', 218, 12, 3203, 26.0215, 0.454160851307704, -80.1241, -1.39842935519719),
(14470, '33020', 218, 12, 3203, 26.0171, 0.454084056820617, -80.1532, -1.39893724600952),
(14471, '33021', 218, 12, 3203, 26.0258, 0.45423590046554, -80.1881, -1.39954636591847),
(14472, '33022', 218, 12, 3203, 26.0128, 0.454009007662781, -80.1436, -1.39876969440133),
(14473, '33023', 218, 12, 3203, 25.986, 0.453541259423246, -80.2068, -1.39987274248859),
(14474, '33024', 218, 12, 3203, 26.0239, 0.454202739209752, -80.2454, -1.40054643957986),
(14475, '33025', 218, 12, 3203, 25.9852, 0.45352729678923, -80.2814, -1.40117475811058),
(14476, '33026', 218, 12, 3203, 26.0264, 0.454246372441052, -80.2953, -1.4014173588766),
(14477, '33027', 218, 12, 3203, 25.9794, 0.453426067692615, -80.3438, -1.40226384356382),
(14478, '33028', 218, 12, 3203, 26.0166, 0.454075330174357, -80.3429, -1.40224813560055),
(14479, '33029', 218, 12, 3203, 25.9919, 0.453644233849114, -80.4062, -1.40335292901706),
(14480, '33030', 218, 12, 3212, 25.4805, 0.444718620054415, -80.5051, -1.40507905964729),
(14481, '33031', 218, 12, 3212, 25.5263, 0.445517980851829, -80.5031, -1.40504415306225),
(14482, '33032', 218, 12, 3212, 25.5334, 0.44564189922872, -80.377, -1.40284329287548),
(14483, '33033', 218, 12, 3212, 25.4917, 0.444914096930639, -80.4341, -1.40383987587837),
(14484, '33034', 218, 12, 3212, 25.397, 0.443261270129, -80.5151, -1.40525359257249),
(14485, '33035', 218, 12, 3212, 25.3799, 0.442962818826909, -80.4039, -1.40331278644427),
(14486, '33036', 218, 12, 16562, 24.9224, 0.434977937499035, -80.6318, -1.40729039180956),
(14487, '33037', 218, 12, 16718, 25.1328, 0.438650110245231, -80.413, -1.4034716114062),
(14488, '33039', 218, 12, 3212, 25.4995, 0.445050232612294, -80.3939, -1.40313825351907),
(14489, '33040', 218, 12, 16720, 24.564, 0.428722677459887, -81.7634, -1.42704053762513),
(14490, '33041', 218, 12, 16720, 24.5554, 0.428572579144216, -81.8052, -1.42777008525247),
(14491, '33042', 218, 12, 18214, 24.6591, 0.430382485578534, -81.457, -1.42169284879702),
(14492, '33043', 218, 12, 15229, 24.6797, 0.430742023404445, -81.3657, -1.42009936318995),
(14493, '33044', 218, 12, 18207, 24.6664, 0.430509894613929, -81.5614, -1.4235149725361),
(14494, '33045', 218, 12, 16720, 24.5563, 0.428588287107484, -81.8049, -1.42776484926471),
(14495, '33050', 218, 12, 17017, 24.7242, 0.431518694921582, -81.0476, -1.41454747083936),
(14496, '33051', 218, 12, 16717, 24.7215, 0.431471571031778, -81.0203, -1.41407099595356),
(14497, '33052', 218, 12, 17018, 24.7249, 0.431530912226346, -81.0632, -1.41481974220267),
(14498, '33054', 218, 12, 0, 25.9173, 0.452342218227126, -80.2512, -1.40064766867647),
(14499, '33055', 218, 12, 0, 25.9434, 0.452797749161897, -80.2772, -1.40110145428199),
(14500, '33056', 218, 12, 0, 25.947, 0.452860581014969, -80.247, -1.40057436484789),
(14501, '33060', 218, 12, 17690, 26.2289, 0.457780664176341, -80.12, -1.39835779669786),
(14502, '33061', 218, 12, 17690, 26.2354, 0.45789411057772, -80.1204, -1.39836477801486),
(14503, '33062', 218, 12, 17690, 26.2365, 0.457913309199492, -80.0959, -1.39793717234813),
(14504, '33063', 218, 12, 17690, 26.2485, 0.458122748709732, -80.2095, -1.39991986637839),
(14505, '33064', 218, 12, 17690, 26.2783, 0.458642856826826, -80.1131, -1.39823736897947),
(14506, '33065', 218, 12, 17690, 26.2719, 0.458531155754698, -80.2661, -1.40090772273502),
(14507, '33066', 218, 12, 17690, 26.2471, 0.458098314100204, -80.1754, -1.39932470910346),
(14508, '33067', 218, 12, 17690, 26.31, 0.459196126199708, -80.2202, -1.40010661660836),
(14509, '33068', 218, 12, 17690, 26.2164, 0.457562498019841, -80.2163, -1.40003854876753),
(14510, '33069', 218, 12, 17690, 26.2334, 0.45785920399268, -80.1566, -1.39899658720409),
(14511, '33070', 218, 12, 18292, 25.0012, 0.436353256949606, -80.5343, -1.40558869578887),
(14512, '33071', 218, 12, 17690, 26.242, 0.458009302308352, -80.2657, -1.40090074141801),
(14513, '33072', 218, 12, 17690, 26.2324, 0.45784175070016, -80.0924, -1.39787608582431),
(14514, '33073', 218, 12, 17690, 26.3047, 0.459103623749352, -80.1855, -1.39950098735791),
(14515, '33074', 218, 12, 17690, 26.2373, 0.457927271833508, -80.1253, -1.39845029914821),
(14516, '33075', 218, 12, 17690, 26.245, 0.458061662185912, -80.2643, -1.40087630680848),
(14517, '33076', 218, 12, 17690, 26.3032, 0.459077443810572, -80.2717, -1.40100546117313),
(14518, '33077', 218, 12, 17690, 26.2455, 0.458070388832172, -80.2635, -1.40086234417447),
(14519, '33081', 218, 12, 3203, 26.0183, 0.454105000771641, -80.2033, -1.39981165596477),
(14520, '33082', 218, 12, 17569, 26.0167, 0.454077075503609, -80.204, -1.39982387326953),
(14521, '33083', 218, 12, 3203, 26.15, 0.456403599396517, -80.2262, -1.40021133636347),
(14522, '33084', 218, 12, 3203, 26.0273, 0.45426208040432, -80.2456, -1.40054993023836),
(14523, '33090', 218, 12, 3212, 25.4761, 0.444641825567327, -80.5428, -1.40573704877529),
(14524, '33092', 218, 12, 3212, 25.544, 0.445826904129432, -80.4234, -1.40365312564841),
(14525, '33093', 218, 12, 17690, 26.2533, 0.458206524513827, -80.2083, -1.39989892242737),
(14526, '33097', 218, 12, 17690, 26.2372, 0.457925526504256, -80.1325, -1.39857596285436),
(14527, '33101', 218, 12, 17102, 25.779, 0.449928427871618, -80.1977, -1.39971391752666),
(14528, '33102', 218, 12, 17102, 25.7979, 0.450258295100245, -80.3017, -1.40152905994873),
(14529, '33107', 218, 12, 17102, 25.7984, 0.450267021746505, -80.302, -1.40153429593649),
(14530, '33109', 218, 12, 17103, 25.7737, 0.449835925421263, -80.1689, -1.39921126270208),
(14531, '33110', 218, 12, 17102, 25.8515, 0.451193791579314, -80.2078, -1.39989019578111),
(14532, '33111', 218, 12, 17102, 25.7663, 0.449706771056615, -80.1925, -1.39962316040555),
(14533, '33112', 218, 12, 17102, 25.7991, 0.450279239051269, -80.342, -1.40223242763728),
(14534, '33114', 218, 12, 17102, 25.7526, 0.449467660949092, -80.271, -1.40099324386837),
(14535, '33116', 218, 12, 17102, 25.672, 0.448060925571984, -80.3743, -1.40279616898568),
(14536, '33119', 218, 12, 17103, 25.7838, 0.450012203675714, -80.1321, -1.39856898153735),
(14537, '33121', 218, 12, 17102, 25.7662, 0.449705025727363, -80.1918, -1.39961094310079),
(14538, '33122', 218, 12, 17102, 25.7993, 0.450282729709773, -80.3004, -1.40150637066845),
(14539, '33124', 218, 12, 17102, 25.726, 0.449003403368061, -80.2366, -1.40039285060568),
(14540, '33125', 218, 12, 17102, 25.7817, 0.449975551761422, -80.2359, -1.40038063330092),
(14541, '33126', 218, 12, 17102, 25.7769, 0.449891775957326, -80.2896, -1.40131787510924),
(14542, '33127', 218, 12, 17102, 25.8137, 0.45053405712206, -80.2067, -1.39987099715934),
(14543, '33128', 218, 12, 17102, 25.7744, 0.449848142726026, -80.208, -1.39989368643961),
(14544, '33129', 218, 12, 17102, 25.7558, 0.449523511485156, -80.2052, -1.39984481722056),
(14545, '33130', 218, 12, 17102, 25.7683, 0.449741677641655, -80.2034, -1.39981340129402),
(14546, '33131', 218, 12, 17102, 25.766, 0.449701535068859, -80.1913, -1.39960221645453),
(14547, '33132', 218, 12, 17102, 25.7864, 0.450057582236266, -80.1893, -1.39956730986949),
(14548, '33133', 218, 12, 17102, 25.7307, 0.449085433842905, -80.242, -1.40048709838529),
(14549, '33134', 218, 12, 17102, 25.7543, 0.449497331546376, -80.2698, -1.40097229991734),
(14550, '33135', 218, 12, 17102, 25.7659, 0.449699789739607, -80.2375, -1.40040855856895),
(14551, '33136', 218, 12, 17102, 25.7857, 0.450045364931502, -80.2036, -1.39981689195252),
(14552, '33137', 218, 12, 17102, 25.8164, 0.450581181011864, -80.1892, -1.39956556454024),
(14553, '33138', 218, 12, 17102, 25.8524, 0.451209499542582, -80.1837, -1.39946957143138),
(14554, '33139', 218, 12, 17103, 25.7833, 0.450003477029454, -80.135, -1.39861959608566),
(14555, '33140', 218, 12, 17103, 25.8167, 0.45058641699962, -80.1281, -1.39849916836727),
(14556, '33141', 218, 12, 17103, 25.857, 0.451289784688174, -80.1382, -1.39867544662172),
(14557, '33142', 218, 12, 17102, 25.8118, 0.450500895866272, -80.2365, -1.40039110527643),
(14558, '33143', 218, 12, 17102, 25.7033, 0.448607213627858, -80.2979, -1.40146273743715),
(14559, '33144', 218, 12, 17102, 25.7621, 0.449633467228031, -80.3107, -1.40168613958141),
(14560, '33145', 218, 12, 17102, 25.7534, 0.449481623583108, -80.2358, -1.40037888797167),
(14561, '33146', 218, 12, 17102, 25.7191, 0.448882975649674, -80.2721, -1.40101244249014),
(14562, '33147', 218, 12, 17102, 25.8501, 0.451169356969786, -80.236, -1.40038237863017),
(14563, '33148', 218, 12, 17102, 25.8273, 0.450771421900331, -80.3121, -1.40171057419094),
(14564, '33149', 218, 12, 16716, 25.6911, 0.448394283459115, -80.1653, -1.39914843084901),
(14565, '33150', 218, 12, 17102, 25.8509, 0.451183319603802, -80.2075, -1.39988495979335),
(14566, '33151', 218, 12, 17102, 25.8318, 0.450849961716671, -80.2095, -1.39991986637839),
(14567, '33152', 218, 12, 17102, 25.7964, 0.450232115161465, -80.3129, -1.40172453682495),
(14568, '33153', 218, 12, 17102, 25.8652, 0.451432901686837, -80.1934, -1.39963886836882),
(14569, '33154', 218, 12, 17102, 25.8839, 0.45175927825696, -80.1311, -1.39855152824483),
(14570, '33155', 218, 12, 17102, 25.7352, 0.449163973659245, -80.3056, -1.40159712778956),
(14571, '33156', 218, 12, 17102, 25.667, 0.447973659109385, -80.3031, -1.40155349455826),
(14572, '33157', 218, 12, 17102, 25.6065, 0.446917734911928, -80.3463, -1.40230747679512),
(14573, '33158', 218, 12, 17102, 25.6368, 0.447446569675282, -80.3167, -1.40179085933653),
(14574, '33159', 218, 12, 17102, 25.7909, 0.450136122052606, -80.2946, -1.40140514157184),
(14575, '33160', 218, 12, 17309, 25.9359, 0.452666849467997, -80.1355, -1.39862832273192),
(14576, '33161', 218, 12, 17102, 25.8913, 0.451888432621608, -80.1797, -1.3993997582613),
(14577, '33162', 218, 12, 17102, 25.928, 0.45252896845709, -80.1794, -1.39939452227354),
(14578, '33163', 218, 12, 17102, 25.963, 0.453139833695288, -80.1414, -1.39873129715778),
(14579, '33164', 218, 12, 17102, 25.9294, 0.452553403066618, -80.1796, -1.39939801293205),
(14580, '33165', 218, 12, 17102, 25.7328, 0.449122085757197, -80.362, -1.40258149348768),
(14581, '33166', 218, 12, 17102, 25.8275, 0.450774912558835, -80.315, -1.40176118873925),
(14582, '33167', 218, 12, 17102, 25.8865, 0.451804656817512, -80.2309, -1.40029336683832),
(14583, '33168', 218, 12, 17102, 25.892, 0.451900649926372, -80.2091, -1.39991288506138),
(14584, '33169', 218, 12, 17102, 25.9409, 0.452754115930597, -80.2147, -1.4000106234995),
(14585, '33170', 218, 12, 17102, 25.5568, 0.446050306273687, -80.4635, -1.40435300267846),
(14586, '33172', 218, 12, 17102, 25.7932, 0.450176264625401, -80.3624, -1.40258847480469),
(14587, '33173', 218, 12, 17102, 25.7004, 0.448556599079551, -80.3599, -1.40254484157339),
(14588, '33174', 218, 12, 17102, 25.7619, 0.449629976569527, -80.3541, -1.40244361247678),
(14589, '33175', 218, 12, 17102, 25.7319, 0.449106377793929, -80.4105, -1.4034279781749),
(14590, '33176', 218, 12, 17102, 25.6565, 0.447790399537925, -80.3628, -1.4025954561217),
(14591, '33177', 218, 12, 17102, 25.5918, 0.446661171511885, -80.4044, -1.40332151309053),
(14592, '33178', 218, 12, 17102, 25.8348, 0.450902321594231, -80.3885, -1.40304400573946),
(14593, '33179', 218, 12, 17102, 25.9556, 0.45301067933064, -80.1804, -1.39941197556606),
(14594, '33180', 218, 12, 17102, 25.9616, 0.45311539908576, -80.141, -1.39872431584078),
(14595, '33181', 218, 12, 17102, 25.9018, 0.452071692193067, -80.1549, -1.3989669166068),
(14596, '33182', 218, 12, 17102, 25.7804, 0.449952862481146, -80.4184, -1.40356585918581),
(14597, '33183', 218, 12, 17102, 25.7005, 0.448558344408803, -80.4064, -1.40335641967557),
(14598, '33184', 218, 12, 17102, 25.7581, 0.449563654057951, -80.4042, -1.40331802243202),
(14599, '33185', 218, 12, 17102, 25.7316, 0.449101141806173, -80.4629, -1.40434253070295),
(14600, '33186', 218, 12, 17102, 25.6594, 0.447841014086233, -80.407, -1.40336689165108),
(14601, '33187', 218, 12, 17102, 25.5888, 0.446608811634325, -80.4887, -1.40479282564996),
(14602, '33188', 218, 12, 17102, 25.8129, 0.450520094488044, -80.239, -1.40043473850773),
(14603, '33189', 218, 12, 17102, 25.5711, 0.446299888356722, -80.3419, -1.40223068230803),
(14604, '33190', 218, 12, 17102, 25.5562, 0.446039834298175, -80.3366, -1.40213817985768),
(14605, '33192', 218, 12, 17102, 25.7969, 0.450240841807725, -80.3222, -1.40188685244539),
(14606, '33193', 218, 12, 17102, 25.697, 0.448497257884983, -80.4456, -1.40404058874235),
(14607, '33194', 218, 12, 17102, 25.7601, 0.449598560642991, -80.3934, -1.40312952687281),
(14608, '33195', 218, 12, 17102, 25.7662, 0.449705025727363, -80.1913, -1.39960221645453),
(14609, '33196', 218, 12, 17102, 25.6532, 0.447732803672609, -80.4819, -1.40467414326082),
(14610, '33197', 218, 12, 17102, 25.5952, 0.446720512706453, -80.3607, -1.40255880420741),
(14611, '33199', 218, 12, 17102, 25.7576, 0.449554927411691, -80.3744, -1.40279791431493),
(14612, '33231', 218, 12, 17102, 25.7739, 0.449839416079767, -80.194, -1.39964934034433),
(14613, '33233', 218, 12, 17102, 25.7306, 0.449083688513653, -80.2432, -1.40050804233631),
(14614, '33234', 218, 12, 17102, 25.753, 0.4494746422661, -80.2712, -1.40099673452687),
(14615, '33238', 218, 12, 17102, 25.8556, 0.451265350078646, -80.185, -1.39949226071165),
(14616, '33239', 218, 12, 17103, 25.7912, 0.450141358040362, -80.1431, -1.39876096775507),
(14617, '33242', 218, 12, 17102, 25.813, 0.450521839817296, -80.2371, -1.40040157725194),
(14618, '33243', 218, 12, 17102, 25.7028, 0.448598486981599, -80.2992, -1.40148542671743),
(14619, '33245', 218, 12, 17102, 25.7478, 0.449383885144996, -80.2876, -1.4012829685242),
(14620, '33247', 218, 12, 17102, 25.8508, 0.45118157427455, -80.239, -1.40043473850773),
(14621, '33255', 218, 12, 17102, 25.7737, 0.449835925421263, -80.1941, -1.39965108567358),
(14622, '33256', 218, 12, 17102, 25.6624, 0.447893373963793, -80.3252, -1.40193921232295),
(14623, '33257', 218, 12, 17102, 25.6122, 0.447017218679292, -80.349, -1.40235460068492),
(14624, '33261', 218, 12, 17102, 25.8938, 0.451932065852908, -80.1829, -1.39945560879736),
(14625, '33265', 218, 12, 17102, 25.7337, 0.449137793720465, -80.4082, -1.4033878356021),
(14626, '33266', 218, 12, 17102, 25.8273, 0.450771421900331, -80.3124, -1.40171581017869),
(14627, '33269', 218, 12, 17102, 25.9427, 0.452785531857133, -80.2151, -1.4000176048165),
(14628, '33280', 218, 12, 17102, 25.9349, 0.452649396175477, -80.1364, -1.39864403069518),
(14629, '33283', 218, 12, 17102, 25.6979, 0.448512965848251, -80.3822, -1.40293404999659),
(14630, '33296', 218, 12, 17102, 25.6579, 0.447814834147453, -80.3593, -1.40253436959788),
(14631, '33299', 218, 12, 17102, 25.7757, 0.449870832006302, -80.2104, -1.39993557434166),
(14632, '33301', 218, 12, 16083, 26.1208, 0.455893963254935, -80.1291, -1.39851662165979),
(14633, '33302', 218, 12, 16083, 26.0349, 0.454394725427472, -80.1962, -1.39968773758788),
(14634, '33303', 218, 12, 16083, 26.1965, 0.457215177498695, -80.0956, -1.39793193636037),
(14635, '33304', 218, 12, 16083, 26.1375, 0.456185433240018, -80.1245, -1.3984363365142),
(14636, '33305', 218, 12, 16083, 26.1542, 0.456476903225101, -80.1238, -1.39842411920943),
(14637, '33306', 218, 12, 16083, 26.1645, 0.456656672138056, -80.1106, -1.39819373574817),
(14638, '33307', 218, 12, 16083, 26.1798, 0.456923707513612, -80.2758, -1.40107701967246),
(14639, '33308', 218, 12, 16083, 26.1897, 0.457096495109559, -80.1094, -1.39817279179715),
(14640, '33309', 218, 12, 16083, 26.1834, 0.456986539366683, -80.1742, -1.39930376515244),
(14641, '33310', 218, 12, 16083, 26.1649, 0.456663653455064, -80.1705, -1.39923918797011),
(14642, '33311', 218, 12, 16083, 26.1417, 0.456258737068602, -80.1734, -1.39928980251842),
(14643, '33312', 218, 12, 16083, 26.0866, 0.455297060650753, -80.1868, -1.39952367663819),
(14644, '33313', 218, 12, 16083, 26.1483, 0.456373928799233, -80.2271, -1.40022704432674),
(14645, '33314', 218, 12, 16083, 26.0671, 0.454956721446614, -80.2237, -1.40016770313217),
(14646, '33315', 218, 12, 16083, 26.0941, 0.455427960344652, -80.1544, -1.39895818996054),
(14647, '33316', 218, 12, 16083, 26.103, 0.45558329464808, -80.1252, -1.39844855381896),
(14648, '33317', 218, 12, 16083, 26.1278, 0.456016136302574, -80.226, -1.40020784570497),
(14649, '33318', 218, 12, 16083, 26.1183, 0.455850330023635, -80.2521, -1.40066337663974),
(14650, '33319', 218, 12, 16083, 26.1822, 0.456965595415659, -80.2272, -1.40022878965599),
(14651, '33320', 218, 12, 16083, 26.1428, 0.456277935690374, -80.1396, -1.39869988123125),
(14652, '33321', 218, 12, 16083, 26.2072, 0.457401927728658, -80.2658, -1.40090248674726),
(14653, '33322', 218, 12, 16083, 26.1493, 0.456391382091753, -80.2744, -1.40105258506294),
(14654, '33323', 218, 12, 16083, 26.1564, 0.456515300468645, -80.315, -1.40176118873925),
(14655, '33324', 218, 12, 16083, 26.1112, 0.455726411646743, -80.2698, -1.40097229991734),
(14656, '33325', 218, 12, 16083, 26.1105, 0.455714194341979, -80.3186, -1.40182402059232),
(14657, '33326', 218, 12, 16083, 26.1122, 0.455743864939263, -80.3716, -1.40274904509587),
(14658, '33327', 218, 12, 16083, 26.119, 0.455862547328399, -80.4358, -1.40386954647566),
(14659, '33328', 218, 12, 16083, 26.0656, 0.454930541507834, -80.2656, -1.40089899608876),
(14660, '33329', 218, 12, 16083, 26.1123, 0.455745610268515, -80.2754, -1.40107003835546),
(14661, '33330', 218, 12, 16083, 26.0596, 0.454825821752714, -80.3221, -1.40188510711614),
(14662, '33331', 218, 12, 16083, 26.058, 0.454797896484682, -80.3702, -1.40272461048635),
(14663, '33332', 218, 12, 16083, 26.0638, 0.454899125581298, -80.4215, -1.40361996439262),
(14664, '33334', 218, 12, 16083, 26.1802, 0.456930688830619, -80.1357, -1.39863181339042),
(14665, '33335', 218, 12, 16083, 26.1828, 0.456976067391171, -80.1347, -1.3986143600979),
(14666, '33337', 218, 12, 16083, 26.1118, 0.455736883622255, -80.2753, -1.4010682930262),
(14667, '33338', 218, 12, 16083, 26.1397, 0.456223830483562, -80.126, -1.39846251645298),
(14668, '33339', 218, 12, 16083, 26.1655, 0.456674125430576, -80.1145, -1.398261803589),
(14669, '33340', 218, 12, 16083, 26.1443, 0.456304115629154, -80.1737, -1.39929503850618),
(14670, '33345', 218, 12, 16083, 26.1796, 0.456920216855108, -80.275, -1.40106305703845),
(14671, '33346', 218, 12, 16083, 26.1222, 0.455918397864463, -80.1439, -1.39877493038908),
(14672, '33348', 218, 12, 16083, 26.19, 0.457101731097315, -80.1095, -1.3981745371264),
(14673, '33349', 218, 12, 16083, 26.1807, 0.456939415476879, -80.2257, -1.40020260971721),
(14674, '33351', 218, 12, 16083, 26.179, 0.456909744879596, -80.274, -1.40104560374593),
(14675, '33355', 218, 12, 16083, 26.1124, 0.455747355597767, -80.3032, -1.40155523988751),
(14676, '33359', 218, 12, 16083, 26.1811, 0.456946396793887, -80.2256, -1.40020086438796),
(14677, '33388', 218, 12, 16083, 26.1173, 0.455832876731115, -80.2541, -1.40069828322478),
(14678, '33394', 218, 12, 16083, 26.1212, 0.455900944571943, -80.1403, -1.39871209853601),
(14679, '33401', 218, 12, 18558, 26.7085, 0.466151263268906, -80.0657, -1.39741008291402),
(14680, '33402', 218, 12, 18558, 26.7152, 0.466268200328789, -80.0535, -1.39719715274528),
(14681, '33403', 218, 12, 18558, 26.7861, 0.467505638768453, -80.0743, -1.3975601812297),
(14682, '33404', 218, 12, 18558, 26.7793, 0.467386956379317, -80.0718, -1.3975165479984),
(14683, '33405', 218, 12, 18558, 26.6713, 0.465502000787164, -80.0605, -1.39731932579292),
(14684, '33406', 218, 12, 18558, 26.6572, 0.465255909362632, -80.0929, -1.39788481247057),
(14685, '33407', 218, 12, 18558, 26.7605, 0.467058834479943, -80.0857, -1.39775914876442),
(14686, '33408', 218, 12, 17311, 26.8391, 0.46843066327201, -80.0636, -1.39737343099973),
(14687, '33409', 218, 12, 18558, 26.7096, 0.466170461890677, -80.0973, -1.39796160695765),
(14688, '33410', 218, 12, 17488, 26.8439, 0.468514439076106, -80.0878, -1.39779580067871),
(14689, '33411', 218, 12, 18558, 26.7144, 0.466254237694773, -80.22, -1.40010312594985),
(14690, '33412', 218, 12, 18558, 26.7884, 0.467545781341249, -80.2443, -1.40052724095809),
(14691, '33413', 218, 12, 18558, 26.6802, 0.465657335090591, -80.1434, -1.39876620374282),
(14692, '33414', 218, 12, 18558, 26.6598, 0.465301287923184, -80.258, -1.40076635106561),
(14693, '33415', 218, 12, 18558, 26.6615, 0.465330958520468, -80.1271, -1.39848171507475),
(14694, '33416', 218, 12, 18558, 26.6662, 0.465412988995312, -80.0897, -1.3978289619345),
(14695, '33417', 218, 12, 18558, 26.7135, 0.466238529731505, -80.1224, -1.3983996845999),
(14696, '33418', 218, 12, 17488, 26.8551, 0.468709915952329, -80.1463, -1.39881681829113),
(14697, '33419', 218, 12, 18558, 26.7822, 0.467437570927625, -80.0928, -1.39788306714131),
(14698, '33420', 218, 12, 18558, 26.8565, 0.468734350561857, -80.0864, -1.39777136606919),
(14699, '33421', 218, 12, 18558, 26.6822, 0.465692241675631, -80.2081, -1.39989543176886),
(14700, '33422', 218, 12, 18558, 26.7475, 0.466831941677183, -80.1266, -1.39847298842849),
(14701, '33424', 218, 12, 15297, 26.5197, 0.46285608164114, -80.1083, -1.39815359317537),
(14702, '33425', 218, 12, 15297, 26.5188, 0.462840373677872, -80.1285, -1.39850614968428),
(14703, '33426', 218, 12, 15297, 26.5174, 0.462815939068344, -80.0831, -1.39771377020387),
(14704, '33427', 218, 12, 15274, 26.347, 0.459841898022946, -80.0825, -1.39770329822836),
(14705, '33428', 218, 12, 15274, 26.3549, 0.459979779033854, -80.1976, -1.3997121721974),
(14706, '33429', 218, 12, 15274, 26.3517, 0.45992392849779, -80.0844, -1.39773645948415),
(14707, '33430', 218, 12, 15171, 26.684, 0.465723657602167, -80.6694, -1.40794663560831),
(14708, '33431', 218, 12, 15274, 26.3853, 0.46051035912646, -80.0996, -1.39800174953045),
(14709, '33432', 218, 12, 15274, 26.3479, 0.459857605986214, -80.093, -1.39788655779982),
(14710, '33433', 218, 12, 15274, 26.3465, 0.459833171376686, -80.1588, -1.39903498444763),
(14711, '33434', 218, 12, 15274, 26.3819, 0.460451017931892, -80.164, -1.39912574156873),
(14712, '33435', 218, 12, 15297, 26.5257, 0.46296080139626, -80.0676, -1.39744324416981),
(14713, '33436', 218, 12, 15297, 26.5259, 0.462964292054764, -80.1101, -1.39818500910191),
(14714, '33437', 218, 12, 15297, 26.5257, 0.46296080139626, -80.1751, -1.39931947311571),
(14715, '33438', 218, 12, 15416, 26.861, 0.468812890378197, -80.631, -1.40727642917555),
(14716, '33439', 218, 12, 652, 26.8303, 0.468277074297835, -80.6355, -1.40735496899189),
(14717, '33440', 218, 12, 15558, 26.7404, 0.466708023300292, -80.9406, -1.41267996853972),
(14718, '33441', 218, 12, 15763, 26.3092, 0.459182163565692, -80.1026, -1.39805410940801),
(14719, '33442', 218, 12, 15763, 26.308, 0.459161219614668, -80.1424, -1.3987487504503),
(14720, '33443', 218, 12, 15763, 26.322, 0.459405565709947, -80.1195, -1.3983490700516),
(14721, '33444', 218, 12, 15774, 26.46, 0.4618141200777, -80.0793, -1.3976474476923),
(14722, '33445', 218, 12, 15774, 26.4595, 0.46180539343144, -80.1058, -1.39810995994407),
(14723, '33446', 218, 12, 15774, 26.4511, 0.461658785774272, -80.1733, -1.39928805718917),
(14724, '33447', 218, 12, 15774, 26.4612, 0.461835064028724, -80.0699, -1.39748338674261),
(14725, '33448', 218, 12, 15774, 26.4538, 0.461705909664076, -80.2082, -1.39989717709812),
(14726, '33454', 218, 12, 16819, 26.5959, 0.46418602253116, -80.2014, -1.39977849470898),
(14727, '33455', 218, 12, 16456, 27.0752, 0.472551385635969, -80.1425, -1.39875049577956),
(14728, '33458', 218, 12, 16688, 26.9349, 0.470102688695421, -80.117, -1.3983054368203),
(14729, '33459', 218, 12, 16788, 26.6926, 0.465873755917838, -80.8147, -1.41048259901146),
(14730, '33460', 218, 12, 16819, 26.6174, 0.464561268320339, -80.057, -1.3972582392691),
(14731, '33461', 218, 12, 16819, 26.6139, 0.464500181796519, -80.09, -1.39783419792226),
(14732, '33462', 218, 12, 16819, 26.5782, 0.463877099253557, -80.0807, -1.39767188230182),
(14733, '33463', 218, 12, 16819, 26.6105, 0.464440840601951, -80.1344, -1.39860912411014),
(14734, '33464', 218, 12, 15274, 26.5839, 0.463976583020921, -80.0522, -1.397174463465),
(14735, '33465', 218, 12, 16819, 26.5762, 0.463842192668517, -80.0854, -1.39775391277667),
(14736, '33466', 218, 12, 16819, 26.6196, 0.464599665563883, -80.0586, -1.39728616453713),
(14737, '33467', 218, 12, 16819, 26.6083, 0.464402443358407, -80.1748, -1.39931423712795),
(14738, '33468', 218, 12, 16688, 26.9384, 0.470163775219241, -80.1134, -1.39824260496723),
(14739, '33469', 218, 12, 16688, 26.9613, 0.470563455617947, -80.0981, -1.39797556959167),
(14740, '33470', 218, 12, 16957, 26.7206, 0.466362448108397, -80.3034, -1.40155873054601),
(14741, '33471', 218, 12, 17175, 26.8333, 0.468329434175394, -81.1055, -1.41555801647626),
(14742, '33474', 218, 12, 15297, 26.5264, 0.462973018701024, -80.0811, -1.39767886361883),
(14743, '33475', 218, 12, 16456, 27.0416, 0.471964955007299, -80.1208, -1.39837175933187),
(14744, '33476', 218, 12, 17479, 26.8187, 0.468074616104603, -80.6631, -1.40783667986544),
(14745, '33477', 218, 12, 16688, 26.9207, 0.469854851941637, -80.0769, -1.39760555979025),
(14746, '33478', 218, 12, 16688, 26.9225, 0.469886267868173, -80.2178, -1.40006472870631),
(14747, '33480', 218, 12, 17486, 26.7163, 0.466287398950561, -80.048, -1.39710115963642),
(14748, '33481', 218, 12, 15274, 26.3817, 0.460447527273388, -80.1032, -1.39806458138352),
(14749, '33482', 218, 12, 15774, 26.4551, 0.461728598944352, -80.0882, -1.39780278199572),
(14750, '33483', 218, 12, 15774, 26.464, 0.461883933247779, -80.0649, -1.39739612028001),
(14751, '33484', 218, 12, 15774, 26.4568, 0.461758269541636, -80.1346, -1.39861261476865),
(14752, '33486', 218, 12, 15274, 26.3454, 0.459813972754914, -80.115, -1.39827053023526),
(14753, '33487', 218, 12, 15274, 26.4121, 0.460978107365994, -80.0912, -1.39785514187328),
(14754, '33488', 218, 12, 15274, 26.3578, 0.460030393582161, -80.1732, -1.39928631185992),
(14755, '33493', 218, 12, 18121, 26.6702, 0.465482802165392, -80.7159, -1.40875821371049),
(14756, '33496', 218, 12, 15274, 26.4053, 0.460859424976859, -80.1668, -1.39917461078779),
(14757, '33497', 218, 12, 15274, 26.3492, 0.45988029526649, -80.2305, -1.40028638552131),
(14758, '33498', 218, 12, 15274, 26.393, 0.460644749478863, -80.2149, -1.400014114158),
(14759, '33499', 218, 12, 15274, 26.4065, 0.460880368927883, -80.1063, -1.39811868659033),
(14760, '33503', 218, 12, 15092, 27.7799, 0.484850720874773, -82.3131, -1.43663461252334),
(14761, '33508', 218, 12, 7653, 27.927, 0.487418100204456, -82.2934, -1.4362907826607),
(14762, '33509', 218, 12, 7653, 27.8933, 0.486829924246534, -82.3326, -1.43697495172748),
(14763, '33510', 218, 12, 7653, 27.9541, 0.487891084431747, -82.296, -1.43633616122125),
(14764, '33511', 218, 12, 7653, 27.9263, 0.487405882899693, -82.2935, -1.43629252798995),
(14765, '33513', 218, 12, 15386, 28.6646, 0.500291648767167, -82.1133, -1.43314744467786),
(14766, '33514', 218, 12, 1445, 28.6969, 0.500855390115561, -82.0034, -1.43122932782992),
(14767, '33521', 218, 12, 1693, 28.8024, 0.502696712476415, -82.0676, -1.4323498292097),
(14768, '33523', 218, 12, 15716, 28.4001, 0.495675252895642, -82.229, -1.43516679062242),
(14769, '33524', 218, 12, 1911, 28.1817, 0.491863453809286, -82.1583, -1.43393284284126),
(14770, '33525', 218, 12, 15716, 28.3644, 0.49505217035268, -82.2098, -1.43483168740603),
(14771, '33526', 218, 12, 15716, 28.4068, 0.495792189955525, -82.1891, -1.43447040425087),
(14772, '33527', 218, 12, 8583, 27.9835, 0.488404211231833, -82.22, -1.43500971098974),
(14773, '33530', 218, 12, 15836, 27.8989, 0.486927662684646, -82.1622, -1.43400091068209),
(14774, '33534', 218, 12, 16207, 27.8429, 0.485950278303529, -82.372, -1.43766261145277),
(14775, '33537', 218, 12, 16756, 28.4653, 0.496813207567942, -82.1747, -1.43421907683858),
(14776, '33538', 218, 12, 16801, 28.8837, 0.504115665158286, -82.1943, -1.43456116137198),
(14777, '33539', 218, 12, 18703, 28.2501, 0.49305725901765, -82.2988, -1.43638503044031),
(14778, '33540', 218, 12, 18703, 28.2316, 0.492734373106031, -82.1668, -1.43408119582768),
(14779, '33541', 218, 12, 18703, 28.2367, 0.492823384897883, -82.2122, -1.43487357530808),
(14780, '33542', 218, 12, 18703, 28.231, 0.492723901130519, -82.1663, -1.43407246918142),
(14781, '33543', 218, 12, 18703, 28.2194, 0.492521442937288, -82.2834, -1.4361162497355),
(14782, '33544', 218, 12, 18703, 28.2662, 0.493338257027221, -82.358, -1.43741826535749),
(14783, '33547', 218, 12, 16912, 27.8079, 0.485339413065331, -82.1496, -1.43378099919633),
(14784, '33548', 218, 12, 16969, 28.1382, 0.491104235584668, -82.4636, -1.4392613330476),
(14785, '33549', 218, 12, 16969, 28.126, 0.490891305415925, -82.4606, -1.43920897317004),
(14786, '33550', 218, 12, 17006, 27.9765, 0.488282038184194, -82.3065, -1.43651942079271),
(14787, '33556', 218, 12, 14343, 28.125, 0.490873852123405, -82.5881, -1.44143426796633),
(14788, '33558', 218, 12, 16969, 28.1261, 0.490893050745177, -82.4596, -1.43919151987752),
(14789, '33559', 218, 12, 16969, 28.1258, 0.490887814757421, -82.4603, -1.43920373718228),
(14790, '33563', 218, 12, 5106, 28.0134, 0.48892606467818, -82.1335, -1.43350000118676),
(14791, '33564', 218, 12, 5106, 28.0186, 0.489016821799283, -82.0969, -1.43286121068053),
(14792, '33565', 218, 12, 5106, 28.0591, 0.489723680146341, -82.1657, -1.4340619972059),
(14793, '33566', 218, 12, 5106, 28.0128, 0.488915592702668, -82.1343, -1.43351396382078),
(14794, '33567', 218, 12, 5106, 27.9729, 0.488219206331122, -82.151, -1.43380543380586),
(14795, '33568', 218, 12, 5430, 27.8701, 0.486425007860072, -82.3162, -1.43668871773016),
(14796, '33569', 218, 12, 5430, 27.8487, 0.486051507400145, -82.3156, -1.43667824575464),
(14797, '33570', 218, 12, 17879, 27.7126, 0.483676114288181, -82.4205, -1.43850909613999),
(14798, '33571', 218, 12, 18220, 27.684, 0.48317695012211, -82.3385, -1.43707792615335),
(14799, '33572', 218, 12, 15014, 27.7738, 0.484744255790401, -82.3936, -1.4380396025712),
(14800, '33573', 218, 12, 18220, 27.7182, 0.483773852726292, -82.3648, -1.43753694774663),
(14801, '33574', 218, 12, 17907, 28.3326, 0.494497155650545, -82.2747, -1.43596440609058),
(14802, '33575', 218, 12, 17879, 27.7126, 0.483676114288181, -82.4201, -1.43850211482298),
(14803, '33576', 218, 12, 17931, 28.3331, 0.494505882296805, -82.272, -1.43591728220077),
(14804, '33583', 218, 12, 18025, 27.9974, 0.48864681199786, -82.2745, -1.43596091543207),
(14805, '33584', 218, 12, 18025, 27.9912, 0.488538601584237, -82.2873, -1.43618431757633),
(14806, '33585', 218, 12, 6156, 28.6964, 0.500846663469301, -82.0036, -1.43123281848842),
(14807, '33586', 218, 12, 18219, 27.6776, 0.483065249049983, -82.4794, -1.43953709506941),
(14808, '33587', 218, 12, 18266, 27.9779, 0.488306472793722, -82.2, -1.43466064513934),
(14809, '33592', 218, 12, 18337, 28.062, 0.489774294694649, -82.3043, -1.43648102354917),
(14810, '33593', 218, 12, 18375, 28.4589, 0.496701506495814, -82.1976, -1.43461875723729),
(14811, '33594', 218, 12, 18422, 27.9169, 0.487241821950005, -82.2485, -1.43550712982656),
(14812, '33595', 218, 12, 18422, 27.9457, 0.487744476774579, -82.2583, -1.43567817209325),
(14813, '33597', 218, 12, 18520, 28.5825, 0.498858733451279, -82.1719, -1.43417020761953),
(14814, '33598', 218, 12, 18649, 27.6919, 0.483314831133018, -82.3312, -1.43695051711796),
(14815, '33601', 218, 12, 18280, 27.9827, 0.488390248597817, -82.3402, -1.43710759675063),
(14816, '33602', 218, 12, 18280, 27.9579, 0.487957406943323, -82.4593, -1.43918628388976),
(14817, '33603', 218, 12, 18280, 27.9845, 0.488421664524353, -82.4683, -1.43934336352244),
(14818, '33604', 218, 12, 18280, 28.0175, 0.488997623177511, -82.455, -1.43911123473192),
(14819, '33605', 218, 12, 18280, 27.9646, 0.488074344003206, -82.4298, -1.43867141176042),
(14820, '33606', 218, 12, 18280, 27.9371, 0.487594378458908, -82.4655, -1.43929449430338),
(14821, '33607', 218, 12, 18280, 27.9654, 0.488088306637222, -82.514, -1.4401409789906),
(14822, '33608', 218, 12, 18280, 27.844, 0.485969476925301, -82.5134, -1.44013050701509),
(14823, '33609', 218, 12, 18280, 27.9433, 0.487702588872531, -82.5105, -1.44007989246678),
(14824, '33610', 218, 12, 18280, 27.9953, 0.488610160083569, -82.3872, -1.43792790149907),
(14825, '33611', 218, 12, 18280, 27.8915, 0.486798508319998, -82.5056, -1.43999437133343),
(14826, '33612', 218, 12, 18280, 28.0542, 0.489638159012993, -82.4499, -1.43902222294007),
(14827, '33613', 218, 12, 18280, 28.079, 0.490071000667488, -82.4533, -1.43908156413464),
(14828, '33614', 218, 12, 18280, 28.007, 0.488814363606052, -82.5155, -1.44016715892938),
(14829, '33615', 218, 12, 18280, 28.0104, 0.48887370480062, -82.5879, -1.44143077730783),
(14830, '33616', 218, 12, 18280, 27.8715, 0.4864494424696, -82.5199, -1.44024395341647),
(14831, '33617', 218, 12, 18280, 28.0394, 0.489379850283698, -82.3947, -1.43805880119297),
(14832, '33618', 218, 12, 18280, 28.0757, 0.490013404802172, -82.4972, -1.43984776367627),
(14833, '33619', 218, 12, 18280, 27.9316, 0.487498385350048, -82.3751, -1.43771671665958),
(14834, '33620', 218, 12, 18280, 28.0608, 0.489753350743625, -82.412, -1.43836074315357),
(14835, '33621', 218, 12, 18280, 27.846, 0.486004383510341, -82.4819, -1.43958072830071),
(14836, '33622', 218, 12, 18280, 27.9554, 0.487913773712023, -82.4578, -1.43916010395098),
(14837, '33623', 218, 12, 18280, 27.9554, 0.487913773712023, -82.4579, -1.43916184928023),
(14838, '33624', 218, 12, 18280, 28.0743, 0.489988970192644, -82.5241, -1.44031725724505),
(14839, '33625', 218, 12, 18280, 28.0694, 0.489903449059296, -82.5586, -1.44091939583699),
(14840, '33626', 218, 12, 18280, 28.0565, 0.489678301585789, -82.6057, -1.44174144591468),
(14841, '33629', 218, 12, 18280, 27.9211, 0.487315125778589, -82.5081, -1.44003800456473),
(14842, '33630', 218, 12, 18280, 27.9679, 0.488131939868522, -82.5181, -1.44021253748993),
(14843, '33631', 218, 12, 18280, 27.9595, 0.487985332211355, -82.5329, -1.44047084621923),
(14844, '33633', 218, 12, 18280, 27.9747, 0.488250622257658, -82.4856, -1.43964530548303),
(14845, '33634', 218, 12, 18280, 28.0103, 0.488871959471368, -82.5523, -1.44080944009411),
(14846, '33635', 218, 12, 18280, 28.0298, 0.489212298675507, -82.6074, -1.44177111651196),
(14847, '33637', 218, 12, 18280, 28.0305, 0.489224515980271, -82.3657, -1.43755265570989),
(14848, '33647', 218, 12, 18280, 28.1162, 0.49072026314923, -82.3623, -1.43749331451533),
(14849, '33650', 218, 12, 18280, 27.968, 0.488133685197774, -82.5179, -1.44020904683143),
(14850, '33651', 218, 12, 18280, 27.9477, 0.487779383359619, -82.4592, -1.43918453856051),
(14851, '33655', 218, 12, 18280, 27.95, 0.487819525932415, -82.4571, -1.43914788664622),
(14852, '33660', 218, 12, 18280, 27.9313, 0.487493149362292, -82.3749, -1.43771322600108),
(14853, '33661', 218, 12, 18280, 27.9712, 0.488189535733838, -82.3481, -1.43724547776154),
(14854, '33662', 218, 12, 18280, 27.9707, 0.488180809087578, -82.3483, -1.43724896842005),
(14855, '33663', 218, 12, 18280, 27.9603, 0.487999294845371, -82.5304, -1.44042721298793),
(14856, '33664', 218, 12, 18280, 27.9602, 0.487997549516119, -82.5309, -1.44043593963419),
(14857, '33672', 218, 12, 18280, 27.9553, 0.487912028382771, -82.4575, -1.43915486796322),
(14858, '33673', 218, 12, 18280, 27.9939, 0.488585725474041, -82.4602, -1.43920199185303),
(14859, '33674', 218, 12, 18280, 28.0177, 0.489001113836015, -82.4562, -1.43913217868295),
(14860, '33675', 218, 12, 18280, 28.1185, 0.490760405722026, -82.4717, -1.43940270471701),
(14861, '33677', 218, 12, 18280, 27.968, 0.488133685197774, -82.5184, -1.44021777347769),
(14862, '33679', 218, 12, 18280, 27.9516, 0.487847451200447, -82.5087, -1.44004847654025),
(14863, '33680', 218, 12, 18280, 28.0003, 0.488697426546168, -82.3989, -1.43813210502156),
(14864, '33681', 218, 12, 18280, 27.8961, 0.48687879346559, -82.5232, -1.44030154928178),
(14865, '33682', 218, 12, 18280, 28.0548, 0.489648630988505, -82.4597, -1.43919326520677),
(14866, '33684', 218, 12, 18280, 27.9957, 0.488617141400576, -82.4964, -1.43983380104225),
(14867, '33685', 218, 12, 18280, 27.9988, 0.488671246607388, -82.5826, -1.44133827485747),
(14868, '33686', 218, 12, 18280, 27.8685, 0.48639708259204, -82.5273, -1.44037310778112),
(14869, '33687', 218, 12, 18280, 28.0357, 0.489315273101374, -82.3936, -1.4380396025712),
(14870, '33688', 218, 12, 18280, 28.0614, 0.489763822719137, -82.5035, -1.43995771941914),
(14871, '33689', 218, 12, 18280, 27.947, 0.487767166054855, -82.459, -1.439181047902),
(14872, '33690', 218, 12, 18280, 27.9453, 0.487737495457571, -82.514, -1.4401409789906),
(14873, '33694', 218, 12, 18280, 28.0704, 0.489920902351816, -82.4951, -1.43981111176197),
(14874, '33697', 218, 12, 18280, 27.959, 0.487976605565095, -82.4822, -1.43958596428847),
(14875, '33701', 218, 12, 17916, 27.7694, 0.484667461303313, -82.6399, -1.44233834851886),
(14876, '33702', 218, 12, 17916, 27.8445, 0.485978203571561, -82.6425, -1.44238372707941),
(14877, '33703', 218, 12, 17916, 27.8178, 0.485512200661279, -82.6243, -1.44206607715555),
(14878, '33704', 218, 12, 17916, 27.7958, 0.48512822822584, -82.6345, -1.44224410073925),
(14879, '33705', 218, 12, 17916, 27.7415, 0.484180514442007, -82.6414, -1.44236452845764),
(14880, '33706', 218, 12, 17916, 27.7383, 0.484124663905943, -82.7544, -1.4443367505124),
(14881, '33707', 218, 12, 17916, 27.7562, 0.48443707784205, -82.7222, -1.44377475449325),
(14882, '33708', 218, 12, 17916, 27.8139, 0.485444132820451, -82.7969, -1.44507851544449),
(14883, '33709', 218, 12, 17916, 27.8163, 0.485486020722499, -82.7302, -1.44391438083341),
(14884, '33710', 218, 12, 17916, 27.7893, 0.48501478182446, -82.7276, -1.44386900227286),
(14885, '33711', 218, 12, 17916, 27.7495, 0.484320140782167, -82.6883, -1.44318308787683),
(14886, '33712', 218, 12, 17916, 27.7329, 0.484030416126335, -82.6684, -1.44283576735568),
(14887, '33713', 218, 12, 17916, 27.7884, 0.484999073861192, -82.675, -1.44295095908631),
(14888, '33714', 218, 12, 17916, 27.8173, 0.485503474015019, -82.6775, -1.44299459231761),
(14889, '33715', 218, 12, 17916, 27.697, 0.483403842924869, -82.7137, -1.44362640150683),
(14890, '33716', 218, 12, 17916, 27.8726, 0.486468641091371, -82.6392, -1.4423261312141),
(14891, '33728', 218, 12, 17916, 27.8799, 0.486596050126767, -82.6686, -1.44283925801418),
(14892, '33729', 218, 12, 17916, 27.8797, 0.486592559468263, -82.6685, -1.44283751268493),
(14893, '33730', 218, 12, 17916, 27.8249, 0.48563611903817, -82.8297, -1.44565098343915),
(14894, '33731', 218, 12, 17916, 27.7075, 0.483587102496329, -82.6793, -1.44302600824415),
(14895, '33732', 218, 12, 17916, 27.7575, 0.484459767122326, -82.6423, -1.44238023642091),
(14896, '33733', 218, 12, 17916, 27.7716, 0.484705858546857, -82.6763, -1.44297364836659),
(14897, '33734', 218, 12, 17916, 27.8027, 0.485248655944228, -82.6473, -1.44246750288351),
(14898, '33736', 218, 12, 17916, 27.7422, 0.484192731746771, -82.7477, -1.44421981345251),
(14899, '33737', 218, 12, 17916, 27.7446, 0.484234619648819, -82.7205, -1.44374508389597),
(14900, '33738', 218, 12, 17916, 27.8018, 0.48523294798096, -82.802, -1.44516752723634),
(14901, '33740', 218, 12, 17916, 27.7689, 0.484658734657053, -82.7689, -1.44458982325393),
(14902, '33741', 218, 12, 17916, 27.6878, 0.483243272633686, -82.7364, -1.44402259124704),
(14903, '33742', 218, 12, 17916, 27.8446, 0.485979948900813, -82.6471, -1.44246401222501),
(14904, '33743', 218, 12, 17916, 27.7843, 0.484927515361861, -82.7297, -1.44390565418715),
(14905, '33744', 218, 12, 15123, 27.8165, 0.485489511381003, -82.7752, -1.44469977899681),
(14906, '33747', 218, 12, 17916, 27.7706, 0.484688405254337, -82.679, -1.44302077225639),
(14907, '33755', 218, 12, 8122, 27.978, 0.488308218122974, -82.781, -1.44480100809343),
(14908, '33756', 218, 12, 8122, 27.945, 0.487732259469815, -82.7885, -1.44493190778733),
(14909, '33757', 218, 12, 8122, 27.9809, 0.488358832671281, -82.7812, -1.44480449875193),
(14910, '33758', 218, 12, 8122, 27.9768, 0.48828727417195, -82.7496, -1.4442529747083),
(14911, '33759', 218, 12, 8122, 27.9736, 0.488231423635886, -82.7109, -1.44357753228778),
(14912, '33760', 218, 12, 8122, 27.9064, 0.487058562378546, -82.7156, -1.44365956276262),
(14913, '33761', 218, 12, 8122, 28.0275, 0.489172156102711, -82.7224, -1.44377824515176),
(14914, '33762', 218, 12, 8122, 27.8967, 0.486889265441102, -82.6765, -1.44297713902509),
(14915, '33763', 218, 12, 8122, 28.0026, 0.488737569118964, -82.7475, -1.44421632279401),
(14916, '33764', 218, 12, 8122, 27.9379, 0.487608341092924, -82.7457, -1.44418490686747),
(14917, '33765', 218, 12, 8122, 27.9746, 0.488248876928406, -82.7456, -1.44418316153822),
(14918, '33766', 218, 12, 8122, 28.0321, 0.489252441248302, -82.7214, -1.44376079185924),
(14919, '33767', 218, 12, 15556, 27.9801, 0.488344870037265, -82.8158, -1.44540838267312),
(14920, '33769', 218, 12, 8122, 27.9653, 0.48808656130797, -82.8002, -1.44513611130981),
(14921, '33770', 218, 12, 16850, 27.9208, 0.487309889790833, -82.7991, -1.44511691268804),
(14922, '33771', 218, 12, 16850, 27.8998, 0.486943370647914, -82.7579, -1.44439783703622),
(14923, '33772', 218, 12, 5735, 27.8404, 0.485906645072229, -82.7964, -1.44506978879823),
(14924, '33773', 218, 12, 16850, 27.8885, 0.486746148442439, -82.7533, -1.44431755189062),
(14925, '33774', 218, 12, 16850, 27.8787, 0.486575106175743, -82.8264, -1.44559338757383),
(14926, '33775', 218, 12, 5735, 27.8447, 0.485981694230065, -82.7961, -1.44506455281048),
(14927, '33776', 218, 12, 5735, 27.8519, 0.486107357936209, -82.826, -1.44558640625682),
(14928, '33777', 218, 12, 5735, 27.8565, 0.4861876430818, -82.7607, -1.44444670625527),
(14929, '33778', 218, 12, 16850, 27.8826, 0.486643174016571, -82.798, -1.44509771406627),
(14930, '33779', 218, 12, 16850, 27.9091, 0.487105686268349, -82.7595, -1.44442576230425),
(14931, '33780', 218, 12, 17631, 27.8406, 0.485910135730733, -82.7186, -1.44371192264018),
(14932, '33781', 218, 12, 17631, 27.8379, 0.48586301184093, -82.7179, -1.44369970533542),
(14933, '33782', 218, 12, 17631, 27.8601, 0.486250474934872, -82.706, -1.44349201115443),
(14934, '33784', 218, 12, 17916, 27.8179, 0.485513945990531, -82.6781, -1.44300506429312),
(14935, '33785', 218, 12, 16539, 27.8977, 0.486906718733622, -82.8439, -1.44589882019293),
(14936, '33786', 218, 12, 15177, 27.925, 0.487383193619417, -82.8367, -1.44577315648679),
(14937, '33801', 218, 12, 16822, 28.0382, 0.489358906332674, -81.9427, -1.43016991297396),
(14938, '33802', 218, 12, 16822, 28.062, 0.489774294694649, -81.945, -1.43021005554675),
(14939, '33803', 218, 12, 16822, 28.0162, 0.488974933897235, -81.9344, -1.43002505064604),
(14940, '33804', 218, 12, 16822, 28.0788, 0.490067510008984, -81.9534, -1.43035666320392),
(14941, '33805', 218, 12, 16822, 28.0875, 0.490219353653907, -81.9782, -1.43078950485842),
(14942, '33806', 218, 12, 16822, 28.0289, 0.489196590712239, -81.9571, -1.43042124038624),
(14943, '33807', 218, 12, 16822, 27.9534, 0.487878867126983, -81.9921, -1.43103210562444),
(14944, '33809', 218, 12, 16822, 28.1231, 0.490840690867617, -81.9873, -1.43094832982035),
(14945, '33810', 218, 12, 16822, 28.1152, 0.49070280985671, -82.0125, -1.43138815279185),
(14946, '33811', 218, 12, 16822, 27.9638, 0.48806038136919, -82.0066, -1.43128517836598),
(14947, '33813', 218, 12, 16822, 27.968, 0.488133685197774, -81.9337, -1.43001283334128),
(14948, '33815', 218, 12, 16822, 28.0384, 0.489362396991178, -81.9965, -1.43110890011153),
(14949, '33820', 218, 12, 14979, 27.8611, 0.486267928227392, -81.7113, -1.42613122108484),
(14950, '33823', 218, 12, 15052, 28.0724, 0.489955808936856, -81.8036, -1.42774215998443),
(14951, '33825', 218, 12, 15062, 27.6035, 0.481771960074255, -81.5099, -1.42261612797133),
(14952, '33826', 218, 12, 15062, 27.5932, 0.481592191161299, -81.5042, -1.42251664420396),
(14953, '33827', 218, 12, 15070, 27.8313, 0.485747820110298, -81.5335, -1.4230280256748),
(14954, '33830', 218, 12, 15101, 27.8986, 0.48692242669689, -81.8188, -1.42800745003074),
(14955, '33831', 218, 12, 15101, 27.8945, 0.486850868197558, -81.8419, -1.42841062108795),
(14956, '33834', 218, 12, 15294, 27.6261, 0.482166404485205, -81.8321, -1.42823957882125),
(14957, '33835', 218, 12, 694, 27.7836, 0.484915298057097, -81.9151, -1.42968820210041),
(14958, '33836', 218, 12, 1977, 28.1605, 0.491493444007863, -81.6049, -1.42427419076072),
(14959, '33837', 218, 12, 1977, 28.1988, 0.492161905111377, -81.6211, -1.42455693409954),
(14960, '33838', 218, 12, 2134, 28.0204, 0.489048237725819, -81.619, -1.42452028218525),
(14961, '33839', 218, 12, 15848, 27.9795, 0.488334398061753, -81.7572, -1.42693232721151),
(14962, '33840', 218, 12, 15875, 28.0063, 0.488802146301288, -81.9011, -1.42944385600513),
(14963, '33841', 218, 12, 16090, 27.747, 0.484276507550867, -81.7758, -1.42725695845238),
(14964, '33843', 218, 12, 16146, 27.7415, 0.484180514442007, -81.5496, -1.42330902368437),
(14965, '33844', 218, 12, 16320, 28.0986, 0.490413085200879, -81.6127, -1.42441032644238),
(14966, '33845', 218, 12, 16320, 28.1085, 0.490585872796826, -81.6294, -1.42470179642746),
(14967, '33846', 218, 12, 16430, 27.9642, 0.488067362686198, -81.8796, -1.42906861021595);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(14968, '33847', 218, 12, 16482, 27.8185, 0.485524417966043, -81.8281, -1.42816976565117),
(14969, '33848', 218, 12, 16551, 28.2619, 0.493263207869385, -81.5102, -1.42262136395908),
(14970, '33849', 218, 12, 16694, 28.1609, 0.491500425324871, -82.0362, -1.43180179582457),
(14971, '33850', 218, 12, 16764, 28.09, 0.490262986885207, -81.7277, -1.42641745508217),
(14972, '33851', 218, 12, 9935, 28.0446, 0.489470607404802, -81.6234, -1.42459707667234),
(14973, '33852', 218, 12, 16806, 27.2902, 0.476303843527757, -81.3707, -1.42018662965255),
(14974, '33853', 218, 12, 16816, 27.9008, 0.486960823940434, -81.5353, -1.42305944160133),
(14975, '33854', 218, 12, 15997, 27.8568, 0.486192879069556, -81.4124, -1.42091443195063),
(14976, '33855', 218, 12, 16532, 27.8752, 0.486514019651923, -81.4749, -1.42200526273313),
(14977, '33856', 218, 12, 17230, 27.8748, 0.486507038334915, -81.4758, -1.4220209706964),
(14978, '33857', 218, 12, 16944, 27.4253, 0.478661783347201, -81.2253, -1.41764892092015),
(14979, '33858', 218, 12, 16949, 28.2427, 0.492928104653003, -81.5672, -1.42361620163272),
(14980, '33859', 218, 12, 16816, 27.7988, 0.4851805881034, -81.3989, -1.42067881250161),
(14981, '33860', 218, 12, 4454, 27.9003, 0.486952097294174, -81.9972, -1.43112111741629),
(14982, '33862', 218, 12, 16806, 27.2922, 0.476338750112796, -81.3635, -1.42006096594641),
(14983, '33863', 218, 12, 17278, 27.869, 0.4864058092383, -81.8081, -1.42782069980077),
(14984, '33865', 218, 12, 17415, 27.4591, 0.479251704634375, -81.9649, -1.4305573760679),
(14985, '33867', 218, 12, 0, 27.8828, 0.486646664675075, -81.4775, -1.42205064129368),
(14986, '33868', 218, 12, 17686, 28.1954, 0.492102563916809, -81.832, -1.428237833492),
(14987, '33870', 218, 12, 18023, 27.4839, 0.47968454628887, -81.4197, -1.42104184098603),
(14988, '33871', 218, 12, 18023, 27.5015, 0.479991724237221, -81.454, -1.42164048891946),
(14989, '33872', 218, 12, 18023, 27.4632, 0.479323263133707, -81.4823, -1.42213441709778),
(14990, '33873', 218, 12, 18511, 27.5431, 0.48071778120605, -81.8184, -1.42800046871373),
(14991, '33875', 218, 12, 18023, 27.4329, 0.478794428370352, -81.4672, -1.42187087238072),
(14992, '33876', 218, 12, 18023, 27.4392, 0.478904384113228, -81.3568, -1.41994402888652),
(14993, '33877', 218, 12, 6664, 27.9805, 0.488351851354273, -81.6161, -1.42446966763694),
(14994, '33880', 218, 12, 18657, 27.9989, 0.48867299193664, -81.7502, -1.42681015416387),
(14995, '33881', 218, 12, 18657, 28.0444, 0.489467116746298, -81.7247, -1.42636509520461),
(14996, '33882', 218, 12, 18657, 28.0013, 0.488714879838688, -81.6728, -1.42545926932282),
(14997, '33883', 218, 12, 18657, 28.0218, 0.489072672335347, -81.7266, -1.4263982564604),
(14998, '33884', 218, 12, 18657, 27.9968, 0.488636340022348, -81.6808, -1.42559889566298),
(14999, '33885', 218, 12, 18657, 28.0556, 0.489662593622521, -81.7135, -1.42616961832839),
(15000, '33888', 218, 12, 18657, 28.0418, 0.489421738185746, -81.7222, -1.42632146197331),
(15001, '33890', 218, 12, 18705, 27.494, 0.479860824543321, -81.7855, -1.42742625538982),
(15002, '33896', 218, 12, 1977, 28.1979, 0.492146197148109, -81.6208, -1.42455169811179),
(15003, '33897', 218, 12, 1977, 28.1985, 0.492156669123621, -81.6209, -1.42455344344104),
(15004, '33898', 218, 12, 16816, 27.9016, 0.48697478657445, -81.5361, -1.42307340423535),
(15005, '33901', 218, 12, 16091, 26.6285, 0.46475499986731, -81.8673, -1.42885393471795),
(15006, '33902', 218, 12, 16091, 26.6028, 0.464306450249547, -81.8656, -1.42882426412067),
(15007, '33903', 218, 12, 17304, 26.6821, 0.465690496346379, -81.9058, -1.42952588647997),
(15008, '33904', 218, 12, 15426, 26.5982, 0.464226165103956, -81.9517, -1.43032699260664),
(15009, '33905', 218, 12, 16091, 26.6782, 0.465622428505551, -81.7746, -1.42723601450136),
(15010, '33906', 218, 12, 16091, 26.593, 0.464135407982852, -81.8582, -1.42869510975602),
(15011, '33907', 218, 12, 16091, 26.5649, 0.463644970463042, -81.8879, -1.42921347254386),
(15012, '33908', 218, 12, 16091, 26.5058, 0.462613480875113, -81.927, -1.42989589628139),
(15013, '33909', 218, 12, 15426, 26.6749, 0.465564832640235, -81.974, -1.43071620102983),
(15014, '33910', 218, 12, 15426, 26.5504, 0.463391897721502, -82.0227, -1.43156617637555),
(15015, '33911', 218, 12, 16091, 26.6267, 0.464723583940774, -81.9944, -1.43107224819724),
(15016, '33912', 218, 12, 16091, 26.5104, 0.462693766020705, -81.8317, -1.42823259750424),
(15017, '33913', 218, 12, 16091, 26.4942, 0.462411022681882, -81.73, -1.42645759765497),
(15018, '33914', 218, 12, 15426, 26.577, 0.463856155302533, -82.002, -1.43120489322039),
(15019, '33915', 218, 12, 15426, 26.6692, 0.465465348872872, -81.9997, -1.43116475064759),
(15020, '33916', 218, 12, 16091, 26.632, 0.46481608639113, -81.8362, -1.42831113732058),
(15021, '33917', 218, 12, 17304, 26.7045, 0.466081450098826, -81.8533, -1.42860958862267),
(15022, '33918', 218, 12, 17304, 26.6778, 0.465615447188543, -81.8935, -1.42931121098198),
(15023, '33919', 218, 12, 16091, 26.5588, 0.46353850537867, -81.9053, -1.42951715983371),
(15024, '33920', 218, 12, 14980, 26.7079, 0.466140791293394, -81.6329, -1.42476288295128),
(15025, '33921', 218, 12, 15271, 26.7592, 0.467036145199667, -82.2636, -1.43577067454361),
(15026, '33922', 218, 12, 15280, 26.6577, 0.465264636008892, -82.1339, -1.43350698250377),
(15027, '33924', 218, 12, 15430, 26.5183, 0.462831647031612, -82.1918, -1.43451752814068),
(15028, '33927', 218, 12, 15905, 26.9781, 0.470856670932282, -82.1994, -1.43465017316383),
(15029, '33928', 218, 12, 15950, 26.4413, 0.461487743507577, -81.789, -1.42748734191364),
(15030, '33930', 218, 12, 15998, 26.7094, 0.466166971232173, -81.5299, -1.42296519382172),
(15031, '33931', 218, 12, 16092, 26.446, 0.46156977398242, -81.9286, -1.42992382154943),
(15032, '33932', 218, 12, 16092, 26.4503, 0.461644823140256, -81.9331, -1.43000236136577),
(15033, '33935', 218, 12, 136290, 26.7537, 0.466940152090807, -81.4392, -1.42138218019017),
(15034, '33936', 218, 12, 16870, 26.6152, 0.464522871076795, -81.6166, -1.4244783942832),
(15035, '33938', 218, 12, 17219, 27.0113, 0.471436120243944, -82.1604, -1.43396949475555),
(15036, '33944', 218, 12, 17514, 26.9456, 0.470289438925384, -81.3167, -1.41924415185647),
(15037, '33945', 218, 12, 17628, 26.6589, 0.465285579959916, -82.1444, -1.43369024207523),
(15038, '33946', 218, 12, 17646, 26.851, 0.468638357452997, -82.2879, -1.43619478955184),
(15039, '33947', 218, 12, 0, 26.8905, 0.469327762507535, -82.2895, -1.43622271481987),
(15040, '33948', 218, 12, 17703, 26.9827, 0.470936956077874, -82.1453, -1.4337059500385),
(15041, '33949', 218, 12, 17703, 26.9766, 0.470830490993502, -82.0834, -1.43262559123151),
(15042, '33950', 218, 12, 17735, 26.9118, 0.46969951763821, -82.0497, -1.43203741527359),
(15043, '33951', 218, 12, 17735, 26.9329, 0.470067782110381, -81.9865, -1.43093436718633),
(15044, '33952', 218, 12, 17703, 26.9934, 0.471123706307837, -82.0984, -1.43288739061931),
(15045, '33953', 218, 12, 17703, 27.0134, 0.471472772158236, -82.2151, -1.43492418985639),
(15046, '33954', 218, 12, 17703, 27.0251, 0.47167697568072, -82.1186, -1.43323994712822),
(15047, '33955', 218, 12, 17735, 26.8396, 0.46843938991827, -81.9991, -1.43115427867208),
(15048, '33956', 218, 12, 17899, 26.5243, 0.462936366786732, -82.0896, -1.43273380164514),
(15049, '33957', 218, 12, 17970, 26.446, 0.46156977398242, -82.0826, -1.4326116285975),
(15050, '33960', 218, 12, 12548, 27.0913, 0.47283238364554, -81.3984, -1.42067008585535),
(15051, '33965', 218, 12, 16091, 26.6404, 0.464962694048297, -81.8727, -1.42894818249756),
(15052, '33970', 218, 12, 16870, 26.6052, 0.464348338151595, -81.6671, -1.42535978555546),
(15053, '33971', 218, 12, 16870, 26.5973, 0.464210457140688, -81.6997, -1.42592876289161),
(15054, '33972', 218, 12, 16870, 26.6027, 0.464304704920295, -81.6336, -1.42477510025604),
(15055, '33975', 218, 12, 16750, 26.7615, 0.467076287772463, -81.4386, -1.42137170821465),
(15056, '33980', 218, 12, 17703, 26.9819, 0.470922993443858, -82.0603, -1.4322224201743),
(15057, '33981', 218, 12, 17703, 26.9369, 0.470137595280461, -82.233, -1.4352366037925),
(15058, '33982', 218, 12, 17735, 26.9713, 0.470737988543147, -81.964, -1.43054166810463),
(15059, '33983', 218, 12, 17735, 27.0069, 0.471359325756857, -82.0166, -1.43145971129118),
(15060, '33990', 218, 12, 15426, 26.6305, 0.46478990645235, -81.955, -1.43038458847195),
(15061, '33991', 218, 12, 15426, 26.6294, 0.464770707830578, -82.0049, -1.4312555077687),
(15062, '33993', 218, 12, 15426, 26.7129, 0.466228057755993, -82.0258, -1.43162028158236),
(15063, '33994', 218, 12, 16091, 26.6306, 0.464791651781602, -81.8502, -1.42855548341586),
(15064, '34002', 218, 0, 0, 0, 0, 0, 0),
(15065, '34003', 218, 0, 0, 0, 0, 0, 0),
(15066, '34009', 218, 0, 0, 0, 0, 0, 0),
(15067, '34020', 218, 0, 0, 0, 0, 0, 0),
(15068, '34021', 218, 0, 0, 0, 0, 0, 0),
(15069, '34022', 218, 0, 0, 0, 0, 0, 0),
(15070, '34023', 218, 0, 0, 0, 0, 0, 0),
(15071, '34024', 218, 0, 0, 0, 0, 0, 0),
(15072, '34025', 218, 0, 0, 0, 0, 0, 0),
(15073, '34030', 218, 0, 0, 0, 0, 0, 0),
(15074, '34031', 218, 0, 0, 0, 0, 0, 0),
(15075, '34032', 218, 0, 0, 0, 0, 0, 0),
(15076, '34033', 218, 0, 0, 0, 0, 0, 0),
(15077, '34034', 218, 0, 0, 0, 0, 0, 0),
(15078, '34035', 218, 0, 0, 0, 0, 0, 0),
(15079, '34036', 218, 0, 0, 0, 0, 0, 0),
(15080, '34037', 218, 0, 0, 0, 0, 0, 0),
(15081, '34038', 218, 0, 0, 0, 0, 0, 0),
(15082, '34039', 218, 0, 0, 0, 0, 0, 0),
(15083, '34040', 218, 0, 0, 0, 0, 0, 0),
(15084, '34041', 218, 0, 0, 0, 0, 0, 0),
(15085, '34042', 218, 0, 0, 0, 0, 0, 0),
(15086, '34043', 218, 0, 0, 0, 0, 0, 0),
(15087, '34050', 218, 0, 0, 0, 0, 0, 0),
(15088, '34051', 218, 0, 0, 0, 0, 0, 0),
(15089, '34053', 218, 0, 0, 0, 0, 0, 0),
(15090, '34054', 218, 0, 0, 0, 0, 0, 0),
(15091, '34055', 218, 0, 0, 0, 0, 0, 0),
(15092, '34058', 218, 0, 0, 0, 0, 0, 0),
(15093, '34060', 218, 0, 0, 0, 0, 0, 0),
(15094, '34071', 218, 0, 0, 0, 0, 0, 0),
(15095, '34077', 218, 0, 0, 0, 0, 0, 0),
(15096, '34078', 218, 0, 0, 0, 0, 0, 0),
(15097, '34079', 218, 0, 0, 0, 0, 0, 0),
(15098, '34086', 218, 0, 0, 0, 0, 0, 0),
(15099, '34090', 218, 0, 0, 0, 0, 0, 0),
(15100, '34091', 218, 0, 0, 0, 0, 0, 0),
(15101, '34092', 218, 0, 0, 0, 0, 0, 0),
(15102, '34093', 218, 0, 0, 0, 0, 0, 0),
(15103, '34095', 218, 0, 0, 0, 0, 0, 0),
(15104, '34098', 218, 0, 0, 0, 0, 0, 0),
(15105, '34099', 218, 0, 0, 0, 0, 0, 0),
(15106, '34101', 218, 12, 17231, 26.139, 0.456211613178798, -81.7969, -1.42762522292455),
(15107, '34102', 218, 12, 17231, 26.1401, 0.45623081180057, -81.7986, -1.42765489352183),
(15108, '34103', 218, 12, 17231, 26.1892, 0.457087768463299, -81.8057, -1.42777881189873),
(15109, '34104', 218, 12, 17231, 26.1581, 0.456544971065929, -81.7343, -1.4265326468128),
(15110, '34105', 218, 12, 17231, 26.1875, 0.457058097866015, -81.7629, -1.42703181097887),
(15111, '34106', 218, 12, 17231, 26.1383, 0.456199395874034, -81.7971, -1.42762871358305),
(15112, '34107', 218, 12, 18425, 26.2698, 0.458494503840406, -81.7899, -1.42750304987691),
(15113, '34108', 218, 12, 17231, 26.2387, 0.457951706443036, -81.8039, -1.42774739597219),
(15114, '34109', 218, 12, 17231, 26.2378, 0.457935998479768, -81.7642, -1.42705450025915),
(15115, '34110', 218, 12, 17231, 26.3017, 0.459051263871793, -81.7885, -1.42747861526738),
(15116, '34112', 218, 12, 17231, 26.1173, 0.455832876731115, -81.7356, -1.42655533609308),
(15117, '34113', 218, 12, 17231, 26.0602, 0.454836293728226, -81.7438, -1.42669845309174),
(15118, '34114', 218, 12, 17231, 25.9863, 0.453546495411002, -81.5339, -1.4230350069918),
(15119, '34116', 218, 12, 17231, 26.1837, 0.456991775354439, -81.7099, -1.42610678647531),
(15120, '34117', 218, 12, 17231, 26.1444, 0.456305860958406, -81.5233, -1.42285000209109),
(15121, '34119', 218, 12, 17231, 26.2569, 0.458269356366899, -81.7145, -1.42618707162091),
(15122, '34120', 218, 12, 17231, 26.3129, 0.459246740748016, -81.5976, -1.42414678172533),
(15123, '34133', 218, 12, 15286, 26.3844, 0.460494651163192, -81.7097, -1.42610329581681),
(15124, '34134', 218, 12, 15286, 26.3638, 0.460135113337281, -81.8237, -1.42809297116408),
(15125, '34135', 218, 12, 15286, 26.3864, 0.460529557748232, -81.7358, -1.42655882675158),
(15126, '34136', 218, 12, 15286, 26.3853, 0.46051035912646, -81.7101, -1.42611027713382),
(15127, '34137', 218, 12, 1756, 25.9458, 0.452839637063945, -81.3582, -1.41996846349605),
(15128, '34138', 218, 12, 15523, 25.8144, 0.450546274426824, -81.3597, -1.41999464343483),
(15129, '34139', 218, 12, 15961, 25.8598, 0.45133865390723, -81.3809, -1.42036465323625),
(15130, '34140', 218, 12, 16246, 25.9256, 0.452487080555042, -81.6467, -1.42500373838805),
(15131, '34141', 218, 12, 17382, 25.9048, 0.452124052070627, -81.3056, -1.4190504203095),
(15132, '34142', 218, 12, 16526, 26.3304, 0.459552173367115, -81.3148, -1.41921099060069),
(15133, '34143', 218, 12, 16526, 26.4299, 0.461288775972849, -81.4337, -1.42128618708131),
(15134, '34145', 218, 12, 0, 25.9432, 0.452794258503393, -81.7187, -1.42626037544949),
(15135, '34146', 218, 12, 0, 25.9427, 0.452785531857133, -81.7183, -1.42625339413248),
(15136, '34201', 218, 12, 15299, 27.4001, 0.478221960375698, -82.4744, -1.43944982860681),
(15137, '34202', 218, 12, 15299, 27.4752, 0.479532702643946, -82.3942, -1.43805007454671),
(15138, '34203', 218, 12, 15299, 27.4462, 0.479026557160868, -82.5311, -1.44043943029269),
(15139, '34204', 218, 12, 15299, 27.4432, 0.478974197283308, -82.5103, -1.44007640180828),
(15140, '34205', 218, 12, 15299, 27.4819, 0.47964963970383, -82.5857, -1.44139238006428),
(15141, '34206', 218, 12, 15299, 27.4948, 0.479874787177337, -82.5709, -1.44113407133499),
(15142, '34207', 218, 12, 15299, 27.4403, 0.478923582735, -82.576, -1.44122308312684),
(15143, '34208', 218, 12, 15299, 27.4845, 0.479695018264381, -82.5344, -1.44049702615801),
(15144, '34209', 218, 12, 15299, 27.507, 0.48008771734608, -82.6438, -1.44240641635969),
(15145, '34210', 218, 12, 15299, 27.4554, 0.479187127452051, -82.6381, -1.44230693259233),
(15146, '34211', 218, 12, 15299, 27.4716, 0.479469870790874, -82.4118, -1.43835725249506),
(15147, '34212', 218, 12, 15299, 27.472, 0.479476852107882, -82.4119, -1.43835899782432),
(15148, '34215', 218, 12, 15632, 27.4687, 0.479419256242566, -82.6871, -1.4431621439258),
(15149, '34216', 218, 12, 15003, 27.5296, 0.480482161757031, -82.736, -1.44401560993003),
(15150, '34217', 218, 12, 15300, 27.4979, 0.479928892384149, -82.712, -1.44359673090955),
(15151, '34218', 218, 12, 16478, 27.5018, 0.479996960224977, -82.7118, -1.44359324025105),
(15152, '34219', 218, 12, 394, 27.564, 0.481082555019717, -82.4336, -1.438737734272),
(15153, '34220', 218, 12, 4844, 27.5215, 0.480340790087619, -82.578, -1.44125798971188),
(15154, '34221', 218, 12, 4844, 27.5401, 0.48066542132849, -82.5514, -1.44079373213085),
(15155, '34222', 218, 12, 15921, 27.5327, 0.480536266963843, -82.5014, -1.43992106750485),
(15156, '34223', 218, 12, 2297, 27.0131, 0.47146753617048, -82.3809, -1.4378179457562),
(15157, '34224', 218, 12, 2297, 26.9261, 0.469949099721245, -82.3015, -1.43643215433011),
(15158, '34228', 218, 12, 16938, 27.4257, 0.478668764664209, -82.6714, -1.44288812723324),
(15159, '34229', 218, 12, 17460, 27.1849, 0.474466011825406, -82.4847, -1.43962959751977),
(15160, '34230', 218, 12, 17990, 27.3537, 0.477412127602773, -82.4869, -1.43966799476331),
(15161, '34231', 218, 12, 17990, 27.2693, 0.47593906971409, -82.5169, -1.44019159353891),
(15162, '34232', 218, 12, 17990, 27.3219, 0.476857112900639, -82.4763, -1.4394829898626),
(15163, '34233', 218, 12, 17990, 27.2829, 0.476176434492361, -82.4752, -1.43946379124083),
(15164, '34234', 218, 12, 17990, 27.3668, 0.477640765734784, -82.5286, -1.44039579706139),
(15165, '34235', 218, 12, 17990, 27.3627, 0.477569207235452, -82.4821, -1.43958421895922),
(15166, '34236', 218, 12, 17990, 27.3309, 0.477014192533318, -82.548, -1.44073439093628),
(15167, '34237', 218, 12, 17990, 27.3375, 0.47712938426395, -82.513, -1.44012352569808),
(15168, '34238', 218, 12, 17990, 27.2465, 0.475541134644635, -82.4882, -1.43969068404359),
(15169, '34239', 218, 12, 17990, 27.3087, 0.476626729439376, -82.5168, -1.44018984820966),
(15170, '34240', 218, 12, 17990, 27.3218, 0.476855367571387, -82.383, -1.43785459767049),
(15171, '34241', 218, 12, 17990, 27.2801, 0.476127565273305, -82.4069, -1.43827173136172),
(15172, '34242', 218, 12, 17990, 27.2741, 0.476022845518185, -82.5487, -1.44074660824104),
(15173, '34243', 218, 12, 17990, 27.408, 0.478359841386606, -82.5229, -1.44029631329403),
(15174, '34250', 218, 12, 18308, 27.5751, 0.481276286566688, -82.5768, -1.44123704576085),
(15175, '34251', 218, 12, 17224, 27.3368, 0.477117166959186, -82.1958, -1.43458734131076),
(15176, '34260', 218, 12, 16996, 27.4236, 0.478632112749917, -82.5391, -1.44057905663285),
(15177, '34264', 218, 12, 17416, 27.4487, 0.479070190392168, -82.5386, -1.44057032998659),
(15178, '34265', 218, 12, 7137, 27.1877, 0.474514881044462, -81.8073, -1.42780673716676),
(15179, '34266', 218, 12, 7137, 27.198, 0.474694649957418, -81.8455, -1.42847345294102),
(15180, '34267', 218, 12, 16095, 27.0866, 0.472750353170696, -81.9523, -1.43033746458215),
(15181, '34268', 218, 12, 17285, 27.1604, 0.474038406158668, -81.8825, -1.42911922476426),
(15182, '34269', 218, 12, 7137, 27.1692, 0.474191995132843, -81.806, -1.42778404788648),
(15183, '34270', 218, 12, 112263, 27.4033, 0.478277810911762, -82.5396, -1.44058778327911),
(15184, '34272', 218, 12, 14092, 27.1368, 0.473626508455197, -82.4476, -1.43898208036728),
(15185, '34274', 218, 12, 4587, 27.1361, 0.473614291150433, -82.4555, -1.43911996137818),
(15186, '34275', 218, 12, 4587, 27.1372, 0.473633489772205, -82.4505, -1.43903269491558),
(15187, '34276', 218, 12, 17990, 27.336, 0.47710320432517, -82.547, -1.44071693764376),
(15188, '34277', 218, 12, 17990, 27.3358, 0.477099713666666, -82.3249, -1.43684056137508),
(15189, '34278', 218, 12, 17990, 27.3321, 0.477035136484342, -82.5304, -1.44042721298793),
(15190, '34280', 218, 12, 15299, 27.4993, 0.479953326993677, -82.6368, -1.44228424331205),
(15191, '34281', 218, 12, 15299, 27.4878, 0.479752614129697, -82.5795, -1.44128416965066),
(15192, '34282', 218, 12, 15299, 27.44, 0.478918346747244, -82.5826, -1.44133827485747),
(15193, '34284', 218, 12, 12543, 27.0483, 0.472081892067182, -82.41, -1.43832583656853),
(15194, '34285', 218, 12, 12543, 27.0743, 0.472535677672701, -82.4344, -1.43875169690601),
(15195, '34286', 218, 12, 17314, 27.0681, 0.472427467259077, -82.1458, -1.43371467668476),
(15196, '34287', 218, 12, 17314, 27.056, 0.472216282419586, -82.2329, -1.43523485846325),
(15197, '34288', 218, 12, 17314, 27.05, 0.472111562664466, -82.1953, -1.4345786146645),
(15198, '34289', 218, 12, 17314, 27.0499, 0.472109817335214, -82.1947, -1.43456814268898),
(15199, '34292', 218, 12, 12543, 27.1031, 0.473038332497275, -82.4072, -1.43827696734947),
(15200, '34293', 218, 12, 12543, 27.0526, 0.472156941225018, -82.395, -1.43806403718073),
(15201, '34295', 218, 12, 2297, 26.9318, 0.470048583488609, -82.2845, -1.43613544835727),
(15202, '34420', 218, 12, 15180, 29.0461, 0.506950079863525, -82.0396, -1.43186113701914),
(15203, '34421', 218, 12, 15180, 29.0456, 0.506941353217265, -82.0391, -1.43185241037288),
(15204, '34423', 218, 12, 15687, 28.8639, 0.503770089966391, -82.5729, -1.44116897792003),
(15205, '34428', 218, 12, 15687, 28.9594, 0.505436879402046, -82.6258, -1.44209225709433),
(15206, '34429', 218, 12, 15687, 28.8704, 0.503883536367771, -82.5937, -1.44153200640444),
(15207, '34430', 218, 12, 15832, 29.0552, 0.507108904825456, -82.3767, -1.43774464192761),
(15208, '34431', 218, 12, 15832, 29.1408, 0.508602906665164, -82.5118, -1.44010258174706),
(15209, '34432', 218, 12, 15832, 29.0596, 0.507185699312544, -82.3858, -1.43790346688954),
(15210, '34433', 218, 12, 15832, 29.0033, 0.506203078943671, -82.522, -1.44028060533076),
(15211, '34434', 218, 12, 15832, 28.9972, 0.5060966138593, -82.433, -1.43872726229649),
(15212, '34436', 218, 12, 16037, 28.7229, 0.501309175721079, -82.2982, -1.4363745584648),
(15213, '34442', 218, 12, 16410, 28.9307, 0.504935969906724, -82.372, -1.43766261145277),
(15214, '34445', 218, 12, 16461, 28.9164, 0.504686387823688, -82.4569, -1.43914439598771),
(15215, '34446', 218, 12, 16485, 28.7442, 0.501680930851754, -82.5263, -1.4403556544886),
(15216, '34447', 218, 12, 16486, 28.7972, 0.502605955355311, -82.5482, -1.44073788159478),
(15217, '34448', 218, 12, 16485, 28.7741, 0.5022027842981, -82.5929, -1.44151804377042),
(15218, '34449', 218, 12, 16546, 29.1996, 0.509629160265336, -82.7091, -1.44354611636124),
(15219, '34450', 218, 12, 3357, 28.8269, 0.503124318143153, -82.256, -1.43563802952046),
(15220, '34451', 218, 12, 3357, 28.8359, 0.503281397775833, -82.3307, -1.4369417904717),
(15221, '34452', 218, 12, 3357, 28.7789, 0.502286560102196, -82.3935, -1.43803785724195),
(15222, '34453', 218, 12, 3357, 28.8764, 0.503988256122891, -82.3504, -1.43728562033434),
(15223, '34460', 218, 12, 16865, 28.9304, 0.504930733918967, -82.491, -1.43973955326264),
(15224, '34461', 218, 12, 16865, 28.8159, 0.502932331925434, -82.4842, -1.43962087087351),
(15225, '34464', 218, 12, 15219, 28.9119, 0.504607848007349, -82.4643, -1.43927355035236),
(15226, '34465', 218, 12, 15219, 28.937, 0.505045925649599, -82.4517, -1.43905363886661),
(15227, '34470', 218, 12, 17363, 29.1993, 0.50962392427758, -82.0914, -1.43276521757167),
(15228, '34471', 218, 12, 17363, 29.1692, 0.50909858017273, -82.0919, -1.43277394421793),
(15229, '34472', 218, 12, 17363, 29.0921, 0.507752931319442, -81.9885, -1.43096927377137),
(15230, '34473', 218, 12, 17363, 29.0255, 0.506590542037614, -82.1876, -1.43444422431209),
(15231, '34474', 218, 12, 17363, 29.1547, 0.508845507431191, -82.1933, -1.43454370807946),
(15232, '34475', 218, 12, 17363, 29.2261, 0.510091672517115, -82.1607, -1.43397473074331),
(15233, '34476', 218, 12, 17363, 29.0861, 0.507648211564323, -82.1953, -1.4345786146645),
(15234, '34477', 218, 12, 17363, 29.1875, 0.509417975425845, -82.1313, -1.43346160394322),
(15235, '34478', 218, 12, 17363, 29.1871, 0.509410994108837, -82.1402, -1.43361693824665),
(15236, '34479', 218, 12, 17363, 29.2379, 0.51029762136885, -82.0977, -1.43287517331455),
(15237, '34480', 218, 12, 17363, 29.1071, 0.508014730707241, -82.0978, -1.4328769186438),
(15238, '34481', 218, 12, 17363, 29.1311, 0.50843360972772, -82.3302, -1.43693306382544),
(15239, '34482', 218, 12, 17363, 29.2302, 0.510163231016447, -82.3042, -1.43647927821992),
(15240, '34483', 218, 12, 17363, 29.1872, 0.509412739438089, -82.1404, -1.43362042890515),
(15241, '34484', 218, 12, 4828, 28.9237, 0.504813796859084, -82.0399, -1.4318663730069),
(15242, '34487', 218, 12, 16485, 28.7807, 0.502317976028732, -82.6154, -1.44191074285212),
(15243, '34488', 218, 12, 14623, 29.2274, 0.510114361797391, -81.9482, -1.43026590608282),
(15244, '34489', 218, 12, 14623, 29.2269, 0.510105635151131, -81.9487, -1.43027463272908),
(15245, '34491', 218, 12, 6148, 28.9907, 0.50598316745792, -82.0473, -1.43199552737154),
(15246, '34492', 218, 12, 6148, 28.991, 0.505988403445676, -82.0468, -1.43198680072528),
(15247, '34498', 218, 12, 18682, 29.023, 0.506546908806314, -82.7341, -1.44398244867424),
(15248, '34601', 218, 12, 1170, 28.5672, 0.498591698075724, -82.3751, -1.43771671665958),
(15249, '34602', 218, 12, 1170, 28.5017, 0.497448507415668, -82.2942, -1.43630474529472),
(15250, '34603', 218, 12, 1170, 28.5544, 0.498368295931469, -82.3933, -1.43803436658344),
(15251, '34604', 218, 12, 1170, 28.5548, 0.498375277248477, -82.3881, -1.43794360946234),
(15252, '34605', 218, 12, 1170, 28.4974, 0.497373458257832, -82.4536, -1.4390868001224),
(15253, '34606', 218, 12, 719, 28.4667, 0.49683764217747, -82.5958, -1.44156865831873),
(15254, '34607', 218, 12, 719, 28.5058, 0.497520065915, -82.6346, -1.44224584606851),
(15255, '34608', 218, 12, 719, 28.4821, 0.497106422882277, -82.5547, -1.44085132799616),
(15256, '34609', 218, 12, 719, 28.4796, 0.497062789650977, -82.4997, -1.43989139690757),
(15257, '34610', 218, 12, 719, 28.3975, 0.49562987433509, -82.538, -1.44055985801108),
(15258, '34611', 218, 12, 719, 28.4826, 0.497115149528537, -82.562, -1.44097873703156),
(15259, '34613', 218, 12, 1170, 28.5482, 0.498260085517845, -82.5294, -1.44040975969541),
(15260, '34614', 218, 12, 1170, 28.6248, 0.499597007724873, -82.5179, -1.44020904683143),
(15261, '34636', 218, 12, 16571, 28.6588, 0.500190419670551, -82.2742, -1.43595567944432),
(15262, '34639', 218, 12, 16842, 28.2279, 0.492669795923707, -82.4509, -1.43903967623259),
(15263, '34652', 218, 12, 17263, 28.237, 0.492828620885639, -82.7292, -1.44389692754089),
(15264, '34653', 218, 12, 17263, 28.247, 0.493003153810838, -82.6987, -1.44336460211903),
(15265, '34654', 218, 12, 17263, 28.3017, 0.493957848911679, -82.6327, -1.44221268481272),
(15266, '34655', 218, 12, 17263, 28.2103, 0.492362617975356, -82.6824, -1.44308011345096),
(15267, '34656', 218, 12, 17263, 28.2425, 0.492924613994499, -82.7106, -1.44357229630002),
(15268, '34660', 218, 12, 17470, 28.0677, 0.489873778462012, -82.7793, -1.44477133749614),
(15269, '34661', 218, 12, 17284, 28.6453, 0.499954800221532, -82.2628, -1.43575671190959),
(15270, '34667', 218, 12, 16505, 28.3924, 0.495540862543238, -82.6535, -1.44257571329713),
(15271, '34668', 218, 12, 17712, 28.3069, 0.494048606032783, -82.7024, -1.44342917930136),
(15272, '34669', 218, 12, 16505, 28.3521, 0.494837494854684, -82.6262, -1.44209923841134),
(15273, '34673', 218, 12, 17712, 28.2737, 0.493469156721121, -82.7195, -1.44372763060345),
(15274, '34674', 218, 12, 16505, 28.3575, 0.494931742634292, -82.6994, -1.4433768194238),
(15275, '34677', 218, 12, 17410, 28.0469, 0.489510749977598, -82.6868, -1.44315690793805),
(15276, '34679', 218, 12, 15025, 28.428, 0.496162199756948, -82.6625, -1.44273279292981),
(15277, '34680', 218, 12, 15917, 28.2102, 0.492360872646104, -82.7089, -1.44354262570274),
(15278, '34681', 218, 12, 15680, 28.0889, 0.490243788263435, -82.7779, -1.44474690288661),
(15279, '34682', 218, 12, 17495, 28.0781, 0.49005529270422, -82.7637, -1.44449906613283),
(15280, '34683', 218, 12, 17495, 28.0764, 0.490025622106936, -82.7578, -1.44439609170696),
(15281, '34684', 218, 12, 17495, 28.0788, 0.490067510008984, -82.7272, -1.44386202095585),
(15282, '34685', 218, 12, 17495, 28.0984, 0.490409594542375, -82.6937, -1.44327733565644),
(15283, '34688', 218, 12, 18289, 28.1479, 0.491273532522112, -82.7562, -1.44436816643893),
(15284, '34689', 218, 12, 18289, 28.1434, 0.491194992705772, -82.746, -1.44419014285523),
(15285, '34690', 218, 12, 16462, 28.1914, 0.492032750746729, -82.7282, -1.44387947424837),
(15286, '34691', 218, 12, 16462, 28.1915, 0.492034496075981, -82.7555, -1.44435594913417),
(15287, '34695', 218, 12, 17889, 28.006, 0.488796910313532, -82.6964, -1.44332445954624),
(15288, '34697', 218, 12, 15828, 28.0257, 0.489140740176175, -82.7637, -1.44449906613283),
(15289, '34698', 218, 12, 15828, 28.0235, 0.489102342932631, -82.7686, -1.44458458726618),
(15290, '34705', 218, 12, 15041, 28.7079, 0.50104737633328, -81.7395, -1.42662340393391),
(15291, '34711', 218, 12, 13559, 28.5333, 0.498000031459298, -81.7624, -1.42702308433261),
(15292, '34712', 218, 12, 13559, 28.5508, 0.498305464078397, -81.7581, -1.42694803517478),
(15293, '34713', 218, 12, 13559, 28.5494, 0.498281029468869, -81.7735, -1.42721681587958),
(15294, '34729', 218, 12, 8879, 28.6217, 0.499542902518061, -81.7121, -1.42614518371886),
(15295, '34731', 218, 12, 16150, 28.8654, 0.503796269905171, -81.8998, -1.42942116672485),
(15296, '34734', 218, 12, 16251, 28.5268, 0.497886585057918, -81.5234, -1.42285174742035),
(15297, '34736', 218, 12, 16295, 28.5728, 0.498689436513836, -81.8657, -1.42882600944992),
(15298, '34737', 218, 12, 16502, 28.7069, 0.50102992304076, -81.7879, -1.42746814329187),
(15299, '34739', 218, 12, 16700, 27.8573, 0.486201605715816, -80.976, -1.41329781509493),
(15300, '34740', 218, 12, 16725, 28.5466, 0.498232160249813, -81.6504, -1.42506831557038),
(15301, '34741', 218, 12, 16740, 28.3079, 0.494066059325303, -81.4214, -1.42107151158331),
(15302, '34742', 218, 12, 16740, 28.2979, 0.493891526400103, -81.3513, -1.41984803577766),
(15303, '34743', 218, 12, 16740, 28.3291, 0.494436069126726, -81.3576, -1.41995799152054),
(15304, '34744', 218, 12, 16740, 28.3002, 0.493931668972899, -81.3487, -1.41980265721711),
(15305, '34745', 218, 12, 16740, 28.3038, 0.493994500825971, -81.4105, -1.42088127069484),
(15306, '34746', 218, 12, 16740, 28.2589, 0.493210847991826, -81.4617, -1.42177487927186),
(15307, '34747', 218, 12, 16740, 28.2969, 0.493874073107583, -81.6163, -1.42447315829545),
(15308, '34748', 218, 12, 3721, 28.8068, 0.502773506963503, -81.8838, -1.42914191404453),
(15309, '34749', 218, 12, 3721, 28.8103, 0.502834593487322, -81.8784, -1.42904766626493),
(15310, '34753', 218, 12, 17047, 28.5799, 0.498813354890727, -81.8956, -1.42934786289627),
(15311, '34755', 218, 12, 17145, 28.5783, 0.498785429622695, -81.7494, -1.42679619152985),
(15312, '34756', 218, 12, 17172, 28.5959, 0.499092607571047, -81.6813, -1.42560762230924),
(15313, '34758', 218, 12, 16740, 28.2001, 0.492184594391653, -81.5019, -1.42247650163117),
(15314, '34759', 218, 12, 16740, 28.144, 0.491205464681284, -81.4543, -1.42164572490722),
(15315, '34760', 218, 12, 4710, 28.5554, 0.498385749223989, -81.6342, -1.42478557223156),
(15316, '34761', 218, 12, 17385, 28.5818, 0.498846516146515, -81.5387, -1.4231187827959),
(15317, '34762', 218, 12, 17390, 28.7501, 0.501783905277622, -81.8846, -1.42915587667855),
(15318, '34769', 218, 12, 17896, 28.2475, 0.493011880457098, -81.2956, -1.4188758873843),
(15319, '34770', 218, 12, 17896, 28.1661, 0.491591182445975, -81.2861, -1.41871008110536),
(15320, '34771', 218, 12, 17896, 28.2878, 0.493715248145652, -81.2136, -1.41744471739767),
(15321, '34772', 218, 12, 17896, 28.1261, 0.490893050745177, -81.242, -1.41794039090523),
(15322, '34773', 218, 12, 17896, 28.0618, 0.489770804036145, -81.0509, -1.41460506670467),
(15323, '34777', 218, 12, 18656, 28.4878, 0.497205906649641, -81.6054, -1.42428291740698),
(15324, '34778', 218, 12, 18656, 28.4979, 0.497382184904092, -81.6166, -1.4244783942832),
(15325, '34785', 218, 12, 6816, 28.8627, 0.503749146015367, -82.0415, -1.43189429827493),
(15326, '34786', 218, 12, 18651, 28.4991, 0.497403128855116, -81.5299, -1.42296519382172),
(15327, '34787', 218, 12, 18656, 28.5339, 0.49801050343481, -81.5915, -1.42404031664095),
(15328, '34788', 218, 12, 3721, 28.8555, 0.503623482309224, -81.7772, -1.42728139306191),
(15329, '34789', 218, 12, 3721, 28.8083, 0.502799686902282, -81.8822, -1.4291139887765),
(15330, '34797', 218, 12, 18678, 28.7415, 0.50163380696195, -81.8179, -1.42799174206747),
(15331, '34945', 218, 12, 16098, 27.4262, 0.478677491310469, -80.4514, -1.40414181783897),
(15332, '34946', 218, 12, 16098, 27.4824, 0.47965836635009, -80.3547, -1.40245408445229),
(15333, '34947', 218, 12, 16098, 27.4485, 0.479066699733664, -80.371, -1.40273857312036),
(15334, '34948', 218, 12, 16098, 27.4478, 0.4790544824289, -80.3412, -1.40221846500327),
(15335, '34949', 218, 12, 16098, 27.4777, 0.479576335875246, -80.3014, -1.40152382396097),
(15336, '34950', 218, 12, 16098, 27.4411, 0.478937545369016, -80.3431, -1.40225162625906),
(15337, '34951', 218, 12, 16098, 27.5345, 0.480567682890379, -80.3989, -1.40322551998167),
(15338, '34952', 218, 12, 17716, 27.2913, 0.476323042149528, -80.3062, -1.40160759976507),
(15339, '34953', 218, 12, 17716, 27.2577, 0.475736611520858, -80.3865, -1.40300909915442),
(15340, '34954', 218, 12, 16098, 27.4467, 0.479035283807128, -80.3374, -1.40215214249169),
(15341, '34956', 218, 12, 16543, 27.0328, 0.471811366033123, -80.469, -1.40444899578732),
(15342, '34957', 218, 12, 16613, 27.2347, 0.4753351857929, -80.2312, -1.40029860282607),
(15343, '34958', 218, 12, 16613, 27.1911, 0.47457422223903, -80.1965, -1.39969297357563),
(15344, '34972', 218, 12, 17396, 27.3244, 0.476900746131939, -80.8495, -1.41108997359116),
(15345, '34973', 218, 12, 17396, 27.247, 0.475549861290895, -80.8311, -1.41076883300879),
(15346, '34974', 218, 12, 17396, 27.2251, 0.475167634184708, -80.8081, -1.41036740728083),
(15347, '34979', 218, 12, 16098, 27.4472, 0.479044010453388, -80.3371, -1.40214690650394),
(15348, '34981', 218, 12, 16098, 27.4066, 0.478335406777078, -80.3623, -1.40258672947544),
(15349, '34982', 218, 12, 16098, 27.3923, 0.478085824694043, -80.3338, -1.40208931063862),
(15350, '34983', 218, 12, 17716, 27.3082, 0.476618002793116, -80.3495, -1.40236332733118),
(15351, '34984', 218, 12, 17716, 27.2747, 0.476033317493697, -80.3459, -1.40230049547811),
(15352, '34985', 218, 12, 17716, 27.2941, 0.476371911368584, -80.3506, -1.40238252595296),
(15353, '34986', 218, 12, 17716, 27.3194, 0.476813479669339, -80.417, -1.40354142457628),
(15354, '34987', 218, 12, 17716, 27.3071, 0.476598804171344, -80.4558, -1.40421861232605),
(15355, '34988', 218, 12, 17716, 27.3414, 0.477197452104778, -80.5179, -1.40530246179154),
(15356, '34990', 218, 12, 17492, 27.167, 0.4741535978893, -80.2933, -1.40138245229156),
(15357, '34991', 218, 12, 17492, 27.1611, 0.474050623463432, -80.2685, -1.40094961063707),
(15358, '34992', 218, 12, 17717, 27.1425, 0.473725992222561, -80.2061, -1.39986052518382),
(15359, '34994', 218, 12, 12169, 27.1992, 0.474715593908442, -80.2543, -1.40070177388329),
(15360, '34995', 218, 12, 12169, 27.1634, 0.474090766036228, -80.2343, -1.40035270803289),
(15361, '34996', 218, 12, 12169, 27.1944, 0.474631818104346, -80.2092, -1.39991463039064),
(15362, '34997', 218, 12, 12169, 27.1389, 0.473663160369489, -80.2148, -1.40001236882875),
(15363, '35004', 218, 2, 4301, 33.5952, 0.586346852865999, -86.495, -1.5096225365125),
(15364, '35005', 218, 2, 13260, 33.591, 0.586273549037415, -86.9621, -1.51777496944856),
(15365, '35006', 218, 2, 79493, 33.4442, 0.583711405695488, -87.1859, -1.52168101631452),
(15366, '35007', 218, 2, 112705, 33.2403, 0.580152679350671, -86.8242, -1.51536816041006),
(15367, '35010', 218, 2, 112720, 32.9393, 0.574899238302168, -85.9506, -1.50012096406464),
(15368, '35011', 218, 2, 112720, 32.9271, 0.574686308133425, -85.9335, -1.49982251276255),
(15369, '35013', 218, 2, 112738, 33.9652, 0.592804571098378, -86.3794, -1.50760493589719),
(15370, '35014', 218, 2, 7073, 33.3307, 0.581730456994474, -86.1847, -1.50420677984356),
(15371, '35015', 218, 2, 14977, 33.5792, 0.58606760018568, -86.6373, -1.51210614003808),
(15372, '35016', 218, 2, 53210, 34.3222, 0.599035396527998, -86.4971, -1.50965918842679),
(15373, '35019', 218, 2, 84784, 34.2641, 0.598021360232589, -86.8462, -1.5157521328455),
(15374, '35020', 218, 2, 418, 33.4072, 0.58306563387225, -86.951, -1.51758123790159),
(15375, '35021', 218, 2, 418, 33.4335, 0.583524655465524, -86.9033, -1.51674871584839),
(15376, '35022', 218, 2, 418, 33.3422, 0.581931169858453, -86.9624, -1.51778020543632),
(15377, '35023', 218, 2, 418, 33.4123, 0.583154645664101, -87.0082, -1.51857956623373),
(15378, '35031', 218, 2, 945, 34.0827, 0.594855332969471, -86.5955, -1.51137659241075),
(15379, '35032', 218, 2, 1038, 33.2608, 0.58051047184733, -86.3383, -1.50688760557462),
(15380, '35033', 218, 2, 1103, 33.9535, 0.592600367575895, -87.0054, -1.51853069701467),
(15381, '35034', 218, 2, 649, 32.9321, 0.574773574596025, -87.1731, -1.52145761417027),
(15382, '35035', 218, 2, 1137, 33.0699, 0.577178638305273, -86.929, -1.51719726546615),
(15383, '35036', 218, 2, 1167, 33.6347, 0.587036257920537, -86.9181, -1.51700702457768),
(15384, '35038', 218, 2, 1252, 33.9077, 0.591801006778481, -87.3164, -1.52395867098838),
(15385, '35040', 218, 2, 1293, 33.1547, 0.578658677510964, -86.7172, -1.51350065811043),
(15386, '35041', 218, 2, 1353, 33.647, 0.587250933418532, -86.9318, -1.51724613468521),
(15387, '35042', 218, 2, 1472, 32.9523, 0.575126131104928, -87.1395, -1.5208711835416),
(15388, '35043', 218, 2, 1509, 33.3206, 0.581554178740023, -86.6474, -1.51228241829253),
(15389, '35044', 218, 2, 1551, 33.2795, 0.580836848417453, -86.353, -1.50714416897466),
(15390, '35045', 218, 2, 1589, 32.8418, 0.573197542281474, -86.633, -1.51203109088025),
(15391, '35046', 218, 2, 1589, 32.8396, 0.57315914503793, -86.6244, -1.51188099256458),
(15392, '35048', 218, 2, 1601, 33.7357, 0.588799040465051, -86.5689, -1.51091233482972),
(15393, '35049', 218, 2, 1620, 33.9697, 0.592883110914718, -86.5996, -1.51144815091008),
(15394, '35051', 218, 2, 1717, 33.1818, 0.579131661738254, -86.6076, -1.51158777725024),
(15395, '35052', 218, 2, 0, 33.5891, 0.586240387781627, -86.3926, -1.50783531935845),
(15396, '35053', 218, 2, 1859, 34.0744, 0.594710470641556, -87.057, -1.5194312869087),
(15397, '35054', 218, 2, 1896, 33.5056, 0.584783037856212, -86.2943, -1.50611966070374),
(15398, '35055', 218, 2, 1914, 34.1767, 0.596495942466346, -86.8448, -1.51572769823597),
(15399, '35056', 218, 2, 1914, 34.1807, 0.596565755636426, -86.8486, -1.51579402074755),
(15400, '35057', 218, 2, 1914, 34.2141, 0.597148695606592, -86.866, -1.51609770803739),
(15401, '35058', 218, 2, 1914, 34.1745, 0.596457545222802, -86.8438, -1.51571024494345),
(15402, '35060', 218, 2, 2056, 33.5587, 0.585709807689021, -86.9288, -1.51719377480765),
(15403, '35061', 218, 2, 2070, 33.464, 0.584056980887382, -86.9586, -1.51771388292474),
(15404, '35062', 218, 2, 746, 33.7274, 0.588654178137136, -87.0056, -1.51853418767318),
(15405, '35063', 218, 2, 2294, 33.8023, 0.589961429746879, -86.9417, -1.51741892228115),
(15406, '35064', 218, 2, 2367, 33.4768, 0.584280383031638, -86.9196, -1.51703320451646),
(15407, '35068', 218, 2, 2632, 33.6113, 0.58662785087557, -86.8133, -1.51517791952159),
(15408, '35070', 218, 2, 2657, 34.0146, 0.593666763748863, -86.7506, -1.51408359808059),
(15409, '35071', 218, 2, 2659, 33.6688, 0.587631415195467, -86.8256, -1.51539259501959),
(15410, '35072', 218, 2, 2778, 33.0636, 0.577068682562397, -86.0436, -1.50174412026899),
(15411, '35073', 218, 2, 2830, 33.6247, 0.586861724995337, -86.9616, -1.5177662428023),
(15412, '35074', 218, 2, 2850, 33.225, 0.579885643975116, -87.1262, -1.52063905475108),
(15413, '35077', 218, 2, 2959, 34.0647, 0.594541173704112, -86.7594, -1.51423718705477),
(15414, '35078', 218, 2, 2986, 33.3389, 0.581873573993138, -86.4547, -1.50891916882394),
(15415, '35079', 218, 2, 3019, 33.8866, 0.59143274230631, -86.8069, -1.51506621844947),
(15416, '35080', 218, 2, 3052, 33.3061, 0.581301105998483, -86.8163, -1.51523027939915),
(15417, '35082', 218, 2, 3194, 33.1157, 0.577977999102686, -86.1079, -1.50286636697803),
(15418, '35083', 218, 2, 3199, 34.1845, 0.596632078148002, -86.6181, -1.5117710368217),
(15419, '35085', 218, 2, 3414, 32.9889, 0.575764921611157, -86.6772, -1.51280252640963),
(15420, '35087', 218, 2, 947, 34.2739, 0.598192402499285, -86.5486, -1.51055803299156),
(15421, '35089', 218, 2, 3496, 32.9671, 0.575384439834223, -85.9644, -1.50036181950141),
(15422, '35091', 218, 2, 3526, 33.768, 0.589362781813445, -86.81, -1.51512032365628),
(15423, '35094', 218, 2, 3719, 33.5395, 0.585374704472638, -86.5573, -1.51070987663649),
(15424, '35096', 218, 2, 3781, 33.5948, 0.586339871548991, -86.1298, -1.50324859408421),
(15425, '35097', 218, 2, 3840, 33.9027, 0.591713740315882, -86.6219, -1.51183735933328),
(15426, '35098', 218, 2, 3843, 34.1825, 0.596597171562962, -87.0406, -1.51914505291138),
(15427, '35111', 218, 2, 4070, 33.2671, 0.580620427590206, -87.1458, -1.52098113928447),
(15428, '35112', 218, 2, 3991, 33.6863, 0.587936847814566, -86.4746, -1.50926648934509),
(15429, '35114', 218, 2, 4056, 33.2414, 0.580171877972443, -86.8611, -1.51601218690405),
(15430, '35115', 218, 2, 4288, 33.1203, 0.578058284248278, -86.8513, -1.51584114463735),
(15431, '35116', 218, 2, 4333, 33.7432, 0.588929940158951, -86.7734, -1.51448153315005),
(15432, '35117', 218, 2, 590, 33.6683, 0.587622688549207, -86.8665, -1.51610643468365),
(15433, '35118', 218, 2, 4457, 33.537, 0.585331071241338, -87.0273, -1.51891292412086),
(15434, '35119', 218, 2, 4520, 33.6453, 0.587221262821248, -86.7725, -1.51446582518678),
(15435, '35120', 218, 2, 4736, 33.6682, 0.587620943219955, -86.4304, -1.50849505381571),
(15436, '35121', 218, 2, 4795, 33.9473, 0.592492157162271, -86.4685, -1.50916002426072),
(15437, '35123', 218, 2, 4841, 33.7475, 0.589004989316786, -86.6437, -1.51221784111021),
(15438, '35124', 218, 2, 4936, 33.3145, 0.581447713655651, -86.8055, -1.51504178383994),
(15439, '35125', 218, 2, 4939, 33.5734, 0.585966371089064, -86.2768, -1.50581422808464),
(15440, '35126', 218, 2, 5092, 33.7158, 0.588451719943904, -86.6588, -1.51248138582726),
(15441, '35127', 218, 2, 5115, 33.4905, 0.584519493139161, -86.9758, -1.51801407955608),
(15442, '35128', 218, 2, 4939, 33.5858, 0.586182791916312, -86.2862, -1.50597828903433),
(15443, '35130', 218, 2, 5264, 33.5742, 0.58598033372308, -87.1666, -1.52134416776889),
(15444, '35131', 218, 2, 5274, 33.9512, 0.592560225003099, -86.4824, -1.50940262502674),
(15445, '35133', 218, 2, 5350, 33.8206, 0.590280824999994, -86.6216, -1.51183212334552),
(15446, '35135', 218, 2, 5423, 33.6022, 0.586469025913639, -86.1973, -1.50442669132931),
(15447, '35136', 218, 2, 5475, 32.8642, 0.57358849603392, -86.2719, -1.5057287069513),
(15448, '35137', 218, 2, 5602, 33.2158, 0.579725073683933, -86.7916, -1.51479918307391),
(15449, '35139', 218, 2, 5677, 33.712, 0.588385397432328, -86.9752, -1.51800360758057),
(15450, '35142', 218, 2, 5777, 33.4046, 0.583020255311698, -86.8746, -1.51624780635307),
(15451, '35143', 218, 2, 59, 33.1008, 0.577717945044139, -86.5019, -1.50974296423088),
(15452, '35144', 218, 2, 5854, 33.232, 0.580007817022756, -86.8251, -1.51538386837333),
(15453, '35146', 218, 2, 6035, 33.7775, 0.589528588092385, -86.4551, -1.50892615014095),
(15454, '35147', 218, 2, 6078, 33.4265, 0.583402482417885, -86.5099, -1.50988259057104),
(15455, '35148', 218, 2, 6143, 33.7527, 0.58909574643789, -87.0505, -1.51931784050732),
(15456, '35149', 218, 2, 6199, 33.2531, 0.580376081494926, -86.2056, -1.50457155365722),
(15457, '35150', 218, 2, 6201, 33.1769, 0.579046140604907, -86.2536, -1.50540931169818),
(15458, '35151', 218, 2, 6201, 33.176, 0.579030432641639, -86.2612, -1.50554195672133),
(15459, '35160', 218, 2, 6215, 33.4392, 0.583624139232888, -86.1008, -1.50274244860113),
(15460, '35161', 218, 2, 6215, 33.436, 0.583568288696824, -86.1058, -1.50282971506373),
(15461, '35171', 218, 2, 6327, 32.9238, 0.574628712268109, -86.7727, -1.51446931584528),
(15462, '35172', 218, 2, 6373, 33.8127, 0.590142943989087, -86.7459, -1.51400156760575),
(15463, '35173', 218, 2, 6396, 33.6265, 0.586893140921873, -86.593, -1.51133295917945),
(15464, '35175', 218, 2, 6461, 34.4202, 0.600745819194952, -86.4627, -1.5090587951641),
(15465, '35176', 218, 2, 459, 33.4842, 0.584409537396285, -86.501, -1.50972725626762),
(15466, '35178', 218, 2, 6568, 33.4005, 0.582948696812366, -86.3952, -1.50788069791901),
(15467, '35179', 218, 2, 6573, 34.2661, 0.598056266817629, -87.0081, -1.51857782090448),
(15468, '35180', 218, 2, 6636, 33.8031, 0.589975392380895, -86.8367, -1.51558632656656),
(15469, '35181', 218, 2, 6657, 33.6249, 0.586865215653841, -86.8926, -1.51656196561842),
(15470, '35182', 218, 2, 6661, 33.6677, 0.587612216573695, -86.2956, -1.50614234998402),
(15471, '35183', 218, 2, 6695, 32.9653, 0.575353023907687, -86.3663, -1.50737629776518),
(15472, '35184', 218, 2, 6704, 33.2031, 0.579503416868929, -87.0725, -1.51970181294276),
(15473, '35185', 218, 2, 6747, 33.3408, 0.581906735248925, -86.5415, -1.51043411461467),
(15474, '35186', 218, 2, 6863, 33.2421, 0.580184095277207, -86.5147, -1.50996636637514),
(15475, '35187', 218, 2, 287, 33.0744, 0.577257178121612, -86.8752, -1.51625827832858),
(15476, '35188', 218, 2, 569, 33.1664, 0.578862881033447, -87.1702, -1.52140699962196),
(15477, '35201', 218, 2, 799, 33.5191, 0.585018657305231, -86.8094, -1.51510985168077),
(15478, '35202', 218, 2, 799, 33.5179, 0.584997713354207, -86.8051, -1.51503480252293),
(15479, '35203', 218, 2, 799, 33.5127, 0.584906956233104, -86.8182, -1.51526344065494),
(15480, '35204', 218, 2, 799, 33.5211, 0.585053563890271, -86.836, -1.5155741092618),
(15481, '35205', 218, 2, 799, 33.4967, 0.584627703552784, -86.8047, -1.51502782120592),
(15482, '35206', 218, 2, 799, 33.5698, 0.585903539235992, -86.7177, -1.51350938475669),
(15483, '35207', 218, 2, 799, 33.5611, 0.585751695591069, -86.8179, -1.51525820466719),
(15484, '35208', 218, 2, 799, 33.4938, 0.584577089004477, -86.8836, -1.51640488598575),
(15485, '35209', 218, 2, 799, 33.4712, 0.584182644593526, -86.8055, -1.51504178383994),
(15486, '35210', 218, 2, 799, 33.5356, 0.58530663663181, -86.6753, -1.51276936515384),
(15487, '35211', 218, 2, 799, 33.476, 0.584266420397622, -86.8632, -1.51604883881834),
(15488, '35212', 218, 2, 799, 33.5422, 0.585421828362442, -86.7476, -1.51403123820303),
(15489, '35213', 218, 2, 799, 33.5051, 0.584774311209952, -86.7461, -1.51400505826425),
(15490, '35214', 218, 2, 799, 33.5586, 0.585708062359769, -86.8933, -1.51657418292319),
(15491, '35215', 218, 2, 799, 33.6363, 0.587064183188569, -86.6915, -1.51305210849266),
(15492, '35216', 218, 2, 799, 33.4185, 0.583262856077725, -86.795, -1.51485852426848),
(15493, '35217', 218, 2, 799, 33.5908, 0.586270058378911, -86.7609, -1.51426336699355),
(15494, '35218', 218, 2, 799, 33.5056, 0.584783037856212, -86.8955, -1.51661258016673),
(15495, '35219', 218, 2, 799, 33.4739, 0.58422976848333, -86.8254, -1.51538910436108),
(15496, '35220', 218, 2, 799, 33.4403, 0.58364333785466, -86.9062, -1.5167993303967),
(15497, '35221', 218, 2, 799, 33.4539, 0.583880702632931, -86.8937, -1.5165811642402),
(15498, '35222', 218, 2, 799, 33.5246, 0.585114650414091, -86.7692, -1.51440822932146),
(15499, '35223', 218, 2, 799, 33.4875, 0.584467133261601, -86.7374, -1.51385321461933),
(15500, '35224', 218, 2, 799, 33.5178, 0.584995968024955, -86.9329, -1.51726533330698),
(15501, '35225', 218, 2, 799, 33.5197, 0.585029129280743, -86.801, -1.5149632440236),
(15502, '35226', 218, 2, 799, 33.4061, 0.583046435250478, -86.8313, -1.51549207878695),
(15503, '35228', 218, 2, 799, 33.4618, 0.584018583643839, -86.9179, -1.51700353391918),
(15504, '35229', 218, 2, 799, 33.464, 0.584056980887382, -86.7937, -1.5148358349882),
(15505, '35230', 218, 2, 799, 33.5198, 0.585030874609995, -86.8016, -1.51497371599911),
(15506, '35231', 218, 2, 799, 33.5638, 0.585798819480873, -86.8952, -1.51660734417898),
(15507, '35232', 218, 2, 799, 33.5378, 0.585345033875354, -86.7566, -1.51418831783571),
(15508, '35233', 218, 2, 799, 33.509, 0.58484237905078, -86.8011, -1.51496498935285),
(15509, '35234', 218, 2, 799, 33.5387, 0.585360741838622, -86.8051, -1.51503480252293),
(15510, '35235', 218, 2, 799, 33.607, 0.586552801717734, -86.6569, -1.51244822457147),
(15511, '35236', 218, 2, 799, 33.3586, 0.58221740385578, -86.8169, -1.51524075137467),
(15512, '35237', 218, 2, 799, 33.5193, 0.585022147963735, -86.8094, -1.51510985168077),
(15513, '35238', 218, 2, 799, 33.5203, 0.585039601256255, -86.8026, -1.51499116929163),
(15514, '35240', 218, 2, 799, 33.5191, 0.585018657305231, -86.8011, -1.51496498935285),
(15515, '35242', 218, 2, 799, 33.4001, 0.582941715495358, -86.7133, -1.5134325902696),
(15516, '35243', 218, 2, 799, 33.4428, 0.58368697108596, -86.7471, -1.51402251155677),
(15517, '35244', 218, 2, 799, 33.3635, 0.582302924989128, -86.7881, -1.51473809655009),
(15518, '35245', 218, 2, 799, 33.5197, 0.585029129280743, -86.8015, -1.51497197066986),
(15519, '35246', 218, 2, 799, 33.5192, 0.585020402634483, -86.8013, -1.51496848001135),
(15520, '35249', 218, 2, 799, 33.5209, 0.585050073231767, -86.8027, -1.51499291462088),
(15521, '35253', 218, 2, 799, 33.4873, 0.584463642603097, -86.7416, -1.51392651844791),
(15522, '35254', 218, 2, 799, 33.5168, 0.584978514732436, -86.8504, -1.51582543667408),
(15523, '35255', 218, 2, 799, 33.4956, 0.584608504931013, -86.8076, -1.51507843575423),
(15524, '35259', 218, 2, 799, 33.483, 0.584388593445261, -86.7921, -1.51480790972017),
(15525, '35260', 218, 2, 799, 33.3987, 0.58291728088583, -86.8365, -1.51558283590806),
(15526, '35261', 218, 2, 799, 33.5716, 0.585934955162528, -86.7153, -1.51346749685464),
(15527, '35263', 218, 2, 799, 33.5225, 0.585077998499799, -86.8094, -1.51510985168077),
(15528, '35266', 218, 2, 799, 33.4448, 0.583721877671, -86.7911, -1.51479045642765),
(15529, '35277', 218, 2, 799, 33.4432, 0.583693952402968, -86.7395, -1.51388986653362),
(15530, '35278', 218, 2, 799, 33.4635, 0.584048254241123, -86.7891, -1.51475554984261),
(15531, '35279', 218, 2, 799, 33.4415, 0.583664281805684, -86.8571, -1.51594237373397),
(15532, '35280', 218, 2, 799, 33.5078, 0.584821435099756, -86.8207, -1.51530707388624),
(15533, '35281', 218, 2, 799, 33.5086, 0.584835397733772, -86.8208, -1.51530881921549),
(15534, '35282', 218, 2, 799, 33.4971, 0.584634684869793, -86.793, -1.51482361768344),
(15535, '35283', 218, 2, 799, 33.5193, 0.585022147963735, -86.8096, -1.51511334233927),
(15536, '35285', 218, 2, 799, 33.5408, 0.585397393752914, -86.8022, -1.51498418797462),
(15537, '35286', 218, 2, 799, 33.4233, 0.583346631881821, -86.795, -1.51485852426848),
(15538, '35287', 218, 2, 799, 33.5171, 0.584983750720191, -86.8076, -1.51507843575423),
(15539, '35288', 218, 2, 799, 33.4634, 0.58404650891187, -86.7718, -1.51445360788202),
(15540, '35289', 218, 2, 799, 33.4606, 0.583997639692815, -86.8385, -1.5156177424931),
(15541, '35290', 218, 2, 799, 33.548, 0.585523057459058, -86.7418, -1.51393000910642),
(15542, '35291', 218, 2, 799, 33.5131, 0.584913937550112, -86.805, -1.51503305719368),
(15543, '35292', 218, 2, 799, 33.5137, 0.584924409525624, -86.8049, -1.51503131186443),
(15544, '35293', 218, 2, 799, 33.466, 0.584091887472422, -86.8264, -1.5154065576536),
(15545, '35294', 218, 2, 799, 33.5061, 0.584791764502472, -86.8087, -1.515097634376),
(15546, '35295', 218, 2, 799, 33.5125, 0.5849034655746, -86.8041, -1.51501734923041),
(15547, '35296', 218, 2, 799, 33.4148, 0.583198278895401, -86.81, -1.51512032365628),
(15548, '35297', 218, 2, 799, 33.4928, 0.584559635711957, -86.7788, -1.51457578092966),
(15549, '35298', 218, 2, 799, 33.5024, 0.584727187320148, -86.7996, -1.51493880941407),
(15550, '35299', 218, 2, 799, 33.5169, 0.584980260061687, -86.8122, -1.51515872089982),
(15551, '35401', 218, 2, 6423, 33.1948, 0.579358554541014, -87.565, -1.52829755950883),
(15552, '35402', 218, 2, 6423, 33.1463, 0.578512069853796, -87.6111, -1.529102156294),
(15553, '35403', 218, 2, 6423, 33.2057, 0.579548795429481, -87.5235, -1.52757324786926),
(15554, '35404', 218, 2, 6423, 33.2113, 0.579646533867593, -87.4916, -1.52701648783787),
(15555, '35405', 218, 2, 6423, 33.1603, 0.578756415949076, -87.5182, -1.5274807454189),
(15556, '35406', 218, 2, 6423, 33.2534, 0.580381317482682, -87.5276, -1.52764480636859),
(15557, '35407', 218, 2, 6423, 33.1678, 0.578887315642975, -87.5216, -1.52754008661347),
(15558, '35440', 218, 2, 112673, 33.2903, 0.581025343976668, -87.1981, -1.52189394648327),
(15559, '35441', 218, 2, 215, 32.8781, 0.573831096799948, -87.7467, -1.53146882275971);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(15560, '35442', 218, 2, 31625, 33.1284, 0.578199655917689, -88.1537, -1.53857231281533),
(15561, '35443', 218, 2, 1032, 32.7629, 0.57182047750165, -88.0272, -1.53636447131155),
(15562, '35444', 218, 2, 1174, 33.339, 0.581875319322389, -87.123, -1.52058320421502),
(15563, '35446', 218, 2, 1226, 33.2656, 0.580594247651426, -87.7279, -1.53114070086033),
(15564, '35447', 218, 2, 1380, 33.226, 0.579903097267636, -88.0719, -1.53714463348719),
(15565, '35448', 218, 2, 1630, 32.9132, 0.574443707367398, -87.9929, -1.53576582337812),
(15566, '35449', 218, 2, 1668, 33.1593, 0.578738962656556, -87.3405, -1.52437929533811),
(15567, '35452', 218, 2, 1682, 33.2874, 0.58097472942836, -87.648, -1.52974618278799),
(15568, '35453', 218, 2, 1797, 33.1987, 0.579426622381842, -87.4021, -1.52545441815734),
(15569, '35456', 218, 2, 2133, 33.0936, 0.577592281337995, -87.4456, -1.52621363638195),
(15570, '35457', 218, 2, 2211, 33.3203, 0.581548942752267, -87.8109, -1.53258932413949),
(15571, '35458', 218, 2, 2282, 33.3641, 0.58231339696464, -87.8027, -1.53244620714083),
(15572, '35459', 218, 2, 2291, 32.7609, 0.57178557091661, -88.3103, -1.54130549842395),
(15573, '35460', 218, 2, 2315, 32.7614, 0.57179429756287, -88.1736, -1.53891963333647),
(15574, '35461', 218, 2, 2326, 33.3835, 0.582651990839527, -88.2218, -1.53976088203593),
(15575, '35462', 218, 2, 2338, 32.8399, 0.573164381025686, -87.8885, -1.53394369963904),
(15576, '35463', 218, 2, 2566, 33.1251, 0.578142060052374, -87.7259, -1.53110579427529),
(15577, '35464', 218, 2, 2644, 32.8171, 0.572766445956231, -88.1563, -1.53861769137588),
(15578, '35466', 218, 2, 2784, 33.3981, 0.582906808910318, -87.8928, -1.53401874879687),
(15579, '35468', 218, 2, 3491, 33.341, 0.581910225907429, -87.3047, -1.52375446746589),
(15580, '35469', 218, 2, 3570, 32.9722, 0.575473451626074, -87.8036, -1.53246191510409),
(15581, '35470', 218, 2, 3825, 32.5688, 0.568432793423529, -88.164, -1.53875208172828),
(15582, '35471', 218, 2, 4115, 33.3807, 0.582603121620471, -88.1412, -1.53835414665883),
(15583, '35473', 218, 2, 4635, 33.2285, 0.579946730498936, -87.5776, -1.52851747099459),
(15584, '35474', 218, 2, 4360, 33.006, 0.576063372913248, -87.603, -1.52896078462459),
(15585, '35475', 218, 2, 4635, 33.2444, 0.580224237850003, -87.5921, -1.52877054373613),
(15586, '35476', 218, 2, 4635, 33.2543, 0.58039702544595, -87.5847, -1.52864138937148),
(15587, '35477', 218, 2, 4851, 32.9506, 0.575096460507644, -88.2687, -1.54057944145512),
(15588, '35478', 218, 2, 4973, 33.2323, 0.580013053010512, -87.4237, -1.52583140927577),
(15589, '35480', 218, 2, 5284, 33.0522, 0.57686971502767, -87.7684, -1.53184755920739),
(15590, '35481', 218, 2, 5336, 33.3842, 0.582664208144291, -88.0121, -1.5361009265945),
(15591, '35482', 218, 2, 5629, 33.4555, 0.583908627900963, -87.6692, -1.53011619258941),
(15592, '35485', 218, 2, 6423, 33.1645, 0.578829719777659, -87.6159, -1.5291859320981),
(15593, '35486', 218, 2, 6423, 33.2081, 0.579590683331529, -87.5398, -1.52785773653733),
(15594, '35487', 218, 2, 6423, 33.2159, 0.579726819013184, -87.5402, -1.52786471785434),
(15595, '35490', 218, 2, 6520, 33.2922, 0.581058505232456, -87.159, -1.52121152274574),
(15596, '35491', 218, 2, 6718, 32.9236, 0.574625221609605, -88.085, -1.53737327161921),
(15597, '35501', 218, 2, 738, 33.843, 0.590671778752441, -87.2734, -1.52320817941002),
(15598, '35502', 218, 2, 738, 33.8306, 0.590455357925194, -87.2771, -1.52327275659234),
(15599, '35503', 218, 2, 738, 33.9321, 0.592226867115968, -87.3115, -1.52387314985503),
(15600, '35504', 218, 2, 738, 33.8899, 0.591490338171626, -87.1931, -1.52180668002067),
(15601, '35540', 218, 2, 34507, 34.2156, 0.597174875545372, -87.2884, -1.52346997879782),
(15602, '35541', 218, 2, 53228, 34.0511, 0.594303808925841, -87.1557, -1.52115392688042),
(15603, '35542', 218, 2, 112930, 33.7049, 0.588261479055437, -87.6887, -1.53045653179355),
(15604, '35543', 218, 2, 53, 34.197, 0.596850244304501, -87.7147, -1.53091031739907),
(15605, '35544', 218, 2, 134, 33.9632, 0.592769664513338, -88.0195, -1.53623008095915),
(15606, '35545', 218, 2, 221, 33.6463, 0.587238716113768, -87.9297, -1.53466277529086),
(15607, '35546', 218, 2, 389, 33.4999, 0.584683554088848, -87.6868, -1.53042337053776),
(15608, '35548', 218, 2, 1141, 34.0533, 0.594342206169385, -87.7311, -1.5311965513964),
(15609, '35549', 218, 2, 1351, 33.9106, 0.591851621326789, -87.5416, -1.52788915246387),
(15610, '35550', 218, 2, 924, 33.7594, 0.589212683497774, -87.1854, -1.52167228966826),
(15611, '35551', 218, 2, 2021, 34.1704, 0.59638598672347, -87.6058, -1.52900965384365),
(15612, '35552', 218, 2, 2034, 33.9941, 0.593308971252204, -88.1575, -1.5386386353269),
(15613, '35553', 218, 2, 2084, 34.1328, 0.595729742924721, -87.3856, -1.52516643883076),
(15614, '35554', 218, 2, 2252, 33.922, 0.592050588861516, -87.6229, -1.52930810514574),
(15615, '35555', 218, 2, 2426, 33.6933, 0.588059020862205, -87.8324, -1.53296456992867),
(15616, '35559', 218, 2, 2745, 33.8848, 0.591401326379775, -87.7445, -1.53143042551616),
(15617, '35560', 218, 2, 2777, 33.669, 0.587634905853971, -87.2313, -1.52247339579493),
(15618, '35563', 218, 2, 2900, 33.9677, 0.592848204329678, -87.8988, -1.53412346855199),
(15619, '35564', 218, 2, 2921, 34.2574, 0.597904423172705, -87.8656, -1.53354401924033),
(15620, '35565', 218, 2, 2933, 34.2323, 0.597466345530455, -87.6164, -1.52919465874436),
(15621, '35570', 218, 2, 2950, 34.1676, 0.596337117504415, -87.9789, -1.53552147728284),
(15622, '35571', 218, 2, 3178, 34.3479, 0.59948394614576, -87.968, -1.53533123639437),
(15623, '35572', 218, 2, 3246, 34.1206, 0.595516812755977, -87.2585, -1.52294812535147),
(15624, '35573', 218, 2, 3481, 33.9013, 0.591689305706354, -87.5536, -1.52809859197411),
(15625, '35574', 218, 2, 3499, 33.6347, 0.587036257920537, -87.9343, -1.53474306043645),
(15626, '35575', 218, 2, 3914, 34.0518, 0.594316026230605, -87.5306, -1.52769716624615),
(15627, '35576', 218, 2, 4224, 33.5491, 0.58554225608083, -88.194, -1.53927568050388),
(15628, '35577', 218, 2, 4485, 34.0887, 0.594960052724591, -87.6045, -1.52898696456337),
(15629, '35578', 218, 2, 4486, 33.9355, 0.592286208310536, -87.4441, -1.52618745644317),
(15630, '35579', 218, 2, 4718, 33.671, 0.587669812439011, -87.3667, -1.52483657160213),
(15631, '35580', 218, 2, 394, 33.7067, 0.588292894981973, -87.2548, -1.52288354816915),
(15632, '35581', 218, 2, 4982, 34.3526, 0.599565976620604, -87.764, -1.5317707647203),
(15633, '35582', 218, 2, 5308, 34.4421, 0.601128046301139, -88.1421, -1.53836985462209),
(15634, '35584', 218, 2, 5869, 33.8217, 0.590300023621766, -87.0834, -1.51989205383123),
(15635, '35585', 218, 2, 6038, 34.378, 0.600009290250611, -87.6951, -1.53056823286568),
(15636, '35586', 218, 2, 6132, 33.8937, 0.591556660683202, -88.1336, -1.53822150163567),
(15637, '35587', 218, 2, 6368, 33.8385, 0.590593238936101, -87.4498, -1.52628694021054),
(15638, '35592', 218, 2, 6535, 33.7547, 0.58913065302293, -88.119, -1.53796668356488),
(15639, '35593', 218, 2, 6567, 34.3654, 0.599789378764859, -88.0803, -1.53729124114436),
(15640, '35594', 218, 2, 6882, 33.9247, 0.59209771275132, -87.8151, -1.53266262796807),
(15641, '35601', 218, 2, 2007, 34.5896, 0.603702406947831, -86.9826, -1.51813276194522),
(15642, '35602', 218, 2, 2007, 34.5442, 0.602910027467425, -86.9631, -1.51779242274108),
(15643, '35603', 218, 2, 2007, 34.546, 0.602941443393961, -86.9796, -1.51808040206766),
(15644, '35609', 218, 2, 2007, 34.6107, 0.604070671420001, -87.0216, -1.5188134403535),
(15645, '35610', 218, 2, 7099, 34.9524, 0.610034461474066, -87.2735, -1.52320992473927),
(15646, '35611', 218, 2, 7182, 34.797, 0.607322219816467, -86.9683, -1.51788317986218),
(15647, '35612', 218, 2, 7182, 34.7967, 0.607316983828711, -87.0092, -1.51859701952625),
(15648, '35613', 218, 2, 7182, 34.8242, 0.607796949373009, -86.8808, -1.51635601676669),
(15649, '35614', 218, 2, 7182, 34.786, 0.607130233598748, -87.0738, -1.51972450222304),
(15650, '35615', 218, 2, 246, 34.7094, 0.60579331139172, -86.7425, -1.51394222641118),
(15651, '35616', 218, 2, 5, 34.7199, 0.605976570963179, -88.0029, -1.53594035630332),
(15652, '35617', 218, 2, 1638, 34.9389, 0.609798842025047, -87.7714, -1.53189991908495),
(15653, '35618', 218, 2, 1839, 34.6526, 0.604801964376587, -87.3008, -1.52368639962507),
(15654, '35619', 218, 2, 1964, 34.4197, 0.600737092548692, -87.1602, -1.52123246669676),
(15655, '35620', 218, 2, 2259, 34.9081, 0.609261280615433, -87.0071, -1.51856036761196),
(15656, '35621', 218, 2, 2339, 34.3157, 0.598921950126618, -86.7378, -1.51386019593634),
(15657, '35622', 218, 2, 2410, 34.3804, 0.600051178152659, -86.9031, -1.51674522518988),
(15658, '35630', 218, 2, 2502, 34.8187, 0.60770095626415, -87.6574, -1.52991024373768),
(15659, '35631', 218, 2, 2502, 34.8127, 0.60759623650903, -87.6546, -1.52986137451862),
(15660, '35632', 218, 2, 2502, 34.8404, 0.608079692711832, -87.6066, -1.52902361647766),
(15661, '35633', 218, 2, 2502, 34.8549, 0.608332765453372, -87.6857, -1.53040417191599),
(15662, '35634', 218, 2, 2502, 34.8, 0.607374579694027, -87.6775, -1.53026105491733),
(15663, '35640', 218, 2, 2999, 34.4442, 0.601164698215431, -86.9388, -1.51736830773285),
(15664, '35643', 218, 2, 3145, 34.6136, 0.604121285968309, -87.1997, -1.5219218717513),
(15665, '35645', 218, 2, 3523, 34.917, 0.60941661491886, -87.504, -1.52723290866512),
(15666, '35646', 218, 2, 3726, 34.6972, 0.605580381222977, -87.5227, -1.52755928523524),
(15667, '35647', 218, 2, 3735, 34.9245, 0.60954751461276, -87.1352, -1.52079613438376),
(15668, '35648', 218, 2, 3748, 34.954, 0.610062386742098, -87.396, -1.52534795307296),
(15669, '35649', 218, 2, 4315, 34.7089, 0.60578458474546, -86.7426, -1.51394397174043),
(15670, '35650', 218, 2, 4358, 34.4943, 0.60203910817068, -87.2916, -1.52352582933388),
(15671, '35651', 218, 2, 4376, 34.4596, 0.601433478920238, -87.4803, -1.5268192656324),
(15672, '35652', 218, 2, 5512, 34.8284, 0.607870253201593, -87.2954, -1.52359215184546),
(15673, '35653', 218, 2, 5585, 34.5076, 0.602271236961195, -87.7376, -1.53130999779778),
(15674, '35654', 218, 2, 5585, 34.5082, 0.602281708936707, -87.729, -1.53115989948211),
(15675, '35660', 218, 2, 5785, 34.7575, 0.606632814761929, -87.684, -1.53037450131871),
(15676, '35661', 218, 2, 4467, 34.7521, 0.606538566982321, -87.6433, -1.52966415231315),
(15677, '35662', 218, 2, 4467, 34.7878, 0.607161649525283, -87.6098, -1.52907946701373),
(15678, '35670', 218, 2, 5947, 34.5361, 0.602768655798014, -86.7813, -1.51461941416096),
(15679, '35671', 218, 2, 6233, 34.7188, 0.605957372341407, -86.9773, -1.51804025949486),
(15680, '35672', 218, 2, 6365, 34.6155, 0.604154447224097, -87.4161, -1.52569876425262),
(15681, '35673', 218, 2, 398, 34.5546, 0.603091541709633, -87.1565, -1.52116788951444),
(15682, '35674', 218, 2, 6425, 34.7223, 0.606018458865227, -87.6974, -1.53060837543848),
(15683, '35677', 218, 2, 6650, 34.9486, 0.60996813896249, -88.0067, -1.53600667881489),
(15684, '35699', 218, 2, 2007, 34.6112, 0.604079398066261, -87.0216, -1.5188134403535),
(15685, '35739', 218, 2, 18903, 34.9613, 0.610189795777494, -86.7541, -1.51414468460441),
(15686, '35740', 218, 2, 1130, 34.9443, 0.609893089804655, -85.7227, -1.49614335869934),
(15687, '35741', 218, 2, 1189, 34.7212, 0.605999260243455, -86.4833, -1.50941833299001),
(15688, '35742', 218, 2, 1348, 34.8054, 0.607468827473634, -86.7827, -1.51464384877048),
(15689, '35744', 218, 2, 2141, 34.6075, 0.604014820883938, -85.9022, -1.49927622470667),
(15690, '35745', 218, 2, 2325, 34.9131, 0.609348547078032, -86.1957, -1.50439876606128),
(15691, '35746', 218, 2, 2359, 34.8273, 0.607851054579821, -85.9879, -1.50077197187563),
(15692, '35747', 218, 2, 104, 34.5056, 0.602236330376155, -86.2685, -1.50566936575673),
(15693, '35748', 218, 2, 2915, 34.7153, 0.605896285817587, -86.3932, -1.50784579133396),
(15694, '35749', 218, 2, 3000, 34.8331, 0.607952283676437, -86.7405, -1.51390731982614),
(15695, '35750', 218, 2, 3033, 34.951, 0.610010026864538, -86.5869, -1.51122649409508),
(15696, '35751', 218, 2, 3202, 34.8145, 0.607627652435566, -86.2727, -1.50574266958531),
(15697, '35752', 218, 2, 3203, 34.7363, 0.606262804960506, -85.965, -1.50037229147693),
(15698, '35754', 218, 2, 3590, 34.5221, 0.602524309702735, -86.5997, -1.51144989623933),
(15699, '35755', 218, 2, 3666, 34.4531, 0.601320032518858, -86.1428, -1.50347548688697),
(15700, '35756', 218, 2, 3938, 34.5825, 0.603578488570939, -86.8205, -1.51530358322774),
(15701, '35757', 218, 2, 3938, 34.7715, 0.606877160857208, -86.7516, -1.51410105137311),
(15702, '35758', 218, 2, 3938, 34.7094, 0.60579331139172, -86.7419, -1.51393175443567),
(15703, '35759', 218, 2, 4166, 34.865, 0.608509043707823, -86.5665, -1.51087044692767),
(15704, '35760', 218, 2, 254, 34.5507, 0.603023473868805, -86.394, -1.50785975396798),
(15705, '35761', 218, 2, 4548, 34.9, 0.609119908946021, -86.4481, -1.50880397709331),
(15706, '35762', 218, 2, 4592, 34.7924, 0.607241934670875, -86.5717, -1.51096120404878),
(15707, '35763', 218, 2, 4825, 34.6085, 0.604032274176458, -86.4629, -1.50906228582261),
(15708, '35764', 218, 2, 4837, 34.6733, 0.60516324753175, -86.3166, -1.50650886912694),
(15709, '35765', 218, 2, 5096, 34.696, 0.605559437271952, -85.8102, -1.49767052179484),
(15710, '35766', 218, 2, 5231, 34.837, 0.608020351517265, -86.229, -1.50497996070219),
(15711, '35767', 218, 2, 5595, 34.7701, 0.60685272624768, -86.4811, -1.50937993574647),
(15712, '35768', 218, 2, 5695, 34.6597, 0.604925882753479, -86.0235, -1.50139330908934),
(15713, '35769', 218, 2, 5695, 34.6489, 0.604737387194263, -86.0471, -1.50180520679281),
(15714, '35771', 218, 2, 5718, 34.5818, 0.603566271266175, -85.9904, -1.50081560510693),
(15715, '35772', 218, 2, 6080, 34.8693, 0.608584092865659, -85.834, -1.49808591015681),
(15716, '35773', 218, 2, 6360, 34.9001, 0.609121654275273, -86.691, -1.5130433818464),
(15717, '35774', 218, 2, 6381, 34.748, 0.60646700848299, -86.2757, -1.50579502946287),
(15718, '35775', 218, 2, 6495, 34.5497, 0.603006020576285, -86.6941, -1.51309748705322),
(15719, '35776', 218, 2, 6954, 34.5757, 0.603459806181803, -86.244, -1.50524176008999),
(15720, '35801', 218, 2, 3297, 34.7278, 0.606114451974087, -86.5676, -1.51088964554944),
(15721, '35802', 218, 2, 3297, 34.6687, 0.605082962386158, -86.5599, -1.51075525519704),
(15722, '35803', 218, 2, 3297, 34.6167, 0.604175391175121, -86.5458, -1.51050916377251),
(15723, '35804', 218, 2, 3297, 34.7281, 0.606119687961843, -86.5855, -1.51120205948555),
(15724, '35805', 218, 2, 3297, 34.7134, 0.6058631245618, -86.6153, -1.51172216760264),
(15725, '35806', 218, 2, 3297, 34.7554, 0.606596162847637, -86.6766, -1.51279205443412),
(15726, '35807', 218, 2, 3297, 34.7115, 0.605829963306012, -86.6547, -1.51240982732793),
(15727, '35808', 218, 2, 3297, 34.6999, 0.60562750511278, -86.6424, -1.51219515182993),
(15728, '35809', 218, 2, 3297, 34.6332, 0.6044633705017, -86.6544, -1.51240459134017),
(15729, '35810', 218, 2, 3297, 34.7799, 0.607023768514376, -86.6067, -1.51157206928697),
(15730, '35811', 218, 2, 3297, 34.7825, 0.607069147074928, -86.524, -1.51012868199557),
(15731, '35812', 218, 2, 3297, 34.6333, 0.604465115830952, -86.6546, -1.51240808199868),
(15732, '35813', 218, 2, 3297, 34.6456, 0.604679791328947, -86.7531, -1.51412723131189),
(15733, '35814', 218, 2, 3297, 34.7096, 0.605796802050224, -86.6149, -1.51171518628564),
(15734, '35815', 218, 2, 3297, 34.6423, 0.604622195463632, -86.5671, -1.51088091890318),
(15735, '35816', 218, 2, 3297, 34.7388, 0.606306438191806, -86.6232, -1.51186004861355),
(15736, '35824', 218, 2, 3297, 34.6236, 0.604295818893509, -86.7331, -1.51377816546149),
(15737, '35893', 218, 2, 3297, 34.7306, 0.606163321193143, -86.586, -1.51121078613181),
(15738, '35894', 218, 2, 3297, 34.6464, 0.604693753962963, -86.7514, -1.51409756071461),
(15739, '35895', 218, 2, 3297, 34.7305, 0.606161575863891, -86.5857, -1.51120555014405),
(15740, '35896', 218, 2, 3297, 34.6627, 0.604978242631039, -86.7523, -1.51411326867788),
(15741, '35897', 218, 2, 3297, 34.7192, 0.605964353658415, -86.6297, -1.51197349501493),
(15742, '35898', 218, 2, 3297, 34.6288, 0.604386576014612, -86.6547, -1.51240982732793),
(15743, '35899', 218, 2, 3297, 34.7406, 0.606337854118342, -86.6284, -1.51195080573466),
(15744, '35901', 218, 2, 2640, 34.0066, 0.593527137408704, -86.0137, -1.50122226682265),
(15745, '35902', 218, 2, 2640, 34.0004, 0.59341892699508, -85.9576, -1.50024313711228),
(15746, '35903', 218, 2, 2640, 33.9848, 0.593146655631769, -85.969, -1.50044210464701),
(15747, '35904', 218, 2, 2640, 34.0266, 0.593876203259103, -86.055, -1.50194308780372),
(15748, '35905', 218, 2, 2640, 33.9529, 0.592589895600383, -85.905, -1.49932509392573),
(15749, '35906', 218, 2, 5277, 33.956, 0.592644000807195, -86.05, -1.50185582134112),
(15750, '35907', 218, 2, 2640, 33.9008, 0.591680579060094, -86.0152, -1.50124844676143),
(15751, '35950', 218, 2, 112712, 34.2645, 0.598028341549597, -86.2054, -1.50456806299872),
(15752, '35951', 218, 2, 112712, 34.2671, 0.598073720110149, -86.2094, -1.5046378761688),
(15753, '35952', 218, 2, 14978, 34.0292, 0.593921581819654, -86.3219, -1.50660137157729),
(15754, '35953', 218, 2, 15040, 33.8366, 0.590560077680313, -86.2511, -1.50536567846688),
(15755, '35954', 218, 2, 112857, 34.0139, 0.593654546444099, -86.0931, -1.50260805824873),
(15756, '35956', 218, 2, 85, 34.2026, 0.596947982742613, -86.1554, -1.50369539837272),
(15757, '35957', 218, 2, 85, 34.2055, 0.59699859729092, -86.1679, -1.50391356452922),
(15758, '35958', 218, 2, 652, 34.9505, 0.610001300218278, -85.6443, -1.49477502056578),
(15759, '35959', 218, 2, 1408, 34.2194, 0.597241198056948, -85.5974, -1.49395646114659),
(15760, '35960', 218, 2, 1470, 34.1517, 0.596059610153347, -85.6714, -1.49524800479307),
(15761, '35961', 218, 2, 1706, 34.3085, 0.598796286420475, -85.8333, -1.49807369285205),
(15762, '35962', 218, 2, 1904, 34.2842, 0.59837217141224, -85.9981, -1.50094999545934),
(15763, '35963', 218, 2, 1989, 34.358, 0.599660224400212, -85.9283, -1.49973175564144),
(15764, '35964', 218, 2, 2088, 34.1717, 0.596408676003746, -86.3216, -1.50659613558954),
(15765, '35966', 218, 2, 2479, 34.8094, 0.607538640643714, -85.7324, -1.49631265563679),
(15766, '35967', 218, 2, 2560, 34.4459, 0.601194368812715, -85.7151, -1.49601071367619),
(15767, '35968', 218, 2, 2560, 34.4442, 0.601164698215431, -85.7201, -1.49609798013879),
(15768, '35971', 218, 2, 2639, 34.5056, 0.602236330376155, -85.9038, -1.4993041499747),
(15769, '35972', 218, 2, 2646, 33.9924, 0.593279300654921, -86.2276, -1.50495552609266),
(15770, '35973', 218, 2, 2682, 34.3697, 0.599864427922695, -85.5568, -1.49324785747028),
(15771, '35974', 218, 2, 2702, 34.3596, 0.599688149668244, -86.0045, -1.50106169653146),
(15772, '35975', 218, 2, 0, 34.4348, 0.601000637265743, -86.0424, -1.50172317631797),
(15773, '35976', 218, 2, 2912, 34.3366, 0.599286723940285, -86.3058, -1.50632037356772),
(15774, '35978', 218, 2, 3055, 34.6281, 0.604374358709848, -85.7521, -1.49665648549943),
(15775, '35979', 218, 2, 3093, 34.8811, 0.608790041717394, -85.6375, -1.49465633817664),
(15776, '35980', 218, 2, 468, 34.1845, 0.596632078148002, -86.321, -1.50658566361403),
(15777, '35981', 218, 2, 3314, 34.729, 0.606135395925111, -85.6364, -1.49463713955487),
(15778, '35983', 218, 2, 3721, 34.1625, 0.596248105712563, -85.7784, -1.4971155070927),
(15779, '35984', 218, 2, 4169, 34.5896, 0.603702406947831, -85.5778, -1.4936143766132),
(15780, '35986', 218, 2, 5285, 34.4989, 0.602119393316272, -85.846, -1.49829534966705),
(15781, '35987', 218, 2, 6066, 33.932, 0.592225121786716, -86.1753, -1.50404271889387),
(15782, '35988', 218, 2, 6205, 34.5592, 0.603171826855224, -85.7882, -1.4972865493594),
(15783, '35989', 218, 2, 6505, 34.5055, 0.602234585046903, -85.683, -1.4954504629863),
(15784, '35990', 218, 2, 72, 34.0644, 0.594535937716356, -86.287, -1.50599225166835),
(15785, '36003', 218, 2, 112870, 32.4429, 0.566235423895268, -86.6732, -1.51273271323955),
(15786, '36005', 218, 2, 7248, 31.8419, 0.555745995090782, -85.7929, -1.49736857983424),
(15787, '36006', 218, 2, 766, 32.6144, 0.569228663562439, -86.7115, -1.51340117434306),
(15788, '36008', 218, 2, 1050, 32.5004, 0.567238988215165, -86.5721, -1.51096818536578),
(15789, '36009', 218, 2, 1090, 31.5871, 0.551298896156701, -86.2499, -1.50534473451586),
(15790, '36010', 218, 2, 1201, 31.7204, 0.553625420049609, -85.8173, -1.49779444017173),
(15791, '36013', 218, 2, 7972, 32.2986, 0.563716913784641, -86.1117, -1.5029326894896),
(15792, '36015', 218, 2, 1496, 31.6637, 0.552635818363729, -86.7006, -1.5132109334546),
(15793, '36016', 218, 2, 608, 31.8832, 0.556466816071856, -85.4493, -1.49137162852439),
(15794, '36017', 218, 2, 1632, 31.7109, 0.55345961377067, -85.6605, -1.4950577639046),
(15795, '36020', 218, 2, 1755, 32.4967, 0.567174411032841, -86.3414, -1.50694171078143),
(15796, '36022', 218, 2, 2003, 32.5841, 0.568699828799084, -86.445, -1.5087498718865),
(15797, '36023', 218, 2, 0, 32.6078, 0.569113471831807, -85.8083, -1.49763736053905),
(15798, '36024', 218, 2, 2214, 32.6214, 0.569350836610078, -86.0421, -1.50171794033021),
(15799, '36025', 218, 2, 64511, 32.5182, 0.56754965682202, -86.3502, -1.50709529975561),
(15800, '36026', 218, 2, 2317, 32.8081, 0.572609366323552, -86.1127, -1.50295014278212),
(15801, '36027', 218, 2, 2331, 31.8874, 0.55654011990044, -85.1539, -1.486215925914),
(15802, '36028', 218, 2, 2099, 31.5212, 0.550148724179637, -86.3616, -1.50729426729033),
(15803, '36029', 218, 2, 2456, 32.1781, 0.561613792035987, -85.9046, -1.49931811260872),
(15804, '36030', 218, 2, 2533, 31.8756, 0.556334171048705, -86.7944, -1.51484805229297),
(15805, '36031', 218, 2, 2554, 32.2861, 0.563498747628141, -85.7277, -1.49623062516194),
(15806, '36032', 218, 2, 2555, 31.9842, 0.55822959861637, -86.5778, -1.51106766913315),
(15807, '36033', 218, 2, 2699, 31.6374, 0.552176796770454, -86.7356, -1.51382179869279),
(15808, '36034', 218, 2, 2749, 31.6685, 0.552719594167824, -86.1671, -1.50389960189521),
(15809, '36035', 218, 2, 419, 31.8553, 0.55597986921055, -86.11, -1.50290301889232),
(15810, '36036', 218, 2, 2800, 32.0011, 0.558524559259957, -86.1159, -1.50300599331818),
(15811, '36037', 218, 2, 2868, 31.8185, 0.555337588045816, -86.6076, -1.51158777725024),
(15812, '36038', 218, 2, 2652, 31.424, 0.548452264146698, -86.4171, -1.50826292502519),
(15813, '36039', 218, 2, 2970, 32.3077, 0.563875738746572, -85.8048, -1.49757627401523),
(15814, '36040', 218, 2, 3026, 32.1896, 0.561814504899967, -86.6615, -1.51252850971707),
(15815, '36041', 218, 2, 3112, 31.9203, 0.557114333224346, -86.2975, -1.50617551123981),
(15816, '36042', 218, 2, 3218, 31.8781, 0.556377804280004, -86.398, -1.50792956713806),
(15817, '36043', 218, 2, 3226, 32.2322, 0.562558015161316, -86.368, -1.50740596836246),
(15818, '36045', 218, 2, 3501, 32.6186, 0.569301967391022, -85.9484, -1.50008256682109),
(15819, '36046', 218, 2, 3670, 31.9871, 0.558280213164678, -86.2789, -1.50585087999894),
(15820, '36047', 218, 2, 3739, 32.0795, 0.559892897393521, -86.5555, -1.51067846070995),
(15821, '36048', 218, 2, 3876, 31.7824, 0.554707524185846, -85.5555, -1.49322516819001),
(15822, '36049', 218, 2, 3909, 31.7139, 0.55351197364823, -86.2648, -1.5056047885744),
(15823, '36051', 218, 2, 3985, 32.6696, 0.57019208530954, -86.516, -1.50998905565541),
(15824, '36052', 218, 2, 42009, 32.4914, 0.567081908582486, -86.3668, -1.50738502441144),
(15825, '36053', 218, 2, 41, 32.1078, 0.560386825571835, -85.5257, -1.49270506007291),
(15826, '36054', 218, 2, 4211, 32.49, 0.567057473972958, -86.3644, -1.50734313650939),
(15827, '36057', 218, 2, 4380, 32.3619, 0.564821707201153, -86.0636, -1.50209318611939),
(15828, '36061', 218, 2, 4958, 31.9934, 0.558390168907554, -85.7514, -1.49664426819467),
(15829, '36062', 218, 2, 4976, 31.8494, 0.555876894784682, -86.2071, -1.504597733596),
(15830, '36064', 218, 2, 5004, 32.3243, 0.564165463402403, -86.0944, -1.50263074752901),
(15831, '36065', 218, 2, 5046, 32.0681, 0.559693929858794, -86.0597, -1.50202511827856),
(15832, '36066', 218, 2, 5217, 32.4669, 0.566654302915747, -86.437, -1.50861024554634),
(15833, '36067', 218, 2, 5217, 32.4859, 0.566985915473626, -86.5088, -1.50986339194927),
(15834, '36068', 218, 2, 5217, 32.4617, 0.566563545794643, -86.4462, -1.50877081583752),
(15835, '36069', 218, 2, 5290, 32.1209, 0.560615463703847, -86.2952, -1.50613536866701),
(15836, '36071', 218, 2, 5590, 31.7688, 0.554470159407574, -86.3672, -1.50739200572845),
(15837, '36072', 218, 2, 2331, 31.8908, 0.556599461095008, -85.1455, -1.48606931825683),
(15838, '36075', 218, 2, 5834, 32.4067, 0.565603614706046, -85.9536, -1.5001733239422),
(15839, '36078', 218, 2, 6223, 32.5415, 0.567956318537735, -85.9038, -1.4993041499747),
(15840, '36079', 218, 2, 199, 31.714, 0.553513718977482, -85.9754, -1.50055380571913),
(15841, '36080', 218, 2, 6352, 32.6538, 0.569916323287724, -86.2679, -1.50565889378122),
(15842, '36081', 218, 2, 199, 31.8027, 0.555061826024001, -85.9639, -1.50035309285515),
(15843, '36082', 218, 2, 199, 31.8005, 0.555023428780457, -85.9579, -1.50024837310003),
(15844, '36083', 218, 2, 6426, 32.4254, 0.565929991276169, -85.6909, -1.49558834399721),
(15845, '36087', 218, 2, 0, 32.4149, 0.56574673170471, -85.6805, -1.495406829755),
(15846, '36088', 218, 2, 0, 32.4144, 0.56573800505845, -85.718, -1.4960613282245),
(15847, '36089', 218, 2, 6474, 32.1416, 0.560976746859009, -85.715, -1.49600896834694),
(15848, '36091', 218, 2, 6532, 32.6897, 0.57054289648919, -86.5502, -1.5105859582596),
(15849, '36092', 218, 2, 6756, 32.5309, 0.567771313637023, -86.1957, -1.50439876606128),
(15850, '36093', 218, 2, 6756, 32.5442, 0.568003442427539, -86.2022, -1.50451221246266),
(15851, '36101', 218, 2, 4289, 32.3966, 0.565427336451595, -86.3238, -1.50663453283308),
(15852, '36102', 218, 2, 4289, 32.397, 0.565434317768603, -86.3263, -1.50667816606438),
(15853, '36103', 218, 2, 4289, 32.3965, 0.565425591122343, -86.3258, -1.50666943941812),
(15854, '36104', 218, 2, 4289, 32.4079, 0.56562455865707, -86.33, -1.5067427432467),
(15855, '36105', 218, 2, 4289, 32.3257, 0.564189898011931, -86.313, -1.50644603727387),
(15856, '36106', 218, 2, 4289, 32.3537, 0.564678590202489, -86.2643, -1.50559606192814),
(15857, '36107', 218, 2, 4289, 32.3786, 0.565113177186236, -86.2789, -1.50585087999894),
(15858, '36108', 218, 2, 4289, 32.3474, 0.564568634459614, -86.3636, -1.50732917387537),
(15859, '36109', 218, 2, 4289, 32.3829, 0.565188226344072, -86.2436, -1.50523477877298),
(15860, '36110', 218, 2, 4289, 32.4179, 0.56579909158227, -86.2733, -1.50575314156082),
(15861, '36111', 218, 2, 4289, 32.3394, 0.564429008119454, -86.2706, -1.50570601767102),
(15862, '36112', 218, 2, 4289, 32.3789, 0.565118413173992, -86.3469, -1.50703770389029),
(15863, '36113', 218, 2, 4289, 32.3779, 0.565100959881472, -86.3381, -1.50688411491612),
(15864, '36114', 218, 2, 4289, 32.4068, 0.565605360035298, -86.2488, -1.50532553589409),
(15865, '36115', 218, 2, 4289, 32.4077, 0.565621067998566, -86.2485, -1.50532029990633),
(15866, '36116', 218, 2, 4289, 32.3123, 0.563956023892164, -86.2393, -1.50515972961515),
(15867, '36117', 218, 2, 4289, 32.3698, 0.56495958821206, -86.1761, -1.50405668152789),
(15868, '36118', 218, 2, 4289, 32.4075, 0.565617577340062, -86.2491, -1.50533077188184),
(15869, '36119', 218, 2, 4289, 32.3964, 0.565423845793091, -86.3259, -1.50667118474737),
(15870, '36120', 218, 2, 4289, 32.3115, 0.563942061258148, -86.2342, -1.50507071782329),
(15871, '36121', 218, 2, 4289, 32.3869, 0.565258039514151, -86.148, -1.50356624400808),
(15872, '36123', 218, 2, 4289, 32.3666, 0.564903737675997, -86.3004, -1.50622612578811),
(15873, '36124', 218, 2, 4289, 32.393, 0.565364504598523, -86.1764, -1.50406191751564),
(15874, '36125', 218, 2, 4289, 32.315, 0.564003147781968, -86.3183, -1.50653853972422),
(15875, '36130', 218, 2, 4289, 32.3743, 0.5650381280284, -86.3116, -1.50642160266434),
(15876, '36131', 218, 2, 4289, 32.3789, 0.565118413173992, -86.3007, -1.50623136177587),
(15877, '36132', 218, 2, 4289, 32.3772, 0.565088742576708, -86.1801, -1.50412649469797),
(15878, '36133', 218, 2, 4289, 32.3744, 0.565039873357652, -86.3122, -1.50643207463985),
(15879, '36134', 218, 2, 4289, 32.3775, 0.565093978564464, -86.3107, -1.50640589470107),
(15880, '36135', 218, 2, 4289, 32.3863, 0.565247567538639, -86.1479, -1.50356449867882),
(15881, '36140', 218, 2, 4289, 32.3855, 0.565233604904624, -86.1471, -1.50355053604481),
(15882, '36141', 218, 2, 4289, 32.3866, 0.565252803526396, -86.1484, -1.50357322532508),
(15883, '36142', 218, 2, 4289, 32.3803, 0.56514284778352, -86.3126, -1.50643905595686),
(15884, '36177', 218, 2, 4289, 32.3787, 0.565114922515488, -86.3007, -1.50623136177587),
(15885, '36191', 218, 2, 4289, 32.3266, 0.564205605975199, -86.2781, -1.50583691736492),
(15886, '36201', 218, 2, 53195, 33.6591, 0.587462118258023, -85.8254, -1.49793581184114),
(15887, '36202', 218, 2, 53195, 33.7169, 0.588470918565676, -85.8752, -1.49880498580863),
(15888, '36203', 218, 2, 4828, 33.6024, 0.586472516572143, -85.8383, -1.49816095931465),
(15889, '36204', 218, 2, 53195, 33.6856, 0.587924630509802, -85.8235, -1.49790265058535),
(15890, '36205', 218, 2, 53195, 33.7119, 0.588383652103076, -85.8134, -1.4977263723309),
(15891, '36206', 218, 2, 53195, 33.7212, 0.588545967723512, -85.8339, -1.49808416482756),
(15892, '36207', 218, 2, 53195, 33.6539, 0.58737136113692, -85.7691, -1.49695319147227),
(15893, '36250', 218, 2, 34524, 33.766, 0.589327875228405, -85.8955, -1.49915928764679),
(15894, '36251', 218, 2, 13301, 33.2724, 0.580712930040561, -85.8324, -1.49805798488878),
(15895, '36253', 218, 2, 1267, 33.6016, 0.586458553938127, -85.9651, -1.50037403680618),
(15896, '36254', 218, 2, 1565, 33.6563, 0.587413249038968, -85.6997, -1.49574193297138),
(15897, '36255', 218, 2, 1857, 33.2152, 0.579714601708421, -85.6905, -1.4955813626802),
(15898, '36256', 218, 2, 1984, 33.0397, 0.576651548871171, -85.7408, -1.49645926329395),
(15899, '36257', 218, 2, 0, 33.6287, 0.586931538165417, -85.7416, -1.49647322592797),
(15900, '36258', 218, 2, 2022, 33.4538, 0.583878957303679, -85.6848, -1.49548187891284),
(15901, '36260', 218, 2, 2187, 33.604, 0.586500441840174, -85.9769, -1.50057998565791),
(15902, '36261', 218, 2, 2239, 33.7063, 0.588285913664965, -85.5098, -1.49242755272185),
(15903, '36262', 218, 2, 2623, 33.7302, 0.588703047356191, -85.432, -1.4910696865638),
(15904, '36263', 218, 2, 2802, 33.464, 0.584056980887382, -85.3374, -1.48941860509141),
(15905, '36264', 218, 2, 3050, 33.6484, 0.58727536802806, -85.5847, -1.49373480433159),
(15906, '36265', 218, 2, 3395, 33.8297, 0.590439649961926, -85.7759, -1.4970718738614),
(15907, '36266', 218, 2, 3791, 33.3185, 0.581517526825731, -85.5921, -1.49386395869624),
(15908, '36267', 218, 2, 4221, 33.158, 0.57871627337628, -85.9591, -1.50026931705106),
(15909, '36268', 218, 2, 4461, 33.5311, 0.585228096815471, -85.9755, -1.50055555104838),
(15910, '36269', 218, 2, 4466, 33.7438, 0.588940412134463, -85.3786, -1.49013768074323),
(15911, '36270', 218, 2, 4567, 33.43, 0.583463568941704, -85.518, -1.49257066972051),
(15912, '36271', 218, 2, 4740, 33.7933, 0.5898043501142, -86.0115, -1.5011838695791),
(15913, '36272', 218, 2, 4996, 33.9154, 0.591935397130885, -85.6339, -1.49459350632357),
(15914, '36273', 218, 2, 5294, 33.5793, 0.586069345514932, -85.3986, -1.49048674659363),
(15915, '36274', 218, 2, 5436, 33.1522, 0.578615044279664, -85.3726, -1.49003296098811),
(15916, '36275', 218, 2, 6002, 33.9731, 0.592942452109286, -85.5538, -1.49319549759272),
(15917, '36276', 218, 2, 6589, 33.1212, 0.578073992211546, -85.5712, -1.49349918488257),
(15918, '36277', 218, 2, 6669, 33.7539, 0.589116690388914, -85.8196, -1.49783458274453),
(15919, '36278', 218, 2, 6675, 33.3272, 0.581669370470654, -85.5048, -1.49234028625925),
(15920, '36279', 218, 2, 902, 33.8662, 0.591076695138904, -85.8895, -1.49905456789167),
(15921, '36280', 218, 2, 6917, 33.3578, 0.582203441221764, -85.3464, -1.48957568472409),
(15922, '36301', 218, 2, 2081, 31.2038, 0.544609049133807, -85.4059, -1.49061415562903),
(15923, '36302', 218, 2, 2081, 31.2276, 0.545024437495781, -85.3935, -1.49039773480178),
(15924, '36303', 218, 2, 2081, 31.2451, 0.54532987011488, -85.4103, -1.49069095011611),
(15925, '36304', 218, 2, 2081, 31.2363, 0.545176281140705, -85.4053, -1.49060368365351),
(15926, '36305', 218, 2, 2081, 31.2234, 0.544951133667198, -85.3906, -1.49034712025347),
(15927, '36310', 218, 2, 18708, 31.5543, 0.550726428162047, -85.2554, -1.48798743510477),
(15928, '36311', 218, 2, 112194, 31.5985, 0.551497863691428, -85.7201, -1.49609798013879),
(15929, '36312', 218, 2, 728, 31.1878, 0.544329796453487, -85.239, -1.48770120110745),
(15930, '36313', 218, 2, 294, 31.2279, 0.545029673483537, -85.7619, -1.49682752776612),
(15931, '36314', 218, 2, 821, 31.0076, 0.541184713141394, -85.7461, -1.49655176574431),
(15932, '36316', 218, 2, 1483, 31.1784, 0.5441657355038, -85.9184, -1.4995589680455),
(15933, '36317', 218, 2, 1635, 31.5999, 0.551522298300956, -85.4696, -1.49172593036255),
(15934, '36318', 218, 2, 1677, 31.169, 0.544001674554113, -85.9118, -1.49944377631486),
(15935, '36319', 218, 2, 1716, 31.2897, 0.54610828696127, -85.1128, -1.48549859559143),
(15936, '36320', 218, 2, 1802, 31.0531, 0.541978837951051, -85.3012, -1.48878679590219),
(15937, '36321', 218, 2, 1847, 31.2012, 0.544563670573255, -85.3014, -1.48879028656069),
(15938, '36322', 218, 2, 1951, 31.3028, 0.546336925093281, -85.7129, -1.49597231643265),
(15939, '36323', 218, 2, 316, 31.4192, 0.548368488342602, -86.077, -1.50232706023916),
(15940, '36330', 218, 2, 2311, 31.3251, 0.546726133516476, -85.8448, -1.49827440571603),
(15941, '36331', 218, 2, 2311, 31.3254, 0.546731369504232, -85.8558, -1.49846639193375),
(15942, '36340', 218, 2, 2687, 31.0356, 0.541673405331952, -85.8792, -1.49887479897871),
(15943, '36343', 218, 2, 2785, 31.1519, 0.543703223252022, -85.0749, -1.48483711580492),
(15944, '36344', 218, 2, 2998, 31.1029, 0.542848011918544, -85.6979, -1.49571051704485),
(15945, '36345', 218, 2, 3037, 31.3518, 0.547192136426758, -85.3405, -1.48947271029822),
(15946, '36346', 218, 2, 110, 31.5576, 0.550784024027363, -86.0566, -1.50197101307175),
(15947, '36349', 218, 2, 3963, 31.1057, 0.5428968811376, -85.6024, -1.49404372760919),
(15948, '36350', 218, 2, 4187, 31.2777, 0.54589884745103, -85.4985, -1.49223033051637),
(15949, '36351', 218, 2, 4518, 31.3843, 0.547759368433656, -85.9307, -1.49977364354349),
(15950, '36352', 218, 2, 4570, 31.3293, 0.54679943734506, -85.6034, -1.49406118090171),
(15951, '36353', 218, 2, 4573, 31.4503, 0.548911285739973, -85.3272, -1.48924058150771),
(15952, '36360', 218, 2, 4832, 31.4414, 0.548755951436545, -85.6463, -1.49480992715082),
(15953, '36361', 218, 2, 4832, 31.4566, 0.549021241482848, -85.6455, -1.4947959645168),
(15954, '36362', 218, 2, 0, 31.3455, 0.547082180683883, -85.719, -1.49607878151702),
(15955, '36370', 218, 2, 4853, 31.0549, 0.542010253877587, -85.3033, -1.48882344781648),
(15956, '36371', 218, 2, 5010, 31.3965, 0.5479722986024, -85.5032, -1.49231236099122),
(15957, '36373', 218, 2, 5835, 31.6143, 0.551773625713243, -85.1464, -1.4860850262201),
(15958, '36374', 218, 2, 5882, 31.5593, 0.550813694624646, -85.5436, -1.49301747400902),
(15959, '36375', 218, 2, 5902, 31.1099, 0.542970184966184, -85.5944, -1.49390410126903),
(15960, '36376', 218, 2, 6671, 31.202, 0.544577633207271, -85.2954, -1.48868556680557),
(15961, '36401', 218, 2, 2343, 31.4321, 0.54859363581611, -86.9529, -1.51761439915738),
(15962, '36420', 218, 2, 14987, 31.308, 0.546427682214385, -86.477, -1.50930837724714),
(15963, '36425', 218, 2, 90, 31.7481, 0.554108876252412, -87.1058, -1.52028300758368),
(15964, '36426', 218, 2, 1115, 31.1133, 0.543029526160752, -87.0692, -1.51964421707745),
(15965, '36427', 218, 2, 1115, 31.1078, 0.542933533051892, -87.0721, -1.51969483162575),
(15966, '36429', 218, 2, 1157, 31.4943, 0.54967923061085, -86.9127, -1.51691277679808),
(15967, '36431', 218, 2, 1249, 31.6041, 0.55159560212954, -87.2646, -1.52305459043584),
(15968, '36432', 218, 2, 1394, 31.3045, 0.546366595690565, -87.0257, -1.51888499885283),
(15969, '36435', 218, 2, 1855, 31.8892, 0.556571535826976, -87.3299, -1.5241942904374),
(15970, '36436', 218, 2, 2041, 31.7306, 0.553803443633313, -87.6509, -1.5297967973363),
(15971, '36439', 218, 2, 2350, 31.3952, 0.547949609322124, -87.4187, -1.52574414281317),
(15972, '36441', 218, 2, 2503, 30.9934, 0.540936876387611, -87.2563, -1.52290972810793),
(15973, '36442', 218, 2, 2501, 31.0053, 0.541144570568598, -86.3261, -1.50667467540588),
(15974, '36444', 218, 2, 2595, 31.7219, 0.553651599988389, -87.4554, -1.52638467864865),
(15975, '36445', 218, 2, 2618, 31.4154, 0.548302165831027, -87.4209, -1.52578254005671),
(15976, '36446', 218, 2, 2628, 31.7865, 0.554779082685178, -87.6456, -1.52970429488594),
(15977, '36449', 218, 2, 2779, 31.3951, 0.547947863992872, -87.4186, -1.52574239748391),
(15978, '36451', 218, 2, 2887, 31.7027, 0.553316496772006, -87.7785, -1.53202383746184),
(15979, '36453', 218, 2, 3551, 31.229, 0.545048872105309, -86.1524, -1.50364303849516),
(15980, '36454', 218, 2, 425, 31.3211, 0.546656320346396, -87.1995, -1.5219183810928),
(15981, '36455', 218, 2, 3836, 31.051, 0.541942186036759, -86.349, -1.50707435580458),
(15982, '36456', 218, 2, 4104, 31.5558, 0.550752608100827, -86.7512, -1.5140940700561),
(15983, '36457', 218, 2, 4149, 31.3957, 0.547958335968384, -87.4186, -1.52574239748391),
(15984, '36458', 218, 2, 4178, 31.3953, 0.547951354651376, -87.4183, -1.52573716149616),
(15985, '36460', 218, 2, 4273, 31.5164, 0.550064948375541, -87.3278, -1.5241576385231),
(15986, '36461', 218, 2, 4273, 31.5179, 0.550091128314321, -87.3213, -1.52404419212172),
(15987, '36462', 218, 2, 4273, 31.5275, 0.550258679922512, -87.3247, -1.52410353331629),
(15988, '36467', 218, 2, 4796, 31.2799, 0.545937244694574, -86.2567, -1.50546341690499),
(15989, '36470', 218, 2, 4955, 31.527, 0.550249953276252, -87.3243, -1.52409655199928),
(15990, '36471', 218, 2, 4970, 31.604, 0.551593856800288, -87.2646, -1.52305459043584),
(15991, '36473', 218, 2, 5297, 31.3115, 0.546488768738205, -87.3081, -1.52381380866046),
(15992, '36474', 218, 2, 5315, 31.4556, 0.549003788190328, -86.6063, -1.51156508796997),
(15993, '36475', 218, 2, 5355, 31.4291, 0.54854127593855, -87.1629, -1.52127959058657),
(15994, '36476', 218, 2, 5435, 31.302, 0.546322962459265, -86.6214, -1.51182863268702),
(15995, '36477', 218, 2, 5631, 31.111, 0.542989383587956, -86.0479, -1.50181916942683),
(15996, '36480', 218, 2, 6496, 31.3284, 0.546783729381792, -87.6048, -1.52899220055113),
(15997, '36481', 218, 2, 6584, 31.8237, 0.555428345166919, -87.3123, -1.52388711248905),
(15998, '36482', 218, 2, 6757, 31.6497, 0.552391472268449, -87.6275, -1.52938839029133),
(15999, '36483', 218, 2, 6883, 31.1222, 0.543184860464179, -86.5862, -1.51121427679031),
(16000, '36501', 218, 2, 7066, 31.4376, 0.548689628924969, -87.7262, -1.53111103026305),
(16001, '36502', 218, 2, 112855, 31.0237, 0.541465711150965, -87.4888, -1.52696761861882),
(16002, '36503', 218, 2, 112855, 31.0217, 0.541430804565925, -87.4954, -1.52708281034945),
(16003, '36504', 218, 2, 112855, 31.0226, 0.541446512529193, -87.4818, -1.52684544557118),
(16004, '36505', 218, 2, 112873, 30.9039, 0.539374806707076, -88.048, -1.53672749979597),
(16005, '36507', 218, 2, 10, 30.8739, 0.538851207931477, -87.7773, -1.53200289351082),
(16006, '36509', 218, 2, 22, 30.4058, 0.530681321702892, -88.2457, -1.54017801572716),
(16007, '36511', 218, 2, 1039, 30.3144, 0.529086090766569, -87.7268, -1.53112150223856),
(16008, '36512', 218, 2, 1217, 31.0895, 0.542614137798777, -88.0445, -1.53666641327215),
(16009, '36513', 218, 2, 1300, 30.7988, 0.53754046566323, -88.2342, -1.53997730286318),
(16010, '36515', 218, 2, 1361, 31.3267, 0.546754058784508, -87.8378, -1.53305881770828),
(16011, '36518', 218, 2, 1505, 31.4644, 0.549157377164504, -88.2336, -1.53996683088767),
(16012, '36521', 218, 2, 1578, 30.9552, 0.540270160613349, -88.1951, -1.53929487912565),
(16013, '36522', 218, 2, 1584, 31.0705, 0.542282525240898, -88.2659, -1.54053057223606),
(16014, '36523', 218, 2, 1675, 30.3852, 0.530321783876981, -88.1684, -1.53882887621537),
(16015, '36524', 218, 2, 1678, 31.7895, 0.554831442562737, -88.0668, -1.53705562169534),
(16016, '36525', 218, 2, 1868, 30.8876, 0.539090318039001, -88.0263, -1.53634876334828),
(16017, '36526', 218, 2, 1969, 30.6199, 0.534418071631412, -87.8882, -1.53393846365128),
(16018, '36527', 218, 2, 5987, 30.6831, 0.535521119718672, -87.8717, -1.5336504843247),
(16019, '36528', 218, 2, 1975, 30.2523, 0.528002241301081, -88.1244, -1.53806093134449),
(16020, '36529', 218, 2, 2011, 31.1879, 0.544331541782739, -88.3079, -1.5412636105219),
(16021, '36530', 218, 2, 2250, 30.3974, 0.530534714045724, -87.5587, -1.52818760376596),
(16022, '36532', 218, 2, 2376, 30.5008, 0.532339384492286, -87.87, -1.53362081372742),
(16023, '36533', 218, 2, 2376, 30.4895, 0.532142162286811, -87.8548, -1.53335552368111),
(16024, '36535', 218, 2, 2510, 30.3965, 0.530519006082456, -87.7015, -1.53067993393781),
(16025, '36536', 218, 2, 2510, 30.4013, 0.530602781886552, -87.6624, -1.52999751020028),
(16026, '36538', 218, 2, 2599, 31.6566, 0.552511899986837, -88.1337, -1.53822324696493),
(16027, '36539', 218, 2, 2625, 31.3244, 0.546713916211712, -88.3144, -1.54137705692328),
(16028, '36540', 218, 2, 2642, 31.4218, 0.548413866903154, -87.6736, -1.5301929870765),
(16029, '36541', 218, 2, 2805, 30.4914, 0.532175323542599, -88.3307, -1.54166154559136),
(16030, '36542', 218, 2, 2905, 30.272, 0.528346071163723, -87.7171, -1.53095220530112),
(16031, '36543', 218, 2, 3306, 31.221, 0.54490924576515, -87.4613, -1.52648765307452),
(16032, '36544', 218, 2, 3366, 30.4796, 0.531969374690864, -88.2303, -1.53990923502235),
(16033, '36545', 218, 2, 3384, 31.5257, 0.550227263995976, -87.8899, -1.53396813424856),
(16034, '36547', 218, 2, 2905, 30.2457, 0.527887049570449, -87.7003, -1.53065898998678),
(16035, '36548', 218, 2, 3734, 31.5153, 0.550045749753769, -87.8962, -1.53407808999144),
(16036, '36549', 218, 2, 3772, 30.387, 0.530353199803517, -87.4632, -1.5265208143303),
(16037, '36550', 218, 2, 3805, 31.2178, 0.544853395229086, -87.794, -1.5322943634959),
(16038, '36551', 218, 2, 3894, 30.6134, 0.534304625230032, -87.7542, -1.53159972245361),
(16039, '36553', 218, 2, 4100, 31.2331, 0.545120430604641, -88.0657, -1.53703642307357),
(16040, '36555', 218, 2, 3952, 30.4027, 0.53062721649608, -87.7865, -1.532163463802),
(16041, '36556', 218, 2, 3958, 31.2337, 0.545130902580153, -88.0652, -1.53702769642731),
(16042, '36558', 218, 2, 4225, 31.6269, 0.551993537198995, -88.3539, -1.54206646197782),
(16043, '36559', 218, 2, 4299, 30.5684, 0.533519227066635, -87.8988, -1.53412346855199),
(16044, '36560', 218, 2, 4411, 31.0976, 0.542755509468189, -87.9941, -1.53578676732914),
(16045, '36561', 218, 2, 4798, 30.2953, 0.528752732879438, -87.5503, -1.52804099610879),
(16046, '36562', 218, 2, 4953, 31.0128, 0.541275470262497, -87.6604, -1.52996260361524),
(16047, '36564', 218, 2, 5161, 30.4773, 0.531929232118068, -87.9187, -1.53447078907314),
(16048, '36567', 218, 2, 5445, 30.5865, 0.533835131661246, -87.6415, -1.52963273638661),
(16049, '36568', 218, 2, 5612, 30.4931, 0.532204994139883, -88.2869, -1.54089709137898),
(16050, '36569', 218, 2, 5615, 31.5386, 0.550452411469484, -88.0534, -1.53682174757558),
(16051, '36570', 218, 2, 5624, 31.6658, 0.55267247027802, -87.9852, -1.53563143302572),
(16052, '36571', 218, 2, 5657, 30.8266, 0.538025667195284, -88.0925, -1.5375041713131),
(16053, '36572', 218, 2, 5671, 30.8528, 0.538482943459306, -88.056, -1.53686712613613),
(16054, '36574', 218, 2, 5735, 30.5087, 0.532477265503194, -87.4734, -1.52669883791401),
(16055, '36575', 218, 2, 5737, 30.7582, 0.53683186198692, -88.2643, -1.54050264696803),
(16056, '36576', 218, 2, 5859, 30.5314, 0.532873455243397, -87.7608, -1.53171491418424),
(16057, '36577', 218, 2, 5987, 30.6754, 0.535386729366269, -87.8844, -1.5338721411397),
(16058, '36578', 218, 2, 6053, 30.7404, 0.536521193380065, -87.789, -1.5322070970333),
(16059, '36579', 218, 2, 510, 31.0851, 0.542537343311689, -87.8274, -1.53287730346607),
(16060, '36580', 218, 2, 6147, 30.482, 0.532011262592912, -87.7211, -1.5310220184712),
(16061, '36581', 218, 2, 6159, 31.3933, 0.547916448066336, -88.0619, -1.53697010056199),
(16062, '36582', 218, 2, 6306, 30.5347, 0.532931051108713, -88.1814, -1.53905576901813),
(16063, '36583', 218, 2, 6336, 31.3831, 0.547738424482632, -88.266, -1.54053231756531),
(16064, '36584', 218, 2, 6570, 31.2549, 0.545500912381576, -88.3941, -1.54276808433712),
(16065, '36585', 218, 2, 6593, 31.3942, 0.547932156029604, -88.0615, -1.53696311924499),
(16066, '36586', 218, 2, 6606, 31.629, 0.552030189113287, -87.8211, -1.53276734772319),
(16067, '36587', 218, 2, 6852, 30.8148, 0.537819718343549, -88.331, -1.54166678157911),
(16068, '36590', 218, 2, 6306, 30.536, 0.532953740388988, -88.185, -1.5391186008712),
(16069, '36601', 218, 2, 4259, 30.7005, 0.535824807008519, -88.0469, -1.5367083011742),
(16070, '36602', 218, 2, 4259, 30.69, 0.53564154743706, -88.0469, -1.5367083011742),
(16071, '36603', 218, 2, 4259, 30.6887, 0.535618858156784, -88.0551, -1.53685141817286),
(16072, '36604', 218, 2, 4259, 30.6808, 0.535480977145876, -88.0703, -1.53711670821916),
(16073, '36605', 218, 2, 4259, 30.6303, 0.534599585873619, -88.0861, -1.53739247024098),
(16074, '36606', 218, 2, 4259, 30.6727, 0.535339605476465, -88.1024, -1.53767695890905),
(16075, '36607', 218, 2, 4259, 30.6987, 0.535793391081983, -88.1034, -1.53769441220157),
(16076, '36608', 218, 2, 4259, 30.6954, 0.535735795216667, -88.1957, -1.53930535110116),
(16077, '36609', 218, 2, 4259, 30.6477, 0.534903273163466, -88.1689, -1.53883760286163),
(16078, '36610', 218, 2, 4259, 30.7383, 0.536484541465773, -88.0814, -1.53731043976613),
(16079, '36611', 218, 2, 4259, 30.7662, 0.536971488327079, -88.0841, -1.53735756365594),
(16080, '36612', 218, 2, 4259, 30.7512, 0.53670968893928, -88.1117, -1.53783927452949),
(16081, '36613', 218, 2, 2244, 30.7859, 0.537315318189722, -88.1658, -1.53878349765482),
(16082, '36614', 218, 2, 4259, 30.7377, 0.536474069490261, -88.0538, -1.53682872889258),
(16083, '36615', 218, 2, 4259, 30.6299, 0.534592604556611, -88.0734, -1.53717081342597),
(16084, '36616', 218, 2, 4259, 30.6706, 0.535302953562173, -88.1269, -1.53810456457579),
(16085, '36617', 218, 2, 4259, 30.7155, 0.536086606396318, -88.0903, -1.53746577406956),
(16086, '36618', 218, 2, 4259, 30.7297, 0.536334443150101, -88.1717, -1.53888647208068),
(16087, '36619', 218, 2, 4259, 30.5953, 0.533988720635421, -88.1845, -1.53910987422494),
(16088, '36621', 218, 2, 4259, 30.6937, 0.535706124619383, -88.0454, -1.53668212123542),
(16089, '36622', 218, 2, 4259, 30.6935, 0.53570263396088, -88.0414, -1.53661230806534),
(16090, '36623', 218, 2, 4259, 30.696, 0.535746267192179, -88.0434, -1.53664721465038),
(16091, '36625', 218, 2, 4259, 30.6965, 0.535754993838439, -88.0436, -1.53665070530888),
(16092, '36626', 218, 2, 4259, 30.6793, 0.535454797207096, -88.123, -1.53803649673496),
(16093, '36628', 218, 2, 4259, 30.6926, 0.535686925997612, -88.0441, -1.53665943195514),
(16094, '36630', 218, 2, 4259, 30.6906, 0.535652019412572, -88.0417, -1.53661754405309),
(16095, '36631', 218, 2, 4259, 30.6757, 0.535391965354025, -88.119, -1.53796668356488),
(16096, '36633', 218, 2, 4259, 30.6707, 0.535304698891425, -88.1056, -1.53773280944512),
(16097, '36640', 218, 2, 4259, 30.683, 0.53551937438942, -88.0686, -1.53708703762188),
(16098, '36641', 218, 2, 4259, 30.6824, 0.535508902413908, -88.069, -1.53709401893889),
(16099, '36644', 218, 2, 4259, 30.6921, 0.535678199351352, -88.0429, -1.53663848800412),
(16100, '36652', 218, 2, 4259, 30.6933, 0.535699143302376, -88.0432, -1.53664372399187),
(16101, '36660', 218, 2, 4259, 30.6747, 0.535374512061505, -88.087, -1.53740817820425),
(16102, '36663', 218, 2, 4259, 30.7645, 0.536941817729796, -88.1278, -1.53812027253906),
(16103, '36670', 218, 2, 4259, 30.6982, 0.535784664435723, -88.1055, -1.53773106411586),
(16104, '36671', 218, 2, 4259, 30.7757, 0.537137294606019, -88.0796, -1.5372790238396),
(16105, '36675', 218, 2, 4259, 30.6948, 0.535725323241156, -88.0431, -1.53664197866262),
(16106, '36685', 218, 2, 4259, 30.6879, 0.535604895522768, -88.2948, -1.54103497238989),
(16107, '36688', 218, 2, 4259, 30.6903, 0.535646783424816, -88.1877, -1.539165724761),
(16108, '36689', 218, 2, 4259, 30.6888, 0.535620603486036, -88.173, -1.53890916136096),
(16109, '36690', 218, 2, 4259, 30.6932, 0.535697397973124, -88.0565, -1.53687585278239),
(16110, '36691', 218, 2, 4259, 30.6946, 0.535721832582651, -88.0431, -1.53664197866262),
(16111, '36693', 218, 2, 4259, 30.6312, 0.534615293836887, -88.1579, -1.53864561664391),
(16112, '36695', 218, 2, 4259, 30.6465, 0.534882329212442, -88.2377, -1.540038389387),
(16113, '36701', 218, 2, 5731, 32.4164, 0.56577291164349, -87.0285, -1.51893386807188),
(16114, '36702', 218, 2, 5731, 32.4058, 0.565587906742778, -87.0238, -1.51885183759704),
(16115, '36703', 218, 2, 5731, 32.4188, 0.565814799545538, -87.0064, -1.51854815030719),
(16116, '36720', 218, 2, 34519, 32.1151, 0.560514234607231, -87.3292, -1.52418207313263),
(16117, '36721', 218, 2, 0, 32.0731, 0.559781196321393, -87.5617, -1.52823996364352),
(16118, '36722', 218, 2, 15026, 32.0446, 0.559283777484575, -87.5877, -1.52869374924904),
(16119, '36723', 218, 2, 1071, 32.0774, 0.559856245479229, -87.2802, -1.52332686179915),
(16120, '36726', 218, 2, 1304, 31.9992, 0.558491398004169, -87.2988, -1.52365149304003),
(16121, '36727', 218, 2, 1317, 31.967, 0.557929401985027, -88.0059, -1.53599271618088),
(16122, '36728', 218, 2, 1398, 32.203, 0.562048379019734, -87.4807, -1.5268262469494),
(16123, '36732', 218, 2, 2025, 32.5081, 0.567373378567569, -87.838, -1.53306230836678),
(16124, '36736', 218, 2, 2052, 32.0568, 0.559496707653318, -87.7288, -1.5311564088236),
(16125, '36738', 218, 2, 2424, 32.4094, 0.56565073859585, -87.6146, -1.52916324281782),
(16126, '36740', 218, 2, 2550, 32.6519, 0.569883162031936, -87.8715, -1.5336469936662),
(16127, '36741', 218, 2, 2635, 32.0033, 0.558562956503501, -86.9644, -1.51781511202136),
(16128, '36742', 218, 2, 2647, 32.5417, 0.567959809196239, -87.705, -1.53074102046163),
(16129, '36744', 218, 2, 2866, 32.7017, 0.57075233599943, -87.5986, -1.5288839901375),
(16130, '36745', 218, 2, 3409, 32.3852, 0.565228368916868, -87.9026, -1.53418979106357),
(16131, '36748', 218, 2, 3784, 32.3037, 0.563805925576492, -87.7946, -1.53230483547141),
(16132, '36749', 218, 2, 3445, 32.4755, 0.566804401231418, -86.8486, -1.51579402074755),
(16133, '36750', 218, 2, 3981, 32.7911, 0.572312660350713, -86.8722, -1.51620591845102),
(16134, '36751', 218, 2, 3885, 31.8519, 0.555920528015982, -87.5704, -1.52839180728844),
(16135, '36752', 218, 2, 3891, 32.3007, 0.563753565698932, -86.6187, -1.51178150879721);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(16136, '36753', 218, 2, 4119, 31.8313, 0.555560990190071, -87.0934, -1.52006658675643),
(16137, '36754', 218, 2, 3947, 32.1395, 0.560940094944718, -87.7186, -1.5309783852399),
(16138, '36756', 218, 2, 630, 32.6269, 0.569446829718938, -87.3198, -1.52401801218294),
(16139, '36758', 218, 2, 5108, 32.5945, 0.568881343041292, -86.941, -1.51740670497639),
(16140, '36759', 218, 2, 3998, 32.4418, 0.566216225273496, -87.2816, -1.52335129640868),
(16141, '36761', 218, 2, 4246, 32.0862, 0.560009834453405, -87.0157, -1.51871046592763),
(16142, '36762', 218, 2, 4343, 31.9707, 0.557993979167351, -87.9754, -1.53546039075902),
(16143, '36763', 218, 2, 4471, 32.2476, 0.562826795866123, -87.9475, -1.53497344389771),
(16144, '36764', 218, 2, 4476, 32.1131, 0.560479328022191, -87.9881, -1.53568204757402),
(16145, '36765', 218, 2, 4562, 32.5468, 0.56804882098809, -87.586, -1.52866407865175),
(16146, '36766', 218, 2, 4679, 31.922, 0.55714400382163, -87.0881, -1.51997408430607),
(16147, '36767', 218, 2, 4801, 32.3191, 0.564074706281299, -87.0974, -1.52013639992651),
(16148, '36768', 218, 2, 5015, 31.9378, 0.557419765843445, -87.0097, -1.51860574617251),
(16149, '36769', 218, 2, 953, 31.9482, 0.557601280085652, -87.5568, -1.52815444251017),
(16150, '36773', 218, 2, 5600, 32.2821, 0.563428934458061, -87.4165, -1.52570574556962),
(16151, '36775', 218, 2, 715, 32.266, 0.56314793644849, -86.9881, -1.51822875505408),
(16152, '36776', 218, 2, 5676, 32.7045, 0.570801205218486, -87.5965, -1.52884733822321),
(16153, '36778', 218, 2, 192, 32.0044, 0.558582155125273, -87.0076, -1.51856909425822),
(16154, '36779', 218, 2, 6037, 32.6795, 0.570364872905487, -87.1407, -1.52089212749262),
(16155, '36782', 218, 2, 6195, 32.0795, 0.559892897393521, -87.9453, -1.53493504665417),
(16156, '36783', 218, 2, 6315, 32.2678, 0.563179352375026, -87.6252, -1.52934824771854),
(16157, '36784', 218, 2, 6316, 31.891, 0.556602951753512, -87.7483, -1.53149674802774),
(16158, '36785', 218, 2, 6437, 32.2703, 0.563222985606326, -86.8491, -1.51580274739381),
(16159, '36786', 218, 2, 6475, 32.4596, 0.566526893880351, -87.4645, -1.52654350361058),
(16160, '36790', 218, 2, 6052, 32.7106, 0.570907670302857, -86.9191, -1.5170244778702),
(16161, '36792', 218, 2, 5293, 32.8912, 0.574059734931959, -86.9066, -1.5168063117137),
(16162, '36793', 218, 2, 3693, 32.8693, 0.573677507825772, -86.962, -1.51777322411931),
(16163, '36801', 218, 2, 4790, 32.6398, 0.569671977192445, -85.3824, -1.49020400325481),
(16164, '36802', 218, 2, 4790, 32.5958, 0.568904032321568, -85.3182, -1.48908350187503),
(16165, '36803', 218, 2, 4790, 32.6446, 0.569755752996541, -85.3737, -1.49005215960988),
(16166, '36804', 218, 2, 4790, 32.6538, 0.569916323287724, -85.3792, -1.49014815271874),
(16167, '36830', 218, 2, 13306, 32.6007, 0.568989553454915, -85.4757, -1.49183239544692),
(16168, '36831', 218, 2, 13306, 32.6076, 0.569109981173303, -85.4811, -1.49192664322652),
(16169, '36832', 218, 2, 13306, 32.5933, 0.568860399090268, -85.4799, -1.4919056992755),
(16170, '36849', 218, 2, 0, 32.6013, 0.569000025430427, -85.508, -1.49239613679531),
(16171, '36850', 218, 2, 1314, 32.8973, 0.574166200016331, -85.5751, -1.4935672527234),
(16172, '36851', 218, 2, 1799, 32.1456, 0.561046560029089, -85.0645, -1.48465560156272),
(16173, '36852', 218, 2, 1937, 32.7597, 0.571764626965586, -85.2421, -1.48775530631426),
(16174, '36853', 218, 2, 1944, 32.8261, 0.572923525588911, -85.7617, -1.49682403710762),
(16175, '36854', 218, 2, 6497, 32.8107, 0.572654744884103, -85.1817, -1.48670112744605),
(16176, '36855', 218, 2, 2458, 33.0478, 0.576792920540582, -85.2682, -1.48821083724903),
(16177, '36856', 218, 2, 2558, 32.3414, 0.564463914704494, -85.0218, -1.48391034597211),
(16178, '36858', 218, 2, 3003, 32.2207, 0.562357302297337, -85.2388, -1.48769771044894),
(16179, '36859', 218, 2, 3210, 32.1717, 0.56150209096386, -85.1301, -1.48580053755202),
(16180, '36860', 218, 2, 3304, 32.2355, 0.562615611026632, -85.4166, -1.49080090585899),
(16181, '36861', 218, 2, 3393, 32.8814, 0.573888692665263, -85.8263, -1.49795151980441),
(16182, '36862', 218, 2, 3594, 32.8954, 0.574133038760543, -85.4347, -1.4911168104536),
(16183, '36863', 218, 2, 3660, 32.8686, 0.573665290521008, -85.2361, -1.48765058655914),
(16184, '36865', 218, 2, 3829, 32.6197, 0.569321166012794, -85.6016, -1.49402976497518),
(16185, '36866', 218, 2, 4650, 32.5609, 0.568294912412622, -85.6634, -1.49510837845291),
(16186, '36867', 218, 2, 4981, 32.4722, 0.566746805366103, -85.019, -1.48386147675306),
(16187, '36868', 218, 2, 4981, 32.4523, 0.566399484844956, -85.0091, -1.48368868915711),
(16188, '36869', 218, 2, 4981, 32.4411, 0.566204007968732, -85.0285, -1.484027283032),
(16189, '36870', 218, 2, 4981, 32.4655, 0.566629868306219, -85.0146, -1.48378468226597),
(16190, '36871', 218, 2, 5100, 32.1881, 0.561788324961187, -85.2246, -1.48744987369516),
(16191, '36872', 218, 2, 6497, 32.7811, 0.572138127425513, -85.148, -1.48611295148813),
(16192, '36874', 218, 2, 126, 32.5382, 0.567898722672419, -85.2213, -1.48739227782984),
(16193, '36875', 218, 2, 5710, 32.3373, 0.564392356205162, -85.0205, -1.48388765669184),
(16194, '36877', 218, 2, 5920, 32.5384, 0.567902213330923, -85.0991, -1.48525948548391),
(16195, '36879', 218, 2, 6664, 32.7856, 0.572216667241853, -85.5321, -1.49281676114504),
(16196, '36901', 218, 2, 240, 32.4491, 0.566343634308892, -88.1332, -1.53821452031867),
(16197, '36904', 218, 2, 1257, 32.0905, 0.56008488361124, -88.2202, -1.5397329567679),
(16198, '36906', 218, 2, 1893, 32.2288, 0.562498673966748, -88.2743, -1.54067717989323),
(16199, '36907', 218, 2, 1912, 32.3931, 0.565366249927775, -88.3604, -1.5421799083792),
(16200, '36908', 218, 2, 2715, 31.8623, 0.556102042258189, -88.3401, -1.54182560654104),
(16201, '36910', 218, 2, 3380, 32.239, 0.562676697550452, -88.2206, -1.53973993808491),
(16202, '36912', 218, 2, 3795, 32.2413, 0.562716840123248, -88.3445, -1.54190240102813),
(16203, '36913', 218, 2, 4160, 31.9299, 0.557281884832537, -88.459, -1.54390080302166),
(16204, '36915', 218, 2, 4495, 32.0122, 0.558718290806929, -88.3378, -1.54178546396825),
(16205, '36916', 218, 2, 4945, 32.2468, 0.562812833232108, -88.0811, -1.53730520377838),
(16206, '36919', 218, 2, 5852, 31.7619, 0.554349731689187, -88.3027, -1.5411728534008),
(16207, '36921', 218, 2, 6370, 31.9654, 0.557901476716995, -88.3582, -1.54214151113565),
(16208, '36922', 218, 2, 861, 31.1325, 0.543364629377135, -87.07, -1.51965817971146),
(16209, '36925', 218, 2, 6986, 32.4869, 0.567003368766146, -88.2943, -1.54102624574363),
(16210, '37010', 218, 50, 14941, 36.5725, 0.638310540685626, -87.0745, -1.5197367195278),
(16211, '37011', 218, 50, 147, 36.1707, 0.631297807751113, -86.8826, -1.51638743269323),
(16212, '37012', 218, 50, 34524, 36.0773, 0.62966767022975, -86.0343, -1.50158180464856),
(16213, '37013', 218, 50, 147, 36.06, 0.629365728269155, -86.6492, -1.51231383421907),
(16214, '37014', 218, 50, 31674, 35.8662, 0.62598328017879, -86.6835, -1.5129124821525),
(16215, '37015', 218, 50, 84735, 36.2857, 0.633304936390906, -87.0684, -1.51963025444343),
(16216, '37016', 218, 50, 84749, 35.9907, 0.628156215097523, -86.1147, -1.50298504936716),
(16217, '37018', 218, 50, 71777, 35.62, 0.62168627956038, -86.1724, -1.50399210434556),
(16218, '37019', 218, 50, 7375, 35.5156, 0.619864155821298, -86.8087, -1.515097634376),
(16219, '37020', 218, 50, 84931, 35.6057, 0.621436697477345, -86.4073, -1.5080918827585),
(16220, '37022', 218, 50, 53458, 36.5164, 0.637331410975257, -86.3249, -1.50665373145485),
(16221, '37023', 218, 50, 7474, 36.5966, 0.638731165035357, -87.6988, -1.530632810048),
(16222, '37024', 218, 50, 1106, 35.9984, 0.628290605449927, -86.7876, -1.51472936990383),
(16223, '37025', 218, 50, 85193, 35.9321, 0.627133452155854, -87.2464, -1.52273694051198),
(16224, '37026', 218, 50, 85248, 35.6995, 0.623073816315716, -86.1012, -1.50274942991814),
(16225, '37027', 218, 50, 1106, 35.9996, 0.628311549400951, -86.7912, -1.5147922017569),
(16226, '37028', 218, 50, 85418, 36.6596, 0.639830722464113, -87.8291, -1.53290697406335),
(16227, '37029', 218, 50, 1244, 36.0738, 0.62960658370593, -87.29, -1.52349790406585),
(16228, '37030', 218, 50, 7932, 36.2533, 0.63273944971326, -85.9555, -1.50020648519799),
(16229, '37031', 218, 50, 58915, 36.3833, 0.635008377740853, -86.3156, -1.50649141583442),
(16230, '37032', 218, 50, 1419, 36.5116, 0.637247635171162, -87.0222, -1.51882391232901),
(16231, '37033', 218, 50, 1459, 35.8031, 0.624881977420782, -87.446, -1.52622061769896),
(16232, '37034', 218, 50, 1489, 35.6221, 0.621722931474672, -86.6197, -1.51179896208973),
(16233, '37035', 218, 50, 85708, 36.3691, 0.63476054098707, -87.1373, -1.52083278629805),
(16234, '37036', 218, 50, 8042, 36.2103, 0.631988958134903, -87.2643, -1.52304935444809),
(16235, '37037', 218, 50, 1572, 35.7403, 0.623785910650529, -86.4204, -1.50832052089051),
(16236, '37040', 218, 50, 848, 36.5312, 0.637589719704552, -87.3503, -1.5245503376048),
(16237, '37041', 218, 50, 848, 36.5614, 0.638116809138655, -87.3468, -1.52448925108098),
(16238, '37042', 218, 50, 848, 36.5616, 0.638120299797159, -87.3967, -1.52536017037773),
(16239, '37043', 218, 50, 848, 36.5158, 0.637320938999745, -87.2677, -1.52310869564266),
(16240, '37044', 218, 50, 848, 36.5301, 0.637570521082781, -87.3368, -1.52431471815578),
(16241, '37046', 218, 50, 85928, 35.7993, 0.624815654909206, -86.7297, -1.51371882426693),
(16242, '37047', 218, 50, 46001, 35.3578, 0.617110026261651, -86.8416, -1.51567184769991),
(16243, '37048', 218, 50, 1800, 36.4944, 0.636947438539819, -86.5941, -1.51135215780122),
(16244, '37049', 218, 50, 473, 36.5556, 0.638015580042039, -86.6824, -1.51289328353073),
(16245, '37050', 218, 50, 35467, 36.3726, 0.634821627510889, -87.5633, -1.52826788891155),
(16246, '37051', 218, 50, 86165, 36.3499, 0.634425437770687, -87.4396, -1.52610891662683),
(16247, '37052', 218, 50, 1923, 36.3808, 0.634964744509553, -87.4056, -1.52551550468116),
(16248, '37055', 218, 50, 20581, 36.0752, 0.629631018315458, -87.3756, -1.52499190590556),
(16249, '37056', 218, 50, 20581, 36.0763, 0.62965021693723, -87.3771, -1.52501808584434),
(16250, '37057', 218, 50, 26959, 36.4013, 0.635322537006212, -86.0398, -1.50167779775742),
(16251, '37058', 218, 50, 8583, 36.4808, 0.636710073761547, -87.8356, -1.53302042046473),
(16252, '37059', 218, 50, 86578, 36.0144, 0.628569858130246, -85.9458, -1.50003718826054),
(16253, '37060', 218, 50, 86657, 35.7467, 0.623897611722657, -86.6404, -1.5121602452449),
(16254, '37061', 218, 50, 2319, 36.2919, 0.63341314680453, -87.7458, -1.53145311479644),
(16255, '37062', 218, 50, 500, 35.9688, 0.627773987991336, -87.1264, -1.52064254540959),
(16256, '37063', 218, 50, 72584, 35.7464, 0.623892375734901, -86.3892, -1.50777597816389),
(16257, '37064', 218, 50, 2595, 35.9225, 0.626965900547663, -86.888, -1.51648168047283),
(16258, '37065', 218, 50, 2595, 35.9246, 0.627002552461955, -86.8693, -1.51615530390271),
(16259, '37066', 218, 50, 9037, 36.3898, 0.635121824142233, -86.4551, -1.50892615014095),
(16260, '37067', 218, 50, 2595, 35.9257, 0.627021751083727, -86.8056, -1.51504352916919),
(16261, '37068', 218, 50, 2595, 35.9297, 0.627091564253807, -86.842, -1.51567882901692),
(16262, '37069', 218, 50, 2595, 35.992, 0.628178904377799, -86.8962, -1.5166247974715),
(16263, '37070', 218, 50, 87328, 36.3233, 0.633961180189656, -86.7133, -1.5134325902696),
(16264, '37071', 218, 50, 87267, 36.1936, 0.63169748814982, -86.2759, -1.50579852012138),
(16265, '37072', 218, 50, 87328, 36.3248, 0.633987360128436, -86.7376, -1.51385670527783),
(16266, '37073', 218, 50, 2860, 36.4283, 0.63579377590425, -86.8021, -1.51498244264537),
(16267, '37074', 218, 50, 27395, 36.3891, 0.635109606837469, -86.1583, -1.50374601292103),
(16268, '37075', 218, 50, 65498, 36.3127, 0.633776175288945, -86.6074, -1.51158428659174),
(16269, '37076', 218, 50, 9439, 36.1856, 0.63155786180966, -86.6005, -1.51146385887335),
(16270, '37077', 218, 50, 65498, 36.3042, 0.633627822302525, -86.6201, -1.51180594340674),
(16271, '37078', 218, 50, 88046, 35.9497, 0.627440630104205, -87.7617, -1.53173062214751),
(16272, '37079', 218, 50, 55468, 36.4669, 0.63646747299552, -87.5749, -1.52847034710478),
(16273, '37080', 218, 50, 88186, 36.3216, 0.633931509592372, -86.8876, -1.51647469915583),
(16274, '37082', 218, 50, 88300, 36.0858, 0.62981602321617, -87.1185, -1.52050466439868),
(16275, '37083', 218, 50, 3594, 36.5236, 0.637457074681401, -86.0259, -1.50143519699139),
(16276, '37085', 218, 50, 88445, 35.9411, 0.627290531788534, -86.2732, -1.50575139623157),
(16277, '37086', 218, 50, 88340, 36.0116, 0.62852098891119, -86.5655, -1.51085299363515),
(16278, '37087', 218, 50, 3708, 36.2136, 0.632046554000218, -86.3088, -1.50637273344528),
(16279, '37088', 218, 50, 3708, 36.2077, 0.631943579574351, -86.2913, -1.50606730082618),
(16280, '37089', 218, 50, 88340, 35.9988, 0.628297586766935, -86.573, -1.51098389332905),
(16281, '37090', 218, 50, 3708, 36.1512, 0.630957468546974, -86.315, -1.50648094385891),
(16282, '37091', 218, 50, 3750, 35.4498, 0.618715729173486, -86.7973, -1.51489866684127),
(16283, '37095', 218, 50, 3751, 36.0057, 0.628418014485322, -85.9682, -1.50042814201299),
(16284, '37096', 218, 50, 3784, 35.5882, 0.621131264858246, -87.8783, -1.53376567605533),
(16285, '37097', 218, 50, 88638, 35.7803, 0.624484042351327, -87.7873, -1.53217742643602),
(16286, '37098', 218, 50, 30388, 35.8887, 0.626375979260489, -87.3371, -1.52431995414354),
(16287, '37101', 218, 50, 88903, 36.1377, 0.630721849097955, -87.6587, -1.52993293301795),
(16288, '37110', 218, 50, 88922, 35.6858, 0.622834706208192, -85.7777, -1.49710328978794),
(16289, '37111', 218, 50, 88922, 35.6875, 0.622864376805476, -85.7763, -1.49707885517841),
(16290, '37115', 218, 50, 3938, 36.2647, 0.632938417247988, -86.712, -1.51340990098932),
(16291, '37116', 218, 50, 3938, 36.1914, 0.631659090906276, -86.7447, -1.51398062365473),
(16292, '37118', 218, 50, 4232, 35.9179, 0.626885615402071, -86.1779, -1.50408809745442),
(16293, '37119', 218, 50, 4255, 36.6329, 0.639364719553831, -86.5379, -1.5103712827616),
(16294, '37121', 218, 50, 89206, 36.2046, 0.631889474367539, -86.5193, -1.51004665152073),
(16295, '37122', 218, 50, 89206, 36.2136, 0.632046554000218, -86.5156, -1.50998207433841),
(16296, '37127', 218, 50, 10713, 35.7733, 0.624361869303687, -86.3293, -1.50673052594194),
(16297, '37128', 218, 50, 10713, 35.8388, 0.625505059963744, -86.5366, -1.51034859348133),
(16298, '37129', 218, 50, 10713, 35.8703, 0.626054838678122, -86.4348, -1.50857184830279),
(16299, '37130', 218, 50, 10713, 35.8474, 0.625655158279415, -86.3714, -1.50746530955703),
(16300, '37131', 218, 50, 10713, 35.8533, 0.625758132705283, -86.3944, -1.50786673528499),
(16301, '37132', 218, 50, 10713, 35.8478, 0.625662139596423, -86.3641, -1.50733790052163),
(16302, '37133', 218, 50, 10713, 35.8374, 0.625480625354216, -86.3935, -1.50785102732172),
(16303, '37134', 218, 50, 89394, 36.012, 0.628527970228198, -87.9654, -1.53528585783382),
(16304, '37135', 218, 50, 89446, 35.9432, 0.627327183702826, -86.6723, -1.51271700527628),
(16305, '37136', 218, 50, 89451, 36.1936, 0.63169748814982, -86.2757, -1.50579502946287),
(16306, '37137', 218, 50, 89505, 35.8368, 0.625470153378704, -87.4475, -1.52624679763774),
(16307, '37138', 218, 50, 10943, 36.2453, 0.632599823373101, -86.6326, -1.51202410956324),
(16308, '37140', 218, 50, 56689, 35.872, 0.626084509275406, -87.6536, -1.5298439212261),
(16309, '37141', 218, 50, 89698, 36.6145, 0.639043578971464, -86.7178, -1.51351113008594),
(16310, '37142', 218, 50, 4846, 36.408, 0.635439474066096, -87.5071, -1.52728701387193),
(16311, '37143', 218, 50, 28212, 36.1132, 0.630294243431216, -87.0442, -1.51920788476445),
(16312, '37144', 218, 50, 14402, 35.3777, 0.617457346782798, -86.5894, -1.51127012732638),
(16313, '37145', 218, 50, 90011, 36.3537, 0.634491760282263, -85.9, -1.49923782746313),
(16314, '37146', 218, 50, 5152, 36.3866, 0.635065973606169, -87.0379, -1.51909792902157),
(16315, '37147', 218, 50, 14431, 35.6687, 0.622536254906101, -87.6566, -1.52989628110366),
(16316, '37148', 218, 50, 5188, 36.5671, 0.638216292906019, -86.4898, -1.50953177939139),
(16317, '37149', 218, 50, 90224, 35.8261, 0.62528340314874, -86.2211, -1.50484207969128),
(16318, '37150', 218, 50, 90233, 36.5325, 0.637612408984828, -85.8486, -1.4983407282276),
(16319, '37151', 218, 50, 71334, 36.3497, 0.634421947112183, -86.0303, -1.50151199147848),
(16320, '37152', 218, 50, 37926, 36.4053, 0.635392350176292, -86.7709, -1.51443789991875),
(16321, '37153', 218, 50, 37980, 35.6858, 0.622834706208192, -86.5694, -1.51092106147598),
(16322, '37155', 218, 50, 90567, 36.6085, 0.638938859216344, -87.2824, -1.5233652590427),
(16323, '37160', 218, 50, 11899, 35.4729, 0.619118900230697, -86.4684, -1.50915827893146),
(16324, '37161', 218, 50, 11899, 35.4837, 0.619307395789912, -86.4602, -1.5090151619328),
(16325, '37162', 218, 50, 11899, 35.4899, 0.619415606203536, -86.4463, -1.50877256116677),
(16326, '37165', 218, 50, 981, 36.2248, 0.632242030876442, -87.4624, -1.52650685169629),
(16327, '37166', 218, 50, 12002, 35.9585, 0.627594219078381, -85.8256, -1.49793930249965),
(16328, '37167', 218, 50, 452, 35.9647, 0.627702429492005, -86.5149, -1.50996985703364),
(16329, '37171', 218, 50, 5980, 36.3611, 0.63462091464691, -87.3039, -1.52374050483188),
(16330, '37172', 218, 50, 349, 36.5232, 0.637450093364393, -86.8688, -1.51614657725645),
(16331, '37174', 218, 50, 719, 35.7534, 0.624014548782541, -86.8829, -1.51639266868098),
(16332, '37175', 218, 50, 6081, 36.3214, 0.633928018933868, -87.8929, -1.53402049412612),
(16333, '37178', 218, 50, 91284, 36.3148, 0.633812827203237, -87.7638, -1.5317672740618),
(16334, '37179', 218, 50, 91318, 35.8003, 0.624833108201726, -86.905, -1.51677838644567),
(16335, '37180', 218, 50, 25657, 35.6224, 0.621728167462428, -86.5695, -1.51092280680523),
(16336, '37181', 218, 50, 91554, 36.2236, 0.632221086925418, -87.462, -1.52649987037928),
(16337, '37183', 218, 50, 28911, 35.5035, 0.619652970981807, -86.3394, -1.50690680419639),
(16338, '37184', 218, 50, 18507, 36.1078, 0.630199995651608, -86.1368, -1.50337076713185),
(16339, '37185', 218, 50, 6664, 36.0866, 0.629829985850186, -87.7894, -1.53221407835031),
(16340, '37186', 218, 50, 34392, 36.5865, 0.638554886780905, -86.2675, -1.50565191246421),
(16341, '37187', 218, 50, 12797, 36.118, 0.630378019235312, -87.2272, -1.5224018372956),
(16342, '37188', 218, 50, 58264, 36.4848, 0.636779886931627, -86.6854, -1.51294564340829),
(16343, '37189', 218, 50, 91840, 36.2749, 0.633116440831691, -86.8302, -1.51547288016518),
(16344, '37190', 218, 50, 362, 35.815, 0.625089671601769, -86.0716, -1.50223281245955),
(16345, '37191', 218, 50, 6936, 36.5033, 0.637102772843246, -87.5392, -1.52784726456182),
(16346, '37201', 218, 50, 10729, 36.1643, 0.631186106678985, -86.7771, -1.51454611033237),
(16347, '37202', 218, 50, 10729, 36.149, 0.63091907130343, -86.7909, -1.51478696576915),
(16348, '37203', 218, 50, 10729, 36.1551, 0.631025536387802, -86.7951, -1.51486026959773),
(16349, '37204', 218, 50, 10729, 36.1104, 0.63024537421216, -86.7788, -1.51457578092966),
(16350, '37205', 218, 50, 10729, 36.1114, 0.63026282750468, -86.8671, -1.51611690665917),
(16351, '37206', 218, 50, 10729, 36.1814, 0.631484557981076, -86.7369, -1.51384448797307),
(16352, '37207', 218, 50, 10729, 36.224, 0.632228068242426, -86.7755, -1.51451818506434),
(16353, '37208', 218, 50, 10729, 36.1737, 0.631350167628673, -86.8075, -1.51507669042498),
(16354, '37209', 218, 50, 10729, 36.1499, 0.630934779266698, -86.8667, -1.51610992534216),
(16355, '37210', 218, 50, 10729, 36.1394, 0.630751519695239, -86.74, -1.51389859317988),
(16356, '37211', 218, 50, 10729, 36.0779, 0.629678142205262, -86.7206, -1.51355999930499),
(16357, '37212', 218, 50, 10729, 36.1344, 0.630664253232639, -86.8033, -1.51500338659639),
(16358, '37213', 218, 50, 10729, 36.1622, 0.631149454764693, -86.7588, -1.51422671507926),
(16359, '37214', 218, 50, 10729, 36.1636, 0.631173889374221, -86.6612, -1.51252327372931),
(16360, '37215', 218, 50, 10729, 36.0955, 0.629985320153613, -86.826, -1.5153995763366),
(16361, '37216', 218, 50, 10729, 36.2129, 0.632034336695455, -86.7255, -1.51364552043834),
(16362, '37217', 218, 50, 10729, 36.1024, 0.630105747872001, -86.658, -1.51246742319325),
(16363, '37218', 218, 50, 10729, 36.2205, 0.632166981718606, -86.8576, -1.51595110038023),
(16364, '37219', 218, 50, 10729, 36.1658, 0.631212286617765, -86.7869, -1.51471715259907),
(16365, '37220', 218, 50, 10729, 36.0619, 0.629398889524943, -86.7768, -1.51454087434462),
(16366, '37221', 218, 50, 10729, 36.0745, 0.629618801010694, -86.9477, -1.51752364203627),
(16367, '37222', 218, 50, 10729, 36.0697, 0.629535025206599, -86.7262, -1.51365773774311),
(16368, '37224', 218, 50, 10729, 36.1501, 0.630938269925202, -86.7925, -1.51481489103718),
(16369, '37227', 218, 50, 10729, 36.1323, 0.630627601318347, -86.6714, -1.51270129731301),
(16370, '37228', 218, 50, 10729, 36.1916, 0.63166258156478, -86.8004, -1.51495277204809),
(16371, '37229', 218, 50, 10729, 36.1655, 0.631207050630009, -86.6641, -1.51257388827762),
(16372, '37230', 218, 50, 10729, 36.1495, 0.63092779794969, -86.789, -1.51475380451336),
(16373, '37232', 218, 50, 10729, 36.1432, 0.630817842206814, -86.8095, -1.51511159701002),
(16374, '37234', 218, 50, 10729, 36.1502, 0.630940015254454, -86.7908, -1.51478522043989),
(16375, '37235', 218, 50, 10729, 36.1499, 0.630934779266698, -86.79, -1.51477125780588),
(16376, '37236', 218, 50, 10729, 36.1532, 0.630992375132014, -86.8017, -1.51497546132836),
(16377, '37237', 218, 50, 10729, 36.1642, 0.631184361349733, -86.7748, -1.51450596775958),
(16378, '37238', 218, 50, 10729, 36.1639, 0.631179125361977, -86.7745, -1.51450073177182),
(16379, '37239', 218, 50, 10729, 36.1675, 0.631241957215049, -86.7854, -1.51469097266029),
(16380, '37240', 218, 50, 10729, 36.1422, 0.630800388914295, -86.8052, -1.51503654785218),
(16381, '37241', 218, 50, 10729, 36.1103, 0.630243628882908, -86.6765, -1.51279030910487),
(16382, '37242', 218, 50, 10729, 36.1673, 0.631238466556545, -86.7854, -1.51469097266029),
(16383, '37243', 218, 50, 10729, 36.1525, 0.63098015782725, -86.8022, -1.51498418797462),
(16384, '37244', 218, 50, 10729, 36.167, 0.631233230568789, -86.785, -1.51468399134328),
(16385, '37245', 218, 50, 10729, 36.1669, 0.631231485239537, -86.7849, -1.51468224601403),
(16386, '37246', 218, 50, 10729, 36.1661, 0.631217522605521, -86.7848, -1.51468050068478),
(16387, '37247', 218, 50, 10729, 36.1671, 0.631234975898041, -86.7856, -1.51469446331879),
(16388, '37248', 218, 50, 10729, 36.1673, 0.631238466556545, -86.7849, -1.51468224601403),
(16389, '37249', 218, 50, 10729, 36.1676, 0.631243702544301, -86.7847, -1.51467875535552),
(16390, '37250', 218, 50, 10729, 36.1614, 0.631135492130678, -86.784, -1.51466653805076),
(16391, '37301', 218, 50, 26361, 35.4165, 0.618134534532572, -85.7975, -1.49744886497984),
(16392, '37302', 218, 50, 84689, 35.0116, 0.611067696391247, -85.0194, -1.48386845807007),
(16393, '37303', 218, 50, 7182, 35.4466, 0.618659878637422, -84.6004, -1.47655552850421),
(16394, '37304', 218, 50, 84796, 35.3437, 0.61686393483712, -85.1419, -1.48600648640376),
(16395, '37305', 218, 50, 84918, 35.4843, 0.619317867765424, -85.6515, -1.49490068427192),
(16396, '37306', 218, 50, 13361, 35.2012, 0.614376840653028, -85.9021, -1.49927447937742),
(16397, '37307', 218, 50, 358, 35.0228, 0.61126317326747, -84.3411, -1.47202988975379),
(16398, '37308', 218, 50, 44838, 35.3062, 0.616209436367622, -85.0096, -1.48369741580337),
(16399, '37309', 218, 50, 1294, 35.3833, 0.61755508522091, -84.7643, -1.47941612314823),
(16400, '37310', 218, 50, 8039, 35.2618, 0.615434510179736, -84.8696, -1.48125395485058),
(16401, '37311', 218, 50, 1620, 35.1587, 0.61363507572093, -84.8707, -1.48127315347235),
(16402, '37312', 218, 50, 1620, 35.1984, 0.614327971433972, -84.8619, -1.48111956449818),
(16403, '37313', 218, 50, 1664, 35.4057, 0.617946038973356, -85.6459, -1.49480294583381),
(16404, '37314', 218, 50, 0, 35.4618, 0.618925168683725, -84.3437, -1.47207526831434),
(16405, '37315', 218, 50, 85935, 35.0464, 0.611675070970941, -85.0448, -1.48431177170007),
(16406, '37316', 218, 50, 85971, 35.005, 0.610952504660615, -84.7354, -1.4789117229944),
(16407, '37317', 218, 50, 86005, 34.9896, 0.610683723955808, -84.3705, -1.47254301655388),
(16408, '37318', 218, 50, 8268, 35.1651, 0.613746776793058, -86.0135, -1.50121877616414),
(16409, '37320', 218, 50, 1620, 35.1592, 0.61364380236719, -84.877, -1.48138310921523),
(16410, '37321', 218, 50, 1992, 35.4921, 0.619454003447079, -85.0166, -1.48381958885101),
(16411, '37322', 218, 50, 2007, 35.454, 0.61878903300207, -84.9128, -1.48200793708744),
(16412, '37323', 218, 50, 1620, 35.1216, 0.61298755856844, -84.8651, -1.48117541503424),
(16413, '37324', 218, 50, 86263, 35.2093, 0.614518212322439, -86.0832, -1.50243527065278),
(16414, '37325', 218, 50, 72302, 35.2509, 0.615244269291269, -84.6239, -1.47696568087843),
(16415, '37326', 218, 50, 20693, 35.0359, 0.611491811399481, -84.3826, -1.47275420139337),
(16416, '37327', 218, 50, 8626, 35.3718, 0.61735437235693, -85.3915, -1.49036282821674),
(16417, '37328', 218, 50, 86791, 35.0347, 0.611470867448457, -86.4227, -1.5083606634633),
(16418, '37329', 218, 50, 2297, 35.3318, 0.616656240656133, -84.5217, -1.47518195438289),
(16419, '37330', 218, 50, 86839, 35.2734, 0.615636968372968, -86.1309, -1.50326779270598),
(16420, '37331', 218, 50, 8785, 35.3272, 0.616575955510541, -84.5295, -1.47531809006455),
(16421, '37332', 218, 50, 86856, 35.6156, 0.621609485073292, -84.9966, -1.48347052300061),
(16422, '37333', 218, 50, 86944, 35.1383, 0.613279028553524, -84.3283, -1.47180648760953),
(16423, '37334', 218, 50, 2428, 35.1522, 0.613521629319551, -86.5763, -1.51104148919437),
(16424, '37335', 218, 50, 35933, 35.0203, 0.61121954003617, -86.4373, -1.50861548153409),
(16425, '37336', 218, 50, 2693, 35.2705, 0.61558635382466, -84.9866, -1.48329599007541),
(16426, '37337', 218, 50, 534, 35.7678, 0.624265876194828, -84.8546, -1.48099215546278),
(16427, '37338', 218, 50, 2830, 35.4498, 0.618715729173486, -85.0832, -1.48498197813284),
(16428, '37339', 218, 50, 0, 35.3615, 0.617174603443975, -85.7402, -1.49644879131844),
(16429, '37340', 218, 50, 55113, 35.0178, 0.61117590680487, -85.5101, -1.4924327887096),
(16430, '37341', 218, 50, 9353, 35.175, 0.613919564389005, -85.0947, -1.48518269099682),
(16431, '37342', 218, 50, 3145, 35.389, 0.617654568988273, -85.9978, -1.50094475947158),
(16432, '37343', 218, 50, 87877, 35.1631, 0.613711870208018, -85.214, -1.48726486879445),
(16433, '37345', 218, 50, 88033, 35.0536, 0.611800734677084, -86.2714, -1.50571998030504),
(16434, '37347', 218, 50, 738, 35.0703, 0.612092204662167, -85.6303, -1.4945306744705),
(16435, '37348', 218, 50, 9828, 35.1078, 0.612746703131665, -86.465, -1.5090989377369),
(16436, '37349', 218, 50, 585, 35.469, 0.619050832389869, -86.0808, -1.50239338275073),
(16437, '37350', 218, 50, 22740, 35.0002, 0.610868728856519, -85.3521, -1.48967516849145),
(16438, '37351', 218, 50, 88720, 35.1034, 0.612669908644577, -85.2635, -1.48812880677419),
(16439, '37352', 218, 50, 16971, 35.2617, 0.615432764850484, -86.3843, -1.50769045703054),
(16440, '37353', 218, 50, 815, 35.0755, 0.612182961783271, -85.0094, -1.48369392514487),
(16441, '37354', 218, 50, 37022, 35.5201, 0.619942695637638, -84.3648, -1.47244353278651),
(16442, '37355', 218, 50, 585, 35.4761, 0.61917475076676, -86.1062, -1.50283669638074),
(16443, '37356', 218, 50, 89110, 35.2212, 0.614725906503427, -85.8487, -1.49834247355686),
(16444, '37357', 218, 50, 42178, 35.5864, 0.62109984893171, -85.9363, -1.4998713819816),
(16445, '37359', 218, 50, 4454, 35.1829, 0.614057445399913, -86.4198, -1.508310048915),
(16446, '37360', 218, 50, 17293, 35.4132, 0.618076938667256, -86.238, -1.50513704033487),
(16447, '37361', 218, 50, 17385, 35.1068, 0.612729249839145, -84.7084, -1.47844048409636),
(16448, '37362', 218, 50, 89669, 35.044, 0.611633183068893, -84.643, -1.47729903876556),
(16449, '37363', 218, 50, 89685, 35.0871, 0.612385419976502, -85.0601, -1.48457880707563),
(16450, '37364', 218, 50, 1620, 35.159, 0.613640311708686, -84.8351, -1.48065181625864),
(16451, '37365', 218, 50, 337, 35.3774, 0.617452110795042, -85.5689, -1.49345904230978),
(16452, '37366', 218, 50, 4936, 35.3214, 0.616474726413925, -85.788, -1.4972830587009),
(16453, '37367', 218, 50, 5005, 35.6154, 0.621605994414788, -85.1901, -1.48684773510322),
(16454, '37369', 218, 50, 14477, 35.1826, 0.614052209412157, -84.5062, -1.47491142834883),
(16455, '37370', 218, 50, 11557, 35.3268, 0.616568974193533, -84.6595, -1.47758701809214),
(16456, '37371', 218, 50, 7182, 35.4422, 0.618583084150334, -84.5926, -1.47641939282256),
(16457, '37372', 218, 50, 24596, 35.2132, 0.614586280163267, -85.8865, -1.49900220801411),
(16458, '37373', 218, 50, 90583, 35.3842, 0.617570793184178, -85.0972, -1.48522632422812),
(16459, '37374', 218, 50, 90669, 35.1911, 0.614200562398576, -85.6603, -1.4950542732461),
(16460, '37375', 218, 50, 90699, 35.2042, 0.614429200530588, -85.921, -1.49960434660605),
(16461, '37376', 218, 50, 14604, 35.0551, 0.611826914615864, -85.9662, -1.50039323542795),
(16462, '37377', 218, 50, 90815, 35.1502, 0.613486722734511, -85.33, -1.48928945072676),
(16463, '37378', 218, 50, 90859, 35.6493, 0.622197661031214, -85.833, -1.49806845686429),
(16464, '37379', 218, 50, 0, 35.2642, 0.615476398081784, -85.1578, -1.48628399375483),
(16465, '37380', 218, 50, 90922, 35.0098, 0.611036280464711, -85.7115, -1.49594788182312),
(16466, '37381', 218, 50, 57670, 35.67, 0.622558944186377, -84.8528, -1.48096073953624),
(16467, '37382', 218, 50, 91138, 35.5597, 0.620633846021428, -85.992, -1.50084353037496),
(16468, '37383', 218, 50, 90699, 35.2012, 0.614376840653028, -85.9205, -1.49959561995979),
(16469, '37384', 218, 50, 0, 35.272, 0.61561253376344, -85.17, -1.48649692392357),
(16470, '37385', 218, 50, 91268, 35.3398, 0.616795866996292, -84.2345, -1.47016936877116),
(16471, '37387', 218, 50, 91399, 35.2801, 0.615753905432851, -85.7344, -1.49634756222183),
(16472, '37388', 218, 50, 91435, 35.3709, 0.617338664393662, -86.2117, -1.5046780187416),
(16473, '37389', 218, 50, 0, 35.3209, 0.616465999767665, -86.0667, -1.5021472913262),
(16474, '37391', 218, 50, 91449, 35.144, 0.613378512320887, -84.3671, -1.47248367535931),
(16475, '37394', 218, 50, 12571, 35.5381, 0.620256854902997, -85.8591, -1.49852398779906),
(16476, '37395', 218, 50, 0, 35.6174, 0.621640900999828, -84.7539, -1.47923460890602),
(16477, '37396', 218, 50, 6794, 35.0928, 0.612484903743866, -85.3977, -1.49047103863036),
(16478, '37397', 218, 50, 91856, 35.2006, 0.614366368677516, -85.5151, -1.4925200551722),
(16479, '37398', 218, 50, 12894, 35.187, 0.614129003899245, -86.1099, -1.50290127356307),
(16480, '37401', 218, 50, 75409, 35.0375, 0.611519736667513, -85.3077, -1.48890024230357),
(16481, '37402', 218, 50, 75409, 35.0448, 0.611647145702909, -85.3081, -1.48890722362057),
(16482, '37403', 218, 50, 75409, 35.0457, 0.611662853666177, -85.2983, -1.48873618135388),
(16483, '37404', 218, 50, 75409, 35.0302, 0.611392327632118, -85.2726, -1.48828763173612),
(16484, '37405', 218, 50, 75409, 35.0749, 0.612172489807759, -85.3091, -1.48892467691309),
(16485, '37406', 218, 50, 75409, 35.0642, 0.611985739577796, -85.2462, -1.48782686481359),
(16486, '37407', 218, 50, 75409, 35.0009, 0.610880946161283, -85.2863, -1.48852674184364),
(16487, '37408', 218, 50, 75409, 35.0297, 0.611383600985858, -85.3068, -1.4888845343403),
(16488, '37409', 218, 50, 75409, 35.0013, 0.610887927478291, -85.3352, -1.48938020784787),
(16489, '37410', 218, 50, 75409, 35.0028, 0.610914107417071, -85.3143, -1.4890154340342),
(16490, '37411', 218, 50, 75409, 35.0267, 0.611331241108298, -85.2357, -1.48764360524213),
(16491, '37412', 218, 50, 75409, 34.9975, 0.610821604966716, -85.2352, -1.48763487859587),
(16492, '37414', 218, 50, 75409, 35.0256, 0.611312042486526, -85.2314, -1.48756855608429),
(16493, '37415', 218, 50, 75409, 35.1188, 0.612938689349385, -85.2845, -1.4884953259171),
(16494, '37416', 218, 50, 75409, 35.0957, 0.612535518292174, -85.1537, -1.4862124352555),
(16495, '37419', 218, 50, 75409, 35.0331, 0.611442942180425, -85.3675, -1.48994394919626),
(16496, '37421', 218, 50, 75409, 35.027, 0.611336477096054, -85.1458, -1.48607455424459),
(16497, '37422', 218, 50, 75409, 35.1397, 0.613303463163051, -85.3483, -1.48960884597988),
(16498, '37424', 218, 50, 75409, 35.0297, 0.611383600985858, -85.1493, -1.48613564076841),
(16499, '37450', 218, 50, 75409, 35.0452, 0.611654127019917, -85.3086, -1.48891595026683),
(16500, '37501', 218, 50, 4163, 35.0689, 0.612067770052639, -89.9585, -1.57007201515532),
(16501, '37601', 218, 50, 55594, 36.3335, 0.63413920377336, -82.3622, -1.43749156918607),
(16502, '37602', 218, 50, 55594, 36.3064, 0.633666219546069, -82.3817, -1.43783190839021),
(16503, '37604', 218, 50, 55594, 36.3119, 0.633762212654929, -82.3816, -1.43783016306096),
(16504, '37605', 218, 50, 55594, 36.3462, 0.634360860588363, -82.3338, -1.43699589567851),
(16505, '37614', 218, 50, 55594, 36.3318, 0.634109533176076, -82.3688, -1.43760676091671),
(16506, '37615', 218, 50, 55594, 36.4069, 0.635420275444324, -82.4589, -1.43917930257275),
(16507, '37616', 218, 50, 570, 36.1876, 0.6315927683947, -82.7024, -1.44342917930136),
(16508, '37617', 218, 50, 79836, 36.534, 0.637638588923608, -82.3582, -1.43742175601599),
(16509, '37618', 218, 50, 1011, 36.471, 0.636539031494852, -82.2366, -1.43529943564557),
(16510, '37620', 218, 50, 15330, 36.5679, 0.638230255540034, -82.1826, -1.43435695784949),
(16511, '37621', 218, 50, 15330, 36.5816, 0.638469365647558, -82.2065, -1.43477409154072),
(16512, '37625', 218, 50, 15330, 36.5954, 0.638710221084333, -82.1888, -1.43446516826312),
(16513, '37640', 218, 50, 1257, 36.3416, 0.634280575442771, -82.2169, -1.43495560578293),
(16514, '37641', 218, 50, 85818, 36.1488, 0.630915580644926, -82.6084, -1.44178856980448),
(16515, '37642', 218, 50, 13548, 36.5302, 0.637572266412033, -82.7001, -1.44338903672856),
(16516, '37643', 218, 50, 86766, 36.3416, 0.634280575442771, -82.2265, -1.43512315739112),
(16517, '37644', 218, 50, 86766, 36.3482, 0.634395767173403, -82.2107, -1.4348473953693),
(16518, '37645', 218, 50, 4363, 36.5584, 0.638064449261095, -82.6611, -1.44270835832028),
(16519, '37650', 218, 50, 8778, 36.1418, 0.630793407597287, -82.4109, -1.43834154453179),
(16520, '37656', 218, 50, 86927, 36.4323, 0.63586358907433, -82.5927, -1.44151455311192),
(16521, '37657', 218, 50, 86987, 36.025, 0.628754863030957, -82.5512, -1.44079024147234),
(16522, '37658', 218, 50, 2957, 36.24, 0.632507320922745, -82.1927, -1.43453323610394),
(16523, '37659', 218, 50, 88207, 36.2696, 0.633023938381335, -82.4877, -1.43968195739733),
(16524, '37660', 218, 50, 88296, 36.548, 0.637882935018888, -82.5475, -1.44072566429002),
(16525, '37662', 218, 50, 88296, 36.5482, 0.637886425677392, -82.5642, -1.4410171342751),
(16526, '37663', 218, 50, 88296, 36.4613, 0.636369734557409, -82.4843, -1.43962261620276),
(16527, '37664', 218, 50, 88296, 36.5262, 0.637502453241953, -82.4936, -1.43978493182319),
(16528, '37665', 218, 50, 88296, 36.5803, 0.638446676367282, -82.5642, -1.4410171342751),
(16529, '37669', 218, 50, 88296, 36.5299, 0.637567030424277, -82.5567, -1.4408862345812),
(16530, '37680', 218, 50, 88457, 36.5734, 0.638326248648894, -81.7382, -1.42660071465363),
(16531, '37681', 218, 50, 10107, 36.2135, 0.632044808670967, -82.584, -1.441362709467),
(16532, '37682', 218, 50, 0, 36.3025, 0.633598151705241, -82.2966, -1.43634663319677),
(16533, '37683', 218, 50, 23241, 36.474, 0.636591391372412, -81.8026, -1.42772470669191),
(16534, '37684', 218, 50, 4432, 36.3081, 0.633695890143353, -82.3773, -1.43775511390312),
(16535, '37686', 218, 50, 89929, 36.4481, 0.636139351096145, -82.3349, -1.43701509430028),
(16536, '37687', 218, 50, 90384, 36.1714, 0.631310025055877, -82.0954, -1.43283503074175),
(16537, '37688', 218, 50, 24773, 36.5457, 0.637842792446092, -81.8835, -1.42913667805678),
(16538, '37690', 218, 50, 91264, 36.2326, 0.632378166558097, -82.5508, -1.44078326015534),
(16539, '37691', 218, 50, 6371, 36.3675, 0.634732615719038, -81.7542, -1.42687996733395),
(16540, '37692', 218, 50, 91481, 36.1863, 0.631570079114424, -82.3413, -1.43712679537241),
(16541, '37694', 218, 50, 38760, 36.4131, 0.635528485857947, -82.2692, -1.43586841298172),
(16542, '37699', 218, 50, 89929, 36.4192, 0.635634950942319, -82.3044, -1.43648276887842),
(16543, '37701', 218, 50, 84606, 35.7844, 0.624555600850659, -83.9811, -1.46574670444661),
(16544, '37705', 218, 50, 18848, 36.2146, 0.632064007292738, -84.0179, -1.46638898561134),
(16545, '37707', 218, 50, 7168, 36.4224, 0.635690801478383, -83.5581, -1.45836396171067),
(16546, '37708', 218, 50, 84867, 36.3404, 0.634259631491747, -83.3263, -1.45431828850455),
(16547, '37709', 218, 50, 19318, 36.1245, 0.630491465636692, -83.7171, -1.46113903522134),
(16548, '37710', 218, 50, 85300, 36.1889, 0.631615457674976, -84.1995, -1.46955850353297),
(16549, '37711', 218, 50, 85416, 36.2666, 0.632971578503776, -83.1039, -1.45043667624812),
(16550, '37713', 218, 50, 35091, 36.0782, 0.629683378193018, -83.1542, -1.45131457686187),
(16551, '37714', 218, 50, 15454, 36.2758, 0.633132148794959, -84.1942, -1.46946600108261),
(16552, '37715', 218, 50, 85830, 36.5426, 0.63778868723928, -83.8751, -1.4638966554395),
(16553, '37716', 218, 50, 1630, 36.1, 0.630063859969953, -84.1389, -1.46850083400626),
(16554, '37717', 218, 50, 1630, 36.0906, 0.629899799020265, -84.1308, -1.46835946233685),
(16555, '37719', 218, 50, 85903, 36.0503, 0.629196431331712, -84.3468, -1.47212937352115),
(16556, '37721', 218, 50, 86018, 36.1246, 0.630493210965944, -83.8116, -1.46278837136448),
(16557, '37722', 218, 50, 54213, 35.8101, 0.625004150468421, -83.2133, -1.4523460664498),
(16558, '37723', 218, 50, 26876, 35.8952, 0.626489425661869, -84.846, -1.48084205714711),
(16559, '37724', 218, 50, 86166, 36.5456, 0.63784104711684, -83.69, -1.46066605099405),
(16560, '37725', 218, 50, 86216, 36.0194, 0.628657124592846, -83.4185, -1.45592748207489),
(16561, '37726', 218, 50, 86267, 36.2198, 0.632154764413842, -84.8388, -1.48071639344097),
(16562, '37727', 218, 50, 15768, 35.8833, 0.626281731480881, -83.0001, -1.44862502448455),
(16563, '37729', 218, 50, 8616, 36.4277, 0.635783303928738, -83.994, -1.46597185192012),
(16564, '37730', 218, 50, 86648, 36.5518, 0.637949257530463, -83.9766, -1.46566816463027),
(16565, '37731', 218, 50, 86753, 36.5004, 0.637052158294938, -83.0808, -1.4500335051909),
(16566, '37732', 218, 50, 2254, 36.4586, 0.636322610667605, -84.5793, -1.47618726403204),
(16567, '37733', 218, 50, 31014, 36.3601, 0.63460346135439, -84.7009, -1.47830958440247),
(16568, '37737', 218, 50, 27220, 35.7729, 0.624354887986679, -84.1562, -1.46880277596685),
(16569, '37738', 218, 50, 87211, 35.7114, 0.623281510496703, -83.513, -1.45757681821802),
(16570, '37742', 218, 50, 87432, 35.6573, 0.622337287371374, -84.1733, -1.46910122726894),
(16571, '37743', 218, 50, 87441, 36.163, 0.631163417398709, -82.8196, -1.4454747051847),
(16572, '37744', 218, 50, 87441, 36.1626, 0.631156436081701, -82.8104, -1.44531413489351),
(16573, '37745', 218, 50, 87441, 36.1867, 0.631577060431432, -82.8134, -1.44536649477107),
(16574, '37748', 218, 50, 87610, 35.9233, 0.626979863181679, -84.5495, -1.47566715591495),
(16575, '37752', 218, 50, 87624, 36.5709, 0.638282615417594, -83.6381, -1.45976022511227),
(16576, '37753', 218, 50, 2998, 35.8213, 0.625199627344645, -83.0997, -1.45036337241953),
(16577, '37754', 218, 50, 87673, 36.0899, 0.629887581715502, -84.0402, -1.46677819403454),
(16578, '37755', 218, 50, 87675, 36.4331, 0.635877551708346, -84.5644, -1.47592720997349),
(16579, '37756', 218, 50, 3297, 36.4121, 0.635511032565427, -84.4885, -1.47460250507123),
(16580, '37757', 218, 50, 88129, 36.3321, 0.634114769163832, -84.1811, -1.4692373629506),
(16581, '37760', 218, 50, 27551, 36.1208, 0.630426888454368, -83.4923, -1.45721553506286),
(16582, '37762', 218, 50, 88166, 36.581, 0.638458893672046, -84.1266, -1.46828615850826),
(16583, '37763', 218, 50, 3542, 35.8738, 0.626115925201942, -84.5061, -1.47490968301958),
(16584, '37764', 218, 50, 36753, 35.9799, 0.627967719538308, -83.6732, -1.46037283567972),
(16585, '37765', 218, 50, 948, 36.565, 0.638179640991727, -83.0478, -1.44945754653775),
(16586, '37766', 218, 50, 0, 36.3822, 0.634989179119081, -84.1094, -1.46798596187692),
(16587, '37769', 218, 50, 9930, 36.2178, 0.632119857828802, -84.1523, -1.46873470812602),
(16588, '37770', 218, 50, 88428, 36.1535, 0.63099761111977, -84.6901, -1.47812108884325),
(16589, '37771', 218, 50, 88521, 35.7942, 0.624726643117354, -84.2658, -1.47071565682704),
(16590, '37772', 218, 50, 88521, 35.787, 0.624600979411211, -84.2191, -1.46990058806636),
(16591, '37773', 218, 50, 88657, 36.3911, 0.635144513422508, -83.5845, -1.4588247286332),
(16592, '37774', 218, 50, 88686, 35.7089, 0.623237877265403, -84.3005, -1.47132128607748),
(16593, '37777', 218, 50, 3876, 35.8303, 0.625356706977324, -84.0456, -1.46687244181415),
(16594, '37778', 218, 50, 66513, 36.1619, 0.631144218776937, -83.2469, -1.45293249707847),
(16595, '37779', 218, 50, 3908, 36.1584, 0.631083132253118, -83.75, -1.46171324854525),
(16596, '37801', 218, 50, 4028, 35.747, 0.623902847710413, -83.9728, -1.46560184211869),
(16597, '37802', 218, 50, 4028, 35.7565, 0.624068653989353, -83.9705, -1.4655616995459),
(16598, '37803', 218, 50, 4028, 35.7639, 0.624197808354, -83.9671, -1.46550235835133),
(16599, '37804', 218, 50, 4028, 35.7745, 0.624382813254711, -83.9408, -1.46504333675806),
(16600, '37806', 218, 50, 56120, 36.0781, 0.629681632863766, -83.7377, -1.46149857304726),
(16601, '37807', 218, 50, 88883, 36.1654, 0.631205305300757, -83.9125, -1.46454940857974),
(16602, '37809', 218, 50, 41, 36.1472, 0.630887655376894, -83.0311, -1.44916607655266),
(16603, '37810', 218, 50, 10551, 36.1798, 0.631456632713044, -83.0951, -1.45028308727394),
(16604, '37811', 218, 50, 89138, 36.3701, 0.63477799427959, -83.1955, -1.45203539784294),
(16605, '37813', 218, 50, 30565, 36.1885, 0.631608476357968, -83.2716, -1.45336359340371),
(16606, '37814', 218, 50, 30565, 36.2241, 0.632229813571678, -83.313, -1.45408615971404),
(16607, '37815', 218, 50, 30565, 36.2139, 0.632051789987975, -83.2945, -1.45376327380242),
(16608, '37816', 218, 50, 30565, 36.1905, 0.631643382943008, -83.3723, -1.45512113996047),
(16609, '37818', 218, 50, 89172, 36.1711, 0.631304789068121, -82.9736, -1.44816251223277),
(16610, '37819', 218, 50, 49796, 36.5425, 0.637786941910028, -84.1856, -1.46931590276694),
(16611, '37820', 218, 50, 4548, 36.0804, 0.629721775436562, -83.5681, -1.45853849463587),
(16612, '37821', 218, 50, 10799, 35.9631, 0.627674504223973, -83.1898, -1.45193591407558),
(16613, '37822', 218, 50, 10799, 35.9607, 0.627632616321925, -83.1914, -1.45196383934361),
(16614, '37824', 218, 50, 89413, 36.4365, 0.635936892902914, -83.6056, -1.45919299310537),
(16615, '37825', 218, 50, 89413, 36.4405, 0.636006706072994, -83.6017, -1.45912492526454),
(16616, '37826', 218, 50, 89441, 35.5116, 0.619794342651218, -84.5451, -1.47559036142786),
(16617, '37828', 218, 50, 23401, 36.1967, 0.631751593356631, -84.0694, -1.46728783017612),
(16618, '37829', 218, 50, 4701, 36.0146, 0.62857334878875, -84.638, -1.47721177230296),
(16619, '37830', 218, 50, 4694, 36.0215, 0.628693776507137, -84.253, -1.47049225468278),
(16620, '37831', 218, 50, 4694, 35.963, 0.627672758894721, -84.2967, -1.4712549635659),
(16621, '37840', 218, 50, 89679, 36.0358, 0.628943358590173, -84.3244, -1.47173841976871),
(16622, '37841', 218, 50, 10986, 36.5033, 0.637102772843246, -84.5147, -1.47505978133525),
(16623, '37842', 218, 50, 11044, 35.8821, 0.626260787529857, -84.8089, -1.48019453999462),
(16624, '37843', 218, 50, 89791, 35.9983, 0.628288860120675, -83.0535, -1.44955703030511),
(16625, '37845', 218, 50, 37656, 36.0533, 0.629248791209272, -84.4348, -1.47366526326291),
(16626, '37846', 218, 50, 4983, 35.6782, 0.622702061185041, -84.4044, -1.4731346831703),
(16627, '37847', 218, 50, 42592, 36.4605, 0.636355771923393, -84.2985, -1.47128637949244),
(16628, '37848', 218, 50, 24105, 36.2496, 0.632674872530936, -83.6688, -1.46029604119263),
(16629, '37849', 218, 50, 5200, 36.0527, 0.62923831923376, -84.0258, -1.46652686662225),
(16630, '37851', 218, 50, 37822, 36.5434, 0.637802649873296, -83.8756, -1.46390538208576),
(16631, '37852', 218, 50, 14501, 36.3256, 0.634001322762452, -84.571, -1.47604240170412),
(16632, '37853', 218, 50, 5475, 35.8279, 0.625314819075276, -83.9444, -1.46510616861113),
(16633, '37854', 218, 50, 5481, 35.8651, 0.625964081557018, -84.6808, -1.47795877322281),
(16634, '37857', 218, 50, 5512, 36.4037, 0.63536442490826, -83.007, -1.44874545220293),
(16635, '37860', 218, 50, 5585, 36.2443, 0.632582370080581, -83.1919, -1.45197256598987),
(16636, '37861', 218, 50, 5590, 36.2797, 0.633200216635787, -83.5178, -1.45766059402212),
(16637, '37862', 218, 50, 90698, 35.8719, 0.626082763946154, -83.5353, -1.45796602664122),
(16638, '37863', 218, 50, 89881, 35.7924, 0.624695227190818, -83.5618, -1.458428538893),
(16639, '37864', 218, 50, 90698, 35.8548, 0.625784312644063, -83.5753, -1.45866415834202),
(16640, '37865', 218, 50, 5745, 35.8662, 0.62598328017879, -83.7395, -1.46152998897379),
(16641, '37866', 218, 50, 90749, 36.3593, 0.634589498720374, -83.8645, -1.46371165053878),
(16642, '37867', 218, 50, 90753, 36.5804, 0.638448421696534, -83.6389, -1.45977418774629),
(16643, '37868', 218, 50, 89881, 35.7763, 0.624414229181247, -83.5366, -1.4579887159215),
(16644, '37869', 218, 50, 90886, 36.5331, 0.63762288096034, -83.2173, -1.45241587961988),
(16645, '37870', 218, 50, 38318, 36.4775, 0.636652477896232, -83.811, -1.46277789938897),
(16646, '37871', 218, 50, 91079, 36.0183, 0.628637925971074, -83.7084, -1.46098719157642),
(16647, '37872', 218, 50, 91143, 36.2737, 0.633095496880667, -84.7035, -1.47835496296302),
(16648, '37873', 218, 50, 91177, 36.4633, 0.636404641142448, -82.8256, -1.44557942493982),
(16649, '37874', 218, 50, 6196, 35.6029, 0.621387828258289, -84.4639, -1.47417315407524),
(16650, '37876', 218, 50, 90698, 35.8398, 0.625522513256264, -83.4823, -1.45704100213766),
(16651, '37877', 218, 50, 91209, 36.1721, 0.631322242360641, -83.4219, -1.45598682326946),
(16652, '37878', 218, 50, 6223, 35.5687, 0.620790925654107, -83.9815, -1.46575368576362),
(16653, '37879', 218, 50, 25361, 36.4448, 0.636081755230829, -83.5843, -1.4588212379747),
(16654, '37880', 218, 50, 57856, 35.6826, 0.622778855672129, -84.6517, -1.47745088241048),
(16655, '37881', 218, 50, 91321, 36.3946, 0.635205599946328, -83.3655, -1.45500245757133),
(16656, '37882', 218, 50, 14757, 35.6276, 0.621818924583532, -83.7821, -1.46227349923514),
(16657, '37885', 218, 50, 91594, 35.4851, 0.61933183039944, -84.0927, -1.46769449189184),
(16658, '37886', 218, 50, 91613, 35.7755, 0.624400266547231, -83.8195, -1.46292625237539),
(16659, '37887', 218, 50, 28910, 36.0489, 0.629171996722184, -84.6159, -1.47682605453827),
(16660, '37888', 218, 50, 12668, 36.3142, 0.633802355227725, -83.5982, -1.45906383874072),
(16661, '37890', 218, 50, 91831, 36.1051, 0.630152871761805, -83.2865, -1.45362364746226),
(16662, '37891', 218, 50, 6792, 36.2576, 0.632814498871096, -83.1401, -1.45106848543734),
(16663, '37892', 218, 50, 6882, 36.5215, 0.637420422767109, -84.5019, -1.474836379191),
(16664, '37901', 218, 50, 3570, 36.0324, 0.628884017395605, -83.8858, -1.46408340566946),
(16665, '37902', 218, 50, 3570, 35.9616, 0.627648324285193, -83.9214, -1.46470474288317),
(16666, '37909', 218, 50, 3570, 35.9463, 0.627381288909638, -84.0174, -1.46638025896508),
(16667, '37912', 218, 50, 3570, 36.006, 0.628423250473078, -83.9825, -1.46577113905614),
(16668, '37914', 218, 50, 3570, 35.9937, 0.628208574975083, -83.829, -1.46309205865433),
(16669, '37915', 218, 50, 3570, 35.9724, 0.627836819844408, -83.9023, -1.46437138499604),
(16670, '37916', 218, 50, 3570, 35.9569, 0.627566293810349, -83.9331, -1.46490894640565),
(16671, '37917', 218, 50, 3570, 35.9953, 0.628236500243115, -83.9156, -1.46460351378655),
(16672, '37918', 218, 50, 3570, 36.0491, 0.629175487380688, -83.9202, -1.46468379893215),
(16673, '37919', 218, 50, 3570, 35.9262, 0.627030477729987, -84.0069, -1.46619699939362),
(16674, '37920', 218, 50, 3570, 35.9232, 0.626978117852427, -83.8769, -1.46392807136603),
(16675, '37921', 218, 50, 3570, 35.9759, 0.627897906368228, -83.9853, -1.46582000827519),
(16676, '37922', 218, 50, 3570, 35.8757, 0.62614908645773, -84.1295, -1.46833677305657),
(16677, '37923', 218, 50, 3570, 35.9252, 0.627013024437467, -84.0976, -1.46778001302518),
(16678, '37924', 218, 50, 3570, 36.0314, 0.628866564103085, -83.8142, -1.46283374992503),
(16679, '37927', 218, 50, 3570, 36.0009, 0.628334238681227, -83.9127, -1.46455289923825),
(16680, '37928', 218, 50, 3570, 36.0608, 0.629379690903171, -83.9098, -1.46450228468994),
(16681, '37929', 218, 50, 3570, 35.9605, 0.627629125663421, -83.9204, -1.46468728959065),
(16682, '37930', 218, 50, 3570, 35.9301, 0.627098545570815, -84.0804, -1.46747981639384),
(16683, '37931', 218, 50, 3570, 35.9737, 0.627859509124684, -84.1116, -1.46802435912046),
(16684, '37932', 218, 50, 3570, 35.9218, 0.626953683242899, -84.1757, -1.46914311517099),
(16685, '37933', 218, 50, 3570, 35.8672, 0.62600073347131, -84.1243, -1.46824601593547),
(16686, '37938', 218, 50, 3570, 36.1103, 0.630243628882908, -83.9333, -1.46491243706416),
(16687, '37939', 218, 50, 3570, 35.9133, 0.62680533025648, -84.0011, -1.46609577029701),
(16688, '37940', 218, 50, 3570, 35.8965, 0.626512114942145, -83.8525, -1.46350221102855),
(16689, '37950', 218, 50, 3570, 35.9469, 0.62739176088515, -84.0227, -1.46647276141544),
(16690, '37955', 218, 50, 3570, 35.9604, 0.627627380334169, -83.9209, -1.46469601623691),
(16691, '37990', 218, 50, 3570, 35.8674, 0.626004224129814, -84.1238, -1.46823728928921),
(16692, '37995', 218, 50, 3570, 35.9632, 0.627676249553225, -83.9166, -1.46462096707907),
(16693, '37996', 218, 50, 3570, 35.9541, 0.627517424591293, -83.9345, -1.46493338101518),
(16694, '37997', 218, 50, 3570, 35.9655, 0.627716392126021, -83.9086, -1.46448134073891),
(16695, '37998', 218, 50, 3570, 35.9362, 0.627205010655186, -83.7511, -1.46173244716702),
(16696, '38001', 218, 50, 7039, 35.7847, 0.624560836838415, -89.1143, -1.55533794560998),
(16697, '38002', 218, 50, 15026, 35.2702, 0.615581117836904, -89.7371, -1.5662078561914),
(16698, '38004', 218, 50, 34614, 35.3913, 0.617694711561069, -89.7564, -1.56654470473704),
(16699, '38006', 218, 50, 58616, 35.7323, 0.62364628431037, -89.0913, -1.55493651988202),
(16700, '38007', 218, 50, 910, 36.2125, 0.632027355378447, -89.477, -1.56166825480697),
(16701, '38008', 218, 50, 1034, 35.2666, 0.615518285983832, -89.0044, -1.55341982876204);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(16702, '38010', 218, 50, 26592, 35.1999, 0.614354151372752, -89.3938, -1.56021614086931),
(16703, '38011', 218, 50, 212, 35.4831, 0.6192969238144, -89.7232, -1.56596525542538),
(16704, '38012', 218, 50, 1191, 35.5966, 0.621277872515414, -89.2695, -1.55804669660908),
(16705, '38014', 218, 50, 19602, 35.2661, 0.615509559337572, -89.772, -1.56681697610035),
(16706, '38015', 218, 50, 85439, 35.5624, 0.620680969911231, -89.839, -1.56798634669919),
(16707, '38016', 218, 50, 924, 35.1533, 0.613540827941323, -89.78, -1.56695660244051),
(16708, '38017', 218, 50, 85938, 35.0522, 0.611776300067556, -89.6776, -1.56516938528647),
(16709, '38018', 218, 50, 924, 35.1541, 0.613554790575339, -89.7799, -1.56695485711126),
(16710, '38019', 218, 50, 15652, 35.5599, 0.620637336679932, -89.6586, -1.56483777272859),
(16711, '38021', 218, 50, 86113, 35.9087, 0.626725045110888, -89.1913, -1.55668184913402),
(16712, '38023', 218, 50, 86594, 35.4677, 0.619028143109593, -89.9563, -1.57003361791178),
(16713, '38024', 218, 50, 86642, 36.0388, 0.628995718467733, -89.3832, -1.5600311359686),
(16714, '38025', 218, 50, 86642, 36.0348, 0.628925905297653, -89.3852, -1.56006604255364),
(16715, '38027', 218, 50, 85938, 35.055, 0.611825169286612, -89.6786, -1.56518683857899),
(16716, '38028', 218, 50, 86647, 35.155, 0.613570498538607, -89.68, -1.56521127318851),
(16717, '38029', 218, 50, 13721, 35.2046, 0.614436181847596, -89.8203, -1.56765997012906),
(16718, '38030', 218, 50, 2445, 35.9895, 0.628135271146499, -89.581, -1.56348339722904),
(16719, '38034', 218, 50, 2610, 35.9084, 0.626719809123132, -89.1916, -1.55668708512177),
(16720, '38036', 218, 50, 87186, 35.325, 0.616537558266997, -89.6197, -1.56415883964956),
(16721, '38037', 218, 50, 865, 35.8327, 0.625398594879372, -89.4054, -1.56041859906254),
(16722, '38039', 218, 50, 87355, 35.2746, 0.615657912323992, -89.1538, -1.55602735066452),
(16723, '38040', 218, 50, 21681, 35.8767, 0.62616653975025, -89.3969, -1.56027024607612),
(16724, '38041', 218, 50, 87694, 35.6716, 0.622586869454409, -89.5704, -1.56329839232833),
(16725, '38042', 218, 50, 9473, 35.3238, 0.616516614315973, -89.1513, -1.55598371743322),
(16726, '38044', 218, 50, 27469, 35.2242, 0.614778266380987, -88.824, -1.55027125479144),
(16727, '38045', 218, 50, 9914, 35.294, 0.615996506198879, -89.3699, -1.55979900717808),
(16728, '38046', 218, 50, 3584, 35.0674, 0.61204159011386, -89.3295, -1.55909389416027),
(16729, '38047', 218, 50, 425, 36.0648, 0.629449504073251, -89.4198, -1.56066992647483),
(16730, '38048', 218, 50, 3937, 35.1538, 0.613549554587583, -89.4892, -1.56188118497571),
(16731, '38049', 218, 50, 17048, 35.4165, 0.618134534532572, -89.5372, -1.56271894301667),
(16732, '38050', 218, 50, 88868, 35.8186, 0.625152503454841, -89.2232, -1.5572386091654),
(16733, '38052', 218, 50, 4185, 35.0622, 0.611950832992756, -88.8951, -1.55151218388961),
(16734, '38053', 218, 50, 49512, 35.3324, 0.616666712631645, -89.9042, -1.56912430137149),
(16735, '38054', 218, 50, 49512, 35.3393, 0.616787140350032, -89.879, -1.56868447839998),
(16736, '38055', 218, 50, 49512, 35.341, 0.616816810947316, -89.8972, -1.56900212832385),
(16737, '38056', 218, 50, 89080, 36.0654, 0.629459976048763, -89.42, -1.56067341713333),
(16738, '38057', 218, 50, 4344, 35.0567, 0.611854839883896, -89.4625, -1.56141518206543),
(16739, '38058', 218, 50, 4461, 35.4482, 0.618687803905454, -89.8102, -1.56748369187461),
(16740, '38059', 218, 50, 4562, 36.1127, 0.630285516784956, -89.2653, -1.55797339278049),
(16741, '38060', 218, 50, 4710, 35.2125, 0.614574062858503, -89.542, -1.56280271882076),
(16742, '38061', 218, 50, 5158, 35.0316, 0.611416762241646, -88.8156, -1.55012464713428),
(16743, '38063', 218, 50, 5404, 35.7376, 0.623738786760725, -89.5354, -1.56268752709013),
(16744, '38066', 218, 50, 24541, 35.0844, 0.612338296086699, -89.5657, -1.56321636185349),
(16745, '38067', 218, 50, 51227, 35.0522, 0.611776300067556, -88.9463, -1.55240579246663),
(16746, '38068', 218, 50, 5947, 35.2398, 0.615050537744298, -89.3618, -1.55965763550867),
(16747, '38069', 218, 50, 6052, 35.4436, 0.618607518759862, -89.3387, -1.55925446445146),
(16748, '38070', 218, 50, 91343, 36.0954, 0.629983574824361, -89.2395, -1.55752309783348),
(16749, '38071', 218, 50, 12332, 35.422, 0.618230527641431, -89.8083, -1.56745053061882),
(16750, '38074', 218, 50, 1034, 35.2638, 0.615469416764776, -88.9989, -1.55332383565318),
(16751, '38075', 218, 50, 12831, 35.3276, 0.616582936827549, -89.1486, -1.55593659354342),
(16752, '38076', 218, 50, 18638, 35.17, 0.613832297926406, -89.4026, -1.56036972984348),
(16753, '38077', 218, 50, 92031, 36.2624, 0.632898274675192, -89.5222, -1.56245714362887),
(16754, '38079', 218, 50, 91367, 36.376, 0.634880968705457, -89.4775, -1.56167698145323),
(16755, '38080', 218, 50, 28415, 36.2649, 0.632941907906492, -89.483, -1.56177297456209),
(16756, '38083', 218, 50, 49512, 35.3341, 0.616696383228928, -89.8881, -1.56884330336191),
(16757, '38088', 218, 50, 924, 35.1545, 0.613561771892347, -89.7891, -1.56711542740244),
(16758, '38101', 218, 50, 4163, 35.1303, 0.613139402213364, -90.054, -1.57173880459097),
(16759, '38103', 218, 50, 4163, 35.1516, 0.613511157344039, -90.0355, -1.57141591867935),
(16760, '38104', 218, 50, 4163, 35.1395, 0.613299972504547, -89.9991, -1.57078061883163),
(16761, '38105', 218, 50, 4163, 35.1515, 0.613509412014787, -90.0342, -1.57139322939908),
(16762, '38106', 218, 50, 4163, 35.1039, 0.612678635290838, -90.0414, -1.57151889310522),
(16763, '38107', 218, 50, 4163, 35.172, 0.613867204511446, -90.016, -1.57107557947522),
(16764, '38108', 218, 50, 4163, 35.179, 0.613989377559085, -89.956, -1.57002838192402),
(16765, '38109', 218, 50, 4163, 35.0501, 0.611739648153265, -90.0682, -1.57198664134476),
(16766, '38110', 218, 50, 4163, 35.0687, 0.612064279394135, -89.9581, -1.57006503383831),
(16767, '38111', 218, 50, 4163, 35.1101, 0.612786845704461, -89.9451, -1.56983814103555),
(16768, '38112', 218, 50, 4163, 35.1477, 0.613443089503211, -89.9772, -1.57039839172544),
(16769, '38113', 218, 50, 4163, 35.2128, 0.614579298846259, -89.9947, -1.57070382434454),
(16770, '38114', 218, 50, 4163, 35.1044, 0.612687361937097, -89.9804, -1.57045424226151),
(16771, '38115', 218, 50, 4163, 35.046, 0.611668089653933, -89.8488, -1.56815738896588),
(16772, '38116', 218, 50, 4163, 35.0377, 0.611523227326017, -90.0071, -1.57092024517179),
(16773, '38117', 218, 50, 4163, 35.1157, 0.612884584142573, -89.9045, -1.56912953735924),
(16774, '38118', 218, 50, 4163, 35.0494, 0.611727430848501, -89.924, -1.56946987656338),
(16775, '38119', 218, 50, 4163, 35.0957, 0.612535518292174, -89.8496, -1.5681713515999),
(16776, '38120', 218, 50, 4163, 35.1208, 0.612973595934425, -89.8618, -1.56838428176864),
(16777, '38122', 218, 50, 4163, 35.1559, 0.613586206501875, -89.9221, -1.56943671530759),
(16778, '38124', 218, 50, 4163, 35.114, 0.612854913545289, -89.9059, -1.56915397196877),
(16779, '38125', 218, 50, 4163, 35.0294, 0.611378364998102, -89.8108, -1.56749416385012),
(16780, '38126', 218, 50, 4163, 35.1263, 0.613069589043284, -90.0427, -1.5715415823855),
(16781, '38127', 218, 50, 4163, 35.2265, 0.614818408953782, -90.0018, -1.57082774272143),
(16782, '38128', 218, 50, 4163, 35.2235, 0.614766049076223, -89.9108, -1.56923949310212),
(16783, '38129', 218, 50, 4163, 35.1497, 0.613477996088251, -90.0487, -1.57164630214062),
(16784, '38130', 218, 50, 4163, 35.0335, 0.611449923497433, -89.9341, -1.56964615481783),
(16785, '38131', 218, 50, 4163, 35.0654, 0.61200668352882, -89.9935, -1.57068288039352),
(16786, '38132', 218, 50, 4163, 35.0632, 0.611968286285276, -89.9775, -1.5704036277132),
(16787, '38133', 218, 50, 4163, 35.2087, 0.614507740346928, -89.7939, -1.56719920320654),
(16788, '38134', 218, 50, 4163, 35.1988, 0.61433495275098, -89.8567, -1.56829526997679),
(16789, '38135', 218, 50, 4163, 35.2305, 0.614888222123862, -89.8531, -1.56823243812372),
(16790, '38136', 218, 50, 4163, 35.1003, 0.612615803437766, -90.0358, -1.57142115466711),
(16791, '38137', 218, 50, 4163, 35.1149, 0.612870621508557, -89.905, -1.5691382640055),
(16792, '38138', 218, 50, 27253, 35.0917, 0.612465705122094, -89.7988, -1.56728472433988),
(16793, '38139', 218, 50, 27253, 35.0888, 0.612415090573786, -89.7691, -1.56676636155204),
(16794, '38140', 218, 50, 4163, 35.1493, 0.613471014771243, -90.049, -1.57165153812837),
(16795, '38141', 218, 50, 4163, 35.0237, 0.611278881230738, -89.8483, -1.56814866231962),
(16796, '38142', 218, 50, 4163, 35.0005, 0.610873964844275, -90.1158, -1.57281741806871),
(16797, '38143', 218, 50, 4163, 35.149, 0.613465778783487, -90.0488, -1.57164804746987),
(16798, '38145', 218, 50, 4163, 35.1401, 0.613310444480059, -90.0544, -1.57174578590798),
(16799, '38146', 218, 50, 4163, 35.1398, 0.613305208492303, -90.0316, -1.57134785083853),
(16800, '38147', 218, 50, 4163, 35.1451, 0.613397710942659, -90.053, -1.57172135129845),
(16801, '38148', 218, 50, 4163, 35.1446, 0.613388984296399, -90.05, -1.57166899142089),
(16802, '38150', 218, 50, 4163, 35.1496, 0.613476250758999, -90.0485, -1.57164281148211),
(16803, '38151', 218, 50, 4163, 35.149, 0.613465778783487, -89.9772, -1.57039839172544),
(16804, '38152', 218, 50, 4163, 35.1185, 0.612933453361629, -89.9384, -1.56972120397567),
(16805, '38157', 218, 50, 4163, 35.1141, 0.612856658874541, -89.9044, -1.56912779202999),
(16806, '38159', 218, 50, 4163, 35.146, 0.613413418905927, -90.0539, -1.57173705926172),
(16807, '38161', 218, 50, 4163, 35.139, 0.613291245858288, -89.862, -1.56838777242714),
(16808, '38163', 218, 50, 4163, 35.1416, 0.613336624418839, -90.037, -1.57144209861813),
(16809, '38165', 218, 50, 4163, 35.1406, 0.613319171126319, -90.0526, -1.57171436998145),
(16810, '38166', 218, 50, 4163, 35.1328, 0.613183035444664, -90.0048, -1.57088010259899),
(16811, '38167', 218, 50, 4163, 35.2564, 0.615340262400129, -90.0305, -1.57132865221675),
(16812, '38168', 218, 50, 4163, 35.2295, 0.614870768831342, -89.9236, -1.56946289524637),
(16813, '38173', 218, 50, 4163, 35.1414, 0.613333133760335, -90.0527, -1.5717161153107),
(16814, '38174', 218, 50, 4163, 35.1331, 0.61318827143242, -90.0052, -1.570887083916),
(16815, '38175', 218, 50, 4163, 35.0463, 0.611673325641689, -89.8667, -1.56846980290199),
(16816, '38177', 218, 50, 4163, 35.1155, 0.612881093484069, -89.9058, -1.56915222663952),
(16817, '38181', 218, 50, 4163, 35.0518, 0.611769318750548, -89.9407, -1.56976134654846),
(16818, '38182', 218, 50, 4163, 35.1481, 0.613450070820219, -89.9714, -1.57029716262883),
(16819, '38183', 218, 50, 27253, 35.0958, 0.612537263621426, -89.804, -1.56737548146099),
(16820, '38184', 218, 50, 4163, 35.1877, 0.614141221204009, -89.8629, -1.56840348039041),
(16821, '38186', 218, 50, 4163, 35.034, 0.611458650143693, -90.0172, -1.57109652342624),
(16822, '38187', 218, 50, 4163, 35.0794, 0.612251029624099, -89.8455, -1.56809979310057),
(16823, '38188', 218, 50, 4163, 35.0997, 0.612605331462254, -89.8611, -1.56837206446388),
(16824, '38190', 218, 50, 4163, 35.0553, 0.611830405274368, -90.0601, -1.57184526967535),
(16825, '38193', 218, 50, 4163, 35.055, 0.611825169286612, -89.8628, -1.56840173506116),
(16826, '38194', 218, 50, 4163, 35.0661, 0.612018900833584, -89.9989, -1.57077712817312),
(16827, '38195', 218, 50, 4163, 35.0613, 0.611935125029488, -89.9374, -1.56970375068315),
(16828, '38197', 218, 50, 4163, 35.1004, 0.612617548767018, -89.8488, -1.56815738896588),
(16829, '38201', 218, 50, 4104, 36.1328, 0.630636327964607, -88.5165, -1.54490436734156),
(16830, '38220', 218, 50, 7189, 36.0107, 0.628505280947922, -88.7152, -1.54837233656527),
(16831, '38221', 218, 50, 85069, 36.2402, 0.632510811581249, -88.0583, -1.53690726870892),
(16832, '38222', 218, 50, 15362, 36.3438, 0.634318972686315, -88.3791, -1.54250628494932),
(16833, '38223', 218, 50, 39860, 36.3579, 0.634565064110846, -88.4621, -1.54395490822848),
(16834, '38224', 218, 50, 1788, 36.3803, 0.634956017863293, -88.4801, -1.54426906749383),
(16835, '38225', 218, 50, 20675, 36.2889, 0.63336078692697, -88.7066, -1.5482222382496),
(16836, '38226', 218, 50, 86613, 36.4742, 0.636594882030916, -88.6661, -1.54751537990254),
(16837, '38229', 218, 50, 9130, 36.2147, 0.632065752621991, -88.6145, -1.54661479000852),
(16838, '38230', 218, 50, 2861, 36.1544, 0.631013319083038, -88.8005, -1.54986110241722),
(16839, '38231', 218, 50, 9426, 36.2056, 0.631906927660059, -88.4639, -1.54398632415501),
(16840, '38232', 218, 50, 87968, 36.3337, 0.634142694431864, -89.3087, -1.55873086567586),
(16841, '38233', 218, 50, 14041, 36.1802, 0.631463614030052, -89.0278, -1.55382823580701),
(16842, '38235', 218, 50, 88917, 35.9856, 0.628067203305671, -88.5802, -1.54601614207508),
(16843, '38236', 218, 50, 3975, 36.1828, 0.631508992590604, -88.2863, -1.54088661940347),
(16844, '38237', 218, 50, 882, 36.3411, 0.634271848796511, -88.8534, -1.55078438159153),
(16845, '38238', 218, 50, 882, 36.3423, 0.634292792747535, -88.8584, -1.55087164805413),
(16846, '38240', 218, 50, 89622, 36.2628, 0.6329052559922, -89.1926, -1.55670453841429),
(16847, '38241', 218, 50, 89749, 36.2825, 0.633249085854843, -88.6975, -1.54806341328767),
(16848, '38242', 218, 50, 11069, 36.3011, 0.633573717095714, -88.3148, -1.54138403824029),
(16849, '38251', 218, 50, 11433, 36.4459, 0.636100953852601, -88.3345, -1.54172786810293),
(16850, '38253', 218, 50, 50901, 36.3239, 0.633971652165168, -89.0401, -1.554042911305),
(16851, '38254', 218, 50, 90593, 36.358, 0.634566809440098, -89.2977, -1.55853887945814),
(16852, '38255', 218, 50, 24789, 36.2346, 0.632413073143137, -88.8249, -1.55028696275471),
(16853, '38256', 218, 50, 6035, 36.3786, 0.634926347266009, -88.1045, -1.53771361082334),
(16854, '38257', 218, 50, 90912, 36.4968, 0.636989326441866, -88.8788, -1.55122769522154),
(16855, '38258', 218, 50, 91412, 36.0316, 0.628870054761589, -88.6003, -1.54636695325473),
(16856, '38259', 218, 50, 6389, 36.2033, 0.631866785087263, -89.191, -1.55667661314626),
(16857, '38260', 218, 50, 199, 36.3327, 0.634125241139344, -89.165, -1.55622282754074),
(16858, '38261', 218, 50, 12457, 36.4235, 0.635710000100155, -89.0553, -1.55430820135131),
(16859, '38271', 218, 50, 6929, 36.4315, 0.635849626440314, -89.1218, -1.55546884530388),
(16860, '38281', 218, 50, 12457, 36.4222, 0.635687310819879, -89.0515, -1.55424187883973),
(16861, '38301', 218, 50, 3384, 35.6104, 0.621518727952189, -88.8187, -1.55017875234109),
(16862, '38302', 218, 50, 3384, 35.5946, 0.621242965930374, -88.8578, -1.55086117607862),
(16863, '38303', 218, 50, 3384, 35.6377, 0.621995202837983, -88.8251, -1.55029045341322),
(16864, '38305', 218, 50, 3384, 35.6834, 0.622792818306145, -88.8241, -1.5502730001207),
(16865, '38308', 218, 50, 3384, 35.595, 0.621249947247382, -88.8191, -1.5501857336581),
(16866, '38310', 218, 50, 13260, 35.2315, 0.614905675416382, -88.3881, -1.542663364582),
(16867, '38311', 218, 50, 84843, 35.4408, 0.618558649540806, -88.1051, -1.53772408279886),
(16868, '38313', 218, 50, 84892, 35.6068, 0.621455896099117, -88.646, -1.54716456872289),
(16869, '38314', 218, 50, 3384, 35.5935, 0.621223767308602, -88.858, -1.55086466673712),
(16870, '38315', 218, 50, 39372, 35.2244, 0.614781757039491, -88.662, -1.54744382140321),
(16871, '38316', 218, 50, 1076, 36.0648, 0.629449504073251, -88.8074, -1.54998153013561),
(16872, '38317', 218, 50, 85360, 36.0374, 0.628971283858204, -88.245, -1.5401657984224),
(16873, '38318', 218, 50, 1223, 35.9365, 0.627210246642942, -88.2692, -1.54058816810138),
(16874, '38320', 218, 50, 1304, 36.0587, 0.629343038988879, -88.1023, -1.5376752135798),
(16875, '38321', 218, 50, 1414, 35.8627, 0.62592219365497, -88.5195, -1.54495672721912),
(16876, '38324', 218, 50, 26799, 35.8625, 0.625918702996466, -88.3782, -1.54249057698605),
(16877, '38326', 218, 50, 86039, 35.1652, 0.61374852212231, -88.2156, -1.53965267162231),
(16878, '38327', 218, 50, 54288, 35.2238, 0.614771285063979, -88.3247, -1.54155682583624),
(16879, '38328', 218, 50, 59202, 35.6744, 0.622635738673465, -88.2173, -1.53968234221959),
(16880, '38329', 218, 50, 54379, 35.5461, 0.620396481243156, -88.1054, -1.53772931878661),
(16881, '38330', 218, 50, 8642, 36.0702, 0.629543751852859, -89.0177, -1.55365195755256),
(16882, '38331', 218, 50, 8676, 35.9693, 0.627782714637596, -89.1318, -1.55564337822908),
(16883, '38332', 218, 50, 75777, 35.4749, 0.619153806815736, -88.4191, -1.54320441665012),
(16884, '38333', 218, 50, 2339, 36.1136, 0.630301224748224, -87.9947, -1.53579723930465),
(16885, '38334', 218, 50, 64714, 35.3197, 0.616445055816641, -88.596, -1.5462919040969),
(16886, '38336', 218, 50, 87166, 35.7228, 0.62348047803143, -89.0617, -1.55441990242343),
(16887, '38337', 218, 50, 2640, 35.7734, 0.62436361463294, -88.9889, -1.55314930272798),
(16888, '38338', 218, 50, 2709, 35.8709, 0.626065310653634, -88.8458, -1.55065173656838),
(16889, '38339', 218, 50, 47753, 35.0147, 0.611121801598059, -88.5269, -1.54508588158377),
(16890, '38340', 218, 50, 23, 35.4262, 0.618303831470015, -88.6543, -1.54730943105081),
(16891, '38341', 218, 50, 60285, 35.8978, 0.62653480422242, -88.0751, -1.53720048402326),
(16892, '38342', 218, 50, 87897, 36.0301, 0.628843874822809, -88.2761, -1.54070859581977),
(16893, '38343', 218, 50, 27486, 35.8398, 0.625522513256264, -88.91, -1.55177223794816),
(16894, '38344', 218, 50, 88028, 36.0066, 0.62843372244859, -88.4206, -1.5432305965889),
(16895, '38345', 218, 50, 30131, 35.5847, 0.621070178334426, -88.509, -1.54477346764766),
(16896, '38346', 218, 50, 36552, 36.0286, 0.628817694884029, -88.8011, -1.54987157439274),
(16897, '38347', 218, 50, 36592, 35.4863, 0.619352774350464, -88.4993, -1.54460417071022),
(16898, '38348', 218, 50, 88473, 35.8635, 0.625936156288986, -88.6497, -1.54722914590522),
(16899, '38351', 218, 50, 3748, 35.6572, 0.622335542042122, -88.4002, -1.54287454942149),
(16900, '38352', 218, 50, 33155, 35.687, 0.622855650159216, -88.8769, -1.55119453396575),
(16901, '38355', 218, 50, 10432, 35.7641, 0.624201299012504, -88.7836, -1.54956614177364),
(16902, '38356', 218, 50, 88956, 35.47, 0.619068285682389, -88.8933, -1.55148076796308),
(16903, '38357', 218, 50, 88982, 35.0693, 0.612074751369647, -88.4448, -1.54365296626788),
(16904, '38358', 218, 50, 23084, 35.9237, 0.626986844498687, -88.7668, -1.5492729264593),
(16905, '38359', 218, 50, 23097, 35.3412, 0.61682030160582, -88.407, -1.54299323181063),
(16906, '38361', 218, 50, 89161, 35.3099, 0.616274013549946, -88.29, -1.54095119658579),
(16907, '38362', 218, 50, 23561, 35.7235, 0.623492695336194, -88.7737, -1.54939335417769),
(16908, '38363', 218, 50, 4894, 35.6479, 0.622173226421687, -88.127, -1.53810630990504),
(16909, '38365', 218, 50, 0, 35.0372, 0.611514500679757, -88.2917, -1.54098086718308),
(16910, '38366', 218, 50, 5092, 35.4895, 0.619408624886528, -88.7406, -1.54881565019528),
(16911, '38367', 218, 50, 5290, 35.0541, 0.611809461323344, -88.6371, -1.54700923441947),
(16912, '38368', 218, 50, 77050, 35.5103, 0.619771653370942, -88.3555, -1.54209438724585),
(16913, '38369', 218, 50, 5589, 36.1287, 0.630564769465275, -88.9759, -1.55292240992522),
(16914, '38370', 218, 50, 11788, 35.3805, 0.617506216001854, -88.2082, -1.53952351725766),
(16915, '38371', 218, 50, 715, 35.4358, 0.618471383078207, -88.3107, -1.54131247974096),
(16916, '38372', 218, 50, 24690, 35.2241, 0.614776521051735, -88.2343, -1.53997904819243),
(16917, '38374', 218, 50, 68597, 35.5027, 0.619639008347791, -88.2363, -1.54001395477747),
(16918, '38375', 218, 50, 90665, 35.174, 0.613902111096486, -88.5886, -1.54616274973225),
(16919, '38376', 218, 50, 5817, 35.1313, 0.613156855505884, -88.3435, -1.54188494773561),
(16920, '38377', 218, 50, 90817, 35.3577, 0.617108280932399, -88.8288, -1.55035503059554),
(16921, '38378', 218, 50, 6001, 35.7686, 0.624279838828844, -88.6644, -1.54748570930526),
(16922, '38379', 218, 50, 91013, 35.1846, 0.614087115997197, -88.4446, -1.54364947560938),
(16923, '38380', 218, 50, 112572, 35.7824, 0.624520694265619, -87.9949, -1.53580072996316),
(16924, '38381', 218, 50, 91383, 35.3639, 0.617216491346023, -88.9379, -1.55225918480946),
(16925, '38382', 218, 50, 6381, 35.9719, 0.627828093198148, -88.9679, -1.55278278358506),
(16926, '38387', 218, 50, 25961, 35.8905, 0.626407395187025, -88.2976, -1.54108384160895),
(16927, '38388', 218, 50, 91864, 35.7216, 0.623459534080406, -88.3899, -1.54269478050854),
(16928, '38389', 218, 50, 26297, 36.0771, 0.629664179571246, -89.0596, -1.55438325050914),
(16929, '38390', 218, 50, 144, 35.8629, 0.625925684313475, -88.379, -1.54250453962007),
(16930, '38391', 218, 50, 8477, 35.5444, 0.620366810645873, -88.9894, -1.55315802937424),
(16931, '38392', 218, 50, 17095, 35.4938, 0.619483674044363, -89.0405, -1.55404989262201),
(16932, '38393', 218, 50, 920, 35.0541, 0.611809461323344, -88.6373, -1.54701272507797),
(16933, '38401', 218, 50, 1716, 35.6103, 0.621516982622937, -87.0502, -1.51931260451957),
(16934, '38402', 218, 50, 1716, 35.6148, 0.621595522439277, -87.0352, -1.51905080513177),
(16935, '38425', 218, 50, 15559, 35.3865, 0.617610935756973, -87.9913, -1.53573789811009),
(16936, '38449', 218, 50, 18903, 35.08, 0.612261501599611, -86.8885, -1.51649040711909),
(16937, '38450', 218, 50, 85942, 35.1472, 0.613434362856951, -87.7041, -1.53072531249836),
(16938, '38451', 218, 50, 86158, 35.4621, 0.618930404671481, -86.993, -1.51831427618743),
(16939, '38452', 218, 50, 86198, 35.0572, 0.611863566530156, -87.7969, -1.53234497804421),
(16940, '38453', 218, 50, 86284, 35.1552, 0.613573989197111, -87.0896, -1.52000026424485),
(16941, '38454', 218, 50, 0, 35.6935, 0.622969096560596, -87.3438, -1.52443689120342),
(16942, '38455', 218, 50, 15918, 35.0803, 0.612266737587367, -86.888, -1.51648168047283),
(16943, '38456', 218, 50, 20932, 35.3264, 0.616561992876525, -87.3063, -1.52378239273393),
(16944, '38457', 218, 50, 2458, 35.0302, 0.611392327632118, -87.2836, -1.52338620299372),
(16945, '38459', 218, 50, 87126, 35.1723, 0.613872440499202, -86.7779, -1.51456007296639),
(16946, '38460', 218, 50, 87332, 35.1281, 0.61310100496982, -87.1443, -1.52095495934569),
(16947, '38461', 218, 50, 47801, 35.585, 0.621075414322182, -87.3563, -1.52465505735992),
(16948, '38462', 218, 50, 87885, 35.5521, 0.620501200998276, -87.5467, -1.52797816425572),
(16949, '38463', 218, 50, 3362, 35.0201, 0.611216049377666, -87.5811, -1.52857855751841),
(16950, '38464', 218, 50, 30308, 35.2462, 0.615162238816425, -87.33, -1.52419603576665),
(16951, '38468', 218, 50, 88525, 35.2297, 0.614874259489846, -87.3403, -1.5243758046796),
(16952, '38469', 218, 50, 3869, 35.0785, 0.612235321660831, -87.4353, -1.526033867469),
(16953, '38471', 218, 50, 88727, 35.12, 0.612959633300408, -87.9057, -1.53424389627038),
(16954, '38472', 218, 50, 27770, 35.3885, 0.617645842342013, -86.9977, -1.51839630666227),
(16955, '38473', 218, 50, 89073, 35.0494, 0.611727430848501, -87.1516, -1.52108236838109),
(16956, '38474', 218, 50, 118, 35.5382, 0.620258600232249, -87.2056, -1.52202484617717),
(16957, '38475', 218, 50, 89675, 35.2685, 0.61555144723962, -88.043, -1.53664023333337),
(16958, '38476', 218, 50, 90126, 35.886, 0.626328855370685, -87.1683, -1.52137383836617),
(16959, '38477', 218, 50, 5238, 35.0525, 0.611781536055312, -87.0101, -1.51861272748952),
(16960, '38478', 218, 50, 11424, 35.1935, 0.614242450300624, -87.0242, -1.51885881891405),
(16961, '38481', 218, 50, 488, 35.0411, 0.611582568520585, -87.5073, -1.52729050453043),
(16962, '38482', 218, 50, 17977, 35.7579, 0.62409308859888, -87.1695, -1.5213947823172),
(16963, '38483', 218, 50, 25219, 35.4362, 0.618478364395215, -87.3382, -1.52433915276531),
(16964, '38485', 218, 50, 25858, 35.3192, 0.616436329170381, -87.7591, -1.53168524358696),
(16965, '38486', 218, 50, 91784, 35.153, 0.613535591953567, -87.5362, -1.52779490468426),
(16966, '38487', 218, 50, 38893, 35.6491, 0.622194170372711, -87.2376, -1.52258335153781),
(16967, '38488', 218, 50, 6212, 35.0513, 0.611760592104288, -86.6827, -1.51289851951849),
(16968, '38501', 218, 50, 85996, 36.1684, 0.631257665178317, -85.4971, -1.49220589590684),
(16969, '38502', 218, 50, 85996, 36.1624, 0.631152945423197, -85.502, -1.49229141704019),
(16970, '38503', 218, 50, 85996, 36.1567, 0.631053461655834, -85.5058, -1.49235773955177),
(16971, '38504', 218, 50, 84618, 36.3691, 0.63476054098707, -84.8115, -1.48023991855517),
(16972, '38505', 218, 50, 85996, 36.1799, 0.631458378042297, -85.4586, -1.49153394414483),
(16973, '38506', 218, 50, 85996, 36.1428, 0.630810860889807, -85.5254, -1.49269982408516),
(16974, '38541', 218, 50, 84630, 36.4916, 0.636898569320763, -85.3202, -1.48911840846007),
(16975, '38542', 218, 50, 84632, 36.3677, 0.634736106377542, -85.1962, -1.48695420018759),
(16976, '38543', 218, 50, 7073, 36.3661, 0.63470818110951, -85.1491, -1.4861321501099),
(16977, '38544', 218, 50, 150, 36.1553, 0.631029027046306, -85.6436, -1.49476280326102),
(16978, '38545', 218, 50, 85137, 36.343, 0.634305010052299, -85.652, -1.49490941091818),
(16979, '38547', 218, 50, 1202, 36.1251, 0.630501937612204, -86.0214, -1.50135665717505),
(16980, '38548', 218, 50, 85407, 36.1832, 0.631515973907612, -85.7565, -1.49673327998652),
(16981, '38549', 218, 50, 85467, 36.5725, 0.638310540685626, -85.1366, -1.4859139839534),
(16982, '38550', 218, 50, 85512, 35.7109, 0.623272783850443, -85.6043, -1.49407688886498),
(16983, '38551', 218, 50, 29423, 36.6168, 0.63908372154426, -85.4287, -1.49101209069848),
(16984, '38552', 218, 50, 85777, 36.1888, 0.631613712345724, -85.8418, -1.49822204583847),
(16985, '38553', 218, 50, 85835, 36.215, 0.632070988609747, -84.9684, -1.48297834015155),
(16986, '38554', 218, 50, 1860, 36.2478, 0.632643456604401, -85.1873, -1.48679886588417),
(16987, '38555', 218, 50, 1904, 35.9582, 0.627588983090625, -84.9722, -1.48304466266313),
(16988, '38556', 218, 50, 3399, 36.414, 0.635544193821215, -84.9342, -1.48238143754737),
(16989, '38557', 218, 50, 1904, 35.9804, 0.627976446184568, -84.9672, -1.48295739620053),
(16990, '38558', 218, 50, 1904, 35.9491, 0.627430158128694, -85.0247, -1.48396096052042),
(16991, '38559', 218, 50, 2098, 35.8668, 0.625993752154302, -85.4963, -1.49219193327283),
(16992, '38560', 218, 50, 8746, 36.2442, 0.632580624751329, -85.8798, -1.49888527095423),
(16993, '38562', 218, 50, 87179, 36.3545, 0.634505722916279, -85.6526, -1.4949198828937),
(16994, '38563', 218, 50, 2788, 36.1733, 0.631343186311665, -85.9306, -1.49977189821424),
(16995, '38564', 218, 50, 55048, 36.2794, 0.633194980648031, -85.7475, -1.49657620035384),
(16996, '38565', 218, 50, 87488, 36.2583, 0.63282671617586, -85.0311, -1.48407266159255),
(16997, '38567', 218, 50, 9453, 36.1071, 0.630187778346845, -85.9085, -1.49938618044955),
(16998, '38568', 218, 50, 87816, 36.4051, 0.635388859517788, -85.439, -1.49119185961144),
(16999, '38569', 218, 50, 16841, 36.0981, 0.630030698714165, -85.8508, -1.49837912547115),
(17000, '38570', 218, 50, 3825, 36.3891, 0.635109606837469, -85.3213, -1.48913760708184),
(17001, '38571', 218, 50, 1904, 35.9575, 0.627576765785861, -84.9715, -1.48303244535836),
(17002, '38572', 218, 50, 1904, 35.9577, 0.627580256444365, -84.9718, -1.48303768134612),
(17003, '38573', 218, 50, 10560, 36.4551, 0.636261524143785, -85.2041, -1.4870920811985),
(17004, '38574', 218, 50, 4284, 36.142, 0.630796898255791, -85.2657, -1.48816720401773),
(17005, '38575', 218, 50, 4348, 36.5966, 0.638731165035357, -85.6856, -1.49549584154685),
(17006, '38577', 218, 50, 89745, 36.568, 0.638232000869286, -84.9505, -1.48266592621544),
(17007, '38578', 218, 50, 268, 35.9789, 0.627950266245788, -85.2, -1.48702052269917),
(17008, '38579', 218, 50, 90175, 35.8336, 0.62541430284264, -85.5491, -1.49311346711788),
(17009, '38580', 218, 50, 90299, 36.3054, 0.633648766253549, -85.3894, -1.49032617630245),
(17010, '38581', 218, 50, 17831, 35.7259, 0.623534583238242, -85.6626, -1.49509441581889),
(17011, '38582', 218, 50, 980, 36.0995, 0.630055133323693, -85.7505, -1.4966285602314),
(17012, '38583', 218, 50, 25003, 35.931, 0.627114253534082, -85.4674, -1.491687533119),
(17013, '38585', 218, 50, 5995, 35.7022, 0.623120940205519, -85.4166, -1.49080090585899),
(17014, '38587', 218, 50, 91614, 35.9308, 0.627110762875579, -85.4748, -1.49181668748365),
(17015, '38588', 218, 50, 91849, 36.4844, 0.636772905614619, -85.708, -1.4958867952993),
(17016, '38589', 218, 50, 511, 36.2667, 0.632973323833028, -85.0871, -1.48505004597367),
(17017, '38601', 218, 30, 18708, 34.4718, 0.601646409088981, -89.5986, -1.56379057517739),
(17018, '38602', 218, 30, 58480, 34.6975, 0.605585617210732, -90.009, -1.57095340642758),
(17019, '38603', 218, 30, 13301, 34.8308, 0.607912141103641, -89.1721, -1.55634674591764),
(17020, '38606', 218, 30, 7298, 34.317, 0.598944639406894, -89.9516, -1.56995158743693),
(17021, '38609', 218, 30, 58606, 34.2355, 0.597522196066519, -90.2929, -1.57590839617399),
(17022, '38610', 218, 30, 984, 34.669, 0.605088198373914, -89.0217, -1.55372177072264),
(17023, '38611', 218, 30, 58850, 34.8436, 0.608135543247896, -89.757, -1.56655517671255),
(17024, '38614', 218, 30, 26802, 34.1999, 0.596900858852809, -90.5747, -1.58082673400611),
(17025, '38617', 218, 30, 59048, 34.3932, 0.600274580296914, -90.4893, -1.5793362228249),
(17026, '38618', 218, 30, 1687, 34.6895, 0.605445990870573, -89.9802, -1.570450751603),
(17027, '38619', 218, 30, 39860, 34.5044, 0.602215386425131, -89.8904, -1.56888344593471),
(17028, '38620', 218, 30, 1839, 34.1719, 0.59641216666225, -90.1389, -1.57322058912592),
(17029, '38621', 218, 30, 35422, 34.5047, 0.602220622412887, -90.1939, -1.57418052021451),
(17030, '38622', 218, 30, 46143, 34.171, 0.596396458698982, -90.1365, -1.57317870122387),
(17031, '38623', 218, 30, 59203, 34.4385, 0.601065214448067, -90.175, -1.57385065298589),
(17032, '38625', 218, 30, 8621, 34.641, 0.604599506183356, -88.8034, -1.54991171696553),
(17033, '38626', 218, 30, 2134, 34.43, 0.600916861461648, -90.4979, -1.57948632114058),
(17034, '38627', 218, 30, 59842, 34.4346, 0.600997146607239, -89.1857, -1.55658411069591),
(17035, '38628', 218, 30, 8837, 34.3924, 0.600260617662898, -90.256, -1.57526436968),
(17036, '38629', 218, 30, 2409, 34.8428, 0.60812158061388, -88.9624, -1.5526867904762),
(17037, '38630', 218, 30, 59889, 34.2026, 0.596947982742613, -90.5717, -1.58077437412855),
(17038, '38631', 218, 30, 59980, 34.363, 0.599747490862811, -90.6352, -1.58188265820356),
(17039, '38632', 218, 30, 16410, 34.8118, 0.607580528545762, -90.027, -1.57126756569294),
(17040, '38633', 218, 30, 9459, 34.6392, 0.60456809025682, -89.1801, -1.5564863722578),
(17041, '38634', 218, 30, 3200, 34.773, 0.606903340795988, -89.4435, -1.56108356950755),
(17042, '38635', 218, 30, 3200, 34.772, 0.606885887503468, -89.4486, -1.5611725812994),
(17043, '38637', 218, 30, 60324, 34.9501, 0.60999431890127, -90.0395, -1.57148573184943),
(17044, '38638', 218, 30, 3320, 34.6343, 0.604482569123472, -89.8233, -1.56771233000662),
(17045, '38639', 218, 30, 22301, 34.3254, 0.599091247064062, -90.453, -1.57870266830643),
(17046, '38641', 218, 30, 60535, 34.8926, 0.608990754581373, -90.1417, -1.57326945834497),
(17047, '38642', 218, 30, 244, 34.9851, 0.610605184139468, -89.4405, -1.56103120962999),
(17048, '38643', 218, 30, 3649, 34.2013, 0.596925293462337, -90.2801, -1.57568499402973),
(17049, '38644', 218, 30, 22773, 34.4535, 0.601327013835866, -90.4763, -1.57910933002215),
(17050, '38645', 218, 30, 56029, 34.2379, 0.597564083968567, -90.5201, -1.57987378423452),
(17051, '38646', 218, 30, 60774, 34.2501, 0.59777701413731, -90.2738, -1.57557503828686),
(17052, '38647', 218, 30, 60877, 34.9344, 0.609720302208707, -89.1149, -1.55534841758549),
(17053, '38649', 218, 30, 118, 34.7376, 0.606285494240782, -89.503, -1.56212204041248),
(17054, '38650', 218, 30, 10720, 34.5413, 0.602859412919117, -89.1292, -1.55559799966853),
(17055, '38651', 218, 30, 56474, 34.8989, 0.609100710324249, -89.9832, -1.57050311148056),
(17056, '38652', 218, 30, 30614, 34.492, 0.601998965597884, -89.0135, -1.55357865372397),
(17057, '38654', 218, 30, 23646, 34.95, 0.609992573572018, -89.8621, -1.5683895177564),
(17058, '38655', 218, 30, 4828, 34.3678, 0.599831266666907, -89.5252, -1.56250950350643),
(17059, '38658', 218, 30, 5171, 34.2164, 0.597188838179388, -89.9465, -1.56986257564508),
(17060, '38659', 218, 30, 61414, 34.5732, 0.603416172950504, -89.3379, -1.55924050181744),
(17061, '38661', 218, 30, 61493, 34.6097, 0.604053218127481, -89.8569, -1.56829876063529),
(17062, '38663', 218, 30, 5404, 34.7329, 0.606203463765938, -88.9502, -1.55247386030746),
(17063, '38664', 218, 30, 5451, 34.8159, 0.607652087045094, -90.3417, -1.57676011684896),
(17064, '38665', 218, 30, 24670, 34.6023, 0.603924063762834, -90.1243, -1.57296577105513),
(17065, '38666', 218, 30, 715, 34.4357, 0.601016345229011, -89.9175, -1.569356430162),
(17066, '38668', 218, 30, 61708, 34.6129, 0.604109068663545, -89.9715, -1.57029890795808),
(17067, '38669', 218, 30, 61748, 34.1869, 0.59667396605005, -90.6264, -1.58172906922939),
(17068, '38670', 218, 30, 5899, 34.4314, 0.600941296071176, -90.2205, -1.57464477779554),
(17069, '38671', 218, 30, 61831, 34.9757, 0.610441123189781, -89.9955, -1.57071778697856),
(17070, '38672', 218, 30, 61831, 34.9913, 0.610713394553092, -90.023, -1.57119775252286),
(17071, '38673', 218, 30, 6252, 34.2744, 0.598201129145544, -89.6378, -1.56447474424417),
(17072, '38674', 218, 30, 62037, 34.8999, 0.609118163616769, -88.9209, -1.55196247883663),
(17073, '38675', 218, 30, 62084, 34.3677, 0.599829521337655, -89.5242, -1.56249205021391),
(17074, '38676', 218, 30, 43402, 34.6864, 0.605391885663761, -90.3759, -1.57735701945314),
(17075, '38677', 218, 30, 28837, 34.3673, 0.599822540020647, -89.5299, -1.56259153398127),
(17076, '38679', 218, 30, 6554, 34.8838, 0.608837165607198, -89.5096, -1.56223723214312),
(17077, '38680', 218, 30, 43532, 34.9582, 0.610135690570682, -90.0969, -1.57248755084008),
(17078, '38683', 218, 30, 12616, 34.949, 0.609975120279498, -88.9002, -1.55160119568146),
(17079, '38685', 218, 30, 790, 34.6338, 0.604473842477212, -89.4692, -1.56153211912531),
(17080, '38686', 218, 30, 43532, 34.9576, 0.61012521859517, -90.1511, -1.57343351929466),
(17081, '38701', 218, 30, 2868, 33.3953, 0.582857939691262, -91.0501, -1.58912402927009),
(17082, '38702', 218, 30, 2868, 33.4104, 0.583121484408314, -91.0617, -1.58932648746332),
(17083, '38703', 218, 30, 2868, 33.4046, 0.583020255311698, -91.0265, -1.58871213156662),
(17084, '38704', 218, 30, 2868, 33.4052, 0.58303072728721, -91.0384, -1.58891982574761),
(17085, '38720', 218, 30, 58448, 34.1302, 0.595684364364169, -90.7706, -1.58424583401077),
(17086, '38721', 218, 30, 18854, 32.9736, 0.575497886235602, -90.8296, -1.58527557826944),
(17087, '38722', 218, 30, 18900, 33.269, 0.580653588845994, -90.8819, -1.58618838546823),
(17088, '38723', 218, 30, 7208, 33.2647, 0.580578539688158, -91.0261, -1.58870515024961),
(17089, '38725', 218, 30, 350, 33.6545, 0.587381833112432, -91.0846, -1.58972616786203),
(17090, '38726', 218, 30, 616, 33.786, 0.589676941078804, -90.9798, -1.58789706280594),
(17091, '38730', 218, 30, 26596, 33.705, 0.588263224384689, -90.7266, -1.58347788913989),
(17092, '38731', 218, 30, 13522, 33.0887, 0.577506760204648, -91.0861, -1.58975234780081),
(17093, '38732', 218, 30, 1620, 33.7394, 0.588863617647375, -90.7244, -1.58343949189634),
(17094, '38733', 218, 30, 1620, 33.7492, 0.58903465991407, -90.8332, -1.58533841012251),
(17095, '38736', 218, 30, 59684, 33.645, 0.587216026833492, -90.5546, -1.58047592282646),
(17096, '38737', 218, 30, 20676, 33.8035, 0.589982373697903, -90.5315, -1.58007275176925),
(17097, '38738', 218, 30, 61221, 33.8727, 0.591190141540283, -90.5517, -1.58042530827815),
(17098, '38739', 218, 30, 2113, 34.1868, 0.596672220720797, -90.6253, -1.58170987060762),
(17099, '38740', 218, 30, 2130, 33.7806, 0.589582693299196, -90.7223, -1.58340283998205),
(17100, '38744', 218, 30, 60047, 33.0364, 0.576593953005855, -91.0178, -1.58856028792169),
(17101, '38745', 218, 30, 2798, 32.8242, 0.572890364333123, -91.0451, -1.58903676280749),
(17102, '38746', 218, 30, 60144, 33.9416, 0.592392673394907, -90.946, -1.58730714151876),
(17103, '38748', 218, 30, 60287, 33.1761, 0.579032177970891, -90.8573, -1.58575903447224),
(17104, '38749', 218, 30, 13981, 33.4334, 0.583522910136272, -90.7589, -1.58404163048828),
(17105, '38751', 218, 30, 16542, 33.4506, 0.583823106767615, -90.6449, -1.58205195514101),
(17106, '38753', 218, 30, 3357, 33.3513, 0.582089994820385, -90.5921, -1.58113042129596),
(17107, '38754', 218, 30, 60396, 33.2599, 0.580494763884062, -90.5932, -1.58114961991773),
(17108, '38756', 218, 30, 10032, 33.4069, 0.583060397884494, -90.8964, -1.58644145820977),
(17109, '38758', 218, 30, 60801, 34.0982, 0.59512585900353, -90.5095, -1.57968877933381),
(17110, '38759', 218, 30, 60869, 33.8343, 0.590519935107517, -90.7284, -1.58350930506642),
(17111, '38760', 218, 30, 60874, 33.4473, 0.583765510902299, -91.0006, -1.58826009129035),
(17112, '38761', 218, 30, 60944, 33.4496, 0.583805653475095, -90.5052, -1.57961373017597),
(17113, '38762', 218, 30, 60961, 33.8862, 0.591425760989303, -90.7301, -1.58353897566371),
(17114, '38764', 218, 30, 11045, 33.7913, 0.58976944352916, -90.8569, -1.58575205315524),
(17115, '38765', 218, 30, 61219, 33.0251, 0.576396730800379, -90.7848, -1.58449367076455),
(17116, '38767', 218, 30, 61514, 34.149, 0.596012486263544, -90.7818, -1.58444131088699),
(17117, '38768', 218, 30, 490, 33.9879, 0.593200760838581, -90.3424, -1.57677233415373),
(17118, '38769', 218, 30, 5546, 33.8529, 0.590844566348388, -91.0256, -1.58869642360335),
(17119, '38771', 218, 30, 61625, 33.7218, 0.588556439699024, -90.5471, -1.58034502313256),
(17120, '38772', 218, 30, 11829, 33.5946, 0.586336380890487, -91.0773, -1.58959875882663),
(17121, '38773', 218, 30, 5780, 33.6058, 0.58653185776671, -90.7735, -1.58429644855907),
(17122, '38774', 218, 30, 59, 33.9504, 0.592546262369083, -90.7652, -1.58415158623116),
(17123, '38776', 218, 30, 61897, 33.4092, 0.58310054045729, -90.9102, -1.58668231364655),
(17124, '38778', 218, 30, 6159, 33.5516, 0.58558588931213, -90.5295, -1.58003784518421),
(17125, '38780', 218, 30, 290, 33.2644, 0.580573303700402, -91.0259, -1.58870165959111),
(17126, '38781', 218, 30, 62358, 33.8977, 0.591626473853282, -90.7187, -1.58334000812898),
(17127, '38782', 218, 30, 26164, 33.5019, 0.584718460673888, -91.0581, -1.58926365561025),
(17128, '38801', 218, 30, 6408, 34.2369, 0.597546630676047, -88.74, -1.54880517821977),
(17129, '38802', 218, 30, 6408, 34.2722, 0.598162731902001, -88.703, -1.54815940639653),
(17130, '38803', 218, 30, 6408, 34.2723, 0.598164477231253, -88.7023, -1.54814718909177),
(17131, '38804', 218, 30, 6408, 34.2864, 0.598410568655784, -88.6847, -1.54784001114342),
(17132, '38820', 218, 30, 58438, 34.1762, 0.596487215820086, -88.9625, -1.55268853580546),
(17133, '38821', 218, 30, 58458, 33.9858, 0.593164108924289, -88.4803, -1.54427255815234),
(17134, '38824', 218, 30, 58533, 34.5165, 0.602426571264623, -88.6362, -1.5469935264562),
(17135, '38825', 218, 30, 15157, 33.9892, 0.593223450118857, -88.4727, -1.54413991312919),
(17136, '38826', 218, 30, 58605, 34.2876, 0.598431512606808, -88.7805, -1.54951203656683),
(17137, '38827', 218, 30, 303, 34.5145, 0.602391664679583, -88.2102, -1.5395584238427),
(17138, '38828', 218, 30, 1001, 34.4325, 0.600960494692947, -88.862, -1.5509344799072),
(17139, '38829', 218, 30, 1048, 34.6549, 0.604842106949383, -88.5612, -1.5456845295172),
(17140, '38833', 218, 30, 1248, 34.8888, 0.608924432069798, -88.3092, -1.54128629980218),
(17141, '38834', 218, 30, 743, 34.9372, 0.609769171427763, -88.5131, -1.54484502614699),
(17142, '38835', 218, 30, 743, 34.9336, 0.609706339574691, -88.5218, -1.54499686979192),
(17143, '38838', 218, 30, 20549, 34.565, 0.60327305595184, -88.1902, -1.5392093579923),
(17144, '38839', 218, 30, 59253, 33.8618, 0.590999900651816, -89.322, -1.55896299446638),
(17145, '38841', 218, 30, 59768, 34.3533, 0.599578193925368, -89.0215, -1.55371828006413),
(17146, '38843', 218, 30, 2628, 34.2693, 0.598112117353693, -88.4011, -1.54289025738476),
(17147, '38844', 218, 30, 60014, 33.886, 0.591422270330799, -88.2365, -1.54001744543598),
(17148, '38846', 218, 30, 47441, 34.8449, 0.608158232528172, -88.4225, -1.54326375784469),
(17149, '38847', 218, 30, 54988, 34.4846, 0.601869811233237, -88.1805, -1.53904006105486),
(17150, '38848', 218, 30, 60120, 33.8512, 0.590814895751104, -88.3644, -1.54224972154928),
(17151, '38849', 218, 30, 60145, 34.4415, 0.601117574325627, -88.6624, -1.54745080272022),
(17152, '38850', 218, 30, 60330, 33.9148, 0.591924925155373, -89.0014, -1.55336746888448),
(17153, '38851', 218, 30, 3246, 33.8977, 0.591626473853282, -89.0003, -1.55334827026271),
(17154, '38852', 218, 30, 9676, 34.8094, 0.607538640643714, -88.1926, -1.53925124589435),
(17155, '38854', 218, 30, 60822, 33.9116, 0.591869074619309, -88.9305, -1.55213003044482),
(17156, '38855', 218, 30, 60762, 34.3721, 0.599906315824743, -88.4767, -1.54420972629927),
(17157, '38856', 218, 30, 3993, 34.4972, 0.602089722718988, -88.421, -1.54323757790591),
(17158, '38857', 218, 30, 60943, 34.2798, 0.598295376925152, -88.5941, -1.54625874284111),
(17159, '38858', 218, 30, 10751, 34.078, 0.594773302494628, -88.617, -1.54665842323982),
(17160, '38859', 218, 30, 4555, 34.5604, 0.603192770806248, -88.4163, -1.54315554743106),
(17161, '38860', 218, 30, 10933, 34.0047, 0.593493976152916, -88.7491, -1.5489640031817),
(17162, '38862', 218, 30, 5108, 34.1989, 0.596883405560289, -88.6639, -1.547476982659),
(17163, '38863', 218, 30, 61389, 34.2462, 0.597708946296482, -89.0064, -1.55345473534708),
(17164, '38864', 218, 30, 5293, 34.1594, 0.596194000505751, -89.1989, -1.55681449415717),
(17165, '38865', 218, 30, 61542, 34.7126, 0.605849161927784, -88.6588, -1.54738797086715),
(17166, '38866', 218, 30, 11788, 34.375, 0.599956930373051, -88.6884, -1.54790458832574),
(17167, '38868', 218, 30, 5777, 34.1188, 0.595485396829441, -88.7147, -1.54836360991901),
(17168, '38869', 218, 30, 18065, 34.3334, 0.599230873404221, -88.955, -1.55255763611156),
(17169, '38870', 218, 30, 12002, 34.0691, 0.5946179681912, -88.3823, -1.54256213548538),
(17170, '38871', 218, 30, 62000, 34.3115, 0.598848646298034, -89.1584, -1.55610763581011),
(17171, '38873', 218, 30, 62043, 34.6453, 0.604674555341191, -88.2382, -1.54004711603326),
(17172, '38874', 218, 30, 62044, 34.305, 0.598735199896655, -89.16, -1.55613556107814),
(17173, '38875', 218, 30, 62068, 33.9126, 0.591886527911829, -88.931, -1.55213875709108),
(17174, '38876', 218, 30, 25561, 34.2186, 0.597227235422932, -88.2072, -1.53950606396514),
(17175, '38877', 218, 30, 62144, 33.9122, 0.591879546594821, -88.9306, -1.55213177577407),
(17176, '38878', 218, 30, 62149, 33.9362, 0.5922984256153, -89.213, -1.5570605855817),
(17177, '38879', 218, 30, 12546, 34.1851, 0.596642550123514, -88.7192, -1.54844214973535),
(17178, '38880', 218, 30, 6759, 34.5359, 0.60276516513951, -88.635, -1.54697258250517),
(17179, '38901', 218, 30, 60122, 33.7803, 0.58957745731144, -89.8067, -1.56742260535079),
(17180, '38902', 218, 30, 60122, 33.7778, 0.589533824080141, -89.8106, -1.56749067319162),
(17181, '38912', 218, 30, 13310, 33.6369, 0.587074655164081, -90.0257, -1.57124487641266),
(17182, '38913', 218, 30, 7249, 34.1064, 0.595268976002194, -89.4198, -1.56066992647483),
(17183, '38914', 218, 30, 707, 33.8664, 0.591080185797408, -89.4565, -1.56131046231031),
(17184, '38915', 218, 30, 15356, 33.9859, 0.593165854253541, -89.3446, -1.55935743887733),
(17185, '38916', 218, 30, 58869, 33.887, 0.591439723623318, -89.326, -1.55903280763645),
(17186, '38917', 218, 30, 1380, 33.5186, 0.585009930658971, -89.9653, -1.57019069754445),
(17187, '38920', 218, 30, 58913, 33.8958, 0.591593312597494, -90.0351, -1.57140893736235),
(17188, '38921', 218, 30, 8039, 34.0073, 0.593539354713468, -90.056, -1.57177371117601),
(17189, '38922', 218, 30, 1678, 33.9765, 0.593001793303853, -89.6761, -1.56514320534769),
(17190, '38923', 218, 30, 59060, 33.3692, 0.582402408756492, -89.976, -1.57037744777442),
(17191, '38924', 218, 30, 59167, 33.2941, 0.581091666488244, -90.229, -1.57479313078196),
(17192, '38925', 218, 30, 59714, 33.6324, 0.586996115347741, -89.7158, -1.56583610106073),
(17193, '38926', 218, 30, 8728, 33.782, 0.589607127908724, -89.8285, -1.56780308712773),
(17194, '38927', 218, 30, 59815, 34.123, 0.595558700658025, -90.0374, -1.57144907993514),
(17195, '38928', 218, 30, 29901, 33.947, 0.592486921174515, -90.1748, -1.57384716232738),
(17196, '38929', 218, 30, 60078, 33.7878, 0.58970835700534, -89.8047, -1.56738769876575),
(17197, '38930', 218, 30, 2869, 33.5172, 0.584985496049444, -90.1759, -1.57386636094915),
(17198, '38935', 218, 30, 2869, 33.5202, 0.585037855927003, -90.1791, -1.57392221148522),
(17199, '38940', 218, 30, 21985, 33.6913, 0.588024114277166, -89.9363, -1.56968455206138),
(17200, '38941', 218, 30, 60400, 33.4961, 0.584617231577273, -90.3264, -1.57649308147341),
(17201, '38943', 218, 30, 60819, 33.5931, 0.586310200951707, -89.8471, -1.5681277183686),
(17202, '38944', 218, 30, 60910, 33.7504, 0.589055603865094, -90.3372, -1.57668157703262),
(17203, '38945', 218, 30, 60926, 33.5201, 0.585036110597751, -90.1802, -1.57394141010699),
(17204, '38946', 218, 30, 4321, 33.3809, 0.582606612278975, -90.35, -1.57690497917688),
(17205, '38947', 218, 30, 61090, 33.5205, 0.585043091914759, -89.9168, -1.56934421285724),
(17206, '38948', 218, 30, 4710, 34.1229, 0.595556955328773, -89.791, -1.56714858865823),
(17207, '38949', 218, 30, 11069, 34.1774, 0.59650815977111, -89.373, -1.55985311238489),
(17208, '38950', 218, 30, 61295, 33.7481, 0.589015461292298, -90.2113, -1.57448420750436),
(17209, '38951', 218, 30, 30845, 33.9447, 0.592446778601719, -89.3147, -1.55883558543098),
(17210, '38952', 218, 30, 61692, 33.6112, 0.586626105546318, -90.376, -1.5773587647824),
(17211, '38953', 218, 30, 61695, 33.8863, 0.591427506318554, -89.9187, -1.56937737411303),
(17212, '38954', 218, 30, 11940, 33.4584, 0.583959242449271, -90.2106, -1.5744719901996),
(17213, '38955', 218, 30, 61801, 33.8096, 0.590088838782275, -89.3435, -1.55933824025555),
(17214, '38957', 218, 30, 18216, 33.9878, 0.593199015509329, -90.3423, -1.57677058882447),
(17215, '38958', 218, 30, 12232, 33.9473, 0.592492157162271, -90.1748, -1.57384716232738),
(17216, '38959', 218, 30, 61949, 33.41, 0.583114503091305, -90.377, -1.57737621807492),
(17217, '38960', 218, 30, 62026, 33.7409, 0.588889797586155, -89.7898, -1.5671276447072),
(17218, '38961', 218, 30, 62028, 33.9879, 0.593200760838581, -89.8751, -1.56861641055916),
(17219, '38962', 218, 30, 62040, 33.8966, 0.59160727523151, -90.0341, -1.57139148406983),
(17220, '38963', 218, 30, 6427, 34.0155, 0.593682471712131, -90.4342, -1.57837454640706),
(17221, '38964', 218, 30, 6520, 34.0151, 0.593675490395123, -90.4314, -1.578325677188),
(17222, '38965', 218, 30, 6647, 34.1547, 0.596111970030907, -89.6333, -1.56439620442783),
(17223, '38966', 218, 30, 6671, 33.9473, 0.592492157162271, -90.3469, -1.57685087397007),
(17224, '38967', 218, 30, 904, 33.4841, 0.584407792067033, -89.7318, -1.56611535374105),
(17225, '39038', 218, 30, 58620, 33.1834, 0.579159587006286, -90.4859, -1.57927688163034),
(17226, '39039', 218, 30, 358, 32.8714, 0.573714159740064, -90.4678, -1.57896097703573),
(17227, '39040', 218, 30, 58635, 32.644, 0.569745281021029, -90.3675, -1.57721041179598),
(17228, '39041', 218, 30, 19382, 32.3721, 0.564999730784856, -90.4544, -1.57872710291596),
(17229, '39042', 218, 30, 7653, 32.2894, 0.563556343493457, -89.9683, -1.57024305742201),
(17230, '39043', 218, 30, 7653, 32.282, 0.563427189128809, -90.0068, -1.57091500918403),
(17231, '39044', 218, 30, 34965, 32.0252, 0.558945183609688, -89.9684, -1.57024480275127),
(17232, '39045', 218, 30, 1304, 32.7306, 0.571256736153256, -89.8166, -1.56759539294674),
(17233, '39046', 218, 30, 19763, 32.6038, 0.569043658661727, -90.0317, -1.57134959616778),
(17234, '39047', 218, 30, 7653, 32.2734, 0.563277090813138, -89.9863, -1.57055721668737),
(17235, '39051', 218, 30, 7932, 32.7386, 0.571396362493416, -89.5353, -1.56268578176088),
(17236, '39054', 218, 30, 7935, 32.8043, 0.572543043811976, -90.9262, -1.58696156632687),
(17237, '39056', 218, 30, 1630, 32.3388, 0.564418536143942, -90.3234, -1.57644072159585),
(17238, '39057', 218, 30, 59091, 32.4777, 0.566842798474962, -89.3168, -1.55887223734527),
(17239, '39058', 218, 30, 1630, 32.3413, 0.564462169375242, -90.3221, -1.57641803231557),
(17240, '39059', 218, 30, 1911, 31.9845, 0.558234834604126, -90.3575, -1.57703587887078),
(17241, '39060', 218, 30, 1630, 32.3604, 0.564795527262373, -90.2655, -1.57543017595894),
(17242, '39061', 218, 30, 59239, 33.0256, 0.576405457446639, -90.7852, -1.58450065208156),
(17243, '39062', 218, 30, 0, 31.9829, 0.558206909336094, -89.8966, -1.56899165634833),
(17244, '39063', 218, 30, 15836, 33.0734, 0.577239724829093, -89.8582, -1.56832144991557),
(17245, '39066', 218, 30, 8695, 32.2788, 0.563371338592746, -90.5886, -1.58106933477214),
(17246, '39067', 218, 30, 8784, 33.0816, 0.577382841827756, -89.5411, -1.56278701085749),
(17247, '39069', 218, 30, 2426, 31.7077, 0.553403763234606, -91.063, -1.5893491767436),
(17248, '39071', 218, 30, 27181, 32.546, 0.568034858354075, -90.2971, -1.57598170000257),
(17249, '39072', 218, 30, 5158, 32.4615, 0.566560055136139, -90.2633, -1.5753917787154),
(17250, '39073', 218, 30, 2502, 32.1491, 0.561107646552909, -90.1351, -1.57315426661434),
(17251, '39074', 218, 30, 2517, 32.3653, 0.564881048395721, -89.4718, -1.56157749768586),
(17252, '39077', 218, 30, 59998, 31.9319, 0.557316791417577, -90.3887, -1.5775804215974),
(17253, '39078', 218, 30, 2693, 31.8355, 0.555634294018655, -90.2191, -1.57462034318602),
(17254, '39079', 218, 30, 2775, 32.9705, 0.57544378102879, -89.9123, -1.5692656730409),
(17255, '39080', 218, 30, 60185, 32.4941, 0.56712903247229, -89.4891, -1.56187943964646),
(17256, '39081', 218, 30, 55188, 31.7199, 0.553616693403349, -91.0381, -1.58891458975985),
(17257, '39082', 218, 30, 2996, 31.9611, 0.55782642755916, -90.0946, -1.57244740826728),
(17258, '39083', 218, 30, 21801, 31.8649, 0.556147420818741, -90.3885, -1.57757693093889),
(17259, '39086', 218, 30, 48026, 31.9551, 0.55772170780404, -90.8235, -1.58516911318507),
(17260, '39087', 218, 30, 3145, 32.4597, 0.566528639209603, -89.5117, -1.56227388405741),
(17261, '39088', 218, 30, 22007, 32.8343, 0.573066642587574, -90.6993, -1.58300141425409),
(17262, '39090', 218, 30, 60518, 33.0562, 0.57693952819775, -89.5904, -1.56364745817873),
(17263, '39092', 218, 30, 36776, 32.341, 0.564456933387486, -89.3544, -1.55952848114402),
(17264, '39094', 218, 30, 10035, 32.641, 0.569692921143469, -89.5677, -1.56325126843853),
(17265, '39095', 218, 30, 3748, 33.1143, 0.577953564493158, -90.0528, -1.57171786063995),
(17266, '39096', 218, 30, 60694, 31.8197, 0.55535853199684, -91.1989, -1.59172107919706),
(17267, '39097', 218, 30, 10204, 32.9785, 0.57558340736895, -90.5942, -1.58116707321025);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(17268, '39098', 218, 30, 37000, 32.5716, 0.568481662642585, -89.7123, -1.56577501453691),
(17269, '39107', 218, 30, 60813, 33.0219, 0.576340880264316, -89.688, -1.56535089952867),
(17270, '39108', 218, 30, 60823, 33.1658, 0.578852409057935, -89.3308, -1.55911658344055),
(17271, '39109', 218, 30, 60745, 32.7089, 0.570877999705573, -89.3764, -1.55991245357946),
(17272, '39110', 218, 30, 3938, 32.4657, 0.566633358964723, -90.1193, -1.57287850459253),
(17273, '39111', 218, 30, 60746, 31.8731, 0.556290537817405, -89.7316, -1.56611186308254),
(17274, '39112', 218, 30, 61653, 31.8981, 0.556726870130403, -89.7772, -1.56690773322145),
(17275, '39113', 218, 30, 60808, 32.8514, 0.573365093889665, -91.0363, -1.58888317383331),
(17276, '39114', 218, 30, 10443, 31.9635, 0.557868315461208, -89.8725, -1.5685710319986),
(17277, '39115', 218, 30, 60879, 33.0496, 0.576824336467118, -90.5722, -1.58078310077481),
(17278, '39116', 218, 30, 37233, 31.8497, 0.555882130772438, -89.5661, -1.56322334317049),
(17279, '39117', 218, 30, 10614, 32.3516, 0.564641938288198, -89.6531, -1.56474177961973),
(17280, '39119', 218, 30, 590, 31.7187, 0.553595749452325, -89.6799, -1.56520952785926),
(17281, '39120', 218, 30, 4483, 31.542, 0.550511752664052, -91.3652, -1.59462356174312),
(17282, '39121', 218, 30, 4483, 31.509, 0.549935794010893, -91.361, -1.59455025791454),
(17283, '39122', 218, 30, 4483, 31.5603, 0.550831147917166, -91.403, -1.59528329620038),
(17284, '39130', 218, 30, 3938, 32.4617, 0.566563545794643, -90.1154, -1.5728104367517),
(17285, '39140', 218, 30, 0, 31.7223, 0.553658581305397, -90.0433, -1.57155205436101),
(17286, '39144', 218, 30, 61246, 31.8519, 0.555920528015982, -90.8064, -1.58487066188298),
(17287, '39145', 218, 30, 61269, 32.3281, 0.564231785913979, -89.79, -1.56713113536571),
(17288, '39146', 218, 30, 11179, 32.8871, 0.573988176432627, -89.9707, -1.57028494532406),
(17289, '39148', 218, 30, 5087, 32.0628, 0.559601427408438, -89.9925, -1.570665427101),
(17290, '39149', 218, 30, 712, 31.8244, 0.555440562471683, -90.0231, -1.57119949785211),
(17291, '39150', 218, 30, 61404, 31.9562, 0.557740906425812, -90.9839, -1.58796862130527),
(17292, '39151', 218, 30, 42704, 32.1026, 0.560296068450732, -89.7861, -1.56706306752488),
(17293, '39152', 218, 30, 11424, 32.2732, 0.563273600154634, -89.6337, -1.56440318574484),
(17294, '39153', 218, 30, 185, 32.0362, 0.559137169827407, -89.5249, -1.56250426751867),
(17295, '39154', 218, 30, 24225, 32.236, 0.562624337672892, -90.4355, -1.57839723568733),
(17296, '39156', 218, 30, 61503, 32.4216, 0.565863668764593, -90.8184, -1.58508010139322),
(17297, '39157', 218, 30, 61539, 32.4195, 0.565827016850302, -90.1242, -1.57296402572587),
(17298, '39158', 218, 30, 61539, 32.4215, 0.565861923435342, -90.1312, -1.57308619877351),
(17299, '39159', 218, 30, 61587, 32.8991, 0.574197615942866, -90.8808, -1.58616918684646),
(17300, '39160', 218, 30, 61651, 32.9803, 0.575614823295486, -89.782, -1.56699150902555),
(17301, '39161', 218, 30, 74207, 32.4694, 0.566697936147047, -89.8749, -1.56861291990065),
(17302, '39162', 218, 30, 61678, 32.6149, 0.569237390208699, -90.6245, -1.5816959079736),
(17303, '39163', 218, 30, 24789, 32.6586, 0.57000009909182, -89.936, -1.56967931607362),
(17304, '39165', 218, 30, 24860, 31.3849, 0.547769840409168, -91.4041, -1.59530249482215),
(17305, '39166', 218, 30, 24871, 33.0948, 0.577613225289019, -90.4906, -1.57935891210518),
(17306, '39167', 218, 30, 6054, 32.0943, 0.560151206122816, -90.0835, -1.57225367672031),
(17307, '39168', 218, 30, 25360, 31.8276, 0.555496413007747, -89.4282, -1.56081653413199),
(17308, '39169', 218, 30, 61984, 33.1818, 0.579131661738254, -90.2236, -1.57469888300236),
(17309, '39170', 218, 30, 12285, 32.1406, 0.560959293566489, -90.3492, -1.57689101654286),
(17310, '39171', 218, 30, 43344, 32.8634, 0.573574533399905, -89.6689, -1.56501754164154),
(17311, '39173', 218, 30, 62036, 32.7319, 0.571279425433532, -90.4598, -1.57882135069557),
(17312, '39174', 218, 30, 62058, 32.3949, 0.565397665854311, -90.1548, -1.57349809647698),
(17313, '39175', 218, 30, 31360, 32.1192, 0.560585793106563, -90.6027, -1.58131542619667),
(17314, '39176', 218, 30, 6490, 33.3336, 0.581781071542782, -89.7425, -1.56630210397101),
(17315, '39177', 218, 30, 25685, 32.5853, 0.568720772750108, -90.845, -1.58554435897425),
(17316, '39179', 218, 30, 31375, 32.8143, 0.572717576737175, -90.0935, -1.57242820964551),
(17317, '39180', 218, 30, 18446, 32.3267, 0.564207351304451, -90.8612, -1.58582710231307),
(17318, '39181', 218, 30, 18446, 32.3415, 0.564465660033746, -90.8588, -1.58578521441102),
(17319, '39182', 218, 30, 18446, 32.3529, 0.564664627568473, -90.8777, -1.58611508163965),
(17320, '39183', 218, 30, 18446, 32.3913, 0.565334834001239, -90.8255, -1.58520401977011),
(17321, '39189', 218, 30, 72, 32.5939, 0.56887087106578, -89.4587, -1.56134885955385),
(17322, '39190', 218, 30, 12671, 31.5787, 0.551152288499533, -91.299, -1.5934681537783),
(17323, '39191', 218, 30, 12739, 31.7012, 0.553290316833226, -90.3955, -1.57769910398653),
(17324, '39192', 218, 30, 6702, 33.2038, 0.579515634173693, -89.7837, -1.56702117962283),
(17325, '39193', 218, 30, 6797, 32.2355, 0.562615611026632, -90.0721, -1.57205470918558),
(17326, '39194', 218, 30, 62401, 32.8558, 0.573441888376753, -90.4051, -1.57786665559473),
(17327, '39201', 218, 30, 3384, 32.2962, 0.563675025882593, -90.1856, -1.5740356578866),
(17328, '39202', 218, 30, 3384, 32.3099, 0.563914135990116, -90.178, -1.57390301286345),
(17329, '39203', 218, 30, 3384, 32.3077, 0.563875738746572, -90.1998, -1.57428349464038),
(17330, '39204', 218, 30, 3384, 32.2827, 0.563439406433573, -90.2315, -1.57483676401326),
(17331, '39205', 218, 30, 3384, 32.3019, 0.563774509649956, -90.1819, -1.57397108070427),
(17332, '39206', 218, 30, 3384, 32.3682, 0.564931662944029, -90.1728, -1.57381225574234),
(17333, '39207', 218, 30, 3384, 32.3092, 0.563901918685352, -90.2004, -1.57429396661589),
(17334, '39208', 218, 30, 23808, 32.2863, 0.563502238286645, -90.0865, -1.57230603659787),
(17335, '39209', 218, 30, 3384, 32.3221, 0.564127066158859, -90.2546, -1.57523993507047),
(17336, '39210', 218, 30, 3384, 32.2759, 0.563320724044438, -90.2187, -1.57461336186901),
(17337, '39211', 218, 30, 3384, 32.3714, 0.564987513480092, -90.128, -1.57303034823745),
(17338, '39212', 218, 30, 3384, 32.2438, 0.562760473354548, -90.265, -1.57542144931268),
(17339, '39213', 218, 30, 3384, 32.3496, 0.564607031703158, -90.2178, -1.57459765390574),
(17340, '39215', 218, 30, 3384, 32.2983, 0.563711677796884, -90.1852, -1.57402867656959),
(17341, '39216', 218, 30, 3384, 32.3383, 0.564409809497682, -90.1646, -1.57366913874368),
(17342, '39217', 218, 30, 3384, 32.2896, 0.563559834151961, -90.184, -1.57400773261857),
(17343, '39218', 218, 30, 5374, 32.218, 0.562310178407533, -90.1572, -1.57353998437903),
(17344, '39225', 218, 30, 3384, 32.2898, 0.563563324810465, -90.1848, -1.57402169525258),
(17345, '39232', 218, 30, 59921, 32.2901, 0.563568560798221, -90.1838, -1.57400424196006),
(17346, '39235', 218, 30, 3384, 32.2814, 0.563416717153297, -90.234, -1.57488039724456),
(17347, '39236', 218, 30, 3384, 32.3629, 0.564839160493673, -90.1464, -1.57335148881982),
(17348, '39250', 218, 30, 3384, 32.2895, 0.563558088822709, -90.1845, -1.57401645926483),
(17349, '39269', 218, 30, 3384, 32.3008, 0.563755311028184, -90.188, -1.57407754578865),
(17350, '39271', 218, 30, 3384, 32.2897, 0.563561579481213, -90.1845, -1.57401645926483),
(17351, '39272', 218, 30, 58853, 32.2144, 0.562247346554461, -90.2669, -1.57545461056847),
(17352, '39282', 218, 30, 3384, 32.2542, 0.562941987596755, -90.2499, -1.57515790459563),
(17353, '39283', 218, 30, 3384, 32.3677, 0.564922936297769, -90.2282, -1.57477916814795),
(17354, '39284', 218, 30, 3384, 32.2723, 0.563257892191366, -90.2155, -1.57455751133294),
(17355, '39286', 218, 30, 3384, 32.3514, 0.564638447629694, -90.1763, -1.57387334226616),
(17356, '39288', 218, 30, 23808, 32.2988, 0.563720404443145, -90.1423, -1.57327993032048),
(17357, '39289', 218, 30, 3384, 32.3859, 0.565240586221632, -90.2746, -1.57558900092087),
(17358, '39296', 218, 30, 3384, 32.3429, 0.564490094643274, -90.1627, -1.57363597748789),
(17359, '39298', 218, 30, 3384, 32.3205, 0.564099140890827, -90.2079, -1.57442486630979),
(17360, '39301', 218, 30, 10448, 32.3722, 0.565001476114108, -88.6989, -1.5480878478972),
(17361, '39302', 218, 30, 10448, 32.3661, 0.564895011029737, -88.7012, -1.54812799046999),
(17362, '39303', 218, 30, 10448, 32.4228, 0.565884612715618, -88.7022, -1.54814544376251),
(17363, '39304', 218, 30, 10448, 32.3638, 0.564854868456941, -88.6874, -1.54788713503322),
(17364, '39305', 218, 30, 10448, 32.4028, 0.565535546865219, -88.7037, -1.54817162370129),
(17365, '39307', 218, 30, 10448, 32.3326, 0.564310325730319, -88.8314, -1.55040040915609),
(17366, '39309', 218, 30, 10448, 32.5391, 0.567914430635687, -88.5676, -1.54579623058933),
(17367, '39320', 218, 30, 7216, 32.486, 0.566987660802878, -88.6963, -1.54804246933665),
(17368, '39322', 218, 30, 58818, 31.4911, 0.549623380074786, -88.5615, -1.54568976550496),
(17369, '39323', 218, 30, 59004, 32.255, 0.562955950230771, -88.9501, -1.55247211497821),
(17370, '39324', 218, 30, 15541, 31.5803, 0.551180213767565, -88.6964, -1.5480442146659),
(17371, '39325', 218, 30, 1706, 32.5228, 0.567629941967612, -88.8159, -1.55012988312203),
(17372, '39326', 218, 30, 1951, 32.5483, 0.56807500092687, -88.6738, -1.54764977025495),
(17373, '39327', 218, 30, 2007, 32.4399, 0.566183064017709, -89.1098, -1.55525940579364),
(17374, '39328', 218, 30, 54366, 32.773, 0.571996755756102, -88.6612, -1.5474298587692),
(17375, '39330', 218, 30, 2311, 32.0797, 0.559896388052025, -88.7441, -1.5488767367191),
(17376, '39332', 218, 30, 3077, 32.3141, 0.5639874398187, -89.0203, -1.55369733611311),
(17377, '39335', 218, 30, 41729, 32.4082, 0.565629794644826, -88.682, -1.54779288725361),
(17378, '39336', 218, 30, 3696, 32.2916, 0.563594740737001, -89.27, -1.55805542325534),
(17379, '39337', 218, 30, 3807, 32.538, 0.567895232013915, -89.1847, -1.55656665740339),
(17380, '39338', 218, 30, 60699, 32.136, 0.560879008420898, -89.2192, -1.55716879599532),
(17381, '39339', 218, 30, 3876, 33.1255, 0.578149041369382, -89.0538, -1.55428202141253),
(17382, '39341', 218, 30, 3937, 33.1157, 0.577977999102686, -88.5579, -1.54562693365189),
(17383, '39342', 218, 30, 630, 32.4175, 0.565792110265262, -88.6501, -1.54723612722223),
(17384, '39345', 218, 30, 4570, 32.32, 0.564090414244567, -89.1635, -1.55619664760196),
(17385, '39346', 218, 30, 61112, 32.9753, 0.575527556832886, -89.1587, -1.55611287179787),
(17386, '39347', 218, 30, 61205, 32.0038, 0.558571683149761, -88.8655, -1.55099556643102),
(17387, '39348', 218, 30, 56816, 32.0102, 0.558683384221889, -89.0777, -1.55469915510375),
(17388, '39350', 218, 30, 4983, 32.7738, 0.572010718390118, -89.1162, -1.55537110686577),
(17389, '39352', 218, 30, 28307, 32.6557, 0.569949484543512, -88.4889, -1.54442265646801),
(17390, '39354', 218, 30, 5220, 32.8633, 0.573572788070653, -88.8361, -1.55048243963093),
(17391, '39355', 218, 30, 11443, 32.0439, 0.559271560179811, -88.7237, -1.54852068955169),
(17392, '39356', 218, 30, 5540, 32.1345, 0.560852828482118, -89.0144, -1.55359436168724),
(17393, '39358', 218, 30, 61696, 32.8405, 0.573174853001198, -88.5159, -1.54489389536605),
(17394, '39359', 218, 30, 28559, 32.5728, 0.568502606593609, -89.3354, -1.55919686858614),
(17395, '39360', 218, 30, 61767, 31.8575, 0.556018266454094, -88.7047, -1.54818907699381),
(17396, '39361', 218, 30, 61772, 32.9679, 0.575398402468239, -88.5432, -1.54537037025184),
(17397, '39362', 218, 30, 6059, 31.435, 0.548644250364417, -88.4667, -1.54403519337407),
(17398, '39363', 218, 30, 6104, 32.1317, 0.560803959263062, -88.7969, -1.54979827056415),
(17399, '39364', 218, 30, 62053, 32.4293, 0.565998059116997, -88.5372, -1.54526565049672),
(17400, '39365', 218, 30, 455, 32.5706, 0.568464209350065, -89.1182, -1.55540601345081),
(17401, '39366', 218, 30, 62181, 31.983, 0.558208654665346, -88.9692, -1.55280547286534),
(17402, '39367', 218, 30, 25858, 31.6773, 0.552873183142, -88.6439, -1.5471279168086),
(17403, '39401', 218, 30, 60198, 31.3243, 0.54671217088246, -89.3033, -1.55863661789625),
(17404, '39402', 218, 30, 60198, 31.3128, 0.54651145801848, -89.3432, -1.5593330042678),
(17405, '39403', 218, 30, 60198, 31.3244, 0.546713916211712, -89.2783, -1.55820028558325),
(17406, '39404', 218, 30, 60198, 31.2964, 0.546225224021153, -89.4297, -1.56084271407077),
(17407, '39406', 218, 30, 60198, 31.3295, 0.546802928003563, -89.3372, -1.55922828451268),
(17408, '39407', 218, 30, 60198, 31.3132, 0.546518439335488, -89.3072, -1.55870468573708),
(17409, '39421', 218, 30, 58562, 31.4952, 0.549694938574118, -89.6862, -1.56531948360214),
(17410, '39422', 218, 30, 16, 31.943, 0.557510522964549, -89.2002, -1.55683718343745),
(17411, '39423', 218, 30, 31761, 31.0403, 0.541755435806796, -88.9046, -1.55167799016855),
(17412, '39425', 218, 30, 1157, 31.0537, 0.541989309926563, -89.2285, -1.55733111161576),
(17413, '39426', 218, 30, 58897, 30.5914, 0.533920652794593, -89.6382, -1.56448172556118),
(17414, '39427', 218, 30, 572, 31.5585, 0.55079973199063, -89.7822, -1.56699499968405),
(17415, '39428', 218, 30, 308, 31.6694, 0.552735302131092, -89.5425, -1.56281144546702),
(17416, '39429', 218, 30, 1716, 31.2564, 0.545527092320356, -89.8268, -1.56777341653044),
(17417, '39436', 218, 30, 59750, 31.4745, 0.549333655418955, -89.3234, -1.5589874290759),
(17418, '39437', 218, 30, 2272, 31.6059, 0.551627018056076, -89.2006, -1.55684416475445),
(17419, '39439', 218, 30, 36355, 31.8983, 0.556730360788907, -89.0062, -1.55345124468858),
(17420, '39440', 218, 30, 14092, 31.7028, 0.553318242101258, -89.139, -1.55576904193523),
(17421, '39441', 218, 30, 14092, 31.7063, 0.553379328625078, -89.1252, -1.55552818649845),
(17422, '39442', 218, 30, 14092, 31.6935, 0.553155926480823, -89.1451, -1.5558755070196),
(17423, '39443', 218, 30, 14092, 31.6944, 0.553171634444091, -89.1306, -1.55562243427806),
(17424, '39451', 218, 30, 60594, 31.1542, 0.543743365824817, -88.5624, -1.54570547346823),
(17425, '39452', 218, 30, 60710, 30.7158, 0.536091842384074, -88.527, -1.54508762691302),
(17426, '39455', 218, 30, 16965, 31.0059, 0.54115504254411, -89.4548, -1.56128079171302),
(17427, '39456', 218, 30, 42044, 31.1019, 0.542830558626024, -88.8242, -1.55027474544995),
(17428, '39457', 218, 30, 60844, 30.6691, 0.535276773623393, -89.6388, -1.56449219753669),
(17429, '39459', 218, 30, 56390, 31.4825, 0.549473281759115, -89.3264, -1.55903978895346),
(17430, '39460', 218, 30, 4348, 32.1393, 0.560936604286214, -89.0657, -1.55448971559351),
(17431, '39461', 218, 30, 4502, 31.1836, 0.544256492624904, -88.7397, -1.54879994223201),
(17432, '39462', 218, 30, 10756, 31.2952, 0.546204280070129, -89.0699, -1.5545630194221),
(17433, '39463', 218, 30, 23378, 30.559, 0.533355166116947, -89.6462, -1.56462135190134),
(17434, '39464', 218, 30, 61197, 31.4033, 0.548090980991535, -89.0917, -1.55494350119903),
(17435, '39465', 218, 30, 61289, 31.3516, 0.547188645768254, -89.2199, -1.55718101330009),
(17436, '39466', 218, 30, 61299, 30.5317, 0.532878691231153, -89.6794, -1.565200801213),
(17437, '39470', 218, 30, 37766, 30.8412, 0.538280485266075, -89.5331, -1.56264738451734),
(17438, '39474', 218, 30, 24130, 31.5964, 0.551461211777136, -89.8751, -1.56861641055916),
(17439, '39475', 218, 30, 57066, 31.0695, 0.542265071948378, -89.2904, -1.55841147042275),
(17440, '39476', 218, 30, 61537, 31.3424, 0.547028075477071, -88.9493, -1.55245815234419),
(17441, '39477', 218, 30, 24644, 31.7876, 0.55479828130695, -89.036, -1.55397135280567),
(17442, '39478', 218, 30, 31072, 31.0464, 0.541861900891167, -89.8073, -1.5674330773263),
(17443, '39479', 218, 30, 28565, 31.5162, 0.550061457717037, -89.488, -1.56186024102469),
(17444, '39480', 218, 30, 61828, 31.7622, 0.554354967676943, -89.3209, -1.5589437958446),
(17445, '39481', 218, 30, 6117, 31.8461, 0.555819298919366, -89.2614, -1.55790532493967),
(17446, '39482', 218, 30, 61929, 31.4177, 0.548342308403822, -89.5431, -1.56282191744253),
(17447, '39483', 218, 30, 59965, 31.168, 0.543984221261593, -89.9638, -1.57016451760567),
(17448, '39501', 218, 30, 16311, 30.3854, 0.530325274535485, -89.0867, -1.55485623473643),
(17449, '39502', 218, 30, 16311, 30.3919, 0.530438720936865, -89.102, -1.55512327011199),
(17450, '39503', 218, 30, 16311, 30.4669, 0.53174771787586, -89.1131, -1.55531700165896),
(17451, '39505', 218, 30, 16311, 30.4437, 0.531342801489398, -89.0701, -1.5545665100806),
(17452, '39506', 218, 30, 16311, 30.3904, 0.530412540998085, -89.0565, -1.55432914530233),
(17453, '39507', 218, 30, 16311, 30.3951, 0.530494571472928, -89.039, -1.55402371268323),
(17454, '39520', 218, 30, 58574, 30.3181, 0.529150667948893, -89.4814, -1.56174504929405),
(17455, '39521', 218, 30, 58574, 30.3277, 0.529318219557084, -89.3709, -1.5598164604706),
(17456, '39522', 218, 30, 0, 30.336, 0.529463081885, -89.5062, -1.56217789094855),
(17457, '39525', 218, 30, 8510, 30.3871, 0.530354945132769, -89.3728, -1.55984962172639),
(17458, '39529', 218, 30, 0, 30.3353, 0.529450864580236, -89.5065, -1.5621831269363),
(17459, '39530', 218, 30, 58677, 30.4021, 0.530616744520568, -88.8962, -1.55153138251138),
(17460, '39531', 218, 30, 58677, 30.4029, 0.530630707154584, -88.9658, -1.55274613167077),
(17461, '39532', 218, 30, 58677, 30.4595, 0.531618563511213, -88.9493, -1.55245815234419),
(17462, '39533', 218, 30, 58677, 30.3951, 0.530494571472928, -88.8851, -1.55133765096441),
(17463, '39534', 218, 30, 58677, 30.4153, 0.530847127981831, -88.9102, -1.55177572860666),
(17464, '39535', 218, 30, 58677, 30.4159, 0.530857599957343, -88.9315, -1.55214748373734),
(17465, '39540', 218, 30, 0, 30.4588, 0.531606346206449, -88.9496, -1.55246338833195),
(17466, '39552', 218, 30, 2321, 30.4513, 0.531475446512549, -88.5421, -1.54535117163007),
(17467, '39553', 218, 30, 60015, 30.4002, 0.53058358326478, -88.6418, -1.54709126489431),
(17468, '39555', 218, 30, 3300, 30.6733, 0.535350077451977, -88.4869, -1.54438774988297),
(17469, '39556', 218, 30, 60485, 30.4166, 0.530869817262107, -89.4489, -1.56117781728716),
(17470, '39558', 218, 30, 36786, 30.2405, 0.527796292449345, -89.434, -1.56091776322861),
(17471, '39560', 218, 30, 49041, 30.3627, 0.529929084795282, -89.1665, -1.55624900747952),
(17472, '39561', 218, 30, 37130, 30.6882, 0.535610131510524, -89.1793, -1.55647240962378),
(17473, '39562', 218, 30, 60960, 30.4253, 0.531021660907031, -88.5288, -1.54511904283956),
(17474, '39563', 218, 30, 60960, 30.409, 0.530737172238956, -88.527, -1.54508762691302),
(17475, '39564', 218, 30, 61145, 30.4123, 0.530794768104272, -88.7549, -1.54906523227832),
(17476, '39565', 218, 30, 61145, 30.57, 0.533547152334667, -88.7403, -1.54881041420752),
(17477, '39566', 218, 30, 61145, 30.4165, 0.530868071932855, -88.8219, -1.55023460287715),
(17478, '39567', 218, 30, 61235, 30.4236, 0.530991990309747, -88.5222, -1.54500385110892),
(17479, '39568', 218, 30, 61235, 30.3717, 0.530086164427962, -88.525, -1.54505272032798),
(17480, '39569', 218, 30, 61235, 30.3661, 0.52998842598985, -88.555, -1.54557631910358),
(17481, '39571', 218, 30, 61236, 30.3663, 0.529991916648354, -89.2652, -1.55797164745124),
(17482, '39572', 218, 30, 61261, 30.2449, 0.527873086936433, -89.6063, -1.5639249655298),
(17483, '39573', 218, 30, 61281, 30.7658, 0.536964507010071, -89.0791, -1.55472358971328),
(17484, '39574', 218, 30, 61679, 30.5967, 0.534013155244949, -89.1278, -1.555573565059),
(17485, '39576', 218, 30, 12704, 30.2896, 0.528653249112074, -89.381, -1.55999273872505),
(17486, '39577', 218, 30, 6808, 30.8583, 0.538578936568166, -89.1369, -1.55573239002093),
(17487, '39581', 218, 30, 61235, 30.4898, 0.532147398274567, -88.5052, -1.54470714513609),
(17488, '39595', 218, 30, 61235, 30.366, 0.529986680660598, -88.5473, -1.54544192875118),
(17489, '39601', 218, 30, 13445, 31.5815, 0.551201157718589, -90.4422, -1.57851417274722),
(17490, '39602', 218, 30, 13445, 31.5905, 0.551358237351269, -90.4718, -1.57903079020581),
(17491, '39603', 218, 30, 13445, 31.5777, 0.551134835207013, -90.4802, -1.57917739786297),
(17492, '39629', 218, 30, 1024, 31.4435, 0.548792603350837, -90.4689, -1.5789801756575),
(17493, '39630', 218, 30, 58821, 31.4625, 0.549124215908716, -90.85, -1.58563162543685),
(17494, '39631', 218, 30, 1472, 31.0901, 0.542624609774289, -91.0689, -1.58945215116946),
(17495, '39632', 218, 30, 58974, 31.1691, 0.544003419883365, -90.4732, -1.57905522481533),
(17496, '39633', 218, 30, 1897, 31.3146, 0.546542873945016, -90.9823, -1.58794069603724),
(17497, '39635', 218, 30, 13762, 31.1851, 0.544282672563684, -90.4487, -1.5786276191486),
(17498, '39638', 218, 30, 21443, 31.2436, 0.5453036901761, -91.0307, -1.5887854353952),
(17499, '39641', 218, 30, 60416, 31.4101, 0.548209663380671, -90.1847, -1.57401994992333),
(17500, '39643', 218, 30, 9895, 31.1753, 0.544111630296988, -89.9862, -1.57055547135812),
(17501, '39645', 218, 30, 3751, 31.1589, 0.543825396299661, -90.8056, -1.58485669924896),
(17502, '39647', 218, 30, 60816, 31.5288, 0.550281369202788, -90.7634, -1.58412017030462),
(17503, '39648', 218, 30, 60821, 31.2413, 0.545263547603304, -90.46, -1.57882484135407),
(17504, '39649', 218, 30, 60821, 31.2432, 0.545296708859092, -90.4527, -1.57869743231867),
(17505, '39652', 218, 30, 3947, 31.1467, 0.543612466130918, -90.4603, -1.57883007734183),
(17506, '39653', 218, 30, 4140, 31.4071, 0.548157303503111, -90.8413, -1.58547978179193),
(17507, '39654', 218, 30, 588, 31.5543, 0.550726428162047, -90.1094, -1.57270571699658),
(17508, '39656', 218, 30, 61134, 31.4403, 0.548736752814773, -89.9999, -1.57079458146564),
(17509, '39657', 218, 30, 61194, 31.0268, 0.541519816357777, -90.4785, -1.57914772726569),
(17510, '39661', 218, 30, 61621, 31.5001, 0.549780459707466, -91.0705, -1.5894800764375),
(17511, '39662', 218, 30, 5588, 31.3812, 0.547705263226845, -90.294, -1.57592759479576),
(17512, '39663', 218, 30, 24872, 31.5839, 0.551243045620637, -90.0313, -1.57134261485077),
(17513, '39664', 218, 30, 5913, 31.3682, 0.547478370424085, -90.6702, -1.58249352344176),
(17514, '39665', 218, 30, 61827, 31.6509, 0.552412416219473, -90.1813, -1.57396060872876),
(17515, '39666', 218, 30, 6151, 31.2979, 0.546251403959933, -90.476, -1.57910409403439),
(17516, '39667', 218, 30, 62107, 31.1173, 0.543099339330832, -90.1457, -1.57333927151505),
(17517, '39668', 218, 30, 6459, 31.7089, 0.55342470718563, -90.8274, -1.5852371810259),
(17518, '39669', 218, 30, 6954, 31.1786, 0.544169226162304, -91.3552, -1.59444902881792),
(17519, '39701', 218, 30, 1718, 33.5149, 0.584945353476648, -88.4218, -1.54325154053992),
(17520, '39702', 218, 30, 1718, 33.4388, 0.58361715791588, -88.348, -1.54196348755195),
(17521, '39703', 218, 30, 1718, 33.5161, 0.584966297427671, -88.4826, -1.54431270072513),
(17522, '39704', 218, 30, 1718, 33.517, 0.584982005390939, -88.4821, -1.54430397407887),
(17523, '39705', 218, 30, 1718, 33.5055, 0.58478129252696, -88.4042, -1.54294436259157),
(17524, '39710', 218, 30, 1718, 33.637, 0.587076400493333, -88.4559, -1.54384669781485),
(17525, '39730', 218, 30, 7017, 33.827, 0.590392526072122, -88.555, -1.54557631910358),
(17526, '39735', 218, 30, 58408, 33.3101, 0.581370919168563, -89.1727, -1.55635721789315),
(17527, '39736', 218, 30, 58490, 33.4112, 0.583135447042329, -88.6446, -1.54714013411337),
(17528, '39737', 218, 30, 251, 33.6119, 0.586638322851082, -89.3667, -1.55974315664202),
(17529, '39739', 218, 30, 1170, 33.2331, 0.580027015644528, -88.5806, -1.54602312339209),
(17530, '39740', 218, 30, 1296, 33.6867, 0.587943829131574, -88.3301, -1.54165107361584),
(17531, '39741', 218, 30, 0, 33.6133, 0.58666275746061, -88.8469, -1.55067093519015),
(17532, '39743', 218, 30, 1860, 33.3415, 0.581918952553689, -88.5161, -1.54489738602455),
(17533, '39744', 218, 30, 59848, 33.541, 0.585400884411418, -89.2746, -1.55813570840093),
(17534, '39745', 218, 30, 59979, 33.2892, 0.581006145354896, -89.3998, -1.56032086062443),
(17535, '39746', 218, 30, 2950, 33.8004, 0.589928268491091, -88.4306, -1.5434051295141),
(17536, '39747', 218, 30, 60484, 33.4421, 0.583674753781196, -89.5697, -1.56328617502356),
(17537, '39750', 218, 30, 60730, 33.5585, 0.585706317030517, -89.0818, -1.55477071360308),
(17538, '39751', 218, 30, 60763, 33.6712, 0.587673303097515, -89.1328, -1.5556608315216),
(17539, '39752', 218, 30, 60798, 33.5412, 0.585404375069922, -89.1359, -1.55571493672841),
(17540, '39753', 218, 30, 701, 33.4497, 0.583807398804347, -88.4807, -1.54427953946935),
(17541, '39754', 218, 30, 23162, 33.718, 0.588490117187448, -88.9476, -1.55242848174691),
(17542, '39755', 218, 30, 61293, 33.594, 0.586325908914975, -88.9548, -1.55255414545305),
(17543, '39756', 218, 30, 5210, 33.8055, 0.590017280282943, -88.6349, -1.54697083717592),
(17544, '39759', 218, 30, 61874, 33.4569, 0.583933062510491, -88.8207, -1.55021365892613),
(17545, '39760', 218, 30, 61874, 33.4502, 0.583816125450607, -88.8184, -1.55017351635333),
(17546, '39762', 218, 30, 0, 33.4567, 0.583929571851987, -88.7837, -1.54956788710289),
(17547, '39766', 218, 30, 61878, 33.5757, 0.58600651366186, -88.3527, -1.54204551802679),
(17548, '39767', 218, 30, 6081, 33.5309, 0.585224606156967, -89.4972, -1.56202081131587),
(17549, '39769', 218, 30, 38425, 33.3683, 0.582386700793224, -89.0519, -1.55424886015674),
(17550, '39771', 218, 30, 62211, 33.6114, 0.586629596204822, -89.3672, -1.55975188328828),
(17551, '39772', 218, 30, 28929, 33.2519, 0.580355137543902, -89.2715, -1.55808160319412),
(17552, '39773', 218, 30, 6722, 33.6565, 0.587416739697472, -88.7555, -1.54907570425383),
(17553, '39776', 218, 30, 6917, 33.7959, 0.589849728674752, -89.0555, -1.55431169200981),
(17554, '39813', 218, 13, 15026, 31.4421, 0.548768168741309, -84.7243, -1.47871799144743),
(17555, '39815', 218, 13, 18957, 30.8189, 0.53789127684288, -84.5188, -1.47513133983458),
(17556, '39817', 218, 13, 19017, 30.9036, 0.53936957071932, -84.5694, -1.47601447643609),
(17557, '39818', 218, 13, 19017, 30.9062, 0.539414949279871, -84.5774, -1.47615410277625),
(17558, '39819', 218, 13, 19017, 30.9042, 0.539380042694832, -84.5689, -1.47600574978983),
(17559, '39823', 218, 13, 7524, 31.3767, 0.547626723410505, -84.9345, -1.48238667353512),
(17560, '39824', 218, 13, 1018, 31.5522, 0.550689776247755, -84.9019, -1.48181769619897),
(17561, '39825', 218, 13, 19502, 30.9453, 0.540097373017401, -84.6783, -1.47791513999151),
(17562, '39826', 218, 13, 19526, 31.8288, 0.555517356958771, -84.3626, -1.47240513554297),
(17563, '39827', 218, 13, 1288, 30.8763, 0.538893095833525, -84.209, -1.46972430981191),
(17564, '39828', 218, 13, 1288, 30.8766, 0.538898331821281, -84.2091, -1.46972605514116),
(17565, '39829', 218, 13, 1299, 30.7482, 0.53665732906172, -84.3116, -1.47151501762445),
(17566, '39832', 218, 13, 1429, 31.186, 0.544298380526952, -85.0038, -1.48359618670676),
(17567, '39834', 218, 13, 20102, 30.8757, 0.538882623858013, -84.4453, -1.47384852283437),
(17568, '39836', 218, 13, 1693, 31.6556, 0.552494446694317, -84.8788, -1.48141452514176),
(17569, '39837', 218, 13, 20190, 31.1725, 0.544062761077932, -84.7308, -1.47883143784881),
(17570, '39840', 218, 13, 20430, 31.7699, 0.554489358029347, -84.7938, -1.47993099527757),
(17571, '39841', 218, 13, 1957, 31.3467, 0.547103124634907, -84.7309, -1.47883318317806),
(17572, '39842', 218, 13, 1989, 31.7674, 0.554445724798047, -84.4321, -1.4736181393731),
(17573, '39845', 218, 13, 20624, 31.0396, 0.541743218502032, -84.8793, -1.48142325178802),
(17574, '39846', 218, 13, 15893, 31.5602, 0.550829402587914, -84.7404, -1.478998989457),
(17575, '39851', 218, 13, 2557, 31.6051, 0.55161305542206, -85.0459, -1.48433097032185),
(17576, '39852', 218, 13, 21262, 30.8767, 0.538900077150533, -84.585, -1.4762867477994),
(17577, '39854', 218, 13, 2693, 31.8653, 0.556154402135749, -85.1029, -1.48532580799548),
(17578, '39859', 218, 13, 3362, 30.9818, 0.540734418194379, -84.7866, -1.47980533157142),
(17579, '39861', 218, 13, 22216, 31.1863, 0.544303616514708, -85.0034, -1.48358920538975),
(17580, '39862', 218, 13, 22603, 31.5229, 0.550178394776921, -84.5055, -1.47489921104407),
(17581, '39866', 218, 13, 4319, 31.5341, 0.550373871653144, -84.6264, -1.47700931410973),
(17582, '39867', 218, 13, 4333, 31.8157, 0.55528871882676, -85.0373, -1.48418087200617),
(17583, '39870', 218, 13, 4570, 31.3217, 0.546666792321908, -84.4563, -1.47404050905209),
(17584, '39877', 218, 13, 23776, 31.894, 0.556655311631071, -84.5064, -1.47491491900734),
(17585, '39885', 218, 13, 24683, 31.7155, 0.553539898916262, -84.3483, -1.47215555345993),
(17586, '39886', 218, 13, 24805, 31.761, 0.554334023725919, -84.6092, -1.47670911747839),
(17587, '39897', 218, 13, 25991, 30.9387, 0.53998218128677, -84.3171, -1.47161101073331),
(17588, '39901', 218, 13, 7187, 33.8872, 0.591443214281822, -84.2904, -1.47114500782303),
(17589, '40003', 218, 21, 15071, 38.2868, 0.668230720052565, -84.9739, -1.48307433326041),
(17590, '40004', 218, 21, 7261, 37.8109, 0.659924698142324, -85.4648, -1.49164215455845),
(17591, '40006', 218, 21, 146, 38.5824, 0.67338991332146, -85.3162, -1.48904859528999),
(17592, '40007', 218, 21, 548, 38.4036, 0.670269264618894, -85.0628, -1.48462593096543),
(17593, '40008', 218, 21, 7544, 37.9073, 0.661607195541246, -85.2904, -1.48859830034297),
(17594, '40009', 218, 21, 34953, 37.4226, 0.65314758465683, -85.1637, -1.48638696818069),
(17595, '40010', 218, 21, 7751, 38.386, 0.669962086670543, -85.4484, -1.49135592056112),
(17596, '40011', 218, 21, 29380, 38.4859, 0.671705670593286, -85.1151, -1.48553873816423),
(17597, '40012', 218, 21, 518, 37.9006, 0.661490258481363, -85.2073, -1.48714793173456),
(17598, '40013', 218, 21, 35404, 37.9171, 0.661778237807942, -85.5006, -1.49226698243066),
(17599, '40014', 218, 21, 13069, 38.3365, 0.669098148690806, -85.4418, -1.49124072883049),
(17600, '40018', 218, 21, 2198, 38.2736, 0.668000336591302, -85.4114, -1.49071014873788),
(17601, '40019', 218, 21, 8755, 38.3763, 0.6697927897331, -85.1802, -1.48667494750727),
(17602, '40020', 218, 21, 2367, 37.9309, 0.662019093244717, -85.3777, -1.49012197277996),
(17603, '40022', 218, 21, 35893, 38.1529, 0.665893724184145, -85.3008, -1.48877981458518),
(17604, '40023', 218, 21, 29797, 38.1878, 0.666502844093091, -85.4417, -1.49123898350124),
(17605, '40025', 218, 21, 2747, 38.3104, 0.668642617756036, -85.6481, -1.49484134307736),
(17606, '40026', 218, 21, 419, 38.4159, 0.67048394011689, -85.5637, -1.49336828518867),
(17607, '40027', 218, 21, 36312, 38.3201, 0.668811914693479, -85.6307, -1.49453765578751),
(17608, '40031', 218, 21, 3584, 38.4059, 0.67030940719169, -85.3885, -1.49031046833918),
(17609, '40032', 218, 21, 3584, 38.4228, 0.670604367835277, -85.3942, -1.49040995210654),
(17610, '40033', 218, 21, 3708, 37.5712, 0.655741143925293, -85.2532, -1.48794903786123),
(17611, '40036', 218, 21, 36937, 38.417, 0.670503138738662, -84.9619, -1.48286489375017),
(17612, '40037', 218, 21, 3869, 37.6897, 0.657809359088907, -85.4563, -1.49149380157203),
(17613, '40040', 218, 21, 27774, 37.7241, 0.658409752351593, -85.0877, -1.48506051794918),
(17614, '40041', 218, 21, 0, 38.2533, 0.667646034753147, -85.6627, -1.49509616114815),
(17615, '40045', 218, 21, 4232, 38.6697, 0.674913585758451, -85.3562, -1.48974672699078),
(17616, '40046', 218, 21, 37290, 38.0195, 0.663565454961984, -85.1377, -1.48593318257518),
(17617, '40047', 218, 21, 37311, 38.0437, 0.663987824640967, -85.5572, -1.49325483878729),
(17618, '40048', 218, 21, 37361, 37.8479, 0.660570469965562, -85.4726, -1.49177829024011),
(17619, '40049', 218, 21, 37383, 37.6646, 0.657371281446656, -85.3989, -1.49049198258139),
(17620, '40050', 218, 21, 4520, 38.4349, 0.670815552674769, -85.1708, -1.48651088655759),
(17621, '40051', 218, 21, 4528, 37.6706, 0.657476001201776, -85.5459, -1.49305761658182),
(17622, '40052', 218, 21, 254, 37.6118, 0.656449747601603, -85.5141, -1.49250260187968),
(17623, '40055', 218, 21, 11133, 38.4959, 0.671880203518485, -85.34, -1.48946398365196),
(17624, '40056', 218, 21, 37659, 38.3048, 0.668544879317924, -85.4851, -1.4919964563966),
(17625, '40057', 218, 21, 37729, 38.37, 0.669682833990224, -85.0625, -1.48462069497768),
(17626, '40058', 218, 21, 5184, 38.5556, 0.672922165081926, -85.0799, -1.48492438226752),
(17627, '40059', 218, 21, 5238, 38.3376, 0.669117347312578, -85.612, -1.49421127921739),
(17628, '40060', 218, 21, 37873, 37.5302, 0.655025558931976, -85.44, -1.49120931290396),
(17629, '40061', 218, 21, 38060, 37.6944, 0.657891389563751, -85.2635, -1.48812880677419),
(17630, '40062', 218, 21, 11751, 37.6288, 0.656746453574442, -85.4663, -1.49166833449723),
(17631, '40063', 218, 21, 38069, 37.5805, 0.655903459545729, -85.3467, -1.48958092071184),
(17632, '40065', 218, 21, 11899, 38.2078, 0.666851909943489, -85.2304, -1.48755110279178),
(17633, '40066', 218, 21, 11899, 38.212, 0.666925213772073, -85.2232, -1.48742543908563),
(17634, '40067', 218, 21, 38223, 38.2353, 0.667331875487788, -85.3547, -1.489720547052),
(17635, '40068', 218, 21, 5916, 38.3567, 0.669450705199709, -85.3218, -1.4891463337281),
(17636, '40069', 218, 21, 349, 37.6847, 0.657722092626307, -85.2191, -1.4873538805863),
(17637, '40070', 218, 21, 65, 38.4895, 0.671768502446357, -85.2317, -1.48757379207205),
(17638, '40071', 218, 21, 25360, 38.048, 0.664062873798803, -85.3721, -1.49002423434185),
(17639, '40075', 218, 21, 38609, 38.5562, 0.672932637057438, -85.1292, -1.48578482958876),
(17640, '40076', 218, 21, 38714, 38.1513, 0.665865798916113, -85.0624, -1.48461894964842),
(17641, '40077', 218, 21, 25961, 38.4872, 0.671728359873562, -85.4535, -1.49144493235297),
(17642, '40078', 218, 21, 38896, 37.8969, 0.661425681299039, -85.1074, -1.48540434781182),
(17643, '40104', 218, 21, 34697, 38.0681, 0.664413684978453, -86.3229, -1.50661882486981),
(17644, '40107', 218, 21, 1061, 37.7565, 0.658975239029239, -85.6375, -1.49465633817664),
(17645, '40108', 218, 21, 7652, 37.9834, 0.662935391102014, -86.1301, -1.50325383007197),
(17646, '40109', 218, 21, 1162, 38.0571, 0.664221698760734, -85.7337, -1.49633534491706),
(17647, '40110', 218, 21, 13559, 37.9297, 0.661998149293693, -85.6531, -1.49492860953996),
(17648, '40111', 218, 21, 35297, 37.8333, 0.660315651894771, -86.6326, -1.51202410956324),
(17649, '40115', 218, 21, 35479, 37.7504, 0.658868773944867, -86.2505, -1.50535520649137),
(17650, '40117', 218, 21, 35722, 37.9064, 0.661591487577978, -86.1507, -1.50361336789788),
(17651, '40118', 218, 21, 2365, 38.1073, 0.665097854045235, -85.7545, -1.49669837340148),
(17652, '40119', 218, 21, 35847, 37.6208, 0.656606827234283, -86.5346, -1.51031368689629),
(17653, '40121', 218, 21, 0, 37.8894, 0.66129478160514, -85.9542, -1.50018379591771),
(17654, '40129', 218, 21, 3153, 37.2992, 0.650993848359869, -86.2308, -1.50501137662873),
(17655, '40140', 218, 21, 9050, 37.8153, 0.660001492629412, -86.3215, -1.50659439026029),
(17656, '40142', 218, 21, 36230, 37.8929, 0.661355868128959, -86.1638, -1.50384200602989),
(17657, '40143', 218, 21, 29997, 37.7452, 0.658778016823764, -86.4606, -1.50902214324981),
(17658, '40144', 218, 21, 36301, 37.6054, 0.656338046529476, -86.3799, -1.50761366254345),
(17659, '40145', 218, 21, 16505, 37.6053, 0.656336301200224, -86.3186, -1.50654377571198),
(17660, '40146', 218, 21, 3366, 37.8233, 0.660141118969571, -86.2767, -1.50581248275539),
(17661, '40150', 218, 21, 36826, 37.8514, 0.660631556489382, -85.7295, -1.49626204108848),
(17662, '40152', 218, 21, 22958, 37.6262, 0.65670107501389, -86.4482, -1.50880572242256),
(17663, '40153', 218, 21, 37137, 37.7085, 0.658137480988282, -86.5187, -1.51003617954522),
(17664, '40155', 218, 21, 37330, 37.936, 0.662108105036569, -85.992, -1.50084353037496),
(17665, '40157', 218, 21, 264, 38.0238, 0.66364050411982, -86.4024, -1.50800636162515),
(17666, '40159', 218, 21, 37850, 37.8245, 0.660162062920595, -85.9399, -1.49993421383467),
(17667, '40160', 218, 21, 37850, 37.8252, 0.660174280225359, -85.9414, -1.49996039377345),
(17668, '40161', 218, 21, 37909, 37.9663, 0.662636939799923, -86.3161, -1.50650014248068),
(17669, '40162', 218, 21, 37933, 37.7519, 0.658894953883647, -86.0036, -1.5010459885682),
(17670, '40164', 218, 21, 38137, 37.6694, 0.657455057250752, -86.3869, -1.50773583559109),
(17671, '40165', 218, 21, 38185, 38.0106, 0.663410120658557, -85.6964, -1.49568433710607),
(17672, '40170', 218, 21, 38377, 37.8983, 0.661450115908567, -86.537, -1.51035557479833),
(17673, '40171', 218, 21, 38633, 37.9721, 0.662738168896539, -86.4644, -1.50908846576139),
(17674, '40175', 218, 21, 38696, 37.814, 0.659978803349136, -85.9879, -1.50077197187563),
(17675, '40176', 218, 21, 18520, 37.9274, 0.661958006720897, -86.396, -1.50789466055302),
(17676, '40177', 218, 21, 6722, 37.9958, 0.663151811929262, -85.9527, -1.50015761597893),
(17677, '40178', 218, 21, 14839, 37.631, 0.656784850817986, -86.3963, -1.50789989654078),
(17678, '40201', 218, 21, 3876, 38.2442, 0.667487209791215, -85.774, -1.49703871260562),
(17679, '40202', 218, 21, 3876, 38.2525, 0.667632072119131, -85.7516, -1.49664775885317),
(17680, '40203', 218, 21, 3876, 38.2482, 0.667557022961295, -85.7639, -1.49686243435116),
(17681, '40204', 218, 21, 3876, 38.2382, 0.667382490036096, -85.7264, -1.49620793588167),
(17682, '40205', 218, 21, 3876, 38.2214, 0.667089274721761, -85.6841, -1.49546966160807),
(17683, '40206', 218, 21, 3876, 38.2554, 0.667682686667439, -85.7005, -1.4957558956054),
(17684, '40207', 218, 21, 3876, 38.2605, 0.66777169845929, -85.6533, -1.49493210019846),
(17685, '40208', 218, 21, 3876, 38.2186, 0.667040405502705, -85.7666, -1.49690955824097),
(17686, '40209', 218, 21, 3876, 38.19, 0.666541241336634, -85.7531, -1.49667393879195),
(17687, '40210', 218, 21, 3876, 38.2326, 0.667284751597984, -85.7878, -1.49727956804239),
(17688, '40211', 218, 21, 3876, 38.2401, 0.667415651291884, -85.8119, -1.49770019239212),
(17689, '40212', 218, 21, 3876, 38.2642, 0.667836275641614, -85.8025, -1.49753613144243),
(17690, '40213', 218, 21, 3876, 38.1851, 0.666455720203287, -85.7144, -1.49599849637143),
(17691, '40214', 218, 21, 3876, 38.1568, 0.665961792024972, -85.7847, -1.49722546283558),
(17692, '40215', 218, 21, 3876, 38.1902, 0.666544731995138, -85.7862, -1.49725164277436),
(17693, '40216', 218, 21, 3876, 38.1857, 0.666466192178799, -85.8332, -1.4980719475228),
(17694, '40217', 218, 21, 3876, 38.216, 0.666995026942153, -85.7408, -1.49645926329395),
(17695, '40218', 218, 21, 3876, 38.1924, 0.666583129238682, -85.6555, -1.494970497442),
(17696, '40219', 218, 21, 3876, 38.1403, 0.665673812698393, -85.6812, -1.49541904705977),
(17697, '40220', 218, 21, 3876, 38.2143, 0.666965356344869, -85.6205, -1.49435963220381),
(17698, '40221', 218, 21, 3876, 38.1875, 0.666497608105335, -85.7513, -1.49664252286541),
(17699, '40222', 218, 21, 3876, 38.2735, 0.66799859126205, -85.6054, -1.49409608748675),
(17700, '40223', 218, 21, 3876, 38.2584, 0.667735046544999, -85.5439, -1.49302270999678),
(17701, '40224', 218, 21, 3876, 38.2285, 0.667213193098652, -85.5748, -1.49356201673564),
(17702, '40225', 218, 21, 3876, 38.1901, 0.666542986665887, -85.6528, -1.4949233735522),
(17703, '40228', 218, 21, 3876, 38.1399, 0.665666831381385, -85.6292, -1.49451147584873),
(17704, '40229', 218, 21, 3876, 38.1024, 0.665012332911887, -85.6667, -1.49516597431823),
(17705, '40231', 218, 21, 3876, 38.1775, 0.666323075180135, -85.7219, -1.49612939606533),
(17706, '40232', 218, 21, 3876, 38.1776, 0.666324820509387, -85.721, -1.49611368810206),
(17707, '40233', 218, 21, 3876, 38.2709, 0.667953212701498, -85.5295, -1.49277138258449),
(17708, '40241', 218, 21, 3876, 38.3028, 0.668509972732884, -85.5839, -1.49372084169757),
(17709, '40242', 218, 21, 3876, 38.28, 0.668112037663429, -85.5913, -1.49384999606222),
(17710, '40243', 218, 21, 3876, 38.24, 0.667413905962632, -85.5386, -1.49293020754642),
(17711, '40245', 218, 21, 3876, 38.2653, 0.667855474263386, -85.4924, -1.492123865432),
(17712, '40250', 218, 21, 3876, 38.2167, 0.667007244246917, -85.624, -1.49442071872762),
(17713, '40251', 218, 21, 3876, 38.2499, 0.667586693558579, -85.7973, -1.49744537432133),
(17714, '40252', 218, 21, 3876, 38.2628, 0.667811841032086, -85.605, -1.49408910616975),
(17715, '40253', 218, 21, 3876, 38.2436, 0.667476737815703, -85.5293, -1.49276789192599),
(17716, '40255', 218, 21, 3876, 38.2251, 0.667153851904084, -85.6841, -1.49546966160807),
(17717, '40256', 218, 21, 3876, 38.1925, 0.666584874567934, -85.807, -1.49761467125877),
(17718, '40257', 218, 21, 3876, 38.2503, 0.667593674875587, -85.6281, -1.49449227722696),
(17719, '40258', 218, 21, 3876, 38.1432, 0.665724427246701, -85.8613, -1.49856238504261),
(17720, '40259', 218, 21, 3876, 38.2539, 0.667656506728659, -85.759, -1.49677691321782),
(17721, '40261', 218, 21, 3876, 38.1945, 0.666619781152974, -85.6517, -1.49490417493043),
(17722, '40266', 218, 21, 3876, 38.2251, 0.667153851904084, -85.7414, -1.49646973526947),
(17723, '40268', 218, 21, 3876, 38.1451, 0.665757588502489, -85.8665, -1.49865314216371),
(17724, '40269', 218, 21, 3876, 38.1637, 0.66608221974336, -85.5148, -1.49251481918445),
(17725, '40270', 218, 21, 3876, 38.2534, 0.667647780082399, -85.7579, -1.49675771459605),
(17726, '40272', 218, 21, 3876, 38.0888, 0.664774968133616, -85.8474, -1.49831978427658),
(17727, '40280', 218, 21, 3876, 38.2465, 0.667527352364011, -85.6855, -1.4954940962176),
(17728, '40281', 218, 21, 3876, 38.1447, 0.665750607185481, -85.8674, -1.49866885012698),
(17729, '40282', 218, 21, 3876, 38.1343, 0.665569092943274, -84.8951, -1.48169901380984),
(17730, '40283', 218, 21, 3876, 38.134, 0.665563856955518, -85.8955, -1.49915928764679),
(17731, '40285', 218, 21, 3876, 38.1764, 0.666303876558363, -85.721, -1.49611368810206),
(17732, '40287', 218, 21, 3876, 38.2245, 0.667143379928573, -85.6844, -1.49547489759583),
(17733, '40289', 218, 21, 3876, 38.2568, 0.667707121276967, -85.758, -1.4967594599253),
(17734, '40290', 218, 21, 3876, 38.1975, 0.666672141030534, -85.696, -1.49567735578906),
(17735, '40291', 218, 21, 3876, 38.1533, 0.665900705501153, -85.595, -1.49391457324455),
(17736, '40292', 218, 21, 3876, 38.2324, 0.66728126093948, -85.672, -1.49525847676858),
(17737, '40293', 218, 21, 3876, 38.2571, 0.667712357264723, -85.7579, -1.49675771459605),
(17738, '40294', 218, 21, 3876, 38.2573, 0.667715847923227, -85.7579, -1.49675771459605),
(17739, '40295', 218, 21, 3876, 38.2476, 0.667546550985783, -85.7575, -1.49675073327904),
(17740, '40296', 218, 21, 3876, 38.2543, 0.667663488045667, -85.7585, -1.49676818657156),
(17741, '40297', 218, 21, 3876, 38.2547, 0.667670469362675, -85.7586, -1.49676993190081),
(17742, '40298', 218, 21, 3876, 38.2565, 0.667701885289211, -85.7531, -1.49667393879195),
(17743, '40299', 218, 21, 3876, 38.1888, 0.666520297385611, -85.5581, -1.49327054675056),
(17744, '40310', 218, 21, 35063, 37.7548, 0.658945568431955, -84.7678, -1.47947720967205),
(17745, '40311', 218, 21, 1358, 38.3383, 0.669129564617342, -84.0252, -1.46651639464674),
(17746, '40312', 218, 21, 1602, 37.8664, 0.660893355877181, -83.9277, -1.46481469862604),
(17747, '40313', 218, 21, 13564, 38.1413, 0.665691265990913, -83.5409, -1.45806376507933),
(17748, '40316', 218, 21, 35564, 37.9214, 0.661853286965778, -83.5083, -1.45749478774318),
(17749, '40317', 218, 21, 35746, 38.1825, 0.666410341642735, -83.2763, -1.45344562387855),
(17750, '40319', 218, 21, 876, 38.1428, 0.665717445929693, -83.5456, -1.45814579555417),
(17751, '40320', 218, 21, 32456, 37.8982, 0.661448370579315, -84.2661, -1.47072089281479),
(17752, '40322', 218, 21, 161, 37.9565, 0.662465897533228, -83.6193, -1.45943210321289),
(17753, '40324', 218, 21, 2693, 38.2211, 0.667084038734005, -84.563, -1.47590277536396),
(17754, '40328', 218, 21, 36170, 37.57, 0.65572019997427, -85.0864, -1.4850378286689),
(17755, '40329', 218, 21, 36244, 38.2523, 0.667628581460627, -83.3183, -1.45417866216439),
(17756, '40330', 218, 21, 30025, 37.7759, 0.659313832904126, -84.8507, -1.48092408762195),
(17757, '40334', 218, 21, 665, 37.9162, 0.661762529844674, -83.8586, -1.46360867611292),
(17758, '40336', 218, 21, 16560, 37.6925, 0.657858228307963, -83.967, -1.46550061302208),
(17759, '40337', 218, 21, 9742, 37.951, 0.662369904424368, -83.8618, -1.46366452664898),
(17760, '40339', 218, 21, 16697, 37.9359, 0.662106359707317, -84.6567, -1.47753814887308),
(17761, '40340', 218, 21, 23374, 37.8782, 0.661099304728916, -84.5805, -1.47620820798306),
(17762, '40342', 218, 21, 30308, 38.0127, 0.663446772572849, -84.9506, -1.48266767154469),
(17763, '40346', 218, 21, 37152, 37.9148, 0.661738095235146, -83.7129, -1.46106573139276),
(17764, '40347', 218, 21, 41, 38.1433, 0.665726172575953, -84.6931, -1.47817344872081),
(17765, '40348', 218, 21, 30514, 38.3008, 0.668475066147844, -84.1404, -1.46852701394504),
(17766, '40350', 218, 21, 4307, 38.3019, 0.668494264769616, -83.8702, -1.46381113430615),
(17767, '40351', 218, 21, 33337, 38.1932, 0.666597091872698, -83.4404, -1.45630970918108),
(17768, '40353', 218, 21, 4408, 38.0588, 0.664251369358018, -83.9357, -1.4649543249662),
(17769, '40355', 218, 21, 4546, 38.6234, 0.674105498314778, -84.8925, -1.48165363524929),
(17770, '40356', 218, 21, 23374, 37.8842, 0.661204024484036, -84.5654, -1.47594466326601),
(17771, '40357', 218, 21, 37453, 38.1446, 0.665748861856229, -84.1089, -1.46797723523066),
(17772, '40358', 218, 21, 37528, 38.0531, 0.664151885590654, -83.7578, -1.46184938422691),
(17773, '40359', 218, 21, 4824, 38.5274, 0.672429982232863, -84.8237, -1.48045284872391),
(17774, '40360', 218, 21, 37564, 38.1426, 0.665713955271189, -83.7694, -1.46205184242014),
(17775, '40361', 218, 21, 11069, 38.2044, 0.666792568748922, -84.239, -1.4702479085875),
(17776, '40362', 218, 21, 11069, 38.2073, 0.666843183297229, -84.2611, -1.47063362635219),
(17777, '40363', 218, 21, 37647, 38.5481, 0.672791265388026, -84.9997, -1.48352462820742),
(17778, '40366', 218, 21, 5220, 38.0851, 0.664710390951292, -83.7575, -1.46184414823915),
(17779, '40370', 218, 21, 38059, 38.3858, 0.669958596012039, -84.5341, -1.47539837521014),
(17780, '40371', 218, 21, 38081, 38.0844, 0.664698173646529, -83.6194, -1.45943384854215),
(17781, '40372', 218, 21, 38083, 37.9128, 0.661703188650106, -84.8755, -1.48135692927645),
(17782, '40374', 218, 21, 24795, 38.2148, 0.666974082991129, -83.876, -1.46391236340276),
(17783, '40376', 218, 21, 18101, 37.7744, 0.659287652965346, -83.6885, -1.46063987105527),
(17784, '40379', 218, 21, 38356, 38.297, 0.668408743636268, -84.6751, -1.47785928945545),
(17785, '40380', 218, 21, 6052, 37.8506, 0.660617593855366, -83.8567, -1.46357551485713),
(17786, '40383', 218, 21, 28861, 38.0478, 0.664059383140299, -84.7167, -1.47858534642428),
(17787, '40384', 218, 21, 28861, 38.0524, 0.66413966828589, -84.7272, -1.47876860599574),
(17788, '40385', 218, 21, 6587, 37.7495, 0.658853065981599, -84.1298, -1.46834200904433),
(17789, '40386', 218, 21, 28861, 38.0544, 0.66417457487093, -84.729, -1.47880002192228),
(17790, '40387', 218, 21, 902, 37.981, 0.662893503199966, -83.473, -1.45687868651723),
(17791, '40390', 218, 21, 34438, 37.8638, 0.660847977316629, -84.6484, -1.47739328654517),
(17792, '40391', 218, 21, 12894, 37.981, 0.662893503199966, -84.1671, -1.46899301685532),
(17793, '40392', 218, 21, 12894, 37.99, 0.663050582832646, -84.1802, -1.46922165498733),
(17794, '40402', 218, 21, 34568, 37.3062, 0.651116021407508, -84.0065, -1.46619001807662),
(17795, '40403', 218, 21, 7416, 37.5843, 0.655969782057305, -84.2763, -1.4708989163985),
(17796, '40404', 218, 21, 7416, 37.5692, 0.655706237340254, -84.2926, -1.47118340506657),
(17797, '40405', 218, 21, 34820, 37.555, 0.65545840058647, -84.2092, -1.46972780047041),
(17798, '40409', 218, 21, 35001, 37.3678, 0.652191144226737, -84.439, -1.47373856709149),
(17799, '40410', 218, 21, 29332, 37.7139, 0.658231728767889, -84.6491, -1.47740550384993),
(17800, '40419', 218, 21, 26876, 37.443, 0.653503631824237, -84.518, -1.47511737720057),
(17801, '40421', 218, 21, 35487, 37.4438, 0.653517594458253, -84.0337, -1.46666474763316),
(17802, '40422', 218, 21, 1964, 37.6414, 0.656966365060194, -84.783, -1.47974249971835),
(17803, '40423', 218, 21, 1964, 37.6427, 0.65698905434047, -84.7715, -1.47954178685437),
(17804, '40434', 218, 21, 36172, 37.4022, 0.652791537489423, -83.9001, -1.46433298775249),
(17805, '40437', 218, 21, 36540, 37.4377, 0.653411129373881, -84.7878, -1.47982627552245),
(17806, '40440', 218, 21, 9806, 37.5808, 0.655908695533485, -84.819, -1.48037081824907),
(17807, '40442', 218, 21, 22385, 37.3646, 0.652135293690673, -84.7008, -1.47830783907321),
(17808, '40444', 218, 21, 16841, 37.6598, 0.65728750564256, -84.5932, -1.47642986479807),
(17809, '40445', 218, 21, 3825, 37.3021, 0.651044462908177, -84.235, -1.47017809541742),
(17810, '40446', 218, 21, 16841, 37.6183, 0.656563194002983, -84.58, -1.4761994813368),
(17811, '40447', 218, 21, 22981, 37.4469, 0.653571699665065, -84.0129, -1.46630171914874),
(17812, '40448', 218, 21, 10412, 37.4525, 0.653669438103176, -84.7594, -1.47933060201488),
(17813, '40452', 218, 21, 37234, 37.5986, 0.65621936414034, -84.9633, -1.4828893283597),
(17814, '40456', 218, 21, 4411, 37.3566, 0.651995667350514, -84.3438, -1.47207701364359),
(17815, '40460', 218, 21, 10999, 37.3882, 0.652547191394144, -84.2209, -1.46993200399289),
(17816, '40461', 218, 21, 37572, 37.5835, 0.655955819423289, -84.4336, -1.47364431931188),
(17817, '40464', 218, 21, 23766, 37.5872, 0.656020396605613, -84.9222, -1.48217199803713),
(17818, '40467', 218, 21, 37639, 37.2897, 0.65082804208093, -84.0538, -1.46701555881281),
(17819, '40468', 218, 21, 4963, 37.649, 0.657099010083345, -84.9678, -1.48296786817604),
(17820, '40472', 218, 21, 37869, 37.6917, 0.657844265673947, -83.9322, -1.46489323844238),
(17821, '40473', 218, 21, 37896, 37.3872, 0.652529738101624, -84.3312, -1.47185710215784),
(17822, '40475', 218, 21, 5381, 37.7625, 0.659079958784359, -84.3018, -1.47134397535776),
(17823, '40476', 218, 21, 5381, 37.7475, 0.65881815939656, -84.2945, -1.47121656632236),
(17824, '40481', 218, 21, 38099, 37.4849, 0.654234924780822, -84.0456, -1.46687244181415),
(17825, '40484', 218, 21, 12107, 37.5157, 0.654772486190437, -84.6784, -1.47791688532077),
(17826, '40486', 218, 21, 25629, 37.3756, 0.652327279908393, -83.875, -1.46389491011024),
(17827, '40488', 218, 21, 38745, 37.4746, 0.654055155867867, -84.0409, -1.4667904113393),
(17828, '40489', 218, 21, 484, 37.3662, 0.652163218958705, -84.6327, -1.47711926985261),
(17829, '40492', 218, 21, 38882, 37.4183, 0.653072535498994, -84.3, -1.47131255943122),
(17830, '40495', 218, 21, 18654, 37.7063, 0.658099083744738, -84.0785, -1.46744665513805),
(17831, '40502', 218, 21, 3748, 38.0001, 0.663226861087097, -84.4784, -1.47442622681678),
(17832, '40503', 218, 21, 3748, 37.9993, 0.663212898453081, -84.5312, -1.47534776066183),
(17833, '40504', 218, 21, 3748, 38.0404, 0.663930228775651, -84.5403, -1.47550658562376);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(17834, '40505', 218, 21, 3748, 38.0609, 0.66428802127231, -84.4534, -1.47398989450378),
(17835, '40506', 218, 21, 3748, 38.032, 0.663783621118483, -84.5066, -1.47491840966584),
(17836, '40507', 218, 21, 3748, 38.0462, 0.664031457872267, -84.4943, -1.47470373416784),
(17837, '40508', 218, 21, 3748, 38.0549, 0.66418330151719, -84.5036, -1.47486604978828),
(17838, '40509', 218, 21, 3748, 38.0031, 0.663279220964657, -84.4157, -1.47333190537578),
(17839, '40510', 218, 21, 3748, 38.0599, 0.66427056797979, -84.6028, -1.47659741640626),
(17840, '40511', 218, 21, 3748, 38.0983, 0.664940774412556, -84.4934, -1.47468802620458),
(17841, '40512', 218, 21, 3748, 38.1386, 0.665644142101109, -84.4701, -1.47428136448886),
(17842, '40513', 218, 21, 3748, 38.0124, 0.663441536585093, -84.5943, -1.47644906341984),
(17843, '40514', 218, 21, 3748, 37.9852, 0.66296680702855, -84.5691, -1.47600924044834),
(17844, '40515', 218, 21, 3748, 37.9632, 0.662582834593111, -84.4644, -1.4741818807215),
(17845, '40516', 218, 21, 3748, 38.0604, 0.66427929462605, -84.3797, -1.47270358684506),
(17846, '40517', 218, 21, 3748, 37.9831, 0.662930155114258, -84.4875, -1.47458505177871),
(17847, '40522', 218, 21, 3748, 38.0192, 0.663560218974228, -84.4882, -1.47459726908347),
(17848, '40523', 218, 21, 3748, 37.9861, 0.662982514991818, -84.5161, -1.47508421594478),
(17849, '40524', 218, 21, 3748, 37.992, 0.663085489417686, -84.5354, -1.47542106449041),
(17850, '40526', 218, 21, 3748, 38.0392, 0.663909284824627, -84.5077, -1.47493760828761),
(17851, '40533', 218, 21, 3748, 38.0425, 0.663966880689943, -84.5428, -1.47555021885506),
(17852, '40536', 218, 21, 3748, 38.0317, 0.663778385130727, -84.5089, -1.47495855223864),
(17853, '40544', 218, 21, 3748, 38.0421, 0.663959899372935, -84.5432, -1.47555720017207),
(17854, '40546', 218, 21, 3748, 38.0395, 0.663914520812383, -84.5076, -1.47493586295836),
(17855, '40550', 218, 21, 3748, 38.1379, 0.665631924796345, -84.4702, -1.47428310981811),
(17856, '40555', 218, 21, 3748, 37.9836, 0.662938881760518, -84.4256, -1.47350469297172),
(17857, '40574', 218, 21, 3748, 38.1367, 0.665610980845321, -84.4735, -1.47434070568343),
(17858, '40575', 218, 21, 3748, 38.137, 0.665616216833077, -84.4737, -1.47434419634193),
(17859, '40576', 218, 21, 3748, 38.1367, 0.665610980845321, -84.4729, -1.47433023370792),
(17860, '40577', 218, 21, 3748, 38.0708, 0.664460808868257, -84.5054, -1.47489746571482),
(17861, '40578', 218, 21, 3748, 38.078, 0.664586472574401, -84.5042, -1.47487652176379),
(17862, '40579', 218, 21, 3748, 38.1379, 0.665631924796345, -84.4701, -1.47428136448886),
(17863, '40580', 218, 21, 3748, 38.1367, 0.665610980845321, -84.4732, -1.47433546969567),
(17864, '40581', 218, 21, 3748, 38.1364, 0.665605744857566, -84.4736, -1.47434245101268),
(17865, '40582', 218, 21, 3748, 38.1363, 0.665603999528314, -84.4729, -1.47433023370792),
(17866, '40583', 218, 21, 3748, 38.1367, 0.665610980845321, -84.4735, -1.47434070568343),
(17867, '40584', 218, 21, 3748, 38.0462, 0.664031457872267, -84.4965, -1.47474213141139),
(17868, '40585', 218, 21, 3748, 38.0463, 0.664033203201519, -84.4953, -1.47472118746036),
(17869, '40586', 218, 21, 3748, 38.0465, 0.664036693860023, -84.4956, -1.47472642344812),
(17870, '40587', 218, 21, 3748, 38.0468, 0.664041929847779, -84.4959, -1.47473165943588),
(17871, '40588', 218, 21, 3748, 38.0465, 0.664036693860023, -84.4952, -1.47471944213111),
(17872, '40589', 218, 21, 3748, 38.0459, 0.664026221884511, -84.4957, -1.47472816877737),
(17873, '40590', 218, 21, 3748, 38.0465, 0.664036693860023, -84.4962, -1.47473689542363),
(17874, '40591', 218, 21, 3748, 38.046, 0.664027967213763, -84.4956, -1.47472642344812),
(17875, '40592', 218, 21, 3748, 38.0461, 0.664029712543015, -84.4954, -1.47472293278962),
(17876, '40593', 218, 21, 3748, 38.0465, 0.664036693860023, -84.4956, -1.47472642344812),
(17877, '40594', 218, 21, 3748, 38.0459, 0.664026221884511, -84.4959, -1.47473165943588),
(17878, '40595', 218, 21, 3748, 38.0475, 0.664054147152543, -84.4964, -1.47474038608214),
(17879, '40596', 218, 21, 3748, 38.0488, 0.664076836432818, -84.5004, -1.47481019925222),
(17880, '40598', 218, 21, 3748, 38.049, 0.664080327091322, -84.5008, -1.47481718056922),
(17881, '40601', 218, 21, 2594, 38.2008, 0.66672973689585, -84.947, -1.48260483969162),
(17882, '40602', 218, 21, 2594, 38.213, 0.666942667064593, -84.8178, -1.48034987429805),
(17883, '40603', 218, 21, 2594, 38.2022, 0.666754171505378, -84.8325, -1.48060643769809),
(17884, '40604', 218, 21, 2594, 38.2237, 0.667129417294557, -84.9184, -1.48210567552555),
(17885, '40618', 218, 21, 2594, 38.1781, 0.666333547155647, -84.8991, -1.48176882697992),
(17886, '40619', 218, 21, 2594, 38.1781, 0.666333547155647, -84.8995, -1.48177580829693),
(17887, '40620', 218, 21, 2594, 38.1778, 0.666328311167891, -84.8991, -1.48176882697992),
(17888, '40621', 218, 21, 2594, 38.2003, 0.66672101024959, -84.8723, -1.48130107874038),
(17889, '40622', 218, 21, 2594, 38.1981, 0.666682613006046, -84.8746, -1.48134122131318),
(17890, '40701', 218, 21, 1763, 36.9368, 0.644668775150641, -84.1143, -1.46807148301027),
(17891, '40702', 218, 21, 1763, 36.9516, 0.644927083879937, -84.087, -1.46759500812447),
(17892, '40724', 218, 21, 1255, 37.0778, 0.647129689395954, -84.0825, -1.46751646830813),
(17893, '40729', 218, 21, 35681, 37.2042, 0.649335785570474, -84.1162, -1.46810464426605),
(17894, '40730', 218, 21, 35768, 36.7031, 0.640589940688731, -84.1464, -1.46863173370016),
(17895, '40734', 218, 21, 21530, 36.9505, 0.644907885258165, -83.9637, -1.46544301715676),
(17896, '40737', 218, 21, 36676, 37.0193, 0.646108671783537, -84.1605, -1.46887782512469),
(17897, '40740', 218, 21, 16897, 37.0188, 0.646099945137277, -84.0621, -1.46716042114073),
(17898, '40741', 218, 21, 3852, 37.1093, 0.647679468110332, -84.0763, -1.46740825789451),
(17899, '40742', 218, 21, 3852, 37.0882, 0.647311203638161, -84.1451, -1.46860904441988),
(17900, '40743', 218, 21, 3852, 37.1291, 0.648025043302227, -84.0838, -1.46753915758841),
(17901, '40744', 218, 21, 3852, 37.0713, 0.647016242994574, -84.0166, -1.46636629633107),
(17902, '40745', 218, 21, 3852, 37.0888, 0.647321675613673, -84.1449, -1.46860555376138),
(17903, '40751', 218, 21, 37079, 37.1097, 0.64768644942734, -83.9085, -1.46447959540966),
(17904, '40754', 218, 21, 37389, 36.6656, 0.639935442219233, -84.1079, -1.46795978193814),
(17905, '40755', 218, 21, 5099, 37.1597, 0.648559114053337, -84.1042, -1.46789520475581),
(17906, '40759', 218, 21, 37975, 36.8252, 0.642720987705416, -84.09, -1.46764736800203),
(17907, '40763', 218, 21, 38211, 36.7244, 0.640961695819406, -83.9692, -1.46553901026562),
(17908, '40769', 218, 21, 6831, 36.7405, 0.641242693828977, -84.164, -1.46893891164851),
(17909, '40771', 218, 21, 634, 36.9188, 0.644354615885283, -84.0807, -1.4674850523816),
(17910, '40801', 218, 21, 0, 36.8622, 0.643366759528654, -83.3609, -1.45492217242574),
(17911, '40803', 218, 21, 7175, 36.9891, 0.645581582349435, -83.3896, -1.45542308192106),
(17912, '40806', 218, 21, 150, 36.8484, 0.643125904091879, -83.3407, -1.45456961591684),
(17913, '40807', 218, 21, 29197, 36.965, 0.645160957999704, -82.9566, -1.44786580625993),
(17914, '40808', 218, 21, 34811, 36.9973, 0.645724699348098, -83.1633, -1.4514734018238),
(17915, '40810', 218, 21, 7536, 36.8754, 0.643597142989917, -83.4296, -1.45612121362186),
(17916, '40813', 218, 21, 7856, 36.695, 0.640448569019319, -83.7672, -1.46201344517659),
(17917, '40815', 218, 21, 35178, 36.7499, 0.641406754778664, -83.2692, -1.45332170550166),
(17918, '40816', 218, 21, 35213, 36.9896, 0.645590308995695, -83.389, -1.45541260994555),
(17919, '40818', 218, 21, 0, 36.8095, 0.642446971012853, -83.2381, -1.45277890810429),
(17920, '40819', 218, 21, 35319, 36.8809, 0.643693136098777, -83.4337, -1.45619277212119),
(17921, '40820', 218, 21, 35411, 36.7548, 0.641492275912012, -83.1989, -1.45209473903751),
(17922, '40823', 218, 21, 20409, 36.975, 0.645335490924903, -82.9856, -1.44837195174301),
(17923, '40824', 218, 21, 0, 36.8659, 0.643431336710978, -83.3898, -1.45542657257957),
(17924, '40826', 218, 21, 35780, 37.0642, 0.646892324617682, -82.7623, -1.4444746315233),
(17925, '40827', 218, 21, 35794, 36.9888, 0.645576346361678, -83.3891, -1.4554143552748),
(17926, '40828', 218, 21, 35808, 36.847, 0.643101469482351, -83.1641, -1.45148736445782),
(17927, '40829', 218, 21, 0, 36.8422, 0.643017693678255, -83.3211, -1.45422753138345),
(17928, '40830', 218, 21, 0, 36.7588, 0.641562089082092, -83.3364, -1.454494566759),
(17929, '40831', 218, 21, 32686, 36.8476, 0.643111941457863, -83.3134, -1.45409314103104),
(17930, '40840', 218, 21, 36362, 36.9538, 0.644965481123481, -83.3903, -1.45543529922583),
(17931, '40843', 218, 21, 36477, 36.8854, 0.643771675915116, -82.9675, -1.4480560471484),
(17932, '40844', 218, 21, 36506, 37.0772, 0.647119217420442, -83.392, -1.45546496982311),
(17933, '40845', 218, 21, 76150, 36.7502, 0.64141199076642, -83.5344, -1.45795031867795),
(17934, '40847', 218, 21, 36707, 36.7744, 0.641834360445403, -83.1602, -1.45141929661699),
(17935, '40849', 218, 21, 0, 36.9206, 0.644386031811818, -83.1832, -1.45182072234495),
(17936, '40854', 218, 21, 36996, 36.8464, 0.643090997506839, -83.3558, -1.45483316063389),
(17937, '40855', 218, 21, 37005, 36.9632, 0.645129542073168, -82.9116, -1.44708040809653),
(17938, '40856', 218, 21, 37228, 36.7411, 0.641253165804489, -83.6933, -1.46072364685937),
(17939, '40858', 218, 21, 37323, 36.9888, 0.645576346361678, -83.3891, -1.4554143552748),
(17940, '40862', 218, 21, 33579, 37.0119, 0.645979517418889, -82.8726, -1.44639972968825),
(17941, '40863', 218, 21, 37601, 36.7462, 0.64134217759634, -83.4555, -1.45657325389813),
(17942, '40865', 218, 21, 24157, 36.9381, 0.644691464430917, -83.2636, -1.45322396706355),
(17943, '40868', 218, 21, 38386, 37.0866, 0.647283278370129, -83.365, -1.45499373092507),
(17944, '40870', 218, 21, 38568, 36.9696, 0.645241243145296, -83.2016, -1.45214186292731),
(17945, '40873', 218, 21, 38731, 36.8358, 0.642905992606127, -83.4103, -1.45578436507623),
(17946, '40874', 218, 21, 38749, 36.9894, 0.645586818337191, -83.3889, -1.4554108646163),
(17947, '40902', 218, 21, 34580, 36.8425, 0.643022929666011, -83.6372, -1.459744517149),
(17948, '40903', 218, 21, 34590, 36.8436, 0.643042128287783, -83.8275, -1.46306587871555),
(17949, '40906', 218, 21, 34669, 36.868, 0.643467988625269, -83.8899, -1.46415496416879),
(17950, '40913', 218, 21, 7444, 36.939, 0.644707172394185, -83.5627, -1.45844424685627),
(17951, '40914', 218, 21, 707, 37.1552, 0.648480574236997, -83.6231, -1.45949842572447),
(17952, '40915', 218, 21, 34823, 36.8901, 0.64385370638996, -83.8263, -1.46304493476452),
(17953, '40921', 218, 21, 0, 36.7656, 0.641680771471227, -83.9191, -1.46466460031037),
(17954, '40923', 218, 21, 13474, 36.9668, 0.64519237392624, -83.8096, -1.46275346477944),
(17955, '40927', 218, 21, 35291, 36.8998, 0.644023003327404, -83.0846, -1.45009982770248),
(17956, '40930', 218, 21, 20499, 36.8721, 0.643539547124601, -83.7299, -1.4613624373656),
(17957, '40931', 218, 21, 35788, 37.1886, 0.649063514207163, -83.5931, -1.45897482694887),
(17958, '40932', 218, 21, 35844, 37.22, 0.649611547592289, -83.7883, -1.46238170964877),
(17959, '40935', 218, 21, 35914, 36.8332, 0.642860614045575, -83.7602, -1.46189127212895),
(17960, '40939', 218, 21, 2576, 36.741, 0.641251420475237, -83.693, -1.46071841087161),
(17961, '40940', 218, 21, 35979, 36.6301, 0.639315850334775, -83.8896, -1.46414972818104),
(17962, '40941', 218, 21, 36054, 37.1241, 0.647937776839627, -83.7462, -1.46164692603368),
(17963, '40943', 218, 21, 36099, 36.9692, 0.645234261828288, -83.8568, -1.46357726018638),
(17964, '40944', 218, 21, 36142, 37.0897, 0.647337383576941, -83.6944, -1.46074284548114),
(17965, '40946', 218, 21, 0, 37.0094, 0.645935884187589, -83.8949, -1.46424223063139),
(17966, '40949', 218, 21, 36356, 36.896, 0.643956680815828, -83.8673, -1.46376051975784),
(17967, '40951', 218, 21, 36437, 37.1205, 0.647874944986555, -83.778, -1.46220194073581),
(17968, '40953', 218, 21, 9517, 36.8779, 0.643640776221217, -83.7798, -1.46223335666235),
(17969, '40955', 218, 21, 539, 36.7301, 0.641061179586769, -83.7986, -1.46256147856172),
(17970, '40958', 218, 21, 36709, 36.8181, 0.642597069328524, -83.5841, -1.45881774731619),
(17971, '40962', 218, 21, 585, 37.1534, 0.648449158310461, -83.7624, -1.4619296693725),
(17972, '40964', 218, 21, 546, 36.7034, 0.640595176676487, -83.4178, -1.45591526477013),
(17973, '40965', 218, 21, 37181, 36.611, 0.638982492447644, -83.7229, -1.46124026431796),
(17974, '40972', 218, 21, 10986, 37.2765, 0.650597658619666, -83.6551, -1.46005693108511),
(17975, '40977', 218, 21, 5077, 36.7542, 0.6414818039365, -83.6999, -1.46083883859),
(17976, '40979', 218, 21, 11618, 37.0288, 0.646274478062476, -83.511, -1.45754191163298),
(17977, '40981', 218, 21, 38113, 37.3969, 0.652699035039067, -83.2717, -1.45336533873296),
(17978, '40982', 218, 21, 38121, 36.9428, 0.644773494905761, -83.7198, -1.46118615911115),
(17979, '40983', 218, 21, 38160, 37.2929, 0.650883892616993, -83.7956, -1.46250911868416),
(17980, '40988', 218, 21, 38397, 36.8846, 0.6437577132811, -83.5283, -1.45784385359358),
(17981, '40995', 218, 21, 38591, 36.7819, 0.641965260139302, -83.8355, -1.46320550505571),
(17982, '40997', 218, 21, 12598, 36.8879, 0.643815309146416, -83.6673, -1.46026986125385),
(17983, '40999', 218, 21, 38966, 37.0091, 0.645930648199833, -83.8449, -1.46336956600539),
(17984, '41001', 218, 21, 34524, 38.9333, 0.679514273666708, -84.3927, -1.47293047964782),
(17985, '41002', 218, 21, 7193, 38.7686, 0.676639716388674, -84.0017, -1.46610624227252),
(17986, '41003', 218, 21, 389, 38.3592, 0.669494338431009, -84.2805, -1.47097222022708),
(17987, '41004', 218, 21, 1170, 38.6512, 0.674590699846832, -84.0958, -1.46774859709865),
(17988, '41005', 218, 21, 1239, 39.0246, 0.681107759273779, -84.7454, -1.4790862559196),
(17989, '41006', 218, 21, 1257, 38.7822, 0.676877081166945, -84.3725, -1.47257792313892),
(17990, '41007', 218, 21, 19701, 38.8946, 0.678838831246186, -84.2956, -1.47123576494413),
(17991, '41008', 218, 21, 1380, 38.6773, 0.675046230781603, -85.169, -1.48647947063105),
(17992, '41010', 218, 21, 743, 38.5375, 0.672606260487315, -84.5924, -1.47641590216405),
(17993, '41011', 218, 21, 15652, 39.072, 0.681935045339224, -84.5275, -1.47528318347951),
(17994, '41012', 218, 21, 15652, 39.0673, 0.681853014864381, -84.5296, -1.4753198353938),
(17995, '41014', 218, 21, 15652, 39.0665, 0.681839052230365, -84.5063, -1.47491317367808),
(17996, '41015', 218, 21, 36809, 39.0195, 0.681018747481927, -84.4998, -1.4747997272767),
(17997, '41016', 218, 21, 15652, 39.0882, 0.682217788678048, -84.5485, -1.47564970262243),
(17998, '41017', 218, 21, 2558, 39.0355, 0.681298000162247, -84.5701, -1.47602669374086),
(17999, '41018', 218, 21, 35789, 39.008, 0.680818034617948, -84.5961, -1.47648047934638),
(18000, '41019', 218, 21, 15652, 39.0684, 0.681872213486153, -84.5311, -1.47534601533258),
(18001, '41022', 218, 21, 2502, 38.992, 0.680538781937629, -84.6431, -1.47730078409481),
(18002, '41030', 218, 21, 8299, 38.8133, 0.677419878564315, -84.6427, -1.4772938027778),
(18003, '41031', 218, 21, 29595, 38.389, 0.670014446548103, -84.2952, -1.47122878362712),
(18004, '41033', 218, 21, 0, 38.7496, 0.676308103830795, -84.4711, -1.47429881778138),
(18005, '41034', 218, 21, 8583, 38.6375, 0.674351589739309, -83.7897, -1.46240614425829),
(18006, '41035', 218, 21, 35640, 38.6907, 0.67528010490137, -84.5931, -1.47642811946882),
(18007, '41037', 218, 21, 35731, 38.4197, 0.670550262628465, -83.8257, -1.46303446278901),
(18008, '41039', 218, 21, 2347, 38.4073, 0.670333841801218, -83.8733, -1.46386523951296),
(18009, '41040', 218, 21, 15986, 38.6761, 0.675025286830579, -84.3354, -1.47193040598643),
(18010, '41041', 218, 21, 35926, 38.4228, 0.670604367835277, -83.7321, -1.46140083460914),
(18011, '41042', 218, 21, 2502, 38.989, 0.680486422060069, -84.6465, -1.47736012528938),
(18012, '41043', 218, 21, 35967, 38.7476, 0.676273197245755, -84.1519, -1.46872772680902),
(18013, '41044', 218, 21, 27253, 38.6269, 0.674166584838598, -83.9791, -1.46571179786157),
(18014, '41045', 218, 21, 36085, 38.7361, 0.676072484381775, -85.0599, -1.48457531641712),
(18015, '41046', 218, 21, 2739, 38.7152, 0.675707710568109, -84.8216, -1.48041619680962),
(18016, '41048', 218, 21, 940, 39.073, 0.681952498631744, -84.6893, -1.47810712620923),
(18017, '41049', 218, 21, 3145, 38.2852, 0.668202794784533, -83.6774, -1.4604461395083),
(18018, '41051', 218, 21, 3320, 38.9399, 0.67962946539734, -84.5515, -1.47570206249999),
(18019, '41052', 218, 21, 3455, 38.661, 0.674761742113528, -84.7747, -1.47959763739044),
(18020, '41053', 218, 21, 14041, 38.8679, 0.678372828335904, -84.4563, -1.47404050905209),
(18021, '41054', 218, 21, 17048, 38.5757, 0.673272976261577, -84.5853, -1.47629198378716),
(18022, '41055', 218, 21, 0, 38.5303, 0.672480596781171, -83.8775, -1.46393854334154),
(18023, '41056', 218, 21, 4063, 38.6402, 0.674398713629113, -83.7594, -1.46187730949494),
(18024, '41059', 218, 21, 10438, 39.0289, 0.681182808431615, -84.3674, -1.47248891134706),
(18025, '41061', 218, 21, 10480, 38.5815, 0.673374205358192, -84.1564, -1.46880626662536),
(18026, '41062', 218, 21, 37221, 38.7055, 0.675538413630665, -83.9191, -1.46466460031037),
(18027, '41063', 218, 21, 37277, 38.8775, 0.678540379944095, -84.4839, -1.47452221992564),
(18028, '41064', 218, 21, 23219, 38.5315, 0.672501540732195, -84.0359, -1.4667031448767),
(18029, '41065', 218, 21, 37344, 38.3505, 0.669342494786085, -83.527, -1.4578211643133),
(18030, '41071', 218, 21, 10799, 39.0834, 0.682134012873952, -84.4843, -1.47452920124265),
(18031, '41072', 218, 21, 10799, 39.0802, 0.682078162337888, -84.4801, -1.47445589741406),
(18032, '41073', 218, 21, 270, 39.1025, 0.682467370761083, -84.4788, -1.47443320813379),
(18033, '41074', 218, 21, 1992, 39.1101, 0.682600015784234, -84.4682, -1.47424820323307),
(18034, '41075', 218, 21, 35964, 39.0808, 0.6820886343134, -84.4531, -1.47398465851602),
(18035, '41076', 218, 21, 10799, 39.0253, 0.681119976578543, -84.4414, -1.47378045499354),
(18036, '41080', 218, 21, 14402, 39.0429, 0.681427154526894, -84.8408, -1.48075130002601),
(18037, '41081', 218, 21, 37737, 38.3077, 0.668595493866232, -83.5676, -1.45852976798961),
(18038, '41083', 218, 21, 11797, 38.6667, 0.674861225880891, -84.9966, -1.48347052300061),
(18039, '41085', 218, 21, 38217, 39.0334, 0.681261348247955, -84.3898, -1.47287986509951),
(18040, '41086', 218, 21, 25003, 38.7237, 0.675856063554528, -84.8873, -1.48156287812818),
(18041, '41091', 218, 21, 455, 38.9291, 0.679440969838125, -84.728, -1.47878256862976),
(18042, '41092', 218, 21, 12546, 38.8255, 0.677632808733058, -84.6804, -1.47795179190581),
(18043, '41093', 218, 21, 38730, 38.3425, 0.669202868445926, -83.556, -1.45832730979638),
(18044, '41094', 218, 21, 18491, 38.8828, 0.678632882394451, -84.6319, -1.47710530721859),
(18045, '41095', 218, 21, 6638, 38.7827, 0.676885807813205, -84.8991, -1.48176882697992),
(18046, '41096', 218, 21, 12671, 38.6162, 0.673979834608634, -83.8077, -1.46272030352365),
(18047, '41097', 218, 21, 6834, 38.6389, 0.674376024348837, -84.561, -1.47586786877893),
(18048, '41098', 218, 21, 26262, 38.6339, 0.674288757886237, -85.0607, -1.48458927905114),
(18049, '41099', 218, 21, 10799, 39.0317, 0.681231677650671, -84.4615, -1.47413126617319),
(18050, '41101', 218, 21, 13301, 38.4588, 0.671232686365995, -82.6596, -1.4426821783815),
(18051, '41102', 218, 21, 13301, 38.4422, 0.670942961710164, -82.6889, -1.44319355985234),
(18052, '41105', 218, 21, 13301, 38.4312, 0.670750975492445, -82.6661, -1.44279562478288),
(18053, '41114', 218, 21, 13301, 38.4597, 0.671248394329263, -82.6449, -1.44242561498146),
(18054, '41121', 218, 21, 34582, 38.5108, 0.672140257577032, -82.873, -1.44640671100526),
(18055, '41124', 218, 21, 19318, 38.0349, 0.663834235666791, -82.8582, -1.44614840227597),
(18056, '41127', 218, 21, 0, 38.603, 0.673749451147371, -83.3626, -1.45495184302303),
(18057, '41128', 218, 21, 35159, 38.4284, 0.670702106273389, -83.1206, -1.4507281462332),
(18058, '41129', 218, 21, 35172, 38.3724, 0.669724721892272, -82.628, -1.44213065433787),
(18059, '41132', 218, 21, 8484, 38.2871, 0.668235956040321, -82.8237, -1.44554626368403),
(18060, '41135', 218, 21, 8753, 38.3822, 0.669895764158968, -83.2609, -1.45317684317375),
(18061, '41137', 218, 21, 35897, 38.6842, 0.67516665849999, -83.0404, -1.4493283921731),
(18062, '41139', 218, 21, 2487, 38.5206, 0.672311299843728, -82.7214, -1.44376079185924),
(18063, '41141', 218, 21, 27246, 38.5521, 0.672861078558106, -83.1928, -1.45198827395314),
(18064, '41142', 218, 21, 36157, 38.2834, 0.668171378857997, -83.0753, -1.44993751208205),
(18065, '41143', 218, 21, 2826, 38.3291, 0.668968994326159, -82.9355, -1.44749754178776),
(18066, '41144', 218, 21, 27332, 38.5731, 0.673227597701025, -82.8134, -1.44536649477107),
(18067, '41146', 218, 21, 36453, 38.237, 0.667361546085072, -82.9181, -1.44719385449791),
(18068, '41149', 218, 21, 36588, 38.0623, 0.664312455881838, -83.0399, -1.44931966552684),
(18069, '41156', 218, 21, 10141, 38.6202, 0.674049647778714, -82.8647, -1.44626184867735),
(18070, '41159', 218, 21, 37071, 38.0134, 0.663458989877612, -82.9596, -1.44791816613749),
(18071, '41160', 218, 21, 37114, 38.0352, 0.663839471654547, -82.8582, -1.44614840227597),
(18072, '41164', 218, 21, 37522, 38.305, 0.668548369976428, -83.1686, -1.45156590427416),
(18073, '41166', 218, 21, 17745, 38.6304, 0.674227671362417, -83.0947, -1.45027610595693),
(18074, '41168', 218, 21, 11732, 38.2988, 0.668440159562804, -82.7474, -1.44421457746476),
(18075, '41169', 218, 21, 5580, 38.5268, 0.672419510257351, -82.7171, -1.4436857427014),
(18076, '41170', 218, 21, 11759, 38.6687, 0.674896132465931, -83.0712, -1.44986595358271),
(18077, '41171', 218, 21, 31072, 38.0697, 0.664441610246485, -83.2184, -1.45243507824165),
(18078, '41173', 218, 21, 33994, 38.2592, 0.667749009179014, -83.2991, -1.45384355894801),
(18079, '41174', 218, 21, 38297, 38.7067, 0.675559357581689, -83.0114, -1.44882224669002),
(18080, '41175', 218, 21, 38302, 38.7194, 0.675781014396692, -82.9522, -1.44778901177284),
(18081, '41179', 218, 21, 38662, 38.5963, 0.673632514087487, -83.3192, -1.45419437012766),
(18082, '41180', 218, 21, 38779, 38.1516, 0.665871034903869, -82.7951, -1.44504709951796),
(18083, '41181', 218, 21, 26074, 38.2113, 0.666912996467309, -82.8968, -1.44682209936724),
(18084, '41183', 218, 21, 31567, 38.5502, 0.672827917302318, -82.7345, -1.44398942999125),
(18085, '41189', 218, 21, 38556, 38.587, 0.673470198467052, -83.5459, -1.45815103154193),
(18086, '41201', 218, 21, 14941, 38.0001, 0.663226861087097, -82.7152, -1.44365258144561),
(18087, '41203', 218, 21, 34714, 37.761, 0.659053778845579, -82.6223, -1.44203117057051),
(18088, '41204', 218, 21, 0, 37.8169, 0.660029417897444, -82.6731, -1.44291779783052),
(18089, '41214', 218, 21, 35533, 37.7767, 0.659327795538142, -82.5966, -1.44158262095275),
(18090, '41215', 218, 21, 2033, 37.7959, 0.659662898754525, -82.859, -1.44616236490998),
(18091, '41216', 218, 21, 2180, 37.7106, 0.658174132902574, -82.8335, -1.44571730595072),
(18092, '41219', 218, 21, 35919, 37.947, 0.662300091254288, -82.8855, -1.44662487716176),
(18093, '41222', 218, 21, 36240, 37.7975, 0.659690824022557, -82.8185, -1.44545550656292),
(18094, '41224', 218, 21, 36567, 37.8623, 0.660821797377849, -82.5156, -1.44016890425863),
(18095, '41226', 218, 21, 36675, 37.9721, 0.662738168896539, -82.9508, -1.44776457716331),
(18096, '41228', 218, 21, 36822, 37.7533, 0.658919388493175, -82.8405, -1.44583947899836),
(18097, '41230', 218, 21, 36978, 38.1127, 0.665192101824843, -82.6063, -1.44175191789019),
(18098, '41231', 218, 21, 36985, 37.7796, 0.65937841008645, -82.3618, -1.43748458786907),
(18099, '41232', 218, 21, 36992, 38, 0.663225115757845, -82.7152, -1.44365258144561),
(18100, '41234', 218, 21, 37151, 37.7967, 0.659676861388541, -82.7318, -1.44394230610144),
(18101, '41238', 218, 21, 37498, 37.841, 0.660450042247174, -82.9412, -1.44759702555512),
(18102, '41240', 218, 21, 37576, 37.8117, 0.65993866077634, -82.8015, -1.44515880059008),
(18103, '41250', 218, 21, 37680, 37.7421, 0.658723911616952, -82.4742, -1.43944633794831),
(18104, '41254', 218, 21, 121226, 37.8744, 0.66103298221734, -82.6625, -1.44273279292981),
(18105, '41255', 218, 21, 11963, 37.889, 0.661287800288132, -82.8437, -1.44589532953443),
(18106, '41256', 218, 21, 38354, 37.8388, 0.66041164500363, -82.86, -1.4461798182025),
(18107, '41257', 218, 21, 133243, 37.84, 0.660432588954654, -82.7628, -1.44448335816956),
(18108, '41260', 218, 21, 38521, 37.8012, 0.659755401204881, -82.7687, -1.44458633259543),
(18109, '41262', 218, 21, 12346, 37.8566, 0.660722313610485, -82.6067, -1.4417588992072),
(18110, '41263', 218, 21, 38612, 37.8585, 0.660755474866273, -82.7376, -1.44404353519806),
(18111, '41264', 218, 21, 38625, 37.9999, 0.663223370428593, -82.7151, -1.44365083611636),
(18112, '41265', 218, 21, 38657, 37.7005, 0.657997854648122, -82.6861, -1.44314469063328),
(18113, '41267', 218, 21, 25802, 37.8586, 0.660757220195525, -82.4426, -1.43889481390468),
(18114, '41268', 218, 21, 38820, 37.8117, 0.65993866077634, -82.8025, -1.4451762538826),
(18115, '41271', 218, 21, 38893, 37.8182, 0.660052107177719, -82.7119, -1.4435949855803),
(18116, '41274', 218, 21, 38929, 37.8719, 0.66098934898604, -82.814, -1.44537696674658),
(18117, '41301', 218, 21, 15412, 37.7439, 0.658755327543488, -83.4488, -1.45645631683824),
(18118, '41307', 218, 21, 31693, 37.5536, 0.655433965976943, -83.4682, -1.45679491071313),
(18119, '41310', 218, 21, 34705, 37.6243, 0.656667913758103, -83.2112, -1.45230941453551),
(18120, '41311', 218, 21, 34717, 37.576, 0.655824919729389, -83.7098, -1.46101162618595),
(18121, '41313', 218, 21, 7428, 37.6499, 0.657114718046613, -83.4735, -1.45688741316349),
(18122, '41314', 218, 21, 1048, 37.4823, 0.654189546220271, -83.6652, -1.46023320933956),
(18123, '41317', 218, 21, 35264, 37.4672, 0.653926001503219, -83.2322, -1.45267593367842),
(18124, '41332', 218, 21, 3033, 37.7946, 0.659640209474249, -83.4587, -1.45662910443419),
(18125, '41333', 218, 21, 36355, 37.5549, 0.655456655257219, -83.7784, -1.46220892205282),
(18126, '41338', 218, 21, 30153, 37.3902, 0.652582097979184, -83.7175, -1.46114601653835),
(18127, '41339', 218, 21, 3384, 37.5391, 0.655180893235403, -83.3891, -1.4554143552748),
(18128, '41342', 218, 21, 36834, 37.7204, 0.658345175169269, -83.3181, -1.45417517150589),
(18129, '41344', 218, 21, 36850, 37.4823, 0.654189546220271, -83.6653, -1.46023495466881),
(18130, '41347', 218, 21, 36956, 37.53, 0.655022068273472, -83.6041, -1.45916681316659),
(18131, '41348', 218, 21, 36973, 37.4469, 0.653571699665065, -83.3182, -1.45417691683514),
(18132, '41351', 218, 21, 37230, 37.3174, 0.651311498283732, -83.5834, -1.45880553001143),
(18133, '41352', 218, 21, 37233, 37.8594, 0.660771182829541, -83.3736, -1.45514382924074),
(18134, '41360', 218, 21, 592, 37.7697, 0.659205622490502, -83.626, -1.45954904027278),
(18135, '41362', 218, 21, 51, 37.6017, 0.656273469347152, -83.6092, -1.45925582495844),
(18136, '41364', 218, 21, 37913, 37.3995, 0.652744413599619, -83.6063, -1.45920521041014),
(18137, '41365', 218, 21, 874, 37.71, 0.658163660927062, -83.6291, -1.45960314547959),
(18138, '41366', 218, 21, 38021, 37.6018, 0.656275214676404, -83.2125, -1.45233210381578),
(18139, '41367', 218, 21, 0, 37.414, 0.652997486341159, -83.2045, -1.45219247747562),
(18140, '41368', 218, 21, 38065, 37.5828, 0.655943602118525, -83.6468, -1.45991206875719),
(18141, '41377', 218, 21, 38478, 37.3933, 0.652636203185996, -83.4424, -1.45634461576612),
(18142, '41385', 218, 21, 38663, 37.6296, 0.656760416208458, -83.4143, -1.45585417824631),
(18143, '41386', 218, 21, 6568, 37.4495, 0.653617078225616, -83.8055, -1.46268190628011),
(18144, '41390', 218, 21, 38842, 37.4094, 0.652917201195567, -83.3705, -1.45508972403393),
(18145, '41397', 218, 21, 39020, 37.6542, 0.657189767204449, -83.6736, -1.46037981699673),
(18146, '41408', 218, 21, 35129, 37.7903, 0.659565160316413, -83.2739, -1.45340373597651),
(18147, '41410', 218, 21, 8084, 37.8523, 0.66064726445265, -83.1358, -1.4509934362795),
(18148, '41413', 218, 21, 92, 37.9862, 0.66298426032107, -83.0902, -1.45019756614059),
(18149, '41419', 218, 21, 13, 37.7979, 0.659697805339565, -83.1914, -1.45196383934361),
(18150, '41421', 218, 21, 35736, 37.9337, 0.662067962463773, -83.0772, -1.44997067333783),
(18151, '41422', 218, 21, 35760, 37.7653, 0.659128828003415, -83.1434, -1.45112608130265),
(18152, '41425', 218, 21, 35824, 37.9128, 0.661703188650106, -83.3928, -1.45547893245713),
(18153, '41426', 218, 21, 8837, 37.7897, 0.659554688340901, -83.002, -1.44865818574033),
(18154, '41433', 218, 21, 36042, 37.6296, 0.656760416208458, -82.9592, -1.44791118482048),
(18155, '41444', 218, 21, 36590, 37.7084, 0.65813573565903, -82.9786, -1.44824977869537),
(18156, '41451', 218, 21, 3960, 37.8723, 0.660996330303049, -83.258, -1.45312622862544),
(18157, '41459', 218, 21, 4792, 37.8892, 0.661291290946636, -83.0344, -1.44922367241798),
(18158, '41464', 218, 21, 28479, 37.6388, 0.656920986499642, -82.9809, -1.44828992126816),
(18159, '41465', 218, 21, 38084, 37.7561, 0.658968257712231, -83.0448, -1.44940518666019),
(18160, '41472', 218, 21, 12753, 37.9721, 0.662738168896539, -83.2775, -1.45346656782958),
(18161, '41477', 218, 21, 38977, 37.9878, 0.663012185589102, -83.3053, -1.45395176936163),
(18162, '41501', 218, 21, 5005, 37.4788, 0.654128459696451, -82.5148, -1.44015494162462),
(18163, '41502', 218, 21, 5005, 37.4792, 0.654135441013459, -82.5188, -1.4402247547947),
(18164, '41503', 218, 21, 112356, 37.6697, 0.657460293238508, -82.2864, -1.43616860961306),
(18165, '41512', 218, 21, 112330, 37.2571, 0.650259064744779, -82.4726, -1.43941841268028),
(18166, '41513', 218, 21, 7373, 37.3027, 0.651054934883689, -82.3501, -1.43728038434658),
(18167, '41514', 218, 21, 34750, 37.6388, 0.656920986499642, -82.2599, -1.43570609736128),
(18168, '41517', 218, 21, 35061, 37.1875, 0.649044315585391, -82.6042, -1.4417152659759),
(18169, '41519', 218, 21, 31955, 37.5982, 0.656212382823332, -82.3213, -1.43677772952201),
(18170, '41520', 218, 21, 35610, 37.2766, 0.650599403948918, -82.5796, -1.44128591497991),
(18171, '41522', 218, 21, 35737, 37.3094, 0.651171871943572, -82.3997, -1.43814606765557),
(18172, '41524', 218, 21, 35872, 37.4386, 0.653426837337149, -82.2644, -1.43578463717762),
(18173, '41526', 218, 21, 35949, 37.5339, 0.6550901361143, -82.5129, -1.44012178036883),
(18174, '41527', 218, 21, 2525, 37.6291, 0.656751689562198, -82.3024, -1.43644786229338),
(18175, '41528', 218, 21, 35993, 37.5459, 0.655299575624539, -82.1376, -1.43357155968609),
(18176, '41531', 218, 21, 2973, 37.6082, 0.656386915748531, -82.2526, -1.43557868832589),
(18177, '41534', 218, 21, 36360, 37.2878, 0.650794880825142, -82.4712, -1.43939397807075),
(18178, '41535', 218, 21, 36516, 37.5784, 0.655866807631437, -82.2551, -1.43562232155719),
(18179, '41537', 218, 21, 3417, 37.1979, 0.649225829827599, -82.6305, -1.44217428756917),
(18180, '41538', 218, 21, 36644, 37.3163, 0.65129229966196, -82.5827, -1.44134002018672),
(18181, '41539', 218, 21, 540, 37.5003, 0.65450370548563, -82.311, -1.43659796060905),
(18182, '41540', 218, 21, 36879, 37.3682, 0.652198125543745, -82.2969, -1.43635186918452),
(18183, '41542', 218, 21, 10194, 37.3135, 0.651243430442904, -82.4683, -1.43934336352244),
(18184, '41543', 218, 21, 37115, 37.5373, 0.655149477308868, -82.2642, -1.43578114651912),
(18185, '41544', 218, 21, 37118, 37.5966, 0.6561844575553, -82.1688, -1.43411610241272),
(18186, '41546', 218, 21, 37139, 37.5297, 0.655016832285716, -82.2165, -1.43494862446592),
(18187, '41547', 218, 21, 3956, 37.5439, 0.655264669039499, -82.0954, -1.43283503074175),
(18188, '41548', 218, 21, 37320, 37.3741, 0.652301099969613, -82.2873, -1.43618431757633),
(18189, '41549', 218, 21, 37347, 37.2944, 0.650910072555773, -82.5862, -1.44140110671054),
(18190, '41553', 218, 21, 23858, 37.4921, 0.654360588486966, -82.1655, -1.4340585065474),
(18191, '41554', 218, 21, 37668, 37.4669, 0.653920765515464, -82.3426, -1.43714948465268),
(18192, '41555', 218, 21, 37704, 37.5596, 0.655538685732062, -82.194, -1.43455592538422),
(18193, '41557', 218, 21, 30917, 37.4977, 0.654458326925078, -82.4278, -1.43863650517538),
(18194, '41558', 218, 21, 33721, 37.5964, 0.656180966896796, -82.1687, -1.43411435708346),
(18195, '41559', 218, 21, 57132, 37.3577, 0.652014865972286, -82.3758, -1.43772893396434),
(18196, '41560', 218, 21, 37960, 37.3288, 0.651510465818459, -82.5708, -1.44113232600573),
(18197, '41561', 218, 21, 11638, 37.3274, 0.651486031208931, -82.4527, -1.43907109215913),
(18198, '41562', 218, 21, 38180, 37.4133, 0.652985269036395, -82.4837, -1.43961214422725),
(18199, '41563', 218, 21, 0, 37.2329, 0.649836695065797, -82.5708, -1.44113232600573),
(18200, '41564', 218, 21, 5844, 37.6144, 0.656495126162155, -82.3775, -1.43775860456163),
(18201, '41566', 218, 21, 6066, 37.4036, 0.652815972098951, -82.2038, -1.43472696765091),
(18202, '41567', 218, 21, 34060, 37.5635, 0.65560675357289, -82.2898, -1.43622795080763),
(18203, '41568', 218, 21, 38403, 37.5248, 0.654931311152368, -82.0451, -1.431957130128),
(18204, '41569', 218, 21, 38555, 37.637, 0.656889570573106, -82.252, -1.43556821635038),
(18205, '41571', 218, 21, 38668, 37.6099, 0.656416586345815, -82.4208, -1.43851433212774),
(18206, '41572', 218, 21, 38705, 37.3042, 0.651081114822469, -82.6514, -1.44253906138284),
(18207, '41601', 218, 21, 18798, 37.6562, 0.657224673789489, -82.7008, -1.44340125403333),
(18208, '41602', 218, 21, 34626, 37.7366, 0.658627918508092, -82.759, -1.44441703565799),
(18209, '41603', 218, 21, 7249, 37.5818, 0.655926148826005, -82.7001, -1.44338903672856),
(18210, '41604', 218, 21, 7346, 37.3728, 0.652278410689337, -82.6731, -1.44291779783052),
(18211, '41605', 218, 21, 34794, 37.5393, 0.655184383893907, -82.6928, -1.44326162769317),
(18212, '41606', 218, 21, 0, 37.3337, 0.651595986951807, -82.7125, -1.44360545755581),
(18213, '41607', 218, 21, 29245, 37.6434, 0.657001271645233, -82.831, -1.44567367271942),
(18214, '41612', 218, 21, 0, 37.3054, 0.651102058773493, -82.7016, -1.44341521666734),
(18215, '41615', 218, 21, 15726, 37.5553, 0.655463636574226, -82.6757, -1.44296317639108),
(18216, '41616', 218, 21, 35512, 37.609, 0.656400878382547, -82.8956, -1.44680115541621),
(18217, '41619', 218, 21, 35632, 37.4802, 0.654152894305979, -82.7476, -1.44421806812326),
(18218, '41621', 218, 21, 35672, 37.6236, 0.656655696453339, -82.724, -1.44380617041979),
(18219, '41622', 218, 21, 35689, 37.5266, 0.654962727078904, -82.824, -1.44555149967178),
(18220, '41630', 218, 21, 9065, 37.4858, 0.65425063274409, -82.8554, -1.44609953305691),
(18221, '41631', 218, 21, 36208, 37.455, 0.653713071334476, -82.7329, -1.44396150472322),
(18222, '41632', 218, 21, 36228, 37.5519, 0.655404295379659, -82.9468, -1.44769476399323),
(18223, '41635', 218, 21, 273, 37.4917, 0.654353607169958, -82.619, -1.4419735747052),
(18224, '41636', 218, 21, 36387, 37.3905, 0.65258733396694, -82.7283, -1.44388121957762),
(18225, '41640', 218, 21, 0, 37.508, 0.654638095838033, -82.831, -1.44567367271942),
(18226, '41642', 218, 21, 36586, 37.5984, 0.656215873481836, -82.6601, -1.44269090502776),
(18227, '41643', 218, 21, 36773, 37.4642, 0.65387364162566, -82.8006, -1.44514309262682),
(18228, '41645', 218, 21, 9983, 37.5498, 0.655367643465367, -82.7745, -1.44468756169205),
(18229, '41647', 218, 21, 4087, 37.4281, 0.65324357776569, -82.7432, -1.44414127363617),
(18230, '41649', 218, 21, 882, 37.5458, 0.655297830295287, -82.7591, -1.44441878098724),
(18231, '41650', 218, 21, 4160, 37.35, 0.651880475619882, -82.6938, -1.44327908098569),
(18232, '41651', 218, 21, 37223, 37.4782, 0.654117987720939, -82.7545, -1.44433849584165),
(18233, '41653', 218, 21, 37799, 37.6677, 0.657425386653468, -82.7679, -1.44457236996141),
(18234, '41655', 218, 21, 37811, 37.5079, 0.654636350508781, -82.7073, -1.44351470043471),
(18235, '41659', 218, 21, 38364, 37.5844, 0.655971527386557, -82.6705, -1.44287241926997),
(18236, '41660', 218, 21, 38498, 37.4252, 0.653192963217382, -82.6396, -1.44233311253111),
(18237, '41663', 218, 21, 38572, 37.5731, 0.655774305181081, -82.6465, -1.44245354024949),
(18238, '41666', 218, 21, 38772, 37.4493, 0.653613587567113, -82.8093, -1.44529493627174),
(18239, '41667', 218, 21, 38784, 37.3282, 0.651499993842947, -82.6884, -1.44318483320608),
(18240, '41669', 218, 21, 38838, 37.3324, 0.651573297671531, -82.7216, -1.44376428251774),
(18241, '41701', 218, 21, 21798, 37.2531, 0.6501892515747, -83.1875, -1.45189577150278),
(18242, '41702', 218, 21, 21798, 37.2495, 0.650126419721628, -83.1929, -1.45199001928239),
(18243, '41712', 218, 21, 34595, 37.3565, 0.651993922021262, -83.1394, -1.45105626813257),
(18244, '41713', 218, 21, 34627, 37.2215, 0.649637727531069, -83.2808, -1.45352416369489),
(18245, '41714', 218, 21, 29171, 37.2104, 0.649443995984098, -83.4885, -1.45714921255129),
(18246, '41719', 218, 21, 34912, 37.3105, 0.651191070565344, -83.2202, -1.45246649416819),
(18247, '41721', 218, 21, 1213, 37.3048, 0.651091586797981, -83.49, -1.45717539249007),
(18248, '41722', 218, 21, 35052, 37.3317, 0.651561080366767, -83.1694, -1.45157986690817),
(18249, '41723', 218, 21, 35083, 37.2678, 0.650445814974743, -83.2716, -1.45336359340371),
(18250, '41725', 218, 21, 35153, 37.3079, 0.651145692004792, -83.0316, -1.44917480319892),
(18251, '41727', 218, 21, 1506, 37.3602, 0.652058499203586, -83.3229, -1.45425894730998),
(18252, '41729', 218, 21, 8196, 37.2935, 0.650894364592505, -83.1992, -1.45209997502527),
(18253, '41730', 218, 21, 1736, 37.2833, 0.650716341008802, -83.3961, -1.45553652832244),
(18254, '41731', 218, 21, 29552, 37.1235, 0.647927304864115, -83.0374, -1.44927603229554),
(18255, '41735', 218, 21, 35555, 37.0212, 0.646141833039325, -83.0917, -1.45022374607937),
(18256, '41736', 218, 21, 35579, 37.3788, 0.652383130444456, -83.21, -1.45228847058448),
(18257, '41739', 218, 21, 530, 37.3349, 0.651616930902831, -83.131, -1.45090966047541),
(18258, '41740', 218, 21, 35770, 37.3262, 0.651465087257907, -83.0699, -1.44984326430244),
(18259, '41743', 218, 21, 35902, 37.3557, 0.651979959387246, -83.1066, -1.45048380013792),
(18260, '41745', 218, 21, 36070, 37.3499, 0.65187873029063, -83.4474, -1.45643188222872),
(18261, '41746', 218, 21, 9320, 37.2013, 0.649285171022167, -83.0983, -1.45033893781),
(18262, '41747', 218, 21, 36281, 37.3014, 0.651032245603413, -83.124, -1.45078748742777),
(18263, '41749', 218, 21, 9636, 37.1639, 0.648632417881921, -83.4376, -1.45626083996202),
(18264, '41751', 218, 21, 3408, 37.2067, 0.649379418801774, -83.1873, -1.45189228084428),
(18265, '41754', 218, 21, 36760, 37.3208, 0.6513708394783, -83.3106, -1.45404427181199),
(18266, '41759', 218, 21, 31078, 37.2374, 0.649915234882137, -83.0322, -1.44918527517444),
(18267, '41760', 218, 21, 38133, 37.2143, 0.649512063824926, -83.0934, -1.45025341667666),
(18268, '41762', 218, 21, 38232, 37.1632, 0.648620200577157, -83.4373, -1.45625560397426),
(18269, '41763', 218, 21, 38248, 37.0712, 0.647014497665322, -83.1162, -1.45065135174611),
(18270, '41764', 218, 21, 38257, 37.1668, 0.648683032430229, -83.2593, -1.45314891790571),
(18271, '41766', 218, 21, 38530, 37.1854, 0.649007663671099, -83.429, -1.45611074164635),
(18272, '41772', 218, 21, 38685, 37.4331, 0.653330844228289, -83.0701, -1.44984675496094),
(18273, '41773', 218, 21, 38687, 37.1598, 0.648560859382589, -83.095, -1.45028134194469),
(18274, '41774', 218, 21, 38702, 37.1392, 0.648201321556678, -83.1674, -1.45154496032313),
(18275, '41775', 218, 21, 38798, 37.1634, 0.648623691235661, -83.3785, -1.45522935037409),
(18276, '41776', 218, 21, 38968, 37.1982, 0.649231065815355, -83.3002, -1.45386275756978),
(18277, '41777', 218, 21, 38989, 37.0437, 0.646534532121024, -83.2208, -1.4524769661437),
(18278, '41778', 218, 21, 38997, 37.2781, 0.650625583887698, -83.3005, -1.45386799355754),
(18279, '41804', 218, 21, 34842, 37.1311, 0.648059949887267, -82.943, -1.44762844148166),
(18280, '41810', 218, 21, 35443, 37.1832, 0.648969266427555, -82.6858, -1.44313945464553),
(18281, '41812', 218, 21, 528, 37.2382, 0.649929197516152, -82.7979, -1.44509596873701),
(18282, '41815', 218, 21, 35790, 37.1746, 0.648819168111884, -82.8221, -1.445518338416),
(18283, '41817', 218, 21, 9061, 37.3769, 0.652349969188669, -82.8897, -1.44669818099034),
(18284, '41819', 218, 21, 2785, 36.9943, 0.645672339470538, -83.0717, -1.44987468022897),
(18285, '41821', 218, 21, 36252, 37.0777, 0.647127944066701, -83.0066, -1.44873847088593),
(18286, '41822', 218, 21, 36440, 37.3234, 0.651416218038852, -82.9499, -1.44774886920004),
(18287, '41824', 218, 21, 36584, 37.1926, 0.649133327377243, -82.9083, -1.44702281223121),
(18288, '41825', 218, 21, 0, 37.1685, 0.648712703027512, -82.6895, -1.44320403182785),
(18289, '41826', 218, 21, 36620, 37.1661, 0.648670815125465, -82.9354, -1.44749579645851),
(18290, '41828', 218, 21, 22417, 37.2954, 0.650927525848293, -82.7931, -1.44501219293292),
(18291, '41831', 218, 21, 36827, 37.4278, 0.653238341777934, -82.9695, -1.44809095373344),
(18292, '41832', 218, 21, 3737, 37.1616, 0.648592275309125, -82.9952, -1.4485395033512),
(18293, '41833', 218, 21, 36901, 37.0384, 0.646442029670668, -82.9449, -1.44766160273744),
(18294, '41834', 218, 21, 36910, 37.2587, 0.650286990012811, -82.9677, -1.4480595378069),
(18295, '41835', 218, 21, 37138, 37.2105, 0.64944574131335, -82.6706, -1.44287416459922),
(18296, '41836', 218, 21, 0, 37.3023, 0.651047953566681, -82.9163, -1.44716243857137),
(18297, '41837', 218, 21, 37106, 37.1066, 0.647632344220528, -82.7669, -1.44455491666889),
(18298, '41838', 218, 21, 37210, 37.1453, 0.64830778664105, -82.7398, -1.4440819324416),
(18299, '41839', 218, 21, 37324, 37.4378, 0.653412874703133, -82.9085, -1.44702630288972),
(18300, '41840', 218, 21, 37385, 37.2132, 0.649492865203154, -82.7079, -1.44352517241022),
(18301, '41843', 218, 21, 11216, 37.306, 0.651112530749005, -82.8258, -1.44558291559832),
(18302, '41844', 218, 21, 37706, 37.3691, 0.652213833507013, -82.8303, -1.44566145541466),
(18303, '41845', 218, 21, 0, 37.1467, 0.648332221250578, -82.8917, -1.44673308757538),
(18304, '41847', 218, 21, 37885, 37.2558, 0.650236375464503, -82.8704, -1.44636133244471),
(18305, '41848', 218, 21, 5568, 37.0931, 0.647396724771509, -83.027, -1.44909451805333),
(18306, '41849', 218, 21, 38143, 37.1747, 0.648820913441136, -82.7306, -1.44392136215042),
(18307, '41855', 218, 21, 351, 37.134, 0.648110564435574, -82.7434, -1.44414476429468),
(18308, '41858', 218, 21, 6792, 37.1235, 0.647927304864115, -82.8247, -1.44556371697655),
(18309, '41859', 218, 21, 35559, 37.4313, 0.653299428301753, -82.8499, -1.44600353994805),
(18310, '41861', 218, 21, 28373, 37.3965, 0.65269205372206, -82.8384, -1.44580282708407),
(18311, '41862', 218, 21, 0, 37.3476, 0.651838587717834, -82.7782, -1.44475213887437),
(18312, '41901', 218, 21, 0, 38.0492, 0.664083817749826, -84.5008, -1.47481718056922),
(18313, '41902', 218, 21, 0, 38.0487, 0.664075091103566, -84.5002, -1.47480670859371),
(18314, '41903', 218, 21, 0, 38.0488, 0.664076836432818, -84.5, -1.47480321793521),
(18315, '41904', 218, 21, 0, 38.0488, 0.664076836432818, -84.5008, -1.47481718056922),
(18316, '41905', 218, 21, 0, 38.0491, 0.664082072420574, -84.5001, -1.47480496326446),
(18317, '41906', 218, 21, 0, 38.0493, 0.664085563079079, -84.5002, -1.47480670859371),
(18318, '42001', 218, 21, 552, 37.0586, 0.646794586179571, -88.6606, -1.54741938679368),
(18319, '42002', 218, 21, 552, 37.0696, 0.64698657239729, -88.6268, -1.54682946550651),
(18320, '42003', 218, 21, 552, 37.0308, 0.646309384647516, -88.5897, -1.54618194835402),
(18321, '42020', 218, 21, 34540, 36.6695, 0.640003510060061, -88.3699, -1.54234571465814),
(18322, '42021', 218, 21, 15026, 36.7892, 0.642092669174698, -89.0088, -1.55349662324913),
(18323, '42022', 218, 21, 34660, 37.1465, 0.648328730592074, -88.9457, -1.55239532049112),
(18324, '42023', 218, 21, 34674, 36.874, 0.643572708380389, -89.0079, -1.55348091528586),
(18325, '42024', 218, 21, 34678, 37.0581, 0.646785859533311, -89.0775, -1.55469566444525),
(18326, '42025', 218, 21, 358, 36.8568, 0.643272511749046, -88.3516, -1.54202631940502),
(18327, '42027', 218, 21, 85, 36.9549, 0.644984679745253, -88.644, -1.54712966213785),
(18328, '42028', 218, 21, 7786, 37.0276, 0.646253534111452, -88.2829, -1.5408272782089),
(18329, '42029', 218, 21, 35108, 37.0197, 0.646115653100545, -88.346, -1.54192858096691),
(18330, '42031', 218, 21, 1630, 36.6684, 0.639984311438289, -88.9939, -1.55323656919058),
(18331, '42032', 218, 21, 1718, 36.7185, 0.640858721393538, -89.1037, -1.55515294070927),
(18332, '42033', 218, 21, 35417, 37.2711, 0.650503410840058, -88.0827, -1.53733312904641),
(18333, '42035', 218, 21, 1923, 36.8932, 0.643907811596772, -88.8767, -1.55119104330724),
(18334, '42036', 218, 21, 2038, 36.6985, 0.640509655543139, -88.1656, -1.53878000699631),
(18335, '42037', 218, 21, 35673, 37.16, 0.648564350041093, -88.1848, -1.5391151102127),
(18336, '42038', 218, 21, 27042, 37.0719, 0.647026714970086, -88.0669, -1.53705736702459),
(18337, '42039', 218, 21, 35850, 36.7591, 0.641567325069847, -88.7928, -1.54972671206482),
(18338, '42040', 218, 21, 8849, 36.6765, 0.6401256831077, -88.5377, -1.54527437714298),
(18339, '42041', 218, 21, 2628, 36.5075, 0.63717607667183, -88.8782, -1.55121722324602),
(18340, '42044', 218, 21, 36088, 36.9285, 0.644523912822726, -88.2203, -1.53973470209715),
(18341, '42045', 218, 21, 36159, 37.0832, 0.647223937175561, -88.2675, -1.54055849750409),
(18342, '42047', 218, 21, 2957, 37.3309, 0.651547117732751, -88.4029, -1.5429216733113),
(18343, '42048', 218, 21, 9325, 36.7926, 0.642152010369266, -88.2501, -1.54025481021425),
(18344, '42049', 218, 21, 36336, 36.5397, 0.637738072690972, -88.3405, -1.54183258785805),
(18345, '42050', 218, 21, 9453, 36.5688, 0.638245963503302, -89.1872, -1.55661029063469),
(18346, '42051', 218, 21, 3077, 36.8483, 0.643124158762627, -88.6653, -1.54750141726853),
(18347, '42053', 218, 21, 36711, 37.0987, 0.64749446320962, -88.8494, -1.55071456842145),
(18348, '42054', 218, 21, 36732, 36.6821, 0.640223421545812, -88.4268, -1.54333880700252),
(18349, '42055', 218, 21, 36771, 37.0585, 0.646792840850319, -88.1279, -1.53812201786831),
(18350, '42056', 218, 21, 36765, 37.1014, 0.647541587099424, -88.9717, -1.55284910609664),
(18351, '42058', 218, 21, 761, 37.0484, 0.646616562595867, -88.4916, -1.54446978035781),
(18352, '42060', 218, 21, 36983, 36.9685, 0.645222044523524, -88.831, -1.55039342783908),
(18353, '42061', 218, 21, 36993, 36.8904, 0.643858942377716, -88.7738, -1.54939509950694),
(18354, '42063', 218, 21, 27770, 36.56, 0.638092374529127, -88.5691, -1.54582241052811),
(18355, '42064', 218, 21, 630, 37.334, 0.651601222939563, -88.08, -1.53728600515661),
(18356, '42066', 218, 21, 10367, 36.7369, 0.641179861975905, -88.6409, -1.54707555693104),
(18357, '42069', 218, 21, 37155, 36.9484, 0.644871233343873, -88.7516, -1.549007636413),
(18358, '42070', 218, 21, 37195, 36.7982, 0.642249748807377, -88.9002, -1.55160119568146),
(18359, '42071', 218, 21, 10715, 36.6048, 0.63887428203402, -88.3201, -1.54147654069064),
(18360, '42076', 218, 21, 37395, 36.5962, 0.638724183718349, -88.0695, -1.53710274558515),
(18361, '42078', 218, 21, 126, 37.2402, 0.649964104101192, -88.2789, -1.54075746503882),
(18362, '42079', 218, 21, 38144, 36.5681, 0.638233746198538, -88.5851, -1.54610166320843),
(18363, '42081', 218, 21, 11999, 37.1423, 0.64825542676349, -88.4053, -1.54296356121334),
(18364, '42082', 218, 21, 38472, 36.9649, 0.645159212670452, -88.5102, -1.54479441159869),
(18365, '42083', 218, 21, 38543, 37.1655, 0.648660343149953, -88.2506, -1.54026353686051),
(18366, '42084', 218, 21, 12343, 37.4326, 0.653322117582029, -88.2452, -1.5401692890809),
(18367, '42085', 218, 21, 6647, 36.5733, 0.638324503319642, -88.7694, -1.54931830501985),
(18368, '42086', 218, 21, 38815, 37.0876, 0.647300731662649, -88.7691, -1.5493130690321),
(18369, '42087', 218, 21, 31529, 36.968, 0.645213317877264, -88.9811, -1.55301316704633),
(18370, '42088', 218, 21, 38918, 36.6167, 0.639081976215008, -88.7379, -1.54876852630548),
(18371, '42101', 218, 21, 15294, 37.0162, 0.646054566576725, -86.4617, -1.50904134187158),
(18372, '42102', 218, 21, 15294, 36.9525, 0.644942791843205, -86.4008, -1.50797843635712),
(18373, '42103', 218, 21, 15294, 36.9609, 0.645089399500372, -86.3721, -1.50747752686179),
(18374, '42104', 218, 21, 15294, 36.933, 0.644602452639066, -86.449, -1.50881968505658),
(18375, '42120', 218, 21, 34510, 36.6713, 0.640034925986597, -86.2758, -1.50579677479212),
(18376, '42122', 218, 21, 18830, 36.8679, 0.643466243296017, -86.3608, -1.50728030465632),
(18377, '42123', 218, 21, 7197, 36.8237, 0.642694807766636, -85.9914, -1.50083305839945),
(18378, '42124', 218, 21, 31761, 36.8652, 0.643419119406214, -85.6451, -1.4947889831998),
(18379, '42127', 218, 21, 7965, 37.1208, 0.647880180974311, -85.9182, -1.49955547738699),
(18380, '42128', 218, 21, 35626, 36.8359, 0.642907737935379, -86.4093, -1.50812678934354),
(18381, '42129', 218, 21, 35715, 36.9906, 0.645607762288214, -85.6128, -1.4942252418514),
(18382, '42130', 218, 21, 35721, 36.9238, 0.644441882347882, -85.7884, -1.4972900400179),
(18383, '42131', 218, 21, 35801, 36.8138, 0.642522020170688, -85.9109, -1.4994280683516),
(18384, '42133', 218, 21, 35968, 36.7045, 0.640614375298259, -85.9359, -1.4998644006646),
(18385, '42134', 218, 21, 2595, 36.7274, 0.641014055696965, -86.5758, -1.51103276254811),
(18386, '42135', 218, 21, 2595, 36.7129, 0.640760982955426, -86.5762, -1.51103974386511),
(18387, '42140', 218, 21, 9040, 36.6583, 0.639808033183837, -85.8147, -1.49774906161118),
(18388, '42141', 218, 21, 2722, 36.9766, 0.645363416192935, -85.9088, -1.4993914164373),
(18389, '42142', 218, 21, 2722, 36.9972, 0.645722954018846, -85.9081, -1.49937919913254),
(18390, '42150', 218, 21, 9292, 36.7953, 0.642199134259069, -86.296, -1.50614933130103),
(18391, '42151', 218, 21, 36386, 36.6644, 0.639914498268209, -85.5998, -1.49399834904864),
(18392, '42152', 218, 21, 36450, 37.0996, 0.647510171172888, -85.8151, -1.49775604292819),
(18393, '42153', 218, 21, 9533, 36.6722, 0.640050633949865, -86.0492, -1.5018418587071),
(18394, '42154', 218, 21, 36746, 37.0565, 0.646757934265279, -85.7198, -1.49609274415104),
(18395, '42156', 218, 21, 10220, 36.8433, 0.643036892300027, -86.0453, -1.50177379086628),
(18396, '42157', 218, 21, 37293, 36.8327, 0.642851887399315, -85.8468, -1.49830931230107),
(18397, '42159', 218, 21, 4710, 36.9978, 0.645733425994358, -86.2583, -1.50549134217302),
(18398, '42160', 218, 21, 4864, 37.0677, 0.646953411141502, -86.0579, -1.50199370235203),
(18399, '42163', 218, 21, 5486, 37.0679, 0.646956901800006, -86.1005, -1.50273721261338);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(18400, '42164', 218, 21, 5699, 36.7723, 0.641797708531111, -86.1818, -1.50415616529525),
(18401, '42166', 218, 21, 38437, 36.8988, 0.644005550034884, -85.6963, -1.49568259177682),
(18402, '42167', 218, 21, 6359, 36.7186, 0.64086046672279, -85.6995, -1.49573844231288),
(18403, '42170', 218, 21, 29018, 36.8406, 0.642989768410223, -86.6117, -1.51165933574957),
(18404, '42171', 218, 21, 38265, 37.0247, 0.646202919563145, -86.1847, -1.50420677984356),
(18405, '42201', 218, 21, 7017, 37.2543, 0.650210195525724, -86.6817, -1.51288106622597),
(18406, '42202', 218, 21, 34504, 36.6856, 0.640284508069632, -86.851, -1.5158359086496),
(18407, '42203', 218, 21, 34530, 36.889, 0.643834507768188, -87.2049, -1.5220126288724),
(18408, '42204', 218, 21, 29086, 36.7097, 0.640705132419362, -87.087, -1.5199548856843),
(18409, '42206', 218, 21, 13306, 36.8861, 0.64378389321988, -86.7229, -1.51360014187779),
(18410, '42207', 218, 21, 34727, 37.3012, 0.651028754944909, -86.2775, -1.50582644538941),
(18411, '42209', 218, 21, 1157, 37.3175, 0.651313243612984, -86.6255, -1.51190019118635),
(18412, '42210', 218, 21, 1191, 37.1969, 0.649208376535079, -86.2805, -1.50587880526697),
(18413, '42211', 218, 21, 26672, 36.8406, 0.642989768410223, -87.8596, -1.53343929948521),
(18414, '42214', 218, 21, 1440, 37.129, 0.648023297972975, -85.6882, -1.49554122010741),
(18415, '42215', 218, 21, 35203, 36.9926, 0.645642668873254, -87.6491, -1.52976538140976),
(18416, '42216', 218, 21, 1629, 36.9898, 0.645593799654199, -87.1449, -1.52096543132121),
(18417, '42217', 218, 21, 20372, 37.04, 0.6464699549387, -87.4906, -1.52699903454535),
(18418, '42219', 218, 21, 2127, 37.1645, 0.648642889857433, -86.7492, -1.51405916347107),
(18419, '42220', 218, 21, 15918, 36.8741, 0.643574453709641, -87.1772, -1.5215291726696),
(18420, '42221', 218, 21, 500, 36.8916, 0.64387988632874, -87.4858, -1.52691525874126),
(18421, '42223', 218, 21, 0, 36.6543, 0.639738220013758, -87.464, -1.52653477696432),
(18422, '42232', 218, 21, 808, 36.8691, 0.643487187247041, -87.6504, -1.52978807069004),
(18423, '42234', 218, 21, 29968, 36.6929, 0.640411917105027, -87.1778, -1.52153964464511),
(18424, '42235', 218, 21, 27352, 37.0601, 0.64682076611835, -86.6066, -1.51157032395772),
(18425, '42236', 218, 21, 9440, 36.7134, 0.640769709601686, -87.6015, -1.52893460468581),
(18426, '42240', 218, 21, 36498, 36.8689, 0.643483696588537, -87.4785, -1.52678784970586),
(18427, '42241', 218, 21, 36498, 36.8654, 0.643422610064718, -87.4885, -1.52696238263106),
(18428, '42251', 218, 21, 3297, 37.162, 0.648599256626133, -86.8832, -1.51639790466874),
(18429, '42252', 218, 21, 36626, 37.2364, 0.649897781589617, -86.5174, -1.51001349026494),
(18430, '42254', 218, 21, 36766, 36.6578, 0.639799306537577, -87.6505, -1.52978981601929),
(18431, '42256', 218, 21, 3750, 36.9782, 0.645391341460967, -86.9695, -1.51790412381321),
(18432, '42257', 218, 21, 36899, 37.2304, 0.649793061834497, -86.3198, -1.506564719663),
(18433, '42259', 218, 21, 37035, 37.2857, 0.65075822891085, -86.191, -1.50431673558643),
(18434, '42261', 218, 21, 17178, 37.2146, 0.649517299812682, -86.6787, -1.51282870634841),
(18435, '42262', 218, 21, 4662, 36.6788, 0.640165825680496, -87.4477, -1.52625028829625),
(18436, '42265', 218, 21, 10985, 36.7205, 0.640893627978578, -86.988, -1.51822700972483),
(18437, '42266', 218, 21, 17567, 36.7771, 0.641881484335207, -87.3635, -1.52478072106607),
(18438, '42267', 218, 21, 341, 37.2307, 0.649798297822253, -86.8104, -1.51512730497329),
(18439, '42270', 218, 21, 37918, 37.1051, 0.647606164281748, -86.4708, -1.50920016683351),
(18440, '42273', 218, 21, 28433, 37.2169, 0.649557442385478, -86.8691, -1.51615181324421),
(18441, '42274', 218, 21, 37977, 36.9518, 0.644930574538441, -86.5991, -1.51143942426382),
(18442, '42275', 218, 21, 5566, 37.1976, 0.649220593839843, -86.4544, -1.50891393283619),
(18443, '42276', 218, 21, 5585, 36.8553, 0.643246331810266, -86.8832, -1.51639790466874),
(18444, '42280', 218, 21, 38171, 36.9409, 0.644740333649973, -87.1059, -1.52028475291293),
(18445, '42283', 218, 21, 38300, 36.8759, 0.643605869636177, -86.6565, -1.51244124325447),
(18446, '42285', 218, 21, 38463, 37.262, 0.650344585878127, -86.281, -1.50588753191323),
(18447, '42286', 218, 21, 6381, 36.7282, 0.641028018330981, -87.2579, -1.52293765337596),
(18448, '42287', 218, 21, 38789, 37.2919, 0.650866439324473, -86.5081, -1.50985117464451),
(18449, '42288', 218, 21, 362, 37.1847, 0.648995446366335, -86.6341, -1.51205028950202),
(18450, '42301', 218, 21, 23697, 37.7481, 0.658828631372071, -87.1778, -1.52153964464511),
(18451, '42302', 218, 21, 23697, 37.7639, 0.659104393393887, -87.0464, -1.51924628200799),
(18452, '42303', 218, 21, 23697, 37.7583, 0.659006654955775, -87.0921, -1.52004389747615),
(18453, '42304', 218, 21, 23697, 37.7751, 0.65929987027011, -87.1661, -1.52133544112263),
(18454, '42320', 218, 21, 34718, 37.4092, 0.652913710537063, -86.877, -1.51628969425511),
(18455, '42321', 218, 21, 7360, 37.1844, 0.648990210378579, -87.1208, -1.52054480697148),
(18456, '42322', 218, 21, 296, 37.6151, 0.656507343466919, -87.3959, -1.52534620774371),
(18457, '42323', 218, 21, 34736, 37.1769, 0.64885931068468, -87.0507, -1.51932133116583),
(18458, '42324', 218, 21, 19183, 37.1436, 0.648278116043766, -86.9659, -1.51784129196014),
(18459, '42325', 218, 21, 1103, 37.3448, 0.651789718498778, -87.2511, -1.52281897098682),
(18460, '42326', 218, 21, 35011, 37.2735, 0.650545298742106, -87.0145, -1.51868952197661),
(18461, '42327', 218, 21, 1294, 37.5661, 0.655652132133442, -87.259, -1.52295685199773),
(18462, '42328', 218, 21, 35196, 37.4169, 0.653048100889466, -86.9963, -1.51837187205274),
(18463, '42330', 218, 21, 1465, 37.2935, 0.650894364592505, -87.1266, -1.52064603606809),
(18464, '42332', 218, 21, 35273, 37.2537, 0.650199723550212, -87.092, -1.5200421521469),
(18465, '42333', 218, 21, 1893, 37.3383, 0.651676272097399, -86.77, -1.51442219195548),
(18466, '42334', 218, 21, 35474, 37.7351, 0.658601738569312, -87.3309, -1.52421174372992),
(18467, '42337', 218, 21, 35627, 37.2158, 0.649538243763706, -87.0488, -1.51928816991004),
(18468, '42338', 218, 21, 2134, 37.5501, 0.655372879453123, -86.7667, -1.51436459609016),
(18469, '42339', 218, 21, 35665, 37.0805, 0.647176813285757, -86.9815, -1.51811356332345),
(18470, '42343', 218, 21, 35950, 37.6155, 0.656514324783927, -86.8194, -1.51528438460596),
(18471, '42344', 218, 21, 2802, 37.2427, 0.650007737332492, -87.2964, -1.52360960513798),
(18472, '42345', 218, 21, 2868, 37.2067, 0.649379418801774, -87.1805, -1.52158676853492),
(18473, '42347', 218, 21, 2998, 37.4526, 0.653671183432428, -86.9051, -1.51678013177492),
(18474, '42348', 218, 21, 36324, 37.7973, 0.659687333364053, -86.8506, -1.51582892733259),
(18475, '42349', 218, 21, 538, 37.4202, 0.653105696754782, -86.6092, -1.51161570251827),
(18476, '42350', 218, 21, 9673, 37.448, 0.653590898286837, -87.1689, -1.52138431034169),
(18477, '42351', 218, 21, 36867, 37.8596, 0.660774673488045, -86.9307, -1.51722693606343),
(18478, '42352', 218, 21, 36928, 37.4988, 0.65447752554685, -87.1254, -1.52062509211707),
(18479, '42354', 218, 21, 37130, 37.3811, 0.652423273017252, -86.9237, -1.5171047630158),
(18480, '42355', 218, 21, 37018, 37.8587, 0.660758965524777, -86.9849, -1.51817290451802),
(18481, '42356', 218, 21, 0, 37.6902, 0.657818085735167, -87.3235, -1.52408258936527),
(18482, '42361', 218, 21, 37501, 37.5082, 0.654641586496537, -86.7155, -1.51347098751314),
(18483, '42364', 218, 21, 37627, 37.7531, 0.658915897834671, -86.8125, -1.51516395688758),
(18484, '42365', 218, 21, 37637, 37.1172, 0.647817349121239, -86.9971, -1.51838583468676),
(18485, '42366', 218, 21, 37667, 37.7365, 0.65862617317884, -86.9422, -1.51742764892741),
(18486, '42367', 218, 21, 5198, 37.2066, 0.649377673472522, -87.1759, -1.52150648338932),
(18487, '42368', 218, 21, 0, 37.6989, 0.65796992938009, -86.7741, -1.51449375045481),
(18488, '42369', 218, 21, 11639, 37.2873, 0.650786154178882, -86.9361, -1.51732118384304),
(18489, '42370', 218, 21, 11691, 37.6656, 0.657388734739176, -86.8284, -1.51544146423864),
(18490, '42371', 218, 21, 38037, 37.5072, 0.654624133204017, -87.2833, -1.52338096700597),
(18491, '42372', 218, 21, 28490, 37.4213, 0.653124895376554, -87.2774, -1.5232779925801),
(18492, '42374', 218, 21, 38284, 37.3364, 0.651643110841611, -87.1401, -1.52088165551711),
(18493, '42375', 218, 21, 196, 37.823, 0.660135882981815, -87.2438, -1.52269156195143),
(18494, '42376', 218, 21, 31360, 37.6253, 0.656685367050623, -87.0757, -1.51975766347883),
(18495, '42377', 218, 21, 38814, 37.6965, 0.657928041478042, -87.2849, -1.523408892274),
(18496, '42378', 218, 21, 6796, 37.6808, 0.657654024785479, -86.8735, -1.51622860773129),
(18497, '42402', 218, 21, 34692, 37.8701, 0.660957933059505, -87.4616, -1.52649288906227),
(18498, '42403', 218, 21, 34843, 37.4587, 0.6537776485168, -87.9327, -1.53471513516842),
(18499, '42404', 218, 21, 1601, 37.4902, 0.654327427231178, -87.7904, -1.53223153164283),
(18500, '42406', 218, 21, 29558, 37.7315, 0.65853890671624, -87.6934, -1.5305385622684),
(18501, '42408', 218, 21, 35523, 37.2043, 0.649337530899726, -87.6767, -1.53024709228331),
(18502, '42409', 218, 21, 828, 37.5215, 0.654873715287052, -87.6821, -1.53034134006292),
(18503, '42410', 218, 21, 35678, 37.273, 0.650536572095846, -87.5123, -1.52737777099303),
(18504, '42411', 218, 21, 2600, 37.2156, 0.649534753105202, -87.9855, -1.53563666901347),
(18505, '42413', 218, 21, 2964, 37.439, 0.653433818654157, -87.4789, -1.52679483102287),
(18506, '42419', 218, 21, 23, 37.836, 0.660362775784574, -87.5904, -1.52874087313884),
(18507, '42420', 218, 21, 23, 37.8242, 0.660156826932839, -87.5559, -1.5281387345469),
(18508, '42431', 218, 21, 37022, 37.333, 0.651583769647043, -87.4973, -1.52711597160523),
(18509, '42436', 218, 21, 37040, 37.4146, 0.65300795831667, -87.5664, -1.52832199411836),
(18510, '42437', 218, 21, 37274, 37.6857, 0.657739545918827, -87.9139, -1.53438701326904),
(18511, '42440', 218, 21, 37281, 37.2379, 0.649923961528396, -87.4692, -1.52662553408542),
(18512, '42441', 218, 21, 677, 37.3525, 0.651924108851182, -87.6598, -1.52995213163973),
(18513, '42442', 218, 21, 28084, 37.1815, 0.648939595830272, -87.471, -1.52665695001196),
(18514, '42444', 218, 21, 37754, 37.6398, 0.656938439792162, -87.6444, -1.52968335093492),
(18515, '42445', 218, 21, 5231, 37.1101, 0.647693430744348, -87.8831, -1.53384945185943),
(18516, '42450', 218, 21, 966, 37.4011, 0.652772338867651, -87.7541, -1.53159797712436),
(18517, '42451', 218, 21, 11522, 37.8604, 0.660788636122061, -87.3784, -1.52504077512461),
(18518, '42452', 218, 21, 37955, 37.6905, 0.657823321722923, -87.551, -1.52805321341356),
(18519, '42453', 218, 21, 11748, 37.1651, 0.648653361832945, -87.5827, -1.52860648278644),
(18520, '42455', 218, 21, 38141, 37.6079, 0.656381679760775, -87.5315, -1.52771287420942),
(18521, '42456', 218, 21, 5898, 37.5042, 0.654571773326457, -87.4438, -1.52618222045542),
(18522, '42457', 218, 21, 38261, 37.8092, 0.65989502754504, -87.7688, -1.5318545405244),
(18523, '42458', 218, 21, 38327, 37.8543, 0.66068217103769, -87.4277, -1.52590122244585),
(18524, '42459', 218, 21, 38425, 37.5483, 0.655341463526587, -87.9841, -1.53561223440394),
(18525, '42460', 218, 21, 28723, 37.4972, 0.654449600278818, -87.9458, -1.53494377330043),
(18526, '42461', 218, 21, 6475, 37.7773, 0.659338267513654, -87.8108, -1.53258757881024),
(18527, '42462', 218, 21, 6664, 37.8023, 0.659774599826652, -87.773, -1.53192784435298),
(18528, '42463', 218, 21, 38832, 37.4889, 0.654304737950902, -87.8612, -1.53346722475324),
(18529, '42464', 218, 21, 6780, 37.1909, 0.649103656779959, -87.3954, -1.52533748109745),
(18530, '42501', 218, 21, 5946, 37.0927, 0.647389743454501, -84.5709, -1.47604065637487),
(18531, '42502', 218, 21, 5946, 37.0945, 0.647421159381037, -84.6041, -1.47662010568653),
(18532, '42503', 218, 21, 5946, 37.0823, 0.647208229212293, -84.6097, -1.47671784412465),
(18533, '42516', 218, 21, 34791, 37.1483, 0.64836014651861, -84.7183, -1.47861327169231),
(18534, '42518', 218, 21, 35003, 36.9663, 0.64518364727998, -84.628, -1.47703723937776),
(18535, '42519', 218, 21, 19652, 36.9679, 0.645211572548012, -84.5739, -1.47609301625243),
(18536, '42528', 218, 21, 35666, 37.1721, 0.648775534880584, -85.0789, -1.484906928975),
(18537, '42533', 218, 21, 2432, 37.0695, 0.646984827068038, -84.5994, -1.47653807521169),
(18538, '42539', 218, 21, 3751, 37.3515, 0.651906655558662, -84.946, -1.4825873863991),
(18539, '42541', 218, 21, 17130, 37.3742, 0.652302845298865, -84.8372, -1.48068846817293),
(18540, '42544', 218, 21, 37350, 37.0524, 0.646686375765947, -84.7615, -1.47936725392917),
(18541, '42553', 218, 21, 38126, 37.1723, 0.648779025539088, -84.6466, -1.47736187061863),
(18542, '42558', 218, 21, 38490, 36.9477, 0.644859016039109, -84.5748, -1.4761087242157),
(18543, '42564', 218, 21, 153698, 37.0877, 0.647302476991901, -84.601, -1.47656600047972),
(18544, '42565', 218, 21, 18652, 37.1787, 0.648890726611216, -84.9152, -1.48204982498949),
(18545, '42566', 218, 21, 39000, 37.3228, 0.65140574606334, -84.9269, -1.48225402851197),
(18546, '42567', 218, 21, 35803, 37.2614, 0.650334113902615, -84.5988, -1.47652760323618),
(18547, '42602', 218, 21, 18772, 36.6929, 0.640411917105027, -85.1328, -1.48584766144183),
(18548, '42603', 218, 21, 7072, 36.7809, 0.641947806846782, -85.0851, -1.48501513938863),
(18549, '42629', 218, 21, 3399, 36.975, 0.645335490924903, -85.0949, -1.48518618165532),
(18550, '42631', 218, 21, 37070, 36.7441, 0.641305525682048, -84.4806, -1.47446462406032),
(18551, '42632', 218, 21, 37199, 36.9324, 0.644591980663554, -84.7791, -1.47967443187752),
(18552, '42633', 218, 21, 588, 36.8367, 0.642921700569395, -84.847, -1.48085951043963),
(18553, '42634', 218, 21, 0, 36.8484, 0.643125904091879, -84.4511, -1.47394975193098),
(18554, '42635', 218, 21, 11209, 36.65, 0.639663170855922, -84.3975, -1.47301425545191),
(18555, '42638', 218, 21, 37900, 36.6722, 0.640050633949865, -84.4714, -1.47430405376914),
(18556, '42642', 218, 21, 38044, 37.0583, 0.646789350191815, -85.0916, -1.48512858579001),
(18557, '42647', 218, 21, 38370, 36.6815, 0.6402129495703, -84.617, -1.47684525316004),
(18558, '42649', 218, 21, 38421, 36.6097, 0.638959803167368, -84.4305, -1.47359021410507),
(18559, '42653', 218, 21, 38869, 36.7216, 0.64091282660035, -84.4679, -1.47424296724532),
(18560, '42701', 218, 21, 27070, 37.7055, 0.658085121110722, -85.8623, -1.49857983833513),
(18561, '42702', 218, 21, 27070, 37.6933, 0.657872190941979, -85.8593, -1.49852747845757),
(18562, '42711', 218, 21, 34644, 36.8734, 0.643562236404877, -85.3047, -1.48884788242601),
(18563, '42712', 218, 21, 34807, 37.5108, 0.654686965057089, -86.1462, -1.50353482808154),
(18564, '42713', 218, 21, 34913, 37.3746, 0.652309826615873, -85.8899, -1.49906154920868),
(18565, '42715', 218, 21, 34972, 36.9563, 0.64500911435478, -85.3915, -1.49036282821674),
(18566, '42716', 218, 21, 26642, 37.4942, 0.654397240401258, -85.6754, -1.49531781796315),
(18567, '42717', 218, 21, 35067, 36.8071, 0.642405083110805, -85.3914, -1.49036108288749),
(18568, '42718', 218, 21, 35120, 37.3492, 0.651866512985866, -85.3587, -1.48979036022208),
(18569, '42719', 218, 21, 35120, 37.3418, 0.651737358621219, -85.3433, -1.48952157951728),
(18570, '42720', 218, 21, 35125, 37.1714, 0.64876331757582, -85.3238, -1.48918124031314),
(18571, '42721', 218, 21, 35127, 37.4266, 0.65321739782691, -86.4902, -1.5095387607084),
(18572, '42722', 218, 21, 35128, 37.2703, 0.650489448206043, -85.7167, -1.49603863894422),
(18573, '42724', 218, 21, 35181, 37.6712, 0.657486473177288, -86.026, -1.50143694232064),
(18574, '42726', 218, 21, 35257, 37.4144, 0.653004467658166, -86.158, -1.50374077693327),
(18575, '42728', 218, 21, 1716, 37.1078, 0.647653288171552, -85.2802, -1.48842027675927),
(18576, '42729', 218, 21, 35459, 37.2984, 0.650979885725853, -86.0609, -1.50204606222959),
(18577, '42731', 218, 21, 35645, 36.8399, 0.642977551105459, -85.5457, -1.49305412592331),
(18578, '42732', 218, 21, 8673, 37.6088, 0.656397387724043, -86.114, -1.5029728320624),
(18579, '42733', 218, 21, 35734, 37.3316, 0.651559335037515, -85.199, -1.48700306940665),
(18580, '42735', 218, 21, 20999, 37.0563, 0.646754443606775, -85.2937, -1.48865589620829),
(18581, '42740', 218, 21, 2741, 37.5944, 0.656146060311756, -85.9411, -1.4999551577857),
(18582, '42741', 218, 21, 36112, 36.9999, 0.64577007790865, -85.2469, -1.48783908211835),
(18583, '42742', 218, 21, 36151, 37.0481, 0.646611326608111, -85.4366, -1.49114997170939),
(18584, '42743', 218, 21, 29951, 37.2438, 0.650026935954264, -85.5104, -1.49243802469736),
(18585, '42746', 218, 21, 36293, 37.2214, 0.649635982201817, -85.7479, -1.49658318167085),
(18586, '42748', 218, 21, 36461, 37.5635, 0.65560675357289, -85.7293, -1.49625855042997),
(18587, '42749', 218, 21, 36503, 37.1821, 0.648950067805784, -85.8801, -1.49889050694198),
(18588, '42753', 218, 21, 36744, 37.2361, 0.649892545601861, -85.1687, -1.48647423464329),
(18589, '42754', 218, 21, 36845, 37.4752, 0.654065627843379, -86.2982, -1.50618772854457),
(18590, '42755', 218, 21, 36845, 37.4802, 0.654152894305979, -86.2937, -1.50610918872823),
(18591, '42757', 218, 21, 3947, 37.3771, 0.652353459847173, -85.7314, -1.49629520234427),
(18592, '42758', 218, 21, 37044, 37.3415, 0.651732122633463, -85.3429, -1.48951459820027),
(18593, '42759', 218, 21, 37063, 36.832, 0.642839670094551, -85.5127, -1.49247816727016),
(18594, '42761', 218, 21, 602, 37.109, 0.647674232122576, -85.4637, -1.49162295593668),
(18595, '42762', 218, 21, 624, 37.4407, 0.653463489251441, -86.41, -1.5081390066483),
(18596, '42764', 218, 21, 10659, 37.4155, 0.653023666279938, -85.6317, -1.49455510908003),
(18597, '42765', 218, 21, 37336, 37.2969, 0.650953705787073, -85.9192, -1.49957293067951),
(18598, '42776', 218, 21, 12023, 37.5303, 0.655027304261228, -85.9337, -1.49982600342105),
(18599, '42782', 218, 21, 28728, 37.337, 0.651653582817123, -85.7005, -1.4957558956054),
(18600, '42783', 218, 21, 6151, 37.5936, 0.65613209767774, -86.0546, -1.50193610648671),
(18601, '42784', 218, 21, 6489, 37.4688, 0.653953926771251, -85.9254, -1.49968114109314),
(18602, '42786', 218, 21, 38765, 36.817, 0.642577870706752, -85.4506, -1.49139431780467),
(18603, '42788', 218, 21, 38852, 37.5412, 0.655217545149695, -86.0337, -1.50157133267305),
(18604, '43001', 218, 41, 34524, 40.0924, 0.699744385026575, -82.6078, -1.44177809782897),
(18605, '43002', 218, 41, 154066, 40.0787, 0.699505274919051, -83.1706, -1.4516008108592),
(18606, '43003', 218, 41, 13302, 40.403, 0.705165377683269, -82.9691, -1.44808397241643),
(18607, '43004', 218, 41, 71833, 40.0113, 0.698328923003207, -82.8098, -1.445303662918),
(18608, '43005', 218, 41, 44866, 40.291, 0.703210608921035, -82.2905, -1.43624016811239),
(18609, '43006', 218, 41, 154462, 40.4716, 0.706362673550137, -82.19, -1.43448611221414),
(18610, '43007', 218, 41, 34998, 40.3414, 0.70409025486404, -83.4129, -1.45582974363678),
(18611, '43008', 218, 41, 71948, 39.9349, 0.696995491454684, -82.4748, -1.43945680992382),
(18612, '43009', 218, 41, 118998, 40.1734, 0.70115810172069, -83.646, -1.45989810612318),
(18613, '43010', 218, 41, 15461, 40, 0.698131700797732, -83.6224, -1.45948620841971),
(18614, '43011', 218, 41, 154657, 40.3099, 0.703540476149662, -82.6711, -1.44288289124548),
(18615, '43013', 218, 41, 115164, 40.2348, 0.702229733881415, -82.6914, -1.44323719308364),
(18616, '43014', 218, 41, 1964, 40.4653, 0.706252717807261, -82.261, -1.43572529598306),
(18617, '43015', 218, 41, 8461, 40.2944, 0.703269950115603, -83.0684, -1.44981708436366),
(18618, '43016', 218, 41, 2113, 40.0996, 0.699870048732718, -83.1139, -1.45061120917332),
(18619, '43017', 218, 41, 2113, 40.1016, 0.699904955317758, -83.1151, -1.45063215312434),
(18620, '43018', 218, 41, 314, 39.9587, 0.697410879816658, -82.6819, -1.4430713868047),
(18621, '43019', 218, 41, 35990, 40.4912, 0.706704758083528, -82.5317, -1.4404499022682),
(18622, '43021', 218, 41, 9031, 40.1925, 0.701491459607821, -82.8973, -1.4468308260135),
(18623, '43022', 218, 41, 155396, 40.3485, 0.704214173240932, -82.3485, -1.43725245907855),
(18624, '43023', 218, 41, 55048, 40.0693, 0.699341213969364, -82.5264, -1.44035739981785),
(18625, '43025', 218, 41, 940, 39.9611, 0.697452767718706, -82.4999, -1.43989488756607),
(18626, '43026', 218, 41, 3140, 40.0324, 0.698697187475378, -83.1382, -1.45103532418155),
(18627, '43027', 218, 41, 22029, 40.2428, 0.702369360221574, -82.5197, -1.44024046275796),
(18628, '43028', 218, 41, 3251, 40.4198, 0.705458592997604, -82.321, -1.43677249353425),
(18629, '43029', 218, 41, 36581, 40.0897, 0.699697261136771, -83.4541, -1.4565488192886),
(18630, '43030', 218, 41, 65924, 39.9604, 0.697440550413942, -82.4143, -1.43840088572636),
(18631, '43031', 218, 41, 3440, 40.1612, 0.700945171551947, -82.6565, -1.44262807317469),
(18632, '43032', 218, 41, 41600, 40.3299, 0.703889542000061, -82.9579, -1.4478884955402),
(18633, '43033', 218, 41, 73126, 39.9602, 0.697437059755438, -82.6056, -1.44173970058543),
(18634, '43035', 218, 41, 156124, 40.181, 0.701290746743842, -83.0102, -1.448801302739),
(18635, '43036', 218, 41, 30405, 40.3527, 0.704287477069516, -83.2638, -1.45322745772205),
(18636, '43037', 218, 41, 27815, 40.2728, 0.702892958997172, -82.3352, -1.43702033028804),
(18637, '43040', 218, 41, 10343, 40.2579, 0.702632904938625, -83.3728, -1.45512986660673),
(18638, '43041', 218, 41, 10343, 40.236, 0.702250677832438, -83.3677, -1.45504085481488),
(18639, '43044', 218, 41, 27864, 40.065, 0.699266164811528, -83.5813, -1.45876887809714),
(18640, '43045', 218, 41, 150737, 40.1775, 0.701229660220022, -83.4439, -1.4563707957049),
(18641, '43046', 218, 41, 30516, 39.8979, 0.696349719631446, -82.5272, -1.44037136245186),
(18642, '43047', 218, 41, 56294, 40.2063, 0.701732315044596, -83.643, -1.45984574624562),
(18643, '43048', 218, 41, 30581, 40.3472, 0.704191483960656, -82.629, -1.44214810763039),
(18644, '43050', 218, 41, 4411, 40.3847, 0.704845982430154, -82.4837, -1.43961214422725),
(18645, '43054', 218, 41, 30614, 40.0851, 0.699616975991179, -82.8113, -1.44532984285678),
(18646, '43055', 218, 41, 10792, 40.0753, 0.699445933724483, -82.3876, -1.43793488281608),
(18647, '43056', 218, 41, 3039, 40.0171, 0.698430152099823, -82.3578, -1.43741477469899),
(18648, '43058', 218, 41, 10792, 40.0598, 0.699175407690425, -82.4008, -1.43816526627734),
(18649, '43060', 218, 41, 156822, 40.216, 0.70190161198204, -83.5693, -1.4585594385869),
(18650, '43061', 218, 41, 137328, 40.2853, 0.703111125153672, -83.2035, -1.4521750241831),
(18651, '43062', 218, 41, 73842, 40.0024, 0.69817358869978, -82.6759, -1.44296666704958),
(18652, '43064', 218, 41, 157160, 40.0809, 0.699543672162595, -83.2837, -1.4535747782432),
(18653, '43065', 218, 41, 5200, 40.1314, 0.700425063434852, -83.0749, -1.44993053076504),
(18654, '43066', 218, 41, 90185, 40.3985, 0.705086837866929, -83.1615, -1.45144198589726),
(18655, '43067', 218, 41, 24225, 40.3497, 0.704235117191956, -83.4641, -1.4567233522138),
(18656, '43068', 218, 41, 28397, 39.9536, 0.697321868024806, -82.8084, -1.44527922830847),
(18657, '43070', 218, 41, 17857, 40.218, 0.70193651856708, -83.9579, -1.46534178806015),
(18658, '43071', 218, 41, 157497, 40.1758, 0.701199989622738, -82.363, -1.43750553182009),
(18659, '43072', 218, 41, 157501, 40.1282, 0.700369212898789, -83.9569, -1.46532433476763),
(18660, '43073', 218, 41, 74469, 39.9993, 0.698119483492968, -82.7513, -1.44428264530558),
(18661, '43074', 218, 41, 25240, 40.2672, 0.702795220559061, -82.8426, -1.44587613091265),
(18662, '43076', 218, 41, 74541, 39.875, 0.695950039232739, -82.3604, -1.43746015325954),
(18663, '43077', 218, 41, 158053, 40.1361, 0.700507093909696, -83.3417, -1.45458706920936),
(18664, '43078', 218, 41, 12500, 40.1128, 0.700100432193981, -83.767, -1.46200995451809),
(18665, '43080', 218, 41, 31360, 40.2331, 0.702200063284131, -82.4553, -1.43911647071968),
(18666, '43081', 218, 41, 143375, 40.1097, 0.70004632698717, -82.9073, -1.44700535893869),
(18667, '43082', 218, 41, 143375, 40.1192, 0.700212133266109, -82.9291, -1.44738584071563),
(18668, '43083', 218, 41, 12776, 40.1092, 0.70003760034091, -83.838, -1.46324913828701),
(18669, '43084', 218, 41, 569, 40.1631, 0.700978332807735, -83.5429, -1.45809867166437),
(18670, '43085', 218, 41, 1718, 40.1009, 0.699892738012994, -83.0357, -1.44924636169826),
(18671, '43086', 218, 41, 143375, 40.1215, 0.700252275838905, -82.9176, -1.44718512785165),
(18672, '43093', 218, 41, 10792, 40.058, 0.699143991763889, -82.4555, -1.43911996137818),
(18673, '43098', 218, 41, 940, 39.9621, 0.697470221011226, -82.4917, -1.43975177056741),
(18674, '43101', 218, 41, 44287, 39.4662, 0.688815133250586, -82.7484, -1.44423203075728),
(18675, '43102', 218, 41, 53174, 39.6414, 0.69187295010008, -82.7606, -1.44444496092602),
(18676, '43103', 218, 41, 15040, 39.7225, 0.693288412123448, -82.9446, -1.44765636674969),
(18677, '43105', 218, 41, 34657, 39.8592, 0.695674277210924, -82.618, -1.44195612141268),
(18678, '43106', 218, 41, 71849, 39.6351, 0.691762994357205, -83.4031, -1.45565870137008),
(18679, '43107', 218, 41, 1103, 39.6991, 0.692880005078481, -82.4214, -1.43852480410325),
(18680, '43109', 218, 41, 1124, 39.917, 0.696683077518577, -82.8314, -1.44568065403643),
(18681, '43110', 218, 41, 72004, 39.8726, 0.695908151330691, -82.8228, -1.44553055572076),
(18682, '43111', 218, 41, 1351, 39.4999, 0.689403309208508, -82.2371, -1.43530816229183),
(18683, '43112', 218, 41, 39663, 39.8021, 0.694677694208035, -82.7089, -1.44354262570274),
(18684, '43113', 218, 41, 29475, 39.5968, 0.691094533253691, -82.9351, -1.44749056047075),
(18685, '43115', 218, 41, 26799, 39.4909, 0.689246229575829, -83.1612, -1.45143674990951),
(18686, '43116', 218, 41, 72185, 39.7713, 0.694140132798421, -83.06, -1.44967047670649),
(18687, '43117', 218, 41, 2031, 39.7647, 0.694024941067789, -83.2075, -1.45224483735318),
(18688, '43119', 218, 41, 9041, 39.9382, 0.697053087319999, -83.1791, -1.45174916384562),
(18689, '43123', 218, 41, 16293, 39.8818, 0.696068721621875, -83.0884, -1.45016615021406),
(18690, '43125', 218, 41, 72772, 39.8599, 0.695686494515688, -82.8929, -1.44675403152641),
(18691, '43126', 218, 41, 2994, 39.8121, 0.694852227133234, -83.1711, -1.45160953750546),
(18692, '43127', 218, 41, 72861, 39.4721, 0.688918107676454, -82.3152, -1.43667126443764),
(18693, '43128', 218, 41, 9742, 39.6588, 0.692176637389927, -83.5746, -1.45865194103725),
(18694, '43130', 218, 41, 16841, 39.7128, 0.693119115186004, -82.6041, -1.44171352064665),
(18695, '43135', 218, 41, 73168, 39.4765, 0.688994902163542, -82.6824, -1.44308011345096),
(18696, '43136', 218, 41, 73247, 39.8043, 0.694716091451579, -82.8082, -1.44527573764997),
(18697, '43137', 218, 41, 73255, 39.8319, 0.695197802325129, -82.9791, -1.44825850534163),
(18698, '43138', 218, 41, 3843, 39.5249, 0.689839641521507, -82.4155, -1.43842182967739),
(18699, '43140', 218, 41, 3852, 39.9009, 0.696402079509005, -83.4408, -1.45631669049808),
(18700, '43142', 218, 41, 23097, 39.5936, 0.691038682717627, -83.5879, -1.45888406982777),
(18701, '43143', 218, 41, 4408, 39.7391, 0.693578136779279, -83.3082, -1.45400238390994),
(18702, '43144', 218, 41, 73612, 39.5158, 0.689680816559575, -82.1671, -1.43408643181543),
(18703, '43145', 218, 41, 23337, 39.5608, 0.690466214722973, -83.2319, -1.45267069769067),
(18704, '43146', 218, 41, 28156, 39.7712, 0.694138387469169, -83.146, -1.45117145986321),
(18705, '43147', 218, 41, 73886, 39.9026, 0.696431750106289, -82.7521, -1.4442966079396),
(18706, '43148', 218, 41, 14431, 39.8174, 0.69494472958359, -82.5044, -1.43997342738241),
(18707, '43149', 218, 41, 24458, 39.5397, 0.690097950250802, -82.5684, -1.44109043810369),
(18708, '43150', 218, 41, 31020, 39.7766, 0.694232635248777, -82.4361, -1.4387813675033),
(18709, '43151', 218, 41, 38144, 39.7287, 0.693396622537071, -83.4742, -1.45689963046825),
(18710, '43152', 218, 41, 74345, 39.4023, 0.687699867858562, -82.6229, -1.44204164254602),
(18711, '43153', 218, 41, 112487, 39.7389, 0.693574646120775, -83.5663, -1.45850707870934),
(18712, '43154', 218, 41, 57752, 39.6012, 0.691171327740778, -82.8176, -1.44543979859966),
(18713, '43155', 218, 41, 12174, 39.6311, 0.691693181187125, -82.5348, -1.44050400747502),
(18714, '43156', 218, 41, 74514, 39.5566, 0.690392910894389, -82.7754, -1.44470326965531),
(18715, '43157', 218, 41, 6335, 39.8426, 0.695384552555093, -82.5443, -1.44066981375396),
(18716, '43158', 218, 41, 74592, 39.451, 0.688549843204283, -82.3636, -1.4375160037956),
(18717, '43160', 218, 41, 74699, 39.5356, 0.69002639175147, -83.4441, -1.4563742863634),
(18718, '43162', 218, 41, 6719, 39.9433, 0.697142099111851, -83.2916, -1.45371265925411),
(18719, '43163', 218, 41, 74780, 39.7626, 0.693988289153497, -82.4499, -1.43902222294007),
(18720, '43164', 218, 41, 38893, 39.5983, 0.691120713192471, -83.1199, -1.45071592892843),
(18721, '43195', 218, 41, 72772, 39.8527, 0.695560830809544, -82.8853, -1.44662138650326),
(18722, '43196', 218, 41, 72772, 39.8532, 0.695569557455804, -82.8916, -1.44673134224613),
(18723, '43198', 218, 41, 72772, 39.8321, 0.695201292983633, -82.9268, -1.44734569814283),
(18724, '43199', 218, 41, 72772, 39.8618, 0.695719655771476, -82.8976, -1.44683606200125),
(18725, '43201', 218, 41, 1718, 39.9913, 0.697979857152808, -83.0005, -1.44863200580155),
(18726, '43202', 218, 41, 1718, 40.0204, 0.698487747965139, -83.0125, -1.44884144531179),
(18727, '43203', 218, 41, 1718, 39.9724, 0.697649989924181, -82.9701, -1.44810142570895),
(18728, '43204', 218, 41, 1718, 39.9554, 0.697353283951342, -83.0828, -1.45006841177595),
(18729, '43205', 218, 41, 1718, 39.9579, 0.697396917182642, -82.9639, -1.44799321529532),
(18730, '43206', 218, 41, 1718, 39.9443, 0.697159552404371, -82.9783, -1.44824454270761),
(18731, '43207', 218, 41, 1718, 39.9008, 0.696400334179753, -82.9671, -1.44804906583139),
(18732, '43209', 218, 41, 1718, 39.9581, 0.697400407841146, -82.9295, -1.44739282203264),
(18733, '43210', 218, 41, 1718, 40.0046, 0.698211985943324, -83.0206, -1.4489828169812),
(18734, '43211', 218, 41, 1718, 40.0117, 0.698335904320215, -82.9696, -1.44809269906269),
(18735, '43212', 218, 41, 1718, 39.9874, 0.697911789311981, -83.0435, -1.44938249737991),
(18736, '43213', 218, 41, 1718, 39.9677, 0.697567959449338, -82.8734, -1.44641369232227),
(18737, '43214', 218, 41, 1718, 40.053, 0.699056725301289, -83.0233, -1.44902994087101),
(18738, '43215', 218, 41, 1718, 39.9643, 0.69750861825477, -83.0029, -1.4486738937036),
(18739, '43216', 218, 41, 1718, 39.974, 0.697677915192213, -82.8975, -1.446834316672),
(18740, '43217', 218, 41, 1718, 39.8256, 0.695087846582254, -82.9455, -1.44767207471296),
(18741, '43218', 218, 41, 1718, 39.9662, 0.697541779510558, -83.0131, -1.4488519172873),
(18742, '43219', 218, 41, 1718, 40.004, 0.698201513967812, -82.9317, -1.44743121927618),
(18743, '43220', 218, 41, 1718, 40.0497, 0.698999129435973, -83.0723, -1.44988515220449),
(18744, '43221', 218, 41, 1718, 40.0167, 0.698423170782815, -83.0668, -1.44978915909563),
(18745, '43222', 218, 41, 1718, 39.9586, 0.697409134487406, -83.0287, -1.44912418865062),
(18746, '43223', 218, 41, 1718, 39.9371, 0.697033888698227, -83.0429, -1.4493720254044),
(18747, '43224', 218, 41, 1718, 40.041, 0.698847285791049, -82.966, -1.44802986720962),
(18748, '43226', 218, 41, 1718, 39.9807, 0.697794852252097, -83.1643, -1.45149085511632),
(18749, '43227', 218, 41, 1718, 39.94, 0.697084503246535, -82.8888, -1.44668247302708),
(18750, '43228', 218, 41, 1718, 39.9516, 0.697286961439767, -83.1242, -1.45079097808627),
(18751, '43229', 218, 41, 1718, 40.0822, 0.699566361442871, -82.9753, -1.44819218283005),
(18752, '43230', 218, 41, 1718, 40.0461, 0.698936297582901, -82.8578, -1.44614142095896),
(18753, '43231', 218, 41, 1718, 40.0792, 0.699514001565311, -82.9407, -1.44758829890886),
(18754, '43232', 218, 41, 1718, 39.9145, 0.696639444287277, -82.8755, -1.44645034423656),
(18755, '43234', 218, 41, 1718, 40.1023, 0.699917172622522, -83.0566, -1.44961113551192),
(18756, '43235', 218, 41, 1718, 40.1028, 0.699925899268782, -83.0582, -1.44963906077995),
(18757, '43236', 218, 41, 1718, 40.0014, 0.69815613540726, -82.8883, -1.44667374638082),
(18758, '43240', 218, 41, 1718, 40.1017, 0.69990670064701, -83.056, -1.44960066353641),
(18759, '43251', 218, 41, 1718, 39.9605, 0.697442295743194, -83.0217, -1.44900201560298),
(18760, '43260', 218, 41, 1718, 39.9619, 0.697466730352722, -83.0016, -1.44865120442333),
(18761, '43265', 218, 41, 1718, 39.9604, 0.697440550413942, -83.0218, -1.44900376093223),
(18762, '43266', 218, 41, 1718, 40.0572, 0.699130029129873, -82.9651, -1.44801415924635),
(18763, '43268', 218, 41, 1718, 39.9636, 0.697496400950006, -82.9935, -1.44850983275391),
(18764, '43270', 218, 41, 1718, 39.963, 0.697485928974494, -83.0003, -1.44862851514305),
(18765, '43271', 218, 41, 1718, 39.9677, 0.697567959449338, -83.0269, -1.44909277272408),
(18766, '43272', 218, 41, 1718, 39.9622, 0.697471966340478, -83.0031, -1.44867738436211),
(18767, '43279', 218, 41, 1718, 39.9683, 0.69757843142485, -83.0274, -1.44910149937034),
(18768, '43287', 218, 41, 1718, 39.9618, 0.69746498502347, -83.0011, -1.44864247777707),
(18769, '43291', 218, 41, 1718, 39.9758, 0.697709331118749, -82.8586, -1.44615538359297),
(18770, '43299', 218, 41, 1718, 40.0399, 0.698828087169278, -82.8694, -1.44634387915219),
(18771, '43301', 218, 41, 630, 40.5643, 0.707980593766736, -83.1243, -1.45079272341552),
(18772, '43302', 218, 41, 630, 40.5855, 0.708350603568159, -83.1259, -1.45082064868355),
(18773, '43306', 218, 41, 630, 40.6091, 0.708762501271629, -83.1612, -1.45143674990951),
(18774, '43307', 218, 41, 630, 40.6093, 0.708765991930133, -83.161, -1.451433259251),
(18775, '43310', 218, 41, 53405, 40.5079, 0.706996228068611, -83.7908, -1.46242534288006),
(18776, '43311', 218, 41, 251, 40.36, 0.704414886104911, -83.7551, -1.4618022603371),
(18777, '43314', 218, 41, 1296, 40.6344, 0.709204069572384, -82.9678, -1.44806128313615),
(18778, '43315', 218, 41, 77970, 40.4839, 0.706577349048132, -82.8634, -1.44623915939707),
(18779, '43316', 218, 41, 1354, 40.9445, 0.714616335582818, -83.3848, -1.45533930611697),
(18780, '43317', 218, 41, 26776, 40.4785, 0.706483101268525, -82.6829, -1.44308884009722),
(18781, '43318', 218, 41, 32210, 40.3303, 0.703896523317069, -83.917, -1.46462794839608),
(18782, '43319', 218, 41, 93883, 40.3075, 0.703498588247614, -83.5822, -1.4587845860604),
(18783, '43320', 218, 41, 15893, 40.5772, 0.708205741240243, -82.8831, -1.44658298925971),
(18784, '43321', 218, 41, 2628, 40.4625, 0.706203848588206, -82.8277, -1.44561607685411),
(18785, '43322', 218, 41, 155529, 40.5345, 0.707460485649641, -83.2157, -1.45238795435185),
(18786, '43323', 218, 41, 119936, 40.7412, 0.711068081213514, -83.2361, -1.45274400151925),
(18787, '43324', 218, 41, 3297, 40.4462, 0.70591935992013, -83.8103, -1.4627656820842),
(18788, '43325', 218, 41, 36547, 40.6646, 0.709731159006486, -82.8427, -1.44587787624191),
(18789, '43326', 218, 41, 14041, 40.6447, 0.709383838485339, -83.6071, -1.45921917304415),
(18790, '43330', 218, 41, 9881, 40.8122, 0.71230726498243, -83.4208, -1.45596762464769),
(18791, '43331', 218, 41, 3619, 40.496, 0.706788533887624, -83.9068, -1.46444992481238),
(18792, '43332', 218, 41, 27650, 40.5762, 0.708188287947723, -83.365, -1.45499373092507),
(18793, '43333', 218, 41, 36868, 40.4372, 0.705762280287451, -83.9176, -1.46463842037159),
(18794, '43334', 218, 41, 3989, 40.3989, 0.705093819183937, -82.8086, -1.44528271896698),
(18795, '43335', 218, 41, 17036, 40.6675, 0.709781773554794, -82.9098, -1.44704899216999),
(18796, '43336', 218, 41, 17130, 40.2935, 0.703254242152335, -83.5834, -1.45880553001143),
(18797, '43337', 218, 41, 156612, 40.6765, 0.709938853187473, -83.252, -1.45302150887032),
(18798, '43338', 218, 41, 4369, 40.5609, 0.707921252572168, -82.7823, -1.4448236973737),
(18799, '43340', 218, 41, 37310, 40.5508, 0.707744974317717, -83.4982, -1.45731850948873),
(18800, '43341', 218, 41, 156702, 40.591, 0.708446596677018, -83.3178, -1.45416993551813),
(18801, '43342', 218, 41, 5238, 40.4719, 0.706367909537893, -83.1762, -1.45169854929731),
(18802, '43343', 218, 41, 17745, 40.3165, 0.703655667880294, -83.977, -1.46567514594728),
(18803, '43344', 218, 41, 24311, 40.4316, 0.705664541849339, -83.3391, -1.45454169064881),
(18804, '43345', 218, 41, 11587, 40.5287, 0.707359256553026, -83.5841, -1.45881774731619),
(18805, '43346', 218, 41, 157450, 40.5679, 0.708043425619808, -83.8423, -1.46332418744484),
(18806, '43347', 218, 41, 157471, 40.4687, 0.706312059001829, -83.6663, -1.46025240796133),
(18807, '43348', 218, 41, 157475, 40.4698, 0.706331257623601, -83.8824, -1.46402406447489),
(18808, '43349', 218, 41, 157613, 40.6209, 0.708968450123365, -82.6649, -1.44277468083186),
(18809, '43350', 218, 41, 25003, 40.3545, 0.704318892996052, -82.7097, -1.44355658833675),
(18810, '43351', 218, 41, 158063, 40.8257, 0.712542884431449, -83.2988, -1.45383832296025),
(18811, '43356', 218, 41, 6601, 40.4656, 0.706257953795017, -83.0609, -1.44968618466976),
(18812, '43357', 218, 41, 12753, 40.2643, 0.702744606010753, -83.7387, -1.46151602633978),
(18813, '43358', 218, 41, 126537, 40.4172, 0.705413214437052, -83.4874, -1.45713001392951),
(18814, '43359', 218, 41, 12778, 40.8705, 0.713324791936342, -83.4506, -1.45648773276478),
(18815, '43360', 218, 41, 158512, 40.3205, 0.703725481050374, -83.6493, -1.45995570198849),
(18816, '43402', 218, 41, 15294, 41.3884, 0.722363852132421, -83.6526, -1.46001329785381),
(18817, '43403', 218, 41, 15294, 41.3762, 0.722150921963678, -83.6499, -1.459966173964),
(18818, '43406', 218, 41, 154422, 41.3319, 0.721377741105044, -83.44, -1.45630272786407),
(18819, '43407', 218, 41, 154536, 41.2771, 0.720421300674951, -83.2478, -1.45294820504174),
(18820, '43408', 218, 41, 32077, 41.5588, 0.725337893177819, -83.251, -1.4530040555778),
(18821, '43410', 218, 41, 8151, 41.3127, 0.721042637888661, -82.965, -1.4480124139171),
(18822, '43412', 218, 41, 154916, 41.6515, 0.726955813394418, -83.284, -1.45358001423096),
(18823, '43413', 218, 41, 154924, 41.2402, 0.719777274180965, -83.6539, -1.46003598713408),
(18824, '43414', 218, 41, 155041, 41.4578, 0.723575110633305, -83.6119, -1.45930294884825),
(18825, '43416', 218, 41, 64511, 41.4811, 0.72398177234902, -83.2813, -1.45353289034115),
(18826, '43420', 218, 41, 2605, 41.346, 0.721623832529575, -83.1183, -1.4506880036604),
(18827, '43430', 218, 41, 9080, 41.5284, 0.724807313085213, -83.3658, -1.45500769355909),
(18828, '43431', 218, 41, 155439, 41.381, 0.722234697767773, -83.3286, -1.45435843107735),
(18829, '43432', 218, 41, 21, 41.5578, 0.725320439885299, -83.243, -1.45286442923764),
(18830, '43433', 218, 41, 32652, 41.5042, 0.724384943406231, -82.8706, -1.44636482310321),
(18831, '43434', 218, 41, 16350, 41.6752, 0.727369456427141, -83.5218, -1.4577304071922),
(18832, '43435', 218, 41, 3052, 41.3315, 0.721370759788036, -83.3006, -1.45386973888679),
(18833, '43436', 218, 41, 155859, 41.7118, 0.728008246933371, -82.8164, -1.44541885464863),
(18834, '43437', 218, 41, 155917, 41.2535, 0.720009402971481, -83.6044, -1.45917204915435),
(18835, '43438', 218, 41, 155959, 41.6016, 0.726084894097673, -82.6874, -1.44316737991356),
(18836, '43439', 218, 41, 156030, 41.5186, 0.724636270818518, -83.0416, -1.44934933612412),
(18837, '43440', 218, 41, 0, 41.5303, 0.724840474341001, -82.7611, -1.44445368757228),
(18838, '43441', 218, 41, 156114, 41.4987, 0.724288950297371, -83.4728, -1.45687519585872),
(18839, '43442', 218, 41, 3786, 41.4201, 0.722917121505303, -83.2216, -1.45249092877771),
(18840, '43443', 218, 41, 156250, 41.4572, 0.723564638657793, -83.4782, -1.45696944363833),
(18841, '43445', 218, 41, 882, 41.5684, 0.725505444786011, -83.3139, -1.4541018676773),
(18842, '43446', 218, 41, 156458, 41.6477, 0.726889490882842, -82.82, -1.4454816865017),
(18843, '43447', 218, 41, 125432, 41.5615, 0.725385017067623, -83.4491, -1.456461552826),
(18844, '43449', 218, 41, 17342, 41.5318, 0.724866654279781, -83.1399, -1.45106499477883),
(18845, '43450', 218, 41, 157074, 41.4107, 0.722753060555616, -83.4768, -1.4569450090288),
(18846, '43451', 218, 41, 42669, 41.317, 0.721117687046497, -83.6192, -1.45943035788364),
(18847, '43452', 218, 41, 157220, 41.5273, 0.724788114463441, -82.911, -1.44706993612102),
(18848, '43456', 218, 41, 0, 41.6469, 0.726875528248827, -82.82, -1.4454816865017),
(18849, '43457', 218, 41, 157375, 41.267, 0.7202450224205, -83.4444, -1.45637952235116),
(18850, '43458', 218, 41, 5491, 41.5322, 0.724873635596789, -83.2129, -1.45233908513279),
(18851, '43460', 218, 41, 157446, 41.6028, 0.726105838048697, -83.5667, -1.45851406002635),
(18852, '43462', 218, 41, 90525, 41.285, 0.720559181685859, -83.7, -1.46084058391925),
(18853, '43463', 218, 41, 106629, 41.5092, 0.72447220986883, -83.5086, -1.45750002373094),
(18854, '43464', 218, 41, 158111, 41.388, 0.722356870815413, -82.944, -1.44764589477418),
(18855, '43465', 218, 41, 38721, 41.5735, 0.725594456577863, -83.4975, -1.45730629218397),
(18856, '43466', 218, 41, 6665, 41.2932, 0.720702298684523, -83.5101, -1.45752620366972),
(18857, '43467', 218, 41, 158292, 41.2411, 0.719792982144233, -83.4933, -1.45723298835538),
(18858, '43468', 218, 41, 18638, 41.6018, 0.726088384756177, -83.3341, -1.45445442418621),
(18859, '43469', 218, 41, 6954, 41.4487, 0.723416285671374, -83.3686, -1.45505656277814),
(18860, '43501', 218, 41, 154053, 41.6459, 0.726858074956307, -84.4495, -1.47392182666295),
(18861, '43502', 218, 41, 15019, 41.5337, 0.724899815535569, -84.2985, -1.47128637949244),
(18862, '43504', 218, 41, 154286, 41.6999, 0.727800552752383, -83.8336, -1.46317234379992),
(18863, '43505', 218, 41, 147237, 41.5233, 0.724718301293361, -84.7502, -1.4791700317237),
(18864, '43506', 218, 41, 1206, 41.4733, 0.723845636667364, -84.5667, -1.47596735254629),
(18865, '43510', 218, 41, 93382, 41.4492, 0.723425012317634, -83.9722, -1.46559137014318),
(18866, '43511', 218, 41, 154918, 41.2604, 0.720129830689868, -83.8219, -1.46296814027743),
(18867, '43512', 218, 41, 35545, 41.2952, 0.720737205269562, -84.3564, -1.47229692512934),
(18868, '43515', 218, 41, 2022, 41.5798, 0.725704412320738, -84.0054, -1.46617081945484),
(18869, '43516', 218, 41, 141654, 41.2071, 0.719199570198555, -83.9004, -1.46433822374025),
(18870, '43517', 218, 41, 32304, 41.4564, 0.723550676023777, -84.7392, -1.47897804550598),
(18871, '43518', 218, 41, 155147, 41.5716, 0.725561295322075, -84.7685, -1.47948942697681),
(18872, '43519', 218, 41, 155205, 41.4265, 0.723028822577431, -84.3964, -1.47299505683014),
(18873, '43520', 218, 41, 54726, 41.383, 0.722269604352813, -84.6308, -1.47708610859682),
(18874, '43521', 218, 41, 2426, 41.661, 0.727121619673358, -84.3049, -1.47139808056457),
(18875, '43522', 218, 41, 131066, 41.4006, 0.722576782301164, -83.8498, -1.46345508713874),
(18876, '43523', 218, 41, 155557, 41.3414, 0.721543547383984, -83.9994, -1.46606609969972),
(18877, '43524', 218, 41, 155592, 41.229, 0.719581797304742, -84.0339, -1.46666823829166),
(18878, '43525', 218, 41, 115971, 41.4656, 0.723711246314961, -83.7065, -1.46095403032063),
(18879, '43526', 218, 41, 9478, 41.3154, 0.721089761778465, -84.737, -1.47893964826243),
(18880, '43527', 218, 41, 70961, 41.2485, 0.719922136508881, -84.1293, -1.46833328239807),
(18881, '43528', 218, 41, 9533, 41.622, 0.72644094126508, -83.7283, -1.46133451209757),
(18882, '43529', 218, 41, 131383, 41.1899, 0.718899373567212, -83.7844, -1.46231364180794),
(18883, '43530', 218, 41, 9764, 41.3256, 0.721267785362169, -84.2855, -1.47105948668968),
(18884, '43531', 218, 41, 156024, 41.6356, 0.726678306043351, -84.495, -1.47471595147261),
(18885, '43532', 218, 41, 116470, 41.4241, 0.722986934675383, -83.9741, -1.46562453139897),
(18886, '43533', 218, 41, 764, 41.6974, 0.727756919521084, -84.0743, -1.46737335130947),
(18887, '43534', 218, 41, 4073, 41.3734, 0.722102052744622, -83.9418, -1.46506079005058),
(18888, '43535', 218, 41, 156302, 41.3222, 0.721208444167601, -84.0383, -1.46674503277875),
(18889, '43536', 218, 41, 156344, 41.3074, 0.720950135438306, -84.6371, -1.47719606433969),
(18890, '43537', 218, 41, 10355, 41.5782, 0.725676487052706, -83.6641, -1.46021401071779),
(18891, '43540', 218, 41, 30492, 41.7023, 0.727842440654431, -83.9361, -1.46496130628321),
(18892, '43541', 218, 41, 125443, 41.3006, 0.72083145304917, -83.8288, -1.46308856799582),
(18893, '43542', 218, 41, 156553, 41.5693, 0.725521152749279, -83.7664, -1.46199948254258),
(18894, '43543', 218, 41, 23162, 41.588, 0.725847529319402, -84.6084, -1.47669515484437),
(18895, '43545', 218, 41, 4479, 41.3857, 0.722316728242617, -84.134, -1.46841531287291),
(18896, '43547', 218, 41, 89332, 41.4917, 0.724166777249731, -83.873, -1.4638600035252),
(18897, '43548', 218, 41, 156700, 41.2034, 0.719134993016232, -84.1676, -1.46900174350158),
(18898, '43549', 218, 41, 156785, 41.3772, 0.722168375256198, -84.5233, -1.47520987965092),
(18899, '43550', 218, 41, 10933, 41.39, 0.722391777400453, -84.1265, -1.46828441317901),
(18900, '43551', 218, 41, 123417, 41.5442, 0.725083075107028, -83.5974, -1.45904987610671),
(18901, '43552', 218, 41, 123417, 41.5535, 0.725245390727464, -83.6241, -1.45951587901699),
(18902, '43553', 218, 41, 157120, 41.5308, 0.724849200987261, -84.226, -1.47002101578474),
(18903, '43554', 218, 41, 42592, 41.6671, 0.727228084757729, -84.5542, -1.47574918638979),
(18904, '43555', 218, 41, 157363, 41.4377, 0.723224299453654, -84.261, -1.47063188102294),
(18905, '43556', 218, 41, 14604, 41.3024, 0.720862868975706, -84.5613, -1.47587310476668),
(18906, '43557', 218, 41, 157839, 41.502, 0.724346546162687, -84.4119, -1.4732655828642),
(18907, '43558', 218, 41, 51889, 41.579, 0.725690449686722, -83.9099, -1.46450403001919),
(18908, '43560', 218, 41, 6205, 41.7094, 0.727966359031323, -83.7099, -1.4610133715152),
(18909, '43565', 218, 41, 157964, 41.418, 0.722880469591011, -83.7411, -1.46155791424182),
(18910, '43566', 218, 41, 25838, 41.5016, 0.724339564845679, -83.7394, -1.46152824364454),
(18911, '43567', 218, 41, 158216, 41.5586, 0.725334402519315, -84.1508, -1.46870852818724),
(18912, '43569', 218, 41, 6746, 41.3506, 0.721704117675167, -83.7936, -1.46247421209912),
(18913, '43570', 218, 41, 144661, 41.5839, 0.72577597082007, -84.4372, -1.47370715116496),
(18914, '43571', 218, 41, 6785, 41.518, 0.724625798843006, -83.8115, -1.46278662603523),
(18915, '43601', 218, 41, 12339, 41.6454, 0.726849348310047, -83.5484, -1.45819466477323),
(18916, '43602', 218, 41, 12339, 41.6463, 0.726865056273314, -83.5488, -1.45820164609024),
(18917, '43603', 218, 41, 12339, 41.6596, 0.72709718506383, -83.5268, -1.4578176736548),
(18918, '43604', 218, 41, 12339, 41.6572, 0.727055297161782, -83.5295, -1.4578647975446),
(18919, '43605', 218, 41, 12339, 41.6425, 0.726798733761739, -83.5085, -1.45749827840168),
(18920, '43606', 218, 41, 12339, 41.6721, 0.727315351220329, -83.605, -1.45918252112986),
(18921, '43607', 218, 41, 12339, 41.6499, 0.726927888126386, -83.6036, -1.45915808652033),
(18922, '43608', 218, 41, 12339, 41.6791, 0.727437524267969, -83.5331, -1.45792762939768),
(18923, '43609', 218, 41, 12339, 41.6311, 0.726599766227011, -83.5779, -1.45870953690257),
(18924, '43610', 218, 41, 12339, 41.6728, 0.727327568525093, -83.5569, -1.45834301775965),
(18925, '43611', 218, 41, 12339, 41.7051, 0.727891309873487, -83.4882, -1.45714397656353),
(18926, '43612', 218, 41, 12339, 41.7038, 0.727868620593211, -83.5395, -1.4580393304698),
(18927, '43613', 218, 41, 12339, 41.7047, 0.727884328556479, -83.6058, -1.45919648376388),
(18928, '43614', 218, 41, 12339, 41.602, 0.726091875414681, -83.6296, -1.45961187212585),
(18929, '43615', 218, 41, 12339, 41.6544, 0.727006427942726, -83.676, -1.46042170489878),
(18930, '43616', 218, 41, 37541, 41.6462, 0.726863310944062, -83.4682, -1.45679491071313),
(18931, '43617', 218, 41, 12339, 41.6663, 0.727214122123713, -83.7177, -1.46114950719686),
(18932, '43618', 218, 41, 37541, 41.6732, 0.727334549842101, -83.3974, -1.45555921760272),
(18933, '43619', 218, 41, 14320, 41.6051, 0.726145980621493, -83.4806, -1.45701133154038),
(18934, '43620', 218, 41, 12339, 41.6651, 0.727193178172689, -83.5536, -1.45828542189433),
(18935, '43623', 218, 41, 12339, 41.7066, 0.727917489812267, -83.6502, -1.45997140995176),
(18936, '43624', 218, 41, 12339, 41.6554, 0.727023881235246, -83.5451, -1.45813706890791),
(18937, '43635', 218, 41, 12339, 41.6516, 0.72695755872367, -83.6702, -1.46032047580216),
(18938, '43652', 218, 41, 12339, 41.6513, 0.726952322735914, -83.5343, -1.4579485733487),
(18939, '43654', 218, 41, 12339, 41.6067, 0.726173905889525, -83.5384, -1.45802013184803),
(18940, '43656', 218, 41, 12339, 41.7045, 0.727880837897975, -83.6514, -1.45999235390278),
(18941, '43657', 218, 41, 12339, 41.6774, 0.727407853670685, -83.5605, -1.45840584961272),
(18942, '43659', 218, 41, 12339, 41.6482, 0.726898217529102, -83.5386, -1.45802362250654),
(18943, '43660', 218, 41, 12339, 41.6424, 0.726796988432487, -83.5438, -1.45811437962764),
(18944, '43661', 218, 41, 12339, 41.6496, 0.72692265213863, -83.6054, -1.45918950244687),
(18945, '43666', 218, 41, 12339, 41.6543, 0.727004682613474, -83.5306, -1.45788399616638),
(18946, '43667', 218, 41, 12339, 41.6509, 0.726945341418906, -83.5354, -1.45796777197047),
(18947, '43681', 218, 41, 12339, 41.642, 0.726790007115479, -83.5446, -1.45812834226165),
(18948, '43682', 218, 41, 12339, 41.6418, 0.726786516456975, -83.5438, -1.45811437962764),
(18949, '43697', 218, 41, 12339, 41.6469, 0.726875528248827, -83.5454, -1.45814230489567),
(18950, '43699', 218, 41, 12339, 41.6288, 0.726559623654215, -83.616, -1.45937450734758),
(18951, '43701', 218, 41, 29051, 39.95, 0.697259036171735, -82.008, -1.43130961297551),
(18952, '43702', 218, 41, 29051, 39.9374, 0.697039124685983, -82.0074, -1.431299141),
(18953, '43711', 218, 41, 7203, 39.832, 0.695199547654381, -81.5753, -1.42375757330213),
(18954, '43713', 218, 41, 19061, 39.979, 0.697765181654813, -81.1701, -1.41668549917305),
(18955, '43716', 218, 41, 44669, 39.829, 0.695147187776822, -81.0081, -1.41385806578482),
(18956, '43717', 218, 41, 71787, 39.8013, 0.694663731574019, -81.5535, -1.4233770915252),
(18957, '43718', 218, 41, 303, 40.0151, 0.698395245514783, -81.0139, -1.41395929488143),
(18958, '43719', 218, 41, 7439, 40.0047, 0.698213731272576, -81.0796, -1.41510597619999),
(18959, '43720', 218, 41, 63023, 39.7963, 0.694576465111419, -81.8778, -1.42903719428941),
(18960, '43721', 218, 41, 1191, 39.9417, 0.697114173843819, -82.2554, -1.43562755754494),
(18961, '43722', 218, 41, 26642, 39.9159, 0.696663878896805, -81.5202, -1.42279589688428),
(18962, '43723', 218, 41, 71982, 39.9633, 0.69749116496225, -81.5458, -1.42324270117279),
(18963, '43724', 218, 41, 1290, 39.7459, 0.693696819168414, -81.5213, -1.42281509550605);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(18964, '43725', 218, 41, 1302, 40.0269, 0.698601194366518, -81.5961, -1.42412060178655),
(18965, '43727', 218, 41, 72068, 39.8788, 0.696016361744315, -81.8125, -1.42789749428786),
(18966, '43728', 218, 41, 72090, 39.6547, 0.692105078890595, -81.8126, -1.42789923961711),
(18967, '43730', 218, 41, 8235, 39.6316, 0.691701907833385, -82.0909, -1.43275649092541),
(18968, '43731', 218, 41, 72243, 39.7493, 0.693756160362982, -82.0986, -1.43289088127782),
(18969, '43732', 218, 41, 20409, 39.8826, 0.69608268425589, -81.6441, -1.4249583598275),
(18970, '43733', 218, 41, 72311, 39.9298, 0.696906479662832, -81.5023, -1.42248348294817),
(18971, '43734', 218, 41, 72351, 39.8798, 0.696033815036835, -81.9115, -1.42962537024734),
(18972, '43735', 218, 41, 72379, 39.8538, 0.695580029431316, -82.1231, -1.43331848694456),
(18973, '43736', 218, 41, 500, 39.9941, 0.698028726371864, -81.2866, -1.41871880775162),
(18974, '43738', 218, 41, 72620, 39.8559, 0.695616681345608, -82.1407, -1.43362566489291),
(18975, '43739', 218, 41, 72685, 39.9388, 0.697063559295511, -82.2724, -1.43592426351778),
(18976, '43740', 218, 41, 55051, 39.9524, 0.697300924073783, -82.2124, -1.43487706596659),
(18977, '43746', 218, 41, 3228, 39.9611, 0.697452767718706, -82.17, -1.43413704636374),
(18978, '43747', 218, 41, 3422, 39.8398, 0.695335683336037, -81.1141, -1.41570811479193),
(18979, '43748', 218, 41, 9806, 39.7147, 0.693152276441792, -82.3135, -1.43664159384035),
(18980, '43749', 218, 41, 155985, 40.1654, 0.70101847538053, -81.5442, -1.42321477590476),
(18981, '43750', 218, 41, 41619, 39.9947, 0.698039198347376, -81.5052, -1.42253409749648),
(18982, '43752', 218, 41, 73146, 39.7169, 0.693190673685336, -81.0124, -1.41393311494265),
(18983, '43754', 218, 41, 10065, 39.7618, 0.693974326519481, -81.2376, -1.41786359641815),
(18984, '43755', 218, 41, 73280, 40.0499, 0.699002620094477, -81.4379, -1.42135949090989),
(18985, '43756', 218, 41, 73404, 39.6701, 0.692373859595403, -81.8452, -1.42846821695326),
(18986, '43757', 218, 41, 37031, 39.8573, 0.695641115955136, -81.1427, -1.416207278958),
(18987, '43758', 218, 41, 3962, 39.6397, 0.691843279502796, -81.8927, -1.42929724834796),
(18988, '43759', 218, 41, 30565, 40.0625, 0.699222531580228, -81.0719, -1.41497158584759),
(18989, '43760', 218, 41, 73584, 39.9, 0.696386371545737, -82.1735, -1.43419813288756),
(18990, '43761', 218, 41, 73601, 39.6636, 0.692260413194023, -82.1437, -1.43367802477047),
(18991, '43762', 218, 41, 37395, 40.0226, 0.698526145208683, -81.7503, -1.42681189949312),
(18992, '43764', 218, 41, 4545, 39.714, 0.693140059137028, -82.2096, -1.43482819674753),
(18993, '43766', 218, 41, 73679, 39.6152, 0.691415673836058, -82.2783, -1.43602723794365),
(18994, '43767', 218, 41, 23480, 39.9951, 0.698046179664384, -81.8024, -1.42772121603341),
(18995, '43768', 218, 41, 37513, 40.0345, 0.69873383938967, -81.4102, -1.42087603470709),
(18996, '43771', 218, 41, 73882, 39.8455, 0.695435167103401, -81.9381, -1.43008962782837),
(18997, '43772', 218, 41, 73921, 39.9094, 0.696550432495425, -81.5494, -1.42330553302586),
(18998, '43773', 218, 41, 73997, 40.0357, 0.698754783340694, -81.2951, -1.41886716073804),
(18999, '43777', 218, 41, 11688, 39.824, 0.695059921314222, -82.0643, -1.43229223334438),
(19000, '43778', 218, 41, 74190, 40.0076, 0.698264345820883, -81.3727, -1.42022153623759),
(19001, '43779', 218, 41, 74210, 39.816, 0.694920294974062, -81.4383, -1.4213664722269),
(19002, '43780', 218, 41, 74254, 39.9387, 0.697061813966259, -81.4622, -1.42178360591812),
(19003, '43782', 218, 41, 5783, 39.613, 0.691377276592514, -82.2131, -1.43488928327135),
(19004, '43783', 218, 41, 5946, 39.8061, 0.694747507378115, -82.2924, -1.43627332936818),
(19005, '43786', 218, 41, 12102, 39.7131, 0.69312435117376, -81.2776, -1.41856172811894),
(19006, '43787', 218, 41, 74422, 39.5585, 0.690426072150177, -81.7739, -1.42722379719659),
(19007, '43788', 218, 41, 6148, 39.7924, 0.694508397270592, -81.3465, -1.41976425997357),
(19008, '43789', 218, 41, 74498, 39.6534, 0.692082389610319, -81.2388, -1.41788454036917),
(19009, '43791', 218, 41, 74807, 39.8741, 0.695934331269471, -82.1067, -1.43303225294723),
(19010, '43793', 218, 41, 74884, 39.7553, 0.693860880118102, -81.1133, -1.41569415215792),
(19011, '43802', 218, 41, 13260, 40.0861, 0.699634429283699, -81.8588, -1.42870558173153),
(19012, '43803', 218, 41, 15087, 40.355, 0.704327619642312, -81.6449, -1.42497232246152),
(19013, '43804', 218, 41, 62687, 40.4647, 0.706242245831749, -81.7358, -1.42655882675158),
(19014, '43805', 218, 41, 129858, 40.401, 0.705130471098229, -81.9639, -1.43053992277538),
(19015, '43811', 218, 41, 115086, 40.1926, 0.701493204937073, -81.9102, -1.42960268096706),
(19016, '43812', 218, 41, 154856, 40.267, 0.702791729900557, -81.8533, -1.42860958862267),
(19017, '43821', 218, 41, 20675, 40.1129, 0.700102177523233, -82.0095, -1.43133579291429),
(19018, '43822', 218, 41, 155348, 40.1229, 0.700276710448433, -82.1268, -1.43338306412688),
(19019, '43824', 218, 41, 8997, 40.348, 0.704205446594672, -81.74, -1.42663213058016),
(19020, '43828', 218, 41, 16697, 40.3453, 0.704158322704868, -81.8688, -1.42888011465673),
(19021, '43830', 218, 41, 156673, 40.0439, 0.698897900339357, -82.1076, -1.4330479609105),
(19022, '43832', 218, 41, 156770, 40.2753, 0.702936592228472, -81.6059, -1.42429164405324),
(19023, '43836', 218, 41, 11247, 40.2063, 0.701732315044596, -81.7191, -1.4262673567665),
(19024, '43837', 218, 41, 151861, 40.3199, 0.703715009074862, -81.5041, -1.42251489887471),
(19025, '43840', 218, 41, 25149, 40.4077, 0.705247408158113, -81.5957, -1.42411362046954),
(19026, '43842', 218, 41, 157982, 40.1412, 0.700596105701548, -82.0121, -1.43138117147484),
(19027, '43843', 218, 41, 74677, 40.308, 0.703507314893874, -82.2213, -1.43503240027001),
(19028, '43844', 218, 41, 6638, 40.3096, 0.703535240161906, -82.0497, -1.43203741527359),
(19029, '43845', 218, 41, 123990, 40.2707, 0.70285630708288, -81.7368, -1.4265762800441),
(19030, '43901', 218, 41, 154022, 40.2199, 0.701969679822867, -80.8654, -1.41136748094222),
(19031, '43902', 218, 41, 71644, 39.8805, 0.696046032341599, -80.9919, -1.413575322446),
(19032, '43903', 218, 41, 18842, 40.4753, 0.706427250732461, -80.9619, -1.4130517236704),
(19033, '43905', 218, 41, 7286, 40.1059, 0.699980004475594, -80.8399, -1.41092242198296),
(19034, '43906', 218, 41, 7382, 40.0173, 0.698433642758327, -80.7579, -1.40949125199633),
(19035, '43907', 218, 41, 26672, 40.2698, 0.702840599119613, -81.0126, -1.41393660560116),
(19036, '43908', 218, 41, 154285, 40.5475, 0.707687378452401, -80.9295, -1.41248623699275),
(19037, '43909', 218, 41, 19318, 40.0689, 0.699334232652356, -80.8175, -1.41053146823052),
(19038, '43910', 218, 41, 13040, 40.3446, 0.704146105400104, -80.808, -1.41036566195158),
(19039, '43912', 218, 41, 1130, 40.0735, 0.699414517797948, -80.7648, -1.40961167971472),
(19040, '43913', 218, 41, 1141, 40.2656, 0.702767295291029, -80.6291, -1.40724326791976),
(19041, '43914', 218, 41, 806, 39.7687, 0.694094754237869, -80.946, -1.41277421631933),
(19042, '43915', 218, 41, 72109, 39.7476, 0.693726489765698, -80.894, -1.41186664510829),
(19043, '43916', 218, 41, 20163, 39.7834, 0.694351317637912, -80.9529, -1.41289464403772),
(19044, '43917', 218, 41, 72320, 40.1471, 0.700699080127416, -80.8308, -1.41076359702103),
(19045, '43920', 218, 41, 155093, 40.6468, 0.709420490399631, -80.5787, -1.40636362197675),
(19046, '43925', 218, 41, 27039, 40.4502, 0.70598917309021, -80.8606, -1.41128370513813),
(19047, '43926', 218, 41, 2294, 40.5099, 0.707031134653651, -80.6249, -1.40716996409118),
(19048, '43927', 218, 41, 155218, 40.1199, 0.700224350570873, -80.9328, -1.41254383285807),
(19049, '43928', 218, 41, 2739, 40.0056, 0.698229439235844, -80.874, -1.41151757925789),
(19050, '43930', 218, 41, 9307, 40.6136, 0.708841041087969, -80.7851, -1.40996598155287),
(19051, '43931', 218, 41, 55163, 39.663, 0.692249941218511, -80.8763, -1.41155772183069),
(19052, '43932', 218, 41, 3364, 40.5928, 0.708478012603554, -80.7064, -1.40859240743155),
(19053, '43933', 218, 41, 73036, 39.9432, 0.697140353782599, -80.8987, -1.41194867558314),
(19054, '43934', 218, 41, 9985, 40.0764, 0.699465132346256, -80.7886, -1.41002706807669),
(19055, '43935', 218, 41, 156360, 40.1024, 0.699918917951774, -80.7338, -1.4090706276466),
(19056, '43937', 218, 41, 4057, 40.1322, 0.700439026068868, -80.8799, -1.41162055368376),
(19057, '43938', 218, 41, 156534, 40.3198, 0.70371326374561, -80.6197, -1.40707920697007),
(19058, '43939', 218, 41, 118, 40.1755, 0.701194753634982, -80.8002, -1.41022952626992),
(19059, '43940', 218, 41, 156683, 40.0275, 0.69861166634203, -80.8185, -1.41054892152304),
(19060, '43941', 218, 41, 37700, 40.2527, 0.702542147817521, -80.8143, -1.41047561769445),
(19061, '43942', 218, 41, 73973, 39.8642, 0.695761543673524, -80.8181, -1.41054194020603),
(19062, '43943', 218, 41, 97390, 40.1764, 0.70121046159825, -80.7054, -1.40857495413903),
(19063, '43944', 218, 41, 5381, 40.4305, 0.705645343227567, -80.7586, -1.40950346930109),
(19064, '43945', 218, 41, 157519, 40.6407, 0.70931402531526, -80.8299, -1.41074788905776),
(19065, '43946', 218, 41, 715, 39.641, 0.691865968783072, -80.9494, -1.4128335575139),
(19066, '43947', 218, 41, 43016, 39.9674, 0.697562723461582, -80.7562, -1.40946158139905),
(19067, '43948', 218, 41, 5916, 40.2723, 0.702884232350912, -80.7808, -1.40989093239504),
(19068, '43950', 218, 41, 157486, 40.0843, 0.699603013357163, -80.9137, -1.41221047497094),
(19069, '43951', 218, 41, 9926, 40.112, 0.700086469559965, -81.0193, -1.41405354266104),
(19070, '43952', 218, 41, 38379, 40.3684, 0.704561493762079, -80.6607, -1.40779479196339),
(19071, '43953', 218, 41, 38379, 40.3754, 0.704683666809719, -80.7041, -1.40855226485876),
(19072, '43961', 218, 41, 132, 40.5206, 0.707217884883614, -80.628, -1.40722406929799),
(19073, '43962', 218, 41, 91138, 40.6768, 0.709944089175229, -80.8861, -1.41172876409739),
(19074, '43963', 218, 41, 157945, 40.1709, 0.70111446848939, -80.6979, -1.40844405444513),
(19075, '43964', 218, 41, 28798, 40.463, 0.706212575234466, -80.6108, -1.40692387266664),
(19076, '43966', 218, 41, 123868, 40.3571, 0.704364271556604, -80.8471, -1.41104808568911),
(19077, '43967', 218, 41, 28907, 40.0221, 0.698517418562423, -80.938, -1.41263458997917),
(19078, '43968', 218, 41, 34380, 40.6259, 0.709055716585964, -80.6687, -1.40793441830355),
(19079, '43970', 218, 41, 112116, 40.4672, 0.706285879063049, -80.8898, -1.41179334127971),
(19080, '43971', 218, 41, 26297, 40.1633, 0.700981823466239, -80.706, -1.40858542611454),
(19081, '43972', 218, 41, 154181, 40.0984, 0.699849104781694, -80.9758, -1.41329432443642),
(19082, '43973', 218, 41, 16142, 40.1547, 0.700831725150567, -81.3227, -1.41934887161159),
(19083, '43974', 218, 41, 2996, 40.1815, 0.701299473390102, -80.8875, -1.41175319870691),
(19084, '43976', 218, 41, 41406, 40.3669, 0.704535313823299, -80.9076, -1.41210400988656),
(19085, '43977', 218, 41, 113299, 40.1281, 0.700367467569537, -81.0686, -1.41491398998228),
(19086, '43981', 218, 41, 28012, 40.1828, 0.701322162670378, -80.9958, -1.41364339028682),
(19087, '43983', 218, 41, 4996, 40.1411, 0.700594360372296, -81.1902, -1.4170363103527),
(19088, '43984', 218, 41, 156746, 40.3971, 0.705062403257401, -81.0333, -1.41429788875632),
(19089, '43985', 218, 41, 3196, 40.1607, 0.700936444905687, -81.1268, -1.41592977160694),
(19090, '43986', 218, 41, 27563, 40.3698, 0.704585928371607, -80.9865, -1.41348107466639),
(19091, '43988', 218, 41, 133027, 40.3788, 0.704743008004286, -81.1206, -1.41582156119331),
(19092, '43989', 218, 41, 5833, 40.2078, 0.701758494983376, -80.9215, -1.41234661065259),
(19093, '44001', 218, 41, 62514, 41.3917, 0.722421447997737, -82.2326, -1.43522962247549),
(19094, '44003', 218, 41, 14988, 41.6129, 0.726282116303148, -80.5656, -1.40613498384474),
(19095, '44004', 218, 41, 154109, 41.8681, 0.730736196554238, -80.7945, -1.41013004250256),
(19096, '44005', 218, 41, 154109, 41.8793, 0.730931673430461, -80.7982, -1.41019461968488),
(19097, '44010', 218, 41, 154144, 41.7633, 0.728907091498148, -80.8669, -1.411393660881),
(19098, '44011', 218, 41, 7208, 41.4474, 0.723393596391098, -82.0214, -1.43154348709528),
(19099, '44012', 218, 41, 114478, 41.5014, 0.724336074187175, -82.0085, -1.43131833962177),
(19100, '44017', 218, 41, 7416, 41.3695, 0.722033984903794, -81.8586, -1.42870209107303),
(19101, '44021', 218, 41, 7796, 41.4513, 0.723461664231926, -81.1587, -1.41648653163832),
(19102, '44022', 218, 41, 154669, 41.4381, 0.723231280770662, -81.4183, -1.4210174063765),
(19103, '44023', 218, 41, 154669, 41.3905, 0.722400504046713, -81.3371, -1.41960019902388),
(19104, '44024', 218, 41, 154681, 41.5691, 0.725517662090775, -81.2069, -1.41732778033778),
(19105, '44026', 218, 41, 154710, 41.5342, 0.724908542181829, -81.3414, -1.41967524818172),
(19106, '44028', 218, 41, 154812, 41.3242, 0.721243350752641, -81.9348, -1.43003203196305),
(19107, '44030', 218, 41, 154833, 41.9309, 0.73183226332449, -80.5827, -1.40643343514683),
(19108, '44032', 218, 41, 101475, 41.6644, 0.727180960867926, -80.6744, -1.40803390207091),
(19109, '44033', 218, 41, 155073, 41.5461, 0.725116236362816, -81.101, -1.41547947665992),
(19110, '44035', 218, 41, 32356, 41.3733, 0.72210030741537, -82.1145, -1.43316838862888),
(19111, '44036', 218, 41, 32356, 41.3705, 0.722051438196314, -82.096, -1.43284550271726),
(19112, '44039', 218, 41, 156840, 41.3952, 0.722482534521557, -82.003, -1.43122234651291),
(19113, '44040', 218, 41, 155410, 41.5301, 0.724836983682497, -81.4155, -1.42096853715744),
(19114, '44041', 218, 41, 2687, 41.8041, 0.729619185832961, -80.9474, -1.41279865092886),
(19115, '44044', 218, 41, 27298, 41.2828, 0.720520784442315, -82.0563, -1.43215260700422),
(19116, '44045', 218, 41, 41159, 41.7368, 0.728444579246369, -81.2812, -1.41862455997201),
(19117, '44046', 218, 41, 145478, 41.5418, 0.72504118720498, -81.0746, -1.41501870973739),
(19118, '44047', 218, 41, 3409, 41.7317, 0.728355567454518, -80.7456, -1.40927657649833),
(19119, '44048', 218, 41, 41617, 41.8628, 0.730643694103882, -80.6546, -1.40768832687902),
(19120, '44049', 218, 41, 155998, 41.2666, 0.720238041103492, -82.3047, -1.43648800486618),
(19121, '44050', 218, 41, 103428, 41.2331, 0.719653355804074, -82.1336, -1.43350174651601),
(19122, '44052', 218, 41, 156228, 41.4567, 0.723555912011533, -82.1679, -1.43410039444945),
(19123, '44053', 218, 41, 156228, 41.4301, 0.723091654430503, -82.2047, -1.43474267561418),
(19124, '44054', 218, 41, 157622, 41.4804, 0.723969555044256, -82.0976, -1.4328734279853),
(19125, '44055', 218, 41, 156228, 41.4335, 0.723150995625071, -82.1393, -1.43360123028338),
(19126, '44056', 218, 41, 3926, 41.3202, 0.721173537582561, -81.5009, -1.42245904833865),
(19127, '44057', 218, 41, 3938, 41.8058, 0.729648856430245, -81.0603, -1.41476912765436),
(19128, '44060', 218, 41, 30487, 41.6827, 0.72750035612104, -81.3351, -1.41956529243884),
(19129, '44061', 218, 41, 30487, 41.6912, 0.72764870910746, -81.334, -1.41954609381707),
(19130, '44062', 218, 41, 113705, 41.4548, 0.723522750755745, -81.0605, -1.41477261831286),
(19131, '44064', 218, 41, 125472, 41.6119, 0.726264663010628, -81.0531, -1.41464346394822),
(19132, '44065', 218, 41, 33420, 41.4674, 0.723742662241497, -81.2417, -1.41793515491748),
(19133, '44067', 218, 41, 37457, 41.318, 0.721135140339017, -81.545, -1.42322873853878),
(19134, '44068', 218, 41, 156819, 41.912, 0.731502396095863, -80.6849, -1.40821716164237),
(19135, '44070', 218, 41, 156831, 41.4188, 0.722894432225027, -81.9152, -1.42968994742966),
(19136, '44072', 218, 41, 139372, 41.474, 0.723857853972128, -81.3393, -1.41963859626742),
(19137, '44073', 218, 41, 139372, 41.4641, 0.723685066376181, -81.3404, -1.4196577948892),
(19138, '44074', 218, 41, 42414, 41.2859, 0.720574889649127, -82.2202, -1.43501320164824),
(19139, '44076', 218, 41, 33507, 41.5344, 0.724912032840333, -80.8311, -1.41076883300879),
(19140, '44077', 218, 41, 157003, 41.7144, 0.728053625493923, -81.2395, -1.41789675767393),
(19141, '44080', 218, 41, 128476, 41.3708, 0.72205667418407, -81.0659, -1.41486686609247),
(19142, '44081', 218, 41, 11148, 41.7673, 0.728976904668228, -81.147, -1.41628232811584),
(19143, '44082', 218, 41, 56879, 41.764, 0.728919308802912, -80.5628, -1.40608611462569),
(19144, '44084', 218, 41, 5457, 41.6665, 0.727217612782217, -80.873, -1.41150012596537),
(19145, '44085', 218, 41, 490, 41.6145, 0.72631004157118, -80.8547, -1.41118073071226),
(19146, '44086', 218, 41, 6317, 41.6778, 0.727414834987693, -81.0533, -1.41464695460672),
(19147, '44087', 218, 41, 158017, 41.3224, 0.721211934826105, -81.4524, -1.42161256365143),
(19148, '44088', 218, 41, 25657, 41.78, 0.729198561483231, -81.0063, -1.41382664985828),
(19149, '44089', 218, 41, 28859, 41.4059, 0.72266928475152, -82.3863, -1.4379121935358),
(19150, '44090', 218, 41, 902, 41.1579, 0.718340868206574, -82.2335, -1.43524533043876),
(19151, '44092', 218, 41, 31529, 41.6036, 0.726119800682713, -81.4679, -1.42188308968549),
(19152, '44093', 218, 41, 121993, 41.534, 0.724905051523325, -80.5929, -1.40661145873054),
(19153, '44094', 218, 41, 52829, 41.6366, 0.726695759335871, -81.4171, -1.42099646242548),
(19154, '44095', 218, 41, 155118, 41.6544, 0.727006427942726, -81.4435, -1.421457229348),
(19155, '44096', 218, 41, 52829, 41.6463, 0.726865056273314, -81.4091, -1.42085683608532),
(19156, '44097', 218, 41, 155118, 41.6537, 0.726994210637962, -81.451, -1.4215881290419),
(19157, '44099', 218, 41, 18652, 41.5509, 0.725200012166912, -80.9643, -1.41309361157244),
(19158, '44101', 218, 41, 1620, 41.4928, 0.724185975871503, -81.6684, -1.42538247483574),
(19159, '44102', 218, 41, 1620, 41.4732, 0.723843891338112, -81.7372, -1.42658326136111),
(19160, '44103', 218, 41, 1620, 41.5142, 0.72455947633143, -81.6415, -1.42491298126695),
(19161, '44104', 218, 41, 1620, 41.4825, 0.724006206958548, -81.6307, -1.42472448570774),
(19162, '44105', 218, 41, 1620, 41.4509, 0.723454682914918, -81.6286, -1.42468783379344),
(19163, '44106', 218, 41, 1620, 41.5074, 0.724440793942294, -81.6083, -1.42433353195529),
(19164, '44107', 218, 41, 3637, 41.4816, 0.72399049899528, -81.7928, -1.42755366442522),
(19165, '44108', 218, 41, 1620, 41.536, 0.724939958108365, -81.6093, -1.42435098524781),
(19166, '44109', 218, 41, 1620, 41.4481, 0.723405813695862, -81.6994, -1.42592352690386),
(19167, '44110', 218, 41, 1620, 41.5649, 0.725444358262191, -81.5699, -1.42366332552252),
(19168, '44111', 218, 41, 1620, 41.4579, 0.723576855962557, -81.7856, -1.42742800071907),
(19169, '44112', 218, 41, 1620, 41.5347, 0.724917268828089, -81.5739, -1.4237331386926),
(19170, '44113', 218, 41, 1620, 41.484, 0.724032386897328, -81.6934, -1.42581880714874),
(19171, '44114', 218, 41, 1620, 41.5087, 0.72446348322257, -81.6738, -1.42547672261534),
(19172, '44115', 218, 41, 1620, 41.4947, 0.724219137127291, -81.6757, -1.42550988387113),
(19173, '44116', 218, 41, 68328, 41.4705, 0.723796767448308, -81.8489, -1.42853279413559),
(19174, '44117', 218, 41, 8787, 41.5688, 0.725512426103019, -81.5257, -1.42289188999314),
(19175, '44118', 218, 41, 1620, 41.501, 0.724329092870167, -81.5538, -1.42338232751295),
(19176, '44119', 218, 41, 1620, 41.5859, 0.72581087740511, -81.5485, -1.4232898250626),
(19177, '44120', 218, 41, 1620, 41.4729, 0.723838655350356, -81.5803, -1.42384483976473),
(19178, '44121', 218, 41, 1620, 41.5264, 0.724772406500173, -81.5324, -1.42300882705302),
(19179, '44122', 218, 41, 13340, 41.4713, 0.723810730082324, -81.5153, -1.42271037575093),
(19180, '44123', 218, 41, 8787, 41.6029, 0.726107583377949, -81.5231, -1.42284651143259),
(19181, '44124', 218, 41, 1620, 41.508, 0.724451265917806, -81.4702, -1.42192323225828),
(19182, '44125', 218, 41, 1620, 41.4143, 0.722815892408688, -81.6099, -1.42436145722332),
(19183, '44126', 218, 41, 1620, 41.4434, 0.723323783221018, -81.8544, -1.42862878724445),
(19184, '44127', 218, 41, 1620, 41.4713, 0.723810730082324, -81.6508, -1.42507529688739),
(19185, '44128', 218, 41, 1620, 41.4396, 0.723257460709442, -81.5444, -1.42321826656326),
(19186, '44129', 218, 41, 1620, 41.3944, 0.722468571887541, -81.7351, -1.42654660944682),
(19187, '44130', 218, 41, 1620, 41.3779, 0.722180592560962, -81.7826, -1.42737564084151),
(19188, '44131', 218, 41, 3320, 41.3852, 0.722308001596357, -81.6576, -1.42519397927652),
(19189, '44132', 218, 41, 8787, 41.6073, 0.726184377865037, -81.5009, -1.42245904833865),
(19190, '44133', 218, 41, 156844, 41.3258, 0.721271276020673, -81.744, -1.42670194375024),
(19191, '44134', 218, 41, 1620, 41.3887, 0.722369088120177, -81.7036, -1.42599683073244),
(19192, '44135', 218, 41, 1620, 41.4345, 0.72316844891759, -81.8019, -1.42771248938715),
(19193, '44136', 218, 41, 157834, 41.3137, 0.721060091181181, -81.8298, -1.42819943624846),
(19194, '44137', 218, 41, 156320, 41.4122, 0.722779240494396, -81.5565, -1.42342945140276),
(19195, '44138', 218, 41, 156937, 41.3735, 0.722103798073874, -81.9112, -1.42962013425958),
(19196, '44139', 218, 41, 117834, 41.3909, 0.722407485363721, -81.4433, -1.4214537386895),
(19197, '44140', 218, 41, 7313, 41.4848, 0.724046349531344, -81.9267, -1.42989066029364),
(19198, '44141', 218, 41, 154434, 41.317, 0.721117687046497, -81.6254, -1.42463198325738),
(19199, '44142', 218, 41, 0, 41.3967, 0.722508714460337, -81.8345, -1.4282814667233),
(19200, '44143', 218, 41, 1620, 41.554, 0.725254117373724, -81.4795, -1.42208554787872),
(19201, '44144', 218, 41, 1620, 41.4368, 0.723208591490386, -81.7447, -1.42671416105501),
(19202, '44145', 218, 41, 637, 41.45, 0.72343897495165, -81.9232, -1.42982957376982),
(19203, '44146', 218, 41, 146, 41.3905, 0.722400504046713, -81.5272, -1.42291806993192),
(19204, '44147', 218, 41, 154469, 41.3214, 0.721194481533585, -81.6748, -1.42549417590786),
(19205, '44149', 218, 41, 157834, 41.3183, 0.721140376326773, -81.853, -1.42860435263492),
(19206, '44178', 218, 41, 1620, 41.5, 0.724311639577647, -81.6947, -1.42584149642901),
(19207, '44181', 218, 41, 1620, 41.4584, 0.723585582608817, -81.7888, -1.42748385125514),
(19208, '44185', 218, 41, 1620, 41.4999, 0.724309894248395, -81.6871, -1.42570885140586),
(19209, '44188', 218, 41, 1620, 41.4027, 0.722613434215456, -81.8263, -1.42813834972464),
(19210, '44189', 218, 41, 1620, 41.477, 0.723910213849688, -81.7415, -1.42665831051895),
(19211, '44190', 218, 41, 1620, 41.5034, 0.724370980772215, -81.6209, -1.42455344344104),
(19212, '44191', 218, 41, 1620, 41.4833, 0.724020169592564, -81.7031, -1.42598810408618),
(19213, '44192', 218, 41, 1620, 41.5003, 0.724316875565403, -81.6864, -1.4256966341011),
(19214, '44193', 218, 41, 1620, 41.5019, 0.724344800833435, -81.6955, -1.42585545906303),
(19215, '44194', 218, 41, 1620, 41.5162, 0.72459438291647, -81.6747, -1.42549243057861),
(19216, '44195', 218, 41, 1620, 41.5041, 0.724383198076979, -81.6204, -1.42454471679478),
(19217, '44197', 218, 41, 1620, 41.48, 0.723962573727248, -81.6785, -1.42555875309019),
(19218, '44198', 218, 41, 1620, 41.4913, 0.724159795932723, -81.6749, -1.42549592123712),
(19219, '44199', 218, 41, 1620, 41.5043, 0.724386688735483, -81.6911, -1.42577866457594),
(19220, '44201', 218, 41, 18960, 41.0265, 0.716047505569454, -81.1974, -1.41716197405884),
(19221, '44202', 218, 41, 474, 41.3152, 0.721086271119961, -81.3469, -1.41977124129058),
(19222, '44203', 218, 41, 154182, 41.0176, 0.715892171266026, -81.6181, -1.42450457422198),
(19223, '44210', 218, 41, 19093, 41.1891, 0.718885410933196, -81.6291, -1.4246965604397),
(19224, '44211', 218, 41, 154425, 41.1695, 0.718543326399805, -81.3135, -1.41918830132041),
(19225, '44212', 218, 41, 19602, 41.2474, 0.719902937887109, -81.8261, -1.42813485906613),
(19226, '44214', 218, 41, 1232, 40.9471, 0.71466171414337, -81.9979, -1.43113333472106),
(19227, '44215', 218, 41, 130211, 41.0682, 0.716775307867535, -81.902, -1.4294595639684),
(19228, '44216', 218, 41, 1630, 40.9402, 0.714541286424982, -81.5825, -1.42388323700827),
(19229, '44217', 218, 41, 35429, 40.9585, 0.714860681678097, -81.9058, -1.42952588647997),
(19230, '44221', 218, 41, 154920, 41.143, 0.718080814148027, -81.4734, -1.42197908279435),
(19231, '44222', 218, 41, 154920, 41.1352, 0.717944678466371, -81.484, -1.42216408769506),
(19232, '44223', 218, 41, 154920, 41.1476, 0.718161099293619, -81.5193, -1.42278018892101),
(19233, '44224', 218, 41, 126272, 41.175, 0.718639319508665, -81.4395, -1.42138741617792),
(19234, '44230', 218, 41, 8586, 40.963, 0.714939221494437, -81.689, -1.42574201266165),
(19235, '44231', 218, 41, 155408, 41.2905, 0.720655174794719, -81.0739, -1.41500649243263),
(19236, '44232', 218, 41, 21540, 40.9365, 0.714476709242659, -81.4743, -1.42199479075762),
(19237, '44233', 218, 41, 94928, 41.2462, 0.719881993936085, -81.7449, -1.42671765171351),
(19238, '44234', 218, 41, 9518, 41.3119, 0.721028675254645, -81.1557, -1.41643417176076),
(19239, '44235', 218, 41, 22030, 41.0355, 0.716204585202133, -82.1207, -1.43327659904251),
(19240, '44236', 218, 41, 16505, 41.2474, 0.719902937887109, -81.4387, -1.42137345354391),
(19241, '44237', 218, 41, 16505, 41.2536, 0.720011148300733, -81.4837, -1.4221588517073),
(19242, '44238', 218, 41, 16505, 41.2417, 0.719803454119745, -81.4409, -1.42141185078745),
(19243, '44240', 218, 41, 3501, 41.1529, 0.718253601743974, -81.3257, -1.41940123148915),
(19244, '44241', 218, 41, 157826, 41.2473, 0.719901192557857, -81.3441, -1.41972237207152),
(19245, '44242', 218, 41, 3501, 41.1476, 0.718161099293619, -81.3626, -1.42004525798314),
(19246, '44243', 218, 41, 3501, 41.1337, 0.717918498527591, -81.3407, -1.41966303087695),
(19247, '44250', 218, 41, 156065, 41.0218, 0.71596547509461, -81.4355, -1.42131760300784),
(19248, '44251', 218, 41, 158322, 41.0279, 0.716071940178982, -81.9353, -1.43004075860931),
(19249, '44253', 218, 41, 27727, 41.1587, 0.71835483084059, -82.0236, -1.43158188433882),
(19250, '44254', 218, 41, 112, 41.0429, 0.716333739566781, -82.0177, -1.43147890991295),
(19251, '44255', 218, 41, 3977, 41.2828, 0.720520784442315, -81.2323, -1.41777109396779),
(19252, '44256', 218, 41, 10432, 41.1384, 0.718000529002435, -81.8612, -1.42874746963358),
(19253, '44258', 218, 41, 10432, 41.1008, 0.717344285203685, -82.1244, -1.43334117622483),
(19254, '44260', 218, 41, 156545, 41.0352, 0.716199349214377, -81.3493, -1.41981312919262),
(19255, '44262', 218, 41, 156654, 41.1407, 0.718040671575231, -81.4369, -1.42134203761737),
(19256, '44264', 218, 41, 157078, 41.2301, 0.719600995926514, -81.5512, -1.4233369489524),
(19257, '44265', 218, 41, 5293, 41.0197, 0.715928823180318, -81.3029, -1.4190032964197),
(19258, '44266', 218, 41, 37869, 41.1589, 0.718358321499094, -81.2334, -1.41779029258956),
(19259, '44270', 218, 41, 157379, 40.9671, 0.715010779993769, -81.7806, -1.42734073425647),
(19260, '44272', 218, 41, 157432, 41.0951, 0.717244801436322, -81.2155, -1.41747787865345),
(19261, '44273', 218, 41, 18040, 41.026, 0.716038778923194, -81.8807, -1.42908780883772),
(19262, '44274', 218, 41, 117742, 41.1001, 0.717332067898921, -81.7353, -1.42655010010532),
(19263, '44275', 218, 41, 5995, 41.1002, 0.717333813228173, -82.0917, -1.43277045355943),
(19264, '44276', 218, 41, 25116, 40.9391, 0.714522087803211, -81.8348, -1.42828670271106),
(19265, '44278', 218, 41, 121660, 41.0978, 0.717291925326126, -81.4274, -1.42117623133843),
(19266, '44280', 218, 41, 494, 41.2358, 0.719700479693878, -81.9167, -1.42971612736844),
(19267, '44281', 218, 41, 6590, 41.0324, 0.716150479995321, -81.7335, -1.42651868417879),
(19268, '44282', 218, 41, 6590, 41.0259, 0.716037033593942, -81.7297, -1.42645236166721),
(19269, '44285', 218, 41, 38772, 41.1594, 0.718367048145354, -81.0696, -1.41493144327479),
(19270, '44286', 218, 41, 24305, 41.2322, 0.719637647840806, -81.6389, -1.4248676027064),
(19271, '44287', 218, 41, 28944, 40.9402, 0.714541286424982, -82.0861, -1.43267271512132),
(19272, '44288', 218, 41, 114305, 41.2411, 0.719792982144233, -81.0582, -1.41473247574007),
(19273, '44301', 218, 41, 215, 41.0425, 0.716326758249773, -81.5198, -1.42278891556727),
(19274, '44302', 218, 41, 215, 41.0906, 0.717166261619982, -81.5381, -1.42310831082039),
(19275, '44303', 218, 41, 215, 41.1007, 0.717342539874433, -81.5353, -1.42305944160133),
(19276, '44304', 218, 41, 215, 41.0827, 0.717028380609074, -81.5095, -1.42260914665432),
(19277, '44305', 218, 41, 215, 41.0752, 0.716897480915175, -81.4655, -1.42184120178344),
(19278, '44306', 218, 41, 215, 41.0474, 0.71641227938312, -81.4867, -1.42221121158486),
(19279, '44307', 218, 41, 215, 41.0696, 0.716799742477063, -81.5452, -1.42323222919728),
(19280, '44308', 218, 41, 215, 41.0823, 0.717021399292066, -81.5173, -1.42274528233597),
(19281, '44309', 218, 41, 215, 41.0975, 0.717286689338369, -81.5146, -1.42269815844617),
(19282, '44310', 218, 41, 215, 41.1058, 0.717431551666285, -81.5016, -1.42247126564341),
(19283, '44311', 218, 41, 215, 41.0635, 0.716693277392692, -81.5213, -1.42281509550605),
(19284, '44312', 218, 41, 215, 41.0301, 0.716110337422525, -81.4377, -1.42135600025139),
(19285, '44313', 218, 41, 215, 41.1369, 0.717974349063655, -81.5985, -1.42416248968859),
(19286, '44314', 218, 41, 215, 41.0409, 0.716298832981741, -81.5586, -1.42346610331705),
(19287, '44315', 218, 41, 215, 41.0403, 0.716288361006229, -81.4835, -1.4221553610488),
(19288, '44316', 218, 41, 215, 41.0782, 0.716949840792735, -81.4707, -1.42193195890454),
(19289, '44317', 218, 41, 215, 41.0436, 0.716345956871545, -81.5246, -1.42287269137137),
(19290, '44319', 218, 41, 215, 40.9874, 0.715365081831924, -81.5322, -1.42300533639452),
(19291, '44320', 218, 41, 215, 41.0812, 0.717002200670295, -81.5729, -1.42371568540008),
(19292, '44321', 218, 41, 215, 41.1048, 0.717414098373765, -81.6477, -1.42502119168057),
(19293, '44322', 218, 41, 215, 41.0797, 0.716976020731515, -81.5831, -1.42389370898379),
(19294, '44325', 218, 41, 215, 41.0771, 0.716930642170963, -81.5127, -1.42266499719038),
(19295, '44326', 218, 41, 215, 41.0844, 0.717058051206358, -81.5174, -1.42274702766523),
(19296, '44328', 218, 41, 215, 41.0864, 0.717092957791398, -81.5079, -1.42258122138629),
(19297, '44333', 218, 41, 215, 41.1494, 0.718192515220155, -81.6263, -1.42464769122065),
(19298, '44334', 218, 41, 13090, 41.0815, 0.71700743665805, -81.519, -1.42277495293326),
(19299, '44372', 218, 41, 215, 41.153, 0.718255347073226, -81.6093, -1.42435098524781),
(19300, '44393', 218, 41, 215, 41.0855, 0.71707724982813, -81.508, -1.42258296671554),
(19301, '44396', 218, 41, 215, 41.0658, 0.716733419965487, -81.5211, -1.42281160484755),
(19302, '44398', 218, 41, 215, 41.0825, 0.71702488995057, -81.5081, -1.42258471204479),
(19303, '44399', 218, 41, 215, 41.0849, 0.717066777852618, -81.5162, -1.4227260837142),
(19304, '44401', 218, 41, 129785, 41.0336, 0.716171423946345, -80.9505, -1.41285275613567),
(19305, '44402', 218, 41, 154464, 41.381, 0.722234697767773, -80.8593, -1.41126101585785),
(19306, '44403', 218, 41, 13444, 41.2378, 0.719735386278918, -80.5793, -1.40637409395227),
(19307, '44404', 218, 41, 154535, 41.3332, 0.72140043038532, -80.5443, -1.40576322871407),
(19308, '44405', 218, 41, 1317, 41.0776, 0.716939368817223, -80.5927, -1.40660796807203),
(19309, '44406', 218, 41, 7893, 41.0271, 0.716057977544966, -80.7591, -1.40951219594735),
(19310, '44408', 218, 41, 1717, 40.8737, 0.713380642472406, -80.6828, -1.40818050972808),
(19311, '44410', 218, 41, 29554, 41.3292, 0.721330617215241, -80.7313, -1.4090269944153),
(19312, '44411', 218, 41, 8455, 41.0221, 0.715970711082366, -81.0427, -1.41446194970601),
(19313, '44412', 218, 41, 2039, 41.0956, 0.717253528082582, -81.0413, -1.41443751509648),
(19314, '44413', 218, 41, 155110, 40.8411, 0.712811665136256, -80.5474, -1.40581733392088),
(19315, '44415', 218, 41, 15918, 40.7692, 0.711556773404072, -80.694, -1.4083759866043),
(19316, '44416', 218, 41, 579, 41.0273, 0.71606146820347, -80.8582, -1.41124181723608),
(19317, '44417', 218, 41, 15990, 41.4269, 0.723035803894439, -80.6643, -1.40785762381646),
(19318, '44418', 218, 41, 2578, 41.304, 0.720890794243738, -80.6079, -1.40687325811834),
(19319, '44420', 218, 41, 2718, 41.1613, 0.718400209401142, -80.6899, -1.40830442810497),
(19320, '44422', 218, 41, 155544, 40.9437, 0.714602372948802, -80.7921, -1.41008815460051),
(19321, '44423', 218, 41, 155605, 40.7651, 0.71148521490474, -80.9046, -1.412051650009),
(19322, '44424', 218, 41, 2998, 41.3142, 0.721068817827441, -80.5711, -1.4062309769536),
(19323, '44425', 218, 41, 3261, 41.1627, 0.71842464401067, -80.5802, -1.40638980191553),
(19324, '44427', 218, 41, 22347, 40.7329, 0.710923218885598, -80.9506, -1.41285450146492),
(19325, '44428', 218, 41, 120225, 41.4375, 0.72322080879515, -80.5809, -1.4064020192203),
(19326, '44429', 218, 41, 156046, 41.1023, 0.717370465142465, -80.9824, -1.41340951616706),
(19327, '44430', 218, 41, 156101, 41.242, 0.719808690107501, -80.8849, -1.41170782014636),
(19328, '44431', 218, 41, 136455, 40.8596, 0.713134551047875, -80.7554, -1.40944761876503),
(19329, '44432', 218, 41, 10116, 40.762, 0.711431109697929, -80.7587, -1.40950521463034),
(19330, '44436', 218, 41, 156244, 41.0519, 0.71649081919946, -80.5452, -1.40577893667734),
(19331, '44437', 218, 41, 815, 41.1592, 0.71836355748685, -80.7307, -1.40901652243979),
(19332, '44438', 218, 41, 156368, 41.2251, 0.719513729463914, -80.5341, -1.40558520513037),
(19333, '44439', 218, 41, 156448, 41.4627, 0.723660631766653, -80.9537, -1.41290860667173),
(19334, '44440', 218, 41, 156528, 41.1432, 0.718084304806531, -80.7732, -1.40975828737188),
(19335, '44441', 218, 41, 96458, 40.7746, 0.71165102118368, -80.5576, -1.40599535750458),
(19336, '44442', 218, 41, 30644, 40.9662, 0.714995072030501, -80.5545, -1.40594125229777),
(19337, '44443', 218, 41, 156750, 40.9258, 0.714289959012695, -80.5986, -1.4067109424979),
(19338, '44444', 218, 41, 151087, 41.1873, 0.71885399500666, -80.9688, -1.41317215138878),
(19339, '44445', 218, 41, 156753, 40.8453, 0.71288496896484, -80.6206, -1.40709491493334),
(19340, '44446', 218, 41, 17280, 41.1873, 0.71885399500666, -80.7499, -1.40935162565617),
(19341, '44449', 218, 41, 137160, 40.9973, 0.715537869427871, -81.026, -1.41417047972093),
(19342, '44450', 218, 41, 113809, 41.4472, 0.723390105732594, -80.8317, -1.4107793049843),
(19343, '44451', 218, 41, 156817, 41.0817, 0.717010927316554, -80.8658, -1.41137446225923),
(19344, '44452', 218, 41, 156824, 40.9515, 0.714738508630458, -80.6575, -1.40773894142733),
(19345, '44453', 218, 41, 30739, 41.3366, 0.721459771579888, -80.5223, -1.40537925627863),
(19346, '44454', 218, 41, 14402, 40.9184, 0.714160804648048, -80.5357, -1.4056131303984),
(19347, '44455', 218, 41, 874, 40.7801, 0.71174701429254, -80.6046, -1.40681566225302),
(19348, '44460', 218, 41, 126, 40.8843, 0.713565647373118, -80.8699, -1.41144602075856),
(19349, '44470', 218, 41, 114103, 41.2997, 0.720815745085902, -80.9526, -1.41288940804996),
(19350, '44471', 218, 41, 157837, 41.0521, 0.716494309857964, -80.5923, -1.40660098675503),
(19351, '44473', 218, 41, 6557, 41.2395, 0.719765056876202, -80.6615, -1.40780875459741),
(19352, '44481', 218, 41, 12663, 41.2197, 0.719419481684307, -80.8583, -1.41124356256533),
(19353, '44482', 218, 41, 12663, 41.1936, 0.718963950749536, -80.8266, -1.41069029319245),
(19354, '44483', 218, 41, 12663, 41.2534, 0.720007657642229, -80.8134, -1.41045990973119),
(19355, '44484', 218, 41, 12663, 41.2282, 0.719567834670726, -80.7606, -1.40953837588613),
(19356, '44485', 218, 41, 12663, 41.2369, 0.71971967831565, -80.8435, -1.41098525383604),
(19357, '44486', 218, 41, 12663, 41.3017, 0.720850651670942, -80.8406, -1.41093463928773),
(19358, '44487', 218, 41, 12663, 41.2373, 0.719726659632658, -80.8187, -1.41055241218154),
(19359, '44488', 218, 41, 12663, 41.2374, 0.71972840496191, -80.8163, -1.41051052427949),
(19360, '44490', 218, 41, 146572, 40.8977, 0.713799521492885, -80.7621, -1.40956455582491),
(19361, '44491', 218, 41, 129252, 41.3701, 0.722044456879306, -80.9605, -1.41302728906087),
(19362, '44492', 218, 41, 6722, 40.7083, 0.710493867889608, -80.7021, -1.40851735827372),
(19363, '44493', 218, 41, 904, 40.8251, 0.712532412455937, -80.8989, -1.41195216624164),
(19364, '44501', 218, 41, 13011, 41.0966, 0.717270981375102, -80.6597, -1.40777733867087),
(19365, '44502', 218, 41, 13011, 41.0853, 0.717073759169626, -80.6432, -1.40748935934429),
(19366, '44503', 218, 41, 13011, 41.0988, 0.717309378618645, -80.654, -1.40767785490351),
(19367, '44504', 218, 41, 13011, 41.1232, 0.717735238956132, -80.6564, -1.40771974280555),
(19368, '44505', 218, 41, 13011, 41.1151, 0.717593867286721, -80.6114, -1.40693434464216),
(19369, '44506', 218, 41, 13011, 41.0965, 0.71726923604585, -80.6267, -1.40720138001771),
(19370, '44507', 218, 41, 13011, 41.0743, 0.716881772951907, -80.6549, -1.40769356286677),
(19371, '44509', 218, 41, 13011, 41.1065, 0.717443768971049, -80.6935, -1.40836725995804),
(19372, '44510', 218, 41, 13011, 41.1197, 0.717674152432312, -80.6693, -1.40794489027906),
(19373, '44511', 218, 41, 13011, 41.0695, 0.716797997147811, -80.6974, -1.40843532779887),
(19374, '44512', 218, 41, 13011, 41.0321, 0.716145244007565, -80.6675, -1.40791347435253),
(19375, '44513', 218, 41, 13011, 41.0241, 0.716005617667406, -80.6752, -1.40804786470493),
(19376, '44514', 218, 41, 13011, 41.0181, 0.715900897912286, -80.6143, -1.40698495919046),
(19377, '44515', 218, 41, 13011, 41.0997, 0.717325086581913, -80.7506, -1.40936384296093),
(19378, '44555', 218, 41, 13011, 41.1034, 0.717389663764237, -80.6428, -1.40748237802728),
(19379, '44598', 218, 41, 13011, 41.0989, 0.717311123947898, -80.6469, -1.40755393652662),
(19380, '44599', 218, 41, 13011, 41.1009, 0.717346030532937, -80.6492, -1.40759407909941),
(19381, '44601', 218, 41, 14970, 40.9176, 0.714146842014032, -81.1334, -1.41604496333757),
(19382, '44606', 218, 41, 53202, 40.7391, 0.711031429299222, -81.8055, -1.42777532124022),
(19383, '44607', 218, 41, 7193, 40.6814, 0.710024374320821, -81.0197, -1.41406052397805),
(19384, '44608', 218, 41, 92505, 40.6562, 0.709584551349319, -81.5844, -1.42391639826406),
(19385, '44609', 218, 41, 309, 40.9316, 0.714391188109311, -80.9907, -1.41355437849497),
(19386, '44610', 218, 41, 376, 40.5564, 0.707842712755828, -81.8111, -1.42787305967833),
(19387, '44611', 218, 41, 129818, 40.6342, 0.70920057891388, -82.0928, -1.4327896521812),
(19388, '44612', 218, 41, 1034, 40.6415, 0.709327987949275, -81.4439, -1.42146421066501),
(19389, '44613', 218, 41, 15318, 40.7137, 0.710588115669215, -81.5968, -1.42413281909131),
(19390, '44614', 218, 41, 154588, 40.8858, 0.713591827311898, -81.5663, -1.42360049366945),
(19391, '44615', 218, 41, 1380, 40.5594, 0.707895072633388, -81.0844, -1.41518975200409),
(19392, '44617', 218, 41, 154690, 40.5066, 0.706973538788335, -81.7855, -1.42742625538982),
(19393, '44618', 218, 41, 8391, 40.7828, 0.711794138182343, -81.6991, -1.4259182909161),
(19394, '44619', 218, 41, 1957, 40.9009, 0.713855372028949, -80.9566, -1.41295922122004),
(19395, '44620', 218, 41, 154972, 40.5752, 0.708170834655203, -81.2126, -1.41742726410515),
(19396, '44621', 218, 41, 462, 40.3949, 0.705024006013857, -81.3303, -1.41948151663474),
(19397, '44622', 218, 41, 8583, 40.5286, 0.707357511223774, -81.4762, -1.4220279520134),
(19398, '44624', 218, 41, 2134, 40.6205, 0.708961468806357, -81.713, -1.42616089168213),
(19399, '44625', 218, 41, 143766, 40.7683, 0.711541065440804, -80.9968, -1.41366084357934),
(19400, '44626', 218, 41, 155106, 40.6932, 0.710230323172556, -81.3764, -1.42028611341991),
(19401, '44627', 218, 41, 29848, 40.6861, 0.710106404795665, -81.8538, -1.42861831526893),
(19402, '44628', 218, 41, 47494, 40.5381, 0.707523317502713, -82.2202, -1.43501320164824),
(19403, '44629', 218, 41, 155474, 40.3585, 0.704388706166131, -81.4316, -1.42124953516701),
(19404, '44630', 218, 41, 65223, 40.9291, 0.714347554878011, -81.4026, -1.42074338968394),
(19405, '44631', 218, 41, 155621, 40.52, 0.707207412908102, -80.9968, -1.41366084357934),
(19406, '44632', 218, 41, 55196, 40.9586, 0.714862427007349, -81.3262, -1.41940995813541),
(19407, '44633', 218, 41, 22024, 40.6214, 0.708977176769625, -81.9172, -1.4297248540147),
(19408, '44634', 218, 41, 155777, 40.8333, 0.712675529454601, -81.0477, -1.41454921616861),
(19409, '44636', 218, 41, 155982, 40.7404, 0.711054118579498, -81.7446, -1.42671241572576),
(19410, '44637', 218, 41, 155981, 40.501, 0.706875800350223, -81.9901, -1.4309971990394),
(19411, '44638', 218, 41, 16832, 40.6216, 0.708980667428129, -82.1363, -1.43354887040582),
(19412, '44639', 218, 41, 30315, 40.4471, 0.705935067883398, -81.2183, -1.41752674787251),
(19413, '44640', 218, 41, 156158, 40.9828, 0.715284796686332, -81.1486, -1.41631025338387),
(19414, '44641', 218, 41, 3876, 40.8461, 0.712898931598856, -81.2606, -1.4182650221461),
(19415, '44643', 218, 41, 3947, 40.6683, 0.70979573618881, -81.3084, -1.41909928952856),
(19416, '44644', 218, 41, 3963, 40.6841, 0.710071498210625, -81.1984, -1.41717942735136),
(19417, '44645', 218, 41, 22897, 40.908, 0.71397929040584, -81.7282, -1.42642618172843),
(19418, '44646', 218, 41, 112212, 40.8051, 0.712183346605538, -81.5187, -1.4227697169455),
(19419, '44647', 218, 41, 112212, 40.7978, 0.712055937570143, -81.5545, -1.42339454481772),
(19420, '44648', 218, 41, 112212, 40.7549, 0.711307191321037, -81.5163, -1.42272782904345),
(19421, '44650', 218, 41, 156372, 40.8761, 0.713422530374454, -81.1743, -1.41675880300163),
(19422, '44651', 218, 41, 110388, 40.632, 0.709162181670336, -80.9593, -1.41300634510985),
(19423, '44652', 218, 41, 156462, 40.8977, 0.713799521492885, -81.3266, -1.41941693945242),
(19424, '44653', 218, 41, 117, 40.4372, 0.705762280287451, -81.3726, -1.42021979090834),
(19425, '44654', 218, 41, 30514, 40.5473, 0.707683887793897, -81.8744, -1.42897785309485),
(19426, '44656', 218, 41, 30529, 40.594, 0.708498956554578, -81.3559, -1.41992832092325),
(19427, '44657', 218, 41, 37221, 40.7512, 0.711242614138713, -81.1163, -1.41574651203548),
(19428, '44659', 218, 41, 156626, 40.695, 0.710261739099092, -81.702, -1.42596890546441),
(19429, '44660', 218, 41, 4376, 40.6248, 0.709036517964192, -81.7892, -1.42749083257215),
(19430, '44661', 218, 41, 10729, 40.5942, 0.708502447213082, -82.1009, -1.43293102385061),
(19431, '44662', 218, 41, 17243, 40.7189, 0.710678872790319, -81.5317, -1.42299660974826),
(19432, '44663', 218, 41, 28042, 40.489, 0.706666360839984, -81.4451, -1.42148515461603),
(19433, '44665', 218, 41, 96594, 40.8408, 0.7128064291485, -80.9862, -1.41347583867863),
(19434, '44666', 218, 41, 151223, 40.8314, 0.712642368198813, -81.6163, -1.42447315829545),
(19435, '44667', 218, 41, 4801, 40.8356, 0.712715672027396, -81.77, -1.42715572935576),
(19436, '44669', 218, 41, 11069, 40.7901, 0.711921547217739, -81.1607, -1.41652143822336),
(19437, '44670', 218, 41, 11624, 40.7623, 0.711436345685685, -81.188, -1.41699791310916),
(19438, '44671', 218, 41, 51218, 40.6421, 0.709338459924787, -81.3695, -1.42016568570153),
(19439, '44672', 218, 41, 18023, 40.9219, 0.714221891171868, -81.0273, -1.4141931690012),
(19440, '44675', 218, 41, 157636, 40.5185, 0.707181232969322, -81.2361, -1.41783741647937),
(19441, '44676', 218, 41, 5840, 40.697, 0.710296645684132, -82.0368, -1.43181226780008),
(19442, '44677', 218, 41, 12002, 40.8686, 0.713291630680555, -81.8582, -1.42869510975602),
(19443, '44678', 218, 41, 71406, 40.5668, 0.708024226998036, -81.3605, -1.42000860606885),
(19444, '44679', 218, 41, 12131, 40.319, 0.703699301111594, -81.3118, -1.41915863072313),
(19445, '44680', 218, 41, 28710, 40.5995, 0.708594949663438, -81.5308, -1.42298090178499),
(19446, '44681', 218, 41, 25209, 40.5036, 0.706921178910775, -81.641, -1.42490425462069),
(19447, '44682', 218, 41, 158008, 40.398, 0.705078111220669, -81.4049, -1.42078353225673),
(19448, '44683', 218, 41, 158027, 40.394, 0.705008298050589, -81.3487, -1.41980265721711),
(19449, '44685', 218, 41, 6475, 40.9626, 0.714932240177429, -81.3897, -1.42051824221043),
(19450, '44687', 218, 41, 25789, 40.5412, 0.707577422709525, -81.7213, -1.42630575401004),
(19451, '44688', 218, 41, 484, 40.6857, 0.710099423478657, -81.2684, -1.41840115782776),
(19452, '44689', 218, 41, 12881, 40.6566, 0.709591532666327, -81.6351, -1.42480128019482),
(19453, '44690', 218, 41, 12898, 40.6161, 0.708884674319269, -81.7061, -1.42604046396374),
(19454, '44691', 218, 41, 12957, 40.8075, 0.712225234507586, -81.957, -1.43041949505699),
(19455, '44693', 218, 41, 154959, 40.3077, 0.703502078906118, -81.1877, -1.4169926771214),
(19456, '44695', 218, 41, 154407, 40.4159, 0.705390525156776, -81.1771, -1.41680767222069),
(19457, '44697', 218, 41, 7009, 40.6141, 0.708849767734229, -81.4243, -1.42112212613162),
(19458, '44699', 218, 41, 123803, 40.2807, 0.70303084000808, -81.2698, -1.41842559243729),
(19459, '44701', 218, 41, 19763, 40.7304, 0.710879585654298, -81.453, -1.42162303562694),
(19460, '44702', 218, 41, 19763, 40.799, 0.712076881521167, -81.3756, -1.4202721507859),
(19461, '44703', 218, 41, 19763, 40.8074, 0.712223489178334, -81.369, -1.42015695905527),
(19462, '44704', 218, 41, 19763, 40.7996, 0.712087353496678, -81.3532, -1.41988119703345),
(19463, '44705', 218, 41, 19763, 40.8224, 0.712485288566133, -81.3388, -1.41962986962116),
(19464, '44706', 218, 41, 19763, 40.772, 0.711605642623128, -81.4129, -1.42092315859689),
(19465, '44707', 218, 41, 19763, 40.7833, 0.711802864828603, -81.3599, -1.41999813409333),
(19466, '44708', 218, 41, 19763, 40.8121, 0.712305519653178, -81.4269, -1.42116750469217),
(19467, '44709', 218, 41, 19763, 40.8387, 0.712769777234208, -81.3882, -1.42049206227165),
(19468, '44710', 218, 41, 19763, 40.7912, 0.711940745839511, -81.421, -1.4210645302663),
(19469, '44711', 218, 41, 19763, 40.8275, 0.712574300357985, -81.3854, -1.42044319305259),
(19470, '44712', 218, 41, 19763, 40.7991, 0.712078626850419, -81.3739, -1.42024248018861),
(19471, '44714', 218, 41, 19763, 40.8293, 0.712605716284521, -81.3602, -1.42000337008109),
(19472, '44718', 218, 41, 19763, 40.8524, 0.713008887341732, -81.4436, -1.42145897467725),
(19473, '44720', 218, 41, 19763, 40.8855, 0.713586591324142, -81.4143, -1.42094759320642),
(19474, '44721', 218, 41, 19763, 40.8832, 0.713546448751346, -81.3339, -1.41954434848782),
(19475, '44730', 218, 41, 19763, 40.7818, 0.711776684889823, -81.2781, -1.4185704547652),
(19476, '44735', 218, 41, 19763, 40.852, 0.713001906024723, -81.4418, -1.42142755875072),
(19477, '44750', 218, 41, 19763, 40.7904, 0.711926783205495, -81.4222, -1.42108547421733),
(19478, '44760', 218, 41, 19763, 40.8515, 0.712993179378464, -81.4546, -1.42165096089497),
(19479, '44767', 218, 41, 19763, 40.8937, 0.713729708322805, -81.4248, -1.42113085277788),
(19480, '44798', 218, 41, 19763, 40.8268, 0.712562083053221, -81.3846, -1.42042923041858),
(19481, '44799', 218, 41, 19763, 40.8119, 0.712302028994674, -81.3734, -1.42023375354235),
(19482, '44801', 218, 41, 18746, 41.1042, 0.717403626398253, -83.2674, -1.45329028957513),
(19483, '44802', 218, 41, 154052, 41.0392, 0.716269162384457, -83.4473, -1.45643013689946),
(19484, '44803', 218, 41, 113229, 41.2153, 0.719342687197219, -83.3316, -1.45441079095491),
(19485, '44804', 218, 41, 7137, 41.1079, 0.717468203580577, -83.525, -1.45778625772826),
(19486, '44805', 218, 41, 13301, 40.8606, 0.713152004340395, -82.3163, -1.43669046305941),
(19487, '44807', 218, 41, 7188, 41.0704, 0.716813705111079, -82.891, -1.44672087027062),
(19488, '44809', 218, 41, 15103, 41.1322, 0.717892318588812, -83.2861, -1.45361666614525),
(19489, '44811', 218, 41, 270, 41.2543, 0.720023365605497, -82.8181, -1.44544852524592),
(19490, '44813', 218, 41, 7390, 40.6106, 0.708788681210409, -82.5165, -1.4401846122219),
(19491, '44814', 218, 41, 70538, 41.3251, 0.721259058715909, -82.4787, -1.43952487776465),
(19492, '44815', 218, 41, 154309, 41.2458, 0.719875012619077, -83.2325, -1.45268116966618),
(19493, '44816', 218, 41, 799, 41.3288, 0.721323635898232, -82.3577, -1.43741302936973),
(19494, '44817', 218, 41, 92690, 41.1959, 0.719004093322332, -83.5502, -1.45822608069977),
(19495, '44818', 218, 41, 79834, 40.9561, 0.71481879377605, -82.9748, -1.44818345618379),
(19496, '44820', 218, 41, 31910, 40.8158, 0.712370096835502, -82.9706, -1.44811015235521),
(19497, '44822', 218, 41, 1257, 40.5843, 0.708329659617135, -82.4149, -1.43841135770187),
(19498, '44824', 218, 41, 63498, 41.3848, 0.722301020279349, -82.8008, -1.44514658328532),
(19499, '44825', 218, 41, 8043, 40.9515, 0.714738508630458, -82.943, -1.44762844148166),
(19500, '44826', 218, 41, 308, 41.2356, 0.719696989035374, -82.4857, -1.43964705081229),
(19501, '44827', 218, 41, 32179, 40.7995, 0.712085608167427, -82.7607, -1.44444670625527),
(19502, '44828', 218, 41, 2479, 41.2363, 0.719709206340138, -82.8589, -1.44616061958073),
(19503, '44830', 218, 41, 2568, 41.1833, 0.718784181836581, -83.4071, -1.45572851454016),
(19504, '44833', 218, 41, 41033, 40.7374, 0.711001758701938, -82.7995, -1.44512389400504),
(19505, '44836', 218, 41, 41182, 41.2331, 0.719653355804074, -83.0724, -1.44988689753374),
(19506, '44837', 218, 41, 32630, 41.0349, 0.716194113226621, -82.5075, -1.44002753258922),
(19507, '44838', 218, 41, 65448, 40.7722, 0.711609133281632, -82.2602, -1.43571133334904),
(19508, '44839', 218, 41, 30131, 41.3895, 0.722383050754193, -82.56, -1.44094383044652),
(19509, '44840', 218, 41, 155916, 40.8094, 0.712258395763374, -82.1888, -1.43446516826312),
(19510, '44841', 218, 41, 3481, 41.2454, 0.719868031302069, -83.3019, -1.45389242816706),
(19511, '44842', 218, 41, 150398, 40.645, 0.709389074473095, -82.2304, -1.43519122523195),
(19512, '44843', 218, 41, 10220, 40.6922, 0.710212869880037, -82.4042, -1.43822460747191),
(19513, '44844', 218, 41, 156392, 40.9803, 0.715241163455032, -83.2697, -1.45333043214792),
(19514, '44845', 218, 41, 156434, 41.0296, 0.716101610776265, -83.132, -1.45092711376793),
(19515, '44846', 218, 41, 23084, 41.3079, 0.720958862084566, -82.6043, -1.44171701130515),
(19516, '44847', 218, 41, 4273, 41.2151, 0.719339196538715, -82.7137, -1.44362640150683),
(19517, '44848', 218, 41, 23308, 40.9214, 0.714213164525608, -82.2812, -1.43607785249196),
(19518, '44849', 218, 41, 37398, 40.8147, 0.71235089821373, -83.1388, -1.45104579615706),
(19519, '44850', 218, 41, 4528, 41.0346, 0.716188877238865, -82.6805, -1.44304695219517),
(19520, '44851', 218, 41, 4547, 41.1021, 0.717366974483961, -82.4214, -1.43852480410325),
(19521, '44853', 218, 41, 156743, 41.0524, 0.71649954584572, -83.3081, -1.45400063858069),
(19522, '44854', 218, 41, 30655, 40.9493, 0.714700111386914, -82.8523, -1.4460454278501),
(19523, '44855', 218, 41, 128305, 41.1042, 0.717403626398253, -82.5977, -1.44160181957452),
(19524, '44856', 218, 41, 156843, 40.7926, 0.711965180449039, -82.8572, -1.44613094898345),
(19525, '44857', 218, 41, 17325, 41.2355, 0.719695243706122, -82.6028, -1.44169083136637),
(19526, '44859', 218, 41, 78863, 41.0024, 0.715626881219723, -82.3443, -1.43717915524997);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(19527, '44860', 218, 41, 4732, 40.8509, 0.712982707402952, -83.0949, -1.45027959661544),
(19528, '44861', 218, 41, 67456, 41.2396, 0.719766802205454, -83.1512, -1.45126221698431),
(19529, '44862', 218, 41, 33502, 40.7612, 0.711417147063913, -82.6463, -1.44245004959099),
(19530, '44864', 218, 41, 123418, 40.6512, 0.709497284886719, -82.3131, -1.43663461252334),
(19531, '44865', 218, 41, 14433, 40.9827, 0.71528305135708, -82.6693, -1.44285147531895),
(19532, '44866', 218, 41, 5163, 40.9307, 0.714375480146043, -82.2036, -1.43472347699241),
(19533, '44867', 218, 41, 5356, 41.1422, 0.718066851514011, -82.9976, -1.44858139125325),
(19534, '44870', 218, 41, 5646, 41.4335, 0.723150995625071, -82.7154, -1.44365607210412),
(19535, '44871', 218, 41, 5646, 41.4488, 0.723418031000626, -82.7079, -1.44352517241022),
(19536, '44874', 218, 41, 24690, 40.9665, 0.715000308018257, -82.3652, -1.43754392906363),
(19537, '44875', 218, 41, 59, 40.8817, 0.713520268812566, -82.6514, -1.44253906138284),
(19538, '44878', 218, 41, 5817, 40.9499, 0.714710583362426, -82.5475, -1.44072566429002),
(19539, '44880', 218, 41, 28723, 41.0302, 0.716112082751777, -82.216, -1.43493989781966),
(19540, '44881', 218, 41, 6137, 40.8703, 0.713321301277838, -82.8805, -1.44653761069916),
(19541, '44882', 218, 41, 6199, 40.9513, 0.714735017971954, -83.1706, -1.4516008108592),
(19542, '44883', 218, 41, 57899, 41.1212, 0.717700332371092, -83.1773, -1.45171774791908),
(19543, '44887', 218, 41, 157953, 40.9021, 0.713876315979973, -82.791, -1.44497554101863),
(19544, '44888', 218, 41, 26074, 41.0554, 0.71655190572328, -82.7255, -1.44383235035857),
(19545, '44889', 218, 41, 158137, 41.2254, 0.71951896545167, -82.4021, -1.43818795555762),
(19546, '44890', 218, 41, 26074, 41.0727, 0.716853847683875, -82.7243, -1.44381140640755),
(19547, '44901', 218, 41, 3975, 40.6843, 0.710074988869129, -82.5864, -1.44140459736905),
(19548, '44902', 218, 41, 3975, 40.759, 0.711378749820369, -82.5124, -1.44011305372257),
(19549, '44903', 218, 41, 3975, 40.7624, 0.711438091014937, -82.5186, -1.44022126413619),
(19550, '44904', 218, 41, 3975, 40.6862, 0.710108150124917, -82.5662, -1.44105204086014),
(19551, '44905', 218, 41, 3975, 40.7765, 0.711684182439468, -82.4793, -1.43953534974016),
(19552, '44906', 218, 41, 3975, 40.7625, 0.711439836344189, -82.5668, -1.44106251283565),
(19553, '44907', 218, 41, 3975, 40.7323, 0.710912746910086, -82.5233, -1.44030329461104),
(19554, '44999', 218, 41, 3975, 40.7628, 0.711445072331945, -82.5269, -1.44036612646411),
(19555, '45001', 218, 41, 71628, 39.1385, 0.683095689291801, -84.7099, -1.47846666403514),
(19556, '45002', 218, 41, 72141, 39.1823, 0.683860143504174, -84.7231, -1.47869704749641),
(19557, '45003', 218, 41, 29531, 39.5878, 0.690937453621011, -84.7862, -1.47979835025442),
(19558, '45004', 218, 41, 1706, 39.5151, 0.689668599254811, -84.6085, -1.47669690017362),
(19559, '45005', 218, 41, 2595, 39.5496, 0.690270737846749, -84.3016, -1.47134048469925),
(19560, '45011', 218, 41, 2950, 39.4052, 0.68775048240687, -84.5092, -1.47496378822639),
(19561, '45012', 218, 41, 2950, 39.4738, 0.688947778273738, -84.6832, -1.47800066112486),
(19562, '45013', 218, 41, 2950, 39.4077, 0.687794115638169, -84.6161, -1.47682954519677),
(19563, '45014', 218, 41, 2367, 39.3278, 0.686399597565826, -84.5525, -1.47571951579251),
(19564, '45015', 218, 41, 2950, 39.3676, 0.68709423860812, -84.5495, -1.47566715591495),
(19565, '45018', 218, 41, 2367, 39.4321, 0.688219975975656, -84.4954, -1.47472293278962),
(19566, '45020', 218, 41, 2950, 39.3874, 0.687439813800015, -84.5678, -1.47598655116806),
(19567, '45023', 218, 41, 2950, 39.3722, 0.687174523753711, -84.5304, -1.47533379802781),
(19568, '45025', 218, 41, 2950, 39.3992, 0.68764576265175, -84.5638, -1.47591673799798),
(19569, '45026', 218, 41, 2950, 39.4021, 0.687696377200058, -84.5593, -1.47583819818164),
(19570, '45030', 218, 41, 9353, 39.2571, 0.685165649784666, -84.7676, -1.47947371901355),
(19571, '45032', 218, 41, 30032, 39.5032, 0.689460905073824, -84.008, -1.4662161980154),
(19572, '45033', 218, 41, 72948, 39.1766, 0.683760659736811, -84.7626, -1.47938645255095),
(19573, '45034', 218, 41, 73115, 39.3544, 0.686863855146856, -84.2506, -1.47045036678073),
(19574, '45036', 218, 41, 3708, 39.4476, 0.688490502009715, -84.21, -1.46974176310442),
(19575, '45039', 218, 41, 73342, 39.3189, 0.686244263262398, -84.2553, -1.47053239725558),
(19576, '45040', 218, 41, 17048, 39.3441, 0.686684086233901, -84.3144, -1.47156388684351),
(19577, '45041', 218, 41, 73454, 39.2137, 0.6844081768893, -84.7036, -1.47835670829227),
(19578, '45042', 218, 41, 14224, 39.5303, 0.689933889301114, -84.3911, -1.47290255437979),
(19579, '45043', 218, 41, 14224, 39.5189, 0.689734921766387, -84.3992, -1.4730439260492),
(19580, '45044', 218, 41, 14224, 39.4855, 0.689151981796221, -84.3824, -1.47275071073486),
(19581, '45050', 218, 41, 10560, 39.4441, 0.688429415485895, -84.3716, -1.47256221517565),
(19582, '45051', 218, 41, 73590, 39.096, 0.682353924359703, -84.6403, -1.47725191487576),
(19583, '45052', 218, 41, 23407, 39.1566, 0.683411593886412, -84.7252, -1.4787336994107),
(19584, '45053', 218, 41, 73775, 39.3441, 0.686684086233901, -84.7838, -1.47975646235237),
(19585, '45054', 218, 41, 73799, 39.4493, 0.688520172606999, -84.0811, -1.4674920336986),
(19586, '45055', 218, 41, 73812, 39.4516, 0.688560315179795, -84.5158, -1.47507897995702),
(19587, '45056', 218, 41, 4828, 39.4959, 0.689333496038428, -84.7437, -1.47905658532232),
(19588, '45061', 218, 41, 11692, 39.3109, 0.686104636922239, -84.6478, -1.47738281456966),
(19589, '45062', 218, 41, 74257, 39.4803, 0.689061224675117, -84.5539, -1.47574395040203),
(19590, '45063', 218, 41, 74268, 39.327, 0.68638563493181, -84.7153, -1.47856091181475),
(19591, '45064', 218, 41, 5947, 39.5529, 0.690328333712065, -84.6321, -1.47710879787709),
(19592, '45065', 218, 41, 74353, 39.3713, 0.687158815790443, -84.2137, -1.46980634028675),
(19593, '45066', 218, 41, 74384, 39.5594, 0.690441780113445, -84.2238, -1.4699826185412),
(19594, '45067', 218, 41, 6381, 39.4712, 0.688902399713186, -84.4578, -1.47406668899087),
(19595, '45068', 218, 41, 25859, 39.5277, 0.689888510740563, -84.0911, -1.4676665666238),
(19596, '45069', 218, 41, 79370, 39.3441, 0.686684086233901, -84.3978, -1.47301949143967),
(19597, '45070', 218, 41, 74766, 39.5892, 0.690961888230539, -84.5547, -1.47575791303605),
(19598, '45071', 218, 41, 79370, 39.3334, 0.686497336003938, -84.4048, -1.47314166448731),
(19599, '45073', 218, 41, 10560, 39.5126, 0.689624966023511, -84.4078, -1.47319402436487),
(19600, '45099', 218, 41, 10560, 39.4459, 0.688460831412431, -84.348, -1.47215031747218),
(19601, '45101', 218, 41, 7017, 38.6767, 0.675035758806091, -83.7516, -1.46174117381328),
(19602, '45102', 218, 41, 39096, 39.03, 0.681202007053387, -84.2185, -1.46989011609084),
(19603, '45103', 218, 41, 7293, 39.092, 0.682284111189623, -84.174, -1.46911344457371),
(19604, '45105', 218, 41, 647, 38.7506, 0.676325557123315, -83.6125, -1.45931342082376),
(19605, '45106', 218, 41, 220, 38.948, 0.679770837066751, -84.0976, -1.46778001302518),
(19606, '45107', 218, 41, 71838, 39.307, 0.686036569081411, -83.963, -1.465430799852),
(19607, '45110', 218, 41, 7769, 39.144, 0.68319168240066, -83.5962, -1.45902893215568),
(19608, '45111', 218, 41, 71997, 39.1956, 0.684092272294689, -84.2913, -1.4711607157863),
(19609, '45112', 218, 41, 72096, 38.7925, 0.6770568500799, -84.1402, -1.46852352328653),
(19610, '45113', 218, 41, 848, 39.4047, 0.68774175576061, -83.9637, -1.46544301715676),
(19611, '45114', 218, 41, 1912, 39.361, 0.686979046877488, -83.8624, -1.46367499862449),
(19612, '45115', 218, 41, 2007, 38.8141, 0.677433841198331, -83.7004, -1.46084756523626),
(19613, '45118', 218, 41, 2428, 39.1814, 0.683844435540906, -83.9514, -1.46522834165877),
(19614, '45119', 218, 41, 72534, 38.878, 0.678549106590355, -83.9993, -1.46606435437047),
(19615, '45120', 218, 41, 72536, 38.8251, 0.67762582741605, -84.1038, -1.46788822343881),
(19616, '45121', 218, 41, 2693, 38.878, 0.678549106590355, -83.8966, -1.46427190122867),
(19617, '45122', 218, 41, 419, 39.2236, 0.684580964485248, -84.1387, -1.46849734334775),
(19618, '45123', 218, 41, 2861, 39.3318, 0.686469410735906, -83.4116, -1.4558070543565),
(19619, '45130', 218, 41, 72792, 38.9093, 0.67909539464623, -83.9851, -1.46581651761669),
(19620, '45131', 218, 41, 72893, 38.7905, 0.67702194349486, -83.9673, -1.46550584900983),
(19621, '45132', 218, 41, 3108, 39.3442, 0.686685831563153, -83.603, -1.45914761454482),
(19622, '45133', 218, 41, 3145, 39.1667, 0.683587872140863, -83.5811, -1.45876538743863),
(19623, '45135', 218, 41, 3721, 39.3353, 0.686530497259725, -83.5459, -1.45815103154193),
(19624, '45138', 218, 41, 41773, 39.4235, 0.688069877659985, -83.6547, -1.4600499497681),
(19625, '45140', 218, 41, 73286, 39.2673, 0.685343673368369, -84.2923, -1.47117816907882),
(19626, '45142', 218, 41, 16971, 39.2041, 0.684240625281109, -83.7879, -1.46237472833176),
(19627, '45144', 218, 41, 585, 38.7024, 0.675484308423853, -83.6111, -1.45928898621423),
(19628, '45145', 218, 41, 17017, 39.1297, 0.682942100317625, -83.9727, -1.46560009678944),
(19629, '45146', 218, 41, 27817, 39.3167, 0.686205866018854, -83.7963, -1.46252133598892),
(19630, '45147', 218, 41, 73455, 39.2147, 0.68442563018182, -84.2999, -1.47131081410197),
(19631, '45148', 218, 41, 10461, 39.2927, 0.685786986998376, -83.8885, -1.46413052955926),
(19632, '45150', 218, 41, 10480, 39.1791, 0.68380429296811, -84.2432, -1.47032121241609),
(19633, '45152', 218, 41, 587, 39.3503, 0.686792296647525, -84.1289, -1.46832630108106),
(19634, '45153', 218, 41, 4344, 38.8618, 0.678266363251532, -84.202, -1.46960213676427),
(19635, '45154', 218, 41, 73583, 39.0488, 0.681530128952762, -83.9296, -1.46484785988183),
(19636, '45155', 218, 41, 73600, 39.0384, 0.681348614710554, -83.752, -1.46174815513029),
(19637, '45156', 218, 41, 61029, 38.8099, 0.677360537369747, -84.211, -1.46975921639694),
(19638, '45157', 218, 41, 177, 38.9566, 0.679920935382423, -84.2464, -1.47037706295215),
(19639, '45158', 218, 41, 73692, 39.1819, 0.683853162187166, -84.0878, -1.46760897075849),
(19640, '45159', 218, 41, 73682, 39.3437, 0.686677104916893, -83.6975, -1.46079695068795),
(19641, '45160', 218, 41, 11032, 39.1231, 0.682826908586994, -84.1374, -1.46847465406748),
(19642, '45162', 218, 41, 73927, 39.2862, 0.685673540596996, -84.09, -1.46764736800203),
(19643, '45164', 218, 41, 73957, 39.5524, 0.690319607065805, -83.7853, -1.46232934977121),
(19644, '45165', 218, 41, 2861, 39.3542, 0.686860364488352, -83.3886, -1.45540562862854),
(19645, '45166', 218, 41, 74037, 39.4818, 0.689087404613897, -83.6768, -1.46043566753279),
(19646, '45167', 218, 41, 5404, 38.7601, 0.676491363402254, -83.8116, -1.46278837136448),
(19647, '45168', 218, 41, 5585, 38.8592, 0.678220984690981, -83.7723, -1.46210245696845),
(19648, '45169', 218, 41, 74172, 39.4919, 0.689263682868349, -83.6573, -1.46009532832865),
(19649, '45171', 218, 41, 31076, 38.9704, 0.680161790819198, -83.7918, -1.46244279617258),
(19650, '45172', 218, 41, 74310, 39.0568, 0.681669755292921, -83.3522, -1.45477032878082),
(19651, '45174', 218, 41, 74527, 39.1603, 0.683476171068735, -84.3114, -1.47151152696595),
(19652, '45176', 218, 41, 6831, 39.0748, 0.68198391455828, -84.044, -1.46684451654611),
(19653, '45177', 218, 41, 14869, 39.4532, 0.688588240447827, -83.8408, -1.46329800750606),
(19654, '45201', 218, 41, 8080, 39.1068, 0.682542419918919, -84.5009, -1.47481892589848),
(19655, '45202', 218, 41, 8080, 39.1053, 0.682516239980139, -84.5017, -1.47483288853249),
(19656, '45203', 218, 41, 8080, 39.1063, 0.682533693272658, -84.53, -1.47532681671081),
(19657, '45204', 218, 41, 8080, 39.0998, 0.682420246871279, -84.5708, -1.47603891104562),
(19658, '45205', 218, 41, 8080, 39.1114, 0.68262270506451, -84.5761, -1.47613141349598),
(19659, '45206', 218, 41, 8080, 39.127, 0.682894976427821, -84.4853, -1.47454665453517),
(19660, '45207', 218, 41, 8080, 39.1436, 0.683184701083652, -84.4734, -1.47433896035418),
(19661, '45208', 218, 41, 8080, 39.1361, 0.683053801389753, -84.4349, -1.47366700859216),
(19662, '45209', 218, 41, 8080, 39.1525, 0.68334003538708, -84.4303, -1.47358672344657),
(19663, '45210', 218, 41, 8080, 39.111, 0.682615723747502, -84.5161, -1.47508421594478),
(19664, '45211', 218, 41, 8080, 39.1544, 0.683373196642868, -84.6048, -1.4766323229913),
(19665, '45212', 218, 41, 8080, 39.1628, 0.683519804300035, -84.4524, -1.47397244121126),
(19666, '45213', 218, 41, 8080, 39.1822, 0.683858398174922, -84.4191, -1.47339124657035),
(19667, '45214', 218, 41, 8080, 39.1212, 0.682793747331206, -84.5425, -1.47554498286731),
(19668, '45215', 218, 41, 8080, 39.2298, 0.684689174898871, -84.4624, -1.47414697413646),
(19669, '45216', 218, 41, 8080, 39.1985, 0.684142886842997, -84.4788, -1.47443320813379),
(19670, '45217', 218, 41, 8080, 39.1659, 0.683573909506847, -84.492, -1.47466359159505),
(19671, '45218', 218, 41, 8080, 39.2684, 0.685362871990141, -84.5208, -1.47516624641962),
(19672, '45219', 218, 41, 8080, 39.1264, 0.682884504452309, -84.5174, -1.47510690522506),
(19673, '45220', 218, 41, 8080, 39.147, 0.68324404227822, -84.5181, -1.47511912252982),
(19674, '45221', 218, 41, 8080, 39.1303, 0.682952572293137, -84.516, -1.47508247061553),
(19675, '45222', 218, 41, 8080, 39.1948, 0.684078309660674, -84.4488, -1.47390960935819),
(19676, '45223', 218, 41, 8080, 39.1641, 0.683542493580311, -84.549, -1.47565842926869),
(19677, '45224', 218, 41, 8080, 39.2037, 0.684233643964101, -84.5323, -1.4753669592836),
(19678, '45225', 218, 41, 8080, 39.1411, 0.683141067852353, -84.5528, -1.47572475178026),
(19679, '45226', 218, 41, 8080, 39.1175, 0.682729170148882, -84.4256, -1.47350469297172),
(19680, '45227', 218, 41, 8080, 39.1534, 0.683355743350348, -84.3868, -1.47282750522195),
(19681, '45228', 218, 41, 8080, 39.0668, 0.681844288218121, -84.427, -1.47352912758125),
(19682, '45229', 218, 41, 8080, 39.1528, 0.683345271374836, -84.4878, -1.47459028776646),
(19683, '45230', 218, 41, 8080, 39.0783, 0.6820450010821, -84.3738, -1.47260061241919),
(19684, '45231', 218, 41, 8080, 39.2431, 0.684921303689387, -84.5399, -1.47549960430675),
(19685, '45232', 218, 41, 8080, 39.1782, 0.683788585004842, -84.5135, -1.47503883738423),
(19686, '45233', 218, 41, 8080, 39.1202, 0.682776294038686, -84.6697, -1.47776504167584),
(19687, '45234', 218, 41, 8080, 39.2767, 0.685507734318057, -84.3983, -1.47302821808593),
(19688, '45235', 218, 41, 8080, 39.2767, 0.685507734318057, -84.3982, -1.47302647275668),
(19689, '45236', 218, 41, 8080, 39.2055, 0.684265059890637, -84.3985, -1.47303170874443),
(19690, '45237', 218, 41, 8080, 39.1898, 0.683991043198074, -84.4535, -1.47399163983303),
(19691, '45238', 218, 41, 8080, 39.1113, 0.682620959735258, -84.6143, -1.47679812927024),
(19692, '45239', 218, 41, 8080, 39.2224, 0.684560020534224, -84.5837, -1.47626405851913),
(19693, '45240', 218, 41, 8080, 39.2862, 0.685673540596996, -84.5218, -1.47518369971214),
(19694, '45241', 218, 41, 8080, 39.2662, 0.685324474746597, -84.4029, -1.47310850323152),
(19695, '45242', 218, 41, 8080, 39.2424, 0.684909086384623, -84.3559, -1.47228819848308),
(19696, '45243', 218, 41, 8080, 39.1851, 0.68390901272323, -84.3529, -1.47223583860553),
(19697, '45244', 218, 41, 8080, 39.11, 0.682598270454982, -84.3499, -1.47218347872797),
(19698, '45245', 218, 41, 8080, 39.0678, 0.681861741510641, -84.2767, -1.47090589771551),
(19699, '45246', 218, 41, 8080, 39.2824, 0.685607218085421, -84.4687, -1.47425692987933),
(19700, '45247', 218, 41, 8080, 39.2292, 0.68467870292336, -84.6248, -1.4769813888417),
(19701, '45248', 218, 41, 8080, 39.16, 0.683470935080979, -84.6631, -1.47764984994521),
(19702, '45249', 218, 41, 8080, 39.291, 0.685757316401092, -84.3346, -1.47191644335241),
(19703, '45250', 218, 41, 8080, 39.1219, 0.68280596463597, -84.5449, -1.47558687076935),
(19704, '45251', 218, 41, 8080, 39.2524, 0.685083619309822, -84.5892, -1.47636005162799),
(19705, '45252', 218, 41, 8080, 39.2719, 0.685423958513961, -84.6269, -1.47701804075599),
(19706, '45253', 218, 41, 8080, 39.2692, 0.685376834624157, -84.5986, -1.47652411257767),
(19707, '45254', 218, 41, 8080, 39.1074, 0.68255289189443, -84.5004, -1.47481019925222),
(19708, '45255', 218, 41, 8080, 39.0497, 0.68154583691603, -84.3438, -1.47207701364359),
(19709, '45258', 218, 41, 8080, 39.1424, 0.683163757132628, -84.6246, -1.47697789818319),
(19710, '45262', 218, 41, 8080, 39.1222, 0.682811200623726, -84.5451, -1.47559036142786),
(19711, '45263', 218, 41, 8080, 39.106, 0.682528457284903, -84.5356, -1.47542455514892),
(19712, '45264', 218, 41, 8080, 39.1044, 0.682500532016871, -84.5355, -1.47542280981967),
(19713, '45267', 218, 41, 8080, 39.1271, 0.682896721757073, -84.5123, -1.4750178934332),
(19714, '45268', 218, 41, 8080, 39.1477, 0.683256259582984, -84.5211, -1.47517148240738),
(19715, '45269', 218, 41, 8080, 39.104, 0.682493550699863, -84.5358, -1.47542804580742),
(19716, '45270', 218, 41, 8080, 39.1041, 0.682495296029115, -84.5361, -1.47543328179518),
(19717, '45271', 218, 41, 8080, 39.1365, 0.683060782706761, -84.5369, -1.47544724442919),
(19718, '45273', 218, 41, 8080, 39.1019, 0.682456898785571, -84.5131, -1.47503185606722),
(19719, '45274', 218, 41, 8080, 39.1366, 0.683062528036013, -84.5374, -1.47545597107545),
(19720, '45275', 218, 41, 8080, 39.1403, 0.683127105218337, -84.5062, -1.47491142834883),
(19721, '45277', 218, 41, 8080, 39.0291, 0.681186299090119, -84.5199, -1.47515053845636),
(19722, '45280', 218, 41, 8080, 39.1622, 0.683509332324523, -84.4572, -1.47405621701535),
(19723, '45296', 218, 41, 8080, 39.1045, 0.682502277346123, -84.5353, -1.47541931916116),
(19724, '45298', 218, 41, 8080, 39.0859, 0.682177646105252, -84.5148, -1.4750615266645),
(19725, '45299', 218, 41, 8080, 39.1026, 0.682469116090335, -84.508, -1.47494284427537),
(19726, '45301', 218, 41, 7072, 39.7091, 0.69305453800368, -84.0189, -1.46640643890386),
(19727, '45302', 218, 41, 26375, 40.399, 0.705095564513189, -84.203, -1.46961959005679),
(19728, '45303', 218, 41, 154076, 40.2168, 0.701915574616055, -84.6416, -1.47727460415603),
(19729, '45304', 218, 41, 71686, 39.9895, 0.697948441226272, -84.5338, -1.47539313922238),
(19730, '45305', 218, 41, 71790, 39.6395, 0.691839788844292, -84.0844, -1.46754962956392),
(19731, '45306', 218, 41, 154402, 40.4634, 0.706219556551474, -84.1827, -1.46926528821863),
(19732, '45307', 218, 41, 19415, 39.5806, 0.690811789914868, -83.7234, -1.46124899096422),
(19733, '45308', 218, 41, 1076, 40.1318, 0.70043204475186, -84.4689, -1.47426042053784),
(19734, '45309', 218, 41, 26617, 39.8404, 0.695346155311549, -84.4202, -1.47341044519212),
(19735, '45310', 218, 41, 154537, 40.3511, 0.704259551801484, -84.6434, -1.47730602008257),
(19736, '45311', 218, 41, 1304, 39.633, 0.691726342442913, -84.6651, -1.47768475653025),
(19737, '45312', 218, 41, 154627, 40.0573, 0.699131774459125, -84.0887, -1.46762467872176),
(19738, '45314', 218, 41, 1435, 39.7472, 0.69371950844869, -83.7878, -1.46237298300251),
(19739, '45315', 218, 41, 608, 39.8522, 0.695552104163284, -84.332, -1.47187106479186),
(19740, '45316', 218, 41, 15559, 39.7986, 0.694616607684215, -83.8267, -1.46305191608153),
(19741, '45317', 218, 41, 63880, 40.1897, 0.701442590388765, -83.9926, -1.46594741731059),
(19742, '45318', 218, 41, 15652, 40.1242, 0.700299399728709, -84.351, -1.47220267734974),
(19743, '45319', 218, 41, 72334, 39.9192, 0.69672147476212, -83.9471, -1.46515329250093),
(19744, '45320', 218, 41, 8676, 39.7341, 0.693490870316679, -84.6727, -1.4778174015534),
(19745, '45321', 218, 41, 15909, 39.8915, 0.696238018559318, -84.6759, -1.47787325208947),
(19746, '45322', 218, 41, 2297, 39.872, 0.695897679355179, -84.3091, -1.47147138439315),
(19747, '45323', 218, 41, 2304, 39.8671, 0.695812158221831, -83.9375, -1.46498574089274),
(19748, '45324', 218, 41, 72490, 39.8054, 0.694735290073351, -84.0182, -1.4663942215991),
(19749, '45325', 218, 41, 2418, 39.6859, 0.692649621617218, -84.4205, -1.47341568117987),
(19750, '45326', 218, 41, 16032, 40.1399, 0.700573416421272, -84.1023, -1.46786204350003),
(19751, '45327', 218, 41, 27253, 39.6306, 0.691684454540865, -84.384, -1.4727786360029),
(19752, '45328', 218, 41, 72658, 40.1132, 0.700107413510989, -84.4947, -1.47471071548485),
(19753, '45330', 218, 41, 21526, 39.6488, 0.692002104464728, -84.5258, -1.47525351288222),
(19754, '45331', 218, 41, 2868, 40.096, 0.699807216879646, -84.6332, -1.47712799649887),
(19755, '45332', 218, 41, 72930, 39.9947, 0.698039198347376, -84.7899, -1.47986292743674),
(19756, '45333', 218, 41, 3246, 40.2566, 0.702610215658349, -84.3443, -1.47208574028985),
(19757, '45334', 218, 41, 155863, 40.4429, 0.705861764054815, -84.044, -1.46684451654611),
(19758, '45335', 218, 41, 3399, 39.636, 0.691778702320473, -83.7488, -1.46169230459423),
(19759, '45336', 218, 41, 155975, 40.4394, 0.705800677530995, -84.2637, -1.47067900491275),
(19760, '45337', 218, 41, 36808, 39.9963, 0.698067123615408, -84.4084, -1.47320449634038),
(19761, '45338', 218, 41, 3750, 39.8468, 0.695457856383677, -84.5453, -1.47559385208636),
(19762, '45339', 218, 41, 73298, 40.0034, 0.6981910419923, -84.3488, -1.47216428010619),
(19763, '45340', 218, 41, 3982, 40.374, 0.704659232200191, -84.0442, -1.46684800720462),
(19764, '45341', 218, 41, 73428, 39.8817, 0.696066976292623, -84.0239, -1.46649370536646),
(19765, '45342', 218, 41, 73453, 39.6306, 0.691684454540865, -84.2621, -1.47065107964471),
(19766, '45343', 218, 41, 73453, 39.637, 0.691796155612992, -84.2651, -1.47070343952227),
(19767, '45344', 218, 41, 73641, 39.9375, 0.697040870015235, -84.0122, -1.46628950184398),
(19768, '45345', 218, 41, 30637, 39.7383, 0.693564174145263, -84.3926, -1.47292873431857),
(19769, '45346', 218, 41, 73660, 39.98, 0.697782634947333, -84.7144, -1.47854520385148),
(19770, '45347', 218, 41, 73670, 39.8704, 0.695869754087147, -84.7728, -1.47956447613465),
(19771, '45348', 218, 41, 156755, 40.3307, 0.703903504634077, -84.6472, -1.47737234259414),
(19772, '45349', 218, 41, 73711, 39.9904, 0.69796414918954, -83.9407, -1.4650415914288),
(19773, '45350', 218, 41, 14314, 40.3237, 0.703781331586438, -84.5684, -1.47599702314357),
(19774, '45351', 218, 41, 506, 40.3406, 0.704076292230025, -84.4949, -1.47471420614336),
(19775, '45352', 218, 41, 4839, 40.0502, 0.699007856082233, -84.7433, -1.47904960400531),
(19776, '45353', 218, 41, 71250, 40.2946, 0.703273440774107, -84.0338, -1.46666649296241),
(19777, '45354', 218, 41, 23863, 39.9043, 0.696461420703573, -84.4015, -1.47308406862199),
(19778, '45356', 218, 41, 33629, 40.1496, 0.700742713358715, -84.2436, -1.4703281937331),
(19779, '45358', 218, 41, 73910, 39.9868, 0.697901317336469, -84.4866, -1.47456934381544),
(19780, '45359', 218, 41, 268, 40.0533, 0.699061961289045, -84.3513, -1.47220791333749),
(19781, '45360', 218, 41, 151851, 40.3303, 0.703896523317069, -84.092, -1.46768227458707),
(19782, '45361', 218, 41, 73969, 39.9623, 0.69747371166973, -84.4153, -1.47332492405877),
(19783, '45362', 218, 41, 31012, 40.2873, 0.703146031738712, -84.6329, -1.47712276051111),
(19784, '45363', 218, 41, 146242, 40.2409, 0.702336198965786, -84.4042, -1.4731311925118),
(19785, '45365', 218, 41, 5844, 40.287, 0.703140795750956, -84.159, -1.46885164518591),
(19786, '45367', 218, 41, 5844, 40.2893, 0.703180938323751, -84.1632, -1.46892494901449),
(19787, '45368', 218, 41, 74346, 39.85, 0.69551370691974, -83.6589, -1.46012325359668),
(19788, '45369', 218, 41, 74363, 39.9535, 0.697320122695554, -83.6139, -1.45933785543329),
(19789, '45370', 218, 41, 826, 39.6017, 0.691180054387038, -84.1375, -1.46847639939673),
(19790, '45371', 218, 41, 74553, 39.9518, 0.697290452098271, -84.1776, -1.46917627642678),
(19791, '45372', 218, 41, 157979, 40.0133, 0.698363829588247, -83.8355, -1.46320550505571),
(19792, '45373', 218, 41, 199, 40.0354, 0.698749547352938, -84.2068, -1.46968591256836),
(19793, '45374', 218, 41, 199, 40.0446, 0.698910117644121, -84.2192, -1.46990233339561),
(19794, '45377', 218, 41, 28848, 39.887, 0.696159478742978, -84.2034, -1.46962657137379),
(19795, '45378', 218, 41, 12546, 39.9018, 0.696417787472273, -84.4892, -1.47461472237599),
(19796, '45380', 218, 41, 28861, 40.2394, 0.702310019027006, -84.508, -1.47494284427537),
(19797, '45381', 218, 41, 74760, 39.7293, 0.693407094512583, -84.5345, -1.47540535652715),
(19798, '45382', 218, 41, 74774, 39.8952, 0.696302595741642, -84.6209, -1.47691332100087),
(19799, '45383', 218, 41, 74777, 39.9555, 0.697355029280594, -84.3298, -1.47183266754831),
(19800, '45384', 218, 41, 74828, 39.7125, 0.693113879198248, -83.8843, -1.46405722573068),
(19801, '45385', 218, 41, 29041, 39.6909, 0.692736888079817, -83.9518, -1.46523532297578),
(19802, '45387', 218, 41, 53094, 39.7983, 0.694611371696459, -83.8977, -1.46429109985045),
(19803, '45388', 218, 41, 14928, 40.3248, 0.703800530208209, -84.4838, -1.47452047459639),
(19804, '45389', 218, 41, 29472, 40.0565, 0.699117811825109, -84.025, -1.46651290398824),
(19805, '45390', 218, 41, 12457, 40.2095, 0.70178816558066, -84.7809, -1.47970584780406),
(19806, '45401', 218, 41, 1992, 39.7739, 0.694185511358973, -84.1983, -1.46953755958194),
(19807, '45402', 218, 41, 1992, 39.7568, 0.693887060056882, -84.1863, -1.4693281200717),
(19808, '45403', 218, 41, 1992, 39.7623, 0.693983053165741, -84.1522, -1.46873296279677),
(19809, '45404', 218, 41, 1992, 39.7869, 0.694412404161732, -84.1619, -1.46890225973422),
(19810, '45405', 218, 41, 1992, 39.7903, 0.6944717453563, -84.2141, -1.46981332160376),
(19811, '45406', 218, 41, 1992, 39.7864, 0.694403677515472, -84.2473, -1.47039277091542),
(19812, '45407', 218, 41, 1992, 39.7593, 0.693930693288182, -84.2226, -1.46996167459018),
(19813, '45408', 218, 41, 1992, 39.7409, 0.693609552705815, -84.2256, -1.47001403446774),
(19814, '45409', 218, 41, 1992, 39.7249, 0.693330300025495, -84.1867, -1.46933510138871),
(19815, '45410', 218, 41, 1992, 39.7484, 0.693740452399714, -84.1597, -1.46886386249067),
(19816, '45412', 218, 41, 1992, 39.7604, 0.693949891909953, -84.1954, -1.46948694503363),
(19817, '45413', 218, 41, 1992, 39.8227, 0.695037232033946, -84.1919, -1.46942585850981),
(19818, '45414', 218, 41, 1992, 39.8272, 0.695115771850286, -84.2029, -1.46961784472753),
(19819, '45415', 218, 41, 1992, 39.8333, 0.695222236934657, -84.2638, -1.470680750242),
(19820, '45416', 218, 41, 1992, 39.8039, 0.694709110134571, -84.2587, -1.47059173845015),
(19821, '45417', 218, 41, 1992, 39.7534, 0.693827718862314, -84.2418, -1.47029677780656),
(19822, '45418', 218, 41, 1992, 39.7176, 0.6932028909901, -84.2674, -1.47074358209507),
(19823, '45419', 218, 41, 1992, 39.714, 0.693140059137028, -84.167, -1.46899127152607),
(19824, '45420', 218, 41, 1992, 39.7213, 0.693267468172424, -84.1331, -1.46839960490964),
(19825, '45422', 218, 41, 1992, 39.7582, 0.69391149466641, -84.1876, -1.46935080935198),
(19826, '45423', 218, 41, 1992, 39.7585, 0.693916730654165, -84.1884, -1.46936477198599),
(19827, '45424', 218, 41, 1992, 39.8444, 0.695415968481629, -84.1243, -1.46824601593547),
(19828, '45426', 218, 41, 1992, 39.8048, 0.694724818097839, -84.3004, -1.47131954074823),
(19829, '45427', 218, 41, 1992, 39.7538, 0.693834700179322, -84.2804, -1.47097047489783),
(19830, '45428', 218, 41, 1992, 39.7512, 0.69378932161877, -84.2499, -1.47043814947597),
(19831, '45429', 218, 41, 1992, 39.6861, 0.692653112275722, -84.1617, -1.46889876907571),
(19832, '45430', 218, 41, 1992, 39.7065, 0.693009159443128, -84.0832, -1.4675286856129),
(19833, '45431', 218, 41, 1992, 39.7654, 0.694037158372553, -84.119, -1.46815351348511),
(19834, '45432', 218, 41, 1992, 39.7399, 0.693592099413295, -84.0699, -1.46729655682238),
(19835, '45433', 218, 41, 1992, 39.8056, 0.694738780731855, -84.0449, -1.46686022450938),
(19836, '45434', 218, 41, 1992, 39.711, 0.693087699259468, -84.0395, -1.46676597672977),
(19837, '45435', 218, 41, 1992, 39.7678, 0.694079046274601, -84.0832, -1.4675286856129),
(19838, '45437', 218, 41, 1992, 39.7697, 0.694112207530389, -84.1234, -1.4682303079722),
(19839, '45439', 218, 41, 1992, 39.6985, 0.692869533102969, -84.2202, -1.46991978668813),
(19840, '45440', 218, 41, 1992, 39.6716, 0.692400039534182, -84.1226, -1.46821634533818),
(19841, '45441', 218, 41, 1992, 39.6463, 0.691958471233428, -84.1676, -1.46900174350158),
(19842, '45448', 218, 41, 1992, 39.6466, 0.691963707221184, -84.167, -1.46899127152607),
(19843, '45449', 218, 41, 1992, 39.6621, 0.692234233255243, -84.2386, -1.4702409272705),
(19844, '45454', 218, 41, 1992, 39.6306, 0.691684454540865, -84.1573, -1.46882197458862),
(19845, '45458', 218, 41, 1992, 39.6133, 0.69138251258027, -84.1615, -1.46889527841721),
(19846, '45459', 218, 41, 1992, 39.638, 0.691813608905512, -84.1683, -1.46901396080634),
(19847, '45463', 218, 41, 1992, 39.7613, 0.693965599873221, -84.1934, -1.46945203844859),
(19848, '45469', 218, 41, 1992, 39.723, 0.693297138769708, -84.1909, -1.46940840521729),
(19849, '45470', 218, 41, 1992, 39.6296, 0.691667001248345, -84.2752, -1.47087971777673),
(19850, '45475', 218, 41, 1992, 39.6462, 0.691956725904176, -84.168, -1.46900872481859),
(19851, '45479', 218, 41, 1992, 39.7232, 0.693300629428211, -84.1916, -1.46942062252206),
(19852, '45481', 218, 41, 1992, 39.7577, 0.69390276802015, -84.1774, -1.46917278576827),
(19853, '45482', 218, 41, 1992, 39.7214, 0.693269213501676, -84.102, -1.46785680751227),
(19854, '45490', 218, 41, 1992, 39.8965, 0.696325285021918, -84.2199, -1.46991455070037),
(19855, '45501', 218, 41, 349, 39.9254, 0.696829685175744, -83.8559, -1.46356155222311),
(19856, '45502', 218, 41, 349, 39.9245, 0.696813977212476, -83.8252, -1.46302573614275),
(19857, '45503', 218, 41, 349, 39.9526, 0.697304414732286, -83.7807, -1.46224906462561),
(19858, '45504', 218, 41, 349, 39.9398, 0.697081012588031, -83.8455, -1.46338003798091),
(19859, '45505', 218, 41, 349, 39.9096, 0.696553923153929, -83.7779, -1.46220019540656),
(19860, '45506', 218, 41, 349, 39.9105, 0.696569631117197, -83.8372, -1.46323517565299),
(19861, '45601', 218, 41, 54027, 39.328, 0.68640308822433, -82.9825, -1.44831784653619),
(19862, '45612', 218, 41, 19017, 39.2386, 0.684842763873047, -83.2685, -1.4533094881969),
(19863, '45613', 218, 41, 7346, 39.0248, 0.681111249932283, -82.8588, -1.44615887425148),
(19864, '45614', 218, 41, 53465, 38.9306, 0.679467149776904, -82.2567, -1.43565024682522),
(19865, '45616', 218, 41, 959, 38.7907, 0.677025434153364, -83.3397, -1.45455216262432),
(19866, '45617', 218, 41, 71871, 39.2806, 0.685575802158885, -83.1598, -1.45141231529998),
(19867, '45618', 218, 41, 72079, 38.8519, 0.678093575655585, -83.5854, -1.45884043659647),
(19868, '45619', 218, 41, 54018, 38.4281, 0.670696870285633, -82.4518, -1.43905538419586),
(19869, '45620', 218, 41, 72084, 38.946, 0.679735930481712, -82.1111, -1.43310904743432),
(19870, '45621', 218, 41, 35303, 39.1222, 0.682811200623726, -82.5337, -1.44048480885324),
(19871, '45622', 218, 41, 1868, 39.3857, 0.687410143202731, -82.5313, -1.4404429209512),
(19872, '45623', 218, 41, 72249, 38.6154, 0.673965871974618, -82.2633, -1.43576543855585),
(19873, '45624', 218, 41, 29595, 39.1613, 0.683493624361255, -83.3532, -1.45478778207334),
(19874, '45628', 218, 41, 2594, 39.388, 0.687450285775526, -83.1964, -1.45205110580621),
(19875, '45629', 218, 41, 72595, 38.6587, 0.674721599540732, -82.8078, -1.44526875633296),
(19876, '45630', 218, 41, 2610, 38.6977, 0.67540227794901, -83.0942, -1.45026737931067),
(19877, '45631', 218, 41, 72628, 38.8206, 0.677547287599711, -82.1964, -1.43459781328627),
(19878, '45633', 218, 41, 2943, 39.4523, 0.688572532484559, -82.7873, -1.4449109638363),
(19879, '45634', 218, 41, 55147, 39.1606, 0.683481407056491, -82.5257, -1.44034518251308),
(19880, '45636', 218, 41, 16381, 38.5846, 0.673428310565004, -82.8322, -1.44569461667045),
(19881, '45638', 218, 41, 9671, 38.5237, 0.67236540505054, -82.668, -1.44282878603867),
(19882, '45640', 218, 41, 3384, 39.0325, 0.681245640284687, -82.6476, -1.44247273887127),
(19883, '45642', 218, 41, 738, 39.0471, 0.681500458355478, -83.0527, -1.44954306767109),
(19884, '45643', 218, 41, 9847, 38.8732, 0.67846533078626, -82.2607, -1.4357200599953),
(19885, '45644', 218, 41, 3542, 39.4479, 0.688495737997471, -82.8761, -1.44646081621207),
(19886, '45645', 218, 41, 48755, 38.5765, 0.673286938895593, -82.5313, -1.4404429209512),
(19887, '45646', 218, 41, 3678, 39.0877, 0.682209062031788, -83.2905, -1.45369346063234),
(19888, '45647', 218, 41, 49032, 39.2773, 0.685518206293569, -82.7995, -1.44512389400504),
(19889, '45648', 218, 41, 73295, 38.9764, 0.680266510574318, -83.0423, -1.44936155342889),
(19890, '45650', 218, 41, 73310, 38.7463, 0.676250507965479, -83.4242, -1.45602696584225),
(19891, '45651', 218, 41, 10379, 39.2488, 0.68502078745675, -82.48, -1.43954756704492),
(19892, '45652', 218, 41, 73410, 38.8308, 0.677725311183414, -83.0744, -1.44992180411878),
(19893, '45653', 218, 41, 73496, 38.8895, 0.678749819454335, -82.8314, -1.44568065403643),
(19894, '45654', 218, 41, 73673, 39.4104, 0.687841239527973, -82.3575, -1.43740953871123),
(19895, '45656', 218, 41, 4679, 38.8962, 0.678866756514218, -82.5986, -1.44161752753779),
(19896, '45657', 218, 41, 67545, 38.8203, 0.677542051611955, -83.2883, -1.45365506338879),
(19897, '45658', 218, 41, 30786, 38.7761, 0.676770616082573, -82.4395, -1.43884070869787),
(19898, '45659', 218, 41, 11126, 38.8745, 0.678488020066536, -82.5884, -1.44143950395408),
(19899, '45660', 218, 41, 73856, 38.9553, 0.679898246102147, -83.4026, -1.45564997472382),
(19900, '45661', 218, 41, 73894, 39.0397, 0.68137130399083, -83.0692, -1.44983104699767),
(19901, '45662', 218, 41, 37775, 38.7535, 0.676376171671623, -82.9671, -1.44804906583139),
(19902, '45663', 218, 41, 74778, 38.7629, 0.67654023262131, -83.0281, -1.4491137166751),
(19903, '45669', 218, 41, 57050, 38.4381, 0.670871403210832, -82.3804, -1.43780921910994),
(19904, '45671', 218, 41, 74015, 38.9803, 0.680334578415146, -83.2757, -1.45343515190304),
(19905, '45672', 218, 41, 5300, 39.174, 0.683715281176259, -82.7091, -1.44354611636124),
(19906, '45673', 218, 41, 74066, 39.203, 0.684221426659337, -82.8137, -1.44537173075883),
(19907, '45674', 218, 41, 71335, 38.8828, 0.678632882394451, -82.3806, -1.43781270976844),
(19908, '45675', 218, 41, 74106, 38.5207, 0.67231304517298, -82.5636, -1.44100666229959),
(19909, '45677', 218, 41, 74226, 38.7984, 0.677159824505768, -82.7647, -1.44451651942535),
(19910, '45678', 218, 41, 38128, 38.6114, 0.673896058804539, -82.3998, -1.43814781298482),
(19911, '45679', 218, 41, 74241, 38.9659, 0.680083251002858, -83.5634, -1.45845646416103),
(19912, '45680', 218, 41, 43135, 38.42, 0.670555498616221, -82.5808, -1.44130685893093),
(19913, '45681', 218, 41, 74362, 39.3081, 0.686055767703183, -83.2584, -1.45313320994245),
(19914, '45682', 218, 41, 74364, 38.8657, 0.67833443109236, -82.7494, -1.4442494840498),
(19915, '45683', 218, 41, 6092, 38.9497, 0.679800507664035, -82.862, -1.44621472478754),
(19916, '45684', 218, 41, 61902, 38.7066, 0.675557612252437, -83.3582, -1.45487504853594),
(19917, '45685', 218, 41, 12317, 38.9563, 0.679915699394667, -82.474, -1.4394428472898),
(19918, '45686', 218, 41, 34282, 38.9942, 0.680577179181173, -82.378, -1.43776733120789),
(19919, '45687', 218, 41, 831, 38.9699, 0.680153064172938, -83.0201, -1.44897409033494),
(19920, '45688', 218, 41, 6650, 38.6887, 0.67524519831633, -82.4556, -1.43912170670744),
(19921, '45690', 218, 41, 6664, 39.1205, 0.682781530026442, -83.0093, -1.44878559477573),
(19922, '45692', 218, 41, 58192, 39.1206, 0.682783275355694, -82.5473, -1.44072217363152),
(19923, '45693', 218, 41, 28946, 38.8008, 0.677201712407816, -83.5304, -1.45788050550787),
(19924, '45694', 218, 41, 38841, 38.7378, 0.676102154979059, -82.8394, -1.44582028037659),
(19925, '45695', 218, 41, 74832, 39.0761, 0.682006603838556, -82.327, -1.43687721328937),
(19926, '45696', 218, 41, 74840, 38.595, 0.673609824807211, -82.4543, -1.43909901742716),
(19927, '45697', 218, 41, 12894, 38.9084, 0.679079686682962, -83.6363, -1.45972880918573),
(19928, '45698', 218, 41, 74916, 39.2832, 0.685621180719436, -82.3936, -1.4380396025712),
(19929, '45699', 218, 41, 73295, 38.8792, 0.678570050541379, -82.9951, -1.44853775802195),
(19930, '45701', 218, 41, 7182, 39.3157, 0.686188412726335, -82.0956, -1.43283852140026),
(19931, '45710', 218, 41, 18772, 39.2298, 0.684689174898871, -82.1953, -1.4345786146645),
(19932, '45711', 218, 41, 71661, 39.4145, 0.687912798027305, -81.9414, -1.43014722369368),
(19933, '45712', 218, 41, 34678, 39.3964, 0.687596893432694, -81.6647, -1.42531789765341),
(19934, '45713', 218, 41, 19076, 39.4197, 0.688003555148409, -81.8154, -1.42794810883617),
(19935, '45714', 218, 41, 31791, 39.2801, 0.685567075512625, -81.5904, -1.42402111801918),
(19936, '45715', 218, 41, 7444, 39.55, 0.690277719163757, -81.6358, -1.42481349749959),
(19937, '45716', 218, 41, 71943, 39.4592, 0.688692960202947, -82.1865, -1.43442502569032),
(19938, '45717', 218, 41, 19772, 39.3777, 0.687270516862571, -82.2712, -1.43590331956676),
(19939, '45719', 218, 41, 19971, 39.4036, 0.687722557138838, -82.1294, -1.43342844268743),
(19940, '45720', 218, 41, 8056, 39.0874, 0.682203826044032, -81.9228, -1.42982259245281),
(19941, '45721', 218, 41, 72161, 39.5677, 0.69058664244136, -81.5813, -1.42386229305725),
(19942, '45723', 218, 41, 72203, 39.2276, 0.684650777655328, -81.8001, -1.42768107346061),
(19943, '45724', 218, 41, 15698, 39.4056, 0.687757463723877, -81.7705, -1.42716445600202),
(19944, '45727', 218, 41, 72314, 39.6366, 0.691789174295984, -81.5066, -1.42255853210601),
(19945, '45729', 218, 41, 21138, 39.4001, 0.687661470615018, -81.6521, -1.42509798616766),
(19946, '45732', 218, 41, 72689, 39.4978, 0.689366657294216, -82.0887, -1.43271809368187),
(19947, '45734', 218, 41, 2830, 39.6561, 0.692129513500123, -81.1849, -1.41694380790234),
(19948, '45735', 218, 41, 72777, 39.2603, 0.68522150032073, -81.9299, -1.4299465108297),
(19949, '45739', 218, 41, 72924, 39.188, 0.683959627271538, -81.7518, -1.4268380794319),
(19950, '45740', 218, 41, 3395, 39.4761, 0.688987920846534, -82.0788, -1.43254530608592),
(19951, '45741', 218, 41, 73158, 39.0684, 0.681872213486153, -82.2414, -1.43538321144966),
(19952, '45742', 218, 41, 73252, 39.2853, 0.685657832633728, -81.6951, -1.42584847774602),
(19953, '45743', 218, 41, 36960, 39.0768, 0.68201882114332, -81.8546, -1.42863227790295),
(19954, '45744', 218, 41, 10211, 39.5302, 0.689932143971862, -81.5065, -1.42255678677676),
(19955, '45745', 218, 41, 73293, 39.6475, 0.691979415184452, -81.3279, -1.4194396287327),
(19956, '45746', 218, 41, 73320, 39.6075, 0.691281283483654, -81.4391, -1.42138043486091),
(19957, '45750', 218, 41, 3993, 39.4287, 0.688160634781088, -81.4548, -1.42165445155348),
(19958, '45760', 218, 41, 73458, 39.0058, 0.680779637374404, -82.0788, -1.43254530608592),
(19959, '45761', 218, 41, 73480, 39.4264, 0.688120492208292, -82.0791, -1.43255054207368),
(19960, '45764', 218, 41, 10749, 39.4452, 0.688448614107667, -82.2257, -1.4351091947571),
(19961, '45766', 218, 41, 73664, 39.336, 0.686542714564489, -82.2424, -1.43540066474218),
(19962, '45767', 218, 41, 73666, 39.6005, 0.691159110436014, -81.0817, -1.41514262811429),
(19963, '45768', 218, 41, 10799, 39.4033, 0.687717321151082, -81.2695, -1.41842035644953),
(19964, '45769', 218, 41, 33663, 39.079, 0.682057218386864, -82.0257, -1.43161853625311),
(19965, '45770', 218, 41, 5188, 38.9884, 0.680475950084557, -81.7972, -1.42763045891231),
(19966, '45771', 218, 41, 819, 38.9869, 0.680449770145777, -81.9065, -1.42953810378474),
(19967, '45772', 218, 41, 33736, 39.1345, 0.683025876121721, -81.8191, -1.42801268601849),
(19968, '45773', 218, 41, 13196, 39.3897, 0.68747995637281, -81.3535, -1.41988643302121),
(19969, '45775', 218, 41, 17882, 39.0788, 0.68205372772836, -82.156, -1.43389270026846),
(19970, '45776', 218, 41, 685, 39.1707, 0.683657685310943, -82.0279, -1.43165693349666),
(19971, '45777', 218, 41, 24795, 39.442, 0.688392763571604, -81.919, -1.42975626994123),
(19972, '45778', 218, 41, 6081, 39.3389, 0.686593329112797, -81.9032, -1.42948050791942),
(19973, '45779', 218, 41, 57818, 38.9985, 0.680652228339009, -81.9744, -1.43072318234684),
(19974, '45780', 218, 41, 25430, 39.3695, 0.687127399863908, -82.1335, -1.43350000118676),
(19975, '45781', 218, 41, 57927, 39.2394, 0.684856726507063, -81.7493, -1.4267944462006),
(19976, '45782', 218, 41, 6389, 39.4812, 0.689076932638385, -82.0808, -1.43258021267096),
(19977, '45783', 218, 41, 74578, 39.1675, 0.683601834774879, -81.8348, -1.42828670271106),
(19978, '45784', 218, 41, 6568, 39.3364, 0.686549695881497, -81.6756, -1.42550813854188),
(19979, '45786', 218, 41, 790, 39.5149, 0.689665108596307, -81.6649, -1.42532138831192),
(19980, '45787', 218, 41, 18507, 39.4655, 0.688802915945822, -81.6335, -1.42477335492679),
(19981, '45788', 218, 41, 12787, 39.4803, 0.689061224675117, -81.352, -1.41986025308243),
(19982, '45789', 218, 41, 74858, 39.5825, 0.690844951170656, -81.2406, -1.41791595629571),
(19983, '45801', 218, 41, 66371, 40.7609, 0.711411911076157, -84.0706, -1.46730877412714),
(19984, '45802', 218, 41, 66371, 40.7419, 0.711080298518278, -84.175, -1.46913089786623),
(19985, '45804', 218, 41, 66371, 40.7226, 0.710743449972643, -84.0784, -1.4674449098088),
(19986, '45805', 218, 41, 66371, 40.7367, 0.710989541397174, -84.1547, -1.46877659602807),
(19987, '45806', 218, 41, 66371, 40.6851, 0.710088951503145, -84.1334, -1.4684048408974),
(19988, '45807', 218, 41, 66371, 40.7932, 0.711975652424551, -84.1753, -1.46913613385398),
(19989, '45808', 218, 41, 53382, 40.8337, 0.712682510771609, -83.9696, -1.46554599158263),
(19990, '45809', 218, 41, 155480, 40.8447, 0.712874496989328, -84.1847, -1.46930019480367),
(19991, '45810', 218, 41, 7026, 40.7486, 0.711197235578161, -83.7915, -1.46243756018483),
(19992, '45812', 218, 41, 34526, 40.6964, 0.71028617370862, -83.8232, -1.46299082955771),
(19993, '45813', 218, 41, 146832, 41.1814, 0.718751020580793, -84.7423, -1.47903215071279),
(19994, '45814', 218, 41, 15026, 40.8986, 0.713815229456153, -83.6305, -1.45962758008912),
(19995, '45815', 218, 41, 15188, 41.0287, 0.716085902812997, -83.986, -1.46583222557996),
(19996, '45816', 218, 41, 154279, 41.0038, 0.715651315829251, -83.7944, -1.46248817473314),
(19997, '45817', 218, 41, 1018, 40.8835, 0.713551684739102, -83.9108, -1.46451973798246),
(19998, '45819', 218, 41, 63266, 40.6234, 0.709012083354664, -84.2596, -1.47060744641341),
(19999, '45820', 218, 41, 1288, 40.8306, 0.712628405564797, -84.085, -1.46756010153943),
(20000, '45821', 218, 41, 7972, 41.2183, 0.719395047074779, -84.6029, -1.47659916173551),
(20001, '45822', 218, 41, 29423, 40.5469, 0.707676906476889, -84.5799, -1.47619773600755),
(20002, '45826', 218, 41, 1544, 40.4378, 0.705772752262963, -84.4948, -1.4747124608141),
(20003, '45827', 218, 41, 1638, 41.0119, 0.715792687498662, -84.2872, -1.47108915728696),
(20004, '45828', 218, 41, 1687, 40.484, 0.706579094377384, -84.6574, -1.47755036617785),
(20005, '45830', 218, 41, 154816, 40.8731, 0.713370170496894, -84.0273, -1.46655304656103),
(20006, '45831', 218, 41, 154840, 41.1017, 0.717359993166953, -84.2534, -1.47049923599979),
(20007, '45832', 218, 41, 154843, 40.9175, 0.71414509668478, -84.704, -1.47836368960928),
(20008, '45833', 218, 41, 32226, 40.8239, 0.712511468504913, -84.3233, -1.47171922114693),
(20009, '45835', 218, 41, 108925, 40.7694, 0.711560264062576, -83.684, -1.46056133123893),
(20010, '45836', 218, 41, 32273, 40.7845, 0.711823808779627, -83.6352, -1.45970961056396),
(20011, '45837', 218, 41, 13687, 41.0558, 0.716558887040288, -84.302, -1.47134746601626),
(20012, '45838', 218, 41, 2254, 40.7418, 0.711078553189026, -84.4761, -1.47438608424398),
(20013, '45839', 218, 41, 21083, 41.0441, 0.716354683517805, -83.65, -1.45996791929326),
(20014, '45840', 218, 41, 21083, 41.0409, 0.716298832981741, -83.6446, -1.45987367151365),
(20015, '45841', 218, 41, 155912, 40.8929, 0.713715745688789, -83.7281, -1.46133102143906),
(20016, '45843', 218, 41, 2517, 40.7774, 0.711699890402736, -83.5371, -1.45799744256775),
(20017, '45844', 218, 41, 155306, 40.9145, 0.71409273680722, -84.2929, -1.47118864105433),
(20018, '45845', 218, 41, 155307, 40.3285, 0.703865107390533, -84.3749, -1.47261981104096),
(20019, '45846', 218, 41, 155309, 40.4168, 0.705406233120044, -84.7459, -1.47909498256586),
(20020, '45848', 218, 41, 155450, 41.0265, 0.716047505569454, -84.0732, -1.4673541526877),
(20021, '45849', 218, 41, 113509, 41.018, 0.715899152583034, -84.4856, -1.47455189052292),
(20022, '45850', 218, 41, 155645, 40.7231, 0.710752176618903, -83.9358, -1.46495607029546),
(20023, '45851', 218, 41, 32710, 41.0195, 0.715925332521814, -84.5804, -1.47620646265381),
(20024, '45853', 218, 41, 88224, 40.9842, 0.71530923129586, -84.1981, -1.46953406892344),
(20025, '45854', 218, 41, 3594, 40.7572, 0.711347333893833, -83.9488, -1.46518296309822),
(20026, '45855', 218, 41, 55815, 41.0886, 0.717131355034942, -84.5856, -1.47629721977492),
(20027, '45856', 218, 41, 14102, 41.0977, 0.717290179996874, -83.9971, -1.46602595712693),
(20028, '45858', 218, 41, 60821, 41.1051, 0.717419334361521, -83.8083, -1.46273077549916),
(20029, '45859', 218, 41, 156400, 40.6926, 0.710219851197045, -83.7858, -1.46233807641746),
(20030, '45860', 218, 41, 156333, 40.3968, 0.705057167269645, -84.5158, -1.47507897995702),
(20031, '45861', 218, 41, 4153, 41.0919, 0.717188950900258, -84.4198, -1.47340346387511),
(20032, '45862', 218, 41, 56203, 40.6734, 0.709884747980662, -84.5241, -1.47522384228494),
(20033, '45863', 218, 41, 110420, 40.8555, 0.713062992548543, -84.4474, -1.47388517474866),
(20034, '45864', 218, 41, 27905, 41.1028, 0.717379191788725, -84.1318, -1.46837691562937),
(20035, '45865', 218, 41, 156535, 40.4008, 0.705126980439725, -84.3817, -1.4727384934301),
(20036, '45866', 218, 41, 23157, 40.4882, 0.706652398205968, -84.5488, -1.47565493861018),
(20037, '45867', 218, 41, 156623, 40.9061, 0.713946129150053, -83.534, -1.45794333736094),
(20038, '45868', 218, 41, 156625, 40.9676, 0.715019506640029, -83.8374, -1.46323866631149),
(20039, '45869', 218, 41, 96481, 40.4444, 0.705887943993595, -84.3803, -1.47271405882057),
(20040, '45870', 218, 41, 144190, 40.5559, 0.707833986109568, -83.9524, -1.46524579495129),
(20041, '45871', 218, 41, 156725, 40.4957, 0.706783297899868, -84.3021, -1.47134921134551),
(20042, '45872', 218, 41, 156800, 41.1869, 0.718847013689653, -83.6702, -1.46032047580216),
(20043, '45873', 218, 41, 4723, 41.1, 0.717330322569669, -84.4004, -1.47306487000022),
(20044, '45874', 218, 41, 156915, 40.7747, 0.711652766512932, -84.6354, -1.47716639374241),
(20045, '45875', 218, 41, 33532, 41.0268, 0.71605274155721, -84.0547, -1.46703126677608),
(20046, '45876', 218, 41, 156985, 40.9309, 0.714378970804547, -84.3388, -1.47198974718099),
(20047, '45877', 218, 41, 89753, 40.9494, 0.714701856716166, -83.9543, -1.46527895620708),
(20048, '45879', 218, 41, 56816, 41.1401, 0.718030199599719, -84.5842, -1.47627278516539),
(20049, '45880', 218, 41, 11107, 41.0778, 0.716942859475727, -84.7279, -1.4787808233005),
(20050, '45881', 218, 41, 113968, 40.9551, 0.71480134048353, -83.7774, -1.4621914687603),
(20051, '45882', 218, 41, 5475, 40.6725, 0.709869040017394, -84.658, -1.47756083815336),
(20052, '45883', 218, 41, 31030, 40.41, 0.705287550730909, -84.6328, -1.47712101518186),
(20053, '45884', 218, 41, 28504, 40.5556, 0.707828750121812, -84.0839, -1.46754090291766),
(20054, '45885', 218, 41, 24606, 40.5463, 0.707666434501377, -84.399, -1.47304043539069),
(20055, '45886', 218, 41, 11829, 40.9869, 0.715356355185664, -84.584, -1.47626929450688),
(20056, '45887', 218, 41, 51592, 40.7192, 0.710684108778075, -84.3418, -1.47204210705855),
(20057, '45888', 218, 41, 158054, 40.6025, 0.708647309540998, -84.087, -1.46759500812447),
(20058, '45889', 218, 41, 12525, 41.1383, 0.717998783673183, -83.6382, -1.45976197044152),
(20059, '45890', 218, 41, 158093, 40.9689, 0.715042195920305, -83.4894, -1.45716492051455),
(20060, '45891', 218, 41, 25694, 40.8624, 0.713183420266931, -84.5872, -1.47632514504295),
(20061, '45893', 218, 41, 158096, 40.8818, 0.713522014141818, -84.1484, -1.4686666402852),
(20062, '45894', 218, 41, 158097, 40.7523, 0.711261812760485, -84.5163, -1.47508770660328),
(20063, '45895', 218, 41, 158157, 40.5781, 0.708221449203511, -84.1763, -1.4691535871465),
(20064, '45896', 218, 41, 158234, 40.6047, 0.708685706784542, -83.9648, -1.46546221577853),
(20065, '45897', 218, 41, 6834, 40.8339, 0.712686001430113, -83.6475, -1.45992428606196),
(20066, '45898', 218, 41, 158415, 40.6948, 0.710258248440588, -84.7829, -1.4797407543891),
(20067, '45899', 218, 41, 6963, 40.8004, 0.712101316130694, -84.773, -1.47956796679315),
(20068, '45944', 218, 41, 8080, 39.0866, 0.682189863410016, -84.5141, -1.47504930935974),
(20069, '45999', 218, 41, 8080, 39.0864, 0.682186372751512, -84.5142, -1.47505105468899),
(20070, '46001', 218, 19, 34524, 40.2639, 0.702737624693745, -85.677, -1.49534574323118),
(20071, '46011', 218, 19, 7099, 40.1066, 0.699992221780358, -85.7228, -1.4961451040286),
(20072, '46012', 218, 19, 7099, 40.1276, 0.700358740923277, -85.6552, -1.49496526145425),
(20073, '46013', 218, 19, 7099, 40.0659, 0.699281872774796, -85.6797, -1.49539286712099),
(20074, '46014', 218, 19, 7099, 40.0828, 0.699576833418383, -85.6773, -1.49535097921894),
(20075, '46015', 218, 19, 7099, 40.1063, 0.699986985792602, -85.678, -1.4953631965237),
(20076, '46016', 218, 19, 7099, 40.1007, 0.69988924735449, -85.6792, -1.49538414047473),
(20077, '46017', 218, 19, 7099, 40.1002, 0.69988052070823, -85.6053, -1.4940943421575),
(20078, '46018', 218, 19, 7099, 40.0929, 0.699753111672835, -85.6875, -1.49552900280264),
(20079, '46030', 218, 19, 7137, 40.1728, 0.701147629745178, -86.0161, -1.50126415472469),
(20080, '46031', 218, 19, 7187, 40.2124, 0.701838780128968, -86.0091, -1.50114198167706),
(20081, '46032', 218, 19, 7911, 39.9706, 0.697618573997645, -86.1324, -1.50329397264476),
(20082, '46033', 218, 19, 7911, 39.9647, 0.697515599571778, -86.0997, -1.50272324997936),
(20083, '46034', 218, 19, 32068, 40.1295, 0.700391902179064, -86.0178, -1.50129382532198),
(20084, '46035', 218, 19, 8175, 40.1942, 0.701521130205105, -86.6667, -1.51261926683817),
(20085, '46036', 218, 19, 15933, 40.2744, 0.702920884265204, -85.841, -1.49820808320445),
(20086, '46038', 218, 19, 29796, 39.9578, 0.69739517185339, -86.0212, -1.50135316651655),
(20087, '46039', 218, 19, 2517, 40.3751, 0.704678430821963, -86.3125, -1.50643731062761),
(20088, '46040', 218, 19, 21246, 39.9343, 0.696985019479172, -85.8479, -1.49832851092284),
(20089, '46041', 218, 19, 2594, 40.2809, 0.703034330666584, -86.5091, -1.50986862793703),
(20090, '46044', 218, 19, 122655, 40.2212, 0.701992369103143, -85.7718, -1.49700031536207),
(20091, '46045', 218, 19, 122700, 40.2892, 0.703179192994499, -86.1493, -1.50358893328835);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(20092, '46046', 218, 19, 122818, 40.2869, 0.703139050421704, -86.3391, -1.50690156820864),
(20093, '46047', 218, 19, 36458, 40.2834, 0.703077963897884, -85.9472, -1.50006162287007),
(20094, '46048', 218, 19, 9659, 39.9575, 0.697389935865634, -85.8033, -1.49755009407645),
(20095, '46049', 218, 19, 48600, 40.2887, 0.703170466348239, -86.2304, -1.50500439531172),
(20096, '46050', 218, 19, 60498, 40.1939, 0.701515894217349, -86.3586, -1.50724190741278),
(20097, '46051', 218, 19, 123027, 40.0682, 0.699322015347592, -85.8481, -1.49833200158134),
(20098, '46052', 218, 19, 3708, 40.0536, 0.699067197276801, -86.4684, -1.50915827893146),
(20099, '46055', 218, 19, 30471, 39.9075, 0.696517271239637, -85.9235, -1.49964797983735),
(20100, '46056', 218, 19, 30443, 40.0765, 0.699466877675508, -85.692, -1.49560754261898),
(20101, '46057', 218, 19, 123188, 40.3262, 0.703824964817737, -86.4238, -1.50837986208508),
(20102, '46058', 218, 19, 4454, 40.373, 0.704641778907671, -86.6285, -1.51195255106391),
(20103, '46060', 218, 19, 123312, 40.0381, 0.698796671242742, -86.0049, -1.50106867784847),
(20104, '46061', 218, 19, 123312, 40.0561, 0.699110830508101, -86.0321, -1.50154340740501),
(20105, '46063', 218, 19, 123372, 40.2706, 0.702854561753628, -85.7279, -1.49623411582045),
(20106, '46064', 218, 19, 11133, 40.0012, 0.698152644748756, -85.7367, -1.49638770479462),
(20107, '46065', 218, 19, 24541, 40.4189, 0.705442885034336, -86.5954, -1.5113748470815),
(20108, '46067', 218, 19, 38144, 40.4155, 0.705383543839768, -86.5151, -1.50997334769215),
(20109, '46068', 218, 19, 38174, 40.3796, 0.704756970638302, -86.0902, -1.50255744370042),
(20110, '46069', 218, 19, 11906, 40.1358, 0.70050185792194, -86.2127, -1.50469547203412),
(20111, '46070', 218, 19, 91138, 40.3384, 0.704037894986481, -85.6425, -1.49474360463924),
(20112, '46071', 218, 19, 14749, 40.1259, 0.700329070325993, -86.6089, -1.51161046653052),
(20113, '46072', 218, 19, 12332, 40.2883, 0.703163485031231, -86.0452, -1.50177204553702),
(20114, '46074', 218, 19, 723, 40.0349, 0.698740820706678, -86.1553, -1.50369365304347),
(20115, '46075', 218, 19, 31524, 39.9801, 0.697784380276585, -86.347, -1.50703944921954),
(20116, '46076', 218, 19, 124030, 40.3621, 0.704451538019203, -85.9575, -1.50024139178303),
(20117, '46077', 218, 19, 31589, 39.9579, 0.697396917182642, -86.2757, -1.50579502946287),
(20118, '46082', 218, 19, 7911, 39.9787, 0.697759945667057, -86.1181, -1.50304439056173),
(20119, '46102', 218, 19, 7029, 39.9953, 0.698049670322888, -86.6205, -1.51181292472375),
(20120, '46103', 218, 19, 29095, 39.7004, 0.692902694358757, -86.5842, -1.51117937020527),
(20121, '46104', 218, 19, 15026, 39.6543, 0.692098097573587, -85.5759, -1.49358121535742),
(20122, '46105', 218, 19, 19017, 39.7609, 0.693958618556213, -86.8154, -1.51521457143589),
(20123, '46106', 218, 19, 29151, 39.5256, 0.689851858826271, -86.1901, -1.50430102762316),
(20124, '46107', 218, 19, 296, 39.7156, 0.69316798440506, -86.0961, -1.50266041812629),
(20125, '46110', 218, 19, 29251, 39.5669, 0.690572679807344, -85.9143, -1.49948740954616),
(20126, '46111', 218, 19, 1157, 39.5402, 0.690106676897062, -86.3689, -1.50742167632573),
(20127, '46112', 218, 19, 29321, 39.8445, 0.695417713810881, -86.392, -1.50782484738294),
(20128, '46113', 218, 19, 29372, 39.6574, 0.692152202780399, -86.3137, -1.50645825457863),
(20129, '46114', 218, 19, 29412, 39.6617, 0.692227251938235, -86.5019, -1.50974296423088),
(20130, '46115', 218, 19, 7932, 39.7349, 0.693504832950695, -85.573, -1.49353060080911),
(20131, '46117', 218, 19, 29461, 39.7922, 0.694504906612088, -85.612, -1.49421127921739),
(20132, '46118', 218, 19, 608, 39.6901, 0.692722925445801, -86.523, -1.51011122870305),
(20133, '46120', 218, 19, 1638, 39.5104, 0.689586568779967, -86.7947, -1.51485328828072),
(20134, '46121', 218, 19, 29524, 39.6952, 0.692811937237653, -86.6182, -1.51177278215095),
(20135, '46122', 218, 19, 1964, 39.7605, 0.693951637239205, -86.5014, -1.50973423758462),
(20136, '46123', 218, 19, 7208, 39.7606, 0.693953382568457, -86.5262, -1.51016707923912),
(20137, '46124', 218, 19, 29702, 39.354, 0.686856873829848, -85.9641, -1.50035658351366),
(20138, '46125', 218, 19, 8755, 39.5211, 0.689773319009931, -86.6416, -1.51218118919592),
(20139, '46126', 218, 19, 8820, 39.6252, 0.691590206761257, -85.8745, -1.49879276850387),
(20140, '46127', 218, 19, 15986, 39.7434, 0.693653185937114, -85.3554, -1.48973276435677),
(20141, '46128', 218, 19, 27166, 39.6552, 0.692113805536855, -86.7455, -1.51399458628874),
(20142, '46129', 218, 19, 0, 39.7055, 0.692991706150609, -85.8225, -1.49788519729283),
(20143, '46130', 218, 19, 29829, 39.695, 0.692808446579149, -85.7811, -1.49716263098251),
(20144, '46131', 218, 19, 2595, 39.4845, 0.689134528503701, -86.052, -1.50189072792616),
(20145, '46133', 218, 19, 2749, 39.6099, 0.691323171385702, -85.2753, -1.48833475562592),
(20146, '46135', 218, 19, 29941, 39.6435, 0.691909602014372, -86.8564, -1.5159301564292),
(20147, '46140', 218, 19, 2861, 39.7947, 0.694548539843387, -85.7927, -1.49736508917574),
(20148, '46142', 218, 19, 2869, 39.6204, 0.691506430957161, -86.1449, -1.50351213880126),
(20149, '46143', 218, 19, 2869, 39.5987, 0.691127694509479, -86.1336, -1.50331491659579),
(20150, '46144', 218, 19, 29970, 39.6609, 0.692213289304219, -85.6476, -1.4948326164311),
(20151, '46146', 218, 19, 22029, 39.5776, 0.690759430037308, -85.5784, -1.49362484858872),
(20152, '46147', 218, 19, 3399, 39.9278, 0.696871573077792, -86.6283, -1.5119490604054),
(20153, '46148', 218, 19, 30261, 39.7963, 0.694576465111419, -85.527, -1.49272774935319),
(20154, '46149', 218, 19, 30359, 39.8862, 0.696145516108962, -86.5436, -1.51047076652896),
(20155, '46150', 218, 19, 30414, 39.5762, 0.69073499542778, -85.6377, -1.49465982883515),
(20156, '46151', 218, 19, 27817, 39.4458, 0.688459086083179, -86.4187, -1.50829085029322),
(20157, '46154', 218, 19, 4045, 39.8567, 0.695630643979624, -85.7708, -1.49698286206955),
(20158, '46155', 218, 19, 4059, 39.744, 0.693663657912626, -85.43, -1.49103477997876),
(20159, '46156', 218, 19, 30524, 39.5002, 0.689408545196264, -85.469, -1.49171545838703),
(20160, '46157', 218, 19, 4274, 39.5503, 0.690282955151513, -86.5, -1.5097098029751),
(20161, '46158', 218, 19, 4315, 39.5911, 0.690995049486327, -86.3772, -1.50756653865365),
(20162, '46160', 218, 19, 17178, 39.38, 0.687310659435367, -86.2648, -1.5056047885744),
(20163, '46161', 218, 19, 30565, 39.6729, 0.692422728814458, -85.7001, -1.49574891428839),
(20164, '46162', 218, 19, 4495, 39.4857, 0.689155472454725, -85.9967, -1.50092556084981),
(20165, '46163', 218, 19, 28041, 39.7325, 0.693462945048647, -85.9085, -1.49938618044955),
(20166, '46164', 218, 19, 30667, 39.3825, 0.687354292666667, -86.0867, -1.5024963571766),
(20167, '46165', 218, 19, 30685, 39.8424, 0.695381061896589, -86.6333, -1.512036326868),
(20168, '46166', 218, 19, 30769, 39.3975, 0.687616092054466, -86.5613, -1.51077968980657),
(20169, '46167', 218, 19, 30845, 39.8655, 0.695784232953799, -86.4693, -1.50917398689473),
(20170, '46168', 218, 19, 11247, 39.7082, 0.693038830040412, -86.394, -1.50785975396798),
(20171, '46170', 218, 19, 30909, 39.5743, 0.690701834171992, -86.8649, -1.51607850941562),
(20172, '46171', 218, 19, 30945, 39.5381, 0.69007002498277, -86.9586, -1.51771388292474),
(20173, '46172', 218, 19, 30985, 39.8486, 0.695489272310212, -86.7979, -1.51490913881679),
(20174, '46173', 218, 19, 31020, 39.6145, 0.691403456531294, -85.4491, -1.49136813786589),
(20175, '46175', 218, 19, 5585, 39.8224, 0.69503199604619, -86.9542, -1.51763708843765),
(20176, '46176', 218, 19, 11899, 39.5184, 0.689726195120127, -85.777, -1.49709107248318),
(20177, '46180', 218, 19, 31224, 39.6374, 0.69180313693, -86.6334, -1.51203807219726),
(20178, '46181', 218, 19, 12377, 39.3644, 0.687038388072056, -86.1816, -1.50415267463675),
(20179, '46182', 218, 19, 12596, 39.4277, 0.688143181488568, -85.6311, -1.49454463710452),
(20180, '46183', 218, 19, 31494, 39.6542, 0.692096352244336, -86.2792, -1.50585611598669),
(20181, '46184', 218, 19, 31522, 39.5608, 0.690466214722973, -86.0831, -1.50243352532353),
(20182, '46186', 218, 19, 31534, 39.8858, 0.696138534791954, -85.6086, -1.49415193802282),
(20183, '46201', 218, 19, 30144, 39.7754, 0.694211691297753, -86.1091, -1.50288731092905),
(20184, '46202', 218, 19, 30144, 39.7805, 0.694300703089604, -86.16, -1.50377568351831),
(20185, '46203', 218, 19, 30144, 39.7417, 0.69362351533983, -86.1061, -1.50283495105149),
(20186, '46204', 218, 19, 30144, 39.7722, 0.694155840761689, -86.156, -1.50370587034823),
(20187, '46205', 218, 19, 30144, 39.8272, 0.695115771850286, -86.1298, -1.50324859408421),
(20188, '46206', 218, 19, 30144, 39.7434, 0.693653185937114, -86.1619, -1.5038088447741),
(20189, '46207', 218, 19, 30144, 39.7433, 0.693651440607862, -86.162, -1.50381059010335),
(20190, '46208', 218, 19, 30144, 39.8321, 0.695201292983633, -86.1903, -1.50430451828167),
(20191, '46209', 218, 19, 30144, 39.7435, 0.693654931266366, -86.1617, -1.5038053541156),
(20192, '46211', 218, 19, 30144, 39.8924, 0.696253726522586, -86.2576, -1.50547912486826),
(20193, '46214', 218, 19, 30144, 39.7889, 0.694447310746772, -86.2941, -1.50611617004524),
(20194, '46216', 218, 19, 30144, 39.8626, 0.695733618405492, -86.015, -1.50124495610292),
(20195, '46217', 218, 19, 30144, 39.669, 0.692354660973631, -86.1992, -1.5044598525851),
(20196, '46218', 218, 19, 30144, 39.806, 0.694745762048863, -86.0999, -1.50272674063787),
(20197, '46219', 218, 19, 30144, 39.7828, 0.6943408456624, -86.0445, -1.50175982823226),
(20198, '46220', 218, 19, 30144, 39.8669, 0.695808667563327, -86.108, -1.50286811230728),
(20199, '46221', 218, 19, 30144, 39.723, 0.693297138769708, -86.2288, -1.50497647004369),
(20200, '46222', 218, 19, 30144, 39.788, 0.694431602783504, -86.2135, -1.50470943466813),
(20201, '46223', 218, 19, 30144, 39.7844, 0.694368770930432, -86.1618, -1.50380709944485),
(20202, '46224', 218, 19, 30144, 39.7979, 0.694604390379451, -86.2615, -1.50554719270909),
(20203, '46225', 218, 19, 30144, 39.7469, 0.693714272460934, -86.1615, -1.50380186345709),
(20204, '46226', 218, 19, 30144, 39.8372, 0.695290304775485, -86.0492, -1.5018418587071),
(20205, '46227', 218, 19, 30144, 39.6747, 0.692454144740994, -86.1288, -1.50323114079169),
(20206, '46228', 218, 19, 30144, 39.8544, 0.695590501406828, -86.1199, -1.50307580648826),
(20207, '46229', 218, 19, 30144, 39.7925, 0.694510142599844, -85.9836, -1.5006969227178),
(20208, '46230', 218, 19, 30144, 39.8679, 0.695826120855847, -86.1087, -1.50288032961204),
(20209, '46231', 218, 19, 30144, 39.7228, 0.693293648111204, -86.309, -1.50637622410379),
(20210, '46234', 218, 19, 30144, 39.8076, 0.694773687316895, -86.3372, -1.50686840695285),
(20211, '46235', 218, 19, 30144, 39.8421, 0.695375825908833, -85.9814, -1.50065852547425),
(20212, '46236', 218, 19, 30144, 39.8632, 0.695744090381004, -85.9675, -1.50041592470823),
(20213, '46237', 218, 19, 30144, 39.6849, 0.692632168324698, -86.0803, -1.50238465610447),
(20214, '46239', 218, 19, 30144, 39.7196, 0.69323779757514, -86.0034, -1.50104249790969),
(20215, '46240', 218, 19, 30144, 39.9042, 0.696459675374321, -86.1281, -1.50321892348693),
(20216, '46241', 218, 19, 30144, 39.7265, 0.693358225293527, -86.2548, -1.50543025564921),
(20217, '46242', 218, 19, 30144, 39.7023, 0.692935855614545, -86.2571, -1.505470398222),
(20218, '46244', 218, 19, 30144, 39.7736, 0.694180275371217, -86.158, -1.50374077693327),
(20219, '46247', 218, 19, 30144, 39.6763, 0.692482070009026, -86.1316, -1.50328001001075),
(20220, '46249', 218, 19, 30144, 39.86, 0.69568823984494, -86.0014, -1.50100759132465),
(20221, '46250', 218, 19, 30144, 39.9015, 0.696412551484517, -86.0707, -1.50221710449628),
(20222, '46251', 218, 19, 30144, 39.7273, 0.693372187927543, -86.2681, -1.50566238443972),
(20223, '46253', 218, 19, 30144, 39.828, 0.695129734484302, -86.2717, -1.50572521629279),
(20224, '46254', 218, 19, 30144, 39.8426, 0.695384552555093, -86.263, -1.50557337264787),
(20225, '46255', 218, 19, 30144, 39.7663, 0.694052866335821, -86.1608, -1.50378964615233),
(20226, '46256', 218, 19, 30144, 39.9086, 0.696536469861409, -85.994, -1.50087843696),
(20227, '46259', 218, 19, 30144, 39.6559, 0.692126022841619, -85.9976, -1.50094126881308),
(20228, '46260', 218, 19, 30144, 39.8932, 0.696267689156602, -86.1832, -1.50418059990478),
(20229, '46266', 218, 19, 30144, 39.7677, 0.694077300945349, -86.1634, -1.50383502471288),
(20230, '46268', 218, 19, 30144, 39.8993, 0.696374154240973, -86.2244, -1.5048996755566),
(20231, '46274', 218, 19, 30144, 39.8922, 0.696250235864082, -86.2571, -1.505470398222),
(20232, '46275', 218, 19, 30144, 39.7704, 0.694124424835153, -86.1563, -1.50371110633599),
(20233, '46277', 218, 19, 30144, 39.7715, 0.694143623456925, -86.1569, -1.5037215783115),
(20234, '46278', 218, 19, 30144, 39.8905, 0.696220565266798, -86.2892, -1.50603064891189),
(20235, '46280', 218, 19, 30144, 39.9386, 0.697060068637007, -86.1365, -1.5033655311441),
(20236, '46282', 218, 19, 30144, 39.7709, 0.694133151481413, -86.1558, -1.50370237968973),
(20237, '46283', 218, 19, 30144, 39.7745, 0.694195983334485, -86.1098, -1.50289952823381),
(20238, '46285', 218, 19, 30144, 39.7435, 0.693654931266366, -86.162, -1.50381059010335),
(20239, '46290', 218, 19, 30144, 39.9367, 0.697026907381219, -86.2112, -1.50466929209534),
(20240, '46291', 218, 19, 30144, 39.7839, 0.694360044284172, -86.0441, -1.50175284691525),
(20241, '46295', 218, 19, 30144, 39.6732, 0.692427964802214, -86.1931, -1.50435338750072),
(20242, '46296', 218, 19, 30144, 39.7683, 0.694087772920861, -86.1585, -1.50374950357953),
(20243, '46298', 218, 19, 30144, 39.8983, 0.696356700948454, -86.2315, -1.50502359393349),
(20244, '46301', 218, 19, 19270, 41.6736, 0.727341531159109, -86.9752, -1.51800360758057),
(20245, '46302', 218, 19, 122252, 41.3533, 0.721751241564971, -87.1271, -1.52065476271435),
(20246, '46303', 218, 19, 1424, 41.3753, 0.72213521400041, -87.4449, -1.52620141907719),
(20247, '46304', 218, 19, 29467, 41.6185, 0.72637985474126, -87.0282, -1.51892863208413),
(20248, '46307', 218, 19, 15678, 41.4199, 0.722913630846799, -87.3558, -1.52464633071366),
(20249, '46308', 218, 19, 15678, 41.4169, 0.722861270969239, -87.365, -1.52480690100485),
(20250, '46310', 218, 19, 122479, 41.1833, 0.718784181836581, -87.2087, -1.52207895138398),
(20251, '46311', 218, 19, 8642, 41.4881, 0.724103945396659, -87.5091, -1.52732192045697),
(20252, '46312', 218, 19, 122537, 41.6361, 0.726687032689611, -87.4597, -1.52645972780648),
(20253, '46319', 218, 19, 21615, 41.5305, 0.724843964999505, -87.4243, -1.52584188125128),
(20254, '46320', 218, 19, 421, 41.6151, 0.726320513546692, -87.5052, -1.52725385261614),
(20255, '46321', 218, 19, 82531, 41.5539, 0.725252372044472, -87.4997, -1.52715785950728),
(20256, '46322', 218, 19, 3108, 41.5507, 0.725196521508408, -87.458, -1.5264300572092),
(20257, '46323', 218, 19, 421, 41.5873, 0.725835312014638, -87.4524, -1.52633231877109),
(20258, '46324', 218, 19, 421, 41.584, 0.725777716149322, -87.5014, -1.52718753010457),
(20259, '46325', 218, 19, 421, 41.6139, 0.726299569595668, -87.5132, -1.5273934789563),
(20260, '46327', 218, 19, 421, 41.632, 0.726615474190279, -87.5083, -1.52730795782295),
(20261, '46340', 218, 19, 9318, 41.4139, 0.72280891109168, -86.7796, -1.51458974356367),
(20262, '46341', 218, 19, 940, 41.3393, 0.721506895469692, -87.198, -1.52189220115402),
(20263, '46342', 218, 19, 844, 41.5359, 0.724938212779113, -87.2711, -1.52316803683722),
(20264, '46345', 218, 19, 73117, 41.5265, 0.724774151829425, -86.6996, -1.51319348016208),
(20265, '46346', 218, 19, 122962, 41.4807, 0.723974791032012, -86.6935, -1.5130870150777),
(20266, '46347', 218, 19, 122977, 41.3144, 0.721072308485945, -87.033, -1.51901240788822),
(20267, '46348', 218, 19, 16751, 41.3107, 0.721007731303621, -86.8874, -1.51647120849732),
(20268, '46349', 218, 19, 9941, 41.1275, 0.717810288113968, -87.459, -1.52644751050172),
(20269, '46350', 218, 19, 95453, 41.6161, 0.726337966839212, -86.7319, -1.51375722151047),
(20270, '46352', 218, 19, 95453, 41.6228, 0.726454903899096, -86.6969, -1.51314635627227),
(20271, '46355', 218, 19, 3734, 41.3623, 0.721908321197651, -87.2689, -1.52312963959368),
(20272, '46356', 218, 19, 10211, 41.2848, 0.720555691027355, -87.4177, -1.52572668952065),
(20273, '46360', 218, 19, 60877, 41.709, 0.727959377714315, -86.865, -1.51608025474487),
(20274, '46361', 218, 19, 60877, 41.7179, 0.728114712017742, -86.9039, -1.5167591878239),
(20275, '46365', 218, 19, 429, 41.5959, 0.725985410330309, -86.5505, -1.51059119424735),
(20276, '46366', 218, 19, 123323, 41.2193, 0.719412500367299, -86.7742, -1.51449549578406),
(20277, '46368', 218, 19, 42669, 41.5782, 0.725676487052706, -87.1822, -1.5216164391322),
(20278, '46371', 218, 19, 123579, 41.688, 0.727592858571396, -86.6117, -1.51165933574957),
(20279, '46372', 218, 19, 823, 41.1427, 0.718075578160271, -87.3131, -1.52390107512306),
(20280, '46373', 218, 19, 31032, 41.4514, 0.723463409561178, -87.4753, -1.5267319991698),
(20281, '46374', 218, 19, 123622, 41.1986, 0.719051217212136, -86.8921, -1.51655323897216),
(20282, '46375', 218, 19, 123628, 41.4924, 0.724178994554495, -87.4591, -1.52644925583097),
(20283, '46376', 218, 19, 123629, 41.183, 0.718778945848825, -87.4629, -1.52651557834255),
(20284, '46377', 218, 19, 59, 41.1927, 0.718948242786268, -87.3433, -1.52442816455716),
(20285, '46379', 218, 19, 123753, 41.1666, 0.718492711851498, -87.4396, -1.52610891662683),
(20286, '46380', 218, 19, 123787, 41.1986, 0.719051217212136, -86.9736, -1.51797568231254),
(20287, '46381', 218, 19, 28771, 41.173, 0.718604412923625, -87.3334, -1.52425537696122),
(20288, '46382', 218, 19, 38631, 41.4888, 0.724116162701423, -86.7673, -1.51437506806568),
(20289, '46383', 218, 19, 18421, 41.4878, 0.724098709408903, -87.0742, -1.51973148354005),
(20290, '46384', 218, 19, 18421, 41.4938, 0.724203429164023, -87.0556, -1.51940685229918),
(20291, '46385', 218, 19, 18421, 41.4663, 0.723723463619725, -87.1419, -1.52091307144365),
(20292, '46390', 218, 19, 123916, 41.4352, 0.723180666222354, -86.8934, -1.51657592825244),
(20293, '46391', 218, 19, 12776, 41.5536, 0.725247136056716, -86.9017, -1.51672079058036),
(20294, '46392', 218, 19, 84329, 40.5639, 0.707973612449728, -87.1067, -1.52029871554694),
(20295, '46393', 218, 19, 6759, 41.5118, 0.724517588429382, -87.1797, -1.5215728059009),
(20296, '46394', 218, 19, 34415, 41.6773, 0.727406108341433, -87.4959, -1.52709153699571),
(20297, '46401', 218, 19, 16182, 41.4575, 0.723569874645549, -87.2873, -1.52345078017605),
(20298, '46402', 218, 19, 16182, 41.5987, 0.726034279549365, -87.3363, -1.52430599150952),
(20299, '46403', 218, 19, 16182, 41.5899, 0.72588069057519, -87.2748, -1.52323261401955),
(20300, '46404', 218, 19, 16182, 41.5864, 0.72581960405137, -87.3739, -1.52496223530827),
(20301, '46405', 218, 19, 55773, 41.5686, 0.725508935444515, -87.2704, -1.52315581953246),
(20302, '46406', 218, 19, 16182, 41.5877, 0.725842293331646, -87.4102, -1.52559578982675),
(20303, '46407', 218, 19, 16182, 41.5811, 0.725727101601014, -87.3348, -1.52427981157074),
(20304, '46408', 218, 19, 16182, 41.5413, 0.72503246055872, -87.3681, -1.52486100621166),
(20305, '46409', 218, 19, 16182, 41.5429, 0.725060385826752, -87.3254, -1.52411575062106),
(20306, '46410', 218, 19, 23048, 41.4946, 0.724217391798039, -87.3514, -1.52456953622657),
(20307, '46411', 218, 19, 23048, 41.4719, 0.723821202057836, -87.3788, -1.52504775644162),
(20308, '46501', 218, 19, 122158, 41.6972, 0.72775342886258, -86.2449, -1.50525746805326),
(20309, '46502', 218, 19, 7189, 41.2605, 0.72013157601912, -85.975, -1.50054682440212),
(20310, '46504', 218, 19, 26582, 41.3183, 0.721140376326773, -86.1203, -1.50308278780527),
(20311, '46506', 218, 19, 1103, 41.4345, 0.72316844891759, -86.1735, -1.50401130296733),
(20312, '46507', 218, 19, 15330, 41.7199, 0.728149618602782, -85.8267, -1.49795850112142),
(20313, '46508', 218, 19, 122296, 41.1557, 0.71830247096303, -85.9691, -1.50044384997626),
(20314, '46510', 218, 19, 35265, 41.1242, 0.717752692248652, -85.8971, -1.49918721291482),
(20315, '46511', 218, 19, 32191, 41.2263, 0.719534673414938, -86.4136, -1.50820183850137),
(20316, '46513', 218, 19, 8558, 41.3607, 0.721880395929619, -86.4435, -1.50872369194772),
(20317, '46514', 218, 19, 94006, 41.71, 0.727976831006835, -85.9731, -1.50051366314634),
(20318, '46515', 218, 19, 94006, 41.6823, 0.727493374804032, -85.9714, -1.50048399254905),
(20319, '46516', 218, 19, 94006, 41.6744, 0.727355493793125, -85.9578, -1.50024662777078),
(20320, '46517', 218, 19, 94006, 41.649, 0.726912180163118, -85.9686, -1.50043512333),
(20321, '46524', 218, 19, 122586, 41.2949, 0.720731969281806, -86.0875, -1.50251031981062),
(20322, '46526', 218, 19, 419, 41.5886, 0.725858001294914, -85.8385, -1.49816444997315),
(20323, '46527', 218, 19, 419, 41.5885, 0.725856255965662, -85.8417, -1.49822030050922),
(20324, '46528', 218, 19, 419, 41.5989, 0.726037770207869, -85.7891, -1.49730225732267),
(20325, '46530', 218, 19, 94574, 41.7423, 0.728540572355229, -86.1596, -1.50376870220131),
(20326, '46531', 218, 19, 122741, 41.3256, 0.721267785362169, -86.5227, -1.5101059927153),
(20327, '46532', 218, 19, 9305, 41.3796, 0.722210263158246, -86.5861, -1.51121253146106),
(20328, '46534', 218, 19, 30266, 41.2959, 0.720749422574326, -86.6174, -1.51175881951694),
(20329, '46536', 218, 19, 16832, 41.5261, 0.724767170512417, -86.2775, -1.50582644538941),
(20330, '46537', 218, 19, 0, 41.4565, 0.723552421353029, -86.3067, -1.50633608153099),
(20331, '46538', 218, 19, 3721, 41.3303, 0.721349815837012, -85.8441, -1.49826218841126),
(20332, '46539', 218, 19, 4169, 41.1717, 0.718581723643349, -86.0356, -1.50160449392883),
(20333, '46540', 218, 19, 30497, 41.6748, 0.727362475110133, -85.7045, -1.49582570877548),
(20334, '46542', 218, 19, 10480, 41.409, 0.722723389958332, -85.8485, -1.49833898289835),
(20335, '46543', 218, 19, 30514, 41.5202, 0.72466419608655, -85.6958, -1.49567386513056),
(20336, '46544', 218, 19, 123213, 41.6501, 0.72693137878489, -86.1565, -1.50371459699449),
(20337, '46545', 218, 19, 123213, 41.6825, 0.727496865462536, -86.1618, -1.50380709944485),
(20338, '46546', 218, 19, 123213, 41.6617, 0.727133836978122, -86.1587, -1.50375299423804),
(20339, '46550', 218, 19, 123270, 41.4485, 0.72341279501287, -85.9987, -1.50096046743485),
(20340, '46552', 218, 19, 73641, 41.7066, 0.727917489812267, -86.4811, -1.50937993574647),
(20341, '46553', 218, 19, 73670, 41.5016, 0.724339564845679, -85.8305, -1.49802482363299),
(20342, '46554', 218, 19, 89474, 41.5517, 0.725213974800928, -86.4035, -1.50802556024692),
(20343, '46555', 218, 19, 123328, 41.3263, 0.721280002666933, -85.6905, -1.4955813626802),
(20344, '46556', 218, 19, 28086, 41.6951, 0.727716776948288, -86.2385, -1.50514576698113),
(20345, '46561', 218, 19, 11010, 41.6699, 0.727276953976785, -86.0777, -1.50233927754392),
(20346, '46562', 218, 19, 123430, 41.2001, 0.719077397150916, -85.7091, -1.49590599392107),
(20347, '46563', 218, 19, 14433, 41.3491, 0.721677937736387, -86.3275, -1.5066991100154),
(20348, '46565', 218, 19, 123668, 41.6772, 0.727404363012181, -85.5795, -1.49364404721049),
(20349, '46566', 218, 19, 5844, 41.1064, 0.717442023641797, -85.7461, -1.49655176574431),
(20350, '46567', 218, 19, 57818, 41.4201, 0.722917121505303, -85.7413, -1.49646798994021),
(20351, '46570', 218, 19, 123803, 41.2121, 0.719286836661155, -86.1239, -1.50314561965834),
(20352, '46571', 218, 19, 34152, 41.5391, 0.724994063315176, -85.5387, -1.49293195287567),
(20353, '46572', 218, 19, 25629, 41.419, 0.722897922883531, -86.4012, -1.50798541767412),
(20354, '46573', 218, 19, 34296, 41.5384, 0.724981846010413, -86.0834, -1.50243876131129),
(20355, '46574', 218, 19, 6611, 41.4697, 0.723782804814293, -86.4639, -1.50907973911512),
(20356, '46580', 218, 19, 6638, 41.2377, 0.719733640949666, -85.8526, -1.49841054139768),
(20357, '46581', 218, 19, 6638, 41.2373, 0.719726659632658, -85.8601, -1.49854144109158),
(20358, '46582', 218, 19, 6638, 41.2381, 0.719740622266674, -85.8531, -1.49841926804394),
(20359, '46590', 218, 19, 124035, 41.2206, 0.719435189647575, -85.8174, -1.49779618550098),
(20360, '46595', 218, 19, 6967, 41.5233, 0.724718301293361, -86.1678, -1.50391181919997),
(20361, '46601', 218, 19, 12027, 41.6738, 0.727345021817613, -86.2529, -1.50539709439342),
(20362, '46604', 218, 19, 12027, 41.6749, 0.727364220439385, -86.2121, -1.5046850000586),
(20363, '46612', 218, 19, 12027, 41.6074, 0.726186123194289, -86.2877, -1.50600446897311),
(20364, '46613', 218, 19, 12027, 41.6551, 0.72701864524749, -86.254, -1.50541629301519),
(20365, '46614', 218, 19, 12027, 41.6231, 0.726460139886852, -86.2498, -1.50534298918661),
(20366, '46615', 218, 19, 12027, 41.6737, 0.727343276488361, -86.212, -1.50468325472935),
(20367, '46616', 218, 19, 12027, 41.6909, 0.727643473119704, -86.265, -1.50560827923291),
(20368, '46617', 218, 19, 12027, 41.6842, 0.72752653605982, -86.2361, -1.50510387907908),
(20369, '46619', 218, 19, 12027, 41.6681, 0.727245538050249, -86.3238, -1.50663453283308),
(20370, '46620', 218, 19, 12027, 41.7212, 0.728172307883058, -86.3306, -1.50675321522222),
(20371, '46624', 218, 19, 12027, 41.6564, 0.727041334527766, -86.2897, -1.50603937555815),
(20372, '46626', 218, 19, 12027, 41.6564, 0.727041334527766, -86.2951, -1.50613362333776),
(20373, '46628', 218, 19, 12027, 41.7021, 0.727838949995927, -86.3083, -1.50636400679902),
(20374, '46629', 218, 19, 12027, 41.6549, 0.727015154588986, -86.3601, -1.50726808735155),
(20375, '46634', 218, 19, 12027, 41.6914, 0.727652199765964, -86.2376, -1.50513005901786),
(20376, '46635', 218, 19, 12027, 41.7141, 0.728048389506167, -86.2078, -1.50460995090077),
(20377, '46637', 218, 19, 12027, 41.7282, 0.728294480930698, -86.2432, -1.50522779745597),
(20378, '46660', 218, 19, 12027, 41.6941, 0.727699323655768, -86.2138, -1.50471467065589),
(20379, '46680', 218, 19, 12027, 41.6325, 0.726624200836539, -86.2523, -1.50538662241791),
(20380, '46699', 218, 19, 12027, 41.6704, 0.727285680623045, -86.2527, -1.50539360373491),
(20381, '46701', 218, 19, 7043, 41.3952, 0.722482534521557, -85.423, -1.49091260693112),
(20382, '46702', 218, 19, 7102, 40.8538, 0.713033321951259, -85.6031, -1.49405594491396),
(20383, '46703', 218, 19, 31649, 41.6404, 0.726762081847447, -85.0029, -1.48358047874349),
(20384, '46704', 218, 19, 18900, 41.1037, 0.717394899751993, -85.2918, -1.4886227349525),
(20385, '46705', 218, 19, 13302, 41.5144, 0.724562966989934, -85.0697, -1.48474635868382),
(20386, '46706', 218, 19, 13306, 41.3688, 0.72202176759903, -85.0488, -1.48438158487015),
(20387, '46710', 218, 19, 7212, 41.364, 0.721937991794934, -85.2374, -1.48767327583941),
(20388, '46711', 218, 19, 113160, 40.6571, 0.709600259312587, -84.9542, -1.48273050339777),
(20389, '46713', 218, 19, 122229, 40.9441, 0.71460935426581, -85.6186, -1.49432647094802),
(20390, '46714', 218, 19, 1018, 40.7337, 0.710937181519614, -85.1766, -1.4866121156542),
(20391, '46720', 218, 19, 45096, 41.4552, 0.723529732072753, -85.4011, -1.49053037982493),
(20392, '46721', 218, 19, 1257, 41.4163, 0.722850798993728, -84.8855, -1.48153146220165),
(20393, '46723', 218, 19, 122367, 41.2222, 0.719463114915607, -85.2744, -1.48831904766265),
(20394, '46725', 218, 19, 122416, 41.1603, 0.718382756108622, -85.4917, -1.49211164812724),
(20395, '46730', 218, 19, 122432, 41.438, 0.72322953544141, -85.1522, -1.48618625531672),
(20396, '46731', 218, 19, 122442, 40.7779, 0.711708617048996, -85.0979, -1.48523854153288),
(20397, '46732', 218, 19, 1893, 41.4028, 0.722615179544708, -85.6666, -1.49516422898897),
(20398, '46733', 218, 19, 2007, 40.8298, 0.712614442930781, -84.9273, -1.48226100982898),
(20399, '46737', 218, 19, 2605, 41.7344, 0.728402691344321, -84.9095, -1.48195034122213),
(20400, '46738', 218, 19, 9065, 41.347, 0.721641285822095, -85.1347, -1.48588082269762),
(20401, '46740', 218, 19, 2687, 40.5929, 0.708479757932806, -84.96, -1.48283173249438),
(20402, '46741', 218, 19, 122702, 41.2128, 0.719299053965919, -84.9714, -1.48303070002911),
(20403, '46742', 218, 19, 2950, 41.5144, 0.724562966989934, -84.8963, -1.48171995776086),
(20404, '46743', 218, 19, 32686, 41.2168, 0.719368867135999, -84.8469, -1.48085776511038),
(20405, '46745', 218, 19, 72917, 40.9511, 0.71473152731345, -85.0057, -1.48362934796254),
(20406, '46746', 218, 19, 3253, 41.7295, 0.728317170210974, -85.4298, -1.49103128932025),
(20407, '46747', 218, 19, 16505, 41.5266, 0.724775897158677, -85.1127, -1.48549685026218),
(20408, '46748', 218, 19, 122845, 41.2412, 0.719794727473485, -85.1568, -1.48626654046231),
(20409, '46750', 218, 19, 9621, 40.8841, 0.713562156714614, -85.4934, -1.49214131872452),
(20410, '46755', 218, 19, 116293, 41.4457, 0.723363925793814, -85.2612, -1.48808866420139),
(20411, '46759', 218, 19, 3513, 40.6063, 0.708713632052573, -85.1924, -1.48688787767602),
(20412, '46760', 218, 19, 122960, 41.3514, 0.721718080309183, -85.608, -1.49414146604731),
(20413, '46761', 218, 19, 103428, 41.6434, 0.726814441725007, -85.4173, -1.49081312316375),
(20414, '46763', 218, 19, 123026, 41.2924, 0.720688336050507, -85.1997, -1.48701528671141),
(20415, '46764', 218, 19, 123028, 41.1922, 0.718939516140008, -85.6182, -1.49431948963101),
(20416, '46765', 218, 19, 22630, 41.2266, 0.719539909402694, -85.0309, -1.48406917093405),
(20417, '46766', 218, 19, 116470, 40.707, 0.710471178609332, -85.2888, -1.48857037507494),
(20418, '46767', 218, 19, 123067, 41.4647, 0.723695538351693, -85.5902, -1.49383079744045),
(20419, '46769', 218, 19, 116554, 40.6448, 0.709385583814591, -85.0334, -1.48411280416535),
(20420, '46770', 218, 19, 113255, 40.8346, 0.712698218734876, -85.3286, -1.48926501611723),
(20421, '46771', 218, 19, 123217, 41.6844, 0.727530026718324, -85.2793, -1.488404568796),
(20422, '46772', 218, 19, 10560, 40.7423, 0.711087279835286, -84.9429, -1.48253328119229),
(20423, '46773', 218, 19, 4273, 40.983, 0.715288287344836, -84.8779, -1.4813988171785),
(20424, '46774', 218, 19, 4528, 41.0806, 0.716991728694782, -84.9952, -1.48344608839108),
(20425, '46776', 218, 19, 23671, 41.7365, 0.728439343258613, -85.1697, -1.48649168793581),
(20426, '46777', 218, 19, 117168, 40.8735, 0.713377151813902, -85.1664, -1.4864340920705),
(20427, '46778', 218, 19, 37655, 40.6115, 0.708804389173677, -85.1524, -1.48618974597522),
(20428, '46779', 218, 19, 123451, 41.606, 0.726161688584761, -85.0519, -1.48443569007697),
(20429, '46780', 218, 19, 71296, 40.7779, 0.711708617048996, -84.8422, -1.48077573463553),
(20430, '46781', 218, 19, 123471, 40.6543, 0.709551390093531, -85.2419, -1.48775181565575),
(20431, '46782', 218, 19, 97229, 40.8324, 0.712659821491333, -85.0147, -1.48378642759522),
(20432, '46783', 218, 19, 5436, 40.9659, 0.714989836042745, -85.2951, -1.48868033081782),
(20433, '46784', 218, 19, 123580, 41.4946, 0.724217391798039, -85.3686, -1.48996314781803),
(20434, '46785', 218, 19, 11757, 41.3202, 0.721173537582561, -84.8905, -1.48161872866425),
(20435, '46786', 218, 19, 74356, 41.532, 0.724870144938285, -85.2723, -1.48828239574836),
(20436, '46787', 218, 19, 123703, 41.0844, 0.717058051206358, -85.6164, -1.49428807370447),
(20437, '46788', 218, 19, 51592, 41.2515, 0.719974496386441, -84.9404, -1.48248964796099),
(20438, '46789', 218, 19, 123748, 41.5816, 0.725735828247274, -85.1992, -1.48700656006515),
(20439, '46791', 218, 19, 123867, 40.8333, 0.712675529454601, -85.233, -1.48759648135233),
(20440, '46792', 218, 19, 12663, 40.6856, 0.710097678149405, -85.4239, -1.49092831489438),
(20441, '46793', 218, 19, 6650, 41.4282, 0.723058493174715, -85.0198, -1.48387543938708),
(20442, '46794', 218, 19, 123953, 41.4913, 0.724159795932723, -85.4224, -1.4909021349556),
(20443, '46795', 218, 19, 124040, 41.524, 0.724730518598125, -85.364, -1.48988286267244),
(20444, '46796', 218, 19, 124041, 41.3355, 0.721440572958116, -85.4958, -1.49218320662657),
(20445, '46797', 218, 19, 29018, 41.1297, 0.717848685357512, -84.8641, -1.48115796174172),
(20446, '46798', 218, 19, 13008, 40.9406, 0.714548267741991, -85.2174, -1.48732420998902),
(20447, '46799', 218, 19, 29051, 40.916, 0.714118916746, -85.281, -1.48843423939328),
(20448, '46801', 218, 19, 122632, 41.0689, 0.716787525172299, -85.1655, -1.48641838410723),
(20449, '46802', 218, 19, 122632, 41.0718, 0.716838139720607, -85.1525, -1.48619149130447),
(20450, '46803', 218, 19, 122632, 41.0702, 0.716810214452575, -85.1023, -1.48531533601997),
(20451, '46804', 218, 19, 122632, 41.0549, 0.71654317907702, -85.2417, -1.48774832499725),
(20452, '46805', 218, 19, 122632, 41.0984, 0.717302397301637, -85.116, -1.48555444612749),
(20453, '46806', 218, 19, 122632, 41.0472, 0.716408788724616, -85.1056, -1.48537293188529),
(20454, '46807', 218, 19, 122632, 41.0468, 0.716401807407608, -85.1462, -1.4860815355616),
(20455, '46808', 218, 19, 122632, 41.0976, 0.717288434667622, -85.17, -1.48649692392357),
(20456, '46809', 218, 19, 122632, 41.0239, 0.716002127008902, -85.1901, -1.48684773510322),
(20457, '46814', 218, 19, 122632, 41.1302, 0.717857412003772, -85.1294, -1.48578832024726),
(20458, '46815', 218, 19, 122632, 41.1149, 0.717590376628217, -85.0619, -1.48461022300216),
(20459, '46816', 218, 19, 122632, 41.0172, 0.715885189949018, -85.0779, -1.48488947568248),
(20460, '46818', 218, 19, 122632, 41.147, 0.718150627318107, -85.2263, -1.48747954429244),
(20461, '46819', 218, 19, 122632, 40.9995, 0.715576266671415, -85.1322, -1.48583718946632),
(20462, '46825', 218, 19, 122632, 41.1597, 0.71837228413311, -85.119, -1.48560680600505),
(20463, '46835', 218, 19, 122632, 41.1395, 0.718019727624207, -85.0621, -1.48461371366067),
(20464, '46845', 218, 19, 122632, 41.197, 0.719023291944104, -85.1101, -1.48545147170163),
(20465, '46850', 218, 19, 122632, 41.0692, 0.716792761160055, -85.1663, -1.48643234674125),
(20466, '46851', 218, 19, 122632, 41.0688, 0.716785779843047, -85.1657, -1.48642187476573),
(20467, '46852', 218, 19, 122632, 41.0693, 0.716794506489307, -85.1656, -1.48642012943648),
(20468, '46853', 218, 19, 122632, 41.0685, 0.716780543855291, -85.1655, -1.48641838410723),
(20469, '46854', 218, 19, 122632, 41.1495, 0.718194260549407, -85.0722, -1.48478999191512),
(20470, '46855', 218, 19, 122632, 41.0692, 0.716792761160055, -85.1656, -1.48642012943648),
(20471, '46856', 218, 19, 122632, 41.069, 0.716789270501551, -85.1656, -1.48642012943648),
(20472, '46857', 218, 19, 122632, 41.0687, 0.716784034513795, -85.1665, -1.48643583739975),
(20473, '46858', 218, 19, 122632, 41.0691, 0.716791015830803, -85.1663, -1.48643234674125),
(20474, '46859', 218, 19, 122632, 41.0693, 0.716794506489307, -85.1658, -1.48642362009499),
(20475, '46860', 218, 19, 122632, 41.0685, 0.716780543855291, -85.1655, -1.48641838410723),
(20476, '46861', 218, 19, 122632, 41.0687, 0.716784034513795, -85.1656, -1.48642012943648),
(20477, '46862', 218, 19, 122632, 41.0689, 0.716787525172299, -85.1657, -1.48642187476573),
(20478, '46863', 218, 19, 122632, 41.0693, 0.716794506489307, -85.1659, -1.48642536542424),
(20479, '46864', 218, 19, 122632, 41.0694, 0.716796251818559, -85.1662, -1.48643060141199),
(20480, '46865', 218, 19, 122632, 41.0688, 0.716785779843047, -85.166, -1.48642711075349),
(20481, '46866', 218, 19, 122632, 41.0692, 0.716792761160055, -85.1655, -1.48641838410723),
(20482, '46867', 218, 19, 122632, 41.069, 0.716789270501551, -85.166, -1.48642711075349),
(20483, '46868', 218, 19, 122632, 41.069, 0.716789270501551, -85.1662, -1.48643060141199),
(20484, '46869', 218, 19, 122632, 41.069, 0.716789270501551, -85.1664, -1.4864340920705),
(20485, '46885', 218, 19, 122632, 41.1362, 0.717962131758891, -85.0342, -1.48412676679936),
(20486, '46895', 218, 19, 122632, 41.1052, 0.717421079690773, -85.114, -1.48551953954245),
(20487, '46896', 218, 19, 122632, 41.0072, 0.715710657023819, -85.0657, -1.48467654551374),
(20488, '46897', 218, 19, 122632, 41.068, 0.716771817209031, -85.1625, -1.48636602422967),
(20489, '46898', 218, 19, 122632, 41.2007, 0.719087869126428, -85.303, -1.48881821182872),
(20490, '46899', 218, 19, 122632, 40.9969, 0.715530888110863, -85.2368, -1.4876628038639),
(20491, '46901', 218, 19, 9895, 40.4913, 0.70670650341278, -86.1472, -1.50355228137406),
(20492, '46902', 218, 19, 9895, 40.4543, 0.706060731589542, -86.1342, -1.5033253885713),
(20493, '46903', 218, 19, 9895, 40.4752, 0.706425505403209, -86.1332, -1.50330793527878),
(20494, '46904', 218, 19, 9895, 40.6589, 0.709631675239123, -86.2426, -1.50521732548046),
(20495, '46910', 218, 19, 215, 41.04, 0.716283125018473, -86.031, -1.50152420878324),
(20496, '46911', 218, 19, 7087, 40.6165, 0.708891655636277, -85.9401, -1.49993770449318),
(20497, '46912', 218, 19, 7182, 41.0533, 0.716515253808988, -86.1255, -1.50317354492638),
(20498, '46913', 218, 19, 112366, 40.5146, 0.707113165128495, -86.5253, -1.51015137127585),
(20499, '46914', 218, 19, 7775, 40.66, 0.709650873860894, -86.1018, -1.50275990189365),
(20500, '46915', 218, 19, 1239, 40.4801, 0.706511026536557, -86.3949, -1.50787546193125),
(20501, '46916', 218, 19, 1253, 40.6767, 0.709942343845977, -86.5078, -1.50984593865675),
(20502, '46917', 218, 19, 1304, 40.6107, 0.708790426539661, -86.537, -1.51035557479833),
(20503, '46919', 218, 19, 39874, 40.5786, 0.708230175849771, -85.8713, -1.49873691796781),
(20504, '46920', 218, 19, 15698, 40.4707, 0.706346965586869, -86.4745, -1.50926474401584),
(20505, '46921', 218, 19, 122482, 40.9105, 0.71402292363714, -86.1009, -1.50274419393039),
(20506, '46922', 218, 19, 108817, 41.1387, 0.718005764990191, -86.4164, -1.50825070772043),
(20507, '46923', 218, 19, 108840, 40.5864, 0.708366311531426, -86.6713, -1.51269955198376),
(20508, '46926', 218, 19, 2033, 40.8908, 0.713679093774497, -86.0528, -1.50190469056018),
(20509, '46928', 218, 19, 2379, 40.415, 0.705374817193508, -85.6461, -1.49480643649232),
(20510, '46929', 218, 19, 27181, 40.5455, 0.707652471867361, -86.5221, -1.51009552073979),
(20511, '46930', 218, 19, 94310, 40.4113, 0.705310240011184, -85.574, -1.49354805410163),
(20512, '46931', 218, 19, 2628, 40.9483, 0.714682658094394, -86.2657, -1.50562049653767),
(20513, '46932', 218, 19, 36036, 40.5794, 0.708244138483787, -86.1951, -1.50438829408576),
(20514, '46933', 218, 19, 75913, 40.4883, 0.70665414353522, -85.6063, -1.49411179545002),
(20515, '46935', 218, 19, 122712, 40.9476, 0.71467044078963, -86.4047, -1.50804650419794),
(20516, '46936', 218, 19, 65223, 40.4747, 0.706416778756949, -85.9713, -1.5004822472198),
(20517, '46937', 218, 19, 72876, 40.4197, 0.705456847668352, -86.0412, -1.50170223236695),
(20518, '46938', 218, 19, 3452, 40.4757, 0.706434232049469, -85.6223, -1.49439104813034),
(20519, '46939', 218, 19, 122954, 40.9941, 0.715482018891808, -86.398, -1.50792956713806),
(20520, '46940', 218, 19, 122982, 40.6742, 0.709898710614678, -85.7217, -1.49612590540682),
(20521, '46941', 218, 19, 122992, 40.8375, 0.712748833283184, -85.7278, -1.49623237049119),
(20522, '46942', 218, 19, 122995, 40.7645, 0.711474742929228, -86.5417, -1.51043760527318),
(20523, '46943', 218, 19, 36781, 40.974, 0.715131207712157, -85.8353, -1.49810859943709),
(20524, '46945', 218, 19, 123039, 41.1213, 0.717702077700344, -86.386, -1.50772012762782),
(20525, '46946', 218, 19, 103671, 41.0335, 0.716169678617093, -85.7363, -1.49638072347761),
(20526, '46947', 218, 19, 36951, 40.7903, 0.711925037876243, -86.4079, -1.50810235473401),
(20527, '46950', 218, 19, 10223, 40.8661, 0.713247997449255, -86.4119, -1.50817216790409),
(20528, '46951', 218, 19, 123112, 40.9571, 0.71483624706857, -86.1287, -1.50322939546244),
(20529, '46952', 218, 19, 630, 40.5735, 0.708141164057919, -85.6687, -1.49520088090327),
(20530, '46953', 218, 19, 630, 40.5313, 0.707404635113578, -85.6569, -1.49499493205153),
(20531, '46957', 218, 19, 4038, 40.388, 0.70490357829547, -85.4983, -1.49222683985787),
(20532, '46958', 218, 19, 37178, 40.8235, 0.712504487187905, -86.115, -1.50299028535492),
(20533, '46959', 218, 19, 17102, 40.6139, 0.708846277075725, -86.1064, -1.50284018703925),
(20534, '46960', 218, 19, 4284, 41.1276, 0.71781203344322, -86.5254, -1.5101531166051),
(20535, '46961', 218, 19, 96524, 40.7641, 0.71146776161222, -86.1925, -1.50434291552521),
(20536, '46962', 218, 19, 123325, 41.0043, 0.715660042475511, -85.7734, -1.4970282406301),
(20537, '46965', 218, 19, 120861, 40.4191, 0.70544637569284, -86.1043, -1.50280353512495),
(20538, '46967', 218, 19, 61178, 40.6948, 0.710258248440588, -86.1948, -1.50438305809801),
(20539, '46968', 218, 19, 61181, 41.1752, 0.718642810167169, -86.5531, -1.5106365728079),
(20540, '46970', 218, 19, 33609, 40.7531, 0.711275775394501, -86.0747, -1.50228691766636),
(20541, '46971', 218, 19, 0, 40.6733, 0.70988300265141, -86.1574, -1.50373030495776),
(20542, '46974', 218, 19, 123564, 40.9107, 0.714026414295644, -85.9234, -1.4996462345081),
(20543, '46975', 218, 19, 28433, 41.0625, 0.716675824100172, -86.2093, -1.50463613083955),
(20544, '46977', 218, 19, 37977, 40.6423, 0.709341950583291, -86.5753, -1.51102403590185),
(20545, '46978', 218, 19, 123597, 40.8586, 0.713117097755355, -86.4923, -1.50957541262269),
(20546, '46979', 218, 19, 123604, 40.4207, 0.705474300960872, -86.2653, -1.50561351522066),
(20547, '46980', 218, 19, 112651, 40.9562, 0.714820539105302, -85.7383, -1.49641563006265),
(20548, '46982', 218, 19, 18083, 41.0715, 0.716832903732851, -85.888, -1.49902838795289),
(20549, '46984', 218, 19, 5946, 40.6714, 0.709849841395622, -85.8291, -1.49800038902347),
(20550, '46985', 218, 19, 12110, 40.9534, 0.714771669886246, -86.5254, -1.5101531166051),
(20551, '46986', 218, 19, 123769, 40.5078, 0.706994482739359, -85.8216, -1.49786948932957),
(20552, '46987', 218, 19, 123770, 40.5711, 0.708099276155871, -85.7676, -1.49692701153349),
(20553, '46988', 218, 19, 123836, 40.855, 0.713054265902283, -86.2066, -1.50458900694974),
(20554, '46989', 218, 19, 34227, 40.4676, 0.706292860380057, -85.5067, -1.49237344751504),
(20555, '46990', 218, 19, 12500, 40.8994, 0.713829192090169, -85.7176, -1.49605434690749),
(20556, '46991', 218, 19, 12525, 40.617, 0.708900382282537, -85.5057, -1.49235599422252),
(20557, '46992', 218, 19, 12577, 40.803, 0.712146694691246, -85.8289, -1.49799689836496),
(20558, '46994', 218, 19, 18491, 40.6629, 0.709701488409202, -86.2421, -1.5052085988342),
(20559, '46995', 218, 19, 123986, 40.4394, 0.705800677530995, -86.2159, -1.50475132257018),
(20560, '46996', 218, 19, 124028, 41.0527, 0.716504781833476, -86.6055, -1.51155112533595),
(20561, '46998', 218, 19, 6991, 40.5682, 0.708048661607564, -86.3509, -1.50710751706037),
(20562, '47001', 218, 19, 474, 39.0613, 0.681748295109261, -84.9187, -1.48211091151331),
(20563, '47003', 218, 19, 31486, 39.5071, 0.689528972914652, -84.8636, -1.48114923509546),
(20564, '47006', 218, 19, 7298, 39.3305, 0.68644672145563, -85.1981, -1.48698736144338),
(20565, '47010', 218, 19, 19093, 39.4903, 0.689235757600317, -84.8409, -1.48075304535526),
(20566, '47011', 218, 19, 26498, 38.8732, 0.67846533078626, -85.0789, -1.484906928975),
(20567, '47012', 218, 19, 26617, 39.4192, 0.687994828502149, -84.9877, -1.48331518869718),
(20568, '47016', 218, 19, 1414, 39.3698, 0.687132635851664, -84.9072, -1.48191019864933),
(20569, '47017', 218, 19, 473, 38.9463, 0.679741166469468, -85.2211, -1.48738878717134),
(20570, '47018', 218, 19, 29642, 39.0191, 0.681011766164919, -85.0597, -1.48457182575862),
(20571, '47019', 218, 19, 29685, 38.8725, 0.678453113481496, -84.988, -1.48332042468494),
(20572, '47020', 218, 19, 2502, 38.8221, 0.677573467538491, -84.9352, -1.48239889083989),
(20573, '47021', 218, 19, 2610, 39.1186, 0.682748368770654, -85.2104, -1.48720203694138),
(20574, '47022', 218, 19, 16297, 39.2068, 0.684287749170913, -84.9524, -1.48269908747123),
(20575, '47023', 218, 19, 30100, 39.0228, 0.681076343347243, -85.3869, -1.49028254307115),
(20576, '47024', 218, 19, 14092, 39.4767, 0.688998392822046, -85.1917, -1.48687566037125),
(20577, '47025', 218, 19, 30308, 39.1454, 0.683216117010188, -84.862, -1.48112130982743),
(20578, '47030', 218, 19, 30492, 39.4247, 0.688090821611008, -85.1358, -1.48590002131939),
(20579, '47031', 218, 19, 23084, 39.1644, 0.683547729568067, -85.1411, -1.48599252376974),
(20580, '47032', 218, 19, 30560, 39.0772, 0.682025802460328, -85.0528, -1.48445139804023),
(20581, '47033', 218, 19, 4333, 39.2869, 0.68568575790176, -85.1943, -1.48692103893181),
(20582, '47034', 218, 19, 4479, 39.2049, 0.684254587915125, -85.3304, -1.48929643204377),
(20583, '47035', 218, 19, 30653, 39.3099, 0.686087183629719, -84.9003, -1.48178977093094),
(20584, '47036', 218, 19, 28128, 39.3812, 0.687331603386391, -85.2414, -1.48774308900949),
(20585, '47037', 218, 19, 506, 39.1286, 0.682922901695853, -85.2925, -1.48863495225726),
(20586, '47038', 218, 19, 30786, 38.8361, 0.67781781363377, -84.8441, -1.48080889589132),
(20587, '47039', 218, 19, 23878, 39.1131, 0.682652375661794, -85.2218, -1.4874010044761),
(20588, '47040', 218, 19, 14485, 38.9492, 0.679791781017775, -84.8563, -1.48102182606006),
(20589, '47041', 218, 19, 31261, 39.226, 0.684622852387296, -85.0321, -1.48409011488507),
(20590, '47042', 218, 19, 28861, 39.0671, 0.681849524205877, -85.2556, -1.48799092576328),
(20591, '47043', 218, 19, 31389, 38.7479, 0.676278433233511, -85.0686, -1.48472716006205),
(20592, '47060', 218, 19, 31490, 39.3323, 0.686478137382166, -84.874, -1.48133074933767),
(20593, '47102', 218, 19, 7197, 38.7448, 0.676224328026699, -85.806, -1.49759721796625),
(20594, '47104', 218, 19, 548, 38.54, 0.672649893718615, -85.424, -1.49093006022364),
(20595, '47106', 218, 19, 29262, 38.4524, 0.671120985293868, -85.8709, -1.4987299366508),
(20596, '47107', 218, 19, 1076, 38.3679, 0.669646182075932, -86.0618, -1.50206177019286),
(20597, '47108', 218, 19, 29380, 38.6377, 0.674355080397813, -86.2403, -1.50517718290767),
(20598, '47110', 218, 19, 1462, 38.0926, 0.664841290645192, -86.1602, -1.50377917417682),
(20599, '47111', 218, 19, 29458, 38.4586, 0.671229195707491, -85.655, -1.49496177079574),
(20600, '47112', 218, 19, 29558, 38.2063, 0.666825730004709, -86.1249, -1.50316307295086),
(20601, '47114', 218, 19, 15660, 38.2917, 0.668316241185913, -86.0743, -1.50227993634936),
(20602, '47115', 218, 19, 29630, 38.339, 0.669141781922106, -86.2672, -1.50564667647645),
(20603, '47116', 218, 19, 29697, 38.3195, 0.668801442717967, -86.6176, -1.51176231017544),
(20604, '47117', 218, 19, 8719, 38.1137, 0.665209555117363, -86.0533, -1.50191341720644),
(20605, '47118', 218, 19, 8766, 38.3346, 0.669064987435018, -86.4625, -1.5090553045056),
(20606, '47119', 218, 19, 29815, 38.3539, 0.669401835980653, -85.8849, -1.49897428274608),
(20607, '47120', 218, 19, 29848, 38.6856, 0.675191093109518, -85.7749, -1.49705442056888),
(20608, '47122', 218, 19, 2693, 38.3078, 0.668597239195484, -85.9518, -1.50014190801566),
(20609, '47123', 218, 19, 27315, 38.2876, 0.668244682686581, -86.4724, -1.50922809210154),
(20610, '47124', 218, 19, 2868, 38.3765, 0.669796280391604, -85.9947, -1.50089065426477),
(20611, '47125', 218, 19, 29997, 38.4649, 0.671339151450367, -86.3227, -1.50661533421131),
(20612, '47126', 218, 19, 3064, 38.5406, 0.672660365694127, -85.7708, -1.49698286206955),
(20613, '47129', 218, 19, 848, 38.305, 0.668548369976428, -85.7701, -1.49697064476479),
(20614, '47130', 218, 19, 9742, 38.3033, 0.668518699379144, -85.7332, -1.4963266182708),
(20615, '47131', 218, 19, 9742, 38.3398, 0.669155744556122, -85.7016, -1.49577509422717),
(20616, '47132', 218, 19, 9742, 38.2871, 0.668235956040321, -85.7335, -1.49633185425856),
(20617, '47133', 218, 19, 9742, 38.287, 0.668234210711069, -85.733, -1.4963231276123),
(20618, '47134', 218, 19, 9742, 38.2868, 0.668230720052565, -85.7335, -1.49633185425856),
(20619, '47135', 218, 19, 9914, 38.0413, 0.663945936738919, -86.0719, -1.50223804844731),
(20620, '47136', 218, 19, 27675, 38.2457, 0.667513389729995, -85.9301, -1.49976317156798),
(20621, '47137', 218, 19, 30314, 38.2112, 0.666911251138057, -86.3649, -1.50735186315565),
(20622, '47138', 218, 19, 3748, 38.7138, 0.675683275958581, -85.6564, -1.49498620540527),
(20623, '47139', 218, 19, 30356, 38.7002, 0.67544591118031, -85.9034, -1.4992971686577),
(20624, '47140', 218, 19, 3989, 38.3806, 0.669867838890936, -86.384, -1.50768522104278),
(20625, '47141', 218, 19, 10343, 38.5475, 0.672780793412514, -85.5973, -1.49395471581734),
(20626, '47142', 218, 19, 30463, 38.0929, 0.664846526632948, -86.1919, -1.5043324435497),
(20627, '47143', 218, 19, 4163, 38.4734, 0.671487504436786, -85.767, -1.49691653955798),
(20628, '47144', 218, 19, 9742, 38.3305, 0.668993428935686, -85.7124, -1.49596358978639),
(20629, '47145', 218, 19, 602, 38.3416, 0.669187160482658, -86.2677, -1.50565540312271),
(20630, '47146', 218, 19, 0, 38.3198, 0.668806678705723, -85.9116, -1.49944028565636),
(20631, '47147', 218, 19, 30597, 38.583, 0.673400385296972, -85.5369, -1.49290053694914),
(20632, '47150', 218, 19, 30614, 38.3073, 0.668588512549224, -85.8288, -1.49799515303571),
(20633, '47151', 218, 19, 30614, 38.2871, 0.668235956040321, -85.8228, -1.49789043328059),
(20634, '47160', 218, 19, 30644, 38.136, 0.665598763540558, -86.0528, -1.50190469056018),
(20635, '47161', 218, 19, 30652, 38.3025, 0.668504736745128, -86.0973, -1.50268136207731),
(20636, '47162', 218, 19, 30655, 38.5453, 0.67274239616897, -85.4777, -1.49186730203196),
(20637, '47163', 218, 19, 23685, 38.5423, 0.67269003629141, -85.6615, -1.49507521719712),
(20638, '47164', 218, 19, 4846, 38.4068, 0.670325115154958, -86.0882, -1.50252253711538),
(20639, '47165', 218, 19, 769, 38.3998, 0.670202942107319, -85.9943, -1.50088367294776),
(20640, '47166', 218, 19, 5291, 38.3394, 0.669148763239114, -86.1367, -1.5033690218026),
(20641, '47167', 218, 19, 126, 38.6045, 0.673775631086151, -86.0999, -1.50272674063787),
(20642, '47170', 218, 19, 31093, 38.6867, 0.67521029173129, -85.7753, -1.49706140188589),
(20643, '47172', 218, 19, 31098, 38.3908, 0.670045862474639, -85.7607, -1.4968065838151),
(20644, '47174', 218, 19, 65, 38.223, 0.667117199989793, -86.492, -1.50957017663494),
(20645, '47175', 218, 19, 31291, 38.3489, 0.669314569518053, -86.5389, -1.51038873605412),
(20646, '47177', 218, 19, 6443, 38.5153, 0.672218797393372, -85.7599, -1.49679262118109),
(20647, '47199', 218, 19, 9742, 38.2867, 0.668228974723313, -85.7332, -1.4963266182708),
(20648, '47201', 218, 19, 1718, 39.2003, 0.684174302769533, -85.9324, -1.49980331414078),
(20649, '47202', 218, 19, 1718, 39.2054, 0.684263314561385, -85.9211, -1.4996060919353),
(20650, '47203', 218, 19, 1718, 39.2318, 0.684724081483911, -85.8746, -1.49879451383312),
(20651, '47220', 218, 19, 1190, 38.8809, 0.678599721138663, -86.046, -1.50178600817104),
(20652, '47223', 218, 19, 7803, 39.1216, 0.682800728648214, -85.4933, -1.49213957339527),
(20653, '47224', 218, 19, 306, 38.8735, 0.678470566774016, -85.2688, -1.48822130922454),
(20654, '47225', 218, 19, 26799, 39.4325, 0.688226957292664, -85.3564, -1.48975021764929);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(20655, '47226', 218, 19, 695, 39.282, 0.685600236768412, -85.8689, -1.49869503006576),
(20656, '47227', 218, 19, 29543, 38.8559, 0.678163388825665, -85.6362, -1.49463364889637),
(20657, '47228', 218, 19, 29554, 38.9876, 0.680461987450541, -86.0033, -1.50104075258044),
(20658, '47229', 218, 19, 29583, 38.7956, 0.677110955286712, -85.8414, -1.49821506452146),
(20659, '47230', 218, 19, 29631, 38.782, 0.676873590508441, -85.6272, -1.49447656926369),
(20660, '47231', 218, 19, 13687, 38.8899, 0.678756800771343, -85.5004, -1.49226349177216),
(20661, '47232', 218, 19, 27070, 39.1215, 0.682798983318962, -85.8124, -1.49770891903838),
(20662, '47234', 218, 19, 2479, 39.3938, 0.687551514872142, -85.6855, -1.4954940962176),
(20663, '47235', 218, 19, 2604, 39.0082, 0.680821525276452, -86.1228, -1.50312642103657),
(20664, '47236', 218, 19, 29918, 39.1594, 0.683460463105467, -85.7136, -1.49598453373741),
(20665, '47240', 218, 19, 29951, 39.3545, 0.686865600476108, -85.4446, -1.49128959804955),
(20666, '47243', 218, 19, 2963, 38.7153, 0.675709455897361, -85.4715, -1.49175909161833),
(20667, '47244', 218, 19, 27395, 39.2666, 0.685331456063605, -85.6982, -1.4957157530326),
(20668, '47245', 218, 19, 3019, 38.983, 0.680381702304949, -85.7408, -1.49645926329395),
(20669, '47246', 218, 19, 665, 39.2926, 0.685785241669124, -85.7605, -1.4968030931566),
(20670, '47247', 218, 19, 3455, 39.0617, 0.681755276426269, -85.8885, -1.49903711459915),
(20671, '47249', 218, 19, 30272, 38.9595, 0.679971549930731, -86.2037, -1.50453839240144),
(20672, '47250', 218, 19, 3938, 38.7558, 0.676416314244418, -85.3953, -1.49042915072831),
(20673, '47260', 218, 19, 30481, 38.8196, 0.677529834307191, -86.2114, -1.50467278275384),
(20674, '47261', 218, 19, 30518, 39.321, 0.68628091517669, -85.4775, -1.49186381137345),
(20675, '47262', 218, 19, 30605, 39.0641, 0.681797164328317, -85.4598, -1.49155488809585),
(20676, '47263', 218, 19, 23349, 39.3093, 0.686076711654207, -85.3297, -1.48928421473901),
(20677, '47264', 218, 19, 4593, 38.9544, 0.679882538138879, -86.2205, -1.50483160771577),
(20678, '47265', 218, 19, 30688, 39.0173, 0.680980350238384, -85.6529, -1.49492511888145),
(20679, '47270', 218, 19, 30771, 38.8574, 0.678189568764445, -85.7422, -1.49648369790348),
(20680, '47272', 218, 19, 11759, 39.4286, 0.688158889451836, -85.632, -1.49456034506778),
(20681, '47273', 218, 19, 11824, 39.0798, 0.68207118102088, -85.7245, -1.49617477462588),
(20682, '47274', 218, 19, 5745, 38.9592, 0.679966313942975, -85.8906, -1.49907376651344),
(20683, '47280', 218, 19, 25360, 39.2948, 0.685823638912668, -85.95, -1.50011049208913),
(20684, '47281', 218, 19, 31364, 38.8009, 0.677203457737068, -86.058, -1.50199544768128),
(20685, '47282', 218, 19, 6535, 38.7405, 0.676149278868863, -85.3809, -1.49017782331603),
(20686, '47283', 218, 19, 25961, 39.1772, 0.683771131712323, -85.5736, -1.49354107278462),
(20687, '47302', 218, 19, 33371, 40.1734, 0.70115810172069, -85.3818, -1.49019353127929),
(20688, '47303', 218, 19, 33371, 40.2195, 0.701962698505859, -85.377, -1.4901097554752),
(20689, '47304', 218, 19, 33371, 40.2122, 0.701835289470464, -85.4396, -1.49120233158695),
(20690, '47305', 218, 19, 33371, 40.1926, 0.701493204937073, -85.3858, -1.49026334444937),
(20691, '47306', 218, 19, 33371, 40.2006, 0.701632831277232, -85.408, -1.49065080754332),
(20692, '47307', 218, 19, 33371, 40.1781, 0.701240132195534, -85.3918, -1.49036806420449),
(20693, '47308', 218, 19, 33371, 40.1333, 0.70045822469064, -85.3808, -1.49017607798677),
(20694, '47320', 218, 19, 18772, 40.2974, 0.703322309993163, -85.2437, -1.48778323158229),
(20695, '47322', 218, 19, 647, 39.7456, 0.693691583180658, -86.1937, -1.50436385947624),
(20696, '47324', 218, 19, 1061, 39.7415, 0.693620024681327, -84.8522, -1.48095026756073),
(20697, '47325', 218, 19, 1191, 39.7174, 0.693199400331596, -84.9612, -1.48285267644541),
(20698, '47326', 218, 19, 652, 40.5338, 0.707448268344878, -84.9634, -1.48289107368895),
(20699, '47327', 218, 19, 29371, 39.823, 0.695042468021702, -85.1632, -1.48637824153443),
(20700, '47330', 218, 19, 1459, 39.7981, 0.694607881037955, -85.0111, -1.48372359574215),
(20701, '47331', 218, 19, 15599, 39.6511, 0.692042247037524, -85.1371, -1.48592271059966),
(20702, '47334', 218, 19, 1951, 40.1235, 0.700287182423945, -85.5479, -1.49309252316686),
(20703, '47335', 218, 19, 2113, 39.8137, 0.694880152401266, -85.2071, -1.48714444107606),
(20704, '47336', 218, 19, 32273, 40.3742, 0.704662722858695, -85.2105, -1.48720378227063),
(20705, '47337', 218, 19, 29676, 39.8033, 0.694698638159059, -85.4368, -1.49115346236789),
(20706, '47338', 218, 19, 8676, 40.3409, 0.70408152821778, -85.3531, -1.48969262178397),
(20707, '47339', 218, 19, 8685, 39.9673, 0.69756097813233, -85.0954, -1.48519490830158),
(20708, '47340', 218, 19, 40882, 40.183, 0.701325653328881, -85.1113, -1.48547241565265),
(20709, '47341', 218, 19, 29828, 39.9703, 0.69761333800989, -84.9115, -1.48198524780717),
(20710, '47342', 218, 19, 2675, 40.3101, 0.703543966808166, -85.5015, -1.49228269039393),
(20711, '47344', 218, 19, 2866, 39.8784, 0.696009380427307, -85.4632, -1.49161422929042),
(20712, '47345', 218, 19, 29960, 39.8939, 0.696279906461366, -85.0484, -1.48437460355315),
(20713, '47346', 218, 19, 29973, 39.9263, 0.696845393139012, -85.1543, -1.48622290723101),
(20714, '47348', 218, 19, 109575, 40.4481, 0.705952521175918, -85.3727, -1.49003470631736),
(20715, '47351', 218, 19, 30237, 39.9039, 0.696454439386565, -85.5199, -1.4926038309763),
(20716, '47352', 218, 19, 10065, 39.8042, 0.694714346122327, -85.3534, -1.48969785777173),
(20717, '47353', 218, 19, 3751, 39.6322, 0.691712379808897, -84.9294, -1.48229766174327),
(20718, '47354', 218, 19, 123097, 39.9989, 0.69811250217596, -85.1624, -1.48636427890042),
(20719, '47355', 218, 19, 3914, 40.0492, 0.698990402789713, -84.9427, -1.48252979053379),
(20720, '47356', 218, 19, 14224, 40.0578, 0.699140501105385, -85.5401, -1.4929563874852),
(20721, '47357', 218, 19, 4232, 39.7663, 0.694052866335821, -85.1367, -1.48591572928266),
(20722, '47358', 218, 19, 10550, 39.9919, 0.69799032912832, -85.0795, -1.48491740095052),
(20723, '47359', 218, 19, 23162, 40.5522, 0.707769408927244, -85.2791, -1.4884010781375),
(20724, '47360', 218, 19, 30555, 39.9955, 0.698053160981392, -85.2499, -1.48789144199591),
(20725, '47361', 218, 19, 73594, 40.006, 0.698236420552852, -85.3861, -1.49026858043713),
(20726, '47362', 218, 19, 4520, 39.9212, 0.69675638134716, -85.3684, -1.48995965715953),
(20727, '47366', 218, 19, 30639, 39.8629, 0.695738854393248, -85.2635, -1.48812880677419),
(20728, '47367', 218, 19, 4721, 40.0792, 0.699514001565311, -85.3908, -1.49035061091197),
(20729, '47368', 218, 19, 123394, 40.1919, 0.701480987632309, -85.193, -1.48689834965153),
(20730, '47369', 218, 19, 23836, 40.4937, 0.706748391314828, -85.1476, -1.48610597017112),
(20731, '47370', 218, 19, 28222, 39.8124, 0.69485746312099, -85.1368, -1.48591747461191),
(20732, '47371', 218, 19, 5188, 40.4341, 0.705708175080639, -84.9833, -1.4832383942101),
(20733, '47373', 218, 19, 123522, 40.3485, 0.704214173240932, -85.1514, -1.4861722926827),
(20734, '47374', 218, 19, 5381, 39.8331, 0.695218746276153, -84.8929, -1.48166061656629),
(20735, '47375', 218, 19, 5381, 39.8306, 0.695175113044853, -84.8946, -1.48169028716358),
(20736, '47380', 218, 19, 5391, 40.2904, 0.703200136945523, -85.0286, -1.48402902836125),
(20737, '47381', 218, 19, 123613, 40.3533, 0.704297949045028, -84.8533, -1.4809694661825),
(20738, '47382', 218, 19, 5658, 40.2361, 0.70225242316169, -84.9182, -1.48210218486705),
(20739, '47383', 218, 19, 5731, 40.1873, 0.701400702486717, -85.2733, -1.48829984904088),
(20740, '47384', 218, 19, 5825, 39.8905, 0.696220565266798, -85.5811, -1.49367197247852),
(20741, '47385', 218, 19, 31180, 39.8364, 0.695276342141469, -85.4372, -1.4911604436849),
(20742, '47386', 218, 19, 123716, 40.0463, 0.698939788241405, -85.3922, -1.4903750455215),
(20743, '47387', 218, 19, 6114, 39.8307, 0.695176858374105, -85.2701, -1.48824399850482),
(20744, '47388', 218, 19, 6137, 40.0159, 0.698409208148799, -85.4422, -1.4912477101475),
(20745, '47390', 218, 19, 12457, 40.2037, 0.701686936484044, -84.8183, -1.48035860094431),
(20746, '47392', 218, 19, 18520, 39.9063, 0.696496327288613, -84.9306, -1.4823186056943),
(20747, '47393', 218, 19, 6831, 39.9505, 0.697267762817995, -84.9923, -1.48339547384278),
(20748, '47394', 218, 19, 12894, 40.1721, 0.701135412440414, -84.9784, -1.48315287307675),
(20749, '47396', 218, 19, 143, 40.1744, 0.70117555501321, -85.4886, -1.49205754292042),
(20750, '47401', 218, 19, 29235, 39.0969, 0.682369632322971, -86.4583, -1.50898200067701),
(20751, '47402', 218, 19, 29235, 39.0953, 0.682341707054939, -86.47, -1.5091862041995),
(20752, '47403', 218, 19, 29235, 39.1141, 0.682669828954314, -86.5878, -1.51124220205835),
(20753, '47404', 218, 19, 29235, 39.1931, 0.68404863906339, -86.574, -1.51100134662157),
(20754, '47405', 218, 19, 29235, 39.1725, 0.683689101237479, -86.5257, -1.51015835259286),
(20755, '47406', 218, 19, 29235, 39.18, 0.683820000931378, -86.5156, -1.50998207433841),
(20756, '47407', 218, 19, 29235, 39.1714, 0.683669902615707, -86.4954, -1.5096295178295),
(20757, '47408', 218, 19, 29235, 39.2198, 0.684514641973672, -86.4583, -1.50898200067701),
(20758, '47420', 218, 19, 7207, 38.9484, 0.679777818383759, -86.6283, -1.5119490604054),
(20759, '47421', 218, 19, 146, 38.862, 0.678269853910036, -86.491, -1.50955272334242),
(20760, '47424', 218, 19, 7544, 39.026, 0.681132193883307, -86.9415, -1.51741543162265),
(20761, '47426', 218, 19, 29500, 39.094, 0.682319017774663, -86.4659, -1.50911464570017),
(20762, '47427', 218, 19, 1659, 39.249, 0.685024278115254, -86.9882, -1.51823050038333),
(20763, '47429', 218, 19, 29715, 39.2493, 0.68502951410301, -86.6201, -1.51180594340674),
(20764, '47430', 218, 19, 29825, 38.7371, 0.676089937674295, -86.4538, -1.50890346086067),
(20765, '47431', 218, 19, 29850, 39.2111, 0.684362798328749, -86.8508, -1.51583241799109),
(20766, '47432', 218, 19, 29855, 38.5457, 0.672749377485978, -86.619, -1.51178674478497),
(20767, '47433', 218, 19, 2794, 39.304, 0.685984209203851, -86.6239, -1.51187226591832),
(20768, '47434', 218, 19, 30025, 39.0117, 0.680882611800272, -86.5435, -1.51046902119971),
(20769, '47435', 218, 19, 30045, 39.3074, 0.686043550398419, -86.312, -1.50642858398135),
(20770, '47436', 218, 19, 30047, 39.0063, 0.680788364020664, -86.4372, -1.50861373620484),
(20771, '47437', 218, 19, 30131, 38.7719, 0.67669731225399, -86.6286, -1.51195429639316),
(20772, '47438', 218, 19, 30187, 39.1611, 0.683490133702751, -87.2008, -1.52194107037307),
(20773, '47439', 218, 19, 30268, 39.0305, 0.681210733699647, -86.8542, -1.51589175918566),
(20774, '47441', 218, 19, 3792, 39.0368, 0.681320689442522, -87.1632, -1.52128482657432),
(20775, '47443', 218, 19, 764, 38.9912, 0.680524819303613, -87.0823, -1.51987285520946),
(20776, '47445', 218, 19, 10461, 39.0604, 0.681732587145993, -87.1851, -1.52166705368051),
(20777, '47446', 218, 19, 4252, 38.7326, 0.676011397857956, -86.4727, -1.5092333280893),
(20778, '47448', 218, 19, 10729, 39.2137, 0.6844081768893, -86.2647, -1.50560304324515),
(20779, '47449', 218, 19, 17269, 38.9258, 0.679383373972809, -87.0093, -1.5185987648555),
(20780, '47451', 218, 19, 30735, 38.8954, 0.678852793880202, -86.5256, -1.51015660726361),
(20781, '47452', 218, 19, 28158, 38.6611, 0.67476348744278, -86.4528, -1.50888600756815),
(20782, '47453', 218, 19, 30761, 38.9488, 0.679784799700767, -86.7573, -1.51420053514048),
(20783, '47454', 218, 19, 23730, 38.5564, 0.672936127715942, -86.4693, -1.50917398689473),
(20784, '47455', 218, 19, 30785, 39.2493, 0.68502951410301, -86.9877, -1.51822177373707),
(20785, '47456', 218, 19, 17745, 39.4361, 0.688289789145736, -86.7905, -1.51477998445214),
(20786, '47457', 218, 19, 5690, 39.0311, 0.681221205675159, -86.8539, -1.5158865231979),
(20787, '47458', 218, 19, 12002, 39.0695, 0.681891412107925, -86.5068, -1.50982848536423),
(20788, '47459', 218, 19, 493, 39.1238, 0.682839125891758, -86.7575, -1.51420402579898),
(20789, '47460', 218, 19, 5995, 39.2867, 0.685682267243256, -86.7592, -1.51423369639626),
(20790, '47462', 218, 19, 6035, 39.0039, 0.680746476118616, -86.5882, -1.51124918337535),
(20791, '47463', 218, 19, 12107, 39.0936, 0.682312036457655, -86.6636, -1.51256516163136),
(20792, '47464', 218, 19, 31226, 39.2991, 0.685898688070504, -86.65, -1.51232779685309),
(20793, '47465', 218, 19, 31276, 39.0396, 0.681369558661578, -87.0478, -1.51927071661752),
(20794, '47467', 218, 19, 31326, 38.8721, 0.678446132164488, -86.4572, -1.50896280205524),
(20795, '47468', 218, 19, 25657, 39.2602, 0.685219754991478, -86.4147, -1.50822103712314),
(20796, '47469', 218, 19, 31483, 38.571, 0.673190945786733, -86.6125, -1.51167329838359),
(20797, '47470', 218, 19, 878, 38.7724, 0.676706038900249, -86.6276, -1.51193684310064),
(20798, '47471', 218, 19, 31567, 39.1182, 0.682741387453646, -86.9787, -1.51806469410439),
(20799, '47490', 218, 19, 29235, 39.1669, 0.683591362799367, -86.5215, -1.51008504876427),
(20800, '47501', 218, 19, 12671, 38.6578, 0.674705891577464, -87.1728, -1.52145237818251),
(20801, '47512', 218, 19, 29212, 38.7729, 0.676714765546509, -87.3071, -1.52379635536794),
(20802, '47513', 218, 19, 29219, 38.2817, 0.668141708260713, -86.7169, -1.51349542212267),
(20803, '47514', 218, 19, 1085, 38.0105, 0.663408375329305, -86.6932, -1.51308177908995),
(20804, '47515', 218, 19, 1144, 38.1677, 0.66615203291344, -86.7157, -1.51347447817165),
(20805, '47516', 218, 19, 1199, 38.7575, 0.676445984841702, -87.4349, -1.52602688615199),
(20806, '47519', 218, 19, 29384, 38.6958, 0.675369116693222, -86.9671, -1.51786223591116),
(20807, '47520', 218, 19, 29390, 37.9111, 0.661673518052822, -86.743, -1.51395095305744),
(20808, '47521', 218, 19, 29422, 38.3926, 0.670077278401175, -86.7367, -1.51384099731457),
(20809, '47522', 218, 19, 29571, 38.8954, 0.678852793880202, -86.9, -1.51669111998307),
(20810, '47523', 218, 19, 847, 38.1626, 0.666063021121588, -86.9822, -1.51812578062821),
(20811, '47524', 218, 19, 29617, 38.4852, 0.671693453288522, -87.6223, -1.52929763317023),
(20812, '47525', 218, 19, 2031, 38.0276, 0.663706826631396, -86.569, -1.51091408015897),
(20813, '47527', 218, 19, 20689, 38.4733, 0.671485759107534, -86.7824, -1.51463861278273),
(20814, '47528', 218, 19, 29703, 38.8126, 0.677407661259551, -87.2449, -1.5227107605732),
(20815, '47529', 218, 19, 8750, 38.8765, 0.678522926651576, -87.0854, -1.51992696041627),
(20816, '47531', 218, 19, 20954, 38.0243, 0.66364923076608, -86.8312, -1.5154903334577),
(20817, '47532', 218, 19, 29787, 38.2269, 0.66718526783062, -86.8626, -1.51603836684283),
(20818, '47535', 218, 19, 29851, 38.8516, 0.678088339667829, -87.4147, -1.52567432964309),
(20819, '47536', 218, 19, 29863, 38.1383, 0.665638906113353, -86.8478, -1.51578005811353),
(20820, '47537', 218, 19, 29881, 38.2175, 0.667021206880933, -86.8638, -1.51605931079385),
(20821, '47541', 218, 19, 9533, 38.2451, 0.667502917754483, -87.0397, -1.51912934494811),
(20822, '47542', 218, 19, 30130, 38.2976, 0.66841921561178, -86.9539, -1.5176318524499),
(20823, '47545', 218, 19, 30148, 38.2928, 0.668335439807685, -86.9604, -1.51774529885128),
(20824, '47546', 218, 19, 738, 38.3957, 0.670131383607987, -86.933, -1.51726707863623),
(20825, '47547', 218, 19, 738, 38.4196, 0.670548517299214, -86.9666, -1.5178535092649),
(20826, '47549', 218, 19, 738, 38.391, 0.670049353133143, -86.9581, -1.51770515627848),
(20827, '47550', 218, 19, 244, 38.047, 0.664045420506282, -86.9638, -1.51780464004584),
(20828, '47551', 218, 19, 30320, 38.1028, 0.665019314228895, -86.6051, -1.51154414401894),
(20829, '47552', 218, 19, 30345, 38.1294, 0.665483571809926, -86.9892, -1.51824795367585),
(20830, '47553', 218, 19, 27751, 38.6789, 0.675074156049635, -86.9144, -1.51694244739536),
(20831, '47556', 218, 19, 30426, 38.1393, 0.665656359405873, -86.8477, -1.51577831278428),
(20832, '47557', 218, 19, 27930, 38.581, 0.673365478711932, -87.3537, -1.52460967879937),
(20833, '47558', 218, 19, 4289, 38.6238, 0.674112479631786, -87.045, -1.51922184739846),
(20834, '47561', 218, 19, 30711, 38.852, 0.678095320984837, -87.415, -1.52567956563084),
(20835, '47562', 218, 19, 30715, 38.8419, 0.677919042730386, -86.9908, -1.51827587894388),
(20836, '47564', 218, 19, 11014, 38.4805, 0.671611422813678, -87.1009, -1.52019748645033),
(20837, '47567', 218, 19, 14402, 38.4927, 0.671824352982421, -87.2789, -1.52330417251888),
(20838, '47568', 218, 19, 23999, 38.7797, 0.676833447935645, -87.1843, -1.52165309104649),
(20839, '47573', 218, 19, 11452, 38.7724, 0.676706038900249, -87.3283, -1.52416636516936),
(20840, '47574', 218, 19, 490, 37.9458, 0.662279147303264, -86.5889, -1.51126140068012),
(20841, '47575', 218, 19, 31028, 38.3334, 0.669044043483994, -86.8221, -1.51533150849577),
(20842, '47576', 218, 19, 31033, 38.2282, 0.667207957110896, -86.6104, -1.5116366464693),
(20843, '47577', 218, 19, 31044, 38.1877, 0.666501098763839, -86.8497, -1.51581321936932),
(20844, '47578', 218, 19, 31067, 38.8958, 0.67885977519721, -87.1862, -1.52168625230228),
(20845, '47579', 218, 19, 24665, 38.1077, 0.665104835362243, -86.9305, -1.51722344540493),
(20846, '47580', 218, 19, 31083, 38.3423, 0.669199377787422, -86.7558, -1.5141743552017),
(20847, '47581', 218, 19, 31122, 38.6677, 0.674878679173411, -86.7954, -1.51486550558549),
(20848, '47584', 218, 19, 31200, 38.3479, 0.669297116225534, -87.2222, -1.522314570833),
(20849, '47585', 218, 19, 31219, 38.2767, 0.668054441798113, -87.128, -1.52067047067762),
(20850, '47586', 218, 19, 31297, 37.9512, 0.662373395082872, -86.7595, -1.51423893238402),
(20851, '47588', 218, 19, 199, 37.9953, 0.663143085283001, -86.8025, -1.51498942396238),
(20852, '47590', 218, 19, 31377, 38.3741, 0.669754392489556, -87.1044, -1.52025857297415),
(20853, '47591', 218, 19, 31399, 38.6765, 0.675032268147587, -87.5141, -1.52740918691957),
(20854, '47596', 218, 19, 31504, 38.8735, 0.678470566774016, -87.2033, -1.52198470360437),
(20855, '47597', 218, 19, 31509, 38.6717, 0.674948492343491, -87.2997, -1.52366720100329),
(20856, '47598', 218, 19, 567, 38.3833, 0.669914962780739, -87.2174, -1.5222307950289),
(20857, '47601', 218, 19, 29261, 38.0488, 0.664076836432818, -87.2605, -1.52298303193651),
(20858, '47610', 218, 19, 656, 38.036, 0.663853434288563, -87.379, -1.52505124710013),
(20859, '47611', 218, 19, 29473, 38.014, 0.663469461853125, -87.0355, -1.51905604111952),
(20860, '47612', 218, 19, 29595, 38.1688, 0.666171231535212, -87.6935, -1.53054030759765),
(20861, '47613', 218, 19, 29710, 38.1608, 0.666031605195052, -87.4483, -1.52626076027176),
(20862, '47614', 218, 19, 29817, 38.1294, 0.665483571809926, -87.1646, -1.52130926118385),
(20863, '47615', 218, 19, 534, 37.9866, 0.662991241638078, -86.9421, -1.51742590359816),
(20864, '47616', 218, 19, 9242, 38.2081, 0.666857145931245, -87.9239, -1.53456154619424),
(20865, '47617', 218, 19, 9378, 37.9124, 0.661696207333098, -87.2007, -1.52193932504382),
(20866, '47618', 218, 19, 30147, 38.1085, 0.665118797996259, -87.5583, -1.52818062244895),
(20867, '47619', 218, 19, 27770, 38.1905, 0.666549967982894, -87.2903, -1.52350314005361),
(20868, '47620', 218, 19, 4411, 37.9491, 0.66233674316858, -87.8614, -1.53347071541175),
(20869, '47629', 218, 19, 30662, 37.9563, 0.662462406874724, -87.4031, -1.52547187144986),
(20870, '47630', 218, 19, 30662, 37.9612, 0.662547928008071, -87.3905, -1.5252519599641),
(20871, '47631', 218, 19, 4526, 38.1168, 0.665263660324175, -87.9221, -1.53453013026771),
(20872, '47633', 218, 19, 30884, 38.1572, 0.66596877334198, -87.7752, -1.53196624159653),
(20873, '47634', 218, 19, 5374, 37.9124, 0.661696207333098, -87.2009, -1.52194281570232),
(20874, '47635', 218, 19, 11639, 37.8834, 0.66119006185002, -87.0515, -1.51933529379984),
(20875, '47637', 218, 19, 31300, 38.1314, 0.665518478394966, -87.1494, -1.52104397113755),
(20876, '47638', 218, 19, 31407, 38.0742, 0.664520150062825, -87.7613, -1.5317236408305),
(20877, '47639', 218, 19, 30036, 38.2054, 0.666810022041442, -87.5761, -1.52849129105581),
(20878, '47640', 218, 19, 30043, 38.4889, 0.671758030470845, -87.5396, -1.52785424587883),
(20879, '47647', 218, 19, 29336, 38.2257, 0.667164323879596, -87.4446, -1.52619618308943),
(20880, '47648', 218, 19, 29823, 38.2468, 0.667532588351767, -87.576, -1.52848954572655),
(20881, '47649', 218, 19, 2593, 38.3334, 0.669044043483994, -87.4449, -1.52620141907719),
(20882, '47654', 218, 19, 3934, 38.2524, 0.667630326789879, -87.3912, -1.52526417726887),
(20883, '47660', 218, 19, 30708, 38.3366, 0.669099894020058, -87.3521, -1.52458175353134),
(20884, '47665', 218, 19, 11032, 38.2742, 0.668010808566814, -87.6898, -1.53047573041532),
(20885, '47666', 218, 19, 11097, 38.4074, 0.67033558713047, -87.5858, -1.52866058799325),
(20886, '47670', 218, 19, 5231, 38.3527, 0.669380892029629, -87.5686, -1.52836039136191),
(20887, '47683', 218, 19, 5947, 38.281, 0.668129490955949, -87.378, -1.52503379380761),
(20888, '47701', 218, 19, 2341, 37.9743, 0.662776566140083, -87.5734, -1.528444167166),
(20889, '47702', 218, 19, 2341, 37.9544, 0.662429245618936, -87.5591, -1.52819458508297),
(20890, '47703', 218, 19, 2341, 37.955, 0.662439717594448, -87.5589, -1.52819109442446),
(20891, '47704', 218, 19, 2341, 37.9541, 0.66242400963118, -87.5594, -1.52819982107072),
(20892, '47705', 218, 19, 2341, 37.9544, 0.662429245618936, -87.5596, -1.52820331172923),
(20893, '47706', 218, 19, 2341, 37.9546, 0.66243273627744, -87.5593, -1.52819807574147),
(20894, '47708', 218, 19, 2341, 37.9748, 0.662785292786343, -87.5736, -1.52844765782451),
(20895, '47710', 218, 19, 2341, 38.0103, 0.663404884670801, -87.5763, -1.52849478171431),
(20896, '47711', 218, 19, 2341, 38.0292, 0.663734751899428, -87.5332, -1.5277425448067),
(20897, '47712', 218, 19, 2341, 37.9897, 0.66304534684489, -87.6381, -1.52957339519204),
(20898, '47713', 218, 19, 2341, 37.9649, 0.662612505190395, -87.5578, -1.52817189580269),
(20899, '47714', 218, 19, 2341, 37.9572, 0.662478114837992, -87.5214, -1.52753659595497),
(20900, '47715', 218, 19, 2341, 37.9702, 0.662705007640751, -87.4811, -1.52683322826641),
(20901, '47716', 218, 19, 2341, 37.9624, 0.662568871959095, -87.4924, -1.52703045047189),
(20902, '47719', 218, 19, 2341, 37.9848, 0.662959825711542, -87.5935, -1.52879497834565),
(20903, '47720', 218, 19, 2341, 38.0327, 0.663795838423247, -87.6292, -1.52941806088862),
(20904, '47721', 218, 19, 2341, 37.9136, 0.661717151284122, -87.6478, -1.52974269212949),
(20905, '47722', 218, 19, 2341, 37.9754, 0.662795764761855, -87.5322, -1.52772509151418),
(20906, '47724', 218, 19, 2341, 38.0006, 0.663235587733357, -87.5706, -1.52839529794695),
(20907, '47725', 218, 19, 2341, 37.9747, 0.662783547457091, -87.5562, -1.52814397053466),
(20908, '47727', 218, 19, 2341, 38.0822, 0.664659776402985, -87.5236, -1.52757499319851),
(20909, '47728', 218, 19, 2341, 37.9486, 0.66232801652232, -87.5303, -1.52769193025839),
(20910, '47730', 218, 19, 2341, 37.9731, 0.662755622189059, -87.5732, -1.5284406765075),
(20911, '47731', 218, 19, 2341, 37.9744, 0.662778311469335, -87.5732, -1.5284406765075),
(20912, '47732', 218, 19, 2341, 37.9741, 0.662773075481579, -87.573, -1.52843718584899),
(20913, '47733', 218, 19, 2341, 37.9748, 0.662785292786343, -87.5738, -1.52845114848301),
(20914, '47734', 218, 19, 2341, 37.9746, 0.662781802127839, -87.574, -1.52845463914151),
(20915, '47735', 218, 19, 2341, 37.9742, 0.662774820810831, -87.5736, -1.52844765782451),
(20916, '47736', 218, 19, 2341, 37.9546, 0.66243273627744, -87.559, -1.52819283975372),
(20917, '47737', 218, 19, 2341, 37.9742, 0.662774820810831, -87.5735, -1.52844591249525),
(20918, '47739', 218, 19, 2341, 38.0208, 0.66358814424226, -87.5744, -1.52846162045852),
(20919, '47740', 218, 19, 2341, 37.978, 0.662841143322407, -87.5857, -1.528658842664),
(20920, '47741', 218, 19, 2341, 37.9719, 0.662734678238035, -87.5713, -1.52840751525171),
(20921, '47744', 218, 19, 2341, 37.9783, 0.662846379310162, -87.5974, -1.52886304618648),
(20922, '47747', 218, 19, 2341, 37.983, 0.662928409785006, -87.5711, -1.52840402459321),
(20923, '47750', 218, 19, 2341, 37.9627, 0.662574107946851, -87.5056, -1.52726083393315),
(20924, '47801', 218, 19, 31301, 39.4661, 0.688813387921334, -87.4141, -1.52566385766758),
(20925, '47802', 218, 19, 31301, 39.4266, 0.688123982866796, -87.3924, -1.52528512121989),
(20926, '47803', 218, 19, 31301, 39.4651, 0.688795934628814, -87.3564, -1.52465680268917),
(20927, '47804', 218, 19, 31301, 39.496, 0.68933524136768, -87.3909, -1.52525894128111),
(20928, '47805', 218, 19, 31301, 39.5276, 0.689886765411311, -87.3654, -1.52481388232185),
(20929, '47807', 218, 19, 31301, 39.4718, 0.688912871688698, -87.3974, -1.52537238768249),
(20930, '47808', 218, 19, 31301, 39.512, 0.689614494047999, -87.3492, -1.52453113898303),
(20931, '47809', 218, 19, 31301, 39.4709, 0.68889716372543, -87.4082, -1.52556088324171),
(20932, '47811', 218, 19, 31301, 39.4506, 0.688542861887275, -87.3479, -1.52450844970276),
(20933, '47812', 218, 19, 31301, 39.4665, 0.688820369238342, -87.407, -1.52553993929068),
(20934, '47813', 218, 19, 31301, 39.4672, 0.688832586543106, -87.4066, -1.52553295797368),
(20935, '47814', 218, 19, 31301, 39.4669, 0.68882735055535, -87.4064, -1.52552946731517),
(20936, '47830', 218, 19, 29190, 39.7707, 0.694129660822909, -87.1691, -1.52138780100019),
(20937, '47831', 218, 19, 29226, 39.6514, 0.69204748302528, -87.4599, -1.52646321846499),
(20938, '47832', 218, 19, 13040, 39.8446, 0.695419459140133, -87.2667, -1.52309124235014),
(20939, '47833', 218, 19, 15294, 39.4751, 0.688970467554014, -87.105, -1.52026904494966),
(20940, '47834', 218, 19, 29280, 39.5248, 0.689837896192255, -87.125, -1.52061811080006),
(20941, '47836', 218, 19, 1132, 39.6508, 0.692037011049768, -87.1807, -1.52159025919342),
(20942, '47837', 218, 19, 26706, 39.5773, 0.690754194049552, -87.0573, -1.51943652289646),
(20943, '47838', 218, 19, 1358, 39.1155, 0.682694263563842, -87.4611, -1.52648416241601),
(20944, '47840', 218, 19, 19905, 39.3792, 0.687296696801351, -87.0989, -1.52016257986529),
(20945, '47841', 218, 19, 1602, 39.277, 0.685512970305813, -87.1123, -1.52039645398506),
(20946, '47842', 218, 19, 1630, 39.6598, 0.692194090682447, -87.4048, -1.52550154204714),
(20947, '47845', 218, 19, 1664, 39.2012, 0.684190010732801, -87.1873, -1.52170545092405),
(20948, '47846', 218, 19, 29556, 39.3833, 0.687368255300683, -87.2051, -1.52201611953091),
(20949, '47847', 218, 19, 15726, 39.8045, 0.694719582110083, -87.4919, -1.52702172382563),
(20950, '47848', 218, 19, 8619, 39.0677, 0.681859996181389, -87.253, -1.52285213224261),
(20951, '47849', 218, 19, 8817, 39.2134, 0.684402940901544, -87.5257, -1.5276116451128),
(20952, '47850', 218, 19, 29784, 39.2536, 0.685104563260846, -87.3787, -1.52504601111237),
(20953, '47851', 218, 19, 29818, 39.5415, 0.690129366177338, -87.3163, -1.52395692565912),
(20954, '47852', 218, 19, 2830, 39.1046, 0.682504022675375, -87.4354, -1.52603561279825),
(20955, '47853', 218, 19, 745, 39.5771, 0.690750703391048, -87.0579, -1.51944699487197),
(20956, '47854', 218, 19, 3147, 39.7628, 0.693991779812001, -87.4098, -1.52558880850974),
(20957, '47855', 218, 19, 30132, 39.1843, 0.683895050089214, -87.2996, -1.52366545567404),
(20958, '47856', 218, 19, 3470, 39.7704, 0.694124424835153, -87.1686, -1.52137907435393),
(20959, '47857', 218, 19, 30262, 39.5771, 0.690750703391048, -87.0569, -1.51942954157945),
(20960, '47858', 218, 19, 3744, 39.285, 0.685652596645972, -87.2683, -1.52311916761817),
(20961, '47859', 218, 19, 4011, 39.9118, 0.696592320397473, -87.1732, -1.52145935949952),
(20962, '47860', 218, 19, 17078, 39.7706, 0.694127915493657, -87.1683, -1.52137383836617),
(20963, '47861', 218, 19, 30488, 39.0138, 0.680919263714564, -87.5253, -1.52760466379579),
(20964, '47862', 218, 19, 23157, 39.7888, 0.69444556541752, -87.3703, -1.5248994034552),
(20965, '47863', 218, 19, 30633, 39.5109, 0.689595295426228, -87.4758, -1.52674072581606),
(20966, '47864', 218, 19, 30637, 39.0139, 0.680921009043816, -87.5255, -1.5276081544543),
(20967, '47865', 218, 19, 17550, 38.964, 0.680050089747071, -87.3571, -1.52466901999394),
(20968, '47866', 218, 19, 30837, 39.2868, 0.685684012572508, -87.3807, -1.52508091769741),
(20969, '47868', 218, 19, 30868, 39.4498, 0.688528899253259, -86.9752, -1.51800360758057),
(20970, '47869', 218, 19, 11367, 39.3583, 0.686931922987684, -87.4075, -1.52554866593694),
(20971, '47870', 218, 19, 112320, 39.3581, 0.68692843232918, -87.4077, -1.52555215659545),
(20972, '47871', 218, 19, 5401, 39.3888, 0.687464248409543, -87.3006, -1.52368290896656),
(20973, '47872', 218, 19, 5479, 39.7666, 0.694058102323577, -87.2283, -1.52242103591737),
(20974, '47874', 218, 19, 5546, 39.6221, 0.691536101554445, -87.2807, -1.52333558844541),
(20975, '47875', 218, 19, 31029, 39.7569, 0.693888805386134, -87.4857, -1.526913513412),
(20976, '47876', 218, 19, 0, 39.5108, 0.689593550096976, -87.4767, -1.52675643377932),
(20977, '47878', 218, 19, 31097, 39.4921, 0.689267173526853, -87.2652, -1.52306506241136),
(20978, '47879', 218, 19, 31112, 39.1795, 0.683811274285118, -87.3914, -1.52526766792737),
(20979, '47880', 218, 19, 31113, 39.5108, 0.689593550096976, -87.4761, -1.52674596180381),
(20980, '47881', 218, 19, 25106, 39.5164, 0.689691288535087, -87.1253, -1.52062334678782),
(20981, '47882', 218, 19, 28723, 39.0984, 0.682395812261751, -87.4043, -1.52549281540088),
(20982, '47884', 218, 19, 31355, 39.651, 0.692040501708272, -87.4601, -1.52646670912349),
(20983, '47885', 218, 19, 31497, 39.4648, 0.688790698641058, -87.4462, -1.52622410835747),
(20984, '47901', 218, 19, 3594, 40.4174, 0.705416705095556, -86.8893, -1.51650436975311),
(20985, '47902', 218, 19, 3594, 40.4139, 0.705355618571736, -86.8491, -1.51580274739381),
(20986, '47903', 218, 19, 3594, 40.4175, 0.705418450424808, -86.8541, -1.51589001385641),
(20987, '47904', 218, 19, 3594, 40.4273, 0.705589492691504, -86.874, -1.51623733437755),
(20988, '47905', 218, 19, 3594, 40.3214, 0.703741189013642, -86.9125, -1.51690928613957),
(20989, '47906', 218, 19, 123990, 40.4964, 0.706795515204632, -86.9659, -1.51784129196014),
(20990, '47907', 218, 19, 123990, 40.3689, 0.704570220408339, -86.8772, -1.51629318491362),
(20991, '47909', 218, 19, 3594, 40.3223, 0.703756896976909, -86.8856, -1.51643979257079),
(20992, '47916', 218, 19, 7039, 39.9755, 0.697704095130993, -87.0279, -1.51892339609637),
(20993, '47917', 218, 19, 92237, 40.4654, 0.706254463136514, -87.463, -1.5265173236718),
(20994, '47918', 218, 19, 7188, 40.2904, 0.703200136945523, -87.2471, -1.52274915781674),
(20995, '47920', 218, 19, 122196, 40.5267, 0.707324349967986, -86.8274, -1.51542401094612),
(20996, '47921', 218, 19, 7613, 40.516, 0.707137599738022, -87.3565, -1.52465854801843),
(20997, '47922', 218, 19, 122279, 40.867, 0.713263705412523, -87.3653, -1.5248121369926),
(20998, '47923', 218, 19, 63225, 40.6003, 0.708608912297454, -86.864, -1.51606280145235),
(20999, '47924', 218, 19, 19615, 40.4876, 0.706641926230456, -86.7614, -1.51427209363981),
(21000, '47925', 218, 19, 26642, 40.6035, 0.708664762833518, -86.8664, -1.5161046893544),
(21001, '47926', 218, 19, 122300, 40.7043, 0.710424054719528, -86.577, -1.51105370649913),
(21002, '47928', 218, 19, 29419, 39.9496, 0.697252054854727, -87.4639, -1.52653303163507),
(21003, '47929', 218, 19, 93176, 40.6633, 0.70970846972621, -86.8666, -1.51610818001291),
(21004, '47930', 218, 19, 80344, 40.244, 0.702390304172598, -86.73, -1.51372406025468),
(21005, '47932', 218, 19, 15652, 40.1404, 0.700582143067532, -87.3889, -1.52522403469607),
(21006, '47933', 218, 19, 8287, 40.0311, 0.698674498195102, -86.9071, -1.51681503835996),
(21007, '47934', 218, 19, 8287, 40.0395, 0.69882110585227, -86.9218, -1.51707160176001),
(21008, '47935', 218, 19, 8287, 40.0387, 0.698807143218254, -86.9217, -1.51706985643076),
(21009, '47936', 218, 19, 8287, 40.0417, 0.698859503095813, -86.8989, -1.5166719213613),
(21010, '47937', 218, 19, 8287, 40.039, 0.69881237920601, -86.9218, -1.51707160176001),
(21011, '47938', 218, 19, 8287, 40.0387, 0.698807143218254, -86.9219, -1.51707334708926),
(21012, '47939', 218, 19, 8287, 40.0389, 0.698810633876758, -86.9216, -1.5170681111015),
(21013, '47940', 218, 19, 1971, 40.1376, 0.700533273848476, -86.7577, -1.51420751645748),
(21014, '47941', 218, 19, 1992, 40.3759, 0.704692393455979, -86.7669, -1.51436808674867),
(21015, '47942', 218, 19, 122536, 40.6835, 0.710061026235113, -87.4142, -1.52566560299683),
(21016, '47943', 218, 19, 2362, 41.0709, 0.716822431757339, -87.2088, -1.52208069671323),
(21017, '47944', 218, 19, 2578, 40.6186, 0.708928307550569, -87.3187, -1.52399881356117),
(21018, '47946', 218, 19, 122641, 40.9851, 0.715324939259128, -86.8819, -1.51637521538846),
(21019, '47948', 218, 19, 16246, 40.7664, 0.711507904185016, -87.2933, -1.52355549993117),
(21020, '47949', 218, 19, 3145, 40.1084, 0.700023637706894, -87.1569, -1.52117487083145),
(21021, '47950', 218, 19, 88058, 40.5106, 0.707043351958415, -86.8415, -1.51567010237066),
(21022, '47951', 218, 19, 48629, 40.7756, 0.7116684744762, -87.4452, -1.52620665506495),
(21023, '47952', 218, 19, 27631, 39.9992, 0.698117738163716, -87.3064, -1.52378413806318),
(21024, '47954', 218, 19, 30279, 39.9147, 0.696642934945781, -86.7986, -1.51492135612155),
(21025, '47955', 218, 19, 3784, 40.1895, 0.701439099730261, -86.9024, -1.51673300788512),
(21026, '47957', 218, 19, 123167, 41.0787, 0.716958567438995, -86.889, -1.51649913376535),
(21027, '47958', 218, 19, 123169, 40.1642, 0.700997531429506, -87.1494, -1.52104397113755),
(21028, '47959', 218, 19, 123220, 40.8646, 0.713221817510475, -86.8785, -1.51631587419389),
(21029, '47960', 218, 19, 588, 40.7507, 0.711233887492453, -86.7637, -1.5143122362126),
(21030, '47962', 218, 19, 82459, 40.4742, 0.706408052110689, -87.0289, -1.51894084938889),
(21031, '47963', 218, 19, 56378, 40.9463, 0.714647751509354, -87.4538, -1.52635675338062),
(21032, '47964', 218, 19, 116948, 40.9515, 0.714738508630458, -87.2986, -1.52364800238152),
(21033, '47965', 218, 19, 4548, 39.9509, 0.697274744135003, -86.9191, -1.5170244778702),
(21034, '47966', 218, 19, 10799, 39.8841, 0.69610886419467, -87.4091, -1.52557659120498),
(21035, '47967', 218, 19, 177, 40.1932, 0.701503676912585, -86.9801, -1.51808912871392),
(21036, '47968', 218, 19, 30649, 39.9966, 0.698072359603164, -86.7525, -1.51411675933638),
(21037, '47969', 218, 19, 839, 40.2047, 0.701704389776564, -87.1475, -1.52101080988176),
(21038, '47970', 218, 19, 73807, 40.4898, 0.706680323474, -87.0972, -1.52013290926801),
(21039, '47971', 218, 19, 4828, 40.5218, 0.707238828834638, -87.2484, -1.52277184709702),
(21040, '47974', 218, 19, 123418, 40.0766, 0.699468623004759, -87.4779, -1.52677737773035),
(21041, '47975', 218, 19, 82994, 40.432, 0.705671523166347, -87.2352, -1.52254146363576),
(21042, '47977', 218, 19, 74045, 40.7623, 0.711436345685685, -87.152, -1.5210893496981),
(21043, '47978', 218, 19, 57137, 40.937, 0.714485435888919, -87.1533, -1.52111203897837),
(21044, '47980', 218, 19, 5360, 40.7482, 0.711190254261153, -86.8737, -1.5162320983898),
(21045, '47981', 218, 19, 97626, 40.2553, 0.702587526378073, -86.8992, -1.51667715734906),
(21046, '47982', 218, 19, 6059, 40.1972, 0.701573490082665, -87.5268, -1.52763084373457),
(21047, '47983', 218, 19, 123736, 40.2866, 0.703133814433948, -86.7706, -1.51443266393099),
(21048, '47984', 218, 19, 123775, 40.5052, 0.706949104178807, -87.4541, -1.52636198936837),
(21049, '47986', 218, 19, 91273, 40.513, 0.707085239860463, -87.2067, -1.52204404479894),
(21050, '47987', 218, 19, 123885, 40.113, 0.700103922852485, -87.2647, -1.5230563357651),
(21051, '47988', 218, 19, 721, 39.9875, 0.697913534641233, -87.148, -1.52101953652802),
(21052, '47989', 218, 19, 12704, 39.8786, 0.696012871085811, -87.0429, -1.51918519548417),
(21053, '47990', 218, 19, 123970, 40.0881, 0.699669335868739, -87.065, -1.51957091324886),
(21054, '47991', 218, 19, 58217, 40.2701, 0.702845835107369, -87.3849, -1.52515422152599),
(21055, '47992', 218, 19, 91784, 40.3165, 0.703655667880294, -87.0633, -1.51954124265158),
(21056, '47993', 218, 19, 38893, 40.2861, 0.703125087787688, -87.2949, -1.5235834251992),
(21057, '47994', 218, 19, 34455, 40.1745, 0.701177300342462, -87.0721, -1.51969483162575),
(21058, '47995', 218, 19, 34461, 40.7584, 0.711368277844857, -87.0426, -1.51917995949642),
(21059, '47996', 218, 19, 123990, 40.4446, 0.705891434652099, -86.9117, -1.51689532350556),
(21060, '47997', 218, 19, 124058, 40.6668, 0.70976955625003, -86.7239, -1.51361759517031),
(21061, '48001', 218, 27, 129471, 42.641, 0.744225846342902, -82.5605, -1.44095255709278),
(21062, '48002', 218, 27, 53157, 42.9331, 0.749323953087978, -82.9135, -1.44711356935232),
(21063, '48003', 218, 27, 112747, 42.9263, 0.749205270698842, -83.0429, -1.4493720254044),
(21064, '48004', 218, 27, 129527, 42.7162, 0.745538333940402, -82.6832, -1.44309407608498),
(21065, '48005', 218, 27, 129563, 42.8456, 0.747796789992482, -82.919, -1.44720956246118),
(21066, '48006', 218, 27, 7207, 43.0643, 0.751613825066594, -82.6868, -1.44315690793805),
(21067, '48007', 218, 27, 199, 42.5802, 0.743164686157689, -83.1429, -1.45111735465639),
(21068, '48009', 218, 27, 799, 42.5447, 0.742545094273231, -83.2141, -1.45236002908381),
(21069, '48012', 218, 27, 799, 42.5461, 0.74256952888276, -83.2112, -1.45230941453551),
(21070, '48014', 218, 27, 130077, 43.0226, 0.750886022768512, -82.9218, -1.44725843168023),
(21071, '48015', 218, 27, 93147, 42.4795, 0.741407139600931, -83.0265, -1.44908579140707),
(21072, '48017', 218, 27, 93282, 42.536, 0.742393250628308, -83.1501, -1.45124301836254),
(21073, '48021', 218, 27, 130601, 42.4661, 0.741173265481164, -82.9458, -1.44767731070071),
(21074, '48022', 218, 27, 32360, 43.0219, 0.750873805463748, -82.8147, -1.44538918405135),
(21075, '48023', 218, 27, 54696, 42.7014, 0.745280025211107, -82.6506, -1.44252509874883),
(21076, '48025', 218, 27, 2595, 42.5213, 0.742136687228265, -83.2632, -1.45321698574654),
(21077, '48026', 218, 27, 115636, 42.5355, 0.742384523982048, -82.9511, -1.44776981315107),
(21078, '48027', 218, 27, 131037, 42.9476, 0.749577025829517, -82.6801, -1.44303997087816),
(21079, '48028', 218, 27, 0, 42.5782, 0.74312977957265, -82.6007, -1.44165417945208),
(21080, '48030', 218, 27, 131261, 42.4605, 0.741075527043052, -83.0984, -1.45034068313926),
(21081, '48032', 218, 27, 3413, 43.1315, 0.752786686323934, -82.5837, -1.44135747347924),
(21082, '48034', 218, 27, 126225, 42.471, 0.741258786614512, -83.2935, -1.4537458205099),
(21083, '48035', 218, 27, 0, 42.5564, 0.742749297795715, -82.9097, -1.44704724684074),
(21084, '48036', 218, 27, 0, 42.593, 0.743388088301945, -82.9089, -1.44703328420673),
(21085, '48037', 218, 27, 126225, 42.4869, 0.741536293965579, -83.2632, -1.45321698574654),
(21086, '48038', 218, 27, 0, 42.6025, 0.743553894580884, -82.9524, -1.44779250243134),
(21087, '48039', 218, 27, 131937, 42.6997, 0.745250354613823, -82.5455, -1.44069075770498),
(21088, '48040', 218, 27, 10343, 42.9146, 0.749001067176359, -82.4818, -1.43957898297146),
(21089, '48041', 218, 27, 4163, 42.9376, 0.749402492904317, -82.8027, -1.44517974454111),
(21090, '48042', 218, 27, 56039, 42.6839, 0.744974592592008, -82.9183, -1.44719734515641),
(21091, '48043', 218, 27, 132185, 42.5962, 0.743443938838009, -82.8818, -1.44656029997944),
(21092, '48044', 218, 27, 56039, 42.6518, 0.744414341902118, -82.9269, -1.44734744347209),
(21093, '48045', 218, 27, 0, 42.6102, 0.743688284933288, -82.8355, -1.44575221253576),
(21094, '48046', 218, 27, 132185, 42.591, 0.743353181716905, -82.8805, -1.44653761069916),
(21095, '48047', 218, 27, 30619, 42.6734, 0.744791333020548, -82.7792, -1.44476959216689),
(21096, '48048', 218, 27, 4528, 42.7337, 0.745843766559501, -82.8157, -1.44540663734387),
(21097, '48049', 218, 27, 0, 43.0351, 0.751104188925012, -82.5546, -1.44084958266691),
(21098, '48050', 218, 27, 4528, 42.7887, 0.746803697648098, -82.8011, -1.44515181927308),
(21099, '48051', 218, 27, 30619, 42.6916, 0.745108982944411, -82.8117, -1.44533682417379),
(21100, '48054', 218, 27, 0, 42.7698, 0.746473830419471, -82.5425, -1.44063839782742),
(21101, '48059', 218, 27, 0, 43.0776, 0.751845953857109, -82.4822, -1.43958596428847),
(21102, '48060', 218, 27, 132697, 42.9824, 0.750184400409211, -82.456, -1.43912868802444),
(21103, '48061', 218, 27, 132697, 42.9938, 0.750383367943938, -82.4335, -1.43873598894275),
(21104, '48062', 218, 27, 5381, 42.8435, 0.747760138078191, -82.7982, -1.44510120472477),
(21105, '48063', 218, 27, 1718, 42.8494, 0.747863112504058, -82.6767, -1.4429806296836),
(21106, '48064', 218, 27, 100553, 42.766, 0.746407507907895, -82.6849, -1.44312374668226),
(21107, '48065', 218, 27, 17848, 42.8381, 0.747665890298583, -83.0349, -1.44923239906424),
(21108, '48066', 218, 27, 11688, 42.504, 0.74183474526767, -82.9374, -1.44753070304354),
(21109, '48067', 218, 27, 51095, 42.49, 0.741590399172391, -83.14, -1.45106674010809),
(21110, '48068', 218, 27, 51095, 42.4888, 0.741569455221367, -83.1467, -1.45118367716797),
(21111, '48069', 218, 27, 5142, 42.471, 0.741258786614512, -83.1399, -1.45106499477883),
(21112, '48070', 218, 27, 48392, 42.482, 0.741450772832231, -83.167, -1.45153797900612),
(21113, '48071', 218, 27, 103916, 42.5019, 0.741798093353378, -83.1058, -1.4504698375039),
(21114, '48072', 218, 27, 372, 42.5001, 0.741766677426842, -83.1863, -1.45187482755176),
(21115, '48073', 218, 27, 51095, 42.5191, 0.742098289984721, -83.1659, -1.45151878038435),
(21116, '48074', 218, 27, 38264, 42.9434, 0.749503722000933, -82.562, -1.44097873703156),
(21117, '48075', 218, 27, 126225, 42.4613, 0.741089489677068, -83.2275, -1.45259390320358),
(21118, '48076', 218, 27, 126225, 42.4991, 0.741749224134322, -83.2308, -1.4526514990689),
(21119, '48079', 218, 27, 5605, 42.8542, 0.747946888308154, -82.5476, -1.44072740961927),
(21120, '48080', 218, 27, 5609, 42.4632, 0.741122650932856, -82.9026, -1.44692332846385),
(21121, '48081', 218, 27, 5609, 42.4962, 0.741698609586014, -82.8994, -1.44686747792779),
(21122, '48082', 218, 27, 5609, 42.5279, 0.742251878958897, -82.8873, -1.4466562930883),
(21123, '48083', 218, 27, 199, 42.5599, 0.742810384319535, -83.1208, -1.4507316368917),
(21124, '48084', 218, 27, 199, 42.5604, 0.742819110965795, -83.1712, -1.45161128283471),
(21125, '48085', 218, 27, 199, 42.5969, 0.743456156142773, -83.1204, -1.45072465557469),
(21126, '48086', 218, 27, 126225, 42.4757, 0.741340817089356, -83.2594, -1.45315066323497),
(21127, '48088', 218, 27, 12663, 42.5176, 0.742072110045941, -82.9826, -1.44831959186545),
(21128, '48089', 218, 27, 12663, 42.468, 0.741206426736952, -82.9957, -1.44854822999746),
(21129, '48090', 218, 27, 12663, 42.4546, 0.740972552617185, -82.8843, -1.44660393321074),
(21130, '48091', 218, 27, 12663, 42.467, 0.741188973444432, -83.0581, -1.4496373154507),
(21131, '48092', 218, 27, 12663, 42.5131, 0.741993570229601, -83.0602, -1.44967396736499),
(21132, '48093', 218, 27, 12663, 42.5169, 0.742059892741177, -83.0081, -1.44876465082471),
(21133, '48094', 218, 27, 12671, 42.7261, 0.745711121536349, -83.0298, -1.44914338727239),
(21134, '48095', 218, 27, 12671, 42.7804, 0.746658835320182, -83.0387, -1.44929872157582),
(21135, '48096', 218, 27, 5300, 42.7637, 0.746367365335099, -82.9104, -1.44705946414551),
(21136, '48097', 218, 27, 12986, 43.1228, 0.752634842679011, -82.826, -1.44558640625682),
(21137, '48098', 218, 27, 199, 42.6022, 0.743548658593128, -83.1778, -1.45172647456534),
(21138, '48099', 218, 27, 199, 42.561, 0.742829582941307, -83.1466, -1.45118193183872),
(21139, '48101', 218, 27, 129480, 42.2545, 0.737480148783944, -83.2103, -1.45229370657224),
(21140, '48103', 218, 27, 129533, 42.2806, 0.737935679718715, -83.7978, -1.4625475159277),
(21141, '48104', 218, 27, 129533, 42.2595, 0.737567415246544, -83.7201, -1.4611913950989),
(21142, '48105', 218, 27, 129533, 42.3065, 0.738387719994981, -83.7042, -1.46091388774784),
(21143, '48106', 218, 27, 129533, 42.2293, 0.737040325812441, -83.7359, -1.46146715712072),
(21144, '48107', 218, 27, 129533, 42.2554, 0.737495856747212, -83.6802, -1.46049500872736),
(21145, '48108', 218, 27, 129533, 42.2382, 0.737195660115869, -83.7204, -1.46119663108666),
(21146, '48109', 218, 27, 129533, 42.2914, 0.73812417527793, -83.7144, -1.46109191133154),
(21147, '48110', 218, 27, 29136, 42.0169, 0.733333246481205, -83.6662, -1.46025066263208),
(21148, '48111', 218, 27, 263, 42.1758, 0.736106574662625, -83.4877, -1.45713524991727),
(21149, '48112', 218, 27, 263, 42.2036, 0.736591776194679, -83.4827, -1.45704798345467),
(21150, '48113', 218, 27, 129533, 42.2753, 0.737843177268359, -83.7303, -1.46136941868261),
(21151, '48114', 218, 27, 212, 42.5293, 0.742276313568424, -83.78, -1.46223684732085),
(21152, '48115', 218, 27, 19494, 42.1601, 0.735832557970061, -83.9181, -1.46464714701785),
(21153, '48116', 218, 27, 212, 42.5334, 0.742347872067756, -83.7741, -1.46213387289498),
(21154, '48117', 218, 27, 75333, 42.0529, 0.733961565011923, -83.4102, -1.45578261974697),
(21155, '48118', 218, 27, 1509, 42.3164, 0.738560507590929, -84.0315, -1.46662635038961),
(21156, '48120', 218, 27, 40029, 42.306, 0.738378993348721, -83.1712, -1.45161128283471),
(21157, '48121', 218, 27, 40029, 42.3116, 0.738476731786833, -83.1916, -1.45196733000211),
(21158, '48122', 218, 27, 132042, 42.2797, 0.737919971755447, -83.1804, -1.45177185312589),
(21159, '48123', 218, 27, 40029, 42.3116, 0.738476731786833, -83.2136, -1.45235130243755),
(21160, '48124', 218, 27, 40029, 42.2956, 0.738197479106514, -83.2508, -1.4530005649193),
(21161, '48125', 218, 27, 130441, 42.2774, 0.737879829182651, -83.2617, -1.45319080580776),
(21162, '48126', 218, 27, 40029, 42.3323, 0.738838014941996, -83.1947, -1.45202143520893),
(21163, '48127', 218, 27, 130441, 42.3363, 0.738907828112075, -83.2815, -1.45353638099966),
(21164, '48128', 218, 27, 40029, 42.3196, 0.738616358126992, -83.2628, -1.45321000442953),
(21165, '48130', 218, 27, 2038, 42.3516, 0.73917486348763, -83.8985, -1.46430506248446),
(21166, '48131', 218, 27, 2134, 41.964, 0.7324099673069, -83.6671, -1.46026637059535),
(21167, '48133', 218, 27, 15943, 41.7821, 0.729235213397523, -83.491, -1.45719284578259),
(21168, '48134', 218, 27, 2479, 42.1076, 0.734916260112764, -83.2829, -1.45356081560919),
(21169, '48135', 218, 27, 2657, 42.3243, 0.738698388601836, -83.3393, -1.45454518130731),
(21170, '48136', 218, 27, 2657, 42.3243, 0.738698388601836, -83.3429, -1.45460801316038),
(21171, '48137', 218, 27, 9237, 42.4032, 0.740075453381659, -84.0336, -1.46666300230391),
(21172, '48138', 218, 27, 131141, 42.134, 0.735377027035291, -83.1555, -1.45133726614214),
(21173, '48139', 218, 27, 2948, 42.4522, 0.740930664715137, -83.8117, -1.46279011669373),
(21174, '48140', 218, 27, 9638, 41.8734, 0.730828699004594, -83.5805, -1.45875491546312),
(21175, '48141', 218, 27, 113114, 42.2932, 0.738155591204466, -83.3143, -1.45410884899431),
(21176, '48143', 218, 27, 16822, 42.4582, 0.741035384470256, -83.8972, -1.46428237320419),
(21177, '48144', 218, 27, 131682, 41.7537, 0.728739539889956, -83.626, -1.45954904027278),
(21178, '48145', 218, 27, 95463, 41.8485, 0.730394112020847, -83.453, -1.45652962066683),
(21179, '48146', 218, 27, 13147, 42.2442, 0.737300379870989, -83.1805, -1.45177359845514),
(21180, '48150', 218, 27, 30358, 42.3646, 0.73940175629039, -83.3698, -1.45507750672917),
(21181, '48151', 218, 27, 30358, 42.398, 0.739984696260556, -83.3729, -1.45513161193598),
(21182, '48152', 218, 27, 30358, 42.4258, 0.74046989779261, -83.3694, -1.45507052541216),
(21183, '48153', 218, 27, 30358, 42.3667, 0.739438408204682, -83.3875, -1.45538643000677),
(21184, '48154', 218, 27, 30358, 42.3962, 0.73995328033402, -83.3782, -1.45522411438634),
(21185, '48157', 218, 27, 131852, 41.8169, 0.729842587977217, -83.4437, -1.45636730504639),
(21186, '48158', 218, 27, 585, 42.1512, 0.735677223666634, -84.0288, -1.46657922649981),
(21187, '48159', 218, 27, 131992, 42.0189, 0.733368153066245, -83.5459, -1.45815103154193),
(21188, '48160', 218, 27, 23084, 42.1108, 0.734972110648828, -83.6834, -1.46055085926342),
(21189, '48161', 218, 27, 10560, 41.9081, 0.731434328255036, -83.4707, -1.45683854394443),
(21190, '48162', 218, 27, 10560, 41.9473, 0.732118497321817, -83.4057, -1.45570407993063),
(21191, '48164', 218, 27, 30620, 42.1256, 0.735230419378123, -83.3909, -1.45544577120134),
(21192, '48165', 218, 27, 132268, 42.5056, 0.741862670535702, -83.6262, -1.45955253093128),
(21193, '48166', 218, 27, 10799, 41.9777, 0.732649077414424, -83.2855, -1.45360619416974),
(21194, '48167', 218, 27, 71188, 42.4217, 0.740398339293278, -83.4721, -1.45686297855396),
(21195, '48169', 218, 27, 11200, 42.4595, 0.741058073750532, -83.9366, -1.46497003292947),
(21196, '48170', 218, 27, 14433, 42.3708, 0.739509966704013, -83.5195, -1.4576902646194),
(21197, '48173', 218, 27, 5481, 42.0755, 0.734356009422874, -83.2196, -1.45245602219267),
(21198, '48174', 218, 27, 5532, 42.2225, 0.736921643423306, -83.373, -1.45513335726523),
(21199, '48175', 218, 27, 126, 42.4057, 0.740119086612959, -83.5792, -1.45873222618284),
(21200, '48176', 218, 27, 11776, 42.1665, 0.735944259042189, -83.7898, -1.46240788958754),
(21201, '48177', 218, 27, 5628, 41.8094, 0.729711688283317, -83.5761, -1.45867812097603),
(21202, '48178', 218, 27, 133186, 42.4496, 0.740885286154585, -83.6603, -1.46014768820621),
(21203, '48179', 218, 27, 133193, 42.051, 0.733928403756136, -83.2624, -1.45320302311253),
(21204, '48180', 218, 27, 6252, 42.2329, 0.737103157665513, -83.2687, -1.4533129788554),
(21205, '48182', 218, 27, 25370, 41.7893, 0.729360877103666, -83.5713, -1.45859434517194),
(21206, '48183', 218, 27, 6381, 42.1369, 0.735427641583599, -83.2158, -1.4523896996811),
(21207, '48184', 218, 27, 6665, 42.2769, 0.737871102536391, -83.3802, -1.45525902097138),
(21208, '48185', 218, 27, 6743, 42.3384, 0.738944480026367, -83.3961, -1.45553652832244),
(21209, '48186', 218, 27, 6743, 42.3, 0.738274273593601, -83.3807, -1.45526774761764),
(21210, '48187', 218, 27, 19763, 42.3317, 0.738827542966484, -83.4758, -1.45692755573628),
(21211, '48188', 218, 27, 19763, 42.2886, 0.738075306058874, -83.477, -1.45694849968731),
(21212, '48189', 218, 27, 133723, 42.4001, 0.740021348174848, -83.7675, -1.46201868116435),
(21213, '48190', 218, 27, 112045, 42.126, 0.735237400695131, -83.5969, -1.45904114946045),
(21214, '48191', 218, 27, 12872, 42.1329, 0.735357828413519, -83.5717, -1.45860132648895),
(21215, '48192', 218, 27, 31570, 42.1812, 0.736200822442232, -83.1726, -1.45163571744424),
(21216, '48195', 218, 27, 18159, 42.206, 0.736633664096727, -83.2057, -1.45221342142665),
(21217, '48197', 218, 27, 26308, 42.2311, 0.737071741738977, -83.6213, -1.45946700979793),
(21218, '48198', 218, 27, 26308, 42.2478, 0.73736321172406, -83.5877, -1.45888057916926),
(21219, '48201', 218, 27, 2034, 42.345, 0.739059671756999, -83.0597, -1.44966524071873);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(21220, '48202', 218, 27, 2034, 42.3734, 0.739555345264565, -83.0771, -1.44996892800858),
(21221, '48203', 218, 27, 16433, 42.422, 0.740403575281034, -83.1028, -1.45041747762634),
(21222, '48204', 218, 27, 2034, 42.3657, 0.739420954912162, -83.1398, -1.45106324944958),
(21223, '48205', 218, 27, 2034, 42.4337, 0.740607778803518, -82.9815, -1.44830039324367),
(21224, '48206', 218, 27, 2034, 42.3711, 0.739515202691769, -83.1008, -1.4503825710413),
(21225, '48207', 218, 27, 2034, 42.353, 0.739199298097158, -83.0259, -1.44907531943156),
(21226, '48208', 218, 27, 2034, 42.3501, 0.739148683548851, -83.0901, -1.45019582081134),
(21227, '48209', 218, 27, 2034, 42.3066, 0.738389465324233, -83.1125, -1.45058677456379),
(21228, '48210', 218, 27, 2034, 42.3375, 0.738928772063099, -83.1283, -1.4508625365856),
(21229, '48211', 218, 27, 2034, 42.3816, 0.739698462263229, -83.0492, -1.44948198114727),
(21230, '48212', 218, 27, 131186, 42.4105, 0.740202862417055, -83.0575, -1.44962684347519),
(21231, '48213', 218, 27, 2034, 42.3962, 0.73995328033402, -82.9961, -1.44855521131447),
(21232, '48214', 218, 27, 2034, 42.3673, 0.739448880180194, -82.9904, -1.4484557275471),
(21233, '48215', 218, 27, 2034, 42.3774, 0.739625158434645, -82.9523, -1.44779075710209),
(21234, '48216', 218, 27, 2034, 42.3271, 0.738747257820892, -83.0806, -1.4500300145324),
(21235, '48217', 218, 27, 2034, 42.2767, 0.737867611877887, -83.1547, -1.45132330350813),
(21236, '48218', 218, 27, 132843, 42.2703, 0.737755910805759, -83.1375, -1.45102310687679),
(21237, '48219', 218, 27, 2034, 42.4259, 0.740471643121862, -83.252, -1.45302150887032),
(21238, '48220', 218, 27, 8879, 42.4585, 0.741040620458012, -83.1377, -1.45102659753529),
(21239, '48221', 218, 27, 2034, 42.4275, 0.740499568389894, -83.1485, -1.45121509309451),
(21240, '48222', 218, 27, 2034, 42.2713, 0.737773364098279, -83.1311, -1.45091140580466),
(21241, '48223', 218, 27, 2034, 42.3921, 0.739881721834688, -83.2485, -1.4529604223465),
(21242, '48224', 218, 27, 2034, 42.409, 0.740176682478275, -82.9437, -1.44764065878642),
(21243, '48225', 218, 27, 131214, 42.4376, 0.740675846644346, -82.9278, -1.44736315143535),
(21244, '48226', 218, 27, 2034, 42.3318, 0.738829288295736, -83.0504, -1.4495029250983),
(21245, '48227', 218, 27, 2034, 42.3873, 0.739797946030592, -83.1919, -1.45197256598987),
(21246, '48228', 218, 27, 2034, 42.3553, 0.739239440669954, -83.214, -1.45235828375456),
(21247, '48229', 218, 27, 130616, 42.2523, 0.7374417515404, -83.1459, -1.45116971453395),
(21248, '48230', 218, 27, 131143, 42.3844, 0.739747331482285, -82.923, -1.44727937563126),
(21249, '48231', 218, 27, 2034, 42.3316, 0.738825797637232, -83.0495, -1.44948721713503),
(21250, '48232', 218, 27, 2034, 42.3317, 0.738827542966484, -83.0488, -1.44947499983027),
(21251, '48233', 218, 27, 2034, 42.3244, 0.738700133931088, -83.0608, -1.44968443934051),
(21252, '48234', 218, 27, 2034, 42.4318, 0.74057461754773, -83.0433, -1.44937900672141),
(21253, '48235', 218, 27, 2034, 42.427, 0.740490841743634, -83.1942, -1.45201270856267),
(21254, '48236', 218, 27, 131143, 42.424, 0.740438481866074, -82.8982, -1.44684653397676),
(21255, '48237', 218, 27, 4691, 42.4661, 0.741173265481164, -83.1809, -1.45178057977215),
(21256, '48238', 218, 27, 2034, 42.397, 0.739967242968036, -83.1413, -1.45108942938836),
(21257, '48239', 218, 27, 57124, 42.3757, 0.739595487837361, -83.2865, -1.45362364746226),
(21258, '48240', 218, 27, 57124, 42.4255, 0.740464661804854, -83.3014, -1.4538837015208),
(21259, '48242', 218, 27, 2034, 42.2154, 0.736797725046414, -83.3502, -1.45473542219578),
(21260, '48243', 218, 27, 2034, 42.3297, 0.738792636381444, -83.0363, -1.44925683367377),
(21261, '48244', 218, 27, 2034, 42.3271, 0.738747257820892, -83.0792, -1.45000557992287),
(21262, '48255', 218, 27, 2034, 42.3304, 0.738804853686208, -83.0516, -1.44952386904932),
(21263, '48260', 218, 27, 2034, 42.3348, 0.738881648173295, -83.0579, -1.4496338247922),
(21264, '48264', 218, 27, 2034, 42.3303, 0.738803108356956, -83.0457, -1.44942089462345),
(21265, '48265', 218, 27, 2034, 42.4394, 0.740707262570881, -82.9302, -1.4474050393374),
(21266, '48266', 218, 27, 2034, 42.345, 0.739059671756999, -83.0086, -1.44877337747097),
(21267, '48267', 218, 27, 2034, 42.3299, 0.738796127039948, -83.0519, -1.44952910503708),
(21268, '48268', 218, 27, 2034, 42.3294, 0.738787400393688, -83.0461, -1.44942787594046),
(21269, '48269', 218, 27, 2034, 42.3299, 0.738796127039948, -83.0464, -1.44943311192822),
(21270, '48272', 218, 27, 2034, 42.3377, 0.738932262721603, -83.052, -1.44953085036633),
(21271, '48275', 218, 27, 2034, 42.3303, 0.738803108356956, -83.0489, -1.44947674515952),
(21272, '48277', 218, 27, 2034, 42.3251, 0.738712351235852, -83.0608, -1.44968443934051),
(21273, '48278', 218, 27, 2034, 42.3258, 0.738724568540616, -83.0601, -1.44967222203574),
(21274, '48279', 218, 27, 2034, 42.33, 0.7387978723692, -83.0389, -1.44930221223432),
(21275, '48288', 218, 27, 2034, 42.422, 0.740403575281034, -83.1037, -1.45043318558961),
(21276, '48301', 218, 27, 129864, 42.5449, 0.742548584931735, -83.2835, -1.4535712875847),
(21277, '48302', 218, 27, 129864, 42.5837, 0.743225772681509, -83.2964, -1.4537964350582),
(21278, '48303', 218, 27, 129864, 42.5833, 0.743218791364501, -83.2456, -1.45290980779819),
(21279, '48304', 218, 27, 129864, 42.5895, 0.743327001778125, -83.2322, -1.45267593367842),
(21280, '48306', 218, 27, 28433, 42.7234, 0.745663997646545, -83.1471, -1.45119065848498),
(21281, '48307', 218, 27, 28433, 42.6577, 0.744517316327985, -83.1227, -1.45076479814749),
(21282, '48308', 218, 27, 28433, 42.6801, 0.744908270080432, -83.1334, -1.45095154837745),
(21283, '48309', 218, 27, 28433, 42.6687, 0.744709302545705, -83.1772, -1.45171600258983),
(21284, '48310', 218, 27, 25121, 42.5695, 0.742977935927726, -83.0674, -1.44979963107114),
(21285, '48311', 218, 27, 25121, 42.5802, 0.743164686157689, -83.0303, -1.44915211391865),
(21286, '48312', 218, 27, 25121, 42.5588, 0.742791185697763, -83.0075, -1.44875417884919),
(21287, '48313', 218, 27, 25121, 42.597, 0.743457901472025, -82.9969, -1.44856917394848),
(21288, '48314', 218, 27, 25121, 42.6008, 0.7435242239836, -83.059, -1.44965302341397),
(21289, '48315', 218, 27, 31360, 42.6663, 0.744667414643657, -82.9954, -1.4485429940097),
(21290, '48316', 218, 27, 31360, 42.689, 0.745063604383859, -83.0578, -1.44963207946295),
(21291, '48317', 218, 27, 31360, 42.6469, 0.74432882076877, -83.0525, -1.44953957701259),
(21292, '48318', 218, 27, 31360, 42.6256, 0.743957065638095, -83.0336, -1.44920970978396),
(21293, '48320', 218, 27, 131543, 42.6077, 0.743644651701988, -83.3436, -1.45462023046515),
(21294, '48321', 218, 27, 13307, 42.6744, 0.744808786313068, -83.244, -1.45288188253016),
(21295, '48322', 218, 27, 153575, 42.5418, 0.742494479724924, -83.3829, -1.45530614486118),
(21296, '48323', 218, 27, 153575, 42.571, 0.743004115866506, -83.3699, -1.45507925205842),
(21297, '48324', 218, 27, 153575, 42.5977, 0.743470118776789, -83.3951, -1.45551907502992),
(21298, '48325', 218, 27, 153575, 42.596, 0.743440448179505, -83.3873, -1.45538293934827),
(21299, '48326', 218, 27, 13307, 42.6802, 0.744910015409684, -83.2314, -1.45266197104441),
(21300, '48327', 218, 27, 790, 42.6458, 0.744309622146998, -83.4079, -1.45574247717418),
(21301, '48328', 218, 27, 790, 42.6461, 0.744314858134754, -83.3554, -1.45482617931688),
(21302, '48329', 218, 27, 790, 42.6885, 0.745054877737599, -83.3888, -1.45540911928705),
(21303, '48330', 218, 27, 130538, 42.6845, 0.74498506456752, -83.3767, -1.45519793444756),
(21304, '48331', 218, 27, 8849, 42.5101, 0.741941210352042, -83.4064, -1.4557162972354),
(21305, '48332', 218, 27, 8849, 42.4632, 0.741122650932856, -83.3768, -1.45519967977681),
(21306, '48333', 218, 27, 8849, 42.4647, 0.741148830871636, -83.3765, -1.45519444378905),
(21307, '48334', 218, 27, 8849, 42.5079, 0.741902813108498, -83.352, -1.45476683812231),
(21308, '48335', 218, 27, 8849, 42.4656, 0.741164538834904, -83.4025, -1.45564822939457),
(21309, '48336', 218, 27, 8849, 42.4604, 0.7410737817138, -83.3454, -1.45465164639168),
(21310, '48340', 218, 27, 28298, 42.6702, 0.744735482484484, -83.2914, -1.45370916859561),
(21311, '48341', 218, 27, 28298, 42.6251, 0.743948338991835, -83.294, -1.45375454715616),
(21312, '48342', 218, 27, 28298, 42.6445, 0.744286932866722, -83.2743, -1.45341071729351),
(21313, '48343', 218, 27, 28298, 42.6388, 0.744187449099358, -83.2908, -1.45369869662009),
(21314, '48346', 218, 27, 20075, 42.7236, 0.745667488305049, -83.4161, -1.45588559417284),
(21315, '48347', 218, 27, 20075, 42.736, 0.745883909132297, -83.4183, -1.45592399141639),
(21316, '48348', 218, 27, 20075, 42.7675, 0.746433687846675, -83.4007, -1.45561681346803),
(21317, '48350', 218, 27, 35517, 42.7422, 0.74599211954592, -83.5308, -1.45788748682488),
(21318, '48353', 218, 27, 165, 42.624, 0.743929140370063, -83.7086, -1.46099068223493),
(21319, '48356', 218, 27, 3108, 42.6509, 0.74439863393885, -83.5823, -1.45878633138966),
(21320, '48357', 218, 27, 3108, 42.6581, 0.744524297644993, -83.6362, -1.45972706385648),
(21321, '48359', 218, 27, 131649, 42.7206, 0.74561512842749, -83.2786, -1.45348576645135),
(21322, '48360', 218, 27, 131649, 42.7491, 0.746112547264308, -83.2674, -1.45329028957513),
(21323, '48361', 218, 27, 131649, 42.7844, 0.746728648490262, -83.2402, -1.45281556001858),
(21324, '48362', 218, 27, 131649, 42.7823, 0.74669199657597, -83.2705, -1.45334439478194),
(21325, '48363', 218, 27, 4710, 42.7653, 0.746395290603131, -83.1664, -1.45152750703061),
(21326, '48366', 218, 27, 16832, 42.8216, 0.747377910972004, -83.1507, -1.45125349033805),
(21327, '48367', 218, 27, 3733, 42.844, 0.747768864724451, -83.1401, -1.45106848543734),
(21328, '48370', 218, 27, 4828, 42.8412, 0.747719995505395, -83.2004, -1.45212091897629),
(21329, '48371', 218, 27, 4828, 42.8378, 0.747660654310827, -83.2886, -1.45366029937655),
(21330, '48374', 218, 27, 132361, 42.4716, 0.741269258590024, -83.5202, -1.45770248192417),
(21331, '48375', 218, 27, 132361, 42.4626, 0.741112178957344, -83.4613, -1.45667448299474),
(21332, '48376', 218, 27, 132361, 42.4876, 0.741548511270343, -83.4755, -1.45692231974853),
(21333, '48377', 218, 27, 132361, 42.5088, 0.741918521071766, -83.4734, -1.45688566783423),
(21334, '48380', 218, 27, 10480, 42.5869, 0.743281623217573, -83.6505, -1.45997664593952),
(21335, '48381', 218, 27, 10480, 42.5729, 0.743037277122294, -83.5956, -1.45901846018017),
(21336, '48382', 218, 27, 0, 42.5935, 0.743396814948205, -83.4893, -1.4571631751853),
(21337, '48383', 218, 27, 70098, 42.6591, 0.744541750937513, -83.5418, -1.4580794730426),
(21338, '48386', 218, 27, 70098, 42.6403, 0.744213629038138, -83.4721, -1.45686297855396),
(21339, '48387', 218, 27, 133476, 42.6147, 0.743766824749628, -83.4473, -1.45643013689946),
(21340, '48390', 218, 27, 133566, 42.5523, 0.742677739296383, -83.4766, -1.4569415183703),
(21341, '48391', 218, 27, 133566, 42.534, 0.742358344043268, -83.4782, -1.45696944363833),
(21342, '48393', 218, 27, 133777, 42.5204, 0.742120979264997, -83.5419, -1.45808121837185),
(21343, '48397', 218, 27, 12663, 42.5004, 0.741771913414598, -83.0462, -1.44942962126971),
(21344, '48398', 218, 27, 93282, 42.5372, 0.742414194579332, -83.1514, -1.45126570764281),
(21345, '48401', 218, 27, 26384, 43.3542, 0.756673534568126, -82.6463, -1.44245004959099),
(21346, '48410', 218, 27, 15022, 43.5634, 0.760324763363298, -82.928, -1.44736664209386),
(21347, '48411', 218, 27, 26413, 42.9322, 0.74930824512471, -83.5479, -1.45818593812697),
(21348, '48412', 218, 27, 7188, 43.0627, 0.751585899798562, -83.1658, -1.4515170350551),
(21349, '48413', 218, 27, 129636, 43.8059, 0.764557186799384, -82.9975, -1.44857964592399),
(21350, '48414', 218, 27, 19038, 42.8676, 0.748180762427921, -84.0757, -1.467397785919),
(21351, '48415', 218, 27, 129835, 43.2684, 0.755176042069915, -83.7962, -1.46251959065967),
(21352, '48416', 218, 27, 129968, 43.2291, 0.754490127673881, -82.949, -1.44773316123678),
(21353, '48417', 218, 27, 58842, 43.2565, 0.754968347888927, -83.9345, -1.46493338101518),
(21354, '48418', 218, 27, 7810, 42.8113, 0.747198142059048, -83.9806, -1.46573797780035),
(21355, '48419', 218, 27, 19818, 43.4365, 0.758109940542517, -82.6339, -1.44223362876374),
(21356, '48420', 218, 27, 1632, 43.1756, 0.753556376524064, -83.7204, -1.46119663108666),
(21357, '48421', 218, 27, 130308, 43.1538, 0.753175894747129, -83.3839, -1.4553235981537),
(21358, '48422', 218, 27, 130374, 43.2643, 0.755104483570583, -82.636, -1.44227028067803),
(21359, '48423', 218, 27, 20482, 43.031, 0.75103263042568, -83.5227, -1.45774611515547),
(21360, '48426', 218, 27, 29617, 43.5045, 0.759296764433873, -83.0633, -1.44972807257181),
(21361, '48427', 218, 27, 8447, 43.5309, 0.7597575313564, -82.706, -1.44349201115443),
(21362, '48428', 218, 27, 8610, 42.936, 0.749374567636285, -83.1437, -1.45113131729041),
(21363, '48429', 218, 27, 20717, 42.9098, 0.748917291372263, -83.9942, -1.46597534257862),
(21364, '48430', 218, 27, 2431, 42.8152, 0.747266209899876, -83.7151, -1.46110412863631),
(21365, '48432', 218, 27, 130794, 43.9032, 0.766255392161574, -82.998, -1.44858837257025),
(21366, '48433', 218, 27, 113299, 43.0695, 0.751704582187698, -83.8398, -1.46328055421354),
(21367, '48434', 218, 27, 35957, 43.661, 0.762028204713244, -82.6109, -1.44183220303578),
(21368, '48435', 218, 27, 2568, 43.2612, 0.755050378363771, -83.3818, -1.45528694623941),
(21369, '48436', 218, 27, 54893, 42.8683, 0.748192979732685, -83.8784, -1.46395425130481),
(21370, '48437', 218, 27, 130966, 43.1034, 0.752296248804124, -83.6399, -1.45979164103881),
(21371, '48438', 218, 27, 9157, 42.9103, 0.748926018018523, -83.5084, -1.45749653307243),
(21372, '48439', 218, 27, 131055, 42.9253, 0.749187817406322, -83.6371, -1.45974277181975),
(21373, '48440', 218, 27, 27352, 42.9527, 0.749666037621368, -83.4043, -1.45567964532111),
(21374, '48441', 218, 27, 16343, 43.8097, 0.76462350931096, -82.6891, -1.44319705051084),
(21375, '48442', 218, 27, 41376, 42.7898, 0.74682289626987, -83.6078, -1.45923139034891),
(21376, '48444', 218, 27, 131425, 43.0558, 0.751465472080175, -83.0682, -1.44981359370515),
(21377, '48445', 218, 27, 131579, 43.9503, 0.767077442239264, -83.003, -1.44867563903285),
(21378, '48446', 218, 27, 131692, 43.0557, 0.751463726750923, -83.3296, -1.45437588436987),
(21379, '48449', 218, 27, 131740, 42.9957, 0.750416529199726, -83.9523, -1.46524404962204),
(21380, '48450', 218, 27, 3748, 43.2466, 0.75479556029298, -82.5309, -1.44043593963419),
(21381, '48451', 218, 27, 3784, 42.8124, 0.74721734068082, -83.799, -1.46256845987873),
(21382, '48453', 218, 27, 131949, 43.3397, 0.756420461826586, -83.0384, -1.44929348558806),
(21383, '48454', 218, 27, 4160, 43.2001, 0.753983982190802, -82.8202, -1.44548517716021),
(21384, '48455', 218, 27, 30492, 42.9442, 0.749517684634949, -83.3066, -1.45397445864191),
(21385, '48456', 218, 27, 132124, 43.6663, 0.7621207071636, -82.7398, -1.4440819324416),
(21386, '48457', 218, 27, 4299, 43.1804, 0.75364015232816, -83.8812, -1.46400312052387),
(21387, '48458', 218, 27, 78784, 43.1161, 0.752517905619127, -83.687, -1.46061369111649),
(21388, '48460', 218, 27, 132269, 43.1099, 0.752409695205503, -83.9981, -1.46604341041945),
(21389, '48461', 218, 27, 37450, 43.208, 0.75412186320171, -83.2131, -1.45234257579129),
(21390, '48462', 218, 27, 117155, 42.8394, 0.747688579578859, -83.4282, -1.45609677901233),
(21391, '48463', 218, 27, 132475, 43.1574, 0.753238726600201, -83.5193, -1.4576867739609),
(21392, '48464', 218, 27, 132485, 43.2125, 0.75420040301805, -83.4235, -1.45601474853749),
(21393, '48465', 218, 27, 132513, 43.6152, 0.761228843915831, -82.6932, -1.44326860901018),
(21394, '48466', 218, 27, 17560, 43.273, 0.755256327215506, -82.8118, -1.44533856950304),
(21395, '48467', 218, 27, 132692, 44.0185, 0.768267756789124, -83.001, -1.44864073244781),
(21396, '48468', 218, 27, 132696, 43.9438, 0.766963995837884, -82.7789, -1.44476435617913),
(21397, '48469', 218, 27, 132702, 43.4763, 0.758804581584811, -82.5726, -1.44116374193227),
(21398, '48470', 218, 27, 5588, 43.7309, 0.763248189860388, -82.7517, -1.44428962662259),
(21399, '48471', 218, 27, 5646, 43.4184, 0.757794035947906, -82.848, -1.44597037869226),
(21400, '48472', 218, 27, 133149, 43.5187, 0.759544601187656, -82.9569, -1.44787104224768),
(21401, '48473', 218, 27, 133338, 42.9507, 0.749631131036329, -83.82, -1.46293497902165),
(21402, '48475', 218, 27, 133470, 43.7149, 0.762968937180069, -82.9423, -1.44761622417689),
(21403, '48476', 218, 27, 6535, 42.9389, 0.749425182184593, -84.0287, -1.46657748117056),
(21404, '48501', 218, 27, 21143, 42.9663, 0.74990340239964, -83.7769, -1.46218274211404),
(21405, '48502', 218, 27, 21143, 43.0147, 0.750748141757605, -83.69, -1.46066605099405),
(21406, '48503', 218, 27, 21143, 43.0128, 0.750714980501817, -83.6899, -1.4606643056648),
(21407, '48504', 218, 27, 21143, 43.0377, 0.751149567485564, -83.7438, -1.46160503813163),
(21408, '48505', 218, 27, 21143, 43.0634, 0.751598117103326, -83.6942, -1.46073935482264),
(21409, '48506', 218, 27, 21143, 43.0503, 0.751369478971315, -83.6352, -1.45970961056396),
(21410, '48507', 218, 27, 21143, 42.9724, 0.750009867484011, -83.7044, -1.46091737840634),
(21411, '48509', 218, 27, 7796, 43.0237, 0.750905221390284, -83.6049, -1.45918077580061),
(21412, '48519', 218, 27, 7796, 42.9891, 0.750301337469094, -83.6136, -1.45933261944553),
(21413, '48529', 218, 27, 7796, 42.9726, 0.750013358142515, -83.6639, -1.46021052005928),
(21414, '48531', 218, 27, 21143, 43.0555, 0.751460236092419, -83.7498, -1.46170975788675),
(21415, '48532', 218, 27, 21143, 43.0097, 0.750660875295005, -83.7733, -1.46211991026097),
(21416, '48550', 218, 27, 21143, 43.0677, 0.751673166261162, -83.6891, -1.46065034303079),
(21417, '48551', 218, 27, 21143, 42.9904, 0.75032402674937, -83.7133, -1.46107271270977),
(21418, '48552', 218, 27, 21143, 42.9907, 0.750329262737126, -83.7137, -1.46107969402678),
(21419, '48553', 218, 27, 21143, 42.9738, 0.750034302093539, -83.7185, -1.46116346983087),
(21420, '48554', 218, 27, 21143, 42.9388, 0.749423436855341, -83.8241, -1.46300653752098),
(21421, '48555', 218, 27, 21143, 43.0558, 0.751465472080175, -83.7484, -1.46168532327722),
(21422, '48556', 218, 27, 21143, 43.0678, 0.751674911590414, -83.6263, -1.45955427626053),
(21423, '48557', 218, 27, 21143, 42.9873, 0.750269921542558, -83.6765, -1.46043043154504),
(21424, '48559', 218, 27, 21143, 43.023, 0.750893004085521, -83.6927, -1.46071317488386),
(21425, '48601', 218, 27, 5602, 43.4087, 0.757624739010463, -83.9042, -1.46440454625183),
(21426, '48602', 218, 27, 5602, 43.4243, 0.757897010373774, -83.974, -1.46562278606972),
(21427, '48603', 218, 27, 5602, 43.435, 0.758083760603737, -84.0308, -1.46661413308485),
(21428, '48604', 218, 27, 5602, 43.4735, 0.758755712365755, -83.9498, -1.46520041639074),
(21429, '48605', 218, 27, 5602, 43.4588, 0.758499148965712, -84.0519, -1.46698239755702),
(21430, '48606', 218, 27, 5602, 43.4321, 0.758033146055429, -83.9338, -1.46492116371042),
(21431, '48607', 218, 27, 5602, 43.4318, 0.758027910067673, -83.9335, -1.46491592772266),
(21432, '48608', 218, 27, 5602, 43.4394, 0.758160555090825, -84.029, -1.46658271715832),
(21433, '48609', 218, 27, 5602, 43.412, 0.757682334875778, -84.0871, -1.46759675345372),
(21434, '48610', 218, 27, 34526, 44.126, 0.770143985735018, -84.0869, -1.46759326279522),
(21435, '48611', 218, 27, 13306, 43.6182, 0.761281203793391, -84.0888, -1.46762642405101),
(21436, '48612', 218, 27, 134, 43.876, 0.765780662605032, -84.4185, -1.47338077459483),
(21437, '48613', 218, 27, 31801, 43.9361, 0.766829605485481, -84.1151, -1.46808544564428),
(21438, '48614', 218, 27, 129914, 43.2482, 0.754823485561012, -84.2947, -1.47122005698086),
(21439, '48615', 218, 27, 26597, 43.3907, 0.757310579745104, -84.4826, -1.47449953064536),
(21440, '48616', 218, 27, 130187, 43.1943, 0.753882753094187, -84.117, -1.46811860690007),
(21441, '48617', 218, 27, 32072, 43.8619, 0.765534571180501, -84.7355, -1.47891346832366),
(21442, '48618', 218, 27, 1693, 43.743, 0.76345937469988, -84.5477, -1.47563573998841),
(21443, '48619', 218, 27, 0, 44.8012, 0.781928448844484, -84.0358, -1.46670139954745),
(21444, '48620', 218, 27, 78192, 43.8, 0.764454212373516, -84.3898, -1.47287986509951),
(21445, '48621', 218, 27, 500, 44.723, 0.780563601369424, -84.0377, -1.46673456080324),
(21446, '48622', 218, 27, 75816, 43.8621, 0.765538061839005, -84.8657, -1.48118588700975),
(21447, '48623', 218, 27, 40997, 43.5033, 0.759275820482849, -84.128, -1.46831059311779),
(21448, '48624', 218, 27, 109375, 44.0392, 0.768629039944287, -84.4569, -1.4740509810276),
(21449, '48625', 218, 27, 9353, 44.0407, 0.768655219883067, -84.8056, -1.4801369441293),
(21450, '48626', 218, 27, 72876, 43.4106, 0.75765790026625, -84.2221, -1.46995294794392),
(21451, '48627', 218, 27, 131300, 44.4445, 0.77570285940262, -84.7454, -1.4790862559196),
(21452, '48628', 218, 27, 665, 43.7796, 0.76409816520611, -84.3333, -1.47189375407213),
(21453, '48629', 218, 27, 131368, 44.3248, 0.773613700287983, -84.7376, -1.47895012023795),
(21454, '48630', 218, 27, 131369, 44.326, 0.773634644239007, -84.7736, -1.47957843876867),
(21455, '48631', 218, 27, 131539, 43.6772, 0.762310948052067, -83.9905, -1.4659107653963),
(21456, '48632', 218, 27, 36776, 43.8972, 0.766150672406455, -85.0027, -1.48357698808498),
(21457, '48633', 218, 27, 131640, 43.9797, 0.76759056903935, -84.9068, -1.48190321733232),
(21458, '48634', 218, 27, 3793, 43.7474, 0.763536169186967, -84.0379, -1.46673805146174),
(21459, '48635', 218, 27, 3905, 44.4005, 0.774934914531742, -83.9906, -1.46591251072555),
(21460, '48636', 218, 27, 37003, 44.6352, 0.779031202286173, -84.2518, -1.47047131073176),
(21461, '48637', 218, 27, 49421, 43.3997, 0.757467659377783, -84.3245, -1.47174016509796),
(21462, '48640', 218, 27, 10461, 43.6278, 0.761448755401582, -84.2741, -1.47086051915495),
(21463, '48641', 218, 27, 10461, 43.5791, 0.760598780055861, -84.3568, -1.47230390644635),
(21464, '48642', 218, 27, 10461, 43.6341, 0.761558711144458, -84.2029, -1.46961784472753),
(21465, '48647', 218, 27, 132128, 44.6594, 0.779453571965156, -84.1143, -1.46807148301027),
(21466, '48649', 218, 27, 818, 43.1516, 0.753137497503585, -84.2012, -1.46958817413025),
(21467, '48650', 218, 27, 132614, 43.8491, 0.765311169036246, -83.9938, -1.46596836126161),
(21468, '48651', 218, 27, 132738, 44.2964, 0.773118026780416, -84.6626, -1.47764112329895),
(21469, '48652', 218, 27, 210, 43.8694, 0.7656654708744, -84.2154, -1.46983601088403),
(21470, '48653', 218, 27, 132900, 44.4663, 0.776083341179554, -84.6769, -1.47789070538199),
(21471, '48654', 218, 27, 11675, 44.4336, 0.775512618514152, -84.1207, -1.46818318408239),
(21472, '48655', 218, 27, 11748, 43.2926, 0.755598411748897, -84.1638, -1.46893542099),
(21473, '48656', 218, 27, 132962, 44.3649, 0.774313577318032, -84.4307, -1.47359370476358),
(21474, '48657', 218, 27, 188, 43.701, 0.762726336414042, -84.3953, -1.47297585820837),
(21475, '48658', 218, 27, 57699, 43.9772, 0.76754693580805, -83.9351, -1.46494385299069),
(21476, '48659', 218, 27, 25116, 44.0628, 0.769040937647757, -84.0269, -1.46654606524402),
(21477, '48661', 218, 27, 118384, 44.2884, 0.772978400440257, -84.2159, -1.46984473753029),
(21478, '48662', 218, 27, 6759, 43.3914, 0.757322797049867, -84.4147, -1.47331445208326),
(21479, '48663', 218, 27, 5602, 43.4201, 0.75782370654519, -83.9491, -1.46518819908597),
(21480, '48667', 218, 27, 10461, 43.6083, 0.761108416197443, -84.2388, -1.470244417929),
(21481, '48670', 218, 27, 10461, 43.6344, 0.761563947132214, -84.2575, -1.47057079449912),
(21482, '48674', 218, 27, 10461, 43.7076, 0.762841528144674, -84.2325, -1.47013446218612),
(21483, '48686', 218, 27, 10461, 43.5978, 0.760925156625984, -84.2077, -1.46970162053163),
(21484, '48701', 218, 27, 215, 43.5879, 0.760752369030036, -83.5486, -1.45819815543173),
(21485, '48703', 218, 27, 129593, 44.0614, 0.76901650303823, -83.6442, -1.45986669019664),
(21486, '48705', 218, 27, 129679, 44.6809, 0.779828817754334, -83.6304, -1.45962583475987),
(21487, '48706', 218, 27, 15113, 43.6093, 0.761125869489963, -83.9211, -1.46469950689541),
(21488, '48707', 218, 27, 15113, 43.5299, 0.75974007806388, -83.8417, -1.46331371546933),
(21489, '48708', 218, 27, 15113, 43.582, 0.760649394604169, -83.868, -1.4637727370626),
(21490, '48710', 218, 27, 107059, 43.5621, 0.760302074083022, -83.989, -1.46588458545752),
(21491, '48720', 218, 27, 129703, 43.83, 0.764977811149115, -83.351, -1.45474938482979),
(21492, '48721', 218, 27, 129848, 44.7975, 0.78186387166216, -83.3248, -1.45429210856577),
(21493, '48722', 218, 27, 1130, 43.3505, 0.756608957385802, -83.8518, -1.46348999372378),
(21494, '48723', 218, 27, 93064, 43.4878, 0.75900529444879, -83.3882, -1.45539864731154),
(21495, '48724', 218, 27, 1380, 43.4599, 0.758518347587484, -83.9282, -1.4648234252723),
(21496, '48725', 218, 27, 130107, 43.949, 0.767054752958988, -83.2336, -1.45270036828795),
(21497, '48726', 218, 27, 130114, 43.5914, 0.760813455553856, -83.1979, -1.45207728574499),
(21498, '48727', 218, 27, 695, 43.3049, 0.755813087246892, -83.1777, -1.45172472923609),
(21499, '48728', 218, 27, 26901, 44.7266, 0.780626433222496, -83.8084, -1.46273252082842),
(21500, '48729', 218, 27, 130461, 43.4934, 0.759103032886902, -83.1825, -1.45180850504018),
(21501, '48730', 218, 27, 130594, 44.307, 0.773303031681128, -83.47, -1.45682632663967),
(21502, '48731', 218, 27, 15918, 43.8319, 0.765010972404902, -83.1606, -1.451426277934),
(21503, '48732', 218, 27, 130704, 43.6053, 0.761056056319883, -83.8205, -1.46294370566791),
(21504, '48733', 218, 27, 64617, 43.5354, 0.759836071172739, -83.5945, -1.4589992615584),
(21505, '48734', 218, 27, 130875, 43.3394, 0.75641522583883, -83.7476, -1.4616713606432),
(21506, '48735', 218, 27, 130930, 43.652, 0.761871125080565, -83.2745, -1.45341420795202),
(21507, '48736', 218, 27, 127565, 43.494, 0.759113504862414, -83.6126, -1.45931516615301),
(21508, '48737', 218, 27, 131019, 44.551, 0.777561635055994, -83.7062, -1.46094879433288),
(21509, '48738', 218, 27, 32623, 44.5636, 0.777781546541745, -83.3297, -1.45437762969912),
(21510, '48739', 218, 27, 32661, 44.4012, 0.774947131836506, -83.8138, -1.46282676860802),
(21511, '48740', 218, 27, 2996, 44.6583, 0.779434373343384, -83.3579, -1.45486981254818),
(21512, '48741', 218, 27, 3542, 43.4047, 0.757554925840383, -83.1789, -1.45174567318711),
(21513, '48742', 218, 27, 3781, 44.7312, 0.780706718368088, -83.4376, -1.45626083996202),
(21514, '48743', 218, 27, 60680, 44.4323, 0.775489929233877, -83.8746, -1.46388792879324),
(21515, '48744', 218, 27, 71100, 43.3543, 0.756675279897378, -83.3641, -1.4549780229618),
(21516, '48745', 218, 27, 132094, 44.578, 0.778032873954032, -83.4574, -1.45660641515392),
(21517, '48746', 218, 27, 49512, 43.2773, 0.755331376373342, -83.5402, -1.45805154777457),
(21518, '48747', 218, 27, 27990, 43.525, 0.759654556930532, -83.7553, -1.46180575099561),
(21519, '48748', 218, 27, 28003, 44.3027, 0.773227982523292, -83.6759, -1.46041995956952),
(21520, '48749', 218, 27, 132426, 44.0546, 0.768897820649094, -83.8939, -1.46422477733887),
(21521, '48750', 218, 27, 132464, 44.4483, 0.775769181914196, -83.3796, -1.45524854899586),
(21522, '48754', 218, 27, 132492, 43.7306, 0.763242953872632, -83.2446, -1.45289235450567),
(21523, '48755', 218, 27, 30826, 43.8524, 0.765368764901561, -83.2898, -1.45368124332757),
(21524, '48756', 218, 27, 5219, 44.2089, 0.771590863684921, -84.0065, -1.46619001807662),
(21525, '48757', 218, 27, 11530, 43.4655, 0.758616086025595, -83.6718, -1.46034840107019),
(21526, '48758', 218, 27, 5378, 43.4089, 0.757628229668967, -83.6752, -1.46040774226476),
(21527, '48759', 218, 27, 133037, 43.7348, 0.763316257701216, -83.4144, -1.45585592357556),
(21528, '48760', 218, 27, 31131, 43.3222, 0.756115029207488, -83.2478, -1.45294820504174),
(21529, '48761', 218, 27, 133173, 44.4771, 0.77627183673877, -83.9169, -1.46462620306683),
(21530, '48762', 218, 27, 57693, 44.7943, 0.781808021126096, -83.517, -1.4576466313881),
(21531, '48763', 218, 27, 133359, 44.2642, 0.772556030761274, -83.5647, -1.45847915344131),
(21532, '48764', 218, 27, 133359, 44.2741, 0.772728818357221, -83.5322, -1.45791192143441),
(21533, '48765', 218, 27, 6415, 44.1309, 0.770229506868366, -83.7175, -1.46114601653835),
(21534, '48766', 218, 27, 13237, 44.1222, 0.770077663223442, -83.8552, -1.46354933491835),
(21535, '48767', 218, 27, 25657, 43.6438, 0.761728008081901, -83.4724, -1.45686821454171),
(21536, '48768', 218, 27, 34255, 43.3702, 0.756952787248445, -83.5738, -1.45863797840324),
(21537, '48769', 218, 27, 28817, 43.3098, 0.75589860838024, -83.6146, -1.45935007273805),
(21538, '48770', 218, 27, 118463, 44.2363, 0.772069083899968, -83.8102, -1.46276393675495),
(21539, '48787', 218, 27, 130875, 43.3316, 0.756279090157175, -83.7382, -1.46150729969352),
(21540, '48801', 218, 27, 7066, 43.3763, 0.757059252332816, -84.6652, -1.4776865018595),
(21541, '48802', 218, 27, 7066, 43.3797, 0.757118593527384, -84.6548, -1.4775049876173),
(21542, '48804', 218, 27, 118, 43.6064, 0.761075254941655, -84.6888, -1.47809839956297),
(21543, '48805', 218, 27, 132408, 42.7079, 0.745393471612486, -84.4143, -1.47330747076625),
(21544, '48806', 218, 27, 13302, 43.1769, 0.75357906580434, -84.5048, -1.4748869937393),
(21545, '48807', 218, 27, 26443, 43.1424, 0.752976927212402, -84.4215, -1.47343313447239),
(21546, '48808', 218, 27, 19093, 42.8185, 0.747323805765192, -84.4588, -1.47408414228339),
(21547, '48809', 218, 27, 129742, 43.0782, 0.751856425832621, -85.2314, -1.48756855608429),
(21548, '48811', 218, 27, 58901, 43.181, 0.753650624303671, -84.8688, -1.48123999221656),
(21549, '48812', 218, 27, 1424, 43.4074, 0.757602049730187, -84.9763, -1.48311622116246),
(21550, '48813', 218, 27, 8042, 42.5744, 0.743063457061074, -84.8366, -1.48067799619742),
(21551, '48815', 218, 27, 848, 42.845, 0.74778631801697, -85.2471, -1.48784257277686),
(21552, '48816', 218, 27, 130279, 42.7588, 0.746281844201751, -83.9496, -1.46519692573223),
(21553, '48817', 218, 27, 122432, 43.0055, 0.750587571466421, -84.0671, -1.46724768760332),
(21554, '48818', 218, 27, 29586, 43.2709, 0.755219675301214, -84.9088, -1.48193812391736),
(21555, '48819', 218, 27, 130421, 42.5504, 0.742644578040595, -84.2819, -1.47099665483661),
(21556, '48820', 218, 27, 20499, 42.8465, 0.74781249795575, -84.5902, -1.47637750492051),
(21557, '48821', 218, 27, 130504, 42.648, 0.744348019390542, -84.6475, -1.4773775785819),
(21558, '48822', 218, 27, 2149, 42.9745, 0.750046519398303, -84.5325, -1.47537044994211),
(21559, '48823', 218, 27, 130588, 42.7438, 0.746020044813952, -84.4732, -1.47433546969567),
(21560, '48824', 218, 27, 130588, 42.6516, 0.744410851243614, -84.4925, -1.47467231824131),
(21561, '48825', 218, 27, 130588, 42.7243, 0.745679705609813, -84.4636, -1.47416791808748),
(21562, '48826', 218, 27, 130588, 42.7457, 0.74605320606974, -84.4842, -1.47452745591339),
(21563, '48827', 218, 27, 130605, 42.5093, 0.741927247718026, -84.6691, -1.47775456970033),
(21564, '48829', 218, 27, 115414, 43.3987, 0.757450206085263, -85.0266, -1.48399412177621),
(21565, '48830', 218, 27, 40798, 43.3637, 0.756839340847065, -84.8373, -1.48069021350219),
(21566, '48831', 218, 27, 35760, 43.0882, 0.752030958757821, -84.4278, -1.47354309021527),
(21567, '48832', 218, 27, 130672, 43.4076, 0.757605540388691, -84.7741, -1.47958716541493),
(21568, '48833', 218, 27, 2334, 43.1033, 0.752294503474872, -84.506, -1.47490793769033),
(21569, '48834', 218, 27, 35876, 43.1447, 0.753017069785198, -85.0489, -1.48438333019941),
(21570, '48835', 218, 27, 2578, 43.011, 0.750683564575281, -84.7484, -1.47913861579716),
(21571, '48836', 218, 27, 130869, 42.6649, 0.744642980034129, -84.07, -1.46729830215163),
(21572, '48837', 218, 27, 131063, 42.7435, 0.746014808826196, -84.7424, -1.47903389604204),
(21573, '48838', 218, 27, 2868, 43.1907, 0.753819921241115, -85.248, -1.48785828074013),
(21574, '48840', 218, 27, 131240, 42.7536, 0.746191087080648, -84.3936, -1.47294618761109),
(21575, '48841', 218, 27, 23, 43.1026, 0.752282286170108, -84.2271, -1.47004021440652),
(21576, '48842', 218, 27, 3208, 42.6428, 0.744257262269438, -84.5279, -1.47529016479651),
(21577, '48843', 218, 27, 9597, 42.6217, 0.743888997797267, -83.9182, -1.46464889234711),
(21578, '48844', 218, 27, 9597, 42.607, 0.743632434397224, -83.9294, -1.46484436922333),
(21579, '48845', 218, 27, 125114, 43.0942, 0.75213567851294, -84.8641, -1.48115796174172),
(21580, '48846', 218, 27, 9664, 42.9872, 0.750268176213306, -85.0656, -1.48467480018449),
(21581, '48847', 218, 27, 22194, 43.2736, 0.755266799191018, -84.5914, -1.47639844887153),
(21582, '48848', 218, 27, 131627, 42.885, 0.748484449717768, -84.3269, -1.47178205300001),
(21583, '48849', 218, 27, 131648, 42.8037, 0.747065497035897, -85.1398, -1.48596983448947),
(21584, '48850', 218, 27, 3619, 43.4272, 0.757947624922081, -85.2505, -1.48790191397143),
(21585, '48851', 218, 27, 764, 42.9591, 0.749777738693496, -84.9437, -1.48254724382631),
(21586, '48852', 218, 27, 0, 43.3527, 0.756647354629346, -85.0492, -1.48438856618716),
(21587, '48853', 218, 27, 131915, 43.1033, 0.752294503474872, -84.6919, -1.47815250476979),
(21588, '48854', 218, 27, 17048, 42.5839, 0.743229263340013, -84.4402, -1.47375951104252),
(21589, '48855', 218, 27, 9597, 42.6217, 0.743888997797267, -83.9178, -1.4646419110301),
(21590, '48856', 218, 27, 4185, 43.197, 0.753929876983991, -84.7376, -1.47895012023795),
(21591, '48857', 218, 27, 132176, 42.8416, 0.747726976822403, -84.1624, -1.46891098638048),
(21592, '48858', 218, 27, 118, 43.6009, 0.760979261832796, -84.7881, -1.4798315115102),
(21593, '48859', 218, 27, 118, 43.5965, 0.760902467345708, -84.7788, -1.47966919588977),
(21594, '48860', 218, 27, 10705, 43.0322, 0.751053574376704, -84.9198, -1.48213011013508),
(21595, '48861', 218, 27, 132203, 42.7253, 0.745697158902333, -84.9227, -1.48218072468339),
(21596, '48862', 218, 27, 14314, 43.2478, 0.754816504244004, -84.5437, -1.47556592681833),
(21597, '48863', 218, 27, 4662, 42.6995, 0.745246863955319, -83.9301, -1.46485658652809),
(21598, '48864', 218, 27, 132408, 42.7078, 0.745391726283234, -84.4206, -1.47341742650912),
(21599, '48865', 218, 27, 28158, 43.0863, 0.751997797502033, -85.1174, -1.48557888073702),
(21600, '48866', 218, 27, 132491, 43.0056, 0.750589316795673, -84.3981, -1.47302472742743),
(21601, '48867', 218, 27, 132493, 43.0022, 0.750529975601106, -84.1803, -1.46922340031658),
(21602, '48870', 218, 27, 117221, 43.1096, 0.752404459217747, -84.9849, -1.48326631947813),
(21603, '48871', 218, 27, 132583, 43.1571, 0.753233490612445, -84.681, -1.47796226388132),
(21604, '48872', 218, 27, 11148, 42.8142, 0.747248756607356, -84.2272, -1.47004195973577),
(21605, '48873', 218, 27, 132599, 42.9835, 0.750203599030983, -84.8579, -1.4810497513281),
(21606, '48874', 218, 27, 132685, 43.1842, 0.753706474839735, -84.6017, -1.47657821778449),
(21607, '48875', 218, 27, 5188, 42.8606, 0.748058589380282, -84.9298, -1.48230464306028),
(21608, '48876', 218, 27, 24101, 42.6398, 0.744204902391878, -84.737, -1.47893964826243),
(21609, '48877', 218, 27, 5416, 43.4012, 0.757493839316563, -84.8414, -1.48076177200152),
(21610, '48878', 218, 27, 132911, 43.7143, 0.762958465204557, -84.7692, -1.47950164428158),
(21611, '48879', 218, 27, 28504, 43.0014, 0.75051601296709, -84.5747, -1.47610697888645),
(21612, '48880', 218, 27, 24604, 43.411, 0.757664881583258, -84.5976, -1.47650665928516),
(21613, '48881', 218, 27, 24673, 42.9261, 0.749201780040338, -85.2094, -1.48718458364886),
(21614, '48882', 218, 27, 133062, 42.8093, 0.747163235474009, -84.2931, -1.47119213171283),
(21615, '48883', 218, 27, 28589, 43.5222, 0.759605687711476, -84.7293, -1.47880525791003),
(21616, '48884', 218, 27, 11906, 43.2097, 0.754151533798994, -85.0552, -1.48449328594228),
(21617, '48885', 218, 27, 5844, 43.2524, 0.754896789389595, -85.1428, -1.48602219436703),
(21618, '48886', 218, 27, 133130, 43.4156, 0.75774516672885, -85.1602, -1.48632588165688),
(21619, '48887', 218, 27, 452, 43.0593, 0.751526558603994, -85.2623, -1.48810786282316),
(21620, '48888', 218, 27, 6052, 43.3047, 0.755809596588388, -85.1085, -1.48542354643359),
(21621, '48889', 218, 27, 18216, 43.2936, 0.755615865041417, -84.7974, -1.47999382713064),
(21622, '48890', 218, 27, 28734, 42.7498, 0.746124764569072, -84.9896, -1.48334834995297),
(21623, '48891', 218, 27, 133517, 43.395, 0.757385628902939, -84.9168, -1.48207775025752),
(21624, '48892', 218, 27, 98955, 42.6476, 0.744341038073534, -84.1776, -1.46917627642678),
(21625, '48893', 218, 27, 52573, 43.6708, 0.76219924697994, -84.9879, -1.48331867935569),
(21626, '48894', 218, 27, 31504, 42.9291, 0.749254139917898, -84.7985, -1.48001302575241),
(21627, '48895', 218, 27, 70213, 42.6912, 0.745102001627403, -84.2847, -1.47104552405566),
(21628, '48896', 218, 27, 6886, 43.5238, 0.759633612979508, -84.9021, -1.48182118685748),
(21629, '48897', 218, 27, 6917, 42.7076, 0.74538823562473, -85.1307, -1.48581100952754),
(21630, '48901', 218, 27, 9985, 42.7338, 0.745845511888753, -84.5524, -1.47571777046325),
(21631, '48906', 218, 27, 9985, 42.7677, 0.746437178505179, -84.5826, -1.47624485989736),
(21632, '48907', 218, 27, 9985, 42.7276, 0.745737301475129, -84.644, -1.47731649205808),
(21633, '48908', 218, 27, 9985, 42.7271, 0.745728574828869, -84.6434, -1.47730602008257),
(21634, '48909', 218, 27, 9985, 42.7339, 0.745847257218005, -84.5485, -1.47564970262243),
(21635, '48910', 218, 27, 9985, 42.7031, 0.745309695808391, -84.546, -1.47560606939113),
(21636, '48911', 218, 27, 9985, 42.6793, 0.744894307446416, -84.5652, -1.47594117260751),
(21637, '48912', 218, 27, 9985, 42.7368, 0.745897871766313, -84.5236, -1.47521511563868),
(21638, '48913', 218, 27, 9985, 42.674, 0.74480180499606, -84.6628, -1.47764461395746),
(21639, '48915', 218, 27, 9985, 42.7384, 0.745925797034344, -84.5709, -1.47604065637487),
(21640, '48916', 218, 27, 9985, 42.6738, 0.744798314337556, -84.5739, -1.47609301625243),
(21641, '48917', 218, 27, 9985, 42.733, 0.745831549254737, -84.6379, -1.47721002697371),
(21642, '48918', 218, 27, 9985, 42.6742, 0.744805295654564, -84.6767, -1.47788721472348),
(21643, '48919', 218, 27, 9985, 42.7292, 0.745765226743161, -84.5522, -1.47571427980475),
(21644, '48921', 218, 27, 9985, 42.7238, 0.745670978963553, -84.5564, -1.47578758363333),
(21645, '48922', 218, 27, 9985, 42.7327, 0.745826313266981, -84.5587, -1.47582772620613),
(21646, '48924', 218, 27, 9985, 42.6991, 0.745239882638311, -84.5266, -1.47526747551624),
(21647, '48929', 218, 27, 9985, 42.7326, 0.745824567937729, -84.5584, -1.47582249021837),
(21648, '48930', 218, 27, 9985, 42.7322, 0.745817586620721, -84.5583, -1.47582074488912),
(21649, '48933', 218, 27, 9985, 42.7314, 0.745803623986705, -84.5519, -1.47570904381699),
(21650, '48937', 218, 27, 9985, 42.7826, 0.746697232563726, -84.5702, -1.47602843907011),
(21651, '48950', 218, 27, 9985, 42.7247, 0.745686686926821, -84.6457, -1.47734616265536),
(21652, '48951', 218, 27, 9985, 42.7321, 0.745815841291469, -84.5561, -1.47578234764558),
(21653, '48956', 218, 27, 9985, 42.7328, 0.745828058596233, -84.5581, -1.47581725423062),
(21654, '48980', 218, 27, 9985, 42.675, 0.74481925828858, -84.6765, -1.47788372406498),
(21655, '49001', 218, 27, 9808, 42.2781, 0.737892046487415, -85.5482, -1.49309775915461),
(21656, '49002', 218, 27, 42669, 42.2078, 0.736665080023263, -85.5953, -1.4939198092323),
(21657, '49003', 218, 27, 9808, 42.3116, 0.738476731786833, -85.6835, -1.49545918963256),
(21658, '49004', 218, 27, 9808, 42.3273, 0.738750748479396, -85.5537, -1.49319375226347),
(21659, '49005', 218, 27, 9808, 42.2917, 0.738129411265686, -85.5798, -1.49364928319824),
(21660, '49006', 218, 27, 9808, 42.2948, 0.738183516472498, -85.6246, -1.49443119070314),
(21661, '49007', 218, 27, 9808, 42.3003, 0.738279509581357, -85.6078, -1.4941379753888),
(21662, '49008', 218, 27, 9808, 42.2601, 0.737577887222056, -85.6115, -1.49420255257113),
(21663, '49009', 218, 27, 9808, 42.2769, 0.737871102536391, -85.6889, -1.49555343741217),
(21664, '49010', 218, 27, 129474, 42.531, 0.742305984165708, -85.8695, -1.49870550204127),
(21665, '49011', 218, 27, 7182, 42.0983, 0.734753944492329, -85.222, -1.48740449513461),
(21666, '49012', 218, 27, 7193, 42.3575, 0.739277837913498, -85.3494, -1.48962804460165),
(21667, '49013', 218, 27, 34662, 42.3076, 0.738406918616753, -86.113, -1.50295537876988),
(21668, '49014', 218, 27, 79687, 42.3103, 0.738454042506557, -85.1057, -1.48537467721454),
(21669, '49015', 218, 27, 79687, 42.3028, 0.738323142812657, -85.2092, -1.48718109299035),
(21670, '49016', 218, 27, 79687, 42.3035, 0.738335360117421, -85.1717, -1.48652659452085),
(21671, '49017', 218, 27, 79687, 42.3279, 0.738761220454908, -85.1795, -1.48666273020251),
(21672, '49018', 218, 27, 79687, 42.3964, 0.739956770992524, -85.2201, -1.48737133387882),
(21673, '49019', 218, 27, 9808, 42.2746, 0.737830959963595, -85.5888, -1.49380636283092),
(21674, '49020', 218, 27, 146, 42.3956, 0.739942808358508, -85.2329, -1.48759473602308),
(21675, '49021', 218, 27, 270, 42.4644, 0.74114359488388, -85.0072, -1.48365552790132),
(21676, '49022', 218, 27, 19206, 42.1118, 0.734989563941348, -86.4057, -1.50806395749046),
(21677, '49023', 218, 27, 19206, 42.1085, 0.734931968076032, -86.465, -1.5090989377369),
(21678, '49024', 218, 27, 42669, 42.2017, 0.736558614938891, -85.5903, -1.4938325427697),
(21679, '49026', 218, 27, 13040, 42.3729, 0.739546618618305, -85.9682, -1.50042814201299),
(21680, '49027', 218, 27, 129920, 42.3519, 0.739180099475386, -86.0636, -1.50209318611939),
(21681, '49028', 218, 27, 15335, 41.8498, 0.730416801301123, -85.1906, -1.48685646174948),
(21682, '49029', 218, 27, 1239, 42.137, 0.735429386912851, -85.0898, -1.48509716986347),
(21683, '49030', 218, 27, 31927, 41.8565, 0.730533738361007, -85.3351, -1.48937846251861),
(21684, '49031', 218, 27, 130116, 41.9043, 0.73136800574346, -85.9875, -1.50076499055862),
(21685, '49032', 218, 27, 1472, 41.9233, 0.731699618301339, -85.502, -1.49229141704019),
(21686, '49033', 218, 27, 130147, 42.2276, 0.737010655215158, -85.0952, -1.48519141764308),
(21687, '49034', 218, 27, 20102, 42.2362, 0.737160753530829, -85.3461, -1.48957044873633),
(21688, '49035', 218, 27, 1638, 42.5513, 0.742660286003863, -85.3833, -1.49021971121807),
(21689, '49036', 218, 27, 1687, 41.9072, 0.731418620291768, -85.014, -1.48377421029046),
(21690, '49038', 218, 27, 29534, 42.2046, 0.736609229487199, -86.3283, -1.50671307264942),
(21691, '49039', 218, 27, 0, 42.2232, 0.73693386072807, -86.3739, -1.50750894278833),
(21692, '49040', 218, 27, 20173, 41.9568, 0.732284303600757, -85.3302, -1.48929294138527),
(21693, '49041', 218, 27, 130316, 42.2872, 0.738050871449346, -85.5105, -1.49243977002661),
(21694, '49042', 218, 27, 20218, 41.8514, 0.730444726569155, -85.6642, -1.49512234108693),
(21695, '49043', 218, 27, 32166, 42.2964, 0.73821144174053, -86.2699, -1.50569380036626),
(21696, '49045', 218, 27, 2007, 42.117, 0.735080321062452, -85.9995, -1.50097443006886),
(21697, '49046', 218, 27, 130473, 42.5134, 0.741998806217357, -85.4016, -1.49053910647119),
(21698, '49047', 218, 27, 130534, 41.9991, 0.73302257787435, -86.1108, -1.50291698152633),
(21699, '49048', 218, 27, 9808, 42.2914, 0.73812417527793, -85.5872, -1.49377843756289),
(21700, '49050', 218, 27, 93806, 42.5008, 0.741778894731606, -85.2401, -1.48772039972922),
(21701, '49051', 218, 27, 130590, 42.1908, 0.736368374050424, -85.2384, -1.48769072913193),
(21702, '49052', 218, 27, 2628, 42.1066, 0.734898806820244, -85.3377, -1.48942384107916),
(21703, '49053', 218, 27, 32506, 42.2906, 0.738110212643914, -85.418, -1.49082534046852),
(21704, '49055', 218, 27, 131024, 42.3646, 0.73940175629039, -85.8703, -1.49871946467529),
(21705, '49056', 218, 27, 87355, 42.3758, 0.739597233166613, -86.0595, -1.50202162762006),
(21706, '49057', 218, 27, 2998, 42.1963, 0.736464367159283, -86.1678, -1.50391181919997),
(21707, '49058', 218, 27, 16375, 42.6407, 0.744220610355146, -85.2971, -1.48871523740286),
(21708, '49060', 218, 27, 27426, 42.4343, 0.74061825077903, -85.4003, -1.49051641719091),
(21709, '49061', 218, 27, 3445, 41.8823, 0.730984033308021, -85.8266, -1.49795675579217),
(21710, '49062', 218, 27, 16702, 42.3619, 0.739354632400586, -85.8144, -1.49774382562342),
(21711, '49063', 218, 27, 16757, 42.4136, 0.740256967623867, -86.1302, -1.50325557540122),
(21712, '49064', 218, 27, 3696, 42.2197, 0.73687277420425, -86.0506, -1.50186629331663),
(21713, '49065', 218, 27, 22591, 42.147, 0.73560391983805, -85.8395, -1.49818190326567),
(21714, '49066', 218, 27, 95688, 42.032, 0.733596791198256, -85.3525, -1.48968214980846),
(21715, '49067', 218, 27, 37053, 42.0154, 0.733307066542426, -85.8351, -1.49810510877858),
(21716, '49068', 218, 27, 4011, 42.269, 0.737733221525483, -84.9447, -1.48256469711883),
(21717, '49069', 218, 27, 4011, 42.2691, 0.737734966854735, -84.9448, -1.48256644244808),
(21718, '49070', 218, 27, 882, 42.5381, 0.7424299025426, -85.632, -1.49456034506778),
(21719, '49071', 218, 27, 104066, 42.2323, 0.737092685690001, -85.7898, -1.49731447462743),
(21720, '49072', 218, 27, 56203, 42.008, 0.733177912177778, -85.4598, -1.49155488809585),
(21721, '49073', 218, 27, 10729, 42.5847, 0.743243225974029, -85.1214, -1.4856486939071),
(21722, '49074', 218, 27, 37361, 42.2897, 0.738094504680646, -85.602, -1.49403674629219),
(21723, '49075', 218, 27, 96632, 41.9191, 0.731626314472755, -85.4491, -1.49136813786589),
(21724, '49076', 218, 27, 28135, 42.4544, 0.740969061958681, -84.909, -1.48194161457587),
(21725, '49077', 218, 27, 132467, 42.259, 0.737558688600284, -85.6777, -1.49535796053595),
(21726, '49078', 218, 27, 110792, 42.4681, 0.741208172066204, -85.7141, -1.49599326038367),
(21727, '49079', 218, 27, 37604, 42.232, 0.737087449702245, -85.903, -1.49929018734069),
(21728, '49080', 218, 27, 132648, 42.4544, 0.740969061958681, -85.6291, -1.49450973051948),
(21729, '49081', 218, 27, 42669, 42.2054, 0.736623192121215, -85.5703, -1.4934834769193),
(21730, '49082', 218, 27, 17745, 41.947, 0.732113261334062, -84.8857, -1.48153495286015),
(21731, '49083', 218, 27, 5374, 42.379, 0.739653083702677, -85.4459, -1.49131228732982),
(21732, '49084', 218, 27, 5423, 42.1822, 0.736218275734752, -86.384, -1.50768522104278),
(21733, '49085', 218, 27, 488, 42.0685, 0.734233836375235, -86.4771, -1.50931012257639),
(21734, '49087', 218, 27, 133020, 42.1215, 0.735158860878791, -85.6697, -1.49521833419579),
(21735, '49088', 218, 27, 28555, 42.1855, 0.736275871600068, -85.4211, -1.49087944567533),
(21736, '49089', 218, 27, 14604, 42.0075, 0.733169185531518, -85.23, -1.48754412147477),
(21737, '49090', 218, 27, 34014, 42.3854, 0.739764784774804, -86.257, -1.50546865289275),
(21738, '49091', 218, 27, 38425, 41.812, 0.729757066843869, -85.4289, -1.49101558135698),
(21739, '49092', 218, 27, 133372, 42.1033, 0.734841210954928, -84.9803, -1.48318603433254),
(21740, '49093', 218, 27, 62020, 41.9601, 0.732341899466073, -85.6364, -1.49463713955487),
(21741, '49094', 218, 27, 12457, 42.0412, 0.73375736148944, -85.1157, -1.48554921013974),
(21742, '49095', 218, 27, 28848, 41.9035, 0.731354043109444, -85.8874, -1.49901791597738),
(21743, '49096', 218, 27, 133508, 42.6334, 0.744093201319751, -85.0148, -1.48378817292448),
(21744, '49097', 218, 27, 18446, 42.1177, 0.735092538367216, -85.5037, -1.49232108763748),
(21745, '49098', 218, 27, 113225, 42.1895, 0.736345684770148, -86.2566, -1.50546167157574),
(21746, '49099', 218, 27, 121969, 41.791, 0.72939054770095, -85.6583, -1.49501936666106),
(21747, '49101', 218, 27, 129674, 41.9456, 0.732088826724533, -86.4849, -1.50944625825804),
(21748, '49102', 218, 27, 129793, 41.9552, 0.732256378332725, -86.275, -1.50578281215811),
(21749, '49103', 218, 27, 129791, 41.942, 0.732025994871462, -86.3531, -1.50714591430392),
(21750, '49104', 218, 27, 129791, 41.9478, 0.732127223968077, -86.3403, -1.50692251215966),
(21751, '49106', 218, 27, 129938, 41.9391, 0.731975380323154, -86.5533, -1.51064006346641),
(21752, '49107', 218, 27, 15362, 41.8412, 0.730266702985451, -86.3902, -1.50779343145641),
(21753, '49111', 218, 27, 80820, 42.0175, 0.733343718456717, -86.2985, -1.50619296453233),
(21754, '49112', 218, 27, 130633, 41.7971, 0.729497012785322, -86.0416, -1.50170921368395),
(21755, '49113', 218, 27, 130936, 41.7986, 0.729523192724102, -86.5123, -1.50992447847309),
(21756, '49115', 218, 27, 131200, 41.8773, 0.730896766845421, -86.6306, -1.5119892029782),
(21757, '49116', 218, 27, 9948, 41.8482, 0.730388876033091, -86.67, -1.51267686270349),
(21758, '49117', 218, 27, 117000, 41.7859, 0.729301535909099, -86.7547, -1.51415515657992),
(21759, '49119', 218, 27, 132273, 41.8768, 0.730888040199161, -86.5498, -1.51057897694259),
(21760, '49120', 218, 27, 17280, 41.8212, 0.729917637135053, -86.2588, -1.50550006881928),
(21761, '49121', 218, 27, 17280, 41.8275, 0.730027592877928, -86.2537, -1.50541105702743),
(21762, '49125', 218, 27, 33898, 41.8899, 0.731116678331173, -86.5943, -1.51135564845973),
(21763, '49126', 218, 27, 133157, 42.0369, 0.733682312331604, -86.3686, -1.50741644033797),
(21764, '49127', 218, 27, 51694, 42.0178, 0.733348954444473, -86.5152, -1.5099750930214),
(21765, '49128', 218, 27, 18339, 41.8261, 0.7300031582684, -86.6154, -1.5117239129319),
(21766, '49129', 218, 27, 133477, 41.8285, 0.730045046170448, -86.6899, -1.51302418322463),
(21767, '49130', 218, 27, 455, 41.7851, 0.729287573275083, -85.8498, -1.49836167217863),
(21768, '49201', 218, 27, 3384, 42.2453, 0.737319578492761, -84.3835, -1.47276990935664),
(21769, '49202', 218, 27, 3384, 42.2638, 0.73764246440438, -84.4129, -1.47328303615672),
(21770, '49203', 218, 27, 3384, 42.2249, 0.736963531325354, -84.4088, -1.47321147765739),
(21771, '49204', 218, 27, 3384, 42.3308, 0.738811835003216, -84.5154, -1.47507199864002),
(21772, '49220', 218, 27, 34507, 42.0017, 0.733067956434902, -84.3222, -1.47170002252516),
(21773, '49221', 218, 27, 18746, 41.9041, 0.731364515084956, -84.0471, -1.46689862175293),
(21774, '49224', 218, 27, 7043, 42.2599, 0.737574396563552, -84.7612, -1.47936201794142),
(21775, '49227', 218, 27, 18798, 41.951, 0.732183074504141, -84.769, -1.47949815362307),
(21776, '49228', 218, 27, 129858, 41.8212, 0.729917637135053, -83.8741, -1.46387920214698),
(21777, '49229', 218, 27, 45111, 41.985, 0.732776486449819, -83.8375, -1.46324041164075),
(21778, '49230', 218, 27, 1157, 42.1039, 0.734851682930441, -84.2448, -1.47034913768412),
(21779, '49232', 218, 27, 1304, 41.7419, 0.728533591038221, -84.6535, -1.47748229833702),
(21780, '49233', 218, 27, 53948, 42.0536, 0.733973782316687, -84.3806, -1.47271929480833),
(21781, '49234', 218, 27, 130237, 42.1213, 0.735155370220288, -84.3485, -1.47215904411844),
(21782, '49235', 218, 27, 608, 41.866, 0.730699544639946, -84.2113, -1.4697644523847);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(21783, '49236', 218, 27, 1630, 42.0673, 0.734212892424211, -83.9565, -1.46531735345062),
(21784, '49237', 218, 27, 698, 42.1737, 0.736069922748332, -84.6485, -1.47739503187442),
(21785, '49238', 218, 27, 8455, 41.8952, 0.731209180781528, -83.7981, -1.46255275191546),
(21786, '49239', 218, 27, 130915, 41.7932, 0.729428944944494, -84.6256, -1.47699535147571),
(21787, '49240', 218, 27, 60091, 42.2829, 0.73797582229151, -84.2002, -1.46957072083773),
(21788, '49241', 218, 27, 2963, 42.1032, 0.734839465625677, -84.6018, -1.47657996311374),
(21789, '49242', 218, 27, 3147, 41.9002, 0.731296447244128, -84.623, -1.47694997291516),
(21790, '49245', 218, 27, 22029, 42.1496, 0.735649298398602, -84.8115, -1.48023991855517),
(21791, '49246', 218, 27, 468, 42.122, 0.735167587525052, -84.5016, -1.47483114320324),
(21792, '49247', 218, 27, 16505, 41.8534, 0.730479633154195, -84.3316, -1.47186408347485),
(21793, '49248', 218, 27, 738, 41.7693, 0.729011811253268, -84.0077, -1.46621096202764),
(21794, '49249', 218, 27, 9752, 42.042, 0.733771324123456, -84.4446, -1.4738363055296),
(21795, '49250', 218, 27, 3455, 42.0098, 0.733209328104314, -84.6331, -1.47712625116961),
(21796, '49251', 218, 27, 10047, 42.4672, 0.741192464102936, -84.4194, -1.4733964825581),
(21797, '49252', 218, 27, 27727, 42.035, 0.733649151075816, -84.7649, -1.47942659512374),
(21798, '49253', 218, 27, 131895, 41.9743, 0.732589736219856, -84.2784, -1.47093556831279),
(21799, '49254', 218, 27, 132079, 42.2275, 0.737008909885906, -84.3229, -1.47171223982993),
(21800, '49255', 218, 27, 4289, 41.7834, 0.729257902677799, -84.8818, -1.48146688501932),
(21801, '49256', 218, 27, 132168, 41.7441, 0.728571988281765, -84.2167, -1.46985870016431),
(21802, '49257', 218, 27, 4344, 42.0474, 0.733865571903064, -84.5092, -1.47496378822639),
(21803, '49258', 218, 27, 132182, 42.0589, 0.734066284767043, -84.6584, -1.47756781947037),
(21804, '49259', 218, 27, 132209, 42.3785, 0.739644357056417, -84.2603, -1.47061966371818),
(21805, '49261', 218, 27, 4479, 42.2472, 0.737352739748548, -84.4029, -1.47310850323152),
(21806, '49262', 218, 27, 125578, 41.9629, 0.732390768685128, -84.4929, -1.47467929955832),
(21807, '49263', 218, 27, 10862, 42.1611, 0.735850011262581, -84.1867, -1.46933510138871),
(21808, '49264', 218, 27, 132434, 42.4519, 0.740925428727381, -84.5509, -1.47569159052447),
(21809, '49265', 218, 27, 132438, 42.0146, 0.73329310390841, -84.1724, -1.46908551930567),
(21810, '49266', 218, 27, 132471, 41.8492, 0.730406329325611, -84.5478, -1.47563748531766),
(21811, '49267', 218, 27, 0, 41.7589, 0.72883029701106, -83.6921, -1.46070270290835),
(21812, '49268', 218, 27, 4846, 41.8703, 0.730774593797782, -83.9334, -1.46491418239341),
(21813, '49269', 218, 27, 11084, 42.2776, 0.737883319841155, -84.5848, -1.4762832571409),
(21814, '49270', 218, 27, 14402, 41.872, 0.730804264395066, -83.6837, -1.46055609525118),
(21815, '49271', 218, 27, 132642, 41.8388, 0.730224815083404, -84.4593, -1.47409286892965),
(21816, '49272', 218, 27, 123451, 42.3942, 0.73991837374898, -84.3454, -1.47210493891163),
(21817, '49274', 218, 27, 33727, 41.8457, 0.730345242801791, -84.7594, -1.47933060201488),
(21818, '49275', 218, 27, 11587, 41.9903, 0.732868988900175, -83.8641, -1.46370466922178),
(21819, '49276', 218, 27, 33772, 41.7952, 0.729463851529534, -83.8095, -1.46275171945019),
(21820, '49277', 218, 27, 132854, 42.3884, 0.739817144652364, -84.4655, -1.47420107934327),
(21821, '49278', 218, 27, 33811, 41.9125, 0.731511122742123, -84.3236, -1.47172445713469),
(21822, '49279', 218, 27, 33890, 41.7825, 0.729242194714531, -84.104, -1.46789171409731),
(21823, '49280', 218, 27, 18037, 41.7861, 0.729305026567603, -84.178, -1.46918325774379),
(21824, '49281', 218, 27, 5946, 42.0497, 0.73390571447586, -84.3843, -1.47278387199065),
(21825, '49282', 218, 27, 133163, 42.0526, 0.733956329024167, -84.4152, -1.47332317872952),
(21826, '49283', 218, 27, 133214, 42.2074, 0.736658098706255, -84.5479, -1.47563923064691),
(21827, '49284', 218, 27, 123716, 42.3799, 0.739668791665945, -84.6629, -1.47764635928671),
(21828, '49285', 218, 27, 25139, 42.4677, 0.741201190749196, -84.2108, -1.46975572573844),
(21829, '49286', 218, 27, 6262, 42.0078, 0.733174421519274, -83.944, -1.46509918729412),
(21830, '49287', 218, 27, 12332, 42.0297, 0.733556648625461, -84.086, -1.46757755483195),
(21831, '49288', 218, 27, 12596, 41.7327, 0.728373020747038, -84.4385, -1.47372984044523),
(21832, '49289', 218, 27, 6746, 41.7713, 0.729046717838307, -84.1003, -1.46782713691499),
(21833, '49301', 218, 27, 7026, 42.9553, 0.74971141618192, -85.4714, -1.49175734628908),
(21834, '49302', 218, 27, 18828, 42.8333, 0.747582114494487, -85.4225, -1.49090388028486),
(21835, '49303', 218, 27, 7216, 43.2737, 0.75526854452027, -85.8415, -1.49821680985071),
(21836, '49304', 218, 27, 722, 43.898, 0.766164635040471, -85.8548, -1.49844893864123),
(21837, '49305', 218, 27, 129677, 43.7479, 0.763544895833227, -85.1683, -1.48646725332629),
(21838, '49306', 218, 27, 303, 43.0766, 0.751828500564589, -85.588, -1.49379240019691),
(21839, '49307', 218, 27, 129820, 43.701, 0.762726336414042, -85.4662, -1.49166658916798),
(21840, '49309', 218, 27, 129845, 43.7404, 0.763413996139328, -85.8692, -1.49870026605351),
(21841, '49310', 218, 27, 13397, 43.5186, 0.759542855858404, -85.0117, -1.48373406771766),
(21842, '49311', 218, 27, 694, 42.6347, 0.744115890600026, -85.643, -1.4947523312855),
(21843, '49312', 218, 27, 129953, 43.6867, 0.762476754331007, -85.7951, -1.49740697707779),
(21844, '49314', 218, 27, 130006, 42.7326, 0.745824567937729, -85.8495, -1.49835643619087),
(21845, '49315', 218, 27, 130032, 42.8052, 0.747091676974677, -85.7037, -1.49581174614146),
(21846, '49316', 218, 27, 1296, 42.8145, 0.747253992595112, -85.5432, -1.49301049269201),
(21847, '49317', 218, 27, 35133, 43.1268, 0.752704655849091, -85.4797, -1.491902208617),
(21848, '49318', 218, 27, 130110, 43.2369, 0.754626263355536, -85.8233, -1.49789915992685),
(21849, '49319', 218, 27, 1429, 43.2273, 0.754458711747345, -85.5393, -1.49294242485119),
(21850, '49320', 218, 27, 130211, 43.7599, 0.763754335343467, -85.2866, -1.4885319778314),
(21851, '49321', 218, 27, 130317, 43.059, 0.751521322616238, -85.6683, -1.49519389958626),
(21852, '49322', 218, 27, 59108, 43.3592, 0.756760801030725, -85.3636, -1.48987588135543),
(21853, '49323', 218, 27, 108941, 42.7234, 0.745663997646545, -85.7781, -1.49711027110495),
(21854, '49325', 218, 27, 16142, 42.751, 0.746145708520096, -85.3064, -1.48887755302329),
(21855, '49326', 218, 27, 41140, 43.2373, 0.754633244672544, -85.3409, -1.48947969161523),
(21856, '49327', 218, 27, 104, 43.3418, 0.756457113740878, -85.8281, -1.49798293573095),
(21857, '49328', 218, 27, 3235, 42.6293, 0.744021642820419, -85.7533, -1.49667742945045),
(21858, '49329', 218, 27, 131375, 43.4121, 0.75768408020503, -85.4604, -1.49156536007136),
(21859, '49330', 218, 27, 131556, 43.2363, 0.754615791380024, -85.726, -1.49620095456466),
(21860, '49331', 218, 27, 10211, 42.9505, 0.749627640377824, -85.3607, -1.48982526680712),
(21861, '49332', 218, 27, 132032, 43.6385, 0.761635505631545, -85.2479, -1.48785653541087),
(21862, '49333', 218, 27, 110425, 42.7011, 0.745274789223351, -85.4714, -1.49175734628908),
(21863, '49335', 218, 27, 33316, 42.7382, 0.745922306375841, -85.6636, -1.49511186911141),
(21864, '49336', 218, 27, 42172, 43.5041, 0.759289783116865, -85.4268, -1.49097892944269),
(21865, '49337', 218, 27, 132276, 43.4314, 0.758020928750665, -85.7333, -1.49632836360005),
(21866, '49338', 218, 27, 11069, 43.7812, 0.764126090474141, -85.5154, -1.49252529115996),
(21867, '49339', 218, 27, 17596, 43.3321, 0.756287816803435, -85.4847, -1.4919894750796),
(21868, '49340', 218, 27, 24285, 43.6176, 0.761270731817879, -85.1388, -1.48595238119695),
(21869, '49341', 218, 27, 5475, 43.1131, 0.752465545741567, -85.5104, -1.49243802469736),
(21870, '49342', 218, 27, 11649, 43.7006, 0.762719355097034, -85.3109, -1.48895609283963),
(21871, '49343', 218, 27, 97827, 43.28, 0.755378500263146, -85.4763, -1.49184286742243),
(21872, '49344', 218, 27, 11899, 42.5997, 0.743505025361828, -85.6138, -1.49424269514392),
(21873, '49345', 218, 27, 25003, 43.1615, 0.753310285099532, -85.6954, -1.49566688381355),
(21874, '49346', 218, 27, 117893, 43.5878, 0.760750623700784, -85.3621, -1.48984970141665),
(21875, '49347', 218, 27, 133447, 43.3162, 0.756010309452368, -85.347, -1.4895861566996),
(21876, '49348', 218, 27, 38772, 42.6799, 0.744904779421928, -85.6335, -1.49458652500656),
(21877, '49349', 218, 27, 31515, 43.561, 0.76028287546125, -85.7513, -1.49664252286541),
(21878, '49351', 218, 27, 5475, 43.1261, 0.752692438544327, -85.5565, -1.49324262148253),
(21879, '49355', 218, 27, 7026, 42.9553, 0.74971141618192, -85.4794, -1.49189697262924),
(21880, '49356', 218, 27, 7026, 42.9556, 0.749716652169676, -85.4808, -1.49192140723877),
(21881, '49357', 218, 27, 7026, 42.9539, 0.749686981572392, -85.4891, -1.49206626956668),
(21882, '49401', 218, 27, 7060, 42.9717, 0.749997650179247, -85.9326, -1.49980680479928),
(21883, '49402', 218, 27, 7649, 43.92, 0.76654860747591, -86.0686, -1.50218045258199),
(21884, '49403', 218, 27, 54178, 43.1361, 0.752866971469526, -85.8543, -1.49844021199497),
(21885, '49404', 218, 27, 35372, 43.0669, 0.751659203627146, -85.9331, -1.49981553144554),
(21886, '49405', 218, 27, 35479, 43.9279, 0.766686488486817, -86.205, -1.50456108168171),
(21887, '49406', 218, 27, 2088, 42.6422, 0.744246790293926, -86.2144, -1.5047251426314),
(21888, '49408', 218, 27, 130773, 42.5745, 0.743065202390326, -86.1519, -1.5036343118489),
(21889, '49409', 218, 27, 130785, 43.0802, 0.751891332417661, -86.2156, -1.50474608658242),
(21890, '49410', 218, 27, 2573, 44.0181, 0.768260775472116, -86.1358, -1.50335331383933),
(21891, '49411', 218, 27, 130893, 44.1072, 0.769815863835643, -86.2398, -1.50516845626141),
(21892, '49412', 218, 27, 2605, 43.4672, 0.758645756622879, -85.9487, -1.50008780280885),
(21893, '49413', 218, 27, 2605, 43.4613, 0.758542782197012, -85.9517, -1.50014016268641),
(21894, '49415', 218, 27, 130922, 43.1428, 0.75298390852941, -86.1374, -1.50338123910736),
(21895, '49416', 218, 27, 21427, 42.5208, 0.742127960582005, -86.2328, -1.50504628321377),
(21896, '49417', 218, 27, 131058, 43.0372, 0.751140840839304, -86.1865, -1.50423819577009),
(21897, '49418', 218, 27, 131078, 42.8981, 0.74871308784978, -85.7572, -1.49674549729128),
(21898, '49419', 218, 27, 2950, 42.6836, 0.744969356604252, -85.9857, -1.50073357463209),
(21899, '49420', 218, 27, 9362, 43.7023, 0.762749025694318, -86.3574, -1.50722096346175),
(21900, '49421', 218, 27, 131291, 43.6122, 0.761176484038271, -86.0622, -1.50206875150986),
(21901, '49422', 218, 27, 9533, 42.7875, 0.746782753697074, -86.109, -1.5028855655998),
(21902, '49423', 218, 27, 9533, 42.779, 0.746634400710654, -86.1101, -1.50290476422157),
(21903, '49424', 218, 27, 9533, 42.822, 0.747384892289012, -86.1472, -1.50355228137406),
(21904, '49425', 218, 27, 30100, 43.4281, 0.757963332885349, -86.1042, -1.5028017897957),
(21905, '49426', 218, 27, 30125, 42.875, 0.748309916792569, -85.8788, -1.49886781766171),
(21906, '49427', 218, 27, 3399, 42.8271, 0.747473904080864, -85.8432, -1.498246480448),
(21907, '49428', 218, 27, 131498, 42.9072, 0.748871912811711, -85.8283, -1.49798642638945),
(21908, '49429', 218, 27, 131498, 42.894, 0.748641529350448, -85.8312, -1.49803704093776),
(21909, '49430', 218, 27, 9971, 43.0059, 0.750594552783429, -85.8951, -1.49915230632978),
(21910, '49431', 218, 27, 41898, 43.9689, 0.767402073480135, -86.4205, -1.50832226621976),
(21911, '49434', 218, 27, 131865, 42.766, 0.746407507907895, -86.2062, -1.50458202563274),
(21912, '49435', 218, 27, 112644, 43.0237, 0.750905221390284, -85.8358, -1.49811732608335),
(21913, '49436', 218, 27, 132028, 43.6827, 0.762406941160927, -86.4619, -1.50904483253009),
(21914, '49437', 218, 27, 4275, 43.4213, 0.757844650496214, -86.3597, -1.50726110603455),
(21915, '49440', 218, 27, 60998, 43.2323, 0.754545978209945, -86.2528, -1.50539534906416),
(21916, '49441', 218, 27, 60998, 43.1975, 0.75393860363025, -86.2744, -1.5057723401826),
(21917, '49442', 218, 27, 60998, 43.2329, 0.754556450185456, -86.1714, -1.50397465105304),
(21918, '49443', 218, 27, 60998, 43.213, 0.75420912966431, -86.2273, -1.50495029010491),
(21919, '49444', 218, 27, 60998, 43.1936, 0.753870535789423, -86.2114, -1.50467278275384),
(21920, '49445', 218, 27, 60998, 43.2821, 0.755415152177438, -86.2721, -1.5057321976098),
(21921, '49446', 218, 27, 23334, 43.5603, 0.760270658156486, -86.3573, -1.5072192181325),
(21922, '49448', 218, 27, 132365, 43.0793, 0.751875624454393, -86.0825, -1.50242305334802),
(21923, '49449', 218, 27, 132576, 43.7843, 0.764180195680953, -86.4177, -1.5082733970007),
(21924, '49450', 218, 27, 11428, 42.4827, 0.741462990136995, -86.08, -1.50237942011672),
(21925, '49451', 218, 27, 37869, 43.2069, 0.754102664579938, -85.9614, -1.50030945962385),
(21926, '49452', 218, 27, 132918, 43.5146, 0.759473042688325, -86.3082, -1.50636226146977),
(21927, '49453', 218, 27, 114025, 42.663, 0.744609818778341, -86.1848, -1.50420852517281),
(21928, '49454', 218, 27, 28557, 43.9434, 0.766957014520876, -86.2876, -1.50600272364386),
(21929, '49455', 218, 27, 59, 43.6041, 0.761035112368859, -86.361, -1.50728379531482),
(21930, '49456', 218, 27, 14657, 43.0865, 0.752001288160537, -86.1915, -1.50432546223269),
(21931, '49457', 218, 27, 62104, 43.3615, 0.756800943603521, -86.1784, -1.50409682410068),
(21932, '49458', 218, 27, 84183, 43.9433, 0.766955269191624, -86.0977, -1.50268834339432),
(21933, '49459', 218, 27, 12606, 43.7422, 0.763445412065864, -86.0106, -1.50116816161583),
(21934, '49460', 218, 27, 133661, 42.9361, 0.749376312965537, -86.1468, -1.50354530005705),
(21935, '49461', 218, 27, 12826, 43.3857, 0.757223313282504, -86.3412, -1.50693822012293),
(21936, '49463', 218, 27, 133542, 43.3709, 0.756965004553209, -86.422, -1.50834844615854),
(21937, '49464', 218, 27, 133838, 42.8389, 0.747679852932599, -86.0098, -1.50115419898182),
(21938, '49468', 218, 27, 131078, 42.9043, 0.748821298263403, -85.7561, -1.49672629866951),
(21939, '49501', 218, 27, 131066, 42.9666, 0.749908638387396, -85.6552, -1.49496526145425),
(21940, '49502', 218, 27, 131066, 42.9638, 0.74985976916834, -85.661, -1.49506649055086),
(21941, '49503', 218, 27, 131066, 42.9651, 0.749882458448616, -85.6586, -1.49502460264882),
(21942, '49504', 218, 27, 131066, 42.9861, 0.750248977591535, -85.7228, -1.4961451040286),
(21943, '49505', 218, 27, 131066, 43.0132, 0.750721961818825, -85.6243, -1.49442595471538),
(21944, '49506', 218, 27, 131066, 42.9405, 0.749453107452625, -85.5943, -1.49390235593978),
(21945, '49507', 218, 27, 131066, 42.9317, 0.74929951847845, -85.654, -1.49494431750322),
(21946, '49508', 218, 27, 131066, 42.8743, 0.748297699487805, -85.6245, -1.49442944537388),
(21947, '49509', 218, 27, 131066, 42.9015, 0.748772429044347, -85.7051, -1.49583618075099),
(21948, '49510', 218, 27, 131066, 43.0216, 0.750868569475992, -85.611, -1.49419382592487),
(21949, '49512', 218, 27, 131066, 42.8926, 0.74861709474092, -85.5699, -1.4934764956023),
(21950, '49514', 218, 27, 131066, 42.9669, 0.749913874375152, -85.6552, -1.49496526145425),
(21951, '49515', 218, 27, 131066, 42.9669, 0.749913874375152, -85.6549, -1.49496002546649),
(21952, '49516', 218, 27, 131066, 42.9187, 0.74907262567569, -85.5282, -1.49274869330421),
(21953, '49518', 218, 27, 131066, 42.8737, 0.748287227512293, -85.6245, -1.49442944537388),
(21954, '49523', 218, 27, 131066, 42.9651, 0.749882458448616, -85.6702, -1.49522706084205),
(21955, '49525', 218, 27, 131066, 43.0143, 0.750741160440597, -85.6005, -1.49401056635341),
(21956, '49530', 218, 27, 131066, 42.8674, 0.748177271769417, -85.546, -1.49305936191107),
(21957, '49544', 218, 27, 131066, 43.0007, 0.750503795662326, -85.7423, -1.49648544323273),
(21958, '49546', 218, 27, 131066, 42.9281, 0.749236686625378, -85.5311, -1.49279930785252),
(21959, '49548', 218, 27, 131066, 42.8644, 0.748124911891857, -85.6623, -1.49508917983114),
(21960, '49550', 218, 27, 131066, 43.0079, 0.750629459368469, -85.7175, -1.49605260157824),
(21961, '49555', 218, 27, 131066, 42.9708, 0.749981942215979, -85.664, -1.49511885042842),
(21962, '49560', 218, 27, 131066, 42.8733, 0.748280246195285, -85.6245, -1.49442944537388),
(21963, '49588', 218, 27, 131066, 42.966, 0.749898166411884, -85.6553, -1.4949670067835),
(21964, '49599', 218, 27, 131066, 42.9656, 0.749891185094876, -85.6543, -1.49494955349098),
(21965, '49601', 218, 27, 15396, 44.2558, 0.772409423104107, -85.4429, -1.49125992745226),
(21966, '49610', 218, 27, 726, 44.7941, 0.781804530467592, -85.4933, -1.49213957339527),
(21967, '49611', 218, 27, 53143, 44.956, 0.784630218526571, -84.8974, -1.48173915638263),
(21968, '49612', 218, 27, 796, 44.8938, 0.78354462373183, -85.2647, -1.48814975072521),
(21969, '49613', 218, 27, 7137, 44.4823, 0.776362593859874, -86.2179, -1.50478622915522),
(21970, '49614', 218, 27, 129716, 44.4264, 0.775386954808009, -86.1275, -1.50320845151142),
(21971, '49615', 218, 27, 7382, 44.969, 0.78485711132933, -85.2126, -1.48724043418492),
(21972, '49616', 218, 27, 129777, 44.5913, 0.778265002744547, -86.097, -1.50267612608956),
(21973, '49617', 218, 27, 616, 44.6443, 0.779190027248104, -86.0572, -1.50198148504726),
(21974, '49618', 218, 27, 58739, 44.2994, 0.773170386657976, -85.5925, -1.49387094001325),
(21975, '49619', 218, 27, 129926, 44.3071, 0.77330477701038, -86.023, -1.50138458244308),
(21976, '49620', 218, 27, 118947, 44.5505, 0.777552908409734, -85.7158, -1.49602293098096),
(21977, '49621', 218, 27, 31988, 44.8638, 0.783021024956232, -85.7855, -1.4972394254696),
(21978, '49622', 218, 27, 130144, 45.0756, 0.786717632311956, -85.2625, -1.48811135348167),
(21979, '49623', 218, 27, 1501, 43.8966, 0.766140200430943, -85.635, -1.49461270494534),
(21980, '49625', 218, 27, 130340, 44.4459, 0.775727294012148, -85.8858, -1.49898999070935),
(21981, '49626', 218, 27, 155118, 44.2452, 0.772224418203395, -86.2949, -1.50613013267925),
(21982, '49627', 218, 27, 8671, 45.0876, 0.786927071822195, -85.3117, -1.48897005547365),
(21983, '49628', 218, 27, 2250, 44.6165, 0.77870482571605, -86.2271, -1.5049467994464),
(21984, '49629', 218, 27, 130644, 44.9034, 0.783712175340022, -85.399, -1.49049372791064),
(21985, '49630', 218, 27, 2294, 44.8391, 0.782589928630989, -86.0307, -1.50151897279549),
(21986, '49631', 218, 27, 130716, 43.8929, 0.766075623248619, -85.265, -1.48815498671297),
(21987, '49632', 218, 27, 15986, 44.2545, 0.772386733823831, -85.0226, -1.48392430860613),
(21988, '49633', 218, 27, 130788, 44.5639, 0.777786782529501, -85.1919, -1.48687915102976),
(21989, '49634', 218, 27, 130790, 44.215, 0.771697328769293, -86.2901, -1.50604635687516),
(21990, '49635', 218, 27, 2594, 44.6305, 0.778949171811329, -86.2152, -1.50473910526542),
(21991, '49636', 218, 27, 131007, 44.8898, 0.783474810561751, -85.9659, -1.50038799944019),
(21992, '49637', 218, 27, 131102, 44.6331, 0.778994550371881, -85.7072, -1.49587283266528),
(21993, '49638', 218, 27, 131216, 44.2943, 0.773081374866124, -85.7254, -1.49619048258915),
(21994, '49639', 218, 27, 127733, 43.8523, 0.765367019572309, -85.4099, -1.4906839687991),
(21995, '49640', 218, 27, 131352, 44.7028, 0.780211044860521, -86.0567, -1.501972758401),
(21996, '49642', 218, 27, 36552, 43.8906, 0.766035480675823, -85.7834, -1.4972027735553),
(21997, '49643', 218, 27, 131448, 44.6373, 0.779067854200465, -85.7775, -1.49709979912944),
(21998, '49644', 218, 27, 131463, 44.1678, 0.770873533362351, -85.9587, -1.50026233573405),
(21999, '49645', 218, 27, 131530, 44.3675, 0.774358955878584, -86.0397, -1.50167605242817),
(22000, '49646', 218, 27, 131531, 44.7392, 0.780846344708247, -85.0812, -1.4849470715478),
(22001, '49648', 218, 27, 131568, 44.9245, 0.784080439812193, -85.3574, -1.48976767094181),
(22002, '49649', 218, 27, 16734, 44.5762, 0.778001458027496, -85.5439, -1.49302270999678),
(22003, '49650', 218, 27, 131634, 44.7472, 0.780985971048407, -85.8766, -1.49882942041816),
(22004, '49651', 218, 27, 9930, 44.3538, 0.774119845771061, -85.1693, -1.48648470661881),
(22005, '49653', 218, 27, 131643, 44.9893, 0.785211413167485, -85.7356, -1.49636850617285),
(22006, '49654', 218, 27, 10032, 45.0247, 0.785829259722691, -85.754, -1.49668964675522),
(22007, '49655', 218, 27, 3734, 44.0358, 0.768569698749719, -85.427, -1.4909824201012),
(22008, '49656', 218, 27, 60720, 44.056, 0.768922255258622, -85.6884, -1.49554471076591),
(22009, '49657', 218, 27, 131998, 44.2187, 0.771761905951617, -85.1953, -1.48693849222433),
(22010, '49659', 218, 27, 131889, 44.9157, 0.783926850838017, -85.0429, -1.48427861044429),
(22011, '49660', 218, 27, 3970, 44.2527, 0.772355317897295, -86.2698, -1.505692055037),
(22012, '49663', 218, 27, 37048, 44.4228, 0.775324122954937, -85.4311, -1.49105397860053),
(22013, '49664', 218, 27, 33186, 44.8798, 0.783300277636551, -85.8904, -1.49907027585494),
(22014, '49665', 218, 27, 630, 44.094, 0.76958548037438, -85.179, -1.48665400355625),
(22015, '49666', 218, 27, 10367, 44.5988, 0.778395902438447, -85.5332, -1.49283595976681),
(22016, '49667', 218, 27, 27880, 44.3423, 0.773919132907082, -84.9308, -1.4823220963528),
(22017, '49668', 218, 27, 132065, 44.4084, 0.77507279554265, -85.706, -1.49585188871426),
(22018, '49670', 218, 27, 4635, 45.1336, 0.787729923278113, -85.6118, -1.49420778855888),
(22019, '49673', 218, 27, 132410, 44.9555, 0.784621491880311, -85.4902, -1.49208546818846),
(22020, '49674', 218, 27, 132425, 45.0653, 0.786537863399001, -85.6242, -1.49442420938613),
(22021, '49675', 218, 27, 132431, 44.3682, 0.774371173183348, -86.217, -1.50477052119195),
(22022, '49676', 218, 27, 132771, 44.8203, 0.782261806731615, -85.2651, -1.48815673204222),
(22023, '49677', 218, 27, 132798, 43.9031, 0.766253646832323, -85.5093, -1.49241882607559),
(22024, '49679', 218, 27, 18019, 43.8648, 0.765585185728809, -85.1585, -1.48629621105959),
(22025, '49680', 218, 27, 133172, 44.6336, 0.779003277018141, -85.244, -1.48778846757005),
(22026, '49682', 218, 27, 133332, 44.9664, 0.784811732768778, -85.6401, -1.4947017167372),
(22027, '49683', 218, 27, 14747, 44.4984, 0.776643591869445, -85.9978, -1.50094475947158),
(22028, '49684', 218, 27, 133428, 44.7729, 0.781434520666169, -85.7012, -1.49576811291016),
(22029, '49685', 218, 27, 133428, 44.6752, 0.779729333986971, -85.6551, -1.494963516125),
(22030, '49686', 218, 27, 133428, 44.7566, 0.781150031998094, -85.5984, -1.49397391443911),
(22031, '49688', 218, 27, 133461, 44.1168, 0.769983415443834, -85.4308, -1.49104874261277),
(22032, '49689', 218, 27, 58192, 44.2148, 0.771693838110789, -85.9377, -1.49989581659113),
(22033, '49690', 218, 27, 6831, 44.7886, 0.781708537358732, -85.4295, -1.4910260533325),
(22034, '49696', 218, 27, 133428, 44.7546, 0.781115125413054, -85.6033, -1.49405943557246),
(22035, '49701', 218, 27, 131869, 45.78, 0.799011731563004, -84.7522, -1.47920493830874),
(22036, '49705', 218, 27, 570, 45.3628, 0.791730217923684, -84.4732, -1.47433546969567),
(22037, '49706', 218, 27, 129449, 45.4458, 0.793178841202839, -84.8017, -1.48006887628848),
(22038, '49707', 218, 27, 7071, 45.0728, 0.7866687630929, -83.4789, -1.45698166094309),
(22039, '49709', 218, 27, 7187, 44.9907, 0.785235847777013, -84.1422, -1.46855842987157),
(22040, '49710', 218, 27, 129669, 46.4868, 0.8113477187161, -84.3766, -1.47264948163825),
(22041, '49711', 218, 27, 70505, 45.4297, 0.792897843193268, -85.2236, -1.48743242040264),
(22042, '49712', 218, 27, 129900, 45.2216, 0.789265813019868, -85.0248, -1.48396270584967),
(22043, '49713', 218, 27, 129901, 45.1912, 0.788735232927261, -84.8595, -1.48107767659613),
(22044, '49715', 218, 27, 129944, 46.398, 0.809797866340329, -84.5938, -1.47644033677358),
(22045, '49716', 218, 27, 35028, 45.507, 0.79424698270506, -84.7727, -1.4795627308054),
(22046, '49717', 218, 27, 130017, 45.4323, 0.79294322175382, -84.6942, -1.47819264734258),
(22047, '49718', 218, 27, 130089, 45.6997, 0.797610232173653, -84.7949, -1.47995019389934),
(22048, '49719', 218, 27, 1435, 45.9222, 0.80149358975934, -84.4005, -1.47306661532947),
(22049, '49720', 218, 27, 130164, 45.2947, 0.790541648703076, -85.2394, -1.48770818242445),
(22050, '49721', 218, 27, 130177, 45.595, 0.795782872446815, -84.4717, -1.47430928975689),
(22051, '49722', 218, 27, 8215, 45.4186, 0.792704111646297, -84.8643, -1.48116145240022),
(22052, '49723', 218, 27, 130372, 45.6289, 0.796374539063241, -85.0266, -1.48399412177621),
(22053, '49724', 218, 27, 130408, 46.3443, 0.808860624532008, -84.4126, -1.47327780016897),
(22054, '49725', 218, 27, 130435, 45.984, 0.802572203237073, -83.9019, -1.46436440367903),
(22055, '49726', 218, 27, 0, 46.0103, 0.803031224830347, -83.7591, -1.46187207350718),
(22056, '49727', 218, 27, 130583, 45.1755, 0.788461216234698, -85.1317, -1.48582846282006),
(22057, '49728', 218, 27, 130612, 46.3323, 0.808651185021769, -85.176, -1.48660164367869),
(22058, '49729', 218, 27, 579, 45.1439, 0.787909692191068, -85.2102, -1.48719854628287),
(22059, '49730', 218, 27, 54613, 44.9508, 0.784539461405467, -84.8843, -1.48151051825062),
(22060, '49733', 218, 27, 115662, 44.7947, 0.781815002443104, -84.7241, -1.47871450078893),
(22061, '49734', 218, 27, 32534, 45.0275, 0.785878128941747, -84.6746, -1.47785056280919),
(22062, '49735', 218, 27, 32534, 44.9886, 0.785199195862721, -84.6744, -1.47784707215069),
(22063, '49736', 218, 27, 131026, 46.1003, 0.804602021157142, -84.08, -1.46747283507683),
(22064, '49737', 218, 27, 131034, 45.5618, 0.795203423135152, -85.0939, -1.4851687283628),
(22065, '49738', 218, 27, 131103, 44.6571, 0.77941342939236, -84.7281, -1.47878431395901),
(22066, '49739', 218, 27, 131103, 44.6194, 0.778755440264358, -84.7819, -1.47972330109658),
(22067, '49740', 218, 27, 131204, 45.5325, 0.794692041664318, -85.0044, -1.48360665868227),
(22068, '49743', 218, 27, 72860, 45.2962, 0.790567828641855, -83.8722, -1.46384604089119),
(22069, '49744', 218, 27, 9445, 44.9928, 0.785272499691305, -83.6613, -1.46016514149873),
(22070, '49745', 218, 27, 131292, 46.0296, 0.803368073375982, -84.3286, -1.47181172359729),
(22071, '49746', 218, 27, 3141, 45.0645, 0.786523900764985, -83.8451, -1.4633730566639),
(22072, '49747', 218, 27, 131384, 44.8928, 0.78352717043931, -83.6107, -1.45928200489722),
(22073, '49748', 218, 27, 9611, 46.3569, 0.809080536017759, -85.1567, -1.48626479513306),
(22074, '49749', 218, 27, 127802, 45.4254, 0.792822794035432, -84.5902, -1.47637750492051),
(22075, '49751', 218, 27, 131505, 44.9768, 0.784993247010986, -84.451, -1.47394800660173),
(22076, '49752', 218, 27, 116326, 46.3666, 0.809249832955203, -84.8462, -1.48084554780561),
(22077, '49753', 218, 27, 131621, 45.0568, 0.786389510412581, -83.7481, -1.46168008728946),
(22078, '49755', 218, 27, 131756, 45.6465, 0.796681717011592, -84.8416, -1.48076526266002),
(22079, '49756', 218, 27, 3747, 44.8077, 0.782041895245863, -84.2733, -1.47084655652094),
(22080, '49757', 218, 27, 131867, 45.8571, 0.800357380416292, -84.6182, -1.47686619711107),
(22081, '49759', 218, 27, 30514, 45.4393, 0.793065394801459, -84.0997, -1.46781666493948),
(22082, '49760', 218, 27, 10585, 46.0448, 0.803633363422285, -84.9729, -1.48305687996789),
(22083, '49761', 218, 27, 132202, 45.5628, 0.795220876427672, -84.5206, -1.47516275576112),
(22084, '49762', 218, 27, 132238, 46.1496, 0.805462468478375, -85.4048, -1.49059495700725),
(22085, '49764', 218, 27, 10923, 45.4225, 0.792772179487124, -84.8268, -1.48050695393073),
(22086, '49765', 218, 27, 132428, 45.3729, 0.791906496178135, -84.211, -1.46975921639694),
(22087, '49766', 218, 27, 132472, 44.9194, 0.783991428020341, -83.4629, -1.45670240826278),
(22088, '49768', 218, 27, 11064, 46.59, 0.813148898504158, -85.1273, -1.48575166833297),
(22089, '49769', 218, 27, 132566, 45.5683, 0.795316869536532, -84.8749, -1.48134645730094),
(22090, '49770', 218, 27, 132594, 45.3593, 0.791669131399864, -84.9283, -1.4822784631215),
(22091, '49774', 218, 27, 132604, 46.1707, 0.805830732950546, -84.1828, -1.46926703354788),
(22092, '49775', 218, 27, 132673, 45.7637, 0.798727242894929, -84.4673, -1.47423249526981),
(22093, '49776', 218, 27, 28305, 45.2593, 0.78992380214787, -83.6866, -1.46060670979949),
(22094, '49777', 218, 27, 105450, 45.3246, 0.791063502149422, -83.49, -1.45717539249007),
(22095, '49778', 218, 27, 129944, 46.4058, 0.809934002021985, -84.5725, -1.4760685816429),
(22096, '49779', 218, 27, 132879, 45.414, 0.792623826500705, -83.8579, -1.46359645880815),
(22097, '49780', 218, 27, 61624, 46.2932, 0.807968761284239, -84.5697, -1.47601971242385),
(22098, '49781', 218, 27, 132964, 45.8812, 0.800778004766022, -84.7319, -1.47885063647058),
(22099, '49782', 218, 27, 62796, 45.7217, 0.797994204609091, -85.5474, -1.4930837965206),
(22100, '49783', 218, 27, 0, 46.4799, 0.811227290997712, -84.359, -1.4723423036899),
(22101, '49784', 218, 27, 109965, 46.2594, 0.807378839997065, -84.3843, -1.47278387199065),
(22102, '49785', 218, 27, 109965, 46.2592, 0.807375349338561, -84.4067, -1.4731748257431),
(22103, '49786', 218, 27, 109965, 46.2659, 0.807492286398445, -84.4507, -1.47394277061398),
(22104, '49788', 218, 27, 109965, 46.2696, 0.807556863580768, -84.4542, -1.4740038571378),
(22105, '49790', 218, 27, 133294, 46.3574, 0.809089262664019, -84.9691, -1.48299055745631),
(22106, '49791', 218, 27, 133417, 45.4839, 0.793843811647849, -84.5957, -1.47647349802937),
(22107, '49792', 218, 27, 133423, 45.3682, 0.791824465703291, -84.3066, -1.47142775116185),
(22108, '49793', 218, 27, 133438, 46.1941, 0.806239139995513, -85.0193, -1.48386671274081),
(22109, '49795', 218, 27, 6518, 45.1447, 0.787923654825084, -84.6279, -1.47703549404851),
(22110, '49796', 218, 27, 133569, 45.266, 0.790040739207753, -84.9334, -1.48236747491335),
(22111, '49797', 218, 27, 25834, 44.8677, 0.78308909279706, -84.6692, -1.47775631502958),
(22112, '49799', 218, 27, 38939, 45.2681, 0.790077391122045, -84.5913, -1.47639670354228),
(22113, '49801', 218, 27, 55484, 45.817, 0.799657503386242, -88.0692, -1.53709750959739),
(22114, '49802', 218, 27, 16732, 45.8199, 0.79970811793455, -88.0669, -1.53705736702459),
(22115, '49805', 218, 27, 129490, 47.2882, 0.825334787341583, -88.4113, -1.54306828096846),
(22116, '49806', 218, 27, 129599, 46.4283, 0.810326701103683, -86.8375, -1.51560028920058),
(22117, '49807', 218, 27, 129670, 45.7084, 0.797762075818576, -87.2504, -1.52280675368206),
(22118, '49808', 218, 27, 26522, 46.8182, 0.817131739857209, -87.7304, -1.53118433409163),
(22119, '49812', 218, 27, 1363, 45.5825, 0.795564706290315, -87.5579, -1.52817364113194),
(22120, '49814', 218, 27, 1480, 46.5062, 0.811686312590987, -87.8364, -1.53303438309875),
(22121, '49815', 218, 27, 130156, 46.1548, 0.805553225599479, -88.0742, -1.53718477605999),
(22122, '49816', 218, 27, 13522, 46.2909, 0.807928618711443, -86.7614, -1.51427209363981),
(22123, '49817', 218, 27, 1742, 45.9114, 0.801305094200125, -86.5228, -1.51010773804455),
(22124, '49818', 218, 27, 20256, 45.9098, 0.801277168932093, -87.2006, -1.52193757971457),
(22125, '49819', 218, 27, 26395, 46.0503, 0.803729356531145, -87.4924, -1.52703045047189),
(22126, '49820', 218, 27, 1933, 46.1965, 0.806281027897561, -85.8205, -1.49785029070779),
(22127, '49821', 218, 27, 8382, 45.4534, 0.793311486225991, -87.5942, -1.52880719565042),
(22128, '49822', 218, 27, 130460, 46.4486, 0.810681002941838, -87.006, -1.51854116899019),
(22129, '49825', 218, 27, 130610, 46.3558, 0.809061337395987, -87.0357, -1.51905953177803),
(22130, '49826', 218, 27, 132933, 46.3442, 0.808858879202756, -86.9222, -1.51707858307702),
(22131, '49827', 218, 27, 130684, 46.2054, 0.806436362200988, -85.5954, -1.49392155456155),
(22132, '49829', 218, 27, 130700, 45.7499, 0.798486387458154, -87.0966, -1.52012243729249),
(22133, '49831', 218, 27, 130771, 45.9977, 0.802811313344596, -87.8258, -1.53284937819804),
(22134, '49833', 218, 27, 131801, 46.2886, 0.807888476138647, -87.3328, -1.5242449049857),
(22135, '49834', 218, 27, 130857, 46.0807, 0.804259936623751, -87.7775, -1.53200638416932),
(22136, '49835', 218, 27, 2656, 45.7367, 0.79825600399689, -86.5911, -1.51129979792366),
(22137, '49836', 218, 27, 130976, 46.2443, 0.807115295280014, -85.9273, -1.49971430234892),
(22138, '49837', 218, 27, 2726, 45.8502, 0.800236952697904, -87.0495, -1.5193003872148),
(22139, '49838', 218, 27, 131047, 46.0668, 0.804017335857724, -85.7334, -1.49633010892931),
(22140, '49839', 218, 27, 131065, 46.5899, 0.813147153174906, -86.0438, -1.5017476109275),
(22141, '49840', 218, 27, 131159, 46.112, 0.804806224679625, -86.0083, -1.50112801904304),
(22142, '49841', 218, 27, 109508, 46.2766, 0.807679036628408, -87.4467, -1.52623283500373),
(22143, '49845', 218, 27, 2992, 45.7032, 0.797671318697472, -87.3457, -1.52447005245921),
(22144, '49847', 218, 27, 131285, 45.7509, 0.798503840750674, -87.6412, -1.52962750039885),
(22145, '49848', 218, 27, 9659, 45.3766, 0.791971073360459, -87.6126, -1.52912833623278),
(22146, '49849', 218, 27, 131475, 46.4924, 0.811445457154212, -87.6821, -1.53034134006292),
(22147, '49852', 218, 27, 3869, 45.7792, 0.798997768928988, -87.8173, -1.53270102521162),
(22148, '49853', 218, 27, 60838, 46.3739, 0.809377241990598, -85.7393, -1.49643308335517),
(22149, '49854', 218, 27, 131892, 45.9612, 0.802174268167618, -86.2453, -1.50526444937027),
(22150, '49855', 218, 27, 33204, 46.5268, 0.812045850416898, -87.3866, -1.52518389212328),
(22151, '49858', 218, 27, 120594, 45.1224, 0.787534446401889, -87.6157, -1.5291824414396),
(22152, '49861', 218, 27, 132077, 46.5315, 0.812127880891741, -88.0878, -1.53742214083826),
(22153, '49862', 218, 27, 132206, 46.4147, 0.810089336325412, -86.6364, -1.51209043207482),
(22154, '49863', 218, 27, 96431, 45.6092, 0.796030709200598, -87.5523, -1.52807590269383),
(22155, '49864', 218, 27, 132227, 45.8412, 0.800079873065225, -86.6621, -1.51253898169258),
(22156, '49865', 218, 27, 132237, 46.4585, 0.810853790537786, -87.6812, -1.53032563209965),
(22157, '49866', 218, 27, 132242, 46.512, 0.811787541687603, -87.5918, -1.52876530774837),
(22158, '49868', 218, 27, 17269, 46.3469, 0.80890600309256, -85.5075, -1.49238741014905),
(22159, '49870', 218, 27, 33458, 45.7877, 0.799146121915408, -87.9049, -1.53422993363636),
(22160, '49871', 218, 27, 337, 46.4405, 0.810539631272427, -87.5881, -1.52870073056605),
(22161, '49872', 218, 27, 11143, 45.9973, 0.802804332027588, -87.0901, -1.52000899089111),
(22162, '49873', 218, 27, 132584, 45.877, 0.800704700937439, -87.5011, -1.52718229411681),
(22163, '49874', 218, 27, 5205, 45.6923, 0.797481077809005, -87.4998, -1.52715960483653),
(22164, '49876', 218, 27, 132750, 45.8013, 0.799383486693679, -87.9881, -1.53568204757402),
(22165, '49877', 218, 27, 5284, 46.1085, 0.804745138155805, -87.7835, -1.53211110392444),
(22166, '49878', 218, 27, 132772, 45.8974, 0.801060748104845, -86.897, -1.51663876010551),
(22167, '49879', 218, 27, 5356, 46.2772, 0.80768950860392, -88.1362, -1.53826688019623),
(22168, '49880', 218, 27, 11629, 46.0367, 0.803491991752874, -87.1757, -1.52150299273082),
(22169, '49881', 218, 27, 132951, 46.0689, 0.804053987772016, -88.0629, -1.53698755385451),
(22170, '49883', 218, 27, 24739, 46.4177, 0.810141696202972, -86.0527, -1.50190294523092),
(22171, '49884', 218, 27, 133107, 46.3562, 0.809068318712995, -86.4513, -1.50885982762937),
(22172, '49885', 218, 27, 133131, 46.3502, 0.808963598957876, -87.2516, -1.52282769763308),
(22173, '49886', 218, 27, 24994, 45.6955, 0.797536928345069, -87.5044, -1.52723988998213),
(22174, '49887', 218, 27, 61884, 45.4145, 0.792632553146965, -87.6151, -1.52917196946408),
(22175, '49891', 218, 27, 133431, 46.2026, 0.806387492981932, -86.8658, -1.51609421737889),
(22176, '49892', 218, 27, 6585, 45.7821, 0.799048383477296, -87.8678, -1.53358241648387),
(22177, '49893', 218, 27, 721, 45.3326, 0.791203128489581, -87.6096, -1.52907597635522),
(22178, '49894', 218, 27, 34376, 45.7785, 0.798985551624224, -87.0754, -1.51975242749107),
(22179, '49895', 218, 27, 34399, 46.372, 0.80934408073481, -86.6193, -1.51179198077272),
(22180, '49896', 218, 27, 565, 45.6571, 0.796866721912303, -87.3986, -1.52539333163352),
(22181, '49901', 218, 27, 129438, 47.297, 0.825488376315758, -88.3962, -1.54280473625141),
(22182, '49902', 218, 27, 7072, 46.015, 0.803113255305191, -88.3049, -1.54121125064434),
(22183, '49903', 218, 27, 129518, 46.2376, 0.80699835822013, -88.4441, -1.54364074896312),
(22184, '49905', 218, 27, 129587, 47.0654, 0.821446193768139, -88.6503, -1.54723961788073),
(22185, '49908', 218, 27, 129666, 46.7765, 0.816403937559128, -88.4946, -1.54452214023537),
(22186, '49910', 218, 27, 129780, 46.592, 0.813183805089198, -89.567, -1.56323905113376),
(22187, '49911', 218, 27, 418, 46.478, 0.811194129741925, -90.0526, -1.57171436998145),
(22188, '49912', 218, 27, 129976, 46.5376, 0.812234345976113, -89.2031, -1.55688779798575),
(22189, '49913', 218, 27, 1298, 47.2401, 0.824495283971373, -88.4504, -1.54375070470599),
(22190, '49915', 218, 27, 130112, 46.0661, 0.80400511855296, -88.6294, -1.54687484406706),
(22191, '49916', 218, 27, 130172, 47.027, 0.820775987335373, -88.5276, -1.54509809888853),
(22192, '49917', 218, 27, 130342, 47.2843, 0.825266719500755, -88.3859, -1.54262496733846),
(22193, '49918', 218, 27, 130344, 47.4688, 0.828486851970684, -87.8882, -1.53393846365128),
(22194, '49919', 218, 27, 15652, 46.5474, 0.812405388242809, -88.5171, -1.54491483931707),
(22195, '49920', 218, 27, 80591, 46.1048, 0.804680560973482, -88.3505, -1.54200712078325),
(22196, '49921', 218, 27, 115290, 47.0926, 0.821920923324682, -88.5827, -1.54605977530638),
(22197, '49922', 218, 27, 130512, 47.1233, 0.822456739405044, -88.5024, -1.54465827591703),
(22198, '49925', 218, 27, 130728, 46.5418, 0.812307649804697, -89.3797, -1.55997004944478),
(22199, '49927', 218, 27, 130928, 46.0523, 0.803764263116185, -88.5917, -1.54621685493906),
(22200, '49929', 218, 27, 9223, 46.7801, 0.816466769412199, -89.0978, -1.5550499662834),
(22201, '49930', 218, 27, 9313, 47.1313, 0.822596365745203, -88.5882, -1.54615576841524),
(22202, '49931', 218, 27, 116085, 47.1169, 0.822345038332916, -88.5628, -1.54571245478523),
(22203, '49934', 218, 27, 30121, 47.1755, 0.823367801274585, -88.431, -1.54341211083111),
(22204, '49935', 218, 27, 131461, 46.1071, 0.804720703546278, -88.6584, -1.54738098955014),
(22205, '49938', 218, 27, 131465, 46.4574, 0.810834591916014, -90.1559, -1.57351729509876),
(22206, '49942', 218, 27, 131542, 47.2677, 0.824976994844924, -88.4184, -1.54319219934535),
(22207, '49945', 218, 27, 131644, 47.1941, 0.823692432515456, -88.4114, -1.54307002629771),
(22208, '49946', 218, 27, 131610, 46.759, 0.816098504940029, -88.448, -1.54370881680394),
(22209, '49947', 218, 27, 131933, 46.3793, 0.809471489770206, -89.6966, -1.56550099784435),
(22210, '49948', 218, 27, 131980, 46.7263, 0.815527782274626, -89.0338, -1.55393295556213),
(22211, '49950', 218, 27, 10551, 47.3154, 0.825809516898125, -88.3426, -1.54186923977234),
(22212, '49952', 218, 27, 132297, 46.6359, 0.813950004630824, -88.8797, -1.5512434031848),
(22213, '49953', 218, 27, 132439, 46.8538, 0.817753077070919, -89.3181, -1.55889492662555),
(22214, '49955', 218, 27, 132507, 47.0436, 0.821065711991204, -88.6716, -1.5476113730114),
(22215, '49958', 218, 27, 132565, 46.7301, 0.815594104786202, -88.6414, -1.5470842835773),
(22216, '49959', 218, 27, 42735, 46.4767, 0.811171440461649, -89.9927, -1.5706689177595),
(22217, '49960', 218, 27, 187, 46.7413, 0.815789581662426, -89.1848, -1.55656840273264),
(22218, '49961', 218, 27, 133115, 46.5063, 0.811688057920239, -88.7316, -1.5486585705626),
(22219, '49962', 218, 27, 133134, 46.8702, 0.818039311068246, -88.1607, -1.53869448586297),
(22220, '49963', 218, 27, 133191, 47.0713, 0.821549168194007, -88.6436, -1.54712268082085),
(22221, '49964', 218, 27, 133243, 46.0836, 0.804310551172059, -88.6313, -1.54690800532285),
(22222, '49965', 218, 27, 133413, 46.9383, 0.819227880288854, -88.8518, -1.5507564563235),
(22223, '49967', 218, 27, 98637, 46.4784, 0.811201111058932, -89.0072, -1.5534686979811),
(22224, '49968', 218, 27, 831, 46.4769, 0.811174931120153, -89.9379, -1.56971247732941),
(22225, '49969', 218, 27, 133592, 46.2701, 0.807565590227028, -89.1749, -1.55639561513669),
(22226, '49970', 218, 27, 133608, 46.4994, 0.811567630201851, -88.6204, -1.54671776443438),
(22227, '49971', 218, 27, 91831, 46.7553, 0.816033927757705, -89.5821, -1.56350259585081),
(22228, '50001', 218, 16, 114341, 41.3614, 0.721892613234383, -93.431, -1.63067857343082),
(22229, '50002', 218, 16, 34502, 41.4982, 0.724280223651111, -94.6475, -1.65191050378133),
(22230, '50003', 218, 16, 18743, 41.6171, 0.726355420131732, -94.0219, -1.64099172398086),
(22231, '50005', 218, 16, 7043, 42.1204, 0.73513966225702, -93.0121, -1.62336738919422),
(22232, '50006', 218, 16, 796, 42.5176, 0.742072110045941, -93.3743, -1.62968897174494),
(22233, '50007', 218, 16, 114380, 41.8185, 0.729870513245249, -93.6106, -1.6338131847674),
(22234, '50008', 218, 16, 26353, 40.6747, 0.709907437260938, -93.3832, -1.62984430604837),
(22235, '50009', 218, 16, 14978, 41.6477, 0.726889490882842, -93.4708, -1.63137321447312),
(22236, '50010', 218, 16, 7089, 42.0277, 0.733521742040421, -93.6367, -1.63426871570217),
(22237, '50011', 218, 16, 7089, 42.0229, 0.733437966236325, -93.642, -1.63436121815253),
(22238, '50012', 218, 16, 7089, 42.0227, 0.733434475577821, -93.6494, -1.63449037251718),
(22239, '50013', 218, 16, 7089, 42.0199, 0.733385606358765, -93.6452, -1.63441706868859),
(22240, '50014', 218, 16, 7089, 42.0242, 0.733460655516601, -93.6643, -1.63475042657572),
(22241, '50015', 218, 16, 114419, 41.7252, 0.728242121053138, -93.6049, -1.63371370100004),
(22242, '50020', 218, 16, 29102, 41.4463, 0.723374397769326, -94.766, -1.65397871894495),
(22243, '50021', 218, 16, 114419, 41.7219, 0.728184525187822, -93.6074, -1.63375733423134),
(22244, '50022', 218, 16, 62617, 41.3995, 0.722557583679392, -95.0092, -1.6582233596858),
(22245, '50025', 218, 16, 15055, 41.7158, 0.728078060103451, -94.9258, -1.65676775508963),
(22246, '50026', 218, 16, 44547, 41.8202, 0.729900183842533, -94.4543, -1.64853852766648),
(22247, '50027', 218, 16, 114508, 41.5083, 0.724456501905562, -92.4711, -1.61392515794093),
(22248, '50028', 218, 16, 150, 41.8235, 0.729957779707848, -93.1467, -1.6257166023674),
(22249, '50029', 218, 16, 360, 41.8522, 0.730458689203171, -94.5586, -1.65035890607631),
(22250, '50031', 218, 16, 7346, 42.0363, 0.733671840356092, -94.106, -1.64245954588178),
(22251, '50032', 218, 16, 400, 41.6681, 0.727245538050249, -93.5441, -1.63265254081483),
(22252, '50033', 218, 16, 114602, 41.3598, 0.721864687966351, -93.7904, -1.63695128676249),
(22253, '50034', 218, 16, 114627, 42.4807, 0.741428083551955, -93.6426, -1.63437169012804),
(22254, '50035', 218, 16, 34906, 41.724, 0.728221177102114, -93.4496, -1.63100320467169),
(22255, '50036', 218, 16, 7601, 42.0618, 0.734116899315351, -93.8855, -1.63861109488114),
(22256, '50037', 218, 16, 7601, 42.0527, 0.733958074353419, -93.8788, -1.63849415782125),
(22257, '50038', 218, 16, 1048, 41.5386, 0.724985336668917, -93.8824, -1.63855698967432),
(22258, '50039', 218, 16, 112991, 41.8504, 0.730427273276635, -94.0092, -1.64077006716585),
(22259, '50040', 218, 16, 114676, 42.166, 0.735935532395929, -94.1063, -1.64246478186954),
(22260, '50041', 218, 16, 1076, 42.6007, 0.743522478654348, -93.2028, -1.62669573207777),
(22261, '50042', 218, 16, 85264, 41.5534, 0.725243645398212, -94.9838, -1.65778004605579),
(22262, '50043', 218, 16, 7746, 42.5143, 0.742014514180625, -93.4096, -1.6303050729709),
(22263, '50044', 218, 16, 7799, 41.2066, 0.719190843552295, -92.8815, -1.62108798919111),
(22264, '50046', 218, 16, 1302, 41.9035, 0.731354043109444, -93.5322, -1.63244484663384),
(22265, '50047', 218, 16, 1358, 41.4754, 0.723882288581656, -93.4767, -1.63147618889898),
(22266, '50048', 218, 16, 1393, 41.4895, 0.724128380006187, -94.4298, -1.64811092199974),
(22267, '50049', 218, 16, 53997, 41.0168, 0.71587820863201, -93.3097, -1.62856148904815),
(22268, '50050', 218, 16, 114973, 42.1324, 0.735349101767259, -94.4594, -1.64862753945833),
(22269, '50051', 218, 16, 35275, 42.1341, 0.735378772364543, -93.1459, -1.62570263973339),
(22270, '50052', 218, 16, 1632, 40.6809, 0.710015647674561, -93.4988, -1.63186190666367),
(22271, '50054', 218, 16, 8175, 41.6748, 0.727362475110133, -93.2436, -1.62740782641258),
(22272, '50055', 218, 16, 308, 41.9027, 0.731340080475428, -93.3056, -1.62848993054882),
(22273, '50056', 218, 16, 527, 42.0172, 0.733338482468961, -93.3166, -1.62868191676654),
(22274, '50057', 218, 16, 1716, 41.1845, 0.718805125787605, -93.1581, -1.62591556990213),
(22275, '50058', 218, 16, 115098, 41.878, 0.730908984150185, -94.6789, -1.65245853716646),
(22276, '50059', 218, 16, 1748, 41.8992, 0.731278993951608, -94.3386, -1.64651918172192),
(22277, '50060', 218, 16, 29558, 40.7597, 0.711390967125133, -93.318, -1.62870635137607),
(22278, '50061', 218, 16, 20417, 41.4895, 0.724128380006187, -93.7545, -1.63632471356102),
(22279, '50062', 218, 16, 1953, 41.2307, 0.719611467902026, -93.2386, -1.62732055994999),
(22280, '50063', 218, 16, 115188, 41.6921, 0.727664417070728, -93.9706, -1.64009637007458),
(22281, '50064', 218, 16, 15726, 42.1028, 0.734832484308669, -94.2272, -1.6445748849352),
(22282, '50065', 218, 16, 115202, 40.639, 0.709284354717976, -93.8097, -1.63728813530812),
(22283, '50066', 218, 16, 1989, 41.8204, 0.729903674501037, -94.2218, -1.64448063715559),
(22284, '50067', 218, 16, 2007, 40.7685, 0.711544556099308, -93.8431, -1.63787107527829),
(22285, '50068', 218, 16, 2031, 40.9416, 0.71456572103451, -93.4993, -1.63187063330993),
(22286, '50069', 218, 16, 26922, 41.5327, 0.724882362243049, -94.0622, -1.64169509166941),
(22287, '50070', 218, 16, 2038, 41.5171, 0.724610090879738, -94.2234, -1.64450856242363),
(22288, '50071', 218, 16, 115331, 42.6556, 0.744480664413693, -93.5032, -1.63193870115076),
(22289, '50072', 218, 16, 115369, 41.494, 0.724206919822527, -94.1246, -1.64278417712265),
(22290, '50073', 218, 16, 94006, 41.7883, 0.729343423811146, -93.5164, -1.63216908461203),
(22291, '50074', 218, 16, 115458, 40.8504, 0.712973980756692, -94.0761, -1.64193769243544),
(22292, '50075', 218, 16, 579, 42.3133, 0.738506402384117, -93.5791, -1.63326340605303),
(22293, '50076', 218, 16, 115509, 41.591, 0.725899889196962, -94.8741, -1.65586541986635),
(22294, '50078', 218, 16, 2432, 41.9374, 0.73194570972587, -92.8661, -1.62081920848631),
(22295, '50101', 218, 16, 32508, 42.6907, 0.745093274981143, -93.5971, -1.63357756531838),
(22296, '50102', 218, 16, 2657, 42.2522, 0.737440006211148, -93.4042, -1.63021082519129),
(22297, '50103', 218, 16, 16176, 40.7182, 0.710666655485555, -93.6147, -1.63388474326674),
(22298, '50104', 218, 16, 2709, 41.4669, 0.723733935595237, -92.3545, -1.6118901040331),
(22299, '50105', 218, 16, 2713, 42.1061, 0.734890080173984, -93.6466, -1.63444150329812),
(22300, '50106', 218, 16, 102246, 41.8975, 0.731249323354324, -92.821, -1.62003206499366),
(22301, '50107', 218, 16, 87355, 42.0314, 0.733586319222745, -94.2337, -1.64468833133658),
(22302, '50108', 218, 16, 41159, 40.8111, 0.712288066360658, -93.9572, -1.63986249595482),
(22303, '50109', 218, 16, 94574, 41.76, 0.728849495632832, -93.7767, -1.63671217665497),
(22304, '50110', 218, 16, 21530, 41.8395, 0.730237032388168, -94.9796, -1.65770674222721),
(22305, '50111', 218, 16, 2885, 41.683, 0.727505592108796, -93.7837, -1.63683434970261),
(22306, '50112', 218, 16, 27346, 41.7461, 0.728606894866805, -92.7234, -1.61832862364371),
(22307, '50115', 218, 16, 115894, 41.6789, 0.727434033609465, -94.5004, -1.64934312445165),
(22308, '50116', 218, 16, 2950, 41.1765, 0.718665499447445, -92.9323, -1.62197461645113),
(22309, '50117', 218, 16, 9306, 41.6452, 0.726845857651543, -94.918, -1.65663161940798),
(22310, '50118', 218, 16, 2998, 41.4589, 0.723594309255077, -93.3927, -1.63001011232731),
(22311, '50119', 218, 16, 9372, 41.3186, 0.721145612314529, -92.9279, -1.62189782196404),
(22312, '50120', 218, 16, 16381, 41.9306, 0.731827027336734, -92.9795, -1.62279841185807),
(22313, '50122', 218, 16, 3261, 42.3045, 0.738352813409941, -93.2974, -1.62834681355016),
(22314, '50123', 218, 16, 116103, 40.8599, 0.713139787035631, -93.4966, -1.63182350942013),
(22315, '50124', 218, 16, 95063, 41.8958, 0.73121965275704, -93.6047, -1.63371021034154),
(22316, '50125', 218, 16, 16542, 41.3532, 0.721749496235719, -93.5765, -1.63321802749247),
(22317, '50126', 218, 16, 116148, 42.5114, 0.741963899632317, -93.2884, -1.62818973391748),
(22318, '50127', 218, 16, 55479, 41.7327, 0.728373020747038, -93.1679, -1.62608661216883),
(22319, '50128', 218, 16, 22217, 41.8343, 0.730146275267064, -94.3386, -1.64651918172192),
(22320, '50129', 218, 16, 3409, 42.0151, 0.733301830554669, -94.3779, -1.64720509611796),
(22321, '50130', 218, 16, 9764, 42.3077, 0.738408663946005, -93.6429, -1.6343769261158),
(22322, '50131', 218, 16, 327, 41.6832, 0.7275090827673, -93.7081, -1.6355148807881),
(22323, '50132', 218, 16, 116281, 42.3927, 0.7398921938102, -93.7296, -1.63589012657728),
(22324, '50133', 218, 16, 116287, 40.649, 0.709458887643175, -94.0726, -1.64187660591162),
(22325, '50134', 218, 16, 116288, 41.9445, 0.732069628102762, -93.6587, -1.63465268813761),
(22326, '50135', 218, 16, 27611, 41.7303, 0.72833113284499, -92.9199, -1.62175819562388),
(22327, '50136', 218, 16, 103314, 41.4708, 0.723802003436064, -92.2429, -1.60994231658788),
(22328, '50137', 218, 16, 116318, 41.7203, 0.72815659991979, -93.0342, -1.62375310695891),
(22329, '50138', 218, 16, 3570, 41.3197, 0.721164810936301, -93.1027, -1.62494865749652),
(22330, '50139', 218, 16, 116356, 41.1979, 0.719038999907372, -93.3921, -1.6299996403518),
(22331, '50140', 218, 16, 116395, 40.6225, 0.708996375391397, -93.9332, -1.63944361693434),
(22332, '50141', 218, 16, 14092, 41.8859, 0.731046865161093, -92.9413, -1.62213169608381),
(22333, '50142', 218, 16, 3703, 42.007, 0.733160458885258, -92.7762, -1.61925015748876),
(22334, '50143', 218, 16, 3726, 41.3755, 0.722138704658914, -92.8157, -1.6199395625433),
(22335, '50144', 218, 16, 3732, 40.7402, 0.711050627920994, -93.7459, -1.63617461524535),
(22336, '50145', 218, 16, 116470, 41.2057, 0.719175135589027, -93.5003, -1.63188808660245),
(22337, '50146', 218, 16, 3784, 41.6429, 0.726805715078747, -94.271, -1.64533933914757),
(22338, '50147', 218, 16, 3791, 40.582, 0.708289517044339, -93.5251, -1.63232092825695),
(22339, '50148', 218, 16, 116563, 42.1842, 0.736253182319792, -93.0002, -1.62315969501323),
(22340, '50149', 218, 16, 116608, 41.114, 0.717574668664949, -94.0708, -1.64184518998508),
(22341, '50150', 218, 16, 116623, 41.1327, 0.717901045235072, -92.9055, -1.62150686821159),
(22342, '50151', 218, 16, 10220, 41.1767, 0.718668990105949, -93.5413, -1.63260367159577),
(22343, '50152', 218, 16, 60720, 41.9961, 0.732970217996791, -93.8626, -1.63821141448243);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(22344, '50153', 218, 16, 27770, 41.5796, 0.725700921662234, -92.7836, -1.61937931185341),
(22345, '50154', 218, 16, 116787, 42.1653, 0.735923315091165, -93.3901, -1.62996473376676),
(22346, '50155', 218, 16, 73320, 41.2144, 0.719326979233951, -94.1852, -1.64384184664936),
(22347, '50156', 218, 16, 3944, 41.8748, 0.730853133614122, -93.8206, -1.63747837619659),
(22348, '50157', 218, 16, 116688, 41.6101, 0.726233247084093, -92.5294, -1.61494268489484),
(22349, '50158', 218, 16, 71092, 42.0405, 0.733745144184676, -92.9085, -1.62155922808915),
(22350, '50160', 218, 16, 116757, 41.3739, 0.722110779390882, -93.7411, -1.63609083944126),
(22351, '50161', 218, 16, 4045, 41.8179, 0.729860041269737, -93.4013, -1.63016021064298),
(22352, '50162', 218, 16, 10438, 41.9307, 0.731828772665986, -93.0689, -1.62435873620935),
(22353, '50163', 218, 16, 0, 41.2247, 0.719506748146906, -93.2402, -1.62734848521802),
(22354, '50164', 218, 16, 23043, 41.5556, 0.725282042641756, -94.4202, -1.64794337039155),
(22355, '50165', 218, 16, 33288, 40.8545, 0.713045539256023, -93.2696, -1.6278616120181),
(22356, '50166', 218, 16, 503, 41.2819, 0.720505076479047, -93.4271, -1.63061050558999),
(22357, '50167', 218, 16, 116866, 41.757, 0.728797135755272, -94.0271, -1.64108248110196),
(22358, '50168', 218, 16, 56294, 41.8036, 0.729610459186702, -93.2891, -1.62820195122224),
(22359, '50169', 218, 16, 4255, 41.6664, 0.727215867452965, -93.3678, -1.62957552534356),
(22360, '50170', 218, 16, 10560, 41.5234, 0.724720046622613, -93.1022, -1.62493993085026),
(22361, '50171', 218, 16, 23157, 41.5834, 0.72576724417381, -92.5235, -1.61483971046897),
(22362, '50173', 218, 16, 113010, 41.949, 0.732148167919101, -92.708, -1.6180598429389),
(22363, '50174', 218, 16, 10715, 41.0414, 0.716307559628001, -93.9495, -1.63972810560241),
(22364, '50177', 218, 16, 27346, 41.7408, 0.728514392416449, -92.7224, -1.61831117035119),
(22365, '50197', 218, 16, 3570, 41.3208, 0.721184009558073, -93.1097, -1.62507083054416),
(22366, '50198', 218, 16, 3570, 41.3208, 0.721184009558073, -93.109, -1.6250586132394),
(22367, '50201', 218, 16, 37398, 42.0186, 0.733362917078489, -93.4507, -1.63102240329346),
(22368, '50206', 218, 16, 4553, 42.1948, 0.736438187220503, -93.1901, -1.62647407526277),
(22369, '50207', 218, 16, 4554, 41.4692, 0.723774078168033, -92.6515, -1.61707373191153),
(22370, '50208', 218, 16, 4570, 41.698, 0.727767391496596, -93.0484, -1.62400094371269),
(22371, '50210', 218, 16, 117015, 41.2004, 0.719082633138672, -93.6983, -1.6353438385214),
(22372, '50211', 218, 16, 17325, 41.4665, 0.723726954278229, -93.6877, -1.63515883362069),
(22373, '50212', 218, 16, 10927, 42.0393, 0.733724200233652, -94.0291, -1.641117387687),
(22374, '50213', 218, 16, 11010, 41.0344, 0.716185386580361, -93.7651, -1.63650971846174),
(22375, '50214', 218, 16, 117173, 41.4588, 0.723592563925825, -93.0402, -1.62385782671403),
(22376, '50216', 218, 16, 117225, 41.6924, 0.727669653058484, -94.366, -1.64699740193697),
(22377, '50217', 218, 16, 33583, 42.1641, 0.735902371140141, -94.2566, -1.64508801173529),
(22378, '50218', 218, 16, 428, 41.3754, 0.722136959329662, -93.8729, -1.63839118339539),
(22379, '50219', 218, 16, 117252, 41.4082, 0.722709427324316, -92.9155, -1.62168140113679),
(22380, '50220', 218, 16, 11148, 41.8409, 0.730261466997695, -94.0978, -1.64231642888312),
(22381, '50222', 218, 16, 33609, 41.205, 0.719162918284263, -93.9411, -1.63958149794525),
(22382, '50223', 218, 16, 117294, 42.1671, 0.735954731017701, -94.0106, -1.64079450177538),
(22383, '50225', 218, 16, 14431, 41.3872, 0.722342908181397, -93.2689, -1.62784939471334),
(22384, '50226', 218, 16, 17686, 41.7802, 0.729202052141735, -93.7078, -1.63550964480034),
(22385, '50227', 218, 16, 117387, 42.601, 0.743527714642104, -93.4396, -1.63082867174649),
(22386, '50228', 218, 16, 30889, 41.5983, 0.726027298232357, -93.2378, -1.62730659731597),
(22387, '50229', 218, 16, 117427, 41.3616, 0.721896103892887, -93.719, -1.63570512167657),
(22388, '50230', 218, 16, 50693, 42.3152, 0.738539563639904, -93.4314, -1.63068555474783),
(22389, '50231', 218, 16, 11462, 42.2524, 0.737443496869652, -93.6399, -1.63432456623824),
(22390, '50232', 218, 16, 117469, 41.5867, 0.725824840039126, -93.0233, -1.62356286607044),
(22391, '50233', 218, 16, 11515, 41.5529, 0.725234918751952, -94.1826, -1.64379646808881),
(22392, '50234', 218, 16, 210, 41.9095, 0.731458762864564, -93.1798, -1.62629430634981),
(22393, '50235', 218, 16, 117538, 41.9333, 0.731874151226538, -94.2008, -1.64411411801267),
(22394, '50236', 218, 16, 5513, 42.1663, 0.735940768383685, -93.4999, -1.63188110528545),
(22395, '50237', 218, 16, 117627, 41.5484, 0.725156378935612, -93.4003, -1.63014275735046),
(22396, '50238', 218, 16, 5580, 40.9833, 0.715293523332592, -93.1961, -1.62657879501789),
(22397, '50239', 218, 16, 31028, 42.1334, 0.735366555059779, -93.1998, -1.62664337220021),
(22398, '50240', 218, 16, 11748, 41.3012, 0.720841925024682, -93.7471, -1.63619555919638),
(22399, '50241', 218, 16, 24606, 41.3061, 0.72092744615803, -93.7342, -1.63597041172287),
(22400, '50242', 218, 16, 117716, 41.5552, 0.725275061324748, -92.6988, -1.61789927264772),
(22401, '50243', 218, 16, 117754, 41.8651, 0.730683836676678, -93.6946, -1.63527926133908),
(22402, '50244', 218, 16, 60, 41.8797, 0.730938654747469, -93.6812, -1.63504538721931),
(22403, '50246', 218, 16, 38360, 42.2896, 0.738092759351394, -93.7953, -1.63703680789584),
(22404, '50247', 218, 16, 117897, 42.0125, 0.733256451994118, -93.1626, -1.62599410971847),
(22405, '50248', 218, 16, 117918, 42.1832, 0.736235729027272, -93.5903, -1.63345888292925),
(22406, '50249', 218, 16, 14683, 42.2715, 0.737776854756783, -93.9261, -1.63931969855745),
(22407, '50250', 218, 16, 12169, 41.5045, 0.724390179393987, -94.3156, -1.64611775599396),
(22408, '50251', 218, 16, 111588, 41.5771, 0.725657288430934, -92.8421, -1.62040032946583),
(22409, '50252', 218, 16, 25280, 41.4406, 0.723274914001962, -93.3491, -1.62924914877344),
(22410, '50254', 218, 16, 28771, 40.9836, 0.715298759320348, -94.0714, -1.64185566196059),
(22411, '50255', 218, 16, 12309, 41.4667, 0.723730444936733, -92.354, -1.61188137738684),
(22412, '50256', 218, 16, 38571, 41.2802, 0.720475405881763, -92.8747, -1.62096930680198),
(22413, '50257', 218, 16, 74574, 41.208, 0.719215278161823, -93.8454, -1.63791121785109),
(22414, '50258', 218, 16, 455, 42.1722, 0.736043742809553, -93.0844, -1.62462926224341),
(22415, '50259', 218, 16, 9105, 42.2524, 0.737443496869652, -93.0592, -1.62418943927191),
(22416, '50261', 218, 16, 74640, 41.5271, 0.724784623804937, -93.9576, -1.63986947727182),
(22417, '50262', 218, 16, 25694, 40.8547, 0.713049029914527, -93.8436, -1.63787980192455),
(22418, '50263', 218, 16, 118346, 41.6018, 0.726088384756177, -93.8698, -1.63833707818857),
(22419, '50264', 218, 16, 635, 40.8555, 0.713062992548543, -93.7288, -1.63587616394326),
(22420, '50265', 218, 16, 118391, 41.5815, 0.725734082918022, -93.7547, -1.63632820421953),
(22421, '50266', 218, 16, 118391, 41.5872, 0.725833566685386, -93.7664, -1.63653240774201),
(22422, '50268', 218, 16, 118441, 41.3799, 0.722215499146002, -92.3541, -1.6118831227161),
(22423, '50269', 218, 16, 118458, 42.252, 0.737436515552644, -93.0597, -1.62419816591817),
(22424, '50271', 218, 16, 878, 42.4866, 0.741531057977823, -93.542, -1.63261588890054),
(22425, '50272', 218, 16, 12870, 41.1169, 0.717625283213256, -93.2703, -1.62787382932287),
(22426, '50273', 218, 16, 118498, 41.3349, 0.721430100982604, -94.0154, -1.64087827757948),
(22427, '50274', 218, 16, 118501, 41.4034, 0.72262565152022, -94.8883, -1.65611325662014),
(22428, '50275', 218, 16, 29018, 40.9862, 0.7153441378809, -93.6144, -1.63387950727898),
(22429, '50276', 218, 16, 6955, 41.8547, 0.730502322434471, -93.9225, -1.63925686670437),
(22430, '50277', 218, 16, 12986, 41.774, 0.729093841728111, -94.356, -1.64682286901177),
(22431, '50278', 218, 16, 118557, 42.1622, 0.735869209884353, -93.3067, -1.62850912917059),
(22432, '50301', 218, 16, 115259, 41.6052, 0.726147725950745, -93.6323, -1.63419192121509),
(22433, '50302', 218, 16, 115259, 41.6048, 0.726140744633737, -93.6318, -1.63418319456883),
(22434, '50303', 218, 16, 115259, 41.6049, 0.726142489962989, -93.6314, -1.63417621325182),
(22435, '50304', 218, 16, 115259, 41.6051, 0.726145980621493, -93.6315, -1.63417795858107),
(22436, '50305', 218, 16, 115259, 41.605, 0.726144235292241, -93.6311, -1.63417097726406),
(22437, '50306', 218, 16, 115259, 41.6046, 0.726137253975233, -93.6312, -1.63417272259331),
(22438, '50307', 218, 16, 115259, 41.5938, 0.725948758416017, -93.6018, -1.63365959579323),
(22439, '50308', 218, 16, 115259, 41.585, 0.725795169441842, -93.6192, -1.63396328308308),
(22440, '50309', 218, 16, 115259, 41.586, 0.725812622734362, -93.6185, -1.63395106577831),
(22441, '50310', 218, 16, 115259, 41.6262, 0.726514245093664, -93.6723, -1.63489005291588),
(22442, '50311', 218, 16, 115259, 41.6024, 0.726098856731689, -93.687, -1.63514661631593),
(22443, '50312', 218, 16, 115259, 41.5862, 0.725816113392866, -93.678, -1.63498953668325),
(22444, '50313', 218, 16, 115259, 41.6421, 0.726791752444731, -93.6156, -1.63390045123),
(22445, '50314', 218, 16, 115259, 41.6029, 0.726107583377949, -93.6313, -1.63417446792257),
(22446, '50315', 218, 16, 115259, 41.547, 0.725131944326084, -93.6183, -1.63394757511981),
(22447, '50316', 218, 16, 115259, 41.6076, 0.726189613852793, -93.5967, -1.63357058400138),
(22448, '50317', 218, 16, 115259, 41.6054, 0.726151216609249, -93.5436, -1.63264381416857),
(22449, '50318', 218, 16, 115259, 41.5847, 0.725789933454086, -93.6196, -1.63397026440008),
(22450, '50319', 218, 16, 115259, 41.5926, 0.725927814464993, -93.6, -1.63362817986669),
(22451, '50320', 218, 16, 115259, 41.5449, 0.725095292411792, -93.5821, -1.63331576593059),
(22452, '50321', 218, 16, 115259, 41.5455, 0.725105764387304, -93.6764, -1.63496161141522),
(22453, '50322', 218, 16, 28840, 41.6257, 0.726505518447404, -93.7361, -1.63600357297866),
(22454, '50323', 218, 16, 28840, 41.62, 0.72640603468004, -93.8021, -1.63715549028497),
(22455, '50325', 218, 16, 115036, 41.605, 0.726144235292241, -93.75, -1.63624617374468),
(22456, '50327', 218, 16, 115259, 41.6007, 0.726069186134405, -93.609, -1.63378525949937),
(22457, '50328', 218, 16, 115259, 41.5861, 0.725814368063614, -93.6378, -1.63428791432395),
(22458, '50329', 218, 16, 115259, 41.5855, 0.725803896088102, -93.6375, -1.63428267833619),
(22459, '50330', 218, 16, 115259, 41.586, 0.725812622734362, -93.6373, -1.63427918767769),
(22460, '50331', 218, 16, 115259, 41.5858, 0.725809132075858, -93.6371, -1.63427569701918),
(22461, '50332', 218, 16, 115259, 41.5861, 0.725814368063614, -93.6377, -1.63428616899469),
(22462, '50333', 218, 16, 115259, 41.6802, 0.727456722889741, -93.6082, -1.63377129686536),
(22463, '50334', 218, 16, 115259, 41.6294, 0.726570095629727, -93.7126, -1.63559342060444),
(22464, '50335', 218, 16, 115259, 41.5959, 0.725985410330309, -93.6198, -1.63397375505859),
(22465, '50336', 218, 16, 115259, 41.5696, 0.725526388737035, -93.7161, -1.63565450712826),
(22466, '50338', 218, 16, 115259, 41.6091, 0.726215793791573, -93.6477, -1.63446070191989),
(22467, '50339', 218, 16, 115259, 41.5965, 0.725995882305821, -93.7465, -1.63618508722086),
(22468, '50340', 218, 16, 115259, 41.5846, 0.725788188124834, -93.6176, -1.63393535781504),
(22469, '50347', 218, 16, 115259, 41.5844, 0.72578469746633, -93.7132, -1.63560389257995),
(22470, '50350', 218, 16, 115259, 41.5836, 0.725770734832314, -93.714, -1.63561785521397),
(22471, '50359', 218, 16, 115259, 41.5953, 0.725974938354797, -93.765, -1.63650797313248),
(22472, '50360', 218, 16, 115259, 41.5955, 0.725978429013301, -93.7652, -1.63651146379099),
(22473, '50361', 218, 16, 115259, 41.5951, 0.725971447696293, -93.7656, -1.636518445108),
(22474, '50362', 218, 16, 115259, 41.5956, 0.725980174342553, -93.7655, -1.63651669977874),
(22475, '50363', 218, 16, 115259, 41.5959, 0.725985410330309, -93.7648, -1.63650448247398),
(22476, '50364', 218, 16, 115259, 41.5957, 0.725981919671805, -93.7652, -1.63651146379099),
(22477, '50367', 218, 16, 115259, 41.5958, 0.725983665001057, -93.7655, -1.63651669977874),
(22478, '50368', 218, 16, 115259, 41.5957, 0.725981919671805, -93.765, -1.63650797313248),
(22479, '50369', 218, 16, 115259, 41.5946, 0.725962721050033, -93.7477, -1.63620603117189),
(22480, '50380', 218, 16, 115259, 41.584, 0.725777716149322, -93.6388, -1.63430536761647),
(22481, '50381', 218, 16, 115259, 41.5837, 0.725772480161566, -93.6393, -1.63431409426273),
(22482, '50391', 218, 16, 115259, 41.5859, 0.72581087740511, -93.6204, -1.6339842270341),
(22483, '50392', 218, 16, 115259, 41.5878, 0.725844038660898, -93.6272, -1.63410290942323),
(22484, '50393', 218, 16, 115259, 41.5834, 0.72576724417381, -93.6222, -1.63401564296064),
(22485, '50394', 218, 16, 115259, 41.63, 0.726580567605239, -93.6738, -1.63491623285466),
(22486, '50395', 218, 16, 115259, 41.6046, 0.726137253975233, -93.6313, -1.63417446792257),
(22487, '50396', 218, 16, 115259, 41.5854, 0.72580215075885, -93.6096, -1.63379573147488),
(22488, '50397', 218, 16, 115259, 41.5956, 0.725980174342553, -93.62, -1.63397724571709),
(22489, '50398', 218, 16, 118391, 41.5775, 0.725664269747942, -93.7115, -1.63557422198267),
(22490, '50401', 218, 16, 4032, 43.149, 0.753092118943033, -93.1999, -1.62664511752946),
(22491, '50402', 218, 16, 4032, 43.1534, 0.753168913430121, -93.2011, -1.62666606148049),
(22492, '50420', 218, 16, 7048, 42.8194, 0.74733951372846, -93.4389, -1.63081645444173),
(22493, '50421', 218, 16, 114557, 42.848, 0.74783867789453, -93.6113, -1.63382540207217),
(22494, '50423', 218, 16, 19512, 43.0958, 0.752163603780972, -93.8018, -1.63715025429722),
(22495, '50424', 218, 16, 114758, 43.3878, 0.757259965196796, -93.9483, -1.63970716165139),
(22496, '50426', 218, 16, 1369, 43.4276, 0.757954606239089, -92.916, -1.62169012778305),
(22497, '50427', 218, 16, 26757, 42.8356, 0.747622257067283, -93.223, -1.62704828858667),
(22498, '50428', 218, 16, 8114, 43.1365, 0.752873952786534, -93.3831, -1.62984256071912),
(22499, '50430', 218, 16, 115115, 42.9926, 0.750362423992914, -93.956, -1.63984155200379),
(22500, '50431', 218, 16, 54228, 42.7364, 0.745890890449305, -93.3681, -1.62958076133132),
(22501, '50432', 218, 16, 15682, 43.2239, 0.754399370552777, -93.7891, -1.63692859748221),
(22502, '50433', 218, 16, 20649, 42.9206, 0.749105786931478, -93.0418, -1.62388575198206),
(22503, '50434', 218, 16, 54748, 43.2654, 0.755123682192355, -93.4221, -1.63052323912739),
(22504, '50435', 218, 16, 2508, 43.1271, 0.752709891836846, -92.7371, -1.61856773375123),
(22505, '50436', 218, 16, 16058, 43.2646, 0.755109719558339, -93.6418, -1.63435772749403),
(22506, '50438', 218, 16, 9061, 43.0987, 0.75221421832928, -93.6118, -1.63383412871843),
(22507, '50439', 218, 16, 115763, 42.9247, 0.74917734543081, -93.6158, -1.63390394188851),
(22508, '50440', 218, 16, 27298, 43.3276, 0.756209276987095, -93.0725, -1.62442156806242),
(22509, '50441', 218, 16, 2957, 42.7434, 0.746013063496944, -93.2067, -1.6267637999186),
(22510, '50444', 218, 16, 115923, 43.2792, 0.75536453762913, -93.3784, -1.62976053024427),
(22511, '50446', 218, 16, 116263, 43.3627, 0.756821887554545, -93.4553, -1.63110268843906),
(22512, '50447', 218, 16, 95245, 42.9369, 0.749390275599553, -93.7909, -1.63696001340875),
(22513, '50448', 218, 16, 9833, 43.3538, 0.756666553251118, -93.2298, -1.62716697097581),
(22514, '50449', 218, 16, 116331, 43.0457, 0.751289193825723, -93.4771, -1.63148317021599),
(22515, '50450', 218, 16, 116370, 43.4176, 0.75778007331389, -93.5311, -1.63242564801207),
(22516, '50451', 218, 16, 103489, 43.4092, 0.757633465656723, -94.0546, -1.64156244664626),
(22517, '50452', 218, 16, 33002, 42.7752, 0.746568078199078, -93.3207, -1.62875347526587),
(22518, '50453', 218, 16, 10032, 43.3361, 0.756357629973515, -93.6339, -1.63421984648312),
(22519, '50454', 218, 16, 116566, 43.3918, 0.757329778366876, -92.73, -1.61844381537434),
(22520, '50455', 218, 16, 116793, 43.4644, 0.758596887403823, -92.6129, -1.61640003482026),
(22521, '50456', 218, 16, 66591, 43.288, 0.755518126603305, -93.2018, -1.62667827878525),
(22522, '50457', 218, 16, 116825, 42.9282, 0.74923843195463, -93.4654, -1.63127896669351),
(22523, '50458', 218, 16, 117049, 43.127, 0.752708146507595, -92.9962, -1.62308988184315),
(22524, '50459', 218, 16, 14320, 43.4461, 0.758277492150708, -93.217, -1.62694356883155),
(22525, '50460', 218, 16, 4799, 43.2362, 0.754614046050772, -92.6825, -1.61761478397964),
(22526, '50461', 218, 16, 11002, 43.2845, 0.755457040079486, -92.809, -1.61982262548342),
(22527, '50464', 218, 16, 14433, 43.2468, 0.754799050951484, -93.123, -1.62530295933468),
(22528, '50465', 218, 16, 117452, 43.4649, 0.758605614050083, -93.9108, -1.63905266318189),
(22529, '50466', 218, 16, 11557, 43.3629, 0.756825378213049, -92.55, -1.61530222272075),
(22530, '50467', 218, 16, 117565, 43.2073, 0.754109645896946, -93.085, -1.62463973421892),
(22531, '50468', 218, 16, 5475, 43.0521, 0.751400894897851, -92.947, -1.62223117985117),
(22532, '50469', 218, 16, 11640, 42.9855, 0.750238505616023, -93.1902, -1.62647582059202),
(22533, '50470', 218, 16, 68409, 42.7405, 0.745962448948636, -93.5493, -1.63274329793593),
(22534, '50471', 218, 16, 11720, 43.1276, 0.752718618483107, -92.9043, -1.62148592426057),
(22535, '50472', 218, 16, 117646, 43.3782, 0.757092413588604, -92.9192, -1.62174597831912),
(22536, '50473', 218, 16, 117690, 43.4662, 0.758628303330359, -93.6549, -1.63458636562604),
(22537, '50475', 218, 16, 5785, 42.8938, 0.748638038691944, -93.2171, -1.62694531416081),
(22538, '50476', 218, 16, 117886, 43.4406, 0.758181499041849, -92.7826, -1.61936185856089),
(22539, '50477', 218, 16, 117974, 42.9499, 0.749617168402313, -93.3149, -1.62865224616926),
(22540, '50478', 218, 16, 6317, 43.3691, 0.756933588626673, -93.7719, -1.63662840085087),
(22541, '50479', 218, 16, 351, 42.9442, 0.749517684634949, -93.3838, -1.62985477802388),
(22542, '50480', 218, 16, 118052, 43.237, 0.754628008684788, -94.041, -1.64132508186799),
(22543, '50481', 218, 16, 118054, 43.4277, 0.757956351568342, -92.9154, -1.62167965580754),
(22544, '50482', 218, 16, 98786, 43.1263, 0.752695929202831, -93.4751, -1.63144826363095),
(22545, '50483', 218, 16, 638, 43.0874, 0.752016996123805, -93.9924, -1.64047685185152),
(22546, '50484', 218, 16, 99177, 43.2307, 0.754518052941913, -93.9084, -1.63901077527984),
(22547, '50501', 218, 16, 32464, 42.507, 0.74188710514523, -94.1803, -1.64375632551602),
(22548, '50510', 218, 16, 114366, 42.7856, 0.746749592441286, -94.961, -1.65738211098634),
(22549, '50511', 218, 16, 114376, 43.071, 0.751730762126478, -94.2296, -1.64461677283725),
(22550, '50514', 218, 16, 7163, 43.3962, 0.757406572853963, -94.4854, -1.64908132506385),
(22551, '50515', 218, 16, 29135, 43.039, 0.75117225676584, -94.8338, -1.6551620521778),
(22552, '50516', 218, 16, 31716, 42.6012, 0.743531205300608, -94.1512, -1.64324843470369),
(22553, '50517', 218, 16, 19038, 43.2912, 0.755573977139369, -94.2164, -1.64438638937599),
(22554, '50518', 218, 16, 92444, 42.5076, 0.741897577120742, -94.3647, -1.64697471265669),
(22555, '50519', 218, 16, 114655, 42.866, 0.748152837159889, -94.2865, -1.64560986518163),
(22556, '50520', 218, 16, 114688, 42.7926, 0.746871765488925, -94.3868, -1.64736043042138),
(22557, '50521', 218, 16, 19652, 42.3362, 0.738906082782823, -94.1119, -1.64256252030765),
(22558, '50522', 218, 16, 58842, 43.1979, 0.753945584947258, -94.2216, -1.64447714649709),
(22559, '50523', 218, 16, 114802, 42.3617, 0.739351141742082, -94.2919, -1.64570411296124),
(22560, '50524', 218, 16, 32072, 42.5874, 0.743290349863833, -94.3455, -1.64663960944031),
(22561, '50525', 218, 16, 72110, 42.7318, 0.745810605303713, -93.7315, -1.63592328783307),
(22562, '50526', 218, 16, 72110, 42.732, 0.745814095962217, -93.7322, -1.63593550513783),
(22563, '50527', 218, 16, 15694, 42.9597, 0.749788210669008, -94.8258, -1.65502242583764),
(22564, '50528', 218, 16, 115175, 43.0894, 0.752051902708845, -94.5494, -1.65019833578513),
(22565, '50529', 218, 16, 115181, 42.7207, 0.745616873756742, -94.2012, -1.64412109932968),
(22566, '50530', 218, 16, 1992, 42.2654, 0.737670389672411, -94.0645, -1.64173523424221),
(22567, '50531', 218, 16, 115291, 43.4655, 0.758616086025595, -94.6193, -1.65141832093227),
(22568, '50532', 218, 16, 115348, 42.4689, 0.74122213470022, -93.9921, -1.64047161586376),
(22569, '50533', 218, 16, 20735, 42.6649, 0.744642980034129, -93.9041, -1.63893572612201),
(22570, '50535', 218, 16, 15851, 42.4587, 0.741044111116516, -95.0926, -1.65967896428196),
(22571, '50536', 218, 16, 115477, 43.1102, 0.752414931193259, -94.6805, -1.65248646243449),
(22572, '50538', 218, 16, 115545, 42.2782, 0.737893791816667, -94.4028, -1.6476396831017),
(22573, '50539', 218, 16, 2431, 43.2167, 0.754273706846633, -94.4088, -1.64774440285682),
(22574, '50540', 218, 16, 75848, 42.5834, 0.743220536693753, -94.8431, -1.65532436779823),
(22575, '50541', 218, 16, 115739, 42.7312, 0.745800133328201, -94.4382, -1.64825752965691),
(22576, '50542', 218, 16, 115760, 42.7344, 0.745855983864265, -93.9215, -1.63923941341185),
(22577, '50543', 218, 16, 115769, 42.2809, 0.737940915706471, -94.2911, -1.64569015032723),
(22578, '50544', 218, 16, 36277, 42.2612, 0.737597085843828, -94.1762, -1.64368476701668),
(22579, '50545', 218, 16, 2973, 42.811, 0.747192906071292, -94.0518, -1.6415135774272),
(22580, '50546', 218, 16, 65428, 42.843, 0.747751411431931, -94.7379, -1.65348828142514),
(22581, '50548', 218, 16, 27486, 42.7213, 0.745627345732254, -94.221, -1.64446667452158),
(22582, '50551', 218, 16, 116264, 42.5128, 0.741988334241845, -94.7454, -1.65361918111904),
(22583, '50552', 218, 16, 116336, 42.4556, 0.740990005909705, -94.4578, -1.6485996141903),
(22584, '50554', 218, 16, 82032, 42.8475, 0.74782995124827, -94.8487, -1.65542210623635),
(22585, '50556', 218, 16, 116447, 43.4428, 0.758219896285393, -94.1473, -1.64318036686286),
(22586, '50557', 218, 16, 3725, 42.4702, 0.741244823980496, -93.9899, -1.64043321862022),
(22587, '50558', 218, 16, 36928, 42.869, 0.748205197037449, -94.184, -1.64382090269834),
(22588, '50559', 218, 16, 10172, 43.2208, 0.754345265345965, -94.3242, -1.64626785430964),
(22589, '50560', 218, 16, 116629, 42.9134, 0.748980123225335, -94.084, -1.64207557344635),
(22590, '50561', 218, 16, 116655, 42.4248, 0.74045244450009, -94.8598, -1.65561583778332),
(22591, '50562', 218, 16, 95967, 42.9372, 0.749395511587309, -94.6843, -1.65255278494607),
(22592, '50563', 218, 16, 10293, 42.529, 0.742271077580668, -94.5355, -1.6499557350191),
(22593, '50565', 218, 16, 17017, 42.8599, 0.748046372075518, -94.984, -1.65778353671429),
(22594, '50566', 218, 16, 37265, 42.4474, 0.740846888911041, -94.2908, -1.64568491433947),
(22595, '50567', 218, 16, 116985, 42.5155, 0.742035458131649, -95.0894, -1.6596231137459),
(22596, '50568', 218, 16, 4567, 42.6062, 0.743618471763208, -95.0028, -1.65811165861367),
(22597, '50569', 218, 16, 4809, 42.4294, 0.740532729645682, -94.1618, -1.6434334396044),
(22598, '50570', 218, 16, 117189, 42.8961, 0.74867818126474, -94.3776, -1.6471998601302),
(22599, '50571', 218, 16, 337, 42.6321, 0.744070512039475, -94.5988, -1.65106052843561),
(22600, '50573', 218, 16, 97137, 42.8645, 0.748126657221109, -94.6197, -1.65142530224928),
(22601, '50574', 218, 16, 5158, 42.7345, 0.745857729193517, -94.6712, -1.65232414681406),
(22602, '50575', 218, 16, 33663, 42.7345, 0.745857729193517, -94.6839, -1.65254580362906),
(22603, '50576', 218, 16, 117488, 42.8251, 0.747438997495824, -95.1649, -1.66094083733115),
(22604, '50577', 218, 16, 117492, 42.8281, 0.747491357373383, -93.9779, -1.64022377910998),
(22605, '50578', 218, 16, 117536, 43.234, 0.754575648807228, -94.32, -1.64619455048105),
(22606, '50579', 218, 16, 117584, 42.3966, 0.739960261651028, -94.6332, -1.6516609216983),
(22607, '50581', 218, 16, 111184, 42.814, 0.747245265948852, -94.5297, -1.64985450592248),
(22608, '50582', 218, 16, 17882, 42.7596, 0.746295806835767, -94.2919, -1.64570411296124),
(22609, '50583', 218, 16, 117642, 42.4197, 0.740363432708239, -94.9938, -1.65795457898099),
(22610, '50585', 218, 16, 117806, 42.8912, 0.748592660131392, -95.1471, -1.6606301687243),
(22611, '50586', 218, 16, 106389, 42.377, 0.739618177117637, -94.4294, -1.64810394068273),
(22612, '50588', 218, 16, 117916, 42.6414, 0.74423282765991, -95.2028, -1.66160231711766),
(22613, '50590', 218, 16, 117981, 43.3831, 0.757177934721952, -94.3091, -1.64600430959258),
(22614, '50591', 218, 16, 84020, 42.6883, 0.745051387079095, -94.0507, -1.64149437880543),
(22615, '50592', 218, 16, 57945, 42.7292, 0.745765226743161, -95.1823, -1.661244524621),
(22616, '50593', 218, 16, 107106, 42.6316, 0.744061785393215, -94.8161, -1.6548531289002),
(22617, '50594', 218, 16, 6568, 42.5906, 0.743346200399897, -94.0193, -1.6409463454203),
(22618, '50595', 218, 16, 118364, 42.4657, 0.741166284164156, -93.8198, -1.63746441356258),
(22619, '50597', 218, 16, 6703, 42.9605, 0.749802173303024, -94.4454, -1.64838319336305),
(22620, '50598', 218, 16, 118463, 43.0601, 0.75154052123801, -94.4211, -1.64795907835482),
(22621, '50599', 218, 16, 118522, 42.6007, 0.743522478654348, -93.7942, -1.63701760927407),
(22622, '50601', 218, 16, 114340, 42.5512, 0.742658540674611, -93.0515, -1.6240550489195),
(22623, '50602', 218, 16, 7064, 42.7598, 0.746299297494271, -92.8009, -1.61968125381401),
(22624, '50603', 218, 16, 18822, 43.1481, 0.753076410979765, -92.4357, -1.61330731138572),
(22625, '50604', 218, 16, 114421, 42.5832, 0.743217046035249, -92.8832, -1.6211176597884),
(22626, '50605', 218, 16, 114429, 42.8344, 0.747601313116259, -93.0029, -1.62320681890303),
(22627, '50606', 218, 16, 15026, 42.7688, 0.746456377126951, -91.6946, -1.60037267629919),
(22628, '50607', 218, 16, 474, 42.622, 0.743894233785023, -91.7331, -1.60104462806121),
(22629, '50608', 218, 16, 99555, 42.5993, 0.74349804404482, -92.9668, -1.62257675504306),
(22630, '50609', 218, 16, 112404, 42.2203, 0.736883246179762, -92.8218, -1.62004602762767),
(22631, '50611', 218, 16, 1144, 42.7731, 0.746531426284787, -92.9055, -1.62150686821159),
(22632, '50612', 218, 16, 793, 42.3122, 0.738487203762345, -92.3784, -1.61230723772433),
(22633, '50613', 218, 16, 63543, 42.5282, 0.742257114946652, -92.4505, -1.61356562011502),
(22634, '50614', 218, 16, 63543, 42.5125, 0.741983098254089, -92.4593, -1.61371920908919),
(22635, '50616', 218, 16, 100697, 43.0672, 0.751664439614902, -92.6734, -1.61745595901771),
(22636, '50619', 218, 16, 848, 42.7797, 0.746646618015418, -92.663, -1.61727444477551),
(22637, '50620', 218, 16, 1722, 43.0702, 0.751716799492462, -92.7139, -1.61816281736477),
(22638, '50621', 218, 16, 15601, 42.2267, 0.73699494725189, -92.872, -1.62092218291217),
(22639, '50622', 218, 16, 2033, 42.6694, 0.744721519850469, -92.3342, -1.61153580219495),
(22640, '50623', 218, 16, 75648, 42.5296, 0.74228154955618, -92.2134, -1.60942744445854),
(22641, '50624', 218, 16, 93743, 42.4052, 0.740110359966699, -92.6874, -1.61770030511299),
(22642, '50625', 218, 16, 115345, 42.7643, 0.746377837310611, -92.9792, -1.62279317587031),
(22643, '50626', 218, 16, 115350, 42.577, 0.743108835621626, -92.1699, -1.60866822623392),
(22644, '50627', 218, 16, 15908, 42.3648, 0.739405246948894, -93.0962, -1.62483521109514),
(22645, '50628', 218, 16, 101709, 43.2452, 0.754771125683452, -92.4371, -1.61333174599525),
(22646, '50629', 218, 16, 46951, 42.6382, 0.744176977123846, -92.0498, -1.60657208580228),
(22647, '50630', 218, 16, 29848, 42.9657, 0.749892930424128, -92.1972, -1.60914470111972),
(22648, '50631', 218, 16, 115639, 42.8041, 0.747072478352905, -92.2682, -1.61038388488863),
(22649, '50632', 218, 16, 115704, 42.093, 0.734661442041973, -92.6746, -1.61747690296874),
(22650, '50633', 218, 16, 2687, 42.6769, 0.744852419544368, -93.1312, -1.62544607633334),
(22651, '50634', 218, 16, 115732, 42.4164, 0.740305836842923, -92.213, -1.60942046314153),
(22652, '50635', 218, 16, 112999, 42.1847, 0.736261908966052, -92.7147, -1.61817677999879),
(22653, '50636', 218, 16, 115859, 42.8975, 0.748702615874268, -92.8043, -1.61974059500857),
(22654, '50638', 218, 16, 115888, 42.3602, 0.739324961803302, -92.7732, -1.6191977976112),
(22655, '50641', 218, 16, 30043, 42.6174, 0.743813948639432, -91.9036, -1.60402041443586),
(22656, '50642', 218, 16, 9533, 42.3998, 0.740016112187092, -92.7984, -1.61963762058271),
(22657, '50643', 218, 16, 16505, 42.3821, 0.739707188909489, -92.4611, -1.61375062501573),
(22658, '50644', 218, 16, 3320, 42.4699, 0.74123958799274, -91.8965, -1.60389649605897),
(22659, '50645', 218, 16, 9664, 43.0391, 0.751174002095091, -92.4945, -1.6143335649859),
(22660, '50647', 218, 16, 27546, 42.635, 0.744121126587782, -92.4949, -1.6143405463029),
(22661, '50648', 218, 16, 9762, 42.476, 0.741346053077111, -92.0622, -1.60678850662952),
(22662, '50649', 218, 16, 116311, 42.6867, 0.745023461811063, -92.8486, -1.62051377586721),
(22663, '50650', 218, 16, 9971, 42.5997, 0.743505025361828, -91.6418, -1.59945114245414),
(22664, '50651', 218, 16, 116352, 42.3318, 0.738829288295736, -92.1963, -1.60912899315645),
(22665, '50652', 218, 16, 3781, 42.2636, 0.737638973745875, -92.6908, -1.61775964630756),
(22666, '50653', 218, 16, 116721, 42.9627, 0.749840570546568, -92.9167, -1.62170234508782),
(22667, '50654', 218, 16, 10349, 42.5125, 0.741983098254089, -91.5493, -1.59783671289604),
(22668, '50655', 218, 16, 4057, 42.7737, 0.746541898260298, -91.881, -1.60362597002491),
(22669, '50657', 218, 16, 42178, 42.3724, 0.739537891972045, -92.7931, -1.61954511813235),
(22670, '50658', 218, 16, 17237, 42.9478, 0.749580516488021, -92.5378, -1.61508929255201),
(22671, '50659', 218, 16, 117003, 43.0592, 0.751524813274742, -92.3148, -1.61119720832006),
(22672, '50660', 218, 16, 28028, 42.5852, 0.743251952620289, -92.6487, -1.61702486269247),
(22673, '50661', 218, 16, 117063, 43.0598, 0.751535285250254, -92.3128, -1.61116230173502),
(22674, '50662', 218, 16, 117107, 42.6771, 0.744855910202872, -91.9134, -1.60419145670256),
(22675, '50664', 218, 16, 23682, 42.7087, 0.745407434246502, -91.8742, -1.60350728763577),
(22676, '50665', 218, 16, 23761, 42.5761, 0.743093127658358, -92.789, -1.61947355963302),
(22677, '50666', 218, 16, 11247, 42.8433, 0.747756647419687, -92.5343, -1.61502820602819),
(22678, '50667', 218, 16, 24225, 42.4682, 0.741209917395456, -92.2207, -1.60955485349393),
(22679, '50668', 218, 16, 117468, 42.7041, 0.74532714910091, -92.226, -1.60964735594429),
(22680, '50669', 218, 16, 117487, 42.3122, 0.738487203762345, -92.6252, -1.61661471031825),
(22681, '50670', 218, 16, 117756, 42.7114, 0.745454558136306, -92.5813, -1.61584851077663),
(22682, '50671', 218, 16, 196, 42.6425, 0.744252026281682, -91.8104, -1.602393767573),
(22683, '50672', 218, 16, 117901, 42.4087, 0.740171446490519, -93.0655, -1.62429939501478),
(22684, '50673', 218, 16, 61902, 42.5791, 0.743145487535917, -92.7619, -1.61900057540573),
(22685, '50674', 218, 16, 18216, 42.8507, 0.747885801784334, -92.0987, -1.6074255518065),
(22686, '50675', 218, 16, 118063, 42.1907, 0.736366628721172, -92.4792, -1.61406652961034),
(22687, '50676', 218, 16, 118070, 42.8072, 0.747126583559717, -92.2581, -1.61020760663418),
(22688, '50677', 218, 16, 6664, 42.7262, 0.745712866865601, -92.4742, -1.61397926314774),
(22689, '50680', 218, 16, 38797, 42.4317, 0.740572872218478, -92.9285, -1.62190829393955),
(22690, '50681', 218, 16, 18573, 42.8181, 0.747316824448184, -92.0228, -1.60610084690424),
(22691, '50682', 218, 16, 12913, 42.4724, 0.74128322122404, -91.7344, -1.60106731734149),
(22692, '50701', 218, 16, 6650, 42.4764, 0.741353034394119, -92.367, -1.6121082701896),
(22693, '50702', 218, 16, 6650, 42.4703, 0.741246569309748, -92.33, -1.61146249836636),
(22694, '50703', 218, 16, 6650, 42.5144, 0.742016259509877, -92.3204, -1.61129494675817),
(22695, '50704', 218, 16, 6650, 42.5278, 0.742250133629644, -92.2715, -1.61044148075395),
(22696, '50706', 218, 16, 6650, 42.4112, 0.740215079721819, -92.2672, -1.61036643159611),
(22697, '50707', 218, 16, 15960, 42.4776, 0.741373978345143, -92.2786, -1.61056539913084),
(22698, '50799', 218, 16, 6650, 42.4917, 0.741620069769675, -92.3508, -1.61182552685078),
(22699, '50801', 218, 16, 35429, 41.06, 0.716632190868872, -94.3648, -1.64697645798595),
(22700, '50830', 218, 16, 570, 41.0276, 0.716066704191226, -94.1976, -1.64405826747661),
(22701, '50831', 218, 16, 114433, 40.984, 0.715305740637356, -94.0714, -1.64185566196059),
(22702, '50833', 218, 16, 146, 40.6802, 0.710003430369797, -94.7101, -1.65300307989308),
(22703, '50835', 218, 16, 358, 40.7279, 0.710835952422998, -94.3985, -1.64756463394387),
(22704, '50836', 218, 16, 114636, 40.6488, 0.709455396984671, -94.5279, -1.64982308999595),
(22705, '50837', 218, 16, 19494, 41.1805, 0.718735312617525, -94.6428, -1.65182847330649),
(22706, '50839', 218, 16, 26706, 40.9427, 0.714584919656282, -94.8717, -1.6558235319643),
(22707, '50840', 218, 16, 13564, 40.8011, 0.712113533435458, -94.4769, -1.64893297207743),
(22708, '50841', 218, 16, 8235, 40.9918, 0.715441876319012, -94.7372, -1.65347606412037),
(22709, '50842', 218, 16, 1893, 41.0803, 0.716986492707027, -94.3905, -1.64742500760371),
(22710, '50843', 218, 16, 20409, 41.2448, 0.719857559326557, -94.8706, -1.65580433334253),
(22711, '50845', 218, 16, 115273, 40.8336, 0.712680765442356, -94.3574, -1.6468473036213),
(22712, '50846', 218, 16, 115593, 41.2918, 0.720677864074995, -94.5639, -1.65045140852667),
(22713, '50847', 218, 16, 104, 41.1154, 0.717599103274477, -94.984, -1.65778353671429),
(22714, '50848', 218, 16, 115834, 40.7578, 0.711357805869345, -94.7447, -1.65360696381427),
(22715, '50849', 218, 16, 2861, 41.3052, 0.720911738194762, -94.4602, -1.64864150209235),
(22716, '50851', 218, 16, 425, 40.8818, 0.713522014141818, -94.5602, -1.65038683134434),
(22717, '50853', 218, 16, 116768, 41.2539, 0.720016384288489, -94.7686, -1.6540240975055),
(22718, '50854', 218, 16, 116948, 40.7146, 0.710603823632483, -94.237, -1.6447459272019),
(22719, '50857', 218, 16, 56546, 40.943, 0.714590155644038, -94.8717, -1.6558235319643),
(22720, '50858', 218, 16, 28156, 41.2019, 0.719108813077452, -94.4204, -1.64794686105005),
(22721, '50859', 218, 16, 5219, 41.0286, 0.716084157483745, -94.5278, -1.6498213446667),
(22722, '50860', 218, 16, 11513, 40.6054, 0.708697924089306, -94.3572, -1.64684381296279),
(22723, '50861', 218, 16, 117739, 40.9413, 0.714560485046754, -94.2429, -1.64484890162776),
(22724, '50862', 218, 16, 24795, 40.8021, 0.712130986727978, -94.6364, -1.65171677223436),
(22725, '50863', 218, 16, 57911, 40.8522, 0.713005396683228, -94.1933, -1.64398321831877),
(22726, '50864', 218, 16, 118208, 40.9287, 0.714340573561003, -94.9771, -1.65766310899591),
(22727, '50936', 218, 16, 115259, 41.5835, 0.725768989503062, -93.639, -1.63430885827497),
(22728, '50940', 218, 16, 115259, 41.5825, 0.725751536210542, -93.6288, -1.63413083469127),
(22729, '50947', 218, 16, 115259, 41.5834, 0.72576724417381, -93.6289, -1.63413258002052),
(22730, '50950', 218, 16, 115259, 41.5821, 0.725744554893534, -93.6288, -1.63413083469127),
(22731, '50980', 218, 16, 115259, 41.5837, 0.725772480161566, -93.6386, -1.63430187695796),
(22732, '50981', 218, 16, 115259, 41.5835, 0.725768989503062, -93.639, -1.63430885827497),
(22733, '51001', 218, 16, 215, 42.8272, 0.747475649410115, -96.5538, -1.6851817153121),
(22734, '51002', 218, 16, 29092, 42.6706, 0.744742463801492, -95.3043, -1.66337382630843),
(22735, '51003', 218, 16, 14977, 42.9872, 0.750268176213306, -96.0107, -1.67570283214452),
(22736, '51004', 218, 16, 74997, 42.3883, 0.739815399323112, -95.8847, -1.67350371728701),
(22737, '51005', 218, 16, 114468, 42.7149, 0.745515644660126, -95.4347, -1.66564973565303),
(22738, '51006', 218, 16, 79687, 42.3225, 0.7386669726753, -95.5928, -1.66840910120044),
(22739, '51007', 218, 16, 15335, 42.4117, 0.740223806368079, -96.2124, -1.67922316124579),
(22740, '51008', 218, 16, 114730, 42.8091, 0.747159744815505, -96.2676, -1.68018658299289),
(22741, '51009', 218, 16, 1298, 42.9453, 0.749536883256721, -95.5501, -1.66766384560983),
(22742, '51010', 218, 16, 114873, 42.0738, 0.73432633882559, -95.9084, -1.67391736031973),
(22743, '51011', 218, 16, 19964, 43.0111, 0.750685309904533, -96.4347, -1.68310302817298),
(22744, '51012', 218, 16, 5, 42.7499, 0.746126509898324, -95.5577, -1.66779649063299),
(22745, '51014', 218, 16, 115015, 42.8123, 0.747215595351568, -95.7114, -1.6704790616933),
(22746, '51015', 218, 16, 115025, 42.3478, 0.739108540976055, -96.0935, -1.67714796476517),
(22747, '51016', 218, 16, 115113, 42.4764, 0.741353034394119, -95.7838, -1.67174268007174),
(22748, '51018', 218, 16, 75594, 42.4647, 0.741148830871636, -95.6759, -1.66985946980884),
(22749, '51019', 218, 16, 64114, 42.2606, 0.737586613868316, -95.7835, -1.67173744408399),
(22750, '51020', 218, 16, 32510, 42.5061, 0.741871397181962, -95.4169, -1.66533906704618),
(22751, '51022', 218, 16, 55048, 42.9832, 0.750198363043227, -95.9042, -1.67384405649115),
(22752, '51023', 218, 16, 115979, 43.0007, 0.750503795662326, -96.4812, -1.68391460627515),
(22753, '51024', 218, 16, 3161, 42.6224, 0.743901215102031, -96.2958, -1.68067876584196),
(22754, '51025', 218, 16, 55353, 42.4865, 0.741529312648571, -95.5438, -1.66755388986696),
(22755, '51026', 218, 16, 116081, 42.2551, 0.737490620759456, -96.0935, -1.67714796476517),
(22756, '51027', 218, 16, 116163, 42.9753, 0.750060482032319, -96.3164, -1.68103830366787),
(22757, '51028', 218, 16, 16734, 42.633, 0.744086220002743, -96.0611, -1.67658247808752),
(22758, '51029', 218, 16, 55809, 42.8619, 0.748081278660558, -95.545, -1.66757483381798),
(22759, '51030', 218, 16, 22591, 42.4784, 0.741387940979159, -96.186, -1.67876239432327),
(22760, '51031', 218, 16, 116429, 42.7878, 0.74678798968483, -96.1727, -1.67853026553275),
(22761, '51033', 218, 16, 116554, 42.8898, 0.748568225521864, -95.2461, -1.66235804468377),
(22762, '51034', 218, 16, 30422, 42.1602, 0.735834303299313, -95.8031, -1.67207952861738),
(22763, '51035', 218, 16, 37055, 42.8217, 0.747379656301256, -95.8051, -1.67211443520242),
(22764, '51036', 218, 16, 37097, 42.9665, 0.749906893058144, -96.1801, -1.6786594198974),
(22765, '51037', 218, 16, 33252, 42.7943, 0.746901436086209, -95.6336, -1.66912119553525),
(22766, '51038', 218, 16, 49421, 42.7233, 0.745662252317293, -96.2479, -1.67984275313025),
(22767, '51039', 218, 16, 116966, 42.4901, 0.741592144501643, -96.0686, -1.67671337778142),
(22768, '51040', 218, 16, 117125, 42.03, 0.733561884613217, -96.0988, -1.67724046721553),
(22769, '51041', 218, 16, 17426, 43.005, 0.750578844820161, -96.059, -1.67654582617323),
(22770, '51044', 218, 16, 56737, 42.2825, 0.737968840974502, -95.8935, -1.67365730626118),
(22771, '51045', 218, 16, 117203, 42.8199, 0.74734824037472, -96.056, -1.67649346629567),
(22772, '51046', 218, 16, 117248, 42.9779, 0.750105860592871, -95.6879, -1.67006890931908),
(22773, '51047', 218, 16, 4973, 42.9184, 0.749067389687934, -95.3404, -1.6640038901684),
(22774, '51048', 218, 16, 17596, 42.545, 0.742550330260987, -95.8677, -1.67320701131417),
(22775, '51049', 218, 16, 42723, 42.6302, 0.744037350783687, -95.6425, -1.66927652983868),
(22776, '51050', 218, 16, 113208, 42.815, 0.747262719241372, -95.9708, -1.67500644577297),
(22777, '51051', 218, 16, 11649, 42.2048, 0.736612720145703, -95.9504, -1.67465039860557),
(22778, '51052', 218, 16, 42954, 42.3062, 0.738382484007225, -96.2761, -1.68033493597931),
(22779, '51053', 218, 16, 117693, 42.4983, 0.741735261500306, -95.2939, -1.66319231206622),
(22780, '51054', 218, 16, 117725, 42.4059, 0.740122577271463, -96.3571, -1.68174865267343),
(22781, '51055', 218, 16, 11975, 42.2338, 0.737118865628781, -96.2234, -1.67941514746351),
(22782, '51056', 218, 16, 11999, 42.2293, 0.737040325812441, -95.9331, -1.67434845664497),
(22783, '51058', 218, 16, 38454, 42.9725, 0.750011612813263, -95.4979, -1.66675278374029),
(22784, '51059', 218, 16, 25588, 42.0207, 0.733399568992781, -95.9649, -1.67490347134711),
(22785, '51060', 218, 16, 118159, 42.0503, 0.733916186451372, -95.7059, -1.67038306858444),
(22786, '51061', 218, 16, 118330, 42.5767, 0.74310359963387, -95.726, -1.67073387976409),
(22787, '51062', 218, 16, 723, 42.7075, 0.745386490295478, -96.4879, -1.68403154333504),
(22788, '51063', 218, 16, 34415, 42.1253, 0.735225183390367, -96.1512, -1.67815501974357),
(22789, '51101', 218, 16, 117804, 42.4942, 0.741663703000974, -96.3933, -1.68238046186265),
(22790, '51102', 218, 16, 117804, 42.4191, 0.740352960732727, -96.3387, -1.68142751209106),
(22791, '51103', 218, 16, 117804, 42.5071, 0.741888850474482, -96.4345, -1.68309953751447),
(22792, '51104', 218, 16, 117804, 42.5236, 0.742176829801061, -96.384, -1.68221814624221),
(22793, '51105', 218, 16, 117804, 42.5024, 0.741806819999638, -96.376, -1.68207851990206),
(22794, '51106', 218, 16, 117804, 42.4693, 0.741229116017228, -96.3576, -1.68175737931969),
(22795, '51108', 218, 16, 117804, 42.5433, 0.742520659663704, -96.3735, -1.68203488667076),
(22796, '51109', 218, 16, 117804, 42.5172, 0.742065128728933, -96.4791, -1.68387795436086),
(22797, '51111', 218, 16, 117804, 42.4246, 0.740448953841586, -96.3754, -1.68206804792654),
(22798, '51201', 218, 16, 57525, 43.1821, 0.753669822925443, -95.8466, -1.672838746842),
(22799, '51230', 218, 16, 92231, 43.3035, 0.755788652637365, -96.2825, -1.68044663705144),
(22800, '51231', 218, 16, 15020, 43.1157, 0.752510924302119, -95.7444, -1.67105502034646),
(22801, '51232', 218, 16, 7180, 43.3121, 0.755938750953036, -95.7843, -1.671751406718),
(22802, '51234', 218, 16, 114678, 43.1904, 0.753814685253359, -96.0024, -1.6755579698166),
(22803, '51235', 218, 16, 115297, 43.2783, 0.755348829665862, -96.2301, -1.6795320845234),
(22804, '51237', 218, 16, 9085, 43.347, 0.756547870861982, -96.0047, -1.6755981123894),
(22805, '51238', 218, 16, 116084, 43.0718, 0.751744724760494, -95.9035, -1.67383183918638),
(22806, '51239', 218, 16, 3279, 43.1901, 0.753809449265603, -96.1341, -1.67785656844148),
(22807, '51240', 218, 16, 27, 43.3071, 0.755851484490436, -96.4308, -1.68303496033215),
(22808, '51241', 218, 16, 116409, 43.4545, 0.758424099807876, -96.433, -1.68307335757569),
(22809, '51242', 218, 16, 3735, 43.4383, 0.758141356469053, -96.3331, -1.68132977365295),
(22810, '51243', 218, 16, 3807, 43.4659, 0.758623067342603, -95.9196, -1.67411283719595),
(22811, '51244', 218, 16, 37091, 43.2153, 0.754249272237105, -95.9798, -1.67516352540565),
(22812, '51245', 218, 16, 117422, 43.0893, 0.752050157379593, -95.6239, -1.66895189859781),
(22813, '51246', 218, 16, 117567, 43.4278, 0.757958096897593, -96.1703, -1.6784883776307),
(22814, '51247', 218, 16, 117568, 43.2027, 0.754029360751354, -96.2951, -1.68066654853719),
(22815, '51248', 218, 16, 17956, 43.183, 0.753685530888711, -95.6568, -1.66952611192171),
(22816, '51249', 218, 16, 24860, 43.4029, 0.757523509913847, -95.7455, -1.67107421896823),
(22817, '51250', 218, 16, 117802, 43.079, 0.751870388466637, -96.1748, -1.67856691744704),
(22818, '51301', 218, 16, 5995, 43.1435, 0.752996125834174, -95.1473, -1.6606336593828),
(22819, '51331', 218, 16, 114442, 43.3643, 0.756849812822577, -95.1346, -1.6604120025678),
(22820, '51333', 218, 16, 46303, 43.1687, 0.753435948805676, -94.9732, -1.65759504115508),
(22821, '51334', 218, 16, 115489, 43.405, 0.757560161828139, -94.8327, -1.65514285355603),
(22822, '51338', 218, 16, 115504, 43.1595, 0.753275378514493, -95.3268, -1.66376652539013),
(22823, '51340', 218, 16, 2568, 43.2124, 0.754198657688798, -95.2101, -1.66172972615305),
(22824, '51341', 218, 16, 115734, 43.04, 0.751189710058359, -95.0329, -1.65863700271852),
(22825, '51342', 218, 16, 115773, 43.2359, 0.754608810063016, -94.7522, -1.65373786350817),
(22826, '51343', 218, 16, 2868, 43.0397, 0.751184474070604, -95.0329, -1.65863700271852),
(22827, '51344', 218, 16, 115890, 43.3939, 0.757366430281167, -94.7538, -1.6537657887762),
(22828, '51345', 218, 16, 2992, 43.4456, 0.758268765504448, -95.4324, -1.66560959308024),
(22829, '51346', 218, 16, 9365, 43.1814, 0.753657605620679, -95.4767, -1.66638277393887),
(22830, '51347', 218, 16, 16802, 43.4472, 0.75829669077248, -95.3318, -1.66385379185273),
(22831, '51349', 218, 16, 116782, 43.3739, 0.757017364430769, -95.5094, -1.66695349660427),
(22832, '51350', 218, 16, 4160, 43.2785, 0.755352320324366, -95.5646, -1.66791691835137),
(22833, '51351', 218, 16, 10480, 43.3274, 0.756205786328591, -95.1516, -1.66070870854064),
(22834, '51354', 218, 16, 117104, 43.4147, 0.757729458765582, -95.5352, -1.66740379155129),
(22835, '51355', 218, 16, 117110, 43.379, 0.75710637622262, -95.1627, -1.66090244008761),
(22836, '51357', 218, 16, 5571, 43.0764, 0.751825009906085, -95.2877, -1.6630841016526),
(22837, '51358', 218, 16, 117635, 43.1297, 0.752755270397398, -94.8993, -1.65630524283785),
(22838, '51360', 218, 16, 117859, 43.4231, 0.75787606642275, -95.1002, -1.65981160930511),
(22839, '51363', 218, 16, 6182, 43.4628, 0.758568962135792, -94.9717, -1.6575688612163),
(22840, '51364', 218, 16, 118022, 43.3012, 0.755748510064569, -94.9708, -1.65755315325303),
(22841, '51365', 218, 16, 38730, 43.2983, 0.755697895516261, -94.8534, -1.65550413671119),
(22842, '51366', 218, 16, 6671, 43.0624, 0.751580663810806, -95.2826, -1.66299508986075),
(22843, '51401', 218, 16, 39663, 42.0611, 0.734104682010587, -94.859, -1.6556018751493),
(22844, '51430', 218, 16, 7137, 42.0881, 0.734575920908625, -95.0469, -1.6588813488138),
(22845, '51431', 218, 16, 7168, 42.3357, 0.738897356136563, -95.3456, -1.66409464728951),
(22846, '51432', 218, 16, 18946, 41.9122, 0.731505886754367, -95.1363, -1.66044167316508),
(22847, '51433', 218, 16, 13306, 42.2507, 0.737413826272368, -94.877, -1.65591603441466),
(22848, '51436', 218, 16, 114695, 42.1832, 0.736235729027272, -94.9765, -1.65765263702039),
(22849, '51439', 218, 16, 54008, 42.0664, 0.734197184460943, -95.5889, -1.66834103335961),
(22850, '51440', 218, 16, 115227, 41.9077, 0.731427346938028, -94.8214, -1.65494563135055),
(22851, '51441', 218, 16, 113155, 42.0962, 0.734717292578037, -95.3428, -1.66404577807045),
(22852, '51442', 218, 16, 32227, 42.0209, 0.733403059651285, -95.3484, -1.66414351650856),
(22853, '51443', 218, 16, 94502, 42.0593, 0.734073266084051, -94.7276, -1.65330851251218),
(22854, '51444', 218, 16, 115899, 42.0057, 0.733137769604982, -94.9742, -1.6576124944476),
(22855, '51445', 218, 16, 116115, 42.3432, 0.739028255830463, -95.4652, -1.66618206107489),
(22856, '51446', 218, 16, 36581, 41.7913, 0.729395783688706, -95.2069, -1.66167387561699),
(22857, '51447', 218, 16, 116327, 41.7287, 0.728303207576958, -95.2649, -1.66268616658315),
(22858, '51448', 218, 16, 116330, 42.196, 0.736459131171527, -95.3273, -1.66377525203639),
(22859, '51449', 218, 16, 9930, 42.2692, 0.737736712183987, -94.7361, -1.6534568654986),
(22860, '51450', 218, 16, 3614, 42.3045, 0.738352813409941, -95.0437, -1.65882549827773),
(22861, '51451', 218, 16, 116400, 42.1841, 0.73625143699054, -94.6924, -1.65269415661548),
(22862, '51452', 218, 16, 116494, 42.1257, 0.735232164707375, -94.7835, -1.65428415156405),
(22863, '51453', 218, 16, 116597, 42.2691, 0.737734966854735, -94.5398, -1.65003078417694),
(22864, '51454', 218, 16, 30414, 41.9014, 0.731317391195152, -95.2508, -1.66244007515861),
(22865, '51455', 218, 16, 10288, 41.9067, 0.731409893645508, -95.0629, -1.65916060149412),
(22866, '51458', 218, 16, 117106, 42.3108, 0.738462769152817, -95.2475, -1.6623824792933),
(22867, '51459', 218, 16, 965, 42.0785, 0.734408369300434, -94.5714, -1.65058230822057),
(22868, '51460', 218, 16, 117524, 42.1289, 0.735288015243439, -95.5747, -1.66809319660582),
(22869, '51461', 218, 16, 117694, 42.1634, 0.735890153835377, -95.4341, -1.66563926367752),
(22870, '51462', 218, 16, 5701, 42.0236, 0.733450183541089, -94.5453, -1.65012677728579),
(22871, '51463', 218, 16, 91273, 41.9071, 0.731416874962516, -94.9182, -1.65663511006648),
(22872, '51465', 218, 16, 12506, 42.0613, 0.734108172669091, -95.2037, -1.66161802508093),
(22873, '51466', 218, 16, 43524, 42.272, 0.737785581403043, -95.0923, -1.6596737282942),
(22874, '51467', 218, 16, 25963, 42.0755, 0.734356009422874, -95.1005, -1.65981684529287),
(22875, '51501', 218, 16, 115126, 41.2563, 0.720058272190537, -95.8545, -1.6729766278529),
(22876, '51502', 218, 16, 115126, 41.2605, 0.72013157601912, -95.852, -1.6729329946216),
(22877, '51503', 218, 16, 115126, 41.2631, 0.720176954579672, -95.8202, -1.67237797991947),
(22878, '51510', 218, 16, 114854, 41.2928, 0.720695317367514, -95.9131, -1.67399939079457),
(22879, '51520', 218, 16, 71689, 41.9495, 0.732156894565361, -95.4631, -1.6661454091606),
(22880, '51521', 218, 16, 7207, 41.4751, 0.7238770525939, -95.3391, -1.66398120088813),
(22881, '51523', 218, 16, 114632, 41.9323, 0.731856697934018, -96.0817, -1.67694201591344),
(22882, '51525', 218, 16, 572, 41.2362, 0.719707461010886, -95.4176, -1.66535128435094),
(22883, '51526', 218, 16, 8292, 41.3662, 0.721976389038478, -95.8531, -1.67295219324338),
(22884, '51527', 218, 16, 35545, 41.827, 0.730018866231668, -95.3393, -1.66398469154663),
(22885, '51528', 218, 16, 115328, 41.928, 0.731781648776182, -95.4793, -1.66642815249942),
(22886, '51529', 218, 16, 8626, 41.8503, 0.730425527947383, -95.6066, -1.66864995663721),
(22887, '51530', 218, 16, 108993, 41.7741, 0.729095587057363, -95.417, -1.66534081237543),
(22888, '51531', 218, 16, 35734, 41.5927, 0.725929559794246, -95.0616, -1.65913791221384),
(22889, '51532', 218, 16, 8728, 41.1488, 0.718182043244643, -95.1629, -1.66090593074611),
(22890, '51533', 218, 16, 8753, 41.018, 0.715899152583034, -95.4017, -1.66507377699987),
(22891, '51534', 218, 16, 2749, 41.0475, 0.716414024712372, -95.7415, -1.67100440579815),
(22892, '51535', 218, 16, 55106, 41.2366, 0.719714442327894, -95.1403, -1.66051148633516),
(22893, '51536', 218, 16, 9313, 41.3904, 0.722398758717461, -95.3587, -1.66432328542152),
(22894, '51537', 218, 16, 32686, 41.6544, 0.727006427942726, -95.3244, -1.66372463748808),
(22895, '51540', 218, 16, 16375, 41.0222, 0.715972456411618, -95.4984, -1.66676151038655),
(22896, '51541', 218, 16, 23, 41.1389, 0.718009255648695, -95.4312, -1.66558864912921),
(22897, '51542', 218, 16, 55364, 41.4774, 0.723917195166696, -95.9197, -1.67411458252521),
(22898, '51543', 218, 16, 103336, 41.6453, 0.726847602980795, -95.0348, -1.65867016397431),
(22899, '51544', 218, 16, 3744, 41.3057, 0.720920464841022, -95.0849, -1.65954457392956),
(22900, '51545', 218, 16, 116569, 41.8088, 0.729701216307805, -96.0224, -1.675907035667),
(22901, '51546', 218, 16, 3843, 41.6448, 0.726838876334534, -95.7901, -1.67185263581462),
(22902, '51548', 218, 16, 10384, 41.3028, 0.720869850292714, -95.6736, -1.66981932723605),
(22903, '51549', 218, 16, 3926, 41.1919, 0.718934280152252, -95.4232, -1.66544902278905),
(22904, '51550', 218, 16, 3947, 41.7109, 0.727992538970103, -95.8511, -1.67291728665834);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(22905, '51551', 218, 16, 3963, 41.0047, 0.715667023792519, -95.5834, -1.66824504025075),
(22906, '51552', 218, 16, 112644, 41.449, 0.72342152165913, -95.1102, -1.65998614223031),
(22907, '51553', 218, 16, 42112, 41.4682, 0.723756624875513, -95.5419, -1.66752072861117),
(22908, '51554', 218, 16, 4236, 41.1422, 0.718066851514011, -95.6918, -1.67013697715991),
(22909, '51555', 218, 16, 116874, 41.5597, 0.725353601141087, -95.8903, -1.67360145572512),
(22910, '51556', 218, 16, 116879, 41.6201, 0.726407780009292, -96.0102, -1.67569410549826),
(22911, '51557', 218, 16, 116883, 41.7108, 0.727990793640851, -96.0223, -1.67590529033775),
(22912, '51558', 218, 16, 60944, 41.9246, 0.731722307581615, -95.8498, -1.67289459737806),
(22913, '51559', 218, 16, 33393, 41.452, 0.723473881536689, -95.6177, -1.66884368818418),
(22914, '51560', 218, 16, 4710, 41.3089, 0.720976315377086, -95.3949, -1.66495509461074),
(22915, '51561', 218, 16, 117208, 41.02, 0.715934059168074, -95.7983, -1.67199575281328),
(22916, '51562', 218, 16, 28181, 41.7268, 0.72827004632117, -95.4744, -1.66634263136607),
(22917, '51563', 218, 16, 89849, 41.5788, 0.725686959028218, -95.5703, -1.66801640211874),
(22918, '51564', 218, 16, 5096, 41.8331, 0.73012533131604, -95.9258, -1.67422104760958),
(22919, '51565', 218, 16, 37775, 41.645, 0.726842366993039, -95.4997, -1.66678419966683),
(22920, '51566', 218, 16, 5318, 41.01, 0.715759526242875, -95.2201, -1.66190425907825),
(22921, '51570', 218, 16, 59, 41.5178, 0.724622308184502, -95.4506, -1.6659272430041),
(22922, '51571', 218, 16, 24871, 41.1116, 0.717532780762901, -95.6364, -1.6691700647543),
(22923, '51572', 218, 16, 33994, 41.9853, 0.732781722437575, -95.7803, -1.67168159354792),
(22924, '51573', 218, 16, 6052, 40.9819, 0.715269088723064, -95.1023, -1.6598482612194),
(22925, '51574', 218, 16, 6269, 41.5955, 0.725978429013301, -95.4432, -1.66579808863945),
(22926, '51575', 218, 16, 118067, 41.2305, 0.719607977243522, -95.6058, -1.66863599400319),
(22927, '51576', 218, 16, 6443, 41.315, 0.721082780461457, -95.7077, -1.67041448451098),
(22928, '51577', 218, 16, 12616, 41.4794, 0.723952101751736, -95.2222, -1.66194091099254),
(22929, '51578', 218, 16, 31504, 41.7199, 0.728149618602782, -95.3945, -1.66494811329373),
(22930, '51579', 218, 16, 634, 41.7486, 0.728650528098105, -95.6956, -1.67020329967149),
(22931, '51591', 218, 16, 5318, 40.9775, 0.715192294235976, -95.2572, -1.66255177623074),
(22932, '51593', 218, 16, 32686, 41.2657, 0.720222333140224, -95.791, -1.67186834377789),
(22933, '51601', 218, 16, 14609, 40.7606, 0.711406675088401, -95.3688, -1.66449956367597),
(22934, '51602', 218, 16, 14609, 40.7666, 0.71151139484352, -95.3721, -1.66455715954128),
(22935, '51603', 218, 16, 14609, 40.767, 0.711518376160528, -95.3744, -1.66459730211408),
(22936, '51630', 218, 16, 13397, 40.5988, 0.708582732358674, -95.2074, -1.66168260226325),
(22937, '51631', 218, 16, 114684, 40.6128, 0.708827078453953, -94.9728, -1.65758805983807),
(22938, '51632', 218, 16, 114979, 40.736, 0.71097732409241, -95.0397, -1.65875568510765),
(22939, '51636', 218, 16, 8163, 40.6587, 0.709628184580618, -95.234, -1.66214685984428),
(22940, '51637', 218, 16, 115060, 40.6175, 0.708909108928797, -95.1082, -1.65995123564527),
(22941, '51638', 218, 16, 8781, 40.8322, 0.712656330832829, -95.3018, -1.66333019307713),
(22942, '51639', 218, 16, 86945, 40.723, 0.710750431289651, -95.4781, -1.6664072085484),
(22943, '51640', 218, 16, 2948, 40.6362, 0.70923548549892, -95.6538, -1.66947375204415),
(22944, '51645', 218, 16, 116119, 40.8775, 0.713446964983982, -95.426, -1.66549789200811),
(22945, '51646', 218, 16, 4548, 40.7312, 0.710893548288314, -94.9011, -1.65633665876439),
(22946, '51647', 218, 16, 117081, 40.6081, 0.708745047979109, -95.2899, -1.66312249889614),
(22947, '51648', 218, 16, 117261, 40.7502, 0.711225160846193, -95.81, -1.67219995633577),
(22948, '51649', 218, 16, 5293, 40.8716, 0.713343990558114, -95.5668, -1.66795531559492),
(22949, '51650', 218, 16, 5429, 40.6875, 0.710130839405193, -95.5681, -1.66797800487519),
(22950, '51651', 218, 16, 117738, 40.6811, 0.710019138333065, -95.0639, -1.65917805478664),
(22951, '51652', 218, 16, 5844, 40.7479, 0.711185018273397, -95.6454, -1.66932714438698),
(22952, '51653', 218, 16, 275, 40.8971, 0.713789049517373, -95.6714, -1.6697809299925),
(22953, '51654', 218, 16, 12317, 40.8195, 0.712434674017825, -95.7528, -1.67120162800363),
(22954, '51656', 218, 16, 143, 40.7328, 0.710921473556346, -95.1558, -1.66078201236922),
(22955, '52001', 218, 16, 32268, 42.5053, 0.741857434547946, -90.6988, -1.58299268760783),
(22956, '52002', 218, 16, 32268, 42.5118, 0.741970880949325, -90.7508, -1.58390025881887),
(22957, '52003', 218, 16, 32268, 42.4647, 0.741148830871636, -90.6875, -1.58279546540236),
(22958, '52004', 218, 16, 32268, 42.4987, 0.741742242817314, -90.6681, -1.58245687152747),
(22959, '52030', 218, 16, 14991, 42.1636, 0.735893644493881, -90.6069, -1.58138873002525),
(22960, '52031', 218, 16, 270, 42.2598, 0.7375726512343, -90.4284, -1.57827331731044),
(22961, '52032', 218, 16, 39360, 42.3351, 0.738886884161051, -90.8362, -1.58539077000007),
(22962, '52033', 218, 16, 26723, 42.3123, 0.738488949091597, -91.0031, -1.58830372452165),
(22963, '52035', 218, 16, 20161, 42.6384, 0.74418046778235, -91.2014, -1.59176471242836),
(22964, '52036', 218, 16, 8461, 42.4849, 0.741501387380539, -91.2686, -1.5929375736857),
(22965, '52037', 218, 16, 2021, 42.0018, 0.733069701764154, -90.6079, -1.58140618331777),
(22966, '52038', 218, 16, 2134, 42.5784, 0.743133270231154, -91.5467, -1.59779133433549),
(22967, '52039', 218, 16, 93851, 42.542, 0.742497970383428, -90.8403, -1.5854623284994),
(22968, '52040', 218, 16, 115358, 42.4846, 0.741496151392783, -91.1063, -1.59010490430971),
(22969, '52041', 218, 16, 2153, 42.4818, 0.741447282173727, -91.2701, -1.59296375362448),
(22970, '52042', 218, 16, 2230, 42.6471, 0.744332311427274, -91.4033, -1.59528853218813),
(22971, '52043', 218, 16, 115445, 42.857, 0.74799575752721, -91.4053, -1.59532343877317),
(22972, '52044', 218, 16, 115449, 42.7409, 0.745969430265644, -91.2787, -1.59311385194015),
(22973, '52045', 218, 16, 2316, 42.4499, 0.740890522142341, -90.9355, -1.5871238819473),
(22974, '52046', 218, 16, 2417, 42.4523, 0.740932410044389, -91.0089, -1.58840495361827),
(22975, '52047', 218, 16, 29784, 42.9499, 0.749617168402313, -91.3103, -1.59366537598378),
(22976, '52048', 218, 16, 9047, 42.7457, 0.74605320606974, -91.2523, -1.59265308501762),
(22977, '52049', 218, 16, 115698, 42.8672, 0.748173781110913, -91.241, -1.59245586281215),
(22978, '52050', 218, 16, 32621, 42.6019, 0.743543422605372, -91.3109, -1.59367584795929),
(22979, '52052', 218, 16, 115896, 42.7877, 0.746786244355578, -91.1065, -1.59010839496821),
(22980, '52053', 218, 16, 36481, 42.5934, 0.743395069618953, -90.963, -1.5876038474916),
(22981, '52054', 218, 16, 116351, 42.3786, 0.739646102385669, -90.6666, -1.58243069158869),
(22982, '52055', 218, 16, 116573, 42.8381, 0.747665890298583, -91.4404, -1.59593604934062),
(22983, '52056', 218, 16, 116642, 42.6097, 0.743679558287028, -91.0836, -1.58970871456951),
(22984, '52057', 218, 16, 585, 42.4871, 0.741539784624083, -91.4569, -1.5962240286672),
(22985, '52060', 218, 16, 116718, 42.0704, 0.734266997631022, -90.6619, -1.58234866111385),
(22986, '52064', 218, 16, 42092, 42.0473, 0.733863826573812, -90.3136, -1.57626967932915),
(22987, '52065', 218, 16, 73682, 42.5598, 0.742808638990283, -91.0909, -1.5898361236049),
(22988, '52066', 218, 16, 117057, 42.6725, 0.74477562505728, -90.9647, -1.58763351808889),
(22989, '52068', 218, 16, 117260, 42.4361, 0.740649666705566, -90.8138, -1.58499981624763),
(22990, '52069', 218, 16, 5220, 42.0505, 0.733919677109875, -90.3951, -1.57769212266953),
(22991, '52070', 218, 16, 57322, 42.0688, 0.734239072362991, -90.1728, -1.57381225574234),
(22992, '52071', 218, 16, 117654, 42.3343, 0.738872921527035, -90.4952, -1.57943919725077),
(22993, '52072', 218, 16, 117661, 42.9496, 0.749611932414556, -91.4291, -1.59573882713515),
(22994, '52073', 218, 16, 11910, 42.6138, 0.74375111678636, -90.8106, -1.58494396571156),
(22995, '52074', 218, 16, 113216, 42.0766, 0.734375208044646, -90.4901, -1.57935018545892),
(22996, '52075', 218, 16, 25039, 42.1641, 0.735902371140141, -90.4903, -1.57935367611742),
(22997, '52076', 218, 16, 117925, 42.7035, 0.745316677125399, -91.5125, -1.59719443173131),
(22998, '52077', 218, 16, 31401, 42.8033, 0.747058515718889, -91.5423, -1.59771453984841),
(22999, '52078', 218, 16, 31567, 42.3925, 0.739888703151696, -91.1031, -1.59004905377365),
(23000, '52079', 218, 16, 118560, 42.3364, 0.738909573441327, -90.7353, -1.58362973278481),
(23001, '52099', 218, 16, 32268, 42.4994, 0.741754460122078, -90.6683, -1.58246036218597),
(23002, '52101', 218, 16, 115225, 43.2996, 0.755720584796537, -91.7917, -1.60206739100288),
(23003, '52132', 218, 16, 114803, 43.1836, 0.753696002864223, -91.871, -1.60345143709971),
(23004, '52133', 218, 16, 63498, 43.1681, 0.753425476830164, -91.6642, -1.59984209620659),
(23005, '52134', 218, 16, 8056, 43.4649, 0.758605614050083, -92.4351, -1.61329683941021),
(23006, '52135', 218, 16, 13559, 43.004, 0.750561391527641, -91.6613, -1.59979148165828),
(23007, '52136', 218, 16, 115152, 43.3749, 0.757034817723288, -92.1161, -1.60772923909635),
(23008, '52140', 218, 16, 20633, 43.4353, 0.758088996591493, -91.5119, -1.5971839597558),
(23009, '52141', 218, 16, 2254, 42.9597, 0.749788210669008, -91.6362, -1.59935340401603),
(23010, '52142', 218, 16, 2426, 42.8559, 0.747976558905438, -91.8124, -1.60242867415804),
(23011, '52144', 218, 16, 112997, 43.1437, 0.752999616492678, -91.9307, -1.60449339866315),
(23012, '52146', 218, 16, 109564, 43.2044, 0.754059031348638, -91.1463, -1.59080303601051),
(23013, '52147', 218, 16, 47945, 42.9377, 0.749404238233569, -91.9502, -1.60483373786729),
(23014, '52149', 218, 16, 55297, 43.3058, 0.75582879521016, -91.7927, -1.6020848442954),
(23015, '52151', 218, 16, 9985, 43.3602, 0.756778254323245, -91.2207, -1.59210156097399),
(23016, '52154', 218, 16, 27683, 43.1041, 0.752308466108888, -92.1394, -1.60813590081206),
(23017, '52155', 218, 16, 116501, 43.4529, 0.758396174539844, -92.2819, -1.61062299499616),
(23018, '52156', 218, 16, 116631, 43.0552, 0.751455000104663, -91.3922, -1.59509480064116),
(23019, '52157', 218, 16, 10403, 43.0216, 0.750868569475992, -91.1814, -1.59141564657796),
(23020, '52158', 218, 16, 33204, 43.0593, 0.751526558603994, -91.2158, -1.59201603984064),
(23021, '52159', 218, 16, 116890, 43.0497, 0.751359006995803, -91.389, -1.5950389501051),
(23022, '52160', 218, 16, 116995, 43.4963, 0.75915364743521, -91.2878, -1.59327267690208),
(23023, '52161', 218, 16, 117168, 43.1731, 0.753512743292764, -91.8202, -1.6025648098397),
(23024, '52162', 218, 16, 117394, 43.085, 0.751975108221757, -91.5667, -1.59814040018589),
(23025, '52163', 218, 16, 117429, 43.3627, 0.756821887554545, -92.168, -1.60863506497813),
(23026, '52164', 218, 16, 50706, 42.8621, 0.748084769319062, -91.8857, -1.60370800049975),
(23027, '52165', 218, 16, 11587, 43.2939, 0.755621101029173, -91.988, -1.60549347232454),
(23028, '52166', 218, 16, 117658, 43.0671, 0.75166269428565, -91.9332, -1.60453703189445),
(23029, '52168', 218, 16, 117858, 43.2035, 0.75404332338537, -91.9512, -1.60485119115981),
(23030, '52169', 218, 16, 77568, 42.8398, 0.747695560895867, -91.6541, -1.59966581795213),
(23031, '52170', 218, 16, 25838, 43.269, 0.755186514045426, -91.257, -1.59273511549247),
(23032, '52171', 218, 16, 118345, 43.0612, 0.751559719859782, -91.9904, -1.60553536022659),
(23033, '52172', 218, 16, 118347, 43.2698, 0.755200476679442, -91.4775, -1.59658356649311),
(23034, '52175', 218, 16, 28946, 42.9636, 0.749856278509836, -91.8091, -1.60237107829273),
(23035, '52201', 218, 16, 92138, 41.2903, 0.720651684136215, -91.5553, -1.59794143265116),
(23036, '52202', 218, 16, 114371, 42.1566, 0.735771471446241, -91.6331, -1.59929929880922),
(23037, '52203', 218, 16, 114400, 41.8051, 0.729636639125481, -91.8679, -1.6033973318929),
(23038, '52204', 218, 16, 114400, 41.8002, 0.729551117992134, -91.8703, -1.60343921979495),
(23039, '52205', 218, 16, 114410, 42.1085, 0.734931968076032, -91.2829, -1.59318715576873),
(23040, '52206', 218, 16, 7186, 42.0061, 0.73314475092199, -91.8723, -1.60347412637999),
(23041, '52207', 218, 16, 722, 42.0731, 0.734314121520826, -90.8187, -1.58508533738097),
(23042, '52208', 218, 16, 31776, 41.8971, 0.731242342037316, -92.2766, -1.6105304925458),
(23043, '52209', 218, 16, 39401, 41.9062, 0.731401166999248, -92.0826, -1.60714455379693),
(23044, '52210', 218, 16, 7653, 42.3146, 0.738529091664393, -92.0027, -1.60575003572459),
(23045, '52211', 218, 16, 1157, 41.7321, 0.728362548771526, -92.4446, -1.61346264568915),
(23046, '52212', 218, 16, 114913, 42.0776, 0.734392661337166, -91.0731, -1.58952545499805),
(23047, '52213', 218, 16, 655, 42.1924, 0.736396299318456, -91.76, -1.60151412163),
(23048, '52214', 218, 16, 1465, 42.1916, 0.73638233668444, -91.5104, -1.59715777981702),
(23049, '52215', 218, 16, 1509, 41.9179, 0.731605370521731, -92.392, -1.6125446025026),
(23050, '52216', 218, 16, 1592, 41.8813, 0.730966580015501, -91.0619, -1.58932997812182),
(23051, '52217', 218, 16, 115040, 42.0778, 0.73439615199567, -92.4029, -1.61273484339107),
(23052, '52218', 218, 16, 115049, 42.2772, 0.737876338524147, -91.5436, -1.59773722912868),
(23053, '52219', 218, 16, 117416, 42.2378, 0.737188678798861, -91.4241, -1.59565156067255),
(23054, '52220', 218, 16, 115093, 41.7412, 0.728521373733457, -91.9686, -1.60515487844966),
(23055, '52221', 218, 16, 9256, 41.6493, 0.726917416150874, -92.3429, -1.61168764583987),
(23056, '52222', 218, 16, 64158, 41.5979, 0.726020316915349, -92.3189, -1.61126876681939),
(23057, '52223', 218, 16, 20537, 42.429, 0.740525748328674, -91.3326, -1.59405458440697),
(23058, '52224', 218, 16, 115359, 42.1692, 0.735991382931993, -92.3067, -1.61105583665065),
(23059, '52225', 218, 16, 64460, 42.014, 0.733282631932898, -92.3499, -1.61180981888751),
(23060, '52226', 218, 16, 15933, 41.9887, 0.732841063632143, -90.7237, -1.58342727459158),
(23061, '52227', 218, 16, 54625, 41.8946, 0.731198708806016, -91.5673, -1.5981508721614),
(23062, '52228', 218, 16, 13733, 41.9128, 0.731516358729879, -91.7816, -1.60189111274843),
(23063, '52229', 218, 16, 27246, 42.1413, 0.735504436070686, -92.1396, -1.60813939147057),
(23064, '52231', 218, 16, 16368, 41.3811, 0.722236443097026, -92.0252, -1.60614273480629),
(23065, '52232', 218, 16, 115968, 41.8193, 0.729884475879265, -92.3575, -1.61194246391066),
(23066, '52233', 218, 16, 32748, 42.0427, 0.73378354142822, -91.6749, -1.60002884643655),
(23067, '52235', 218, 16, 21948, 41.555, 0.725271570666244, -91.5326, -1.59754524291096),
(23068, '52236', 218, 16, 3212, 41.7268, 0.72827004632117, -91.8854, -1.603702764512),
(23069, '52237', 218, 16, 116079, 42.3217, 0.738653010041284, -91.124, -1.59041382758731),
(23070, '52240', 218, 16, 16559, 41.6568, 0.727048315844774, -91.5283, -1.59747019375313),
(23071, '52241', 218, 16, 115106, 41.6833, 0.727510828096552, -91.5794, -1.5983620570009),
(23072, '52242', 218, 16, 16559, 41.6622, 0.727142563624382, -91.5405, -1.59768312392187),
(23073, '52243', 218, 16, 16559, 41.6581, 0.72707100512505, -91.5346, -1.597580149496),
(23074, '52244', 218, 16, 16559, 41.6856, 0.727550970669348, -91.5174, -1.59727995286466),
(23075, '52245', 218, 16, 16559, 41.6647, 0.727186196855682, -91.5104, -1.59715777981702),
(23076, '52246', 218, 16, 16559, 41.6547, 0.727011663930482, -91.5608, -1.59803742576002),
(23077, '52247', 218, 16, 3478, 41.4873, 0.724089982762643, -91.7042, -1.60054022790738),
(23078, '52248', 218, 16, 55657, 41.3646, 0.721948463770447, -91.9551, -1.60491925900064),
(23079, '52249', 218, 16, 3513, 42.0006, 0.73304875781313, -92.2003, -1.60919880632653),
(23080, '52251', 218, 16, 116358, 41.7618, 0.728880911559368, -92.1955, -1.60911503052243),
(23081, '52252', 218, 16, 116402, 42.1932, 0.736410261952471, -91.2225, -1.59213297690053),
(23082, '52253', 218, 16, 10116, 41.9172, 0.731593153216967, -91.3835, -1.59494295699624),
(23083, '52254', 218, 16, 116613, 41.9635, 0.732401240660641, -90.8174, -1.5850626481007),
(23084, '52255', 218, 16, 10213, 41.8583, 0.730565154287542, -90.9258, -1.58695458500986),
(23085, '52257', 218, 16, 37003, 41.9057, 0.731392440352988, -92.1789, -1.6088253058666),
(23086, '52301', 218, 16, 3989, 41.7955, 0.72946908751729, -92.0818, -1.60713059116291),
(23087, '52302', 218, 16, 630, 42.0454, 0.733830665318024, -91.5959, -1.59865003632747),
(23088, '52305', 218, 16, 116756, 42.0112, 0.733233762713842, -91.387, -1.59500404352006),
(23089, '52306', 218, 16, 4145, 41.9057, 0.731392440352988, -91.2532, -1.59266879298089),
(23090, '52307', 218, 16, 116830, 41.8012, 0.729568571284654, -91.8917, -1.60381272025487),
(23091, '52308', 218, 16, 30514, 41.5739, 0.725601437894871, -92.1604, -1.60850241995498),
(23092, '52309', 218, 16, 4270, 42.0817, 0.734464219836498, -90.8719, -1.58601385254304),
(23093, '52310', 218, 16, 588, 42.2384, 0.737199150774373, -91.1897, -1.59156050890587),
(23094, '52312', 218, 16, 42172, 42.0066, 0.73315347756825, -91.2461, -1.592544874604),
(23095, '52313', 218, 16, 27960, 42.2544, 0.737478403454692, -92.1686, -1.60864553695365),
(23096, '52314', 218, 16, 4411, 41.9334, 0.73187589655579, -91.4376, -1.59588718012157),
(23097, '52315', 218, 16, 56522, 41.9937, 0.732928330094743, -91.9678, -1.60514091581564),
(23098, '52316', 218, 16, 117059, 41.5148, 0.724569948306942, -92.0788, -1.60707823128535),
(23099, '52317', 218, 16, 89474, 41.7425, 0.728544063013733, -91.6019, -1.59875475608259),
(23100, '52318', 218, 16, 33458, 41.9046, 0.731373241731216, -91.9203, -1.60431188442094),
(23101, '52319', 218, 16, 4701, 41.7171, 0.728100749383726, -91.6225, -1.5991142939085),
(23102, '52320', 218, 16, 37518, 42.0028, 0.733087155056674, -91.1375, -1.59064944703633),
(23103, '52321', 218, 16, 117131, 42.1293, 0.735294996560447, -90.957, -1.58749912773648),
(23104, '52322', 218, 16, 4828, 41.7234, 0.728210705126602, -91.7842, -1.60193649130898),
(23105, '52323', 218, 16, 117199, 41.9891, 0.732848044949151, -90.9803, -1.5879057894522),
(23106, '52324', 218, 16, 117221, 42.0493, 0.733898733158852, -91.7928, -1.60208658962465),
(23107, '52325', 218, 16, 4892, 41.5559, 0.725287278629512, -92.0055, -1.60579890494364),
(23108, '52326', 218, 16, 117441, 42.3946, 0.739925355065988, -91.7569, -1.60146001642318),
(23109, '52327', 218, 16, 5423, 41.4821, 0.72399922564154, -91.58, -1.59837252897641),
(23110, '52328', 218, 16, 74103, 42.0728, 0.73430888553307, -91.664, -1.59983860554808),
(23111, '52329', 218, 16, 117618, 42.3689, 0.739476805448225, -91.8446, -1.60299067017718),
(23112, '52330', 218, 16, 5594, 42.3505, 0.739155664865858, -91.4834, -1.59668654091898),
(23113, '52332', 218, 16, 117758, 42.0928, 0.734657951383469, -91.8695, -1.60342525716093),
(23114, '52333', 218, 16, 117834, 41.807, 0.729669800381269, -91.5176, -1.59728344352316),
(23115, '52334', 218, 16, 117837, 41.7597, 0.728844259645076, -91.9288, -1.60446023740736),
(23116, '52335', 218, 16, 117839, 41.4692, 0.723774078168033, -92.1188, -1.60777636298615),
(23117, '52336', 218, 16, 6035, 42.0641, 0.734157041888147, -91.4393, -1.59591685071885),
(23118, '52337', 218, 16, 117893, 41.8922, 0.731156820903969, -91.1509, -1.5908833211561),
(23119, '52338', 218, 16, 117986, 41.8456, 0.730343497472539, -91.6958, -1.60039362025022),
(23120, '52339', 218, 16, 43289, 41.9669, 0.732460581855208, -92.5761, -1.61575775365552),
(23121, '52340', 218, 16, 57899, 41.7062, 0.727910508495259, -91.6639, -1.59983686021883),
(23122, '52341', 218, 16, 38553, 42.1078, 0.734919750771268, -91.737, -1.60111269590204),
(23123, '52342', 218, 16, 12339, 41.9927, 0.732910876802223, -92.5755, -1.61574728168001),
(23124, '52344', 218, 16, 118073, 42.2928, 0.738148609887458, -91.6829, -1.60016847277671),
(23125, '52345', 218, 16, 12500, 42.2231, 0.736932115398818, -91.8759, -1.60353695823306),
(23126, '52346', 218, 16, 118179, 42.0238, 0.733453674199593, -92.0805, -1.60710790188264),
(23127, '52347', 218, 16, 12551, 41.7297, 0.728320660869478, -92.295, -1.61085163312817),
(23128, '52348', 218, 16, 34279, 41.9737, 0.732579264244344, -92.3622, -1.61202449438551),
(23129, '52349', 218, 16, 34282, 42.167, 0.735952985688449, -92.0167, -1.60599438181987),
(23130, '52350', 218, 16, 12571, 42.0902, 0.734612572822917, -91.3859, -1.59498484489829),
(23131, '52351', 218, 16, 118237, 41.9051, 0.731381968377476, -91.8902, -1.60378654031609),
(23132, '52352', 218, 16, 12598, 42.2714, 0.737775109427531, -91.7598, -1.60151063097149),
(23133, '52353', 218, 16, 12671, 41.2991, 0.72080527311039, -91.6897, -1.60028715516584),
(23134, '52354', 218, 16, 6653, 41.9054, 0.731387204365232, -92.0069, -1.60582333955317),
(23135, '52355', 218, 16, 18520, 41.4366, 0.723205100831882, -92.1897, -1.60901380142582),
(23136, '52356', 218, 16, 62252, 41.4708, 0.723802003436064, -91.8349, -1.60282137323974),
(23137, '52358', 218, 16, 118384, 41.6737, 0.727343276488361, -91.3458, -1.59428496786824),
(23138, '52359', 218, 16, 79370, 41.3773, 0.72217012058545, -91.8808, -1.60362247936641),
(23139, '52361', 218, 16, 6831, 41.6609, 0.727119874344106, -92.0136, -1.60594027661305),
(23140, '52362', 218, 16, 14923, 42.0602, 0.734088974047319, -91.0047, -1.58833164978968),
(23141, '52401', 218, 16, 114889, 41.9712, 0.732535631013044, -91.6587, -1.59974610309773),
(23142, '52402', 218, 16, 114889, 42.0217, 0.733417022285301, -91.6705, -1.59995205194946),
(23143, '52403', 218, 16, 114889, 41.9828, 0.732738089206275, -91.6074, -1.59885074919145),
(23144, '52404', 218, 16, 114889, 41.9482, 0.732134205285085, -91.6875, -1.6002487579223),
(23145, '52405', 218, 16, 114889, 41.981, 0.732706673279739, -91.7157, -1.60074094077136),
(23146, '52406', 218, 16, 114889, 41.9194, 0.731631550460511, -91.6789, -1.60009865960663),
(23147, '52407', 218, 16, 114889, 41.9741, 0.732586245561352, -91.6569, -1.59971468717119),
(23148, '52408', 218, 16, 114889, 41.9871, 0.732813138364111, -91.7157, -1.60074094077136),
(23149, '52409', 218, 16, 114889, 41.9879, 0.732827100998127, -91.716, -1.60074617675912),
(23150, '52410', 218, 16, 114889, 42.0214, 0.733411786297545, -91.6606, -1.59977926435351),
(23151, '52411', 218, 16, 114889, 42.0415, 0.733762597477196, -91.7221, -1.60085264184349),
(23152, '52497', 218, 16, 114889, 42.0082, 0.733181402836282, -91.6443, -1.59949477568544),
(23153, '52498', 218, 16, 114889, 42.0215, 0.733413531626797, -91.6606, -1.59977926435351),
(23154, '52499', 218, 16, 114889, 41.9746, 0.732594972207612, -91.6578, -1.59973039513446),
(23155, '52501', 218, 16, 33540, 41.0165, 0.715872972644254, -92.4146, -1.61293904691355),
(23156, '52530', 218, 16, 53132, 40.9966, 0.715525652123107, -92.3069, -1.61105932730915),
(23157, '52531', 218, 16, 34520, 41.0257, 0.716033542935438, -92.8029, -1.61971616039905),
(23158, '52533', 218, 16, 7293, 40.9991, 0.715569285354407, -92.1593, -1.60848322133321),
(23159, '52534', 218, 16, 34, 41.2759, 0.720400356723927, -92.6818, -1.61760256667488),
(23160, '52535', 218, 16, 799, 40.8547, 0.713049029914527, -91.9504, -1.60483722852579),
(23161, '52536', 218, 16, 29227, 40.9616, 0.714914786884909, -92.6342, -1.61677178995093),
(23162, '52537', 218, 16, 7544, 40.7524, 0.711263558089737, -92.4164, -1.61297046284009),
(23163, '52538', 218, 16, 31491, 40.7162, 0.710631748900515, -92.5621, -1.61551340756024),
(23164, '52540', 218, 16, 212, 41.1732, 0.718607903582129, -91.822, -1.60259622576623),
(23165, '52542', 218, 16, 114825, 40.6436, 0.709364639863567, -92.0688, -1.60690369836016),
(23166, '52543', 218, 16, 31988, 41.2062, 0.719183862235288, -92.5018, -1.61446097402129),
(23167, '52544', 218, 16, 1459, 40.7272, 0.710823735118235, -92.8635, -1.62077382992575),
(23168, '52548', 218, 16, 54027, 41.0729, 0.716857338342379, -92.5416, -1.61515561506358),
(23169, '52549', 218, 16, 8080, 40.6308, 0.709141237719312, -92.9241, -1.62183149945246),
(23170, '52550', 218, 16, 2022, 41.3002, 0.720824471732162, -92.3529, -1.61186217876507),
(23171, '52551', 218, 16, 115302, 40.8009, 0.712110042776954, -92.0456, -1.60649878197369),
(23172, '52552', 218, 16, 115333, 40.7773, 0.711698145073484, -92.4555, -1.61365288657762),
(23173, '52553', 218, 16, 27042, 41.1567, 0.71831992425555, -92.6342, -1.61677178995093),
(23174, '52554', 218, 16, 54579, 40.9181, 0.714155568660292, -92.2209, -1.60955834415244),
(23175, '52555', 218, 16, 46941, 40.6487, 0.709453651655419, -92.8442, -1.62043698138012),
(23176, '52556', 218, 16, 2367, 41.0057, 0.715684477085039, -91.9672, -1.60513044384013),
(23177, '52557', 218, 16, 2367, 41.0072, 0.715710657023819, -91.9656, -1.6051025185721),
(23178, '52560', 218, 16, 101993, 40.8559, 0.713069973865551, -92.2945, -1.61084290648191),
(23179, '52561', 218, 16, 2605, 41.2134, 0.719309525941431, -92.4349, -1.61329334875171),
(23180, '52562', 218, 16, 65448, 41.3309, 0.721360287812524, -92.1819, -1.60887766574416),
(23181, '52563', 218, 16, 55238, 41.1759, 0.718655027471933, -92.3081, -1.61108027126018),
(23182, '52565', 218, 16, 116309, 40.7344, 0.710949398824378, -91.9642, -1.60507808396257),
(23183, '52566', 218, 16, 36734, 41.1193, 0.717667171115304, -92.4666, -1.61384661812459),
(23184, '52567', 218, 16, 3766, 40.9561, 0.71481879377605, -92.0493, -1.60656335915602),
(23185, '52568', 218, 16, 27815, 41.2018, 0.7191070677482, -92.1588, -1.60847449468695),
(23186, '52569', 218, 16, 4153, 40.9754, 0.715155642321684, -93.0534, -1.62408821017529),
(23187, '52570', 218, 16, 4232, 40.6769, 0.709945834504481, -92.1406, -1.60815684476309),
(23188, '52571', 218, 16, 76631, 40.8909, 0.713680839103749, -92.8162, -1.61994828918956),
(23189, '52572', 218, 16, 4358, 40.6862, 0.710108150124917, -92.6855, -1.6176671438572),
(23190, '52573', 218, 16, 4408, 40.638, 0.709266901425456, -91.9139, -1.60420018334882),
(23191, '52574', 218, 16, 23299, 40.7798, 0.711741778304784, -92.9467, -1.62222594386341),
(23192, '52576', 218, 16, 4783, 41.2016, 0.719103577089696, -92.1586, -1.60847100402845),
(23193, '52577', 218, 16, 28160, 41.2943, 0.720721497306294, -92.6427, -1.61692014293735),
(23194, '52580', 218, 16, 117212, 41.1195, 0.717670661773808, -92.0625, -1.60679374261728),
(23195, '52581', 218, 16, 5105, 40.7819, 0.711778430219076, -93.0359, -1.62378277755619),
(23196, '52583', 218, 16, 117428, 40.7684, 0.711542810770056, -93.1552, -1.62586495535382),
(23197, '52584', 218, 16, 11424, 40.6934, 0.71023381383106, -92.2368, -1.60983585150351),
(23198, '52585', 218, 16, 5374, 41.1849, 0.718812107104613, -91.994, -1.60559819207966),
(23199, '52586', 218, 16, 5540, 41.1767, 0.718668990105949, -92.311, -1.61113088580849),
(23200, '52588', 218, 16, 5731, 40.857, 0.713089172487323, -92.1212, -1.6078182508882),
(23201, '52590', 218, 16, 5745, 40.6836, 0.710062771564365, -93.1188, -1.6252296555061),
(23202, '52591', 218, 16, 117789, 41.3321, 0.721381231763548, -92.2041, -1.6092651288381),
(23203, '52593', 218, 16, 118096, 40.8189, 0.712424202042313, -92.6984, -1.61789229133071),
(23204, '52594', 218, 16, 25657, 40.8521, 0.713003651353975, -92.6932, -1.61780153420961),
(23205, '52595', 218, 16, 18408, 41.2875, 0.720602814917159, -92.619, -1.61650649990463),
(23206, '52601', 218, 16, 1239, 40.8092, 0.71225490510487, -91.1175, -1.59030038118593),
(23207, '52619', 218, 16, 15022, 40.5642, 0.707978848437484, -91.5788, -1.59835158502538),
(23208, '52620', 218, 16, 114661, 40.7007, 0.710361222866456, -91.8005, -1.60222097997705),
(23209, '52621', 218, 16, 8287, 41.2158, 0.719351413843479, -91.5359, -1.59760283877628),
(23210, '52623', 218, 16, 1964, 40.8632, 0.713197382900947, -91.3144, -1.59373693448311),
(23211, '52624', 218, 16, 8477, 40.7419, 0.711080298518278, -91.3381, -1.59415057751583),
(23212, '52625', 218, 16, 26968, 40.6422, 0.709340205254039, -91.5661, -1.59812992821038),
(23213, '52626', 218, 16, 8849, 40.6472, 0.709427471716639, -91.7464, -1.60127675685173),
(23214, '52627', 218, 16, 115607, 40.631, 0.709144728377816, -91.3364, -1.59412090691855),
(23215, '52630', 218, 16, 3145, 40.831, 0.712635386881805, -91.7088, -1.60062051305298),
(23216, '52631', 218, 16, 116085, 40.77, 0.711570736038088, -91.6609, -1.59978450034127),
(23217, '52632', 218, 16, 116304, 40.4048, 0.705196793609805, -91.3945, -1.59513494321396),
(23218, '52635', 218, 16, 116581, 40.9955, 0.715506453501335, -91.7511, -1.60135878732657),
(23219, '52637', 218, 16, 116804, 41.0079, 0.715722874328583, -91.1629, -1.59109276066634),
(23220, '52638', 218, 16, 14224, 40.8238, 0.712509723175661, -91.2634, -1.59284681656459),
(23221, '52639', 218, 16, 4299, 40.5283, 0.707352275236018, -91.4169, -1.5955258969664),
(23222, '52640', 218, 16, 10601, 41.0951, 0.717244801436322, -91.2535, -1.59267402896865),
(23223, '52641', 218, 16, 118, 40.9667, 0.715003798676761, -91.55, -1.59784893020081),
(23224, '52642', 218, 16, 490, 40.981, 0.715253380759796, -91.682, -1.60015276481344),
(23225, '52644', 218, 16, 4410, 41.0316, 0.716136517361305, -91.4287, -1.59573184581814),
(23226, '52645', 218, 16, 4547, 40.9251, 0.714277741707931, -91.4014, -1.59525537093235),
(23227, '52646', 218, 16, 4721, 41.098, 0.71729541598463, -91.0428, -1.58899662023469),
(23228, '52647', 218, 16, 67483, 41.1193, 0.717667171115304, -91.5438, -1.59774071978719),
(23229, '52648', 218, 16, 56885, 40.7695, 0.711562009391828, -91.5451, -1.59776340906746),
(23230, '52649', 218, 16, 126, 40.854, 0.713036812609763, -91.6191, -1.59905495271394),
(23231, '52650', 218, 16, 77306, 40.9427, 0.714584919656282, -91.1988, -1.5917193338678),
(23232, '52651', 218, 16, 74422, 40.8571, 0.713090917816575, -91.8342, -1.60280915593498),
(23233, '52652', 218, 16, 117983, 41.1195, 0.717670661773808, -91.5442, -1.59774770110419),
(23234, '52653', 218, 16, 118261, 41.1812, 0.718747529922289, -91.1877, -1.59152560232083),
(23235, '52654', 218, 16, 38772, 41.1463, 0.718138410013343, -91.6645, -1.59984733219434),
(23236, '52655', 218, 16, 118388, 40.8241, 0.712514959163417, -91.1631, -1.59109625132484),
(23237, '52656', 218, 16, 6722, 40.7166, 0.710638730217523, -91.4522, -1.59614199819236),
(23238, '52657', 218, 16, 11759, 40.7689, 0.711551537416316, -91.5384, -1.59764647200758),
(23239, '52658', 218, 16, 118437, 40.6832, 0.710055790247357, -91.2024, -1.59178216572088),
(23240, '52659', 218, 16, 6882, 41.1281, 0.71782076008948, -91.4377, -1.59588892545082),
(23241, '52660', 218, 16, 118542, 41.0311, 0.716127790715045, -91.3135, -1.59372122651984),
(23242, '52701', 218, 16, 14988, 41.9907, 0.732875970217183, -90.2419, -1.57501827825547),
(23243, '52720', 218, 16, 114455, 41.5722, 0.725571767297587, -91.1653, -1.59113464856839),
(23244, '52721', 218, 16, 15192, 41.7413, 0.728523119062709, -90.9742, -1.58779932436783),
(23245, '52722', 218, 16, 114599, 41.5526, 0.725229682764196, -90.4806, -1.57918437917998),
(23246, '52726', 218, 16, 34869, 41.499, 0.724294186285127, -90.7564, -1.58399799725698),
(23247, '52727', 218, 16, 652, 41.9727, 0.732561810951824, -90.3411, -1.57674964487345),
(23248, '52728', 218, 16, 26642, 41.4572, 0.723564638657793, -90.7269, -1.58348312512764),
(23249, '52729', 218, 16, 114792, 41.8262, 0.730004903597652, -90.7586, -1.58403639450053),
(23250, '52730', 218, 16, 114806, 41.7874, 0.729327715847878, -90.2576, -1.57529229494803),
(23251, '52731', 218, 16, 8042, 41.9633, 0.732397750002136, -90.9064, -1.58661599113497),
(23252, '52732', 218, 16, 1630, 41.8513, 0.730442981239903, -90.2062, -1.57439519571251),
(23253, '52733', 218, 16, 1630, 41.844, 0.730315572204507, -90.1888, -1.57409150842266),
(23254, '52736', 218, 16, 1630, 41.8431, 0.730299864241239, -90.2328, -1.57485945329354),
(23255, '52737', 218, 16, 1719, 41.2622, 0.720161246616404, -91.3736, -1.59477016940029),
(23256, '52738', 218, 16, 115075, 41.2751, 0.720386394089912, -91.3645, -1.59461134443836),
(23257, '52739', 218, 16, 115086, 41.38, 0.722217244475254, -91.3491, -1.59434256373355),
(23258, '52742', 218, 16, 8432, 41.8233, 0.729954289049344, -90.542, -1.58025601134071),
(23259, '52745', 218, 16, 828, 41.7152, 0.728067588127939, -90.7579, -1.58402417719576),
(23260, '52746', 218, 16, 115292, 41.7118, 0.728008246933371, -90.6794, -1.58265409373295),
(23261, '52747', 218, 16, 15836, 41.6008, 0.726070931463657, -90.9087, -1.58665613370777),
(23262, '52748', 218, 16, 2252, 41.6637, 0.727168743563161, -90.5592, -1.58055620797205),
(23263, '52749', 218, 16, 16149, 41.355, 0.721780912162255, -91.1279, -1.59048189542814),
(23264, '52750', 218, 16, 115765, 41.994, 0.732933566082499, -90.4099, -1.57795043139882),
(23265, '52751', 218, 16, 115781, 41.8433, 0.730303354899743, -90.6775, -1.58262093247716),
(23266, '52752', 218, 16, 534, 41.2771, 0.720421300674951, -91.187, -1.59151338501607),
(23267, '52753', 218, 16, 116425, 41.6086, 0.726207067145313, -90.3721, -1.57729069694157),
(23268, '52754', 218, 16, 30323, 41.3277, 0.721304437276461, -91.2355, -1.59235986970329),
(23269, '52755', 218, 16, 30370, 41.4845, 0.724041113543588, -91.4257, -1.59567948594058),
(23270, '52756', 218, 16, 116604, 41.7197, 0.728146127944278, -90.5479, -1.58035898576657),
(23271, '52757', 218, 16, 103847, 41.8372, 0.730196889815372, -90.4776, -1.57913201930242),
(23272, '52758', 218, 16, 116788, 41.746, 0.728605149537553, -90.4468, -1.57859445789281),
(23273, '52759', 218, 16, 23162, 41.4621, 0.723650159791141, -90.8098, -1.58493000307755),
(23274, '52760', 218, 16, 4344, 41.5827, 0.725755026869046, -91.053, -1.5891746438184),
(23275, '52761', 218, 16, 116971, 41.4251, 0.723004387967903, -91.0577, -1.58925667429324),
(23276, '52765', 218, 16, 4546, 41.7276, 0.728284008955186, -90.8622, -1.58584455560559),
(23277, '52766', 218, 16, 17278, 41.4799, 0.723960828397996, -91.308, -1.59362523341098),
(23278, '52767', 218, 16, 5149, 41.5654, 0.725453084908451, -90.425, -1.57821397611587),
(23279, '52768', 218, 16, 5231, 41.6876, 0.727585877254388, -90.3838, -1.57749490046405),
(23280, '52769', 218, 16, 510, 41.6576, 0.72706227847879, -90.8393, -1.58544487520688),
(23281, '52771', 218, 16, 118013, 42.0119, 0.733245980018606, -90.248, -1.57512474333984),
(23282, '52772', 218, 16, 12332, 41.7718, 0.729055444484567, -91.1284, -1.5904906220744),
(23283, '52773', 218, 16, 354, 41.6114, 0.726255936364368, -90.7682, -1.58420394610872),
(23284, '52774', 218, 16, 118377, 41.9058, 0.73139418568224, -90.6107, -1.58145505253683),
(23285, '52776', 218, 16, 12753, 41.5727, 0.725580493943847, -91.2617, -1.59281714596731),
(23286, '52777', 218, 16, 31509, 41.8336, 0.7301340579623, -90.8395, -1.58544836586539),
(23287, '52778', 218, 16, 287, 41.59, 0.725882435904442, -91.017, -1.58854632528768),
(23288, '52801', 218, 16, 1977, 41.5232, 0.724716555964109, -90.5784, -1.58089131118843),
(23289, '52802', 218, 16, 1977, 41.5122, 0.72452456974639, -90.6247, -1.58169939863211),
(23290, '52803', 218, 16, 1977, 41.5386, 0.724985336668917, -90.5557, -1.58049512144823),
(23291, '52804', 218, 16, 1977, 41.544, 0.725079584448524, -90.6218, -1.5816487840838),
(23292, '52805', 218, 16, 1977, 41.5728, 0.725582239273099, -90.6003, -1.58127353829462),
(23293, '52806', 218, 16, 1977, 41.5728, 0.725582239273099, -90.6036, -1.58133113415993),
(23294, '52807', 218, 16, 1977, 41.5662, 0.725467047542467, -90.5383, -1.58019143415838),
(23295, '52808', 218, 16, 1977, 41.5025, 0.724355272808947, -90.6367, -1.58190883814234),
(23296, '52809', 218, 16, 1977, 41.5637, 0.725423414311167, -90.6324, -1.58183378898451),
(23297, '53001', 218, 57, 92118, 43.6221, 0.761349271634219, -87.9588, -1.53517066610319),
(23298, '53002', 218, 57, 53157, 43.4568, 0.758464242380672, -88.3569, -1.54211882185538),
(23299, '53003', 218, 57, 172978, 43.2121, 0.754193421701042, -88.5161, -1.54489738602455),
(23300, '53004', 218, 57, 108152, 43.511, 0.759410210835253, -87.8567, -1.5333886849369),
(23301, '53005', 218, 57, 13444, 43.0616, 0.75156670117679, -88.1254, -1.53807838463701),
(23302, '53006', 218, 57, 1191, 43.6164, 0.761249787866855, -88.4888, -1.54442091113876),
(23303, '53007', 218, 57, 1257, 43.1072, 0.7523625713157, -88.0706, -1.53712194420692),
(23304, '53008', 218, 57, 13444, 43.0605, 0.751547502555018, -88.1067, -1.53775200806689),
(23305, '53010', 218, 57, 154582, 43.6088, 0.761117142843703, -88.2778, -1.54073826641705),
(23306, '53011', 218, 57, 26723, 43.659, 0.761993298128204, -88.0342, -1.53648664435919),
(23307, '53012', 218, 57, 173490, 43.3043, 0.75580261527138, -87.9948, -1.53579898463391),
(23308, '53013', 218, 57, 1414, 43.5704, 0.760446936410937, -87.8448, -1.53318099075591),
(23309, '53014', 218, 57, 1552, 44.0305, 0.768477196299363, -88.1913, -1.53922855661408),
(23310, '53015', 218, 57, 1620, 43.9194, 0.766538135500398, -87.7676, -1.53183359657338),
(23311, '53016', 218, 57, 173597, 43.3132, 0.755957949574808, -88.7188, -1.54843516841835),
(23312, '53017', 218, 57, 45899, 43.2035, 0.75404332338537, -88.2421, -1.54011518387409),
(23313, '53018', 218, 57, 26931, 43.0617, 0.751568446506042, -88.402, -1.54290596534803),
(23314, '53019', 218, 57, 2217, 43.6943, 0.762609399354158, -88.3417, -1.54185353180907),
(23315, '53020', 218, 57, 173978, 43.8302, 0.764981301807619, -88.0158, -1.53616550377683),
(23316, '53021', 218, 57, 2600, 43.4626, 0.758565471477287, -87.9531, -1.53507118233582),
(23317, '53022', 218, 57, 27253, 43.2239, 0.754399370552777, -88.1456, -1.53843094114591),
(23318, '53023', 218, 57, 174273, 43.7924, 0.764321567350365, -88.076, -1.53721619198653),
(23319, '53024', 218, 57, 27298, 43.323, 0.756128991841503, -87.9491, -1.53500136916574),
(23320, '53026', 218, 57, 32623, 43.778, 0.764070239938078, -88.083, -1.53733836503417),
(23321, '53027', 218, 57, 2998, 43.3045, 0.755806105929884, -88.3646, -1.54225321220778),
(23322, '53029', 218, 57, 165, 43.1091, 0.752395732571488, -88.3504, -1.542005375454),
(23323, '53031', 218, 57, 125079, 43.6385, 0.761635505631545, -87.9198, -1.53448998769491),
(23324, '53032', 218, 57, 174569, 43.4499, 0.758343814662284, -88.6306, -1.54689578801809),
(23325, '53033', 218, 57, 174590, 43.2344, 0.754582630124236, -88.2466, -1.54019372369043),
(23326, '53034', 218, 57, 174611, 43.3454, 0.75651994559395, -88.6001, -1.54636346259623),
(23327, '53035', 218, 57, 78507, 43.3953, 0.757390864890695, -88.5329, -1.54519060133889),
(23328, '53036', 218, 57, 174663, 43.136, 0.752865226140274, -88.5836, -1.54607548326965),
(23329, '53037', 218, 57, 3384, 43.3199, 0.756074886634691, -88.1632, -1.53873811909426),
(23330, '53038', 218, 57, 149925, 43.0721, 0.75174996074825, -88.7743, -1.5494038261532),
(23331, '53039', 218, 57, 163198, 43.3964, 0.757410063512467, -88.6866, -1.5478731723992),
(23332, '53040', 218, 57, 174755, 43.5113, 0.759415446823009, -88.2053, -1.53947290270935),
(23333, '53042', 218, 57, 55672, 43.9284, 0.766695215133077, -87.9892, -1.53570124619579),
(23334, '53044', 218, 57, 36754, 43.7404, 0.763413996139328, -87.7866, -1.53216520913125),
(23335, '53045', 218, 57, 13444, 43.0668, 0.751657458297894, -88.1521, -1.53854438754729),
(23336, '53046', 218, 57, 174913, 43.1498, 0.753106081577049, -88.1672, -1.53880793226434),
(23337, '53047', 218, 57, 3708, 43.1914, 0.753832138545879, -88.7217, -1.54848578296665),
(23338, '53048', 218, 57, 175042, 43.5902, 0.760792511602832, -88.443, -1.54362155034134),
(23339, '53049', 218, 57, 3960, 43.8478, 0.76528847975597, -88.3443, -1.54189891036963),
(23340, '53050', 218, 57, 71100, 43.4993, 0.759206007312769, -88.547, -1.54543669276342),
(23341, '53051', 218, 57, 175273, 43.131, 0.752777959677674, -88.1312, -1.53817961373363),
(23342, '53052', 218, 57, 175273, 43.1793, 0.753620953706387, -88.1171, -1.5379335223091),
(23343, '53056', 218, 57, 136848, 43.1483, 0.753079901638269, -88.3072, -1.54125139321714),
(23344, '53057', 218, 57, 23211, 43.8235, 0.764864364747735, -88.2467, -1.54019546901968),
(23345, '53058', 218, 57, 175459, 43.1115, 0.752437620473535, -88.4031, -1.5429251639698),
(23346, '53059', 218, 57, 56472, 43.3124, 0.755943986940792, -88.5254, -1.54505970164499),
(23347, '53060', 218, 57, 4565, 43.4304, 0.758003475458145, -88.0455, -1.53668386656467),
(23348, '53061', 218, 57, 175519, 43.9473, 0.767025082361704, -88.0909, -1.53747624604507),
(23349, '53062', 218, 57, 175519, 43.9477, 0.767032063678712, -88.1015, -1.53766125094578),
(23350, '53063', 218, 57, 4570, 43.9687, 0.767398582821631, -87.7933, -1.53228214619114),
(23351, '53064', 218, 57, 23432, 43.1594, 0.753273633185241, -88.3701, -1.54234920531664),
(23352, '53065', 218, 57, 23561, 43.6839, 0.762427885111951, -88.5463, -1.54542447545866),
(23353, '53066', 218, 57, 175648, 43.1025, 0.752280540840856, -88.477, -1.54421496228702),
(23354, '53069', 218, 57, 175668, 43.113, 0.752463800412315, -88.4448, -1.54365296626788),
(23355, '53070', 218, 57, 175693, 43.6257, 0.76141210348729, -87.7916, -1.53225247559385),
(23356, '53072', 218, 57, 175808, 43.0803, 0.751893077746913, -88.2542, -1.54032636871358),
(23357, '53073', 218, 57, 14433, 43.7506, 0.763592019723031, -87.9802, -1.53554416656312),
(23358, '53074', 218, 57, 151861, 43.3992, 0.757458932731523, -87.881, -1.53381279994514),
(23359, '53075', 218, 57, 176013, 43.5548, 0.760174665047626, -87.9524, -1.53505896503106),
(23360, '53076', 218, 57, 24305, 43.2686, 0.755179532728418, -88.2173, -1.53968234221959),
(23361, '53078', 218, 57, 11716, 43.3248, 0.756160407768039, -88.4249, -1.54330564574673),
(23362, '53079', 218, 57, 17896, 43.7941, 0.764351237947649, -88.1752, -1.5389475586045),
(23363, '53080', 218, 57, 176277, 43.3871, 0.757247747892032, -87.9653, -1.53528411250457),
(23364, '53081', 218, 57, 176349, 43.741, 0.76342446811484, -87.7323, -1.53121749534742),
(23365, '53082', 218, 57, 176349, 43.7653, 0.763848583123074, -87.7672, -1.53182661525637),
(23366, '53083', 218, 57, 176349, 43.7858, 0.764206375619733, -87.7623, -1.53174109412302),
(23367, '53085', 218, 57, 176351, 43.7295, 0.76322375525086, -87.8144, -1.53265041066331),
(23368, '53086', 218, 57, 176419, 43.3298, 0.756247674230639, -88.2778, -1.54073826641705),
(23369, '53088', 218, 57, 25139, 44.0754, 0.769260849133509, -88.3005, -1.54113445615725),
(23370, '53089', 218, 57, 106745, 43.1504, 0.753116553552561, -88.2339, -1.53997206687542),
(23371, '53090', 218, 57, 6703, 43.4819, 0.758902320022922, -88.1983, -1.53935072966171),
(23372, '53091', 218, 57, 153099, 43.5167, 0.759509694602616, -88.4537, -1.54380830057131),
(23373, '53092', 218, 57, 176665, 43.225, 0.754418569174549, -87.96, -1.53519161005421),
(23374, '53093', 218, 57, 6601, 43.6762, 0.762293494759547, -87.9441, -1.53491410270315),
(23375, '53094', 218, 57, 18507, 43.1869, 0.753753598729539, -88.7222, -1.54849450961291),
(23376, '53095', 218, 57, 6703, 43.4209, 0.757837669179206, -88.1855, -1.53912732751746),
(23377, '53097', 218, 57, 175280, 43.2417, 0.754710039159632, -88.0001, -1.53589148708426),
(23378, '53098', 218, 57, 18507, 43.2037, 0.754046814043874, -88.7203, -1.54846134835713),
(23379, '53099', 218, 57, 6917, 43.3703, 0.756954532577697, -88.5183, -1.5449357832681),
(23380, '53101', 218, 57, 7292, 42.5402, 0.742466554456892, -88.2274, -1.53985862047405),
(23381, '53102', 218, 57, 173149, 42.9183, 0.749065644358682, -88.2152, -1.5396456903053),
(23382, '53103', 218, 57, 39380, 42.8766, 0.748337842060601, -88.2152, -1.5396456903053),
(23383, '53104', 218, 57, 15330, 42.5395, 0.742454337152128, -88.0443, -1.53666292261364),
(23384, '53105', 218, 57, 1239, 42.6778, 0.744868127507636, -88.2661, -1.54053406289457),
(23385, '53108', 218, 57, 1296, 42.8272, 0.747475649410115, -87.935, -1.53475527774121),
(23386, '53109', 218, 57, 173427, 42.5388, 0.742442119847364, -88.1419, -1.53836636396359),
(23387, '53110', 218, 57, 173704, 42.9473, 0.749571789841761, -87.864, -1.5335160939723),
(23388, '53114', 218, 57, 20468, 42.6025, 0.743553894580884, -88.7046, -1.54818733166456),
(23389, '53115', 218, 57, 32219, 42.6162, 0.743793004688407, -88.6286, -1.54686088143305),
(23390, '53118', 218, 57, 173840, 42.9861, 0.750248977591535, -88.4602, -1.54392174697269),
(23391, '53119', 218, 57, 2149, 42.8793, 0.748384965950405, -88.4702, -1.54409627989789),
(23392, '53120', 218, 57, 127387, 42.8004, 0.747007901170581, -88.4167, -1.54316252874807),
(23393, '53121', 218, 57, 159, 42.6833, 0.744964120616496, -88.5408, -1.5453284823498),
(23394, '53122', 218, 57, 8738, 43.0485, 0.751338063044779, -88.0865, -1.53739945155799),
(23395, '53125', 218, 57, 32455, 42.546, 0.742567783553507, -88.5666, -1.54577877729681),
(23396, '53126', 218, 57, 174183, 42.7807, 0.746664071307938, -87.9592, -1.5351776474202),
(23397, '53127', 218, 57, 174235, 42.9686, 0.749943544972436, -88.3725, -1.54239109321869),
(23398, '53128', 218, 57, 174231, 42.5347, 0.742370561348032, -88.2966, -1.54106638831643),
(23399, '53129', 218, 57, 27326, 42.9386, 0.749419946196837, -87.9971, -1.5358391272067),
(23400, '53130', 218, 57, 174387, 42.9406, 0.749454852781877, -88.0503, -1.53676764236876),
(23401, '53132', 218, 57, 2595, 42.8993, 0.748734031800803, -88.0065, -1.53600318815639),
(23402, '53137', 218, 57, 174477, 43.0569, 0.751484670701946, -88.6945, -1.54801105341011),
(23403, '53138', 218, 57, 55364, 42.7497, 0.74612301923982, -88.3044, -1.54120252399808),
(23404, '53139', 218, 57, 174723, 42.7021, 0.745292242515871, -88.1261, -1.53809060194177),
(23405, '53140', 218, 57, 174749, 42.5811, 0.743180394120957, -87.83, -1.53292268202662),
(23406, '53141', 218, 57, 174749, 42.5839, 0.743229263340013, -87.8214, -1.53277258371095),
(23407, '53142', 218, 57, 174749, 42.5744, 0.743063457061074, -87.8809, -1.53381105461588),
(23408, '53143', 218, 57, 174749, 42.5455, 0.742559056907247, -87.8365, -1.533036128428),
(23409, '53144', 218, 57, 174749, 42.6498, 0.744379435317078, -87.8682, -1.53358939780088),
(23410, '53146', 218, 57, 17254, 42.9711, 0.749987178203735, -88.1567, -1.53862467269289),
(23411, '53147', 218, 57, 16785, 42.5892, 0.743321765790369, -88.4401, -1.54357093579304),
(23412, '53148', 218, 57, 764, 42.65, 0.744382925975582, -88.3582, -1.54214151113565),
(23413, '53149', 218, 57, 175438, 42.8653, 0.748140619855125, -88.3367, -1.54176626534647),
(23414, '53150', 218, 57, 175449, 42.9093, 0.748908564726003, -88.1167, -1.53792654099209),
(23415, '53151', 218, 57, 17254, 42.982, 0.750177419092203, -88.1053, -1.53772757345736),
(23416, '53152', 218, 57, 175530, 42.5789, 0.743141996877414, -88.229, -1.53988654574208),
(23417, '53153', 218, 57, 96606, 42.9326, 0.749315226441718, -88.3853, -1.54261449536294),
(23418, '53154', 218, 57, 23502, 42.8872, 0.748522846961312, -87.9015, -1.5341705924418),
(23419, '53156', 218, 57, 4846, 42.8769, 0.748343078048357, -88.5879, -1.54615053242748),
(23420, '53157', 218, 57, 175779, 42.5414, 0.742487498407916, -88.3581, -1.5421397658064),
(23421, '53158', 218, 57, 117331, 42.5509, 0.742653304686855, -87.9317, -1.5346976818759),
(23422, '53159', 218, 57, 175943, 42.5532, 0.742693447259651, -88.294, -1.54102100975587),
(23423, '53167', 218, 57, 28433, 42.7405, 0.745962448948636, -88.2247, -1.53981149658424),
(23424, '53168', 218, 57, 126, 42.5667, 0.74292906670867, -88.1253, -1.53807663930776),
(23425, '53170', 218, 57, 18083, 42.5506, 0.742648068699099, -88.1703, -1.53886203747116),
(23426, '53171', 218, 57, 106389, 42.6385, 0.744182213111602, -87.9073, -1.53427182153841),
(23427, '53172', 218, 57, 176450, 42.9118, 0.748952197957303, -87.8654, -1.53354052858183),
(23428, '53176', 218, 57, 349, 42.6428, 0.744257262269438, -88.4135, -1.54310667821201),
(23429, '53177', 218, 57, 176583, 42.6982, 0.745224174675043, -87.9185, -1.53446729841463),
(23430, '53178', 218, 57, 28723, 43.0107, 0.750678328587525, -88.5968, -1.54630586673091),
(23431, '53179', 218, 57, 176726, 42.5165, 0.742052911424169, -88.1325, -1.5382023030139),
(23432, '53181', 218, 57, 18397, 42.5209, 0.742129705911257, -88.253, -1.54030542476256),
(23433, '53182', 218, 57, 6461, 42.705, 0.745342857064178, -88.0412, -1.53660881740683),
(23434, '53183', 218, 57, 38725, 43.004, 0.750561391527641, -88.3795, -1.54251326626633),
(23435, '53184', 218, 57, 143305, 42.5321, 0.74232518278748, -88.5977, -1.54632157469418),
(23436, '53185', 218, 57, 790, 42.7948, 0.746910162732469, -88.1954, -1.53930011511341),
(23437, '53186', 218, 57, 176899, 43.0105, 0.750674837929021, -88.2128, -1.53960380240325),
(23438, '53187', 218, 57, 176899, 43.0092, 0.750652148648745, -88.2242, -1.53980276993798),
(23439, '53188', 218, 57, 176899, 43.0172, 0.750791774988905, -88.2661, -1.54053406289457),
(23440, '53189', 218, 57, 176899, 43.0117, 0.750695781880045, -88.2313, -1.53992668831487),
(23441, '53190', 218, 57, 26032, 42.8194, 0.74733951372846, -88.7279, -1.54859399338028),
(23442, '53191', 218, 57, 177048, 42.5756, 0.743084401012098, -88.5388, -1.54529357576476),
(23443, '53192', 218, 57, 12881, 42.512, 0.741974371607829, -88.211, -1.53957238647672),
(23444, '53194', 218, 57, 44230, 42.5648, 0.742895905452882, -88.072, -1.53714637881645),
(23445, '53195', 218, 57, 34489, 42.5119, 0.741972626278577, -88.4815, -1.54429350210336),
(23446, '53201', 218, 57, 66863, 43.0348, 0.751098952937256, -87.9151, -1.53440795722007),
(23447, '53202', 218, 57, 66863, 43.0462, 0.751297920471983, -87.8984, -1.53411648723498),
(23448, '53203', 218, 57, 66863, 43.0387, 0.751167020778084, -87.915, -1.53440621189081),
(23449, '53204', 218, 57, 66863, 43.0181, 0.750807482952173, -87.9252, -1.53458423547452),
(23450, '53205', 218, 57, 66863, 43.0528, 0.751413112202615, -87.9322, -1.53470640852216),
(23451, '53206', 218, 57, 66863, 43.0752, 0.751804065955061, -87.9332, -1.53472386181468),
(23452, '53207', 218, 57, 66863, 42.9822, 0.750180909750707, -87.8926, -1.53401525813837),
(23453, '53208', 218, 57, 66863, 43.0465, 0.751303156459739, -87.9665, -1.53530505645559),
(23454, '53209', 218, 57, 66863, 43.1241, 0.752657531959287, -87.9456, -1.53494028264193),
(23455, '53210', 218, 57, 66863, 43.0685, 0.751687128895178, -87.9767, -1.5354830800393),
(23456, '53211', 218, 57, 66863, 43.0834, 0.751947182953725, -87.8865, -1.533908793054),
(23457, '53212', 218, 57, 66863, 43.0703, 0.751718544821714, -87.9054, -1.53423866028262),
(23458, '53213', 218, 57, 66863, 43.0483, 0.751334572386275, -88.0029, -1.53594035630332),
(23459, '53214', 218, 57, 66863, 43.0205, 0.750849370854221, -88.0187, -1.53621611832513),
(23460, '53215', 218, 57, 66863, 42.9995, 0.750482851711302, -87.9457, -1.53494202797118),
(23461, '53216', 218, 57, 66863, 43.0874, 0.752016996123805, -87.9756, -1.53546388141752),
(23462, '53217', 218, 57, 66863, 43.1484, 0.753081646967521, -87.9119, -1.534352106684),
(23463, '53218', 218, 57, 66863, 43.1123, 0.752451583107551, -87.9933, -1.53577280469513),
(23464, '53219', 218, 57, 66863, 42.9948, 0.750400821236458, -87.9929, -1.53576582337812),
(23465, '53220', 218, 57, 66863, 42.9674, 0.749922601021412, -87.9918, -1.53574662475635),
(23466, '53221', 218, 57, 66863, 42.9481, 0.749585752475777, -87.9427, -1.53488966809362);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(23467, '53222', 218, 57, 66863, 43.083, 0.751940201636717, -88.0381, -1.53655471220002),
(23468, '53223', 218, 57, 66863, 43.1589, 0.753264906538981, -87.9935, -1.53577629535363),
(23469, '53224', 218, 57, 66863, 43.1585, 0.753257925221973, -88.0428, -1.53663674267486),
(23470, '53225', 218, 57, 66863, 43.1158, 0.752512669631371, -88.0409, -1.53660358141908),
(23471, '53226', 218, 57, 66863, 43.0481, 0.751331081727771, -88.0429, -1.53663848800412),
(23472, '53227', 218, 57, 66863, 42.995, 0.750404311894962, -88.0414, -1.53661230806534),
(23473, '53228', 218, 57, 66863, 42.9644, 0.749870241143852, -88.0426, -1.53663325201636),
(23474, '53233', 218, 57, 66863, 43.0388, 0.751168766107336, -87.9335, -1.53472909780243),
(23475, '53234', 218, 57, 66863, 43.0027, 0.750538702247366, -87.9677, -1.53532600040662),
(23476, '53235', 218, 57, 66863, 42.9698, 0.749964488923459, -87.8736, -1.53368364558049),
(23477, '53237', 218, 57, 66863, 42.9441, 0.749515939305697, -87.9088, -1.53429800147719),
(23478, '53259', 218, 57, 66863, 43.0383, 0.751160039461076, -87.9132, -1.53437479596428),
(23479, '53263', 218, 57, 66863, 43.082, 0.751922748344197, -88.0366, -1.53652853226124),
(23480, '53267', 218, 57, 66863, 43.0441, 0.751261268557691, -87.91, -1.53431894542822),
(23481, '53268', 218, 57, 66863, 43.0382, 0.751158294131824, -87.9108, -1.53433290806223),
(23482, '53270', 218, 57, 66863, 43.0392, 0.751175747424343, -87.9044, -1.5342212069901),
(23483, '53274', 218, 57, 66863, 43.0391, 0.751174002095091, -87.9068, -1.53426309489215),
(23484, '53277', 218, 57, 66863, 43.0392, 0.751175747424343, -87.902, -1.53417931908806),
(23485, '53278', 218, 57, 66863, 43.0393, 0.751177492753595, -87.9027, -1.53419153639282),
(23486, '53280', 218, 57, 66863, 43.0411, 0.751208908680131, -87.9581, -1.53515844879842),
(23487, '53281', 218, 57, 66863, 43.0409, 0.751205418021627, -87.9582, -1.53516019412768),
(23488, '53284', 218, 57, 66863, 43.0964, 0.752174075756484, -87.9081, -1.53428578417243),
(23489, '53285', 218, 57, 66863, 43.0967, 0.75217931174424, -87.9078, -1.53428054818467),
(23490, '53288', 218, 57, 66863, 43.0406, 0.751200182033871, -87.9102, -1.53432243608672),
(23491, '53290', 218, 57, 66863, 43.0371, 0.751139095510052, -87.9144, -1.5343957399153),
(23492, '53293', 218, 57, 66863, 43.0403, 0.751194946046115, -87.9194, -1.5344830063779),
(23493, '53295', 218, 57, 66863, 43.0188, 0.750819700256937, -87.9816, -1.53556860117264),
(23494, '53401', 218, 57, 819, 42.6939, 0.745149125517207, -87.8133, -1.53263121204154),
(23495, '53402', 218, 57, 819, 42.7991, 0.746985211890305, -87.8329, -1.53297329657493),
(23496, '53403', 218, 57, 819, 42.7034, 0.745314931796147, -87.8094, -1.53256314420071),
(23497, '53404', 218, 57, 819, 42.744, 0.746023535472456, -87.8094, -1.53256314420071),
(23498, '53405', 218, 57, 819, 42.7173, 0.745557532562174, -87.8237, -1.53281272628374),
(23499, '53406', 218, 57, 819, 42.7265, 0.745718102853357, -87.8587, -1.53342359152194),
(23500, '53407', 218, 57, 819, 42.7256, 0.745702394890089, -87.7826, -1.53209539596117),
(23501, '53408', 218, 57, 819, 42.7287, 0.745756500096901, -87.8066, -1.53251427498165),
(23502, '53490', 218, 57, 819, 42.7258, 0.745705885548593, -87.7827, -1.53209714129043),
(23503, '53501', 218, 57, 570, 42.6038, 0.74357658386116, -89.0718, -1.55459618067789),
(23504, '53502', 218, 57, 18772, 42.7314, 0.745803623986705, -89.4453, -1.56111498543408),
(23505, '53503', 218, 57, 146856, 43.1421, 0.752971691224646, -89.9468, -1.56986781163284),
(23506, '53504', 218, 57, 15022, 42.7018, 0.745287006528115, -89.9014, -1.56907543215243),
(23507, '53505', 218, 57, 13310, 42.6867, 0.745023461811063, -88.8117, -1.55005657929345),
(23508, '53506', 218, 57, 7207, 43.1911, 0.753826902558123, -90.3212, -1.5764023243523),
(23509, '53507', 218, 57, 147011, 43.01, 0.750666111282761, -89.8985, -1.56902481760412),
(23510, '53508', 218, 57, 263, 42.8834, 0.748456524449736, -89.5607, -1.56312909539089),
(23511, '53510', 218, 57, 303, 42.7317, 0.745808859974461, -90.3285, -1.5765297333877),
(23512, '53511', 218, 57, 309, 42.5274, 0.742243152312636, -89.0485, -1.55418951896217),
(23513, '53512', 218, 57, 309, 42.5083, 0.741909794425506, -89.032, -1.55390153963559),
(23514, '53515', 218, 57, 173199, 43.1265, 0.752699419861334, -89.7413, -1.56628116001999),
(23515, '53516', 218, 57, 124259, 42.7855, 0.746747847112034, -89.9011, -1.56907019616467),
(23516, '53517', 218, 57, 173233, 43.0054, 0.750585826137169, -89.8188, -1.56763379019028),
(23517, '53518', 218, 57, 29245, 43.1834, 0.753692512205719, -90.5555, -1.58049163078973),
(23518, '53520', 218, 57, 35001, 42.6203, 0.743864563187739, -89.376, -1.55990547226245),
(23519, '53521', 218, 57, 1157, 42.8694, 0.748212178354457, -89.3911, -1.5601690169795),
(23520, '53522', 218, 57, 1192, 42.5728, 0.743035531793042, -89.7958, -1.56723236446232),
(23521, '53523', 218, 57, 1302, 42.9823, 0.750182655079959, -89.0462, -1.55414937638937),
(23522, '53525', 218, 57, 1630, 42.5592, 0.742798167014771, -88.8688, -1.55105316229634),
(23523, '53526', 218, 57, 20127, 42.9647, 0.749875477131608, -90.3324, -1.57659780122853),
(23524, '53527', 218, 57, 1788, 43.0737, 0.751777886016282, -89.1992, -1.55681973014493),
(23525, '53528', 218, 57, 473, 43.1203, 0.752591209447711, -89.6382, -1.56448172556118),
(23526, '53529', 218, 57, 75605, 43.2364, 0.754617536709276, -89.5264, -1.56253044745745),
(23527, '53530', 218, 57, 1971, 42.6883, 0.745051387079095, -90.1083, -1.57268651837481),
(23528, '53531', 218, 57, 8455, 43.0545, 0.751442782799899, -89.0942, -1.55498713443033),
(23529, '53532', 218, 57, 134945, 43.2391, 0.75466466059908, -89.3355, -1.55919861391539),
(23530, '53533', 218, 57, 115290, 42.9632, 0.749849297192828, -90.1324, -1.57310714272454),
(23531, '53534', 218, 57, 32304, 42.8223, 0.747390128276768, -89.0658, -1.55449146092277),
(23532, '53535', 218, 57, 80843, 42.9661, 0.749899911741136, -90.2648, -1.57541795865418),
(23533, '53536', 218, 57, 2341, 42.7695, 0.746468594431715, -89.2736, -1.55811825510841),
(23534, '53537', 218, 57, 64786, 42.6708, 0.744745954459996, -89.2101, -1.55700997103339),
(23535, '53538', 218, 57, 112997, 42.9267, 0.74921225201585, -88.8409, -1.55056621543503),
(23536, '53540', 218, 57, 174304, 43.2239, 0.754399370552777, -90.2935, -1.5759188681495),
(23537, '53541', 218, 57, 55051, 42.5857, 0.743260679266549, -90.0198, -1.57114190198679),
(23538, '53542', 218, 57, 2963, 42.6297, 0.744028624137427, -89.1688, -1.55628915005232),
(23539, '53543', 218, 57, 3108, 43.0416, 0.751217635326391, -90.364, -1.57714932527216),
(23540, '53544', 218, 57, 60287, 42.9047, 0.748828279580411, -89.8303, -1.56783450305426),
(23541, '53545', 218, 57, 27546, 42.688, 0.745046151091339, -89.0522, -1.55425409614449),
(23542, '53546', 218, 57, 27546, 42.6695, 0.74472326517972, -88.9925, -1.55321213458105),
(23543, '53547', 218, 57, 27546, 42.705, 0.745342857064178, -89.0058, -1.55344426337157),
(23544, '53549', 218, 57, 3409, 43.0022, 0.750529975601106, -88.8049, -1.54993789690431),
(23545, '53550', 218, 57, 174712, 42.5017, 0.741794602694874, -89.5106, -1.56225468543564),
(23546, '53551', 218, 57, 116370, 43.0809, 0.751903549722425, -88.9108, -1.55178620058217),
(23547, '53553', 218, 57, 3784, 42.9165, 0.749034228432146, -90.2758, -1.5756099448719),
(23548, '53554', 218, 57, 3825, 42.8988, 0.748725305154544, -90.4555, -1.57874630153773),
(23549, '53555', 218, 57, 112, 43.327, 0.756198805011583, -89.5627, -1.56316400197593),
(23550, '53556', 218, 57, 10172, 43.1829, 0.753683785559459, -90.1981, -1.5742538240431),
(23551, '53557', 218, 57, 10211, 43.3396, 0.756418716497334, -88.8156, -1.55012464713428),
(23552, '53558', 218, 57, 33228, 43.0084, 0.750638186014729, -89.2944, -1.55848128359282),
(23553, '53559', 218, 57, 4011, 43.1743, 0.753533687243788, -89.0744, -1.55464155923844),
(23554, '53560', 218, 57, 175221, 43.1874, 0.753762325375799, -89.7587, -1.56658484730983),
(23555, '53561', 218, 57, 17098, 43.3776, 0.757081941613092, -89.6738, -1.56510306277489),
(23556, '53562', 218, 57, 4185, 43.1058, 0.752338136706172, -89.5159, -1.56234718788599),
(23557, '53563', 218, 57, 4232, 42.7789, 0.746632655381402, -88.9551, -1.55255938144081),
(23558, '53565', 218, 57, 56289, 42.8624, 0.748090005306818, -90.1804, -1.57394490076549),
(23559, '53566', 218, 57, 10560, 42.598, 0.743475354764545, -89.6396, -1.56450616017071),
(23560, '53569', 218, 57, 96299, 42.9909, 0.75033275339563, -90.4725, -1.57904300751057),
(23561, '53570', 218, 57, 588, 42.7497, 0.74612301923982, -89.5947, -1.56372250733656),
(23562, '53571', 218, 57, 27951, 43.2778, 0.755340103019602, -89.3568, -1.55957036904607),
(23563, '53572', 218, 57, 60967, 42.9799, 0.750140767177911, -89.731, -1.56610139110703),
(23564, '53573', 218, 57, 4468, 43.165, 0.753371371623352, -90.4664, -1.5789365424262),
(23565, '53574', 218, 57, 175514, 42.8125, 0.747219086010072, -89.6371, -1.56446252693941),
(23566, '53575', 218, 57, 37541, 42.9316, 0.749297773149198, -89.3888, -1.56012887440671),
(23567, '53576', 218, 57, 144280, 42.6236, 0.743922159053055, -89.2433, -1.55758942034506),
(23568, '53577', 218, 57, 713, 43.2769, 0.755324395056334, -90.0452, -1.5715852156168),
(23569, '53578', 218, 57, 175960, 43.2883, 0.755523362591061, -89.739, -1.56624101744719),
(23570, '53579', 218, 57, 176046, 43.3074, 0.755856720478192, -88.8451, -1.55063951926361),
(23571, '53580', 218, 57, 176057, 42.8433, 0.747756647419687, -90.3955, -1.57769910398653),
(23572, '53581', 218, 57, 123532, 43.3388, 0.756404753863319, -90.3854, -1.57752282573208),
(23573, '53582', 218, 57, 11587, 42.9985, 0.750465398418782, -89.994, -1.57069160703978),
(23574, '53583', 218, 57, 176273, 43.2734, 0.755263308532514, -89.7336, -1.56614676966758),
(23575, '53584', 218, 57, 176326, 43.2778, 0.755340103019602, -90.291, -1.5758752349182),
(23576, '53585', 218, 57, 24789, 42.5061, 0.741871397181962, -88.7276, -1.54858875739252),
(23577, '53586', 218, 57, 176394, 42.5794, 0.743150723523674, -90.2255, -1.57473204425814),
(23578, '53587', 218, 57, 176456, 42.5877, 0.743295585851589, -89.9021, -1.56908764945719),
(23579, '53588', 218, 57, 121548, 43.1844, 0.753709965498239, -90.0783, -1.57216291959921),
(23580, '53589', 218, 57, 126269, 42.9289, 0.749250649259394, -89.2158, -1.55710945480076),
(23581, '53590', 218, 57, 176609, 43.1924, 0.753849591838399, -89.2198, -1.55717926797084),
(23582, '53591', 218, 57, 176609, 43.1879, 0.753771052022059, -89.2371, -1.55748120993143),
(23583, '53593', 218, 57, 12546, 42.9913, 0.750339734712638, -89.5688, -1.5632704670603),
(23584, '53594', 218, 57, 6650, 43.1802, 0.753636661669655, -88.9846, -1.55307425357015),
(23585, '53595', 218, 57, 115290, 42.9638, 0.74985976916834, -90.1305, -1.57307398146875),
(23586, '53596', 218, 57, 176609, 43.192, 0.753842610521391, -89.2617, -1.55791056092742),
(23587, '53597', 218, 57, 176904, 43.1779, 0.75359651909686, -89.4512, -1.56121795985995),
(23588, '53598', 218, 57, 18652, 43.2125, 0.75420040301805, -89.3435, -1.55933824025555),
(23589, '53599', 218, 57, 6914, 42.6495, 0.744374199329322, -89.8617, -1.56838253643939),
(23590, '53701', 218, 57, 3938, 43.0731, 0.75176741404077, -89.3816, -1.56000321070056),
(23591, '53702', 218, 57, 3938, 43.0754, 0.751807556613565, -89.3808, -1.55998924806655),
(23592, '53703', 218, 57, 3938, 43.0793, 0.751875624454393, -89.3767, -1.55991768956722),
(23593, '53704', 218, 57, 3938, 43.1163, 0.752521396277631, -89.335, -1.55918988726913),
(23594, '53705', 218, 57, 3938, 43.0728, 0.751762178053014, -89.4608, -1.56138551146814),
(23595, '53706', 218, 57, 3938, 43.0753, 0.751805811284313, -89.4118, -1.56053030013467),
(23596, '53707', 218, 57, 3938, 43.0986, 0.752212473000028, -89.3129, -1.55880416950444),
(23597, '53708', 218, 57, 3938, 43.0999, 0.752235162280304, -89.3137, -1.55881813213846),
(23598, '53711', 218, 57, 3938, 43.0336, 0.751078008986232, -89.4451, -1.56111149477558),
(23599, '53713', 218, 57, 3938, 43.0356, 0.751112915571272, -89.3957, -1.56024930212509),
(23600, '53714', 218, 57, 3938, 43.099, 0.752219454317036, -89.3126, -1.55879893351669),
(23601, '53715', 218, 57, 3938, 43.0629, 0.751589390457066, -89.3964, -1.56026151942986),
(23602, '53716', 218, 57, 3938, 43.0665, 0.751652222310138, -89.3151, -1.55884256674799),
(23603, '53717', 218, 57, 3938, 43.0718, 0.751744724760494, -89.5111, -1.5622634120819),
(23604, '53718', 218, 57, 3938, 43.1505, 0.753118298881813, -89.409, -1.56048143091561),
(23605, '53719', 218, 57, 3938, 43.0307, 0.751027394437924, -89.4981, -1.56203651927914),
(23606, '53725', 218, 57, 3938, 43.0504, 0.751371224300567, -89.3958, -1.56025104745435),
(23607, '53726', 218, 57, 3938, 43.0728, 0.751762178053014, -89.3981, -1.56029119002714),
(23608, '53744', 218, 57, 3938, 43.0153, 0.750758613733117, -89.4135, -1.56055997073195),
(23609, '53774', 218, 57, 3938, 43.0734, 0.751772650028526, -89.4012, -1.56034529523395),
(23610, '53777', 218, 57, 3938, 43.1069, 0.752357335327944, -89.3387, -1.55925446445146),
(23611, '53778', 218, 57, 3938, 43.098, 0.752202001024516, -89.3248, -1.55901186368543),
(23612, '53779', 218, 57, 3938, 43.098, 0.752202001024516, -89.3243, -1.55900313703917),
(23613, '53782', 218, 57, 3938, 43.062, 0.751573682493798, -89.3131, -1.55880766016295),
(23614, '53783', 218, 57, 3938, 43.1597, 0.753278869172997, -89.2842, -1.55830326000912),
(23615, '53784', 218, 57, 3938, 43.0393, 0.751177492753595, -89.3931, -1.56020392356454),
(23616, '53785', 218, 57, 3938, 43.0765, 0.751826755235337, -89.3817, -1.56000495602982),
(23617, '53786', 218, 57, 3938, 43.076, 0.751818028589077, -89.3816, -1.56000321070056),
(23618, '53787', 218, 57, 3938, 43.0766, 0.751828500564589, -89.3819, -1.56000844668832),
(23619, '53788', 218, 57, 3938, 43.0769, 0.751833736552345, -89.377, -1.55992292555497),
(23620, '53789', 218, 57, 3938, 43.0764, 0.751825009906085, -89.3815, -1.56000146537131),
(23621, '53790', 218, 57, 3938, 43.0757, 0.751812792601321, -89.3815, -1.56000146537131),
(23622, '53791', 218, 57, 3938, 43.0758, 0.751814537930573, -89.4552, -1.56128777303003),
(23623, '53792', 218, 57, 3938, 43.0769, 0.751833736552345, -89.4331, -1.56090205526534),
(23624, '53793', 218, 57, 3938, 43.0986, 0.752212473000028, -89.3242, -1.55900139170992),
(23625, '53794', 218, 57, 3938, 43.0983, 0.752207237012272, -89.3246, -1.55900837302693),
(23626, '53801', 218, 57, 44547, 42.9261, 0.749201780040338, -91.0537, -1.58918686112316),
(23627, '53802', 218, 57, 173119, 42.7613, 0.746325477433051, -90.891, -1.58634721043017),
(23628, '53803', 218, 57, 358, 42.5603, 0.742817365636543, -90.3659, -1.57718248652794),
(23629, '53804', 218, 57, 29235, 42.8742, 0.748295954158553, -90.9147, -1.58676085346289),
(23630, '53805', 218, 57, 100067, 43.1198, 0.752582482801451, -90.681, -1.58268201900098),
(23631, '53806', 218, 57, 19837, 42.7405, 0.745962448948636, -90.9421, -1.58723907367794),
(23632, '53807', 218, 57, 173702, 42.5976, 0.743468373447536, -90.51, -1.57969750598007),
(23633, '53808', 218, 57, 29641, 42.6265, 0.743972773601363, -90.5942, -1.58116707321025),
(23634, '53809', 218, 57, 174086, 42.9878, 0.750278648188818, -90.6436, -1.58202926586073),
(23635, '53810', 218, 57, 21412, 42.8221, 0.747386637618264, -90.9892, -1.58806112375562),
(23636, '53811', 218, 57, 3033, 42.5365, 0.742401977274568, -90.5082, -1.57966609005353),
(23637, '53812', 218, 57, 174767, 42.5839, 0.743229263340013, -90.6009, -1.58128401027013),
(23638, '53813', 218, 57, 16841, 42.8455, 0.74779504466323, -90.7084, -1.58316023921602),
(23639, '53816', 218, 57, 4376, 42.9724, 0.750009867484011, -90.8449, -1.585542613645),
(23640, '53817', 218, 57, 175767, 42.9454, 0.749538628585973, -90.9724, -1.58776790844129),
(23641, '53818', 218, 57, 117318, 42.7461, 0.746060187386748, -90.4965, -1.57946188653105),
(23642, '53820', 218, 57, 57008, 42.6976, 0.745213702699531, -90.707, -1.5831358046065),
(23643, '53821', 218, 57, 175957, 43.0459, 0.751292684484227, -91.1362, -1.59062675775606),
(23644, '53824', 218, 57, 176406, 42.5235, 0.742175084471809, -90.5387, -1.58019841547539),
(23645, '53825', 218, 57, 176552, 42.9168, 0.749039464419902, -90.5888, -1.58107282543064),
(23646, '53826', 218, 57, 176927, 43.111, 0.752428893827275, -90.8553, -1.5857241278872),
(23647, '53827', 218, 57, 38954, 43.0466, 0.751304901788991, -90.8247, -1.58519005713609),
(23648, '53901', 218, 57, 42669, 43.5421, 0.759953008232623, -89.4718, -1.56157749768586),
(23649, '53910', 218, 57, 14941, 43.909, 0.76635662125819, -89.8015, -1.56733184822969),
(23650, '53911', 218, 57, 15026, 43.2859, 0.755481474689014, -89.3871, -1.56009920380942),
(23651, '53913', 218, 57, 173048, 43.4772, 0.758820289548079, -89.744, -1.56632828390979),
(23652, '53916', 218, 57, 34718, 43.4617, 0.758549763514019, -88.8405, -1.55055923411802),
(23653, '53917', 218, 57, 34718, 43.464, 0.758589906086815, -88.8368, -1.5504946569357),
(23654, '53919', 218, 57, 7653, 43.733, 0.76328484177468, -88.7841, -1.5495748684199),
(23655, '53920', 218, 57, 7677, 43.6599, 0.762009006091472, -89.6183, -1.56413440504003),
(23656, '53922', 218, 57, 19647, 43.5242, 0.759640594296516, -88.7026, -1.54815242507952),
(23657, '53923', 218, 57, 26686, 43.5457, 0.760015840085695, -89.1068, -1.55520704591608),
(23658, '53924', 218, 57, 119059, 43.5029, 0.759268839165841, -90.2714, -1.57553315038481),
(23659, '53925', 218, 57, 1718, 43.3374, 0.756380319253791, -89.0265, -1.55380554652673),
(23660, '53926', 218, 57, 8391, 43.6556, 0.761933956933637, -89.2047, -1.55691572325379),
(23661, '53927', 218, 57, 15772, 43.9605, 0.767255465822967, -89.9427, -1.5697962531335),
(23662, '53928', 218, 57, 8586, 43.4266, 0.757937152946569, -89.1484, -1.55593310288491),
(23663, '53929', 218, 57, 64517, 43.7444, 0.763483809309408, -90.2665, -1.57544762925146),
(23664, '53930', 218, 57, 161366, 43.716, 0.762988135801841, -89.467, -1.56149372188177),
(23665, '53931', 218, 57, 174062, 43.7442, 0.763480318650903, -88.8659, -1.55100254774803),
(23666, '53932', 218, 57, 32423, 43.3859, 0.757226803941008, -89.0438, -1.55410748848733),
(23667, '53933', 218, 57, 119675, 43.5645, 0.76034396198507, -88.9124, -1.55181412585021),
(23668, '53934', 218, 57, 2610, 43.9781, 0.767562643771318, -89.8364, -1.56794096813863),
(23669, '53935', 218, 57, 135490, 43.589, 0.760771567651808, -89.0665, -1.55450367822753),
(23670, '53936', 218, 57, 174311, 43.8551, 0.765415888791365, -89.7301, -1.56608568314376),
(23671, '53937', 218, 57, 0, 43.387, 0.75724600256278, -90.1656, -1.5736865920362),
(23672, '53939', 218, 57, 3542, 43.6944, 0.76261114468341, -89.1249, -1.55552295051069),
(23673, '53940', 218, 57, 174853, 43.5907, 0.760801238249092, -89.794, -1.56720094853579),
(23674, '53941', 218, 57, 174834, 43.5767, 0.760556892153813, -90.1387, -1.57321709846741),
(23675, '53942', 218, 57, 163794, 43.4686, 0.758670191232407, -90.1595, -1.57358012695183),
(23676, '53943', 218, 57, 22725, 43.4399, 0.758169281737085, -90.0404, -1.5715014398127),
(23677, '53944', 218, 57, 33158, 43.709, 0.762865962754202, -89.8934, -1.56893580581227),
(23678, '53946', 218, 57, 175180, 43.7084, 0.76285549077869, -88.9876, -1.55312661344771),
(23679, '53947', 218, 57, 33204, 43.7475, 0.763537914516219, -89.1417, -1.55581616582503),
(23680, '53948', 218, 57, 175215, 43.7967, 0.764396616508201, -90.08, -1.57219259019649),
(23681, '53949', 218, 57, 125464, 43.7937, 0.764344256630641, -89.3276, -1.55906073290449),
(23682, '53950', 218, 57, 30639, 43.8858, 0.765951704871727, -90.1529, -1.5734649352212),
(23683, '53951', 218, 57, 165319, 43.4299, 0.757994748811885, -89.8524, -1.56822022081895),
(23684, '53952', 218, 57, 4828, 43.8001, 0.764455957702768, -89.6412, -1.56453408543874),
(23685, '53953', 218, 57, 175742, 43.766, 0.763860800427838, -89.4687, -1.56152339247905),
(23686, '53954', 218, 57, 175752, 43.5314, 0.75976625800266, -89.3198, -1.55892459722283),
(23687, '53955', 218, 57, 110979, 43.3935, 0.757359448964159, -89.4139, -1.56056695204896),
(23688, '53956', 218, 57, 5293, 43.5408, 0.759930318952347, -89.0025, -1.55338666750625),
(23689, '53957', 218, 57, 5293, 43.5389, 0.759897157696559, -89.0069, -1.55346346199334),
(23690, '53958', 218, 57, 157304, 43.5325, 0.759785456624432, -90.003, -1.57084868667246),
(23691, '53959', 218, 57, 157304, 43.5367, 0.759858760453015, -90.0014, -1.57082076140442),
(23692, '53960', 218, 57, 17799, 43.4457, 0.7582705108337, -89.2507, -1.5577185747097),
(23693, '53961', 218, 57, 5469, 43.479, 0.758851705474615, -89.9125, -1.5692691636994),
(23694, '53962', 218, 57, 28825, 43.6853, 0.762452319721479, -90.2661, -1.57544064793445),
(23695, '53963', 218, 57, 176911, 43.6286, 0.761462718035598, -88.7351, -1.54871965708642),
(23696, '53964', 218, 57, 723, 43.9212, 0.766569551426934, -89.6209, -1.56417978360059),
(23697, '53965', 218, 57, 177097, 43.7263, 0.763167904714797, -89.7614, -1.56663197119964),
(23698, '53968', 218, 57, 177112, 43.655, 0.761923484958125, -90.2211, -1.57465524977106),
(23699, '53969', 218, 57, 177154, 43.4946, 0.759123976837926, -89.3077, -1.55871341238334),
(23700, '54001', 218, 57, 172905, 45.3089, 0.790789485456859, -92.3559, -1.61191453864263),
(23701, '54002', 218, 57, 722, 44.9583, 0.784670361099367, -92.37, -1.61216063006716),
(23702, '54003', 218, 57, 173122, 44.7872, 0.781684102749204, -92.4411, -1.61340155916533),
(23703, '54004', 218, 57, 608, 45.3295, 0.79114902328277, -92.1691, -1.60865426359991),
(23704, '54005', 218, 57, 8114, 45.2506, 0.789771958502946, -92.2735, -1.61047638733899),
(23705, '54006', 218, 57, 75594, 45.578, 0.795486166473976, -92.7069, -1.61804064431713),
(23706, '54007', 218, 57, 2011, 45.1727, 0.788412347015642, -92.3626, -1.61203147570251),
(23707, '54009', 218, 57, 173855, 45.3621, 0.79171800061892, -92.6215, -1.61655013313593),
(23708, '54010', 218, 57, 173904, 44.7324, 0.780727662319111, -92.4709, -1.61392166728242),
(23709, '54011', 218, 57, 579, 44.7369, 0.780806202135451, -92.4826, -1.61412587080491),
(23710, '54013', 218, 57, 174284, 45.0609, 0.786461068911913, -92.1729, -1.60872058611148),
(23711, '54014', 218, 57, 174389, 44.6023, 0.778456988962267, -92.5386, -1.61510325518602),
(23712, '54015', 218, 57, 421, 44.965, 0.78478729815925, -92.4632, -1.61378727693002),
(23713, '54016', 218, 57, 16505, 44.9728, 0.784923433840906, -92.7441, -1.61868990679887),
(23714, '54017', 218, 57, 177, 45.1216, 0.787520483767873, -92.5389, -1.61510849117378),
(23715, '54020', 218, 57, 11010, 45.323, 0.79103557688139, -92.6986, -1.61789578198922),
(23716, '54021', 218, 57, 5219, 44.7515, 0.781061020206242, -92.7929, -1.61954162747385),
(23717, '54022', 218, 57, 5435, 44.8577, 0.78291455987186, -92.6214, -1.61654838780668),
(23718, '54023', 218, 57, 5442, 44.9841, 0.785120656046381, -92.5518, -1.61533363864729),
(23719, '54024', 218, 57, 176228, 45.4104, 0.792560994647633, -92.6328, -1.6167473553414),
(23720, '54025', 218, 57, 5946, 45.1285, 0.787640911486261, -92.6772, -1.61752228152929),
(23721, '54026', 218, 57, 176524, 45.1963, 0.788824244719113, -92.5315, -1.61497933680913),
(23722, '54027', 218, 57, 565, 44.9571, 0.784649417148343, -92.1702, -1.60867346222168),
(23723, '54028', 218, 57, 6954, 44.9529, 0.784576113319759, -92.2869, -1.61071026145876),
(23724, '54082', 218, 57, 127775, 45.0672, 0.786571024654788, -92.7688, -1.61912100312412),
(23725, '54101', 218, 57, 172830, 44.7842, 0.781631742871645, -88.0476, -1.53672051847896),
(23726, '54102', 218, 57, 172902, 45.4971, 0.794074195109112, -87.9329, -1.53471862582692),
(23727, '54103', 218, 57, 172964, 45.6675, 0.79704823615451, -88.4468, -1.54368787285292),
(23728, '54104', 218, 57, 172992, 45.4595, 0.793417951310362, -88.2423, -1.54011867453259),
(23729, '54106', 218, 57, 842, 44.4827, 0.776369575176882, -88.4491, -1.54372801542572),
(23730, '54107', 218, 57, 173248, 44.6958, 0.780088871812882, -88.4378, -1.54353079322024),
(23731, '54110', 218, 57, 173299, 44.1739, 0.770979998446723, -88.0669, -1.53705736702459),
(23732, '54111', 218, 57, 7972, 44.8108, 0.782096000452675, -88.4509, -1.54375943135225),
(23733, '54112', 218, 57, 1693, 45.0368, 0.786040444562182, -88.1419, -1.53836636396359),
(23734, '54113', 218, 57, 173632, 44.266, 0.77258744668781, -88.3102, -1.5413037530947),
(23735, '54114', 218, 57, 173693, 45.2428, 0.789635822821291, -88.3476, -1.54195650623494),
(23736, '54115', 218, 57, 173757, 44.4365, 0.77556323306246, -88.0696, -1.5371044909144),
(23737, '54119', 218, 57, 2127, 45.5755, 0.795442533242676, -88.1106, -1.53782007590772),
(23738, '54120', 218, 57, 174084, 45.7648, 0.798746441516701, -88.4433, -1.5436267863291),
(23739, '54121', 218, 57, 2502, 45.9229, 0.801505807064104, -88.2504, -1.540260046202),
(23740, '54123', 218, 57, 174134, 44.2054, 0.771529777161101, -88.1459, -1.53843617713367),
(23741, '54124', 218, 57, 9113, 44.9063, 0.78376278988833, -88.3426, -1.54186923977234),
(23742, '54125', 218, 57, 2775, 45.6296, 0.796386756368005, -88.3545, -1.54207693395333),
(23743, '54126', 218, 57, 32626, 44.2894, 0.772995853732777, -88.0335, -1.53647442705443),
(23744, '54127', 218, 57, 13848, 44.7953, 0.781825474418616, -88.2699, -1.54060038540614),
(23745, '54128', 218, 57, 36207, 44.8423, 0.782645779167053, -88.8217, -1.55023111221865),
(23746, '54129', 218, 57, 109655, 44.1461, 0.770494796914669, -88.1719, -1.53888996273919),
(23747, '54130', 218, 57, 174727, 44.2905, 0.773015052354549, -88.2732, -1.54065798127146),
(23748, '54131', 218, 57, 29850, 44.3646, 0.774308341330276, -88.2663, -1.54053755355307),
(23749, '54135', 218, 57, 174753, 44.8985, 0.783626654206674, -88.5462, -1.5454227301294),
(23750, '54136', 218, 57, 3526, 44.2699, 0.772655514528638, -88.3383, -1.54179419061451),
(23751, '54137', 218, 57, 55730, 44.7636, 0.781272205045734, -88.2275, -1.5398603658033),
(23752, '54138', 218, 57, 3637, 45.3221, 0.791019868918122, -88.4859, -1.54437029659045),
(23753, '54139', 218, 57, 10035, 44.9445, 0.784429505662591, -88.0608, -1.53695090194022),
(23754, '54140', 218, 57, 175010, 44.2844, 0.772908587270177, -88.3094, -1.54128979046068),
(23755, '54141', 218, 57, 175026, 44.6443, 0.779190027248104, -88.0374, -1.53654249489526),
(23756, '54143', 218, 57, 175172, 45.0904, 0.786975941041251, -87.6267, -1.52937442765732),
(23757, '54149', 218, 57, 49687, 45.2075, 0.789019721595337, -88.5021, -1.54465303992927),
(23758, '54150', 218, 57, 175488, 44.9862, 0.785157307960673, -88.8586, -1.55087513871263),
(23759, '54151', 218, 57, 37421, 45.754, 0.798557945957486, -88.0012, -1.53591068570603),
(23760, '54152', 218, 57, 17278, 44.5653, 0.777811217139029, -88.4668, -1.54403693870332),
(23761, '54153', 218, 57, 142575, 44.8923, 0.78351844379305, -87.8988, -1.53412346855199),
(23762, '54154', 218, 57, 175654, 44.8729, 0.783179849918163, -88.1639, -1.53875033639903),
(23763, '54155', 218, 57, 10986, 44.5303, 0.777200351900831, -88.1609, -1.53869797652147),
(23764, '54156', 218, 57, 175782, 45.5642, 0.7952453110372, -88.0004, -1.53589672307202),
(23765, '54157', 218, 57, 175801, 45.0549, 0.786356349156793, -87.7608, -1.53171491418424),
(23766, '54159', 218, 57, 24089, 45.2026, 0.788934200461989, -87.8173, -1.53270102521162),
(23767, '54160', 218, 57, 5197, 44.1189, 0.770020067358126, -88.097, -1.53758271112944),
(23768, '54161', 218, 57, 105426, 45.1004, 0.787150473966451, -88.2104, -1.53956191450121),
(23769, '54162', 218, 57, 11424, 44.654, 0.779359324185548, -88.2119, -1.53958809443999),
(23770, '54165', 218, 57, 5745, 44.4995, 0.776662790491217, -88.3044, -1.54120252399808),
(23771, '54166', 218, 57, 18058, 44.7834, 0.781617780237629, -88.5899, -1.54618543901252),
(23772, '54169', 218, 57, 14604, 44.1734, 0.770971271800463, -88.2595, -1.54041887116394),
(23773, '54170', 218, 57, 176383, 44.4417, 0.775653990183564, -88.5782, -1.54598123549004),
(23774, '54171', 218, 57, 138160, 44.72, 0.780511241491864, -88.1085, -1.53778342399342),
(23775, '54173', 218, 57, 176585, 44.6382, 0.779083562163733, -88.0361, -1.53651980561498),
(23776, '54174', 218, 57, 176627, 45.035, 0.786009028635646, -88.3802, -1.54252548357109),
(23777, '54175', 218, 57, 14757, 45.3148, 0.790892459882726, -88.618, -1.54667587653234),
(23778, '54177', 218, 57, 176918, 45.3611, 0.7917005473264, -87.9138, -1.53438526793979),
(23779, '54180', 218, 57, 74890, 44.3257, 0.77362940825125, -88.1667, -1.53879920561808),
(23780, '54182', 218, 57, 177173, 44.7328, 0.780734643636119, -88.3588, -1.54215198311117),
(23781, '54201', 218, 57, 58438, 44.608, 0.77855647272963, -87.449, -1.52627297757652),
(23782, '54202', 218, 57, 173030, 45.065, 0.786532627411245, -87.142, -1.5209148167729),
(23783, '54203', 218, 57, 7649, 44.1447, 0.770470362305141, -87.7611, -1.531720150172),
(23784, '54204', 218, 57, 26633, 44.7505, 0.781043566913722, -87.6345, -1.52951056333897),
(23785, '54205', 218, 57, 100553, 44.5551, 0.777633193555326, -87.6222, -1.52929588784098),
(23786, '54207', 218, 57, 308, 44.0857, 0.769440618046464, -87.9815, -1.53556685584339),
(23787, '54208', 218, 57, 8477, 44.3663, 0.77433801192756, -87.8515, -1.5332979278158),
(23788, '54209', 218, 57, 29707, 45.0175, 0.785703596016547, -87.2862, -1.52343158155427),
(23789, '54210', 218, 57, 173987, 45.2597, 0.789930783464878, -87.044, -1.51920439410594),
(23790, '54211', 218, 57, 177414, 45.1566, 0.788131349006071, -87.1673, -1.52135638507365),
(23791, '54212', 218, 57, 16015, 45.1039, 0.78721156049027, -87.2142, -1.52217494449284),
(23792, '54213', 218, 57, 35957, 44.7012, 0.780183119592489, -87.5019, -1.52719625675083),
(23793, '54214', 218, 57, 174169, 44.2039, 0.771503597222321, -87.7201, -1.53100456517868),
(23794, '54215', 218, 57, 174736, 44.2188, 0.771763651280869, -87.8161, -1.53268008126059),
(23795, '54216', 218, 57, 174758, 44.4509, 0.775814560474747, -87.5169, -1.52745805613863),
(23796, '54217', 218, 57, 116642, 44.5396, 0.777362667521266, -87.7038, -1.5307200765106),
(23797, '54220', 218, 57, 175130, 44.0977, 0.769650057556704, -87.7096, -1.53082130560722),
(23798, '54221', 218, 57, 175130, 44.1297, 0.770208562917342, -87.6055, -1.52900441785589),
(23799, '54226', 218, 57, 3982, 44.7252, 0.780601998612968, -87.4835, -1.52687511616846),
(23800, '54227', 218, 57, 66618, 44.2841, 0.772903351282421, -87.8051, -1.53248809504287),
(23801, '54228', 218, 57, 175352, 44.2643, 0.772557776090526, -87.6472, -1.52973222015397),
(23802, '54229', 218, 57, 175513, 44.5591, 0.777703006725405, -87.8334, -1.53298202322119),
(23803, '54230', 218, 57, 33736, 44.149, 0.770545411462977, -87.9218, -1.53452489427995),
(23804, '54232', 218, 57, 176245, 44.006, 0.768049590632625, -87.9241, -1.53456503685275),
(23805, '54234', 218, 57, 176412, 45.1902, 0.788717779634741, -87.1145, -1.5204348512286),
(23806, '54235', 218, 57, 176580, 44.8445, 0.782684176410597, -87.3736, -1.52495699932052),
(23807, '54240', 218, 57, 176693, 44.3264, 0.773641625556014, -87.624, -1.52932730376751),
(23808, '54241', 218, 57, 52271, 44.18, 0.771086463531095, -87.6005, -1.52891715139329),
(23809, '54245', 218, 57, 176796, 44.0318, 0.768499885579639, -87.8801, -1.53379709198187),
(23810, '54246', 218, 57, 0, 45.3716, 0.791883806897859, -86.903, -1.51674347986063),
(23811, '54247', 218, 57, 153791, 44.1825, 0.771130096762395, -87.7929, -1.53227516487413),
(23812, '54301', 218, 57, 105, 44.4859, 0.776425425712945, -88.0063, -1.53599969749789),
(23813, '54302', 218, 57, 105, 44.506, 0.776776236892596, -87.9755, -1.53546213608827),
(23814, '54303', 218, 57, 105, 44.5324, 0.777237003815123, -88.0581, -1.53690377805042),
(23815, '54304', 218, 57, 105, 44.5035, 0.776732603661296, -88.0653, -1.53702944175656),
(23816, '54305', 218, 57, 105, 44.535, 0.777282382375675, -88.0954, -1.53755478586141),
(23817, '54306', 218, 57, 105, 44.5188, 0.776999639036852, -88.0201, -1.53624055293466),
(23818, '54307', 218, 57, 105, 44.5343, 0.777270165070911, -88.0948, -1.5375443138859),
(23819, '54308', 218, 57, 105, 44.5089, 0.776826851440904, -87.9333, -1.53472560714393),
(23820, '54311', 218, 57, 105, 44.4921, 0.776533636126569, -87.9283, -1.53463834068133),
(23821, '54313', 218, 57, 105, 44.5615, 0.777744894627453, -88.1034, -1.53769441220157),
(23822, '54324', 218, 57, 105, 44.4803, 0.776327687274834, -88.0194, -1.5362283356299),
(23823, '54344', 218, 57, 105, 44.4202, 0.775278744394385, -88.1073, -1.5377624800424),
(23824, '54401', 218, 57, 18514, 44.9604, 0.784707013013659, -89.6542, -1.5647609782415),
(23825, '54402', 218, 57, 18514, 45.0208, 0.785761191881863, -89.6498, -1.56468418375441),
(23826, '54403', 218, 57, 18514, 44.9606, 0.784710503672163, -89.6014, -1.56383944439645),
(23827, '54404', 218, 57, 30448, 44.6688, 0.779617632914843, -90.172, -1.57379829310833),
(23828, '54405', 218, 57, 172827, 44.9478, 0.784487101527907, -90.3241, -1.57645293890061),
(23829, '54406', 218, 57, 62514, 44.4246, 0.775355538881473, -89.3193, -1.55891587057657),
(23830, '54407', 218, 57, 172908, 44.5162, 0.7769542604763, -89.2955, -1.5585004822146),
(23831, '54408', 218, 57, 172925, 45.0426, 0.786141673658798, -89.29, -1.55840448910574),
(23832, '54409', 218, 57, 172932, 45.1421, 0.787878276264532, -89.1509, -1.55597673611621),
(23833, '54410', 218, 57, 172969, 44.5418, 0.77740106476481, -90.0477, -1.5716288488481),
(23834, '54411', 218, 57, 7182, 45.0339, 0.785989830013874, -90.0827, -1.5722397140863),
(23835, '54412', 218, 57, 15052, 44.6366, 0.779055636895701, -90.0049, -1.57088184792824),
(23836, '54413', 218, 57, 19009, 44.2844, 0.772908587270177, -90.1135, -1.57277727549591),
(23837, '54414', 218, 57, 173190, 44.9324, 0.7842183208231, -89.2102, -1.55701171636265),
(23838, '54415', 218, 57, 173219, 44.6156, 0.778689117752782, -89.9182, -1.56936864746677),
(23839, '54416', 218, 57, 100091, 44.8634, 0.783014043639224, -88.9802, -1.55299745908306),
(23840, '54417', 218, 57, 71913, 45.027, 0.785869402295487, -89.6528, -1.56473654363197),
(23841, '54418', 218, 57, 652, 45.214, 0.789133167996716, -89.0615, -1.55441641176493),
(23842, '54420', 218, 57, 119128, 44.5757, 0.777992731381236, -90.2982, -1.57600089862434),
(23843, '54421', 218, 57, 35315, 44.9117, 0.783857037667937, -90.3197, -1.57637614441352),
(23844, '54422', 218, 57, 173712, 44.9527, 0.784572622661255, -90.4338, -1.57836756509005),
(23845, '54423', 218, 57, 35479, 44.5817, 0.778097451136356, -89.4194, -1.56066294515782),
(23846, '54424', 218, 57, 20516, 45.309, 0.790791230786111, -89.186, -1.55658934668366),
(23847, '54425', 218, 57, 20633, 45.0046, 0.78547844854304, -90.3326, -1.57660129188703),
(23848, '54426', 218, 57, 15886, 44.9147, 0.783909397545497, -89.9511, -1.56994286079067),
(23849, '54427', 218, 57, 173961, 44.8207, 0.782268788048623, -89.2671, -1.55800480870703),
(23850, '54428', 218, 57, 173962, 45.4429, 0.793128226654531, -89.0811, -1.55475849629832),
(23851, '54429', 218, 57, 173964, 44.7836, 0.781621270896133, -89.2487, -1.55768366812466),
(23852, '54430', 218, 57, 40808, 45.1494, 0.788005685299928, -88.891, -1.55144062539028),
(23853, '54432', 218, 57, 9041, 44.7452, 0.780951064463367, -89.2356, -1.55745502999265),
(23854, '54433', 218, 57, 102246, 45.2158, 0.789164583923252, -90.8153, -1.58502599618641),
(23855, '54434', 218, 57, 174720, 45.3324, 0.791199637831078, -90.7427, -1.58375888714946),
(23856, '54435', 218, 57, 9130, 45.4027, 0.792426604295229, -89.4611, -1.5613907474559),
(23857, '54436', 218, 57, 174325, 44.5675, 0.777849614382573, -90.45, -1.57865030842887),
(23858, '54437', 218, 57, 2869, 44.7693, 0.781371688813097, -90.6034, -1.58132764350143),
(23859, '54439', 218, 57, 55163, 45.2449, 0.789672474735582, -90.7421, -1.58374841517395),
(23860, '54440', 218, 57, 21782, 44.8252, 0.782347327864962, -89.3809, -1.5599909933958),
(23861, '54441', 218, 57, 65527, 44.6413, 0.779137667370545, -90.1034, -1.57260099724146),
(23862, '54442', 218, 57, 9668, 45.4262, 0.792836756669448, -89.6933, -1.56544340197903),
(23863, '54443', 218, 57, 9806, 44.6038, 0.778483168901047, -89.7457, -1.56635795450707),
(23864, '54444', 218, 57, 174742, 45.2441, 0.789658512101566, -89.1226, -1.5554828079379),
(23865, '54446', 218, 57, 76463, 44.7375, 0.780816674110963, -90.4936, -1.57941127198274),
(23866, '54447', 218, 57, 175073, 45.1189, 0.78747335987807, -90.6947, -1.5829211291085),
(23867, '54448', 218, 57, 17017, 44.9296, 0.784169451604044, -89.8339, -1.56789733490733),
(23868, '54449', 218, 57, 30448, 44.6451, 0.77920398988212, -90.1871, -1.57406183782538),
(23869, '54450', 218, 57, 27833, 45.0059, 0.785501137823316, -89.0411, -1.55406036459752),
(23870, '54451', 218, 57, 49404, 45.1443, 0.787916673508076, -90.3395, -1.57672171960542),
(23871, '54452', 218, 57, 49421, 45.1829, 0.788590370599346, -89.6937, -1.56545038329604),
(23872, '54454', 218, 57, 175318, 44.6009, 0.778432554352739, -89.8821, -1.5687385836068),
(23873, '54455', 218, 57, 175413, 44.7897, 0.781727735980504, -89.6855, -1.56530726629737),
(23874, '54456', 218, 57, 175474, 44.5614, 0.777743149298201, -90.5937, -1.58115834656399),
(23875, '54457', 218, 57, 175477, 44.2028, 0.77148439860055, -89.8111, -1.56749939983788),
(23876, '54458', 218, 57, 10749, 44.4936, 0.776559816065349, -89.3127, -1.55880067884594),
(23877, '54459', 218, 57, 137259, 45.4357, 0.793002562948388, -90.2438, -1.57505143951126),
(23878, '54460', 218, 57, 23695, 44.9483, 0.784495828174167, -90.5629, -1.58062078515437),
(23879, '54462', 218, 57, 4924, 45.3912, 0.79222589143125, -89.0856, -1.55483703611466),
(23880, '54463', 218, 57, 17566, 45.5025, 0.79416844288872, -89.1588, -1.55611461712712),
(23881, '54464', 218, 57, 123431, 45.0513, 0.786293517303721, -89.0139, -1.55358563504098),
(23882, '54465', 218, 57, 105225, 45.3764, 0.791967582701955, -88.8961, -1.55152963718213),
(23883, '54466', 218, 57, 50447, 44.4468, 0.775743001975416, -90.1802, -1.57394141010699),
(23884, '54467', 218, 57, 97137, 44.4422, 0.775662716829824, -89.5429, -1.56281842678403),
(23885, '54469', 218, 57, 175911, 44.3491, 0.774037815296217, -89.8652, -1.56844362296321),
(23886, '54470', 218, 57, 176065, 45.3191, 0.790967509040562, -90.1927, -1.57415957626349),
(23887, '54471', 218, 57, 176101, 44.8969, 0.783598728938642, -89.429, -1.56083049676601),
(23888, '54472', 218, 57, 30448, 44.6631, 0.779518149147479, -90.1749, -1.57384890765663),
(23889, '54473', 218, 57, 171227, 44.6293, 0.778928227860305, -89.3184, -1.5589001626133),
(23890, '54474', 218, 57, 176185, 44.885, 0.783391034757655, -89.619, -1.5641466223448),
(23891, '54475', 218, 57, 90525, 44.4804, 0.776329432604086, -89.8016, -1.56733359355894),
(23892, '54476', 218, 57, 57444, 44.9054, 0.783747081925062, -89.5715, -1.5633175909501),
(23893, '54479', 218, 57, 5995, 44.7562, 0.781143050681086, -90.2962, -1.5759659920393),
(23894, '54480', 218, 57, 152910, 45.0799, 0.786792681469792, -90.3154, -1.57630109525569),
(23895, '54481', 218, 57, 167602, 44.5218, 0.777051998914411, -89.5602, -1.56312036874463),
(23896, '54484', 218, 57, 14683, 44.7969, 0.781853399686648, -90.0669, -1.57196395206448),
(23897, '54485', 218, 57, 176599, 45.3626, 0.79172672726518, -89.1875, -1.55661552662244),
(23898, '54486', 218, 57, 176684, 44.7463, 0.780970263085139, -89.042, -1.55407607256079),
(23899, '54487', 218, 57, 12346, 45.4765, 0.793714657283201, -89.7285, -1.56605775787573),
(23900, '54488', 218, 57, 6476, 44.8469, 0.782726064312645, -90.3217, -1.57641105099856),
(23901, '54489', 218, 57, 34265, 44.4652, 0.776064142557783, -89.9912, -1.57064273782072),
(23902, '54490', 218, 57, 52650, 45.3352, 0.791248507050133, -90.3577, -1.57703936952928),
(23903, '54491', 218, 57, 70098, 45.1497, 0.788010921287684, -88.6029, -1.54641233181528),
(23904, '54492', 218, 57, 167602, 44.4884, 0.776469058944245, -89.5278, -1.56255488206698),
(23905, '54493', 218, 57, 26074, 44.6983, 0.780132505044181, -90.8155, -1.58502948684491),
(23906, '54494', 218, 57, 177099, 44.3752, 0.774493346230988, -89.8154, -1.56757444899572),
(23907, '54495', 218, 57, 177099, 44.4042, 0.774999491714066, -89.8671, -1.568476784219),
(23908, '54498', 218, 57, 177102, 44.9554, 0.784619746551059, -90.598, -1.58123339572182),
(23909, '54499', 218, 57, 58342, 44.8254, 0.782350818523466, -89.1689, -1.55629089538157),
(23910, '54501', 218, 57, 176061, 45.656, 0.796847523290531, -89.4041, -1.56039590978226),
(23911, '54511', 218, 57, 133987, 45.7239, 0.798032601852635, -88.8585, -1.55087339338338),
(23912, '54512', 218, 57, 173258, 46.0965, 0.804535698645566, -89.6524, -1.56472956231496),
(23913, '54513', 218, 57, 45019, 45.5695, 0.795337813487556, -90.1233, -1.57294831776261),
(23914, '54514', 218, 57, 130029, 46.0849, 0.804333240452335, -90.25, -1.57515964992488),
(23915, '54515', 218, 57, 15461, 45.5368, 0.794767090822154, -90.53, -1.58004657183047),
(23916, '54517', 218, 57, 173551, 46.27, 0.807563844897776, -90.8987, -1.58648160078257),
(23917, '54519', 218, 57, 63880, 46.044, 0.803619400788269, -89.2699, -1.55805367792609),
(23918, '54520', 218, 57, 46072, 45.5687, 0.79532385085354, -88.902, -1.551632611608),
(23919, '54521', 218, 57, 130569, 45.9273, 0.801582601551192, -89.2404, -1.55753880579675),
(23920, '54524', 218, 57, 174095, 45.8773, 0.800709936925195, -90.4203, -1.57813194564103),
(23921, '54525', 218, 57, 149127, 46.4303, 0.810361607688723, -90.224, -1.57470586431936),
(23922, '54526', 218, 57, 94492, 45.501, 0.79414226294994, -90.9061, -1.58661075514722),
(23923, '54527', 218, 57, 94502, 46.1341, 0.805191942444316, -90.5768, -1.5808633859204),
(23924, '54529', 218, 57, 174432, 45.6934, 0.797500276430777, -89.6576, -1.56482031943607),
(23925, '54530', 218, 57, 9384, 45.5119, 0.794332503838407, -90.7121, -1.58322481639835),
(23926, '54531', 218, 57, 47965, 45.7682, 0.798805782711269, -89.7585, -1.56658135665133),
(23927, '54532', 218, 57, 174469, 45.5629, 0.795222621756924, -89.716, -1.56583959171923),
(23928, '54534', 218, 57, 3300, 46.4501, 0.810707182880618, -90.1944, -1.57418924686077),
(23929, '54536', 218, 57, 174641, 46.4158, 0.810108534947184, -90.275, -1.57559598223788),
(23930, '54537', 218, 57, 174746, 45.529, 0.794630955140498, -90.5923, -1.58113391195446),
(23931, '54538', 218, 57, 174840, 45.9648, 0.802237100020689, -89.8869, -1.56882235941089),
(23932, '54539', 218, 57, 174873, 45.8086, 0.799510895729074, -89.5802, -1.56346943459502),
(23933, '54540', 218, 57, 0, 46.1562, 0.805577660209007, -89.3136, -1.55881638680921),
(23934, '54541', 218, 57, 150172, 45.5605, 0.795180733854876, -88.6773, -1.54771085677877),
(23935, '54542', 218, 57, 60680, 45.9261, 0.801561657600168, -88.7662, -1.54926245448379),
(23936, '54543', 218, 57, 175236, 45.763, 0.798715025590165, -89.514, -1.5623140266302),
(23937, '54545', 218, 57, 175134, 46.087, 0.804369892366627, -89.8237, -1.56771931132363),
(23938, '54546', 218, 57, 175271, 46.3247, 0.808518539998617, -90.6571, -1.58226488530975),
(23939, '54547', 218, 57, 17095, 46.1764, 0.80593021671791, -90.0752, -1.5721088143924),
(23940, '54548', 218, 57, 175346, 45.8647, 0.800490025439443, -89.7604, -1.56661451790712),
(23941, '54550', 218, 57, 10575, 46.4243, 0.810256887933604, -90.2528, -1.57520851914394),
(23942, '54552', 218, 57, 175758, 45.9354, 0.801723973220603, -90.4296, -1.57829426126146),
(23943, '54554', 218, 57, 23858, 46.0613, 0.803921342748864, -89.068, -1.55452985816631),
(23944, '54555', 218, 57, 11173, 45.6899, 0.797439189906957, -90.4004, -1.57778462511988),
(23945, '54556', 218, 57, 28341, 45.5457, 0.794922425125581, -90.289, -1.57584032833316),
(23946, '54557', 218, 57, 105450, 46.226, 0.806795900026899, -89.728, -1.56604903122947),
(23947, '54558', 218, 57, 176233, 45.9277, 0.8015895828682, -89.4821, -1.56175726659882),
(23948, '54559', 218, 57, 24697, 46.52, 0.811927168027762, -90.5528, -1.58044450689992),
(23949, '54560', 218, 57, 176289, 45.9952, 0.802767680113296, -89.5191, -1.56240303842206),
(23950, '54561', 218, 57, 152880, 46.0544, 0.803800915030477, -89.46, -1.56137154883413),
(23951, '54562', 218, 57, 18338, 45.8039, 0.799428865254231, -89.1232, -1.55549327991341),
(23952, '54563', 218, 57, 43368, 45.5751, 0.795435551925668, -90.9527, -1.58742407857865),
(23953, '54564', 218, 57, 118070, 45.6458, 0.796669499706828, -89.9831, -1.57050136615131),
(23954, '54565', 218, 57, 176789, 46.3441, 0.808857133873504, -90.4696, -1.57899239296226),
(23955, '54566', 218, 57, 176837, 45.4336, 0.792965911034096, -88.6921, -1.54796916550806),
(23956, '54568', 218, 57, 513, 45.8786, 0.80073262620547, -89.671, -1.56505419355584),
(23957, '54601', 218, 57, 16751, 43.7974, 0.764408833812965, -91.2217, -1.59211901426651),
(23958, '54602', 218, 57, 16751, 43.8274, 0.764932432588563, -91.2334, -1.59232321778899),
(23959, '54603', 218, 57, 16751, 43.85, 0.765326876999514, -91.2507, -1.59262515974959),
(23960, '54610', 218, 57, 7066, 44.3234, 0.773589265678455, -91.9128, -1.60418098472704),
(23961, '54611', 218, 57, 172881, 44.4363, 0.775559742403956, -90.9129, -1.58672943753635),
(23962, '54612', 218, 57, 7137, 44.2513, 0.772330883287767, -91.4951, -1.59689074444146),
(23963, '54613', 218, 57, 172955, 44.0651, 0.769081080220553, -89.8995, -1.56904227089664),
(23964, '54614', 218, 57, 34662, 43.8939, 0.766093076541139, -90.9837, -1.58796513064676),
(23965, '54615', 218, 57, 173204, 44.2939, 0.773074393549116, -90.8482, -1.58560020951031),
(23966, '54616', 218, 57, 26538, 44.2937, 0.773070902890612, -91.231, -1.59228132988695),
(23967, '54618', 218, 57, 173425, 43.9194, 0.766538135500398, -90.2697, -1.57550347978753),
(23968, '54619', 218, 57, 173455, 43.874, 0.765745756019992, -90.661, -1.58233295315058),
(23969, '54620', 218, 57, 29416, 44.0872, 0.769466797985244, -90.8422, -1.58549548975519),
(23970, '54621', 218, 57, 173511, 43.6567, 0.761953155555408, -91.013, -1.5884765121176),
(23971, '54622', 218, 57, 1674, 44.2291, 0.771943420193824, -91.8537, -1.60314949513912),
(23972, '54623', 218, 57, 173655, 43.7015, 0.762735063060302, -91.0092, -1.58841018960602),
(23973, '54624', 218, 57, 26922, 43.4002, 0.757476386024043, -91.1709, -1.5912323870065),
(23974, '54625', 218, 57, 75669, 44.2469, 0.772254088800679, -91.4901, -1.59680347797886),
(23975, '54626', 218, 57, 20777, 43.1969, 0.753928131654738, -91.0141, -1.58849571073937),
(23976, '54627', 218, 57, 101761, 44.1711, 0.770931129227667, -91.2723, -1.59300215086802),
(23977, '54628', 218, 57, 174093, 43.3814, 0.757148264124668, -91.0018, -1.58828103524138),
(23978, '54629', 218, 57, 29828, 44.13, 0.770213798905098, -91.7145, -1.60071999682034),
(23979, '54630', 218, 57, 47338, 44.0776, 0.769299246377052, -91.3626, -1.59457818318257),
(23980, '54631', 218, 57, 174225, 43.2897, 0.755547797200589, -90.8668, -1.58592484075118),
(23981, '54632', 218, 57, 9080, 43.5636, 0.760328254021802, -91.2268, -1.59220802605836),
(23982, '54634', 218, 57, 3145, 43.6527, 0.761883342385329, -90.3427, -1.57677757014148),
(23983, '54635', 218, 57, 174533, 44.3845, 0.774655661851423, -91.0115, -1.58845033217882),
(23984, '54636', 218, 57, 174555, 43.9644, 0.767323533663795, -91.2585, -1.59276129543125),
(23985, '54637', 218, 57, 60365, 43.8802, 0.765853966433616, -90.2739, -1.57557678361611),
(23986, '54638', 218, 57, 16702, 43.8103, 0.764633981286472, -90.4037, -1.5778422209852),
(23987, '54639', 218, 57, 174825, 43.6185, 0.761286439781147, -90.6249, -1.58170288929061),
(23988, '54640', 218, 57, 175100, 43.2484, 0.754826976219516, -91.0484, -1.58909435867281),
(23989, '54641', 218, 57, 78703, 44.1431, 0.770442437037109, -90.3081, -1.57617368622029),
(23990, '54642', 218, 57, 4153, 44.1325, 0.770257432136398, -90.9954, -1.58816933416925),
(23991, '54643', 218, 57, 175323, 44.1926, 0.771306375016846, -90.6474, -1.58209558837231),
(23992, '54644', 218, 57, 175339, 44.0275, 0.768424836421803, -91.0507, -1.5891345012456),
(23993, '54645', 218, 57, 4408, 43.3138, 0.75596842155032, -90.9309, -1.58704359680171),
(23994, '54646', 218, 57, 175470, 44.0303, 0.768473705640859, -90.0806, -1.572203062172),
(23995, '54648', 218, 57, 17325, 43.825, 0.764890544686515, -90.6632, -1.58237135039412),
(23996, '54649', 218, 57, 4701, 43.9594, 0.767236267201195, -90.3815, -1.57745475789126),
(23997, '54650', 218, 57, 96794, 43.8853, 0.765942978225468, -91.218, -1.59205443708419),
(23998, '54651', 218, 57, 33502, 43.724, 0.763127762142001, -90.5917, -1.58112343997895),
(23999, '54652', 218, 57, 176028, 43.4552, 0.75843631711264, -90.7628, -1.58410969832911),
(24000, '54653', 218, 57, 187, 43.9074, 0.766328695990158, -90.9157, -1.58677830675541),
(24001, '54654', 218, 57, 18037, 43.2645, 0.755107974229087, -90.9581, -1.58751832635825),
(24002, '54655', 218, 57, 176430, 43.3882, 0.757266946513804, -90.7711, -1.58425456065702),
(24003, '54656', 218, 57, 25003, 43.9453, 0.766990175776664, -90.8117, -1.58496316433333),
(24004, '54657', 218, 57, 117905, 43.2014, 0.754006671471078, -90.8542, -1.58570492926543),
(24005, '54658', 218, 57, 51715, 43.664, 0.762080564590804, -91.2185, -1.59206316373045),
(24006, '54659', 218, 57, 6252, 44.3286, 0.773680022799558, -91.1105, -1.59017820813829),
(24007, '54660', 218, 57, 129083, 43.9815, 0.767621984965886, -90.5068, -1.579641655444),
(24008, '54661', 218, 57, 176717, 44.0063, 0.768054826620381, -91.4365, -1.5958679814998),
(24009, '54662', 218, 57, 176743, 44.0028, 0.767993740096561, -90.5597, -1.58056493461831),
(24010, '54664', 218, 57, 12571, 43.4451, 0.758260038858188, -90.6757, -1.58258951655062),
(24011, '54665', 218, 57, 176834, 43.5569, 0.760211316961918, -90.8894, -1.58631928516213),
(24012, '54666', 218, 57, 176859, 44.13, 0.770213798905098, -90.5004, -1.57952995437188),
(24013, '54667', 218, 57, 176985, 43.6539, 0.761904286336353, -90.8589, -1.58578695974028),
(24014, '54669', 218, 57, 28944, 43.8994, 0.766189069649999, -91.0858, -1.58974711181305),
(24015, '54670', 218, 57, 287, 43.8156, 0.764726483736828, -90.5289, -1.58002737320869),
(24016, '54701', 218, 57, 80820, 44.7984, 0.781879579625428, -91.4824, -1.59666908762646),
(24017, '54702', 218, 57, 80820, 44.8145, 0.782160577634999, -91.5009, -1.59699197353808),
(24018, '54703', 218, 57, 80820, 44.8256, 0.78235430918197, -91.4992, -1.5969623029408),
(24019, '54720', 218, 57, 14978, 44.8028, 0.781956374112515, -91.4358, -1.59585576419503),
(24020, '54721', 218, 57, 172954, 44.6221, 0.778802564154162, -92.0696, -1.60691766099417),
(24021, '54722', 218, 57, 7193, 44.6879, 0.779950990801974, -91.1301, -1.59052029267168),
(24022, '54723', 218, 57, 15113, 44.5875, 0.778198680232972, -92.4532, -1.61361274400482),
(24023, '54724', 218, 57, 7542, 45.1013, 0.787166181929719, -91.4843, -1.59670224888225),
(24024, '54725', 218, 57, 173264, 45.0433, 0.786153890963562, -92.0401, -1.60640278886483),
(24025, '54726', 218, 57, 1069, 44.9506, 0.784535970746963, -91.0406, -1.58895822299115),
(24026, '54727', 218, 57, 173397, 44.9384, 0.78432304057822, -91.1727, -1.59126380293303),
(24027, '54728', 218, 57, 173521, 45.3143, 0.790883733236467, -91.6723, -1.599983467876),
(24028, '54729', 218, 57, 173535, 44.9236, 0.784064731848925, -91.371, -1.59472479083974),
(24029, '54730', 218, 57, 8175, 44.9979, 0.785361511483156, -91.7264, -1.60092769100133);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(24030, '54731', 218, 57, 173643, 45.3713, 0.791878570910103, -91.0595, -1.58928809021978),
(24031, '54732', 218, 57, 20256, 45.1531, 0.788070262482252, -91.1588, -1.59102120216701),
(24032, '54733', 218, 57, 1953, 45.2613, 0.789958708732909, -91.841, -1.60292783832411),
(24033, '54734', 218, 57, 2096, 45.045, 0.786183561560846, -92.1083, -1.60759310341469),
(24034, '54735', 218, 57, 40694, 44.7746, 0.781464191263453, -91.9319, -1.60451434261418),
(24035, '54736', 218, 57, 20717, 44.6279, 0.778903793250777, -91.9598, -1.60500128947548),
(24036, '54737', 218, 57, 173927, 44.7241, 0.780582799991196, -92.0484, -1.60654765119275),
(24037, '54738', 218, 57, 173969, 44.5758, 0.777994476710488, -91.4708, -1.59646662943323),
(24038, '54739', 218, 57, 173974, 44.8742, 0.783202539198439, -91.6919, -1.60032555240939),
(24039, '54740', 218, 57, 8746, 44.7807, 0.781570656347825, -92.1498, -1.60831741505427),
(24040, '54741', 218, 57, 20980, 44.6022, 0.778455243633015, -90.9594, -1.58754101563853),
(24041, '54742', 218, 57, 27138, 44.7556, 0.781132578705574, -91.3319, -1.59404236710221),
(24042, '54743', 218, 57, 143865, 44.4709, 0.776163626325146, -91.6762, -1.60005153571683),
(24043, '54745', 218, 57, 174552, 45.2438, 0.78965327611381, -91.2039, -1.59180834565966),
(24044, '54746', 218, 57, 174601, 44.5442, 0.777442952666858, -90.8732, -1.58603654182331),
(24045, '54747', 218, 57, 3320, 44.3591, 0.774212348221417, -91.4219, -1.595613163429),
(24046, '54748', 218, 57, 174695, 45.071, 0.786637347166364, -91.2588, -1.592766531419),
(24047, '54749', 218, 57, 27642, 44.9591, 0.784684323733383, -92.073, -1.60697700218874),
(24048, '54750', 218, 57, 175115, 44.5647, 0.777800745163517, -92.3074, -1.61106805395541),
(24049, '54751', 218, 57, 175275, 44.8781, 0.783270607039267, -91.9222, -1.60434504567673),
(24050, '54754', 218, 57, 175287, 44.4522, 0.775837249755023, -90.8405, -1.58546581915791),
(24051, '54755', 218, 57, 175363, 44.5692, 0.777879284979857, -91.6702, -1.59994681596171),
(24052, '54756', 218, 57, 4506, 44.4406, 0.775634791561792, -92.0155, -1.60597343786884),
(24053, '54757', 218, 57, 128231, 45.2098, 0.789059864168132, -91.5468, -1.59779307966475),
(24054, '54758', 218, 57, 132471, 44.574, 0.777963060783952, -91.2195, -1.59208061702297),
(24055, '54759', 218, 57, 175790, 44.4423, 0.775664462159076, -92.1489, -1.608301707091),
(24056, '54760', 218, 57, 175827, 44.4258, 0.775376482832497, -91.2058, -1.59184150691544),
(24057, '54761', 218, 57, 175884, 44.6326, 0.778985823725621, -92.1907, -1.60903125471834),
(24058, '54762', 218, 57, 175952, 45.2543, 0.78983653568527, -91.9807, -1.60536606328915),
(24059, '54763', 218, 57, 61539, 45.2187, 0.78921519847156, -91.907, -1.60407975563043),
(24060, '54764', 218, 57, 117565, 44.7187, 0.780488552211588, -91.6897, -1.60028715516584),
(24061, '54765', 218, 57, 33890, 45.1728, 0.788414092344895, -91.7032, -1.60052277461486),
(24062, '54766', 218, 57, 57525, 45.3109, 0.790824392041899, -90.9022, -1.58654268730639),
(24063, '54767', 218, 57, 826, 44.8456, 0.782703375032369, -92.2389, -1.6098725034178),
(24064, '54768', 218, 57, 196, 44.9623, 0.784740174269446, -90.9335, -1.58708897536226),
(24065, '54769', 218, 57, 38390, 44.4856, 0.776420189725189, -92.2664, -1.6103524689621),
(24066, '54770', 218, 57, 176577, 44.5503, 0.77754941775123, -91.3916, -1.59508432866565),
(24067, '54771', 218, 57, 176675, 44.9593, 0.784687814391887, -90.7992, -1.58474499817684),
(24068, '54772', 218, 57, 6759, 45.0444, 0.786173089585334, -91.9093, -1.60411989820322),
(24069, '54773', 218, 57, 12826, 44.3665, 0.774341502586064, -91.3181, -1.59380151166543),
(24070, '54774', 218, 57, 173535, 44.9367, 0.784293369980936, -91.3927, -1.59510352728742),
(24071, '54801', 218, 57, 25020, 45.8917, 0.800961264337482, -92.0694, -1.60691417033567),
(24072, '54805', 218, 57, 31634, 45.4172, 0.792679677036769, -92.0312, -1.60624745456141),
(24073, '54806', 218, 57, 13301, 46.5879, 0.813112246589866, -90.8781, -1.58612206295666),
(24074, '54810', 218, 57, 173040, 45.4722, 0.793639608125365, -92.4563, -1.61366684921163),
(24075, '54812', 218, 57, 39231, 45.3998, 0.792375989746922, -91.8697, -1.60342874781943),
(24076, '54813', 218, 57, 173066, 45.677, 0.79721404243345, -92.0996, -1.60744125976977),
(24077, '54814', 218, 57, 122197, 46.8106, 0.816999094834058, -90.8204, -1.58511500797826),
(24078, '54816', 218, 57, 350, 46.5017, 0.811607772774647, -91.0762, -1.58957956020486),
(24079, '54817', 218, 57, 44838, 45.6182, 0.796187788833277, -91.5961, -1.59865352698598),
(24080, '54818', 218, 57, 173298, 45.6022, 0.795908536152958, -91.6717, -1.59997299590049),
(24081, '54819', 218, 57, 15356, 45.4593, 0.793414460651858, -91.2731, -1.59301611350204),
(24082, '54820', 218, 57, 39545, 46.537, 0.812223874000601, -91.5585, -1.59799728318723),
(24083, '54821', 218, 57, 118998, 46.2244, 0.806767974758867, -91.1716, -1.59124460431126),
(24084, '54822', 218, 57, 806, 45.3964, 0.792316648552354, -91.715, -1.6007287234666),
(24085, '54824', 218, 57, 173498, 45.4507, 0.793264362336187, -92.5487, -1.61527953344048),
(24086, '54826', 218, 57, 130316, 45.4848, 0.793859519611117, -92.0877, -1.60723356558878),
(24087, '54827', 218, 57, 173664, 46.8562, 0.817794964972967, -91.0934, -1.5898797568362),
(24088, '54828', 218, 57, 173671, 45.7973, 0.799313673523599, -91.3433, -1.59424133463694),
(24089, '54829', 218, 57, 20409, 45.5361, 0.79475487351739, -92.0171, -1.60600136313687),
(24090, '54830', 218, 57, 64114, 45.9982, 0.802820039990856, -92.252, -1.61010114154981),
(24091, '54832', 218, 57, 2109, 46.3319, 0.808644203704761, -91.3368, -1.59412788823556),
(24092, '54834', 218, 57, 2228, 45.7427, 0.79836072375201, -91.4755, -1.59654865990807),
(24093, '54835', 218, 57, 174048, 45.6775, 0.79722276907971, -91.2336, -1.5923267084475),
(24094, '54836', 218, 57, 21272, 46.4847, 0.811311066801808, -92.1867, -1.60896144154826),
(24095, '54837', 218, 57, 115662, 45.7053, 0.797707970611764, -92.4795, -1.6140717655981),
(24096, '54838', 218, 57, 2785, 46.2816, 0.807766303091008, -91.7401, -1.60116680110885),
(24097, '54839', 218, 57, 47582, 46.348, 0.808925201714332, -91.1008, -1.59000891120085),
(24098, '54840', 218, 57, 27315, 45.7552, 0.79857888990851, -92.6525, -1.61709118520405),
(24099, '54841', 218, 57, 174446, 45.6135, 0.796105758358434, -91.7822, -1.60190158472394),
(24100, '54842', 218, 57, 13124, 46.5036, 0.811640934030435, -91.8606, -1.6032699228575),
(24101, '54843', 218, 57, 36333, 46.017, 0.803148161890231, -91.461, -1.59629558716653),
(24102, '54844', 218, 57, 174485, 46.7733, 0.816348087023064, -91.2255, -1.59218533677809),
(24103, '54845', 218, 57, 174492, 45.8072, 0.799486461119547, -92.1333, -1.60802943572769),
(24104, '54846', 218, 57, 36402, 46.3832, 0.809539557611034, -90.7364, -1.58364893140658),
(24105, '54847', 218, 57, 131461, 46.5642, 0.812698603557144, -91.413, -1.59545782912558),
(24106, '54848', 218, 57, 32959, 45.4639, 0.79349474579745, -91.0976, -1.58995306066479),
(24107, '54849', 218, 57, 174868, 46.4912, 0.811424513203188, -91.7435, -1.60122614230342),
(24108, '54850', 218, 57, 174831, 46.9376, 0.81921566298409, -90.5805, -1.58092796310272),
(24109, '54853', 218, 57, 66518, 45.5723, 0.795386682706612, -92.4749, -1.6139914804525),
(24110, '54854', 218, 57, 10294, 46.6418, 0.814052979056691, -91.6803, -1.60012309421616),
(24111, '54855', 218, 57, 3989, 46.3542, 0.809033412127955, -90.8467, -1.58557402957153),
(24112, '54856', 218, 57, 17048, 46.424, 0.810251651945848, -91.1138, -1.59023580400361),
(24113, '54857', 218, 57, 175310, 45.5931, 0.795749711191027, -91.5985, -1.59869541488803),
(24114, '54858', 218, 57, 602, 45.5268, 0.794592557896954, -92.5071, -1.61455347647165),
(24115, '54859', 218, 57, 175348, 46.1024, 0.804638673071434, -91.8536, -1.60314774980986),
(24116, '54861', 218, 57, 175660, 46.5625, 0.81266893295986, -90.6566, -1.58225615866349),
(24117, '54862', 218, 57, 175666, 45.8069, 0.799481225131791, -91.1149, -1.59025500262538),
(24118, '54864', 218, 57, 37756, 46.5734, 0.812859173848327, -91.8214, -1.60258575379072),
(24119, '54865', 218, 57, 175917, 46.7332, 0.815648209993014, -91.3913, -1.59507909267789),
(24120, '54867', 218, 57, 176002, 45.8048, 0.799444573217499, -91.2309, -1.59227958455769),
(24121, '54868', 218, 57, 137690, 45.5164, 0.794411043654747, -91.7327, -1.6010376467442),
(24122, '54870', 218, 57, 176271, 45.6304, 0.796400719002021, -91.7239, -1.60088405777003),
(24123, '54871', 218, 57, 11900, 45.7586, 0.798638231103077, -92.1038, -1.60751456359835),
(24124, '54872', 218, 57, 176411, 45.7801, 0.799013476892256, -92.3833, -1.61239275885768),
(24125, '54873', 218, 57, 176432, 46.343, 0.808837935251732, -91.8188, -1.60254037523017),
(24126, '54874', 218, 57, 133191, 46.5796, 0.812967384261951, -91.9323, -1.60452132393118),
(24127, '54875', 218, 57, 25039, 45.9867, 0.802619327126876, -91.6763, -1.60005328104608),
(24128, '54876', 218, 57, 83844, 45.8129, 0.79958594488691, -91.5268, -1.59744401381435),
(24129, '54880', 218, 57, 6182, 46.7042, 0.815142064509936, -92.0736, -1.60698747416425),
(24130, '54888', 218, 57, 52187, 45.986, 0.802607109822112, -91.8908, -1.60379701229161),
(24131, '54889', 218, 57, 176745, 45.3986, 0.792355045795898, -92.1405, -1.60815509943384),
(24132, '54890', 218, 57, 176863, 46.172, 0.805853422230822, -91.7986, -1.60218781872127),
(24133, '54891', 218, 57, 12668, 46.6743, 0.814620211063589, -90.8966, -1.58644494886828),
(24134, '54893', 218, 57, 18520, 45.8789, 0.800737862193227, -92.298, -1.61090399300573),
(24135, '54895', 218, 57, 177003, 45.4264, 0.792840247327952, -91.4145, -1.59548400906436),
(24136, '54896', 218, 57, 112110, 45.8092, 0.799521367704586, -90.8672, -1.58593182206819),
(24137, '54901', 218, 57, 175714, 44.018, 0.768259030142864, -88.5379, -1.54527786780149),
(24138, '54902', 218, 57, 175714, 43.9969, 0.767890765670693, -88.6696, -1.54757646642636),
(24139, '54903', 218, 57, 175714, 43.9959, 0.767873312378173, -88.5637, -1.5457281627485),
(24140, '54904', 218, 57, 175714, 44.0253, 0.76838643917826, -88.6177, -1.54667064054458),
(24141, '54906', 218, 57, 175714, 44.0183, 0.76826426613062, -88.5538, -1.54555537515255),
(24142, '54909', 218, 57, 7068, 44.3, 0.773180858633488, -89.3408, -1.55929111636575),
(24143, '54911', 218, 57, 7132, 44.2756, 0.772754998296001, -88.3931, -1.5427506310446),
(24144, '54912', 218, 57, 7132, 44.2671, 0.772606645309582, -88.434, -1.54346447070867),
(24145, '54913', 218, 57, 7132, 44.2621, 0.772519378846982, -88.4157, -1.54314507545555),
(24146, '54914', 218, 57, 7132, 44.2703, 0.772662495845646, -88.4382, -1.54353777453725),
(24147, '54915', 218, 57, 7132, 44.2796, 0.772824811466081, -88.4096, -1.54303861037118),
(24148, '54919', 218, 57, 7132, 44.2659, 0.772585701358558, -88.3963, -1.54280648158066),
(24149, '54921', 218, 57, 19038, 44.3075, 0.773311758327388, -89.5439, -1.56283588007655),
(24150, '54922', 218, 57, 53, 44.5274, 0.777149737352523, -88.7266, -1.5485713041),
(24151, '54923', 218, 57, 376, 43.9697, 0.767416036114151, -88.9498, -1.55246687899045),
(24152, '54926', 218, 57, 134249, 44.619, 0.77874845894735, -89.0165, -1.55363101360153),
(24153, '54927', 218, 57, 173387, 44.102, 0.769725106714539, -88.6539, -1.5473024497338),
(24154, '54928', 218, 57, 39660, 44.7527, 0.781081964157266, -88.8984, -1.55156977975493),
(24155, '54929', 218, 57, 1631, 44.6243, 0.778840961397706, -88.7583, -1.54912457347288),
(24156, '54930', 218, 57, 29534, 44.0224, 0.768335824629952, -89.6345, -1.56441714837886),
(24157, '54931', 218, 57, 847, 44.273, 0.77270961973545, -88.6787, -1.5477352913883),
(24158, '54932', 218, 57, 15909, 43.8478, 0.76528847975597, -88.6475, -1.54719074866167),
(24159, '54933', 218, 57, 27100, 44.6669, 0.779584471659055, -88.7033, -1.54816464238429),
(24160, '54934', 218, 57, 2334, 44.0039, 0.768012938718333, -88.8393, -1.550538290167),
(24161, '54935', 218, 57, 119643, 43.7763, 0.764040569340794, -88.4325, -1.54343829076989),
(24162, '54936', 218, 57, 119643, 43.7732, 0.763986464133982, -88.4471, -1.54369310884068),
(24163, '54937', 218, 57, 119643, 43.8069, 0.764574640091904, -88.481, -1.5442847754571),
(24164, '54940', 218, 57, 2605, 44.2129, 0.771660676855001, -88.8291, -1.5503602665833),
(24165, '54941', 218, 57, 94596, 43.8394, 0.765141872098802, -88.9662, -1.55275311298778),
(24166, '54942', 218, 57, 2868, 44.3093, 0.773343174253924, -88.5491, -1.54547334467771),
(24167, '54943', 218, 57, 9313, 44.1325, 0.770257432136398, -89.692, -1.56542071269875),
(24168, '54944', 218, 57, 122836, 44.3238, 0.773596246995463, -88.6227, -1.54675790700718),
(24169, '54945', 218, 57, 16556, 44.5109, 0.776861758025944, -89.1306, -1.55562243427806),
(24170, '54946', 218, 57, 9863, 44.355, 0.774140789722085, -89.1194, -1.55542695740183),
(24171, '54947', 218, 57, 16851, 44.196, 0.771365716211414, -88.699, -1.54808959322645),
(24172, '54948', 218, 57, 174956, 44.7764, 0.781495607189989, -88.8858, -1.55134986826918),
(24173, '54949', 218, 57, 175123, 44.4618, 0.776004801363215, -88.9193, -1.55193455356859),
(24174, '54950', 218, 57, 630, 44.673, 0.779690936743427, -88.8873, -1.55137604820796),
(24175, '54952', 218, 57, 175264, 44.2149, 0.771695583440041, -88.4328, -1.54344352675764),
(24176, '54956', 218, 57, 4503, 44.1808, 0.771100426165111, -88.4881, -1.54440869383399),
(24177, '54957', 218, 57, 4503, 44.1859, 0.771189437956962, -88.462, -1.54395316289922),
(24178, '54960', 218, 57, 175494, 43.9349, 0.766808661534457, -89.2573, -1.55783376644033),
(24179, '54961', 218, 57, 4547, 44.3866, 0.774692313765715, -88.7468, -1.5489238606089),
(24180, '54962', 218, 57, 145957, 44.4876, 0.776455096310229, -89.0187, -1.55366941084508),
(24181, '54963', 218, 57, 151388, 44.0433, 0.768700598443619, -88.7599, -1.54915249874091),
(24182, '54964', 218, 57, 4994, 43.9313, 0.766745829681385, -88.7126, -1.54832695800472),
(24183, '54965', 218, 57, 132625, 44.1747, 0.770993961080739, -89.0829, -1.55478991222486),
(24184, '54966', 218, 57, 11247, 44.2144, 0.771686856793781, -89.4987, -1.56204699125465),
(24185, '54967', 218, 57, 175944, 44.1217, 0.770068936577182, -88.9256, -1.55204450931147),
(24186, '54968', 218, 57, 5231, 43.8528, 0.765375746218569, -89.1294, -1.55560149032703),
(24187, '54969', 218, 57, 128635, 44.273, 0.77270961973545, -88.7701, -1.54933052232462),
(24188, '54970', 218, 57, 176036, 44.0609, 0.769007776391969, -89.0997, -1.55508312753919),
(24189, '54971', 218, 57, 176106, 43.8454, 0.765246591853922, -88.8407, -1.55056272477653),
(24190, '54974', 218, 57, 117607, 43.81, 0.764628745298716, -88.6712, -1.5476043916944),
(24191, '54975', 218, 57, 28479, 44.4123, 0.775140863383478, -88.8626, -1.55094495188271),
(24192, '54976', 218, 57, 176284, 44.1756, 0.771009669044007, -89.1142, -1.55533620028073),
(24193, '54977', 218, 57, 176290, 44.4622, 0.776011782680223, -89.1466, -1.55590168695838),
(24194, '54978', 218, 57, 176688, 44.7841, 0.781629997542393, -88.8992, -1.55158374238894),
(24195, '54979', 218, 57, 176805, 43.8987, 0.766176852345235, -88.5517, -1.54551872323826),
(24196, '54980', 218, 57, 176897, 43.9894, 0.767759865976794, -88.7723, -1.54936891956816),
(24197, '54981', 218, 57, 176906, 44.3552, 0.774144280380589, -89.0869, -1.55485972539494),
(24198, '54982', 218, 57, 176922, 44.0715, 0.769192781292681, -89.2891, -1.55838878114247),
(24199, '54983', 218, 57, 177000, 44.3203, 0.773535160471643, -88.9328, -1.55217017301761),
(24200, '54984', 218, 57, 177042, 44.1683, 0.770882260008611, -89.2124, -1.55705011360619),
(24201, '54985', 218, 57, 122019, 44.0754, 0.769260849133509, -88.524, -1.54503526703546),
(24202, '54986', 218, 57, 177087, 44.1185, 0.770013086041118, -88.7347, -1.54871267576941),
(24203, '54990', 218, 57, 16556, 44.5081, 0.776812888806888, -89.1307, -1.55562417960731),
(24204, '55001', 218, 28, 570, 44.9034, 0.783712175340022, -92.8188, -1.61999366775011),
(24205, '55002', 218, 28, 133917, 45.4771, 0.793725129258713, -92.7968, -1.61960969531467),
(24206, '55003', 218, 28, 15140, 44.9035, 0.783713920669274, -92.8197, -1.62000937571338),
(24207, '55005', 218, 28, 220, 45.4037, 0.792444057587749, -93.2679, -1.62783194142082),
(24208, '55006', 218, 28, 134373, 45.7244, 0.798041328498895, -93.1726, -1.62616864264367),
(24209, '55007', 218, 28, 134418, 45.9447, 0.801886288841039, -92.8657, -1.6208122271693),
(24210, '55008', 218, 28, 1302, 45.5637, 0.79523658439094, -93.2287, -1.62714777235404),
(24211, '55009', 218, 28, 134547, 44.509, 0.776828596770156, -92.9031, -1.62146498030954),
(24212, '55010', 218, 28, 77985, 44.5728, 0.777942116832929, -93.1244, -1.62532739394421),
(24213, '55011', 218, 28, 31988, 45.3337, 0.791222327111353, -93.2572, -1.62764519119086),
(24214, '55012', 218, 28, 93143, 45.3947, 0.79228697795507, -92.8168, -1.61995876116507),
(24215, '55013', 218, 28, 134660, 45.3721, 0.791892533544119, -92.8903, -1.62124157816529),
(24216, '55014', 218, 28, 134672, 45.154, 0.78808597044552, -93.1397, -1.62559442931976),
(24217, '55016', 218, 28, 1788, 44.8402, 0.782609127252761, -92.8919, -1.62126950343332),
(24218, '55017', 218, 28, 134909, 45.6634, 0.796976677655179, -93.4029, -1.63018813591101),
(24219, '55018', 218, 28, 462, 44.3982, 0.774894771958947, -93.0522, -1.62406726622427),
(24220, '55019', 218, 28, 27007, 44.4145, 0.775179260627021, -93.2393, -1.62733277725475),
(24221, '55020', 218, 28, 2260, 44.5675, 0.777849614382573, -93.3287, -1.62889310160603),
(24222, '55021', 218, 28, 135325, 44.2949, 0.773091846841636, -93.2778, -1.62800472901677),
(24223, '55024', 218, 28, 8849, 44.6403, 0.779120214078025, -93.1495, -1.62576547158646),
(24224, '55025', 218, 28, 47138, 45.2762, 0.790218762791457, -92.99, -1.62298167142953),
(24225, '55026', 218, 28, 16145, 44.4951, 0.776585996004129, -92.3591, -1.61197038917869),
(24226, '55027', 218, 28, 135609, 44.408, 0.775065814225642, -92.5856, -1.61592355993446),
(24227, '55029', 218, 28, 65138, 45.5644, 0.795248801695704, -93.3404, -1.62909730512852),
(24228, '55030', 218, 28, 135677, 45.8578, 0.800369597721056, -93.0532, -1.62408471951679),
(24229, '55031', 218, 28, 2957, 44.609, 0.77857392602215, -93.0023, -1.62319634692752),
(24230, '55032', 218, 28, 2992, 45.5924, 0.795737493886263, -92.9837, -1.62287171568665),
(24231, '55033', 218, 28, 16375, 44.7302, 0.780689265075568, -92.8515, -1.62056439041551),
(24232, '55036', 218, 28, 135897, 45.836, 0.799989115944121, -92.9601, -1.62245981798318),
(24233, '55037', 218, 28, 94928, 46.0132, 0.803081839378655, -92.9412, -1.62212995075455),
(24234, '55038', 218, 28, 3275, 45.1628, 0.788239559419695, -92.9793, -1.62279492119956),
(24235, '55040', 218, 28, 136091, 45.49, 0.793950276732221, -93.2534, -1.62757886867928),
(24236, '55041', 218, 28, 9930, 44.4445, 0.77570285940262, -92.27, -1.61041530081517),
(24237, '55042', 218, 28, 136313, 44.9956, 0.785321368910361, -92.908, -1.62155050144289),
(24238, '55043', 218, 28, 16822, 44.9503, 0.784530734759207, -92.7689, -1.61912274845337),
(24239, '55044', 218, 28, 16832, 44.6525, 0.779333144246768, -93.2483, -1.62748985688743),
(24240, '55045', 218, 28, 136521, 45.3856, 0.792128152993138, -92.838, -1.6203287709665),
(24241, '55046', 218, 28, 10193, 44.4579, 0.775936733522387, -93.4209, -1.63050229517637),
(24242, '55047', 218, 28, 136737, 45.1977, 0.788848679328641, -92.7791, -1.61930077203707),
(24243, '55049', 218, 28, 49404, 44.1735, 0.770973017129715, -93.247, -1.62746716760715),
(24244, '55051', 218, 28, 23175, 45.8761, 0.800688992974171, -93.2952, -1.62830841630661),
(24245, '55052', 218, 28, 30565, 44.2336, 0.772021960010164, -93.4367, -1.63077805719819),
(24246, '55053', 218, 28, 137052, 44.3466, 0.773994182064917, -93.087, -1.62467464080396),
(24247, '55054', 218, 28, 4548, 44.5716, 0.777921172881905, -93.3532, -1.62932070727277),
(24248, '55055', 218, 28, 10799, 44.8721, 0.783165887284148, -92.9982, -1.62312478842819),
(24249, '55056', 218, 28, 37450, 45.5121, 0.794335994496911, -92.9677, -1.62259246300633),
(24250, '55057', 218, 28, 37457, 44.445, 0.77571158604888, -93.1812, -1.62631874095934),
(24251, '55060', 218, 28, 137350, 44.0856, 0.769438872717212, -93.2206, -1.62700640068463),
(24252, '55063', 218, 28, 11203, 45.8274, 0.799839017628449, -92.9692, -1.62261864294511),
(24253, '55065', 218, 28, 5293, 44.5263, 0.777130538730751, -93.0189, -1.62348607158335),
(24254, '55066', 218, 28, 11512, 44.5576, 0.777676826786625, -92.5499, -1.6153004773915),
(24255, '55067', 218, 28, 5457, 45.7609, 0.798678373675873, -92.9086, -1.6215609734184),
(24256, '55068', 218, 28, 74137, 44.7466, 0.780975499072895, -93.0755, -1.62447392793998),
(24257, '55069', 218, 28, 137854, 45.6837, 0.797330979493334, -92.9673, -1.62258548168932),
(24258, '55070', 218, 28, 11751, 45.3986, 0.792355045795898, -93.3612, -1.62946033361293),
(24259, '55071', 218, 28, 137950, 44.8416, 0.782633561862289, -92.996, -1.62308639118465),
(24260, '55072', 218, 28, 57416, 46.1278, 0.80508198670144, -92.8653, -1.62080524585229),
(24261, '55073', 218, 28, 33902, 45.2699, 0.790108807048581, -92.8311, -1.62020834324811),
(24262, '55074', 218, 28, 111349, 45.3887, 0.79218225819995, -92.747, -1.61874052134718),
(24263, '55075', 218, 28, 138187, 44.8923, 0.78351844379305, -93.0432, -1.62391018659159),
(24264, '55076', 218, 28, 136076, 44.8463, 0.782715592337133, -93.0322, -1.62371820037387),
(24265, '55077', 218, 28, 136076, 44.8299, 0.782429358339806, -93.0836, -1.62461529960939),
(24266, '55078', 218, 28, 985, 45.3981, 0.792346319149638, -92.9878, -1.62294327418598),
(24267, '55079', 218, 28, 985, 45.3984, 0.792351555137394, -92.9888, -1.6229607274785),
(24268, '55080', 218, 28, 138257, 45.6648, 0.797001112264707, -93.2323, -1.62721060420711),
(24269, '55082', 218, 28, 12131, 45.0511, 0.786290026645217, -92.8071, -1.61978946422763),
(24270, '55083', 218, 28, 12131, 45.0565, 0.786384274424825, -92.8218, -1.62004602762767),
(24271, '55084', 218, 28, 138407, 45.412, 0.792588919915665, -92.6619, -1.61725524615373),
(24272, '55085', 218, 28, 34261, 44.6742, 0.779711880694451, -92.9669, -1.62257850037232),
(24273, '55087', 218, 28, 6638, 44.2435, 0.772194747606111, -93.4004, -1.63014450267971),
(24274, '55088', 218, 28, 18520, 44.5184, 0.776992657719844, -93.368, -1.62957901600207),
(24275, '55089', 218, 28, 6684, 44.6213, 0.778788601520146, -92.6524, -1.61708943987479),
(24276, '55090', 218, 28, 138838, 45.0534, 0.786330169218013, -92.9566, -1.62239873145936),
(24277, '55092', 218, 28, 14923, 45.3363, 0.791267705671905, -92.9974, -1.62311082579417),
(24278, '55101', 218, 28, 11759, 44.97, 0.78487456462185, -93.0818, -1.62458388368286),
(24279, '55102', 218, 28, 11759, 44.9328, 0.784225302140108, -93.1215, -1.6252767793959),
(24280, '55103', 218, 28, 11759, 44.9664, 0.784811732768778, -93.1247, -1.62533262993196),
(24281, '55104', 218, 28, 11759, 44.9565, 0.784638945172831, -93.1595, -1.62594000451166),
(24282, '55105', 218, 28, 11759, 44.9351, 0.784265444712904, -93.165, -1.62603599762052),
(24283, '55106', 218, 28, 11759, 44.9578, 0.784661634453107, -93.0513, -1.624051558261),
(24284, '55107', 218, 28, 11759, 44.9322, 0.784214830164596, -93.0757, -1.62447741859849),
(24285, '55108', 218, 28, 11759, 44.9824, 0.785090985449097, -93.1814, -1.62632223161784),
(24286, '55109', 218, 28, 11759, 45.0141, 0.78564425482198, -93.0291, -1.62366409516706),
(24287, '55110', 218, 28, 11759, 45.0904, 0.786975941041251, -93.0057, -1.62325568812209),
(24288, '55111', 218, 28, 11759, 44.8871, 0.783427686671947, -93.1911, -1.62649152855529),
(24289, '55112', 218, 28, 11759, 44.967, 0.78482220474429, -93.198, -1.62661195627368),
(24290, '55113', 218, 28, 11759, 45.013, 0.785625056200208, -93.1578, -1.62591033391437),
(24291, '55114', 218, 28, 11759, 44.9662, 0.784808242110274, -93.1965, -1.6265857763349),
(24292, '55115', 218, 28, 11759, 45.062, 0.786480267533685, -92.9564, -1.62239524080086),
(24293, '55116', 218, 28, 11759, 44.9121, 0.783864018984945, -93.1749, -1.62620878521646),
(24294, '55117', 218, 28, 11759, 44.992, 0.785258537057289, -93.0994, -1.62489106163121),
(24295, '55118', 218, 28, 11759, 44.902, 0.783687740730494, -93.1077, -1.62503592395912),
(24296, '55119', 218, 28, 11759, 44.9385, 0.784324785907472, -93.0041, -1.62322776285406),
(24297, '55120', 218, 28, 11759, 44.8717, 0.78315890596714, -93.1542, -1.6258475020613),
(24298, '55121', 218, 28, 11759, 44.8468, 0.782724318983393, -93.1474, -1.62572881967217),
(24299, '55122', 218, 28, 11759, 44.8023, 0.781947647466256, -93.1974, -1.62660148429816),
(24300, '55123', 218, 28, 11759, 44.8049, 0.781993026026807, -93.1381, -1.62556650405173),
(24301, '55124', 218, 28, 11759, 44.7416, 0.780888232610295, -93.2071, -1.62677078123561),
(24302, '55125', 218, 28, 11759, 44.9199, 0.784000154666601, -92.9254, -1.62185418873274),
(24303, '55126', 218, 28, 11759, 45.0857, 0.786893910566407, -93.1369, -1.62554556010071),
(24304, '55127', 218, 28, 11759, 45.0723, 0.78666003644664, -93.089, -1.624709547389),
(24305, '55128', 218, 28, 11759, 44.993, 0.785275990349809, -92.9684, -1.6226046803111),
(24306, '55129', 218, 28, 11759, 44.9214, 0.784026334605381, -92.9473, -1.62223641583893),
(24307, '55133', 218, 28, 11759, 44.9426, 0.784396344406804, -93.0045, -1.62323474417107),
(24308, '55144', 218, 28, 11759, 44.9296, 0.784169451604044, -93.0475, -1.62398523574942),
(24309, '55145', 218, 28, 11759, 44.945, 0.784438232308851, -93.0925, -1.62477063391282),
(24310, '55146', 218, 28, 11759, 44.9424, 0.7843928537483, -93.0837, -1.62461704493865),
(24311, '55150', 218, 28, 104190, 44.8854, 0.783398016074663, -93.1611, -1.62596792977969),
(24312, '55155', 218, 28, 11759, 44.9629, 0.784750646244958, -93.1245, -1.62532913927346),
(24313, '55161', 218, 28, 11759, 45.0133, 0.785630292187964, -93.1572, -1.62589986193886),
(24314, '55164', 218, 28, 11759, 44.9663, 0.784809987439526, -93.085, -1.62463973421892),
(24315, '55165', 218, 28, 11759, 44.967, 0.78482220474429, -93.0853, -1.62464497020668),
(24316, '55166', 218, 28, 11759, 44.9661, 0.784806496781022, -93.084, -1.6246222809264),
(24317, '55168', 218, 28, 11759, 44.9458, 0.784452194942867, -93.0889, -1.62470780205975),
(24318, '55169', 218, 28, 11759, 44.9312, 0.784197376872076, -93.0811, -1.62457166637809),
(24319, '55170', 218, 28, 11759, 44.944, 0.784420779016332, -93.093, -1.62477936055908),
(24320, '55171', 218, 28, 11759, 44.9445, 0.784429505662591, -93.0929, -1.62477761522983),
(24321, '55172', 218, 28, 11759, 44.9659, 0.784803006122518, -93.0838, -1.6246187902679),
(24322, '55175', 218, 28, 11759, 44.9675, 0.78483093139055, -93.085, -1.62463973421892),
(24323, '55177', 218, 28, 11759, 45.0145, 0.785651236138987, -93.1846, -1.62637808215391),
(24324, '55182', 218, 28, 11759, 45.0219, 0.785780390503635, -93.1484, -1.62574627296469),
(24325, '55187', 218, 28, 11759, 44.9477, 0.784485356198655, -92.9104, -1.62159238934494),
(24326, '55188', 218, 28, 11759, 44.9209, 0.784017607959121, -92.9444, -1.62218580129062),
(24327, '55190', 218, 28, 11759, 45.07, 0.786619893873844, -93.1921, -1.62650898184781),
(24328, '55191', 218, 28, 11759, 45.0699, 0.786618148544592, -93.1924, -1.62651421783556),
(24329, '55301', 218, 28, 112712, 45.2386, 0.789562518992707, -93.6555, -1.63459683760155),
(24330, '55302', 218, 28, 44379, 45.0737, 0.786684471056168, -93.5718, -1.63313599701763),
(24331, '55303', 218, 28, 122146, 45.2683, 0.790080881780549, -94.1262, -1.64281210239069),
(24332, '55304', 218, 28, 14988, 45.2405, 0.789595680248495, -93.295, -1.62830492564811),
(24333, '55305', 218, 28, 3235, 44.9752, 0.784965321742954, -93.2589, -1.62767486178814),
(24334, '55306', 218, 28, 1248, 44.7322, 0.780724171660607, -93.2915, -1.62824383912429),
(24335, '55307', 218, 28, 15026, 44.6066, 0.778532038120103, -94.0782, -1.64197434434973),
(24336, '55308', 218, 28, 15157, 45.4122, 0.792592410574169, -93.8401, -1.63781871540073),
(24337, '55309', 218, 28, 7472, 45.3327, 0.791204873818834, -93.7466, -1.63618683255012),
(24338, '55310', 218, 28, 134284, 44.7643, 0.781284422350498, -94.8984, -1.65628953487459),
(24339, '55311', 218, 28, 132471, 45.0971, 0.787092878101135, -93.4886, -1.63168388307997),
(24340, '55312', 218, 28, 77937, 44.7317, 0.780715445014347, -94.3508, -1.64673211189067),
(24341, '55313', 218, 28, 26642, 45.1761, 0.78847168821021, -93.8748, -1.63842434465117),
(24342, '55314', 218, 28, 134465, 44.7383, 0.780830636744979, -94.6235, -1.65149162476085),
(24343, '55315', 218, 28, 7933, 44.7187, 0.780488552211588, -93.6869, -1.63514487098668),
(24344, '55316', 218, 28, 119083, 45.1734, 0.788424564320407, -93.391, -1.62998044173002),
(24345, '55317', 218, 28, 134633, 44.8525, 0.782823802750757, -93.5501, -1.63275726056995),
(24346, '55318', 218, 28, 85719, 44.812, 0.782116944403699, -93.6091, -1.63378700482862),
(24347, '55319', 218, 28, 8114, 45.4484, 0.793224219763391, -93.9982, -1.64057808094813),
(24348, '55320', 218, 28, 8122, 45.4131, 0.792608118537437, -94.0453, -1.64140013102582),
(24349, '55321', 218, 28, 134747, 45.0784, 0.786766501531012, -94.1909, -1.64394133041673),
(24350, '55322', 218, 28, 70683, 44.7722, 0.781422303361405, -93.7869, -1.63689020023867),
(24351, '55323', 218, 28, 134878, 44.9556, 0.784623237209563, -93.5767, -1.63322151815098),
(24352, '55324', 218, 28, 26915, 45.1095, 0.787309298928382, -94.4401, -1.6482906909127),
(24353, '55325', 218, 28, 134932, 45.0811, 0.786813625420816, -94.3089, -1.64600081893408),
(24354, '55327', 218, 28, 1992, 45.1999, 0.788887076572185, -93.4708, -1.63137321447312),
(24355, '55328', 218, 28, 72302, 45.0356, 0.786019500611158, -93.8178, -1.63742950697754),
(24356, '55329', 218, 28, 135140, 45.3459, 0.791435257280097, -94.5604, -1.65039032200285),
(24357, '55330', 218, 28, 135184, 45.3133, 0.790866279943947, -93.5745, -1.63318312090743),
(24358, '55331', 218, 28, 8809, 44.9012, 0.783673778096478, -93.5727, -1.6331517049809),
(24359, '55332', 218, 28, 13733, 44.5466, 0.777484840568906, -94.7433, -1.65358252920474),
(24360, '55333', 218, 28, 2595, 44.5272, 0.777146246694019, -94.8829, -1.65601900884053),
(24361, '55334', 218, 28, 32534, 44.5556, 0.777641920201586, -94.2164, -1.64438638937599),
(24362, '55335', 218, 28, 75922, 44.529, 0.777177662620555, -94.5288, -1.64983879795922),
(24363, '55336', 218, 28, 2739, 44.7708, 0.781397868751877, -94.1488, -1.64320654680164),
(24364, '55337', 218, 28, 1248, 44.769, 0.781366452825341, -93.2798, -1.62803963560181),
(24365, '55338', 218, 28, 135686, 44.6483, 0.779259840418184, -93.9013, -1.63888685690295),
(24366, '55339', 218, 28, 2948, 44.7328, 0.780734643636119, -93.9663, -1.64002132091675),
(24367, '55340', 218, 28, 27367, 45.0724, 0.786661781775892, -93.5787, -1.63325642473602),
(24368, '55341', 218, 28, 2963, 45.16, 0.788190690200639, -93.6547, -1.63458287496753),
(24369, '55342', 218, 28, 3049, 44.7424, 0.780902195244311, -94.7172, -1.65312699826997),
(24370, '55343', 218, 28, 3235, 44.921, 0.784019353288373, -93.422, -1.63052149379814),
(24371, '55344', 218, 28, 135138, 44.8599, 0.782952957115404, -93.4481, -1.63097702473291),
(24372, '55345', 218, 28, 136910, 44.9198, 0.783998409337349, -93.4852, -1.6316245418854),
(24373, '55346', 218, 28, 135138, 44.8803, 0.783309004282811, -93.4835, -1.63159487128812),
(24374, '55347', 218, 28, 135138, 44.8502, 0.782783660177961, -93.4874, -1.63166293912895),
(24375, '55348', 218, 28, 136714, 44.8281, 0.78239794241327, -93.3914, -1.62998742304703),
(24376, '55349', 218, 28, 136022, 45.0584, 0.786417435680613, -94.0663, -1.64176665016874),
(24377, '55350', 218, 28, 9633, 44.8906, 0.783488773195766, -94.3723, -1.64710735767984),
(24378, '55352', 218, 28, 3460, 44.6688, 0.779617632914843, -93.6321, -1.63418843055658),
(24379, '55353', 218, 28, 9856, 45.3589, 0.791662150082856, -94.2991, -1.64582977666738),
(24380, '55354', 218, 28, 136482, 44.8847, 0.783385798769899, -94.0429, -1.64135824312378),
(24381, '55355', 218, 28, 27727, 45.1258, 0.787593787596457, -94.5251, -1.64977422077689),
(24382, '55356', 218, 28, 60680, 44.985, 0.785136364009649, -93.5827, -1.6333262379061),
(24383, '55357', 218, 28, 3869, 45.1007, 0.787155709954207, -93.6629, -1.6347259919662),
(24384, '55358', 218, 28, 110276, 45.2318, 0.789443836603571, -94.0066, -1.6407246886053),
(24385, '55359', 218, 28, 136714, 45.0107, 0.785584913627412, -93.7002, -1.63537699977719),
(24386, '55360', 218, 28, 136771, 44.8848, 0.783387544099151, -93.8884, -1.63866170942944),
(24387, '55361', 218, 28, 136911, 44.9504, 0.784532480088459, -93.589, -1.63343619364897),
(24388, '55362', 218, 28, 588, 45.3058, 0.790735380250047, -93.7978, -1.63708044112714),
(24389, '55363', 218, 28, 4299, 45.0674, 0.786574515313292, -93.9147, -1.63912073102272),
(24390, '55364', 218, 28, 42190, 44.9373, 0.784303841956448, -93.666, -1.63478009717301),
(24391, '55365', 218, 28, 588, 45.2789, 0.790265886681261, -93.8077, -1.63725322872308),
(24392, '55366', 218, 28, 128231, 44.6783, 0.779783439193783, -94.2093, -1.64426247099909),
(24393, '55367', 218, 28, 631, 44.8848, 0.783387544099151, -93.9697, -1.64008066211132),
(24394, '55368', 218, 28, 4648, 44.7687, 0.781361216837585, -93.9296, -1.63938078508127),
(24395, '55369', 218, 28, 132471, 45.122, 0.787527465084881, -93.4173, -1.6304394633233),
(24396, '55370', 218, 28, 37716, 44.7734, 0.781443247312429, -94.0395, -1.64129890192921),
(24397, '55371', 218, 28, 5231, 45.5744, 0.795423334620904, -93.5861, -1.63338557910067),
(24398, '55372', 218, 28, 137590, 44.6843, 0.779888158948902, -93.3987, -1.63011483208243),
(24399, '55373', 218, 28, 5475, 45.0892, 0.786954997090227, -93.7357, -1.63599659166165),
(24400, '55374', 218, 28, 874, 45.1888, 0.788693345025214, -93.5568, -1.63287419762983),
(24401, '55375', 218, 28, 137895, 44.9037, 0.783717411327778, -93.7519, -1.63627933500047),
(24402, '55376', 218, 28, 113341, 45.2106, 0.789073826802148, -93.665, -1.63476264388049),
(24403, '55377', 218, 28, 57423, 45.5407, 0.794835158662982, -93.8118, -1.63732478722242),
(24404, '55378', 218, 28, 38115, 44.7616, 0.781237298460694, -93.3514, -1.62928929134623),
(24405, '55379', 218, 28, 138049, 44.791, 0.78175042526078, -93.5139, -1.63212545138073),
(24406, '55380', 218, 28, 24872, 45.3316, 0.791185675197062, -93.9566, -1.6398520239793),
(24407, '55381', 218, 28, 18083, 44.9036, 0.783715665998526, -94.1972, -1.6440512861596),
(24408, '55382', 218, 28, 34014, 45.2935, 0.790520704752052, -94.2182, -1.64441780530252),
(24409, '55383', 218, 28, 4648, 44.769, 0.781366452825341, -93.9256, -1.63931097191119),
(24410, '55384', 218, 28, 138229, 44.9358, 0.784277662017668, -93.6328, -1.63420064786135),
(24411, '55385', 218, 28, 6081, 44.7221, 0.780547893406156, -94.4866, -1.64910226901487),
(24412, '55386', 218, 28, 6554, 44.8659, 0.783057676870524, -93.6681, -1.6348167490873),
(24413, '55387', 218, 28, 138615, 44.8479, 0.782743517605165, -93.7903, -1.63694954143324),
(24414, '55388', 218, 28, 18507, 44.948, 0.784490592186411, -93.841, -1.637834423364),
(24415, '55389', 218, 28, 6653, 45.3586, 0.7916569140951, -94.4296, -1.64810743134124),
(24416, '55390', 218, 28, 6664, 45.0659, 0.786548335374513, -93.9703, -1.64009113408683),
(24417, '55391', 218, 28, 138724, 44.9714, 0.784898999231378, -93.5239, -1.63229998430592),
(24418, '55392', 218, 28, 17243, 44.9578, 0.784661634453107, -93.5409, -1.63259669027876),
(24419, '55393', 218, 28, 136714, 44.9938, 0.785289952983825, -93.7105, -1.63555676869015),
(24420, '55394', 218, 28, 6991, 44.8147, 0.782164068293503, -93.919, -1.63919578018055),
(24421, '55395', 218, 28, 114316, 44.9646, 0.784780316842242, -94.0478, -1.64144376425712),
(24422, '55396', 218, 28, 12913, 44.5428, 0.77741851805733, -94.3665, -1.64700612858323),
(24423, '55397', 218, 28, 6991, 44.7817, 0.781588109640345, -93.9159, -1.63914167497374),
(24424, '55398', 218, 28, 7002, 45.4439, 0.793145679947051, -93.5937, -1.63351822412382),
(24425, '55399', 218, 28, 6991, 44.8144, 0.782158832305747, -93.9185, -1.63918705353429),
(24426, '55401', 218, 28, 33298, 44.9858, 0.785150326643665, -93.2717, -1.62789826393239),
(24427, '55402', 218, 28, 33298, 44.9761, 0.784981029706222, -93.2715, -1.62789477327389),
(24428, '55403', 218, 28, 33298, 44.9726, 0.784919943182402, -93.2859, -1.62814610068618),
(24429, '55404', 218, 28, 33298, 44.9616, 0.784727956964682, -93.2619, -1.6277272216657),
(24430, '55405', 218, 28, 33298, 44.974, 0.78494437779193, -93.3062, -1.62850040252433),
(24431, '55406', 218, 28, 33298, 44.9406, 0.784361437821764, -93.2214, -1.62702036331864),
(24432, '55407', 218, 28, 33298, 44.9388, 0.784330021895228, -93.2532, -1.62757537802078),
(24433, '55408', 218, 28, 33298, 44.9468, 0.784469648235387, -93.2883, -1.62818798858823),
(24434, '55409', 218, 28, 33298, 44.9254, 0.784096147775461, -93.2888, -1.62819671523449),
(24435, '55410', 218, 28, 33298, 44.9127, 0.783874490960457, -93.3198, -1.6287377673026),
(24436, '55411', 218, 28, 33298, 44.9994, 0.785387691421936, -93.2982, -1.62836077618417),
(24437, '55412', 218, 28, 33298, 45.0268, 0.785865911636983, -93.3007, -1.62840440941547),
(24438, '55413', 218, 28, 33298, 44.9992, 0.785384200763432, -93.2449, -1.62743051569286),
(24439, '55414', 218, 28, 33298, 44.9813, 0.785071786827325, -93.2268, -1.62711461109825),
(24440, '55415', 218, 28, 33298, 44.9753, 0.784967067072206, -93.2582, -1.62766264448338),
(24441, '55416', 218, 28, 33298, 44.9502, 0.784528989429955, -93.3434, -1.62914966500608),
(24442, '55417', 218, 28, 33298, 44.9062, 0.783761044559078, -93.2302, -1.62717395229282),
(24443, '55418', 218, 28, 33298, 45.0222, 0.785785626491391, -93.2442, -1.6274182983881),
(24444, '55419', 218, 28, 33298, 44.9015, 0.783679014084234, -93.2867, -1.62816006332019),
(24445, '55420', 218, 28, 33298, 44.837, 0.782553276716698, -93.2778, -1.62800472901677),
(24446, '55421', 218, 28, 33298, 45.0579, 0.786408709034353, -93.2522, -1.62755792472826),
(24447, '55422', 218, 28, 33298, 45.0184, 0.785719303979815, -93.3414, -1.62911475842104),
(24448, '55423', 218, 28, 33298, 44.8762, 0.783237445783479, -93.2838, -1.62810944877189),
(24449, '55424', 218, 28, 33298, 44.9042, 0.783726137974038, -93.3393, -1.62907810650674),
(24450, '55425', 218, 28, 33298, 44.8473, 0.782733045629653, -93.2441, -1.62741655305884),
(24451, '55426', 218, 28, 33298, 44.9532, 0.784581349307515, -93.3764, -1.62972562365923),
(24452, '55427', 218, 28, 33298, 45.0052, 0.785488920518552, -93.3787, -1.62976576623203),
(24453, '55428', 218, 28, 33298, 45.0638, 0.786511683460221, -93.3807, -1.62980067281707),
(24454, '55429', 218, 28, 33298, 45.0646, 0.786525646094237, -93.3404, -1.62909730512852),
(24455, '55430', 218, 28, 33298, 45.064, 0.786515174118725, -93.3044, -1.6284689865978),
(24456, '55431', 218, 28, 33298, 44.8272, 0.782382234450002, -93.3134, -1.62862606623048),
(24457, '55432', 218, 28, 33298, 45.0978, 0.787105095405899, -93.256, -1.62762424723983),
(24458, '55433', 218, 28, 33298, 45.1658, 0.788291919297255, -93.3223, -1.6287814005339),
(24459, '55434', 218, 28, 33298, 45.1679, 0.788328571211547, -93.2492, -1.6275055648507),
(24460, '55435', 218, 28, 33298, 44.9166, 0.783942558801285, -93.4841, -1.63160534326363),
(24461, '55436', 218, 28, 33298, 44.9043, 0.78372788330329, -93.3745, -1.62969246240345),
(24462, '55437', 218, 28, 33298, 44.8245, 0.782335110560198, -93.3438, -1.62915664632308),
(24463, '55438', 218, 28, 33298, 44.8248, 0.782340346547954, -93.3801, -1.62979020084156),
(24464, '55439', 218, 28, 33298, 44.8776, 0.783261880393007, -93.3751, -1.62970293437896),
(24465, '55440', 218, 28, 33298, 44.9861, 0.785155562631421, -93.2705, -1.62787731998137),
(24466, '55441', 218, 28, 33298, 45.0044, 0.785474957884536, -93.4282, -1.63062970421177),
(24467, '55442', 218, 28, 33298, 45.0485, 0.786244648084666, -93.4282, -1.63062970421177),
(24468, '55443', 218, 28, 33298, 45.1246, 0.787572843645433, -93.3424, -1.62913221171355),
(24469, '55444', 218, 28, 33298, 45.1056, 0.787241231087554, -93.3046, -1.6284724772563),
(24470, '55445', 218, 28, 33298, 45.1197, 0.787487322512086, -93.3778, -1.62975005826876),
(24471, '55446', 218, 28, 33298, 45.0428, 0.786145164317302, -93.4881, -1.63167515643371),
(24472, '55447', 218, 28, 33298, 45.0012, 0.785419107348472, -93.4904, -1.63171529900651),
(24473, '55448', 218, 28, 33298, 45.1971, 0.788838207353129, -93.3021, -1.628428844025),
(24474, '55449', 218, 28, 33298, 45.1737, 0.788429800308162, -93.1977, -1.62660672028592),
(24475, '55450', 218, 28, 33298, 44.8779, 0.783267116380763, -93.2191, -1.62698022074585),
(24476, '55454', 218, 28, 33298, 44.9686, 0.784850130012322, -93.2447, -1.62742702503436),
(24477, '55455', 218, 28, 33298, 44.9761, 0.784981029706222, -93.2354, -1.62726470941392),
(24478, '55458', 218, 28, 33298, 44.9866, 0.785164289277681, -93.2705, -1.62787731998137),
(24479, '55459', 218, 28, 33298, 44.9865, 0.785162543948429, -93.2704, -1.62787557465212),
(24480, '55460', 218, 28, 33298, 44.9863, 0.785159053289925, -93.2703, -1.62787382932287),
(24481, '55468', 218, 28, 33298, 44.9804, 0.785056078864057, -93.2629, -1.62774467495822),
(24482, '55470', 218, 28, 33298, 44.9859, 0.785152071972917, -93.2708, -1.62788255596913),
(24483, '55472', 218, 28, 33298, 44.9835, 0.785110184070869, -93.2653, -1.62778656286027),
(24484, '55473', 218, 28, 33298, 44.9617, 0.784729702293934, -93.267, -1.62781623345755),
(24485, '55474', 218, 28, 33298, 44.98, 0.785049097547049, -93.2639, -1.62776212825074),
(24486, '55478', 218, 28, 33298, 44.9832, 0.785104948083113, -93.2646, -1.6277743455555),
(24487, '55479', 218, 28, 33298, 44.9837, 0.785113674729373, -93.2648, -1.62777783621401),
(24488, '55480', 218, 28, 33298, 44.986, 0.785153817302169, -93.2709, -1.62788430129838),
(24489, '55483', 218, 28, 33298, 44.9356, 0.784274171359164, -93.2814, -1.62806756086984),
(24490, '55484', 218, 28, 33298, 44.9707, 0.784886781926614, -93.2836, -1.62810595811338),
(24491, '55485', 218, 28, 33298, 44.9368, 0.784295115310188, -93.2225, -1.62703956194041),
(24492, '55486', 218, 28, 33298, 44.9771, 0.784998482998742, -93.2693, -1.62785637603035),
(24493, '55487', 218, 28, 33298, 44.9764, 0.784986265693978, -93.2673, -1.62782146944531),
(24494, '55488', 218, 28, 33298, 44.9796, 0.785042116230041, -93.2638, -1.62776038292149),
(24495, '55550', 218, 28, 6991, 44.8145, 0.782160577634999, -93.919, -1.63919578018055),
(24496, '55551', 218, 28, 6991, 44.8149, 0.782167558952007, -93.9189, -1.6391940348513),
(24497, '55552', 218, 28, 6991, 44.8142, 0.782155341647243, -93.919, -1.63919578018055),
(24498, '55553', 218, 28, 6991, 44.8146, 0.782162322964251, -93.9191, -1.63919752550981),
(24499, '55554', 218, 28, 4648, 44.7676, 0.781342018215814, -93.9272, -1.63933889717922),
(24500, '55555', 218, 28, 6991, 44.8139, 0.782150105659487, -93.9194, -1.63920276149756),
(24501, '55556', 218, 28, 6991, 44.8141, 0.782153596317991, -93.9192, -1.63919927083906),
(24502, '55557', 218, 28, 6991, 44.8145, 0.782160577634999, -93.9191, -1.63919752550981),
(24503, '55558', 218, 28, 6991, 44.8147, 0.782164068293503, -93.919, -1.63919578018055),
(24504, '55559', 218, 28, 6991, 44.8144, 0.782158832305747, -93.9193, -1.63920101616831),
(24505, '55560', 218, 28, 6991, 44.8146, 0.782162322964251, -93.9192, -1.63919927083906),
(24506, '55561', 218, 28, 588, 45.2791, 0.790269377339764, -93.8076, -1.63725148339383),
(24507, '55562', 218, 28, 6991, 44.814, 0.782151850988739, -93.9192, -1.63919927083906),
(24508, '55563', 218, 28, 588, 45.2789, 0.790265886681261, -93.8077, -1.63725322872308),
(24509, '55564', 218, 28, 6991, 44.8144, 0.782158832305747, -93.9193, -1.63920101616831),
(24510, '55565', 218, 28, 588, 45.2789, 0.790265886681261, -93.8076, -1.63725148339383),
(24511, '55566', 218, 28, 6991, 44.8148, 0.782165813622755, -93.9193, -1.63920101616831),
(24512, '55567', 218, 28, 6991, 44.8142, 0.782155341647243, -93.9186, -1.63918879886355),
(24513, '55568', 218, 28, 6991, 44.8143, 0.782157086976495, -93.9188, -1.63919228952205),
(24514, '55569', 218, 28, 132471, 45.1174, 0.78744717993929, -93.3993, -1.63012530405794),
(24515, '55570', 218, 28, 136714, 44.9942, 0.785296934300833, -93.7103, -1.63555327803164),
(24516, '55571', 218, 28, 136714, 44.9937, 0.785288207654573, -93.7111, -1.63556724066566),
(24517, '55572', 218, 28, 136714, 44.9937, 0.785288207654573, -93.7101, -1.63554978737314),
(24518, '55573', 218, 28, 6991, 44.8144, 0.782158832305747, -93.919, -1.63919578018055),
(24519, '55574', 218, 28, 136714, 44.9943, 0.785298679630085, -93.7104, -1.63555502336089),
(24520, '55575', 218, 28, 136022, 45.0594, 0.786434888973133, -94.0661, -1.64176315951024),
(24521, '55576', 218, 28, 136714, 44.9939, 0.785291698313077, -93.7109, -1.63556375000715),
(24522, '55577', 218, 28, 136714, 44.9937, 0.785288207654573, -93.7105, -1.63555676869015),
(24523, '55578', 218, 28, 136714, 44.9937, 0.785288207654573, -93.7104, -1.63555502336089),
(24524, '55579', 218, 28, 136714, 44.9938, 0.785289952983825, -93.7106, -1.6355585140194),
(24525, '55580', 218, 28, 588, 45.2795, 0.790276358656772, -93.8077, -1.63725322872308),
(24526, '55581', 218, 28, 588, 45.2792, 0.790271122669017, -93.8075, -1.63724973806458),
(24527, '55582', 218, 28, 588, 45.279, 0.790267632010513, -93.8077, -1.63725322872308),
(24528, '55583', 218, 28, 4648, 44.7644, 0.78128616767975, -93.9406, -1.63957277129899),
(24529, '55584', 218, 28, 588, 45.2798, 0.790281594644528, -93.8072, -1.63724450207682),
(24530, '55585', 218, 28, 588, 45.2797, 0.790279849315276, -93.8077, -1.63725322872308),
(24531, '55586', 218, 28, 588, 45.2789, 0.790265886681261, -93.8082, -1.63726195536934),
(24532, '55587', 218, 28, 588, 45.2797, 0.790279849315276, -93.8076, -1.63725148339383),
(24533, '55588', 218, 28, 588, 45.2791, 0.790269377339764, -93.808, -1.63725846471084),
(24534, '55589', 218, 28, 588, 45.2788, 0.790264141352008, -93.8073, -1.63724624740608),
(24535, '55590', 218, 28, 588, 45.2798, 0.790281594644528, -93.8077, -1.63725322872308),
(24536, '55591', 218, 28, 588, 45.2796, 0.790278103986024, -93.8074, -1.63724799273533),
(24537, '55592', 218, 28, 136714, 44.9937, 0.785288207654573, -93.7105, -1.63555676869015),
(24538, '55593', 218, 28, 136714, 44.9933, 0.785281226337565, -93.7105, -1.63555676869015),
(24539, '55594', 218, 28, 6991, 44.8146, 0.782162322964251, -93.9194, -1.63920276149756),
(24540, '55595', 218, 28, 3869, 45.1041, 0.787215051148774, -93.6603, -1.63468061340565),
(24541, '55596', 218, 28, 3869, 45.1034, 0.78720283384401, -93.6602, -1.63467886807639),
(24542, '55597', 218, 28, 3869, 45.1037, 0.787208069831767, -93.6601, -1.63467712274714),
(24543, '55598', 218, 28, 3869, 45.1043, 0.787218541807278, -93.6607, -1.63468759472265),
(24544, '55599', 218, 28, 3869, 45.0614, 0.786469795558173, -93.6621, -1.63471202933218),
(24545, '55601', 218, 28, 134147, 47.2672, 0.824968268198664, -91.317, -1.59378231304366),
(24546, '55602', 218, 28, 134410, 47.3115, 0.825741449057297, -91.8388, -1.60288944108057),
(24547, '55603', 218, 28, 80996, 47.4686, 0.82848336131218, -91.2796, -1.59312955990342),
(24548, '55604', 218, 28, 131065, 47.7483, 0.833365047230008, -90.3523, -1.57694512174967),
(24549, '55605', 218, 28, 135652, 47.9616, 0.837087834524512, -89.7615, -1.56663371652889),
(24550, '55606', 218, 28, 136021, 47.8747, 0.835571143404529, -89.9622, -1.57013659233764),
(24551, '55607', 218, 28, 3368, 47.6266, 0.831240981530331, -91.3963, -1.59516635914049),
(24552, '55609', 218, 28, 136264, 46.9489, 0.819412885189566, -91.7788, -1.60184224352937),
(24553, '55612', 218, 28, 136611, 47.6986, 0.832497618591767, -90.624, -1.58168718132734),
(24554, '55613', 218, 28, 97910, 47.6937, 0.83241209745842, -90.96, -1.58755148761404),
(24555, '55614', 218, 28, 138111, 47.3229, 0.825940416592025, -91.2607, -1.59279969267479),
(24556, '55615', 218, 28, 138451, 47.7436, 0.833283016755165, -90.8315, -1.58530873952523),
(24557, '55616', 218, 28, 138509, 47.0317, 0.820858017810217, -91.6705, -1.59995205194946),
(24558, '55701', 218, 28, 107918, 46.8412, 0.817533165585168, -92.22, -1.60954263618917),
(24559, '55702', 218, 28, 133892, 46.9766, 0.819896341392368, -92.6026, -1.6162202659073),
(24560, '55703', 218, 28, 77787, 47.7594, 0.83355877877698, -92.7724, -1.61918383497719),
(24561, '55704', 218, 28, 134017, 46.2755, 0.807659838006636, -92.8127, -1.61988720266574),
(24562, '55705', 218, 28, 474, 47.464, 0.828403076166589, -92.2434, -1.60995104323414),
(24563, '55706', 218, 28, 134052, 47.7173, 0.83282399516189, -91.9625, -1.60504841336529),
(24564, '55707', 218, 28, 92444, 46.5215, 0.811953347966542, -92.6192, -1.61650999056313),
(24565, '55708', 218, 28, 134290, 47.5453, 0.82982202884846, -92.336, -1.61156721812148),
(24566, '55709', 218, 28, 134355, 47.2498, 0.824664580908817, -93.3657, -1.62953887342927),
(24567, '55710', 218, 28, 19512, 47.6497, 0.831644152587542, -92.6585, -1.61719590495917),
(24568, '55711', 218, 28, 63225, 46.8575, 0.817817654253243, -92.6724, -1.61743850572519),
(24569, '55712', 218, 28, 7724, 46.2882, 0.807881494821639, -92.5511, -1.61532142134252),
(24570, '55713', 218, 28, 1226, 47.4943, 0.828931910929943, -92.7769, -1.61926237479353),
(24571, '55716', 218, 28, 1298, 47.314, 0.825785082288597, -93.2777, -1.62800298368751),
(24572, '55717', 218, 28, 108480, 47.0791, 0.821685303875662, -92.4723, -1.61394610189195),
(24573, '55718', 218, 28, 1361, 46.6341, 0.813918588704288, -92.4825, -1.61412412547566),
(24574, '55719', 218, 28, 1563, 47.5187, 0.829357771267429, -92.8835, -1.62112289577615),
(24575, '55720', 218, 28, 134727, 46.7145, 0.815321833422891, -92.4855, -1.61417648535322),
(24576, '55721', 218, 28, 45880, 47.2402, 0.824497029300625, -93.623, -1.63402960559465),
(24577, '55722', 218, 28, 134752, 47.2878, 0.825327806024575, -93.4283, -1.63063144954102),
(24578, '55723', 218, 28, 15606, 47.8508, 0.835154009713303, -92.7402, -1.61862183895805),
(24579, '55724', 218, 28, 1793, 47.162, 0.823132181825566, -92.388, -1.61247478933252),
(24580, '55725', 218, 28, 134843, 48.2657, 0.842395380779827, -92.4906, -1.61426549714507),
(24581, '55726', 218, 28, 1893, 46.6498, 0.814192605396851, -92.9038, -1.62147719761431),
(24582, '55730', 218, 28, 131066, 47.2383, 0.824463868044837, -93.5302, -1.6324099400488),
(24583, '55731', 218, 28, 54625, 47.8917, 0.835867849377368, -91.8865, -1.60372196313377),
(24584, '55732', 218, 28, 27100, 47.6685, 0.831972274486917, -92.2273, -1.60967004522457),
(24585, '55733', 218, 28, 135260, 46.7109, 0.815259001569819, -92.3603, -1.61199133312972),
(24586, '55734', 218, 28, 135280, 47.43, 0.827809664220911, -92.5135, -1.61466517754377),
(24587, '55735', 218, 28, 135366, 46.2161, 0.806623112430951, -92.953, -1.62233589960629),
(24588, '55736', 218, 28, 130818, 46.9439, 0.819325618726966, -92.9192, -1.62174597831912),
(24589, '55738', 218, 28, 54802, 47.2709, 0.825032845380988, -92.6196, -1.61651697188014),
(24590, '55741', 218, 28, 2713, 47.4636, 0.828396094849581, -92.3912, -1.61253063986859),
(24591, '55742', 218, 28, 16246, 47.1959, 0.823723848441992, -93.1299, -1.62542338705307);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(24592, '55744', 218, 28, 131066, 47.2314, 0.82434344032645, -93.5239, -1.63229998430592),
(24593, '55745', 218, 28, 131066, 47.2293, 0.824306788412158, -93.5245, -1.63231045628144),
(24594, '55746', 218, 28, 135914, 47.414, 0.827530411540591, -92.9307, -1.62194669118309),
(24595, '55747', 218, 28, 135914, 47.3998, 0.827282574786808, -92.9476, -1.62224165182668),
(24596, '55748', 218, 28, 21935, 46.9871, 0.820079600963828, -93.5801, -1.63328085934555),
(24597, '55749', 218, 28, 125098, 46.474, 0.811124316571845, -92.3951, -1.61259870770941),
(24598, '55750', 218, 28, 136025, 47.5165, 0.829319374023886, -92.1399, -1.60814462745832),
(24599, '55751', 218, 28, 27518, 47.4071, 0.827409983822204, -92.6554, -1.61714179975235),
(24600, '55752', 218, 28, 136118, 46.9413, 0.819280240166414, -93.3134, -1.62862606623048),
(24601, '55753', 218, 28, 136187, 47.3973, 0.827238941555508, -93.0777, -1.62451232518353),
(24602, '55756', 218, 28, 120207, 46.2979, 0.808050791759083, -92.7215, -1.61829546238792),
(24603, '55757', 218, 28, 136224, 46.5132, 0.811808485638626, -92.9196, -1.62175295963612),
(24604, '55758', 218, 28, 131593, 47.5142, 0.82927923145109, -92.7306, -1.61845428734985),
(24605, '55760', 218, 28, 10403, 46.7244, 0.815494621018839, -93.3162, -1.62867493544953),
(24606, '55763', 218, 28, 136663, 47.3376, 0.826196979992068, -92.2591, -1.6102250599267),
(24607, '55764', 218, 28, 10300, 47.3189, 0.825870603421945, -93.3018, -1.62842360803725),
(24608, '55765', 218, 28, 23012, 47.1022, 0.822088474932873, -92.7588, -1.61894647019892),
(24609, '55766', 218, 28, 136833, 47.2488, 0.824647127616297, -92.419, -1.61301584140064),
(24610, '55767', 218, 28, 136957, 46.4525, 0.810749070782666, -92.7695, -1.61913322042888),
(24611, '55768', 218, 28, 137006, 47.48, 0.828682328846908, -92.6729, -1.61744723237145),
(24612, '55769', 218, 28, 137039, 47.3775, 0.826893366363613, -93.166, -1.62605345091304),
(24613, '55771', 218, 28, 37545, 48.0765, 0.839093217835054, -92.7871, -1.61944039837723),
(24614, '55772', 218, 28, 137057, 48.2727, 0.842517553827467, -93.3822, -1.62982685275585),
(24615, '55775', 218, 28, 137417, 47.3277, 0.82602419239612, -93.1602, -1.62595222181642),
(24616, '55777', 218, 28, 6578, 47.5228, 0.829429329766761, -92.5341, -1.61502471536968),
(24617, '55779', 218, 28, 5602, 46.8997, 0.818554183197585, -92.4475, -1.61351326023746),
(24618, '55780', 218, 28, 33898, 46.6834, 0.814779036025521, -92.6828, -1.6176200199674),
(24619, '55781', 218, 28, 138105, 47.6811, 0.832192185972668, -92.9971, -1.62310558980642),
(24620, '55782', 218, 28, 12026, 47.8147, 0.834523945853333, -92.2377, -1.60985155946677),
(24621, '55783', 218, 28, 138326, 46.3617, 0.809164311821855, -92.7785, -1.61929030006156),
(24622, '55784', 218, 28, 138367, 47.0676, 0.821484591011683, -93.1859, -1.62640077143418),
(24623, '55785', 218, 28, 138373, 46.8776, 0.818168465432894, -93.6817, -1.63505411386557),
(24624, '55786', 218, 28, 138388, 47.3127, 0.825762393008321, -93.3824, -1.62983034341435),
(24625, '55787', 218, 28, 25327, 46.6393, 0.814009345825391, -93.1224, -1.62529248735917),
(24626, '55790', 218, 28, 133423, 47.7944, 0.834169644015178, -92.3519, -1.61184472547255),
(24627, '55791', 218, 28, 138501, 46.8957, 0.818484370027505, -92.3565, -1.61192501061814),
(24628, '55792', 218, 28, 6578, 47.5465, 0.829842972799484, -92.5277, -1.61491301429756),
(24629, '55793', 218, 28, 138667, 47.3949, 0.827197053653461, -93.0717, -1.62440760542841),
(24630, '55795', 218, 28, 138851, 46.31, 0.808261976598574, -92.8592, -1.62069878076792),
(24631, '55796', 218, 28, 6892, 47.9281, 0.836503149225094, -91.8027, -1.6022593772206),
(24632, '55797', 218, 28, 138944, 46.5681, 0.812766671397971, -92.3576, -1.61194420923992),
(24633, '55798', 218, 28, 6964, 46.7849, 0.816550545216295, -92.9507, -1.62229575703349),
(24634, '55801', 218, 28, 20699, 47.1, 0.822050077689329, -91.8528, -1.60313378717585),
(24635, '55802', 218, 28, 20699, 46.7641, 0.81618751673188, -92.1146, -1.60770305915757),
(24636, '55803', 218, 28, 20699, 46.9124, 0.818775840012588, -92.1174, -1.60775192837662),
(24637, '55804', 218, 28, 20699, 46.8651, 0.817950299276395, -91.9803, -1.60535908197214),
(24638, '55805', 218, 28, 20699, 46.799, 0.816796636640826, -92.095, -1.60736097462418),
(24639, '55806', 218, 28, 20699, 46.7724, 0.816332379059796, -92.1244, -1.60787410142426),
(24640, '55807', 218, 28, 20699, 46.7382, 0.815735476455614, -92.17, -1.60866997156317),
(24641, '55808', 218, 28, 20699, 46.6783, 0.814690024233669, -92.2327, -1.60976429300417),
(24642, '55810', 218, 28, 20699, 46.7515, 0.815967605246129, -92.2456, -1.60998944047768),
(24643, '55811', 218, 28, 20699, 46.8113, 0.817011312138822, -92.1741, -1.60874153006251),
(24644, '55812', 218, 28, 20699, 46.8109, 0.817004330821814, -92.0736, -1.60698747416425),
(24645, '55814', 218, 28, 20699, 46.8412, 0.817533165585168, -92.2198, -1.60953914553067),
(24646, '55815', 218, 28, 20699, 46.7594, 0.816105486257036, -92.1324, -1.60801372776442),
(24647, '55816', 218, 28, 20699, 46.7688, 0.816269547206724, -92.1296, -1.60796485854537),
(24648, '55901', 218, 28, 28433, 44.0514, 0.76884197011303, -92.4964, -1.61436672624168),
(24649, '55902', 218, 28, 28433, 43.9993, 0.767932653572741, -92.4921, -1.61429167708385),
(24650, '55903', 218, 28, 28433, 43.9984, 0.767916945609473, -92.5327, -1.61500028076016),
(24651, '55904', 218, 28, 28433, 44.0135, 0.768180490326524, -92.4218, -1.6130647106197),
(24652, '55905', 218, 28, 28433, 44.0366, 0.768583661383735, -92.4917, -1.61428469576684),
(24653, '55906', 218, 28, 28433, 44.0623, 0.769032211001497, -92.4375, -1.61333872731226),
(24654, '55909', 218, 28, 14941, 43.5665, 0.76037886857011, -92.7178, -1.6182308852056),
(24655, '55910', 218, 28, 133925, 44.139, 0.770370878537777, -91.8989, -1.60393838396102),
(24656, '55912', 218, 28, 7197, 43.6663, 0.7621207071636, -92.9808, -1.62282110113834),
(24657, '55917', 218, 28, 134315, 43.8661, 0.765607875009085, -93.0542, -1.62410217280931),
(24658, '55918', 218, 28, 15350, 43.731, 0.76324993518964, -92.8721, -1.62092392824143),
(24659, '55919', 218, 28, 1191, 43.6892, 0.762520387562307, -91.2965, -1.593424520547),
(24660, '55920', 218, 28, 7810, 44.0342, 0.768541773481687, -92.6491, -1.61703184400948),
(24661, '55921', 218, 28, 1296, 43.6328, 0.761536021864182, -91.5023, -1.59701640814761),
(24662, '55922', 218, 28, 19763, 43.587, 0.760736661066769, -91.9101, -1.60413386083724),
(24663, '55923', 218, 28, 8043, 43.8434, 0.765211685268882, -92.1859, -1.60894747891424),
(24664, '55924', 218, 28, 26794, 44.0457, 0.768742486345666, -92.9966, -1.62309686316016),
(24665, '55925', 218, 28, 20443, 43.9101, 0.766375819879962, -91.357, -1.59448044474446),
(24666, '55926', 218, 28, 2038, 43.7174, 0.763012570411369, -92.7491, -1.61877717326147),
(24667, '55927', 218, 28, 135021, 44.0355, 0.768564462761963, -92.8652, -1.62080350052304),
(24668, '55929', 218, 28, 8583, 43.9737, 0.76748584928423, -92.1361, -1.60807830494675),
(24669, '55931', 218, 28, 135162, 43.6022, 0.761001951113072, -91.4455, -1.59602506113247),
(24670, '55932', 218, 28, 2254, 44.1255, 0.770135259088758, -92.2493, -1.61005401766001),
(24671, '55933', 218, 28, 15918, 43.6303, 0.761492388632882, -92.6894, -1.61773521169803),
(24672, '55934', 218, 28, 135296, 43.9891, 0.767754629989038, -92.2443, -1.60996675119741),
(24673, '55935', 218, 28, 2573, 43.7179, 0.763021297057629, -92.1502, -1.60832439637128),
(24674, '55936', 218, 28, 135648, 43.7056, 0.762806621559634, -92.5707, -1.61566350587591),
(24675, '55939', 218, 28, 745, 43.5561, 0.760197354327902, -92.0097, -1.60587220877223),
(24676, '55940', 218, 28, 102676, 43.8918, 0.766056424626847, -92.8476, -1.62049632257469),
(24677, '55941', 218, 28, 135969, 43.7584, 0.763728155404687, -91.3536, -1.59442110354989),
(24678, '55942', 218, 28, 22029, 43.9844, 0.767672599514194, -91.6372, -1.59937085730855),
(24679, '55943', 218, 28, 3246, 43.7619, 0.763789241928507, -91.569, -1.59818054275869),
(24680, '55944', 218, 28, 30234, 44.0351, 0.768557481444955, -92.7521, -1.61882953313903),
(24681, '55945', 218, 28, 27611, 44.3079, 0.773318739644395, -91.9949, -1.60561390004293),
(24682, '55946', 218, 28, 9843, 44.2713, 0.772679949138166, -92.9869, -1.62292756622272),
(24683, '55947', 218, 28, 136280, 43.8225, 0.764846911455215, -91.3281, -1.59397604459063),
(24684, '55949', 218, 28, 116400, 43.7167, 0.763000353106605, -91.9748, -1.60526308886328),
(24685, '55950', 218, 28, 9985, 43.7181, 0.763024787716133, -92.9896, -1.62297469011252),
(24686, '55951', 218, 28, 33011, 43.5111, 0.759411956164505, -92.503, -1.61448191797231),
(24687, '55952', 218, 28, 3747, 43.985, 0.767683071489706, -91.8682, -1.60340256788065),
(24688, '55953', 218, 28, 3912, 43.506, 0.759322944372653, -92.9418, -1.62214042273007),
(24689, '55954', 218, 28, 16978, 43.5217, 0.759596961065216, -91.7672, -1.60163978533614),
(24690, '55955', 218, 28, 136694, 44.0687, 0.769143912073625, -92.7587, -1.61894472486966),
(24691, '55956', 218, 28, 66693, 44.2728, 0.772706129076945, -92.5444, -1.61520448428264),
(24692, '55957', 218, 28, 4227, 44.2447, 0.772215691557135, -92.2967, -1.61088130372545),
(24693, '55959', 218, 28, 136903, 44.0871, 0.769465052655992, -91.743, -1.60121741565716),
(24694, '55960', 218, 28, 104984, 44.1509, 0.770578572718764, -92.523, -1.61483098382271),
(24695, '55961', 218, 28, 137328, 43.5741, 0.760511513593261, -92.4085, -1.61283258182918),
(24696, '55962', 218, 28, 4973, 43.7734, 0.763989954792486, -91.8491, -1.60306920999352),
(24697, '55963', 218, 28, 17608, 44.202, 0.771470435966534, -92.6492, -1.61703358933873),
(24698, '55964', 218, 28, 5102, 44.1653, 0.770829900131052, -92.1682, -1.60863855563664),
(24699, '55965', 218, 28, 5220, 43.6672, 0.762136415126868, -92.0809, -1.60711488319965),
(24700, '55967', 218, 28, 819, 43.7961, 0.764386144532689, -92.5693, -1.61563907126639),
(24701, '55968', 218, 28, 137646, 44.3985, 0.774900007946702, -92.0721, -1.60696129422547),
(24702, '55969', 218, 28, 137779, 44.0984, 0.769662274861467, -91.8212, -1.60258226313222),
(24703, '55970', 218, 28, 83374, 43.5714, 0.760464389703457, -92.7191, -1.61825357448587),
(24704, '55971', 218, 28, 137860, 43.7991, 0.764438504410248, -91.7551, -1.60142860049665),
(24705, '55972', 218, 28, 11748, 43.9687, 0.767398582821631, -92.0626, -1.60679548794653),
(24706, '55973', 218, 28, 137991, 43.805, 0.764541478836116, -92.7492, -1.61877891859072),
(24707, '55974', 218, 28, 31191, 43.5613, 0.760288111449006, -91.6378, -1.59938132928406),
(24708, '55975', 218, 28, 826, 43.6878, 0.762495952952779, -92.3896, -1.61250271460055),
(24709, '55976', 218, 28, 6086, 43.8573, 0.765454286034909, -92.4859, -1.61418346667022),
(24710, '55977', 218, 28, 138398, 43.5439, 0.759984424159159, -92.6284, -1.61667056085432),
(24711, '55979', 218, 28, 31360, 43.9454, 0.766991921105916, -91.935, -1.60456844782099),
(24712, '55981', 218, 28, 138608, 44.3605, 0.774236782830945, -92.0207, -1.60606419498995),
(24713, '55982', 218, 28, 121846, 43.8046, 0.764534497519108, -92.8693, -1.62087505902237),
(24714, '55983', 218, 28, 138658, 44.3026, 0.77322623719404, -92.7901, -1.61949275825479),
(24715, '55985', 218, 28, 69981, 44.1496, 0.770555883438488, -92.9024, -1.62145276300478),
(24716, '55987', 218, 28, 904, 44.0455, 0.768738995687162, -91.6522, -1.59963265669635),
(24717, '55988', 218, 28, 510, 44.0261, 0.768400401812276, -91.7597, -1.60150888564224),
(24718, '55990', 218, 28, 138958, 43.7044, 0.76278567760861, -92.2624, -1.61028265579202),
(24719, '55991', 218, 28, 138988, 44.1933, 0.77131859232161, -92.4658, -1.61383265549057),
(24720, '55992', 218, 28, 138992, 44.2921, 0.77304297762258, -92.6709, -1.61741232578641),
(24721, '56001', 218, 28, 33184, 44.159, 0.770719944388176, -93.998, -1.64057459028963),
(24722, '56002', 218, 28, 33184, 44.1631, 0.770791502887508, -94.0034, -1.64066883806924),
(24723, '56003', 218, 28, 33184, 44.1746, 0.770992215751487, -94.0283, -1.64110342505298),
(24724, '56006', 218, 28, 33184, 44.1169, 0.769985160773086, -93.9985, -1.64058331693589),
(24725, '56007', 218, 28, 133881, 43.6496, 0.761829237178517, -93.3693, -1.62960170528234),
(24726, '56009', 218, 28, 796, 43.6702, 0.762188775004428, -93.5724, -1.63314646899314),
(24727, '56010', 218, 28, 7087, 43.8869, 0.765970903493499, -94.1587, -1.64337933439758),
(24728, '56011', 218, 28, 31776, 44.6267, 0.778882849299753, -93.7779, -1.63673312060599),
(24729, '56013', 218, 28, 134322, 43.6393, 0.761649468265561, -94.0929, -1.64223090774977),
(24730, '56014', 218, 28, 134403, 43.5642, 0.760338725997314, -93.8137, -1.6373579484782),
(24731, '56016', 218, 28, 134686, 43.7631, 0.76381018587953, -93.3184, -1.62871333269308),
(24732, '56017', 218, 28, 1620, 44.3229, 0.773580539032195, -93.8363, -1.63775239288915),
(24733, '56019', 218, 28, 134772, 44.1107, 0.769876950359463, -94.9047, -1.65639949061746),
(24734, '56020', 218, 28, 115088, 43.6159, 0.761241061220595, -93.5292, -1.63239248675628),
(24735, '56021', 218, 28, 1839, 44.2629, 0.772533341480998, -94.338, -1.64650870974641),
(24736, '56022', 218, 28, 134925, 44.0517, 0.768847206100786, -94.838, -1.65523535600638),
(24737, '56023', 218, 28, 32219, 43.7679, 0.763893961683626, -94.0061, -1.64071596195904),
(24738, '56024', 218, 28, 15848, 44.1627, 0.7707845215705, -93.8826, -1.63856048033283),
(24739, '56025', 218, 28, 2193, 43.7605, 0.763764807318979, -93.9474, -1.63969145368812),
(24740, '56026', 218, 28, 13721, 43.8721, 0.765712594764204, -93.3011, -1.62841139073248),
(24741, '56027', 218, 28, 64511, 43.5039, 0.759286292458361, -94.0861, -1.64211222536064),
(24742, '56028', 218, 28, 135224, 44.2339, 0.77202719599792, -93.7053, -1.63546601156904),
(24743, '56029', 218, 28, 8758, 43.5043, 0.759293273775369, -93.4891, -1.63169260972623),
(24744, '56030', 218, 28, 135263, 44.3201, 0.773531669813139, -94.5798, -1.65072891587773),
(24745, '56031', 218, 28, 27132, 43.6469, 0.761782113288713, -94.4602, -1.64864150209235),
(24746, '56032', 218, 28, 135466, 43.7662, 0.763864291086342, -93.5627, -1.6329771720557),
(24747, '56033', 218, 28, 162, 43.5864, 0.760726189091256, -93.9234, -1.63927257466764),
(24748, '56034', 218, 28, 2657, 44.048, 0.768782628918462, -94.1663, -1.64351197942074),
(24749, '56035', 218, 28, 2687, 43.8281, 0.764944649893327, -93.2716, -1.62789651860314),
(24750, '56036', 218, 28, 2748, 43.5706, 0.760450427069441, -93.2744, -1.6279453878222),
(24751, '56037', 218, 28, 135607, 44.0033, 0.768002466742821, -94.0682, -1.64179981142453),
(24752, '56039', 218, 28, 21520, 43.6985, 0.762682703182742, -94.3432, -1.64659946686751),
(24753, '56041', 218, 28, 135791, 44.1509, 0.770578572718764, -94.4923, -1.64920175278224),
(24754, '56042', 218, 28, 165, 43.8067, 0.7645711494334, -93.4875, -1.6316646844582),
(24755, '56043', 218, 28, 36333, 43.6484, 0.761808293227493, -93.2458, -1.62744622365613),
(24756, '56044', 218, 28, 23, 44.5272, 0.777146246694019, -93.9072, -1.63898983132882),
(24757, '56045', 218, 28, 60287, 43.7587, 0.763733391392443, -93.2028, -1.62669573207777),
(24758, '56046', 218, 28, 665, 43.981, 0.767613258319626, -93.3412, -1.62911126776253),
(24759, '56047', 218, 28, 13999, 43.7247, 0.763139979446765, -94.1941, -1.64399718095279),
(24760, '56048', 218, 28, 27546, 44.1163, 0.769974688797574, -93.708, -1.63551313545885),
(24761, '56050', 218, 28, 136180, 44.2691, 0.772641551894622, -93.967, -1.64003353822151),
(24762, '56051', 218, 28, 136230, 43.5371, 0.759865741770023, -93.7133, -1.6356056379092),
(24763, '56052', 218, 28, 66081, 44.3344, 0.773781251896174, -93.4877, -1.6316681751167),
(24764, '56054', 218, 28, 3594, 44.4464, 0.775736020658408, -94.394, -1.64748609412753),
(24765, '56055', 218, 28, 136309, 44.1134, 0.769924074249267, -94.214, -1.64434450147394),
(24766, '56056', 218, 28, 95463, 43.9822, 0.76763420227065, -94.6285, -1.65157889122345),
(24767, '56057', 218, 28, 136429, 44.3919, 0.774784816216071, -93.7366, -1.63601229962492),
(24768, '56058', 218, 28, 136437, 44.4575, 0.775929752205379, -93.9067, -1.63898110468256),
(24769, '56060', 218, 28, 10065, 43.9235, 0.766609693999729, -94.4354, -1.64820866043785),
(24770, '56062', 218, 28, 136638, 44.05, 0.768817535503502, -94.4165, -1.64787879320923),
(24771, '56063', 218, 28, 73326, 44.2011, 0.771454728003266, -93.813, -1.63734573117344),
(24772, '56065', 218, 28, 30422, 43.9271, 0.766672525852801, -93.9548, -1.63982060805277),
(24773, '56068', 218, 28, 136906, 43.8402, 0.765155834732818, -93.8307, -1.63765465445104),
(24774, '56069', 218, 28, 4289, 44.437, 0.77557195970872, -93.5885, -1.63342746700271),
(24775, '56071', 218, 28, 137090, 44.5472, 0.777495312544418, -93.5788, -1.63325817006527),
(24776, '56072', 218, 28, 137093, 43.8954, 0.766119256479919, -93.4898, -1.63170482703099),
(24777, '56073', 218, 28, 96522, 44.3115, 0.773381571497467, -94.4641, -1.64870956993318),
(24778, '56074', 218, 28, 137121, 44.2751, 0.772746271649741, -94.1908, -1.64393958508748),
(24779, '56075', 218, 28, 137203, 43.7344, 0.763309276384208, -94.4364, -1.64822611373037),
(24780, '56076', 218, 28, 4710, 43.634, 0.761556965815206, -93.1137, -1.62514064371424),
(24781, '56078', 218, 28, 71250, 44.0074, 0.768074025242153, -93.7845, -1.63684831233662),
(24782, '56080', 218, 28, 5605, 44.081, 0.76935858757162, -93.8558, -1.63809273209329),
(24783, '56081', 218, 28, 11756, 43.9834, 0.767655146221674, -94.6256, -1.65152827667515),
(24784, '56082', 218, 28, 17915, 44.3312, 0.77372540136011, -93.9618, -1.63994278110041),
(24785, '56083', 218, 28, 17956, 44.2109, 0.771625770269961, -95.1288, -1.66031077347118),
(24786, '56084', 218, 28, 5715, 44.2286, 0.771934693547564, -94.4339, -1.64818248049907),
(24787, '56085', 218, 28, 138150, 44.2965, 0.773119772109668, -94.7232, -1.65323171802509),
(24788, '56087', 218, 28, 349, 44.2397, 0.772128425094535, -94.9786, -1.65768928893469),
(24789, '56088', 218, 28, 138489, 43.8288, 0.764956867198091, -94.4346, -1.64819469780384),
(24790, '56089', 218, 28, 18397, 43.5616, 0.760293347436762, -93.4248, -1.6305703630172),
(24791, '56090', 218, 28, 114205, 43.9616, 0.767274664444739, -94.1684, -1.64354863133503),
(24792, '56091', 218, 28, 52455, 43.9352, 0.766813897522213, -93.6975, -1.63532987588739),
(24793, '56093', 218, 28, 138681, 44.0798, 0.769337643620596, -93.5025, -1.631926483846),
(24794, '56096', 218, 28, 25838, 44.2192, 0.771770632597877, -93.5684, -1.63307665582306),
(24795, '56097', 218, 28, 34376, 43.7423, 0.763447157395116, -93.7297, -1.63589187190653),
(24796, '56098', 218, 28, 122019, 43.7678, 0.763892216354374, -94.1704, -1.64358353792007),
(24797, '56101', 218, 28, 31547, 43.8717, 0.765705613447196, -95.1165, -1.66009609797319),
(24798, '56110', 218, 28, 18746, 43.6299, 0.761485407315874, -95.9349, -1.67437987257151),
(24799, '56111', 218, 28, 7072, 43.5872, 0.760740151725272, -94.9138, -1.65655831557939),
(24800, '56113', 218, 28, 18899, 44.4162, 0.775208931224305, -96.2016, -1.67903466568658),
(24801, '56114', 218, 28, 7207, 43.9479, 0.767035554337216, -95.6457, -1.66933238037474),
(24802, '56115', 218, 28, 134069, 44.233, 0.772011488034652, -95.8737, -1.67331173106929),
(24803, '56116', 218, 28, 15155, 43.6308, 0.761501115279142, -96.3723, -1.68201394271973),
(24804, '56117', 218, 28, 7481, 43.5429, 0.759966970866639, -95.632, -1.66909327026722),
(24805, '56118', 218, 28, 134269, 43.9054, 0.766293789405118, -95.0444, -1.6588377155825),
(24806, '56119', 218, 28, 15318, 43.694, 0.762604163366402, -95.4639, -1.66615937179461),
(24807, '56120', 218, 28, 7808, 43.9582, 0.767215323250171, -94.7937, -1.65446217514775),
(24808, '56121', 218, 28, 19924, 43.5328, 0.759790692612188, -94.6347, -1.65168710163708),
(24809, '56122', 218, 28, 656, 43.9302, 0.766726631059613, -95.9478, -1.67460502004502),
(24810, '56123', 218, 28, 59179, 44.0424, 0.768684890480351, -95.4336, -1.66563053703126),
(24811, '56125', 218, 28, 135047, 44.0509, 0.76883324346677, -95.5495, -1.66765337363432),
(24812, '56127', 218, 28, 135079, 43.5433, 0.759973952183647, -94.7944, -1.65447439245251),
(24813, '56128', 218, 28, 32304, 43.8741, 0.765747501349244, -96.1309, -1.67780071790542),
(24814, '56129', 218, 28, 579, 43.5186, 0.759542855858404, -96.0205, -1.67587387441122),
(24815, '56131', 218, 28, 29863, 43.8704, 0.76568292416692, -95.5994, -1.66852429293107),
(24816, '56132', 218, 28, 32532, 44.2169, 0.771730490025081, -95.7586, -1.67130285710024),
(24817, '56134', 218, 28, 2971, 43.7745, 0.764009153414258, -96.1983, -1.67897706982126),
(24818, '56136', 218, 28, 21835, 44.5036, 0.776734348990548, -96.4124, -1.68271381974978),
(24819, '56137', 218, 28, 135906, 43.7926, 0.764325058008869, -95.3186, -1.66362340839147),
(24820, '56138', 218, 28, 21948, 43.5273, 0.759694699503328, -96.3573, -1.68175214333193),
(24821, '56139', 218, 28, 9533, 44.0913, 0.769538356484576, -96.1885, -1.67880602755457),
(24822, '56140', 218, 28, 136059, 43.9061, 0.766306006709882, -96.3665, -1.68191271362312),
(24823, '56141', 218, 28, 16558, 43.9147, 0.766456105025554, -95.7837, -1.67174093474249),
(24824, '56142', 218, 28, 3375, 44.4606, 0.775983857412191, -96.2465, -1.67981831852072),
(24825, '56143', 218, 28, 3384, 43.6218, 0.761344035646462, -94.9903, -1.65789349245717),
(24826, '56144', 218, 28, 738, 43.8568, 0.765445559388649, -96.3944, -1.68239966048442),
(24827, '56145', 218, 28, 88158, 44.0579, 0.76895541651441, -95.1947, -1.66146094544825),
(24828, '56146', 218, 28, 136171, 43.5466, 0.760031548048963, -96.1089, -1.67741674546998),
(24829, '56147', 218, 28, 32913, 43.7617, 0.763785751270002, -96.1119, -1.67746910534754),
(24830, '56149', 218, 28, 136301, 44.2616, 0.772510652200722, -96.2867, -1.68051994088002),
(24831, '56150', 218, 28, 41689, 43.6735, 0.762246370869743, -95.1702, -1.66103333978151),
(24832, '56151', 218, 28, 136362, 44.0231, 0.768348041934716, -95.9972, -1.6754672126955),
(24833, '56152', 218, 28, 9967, 44.2277, 0.771918985584296, -95.2642, -1.66267394927838),
(24834, '56153', 218, 28, 30322, 43.8203, 0.764808514211671, -95.9976, -1.67547419401251),
(24835, '56155', 218, 28, 41815, 43.7177, 0.763017806399125, -95.9927, -1.67538867287916),
(24836, '56156', 218, 28, 3909, 43.6597, 0.762005515432968, -96.2102, -1.67918476400225),
(24837, '56157', 218, 28, 136623, 44.4142, 0.775174024639266, -95.9579, -1.67478129829947),
(24838, '56158', 218, 28, 3947, 43.6294, 0.761476680669614, -96.1124, -1.6774778319938),
(24839, '56159', 218, 28, 104492, 43.9397, 0.766892437338553, -94.9294, -1.65683058694271),
(24840, '56160', 218, 28, 28106, 43.8675, 0.765632309618613, -94.7424, -1.65356682124148),
(24841, '56161', 218, 28, 137264, 43.715, 0.762970682509321, -95.3468, -1.66411559124053),
(24842, '56162', 218, 28, 137291, 43.8468, 0.76527102646345, -94.6997, -1.65282156565087),
(24843, '56164', 218, 28, 137502, 43.9969, 0.767890765670693, -96.3178, -1.68106273827739),
(24844, '56165', 218, 28, 33727, 43.7123, 0.762923558619517, -95.7585, -1.67130111177099),
(24845, '56166', 218, 28, 68172, 44.2197, 0.771779359244137, -95.3645, -1.66442451451813),
(24846, '56167', 218, 28, 17861, 43.5407, 0.759928573623095, -95.4657, -1.66619078772115),
(24847, '56168', 218, 28, 137864, 43.6306, 0.761497624620638, -95.7539, -1.6712208266254),
(24848, '56169', 218, 28, 5580, 44.3215, 0.773556104422667, -95.9497, -1.6746381813008),
(24849, '56170', 218, 28, 977, 44.1749, 0.770997451739243, -96.1029, -1.67731202571486),
(24850, '56171', 218, 28, 138069, 43.6521, 0.761872870409817, -94.7254, -1.65327011526864),
(24851, '56172', 218, 28, 138147, 43.9871, 0.767719723403998, -95.7552, -1.67124351590567),
(24852, '56173', 218, 28, 98283, 43.5434, 0.759975697512899, -96.2321, -1.67956699110844),
(24853, '56174', 218, 28, 138312, 44.0389, 0.768623803956531, -95.3187, -1.66362515372072),
(24854, '56175', 218, 28, 38571, 44.2345, 0.772037667973432, -95.6177, -1.66884368818418),
(24855, '56176', 218, 28, 138478, 43.7619, 0.763789241928507, -94.7146, -1.65308161970942),
(24856, '56177', 218, 28, 138483, 43.8889, 0.766005810078539, -96.2555, -1.6799753981534),
(24857, '56178', 218, 28, 6437, 44.2746, 0.772737545003481, -96.1338, -1.67785133245372),
(24858, '56180', 218, 28, 72, 44.2387, 0.772110971802015, -95.5128, -1.66701283779884),
(24859, '56181', 218, 28, 12723, 43.6671, 0.762134669797616, -94.6207, -1.6514427555418),
(24860, '56183', 218, 28, 6730, 44.0427, 0.768690126468107, -95.4362, -1.66567591559181),
(24861, '56185', 218, 28, 14873, 43.7756, 0.76402835203603, -95.8332, -1.67260487272223),
(24862, '56186', 218, 28, 569, 43.9802, 0.76759929568561, -96.122, -1.67764538360199),
(24863, '56187', 218, 28, 31567, 43.624, 0.761382432890006, -95.6018, -1.66856618083311),
(24864, '56201', 218, 28, 138845, 45.1174, 0.78744717993929, -95.0414, -1.65878535570494),
(24865, '56207', 218, 28, 34519, 45.5422, 0.794861338601762, -96.0551, -1.67647775833241),
(24866, '56208', 218, 28, 7132, 45.2015, 0.788915001840217, -96.0181, -1.67583198650917),
(24867, '56209', 218, 28, 18960, 45.1278, 0.787628694181497, -94.8041, -1.65464368938996),
(24868, '56210', 218, 28, 26454, 45.5519, 0.795030635539205, -96.5588, -1.6852689817747),
(24869, '56211', 218, 28, 134139, 45.3207, 0.790995434308594, -96.4603, -1.68354983246149),
(24870, '56212', 218, 28, 79738, 45.1707, 0.788377440430603, -96.3292, -1.68126170581212),
(24871, '56214', 218, 28, 7395, 44.8111, 0.782101236440431, -95.5417, -1.66751723795267),
(24872, '56215', 218, 28, 642, 45.3151, 0.790897695870482, -95.6023, -1.66857490747938),
(24873, '56216', 218, 28, 134309, 44.9361, 0.784282898005424, -95.0638, -1.65917630945739),
(24874, '56218', 218, 28, 1069, 44.8489, 0.782760970897685, -95.9708, -1.67500644577297),
(24875, '56219', 218, 28, 29320, 45.648, 0.796707896950372, -96.7241, -1.68815401102825),
(24876, '56220', 218, 28, 35123, 44.7161, 0.780443173651036, -96.2646, -1.68013422311533),
(24877, '56221', 218, 28, 134666, 45.5717, 0.7953762107311, -96.1739, -1.67855120948377),
(24878, '56222', 218, 28, 134675, 44.9576, 0.784658143794603, -95.3674, -1.66447512906644),
(24879, '56223', 218, 28, 134684, 44.7945, 0.7818115117846, -95.807, -1.67214759645821),
(24880, '56224', 218, 28, 461, 44.4132, 0.775156571346746, -95.0473, -1.65888833013081),
(24881, '56225', 218, 28, 1630, 45.4598, 0.793423187298118, -96.4365, -1.68313444409951),
(24882, '56226', 218, 28, 134724, 45.3769, 0.791976309348215, -95.6797, -1.66992579232042),
(24883, '56227', 218, 28, 134813, 45.3045, 0.790712690969771, -96.1754, -1.67857738942255),
(24884, '56228', 218, 28, 134827, 44.9368, 0.784295115310188, -94.6971, -1.65277618709032),
(24885, '56229', 218, 28, 1802, 44.6044, 0.778493640876559, -95.6735, -1.66981758190679),
(24886, '56230', 218, 28, 134919, 44.8054, 0.782001752673067, -95.0577, -1.65906984437301),
(24887, '56231', 218, 28, 119312, 45.2845, 0.790363625119372, -95.7516, -1.6711806840526),
(24888, '56232', 218, 28, 1989, 44.9366, 0.784291624651684, -96.0632, -1.67661913000182),
(24889, '56235', 218, 28, 130518, 45.7162, 0.797898211500232, -96.1283, -1.67775533934487),
(24890, '56236', 218, 28, 115345, 45.7188, 0.797943590060784, -96.4233, -1.68290406063825),
(24891, '56237', 218, 28, 2207, 44.617, 0.77871355236231, -95.4146, -1.66529892447338),
(24892, '56239', 218, 28, 36085, 44.5143, 0.776921099220512, -95.8927, -1.67364334362717),
(24893, '56240', 218, 28, 16254, 45.5689, 0.795327341512044, -96.4374, -1.68315015206278),
(24894, '56241', 218, 28, 65139, 44.81, 0.782082037818659, -95.5483, -1.6676324296833),
(24895, '56243', 218, 28, 16293, 45.1513, 0.788038846555716, -94.6821, -1.65251438770252),
(24896, '56244', 218, 28, 9313, 45.4969, 0.794070704450608, -95.7928, -1.67189975970442),
(24897, '56245', 218, 28, 135786, 44.6923, 0.780027785289062, -95.6203, -1.66888906674473),
(24898, '56248', 218, 28, 9438, 45.8096, 0.799528349021594, -96.1403, -1.6779647788551),
(24899, '56249', 218, 28, 3196, 45.2826, 0.790330463863584, -95.9323, -1.67433449401096),
(24900, '56251', 218, 28, 136173, 45.1445, 0.78792016416658, -94.9225, -1.65671015922432),
(24901, '56252', 218, 28, 136213, 45.2387, 0.789564264321959, -95.313, -1.66352566995336),
(24902, '56253', 218, 28, 136335, 44.9709, 0.784890272585118, -94.8901, -1.65614467254667),
(24903, '56255', 218, 28, 136603, 44.4084, 0.77507279554265, -95.4096, -1.66521165801078),
(24904, '56256', 218, 28, 3938, 45.0132, 0.785628546858712, -96.1885, -1.67880602755457),
(24905, '56257', 218, 28, 3993, 44.9323, 0.784216575493848, -96.3992, -1.68248343628852),
(24906, '56258', 218, 28, 4011, 44.4455, 0.77572031269514, -95.7853, -1.67176886001052),
(24907, '56260', 218, 28, 4057, 44.9063, 0.78376278988833, -95.4682, -1.66623442095245),
(24908, '56262', 218, 28, 23084, 45.1094, 0.78730755359913, -95.9126, -1.67399066414831),
(24909, '56263', 218, 28, 30524, 44.4482, 0.775767436584944, -95.5513, -1.66768478956086),
(24910, '56264', 218, 28, 136899, 44.5616, 0.777746639956705, -95.985, -1.67525428252676),
(24911, '56265', 218, 28, 23156, 44.9495, 0.784516772125191, -95.7166, -1.6705698188144),
(24912, '56266', 218, 28, 4319, 44.4153, 0.775193223261037, -94.9259, -1.65676950041889),
(24913, '56267', 218, 28, 4333, 45.5864, 0.795632774131143, -95.9144, -1.67402208007485),
(24914, '56270', 218, 28, 10614, 44.5873, 0.778195189574468, -95.0408, -1.65877488372943),
(24915, '56271', 218, 28, 17219, 45.2245, 0.789316427568176, -95.3922, -1.66490797072093),
(24916, '56273', 218, 28, 4547, 45.3109, 0.790824392041899, -94.9893, -1.65787603916465),
(24917, '56274', 218, 28, 23394, 45.8908, 0.800945556374214, -96.1294, -1.67777453796664),
(24918, '56276', 218, 28, 14343, 45.3251, 0.791072228795682, -96.3013, -1.68077475895082),
(24919, '56277', 218, 28, 67498, 44.7752, 0.781474663238965, -94.9884, -1.65786033120138),
(24920, '56278', 218, 28, 117155, 45.3126, 0.790854062639183, -96.4421, -1.68323218253762),
(24921, '56279', 218, 28, 14387, 45.215, 0.789150621289236, -95.1699, -1.66102810379375),
(24922, '56280', 218, 28, 5186, 44.6749, 0.779724097999215, -96.1545, -1.67821261560889),
(24923, '56281', 218, 28, 137588, 44.9498, 0.784522008112947, -95.1755, -1.66112584223186),
(24924, '56282', 218, 28, 24225, 45.0242, 0.785820533076431, -95.1958, -1.66148014407002),
(24925, '56283', 218, 28, 137662, 44.5408, 0.77738361147229, -95.1098, -1.6599791609133),
(24926, '56284', 218, 28, 137680, 44.9122, 0.783865764314197, -95.1895, -1.66137018832714),
(24927, '56285', 218, 28, 77153, 44.7816, 0.781586364311093, -95.3617, -1.66437564529908),
(24928, '56287', 218, 28, 68616, 44.4817, 0.776352121884362, -95.3107, -1.66348552738056),
(24929, '56288', 218, 28, 138208, 45.2455, 0.789682946711094, -94.9504, -1.65719710608562),
(24930, '56289', 218, 28, 138346, 45.3295, 0.79114902328277, -95.1851, -1.66129339384005),
(24931, '56291', 218, 28, 126319, 44.5893, 0.778230096159508, -96.0554, -1.67648299432016),
(24932, '56292', 218, 28, 12549, 44.4995, 0.776662790491217, -95.4112, -1.66523958327881),
(24933, '56293', 218, 28, 18463, 44.402, 0.774961094470522, -95.2483, -1.66239644192731),
(24934, '56294', 218, 28, 28903, 44.3228, 0.773578793702943, -95.1789, -1.66118518342643),
(24935, '56295', 218, 28, 6657, 45.024, 0.785817042417927, -95.7933, -1.67190848635068),
(24936, '56296', 218, 28, 25985, 45.8046, 0.799441082558995, -96.4967, -1.68418513230921),
(24937, '56297', 218, 28, 44197, 44.6515, 0.779315690954248, -95.5399, -1.66748582202613),
(24938, '56301', 218, 28, 17896, 45.5333, 0.794706004298334, -94.2103, -1.64427992429161),
(24939, '56302', 218, 28, 17896, 45.5617, 0.7952016778059, -94.1651, -1.64349103546971),
(24940, '56303', 218, 28, 17896, 45.5837, 0.795585650241339, -94.2059, -1.64420312980453),
(24941, '56304', 218, 28, 17896, 45.5275, 0.794604775201718, -94.0667, -1.64177363148575),
(24942, '56307', 218, 28, 18772, 45.637, 0.796515910732652, -94.5785, -1.65070622659746),
(24943, '56308', 218, 28, 34524, 45.8906, 0.80094206571571, -95.3677, -1.6644803650542),
(24944, '56309', 218, 28, 92351, 46.0915, 0.804448432182966, -95.8178, -1.67233609201742),
(24945, '56310', 218, 28, 7208, 45.6265, 0.796332651161193, -94.4456, -1.64838668402156),
(24946, '56311', 218, 28, 149, 45.8904, 0.800938575057206, -95.8827, -1.67346881070197),
(24947, '56312', 218, 28, 53397, 45.4847, 0.793857774281865, -94.9548, -1.65727390057271),
(24948, '56313', 218, 28, 134336, 45.7858, 0.79911296065962, -93.5528, -1.63280438445975),
(24949, '56314', 218, 28, 134356, 45.7714, 0.798861633247333, -94.3556, -1.64681588769476),
(24950, '56315', 218, 28, 7653, 45.9659, 0.802256298642462, -95.5954, -1.66845447976099),
(24951, '56316', 218, 28, 134432, 45.5286, 0.79462397382349, -95.0892, -1.65961962308739),
(24952, '56317', 218, 28, 134459, 45.8984, 0.801078201397365, -94.0922, -1.64221869044501),
(24953, '56318', 218, 28, 134494, 45.6203, 0.796224440747569, -94.886, -1.65607311404734),
(24954, '56319', 218, 28, 58889, 45.9706, 0.802338329117305, -95.2916, -1.66315216949343),
(24955, '56320', 218, 28, 1686, 45.4585, 0.793400498017842, -94.4257, -1.64803936350041),
(24956, '56321', 218, 28, 8182, 45.5756, 0.795444278571928, -94.3694, -1.64705674313154),
(24957, '56323', 218, 28, 35485, 45.615, 0.796131938297213, -95.7367, -1.67092062999406),
(24958, '56324', 218, 28, 8391, 46.1515, 0.805495629734163, -95.8314, -1.67257345679569),
(24959, '56325', 218, 28, 135220, 45.5631, 0.795226112415428, -94.9472, -1.65714125554956),
(24960, '56326', 218, 28, 2341, 46.0062, 0.802959666331015, -95.6854, -1.67002527608778),
(24961, '56327', 218, 28, 75816, 45.7675, 0.798793565406505, -95.6253, -1.66897633320733),
(24962, '56328', 218, 28, 135379, 45.9508, 0.80199275392541, -94.5307, -1.649871959215),
(24963, '56329', 218, 28, 2510, 45.6884, 0.797413009968177, -93.9129, -1.63908931509618),
(24964, '56330', 218, 28, 47148, 45.7606, 0.798673137688117, -93.7775, -1.63672613928898),
(24965, '56331', 218, 28, 16142, 45.6812, 0.797287346262034, -94.6802, -1.65248122644674),
(24966, '56332', 218, 28, 9050, 46.021, 0.80321797506031, -95.458, -1.66605639736875),
(24967, '56333', 218, 28, 102246, 45.7444, 0.798390394349294, -93.9655, -1.64000735828273),
(24968, '56334', 218, 28, 2749, 45.6485, 0.796716623596632, -95.3841, -1.66476659905152),
(24969, '56335', 218, 28, 135709, 45.6011, 0.795889337531186, -94.8588, -1.6555983844908),
(24970, '56336', 218, 28, 135720, 45.8241, 0.799781421763134, -94.7493, -1.65368724895986),
(24971, '56338', 218, 28, 3141, 46.0343, 0.803450103850826, -93.8603, -1.63817127190963),
(24972, '56339', 218, 28, 27449, 45.8314, 0.799908830798529, -95.7893, -1.6718386731806),
(24973, '56340', 218, 28, 135974, 45.7363, 0.798249022679883, -94.4316, -1.64814233792628),
(24974, '56341', 218, 28, 135987, 45.8091, 0.799519622375334, -95.5729, -1.66806178067929),
(24975, '56342', 218, 28, 136104, 46.196, 0.8062723012513, -93.4896, -1.63170133637249),
(24976, '56343', 218, 28, 22347, 45.847, 0.80018110216184, -95.6958, -1.67020679032999),
(24977, '56344', 218, 28, 136413, 46.0394, 0.803539115642677, -94.0628, -1.64170556364492),
(24978, '56345', 218, 28, 103722, 45.9759, 0.802430831567661, -94.3633, -1.64695027804717),
(24979, '56347', 218, 28, 136578, 45.9709, 0.802343565105061, -94.8605, -1.65562805508808),
(24980, '56349', 218, 28, 10217, 45.7033, 0.797673064026724, -95.5206, -1.6671489734805),
(24981, '56350', 218, 28, 60831, 46.2889, 0.807893712126403, -93.2419, -1.6273781558153),
(24982, '56352', 218, 28, 4153, 45.6524, 0.796784691437459, -94.8065, -1.654685577292),
(24983, '56353', 218, 28, 136866, 45.7552, 0.79857888990851, -93.6506, -1.6345113164682),
(24984, '56354', 218, 28, 136887, 46.0426, 0.803594966178741, -95.2937, -1.66318882140772),
(24985, '56355', 218, 28, 4506, 45.9333, 0.801687321306311, -95.2195, -1.66189378710274),
(24986, '56356', 218, 28, 137088, 45.63, 0.796393737685013, -94.7523, -1.65373960883742),
(24987, '56357', 218, 28, 4691, 45.7039, 0.797683536002236, -93.8075, -1.63724973806458),
(24988, '56358', 218, 28, 137262, 45.8313, 0.799907085469277, -93.4238, -1.63055290972468),
(24989, '56359', 218, 28, 137276, 46.0731, 0.804127291600599, -93.6638, -1.63474169992946),
(24990, '56360', 218, 28, 137310, 45.8706, 0.800592999865311, -95.1654, -1.66094956397741),
(24991, '56361', 218, 28, 137383, 46.152, 0.805504356380423, -95.3304, -1.6638293572432),
(24992, '56362', 218, 28, 30790, 45.4062, 0.792487690819049, -94.7018, -1.65285821756517),
(24993, '56363', 218, 28, 56828, 45.6985, 0.797589288222629, -93.6489, -1.63448164587092),
(24994, '56364', 218, 28, 137455, 45.9796, 0.802495408749985, -94.0974, -1.64230944756611),
(24995, '56367', 218, 28, 5367, 45.754, 0.798557945957486, -94.154, -1.64329730392274),
(24996, '56368', 218, 28, 5381, 45.441, 0.793095065398743, -94.5288, -1.64983879795922),
(24997, '56369', 218, 28, 5479, 45.4688, 0.793580266930798, -94.3417, -1.64657328692873),
(24998, '56371', 218, 28, 24518, 45.4328, 0.79295194840008, -94.6367, -1.65172200822212),
(24999, '56372', 218, 28, 17896, 45.5662, 0.79528021762224, -94.2163, -1.64438464404673),
(25000, '56373', 218, 28, 28479, 45.8314, 0.799908830798529, -94.2895, -1.64566222505919),
(25001, '56374', 218, 28, 488, 45.5857, 0.795620556826379, -94.3274, -1.6463237048457),
(25002, '56375', 218, 28, 51183, 45.7014, 0.797639902770937, -94.2698, -1.64531839519655),
(25003, '56376', 218, 28, 51175, 45.5017, 0.794154480254704, -94.6647, -1.65221070041268),
(25004, '56377', 218, 28, 137994, 45.6212, 0.796240148710837, -94.2088, -1.64425374435283),
(25005, '56378', 218, 28, 137996, 45.711, 0.797807454379128, -94.9621, -1.65740130960811),
(25006, '56379', 218, 28, 137999, 45.6189, 0.796200006138041, -94.1176, -1.64266200407502),
(25007, '56381', 218, 28, 138270, 45.613, 0.796097031712174, -95.5301, -1.66731477975944),
(25008, '56382', 218, 28, 31272, 45.9481, 0.801945630035606, -94.6259, -1.6515335126629),
(25009, '56384', 218, 28, 138533, 45.8121, 0.799571982252894, -94.581, -1.65074985982876),
(25010, '56385', 218, 28, 138590, 45.6875, 0.797397302004909, -95.1181, -1.66012402324122),
(25011, '56386', 218, 28, 138627, 46.0647, 0.803980683943432, -93.4962, -1.63181652810312),
(25012, '56387', 218, 28, 138631, 45.5524, 0.795039362185465, -94.2165, -1.64438813470524),
(25013, '56388', 218, 28, 138631, 45.5575, 0.795128373977317, -94.2244, -1.64452601571615),
(25014, '56389', 218, 28, 28946, 45.7987, 0.799338108133127, -95.0805, -1.65946777944247),
(25015, '56393', 218, 28, 17896, 45.5658, 0.795273236305232, -94.2168, -1.64439337069299),
(25016, '56395', 218, 28, 17896, 45.561, 0.795189460501136, -94.1641, -1.64347358217719),
(25017, '56396', 218, 28, 17896, 45.567, 0.795294180256256, -94.2107, -1.64428690560862),
(25018, '56397', 218, 28, 17896, 45.4805, 0.793784470453281, -94.2524, -1.6450147079067),
(25019, '56398', 218, 28, 17896, 45.4809, 0.793791451770289, -94.2525, -1.64501645323596),
(25020, '56399', 218, 28, 17896, 45.5495, 0.794988747637157, -94.2299, -1.644622008825),
(25021, '56401', 218, 28, 31880, 46.3512, 0.808981052250396, -94.1639, -1.64347009151869),
(25022, '56425', 218, 28, 150, 46.3433, 0.808843171239488, -94.2864, -1.64560811985238),
(25023, '56430', 218, 28, 0, 46.3827, 0.809530830964774, -94.3607, -1.64690489948661),
(25024, '56431', 218, 28, 133867, 46.5319, 0.812134862208749, -93.7078, -1.63550964480034),
(25025, '56433', 218, 28, 133871, 47.0203, 0.82065905027549, -94.7258, -1.65327709658564),
(25026, '56434', 218, 28, 53148, 46.4123, 0.810047448423364, -94.9675, -1.65749555738772),
(25027, '56435', 218, 28, 108063, 46.8575, 0.817817654253243, -94.3689, -1.64704801648528),
(25028, '56436', 218, 28, 19194, 47.1581, 0.823064113984738, -94.6901, -1.65265401404268),
(25029, '56437', 218, 28, 399, 46.218, 0.806656273686739, -95.0492, -1.65892149138659),
(25030, '56438', 218, 28, 134434, 46.0862, 0.804355929732611, -94.8692, -1.655779898733),
(25031, '56440', 218, 28, 134681, 46.1294, 0.805109911969472, -94.9515, -1.6572163047074),
(25032, '56441', 218, 28, 1897, 46.4816, 0.811256961594996, -93.9574, -1.63986598661332),
(25033, '56442', 218, 28, 0, 46.7258, 0.815519055628366, -94.0507, -1.64149437880543),
(25034, '56443', 218, 28, 75594, 46.1949, 0.806253102629529, -94.5707, -1.6505700909158),
(25035, '56444', 218, 28, 13637, 46.4744, 0.811131297888853, -93.9055, -1.63896016073154),
(25036, '56446', 218, 28, 59730, 46.161, 0.805661436013102, -95.0285, -1.65856020823143),
(25037, '56447', 218, 28, 135230, 46.7595, 0.816107231586289, -93.9032, -1.63892001815874),
(25038, '56448', 218, 28, 135358, 46.8032, 0.81686994046941, -94.0164, -1.640895730872),
(25039, '56449', 218, 28, 135424, 46.205, 0.80642938088398, -94.2286, -1.64459931954473),
(25040, '56450', 218, 28, 27246, 46.2436, 0.80710307797525, -93.9362, -1.6394959768119),
(25041, '56452', 218, 28, 135744, 47.0016, 0.820332673705367, -94.5006, -1.64934661511015),
(25042, '56453', 218, 28, 65527, 46.3259, 0.808539483949641, -95.0293, -1.65857417086545),
(25043, '56455', 218, 28, 9671, 46.4779, 0.811192384412673, -93.976, -1.64019061785419),
(25044, '56456', 218, 28, 3417, 46.6501, 0.814197841384607, -94.3345, -1.64644762322259),
(25045, '56458', 218, 28, 131640, 47.2827, 0.825238794232723, -95.047, -1.65888309414305),
(25046, '56459', 218, 28, 136330, 46.502, 0.811613008762403, -94.2574, -1.6451019743693),
(25047, '56461', 218, 28, 122986, 47.2372, 0.824444669423065, -94.7907, -1.65440981527019),
(25048, '56464', 218, 28, 136836, 46.7608, 0.816129920866565, -94.9745, -1.65761773043535),
(25049, '56465', 218, 28, 37170, 46.4615, 0.810906150415345, -94.1716, -1.64360448187109),
(25050, '56466', 218, 28, 4356, 46.3029, 0.808138058221682, -94.5648, -1.65046711648993),
(25051, '56467', 218, 28, 137060, 46.8764, 0.81814752148187, -94.8063, -1.6546820866335),
(25052, '56468', 218, 28, 137139, 46.5063, 0.811688057920239, -94.2798, -1.64549292812175),
(25053, '56469', 218, 28, 137363, 46.7276, 0.815550471554902, -93.6111, -1.63382191141366),
(25054, '56470', 218, 28, 137374, 46.9213, 0.818931174316015, -95.0549, -1.65902097515396),
(25055, '56472', 218, 28, 137428, 46.5968, 0.813267580893294, -94.2782, -1.64546500285372),
(25056, '56473', 218, 28, 137462, 46.2935, 0.807973997271995, -94.3321, -1.64640573532054),
(25057, '56474', 218, 28, 132625, 46.7486, 0.815916990697821, -94.3757, -1.64716669887441),
(25058, '56475', 218, 28, 11462, 46.0642, 0.803971957297172, -94.5185, -1.64965902904626),
(25059, '56477', 218, 28, 138033, 46.628, 0.813812123619916, -95.0924, -1.65967547362346),
(25060, '56478', 218, 28, 10811, 46.638, 0.813986656545115, -94.881, -1.65598584758474),
(25061, '56479', 218, 28, 43197, 46.3556, 0.809057846737483, -94.7945, -1.65447613778176),
(25062, '56481', 218, 28, 138575, 46.3977, 0.809792630352573, -95.0127, -1.65828444620962),
(25063, '56482', 218, 28, 77568, 46.4386, 0.810506470016639, -95.1389, -1.66048705172563),
(25064, '56484', 218, 28, 12598, 47.1232, 0.822454994075792, -94.6073, -1.65120888142203),
(25065, '56501', 218, 28, 135002, 46.8148, 0.817072398662641, -95.847, -1.67284572815901),
(25066, '56502', 218, 28, 135002, 46.8176, 0.817121267881697, -95.845, -1.67281082157397),
(25067, '56510', 218, 28, 7026, 47.2982, 0.825509320266782, -96.5119, -1.68445042235552),
(25068, '56511', 218, 28, 15055, 46.8625, 0.817904920715843, -95.9826, -1.67521239462471),
(25069, '56514', 218, 28, 19061, 46.6528, 0.814244965274411, -96.4168, -1.68279061423687),
(25070, '56515', 218, 28, 134119, 46.2851, 0.807827389614827, -95.7127, -1.67050175097358),
(25071, '56516', 218, 28, 134168, 47.4556, 0.828256468509421, -95.936, -1.67439907119328),
(25072, '56517', 218, 28, 134196, 47.8004, 0.834274363770298, -96.436, -1.68312571745325),
(25073, '56518', 218, 28, 1018, 46.4999, 0.811576356848111, -95.2179, -1.66186586183471),
(25074, '56519', 218, 28, 134352, 47.1944, 0.823697668503212, -96.5623, -1.68533006829852),
(25075, '56520', 218, 28, 26597, 46.2672, 0.80751497567872, -96.5862, -1.68574720198975),
(25076, '56521', 218, 28, 15401, 47.0209, 0.820669522251002, -96.0001, -1.67551782724381),
(25077, '56522', 218, 28, 1317, 46.1206, 0.804956322995297, -96.4409, -1.6832112385866),
(25078, '56523', 218, 28, 20102, 47.6096, 0.830944275557492, -96.8148, -1.68973702465981),
(25079, '56524', 218, 28, 134721, 46.3253, 0.808529011974129, -95.5934, -1.66841957317595),
(25080, '56525', 218, 28, 130316, 46.6753, 0.814637664356109, -96.7421, -1.68846817029361),
(25081, '56527', 218, 28, 8452, 46.4129, 0.810057920398876, -95.2806, -1.66296018327571),
(25082, '56528', 218, 28, 54414, 46.5423, 0.812316376450957, -95.7823, -1.67171650013296),
(25083, '56529', 218, 28, 2045, 46.8774, 0.81816497477439, -96.7015, -1.6877595666173),
(25084, '56531', 218, 28, 130640, 45.9912, 0.802697866943216, -95.9721, -1.67502913505325),
(25085, '56533', 218, 28, 8719, 46.41, 0.810007305850568, -96.092, -1.67712178482639),
(25086, '56534', 218, 28, 135249, 46.4999, 0.811576356848111, -96.0311, -1.67605887931193),
(25087, '56535', 218, 28, 135258, 47.6655, 0.831919914609357, -96.0081, -1.67565745358397),
(25088, '56536', 218, 28, 8869, 47.0537, 0.821241990245656, -96.4962, -1.68417640566295),
(25089, '56537', 218, 28, 135350, 46.2853, 0.807830880273331, -96.0726, -1.6767831909515),
(25090, '56538', 218, 28, 135350, 46.2831, 0.807792483029787, -96.0736, -1.67680064424402),
(25091, '56540', 218, 28, 54748, 47.5397, 0.829724290410348, -96.2899, -1.68057579141609),
(25092, '56541', 218, 28, 135382, 47.1666, 0.823212466971157, -96.1308, -1.67779897257616),
(25093, '56542', 218, 28, 135430, 47.5788, 0.830406714147878, -95.7507, -1.67116497608933),
(25094, '56543', 218, 28, 135448, 46.2521, 0.807251430961669, -96.3215, -1.68112731545972),
(25095, '56544', 218, 28, 135462, 46.7361, 0.815698824541322, -95.7157, -1.67055411085114),
(25096, '56545', 218, 28, 16182, 47.3685, 0.826736286730934, -96.195, -1.67891947395595),
(25097, '56546', 218, 28, 2693, 47.1085, 0.822198430675749, -96.6931, -1.68761295896013),
(25098, '56547', 218, 28, 47524, 46.8732, 0.818091670945806, -96.5775, -1.68559535834482),
(25099, '56548', 218, 28, 135762, 47.3519, 0.826446562075103, -96.8252, -1.68991853890201),
(25100, '56549', 218, 28, 76047, 46.8822, 0.818248750578486, -96.3206, -1.68111160749645),
(25101, '56550', 218, 28, 135889, 47.2641, 0.824914162991852, -96.8104, -1.68966023017272),
(25102, '56551', 218, 28, 87694, 46.3244, 0.808513304010861, -95.3443, -1.66407195800923),
(25103, '56552', 218, 28, 135959, 47.02, 0.820653814287734, -96.3146, -1.68100688774133),
(25104, '56553', 218, 28, 3501, 46.4261, 0.810288303860139, -96.6784, -1.68735639556009),
(25105, '56554', 218, 28, 16802, 46.8256, 0.817260894221857, -96.0799, -1.6769105999869),
(25106, '56556', 218, 28, 4100, 47.6377, 0.831434713077303, -95.8872, -1.67354735051831),
(25107, '56557', 218, 28, 136652, 47.3055, 0.825636729302178, -95.9615, -1.67484413015254),
(25108, '56560', 218, 28, 60944, 46.866, 0.817966007239663, -96.7534, -1.68866539249908),
(25109, '56561', 218, 28, 60944, 46.9253, 0.819000987486095, -96.7122, -1.68794631684726),
(25110, '56562', 218, 28, 60944, 46.8623, 0.817901430057339, -96.7657, -1.68888006799708),
(25111, '56563', 218, 28, 60944, 46.8652, 0.817952044605647, -96.7581, -1.68874742297393),
(25112, '56565', 218, 28, 17237, 46.0603, 0.803903889456344, -96.3464, -1.68156190244346),
(25113, '56566', 218, 28, 137043, 47.238, 0.824458632057081, -95.6152, -1.66880005495288),
(25114, '56567', 218, 28, 137106, 46.5162, 0.811860845516186, -95.3666, -1.66446116643242),
(25115, '56568', 218, 28, 137129, 47.5424, 0.829771414300152, -96.7173, -1.68803532863911),
(25116, '56569', 218, 28, 137259, 47.1078, 0.822186213370985, -95.9997, -1.6755108459268),
(25117, '56570', 218, 28, 11002, 46.9343, 0.819158067118775, -95.2247, -1.66198454422384),
(25118, '56571', 218, 28, 137344, 46.4124, 0.810049193752616, -95.5313, -1.66733572371046),
(25119, '56572', 218, 28, 137408, 46.569, 0.812782379361239, -96.0823, -1.67695248788895),
(25120, '56573', 218, 28, 128517, 46.5942, 0.813222202332742, -95.5755, -1.66810715923984),
(25121, '56574', 218, 28, 137437, 47.1949, 0.823706395149472, -96.7614, -1.68880501883924),
(25122, '56575', 218, 28, 137545, 47.0394, 0.820992408162621, -95.3071, -1.66342269552749),
(25123, '56576', 218, 28, 5378, 46.4986, 0.811553667567835, -95.5945, -1.66843877179772),
(25124, '56577', 218, 28, 24311, 46.9382, 0.819226134959602, -95.8618, -1.6731040368883),
(25125, '56578', 218, 28, 137748, 46.8714, 0.81806025501927, -95.5973, -1.66848764101678),
(25126, '56579', 218, 28, 137836, 46.4728, 0.811103372620821, -96.2776, -1.68036111591809),
(25127, '56580', 218, 28, 137879, 46.7789, 0.816445825461175, -96.6545, -1.68693926186886),
(25128, '56581', 218, 28, 24813, 47.4557, 0.828258213838673, -96.7192, -1.6880684898949),
(25129, '56583', 218, 28, 138443, 45.9788, 0.802481446115969, -96.4183, -1.68281679417565),
(25130, '56584', 218, 28, 74584, 47.2846, 0.825271955488511, -96.2642, -1.68012724179833),
(25131, '56585', 218, 28, 123840, 47.0784, 0.821673086570898, -96.2572, -1.68000506875069),
(25132, '56586', 218, 28, 6443, 46.3254, 0.808530757303381, -95.8386, -1.67269912050184),
(25133, '56587', 218, 28, 138559, 46.6728, 0.814594031124809, -95.7944, -1.67192768497246),
(25134, '56588', 218, 28, 34279, 46.2384, 0.807012320854146, -95.5832, -1.66824154959224),
(25135, '56589', 218, 28, 138712, 47.194, 0.823690687186204, -95.873, -1.67329951376452),
(25136, '56590', 218, 28, 69974, 46.0649, 0.803984174601936, -96.1415, -1.67798572280613),
(25137, '56591', 218, 28, 138811, 47.0962, 0.821983755177753, -95.8425, -1.67276718834267),
(25138, '56592', 218, 28, 138879, 47.6314, 0.831324757334427, -95.8888, -1.67357527578634),
(25139, '56593', 218, 28, 29014, 46.8345, 0.817416228525284, -95.368, -1.66448560104195),
(25140, '56594', 218, 28, 138915, 46.546, 0.812380953633281, -96.5754, -1.68555870643053),
(25141, '56601', 218, 28, 134203, 47.5044, 0.829108189184394, -94.8572, -1.65557045922277),
(25142, '56619', 218, 28, 134203, 47.4734, 0.828567137116276, -94.8798, -1.65596490363372),
(25143, '56621', 218, 28, 44547, 47.5232, 0.829436311083769, -95.3983, -1.66501443580531),
(25144, '56623', 218, 28, 134123, 48.7028, 0.850024214940294, -94.6578, -1.65209027269429),
(25145, '56626', 218, 28, 112621, 47.3127, 0.825762393008321, -94.208, -1.64423978171882),
(25146, '56627', 218, 28, 134249, 48.1574, 0.840505189199917, -93.8637, -1.6382306131042),
(25147, '56628', 218, 28, 134266, 47.7632, 0.833625101288556, -93.7058, -1.6354747382153),
(25148, '56629', 218, 28, 99931, 48.5615, 0.847558064707226, -94.2384, -1.64477036181142),
(25149, '56630', 218, 28, 134299, 47.8152, 0.834532672499593, -94.5386, -1.65000984022591),
(25150, '56631', 218, 28, 134358, 47.5436, 0.829792358251176, -93.7969, -1.63706473316387),
(25151, '56633', 218, 28, 134591, 47.3792, 0.826923036960897, -94.6042, -1.65115477621522),
(25152, '56634', 218, 28, 100875, 47.832, 0.834825887813928, -95.3156, -1.66357104851391);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(25153, '56636', 218, 28, 134961, 47.3626, 0.826633312305066, -93.7903, -1.63694954143324),
(25154, '56637', 218, 28, 138391, 47.5913, 0.830624880304377, -93.7754, -1.63668948737469),
(25155, '56639', 218, 28, 40775, 47.8549, 0.835225568212634, -93.6213, -1.63399993499737),
(25156, '56641', 218, 28, 135343, 47.1975, 0.823751773710024, -94.2385, -1.64477210714068),
(25157, '56644', 218, 28, 135603, 47.8473, 0.835092923189483, -95.4816, -1.66646829507222),
(25158, '56646', 218, 28, 135737, 47.8041, 0.834338940952621, -95.6433, -1.66929049247269),
(25159, '56647', 218, 28, 3160, 47.7592, 0.833555288118476, -94.6772, -1.65242886656918),
(25160, '56649', 218, 28, 136074, 48.5843, 0.847955999776681, -93.4146, -1.63039233943349),
(25161, '56650', 218, 28, 136190, 47.9603, 0.837065145244236, -94.4823, -1.64902721985704),
(25162, '56651', 218, 28, 136463, 47.5437, 0.829794103580428, -95.6181, -1.66885066950119),
(25163, '56652', 218, 28, 3733, 47.6306, 0.831310794700411, -95.3689, -1.66450130900522),
(25164, '56653', 218, 28, 136556, 48.2734, 0.842529771132231, -93.3828, -1.62983732473136),
(25165, '56654', 218, 28, 136565, 48.519, 0.846816299775129, -93.8964, -1.6388013357696),
(25166, '56655', 218, 28, 41862, 47.0666, 0.821467137719163, -94.1582, -1.64337060775132),
(25167, '56657', 218, 28, 136732, 47.6389, 0.831455657028327, -93.6674, -1.63480453178254),
(25168, '56658', 218, 28, 96000, 48.0958, 0.839430066380689, -93.94, -1.63956229932347),
(25169, '56659', 218, 28, 56134, 47.6301, 0.831302068054151, -93.9854, -1.64035467880388),
(25170, '56660', 218, 28, 71126, 47.9884, 0.837555582764047, -94.2147, -1.6443567187787),
(25171, '56661', 218, 28, 137200, 47.8298, 0.834787490570384, -94.1455, -1.64314895093632),
(25172, '56662', 218, 28, 137348, 46.8462, 0.817620432047768, -93.9026, -1.63890954618323),
(25173, '56663', 218, 28, 4945, 47.4547, 0.828240760546153, -94.4798, -1.64898358662574),
(25174, '56666', 218, 28, 121081, 48.0753, 0.83907227388403, -94.85, -1.65544479551662),
(25175, '56667', 218, 28, 137602, 47.7378, 0.833181787658549, -94.9998, -1.65805929873611),
(25176, '56668', 218, 28, 137630, 48.6147, 0.848486579869287, -93.3481, -1.62923169548092),
(25177, '56669', 218, 28, 136166, 48.4472, 0.845563153372197, -93.0468, -1.62397301844466),
(25178, '56670', 218, 28, 137657, 47.8569, 0.835260474797674, -94.9234, -1.65672586718759),
(25179, '56671', 218, 28, 0, 47.8483, 0.835110376482003, -95.0629, -1.65916060149412),
(25180, '56672', 218, 28, 137671, 47.086, 0.82180573159405, -93.8987, -1.6388414783424),
(25181, '56673', 218, 28, 5534, 48.7813, 0.85139429840311, -95.25, -1.6624261125246),
(25182, '56676', 218, 28, 138082, 47.7797, 0.833913080615135, -95.1324, -1.66037360532425),
(25183, '56678', 218, 28, 38276, 47.5433, 0.82978712226342, -95.1197, -1.66015194850925),
(25184, '56679', 218, 28, 138182, 48.5882, 0.848024067617509, -93.3983, -1.63010785076542),
(25185, '56680', 218, 28, 14657, 47.5867, 0.830544595158786, -93.8434, -1.63787631126605),
(25186, '56681', 218, 28, 138250, 47.6295, 0.831291596078639, -94.1765, -1.64369000300444),
(25187, '56682', 218, 28, 6197, 48.8433, 0.852476402539346, -95.287, -1.66307188434784),
(25188, '56683', 218, 28, 138417, 47.6601, 0.831825666829749, -94.684, -1.65254754895831),
(25189, '56684', 218, 28, 57935, 47.7609, 0.83358495871576, -95.7716, -1.671529749903),
(25190, '56685', 218, 28, 138691, 48.1958, 0.841175395632683, -94.4827, -1.64903420117405),
(25191, '56686', 218, 28, 878, 48.8163, 0.852005163641308, -94.9593, -1.65735244038905),
(25192, '56687', 218, 28, 287, 47.5248, 0.829464236351801, -94.9957, -1.65798774023678),
(25193, '56688', 218, 28, 31549, 47.72, 0.832871119051694, -93.9642, -1.63998466900246),
(25194, '56701', 218, 28, 138426, 48.1171, 0.839801821511364, -96.1716, -1.67851106691098),
(25195, '56710', 218, 28, 92229, 48.2281, 0.841739136981077, -96.9554, -1.69219095758811),
(25196, '56711', 218, 28, 133950, 49.3105, 0.860630580804664, -95.0943, -1.65970863487924),
(25197, '56713', 218, 28, 15022, 48.3326, 0.843563006049411, -96.8229, -1.68987839632922),
(25198, '56714', 218, 28, 31716, 48.8568, 0.852712021988366, -96.2062, -1.67911495083217),
(25199, '56715', 218, 28, 1162, 47.804, 0.834337195623369, -96.0307, -1.67605189799492),
(25200, '56716', 218, 28, 134859, 47.7739, 0.833811851518519, -96.6061, -1.68609452251089),
(25201, '56720', 218, 28, 8558, 48.588, 0.848020576959005, -96.863, -1.69057827335927),
(25202, '56721', 218, 28, 135109, 47.9301, 0.836538055810134, -97.0176, -1.69327655238285),
(25203, '56722', 218, 28, 8787, 48.0501, 0.838632450912527, -96.8923, -1.6910896548301),
(25204, '56723', 218, 28, 8891, 47.7998, 0.834263891794785, -96.7987, -1.68945602665024),
(25205, '56724', 218, 28, 135526, 48.4148, 0.844997666694551, -95.7945, -1.67192943030171),
(25206, '56725', 218, 28, 135615, 48.0612, 0.838826182459499, -95.714, -1.67052444025385),
(25207, '56726', 218, 28, 32623, 48.7209, 0.850340119534905, -96.207, -1.67912891346618),
(25208, '56727', 218, 28, 135734, 48.2813, 0.842667652143138, -95.3791, -1.66467933258892),
(25209, '56728', 218, 28, 119902, 48.774, 0.851266889367714, -96.942, -1.69195708346834),
(25210, '56729', 218, 28, 135760, 48.6731, 0.849505852152452, -96.583, -1.68569135145368),
(25211, '56731', 218, 28, 27486, 48.9215, 0.853841250014406, -97.0933, -1.69459776662661),
(25212, '56732', 218, 28, 136178, 48.5772, 0.847832081399789, -96.5284, -1.68473840168209),
(25213, '56733', 218, 28, 3499, 48.6344, 0.84883040973193, -96.9792, -1.69260634595008),
(25214, '56734', 218, 28, 136304, 48.8456, 0.852516545112142, -96.5625, -1.68533355895702),
(25215, '56735', 218, 28, 16841, 48.9113, 0.853663226430702, -96.8426, -1.69022222619186),
(25216, '56736', 218, 28, 30487, 47.6729, 0.832049068974005, -96.2092, -1.67916731070973),
(25217, '56737', 218, 28, 17116, 48.4568, 0.845730704980388, -96.0596, -1.67655629814875),
(25218, '56738', 218, 28, 137110, 48.2782, 0.842613546936326, -96.2083, -1.67915160274646),
(25219, '56740', 218, 28, 137221, 48.9762, 0.854795945115247, -97.1426, -1.69545821394784),
(25220, '56741', 218, 28, 67355, 49.3122, 0.860660251401948, -94.8672, -1.65574499214796),
(25221, '56742', 218, 28, 137266, 47.8379, 0.834928862239795, -95.8527, -1.67294521192637),
(25222, '56744', 218, 28, 17457, 48.2277, 0.841732155664069, -97.0852, -1.6944563949572),
(25223, '56748', 218, 28, 17672, 47.9065, 0.836126158106663, -95.9025, -1.67381438589386),
(25224, '56750', 218, 28, 137650, 47.8848, 0.835747421658981, -96.2714, -1.68025290550447),
(25225, '56751', 218, 28, 137806, 48.7681, 0.851163914941847, -95.6703, -1.66976173137073),
(25226, '56754', 218, 28, 137913, 48.0016, 0.83778596622531, -96.2759, -1.68033144532081),
(25227, '56755', 218, 28, 11764, 48.938, 0.854129229340985, -97.1636, -1.69582473309076),
(25228, '56756', 218, 28, 137972, 48.8422, 0.852457203917574, -95.5489, -1.66764290165881),
(25229, '56757', 218, 28, 61881, 48.4696, 0.845954107124644, -96.8704, -1.69070742772392),
(25230, '56758', 218, 28, 138318, 48.4573, 0.845739431626648, -96.4524, -1.68341195145058),
(25231, '56759', 218, 28, 138320, 48.6243, 0.848654131477479, -96.1157, -1.67753542785911),
(25232, '56760', 218, 28, 18449, 48.2385, 0.841920651223285, -96.496, -1.68417291500445),
(25233, '56761', 218, 28, 138666, 48.6285, 0.848727435306063, -95.7326, -1.67084907149472),
(25234, '56762', 218, 28, 12663, 48.1975, 0.841205066229967, -96.7717, -1.6889847877522),
(25235, '56763', 218, 28, 138677, 48.9056, 0.853563742663339, -95.3199, -1.66364609767174),
(25236, '57001', 218, 49, 169703, 43.0254, 0.750934891987568, -96.6223, -1.68637726584972),
(25237, '57002', 218, 49, 474, 44.2905, 0.773015052354549, -96.7138, -1.68797424211529),
(25238, '57003', 218, 49, 62687, 43.7491, 0.763565839784251, -96.7354, -1.68835123323372),
(25239, '57004', 218, 49, 15197, 43.0718, 0.751744724760494, -96.7758, -1.68905634625153),
(25240, '57005', 218, 49, 7653, 43.5902, 0.760792511602832, -96.5801, -1.68564073690538),
(25241, '57006', 218, 49, 7700, 44.3019, 0.773214019889276, -96.7887, -1.68928149372504),
(25242, '57007', 218, 49, 7700, 44.3065, 0.773294305034868, -96.7867, -1.68924658714),
(25243, '57010', 218, 49, 1232, 42.6047, 0.743592291824428, -96.5625, -1.68533355895702),
(25244, '57012', 218, 49, 169955, 43.5976, 0.76092166596748, -97.2927, -1.69807795315509),
(25245, '57013', 218, 49, 19763, 43.3041, 0.755799124612876, -96.5948, -1.68589730030542),
(25246, '57014', 218, 49, 1459, 43.1441, 0.753006597809686, -96.9897, -1.69278960552154),
(25247, '57015', 218, 49, 1483, 43.3703, 0.756954532577697, -96.9829, -1.69267092313241),
(25248, '57016', 218, 49, 8056, 43.8916, 0.766052933968343, -97.0091, -1.69312819939643),
(25249, '57017', 218, 49, 170057, 43.9821, 0.767632456941398, -96.8144, -1.6897300433428),
(25250, '57018', 218, 49, 93382, 43.787, 0.764227319570757, -96.9273, -1.6917005200683),
(25251, '57020', 218, 49, 170102, 43.6617, 0.762040422018008, -96.8095, -1.68964452220945),
(25252, '57021', 218, 49, 20476, 43.2891, 0.755537325225077, -96.9847, -1.69270233905894),
(25253, '57022', 218, 49, 170144, 43.8252, 0.764894035345019, -96.7173, -1.68803532863911),
(25254, '57024', 218, 49, 928, 43.9981, 0.767911709621717, -96.6463, -1.6867961448702),
(25255, '57025', 218, 49, 170223, 42.6852, 0.744997281872284, -96.6841, -1.68745587932745),
(25256, '57026', 218, 49, 15918, 44.2347, 0.772041158631936, -96.481, -1.68391111561665),
(25257, '57027', 218, 49, 500, 43.2092, 0.754142807152734, -96.5912, -1.68583446845235),
(25258, '57028', 218, 49, 170303, 44.047, 0.768765175625942, -96.5965, -1.6859269709027),
(25259, '57029', 218, 49, 21295, 43.3482, 0.756568814813006, -97.4314, -1.7004987248276),
(25260, '57030', 218, 49, 170363, 43.7141, 0.762954974546053, -96.5015, -1.68426890811331),
(25261, '57031', 218, 49, 149074, 42.8878, 0.748533318936824, -97.1732, -1.69599228469895),
(25262, '57032', 218, 49, 2994, 43.4296, 0.757989512824129, -96.6972, -1.68768451745946),
(25263, '57033', 218, 49, 2998, 43.629, 0.761469699352606, -96.9432, -1.69197802741937),
(25264, '57034', 218, 49, 16505, 43.1295, 0.752751779738894, -96.4568, -1.68348874593767),
(25265, '57035', 218, 49, 27486, 43.7094, 0.76287294407121, -96.8893, -1.69103729495254),
(25266, '57036', 218, 49, 3300, 43.2935, 0.755614119712165, -97.2219, -1.69684226004468),
(25267, '57037', 218, 49, 41492, 43.1157, 0.752510924302119, -97.2867, -1.69797323339997),
(25268, '57038', 218, 49, 3409, 42.5751, 0.743075674365838, -96.5412, -1.68496180382635),
(25269, '57039', 218, 49, 136465, 43.3535, 0.756661317263362, -96.8954, -1.69114376003691),
(25270, '57040', 218, 49, 10053, 43.0742, 0.751786612662541, -97.5463, -1.70250410813814),
(25271, '57041', 218, 49, 764, 43.7849, 0.764190667656465, -96.9277, -1.69170750138531),
(25272, '57042', 218, 49, 3938, 44.007, 0.768067043925145, -97.1133, -1.69494683247701),
(25273, '57043', 218, 49, 630, 43.4224, 0.757863849117986, -97.2588, -1.69748628653866),
(25274, '57044', 218, 49, 170850, 42.8661, 0.748154582489141, -97.101, -1.69473215697901),
(25275, '57045', 218, 49, 164470, 43.2375, 0.754636735331048, -97.5768, -1.70303643356),
(25276, '57046', 218, 49, 170895, 42.9981, 0.750458417101774, -97.3372, -1.69885462467222),
(25277, '57047', 218, 49, 10560, 43.4802, 0.758872649425639, -97.2192, -1.69679513615487),
(25278, '57048', 218, 49, 4299, 43.7004, 0.76271586443853, -97.1852, -1.69620172420919),
(25279, '57049', 218, 49, 170958, 42.5413, 0.742485753078664, -96.5081, -1.68438409984394),
(25280, '57050', 218, 49, 151314, 44.1531, 0.770616969962308, -97.0092, -1.69312994472568),
(25281, '57051', 218, 49, 37514, 44.4373, 0.775577195696476, -97.5515, -1.70259486525925),
(25282, '57052', 218, 49, 28135, 43.2838, 0.755444822774722, -97.7336, -1.70577310982713),
(25283, '57053', 218, 49, 4872, 43.3964, 0.757410063512467, -97.1377, -1.6953726928145),
(25284, '57054', 218, 49, 33718, 44.1172, 0.769990396760842, -97.2147, -1.69671659633853),
(25285, '57055', 218, 49, 123527, 43.6684, 0.762157359077892, -96.7034, -1.68779272787308),
(25286, '57056', 218, 49, 24549, 43.5874, 0.760743642383776, -96.5804, -1.68564597289313),
(25287, '57057', 218, 49, 17882, 44.0736, 0.769229433206973, -96.9558, -1.69219793890512),
(25288, '57058', 218, 49, 126, 43.7263, 0.763167904714797, -97.3856, -1.69969936403019),
(25289, '57059', 218, 49, 5690, 43.1363, 0.75287046212803, -97.7276, -1.70566839007201),
(25290, '57061', 218, 49, 18091, 44.2428, 0.772182530301347, -97.0676, -1.69414921700885),
(25291, '57062', 218, 49, 349, 42.8549, 0.747959105612918, -97.8939, -1.70857087261808),
(25292, '57063', 218, 49, 275, 42.9503, 0.74962414971932, -97.6675, -1.70461944719156),
(25293, '57064', 218, 49, 57846, 43.4468, 0.758289709455472, -96.8376, -1.69013495972926),
(25294, '57065', 218, 49, 38578, 43.892, 0.766059915285351, -96.6117, -1.68619226094901),
(25295, '57066', 218, 49, 158023, 42.9925, 0.750360678663662, -97.8604, -1.70798618731866),
(25296, '57067', 218, 49, 31360, 42.9599, 0.749791701327512, -97.509, -1.70185310032715),
(25297, '57068', 218, 49, 12510, 43.5818, 0.760645903945665, -96.4652, -1.68363535359483),
(25298, '57069', 218, 49, 34261, 42.7819, 0.746685015258962, -96.9274, -1.69170226539755),
(25299, '57070', 218, 49, 171505, 43.1709, 0.75347434604922, -97.0844, -1.69444243232318),
(25300, '57071', 218, 49, 31401, 44.3209, 0.773545632447155, -96.9218, -1.69160452695944),
(25301, '57072', 218, 49, 171523, 42.9962, 0.750425255845986, -97.2191, -1.69679339082562),
(25302, '57073', 218, 49, 171532, 42.9937, 0.750381622614686, -97.0442, -1.69374080996388),
(25303, '57075', 218, 49, 58194, 43.9956, 0.767868076390417, -96.9653, -1.69236374518406),
(25304, '57076', 218, 49, 171636, 43.9577, 0.767206596603911, -97.309, -1.69836244182316),
(25305, '57077', 218, 49, 99213, 43.3294, 0.756240692913631, -96.7672, -1.68890624793586),
(25306, '57078', 218, 49, 171662, 42.8814, 0.748421617864696, -97.3905, -1.69978488516354),
(25307, '57079', 218, 49, 171662, 42.8896, 0.74856473486336, -97.392, -1.69981106510232),
(25308, '57101', 218, 49, 171301, 43.6023, 0.761003696442324, -96.7064, -1.68784508775064),
(25309, '57103', 218, 49, 171301, 43.5365, 0.759855269794511, -96.6841, -1.68745587932745),
(25310, '57104', 218, 49, 171301, 43.5574, 0.760220043608178, -96.7325, -1.68830061868541),
(25311, '57105', 218, 49, 171301, 43.5234, 0.7596266316625, -96.7318, -1.68828840138065),
(25312, '57106', 218, 49, 171301, 43.5198, 0.759563799809428, -96.7903, -1.68930941899307),
(25313, '57107', 218, 49, 171301, 43.5637, 0.760329999351054, -96.8004, -1.68948569724752),
(25314, '57108', 218, 49, 171301, 43.4725, 0.758738259073235, -96.6891, -1.68754314579005),
(25315, '57109', 218, 49, 171301, 43.5209, 0.7595829984312, -96.7366, -1.68837217718475),
(25316, '57110', 218, 49, 171301, 43.5432, 0.759972206854395, -96.639, -1.6866687358348),
(25317, '57117', 218, 49, 171301, 43.5511, 0.760110087865302, -96.7246, -1.68816273767451),
(25318, '57118', 218, 49, 171301, 43.6018, 0.760994969796064, -96.7055, -1.68782937978738),
(25319, '57186', 218, 49, 171301, 43.5468, 0.760035038707467, -96.7287, -1.68823429617384),
(25320, '57188', 218, 49, 171301, 43.6014, 0.760987988479056, -96.7175, -1.68803881929762),
(25321, '57189', 218, 49, 171301, 43.6024, 0.761005441771576, -96.718, -1.68804754594388),
(25322, '57192', 218, 49, 171301, 43.5473, 0.760043765353727, -96.7269, -1.6882028802473),
(25323, '57193', 218, 49, 171301, 43.5451, 0.760005368110183, -96.7239, -1.68815052036974),
(25324, '57194', 218, 49, 171301, 43.5472, 0.760042020024475, -96.7305, -1.68826571210038),
(25325, '57195', 218, 49, 171301, 43.5474, 0.760045510682979, -96.7303, -1.68826222144187),
(25326, '57196', 218, 49, 171301, 43.5445, 0.759994896134671, -96.7232, -1.68813830306498),
(25327, '57197', 218, 49, 171301, 43.5217, 0.759596961065216, -96.7415, -1.68845769831809),
(25328, '57198', 218, 49, 171301, 43.7331, 0.763286587103932, -96.6293, -1.68649943889736),
(25329, '57201', 218, 49, 18507, 44.9038, 0.78371915665703, -97.1209, -1.69507947750016),
(25330, '57212', 218, 49, 15026, 44.3654, 0.774322303964292, -97.1494, -1.69557689633698),
(25331, '57213', 218, 49, 18949, 44.5578, 0.777680317445129, -96.5456, -1.68503859831344),
(25332, '57214', 218, 49, 31716, 44.4909, 0.776512692175545, -97.2236, -1.69687193064196),
(25333, '57216', 218, 49, 169838, 45.2952, 0.790550375349336, -96.4637, -1.68360917365605),
(25334, '57217', 218, 49, 694, 44.9059, 0.783755808571322, -97.7072, -1.7053123429046),
(25335, '57218', 218, 49, 71880, 44.6742, 0.779711880694451, -96.6677, -1.68716964533012),
(25336, '57219', 218, 49, 15330, 45.3188, 0.790962273052806, -97.6358, -1.70406617781868),
(25337, '57220', 218, 49, 15356, 44.4841, 0.776394009786409, -96.9322, -1.69178604120165),
(25338, '57221', 218, 49, 652, 44.6308, 0.778954407799085, -97.4308, -1.70048825285209),
(25339, '57223', 218, 49, 39682, 44.7263, 0.78062119723474, -97.0275, -1.6934493399788),
(25340, '57224', 218, 49, 170018, 45.8775, 0.800713427583698, -97.1036, -1.69477753553957),
(25341, '57225', 218, 49, 1590, 44.8795, 0.783295041648795, -97.7341, -1.70578183647339),
(25342, '57226', 218, 49, 8114, 44.7598, 0.781205882534158, -96.6846, -1.68746460597371),
(25343, '57227', 218, 49, 1779, 45.364, 0.791751161874708, -96.6674, -1.68716440934237),
(25344, '57231', 218, 49, 170137, 44.3867, 0.774694059094967, -97.552, -1.70260359190551),
(25345, '57232', 218, 49, 2217, 45.6129, 0.796095286382922, -97.3542, -1.69915133064506),
(25346, '57233', 218, 49, 8778, 44.4926, 0.776542362772829, -97.4003, -1.69995592743023),
(25347, '57234', 218, 49, 170258, 44.6236, 0.778828744092942, -96.958, -1.69223633614866),
(25348, '57235', 218, 49, 2502, 45.0655, 0.786541354057505, -97.2698, -1.69767827275638),
(25349, '57236', 218, 49, 2657, 44.9344, 0.78425322740814, -97.5552, -1.70265944244157),
(25350, '57237', 218, 49, 16182, 44.8538, 0.782846492031033, -96.5335, -1.68482741347395),
(25351, '57238', 218, 49, 9160, 44.9021, 0.783689486059746, -96.7798, -1.68912615942161),
(25352, '57239', 218, 49, 170434, 45.4995, 0.79411608301116, -97.4116, -1.70015314963571),
(25353, '57241', 218, 49, 41288, 44.6754, 0.779732824645475, -97.2494, -1.69732222558897),
(25354, '57242', 218, 49, 36336, 44.7592, 0.781195410558646, -97.3842, -1.69967492942066),
(25355, '57243', 218, 49, 9426, 44.8916, 0.783506226488286, -97.4313, -1.70049697949835),
(25356, '57244', 218, 49, 170501, 44.3836, 0.774639953888155, -97.1668, -1.69588058362683),
(25357, '57245', 218, 49, 170667, 44.8797, 0.783298532307299, -96.9427, -1.69196930077311),
(25358, '57246', 218, 49, 170677, 45.0274, 0.785876383612495, -96.6997, -1.68772815069076),
(25359, '57247', 218, 49, 9930, 45.6973, 0.797568344271605, -97.353, -1.69913038669404),
(25360, '57248', 218, 49, 170695, 44.5818, 0.778099196465608, -97.2101, -1.69663631119294),
(25361, '57249', 218, 49, 170698, 44.3623, 0.77426819875748, -97.3638, -1.69931888225326),
(25362, '57251', 218, 49, 56115, 45.281, 0.790302538595552, -96.9388, -1.69190123293228),
(25363, '57252', 218, 49, 104246, 45.2189, 0.789218689130064, -96.6322, -1.68655005344566),
(25364, '57253', 218, 49, 104246, 45.2192, 0.78922392511782, -96.6345, -1.68659019601846),
(25365, '57255', 218, 49, 170934, 45.8775, 0.800713427583698, -96.9166, -1.69151376983834),
(25366, '57256', 218, 49, 171024, 45.157, 0.788138330323079, -97.2059, -1.69656300736436),
(25367, '57257', 218, 49, 171051, 45.499, 0.7941073563649, -97.0468, -1.69378618852443),
(25368, '57258', 218, 49, 24225, 44.8927, 0.783525425110058, -97.9192, -1.70901244091883),
(25369, '57259', 218, 49, 171176, 45.0207, 0.785759446552611, -96.5449, -1.68502638100867),
(25370, '57260', 218, 49, 171227, 45.8786, 0.80073262620547, -96.7125, -1.68795155283502),
(25371, '57261', 218, 49, 28468, 45.5155, 0.794395335691479, -97.5909, -1.70328252498453),
(25372, '57262', 218, 49, 171306, 45.6635, 0.796978422984431, -97.0482, -1.69381062313396),
(25373, '57263', 218, 49, 38302, 45.1077, 0.787277883001846, -97.0237, -1.69338301746722),
(25374, '57264', 218, 49, 38390, 45.1069, 0.78726392036783, -96.822, -1.68986268836595),
(25375, '57265', 218, 49, 171387, 45.0206, 0.785757701223359, -96.8211, -1.68984698040268),
(25376, '57266', 218, 49, 6151, 45.3873, 0.792157823590422, -97.0431, -1.69372161134211),
(25377, '57268', 218, 49, 28798, 44.573, 0.777945607491432, -96.6424, -1.68672807702937),
(25378, '57269', 218, 49, 31335, 45.2119, 0.789096516082424, -97.0218, -1.69334985621143),
(25379, '57270', 218, 49, 171492, 45.8634, 0.800467336159167, -97.2869, -1.69797672405847),
(25380, '57271', 218, 49, 6557, 44.6782, 0.77978169386453, -97.5474, -1.70252330675992),
(25381, '57272', 218, 49, 721, 45.0649, 0.786530882081993, -97.4328, -1.70052315943713),
(25382, '57273', 218, 49, 171558, 45.3327, 0.791204873818834, -97.3072, -1.69833102589663),
(25383, '57274', 218, 49, 18520, 45.3339, 0.791225817769857, -97.5187, -1.70202239726459),
(25384, '57276', 218, 49, 6768, 44.4252, 0.775366010856985, -96.5956, -1.68591126293943),
(25385, '57278', 218, 49, 26098, 44.6316, 0.778968370433101, -97.7346, -1.70579056311965),
(25386, '57279', 218, 49, 12881, 45.4152, 0.792644770451729, -96.8657, -1.69062539724907),
(25387, '57301', 218, 49, 4252, 43.7111, 0.762902614668493, -98.0273, -1.71089914184024),
(25388, '57311', 218, 49, 34524, 43.6553, 0.76192872094588, -97.7808, -1.70659690523407),
(25389, '57312', 218, 49, 7071, 44.1538, 0.770629187267072, -98.4516, -1.71830457385645),
(25390, '57313', 218, 49, 53231, 43.3191, 0.756060924000676, -98.3463, -1.7164667421541),
(25391, '57314', 218, 49, 7166, 44.041, 0.768660455870823, -97.9622, -1.70976293249719),
(25392, '57315', 218, 49, 7208, 43.0062, 0.750599788771185, -98.059, -1.71145241121312),
(25393, '57317', 218, 49, 169865, 43.0612, 0.751559719859782, -99.0324, -1.72844144615203),
(25394, '57319', 218, 49, 19494, 43.5512, 0.760111833194554, -97.5003, -1.70170125668223),
(25395, '57321', 218, 49, 100469, 43.8805, 0.765859202421372, -97.4998, -1.70169253003597),
(25396, '57322', 218, 49, 1369, 44.675, 0.779725843328467, -97.917, -1.70897404367529),
(25397, '57323', 218, 49, 7932, 44.1724, 0.770953818507943, -97.7189, -1.70551654642709),
(25398, '57324', 218, 49, 169987, 44.3706, 0.774413061085396, -98.0353, -1.7110387681804),
(25399, '57325', 218, 49, 127081, 43.8056, 0.764551950811628, -99.3251, -1.73355002487262),
(25400, '57326', 218, 49, 127081, 43.8073, 0.764581621408912, -99.3203, -1.73346624906852),
(25401, '57328', 218, 49, 160439, 43.4248, 0.757905737020034, -98.4045, -1.71748252377876),
(25402, '57329', 218, 49, 86219, 43.0392, 0.751175747424343, -98.184, -1.71363407277811),
(25403, '57330', 218, 49, 46278, 43.2999, 0.755725820784293, -98.2157, -1.71418734215099),
(25404, '57331', 218, 49, 160806, 43.4637, 0.75858467009906, -97.9951, -1.7103371458211),
(25405, '57332', 218, 49, 27099, 43.6041, 0.761035112368859, -97.6202, -1.70379390645537),
(25406, '57334', 218, 49, 170262, 43.5458, 0.760017585414947, -97.9839, -1.71014166894487),
(25407, '57335', 218, 49, 13733, 43.0597, 0.751533539921002, -98.7643, -1.72376221842744),
(25408, '57337', 218, 49, 170298, 43.98, 0.767595805027106, -97.791, -1.70677492881777),
(25409, '57339', 218, 49, 170317, 44.0665, 0.769105514830081, -99.3277, -1.73359540343317),
(25410, '57340', 218, 49, 2628, 43.7271, 0.763181867348812, -97.8216, -1.70730899956889),
(25411, '57341', 218, 49, 0, 44.088, 0.76948076061926, -99.0693, -1.72908547264602),
(25412, '57342', 218, 49, 36071, 43.2548, 0.754938677291643, -98.6891, -1.72244973082994),
(25413, '57344', 218, 49, 9353, 43.4581, 0.758486931660948, -98.527, -1.71962055211245),
(25414, '57345', 218, 49, 170516, 44.5182, 0.77698916706134, -99.4434, -1.73561474937773),
(25415, '57346', 218, 49, 171376, 44.2475, 0.772264560776191, -99.4527, -1.73577706499816),
(25416, '57348', 218, 49, 30091, 44.6298, 0.778936954506565, -98.4087, -1.71755582760734),
(25417, '57349', 218, 49, 3251, 44.0125, 0.768163037034004, -97.5273, -1.70217249558027),
(25418, '57350', 218, 49, 30131, 44.3575, 0.774184422953385, -98.2165, -1.71420130478501),
(25419, '57353', 218, 49, 109799, 44.3657, 0.774327539952048, -97.8504, -1.70781165439346),
(25420, '57354', 218, 49, 3482, 43.2082, 0.754125353860214, -97.8263, -1.70739103004373),
(25421, '57355', 218, 49, 9856, 43.7176, 0.763016061069873, -98.9327, -1.72670135288779),
(25422, '57356', 218, 49, 170685, 43.1567, 0.753226509295437, -98.5375, -1.71980381168391),
(25423, '57358', 218, 49, 3658, 44.0704, 0.769173582670909, -98.4034, -1.71746332515699),
(25424, '57359', 218, 49, 3737, 43.8947, 0.766107039175155, -98.2108, -1.71410182101765),
(25425, '57361', 218, 49, 76523, 42.9595, 0.749784720010504, -98.3928, -1.71727832025628),
(25426, '57362', 218, 49, 4213, 44.5197, 0.77701534700012, -98.9855, -1.72762288673285),
(25427, '57363', 218, 49, 4411, 43.7187, 0.763035259691645, -98.2654, -1.71505477078924),
(25428, '57364', 218, 49, 23337, 43.4351, 0.758085505932989, -98.6478, -1.72172890984886),
(25429, '57365', 218, 49, 170981, 43.7971, 0.764403597825209, -99.3952, -1.73477350067827),
(25430, '57366', 218, 49, 151568, 43.3944, 0.757375156927427, -97.9872, -1.71019926481019),
(25431, '57367', 218, 49, 171064, 43.0672, 0.751664439614902, -98.5306, -1.71968338396553),
(25432, '57368', 218, 49, 171076, 43.7143, 0.762958465204557, -98.4815, -1.7188264273028),
(25433, '57369', 218, 49, 137511, 43.3874, 0.757252983879788, -98.844, -1.72515324584128),
(25434, '57370', 218, 49, 171130, 43.7747, 0.764012644072762, -99.1725, -1.73088665243408),
(25435, '57371', 218, 49, 171169, 44.5916, 0.778270238732304, -99.2479, -1.73220263069008),
(25436, '57373', 218, 49, 152304, 44.5311, 0.777214314534847, -98.8044, -1.72446209545749),
(25437, '57374', 218, 49, 5995, 43.7763, 0.764040569340794, -97.5891, -1.703251109058),
(25438, '57375', 218, 49, 57728, 43.5852, 0.760705245140233, -98.5583, -1.72016684016833),
(25439, '57376', 218, 49, 98631, 43.2559, 0.754957875913415, -97.9905, -1.7102568606755),
(25440, '57379', 218, 49, 34285, 44.3229, 0.773580539032195, -98.4084, -1.71755059161959),
(25441, '57380', 218, 49, 18471, 43.0806, 0.751898313734669, -98.2902, -1.71548761244373),
(25442, '57381', 218, 49, 6700, 44.3713, 0.77442527839016, -98.6806, -1.72230137784352),
(25443, '57382', 218, 49, 171583, 44.0818, 0.769372550205636, -98.5697, -1.72036580770305),
(25444, '57383', 218, 49, 70098, 43.804, 0.764524025543596, -98.6815, -1.72231708580678),
(25445, '57384', 218, 49, 171648, 44.4109, 0.77511642877395, -98.4726, -1.71867109299937),
(25446, '57385', 218, 49, 169685, 44.0672, 0.769117732134845, -98.211, -1.71410531167615),
(25447, '57386', 218, 49, 12986, 44.532, 0.777230022498115, -97.9806, -1.71008407307956),
(25448, '57399', 218, 49, 30131, 44.3638, 0.77429437869626, -98.2183, -1.71423272071155),
(25449, '57401', 218, 49, 7017, 45.4647, 0.793508708431466, -98.4905, -1.71898350693548),
(25450, '57402', 218, 49, 7017, 45.4952, 0.794041033853324, -98.4947, -1.71905681076406),
(25451, '57420', 218, 49, 201852, 45.2463, 0.78969690934511, -99.8052, -1.74192935061144),
(25452, '57421', 218, 49, 62514, 45.7194, 0.797954062036295, -97.9162, -1.70896008104127),
(25453, '57422', 218, 49, 14988, 45.4143, 0.792629062488461, -97.9184, -1.70899847828482),
(25454, '57424', 218, 49, 7180, 45.027, 0.785869402295487, -98.4715, -1.7186518943776),
(25455, '57426', 218, 49, 29152, 45.7177, 0.797924391439012, -98.6083, -1.72103950479432),
(25456, '57427', 218, 49, 19093, 45.4613, 0.793449367236898, -98.3296, -1.71617527216902),
(25457, '57428', 218, 49, 169874, 45.4507, 0.793264362336187, -99.6605, -1.73940385918381),
(25458, '57429', 218, 49, 169892, 45.1625, 0.788234323431939, -98.322, -1.71604262714586),
(25459, '57430', 218, 49, 45111, 45.7934, 0.799245605682771, -97.7519, -1.70609250508025),
(25460, '57432', 218, 49, 26794, 45.6652, 0.797008093581715, -98.0612, -1.71149080845666),
(25461, '57433', 218, 49, 1716, 45.6845, 0.79734494212735, -98.2952, -1.71557487890633),
(25462, '57434', 218, 49, 101047, 45.1646, 0.788270975346231, -98.0133, -1.71065479574496),
(25463, '57435', 218, 49, 170099, 45.1726, 0.788410601686391, -98.9395, -1.72682003527693),
(25464, '57436', 218, 49, 170173, 44.7881, 0.781699810712472, -98.1186, -1.71249262744731),
(25465, '57437', 218, 49, 2334, 45.7687, 0.798814509357529, -99.6224, -1.7387388887388),
(25466, '57438', 218, 49, 170295, 45.0353, 0.786014264623402, -99.1216, -1.72999827984481),
(25467, '57439', 218, 49, 161596, 45.3312, 0.791178693880054, -98.0972, -1.71211912698738),
(25468, '57440', 218, 49, 2594, 44.7638, 0.781275695704238, -98.2804, -1.71531657017704),
(25469, '57441', 218, 49, 32485, 45.8328, 0.799933265408057, -98.5057, -1.71924879698178),
(25470, '57442', 218, 49, 72658, 45.0143, 0.785647745480483, -99.9948, -1.74523849487323),
(25471, '57445', 218, 49, 113503, 45.4535, 0.793313231555243, -98.0976, -1.71212610830439),
(25472, '57446', 218, 49, 36349, 45.8831, 0.80081116602181, -98.148, -1.71300575424739),
(25473, '57448', 218, 49, 170547, 45.5498, 0.794993983624913, -99.5225, -1.73699530481606),
(25474, '57449', 218, 49, 116085, 45.8084, 0.79950740507057, -98.104, -1.71223780937652),
(25475, '57450', 218, 49, 170551, 45.2418, 0.789618369528771, -99.7784, -1.74146160237191),
(25476, '57451', 218, 49, 125144, 45.4455, 0.793173605215083, -99.0299, -1.72839781292073),
(25477, '57452', 218, 49, 3406, 45.42, 0.792728546255825, -99.8093, -1.74200090911078),
(25478, '57454', 218, 49, 9982, 45.6312, 0.796414681636036, -97.7317, -1.70573994857134),
(25479, '57455', 218, 49, 3708, 44.9789, 0.785029898925278, -99.7153, -1.7403602996139),
(25480, '57456', 218, 49, 10041, 45.6255, 0.796315197868673, -98.7692, -1.72384773956078),
(25481, '57457', 218, 49, 0, 45.772, 0.798872105222844, -99.2502, -1.73224277326288),
(25482, '57460', 218, 49, 3975, 45.2153, 0.789155857276992, -98.6318, -1.72144965716854),
(25483, '57461', 218, 49, 76580, 45.1616, 0.788218615468671, -98.478, -1.71876534077898),
(25484, '57462', 218, 49, 37220, 45.3591, 0.79166564074136, -98.6629, -1.72199245456591),
(25485, '57465', 218, 49, 71188, 45.1536, 0.788078989128511, -98.6806, -1.72230137784352),
(25486, '57466', 218, 49, 171007, 45.2015, 0.788915001840217, -99.451, -1.73574739440088),
(25487, '57467', 218, 49, 28156, 44.8385, 0.782579456655478, -99.1117, -1.72982549224886),
(25488, '57468', 218, 49, 56879, 45.5011, 0.794144008279192, -97.7951, -1.70684648731711),
(25489, '57469', 218, 49, 11515, 44.8749, 0.783214756503203, -98.516, -1.71942856589473),
(25490, '57470', 218, 49, 171210, 45.027, 0.785869402295487, -98.7771, -1.72398562057169),
(25491, '57471', 218, 49, 24518, 45.4511, 0.793271343653195, -99.3362, -1.73374375641959),
(25492, '57472', 218, 49, 185046, 45.5067, 0.794241746717304, -100.0305, -1.74586157741619),
(25493, '57473', 218, 49, 18037, 45.0372, 0.78604742587919, -99.1292, -1.73013092486796),
(25494, '57474', 218, 49, 14683, 45.2875, 0.790415984996932, -98.2806, -1.71532006083554),
(25495, '57475', 218, 49, 171426, 45.1371, 0.787791009801933, -99.6212, -1.73871794478778),
(25496, '57476', 218, 49, 171445, 44.7208, 0.78052520412588, -98.584, -1.72061538978609),
(25497, '57477', 218, 49, 171454, 45.0239, 0.785815297088675, -98.1044, -1.71224479069353),
(25498, '57479', 218, 49, 12662, 45.3503, 0.791512051767184, -98.4432, -1.71815796619928),
(25499, '57481', 218, 49, 25961, 45.6084, 0.796016746566582, -98.6645, -1.72202037983395),
(25500, '57501', 218, 49, 128535, 44.368, 0.774367682524844, -100.3385, -1.75123719151233),
(25501, '57520', 218, 49, 201849, 44.8449, 0.782691157727605, -100.061, -1.74639390283805),
(25502, '57521', 218, 49, 13361, 43.9016, 0.766227466893543, -101.2482, -1.76711445171772),
(25503, '57522', 218, 49, 169857, 44.5165, 0.776959496464056, -99.9885, -1.74512853913035),
(25504, '57523', 218, 49, 35064, 43.1852, 0.753723928132255, -99.29, -1.73293741430517),
(25505, '57526', 218, 49, 35159, 43.3373, 0.756378573924539, -100.1706, -1.74830678369823),
(25506, '57528', 218, 49, 170060, 43.2624, 0.755071322314795, -99.7178, -1.7404039328452),
(25507, '57529', 218, 49, 1953, 43.2367, 0.754622772697032, -99.5131, -1.73683124386637),
(25508, '57531', 218, 49, 35628, 43.9359, 0.766826114826977, -100.471, -1.75354975277122),
(25509, '57532', 218, 49, 202138, 44.3539, 0.774121591100313, -100.3844, -1.752038297639),
(25510, '57533', 218, 49, 9237, 43.2332, 0.754561686173212, -99.4279, -1.73534422334367),
(25511, '57534', 218, 49, 170448, 43.6706, 0.762195756321436, -99.7006, -1.74010373621386),
(25512, '57536', 218, 49, 94760, 44.5255, 0.777116576096735, -99.7415, -1.74081757587792),
(25513, '57537', 218, 49, 3020, 44.4321, 0.775486438575372, -100.5473, -1.75488143899049),
(25514, '57538', 218, 49, 27418, 43.1148, 0.752495216338851, -99.1957, -1.73129156882054),
(25515, '57540', 218, 49, 170536, 44.5183, 0.776990912390592, -99.588, -1.73813849547611),
(25516, '57541', 218, 49, 22126, 43.5894, 0.760778548968816, -99.962, -1.74466602687857),
(25517, '57542', 218, 49, 16558, 43.605, 0.761050820332127, -99.4885, -1.73640189287038),
(25518, '57543', 218, 49, 202264, 43.8338, 0.76504413366069, -101.4902, -1.77133814850755),
(25519, '57544', 218, 49, 36691, 43.8885, 0.765998828761531, -99.8321, -1.74239884418023),
(25520, '57547', 218, 49, 145649, 43.5539, 0.760158957084358, -101.3686, -1.76921582813712),
(25521, '57548', 218, 49, 170793, 44.058, 0.768957161843662, -99.697, -1.74004090436079),
(25522, '57551', 218, 49, 882, 43.1747, 0.753540668560796, -101.7353, -1.77561595050419),
(25523, '57552', 218, 49, 10461, 44.3184, 0.773501999215855, -101.3678, -1.76920186550311),
(25524, '57553', 218, 49, 202378, 44.4199, 0.775273508406629, -101.8053, -1.77683768098058),
(25525, '57555', 218, 49, 14256, 43.1912, 0.753828647887375, -100.4744, -1.75360909396579),
(25526, '57557', 218, 49, 49532, 44.6575, 0.779420410709368, -100.9049, -1.76112273639563),
(25527, '57559', 218, 49, 191922, 43.9604, 0.767253720493715, -100.7004, -1.7575535380753),
(25528, '57560', 218, 49, 23401, 43.475, 0.758781892304535, -101.0805, -1.76418753456213),
(25529, '57562', 218, 49, 202452, 43.9894, 0.767759865976794, -100.9312, -1.7615817579889),
(25530, '57563', 218, 49, 202456, 43.3606, 0.756785235640253, -100.3885, -1.75210985613833),
(25531, '57564', 218, 49, 202458, 44.7061, 0.780268640725837, -100.0666, -1.74649164127616),
(25532, '57566', 218, 49, 132536, 43.3289, 0.756231966267371, -101.0154, -1.76305132521908),
(25533, '57567', 218, 49, 82935, 44.0405, 0.768651729224563, -101.6627, -1.77434884146724),
(25534, '57568', 218, 49, 177374, 43.9065, 0.76631298802689, -100.0566, -1.74631710835096),
(25535, '57569', 218, 49, 14477, 43.8303, 0.764983047136871, -99.5287, -1.73710351522968),
(25536, '57570', 218, 49, 5545, 43.2674, 0.755158588777395, -100.7368, -1.75818883792302),
(25537, '57571', 218, 49, 11748, 43.1081, 0.752378279278968, -99.1132, -1.72985167218764),
(25538, '57572', 218, 49, 11751, 43.1407, 0.752947256615118, -100.9706, -1.76226941771419),
(25539, '57574', 218, 49, 153235, 43.0976, 0.752195019707508, -101.4397, -1.77045675723529),
(25540, '57576', 218, 49, 43505, 44.0203, 0.76829917271566, -100.3064, -1.75067694082244),
(25541, '57577', 218, 49, 202745, 43.5527, 0.760138013133334, -101.8037, -1.77680975571255),
(25542, '57578', 218, 49, 171605, 43.0615, 0.751564955847538, -99.7424, -1.74083328384119),
(25543, '57579', 218, 49, 12819, 43.5674, 0.760394576533378, -100.7462, -1.75835289887271),
(25544, '57580', 218, 49, 58328, 43.3731, 0.757003401796753, -99.8551, -1.74280026990819),
(25545, '57584', 218, 49, 202797, 43.4648, 0.758603868720831, -100.0665, -1.74648989594691),
(25546, '57585', 218, 49, 44195, 43.5601, 0.760267167497982, -100.408, -1.75245019534247),
(25547, '57601', 218, 49, 202391, 45.5397, 0.794817705370462, -100.4335, -1.75289525430172),
(25548, '57620', 218, 49, 31831, 45.5225, 0.794517508739119, -102.4724, -1.78848077242064),
(25549, '57621', 218, 49, 201947, 45.8764, 0.800694228961927, -101.3715, -1.76926644268543),
(25550, '57622', 218, 49, 58979, 44.6115, 0.77861755925345, -101.7953, -1.77666314805538),
(25551, '57623', 218, 49, 2138, 44.9917, 0.785253301069533, -101.6492, -1.77411322201822),
(25552, '57625', 218, 49, 202078, 44.9962, 0.785331840885872, -101.2396, -1.76696435340205),
(25553, '57626', 218, 49, 747, 45.0205, 0.785755955894107, -102.0345, -1.78083797562615),
(25554, '57629', 218, 49, 202155, 45.4326, 0.792948457741576, -101.7229, -1.77539952967694),
(25555, '57630', 218, 49, 202156, 45.4355, 0.792999072289884, -100.8878, -1.76082428509354),
(25556, '57631', 218, 49, 149163, 45.5331, 0.79470251363983, -100.2705, -1.75005036762097),
(25557, '57632', 218, 49, 202206, 45.8551, 0.800322473831252, -100.0248, -1.74576209364882),
(25558, '57633', 218, 49, 27524, 45.3953, 0.792297449930582, -101.4312, -1.77030840424887),
(25559, '57634', 218, 49, 202269, 45.8821, 0.80079371272929, -101.9122, -1.77870343795097),
(25560, '57636', 218, 49, 202295, 45.0183, 0.785717558650563, -101.4311, -1.77030665891962),
(25561, '57638', 218, 49, 202300, 45.9381, 0.801771097110407, -102.1616, -1.78305628910544),
(25562, '57639', 218, 49, 202317, 45.6816, 0.797294327579042, -100.7959, -1.75922032751095),
(25563, '57640', 218, 49, 199487, 45.8394, 0.800048457138689, -102.7555, -1.79342179953303),
(25564, '57641', 218, 49, 4100, 45.6858, 0.797367631407625, -101.6224, -1.77364547377869),
(25565, '57642', 218, 49, 202362, 45.6913, 0.797463624516485, -100.9939, -1.7626760794299),
(25566, '57644', 218, 49, 23000, 45.2948, 0.790543394032328, -102.2963, -1.78540724760788),
(25567, '57645', 218, 49, 30565, 45.8813, 0.800779750095274, -101.6998, -1.77499635861973),
(25568, '57646', 218, 49, 10620, 45.6771, 0.797215787762702, -100.0357, -1.74595233453729),
(25569, '57647', 218, 49, 202471, 45.055, 0.786358094486045, -100.7902, -1.75912084374359),
(25570, '57648', 218, 49, 42644, 45.861, 0.800425448257119, -100.3203, -1.75091954158847),
(25571, '57649', 218, 49, 30889, 45.6029, 0.795920753457722, -102.8272, -1.79467320060671),
(25572, '57650', 218, 49, 5284, 45.8532, 0.800289312575464, -103.0346, -1.79829301347535),
(25573, '57651', 218, 49, 105662, 45.5205, 0.794482602154079, -103.0614, -1.79876076171488),
(25574, '57652', 218, 49, 50814, 45.079, 0.786776973506524, -100.7059, -1.75764953118416),
(25575, '57656', 218, 49, 202688, 45.4262, 0.792836756669448, -101.0744, -1.76408106947776),
(25576, '57657', 218, 49, 18367, 45.4152, 0.792644770451729, -100.7035, -1.75760764328211),
(25577, '57658', 218, 49, 202736, 45.784, 0.799081544733084, -100.5156, -1.75432816961761),
(25578, '57659', 218, 49, 12598, 45.9108, 0.801294622224613, -101.0896, -1.76434635952406),
(25579, '57660', 218, 49, 38760, 45.9245, 0.801533732332136, -101.514, -1.77175353686952),
(25580, '57661', 218, 49, 79407, 45.271, 0.790128005670353, -100.8856, -1.76078588784999),
(25581, '57701', 218, 49, 132771, 44.0736, 0.769229433206973, -103.2057, -1.80127927182551),
(25582, '57702', 218, 49, 132771, 44.0642, 0.769065372257285, -103.2823, -1.80261619403254),
(25583, '57703', 218, 49, 132771, 44.0809, 0.769356842242368, -103.2303, -1.8017086228215),
(25584, '57706', 218, 49, 0, 44.1496, 0.770555883438488, -103.0717, -1.79894053062784),
(25585, '57709', 218, 49, 132771, 44.231, 0.771976581449612, -103.3905, -1.8045046402832),
(25586, '57714', 218, 49, 18798, 43.3044, 0.755804360600633, -101.9121, -1.77870169262171),
(25587, '57716', 218, 49, 201886, 43.0862, 0.751996052172781, -102.2195, -1.78406683474234),
(25588, '57717', 218, 49, 201895, 44.6655, 0.779560037049527, -103.8495, -1.81251570154985),
(25589, '57718', 218, 49, 34832, 44.1592, 0.77072343504668, -103.3275, -1.80340508285444),
(25590, '57719', 218, 49, 85226, 44.1181, 0.77000610472411, -103.0788, -1.79906444900473),
(25591, '57720', 218, 49, 26642, 45.4989, 0.794105611035648, -103.5967, -1.80810350920081),
(25592, '57722', 218, 49, 92900, 43.5147, 0.759474788017577, -103.261, -1.80224443890186),
(25593, '57724', 218, 49, 201959, 45.6513, 0.796765492815687, -103.9378, -1.81405682727936),
(25594, '57725', 218, 49, 201964, 43.9498, 0.767068715593004, -103.0154, -1.79795791025897),
(25595, '57730', 218, 49, 35479, 43.7675, 0.763886980366618, -103.5964, -1.80809827321305),
(25596, '57732', 218, 49, 93665, 44.3753, 0.77449509156024, -103.7284, -1.81040210782569),
(25597, '57735', 218, 49, 2222, 43.2991, 0.755711858150277, -103.8295, -1.81216663569945),
(25598, '57736', 218, 49, 8740, 44.26, 0.77248272693269, -102.6324, -1.79127329922383),
(25599, '57737', 218, 49, 202103, 44.5282, 0.777163699986539, -102.5887, -1.79051059034071),
(25600, '57738', 218, 49, 20978, 43.6513, 0.761858907775801, -103.2225, -1.80157248713985),
(25601, '57741', 218, 49, 16090, 44.4122, 0.775139118054226, -103.4741, -1.80596373553786),
(25602, '57744', 218, 49, 102742, 43.8376, 0.765110456172266, -103.1923, -1.80104539770574),
(25603, '57745', 218, 49, 21935, 43.93, 0.766723140401109, -103.5746, -1.80771779143612),
(25604, '57747', 218, 49, 9587, 43.4311, 0.758015692762909, -103.4783, -1.80603703936645),
(25605, '57748', 218, 49, 55400, 44.5421, 0.777406300752566, -102.2129, -1.78395164301171),
(25606, '57750', 218, 49, 202249, 43.7586, 0.763731646063191, -101.898, -1.77845560119718),
(25607, '57751', 218, 49, 3513, 43.9434, 0.766957014520876, -103.3634, -1.80403165605591),
(25608, '57752', 218, 49, 22439, 43.5347, 0.759823853867975, -102.3182, -1.78578947471406),
(25609, '57754', 218, 49, 202298, 44.3518, 0.774084939186021, -103.7649, -1.81103915300266),
(25610, '57755', 218, 49, 37000, 45.8485, 0.80020728210062, -103.3651, -1.80406132665319),
(25611, '57756', 218, 49, 202339, 43.3002, 0.755731056772049, -102.3854, -1.7869623359714),
(25612, '57758', 218, 49, 202407, 45.0529, 0.786321442571753, -102.8049, -1.79428399218352),
(25613, '57759', 218, 49, 10750, 44.1977, 0.771395386808698, -103.5196, -1.80675786034752),
(25614, '57760', 218, 49, 4567, 44.7162, 0.780444918980288, -103.4235, -1.80508059893636),
(25615, '57761', 218, 49, 202419, 44.0948, 0.769599443008396, -102.8335, -1.79478315634959),
(25616, '57762', 218, 49, 202426, 44.6738, 0.779704899377443, -103.5563, -1.807398396183),
(25617, '57763', 218, 49, 202449, 43.1804, 0.75364015232816, -103.2323, -1.80174352940654),
(25618, '57764', 218, 49, 202451, 43.1882, 0.753776288009815, -102.7387, -1.7931285842187),
(25619, '57765', 218, 49, 10987, 44.884, 0.783373581465135, -102.4467, -1.78803222280287),
(25620, '57766', 218, 49, 89689, 43.3649, 0.756860284798089, -103.1357, -1.80005754134912),
(25621, '57767', 218, 49, 137349, 44.0736, 0.769229433206973, -102.5569, -1.78995557563857),
(25622, '57769', 218, 49, 4996, 44.23, 0.771959128157092, -103.3906, -1.80450638561245),
(25623, '57770', 218, 49, 592, 43.3265, 0.756190078365323, -102.7354, -1.79307098835338),
(25624, '57772', 218, 49, 175908, 43.304, 0.755797379283624, -102.2099, -1.78389928313415),
(25625, '57773', 218, 49, 24139, 43.6096, 0.761131105477719, -103.5935, -1.80804765866475),
(25626, '57774', 218, 49, 341, 43.1733, 0.753516233951268, -103.8769, -1.8129939217649),
(25627, '57775', 218, 49, 11442, 44.081, 0.76935858757162, -102.0668, -1.78140171697455),
(25628, '57776', 218, 49, 202546, 45.2708, 0.790124515011849, -103.5481, -1.80725527918434),
(25629, '57777', 218, 49, 0, 44.7334, 0.780745115611632, -102.654, -1.79165029034226),
(25630, '57779', 218, 49, 202587, 44.5615, 0.777744894627453, -103.7488, -1.81075815499309),
(25631, '57780', 218, 49, 202596, 43.7936, 0.764342511301389, -102.4332, -1.78779660335386),
(25632, '57782', 218, 49, 24925, 43.2686, 0.755179532728418, -103.1661, -1.80058812144172),
(25633, '57783', 218, 49, 202647, 44.4948, 0.776580760016373, -103.8675, -1.81282986081521),
(25634, '57785', 218, 49, 38425, 44.4065, 0.775039634286862, -103.5118, -1.80662172466587),
(25635, '57787', 218, 49, 28825, 44.6576, 0.77942215603862, -102.8108, -1.79438696660939),
(25636, '57788', 218, 49, 52327, 44.6277, 0.778900302592273, -103.3668, -1.80409099725047),
(25637, '57790', 218, 49, 168429, 43.9928, 0.767819207171361, -102.2395, -1.78441590059274),
(25638, '57791', 218, 49, 202752, 44.0983, 0.769660529532215, -102.3339, -1.78606349140663),
(25639, '57792', 218, 49, 202784, 44.6167, 0.778708316374554, -102.4264, -1.78767792096472),
(25640, '57793', 218, 49, 38866, 44.4642, 0.776046689265263, -103.6386, -1.8088348021574),
(25641, '57794', 218, 49, 202803, 43.1584, 0.753256179892721, -102.3586, -1.78649458773187),
(25642, '57799', 218, 49, 202647, 44.4883, 0.776467313614993, -103.8572, -1.81265009190226),
(25643, '58001', 218, 34, 92088, 46.4181, 0.81014867751998, -96.7119, -1.6879410808595),
(25644, '58002', 218, 34, 139556, 46.7551, 0.816030437099201, -97.1131, -1.69494334181851),
(25645, '58004', 218, 34, 118615, 47.0197, 0.820648578299978, -97.2496, -1.69732571624748),
(25646, '58005', 218, 34, 139605, 47.1428, 0.822797078609183, -96.8885, -1.69102333231853),
(25647, '58006', 218, 34, 7168, 47.1081, 0.822191449358741, -97.1969, -1.69640592773168),
(25648, '58007', 218, 34, 129630, 47.0216, 0.820681739555766, -97.5784, -1.70306435882804),
(25649, '58008', 218, 34, 7274, 46.2663, 0.807499267715453, -96.9996, -1.69296239311749),
(25650, '58009', 218, 34, 13397, 47.3649, 0.826673454877862, -97.2699, -1.69768001808563),
(25651, '58011', 218, 34, 26642, 46.9344, 0.819159812448026, -97.493, -1.70157384764683),
(25652, '58012', 218, 34, 139768, 46.9011, 0.818578617807113, -97.2122, -1.69667296310723),
(25653, '58013', 218, 34, 29419, 46.1394, 0.805284444894672, -97.4238, -1.70036607980445),
(25654, '58015', 218, 34, 35243, 46.5326, 0.812147079513513, -96.7823, -1.68916979265291),
(25655, '58016', 218, 34, 695, 47.3675, 0.826718833438414, -97.4099, -1.70012347903842),
(25656, '58017', 218, 34, 35312, 46.0782, 0.804216303392451, -97.8554, -1.70789892085606),
(25657, '58018', 218, 34, 8175, 46.5001, 0.811579847506615, -97.0492, -1.69382807642648),
(25658, '58021', 218, 34, 1977, 46.7142, 0.815316597435135, -97.0679, -1.6941544529966),
(25659, '58027', 218, 34, 139975, 46.6228, 0.813721366498812, -97.6014, -1.70346578455599),
(25660, '58029', 218, 34, 15943, 47.1088, 0.822203666663505, -97.3874, -1.69973077995673),
(25661, '58030', 218, 34, 2379, 46.0543, 0.803799169701224, -96.6019, -1.68602121868231),
(25662, '58031', 218, 34, 140015, 46.7608, 0.816129920866565, -97.7892, -1.70674351289124),
(25663, '58032', 218, 34, 27186, 46.1057, 0.80469626893675, -97.6379, -1.70410282973297),
(25664, '58033', 218, 34, 140038, 46.4565, 0.810818883952746, -97.9084, -1.70882394535962),
(25665, '58035', 218, 34, 32506, 47.2819, 0.825224831598707, -97.3241, -1.69862598654021),
(25666, '58036', 218, 34, 9048, 47.1081, 0.822191449358741, -97.0061, -1.69307583951887),
(25667, '58038', 218, 34, 16264, 47.1952, 0.823711631137228, -97.0701, -1.69419285024015),
(25668, '58040', 218, 34, 140152, 46.2227, 0.806738304161583, -97.6568, -1.7044326969616),
(25669, '58041', 218, 34, 60168, 46.0714, 0.804097621003316, -96.9019, -1.69125720643829),
(25670, '58042', 218, 34, 9373, 46.9838, 0.820022005098512, -96.8902, -1.69105300291581),
(25671, '58043', 218, 34, 3010, 45.9781, 0.802469228811205, -97.6256, -1.70388815423498),
(25672, '58045', 218, 34, 3145, 47.4031, 0.827340170652124, -97.0589, -1.69399737336392),
(25673, '58046', 218, 34, 665, 47.1965, 0.823734320417504, -97.7696, -1.70640142835785),
(25674, '58047', 218, 34, 27467, 46.7413, 0.815789581662426, -96.8861, -1.69098144441648),
(25675, '58048', 218, 34, 3284, 47.195, 0.823708140478724, -97.3238, -1.69862075055246),
(25676, '58049', 218, 34, 109912, 46.7177, 0.815377683958955, -97.9966, -1.71036332575988),
(25677, '58051', 218, 34, 140324, 46.6495, 0.814187369409095, -97.0168, -1.69326258974883),
(25678, '58052', 218, 34, 3733, 46.6506, 0.814206568030867, -97.2463, -1.69726812038216),
(25679, '58053', 218, 34, 140397, 46.0779, 0.804211067404695, -97.1508, -1.69560133094651),
(25680, '58054', 218, 34, 10116, 46.4402, 0.810534395284671, -97.6833, -1.70489520921338),
(25681, '58056', 218, 34, 3909, 47.3122, 0.825753666362061, -97.738, -1.70584990431422),
(25682, '58057', 218, 34, 42042, 46.5048, 0.811661877981459, -97.1895, -1.69627677336703),
(25683, '58058', 218, 34, 140446, 46.1652, 0.805734739841686, -96.9781, -1.69258714732831),
(25684, '58059', 218, 34, 30422, 46.8908, 0.818398848894157, -97.0499, -1.69384029373124),
(25685, '58060', 218, 34, 78753, 46.2586, 0.807364877363049, -97.4561, -1.70092982115285),
(25686, '58061', 218, 34, 140532, 46.269, 0.807546391605256, -96.875, -1.69078771286951),
(25687, '58062', 218, 34, 96569, 46.6743, 0.814620211063589, -97.7869, -1.70670337031844),
(25688, '58063', 218, 34, 140647, 46.9496, 0.81942510249433, -97.7802, -1.70658643325856),
(25689, '58064', 218, 34, 678, 47.1433, 0.822805805255443, -97.6161, -1.70372234795604),
(25690, '58065', 218, 34, 137464, 47.2067, 0.823912344001207, -97.7959, -1.70686044995112),
(25691, '58067', 218, 34, 17882, 46.0523, 0.803764263116185, -97.5028, -1.70174488991353),
(25692, '58068', 218, 34, 57525, 46.5307, 0.812113918257726, -97.4125, -1.70016885759898),
(25693, '58069', 218, 34, 140926, 46.2434, 0.807099587316746, -97.6435, -1.70420056817108),
(25694, '58071', 218, 34, 140972, 46.895, 0.818472152722741, -97.6374, -1.70409410308671),
(25695, '58072', 218, 34, 494, 46.9238, 0.818974807547315, -98.0043, -1.71049771611228),
(25696, '58074', 218, 34, 118232, 46.2822, 0.80777677506652, -96.6088, -1.6861416464007),
(25697, '58075', 218, 34, 118232, 46.2709, 0.807579552861044, -96.6088, -1.6861416464007),
(25698, '58076', 218, 34, 118232, 46.2708, 0.807577807531792, -96.6072, -1.68611372113267),
(25699, '58077', 218, 34, 354, 46.499, 0.811560648884843, -97.0716, -1.69421903017893),
(25700, '58078', 218, 34, 138759, 46.8702, 0.818039311068246, -96.8925, -1.69109314548861),
(25701, '58079', 218, 34, 31509, 46.8763, 0.818145776152618, -97.4085, -1.7000990444289),
(25702, '58081', 218, 34, 141111, 46.2645, 0.807467851788917, -97.1312, -1.69525924641312),
(25703, '58102', 218, 34, 8846, 46.8937, 0.818449463442465, -96.7989, -1.68945951730874),
(25704, '58103', 218, 34, 8846, 46.854, 0.817756567729423, -96.8153, -1.68974575130607),
(25705, '58104', 218, 34, 8846, 46.8202, 0.817166646442249, -96.8079, -1.68961659694142),
(25706, '58105', 218, 34, 8846, 46.9124, 0.818775840012588, -96.793, -1.68935654288287),
(25707, '58106', 218, 34, 8846, 46.8547, 0.817768785034187, -96.8237, -1.68989235896323),
(25708, '58107', 218, 34, 8846, 46.8264, 0.817274856855873, -96.8502, -1.69035487121501),
(25709, '58108', 218, 34, 8846, 46.8535, 0.817747841083163, -96.7982, -1.68944730000397),
(25710, '58109', 218, 34, 8846, 46.8081, 0.816955461602758, -96.8646, -1.6906061986273),
(25711, '58121', 218, 34, 8846, 46.8622, 0.817899684728087, -96.8602, -1.69052940414021),
(25712, '58122', 218, 34, 8846, 46.8846, 0.818290638480533, -96.784, -1.68919946325019);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(25713, '58123', 218, 34, 8846, 46.9262, 0.819016695449363, -96.8503, -1.69035661654426),
(25714, '58124', 218, 34, 8846, 46.8742, 0.818109124238326, -96.7875, -1.68926054977401),
(25715, '58125', 218, 34, 8846, 46.8766, 0.818151012140374, -96.8171, -1.6897771672326),
(25716, '58126', 218, 34, 8846, 46.8742, 0.818109124238326, -96.7852, -1.68922040720122),
(25717, '58201', 218, 34, 140116, 47.9117, 0.836216915227767, -97.0549, -1.69392756019384),
(25718, '58202', 218, 34, 140116, 47.9208, 0.836375740189699, -97.0736, -1.69425393676397),
(25719, '58203', 218, 34, 140116, 47.9292, 0.836522347846866, -97.0717, -1.69422077550818),
(25720, '58204', 218, 34, 0, 47.96, 0.83705990925648, -97.3702, -1.69943058332538),
(25721, '58205', 218, 34, 0, 47.9254, 0.836456025335291, -97.2409, -1.69717387260255),
(25722, '58206', 218, 34, 140116, 47.898, 0.835977805120244, -97.067, -1.69413874503334),
(25723, '58207', 218, 34, 140116, 47.9172, 0.836312908336627, -97.3678, -1.69938869542333),
(25724, '58208', 218, 34, 140116, 47.8817, 0.835693316452169, -97.061, -1.69403402527822),
(25725, '58210', 218, 34, 14941, 48.4128, 0.844962760109511, -98.1221, -1.71255371397113),
(25726, '58212', 218, 34, 139598, 47.7596, 0.833562269435484, -97.9468, -1.70949415179238),
(25727, '58214', 218, 34, 108028, 47.8896, 0.835831197463076, -97.4941, -1.7015930462686),
(25728, '58216', 218, 34, 139647, 48.8585, 0.852741692585649, -97.49, -1.70152148776927),
(25729, '58218', 218, 34, 31939, 47.6023, 0.830816866522097, -97.0991, -1.69469899572323),
(25730, '58219', 218, 34, 1296, 47.4518, 0.828190145997845, -96.9187, -1.69155042175263),
(25731, '58220', 218, 34, 139774, 48.7826, 0.851416987683386, -97.6103, -1.70362111885942),
(25732, '58222', 218, 34, 29586, 48.5863, 0.847990906361721, -97.6656, -1.70458628593577),
(25733, '58223', 218, 34, 15691, 47.5429, 0.829780140946412, -96.976, -1.69255049541402),
(25734, '58224', 218, 34, 139857, 48.1656, 0.840648306198581, -97.9639, -1.70979260309447),
(25735, '58225', 218, 34, 20677, 48.5686, 0.847681983084118, -97.1766, -1.69605162589352),
(25736, '58227', 218, 34, 27051, 48.3979, 0.844702706050964, -97.7471, -1.70600872927615),
(25737, '58228', 218, 34, 139971, 47.92, 0.836361777555683, -97.3673, -1.69937996877707),
(25738, '58229', 218, 34, 2365, 48.4706, 0.845971560417163, -98.2087, -1.71406516910336),
(25739, '58230', 218, 34, 2445, 47.5347, 0.829637023947749, -97.7119, -1.70539437337945),
(25740, '58231', 218, 34, 16057, 48.2385, 0.841920651223285, -97.8378, -1.70759174290771),
(25741, '58233', 218, 34, 21212, 48.2381, 0.841913669906277, -97.4486, -1.70079892145895),
(25742, '58235', 218, 34, 140086, 48.1078, 0.839639505890928, -97.4492, -1.70080939343446),
(25743, '58236', 218, 34, 140092, 48.7062, 0.850083556134862, -97.4472, -1.70077448684942),
(25744, '58237', 218, 34, 27298, 48.4152, 0.845004648011559, -97.4268, -1.70041843968201),
(25745, '58238', 218, 34, 2950, 48.7721, 0.851233728111926, -97.4913, -1.70154417704955),
(25746, '58239', 218, 34, 2961, 48.9458, 0.854265365022641, -98.7367, -1.72328050755389),
(25747, '58240', 218, 34, 3007, 47.6388, 0.831453911699075, -97.4587, -1.7009751997134),
(25748, '58241', 218, 34, 78451, 48.6738, 0.849518069457216, -97.6008, -1.70345531258048),
(25749, '58243', 218, 34, 140244, 48.5072, 0.846610350923393, -97.5836, -1.70315511594914),
(25750, '58244', 218, 34, 113114, 48.1509, 0.840391742798538, -97.6763, -1.70477303616574),
(25751, '58249', 218, 34, 13145, 48.7633, 0.851080139137751, -98.3735, -1.71694147171064),
(25752, '58250', 218, 34, 140366, 48.2888, 0.842798551837038, -98.0603, -1.7114751004934),
(25753, '58251', 218, 34, 55807, 47.9079, 0.836150592716191, -97.6279, -1.70392829680777),
(25754, '58254', 218, 34, 4116, 47.7688, 0.833722839726667, -98.1762, -1.71349793709646),
(25755, '58255', 218, 34, 140438, 48.9435, 0.854225222449845, -98.3931, -1.71728355624403),
(25756, '58256', 218, 34, 95989, 48.1022, 0.839541767452817, -97.2468, -1.69727684702842),
(25757, '58257', 218, 34, 71100, 47.5002, 0.82903488535581, -97.3237, -1.69861900522321),
(25758, '58258', 218, 34, 140487, 47.9799, 0.837407229777627, -97.5053, -1.70178852314483),
(25759, '58259', 218, 34, 132080, 48.0487, 0.838608016302999, -98.1261, -1.71262352714121),
(25760, '58260', 218, 34, 4232, 48.6304, 0.84876059656185, -97.9921, -1.71028478594354),
(25761, '58261', 218, 34, 140517, 48.2904, 0.84282647710507, -97.3706, -1.69943756464239),
(25762, '58262', 218, 34, 49687, 48.6738, 0.849518069457216, -97.7971, -1.70688139390215),
(25763, '58265', 218, 34, 140561, 48.9423, 0.854204278498821, -97.4833, -1.70140455070939),
(25764, '58266', 218, 34, 37421, 47.9775, 0.837365341875579, -97.8179, -1.70724442238656),
(25765, '58267', 218, 34, 14320, 47.7355, 0.833141645085753, -97.5708, -1.70293171380488),
(25766, '58269', 218, 34, 140654, 48.6308, 0.848767577878858, -98.2532, -1.71484184062049),
(25767, '58270', 218, 34, 140669, 48.3967, 0.84468176209994, -97.7443, -1.70595986005709),
(25768, '58271', 218, 34, 56833, 48.9638, 0.854579524288, -97.2468, -1.69727684702842),
(25769, '58272', 218, 34, 14402, 47.9773, 0.837361851217076, -97.9614, -1.70974896986317),
(25770, '58273', 218, 34, 97093, 48.2822, 0.842683360106406, -97.7081, -1.70532805086787),
(25771, '58274', 218, 34, 5188, 47.4993, 0.829019177392542, -97.3718, -1.69945850859341),
(25772, '58275', 218, 34, 5360, 47.6718, 0.832029870352233, -97.1076, -1.69484734870965),
(25773, '58276', 218, 34, 11761, 48.63, 0.848753615244843, -97.4693, -1.70116020461411),
(25774, '58277', 218, 34, 24789, 47.6298, 0.831296832066395, -97.9203, -1.7090316395406),
(25775, '58278', 218, 34, 6317, 47.7756, 0.833841522115803, -97.1049, -1.69480022481984),
(25776, '58281', 218, 34, 38725, 48.9459, 0.854267110351893, -98.5398, -1.71984395425671),
(25777, '58282', 218, 34, 84183, 48.9242, 0.85388837390421, -97.9156, -1.70894960906576),
(25778, '58301', 218, 34, 130489, 48.1117, 0.839707573731756, -98.8575, -1.72538886529029),
(25779, '58310', 218, 34, 129435, 48.998, 0.855176426892182, -100.0515, -1.74622809655911),
(25780, '58311', 218, 34, 39087, 48.6304, 0.84876059656185, -98.5914, -1.72074454415074),
(25781, '58313', 218, 34, 31725, 48.1662, 0.840658778174093, -100.0368, -1.74597153315906),
(25782, '58316', 218, 34, 139658, 48.6645, 0.84935575383678, -99.8407, -1.7425489424959),
(25783, '58317', 218, 34, 31829, 48.6271, 0.848703000696535, -99.3783, -1.73447854003468),
(25784, '58318', 218, 34, 198028, 48.8235, 0.852130827347451, -100.4584, -1.75332984128547),
(25785, '58319', 218, 34, 1103, 47.6639, 0.831891989341325, -99.6645, -1.73947367235389),
(25786, '58321', 218, 34, 139720, 48.2377, 0.841906688589269, -98.3565, -1.7166447657378),
(25787, '58323', 218, 34, 7856, 48.8054, 0.851814922752841, -98.9337, -1.72671880618031),
(25788, '58324', 218, 34, 139758, 48.4881, 0.846276993036263, -99.2037, -1.7314311951607),
(25789, '58325', 218, 34, 139795, 48.315, 0.84325582810106, -99.0818, -1.72930363880252),
(25790, '58327', 218, 34, 139840, 48.0135, 0.837993660406297, -98.6049, -1.72098016359976),
(25791, '58329', 218, 34, 198218, 48.8151, 0.851984219690284, -100.0625, -1.74642008277683),
(25792, '58330', 218, 34, 115414, 48.4563, 0.845721978334128, -98.4488, -1.71825570463739),
(25793, '58331', 218, 34, 139946, 48.6312, 0.848774559195866, -99.101, -1.7296387420189),
(25794, '58332', 218, 34, 20923, 48.0994, 0.839492898233761, -99.6796, -1.73973721707094),
(25795, '58335', 218, 34, 140042, 47.9761, 0.837340907266052, -98.9943, -1.72777647570702),
(25796, '58337', 218, 34, 140162, 47.7745, 0.833822323494031, -99.4474, -1.73568456254781),
(25797, '58338', 218, 34, 2956, 48.5003, 0.846489923205006, -98.6446, -1.7216730593128),
(25798, '58339', 218, 34, 140184, 48.8482, 0.852561923672694, -99.3822, -1.73454660787551),
(25799, '58341', 218, 34, 9372, 47.7699, 0.833742038348439, -99.9302, -1.74411101217644),
(25800, '58343', 218, 34, 30266, 48.3265, 0.84345654096504, -99.6527, -1.73926772350215),
(25801, '58344', 218, 34, 103489, 48.0414, 0.838480607267604, -98.341, -1.71637423970374),
(25802, '58345', 218, 34, 22591, 48.2974, 0.842948650152709, -98.4434, -1.71816145685779),
(25803, '58346', 218, 34, 3719, 48.2521, 0.842158016001556, -99.4306, -1.73539134723347),
(25804, '58348', 218, 34, 140435, 47.9345, 0.836614850297222, -99.5541, -1.73754682885969),
(25805, '58351', 218, 34, 140565, 48.0678, 0.83894137419013, -99.2597, -1.73240857954182),
(25806, '58352', 218, 34, 140547, 48.6315, 0.848779795183622, -98.8487, -1.72523527631612),
(25807, '58353', 218, 34, 140552, 48.6359, 0.84885658967071, -99.6219, -1.73873016209254),
(25808, '58355', 218, 34, 33398, 48.5772, 0.847832081399789, -98.3696, -1.71687340386981),
(25809, '58356', 218, 34, 140572, 47.6812, 0.83219393130192, -99.1361, -1.73025135258635),
(25810, '58357', 218, 34, 140636, 47.9576, 0.837018021354433, -99.1609, -1.73068419424085),
(25811, '58359', 218, 34, 198714, 48.0914, 0.839353271893601, -100.1628, -1.74817064801658),
(25812, '58361', 218, 34, 769, 47.7586, 0.833544816142964, -98.3327, -1.71622937737583),
(25813, '58362', 218, 34, 265, 48.2315, 0.841798478175645, -99.0512, -1.72876956805141),
(25814, '58363', 218, 34, 14400, 48.6822, 0.849664677114384, -99.3935, -1.73474383008098),
(25815, '58365', 218, 34, 0, 48.8588, 0.852746928573406, -99.1311, -1.73016408612375),
(25816, '58366', 218, 34, 140790, 48.6638, 0.849343536532017, -99.8463, -1.74264668093401),
(25817, '58367', 218, 34, 11660, 48.8672, 0.852893536230573, -99.6124, -1.7385643558136),
(25818, '58368', 218, 34, 31014, 48.3672, 0.844166889970601, -99.9959, -1.745257693495),
(25819, '58369', 218, 34, 31032, 48.9451, 0.854253147717877, -99.786, -1.74159424739506),
(25820, '58370', 218, 34, 113341, 47.9403, 0.836716079393838, -98.9061, -1.72623709530676),
(25821, '58372', 218, 34, 140846, 48.9461, 0.854270601010397, -98.9343, -1.72672927815583),
(25822, '58374', 218, 34, 140872, 47.8277, 0.834750838656092, -99.1178, -1.72993195733324),
(25823, '58377', 218, 34, 140916, 48.4485, 0.845585842652473, -98.8006, -1.72439577294591),
(25824, '58379', 218, 34, 12338, 47.9251, 0.836450789347534, -98.8159, -1.72466280832146),
(25825, '58380', 218, 34, 79269, 47.7739, 0.833811851518519, -98.5033, -1.71920690907973),
(25826, '58381', 218, 34, 14798, 47.9056, 0.836110450143396, -98.6727, -1.72216349683261),
(25827, '58382', 218, 34, 18520, 48.326, 0.84344781431878, -98.8757, -1.72570651521416),
(25828, '58384', 218, 34, 99130, 48.6175, 0.848535449088343, -100.2981, -1.75053207849452),
(25829, '58385', 218, 34, 107738, 48.4591, 0.845770847553184, -99.6296, -1.73886455244494),
(25830, '58386', 218, 34, 6986, 48.3262, 0.843451304977284, -99.5233, -1.73700926745007),
(25831, '58401', 218, 34, 3399, 46.9099, 0.818732206781288, -98.704, -1.72270978488848),
(25832, '58402', 218, 34, 3399, 46.9046, 0.818639704330932, -98.7332, -1.72321942103007),
(25833, '58405', 218, 34, 3399, 46.9096, 0.818726970793532, -98.6978, -1.72260157447486),
(25834, '58413', 218, 34, 13302, 46.0352, 0.803465811814094, -99.3718, -1.7343650936333),
(25835, '58415', 218, 34, 376, 46.4085, 0.809981125911788, -98.5293, -1.71966069468525),
(25836, '58416', 218, 34, 58678, 47.5859, 0.83053063252477, -98.3719, -1.71691354644261),
(25837, '58418', 218, 34, 19409, 47.3922, 0.827149929763657, -99.7136, -1.74033062901662),
(25838, '58420', 218, 34, 15362, 47.063, 0.821404305866091, -98.8285, -1.72488271980722),
(25839, '58421', 218, 34, 45425, 47.4503, 0.828163966059065, -99.1232, -1.73002620511284),
(25840, '58422', 218, 34, 139771, 47.5443, 0.82980457555594, -99.4581, -1.73587131277777),
(25841, '58423', 218, 34, 139787, 47.4578, 0.828294865752965, -99.8409, -1.74255243315441),
(25842, '58424', 218, 34, 1620, 46.8923, 0.818425028832937, -99.0703, -1.72910292593854),
(25843, '58425', 218, 34, 26853, 47.4458, 0.828085426242726, -98.1179, -1.71248041014254),
(25844, '58426', 218, 34, 15649, 47.2216, 0.824172398059754, -98.5676, -1.72032915578876),
(25845, '58428', 218, 34, 1989, 46.8067, 0.81693102699323, -99.7636, -1.74120329364261),
(25846, '58429', 218, 34, 139870, 47.1977, 0.823755264368528, -98.1508, -1.71305462346645),
(25847, '58430', 218, 34, 198183, 47.566, 0.830183312003623, -100.2556, -1.74979031356243),
(25848, '58431', 218, 34, 20578, 46.5443, 0.812351283035997, -98.4734, -1.71868505563338),
(25849, '58433', 218, 34, 139937, 46.3599, 0.809132895895319, -98.7118, -1.72284592057014),
(25850, '58436', 218, 34, 13721, 46.0036, 0.802914287770463, -98.5214, -1.71952281367434),
(25851, '58438', 218, 34, 140010, 47.6494, 0.831638916599786, -99.6252, -1.73878775795786),
(25852, '58439', 218, 34, 54802, 46.035, 0.80346232115559, -98.8421, -1.72512008458549),
(25853, '58440', 218, 34, 2600, 46.3637, 0.809199218406895, -99.2886, -1.73291297969564),
(25854, '58441', 218, 34, 2627, 46.1966, 0.806282773226812, -98.3787, -1.71703222883175),
(25855, '58442', 218, 34, 140061, 46.6258, 0.813773726376372, -99.1415, -1.73034560036596),
(25856, '58443', 218, 34, 60054, 47.4326, 0.827855042781462, -98.6911, -1.72248463741498),
(25857, '58444', 218, 34, 9157, 47.4767, 0.828624732981592, -100.1238, -1.7474899696083),
(25858, '58445', 218, 34, 140107, 47.544, 0.829799339568184, -98.8194, -1.72472389484528),
(25859, '58448', 218, 34, 140179, 47.2838, 0.825257992854495, -98.0875, -1.71194983004994),
(25860, '58451', 218, 34, 140264, 47.4142, 0.827533902199095, -99.9693, -1.74479343591397),
(25861, '58452', 218, 34, 88180, 47.5419, 0.829762687653892, -98.2372, -1.71456258794017),
(25862, '58454', 218, 34, 95231, 46.4876, 0.811361681350116, -98.813, -1.72461219377316),
(25863, '58455', 218, 34, 140312, 47.3006, 0.82555120816883, -98.7325, -1.7232072037253),
(25864, '58456', 218, 34, 140339, 46.2989, 0.808068245051603, -98.9469, -1.72694918964158),
(25865, '58458', 218, 34, 140344, 46.355, 0.809047374761971, -98.2914, -1.71550855639475),
(25866, '58460', 218, 34, 60613, 46.2807, 0.80775059512774, -99.3515, -1.73401079179515),
(25867, '58461', 218, 34, 140407, 46.7181, 0.815384665275963, -98.2067, -1.71403026251832),
(25868, '58463', 218, 34, 27848, 47.483, 0.828734688724467, -100.4444, -1.75308549519019),
(25869, '58464', 218, 34, 37130, 47.5433, 0.82978712226342, -98.5635, -1.72025759728943),
(25870, '58466', 218, 34, 630, 46.5633, 0.812682895593876, -98.2444, -1.71468825164632),
(25871, '58467', 218, 34, 10432, 46.8931, 0.818438991466953, -99.2998, -1.73310845657187),
(25872, '58472', 218, 34, 23162, 46.6691, 0.814529453942486, -98.5856, -1.72064331505412),
(25873, '58474', 218, 34, 140630, 46.138, 0.805260010285144, -98.0887, -1.71197077400096),
(25874, '58475', 218, 34, 97025, 47.1108, 0.822238573248545, -99.5443, -1.73737578659299),
(25875, '58476', 218, 34, 140703, 47.1351, 0.822662688256779, -99.0315, -1.72842573818876),
(25876, '58477', 218, 34, 68152, 47.1571, 0.823046660692218, -100.5212, -1.75442590805572),
(25877, '58478', 218, 34, 11625, 47.158, 0.823062368655486, -99.683, -1.73979655826551),
(25878, '58479', 218, 34, 874, 47.0558, 0.821278642159948, -98.21, -1.71408785838363),
(25879, '58480', 218, 34, 17956, 46.8925, 0.818428519491441, -98.2482, -1.71475457415789),
(25880, '58481', 218, 34, 140905, 47.1102, 0.822228101273033, -98.657, -1.72188948014005),
(25881, '58482', 218, 34, 6066, 46.8569, 0.817807182277731, -99.9148, -1.74384223147163),
(25882, '58483', 218, 34, 98322, 46.6569, 0.814316523773742, -99.3584, -1.73413121951353),
(25883, '58484', 218, 34, 12229, 47.3701, 0.826764211998966, -98.4348, -1.71801135854211),
(25884, '58486', 218, 34, 140948, 47.4137, 0.827525175552835, -99.3942, -1.73475604738575),
(25885, '58487', 218, 34, 140952, 46.8069, 0.816934517651734, -99.5733, -1.73788193207607),
(25886, '58488', 218, 34, 12418, 47.1978, 0.82375700969778, -99.9878, -1.74511632182559),
(25887, '58489', 218, 34, 141005, 46.0403, 0.803554823605945, -99.4864, -1.73636524095609),
(25888, '58490', 218, 34, 12546, 46.3701, 0.809310919479023, -98.0973, -1.71212087231663),
(25889, '58492', 218, 34, 52864, 47.1717, 0.823301478763009, -98.4596, -1.71844420019661),
(25890, '58494', 218, 34, 6883, 47.1527, 0.82296986620513, -100.3325, -1.75113247175721),
(25891, '58495', 218, 34, 141096, 46.2572, 0.807340442753521, -99.5544, -1.73755206484744),
(25892, '58496', 218, 34, 44230, 47.1441, 0.822819767889459, -99.3022, -1.73315034447391),
(25893, '58497', 218, 34, 26308, 46.7613, 0.816138647512824, -98.4388, -1.71808117171219),
(25894, '58501', 218, 34, 7498, 46.8179, 0.817126503869453, -100.7797, -1.75893758417213),
(25895, '58502', 218, 34, 7498, 46.849, 0.817669301266823, -100.7176, -1.75785373470664),
(25896, '58503', 218, 34, 7498, 46.8632, 0.817917138020607, -100.7688, -1.75874734328366),
(25897, '58504', 218, 34, 7498, 46.7867, 0.816581961142831, -100.7778, -1.75890442291634),
(25898, '58505', 218, 34, 7498, 46.849, 0.817669301266823, -100.717, -1.75784326273113),
(25899, '58506', 218, 34, 7498, 46.7298, 0.815588868798446, -100.6195, -1.75614156671043),
(25900, '58507', 218, 34, 7498, 46.7947, 0.816721587482991, -100.7566, -1.75853441311492),
(25901, '58520', 218, 34, 112747, 46.6974, 0.8150233821208, -101.5414, -1.77223175708457),
(25902, '58521', 218, 34, 722, 46.9793, 0.819943465282172, -100.7514, -1.75844365599382),
(25903, '58523', 218, 34, 616, 47.267, 0.82496477754016, -101.777, -1.77634375280227),
(25904, '58524', 218, 34, 604, 46.5896, 0.81314191718715, -100.2656, -1.74996484648763),
(25905, '58528', 218, 34, 198083, 46.3789, 0.809464508453198, -100.6126, -1.75602113899205),
(25906, '58529', 218, 34, 572, 46.4215, 0.810208018714548, -101.566, -1.77266110808056),
(25907, '58530', 218, 34, 1440, 47.1115, 0.822250790553309, -101.2947, -1.7679260298199),
(25908, '58531', 218, 34, 198132, 47.5166, 0.829321119353138, -100.9182, -1.76135486518614),
(25909, '58532', 218, 34, 93823, 46.8511, 0.817705953181115, -100.1406, -1.74778318492263),
(25910, '58533', 218, 34, 2254, 46.4031, 0.809886878132181, -101.828, -1.77723387072079),
(25911, '58535', 218, 34, 198288, 46.4565, 0.810818883952746, -101.2323, -1.76683694436666),
(25912, '58538', 218, 34, 198298, 46.0792, 0.804233756684971, -100.6407, -1.75651157651186),
(25913, '58540', 218, 34, 27246, 47.6546, 0.83172967372089, -101.4114, -1.76996282905698),
(25914, '58541', 218, 34, 135600, 47.3014, 0.825565170802846, -102.0657, -1.78138251835278),
(25915, '58542', 218, 34, 16318, 46.0647, 0.803980683943432, -99.9415, -1.74430823438191),
(25916, '58544', 218, 34, 32727, 46.4838, 0.81129535883854, -100.2775, -1.75017254066861),
(25917, '58545', 218, 34, 3035, 47.298, 0.825505829608278, -101.6236, -1.77366641772971),
(25918, '58549', 218, 34, 140330, 46.589, 0.813131445211638, -99.9783, -1.74495051554665),
(25919, '58552', 218, 34, 3792, 46.2673, 0.807516721007972, -100.2303, -1.74934874526167),
(25920, '58554', 218, 34, 131885, 46.8291, 0.817321980745677, -100.8903, -1.76086791832484),
(25921, '58558', 218, 34, 33248, 46.8227, 0.817210279673549, -100.5993, -1.75578901020153),
(25922, '58559', 218, 34, 17095, 47.4583, 0.828303592399225, -100.7366, -1.75818534726452),
(25923, '58560', 218, 34, 198632, 46.6774, 0.814674316270401, -100.2695, -1.75003291432845),
(25924, '58561', 218, 34, 4479, 46.5038, 0.811644424688939, -99.7681, -1.74128183345895),
(25925, '58562', 218, 34, 198661, 46.2182, 0.806659764345243, -101.8637, -1.77785695326375),
(25926, '58563', 218, 34, 10782, 46.8434, 0.817571562828712, -101.4125, -1.76998202767875),
(25927, '58564', 218, 34, 185, 46.3391, 0.808769867410904, -101.26, -1.76732040056946),
(25928, '58565', 218, 34, 5416, 47.5016, 0.829059319965339, -101.3709, -1.76925597070992),
(25929, '58566', 218, 34, 31028, 46.5811, 0.812993564200731, -100.8916, -1.76089060760511),
(25930, '58568', 218, 34, 198878, 46.0394, 0.803539115642677, -101.276, -1.76759965324978),
(25931, '58569', 218, 34, 28593, 46.2011, 0.806361313043152, -101.2342, -1.76687010562244),
(25932, '58570', 218, 34, 198910, 46.2751, 0.807652856689628, -100.8047, -1.75937391648513),
(25933, '58571', 218, 34, 6052, 47.3834, 0.826996340789481, -101.3951, -1.7696783403889),
(25934, '58572', 218, 34, 25116, 46.8515, 0.817712934498123, -100.2665, -1.74998055445089),
(25935, '58573', 218, 34, 28710, 46.2832, 0.80779422835904, -100.2122, -1.74903284066706),
(25936, '58575', 218, 34, 176745, 47.5187, 0.829357771267429, -100.8898, -1.76085919167858),
(25937, '58576', 218, 34, 6443, 47.4534, 0.828218071265877, -101.1375, -1.76518237223577),
(25938, '58577', 218, 34, 12668, 47.2929, 0.825416817816426, -101.0263, -1.76324156610755),
(25939, '58579', 218, 34, 287, 47.1561, 0.823029207399698, -100.7844, -1.75901961464697),
(25940, '58580', 218, 34, 199130, 47.2984, 0.825512810925286, -101.929, -1.7789966532653),
(25941, '58581', 218, 34, 133838, 46.0266, 0.803315713498422, -99.7246, -1.74052261523434),
(25942, '58601', 218, 34, 2041, 46.8822, 0.818248750578486, -102.7862, -1.7939576156134),
(25943, '58602', 218, 34, 2041, 46.8844, 0.818287147822029, -102.7845, -1.79392794501611),
(25944, '58620', 218, 34, 197930, 46.1781, 0.805959887315194, -103.3952, -1.80458667075804),
(25945, '58621', 218, 34, 19108, 46.9167, 0.818850889170424, -104.0043, -1.81521747123194),
(25946, '58622', 218, 34, 39310, 46.8884, 0.818356960992109, -103.1985, -1.80115360811937),
(25947, '58623', 218, 34, 7625, 46.1814, 0.806017483180509, -103.4, -1.80467044656214),
(25948, '58625', 218, 34, 75669, 47.3038, 0.825607058704894, -102.1794, -1.78336695771229),
(25949, '58626', 218, 34, 198214, 47.352, 0.826448307404355, -102.5637, -1.79007425802771),
(25950, '58627', 218, 34, 2367, 47.1317, 0.822603347062212, -103.355, -1.80388504839874),
(25951, '58630', 218, 34, 2726, 46.8598, 0.817857796826039, -102.5644, -1.79008647533247),
(25952, '58631', 218, 34, 198336, 46.8189, 0.817143957161973, -101.8407, -1.77745552753579),
(25953, '58632', 218, 34, 198346, 46.6636, 0.814433460833626, -103.9403, -1.81410046051066),
(25954, '58634', 218, 34, 198365, 47.4483, 0.828129059474025, -103.3472, -1.80374891271708),
(25955, '58636', 218, 34, 9297, 47.3429, 0.826289482442423, -102.3357, -1.78609490733316),
(25956, '58638', 218, 34, 940, 46.9037, 0.818623996367664, -102.0323, -1.78079957838261),
(25957, '58639', 218, 34, 198425, 46.0061, 0.802957921001763, -102.6452, -1.79149670136808),
(25958, '58640', 218, 34, 198480, 47.3707, 0.826774683974478, -102.7552, -1.79341656354528),
(25959, '58641', 218, 34, 198514, 46.7174, 0.815372447971199, -102.7648, -1.79358411515347),
(25960, '58642', 218, 34, 10288, 47.1155, 0.822320603723388, -102.6416, -1.79143386951501),
(25961, '58643', 218, 34, 198579, 46.3851, 0.809572718866822, -103.8488, -1.81250348424509),
(25962, '58644', 218, 34, 4011, 47.1379, 0.822711557475835, -102.3322, -1.78603382080934),
(25963, '58645', 218, 34, 30481, 46.769, 0.816273037865228, -103.4259, -1.8051224868384),
(25964, '58646', 218, 34, 17196, 46.3746, 0.809389459295362, -102.3227, -1.7858680145304),
(25965, '58647', 218, 34, 23333, 46.5395, 0.812267507231901, -102.8656, -1.79534340703948),
(25966, '58649', 218, 34, 166368, 46.1129, 0.804821932642893, -102.9331, -1.79652150428458),
(25967, '58650', 218, 34, 105645, 46.441, 0.810548357918687, -102.6151, -1.79097135726323),
(25968, '58651', 218, 34, 198799, 46.1838, 0.806059371082557, -103.3948, -1.80457968944103),
(25969, '58652', 218, 34, 198803, 46.8852, 0.818301110456045, -102.3198, -1.78581739998209),
(25970, '58653', 218, 34, 5701, 46.1131, 0.804825423301397, -103.1197, -1.7997782886688),
(25971, '58654', 218, 34, 198880, 46.8047, 0.81689612040819, -103.7344, -1.81050682758081),
(25972, '58655', 218, 34, 198923, 46.7251, 0.815506838323602, -103.0598, -1.79873283644685),
(25973, '58656', 218, 34, 6252, 46.9533, 0.819489679676654, -102.3134, -1.78570569890997),
(25974, '58701', 218, 34, 60909, 48.2327, 0.841819422126669, -101.2949, -1.7679295204784),
(25975, '58702', 218, 34, 60909, 48.2309, 0.841788006200133, -101.3084, -1.76816513992742),
(25976, '58703', 218, 34, 60909, 48.2674, 0.842425051377111, -101.3112, -1.76821400914648),
(25977, '58704', 218, 34, 0, 48.4247, 0.845170454290498, -101.3208, -1.76838156075467),
(25978, '58705', 218, 34, 0, 48.4226, 0.845133802376206, -101.3372, -1.768667794752),
(25979, '58707', 218, 34, 60909, 48.232, 0.841807204821905, -101.2953, -1.76793650179541),
(25980, '58710', 218, 34, 197935, 47.8481, 0.835106885823499, -100.2618, -1.74989852397605),
(25981, '58711', 218, 34, 107995, 48.9466, 0.854279327656656, -101.3653, -1.76915823227181),
(25982, '58712', 218, 34, 62680, 47.9784, 0.837381049838847, -100.5199, -1.75440321877545),
(25983, '58713', 218, 34, 197973, 48.5026, 0.846530065777802, -100.7853, -1.75903532261024),
(25984, '58716', 218, 34, 19194, 47.7614, 0.83359368536202, -101.0354, -1.76340039106948),
(25985, '58718', 218, 34, 197996, 48.3281, 0.843484466233072, -101.9214, -1.77886400824215),
(25986, '58721', 218, 34, 198032, 48.8129, 0.85194582244674, -102.2056, -1.78382423397632),
(25987, '58722', 218, 34, 1239, 48.2607, 0.842308114317227, -101.4389, -1.77044279460128),
(25988, '58723', 218, 34, 141415, 47.7609, 0.83358495871576, -100.6497, -1.75666865614454),
(25989, '58725', 218, 34, 198088, 48.4159, 0.845016865316323, -101.7124, -1.77521627010548),
(25990, '58727', 218, 34, 1718, 48.894, 0.853361284470108, -102.7957, -1.79412342189234),
(25991, '58730', 218, 34, 1897, 48.9138, 0.853706859662002, -103.2945, -1.80282912420128),
(25992, '58731', 218, 34, 54395, 48.4146, 0.844994176036047, -100.9937, -1.7626725887714),
(25993, '58733', 218, 34, 198186, 48.2408, 0.841960793796081, -101.5981, -1.77322135877045),
(25994, '58734', 218, 34, 46637, 48.4596, 0.845779574199444, -101.9072, -1.77861617148837),
(25995, '58735', 218, 34, 2088, 47.8913, 0.83586086806036, -101.55, -1.77238185540024),
(25996, '58736', 218, 34, 35626, 47.924, 0.836431590725762, -100.3708, -1.75180093286072),
(25997, '58737', 218, 34, 198293, 48.9172, 0.85376620085657, -102.2996, -1.78546484347319),
(25998, '58740', 218, 34, 119792, 48.5194, 0.846823281092137, -101.2378, -1.76693293747552),
(25999, '58741', 218, 34, 55048, 48.2531, 0.842175469294076, -100.7828, -1.75899168937894),
(26000, '58744', 218, 34, 198465, 48.1368, 0.840145651374006, -100.49, -1.7538813653291),
(26001, '58746', 218, 34, 198472, 48.6769, 0.849572174664028, -102.0707, -1.78146978481538),
(26002, '58747', 218, 34, 198483, 47.8047, 0.834349412928133, -100.5202, -1.7544084547632),
(26003, '58748', 218, 34, 22435, 48.6794, 0.849615807895328, -100.6571, -1.75679781050918),
(26004, '58750', 218, 34, 163579, 48.6183, 0.848549411722359, -101.4069, -1.76988428924064),
(26005, '58752', 218, 34, 331, 48.8072, 0.851846338679376, -102.5454, -1.78975486277459),
(26006, '58755', 218, 34, 10403, 48.5888, 0.848034539593021, -102.9512, -1.79683740887919),
(26007, '58756', 218, 34, 198565, 48.0228, 0.838155976026733, -101.8314, -1.77729321191535),
(26008, '58757', 218, 34, 198572, 47.8443, 0.835040563311923, -102.7094, -1.79261720274786),
(26009, '58758', 218, 34, 882, 47.718, 0.832836212466654, -100.1211, -1.74744284571849),
(26010, '58759', 218, 34, 56134, 47.8227, 0.834663572193492, -101.2971, -1.76796791772195),
(26011, '58760', 218, 34, 198589, 48.7982, 0.851689259046697, -101.3252, -1.76845835524176),
(26012, '58761', 218, 34, 198633, 48.7641, 0.851094101771767, -101.522, -1.77189316320968),
(26013, '58762', 218, 34, 4565, 48.6874, 0.849755434235487, -101.0032, -1.76283839505034),
(26014, '58763', 218, 34, 710, 47.9821, 0.837445627021171, -102.485, -1.78870068390639),
(26015, '58765', 218, 34, 96565, 48.8885, 0.853265291361248, -103.0092, -1.79784969984534),
(26016, '58768', 218, 34, 23480, 48.2398, 0.841943340503561, -100.9498, -1.76190638922977),
(26017, '58769', 218, 34, 28171, 48.3284, 0.843489702220828, -102.2451, -1.78451363903085),
(26018, '58770', 218, 34, 194365, 47.9463, 0.836820799148957, -102.13, -1.78250476506181),
(26019, '58771', 218, 34, 195477, 48.023, 0.838159466685237, -101.9604, -1.77954468665043),
(26020, '58772', 218, 34, 24085, 48.9462, 0.854272346339648, -102.5458, -1.7897618440916),
(26021, '58773', 218, 34, 175943, 48.628, 0.848718708659803, -102.5883, -1.7905036090237),
(26022, '58775', 218, 34, 166655, 47.695, 0.832434786738696, -101.6785, -1.77462460348905),
(26023, '58776', 218, 34, 11692, 48.3286, 0.843493192879332, -102.5035, -1.78902356981801),
(26024, '58778', 218, 34, 198840, 47.7612, 0.833590194703516, -100.8428, -1.76003888693014),
(26025, '58779', 218, 34, 57320, 47.826, 0.834721168058808, -101.8241, -1.77716580287996),
(26026, '58781', 218, 34, 33898, 48.0664, 0.838916939580602, -101.0794, -1.76416833594036),
(26027, '58782', 218, 34, 14604, 48.9461, 0.854270601010397, -101.8236, -1.7771570762337),
(26028, '58783', 218, 34, 198916, 48.9509, 0.854354376814492, -100.736, -1.75817487528901),
(26029, '58784', 218, 34, 196, 48.3121, 0.843205213552752, -102.3949, -1.78712814225034),
(26030, '58785', 218, 34, 121636, 48.2373, 0.841899707272261, -101.1339, -1.76511954038269),
(26031, '58787', 218, 34, 199003, 48.8214, 0.85209417543316, -101.8686, -1.7779424743971),
(26032, '58788', 218, 34, 168017, 48.3508, 0.843880655973274, -100.4045, -1.75238910881865),
(26033, '58789', 218, 34, 189738, 48.5892, 0.848041520910029, -100.7324, -1.75811204343594),
(26034, '58790', 218, 34, 199041, 48.058, 0.838770331923435, -100.9336, -1.76162364589095),
(26035, '58792', 218, 34, 199047, 47.9352, 0.836627067601986, -100.7776, -1.75890093225784),
(26036, '58793', 218, 34, 158327, 48.8994, 0.853455532249715, -101.0889, -1.7643341422193),
(26037, '58794', 218, 34, 138811, 48.4598, 0.845783064857948, -102.8197, -1.79454230091281),
(26038, '58795', 218, 34, 121982, 48.5901, 0.848057228873297, -103.2113, -1.80137701026362),
(26039, '58801', 218, 34, 18638, 48.1598, 0.840547077101965, -103.6263, -1.8086201266594),
(26040, '58802', 218, 34, 18638, 48.1519, 0.840409196091058, -103.6181, -1.80847700966074),
(26041, '58830', 218, 34, 7039, 48.5902, 0.848058974202549, -103.4065, -1.80478389296352),
(26042, '58831', 218, 34, 7048, 47.8569, 0.835260474797674, -103.6441, -1.80893079526625),
(26043, '58833', 218, 34, 18836, 48.7891, 0.851530434084765, -103.7234, -1.81031484136309),
(26044, '58835', 218, 34, 197949, 47.8075, 0.834398282147189, -103.4394, -1.80535810628742),
(26045, '58838', 218, 34, 1387, 47.6137, 0.831015834056824, -103.8432, -1.81240574580698),
(26046, '58843', 218, 34, 127444, 48.2412, 0.841967775113089, -103.3451, -1.80371226080279),
(26047, '58844', 218, 34, 54818, 48.9467, 0.854281072985909, -103.8877, -1.81318241732411),
(26048, '58845', 218, 34, 198371, 48.5899, 0.848053738214793, -103.9217, -1.81377582926979),
(26049, '58847', 218, 34, 16697, 47.9593, 0.837047691951716, -102.8681, -1.79538704027078),
(26050, '58849', 218, 34, 5300, 48.3449, 0.843777681547407, -103.1677, -1.80061604670975),
(26051, '58852', 218, 34, 25513, 48.3968, 0.844683507429192, -102.9358, -1.79656862817438),
(26052, '58853', 218, 34, 6381, 48.0465, 0.838569619059456, -103.9013, -1.81341978210238),
(26053, '58854', 218, 34, 199062, 47.8016, 0.834295307721321, -103.2796, -1.80256907014274),
(26054, '58856', 218, 34, 193187, 48.5896, 0.848048502227037, -103.6669, -1.80932873033571),
(26055, '59001', 218, 31, 195835, 45.5208, 0.794487838141835, -109.4436, -1.91015116523567),
(26056, '59002', 218, 31, 29062, 45.9268, 0.801573874904932, -108.694, -1.89706817716272),
(26057, '59003', 218, 31, 13301, 45.5473, 0.794950350393613, -106.2668, -1.85470554555831),
(26058, '59004', 218, 31, 13301, 45.6232, 0.796275055295877, -106.3145, -1.85553806761151),
(26059, '59006', 218, 31, 195920, 45.9561, 0.802085256375766, -108.0942, -1.88659969230925),
(26060, '59007', 218, 31, 53377, 45.1614, 0.788215124810167, -109.1573, -1.90515428758721),
(26061, '59008', 218, 31, 34750, 45.0671, 0.786569279325537, -109.165, -1.90528867793961),
(26062, '59010', 218, 31, 186415, 46.0806, 0.804258191294499, -107.172, -1.87050426594736),
(26063, '59011', 218, 31, 196005, 45.8339, 0.799952464029829, -109.9523, -1.91902965514056),
(26064, '59012', 218, 31, 196016, 45.3072, 0.790759814859575, -106.4922, -1.85863951769231),
(26065, '59013', 218, 31, 1069, 45.4582, 0.793395262030086, -109.0663, -1.90356603796789),
(26066, '59014', 218, 31, 193221, 45.2954, 0.79055386600784, -108.9138, -1.9009044108586),
(26067, '59015', 218, 31, 29300, 46.1987, 0.806319425141104, -108.9171, -1.90096200672392),
(26068, '59016', 218, 31, 31938, 45.5172, 0.794425006288763, -106.8741, -1.86530493010567),
(26069, '59018', 218, 31, 196236, 45.7099, 0.797788255757356, -110.4571, -1.92784007720463),
(26070, '59019', 218, 31, 1718, 45.6371, 0.796517656061904, -109.2566, -1.90688739953444),
(26071, '59020', 218, 31, 196267, 45.0166, 0.785687888053279, -109.9333, -1.91869804258268),
(26072, '59022', 218, 31, 196305, 45.6455, 0.796664263719072, -107.4665, -1.87564426059449),
(26073, '59024', 218, 31, 35479, 46.2038, 0.806408436932956, -107.6796, -1.87936355723049),
(26074, '59025', 218, 31, 29617, 45.1309, 0.787682799388309, -106.6982, -1.86223489595141),
(26075, '59026', 218, 31, 15886, 45.507, 0.79424698270506, -109.0085, -1.90255723766024),
(26076, '59027', 218, 31, 196431, 45.1825, 0.788583389282338, -110.9375, -1.93622463893121),
(26077, '59028', 218, 31, 196483, 45.3003, 0.790639387141187, -109.7882, -1.91616556983804),
(26078, '59029', 218, 31, 196547, 45.3917, 0.79223461807751, -108.9094, -1.90082761637151),
(26079, '59030', 218, 31, 115683, 45.036, 0.786026481928166, -110.7055, -1.93217547506658),
(26080, '59031', 218, 31, 196569, 45.4718, 0.793632626808358, -107.2612, -1.87206109964014),
(26081, '59032', 218, 31, 196629, 47.6022, 0.830815121192845, -108.7046, -1.89725318206343),
(26082, '59033', 218, 31, 196644, 45.775, 0.798924465100404, -109.6872, -1.91440278729352),
(26083, '59034', 218, 31, 9325, 45.7179, 0.797927882097516, -107.6184, -1.87829541572827),
(26084, '59035', 218, 31, 0, 45.2942, 0.790532922056816, -107.822, -1.88184890608533),
(26085, '59036', 218, 31, 196670, 46.4367, 0.810473308760851, -109.833, -1.91694747734293),
(26086, '59037', 218, 31, 13999, 45.8868, 0.800875743204134, -108.2685, -1.88964180119548),
(26087, '59038', 218, 31, 196759, 46.2908, 0.807926873382191, -107.2301, -1.87151830224277),
(26088, '59039', 218, 31, 60380, 46.6684, 0.814517236637722, -107.5291, -1.87673683670623),
(26089, '59041', 218, 31, 95202, 45.4834, 0.793835085001589, -108.973, -1.90193764577578),
(26090, '59043', 218, 31, 196869, 45.5762, 0.79545475054744, -106.5306, -1.85930972412507),
(26091, '59044', 218, 31, 14092, 45.6713, 0.797114558666086, -108.7621, -1.89825674638332),
(26092, '59046', 218, 31, 196881, 46.225, 0.806778446734379, -108.7143, -1.89742247900087),
(26093, '59047', 218, 31, 3825, 45.6562, 0.796851013949035, -110.5675, -1.92976692069883),
(26094, '59050', 218, 31, 196929, 45.294, 0.790529431398312, -107.8212, -1.88183494345131),
(26095, '59052', 218, 31, 42042, 45.5424, 0.794864829260266, -110.3033, -1.92515576081506),
(26096, '59053', 218, 31, 196989, 46.4734, 0.811113844596333, -110.4921, -1.92845094244283),
(26097, '59054', 218, 31, 197021, 46.5986, 0.81329899681983, -107.8693, -1.88267444682152),
(26098, '59055', 218, 31, 27871, 46.0747, 0.804155216868631, -109.877, -1.91771542221381),
(26099, '59057', 218, 31, 197078, 45.8635, 0.800469081488419, -108.802, -1.89895313275487),
(26100, '59058', 218, 31, 56387, 46.928, 0.819048111375899, -107.7794, -1.88110539582398),
(26101, '59059', 218, 31, 195366, 46.5158, 0.811853864199178, -108.0892, -1.88651242584666),
(26102, '59061', 218, 31, 96645, 45.4419, 0.793110773362011, -109.8355, -1.91699111057423),
(26103, '59062', 218, 31, 156982, 45.3947, 0.79228697795507, -105.9844, -1.84977673575068),
(26104, '59063', 218, 31, 4864, 45.632, 0.796428644270052, -108.9127, -1.90088521223683),
(26105, '59064', 218, 31, 197277, 45.953, 0.802031151168954, -107.9787, -1.8845838370232),
(26106, '59065', 218, 31, 175964, 45.4337, 0.792967656363348, -110.6814, -1.93175485071685),
(26107, '59066', 218, 31, 11420, 45.419, 0.792711092963304, -108.5316, -1.89423376245748),
(26108, '59067', 218, 31, 197337, 45.9807, 0.802514607371757, -109.3158, -1.90792063445162),
(26109, '59068', 218, 31, 197345, 45.1863, 0.788649711793914, -109.2508, -1.90678617043782),
(26110, '59069', 218, 31, 197352, 45.7069, 0.797735895879796, -109.5423, -1.91187380520738),
(26111, '59070', 218, 31, 5442, 45.3969, 0.792325375198614, -109.1692, -1.90536198176819),
(26112, '59071', 218, 31, 24518, 45.3747, 0.791937912104671, -109.4256, -1.90983700597031),
(26113, '59072', 218, 31, 192143, 46.41, 0.810007305850568, -108.5484, -1.89452697777181),
(26114, '59073', 218, 31, 192143, 46.4485, 0.810679257612586, -108.5388, -1.89435942616362),
(26115, '59074', 218, 31, 197451, 46.2801, 0.807740123152228, -109.2861, -1.90740227166378),
(26116, '59075', 218, 31, 197466, 45.4761, 0.793707675966193, -107.8793, -1.88284897974672),
(26117, '59076', 218, 31, 11797, 46.291, 0.807930364040695, -107.0958, -1.86917432505734),
(26118, '59077', 218, 31, 24641, 47.0145, 0.820557821178874, -107.2724, -1.87225657651637),
(26119, '59078', 218, 31, 11896, 46.3764, 0.809420875221898, -109.5914, -1.91273076187011),
(26120, '59079', 218, 31, 28589, 45.9477, 0.801938648718599, -108.3526, -1.89110962309641),
(26121, '59081', 218, 31, 197543, 45.1045, 0.787222032465782, -110.2221, -1.92373855346244),
(26122, '59082', 218, 31, 6023, 45.738, 0.798278693277167, -110.2263, -1.92381185729103),
(26123, '59083', 218, 31, 18211, 46.6188, 0.813651553328733, -107.5505, -1.87711033716616),
(26124, '59084', 218, 31, 197679, 47.0381, 0.820969718882345, -108.6097, -1.89559686460329),
(26125, '59085', 218, 31, 0, 46.4244, 0.810258633262856, -110.0714, -1.92110834227969),
(26126, '59086', 218, 31, 197859, 46.0548, 0.803807896347485, -110.6943, -1.93197999819036),
(26127, '59087', 218, 31, 197865, 47.0028, 0.820353617656391, -108.3527, -1.89111136842566),
(26128, '59088', 218, 31, 12958, 45.9895, 0.802668196345932, -108.1752, -1.88801340900337),
(26129, '59089', 218, 31, 12983, 45.0787, 0.786771737518768, -107.6704, -1.8792029869393),
(26130, '59101', 218, 31, 53485, 45.7723, 0.798877341210601, -108.4826, -1.893378551124),
(26131, '59102', 218, 31, 53485, 45.7823, 0.7990518741358, -108.5796, -1.89507152049844),
(26132, '59103', 218, 31, 53485, 45.6359, 0.79649671211088, -108.3613, -1.89126146674133),
(26133, '59104', 218, 31, 53485, 45.7759, 0.798940173063672, -108.582, -1.89511340840048),
(26134, '59105', 218, 31, 53485, 45.8373, 0.800011805224397, -108.4661, -1.89309057179742),
(26135, '59106', 218, 31, 53485, 45.7674, 0.798791820077253, -108.6644, -1.89655155970413),
(26136, '59107', 218, 31, 53485, 45.8167, 0.799652267398486, -108.5043, -1.89375728757168),
(26137, '59108', 218, 31, 53485, 45.7748, 0.7989209744419, -108.5819, -1.89511166307123),
(26138, '59111', 218, 31, 53485, 45.6366, 0.796508929415644, -108.3613, -1.89126146674133),
(26139, '59112', 218, 31, 53485, 45.7914, 0.799210699097731, -108.5388, -1.89435942616362),
(26140, '59114', 218, 31, 53485, 45.6424, 0.79661015851226, -108.396, -1.89186709599177),
(26141, '59115', 218, 31, 53485, 45.784, 0.799081544733084, -108.5082, -1.89382535541251),
(26142, '59116', 218, 31, 53485, 45.77, 0.798837198637805, -108.5799, -1.89507675648619),
(26143, '59117', 218, 31, 53485, 45.7839, 0.799079799403832, -108.5045, -1.89376077823019),
(26144, '59201', 218, 31, 197872, 48.1077, 0.839637760561676, -105.5659, -1.84247253283108),
(26145, '59211', 218, 31, 31653, 48.6865, 0.849739726272219, -104.455, -1.82308367017068),
(26146, '59212', 218, 31, 92407, 48.1401, 0.840203247239322, -104.2196, -1.81897516511148),
(26147, '59213', 218, 31, 19523, 48.3309, 0.843533335452127, -104.8736, -1.83038961841953),
(26148, '59214', 218, 31, 129951, 47.2163, 0.824079895609399, -105.8407, -1.84726869761556),
(26149, '59215', 218, 31, 93252, 47.4281, 0.827776502965123, -105.6196, -1.8434097746394),
(26150, '59217', 218, 31, 29571, 47.7114, 0.832721020736023, -104.1829, -1.818334629276),
(26151, '59218', 218, 31, 39967, 48.1475, 0.84033240160397, -104.5161, -1.82415006634365),
(26152, '59219', 218, 31, 8383, 48.6065, 0.848343462870624, -104.2483, -1.8194760746068),
(26153, '59221', 218, 31, 500, 47.8551, 0.835229058871138, -104.0458, -1.81594178287152),
(26154, '59222', 218, 31, 196489, 48.7113, 0.850172567926714, -105.1475, -1.83517007524074),
(26155, '59223', 218, 31, 0, 48.0076, 0.83789068598043, -106.4444, -1.85780525030985),
(26156, '59225', 218, 31, 35988, 48.2656, 0.842393635450575, -105.9481, -1.8491431812322),
(26157, '59226', 218, 31, 196546, 48.3363, 0.843627583231735, -104.4899, -1.82369279007962),
(26158, '59230', 218, 31, 2722, 48.197, 0.841196339583707, -106.6247, -1.8609520789512),
(26159, '59231', 218, 31, 197461, 48.4037, 0.844803935147579, -106.5447, -1.8595558155496),
(26160, '59240', 218, 31, 196605, 48.8478, 0.852554942355686, -106.2485, -1.8543861503052),
(26161, '59241', 218, 31, 120039, 48.3934, 0.844624166234624, -107.0837, -1.86896314021785),
(26162, '59242', 218, 31, 3212, 48.4407, 0.845449706970817, -104.597, -1.82556203770851),
(26163, '59243', 218, 31, 3649, 47.7582, 0.833537834825956, -104.7389, -1.82803865991709),
(26164, '59244', 218, 31, 196878, 48.5475, 0.847313718611947, -106.2264, -1.8540004325405),
(26165, '59245', 218, 31, 196996, 48.244, 0.842016644332144, -104.377, -1.82172231335412),
(26166, '59247', 218, 31, 136819, 48.5032, 0.846540537753314, -104.5018, -1.82390048426061),
(26167, '59248', 218, 31, 17237, 48.1433, 0.840259097775386, -106.3566, -1.8562728512266),
(26168, '59250', 218, 31, 197190, 48.8927, 0.853338595189832, -106.4762, -1.85836026501199),
(26169, '59252', 218, 31, 197201, 48.8992, 0.853452041591211, -104.7388, -1.82803691458784),
(26170, '59253', 218, 31, 30793, 48.7821, 0.851408261037126, -105.8004, -1.84656532992701),
(26171, '59254', 218, 31, 197272, 48.8153, 0.851987710348788, -104.6633, -1.82671919100258),
(26172, '59255', 218, 31, 37756, 48.1105, 0.839686629780732, -105.1909, -1.8359275481361),
(26173, '59256', 218, 31, 24225, 48.781, 0.851389062415354, -104.558, -1.82488135930023),
(26174, '59257', 218, 31, 132796, 48.8333, 0.852301869614147, -104.9218, -1.83123086711899),
(26175, '59258', 218, 31, 33745, 48.574, 0.847776230863726, -104.6921, -1.82722184582716),
(26176, '59259', 218, 31, 61529, 47.6408, 0.831488818284115, -104.9814, -1.83227108335318),
(26177, '59260', 218, 31, 5374, 48.715, 0.850237145109038, -106.2634, -1.85464620436374),
(26178, '59261', 218, 31, 277, 48.4579, 0.84574990360216, -107.3418, -1.87346783501725),
(26179, '59262', 218, 31, 38115, 47.4529, 0.828209344619617, -104.3417, -1.82110621212817),
(26180, '59263', 218, 31, 61695, 48.7907, 0.851558359352797, -105.4204, -1.83993307876943),
(26181, '59270', 218, 31, 5844, 47.7171, 0.832820504503386, -104.1624, -1.81797683677934),
(26182, '59273', 218, 31, 28848, 48.3547, 0.843948723814102, -106.909, -1.86591405001462),
(26183, '59274', 218, 31, 285, 47.8445, 0.835044053970427, -105.7707, -1.84604696713917),
(26184, '59275', 218, 31, 176985, 48.8455, 0.85251479978289, -104.1941, -1.81853010615222),
(26185, '59276', 218, 31, 179519, 48.8982, 0.853434588298691, -105.162, -1.83542314798228),
(26186, '59301', 218, 31, 17131, 46.4088, 0.809986361899544, -105.8393, -1.84724426300603),
(26187, '59311', 218, 31, 195866, 45.1835, 0.788600842574858, -104.2505, -1.81951447185035),
(26188, '59312', 218, 31, 195878, 46.6721, 0.814581813820045, -106.3958, -1.85695702029338),
(26189, '59313', 218, 31, 7221, 46.3634, 0.809193982419139, -104.2709, -1.81987051901776),
(26190, '59314', 218, 31, 7450, 45.2856, 0.790382823741144, -105.3151, -1.83809524706708),
(26191, '59315', 218, 31, 7544, 47.3821, 0.826973651509205, -104.945, -1.83163578350545),
(26192, '59316', 218, 31, 196065, 45.506, 0.79422952941254, -104.9109, -1.83104062623052),
(26193, '59317', 218, 31, 196083, 45.4296, 0.792896097864016, -105.3962, -1.83951070909045),
(26194, '59318', 218, 31, 196098, 47.3137, 0.825779846300841, -107.6271, -1.87844725937319),
(26195, '59319', 218, 31, 196151, 45.4674, 0.79355583232127, -104.1852, -1.8183747718488),
(26196, '59322', 218, 31, 196245, 47.0881, 0.821842383508342, -106.5138, -1.85901650881074),
(26197, '59323', 218, 31, 196252, 45.8982, 0.801074710738861, -106.6264, -1.86098174954848),
(26198, '59324', 218, 31, 196418, 45.8447, 0.800140959589044, -104.5119, -1.82407676251506),
(26199, '59326', 218, 31, 75809, 46.6795, 0.814710968184693, -105.1396, -1.83503219422983),
(26200, '59327', 218, 31, 21226, 46.2659, 0.807492286398445, -106.6799, -1.8619155006983),
(26201, '59330', 218, 31, 196603, 47.1104, 0.822231591931537, -104.7209, -1.82772450065173),
(26202, '59332', 218, 31, 421, 45.3728, 0.791904750848883, -104.6537, -1.82655163939439),
(26203, '59333', 218, 31, 41281, 46.2763, 0.807673800640652, -106.196, -1.8534698524479),
(26204, '59336', 218, 31, 196774, 46.4978, 0.811539704933819, -104.7893, -1.82891830586009),
(26205, '59337', 218, 31, 3460, 47.5419, 0.829762687653892, -106.7926, -1.8638824867653),
(26206, '59338', 218, 31, 3550, 46.6642, 0.814443932809138, -105.873, -1.84783243896396),
(26207, '59339', 218, 31, 41807, 47.1956, 0.823718612454236, -105.2005, -1.83609509974429),
(26208, '59341', 218, 31, 17129, 46.7426, 0.815812270942702, -104.7813, -1.82877867951993),
(26209, '59343', 218, 31, 17412, 45.5413, 0.794845630638494, -105.6486, -1.84391592012248),
(26210, '59344', 218, 31, 5154, 46.39, 0.80965824000017, -104.6461, -1.82641899437124),
(26211, '59345', 218, 31, 83131, 45.7409, 0.798329307825474, -105.2471, -1.83690842317572),
(26212, '59347', 218, 31, 5545, 46.2684, 0.807535919629744, -106.6666, -1.86168337190778),
(26213, '59349', 218, 31, 12285, 46.7906, 0.816650028983659, -105.3138, -1.8380725577868),
(26214, '59351', 218, 31, 197773, 46.0341, 0.803446613192322, -105.6234, -1.84347609715098),
(26215, '59353', 218, 31, 197847, 46.9857, 0.8200551663543, -104.1885, -1.81843236771411),
(26216, '59354', 218, 31, 26074, 46.1311, 0.805139582566756, -104.4577, -1.82313079406048),
(26217, '59401', 218, 31, 47606, 47.5077, 0.82916578504971, -111.2866, -1.94231758334992),
(26218, '59402', 218, 31, 0, 47.5118, 0.829237343549042, -111.1958, -1.94073282438911),
(26219, '59403', 218, 31, 47606, 47.5508, 0.82991802195732, -111.5391, -1.94672453971121),
(26220, '59404', 218, 31, 47606, 47.5099, 0.829204182293254, -111.3521, -1.94346077400998),
(26221, '59405', 218, 31, 47606, 47.476, 0.828612515676828, -111.2609, -1.94186903373216),
(26222, '59406', 218, 31, 47606, 47.4816, 0.82871025411494, -111.2545, -1.94175733266003),
(26223, '59410', 218, 31, 7193, 47.3927, 0.827158656409917, -112.6341, -1.96583589502055),
(26224, '59411', 218, 31, 195912, 48.5932, 0.848111334080109, -113.1774, -1.97531826884663),
(26225, '59412', 218, 31, 195972, 47.3695, 0.826753740023454, -110.9013, -1.93559282974199),
(26226, '59414', 218, 31, 196026, 47.5174, 0.829335081987154, -111.2992, -1.94253749483567),
(26227, '59416', 218, 31, 34957, 48.0296, 0.838274658415869, -111.6613, -1.94885733205714),
(26228, '59417', 218, 31, 19587, 48.5354, 0.847102533772456, -113.0446, -1.97300047159998),
(26229, '59418', 218, 31, 26642, 46.8016, 0.816842015201378, -109.6893, -1.91443943920782),
(26230, '59419', 218, 31, 1267, 47.9783, 0.837379304509595, -112.3051, -1.96009376178148),
(26231, '59420', 218, 31, 35159, 47.7856, 0.834016055041002, -110.9961, -1.93724740187288),
(26232, '59421', 218, 31, 26723, 47.2059, 0.823898381367191, -111.6981, -1.94949961322188),
(26233, '59422', 218, 31, 196215, 47.8313, 0.834813670509164, -112.1641, -1.95763284753617),
(26234, '59424', 218, 31, 193457, 47.3513, 0.826436090099591, -110.0851, -1.92134745238721),
(26235, '59425', 218, 31, 15601, 48.1727, 0.840772224575472, -111.948, -1.95386119102261),
(26236, '59427', 218, 31, 196315, 48.645, 0.849015414632642, -112.3488, -1.96085647066461),
(26237, '59430', 218, 31, 8484, 47.3188, 0.825868858092693, -109.9449, -1.91890050077591),
(26238, '59432', 218, 31, 196384, 48.2154, 0.841517480166074, -112.6714, -1.96648690283154),
(26239, '59433', 218, 31, 2141, 47.8454, 0.835059761933695, -111.7117, -1.94973697800015),
(26240, '59434', 218, 31, 196400, 48.4422, 0.845475886909597, -113.2172, -1.97601290988892),
(26241, '59435', 218, 31, 20932, 48.5952, 0.848146240665148, -112.1016, -1.95654201675368),
(26242, '59436', 218, 31, 2367, 47.6164, 0.831062957946628, -112.0983, -1.95648442088836),
(26243, '59440', 218, 31, 59919, 47.657, 0.831771561622938, -111.1953, -1.94072409774285),
(26244, '59441', 218, 31, 196506, 46.865, 0.817948553947143, -109.0531, -1.90333565450663),
(26245, '59442', 218, 31, 196510, 47.8186, 0.834592013694161, -110.6685, -1.93152970324334),
(26246, '59443', 218, 31, 196515, 47.5601, 0.830080337577755, -111.8086, -1.95142820204533),
(26247, '59444', 218, 31, 196552, 48.733, 0.850551304374397, -111.4693, -1.94550629989332),
(26248, '59445', 218, 31, 196564, 47.0555, 0.821273406172192, -109.4671, -1.91056131760988),
(26249, '59446', 218, 31, 2702, 47.6011, 0.830795922571073, -110.2679, -1.92453791425986),
(26250, '59447', 218, 31, 196584, 47.2214, 0.82416890740125, -110.4278, -1.92732869573379),
(26251, '59448', 218, 31, 196685, 48.316, 0.84327328139358, -112.9291, -1.97098461631393),
(26252, '59450', 218, 31, 120027, 47.592, 0.830637097609141, -110.7826, -1.93352112391987),
(26253, '59451', 218, 31, 94900, 47.0663, 0.821461901731407, -109.4293, -1.90990158315263),
(26254, '59452', 218, 31, 3173, 46.8704, 0.81804280172675, -110.2057, -1.92345231946511),
(26255, '59453', 218, 31, 196801, 46.6033, 0.813381027294673, -109.5984, -1.91285293491775),
(26256, '59454', 218, 31, 136227, 48.7473, 0.850800886457432, -112.013, -1.95499565503641),
(26257, '59456', 218, 31, 66298, 48.2898, 0.842816005129558, -111.7419, -1.95026406743425),
(26258, '59457', 218, 31, 36868, 47.0666, 0.821467137719163, -109.4295, -1.90990507381113),
(26259, '59460', 218, 31, 95783, 48.0038, 0.837824363468854, -110.391, -1.92668641456906),
(26260, '59461', 218, 31, 36975, 48.5359, 0.847111260418716, -112.1522, -1.95742515335518),
(26261, '59462', 218, 31, 27924, 47.1079, 0.822187958700237, -109.8833, -1.91782537795669),
(26262, '59463', 218, 31, 10558, 47.0765, 0.821639925315111, -110.8348, -1.93443218578941),
(26263, '59464', 218, 31, 10581, 46.9746, 0.819861434807328, -109.6933, -1.9145092523779),
(26264, '59465', 218, 31, 197131, 47.0429, 0.821053494686441, -110.7728, -1.93335008165317),
(26265, '59466', 218, 31, 197175, 48.7682, 0.851165660271099, -111.7586, -1.95055553741933),
(26266, '59467', 218, 31, 197234, 48.0768, 0.83909845382281, -112.2793, -1.95964346683447),
(26267, '59468', 218, 31, 140736, 47.6533, 0.831706984440614, -111.4794, -1.94568257814777),
(26268, '59469', 218, 31, 197342, 47.2483, 0.824638400970037, -110.6838, -1.9317967386189),
(26269, '59471', 218, 31, 11712, 47.4071, 0.827409983822204, -108.7355, -1.89779248880229);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(26270, '59472', 218, 31, 197473, 47.3965, 0.827224978921492, -111.166, -1.94021271627202),
(26271, '59474', 218, 31, 59, 48.5116, 0.846687145410481, -111.8312, -1.95182264645628),
(26272, '59477', 218, 31, 43083, 47.4935, 0.828917948295927, -111.9289, -1.95352783313548),
(26273, '59479', 218, 31, 12107, 47.1522, 0.82296113955887, -110.2235, -1.92376298807197),
(26274, '59480', 218, 31, 197626, 47.2366, 0.824434197447554, -111.1488, -1.93991251964067),
(26275, '59482', 218, 31, 69217, 48.8813, 0.853139627655104, -111.9109, -1.95321367387012),
(26276, '59483', 218, 31, 197654, 47.5042, 0.82910469852589, -111.7434, -1.95029024737303),
(26277, '59484', 218, 31, 197669, 48.9652, 0.854603958897527, -112.0308, -1.95530632364326),
(26278, '59485', 218, 31, 12444, 47.4215, 0.827661311234491, -111.5421, -1.94677689958877),
(26279, '59486', 218, 31, 28841, 48.306, 0.843098748468381, -112.2517, -1.95916175596092),
(26280, '59487', 218, 31, 6529, 47.5687, 0.830230435893427, -111.6169, -1.94808240586926),
(26281, '59489', 218, 31, 34457, 47.6328, 0.831349191943955, -109.2125, -1.90611770933431),
(26282, '59501', 218, 31, 115978, 48.5459, 0.847285793343915, -109.6843, -1.91435217274522),
(26283, '59520', 218, 31, 85069, 48.0575, 0.838761605277175, -110.0238, -1.92027756555574),
(26284, '59521', 218, 31, 85226, 48.3216, 0.843371019831692, -109.8349, -1.91698063859872),
(26285, '59522', 218, 31, 8056, 48.5109, 0.846674928105717, -110.9659, -1.93672031243878),
(26286, '59523', 218, 31, 196213, 48.5889, 0.848036284922273, -109.231, -1.90644059524593),
(26287, '59524', 218, 31, 8544, 48.2031, 0.841302804668079, -108.5195, -1.89402257761799),
(26288, '59525', 218, 31, 196589, 48.5991, 0.848214308505976, -110.2652, -1.92449079037005),
(26289, '59526', 218, 31, 16360, 48.6019, 0.848263177725032, -108.8525, -1.89983452402713),
(26290, '59527', 218, 31, 32724, 48.2084, 0.841395307118434, -108.8033, -1.89897582203515),
(26291, '59528', 218, 31, 125079, 48.5979, 0.848193364554952, -110.4268, -1.92731124244127),
(26292, '59529', 218, 31, 196725, 48.8773, 0.853069814485024, -108.7189, -1.89750276414646),
(26293, '59530', 218, 31, 3357, 48.6264, 0.848690783391771, -110.6873, -1.93185782514272),
(26294, '59531', 218, 31, 9793, 48.6953, 0.849893315246395, -110.8245, -1.93425241687646),
(26295, '59532', 218, 31, 76306, 48.5665, 0.847645331169826, -110.0479, -1.92069818990547),
(26296, '59535', 218, 31, 10141, 48.0428, 0.838505041877132, -109.2164, -1.90618577717513),
(26297, '59537', 218, 31, 33139, 48.8185, 0.852043560884852, -107.9131, -1.88343890103389),
(26298, '59538', 218, 31, 3962, 48.356, 0.843971413094378, -107.8719, -1.88271982538207),
(26299, '59540', 218, 31, 61624, 48.6511, 0.849121879717013, -110.5565, -1.92957493448111),
(26300, '59542', 218, 31, 6415, 48.8759, 0.853045379875497, -108.3736, -1.89147614223933),
(26301, '59544', 218, 31, 26032, 48.8743, 0.853017454607465, -107.3933, -1.87436667958203),
(26302, '59545', 218, 31, 197846, 48.8378, 0.852380409430487, -111.1003, -1.93906603495346),
(26303, '59546', 218, 31, 197908, 47.7927, 0.834139973417894, -108.0698, -1.88617383197177),
(26304, '59547', 218, 31, 34493, 48.6542, 0.849175984923825, -109.213, -1.90612643598057),
(26305, '59601', 218, 31, 3052, 46.627, 0.813794670327396, -112.0093, -1.95493107785408),
(26306, '59602', 218, 31, 3052, 46.6437, 0.814086140312479, -111.9735, -1.95430624998187),
(26307, '59604', 218, 31, 3052, 46.6163, 0.813607920097433, -111.9644, -1.95414742501994),
(26308, '59620', 218, 31, 3052, 46.5331, 0.812155806159773, -112.1599, -1.95755954370759),
(26309, '59623', 218, 31, 3052, 46.6074, 0.813452585794005, -112.0122, -1.95498169240239),
(26310, '59624', 218, 31, 3052, 46.5983, 0.813293760832074, -112.0298, -1.95528887035074),
(26311, '59625', 218, 31, 3052, 46.6057, 0.813422915196721, -112.04, -1.95546689393445),
(26312, '59626', 218, 31, 3052, 46.6028, 0.813372300648413, -112.0355, -1.95538835411811),
(26313, '59631', 218, 31, 108107, 46.3018, 0.80811885959991, -112.3661, -1.9611584126252),
(26314, '59632', 218, 31, 26581, 46.2026, 0.806387492981932, -112.0813, -1.95618771491552),
(26315, '59633', 218, 31, 19765, 46.8402, 0.817515712292648, -112.3077, -1.96013914034204),
(26316, '59634', 218, 31, 196224, 46.4755, 0.811150496510625, -111.9693, -1.95423294615329),
(26317, '59635', 218, 31, 196401, 46.6, 0.813323431429358, -111.8894, -1.95283842808094),
(26318, '59636', 218, 31, 0, 46.6038, 0.813389753940933, -112.0911, -1.95635875718222),
(26319, '59638', 218, 31, 27551, 46.382, 0.80951861366001, -112.0563, -1.95575138260252),
(26320, '59639', 218, 31, 3781, 46.949, 0.819414630518818, -112.9175, -1.9707821581207),
(26321, '59640', 218, 31, 10343, 46.7507, 0.815953642612113, -112.2996, -1.95999776867262),
(26322, '59641', 218, 31, 197326, 46.1997, 0.806336878433624, -111.6317, -1.94834071459855),
(26323, '59642', 218, 31, 77096, 46.3011, 0.808106642295147, -110.8736, -1.93510937353918),
(26324, '59643', 218, 31, 197704, 46.1759, 0.80592149007165, -111.4799, -1.94569130479403),
(26325, '59644', 218, 31, 14757, 46.3186, 0.808412074914246, -111.4906, -1.94587805502399),
(26326, '59645', 218, 31, 26021, 46.5412, 0.812297177829185, -110.9107, -1.93575689069167),
(26327, '59647', 218, 31, 18654, 46.3608, 0.809148603858587, -111.6406, -1.94849604890198),
(26328, '59648', 218, 31, 6896, 47.0428, 0.821051749357189, -112.0626, -1.9558613383454),
(26329, '59701', 218, 31, 141415, 45.9915, 0.802703102930972, -112.5156, -1.96376767985693),
(26330, '59702', 218, 31, 141415, 45.9068, 0.801224809054533, -112.4977, -1.96345526592082),
(26331, '59703', 218, 31, 141415, 45.9918, 0.802708338918728, -112.5502, -1.96437156377812),
(26332, '59707', 218, 31, 141415, 46.0039, 0.802919523758219, -112.5341, -1.96409056576855),
(26333, '59710', 218, 31, 84608, 45.2867, 0.790402022362916, -112.1034, -1.95657343268021),
(26334, '59711', 218, 31, 53183, 46.1418, 0.80532633279672, -112.9552, -1.9714401472487),
(26335, '59713', 218, 31, 7208, 46.7821, 0.816501675997239, -112.7598, -1.9680297738903),
(26336, '59714', 218, 31, 53397, 45.8166, 0.799650522069234, -111.1581, -1.94007483526111),
(26337, '59715', 218, 31, 196066, 45.6752, 0.797182626506914, -111.067, -1.93848484031254),
(26338, '59716', 218, 31, 196003, 45.2666, 0.790051211183265, -111.2527, -1.9417259167335),
(26339, '59717', 218, 31, 196066, 45.6604, 0.796924317777619, -111.0625, -1.9384063004962),
(26340, '59718', 218, 31, 196066, 45.6482, 0.796711387608876, -111.2037, -1.94087070540002),
(26341, '59719', 218, 31, 196066, 45.6792, 0.797252439676994, -111.0378, -1.93797520417096),
(26342, '59720', 218, 31, 806, 44.9758, 0.784975793718466, -111.6183, -1.94810684047879),
(26343, '59721', 218, 31, 15433, 45.8631, 0.800462100171411, -111.9777, -1.95437955381045),
(26344, '59722', 218, 31, 86267, 46.3863, 0.809593662817846, -112.7377, -1.96764405612561),
(26345, '59724', 218, 31, 8468, 44.9864, 0.785160798619177, -112.9419, -1.97120801845818),
(26346, '59725', 218, 31, 20585, 45.1901, 0.78871603430549, -112.679, -1.96661954785469),
(26347, '59727', 218, 31, 20592, 45.777, 0.798959371685444, -112.7115, -1.96718677986159),
(26348, '59728', 218, 31, 29718, 46.5741, 0.812871391153091, -112.4977, -1.96345526592082),
(26349, '59729', 218, 31, 20908, 45.3425, 0.791375916085529, -111.7257, -1.94998132409543),
(26350, '59730', 218, 31, 196556, 45.4406, 0.793088084081735, -111.2178, -1.94111679682455),
(26351, '59731', 218, 31, 27246, 46.5227, 0.811974291917566, -112.8604, -1.96978557511781),
(26352, '59732', 218, 31, 47441, 45.482, 0.793810650392061, -112.6949, -1.96689705520576),
(26353, '59733', 218, 31, 9147, 46.5581, 0.812592138472772, -112.9372, -1.97112598798334),
(26354, '59735', 218, 31, 9353, 45.7315, 0.798165246875787, -111.8024, -1.95131999163171),
(26355, '59736', 218, 31, 3384, 45.395, 0.792292213942826, -113.4574, -1.98020519075221),
(26356, '59739', 218, 31, 66371, 44.6455, 0.779210971199128, -112.6004, -1.96524771906262),
(26357, '59740', 218, 31, 175224, 45.446, 0.793182331861343, -111.785, -1.95101630434186),
(26358, '59741', 218, 31, 17009, 45.7815, 0.799037911501784, -111.3185, -1.94287434338131),
(26359, '59743', 218, 31, 4153, 45.6319, 0.796426898940801, -112.6841, -1.96670855964654),
(26360, '59745', 218, 31, 23401, 45.5426, 0.794868319918769, -111.7225, -1.94992547355936),
(26361, '59746', 218, 31, 184207, 45.3693, 0.791843664325063, -113.1181, -1.9742832886002),
(26362, '59747', 218, 31, 123472, 45.6076, 0.796002783932566, -111.9342, -1.95362033558584),
(26363, '59748', 218, 31, 42735, 46.1111, 0.804790516716357, -112.6428, -1.96598773866547),
(26364, '59749', 218, 31, 11906, 45.438, 0.793042705521184, -112.1843, -1.95798540404507),
(26365, '59750', 218, 31, 141415, 45.9739, 0.802395924982621, -112.8089, -1.96888673055303),
(26366, '59751', 218, 31, 195613, 45.6958, 0.797542164332825, -112.2718, -1.95951256714057),
(26367, '59752', 218, 31, 6329, 45.8835, 0.800818147338818, -111.5193, -1.94637896451931),
(26368, '59754', 218, 31, 12421, 45.5727, 0.79539366402362, -112.3903, -1.96158078230418),
(26369, '59755', 218, 31, 107183, 45.2967, 0.790576555288116, -111.9433, -1.95377916054777),
(26370, '59756', 218, 31, 6631, 46.219, 0.806673726979259, -112.7948, -1.9686406391285),
(26371, '59758', 218, 31, 197821, 44.7096, 0.780329727249657, -111.1536, -1.93999629544477),
(26372, '59759', 218, 31, 12826, 45.8722, 0.800620925133343, -112.14, -1.95721222318644),
(26373, '59760', 218, 31, 26094, 45.8242, 0.799783167092386, -111.6368, -1.94842972639041),
(26374, '59761', 218, 31, 38922, 45.7027, 0.797662592051212, -113.6025, -1.98273766349686),
(26375, '59762', 218, 31, 197869, 45.6945, 0.797519475052549, -113.0802, -1.97362180881369),
(26376, '59771', 218, 31, 196066, 45.6794, 0.797255930335498, -111.1469, -1.93987935838489),
(26377, '59772', 218, 31, 196066, 45.663, 0.796969696338171, -111.115, -1.9393225983535),
(26378, '59773', 218, 31, 196066, 45.6712, 0.797112813336834, -111.0805, -1.93872045976156),
(26379, '59801', 218, 31, 197067, 46.8576, 0.817819399582495, -114.0418, -1.99040489490087),
(26380, '59802', 218, 31, 197067, 46.8958, 0.818486115356757, -114.0111, -1.98986907882051),
(26381, '59803', 218, 31, 197067, 46.8221, 0.817199807698037, -114.0189, -1.99000521450216),
(26382, '59804', 218, 31, 197067, 46.8542, 0.817760058387927, -114.1922, -1.99302987009587),
(26383, '59806', 218, 31, 197067, 46.9181, 0.818875323779952, -114.1536, -1.9923561730046),
(26384, '59807', 218, 31, 197067, 46.9717, 0.81981082025902, -113.9646, -1.98905750071833),
(26385, '59808', 218, 31, 197067, 46.8519, 0.817719915815131, -114.0145, -1.98992842001507),
(26386, '59812', 218, 31, 197067, 46.8617, 0.817890958081827, -113.986, -1.98943100117826),
(26387, '59820', 218, 31, 84605, 47.0042, 0.820378052265919, -114.5068, -1.99852067592264),
(26388, '59821', 218, 31, 108014, 47.1581, 0.823064113984738, -114.0521, -1.99058466381382),
(26389, '59823', 218, 31, 58737, 46.8774, 0.81816497477439, -113.63, -1.98321762904116),
(26390, '59824', 218, 31, 196195, 47.4192, 0.827621168661695, -114.1963, -1.9931014285952),
(26391, '59825', 218, 31, 1630, 46.7929, 0.816690171556455, -113.7466, -1.98525268294898),
(26392, '59826', 218, 31, 85989, 47.4901, 0.828858607101359, -113.7142, -1.98468719627134),
(26393, '59827', 218, 31, 8211, 45.854, 0.80030327520948, -114.3334, -1.99549427499968),
(26394, '59828', 218, 31, 196282, 46.3148, 0.80834575240267, -114.0864, -1.99118331174726),
(26395, '59829', 218, 31, 15733, 45.9928, 0.802725792211248, -114.183, -1.99286929980469),
(26396, '59830', 218, 31, 196334, 47.391, 0.827128985812633, -115.3488, -2.01321634822444),
(26397, '59831', 218, 31, 828, 47.3068, 0.825659418582454, -114.3695, -1.99612433885965),
(26398, '59832', 218, 31, 2109, 46.661, 0.814388082273074, -113.1691, -1.97517340651871),
(26399, '59833', 218, 31, 2502, 46.63, 0.813847030204956, -114.0646, -1.99080282997032),
(26400, '59834', 218, 31, 2608, 47.0477, 0.821137270490536, -114.2389, -1.99384493885655),
(26401, '59835', 218, 31, 196628, 46.2029, 0.806392728969688, -114.1412, -1.99213975217735),
(26402, '59837', 218, 31, 29976, 46.3974, 0.809787394364817, -113.2786, -1.97708454204965),
(26403, '59840', 218, 31, 2950, 46.2319, 0.806898874452767, -114.1648, -1.99255164988082),
(26404, '59841', 218, 31, 197257, 46.3285, 0.808584862510193, -114.2172, -1.99346620240887),
(26405, '59842', 218, 31, 196678, 47.3851, 0.827026011386765, -115.3975, -2.01406632357016),
(26406, '59843', 218, 31, 196690, 46.8802, 0.818213843993446, -112.9925, -1.97209115505969),
(26407, '59844', 218, 31, 196692, 48.0434, 0.838515513852644, -115.9565, -2.02382271408881),
(26408, '59845', 218, 31, 9587, 47.5975, 0.830733090718001, -114.6768, -2.00148773565103),
(26409, '59846', 218, 31, 196758, 47.0545, 0.821255952879672, -114.3701, -1.99613481083517),
(26410, '59847', 218, 31, 196933, 46.7578, 0.816077560989005, -114.103, -1.99147303640309),
(26411, '59848', 218, 31, 196939, 47.6726, 0.832043832986249, -114.662, -2.00122942692174),
(26412, '59851', 218, 31, 602, 46.8741, 0.818107378909074, -113.8808, -1.98759491480516),
(26413, '59853', 218, 31, 151312, 48.0391, 0.838440464694808, -115.8212, -2.02146128361086),
(26414, '59854', 218, 31, 197202, 47.0332, 0.820884197748997, -113.0316, -1.97277357879722),
(26415, '59855', 218, 31, 197204, 47.6181, 0.831092628543912, -114.1272, -1.99189540608207),
(26416, '59856', 218, 31, 11064, 47.3883, 0.827081861922829, -114.7977, -2.00359783871669),
(26417, '59858', 218, 31, 165884, 46.2987, 0.808064754393099, -113.3609, -1.97852094802404),
(26418, '59859', 218, 31, 17647, 47.4819, 0.828715490102696, -114.8811, -2.00505344331286),
(26419, '59860', 218, 31, 197276, 47.7001, 0.832523798530547, -114.1423, -1.99215895079912),
(26420, '59863', 218, 31, 197339, 47.2768, 0.825135819806855, -114.1797, -1.99281170393937),
(26421, '59864', 218, 31, 197426, 47.5417, 0.829759196995388, -114.1396, -1.99211182690932),
(26422, '59865', 218, 31, 197459, 47.3606, 0.826598405720026, -114.0563, -1.99065796764241),
(26423, '59866', 218, 31, 152308, 47.2997, 0.825535500205562, -115.0963, -2.00880939186315),
(26424, '59867', 218, 31, 197471, 47.4101, 0.827462343699764, -115.5087, -2.01600712969837),
(26425, '59868', 218, 31, 197499, 47.2246, 0.824224757937314, -113.5001, -1.98095044634282),
(26426, '59870', 218, 31, 51694, 46.5194, 0.81191669605225, -114.055, -1.99063527836213),
(26427, '59871', 218, 31, 197645, 45.7873, 0.7991391405984, -113.881, -1.98759840546366),
(26428, '59872', 218, 31, 6182, 47.1802, 0.823449831749429, -114.8874, -2.00516339905573),
(26429, '59873', 218, 31, 197685, 47.6215, 0.83115196973848, -115.3401, -2.01306450457951),
(26430, '59874', 218, 31, 98637, 47.791, 0.83411030282061, -115.5564, -2.01683965175158),
(26431, '59875', 218, 31, 12551, 46.4012, 0.809853716876393, -114.1685, -1.99261622706315),
(26432, '59901', 218, 31, 196806, 48.2095, 0.841414505740206, -114.2968, -1.99485548449346),
(26433, '59902', 218, 31, 196806, 48.1994, 0.841238227485755, -114.3173, -1.99521327699011),
(26434, '59903', 218, 31, 196806, 48.1942, 0.841147470364651, -114.3551, -1.99587301144737),
(26435, '59904', 218, 31, 196806, 48.1958, 0.841175395632683, -114.3116, -1.99511379322275),
(26436, '59910', 218, 31, 195987, 47.7951, 0.834181861319942, -114.2969, -1.99485722982271),
(26437, '59911', 218, 31, 134266, 48.086, 0.839259024113993, -114.0471, -1.99049739735123),
(26438, '59912', 218, 31, 127138, 48.365, 0.844128492727057, -114.1924, -1.99303336075437),
(26439, '59913', 218, 31, 148033, 48.4362, 0.845371167154477, -114.0539, -1.99061607974036),
(26440, '59914', 218, 31, 1992, 47.8645, 0.835393119820826, -114.3023, -1.99495147760231),
(26441, '59915', 218, 31, 8744, 47.82, 0.834616448303688, -114.3931, -1.99653623656313),
(26442, '59916', 218, 31, 8781, 48.616, 0.848509269149563, -113.9071, -1.98805393639843),
(26443, '59917', 218, 31, 2334, 48.8759, 0.853045379875497, -115.051, -2.008018757712),
(26444, '59918', 218, 31, 196518, 48.7909, 0.851561850011301, -114.8862, -2.00514245510471),
(26445, '59919', 218, 31, 196753, 48.388, 0.844529918455016, -114.0628, -1.99077141404379),
(26446, '59920', 218, 31, 196824, 48.0652, 0.838895995629578, -114.5034, -1.99846133472808),
(26447, '59921', 218, 31, 196860, 48.6213, 0.848601771599919, -113.8718, -1.98743783517248),
(26448, '59922', 218, 31, 9948, 48.0151, 0.838021585674329, -114.2222, -1.99355346887147),
(26449, '59923', 218, 31, 136495, 48.3529, 0.843917307887566, -115.5187, -2.01618166262357),
(26450, '59925', 218, 31, 630, 48.1104, 0.83968488445148, -114.7579, -2.0029031976744),
(26451, '59926', 218, 31, 56111, 48.3922, 0.8446032222836, -114.0375, -1.99032984574303),
(26452, '59927', 218, 31, 4784, 48.5416, 0.84721074418608, -114.5722, -1.99966212125345),
(26453, '59928', 218, 31, 197275, 48.9041, 0.853537562724559, -114.4044, -1.9967334587686),
(26454, '59929', 218, 31, 5236, 47.9262, 0.836469987969306, -114.3734, -1.99619240670048),
(26455, '59930', 218, 31, 61522, 48.9202, 0.85381856073413, -115.1737, -2.01016027670419),
(26456, '59931', 218, 31, 5525, 47.9223, 0.836401920128479, -114.2592, -1.99419924069471),
(26457, '59932', 218, 31, 106389, 48.0815, 0.839180484297654, -114.2382, -1.99383272155179),
(26458, '59933', 218, 31, 157839, 48.6743, 0.849526796103476, -114.769, -2.00309692922137),
(26459, '59934', 218, 31, 52187, 48.7052, 0.850066102842342, -114.8681, -2.0048265505101),
(26460, '59935', 218, 31, 199, 48.4592, 0.845772592882436, -115.8715, -2.02233918422461),
(26461, '59936', 218, 31, 197816, 48.4938, 0.846376476803626, -113.9892, -1.98948685171432),
(26462, '59937', 218, 31, 197841, 48.4081, 0.844880729634667, -114.3532, -1.99583985019158),
(26463, '60001', 218, 18, 796, 42.459, 0.741049347104272, -88.5176, -1.54492356596333),
(26464, '60002', 218, 18, 147, 42.4658, 0.741168029493408, -88.1074, -1.53776422537165),
(26465, '60004', 218, 18, 26394, 42.1082, 0.734926732088276, -87.9747, -1.53544817345426),
(26466, '60005', 218, 18, 26394, 42.0664, 0.734197184460943, -87.9821, -1.5355773278189),
(26467, '60006', 218, 18, 26394, 42.1326, 0.735352592425763, -88.0912, -1.53748148203283),
(26468, '60007', 218, 18, 119506, 42.0071, 0.73316220421451, -88.0051, -1.53597875354686),
(26469, '60008', 218, 18, 14520, 42.0787, 0.734411859958938, -88.0285, -1.53638716059183),
(26470, '60009', 218, 18, 119506, 42.0055, 0.733134278946478, -87.9926, -1.53576058739036),
(26471, '60010', 218, 18, 19071, 42.191, 0.736371864708928, -88.1351, -1.53824768157445),
(26472, '60011', 218, 18, 19071, 42.184, 0.736249691661288, -88.2199, -1.53972772078015),
(26473, '60012', 218, 18, 15682, 42.2662, 0.737684352306427, -88.3139, -1.54136833027702),
(26474, '60013', 218, 18, 7935, 42.2168, 0.736822159655942, -88.2423, -1.54011867453259),
(26475, '60014', 218, 18, 15682, 42.2337, 0.737117120299529, -88.3256, -1.5415725337995),
(26476, '60015', 218, 18, 8455, 42.1735, 0.736066432089828, -87.8764, -1.53373251479955),
(26477, '60016', 218, 18, 119368, 42.047, 0.733858590586056, -87.8913, -1.53399256885809),
(26478, '60017', 218, 18, 119368, 42.0242, 0.733460655516601, -87.9004, -1.53415139382002),
(26479, '60018', 218, 18, 119368, 42.0122, 0.733251216006362, -87.8935, -1.53403096610164),
(26480, '60019', 218, 18, 119368, 42.0241, 0.733458910187349, -87.9001, -1.53414615783227),
(26481, '60020', 218, 18, 119675, 42.3919, 0.739878231176184, -88.1748, -1.5389405772875),
(26482, '60021', 218, 18, 119679, 42.1909, 0.736370119379676, -88.2234, -1.53978880730397),
(26483, '60022', 218, 18, 2739, 42.1337, 0.735371791047535, -87.7621, -1.53173760346452),
(26484, '60025', 218, 18, 2747, 42.0757, 0.734359500081378, -87.8192, -1.5327341864674),
(26485, '60026', 218, 18, 0, 42.0873, 0.734561958274609, -87.8283, -1.53289301142934),
(26486, '60029', 218, 18, 16238, 42.0579, 0.734048831474523, -87.7913, -1.5322472396061),
(26487, '60030', 218, 18, 119848, 42.3444, 0.739049199781487, -88.0237, -1.53630338478773),
(26488, '60031', 218, 18, 2917, 42.3745, 0.739574543886337, -87.9336, -1.53473084313169),
(26489, '60033', 218, 18, 9370, 42.4223, 0.74040881126879, -88.6029, -1.54641233181528),
(26490, '60034', 218, 18, 940, 42.4587, 0.741044111116516, -88.418, -1.54318521802835),
(26491, '60035', 218, 18, 16433, 42.1803, 0.736185114478964, -87.8063, -1.5325090389939),
(26492, '60037', 218, 18, 0, 42.2254, 0.736972257971614, -87.811, -1.53259106946874),
(26493, '60038', 218, 18, 71229, 42.0976, 0.734741727187565, -88.0118, -1.53609569060675),
(26494, '60039', 218, 18, 15682, 42.232, 0.737087449702245, -88.3302, -1.5416528189451),
(26495, '60040', 218, 18, 120027, 42.2027, 0.736576068231411, -87.8126, -1.53261899473677),
(26496, '60041', 218, 18, 9660, 42.3578, 0.739283073901254, -88.1637, -1.53874684574052),
(26497, '60042', 218, 18, 120139, 42.2784, 0.737897282475171, -88.2104, -1.53956191450121),
(26498, '60043', 218, 18, 13136, 42.0882, 0.734577666237877, -87.7152, -1.53091904404533),
(26499, '60044', 218, 18, 120271, 42.2841, 0.737996766242534, -87.8582, -1.53341486487568),
(26500, '60045', 218, 18, 16779, 42.2355, 0.737148536226065, -87.8623, -1.53348642337501),
(26501, '60046', 218, 18, 120282, 42.4101, 0.740195881100047, -88.0647, -1.53701896978105),
(26502, '60047', 218, 18, 120284, 42.197, 0.736476584464047, -88.0577, -1.53689679673341),
(26503, '60048', 218, 18, 3766, 42.2891, 0.738084032705134, -87.9519, -1.5350502383848),
(26504, '60049', 218, 18, 116604, 42.1954, 0.736448659196015, -88.0031, -1.53594384696182),
(26505, '60050', 218, 18, 37130, 42.3456, 0.739070143732511, -88.269, -1.54058467744287),
(26506, '60051', 218, 18, 37130, 42.3409, 0.738988113257667, -88.2908, -1.54096515921981),
(26507, '60053', 218, 18, 110534, 42.0432, 0.73379226807448, -87.793, -1.53227691020338),
(26508, '60055', 218, 18, 71229, 42.1257, 0.735232164707375, -88.0758, -1.53721270132802),
(26509, '60056', 218, 18, 120717, 42.0654, 0.734179731168423, -87.9334, -1.53472735247318),
(26510, '60060', 218, 18, 120723, 42.2617, 0.737605812490088, -88.0158, -1.53616550377683),
(26511, '60061', 218, 18, 121808, 42.2322, 0.737090940360749, -87.9721, -1.5354027948937),
(26512, '60062', 218, 18, 49907, 42.1254, 0.735226928719619, -87.8445, -1.53317575476816),
(26513, '60064', 218, 18, 120803, 42.3252, 0.738714096565104, -87.8571, -1.53339566625391),
(26514, '60065', 218, 18, 49907, 42.2184, 0.736850084923974, -87.8806, -1.53380581862813),
(26515, '60067', 218, 18, 71229, 42.1097, 0.734952912027056, -88.0492, -1.53674844374699),
(26516, '60068', 218, 18, 120970, 41.972, 0.73254959364706, -87.8283, -1.53289301142934),
(26517, '60069', 218, 18, 36898, 42.1889, 0.736335212794636, -87.9302, -1.53467150193712),
(26518, '60070', 218, 18, 50615, 42.1043, 0.734858664247449, -87.9366, -1.53478320300925),
(26519, '60071', 218, 18, 5381, 42.4676, 0.741199445419944, -88.2916, -1.54097912185383),
(26520, '60072', 218, 18, 42810, 42.4086, 0.740169701161267, -88.2967, -1.54106813364568),
(26521, '60073', 218, 18, 17861, 42.3654, 0.739415718924406, -88.0956, -1.53755827651992),
(26522, '60074', 218, 18, 71229, 42.1456, 0.735579485228522, -88.0272, -1.53636447131155),
(26523, '60075', 218, 18, 5580, 42.4889, 0.741571200550619, -87.926, -1.53459819810853),
(26524, '60076', 218, 18, 121473, 42.036, 0.733666604368336, -87.7311, -1.5311965513964),
(26525, '60077', 218, 18, 121473, 42.0334, 0.733621225807785, -87.7582, -1.53166953562369),
(26526, '60078', 218, 18, 71229, 42.1389, 0.735462548168639, -87.9228, -1.53454234757247),
(26527, '60079', 218, 18, 98943, 42.3714, 0.739520438679525, -87.8676, -1.53357892582537),
(26528, '60080', 218, 18, 121487, 42.4257, 0.740468152463358, -88.2802, -1.5407801543191),
(26529, '60081', 218, 18, 31191, 42.4402, 0.740721225204897, -88.2257, -1.53982894987676),
(26530, '60082', 218, 18, 0, 42.1092, 0.734944185380796, -87.8072, -1.53252474695716),
(26531, '60083', 218, 18, 6590, 42.4301, 0.740544946950446, -87.9328, -1.53471688049767),
(26532, '60084', 218, 18, 121880, 42.263, 0.737628501770363, -88.1396, -1.53832622139079),
(26533, '60085', 218, 18, 98943, 42.3627, 0.739368595034602, -87.8623, -1.53348642337501),
(26534, '60086', 218, 18, 120803, 42.3186, 0.738598904834472, -87.8597, -1.53344104481446),
(26535, '60087', 218, 18, 98943, 42.4038, 0.740085925357171, -87.8625, -1.53348991403352),
(26536, '60088', 218, 18, 119849, 42.308, 0.738413899933761, -87.8559, -1.53337472230289),
(26537, '60089', 218, 18, 118955, 42.1741, 0.736076904065341, -87.9644, -1.5352684045413),
(26538, '60090', 218, 18, 12785, 42.1342, 0.735380517693795, -87.9344, -1.5347448057657),
(26539, '60091', 218, 18, 122002, 42.0759, 0.734362990739882, -87.7296, -1.53117037145762),
(26540, '60092', 218, 18, 3766, 42.1234, 0.735192022134579, -87.9134, -1.53437828662278),
(26541, '60093', 218, 18, 122028, 42.1033, 0.734841210954928, -87.7581, -1.53166779029444),
(26542, '60094', 218, 18, 71229, 42.0969, 0.734729509882801, -88.0968, -1.53757922047094),
(26543, '60095', 218, 18, 71229, 42.0964, 0.734720783236541, -88.0112, -1.53608521863123),
(26544, '60096', 218, 18, 122029, 42.4798, 0.741412375588687, -87.8286, -1.53289824741709),
(26545, '60097', 218, 18, 122037, 42.3944, 0.739921864407484, -88.3558, -1.54209962323361),
(26546, '60098', 218, 18, 569, 42.3205, 0.73863206609026, -88.447, -1.54369136351142),
(26547, '60099', 218, 18, 7003, 42.4513, 0.740914956751869, -87.8579, -1.53340962888793),
(26548, '60101', 218, 18, 34507, 41.9324, 0.73185844326327, -88.0047, -1.53597177222985),
(26549, '60102', 218, 18, 44315, 42.1718, 0.736036761492545, -88.2964, -1.54106289765792),
(26550, '60103', 218, 18, 19076, 41.9667, 0.732457091196704, -88.1636, -1.53874510041127),
(26551, '60104', 218, 18, 294, 41.8817, 0.730973561332509, -87.8767, -1.5337377507873),
(26552, '60105', 218, 18, 118778, 41.9573, 0.732293030247017, -87.9442, -1.5349158480324),
(26553, '60106', 218, 18, 118778, 41.9522, 0.732204018455165, -87.9489, -1.53499787850724),
(26554, '60107', 218, 18, 51766, 42.0225, 0.733430984919317, -88.1673, -1.5388096775936),
(26555, '60108', 218, 18, 13040, 41.9488, 0.732144677260597, -88.0808, -1.53729996779062),
(26556, '60109', 218, 18, 1239, 42.065, 0.734172749851415, -88.5103, -1.54479615692794),
(26557, '60110', 218, 18, 29396, 42.121, 0.735150134232532, -88.2682, -1.54057071480886),
(26558, '60111', 218, 18, 32072, 42.0261, 0.733493816772389, -88.8431, -1.55060461267857),
(26559, '60112', 218, 18, 29554, 41.9216, 0.731669947704055, -88.6906, -1.54794298556928),
(26560, '60113', 218, 18, 35429, 41.931, 0.731834008653742, -88.9635, -1.55270598909798),
(26561, '60115', 218, 18, 80649, 41.9282, 0.731785139434686, -88.749, -1.54896225785245),
(26562, '60116', 218, 18, 119039, 41.9154, 0.731561737290431, -88.1357, -1.53825815354997),
(26563, '60117', 218, 18, 13040, 41.9492, 0.732151658577605, -88.0861, -1.53739247024098),
(26564, '60118', 218, 18, 2134, 42.096, 0.734713801919533, -88.2885, -1.54092501664701),
(26565, '60119', 218, 18, 119492, 41.8811, 0.730963089356997, -88.4877, -1.54440171251699),
(26566, '60120', 218, 18, 2254, 42.039, 0.733718964245896, -88.2822, -1.54081506090414),
(26567, '60121', 218, 18, 2254, 42.0371, 0.733685802990108, -88.281, -1.54079411695311),
(26568, '60122', 218, 18, 2254, 42.0401, 0.733738162867668, -88.288, -1.54091629000075),
(26569, '60123', 218, 18, 2254, 42.0421, 0.733773069452708, -88.3121, -1.54133691435048),
(26570, '60125', 218, 18, 119039, 41.9057, 0.731392440352988, -88.1451, -1.53842221449965),
(26571, '60126', 218, 18, 13723, 41.8932, 0.731174274196489, -87.9444, -1.5349193386909),
(26572, '60128', 218, 18, 119039, 41.9172, 0.731593153216967, -88.103, -1.53768743088456),
(26573, '60129', 218, 18, 20923, 42.0266, 0.733502543418649, -88.9352, -1.55221206091966),
(26574, '60130', 218, 18, 2536, 41.8725, 0.730812991041326, -87.8126, -1.53261899473677),
(26575, '60131', 218, 18, 47255, 41.9342, 0.731889859189806, -87.8769, -1.53374124144581),
(26576, '60132', 218, 18, 119039, 41.9175, 0.731598389204723, -88.1029, -1.53768568555531),
(26577, '60133', 218, 18, 119920, 41.9668, 0.732458836525956, -88.164, -1.53875208172828),
(26578, '60134', 218, 18, 2687, 41.8861, 0.731050355819597, -88.3097, -1.54129502644844),
(26579, '60135', 218, 18, 9080, 42.1053, 0.734876117539968, -88.667, -1.54753108786581),
(26580, '60136', 218, 18, 119776, 42.0923, 0.734649224737209, -88.3624, -1.54221481496424),
(26581, '60137', 218, 18, 119790, 41.8718, 0.730800773736562, -88.0632, -1.53699278984227),
(26582, '60138', 218, 18, 119790, 41.8772, 0.730895021516169, -88.0669, -1.53705736702459),
(26583, '60139', 218, 18, 29900, 41.9193, 0.731629805131259, -88.0775, -1.53724237192531),
(26584, '60140', 218, 18, 47801, 42.0952, 0.734699839285517, -88.514, -1.54486073411026),
(26585, '60141', 218, 18, 3160, 41.8548, 0.730504067763723, -87.831, -1.53294013531914),
(26586, '60142', 218, 18, 13999, 42.1889, 0.736335212794636, -88.4324, -1.54343654544063),
(26587, '60143', 218, 18, 95120, 41.9727, 0.732561810951824, -88.0181, -1.53620564634962),
(26588, '60144', 218, 18, 120171, 41.8353, 0.730163728559584, -88.5178, -1.54492705662184),
(26589, '60145', 218, 18, 3542, 42.1065, 0.734897061490992, -88.781, -1.54952076321309),
(26590, '60146', 218, 18, 3558, 42.0887, 0.734586392884137, -88.8537, -1.55078961757929),
(26591, '60147', 218, 18, 0, 41.8817, 0.730973561332509, -88.4307, -1.54340687484335),
(26592, '60148', 218, 18, 22733, 41.8736, 0.730832189663098, -88.0144, -1.5361410691673),
(26593, '60150', 218, 18, 3962, 41.9257, 0.731741506203387, -88.8601, -1.55090131865141),
(26594, '60151', 218, 18, 56073, 41.9014, 0.731317391195152, -88.5922, -1.54622558158532),
(26595, '60152', 218, 18, 3989, 42.2329, 0.737103157665513, -88.6268, -1.54682946550651),
(26596, '60153', 218, 18, 30467, 41.8664, 0.730706525956954, -87.864, -1.5335160939723),
(26597, '60154', 218, 18, 13248, 41.8523, 0.730460434532423, -87.8853, -1.53388784910297),
(26598, '60155', 218, 18, 29300, 41.8571, 0.730544210336519, -87.8557, -1.53337123164438),
(26599, '60156', 218, 18, 120289, 42.1817, 0.736209549088492, -88.3303, -1.54165456427435),
(26600, '60157', 218, 18, 120584, 41.9697, 0.732509451074264, -88.0472, -1.53671353716195),
(26601, '60159', 218, 18, 121389, 42.0329, 0.733612499161524, -88.0834, -1.53734534635117),
(26602, '60160', 218, 18, 17091, 41.9012, 0.731313900536648, -87.862, -1.53348118738726),
(26603, '60161', 218, 18, 17091, 41.9031, 0.731347061792436, -87.8632, -1.53350213133828),
(26604, '60162', 218, 18, 36430, 41.8741, 0.730840916309358, -87.8979, -1.53410776058872),
(26605, '60163', 218, 18, 15198, 41.8829, 0.730994505283533, -87.9077, -1.53427880285542),
(26606, '60164', 218, 18, 17091, 41.9163, 0.731577445253699, -87.8933, -1.53402747544313),
(26607, '60165', 218, 18, 83846, 41.9029, 0.731343571133932, -87.8807, -1.53380756395738),
(26608, '60168', 218, 18, 121389, 42.0436, 0.733799249391488, -88.1268, -1.53810281924654),
(26609, '60170', 218, 18, 121062, 42.0388, 0.733715473587392, -88.286, -1.54088138341571),
(26610, '60171', 218, 18, 121231, 41.9271, 0.731765940812915, -87.8394, -1.53308674297631),
(26611, '60172', 218, 18, 5552, 41.9756, 0.732612425500132, -88.0895, -1.53745181143554),
(26612, '60173', 218, 18, 121389, 42.0509, 0.733926658426884, -88.0493, -1.53675018907624),
(26613, '60174', 218, 18, 11748, 41.9217, 0.731671693033307, -88.3034, -1.54118507070556),
(26614, '60175', 218, 18, 11748, 41.9519, 0.732198782467409, -88.3445, -1.54190240102813),
(26615, '60176', 218, 18, 121392, 41.9577, 0.732300011564025, -87.8703, -1.53362604971517),
(26616, '60177', 218, 18, 121507, 41.9955, 0.732959746021279, -88.2952, -1.5410419537069),
(26617, '60178', 218, 18, 6199, 42.0038, 0.733104608349194, -88.6829, -1.54780859521688),
(26618, '60179', 218, 18, 120045, 42.0779, 0.734397897324922, -88.2242, -1.53980276993798),
(26619, '60180', 218, 18, 455, 42.2231, 0.736932115398818, -88.5267, -1.54508239092526),
(26620, '60181', 218, 18, 121817, 41.8806, 0.730954362710737, -87.9771, -1.5354900613563),
(26621, '60182', 218, 18, 34285, 41.9561, 0.732272086295993, -88.5372, -1.54526565049672),
(26622, '60183', 218, 18, 121863, 41.9378, 0.731952691042878, -88.402, -1.54290596534803),
(26623, '60184', 218, 18, 6665, 41.9465, 0.732104534687801, -88.2319, -1.53993716029038),
(26624, '60185', 218, 18, 121913, 41.8873, 0.731071299770621, -88.1984, -1.53935247499097),
(26625, '60186', 218, 18, 121913, 41.885, 0.731031157197825, -88.2036, -1.53944323211207),
(26626, '60187', 218, 18, 25985, 41.8608, 0.730608787518842, -88.1128, -1.53785847315126),
(26627, '60188', 218, 18, 119039, 41.9197, 0.731636786448267, -88.1406, -1.53834367468331),
(26628, '60189', 218, 18, 25985, 41.8381, 0.73021259777864, -88.1295, -1.53814994313634),
(26629, '60190', 218, 18, 6882, 41.8707, 0.73078157511479, -88.1528, -1.53855660485206),
(26630, '60191', 218, 18, 122038, 41.9602, 0.732343644795325, -87.9784, -1.53551275063658),
(26631, '60192', 218, 18, 121389, 42.0636, 0.734148315241887, -88.2073, -1.53950780929439),
(26632, '60193', 218, 18, 121389, 42.014, 0.733282631932898, -88.0932, -1.53751638861787),
(26633, '60194', 218, 18, 121389, 42.0359, 0.733664859039084, -88.1009, -1.53765077897027),
(26634, '60195', 218, 18, 121389, 42.0678, 0.734221619070471, -88.1016, -1.53766299627504),
(26635, '60196', 218, 18, 121389, 42.0694, 0.734249544338503, -88.0459, -1.53669084788168),
(26636, '60197', 218, 18, 119039, 41.9156, 0.731565227948935, -88.1361, -1.53826513486697),
(26637, '60199', 218, 18, 119039, 41.9168, 0.731586171899959, -88.101, -1.53765252429952),
(26638, '60201', 218, 18, 20954, 42.0568, 0.734029632852751, -87.6996, -1.53064677268202),
(26639, '60202', 218, 18, 20954, 42.0299, 0.733560139283965, -87.689, -1.53046176778131),
(26640, '60203', 218, 18, 20954, 42.0487, 0.73388826118334, -87.7173, -1.53095569595962),
(26641, '60204', 218, 18, 20954, 42.0573, 0.734038359499011, -87.6993, -1.53064153669426),
(26642, '60208', 218, 18, 20954, 42.0578, 0.734047086145271, -87.6739, -1.53019822306426),
(26643, '60209', 218, 18, 20954, 42.0464, 0.733848118610544, -87.6944, -1.53055601556092),
(26644, '60301', 218, 18, 4691, 41.8887, 0.731095734380149, -87.7993, -1.53238686594626),
(26645, '60302', 218, 18, 4691, 41.895, 0.731205690123024, -87.7896, -1.53221756900881),
(26646, '60303', 218, 18, 4691, 41.8874, 0.731073045099873, -87.7897, -1.53221931433807),
(26647, '60304', 218, 18, 4691, 41.8726, 0.730814736370578, -87.7893, -1.53221233302106),
(26648, '60305', 218, 18, 17804, 41.8942, 0.731191727489008, -87.8166, -1.53268880790685),
(26649, '60398', 218, 18, 47255, 41.9345, 0.731895095177562, -87.8632, -1.53350213133828),
(26650, '60399', 218, 18, 118778, 41.9612, 0.732361098087845, -87.9413, -1.53486523348409),
(26651, '60401', 218, 18, 118756, 41.3563, 0.721803601442531, -87.6088, -1.52906201372121),
(26652, '60402', 218, 18, 44793, 41.8374, 0.730200380473876, -87.7907, -1.53223676763059),
(26653, '60406', 218, 18, 118846, 41.6557, 0.727029117223002, -87.6812, -1.53032563209965),
(26654, '60407', 218, 18, 118877, 41.2336, 0.719662082450334, -88.2712, -1.54062307468642),
(26655, '60408', 218, 18, 75202, 41.2634, 0.720182190567428, -88.218, -1.53969455952436),
(26656, '60409', 218, 18, 119005, 41.6125, 0.72627513498614, -87.551, -1.52805321341356),
(26657, '60410', 218, 18, 119087, 41.4364, 0.723201610173378, -88.1883, -1.53917619673652),
(26658, '60411', 218, 18, 119122, 41.5062, 0.72441984999127, -87.6053, -1.52900092719739),
(26659, '60412', 218, 18, 119122, 41.5094, 0.724475700527334, -87.6374, -1.52956117788728),
(26660, '60415', 218, 18, 119124, 41.7009, 0.727818006044903, -87.7767, -1.53199242153531),
(26661, '60416', 218, 18, 1659, 41.2936, 0.72070928000153, -88.2828, -1.54082553287965),
(26662, '60417', 218, 18, 119273, 41.4447, 0.723346472501294, -87.5926, -1.52877927038239),
(26663, '60419', 218, 18, 119389, 41.6262, 0.726514245093664, -87.598, -1.52887351816199),
(26664, '60420', 218, 18, 2144, 41.0918, 0.717187205571006, -88.4266, -1.54333531634402),
(26665, '60421', 218, 18, 15933, 41.4244, 0.722992170663139, -88.0845, -1.53736454497295),
(26666, '60422', 218, 18, 119638, 41.5404, 0.725016752595452, -87.682, -1.53033959473367),
(26667, '60423', 218, 18, 2594, 41.4905, 0.724145833298707, -87.8367, -1.5330396190865),
(26668, '60424', 218, 18, 9048, 41.1692, 0.718538090412049, -88.3207, -1.54148701266616),
(26669, '60425', 218, 18, 2749, 41.5463, 0.72511972702132, -87.6105, -1.52909168431849),
(26670, '60426', 218, 18, 9372, 41.6086, 0.726207067145313, -87.6666, -1.53007081402886),
(26671, '60429', 218, 18, 119965, 41.573, 0.725585729931603, -87.6835, -1.53036577467245),
(26672, '60430', 218, 18, 3214, 41.5551, 0.725273315995496, -87.6694, -1.53011968324792),
(26673, '60431', 218, 18, 95202, 41.5275, 0.724791605121945, -88.0818, -1.53731742108314),
(26674, '60432', 218, 18, 95202, 41.5353, 0.724927740803601, -88.0523, -1.5368025489538),
(26675, '60433', 218, 18, 95202, 41.5105, 0.724494899149106, -88.0521, -1.5367990582953),
(26676, '60434', 218, 18, 95202, 41.5391, 0.724994063315176, -88.0783, -1.53725633455932),
(26677, '60435', 218, 18, 95202, 41.5387, 0.724987081998169, -88.1487, -1.53848504635273),
(26678, '60436', 218, 18, 95202, 41.506, 0.724416359332766, -88.1406, -1.53834367468331),
(26679, '60437', 218, 18, 120225, 41.1945, 0.718979658712804, -88.5583, -1.54563391496889),
(26680, '60438', 218, 18, 9985, 41.5659, 0.725461811554711, -87.5519, -1.52806892137682),
(26681, '60439', 218, 18, 120333, 41.6756, 0.727376437744149, -87.9808, -1.53555463853863),
(26682, '60440', 218, 18, 118856, 41.7055, 0.727898291190495, -88.0743, -1.53718652138924),
(26683, '60441', 218, 18, 36937, 41.6074, 0.726186123194289, -88.0147, -1.53614630515505),
(26684, '60442', 218, 18, 17009, 41.4317, 0.723119579698535, -87.9842, -1.53561397973319),
(26685, '60443', 218, 18, 120545, 41.509, 0.724468719210326, -87.7352, -1.53126810989573),
(26686, '60444', 218, 18, 120555, 41.2481, 0.719915155191873, -88.4132, -1.54310144222425),
(26687, '60445', 218, 18, 49469, 41.6368, 0.726699249994375, -87.7395, -1.53134315905356),
(26688, '60446', 218, 18, 121284, 41.589, 0.725864982611922, -88.0588, -1.53691599535518),
(26689, '60447', 218, 18, 4241, 41.5072, 0.72443730328379, -88.337, -1.54177150133423),
(26690, '60448', 218, 18, 120661, 41.5355, 0.724931231462105, -87.8878, -1.53393148233427),
(26691, '60449', 218, 18, 120668, 41.419, 0.722897922883531, -87.774, -1.5319452976455),
(26692, '60450', 218, 18, 4333, 41.3648, 0.72195195442895, -88.4216, -1.54324804988142),
(26693, '60451', 218, 18, 120763, 41.5095, 0.724477445856586, -87.9638, -1.53525793256579),
(26694, '60452', 218, 18, 336, 41.6083, 0.726201831157557, -87.7545, -1.53160495844136),
(26695, '60453', 218, 18, 4687, 41.7151, 0.728065842798687, -87.7555, -1.53162241173388),
(26696, '60454', 218, 18, 4687, 41.7086, 0.727952396397307, -87.8032, -1.53245493378709),
(26697, '60455', 218, 18, 118900, 41.7415, 0.728526609721213, -87.8045, -1.53247762306736),
(26698, '60456', 218, 18, 109704, 41.7314, 0.728350331466762, -87.7324, -1.53121924067667),
(26699, '60457', 218, 18, 3081, 41.7262, 0.728259574345658, -87.828, -1.53288777544158),
(26700, '60458', 218, 18, 36665, 41.7445, 0.728578969598773, -87.8351, -1.53301169381847),
(26701, '60459', 218, 18, 1232, 41.744, 0.728570242952513, -87.7703, -1.53188072046318),
(26702, '60460', 218, 18, 10922, 41.0022, 0.715623390561219, -88.5224, -1.54500734176743),
(26703, '60461', 218, 18, 120894, 41.5162, 0.72459438291647, -87.6895, -1.53047049442757),
(26704, '60462', 218, 18, 120917, 41.6214, 0.726430469289568, -87.8413, -1.5331199042321),
(26705, '60463', 218, 18, 120956, 41.6579, 0.727067514466546, -87.7851, -1.53213902919247),
(26706, '60464', 218, 18, 120958, 41.6694, 0.727268227330525, -87.8584, -1.53341835553419),
(26707, '60465', 218, 18, 120957, 41.7004, 0.727809279398643, -87.8281, -1.53288952077083),
(26708, '60466', 218, 18, 23746, 41.4872, 0.724088237433391, -87.6845, -1.53038322796497),
(26709, '60467', 218, 18, 120917, 41.5894, 0.72587196392893, -87.884, -1.5338651598227),
(26710, '60468', 218, 18, 121007, 41.3328, 0.721393449068312, -87.7941, -1.53229610882515),
(26711, '60469', 218, 18, 28305, 41.6284, 0.726552642337208, -87.6858, -1.53040591724524),
(26712, '60470', 218, 18, 33721, 41.1563, 0.718312942938542, -88.6573, -1.54736179092837),
(26713, '60471', 218, 18, 121206, 41.4825, 0.724006206958548, -87.7251, -1.53109183164128),
(26714, '60472', 218, 18, 14501, 41.6431, 0.726809205737251, -87.7024, -1.53069564190107),
(26715, '60473', 218, 18, 121515, 41.5979, 0.726020316915349, -87.5991, -1.52889271678376),
(26716, '60474', 218, 18, 14652, 41.1736, 0.718614884899137, -88.2747, -1.54068416121024),
(26717, '60475', 218, 18, 121574, 41.4665, 0.723726954278229, -87.6377, -1.52956641387503),
(26718, '60476', 218, 18, 351, 41.5726, 0.725578748614595, -87.6105, -1.52909168431849),
(26719, '60477', 218, 18, 121715, 41.5753, 0.725625872504398, -87.7876, -1.53218266242377),
(26720, '60478', 218, 18, 20279, 41.5601, 0.725360582458095, -87.7229, -1.53105343439773),
(26721, '60479', 218, 18, 12546, 41.2275, 0.719555617365962, -88.5224, -1.54500734176743),
(26722, '60480', 218, 18, 6844, 41.7237, 0.728215941114358, -87.8764, -1.53373251479955),
(26723, '60481', 218, 18, 14869, 41.2912, 0.720667392099483, -88.1243, -1.53805918601524),
(26724, '60482', 218, 18, 205, 41.6895, 0.727619038510176, -87.7943, -1.53229959948366),
(26725, '60490', 218, 18, 118856, 41.681, 0.727470685523756, -88.1346, -1.53823895492819),
(26726, '60499', 218, 18, 19141, 41.7836, 0.729261393336303, -87.77, -1.53187548447542),
(26727, '60501', 218, 18, 0, 41.783, 0.729250921360791, -87.8164, -1.53268531724835),
(26728, '60504', 218, 18, 474, 41.7547, 0.728756993182476, -88.2418, -1.54010994788633),
(26729, '60505', 218, 18, 474, 41.7597, 0.728844259645076, -88.2974, -1.54108035095044),
(26730, '60506', 218, 18, 474, 41.7648, 0.728933271436928, -88.355, -1.54208566059959),
(26731, '60507', 218, 18, 474, 41.7834, 0.729257902677799, -88.3149, -1.54138578356954),
(26732, '60510', 218, 18, 7293, 41.8463, 0.730355714777303, -88.3097, -1.54129502644844),
(26733, '60511', 218, 18, 7474, 41.749, 0.728657509415113, -88.5302, -1.54514347744908),
(26734, '60512', 218, 18, 15330, 41.7089, 0.727957632385063, -88.4143, -1.54312064084602),
(26735, '60513', 218, 18, 13444, 41.8226, 0.72994207174458, -87.8474, -1.53322636931647),
(26736, '60514', 218, 18, 119149, 41.7859, 0.729301535909099, -87.9554, -1.53511132490862),
(26737, '60515', 218, 18, 115329, 41.807, 0.729669800381269, -88.0213, -1.53626149688568),
(26738, '60516', 218, 18, 115329, 41.7601, 0.728851240962084, -88.0145, -1.53614281449655),
(26739, '60517', 218, 18, 13257, 41.7541, 0.728746521206964, -88.0458, -1.53668910255242),
(26740, '60518', 218, 18, 2153, 41.5859, 0.72581087740511, -88.9243, -1.55202182003119),
(26741, '60519', 218, 18, 40825, 41.778, 0.729163654898191, -88.2424, -1.54012041986184),
(26742, '60520', 218, 18, 94928, 41.7689, 0.72900482993626, -88.6453, -1.54715235141813),
(26743, '60521', 218, 18, 120039, 41.7979, 0.729510975419338, -87.9267, -1.5346104154133),
(26744, '60522', 218, 18, 120039, 41.8431, 0.730299864241239, -87.9513, -1.53503976640929),
(26745, '60523', 218, 18, 120844, 41.8329, 0.730121840657536, -87.945, -1.53492981066641),
(26746, '60525', 218, 18, 3584, 41.7811, 0.729217760105003, -87.8655, -1.53354227391108),
(26747, '60526', 218, 18, 120250, 41.8311, 0.730090424731, -87.8737, -1.53368539090974),
(26748, '60527', 218, 18, 6845, 41.7467, 0.728617366842317, -87.9241, -1.53456503685275),
(26749, '60530', 218, 18, 3715, 41.7946, 0.729453379554022, -88.9703, -1.55282467148711),
(26750, '60531', 218, 18, 10032, 41.5996, 0.726049987512633, -88.7809, -1.54951901788383),
(26751, '60532', 218, 18, 55943, 41.7884, 0.729345169140398, -88.0756, -1.53720921066952),
(26752, '60534', 218, 18, 764, 41.813, 0.729774520136389, -87.8222, -1.53278654634496),
(26753, '60536', 218, 18, 4211, 41.5948, 0.725966211708537, -88.5598, -1.54566009490767),
(26754, '60537', 218, 18, 49512, 41.561, 0.725376290421363, -88.6014, -1.5463861518765),
(26755, '60538', 218, 18, 4289, 41.7098, 0.727973340348331, -88.3378, -1.54178546396825),
(26756, '60539', 218, 18, 120687, 41.8191, 0.729880985220761, -88.3374, -1.54177848265124),
(26757, '60540', 218, 18, 120735, 41.7636, 0.728912327485904, -88.1454, -1.53842745048741),
(26758, '60541', 218, 18, 10792, 41.5178, 0.724622308184502, -88.5105, -1.54479964758644),
(26759, '60542', 218, 18, 120799, 41.8086, 0.729697725649301, -88.3269, -1.54159522307978),
(26760, '60543', 218, 18, 33527, 41.6662, 0.727212376794461, -88.3187, -1.54145210608112),
(26761, '60544', 218, 18, 11247, 41.6158, 0.726332730851456, -88.1984, -1.53935247499097),
(26762, '60545', 218, 18, 5105, 41.6692, 0.727264736672021, -88.5335, -1.5452010733144),
(26763, '60546', 218, 18, 5423, 41.837, 0.730193399156868, -87.8229, -1.53279876364973),
(26764, '60548', 218, 18, 121362, 41.6467, 0.726872037590322, -88.6223, -1.54675092569017),
(26765, '60549', 218, 18, 43007, 41.4619, 0.723646669132637, -88.7717, -1.54935844759265),
(26766, '60550', 218, 18, 121424, 41.7681, 0.728990867302243, -88.8691, -1.55105839828409),
(26767, '60551', 218, 18, 11906, 41.5272, 0.724786369134189, -88.6902, -1.54793600425228),
(26768, '60552', 218, 18, 121489, 41.6491, 0.72691392549237, -88.6791, -1.5477422727053),
(26769, '60553', 218, 18, 121580, 41.814, 0.729791973428909, -89.0207, -1.55370431743012),
(26770, '60554', 218, 18, 12174, 41.7716, 0.729051953826063, -88.4584, -1.54389033104615),
(26771, '60555', 218, 18, 84220, 41.8231, 0.72995079839084, -88.1838, -1.53909765692018),
(26772, '60556', 218, 18, 98932, 41.7524, 0.728716850609681, -88.7712, -1.54934972094639),
(26773, '60557', 218, 18, 121897, 41.4359, 0.723192883527118, -88.7737, -1.54939335417769),
(26774, '60558', 218, 18, 121944, 41.8041, 0.729619185832961, -87.9002, -1.53414790316152),
(26775, '60559', 218, 18, 14837, 41.7946, 0.729453379554022, -87.9763, -1.53547609872229),
(26776, '60560', 218, 18, 26297, 41.6232, 0.726461885216104, -88.4348, -1.54347843334268),
(26777, '60561', 218, 18, 20468, 41.7489, 0.728655764085861, -87.9772, -1.53549180668556),
(26778, '60563', 218, 18, 120735, 41.7915, 0.72939927434721, -88.1632, -1.53873811909426),
(26779, '60564', 218, 18, 120735, 41.7103, 0.727982066994591, -88.1992, -1.53936643762498),
(26780, '60565', 218, 18, 120735, 41.7377, 0.728460287209637, -88.1244, -1.53806093134449),
(26781, '60566', 218, 18, 120735, 41.7422, 0.728538827025977, -88.1258, -1.53808536595402),
(26782, '60567', 218, 18, 120735, 41.7856, 0.729296299921343, -88.1476, -1.53846584773095),
(26783, '60568', 218, 18, 474, 41.7761, 0.729130493642403, -88.2491, -1.54023735692173),
(26784, '60570', 218, 18, 120039, 41.8479, 0.730383640045335, -87.9034, -1.53420375369758),
(26785, '60572', 218, 18, 474, 41.7664, 0.72896119670496, -88.3199, -1.54147305003214),
(26786, '60597', 218, 18, 81108, 41.776, 0.729128748313151, -88.2489, -1.54023386626322),
(26787, '60598', 218, 18, 474, 41.7757, 0.729123512325395, -88.2486, -1.54022863027547),
(26788, '60599', 218, 18, 81108, 41.7722, 0.729062425801575, -88.3603, -1.54217816304995),
(26789, '60601', 218, 18, 119121, 41.886, 0.731048610490345, -87.6248, -1.52934126640153),
(26790, '60602', 218, 18, 119121, 41.8838, 0.731010213246801, -87.6276, -1.52939013562058),
(26791, '60603', 218, 18, 119121, 41.8804, 0.730950872052233, -87.6278, -1.52939362627909),
(26792, '60604', 218, 18, 119121, 41.8782, 0.730912474808689, -87.6251, -1.52934650238928),
(26793, '60605', 218, 18, 119121, 41.8673, 0.730722233920222, -87.6255, -1.52935348370629),
(26794, '60606', 218, 18, 119121, 41.8826, 0.730989269295777, -87.6363, -1.52954197926551),
(26795, '60607', 218, 18, 119121, 41.8757, 0.73086884157739, -87.6518, -1.52981250529957),
(26796, '60608', 218, 18, 119121, 41.8505, 0.730429018605887, -87.6701, -1.53013190055268),
(26797, '60609', 218, 18, 119121, 41.8121, 0.729758812173121, -87.6547, -1.52986311984787),
(26798, '60610', 218, 18, 119121, 41.8999, 0.731291211256372, -87.6371, -1.52955594189952),
(26799, '60611', 218, 18, 119121, 41.8947, 0.731200454135268, -87.6217, -1.52928716119472),
(26800, '60612', 218, 18, 119121, 41.8801, 0.730945636064477, -87.6857, -1.53040417191599),
(26801, '60613', 218, 18, 119121, 41.954, 0.732235434381701, -87.6617, -1.52998529289551),
(26802, '60614', 218, 18, 119121, 41.9217, 0.731671693033307, -87.655, -1.52986835583563),
(26803, '60615', 218, 18, 119121, 41.8032, 0.729603477869693, -87.6042, -1.52898172857562),
(26804, '60616', 218, 18, 119121, 41.8462, 0.730353969448051, -87.6292, -1.52941806088862),
(26805, '60617', 218, 18, 119121, 41.7185, 0.728125183993254, -87.5566, -1.52815095185167),
(26806, '60618', 218, 18, 119121, 41.9446, 0.732071373432014, -87.7031, -1.53070785920584),
(26807, '60619', 218, 18, 119121, 41.7441, 0.728571988281765, -87.6049, -1.52899394588038),
(26808, '60620', 218, 18, 119121, 41.7399, 0.728498684453181, -87.653, -1.52983344925059),
(26809, '60621', 218, 18, 119121, 41.7771, 0.729147946934923, -87.6403, -1.52961179243559),
(26810, '60622', 218, 18, 119121, 41.9013, 0.7313156458659, -87.6713, -1.5301528445037),
(26811, '60623', 218, 18, 119121, 41.8498, 0.730416801301123, -87.7176, -1.53096093194738),
(26812, '60624', 218, 18, 119121, 41.8796, 0.730936909418217, -87.7217, -1.53103249044671),
(26813, '60625', 218, 18, 119121, 41.9706, 0.732525159037532, -87.7031, -1.53070785920584),
(26814, '60626', 218, 18, 119121, 42.0073, 0.733165694873014, -87.6703, -1.53013539121118),
(26815, '60628', 218, 18, 119121, 41.6933, 0.727685361021752, -87.6212, -1.52927843454846),
(26816, '60629', 218, 18, 119121, 41.7769, 0.729144456276419, -87.7107, -1.53084050422899),
(26817, '60630', 218, 18, 119121, 41.9714, 0.732539121671548, -87.7582, -1.53166953562369),
(26818, '60631', 218, 18, 119121, 41.991, 0.732881206204939, -87.8052, -1.53248984037213),
(26819, '60632', 218, 18, 119121, 41.8087, 0.729699470978553, -87.7123, -1.53086842949702),
(26820, '60633', 218, 18, 119121, 41.6532, 0.726985483991702, -87.556, -1.52814047987616),
(26821, '60634', 218, 18, 119121, 41.9439, 0.73205915612725, -87.8102, -1.53257710683472),
(26822, '60636', 218, 18, 119121, 41.7755, 0.729120021666891, -87.6692, -1.53011619258941),
(26823, '60637', 218, 18, 119121, 41.7803, 0.729203797470987, -87.6024, -1.52895031264908),
(26824, '60638', 218, 18, 119121, 41.7813, 0.729221250763507, -87.7724, -1.53191737237747),
(26825, '60639', 218, 18, 119121, 41.92, 0.731642022436023, -87.7566, -1.53164161035566),
(26826, '60640', 218, 18, 119121, 41.9725, 0.73255832029332, -87.6679, -1.53009350330914),
(26827, '60641', 218, 18, 119121, 41.944, 0.732060901456502, -87.747, -1.53147405874746),
(26828, '60643', 218, 18, 119121, 41.6995, 0.727793571435375, -87.663, -1.53000798217579);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(26829, '60644', 218, 18, 119121, 41.8826, 0.730989269295777, -87.7573, -1.53165382766042),
(26830, '60645', 218, 18, 119121, 42.0073, 0.733165694873014, -87.7061, -1.5307602190834),
(26831, '60646', 218, 18, 119121, 41.9934, 0.732923094106987, -87.7516, -1.53155434389306),
(26832, '60647', 218, 18, 119121, 41.9204, 0.731649003753031, -87.7009, -1.5306694619623),
(26833, '60649', 218, 18, 119121, 41.7617, 0.728879166230116, -87.5709, -1.5284005339347),
(26834, '60651', 218, 18, 119121, 41.902, 0.731327863170664, -87.7398, -1.53134839504132),
(26835, '60652', 218, 18, 119121, 41.7447, 0.728582460257277, -87.7153, -1.53092078937458),
(26836, '60653', 218, 18, 119121, 41.819, 0.729879239891509, -87.6107, -1.529095174977),
(26837, '60654', 218, 18, 119121, 41.8882, 0.731087007733889, -87.635, -1.52951928998523),
(26838, '60655', 218, 18, 119121, 41.6905, 0.727636491802696, -87.7109, -1.53084399488749),
(26839, '60656', 218, 18, 119121, 41.975, 0.73260195352462, -87.8248, -1.53283192490552),
(26840, '60657', 218, 18, 119121, 41.9398, 0.731987597627918, -87.6564, -1.52989279044516),
(26841, '60659', 218, 18, 119121, 41.9914, 0.732888187521947, -87.7056, -1.53075149243714),
(26842, '60660', 218, 18, 119121, 41.9913, 0.732886442192695, -87.6675, -1.53008652199213),
(26843, '60661', 218, 18, 119121, 41.8831, 0.730997995942037, -87.6439, -1.52967462428866),
(26844, '60663', 218, 18, 119121, 41.8847, 0.731025921210069, -87.6352, -1.52952278064373),
(26845, '60664', 218, 18, 119121, 41.8747, 0.73085138828487, -87.6559, -1.5298840637989),
(26846, '60665', 218, 18, 119121, 41.8847, 0.731025921210069, -87.6348, -1.52951579932673),
(26847, '60666', 218, 18, 0, 41.9752, 0.732605444183124, -87.8973, -1.53409728861321),
(26848, '60667', 218, 18, 119121, 41.813, 0.729774520136389, -87.6556, -1.52987882781114),
(26849, '60668', 218, 18, 119121, 41.8812, 0.730964834686249, -87.627, -1.52937966364507),
(26850, '60669', 218, 18, 119121, 41.874, 0.730839170980106, -87.6488, -1.52976014542201),
(26851, '60670', 218, 18, 119121, 41.8873, 0.731071299770621, -87.6228, -1.52930635981649),
(26852, '60671', 218, 18, 119121, 41.9014, 0.731317391195152, -87.6368, -1.52955070591177),
(26853, '60672', 218, 18, 119121, 41.8742, 0.73084266163861, -87.6486, -1.5297566547635),
(26854, '60673', 218, 18, 119121, 41.8868, 0.731062573124361, -87.6291, -1.52941631555936),
(26855, '60674', 218, 18, 119121, 41.8751, 0.730858369601878, -87.6484, -1.529753164105),
(26856, '60675', 218, 18, 119121, 41.8805, 0.730952617381485, -87.6319, -1.52946518477842),
(26857, '60677', 218, 18, 119121, 41.882, 0.730978797320265, -87.6366, -1.52954721525326),
(26858, '60678', 218, 18, 119121, 41.8825, 0.730987523966525, -87.6325, -1.52947565675393),
(26859, '60679', 218, 18, 119121, 41.8826, 0.730989269295777, -87.6368, -1.52955070591177),
(26860, '60680', 218, 18, 119121, 41.8654, 0.730689072664434, -87.6455, -1.52970254955669),
(26861, '60681', 218, 18, 119121, 41.8745, 0.730847897626365, -87.6486, -1.5297566547635),
(26862, '60682', 218, 18, 119121, 41.8371, 0.73019514448612, -87.685, -1.53039195461123),
(26863, '60683', 218, 18, 119121, 41.8143, 0.729797209416665, -87.6596, -1.52994864098122),
(26864, '60684', 218, 18, 119121, 41.8692, 0.73075539517601, -87.6717, -1.53015982582071),
(26865, '60685', 218, 18, 119121, 41.8785, 0.730917710796445, -87.6258, -1.52935871969405),
(26866, '60686', 218, 18, 119121, 41.8502, 0.730423782618131, -87.6495, -1.52977236272677),
(26867, '60687', 218, 18, 119121, 41.8803, 0.730949126722981, -87.6251, -1.52934650238928),
(26868, '60688', 218, 18, 119121, 41.8499, 0.730418546630375, -87.6497, -1.52977585338527),
(26869, '60690', 218, 18, 119121, 41.8795, 0.730935164088965, -87.6305, -1.52944075016889),
(26870, '60691', 218, 18, 119121, 41.8787, 0.730921201454949, -87.6147, -1.52916498814708),
(26871, '60693', 218, 18, 119121, 41.8787, 0.730921201454949, -87.6152, -1.52917371479334),
(26872, '60694', 218, 18, 119121, 41.8804, 0.730950872052233, -87.631, -1.52944947681515),
(26873, '60695', 218, 18, 119121, 41.8777, 0.730903748162429, -87.6344, -1.52950881800972),
(26874, '60696', 218, 18, 119121, 41.8505, 0.730429018605887, -87.6503, -1.52978632536079),
(26875, '60697', 218, 18, 119121, 41.8799, 0.730942145405973, -87.6148, -1.52916673347633),
(26876, '60699', 218, 18, 119121, 41.8744, 0.730846152297114, -87.6488, -1.52976014542201),
(26877, '60701', 218, 18, 119121, 42.0275, 0.733518251381917, -87.808, -1.53253870959118),
(26878, '60706', 218, 18, 3002, 41.9633, 0.732397750002136, -87.8165, -1.5326870625776),
(26879, '60707', 218, 18, 80874, 41.923, 0.731694382313583, -87.8165, -1.5326870625776),
(26880, '60712', 218, 18, 120366, 42.0057, 0.733137769604982, -87.7361, -1.531283817859),
(26881, '60714', 218, 18, 17280, 42.0296, 0.733554903296209, -87.8121, -1.53261026809051),
(26882, '60803', 218, 18, 118604, 41.6692, 0.727264736672021, -87.7369, -1.53129778049301),
(26883, '60804', 218, 18, 32068, 41.8444, 0.730322553521515, -87.7602, -1.53170444220873),
(26884, '60805', 218, 18, 46929, 41.7225, 0.728194997163334, -87.701, -1.53067120729155),
(26885, '60827', 218, 18, 5416, 41.6443, 0.726830149688275, -87.6302, -1.52943551418114),
(26886, '60901', 218, 18, 120174, 41.1155, 0.717600848603729, -87.8589, -1.53342708218045),
(26887, '60902', 218, 18, 120174, 41.1204, 0.717686369737076, -87.8614, -1.53347071541175),
(26888, '60910', 218, 18, 118654, 41.08, 0.716981256719271, -87.8071, -1.53252300162791),
(26889, '60911', 218, 18, 118665, 40.8803, 0.713495834203038, -87.9504, -1.53502405844602),
(26890, '60912', 218, 18, 70524, 40.9466, 0.71465298749711, -87.6708, -1.53014411785744),
(26891, '60913', 218, 18, 44926, 41.1471, 0.718152372647359, -88.0574, -1.53689156074565),
(26892, '60914', 218, 18, 118866, 41.1622, 0.71841591736441, -87.8805, -1.53380407329888),
(26893, '60915', 218, 18, 694, 41.145, 0.718115720733067, -87.864, -1.5335160939723),
(26894, '60917', 218, 18, 793, 41.0449, 0.716368646151821, -88.1735, -1.53891788800722),
(26895, '60918', 218, 18, 118947, 40.5967, 0.708546080444382, -88.0361, -1.53651980561498),
(26896, '60919', 218, 18, 118995, 40.9475, 0.714668695460378, -88.153, -1.53856009551056),
(26897, '60920', 218, 18, 119022, 41.0266, 0.716049250898706, -88.3063, -1.54123568525387),
(26898, '60921', 218, 18, 19964, 40.7544, 0.711298464674777, -88.2922, -1.54098959382934),
(26899, '60922', 218, 18, 119100, 41.0061, 0.715691458402047, -87.9124, -1.53436083333026),
(26900, '60924', 218, 18, 119142, 40.5653, 0.707998047059256, -87.8954, -1.53406412735742),
(26901, '60926', 218, 18, 100870, 40.5668, 0.708024226998036, -87.8227, -1.53279527299122),
(26902, '60927', 218, 18, 15559, 40.9344, 0.714440057328367, -87.9344, -1.5347448057657),
(26903, '60928', 218, 18, 15666, 40.7713, 0.711593425318364, -87.8579, -1.53340962888793),
(26904, '60929', 218, 18, 119289, 40.8784, 0.71346267294725, -88.2689, -1.54058293211362),
(26905, '60930', 218, 18, 59197, 40.8237, 0.712507977846409, -87.9793, -1.53552845859985),
(26906, '60931', 218, 18, 20627, 40.8839, 0.71355866605611, -87.6156, -1.52918069611034),
(26907, '60932', 218, 18, 109001, 40.2202, 0.701974915810623, -87.5941, -1.52880545032117),
(26908, '60933', 218, 18, 8728, 40.4637, 0.70622479253923, -88.2751, -1.54069114252725),
(26909, '60934', 218, 18, 119538, 40.9694, 0.715050922566565, -88.3578, -1.54213452981865),
(26910, '60935', 218, 18, 8781, 41.1776, 0.718684698069217, -88.1889, -1.53918666871203),
(26911, '60936', 218, 18, 119774, 40.4675, 0.706291115050805, -88.3739, -1.54241552782822),
(26912, '60938', 218, 18, 102246, 40.7681, 0.7115375747823, -87.9919, -1.5357483700856),
(26913, '60939', 218, 18, 119815, 40.5689, 0.708060878912328, -87.7852, -1.53214077452173),
(26914, '60940', 218, 18, 119834, 41.2386, 0.719749348912934, -87.6472, -1.52973222015397),
(26915, '60941', 218, 18, 119998, 41.0514, 0.7164820925532, -88.0964, -1.53757223915393),
(26916, '60942', 218, 18, 120065, 40.4671, 0.706284133733797, -87.6698, -1.53012666456492),
(26917, '60944', 218, 18, 120073, 41.0726, 0.716852102354623, -87.6145, -1.52916149748857),
(26918, '60945', 218, 18, 109799, 40.8275, 0.712574300357985, -87.5818, -1.52859077482317),
(26919, '60946', 218, 18, 48600, 40.9352, 0.714454019962383, -88.2383, -1.54004886136251),
(26920, '60948', 218, 18, 110161, 40.5276, 0.707340057931254, -88.0958, -1.53756176717842),
(26921, '60949', 218, 18, 37000, 40.3869, 0.704884379673698, -88.1267, -1.53810107391729),
(26922, '60950', 218, 18, 116706, 41.2278, 0.719560853353718, -87.8368, -1.53304136441576),
(26923, '60951', 218, 18, 120532, 40.9165, 0.71412764339226, -87.7272, -1.53112848355557),
(26924, '60952', 218, 18, 4160, 40.5728, 0.708128946753155, -88.2482, -1.54022164895846),
(26925, '60953', 218, 18, 10480, 40.6418, 0.709333223937031, -87.6987, -1.53063106471875),
(26926, '60954', 218, 18, 120664, 41.1631, 0.718431625327678, -87.6631, -1.53000972750504),
(26927, '60955', 218, 18, 120895, 40.7226, 0.710743449972643, -87.9982, -1.53585832582847),
(26928, '60956', 218, 18, 120964, 40.9688, 0.715040450591053, -87.7163, -1.5309382426671),
(26929, '60957', 218, 18, 17550, 40.4595, 0.706151488710646, -88.0944, -1.53753733256889),
(26930, '60959', 218, 18, 121052, 40.7575, 0.711352569881589, -88.1896, -1.53919888601679),
(26931, '60960', 218, 18, 52, 40.4638, 0.706226537868482, -87.8964, -1.53408158064994),
(26932, '60961', 218, 18, 17772, 41.0975, 0.717286689338369, -88.2475, -1.5402094316537),
(26933, '60962', 218, 18, 5442, 40.6147, 0.708860239709741, -88.183, -1.53908369428616),
(26934, '60963', 218, 18, 24541, 40.3786, 0.704739517345782, -87.6658, -1.53005685139484),
(26935, '60964', 218, 18, 51142, 41.0234, 0.715993400362642, -87.717, -1.53095045997187),
(26936, '60966', 218, 18, 57525, 40.7715, 0.711596915976868, -87.5647, -1.52829232352108),
(26937, '60967', 218, 18, 121588, 40.6143, 0.708853258392733, -87.5922, -1.52877228906538),
(26938, '60968', 218, 18, 121682, 40.674, 0.709895219956174, -88.1132, -1.53786545446827),
(26939, '60969', 218, 18, 784, 41.1097, 0.717499619507113, -88.1456, -1.53843094114591),
(26940, '60970', 218, 18, 121878, 40.7768, 0.711689418427224, -87.7392, -1.53133792306581),
(26941, '60973', 218, 18, 902, 40.5392, 0.707542516124485, -87.6798, -1.53030119749012),
(26942, '60974', 218, 18, 6917, 40.7145, 0.710602078303231, -87.7314, -1.53120178738415),
(26943, '61001', 218, 18, 118644, 42.4768, 0.741360015711127, -90.1081, -1.5726830277163),
(26944, '61006', 218, 18, 7180, 41.8485, 0.730394112020847, -89.2009, -1.55684940074221),
(26945, '61007', 218, 18, 31717, 42.19, 0.736354411416408, -89.5912, -1.56366142081274),
(26946, '61008', 218, 18, 13361, 42.2629, 0.737626756441112, -88.8524, -1.55076692829901),
(26947, '61010', 218, 18, 7810, 42.1265, 0.735246127341391, -89.2645, -1.55795943014648),
(26948, '61011', 218, 18, 1296, 42.3873, 0.739797946030592, -88.8961, -1.55152963718213),
(26949, '61012', 218, 18, 75328, 42.4065, 0.740133049246975, -88.7522, -1.54901810838851),
(26950, '61013', 218, 18, 1435, 42.3753, 0.739588506520353, -89.6358, -1.56443983765913),
(26951, '61014', 218, 18, 45582, 41.9153, 0.731559991961179, -89.8295, -1.56782054042025),
(26952, '61015', 218, 18, 119084, 41.9884, 0.732835827644387, -89.2071, -1.55695761115583),
(26953, '61016', 218, 18, 8055, 42.2179, 0.736841358277714, -88.9668, -1.55276358496329),
(26954, '61018', 218, 18, 20443, 42.4067, 0.740136539905479, -89.5461, -1.56287427732009),
(26955, '61019', 218, 18, 20476, 42.4398, 0.740714243887889, -89.4185, -1.56064723719455),
(26956, '61020', 218, 18, 119323, 42.1015, 0.734809795028393, -89.091, -1.55493128389427),
(26957, '61021', 218, 18, 828, 41.8396, 0.730238777717419, -89.4911, -1.5619143462315),
(26958, '61024', 218, 18, 20717, 42.4398, 0.740714243887889, -89.3112, -1.55877449890716),
(26959, '61025', 218, 18, 119444, 42.4833, 0.741473462112507, -90.599, -1.58125084901434),
(26960, '61027', 218, 18, 119498, 42.3399, 0.738970659965147, -89.7538, -1.56649932617649),
(26961, '61028', 218, 18, 8719, 42.3067, 0.738391210653485, -90.185, -1.57402518591109),
(26962, '61030', 218, 18, 59946, 42.1172, 0.735083811720956, -89.5848, -1.56354971974062),
(26963, '61031', 218, 18, 64891, 41.8295, 0.730062499462968, -89.3082, -1.5587221390296),
(26964, '61032', 218, 18, 16142, 42.3038, 0.738340596105177, -89.6341, -1.56441016706185),
(26965, '61036', 218, 18, 9031, 42.4075, 0.740150502539495, -90.3706, -1.57726451700279),
(26966, '61037', 218, 18, 32508, 41.7889, 0.729353895786658, -89.7611, -1.56662673521188),
(26967, '61038', 218, 18, 119744, 42.2493, 0.73738939166284, -88.7367, -1.54874758235445),
(26968, '61039', 218, 18, 115720, 42.2172, 0.73682914097295, -89.4676, -1.56150419385728),
(26969, '61041', 218, 18, 2963, 42.2713, 0.737773364098279, -90.3006, -1.57604278652639),
(26970, '61042', 218, 18, 234, 41.6957, 0.7277272489238, -89.5582, -1.56308546215959),
(26971, '61043', 218, 18, 21985, 42.0649, 0.734171004522163, -89.0956, -1.55501156903986),
(26972, '61044', 218, 18, 3501, 42.3221, 0.738659991358292, -89.9003, -1.56905623353066),
(26973, '61046', 218, 18, 9973, 42.1126, 0.735003526575364, -89.8379, -1.56796714807741),
(26974, '61047', 218, 18, 60591, 42.1433, 0.735539342655726, -89.405, -1.56041161774553),
(26975, '61048', 218, 18, 10035, 42.3833, 0.739728132860513, -89.8242, -1.56772803796989),
(26976, '61049', 218, 18, 30348, 42.0509, 0.733926658426884, -89.0235, -1.55375318664917),
(26977, '61050', 218, 18, 66704, 42.4397, 0.740712498558638, -89.7307, -1.56609615511928),
(26978, '61051', 218, 18, 23097, 41.9627, 0.732387278026625, -89.7757, -1.56688155328267),
(26979, '61052', 218, 18, 120674, 42.1049, 0.73486913622296, -89.0035, -1.55340412079877),
(26980, '61053', 218, 18, 120709, 42.0973, 0.734736491199809, -89.9775, -1.5704036277132),
(26981, '61054', 218, 18, 78784, 42.0537, 0.733975527645939, -89.434, -1.56091776322861),
(26982, '61057', 218, 18, 120733, 41.8311, 0.730090424731, -89.3908, -1.56016378099175),
(26983, '61058', 218, 18, 4506, 41.7952, 0.729463851529534, -89.6031, -1.56386911499373),
(26984, '61059', 218, 18, 30672, 42.4586, 0.741042365787264, -89.946, -1.56985384899882),
(26985, '61060', 218, 18, 30739, 42.4747, 0.741323363796836, -89.6337, -1.56440318574484),
(26986, '61061', 218, 18, 37541, 42.0018, 0.733069701764154, -89.3366, -1.55921781253717),
(26987, '61062', 218, 18, 89822, 42.261, 0.737593595185324, -89.831, -1.56784672035903),
(26988, '61063', 218, 18, 120989, 42.309, 0.738431353226281, -89.335, -1.55918988726913),
(26989, '61064', 218, 18, 56980, 41.9944, 0.732940547399507, -89.588, -1.56360557027668),
(26990, '61065', 218, 18, 11337, 42.377, 0.739618177117637, -88.8448, -1.55063428327586),
(26991, '61067', 218, 18, 121214, 42.3041, 0.738345832092933, -89.4852, -1.56181137180563),
(26992, '61068', 218, 18, 17824, 41.9349, 0.73190207649457, -89.0771, -1.55468868312824),
(26993, '61070', 218, 18, 5455, 42.4109, 0.740209843734063, -89.4749, -1.56163160289267),
(26994, '61071', 218, 18, 117565, 41.7587, 0.728826806352556, -89.6923, -1.56542594868651),
(26995, '61072', 218, 18, 83352, 42.449, 0.740874814179073, -89.105, -1.55517562998955),
(26996, '61073', 218, 18, 24518, 42.4242, 0.740441972524578, -88.9926, -1.55321387991031),
(26997, '61074', 218, 18, 77189, 42.0994, 0.734773143114101, -90.1258, -1.57299195099391),
(26998, '61075', 218, 18, 121383, 42.4678, 0.741202936078448, -90.2516, -1.57518757519291),
(26999, '61077', 218, 18, 33926, 42.2391, 0.737211368079137, -89.3575, -1.55958258635083),
(27000, '61078', 218, 18, 5777, 42.1504, 0.735663261032618, -89.7367, -1.5662008748744),
(27001, '61079', 218, 18, 121451, 42.4433, 0.740775330411709, -89.1977, -1.55679355020615),
(27002, '61080', 218, 18, 121496, 42.4839, 0.741483934088019, -89.0354, -1.55396088083016),
(27003, '61081', 218, 18, 25116, 41.815, 0.729809426721429, -89.7163, -1.56584482770699),
(27004, '61084', 218, 18, 121585, 42.1134, 0.73501748920938, -89.1919, -1.55669232110953),
(27005, '61085', 218, 18, 510, 42.343, 0.739024765171959, -90.0357, -1.57141940933786),
(27006, '61087', 218, 18, 12663, 42.488, 0.741555492587351, -89.993, -1.57067415374726),
(27007, '61088', 218, 18, 122019, 42.2752, 0.737841431939107, -89.2485, -1.55768017746616),
(27008, '61089', 218, 18, 567, 42.4684, 0.74121340805396, -89.8055, -1.56740166139977),
(27009, '61091', 218, 18, 122067, 41.9059, 0.731395931011492, -89.5434, -1.56282715343029),
(27010, '61101', 218, 18, 5475, 42.2982, 0.738242857667066, -89.1279, -1.55557531038825),
(27011, '61102', 218, 18, 5475, 42.2525, 0.737445242198904, -89.1313, -1.55563465158282),
(27012, '61103', 218, 18, 5475, 42.3006, 0.738284745569113, -89.1039, -1.55515643136778),
(27013, '61104', 218, 18, 5475, 42.2552, 0.737492366088708, -89.0815, -1.55476547761533),
(27014, '61105', 218, 18, 5475, 42.2676, 0.737708786915955, -89.0957, -1.55501331436911),
(27015, '61106', 218, 18, 5475, 42.2708, 0.737764637452019, -89.0635, -1.55445131834997),
(27016, '61107', 218, 18, 5475, 42.2813, 0.737947897023479, -89.0274, -1.55382125449),
(27017, '61108', 218, 18, 5475, 42.2527, 0.737448732857408, -89.0278, -1.55382823580701),
(27018, '61109', 218, 18, 5475, 42.2146, 0.736783762412398, -89.0523, -1.55425584147375),
(27019, '61110', 218, 18, 5475, 42.2673, 0.737703550928199, -89.0821, -1.55477594959084),
(27020, '61111', 218, 18, 120443, 42.3281, 0.738764711113412, -89.0264, -1.55380380119748),
(27021, '61112', 218, 18, 5475, 42.2403, 0.737232312030161, -88.9775, -1.55295033519325),
(27022, '61114', 218, 18, 5475, 42.3057, 0.738373757360965, -89.0146, -1.55359785234574),
(27023, '61115', 218, 18, 120463, 42.3543, 0.739221987377434, -89.0422, -1.55407956321929),
(27024, '61125', 218, 18, 5475, 42.239, 0.737209622749885, -89.0151, -1.553606578992),
(27025, '61126', 218, 18, 5475, 42.2538, 0.73746793147918, -89.0178, -1.55365370288181),
(27026, '61130', 218, 18, 120443, 42.3245, 0.73870187926034, -89.0019, -1.55337619553074),
(27027, '61131', 218, 18, 120443, 42.3529, 0.739197552767906, -88.9969, -1.55328892906814),
(27028, '61132', 218, 18, 120443, 42.3522, 0.739185335463142, -88.997, -1.55329067439739),
(27029, '61201', 218, 18, 17831, 41.4869, 0.724083001445636, -90.57, -1.58074470353126),
(27030, '61204', 218, 18, 17831, 41.4916, 0.724165031920479, -90.5696, -1.58073772221426),
(27031, '61230', 218, 18, 18772, 41.7677, 0.728983885985236, -90.2156, -1.5745592566622),
(27032, '61231', 218, 18, 74958, 41.2006, 0.719086123797176, -90.7506, -1.58389676816037),
(27033, '61232', 218, 18, 14987, 41.4399, 0.723262696697198, -90.725, -1.58344996387186),
(27034, '61233', 218, 18, 14988, 41.295, 0.720733714611058, -90.2901, -1.57585952695493),
(27035, '61234', 218, 18, 118628, 41.3965, 0.722505223801833, -89.9097, -1.56922029448035),
(27036, '61235', 218, 18, 18953, 41.4197, 0.722910140188295, -90.0151, -1.57105987151195),
(27037, '61236', 218, 18, 44611, 41.5138, 0.724552495014422, -90.373, -1.57730640490484),
(27038, '61237', 218, 18, 118956, 41.384, 0.722287057645333, -90.9113, -1.58670151226832),
(27039, '61238', 218, 18, 1302, 41.3051, 0.72090999286551, -90.19, -1.57411245237369),
(27040, '61239', 218, 18, 119030, 41.4955, 0.724233099761307, -90.393, -1.57765547075523),
(27041, '61240', 218, 18, 1661, 41.4319, 0.723123070357039, -90.4676, -1.57895748637722),
(27042, '61241', 218, 18, 8186, 41.4803, 0.723967809715004, -90.3281, -1.57652275207069),
(27043, '61242', 218, 18, 924, 41.6879, 0.727591113242144, -90.2928, -1.57590665084474),
(27044, '61243', 218, 18, 119342, 41.6172, 0.726357165460984, -89.6804, -1.56521825450552),
(27045, '61244', 218, 18, 119454, 41.5141, 0.724557731002178, -90.421, -1.57814416294579),
(27046, '61250', 218, 18, 15943, 41.6693, 0.727266482001273, -90.0941, -1.57243868162102),
(27047, '61251', 218, 18, 2431, 41.7323, 0.72836603943003, -90.0718, -1.57204947319783),
(27048, '61252', 218, 18, 2628, 41.854, 0.730490105129707, -90.1446, -1.57332007289328),
(27049, '61254', 218, 18, 32546, 41.4596, 0.723606526559841, -90.1627, -1.57363597748789),
(27050, '61256', 218, 18, 2957, 41.554, 0.725254117373724, -90.4045, -1.57785618361921),
(27051, '61257', 218, 18, 3147, 41.6085, 0.726205321816061, -90.2076, -1.57441963032204),
(27052, '61258', 218, 18, 120066, 41.5216, 0.724688630696077, -89.9117, -1.56925520106539),
(27053, '61259', 218, 18, 120103, 41.3807, 0.722229461780017, -90.8974, -1.58645891150229),
(27054, '61260', 218, 18, 3468, 41.198, 0.719040745236624, -90.8785, -1.58612904427367),
(27055, '61261', 218, 18, 33157, 41.7259, 0.728254338357902, -89.9162, -1.56933374088173),
(27056, '61262', 218, 18, 120455, 41.2894, 0.720635976172947, -90.2976, -1.57599042664883),
(27057, '61263', 218, 18, 60795, 41.277, 0.720419555345699, -90.61, -1.58144283523206),
(27058, '61264', 218, 18, 23084, 41.4241, 0.722986934675383, -90.5766, -1.5808598952619),
(27059, '61265', 218, 18, 33316, 41.4894, 0.724126634676935, -90.4961, -1.57945490521404),
(27060, '61266', 218, 18, 33316, 41.5069, 0.724432067296034, -90.5138, -1.57976382849164),
(27061, '61270', 218, 18, 42178, 41.8231, 0.72995079839084, -89.9637, -1.57016277227642),
(27062, '61272', 218, 18, 30620, 41.249, 0.719930863155141, -90.9912, -1.58809603034066),
(27063, '61273', 218, 18, 4800, 41.3556, 0.721791384137767, -90.3799, -1.57742683262322),
(27064, '61274', 218, 18, 262, 41.3678, 0.72200431430651, -90.261, -1.5753516361426),
(27065, '61275', 218, 18, 121091, 41.5975, 0.726013335598341, -90.317, -1.57632902052372),
(27066, '61276', 218, 18, 121121, 41.277, 0.720419555345699, -90.6094, -1.58143236325655),
(27067, '61277', 218, 18, 121131, 41.6557, 0.727029117223002, -89.9223, -1.5694402059661),
(27068, '61278', 218, 18, 121166, 41.5795, 0.725699176332982, -90.3464, -1.57684214732381),
(27069, '61279', 218, 18, 5360, 41.339, 0.721501659481936, -90.7037, -1.58307820874118),
(27070, '61281', 218, 18, 111375, 41.3109, 0.721011221962125, -90.4938, -1.57941476264124),
(27071, '61282', 218, 18, 121467, 41.501, 0.724329092870167, -90.4158, -1.57805340582469),
(27072, '61283', 218, 18, 31285, 41.6348, 0.726664343409335, -89.7817, -1.56698627303779),
(27073, '61284', 218, 18, 121668, 41.4046, 0.722646595471244, -90.7459, -1.58381473768552),
(27074, '61285', 218, 18, 25465, 41.9599, 0.732338408807569, -90.1026, -1.57258703460744),
(27075, '61299', 218, 18, 17831, 41.518, 0.724625798843006, -90.5311, -1.58006577045224),
(27076, '61301', 218, 18, 95463, 41.3519, 0.721726806955443, -89.0926, -1.5549592091623),
(27077, '61310', 218, 18, 7087, 41.7042, 0.727875601910219, -89.3418, -1.55930856965827),
(27078, '61311', 218, 18, 118622, 41.0517, 0.716487328540956, -88.9312, -1.55214224774958),
(27079, '61312', 218, 18, 15026, 41.4522, 0.723477372195193, -89.2213, -1.55720544790962),
(27080, '61313', 218, 18, 99958, 41.0635, 0.716693277392692, -88.6423, -1.54709999154057),
(27081, '61314', 218, 18, 993, 41.3263, 0.721280002666933, -89.6799, -1.56520952785926),
(27082, '61315', 218, 18, 45239, 41.2885, 0.720620268209679, -89.367, -1.55974839262977),
(27083, '61316', 218, 18, 1427, 41.2635, 0.72018393589668, -89.1254, -1.55553167715695),
(27084, '61317', 218, 18, 63638, 41.4261, 0.723021841260423, -89.2117, -1.55703789630143),
(27085, '61318', 218, 18, 1738, 41.7008, 0.727816260715651, -89.0833, -1.55479689354186),
(27086, '61319', 218, 18, 20256, 40.9912, 0.7154314043435, -88.7305, -1.54863937194083),
(27087, '61320', 218, 18, 72267, 41.3521, 0.721730297613947, -89.3217, -1.55895775847862),
(27088, '61321', 218, 18, 15726, 40.9773, 0.715188803577472, -88.9677, -1.55277929292656),
(27089, '61322', 218, 18, 108848, 41.3262, 0.721278257337681, -89.3012, -1.55859996598196),
(27090, '61323', 218, 18, 8583, 41.3622, 0.721906575868399, -89.3973, -1.56027722739313),
(27091, '61324', 218, 18, 119493, 41.7707, 0.729036245862795, -89.4121, -1.56053553612242),
(27092, '61325', 218, 18, 16262, 41.2389, 0.71975458490069, -88.829, -1.55035852125404),
(27093, '61326', 218, 18, 55048, 41.263, 0.72017520925042, -89.2298, -1.55735380089604),
(27094, '61327', 218, 18, 76065, 41.2534, 0.720007657642229, -89.3408, -1.55929111636575),
(27095, '61328', 218, 18, 120179, 41.5045, 0.724390179393987, -89.4669, -1.56149197655251),
(27096, '61329', 218, 18, 9918, 41.3821, 0.722253896389546, -89.2185, -1.55715657869056),
(27097, '61330', 218, 18, 120254, 41.5308, 0.724849200987261, -89.2809, -1.55824566414381),
(27098, '61331', 218, 18, 120322, 41.7485, 0.728648782768853, -89.2787, -1.55820726690026),
(27099, '61332', 218, 18, 120338, 41.1894, 0.718890646920952, -88.9828, -1.55304283764361),
(27100, '61333', 218, 18, 16936, 41.0049, 0.715670514451023, -88.8932, -1.55147902263382),
(27101, '61334', 218, 18, 120438, 41.1445, 0.718106994086807, -89.0818, -1.55477071360308),
(27102, '61335', 218, 18, 120576, 41.1766, 0.718667244776697, -89.2091, -1.55699251774087),
(27103, '61336', 218, 18, 3947, 41.1223, 0.717719530992864, -89.2468, -1.55765050686888),
(27104, '61337', 218, 18, 56057, 41.4247, 0.722997406650895, -89.3684, -1.5597728272393),
(27105, '61338', 218, 18, 120492, 41.4557, 0.723538458719013, -89.6689, -1.56501754164154),
(27106, '61340', 218, 18, 37060, 41.2652, 0.720213606493964, -89.2481, -1.55767319614915),
(27107, '61341', 218, 18, 120525, 41.33, 0.721344579849256, -88.7083, -1.54825190884689),
(27108, '61342', 218, 18, 104190, 41.5439, 0.725077839119272, -89.1068, -1.55520704591608),
(27109, '61344', 218, 18, 10518, 41.3814, 0.722241679084781, -89.8384, -1.56797587472367),
(27110, '61345', 218, 18, 110616, 41.3, 0.720820981073658, -89.7932, -1.56718698590177),
(27111, '61346', 218, 18, 120755, 41.5349, 0.724920759486593, -89.7542, -1.56650630749349),
(27112, '61348', 218, 18, 23610, 41.2906, 0.720656920123971, -89.0482, -1.55418428297441),
(27113, '61349', 218, 18, 23617, 41.6012, 0.726077912780665, -89.453, -1.56124937578649),
(27114, '61350', 218, 18, 33532, 41.3484, 0.721665720431623, -88.8486, -1.55070060578743),
(27115, '61353', 218, 18, 37604, 41.691, 0.727645218448956, -88.995, -1.55325576781235),
(27116, '61354', 218, 18, 33609, 41.3331, 0.721398685056068, -89.126, -1.55554214913247),
(27117, '61356', 218, 18, 5231, 41.3734, 0.722102052744622, -89.462, -1.56140645541917),
(27118, '61358', 218, 18, 17882, 40.985, 0.715323193929876, -89.0358, -1.55396786214717),
(27119, '61359', 218, 18, 38140, 41.3638, 0.72193450113643, -89.2724, -1.55809731115739),
(27120, '61360', 218, 18, 18037, 41.3278, 0.721306182605713, -88.6102, -1.54653974085068),
(27121, '61361', 218, 18, 5785, 41.355, 0.721780912162255, -89.7361, -1.56619040289888),
(27122, '61362', 218, 18, 826, 41.3301, 0.721346325178508, -89.2225, -1.55722639186064),
(27123, '61363', 218, 18, 6044, 41.2561, 0.720054781532033, -89.1779, -1.55644797501425),
(27124, '61364', 218, 18, 121600, 41.1261, 0.71778585350444, -88.8315, -1.55040215448534),
(27125, '61367', 218, 18, 121606, 41.6288, 0.726559623654215, -89.2562, -1.55781456781856),
(27126, '61368', 218, 18, 121718, 41.2932, 0.720702298684523, -89.5081, -1.56221105220434),
(27127, '61369', 218, 18, 12344, 41.0052, 0.715675750438779, -89.1305, -1.55562068894881),
(27128, '61370', 218, 18, 121724, 41.2162, 0.719358395160487, -89.0521, -1.55425235081524),
(27129, '61371', 218, 18, 43391, 41.4999, 0.724309894248395, -89.0215, -1.55371828006413),
(27130, '61372', 218, 18, 121745, 41.4673, 0.723740916912245, -89.0828, -1.5547881668956),
(27131, '61373', 218, 18, 31360, 41.385, 0.722304510937853, -88.9985, -1.55331685433617),
(27132, '61374', 218, 18, 121791, 41.5515, 0.725210484142424, -89.3542, -1.55952499048552),
(27133, '61375', 218, 18, 121797, 41.0611, 0.716651389490644, -89.2623, -1.55792103290293),
(27134, '61376', 218, 18, 12616, 41.534, 0.724905051523325, -89.5992, -1.5638010471529),
(27135, '61377', 218, 18, 25890, 41.0511, 0.716476856565444, -89.0554, -1.55430994668056),
(27136, '61378', 218, 18, 121912, 41.7188, 0.72813041998101, -89.1622, -1.55617395832169),
(27137, '61379', 218, 18, 122072, 41.3631, 0.721922283831667, -89.5825, -1.56350957716782),
(27138, '61401', 218, 18, 32506, 40.9519, 0.714745489947466, -90.3664, -1.5771912131742),
(27139, '61402', 218, 18, 32506, 40.9484, 0.714684403423646, -90.3713, -1.57727673430755),
(27140, '61410', 218, 18, 44263, 40.804, 0.712164147983766, -90.4017, -1.57780731440016),
(27141, '61411', 218, 18, 34502, 40.2924, 0.703235043530563, -90.425, -1.57821397611587),
(27142, '61412', 218, 18, 402, 41.0661, 0.716738655953243, -90.5548, -1.58047941348496),
(27143, '61413', 218, 18, 7072, 41.192, 0.718936025481504, -90.3766, -1.57736923675791),
(27144, '61414', 218, 18, 34544, 41.1141, 0.717576413994201, -90.1636, -1.57365168545116),
(27145, '61415', 218, 18, 7208, 40.6619, 0.709684035116682, -90.4341, -1.5783728010778),
(27146, '61416', 218, 18, 118718, 40.4968, 0.70680249652164, -90.5663, -1.58068012634894),
(27147, '61417', 218, 18, 400, 40.762, 0.711431109697929, -90.5024, -1.57956486095692),
(27148, '61418', 218, 18, 118805, 40.8556, 0.713064737877795, -90.8587, -1.58578346908177),
(27149, '61419', 218, 18, 118816, 41.2001, 0.719077397150916, -90.1168, -1.57283487136123),
(27150, '61420', 218, 18, 118831, 40.5584, 0.707877619340868, -90.8294, -1.58527208761094),
(27151, '61421', 218, 18, 1076, 41.1762, 0.718660263459689, -89.6562, -1.56479588482654),
(27152, '61422', 218, 18, 15386, 40.5507, 0.707743228988465, -90.5096, -1.57969052466306),
(27153, '61423', 218, 18, 806, 40.883, 0.713542958092842, -90.4987, -1.57950028377459),
(27154, '61424', 218, 18, 119015, 41.0783, 0.716951586121987, -89.6325, -1.56438224179382),
(27155, '61425', 218, 18, 119037, 40.7626, 0.711441581673441, -91.0607, -1.5893090341708),
(27156, '61426', 218, 18, 29414, 41.1176, 0.71763750051802, -89.7057, -1.56565982280628),
(27157, '61427', 218, 18, 1912, 40.4917, 0.706713484729788, -90.1937, -1.57417702955601),
(27158, '61428', 218, 18, 119299, 40.9626, 0.714932240177429, -90.1379, -1.5732031358334),
(27159, '61430', 218, 18, 119445, 40.9454, 0.714632043546086, -90.3116, -1.57623477274411),
(27160, '61431', 218, 18, 2272, 40.6046, 0.708683961455289, -90.2818, -1.57571466462702),
(27161, '61432', 218, 18, 500, 40.6324, 0.709169162987344, -90.1664, -1.57370055467022),
(27162, '61433', 218, 18, 119616, 40.5798, 0.708251119800795, -90.155, -1.57350158713549),
(27163, '61434', 218, 18, 32510, 41.1665, 0.718490966522246, -90.0421, -1.57153111040999),
(27164, '61435', 218, 18, 119768, 40.9994, 0.715574521342163, -90.6146, -1.58152312037765),
(27165, '61436', 218, 18, 119783, 40.879, 0.713473144922762, -90.1575, -1.57354522036679),
(27166, '61437', 218, 18, 2726, 40.8482, 0.712935583513148, -90.9811, -1.58791975208621),
(27167, '61438', 218, 18, 2769, 40.5552, 0.707821768804804, -90.6705, -1.58249875942952),
(27168, '61439', 218, 18, 23, 41.0246, 0.716014344313666, -90.3561, -1.57701144426125),
(27169, '61440', 218, 18, 3343, 40.327, 0.703838927451753, -90.607, -1.5813904753545),
(27170, '61441', 218, 18, 120126, 40.3647, 0.704496916579755, -90.2765, -1.57562216217666),
(27171, '61442', 218, 18, 22329, 41.0996, 0.717323341252662, -90.9355, -1.5871238819473),
(27172, '61443', 218, 18, 22359, 41.2407, 0.719786000827225, -89.9297, -1.56956936033074),
(27173, '61447', 218, 18, 14059, 40.8683, 0.713286394692799, -90.752, -1.58392120276989),
(27174, '61448', 218, 18, 3570, 40.9059, 0.713942638491548, -90.2819, -1.57571640995627),
(27175, '61449', 218, 18, 36766, 41.1094, 0.717494383519357, -89.9732, -1.57032857855536),
(27176, '61450', 218, 18, 32952, 40.5831, 0.708308715666111, -90.9701, -1.58772776586849),
(27177, '61451', 218, 18, 36808, 40.9435, 0.714598882290298, -89.9626, -1.57014357365465),
(27178, '61452', 218, 18, 3815, 40.2407, 0.702332708307282, -90.622, -1.5816522747423),
(27179, '61453', 218, 18, 30356, 41.0104, 0.715766507559882, -90.7475, -1.58384266295355),
(27180, '61454', 218, 18, 3851, 40.6787, 0.709977250431017, -91.0109, -1.58843986020331),
(27181, '61455', 218, 18, 56039, 40.4592, 0.70614625272289, -90.6756, -1.58258777122137),
(27182, '61458', 218, 18, 120506, 40.7985, 0.712068154874906, -90.1642, -1.57366215742667),
(27183, '61459', 218, 18, 3993, 40.498, 0.706823440472664, -90.3936, -1.57766594273075),
(27184, '61460', 218, 18, 4146, 40.7694, 0.711560264062576, -90.8503, -1.5856368614246),
(27185, '61462', 218, 18, 4270, 40.9106, 0.714024668966392, -90.6452, -1.58205719112876),
(27186, '61465', 218, 18, 49791, 41.2021, 0.719112303735956, -90.443, -1.57852813538123),
(27187, '61466', 218, 18, 67259, 41.1072, 0.717455986275813, -90.4759, -1.57910234870514),
(27188, '61467', 218, 18, 10986, 41.0742, 0.716880027622655, -90.2254, -1.57473029892889),
(27189, '61468', 218, 18, 197190, 41.2542, 0.720021620276245, -90.3833, -1.57748617381779),
(27190, '61469', 218, 18, 120904, 40.9446, 0.71461808091207, -90.8842, -1.58622852804103),
(27191, '61470', 218, 18, 30889, 40.6069, 0.708724104028086, -90.5029, -1.57957358760318),
(27192, '61471', 218, 18, 121167, 40.6799, 0.709998194382041, -90.8443, -1.58553214166948),
(27193, '61472', 218, 18, 17799, 41.1095, 0.717496128848609, -90.3962, -1.5777113212913),
(27194, '61473', 218, 18, 11688, 40.7323, 0.710912746910086, -90.6656, -1.58241323829617),
(27195, '61474', 218, 18, 17892, 40.7329, 0.710923218885598, -90.359, -1.57706205880956),
(27196, '61475', 218, 18, 121398, 40.5883, 0.708399472787214, -90.7317, -1.58356690093174),
(27197, '61476', 218, 18, 11845, 41.1021, 0.717366974483961, -90.7996, -1.58475197949384),
(27198, '61477', 218, 18, 5916, 40.4945, 0.706762353948844, -90.2907, -1.57586999893044),
(27199, '61478', 218, 18, 121482, 40.7207, 0.710710288716855, -90.7305, -1.58354595698072),
(27200, '61479', 218, 18, 77301, 41.0176, 0.715892171266026, -89.6965, -1.56549925251509),
(27201, '61480', 218, 18, 121602, 40.7443, 0.711122186420326, -90.9079, -1.58664217107375),
(27202, '61482', 218, 18, 121655, 40.4069, 0.705233445524097, -90.3918, -1.57763452680421),
(27203, '61483', 218, 18, 34148, 41.0946, 0.717236074790062, -89.8642, -1.56842616967069),
(27204, '61484', 218, 18, 121805, 40.2955, 0.703289148737375, -90.4272, -1.57825237335942),
(27205, '61485', 218, 18, 6554, 41.0331, 0.716162697300085, -90.0971, -1.57249104149858),
(27206, '61486', 218, 18, 12571, 41.2049, 0.719161172955012, -90.5847, -1.58100126693131),
(27207, '61488', 218, 18, 121872, 41.026, 0.716038778923194, -90.2753, -1.57560121822564),
(27208, '61489', 218, 18, 121993, 40.8877, 0.713624988567686, -89.9752, -1.5703634851404),
(27209, '61490', 218, 18, 122045, 41.1792, 0.718712623337249, -90.3147, -1.57628887795092),
(27210, '61491', 218, 18, 14923, 41.0701, 0.716808469123323, -89.7891, -1.56711542740244),
(27211, '61501', 218, 18, 18949, 40.2273, 0.702098834187515, -90.3532, -1.57696082971294),
(27212, '61516', 218, 18, 642, 40.8488, 0.71294605548866, -89.1208, -1.55545139201136),
(27213, '61517', 218, 18, 45096, 40.8216, 0.712471325932117, -89.8491, -1.56816262495364),
(27214, '61519', 218, 18, 652, 40.4815, 0.706535461146084, -90.0733, -1.57207565313661),
(27215, '61520', 218, 18, 19763, 40.5587, 0.707882855328624, -90.0297, -1.57131468958274),
(27216, '61523', 218, 18, 54027, 40.9056, 0.713937402503792, -89.5134, -1.56230355465469),
(27217, '61524', 218, 18, 119420, 40.4855, 0.706605274316164, -90.0188, -1.57112444869427),
(27218, '61525', 218, 18, 8626, 40.8427, 0.712839590404288, -89.6447, -1.56459517196256),
(27219, '61526', 218, 18, 119468, 40.9176, 0.714146842014032, -89.6164, -1.56410124378425),
(27220, '61528', 218, 18, 8695, 40.7779, 0.711708617048996, -89.7356, -1.56618167625262),
(27221, '61529', 218, 18, 8746, 40.778, 0.711710362378248, -89.9494, -1.56991319019339),
(27222, '61530', 218, 18, 2334, 40.717, 0.710645711534531, -89.2745, -1.55813396307168),
(27223, '61531', 218, 18, 8849, 40.6987, 0.710326316281416, -90.0037, -1.57086090397722),
(27224, '61532', 218, 18, 16058, 40.2262, 0.702079635565743, -90.0092, -1.57095689708608),
(27225, '61533', 218, 18, 119788, 40.5892, 0.708415180750482, -89.8165, -1.56759364761749),
(27226, '61534', 218, 18, 13848, 40.4466, 0.705926341237138, -89.6514, -1.56471210902244),
(27227, '61535', 218, 18, 16295, 40.5922, 0.708467540628042, -89.5348, -1.56267705511462),
(27228, '61536', 218, 18, 119917, 40.689, 0.710157019343973, -89.7928, -1.56718000458476),
(27229, '61537', 218, 18, 9426, 41.1116, 0.717532780762901, -89.3626, -1.55967159814268),
(27230, '61539', 218, 18, 120222, 40.5575, 0.7078619113776, -89.7699, -1.56678032418606),
(27231, '61540', 218, 18, 3591, 41.0233, 0.71599165503339, -89.4065, -1.56043779768431),
(27232, '61541', 218, 18, 120258, 40.9827, 0.71528305135708, -89.2355, -1.5574532846634),
(27233, '61542', 218, 18, 36868, 40.3905, 0.70494721152677, -90.1624, -1.57363074150014),
(27234, '61543', 218, 18, 3824, 40.4237, 0.705526660838432, -90.0327, -1.5713670494603),
(27235, '61544', 218, 18, 120416, 40.7101, 0.710525283816144, -90.2669, -1.57545461056847),
(27236, '61545', 218, 18, 0, 40.8719, 0.71334922654587, -89.3111, -1.55877275357791),
(27237, '61546', 218, 18, 120489, 40.4222, 0.705500480899652, -89.7821, -1.5669932543548),
(27238, '61547', 218, 18, 30422, 40.6119, 0.708811370490685, -89.7434, -1.56631781193428),
(27239, '61548', 218, 18, 30492, 40.7838, 0.711811591474863, -89.4109, -1.5605145921714),
(27240, '61550', 218, 18, 10614, 40.6145, 0.708856749051237, -89.4625, -1.56141518206543),
(27241, '61552', 218, 18, 10619, 40.8154, 0.712363115518494, -89.5679, -1.56325475909703),
(27242, '61553', 218, 18, 23401, 40.626, 0.709057461915216, -90.032, -1.57135483215553),
(27243, '61554', 218, 18, 769, 40.5716, 0.708108002802131, -89.6201, -1.56416582096657),
(27244, '61555', 218, 18, 769, 40.5677, 0.708039934961304, -89.6452, -1.56460389860882),
(27245, '61558', 218, 18, 769, 40.5679, 0.708043425619808, -89.6408, -1.56452710412173),
(27246, '61559', 218, 18, 67980, 40.9151, 0.714103208782732, -89.7801, -1.56695834776976),
(27247, '61560', 218, 18, 5256, 41.2042, 0.719148955650248, -89.4402, -1.56102597364223),
(27248, '61561', 218, 18, 5436, 40.7973, 0.712047210923883, -89.2017, -1.55686336337623),
(27249, '61562', 218, 18, 490, 40.8822, 0.713528995458826, -89.5005, -1.56207840718119),
(27250, '61563', 218, 18, 121342, 40.4947, 0.706765844607348, -90.0485, -1.57164281148211),
(27251, '61564', 218, 18, 121526, 40.494, 0.706753627302584, -89.6563, -1.56479763015579),
(27252, '61565', 218, 18, 121538, 40.9986, 0.715560558708147, -89.4528, -1.56124588512798),
(27253, '61567', 218, 18, 34152, 40.3724, 0.704631306932159, -89.9384, -1.56972120397567),
(27254, '61568', 218, 18, 25561, 40.5263, 0.707317368650978, -89.488, -1.56186024102469),
(27255, '61569', 218, 18, 121739, 40.6777, 0.709959797138497, -89.9021, -1.56908764945719),
(27256, '61570', 218, 18, 12668, 40.9199, 0.714186984586828, -89.292, -1.55843939569078),
(27257, '61571', 218, 18, 12671, 40.7006, 0.710359477537204, -89.4478, -1.56115861866538),
(27258, '61572', 218, 18, 122079, 40.7845, 0.711823808779627, -90.0437, -1.57155903567802),
(27259, '61601', 218, 18, 30800, 40.6929, 0.710225087184801, -89.5896, -1.56363349554471),
(27260, '61602', 218, 18, 30800, 40.682, 0.710034846296333, -89.603, -1.56386736966448),
(27261, '61603', 218, 18, 30800, 40.713, 0.710575898364451, -89.5773, -1.56341882004672),
(27262, '61604', 218, 18, 30800, 40.7087, 0.710500849206616, -89.6452, -1.56460389860882),
(27263, '61605', 218, 18, 30800, 40.6793, 0.709987722406529, -89.6243, -1.56423912479515),
(27264, '61606', 218, 18, 30800, 40.7004, 0.7103559868787, -89.6088, -1.56396859876109),
(27265, '61607', 218, 18, 30800, 40.6464, 0.709413509082623, -89.6738, -1.56510306277489),
(27266, '61610', 218, 18, 54259, 40.6604, 0.709657855177902, -89.5779, -1.56342929202223),
(27267, '61611', 218, 18, 119456, 40.6616, 0.709678799128926, -89.5541, -1.56301390366025),
(27268, '61612', 218, 18, 30800, 40.6854, 0.710094187490901, -89.5958, -1.56374170595834),
(27269, '61613', 218, 18, 30800, 40.7422, 0.711085534506034, -89.6274, -1.56429323000197),
(27270, '61614', 218, 18, 30800, 40.7539, 0.711289738028517, -89.6012, -1.56383595373794),
(27271, '61615', 218, 18, 30800, 40.7869, 0.711865696681675, -89.6292, -1.5643246459285),
(27272, '61616', 218, 18, 121006, 40.7547, 0.711303700662533, -89.6016, -1.56384293505495),
(27273, '61625', 218, 18, 30800, 40.8466, 0.712907658245116, -89.583, -1.56351830381408),
(27274, '61628', 218, 18, 30800, 40.6904, 0.710181453953501, -89.592, -1.56367538344676),
(27275, '61629', 218, 18, 30800, 40.6914, 0.710198907246021, -89.5896, -1.56363349554471),
(27276, '61630', 218, 18, 30800, 40.6813, 0.710022628991569, -89.604, -1.563884822957),
(27277, '61632', 218, 18, 30800, 40.7627, 0.711443327002693, -89.5676, -1.56324952310927),
(27278, '61633', 218, 18, 30800, 40.7073, 0.710476414597088, -89.6608, -1.56487616997213),
(27279, '61634', 218, 18, 30800, 40.6895, 0.710165745990233, -89.5924, -1.56368236476377),
(27280, '61635', 218, 18, 30800, 40.71, 0.710523538486892, -89.5248, -1.56250252218942),
(27281, '61636', 218, 18, 30800, 40.7, 0.710349005561692, -89.5956, -1.56373821529983),
(27282, '61637', 218, 18, 30800, 40.7015, 0.710375185500472, -89.591, -1.56365793015424),
(27283, '61638', 218, 18, 30800, 40.8028, 0.712143204032742, -89.6262, -1.56427228605094),
(27284, '61639', 218, 18, 30800, 40.7089, 0.71050433986512, -89.5645, -1.56319541790246),
(27285, '61640', 218, 18, 30800, 40.7855, 0.711841262072147, -89.6165, -1.5641029891135),
(27286, '61641', 218, 18, 30800, 40.655, 0.709563607398295, -89.6832, -1.56526712372458),
(27287, '61643', 218, 18, 30800, 40.7254, 0.710792319191699, -89.5569, -1.56306277287931),
(27288, '61644', 218, 18, 30800, 40.7627, 0.711443327002693, -89.568, -1.56325650442628),
(27289, '61650', 218, 18, 30800, 40.6407, 0.70931402531526, -89.4964, -1.56200684868185),
(27290, '61651', 218, 18, 30800, 40.681, 0.710017393003813, -89.6039, -1.56388307762775),
(27291, '61652', 218, 18, 30800, 40.6804, 0.710006921028301, -89.6041, -1.56388656828625),
(27292, '61653', 218, 18, 30800, 40.6809, 0.710015647674561, -89.6038, -1.5638813322985),
(27293, '61654', 218, 18, 30800, 40.6811, 0.710019138333065, -89.6038, -1.5638813322985),
(27294, '61655', 218, 18, 30800, 40.6856, 0.710097678149405, -89.5954, -1.56373472464133),
(27295, '61656', 218, 18, 30800, 40.6815, 0.710026119650073, -89.604, -1.563884822957),
(27296, '61701', 218, 18, 29235, 40.4776, 0.706467393305257, -88.9812, -1.55301491237558),
(27297, '61702', 218, 18, 29235, 40.6061, 0.708710141394069, -88.9855, -1.55308996153341),
(27298, '61704', 218, 18, 29235, 40.4798, 0.706505790548801, -88.9515, -1.55249654958774),
(27299, '61709', 218, 18, 29235, 40.4591, 0.706144507393638, -88.9585, -1.55261872263538),
(27300, '61710', 218, 18, 29235, 40.4789, 0.706490082585533, -88.9533, -1.55252796551427),
(27301, '61720', 218, 18, 39103, 40.5297, 0.707376709845546, -88.5172, -1.54491658464632),
(27302, '61721', 218, 18, 118648, 40.3386, 0.704041385644985, -89.3122, -1.55879195219968),
(27303, '61722', 218, 18, 118658, 40.448, 0.705950775846666, -88.6323, -1.54692545861537),
(27304, '61723', 218, 18, 7187, 40.262, 0.702704463437957, -89.2346, -1.55743757670013),
(27305, '61724', 218, 18, 53413, 40.3403, 0.704071056242269, -88.5177, -1.54492531129258),
(27306, '61725', 218, 18, 85553, 40.5816, 0.708282535727331, -89.1329, -1.55566257685085),
(27307, '61726', 218, 18, 526, 40.7217, 0.710727742009375, -88.7401, -1.54880692354902),
(27308, '61727', 218, 18, 1630, 40.1529, 0.700800309224031, -88.9593, -1.55263268526939),
(27309, '61728', 218, 18, 8175, 40.5663, 0.708015500351776, -88.6138, -1.54660257270375),
(27310, '61729', 218, 18, 119214, 40.6169, 0.708898636953285, -89.2067, -1.55695062983883),
(27311, '61730', 218, 18, 20225, 40.5305, 0.707390672479562, -88.7481, -1.54894654988918),
(27312, '61731', 218, 18, 119277, 40.5954, 0.708523391164106, -88.5165, -1.54490436734156),
(27313, '61732', 218, 18, 119312, 40.529, 0.707364492540782, -89.1768, -1.55642877639248),
(27314, '61733', 218, 18, 8452, 40.6292, 0.70911331245128, -89.3312, -1.55912356475756),
(27315, '61734', 218, 18, 32219, 40.3717, 0.704619089627395, -89.5452, -1.56285856935683),
(27316, '61735', 218, 18, 20499, 40.1863, 0.701383249194197, -88.7901, -1.54967958817502),
(27317, '61736', 218, 18, 2097, 40.3977, 0.705072875232913, -88.8718, -1.5511055221739),
(27318, '61737', 218, 18, 579, 40.4488, 0.705964738480682, -88.7193, -1.54844389506461),
(27319, '61738', 218, 18, 8705, 40.7389, 0.711027938640718, -89.0151, -1.553606578992),
(27320, '61739', 218, 18, 119582, 40.7463, 0.711157093005365, -88.5133, -1.5448485168055),
(27321, '61740', 218, 18, 35911, 40.8771, 0.713439983666974, -88.8595, -1.5508908466759),
(27322, '61741', 218, 18, 119660, 40.7517, 0.711251340784973, -88.4122, -1.54308398893173),
(27323, '61742', 218, 18, 87327, 40.63, 0.709127275085296, -89.2767, -1.55817236031522),
(27324, '61743', 218, 18, 2833, 40.9095, 0.71400547034462, -88.7588, -1.54913330011914),
(27325, '61744', 218, 18, 32637, 40.7447, 0.711129167737334, -88.8802, -1.55125212983106),
(27326, '61745', 218, 18, 119999, 40.3193, 0.70370453709935, -88.971, -1.55283688879188),
(27327, '61747', 218, 18, 41406, 40.423, 0.705514443533668, -89.4152, -1.56058964132923),
(27328, '61748', 218, 18, 16505, 40.6035, 0.708664762833518, -88.9901, -1.55317024667901),
(27329, '61749', 218, 18, 95289, 40.0974, 0.699831651489174, -89.0828, -1.5547881668956),
(27330, '61750', 218, 18, 3658, 40.0818, 0.699559380125863, -88.8464, -1.55066220854389),
(27331, '61751', 218, 18, 14097, 40.2201, 0.701973170481371, -89.2883, -1.55837481850845),
(27332, '61752', 218, 18, 33011, 40.3492, 0.704226390545696, -88.7653, -1.54924674652052),
(27333, '61753', 218, 18, 3748, 40.6201, 0.708954487489349, -88.8069, -1.54997280348935),
(27334, '61754', 218, 18, 73416, 40.3148, 0.70362599728301, -89.1715, -1.55633627394212),
(27335, '61755', 218, 18, 120464, 40.5411, 0.707575677380273, -89.3416, -1.55930507899977),
(27336, '61756', 218, 18, 120520, 40.0373, 0.698782708608726, -88.9548, -1.55255414545305),
(27337, '61758', 218, 18, 56217, 40.5155, 0.707128873091763, -88.8257, -1.55030092538873),
(27338, '61759', 218, 18, 120649, 40.435, 0.705723883043907, -89.3126, -1.55879893351669),
(27339, '61760', 218, 18, 120650, 40.902, 0.713874570650721, -89.0347, -1.5539486635254),
(27340, '61761', 218, 18, 4592, 40.5109, 0.707048587946171, -88.9877, -1.55312835877696),
(27341, '61764', 218, 18, 28298, 40.8783, 0.713460927617998, -88.6322, -1.54692371328612),
(27342, '61769', 218, 18, 121375, 40.8938, 0.713731453652057, -88.4048, -1.54295483456708),
(27343, '61770', 218, 18, 18005, 40.4284, 0.705608691313276, -88.5254, -1.54505970164499),
(27344, '61771', 218, 18, 121410, 40.7421, 0.711083789176782, -89.1349, -1.55569748343589),
(27345, '61772', 218, 18, 5825, 40.4212, 0.705483027607132, -89.0945, -1.55499237041809),
(27346, '61773', 218, 18, 24860, 40.5877, 0.708389000811702, -88.3803, -1.54252722890034),
(27347, '61774', 218, 18, 12107, 40.4349, 0.705722137714655, -89.2213, -1.55720544790962),
(27348, '61775', 218, 18, 51765, 40.652, 0.709511247520735, -88.3983, -1.5428413881657),
(27349, '61776', 218, 18, 34149, 40.5636, 0.707968376461972, -88.8979, -1.55156105310867),
(27350, '61777', 218, 18, 121851, 40.2219, 0.702004586407907, -88.9623, -1.55268504514695),
(27351, '61778', 218, 18, 25859, 40.2402, 0.702323981661022, -89.1252, -1.55552818649845),
(27352, '61790', 218, 18, 4592, 40.5178, 0.707169015664558, -88.9995, -1.55333430762869),
(27353, '61791', 218, 18, 29235, 40.4767, 0.706451685341989, -88.953, -1.55252272952652),
(27354, '61799', 218, 18, 29235, 40.4311, 0.705655815203079, -88.9852, -1.55308472554566),
(27355, '61801', 218, 18, 12500, 40.1106, 0.700062034950438, -88.1971, -1.53932978571069),
(27356, '61802', 218, 18, 12500, 40.128, 0.700365722240285, -88.1749, -1.53894232261675),
(27357, '61803', 218, 18, 12500, 40.1067, 0.69999396710961, -88.214, -1.53962474635428),
(27358, '61810', 218, 18, 26353, 39.9118, 0.696592320397473, -87.9357, -1.53476749504598),
(27359, '61811', 218, 18, 18831, 40.3107, 0.703554438783678, -87.6062, -1.52901663516066),
(27360, '61812', 218, 18, 7163, 40.2184, 0.701943499884087, -87.8962, -1.53407808999144),
(27361, '61813', 218, 18, 26493, 39.9209, 0.696751145359404, -88.5787, -1.5459899621363),
(27362, '61814', 218, 18, 7498, 40.2591, 0.702653848889649, -87.6116, -1.52911088294026),
(27363, '61815', 218, 18, 34907, 40.1125, 0.700095196206225, -88.3718, -1.54237887591392),
(27364, '61816', 218, 18, 26611, 39.9087, 0.696538215190661, -87.9965, -1.53582865523119),
(27365, '61817', 218, 18, 19852, 40.0675, 0.699309798042828, -87.7104, -1.53083526824123),
(27366, '61818', 218, 18, 26750, 39.8892, 0.696197875986522, -88.7333, -1.54868824115988),
(27367, '61820', 218, 18, 119079, 40.1125, 0.700095196206225, -88.2467, -1.54019546901968),
(27368, '61821', 218, 18, 119079, 40.1084, 0.700023637706894, -88.2814, -1.54080109827012),
(27369, '61822', 218, 18, 119079, 40.1308, 0.70041459145934, -88.3126, -1.54134564099674),
(27370, '61824', 218, 18, 119079, 40.1221, 0.700262747814417, -88.2438, -1.54014485447137),
(27371, '61825', 218, 18, 119079, 40.1098, 0.700048072316422, -88.2433, -1.54013612782511),
(27372, '61826', 218, 18, 119079, 40.1373, 0.70052803786072, -88.2771, -1.54072604911229),
(27373, '61830', 218, 18, 8084, 39.9855, 0.697878628056193, -88.6788, -1.54773703671755),
(27374, '61831', 218, 18, 119197, 40.2173, 0.701924301262316, -87.8071, -1.53252300162791),
(27375, '61832', 218, 18, 1964, 40.1338, 0.7004669513369, -87.6285, -1.52940584358385),
(27376, '61833', 218, 18, 12322, 40.0967, 0.69981943418441, -87.6447, -1.52968858692267),
(27377, '61834', 218, 18, 1964, 40.1296, 0.700393647508317, -87.6284, -1.5294040982546),
(27378, '61839', 218, 18, 15748, 40.1214, 0.700250530509653, -88.6472, -1.54718551267392),
(27379, '61840', 218, 18, 2037, 40.3187, 0.703694065123838, -88.2842, -1.54084996748918),
(27380, '61841', 218, 18, 2379, 40.0453, 0.698922334948885, -87.8306, -1.53293315400213),
(27381, '61842', 218, 18, 119599, 40.245, 0.702407757465118, -88.6431, -1.54711395417459),
(27382, '61843', 218, 18, 8891, 40.3163, 0.70365217722179, -88.3476, -1.54195650623494),
(27383, '61844', 218, 18, 119621, 40.0699, 0.699351685944876, -87.7776, -1.53200812949857),
(27384, '61845', 218, 18, 119646, 40.3599, 0.704413140775659, -88.4277, -1.54335451496579),
(27385, '61846', 218, 18, 2693, 39.9807, 0.697794852252097, -87.6354, -1.52952627130224),
(27386, '61847', 218, 18, 9105, 40.3051, 0.703456700345567, -88.0221, -1.5362754595197),
(27387, '61848', 218, 18, 87694, 40.3052, 0.703458445674819, -87.7001, -1.53065549932828),
(27388, '61849', 218, 18, 22029, 40.035, 0.69874256603593, -87.9592, -1.5351776474202),
(27389, '61850', 218, 18, 16542, 39.9262, 0.69684364780976, -87.7398, -1.53134839504132),
(27390, '61851', 218, 18, 27531, 39.9439, 0.697152571087363, -88.456, -1.5438484431441);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(27391, '61852', 218, 18, 3859, 39.8863, 0.696147261438214, -88.0634, -1.53699628050077),
(27392, '61853', 218, 18, 95962, 40.199, 0.7016049060092, -88.3932, -1.54275237637385),
(27393, '61854', 218, 18, 3975, 40.212, 0.70183179881196, -88.5075, -1.54474728770888),
(27394, '61855', 218, 18, 27914, 39.8905, 0.696220565266798, -88.641, -1.54707730226029),
(27395, '61856', 218, 18, 588, 40.0229, 0.698531381196439, -88.5744, -1.54591491297847),
(27396, '61857', 218, 18, 33371, 40.1157, 0.700151046742289, -87.8456, -1.53319495338993),
(27397, '61858', 218, 18, 4723, 40.1104, 0.700058544291933, -87.7756, -1.53197322291353),
(27398, '61859', 218, 18, 10927, 40.1135, 0.700112649498745, -87.9574, -1.53514623149366),
(27399, '61862', 218, 18, 23832, 40.2721, 0.702880741692408, -88.0414, -1.53661230806534),
(27400, '61863', 218, 18, 28223, 39.9147, 0.696642934945781, -88.2743, -1.54067717989323),
(27401, '61864', 218, 18, 73882, 40.0038, 0.698198023309308, -88.1568, -1.53862641802214),
(27402, '61865', 218, 18, 50553, 40.3066, 0.703482880284346, -87.8009, -1.53241479121429),
(27403, '61866', 218, 18, 33723, 40.3096, 0.703535240161906, -88.1513, -1.53853042491328),
(27404, '61870', 218, 18, 28413, 39.8959, 0.696314813046406, -87.6508, -1.52979505200705),
(27405, '61871', 218, 18, 5571, 40.1922, 0.701486223620065, -87.9687, -1.53534345369914),
(27406, '61872', 218, 18, 28491, 39.966, 0.697538288852054, -88.3469, -1.54194428893018),
(27407, '61873', 218, 18, 488, 40.1124, 0.700093450876974, -88.0431, -1.53664197866262),
(27408, '61874', 218, 18, 11814, 40.0657, 0.699278382116292, -88.2515, -1.54027924482378),
(27409, '61875', 218, 18, 5745, 40.1602, 0.700927718259427, -88.4357, -1.54349414130595),
(27410, '61876', 218, 18, 18078, 39.9107, 0.696573121775701, -87.8233, -1.53280574496674),
(27411, '61877', 218, 18, 5844, 40.0241, 0.698552325147462, -88.0732, -1.53716732276747),
(27412, '61878', 218, 18, 25457, 40.2428, 0.702369360221574, -88.1841, -1.53910289290793),
(27413, '61880', 218, 18, 28794, 39.9879, 0.697920515958241, -88.2618, -1.54045901373673),
(27414, '61882', 218, 18, 635, 40.1233, 0.700283691765441, -88.7501, -1.54898145647422),
(27415, '61883', 218, 18, 12776, 40.047, 0.698952005546169, -87.6382, -1.52957514052129),
(27416, '61884', 218, 18, 121967, 40.1029, 0.699927644598034, -88.5081, -1.54475775968439),
(27417, '61910', 218, 18, 18900, 39.6836, 0.692609479044422, -88.3061, -1.54123219459536),
(27418, '61911', 218, 18, 7168, 39.7142, 0.693143549795532, -88.4665, -1.54403170271556),
(27419, '61912', 218, 18, 15038, 39.5299, 0.689926907984106, -88.0209, -1.53625451556868),
(27420, '61913', 218, 18, 7189, 39.8025, 0.694684675525043, -88.4654, -1.54401250409379),
(27421, '61914', 218, 18, 7428, 39.6467, 0.691965452550436, -88.7393, -1.548792960915),
(27422, '61917', 218, 18, 26612, 39.6931, 0.692775285323361, -87.6725, -1.53017378845473),
(27423, '61919', 218, 18, 26683, 39.8048, 0.694724818097839, -88.1265, -1.53809758325878),
(27424, '61920', 218, 18, 8039, 39.4866, 0.689171180417993, -88.1763, -1.53896675722628),
(27425, '61924', 218, 18, 26784, 39.8031, 0.694695147500555, -87.6755, -1.53022614833229),
(27426, '61925', 218, 18, 26910, 39.7128, 0.693119115186004, -88.8062, -1.54996058618459),
(27427, '61928', 218, 18, 112303, 39.4873, 0.689183397722757, -88.5408, -1.5453284823498),
(27428, '61929', 218, 18, 421, 39.8002, 0.694644532952247, -88.5678, -1.54579972124783),
(27429, '61930', 218, 18, 27446, 39.6852, 0.692637404312454, -88.133, -1.53821102966016),
(27430, '61931', 218, 18, 27486, 39.6038, 0.69121670630133, -88.3184, -1.54144687009336),
(27431, '61932', 218, 18, 109, 39.7961, 0.694572974452915, -87.8687, -1.53359812444714),
(27432, '61933', 218, 18, 3481, 39.5538, 0.690344041675333, -87.9383, -1.53481287360653),
(27433, '61936', 218, 18, 3586, 39.8, 0.694641042293743, -88.7132, -1.54833742998023),
(27434, '61937', 218, 18, 27759, 39.7126, 0.6931156245275, -88.6377, -1.54701970639498),
(27435, '61938', 218, 18, 27833, 39.4822, 0.689094385930905, -88.3728, -1.54239632920644),
(27436, '61940', 218, 18, 23055, 39.8019, 0.694674203549531, -87.806, -1.53250380300614),
(27437, '61941', 218, 18, 17219, 39.8006, 0.694651514269255, -88.0785, -1.53725982521783),
(27438, '61942', 218, 18, 28051, 39.7984, 0.694613117025711, -87.9866, -1.53565586763524),
(27439, '61943', 218, 18, 4710, 39.6564, 0.692134749487879, -88.0262, -1.53634701801903),
(27440, '61944', 218, 18, 11069, 39.6103, 0.69133015270271, -87.6964, -1.53059092214596),
(27441, '61949', 218, 18, 28386, 39.6445, 0.691927055306892, -87.8618, -1.53347769672875),
(27442, '61951', 218, 18, 28723, 39.5996, 0.691143402472747, -88.61, -1.54653625019218),
(27443, '61953', 218, 18, 28817, 39.7993, 0.694628824988979, -88.2825, -1.54082029689189),
(27444, '61955', 218, 18, 28859, 39.5811, 0.690820516561128, -87.5891, -1.52871818385857),
(27445, '61956', 218, 18, 28869, 39.8636, 0.695751071698012, -88.1591, -1.53866656059493),
(27446, '61957', 218, 18, 18652, 39.4388, 0.68833691303554, -88.6006, -1.54637218924249),
(27447, '62001', 218, 18, 26347, 38.8794, 0.678573541199883, -89.7448, -1.56634224654381),
(27448, '62002', 218, 18, 14977, 38.9052, 0.679023836146898, -90.1648, -1.57367262940218),
(27449, '62006', 218, 18, 26457, 39.0853, 0.68216717412974, -90.6694, -1.58247956080775),
(27450, '62009', 218, 18, 26496, 39.0934, 0.682308545799151, -89.8021, -1.5673423202052),
(27451, '62010', 218, 18, 26511, 38.9105, 0.679116338597254, -90.0469, -1.57161488621408),
(27452, '62011', 218, 18, 777, 39.1516, 0.683324327423812, -89.1947, -1.55674119032859),
(27453, '62012', 218, 18, 212, 39.0384, 0.681348614710554, -90.1376, -1.57319789984564),
(27454, '62013', 218, 18, 26633, 38.9469, 0.67975163844498, -90.584, -1.58098904962654),
(27455, '62014', 218, 18, 7775, 39.0421, 0.681413191892878, -89.95, -1.5699236621689),
(27456, '62015', 218, 18, 1257, 39.2207, 0.68453034993694, -89.5311, -1.5626124779323),
(27457, '62016', 218, 18, 1380, 39.2989, 0.685895197412, -90.4102, -1.57795566738658),
(27458, '62017', 218, 18, 26824, 39.0901, 0.682250949933835, -89.392, -1.56018472494277),
(27459, '62018', 218, 18, 26861, 38.9103, 0.67911284793875, -90.0821, -1.57222924211078),
(27460, '62019', 218, 18, 26968, 39.0358, 0.681303236150003, -89.4762, -1.56165429217295),
(27461, '62021', 218, 18, 20636, 38.9716, 0.680182734770222, -89.9861, -1.57055372602887),
(27462, '62022', 218, 18, 26981, 38.9647, 0.680062307051835, -90.2993, -1.57602009724612),
(27463, '62023', 218, 18, 0, 38.3463, 0.669269190957502, -90.6684, -1.58246210751523),
(27464, '62024', 218, 18, 27021, 38.8803, 0.678589249163151, -90.083, -1.57224495007405),
(27465, '62025', 218, 18, 2239, 38.8097, 0.677357046711243, -89.9522, -1.56996205941244),
(27466, '62026', 218, 18, 2239, 38.8127, 0.677409406588803, -89.9542, -1.56999696599748),
(27467, '62027', 218, 18, 15910, 39.2872, 0.685690993889516, -90.553, -1.58044799755843),
(27468, '62028', 218, 18, 27089, 38.962, 0.680015183162031, -90.3469, -1.57685087397007),
(27469, '62030', 218, 18, 27162, 39.1288, 0.682926392354357, -90.1947, -1.57419448284853),
(27470, '62031', 218, 18, 27165, 39.1042, 0.682497041358367, -90.5542, -1.58046894150945),
(27471, '62032', 218, 18, 27166, 39.1006, 0.682434209505295, -89.3069, -1.55869944974932),
(27472, '62033', 218, 18, 27260, 39.1253, 0.682865305830538, -89.8167, -1.56759713827599),
(27473, '62034', 218, 18, 2728, 38.753, 0.676367445025363, -89.9795, -1.57043853429824),
(27474, '62035', 218, 18, 21458, 38.9442, 0.679704514555176, -90.2069, -1.57440741301727),
(27475, '62036', 218, 18, 27284, 38.8932, 0.678814396636659, -90.5709, -1.58076041149453),
(27476, '62037', 218, 18, 27298, 38.9701, 0.680156554831442, -90.4424, -1.57851766340572),
(27477, '62040', 218, 18, 27311, 38.7236, 0.675854318225276, -90.109, -1.57269873567957),
(27478, '62044', 218, 18, 2861, 39.342, 0.686647434319609, -90.2121, -1.57449817013838),
(27479, '62045', 218, 18, 2948, 39.2143, 0.684418648864812, -90.6902, -1.58284258929216),
(27480, '62046', 218, 18, 27367, 38.8891, 0.678742838137327, -89.8485, -1.56815215297813),
(27481, '62047', 218, 18, 9325, 39.1539, 0.683364469996608, -90.6218, -1.5816487840838),
(27482, '62048', 218, 18, 2998, 38.8327, 0.677758472439202, -90.093, -1.57241948299925),
(27483, '62049', 218, 18, 3145, 39.1545, 0.68337494197212, -89.4845, -1.56179915450087),
(27484, '62050', 218, 18, 3153, 39.4759, 0.68898443018803, -90.5238, -1.57993836141684),
(27485, '62051', 218, 18, 27519, 39.2038, 0.684235389293353, -89.4059, -1.5604273257088),
(27486, '62052', 218, 18, 27561, 39.1166, 0.682713462185614, -90.3233, -1.57643897626659),
(27487, '62053', 218, 18, 27588, 39.322, 0.68629836846921, -90.6479, -1.58210431501857),
(27488, '62054', 218, 18, 27590, 39.2175, 0.684474499400876, -90.3822, -1.57746697519602),
(27489, '62056', 218, 18, 27727, 39.1778, 0.683781603687834, -89.6514, -1.56471210902244),
(27490, '62058', 218, 18, 3825, 38.9675, 0.68011117627089, -89.761, -1.56662498988263),
(27491, '62059', 218, 18, 22755, 38.6574, 0.674698910260456, -90.165, -1.57367612006069),
(27492, '62060', 218, 18, 3938, 38.6844, 0.675170149158494, -90.1543, -1.57348936983072),
(27493, '62061', 218, 18, 27799, 38.0674, 0.664401467673689, -89.5525, -1.56298597839222),
(27494, '62062', 218, 18, 4028, 38.7249, 0.675877007505552, -89.9574, -1.57005281653355),
(27495, '62063', 218, 18, 30481, 39.205, 0.684256333244377, -90.1596, -1.57358187228108),
(27496, '62065', 218, 18, 27889, 39.2291, 0.684676957594108, -90.6305, -1.58180062772872),
(27497, '62067', 218, 18, 10602, 38.9268, 0.679400827265329, -90.0074, -1.57092548115954),
(27498, '62069', 218, 18, 590, 39.0718, 0.681931554680721, -89.7257, -1.56600888865668),
(27499, '62070', 218, 18, 27983, 39.2934, 0.68579920430314, -90.7228, -1.58341156662831),
(27500, '62071', 218, 18, 0, 38.6448, 0.674478998774705, -90.1596, -1.57358187228108),
(27501, '62074', 218, 18, 28024, 38.9583, 0.679950605979707, -89.7255, -1.56600539799817),
(27502, '62075', 218, 18, 4587, 39.2994, 0.68590392405826, -89.2878, -1.55836609186219),
(27503, '62076', 218, 18, 28109, 39.345, 0.686699794197169, -89.2186, -1.55715832401981),
(27504, '62077', 218, 18, 28181, 39.0286, 0.681177572443859, -89.5257, -1.56251823015269),
(27505, '62078', 218, 18, 428, 39.4803, 0.689061224675117, -90.4828, -1.57922277642353),
(27506, '62079', 218, 18, 28238, 39.1316, 0.682975261573413, -90.1217, -1.57292039249457),
(27507, '62080', 218, 18, 5291, 39.1439, 0.683189937071408, -89.1076, -1.5552210085501),
(27508, '62081', 218, 18, 24458, 39.2859, 0.68566830460924, -90.2718, -1.57554013170182),
(27509, '62082', 218, 18, 28452, 39.4825, 0.689099621918661, -90.3713, -1.57727673430755),
(27510, '62083', 218, 18, 24517, 39.3926, 0.687530570921118, -89.1953, -1.5567516623041),
(27511, '62084', 218, 18, 5568, 38.8478, 0.678022017156253, -90.079, -1.57217513690397),
(27512, '62085', 218, 18, 5676, 39.0767, 0.682017075814068, -89.8028, -1.56735453750996),
(27513, '62086', 218, 18, 28635, 38.9529, 0.679856358200099, -89.5603, -1.56312211407388),
(27514, '62087', 218, 18, 28653, 38.8283, 0.677681677952114, -90.0593, -1.57183130704133),
(27515, '62088', 218, 18, 25106, 39.0114, 0.680877375812516, -89.7869, -1.5670770301589),
(27516, '62089', 218, 18, 28762, 39.1314, 0.682971770914909, -89.4927, -1.56194227149953),
(27517, '62090', 218, 18, 12543, 38.6705, 0.674927548392467, -90.1688, -1.57374244257226),
(27518, '62091', 218, 18, 28897, 39.0427, 0.68142366386839, -89.6427, -1.56456026537752),
(27519, '62092', 218, 18, 367, 39.4388, 0.68833691303554, -90.4019, -1.57781080505866),
(27520, '62093', 218, 18, 6863, 39.0686, 0.681875704144657, -89.8553, -1.56827083536726),
(27521, '62094', 218, 18, 29010, 39.2564, 0.685153432479902, -89.349, -1.55943423336441),
(27522, '62095', 218, 18, 29016, 38.8641, 0.678306505824328, -90.0893, -1.57235490581693),
(27523, '62097', 218, 18, 12958, 38.9257, 0.679381628643557, -89.8846, -1.5687822168381),
(27524, '62098', 218, 18, 29035, 39.3755, 0.687232119619027, -90.2947, -1.57593981210052),
(27525, '62201', 218, 18, 27037, 38.631, 0.674238143337929, -90.1348, -1.57314903062659),
(27526, '62202', 218, 18, 27037, 38.6164, 0.673983325267138, -90.1597, -1.57358361761033),
(27527, '62203', 218, 18, 27037, 38.5988, 0.673676147318787, -90.0743, -1.57209310642913),
(27528, '62204', 218, 18, 27037, 38.6314, 0.674245124654937, -90.1023, -1.57258179861969),
(27529, '62205', 218, 18, 27037, 38.6158, 0.673972853291626, -90.126, -1.57299544165241),
(27530, '62206', 218, 18, 27037, 38.5632, 0.673054810105077, -90.1637, -1.57365343078041),
(27531, '62207', 218, 18, 27037, 38.5875, 0.673478925113312, -90.1304, -1.5730722361395),
(27532, '62208', 218, 18, 21014, 38.5967, 0.673639495404495, -90.012, -1.57100576630514),
(27533, '62214', 218, 18, 26329, 38.3664, 0.669620002137152, -89.6014, -1.56383944439645),
(27534, '62215', 218, 18, 26337, 38.5092, 0.672112332309, -89.6202, -1.56416756629582),
(27535, '62216', 218, 18, 26430, 38.6082, 0.673840208268475, -89.6071, -1.56393892816381),
(27536, '62217', 218, 18, 722, 38.1845, 0.666445248227775, -89.8447, -1.56808583046655),
(27537, '62218', 218, 18, 26456, 38.5378, 0.672611496475071, -89.4499, -1.56119527057968),
(27538, '62219', 218, 18, 26473, 38.6055, 0.673793084378671, -89.435, -1.56093521652113),
(27539, '62220', 218, 18, 263, 38.5142, 0.6721995987716, -89.9905, -1.57063052051596),
(27540, '62221', 218, 18, 263, 38.5306, 0.672485832768927, -89.9683, -1.57024305742201),
(27541, '62222', 218, 18, 263, 38.4695, 0.671419436595959, -89.9825, -1.5704908941758),
(27542, '62223', 218, 18, 263, 38.5485, 0.672798246705034, -90.0382, -1.57146304256916),
(27543, '62224', 218, 18, 27822, 38.4907, 0.671789446397381, -89.7933, -1.56718873123102),
(27544, '62225', 218, 18, 0, 38.5406, 0.672660365694127, -89.8526, -1.56822371147746),
(27545, '62226', 218, 18, 263, 38.5412, 0.672670837669639, -90.0009, -1.57081203475816),
(27546, '62230', 218, 18, 26598, 38.61, 0.673871624195011, -89.5278, -1.56255488206698),
(27547, '62231', 218, 18, 26707, 38.6116, 0.673899549463043, -89.3737, -1.55986532968966),
(27548, '62232', 218, 18, 19834, 38.6351, 0.674309701837261, -90.0144, -1.57104765420718),
(27549, '62233', 218, 18, 8056, 37.9152, 0.661745076552154, -89.816, -1.56758492097123),
(27550, '62234', 218, 18, 1706, 38.6851, 0.675182366463258, -89.9833, -1.57050485680981),
(27551, '62236', 218, 18, 1716, 38.4451, 0.670993576258472, -90.2054, -1.57438123307849),
(27552, '62237', 218, 18, 26866, 38.1704, 0.666199156803244, -89.5559, -1.56304531958679),
(27553, '62238', 218, 18, 15698, 37.9828, 0.662924919126502, -89.3635, -1.55968730610595),
(27554, '62239', 218, 18, 27009, 38.5244, 0.672377622355304, -90.1998, -1.57428349464038),
(27555, '62240', 218, 18, 27025, 38.5417, 0.672679564315898, -90.2169, -1.57458194594247),
(27556, '62241', 218, 18, 27082, 38.0032, 0.663280966293909, -89.8973, -1.5690038736531),
(27557, '62242', 218, 18, 2341, 38.0958, 0.664897141181256, -89.9052, -1.56914175466401),
(27558, '62243', 218, 18, 27213, 38.4247, 0.670637529091065, -89.9063, -1.56916095328578),
(27559, '62244', 218, 18, 27226, 38.1617, 0.66604731315832, -90.1994, -1.57427651332337),
(27560, '62245', 218, 18, 27253, 38.5537, 0.672889003826138, -89.5382, -1.56273639630919),
(27561, '62246', 218, 18, 2868, 38.8903, 0.678763782088351, -89.4068, -1.56044303367207),
(27562, '62247', 218, 18, 27356, 38.9433, 0.679688806591908, -89.1699, -1.55630834867409),
(27563, '62248', 218, 18, 27407, 38.3046, 0.66854138865942, -89.9936, -1.57068462572277),
(27564, '62249', 218, 18, 3108, 38.7395, 0.676131825576343, -89.6734, -1.56509608145788),
(27565, '62250', 218, 18, 27449, 38.5417, 0.672679564315898, -89.2631, -1.55793499553695),
(27566, '62252', 218, 18, 27480, 38.6043, 0.673772140427647, -89.2915, -1.55843066904452),
(27567, '62253', 218, 18, 27620, 38.7415, 0.676166732161383, -89.3131, -1.55880766016295),
(27568, '62254', 218, 18, 3708, 38.6056, 0.673794829707923, -89.8149, -1.56756572234946),
(27569, '62255', 218, 18, 27702, 38.2892, 0.668272607954613, -89.8174, -1.56760935558076),
(27570, '62256', 218, 18, 27784, 38.2356, 0.667337111475544, -90.2236, -1.57469888300236),
(27571, '62257', 218, 18, 27804, 38.2539, 0.667656506728659, -89.7549, -1.56651852479826),
(27572, '62258', 218, 18, 27822, 38.4934, 0.671836570287185, -89.8031, -1.56735977349772),
(27573, '62259', 218, 18, 27873, 37.9104, 0.661661300748058, -89.8397, -1.56799856400395),
(27574, '62260', 218, 18, 27910, 38.4627, 0.671300754206823, -90.0922, -1.57240552036524),
(27575, '62261', 218, 18, 10550, 38.0237, 0.663638758790568, -90.006, -1.57090104655002),
(27576, '62262', 218, 18, 23269, 38.9255, 0.679378137985053, -89.2681, -1.55802226199955),
(27577, '62263', 218, 18, 10729, 38.342, 0.669194141799666, -89.3843, -1.56005033459037),
(27578, '62264', 218, 18, 28012, 38.3245, 0.668888709180567, -89.8791, -1.56868622372924),
(27579, '62265', 218, 18, 28015, 38.5384, 0.672621968450583, -89.6941, -1.56545736461305),
(27580, '62266', 218, 18, 28038, 38.4791, 0.67158698820415, -89.6787, -1.56518858390824),
(27581, '62268', 218, 18, 4701, 38.2615, 0.66778915175181, -89.591, -1.56365793015424),
(27582, '62269', 218, 18, 28088, 38.588, 0.673487651759572, -89.912, -1.56926043705314),
(27583, '62271', 218, 18, 28114, 38.4295, 0.670721304895161, -89.5502, -1.56294583581943),
(27584, '62272', 218, 18, 28215, 38.011, 0.663417101975565, -89.636, -1.56444332831764),
(27585, '62273', 218, 18, 28244, 38.7784, 0.676810758655369, -89.5666, -1.56323206981675),
(27586, '62274', 218, 18, 28252, 38.0782, 0.664589963232905, -89.3879, -1.56011316644344),
(27587, '62275', 218, 18, 5158, 38.771, 0.676681604290722, -89.5017, -1.56209935113221),
(27588, '62277', 218, 18, 28314, 38.0822, 0.664659776402985, -90.1, -1.57254165604689),
(27589, '62278', 218, 18, 28381, 38.2087, 0.666867617906757, -89.9943, -1.57069684302753),
(27590, '62279', 218, 18, 28391, 38.1688, 0.666171231535212, -90.0895, -1.57235839647543),
(27591, '62280', 218, 18, 5481, 37.8294, 0.660247584053943, -89.6228, -1.56421294485637),
(27592, '62281', 218, 18, 28500, 38.7181, 0.675758325116417, -89.7848, -1.56704037824461),
(27593, '62282', 218, 18, 28505, 38.362, 0.669543207650065, -89.7101, -1.56573661729336),
(27594, '62283', 218, 18, 28580, 38.6554, 0.674664003675416, -89.198, -1.5567987861939),
(27595, '62284', 218, 18, 24913, 38.8663, 0.678344903067872, -89.32, -1.55892808788134),
(27596, '62285', 218, 18, 12000, 38.4095, 0.670372239044762, -89.9924, -1.57066368177175),
(27597, '62286', 218, 18, 25003, 38.1263, 0.665429466603114, -89.7032, -1.56561618957498),
(27598, '62288', 218, 18, 28688, 38.0081, 0.663366487427257, -89.6609, -1.56487791530138),
(27599, '62289', 218, 18, 6148, 38.5964, 0.673634259416739, -89.7529, -1.56648361821322),
(27600, '62292', 218, 18, 6338, 38.2116, 0.666918232455065, -89.6829, -1.56526188773682),
(27601, '62293', 218, 18, 6381, 38.6067, 0.673814028329695, -89.6816, -1.56523919845655),
(27602, '62294', 218, 18, 199, 38.7282, 0.675934603370868, -89.8862, -1.56881014210613),
(27603, '62295', 218, 18, 28845, 38.2965, 0.668400016990008, -90.3158, -1.57630807657269),
(27604, '62297', 218, 18, 28899, 38.0206, 0.663584653583756, -89.826, -1.56775945389643),
(27605, '62298', 218, 18, 6650, 38.3386, 0.669134800605098, -90.1514, -1.57343875528242),
(27606, '62301', 218, 18, 17745, 39.9313, 0.696932659601612, -91.3799, -1.59488012514317),
(27607, '62305', 218, 18, 17745, 39.9302, 0.69691346097984, -91.3037, -1.59355018425315),
(27608, '62306', 218, 18, 17745, 39.9338, 0.696976292832912, -91.3054, -1.59357985485043),
(27609, '62310', 218, 18, 18746, 40.5047, 0.706940377532547, -91.1364, -1.59063024841456),
(27610, '62311', 218, 18, 7193, 40.2317, 0.702175628674603, -90.9506, -1.58738742666435),
(27611, '62312', 218, 18, 26454, 39.6951, 0.692810191908401, -91.0218, -1.58863010109177),
(27612, '62313', 218, 18, 118733, 40.3278, 0.703852890085769, -91.1991, -1.59172456985556),
(27613, '62314', 218, 18, 26463, 39.7817, 0.694321647040628, -90.8582, -1.58577474243551),
(27614, '62316', 218, 18, 7620, 40.2392, 0.702306528368502, -91.0853, -1.58973838516679),
(27615, '62318', 218, 18, 19652, 40.5041, 0.706929905557035, -91.1364, -1.59063024841456),
(27616, '62319', 218, 18, 1304, 40.1483, 0.700720024078439, -90.7374, -1.5836663846991),
(27617, '62320', 218, 18, 119017, 40.041, 0.698847285791049, -91.0648, -1.58938059267013),
(27618, '62321', 218, 18, 7932, 40.4118, 0.705318966657444, -91.132, -1.59055345392747),
(27619, '62323', 218, 18, 26754, 39.7827, 0.694339100333148, -90.7492, -1.58387233355084),
(27620, '62324', 218, 18, 608, 40.0299, 0.698653554244078, -90.9576, -1.58750959971199),
(27621, '62325', 218, 18, 119185, 40.0321, 0.698691951487622, -91.1599, -1.59104040078878),
(27622, '62326', 218, 18, 100962, 40.4264, 0.705573784728236, -90.7904, -1.58459140920266),
(27623, '62329', 218, 18, 119205, 40.5949, 0.708514664517846, -91.135, -1.59060581380503),
(27624, '62330', 218, 18, 119304, 40.6336, 0.709190106938368, -91.1743, -1.59129172820107),
(27625, '62334', 218, 18, 119531, 40.4167, 0.705404487790792, -91.2007, -1.59175249512359),
(27626, '62336', 218, 18, 94200, 40.5042, 0.706931650886287, -91.1364, -1.59063024841456),
(27627, '62338', 218, 18, 2578, 39.9908, 0.697971130506548, -91.235, -1.59235114305703),
(27628, '62339', 218, 18, 54988, 40.1087, 0.70002887369465, -91.0198, -1.58859519450673),
(27629, '62340', 218, 18, 27339, 39.7113, 0.693092935247224, -90.7276, -1.58349534243241),
(27630, '62341', 218, 18, 2950, 40.3944, 0.705015279367597, -91.3335, -1.59407029237024),
(27631, '62343', 218, 18, 3279, 39.7181, 0.69321161763636, -91.2597, -1.59278223938227),
(27632, '62344', 218, 18, 3297, 40.1498, 0.700746204017219, -90.8544, -1.58570841992394),
(27633, '62345', 218, 18, 27626, 39.6484, 0.69199512314772, -91.185, -1.59147847843103),
(27634, '62346', 218, 18, 120256, 40.1665, 0.701037674002302, -90.9729, -1.58777663508755),
(27635, '62347', 218, 18, 3751, 39.8789, 0.696018107073567, -91.11, -1.59016948149203),
(27636, '62348', 218, 18, 66371, 40.1663, 0.701034183343798, -91.4065, -1.5953443827242),
(27637, '62349', 218, 18, 60695, 40.153, 0.700802054553283, -91.2029, -1.59179089236714),
(27638, '62351', 218, 18, 56203, 40.0871, 0.699651882576219, -91.2824, -1.59317842912247),
(27639, '62352', 218, 18, 4232, 39.5639, 0.690520319929784, -90.6498, -1.58213747627436),
(27640, '62353', 218, 18, 4408, 39.9868, 0.697901317336469, -90.7646, -1.58414111425565),
(27641, '62354', 218, 18, 4486, 40.5475, 0.707687378452401, -91.3787, -1.59485918119214),
(27642, '62355', 218, 18, 677, 39.3963, 0.687595148103442, -90.771, -1.58425281532777),
(27643, '62356', 218, 18, 28019, 39.6241, 0.691571008139485, -91.0891, -1.58980470767837),
(27644, '62357', 218, 18, 10782, 39.6938, 0.692787502628125, -90.8575, -1.58576252513075),
(27645, '62358', 218, 18, 89441, 40.6159, 0.708881183660765, -91.2876, -1.59326918624358),
(27646, '62359', 218, 18, 120955, 40.0508, 0.699018328057745, -91.225, -1.59217661013183),
(27647, '62360', 218, 18, 28207, 39.8186, 0.694965673534614, -91.2419, -1.59247157077541),
(27648, '62361', 218, 18, 23808, 39.4286, 0.688158889451836, -90.6495, -1.5821322402866),
(27649, '62362', 218, 18, 11148, 39.782, 0.694326883028384, -90.746, -1.58381648301477),
(27650, '62363', 218, 18, 28268, 39.6093, 0.69131269941019, -90.8072, -1.58488462451699),
(27651, '62365', 218, 18, 23999, 39.8282, 0.695133225142806, -91.1961, -1.591672209978),
(27652, '62366', 218, 18, 268, 39.4423, 0.68839799955936, -90.8735, -1.58604177781107),
(27653, '62367', 218, 18, 14433, 40.2896, 0.703186174311507, -90.919, -1.58683590262072),
(27654, '62370', 218, 18, 11639, 39.5354, 0.690022901092966, -91.0187, -1.58857599588496),
(27655, '62373', 218, 18, 121638, 40.2928, 0.703242024847571, -91.386, -1.59498659022754),
(27656, '62374', 218, 18, 12282, 40.4256, 0.70555982209422, -90.7997, -1.5847537248231),
(27657, '62375', 218, 18, 121714, 40.0172, 0.698431897429075, -90.855, -1.58571889189945),
(27658, '62376', 218, 18, 43446, 40.0795, 0.699519237553067, -91.4119, -1.5954386305038),
(27659, '62378', 218, 18, 28861, 39.888, 0.696176932035498, -90.6582, -1.58228408393152),
(27660, '62379', 218, 18, 6638, 40.3555, 0.704336346288572, -91.4285, -1.59572835515964),
(27661, '62380', 218, 18, 6722, 40.2416, 0.70234841627055, -91.2599, -1.59278573004077),
(27662, '62401', 218, 18, 27055, 39.1209, 0.68278851134345, -88.5459, -1.54541749414165),
(27663, '62410', 218, 18, 7060, 38.5285, 0.672449180854635, -87.7094, -1.53081781494871),
(27664, '62411', 218, 18, 26361, 39.0845, 0.682153211495724, -88.7489, -1.5489605125232),
(27665, '62413', 218, 18, 26382, 39.125, 0.682860069842781, -87.7973, -1.53235195936122),
(27666, '62414', 218, 18, 26477, 39.1766, 0.683760659736811, -88.822, -1.5502363482064),
(27667, '62415', 218, 18, 19293, 38.803, 0.67724010965136, -87.6726, -1.53017553378398),
(27668, '62417', 218, 18, 1130, 38.7107, 0.675629170751769, -87.7581, -1.53166779029444),
(27669, '62418', 218, 18, 1190, 38.9939, 0.680571943193417, -88.9527, -1.55251749353876),
(27670, '62419', 218, 18, 1294, 38.7239, 0.675859554213032, -88.1857, -1.53913081817596),
(27671, '62420', 218, 18, 1393, 39.2991, 0.685898688070504, -87.9898, -1.53571171817131),
(27672, '62421', 218, 18, 26794, 38.7546, 0.676395370293394, -87.9658, -1.53529283915083),
(27673, '62422', 218, 18, 26874, 39.2187, 0.6844954433519, -88.9035, -1.55165879154678),
(27674, '62423', 218, 18, 462, 39.4501, 0.688534135241015, -87.6074, -1.52903757911168),
(27675, '62424', 218, 18, 26951, 39.0605, 0.681734332475245, -88.3793, -1.54250977560782),
(27676, '62425', 218, 18, 27007, 38.8261, 0.67764328070857, -88.1045, -1.53771361082334),
(27677, '62426', 218, 18, 2230, 38.9222, 0.679320542119737, -88.6665, -1.54752236121955),
(27678, '62427', 218, 18, 2479, 38.9025, 0.678976712257094, -87.6723, -1.53017029779622),
(27679, '62428', 218, 18, 27332, 39.2481, 0.685008570151986, -88.1614, -1.53870670316773),
(27680, '62431', 218, 18, 27418, 39.2374, 0.684821819922023, -88.9715, -1.55284561543813),
(27681, '62432', 218, 18, 27432, 39.1197, 0.682767567392426, -88.1333, -1.53821626564792),
(27682, '62433', 218, 18, 27497, 39.1085, 0.682572090516202, -87.6599, -1.52995387696898),
(27683, '62434', 218, 18, 27514, 38.8412, 0.677906825425622, -88.3101, -1.54130200776544),
(27684, '62435', 218, 18, 27546, 39.3742, 0.687209430338751, -88.2439, -1.54014659980062),
(27685, '62436', 218, 18, 27563, 39.2021, 0.684205718696069, -88.2476, -1.54021117698295),
(27686, '62438', 218, 18, 3637, 39.3108, 0.686102891592987, -88.8611, -1.55091877194393),
(27687, '62439', 218, 18, 3698, 38.7258, 0.67589271546882, -87.685, -1.53039195461123),
(27688, '62440', 218, 18, 27704, 39.4175, 0.687965157904865, -88.2855, -1.54087265676945),
(27689, '62441', 218, 18, 4011, 39.394, 0.687555005530646, -87.713, -1.53088064680179),
(27690, '62442', 218, 18, 27817, 39.3329, 0.686488609357678, -87.8854, -1.53388959443222),
(27691, '62443', 218, 18, 17048, 38.9611, 0.679999475198763, -88.6333, -1.54694291190789),
(27692, '62444', 218, 18, 27926, 39.2806, 0.685575802158885, -88.6386, -1.54703541435825),
(27693, '62445', 218, 18, 4299, 39.1491, 0.683280694192512, -88.3179, -1.5414381434471),
(27694, '62446', 218, 18, 27967, 38.3822, 0.669895764158968, -88.4055, -1.54296705187185),
(27695, '62447', 218, 18, 17251, 39.3215, 0.68628964182295, -88.4552, -1.54383448051009),
(27696, '62448', 218, 18, 4570, 38.9879, 0.680467223438297, -88.1639, -1.53875033639903),
(27697, '62449', 218, 18, 28101, 39.0015, 0.680704588216568, -87.9086, -1.53429451081869),
(27698, '62450', 218, 18, 4784, 38.7317, 0.675995689894688, -88.0806, -1.53729647713212),
(27699, '62451', 218, 18, 4839, 39.0057, 0.680777892045152, -87.6159, -1.5291859320981),
(27700, '62452', 218, 18, 23761, 38.5913, 0.673545247624888, -88.0639, -1.53700500714703),
(27701, '62454', 218, 18, 11625, 39.0054, 0.680772656057396, -87.7403, -1.53135712168758),
(27702, '62458', 218, 18, 5612, 39.0272, 0.681153137834331, -88.853, -1.55077740027452),
(27703, '62459', 218, 18, 28512, 38.9322, 0.679495075044936, -88.0236, -1.53630163945848),
(27704, '62460', 218, 18, 28499, 38.5919, 0.6735557196004, -87.6464, -1.52971825751996),
(27705, '62461', 218, 18, 28607, 39.1938, 0.684060856368154, -88.6383, -1.54703017837049),
(27706, '62462', 218, 18, 28611, 39.2251, 0.684607144424028, -88.4929, -1.54449246963809),
(27707, '62463', 218, 18, 28694, 39.2637, 0.685280841515298, -88.6303, -1.54689055203033),
(27708, '62464', 218, 18, 28709, 38.9971, 0.680627793729481, -87.8332, -1.53297853256268),
(27709, '62465', 218, 18, 28710, 39.388, 0.687450285775526, -88.6422, -1.54709824621132),
(27710, '62466', 218, 18, 18216, 38.7152, 0.675707710568109, -87.8621, -1.53348293271651),
(27711, '62467', 218, 18, 28766, 39.1317, 0.682977006902665, -88.477, -1.54421496228702),
(27712, '62468', 218, 18, 12339, 39.2726, 0.685436175818725, -88.2424, -1.54012041986184),
(27713, '62469', 218, 18, 28805, 39.3889, 0.687465993738794, -88.3408, -1.54183782384581),
(27714, '62471', 218, 18, 28848, 38.9684, 0.680126884234158, -89.1062, -1.55519657394057),
(27715, '62473', 218, 18, 6657, 39.037, 0.681324180101026, -88.571, -1.5458555717839),
(27716, '62474', 218, 18, 723, 39.4547, 0.688614420386607, -87.9971, -1.5358391272067),
(27717, '62475', 218, 18, 12753, 38.9063, 0.67904303476867, -88.0999, -1.53763332567775),
(27718, '62476', 218, 18, 28944, 38.5198, 0.672297337209712, -88.0076, -1.53602238677816),
(27719, '62477', 218, 18, 28946, 39.2561, 0.685148196492146, -87.6391, -1.52959084848456),
(27720, '62478', 218, 18, 28948, 39.2064, 0.684280767853905, -87.7267, -1.53111975690931),
(27721, '62479', 218, 18, 6759, 39.0191, 0.681011766164919, -88.3119, -1.54133342369198),
(27722, '62480', 218, 18, 28994, 38.9751, 0.680243821294042, -88.0104, -1.53607125599722),
(27723, '62481', 218, 18, 12986, 39.1287, 0.682924647025105, -88.0038, -1.53595606426659),
(27724, '62501', 218, 18, 26393, 39.9848, 0.697866410751429, -88.8181, -1.55016828036558),
(27725, '62510', 218, 18, 26406, 39.5186, 0.689729685778631, -89.0508, -1.55422966153497),
(27726, '62511', 218, 18, 18960, 39.3059, 0.686017370459639, -89.7583, -1.56657786599283),
(27727, '62512', 218, 18, 118747, 40.1424, 0.700617049652572, -89.1979, -1.55679704086465),
(27728, '62513', 218, 18, 26551, 39.6999, 0.692893967712497, -89.1213, -1.55546011865762),
(27729, '62514', 218, 18, 26576, 39.7679, 0.694080791603853, -89.0496, -1.55420871758394),
(27730, '62515', 218, 18, 26642, 39.8502, 0.695517197578244, -89.4088, -1.56047794025711),
(27731, '62517', 218, 18, 26646, 39.5918, 0.691007266791091, -89.4244, -1.56075021162042),
(27732, '62518', 218, 18, 1536, 40.0667, 0.699295835408812, -89.1941, -1.55673071835307),
(27733, '62519', 218, 18, 26859, 39.9369, 0.697030398039723, -89.4017, -1.56035402188021),
(27734, '62520', 218, 18, 1989, 39.8547, 0.695595737394584, -89.4606, -1.56138202080964),
(27735, '62521', 218, 18, 2007, 39.8274, 0.69511926250879, -88.9226, -1.55199214943391),
(27736, '62522', 218, 18, 2007, 39.8446, 0.695419459140133, -88.995, -1.55325576781235),
(27737, '62523', 218, 18, 2007, 39.8436, 0.695402005847613, -88.9511, -1.55248956827073),
(27738, '62524', 218, 18, 2007, 39.9053, 0.696478873996093, -88.9647, -1.552726933049),
(27739, '62525', 218, 18, 2007, 39.8341, 0.695236199568673, -88.945, -1.55238310318636),
(27740, '62526', 218, 18, 2007, 39.8785, 0.696011125756559, -88.9567, -1.55258730670884),
(27741, '62527', 218, 18, 2007, 39.8436, 0.695402005847613, -88.9519, -1.55250353090474),
(27742, '62530', 218, 18, 26954, 39.5647, 0.690534282563801, -89.6563, -1.56479763015579),
(27743, '62531', 218, 18, 27051, 39.6599, 0.692195836011699, -89.3918, -1.56018123428427),
(27744, '62532', 218, 18, 27095, 39.7788, 0.69427103249232, -88.9805, -1.55300269507081),
(27745, '62533', 218, 18, 2418, 39.4406, 0.688368328962076, -89.6505, -1.56469640105918),
(27746, '62534', 218, 18, 21083, 39.5202, 0.689757611046663, -88.753, -1.54903207102253),
(27747, '62535', 218, 18, 21226, 39.9309, 0.696925678284604, -88.9513, -1.55249305892923),
(27748, '62536', 218, 18, 27270, 39.6373, 0.691801391600748, -89.6374, -1.56446776292717),
(27749, '62537', 218, 18, 27390, 39.842, 0.695374080579581, -89.0597, -1.55438499583839),
(27750, '62538', 218, 18, 27396, 39.3849, 0.687396180568715, -89.5452, -1.56285856935683),
(27751, '62539', 218, 18, 27505, 39.854, 0.69558352008982, -89.2473, -1.55765923351514),
(27752, '62540', 218, 18, 27625, 39.5869, 0.690921745657743, -89.4141, -1.56057044270746),
(27753, '62541', 218, 18, 27657, 39.9711, 0.697627300643905, -89.3502, -1.55945517731544),
(27754, '62543', 218, 18, 3678, 39.9687, 0.697585412741858, -89.162, -1.55617046766318),
(27755, '62544', 218, 18, 3937, 39.7148, 0.693154021771044, -88.9975, -1.55329940104365),
(27756, '62545', 218, 18, 27864, 39.8097, 0.694810339231187, -89.3987, -1.56030166200265),
(27757, '62546', 218, 18, 27951, 39.4211, 0.688027989757937, -89.4572, -1.56132267961507),
(27758, '62547', 218, 18, 27960, 39.7582, 0.69391149466641, -89.2141, -1.55707978420347),
(27759, '62548', 218, 18, 120718, 40.0098, 0.698302743064427, -89.284, -1.55829976935062),
(27760, '62549', 218, 18, 4417, 39.7853, 0.6943844788937, -88.87, -1.55107410624736),
(27761, '62550', 218, 18, 27984, 39.6256, 0.691597188078265, -89.017, -1.55363974024779),
(27762, '62551', 218, 18, 28054, 39.8544, 0.695590501406828, -89.1645, -1.55621410089448),
(27763, '62553', 218, 18, 23595, 39.2818, 0.685596746109909, -89.0828, -1.5547881668956),
(27764, '62554', 218, 18, 28154, 39.9347, 0.69699200079618, -88.863, -1.55095193319972),
(27765, '62555', 218, 18, 28165, 39.4828, 0.689104857906417, -89.1949, -1.55674468098709),
(27766, '62556', 218, 18, 337, 39.4802, 0.689059479345865, -89.4495, -1.56118828926267),
(27767, '62557', 218, 18, 4849, 39.3885, 0.687459012421787, -89.0812, -1.55476024162757),
(27768, '62558', 218, 18, 23789, 39.5907, 0.690988068169319, -89.5851, -1.56355495572837),
(27769, '62560', 218, 18, 24225, 39.32, 0.68626346188417, -89.5737, -1.56335598819364),
(27770, '62561', 218, 18, 5429, 39.8532, 0.695569557455804, -89.5423, -1.56280795480852),
(27771, '62563', 218, 18, 28433, 39.7488, 0.693747433716722, -89.5408, -1.56278177486974),
(27772, '62565', 218, 18, 11899, 39.4072, 0.687785388991909, -88.8013, -1.54987506505124),
(27773, '62567', 218, 18, 28706, 39.6377, 0.691808372917756, -89.1904, -1.55666614117075),
(27774, '62568', 218, 18, 6256, 39.5487, 0.690255029883481, -89.2952, -1.55849524622684),
(27775, '62570', 218, 18, 28803, 39.589, 0.690958397572035, -89.4492, -1.56118305327491),
(27776, '62571', 218, 18, 28801, 39.389, 0.687467739068046, -88.964, -1.55271471574424),
(27777, '62572', 218, 18, 28886, 39.3767, 0.687253063570051, -89.6494, -1.5646772024374),
(27778, '62573', 218, 18, 28908, 39.9295, 0.696901243675076, -89.0591, -1.55437452386288),
(27779, '62601', 218, 18, 7048, 39.7305, 0.693428038463607, -90.0376, -1.57145257059365),
(27780, '62610', 218, 18, 26359, 39.5599, 0.690450506759705, -90.435, -1.57838850904107),
(27781, '62611', 218, 18, 26391, 39.8776, 0.695995417793291, -90.3698, -1.57725055436877),
(27782, '62612', 218, 18, 13301, 39.8868, 0.696155988084474, -90.0095, -1.57096213307384),
(27783, '62613', 218, 18, 7182, 39.959, 0.697416115804414, -89.7281, -1.56605077655872),
(27784, '62615', 218, 18, 13306, 39.5899, 0.690974105535303, -89.7451, -1.56634748253156),
(27785, '62617', 218, 18, 19093, 40.1369, 0.700521056543712, -90.1661, -1.57369531868246),
(27786, '62618', 218, 18, 84876, 40.0112, 0.698327177673955, -90.4237, -1.5781912868356),
(27787, '62621', 218, 18, 26560, 39.7342, 0.693492615645931, -90.5238, -1.57993836141684),
(27788, '62622', 218, 18, 1015, 39.9883, 0.697927497275249, -90.3458, -1.57683167534829),
(27789, '62624', 218, 18, 19587, 40.1573, 0.700877103711119, -90.3495, -1.57689625253062),
(27790, '62625', 218, 18, 26697, 39.9264, 0.696847138468264, -89.6694, -1.5650262682878),
(27791, '62626', 218, 18, 26703, 39.2803, 0.685570566171129, -89.8794, -1.56869145971699),
(27792, '62627', 218, 18, 35209, 40.0507, 0.699016582728493, -90.1483, -1.5733846500756),
(27793, '62628', 218, 18, 26757, 39.7669, 0.694063338311333, -90.4015, -1.57780382374165),
(27794, '62629', 218, 18, 13522, 39.677, 0.69249428731379, -89.6945, -1.56546434593005),
(27795, '62630', 218, 18, 1534, 39.2796, 0.685558348866365, -90.0916, -1.57239504838972),
(27796, '62631', 218, 18, 698, 39.8281, 0.695131479813554, -90.371, -1.5772714983198),
(27797, '62633', 218, 18, 2193, 40.2328, 0.702194827296375, -89.8462, -1.56811201040533),
(27798, '62634', 218, 18, 94006, 40.0206, 0.698491238623643, -89.4806, -1.56173108666004),
(27799, '62635', 218, 18, 40811, 40.2981, 0.703334527297927, -89.4853, -1.56181311713488),
(27800, '62638', 218, 18, 2595, 39.6213, 0.691522138920429, -90.0415, -1.57152063843447),
(27801, '62639', 218, 18, 32485, 40.0562, 0.699112575837353, -90.494, -1.57941825329975),
(27802, '62640', 218, 18, 2718, 39.4448, 0.688441632790659, -89.7961, -1.56723760045008),
(27803, '62642', 218, 18, 13861, 40.0834, 0.699587305393895, -89.7416, -1.56628639600774),
(27804, '62643', 218, 18, 55194, 40.2513, 0.702517713207994, -89.4392, -1.56100852034971),
(27805, '62644', 218, 18, 3010, 40.2976, 0.703325800651667, -90.0592, -1.57182956171208),
(27806, '62649', 218, 18, 27425, 39.3902, 0.68748868301907, -90.0943, -1.57244217227953),
(27807, '62650', 218, 18, 3395, 39.7308, 0.693433274451363, -90.2393, -1.57497289969492),
(27808, '62651', 218, 18, 3395, 39.7285, 0.693393131878567, -90.2646, -1.57541446799567),
(27809, '62655', 218, 18, 41600, 40.1531, 0.700803799882535, -90.0085, -1.57094467978132),
(27810, '62656', 218, 18, 3781, 40.1512, 0.700770638626747, -89.3696, -1.55979377119032),
(27811, '62659', 218, 18, 0, 40.0097, 0.698300997735175, -89.8496, -1.5681713515999),
(27812, '62660', 218, 18, 27728, 39.8542, 0.695587010748324, -90.1994, -1.57427651332337),
(27813, '62661', 218, 18, 27736, 39.651, 0.692040501708272, -89.8827, -1.56874905558231),
(27814, '62662', 218, 18, 27761, 39.5506, 0.690288191139269, -89.8459, -1.56810677441757),
(27815, '62663', 218, 18, 585, 39.5422, 0.690141583482102, -90.3306, -1.57656638530199),
(27816, '62664', 218, 18, 4032, 40.2029, 0.701672973850028, -89.6966, -1.56550099784435),
(27817, '62665', 218, 18, 27875, 39.8308, 0.695178603703357, -90.5582, -1.58053875467953),
(27818, '62666', 218, 18, 14224, 40.0999, 0.699875284720474, -89.592, -1.56367538344676),
(27819, '62667', 218, 18, 27927, 39.4783, 0.689026318090077, -89.982, -1.57048216752954),
(27820, '62668', 218, 18, 23287, 39.5872, 0.690926981645499, -90.25, -1.57515964992488),
(27821, '62670', 218, 18, 17254, 39.7342, 0.693492615645931, -89.9078, -1.56918713322456),
(27822, '62671', 218, 18, 23337, 40.1852, 0.701364050572425, -89.5806, -1.56347641591203),
(27823, '62672', 218, 18, 28056, 39.3867, 0.687427596495251, -89.7796, -1.5669496211235),
(27824, '62673', 218, 18, 120861, 40.1022, 0.69991542729327, -89.9655, -1.57019418820296),
(27825, '62674', 218, 18, 4846, 39.4397, 0.688352620998808, -89.9258, -1.56950129248992),
(27826, '62675', 218, 18, 14402, 40.0045, 0.698210240614072, -89.8549, -1.56826385405025),
(27827, '62677', 218, 18, 5141, 39.8744, 0.695939567257227, -89.9187, -1.56937737411303),
(27828, '62681', 218, 18, 31020, 40.1217, 0.700255766497409, -90.5624, -1.58061205850811),
(27829, '62682', 218, 18, 17939, 40.3036, 0.703430520406787, -89.6045, -1.56389354960326),
(27830, '62683', 218, 18, 28557, 39.4737, 0.688946032944486, -90.0965, -1.57248056952307),
(27831, '62684', 218, 18, 18065, 39.8946, 0.69629212376613, -89.603, -1.56386736966448),
(27832, '62685', 218, 18, 28601, 39.1151, 0.682687282246834, -90.0062, -1.57090453720852),
(27833, '62686', 218, 18, 28681, 39.446, 0.688462576741683, -89.7925, -1.56717476859701),
(27834, '62688', 218, 18, 28747, 39.9427, 0.697131627136339, -89.8995, -1.56904227089664),
(27835, '62689', 218, 18, 28771, 39.5385, 0.690077006299778, -89.7637, -1.56667211377243),
(27836, '62690', 218, 18, 28874, 39.5025, 0.68944868776906, -89.769, -1.56676461622279),
(27837, '62691', 218, 18, 6578, 39.9461, 0.697190968330907, -90.203, -1.57433934517645),
(27838, '62692', 218, 18, 6664, 39.5916, 0.691003776132587, -89.9543, -1.56999871132674),
(27839, '62693', 218, 18, 14865, 39.9532, 0.697314886707799, -89.5434, -1.56282715343029),
(27840, '62694', 218, 18, 12894, 39.63, 0.691673982565353, -90.4564, -1.578762009501),
(27841, '62695', 218, 18, 12950, 39.6291, 0.691658274602085, -90.2191, -1.57462034318602),
(27842, '62701', 218, 18, 349, 39.8011, 0.694660240915515, -89.6499, -1.56468592908366),
(27843, '62702', 218, 18, 349, 39.8178, 0.694951710900598, -89.6488, -1.56466673046189),
(27844, '62703', 218, 18, 349, 39.7725, 0.694161076749445, -89.633, -1.56439096844008),
(27845, '62704', 218, 18, 349, 39.7788, 0.69427103249232, -89.6867, -1.5653282102484),
(27846, '62705', 218, 18, 349, 39.7994, 0.694630570318231, -89.6463, -1.56462309723059),
(27847, '62706', 218, 18, 349, 39.7999, 0.694639296964491, -89.653, -1.56474003429048),
(27848, '62707', 218, 18, 349, 39.7762, 0.694225653931769, -89.6503, -1.56469291040067),
(27849, '62708', 218, 18, 349, 39.7587, 0.69392022131267, -89.633, -1.56439096844008),
(27850, '62709', 218, 18, 349, 39.7718, 0.694148859444681, -89.6867, -1.5653282102484),
(27851, '62713', 218, 18, 349, 39.7919, 0.694499670624332, -89.6465, -1.5646265878891),
(27852, '62715', 218, 18, 349, 39.8028, 0.694689911512799, -89.6466, -1.56462833321835),
(27853, '62716', 218, 18, 349, 39.7491, 0.693752669704478, -89.6134, -1.56404888390669),
(27854, '62718', 218, 18, 349, 39.8004, 0.694648023610751, -89.6481, -1.56465451315713),
(27855, '62719', 218, 18, 349, 39.8029, 0.694691656842051, -89.6549, -1.56477319554626),
(27856, '62720', 218, 18, 349, 39.8017, 0.694670712891027, -89.6437, -1.56457771867004),
(27857, '62721', 218, 18, 349, 39.7947, 0.694548539843387, -89.6488, -1.56466673046189),
(27858, '62722', 218, 18, 349, 39.797, 0.694588682416183, -89.6535, -1.56474876093674),
(27859, '62723', 218, 18, 349, 39.7583, 0.693913239995661, -89.633, -1.56439096844008),
(27860, '62726', 218, 18, 349, 39.8032, 0.694696892829807, -89.655, -1.56477494087552),
(27861, '62736', 218, 18, 349, 39.8031, 0.694695147500555, -89.6546, -1.56476795955851),
(27862, '62739', 218, 18, 349, 39.8011, 0.694660240915515, -89.6476, -1.56464578651087),
(27863, '62746', 218, 18, 349, 39.8032, 0.694696892829807, -89.6549, -1.56477319554626),
(27864, '62756', 218, 18, 349, 39.7977, 0.694600899720947, -89.6537, -1.56475225159524),
(27865, '62757', 218, 18, 349, 39.7997, 0.694635806305987, -89.6466, -1.56462833321835),
(27866, '62761', 218, 18, 349, 39.8025, 0.694684675525043, -89.6612, -1.56488315128914),
(27867, '62762', 218, 18, 349, 39.7875, 0.694422876137244, -89.6553, -1.56478017686327),
(27868, '62763', 218, 18, 349, 39.787, 0.694414149490984, -89.6541, -1.56475923291225),
(27869, '62764', 218, 18, 349, 39.7591, 0.693927202629677, -89.6328, -1.56438747778157),
(27870, '62765', 218, 18, 349, 39.8012, 0.694661986244767, -89.6429, -1.56456375603602),
(27871, '62766', 218, 18, 349, 39.7721, 0.694154095432437, -89.6063, -1.5639249655298),
(27872, '62767', 218, 18, 349, 39.8018, 0.694672458220279, -89.6573, -1.56481508344831),
(27873, '62769', 218, 18, 349, 39.807, 0.694763215341383, -89.6449, -1.56459866262106),
(27874, '62776', 218, 18, 349, 39.7994, 0.694630570318231, -89.6536, -1.56475050626599),
(27875, '62777', 218, 18, 349, 39.8021, 0.694677694208035, -89.6547, -1.56476970488776),
(27876, '62781', 218, 18, 349, 39.8103, 0.694820811206699, -89.6577, -1.56482206476532),
(27877, '62786', 218, 18, 349, 39.8015, 0.694667222232523, -89.6582, -1.56483079141158),
(27878, '62791', 218, 18, 349, 39.8538, 0.695580029431316, -89.6335, -1.56439969508634),
(27879, '62794', 218, 18, 349, 39.7586, 0.693918475983417, -89.6334, -1.56439794975709),
(27880, '62796', 218, 18, 349, 39.7941, 0.694538067867876, -89.625, -1.56425134209992),
(27881, '62801', 218, 18, 26746, 38.5265, 0.672414274269595, -89.1276, -1.5555700744005),
(27882, '62803', 218, 18, 27474, 38.4504, 0.671086078708828, -89.3137, -1.55881813213846),
(27883, '62805', 218, 18, 18762, 37.9875, 0.663006949601346, -88.752, -1.54901461773001),
(27884, '62806', 218, 18, 7043, 38.3786, 0.669832932305896, -88.0565, -1.53687585278239),
(27885, '62807', 218, 18, 7066, 38.7352, 0.676056776418507, -88.9197, -1.5519415348856),
(27886, '62808', 218, 18, 13302, 38.3286, 0.668960267679899, -89.1904, -1.55666614117075),
(27887, '62809', 218, 18, 19066, 38.2754, 0.668031752517838, -88.3889, -1.54267732721602),
(27888, '62810', 218, 18, 26484, 38.1928, 0.66659011055569, -88.7599, -1.54915249874091),
(27889, '62811', 218, 18, 26488, 38.3825, 0.669901000146723, -87.9095, -1.53431021878196),
(27890, '62812', 218, 18, 358, 37.9984, 0.663197190489813, -88.9168, -1.55189092033729),
(27891, '62814', 218, 18, 26562, 38.4401, 0.670906309795872, -88.7135, -1.54834266596799),
(27892, '62815', 218, 18, 26571, 38.4489, 0.671059898770048, -87.9997, -1.53588450576725),
(27893, '62816', 218, 18, 15287, 38.193, 0.666593601214194, -88.9396, -1.55228885540675),
(27894, '62817', 218, 18, 1181, 37.9615, 0.662553163995827, -88.4576, -1.54387636841214),
(27895, '62818', 218, 18, 1184, 38.3704, 0.669689815307232, -87.9972, -1.53584087253595),
(27896, '62819', 218, 18, 7751, 37.9803, 0.662881285895202, -89.0152, -1.55360832432126),
(27897, '62820', 218, 18, 26659, 38.1939, 0.666609309177462, -88.2104, -1.53956191450121),
(27898, '62821', 218, 18, 7912, 38.0868, 0.664740061548576, -88.17, -1.5388568014834),
(27899, '62822', 218, 18, 20046, 37.9738, 0.662767839493823, -89.0517, -1.55424536949823),
(27900, '62823', 218, 18, 26792, 38.5138, 0.672192617454592, -88.3642, -1.54224623089077),
(27901, '62824', 218, 18, 1602, 38.6895, 0.675259160950346, -88.3579, -1.5421362751479),
(27902, '62825', 218, 18, 26823, 37.9953, 0.663143085283001, -89.0526, -1.5542610774615),
(27903, '62827', 218, 18, 1904, 38.1663, 0.666127598303912, -88.0671, -1.5370608576831),
(27904, '62828', 218, 18, 26907, 38.1902, 0.666544731995138, -88.5374, -1.54526914115523),
(27905, '62829', 218, 18, 847, 37.9971, 0.663174501209537, -88.5367, -1.54525692385046),
(27906, '62830', 218, 18, 26957, 38.442, 0.67093947105166, -88.9386, -1.55227140211423),
(27907, '62831', 218, 18, 26988, 38.2573, 0.667715847923227, -89.2026, -1.55687907133949),
(27908, '62832', 218, 18, 26990, 38.0122, 0.663438045926589, -89.2343, -1.55743234071238),
(27909, '62833', 218, 18, 27077, 38.3602, 0.669511791723529, -88.1334, -1.53821801097717),
(27910, '62834', 218, 18, 20894, 37.9747, 0.662783547457091, -88.1198, -1.5379806461989),
(27911, '62835', 218, 18, 27104, 38.0989, 0.664951246388068, -88.3389, -1.54180466259002),
(27912, '62836', 218, 18, 2347, 38.0753, 0.664539348684597, -88.8028, -1.54990124499002),
(27913, '62837', 218, 18, 2367, 38.3803, 0.66986260290318, -88.3651, -1.54226193885404),
(27914, '62838', 218, 18, 27147, 38.8328, 0.677760217768454, -88.774, -1.54939859016545),
(27915, '62839', 218, 18, 27181, 38.6724, 0.674960709648255, -88.4861, -1.54437378724895),
(27916, '62840', 218, 18, 0, 37.9019, 0.661512947761639, -88.8394, -1.55054003549625),
(27917, '62841', 218, 18, 27215, 37.8009, 0.659750165217124, -89.0076, -1.5534756792981),
(27918, '62842', 218, 18, 27249, 38.4404, 0.670911545783628, -88.424, -1.54328993778347),
(27919, '62843', 218, 18, 16228, 38.3611, 0.669527499686797, -88.2042, -1.53945370408758),
(27920, '62844', 218, 18, 27321, 38.2386, 0.667389471353104, -88.0158, -1.53616550377683),
(27921, '62845', 218, 18, 27414, 37.9731, 0.662755622189059, -88.2007, -1.53939261756376),
(27922, '62846', 218, 18, 27508, 38.1513, 0.665865798916113, -88.9063, -1.55170766076583),
(27923, '62847', 218, 18, 16556, 38.8342, 0.677784652377982, -88.6276, -1.54684342814053),
(27924, '62848', 218, 18, 3366, 38.4377, 0.670864421893824, -89.1617, -1.55616523167543),
(27925, '62849', 218, 18, 9676, 38.616, 0.67397634395013, -88.7897, -1.54967260685801),
(27926, '62850', 218, 18, 756, 38.5206, 0.672311299843728, -88.5364, -1.54525168786271),
(27927, '62851', 218, 18, 27603, 38.3714, 0.669707268599752, -88.6489, -1.5472151832712),
(27928, '62852', 218, 18, 27605, 38.3499, 0.669332022810573, -87.8659, -1.53354925522809),
(27929, '62853', 218, 18, 27608, 38.519, 0.672283374575696, -88.8101, -1.55002865402542),
(27930, '62854', 218, 18, 27635, 38.7721, 0.676700802912493, -88.8485, -1.55069886045818),
(27931, '62855', 218, 18, 16841, 38.5354, 0.672569608573023, -87.8873, -1.53392275568801),
(27932, '62856', 218, 18, 3843, 37.9558, 0.662453680228464, -88.8403, -1.55055574345952),
(27933, '62857', 218, 18, 27751, 38.9047, 0.679015109500638, -88.8536, -1.55078787225003),
(27934, '62858', 218, 18, 3876, 38.77, 0.676664150998202, -88.5071, -1.54474030639187),
(27935, '62859', 218, 18, 27856, 38.0918, 0.664827328011176, -88.5356, -1.54523772522869),
(27936, '62860', 218, 18, 3926, 38.0105, 0.663408375329305, -88.682, -1.54779288725361),
(27937, '62861', 218, 18, 27835, 38.0353, 0.663841216983799, -88.0455, -1.53668386656467),
(27938, '62862', 218, 18, 27903, 38.088, 0.6647610054996, -88.1696, -1.53884982016639),
(27939, '62863', 218, 18, 4363, 38.4167, 0.670497902750906, -87.7679, -1.53183883256113),
(27940, '62864', 218, 18, 4411, 38.316, 0.668740356194147, -88.9106, -1.55178270992367),
(27941, '62865', 218, 18, 27989, 37.9865, 0.662989496308826, -89.1088, -1.55524195250112),
(27942, '62866', 218, 18, 28002, 38.1634, 0.666076983755604, -88.9779, -1.55295731651026),
(27943, '62867', 218, 18, 4528, 37.8519, 0.660640283135642, -88.0982, -1.53760365508047),
(27944, '62868', 218, 18, 23388, 38.6985, 0.675416240583026, -88.2233, -1.53978706197471),
(27945, '62869', 218, 18, 28065, 37.9804, 0.662883031224454, -88.3274, -1.54160394972604),
(27946, '62870', 218, 18, 28106, 38.6151, 0.673960635986862, -89.0516, -1.55424362416898),
(27947, '62871', 218, 18, 4786, 37.8864, 0.66124242172758, -88.2649, -1.54051311894354),
(27948, '62872', 218, 18, 28147, 38.2788, 0.668091093712405, -88.7553, -1.54907221359532),
(27949, '62874', 218, 18, 28156, 37.9188, 0.661807908405226, -88.9742, -1.55289273932794),
(27950, '62875', 218, 18, 11097, 38.7532, 0.676370935683867, -89.096, -1.55501855035687),
(27951, '62876', 218, 18, 28364, 38.2822, 0.668150434906973, -89.1952, -1.55674991697485),
(27952, '62877', 218, 18, 28405, 38.4004, 0.670213414082831, -89.2012, -1.55685463672997),
(27953, '62878', 218, 18, 28422, 38.5818, 0.673379441345948, -88.4768, -1.54421147162852),
(27954, '62879', 218, 18, 28493, 38.765, 0.676576884535602, -88.3583, -1.54214325646491),
(27955, '62880', 218, 18, 17915, 38.8683, 0.678379809652912, -88.8638, -1.55096589583374),
(27956, '62881', 218, 18, 126, 38.6287, 0.674198000765134, -88.947, -1.5524180097714);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(27957, '62882', 218, 18, 28532, 38.6132, 0.673927474731074, -89.1206, -1.55544790135286),
(27958, '62883', 218, 18, 28547, 38.168, 0.666157268901196, -89.0957, -1.55501331436911),
(27959, '62884', 218, 18, 28567, 38.0915, 0.66482209202342, -89.0508, -1.55422966153497),
(27960, '62885', 218, 18, 28605, 38.8449, 0.677971402607945, -89.0842, -1.55481260150513),
(27961, '62886', 218, 18, 11960, 38.411, 0.670398418983542, -88.5287, -1.5451172975103),
(27962, '62887', 218, 18, 28675, 38.166, 0.666122362316156, -88.3781, -1.5424888316568),
(27963, '62888', 218, 18, 28751, 38.1475, 0.665799476404537, -89.2104, -1.55701520702115),
(27964, '62889', 218, 18, 28770, 38.4676, 0.671386275340171, -88.7551, -1.54906872293682),
(27965, '62890', 218, 18, 14747, 37.9169, 0.661774747149438, -88.7598, -1.54915075341166),
(27966, '62891', 218, 18, 28841, 38.0176, 0.663532293706196, -89.0436, -1.55410399782882),
(27967, '62892', 218, 18, 6535, 38.8052, 0.677278506894904, -89.0828, -1.5547881668956),
(27968, '62893', 218, 18, 6619, 38.5188, 0.672279883917192, -88.9777, -1.55295382585176),
(27969, '62894', 218, 18, 28905, 38.3169, 0.668756064157415, -88.9124, -1.55181412585021),
(27970, '62895', 218, 18, 28922, 38.3473, 0.669286644250021, -88.5905, -1.54619591098804),
(27971, '62896', 218, 18, 28939, 37.8983, 0.661450115908567, -88.92, -1.55194677087336),
(27972, '62897', 218, 18, 12840, 38.1072, 0.665096108715983, -88.8732, -1.55112995678342),
(27973, '62898', 218, 18, 6936, 38.3876, 0.669990011938575, -89.0899, -1.5549120852725),
(27974, '62899', 218, 18, 29041, 38.6952, 0.67535864471771, -88.6409, -1.54707555693104),
(27975, '62901', 218, 18, 19772, 37.7262, 0.658446404265885, -89.2234, -1.55724209982391),
(27976, '62902', 218, 18, 19772, 37.7214, 0.658362628461789, -89.1917, -1.55668883045103),
(27977, '62903', 218, 18, 19772, 37.7306, 0.658523198752972, -89.2106, -1.55701869767965),
(27978, '62905', 218, 18, 26363, 37.5568, 0.655489816513006, -89.3386, -1.55925271912221),
(27979, '62906', 218, 18, 26375, 37.4618, 0.653831753723612, -89.2446, -1.55761210962533),
(27980, '62907', 218, 18, 7203, 37.8819, 0.66116388191124, -89.4474, -1.56115163734838),
(27981, '62908', 218, 18, 218, 37.3265, 0.651470323245663, -88.952, -1.552505276234),
(27982, '62909', 218, 18, 7587, 37.4662, 0.6539085482107, -88.9943, -1.55324355050759),
(27983, '62910', 218, 18, 26614, 37.1252, 0.647956975461399, -88.63, -1.54688531604257),
(27984, '62912', 218, 18, 26647, 37.4654, 0.653894585576684, -88.9861, -1.55310043350893),
(27985, '62913', 218, 18, 26669, 37.0291, 0.646279714050232, -89.291, -1.55842194239826),
(27986, '62914', 218, 18, 1288, 37.0071, 0.645895741614794, -89.1784, -1.55645670166051),
(27987, '62915', 218, 18, 26686, 37.7812, 0.659406335354482, -89.1189, -1.55541823075557),
(27988, '62916', 218, 18, 26693, 37.9159, 0.661757293856918, -89.5945, -1.56371901667806),
(27989, '62917', 218, 18, 26712, 37.6908, 0.657828557710679, -88.6287, -1.5468626267623),
(27990, '62918', 218, 18, 26719, 37.7588, 0.659015381602035, -89.0797, -1.55473406168879),
(27991, '62919', 218, 18, 0, 37.5393, 0.655184383893907, -88.2383, -1.54004886136251),
(27992, '62920', 218, 18, 26819, 37.5327, 0.655069192163276, -89.2536, -1.55776918925801),
(27993, '62921', 218, 18, 26833, 37.8052, 0.65982521437496, -89.0795, -1.55473057103029),
(27994, '62922', 218, 18, 26884, 37.6174, 0.656547486039715, -88.8367, -1.55049291160645),
(27995, '62923', 218, 18, 1938, 37.4522, 0.65366420211542, -89.2716, -1.55808334852337),
(27996, '62924', 218, 18, 26922, 37.8158, 0.660010219275672, -89.2294, -1.55734681957903),
(27997, '62926', 218, 18, 8561, 37.3595, 0.652046281898822, -89.166, -1.55624028083326),
(27998, '62927', 218, 18, 26982, 37.9403, 0.662183154194405, -89.2397, -1.55752658849198),
(27999, '62928', 218, 18, 27042, 37.5363, 0.655132024016348, -88.5956, -1.54628492277989),
(28000, '62930', 218, 18, 15909, 37.8148, 0.659992765983152, -88.4414, -1.54359362507331),
(28001, '62931', 218, 18, 27070, 37.4846, 0.654229688793066, -88.2708, -1.54061609336941),
(28002, '62932', 218, 18, 27076, 37.9106, 0.661664791406562, -89.2354, -1.55745153933415),
(28003, '62933', 218, 18, 27103, 37.7762, 0.659319068891882, -89.0255, -1.55378809323421),
(28004, '62934', 218, 18, 2317, 37.7329, 0.658563341325768, -88.3423, -1.54186400378459),
(28005, '62935', 218, 18, 27230, 37.8415, 0.660458768893434, -88.6097, -1.54653101420442),
(28006, '62938', 218, 18, 27279, 37.3583, 0.652025337947798, -88.489, -1.54442440179726),
(28007, '62939', 218, 18, 27291, 37.5549, 0.655456655257219, -88.9719, -1.55285259675514),
(28008, '62940', 218, 18, 27295, 37.7443, 0.658762308860496, -89.4436, -1.5610853148368),
(28009, '62941', 218, 18, 27300, 37.2525, 0.650178779599188, -89.0132, -1.55357341773622),
(28010, '62942', 218, 18, 27304, 37.6419, 0.656975091706454, -89.4685, -1.56151990182055),
(28011, '62943', 218, 18, 27315, 37.3795, 0.65239534774922, -88.7653, -1.54924674652052),
(28012, '62944', 218, 18, 27370, 37.141, 0.648232737483214, -88.4465, -1.54368263686516),
(28013, '62946', 218, 18, 2994, 37.7318, 0.658544142703996, -88.5446, -1.54539480486137),
(28014, '62947', 218, 18, 21856, 37.4896, 0.654316955255666, -88.4778, -1.54422892492104),
(28015, '62948', 218, 18, 27420, 37.8036, 0.659797289106928, -89.0281, -1.55383347179476),
(28016, '62949', 218, 18, 22117, 37.8316, 0.660285981297487, -89.1428, -1.5558353644468),
(28017, '62950', 218, 18, 27539, 37.7479, 0.658825140713568, -89.5493, -1.56293012785616),
(28018, '62951', 218, 18, 27572, 37.8206, 0.660093995079767, -88.9258, -1.55204799996997),
(28019, '62952', 218, 18, 3452, 37.4524, 0.653667692773924, -89.2688, -1.55803447930431),
(28020, '62953', 218, 18, 947, 37.2078, 0.649398617423546, -88.8436, -1.55061333932483),
(28021, '62954', 218, 18, 27584, 37.6797, 0.657634826163707, -88.2555, -1.54034905799386),
(28022, '62955', 218, 18, 27595, 37.4718, 0.654006286648811, -88.365, -1.54226019352479),
(28023, '62956', 218, 18, 27596, 37.2939, 0.650901345909513, -88.9765, -1.55293288190073),
(28024, '62957', 218, 18, 4073, 37.2945, 0.650911817885025, -89.4962, -1.56200335802335),
(28025, '62958', 218, 18, 27788, 37.6387, 0.65691924117039, -89.1898, -1.55665566919524),
(28026, '62959', 218, 18, 630, 37.7226, 0.658383572412813, -88.8745, -1.5511526460637),
(28027, '62960', 218, 18, 27883, 37.1543, 0.648464866273729, -88.7229, -1.54850672691768),
(28028, '62961', 218, 18, 56256, 37.3513, 0.651903164900158, -89.2701, -1.55805716858459),
(28029, '62962', 218, 18, 27905, 37.0864, 0.647279787711625, -89.3528, -1.55950055587599),
(28030, '62963', 218, 18, 10620, 37.0922, 0.647381016808241, -89.1647, -1.55621759155299),
(28031, '62964', 218, 18, 10622, 37.1151, 0.647780697206947, -89.1978, -1.5567952955354),
(28032, '62965', 218, 18, 27986, 37.7651, 0.659125337344911, -88.5171, -1.54491483931707),
(28033, '62966', 218, 18, 27993, 37.7655, 0.659132318661919, -89.3398, -1.55927366307323),
(28034, '62967', 218, 18, 28018, 37.5783, 0.655865062302185, -88.7639, -1.54922231191099),
(28035, '62969', 218, 18, 23646, 37.167, 0.648686523088733, -89.3537, -1.55951626383926),
(28036, '62970', 218, 18, 28136, 37.2106, 0.649447486642602, -89.0984, -1.55506043825892),
(28037, '62971', 218, 18, 28151, 37.8654, 0.660875902584661, -89.3844, -1.56005207991962),
(28038, '62972', 218, 18, 4832, 37.5341, 0.655093626772804, -88.7643, -1.549229293228),
(28039, '62973', 218, 18, 28217, 37.3097, 0.651177107931328, -89.0813, -1.55476198695682),
(28040, '62974', 218, 18, 5099, 37.7887, 0.659537235048381, -88.8654, -1.55099382110177),
(28041, '62975', 218, 18, 24061, 37.6414, 0.656966365060194, -89.3479, -1.55941503474264),
(28042, '62976', 218, 18, 11424, 37.215, 0.64952428112969, -89.2002, -1.55683718343745),
(28043, '62977', 218, 18, 185, 37.825, 0.660170789566855, -88.5441, -1.54538607821511),
(28044, '62979', 218, 18, 28416, 37.7998, 0.659730966595353, -88.2571, -1.54037698326189),
(28045, '62982', 218, 18, 28466, 37.4183, 0.653072535498994, -88.3532, -1.54205424467305),
(28046, '62983', 218, 18, 28479, 37.8813, 0.661153409935728, -89.1083, -1.55523322585486),
(28047, '62984', 218, 18, 28582, 37.7157, 0.658263144694425, -88.1856, -1.53912907284671),
(28048, '62985', 218, 18, 5863, 37.444, 0.653521085116757, -88.6408, -1.54707381160179),
(28049, '62987', 218, 18, 28704, 37.6381, 0.656908769194878, -88.7394, -1.54879470624426),
(28050, '62988', 218, 18, 28754, 37.2347, 0.649868110992333, -89.267, -1.55800306337778),
(28051, '62990', 218, 18, 12296, 37.1893, 0.649075731511927, -89.3925, -1.56019345158903),
(28052, '62991', 218, 18, 25586, 37.5542, 0.655444437952455, -88.8735, -1.55113519277118),
(28053, '62992', 218, 18, 28822, 37.2677, 0.650444069645491, -89.179, -1.55646717363602),
(28054, '62993', 218, 18, 6476, 37.2377, 0.649920470869892, -89.2684, -1.55802749798731),
(28055, '62994', 218, 18, 28857, 37.9074, 0.661608940870498, -89.32, -1.55892808788134),
(28056, '62995', 218, 18, 6557, 37.4162, 0.653035883584702, -88.8983, -1.55156803442568),
(28057, '62996', 218, 18, 28870, 37.1574, 0.648518971480541, -89.1762, -1.55641830441697),
(28058, '62997', 218, 18, 12873, 37.9856, 0.662973788345558, -89.5602, -1.56312036874463),
(28059, '62998', 218, 18, 29014, 37.5346, 0.655102353419064, -89.4442, -1.56109578681231),
(28060, '62999', 218, 18, 26314, 37.8982, 0.661448370579315, -89.0539, -1.55428376674178),
(28061, '63001', 218, 29, 53157, 38.4974, 0.671906383457265, -90.675, -1.58257729924586),
(28062, '63005', 218, 29, 1534, 38.634, 0.674290503215489, -90.6181, -1.58158420690147),
(28063, '63006', 218, 29, 1534, 38.663, 0.674796648698568, -90.5769, -1.58086513124965),
(28064, '63010', 218, 29, 26395, 38.4316, 0.670757956809453, -90.3952, -1.57769386799878),
(28065, '63011', 218, 29, 53325, 38.5988, 0.673676147318787, -90.5472, -1.58034676846181),
(28066, '63012', 218, 29, 53338, 38.3374, 0.669113856654074, -90.4375, -1.57843214227237),
(28067, '63013', 218, 29, 53378, 38.4194, 0.670545026640709, -91.1867, -1.59150814902831),
(28068, '63014', 218, 29, 7417, 38.6742, 0.674992125574791, -91.3351, -1.59409821763827),
(28069, '63015', 218, 29, 53908, 38.4083, 0.670351295093738, -90.7658, -1.58416205820667),
(28070, '63016', 218, 29, 1419, 38.353, 0.669386128017385, -90.6433, -1.58202402987298),
(28071, '63017', 218, 29, 1534, 38.6475, 0.674526122664509, -90.5446, -1.58030138990126),
(28072, '63019', 218, 29, 54290, 38.2277, 0.667199230464636, -90.3814, -1.577453012562),
(28073, '63020', 218, 29, 20496, 38.1322, 0.665532441028982, -90.5641, -1.5806417291054),
(28074, '63021', 218, 29, 53325, 38.5765, 0.673286938895593, -90.5282, -1.58001515590393),
(28075, '63022', 218, 29, 53325, 38.5955, 0.673618551453471, -90.5461, -1.58032756984004),
(28076, '63023', 218, 29, 54446, 38.3082, 0.668604220512492, -90.6801, -1.58266631103771),
(28077, '63024', 218, 29, 53325, 38.5952, 0.673613315465715, -90.5461, -1.58032756984004),
(28078, '63025', 218, 29, 2334, 38.5096, 0.672119313626008, -90.639, -1.58194898071514),
(28079, '63026', 218, 29, 2431, 38.4816, 0.67163062143545, -90.4571, -1.57877422680576),
(28080, '63028', 218, 29, 16011, 38.2011, 0.666734972883606, -90.4148, -1.57803595253217),
(28081, '63030', 218, 29, 16032, 38.1238, 0.665385833371814, -90.7631, -1.58411493431687),
(28082, '63031', 218, 29, 54791, 38.8047, 0.677269780248644, -90.3435, -1.5767915327755),
(28083, '63032', 218, 29, 54791, 38.8025, 0.6772313830051, -90.3106, -1.57621731945159),
(28084, '63033', 218, 29, 54791, 38.7947, 0.677095247323444, -90.2768, -1.57562739816442),
(28085, '63034', 218, 29, 54791, 38.8349, 0.677796869682746, -90.2922, -1.57589617886922),
(28086, '63036', 218, 29, 27218, 37.7614, 0.659060760162587, -90.4311, -1.57832044120024),
(28087, '63037', 218, 29, 2701, 38.3994, 0.670195960790311, -91.3306, -1.59401967782193),
(28088, '63038', 218, 29, 2739, 38.5827, 0.673395149309216, -90.6526, -1.58218634549341),
(28089, '63039', 218, 29, 55057, 38.4949, 0.671862750225965, -90.8154, -1.58502774151566),
(28090, '63040', 218, 29, 2894, 38.5764, 0.673285193566341, -90.6283, -1.58176223048518),
(28091, '63041', 218, 29, 55111, 38.2297, 0.667234137049676, -90.7952, -1.58467518500676),
(28092, '63042', 218, 29, 13906, 38.7774, 0.676793305362849, -90.3736, -1.57731687688035),
(28093, '63043', 218, 29, 42003, 38.7213, 0.67581417565248, -90.4423, -1.57851591807647),
(28094, '63044', 218, 29, 1132, 38.7505, 0.676323811794063, -90.4151, -1.57804118851993),
(28095, '63045', 218, 29, 54524, 38.7695, 0.676655424351942, -90.4651, -1.57891385314592),
(28096, '63047', 218, 29, 55245, 38.2005, 0.666724500908094, -90.4785, -1.57914772726569),
(28097, '63048', 218, 29, 55259, 38.2629, 0.667813586361338, -90.3859, -1.57753155237834),
(28098, '63049', 218, 29, 48092, 38.4701, 0.671429908571471, -90.5262, -1.57998024931889),
(28099, '63050', 218, 29, 3145, 38.263, 0.66781533169059, -90.567, -1.5806923436537),
(28100, '63051', 218, 29, 55386, 38.4112, 0.670401909642046, -90.5607, -1.58058238791083),
(28101, '63052', 218, 29, 22138, 38.3903, 0.670037135828379, -90.4218, -1.57815812557981),
(28102, '63053', 218, 29, 55681, 38.367, 0.669630474112664, -90.3656, -1.57717725054019),
(28103, '63055', 218, 29, 55747, 38.5211, 0.672320026489988, -90.833, -1.58533491946401),
(28104, '63056', 218, 29, 10047, 38.4455, 0.67100055757548, -91.2206, -1.59209981564474),
(28105, '63057', 218, 29, 0, 38.4266, 0.670670690346853, -90.5493, -1.5803834203761),
(28106, '63060', 218, 29, 55981, 38.3007, 0.668473320818592, -90.8314, -1.58530699419598),
(28107, '63061', 218, 29, 56015, 38.2694, 0.667927032762718, -90.8177, -1.58506788408845),
(28108, '63065', 218, 29, 56069, 38.2493, 0.667576221583067, -90.484, -1.57924372037455),
(28109, '63066', 218, 29, 56384, 38.2787, 0.668089348383153, -90.6515, -1.58216714687164),
(28110, '63068', 218, 29, 4528, 38.6001, 0.673698836599063, -91.22, -1.59208934366923),
(28111, '63069', 218, 29, 56766, 38.494, 0.671847042262697, -90.7644, -1.58413762359714),
(28112, '63070', 218, 29, 56866, 38.2804, 0.668119018980437, -90.4177, -1.57808656708048),
(28113, '63071', 218, 29, 11576, 38.1522, 0.665881506879381, -90.8326, -1.585327938147),
(28114, '63072', 218, 29, 11624, 38.3978, 0.670168035522279, -90.8278, -1.58524416234291),
(28115, '63073', 218, 29, 57331, 38.5777, 0.673307882846616, -90.77, -1.58423536203525),
(28116, '63074', 218, 29, 57332, 38.7257, 0.675890970139568, -90.3888, -1.57758216692665),
(28117, '63077', 218, 29, 5605, 38.3347, 0.66906673276427, -90.9748, -1.58780979634334),
(28118, '63079', 218, 29, 6052, 38.274, 0.66800731790831, -91.1044, -1.59007174305392),
(28119, '63080', 218, 29, 28723, 38.2195, 0.667056113465973, -91.1635, -1.59110323264185),
(28120, '63084', 218, 29, 455, 38.4465, 0.671018010868, -91.0101, -1.58842589756929),
(28121, '63087', 218, 29, 58028, 37.9329, 0.662053999829757, -90.4518, -1.57868172435541),
(28122, '63088', 218, 29, 25685, 38.5525, 0.672868059875114, -90.4906, -1.57935891210518),
(28123, '63089', 218, 29, 28870, 38.4606, 0.671264102292531, -90.8779, -1.58611857229815),
(28124, '63090', 218, 29, 12671, 38.5465, 0.672763340119994, -91.0156, -1.58852189067815),
(28125, '63091', 218, 29, 5545, 38.3833, 0.669914962780739, -91.3904, -1.59506338471463),
(28126, '63099', 218, 29, 2431, 38.5357, 0.672574844560779, -90.4513, -1.57867299770915),
(28127, '63101', 218, 29, 24604, 38.6312, 0.674241633996433, -90.1921, -1.57414910428798),
(28128, '63102', 218, 29, 24604, 38.6328, 0.674269559264465, -90.1894, -1.57410198039817),
(28129, '63103', 218, 29, 24604, 38.6308, 0.674234652679426, -90.2153, -1.57455402067444),
(28130, '63104', 218, 29, 24604, 38.6129, 0.673922238743319, -90.216, -1.5745662379792),
(28131, '63105', 218, 29, 24604, 38.6449, 0.674480744103957, -90.3289, -1.57653671470471),
(28132, '63106', 218, 29, 24604, 38.644, 0.674465036140689, -90.2056, -1.574384723737),
(28133, '63107', 218, 29, 24604, 38.6631, 0.67479839402782, -90.2103, -1.57446675421184),
(28134, '63108', 218, 29, 24604, 38.646, 0.674499942725729, -90.2525, -1.57520328315618),
(28135, '63109', 218, 29, 24604, 38.5854, 0.67344227319902, -90.2942, -1.57593108545426),
(28136, '63110', 218, 29, 24604, 38.622, 0.67408106370525, -90.2606, -1.57534465482559),
(28137, '63111', 218, 29, 24604, 38.5592, 0.672984996934997, -90.252, -1.57519455650992),
(28138, '63112', 218, 29, 24604, 38.6624, 0.674786176723056, -90.2829, -1.57573386324879),
(28139, '63113', 218, 29, 24604, 38.6573, 0.674697164931204, -90.2466, -1.57510030873031),
(28140, '63114', 218, 29, 24604, 38.7036, 0.675505252374877, -90.3656, -1.57717725054019),
(28141, '63115', 218, 29, 24604, 38.6762, 0.675027032159831, -90.2403, -1.57499035298744),
(28142, '63116', 218, 29, 24604, 38.5798, 0.673344534760908, -90.2648, -1.57541795865418),
(28143, '63117', 218, 29, 24604, 38.63, 0.67422069004541, -90.3311, -1.57657511194825),
(28144, '63118', 218, 29, 24604, 38.5936, 0.673585390197684, -90.2256, -1.5747337895874),
(28145, '63119', 218, 29, 24604, 38.5889, 0.67350335972284, -90.3509, -1.57692068714014),
(28146, '63120', 218, 29, 24604, 38.6901, 0.675269632925858, -90.2597, -1.57532894686233),
(28147, '63121', 218, 29, 24604, 38.706, 0.675547140276925, -90.2996, -1.57602533323387),
(28148, '63122', 218, 29, 24604, 38.5837, 0.673412602601736, -90.4162, -1.5780603871417),
(28149, '63123', 218, 29, 24604, 38.5498, 0.67282093598531, -90.326, -1.5764861001564),
(28150, '63124', 218, 29, 24604, 38.6425, 0.674438856201909, -90.3776, -1.57738669005043),
(28151, '63125', 218, 29, 24604, 38.5221, 0.672337479782508, -90.2975, -1.57598868131958),
(28152, '63126', 218, 29, 24604, 38.5515, 0.672850606582594, -90.379, -1.57741112465996),
(28153, '63127', 218, 29, 24604, 38.5399, 0.672648148389363, -90.4059, -1.57788061822874),
(28154, '63128', 218, 29, 24604, 38.4824, 0.671644584069466, -90.3847, -1.57751060842732),
(28155, '63129', 218, 29, 24604, 38.4627, 0.671300754206823, -90.3327, -1.57660303721628),
(28156, '63130', 218, 29, 24604, 38.662, 0.674779195406048, -90.3234, -1.57644072159585),
(28157, '63131', 218, 29, 24604, 38.6174, 0.674000778559658, -90.4438, -1.57854209801525),
(28158, '63132', 218, 29, 24604, 38.6745, 0.674997361562547, -90.3746, -1.57733433017287),
(28159, '63133', 218, 29, 24604, 38.678, 0.675058448086367, -90.3036, -1.57609514640395),
(28160, '63134', 218, 29, 24604, 38.7391, 0.676124844259335, -90.3402, -1.57673393691018),
(28161, '63135', 218, 29, 24604, 38.7472, 0.676266215928747, -90.3021, -1.57606896646517),
(28162, '63136', 218, 29, 24604, 38.7423, 0.676180694795399, -90.2591, -1.57531847488681),
(28163, '63137', 218, 29, 24604, 38.7485, 0.676288905209023, -90.2183, -1.574606380552),
(28164, '63138', 218, 29, 24604, 38.789, 0.67699576355608, -90.2109, -1.57447722618735),
(28165, '63139', 218, 29, 24604, 38.6119, 0.673904785450798, -90.291, -1.5758752349182),
(28166, '63140', 218, 29, 24604, 38.738, 0.676105645637563, -90.3265, -1.57649482680266),
(28167, '63141', 218, 29, 24604, 38.6642, 0.674817592649592, -90.4559, -1.57875328285474),
(28168, '63143', 218, 29, 24604, 38.7432, 0.676196402758667, -90.3623, -1.57711965467487),
(28169, '63144', 218, 29, 24604, 38.6194, 0.674035685144698, -90.3486, -1.57688054456735),
(28170, '63145', 218, 29, 24604, 38.7471, 0.676264470599495, -90.3628, -1.57712838132113),
(28171, '63146', 218, 29, 24604, 38.6947, 0.67534991807145, -90.4566, -1.5787655001595),
(28172, '63147', 218, 29, 24604, 38.6964, 0.675379588668734, -90.2204, -1.57464303246629),
(28173, '63150', 218, 29, 24604, 38.632, 0.674255596630449, -90.193, -1.57416481225125),
(28174, '63151', 218, 29, 24604, 38.4688, 0.671407219291195, -90.3049, -1.57611783568423),
(28175, '63155', 218, 29, 24604, 38.63, 0.67422069004541, -90.2159, -1.57456449264995),
(28176, '63156', 218, 29, 24604, 38.6365, 0.674334136446789, -90.2441, -1.57505667549901),
(28177, '63157', 218, 29, 24604, 38.6131, 0.673925729401822, -90.2151, -1.57455053001594),
(28178, '63158', 218, 29, 24604, 38.6043, 0.673772140427647, -90.2229, -1.57468666569759),
(28179, '63160', 218, 29, 24604, 38.635, 0.674307956508009, -90.1871, -1.57406183782538),
(28180, '63163', 218, 29, 24604, 38.5996, 0.673690109952803, -90.2422, -1.57502351424323),
(28181, '63164', 218, 29, 24604, 38.6352, 0.674311447166513, -90.1877, -1.57407230980089),
(28182, '63166', 218, 29, 24604, 38.6302, 0.674224180703914, -90.2173, -1.57458892725948),
(28183, '63167', 218, 29, 24604, 38.6589, 0.674725090199236, -90.4559, -1.57875328285474),
(28184, '63169', 218, 29, 24604, 38.6293, 0.674208472740646, -90.1924, -1.57415434027573),
(28185, '63171', 218, 29, 24604, 38.5965, 0.673636004745991, -90.3266, -1.57649657213191),
(28186, '63177', 218, 29, 24604, 38.6296, 0.674213708728402, -90.2167, -1.57457845528397),
(28187, '63178', 218, 29, 24604, 38.6306, 0.674231162020921, -90.2163, -1.57457147396696),
(28188, '63179', 218, 29, 24604, 38.6307, 0.674232907350173, -90.2168, -1.57458020061322),
(28189, '63180', 218, 29, 24604, 38.6293, 0.674208472740646, -90.2041, -1.57435854379822),
(28190, '63182', 218, 29, 24604, 38.6295, 0.67421196339915, -90.2045, -1.57436552511522),
(28191, '63188', 218, 29, 24604, 38.6298, 0.674217199386906, -90.1968, -1.57423113476282),
(28192, '63190', 218, 29, 24604, 38.6272, 0.674171820826354, -90.1974, -1.57424160673833),
(28193, '63195', 218, 29, 24604, 38.652, 0.674604662480848, -90.3404, -1.57673742756869),
(28194, '63196', 218, 29, 24604, 38.6289, 0.674201491423638, -90.2037, -1.57435156248121),
(28195, '63197', 218, 29, 24604, 38.6296, 0.674213708728402, -90.2038, -1.57435330781046),
(28196, '63198', 218, 29, 24604, 38.6591, 0.67472858085774, -90.4555, -1.57874630153773),
(28197, '63199', 218, 29, 24604, 38.6441, 0.674466781469941, -90.3284, -1.57652798805845),
(28198, '63301', 218, 29, 11748, 38.7989, 0.677168551152028, -90.5151, -1.57978651777192),
(28199, '63302', 218, 29, 11748, 38.7819, 0.676871845179189, -90.4864, -1.5792856082766),
(28200, '63303', 218, 29, 11748, 38.7551, 0.676404096939654, -90.5625, -1.58061380383736),
(28201, '63304', 218, 29, 11748, 38.7349, 0.676051540430752, -90.6229, -1.58166798270557),
(28202, '63330', 218, 29, 53191, 39.2563, 0.68515168715065, -90.8041, -1.58483051931018),
(28203, '63332', 218, 29, 7193, 38.5974, 0.673651712709259, -90.8819, -1.58618838546823),
(28204, '63333', 218, 29, 53413, 39.0001, 0.680680153607041, -91.337, -1.59413137889406),
(28205, '63334', 218, 29, 15294, 39.3406, 0.686622999710081, -91.1996, -1.59173329650182),
(28206, '63336', 218, 29, 848, 39.3677, 0.687095983937372, -90.9056, -1.58660202850096),
(28207, '63338', 218, 29, 54221, 38.7468, 0.676259234611739, -90.6543, -1.5822160160907),
(28208, '63339', 218, 29, 477, 39.3434, 0.686671868929137, -91.3412, -1.59420468272264),
(28209, '63341', 218, 29, 35545, 38.6635, 0.674805375344828, -90.8184, -1.58508010139322),
(28210, '63342', 218, 29, 54515, 38.597, 0.673644731392251, -91.0025, -1.58829325254614),
(28211, '63343', 218, 29, 54620, 39.1675, 0.683601834774879, -90.7872, -1.5845355586666),
(28212, '63344', 218, 29, 35780, 39.2525, 0.685085364639074, -91.0062, -1.58835782972846),
(28213, '63345', 218, 29, 54722, 39.2755, 0.685486790367033, -91.5757, -1.59829747981857),
(28214, '63346', 218, 29, 0, 38.8545, 0.678138954216137, -90.8652, -1.58589691548315),
(28215, '63347', 218, 29, 2510, 39.0649, 0.681811126962333, -90.7415, -1.58373794319843),
(28216, '63348', 218, 29, 54812, 38.787, 0.676960856971041, -90.9362, -1.58713609925207),
(28217, '63349', 218, 29, 55213, 38.9727, 0.680201933391994, -91.1384, -1.5906651549996),
(28218, '63350', 218, 29, 55287, 38.9016, 0.678961004293826, -91.3717, -1.5947370081445),
(28219, '63351', 218, 29, 36645, 38.9096, 0.679100630633986, -91.2974, -1.59344022851027),
(28220, '63352', 218, 29, 55753, 39.2403, 0.684872434470331, -91.6425, -1.5994633597589),
(28221, '63353', 218, 29, 41880, 39.4453, 0.688450359436919, -91.0545, -1.58920082375718),
(28222, '63357', 218, 29, 56110, 38.6529, 0.674620370444116, -91.0693, -1.58945913248647),
(28223, '63359', 218, 29, 14224, 39.0951, 0.682338216396435, -91.3648, -1.59461658042612),
(28224, '63361', 218, 29, 56347, 38.9781, 0.680296181171602, -91.5049, -1.59706178670816),
(28225, '63362', 218, 29, 56389, 38.9352, 0.679547434922496, -90.9288, -1.58700694488742),
(28226, '63363', 218, 29, 56485, 38.9083, 0.67907794135371, -91.4476, -1.59606171304677),
(28227, '63365', 218, 29, 56508, 38.7102, 0.675620444105509, -90.8794, -1.58614475223693),
(28228, '63366', 218, 29, 28088, 38.8372, 0.677837012255542, -90.7222, -1.5834010946528),
(28229, '63367', 218, 29, 55771, 38.7942, 0.677086520677184, -90.7843, -1.58448494411829),
(28230, '63369', 218, 29, 56668, 38.9435, 0.679692297250412, -90.7659, -1.58416380353592),
(28231, '63370', 218, 29, 4784, 39.0951, 0.682338216396435, -91.2137, -1.59197938792635),
(28232, '63373', 218, 29, 56995, 38.9269, 0.679402572594581, -90.3655, -1.57717550521094),
(28233, '63376', 218, 29, 57372, 38.7804, 0.676845665240409, -90.6224, -1.58165925605931),
(28234, '63377', 218, 29, 11942, 39.1406, 0.683132341206093, -91.0631, -1.58935092207285),
(28235, '63378', 218, 29, 57938, 38.6426, 0.674440601531161, -91.1882, -1.59153432896709),
(28236, '63379', 218, 29, 199, 38.9794, 0.680318870451878, -90.9761, -1.58783248562361),
(28237, '63381', 218, 29, 57947, 38.966, 0.680084996332111, -91.2103, -1.59192004673178),
(28238, '63382', 218, 29, 28848, 39.3068, 0.686033078422907, -91.4892, -1.5967877700156),
(28239, '63383', 218, 29, 6633, 38.8057, 0.677287233541164, -91.1647, -1.59112417659287),
(28240, '63384', 218, 29, 34380, 39.0737, 0.681964715936508, -91.5673, -1.5981508721614),
(28241, '63385', 218, 29, 58195, 38.7977, 0.677147607201004, -90.8595, -1.58579743171579),
(28242, '63386', 218, 29, 58198, 38.8674, 0.678364101689644, -90.2935, -1.5759188681495),
(28243, '63387', 218, 29, 6794, 39.1853, 0.683912503381734, -91.0161, -1.58853061732441),
(28244, '63388', 218, 29, 6831, 38.8363, 0.677821304292274, -92.0043, -1.60577796099262),
(28245, '63389', 218, 29, 6882, 38.9952, 0.680594632473693, -90.7618, -1.58409224503659),
(28246, '63390', 218, 29, 58369, 38.8075, 0.677318649467699, -91.037, -1.58889539113808),
(28247, '63401', 218, 29, 55163, 39.7066, 0.69301090477238, -91.3802, -1.59488536113092),
(28248, '63430', 218, 29, 34524, 40.3573, 0.704367762215108, -91.459, -1.59626068058149),
(28249, '63431', 218, 29, 39100, 39.7358, 0.693520540913963, -92.3477, -1.61177142164397),
(28250, '63432', 218, 29, 139013, 40.5034, 0.706917688252271, -92.002, -1.60573781841982),
(28251, '63433', 218, 29, 18929, 39.52, 0.689754120388159, -91.1596, -1.59103516480102),
(28252, '63434', 218, 29, 220, 39.9072, 0.696512035251881, -92.0382, -1.60636962760905),
(28253, '63435', 218, 29, 19763, 40.1299, 0.700398883496072, -91.5285, -1.59747368441163),
(28254, '63436', 218, 29, 1440, 39.509, 0.68956213417044, -91.5295, -1.59749113770415),
(28255, '63437', 218, 29, 1592, 39.7384, 0.693565919474515, -92.2628, -1.61028963710902),
(28256, '63438', 218, 29, 8632, 39.9595, 0.697424842450674, -91.6759, -1.60004629972907),
(28257, '63439', 218, 29, 40811, 39.8586, 0.695663805235412, -91.8894, -1.60377257768208),
(28258, '63440', 218, 29, 2347, 40.0077, 0.698266091150135, -91.7139, -1.60070952484483),
(28259, '63441', 218, 29, 13800, 39.489, 0.689213068320041, -91.2796, -1.59312955990342),
(28260, '63442', 218, 29, 94574, 40.5032, 0.706914197593767, -92.0017, -1.60573258243207),
(28261, '63443', 218, 29, 32814, 39.6674, 0.692326735705599, -91.8597, -1.60325421489424),
(28262, '63445', 218, 29, 139249, 40.4236, 0.70552491550918, -91.7224, -1.60085787783125),
(28263, '63446', 218, 29, 95347, 40.1253, 0.700318598350481, -92.0039, -1.60577097967561),
(28264, '63447', 218, 29, 16750, 40.1034, 0.699936371244294, -91.9113, -1.60415480478826),
(28265, '63448', 218, 29, 3584, 40.0402, 0.698833323157034, -91.5022, -1.59701466281836),
(28266, '63450', 218, 29, 55856, 39.7199, 0.693243033562896, -92.1468, -1.60826505517671),
(28267, '63451', 218, 29, 3733, 39.9104, 0.696567885787945, -92.2053, -1.60928607278913),
(28268, '63452', 218, 29, 36868, 40.0847, 0.699609994674171, -91.813, -1.60243914613355),
(28269, '63453', 218, 29, 33155, 40.5102, 0.707036370641407, -91.8893, -1.60377083235283),
(28270, '63454', 218, 29, 30467, 39.9396, 0.697077521929527, -91.604, -1.59879140799689),
(28271, '63456', 218, 29, 27930, 39.6515, 0.692049228354532, -91.7332, -1.60104637339046),
(28272, '63457', 218, 29, 588, 40.1187, 0.700203406619849, -91.7121, -1.60067810891829),
(28273, '63458', 218, 29, 10792, 39.9939, 0.69802523571336, -92.0071, -1.60582683021167),
(28274, '63459', 218, 29, 4547, 39.5868, 0.690920000328491, -91.3983, -1.59520126572553),
(28275, '63460', 218, 29, 139372, 40.0395, 0.69882110585227, -92.2599, -1.61023902256072),
(28276, '63461', 218, 29, 4846, 39.7973, 0.694593918403939, -91.5241, -1.59739688992454),
(28277, '63462', 218, 29, 11148, 39.4291, 0.688167616098096, -91.6699, -1.59994157997395),
(28278, '63463', 218, 29, 4983, 39.8359, 0.695267615495209, -91.7664, -1.60162582270212),
(28279, '63464', 218, 29, 5154, 39.9956, 0.698054906310644, -92.1183, -1.60776763633989),
(28280, '63465', 218, 29, 68172, 40.4868, 0.70662796359644, -91.6171, -1.5990200461289),
(28281, '63466', 218, 29, 137947, 40.3169, 0.703662649197302, -91.6647, -1.59985082285285),
(28282, '63467', 218, 29, 57434, 39.5354, 0.690022901092966, -91.4389, -1.59590986940184),
(28283, '63468', 218, 29, 57520, 39.692, 0.692756086701589, -92.0388, -1.60638009958456),
(28284, '63469', 218, 29, 11899, 39.8206, 0.695000580119654, -92.0689, -1.60690544368941),
(28285, '63471', 218, 29, 6252, 39.9048, 0.696470147349833, -91.512, -1.59718570508505),
(28286, '63472', 218, 29, 38772, 40.3964, 0.705050185952637, -91.5821, -1.5984091808907),
(28287, '63473', 218, 29, 6834, 40.2041, 0.701693917801052, -91.866, -1.60336417063711),
(28288, '63474', 218, 29, 139543, 40.335, 0.703978553791913, -91.8928, -1.60383191887665),
(28289, '63501', 218, 29, 27637, 40.1957, 0.701547310143885, -92.5807, -1.61583803880111),
(28290, '63530', 218, 29, 7187, 39.9268, 0.696854119785272, -92.4516, -1.61358481873679),
(28291, '63531', 218, 29, 126824, 40.2595, 0.702660830206657, -92.2631, -1.61029487309678),
(28292, '63532', 218, 29, 34801, 39.7493, 0.693756160362982, -92.564, -1.61554656881603),
(28293, '63533', 218, 29, 92800, 40.2184, 0.701943499884087, -92.4328, -1.61325669683741),
(28294, '63534', 218, 29, 53800, 39.7395, 0.693585118096287, -92.6452, -1.61696377616865),
(28295, '63535', 218, 29, 139093, 40.5699, 0.708078332204848, -92.6205, -1.61653267984341),
(28296, '63536', 218, 29, 2096, 40.4724, 0.706376636184153, -92.4116, -1.61288668703599),
(28297, '63537', 218, 29, 113131, 40.1682, 0.701067344599586, -92.1722, -1.60870836880672),
(28298, '63538', 218, 29, 32348, 39.9329, 0.696960584869644, -92.6506, -1.61705802394826),
(28299, '63539', 218, 29, 8784, 39.9335, 0.696971056845156, -92.7747, -1.61922397754998),
(28300, '63540', 218, 29, 9098, 40.0811, 0.699547162821099, -92.43, -1.61320782761836),
(28301, '63541', 218, 29, 2749, 40.5076, 0.706990992080855, -92.6186, -1.61649951858762),
(28302, '63543', 218, 29, 139180, 40.3524, 0.70428224108176, -92.0041, -1.60577447033411),
(28303, '63544', 218, 29, 27324, 40.3119, 0.703575382734702, -92.8799, -1.62106006392308),
(28304, '63545', 218, 29, 139192, 40.2646, 0.702749841998509, -92.9521, -1.62232019164302),
(28305, '63546', 218, 29, 13859, 40.3437, 0.704130397436836, -92.5373, -1.61508056590575),
(28306, '63547', 218, 29, 139225, 40.1473, 0.700702570785919, -92.3026, -1.61098427815132),
(28307, '63548', 218, 29, 16841, 40.5337, 0.707446523015626, -92.5168, -1.61472277340909),
(28308, '63549', 218, 29, 48763, 40.0244, 0.698557561135218, -92.4916, -1.61428295043759),
(28309, '63551', 218, 29, 30358, 40.5254, 0.70730166068771, -92.738, -1.6185834417145),
(28310, '63552', 218, 29, 3937, 39.7411, 0.693613043364319, -92.47, -1.61390595931916),
(28311, '63555', 218, 29, 4163, 40.4594, 0.706149743381394, -92.1704, -1.60867695288018),
(28312, '63556', 218, 29, 23084, 40.202, 0.70165726588676, -93.1249, -1.62533612059047),
(28313, '63557', 218, 29, 30620, 39.7608, 0.693956873226961, -93.119, -1.6252331461646),
(28314, '63558', 218, 29, 33412, 39.7569, 0.693888805386134, -92.7689, -1.61912274845337),
(28315, '63559', 218, 29, 139371, 40.2945, 0.703271695444855, -92.7489, -1.61877368260297),
(28316, '63560', 218, 29, 42644, 40.3449, 0.70415134138786, -93.1248, -1.62533437526122),
(28317, '63561', 218, 29, 97278, 40.4221, 0.7054987355704, -92.5702, -1.61565477922965),
(28318, '63563', 218, 29, 5590, 40.3473, 0.704193229289908, -92.1081, -1.60758961275619),
(28319, '63565', 218, 29, 25657, 40.4848, 0.7065930570114, -93.0069, -1.62327663207311),
(28320, '63566', 218, 29, 139537, 40.0421, 0.698866484412821, -92.9312, -1.62195541782935),
(28321, '63567', 218, 29, 31567, 40.424, 0.705531896826188, -92.768, -1.6191070404901),
(28322, '63601', 218, 29, 37588, 37.8541, 0.660678680379186, -90.5177, -1.57983189633247),
(28323, '63620', 218, 29, 26382, 37.4267, 0.653219143156162, -90.6561, -1.58224743201723),
(28324, '63621', 218, 29, 7137, 37.5844, 0.655971527386557, -90.6284, -1.58176397581443),
(28325, '63622', 218, 29, 53397, 37.7864, 0.659497092475585, -90.8455, -1.58555308562051),
(28326, '63623', 218, 29, 15180, 37.6719, 0.657498690482052, -90.8575, -1.58576252513075),
(28327, '63624', 218, 29, 7498, 37.7689, 0.659191659856486, -90.6245, -1.5816959079736),
(28328, '63625', 218, 29, 821, 37.5494, 0.655360662148359, -90.9843, -1.58797560262228),
(28329, '63626', 218, 29, 7523, 38.0713, 0.664469535514517, -90.7096, -1.58318118316705),
(28330, '63627', 218, 29, 53533, 38.0392, 0.663909284824627, -90.2803, -1.57568848468824),
(28331, '63628', 218, 29, 53565, 37.915, 0.66174158589365, -90.5899, -1.58109202405241),
(28332, '63629', 218, 29, 15378, 37.5098, 0.654669511764569, -91.1876, -1.59152385699158),
(28333, '63630', 218, 29, 53786, 38.056, 0.664202500138962, -90.6984, -1.58298570629083),
(28334, '63631', 218, 29, 1296, 37.7739, 0.659278926319086, -90.8018, -1.58479037673739),
(28335, '63632', 218, 29, 26723, 37.2994, 0.650997339018373, -90.2693, -1.57549649847052),
(28336, '63633', 218, 29, 1459, 37.4419, 0.653484433202465, -90.9959, -1.58817806081551),
(28337, '63636', 218, 29, 8494, 37.3075, 0.651138710687785, -90.6128, -1.58149170445112),
(28338, '63637', 218, 29, 46618, 37.7439, 0.658755327543488, -90.4982, -1.57949155712833),
(28339, '63638', 218, 29, 35744, 37.2232, 0.649667398128353, -90.9717, -1.58775569113653),
(28340, '63640', 218, 29, 8849, 37.782, 0.659420297988498, -90.4214, -1.5781511442628),
(28341, '63645', 218, 29, 35990, 37.5581, 0.655512505793282, -90.2938, -1.57592410413726),
(28342, '63646', 218, 29, 2753, 37.4867, 0.654266340707358, -90.6909, -1.58285480659693),
(28343, '63648', 218, 29, 3364, 37.8201, 0.660085268433507, -90.7113, -1.58321085376433),
(28344, '63650', 218, 29, 9671, 37.6001, 0.65624554407912, -90.6278, -1.58175350383892),
(28345, '63651', 218, 29, 36746, 37.6756, 0.657563267664376, -90.3672, -1.57720517580822),
(28346, '63653', 218, 29, 55832, 37.8635, 0.660842741328873, -90.5897, -1.58108853339391),
(28347, '63654', 218, 29, 10053, 37.4781, 0.654116242391687, -90.8332, -1.58533841012251),
(28348, '63655', 218, 29, 56101, 37.4065, 0.652866586647259, -90.1986, -1.57426255068936),
(28349, '63656', 218, 29, 0, 37.6944, 0.657891389563751, -90.6842, -1.58273786953704),
(28350, '63660', 218, 29, 56289, 37.9379, 0.662141266292357, -90.7396, -1.58370478194265),
(28351, '63661', 218, 29, 56509, 37.9082, 0.661622903504514, -90.1977, -1.57424684272609),
(28352, '63662', 218, 29, 4902, 37.4157, 0.653027156938442, -90.0652, -1.5719342814672),
(28353, '63663', 218, 29, 30836, 37.623, 0.656645224477827, -90.6398, -1.58196294334916),
(28354, '63664', 218, 29, 57008, 37.9398, 0.662174427548145, -90.7832, -1.58446574549652),
(28355, '63665', 218, 29, 57124, 37.3159, 0.651285318344952, -90.9171, -1.58680274136494),
(28356, '63666', 218, 29, 5360, 37.2426, 0.65000599200324, -90.9524, -1.58741884259089),
(28357, '63670', 218, 29, 57376, 37.9773, 0.662828926017643, -90.0487, -1.57164630214062),
(28358, '63673', 218, 29, 38069, 37.8195, 0.660074796457995, -90.0054, -1.5708905745745),
(28359, '63674', 218, 29, 57896, 38.0192, 0.663560218974228, -90.6528, -1.58218983615192),
(28360, '63675', 218, 29, 6585, 37.3051, 0.651096822785737, -90.7112, -1.58320910843508),
(28361, '63701', 218, 29, 53848, 37.3163, 0.65129229966196, -89.5426, -1.56281319079627),
(28362, '63702', 218, 29, 53848, 37.3108, 0.6511963065531, -89.6252, -1.56425483275842),
(28363, '63703', 218, 29, 53848, 37.2994, 0.650997339018373, -89.5391, -1.56275210427245),
(28364, '63705', 218, 29, 53848, 37.3087, 0.651159654638808, -89.5499, -1.56294059983167),
(28365, '63730', 218, 29, 7029, 37.0999, 0.647515407160644, -89.9192, -1.56938610075929),
(28366, '63732', 218, 29, 53180, 37.5364, 0.6551337693456, -89.5805, -1.56347467058278),
(28367, '63735', 218, 29, 7378, 36.9869, 0.645543185105891, -89.7802, -1.56696009309901),
(28368, '63736', 218, 29, 358, 36.9066, 0.644141685716539, -89.5615, -1.5631430580249),
(28369, '63737', 218, 29, 53635, 37.6614, 0.657315430910592, -89.6525, -1.56473130764422),
(28370, '63738', 218, 29, 19595, 37.6603, 0.657296232288821, -89.6315, -1.5643647885013),
(28371, '63739', 218, 29, 53748, 37.3568, 0.651999158009018, -89.8167, -1.56759713827599),
(28372, '63740', 218, 29, 53978, 37.1799, 0.64891167056224, -89.655, -1.56477494087552),
(28373, '63742', 218, 29, 1726, 37.1586, 0.648539915431565, -89.4423, -1.56106262555652),
(28374, '63743', 218, 29, 1947, 37.511, 0.654690455715593, -89.8269, -1.56777516185969),
(28375, '63744', 218, 29, 2022, 37.1895, 0.649079222170431, -89.7501, -1.56643474899416),
(28376, '63745', 218, 29, 54514, 37.2524, 0.650177034269936, -89.6599, -1.56486046200886),
(28377, '63746', 218, 29, 21043, 37.7027, 0.658036251891666, -89.6883, -1.56535613551643),
(28378, '63747', 218, 29, 54872, 37.5594, 0.655535195073558, -89.8431, -1.56805790519852),
(28379, '63748', 218, 29, 54879, 37.6779, 0.657603410237172, -89.6652, -1.56495296445922),
(28380, '63750', 218, 29, 54959, 37.1316, 0.648068676533526, -90.1995, -1.57427825865263),
(28381, '63751', 218, 29, 47473, 37.3284, 0.651503484501451, -90.0613, -1.57186621362637),
(28382, '63752', 218, 29, 659, 37.3106, 0.651192815894596, -89.679, -1.56519381989599),
(28383, '63753', 218, 29, 2818, 37.2468, 0.650079295831824, -90.1651, -1.57367786538994),
(28384, '63755', 218, 29, 3384, 37.3817, 0.652433744992764, -89.661, -1.56487966063064),
(28385, '63758', 218, 29, 9828, 37.1904, 0.649094930133699, -89.5495, -1.56293361851466),
(28386, '63760', 218, 29, 30320, 37.2646, 0.650389964438679, -89.9104, -1.56923251178511),
(28387, '63763', 218, 29, 56172, 37.0388, 0.646449010987676, -90.1836, -1.57400075130156),
(28388, '63764', 218, 29, 30423, 37.2978, 0.650969413750341, -89.9593, -1.57008597778933),
(28389, '63766', 218, 29, 27906, 37.447, 0.653573444994317, -89.8102, -1.56748369187461),
(28390, '63767', 218, 29, 42172, 37.0444, 0.646546749425787, -89.611, -1.56400699600464),
(28391, '63769', 218, 29, 4694, 37.5318, 0.655053484200008, -89.7561, -1.56653946874928),
(28392, '63770', 218, 29, 0, 37.5709, 0.655735907937538, -89.7034, -1.56561968023348),
(28393, '63771', 218, 29, 23682, 37.0866, 0.647283278370129, -89.6489, -1.56466847579114),
(28394, '63772', 218, 29, 56771, 37.0828, 0.647216955858553, -89.8246, -1.5677350192869),
(28395, '63774', 218, 29, 11143, 37.0947, 0.647424650039541, -89.7748, -1.56686584531941),
(28396, '63775', 218, 29, 4963, 37.7259, 0.658441168278129, -89.8681, -1.56849423751152),
(28397, '63776', 218, 29, 22946, 37.7134, 0.658223002121629, -89.8914, -1.56890089922723),
(28398, '63779', 218, 29, 5158, 37.5016, 0.654526394765906, -89.6383, -1.56448347089043),
(28399, '63780', 218, 29, 5691, 37.2185, 0.649585367653509, -89.5206, -1.56242921836084),
(28400, '63781', 218, 29, 57469, 37.5477, 0.655330991551075, -89.9276, -1.56953270841645),
(28401, '63782', 218, 29, 6120, 37.0696, 0.64698657239729, -90.0109, -1.57098656768336),
(28402, '63783', 218, 29, 6475, 37.6059, 0.656346773175736, -89.719, -1.56589195159679),
(28403, '63784', 218, 29, 58047, 36.9914, 0.64562172492223, -89.6862, -1.56531948360214),
(28404, '63785', 218, 29, 26032, 37.2741, 0.650555770717618, -89.7579, -1.56657088467582),
(28405, '63787', 218, 29, 58390, 37.1322, 0.648079148509038, -90.0843, -1.57226763935433),
(28406, '63801', 218, 29, 57559, 36.8872, 0.643803091841652, -89.5774, -1.56342056537597),
(28407, '63820', 218, 29, 53195, 36.834, 0.642874576679591, -89.3647, -1.55970825005698),
(28408, '63821', 218, 29, 53214, 36.0821, 0.629751446033846, -90.2042, -1.57436028912747),
(28409, '63822', 218, 29, 53444, 36.6705, 0.640020963352581, -89.969, -1.57025527472678),
(28410, '63823', 218, 29, 53449, 36.9096, 0.644194045594099, -89.4475, -1.56115338267763),
(28411, '63824', 218, 29, 31844, 37.0045, 0.645850363054242, -89.5264, -1.56253044745745),
(28412, '63825', 218, 29, 7544, 36.8876, 0.64381007315866, -89.9307, -1.56958681362326),
(28413, '63826', 218, 29, 53621, 36.1784, 0.631432198103517, -89.6721, -1.56507339217761),
(28414, '63827', 218, 29, 7646, 36.2706, 0.633041391673855, -89.9104, -1.56923251178511),
(28415, '63828', 218, 29, 53837, 36.7543, 0.641483549265752, -89.687, -1.56533344623615),
(28416, '63829', 218, 29, 15433, 36.0467, 0.62913359947864, -90.2909, -1.57587348958895),
(28417, '63830', 218, 29, 53884, 36.1839, 0.631528191212376, -89.661, -1.56487966063064),
(28418, '63833', 218, 29, 7956, 36.6927, 0.640408426446523, -89.7555, -1.56652899677377),
(28419, '63834', 218, 29, 8039, 36.9213, 0.644398249116582, -89.3478, -1.55941328941339),
(28420, '63837', 218, 29, 54064, 36.4512, 0.636193456302957, -89.9658, -1.57019942419071),
(28421, '63838', 218, 29, 54179, 36.4838, 0.636762433639107, -89.647, -1.56463531453536),
(28422, '63839', 218, 29, 54192, 36.047, 0.629138835466396, -89.8098, -1.5674767105576),
(28423, '63840', 218, 29, 54395, 36.1912, 0.631655600247772, -89.883, -1.56875429157006),
(28424, '63841', 218, 29, 2038, 36.7939, 0.642174699649542, -89.9605, -1.57010692174036),
(28425, '63845', 218, 29, 54541, 36.778, 0.641897192298475, -89.3845, -1.56005382524887),
(28426, '63846', 218, 29, 8781, 36.8027, 0.642328288623717, -89.8053, -1.56739817074126),
(28427, '63847', 218, 29, 2709, 36.4554, 0.636266760131541, -90.0084, -1.57094293445206),
(28428, '63848', 218, 29, 54948, 36.4508, 0.636186474985949, -89.9183, -1.56937039279602),
(28429, '63849', 218, 29, 54985, 36.1553, 0.631029027046306, -89.9326, -1.56961997487905),
(28430, '63850', 218, 29, 55059, 36.8226, 0.642675609144864, -89.7806, -1.56696707441602),
(28431, '63851', 218, 29, 41288, 36.2337, 0.632397365179869, -89.7516, -1.56646092893294),
(28432, '63852', 218, 29, 21985, 36.4057, 0.6353993314933, -90.0243, -1.57122044180313),
(28433, '63853', 218, 29, 9533, 36.056, 0.629295915099075, -89.8709, -1.56854310673057),
(28434, '63855', 218, 29, 55376, 36.0423, 0.629056804991552, -90.114, -1.57278600214217),
(28435, '63857', 218, 29, 55655, 36.242, 0.632542227507785, -90.0506, -1.57167946339641),
(28436, '63860', 218, 29, 22359, 36.671, 0.640029689998841, -89.5741, -1.56336296951065),
(28437, '63862', 218, 29, 55905, 36.5884, 0.638588048036693, -89.6136, -1.56405237456519),
(28438, '63863', 218, 29, 56057, 36.5589, 0.638073175907355, -89.9729, -1.57032334256761),
(28439, '63866', 218, 29, 49262, 36.5289, 0.637549577131757, -89.6068, -1.56393369217605),
(28440, '63867', 218, 29, 4038, 36.7584, 0.641555107765084, -89.5877, -1.56360033428892),
(28441, '63868', 218, 29, 56369, 36.846, 0.643084016189831, -89.6888, -1.56536486216269),
(28442, '63869', 218, 29, 56504, 36.5884, 0.638588048036693, -89.5496, -1.56293536384391),
(28443, '63870', 218, 29, 11084, 36.6122, 0.639003436398668, -89.8168, -1.56759888360524),
(28444, '63871', 218, 29, 56803, 36.266, 0.632961106528264, -89.8267, -1.56777167120119),
(28445, '63873', 218, 29, 56998, 36.4298, 0.63581995584303, -89.7007, -1.56557255634368),
(28446, '63874', 218, 29, 57191, 36.5523, 0.637957984176723, -89.8191, -1.56763902617804),
(28447, '63875', 218, 29, 50901, 36.0958, 0.629990556141369, -90.0133, -1.57102845558541),
(28448, '63876', 218, 29, 57479, 36.1344, 0.630664253232639, -90.161, -1.57360630689061),
(28449, '63877', 218, 29, 6066, 36.0852, 0.629805551240658, -89.829, -1.56781181377399),
(28450, '63878', 218, 29, 25320, 36.5075, 0.63717607667183, -89.8187, -1.56763204486103),
(28451, '63879', 218, 29, 12655, 36.3418, 0.634284066101275, -89.8194, -1.56764426216579),
(28452, '63880', 218, 29, 6787, 36.1302, 0.630590949404055, -90.1575, -1.57354522036679),
(28453, '63881', 218, 29, 58344, 36.7396, 0.641226985865709, -89.2099, -1.55700648037489),
(28454, '63882', 218, 29, 6967, 36.9166, 0.644316218641739, -89.2244, -1.55725955311643),
(28455, '63901', 218, 29, 56993, 36.7635, 0.641644119556935, -90.4041, -1.57784920230221),
(28456, '63902', 218, 29, 56993, 36.7559, 0.641511474533784, -90.3943, -1.57767816003551),
(28457, '63931', 218, 29, 7670, 36.6436, 0.639551469783794, -90.9616, -1.58757941288207),
(28458, '63932', 218, 29, 53677, 36.7045, 0.640614375298259, -90.237, -1.57493275712212),
(28459, '63933', 218, 29, 1317, 36.493, 0.636923003930291, -90.0723, -1.57205819984409),
(28460, '63934', 218, 29, 54120, 37.2333, 0.649843676382805, -90.3611, -1.57709871072385),
(28461, '63935', 218, 29, 8562, 36.6225, 0.639183205311623, -90.8208, -1.58512198929527),
(28462, '63936', 218, 29, 2116, 36.8182, 0.642598814657776, -90.1345, -1.57314379463883),
(28463, '63937', 218, 29, 54608, 36.9656, 0.645171429975216, -90.7493, -1.58387407888009),
(28464, '63938', 218, 29, 54694, 36.5111, 0.637238908524902, -90.2672, -1.57545984655623),
(28465, '63939', 218, 29, 35828, 36.6752, 0.640102993827424, -90.6447, -1.5820484644825),
(28466, '63940', 218, 29, 2452, 36.7833, 0.64198969474883, -90.2065, -1.57440043170026),
(28467, '63941', 218, 29, 2605, 36.8536, 0.643216661212982, -91.1234, -1.5904033556118),
(28468, '63942', 218, 29, 21359, 36.5632, 0.638148225065191, -91.0746, -1.58955163493683),
(28469, '63943', 218, 29, 16264, 36.8161, 0.642562162743484, -90.7655, -1.58415682221891),
(28470, '63944', 218, 29, 2868, 37.0921, 0.647379271478989, -90.4536, -1.57871314028194),
(28471, '63945', 218, 29, 55201, 36.6837, 0.640251346813844, -90.5746, -1.58082498867686),
(28472, '63947', 218, 29, 9518, 37.2314, 0.649810515127017, -90.2918, -1.57588919755222),
(28473, '63950', 218, 29, 112, 37.2463, 0.650070569185564, -90.4659, -1.57892781577994),
(28474, '63951', 218, 29, 49105, 37.1348, 0.64812452706959, -90.2497, -1.57515441393713),
(28475, '63952', 218, 29, 56253, 37.0458, 0.646571184035315, -90.6466, -1.58208162573829),
(28476, '63953', 218, 29, 10735, 36.5585, 0.638066194590347, -90.6293, -1.5817796837777),
(28477, '63954', 218, 29, 56465, 36.5697, 0.63826167146657, -90.4756, -1.57909711271738),
(28478, '63955', 218, 29, 56751, 36.5838, 0.638507762891101, -90.6882, -1.58280768270712),
(28479, '63956', 218, 29, 428, 37.2113, 0.649459703947366, -90.5716, -1.5807726287993),
(28480, '63957', 218, 29, 4996, 37.1573, 0.648517226151289, -90.694, -1.58290891180374),
(28481, '63960', 218, 29, 57067, 36.9513, 0.644921847892181, -90.158, -1.57355394701305),
(28482, '63961', 218, 29, 57079, 36.5688, 0.638245963503302, -90.2694, -1.57549824379977),
(28483, '63962', 218, 29, 57260, 36.8428, 0.643028165653767, -90.2803, -1.57568848468824),
(28484, '63963', 218, 29, 57548, 37.076, 0.647098273469418, -90.321, -1.5763988336938),
(28485, '63964', 218, 29, 57564, 37.2077, 0.649396872094294, -90.4208, -1.57814067228729),
(28486, '63965', 218, 29, 12525, 36.9131, 0.644255132117919, -91.0484, -1.58909435867281),
(28487, '63966', 218, 29, 58123, 36.9962, 0.645705500726326, -90.2722, -1.57554711301883),
(28488, '63967', 218, 29, 14865, 36.964, 0.645143504707184, -90.4899, -1.57934669480042),
(28489, '64001', 218, 29, 7066, 39.0948, 0.682332980408679, -93.5557, -1.63285499900806),
(28490, '64011', 218, 29, 53356, 39.0047, 0.680760438752632, -94.0668, -1.641775376815),
(28491, '64012', 218, 29, 19183, 38.808, 0.677327376113959, -94.5328, -1.6499086111293),
(28492, '64013', 218, 29, 1001, 39.0171, 0.68097685957988, -94.2816, -1.64552434404829),
(28493, '64014', 218, 29, 1001, 39.0157, 0.680952424970352, -94.2601, -1.64514909825911),
(28494, '64015', 218, 29, 1001, 39.0173, 0.680980350238384, -94.2828, -1.64554528799931),
(28495, '64016', 218, 29, 7751, 39.1247, 0.682854833855025, -94.2012, -1.64412109932968),
(28496, '64017', 218, 29, 1304, 39.1826, 0.68386537949193, -93.8798, -1.63851161111377),
(28497, '64018', 218, 29, 53820, 39.2986, 0.685889961424244, -94.7178, -1.65313747024549),
(28498, '64019', 218, 29, 32024, 38.7935, 0.67707430337242, -93.8745, -1.63841910866342),
(28499, '64020', 218, 29, 32136, 38.9847, 0.680411372902233, -93.5693, -1.63309236378633),
(28500, '64021', 218, 29, 54197, 39.1, 0.682423737529783, -93.6381, -1.6342931503117),
(28501, '64022', 218, 29, 8583, 39.1866, 0.68393519266201, -93.6647, -1.63475740789273),
(28502, '64024', 218, 29, 54686, 39.3413, 0.686635217014845, -94.234, -1.64469356732434),
(28503, '64028', 218, 29, 2417, 39.2834, 0.68562467137794, -94.8307, -1.65510794697099),
(28504, '64029', 218, 29, 55019, 39.0093, 0.680840723898224, -94.213, -1.64432704818142),
(28505, '64030', 218, 29, 534, 38.884, 0.678653826345475, -94.521, -1.64970266227756),
(28506, '64034', 218, 29, 2869, 38.858, 0.678200040739957, -94.3154, -1.64611426533546),
(28507, '64035', 218, 29, 9325, 39.2701, 0.685392542587425, -93.8321, -1.63767908906057),
(28508, '64036', 218, 29, 16406, 39.2144, 0.684420394194064, -93.9285, -1.63936158645949),
(28509, '64037', 218, 29, 55285, 39.074, 0.681969951924264, -93.7207, -1.63573479227385),
(28510, '64040', 218, 29, 27452, 38.7163, 0.675726909189881, -93.9887, -1.64041227466919),
(28511, '64048', 218, 29, 3208, 39.4284, 0.688155398793332, -94.3761, -1.64717368019142),
(28512, '64050', 218, 29, 3320, 39.0953, 0.682341707054939, -94.3976, -1.6475489259806),
(28513, '64051', 218, 29, 3320, 39.092, 0.682284111189623, -94.4188, -1.64791893578202),
(28514, '64052', 218, 29, 3320, 39.0739, 0.681968206595012, -94.447, -1.64841111863108),
(28515, '64053', 218, 29, 3320, 39.1058, 0.682524966626399, -94.463, -1.6486903713114),
(28516, '64054', 218, 29, 3320, 39.1076, 0.682556382552934, -94.4404, -1.64829592690045),
(28517, '64055', 218, 29, 3320, 39.0521, 0.681587724818078, -94.4015, -1.64761699382143),
(28518, '64056', 218, 29, 3320, 39.1159, 0.68270124488085, -94.3486, -1.64669371464712),
(28519, '64057', 218, 29, 3320, 39.07, 0.681900138754185, -94.3449, -1.6466291374648),
(28520, '64058', 218, 29, 3320, 39.1419, 0.683155030486369, -94.3523, -1.64675829182945),
(28521, '64060', 218, 29, 330, 39.3666, 0.6870767853156, -94.3601, -1.6468944275111);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(28522, '64061', 218, 29, 41617, 38.8437, 0.677950458656921, -94.117, -1.6426515320995),
(28523, '64062', 218, 29, 3699, 39.4378, 0.68831945974302, -94.2031, -1.64415426058547),
(28524, '64063', 218, 29, 55847, 38.9189, 0.679262946254421, -94.3597, -1.64688744619409),
(28525, '64064', 218, 29, 55847, 38.9838, 0.680395664938966, -94.3627, -1.64693980607165),
(28526, '64065', 218, 29, 55847, 38.9478, 0.679767346408248, -94.4074, -1.64771996824729),
(28527, '64066', 218, 29, 55869, 39.1361, 0.683053801389753, -94.1356, -1.64297616334037),
(28528, '64067', 218, 29, 3748, 39.182, 0.683854907516418, -93.876, -1.6384452886022),
(28529, '64068', 218, 29, 3751, 39.2404, 0.684874179799583, -94.4332, -1.64817026319431),
(28530, '64069', 218, 29, 3751, 39.2416, 0.684895123750607, -94.419, -1.64792242644053),
(28531, '64070', 218, 29, 55976, 38.8976, 0.678891191123746, -94.1608, -1.64341598631188),
(28532, '64071', 218, 29, 10374, 39.0442, 0.68144984380717, -93.8311, -1.63766163576805),
(28533, '64072', 218, 29, 56308, 39.2401, 0.684868943811827, -94.2903, -1.64567618769321),
(28534, '64073', 218, 29, 56387, 39.3145, 0.686167468775311, -94.2935, -1.64573203822927),
(28535, '64074', 218, 29, 4479, 39.1078, 0.682559873211438, -94.0635, -1.64171778094969),
(28536, '64075', 218, 29, 4662, 38.9974, 0.680633029717237, -94.144, -1.64312277099754),
(28537, '64076', 218, 29, 14343, 38.9962, 0.680612085766213, -93.9539, -1.6398049000895),
(28538, '64077', 218, 29, 56705, 39.2475, 0.684998098176475, -94.0429, -1.64135824312378),
(28539, '64078', 218, 29, 56829, 38.724, 0.675861299542284, -94.4567, -1.64858041556853),
(28540, '64079', 218, 29, 56930, 39.365, 0.687048860047568, -94.7738, -1.6541148546266),
(28541, '64080', 218, 29, 268, 38.791, 0.67703067014112, -94.2673, -1.64527476196525),
(28542, '64081', 218, 29, 55847, 38.9117, 0.679137282548278, -94.4066, -1.64770600561328),
(28543, '64082', 218, 29, 55847, 38.8583, 0.678205276727713, -94.402, -1.64762572046769),
(28544, '64083', 218, 29, 57108, 38.8034, 0.677247090968368, -94.4482, -1.64843206258211),
(28545, '64084', 218, 29, 42749, 39.4155, 0.687930251319825, -94.0139, -1.6408520976407),
(28546, '64085', 218, 29, 5381, 39.2787, 0.685542640903097, -93.9755, -1.64018189120793),
(28547, '64086', 218, 29, 55847, 38.9344, 0.67953347228848, -94.3361, -1.64647554849062),
(28548, '64087', 218, 29, 3751, 39.2462, 0.684975408896199, -94.4189, -1.64792068111127),
(28549, '64088', 218, 29, 24860, 39.1606, 0.683481407056491, -94.1883, -1.64389595185618),
(28550, '64089', 218, 29, 12002, 39.3929, 0.687535806908874, -94.5748, -1.65064164941513),
(28551, '64090', 218, 29, 28710, 38.7596, 0.676482636755994, -94.1664, -1.64351372474999),
(28552, '64092', 218, 29, 12596, 39.2221, 0.684554784546468, -94.7928, -1.65444646718448),
(28553, '64093', 218, 29, 28908, 38.7603, 0.676494854060758, -93.7339, -1.63596517573511),
(28554, '64096', 218, 29, 6664, 39.2071, 0.684292985158669, -93.5206, -1.63224238844061),
(28555, '64097', 218, 29, 902, 39.1328, 0.682996205524437, -93.9852, -1.64035118814537),
(28556, '64098', 218, 29, 6746, 39.4159, 0.687937232636833, -94.8992, -1.6563034975086),
(28557, '64101', 218, 29, 32892, 39.1026, 0.682469116090335, -94.5988, -1.65106052843561),
(28558, '64102', 218, 29, 32892, 39.0935, 0.682310291128403, -94.6017, -1.65111114298392),
(28559, '64105', 218, 29, 32892, 39.1005, 0.682432464176043, -94.5796, -1.65072542521923),
(28560, '64106', 218, 29, 32892, 39.1038, 0.682490060041359, -94.5727, -1.65060499750084),
(28561, '64108', 218, 29, 32892, 39.084, 0.682144484849464, -94.5846, -1.65081269168183),
(28562, '64109', 218, 29, 32892, 39.0666, 0.681840797559617, -94.5678, -1.65051947636749),
(28563, '64110', 218, 29, 32892, 39.0347, 0.681284037528231, -94.5722, -1.65059627085458),
(28564, '64111', 218, 29, 32892, 39.0557, 0.681650556671149, -94.5927, -1.65095406335124),
(28565, '64112', 218, 29, 32892, 39.0374, 0.681331161418034, -94.5938, -1.65097326197301),
(28566, '64113', 218, 29, 32892, 39.0129, 0.680903555751296, -94.5937, -1.65097151664376),
(28567, '64114', 218, 29, 32892, 38.9617, 0.680009947174275, -94.5966, -1.65102213119207),
(28568, '64116', 218, 29, 32892, 39.1572, 0.683422065861924, -94.5685, -1.65053169367226),
(28569, '64117', 218, 29, 32892, 39.1673, 0.683598344116375, -94.5265, -1.64979865538642),
(28570, '64118', 218, 29, 32892, 39.2143, 0.684418648864812, -94.5729, -1.65060848815935),
(28571, '64119', 218, 29, 32892, 39.1993, 0.684156849477013, -94.5199, -1.64968346365579),
(28572, '64120', 218, 29, 32892, 39.1239, 0.682840871221009, -94.5345, -1.64993828172658),
(28573, '64121', 218, 29, 32892, 39.1001, 0.682425482859035, -94.5784, -1.65070448126821),
(28574, '64123', 218, 29, 32892, 39.1135, 0.682659356978802, -94.5247, -1.64976723945988),
(28575, '64124', 218, 29, 32892, 39.1074, 0.68255289189443, -94.542, -1.65006918142048),
(28576, '64125', 218, 29, 32892, 39.1053, 0.682516239980139, -94.495, -1.64924887667204),
(28577, '64126', 218, 29, 32892, 39.0926, 0.682294583165135, -94.497, -1.64928378325708),
(28578, '64127', 218, 29, 32892, 39.0891, 0.682233496641316, -94.5372, -1.64998540561638),
(28579, '64128', 218, 29, 32892, 39.0672, 0.681851269535129, -94.5348, -1.64994351771434),
(28580, '64129', 218, 29, 32892, 39.0496, 0.681544091586778, -94.496, -1.64926632996456),
(28581, '64130', 218, 29, 32892, 39.0343, 0.681277056211223, -94.5434, -1.65009361603001),
(28582, '64131', 218, 29, 32892, 38.9699, 0.680153064172938, -94.5759, -1.65066084803691),
(28583, '64132', 218, 29, 32892, 38.9904, 0.680510856669597, -94.5477, -1.65016866518784),
(28584, '64133', 218, 29, 32892, 39.015, 0.680940207665588, -94.461, -1.64865546472636),
(28585, '64134', 218, 29, 32892, 38.9316, 0.679484603069424, -94.4962, -1.64926982062307),
(28586, '64136', 218, 29, 32892, 39.0177, 0.680987331555391, -94.4015, -1.64761699382143),
(28587, '64137', 218, 29, 32892, 38.9311, 0.679475876423164, -94.5385, -1.65000809489666),
(28588, '64138', 218, 29, 32892, 38.9698, 0.680151318843686, -94.4749, -1.64889806549239),
(28589, '64139', 218, 29, 32892, 38.962, 0.680015183162031, -94.4104, -1.64777232812485),
(28590, '64141', 218, 29, 32892, 39.0844, 0.682151466166472, -94.585, -1.65081967299884),
(28591, '64142', 218, 29, 32892, 39.1042, 0.682497041358367, -94.5802, -1.65073589719474),
(28592, '64144', 218, 29, 32892, 39.143, 0.68317422910814, -94.5709, -1.65057358157431),
(28593, '64145', 218, 29, 32892, 38.8946, 0.678838831246186, -94.5944, -1.65098373394852),
(28594, '64146', 218, 29, 32892, 38.8928, 0.678807415319651, -94.5737, -1.65062245079336),
(28595, '64147', 218, 29, 32892, 38.8522, 0.678098811643341, -94.5473, -1.65016168387083),
(28596, '64148', 218, 29, 32892, 39.0857, 0.682174155446748, -94.5819, -1.65076556779202),
(28597, '64149', 218, 29, 32892, 38.8591, 0.678219239361728, -94.4616, -1.64866593670188),
(28598, '64150', 218, 29, 5423, 39.1765, 0.683758914407558, -94.619, -1.65141308494451),
(28599, '64151', 218, 29, 32892, 39.2134, 0.684402940901544, -94.6328, -1.65165394038129),
(28600, '64152', 218, 29, 32892, 39.222, 0.684553039217216, -94.6974, -1.65278142307808),
(28601, '64153', 218, 29, 32892, 39.2737, 0.685455374440497, -94.6916, -1.65268019398146),
(28602, '64154', 218, 29, 32892, 39.2595, 0.685207537686714, -94.6364, -1.65171677223436),
(28603, '64155', 218, 29, 32892, 39.2732, 0.685446647794237, -94.5721, -1.65059452552533),
(28604, '64156', 218, 29, 32892, 39.2771, 0.685514715635065, -94.5264, -1.64979691005717),
(28605, '64157', 218, 29, 32892, 39.284, 0.685635143353452, -94.469, -1.64879509106652),
(28606, '64158', 218, 29, 32892, 39.2313, 0.684715354837651, -94.4711, -1.64883174298082),
(28607, '64160', 218, 29, 32892, 39.1557, 0.683395885923144, -94.4385, -1.64826276564466),
(28608, '64161', 218, 29, 32892, 39.1573, 0.683423811191176, -94.4524, -1.64850536641069),
(28609, '64163', 218, 29, 32892, 39.3364, 0.686549695881497, -94.7447, -1.65360696381427),
(28610, '64164', 218, 29, 32892, 39.327, 0.68638563493181, -94.6379, -1.65174295217314),
(28611, '64165', 218, 29, 32892, 39.3235, 0.68632454840799, -94.5664, -1.65049504175797),
(28612, '64166', 218, 29, 32892, 39.3135, 0.686150015482791, -94.516, -1.64961539581496),
(28613, '64167', 218, 29, 32892, 39.311, 0.686106382251491, -94.4797, -1.64898184129649),
(28614, '64168', 218, 29, 32892, 39.1675, 0.683601834774879, -94.6341, -1.65167662966157),
(28615, '64170', 218, 29, 32892, 38.9536, 0.679868575504863, -94.5491, -1.65019309979737),
(28616, '64171', 218, 29, 32892, 39.0548, 0.681634848707881, -94.5885, -1.65088075952266),
(28617, '64172', 218, 29, 32892, 39.0849, 0.682160192812732, -94.5845, -1.65081094635258),
(28618, '64173', 218, 29, 32892, 39.083, 0.682127031556944, -94.5867, -1.65084934359612),
(28619, '64179', 218, 29, 32892, 39.1228, 0.682821672599238, -94.5519, -1.65024196901643),
(28620, '64180', 218, 29, 32892, 39.1033, 0.682481333395099, -94.5825, -1.65077603976754),
(28621, '64183', 218, 29, 32892, 39.0997, 0.682418501542027, -94.5779, -1.65069575462195),
(28622, '64184', 218, 29, 32892, 39.106, 0.682528457284903, -94.5929, -1.65095755400974),
(28623, '64185', 218, 29, 32892, 39.1043, 0.682498786687619, -94.5774, -1.65068702797568),
(28624, '64187', 218, 29, 32892, 39.1, 0.682423737529783, -94.578, -1.6506974999512),
(28625, '64188', 218, 29, 32892, 39.2243, 0.684593181790012, -94.5852, -1.65082316365734),
(28626, '64189', 218, 29, 32892, 39.0997, 0.682418501542027, -94.5785, -1.65070622659746),
(28627, '64190', 218, 29, 32892, 39.1893, 0.683982316551814, -94.6827, -1.65252485967804),
(28628, '64191', 218, 29, 32892, 39.0848, 0.68215844748348, -94.5847, -1.65081443701108),
(28629, '64192', 218, 29, 32892, 38.9218, 0.679313560802729, -94.509, -1.64949322276732),
(28630, '64193', 218, 29, 32892, 39.2734, 0.685450138452741, -94.6709, -1.6523189108263),
(28631, '64194', 218, 29, 32892, 39.1023, 0.682463880102579, -94.5813, -1.65075509581651),
(28632, '64195', 218, 29, 32892, 39.3035, 0.685975482557591, -94.7193, -1.65316365018427),
(28633, '64196', 218, 29, 32892, 39.1001, 0.682425482859035, -94.5831, -1.65078651174305),
(28634, '64197', 218, 29, 32892, 38.9557, 0.679905227419155, -94.5677, -1.65051773103824),
(28635, '64198', 218, 29, 32892, 39.1034, 0.682483078724351, -94.5809, -1.6507481144995),
(28636, '64199', 218, 29, 32892, 39.1027, 0.682470861419587, -94.5826, -1.65077778509679),
(28637, '64401', 218, 29, 53132, 39.6604, 0.692204562657959, -94.6847, -1.65255976626308),
(28638, '64402', 218, 29, 18772, 40.2481, 0.70246186267193, -94.3292, -1.64635512077224),
(28639, '64420', 218, 29, 7060, 40.4851, 0.706598292999156, -94.2883, -1.64564128110817),
(28640, '64421', 218, 29, 53175, 39.9116, 0.696588829738969, -94.9253, -1.65675902844337),
(28641, '64422', 218, 29, 7091, 39.8899, 0.696210093291286, -94.5197, -1.64967997299728),
(28642, '64423', 218, 29, 29152, 40.36, 0.704414886104911, -94.8933, -1.65620052308274),
(28643, '64424', 218, 29, 7428, 40.2656, 0.702767295291029, -94.0339, -1.6412011634911),
(28644, '64426', 218, 29, 44908, 40.4723, 0.706374890854901, -93.9249, -1.63929875460642),
(28645, '64427', 218, 29, 139046, 40.1144, 0.700128357462013, -94.8207, -1.65493341404579),
(28646, '64428', 218, 29, 139061, 40.4352, 0.705727373702411, -95.0206, -1.65842232722052),
(28647, '64429', 218, 29, 806, 39.7391, 0.693578136779279, -94.2408, -1.64481224971347),
(28648, '64430', 218, 29, 26802, 39.8149, 0.69490109635229, -94.5245, -1.64976374880138),
(28649, '64431', 218, 29, 80354, 40.507, 0.706980520105343, -95.0316, -1.65861431343824),
(28650, '64432', 218, 29, 8151, 40.2705, 0.702852816424376, -94.6415, -1.65180578402621),
(28651, '64433', 218, 29, 93403, 40.2303, 0.702151194065075, -94.6738, -1.65236952537461),
(28652, '64434', 218, 29, 139100, 40.2737, 0.70290866696044, -94.7171, -1.65312525294072),
(28653, '64436', 218, 29, 54213, 39.8502, 0.695517197578244, -94.6831, -1.65253184099504),
(28654, '64437', 218, 29, 29568, 40.1551, 0.700838706467575, -95.3554, -1.6642656895562),
(28655, '64438', 218, 29, 1971, 40.1901, 0.701449571705773, -94.4125, -1.64780898003915),
(28656, '64439', 218, 29, 40029, 39.5269, 0.689874548106547, -94.7691, -1.65403282415176),
(28657, '64440', 218, 29, 54366, 39.5753, 0.690719287464512, -94.9375, -1.65697195861212),
(28658, '64441', 218, 29, 2033, 40.4279, 0.705599964667016, -94.2904, -1.64567793302246),
(28659, '64442', 218, 29, 86657, 40.5171, 0.707156798359795, -94.0261, -1.64106502780944),
(28660, '64443', 218, 29, 2193, 39.7635, 0.694003997116765, -94.6594, -1.65211819796232),
(28661, '64444', 218, 29, 32304, 39.5064, 0.689516755609888, -94.6331, -1.65165917636905),
(28662, '64445', 218, 29, 8744, 40.5158, 0.707134109079519, -95.13, -1.66033171742221),
(28663, '64446', 218, 29, 13733, 40.3396, 0.704058838937505, -95.3937, -1.66493415065971),
(28664, '64447', 218, 29, 32409, 39.9879, 0.697920515958241, -94.3453, -1.64663611878181),
(28665, '64448', 218, 29, 54732, 39.5857, 0.690900801706719, -94.798, -1.65453722430558),
(28666, '64449', 218, 29, 27166, 40.0032, 0.698187551333796, -94.9485, -1.65716394482984),
(28667, '64451', 218, 29, 16058, 39.986, 0.697887354702453, -95.2224, -1.66194440165105),
(28668, '64453', 218, 29, 9081, 40.3315, 0.703917467268093, -94.4201, -1.6479416250623),
(28669, '64454', 218, 29, 55012, 39.6117, 0.691354587312238, -94.5959, -1.6510099138873),
(28670, '64455', 218, 29, 2802, 40.2017, 0.701652029899004, -95.0417, -1.65879059169269),
(28671, '64456', 218, 29, 29924, 40.4835, 0.706570367731124, -94.4107, -1.64777756411261),
(28672, '64457', 218, 29, 16297, 40.1722, 0.701137157769666, -94.6765, -1.65241664926441),
(28673, '64458', 218, 29, 9378, 40.5231, 0.707261518114914, -94.1749, -1.64366207773641),
(28674, '64459', 218, 29, 3052, 39.9341, 0.696981528820668, -94.6905, -1.65266099535969),
(28675, '64461', 218, 29, 3235, 40.5388, 0.707535534807477, -94.8217, -1.65495086733831),
(28676, '64463', 218, 29, 22375, 40.0507, 0.699016582728493, -94.5194, -1.64967473700953),
(28677, '64465', 218, 29, 3680, 39.5464, 0.690214887310685, -94.346, -1.64664833608657),
(28678, '64466', 218, 29, 16989, 40.2013, 0.701645048581997, -95.0764, -1.65939622094314),
(28679, '64467', 218, 29, 27817, 40.3838, 0.704830274466886, -94.1576, -1.64336013577581),
(28680, '64468', 218, 29, 4028, 40.3469, 0.7041862479729, -94.8724, -1.65583574926907),
(28681, '64469', 218, 29, 4063, 39.8871, 0.69616122407223, -94.3604, -1.64689966349886),
(28682, '64470', 218, 29, 10620, 40.1361, 0.700507093909696, -95.2304, -1.66208402799121),
(28683, '64471', 218, 29, 117003, 40.2158, 0.701898121323536, -94.1591, -1.64338631571459),
(28684, '64473', 218, 29, 37541, 39.9928, 0.698006037091588, -95.142, -1.66054115693244),
(28685, '64474', 218, 29, 4807, 39.7902, 0.694470000027048, -94.2909, -1.64568665966872),
(28686, '64475', 218, 29, 4892, 40.4993, 0.706846129752939, -94.6838, -1.65254405829981),
(28687, '64476', 218, 29, 11182, 40.4669, 0.706280643075293, -94.8324, -1.65513761756827),
(28688, '64477', 218, 29, 30852, 39.5645, 0.690530791905297, -94.4567, -1.64858041556853),
(28689, '64478', 218, 29, 11443, 40.3651, 0.704503897896763, -95.0852, -1.65954980991731),
(28690, '64479', 218, 29, 68097, 40.3535, 0.704301439703532, -94.6712, -1.65232414681406),
(28691, '64480', 218, 29, 139418, 40.0605, 0.699187624995188, -94.6919, -1.65268542996922),
(28692, '64481', 218, 29, 11587, 40.4189, 0.705442885034336, -93.9855, -1.64035642413313),
(28693, '64482', 218, 29, 139426, 40.4116, 0.705315475998941, -95.5171, -1.66708788695668),
(28694, '64483', 218, 29, 117607, 40.0402, 0.698833323157034, -94.8353, -1.65518823211658),
(28695, '64484', 218, 29, 31020, 39.5874, 0.690930472304003, -95.0185, -1.65838567530623),
(28696, '64485', 218, 29, 24690, 39.9388, 0.697063559295511, -94.8299, -1.65509398433697),
(28697, '64486', 218, 29, 11906, 40.4853, 0.70660178365766, -94.5446, -1.65011455998103),
(28698, '64487', 218, 29, 33981, 40.2901, 0.703194900957767, -95.0751, -1.65937353166286),
(28699, '64489', 218, 29, 139467, 40.2177, 0.701931282579323, -94.5404, -1.65004125615245),
(28700, '64490', 218, 29, 31223, 39.7397, 0.693588608754791, -94.503, -1.6493885030122),
(28701, '64491', 218, 29, 139473, 40.4409, 0.705826857469775, -95.3851, -1.66478405234404),
(28702, '64492', 218, 29, 6389, 39.4733, 0.688939051627478, -94.5639, -1.65045140852667),
(28703, '64493', 218, 29, 57962, 39.6274, 0.691628604004801, -94.2849, -1.6455819399136),
(28704, '64494', 218, 29, 38633, 39.979, 0.697765181654813, -94.597, -1.65102911250908),
(28705, '64496', 218, 29, 6657, 40.4834, 0.706568622401872, -95.6289, -1.66903916506041),
(28706, '64497', 218, 29, 58175, 39.8918, 0.696243254547074, -94.2623, -1.64518749550265),
(28707, '64498', 218, 29, 52650, 40.5296, 0.707374964516294, -95.3164, -1.66358501114792),
(28708, '64499', 218, 29, 205, 40.4283, 0.705606945984024, -94.4225, -1.64798351296435),
(28709, '64501', 218, 29, 488, 39.7669, 0.694063338311333, -94.8436, -1.65533309444449),
(28710, '64502', 218, 29, 488, 39.7651, 0.694031922384797, -94.8502, -1.65544828617513),
(28711, '64503', 218, 29, 488, 39.739, 0.693576391450027, -94.818, -1.65488629015598),
(28712, '64504', 218, 29, 488, 39.713, 0.693122605844508, -94.8639, -1.65568739628265),
(28713, '64505', 218, 29, 488, 39.794, 0.694536322538623, -94.843, -1.65532262246898),
(28714, '64506', 218, 29, 488, 39.7869, 0.694412404161732, -94.8056, -1.65466986932874),
(28715, '64507', 218, 29, 488, 39.7503, 0.693773613655502, -94.8088, -1.6547257198648),
(28716, '64508', 218, 29, 488, 39.7772, 0.694243107224289, -94.7995, -1.65456340424436),
(28717, '64601', 218, 29, 54027, 39.7943, 0.694541558526379, -93.5545, -1.63283405505704),
(28718, '64620', 218, 29, 26361, 39.932, 0.696944876906376, -94.0776, -1.64196387237422),
(28719, '64622', 218, 29, 53548, 39.3145, 0.686167468775311, -93.4962, -1.63181652810312),
(28720, '64623', 218, 29, 1062, 39.4687, 0.688858766481886, -93.3395, -1.62908159716525),
(28721, '64624', 218, 29, 53633, 39.5928, 0.691024720083611, -93.7898, -1.63694081478698),
(28722, '64625', 218, 29, 26597, 39.7424, 0.693635732644594, -93.8151, -1.63738238308773),
(28723, '64628', 218, 29, 13444, 39.7866, 0.694407168173976, -93.075, -1.62446520129372),
(28724, '64630', 218, 29, 19587, 40.0069, 0.69825212851612, -93.173, -1.62617562396068),
(28725, '64631', 218, 29, 31908, 39.785, 0.694379242905944, -92.8879, -1.62119969026324),
(28726, '64632', 218, 29, 85476, 40.4817, 0.706538951804588, -93.7426, -1.63611701938004),
(28727, '64633', 218, 29, 1380, 39.361, 0.686979046877488, -93.4957, -1.63180780145686),
(28728, '64635', 218, 29, 8079, 39.9231, 0.696789542602948, -93.4807, -1.63154600206906),
(28729, '64636', 218, 29, 139094, 40.0902, 0.699705987783031, -94.0471, -1.64143154695236),
(28730, '64637', 218, 29, 657, 39.5686, 0.690602350404628, -93.9266, -1.63932842520371),
(28731, '64638', 218, 29, 54354, 39.6647, 0.692279611815795, -93.5879, -1.6334169950272),
(28732, '64639', 218, 29, 8432, 39.3522, 0.686825457903313, -93.2954, -1.62831190696512),
(28733, '64640', 218, 29, 9037, 39.9143, 0.696635953628773, -93.9763, -1.64019585384195),
(28734, '64641', 218, 29, 32508, 40.1591, 0.700908519637655, -93.4089, -1.63029285566613),
(28735, '64642', 218, 29, 139175, 40.1676, 0.701056872624074, -93.7907, -1.63695652275025),
(28736, '64643', 218, 29, 32661, 39.5719, 0.690659946269944, -93.3462, -1.62919853422513),
(28737, '64644', 218, 29, 2950, 39.743, 0.693646204620106, -93.9976, -1.64056760897262),
(28738, '64645', 218, 29, 2992, 40.3097, 0.703536985491158, -93.3468, -1.62920900620064),
(28739, '64646', 218, 29, 41431, 40.1157, 0.700151046742289, -93.2946, -1.6282979443311),
(28740, '64647', 218, 29, 88145, 40.0087, 0.698283544442655, -93.9627, -1.63995848906368),
(28741, '64648', 218, 29, 55539, 40.0106, 0.698316705698443, -93.7893, -1.63693208814072),
(28742, '64649', 218, 29, 36714, 39.744, 0.693663657912626, -94.1494, -1.64321701877715),
(28743, '64650', 218, 29, 3542, 39.6568, 0.692141730804887, -94.0947, -1.64226232367631),
(28744, '64651', 218, 29, 32957, 39.7874, 0.694421130807992, -93.1691, -1.62610755611985),
(28745, '64652', 218, 29, 95591, 39.9995, 0.698122974151472, -93.4319, -1.63069428139409),
(28746, '64653', 218, 29, 55939, 39.7742, 0.694190747346729, -93.0624, -1.62424528980797),
(28747, '64654', 218, 29, 55955, 39.9044, 0.696463166032825, -93.8183, -1.6374382336238),
(28748, '64655', 218, 29, 10223, 40.4307, 0.705648833886071, -93.2871, -1.6281670446372),
(28749, '64656', 218, 29, 37000, 39.6559, 0.692126022841619, -93.7038, -1.63543983163026),
(28750, '64657', 218, 29, 139313, 40.1024, 0.699918917951774, -94.3295, -1.64636035675999),
(28751, '64658', 218, 29, 56078, 39.7162, 0.693178456380572, -92.9461, -1.6222154718879),
(28752, '64659', 218, 29, 4140, 39.7637, 0.694007487775269, -93.2969, -1.6283380869039),
(28753, '64660', 218, 29, 56203, 39.591, 0.690993304157075, -93.1332, -1.62548098291838),
(28754, '64661', 218, 29, 17095, 40.5259, 0.70731038733397, -93.4973, -1.63183572672489),
(28755, '64664', 218, 29, 4315, 39.7413, 0.693616534022823, -93.7167, -1.63566497910377),
(28756, '64667', 218, 29, 839, 40.3443, 0.704140869412348, -93.2708, -1.62788255596913),
(28757, '64668', 218, 29, 56550, 39.3013, 0.685937085314047, -93.6753, -1.63494241279344),
(28758, '64670', 218, 29, 120977, 40.0463, 0.698939788241405, -94.1381, -1.64301979657167),
(28759, '64671', 218, 29, 56980, 39.5566, 0.690392910894389, -94.037, -1.64125526869791),
(28760, '64672', 218, 29, 24118, 40.5266, 0.707322604638734, -93.2877, -1.62817751661271),
(28761, '64673', 218, 29, 5231, 40.3986, 0.705088583196181, -93.5858, -1.63338034311291),
(28762, '64674', 218, 29, 57068, 39.9575, 0.697389935865634, -93.1755, -1.62621925719198),
(28763, '64676', 218, 29, 57279, 39.6531, 0.692077153622564, -93.0644, -1.62428019639301),
(28764, '64679', 218, 29, 139465, 40.2319, 0.702179119333107, -93.5014, -1.63190728522423),
(28765, '64680', 218, 29, 57725, 39.4226, 0.688054169696717, -93.7591, -1.63640499870662),
(28766, '64681', 218, 29, 18216, 39.6559, 0.692126022841619, -93.2422, -1.62738339180306),
(28767, '64682', 218, 29, 38547, 39.5715, 0.690652964952936, -93.4772, -1.63148491554524),
(28768, '64683', 218, 29, 6381, 40.0788, 0.699507020248303, -93.6093, -1.63379049548713),
(28769, '64686', 218, 29, 31360, 39.7389, 0.693574646120775, -93.6285, -1.63412559870351),
(28770, '64687', 218, 29, 58098, 39.316, 0.686193648714091, -93.3775, -1.629744822281),
(28771, '64688', 218, 29, 12785, 39.8066, 0.694756234024375, -93.3934, -1.63002232963207),
(28772, '64689', 218, 29, 18654, 39.8701, 0.695864518099391, -94.1411, -1.64307215644923),
(28773, '64701', 218, 29, 21759, 38.6587, 0.674721599540732, -94.3509, -1.64673385721992),
(28774, '64720', 218, 29, 18746, 38.3974, 0.670161054205271, -94.3507, -1.64673036656141),
(28775, '64722', 218, 29, 643, 38.269, 0.66792005144571, -94.5636, -1.65044617253891),
(28776, '64723', 218, 29, 18842, 38.3956, 0.670129638278735, -94.5612, -1.65040428463686),
(28777, '64724', 218, 29, 53205, 38.1899, 0.666539496007382, -94.028, -1.64109818906523),
(28778, '64725', 218, 29, 26388, 38.4826, 0.67164807472797, -94.3538, -1.64678447176823),
(28779, '64726', 218, 29, 39401, 38.557, 0.672946599691454, -93.9601, -1.63991311050312),
(28780, '64728', 218, 29, 53668, 37.6924, 0.657856482978711, -94.466, -1.64874273118896),
(28781, '64730', 218, 29, 1257, 38.2538, 0.667654761399407, -94.3356, -1.64646682184436),
(28782, '64733', 218, 29, 54025, 38.5893, 0.673510341039848, -93.8559, -1.63809447742255),
(28783, '64734', 218, 29, 1620, 38.6816, 0.675121279939439, -94.5925, -1.65095057269274),
(28784, '64735', 218, 29, 1630, 38.3703, 0.66968806997798, -93.7685, -1.6365690596563),
(28785, '64738', 218, 29, 308, 37.8726, 0.661001566290804, -93.6816, -1.63505236853632),
(28786, '64739', 218, 29, 15664, 38.4945, 0.671855768908957, -94.0718, -1.6418626432776),
(28787, '64740', 218, 29, 54385, 38.2622, 0.667801369056574, -93.7767, -1.63671217665497),
(28788, '64741', 218, 29, 8455, 37.8114, 0.659933424788584, -94.5093, -1.64949845875508),
(28789, '64742', 218, 29, 15817, 38.4823, 0.671642838740214, -94.6069, -1.65120190010502),
(28790, '64743', 218, 29, 54539, 38.6683, 0.674889151148923, -94.2286, -1.64459931954473),
(28791, '64744', 218, 29, 54576, 37.8691, 0.660940479766985, -94.0204, -1.64096554404208),
(28792, '64745', 218, 29, 35967, 38.1713, 0.666214864766512, -94.5535, -1.65026989428446),
(28793, '64746', 218, 29, 21295, 38.6095, 0.673862897548751, -94.4799, -1.64898533195499),
(28794, '64747', 218, 29, 2657, 38.5543, 0.67289947580165, -94.1882, -1.64389420652692),
(28795, '64748', 218, 29, 9150, 37.3923, 0.652618749893476, -94.0935, -1.64224137972528),
(28796, '64750', 218, 29, 9373, 37.9498, 0.662348960473344, -94.1191, -1.6426881840138),
(28797, '64751', 218, 29, 468, 37.9969, 0.663171010551033, -94.3931, -1.64747038616426),
(28798, '64752', 218, 29, 109, 38.0906, 0.664806384060152, -94.5877, -1.65086679688864),
(28799, '64755', 218, 29, 738, 37.3276, 0.651489521867435, -94.3028, -1.64589435384971),
(28800, '64756', 218, 29, 55583, 37.6695, 0.657456802580004, -94.0082, -1.64075261387333),
(28801, '64759', 218, 29, 244, 37.4942, 0.654397240401258, -94.2712, -1.64534282980608),
(28802, '64761', 218, 29, 55850, 38.5835, 0.673409111943232, -93.6943, -1.63527402535132),
(28803, '64762', 218, 29, 30333, 37.5555, 0.65546712723273, -94.5147, -1.64959270653468),
(28804, '64763', 218, 29, 56011, 38.14, 0.665668576710637, -93.7269, -1.63584300268747),
(28805, '64765', 218, 29, 56223, 37.9977, 0.663184973185049, -94.443, -1.648341305461),
(28806, '64766', 218, 29, 10480, 37.5859, 0.655997707325337, -94.1561, -1.64333395583703),
(28807, '64767', 218, 29, 503, 37.7372, 0.658638390483604, -94.2981, -1.64581232337486),
(28808, '64769', 218, 29, 56282, 37.4211, 0.65312140471805, -94.5597, -1.65037810469808),
(28809, '64770', 218, 29, 4299, 38.2589, 0.667743773191259, -93.9849, -1.64034595215762),
(28810, '64771', 218, 29, 4360, 37.7444, 0.658764054189748, -94.4957, -1.64926109397681),
(28811, '64772', 218, 29, 37398, 37.839, 0.660415135662134, -94.3601, -1.6468944275111),
(28812, '64776', 218, 29, 11010, 38.0415, 0.663949427397423, -93.7036, -1.63543634097176),
(28813, '64777', 218, 29, 56810, 38.3213, 0.668832858644503, -94.3476, -1.6466762613546),
(28814, '64778', 218, 29, 57154, 37.9422, 0.662216315450193, -94.5595, -1.65037461403958),
(28815, '64779', 218, 29, 57152, 38.0975, 0.66492681177854, -94.3626, -1.6469380607424),
(28816, '64780', 218, 29, 5479, 38.0756, 0.664544584672353, -94.1672, -1.643527687384),
(28817, '64781', 218, 29, 24518, 37.9772, 0.662827180688391, -93.8129, -1.63734398584419),
(28818, '64783', 218, 29, 57440, 37.9971, 0.663174501209537, -94.1822, -1.6437894867718),
(28819, '64784', 218, 29, 57525, 37.6579, 0.657254344386773, -94.2952, -1.64576170882656),
(28820, '64788', 218, 29, 58021, 38.4608, 0.671267592951035, -93.9982, -1.64057808094813),
(28821, '64789', 218, 29, 18458, 37.9883, 0.663020912235362, -93.6643, -1.63475042657572),
(28822, '64790', 218, 29, 12598, 37.8908, 0.661319216214667, -94.2328, -1.64467262337331),
(28823, '64801', 218, 29, 9793, 37.0824, 0.647209974541545, -94.5019, -1.64936930439043),
(28824, '64802', 218, 29, 9793, 37.0558, 0.646745716960515, -94.5456, -1.65013201327355),
(28825, '64803', 218, 29, 9793, 37.0335, 0.64635650853732, -94.5126, -1.64955605462039),
(28826, '64804', 218, 29, 9793, 37.0662, 0.646927231202722, -94.5107, -1.6495228933646),
(28827, '64830', 218, 29, 53143, 37.2385, 0.649934433503908, -94.4172, -1.64789101051399),
(28828, '64831', 218, 29, 7099, 36.6497, 0.639657934868166, -94.4481, -1.64843031725286),
(28829, '64832', 218, 29, 44465, 37.2732, 0.650540062754351, -94.6089, -1.65123680669006),
(28830, '64833', 218, 29, 7212, 37.1946, 0.649168233962283, -94.1306, -1.64288889687777),
(28831, '64834', 218, 29, 53860, 37.1689, 0.64871968434452, -94.5441, -1.65010583333477),
(28832, '64835', 218, 29, 26719, 37.1493, 0.648377599811129, -94.4392, -1.64827498294943),
(28833, '64836', 218, 29, 7932, 37.167, 0.648686523088733, -94.3167, -1.64613695461574),
(28834, '64840', 218, 29, 2039, 36.8366, 0.642919955240143, -94.3761, -1.64717368019142),
(28835, '64841', 218, 29, 54497, 37.0782, 0.647136670712962, -94.4095, -1.64775662016159),
(28836, '64842', 218, 29, 500, 36.8188, 0.642609286633288, -94.0843, -1.6420808094341),
(28837, '64843', 218, 29, 2775, 36.7394, 0.641223495207205, -94.409, -1.64774789351533),
(28838, '64844', 218, 29, 55021, 36.9176, 0.644333671934259, -94.2644, -1.64522414741694),
(28839, '64847', 218, 29, 55799, 36.5992, 0.638776543595909, -94.4569, -1.64858390622703),
(28840, '64848', 218, 29, 55744, 37.1964, 0.649199649888819, -94.0161, -1.64089049488424),
(28841, '64849', 218, 29, 56460, 37.2567, 0.650252083427771, -94.4436, -1.64835177743652),
(28842, '64850', 218, 29, 56472, 36.8649, 0.643413883418458, -94.3731, -1.64712132031386),
(28843, '64853', 218, 29, 56529, 36.8761, 0.643609360294681, -94.1857, -1.64385057329562),
(28844, '64854', 218, 29, 42301, 36.542, 0.637778215263768, -94.4854, -1.64908132506385),
(28845, '64855', 218, 29, 56704, 37.1881, 0.649054787560903, -94.4684, -1.64878461909101),
(28846, '64856', 218, 29, 5077, 36.5693, 0.638254690149562, -94.3397, -1.64653838034369),
(28847, '64857', 218, 29, 30906, 37.2425, 0.650004246673988, -94.4348, -1.64819818846234),
(28848, '64858', 218, 29, 819, 36.8966, 0.64396715279134, -94.5273, -1.64981261802044),
(28849, '64859', 218, 29, 446, 37.1306, 0.648051223241007, -94.1516, -1.64325541602069),
(28850, '64861', 218, 29, 11642, 36.6993, 0.640523618177155, -94.1187, -1.64268120269679),
(28851, '64862', 218, 29, 57427, 37.0673, 0.646946429824494, -94.1239, -1.64277195981789),
(28852, '64863', 218, 29, 57644, 36.5123, 0.637259852475926, -94.6119, -1.65128916656762),
(28853, '64864', 218, 29, 5602, 37.0234, 0.646180230282869, -94.4681, -1.64877938310326),
(28854, '64865', 218, 29, 18037, 36.8394, 0.642968824459199, -94.6074, -1.65121062675128),
(28855, '64866', 218, 29, 12112, 36.8861, 0.64378389321988, -94.1416, -1.64308088309549),
(28856, '64867', 218, 29, 12121, 36.7481, 0.641375338852128, -94.2175, -1.64440558799776),
(28857, '64868', 218, 29, 57897, 36.6643, 0.639912752938957, -94.5964, -1.65101864053356),
(28858, '64869', 218, 29, 6587, 37.2469, 0.650081041161076, -94.5988, -1.65106052843561),
(28859, '64870', 218, 29, 12712, 37.1434, 0.648274625385262, -94.4711, -1.64883174298082),
(28860, '64873', 218, 29, 58194, 36.9887, 0.645574601032427, -94.1362, -1.64298663531589),
(28861, '64874', 218, 29, 25985, 36.7624, 0.641624920935163, -94.0597, -1.64165145843811),
(28862, '64944', 218, 29, 32892, 38.9538, 0.679872066163367, -94.5489, -1.65018960913887),
(28863, '64999', 218, 29, 32892, 38.9533, 0.679863339517107, -94.5487, -1.65018611848036),
(28864, '65001', 218, 29, 15022, 38.3003, 0.668466339501584, -92.0072, -1.60582857554093),
(28865, '65010', 218, 29, 13301, 38.7879, 0.676976564934309, -92.2586, -1.61021633328044),
(28866, '65011', 218, 29, 19062, 38.4021, 0.670243084680114, -92.7555, -1.6188888743336),
(28867, '65013', 218, 29, 53404, 38.2787, 0.668089348383153, -91.7238, -1.60088231244077),
(28868, '65014', 218, 29, 7530, 38.3015, 0.668487283452608, -91.6344, -1.59932198808949),
(28869, '65016', 218, 29, 53564, 38.5617, 0.673028630166297, -91.9206, -1.6043171204087),
(28870, '65017', 218, 29, 299, 38.0873, 0.664748788194836, -92.531, -1.61497061016287),
(28871, '65018', 218, 29, 19701, 38.6309, 0.674236398008677, -92.5673, -1.61560416468135),
(28872, '65020', 218, 29, 53819, 38.0099, 0.663397903353793, -92.7466, -1.61873354003017),
(28873, '65022', 218, 29, 53925, 38.5992, 0.673683128635795, -92.178, -1.60880959790333),
(28874, '65023', 218, 29, 35196, 38.612, 0.673906530780051, -92.3874, -1.61246431735701),
(28875, '65024', 218, 29, 53983, 38.6352, 0.674311447166513, -91.7608, -1.60152808426401),
(28876, '65025', 218, 29, 26799, 38.6298, 0.674217199386906, -92.6797, -1.61756591476059),
(28877, '65026', 218, 29, 54579, 38.3489, 0.669314569518053, -92.5811, -1.61584502011812),
(28878, '65031', 218, 29, 54661, 38.3335, 0.669045788813246, -92.5526, -1.6153476012813),
(28879, '65032', 218, 29, 346, 38.3843, 0.669932416073259, -92.3678, -1.61212223282362),
(28880, '65034', 218, 29, 54818, 38.5801, 0.673349770748664, -92.7746, -1.61922223222073),
(28881, '65035', 218, 29, 27213, 38.3615, 0.669534481003805, -91.928, -1.60444627477335),
(28882, '65036', 218, 29, 54920, 38.6037, 0.673761668452135, -91.503, -1.59702862545237),
(28883, '65037', 218, 29, 55055, 38.2588, 0.667742027862007, -92.8777, -1.62102166667954),
(28884, '65038', 218, 29, 55817, 38.1988, 0.66669483031081, -92.8334, -1.6202484858209),
(28885, '65039', 218, 29, 55194, 38.7318, 0.67599743522394, -92.3038, -1.61100522210234),
(28886, '65040', 218, 29, 55252, 38.3776, 0.669815479013376, -92.3334, -1.61152183956093),
(28887, '65041', 218, 29, 55262, 38.7008, 0.675456383155821, -91.4391, -1.59591336006035),
(28888, '65042', 218, 29, 3101, 38.4791, 0.67158698820415, -92.6046, -1.61625517249234),
(28889, '65043', 218, 29, 55355, 38.6417, 0.674424893567893, -92.1186, -1.60777287232765),
(28890, '65046', 218, 29, 3399, 38.7919, 0.677046378104388, -92.4841, -1.61415205074369),
(28891, '65047', 218, 29, 55627, 38.1729, 0.666242790034543, -92.5627, -1.61552387953576),
(28892, '65048', 218, 29, 55725, 38.3221, 0.668846821278519, -92.0546, -1.60665586160637),
(28893, '65049', 218, 29, 55770, 38.2012, 0.666736718212858, -92.713, -1.6181471094015),
(28894, '65050', 218, 29, 3678, 38.5498, 0.67282093598531, -92.6489, -1.61702835335097),
(28895, '65051', 218, 29, 33091, 38.4804, 0.671609677484426, -91.8449, -1.60299590616494),
(28896, '65052', 218, 29, 55933, 38.0373, 0.663876123568839, -92.7091, -1.61807904156068),
(28897, '65053', 218, 29, 55966, 38.5433, 0.67270748958393, -92.335, -1.61154976482896),
(28898, '65054', 218, 29, 55993, 38.4644, 0.671330424804107, -91.9548, -1.60491402301288),
(28899, '65055', 218, 29, 56174, 38.628, 0.67418578346037, -92.5684, -1.61562336330312),
(28900, '65058', 218, 29, 37176, 38.2679, 0.667900852823938, -92.1305, -1.60798056650864),
(28901, '65059', 218, 29, 56319, 38.7053, 0.675534922972161, -91.8835, -1.60366960325621),
(28902, '65061', 218, 29, 42178, 38.503, 0.672004121895377, -91.5357, -1.59759934811777),
(28903, '65062', 218, 29, 4408, 38.5324, 0.672517248695463, -91.6105, -1.59890485439827),
(28904, '65063', 218, 29, 56480, 38.7188, 0.675770542421181, -92.0858, -1.60720040433299),
(28905, '65064', 218, 29, 30732, 38.401, 0.670223886058343, -92.525, -1.61486589040775),
(28906, '65065', 218, 29, 56709, 38.1347, 0.665576074260282, -92.6692, -1.61738265518913),
(28907, '65066', 218, 29, 11032, 38.3461, 0.669265700298998, -91.4988, -1.59695532162379),
(28908, '65067', 218, 29, 5188, 38.7984, 0.677159824505768, -91.7006, -1.60047739605431),
(28909, '65068', 218, 29, 57019, 38.8296, 0.67770436723239, -92.5997, -1.61616965135899),
(28910, '65069', 218, 29, 57148, 38.7598, 0.676486127414498, -91.5311, -1.59751906297218),
(28911, '65072', 218, 29, 5489, 38.2944, 0.668363365075717, -92.7124, -1.61813663742599),
(28912, '65074', 218, 29, 5585, 38.508, 0.672091388357976, -92.4352, -1.61329858473946),
(28913, '65075', 218, 29, 57346, 38.2858, 0.668213266760045, -92.2741, -1.6104868593145),
(28914, '65076', 218, 29, 11761, 38.5081, 0.672093133687228, -92.4413, -1.61340504982383),
(28915, '65077', 218, 29, 57716, 38.7569, 0.67643551286619, -91.7849, -1.60194870861374),
(28916, '65078', 218, 29, 34063, 38.4417, 0.670934235063904, -92.9901, -1.62298341675878),
(28917, '65079', 218, 29, 51845, 38.1647, 0.66609967303588, -92.6899, -1.61774393834429),
(28918, '65080', 218, 29, 57849, 38.6461, 0.674501688054981, -91.9579, -1.60496812821969),
(28919, '65081', 218, 29, 12332, 38.654, 0.674639569065888, -92.7792, -1.61930251736632),
(28920, '65082', 218, 29, 6425, 38.2377, 0.667373763389836, -92.4822, -1.6141188894879),
(28921, '65083', 218, 29, 57978, 38.1332, 0.665549894321502, -92.4627, -1.61377855028376),
(28922, '65084', 218, 29, 28861, 38.4325, 0.670773664772721, -92.8454, -1.62045792533114),
(28923, '65085', 218, 29, 31504, 38.4059, 0.67030940719169, -92.0763, -1.60703459805406),
(28924, '65101', 218, 29, 27551, 38.5601, 0.673000704898265, -92.1724, -1.60871185946522),
(28925, '65102', 218, 29, 27551, 38.5774, 0.67330264685886, -92.1723, -1.60871011413597),
(28926, '65103', 218, 29, 27551, 38.5779, 0.67331137350512, -92.1738, -1.60873629407475),
(28927, '65104', 218, 29, 27551, 38.5775, 0.673304392188112, -92.1722, -1.60870836880672),
(28928, '65105', 218, 29, 27551, 38.5781, 0.673314864163624, -92.1727, -1.60871709545298),
(28929, '65106', 218, 29, 27551, 38.5767, 0.673290429554097, -92.1728, -1.60871884078223),
(28930, '65107', 218, 29, 27551, 38.5772, 0.673299156200356, -92.1728, -1.60871884078223),
(28931, '65108', 218, 29, 27551, 38.5767, 0.673290429554097, -92.1727, -1.60871709545298),
(28932, '65109', 218, 29, 27551, 38.5778, 0.673309628175868, -92.2454, -1.60998594981918),
(28933, '65110', 218, 29, 27551, 38.5764, 0.673285193566341, -92.1733, -1.60872756742849),
(28934, '65111', 218, 29, 27551, 38.5501, 0.672826171973066, -92.1173, -1.60775018304737),
(28935, '65201', 218, 29, 1716, 38.9307, 0.679468895106156, -92.2859, -1.61069280816623),
(28936, '65202', 218, 29, 1716, 38.9966, 0.680619067083221, -92.3173, -1.61124084155136),
(28937, '65203', 218, 29, 1716, 38.9292, 0.679442715167377, -92.3692, -1.61214666743315),
(28938, '65205', 218, 29, 1716, 39.0485, 0.681524892965006, -92.2407, -1.60990391934433),
(28939, '65211', 218, 29, 1716, 38.9451, 0.679720222518444, -92.3244, -1.61136475992825),
(28940, '65212', 218, 29, 1716, 38.9093, 0.67909539464623, -92.2471, -1.61001562041646),
(28941, '65215', 218, 29, 1716, 38.9519, 0.679838904907579, -92.3215, -1.61131414537994),
(28942, '65216', 218, 29, 1716, 38.9576, 0.679938388674943, -92.3264, -1.61139966651329),
(28943, '65217', 218, 29, 1716, 38.8978, 0.67889468178225, -92.3346, -1.61154278351196),
(28944, '65218', 218, 29, 1716, 38.9535, 0.679866830175611, -92.366, -1.61209081689708),
(28945, '65230', 218, 29, 7163, 39.2697, 0.685385561270417, -92.7009, -1.61793592456201),
(28946, '65231', 218, 29, 53290, 39.0161, 0.68095940628736, -91.8962, -1.60389126007121),
(28947, '65232', 218, 29, 53430, 39.1042, 0.682497041358367, -91.772, -1.60172356114024),
(28948, '65233', 218, 29, 29261, 38.967, 0.68010244962463, -92.743, -1.6186707081771),
(28949, '65236', 218, 29, 19602, 39.4252, 0.688099548257268, -93.1312, -1.62544607633334),
(28950, '65237', 218, 29, 53738, 38.7883, 0.676983546251317, -92.7988, -1.61964460189971),
(28951, '65239', 218, 29, 1288, 39.5209, 0.689769828351427, -92.4204, -1.61304027601017),
(28952, '65240', 218, 29, 26746, 39.1975, 0.684125433550477, -92.1468, -1.60826505517671),
(28953, '65243', 218, 29, 1590, 39.211, 0.684361052999497, -92.389, -1.61249224262504),
(28954, '65244', 218, 29, 54103, 39.4247, 0.688090821611008, -92.666, -1.61732680465307),
(28955, '65246', 218, 29, 8391, 39.3898, 0.687481701702062, -92.9937, -1.62304624861185),
(28956, '65247', 218, 29, 54683, 39.6495, 0.692014321769492, -92.4509, -1.61357260143203),
(28957, '65248', 218, 29, 2426, 39.1464, 0.683233570302708, -92.6871, -1.61769506912524),
(28958, '65250', 218, 29, 2595, 39.0597, 0.681720369841229, -92.841, -1.62038113084406),
(28959, '65251', 218, 29, 2628, 38.8524, 0.678102302301845, -91.949, -1.60481279391627),
(28960, '65254', 218, 29, 2722, 39.2277, 0.68465252298458, -92.8416, -1.62039160281957),
(28961, '65255', 218, 29, 2943, 39.1052, 0.682514494650887, -92.2249, -1.60962815732252),
(28962, '65256', 218, 29, 2994, 39.1269, 0.682893231098569, -92.4399, -1.61338061521431),
(28963, '65257', 218, 29, 55284, 39.3072, 0.686040059739915, -92.5198, -1.61477513328665),
(28964, '65258', 218, 29, 27457, 39.4854, 0.689150236466969, -92.1371, -1.60809575823927),
(28965, '65259', 218, 29, 3297, 39.4383, 0.68832818638928, -92.5451, -1.6152167015874),
(28966, '65260', 218, 29, 3395, 39.5793, 0.690789100634592, -92.4195, -1.6130245680469),
(28967, '65261', 218, 29, 55667, 39.4324, 0.688225211963412, -92.9358, -1.62203570297495),
(28968, '65262', 218, 29, 55688, 38.9583, 0.679950605979707, -91.9601, -1.60500652546324),
(28969, '65263', 218, 29, 3938, 39.4728, 0.688930324981218, -92.2135, -1.60942918978779),
(28970, '65264', 218, 29, 27815, 39.101, 0.682441190822303, -91.6493, -1.59958204214804),
(28971, '65265', 218, 29, 37178, 39.1691, 0.683629760042911, -91.8835, -1.60366960325621),
(28972, '65270', 218, 29, 30533, 39.4193, 0.687996573831401, -92.4389, -1.61336316192179),
(28973, '65274', 218, 29, 56487, 39.016, 0.680957660958108, -92.7381, -1.61858518704375),
(28974, '65275', 218, 29, 11069, 39.4789, 0.689036790065589, -92.0089, -1.60585824613821),
(28975, '65276', 218, 29, 56885, 38.8695, 0.678400753603936, -92.9074, -1.62154002946738),
(28976, '65278', 218, 29, 37897, 39.2907, 0.685752080413336, -92.3458, -1.61173826038818),
(28977, '65279', 218, 29, 57225, 38.9999, 0.680676662948536, -92.5162, -1.61471230143358),
(28978, '65280', 218, 29, 57304, 39.1902, 0.683998024515082, -91.6812, -1.60013880217943),
(28979, '65281', 218, 29, 28524, 39.422, 0.688043697721205, -92.7999, -1.61966380052149),
(28980, '65282', 218, 29, 17977, 39.404, 0.687729538455846, -91.8274, -1.60269047354584),
(28981, '65283', 218, 29, 57752, 39.5441, 0.69017474473789, -91.8382, -1.60287896910506),
(28982, '65284', 218, 29, 38424, 39.2053, 0.684261569232133, -92.3049, -1.61102442072411),
(28983, '65285', 218, 29, 6317, 39.2016, 0.684196992049809, -92.0386, -1.60637660892605),
(28984, '65286', 218, 29, 198, 39.5079, 0.689542935548668, -93.2101, -1.62682314111317),
(28985, '65287', 218, 29, 58365, 38.9177, 0.679242002303397, -92.5824, -1.6158677093984),
(28986, '65299', 218, 29, 1716, 39.0252, 0.681118231249291, -92.249, -1.61004878167225),
(28987, '65301', 218, 29, 38144, 38.7004, 0.675449401838814, -93.2287, -1.62714777235404),
(28988, '65302', 218, 29, 38144, 38.7068, 0.675561102910941, -93.2242, -1.6270692325377),
(28989, '65305', 218, 29, 0, 38.7299, 0.675964273968152, -93.5647, -1.63301207864074),
(28990, '65320', 218, 29, 53243, 39.004, 0.680748221447868, -93.0433, -1.62391193192084),
(28991, '65321', 218, 29, 871, 39.1039, 0.682491805370611, -93.4847, -1.63161581523914),
(28992, '65322', 218, 29, 13392, 38.9801, 0.680331087756642, -92.9927, -1.62302879531933),
(28993, '65323', 218, 29, 1294, 38.5095, 0.672117568296756, -93.6698, -1.63484641968458),
(28994, '65324', 218, 29, 54106, 38.1283, 0.665464373188154, -92.9647, -1.62254010312877),
(28995, '65325', 218, 29, 54140, 38.4501, 0.671080842721072, -93.2143, -1.62689644494175),
(28996, '65326', 218, 29, 8695, 38.1683, 0.666162504888952, -93.1465, -1.6257131117089),
(28997, '65327', 218, 29, 20894, 38.9715, 0.68018098944097, -93.4922, -1.63174671493304),
(28998, '65329', 218, 29, 2502, 38.6085, 0.673845444256231, -92.9992, -1.62314224172071),
(28999, '65330', 218, 29, 41083, 39.2328, 0.684741534776431, -93.003, -1.62320856423229),
(29000, '65332', 218, 29, 9214, 38.6158, 0.673972853291626, -93.4532, -1.63106603652476),
(29001, '65333', 218, 29, 55389, 38.8998, 0.67892958836729, -93.3602, -1.62944288032041),
(29002, '65334', 218, 29, 48332, 38.8579, 0.678198295410705, -93.2069, -1.6267672905771),
(29003, '65335', 218, 29, 9664, 38.4887, 0.671754539812342, -93.3159, -1.62866969946178),
(29004, '65336', 218, 29, 55715, 38.7633, 0.676547213938318, -93.5568, -1.63287419762983),
(29005, '65337', 218, 29, 55742, 38.7716, 0.676692076266234, -93.4244, -1.63056338170019),
(29006, '65338', 218, 29, 3781, 38.4365, 0.670843477942801, -93.4072, -1.63026318506885),
(29007, '65339', 218, 29, 56060, 39.1262, 0.682881013793805, -93.394, -1.63003280160758),
(29008, '65340', 218, 29, 4011, 39.1154, 0.68269251823459, -93.2004, -1.62665384417572),
(29009, '65344', 218, 29, 17102, 39.3221, 0.686300113798462, -93.2275, -1.62712682840301),
(29010, '65345', 218, 29, 23175, 38.529, 0.672457907500895, -93.2195, -1.62698720206285),
(29011, '65347', 218, 29, 4506, 38.9946, 0.680584160498181, -93.0321, -1.62371645504462),
(29012, '65348', 218, 29, 28164, 38.7045, 0.675520960338145, -93.0024, -1.62319809225677),
(29013, '65349', 218, 29, 60, 39.2143, 0.684418648864812, -93.0711, -1.62439713345289),
(29014, '65350', 218, 29, 12000, 38.6811, 0.675112553293179, -93.0938, -1.6247933231931),
(29015, '65351', 218, 29, 57807, 38.9643, 0.680055325734827, -93.4155, -1.63040804739676),
(29016, '65354', 218, 29, 57818, 38.6149, 0.673957145328358, -92.8915, -1.62126252211631),
(29017, '65355', 218, 29, 6638, 38.2452, 0.667504663083735, -93.3754, -1.62970817036671),
(29018, '65360', 218, 29, 18652, 38.532, 0.672510267378455, -93.5234, -1.63229125765966),
(29019, '65401', 218, 29, 11660, 37.9488, 0.662331507180824, -91.7632, -1.60156997216606),
(29020, '65402', 218, 29, 11660, 37.9421, 0.662214570120941, -91.7713, -1.60171134383547),
(29021, '65409', 218, 29, 11660, 37.9557, 0.662451934899212, -91.7741, -1.60176021305453),
(29022, '65433', 218, 29, 53423, 37.2491, 0.65011943840462, -92.2304, -1.60972415043138),
(29023, '65436', 218, 29, 616, 37.6468, 0.657060612839801, -91.8786, -1.60358408212286),
(29024, '65438', 218, 29, 53489, 36.913, 0.644253386788667, -91.4959, -1.59690470707548),
(29025, '65439', 218, 29, 732, 37.6641, 0.657362554800396, -91.0696, -1.58946436847423),
(29026, '65440', 218, 29, 53586, 37.6143, 0.656493380832903, -91.6097, -1.59889089176425),
(29027, '65441', 218, 29, 26582, 38.1537, 0.66590768681816, -91.2492, -1.59259897981081),
(29028, '65443', 218, 29, 53658, 38.0915, 0.66482209202342, -92.1173, -1.60775018304737),
(29029, '65444', 218, 29, 31910, 37.3984, 0.652725214977847, -92.038, -1.60636613695054),
(29030, '65446', 218, 29, 54017, 37.7842, 0.659458695232041, -91.2353, -1.59235637904478),
(29031, '65449', 218, 29, 54183, 37.8496, 0.660600140562846, -91.4647, -1.59636016434886),
(29032, '65452', 218, 29, 8302, 37.9567, 0.662469388191732, -92.2907, -1.61077658397033),
(29033, '65453', 218, 29, 1912, 38.0685, 0.664420666295461, -91.4124, -1.59544735715006),
(29034, '65456', 218, 29, 1986, 37.8039, 0.659802525094684, -91.1379, -1.59065642835334),
(29035, '65457', 218, 29, 54430, 37.8254, 0.660177770883863, -92.063, -1.60680246926354),
(29036, '65459', 218, 29, 828, 37.9973, 0.663177991868041, -92.1014, -1.60747267569631),
(29037, '65461', 218, 29, 2124, 37.6537, 0.657181040558189, -91.9861, -1.60546031106876),
(29038, '65462', 218, 29, 54561, 37.748, 0.658826886042819, -91.9102, -1.60413560616649),
(29039, '65463', 218, 29, 2252, 37.8214, 0.660107957713783, -92.7746, -1.61922223222073),
(29040, '65464', 218, 29, 35733, 37.2148, 0.649520790471186, -91.9913, -1.60555106818986),
(29041, '65466', 218, 29, 8755, 37.1829, 0.6489640304398, -91.482, -1.59666210630945),
(29042, '65468', 218, 29, 661, 37.2104, 0.649443995984098, -91.7289, -1.60097132423263),
(29043, '65470', 218, 29, 8837, 37.6064, 0.656355499821996, -92.3435, -1.61169811781538),
(29044, '65473', 218, 29, 0, 37.828, 0.660223149444415, -92.2157, -1.60946758703133),
(29045, '65479', 218, 29, 55195, 37.2914, 0.650857712678213, -91.7002, -1.6004704147373),
(29046, '65483', 218, 29, 3246, 37.3233, 0.6514144727096, -91.9613, -1.60502746941426),
(29047, '65484', 218, 29, 55413, 37.2722, 0.65052260946183, -92.1537, -1.6083854828951),
(29048, '65486', 218, 29, 36547, 38.0925, 0.66483954531594, -92.2961, -1.61087083174994),
(29049, '65501', 218, 29, 112413, 37.4637, 0.6538649149794, -91.5088, -1.59712985454899),
(29050, '65529', 218, 29, 9752, 37.9138, 0.661720641942626, -91.9917, -1.60555804950687),
(29051, '65532', 218, 29, 55795, 37.7829, 0.659436005951766, -91.6787, -1.60009516894813),
(29052, '65534', 218, 29, 55806, 37.7264, 0.658449894924389, -92.3432, -1.61169288182763),
(29053, '65535', 218, 29, 55831, 38.0612, 0.664293257260066, -91.1968, -1.59168442728276),
(29054, '65536', 218, 29, 3708, 37.6794, 0.657629590175951, -92.664, -1.61729189806803),
(29055, '65540', 218, 29, 55840, 37.7456, 0.658784998140772, -91.7226, -1.60086136848975),
(29056, '65541', 218, 29, 425, 37.6443, 0.657016979608501, -91.7352, -1.6010812799755),
(29057, '65542', 218, 29, 55904, 37.4951, 0.654412948364526, -91.8598, -1.60325596022349),
(29058, '65543', 218, 29, 16971, 37.495, 0.654411203035274, -92.3091, -1.6110977245527),
(29059, '65546', 218, 29, 56352, 36.9868, 0.645541439776639, -91.575, -1.59828526251381),
(29060, '65548', 218, 29, 4440, 36.9968, 0.645715972701838, -91.7198, -1.6008124992707),
(29061, '65550', 218, 29, 4565, 37.8661, 0.660888119889425, -91.9135, -1.60419320203181),
(29062, '65552', 218, 29, 37716, 37.4915, 0.654350116511454, -92.1838, -1.60891082699995),
(29063, '65555', 218, 29, 57107, 37.362, 0.652089915130121, -91.7689, -1.60166945593342),
(29064, '65556', 218, 29, 5374, 37.8595, 0.660772928158793, -92.3983, -1.61265455824548),
(29065, '65557', 218, 29, 28432, 37.4942, 0.654397240401258, -92.1141, -1.60769433251131),
(29066, '65559', 218, 29, 11756, 37.9982, 0.663193699831309, -91.6163, -1.59900608349488),
(29067, '65560', 218, 29, 126, 37.6416, 0.656969855718697, -91.5366, -1.59761505608104),
(29068, '65564', 218, 29, 12021, 37.1653, 0.648656852491449, -91.9457, -1.60475519805095),
(29069, '65565', 218, 29, 57715, 37.9694, 0.662691045006735, -91.3555, -1.59445426480568),
(29070, '65566', 218, 29, 58067, 37.7255, 0.658434186961121, -91.1271, -1.59046793279412),
(29071, '65567', 218, 29, 57750, 37.8484, 0.660579196611822, -92.4399, -1.61338061521431),
(29072, '65570', 218, 29, 12168, 37.4857, 0.654248887414838, -92.0102, -1.60588093541849),
(29073, '65571', 218, 29, 28728, 37.1338, 0.64810707377707, -91.7057, -1.60056640784616),
(29074, '65572', 218, 29, 57804, 37.9137, 0.661718896613374, -92.3317, -1.61149216896365),
(29075, '65580', 218, 29, 58068, 38.106, 0.665075164764959, -91.7997, -1.60220701734304),
(29076, '65582', 218, 29, 6557, 38.201, 0.666733227554354, -91.9323, -1.60452132393118),
(29077, '65583', 218, 29, 25859, 37.8185, 0.660057343165475, -92.2081, -1.60933494200818),
(29078, '65584', 218, 29, 57374, 37.8285, 0.660231876090675, -92.2005, -1.60920229698503),
(29079, '65586', 218, 29, 38800, 37.8586, 0.660757220195525, -91.3554, -1.59445251947643),
(29080, '65588', 218, 29, 904, 37.0594, 0.646808548813587, -91.2305, -1.59227260324069),
(29081, '65589', 218, 29, 13015, 37.2086, 0.649412580057562, -91.8149, -1.60247230738934),
(29082, '65590', 218, 29, 55983, 37.5731, 0.655774305181081, -92.9319, -1.62196763513412),
(29083, '65591', 218, 29, 10575, 37.99, 0.663050582832646, -92.52, -1.61477862394515),
(29084, '65601', 218, 29, 53148, 37.506, 0.654603189252993, -93.562, -1.63296495475093),
(29085, '65603', 218, 29, 18900, 37.5333, 0.655079664138788, -93.8595, -1.63815730927562);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(29086, '65604', 218, 29, 31678, 37.3164, 0.651294044991212, -93.5823, -1.63331925658909),
(29087, '65605', 218, 29, 474, 36.9681, 0.645215063206516, -93.7225, -1.63576620820039),
(29088, '65606', 218, 29, 14977, 36.7192, 0.640870938698302, -91.365, -1.59462007108462),
(29089, '65607', 218, 29, 53851, 37.7942, 0.659633228157241, -93.8041, -1.63719039687001),
(29090, '65608', 218, 29, 7203, 36.9576, 0.645031803635056, -92.661, -1.61723953819047),
(29091, '65609', 218, 29, 44555, 36.5378, 0.637704911435184, -92.1546, -1.60840119085837),
(29092, '65610', 218, 29, 53485, 37.0638, 0.646885343300674, -93.5548, -1.63283929104479),
(29093, '65611', 218, 29, 968, 36.5186, 0.637369808218801, -93.4469, -1.63095608078189),
(29094, '65612', 218, 29, 0, 37.2197, 0.649606311604534, -93.5613, -1.63295273744617),
(29095, '65613', 218, 29, 1034, 37.6107, 0.656430548979831, -93.4136, -1.63037488614098),
(29096, '65614', 218, 29, 53618, 36.7263, 0.640994857075193, -92.8787, -1.62103911997206),
(29097, '65615', 218, 29, 53626, 36.6439, 0.63955670577155, -93.2182, -1.62696451278258),
(29098, '65616', 218, 29, 53626, 36.6437, 0.639553215113046, -93.2315, -1.62719664157309),
(29099, '65617', 218, 29, 212, 37.4793, 0.654137186342711, -93.3621, -1.6294760415762),
(29100, '65618', 218, 29, 53664, 36.7559, 0.641511474533784, -92.3912, -1.61253063986859),
(29101, '65619', 218, 29, 0, 37.1242, 0.647939522168879, -93.3775, -1.629744822281),
(29102, '65620', 218, 29, 53691, 36.9786, 0.645398322777975, -92.9536, -1.6223463715818),
(29103, '65622', 218, 29, 26642, 37.6459, 0.657044904876533, -93.0942, -1.62480030451011),
(29104, '65623', 218, 29, 7808, 36.7433, 0.641291563048032, -93.9134, -1.63909804174244),
(29105, '65624', 218, 29, 53846, 36.6742, 0.640085540534904, -93.5292, -1.63239248675628),
(29106, '65625', 218, 29, 19837, 36.6805, 0.64019549627778, -93.8714, -1.63836500345661),
(29107, '65626', 218, 29, 53912, 36.596, 0.638720693059845, -92.0767, -1.60704157937106),
(29108, '65627', 218, 29, 53943, 36.563, 0.638144734406687, -93.0186, -1.6234808355956),
(29109, '65629', 218, 29, 45582, 36.9178, 0.644337162592763, -93.0367, -1.62379674019021),
(29110, '65630', 218, 29, 54022, 36.8573, 0.643281238395306, -93.1211, -1.62526979807889),
(29111, '65631', 218, 29, 54096, 37.0243, 0.646195938246137, -93.4711, -1.63137845046087),
(29112, '65632', 218, 29, 8215, 37.5154, 0.654767250202681, -92.749, -1.61877542793222),
(29113, '65633', 218, 29, 29571, 36.9053, 0.644118996436263, -93.5668, -1.63304873055503),
(29114, '65634', 218, 29, 54280, 38.0234, 0.663633522802812, -93.2007, -1.62665908016348),
(29115, '65635', 218, 29, 1944, 37.5288, 0.655001124322448, -93.7096, -1.63554106072688),
(29116, '65636', 218, 29, 54436, 37.1745, 0.648817422782632, -92.8526, -1.62058358903729),
(29117, '65637', 218, 29, 746, 36.7558, 0.641509729204532, -92.2252, -1.60963339331027),
(29118, '65638', 218, 29, 32265, 36.9304, 0.644557074078514, -92.3641, -1.61205765564129),
(29119, '65640', 218, 29, 54510, 37.7042, 0.658062431830446, -93.5204, -1.63223889778211),
(29120, '65641', 218, 29, 54519, 36.564, 0.638162187699207, -93.7548, -1.63632994954878),
(29121, '65644', 218, 29, 54597, 37.4351, 0.653365750813329, -93.0177, -1.62346512763233),
(29122, '65645', 218, 29, 8789, 37.483, 0.654201763525034, -93.5375, -1.6325373490842),
(29123, '65646', 218, 29, 8806, 37.3583, 0.652025337947798, -93.7112, -1.63556898599491),
(29124, '65647', 218, 29, 27125, 36.6708, 0.640026199340337, -93.9373, -1.63951517543367),
(29125, '65648', 218, 29, 54695, 37.3721, 0.652266193384573, -93.1357, -1.62552461614968),
(29126, '65649', 218, 29, 54697, 37.6312, 0.65678834147649, -93.625, -1.63406451217969),
(29127, '65650', 218, 29, 16031, 37.7708, 0.659224821112274, -93.4499, -1.63100844065945),
(29128, '65652', 218, 29, 54805, 37.1143, 0.647766734572931, -93.0596, -1.62419642058892),
(29129, '65653', 218, 29, 21226, 36.6697, 0.640007000718565, -93.1211, -1.62526979807889),
(29130, '65654', 218, 29, 54862, 37.0197, 0.646115653100545, -93.8974, -1.63881878906212),
(29131, '65655', 218, 29, 2644, 36.5749, 0.638352428587674, -92.4153, -1.61295126421832),
(29132, '65656', 218, 29, 9031, 36.8369, 0.642925191227899, -93.4802, -1.6315372754228),
(29133, '65657', 218, 29, 27246, 36.8535, 0.64321491588373, -92.9875, -1.62293803819823),
(29134, '65658', 218, 29, 54988, 36.5447, 0.637825339153572, -93.6308, -1.63416574127631),
(29135, '65659', 218, 29, 2776, 37.7065, 0.658102574403242, -93.2325, -1.62721409486561),
(29136, '65660', 218, 29, 55018, 37.1158, 0.647792914511711, -92.3177, -1.61124782286837),
(29137, '65661', 218, 29, 2861, 37.4144, 0.653004467658166, -93.8419, -1.63785013132727),
(29138, '65662', 218, 29, 55110, 37.4704, 0.653981852039283, -92.5775, -1.61578218826505),
(29139, '65663', 218, 29, 109516, 37.6043, 0.656318847907704, -93.2487, -1.62749683820444),
(29140, '65664', 218, 29, 2944, 37.1929, 0.649138563364999, -93.6287, -1.63412908936201),
(29141, '65666', 218, 29, 55166, 36.5928, 0.638664842523781, -92.3723, -1.61220077263996),
(29142, '65667', 218, 29, 55196, 37.296, 0.650937997823805, -92.5085, -1.61457791108117),
(29143, '65668', 218, 29, 9439, 37.9388, 0.662156974255625, -93.3152, -1.62865748215701),
(29144, '65669', 218, 29, 55297, 36.9718, 0.64527964038884, -93.3534, -1.62932419793127),
(29145, '65672', 218, 29, 16470, 36.6298, 0.639310614347019, -93.2079, -1.62678474386962),
(29146, '65673', 218, 29, 16470, 36.6196, 0.639132590763316, -93.2203, -1.62700116469687),
(29147, '65674', 218, 29, 55420, 37.7951, 0.659648936120509, -93.5771, -1.63322849946799),
(29148, '65675', 218, 29, 3300, 36.9225, 0.644419193067606, -93.4734, -1.63141859303367),
(29149, '65676', 218, 29, 3368, 36.5798, 0.638437949721022, -92.6054, -1.61626913512636),
(29150, '65679', 218, 29, 55700, 36.588, 0.638581066719685, -93.1247, -1.62533262993196),
(29151, '65680', 218, 29, 55704, 36.6662, 0.639945914194745, -93.0273, -1.62363267924052),
(29152, '65681', 218, 29, 55798, 36.5805, 0.638450167025786, -93.448, -1.63097527940366),
(29153, '65682', 218, 29, 16930, 37.387, 0.65252624744312, -93.9526, -1.63978221080922),
(29154, '65685', 218, 29, 33143, 37.7262, 0.658446404265885, -93.0995, -1.62489280696046),
(29155, '65686', 218, 29, 55676, 36.6414, 0.63951307254025, -93.4235, -1.63054767373692),
(29156, '65688', 218, 29, 53625, 36.5805, 0.638450167025786, -91.7308, -1.60100448548841),
(29157, '65689', 218, 29, 53784, 37.1265, 0.647979664741675, -92.103, -1.60750060096434),
(29158, '65690', 218, 29, 1805, 36.5693, 0.638254690149562, -91.302, -1.59352051365586),
(29159, '65692', 218, 29, 55729, 36.614, 0.639034852325204, -91.6195, -1.59906193403094),
(29160, '65701', 218, 29, 56155, 36.765, 0.641670299495715, -92.813, -1.6198924386535),
(29161, '65702', 218, 29, 56039, 37.1068, 0.647635834879032, -92.4836, -1.61414332409743),
(29162, '65704', 218, 29, 3975, 37.1112, 0.64771262936612, -92.5829, -1.61587643604466),
(29163, '65705', 218, 29, 56093, 37.0016, 0.645799748505934, -93.6386, -1.63430187695796),
(29164, '65706', 218, 29, 30448, 37.3394, 0.651695470719171, -92.9067, -1.62152781216262),
(29165, '65707', 218, 29, 4213, 37.2304, 0.649793061834497, -93.8517, -1.63802117359396),
(29166, '65708', 218, 29, 33318, 36.9179, 0.644338907922015, -93.9286, -1.63936333178875),
(29167, '65710', 218, 29, 4337, 37.4668, 0.653919020186211, -93.4306, -1.63067159211381),
(29168, '65711', 218, 29, 4430, 37.1309, 0.648056459228762, -92.2663, -1.61035072363284),
(29169, '65712', 218, 29, 4411, 37.0986, 0.647492717880368, -93.8185, -1.6374417242823),
(29170, '65713', 218, 29, 56533, 37.4016, 0.652781065513911, -92.7428, -1.6186672175186),
(29171, '65714', 218, 29, 56543, 37.0491, 0.646628779900631, -93.2931, -1.62827176439232),
(29172, '65715', 218, 29, 23388, 36.7367, 0.641176371317401, -92.5809, -1.61584152945962),
(29173, '65717', 218, 29, 4648, 37.0353, 0.646387924463856, -92.4237, -1.61309787187548),
(29174, '65720', 218, 29, 4776, 36.9661, 0.645180156621476, -93.0242, -1.62357857403371),
(29175, '65721', 218, 29, 4832, 37.0171, 0.646070274539993, -93.204, -1.62671667602879),
(29176, '65722', 218, 29, 23863, 37.5775, 0.655851099668169, -92.7696, -1.61913496575813),
(29177, '65723', 218, 29, 56875, 36.9486, 0.644874724002377, -94.0027, -1.64065662076447),
(29178, '65724', 218, 29, 5099, 37.8425, 0.660476222185954, -93.3298, -1.6289123002278),
(29179, '65725', 218, 29, 56948, 37.4771, 0.654098789099167, -93.253, -1.62757188736227),
(29180, '65726', 218, 29, 105362, 36.5888, 0.638595029353701, -93.2389, -1.62732579593774),
(29181, '65727', 218, 29, 5163, 37.7575, 0.658992692321759, -93.293, -1.62827001906307),
(29182, '65728', 218, 29, 17696, 36.8933, 0.643909556926024, -93.3723, -1.6296540651599),
(29183, '65729', 218, 29, 28298, 36.5251, 0.637483254620181, -92.5497, -1.615296986733),
(29184, '65730', 218, 29, 5200, 36.5764, 0.638378608526454, -94.1581, -1.64336886242207),
(29185, '65731', 218, 29, 57014, 36.6382, 0.639457222004186, -93.0817, -1.62458213835361),
(29186, '65732', 218, 29, 5220, 37.942, 0.662212824791689, -93.161, -1.62596618445044),
(29187, '65733', 218, 29, 57054, 36.5599, 0.638090629199875, -92.846, -1.62046839730666),
(29188, '65734', 218, 29, 11435, 36.8204, 0.64263721190132, -93.9191, -1.63919752550981),
(29189, '65735', 218, 29, 17745, 38.0074, 0.663354270122493, -93.4675, -1.6313156186078),
(29190, '65737', 218, 29, 57129, 36.6517, 0.639692841453206, -93.4264, -1.63059828828523),
(29191, '65738', 218, 29, 5356, 37.1202, 0.647869708998799, -93.4697, -1.63135401585134),
(29192, '65739', 218, 29, 24319, 36.5399, 0.637741563349476, -93.2795, -1.62803439961405),
(29193, '65740', 218, 29, 50954, 36.7029, 0.640586450030227, -93.162, -1.62598363774296),
(29194, '65741', 218, 29, 24458, 36.7896, 0.642099650491706, -92.409, -1.61284130847544),
(29195, '65742', 218, 29, 5512, 37.1146, 0.647771970560687, -93.0587, -1.62418071262565),
(29196, '65744', 218, 29, 57299, 36.6374, 0.63944325937017, -92.9118, -1.62161682395447),
(29197, '65745', 218, 29, 57473, 36.5272, 0.637519906534473, -93.9375, -1.63951866609217),
(29198, '65746', 218, 29, 5745, 37.1461, 0.648321749275066, -92.7686, -1.61911751246561),
(29199, '65747', 218, 29, 57526, 36.5952, 0.638706730425829, -93.576, -1.63320930084621),
(29200, '65752', 218, 29, 57629, 37.3675, 0.652185908238981, -93.8459, -1.63791994449735),
(29201, '65753', 218, 29, 25003, 36.9496, 0.644892177294897, -93.1246, -1.62533088460271),
(29202, '65754', 218, 29, 43170, 36.8571, 0.643277747736802, -93.2686, -1.62784415872558),
(29203, '65755', 218, 29, 51662, 36.8465, 0.643092742836091, -92.5824, -1.6158677093984),
(29204, '65756', 218, 29, 57749, 37.1112, 0.64771262936612, -93.958, -1.63987645858883),
(29205, '65757', 218, 29, 57753, 37.268, 0.650449305633247, -93.115, -1.62516333299452),
(29206, '65759', 218, 29, 57832, 36.7478, 0.641370102864372, -93.0116, -1.62335866254796),
(29207, '65760', 218, 29, 6262, 36.5877, 0.638575830731929, -92.2579, -1.61020411597568),
(29208, '65761', 218, 29, 57874, 36.5821, 0.638478092293818, -92.7143, -1.61816979868178),
(29209, '65762', 218, 29, 57886, 36.7078, 0.640671971163574, -92.6523, -1.61708769454554),
(29210, '65764', 218, 29, 686, 37.8365, 0.660371502430835, -92.959, -1.62244061936141),
(29211, '65765', 218, 29, 57959, 37.1819, 0.64894657714728, -93.1561, -1.62588066331709),
(29212, '65766', 218, 29, 34208, 36.5258, 0.637495471924945, -92.2344, -1.60979396360146),
(29213, '65767', 218, 29, 12500, 37.8951, 0.661394265372503, -93.5419, -1.63261414357128),
(29214, '65768', 218, 29, 38669, 36.9716, 0.645276149730336, -92.1991, -1.6091778623755),
(29215, '65769', 218, 29, 12546, 36.9644, 0.645150486024192, -93.7931, -1.63699841065229),
(29216, '65770', 218, 29, 72, 37.411, 0.652945126463599, -93.547, -1.63270315536314),
(29217, '65771', 218, 29, 58118, 36.7689, 0.641738367336543, -93.2266, -1.62711112043975),
(29218, '65772', 218, 29, 12668, 36.678, 0.64015186304648, -93.8822, -1.63855349901582),
(29219, '65773', 218, 29, 58162, 36.743, 0.641286327060277, -92.5188, -1.61475767999413),
(29220, '65774', 218, 29, 58176, 37.8913, 0.661327942860927, -93.5407, -1.63259319962026),
(29221, '65775', 218, 29, 58225, 36.7346, 0.641139719403109, -91.8621, -1.60329610279628),
(29222, '65776', 218, 29, 38288, 36.6255, 0.639235565189183, -91.9179, -1.6042699965189),
(29223, '65777', 218, 29, 4301, 36.5367, 0.637685712813412, -91.9905, -1.60553710555584),
(29224, '65778', 218, 29, 10720, 36.5207, 0.637406460133093, -91.2585, -1.59276129543125),
(29225, '65779', 218, 29, 31509, 37.8912, 0.661326197531675, -93.5419, -1.63261414357128),
(29226, '65781', 218, 29, 26074, 37.3039, 0.651075878834713, -93.4363, -1.63077107588118),
(29227, '65783', 218, 29, 38914, 37.7133, 0.658221256792377, -92.935, -1.62202174034093),
(29228, '65784', 218, 29, 58391, 36.6869, 0.640307197349908, -92.3048, -1.61102267539486),
(29229, '65785', 218, 29, 510, 37.6958, 0.657915824173278, -93.7989, -1.63709963974891),
(29230, '65786', 218, 29, 56037, 37.9771, 0.662825435359139, -92.9692, -1.62261864294511),
(29231, '65787', 218, 29, 17819, 38.0106, 0.663410120658557, -92.8086, -1.61981564416641),
(29232, '65788', 218, 29, 56825, 36.8382, 0.642947880508175, -91.7634, -1.60157346282456),
(29233, '65789', 218, 29, 24061, 36.8443, 0.643054345592547, -91.9184, -1.60427872316516),
(29234, '65790', 218, 29, 30886, 36.7013, 0.640558524762195, -92.0473, -1.60652845257098),
(29235, '65791', 218, 29, 28771, 36.5233, 0.637451838693645, -91.5442, -1.59774770110419),
(29236, '65793', 218, 29, 6844, 36.9936, 0.645660122165774, -91.9673, -1.60513218916938),
(29237, '65801', 218, 29, 349, 37.1308, 0.648054713899511, -93.2916, -1.62824558445354),
(29238, '65802', 218, 29, 349, 37.2121, 0.649473666581382, -93.3047, -1.62847422258555),
(29239, '65803', 218, 29, 349, 37.2446, 0.65004089858828, -93.2964, -1.62832936025764),
(29240, '65804', 218, 29, 349, 37.162, 0.648599256626133, -93.2463, -1.62745495030239),
(29241, '65805', 218, 29, 349, 37.2569, 0.650255574086275, -93.3168, -1.62868540742504),
(29242, '65806', 218, 29, 349, 37.2051, 0.649351493533742, -93.2988, -1.62837124815969),
(29243, '65807', 218, 29, 349, 37.1666, 0.648679541771724, -93.3129, -1.62861733958422),
(29244, '65808', 218, 29, 349, 37.1882, 0.649056532890155, -93.2617, -1.6277237310072),
(29245, '65809', 218, 29, 349, 37.1782, 0.648881999964956, -93.2079, -1.62678474386962),
(29246, '65810', 218, 29, 349, 37.122, 0.647901124925335, -93.3181, -1.62870809670532),
(29247, '65814', 218, 29, 349, 37.2153, 0.649529517117446, -93.2981, -1.62835903085492),
(29248, '65817', 218, 29, 349, 37.1668, 0.648683032430229, -93.3257, -1.62884074172847),
(29249, '65890', 218, 29, 349, 37.2065, 0.64937592814327, -93.3509, -1.62928056469997),
(29250, '65898', 218, 29, 349, 37.2156, 0.649534753105202, -93.2951, -1.62830667097736),
(29251, '65899', 218, 29, 349, 37.1493, 0.648377599811129, -93.2509, -1.62753523544798),
(29252, '66002', 218, 20, 31687, 39.5636, 0.690515083942029, -95.128, -1.66029681083717),
(29253, '66006', 218, 20, 31723, 38.7759, 0.676767125424069, -95.1893, -1.66136669766864),
(29254, '66007', 218, 20, 31744, 39.137, 0.683069509353021, -94.9324, -1.65688294682026),
(29255, '66008', 218, 20, 31796, 39.7023, 0.692935855614545, -95.1769, -1.66115027684139),
(29256, '66010', 218, 20, 26551, 38.0955, 0.6648919051935, -95.0047, -1.65814481986946),
(29257, '66012', 218, 20, 31870, 39.0737, 0.681964715936508, -94.8847, -1.65605042476706),
(29258, '66013', 218, 20, 31910, 38.7845, 0.676917223739741, -94.6971, -1.65277618709032),
(29259, '66014', 218, 20, 1459, 38.2131, 0.666944412393845, -94.9861, -1.65782018862859),
(29260, '66015', 218, 20, 1714, 38.0718, 0.664478262160777, -95.3643, -1.66442102385963),
(29261, '66016', 218, 20, 15691, 39.4843, 0.689131037845197, -95.2909, -1.66313995218866),
(29262, '66017', 218, 20, 8484, 39.7528, 0.693817246886802, -94.8688, -1.655772917416),
(29263, '66018', 218, 20, 26922, 38.968, 0.68011990291715, -94.9679, -1.65750253870472),
(29264, '66019', 218, 20, 32090, 38.9311, 0.679475876423164, -94.7686, -1.6540240975055),
(29265, '66020', 218, 20, 2193, 39.3444, 0.686689322221657, -95.1157, -1.66008213533917),
(29266, '66021', 218, 20, 32304, 38.7713, 0.676686840278477, -95.0042, -1.6581360932232),
(29267, '66023', 218, 20, 27055, 39.4866, 0.689171180417993, -95.4524, -1.66595865893064),
(29268, '66024', 218, 20, 15933, 39.7561, 0.693874842752118, -94.8771, -1.65591777974391),
(29269, '66025', 218, 20, 8789, 38.9423, 0.679671353299388, -95.1031, -1.65986222385342),
(29270, '66026', 218, 20, 32455, 38.4227, 0.670602622506025, -94.8391, -1.65525455462815),
(29271, '66027', 218, 20, 0, 39.345, 0.686699794197169, -94.9247, -1.65674855646786),
(29272, '66030', 218, 20, 9048, 38.815, 0.677449549161599, -94.9316, -1.65686898418625),
(29273, '66031', 218, 20, 0, 38.812, 0.677397189284039, -94.9256, -1.65676426443113),
(29274, '66032', 218, 20, 9064, 38.2838, 0.668178360175005, -95.2405, -1.66226030624566),
(29275, '66033', 218, 20, 32621, 38.3682, 0.669651418063688, -95.1261, -1.66026364958138),
(29276, '66035', 218, 20, 3108, 39.8604, 0.695695221161948, -95.2663, -1.66271060119267),
(29277, '66036', 218, 20, 3147, 38.6637, 0.674808866003332, -94.8512, -1.65546573946765),
(29278, '66039', 218, 20, 27625, 38.103, 0.665022804887399, -95.1319, -1.66036487867799),
(29279, '66040', 218, 20, 32950, 38.3584, 0.669480375796993, -94.7419, -1.65355809459522),
(29280, '66041', 218, 20, 16841, 39.5715, 0.690652964952936, -95.3028, -1.66334764636965),
(29281, '66042', 218, 20, 3658, 38.4387, 0.670881875186344, -95.0825, -1.65950268602751),
(29282, '66043', 218, 20, 9985, 39.2558, 0.68514296050439, -94.9005, -1.65632618678888),
(29283, '66044', 218, 20, 3696, 38.9644, 0.680057071064079, -95.254, -1.66249592569468),
(29284, '66045', 218, 20, 3696, 38.9577, 0.679940134004195, -95.2642, -1.66267394927838),
(29285, '66046', 218, 20, 3696, 38.9421, 0.679667862640884, -95.258, -1.66256573886476),
(29286, '66047', 218, 20, 3696, 38.944, 0.679701023896672, -95.2814, -1.66297414590973),
(29287, '66048', 218, 20, 30314, 39.3069, 0.686034823752159, -94.9269, -1.65678695371141),
(29288, '66049', 218, 20, 3696, 38.9707, 0.680167026806954, -95.2797, -1.66294447531244),
(29289, '66050', 218, 20, 33021, 39.0397, 0.68137130399083, -95.3992, -1.66503014376857),
(29290, '66051', 218, 20, 33490, 38.8823, 0.678624155748191, -94.8181, -1.65488803548524),
(29291, '66052', 218, 20, 3793, 39.0016, 0.68070633354582, -95.038, -1.65872601451037),
(29292, '66053', 218, 20, 33143, 38.6235, 0.67410724364403, -94.6771, -1.65242712123992),
(29293, '66054', 218, 20, 33230, 39.1963, 0.684104489599453, -95.2075, -1.6616843475925),
(29294, '66056', 218, 20, 10620, 38.1418, 0.665699992637173, -94.811, -1.65476411710834),
(29295, '66058', 218, 20, 33377, 39.5987, 0.691127694509479, -95.4868, -1.66655905219332),
(29296, '66060', 218, 20, 28084, 39.4177, 0.687968648563369, -95.3312, -1.66384331987722),
(29297, '66061', 218, 20, 33490, 38.8848, 0.678667788979491, -94.8705, -1.65580258801328),
(29298, '66062', 218, 20, 33490, 38.8661, 0.678341412409368, -94.7734, -1.65410787330959),
(29299, '66063', 218, 20, 33490, 38.8811, 0.678603211797167, -94.8187, -1.65489850746075),
(29300, '66064', 218, 20, 33516, 38.4982, 0.671920346091281, -94.9533, -1.65724772063393),
(29301, '66066', 218, 20, 28160, 39.2149, 0.684429120840324, -95.3148, -1.66355708587989),
(29302, '66067', 218, 20, 33532, 38.6099, 0.673869878865759, -95.2658, -1.66270187454641),
(29303, '66070', 218, 20, 33553, 39.2072, 0.684294730487921, -95.4499, -1.66591502569934),
(29304, '66071', 218, 20, 17526, 38.5775, 0.673304392188112, -94.8731, -1.65584796657383),
(29305, '66072', 218, 20, 4872, 38.3286, 0.668960267679899, -94.9912, -1.65790920042044),
(29306, '66073', 218, 20, 11148, 39.0763, 0.68201009449706, -95.3915, -1.66489575341617),
(29307, '66075', 218, 20, 820, 38.1758, 0.666293404582851, -94.7096, -1.65299435324682),
(29308, '66076', 218, 20, 24061, 38.6099, 0.673869878865759, -95.4523, -1.66595691360138),
(29309, '66077', 218, 20, 5197, 39.4255, 0.688104784245024, -95.1415, -1.66053243028619),
(29310, '66078', 218, 20, 5231, 38.487, 0.671724869215058, -95.2747, -1.66285720884984),
(29311, '66079', 218, 20, 33723, 38.5485, 0.672798246705034, -95.0998, -1.6598046279881),
(29312, '66080', 218, 20, 5381, 38.4025, 0.670250065997122, -95.2531, -1.66248021773141),
(29313, '66083', 218, 20, 719, 38.7535, 0.676376171671623, -94.8278, -1.65505733242268),
(29314, '66085', 218, 20, 34058, 38.8025, 0.6772313830051, -94.6498, -1.65195064635413),
(29315, '66086', 218, 20, 34141, 39.107, 0.682545910577422, -95.0872, -1.65958471650235),
(29316, '66087', 218, 20, 199, 39.7876, 0.694424621466496, -95.0871, -1.6595829711731),
(29317, '66088', 218, 20, 34238, 39.3424, 0.686654415636617, -95.46, -1.66609130395379),
(29318, '66090', 218, 20, 34352, 39.764, 0.694012723763025, -94.9495, -1.65718139812236),
(29319, '66091', 218, 20, 34371, 39.5676, 0.690584897112108, -97.6593, -1.7044763301929),
(29320, '66092', 218, 20, 34380, 38.6969, 0.675388315314994, -95.1498, -1.6606772926141),
(29321, '66093', 218, 20, 31504, 38.156, 0.665947829390956, -95.4564, -1.66602847210072),
(29322, '66094', 218, 20, 31515, 39.9423, 0.697124645819331, -95.2861, -1.66305617638457),
(29323, '66095', 218, 20, 6831, 38.4802, 0.671606186825922, -95.4658, -1.6661925330504),
(29324, '66097', 218, 20, 12894, 39.3067, 0.686031333093655, -95.2761, -1.66288164345937),
(29325, '66101', 218, 20, 32892, 39.1173, 0.682725679490378, -94.6303, -1.65161030714999),
(29326, '66102', 218, 20, 32892, 39.1139, 0.68266633829581, -94.6809, -1.6524934437515),
(29327, '66103', 218, 20, 32892, 39.0603, 0.681730841816741, -94.6355, -1.65170106427109),
(29328, '66104', 218, 20, 32892, 39.1376, 0.683079981328533, -94.6803, -1.65248297177599),
(29329, '66105', 218, 20, 32892, 39.0872, 0.682200335385528, -94.6304, -1.65161205247924),
(29330, '66106', 218, 20, 32892, 39.0633, 0.681783201694301, -94.6905, -1.65266099535969),
(29331, '66109', 218, 20, 32892, 39.1441, 0.683193427729912, -94.7986, -1.6545476962811),
(29332, '66110', 218, 20, 32892, 39.1164, 0.68270997152711, -94.6914, -1.65267670332296),
(29333, '66111', 218, 20, 32892, 39.081, 0.682092124971904, -94.7931, -1.65445170317224),
(29334, '66112', 218, 20, 32892, 39.1157, 0.682697754222346, -94.7638, -1.6539403217014),
(29335, '66113', 218, 20, 2239, 39.0654, 0.681819853608593, -94.7996, -1.65456514957362),
(29336, '66115', 218, 20, 32892, 39.1402, 0.683125359889085, -94.6201, -1.65143228356629),
(29337, '66117', 218, 20, 32892, 39.117, 0.682720443502622, -94.6249, -1.65151605937038),
(29338, '66118', 218, 20, 32892, 39.1036, 0.682486569382855, -94.6122, -1.65129440255538),
(29339, '66119', 218, 20, 32892, 39.0869, 0.682195099397772, -94.6378, -1.65174120684389),
(29340, '66160', 218, 20, 32892, 39.0552, 0.681641830024889, -94.6105, -1.6512647319581),
(29341, '66201', 218, 20, 14256, 38.9688, 0.680133865551166, -94.6748, -1.65238697866713),
(29342, '66202', 218, 20, 14256, 39.0231, 0.681081579334999, -94.6683, -1.65227353226575),
(29343, '66203', 218, 20, 5783, 39.0207, 0.681039691432951, -94.7041, -1.65289836013796),
(29344, '66204', 218, 20, 33544, 38.9908, 0.680517837986605, -94.6804, -1.65248471710524),
(29345, '66205', 218, 20, 14256, 39.031, 0.681219460345907, -94.6312, -1.65162601511326),
(29346, '66206', 218, 20, 33017, 38.9608, 0.679994239211007, -94.6195, -1.65142181159077),
(29347, '66207', 218, 20, 33544, 38.9581, 0.679947115321203, -94.6441, -1.65185116258677),
(29348, '66208', 218, 20, 33684, 38.9973, 0.680631284387985, -94.6319, -1.65163823241802),
(29349, '66209', 218, 20, 33017, 38.9023, 0.67897322159859, -94.633, -1.65165743103979),
(29350, '66210', 218, 20, 33544, 38.9235, 0.679343231400013, -94.7073, -1.65295421067403),
(29351, '66211', 218, 20, 33017, 38.9247, 0.679364175351037, -94.6401, -1.65178134941669),
(29352, '66212', 218, 20, 33544, 38.9577, 0.679940134004195, -94.6821, -1.65251438770252),
(29353, '66213', 218, 20, 33544, 38.9029, 0.678983693574102, -94.7037, -1.65289137882095),
(29354, '66214', 218, 20, 33544, 38.961, 0.679997729869511, -94.7139, -1.65306940240466),
(29355, '66215', 218, 20, 33026, 38.9621, 0.680016928491283, -94.742, -1.65355983992447),
(29356, '66216', 218, 20, 5783, 39.0111, 0.68087213982476, -94.7395, -1.65351620669317),
(29357, '66217', 218, 20, 5783, 39.0095, 0.680844214556728, -94.7793, -1.65421084773546),
(29358, '66218', 218, 20, 5783, 39.014, 0.680922754373068, -94.818, -1.65488629015598),
(29359, '66219', 218, 20, 33026, 38.9648, 0.680064052381086, -94.7661, -1.6539804642742),
(29360, '66220', 218, 20, 33026, 38.9667, 0.680097213636874, -94.8177, -1.65488105416823),
(29361, '66221', 218, 20, 33544, 38.8624, 0.678276835227044, -94.7014, -1.65285123624816),
(29362, '66222', 218, 20, 14256, 39.0223, 0.681067616700983, -94.6477, -1.65191399443984),
(29363, '66223', 218, 20, 33544, 38.8561, 0.678166879484169, -94.667, -1.65225084298547),
(29364, '66224', 218, 20, 33544, 38.8655, 0.678330940433856, -94.6284, -1.6515771458942),
(29365, '66225', 218, 20, 33544, 38.8875, 0.678714912869295, -94.6866, -1.65259292751886),
(29366, '66226', 218, 20, 5783, 39.0229, 0.681078088676495, -94.8603, -1.65562456442958),
(29367, '66227', 218, 20, 33026, 38.9786, 0.680304907817862, -94.8663, -1.6557292841847),
(29368, '66250', 218, 20, 0, 38.9579, 0.679943624662699, -94.7888, -1.6543766540144),
(29369, '66251', 218, 20, 33544, 39.0202, 0.681030964786691, -94.6647, -1.65221070041268),
(29370, '66276', 218, 20, 0, 39.0041, 0.68074996677712, -94.6695, -1.65229447621677),
(29371, '66279', 218, 20, 0, 39.0218, 0.681058890054723, -94.6642, -1.65220197376642),
(29372, '66282', 218, 20, 33544, 38.9518, 0.679837159578327, -94.6854, -1.65257198356784),
(29373, '66283', 218, 20, 33544, 38.8625, 0.678278580556296, -94.6687, -1.65228051358276),
(29374, '66285', 218, 20, 33026, 39.0184, 0.680999548860155, -94.6659, -1.6522316443637),
(29375, '66286', 218, 20, 5783, 38.9941, 0.680575433851921, -94.8727, -1.65584098525682),
(29376, '66401', 218, 20, 7066, 38.9637, 0.680044853759315, -96.2443, -1.67977992127718),
(29377, '66402', 218, 20, 13306, 38.9088, 0.67908666799997, -95.8279, -1.67251237027187),
(29378, '66403', 218, 20, 31713, 39.8717, 0.695892443367423, -96.2572, -1.68000506875069),
(29379, '66404', 218, 20, 31717, 39.8442, 0.695412477823125, -96.185, -1.67874494103075),
(29380, '66406', 218, 20, 31763, 39.8616, 0.695716165112972, -96.4195, -1.68283773812667),
(29381, '66407', 218, 20, 31794, 39.245, 0.684954464945175, -96.1779, -1.67862102265385),
(29382, '66408', 218, 20, 31807, 39.9571, 0.697382954548626, -95.9569, -1.67476384500695),
(29383, '66409', 218, 20, 19225, 38.9246, 0.679362430021785, -95.5915, -1.66838641192016),
(29384, '66411', 218, 20, 31856, 39.6826, 0.692592025751902, -96.659, -1.6870178016852),
(29385, '66412', 218, 20, 1103, 39.871, 0.695880226062659, -96.7492, -1.6885920886705),
(29386, '66413', 218, 20, 26656, 38.7536, 0.676377917000874, -95.827, -1.67249666230861),
(29387, '66414', 218, 20, 19772, 38.8183, 0.677507145026915, -95.6934, -1.67016490242794),
(29388, '66415', 218, 20, 26746, 39.7236, 0.693307610745219, -96.1296, -1.67777802862514),
(29389, '66416', 218, 20, 29475, 39.5085, 0.68955340752418, -95.8574, -1.67302724240121),
(29390, '66417', 218, 20, 8235, 39.6415, 0.691874695429332, -96.0958, -1.67718810733797),
(29391, '66418', 218, 20, 32224, 39.2852, 0.685656087304476, -95.9535, -1.67470450381238),
(29392, '66419', 218, 20, 32227, 39.4626, 0.688752301397514, -95.7417, -1.67100789645665),
(29393, '66420', 218, 20, 8583, 38.97, 0.68015480950219, -95.933, -1.67434671131572),
(29394, '66422', 218, 20, 32360, 39.3079, 0.686052277044679, -96.0572, -1.6765144102467),
(29395, '66423', 218, 20, 32383, 38.8589, 0.678215748703225, -96.1065, -1.67737485756793),
(29396, '66424', 218, 20, 32397, 39.7075, 0.693026612735648, -95.396, -1.66497429323251),
(29397, '66425', 218, 20, 500, 39.8491, 0.695497998956472, -95.7042, -1.67035339798716),
(29398, '66426', 218, 20, 2568, 39.4294, 0.688172852085852, -96.488, -1.68403328866429),
(29399, '66427', 218, 20, 2594, 39.7052, 0.692986470162853, -96.4182, -1.6828150488464),
(29400, '66428', 218, 20, 32566, 39.6534, 0.692082389610319, -95.9574, -1.67477257165321),
(29401, '66429', 218, 20, 21522, 39.0968, 0.682367886993719, -95.5296, -1.66730605311318),
(29402, '66431', 218, 20, 32704, 38.7903, 0.677018452836356, -95.9623, -1.67485809278655),
(29403, '66432', 218, 20, 32708, 39.5156, 0.689677325901071, -96.1203, -1.67761571300471),
(29404, '66434', 218, 20, 32748, 39.8536, 0.695576538772812, -95.5336, -1.66737586628326),
(29405, '66436', 218, 20, 30100, 39.4645, 0.688785462653302, -95.7387, -1.6709555365791),
(29406, '66438', 218, 20, 32789, 39.8422, 0.695377571238085, -96.522, -1.68462670060997),
(29407, '66439', 218, 20, 468, 39.6644, 0.692274375828039, -95.5281, -1.6672798731744),
(29408, '66440', 218, 20, 9600, 39.2496, 0.685034750090766, -95.7069, -1.67040052187696),
(29409, '66441', 218, 20, 9806, 39.028, 0.681167100468347, -96.8378, -1.69013845038776),
(29410, '66442', 218, 20, 0, 39.0725, 0.681943771985484, -96.7988, -1.68945777197949),
(29411, '66449', 218, 20, 33031, 39.3631, 0.68701569879178, -96.8325, -1.69004594793741),
(29412, '66450', 218, 20, 3876, 39.3027, 0.685961519923575, -96.3314, -1.68130010305567),
(29413, '66451', 218, 20, 33157, 38.6102, 0.673875114853515, -95.6865, -1.67004447470955),
(29414, '66501', 218, 20, 33228, 39.0539, 0.681619140744613, -96.2367, -1.67964727625403),
(29415, '66502', 218, 20, 17009, 39.1958, 0.684095762953193, -96.5972, -1.68593918820747),
(29416, '66503', 218, 20, 17009, 39.2112, 0.684364543658, -96.6402, -1.68668967978582),
(29417, '66505', 218, 20, 17009, 39.1903, 0.683999769844334, -96.5897, -1.68580828851357),
(29418, '66506', 218, 20, 17009, 39.1852, 0.683910758052482, -96.5727, -1.68551158254073),
(29419, '66507', 218, 20, 3980, 39.0858, 0.682175900776, -96.0264, -1.67597684883708),
(29420, '66508', 218, 20, 10343, 39.8441, 0.695410732493873, -96.6447, -1.68676821960216),
(29421, '66509', 218, 20, 33219, 39.34, 0.686612527734569, -95.7183, -1.67059948941169),
(29422, '66510', 218, 20, 33245, 38.5063, 0.672061717760693, -95.6371, -1.66918228205907),
(29423, '66512', 218, 20, 33252, 39.1886, 0.68397009924705, -95.5673, -1.66796404224118),
(29424, '66514', 218, 20, 10480, 39.1731, 0.683699573212991, -96.9114, -1.69142301271723),
(29425, '66515', 218, 20, 33340, 39.9499, 0.697257290842483, -95.7293, -1.67079147562941),
(29426, '66516', 218, 20, 33426, 39.6096, 0.691317935397946, -95.7323, -1.67084383550697),
(29427, '66517', 218, 20, 10927, 39.1131, 0.682652375661794, -96.7092, -1.6878939569697),
(29428, '66518', 218, 20, 33488, 39.9577, 0.697393426524138, -96.6355, -1.68660764931098),
(29429, '66520', 218, 20, 33496, 39.4147, 0.687916288685809, -96.6003, -1.68599329341428),
(29430, '66521', 218, 20, 33498, 39.4916, 0.689258446880593, -96.1691, -1.67846743367968),
(29431, '66522', 218, 20, 10986, 39.8697, 0.695857536782383, -95.9579, -1.67478129829947),
(29432, '66523', 218, 20, 33509, 38.6323, 0.674260832618205, -95.8273, -1.67250189829636),
(29433, '66524', 218, 20, 4813, 38.7741, 0.676735709497533, -95.5575, -1.66779299997448),
(29434, '66526', 218, 20, 33591, 39.0684, 0.681872213486153, -96.1669, -1.67842903643613),
(29435, '66527', 218, 20, 33680, 38.762, 0.676524524658042, -95.6311, -1.66907756230395),
(29436, '66528', 218, 20, 33712, 38.5812, 0.673368969370436, -95.5281, -1.6672798731744),
(29437, '66531', 218, 20, 5401, 39.2943, 0.685814912266408, -96.8129, -1.68970386340402),
(29438, '66532', 218, 20, 11625, 39.8162, 0.694923785632566, -95.4105, -1.66522736597405),
(29439, '66533', 218, 20, 24541, 39.1544, 0.683373196642868, -95.9609, -1.67483365817703),
(29440, '66534', 218, 20, 33849, 39.9038, 0.696452694057313, -95.8009, -1.67204113137384),
(29441, '66535', 218, 20, 14538, 39.2273, 0.684645541667572, -96.4373, -1.68314840673353),
(29442, '66536', 218, 20, 24606, 39.1971, 0.684118452233469, -96.0669, -1.67668370718414),
(29443, '66537', 218, 20, 5701, 38.7783, 0.676809013326117, -95.7369, -1.67092412065256),
(29444, '66538', 218, 20, 18037, 39.839, 0.695321720702021, -96.0422, -1.6762526108589),
(29445, '66539', 218, 20, 18083, 39.1398, 0.683118378572077, -95.868, -1.67321224730192),
(29446, '66540', 218, 20, 33994, 39.1903, 0.683999769844334, -96.4157, -1.6827714156151),
(29447, '66541', 218, 20, 6148, 39.958, 0.697398662511894, -96.2947, -1.68065956722018),
(29448, '66542', 218, 20, 6262, 39.0201, 0.681029219457439, -95.5545, -1.66774064009692),
(29449, '66543', 218, 20, 34255, 38.6481, 0.67453659464002, -95.6211, -1.66890302937875),
(29450, '66544', 218, 20, 34261, 39.6882, 0.692689764190013, -96.2841, -1.68047456231947),
(29451, '66546', 218, 20, 34296, 38.8958, 0.67885977519721, -95.7092, -1.67044066444976),
(29452, '66547', 218, 20, 34329, 39.2118, 0.684375015633512, -96.317, -1.68104877564338),
(29453, '66548', 218, 20, 25838, 39.6915, 0.692747360055329, -96.7485, -1.68857987136573),
(29454, '66549', 218, 20, 34392, 39.3974, 0.687614346725214, -96.416, -1.68277665160285),
(29455, '66550', 218, 20, 34399, 39.6536, 0.692085880268823, -95.8451, -1.67281256690322),
(29456, '66552', 218, 20, 34415, 39.609, 0.691307463422434, -95.6202, -1.66888732141548),
(29457, '66554', 218, 20, 5293, 39.4223, 0.688048933708961, -96.7718, -1.68898653308145),
(29458, '66555', 218, 20, 10343, 39.8413, 0.695361863274817, -96.6477, -1.68682057947972),
(29459, '66601', 218, 20, 34152, 39.0561, 0.681657537988157, -95.676, -1.66986121513809),
(29460, '66603', 218, 20, 34152, 39.0558, 0.681652302000401, -95.6749, -1.66984201651632),
(29461, '66604', 218, 20, 34152, 39.0413, 0.681399229258862, -95.7275, -1.67076005970287),
(29462, '66605', 218, 20, 34152, 39.0131, 0.6809070464098, -95.6349, -1.66914388481553),
(29463, '66606', 218, 20, 34152, 39.0587, 0.681702916548709, -95.715, -1.67054189354637),
(29464, '66607', 218, 20, 34152, 39.0425, 0.681420173209886, -95.6453, -1.66932539905773),
(29465, '66608', 218, 20, 34152, 39.0783, 0.6820450010821, -95.6675, -1.66971286215168),
(29466, '66609', 218, 20, 34152, 38.9894, 0.680493403377077, -95.6559, -1.66951040395844),
(29467, '66610', 218, 20, 34152, 38.9811, 0.680348541049162, -95.7999, -1.67202367808132),
(29468, '66611', 218, 20, 34152, 39.0158, 0.680954170299604, -95.6969, -1.67022598895176),
(29469, '66612', 218, 20, 34152, 39.04, 0.681376539978586, -95.6791, -1.66991532034491),
(29470, '66614', 218, 20, 34152, 39.0143, 0.680927990360824, -95.7659, -1.67143026613564),
(29471, '66615', 218, 20, 34152, 39.0543, 0.681626122061621, -95.8559, -1.67300106246243),
(29472, '66616', 218, 20, 34152, 39.063, 0.681777965706545, -95.6403, -1.66923813259513),
(29473, '66617', 218, 20, 34152, 39.1316, 0.682975261573413, -95.6406, -1.66924336858289),
(29474, '66618', 218, 20, 34152, 39.1332, 0.683003186841445, -95.7292, -1.67078973030016),
(29475, '66619', 218, 20, 34152, 38.9497, 0.679800507664035, -95.7157, -1.67055411085114),
(29476, '66620', 218, 20, 34152, 38.9464, 0.679742911798719, -95.7138, -1.67052094959535),
(29477, '66621', 218, 20, 34152, 39.0397, 0.68137130399083, -95.7275, -1.67076005970287),
(29478, '66622', 218, 20, 34152, 39.0164, 0.680964642275116, -95.8224, -1.67241637716301),
(29479, '66624', 218, 20, 34152, 39.0146, 0.68093322634858, -95.6706, -1.66976696735849),
(29480, '66625', 218, 20, 34152, 39.048, 0.681516166318746, -95.6799, -1.66992928297892),
(29481, '66626', 218, 20, 34152, 39.0481, 0.681517911647998, -95.6801, -1.66993277363743),
(29482, '66628', 218, 20, 34152, 39.046, 0.681481259733706, -95.6732, -1.66981234591904),
(29483, '66629', 218, 20, 34152, 39.0461, 0.681483005062958, -95.6824, -1.66997291621022),
(29484, '66634', 218, 20, 34152, 39.0487, 0.68152838362351, -95.6777, -1.66989088573538),
(29485, '66636', 218, 20, 34152, 39.0566, 0.681666264634417, -95.6752, -1.66984725250408),
(29486, '66637', 218, 20, 34152, 39.0165, 0.680966387604368, -95.6938, -1.67017188374495),
(29487, '66638', 218, 20, 34152, 39.0482, 0.68151965697725, -95.6778, -1.66989263106463),
(29488, '66642', 218, 20, 34152, 39.0687, 0.681877449473909, -95.6657, -1.66968144622514),
(29489, '66647', 218, 20, 34152, 39.0405, 0.681385266624846, -95.7277, -1.67076355036138),
(29490, '66652', 218, 20, 34152, 39.0592, 0.681711643194969, -95.6697, -1.66975125939522),
(29491, '66653', 218, 20, 34152, 39.0589, 0.681706407207213, -95.6701, -1.66975824071223),
(29492, '66658', 218, 20, 34152, 39.0383, 0.681346869381302, -95.6922, -1.67014395847692),
(29493, '66667', 218, 20, 34152, 39.0402, 0.68138003063709, -95.7268, -1.67074784239811),
(29494, '66675', 218, 20, 34152, 39.0687, 0.681877449473909, -95.6658, -1.66968319155439),
(29495, '66683', 218, 20, 34152, 39.0562, 0.681659283317409, -95.6751, -1.66984550717483),
(29496, '66686', 218, 20, 34152, 39.0164, 0.680964642275116, -95.8215, -1.67240066919975),
(29497, '66692', 218, 20, 34152, 39.0597, 0.681720369841229, -95.67, -1.66975649538298),
(29498, '66699', 218, 20, 34152, 39.0537, 0.681615650086109, -95.6714, -1.6697809299925),
(29499, '66701', 218, 20, 32466, 37.8324, 0.660299943931503, -94.7022, -1.65286519888217),
(29500, '66710', 218, 20, 14978, 37.5218, 0.654878951274808, -95.6606, -1.66959243443329),
(29501, '66711', 218, 20, 7137, 37.6281, 0.656734236269678, -94.7016, -1.65285472690666),
(29502, '66712', 218, 20, 31673, 37.5678, 0.655681802730726, -94.7294, -1.65333992843872),
(29503, '66713', 218, 20, 31752, 37.0221, 0.646157541002593, -94.736, -1.65345512016935),
(29504, '66714', 218, 20, 19194, 37.6339, 0.656835465366294, -95.6322, -1.66909676092572),
(29505, '66716', 218, 20, 15335, 37.9447, 0.662259948681492, -95.0011, -1.65808198801638),
(29506, '66717', 218, 20, 26642, 37.6901, 0.657816340405915, -95.7244, -1.67070595449606),
(29507, '66720', 218, 20, 32033, 37.6774, 0.657594683590911, -95.4604, -1.6660982852708),
(29508, '66724', 218, 20, 5, 37.342, 0.651740849279723, -94.8268, -1.65503987913016),
(29509, '66725', 218, 20, 1718, 37.1707, 0.648751100271056, -94.8449, -1.65535578372477),
(29510, '66727', 218, 20, 32170, 37.6691, 0.657449821262996, -95.9155, -1.67404127869662),
(29511, '66728', 218, 20, 32179, 37.159, 0.648546896748573, -94.67, -1.65230320286303),
(29512, '66732', 218, 20, 32352, 37.8122, 0.6599473874226, -95.1572, -1.66080644697875),
(29513, '66733', 218, 20, 15943, 37.5693, 0.655707982669506, -95.2431, -1.66230568480621),
(29514, '66734', 218, 20, 32433, 37.6167, 0.656535268734951, -94.8599, -1.65561758311257),
(29515, '66735', 218, 20, 2595, 37.5262, 0.654955745761896, -94.7112, -1.65302227851485),
(29516, '66736', 218, 20, 2600, 37.5338, 0.655088390785048, -95.8215, -1.67240066919975),
(29517, '66738', 218, 20, 2628, 38.0103, 0.663404884670801, -94.7198, -1.65317237683053),
(29518, '66739', 218, 20, 9031, 37.0726, 0.64703893227485, -94.6351, -1.65169408295409),
(29519, '66740', 218, 20, 32506, 37.4697, 0.653969634734519, -95.3067, -1.66341571421048),
(29520, '66741', 218, 20, 2663, 37.7149, 0.658249182060409, -94.6844, -1.65255453027532),
(29521, '66742', 218, 20, 32533, 37.9237, 0.661893429538573, -95.3453, -1.66408941130175),
(29522, '66743', 218, 20, 2718, 37.5095, 0.654664275776813, -94.8356, -1.65519346810433),
(29523, '66746', 218, 20, 32735, 37.6525, 0.657160096607165, -95.0149, -1.65832284345316),
(29524, '66748', 218, 20, 27486, 37.8119, 0.659942151434844, -95.434, -1.66563751834827),
(29525, '66749', 218, 20, 16556, 37.9253, 0.661921354806605, -95.3931, -1.6649236786842),
(29526, '66751', 218, 20, 32952, 37.9168, 0.661773001820186, -95.3127, -1.6635204339656),
(29527, '66753', 218, 20, 33226, 37.3537, 0.651945052802206, -95.0198, -1.65840836458651),
(29528, '66754', 218, 20, 30422, 38.018, 0.663539275023204, -94.8751, -1.65588287315887),
(29529, '66755', 218, 20, 10585, 37.9435, 0.662239004730468, -95.1523, -1.6607209258454),
(29530, '66756', 218, 20, 4454, 37.5483, 0.655341463526587, -94.6831, -1.65253184099504),
(29531, '66757', 218, 20, 33390, 37.425, 0.653189472558878, -95.6805, -1.66993975495443),
(29532, '66758', 218, 20, 33395, 37.9727, 0.662748640872051, -95.5553, -1.66775460273094),
(29533, '66759', 218, 20, 30614, 37.5677, 0.655680057401474, -95.9412, -1.67448982831438),
(29534, '66760', 218, 20, 33501, 37.3464, 0.65181764376681, -94.6193, -1.65141832093227),
(29535, '66761', 218, 20, 33629, 37.8644, 0.660858449292141, -95.5924, -1.66840211988343),
(29536, '66762', 218, 20, 5099, 37.4131, 0.652981778377891, -94.6994, -1.65281632966312),
(29537, '66763', 218, 20, 16145, 37.4534, 0.653685146066444, -94.6947, -1.65273429918827),
(29538, '66767', 218, 20, 5219, 38.18, 0.666366708411435, -94.7051, -1.65291581343048),
(29539, '66769', 218, 20, 11515, 37.8591, 0.660765946841785, -94.8325, -1.65513936289752),
(29540, '66770', 218, 20, 5429, 37.1014, 0.647541587099424, -94.6704, -1.65231018418004),
(29541, '66771', 218, 20, 11759, 37.5175, 0.654803902116973, -95.1677, -1.66098970655021),
(29542, '66772', 218, 20, 33896, 37.7551, 0.658950804419711, -95.1609, -1.66087102416107),
(29543, '66773', 218, 20, 33900, 37.2663, 0.650419635035963, -94.8515, -1.6554709754554),
(29544, '66775', 218, 20, 25089, 37.6868, 0.657758744540599, -95.1293, -1.66031950011744),
(29545, '66776', 218, 20, 28771, 37.4876, 0.654282048670626, -95.4729, -1.66631645142729),
(29546, '66777', 218, 20, 28798, 37.7989, 0.659715258632085, -95.9488, -1.67462247333754),
(29547, '66778', 218, 20, 34188, 37.0003, 0.645777059225658, -94.8432, -1.65532611312749),
(29548, '66779', 218, 20, 6475, 37.768, 0.659175951893218, -94.9935, -1.65794934299323),
(29549, '66780', 218, 20, 12616, 37.6011, 0.65626299737164, -95.0828, -1.65950792201526),
(29550, '66781', 218, 20, 28929, 37.3046, 0.651088096139477, -94.7705, -1.65405725876129),
(29551, '66782', 218, 20, 34387, 37.2844, 0.650735539630574, -94.9257, -1.65676600976038),
(29552, '66783', 218, 20, 34479, 37.8807, 0.661142937960216, -95.7322, -1.67084209017772),
(29553, '66801', 218, 20, 15935, 38.4094, 0.67037049371551, -96.1872, -1.67878333827429),
(29554, '66830', 218, 20, 31600, 38.6371, 0.674344608422301, -96.0973, -1.67721428727675),
(29555, '66833', 218, 20, 18798, 38.6354, 0.674314937825017, -96.2419, -1.67973803337513),
(29556, '66834', 218, 20, 18822, 38.8683, 0.678379809652912, -96.4868, -1.68401234471326),
(29557, '66835', 218, 20, 18837, 38.5062, 0.672059972431441, -96.2608, -1.68006790060376),
(29558, '66838', 218, 20, 31919, 38.5659, 0.673101933994881, -96.8192, -1.68981381914689),
(29559, '66839', 218, 20, 1239, 38.1957, 0.666640725103998, -95.7456, -1.67107596429748),
(29560, '66840', 218, 20, 1244, 38.089, 0.66477845879212, -96.8861, -1.69098144441648),
(29561, '66842', 218, 20, 31981, 38.028, 0.663713807948404, -96.655, -1.68694798851512),
(29562, '66843', 218, 20, 1427, 38.2895, 0.668277843942369, -96.7485, -1.68857987136573),
(29563, '66845', 218, 20, 32156, 38.365, 0.669595567527625, -96.5443, -1.68501590903316),
(29564, '66846', 218, 20, 32158, 38.661, 0.674761742113528, -96.4909, -1.6840839032126),
(29565, '66849', 218, 20, 2144, 38.8261, 0.67764328070857, -96.5659, -1.68539290015159),
(29566, '66850', 218, 20, 32346, 38.378, 0.669822460330384, -96.7162, -1.68801613001734),
(29567, '66851', 218, 20, 2502, 38.2433, 0.667471501827947, -96.9281, -1.69171448270232),
(29568, '66852', 218, 20, 32637, 38.0967, 0.664912849144524, -95.8837, -1.67348626399449),
(29569, '66853', 218, 20, 2950, 37.9846, 0.662956335053038, -96.1998, -1.67900324976004),
(29570, '66854', 218, 20, 2998, 38.3082, 0.668604220512492, -95.9569, -1.67476384500695),
(29571, '66855', 218, 20, 9971, 38.1153, 0.665237480385395, -96.0251, -1.67595415955681),
(29572, '66856', 218, 20, 33020, 38.388, 0.669996993255583, -95.8446, -1.67280384025696),
(29573, '66857', 218, 20, 33011, 38.0835, 0.664682465683261, -95.6332, -1.66911421421824),
(29574, '66858', 218, 20, 33086, 38.4936, 0.671840060945689, -96.9599, -1.69226949740445),
(29575, '66859', 218, 20, 33141, 38.5651, 0.673087971360865, -96.9855, -1.69271630169296),
(29576, '66860', 218, 20, 3938, 38.1342, 0.665567347614022, -96.136, -1.67788972969727),
(29577, '66861', 218, 20, 630, 38.3478, 0.669295370896282, -97.0139, -1.69321197520053),
(29578, '66862', 218, 20, 33214, 38.1437, 0.665733153892961, -96.4981, -1.68420956691874),
(29579, '66863', 218, 20, 23315, 37.836, 0.660362775784574, -96.0784, -1.67688442004812),
(29580, '66864', 218, 20, 33397, 38.3975, 0.670162799534523, -96.0236, -1.67592797961803),
(29581, '66865', 218, 20, 33495, 38.2485, 0.667562258949051, -96.2507, -1.67989162234931),
(29582, '66866', 218, 20, 28209, 38.1695, 0.666183448839976, -97.1077, -1.6948490940389),
(29583, '66868', 218, 20, 33727, 38.5397, 0.672644657730859, -96.0208, -1.67587911039897),
(29584, '66869', 218, 20, 34070, 38.3943, 0.670106948998459, -96.5358, -1.68486755604674),
(29585, '66870', 218, 20, 34285, 37.8706, 0.660966659705765, -96.0363, -1.67614963643303),
(29586, '66871', 218, 20, 6664, 38.3885, 0.670005719901843, -95.6003, -1.66854000089434),
(29587, '66872', 218, 20, 6770, 38.7974, 0.677142371213248, -96.7335, -1.68831807197793),
(29588, '66873', 218, 20, 34442, 38.6554, 0.674664003675416, -96.6951, -1.68764786554517),
(29589, '66901', 218, 20, 32136, 39.5675, 0.690583151782856, -97.6578, -1.70445015025412),
(29590, '66930', 218, 20, 31605, 39.6979, 0.692859061127457, -97.4241, -1.70037131579221),
(29591, '66932', 218, 20, 31693, 39.8087, 0.694792885938667, -98.5565, -1.72013542424179),
(29592, '66933', 218, 20, 216, 39.6529, 0.69207366296406, -96.8626, -1.69057129204226),
(29593, '66935', 218, 20, 263, 39.8233, 0.695047704009458, -97.6294, -1.70395447674655),
(29594, '66936', 218, 20, 31927, 39.9155, 0.696656897579797, -98.3865, -1.7171683645134),
(29595, '66937', 218, 20, 15559, 39.566, 0.690556971844076, -97.2797, -1.69785106035233),
(29596, '66938', 218, 20, 8151, 39.5916, 0.691003776132587, -97.4002, -1.69995418210098),
(29597, '66939', 218, 20, 1839, 39.7835, 0.694353062967164, -97.8969, -1.70862323249564),
(29598, '66940', 218, 20, 1912, 39.7851, 0.694380988235196, -97.4254, -1.70039400507248),
(29599, '66941', 218, 20, 32380, 39.8232, 0.695045958680206, -98.4311, -1.71794678135979),
(29600, '66942', 218, 20, 32461, 39.7782, 0.694260560516808, -97.9926, -1.7102935125898),
(29601, '66943', 218, 20, 32626, 39.7278, 0.693380914573803, -96.9779, -1.69258365666981),
(29602, '66944', 218, 20, 32657, 39.8565, 0.69562715332112, -97.3015, -1.69823154212926),
(29603, '66945', 218, 20, 2963, 39.8902, 0.696215329279042, -96.8905, -1.69105823890357),
(29604, '66946', 218, 20, 32783, 39.9575, 0.697389935865634, -96.9739, -1.69251384349973),
(29605, '66948', 218, 20, 3399, 39.5994, 0.691139911814243, -97.8614, -1.70800364061118),
(29606, '66949', 218, 20, 9764, 39.6705, 0.69238084091241, -98.153, -1.71309302070999),
(29607, '66951', 218, 20, 22347, 39.7666, 0.694058102323577, -99.0313, -1.72842224753026),
(29608, '66952', 218, 20, 3708, 39.8101, 0.694817320548195, -98.5571, -1.7201458962173),
(29609, '66953', 218, 20, 33091, 39.685, 0.69263391365395, -97.0765, -1.69430455131228),
(29610, '66955', 218, 20, 33176, 39.9588, 0.69741262514591, -97.3122, -1.69841829235923),
(29611, '66956', 218, 20, 33184, 39.7876, 0.694424621466496, -98.2085, -1.71406167844485),
(29612, '66958', 218, 20, 33345, 39.8448, 0.695422949798637, -97.1722, -1.69597483140643),
(29613, '66959', 218, 20, 33372, 39.9031, 0.696440476752549, -97.5336, -1.70228245132314),
(29614, '66960', 218, 20, 33379, 39.9589, 0.697414370475162, -97.4253, -1.70039225974323),
(29615, '66961', 218, 20, 33458, 39.7001, 0.692897458371001, -97.8285, -1.70742942728727),
(29616, '66962', 218, 20, 337, 39.6099, 0.691323171385702, -97.0869, -1.69448606555448),
(29617, '66963', 218, 20, 11462, 39.6112, 0.691345860665978, -98.0984, -1.71214007093841),
(29618, '66964', 218, 20, 5356, 39.9242, 0.69680874122472, -97.8235, -1.70734216082467),
(29619, '66966', 218, 20, 33902, 39.7956, 0.694564247806655, -97.7827, -1.70663006648986),
(29620, '66967', 218, 20, 33984, 39.7789, 0.694272777821572, -98.7845, -1.72411477493634),
(29621, '66968', 218, 20, 12671, 39.8176, 0.694948220242094, -97.0522, -1.69388043630404),
(29622, '66970', 218, 20, 34363, 39.9147, 0.696642934945781, -97.9873, -1.71020101013944),
(29623, '67001', 218, 20, 31647, 37.7865, 0.659498837804837, -97.631, -1.70398240201458),
(29624, '67002', 218, 20, 14988, 37.6998, 0.657985637343358, -97.1382, -1.69538141946076),
(29625, '67003', 218, 20, 15007, 37.1542, 0.648463120944477, -98.0286, -1.71092183112051),
(29626, '67004', 218, 20, 31667, 37.2646, 0.650389964438679, -97.7649, -1.706319397883),
(29627, '67005', 218, 20, 7148, 37.068, 0.646958647129258, -97.0381, -1.69363434487951),
(29628, '67008', 218, 20, 7187, 37.4325, 0.653320372252777, -96.7688, -1.68893417320389),
(29629, '67009', 218, 20, 7188, 37.2425, 0.650004246673988, -98.2266, -1.71437758303946),
(29630, '67010', 218, 20, 7193, 37.6924, 0.657856482978711, -96.9785, -1.69259412864532),
(29631, '67012', 218, 20, 31761, 37.7003, 0.657994363989618, -96.971, -1.69246322895142),
(29632, '67013', 218, 20, 31776, 37.3946, 0.652658892466272, -97.2795, -1.69784756969382),
(29633, '67016', 218, 20, 31801, 37.8873, 0.661258129690848, -97.5155, -1.70196654672853),
(29634, '67017', 218, 20, 358, 37.787, 0.659507564451097, -97.1091, -1.69487352864843),
(29635, '67018', 218, 20, 1011, 37.0717, 0.647023224311582, -97.88, -1.70832827185205),
(29636, '67019', 218, 20, 31917, 37.3187, 0.651334187564008, -96.7544, -1.6886828457916),
(29637, '67020', 218, 20, 31931, 38.028, 0.663713807948404, -97.5559, -1.70267165974634),
(29638, '67021', 218, 20, 19679, 37.7789, 0.659366192781686, -98.9035, -1.72619171674621),
(29639, '67022', 218, 20, 1290, 37.0418, 0.646501370865236, -97.6144, -1.70369267735875),
(29640, '67023', 218, 20, 1302, 37.183, 0.648965775769052, -96.714, -1.6879777327738),
(29641, '67024', 218, 20, 31992, 37.1053, 0.647609654940252, -96.5009, -1.6842584361378),
(29642, '67025', 218, 20, 32046, 37.63, 0.656767397525466, -97.777, -1.7065305827225),
(29643, '67026', 218, 20, 8122, 37.5409, 0.655212309161939, -97.4957, -1.70162097153664),
(29644, '67028', 218, 20, 697, 37.5139, 0.654741070263901, -98.9024, -1.72617251812444),
(29645, '67029', 218, 20, 1687, 37.2692, 0.650470249584271, -99.3221, -1.73349766499506),
(29646, '67030', 218, 20, 32131, 37.7589, 0.659017126931287, -97.5349, -1.70230514060342),
(29647, '67031', 218, 20, 32140, 37.3899, 0.652576861991428, -97.6433, -1.70419707751258),
(29648, '67035', 218, 20, 1923, 37.6465, 0.657055376852045, -98.4331, -1.71798168794483),
(29649, '67036', 218, 20, 1964, 37.255, 0.650222412830488, -97.8666, -1.70809439773228),
(29650, '67037', 218, 20, 2031, 37.561, 0.65556312034159, -97.2422, -1.69719656188283);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(29651, '67038', 218, 20, 2038, 37.1789, 0.64889421726972, -96.7163, -1.68801787534659),
(29652, '67039', 218, 20, 32253, 37.5164, 0.654784703495201, -97.0122, -1.69318230460324),
(29653, '67041', 218, 20, 32317, 38.0541, 0.664169338883174, -97.1272, -1.69518943324304),
(29654, '67042', 218, 20, 8703, 37.8203, 0.660088759092011, -96.8648, -1.6906096892858),
(29655, '67045', 218, 20, 2334, 37.823, 0.660135882981815, -96.2899, -1.68057579141609),
(29656, '67047', 218, 20, 32423, 37.6072, 0.656369462456011, -96.0279, -1.67600302877586),
(29657, '67049', 218, 20, 16142, 37.183, 0.648965775769052, -97.8565, -1.70791811947783),
(29658, '67050', 218, 20, 32518, 37.6706, 0.657476001201776, -97.6751, -1.70475209221471),
(29659, '67051', 218, 20, 32541, 37.1121, 0.647728337329388, -97.1505, -1.69559609495875),
(29660, '67052', 218, 20, 2756, 37.6578, 0.657252599057521, -97.579, -1.70307483080355),
(29661, '67053', 218, 20, 32565, 38.2459, 0.667516880388499, -97.3504, -1.69908500813349),
(29662, '67054', 218, 20, 29951, 37.603, 0.656296158627428, -99.2945, -1.73301595412151),
(29663, '67055', 218, 20, 32630, 37.7836, 0.65944822325653, -97.2006, -1.696470504914),
(29664, '67056', 218, 20, 32664, 38.0005, 0.663233842404105, -97.5088, -1.70184960966865),
(29665, '67057', 218, 20, 32684, 37.0147, 0.646028386637945, -98.6479, -1.72173065517811),
(29666, '67058', 218, 20, 16368, 37.2848, 0.650742520947582, -98.0256, -1.71086947124295),
(29667, '67059', 218, 20, 32710, 37.6176, 0.656550976698219, -99.1048, -1.72970506453048),
(29668, '67060', 218, 20, 21794, 37.5649, 0.655631188182418, -97.3516, -1.69910595208451),
(29669, '67061', 218, 20, 32727, 37.123, 0.647918578217855, -98.4031, -1.71745808916923),
(29670, '67062', 218, 20, 32744, 38.1385, 0.665642396771857, -97.4282, -1.70044287429154),
(29671, '67063', 218, 20, 3145, 38.351, 0.669351221432345, -97.2035, -1.69652111946231),
(29672, '67065', 218, 20, 27524, 37.4281, 0.65324357776569, -98.5192, -1.7194844164308),
(29673, '67066', 218, 20, 9676, 37.7572, 0.658987456334003, -98.7383, -1.72330843282192),
(29674, '67067', 218, 20, 32901, 37.7704, 0.659217839795266, -97.2941, -1.69810238776462),
(29675, '67068', 218, 20, 27631, 37.6474, 0.657071084815313, -98.1212, -1.71253800600786),
(29676, '67070', 218, 20, 3553, 37.0155, 0.646042349271961, -98.4851, -1.71888925915587),
(29677, '67071', 218, 20, 9930, 37.3328, 0.651580278988539, -98.8028, -1.72443417018945),
(29678, '67072', 218, 20, 3678, 37.5359, 0.655125042699339, -96.643, -1.68673854900488),
(29679, '67073', 218, 20, 3725, 38.3738, 0.6697491565018, -97.3035, -1.6982664487143),
(29680, '67074', 218, 20, 3732, 37.6926, 0.657859973637215, -96.7829, -1.68918026462842),
(29681, '67101', 218, 20, 33178, 37.7741, 0.65928241697759, -97.4724, -1.70121430982092),
(29682, '67102', 218, 20, 33186, 37.0777, 0.647127944066701, -96.7882, -1.68927276707878),
(29683, '67103', 218, 20, 10367, 37.2579, 0.650273027378795, -97.5299, -1.70221787414082),
(29684, '67104', 218, 20, 33239, 37.2853, 0.650751247593842, -98.5776, -1.72050368871396),
(29685, '67105', 218, 20, 23084, 37.2575, 0.650266046061787, -97.6736, -1.70472591227593),
(29686, '67106', 218, 20, 4232, 37.4306, 0.65328721099699, -97.7517, -1.70608901442174),
(29687, '67107', 218, 20, 33357, 38.2025, 0.666759407493134, -97.5187, -1.70202239726459),
(29688, '67108', 218, 20, 4376, 37.8581, 0.660748493549265, -97.6644, -1.70456534198475),
(29689, '67109', 218, 20, 33368, 37.5888, 0.656048321873644, -99.4611, -1.73592367265533),
(29690, '67110', 218, 20, 33370, 37.4884, 0.654296011304642, -97.2477, -1.69729255499169),
(29691, '67111', 218, 20, 17219, 37.6038, 0.656310121261444, -97.9718, -1.70993048410538),
(29692, '67112', 218, 20, 10729, 37.4273, 0.653229615131674, -98.4093, -1.71756629958286),
(29693, '67114', 218, 20, 4570, 38.0466, 0.664038439189275, -97.3485, -1.6990518468777),
(29694, '67117', 218, 20, 33445, 38.0733, 0.664504442099557, -97.3479, -1.69904137490219),
(29695, '67118', 218, 20, 23480, 37.4576, 0.653758449895028, -97.8454, -1.70772438793086),
(29696, '67119', 218, 20, 4828, 37.2759, 0.650587186644154, -97.1688, -1.69591549021187),
(29697, '67120', 218, 20, 17560, 37.4987, 0.654475780217598, -97.3827, -1.69964874948188),
(29698, '67122', 218, 20, 4996, 37.6362, 0.65687560793909, -96.4122, -1.68271032909128),
(29699, '67123', 218, 20, 33678, 37.9388, 0.662156974255625, -97.0183, -1.69328876968761),
(29700, '67124', 218, 20, 11392, 37.6465, 0.657055376852045, -98.7389, -1.72331890479743),
(29701, '67127', 218, 20, 33702, 37.2004, 0.649269463058899, -99.4822, -1.7362919371275),
(29702, '67128', 218, 20, 11451, 37.4283, 0.653247068424194, -98.0803, -1.71182416634379),
(29703, '67131', 218, 20, 11629, 37.4286, 0.65325230441195, -96.928, -1.69171273737306),
(29704, '67132', 218, 20, 33818, 37.7817, 0.659415062000742, -96.6212, -1.68635806722795),
(29705, '67133', 218, 20, 5540, 37.576, 0.655824919729389, -97.1329, -1.6952889170104),
(29706, '67134', 218, 20, 33898, 37.5148, 0.654756778227169, -98.6295, -1.72140951459575),
(29707, '67135', 218, 20, 11850, 37.8903, 0.661310489568408, -97.4369, -1.70059471793646),
(29708, '67137', 218, 20, 33925, 37.623, 0.656645224477827, -96.2286, -1.67950590458462),
(29709, '67138', 218, 20, 24789, 37.2503, 0.650140382355644, -98.4188, -1.7177321058618),
(29710, '67140', 218, 20, 34014, 37.0936, 0.647405451417769, -97.3519, -1.69911118807227),
(29711, '67142', 218, 20, 18169, 37.4281, 0.65324357776569, -98.1899, -1.71373704720398),
(29712, '67143', 218, 20, 18219, 37.3951, 0.652667619112532, -98.8999, -1.72612888489314),
(29713, '67144', 218, 20, 34149, 37.7968, 0.659678606717793, -96.9999, -1.69296762910525),
(29714, '67146', 218, 20, 34208, 37.3863, 0.652514030138356, -97.1219, -1.69509693079268),
(29715, '67147', 218, 20, 34235, 37.8441, 0.660504147453986, -97.3421, -1.69894014580557),
(29716, '67149', 218, 20, 12571, 37.5565, 0.65548458052525, -97.6031, -1.70349545515328),
(29717, '67150', 218, 20, 12596, 37.0825, 0.647211719870797, -98.2382, -1.71458004123269),
(29718, '67151', 218, 20, 18491, 38.118, 0.665284604275199, -97.2566, -1.69744788929512),
(29719, '67152', 218, 20, 902, 37.2686, 0.650459777608759, -97.3954, -1.69987040629689),
(29720, '67154', 218, 20, 26032, 37.964, 0.662596797227127, -97.1457, -1.69551231915466),
(29721, '67155', 218, 20, 34438, 37.3334, 0.651590750964051, -99.2112, -1.7315620948546),
(29722, '67156', 218, 20, 6882, 37.2391, 0.64994490547942, -96.9876, -1.69275295360725),
(29723, '67159', 218, 20, 34489, 37.4275, 0.653233105790178, -98.2998, -1.71565516405192),
(29724, '67201', 218, 20, 34418, 37.6896, 0.657807613759655, -97.3418, -1.69893490981782),
(29725, '67202', 218, 20, 34418, 37.6851, 0.657729073943315, -97.3357, -1.69882844473344),
(29726, '67203', 218, 20, 34418, 37.7038, 0.658055450513438, -97.3641, -1.69932411824101),
(29727, '67204', 218, 20, 34418, 37.7509, 0.658877500591127, -97.3599, -1.69925081441243),
(29728, '67205', 218, 20, 34418, 37.7478, 0.658823395384315, -97.4299, -1.70047254488882),
(29729, '67206', 218, 20, 34418, 37.7004, 0.65799610931887, -97.2373, -1.69711104074948),
(29730, '67207', 218, 20, 34418, 37.6688, 0.65744458527524, -97.23, -1.69698363171409),
(29731, '67208', 218, 20, 34418, 37.7029, 0.65803974255017, -97.2775, -1.69781266310878),
(29732, '67209', 218, 20, 34418, 37.6655, 0.657386989409924, -97.4209, -1.70031546525614),
(29733, '67210', 218, 20, 34418, 37.6295, 0.656758670879206, -97.2632, -1.69756308102575),
(29734, '67211', 218, 20, 34418, 37.6671, 0.657414914677956, -97.3168, -1.69849857750482),
(29735, '67212', 218, 20, 34418, 37.6999, 0.65798738267261, -97.4371, -1.70059820859497),
(29736, '67213', 218, 20, 34418, 37.6699, 0.657463783897012, -97.3625, -1.69929619297298),
(29737, '67214', 218, 20, 34418, 37.7047, 0.658071158476706, -97.3185, -1.6985282481021),
(29738, '67215', 218, 20, 34418, 37.6311, 0.656786596147238, -97.4304, -1.70048127153508),
(29739, '67216', 218, 20, 34418, 37.6201, 0.656594609929519, -97.3178, -1.69851603079734),
(29740, '67217', 218, 20, 34418, 37.6242, 0.656666168428851, -97.3591, -1.69923685177841),
(29741, '67218', 218, 20, 34418, 37.6697, 0.657460293238508, -97.28, -1.69785629634008),
(29742, '67219', 218, 20, 34418, 37.7572, 0.658987456334003, -97.319, -1.69853697474836),
(29743, '67220', 218, 20, 34418, 37.7452, 0.658778016823764, -97.2757, -1.69778124718225),
(29744, '67221', 218, 20, 0, 37.6207, 0.656605081905031, -97.2523, -1.69737284013728),
(29745, '67223', 218, 20, 34418, 37.7286, 0.658488292167933, -97.4889, -1.7015022891475),
(29746, '67226', 218, 20, 34418, 37.7409, 0.658702967665928, -97.2426, -1.69720354319984),
(29747, '67227', 218, 20, 34418, 37.5821, 0.655931384813761, -97.4524, -1.70086524397052),
(29748, '67228', 218, 20, 34418, 37.7667, 0.659153262612942, -97.2061, -1.69656649802286),
(29749, '67230', 218, 20, 34418, 37.674, 0.657535342396344, -97.1757, -1.69603591793025),
(29750, '67231', 218, 20, 34418, 37.5143, 0.654748051580909, -97.4286, -1.70044985560855),
(29751, '67232', 218, 20, 34418, 37.6411, 0.656961129072438, -97.1667, -1.69587883829757),
(29752, '67233', 218, 20, 34418, 37.5521, 0.655407786038163, -97.3312, -1.6987499049171),
(29753, '67235', 218, 20, 34418, 37.6828, 0.657688931370519, -97.4905, -1.70153021441553),
(29754, '67236', 218, 20, 34418, 37.5489, 0.655351935502099, -97.2907, -1.69804304657005),
(29755, '67251', 218, 20, 34418, 37.6866, 0.657755253882095, -97.3358, -1.6988301900627),
(29756, '67256', 218, 20, 34418, 37.7311, 0.658531925399232, -97.3263, -1.69866438378376),
(29757, '67257', 218, 20, 34418, 37.6903, 0.657819831064419, -97.3414, -1.69892792850081),
(29758, '67259', 218, 20, 34418, 37.6869, 0.657760489869851, -97.3376, -1.69886160598923),
(29759, '67260', 218, 20, 34418, 37.7072, 0.658114791708006, -97.2796, -1.69784931502308),
(29760, '67275', 218, 20, 34418, 37.6728, 0.65751439844532, -97.4441, -1.70072038164261),
(29761, '67276', 218, 20, 34418, 37.662, 0.657325902886104, -97.4186, -1.70027532268335),
(29762, '67277', 218, 20, 34418, 37.6655, 0.657386989409924, -97.4256, -1.70039749573099),
(29763, '67278', 218, 20, 34418, 37.6926, 0.657859973637215, -97.3371, -1.69885287934297),
(29764, '67301', 218, 20, 3320, 37.2273, 0.649738956627685, -95.7126, -1.67050000564432),
(29765, '67330', 218, 20, 26361, 37.1972, 0.649213612522835, -95.3045, -1.66337731696694),
(29766, '67332', 218, 20, 19076, 37.06, 0.646819020789099, -95.2133, -1.66178557668912),
(29767, '67333', 218, 20, 7883, 37.0138, 0.646012678674677, -95.9319, -1.67432751269395),
(29768, '67334', 218, 20, 26767, 37.0235, 0.646181975612121, -96.1767, -1.67860007870283),
(29769, '67335', 218, 20, 29463, 37.2651, 0.650398691084939, -95.5516, -1.66769002554861),
(29770, '67336', 218, 20, 1541, 37.0365, 0.64640886841488, -95.091, -1.65965103901393),
(29771, '67337', 218, 20, 32115, 37.0399, 0.646468209609448, -95.6317, -1.66908803427946),
(29772, '67340', 218, 20, 20502, 37.0587, 0.646796331508823, -95.7132, -1.67051047761984),
(29773, '67341', 218, 20, 20549, 37.3182, 0.651325460917748, -95.4135, -1.66527972585161),
(29774, '67342', 218, 20, 13, 37.0613, 0.646841710069375, -95.36, -1.66434597470179),
(29775, '67344', 218, 20, 32320, 37.2893, 0.650821060763921, -95.9099, -1.67394354025851),
(29776, '67345', 218, 20, 32323, 37.3836, 0.652466906248552, -96.2714, -1.68025290550447),
(29777, '67346', 218, 20, 32635, 37.3482, 0.651849059693346, -96.448, -1.68333515696349),
(29778, '67347', 218, 20, 3010, 37.0918, 0.647374035491233, -95.9437, -1.67453346154568),
(29779, '67349', 218, 20, 3251, 37.5133, 0.654730598288389, -96.2324, -1.67957222709619),
(29780, '67351', 218, 20, 3751, 37.1603, 0.648569586028849, -95.6002, -1.66853825556508),
(29781, '67352', 218, 20, 33134, 37.4275, 0.653233105790178, -96.073, -1.67679017226851),
(29782, '67353', 218, 20, 33316, 37.3677, 0.652189398897485, -96.3005, -1.6807607963168),
(29783, '67354', 218, 20, 33352, 37.2078, 0.649398617423546, -95.4475, -1.66587313779729),
(29784, '67355', 218, 20, 33436, 37.0113, 0.645969045443377, -95.9267, -1.67423675557284),
(29785, '67356', 218, 20, 33527, 37.1668, 0.648683032430229, -95.1095, -1.65997392492555),
(29786, '67357', 218, 20, 4894, 37.3392, 0.651691980060667, -95.2691, -1.66275947041173),
(29787, '67360', 218, 20, 33609, 37.0538, 0.646710810375475, -96.1557, -1.67823355955991),
(29788, '67361', 218, 20, 33915, 37.1278, 0.648002354021951, -96.185, -1.67874494103075),
(29789, '67363', 218, 20, 6199, 37.3274, 0.651486031208931, -95.7154, -1.67054887486338),
(29790, '67364', 218, 20, 138, 37.0372, 0.646421085719644, -95.8211, -1.67239368788274),
(29791, '67401', 218, 20, 31053, 38.8276, 0.67766946064735, -97.6146, -1.70369616801726),
(29792, '67402', 218, 20, 31053, 38.8402, 0.677889372133102, -97.6116, -1.7036438081397),
(29793, '67410', 218, 20, 18716, 38.9208, 0.679296107510209, -97.2212, -1.69683004273991),
(29794, '67416', 218, 20, 31686, 38.6698, 0.674915331087703, -97.5838, -1.70315860660764),
(29795, '67417', 218, 20, 474, 39.4119, 0.687867419466753, -97.5104, -1.70187753493668),
(29796, '67418', 218, 20, 29152, 39.1758, 0.683746697102795, -98.0974, -1.71212261764589),
(29797, '67420', 218, 20, 309, 39.4598, 0.688703432178458, -98.1048, -1.71225177201053),
(29798, '67422', 218, 20, 26498, 39.0332, 0.681257857589451, -97.5926, -1.70331219558182),
(29799, '67423', 218, 20, 7444, 38.9585, 0.679954096638211, -97.9842, -1.71014690493263),
(29800, '67425', 218, 20, 26617, 38.8231, 0.67759092083101, -97.8584, -1.70795128073362),
(29801, '67427', 218, 20, 26666, 38.5118, 0.672157710869552, -98.3946, -1.71730973618281),
(29802, '67428', 218, 20, 19763, 38.3864, 0.669969067987551, -97.4281, -1.70044112896229),
(29803, '67430', 218, 20, 31990, 39.5024, 0.689446942439808, -98.387, -1.71717709115966),
(29804, '67431', 218, 20, 1496, 38.9718, 0.680186225428726, -97.0223, -1.69335858285769),
(29805, '67432', 218, 20, 32077, 39.3817, 0.687340330032651, -97.1201, -1.69506551486614),
(29806, '67436', 218, 20, 32226, 39.2757, 0.685490281025537, -97.7659, -1.70633685117552),
(29807, '67437', 218, 20, 2097, 39.5038, 0.689471377049336, -98.5435, -1.71990853143903),
(29808, '67438', 218, 20, 8632, 38.4866, 0.67171788789805, -97.2266, -1.69692429051952),
(29809, '67439', 218, 20, 579, 38.7324, 0.676007907199452, -98.2292, -1.71442296160001),
(29810, '67441', 218, 20, 2311, 38.902, 0.678967985610834, -97.1163, -1.69499919235457),
(29811, '67442', 218, 20, 32428, 38.654, 0.674639569065888, -97.7301, -1.70571202330331),
(29812, '67443', 218, 20, 32510, 38.3891, 0.670016191877355, -97.5494, -1.70255821334496),
(29813, '67444', 218, 20, 32546, 38.516, 0.672231014698136, -98.1552, -1.71313141795354),
(29814, '67445', 218, 20, 32551, 39.3611, 0.68698079220674, -97.8368, -1.70757428961519),
(29815, '67446', 218, 20, 32553, 39.5001, 0.689406799867012, -98.3073, -1.71578606374582),
(29816, '67447', 218, 20, 21540, 39.4303, 0.68818856004912, -96.999, -1.69295192114198),
(29817, '67448', 218, 20, 32652, 38.703, 0.675494780399365, -97.447, -1.70077099619091),
(29818, '67449', 218, 20, 32736, 38.6762, 0.675027032159831, -96.9477, -1.69205656723571),
(29819, '67450', 218, 20, 32788, 38.5871, 0.673471943796304, -98.4122, -1.71761691413116),
(29820, '67451', 218, 20, 665, 38.6906, 0.675278359572118, -97.0748, -1.69427488071499),
(29821, '67452', 218, 20, 3284, 39.2631, 0.685270369539786, -98.4332, -1.71798343327408),
(29822, '67454', 218, 20, 32890, 38.7104, 0.675623934764013, -98.1572, -1.71316632453858),
(29823, '67455', 218, 20, 3781, 39.0412, 0.68139748392961, -98.147, -1.71298830095487),
(29824, '67456', 218, 20, 33090, 38.5759, 0.67327646692008, -97.6753, -1.70475558287322),
(29825, '67457', 218, 20, 3805, 38.397, 0.670154072888263, -98.0114, -1.71062163448917),
(29826, '67458', 218, 20, 33133, 39.2774, 0.685519951622821, -97.7694, -1.70639793769934),
(29827, '67459', 218, 20, 16945, 38.5695, 0.673164765847953, -98.3167, -1.71595012469551),
(29828, '67460', 218, 20, 17075, 38.3745, 0.669761373806564, -97.6572, -1.70443967827861),
(29829, '67464', 218, 20, 33204, 38.554, 0.672894239813894, -97.8331, -1.70750971243286),
(29830, '67466', 218, 20, 33293, 39.3478, 0.686748663416225, -97.4555, -1.70091934917733),
(29831, '67467', 218, 20, 33298, 39.1244, 0.68284959786727, -97.7034, -1.70524602039303),
(29832, '67468', 218, 20, 23183, 39.4881, 0.689197360356773, -97.2721, -1.69771841532918),
(29833, '67470', 218, 20, 33412, 38.9038, 0.67899940153737, -97.5001, -1.70169776602372),
(29834, '67473', 218, 20, 33519, 39.4405, 0.688366583632824, -98.6987, -1.72261728243813),
(29835, '67474', 218, 20, 33670, 39.5245, 0.689832660204499, -98.7095, -1.72280577799734),
(29836, '67475', 218, 20, 33718, 38.5654, 0.673093207348621, -97.0956, -1.69463790919941),
(29837, '67476', 218, 20, 33833, 38.4884, 0.671749303824586, -97.4353, -1.70056679266843),
(29838, '67478', 218, 20, 5863, 39.3843, 0.687385708593203, -97.9327, -1.70924806036785),
(29839, '67480', 218, 20, 33996, 38.9188, 0.679261200925169, -97.3708, -1.69944105530089),
(29840, '67481', 218, 20, 6203, 39.0455, 0.681472533087446, -98.3746, -1.71696067033241),
(29841, '67482', 218, 20, 34112, 39.0078, 0.680814543959444, -97.317, -1.69850206816332),
(29842, '67483', 218, 20, 18280, 38.5656, 0.673096698007125, -97.2054, -1.6965542807181),
(29843, '67484', 218, 20, 34122, 38.9332, 0.679512528337456, -97.7906, -1.70676794750077),
(29844, '67485', 218, 20, 12332, 39.3397, 0.686607291746813, -98.4704, -1.71863269575582),
(29845, '67487', 218, 20, 831, 39.2153, 0.684436102157332, -97.0152, -1.6932346644808),
(29846, '67490', 218, 20, 565, 38.8234, 0.677596156818767, -98.4779, -1.71876359544972),
(29847, '67491', 218, 20, 31547, 38.3865, 0.669970813316803, -97.9091, -1.70883616266438),
(29848, '67492', 218, 20, 634, 38.8299, 0.677709603220146, -96.9685, -1.69241959572012),
(29849, '67501', 218, 20, 9633, 38.0548, 0.664181556187938, -97.9148, -1.70893564643174),
(29850, '67502', 218, 20, 9633, 38.1, 0.66497044500984, -97.9192, -1.70901244091883),
(29851, '67504', 218, 20, 9633, 38.0279, 0.663712062619152, -97.9345, -1.70927947629439),
(29852, '67505', 218, 20, 34012, 37.9866, 0.662991241638078, -97.9547, -1.70963203280329),
(29853, '67510', 218, 20, 31591, 38.0063, 0.663335071500721, -98.2053, -1.71400582790879),
(29854, '67511', 218, 20, 7042, 38.4519, 0.671112258647608, -99.0111, -1.72806969102136),
(29855, '67512', 218, 20, 796, 38.2441, 0.667485464461963, -98.3102, -1.71583667829413),
(29856, '67513', 218, 20, 7048, 38.4711, 0.671447361863991, -99.5531, -1.73752937556717),
(29857, '67514', 218, 20, 15026, 37.884, 0.661200533825532, -98.1854, -1.71365850738764),
(29858, '67515', 218, 20, 26395, 38.6095, 0.673862897548751, -100.0079, -1.74546713300524),
(29859, '67516', 218, 20, 31758, 38.4796, 0.67159571485041, -99.6961, -1.74002519639752),
(29860, '67518', 218, 20, 192931, 38.4776, 0.67156080826537, -100.1514, -1.74797168048185),
(29861, '67519', 218, 20, 31791, 37.9214, 0.661853286965778, -99.093, -1.72949911567874),
(29862, '67520', 218, 20, 31831, 38.5203, 0.672306063855972, -99.197, -1.73131425810082),
(29863, '67521', 218, 20, 31897, 38.6244, 0.674122951607298, -99.6971, -1.74004264969004),
(29864, '67522', 218, 20, 31915, 38.1338, 0.665560366297014, -97.778, -1.70654803601502),
(29865, '67523', 218, 20, 31918, 38.2625, 0.66780660504433, -99.5214, -1.73697610619428),
(29866, '67524', 218, 20, 1501, 38.358, 0.669473394479985, -98.3187, -1.71598503128055),
(29867, '67525', 218, 20, 32070, 38.5241, 0.672372386367547, -98.5361, -1.71977937707438),
(29868, '67526', 218, 20, 32328, 38.3579, 0.669471649150733, -98.5814, -1.72057001122554),
(29869, '67529', 218, 20, 9050, 38.2146, 0.666970592332625, -98.209, -1.71407040509111),
(29870, '67530', 218, 20, 32614, 38.3667, 0.669625238124908, -98.777, -1.72398387524244),
(29871, '67543', 218, 20, 32706, 37.9117, 0.661683990028334, -97.7917, -1.70678714612254),
(29872, '67544', 218, 20, 32778, 38.5195, 0.672292101221956, -98.7771, -1.72398562057169),
(29873, '67545', 218, 20, 16505, 38.1735, 0.666253262010055, -98.5826, -1.72059095517656),
(29874, '67546', 218, 20, 22166, 38.2294, 0.66722890106192, -97.7712, -1.70642935362588),
(29875, '67547', 218, 20, 32931, 37.9225, 0.66187248558755, -99.4093, -1.7350195921028),
(29876, '67548', 218, 20, 16751, 38.5313, 0.672498050073691, -99.3078, -1.73324808291202),
(29877, '67550', 218, 20, 32997, 38.1826, 0.666412086971987, -99.102, -1.72965619531142),
(29878, '67552', 218, 20, 3744, 37.9353, 0.662095887731805, -99.2549, -1.73232480373772),
(29879, '67553', 218, 20, 33056, 38.6545, 0.674648295712148, -99.32, -1.73346101308077),
(29880, '67554', 218, 20, 764, 38.345, 0.669246501677226, -98.2048, -1.71399710126253),
(29881, '67556', 218, 20, 33225, 38.5849, 0.67343354655276, -99.5721, -1.73786098812505),
(29882, '67557', 218, 20, 33169, 37.9582, 0.662495568130512, -98.9704, -1.7273593420158),
(29883, '67559', 218, 20, 33398, 38.4154, 0.67047521347063, -99.418, -1.73517143574772),
(29884, '67560', 218, 20, 33403, 38.4529, 0.671129711940127, -99.9059, -1.7436868971682),
(29885, '67561', 218, 20, 33427, 38.1453, 0.665761079160993, -98.0794, -1.71180845838053),
(29886, '67563', 218, 20, 33479, 37.8689, 0.660936989108481, -99.5181, -1.73691851032897),
(29887, '67564', 218, 20, 33494, 38.5628, 0.673047828788069, -98.917, -1.72642733619523),
(29888, '67565', 218, 20, 17462, 38.5355, 0.672571353902275, -99.0534, -1.72880796529495),
(29889, '67566', 218, 20, 33579, 37.9647, 0.662609014531891, -98.0929, -1.71204407782955),
(29890, '67567', 218, 20, 33597, 38.3041, 0.66853266201316, -98.977, -1.72747453374643),
(29891, '67568', 218, 20, 5154, 37.9863, 0.662986005650322, -98.3015, -1.71568483464921),
(29892, '67570', 218, 20, 33695, 37.7857, 0.659484875170821, -97.9416, -1.70940339467128),
(29893, '67572', 218, 20, 33721, 38.6355, 0.674316683154269, -99.9309, -1.7441232294812),
(29894, '67573', 218, 20, 24225, 38.2605, 0.66777169845929, -98.4205, -1.71776177645908),
(29895, '67574', 218, 20, 33834, 37.9278, 0.661964988037905, -99.4131, -1.73508591461437),
(29896, '67575', 218, 20, 33838, 38.4639, 0.671321698157847, -99.3099, -1.73328473482632),
(29897, '67576', 218, 20, 31032, 38.0024, 0.663267003659893, -98.7604, -1.72369415058661),
(29898, '67578', 218, 20, 12102, 37.9624, 0.662568871959095, -98.6, -1.72089464246641),
(29899, '67579', 218, 20, 25116, 38.2112, 0.666911251138057, -98.2052, -1.71400408257954),
(29900, '67581', 218, 20, 34109, 37.959, 0.662509530764528, -98.4078, -1.71754011964408),
(29901, '67583', 218, 20, 34204, 37.8048, 0.659818233057952, -98.4266, -1.71786824154345),
(29902, '67584', 218, 20, 31360, 38.6455, 0.674491216079469, -100.173, -1.74834867160028),
(29903, '67585', 218, 20, 13008, 37.9435, 0.662239004730468, -97.8689, -1.70813454030508),
(29904, '67601', 218, 20, 32724, 38.8789, 0.678564814553623, -99.322, -1.73349591966581),
(29905, '67621', 218, 20, 31607, 39.8719, 0.695895934025927, -99.1359, -1.73024786192785),
(29906, '67622', 218, 20, 31634, 39.8922, 0.696250235864082, -99.7103, -1.7402730331513),
(29907, '67623', 218, 20, 14977, 39.4575, 0.688663289605663, -98.9549, -1.72708881598174),
(29908, '67625', 218, 20, 31864, 39.4196, 0.688001809819157, -99.6778, -1.7397058011444),
(29909, '67626', 218, 20, 7775, 38.839, 0.677868428182078, -98.6708, -1.72213033557682),
(29910, '67627', 218, 20, 31982, 38.9833, 0.680386938292705, -99.2038, -1.73143294048995),
(29911, '67628', 218, 20, 31988, 39.6618, 0.692228997267487, -98.9253, -1.72657219852315),
(29912, '67629', 218, 20, 608, 39.6805, 0.69255537383761, -100.2939, -1.75045877466594),
(29913, '67631', 218, 20, 187630, 38.9147, 0.679189642425837, -100.0584, -1.74634852427749),
(29914, '67632', 218, 20, 32203, 39.3182, 0.686232045957634, -99.5856, -1.73809660757407),
(29915, '67634', 218, 20, 32247, 38.8442, 0.677959185303181, -98.5882, -1.72068869361467),
(29916, '67635', 218, 20, 20675, 39.6115, 0.691351096653734, -100.3758, -1.75188819932332),
(29917, '67637', 218, 20, 2268, 38.9369, 0.67957710551978, -99.5613, -1.73767249256583),
(29918, '67638', 218, 20, 32534, 39.6597, 0.692192345353195, -98.7813, -1.72405892440027),
(29919, '67639', 218, 20, 9123, 39.6441, 0.691920073989884, -99.2901, -1.73293915963442),
(29920, '67640', 218, 20, 27295, 38.8811, 0.678603211797167, -99.0223, -1.72826516789758),
(29921, '67642', 218, 20, 21935, 39.3662, 0.687069803998592, -99.8453, -1.74262922764149),
(29922, '67643', 218, 20, 16612, 39.6794, 0.692536175215838, -100.2942, -1.7504640106537),
(29923, '67644', 218, 20, 32943, 39.6523, 0.692063190988548, -99.1255, -1.73006634768564),
(29924, '67645', 218, 20, 22628, 39.6102, 0.691328407373458, -100.0012, -1.74535019594535),
(29925, '67646', 218, 20, 3843, 39.6631, 0.692251686547763, -99.5713, -1.73784702549103),
(29926, '67647', 218, 20, 3855, 39.9608, 0.69744753173095, -99.5544, -1.73755206484744),
(29927, '67648', 218, 20, 10220, 39.0588, 0.681704661877961, -98.5378, -1.71980904767167),
(29928, '67649', 218, 20, 33155, 39.0462, 0.68148475039221, -98.6498, -1.7217638164339),
(29929, '67650', 218, 20, 187818, 39.3373, 0.686565403844765, -100.0745, -1.74662952228707),
(29930, '67651', 218, 20, 33381, 39.1892, 0.683980571222562, -99.0233, -1.7282826211901),
(29931, '67653', 218, 20, 187825, 39.8363, 0.695274596812217, -100.1866, -1.74858603637855),
(29932, '67654', 218, 20, 4646, 39.834, 0.695234454239421, -99.8911, -1.74342858843891),
(29933, '67656', 218, 20, 33480, 38.9141, 0.679179170450325, -99.6878, -1.7398803340696),
(29934, '67657', 218, 20, 33559, 39.2533, 0.68509932727309, -99.5631, -1.73770390849237),
(29935, '67658', 218, 20, 11064, 39.046, 0.681481259733706, -98.9266, -1.72659488780342),
(29936, '67659', 218, 20, 33603, 39.3938, 0.687551514872142, -99.9286, -1.74408308690841),
(29937, '67660', 218, 20, 33614, 38.7314, 0.675990453906932, -99.1461, -1.73042588551155),
(29938, '67661', 218, 20, 23863, 39.7562, 0.69387658808137, -99.3263, -1.73357096882364),
(29939, '67663', 218, 20, 23999, 39.232, 0.684727572142415, -99.3008, -1.73312590986439),
(29940, '67664', 218, 20, 505, 39.8325, 0.695208274300641, -99.5717, -1.73785400680804),
(29941, '67665', 218, 20, 5580, 38.8895, 0.678749819454335, -98.8585, -1.72540631858281),
(29942, '67667', 218, 20, 33906, 38.7114, 0.675641388056533, -99.3321, -1.73367219792026),
(29943, '67669', 218, 20, 510, 39.4363, 0.68829327980424, -99.272, -1.73262325503981),
(29944, '67671', 218, 20, 6554, 38.854, 0.678130227569877, -99.1468, -1.73043810281631),
(29945, '67672', 218, 20, 0, 39.0262, 0.681135684541811, -99.8822, -1.74327325413548),
(29946, '67673', 218, 20, 6601, 39.0455, 0.681472533087446, -98.7613, -1.72370985854988),
(29947, '67674', 218, 20, 12598, 38.8667, 0.67835188438488, -99.0756, -1.72919542838889),
(29948, '67675', 218, 20, 34469, 39.4375, 0.688314223755264, -99.101, -1.7296387420189),
(29949, '67701', 218, 20, 35315, 39.3944, 0.687561986847654, -101.0477, -1.76361506656747),
(29950, '67730', 218, 20, 7189, 39.8076, 0.694773687316895, -101.0409, -1.76349638417834),
(29951, '67731', 218, 20, 187599, 39.7499, 0.693766632338494, -101.5333, -1.77209038541516),
(29952, '67732', 218, 20, 15318, 39.3626, 0.68700697214552, -101.3754, -1.76933451052626),
(29953, '67733', 218, 20, 148609, 39.3521, 0.686823712574061, -101.5016, -1.77153711604228),
(29954, '67734', 218, 20, 29878, 39.4382, 0.688326441060028, -100.887, -1.76081032245952),
(29955, '67735', 218, 20, 16246, 39.3505, 0.686795787306029, -101.712, -1.77520928878847),
(29956, '67736', 218, 20, 187686, 38.8545, 0.678138954216137, -100.5038, -1.75412222076588),
(29957, '67737', 218, 20, 187689, 39.113, 0.682650630332542, -100.4661, -1.75346423163788),
(29958, '67738', 218, 20, 27346, 39.1236, 0.682835635233254, -100.6311, -1.75634402490367),
(29959, '67739', 218, 20, 9440, 39.8909, 0.696227546583806, -100.8265, -1.75975439826206),
(29960, '67740', 218, 20, 9601, 39.355, 0.686874327122368, -100.438, -1.75297379411806),
(29961, '67741', 218, 20, 187743, 39.3369, 0.686558422527757, -102.0367, -1.7808763728697),
(29962, '67743', 218, 20, 127933, 39.3728, 0.687184995729223, -101.2231, -1.76667637407547),
(29963, '67744', 218, 20, 187785, 39.8717, 0.695892443367423, -100.9438, -1.76180166947465),
(29964, '67745', 218, 20, 815, 39.7852, 0.694382733564448, -101.2987, -1.76799584298998),
(29965, '67748', 218, 20, 818, 39.1277, 0.682907193732585, -100.8527, -1.76021167452609),
(29966, '67749', 218, 20, 42414, 39.8212, 0.695011052095166, -100.5292, -1.75456553439588),
(29967, '67751', 218, 20, 30772, 39.0641, 0.681797164328317, -100.2326, -1.74938888783447),
(29968, '67752', 218, 20, 187854, 38.9149, 0.679193133084341, -100.245, -1.74960530866172),
(29969, '67753', 218, 20, 61522, 39.4698, 0.688877965103658, -100.7433, -1.7583022843244),
(29970, '67756', 218, 20, 11751, 39.7716, 0.694145368786177, -101.7983, -1.77671550793294),
(29971, '67757', 218, 20, 97961, 39.5405, 0.690111912884818, -100.5674, -1.75523225017015),
(29972, '67758', 218, 20, 106167, 38.9005, 0.678941805672054, -101.7488, -1.77585156995321),
(29973, '67761', 218, 20, 721, 38.917, 0.679229784998633, -101.5642, -1.77262969215402),
(29974, '67762', 218, 20, 187953, 38.8863, 0.678693968918271, -101.9447, -1.77927066995786),
(29975, '67764', 218, 20, 904, 39.0485, 0.681524892965006, -101.2297, -1.7667915658061),
(29976, '67801', 218, 20, 2058, 37.7589, 0.659017126931287, -100.0191, -1.74566260988146),
(29977, '67831', 218, 20, 13301, 37.1869, 0.649033843609879, -99.7709, -1.74133070267801),
(29978, '67834', 218, 20, 31908, 37.5504, 0.655378115440879, -99.6331, -1.73892563896876),
(29979, '67835', 218, 20, 177943, 37.8087, 0.65988630089878, -100.3468, -1.75138205384025),
(29980, '67836', 218, 20, 20230, 38.0406, 0.663933719434155, -102.0073, -1.78036324606961),
(29981, '67837', 218, 20, 1756, 37.5408, 0.655210563832687, -100.6294, -1.75631435430638),
(29982, '67838', 218, 20, 8455, 37.982, 0.662910956492486, -101.1337, -1.76511604972419),
(29983, '67839', 218, 20, 75657, 38.4806, 0.67161316814293, -100.4652, -1.75344852367461),
(29984, '67840', 218, 20, 2297, 37.9894, 0.663040110857134, -100.9551, -1.76199889168013),
(29985, '67841', 218, 20, 94078, 37.6515, 0.657142643314645, -100.2305, -1.74935223592018),
(29986, '67842', 218, 20, 32456, 37.636, 0.656872117280586, -99.753, -1.7410182887419),
(29987, '67843', 218, 20, 32464, 37.6656, 0.657388734739176, -99.9455, -1.74437804755199),
(29988, '67844', 218, 20, 2578, 37.3837, 0.652468651577804, -100.1922, -1.74868377481666),
(29989, '67846', 218, 20, 2657, 37.9757, 0.662801000749611, -100.8493, -1.76015233333152),
(29990, '67849', 218, 20, 32680, 38.1211, 0.66533870948201, -99.7106, -1.74027826913906),
(29991, '67850', 218, 20, 187712, 38.4819, 0.671635857423206, -100.6133, -1.75603335629681),
(29992, '67851', 218, 20, 21985, 38.0051, 0.663314127549697, -100.9832, -1.76248932919994),
(29993, '67853', 218, 20, 9659, 37.9582, 0.662495568130512, -100.5244, -1.75448175859179),
(29994, '67854', 218, 20, 32879, 38.0811, 0.664640577781213, -99.8958, -1.74351061891375),
(29995, '67855', 218, 20, 364, 37.5686, 0.655695765364742, -101.758, -1.77601214024439),
(29996, '67857', 218, 20, 16702, 37.9345, 0.662081925097789, -101.5448, -1.77229109827914),
(29997, '67859', 218, 20, 150052, 37.2032, 0.649318332277954, -100.7014, -1.75757099136782),
(29998, '67860', 218, 20, 110012, 37.9404, 0.662184899523657, -101.259, -1.76730294727694),
(29999, '67861', 218, 20, 187760, 38.4825, 0.671646329398718, -101.3594, -1.76905525784594),
(30000, '67862', 218, 20, 187792, 37.5244, 0.65492432983536, -101.8838, -1.7782077644434),
(30001, '67863', 218, 20, 187794, 38.4757, 0.671527647009582, -101.0563, -1.76376516488315),
(30002, '67864', 218, 20, 73421, 37.2856, 0.650756483581598, -100.3371, -1.7512127569028),
(30003, '67865', 218, 20, 17145, 37.4415, 0.653477451885457, -100.0129, -1.74555439946784),
(30004, '67867', 218, 20, 23157, 37.595, 0.656156532287268, -100.4416, -1.75303662597114),
(30005, '67868', 218, 20, 23878, 37.8351, 0.660347067821306, -100.6923, -1.75741216640589),
(30006, '67869', 218, 20, 17647, 37.2602, 0.650313169951591, -100.5927, -1.7556738184709),
(30007, '67870', 218, 20, 187880, 37.4488, 0.653604860920852, -101.0119, -1.76299023869526),
(30008, '67871', 218, 20, 5691, 38.4803, 0.671607932155174, -100.908, -1.76117684160244),
(30009, '67876', 218, 20, 34022, 37.8487, 0.660584432599578, -99.7551, -1.7410549406562),
(30010, '67877', 218, 20, 121606, 37.4854, 0.654243651427082, -100.8428, -1.76003888693014),
(30011, '67878', 218, 20, 57818, 37.9853, 0.662968552357802, -101.7477, -1.77583237133143),
(30012, '67879', 218, 20, 38583, 38.472, 0.671463069827258, -101.7492, -1.77585855127021),
(30013, '67880', 218, 20, 38625, 37.5818, 0.655926148826005, -101.3589, -1.76904653119968),
(30014, '67882', 218, 20, 6964, 37.824, 0.660153336274335, -99.9329, -1.74415813606624),
(30015, '67901', 218, 20, 30333, 37.0441, 0.646541513438031, -100.9279, -1.76152416212358),
(30016, '67905', 218, 20, 30333, 37.0306, 0.646305893989012, -100.9322, -1.76159921128142),
(30017, '67950', 218, 20, 94006, 37.0019, 0.64580498449369, -101.9008, -1.77850447041624),
(30018, '67951', 218, 20, 187723, 37.1762, 0.648847093379916, -101.3466, -1.76883185570169),
(30019, '67952', 218, 20, 4344, 37.3115, 0.651208523857864, -101.2944, -1.76792079383214),
(30020, '67953', 218, 20, 24305, 37.2832, 0.65071459567955, -101.7383, -1.77566831038175),
(30021, '67954', 218, 20, 11660, 37.1194, 0.647855746364783, -101.6315, -1.77380429874062),
(30022, '68001', 218, 35, 141126, 41.345, 0.721606379237056, -96.9618, -1.69230265866024),
(30023, '68002', 218, 35, 15026, 41.4583, 0.723583837279565, -96.3526, -1.68167011285709),
(30024, '68003', 218, 35, 13301, 41.0393, 0.716270907713709, -96.3758, -1.68207502924355),
(30025, '68004', 218, 35, 19038, 42.0118, 0.733244234689354, -96.5743, -1.68553950780876),
(30026, '68005', 218, 35, 270, 41.1512, 0.718223931146691, -95.9096, -1.67393830427075),
(30027, '68007', 218, 35, 26498, 41.3535, 0.721754732223475, -96.1678, -1.6784447443994),
(30028, '68008', 218, 35, 26538, 41.5451, 0.725098783070296, -96.1379, -1.67792289095306),
(30029, '68009', 218, 35, 26538, 41.5569, 0.725304731922031, -96.2455, -1.6798008652282),
(30030, '68010', 218, 35, 141350, 41.2593, 0.720110632068096, -96.1296, -1.67777802862514),
(30031, '68014', 218, 35, 7724, 41.2632, 0.720178699908924, -96.9653, -1.69236374518406),
(30032, '68015', 218, 35, 141443, 41.397, 0.722513950448093, -96.61, -1.68616259035172),
(30033, '68016', 218, 35, 7973, 41.0419, 0.716316286274261, -96.1036, -1.67732424301962),
(30034, '68017', 218, 35, 130147, 41.059, 0.716614737576352, -96.647, -1.68680836217496),
(30035, '68018', 218, 35, 20173, 41.2996, 0.72081399975665, -96.6063, -1.6860980131694),
(30036, '68019', 218, 35, 29568, 41.782, 0.729233468068271, -96.3574, -1.68175388866118),
(30037, '68020', 218, 35, 2007, 42.0061, 0.73314475092199, -96.2497, -1.67987416905679),
(30038, '68022', 218, 35, 159, 41.2715, 0.72032356223684, -96.2418, -1.67973628804588),
(30039, '68023', 218, 35, 141832, 41.4569, 0.723559402670037, -96.0232, -1.67592099830102),
(30040, '68025', 218, 35, 2605, 41.4402, 0.723267932684954, -96.4927, -1.68411531913913),
(30041, '68026', 218, 35, 2605, 41.4411, 0.723283640648222, -96.4919, -1.68410135650512),
(30042, '68028', 218, 35, 16287, 41.1303, 0.717859157333024, -96.2486, -1.67985497043501),
(30043, '68029', 218, 35, 9438, 41.6451, 0.726844112322291, -96.3208, -1.68111509815495),
(30044, '68030', 218, 35, 22029, 42.3222, 0.738661736687544, -96.4921, -1.68410484716362),
(30045, '68031', 218, 35, 16490, 41.6107, 0.726243719059605, -96.5474, -1.68507001423997),
(30046, '68033', 218, 35, 22194, 41.161, 0.718394973413386, -96.5389, -1.68492166125355),
(30047, '68034', 218, 35, 30237, 41.4748, 0.723871816606144, -96.2033, -1.67906433628386),
(30048, '68036', 218, 35, 3793, 41.6111, 0.726250700376612, -96.5465, -1.68505430627671),
(30049, '68037', 218, 35, 3876, 40.9985, 0.715558813378895, -96.1597, -1.67830337272999),
(30050, '68038', 218, 35, 764, 41.9363, 0.731926511104098, -96.4732, -1.68377497993499),
(30051, '68039', 218, 35, 123112, 42.0124, 0.733254706664866, -96.5772, -1.68559012235707),
(30052, '68040', 218, 35, 66575, 41.304, 0.720890794243738, -96.7352, -1.68834774257522),
(30053, '68041', 218, 35, 76572, 41.2117, 0.719279855344147, -96.5215, -1.68461797396371),
(30054, '68042', 218, 35, 4163, 41.0951, 0.717244801436322, -96.4329, -1.68307161224644),
(30055, '68044', 218, 35, 33427, 41.5231, 0.724714810634857, -96.4973, -1.68419560428472),
(30056, '68045', 218, 35, 4710, 41.836, 0.730175945864348, -96.4641, -1.68361615497306),
(30057, '68046', 218, 35, 142636, 41.1521, 0.718239639109958, -96.0408, -1.67622817624937),
(30058, '68047', 218, 35, 67671, 42.1118, 0.734989563941348, -96.7091, -1.68789221164045),
(30059, '68048', 218, 35, 142695, 41.0086, 0.715735091633347, -95.891, -1.67361367302988),
(30060, '68050', 218, 35, 11363, 41.2996, 0.72081399975665, -96.8509, -1.69036708851978),
(30061, '68055', 218, 35, 5538, 42.0597, 0.734080247401059, -96.4702, -1.68372262005743),
(30062, '68056', 218, 35, 0, 41.0951, 0.717244801436322, -96.0546, -1.67646903168615),
(30063, '68057', 218, 35, 90654, 41.6624, 0.727146054282885, -96.6531, -1.68691482725933),
(30064, '68058', 218, 35, 12027, 41.0022, 0.715623390561219, -96.246, -1.67980959187446),
(30065, '68059', 218, 35, 349, 41.0677, 0.716766581221275, -96.1482, -1.67810265986601),
(30066, '68061', 218, 35, 143175, 41.778, 0.729163654898191, -96.2212, -1.67937675021997),
(30067, '68062', 218, 35, 6335, 42.193, 0.736406771293967, -96.6807, -1.68739653813288),
(30068, '68063', 218, 35, 143234, 41.7337, 0.728390474039557, -96.5051, -1.68433173996638),
(30069, '68064', 218, 35, 6497, 41.3124, 0.721037401900905, -96.3493, -1.68161251699177),
(30070, '68065', 218, 35, 18421, 41.0794, 0.716970784743759, -96.8302, -1.69000580536461),
(30071, '68066', 218, 35, 18474, 41.2118, 0.719281600673399, -96.6228, -1.68638599249598),
(30072, '68067', 218, 35, 143303, 42.1499, 0.735654534386358, -96.4903, -1.68407343123708),
(30073, '68068', 218, 35, 12671, 41.3975, 0.722522677094353, -96.2078, -1.6791428761002),
(30074, '68069', 218, 35, 6650, 41.282, 0.720506821808299, -96.2823, -1.68044314639294),
(30075, '68070', 218, 35, 6746, 41.177, 0.718674226093705, -96.7935, -1.68936526952913),
(30076, '68071', 218, 35, 122019, 42.2379, 0.737190424128113, -96.4738, -1.68378545191051),
(30077, '68072', 218, 35, 567, 41.6091, 0.726215793791573, -96.5033, -1.68430032403984),
(30078, '68073', 218, 35, 143441, 41.2446, 0.719854068668053, -96.3967, -1.68243980305722),
(30079, '68101', 218, 35, 4786, 41.2629, 0.720173463921168, -95.9336, -1.67435718329123),
(30080, '68102', 218, 35, 4786, 41.2608, 0.720136812006876, -95.9343, -1.674369400596),
(30081, '68103', 218, 35, 4786, 41.2565, 0.720061762849041, -95.9447, -1.6745509148382),
(30082, '68104', 218, 35, 4786, 41.2933, 0.720704044013775, -95.9999, -1.6755143365853),
(30083, '68105', 218, 35, 4786, 41.2407, 0.719786000827225, -95.9643, -1.67489299937159),
(30084, '68106', 218, 35, 4786, 41.2392, 0.719759820888445, -96.001, -1.67553353520708),
(30085, '68107', 218, 35, 4786, 41.2084, 0.719222259478831, -95.9552, -1.67473417440966),
(30086, '68108', 218, 35, 4786, 41.2385, 0.719747603583682, -95.9309, -1.67431005940143),
(30087, '68109', 218, 35, 4786, 41.2384, 0.71974585825443, -95.9311, -1.67431355005993),
(30088, '68110', 218, 35, 4786, 41.2931, 0.720700553355271, -95.9267, -1.67423675557284),
(30089, '68111', 218, 35, 4786, 41.2938, 0.720712770660034, -95.9656, -1.67491568865187),
(30090, '68112', 218, 35, 4786, 41.3361, 0.721451044933628, -95.9721, -1.67502913505325),
(30091, '68113', 218, 35, 0, 41.1295, 0.717845194699008, -95.9464, -1.67458058543549),
(30092, '68114', 218, 35, 4786, 41.2639, 0.720190917213688, -96.0523, -1.67642888911335),
(30093, '68116', 218, 35, 4786, 41.291, 0.720663901440979, -96.1672, -1.67843427242389),
(30094, '68117', 218, 35, 4786, 41.207, 0.719197824869303, -95.9982, -1.67548466598802),
(30095, '68118', 218, 35, 4786, 41.2627, 0.720169973262664, -96.1767, -1.67860007870283),
(30096, '68119', 218, 35, 4786, 41.3068, 0.720939663462794, -95.9073, -1.67389816169796),
(30097, '68120', 218, 35, 4786, 41.23, 0.719599250597262, -96.1651, -1.6783976205096),
(30098, '68122', 218, 35, 4786, 41.341, 0.721536566066976, -96.0718, -1.67676922831749),
(30099, '68123', 218, 35, 270, 41.1193, 0.717667171115304, -95.95, -1.67464341728856),
(30100, '68124', 218, 35, 4786, 41.2359, 0.71970222502313, -96.0517, -1.67641841713784),
(30101, '68127', 218, 35, 4786, 41.2036, 0.719138483674736, -96.0537, -1.67645332372288),
(30102, '68128', 218, 35, 22443, 41.16, 0.718377520120866, -96.0425, -1.67625784684665),
(30103, '68130', 218, 35, 4786, 41.2359, 0.71970222502313, -96.1719, -1.67851630289873),
(30104, '68131', 218, 35, 4786, 41.2691, 0.720281674334792, -95.964, -1.67488776338384),
(30105, '68132', 218, 35, 4786, 41.2648, 0.720206625176956, -95.9999, -1.6755143365853),
(30106, '68133', 218, 35, 142636, 41.1265, 0.717792834821448, -96.0064, -1.67562778298668),
(30107, '68134', 218, 35, 4786, 41.2984, 0.720793055805626, -96.0526, -1.67643412510111),
(30108, '68135', 218, 35, 4786, 41.2093, 0.719237967442099, -96.175, -1.67857040810555),
(30109, '68136', 218, 35, 4786, 41.1656, 0.718475258558978, -96.1765, -1.67859658804433),
(30110, '68137', 218, 35, 4786, 41.2028, 0.71912452104072, -96.1215, -1.67763665695573),
(30111, '68138', 218, 35, 4786, 41.1702, 0.71855554370457, -96.125, -1.67769774347955),
(30112, '68139', 218, 35, 4786, 41.2186, 0.719400283062535, -96.1213, -1.67763316629723),
(30113, '68142', 218, 35, 4786, 41.3386, 0.721494678164928, -96.0967, -1.67720381530123),
(30114, '68144', 218, 35, 4786, 41.2359, 0.71970222502313, -96.1145, -1.67751448390809),
(30115, '68145', 218, 35, 4786, 41.2591, 0.720107141409592, -95.9377, -1.67442874179056),
(30116, '68147', 218, 35, 270, 41.1784, 0.718698660703233, -95.9549, -1.67472893842191),
(30117, '68152', 218, 35, 4786, 41.3428, 0.721567981993512, -95.9983, -1.67548641131727),
(30118, '68154', 218, 35, 4786, 41.2637, 0.720187426555184, -96.1181, -1.67757731576116),
(30119, '68155', 218, 35, 4786, 41.2404, 0.71978076483947, -95.964, -1.67488776338384),
(30120, '68157', 218, 35, 4786, 41.184, 0.718796399141345, -95.9948, -1.67542532479345),
(30121, '68164', 218, 35, 4786, 41.2948, 0.720730223952554, -96.1096, -1.67742896277474),
(30122, '68172', 218, 35, 4786, 41.2634, 0.720182190567428, -96.1181, -1.67757731576116),
(30123, '68175', 218, 35, 4786, 41.265, 0.72021011583546, -95.9656, -1.67491568865187),
(30124, '68176', 218, 35, 4786, 41.2627, 0.720169973262664, -95.9367, -1.67441128849804),
(30125, '68178', 218, 35, 4786, 41.265, 0.72021011583546, -95.9488, -1.67462247333754),
(30126, '68179', 218, 35, 4786, 41.2593, 0.720110632068096, -95.9346, -1.67437463658375),
(30127, '68180', 218, 35, 4786, 41.2348, 0.719683026401358, -96.0518, -1.67642016246709),
(30128, '68181', 218, 35, 4786, 41.2577, 0.720082706800064, -95.9379, -1.67443223244907),
(30129, '68182', 218, 35, 4786, 41.2563, 0.720058272190537, -96.0087, -1.67566792555948),
(30130, '68183', 218, 35, 4786, 41.2583, 0.720093178775576, -95.9382, -1.67443746843682),
(30131, '68197', 218, 35, 4786, 41.2585, 0.72009666943408, -95.9377, -1.67442874179056),
(30132, '68198', 218, 35, 4786, 41.2643, 0.720197898530696, -96.0114, -1.67571504944928),
(30133, '68301', 218, 35, 14941, 40.4572, 0.70611134613785, -96.5104, -1.68442424241674),
(30134, '68303', 218, 35, 34524, 40.2473, 0.702447900037914, -97.3898, -1.69977266785877),
(30135, '68304', 218, 35, 113153, 40.8717, 0.713345735887366, -96.3846, -1.68222861821773),
(30136, '68305', 218, 35, 13306, 40.3883, 0.704908814283226, -95.8421, -1.67276020702566),
(30137, '68307', 218, 35, 7207, 40.7975, 0.712050701582387, -96.1208, -1.67762443965097),
(30138, '68309', 218, 35, 141234, 40.0488, 0.698983421472705, -96.5765, -1.6855779050523),
(30139, '68310', 218, 35, 90, 40.27, 0.702844089778117, -96.7428, -1.68848038759837),
(30140, '68313', 218, 35, 134152, 40.7815, 0.711771448902068, -97.2717, -1.69771143401217),
(30141, '68314', 218, 35, 34726, 41.0065, 0.715698439719055, -97.0576, -1.69397468408365),
(30142, '68315', 218, 35, 13361, 40.2512, 0.702515967878741, -97.5346, -1.70229990461566),
(30143, '68316', 218, 35, 19194, 41.0046, 0.715665278463267, -97.6026, -1.70348672850702),
(30144, '68317', 218, 35, 141283, 40.6792, 0.709985977077277, -96.5142, -1.68449056492831),
(30145, '68318', 218, 35, 1001, 40.138, 0.700540255165484, -96.6638, -1.68710157748929),
(30146, '68319', 218, 35, 34955, 40.8845, 0.713569138031622, -97.7475, -1.70601571059316),
(30147, '68320', 218, 35, 19522, 40.4804, 0.706516262524313, -95.9602, -1.67482144087226),
(30148, '68321', 218, 35, 1195, 40.3977, 0.705072875232913, -95.7171, -1.67057854546066),
(30149, '68322', 218, 35, 141382, 40.335, 0.703978553791913, -97.5651, -1.70283223003752),
(30150, '68323', 218, 35, 134479, 40.0881, 0.699669335868739, -96.3496, -1.68161775297953),
(30151, '68324', 218, 35, 35075, 40.5362, 0.707490156246925, -96.2995, -1.68074334302428),
(30152, '68325', 218, 35, 7810, 40.0432, 0.698885683034593, -97.752, -1.7060942504095),
(30153, '68326', 218, 35, 75333, 40.2964, 0.703304856700643, -97.6665, -1.70460199389904),
(30154, '68327', 218, 35, 8056, 40.0113, 0.698328923003207, -97.6168, -1.7037345652608),
(30155, '68328', 218, 35, 141495, 40.4662, 0.706268425770529, -96.8496, -1.6903443992395),
(30156, '68329', 218, 35, 15606, 40.5109, 0.707048587946171, -96.1619, -1.67834176997354),
(30157, '68330', 218, 35, 924, 40.7158, 0.710624767583507, -97.3501, -1.69907977214573),
(30158, '68331', 218, 35, 29554, 40.5055, 0.706954340166563, -96.7058, -1.68783461577513),
(30159, '68332', 218, 35, 26876, 40.3058, 0.70346891765033, -96.4071, -1.68262131729943),
(30160, '68333', 218, 35, 119273, 40.6248, 0.709036517964192, -96.9603, -1.69227647872146),
(30161, '68335', 218, 35, 1977, 40.2801, 0.703020368032568, -97.7933, -1.70681507139057),
(30162, '68336', 218, 35, 141621, 40.9723, 0.715101537114873, -96.692, -1.68759376033836),
(30163, '68337', 218, 35, 1989, 40.1307, 0.700412846130088, -95.8407, -1.67273577241613),
(30164, '68338', 218, 35, 141629, 40.3017, 0.703397359150999, -97.2813, -1.69787898562036),
(30165, '68339', 218, 35, 8484, 40.7373, 0.711000013372686, -96.8466, -1.69029203936194),
(30166, '68340', 218, 35, 141654, 40.1402, 0.700578652409028, -97.7236, -1.70559857690193),
(30167, '68341', 218, 35, 8432, 40.3953, 0.705030987330865, -96.9225, -1.6916167442642),
(30168, '68342', 218, 35, 141660, 40.11, 0.700051562974926, -96.9371, -1.691871562335),
(30169, '68343', 218, 35, 20633, 40.649, 0.709458887643175, -97.1143, -1.69496428576953),
(30170, '68344', 218, 35, 2088, 40.5929, 0.708479757932806, -96.3862, -1.68225654348576),
(30171, '68345', 218, 35, 26988, 40.0344, 0.698732094060418, -96.0463, -1.67632416935823),
(30172, '68346', 218, 35, 2127, 40.6537, 0.709540918118019, -96.0089, -1.67567141621798),
(30173, '68347', 218, 35, 2149, 40.8163, 0.712378823481762, -96.4316, -1.68304892296616),
(30174, '68348', 218, 35, 35733, 40.327, 0.703838927451753, -96.1342, -1.67785831377073),
(30175, '68349', 218, 35, 8746, 40.8428, 0.71284133573354, -96.2943, -1.68065258590318),
(30176, '68350', 218, 35, 35772, 40.0816, 0.699555889467359, -97.0946, -1.69462045590689),
(30177, '68351', 218, 35, 27125, 40.6439, 0.709369875851323, -97.4485, -1.70079717612969),
(30178, '68352', 218, 35, 119582, 40.1421, 0.700611813664816, -97.1767, -1.69605337122277),
(30179, '68354', 218, 35, 27132, 40.6332, 0.70918312562136, -97.5854, -1.70318653187567),
(30180, '68355', 218, 35, 2413, 40.0624, 0.699220786250976, -95.5996, -1.66852778358957),
(30181, '68357', 218, 35, 54758, 40.3058, 0.70346891765033, -96.5202, -1.68459528468343),
(30182, '68358', 218, 35, 141822, 40.5363, 0.707491901576177, -96.6108, -1.68617655298574),
(30183, '68359', 218, 35, 141854, 40.6413, 0.709324497290772, -97.2664, -1.69761893156181),
(30184, '68360', 218, 35, 2663, 40.9426, 0.71458317432703, -96.9857, -1.69271979235146),
(30185, '68361', 218, 35, 2687, 40.527, 0.707329585955742, -97.6006, -1.70345182192198),
(30186, '68362', 218, 35, 27258, 40.1534, 0.700809035870291, -97.4384, -1.70062089787524),
(30187, '68364', 218, 35, 141922, 40.8323, 0.712658076162081, -97.2023, -1.69650017551128),
(30188, '68365', 218, 35, 27298, 40.6276, 0.709085387183248, -97.7147, -1.7054432425985),
(30189, '68366', 218, 35, 2869, 40.9619, 0.714920022872665, -96.4428, -1.68324439984239),
(30190, '68367', 218, 35, 36207, 41.0072, 0.715710657023819, -97.4203, -1.70030499328063),
(30191, '68368', 218, 35, 36251, 40.5581, 0.707872383353112, -96.7933, -1.68936177887063),
(30192, '68370', 218, 35, 940, 40.1678, 0.701060363282578, -97.5898, -1.70326332636276),
(30193, '68371', 218, 35, 23, 40.7797, 0.711740032975532, -97.8118, -1.70713795730219),
(30194, '68372', 218, 35, 9453, 40.6175, 0.708909108928797, -96.6221, -1.68637377519121),
(30195, '68375', 218, 35, 30121, 40.0109, 0.698321941686199, -97.498, -1.70166111410943),
(30196, '68376', 218, 35, 27486, 40.1666, 0.701039419331554, -95.9457, -1.67456836813072),
(30197, '68377', 218, 35, 142130, 40.2194, 0.701960953176607, -97.0287, -1.69347028392982),
(30198, '68378', 218, 35, 364, 40.4112, 0.705308494681932, -95.9992, -1.67550211928054),
(30199, '68380', 218, 35, 3747, 40.2432, 0.702376341538582, -96.4068, -1.68261608131167),
(30200, '68381', 218, 35, 3751, 40.0819, 0.699561125455115, -96.5178, -1.68455339678138),
(30201, '68382', 218, 35, 3870, 40.5956, 0.70852688182261, -96.0244, -1.67594194225204),
(30202, '68401', 218, 35, 142376, 40.7437, 0.711111714444814, -97.5957, -1.70336630078863),
(30203, '68402', 218, 35, 3958, 40.9129, 0.714064811539188, -96.8677, -1.69066030383411),
(30204, '68403', 218, 35, 14168, 40.9188, 0.714167785965056, -96.1649, -1.6783941298511),
(30205, '68404', 218, 35, 142362, 40.6269, 0.709073169878484, -96.7553, -1.68869855375487),
(30206, '68405', 218, 35, 10480, 40.7723, 0.711610878610884, -97.0528, -1.69389090827955),
(30207, '68406', 218, 35, 17137, 40.5004, 0.706865328374711, -97.3881, -1.69974299726149),
(30208, '68407', 218, 35, 17219, 40.9267, 0.714305666975963, -96.281, -1.68042045711266),
(30209, '68409', 218, 35, 10715, 40.9166, 0.714129388721512, -95.9293, -1.6742821341334),
(30210, '68410', 218, 35, 142473, 40.6761, 0.709931871870465, -95.8601, -1.67307436629102),
(30211, '68413', 218, 35, 142475, 40.8348, 0.712701709393381, -95.9975, -1.67547244868326),
(30212, '68414', 218, 35, 116985, 40.3389, 0.704046621632741, -95.6747, -1.66983852585782),
(30213, '68415', 218, 35, 10922, 40.0455, 0.698925825607389, -96.8032, -1.68953456646657),
(30214, '68416', 218, 35, 142582, 40.4125, 0.705331183962209, -97.4515, -1.70084953600725);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(30215, '68417', 218, 35, 76854, 40.7237, 0.710762648594415, -96.1229, -1.67766109156526),
(30216, '68418', 218, 35, 4846, 40.706, 0.710453725316812, -96.3912, -1.68234380994836),
(30217, '68419', 218, 35, 28181, 40.6011, 0.70862287493147, -96.5114, -1.68444169570926),
(30218, '68420', 218, 35, 142646, 40.1114, 0.700075997584454, -96.1523, -1.67817421836534),
(30219, '68421', 218, 35, 33609, 40.4797, 0.706504045219549, -95.7314, -1.6708281275437),
(30220, '68422', 218, 35, 142667, 40.3932, 0.704994335416574, -96.7423, -1.68847166095211),
(30221, '68423', 218, 35, 50455, 40.7918, 0.711951217815023, -96.932, -1.69178255054314),
(30222, '68424', 218, 35, 14433, 40.3033, 0.703425284419031, -96.9878, -1.69275644426576),
(30223, '68428', 218, 35, 24225, 40.9686, 0.715036959932549, -96.789, -1.68928672971279),
(30224, '68429', 218, 35, 5360, 40.045, 0.698917098961129, -97.3123, -1.69842003768848),
(30225, '68430', 218, 35, 142868, 40.6746, 0.709905691931686, -96.6679, -1.68717313598863),
(30226, '68431', 218, 35, 142906, 40.0466, 0.698945024229161, -95.442, -1.66577714468843),
(30227, '68433', 218, 35, 126, 40.0443, 0.698904881656365, -95.7281, -1.67077053167838),
(30228, '68434', 218, 35, 33926, 40.9117, 0.714043867588164, -97.0954, -1.6946344185409),
(30229, '68436', 218, 35, 143013, 40.4152, 0.705378307852012, -97.7227, -1.70558286893866),
(30230, '68437', 218, 35, 90809, 40.2367, 0.702262895137202, -95.6836, -1.66999386016125),
(30231, '68438', 218, 35, 5999, 40.6265, 0.709066188561476, -96.7449, -1.68851703951266),
(30232, '68439', 218, 35, 143106, 40.9746, 0.715141679687669, -97.1725, -1.69598006739419),
(30233, '68440', 218, 35, 18193, 40.0449, 0.698915353631877, -96.9726, -1.69249115421945),
(30234, '68441', 218, 35, 143110, 40.2081, 0.701763730971132, -96.2317, -1.67956000979143),
(30235, '68442', 218, 35, 12121, 40.2318, 0.702177374003855, -95.7729, -1.67155243918328),
(30236, '68443', 218, 35, 25116, 40.461, 0.706177668649426, -96.378, -1.68211342648709),
(30237, '68444', 218, 35, 77355, 40.3946, 0.705018770026101, -97.5394, -1.70238368041976),
(30238, '68445', 218, 35, 51889, 40.3933, 0.704996080745826, -97.0833, -1.69442323370141),
(30239, '68446', 218, 35, 57818, 40.6595, 0.709642147214634, -96.1827, -1.67870479845795),
(30240, '68447', 218, 35, 57821, 40.1782, 0.701241877524786, -96.0949, -1.6771723993747),
(30241, '68448', 218, 35, 34112, 40.5308, 0.707395908467318, -96.0228, -1.67591401698401),
(30242, '68450', 218, 35, 6262, 40.3718, 0.704620834956647, -96.1953, -1.6789247099437),
(30243, '68452', 218, 35, 71218, 40.3935, 0.70499957140433, -97.8811, -1.70834747047382),
(30244, '68453', 218, 35, 143199, 40.4195, 0.705453357009848, -97.3373, -1.69885637000148),
(30245, '68454', 218, 35, 25636, 40.6853, 0.710092442161649, -96.2734, -1.68028781208951),
(30246, '68455', 218, 35, 455, 40.8274, 0.712572555028733, -95.8956, -1.67369395817547),
(30247, '68456', 218, 35, 31360, 40.8947, 0.713747161615325, -97.3454, -1.69899774167089),
(30248, '68457', 218, 35, 107130, 40.1487, 0.700727005395447, -95.7078, -1.67041622984023),
(30249, '68458', 218, 35, 6578, 40.2184, 0.701943499884087, -96.5193, -1.68457957672016),
(30250, '68460', 218, 35, 6587, 40.9287, 0.714340573561003, -97.4449, -1.70073434427662),
(30251, '68461', 218, 35, 18491, 40.7589, 0.711377004491117, -96.5127, -1.68446438498953),
(30252, '68462', 218, 35, 6664, 40.9179, 0.714152078001788, -96.5307, -1.68477854425489),
(30253, '68463', 218, 35, 143342, 40.8683, 0.713286394692799, -96.1399, -1.6779577975381),
(30254, '68464', 218, 35, 12769, 40.3975, 0.705069384574409, -97.2301, -1.69698537704334),
(30255, '68465', 218, 35, 52784, 40.4818, 0.70654069713384, -96.9628, -1.69232011195276),
(30256, '68466', 218, 35, 143430, 40.1224, 0.700267983802173, -96.6661, -1.68714172006209),
(30257, '68467', 218, 35, 6986, 40.8697, 0.713310829302327, -97.5883, -1.70323714642398),
(30258, '68501', 218, 35, 3781, 40.8247, 0.712525431138929, -96.7783, -1.68909997948283),
(30259, '68502', 218, 35, 3781, 40.7892, 0.711905839254471, -96.7144, -1.6879847140908),
(30260, '68503', 218, 35, 3781, 40.8229, 0.712494015212393, -96.6768, -1.68732847029205),
(30261, '68504', 218, 35, 3781, 40.8397, 0.712787230526728, -96.6579, -1.68699860306343),
(30262, '68505', 218, 35, 3781, 40.8421, 0.712829118428776, -96.6252, -1.68642788039803),
(30263, '68506', 218, 35, 3781, 40.7856, 0.711843007401399, -96.6524, -1.68690260995457),
(30264, '68507', 218, 35, 3781, 40.8496, 0.712960018122676, -96.6287, -1.68648896692184),
(30265, '68508', 218, 35, 3781, 40.8192, 0.712429438030069, -96.7111, -1.68792711822549),
(30266, '68509', 218, 35, 3781, 40.818, 0.712408494079045, -96.7092, -1.6878939569697),
(30267, '68510', 218, 35, 3781, 40.8066, 0.712209526544318, -96.6512, -1.68688166600354),
(30268, '68512', 218, 35, 3781, 40.7564, 0.711333371259817, -96.696, -1.68766357350844),
(30269, '68514', 218, 35, 3781, 40.9181, 0.714155568660292, -96.6497, -1.68685548606476),
(30270, '68516', 218, 35, 3781, 40.7518, 0.711253086114225, -96.6479, -1.68682407013823),
(30271, '68517', 218, 35, 3781, 40.9255, 0.714284723024939, -96.6036, -1.68605088927959),
(30272, '68520', 218, 35, 3781, 40.7954, 0.712014049668095, -96.5853, -1.68573149402648),
(30273, '68521', 218, 35, 3781, 40.8501, 0.712968744768936, -96.7174, -1.68803707396836),
(30274, '68522', 218, 35, 3781, 40.7911, 0.711939000510259, -96.7405, -1.68844024502557),
(30275, '68523', 218, 35, 3781, 40.7358, 0.710973833433906, -96.7562, -1.68871426171814),
(30276, '68524', 218, 35, 3781, 40.856, 0.713071719194803, -96.7874, -1.68925880444476),
(30277, '68526', 218, 35, 3781, 40.7351, 0.710961616129142, -96.5912, -1.68583446845235),
(30278, '68527', 218, 35, 3781, 40.843, 0.712844826392044, -96.5374, -1.68489548131477),
(30279, '68528', 218, 35, 3781, 40.8229, 0.712494015212393, -96.7653, -1.68887308668007),
(30280, '68529', 218, 35, 3781, 40.8545, 0.713045539256023, -96.6145, -1.68624113016806),
(30281, '68531', 218, 35, 3781, 40.8857, 0.713590081982646, -96.7154, -1.68800216738332),
(30282, '68532', 218, 35, 3781, 40.7917, 0.711949472485771, -96.8546, -1.6904316657021),
(30283, '68542', 218, 35, 3781, 40.7857, 0.711844752730651, -96.6997, -1.68772815069076),
(30284, '68583', 218, 35, 3781, 40.8312, 0.712638877540309, -96.6637, -1.68709983216004),
(30285, '68588', 218, 35, 3781, 40.8189, 0.712424202042313, -96.7099, -1.68790617427446),
(30286, '68601', 218, 35, 1718, 41.4367, 0.723206846161134, -97.3578, -1.69921416249814),
(30287, '68602', 218, 35, 1718, 41.4456, 0.723362180464562, -97.3091, -1.69836418715241),
(30288, '68620', 218, 35, 7043, 41.6769, 0.727399127024425, -97.9879, -1.71021148211495),
(30289, '68621', 218, 35, 7089, 41.4601, 0.723615253206101, -96.6381, -1.68665302787153),
(30290, '68622', 218, 35, 19076, 41.8608, 0.730608787518842, -98.5429, -1.71989805946352),
(30291, '68623', 218, 35, 53397, 41.4398, 0.723260951367946, -98.1166, -1.71245772086227),
(30292, '68624', 218, 35, 294, 41.346, 0.721623832529575, -97.2557, -1.69743218133185),
(30293, '68626', 218, 35, 34958, 41.1765, 0.718665499447445, -96.966, -1.69237596248882),
(30294, '68627', 218, 35, 114889, 41.5574, 0.725313458568292, -98.1444, -1.71294292239432),
(30295, '68628', 218, 35, 39796, 41.253, 0.720000676325221, -97.8487, -1.70778198379618),
(30296, '68629', 218, 35, 35257, 41.7221, 0.728188015846326, -97.1212, -1.69508471348792),
(30297, '68631', 218, 35, 35429, 41.6553, 0.727022135905994, -97.368, -1.69939218608184),
(30298, '68632', 218, 35, 141623, 41.2446, 0.719854068668053, -97.1308, -1.69525226509611),
(30299, '68633', 218, 35, 75669, 41.7255, 0.728247357040894, -96.8796, -1.6908679980151),
(30300, '68634', 218, 35, 2130, 41.3914, 0.722416212009981, -97.5384, -1.70236622712724),
(30301, '68635', 218, 35, 2144, 41.09, 0.71715578964447, -96.9657, -1.69237072650107),
(30302, '68636', 218, 35, 2254, 41.9592, 0.732326191502805, -98.0642, -1.71154316833422),
(30303, '68637', 218, 35, 115487, 41.8007, 0.729559844638394, -98.6606, -1.72195231199312),
(30304, '68638', 218, 35, 2627, 41.3622, 0.721906575868399, -97.9716, -1.70992699344688),
(30305, '68640', 218, 35, 9080, 41.448, 0.72340406836661, -97.7303, -1.70571551396181),
(30306, '68641', 218, 35, 3254, 41.7235, 0.728212450455854, -97.0037, -1.69303395161682),
(30307, '68642', 218, 35, 9615, 41.6899, 0.727626019827184, -97.4865, -1.70146040124545),
(30308, '68643', 218, 35, 95670, 41.7044, 0.727879092568723, -97.2337, -1.69704820889641),
(30309, '68644', 218, 35, 41807, 41.7054, 0.727896545861243, -97.6976, -1.70514479129641),
(30310, '68647', 218, 35, 10560, 41.4675, 0.723744407570749, -97.6136, -1.70367871472474),
(30311, '68648', 218, 35, 142450, 41.4134, 0.72280018444542, -96.8042, -1.68955201975909),
(30312, '68649', 218, 35, 23407, 41.4654, 0.723707755656457, -96.7803, -1.68913488606787),
(30313, '68651', 218, 35, 11010, 41.2434, 0.719833124717029, -97.5734, -1.70297709236544),
(30314, '68652', 218, 35, 14402, 41.8573, 0.730547700995023, -98.148, -1.71300575424739),
(30315, '68653', 218, 35, 142682, 41.5258, 0.724761934524661, -97.4836, -1.70140978669714),
(30316, '68654', 218, 35, 5163, 41.0729, 0.716857338342379, -97.7869, -1.70670337031844),
(30317, '68655', 218, 35, 51, 41.6468, 0.726873782919574, -98.2374, -1.71456607859868),
(30318, '68658', 218, 35, 142853, 41.1976, 0.719033763919616, -97.2958, -1.6981320583619),
(30319, '68659', 218, 35, 874, 41.4692, 0.723774078168033, -96.9584, -1.69224331746567),
(30320, '68660', 218, 35, 113148, 41.5721, 0.725570021968335, -97.8606, -1.70798967797716),
(30321, '68661', 218, 35, 106069, 41.4484, 0.723411049683618, -97.0592, -1.69400260935168),
(30322, '68662', 218, 35, 59, 41.2694, 0.720286910322548, -97.4329, -1.70052490476638),
(30323, '68663', 218, 35, 24872, 41.3158, 0.721096743095473, -97.6639, -1.70455661533849),
(30324, '68664', 218, 35, 12018, 41.7043, 0.727877347239471, -96.7868, -1.68924833246925),
(30325, '68665', 218, 35, 24994, 41.6985, 0.727776118142856, -98.3948, -1.71731322684132),
(30326, '68666', 218, 35, 143135, 41.1138, 0.717571178006445, -97.5965, -1.70338026342265),
(30327, '68667', 218, 35, 31269, 41.0898, 0.717152298985966, -97.311, -1.6983973484082),
(30328, '68669', 218, 35, 38625, 41.0707, 0.716818941098835, -97.2003, -1.69646526892624),
(30329, '68701', 218, 35, 61085, 42.0332, 0.733617735149281, -97.4236, -1.70036258914595),
(30330, '68702', 218, 35, 61085, 42.028, 0.733526978028177, -97.4171, -1.70024914274457),
(30331, '68710', 218, 35, 18798, 42.4144, 0.740270930257883, -96.8429, -1.69022746217962),
(30332, '68711', 218, 35, 39096, 42.557, 0.742759769771227, -99.0336, -1.72846239010306),
(30333, '68713', 218, 35, 18953, 42.5323, 0.742328673445984, -98.9773, -1.72747976973418),
(30334, '68714', 218, 35, 7292, 42.5822, 0.743199592742729, -99.5377, -1.73726059486236),
(30335, '68715', 218, 35, 79687, 41.999, 0.733020832545099, -97.5986, -1.70341691533694),
(30336, '68716', 218, 35, 141272, 41.9315, 0.731842735300002, -96.8093, -1.68964103155095),
(30337, '68717', 218, 35, 58605, 42.3951, 0.739934081712248, -97.1928, -1.69633436923234),
(30338, '68718', 218, 35, 7544, 42.5972, 0.743461392130529, -97.6481, -1.70428085331667),
(30339, '68719', 218, 35, 1144, 42.8943, 0.748646765338204, -98.6027, -1.72094176635621),
(30340, '68720', 218, 35, 19602, 42.351, 0.739164391512119, -97.9506, -1.70956047430396),
(30341, '68722', 218, 35, 141415, 42.9152, 0.74901153915187, -98.832, -1.72494380633104),
(30342, '68723', 218, 35, 39663, 42.2863, 0.738035163486078, -97.1927, -1.69633262390309),
(30343, '68724', 218, 35, 1440, 42.6137, 0.743749371457108, -97.895, -1.70859007123985),
(30344, '68725', 218, 35, 1475, 42.1485, 0.73563009977683, -98.735, -1.7232508369566),
(30345, '68726', 218, 35, 8122, 42.0887, 0.734586392884137, -98.1818, -1.71359567553457),
(30346, '68727', 218, 35, 63798, 42.5059, 0.741867906523458, -97.2038, -1.69652635545006),
(30347, '68728', 218, 35, 698, 42.3747, 0.739578034544841, -96.9618, -1.69230265866024),
(30348, '68729', 218, 35, 15664, 42.4651, 0.741155812188644, -97.9076, -1.7088099827256),
(30349, '68730', 218, 35, 20372, 42.7407, 0.74596593960714, -97.5294, -1.70220914749456),
(30350, '68731', 218, 35, 115181, 42.4134, 0.740253476965363, -96.4195, -1.68283773812667),
(30351, '68732', 218, 35, 828, 42.4176, 0.740326780793947, -96.955, -1.6921839762711),
(30352, '68733', 218, 35, 8753, 42.284, 0.737995020913282, -96.7258, -1.68818368162553),
(30353, '68734', 218, 35, 8756, 42.4364, 0.740654902693322, -98.8298, -1.72490540908749),
(30354, '68735', 218, 35, 2347, 42.2594, 0.737565669917292, -98.3441, -1.71642834491056),
(30355, '68736', 218, 35, 2516, 42.7367, 0.745896126437061, -97.3637, -1.699317136924),
(30356, '68737', 218, 35, 35967, 42.2638, 0.73764246440438, -97.6593, -1.7044763301929),
(30357, '68738', 218, 35, 141975, 42.1055, 0.734879608198472, -97.4515, -1.70084953600725),
(30358, '68739', 218, 35, 142007, 42.6205, 0.743868053846243, -97.2628, -1.69755609970874),
(30359, '68740', 218, 35, 65764, 42.1775, 0.736136245259908, -97.3092, -1.69836593248167),
(30360, '68741', 218, 35, 3261, 42.4067, 0.740136539905479, -96.6201, -1.68633886860617),
(30361, '68742', 218, 35, 22166, 42.3445, 0.739050945110739, -98.5546, -1.720102262986),
(30362, '68743', 218, 35, 3384, 42.4637, 0.741131377579116, -96.5803, -1.68564422756388),
(30363, '68745', 218, 35, 14092, 42.439, 0.740700281253874, -97.1037, -1.69477928086882),
(30364, '68746', 218, 35, 37005, 42.8598, 0.748044626746266, -98.4405, -1.71811084230948),
(30365, '68747', 218, 35, 73416, 42.3979, 0.739982950931304, -97.4749, -1.70125794305222),
(30366, '68748', 218, 35, 3938, 41.826, 0.730001412939148, -97.4564, -1.7009350571406),
(30367, '68749', 218, 35, 22818, 42.4766, 0.741356525052623, -97.4376, -1.70060693524123),
(30368, '68751', 218, 35, 142369, 42.6898, 0.745077567017875, -96.9832, -1.69267615912016),
(30369, '68752', 218, 35, 142387, 42.0296, 0.733554903296209, -97.7348, -1.70579405377815),
(30370, '68753', 218, 35, 10509, 42.8914, 0.748596150789896, -99.4536, -1.73579277296143),
(30371, '68755', 218, 35, 142470, 42.9264, 0.749207016028094, -99.0877, -1.72940661322839),
(30372, '68756', 218, 35, 142478, 42.1301, 0.735308959194463, -98.0288, -1.71092532177902),
(30373, '68757', 218, 35, 10795, 42.6592, 0.744543496266765, -96.887, -1.69099715237975),
(30374, '68758', 218, 35, 142504, 41.7471, 0.728624348159325, -97.7773, -1.70653581871025),
(30375, '68759', 218, 35, 10799, 42.5957, 0.743435212191749, -99.3337, -1.73370012318829),
(30376, '68760', 218, 35, 142517, 42.748, 0.746093348642536, -98.0265, -1.71088517920622),
(30377, '68761', 218, 35, 4701, 42.0456, 0.733834155976528, -97.9498, -1.70954651166994),
(30378, '68763', 218, 35, 110714, 42.4553, 0.740984769921949, -98.6472, -1.72171843787335),
(30379, '68764', 218, 35, 4799, 42.3368, 0.738916554758335, -98.2403, -1.71461669314699),
(30380, '68765', 218, 35, 67535, 42.3472, 0.739098069000543, -97.5639, -1.7028112860865),
(30381, '68766', 218, 35, 678, 42.4286, 0.740518767011666, -98.378, -1.71702001152698),
(30382, '68767', 218, 35, 181, 42.199, 0.736511491049087, -97.5299, -1.70221787414082),
(30383, '68768', 218, 35, 142673, 42.01, 0.733212818762818, -97.0534, -1.69390138025506),
(30384, '68769', 218, 35, 5102, 42.3528, 0.739195807438654, -97.7876, -1.70671558762321),
(30385, '68770', 218, 35, 11327, 42.5817, 0.743190866096469, -96.7271, -1.68820637090581),
(30386, '68771', 218, 35, 5293, 42.3765, 0.739609450471377, -97.3567, -1.69919496387636),
(30387, '68773', 218, 35, 5571, 42.3061, 0.738380738677973, -98.1255, -1.7126130551657),
(30388, '68774', 218, 35, 51154, 42.8205, 0.747358712350232, -97.3405, -1.69891222053754),
(30389, '68776', 218, 35, 143061, 42.4704, 0.741248314639, -96.4149, -1.68275745298108),
(30390, '68777', 218, 35, 5995, 42.9024, 0.748788137007615, -98.7191, -1.72297332960553),
(30391, '68778', 218, 35, 25060, 42.871, 0.748240103622489, -99.876, -1.74316504372186),
(30392, '68779', 218, 35, 6052, 41.9499, 0.732163875882369, -97.2237, -1.69687367597121),
(30393, '68780', 218, 35, 12169, 42.6044, 0.743587055836672, -99.1418, -1.73035083635371),
(30394, '68781', 218, 35, 6338, 42.0422, 0.73377481478196, -97.8301, -1.7074573525553),
(30395, '68783', 218, 35, 143270, 42.5979, 0.743473609435293, -98.039, -1.71110334536272),
(30396, '68784', 218, 35, 831, 42.2686, 0.737726240208475, -96.868, -1.69066553982187),
(30397, '68785', 218, 35, 18504, 42.2309, 0.737068251080473, -97.0197, -1.69331320429714),
(30398, '68786', 218, 35, 143329, 42.498, 0.74173002551255, -97.5386, -1.70236971778574),
(30399, '68787', 218, 35, 6665, 42.2354, 0.737146790896813, -97.0137, -1.69320848454202),
(30400, '68788', 218, 35, 6722, 41.8448, 0.730329534838523, -96.7119, -1.6879410808595),
(30401, '68789', 218, 35, 143413, 42.4958, 0.741691628269006, -98.0512, -1.71131627553146),
(30402, '68790', 218, 35, 143408, 42.1553, 0.735748782165966, -97.1924, -1.69632738791534),
(30403, '68791', 218, 35, 44191, 41.9905, 0.732872479558679, -96.9159, -1.69150155253357),
(30404, '68792', 218, 35, 143428, 42.7387, 0.745931033022101, -97.1388, -1.69539189143627),
(30405, '68801', 218, 35, 16260, 40.9197, 0.714183493928324, -98.3394, -1.71634631443571),
(30406, '68802', 218, 35, 16260, 40.9105, 0.71402292363714, -98.353, -1.71658367921398),
(30407, '68803', 218, 35, 16260, 40.9259, 0.714291704341947, -98.3795, -1.71704619146576),
(30408, '68810', 218, 35, 26349, 40.8738, 0.713382387801658, -98.4542, -1.718349952417),
(30409, '68812', 218, 35, 62514, 40.8729, 0.71336667983839, -99.2549, -1.73232480373772),
(30410, '68813', 218, 35, 141168, 41.6609, 0.727119874344106, -99.7835, -1.74155061416376),
(30411, '68814', 218, 35, 18862, 41.3288, 0.721323635898232, -99.3283, -1.73360587540868),
(30412, '68815', 218, 35, 7137, 41.524, 0.724730518598125, -99.0371, -1.72852347662688),
(30413, '68816', 218, 35, 15020, 41.177, 0.718674226093705, -98.1157, -1.712442012899),
(30414, '68817', 218, 35, 7180, 41.3004, 0.720827962390666, -98.8159, -1.72466280832146),
(30415, '68818', 218, 35, 474, 40.8659, 0.713244506790751, -98.0031, -1.71047677216125),
(30416, '68819', 218, 35, 44793, 41.3354, 0.721438827628864, -99.5005, -1.73661133238062),
(30417, '68820', 218, 35, 141335, 41.1197, 0.717674152432312, -98.687, -1.72241307891564),
(30418, '68821', 218, 35, 15318, 41.9305, 0.731825282007482, -99.8085, -1.74198694647676),
(30419, '68822', 218, 35, 75227, 41.4056, 0.722664048763764, -99.641, -1.73906351997967),
(30420, '68823', 218, 35, 19669, 41.7815, 0.729224741422011, -99.1352, -1.73023564462308),
(30421, '68824', 218, 35, 1288, 41.0012, 0.715605937268699, -98.611, -1.72108662868413),
(30422, '68825', 218, 35, 15401, 41.2914, 0.720670882757987, -99.9211, -1.74395218721451),
(30423, '68826', 218, 35, 1465, 41.1138, 0.717571178006445, -98.0012, -1.71044361090547),
(30424, '68827', 218, 35, 1496, 40.9994, 0.715574521342163, -98.2044, -1.71399011994552),
(30425, '68828', 218, 35, 130316, 41.5392, 0.724995808644429, -99.3076, -1.73324459225352),
(30426, '68831', 218, 35, 141611, 41.1274, 0.717808542784716, -98.546, -1.71995216467033),
(30427, '68832', 218, 35, 8562, 40.774, 0.711640549208168, -98.3703, -1.71688562117458),
(30428, '68833', 218, 35, 119426, 41.7861, 0.729305026567603, -100.0609, -1.74639215750879),
(30429, '68834', 218, 35, 27042, 41.0107, 0.715771743547639, -99.7038, -1.74015958674992),
(30430, '68835', 218, 35, 316, 41.2828, 0.720520784442315, -98.5946, -1.7208003946868),
(30431, '68836', 218, 35, 141751, 40.7174, 0.710652692851539, -99.374, -1.73440349087684),
(30432, '68837', 218, 35, 32356, 41.6978, 0.727763900838092, -99.0677, -1.72905754737799),
(30433, '68838', 218, 35, 75816, 41.2249, 0.71951023880541, -98.6724, -1.72215826084485),
(30434, '68840', 218, 35, 75922, 40.7468, 0.711165819651626, -98.8433, -1.72514102853651),
(30435, '68841', 218, 35, 141908, 40.7422, 0.711085534506034, -98.111, -1.71235998242416),
(30436, '68842', 218, 35, 32621, 41.5502, 0.725187794862148, -98.5344, -1.7197497064771),
(30437, '68843', 218, 35, 2957, 40.882, 0.713525504800322, -97.8858, -1.70842950094867),
(30438, '68844', 218, 35, 21798, 41.0268, 0.71605274155721, -98.9169, -1.72642559086598),
(30439, '68845', 218, 35, 330, 40.7664, 0.711507904185016, -99.1985, -1.73134043803959),
(30440, '68846', 218, 35, 142084, 41.0855, 0.71707724982813, -97.8879, -1.70846615286296),
(30441, '68847', 218, 35, 330, 40.7024, 0.71039089346374, -99.086, -1.7293769426311),
(30442, '68848', 218, 35, 330, 40.8401, 0.712794211843736, -98.9775, -1.72748326039269),
(30443, '68849', 218, 35, 330, 40.7005, 0.710357732207952, -99.0973, -1.72957416483658),
(30444, '68850', 218, 35, 3748, 40.7808, 0.711759231597303, -99.7441, -1.74086295443848),
(30445, '68852', 218, 35, 27727, 41.1999, 0.719073906492412, -99.1208, -1.7299843172108),
(30446, '68853', 218, 35, 142310, 41.278, 0.720437008638219, -98.9662, -1.72728603818721),
(30447, '68854', 218, 35, 33204, 41.006, 0.715689713072795, -98.0087, -1.71057451059937),
(30448, '68855', 218, 35, 4032, 41.1636, 0.718440351973938, -99.3111, -1.73330567877734),
(30449, '68856', 218, 35, 56217, 41.3931, 0.722445882607265, -99.8452, -1.74262748231224),
(30450, '68858', 218, 35, 4213, 40.9596, 0.714879880299869, -99.3686, -1.73430924309724),
(30451, '68859', 218, 35, 142542, 41.4659, 0.723716482302717, -98.7043, -1.72271502087624),
(30452, '68860', 218, 35, 142575, 41.1331, 0.71790802655208, -99.6639, -1.73946320037838),
(30453, '68861', 218, 35, 14343, 40.7094, 0.71051306651138, -99.2621, -1.73245046744386),
(30454, '68862', 218, 35, 76837, 41.6026, 0.726102347390193, -98.9308, -1.72666819163201),
(30455, '68863', 218, 35, 4818, 40.7386, 0.711022702652962, -99.5374, -1.7372553588746),
(30456, '68864', 218, 35, 337, 41.1679, 0.718515401131774, -98.2163, -1.71419781412651),
(30457, '68865', 218, 35, 11173, 40.898, 0.713804757480641, -98.2133, -1.71414545424895),
(30458, '68866', 218, 35, 820, 40.9695, 0.715052667895817, -99.0878, -1.72940835855764),
(30459, '68869', 218, 35, 37869, 41.0227, 0.715981183057878, -98.9107, -1.72631738045236),
(30460, '68870', 218, 35, 5416, 40.7851, 0.711834280755139, -99.1613, -1.73069117555785),
(30461, '68871', 218, 35, 5479, 41.1169, 0.717625283213256, -98.8579, -1.7253958466073),
(30462, '68872', 218, 35, 28505, 41.0824, 0.717023144621318, -98.3623, -1.71674599483442),
(30463, '68873', 218, 35, 11759, 41.2135, 0.719311271270683, -98.4601, -1.71845292684287),
(30464, '68874', 218, 35, 17996, 41.6424, 0.726796988432487, -99.3724, -1.73437556560881),
(30465, '68875', 218, 35, 11826, 41.4668, 0.723732190265985, -98.7026, -1.72268535027896),
(30466, '68876', 218, 35, 38184, 40.7771, 0.71169465441498, -98.7307, -1.72317578779877),
(30467, '68878', 218, 35, 18216, 40.946, 0.714642515521598, -99.5284, -1.73709827924192),
(30468, '68879', 218, 35, 6252, 41.9141, 0.731539048010155, -99.4541, -1.73580149960769),
(30469, '68880', 218, 35, 143344, 41.4141, 0.722812401750184, -99.3925, -1.73472637678846),
(30470, '68881', 218, 35, 143375, 41.4139, 0.72280891109168, -99.3918, -1.7347141594837),
(30471, '68882', 218, 35, 143414, 41.4663, 0.723723463619725, -98.387, -1.71717709115966),
(30472, '68883', 218, 35, 29016, 40.8219, 0.712476561919873, -98.601, -1.72091209575893),
(30473, '68901', 218, 35, 16375, 40.5897, 0.708423907396742, -98.3923, -1.71726959361002),
(30474, '68902', 218, 35, 16375, 40.5862, 0.708362820872923, -98.3851, -1.71714392990387),
(30475, '68920', 218, 35, 7066, 40.1003, 0.699882266037482, -99.361, -1.73417659807409),
(30476, '68922', 218, 35, 62553, 40.3052, 0.703458445674819, -99.8987, -1.74356123346206),
(30477, '68923', 218, 35, 7187, 40.4536, 0.706048514284778, -99.3392, -1.73379611629715),
(30478, '68924', 218, 35, 31713, 40.4799, 0.706507535878053, -99.1276, -1.73010299959993),
(30479, '68925', 218, 35, 129630, 40.4369, 0.705757044299695, -98.4397, -1.71809687967546),
(30480, '68926', 218, 35, 122205, 40.1367, 0.700517565885208, -99.8265, -1.74230110574212),
(30481, '68927', 218, 35, 53449, 40.5253, 0.707299915358458, -99.634, -1.73894134693203),
(30482, '68928', 218, 35, 19317, 40.2614, 0.702693991462445, -98.6133, -1.72112677125692),
(30483, '68929', 218, 35, 29235, 40.1335, 0.700461715349144, -99.0092, -1.72803652976557),
(30484, '68930', 218, 35, 7554, 40.3319, 0.703924448585101, -98.4503, -1.71828188457617),
(30485, '68932', 218, 35, 1317, 40.2972, 0.703318819334659, -98.7299, -1.72316182516475),
(30486, '68933', 218, 35, 32077, 40.5281, 0.707348784577514, -98.0565, -1.71140877798182),
(30487, '68934', 218, 35, 59220, 40.4184, 0.705434158388076, -97.7236, -1.70559857690193),
(30488, '68935', 218, 35, 15886, 40.3701, 0.704591164359363, -97.9716, -1.70992699344688),
(30489, '68936', 218, 35, 15893, 40.2636, 0.702732388705989, -99.7983, -1.74180892289306),
(30490, '68937', 218, 35, 15933, 40.5898, 0.708425652725994, -99.8592, -1.74287182840752),
(30491, '68938', 218, 35, 2367, 40.4323, 0.705676759154103, -98.1065, -1.71228144260782),
(30492, '68939', 218, 35, 2595, 40.0958, 0.699803726221142, -98.9533, -1.7270608907137),
(30493, '68940', 218, 35, 141860, 40.4636, 0.706223047209978, -99.2496, -1.73223230128736),
(30494, '68941', 218, 35, 141916, 40.4809, 0.706524989170572, -98.2212, -1.71428333525985),
(30495, '68942', 218, 35, 141972, 40.0727, 0.699400555163932, -98.33, -1.71618225348602),
(30496, '68943', 218, 35, 2973, 40.0109, 0.698321941686199, -97.9256, -1.70912414199096),
(30497, '68944', 218, 35, 9370, 40.6217, 0.708982412757381, -98.0956, -1.71209120171935),
(30498, '68945', 218, 35, 142023, 40.5677, 0.708039934961304, -98.7808, -1.72405019775401),
(30499, '68946', 218, 35, 142036, 40.0885, 0.699676317185747, -99.968, -1.74477074663369),
(30500, '68947', 218, 35, 16442, 40.3373, 0.704018696364709, -99.0434, -1.72863343236975),
(30501, '68948', 218, 35, 21986, 40.3049, 0.703453209687063, -100.0006, -1.74533972396984),
(30502, '68949', 218, 35, 142066, 40.443, 0.705863509384067, -99.3691, -1.7343179697435),
(30503, '68950', 218, 35, 55353, 40.4356, 0.705734355019419, -98.6671, -1.7220657583945),
(30504, '68952', 218, 35, 142109, 40.087, 0.699650137246967, -98.6696, -1.7221093916258),
(30505, '68954', 218, 35, 131445, 40.5721, 0.708116729448391, -98.2282, -1.71440550830749),
(30506, '68955', 218, 35, 32887, 40.5902, 0.708432634043002, -98.5062, -1.71925752362804),
(30507, '68956', 218, 35, 142158, 40.6226, 0.708998120720648, -98.6571, -1.7218912254693),
(30508, '68957', 218, 35, 3696, 40.263, 0.702721916730477, -98.2173, -1.71421526741903),
(30509, '68958', 218, 35, 131833, 40.4761, 0.706441213366477, -99.5083, -1.73674746806227),
(30510, '68959', 218, 35, 42112, 40.4968, 0.70680249652164, -98.9514, -1.72702772945792),
(30511, '68960', 218, 35, 142471, 40.076, 0.699458151029247, -99.1387, -1.7302967311469),
(30512, '68961', 218, 35, 4506, 40.2009, 0.701638067264988, -98.0688, -1.71162345347981),
(30513, '68964', 218, 35, 4657, 40.2634, 0.702728898047485, -97.8773, -1.70828114796225),
(30514, '68966', 218, 35, 28158, 40.1758, 0.701199989622738, -99.461, -1.73592192732608),
(30515, '68967', 218, 35, 4828, 40.2526, 0.70254040248827, -99.6352, -1.73896229088305),
(30516, '68969', 218, 35, 11449, 40.3086, 0.703517786869386, -99.2574, -1.73236843696902),
(30517, '68970', 218, 35, 142827, 40.1086, 0.700027128365398, -98.5162, -1.71943205655324),
(30518, '68971', 218, 35, 142832, 40.0992, 0.69986306741571, -99.2286, -1.73186578214445),
(30519, '68972', 218, 35, 5429, 40.1115, 0.700077742913706, -98.8103, -1.72456506988335),
(30520, '68973', 218, 35, 11685, 40.4377, 0.705771006933711, -98.5535, -1.72008306436423),
(30521, '68974', 218, 35, 17879, 40.1324, 0.700442516727372, -97.877, -1.70827591197449),
(30522, '68975', 218, 35, 142954, 40.5685, 0.70805389759532, -97.938, -1.70934056281821),
(30523, '68976', 218, 35, 5916, 40.5854, 0.708348858238907, -99.859, -1.74286833774902),
(30524, '68977', 218, 35, 98270, 40.0897, 0.699697261136771, -99.5725, -1.73786796944205),
(30525, '68978', 218, 35, 6182, 40.023, 0.698533126525691, -98.0663, -1.71157982024852),
(30526, '68979', 218, 35, 12229, 40.6072, 0.708729340015841, -97.858, -1.70794429941661),
(30527, '68980', 218, 35, 98642, 40.6271, 0.709076660536988, -98.0936, -1.71205629513431),
(30528, '68981', 218, 35, 34227, 40.3062, 0.703475898967338, -98.8951, -1.72604510908904),
(30529, '68982', 218, 35, 6812, 40.3946, 0.705018770026101, -99.1222, -1.73000875182032),
(30530, '69001', 218, 35, 96086, 40.1763, 0.701208716268998, -100.6549, -1.75675941326564),
(30531, '69020', 218, 35, 108100, 40.2532, 0.702550874463782, -100.3068, -1.75068392213945),
(30532, '69021', 218, 35, 199171, 40.0506, 0.699014837399241, -101.5331, -1.77208689475665),
(30533, '69022', 218, 35, 1302, 40.283, 0.703070982580876, -100.1699, -1.74829456639347),
(30534, '69023', 218, 35, 1480, 40.4365, 0.705750062982687, -101.7416, -1.77572590624706),
(30535, '69024', 218, 35, 39967, 40.231, 0.702163411369839, -100.8359, -1.75991845921175),
(30536, '69025', 218, 35, 1933, 40.6334, 0.709186616279864, -100.5128, -1.75427930039856),
(30537, '69026', 218, 35, 64114, 40.0454, 0.698924080278137, -100.42, -1.75265963485271),
(30538, '69027', 218, 35, 8762, 40.4804, 0.706516262524313, -101.5132, -1.77173957423551),
(30539, '69028', 218, 35, 15957, 40.6615, 0.709677053799674, -100.0299, -1.74585110544068),
(30540, '69029', 218, 35, 199316, 40.7069, 0.71046943328008, -100.2157, -1.74909392719088),
(30541, '69030', 218, 35, 199369, 40.1594, 0.700913755625411, -101.9469, -1.77930906720141),
(30542, '69031', 218, 35, 9305, 40.4067, 0.705229954865593, -101.2412, -1.76699227867008),
(30543, '69032', 218, 35, 199386, 40.542, 0.707591385343541, -101.0357, -1.76340562705723),
(30544, '69033', 218, 35, 22138, 40.5192, 0.707193450274086, -101.6438, -1.77401897423861),
(30545, '69034', 218, 35, 16542, 40.2408, 0.702334453636534, -100.4174, -1.75261425629215),
(30546, '69036', 218, 35, 3708, 40.0886, 0.699678062514999, -100.2492, -1.7496786124903),
(30547, '69037', 218, 35, 56134, 40.1114, 0.700075997584454, -101.3799, -1.7694130503426),
(30548, '69038', 218, 35, 30467, 40.5257, 0.707306896675466, -100.6671, -1.75697234343438),
(30549, '69039', 218, 35, 4307, 40.5507, 0.707743228988465, -100.289, -1.75037325353259),
(30550, '69040', 218, 35, 137363, 40.2947, 0.703275186103359, -101.075, -1.76409154145327),
(30551, '69041', 218, 35, 11080, 40.1734, 0.70115810172069, -101.767, -1.77616921987707),
(30552, '69042', 218, 35, 199706, 40.4828, 0.70655815042636, -100.3823, -1.7520016457247),
(30553, '69043', 218, 35, 132, 40.1498, 0.700746204017219, -101.2256, -1.76672000730677),
(30554, '69044', 218, 35, 6381, 40.1337, 0.700465206007648, -101.041, -1.76349812950759),
(30555, '69045', 218, 35, 34354, 40.417, 0.705409723778548, -101.3708, -1.76925422538067),
(30556, '69046', 218, 35, 6863, 40.0894, 0.699692025149015, -100.1365, -1.7477116264233),
(30557, '69101', 218, 35, 199567, 41.1352, 0.717944678466371, -100.7739, -1.75883635507551),
(30558, '69103', 218, 35, 199567, 41.1362, 0.717962131758891, -100.7663, -1.75870371005236),
(30559, '69120', 218, 35, 26395, 41.4229, 0.722965990724359, -100.1932, -1.74870122810918),
(30560, '69121', 218, 35, 7168, 41.5684, 0.725505444786011, -101.6959, -1.7749282907789),
(30561, '69122', 218, 35, 753, 41.1085, 0.717478675556089, -102.1452, -1.78277005510811),
(30562, '69123', 218, 35, 34957, 41.0593, 0.716619973564108, -100.3708, -1.75180093286072),
(30563, '69125', 218, 35, 15333, 41.596, 0.725987155659561, -102.8529, -1.79512175022448),
(30564, '69127', 218, 35, 39545, 41.0965, 0.71726923604585, -101.8892, -1.77830201222301),
(30565, '69128', 218, 35, 15386, 41.1943, 0.7189761680543, -103.9223, -1.8137863012453),
(30566, '69129', 218, 35, 35213, 41.0935, 0.71721687616829, -102.4671, -1.78838826997028),
(30567, '69130', 218, 35, 141570, 40.8633, 0.713199128230199, -99.9847, -1.74506221661877),
(30568, '69131', 218, 35, 8391, 41.4088, 0.722719899299828, -102.9697, -1.79716029479081),
(30569, '69132', 218, 35, 46303, 40.8162, 0.71237707815251, -100.9917, -1.76263768218636),
(30570, '69133', 218, 35, 26957, 41.2021, 0.719112303735956, -103.4704, -1.80589915835554),
(30571, '69134', 218, 35, 35760, 40.8528, 0.713015868658739, -101.3659, -1.76916870424732),
(30572, '69135', 218, 35, 13725, 42.294, 0.738169553838482, -100.2916, -1.75041863209315),
(30573, '69138', 218, 35, 199350, 40.9322, 0.714401660084823, -100.1583, -1.74809210820024),
(30574, '69140', 218, 35, 104, 40.8454, 0.712886714294092, -101.7252, -1.77543967224974),
(30575, '69141', 218, 35, 2915, 41.2806, 0.720482387198771, -102.9937, -1.79757917381128),
(30576, '69142', 218, 35, 27362, 41.892, 0.731153330245465, -100.351, -1.75145535766883),
(30577, '69143', 218, 35, 162637, 41.1504, 0.718209968512674, -101.0064, -1.7628942455864),
(30578, '69144', 218, 35, 3513, 41.3036, 0.72088381292673, -101.6075, -1.77338541972014),
(30579, '69145', 218, 35, 9856, 41.2336, 0.719662082450334, -103.6584, -1.80918037734929),
(30580, '69146', 218, 35, 156114, 41.3379, 0.721482460860164, -101.8789, -1.77812224331005),
(30581, '69147', 218, 35, 199478, 41.4429, 0.723315056574758, -102.112, -1.78219060579645),
(30582, '69148', 218, 35, 199484, 41.5702, 0.725536860712547, -102.5435, -1.78972170151881),
(30583, '69149', 218, 35, 199487, 41.2257, 0.719524201439426, -102.6805, -1.79211280259404),
(30584, '69150', 218, 35, 3944, 40.8521, 0.713003651353975, -101.5328, -1.7720816587689),
(30585, '69151', 218, 35, 4045, 41.0791, 0.716965548756003, -100.5244, -1.75448175859179),
(30586, '69152', 218, 35, 199552, 42.0417, 0.7337660881357, -101.0456, -1.76357841465318),
(30587, '69153', 218, 35, 199577, 41.13, 0.717853921345268, -101.7205, -1.77535764177489),
(30588, '69154', 218, 35, 175714, 41.4058, 0.722667539422268, -102.3471, -1.78629387486789),
(30589, '69155', 218, 35, 17550, 41.2109, 0.719265892710131, -101.3759, -1.76934323717252),
(30590, '69156', 218, 35, 5197, 41.218, 0.719389811087023, -103.3148, -1.80318342603944),
(30591, '69157', 218, 35, 50631, 41.9605, 0.732348880783081, -100.104, -1.7471443944164),
(30592, '69160', 218, 35, 5844, 41.1429, 0.718079068818775, -102.9777, -1.79729992113096),
(30593, '69161', 218, 35, 18037, 41.9141, 0.731539048010155, -100.7633, -1.7586513501748),
(30594, '69162', 218, 35, 5844, 41.1399, 0.718026708941215, -102.9817, -1.79736973430104),
(30595, '69163', 218, 35, 6053, 41.4792, 0.723948611093232, -100.5122, -1.75426882842304),
(30596, '69165', 218, 35, 38454, 41.1586, 0.718353085511338, -101.1256, -1.76497467805478),
(30597, '69166', 218, 35, 67, 41.9789, 0.732670021365448, -100.5712, -1.75529857268172),
(30598, '69167', 218, 35, 18385, 41.5683, 0.725503699456759, -101.0601, -1.76383148739472),
(30599, '69168', 218, 35, 34257, 40.8502, 0.712970490098188, -101.9358, -1.77911533565444),
(30600, '69169', 218, 35, 721, 40.8369, 0.712738361307672, -101.1627, -1.76562219520727),
(30601, '69170', 218, 35, 126475, 40.7942, 0.711993105717071, -100.7284, -1.75804223026586),
(30602, '69171', 218, 35, 112076, 40.8495, 0.712958272793424, -100.0249, -1.74576383897808),
(30603, '69190', 218, 35, 175714, 41.4083, 0.722711172653568, -102.3447, -1.78625198696584),
(30604, '69201', 218, 35, 6493, 42.8763, 0.748332606072845, -100.568, -1.75524272214566),
(30605, '69210', 218, 35, 92138, 42.5492, 0.742623634089571, -99.8597, -1.74288055505378),
(30606, '69211', 218, 35, 8158, 42.598, 0.743475354764545, -101.3859, -1.76951777009772),
(30607, '69212', 218, 35, 134859, 42.9008, 0.748760211739583, -100.7941, -1.75918891158442),
(30608, '69214', 218, 35, 3440, 42.4598, 0.741063309738288, -100.0708, -1.74656494510474),
(30609, '69216', 218, 35, 3520, 42.8738, 0.748288972841545, -101.0163, -1.76306703318235),
(30610, '69217', 218, 35, 66472, 42.4368, 0.74066188401033, -99.7483, -1.74093625826706),
(30611, '69218', 218, 35, 132059, 42.3961, 0.739951535004768, -101.7016, -1.77502777454627),
(30612, '69219', 218, 35, 199558, 42.5215, 0.742140177886769, -100.8061, -1.75939835109466),
(30613, '69220', 218, 35, 25000, 42.9411, 0.749463579428137, -100.2575, -1.74982347481821),
(30614, '69221', 218, 35, 44197, 42.6291, 0.744018152161915, -100.3014, -1.75058967435984),
(30615, '69301', 218, 35, 14970, 42.1101, 0.734959893344064, -102.8756, -1.79551793996468),
(30616, '69331', 218, 35, 77787, 41.8958, 0.73121965275704, -103.0729, -1.79896147457886),
(30617, '69333', 218, 35, 92351, 41.9086, 0.731443054901296, -101.9544, -1.77943996689531),
(30618, '69334', 218, 35, 360, 41.7595, 0.728840768986572, -103.3228, -1.8033230523796),
(30619, '69335', 218, 35, 777, 42.2678, 0.737712277574459, -102.1546, -1.7829341160578),
(30620, '69336', 218, 35, 1130, 41.6668, 0.727222848769973, -103.097, -1.79938209892859),
(30621, '69337', 218, 35, 199222, 42.8281, 0.747491357373383, -103.0014, -1.79771356416369),
(30622, '69339', 218, 35, 1860, 42.6839, 0.744974592592008, -103.4095, -1.80483625284108),
(30623, '69340', 218, 35, 579, 42.1755, 0.736101338674868, -102.4581, -1.7882311903376),
(30624, '69341', 218, 35, 199337, 41.8276, 0.73002933820718, -103.6647, -1.80929033309217),
(30625, '69343', 218, 35, 2785, 42.807, 0.747123092901213, -102.2025, -1.7837701287695),
(30626, '69345', 218, 35, 2994, 41.5464, 0.725121472350572, -103.7099, -1.81007922191407),
(30627, '69346', 218, 35, 9353, 42.6908, 0.745095020310395, -103.8555, -1.81262042130497),
(30628, '69347', 218, 35, 199385, 42.6838, 0.744972847262756, -102.6907, -1.79229082617774),
(30629, '69348', 218, 35, 199394, 42.3189, 0.738604140822228, -103.076, -1.79901557978568),
(30630, '69349', 218, 35, 9426, 42, 0.733038285837618, -104.0471, -1.81596447215179),
(30631, '69350', 218, 35, 199417, 42.0034, 0.733097627032186, -101.7657, -1.77614653059679),
(30632, '69351', 218, 35, 9948, 42.0699, 0.734258270984762, -102.4071, -1.78734107241909),
(30633, '69352', 218, 35, 60722, 41.9167, 0.731584426570707, -104.0376, -1.81579866587285),
(30634, '69353', 218, 35, 199521, 41.7829, 0.729249176031539, -103.6805, -1.80956609511398),
(30635, '69354', 218, 35, 199514, 42.5266, 0.742229189678621, -103.105, -1.79952172526875),
(30636, '69355', 218, 35, 199527, 41.7826, 0.729243940043783, -103.6801, -1.80955911379697),
(30637, '69356', 218, 35, 199532, 41.8505, 0.730429018605887, -103.6143, -1.80841068714916),
(30638, '69357', 218, 35, 4252, 41.943, 0.732043448163982, -103.8091, -1.81181058853205),
(30639, '69358', 218, 35, 33340, 41.9651, 0.732429165928672, -103.9256, -1.81384389711062),
(30640, '69360', 218, 35, 31020, 42.7155, 0.745526116635638, -102.4584, -1.78823642632536),
(30641, '69361', 218, 35, 199669, 41.8665, 0.730708271286206, -103.6591, -1.80919259465405),
(30642, '69363', 218, 35, 199669, 41.8686, 0.730744923200498, -103.6589, -1.80918910399555),
(30643, '69365', 218, 35, 199777, 42.7016, 0.745283515869611, -102.4522, -1.78812821591173),
(30644, '69366', 218, 35, 34417, 41.9181, 0.731608861180235, -101.533, -1.7720851494274),
(30645, '69367', 218, 35, 6800, 42.7379, 0.745917070388085, -103.2253, -1.8016213563589),
(30646, '70001', 218, 22, 42075, 29.985, 0.5233369762105, -90.1662, -1.57369706401171),
(30647, '70002', 218, 22, 42075, 30.0179, 0.523911189534406, -90.1615, -1.57361503353687),
(30648, '70003', 218, 22, 42075, 29.9963, 0.523534198415975, -90.2151, -1.57455053001594),
(30649, '70004', 218, 22, 42075, 29.9977, 0.523558633025503, -90.1774, -1.57389254088793),
(30650, '70005', 218, 22, 42075, 29.9985, 0.523572595659519, -90.1334, -1.57312459601706),
(30651, '70006', 218, 22, 42075, 30.0142, 0.523846612352082, -90.1927, -1.57415957626349),
(30652, '70009', 218, 22, 42075, 30.0103, 0.523778544511254, -90.1621, -1.57362550551238),
(30653, '70010', 218, 22, 42075, 30.0104, 0.523780289840506, -90.1623, -1.57362899617088),
(30654, '70011', 218, 22, 42075, 30.0092, 0.523759345889482, -90.156, -1.57351904042801),
(30655, '70030', 218, 22, 40059, 29.8251, 0.520546194736561, -90.4621, -1.57886149326836),
(30656, '70031', 218, 22, 39093, 29.9501, 0.522727856301554, -90.2917, -1.57588745222296),
(30657, '70032', 218, 22, 18888, 29.9581, 0.522867482641713, -89.999, -1.57077887350238),
(30658, '70033', 218, 22, 42075, 29.9983, 0.523569105001015, -90.2117, -1.57449118882137),
(30659, '70036', 218, 22, 39218, 29.6918, 0.518219670843652, -90.1029, -1.5725922705952),
(30660, '70037', 218, 22, 39322, 29.8539, 0.521048849561135, -90.0007, -1.57080854409966),
(30661, '70038', 218, 22, 39449, 29.3465, 0.512193048936516, -89.4235, -1.56073450365715),
(30662, '70039', 218, 22, 39465, 29.9016, 0.521881371614336, -90.3773, -1.57738145406267),
(30663, '70040', 218, 22, 39471, 29.8268, 0.520575865333845, -89.9639, -1.57016626293493),
(30664, '70041', 218, 22, 35059, 29.3493, 0.512241918155572, -89.5165, -1.5623576598615),
(30665, '70042', 218, 22, 1358, 29.8575, 0.521111681414207, -89.9721, -1.57030937993359),
(30666, '70043', 218, 22, 39724, 29.9461, 0.522658043131474, -89.962, -1.57013310167914),
(30667, '70044', 218, 22, 39724, 29.9492, 0.522712148338286, -89.96, -1.5700981950941),
(30668, '70046', 218, 22, 40006, 29.6303, 0.517146293353676, -89.7893, -1.56711891806094),
(30669, '70047', 218, 22, 40063, 29.9663, 0.523010599640377, -90.3753, -1.57734654747763),
(30670, '70049', 218, 22, 40767, 30.0502, 0.5244749308828, -90.5821, -1.58095588837076),
(30671, '70050', 218, 22, 2294, 29.37, 0.512603201310735, -89.5722, -1.56332980825486),
(30672, '70051', 218, 22, 41051, 30.0582, 0.52461455722296, -90.6168, -1.5815615176212),
(30673, '70052', 218, 22, 41144, 30.0518, 0.524502856150832, -90.6871, -1.58278848408535),
(30674, '70053', 218, 22, 16287, 29.9137, 0.522092556453828, -90.0539, -1.57173705926172),
(30675, '70054', 218, 22, 16287, 29.914, 0.522097792441584, -90.0528, -1.57171786063995),
(30676, '70055', 218, 22, 42075, 29.999, 0.523581322305779, -90.1335, -1.57312634134631),
(30677, '70056', 218, 22, 16287, 29.8928, 0.521727782640161, -90.0295, -1.57131119892424),
(30678, '70057', 218, 22, 41243, 29.9676, 0.523033288920653, -90.4071, -1.57790156217977),
(30679, '70058', 218, 22, 9372, 29.8795, 0.521495653849646, -90.0681, -1.5719848960155),
(30680, '70059', 218, 22, 9372, 29.9033, 0.52191104221162, -90.0771, -1.57214197564818),
(30681, '70060', 218, 22, 42075, 29.8679, 0.521293195656414, -90.0693, -1.57200583996653),
(30682, '70062', 218, 22, 27616, 29.989, 0.52340678938058, -90.2515, -1.57518582986366),
(30683, '70063', 218, 22, 27616, 29.9915, 0.523450422611879, -90.2559, -1.57526262435075),
(30684, '70064', 218, 22, 27616, 30.0239, 0.524015909289526, -90.2525, -1.57520328315618),
(30685, '70065', 218, 22, 27616, 30.0237, 0.524012418631022, -90.2492, -1.57514568729087),
(30686, '70066', 218, 22, 41601, 30.0066, 0.523713967328931, -90.485, -1.57926117366707),
(30687, '70067', 218, 22, 41661, 29.7214, 0.518736288302243, -90.1215, -1.57291690183607),
(30688, '70068', 218, 22, 3586, 30.0748, 0.524904281878791, -90.4884, -1.57932051486164),
(30689, '70069', 218, 22, 3586, 30.0732, 0.524876356610759, -90.4976, -1.57948108515282),
(30690, '70070', 218, 22, 41903, 29.9139, 0.522096047112332, -90.3572, -1.57703064288302),
(30691, '70071', 218, 22, 41913, 30.0443, 0.524371956456932, -90.7004, -1.58302061287586),
(30692, '70072', 218, 22, 41988, 29.8728, 0.521378716789762, -90.1081, -1.5726830277163),
(30693, '70073', 218, 22, 41988, 29.8615, 0.521181494584287, -90.1198, -1.57288723123879),
(30694, '70075', 218, 22, 42067, 29.9318, 0.522408461048439, -89.9203, -1.56940529938106),
(30695, '70076', 218, 22, 23207, 30.0512, 0.52449238417532, -90.6377, -1.58192629143486),
(30696, '70078', 218, 22, 42273, 29.9848, 0.523333485551996, -90.3864, -1.5775402790246),
(30697, '70079', 218, 22, 42305, 30.0055, 0.523694768707159, -90.4129, -1.57800279127638),
(30698, '70080', 218, 22, 42488, 29.8764, 0.521441548642834, -90.436, -1.57840596233359),
(30699, '70081', 218, 22, 14410, 29.1812, 0.509308019682969, -89.258, -1.5578459837451),
(30700, '70082', 218, 22, 42639, 29.5756, 0.516191598252835, -89.7919, -1.5671642966215),
(30701, '70083', 218, 22, 42666, 29.4435, 0.51388601831095, -89.7652, -1.56669829371121),
(30702, '70084', 218, 22, 33745, 30.0606, 0.524656445125007, -90.5566, -1.5805108294115),
(30703, '70085', 218, 22, 42907, 29.8672, 0.52128097835165, -89.85, -1.56817833291691),
(30704, '70086', 218, 22, 11756, 30.0318, 0.524153790300433, -90.8558, -1.58573285453346),
(30705, '70087', 218, 22, 28509, 29.9592, 0.522886681263485, -90.312, -1.57624175406112),
(30706, '70090', 218, 22, 43450, 29.9627, 0.522947767787305, -90.706, -1.58311835131398),
(30707, '70091', 218, 22, 12543, 29.2076, 0.509768786605496, -89.2328, -1.5574061607736),
(30708, '70092', 218, 22, 43503, 29.9055, 0.521949439455164, -89.898, -1.56901609095786),
(30709, '70094', 218, 22, 44103, 29.9166, 0.522143171002136, -90.1824, -1.57397980735053),
(30710, '70096', 218, 22, 44103, 29.9048, 0.5219372221504, -90.1428, -1.57328865696674),
(30711, '70112', 218, 22, 42266, 29.9577, 0.522860501324705, -90.0768, -1.57213673966043),
(30712, '70113', 218, 22, 42266, 29.9441, 0.522623136546434, -90.0836, -1.57225542204956),
(30713, '70114', 218, 22, 42266, 29.9346, 0.522457330267495, -90.0229, -1.5711960071936),
(30714, '70115', 218, 22, 42266, 29.9273, 0.522329921232099, -90.1015, -1.57256783598567),
(30715, '70116', 218, 22, 42266, 29.9678, 0.523036779579157, -90.0666, -1.57195871607672),
(30716, '70117', 218, 22, 42266, 29.9696, 0.523068195505693, -90.0298, -1.57131643491199),
(30717, '70118', 218, 22, 42266, 29.9514, 0.52275054558183, -90.121, -1.57290817518981),
(30718, '70119', 218, 22, 42266, 29.9748, 0.523158952626796, -90.0869, -1.57231301791488),
(30719, '70121', 218, 22, 42266, 29.9632, 0.522956494433565, -90.1585, -1.57356267365931),
(30720, '70122', 218, 22, 42266, 30.0055, 0.523694768707159, -90.0637, -1.57190810152842),
(30721, '70123', 218, 22, 42266, 29.9535, 0.522787197496121, -90.2092, -1.57444755559007),
(30722, '70124', 218, 22, 42266, 30.0076, 0.52373142062145, -90.1061, -1.57264812113126),
(30723, '70125', 218, 22, 42266, 29.9521, 0.522762762886594, -90.1028, -1.57259052526595),
(30724, '70126', 218, 22, 42266, 30.0162, 0.523881518937122, -90.0189, -1.57112619402352),
(30725, '70127', 218, 22, 42266, 30.0307, 0.524134591678661, -89.9784, -1.57041933567647),
(30726, '70128', 218, 22, 42266, 30.051, 0.524488893516816, -89.955, -1.5700109286315),
(30727, '70129', 218, 22, 42266, 30.045, 0.524384173761696, -89.9035, -1.56911208406672),
(30728, '70130', 218, 22, 42266, 29.9377, 0.522511435474306, -90.0726, -1.57206343583184),
(30729, '70131', 218, 22, 42266, 29.9201, 0.522204257525955, -89.9961, -1.57072825895407),
(30730, '70139', 218, 22, 42266, 29.9371, 0.522500963498794, -90.0706, -1.5720285292468),
(30731, '70140', 218, 22, 42266, 29.9558, 0.522827340068917, -90.0784, -1.57216466492846),
(30732, '70141', 218, 22, 42266, 29.9896, 0.523417261356091, -90.2544, -1.57523644441197),
(30733, '70142', 218, 22, 42266, 29.9443, 0.522626627204938, -90.0332, -1.57137577610656),
(30734, '70143', 218, 22, 42266, 29.8242, 0.520530486773293, -90.011, -1.57098831301262),
(30735, '70145', 218, 22, 42266, 29.9618, 0.522932059824037, -90.0329, -1.5713705401188),
(30736, '70146', 218, 22, 42266, 30.0341, 0.524193932873229, -90.0426, -1.57153983705625),
(30737, '70148', 218, 22, 42266, 30.0303, 0.524127610361653, -90.0658, -1.57194475344271),
(30738, '70149', 218, 22, 42266, 29.962, 0.522935550482541, -90.0336, -1.57138275742357),
(30739, '70150', 218, 22, 42266, 29.9435, 0.522612664570922, -90.0827, -1.5722397140863),
(30740, '70151', 218, 22, 42266, 29.9425, 0.522595211278402, -90.0827, -1.5722397140863),
(30741, '70152', 218, 22, 42266, 29.9427, 0.522598701936906, -90.0835, -1.57225367672031),
(30742, '70153', 218, 22, 42266, 29.9426, 0.522596956607654, -90.0833, -1.57225018606181),
(30743, '70154', 218, 22, 42266, 29.9207, 0.522214729501467, -90.1, -1.57254165604689),
(30744, '70156', 218, 22, 42266, 29.9435, 0.522612664570922, -90.0835, -1.57225367672031),
(30745, '70157', 218, 22, 42266, 29.9429, 0.52260219259541, -90.0835, -1.57225367672031),
(30746, '70158', 218, 22, 42266, 29.9223, 0.522242654769499, -90.0709, -1.57203376523456),
(30747, '70159', 218, 22, 42266, 29.97, 0.523075176822701, -90.0304, -1.5713269068875),
(30748, '70160', 218, 22, 42266, 29.9438, 0.522617900558678, -90.083, -1.57224495007405),
(30749, '70161', 218, 22, 42266, 29.9434, 0.52261091924167, -90.0828, -1.57224145941555),
(30750, '70162', 218, 22, 42266, 29.9578, 0.522862246653957, -90.0757, -1.57211754103866),
(30751, '70163', 218, 22, 42266, 29.9562, 0.522834321385925, -90.0771, -1.57214197564818),
(30752, '70164', 218, 22, 42266, 30.0065, 0.523712221999678, -90.0033, -1.57085392266021),
(30753, '70165', 218, 22, 42266, 29.9445, 0.522630117863442, -90.0722, -1.57205645451484),
(30754, '70166', 218, 22, 42266, 29.9508, 0.522740073606318, -90.0733, -1.57207565313661),
(30755, '70167', 218, 22, 42266, 29.9628, 0.522949513116557, -90.0836, -1.57225542204956),
(30756, '70170', 218, 22, 42266, 29.9372, 0.522502708828046, -90.0706, -1.5720285292468),
(30757, '70172', 218, 22, 42266, 29.9585, 0.522874463958721, -90.0757, -1.57211754103866),
(30758, '70174', 218, 22, 42266, 29.9252, 0.522293269317807, -90.0148, -1.57105463552419),
(30759, '70175', 218, 22, 42266, 29.9267, 0.522319449256587, -90.1034, -1.57260099724146),
(30760, '70176', 218, 22, 42266, 29.9373, 0.522504454157298, -90.071, -1.57203551056381),
(30761, '70177', 218, 22, 42266, 29.9796, 0.523242728430892, -90.0053, -1.57088882924525),
(30762, '70178', 218, 22, 42266, 29.9471, 0.522675496423994, -90.1256, -1.5729884603354),
(30763, '70179', 218, 22, 42266, 29.9762, 0.523183387236324, -90.0873, -1.57231999923189),
(30764, '70181', 218, 22, 42266, 29.9637, 0.522965221079825, -90.0652, -1.5719342814672),
(30765, '70182', 218, 22, 42266, 30.0099, 0.523771563194246, -90.0655, -1.57193951745495),
(30766, '70183', 218, 22, 42266, 29.9552, 0.522816868093405, -90.2037, -1.57435156248121),
(30767, '70184', 218, 22, 42266, 30.0049, 0.523684296731647, -90.1046, -1.57262194119248),
(30768, '70185', 218, 22, 42266, 29.9532, 0.522781961508366, -90.1039, -1.57260972388772),
(30769, '70186', 218, 22, 42266, 30.0066, 0.523713967328931, -90.0029, -1.5708469413432),
(30770, '70187', 218, 22, 42266, 30.0239, 0.524015909289526, -89.9753, -1.57036523046965),
(30771, '70189', 218, 22, 42266, 30.076, 0.524925225829815, -89.8167, -1.56759713827599),
(30772, '70190', 218, 22, 42266, 29.938, 0.522516671462062, -90.0706, -1.5720285292468),
(30773, '70195', 218, 22, 42266, 29.9546, 0.522806396117893, -90.0746, -1.57209834241688),
(30774, '70301', 218, 22, 43338, 29.8037, 0.520172694276634, -90.8131, -1.58498759894286),
(30775, '70302', 218, 22, 43338, 29.8042, 0.520181420922894, -90.8278, -1.58524416234291),
(30776, '70310', 218, 22, 43338, 29.7901, 0.519935329498363, -90.8213, -1.58513071594153);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(30777, '70339', 218, 22, 42554, 29.9603, 0.522905879885257, -91.2032, -1.59179612835489),
(30778, '70340', 218, 22, 39096, 29.6962, 0.51829646533074, -91.2764, -1.59307370936735),
(30779, '70341', 218, 22, 39329, 30.0286, 0.524097939764369, -91.0622, -1.58933521410958),
(30780, '70342', 218, 22, 400, 29.6951, 0.518277266708968, -91.2237, -1.59215392085155),
(30781, '70343', 218, 22, 39463, 29.551, 0.515762247256844, -90.6071, -1.58139222068375),
(30782, '70344', 218, 22, 39748, 29.4847, 0.514605093962772, -90.5902, -1.58109726004017),
(30783, '70345', 218, 22, 39975, 29.5177, 0.51518105261593, -90.337, -1.57667808637412),
(30784, '70346', 218, 22, 8559, 30.104, 0.525413918020373, -90.9983, -1.58821994871756),
(30785, '70352', 218, 22, 575, 29.6948, 0.518272030721212, -90.952, -1.58741186127388),
(30786, '70353', 218, 22, 40716, 29.3983, 0.513097129489049, -90.7077, -1.58314802191126),
(30787, '70354', 218, 22, 41035, 29.4288, 0.513629454910907, -90.2936, -1.57592061347875),
(30788, '70355', 218, 22, 41072, 29.7056, 0.518460526280428, -90.4881, -1.57931527887388),
(30789, '70356', 218, 22, 2709, 29.6599, 0.517662910812266, -90.959, -1.58753403432152),
(30790, '70357', 218, 22, 41110, 29.3929, 0.513002881709441, -90.269, -1.57549126248276),
(30791, '70358', 218, 22, 41155, 29.2144, 0.509887468994631, -90.0368, -1.57143860795963),
(30792, '70359', 218, 22, 21530, 29.6891, 0.518172546953849, -90.7788, -1.58438895100943),
(30793, '70360', 218, 22, 41416, 29.5918, 0.516474341591658, -90.7463, -1.58382171900253),
(30794, '70361', 218, 22, 41416, 29.5974, 0.51657208002977, -90.7219, -1.58339585866504),
(30795, '70363', 218, 22, 41416, 29.5743, 0.516168908972559, -90.6895, -1.5828303719874),
(30796, '70364', 218, 22, 41416, 29.6228, 0.517015393659776, -90.7305, -1.58354595698072),
(30797, '70371', 218, 22, 41638, 29.8675, 0.521286214339406, -90.5956, -1.58119150781977),
(30798, '70372', 218, 22, 41651, 29.8356, 0.52072945430802, -90.961, -1.58756894090656),
(30799, '70373', 218, 22, 41724, 29.5729, 0.516144474363031, -90.3855, -1.57752457106133),
(30800, '70374', 218, 22, 36937, 29.6226, 0.517011903001272, -90.4948, -1.57943221593376),
(30801, '70375', 218, 22, 42009, 29.6877, 0.518148112344321, -90.5542, -1.58046894150945),
(30802, '70376', 218, 22, 42130, 30.1605, 0.52640002904775, -91.0275, -1.58872958485914),
(30803, '70377', 218, 22, 42143, 29.4751, 0.514437542354581, -90.5448, -1.58030488055976),
(30804, '70380', 218, 22, 4321, 29.6985, 0.518336607903536, -91.2136, -1.5919776425971),
(30805, '70381', 218, 22, 4321, 29.6952, 0.51827901203822, -91.1934, -1.5916250860882),
(30806, '70390', 218, 22, 42236, 29.9066, 0.521968638076936, -91.0291, -1.58875751012717),
(30807, '70391', 218, 22, 42479, 29.9901, 0.523425988002351, -91.0546, -1.58920256908643),
(30808, '70392', 218, 22, 428, 29.6979, 0.518326135928024, -91.3054, -1.59357985485043),
(30809, '70393', 218, 22, 42612, 29.9881, 0.523391081417312, -91.0223, -1.58863882773803),
(30810, '70394', 218, 22, 37848, 29.7098, 0.518533830109011, -90.6015, -1.58129448224564),
(30811, '70395', 218, 22, 42988, 29.713, 0.518589680645075, -90.8278, -1.58524416234291),
(30812, '70397', 218, 22, 43336, 29.415, 0.513388599474132, -90.7788, -1.58438895100943),
(30813, '70401', 218, 22, 421, 30.5178, 0.532636090465126, -90.476, -1.57910409403439),
(30814, '70402', 218, 22, 421, 30.5076, 0.532458066881422, -90.4599, -1.57882309602482),
(30815, '70403', 218, 22, 421, 30.4851, 0.532065367799723, -90.4761, -1.57910583936364),
(30816, '70404', 218, 22, 421, 30.5102, 0.532503445441974, -90.4581, -1.57879168009828),
(30817, '70420', 218, 22, 39037, 30.4791, 0.531960648044604, -90.021, -1.57116284593782),
(30818, '70421', 218, 22, 39049, 30.3983, 0.530550422008992, -90.3697, -1.57724880903952),
(30819, '70422', 218, 22, 39098, 30.7254, 0.536259393992266, -90.5081, -1.57966434472428),
(30820, '70426', 218, 22, 39110, 30.9634, 0.540413277612012, -89.8123, -1.5675203437889),
(30821, '70427', 218, 22, 39422, 30.7732, 0.537093661374719, -89.8631, -1.56840697104892),
(30822, '70429', 218, 22, 39422, 30.7912, 0.537407820640078, -89.849, -1.56816087962439),
(30823, '70431', 218, 22, 1255, 30.6014, 0.534095185719793, -89.9815, -1.57047344088328),
(30824, '70433', 218, 22, 15652, 30.4986, 0.532300987248743, -90.0993, -1.57252943874213),
(30825, '70434', 218, 22, 15652, 30.468, 0.531766916497632, -90.0942, -1.57244042695028),
(30826, '70435', 218, 22, 15652, 30.514, 0.53256976795355, -90.1035, -1.57260274257071),
(30827, '70436', 218, 22, 40935, 30.8278, 0.538046611146308, -90.5368, -1.5801652542196),
(30828, '70437', 218, 22, 2511, 30.6043, 0.534145800268101, -90.1843, -1.57401296860632),
(30829, '70438', 218, 22, 21288, 30.8486, 0.538409639630723, -90.1451, -1.57332879953954),
(30830, '70441', 218, 22, 29951, 30.8845, 0.539036212832189, -90.7497, -1.5838810601971),
(30831, '70442', 218, 22, 41450, 30.5953, 0.533988720635421, -90.3383, -1.57670077565439),
(30832, '70443', 218, 22, 3320, 30.6282, 0.534562933959327, -90.4977, -1.57948283048207),
(30833, '70444', 218, 22, 41589, 30.9355, 0.539926330750706, -90.5164, -1.5798092070522),
(30834, '70445', 218, 22, 41655, 30.3199, 0.529182083875429, -89.921, -1.56941751668582),
(30835, '70446', 218, 22, 41870, 30.6361, 0.534700814970235, -90.4453, -1.57856827795403),
(30836, '70447', 218, 22, 37022, 30.4274, 0.531058312821323, -90.1826, -1.57398329800904),
(30837, '70448', 218, 22, 10284, 30.3852, 0.530321783876981, -90.0682, -1.57198664134476),
(30838, '70449', 218, 22, 42011, 30.2755, 0.528407157687543, -90.7012, -1.58303457550988),
(30839, '70450', 218, 22, 37293, 30.9518, 0.540210819418781, -90.2753, -1.57560121822564),
(30840, '70451', 218, 22, 42238, 30.546, 0.533128273314188, -90.4851, -1.57926291899632),
(30841, '70452', 218, 22, 42519, 30.4014, 0.530604527215804, -89.7767, -1.56689900657519),
(30842, '70453', 218, 22, 557, 30.6951, 0.535730559228911, -90.7751, -1.5843243738271),
(30843, '70454', 218, 22, 42646, 30.4433, 0.53133582017239, -90.3999, -1.57777589847362),
(30844, '70455', 218, 22, 42831, 30.5182, 0.532643071782133, -90.3325, -1.57659954655778),
(30845, '70456', 218, 22, 11685, 30.7655, 0.536959271022315, -90.5126, -1.57974288454062),
(30846, '70457', 218, 22, 33852, 30.5241, 0.532746046208001, -90.0965, -1.57248056952307),
(30847, '70458', 218, 22, 43093, 30.2753, 0.528403667029039, -89.7724, -1.56682395741736),
(30848, '70459', 218, 22, 43093, 30.2871, 0.528609615880775, -89.7743, -1.56685711867315),
(30849, '70460', 218, 22, 43093, 30.2929, 0.52871084497739, -89.8217, -1.56768440473859),
(30850, '70461', 218, 22, 43093, 30.2796, 0.528478716186875, -89.7251, -1.56599841668116),
(30851, '70462', 218, 22, 349, 30.3839, 0.530299094596705, -90.5735, -1.58080579005508),
(30852, '70463', 218, 22, 133, 30.6247, 0.534501847435507, -89.9704, -1.57027970933631),
(30853, '70464', 218, 22, 43282, 30.5321, 0.532885672548161, -89.8767, -1.56864433582719),
(30854, '70465', 218, 22, 43291, 30.8758, 0.538884369187265, -90.5154, -1.57979175375968),
(30855, '70466', 218, 22, 43347, 30.558, 0.533337712824427, -90.4981, -1.57948981179908),
(30856, '70467', 218, 22, 39110, 30.9812, 0.540723946218867, -89.7486, -1.56640856905538),
(30857, '70469', 218, 22, 43093, 30.2808, 0.528499660137899, -89.7774, -1.56691122387996),
(30858, '70470', 218, 22, 10284, 30.388, 0.530370653096037, -90.082, -1.57222749678153),
(30859, '70471', 218, 22, 10284, 30.3808, 0.530244989389893, -90.0807, -1.57220480750126),
(30860, '70501', 218, 22, 3594, 30.2335, 0.527674119401706, -92.0045, -1.60578145165112),
(30861, '70502', 218, 22, 3594, 30.2231, 0.527492605159498, -92.0209, -1.60606768564845),
(30862, '70503', 218, 22, 3594, 30.1874, 0.526869522616536, -92.0466, -1.60651623526621),
(30863, '70504', 218, 22, 3594, 30.1897, 0.526909665189332, -92.04, -1.60640104353558),
(30864, '70505', 218, 22, 3594, 30.2303, 0.527618268865642, -92.0427, -1.60644816742538),
(30865, '70506', 218, 22, 3594, 30.2087, 0.527241277747211, -92.0648, -1.60683388519008),
(30866, '70507', 218, 22, 3594, 30.2817, 0.528515368101167, -92.0193, -1.60603976038042),
(30867, '70508', 218, 22, 3594, 30.1586, 0.526366867791962, -92.0269, -1.60617240540357),
(30868, '70509', 218, 22, 3594, 30.239, 0.527770112510565, -92.0078, -1.60583904751644),
(30869, '70510', 218, 22, 18708, 29.9704, 0.523082158139709, -92.1338, -1.60803816237395),
(30870, '70511', 218, 22, 18708, 29.966, 0.523005363652621, -92.13, -1.60797183986238),
(30871, '70512', 218, 22, 39148, 30.359, 0.529864507612959, -91.9229, -1.6043572629815),
(30872, '70513', 218, 22, 39186, 30.045, 0.524384173761696, -91.8789, -1.60358931811062),
(30873, '70514', 218, 22, 722, 29.8369, 0.520752143588296, -91.5475, -1.59780529696951),
(30874, '70515', 218, 22, 39236, 30.4846, 0.532056641153463, -92.5983, -1.61614521674947),
(30875, '70516', 218, 22, 7649, 30.3361, 0.529464827214252, -92.3393, -1.6116248139868),
(30876, '70517', 218, 22, 39482, 30.2764, 0.528422865650811, -91.8986, -1.60393314797326),
(30877, '70518', 218, 22, 39526, 30.1406, 0.526052708526603, -91.958, -1.60496987354895),
(30878, '70519', 218, 22, 39603, 30.1035, 0.525405191374113, -91.9119, -1.60416527676378),
(30879, '70520', 218, 22, 39647, 30.3268, 0.529302511593816, -92.0412, -1.6064219874866),
(30880, '70521', 218, 22, 35181, 30.3361, 0.529464827214252, -91.8475, -1.60304128472549),
(30881, '70522', 218, 22, 1459, 29.7589, 0.519390786771741, -91.4285, -1.59572835515964),
(30882, '70523', 218, 22, 39732, 29.8882, 0.521647497494569, -91.5263, -1.59743528716809),
(30883, '70524', 218, 22, 39741, 30.5681, 0.533513991078879, -92.3222, -1.61132636268471),
(30884, '70525', 218, 22, 39785, 30.4053, 0.530672595056632, -92.2159, -1.60947107768984),
(30885, '70526', 218, 22, 8340, 30.2138, 0.527330289539063, -92.3744, -1.61223742455425),
(30886, '70527', 218, 22, 8340, 30.2322, 0.52765143012143, -92.379, -1.61231770969984),
(30887, '70528', 218, 22, 40043, 29.9482, 0.522694695045766, -91.9943, -1.60560342806742),
(30888, '70529', 218, 22, 40726, 30.1918, 0.526946317103624, -92.1503, -1.60832614170053),
(30889, '70531', 218, 22, 928, 30.2568, 0.52808078111742, -92.4919, -1.61428818642534),
(30890, '70532', 218, 22, 40808, 30.4441, 0.531349782806406, -92.7073, -1.61804762563414),
(30891, '70533', 218, 22, 40828, 29.9598, 0.522897153238997, -92.0319, -1.60625967186617),
(30892, '70534', 218, 22, 40840, 30.1839, 0.526808436092716, -92.4628, -1.61378029561301),
(30893, '70535', 218, 22, 661, 30.4936, 0.532213720786143, -92.4163, -1.61296871751084),
(30894, '70537', 218, 22, 40848, 30.2605, 0.528145358299744, -92.5637, -1.61554133282828),
(30895, '70538', 218, 22, 2595, 29.7948, 0.520017359973207, -91.5093, -1.59713858119525),
(30896, '70540', 218, 22, 2657, 29.765, 0.519497251856112, -91.4661, -1.59638459895839),
(30897, '70541', 218, 22, 41152, 30.4193, 0.530916941151911, -92.0465, -1.60651448993696),
(30898, '70542', 218, 22, 41219, 30.0276, 0.524080486471849, -92.5088, -1.61458314706893),
(30899, '70543', 218, 22, 41490, 30.3262, 0.529292039618304, -92.5148, -1.61468786682405),
(30900, '70544', 218, 22, 41520, 29.9156, 0.522125717709616, -91.6721, -1.59997997721749),
(30901, '70546', 218, 22, 16612, 30.2228, 0.527487369171742, -92.6572, -1.61717321567889),
(30902, '70548', 218, 22, 41566, 30.0039, 0.523666843439127, -92.2821, -1.61062648565466),
(30903, '70549', 218, 22, 41669, 30.0837, 0.525059616182218, -92.6774, -1.61752577218779),
(30904, '70550', 218, 22, 41741, 30.5161, 0.532606419867842, -92.1759, -1.60877294598904),
(30905, '70551', 218, 22, 41777, 30.4694, 0.53179135110716, -91.9905, -1.60553710555584),
(30906, '70552', 218, 22, 41871, 30.0501, 0.524473185553548, -91.7475, -1.6012959554735),
(30907, '70554', 218, 22, 41958, 30.634, 0.534664163055943, -92.4168, -1.6129774441571),
(30908, '70555', 218, 22, 37097, 30.104, 0.525413918020373, -92.1249, -1.60788282807052),
(30909, '70556', 218, 22, 42070, 30.189, 0.526897447884568, -92.5802, -1.61582931215485),
(30910, '70558', 218, 22, 4232, 30.1046, 0.525424389995885, -92.0751, -1.60701365410303),
(30911, '70559', 218, 22, 33346, 30.0965, 0.525283018326473, -92.5024, -1.6144714459968),
(30912, '70560', 218, 22, 42262, 30, 0.523598775598299, -91.8178, -1.60252292193765),
(30913, '70562', 218, 22, 42262, 29.9909, 0.523439950636367, -91.8196, -1.60255433786419),
(30914, '70563', 218, 22, 42262, 30.046, 0.524401627054216, -91.7394, -1.60115458380409),
(30915, '70569', 218, 22, 3910, 29.9242, 0.522275816025287, -91.7826, -1.60190856604095),
(30916, '70570', 218, 22, 42445, 30.5311, 0.532868219255641, -92.0835, -1.6071602617602),
(30917, '70571', 218, 22, 42445, 30.5335, 0.532910107157689, -92.0809, -1.60711488319965),
(30918, '70575', 218, 22, 11148, 29.9483, 0.522696440375018, -92.1573, -1.60844831474817),
(30919, '70576', 218, 22, 11213, 30.7828, 0.537261212982911, -92.4248, -1.61311707049726),
(30920, '70577', 218, 22, 42657, 30.546, 0.533128273314188, -91.9641, -1.60507633863332),
(30921, '70578', 218, 22, 42748, 30.2355, 0.527709025986746, -92.268, -1.61038039423013),
(30922, '70580', 218, 22, 42760, 30.6741, 0.535364040085993, -92.4266, -1.61314848642379),
(30923, '70581', 218, 22, 5436, 30.3427, 0.529580018944883, -92.7355, -1.6185398084832),
(30924, '70582', 218, 22, 42940, 30.1415, 0.526068416489871, -91.8253, -1.60265382163155),
(30925, '70583', 218, 22, 11829, 30.2473, 0.527914974838481, -92.1023, -1.60748838365957),
(30926, '70584', 218, 22, 12218, 30.3943, 0.530480608838913, -92.0811, -1.60711837385815),
(30927, '70585', 218, 22, 12409, 30.678, 0.53543210792682, -92.2775, -1.61054620050907),
(30928, '70586', 218, 22, 43498, 30.6912, 0.535662491388084, -92.2807, -1.61060205104513),
(30929, '70589', 218, 22, 12671, 30.6141, 0.534316842534796, -92.059, -1.60673265609346),
(30930, '70591', 218, 22, 12733, 30.2354, 0.527707280657494, -92.8201, -1.62001635703039),
(30931, '70592', 218, 22, 70438, 30.1026, 0.525389483410845, -92.0021, -1.60573956374908),
(30932, '70593', 218, 22, 3594, 30.2151, 0.527352978819339, -92.0297, -1.60622127462263),
(30933, '70596', 218, 22, 3594, 30.2241, 0.527510058452018, -92.0201, -1.60605372301443),
(30934, '70598', 218, 22, 3594, 30.1767, 0.526682772386573, -92.0078, -1.60583904751644),
(30935, '70601', 218, 22, 41673, 30.2269, 0.527558927671074, -93.1961, -1.62657879501789),
(30936, '70602', 218, 22, 41673, 30.2266, 0.527553691683318, -93.2132, -1.62687724631998),
(30937, '70605', 218, 22, 41673, 30.1763, 0.526675791069565, -93.2307, -1.62718267893908),
(30938, '70606', 218, 22, 41673, 30.1665, 0.526504748802869, -93.2324, -1.62721234953636),
(30939, '70607', 218, 22, 41673, 30.0898, 0.52516608126659, -93.1758, -1.62622449317973),
(30940, '70609', 218, 22, 41673, 30.1815, 0.526766548190669, -93.2169, -1.6269418235023),
(30941, '70611', 218, 22, 41673, 30.3313, 0.529381051410156, -93.2241, -1.62706748720845),
(30942, '70612', 218, 22, 41673, 30.2375, 0.527743932571785, -93.1817, -1.6263274676056),
(30943, '70615', 218, 22, 41673, 30.2304, 0.527620014194894, -93.1662, -1.62605694157154),
(30944, '70616', 218, 22, 41673, 30.2263, 0.527548455695562, -93.2137, -1.62688597296624),
(30945, '70629', 218, 22, 41673, 30.2267, 0.52755543701257, -93.214, -1.62689120895399),
(30946, '70630', 218, 22, 7378, 30.0977, 0.525303962277497, -93.0131, -1.62338484248674),
(30947, '70631', 218, 22, 806, 29.8236, 0.520520014797781, -93.3976, -1.63009563346066),
(30948, '70632', 218, 22, 39938, 29.7894, 0.519923112193599, -93.0237, -1.62356984738745),
(30949, '70633', 218, 22, 40026, 30.4468, 0.53139690669621, -93.4315, -1.63068730007708),
(30950, '70634', 218, 22, 40027, 30.8496, 0.538427092923243, -93.2912, -1.62823860313653),
(30951, '70637', 218, 22, 35637, 30.7806, 0.537222815739367, -92.9544, -1.62236033421582),
(30952, '70638', 218, 22, 8719, 30.8971, 0.53925612431794, -92.7882, -1.619459596999),
(30953, '70639', 218, 22, 15, 30.9981, 0.541018906862454, -93.4478, -1.63097178874516),
(30954, '70640', 218, 22, 2431, 30.3634, 0.529941302100046, -92.9172, -1.62171107173408),
(30955, '70642', 218, 22, 2627, 30.9933, 0.540935131058359, -92.9815, -1.62283331844311),
(30956, '70643', 218, 22, 41151, 29.7946, 0.520013869314703, -92.782, -1.61935138658538),
(30957, '70644', 218, 22, 104, 30.6767, 0.535409418646544, -92.9343, -1.62200952303617),
(30958, '70645', 218, 22, 41234, 29.9852, 0.523340466869004, -93.3708, -1.62962788522112),
(30959, '70646', 218, 22, 3020, 30.1372, 0.525993367332035, -92.9288, -1.62191352992731),
(30960, '70647', 218, 22, 41491, 30.2356, 0.527710771315998, -93.0132, -1.62338658781599),
(30961, '70648', 218, 22, 30244, 30.4858, 0.532077585104487, -92.8481, -1.62050504922095),
(30962, '70650', 218, 22, 41654, 30.1031, 0.525398210057105, -92.8983, -1.62138120450545),
(30963, '70651', 218, 22, 41748, 30.51, 0.53249995478347, -92.9419, -1.62214216805932),
(30964, '70652', 218, 22, 41862, 30.5921, 0.533932870099357, -93.2689, -1.62784939471334),
(30965, '70653', 218, 22, 42072, 30.7093, 0.535978395982695, -93.5505, -1.63276424188696),
(30966, '70654', 218, 22, 42128, 30.6769, 0.535412909305048, -92.9344, -1.62201126836542),
(30967, '70655', 218, 22, 42414, 30.6191, 0.534404108997396, -92.7612, -1.61898835810096),
(30968, '70656', 218, 22, 42595, 30.94, 0.540004870567046, -92.7751, -1.61923095886699),
(30969, '70657', 218, 22, 42730, 30.4349, 0.531189212515222, -93.1149, -1.62516158766527),
(30970, '70658', 218, 22, 11533, 30.4343, 0.53117874053971, -93.1175, -1.62520696622582),
(30971, '70659', 218, 22, 42873, 30.9191, 0.539640096753379, -93.2828, -1.62809199547937),
(30972, '70660', 218, 22, 43086, 30.5397, 0.533018317571312, -93.5153, -1.63214988599025),
(30973, '70661', 218, 22, 12113, 30.3208, 0.529197791838697, -93.6274, -1.63410640008174),
(30974, '70662', 218, 22, 25210, 30.8336, 0.538147840242924, -93.0195, -1.62349654355887),
(30975, '70663', 218, 22, 65, 30.2298, 0.527609542219382, -93.3588, -1.62941844571088),
(30976, '70664', 218, 22, 65, 30.2642, 0.528209935482068, -93.3732, -1.62966977312317),
(30977, '70665', 218, 22, 65, 30.236, 0.527717752633005, -93.3769, -1.62973435030549),
(30978, '70668', 218, 22, 34282, 30.1905, 0.526923627823348, -93.5847, -1.63336114449114),
(30979, '70669', 218, 22, 637, 30.2574, 0.528091253092932, -93.2635, -1.62775514693373),
(30980, '70704', 218, 22, 7221, 30.5854, 0.533815933039474, -91.1566, -1.59098280492346),
(30981, '70706', 218, 22, 40051, 30.6099, 0.534243538706212, -90.9184, -1.58682543064521),
(30982, '70707', 218, 22, 41120, 30.2309, 0.527628740841154, -90.9069, -1.58662471778123),
(30983, '70710', 218, 22, 39039, 30.3556, 0.529805166418391, -91.2648, -1.59287125117412),
(30984, '70711', 218, 22, 18772, 30.5191, 0.532658779745401, -90.5893, -1.5810815520769),
(30985, '70712', 218, 22, 31649, 30.9954, 0.54097178297265, -91.5424, -1.59771628517766),
(30986, '70714', 218, 22, 7221, 30.5842, 0.53379498908845, -91.1388, -1.59067213631661),
(30987, '70715', 218, 22, 39242, 30.8029, 0.537612024162561, -91.6674, -1.59989794674265),
(30988, '70716', 218, 22, 39263, 30.2101, 0.527265712356739, -91.1687, -1.59119398976295),
(30989, '70717', 218, 22, 39405, 30.5768, 0.533665834723802, -91.6029, -1.59877220937511),
(30990, '70718', 218, 22, 39505, 30.2093, 0.527251749722723, -90.8923, -1.58636989971044),
(30991, '70719', 218, 22, 39556, 30.3868, 0.530349709145013, -91.2546, -1.59269322759042),
(30992, '70720', 218, 22, 39565, 30.5849, 0.533807206393214, -91.3369, -1.59412963356481),
(30993, '70721', 218, 22, 39672, 30.2151, 0.527352978819339, -91.1138, -1.59023580400361),
(30994, '70722', 218, 22, 1630, 30.7118, 0.536022029213995, -90.9, -1.58650429006285),
(30995, '70723', 218, 22, 39873, 30.0283, 0.524092703776613, -90.842, -1.58549199909669),
(30996, '70725', 218, 22, 40002, 30.1317, 0.525897374223175, -90.9666, -1.58766667934467),
(30997, '70726', 218, 22, 40051, 30.4935, 0.532211975456891, -90.9231, -1.58690746112006),
(30998, '70727', 218, 22, 40051, 30.4499, 0.531451011903021, -90.9697, -1.58772078455149),
(30999, '70728', 218, 22, 40723, 30.2697, 0.528305928590928, -90.9445, -1.58728096157998),
(31000, '70729', 218, 22, 40832, 30.5346, 0.532929305779461, -91.3997, -1.59522570033506),
(31001, '70730', 218, 22, 8784, 30.8144, 0.537812737026541, -91.1155, -1.59026547460089),
(31002, '70732', 218, 22, 40942, 30.6068, 0.5341894334994, -91.7029, -1.60051753862711),
(31003, '70733', 218, 22, 41003, 30.3128, 0.529058165498537, -90.7996, -1.58475197949384),
(31004, '70734', 218, 22, 41061, 30.2429, 0.527838180351393, -90.9907, -1.5880873036944),
(31005, '70736', 218, 22, 41106, 30.6363, 0.534704305628739, -91.3362, -1.59411741626004),
(31006, '70737', 218, 22, 41120, 30.2451, 0.527876577594937, -90.9169, -1.58679925070643),
(31007, '70738', 218, 22, 19652, 30.1386, 0.526017801941563, -90.9236, -1.58691618776632),
(31008, '70739', 218, 22, 41197, 30.5398, 0.533020062900564, -91.0019, -1.58828278057063),
(31009, '70740', 218, 22, 41216, 30.4112, 0.5307755694825, -91.431, -1.59577198839094),
(31010, '70743', 218, 22, 41313, 30.0196, 0.52394086013169, -90.7727, -1.58428248592506),
(31011, '70744', 218, 22, 27452, 30.5085, 0.53247377484469, -90.6562, -1.58224917734648),
(31012, '70747', 218, 22, 41484, 30.8777, 0.538917530443053, -91.6809, -1.60013356619167),
(31013, '70748', 218, 22, 3384, 30.778, 0.537177437178815, -91.2102, -1.59191830140253),
(31014, '70749', 218, 22, 41517, 30.6282, 0.534562933959327, -91.4326, -1.59579991365897),
(31015, '70750', 218, 22, 41640, 30.5426, 0.53306893211962, -91.759, -1.60149666833748),
(31016, '70751', 218, 22, 41652, 30.716, 0.536095333042578, -91.5552, -1.59793968732191),
(31017, '70752', 218, 22, 16822, 30.5737, 0.53361172951699, -91.4272, -1.59570566587936),
(31018, '70753', 218, 22, 41779, 30.9389, 0.539985671945274, -91.7317, -1.60102019345168),
(31019, '70754', 218, 22, 3825, 30.4446, 0.531358509452666, -90.7583, -1.58403115851277),
(31020, '70755', 218, 22, 30358, 30.5711, 0.533566350956438, -91.545, -1.59776166373821),
(31021, '70756', 218, 22, 3873, 30.5216, 0.532702412976701, -91.6869, -1.60023828594679),
(31022, '70757', 218, 22, 41982, 30.4908, 0.532164851567087, -91.5181, -1.59729217016942),
(31023, '70759', 218, 22, 42170, 30.6905, 0.53565027408332, -91.613, -1.59894848762957),
(31024, '70760', 218, 22, 42271, 30.6991, 0.535800372398991, -91.4362, -1.59586274551204),
(31025, '70761', 218, 22, 4648, 30.9318, 0.539861753568382, -91.0345, -1.58885175790678),
(31026, '70762', 218, 22, 37551, 30.6147, 0.534327314510308, -91.4635, -1.59633922039783),
(31027, '70763', 218, 22, 42514, 30.0351, 0.524211386165749, -90.7355, -1.58363322344331),
(31028, '70764', 218, 22, 42608, 30.2817, 0.528515368101167, -91.2405, -1.59244713616589),
(31029, '70765', 218, 22, 42608, 30.2888, 0.528639286478058, -91.2338, -1.592330199106),
(31030, '70767', 218, 22, 42655, 30.4781, 0.531943194752084, -91.276, -1.59306672805034),
(31031, '70769', 218, 22, 5213, 30.3112, 0.529030240230505, -90.9356, -1.58712562727656),
(31032, '70770', 218, 22, 37807, 30.6215, 0.534445996899444, -90.9983, -1.58821994871756),
(31033, '70772', 218, 22, 5546, 30.4108, 0.530768588165492, -91.4314, -1.59577896970794),
(31034, '70773', 218, 22, 42878, 30.598, 0.534035844525225, -91.3732, -1.59476318808328),
(31035, '70774', 218, 22, 42905, 30.2355, 0.527709025986746, -90.8457, -1.58555657627901),
(31036, '70775', 218, 22, 28499, 30.8598, 0.538605116506946, -91.3336, -1.59407203769949),
(31037, '70776', 218, 22, 42920, 30.2814, 0.528510132113411, -91.0941, -1.58989197414097),
(31038, '70777', 218, 22, 14635, 30.6859, 0.535569988937728, -91.114, -1.59023929466211),
(31039, '70778', 218, 22, 18119, 30.182, 0.526775274836929, -90.8638, -1.58587248087362),
(31040, '70780', 218, 22, 6179, 30.3093, 0.528997078974717, -91.1814, -1.59141564657796),
(31041, '70781', 218, 22, 43371, 30.5249, 0.532760008842017, -91.4418, -1.59596048395015),
(31042, '70782', 218, 22, 43402, 30.9297, 0.53982510165409, -91.5545, -1.59792747001715),
(31043, '70783', 218, 22, 43467, 30.6867, 0.535583951571744, -91.3873, -1.59500927950781),
(31044, '70784', 218, 22, 831, 30.8894, 0.539121733965536, -91.3497, -1.59435303570906),
(31045, '70785', 218, 22, 12598, 30.5198, 0.532670997050165, -90.8517, -1.58566129603413),
(31046, '70786', 218, 22, 6657, 30.5864, 0.533833386331994, -90.9417, -1.58723209236093),
(31047, '70787', 218, 22, 44110, 30.9657, 0.540453420184808, -91.471, -1.59647012009173),
(31048, '70788', 218, 22, 44117, 30.1672, 0.526516966107633, -91.1468, -1.59081176265677),
(31049, '70789', 218, 22, 565, 30.9486, 0.540154968882717, -91.055, -1.58920955040344),
(31050, '70791', 218, 22, 44247, 30.6553, 0.535035918186618, -91.1347, -1.59060057781728),
(31051, '70792', 218, 22, 0, 30.025, 0.524035107911297, -90.7778, -1.58437149771691),
(31052, '70801', 218, 22, 39245, 30.4482, 0.531421341305737, -91.1855, -1.59148720507729),
(31053, '70802', 218, 22, 39245, 30.4477, 0.531412614659478, -91.1681, -1.59118351778744),
(31054, '70803', 218, 22, 39245, 30.4059, 0.530683067032144, -91.1904, -1.59157272621064),
(31055, '70804', 218, 22, 39245, 30.4494, 0.531442285256761, -91.1737, -1.59128125622555),
(31056, '70805', 218, 22, 39245, 30.4869, 0.532096783726259, -91.1505, -1.59087633983909),
(31057, '70806', 218, 22, 39245, 30.4469, 0.531398652025462, -91.1299, -1.59051680201318),
(31058, '70807', 218, 22, 39245, 30.5348, 0.532932796437965, -91.1758, -1.59131790813985),
(31059, '70808', 218, 22, 39245, 30.408, 0.530719718946436, -91.1413, -1.59071576954791),
(31060, '70809', 218, 22, 39245, 30.4082, 0.53072320960494, -91.0839, -1.58971395055726),
(31061, '70810', 218, 22, 39245, 30.3661, 0.52998842598985, -91.0928, -1.58986928486069),
(31062, '70811', 218, 22, 39245, 30.5328, 0.532897889852925, -91.1248, -1.59042779022133),
(31063, '70812', 218, 22, 39245, 30.5042, 0.532398725686854, -91.1182, -1.5903125984907),
(31064, '70813', 218, 22, 39245, 30.4271, 0.531053076833567, -91.1095, -1.59016075484577),
(31065, '70814', 218, 22, 39245, 30.4855, 0.532072349116731, -91.0685, -1.58944516985246),
(31066, '70815', 218, 22, 39245, 30.4511, 0.531471955854045, -91.0609, -1.5893125248293),
(31067, '70816', 218, 22, 39245, 30.4273, 0.531056567492071, -91.035, -1.58886048455304),
(31068, '70817', 218, 22, 39245, 30.386, 0.530335746510997, -90.9974, -1.58820424075429),
(31069, '70818', 218, 22, 39245, 30.543, 0.533075913436628, -91.0469, -1.58906817873403),
(31070, '70819', 218, 22, 39245, 30.4667, 0.531744227217356, -91.0131, -1.58847825744685),
(31071, '70820', 218, 22, 39245, 30.3753, 0.530148996281034, -91.1677, -1.59117653647043),
(31072, '70821', 218, 22, 39245, 30.4586, 0.531602855547945, -91.1237, -1.59040859159956),
(31073, '70822', 218, 22, 39245, 30.4528, 0.531501626451329, -91.1273, -1.59047142345263),
(31074, '70823', 218, 22, 39245, 30.4457, 0.531377708074438, -91.1882, -1.59153432896709),
(31075, '70825', 218, 22, 39245, 30.4285, 0.531077511443095, -91.0225, -1.58864231839654),
(31076, '70826', 218, 22, 39245, 30.3983, 0.530550422008992, -91.0773, -1.58959875882663),
(31077, '70827', 218, 22, 39245, 30.4331, 0.531157796588686, -91.0822, -1.58968427995998),
(31078, '70831', 218, 22, 39245, 30.45, 0.531452757232273, -91.1883, -1.59153607429635),
(31079, '70833', 218, 22, 39245, 30.4059, 0.530683067032144, -91.1421, -1.59072973218192),
(31080, '70835', 218, 22, 39245, 30.4284, 0.531075766113843, -91.022, -1.58863359175028),
(31081, '70836', 218, 22, 39245, 30.4492, 0.531438794598257, -91.1823, -1.59143135454123),
(31082, '70837', 218, 22, 39245, 30.5489, 0.533178887862496, -91.2068, -1.59185896020796),
(31083, '70874', 218, 22, 39245, 30.5311, 0.532868219255641, -91.1168, -1.59028816388117),
(31084, '70879', 218, 22, 39245, 30.3741, 0.53012805233001, -90.9821, -1.58793720537873),
(31085, '70883', 218, 22, 39245, 30.4505, 0.531461483878533, -91.1357, -1.5906180311098),
(31086, '70884', 218, 22, 39245, 30.379, 0.530213573463357, -91.0977, -1.58995480599404),
(31087, '70892', 218, 22, 39245, 30.4486, 0.531428322622745, -91.1578, -1.59100374887449),
(31088, '70893', 218, 22, 39245, 30.4143, 0.530829674689311, -91.1728, -1.59126554826229),
(31089, '70894', 218, 22, 39245, 30.4133, 0.530812221396791, -91.1793, -1.59137899466367),
(31090, '70895', 218, 22, 39245, 30.4529, 0.531503371780581, -91.0767, -1.58958828685112),
(31091, '70896', 218, 22, 39245, 30.3672, 0.530007624611622, -91.0382, -1.5889163350891),
(31092, '70898', 218, 22, 39245, 30.4207, 0.530941375761439, -91.1394, -1.59068260829212),
(31093, '71001', 218, 22, 7137, 32.5522, 0.568143068767698, -92.9257, -1.62185942472049),
(31094, '71002', 218, 22, 13301, 32.1159, 0.560528197241247, -93.1141, -1.62514762503125),
(31095, '71003', 218, 22, 7182, 32.7816, 0.572146854071773, -92.9935, -1.62304275795335),
(31096, '71004', 218, 22, 7373, 32.7569, 0.571715757746531, -93.854, -1.63806131616676),
(31097, '71006', 218, 22, 358, 32.6815, 0.570399779490527, -93.7109, -1.63556375000715),
(31098, '71007', 218, 22, 7428, 32.3651, 0.564877557737217, -94.0186, -1.64093412811554),
(31099, '71008', 218, 22, 39379, 32.3013, 0.563764037674444, -92.9243, -1.62183499011097),
(31100, '71009', 218, 22, 13397, 32.5849, 0.5687137914331, -93.8937, -1.6387542118798),
(31101, '71016', 218, 22, 39684, 32.1873, 0.561774362327171, -93.1307, -1.62543734968708),
(31102, '71018', 218, 22, 1796, 32.8384, 0.573138201086906, -93.4547, -1.63109221646354),
(31103, '71019', 218, 22, 39930, 32.0203, 0.55885966247634, -93.3316, -1.62894371615434),
(31104, '71021', 218, 22, 35464, 32.9678, 0.575396657138986, -93.4477, -1.63097004341591),
(31105, '71023', 218, 22, 40696, 32.5283, 0.567725935076472, -93.4105, -1.63032078093416),
(31106, '71024', 218, 22, 40704, 32.4881, 0.56702431271717, -93.1987, -1.62662417357844),
(31107, '71025', 218, 22, 2180, 32.1656, 0.561395625879488, -93.4307, -1.63067333744307),
(31108, '71027', 218, 22, 41009, 32.232, 0.562554524502812, -93.6764, -1.63496161141522),
(31109, '71028', 218, 22, 41076, 32.4933, 0.567115069838273, -93.0643, -1.62427845106376),
(31110, '71029', 218, 22, 41083, 32.806, 0.57257271440926, -93.8303, -1.63764767313404),
(31111, '71030', 218, 22, 21443, 32.2005, 0.562004745788434, -93.8462, -1.6379251804851),
(31112, '71031', 218, 22, 41116, 31.9926, 0.558376206273538, -92.9786, -1.6227827038948),
(31113, '71032', 218, 22, 41150, 32.1166, 0.560540414546011, -93.8496, -1.63798452167967),
(31114, '71033', 218, 22, 2869, 32.4385, 0.566158629408181, -93.9849, -1.64034595215762),
(31115, '71034', 218, 22, 41246, 32.1764, 0.561584121438704, -93.3051, -1.62848120390256),
(31116, '71036', 218, 22, 234, 32.0654, 0.55964680596899, -93.4298, -1.6306576294798),
(31117, '71037', 218, 22, 41282, 32.5392, 0.567916175964939, -93.5497, -1.63275027925294),
(31118, '71038', 218, 22, 36329, 32.959, 0.575243068164811, -93.1358, -1.62552636147893),
(31119, '71039', 218, 22, 3050, 32.4421, 0.566221461261253, -93.2946, -1.6282979443311),
(31120, '71040', 218, 22, 22029, 32.789, 0.572276008436421, -93.0606, -1.62421387388143),
(31121, '71043', 218, 22, 41412, 32.8971, 0.574162709357827, -93.8853, -1.63860760422263),
(31122, '71044', 218, 22, 9638, 32.9939, 0.575852188073757, -93.9023, -1.63890431019547),
(31123, '71045', 218, 22, 3399, 32.3775, 0.565093978564464, -93.1832, -1.62635364754438),
(31124, '71046', 218, 22, 41570, 32.2159, 0.562273526493241, -93.996, -1.64053968370459),
(31125, '71047', 218, 22, 41573, 32.3151, 0.56400489311122, -93.8958, -1.63879086379409),
(31126, '71048', 218, 22, 10116, 32.8402, 0.573169617013442, -92.8589, -1.62069354478016),
(31127, '71049', 218, 22, 36951, 32.0153, 0.558772396013741, -93.9333, -1.63944536226359),
(31128, '71050', 218, 22, 22736, 32.0968, 0.560194839354116, -93.9496, -1.63972985093166),
(31129, '71051', 218, 22, 8738, 32.3626, 0.564833924505917, -93.4961, -1.63181478277387),
(31130, '71052', 218, 22, 3975, 32.0347, 0.559110989888628, -93.7006, -1.6353839810942),
(31131, '71055', 218, 22, 42112, 32.6172, 0.569277532781494, -93.2826, -1.62808850482086),
(31132, '71058', 218, 22, 42112, 32.6127, 0.569198992965155, -93.2945, -1.62829619900185),
(31133, '71060', 218, 22, 42155, 32.6583, 0.569994863104064, -93.9783, -1.64023076042699),
(31134, '71061', 218, 22, 37496, 32.7497, 0.571590094040387, -93.9793, -1.64024821371951),
(31135, '71063', 218, 22, 42533, 31.8907, 0.556597715765756, -93.5567, -1.63287245230058),
(31136, '71064', 218, 22, 42599, 32.9074, 0.574342478270782, -93.7002, -1.63537699977719),
(31137, '71065', 218, 22, 268, 31.819, 0.555346314692076, -93.5148, -1.63214115934399),
(31138, '71066', 218, 22, 5207, 31.8426, 0.555758212395546, -93.1692, -1.6261093014491),
(31139, '71067', 218, 22, 5231, 32.5727, 0.568500861264357, -93.5542, -1.63282881906928),
(31140, '71068', 218, 22, 5403, 32.3179, 0.564053762330275, -93.3, -1.62839219211071),
(31141, '71069', 218, 22, 42854, 32.9772, 0.575560718088674, -94.0046, -1.64068978202026),
(31142, '71070', 218, 22, 11776, 32.1412, 0.560969765542001, -92.9409, -1.6221247147668),
(31143, '71071', 218, 22, 42977, 32.9395, 0.574902728960672, -93.4348, -1.6307448959424),
(31144, '71072', 218, 22, 43061, 32.9594, 0.575250049481819, -93.2833, -1.62810072212563),
(31145, '71073', 218, 22, 24860, 32.5485, 0.568078491585374, -93.2926, -1.62826303774606),
(31146, '71075', 218, 22, 6032, 33.0009, 0.575974361121397, -93.4607, -1.63119693621866),
(31147, '71078', 218, 22, 6104, 32.3157, 0.564015365086732, -93.7781, -1.63673661126449),
(31148, '71079', 218, 22, 6148, 32.9354, 0.57483117046134, -92.8059, -1.61976852027661),
(31149, '71080', 218, 22, 6252, 32.5002, 0.567235497556661, -93.074, -1.6244477480012),
(31150, '71082', 218, 22, 43505, 32.8633, 0.573572788070653, -93.9854, -1.64035467880388),
(31151, '71101', 218, 22, 43063, 32.5058, 0.567333235994773, -93.7485, -1.6362199938059),
(31152, '71102', 218, 22, 43063, 32.4906, 0.56706794594847, -93.7694, -1.63658476761957),
(31153, '71103', 218, 22, 43063, 32.4921, 0.56709412588725, -93.773, -1.63664759947264),
(31154, '71104', 218, 22, 43063, 32.4845, 0.566961480864098, -93.7321, -1.63593375980858),
(31155, '71105', 218, 22, 43063, 32.4548, 0.566443118076256, -93.7126, -1.63559342060444),
(31156, '71106', 218, 22, 43063, 32.4236, 0.565898575349633, -93.7421, -1.63610829273378),
(31157, '71107', 218, 22, 43063, 32.5684, 0.568425812106521, -93.8378, -1.63777857282794),
(31158, '71108', 218, 22, 43063, 32.443, 0.56623716922452, -93.7882, -1.63691288951895),
(31159, '71109', 218, 22, 43063, 32.4741, 0.566779966621891, -93.8122, -1.63733176853942),
(31160, '71110', 218, 22, 0, 32.5033, 0.567289602763473, -93.6658, -1.6347766065145),
(31161, '71111', 218, 22, 39456, 32.5463, 0.568040094341831, -93.7063, -1.63548346486156),
(31162, '71112', 218, 22, 39456, 32.4865, 0.566996387449138, -93.673, -1.63490227022065),
(31163, '71113', 218, 22, 39456, 32.4931, 0.56711157917977, -93.6861, -1.63513090835266),
(31164, '71115', 218, 22, 43063, 32.3844, 0.565214406282852, -93.669, -1.63483245705057),
(31165, '71118', 218, 22, 43063, 32.396, 0.565416864476083, -93.8039, -1.63718690621151),
(31166, '71119', 218, 22, 43063, 32.4767, 0.566825345182442, -93.8773, -1.63846797788247),
(31167, '71120', 218, 22, 43063, 32.5064, 0.567343707970285, -93.7425, -1.63611527405078),
(31168, '71129', 218, 22, 43063, 32.4251, 0.565924755288413, -93.8973, -1.63881704373287),
(31169, '71130', 218, 22, 43063, 32.4907, 0.567069691277722, -93.7693, -1.63658302229032),
(31170, '71133', 218, 22, 43063, 32.4909, 0.567073181936226, -93.7696, -1.63658825827807),
(31171, '71134', 218, 22, 43063, 32.4814, 0.566907375657286, -93.7369, -1.63601753561267),
(31172, '71135', 218, 22, 43063, 32.4434, 0.566244150541528, -93.7096, -1.63554106072688),
(31173, '71136', 218, 22, 43063, 32.4225, 0.565879376727861, -93.7592, -1.63640674403587),
(31174, '71137', 218, 22, 43063, 32.5947, 0.568884833699796, -93.8544, -1.63806829748377),
(31175, '71138', 218, 22, 43063, 32.4077, 0.565621067998566, -93.7976, -1.63707695046863),
(31176, '71148', 218, 22, 43063, 32.4565, 0.56647278867354, -93.7774, -1.63672439395973),
(31177, '71149', 218, 22, 43063, 32.506, 0.567336726653277, -93.7437, -1.63613621800181),
(31178, '71151', 218, 22, 43063, 32.5053, 0.567324509348513, -93.7421, -1.63610829273378),
(31179, '71152', 218, 22, 43063, 32.4414, 0.566209243956488, -93.7897, -1.63693906945773),
(31180, '71153', 218, 22, 43063, 32.5126, 0.567451918383908, -93.7498, -1.63624268308618),
(31181, '71154', 218, 22, 43063, 32.491, 0.567074927265478, -93.7689, -1.63657604097331),
(31182, '71156', 218, 22, 43063, 32.5147, 0.5674885702982, -93.7502, -1.63624966440319),
(31183, '71161', 218, 22, 43063, 32.5008, 0.567245969532173, -93.754, -1.63631598691476),
(31184, '71162', 218, 22, 43063, 32.5055, 0.567328000007017, -93.7433, -1.6361292366848),
(31185, '71163', 218, 22, 43063, 32.5052, 0.567322764019261, -93.743, -1.63612400069704),
(31186, '71164', 218, 22, 43063, 32.5061, 0.567338471982529, -93.7442, -1.63614494464807),
(31187, '71165', 218, 22, 43063, 32.5034, 0.567291348092725, -93.7449, -1.63615716195283),
(31188, '71166', 218, 22, 43063, 32.5057, 0.567331490665521, -93.744, -1.63614145398956),
(31189, '71171', 218, 22, 39456, 32.5157, 0.56750602359072, -93.7323, -1.63593725046708),
(31190, '71172', 218, 22, 39456, 32.5318, 0.567787021600291, -93.6534, -1.63456018568726),
(31191, '71201', 218, 22, 10560, 32.5213, 0.567603762028832, -92.1036, -1.60751107293985),
(31192, '71202', 218, 22, 10560, 32.4669, 0.566654302915747, -92.0851, -1.60718818702823),
(31193, '71203', 218, 22, 10560, 32.5483, 0.56807500092687, -92.0449, -1.60648656466893),
(31194, '71207', 218, 22, 10560, 32.5151, 0.567495551615208, -92.1162, -1.6077309844256),
(31195, '71208', 218, 22, 10560, 32.5256, 0.567678811186668, -92.0814, -1.60712360984591),
(31196, '71209', 218, 22, 10560, 32.53, 0.567755605673755, -92.0747, -1.60700667278602),
(31197, '71210', 218, 22, 10560, 32.5061, 0.567338471982529, -92.1022, -1.60748663833032),
(31198, '71211', 218, 22, 10560, 32.6979, 0.570686013487854, -92.0747, -1.60700667278602),
(31199, '71212', 218, 22, 10560, 32.5092, 0.567392577189341, -92.1189, -1.6077781083154),
(31200, '71213', 218, 22, 10560, 32.5118, 0.567437955749892, -92.0851, -1.60718818702823),
(31201, '71218', 218, 22, 39129, 32.3488, 0.564593069069142, -91.7775, -1.6018195542491),
(31202, '71219', 218, 22, 15105, 32.3171, 0.56403979969626, -91.6894, -1.60028191917809),
(31203, '71220', 218, 22, 39240, 32.7782, 0.572087512877205, -91.9127, -1.60417923939779),
(31204, '71221', 218, 22, 39240, 32.756, 0.571700049783263, -91.8724, -1.60347587170924),
(31205, '71222', 218, 22, 7420, 32.8204, 0.572824041821547, -92.6584, -1.61719415962991),
(31206, '71223', 218, 22, 1041, 32.9019, 0.574246485161922, -91.6787, -1.60009516894813),
(31207, '71225', 218, 22, 1294, 32.5291, 0.567739897710488, -92.3126, -1.61115881107652),
(31208, '71226', 218, 22, 13522, 32.2393, 0.562681933538208, -92.4158, -1.61295999086458),
(31209, '71227', 218, 22, 39779, 32.54, 0.567930138598955, -92.3912, -1.61253063986859),
(31210, '71229', 218, 22, 39850, 32.6863, 0.570483555294623, -91.8171, -1.60251070463289),
(31211, '71230', 218, 22, 20396, 32.1435, 0.561009908114797, -91.7022, -1.60050532132234),
(31212, '71232', 218, 22, 20537, 32.4556, 0.566457080710272, -91.4906, -1.59681220462512),
(31213, '71233', 218, 22, 2022, 32.3235, 0.564151500768387, -90.9237, -1.58691793309557),
(31214, '71234', 218, 22, 40694, 32.5704, 0.568460718691561, -92.3686, -1.61213619545763),
(31215, '71235', 218, 22, 40708, 32.6984, 0.570694740134114, -92.6978, -1.6178818193552),
(31216, '71237', 218, 22, 40827, 32.6021, 0.569013988064443, -91.4843, -1.59670224888225),
(31217, '71238', 218, 22, 8777, 32.4102, 0.565664701229866, -92.3286, -1.61143806375684),
(31218, '71240', 218, 22, 8817, 32.6439, 0.569743535691777, -92.0363, -1.60633646635326),
(31219, '71241', 218, 22, 40880, 32.7744, 0.57202119036563, -92.4014, -1.61270866345229),
(31220, '71242', 218, 22, 2517, 32.8629, 0.573565806753645, -91.3924, -1.59509829129967),
(31221, '71243', 218, 22, 40971, 32.0377, 0.559163349766187, -91.8276, -1.60269396420435),
(31222, '71245', 218, 22, 41142, 32.5235, 0.567642159272376, -92.7139, -1.61816281736477),
(31223, '71247', 218, 22, 3177, 32.277, 0.56333992266621, -92.7129, -1.61814536407225),
(31224, '71249', 218, 22, 41538, 32.035, 0.559116225876383, -91.7473, -1.60129246481499),
(31225, '71250', 218, 22, 3445, 32.9417, 0.574941126204216, -91.554, -1.59791874337089),
(31226, '71251', 218, 22, 3452, 32.2419, 0.56272731209876, -92.7107, -1.61810696682871),
(31227, '71253', 218, 22, 41600, 32.8701, 0.573691470459788, -91.4282, -1.59572311917188),
(31228, '71254', 218, 22, 41682, 32.8041, 0.572539553153472, -91.1781, -1.59135805071264),
(31229, '71256', 218, 22, 41798, 32.9279, 0.574700270767441, -92.6888, -1.61772473972252),
(31230, '71259', 218, 22, 41961, 32.2978, 0.563702951150625, -91.8307, -1.60274806941116),
(31231, '71260', 218, 22, 630, 32.9051, 0.574302335697986, -92.2428, -1.60994057125863),
(31232, '71261', 218, 22, 42066, 32.7676, 0.571902507976494, -91.749, -1.60132213541228),
(31233, '71263', 218, 22, 4662, 32.8643, 0.573590241363172, -91.3887, -1.59503371411734),
(31234, '71264', 218, 22, 4694, 32.6493, 0.569837783471385, -91.746, -1.60126977553472),
(31235, '71266', 218, 22, 42592, 32.7127, 0.570944322217149, -91.4824, -1.59666908762646),
(31236, '71268', 218, 22, 11443, 32.365, 0.564875812407965, -92.651, -1.61706500526527),
(31237, '71269', 218, 22, 42749, 32.4747, 0.566790438597403, -91.7569, -1.60146001642318),
(31238, '71270', 218, 22, 42898, 32.5318, 0.567787021600291, -92.6392, -1.61685905641353),
(31239, '71272', 218, 22, 42898, 32.5291, 0.567739897710488, -92.6496, -1.61704057065574),
(31240, '71273', 218, 22, 42898, 32.557, 0.568226844571794, -92.5906, -1.61601082639706),
(31241, '71275', 218, 22, 11961, 32.5308, 0.567769568307771, -92.7857, -1.6194159637677),
(31242, '71276', 218, 22, 43116, 32.5778, 0.568589873056209, -91.2524, -1.59265483034687),
(31243, '71277', 218, 22, 31169, 32.8967, 0.574155728040819, -92.6071, -1.61629880572364),
(31244, '71279', 218, 22, 43206, 32.486, 0.566987660802878, -91.8597, -1.60325421489424),
(31245, '71280', 218, 22, 43217, 32.6947, 0.57063016295179, -92.0708, -1.6069386049452),
(31246, '71281', 218, 22, 43268, 32.5984, 0.568949410882119, -92.0179, -1.60601532577089),
(31247, '71282', 218, 22, 43287, 32.4095, 0.565652483925102, -91.1892, -1.59155178225961),
(31248, '71284', 218, 22, 43287, 32.4074, 0.56561583201081, -91.1893, -1.59155352758887),
(31249, '71286', 218, 22, 43382, 32.6676, 0.5701571787245, -91.2528, -1.59266181166388),
(31250, '71291', 218, 22, 44080, 32.5012, 0.567252950849181, -92.1906, -1.60902950938908),
(31251, '71292', 218, 22, 44080, 32.4468, 0.566303491736096, -92.2058, -1.60929479943539),
(31252, '71294', 218, 22, 44080, 32.5111, 0.567425738445128, -92.1817, -1.60887417508566),
(31253, '71295', 218, 22, 44187, 32.1615, 0.561324067380156, -91.7235, -1.60087707645302),
(31254, '71301', 218, 22, 34524, 31.2927, 0.54616064683883, -92.4612, -1.61375237034498),
(31255, '71302', 218, 22, 34524, 31.2654, 0.545684171953035, -92.4137, -1.61292333895028),
(31256, '71303', 218, 22, 34524, 31.3004, 0.546295037191233, -92.5046, -1.61450984324035),
(31257, '71306', 218, 22, 34524, 31.1957, 0.544467677464395, -92.6737, -1.61746119500547),
(31258, '71307', 218, 22, 34524, 31.2856, 0.546036728461938, -92.4507, -1.61356911077352),
(31259, '71309', 218, 22, 34524, 31.2538, 0.545481713759804, -92.4729, -1.61395657386746),
(31260, '71315', 218, 22, 34524, 31.2544, 0.545492185735316, -92.4724, -1.6139478472212),
(31261, '71316', 218, 22, 726, 31.2599, 0.545588178844175, -91.7674, -1.60164327599464),
(31262, '71320', 218, 22, 39450, 31.1053, 0.542889899820592, -91.9074, -1.60408673694744),
(31263, '71322', 218, 22, 39576, 30.9535, 0.540240490016065, -92.1857, -1.60894398825574),
(31264, '71323', 218, 22, 655, 31.2545, 0.545493931064568, -92.2392, -1.60987773940555),
(31265, '71324', 218, 22, 1501, 32.0964, 0.560187858037108, -91.6987, -1.60044423479852),
(31266, '71325', 218, 22, 39756, 31.0173, 0.541354010078837, -92.2918, -1.6107957825921),
(31267, '71326', 218, 22, 608, 31.8172, 0.55531489876554, -91.53, -1.59749986435041),
(31268, '71327', 218, 22, 39909, 30.9907, 0.540889752497807, -92.0536, -1.60663840831385),
(31269, '71328', 218, 22, 40066, 31.36, 0.547335253425422, -92.2062, -1.6093017807524),
(31270, '71329', 218, 22, 13687, 30.9295, 0.539821610995586, -91.9474, -1.60478486864823),
(31271, '71330', 218, 22, 2207, 31.1221, 0.543183115134927, -92.2579, -1.61020411597568),
(31272, '71331', 218, 22, 40775, 31.2534, 0.545474732442796, -92.0897, -1.60726847217382),
(31273, '71333', 218, 22, 2343, 30.9469, 0.540125298285433, -92.0959, -1.60737668258745),
(31274, '71334', 218, 22, 40900, 31.6263, 0.551983065223483, -91.5501, -1.59785067553006),
(31275, '71336', 218, 22, 2713, 32.0078, 0.558641496319841, -91.5676, -1.59815610814916),
(31276, '71339', 218, 22, 2948, 31.0629, 0.542149880217747, -91.9236, -1.60436948028626),
(31277, '71340', 218, 22, 41275, 31.7947, 0.554922199683841, -91.893, -1.60383540953515),
(31278, '71341', 218, 22, 41312, 31.0572, 0.542050396450383, -92.1403, -1.60815160877533),
(31279, '71342', 218, 22, 3415, 31.694, 0.553164653127083, -92.1269, -1.60791773465556),
(31280, '71343', 218, 22, 3455, 31.6518, 0.552428124182741, -91.8269, -1.60268174689958),
(31281, '71345', 218, 22, 41752, 30.7302, 0.536343169796361, -91.9766, -1.60529450478982),
(31282, '71346', 218, 22, 41754, 31.1043, 0.542872446528072, -92.4033, -1.61274182470808),
(31283, '71348', 218, 22, 112376, 31.2637, 0.545654501355751, -92.4242, -1.61310659852174),
(31284, '71350', 218, 22, 41969, 31.0802, 0.542451822178342, -92.0252, -1.60614273480629),
(31285, '71351', 218, 22, 41987, 31.1258, 0.543247692317251, -92.0625, -1.60679374261728),
(31286, '71353', 218, 22, 27871, 30.6537, 0.535007992918586, -91.7903, -1.60204295639335),
(31287, '71354', 218, 22, 4284, 31.349, 0.547143267207702, -91.6684, -1.59991540003517),
(31288, '71355', 218, 22, 42159, 31.0429, 0.541800814367348, -91.9832, -1.60540969652045),
(31289, '71356', 218, 22, 587, 30.8256, 0.538008213902764, -92.017, -1.60599961780762),
(31290, '71357', 218, 22, 42275, 32.0659, 0.55965553261525, -91.2401, -1.59244015484888),
(31291, '71358', 218, 22, 4844, 30.6998, 0.535812589703755, -91.9155, -1.60422810861685),
(31292, '71359', 218, 22, 5077, 31.3258, 0.54673835082124, -92.4274, -1.61316244905781),
(31293, '71360', 218, 22, 5077, 31.3487, 0.547138031219946, -92.393, -1.61256205579512),
(31294, '71361', 218, 22, 5077, 31.3562, 0.547268930913846, -92.4046, -1.61276451398835),
(31295, '71362', 218, 22, 42613, 30.9208, 0.539669767350663, -91.9873, -1.60548125501978),
(31296, '71363', 218, 22, 5363, 31.6364, 0.552159343477934, -92.001, -1.6057203651273),
(31297, '71365', 218, 22, 42889, 31.1896, 0.544361212380023, -92.2483, -1.61003656436749),
(31298, '71366', 218, 22, 488, 31.9164, 0.557046265383518, -91.2379, -1.59240175760533),
(31299, '71367', 218, 22, 42933, 30.852, 0.538468980825291, -92.4096, -1.61285178045095),
(31300, '71368', 218, 22, 43070, 31.8551, 0.555976378552046, -91.6935, -1.60035347767742),
(31301, '71369', 218, 22, 43081, 30.9896, 0.540870553876035, -91.8267, -1.60267825624108),
(31302, '71371', 218, 22, 38592, 31.637, 0.552169815453446, -92.2488, -1.61004529101375),
(31303, '71373', 218, 22, 25728, 31.5703, 0.551005680842366, -91.4451, -1.59601807981547),
(31304, '71375', 218, 22, 12694, 31.8208, 0.555377730618612, -91.3818, -1.59491328639895),
(31305, '71377', 218, 22, 44143, 31.6161, 0.551805041639779, -91.784, -1.60193300065048),
(31306, '71378', 218, 22, 44191, 31.9734, 0.558041103057155, -91.6544, -1.59967105393989),
(31307, '71401', 218, 22, 39044, 31.7566, 0.554257229238831, -91.9953, -1.60562088135994),
(31308, '71403', 218, 22, 39101, 31.2118, 0.544748675473966, -93.3905, -1.62997171508376),
(31309, '71404', 218, 22, 7187, 31.8323, 0.555578443482591, -92.7889, -1.61947181430377),
(31310, '71405', 218, 22, 7241, 31.4158, 0.548309147148035, -92.4069, -1.61280465656115),
(31311, '71406', 218, 22, 303, 31.7125, 0.553487539038702, -93.4998, -1.63187935995619),
(31312, '71407', 218, 22, 31801, 31.4857, 0.549529132295179, -92.4999, -1.6144278127655),
(31313, '71409', 218, 22, 34943, 31.3148, 0.54654636460352, -92.6872, -1.61769681445449),
(31314, '71410', 218, 22, 7856, 31.9652, 0.557897986058491, -92.7755, -1.619237940184),
(31315, '71411', 218, 22, 39630, 31.8956, 0.556683236899103, -93.1144, -1.62515286101901),
(31316, '71414', 218, 22, 1592, 31.8211, 0.555382966606368, -93.0291, -1.62366409516706),
(31317, '71415', 218, 22, 39796, 32.0281, 0.558995798157996, -92.1395, -1.60813764614132),
(31318, '71416', 218, 22, 39814, 31.5209, 0.550143488191881, -92.7065, -1.61803366300012),
(31319, '71417', 218, 22, 8175, 31.5202, 0.550131270887117, -92.7062, -1.61802842701237),
(31320, '71418', 218, 22, 1716, 32.0826, 0.559947002600333, -92.0874, -1.60722832960103),
(31321, '71419', 218, 22, 39874, 31.723, 0.553670798610161, -93.6373, -1.63427918767769),
(31322, '71422', 218, 22, 8544, 32.0711, 0.559746289736353, -92.6682, -1.61736520189661),
(31323, '71423', 218, 22, 40703, 31.5717, 0.551030115451894, -92.528, -1.61491825028531),
(31324, '71424', 218, 22, 32348, 31.151, 0.543687515288754, -92.7073, -1.61804762563414),
(31325, '71425', 218, 22, 2311, 31.8926, 0.556630877021544, -91.8825, -1.60365214996369),
(31326, '71426', 218, 22, 8891, 31.4949, 0.549689702586362, -93.4699, -1.63135750650985),
(31327, '71427', 218, 22, 2487, 31.3912, 0.547879796152044, -92.8767, -1.62100421338702),
(31328, '71428', 218, 22, 27181, 31.6143, 0.551773625713243, -93.0939, -1.62479506852235),
(31329, '71429', 218, 22, 40929, 31.5627, 0.550873035819214, -93.4785, -1.63150760482552),
(31330, '71430', 218, 22, 2524, 31.051, 0.541942186036759, -92.5071, -1.61455347647165),
(31331, '71431', 218, 22, 9048, 31.2695, 0.545755730452367, -92.6928, -1.6177945528926),
(31332, '71432', 218, 22, 2693, 31.7365, 0.55390641805918, -92.3915, -1.61253587585634),
(31333, '71433', 218, 22, 41097, 30.9857, 0.540802486035207, -92.641, -1.61689047234007),
(31334, '71434', 218, 22, 41136, 31.4322, 0.548595381145362, -92.9433, -1.62216660266885),
(31335, '71435', 218, 22, 2826, 32.0119, 0.558713054819173, -91.95, -1.60483024720879),
(31336, '71438', 218, 22, 41362, 31.1468, 0.54361421146017, -92.7474, -1.61874750266419),
(31337, '71439', 218, 22, 41409, 31.3227, 0.546684245614428, -93.3136, -1.62862955688898),
(31338, '71440', 218, 22, 41554, 31.9391, 0.557442455123721, -92.5986, -1.61615045273722),
(31339, '71441', 218, 22, 3492, 32.0026, 0.558550739198737, -92.1477, -1.60828076313998),
(31340, '71443', 218, 22, 41641, 31.3372, 0.546937318355967, -93.1655, -1.62604472426678);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(31341, '71446', 218, 22, 30315, 31.1254, 0.543240711000243, -93.2761, -1.62797505841948),
(31342, '71447', 218, 22, 10035, 31.4167, 0.548324855111302, -92.7795, -1.61930775335408),
(31343, '71448', 218, 22, 41859, 31.0063, 0.541162023861118, -92.5527, -1.61534934661056),
(31344, '71449', 218, 22, 41970, 31.5655, 0.55092190503827, -93.4801, -1.63153553009355),
(31345, '71450', 218, 22, 41993, 31.8006, 0.555025174109709, -93.3957, -1.63006247220487),
(31346, '71452', 218, 22, 4153, 31.6517, 0.552426378853489, -93.0155, -1.62342673038879),
(31347, '71454', 218, 22, 4289, 31.6281, 0.552014481150019, -92.8213, -1.62003730098141),
(31348, '71455', 218, 22, 23175, 31.3299, 0.546809909320571, -92.8845, -1.62114034906867),
(31349, '71456', 218, 22, 4483, 31.6803, 0.55292554301956, -93.0131, -1.62338484248674),
(31350, '71457', 218, 22, 42240, 31.7614, 0.554341005042927, -93.0858, -1.62465369685294),
(31351, '71458', 218, 22, 42240, 31.76, 0.554316570433399, -93.0859, -1.62465544218219),
(31352, '71459', 218, 22, 30315, 31.0603, 0.542104501657195, -93.2208, -1.62700989134313),
(31353, '71460', 218, 22, 42246, 31.4691, 0.549239407639348, -93.575, -1.63319184755369),
(31354, '71461', 218, 22, 0, 31.114, 0.543041743465516, -93.282, -1.62807803284535),
(31355, '71462', 218, 22, 23388, 31.6364, 0.552159343477934, -93.6727, -1.63489703423289),
(31356, '71463', 218, 22, 4701, 30.8147, 0.537817973014297, -92.6581, -1.61718892364216),
(31357, '71465', 218, 22, 42436, 31.9085, 0.556908384372611, -92.2204, -1.60954961750618),
(31358, '71466', 218, 22, 17462, 31.2185, 0.54486561253385, -92.7452, -1.61870910542064),
(31359, '71467', 218, 22, 42644, 31.4332, 0.548612834437882, -92.4132, -1.61291461230402),
(31360, '71468', 218, 22, 42703, 31.5181, 0.550094618972825, -93.1139, -1.62514413437275),
(31361, '71469', 218, 22, 42830, 31.8047, 0.555096732609041, -93.3065, -1.62850563851209),
(31362, '71471', 218, 22, 31043, 31.7594, 0.554306098457887, -92.9588, -1.6224371287029),
(31363, '71472', 218, 22, 43073, 31.2049, 0.544628247755579, -92.7882, -1.619459596999),
(31364, '71473', 218, 22, 5849, 32.0561, 0.559484490348554, -92.4119, -1.61289192302375),
(31365, '71474', 218, 22, 5863, 31.2456, 0.54533859676114, -93.0155, -1.62342673038879),
(31366, '71475', 218, 22, 43091, 31.1988, 0.544521782671207, -93.1349, -1.62551065351567),
(31367, '71477', 218, 22, 25513, 31.3935, 0.54791993872484, -92.4343, -1.61328287677619),
(31368, '71479', 218, 22, 43401, 31.8616, 0.556089824953425, -92.291, -1.61078181995809),
(31369, '71480', 218, 22, 43445, 31.8642, 0.556135203513977, -92.2936, -1.61082719851864),
(31370, '71481', 218, 22, 38679, 31.6994, 0.553258900906691, -92.7724, -1.61918383497719),
(31371, '71483', 218, 22, 44186, 31.9228, 0.557157966455646, -92.6456, -1.61697075748566),
(31372, '71485', 218, 22, 44230, 31.1614, 0.543869029530961, -92.5024, -1.6144714459968),
(31373, '71486', 218, 22, 44258, 31.6277, 0.552007499833011, -93.6334, -1.63421111983686),
(31374, '71496', 218, 22, 30315, 31.1444, 0.543572323558122, -93.2595, -1.62768533376365),
(31375, '71497', 218, 22, 42240, 31.755, 0.554229303970799, -93.098, -1.62486662702168),
(31376, '71601', 218, 4, 11202, 34.1996, 0.596895622865053, -91.9303, -1.60448641734614),
(31377, '71602', 218, 4, 367, 34.2604, 0.597956783050265, -92.1298, -1.60796834920387),
(31378, '71603', 218, 4, 11202, 34.1979, 0.596865952267769, -92.0359, -1.60632948503625),
(31379, '71611', 218, 4, 11202, 34.1991, 0.596886896218793, -91.9398, -1.60465222362508),
(31380, '71612', 218, 4, 367, 34.2285, 0.597400023018879, -92.0026, -1.60574829039534),
(31381, '71613', 218, 4, 11202, 34.1388, 0.59583446267984, -92.108, -1.60758786742694),
(31382, '71630', 218, 4, 7148, 33.5871, 0.586205481196587, -91.2483, -1.59258327184754),
(31383, '71631', 218, 4, 7248, 33.5454, 0.585477678898506, -92.2661, -1.61034723297434),
(31384, '71635', 218, 4, 8328, 33.1269, 0.57817347597891, -91.9595, -1.60499605348773),
(31385, '71638', 218, 4, 8493, 33.5277, 0.585168755620903, -91.4386, -1.59590463341409),
(31386, '71639', 218, 4, 8621, 33.8872, 0.591443214281822, -91.4891, -1.59678602468634),
(31387, '71640', 218, 4, 8789, 33.1156, 0.577976253773434, -91.2627, -1.59283459925983),
(31388, '71642', 218, 4, 8949, 33.3445, 0.581971312431249, -91.8203, -1.60256655516895),
(31389, '71643', 218, 4, 9168, 33.9882, 0.593205996826337, -91.5565, -1.59796237660219),
(31390, '71644', 218, 4, 2800, 33.9801, 0.593064625156925, -91.6869, -1.60023828594679),
(31391, '71646', 218, 4, 2948, 33.2274, 0.579927531877164, -91.7979, -1.6021756014165),
(31392, '71647', 218, 4, 9439, 33.3683, 0.582386700793224, -92.1125, -1.60766640724328),
(31393, '71649', 218, 4, 9747, 33.2564, 0.580433677360242, -91.2863, -1.5932464969633),
(31394, '71651', 218, 4, 9753, 33.3467, 0.582009709674793, -92.2865, -1.61070328014175),
(31395, '71652', 218, 4, 9871, 33.8786, 0.591293115966151, -92.3049, -1.61102442072411),
(31396, '71653', 218, 4, 9941, 33.3314, 0.581742674299238, -91.2846, -1.59321682636602),
(31397, '71654', 218, 4, 10400, 33.6238, 0.586846017032069, -91.3586, -1.59450837001249),
(31398, '71655', 218, 4, 588, 33.6289, 0.586935028823921, -91.7898, -1.60203422974709),
(31399, '71656', 218, 4, 588, 33.6288, 0.586933283494669, -91.7912, -1.60205866435662),
(31400, '71657', 218, 4, 588, 33.6289, 0.586935028823921, -91.7913, -1.60206040968587),
(31401, '71658', 218, 4, 4299, 33.3263, 0.581653662507386, -91.551, -1.59786638349333),
(31402, '71659', 218, 4, 4344, 34.1467, 0.595972343690748, -91.795, -1.60212498686819),
(31403, '71660', 218, 4, 10760, 33.7652, 0.589313912594389, -92.1913, -1.60904172669385),
(31404, '71661', 218, 4, 4871, 33.1133, 0.577936111200638, -91.529, -1.59748241105789),
(31405, '71662', 218, 4, 11179, 33.8023, 0.589961429746879, -91.3885, -1.59503022345884),
(31406, '71663', 218, 4, 5188, 33.2398, 0.580143952704411, -91.516, -1.59725551825513),
(31407, '71665', 218, 4, 11594, 33.9626, 0.592759192537826, -92.2077, -1.60932796069118),
(31408, '71666', 218, 4, 10400, 33.6254, 0.586873942300101, -91.2028, -1.59178914703788),
(31409, '71667', 218, 4, 12110, 33.9393, 0.592352530822112, -91.844, -1.60298019820167),
(31410, '71670', 218, 4, 12320, 33.6624, 0.587519714123339, -91.5388, -1.59765345332459),
(31411, '71671', 218, 4, 12663, 33.611, 0.586622614887814, -92.0681, -1.60689148105539),
(31412, '71674', 218, 4, 6657, 33.7962, 0.589854964662508, -91.3032, -1.59354145760689),
(31413, '71675', 218, 4, 12879, 33.6268, 0.586898376909629, -91.9287, -1.60445849207811),
(31414, '71676', 218, 4, 12881, 33.0537, 0.57689589496645, -91.5726, -1.59824337461176),
(31415, '71677', 218, 4, 12894, 33.7509, 0.589064330511354, -91.5459, -1.59777737170148),
(31416, '71678', 218, 4, 143, 34.0328, 0.593984413672726, -91.7905, -1.60204644705185),
(31417, '71701', 218, 4, 1304, 33.5678, 0.585868632650953, -92.8369, -1.62030957234472),
(31418, '71711', 218, 4, 1304, 33.5846, 0.586161847965288, -92.8333, -1.62024674049165),
(31419, '71720', 218, 4, 7335, 33.7284, 0.588671631429656, -92.6357, -1.61679796988971),
(31420, '71721', 218, 4, 7370, 33.8886, 0.59146764889135, -93.2037, -1.62671144004104),
(31421, '71722', 218, 4, 1011, 33.6966, 0.588116616727521, -93.2025, -1.62669049609002),
(31422, '71724', 218, 4, 7852, 33.3224, 0.581585594666558, -92.545, -1.61521495625815),
(31423, '71725', 218, 4, 7932, 34.0491, 0.594268902340801, -92.6486, -1.61702311736322),
(31424, '71726', 218, 4, 8067, 33.705, 0.588263224384689, -93.0281, -1.62364664187454),
(31425, '71728', 218, 4, 1933, 33.9979, 0.59337529376378, -93.1053, -1.62499403605708),
(31426, '71730', 218, 4, 8703, 33.215, 0.579711111049917, -92.6653, -1.6173145873483),
(31427, '71731', 218, 4, 8703, 33.2117, 0.579653515184601, -92.6655, -1.61731807800681),
(31428, '71740', 218, 4, 8753, 33.0969, 0.577649877203311, -93.1896, -1.62646534861651),
(31429, '71742', 218, 4, 2516, 33.8135, 0.590156906623103, -92.4197, -1.6130280587054),
(31430, '71743', 218, 4, 9277, 33.9175, 0.591972049045177, -93.149, -1.6257567449402),
(31431, '71744', 218, 4, 2957, 33.5129, 0.584910446891608, -92.5593, -1.61546453834119),
(31432, '71745', 218, 4, 2990, 33.5065, 0.58479874581948, -92.395, -1.61259696238016),
(31433, '71747', 218, 4, 9634, 33.0567, 0.57694825484401, -92.1821, -1.60888115640267),
(31434, '71748', 218, 4, 9677, 33.9093, 0.591828932046513, -92.4416, -1.61341028581159),
(31435, '71749', 218, 4, 9806, 33.0193, 0.576295501703764, -92.7237, -1.61833385963147),
(31436, '71750', 218, 4, 3699, 33.1971, 0.57939869711381, -92.4829, -1.61413110679266),
(31437, '71751', 218, 4, 10203, 33.4109, 0.583130211054573, -92.7787, -1.61929379072006),
(31438, '71752', 218, 4, 10420, 33.3858, 0.582692133412323, -93.1967, -1.6265892669934),
(31439, '71753', 218, 4, 3947, 33.2638, 0.58056283172489, -93.235, -1.62725772809691),
(31440, '71754', 218, 4, 3947, 33.267, 0.580618682260954, -93.2391, -1.62732928659624),
(31441, '71758', 218, 4, 10633, 33.3143, 0.581444222997147, -92.9415, -1.62213518674231),
(31442, '71759', 218, 4, 10830, 33.3251, 0.581632718556362, -92.6658, -1.61732331399456),
(31443, '71762', 218, 4, 11980, 33.3625, 0.582285471696608, -92.7283, -1.61841414477706),
(31444, '71763', 218, 4, 12058, 33.9138, 0.591907471862853, -92.7717, -1.61917161767242),
(31445, '71764', 218, 4, 983, 33.4211, 0.583308234638277, -93.0348, -1.62376357893442),
(31446, '71765', 218, 4, 12158, 33.2085, 0.579597664648537, -92.4424, -1.61342424844561),
(31447, '71766', 218, 4, 351, 33.7538, 0.589114945059662, -92.46, -1.61373142639396),
(31448, '71768', 218, 4, 12500, 33.1591, 0.578735471998052, -92.4458, -1.61348358964017),
(31449, '71769', 218, 4, 12557, 33.2592, 0.580482546579298, -93.0436, -1.6239171679086),
(31450, '71770', 218, 4, 6601, 33.3521, 0.582103957454401, -93.2906, -1.62822813116102),
(31451, '71772', 218, 4, 12786, 33.8312, 0.590465829900706, -93.1255, -1.62534659256598),
(31452, '71801', 218, 4, 665, 33.6636, 0.587540658074363, -93.5896, -1.63344666562449),
(31453, '71802', 218, 4, 665, 33.6682, 0.587620943219955, -93.5882, -1.63342223101496),
(31454, '71820', 218, 4, 7058, 33.7698, 0.589394197739981, -94.2603, -1.64515258891761),
(31455, '71822', 218, 4, 7174, 33.6726, 0.587697737707043, -94.1257, -1.64280337574443),
(31456, '71823', 218, 4, 7399, 34.0426, 0.594155455939422, -94.3956, -1.64751401939556),
(31457, '71825', 218, 4, 7540, 33.8875, 0.591448450269578, -93.522, -1.63226682305014),
(31458, '71826', 218, 4, 694, 33.1125, 0.577922148566622, -93.6488, -1.63447990054167),
(31459, '71827', 218, 4, 7751, 33.3693, 0.582404154085744, -93.4437, -1.63090023024583),
(31460, '71828', 218, 4, 7838, 33.6222, 0.586818091764037, -93.2638, -1.62776038292149),
(31461, '71831', 218, 4, 1718, 33.7523, 0.589088765120882, -93.8213, -1.63749059350136),
(31462, '71832', 218, 4, 8426, 34.04, 0.59411007737887, -94.3438, -1.64660993884303),
(31463, '71833', 218, 4, 8519, 33.9957, 0.593336896520236, -93.8386, -1.63779253546195),
(31464, '71834', 218, 4, 8542, 33.1157, 0.577977999102686, -93.9588, -1.63989042122285),
(31465, '71835', 218, 4, 8756, 33.6705, 0.587661085792751, -93.4006, -1.63014799333822),
(31466, '71836', 218, 4, 8924, 33.6959, 0.588104399422757, -94.4026, -1.6476361924432),
(31467, '71837', 218, 4, 8948, 33.2849, 0.580931096197061, -93.8897, -1.63868439870972),
(31468, '71838', 218, 4, 2628, 33.6299, 0.586952482116441, -93.8135, -1.6373544578197),
(31469, '71839', 218, 4, 0, 33.3177, 0.581503564191715, -93.7599, -1.63641896134063),
(31470, '71840', 218, 4, 9080, 33.3832, 0.582646754851771, -93.9096, -1.63903171923087),
(31471, '71841', 218, 4, 9114, 34.1477, 0.595989796983268, -94.3129, -1.64607063210416),
(31472, '71842', 218, 4, 9577, 33.9061, 0.591773081510449, -94.2664, -1.64525905400198),
(31473, '71844', 218, 4, 9980, 33.6955, 0.588097418105749, -93.3527, -1.62931198062651),
(31474, '71845', 218, 4, 10065, 33.3595, 0.582233111819048, -93.5818, -1.63331052994283),
(31475, '71846', 218, 4, 10144, 33.9187, 0.591992992996201, -94.1153, -1.64262186150222),
(31476, '71847', 218, 4, 10380, 33.93, 0.592190215201676, -93.6394, -1.63431583959198),
(31477, '71851', 218, 4, 4237, 33.8739, 0.591211085491307, -93.9187, -1.6391905441928),
(31478, '71852', 218, 4, 10729, 33.9434, 0.592424089321443, -93.8482, -1.63796008707014),
(31479, '71853', 218, 4, 10927, 33.5974, 0.586385250109543, -93.9719, -1.64011905935486),
(31480, '71854', 218, 4, 12287, 33.4388, 0.58361715791588, -94.0195, -1.64094983607881),
(31481, '71855', 218, 4, 4831, 33.879, 0.591300097283159, -93.7414, -1.63609607542901),
(31482, '71857', 218, 4, 5219, 33.8007, 0.589933504478847, -93.3803, -1.62979369150006),
(31483, '71858', 218, 4, 11696, 33.5696, 0.585900048577488, -93.2904, -1.62822464050252),
(31484, '71859', 218, 4, 5658, 33.7706, 0.589408160373997, -93.8839, -1.6385831696131),
(31485, '71860', 218, 4, 12106, 33.3612, 0.582262782416332, -93.5025, -1.631926483846),
(31486, '71861', 218, 4, 6252, 33.1115, 0.577904695274102, -93.4479, -1.63097353407441),
(31487, '71862', 218, 4, 12671, 33.7505, 0.589057349194346, -93.6683, -1.6348202397458),
(31488, '71864', 218, 4, 12873, 33.4919, 0.584543927748689, -93.3007, -1.62840440941547),
(31489, '71865', 218, 4, 287, 33.7428, 0.588922958841943, -94.1125, -1.64257299228316),
(31490, '71866', 218, 4, 12913, 33.8694, 0.591132545674967, -94.4065, -1.64770426028403),
(31491, '71901', 218, 4, 0, 34.4966, 0.602079250743476, -93.0314, -1.62370423773985),
(31492, '71902', 218, 4, 0, 34.5032, 0.602194442474107, -93.055, -1.62411613544332),
(31493, '71903', 218, 4, 0, 34.5268, 0.602606340177578, -92.9942, -1.62305497525811),
(31494, '71909', 218, 4, 9589, 34.6662, 0.605039329154858, -93.0102, -1.62333422793843),
(31495, '71910', 218, 4, 9589, 34.6648, 0.60501489454533, -93.0003, -1.62316144034248),
(31496, '71913', 218, 4, 0, 34.4057, 0.600492746453413, -93.0752, -1.62446869195223),
(31497, '71914', 218, 4, 0, 34.5309, 0.60267789867691, -93.0491, -1.62401316101746),
(31498, '71920', 218, 4, 7073, 34.2286, 0.597401768348131, -93.379, -1.62977100221979),
(31499, '71921', 218, 4, 7091, 34.2416, 0.59762866115089, -93.3596, -1.6294324083449),
(31500, '71922', 218, 4, 7121, 34.0238, 0.593827334040047, -93.4507, -1.63102240329346),
(31501, '71923', 218, 4, 7145, 34.0866, 0.594923400810299, -93.0425, -1.62389796928682),
(31502, '71929', 218, 4, 7498, 34.3374, 0.599300686574301, -93.1905, -1.62648105657978),
(31503, '71932', 218, 4, 7571, 34.5519, 0.603044417819829, -94.206, -1.64420487513378),
(31504, '71933', 218, 4, 7595, 34.3466, 0.599461256865484, -93.3182, -1.62870984203457),
(31505, '71935', 218, 4, 7823, 34.4167, 0.600684732671132, -93.6429, -1.6343769261158),
(31506, '71937', 218, 4, 91, 34.4311, 0.60093606008342, -94.4182, -1.64790846380651),
(31507, '71940', 218, 4, 8467, 34.0577, 0.594419000656473, -93.5326, -1.63245182795085),
(31508, '71941', 218, 4, 8558, 34.2, 0.596902604182061, -92.9305, -1.62194320052459),
(31509, '71942', 218, 4, 2610, 34.2467, 0.597717672942742, -92.9833, -1.62286473436964),
(31510, '71943', 218, 4, 2749, 34.3259, 0.599099973710322, -93.5482, -1.63272409931416),
(31511, '71944', 218, 4, 9178, 34.2328, 0.597475072176715, -94.3622, -1.64693107942539),
(31512, '71945', 218, 4, 9378, 34.4874, 0.601918680452292, -94.3503, -1.64672338524441),
(31513, '71946', 218, 4, 3007, 34.3583, 0.599665460387968, -94.3765, -1.64718066150843),
(31514, '71949', 218, 4, 9757, 34.7092, 0.605789820733216, -93.2201, -1.62699767403837),
(31515, '71950', 218, 4, 9881, 34.2188, 0.597230726081436, -93.5861, -1.63338557910067),
(31516, '71951', 218, 4, 0, 34.4389, 0.601072195765075, -93.1105, -1.62508479317818),
(31517, '71952', 218, 4, 9983, 34.3088, 0.59880152240823, -93.8459, -1.63791994449735),
(31518, '71953', 218, 4, 10441, 34.5818, 0.603566271266175, -94.2415, -1.64482446701824),
(31519, '71956', 218, 4, 10679, 34.552, 0.603046163149081, -93.1597, -1.62594349517016),
(31520, '71957', 218, 4, 10634, 34.5369, 0.60278261843203, -93.5036, -1.63194568246777),
(31521, '71958', 218, 4, 10713, 34.0628, 0.594508012448325, -93.6915, -1.63522515613227),
(31522, '71959', 218, 4, 10801, 34.2202, 0.597255160690964, -93.8535, -1.6380525895205),
(31523, '71960', 218, 4, 4593, 34.459, 0.601423006944726, -93.6565, -1.63461429089407),
(31524, '71961', 218, 4, 10923, 34.6026, 0.60392929975059, -93.8297, -1.63763720115852),
(31525, '71962', 218, 4, 10933, 34.082, 0.594843115664707, -93.313, -1.62861908491347),
(31526, '71964', 218, 4, 11117, 34.4477, 0.601225784739251, -93.1965, -1.6265857763349),
(31527, '71965', 218, 4, 11134, 34.6533, 0.604814181681351, -93.7482, -1.63621475781815),
(31528, '71966', 218, 4, 10923, 34.6199, 0.604231241711185, -93.7854, -1.63686402029989),
(31529, '71968', 218, 4, 5571, 34.5217, 0.602517328385726, -93.2984, -1.62836426684268),
(31530, '71969', 218, 4, 11960, 34.6683, 0.60507598106915, -93.6649, -1.63476089855124),
(31531, '71970', 218, 4, 12146, 34.678, 0.605245278006594, -93.5608, -1.63294401079991),
(31532, '71971', 218, 4, 12445, 34.2863, 0.598408823326532, -94.1186, -1.64267945736754),
(31533, '71972', 218, 4, 12528, 34.3766, 0.599984855641083, -94.3596, -1.64688570086484),
(31534, '71973', 218, 4, 12845, 34.3123, 0.59886260893205, -94.3474, -1.6466727706961),
(31535, '71998', 218, 4, 7145, 34.1275, 0.595637240474365, -93.0531, -1.62408297418754),
(31536, '71999', 218, 4, 7145, 34.1236, 0.595569172633537, -93.0704, -1.62438491614813),
(31537, '72001', 218, 4, 7028, 35.0481, 0.611704741568225, -92.9045, -1.62148941491907),
(31538, '72002', 218, 4, 7048, 34.634, 0.604477333135716, -92.4829, -1.61413110679266),
(31539, '72003', 218, 4, 7070, 34.2973, 0.598600809544251, -91.3455, -1.59427973188048),
(31540, '72004', 218, 4, 7078, 34.3197, 0.598991763296698, -91.8438, -1.60297670754317),
(31541, '72005', 218, 4, 7083, 35.5534, 0.620523890278552, -91.0793, -1.58963366541167),
(31542, '72006', 218, 4, 7193, 35.2839, 0.615820227944427, -91.3622, -1.59457120186556),
(31543, '72007', 218, 4, 7197, 34.9993, 0.610853020893251, -91.9714, -1.60520374766871),
(31544, '72010', 218, 4, 7236, 35.3037, 0.616165803136322, -91.5881, -1.59851390064582),
(31545, '72011', 218, 4, 4, 34.5325, 0.602705823944942, -92.4741, -1.61397751781849),
(31546, '72012', 218, 4, 7359, 35.075, 0.612174235137011, -91.8931, -1.6038371548644),
(31547, '72013', 218, 4, 7357, 35.423, 0.618247980933951, -92.4147, -1.6129407922428),
(31548, '72014', 218, 4, 7368, 35.4259, 0.618298595482259, -91.1086, -1.59014504688251),
(31549, '72015', 218, 4, 358, 34.5662, 0.603293999902864, -92.5848, -1.61590959730045),
(31550, '72016', 218, 4, 7481, 34.884, 0.608840656265702, -92.6948, -1.61782945947764),
(31551, '72017', 218, 4, 7495, 34.8372, 0.608023842175769, -91.5367, -1.59761680141029),
(31552, '72018', 218, 4, 358, 34.5639, 0.603253857330068, -92.5876, -1.6159584665195),
(31553, '72020', 218, 4, 1076, 35.5501, 0.620466294413236, -91.4375, -1.59588543479232),
(31554, '72021', 218, 4, 7684, 34.8901, 0.608947121350074, -91.1918, -1.59159716082017),
(31555, '72022', 218, 4, 652, 34.6006, 0.60389439316555, -92.4893, -1.61424280786479),
(31556, '72023', 218, 4, 7814, 34.9667, 0.610284043557101, -92.0146, -1.60595772990557),
(31557, '72024', 218, 4, 1358, 34.7881, 0.607166885513039, -91.7449, -1.60125057691295),
(31558, '72025', 218, 4, 7936, 35.0308, 0.61140279960763, -93.0372, -1.62380546683647),
(31559, '72026', 218, 4, 7942, 34.4536, 0.601328759165118, -91.3294, -1.59399873387091),
(31560, '72027', 218, 4, 1454, 35.4013, 0.617869244486269, -92.5598, -1.61547326498745),
(31561, '72028', 218, 4, 8073, 35.5207, 0.61995316761315, -92.4172, -1.6129844254741),
(31562, '72029', 218, 4, 8087, 34.6952, 0.605545474637937, -91.308, -1.59362523341098),
(31563, '72030', 218, 4, 1620, 35.3683, 0.61729328583311, -92.7044, -1.61799701108583),
(31564, '72031', 218, 4, 1630, 35.5803, 0.620993383847338, -92.4359, -1.61331080204423),
(31565, '72032', 218, 4, 8215, 35.0863, 0.612371457342486, -92.4352, -1.61329858473946),
(31566, '72033', 218, 4, 8215, 35.0839, 0.612329569440439, -92.373, -1.61221298994472),
(31567, '72034', 218, 4, 8215, 35.0887, 0.612413345244534, -92.4419, -1.61341552179935),
(31568, '72035', 218, 4, 8215, 35.0746, 0.612167253820003, -92.4588, -1.61371048244293),
(31569, '72036', 218, 4, 8241, 35.0034, 0.610924579392583, -91.2527, -1.59266006633463),
(31570, '72037', 218, 4, 1855, 34.5386, 0.602812289029314, -91.874, -1.60350379697727),
(31571, '72038', 218, 4, 8305, 34.4199, 0.600740583207196, -91.2291, -1.59224816863116),
(31572, '72039', 218, 4, 1957, 35.2984, 0.616073300685966, -92.4398, -1.61337886988505),
(31573, '72040', 218, 4, 8494, 34.9579, 0.610130454582926, -91.5084, -1.59712287323198),
(31574, '72041', 218, 4, 8430, 34.7142, 0.605877087195816, -91.5428, -1.59772326649467),
(31575, '72042', 218, 4, 8432, 34.2911, 0.598492599130628, -91.3376, -1.59414185086957),
(31576, '72043', 218, 4, 8512, 35.6354, 0.621955060265187, -91.2558, -1.59271417154144),
(31577, '72044', 218, 4, 2222, 35.6484, 0.622181953067947, -92.1897, -1.60901380142582),
(31578, '72045', 218, 4, 8705, 35.1057, 0.612710051217373, -92.0873, -1.60722658427177),
(31579, '72046', 218, 4, 8764, 34.5439, 0.602904791479669, -91.967, -1.60512695318163),
(31580, '72047', 218, 4, 8769, 35.2187, 0.614682273272127, -92.2118, -1.60939951919051),
(31581, '72048', 218, 4, 8784, 34.1959, 0.596831045682729, -91.1354, -1.59061279512204),
(31582, '72051', 218, 4, 8963, 35.7641, 0.624201299012504, -92.3059, -1.61104187401663),
(31583, '72052', 218, 4, 9061, 35.1221, 0.612996285214701, -91.7295, -1.60098179620814),
(31584, '72053', 218, 4, 8181, 34.7092, 0.605789820733216, -92.2241, -1.6096141946885),
(31585, '72055', 218, 4, 9113, 34.1203, 0.595511576768221, -91.3779, -1.59484521855813),
(31586, '72057', 218, 4, 9184, 34.1204, 0.595513322097473, -92.3078, -1.61107503527242),
(31587, '72058', 218, 4, 2860, 35.2202, 0.614708453210907, -92.3859, -1.61243813741823),
(31588, '72059', 218, 4, 9237, 35.1552, 0.613573989197111, -91.3431, -1.59423784397843),
(31589, '72060', 218, 4, 9246, 35.1224, 0.613001521202456, -91.6448, -1.5995035023317),
(31590, '72061', 218, 4, 322, 35.3181, 0.616417130548609, -92.3266, -1.6114031571718),
(31591, '72063', 218, 4, 9380, 35.2815, 0.615778340042379, -92.7903, -1.61949624891329),
(31592, '72064', 218, 4, 3035, 34.795, 0.607287313231427, -91.5683, -1.59816832545392),
(31593, '72065', 218, 4, 9428, 34.5092, 0.602299162229227, -92.2107, -1.60938032056874),
(31594, '72066', 218, 4, 9465, 34.9796, 0.610509191030608, -91.7486, -1.60131515409527),
(31595, '72067', 218, 4, 9485, 35.5854, 0.62108239563919, -92.156, -1.60842562546789),
(31596, '72068', 218, 4, 9488, 35.1804, 0.614013812168613, -91.7152, -1.6007322141251),
(31597, '72069', 218, 4, 3197, 34.6037, 0.603948498372362, -91.1657, -1.59114162988539),
(31598, '72070', 218, 4, 3246, 35.0438, 0.611629692410389, -92.6896, -1.61773870235654),
(31599, '72071', 218, 4, 9597, 35.1135, 0.612846186899029, -91.245, -1.59252567598223),
(31600, '72072', 218, 4, 9614, 34.5432, 0.602892574174905, -91.732, -1.60102542943944),
(31601, '72073', 218, 4, 9615, 34.3784, 0.600016271567619, -91.6605, -1.59977751902426),
(31602, '72074', 218, 4, 3284, 35.0531, 0.611792008030824, -91.1261, -1.5904504795016),
(31603, '72075', 218, 4, 9703, 35.6382, 0.622003929484243, -91.193, -1.59161810477119),
(31604, '72076', 218, 4, 3395, 34.8737, 0.608660887352746, -92.124, -1.60786712010726),
(31605, '72078', 218, 4, 3395, 34.8671, 0.608545695622115, -92.1217, -1.60782697753446),
(31606, '72079', 218, 4, 3409, 34.3849, 0.600129717968998, -92.1691, -1.60865426359991),
(31607, '72080', 218, 4, 3422, 35.3928, 0.617720891499849, -92.8079, -1.61980342686165),
(31608, '72081', 218, 4, 9801, 35.1737, 0.613896875108729, -91.7729, -1.6017392691035),
(31609, '72082', 218, 4, 9833, 35.2326, 0.614924874038154, -91.6684, -1.59991540003517),
(31610, '72083', 218, 4, 9844, 34.6072, 0.604009584896182, -92.003, -1.60575527171234),
(31611, '72084', 218, 4, 10041, 34.2182, 0.597220254105924, -92.6031, -1.61622899255356),
(31612, '72085', 218, 4, 10056, 35.363, 0.617200783382755, -91.8288, -1.60271490815537),
(31613, '72086', 218, 4, 10190, 34.7839, 0.607093581684456, -91.901, -1.60397503587531),
(31614, '72087', 218, 4, 10193, 34.5655, 0.6032817825981, -92.8163, -1.61995003451881),
(31615, '72088', 218, 4, 8819, 35.6124, 0.621553634537229, -92.2931, -1.61081847187238),
(31616, '72089', 218, 4, 652, 34.5958, 0.603810617361454, -92.489, -1.61423757187704),
(31617, '72099', 218, 4, 0, 34.891, 0.608962829313341, -92.1591, -1.60847973067471),
(31618, '72101', 218, 4, 10390, 35.2624, 0.615444982155248, -91.2012, -1.59176122176985),
(31619, '72102', 218, 4, 4113, 35.1159, 0.612888074801077, -91.82, -1.60256131918119),
(31620, '72103', 218, 4, 10244, 34.5918, 0.603740804191374, -92.3818, -1.6123665789189),
(31621, '72104', 218, 4, 3963, 34.3621, 0.599731782899543, -92.8072, -1.61979120955688),
(31622, '72105', 218, 4, 3449, 34.4285, 0.600890681522868, -92.8849, -1.62114733038568),
(31623, '72106', 218, 4, 10368, 34.9687, 0.610318950142141, -92.4288, -1.61318688366733),
(31624, '72107', 218, 4, 10445, 35.1482, 0.613451816149471, -92.5545, -1.61538076253709),
(31625, '72108', 218, 4, 10560, 34.7352, 0.606243606338734, -91.1032, -1.5900507991029),
(31626, '72110', 218, 4, 10606, 35.1552, 0.613573989197111, -92.7413, -1.61864103757982),
(31627, '72111', 218, 4, 4411, 35.1866, 0.614122022582237, -92.0755, -1.60702063542004),
(31628, '72112', 218, 4, 10799, 35.6123, 0.621551889207977, -91.2618, -1.59281889129656),
(31629, '72113', 218, 4, 10356, 34.8523, 0.60828738689282, -92.4053, -1.61277673129312),
(31630, '72114', 218, 4, 10848, 34.7649, 0.606761969126577, -92.256, -1.61017095471989),
(31631, '72115', 218, 4, 10848, 34.7674, 0.606805602357877, -92.2578, -1.61020237064642),
(31632, '72116', 218, 4, 10848, 34.8016, 0.607402504962059, -92.2322, -1.60975556635791),
(31633, '72117', 218, 4, 10848, 34.7775, 0.606981880612328, -92.1919, -1.60905219866936),
(31634, '72118', 218, 4, 10848, 34.8035, 0.607435666217847, -92.3165, -1.61122687891735),
(31635, '72119', 218, 4, 10848, 34.7647, 0.606758478468073, -92.2561, -1.61017270004914),
(31636, '72120', 218, 4, 14604, 34.8923, 0.608985518593617, -92.2288, -1.60969622516335),
(31637, '72121', 218, 4, 11060, 35.4233, 0.618253216921707, -91.8409, -1.60292609299486),
(31638, '72122', 218, 4, 11088, 34.8045, 0.607453119510366, -92.85, -1.62053821047674),
(31639, '72123', 218, 4, 428, 35.257, 0.615350734375641, -91.2351, -1.59235288838628),
(31640, '72124', 218, 4, 10848, 34.81, 0.607549112619226, -92.2362, -1.60982537952799),
(31641, '72125', 218, 4, 11148, 35.0379, 0.611526717984521, -92.7939, -1.61955908076637),
(31642, '72126', 218, 4, 4963, 35.0138, 0.611106093634791, -92.8036, -1.61972837770381),
(31643, '72127', 218, 4, 11303, 35.1588, 0.613636821050182, -92.6354, -1.61679273390196),
(31644, '72128', 218, 4, 11360, 34.3591, 0.599679423021984, -92.6059, -1.61627786177262),
(31645, '72129', 218, 4, 11393, 34.2946, 0.598553685654447, -92.5018, -1.61446097402129),
(31646, '72130', 218, 4, 11402, 35.6917, 0.62293768063406, -92.1434, -1.60820571398214),
(31647, '72131', 218, 4, 11443, 35.3805, 0.617506216001854, -92.2105, -1.60937682991023),
(31648, '72132', 218, 4, 11515, 34.4589, 0.601421261615474, -92.1759, -1.60877294598904),
(31649, '72133', 218, 4, 11552, 34.1728, 0.596427874625518, -91.6278, -1.59920679635886),
(31650, '72134', 218, 4, 11650, 34.6164, 0.604170155187365, -91.3745, -1.59478587736356),
(31651, '72135', 218, 4, 5513, 34.8711, 0.608615508792195, -92.524, -1.61484843711523),
(31652, '72136', 218, 4, 11664, 35.2195, 0.614696235906143, -92.0691, -1.60690893434791),
(31653, '72137', 218, 4, 11676, 35.3128, 0.616324628098254, -91.9806, -1.6053643179599),
(31654, '72139', 218, 4, 5580, 35.3627, 0.617195547394999, -91.5073, -1.59710367461021),
(31655, '72140', 218, 4, 11748, 34.3373, 0.599298941245049, -91.1818, -1.59142262789497),
(31656, '72141', 218, 4, 5690, 35.5203, 0.619946186296142, -92.6685, -1.61737043788437),
(31657, '72142', 218, 4, 11829, 34.7749, 0.606936502051776, -92.0616, -1.60677803465401),
(31658, '72143', 218, 4, 5713, 35.2464, 0.615165729474929, -91.7368, -1.60110920524353),
(31659, '72145', 218, 4, 5713, 35.2526, 0.615273939888553, -91.7429, -1.60121567032791),
(31660, '72149', 218, 4, 5713, 35.2487, 0.615205872047725, -91.7281, -1.60095736159861),
(31661, '72150', 218, 4, 11906, 34.3076, 0.598780578457207, -92.4012, -1.61270517279378),
(31662, '72152', 218, 4, 11910, 34.3515, 0.599546777998832, -91.9897, -1.60552314292183),
(31663, '72153', 218, 4, 5825, 35.6174, 0.621640900999828, -92.2622, -1.61027916513351),
(31664, '72156', 218, 4, 12020, 35.2722, 0.615616024421944, -92.6767, -1.61751355488303),
(31665, '72157', 218, 4, 349, 35.2742, 0.615650931006984, -92.5382, -1.61509627386902),
(31666, '72158', 218, 4, 358, 34.5693, 0.603348105109676, -92.5776, -1.6157839335943),
(31667, '72160', 218, 4, 12164, 34.4959, 0.602067033438712, -91.5513, -1.59787161948108),
(31668, '72164', 218, 4, 6194, 34.6771, 0.605229570043326, -92.2404, -1.60989868335658),
(31669, '72165', 218, 4, 12298, 35.5561, 0.620571014168356, -91.4734, -1.59651200799378),
(31670, '72166', 218, 4, 12318, 34.0598, 0.594455652570765, -91.2329, -1.59231449114273),
(31671, '72167', 218, 4, 12380, 34.4475, 0.601222294080747, -92.6553, -1.6171400544231),
(31672, '72168', 218, 4, 6399, 34.4393, 0.601079177082083, -91.8909, -1.60379875762086),
(31673, '72169', 218, 4, 6408, 35.3917, 0.617701692878077, -91.2303, -1.59226911258218),
(31674, '72170', 218, 4, 12444, 34.5755, 0.603456315523299, -91.5325, -1.59754349758171),
(31675, '72173', 218, 4, 12564, 35.0987, 0.612587878169734, -92.2989, -1.61091970096899),
(31676, '72175', 218, 4, 12578, 34.3606, 0.599705602960764, -91.7948, -1.60212149620969),
(31677, '72176', 218, 4, 861, 35.0211, 0.611233502670186, -91.9488, -1.60480930325776),
(31678, '72178', 218, 4, 6722, 35.2038, 0.61442221921358, -91.61, -1.59889612775201),
(31679, '72179', 218, 4, 6811, 35.4454, 0.618638934686398, -91.9021, -1.60399423449708),
(31680, '72180', 218, 4, 12950, 34.5301, 0.602663936042894, -92.2112, -1.609389047215),
(31681, '72181', 218, 4, 12957, 35.1931, 0.614235468983616, -92.4665, -1.61384487279534),
(31682, '72182', 218, 4, 6964, 34.4446, 0.601171679532439, -92.0394, -1.60639057156007),
(31683, '72183', 218, 4, 12969, 34.6007, 0.603896138494802, -92.2181, -1.60950947493338),
(31684, '72189', 218, 4, 10390, 35.2566, 0.615343753058633, -91.1977, -1.59170013524603),
(31685, '72190', 218, 4, 10848, 34.7971, 0.607323965145719, -92.2567, -1.61018317202465),
(31686, '72199', 218, 4, 10848, 34.7883, 0.607170376171543, -92.2559, -1.61016920939064),
(31687, '72201', 218, 4, 3807, 34.7463, 0.606437337885706, -92.2766, -1.6105304925458),
(31688, '72202', 218, 4, 3807, 34.7403, 0.606332618130586, -92.2729, -1.61046591536348),
(31689, '72203', 218, 4, 3807, 34.6347, 0.60448955044048, -92.2269, -1.60966306390756),
(31690, '72204', 218, 4, 3807, 34.7261, 0.606084781376803, -92.3491, -1.6117958562535),
(31691, '72205', 218, 4, 3807, 34.7527, 0.606549038957833, -92.3448, -1.61172080709566),
(31692, '72206', 218, 4, 3807, 34.68, 0.605280184591633, -92.2778, -1.61055143649682),
(31693, '72207', 218, 4, 3807, 34.7719, 0.606884142174216, -92.3588, -1.61196515319094),
(31694, '72209', 218, 4, 3807, 34.6746, 0.605185936812026, -92.3627, -1.61203322103177),
(31695, '72210', 218, 4, 3807, 34.7152, 0.605894540488336, -92.4584, -1.61370350112593),
(31696, '72211', 218, 4, 3807, 34.7608, 0.606690410627245, -92.4437, -1.61344693772588),
(31697, '72212', 218, 4, 3807, 34.7876, 0.607158158866779, -92.42, -1.61303329469316),
(31698, '72214', 218, 4, 3807, 34.7765, 0.606964427319808, -92.2744, -1.61049209530226),
(31699, '72215', 218, 4, 3807, 34.751, 0.606519368360549, -92.3495, -1.6118028375705),
(31700, '72216', 218, 4, 3807, 34.8257, 0.607823129311789, -92.2161, -1.60947456834834),
(31701, '72217', 218, 4, 3807, 34.7747, 0.606933011393272, -92.3583, -1.61195642654468),
(31702, '72219', 218, 4, 3807, 34.6806, 0.605290656567145, -92.3458, -1.61173826038818),
(31703, '72221', 218, 4, 3807, 34.7937, 0.607264623951151, -92.5336, -1.61501598872343),
(31704, '72222', 218, 4, 3807, 34.7219, 0.606011477548219, -92.3539, -1.61187963205759),
(31705, '72223', 218, 4, 3807, 34.7467, 0.606444319202714, -92.2892, -1.61075040403155),
(31706, '72225', 218, 4, 3807, 34.751, 0.606519368360549, -92.3487, -1.61178887493649),
(31707, '72227', 218, 4, 3807, 34.7739, 0.606919048759256, -92.3726, -1.61220600862771),
(31708, '72231', 218, 4, 3807, 34.7471, 0.606451300519722, -92.2791, -1.6105741257771),
(31709, '72260', 218, 4, 3807, 34.7459, 0.606430356568698, -92.2899, -1.61076262133631),
(31710, '72295', 218, 4, 3807, 34.7471, 0.606451300519722, -92.2792, -1.61057587110635),
(31711, '72301', 218, 4, 12754, 35.1476, 0.613441344173959, -90.1781, -1.5739047581927),
(31712, '72303', 218, 4, 12754, 35.1462, 0.613416909564431, -90.1841, -1.57400947794782),
(31713, '72310', 218, 4, 7162, 35.9934, 0.628203338987327, -90.1588, -1.57356790964706),
(31714, '72311', 218, 4, 7206, 34.69, 0.605454717516833, -90.943, -1.5872547816412),
(31715, '72312', 218, 4, 7286, 34.4941, 0.602035617512176, -90.7119, -1.58322132573984),
(31716, '72313', 218, 4, 7292, 35.514, 0.619836230553266, -90.1965, -1.57422589877507),
(31717, '72314', 218, 4, 789, 35.4015, 0.617872735144773, -90.6299, -1.58179015575321),
(31718, '72315', 218, 4, 7570, 35.934, 0.627166613411642, -89.9218, -1.56943147931984),
(31719, '72316', 218, 4, 7570, 35.9276, 0.627054912339515, -89.9185, -1.56937388345452),
(31720, '72319', 218, 4, 9165, 35.9593, 0.627608181712397, -89.9725, -1.5703163612506),
(31721, '72320', 218, 4, 7674, 34.8458, 0.60817394049144, -90.5268, -1.5799907212944),
(31722, '72321', 218, 4, 7782, 35.8159, 0.625105379565037, -89.9389, -1.56972993062193),
(31723, '72322', 218, 4, 1290, 35.1036, 0.612673399303082, -90.7716, -1.58426328730328),
(31724, '72324', 218, 4, 8055, 35.395, 0.617759288743393, -90.7961, -1.58469089297002),
(31725, '72325', 218, 4, 8095, 35.2209, 0.614720670515671, -90.324, -1.57645119357136),
(31726, '72326', 218, 4, 571, 35.1032, 0.612666417986073, -90.771, -1.58425281532777),
(31727, '72327', 218, 4, 8287, 35.2245, 0.614783502368743, -90.326, -1.5764861001564),
(31728, '72328', 218, 4, 8346, 34.1967, 0.596845008316745, -90.9491, -1.58736124672557),
(31729, '72329', 218, 4, 8602, 35.5492, 0.620450586449968, -89.9511, -1.56994286079067),
(31730, '72330', 218, 4, 8645, 35.5951, 0.621251692576634, -90.2168, -1.57458020061322),
(31731, '72331', 218, 4, 8659, 35.2698, 0.615574136519896, -90.462, -1.57885974793911),
(31732, '72332', 218, 4, 8692, 35.1008, 0.612624530084026, -90.3081, -1.57617368622029),
(31733, '72333', 218, 4, 8707, 34.306, 0.598752653189175, -90.8559, -1.58573459986272),
(31734, '72335', 218, 4, 8935, 35.0091, 0.611024063159947, -90.7855, -1.58450588806931),
(31735, '72336', 218, 4, 8935, 35.0149, 0.611125292256562, -90.7851, -1.5844989067523),
(31736, '72338', 218, 4, 9004, 35.4666, 0.619008944487821, -90.0564, -1.57178069249302),
(31737, '72339', 218, 4, 2716, 35.3928, 0.617720891499849, -90.2483, -1.5751299793276),
(31738, '72340', 218, 4, 9160, 34.9673, 0.610294515532613, -90.9946, -1.58815537153523),
(31739, '72341', 218, 4, 3024, 34.8722, 0.608634707413967, -90.7297, -1.5835319943467),
(31740, '72342', 218, 4, 3052, 34.5309, 0.60267789867691, -90.6007, -1.58128051961163),
(31741, '72346', 218, 4, 9447, 35.0661, 0.612018900833584, -90.4666, -1.5789400330847),
(31742, '72347', 218, 4, 3084, 35.4028, 0.617895424425049, -90.9956, -1.58817282482775),
(31743, '72348', 218, 4, 9609, 34.9187, 0.609446285516144, -90.3112, -1.5762277914271),
(31744, '72350', 218, 4, 9781, 35.5125, 0.619810050614486, -90.1464, -1.57335148881982),
(31745, '72351', 218, 4, 9824, 35.6977, 0.62304240038918, -90.0994, -1.57253118407138),
(31746, '72352', 218, 4, 3584, 34.7799, 0.607023768514376, -90.7448, -1.58379553906375),
(31747, '72353', 218, 4, 9970, 34.3976, 0.600351374784001, -90.8648, -1.58588993416614),
(31748, '72354', 218, 4, 10044, 35.6103, 0.621516982622937, -90.3352, -1.57664667044758),
(31749, '72355', 218, 4, 10073, 34.6771, 0.605229570043326, -90.7663, -1.58417078485293),
(31750, '72358', 218, 4, 10240, 35.7559, 0.62405818201384, -89.9306, -1.56958506829401),
(31751, '72359', 218, 4, 3938, 35.0186, 0.611189869438886, -90.8388, -1.58543614856063),
(31752, '72360', 218, 4, 10308, 34.7722, 0.606889378161972, -90.7633, -1.58411842497537),
(31753, '72364', 218, 4, 630, 35.2123, 0.614570572199999, -90.201, -1.57430443859141),
(31754, '72365', 218, 4, 10319, 35.532, 0.620150389818625, -90.4172, -1.57807784043422),
(31755, '72366', 218, 4, 10340, 34.542, 0.602871630223881, -90.9848, -1.58798432926854),
(31756, '72367', 218, 4, 10439, 34.1961, 0.596834536341233, -91.0401, -1.58894949634489),
(31757, '72368', 218, 4, 10602, 34.7664, 0.606788149065357, -90.7642, -1.58413413293864),
(31758, '72369', 218, 4, 10986, 34.3974, 0.600347884125497, -90.8653, -1.5858986608124),
(31759, '72370', 218, 4, 11010, 35.7034, 0.623141884156543, -89.9755, -1.57036872112816),
(31760, '72372', 218, 4, 4839, 34.9544, 0.610069368059106, -90.9043, -1.58657933922068),
(31761, '72373', 218, 4, 11079, 35.2702, 0.615581117836904, -90.5583, -1.58054050000878),
(31762, '72374', 218, 4, 11337, 34.5389, 0.602817525017069, -90.8796, -1.58614824289544),
(31763, '72376', 218, 4, 5236, 35.0825, 0.612305134830911, -90.2463, -1.57509507274256),
(31764, '72377', 218, 4, 11611, 35.5603, 0.62064431799694, -90.4344, -1.57837803706556),
(31765, '72379', 218, 4, 12016, 34.0461, 0.594216542463242, -91.0437, -1.58901232819796),
(31766, '72381', 218, 4, 12351, 35.8137, 0.625066982321493, -89.7572, -1.56655866737105),
(31767, '72383', 218, 4, 6415, 34.5421, 0.602873375553133, -90.9845, -1.58797909328078),
(31768, '72384', 218, 4, 12416, 35.3078, 0.616237361635654, -90.2613, -1.57535687213036),
(31769, '72385', 218, 4, 12431, 35.3765, 0.617436402831774, -90.5068, -1.579641655444),
(31770, '72386', 218, 4, 12438, 35.4838, 0.619309141119164, -90.3695, -1.57724531838102),
(31771, '72387', 218, 4, 12530, 35.2562, 0.615336771741625, -90.8068, -1.58487764319999),
(31772, '72389', 218, 4, 12577, 34.3973, 0.600346138796246, -90.8657, -1.58590564212941),
(31773, '72390', 218, 4, 12750, 34.5451, 0.602925735430693, -90.6448, -1.58205020981176),
(31774, '72391', 218, 4, 6725, 35.5951, 0.621251692576634, -90.2173, -1.57458892725948),
(31775, '72392', 218, 4, 12781, 34.9515, 0.610018753510798, -91.0988, -1.58997400461581),
(31776, '72394', 218, 4, 12847, 35.0227, 0.611261427938218, -90.6854, -1.58275881348807),
(31777, '72395', 218, 4, 565, 35.5709, 0.620829322897651, -90.0424, -1.57153634639774),
(31778, '72396', 218, 4, 12981, 35.2258, 0.614806191649019, -90.7893, -1.58457221058089),
(31779, '72401', 218, 4, 3452, 35.8275, 0.625307837758268, -90.6975, -1.58296999832756),
(31780, '72402', 218, 4, 3452, 35.805, 0.62491513867657, -90.776, -1.58434008179037),
(31781, '72403', 218, 4, 3452, 35.8723, 0.626089745263162, -90.6426, -1.58201181256821),
(31782, '72404', 218, 4, 3452, 35.7981, 0.624794710958182, -90.7142, -1.58326146831264),
(31783, '72410', 218, 4, 7054, 36.1253, 0.630505428270708, -90.9262, -1.58696156632687),
(31784, '72411', 218, 4, 7311, 35.7422, 0.623819071906317, -90.5596, -1.58056318928906),
(31785, '72412', 218, 4, 296, 36.2047, 0.631891219696791, -90.6216, -1.58164529342529),
(31786, '72413', 218, 4, 7482, 36.245, 0.632594587385345, -90.958, -1.587516581029),
(31787, '72414', 218, 4, 7505, 35.837, 0.625473644037208, -90.3657, -1.57717899586944),
(31788, '72415', 218, 4, 7513, 36.1236, 0.630475757673424, -91.1351, -1.59060755913428),
(31789, '72416', 218, 4, 7596, 35.9026, 0.626618580026516, -90.7857, -1.58450937872782),
(31790, '72417', 218, 4, 7701, 35.903, 0.626625561343524, -90.5804, -1.58092621777347),
(31791, '72419', 218, 4, 7901, 35.759, 0.624112287220652, -90.3222, -1.57641977764482),
(31792, '72421', 218, 4, 696, 35.8385, 0.625499823975988, -90.9539, -1.58744502252967),
(31793, '72422', 218, 4, 8235, 36.4112, 0.635495324602159, -90.5889, -1.58107457075989),
(31794, '72424', 218, 4, 8402, 36.3832, 0.635006632411601, -90.7261, -1.58346916249363),
(31795, '72425', 218, 4, 8463, 36.1944, 0.631711450783836, -90.7308, -1.58355119296847),
(31796, '72426', 218, 4, 8468, 35.8559, 0.625803511265835, -90.042, -1.57152936508073),
(31797, '72427', 218, 4, 2242, 35.8665, 0.625988516166546, -90.953, -1.5874293145664),
(31798, '72428', 218, 4, 8785, 35.7176, 0.623389720910327, -90.197, -1.57423462542133),
(31799, '72429', 218, 4, 8891, 35.5114, 0.619790851992714, -90.9303, -1.5870331248262),
(31800, '72430', 218, 4, 9228, 36.3401, 0.634254395503991, -90.2232, -1.57469190168535),
(31801, '72431', 218, 4, 9254, 35.6524, 0.622251766238026, -91.0744, -1.58954814427832),
(31802, '72432', 218, 4, 2994, 35.5616, 0.620667007277215, -90.7211, -1.58338189603103),
(31803, '72433', 218, 4, 9601, 36.0469, 0.629137090137144, -90.9767, -1.58784295759913),
(31804, '72434', 218, 4, 9641, 36.1823, 0.631500265944344, -91.1949, -1.59165126602698),
(31805, '72435', 218, 4, 9890, 36.3143, 0.633804100556977, -90.5875, -1.58105013615036),
(31806, '72436', 218, 4, 9924, 36.2256, 0.632255993510458, -90.5178, -1.57983364166172),
(31807, '72437', 218, 4, 9930, 35.8184, 0.625149012796337, -90.4389, -1.5784565768819),
(31808, '72438', 218, 4, 10004, 35.9319, 0.62712996149735, -90.2542, -1.57523295375347),
(31809, '72439', 218, 4, 10092, 36.0701, 0.629542006523607, -90.7478, -1.58384789894131),
(31810, '72440', 218, 4, 3914, 35.9976, 0.628276642815911, -91.2464, -1.59255011059175),
(31811, '72441', 218, 4, 10393, 36.3831, 0.635004887082349, -90.3936, -1.57766594273075),
(31812, '72442', 218, 4, 3968, 35.8857, 0.626323619382929, -90.1659, -1.57369182802396),
(31813, '72443', 218, 4, 10321, 36.188, 0.631599749711708, -90.3848, -1.57751235375657),
(31814, '72444', 218, 4, 4057, 36.4235, 0.635710000100155, -90.9008, -1.58651825269686),
(31815, '72445', 218, 4, 10526, 35.9697, 0.627789695954604, -91.0255, -1.5886946782741),
(31816, '72447', 218, 4, 10554, 35.882, 0.626259042200605, -90.3494, -1.57689450720136),
(31817, '72449', 218, 4, 10874, 36.1832, 0.631515973907612, -90.8327, -1.58532968347625),
(31818, '72450', 218, 4, 11066, 36.0574, 0.629320349708603, -90.5012, -1.57954391700589),
(31819, '72451', 218, 4, 11066, 36.0582, 0.629334312342619, -90.4999, -1.57952122772562),
(31820, '72453', 218, 4, 11118, 36.2802, 0.633208943282047, -90.665, -1.58240276632066),
(31821, '72454', 218, 4, 11191, 36.3833, 0.635008377740853, -90.1933, -1.574170048239),
(31822, '72455', 218, 4, 5158, 36.2655, 0.632952379882004, -90.977, -1.58784819358688),
(31823, '72456', 218, 4, 342, 36.4433, 0.636055575292049, -90.2692, -1.57549475314127),
(31824, '72457', 218, 4, 11342, 36.0816, 0.629742719387586, -91.0637, -1.58936139404836),
(31825, '72458', 218, 4, 5207, 36.0537, 0.62925577252628, -91.1486, -1.5908431785833),
(31826, '72459', 218, 4, 11474, 36.1842, 0.631533427200132, -91.2857, -1.59323602498779),
(31827, '72460', 218, 4, 11475, 36.3613, 0.634624405305414, -91.2428, -1.59248727873868),
(31828, '72461', 218, 4, 11485, 36.2626, 0.632901765333696, -90.2931, -1.57591188683249),
(31829, '72462', 218, 4, 11549, 36.3611, 0.63462091464691, -90.7581, -1.58402766785427),
(31830, '72464', 218, 4, 11751, 36.4552, 0.636263269473037, -90.1429, -1.573290402296),
(31831, '72465', 218, 4, 11850, 35.9857, 0.628068948634923, -90.8814, -1.58617965882197),
(31832, '72466', 218, 4, 12002, 36.0954, 0.629983574824361, -91.2745, -1.59304054811156),
(31833, '72467', 218, 4, 0, 35.8497, 0.625695300852211, -90.679, -1.58264711241594),
(31834, '72469', 218, 4, 6113, 35.9723, 0.627835074515156, -91.3926, -1.59510178195817),
(31835, '72470', 218, 4, 12168, 36.4544, 0.636249306839021, -90.7233, -1.58342029327457),
(31836, '72471', 218, 4, 12240, 35.8376, 0.62548411601272, -91.1198, -1.59034052375873),
(31837, '72472', 218, 4, 12392, 35.674, 0.622628757356457, -90.5201, -1.57987378423452),
(31838, '72473', 218, 4, 12397, 35.7324, 0.623648029639622, -91.201, -1.59175773111135),
(31839, '72474', 218, 4, 354, 36.0425, 0.629060295650056, -90.6706, -1.58250050475877),
(31840, '72475', 218, 4, 12592, 35.5649, 0.620724603142531, -90.9344, -1.58710468332553),
(31841, '72476', 218, 4, 12633, 36.0698, 0.629536770535851, -90.9592, -1.58753752498003),
(31842, '72478', 218, 4, 6631, 36.4679, 0.63648492628804, -91.0425, -1.58899138424694),
(31843, '72479', 218, 4, 12729, 35.6431, 0.622089450617591, -90.9302, -1.58703137949695),
(31844, '72482', 218, 4, 12871, 36.3172, 0.633854715105285, -91.3913, -1.59507909267789),
(31845, '72501', 218, 4, 7298, 35.7715, 0.624330453377152, -91.6374, -1.59937434796705),
(31846, '72503', 218, 4, 7298, 35.7267, 0.623548545872258, -91.6729, -1.59999393985151),
(31847, '72512', 218, 4, 9583, 36.2252, 0.63224901219345, -91.7515, -1.60136576864358),
(31848, '72513', 218, 4, 7173, 36.2241, 0.632229813571678, -91.612, -1.59893103433705),
(31849, '72515', 218, 4, 681, 36.301, 0.633571971766462, -91.9779, -1.60531719407009),
(31850, '72516', 218, 4, 7613, 36.0092, 0.628479101009142, -92.033, -1.60627887048794),
(31851, '72517', 218, 4, 7698, 36.1319, 0.630620620001339, -91.9633, -1.6050623759993),
(31852, '72519', 218, 4, 7847, 36.1541, 0.631008083095282, -92.019, -1.60603452439266),
(31853, '72520', 218, 4, 7862, 36.3922, 0.63516371204428, -91.7281, -1.60095736159861),
(31854, '72521', 218, 4, 7965, 35.8947, 0.626480699015609, -91.5062, -1.59708447598844),
(31855, '72522', 218, 4, 8042, 35.7979, 0.624791220299678, -91.465, -1.59636540033661),
(31856, '72523', 218, 4, 698, 35.621, 0.6217037328529, -91.782, -1.60189809406544),
(31857, '72524', 218, 4, 8223, 35.8311, 0.62537066961134, -91.3495, -1.59434954505056),
(31858, '72525', 218, 4, 1524, 36.2882, 0.633348569622206, -91.5959, -1.59865003632747),
(31859, '72526', 218, 4, 8368, 35.8775, 0.626180502384266, -91.7599, -1.60151237630074),
(31860, '72527', 218, 4, 8496, 35.7315, 0.623632321676354, -91.6835, -1.60017894475222),
(31861, '72528', 218, 4, 8553, 36.228, 0.632297881412506, -92.106, -1.6075529608419),
(31862, '72529', 218, 4, 1524, 36.298, 0.633519611888902, -91.5385, -1.59764821733683),
(31863, '72530', 218, 4, 8592, 35.5121, 0.619803069297478, -92.0316, -1.60625443587841),
(31864, '72531', 218, 4, 8719, 36.3145, 0.633807591215481, -92.0958, -1.60737493725819),
(31865, '72532', 218, 4, 8797, 36.0946, 0.629969612190345, -91.5795, -1.59836380233015),
(31866, '72533', 218, 4, 0, 36.0244, 0.628744391055445, -92.2239, -1.60961070403),
(31867, '72534', 218, 4, 8912, 35.6023, 0.621377356282777, -91.7305, -1.60099924950066),
(31868, '72536', 218, 4, 2595, 36.122, 0.630447832405392, -91.8085, -1.60236060631721),
(31869, '72537', 218, 4, 9040, 36.3657, 0.634701199792502, -92.4633, -1.61378902225927),
(31870, '72538', 218, 4, 319, 36.4412, 0.636018923377758, -92.0979, -1.60741158917249),
(31871, '72539', 218, 4, 2739, 36.2923, 0.633420128121538, -91.7757, -1.60178813832256),
(31872, '72540', 218, 4, 9258, 35.958, 0.627585492432121, -91.9392, -1.60464175164957),
(31873, '72542', 218, 4, 2973, 36.2567, 0.632798790907828, -91.542, -1.59770930386065),
(31874, '72543', 218, 4, 9403, 35.4964, 0.619529052604915, -92.0334, -1.60628585180495),
(31875, '72544', 218, 4, 23, 36.3488, 0.634406239148915, -92.2333, -1.60977476497969),
(31876, '72545', 218, 4, 9403, 35.4875, 0.619373718301488, -92.055, -1.60666284292338),
(31877, '72546', 218, 4, 9638, 35.5973, 0.621290089820177, -91.9482, -1.60479883128225),
(31878, '72550', 218, 4, 901, 35.7226, 0.623476987372926, -91.7642, -1.60158742545858),
(31879, '72553', 218, 4, 10267, 35.7037, 0.623147120144299, -91.4813, -1.59664988900469),
(31880, '72554', 218, 4, 10280, 36.4985, 0.63701899703915, -91.5403, -1.59767963326337),
(31881, '72555', 218, 4, 10305, 35.7501, 0.623956952917225, -91.9439, -1.60472378212441),
(31882, '72556', 218, 4, 10438, 36.0624, 0.629407616171203, -91.9002, -1.60396107324129),
(31883, '72557', 218, 4, 10552, 36.4643, 0.636422094434968, -91.8592, -1.60324548824798),
(31884, '72560', 218, 4, 4440, 35.8655, 0.625971062874026, -92.1251, -1.60788631872903),
(31885, '72561', 218, 4, 118, 35.9645, 0.627698938833501, -91.8075, -1.60234315302469),
(31886, '72562', 218, 4, 10792, 35.7298, 0.62360265107907, -91.4335, -1.59581562162224),
(31887, '72564', 218, 4, 10928, 35.6095, 0.621503019988921, -91.4384, -1.59590114275558),
(31888, '72565', 218, 4, 4828, 36.2144, 0.632060516634234, -91.9193, -1.60429443112842),
(31889, '72566', 218, 4, 5077, 36.1742, 0.631358894274933, -92.0927, -1.60732083205138),
(31890, '72567', 218, 4, 5115, 35.8445, 0.625604543731107, -91.927, -1.60442882148083),
(31891, '72568', 218, 4, 5141, 35.5635, 0.620700168533003, -91.6303, -1.59925042959016),
(31892, '72569', 218, 4, 11355, 36.082, 0.629749700704594, -91.4347, -1.59583656557326),
(31893, '72571', 218, 4, 112244, 35.6463, 0.622145301153655, -91.531, -1.59751731764293),
(31894, '72572', 218, 4, 11745, 35.9169, 0.626868162109551, -91.3016, -1.59351353233885),
(31895, '72573', 218, 4, 11746, 36.0414, 0.629041097028284, -91.8199, -1.60255957385194),
(31896, '72575', 218, 4, 97739, 35.6917, 0.62293768063406, -91.5922, -1.59858545914515),
(31897, '72576', 218, 4, 126, 36.37, 0.634776248950338, -91.826, -1.60266603893631),
(31898, '72577', 218, 4, 5844, 35.9845, 0.628048004683899, -91.6377, -1.59937958395481),
(31899, '72578', 218, 4, 6121, 36.4661, 0.636453510361504, -91.9908, -1.6055423415436),
(31900, '72579', 218, 4, 12183, 35.7997, 0.624822636226214, -91.4758, -1.59655389589583),
(31901, '72581', 218, 4, 12402, 35.552, 0.620499455669024, -91.9497, -1.60482501122103),
(31902, '72583', 218, 4, 12571, 36.3869, 0.635071209593925, -91.993, -1.60558073878714),
(31903, '72584', 218, 4, 12572, 36.1616, 0.631138982789181, -91.8525, -1.60312855118809),
(31904, '72585', 218, 4, 12846, 36.2143, 0.632058771304983, -92.0071, -1.60582683021167),
(31905, '72587', 218, 4, 12912, 36.225, 0.632245521534946, -91.8554, -1.6031791657364),
(31906, '72601', 218, 4, 9353, 36.2382, 0.632475904996209, -93.1143, -1.62515111568976),
(31907, '72602', 218, 4, 9353, 36.2239, 0.632226322913174, -93.1157, -1.62517555029928),
(31908, '72610', 218, 4, 7046, 35.894, 0.626468481710845, -92.3838, -1.61240148550394),
(31909, '72611', 218, 4, 7071, 36.2994, 0.63354404649843, -93.2713, -1.62789128261539),
(31910, '72613', 218, 4, 7346, 36.3844, 0.635027576362625, -93.6203, -1.63398248170485),
(31911, '72615', 218, 4, 7418, 36.2617, 0.632886057370428, -93.1061, -1.62500799869109),
(31912, '72616', 218, 4, 7422, 36.369, 0.634758795657818, -93.566, -1.63303476792101),
(31913, '72617', 218, 4, 7466, 36.0326, 0.628887508054109, -92.3589, -1.61196689852019),
(31914, '72619', 218, 4, 7772, 36.384, 0.635020595045617, -92.5788, -1.61580487754533);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(31915, '72623', 218, 4, 8096, 36.4511, 0.636191710973705, -92.3488, -1.61179062026574),
(31916, '72624', 218, 4, 1738, 36.0841, 0.629786352618886, -93.306, -1.62849691186583),
(31917, '72626', 218, 4, 8239, 36.3183, 0.633873913727057, -92.5351, -1.6150421686622),
(31918, '72628', 218, 4, 8451, 35.8415, 0.625552183853548, -93.3506, -1.62927532871222),
(31919, '72629', 218, 4, 8479, 35.7216, 0.623459534080406, -92.5881, -1.61596719316576),
(31920, '72630', 218, 4, 8508, 36.4556, 0.636270250790045, -92.9154, -1.62167965580754),
(31921, '72631', 218, 4, 8793, 36.3993, 0.635287630421172, -93.7373, -1.63602451692968),
(31922, '72632', 218, 4, 8793, 36.4427, 0.636045103316538, -93.7408, -1.6360856034535),
(31923, '72633', 218, 4, 8806, 36.155, 0.63102379105855, -92.915, -1.62167267449053),
(31924, '72634', 218, 4, 8910, 36.2828, 0.633254321842599, -92.594, -1.61607016759163),
(31925, '72635', 218, 4, 9071, 36.279, 0.633187999331023, -92.4981, -1.61439639683897),
(31926, '72636', 218, 4, 2713, 35.9656, 0.627718137455273, -92.8115, -1.61986625871472),
(31927, '72638', 218, 4, 9209, 36.3361, 0.634184582333912, -93.4351, -1.63075013193015),
(31928, '72639', 218, 4, 9348, 35.9845, 0.628048004683899, -92.4928, -1.61430389438861),
(31929, '72640', 218, 4, 325, 36.015, 0.628580330105758, -93.0435, -1.62391542257934),
(31930, '72641', 218, 4, 738, 36.0044, 0.628395325205046, -93.2179, -1.62695927679482),
(31931, '72642', 218, 4, 3619, 36.387, 0.635072954923177, -92.5186, -1.61475418933563),
(31932, '72644', 218, 4, 10005, 36.4689, 0.63650237958056, -92.9126, -1.62163078658848),
(31933, '72645', 218, 4, 10047, 35.8219, 0.625210099320157, -92.5843, -1.61590087065419),
(31934, '72648', 218, 4, 95995, 36.0845, 0.629793333935894, -93.1495, -1.62576547158646),
(31935, '72650', 218, 4, 4011, 35.9408, 0.627285295800778, -92.6544, -1.61712434645983),
(31936, '72651', 218, 4, 41, 36.2894, 0.63336951357323, -92.4383, -1.61335268994627),
(31937, '72653', 218, 4, 4432, 36.3375, 0.634209016943439, -92.3767, -1.61227756712705),
(31938, '72654', 218, 4, 4432, 36.3356, 0.634175855687652, -92.3847, -1.61241719346721),
(31939, '72655', 218, 4, 10635, 35.8552, 0.625791293961071, -93.0535, -1.62408995550454),
(31940, '72657', 218, 4, 12326, 35.8967, 0.626515605600649, -92.25, -1.61006623496477),
(31941, '72658', 218, 4, 10825, 36.164, 0.631180870691229, -92.2633, -1.61029836375528),
(31942, '72659', 218, 4, 10825, 36.2087, 0.631961032866871, -92.2821, -1.61062648565466),
(31943, '72660', 218, 4, 4662, 36.46, 0.636347045277133, -93.4322, -1.63069951738185),
(31944, '72661', 218, 4, 4710, 36.449, 0.636155059059413, -92.5733, -1.61570888443647),
(31945, '72662', 218, 4, 4786, 36.4559, 0.636275486777801, -93.1723, -1.62616340665591),
(31946, '72663', 218, 4, 338, 35.9438, 0.627337655678338, -92.3323, -1.61150264093916),
(31947, '72666', 218, 4, 11092, 35.9393, 0.627259115861998, -93.282, -1.62807803284535),
(31948, '72668', 218, 4, 11128, 36.4192, 0.635634950942319, -92.7679, -1.61910529516085),
(31949, '72669', 218, 4, 11201, 36.0722, 0.629578658437899, -92.8897, -1.62123110618978),
(31950, '72670', 218, 4, 11327, 36.0516, 0.629219120611988, -93.4105, -1.63032078093416),
(31951, '72672', 218, 4, 11436, 36.2168, 0.632102404536282, -92.7404, -1.61862532961655),
(31952, '72675', 218, 4, 11757, 35.9652, 0.627711156138265, -92.812, -1.61987498536098),
(31953, '72677', 218, 4, 6151, 36.2163, 0.632093677890022, -92.7396, -1.61861136698253),
(31954, '72679', 218, 4, 12321, 35.6976, 0.623040655059928, -92.8648, -1.62079651920603),
(31955, '72680', 218, 4, 12326, 35.8428, 0.625574873133824, -92.3565, -1.61192501061814),
(31956, '72682', 218, 4, 12510, 36.144, 0.63083180484083, -92.9806, -1.62281761047984),
(31957, '72683', 218, 4, 12542, 35.9445, 0.627349872983102, -93.1097, -1.62507083054416),
(31958, '72685', 218, 4, 12771, 36.0414, 0.629041097028284, -92.9867, -1.62292407556421),
(31959, '72686', 218, 4, 12917, 35.789, 0.624635885996251, -92.8337, -1.62025372180866),
(31960, '72687', 218, 4, 12997, 36.2269, 0.632278682790734, -92.6831, -1.61762525595516),
(31961, '72701', 218, 4, 2428, 36.066, 0.629470448024275, -94.1558, -1.64332871984928),
(31962, '72702', 218, 4, 2428, 36.0609, 0.629381436232423, -94.1612, -1.64342296762888),
(31963, '72703', 218, 4, 2428, 36.0979, 0.630027208055661, -94.152, -1.6432623973377),
(31964, '72704', 218, 4, 2428, 36.08, 0.629714794119554, -94.2015, -1.64412633531744),
(31965, '72711', 218, 4, 7207, 36.3529, 0.634477797648247, -94.0446, -1.64138791372106),
(31966, '72712', 218, 4, 647, 36.3743, 0.634851298108173, -94.2101, -1.64427643363311),
(31967, '72714', 218, 4, 7379, 36.4681, 0.636488416946544, -94.244, -1.64486810024954),
(31968, '72715', 218, 4, 7379, 36.4681, 0.636488416946544, -94.2941, -1.64574251020479),
(31969, '72716', 218, 4, 647, 36.323, 0.6339559442019, -94.1813, -1.64377377880854),
(31970, '72717', 218, 4, 7882, 35.9099, 0.626745989061912, -94.3799, -1.647240002703),
(31971, '72718', 218, 4, 1404, 36.2744, 0.633107714185431, -94.2018, -1.64413157130519),
(31972, '72719', 218, 4, 8007, 36.371, 0.634793702242858, -94.3159, -1.64612299198172),
(31973, '72721', 218, 4, 8196, 35.847, 0.625648176962407, -93.8196, -1.63746092290407),
(31974, '72722', 218, 4, 2007, 36.3418, 0.634284066101275, -94.4401, -1.6482906909127),
(31975, '72727', 218, 4, 8723, 36.0534, 0.629250536538524, -93.9945, -1.64051350376581),
(31976, '72728', 218, 4, 8740, 36.2057, 0.631908672989311, -94.2334, -1.64468309534882),
(31977, '72729', 218, 4, 2341, 35.8006, 0.624838344189482, -94.4764, -1.64892424543117),
(31978, '72730', 218, 4, 8849, 36.0438, 0.629082984930332, -94.2379, -1.64476163516516),
(31979, '72732', 218, 4, 9050, 36.3908, 0.635139277434752, -93.9113, -1.63906138982815),
(31980, '72733', 218, 4, 9075, 36.4767, 0.636638515262216, -93.919, -1.63919578018055),
(31981, '72734', 218, 4, 9081, 36.2698, 0.633027429039839, -94.4849, -1.64907259841759),
(31982, '72735', 218, 4, 419, 36.1003, 0.630069095957709, -93.9885, -1.64040878401069),
(31983, '72736', 218, 4, 9198, 36.4214, 0.635673348185863, -94.4496, -1.64845649719164),
(31984, '72737', 218, 4, 9223, 35.995, 0.628231264255359, -94.175, -1.64366382306566),
(31985, '72738', 218, 4, 9516, 36.1408, 0.630775954304767, -93.8683, -1.63831089824979),
(31986, '72739', 218, 4, 9519, 36.4772, 0.636647241908476, -94.3292, -1.64635512077224),
(31987, '72740', 218, 4, 3297, 36.086, 0.629819513874674, -93.7335, -1.63595819441811),
(31988, '72741', 218, 4, 364, 36.1304, 0.630594440062559, -94.1642, -1.64347532750644),
(31989, '72742', 218, 4, 3542, 36.0388, 0.628995718467733, -93.4995, -1.63187412396844),
(31990, '72744', 218, 4, 3781, 35.951, 0.627463319384481, -94.4125, -1.64780898003915),
(31991, '72745', 218, 4, 10211, 36.2589, 0.632837188151372, -94.1311, -1.64289762352403),
(31992, '72747', 218, 4, 4063, 36.3998, 0.635296357067432, -94.5739, -1.65062594145187),
(31993, '72749', 218, 4, 587, 35.8559, 0.625803511265835, -94.4316, -1.64814233792628),
(31994, '72751', 218, 4, 4907, 36.4491, 0.636156804388665, -94.1178, -1.64266549473352),
(31995, '72752', 218, 4, 11161, 35.8396, 0.62551902259776, -93.5964, -1.63356534801362),
(31996, '72753', 218, 4, 11369, 35.9777, 0.627929322294764, -94.3171, -1.64614393593274),
(31997, '72756', 218, 4, 874, 36.3238, 0.633969906835916, -94.0244, -1.64103535721216),
(31998, '72757', 218, 4, 874, 36.3337, 0.634142694431864, -94.1244, -1.64278068646415),
(31999, '72758', 218, 4, 874, 36.3314, 0.634102551859068, -94.1272, -1.64282955568321),
(32000, '72760', 218, 4, 11759, 35.8569, 0.625820964558355, -93.7226, -1.63576795352964),
(32001, '72761', 218, 4, 11944, 36.1823, 0.631500265944344, -94.5404, -1.65004125615245),
(32002, '72762', 218, 4, 6023, 36.1827, 0.631507247261352, -94.1656, -1.64349976211597),
(32003, '72764', 218, 4, 6023, 36.1775, 0.631416490140249, -94.1456, -1.64315069626557),
(32004, '72765', 218, 4, 6023, 36.1958, 0.631735885393364, -94.1008, -1.64236878876068),
(32005, '72766', 218, 4, 6023, 36.1871, 0.63158404174844, -94.1287, -1.64285573562199),
(32006, '72768', 218, 4, 6137, 36.4779, 0.63665945921324, -94.4611, -1.64865721005562),
(32007, '72769', 218, 4, 12200, 36.0233, 0.628725192433673, -94.4995, -1.64932741648838),
(32008, '72770', 218, 4, 12354, 36.189, 0.631617203004228, -94.2268, -1.64456790361819),
(32009, '72773', 218, 4, 638, 35.9262, 0.627030477729987, -93.9073, -1.63899157665807),
(32010, '72774', 218, 4, 12747, 35.9312, 0.627117744192586, -94.181, -1.64376854282078),
(32011, '72776', 218, 4, 12915, 35.9413, 0.627294022447038, -93.606, -1.63373289962181),
(32012, '72801', 218, 4, 5585, 35.2817, 0.615781830700883, -93.1388, -1.62557872135649),
(32013, '72802', 218, 4, 5585, 35.3165, 0.616389205280577, -93.0896, -1.62472001936451),
(32014, '72811', 218, 4, 5585, 35.2758, 0.615678856275016, -93.1316, -1.62545305765035),
(32015, '72812', 218, 4, 5585, 35.2239, 0.614773030393231, -93.1193, -1.62523838215236),
(32016, '72820', 218, 4, 7055, 35.5066, 0.619707076188619, -93.8455, -1.63791296318034),
(32017, '72821', 218, 4, 7080, 35.4431, 0.618598792113602, -93.7632, -1.63647655720595),
(32018, '72823', 218, 4, 7186, 35.2473, 0.615181437438197, -92.9328, -1.62198334309739),
(32019, '72824', 218, 4, 263, 35.1104, 0.612792081692217, -93.4564, -1.63112188706083),
(32020, '72826', 218, 4, 984, 35.1443, 0.613383748308643, -93.7187, -1.63569988568881),
(32021, '72827', 218, 4, 1018, 34.8979, 0.609083257031729, -93.5987, -1.63360549058642),
(32022, '72828', 218, 4, 7677, 34.9064, 0.609231610018149, -93.5189, -1.63221271784333),
(32023, '72829', 218, 4, 1459, 35.1671, 0.613781683378098, -93.2249, -1.62708144984246),
(32024, '72830', 218, 4, 848, 35.4671, 0.619017671134081, -93.4719, -1.63139241309489),
(32025, '72832', 218, 4, 8153, 35.4364, 0.618481855053719, -93.6706, -1.6348603823186),
(32026, '72833', 218, 4, 1964, 35.0683, 0.612057298077128, -93.3763, -1.62972387832998),
(32027, '72834', 218, 4, 8399, 35.221, 0.614722415844923, -93.1581, -1.62591556990213),
(32028, '72835', 218, 4, 8461, 35.2393, 0.615041811098038, -93.4426, -1.63088103162405),
(32029, '72837', 218, 4, 8583, 35.3717, 0.617352627027678, -93.1182, -1.62521918353058),
(32030, '72838', 218, 4, 9193, 34.8903, 0.608950612008578, -93.6727, -1.63489703423289),
(32031, '72839', 218, 4, 9283, 35.5243, 0.620015999466222, -93.339, -1.62907287051899),
(32032, '72840', 218, 4, 9366, 35.4416, 0.618572612174822, -93.6652, -1.63476613453899),
(32033, '72841', 218, 4, 9372, 34.864, 0.608491590415303, -93.7624, -1.63646259457193),
(32034, '72842', 218, 4, 3010, 35.0978, 0.612572170206466, -93.6079, -1.6337660608776),
(32035, '72843', 218, 4, 3049, 35.5085, 0.619740237444406, -92.9737, -1.62269718276145),
(32036, '72845', 218, 4, 3570, 35.3699, 0.617321211101142, -93.3642, -1.62951269349049),
(32037, '72846', 218, 4, 244, 35.436, 0.618474873736711, -93.3941, -1.63003454693684),
(32038, '72847', 218, 4, 3852, 35.341, 0.616816810947316, -93.2364, -1.62728216270644),
(32039, '72851', 218, 4, 10757, 35.3305, 0.616633551375857, -93.4432, -1.63089150359957),
(32040, '72852', 218, 4, 10918, 35.7136, 0.623319907740247, -93.577, -1.63322675413873),
(32041, '72853', 218, 4, 10934, 35.0442, 0.611636673727397, -93.1831, -1.62635190221513),
(32042, '72854', 218, 4, 11044, 35.6739, 0.622627012027205, -93.4313, -1.63068380941858),
(32043, '72855', 218, 4, 11069, 35.2918, 0.615958108955335, -93.7258, -1.6358238040657),
(32044, '72856', 218, 4, 0, 35.6891, 0.622892302073508, -93.0549, -1.62411439011407),
(32045, '72857', 218, 4, 5102, 34.9874, 0.610645326712264, -93.298, -1.62835728552567),
(32046, '72858', 218, 4, 11354, 35.2143, 0.614605478785039, -92.9937, -1.62304624861185),
(32047, '72860', 218, 4, 11706, 34.9359, 0.609746482147487, -93.4048, -1.6302212971668),
(32048, '72863', 218, 4, 5701, 35.3303, 0.616630060717353, -93.5425, -1.6326246155468),
(32049, '72865', 218, 4, 12167, 35.327, 0.616572464852037, -93.6356, -1.6342495170804),
(32050, '72901', 218, 4, 8940, 35.3693, 0.61731073912563, -94.4144, -1.64784214129493),
(32051, '72902', 218, 4, 8940, 35.3181, 0.616417130548609, -94.3557, -1.64681763302401),
(32052, '72903', 218, 4, 8940, 35.3427, 0.6168464815446, -94.3752, -1.64715797222815),
(32053, '72904', 218, 4, 8940, 35.4054, 0.6179408029856, -94.3891, -1.64740057299418),
(32054, '72905', 218, 4, 8940, 35.2863, 0.615862115846475, -94.277, -1.64544405890269),
(32055, '72906', 218, 4, 8940, 35.3316, 0.616652749997629, -94.3997, -1.64758557789489),
(32056, '72908', 218, 4, 8940, 35.2985, 0.616075046015218, -94.4079, -1.64772869489355),
(32057, '72913', 218, 4, 8940, 35.3814, 0.617521923965122, -94.3765, -1.64718066150843),
(32058, '72914', 218, 4, 8940, 35.3858, 0.617598718452209, -94.3978, -1.6475524166391),
(32059, '72916', 218, 4, 8940, 35.3275, 0.616581191498297, -94.4243, -1.64801492889088),
(32060, '72917', 218, 4, 8940, 35.3305, 0.616633551375857, -94.3779, -1.64720509611796),
(32061, '72918', 218, 4, 8940, 35.3021, 0.61613787786829, -94.4105, -1.64777407345411),
(32062, '72919', 218, 4, 8940, 35.351, 0.616991343872515, -94.3503, -1.64672338524441),
(32063, '72921', 218, 4, 7066, 35.4883, 0.619387680935504, -94.2271, -1.64457313960595),
(32064, '72923', 218, 4, 7270, 35.3308, 0.616638787363613, -94.3066, -1.64596067636128),
(32065, '72924', 218, 4, 7296, 34.9218, 0.609500390722956, -94.3948, -1.64750005676154),
(32066, '72926', 218, 4, 7587, 34.7145, 0.605882323183572, -94.0257, -1.64105804649243),
(32067, '72927', 218, 4, 1048, 35.1389, 0.613289500529035, -93.9202, -1.63921672413158),
(32068, '72928', 218, 4, 7649, 35.2874, 0.615881314468247, -93.9437, -1.6396268765058),
(32069, '72930', 218, 4, 7972, 35.4564, 0.618830920904118, -93.504, -1.63195266378478),
(32070, '72932', 218, 4, 1435, 35.6083, 0.621482076037897, -94.3268, -1.64631323287019),
(32071, '72933', 218, 4, 8039, 35.299, 0.616083772661478, -94.04, -1.64130762857547),
(32072, '72934', 218, 4, 8056, 35.704, 0.623152356132055, -94.2376, -1.64475639917741),
(32073, '72935', 218, 4, 8642, 35.4993, 0.619579667153223, -94.1884, -1.64389769718543),
(32074, '72936', 218, 4, 2869, 35.215, 0.614617696089803, -94.2607, -1.64515957023462),
(32075, '72937', 218, 4, 9281, 35.1874, 0.614135985216253, -94.4107, -1.64777756411261),
(32076, '72938', 218, 4, 2998, 35.0044, 0.610942032685103, -94.3921, -1.64745293287174),
(32077, '72940', 218, 4, 9621, 35.0835, 0.612322588123431, -94.2585, -1.64512117299108),
(32078, '72941', 218, 4, 3690, 35.3371, 0.616748743106488, -94.1677, -1.64353641403026),
(32079, '72943', 218, 4, 3946, 35.1693, 0.613820080621642, -93.7877, -1.63690416287269),
(32080, '72944', 218, 4, 3975, 35.0212, 0.611235247999438, -94.202, -1.6441350619637),
(32081, '72945', 218, 4, 10461, 35.1071, 0.612734485826901, -94.3605, -1.64690140882811),
(32082, '72946', 218, 4, 10696, 35.6263, 0.621796235303256, -94.0857, -1.64210524404363),
(32083, '72947', 218, 4, 4454, 35.5018, 0.619623300384523, -94.0559, -1.64158513592653),
(32084, '72948', 218, 4, 10733, 35.6954, 0.623002257816384, -94.4216, -1.64796780500108),
(32085, '72949', 218, 4, 4832, 35.4911, 0.61943655015456, -93.837, -1.63776461019392),
(32086, '72950', 218, 4, 11080, 34.7961, 0.607306511853199, -93.8766, -1.63845576057771),
(32087, '72951', 218, 4, 11471, 35.2584, 0.615375168985169, -93.8339, -1.63771050498711),
(32088, '72952', 218, 4, 11724, 35.4638, 0.618960075268765, -94.3184, -1.64616662521302),
(32089, '72955', 218, 4, 6475, 35.5878, 0.621124283541238, -94.4348, -1.64819818846234),
(32090, '72956', 218, 4, 12525, 35.4438, 0.618611009418366, -94.3426, -1.646588994892),
(32091, '72957', 218, 4, 12525, 35.4364, 0.618481855053719, -94.3524, -1.6467600371587),
(32092, '72958', 218, 4, 12596, 34.897, 0.609067549068461, -94.0908, -1.64219425583548),
(32093, '72959', 218, 4, 567, 35.8124, 0.625044293041217, -94.1047, -1.64243685660151),
(32094, '73001', 218, 42, 7042, 35.2382, 0.615022612476266, -98.4242, -1.7178263536414),
(32095, '73002', 218, 42, 74959, 34.9146, 0.609374727016812, -97.7797, -1.7065777066123),
(32096, '73003', 218, 42, 2234, 35.6609, 0.622400119224446, -97.5081, -1.70183739236388),
(32097, '73004', 218, 42, 74987, 35.1312, 0.613155110176632, -97.7877, -1.70671733295246),
(32098, '73005', 218, 42, 74995, 35.0704, 0.612093949991419, -98.2475, -1.71474235685313),
(32099, '73006', 218, 42, 75002, 34.8935, 0.609006462544641, -98.3607, -1.71671806956639),
(32100, '73007', 218, 42, 7137, 35.67, 0.622558944186377, -97.3284, -1.69870103569805),
(32101, '73008', 218, 42, 7428, 35.5053, 0.619684386908343, -97.6413, -1.70416217092754),
(32102, '73009', 218, 42, 75132, 35.3121, 0.61631241079349, -98.3498, -1.71652782867792),
(32103, '73010', 218, 42, 13397, 35.1352, 0.613224923346712, -97.6478, -1.70427561732892),
(32104, '73011', 218, 42, 694, 34.8585, 0.608395597306443, -97.7218, -1.70556716097539),
(32105, '73012', 218, 42, 75205, 34.6087, 0.604035764834961, -97.8172, -1.7072322050818),
(32106, '73013', 218, 42, 2234, 35.6217, 0.621715950157664, -97.4707, -1.70118463922364),
(32107, '73014', 218, 42, 1298, 35.5365, 0.620228929634965, -98.0879, -1.71195681136695),
(32108, '73015', 218, 42, 19794, 35.1036, 0.612673399303082, -98.6024, -1.72093653036846),
(32109, '73016', 218, 42, 75359, 35.7994, 0.624817400238458, -97.6781, -1.70480445209227),
(32110, '73017', 218, 42, 75384, 34.9364, 0.609755208793747, -98.1397, -1.71286089191948),
(32111, '73018', 218, 42, 75427, 35.0356, 0.611486575411725, -97.9493, -1.70953778502368),
(32112, '73019', 218, 42, 4593, 35.2095, 0.614521702980943, -97.4432, -1.70070467367934),
(32113, '73020', 218, 42, 8073, 35.463, 0.618946112634749, -97.2631, -1.6975613356965),
(32114, '73021', 218, 42, 1714, 35.3337, 0.61668940191192, -98.6761, -1.72222283802718),
(32115, '73022', 218, 42, 75509, 35.6161, 0.621618211719552, -97.9942, -1.71032143785783),
(32116, '73023', 218, 42, 75427, 35.0424, 0.611605257800861, -97.9366, -1.70931612820868),
(32117, '73024', 218, 42, 75530, 35.3781, 0.617464328099806, -98.7822, -1.72407463236354),
(32118, '73026', 218, 42, 4593, 35.2226, 0.614750341112955, -97.4395, -1.70064009649701),
(32119, '73027', 218, 42, 75557, 35.953, 0.627498225969521, -97.2359, -1.69708660613995),
(32120, '73028', 218, 42, 8292, 35.9535, 0.627506952615781, -97.5946, -1.70334710216686),
(32121, '73029', 218, 42, 1942, 34.8967, 0.609062313080705, -98.2041, -1.71398488395776),
(32122, '73030', 218, 42, 20476, 34.5022, 0.602176989181588, -97.1157, -1.69498872037906),
(32123, '73031', 218, 42, 75655, 35.0335, 0.611449923497433, -97.6291, -1.7039492407588),
(32124, '73032', 218, 42, 20649, 34.3998, 0.600389772027545, -97.0513, -1.69386472834077),
(32125, '73033', 218, 42, 75720, 35.3051, 0.61619023774585, -98.5576, -1.72015462286356),
(32126, '73034', 218, 42, 2234, 35.6596, 0.62237742994417, -97.4682, -1.70114100599234),
(32127, '73036', 218, 42, 75748, 35.527, 0.620063123356025, -97.9559, -1.70965297675431),
(32128, '73038', 218, 42, 75858, 35.0987, 0.612587878169734, -98.4401, -1.71810386099247),
(32129, '73040', 218, 42, 75915, 35.6301, 0.621862557814832, -98.32, -1.71600772056082),
(32130, '73041', 218, 42, 75951, 35.0709, 0.612102676637679, -98.872, -1.72564193803183),
(32131, '73042', 218, 42, 75955, 35.1887, 0.614158674496529, -98.2572, -1.71491165379057),
(32132, '73043', 218, 42, 2861, 35.7451, 0.623869686454625, -98.3875, -1.71718581780592),
(32133, '73044', 218, 42, 29968, 35.8658, 0.625976298861782, -97.4237, -1.7003643344752),
(32134, '73045', 218, 42, 76027, 35.473, 0.619120645559949, -97.1754, -1.6960306819425),
(32135, '73047', 218, 42, 3161, 35.4726, 0.619113664242941, -98.3555, -1.71662731244528),
(32136, '73048', 218, 42, 36545, 35.5427, 0.620337140048589, -98.5584, -1.72016858549758),
(32137, '73049', 218, 42, 3445, 35.5686, 0.620789180324855, -97.3219, -1.69858758929667),
(32138, '73050', 218, 42, 3666, 35.945, 0.627358599629362, -97.2531, -1.6973868027713),
(32139, '73051', 218, 42, 3748, 35.0156, 0.611137509561326, -97.3311, -1.69874815958785),
(32140, '73052', 218, 42, 41807, 34.8393, 0.60806049409006, -97.6076, -1.70357399496962),
(32141, '73053', 218, 42, 76449, 35.3709, 0.617338664393662, -98.3953, -1.71732195348758),
(32142, '73054', 218, 42, 60720, 35.6538, 0.622276200847554, -97.1921, -1.69632215192758),
(32143, '73055', 218, 42, 4004, 34.6481, 0.604723424560247, -97.959, -1.70970708196113),
(32144, '73056', 218, 42, 4011, 36.1276, 0.630545570843503, -97.5919, -1.70329997827705),
(32145, '73057', 218, 42, 4063, 34.8164, 0.607660813691354, -97.4123, -1.70016536694047),
(32146, '73058', 218, 42, 10448, 35.8415, 0.625552183853548, -97.2407, -1.69717038194405),
(32147, '73059', 218, 42, 76615, 35.313, 0.616328118756758, -97.9471, -1.70949938778014),
(32148, '73061', 218, 42, 42178, 36.2975, 0.633510885242642, -97.0086, -1.69311947275017),
(32149, '73062', 218, 42, 4440, 35.0982, 0.612579151523474, -98.7539, -1.72358070418523),
(32150, '73063', 218, 42, 76662, 36.0649, 0.629451249402503, -97.4042, -1.70002399527106),
(32151, '73064', 218, 42, 76672, 35.3897, 0.617666786293037, -97.731, -1.70572773126658),
(32152, '73065', 218, 42, 10795, 35.251, 0.615246014620521, -97.6248, -1.70387419160096),
(32153, '73066', 218, 42, 76714, 35.4949, 0.619502872666135, -97.3256, -1.69865216647899),
(32154, '73067', 218, 42, 76718, 34.9445, 0.609896580463158, -97.916, -1.70895659038277),
(32155, '73068', 218, 42, 23388, 35.1439, 0.613376766991635, -97.3631, -1.69930666494849),
(32156, '73069', 218, 42, 4593, 35.2502, 0.615232051986505, -97.46, -1.70099788899367),
(32157, '73070', 218, 42, 4593, 35.2217, 0.614734633149687, -97.3661, -1.69935902482605),
(32158, '73071', 218, 42, 4593, 35.2293, 0.614867278172838, -97.3583, -1.6992228891444),
(32159, '73072', 218, 42, 4593, 35.2179, 0.614668310638111, -97.4838, -1.70141327735565),
(32160, '73073', 218, 42, 10999, 36.1322, 0.630625855989095, -97.4415, -1.70067500308205),
(32161, '73074', 218, 42, 23730, 34.8279, 0.607861526555333, -97.2615, -1.69753341042846),
(32162, '73075', 218, 42, 76906, 34.7592, 0.606662485359213, -97.2049, -1.69654555407184),
(32163, '73077', 218, 42, 11148, 36.2918, 0.633411401475278, -97.2883, -1.698001158668),
(32164, '73078', 218, 42, 4996, 35.6392, 0.622021382776763, -97.7456, -1.70598254933737),
(32165, '73079', 218, 42, 76970, 35.1579, 0.613621113086914, -98.0027, -1.71046979084425),
(32166, '73080', 218, 42, 30906, 35.0167, 0.611156708183098, -97.3659, -1.69935553416755),
(32167, '73082', 218, 42, 77145, 34.7843, 0.607100563001464, -97.9582, -1.70969311932711),
(32168, '73083', 218, 42, 2234, 35.7394, 0.623770202687261, -97.4789, -1.7013277562223),
(32169, '73084', 218, 42, 5995, 35.5169, 0.619886845101574, -97.3471, -1.69902741226817),
(32170, '73085', 218, 42, 13015, 35.4903, 0.619422587520543, -97.737, -1.7058324510217),
(32171, '73086', 218, 42, 65, 34.5082, 0.602281708936707, -96.9738, -1.69251209817048),
(32172, '73089', 218, 42, 12418, 35.2907, 0.615938910333563, -97.7815, -1.70660912253884),
(32173, '73090', 218, 42, 12457, 35.3939, 0.617740090121621, -97.9382, -1.70934405347671),
(32174, '73092', 218, 42, 77547, 35.0745, 0.612165508490751, -98.0559, -1.71139830600631),
(32175, '73093', 218, 42, 12671, 35.1279, 0.613097514311316, -97.4899, -1.70151974244002),
(32176, '73094', 218, 42, 12687, 35.1033, 0.612668163315325, -98.3401, -1.71635853174048),
(32177, '73095', 218, 42, 6665, 34.917, 0.60941661491886, -97.3132, -1.69843574565175),
(32178, '73096', 218, 42, 25862, 35.5335, 0.620176569757405, -98.6973, -1.7225928478286),
(32179, '73097', 218, 42, 31509, 35.3963, 0.617781978023669, -97.6493, -1.7043017972677),
(32180, '73098', 218, 42, 14922, 34.6437, 0.60464663007316, -97.1632, -1.69581775177375),
(32181, '73099', 218, 42, 13015, 35.4978, 0.619553487214443, -97.7329, -1.70576089252237),
(32182, '73101', 218, 42, 76800, 35.4911, 0.61943655015456, -97.5628, -1.70279208746472),
(32183, '73102', 218, 42, 76800, 35.4713, 0.619090974962665, -97.518, -1.70201017995983),
(32184, '73103', 218, 42, 76800, 35.4912, 0.619438295483811, -97.5155, -1.70196654672853),
(32185, '73104', 218, 42, 76800, 35.4756, 0.6191660241205, -97.5035, -1.70175710721829),
(32186, '73105', 218, 42, 76800, 35.5122, 0.61980481462673, -97.5027, -1.70174314458428),
(32187, '73106', 218, 42, 76800, 35.4814, 0.619267253217116, -97.5357, -1.70231910323743),
(32188, '73107', 218, 42, 76800, 35.4847, 0.619324849082432, -97.5765, -1.70303119757225),
(32189, '73108', 218, 42, 76800, 35.4479, 0.618682567917698, -97.5626, -1.70278859680622),
(32190, '73109', 218, 42, 76800, 35.4329, 0.618420768529899, -97.5214, -1.7020695211544),
(32191, '73110', 218, 42, 76800, 35.4601, 0.618895498086441, -97.3968, -1.69989484090641),
(32192, '73111', 218, 42, 76800, 35.5101, 0.619768162712438, -97.4706, -1.70118289389439),
(32193, '73112', 218, 42, 76800, 35.5182, 0.61990953438185, -97.5725, -1.70296138440217),
(32194, '73113', 218, 42, 76800, 35.5633, 0.620696677874499, -97.5, -1.70169602069447),
(32195, '73114', 218, 42, 76800, 35.5685, 0.620787434995603, -97.5213, -1.70206777582515),
(32196, '73115', 218, 42, 76800, 35.4409, 0.618560394870058, -97.4417, -1.70067849374056),
(32197, '73116', 218, 42, 76800, 35.5421, 0.620326668073077, -97.5564, -1.7026803863926),
(32198, '73117', 218, 42, 76800, 35.4776, 0.61920093070554, -97.4703, -1.70117765790663),
(32199, '73118', 218, 42, 76800, 35.5171, 0.619890335760078, -97.5284, -1.70219169420204),
(32200, '73119', 218, 42, 76800, 35.423, 0.618247980933951, -97.5703, -1.70292298715862),
(32201, '73120', 218, 42, 76800, 35.5836, 0.621050979712654, -97.5747, -1.70299978164571),
(32202, '73121', 218, 42, 76800, 35.5093, 0.619754200078423, -97.4454, -1.70074307092288),
(32203, '73122', 218, 42, 76800, 35.5213, 0.619963639588662, -97.614, -1.70368569604175),
(32204, '73123', 218, 42, 76800, 35.5372, 0.620241146939729, -97.6224, -1.70383230369891),
(32205, '73124', 218, 42, 76800, 35.4332, 0.618426004517655, -97.5257, -1.70214457031223),
(32206, '73125', 218, 42, 76800, 35.459, 0.618876299464669, -97.5285, -1.70219343953129),
(32207, '73126', 218, 42, 76800, 35.457, 0.618841392879629, -97.4896, -1.70151450645226),
(32208, '73127', 218, 42, 76800, 35.4832, 0.619298669143652, -97.6332, -1.70402079925813),
(32209, '73128', 218, 42, 76800, 35.4498, 0.618715729173486, -97.6207, -1.70380263310163),
(32210, '73129', 218, 42, 76800, 35.4322, 0.618408551225135, -97.4848, -1.70143073064817),
(32211, '73130', 218, 42, 76800, 35.4675, 0.619024652451089, -97.3365, -1.69884240736746),
(32212, '73131', 218, 42, 76800, 35.5813, 0.621010837139858, -97.4689, -1.7011532232971),
(32213, '73132', 218, 42, 76800, 35.5458, 0.6203912452554, -97.6371, -1.70408886709896),
(32214, '73134', 218, 42, 76800, 35.6135, 0.621572833159001, -97.5688, -1.70289680721984),
(32215, '73135', 218, 42, 76800, 35.3953, 0.617764524731149, -97.4254, -1.70039400507248),
(32216, '73136', 218, 42, 76800, 35.5901, 0.621164426114034, -97.4556, -1.70092109450659),
(32217, '73137', 218, 42, 76800, 35.4804, 0.619249799924596, -97.6354, -1.70405919650167),
(32218, '73139', 218, 42, 76800, 35.3933, 0.617729618146109, -97.5256, -1.70214282498298),
(32219, '73140', 218, 42, 76800, 35.4659, 0.618996727183057, -97.3835, -1.6996627121159),
(32220, '73141', 218, 42, 76800, 35.4914, 0.619441786142315, -97.3754, -1.69952134044649),
(32221, '73142', 218, 42, 76800, 35.6091, 0.621496038671913, -97.6395, -1.704130755001),
(32222, '73143', 218, 42, 76800, 35.4332, 0.618426004517655, -97.525, -1.70213235300747),
(32223, '73144', 218, 42, 76800, 35.4089, 0.61800188950942, -97.5548, -1.70265246112456),
(32224, '73145', 218, 42, 76800, 35.4195, 0.618186894410132, -97.3943, -1.69985120767511),
(32225, '73146', 218, 42, 76800, 35.494, 0.619487164702867, -97.5299, -1.70221787414082),
(32226, '73147', 218, 42, 76800, 35.4857, 0.619342302374952, -97.5817, -1.70312195469335),
(32227, '73148', 218, 42, 76800, 35.4541, 0.618790778331322, -97.5545, -1.70264722513681),
(32228, '73149', 218, 42, 76800, 35.3942, 0.617745326109377, -97.4926, -1.70156686632982),
(32229, '73150', 218, 42, 76800, 35.4101, 0.618022833460444, -97.3239, -1.69862249588171),
(32230, '73151', 218, 42, 76800, 35.5727, 0.620860738824187, -97.3743, -1.69950214182471),
(32231, '73152', 218, 42, 76800, 35.5192, 0.61992698767437, -97.5038, -1.70176234320605),
(32232, '73153', 218, 42, 76800, 35.3349, 0.616710345862944, -97.4902, -1.70152497842778),
(32233, '73154', 218, 42, 76800, 35.5242, 0.62001425413697, -97.5254, -1.70213933432448),
(32234, '73155', 218, 42, 76800, 35.4201, 0.618197366385643, -97.4373, -1.70060169925347),
(32235, '73156', 218, 42, 76800, 35.5673, 0.620766491044579, -97.5517, -1.70259835591775),
(32236, '73157', 218, 42, 76800, 35.4262, 0.618303831470015, -97.5677, -1.70287760859807),
(32237, '73159', 218, 42, 76800, 35.392, 0.617706928865833, -97.556, -1.70267340507559),
(32238, '73160', 218, 42, 76800, 35.3409, 0.616815065618064, -97.4784, -1.70131902957604),
(32239, '73162', 218, 42, 76800, 35.5784, 0.620960222591551, -97.6421, -1.70417613356156),
(32240, '73163', 218, 42, 76800, 35.4326, 0.618415532542143, -97.5243, -1.70212013570271),
(32241, '73164', 218, 42, 76800, 35.4322, 0.618408551225135, -97.5245, -1.70212362636121),
(32242, '73165', 218, 42, 76800, 35.3388, 0.616778413703772, -97.3512, -1.6990989707675),
(32243, '73167', 218, 42, 76800, 35.4592, 0.618879790123173, -97.5195, -1.70203635989861),
(32244, '73169', 218, 42, 76800, 35.3939, 0.617740090121621, -97.647, -1.7042616546949),
(32245, '73170', 218, 42, 76800, 35.3415, 0.616825537593576, -97.5401, -1.70239589772452),
(32246, '73172', 218, 42, 76800, 35.4217, 0.618225291653675, -97.569, -1.70290029787835),
(32247, '73173', 218, 42, 76800, 35.3389, 0.616780159033024, -97.6212, -1.70381135974789),
(32248, '73177', 218, 42, 76800, 35.5783, 0.620958477262299, -97.5763, -1.70302770691374),
(32249, '73178', 218, 42, 76800, 35.537, 0.620237656281225, -97.5657, -1.70284270201303),
(32250, '73179', 218, 42, 76800, 35.4236, 0.618258452909463, -97.6418, -1.7041708975738),
(32251, '73180', 218, 42, 76800, 35.4217, 0.618225291653675, -97.5688, -1.70289680721984),
(32252, '73184', 218, 42, 76800, 35.6178, 0.621647882316836, -97.5723, -1.70295789374366),
(32253, '73185', 218, 42, 76800, 35.4675, 0.619024652451089, -97.5165, -1.70198400002105),
(32254, '73189', 218, 42, 76800, 35.3935, 0.617733108804613, -97.579, -1.70307483080355),
(32255, '73190', 218, 42, 76800, 35.4594, 0.618883280781677, -97.5178, -1.70200668930133),
(32256, '73193', 218, 42, 76800, 35.4595, 0.618885026110929, -97.5178, -1.70200668930133),
(32257, '73194', 218, 42, 76800, 35.5184, 0.619913025040354, -97.5034, -1.70175536188904),
(32258, '73195', 218, 42, 76800, 35.4679, 0.619031633768097, -97.5165, -1.70198400002105),
(32259, '73196', 218, 42, 76800, 35.4602, 0.618897243415693, -97.3973, -1.69990356755267),
(32260, '73197', 218, 42, 76800, 35.4672, 0.619019416463333, -97.5157, -1.70197003738703),
(32261, '73198', 218, 42, 76800, 35.5189, 0.619921751686614, -97.5751, -1.70300676296272),
(32262, '73199', 218, 42, 76800, 35.5781, 0.620954986603795, -97.7232, -1.70559159558492),
(32263, '73301', 218, 51, 7197, 30.2205, 0.527447226598946, -97.7488, -1.70603839987343),
(32264, '73344', 218, 51, 7197, 30.179, 0.526722914959369, -97.7257, -1.70563522881622),
(32265, '73401', 218, 42, 18903, 34.175, 0.596466271869062, -97.1398, -1.69540934472879),
(32266, '73402', 218, 42, 18903, 34.1664, 0.596316173553391, -97.1049, -1.69480022481984),
(32267, '73403', 218, 42, 18903, 34.1736, 0.596441837259534, -97.1432, -1.69546868592336),
(32268, '73425', 218, 42, 75545, 34.4481, 0.601232766056259, -97.563, -1.70279557812323),
(32269, '73430', 218, 42, 75273, 33.9226, 0.592061060837028, -97.3134, -1.69843923631025),
(32270, '73432', 218, 42, 1693, 34.2841, 0.598370426082988, -96.4864, -1.68400536339626),
(32271, '73433', 218, 42, 75767, 34.6146, 0.604138739260829, -97.4044, -1.70002748592956),
(32272, '73434', 218, 42, 35967, 34.6364, 0.604519221037764, -97.554, -1.70263849849055),
(32273, '73435', 218, 42, 8963, 34.3634, 0.599754472179819, -97.492, -1.70155639435431),
(32274, '73436', 218, 42, 75916, 34.2906, 0.598483872484368, -97.0337, -1.69355755039242),
(32275, '73437', 218, 42, 2802, 34.3231, 0.599051104491266, -97.5037, -1.70176059787679),
(32276, '73438', 218, 42, 76057, 34.2281, 0.597393041701871, -97.4839, -1.7014150226849),
(32277, '73439', 218, 42, 3542, 33.9892, 0.593223450118857, -96.7072, -1.68785905038466),
(32278, '73440', 218, 42, 3708, 33.9632, 0.592769664513338, -96.8732, -1.69075629694297),
(32279, '73441', 218, 42, 3732, 33.9516, 0.592567206320107, -97.4592, -1.70098392635966),
(32280, '73442', 218, 42, 41841, 34.3252, 0.599087756405558, -97.6864, -1.70494931442019),
(32281, '73443', 218, 42, 10165, 34.1757, 0.596478489173826, -97.2609, -1.69752293845295),
(32282, '73444', 218, 42, 76065, 34.4759, 0.601717967588313, -97.4114, -1.7001496589772),
(32283, '73446', 218, 42, 76483, 34.089, 0.594965288712347, -96.7737, -1.68901969433724),
(32284, '73447', 218, 42, 37044, 34.1969, 0.596848498975249, -96.7921, -1.6893408349196),
(32285, '73448', 218, 42, 3993, 33.9361, 0.592296680286048, -97.1229, -1.6951143840852),
(32286, '73449', 218, 42, 76572, 33.9418, 0.592396164053411, -96.402, -1.68253230550757),
(32287, '73450', 218, 42, 37195, 34.1715, 0.596405185345242, -96.5261, -1.6846982591093),
(32288, '73453', 218, 42, 4813, 34.0491, 0.594268902340801, -97.1158, -1.69499046570831),
(32289, '73455', 218, 42, 77047, 34.2436, 0.59766356773593, -96.7489, -1.68858685268274),
(32290, '73456', 218, 42, 77096, 34.1815, 0.596579718270442, -97.6104, -1.70362286418867),
(32291, '73458', 218, 42, 77316, 34.3143, 0.59889751551709, -97.1271, -1.69518768791378),
(32292, '73459', 218, 42, 77436, 33.7881, 0.589713592993096, -97.1348, -1.69532207826619),
(32293, '73460', 218, 42, 62043, 34.234, 0.597496016127739, -96.6758, -1.68731101699953),
(32294, '73461', 218, 42, 77587, 34.3926, 0.600264108321402, -96.499, -1.68422527488201),
(32295, '73463', 218, 42, 565, 34.1609, 0.596220180444531, -97.4252, -1.70039051441398),
(32296, '73476', 218, 42, 4957, 34.5976, 0.60384203328799, -97.3919, -1.69980931977307),
(32297, '73481', 218, 42, 77046, 34.4099, 0.600566050281997, -97.513, -1.70192291349723),
(32298, '73487', 218, 42, 77417, 34.4819, 0.601822687343433, -97.4611, -1.70101708761545),
(32299, '73488', 218, 42, 77508, 34.4852, 0.601880283208749, -97.5362, -1.70232782988369),
(32300, '73491', 218, 42, 28851, 34.4614, 0.601464894846774, -97.6691, -1.70464737245959),
(32301, '73501', 218, 42, 22591, 34.6086, 0.60403401950571, -98.395, -1.71731671749982),
(32302, '73502', 218, 42, 22591, 34.6026, 0.60392929975059, -98.3957, -1.71732893480458),
(32303, '73503', 218, 42, 0, 34.6516, 0.604784511084067, -98.4115, -1.7176046968264),
(32304, '73505', 218, 42, 22591, 34.6161, 0.604164919199609, -98.4592, -1.7184372188796),
(32305, '73506', 218, 42, 22591, 34.6231, 0.604287092247249, -98.4597, -1.71844594552586),
(32306, '73507', 218, 42, 22591, 34.6234, 0.604292328235005, -98.3836, -1.71711774996509),
(32307, '73520', 218, 42, 74938, 34.2432, 0.597656586418922, -97.9668, -1.70984321764278),
(32308, '73521', 218, 42, 7080, 34.6438, 0.604648375402412, -99.3255, -1.73355700618963),
(32309, '73522', 218, 42, 7080, 34.6478, 0.604718188572491, -99.3364, -1.7337472470781),
(32310, '73523', 218, 42, 0, 34.68, 0.605280184591633, -99.3424, -1.73385196683321),
(32311, '73526', 218, 42, 26538, 34.7777, 0.606985371270832, -99.3329, -1.73368616055428),
(32312, '73527', 218, 42, 26669, 34.6303, 0.604412755953392, -98.6284, -1.72139031597398),
(32313, '73528', 218, 42, 75409, 34.4219, 0.600775489792236, -98.6491, -1.72175159912914),
(32314, '73529', 218, 42, 75505, 34.3672, 0.599820794691395, -97.9685, -1.70987288824006),
(32315, '73530', 218, 42, 8406, 34.243, 0.597653095760418, -99.0786, -1.72924778826645),
(32316, '73531', 218, 42, 75646, 34.2164, 0.597188838179388, -98.5644, -1.7202733052527),
(32317, '73532', 218, 42, 2124, 34.6636, 0.604993950594307, -99.5704, -1.73783131752776),
(32318, '73533', 218, 42, 2130, 34.5125, 0.602356758094543, -97.9605, -1.70973326189991),
(32319, '73534', 218, 42, 2130, 34.5095, 0.602304398216983, -97.9672, -1.70985019895979),
(32320, '73536', 218, 42, 2130, 34.4479, 0.601229275397755, -97.8352, -1.70754636434716),
(32321, '73537', 218, 42, 15909, 34.4733, 0.601672589027761, -99.6497, -1.73921536362459),
(32322, '73538', 218, 42, 2254, 34.7265, 0.606091762693811, -98.2595, -1.71495179636337),
(32323, '73539', 218, 42, 32348, 34.5076, 0.602271236961195, -99.2983, -1.73308227663309),
(32324, '73540', 218, 42, 35862, 34.4665, 0.601553906638626, -98.5446, -1.7199277300608),
(32325, '73541', 218, 42, 16032, 34.8227, 0.607770769434229, -98.2356, -1.71453466267214),
(32326, '73542', 218, 42, 32485, 34.3923, 0.600258872333646, -99.0129, -1.72810110694789),
(32327, '73543', 218, 42, 75920, 34.4813, 0.601812215367921, -98.3817, -1.71708458870931),
(32328, '73544', 218, 42, 9168, 34.6664, 0.605042819813362, -99.7814, -1.74151396224947),
(32329, '73546', 218, 42, 9175, 34.2319, 0.597459364213447, -98.6901, -1.72246718412246),
(32330, '73547', 218, 42, 47585, 34.9616, 0.610195031765249, -99.3821, -1.73454486254626),
(32331, '73548', 218, 42, 16375, 34.2156, 0.597174875545372, -98.106, -1.71227271596156),
(32332, '73549', 218, 42, 76058, 34.6283, 0.604377849368352, -99.1384, -1.73029149515915),
(32333, '73550', 218, 42, 9537, 34.6872, 0.605405848297777, -99.9162, -1.74386666608116),
(32334, '73551', 218, 42, 16470, 34.3628, 0.599744000204308, -98.8885, -1.72592991735841),
(32335, '73552', 218, 42, 76168, 34.6209, 0.604248695003705, -98.7536, -1.72357546819747),
(32336, '73553', 218, 42, 73286, 34.3695, 0.599860937264191, -98.7362, -1.72327178090763),
(32337, '73554', 218, 42, 37038, 34.8791, 0.608755135132354, -99.5034, -1.73666194692893),
(32338, '73555', 218, 42, 37040, 34.507, 0.602260764985683, -98.981, -1.72754434691651),
(32339, '73556', 218, 42, 37071, 34.7243, 0.606053365450267, -99.3851, -1.73459722242382),
(32340, '73557', 218, 42, 76575, 34.7281, 0.606119687961843, -98.4641, -1.71852274001295),
(32341, '73558', 218, 42, 76577, 34.7827, 0.607072637733432, -98.5798, -1.72054208595751),
(32342, '73559', 218, 42, 4436, 34.6976, 0.605587362539984, -98.9475, -1.72695966161709),
(32343, '73560', 218, 42, 4785, 34.5457, 0.602936207406205, -99.4224, -1.73524823023481),
(32344, '73561', 218, 42, 37551, 33.9622, 0.592752211220818, -97.763, -1.70628623662722),
(32345, '73562', 218, 42, 77040, 34.1779, 0.59651688641737, -98.4334, -1.71798692393259),
(32346, '73564', 218, 42, 5534, 34.8504, 0.608254225637032, -99.0229, -1.72827563987309),
(32347, '73565', 218, 42, 5594, 34.0297, 0.593930308465914, -97.8753, -1.70824624137721),
(32348, '73566', 218, 42, 12018, 34.6564, 0.604868286888163, -98.9523, -1.72704343742118),
(32349, '73567', 218, 42, 25116, 34.7502, 0.606505405726534, -98.1625, -1.71325882698893),
(32350, '73568', 218, 42, 12281, 34.2738, 0.598190657170033, -98.2343, -1.71451197339187),
(32351, '73569', 218, 42, 77430, 33.9093, 0.591828932046513, -97.9385, -1.70934928946447),
(32352, '73570', 218, 42, 12332, 34.4992, 0.602124629304028, -99.1441, -1.73039097892651),
(32353, '73571', 218, 42, 77563, 34.8889, 0.60892617739905, -99.8148, -1.74209690221964),
(32354, '73572', 218, 42, 12640, 34.3514, 0.59954503266958, -98.3052, -1.71574941183153),
(32355, '73573', 218, 42, 77621, 34.1686, 0.596354570796934, -97.9976, -1.7103807790524),
(32356, '73575', 218, 42, 2130, 34.4951, 0.602053070804696, -97.9959, -1.71035110845511),
(32357, '73601', 218, 42, 1630, 35.5117, 0.61979608798047, -98.9705, -1.72736108734505),
(32358, '73620', 218, 42, 75006, 35.5763, 0.620923570677259, -98.9619, -1.72721098902938),
(32359, '73622', 218, 42, 410, 35.3855, 0.617593482464453, -98.9976, -1.72783407157234),
(32360, '73624', 218, 42, 75275, 35.3545, 0.617052430396335, -99.1744, -1.73091981368986),
(32361, '73625', 218, 42, 1257, 35.6451, 0.622124357202631, -99.2605, -1.73242254217583),
(32362, '73626', 218, 42, 75327, 35.418, 0.618160714471352, -99.2806, -1.73277335335548),
(32363, '73627', 218, 42, 35159, 35.2135, 0.614591516151023, -99.4569, -1.73585036882675),
(32364, '73628', 218, 42, 32059, 35.6412, 0.622056289361803, -99.689, -1.73990127802063),
(32365, '73632', 218, 42, 35378, 35.2939, 0.615994760869627, -98.994, -1.72777123971927),
(32366, '73638', 218, 42, 1860, 35.8508, 0.625714499473983, -99.8087, -1.74199043713526),
(32367, '73639', 218, 42, 75595, 35.6669, 0.622504838979566, -98.8823, -1.72582170694479),
(32368, '73641', 218, 42, 75658, 35.2775, 0.6157085268723, -99.1302, -1.73014837816048),
(32369, '73642', 218, 42, 8632, 35.8478, 0.625662139596423, -99.9202, -1.74393647925124),
(32370, '73644', 218, 42, 32320, 35.41, 0.618021088131192, -99.4145, -1.7351103492239),
(32371, '73645', 218, 42, 20921, 35.2115, 0.614556609565983, -99.8689, -1.74304112534496),
(32372, '73646', 218, 42, 54734, 35.836, 0.625456190744688, -98.68, -1.722290905868),
(32373, '73647', 218, 42, 75865, 35.3998, 0.617843064547489, -99.1102, -1.72979931231008),
(32374, '73648', 218, 42, 32320, 35.4071, 0.617970473582884, -99.4197, -1.73520110634501),
(32375, '73650', 218, 42, 76012, 35.6897, 0.62290277404902, -99.472, -1.7361139135438),
(32376, '73651', 218, 42, 844, 35.0253, 0.61130680649877, -99.0938, -1.72951307831276),
(32377, '73654', 218, 42, 76360, 35.8688, 0.626028658739342, -99.345, -1.73389734539377),
(32378, '73655', 218, 42, 76443, 34.9888, 0.610669761321792, -99.247, -1.73218692272681),
(32379, '73658', 218, 42, 4723, 35.9328, 0.627145669460618, -98.7062, -1.72274818213203),
(32380, '73659', 218, 42, 5256, 35.8441, 0.625597562414099, -98.942, -1.72686366850823),
(32381, '73660', 218, 42, 77083, 35.6572, 0.622335542042122, -99.9032, -1.7436397732784),
(32382, '73661', 218, 42, 11641, 35.1568, 0.613601914465142, -99.0585, -1.7288969770868),
(32383, '73662', 218, 42, 5677, 35.2988, 0.616080282002974, -99.6386, -1.73902163207762),
(32384, '73663', 218, 42, 77205, 36.142, 0.630796898255791, -98.9295, -1.72664550235173),
(32385, '73664', 218, 42, 57483, 35.1562, 0.61359144248963, -99.1744, -1.73091981368986),
(32386, '73666', 218, 42, 6196, 35.4429, 0.618595301455098, -99.9116, -1.74378638093557),
(32387, '73667', 218, 42, 77412, 36.0407, 0.62902887972352, -98.9605, -1.72718655441985),
(32388, '73668', 218, 42, 38514, 35.2323, 0.614919638050398, -99.9683, -1.74477598262145),
(32389, '73669', 218, 42, 6310, 35.7464, 0.623892375734901, -98.7447, -1.72342013389404),
(32390, '73673', 218, 42, 12874, 35.0471, 0.611687288275705, -99.642, -1.73908097327219),
(32391, '73701', 218, 42, 59815, 36.4041, 0.635371406225268, -97.8729, -1.70820435347516),
(32392, '73702', 218, 42, 59815, 36.3977, 0.63525970515314, -97.8738, -1.70822006143843),
(32393, '73703', 218, 42, 59815, 36.3997, 0.63529461173818, -97.9173, -1.70897927966304),
(32394, '73705', 218, 42, 59815, 36.3872, 0.635076445581681, -98.0928, -1.71204233250029),
(32395, '73706', 218, 42, 59815, 36.3973, 0.635252723836132, -97.9332, -1.70925678701411),
(32396, '73716', 218, 42, 18787, 36.5119, 0.637252871158918, -98.451, -1.71829410188094),
(32397, '73717', 218, 42, 14980, 36.7996, 0.642274183416905, -98.6676, -1.72207448504076),
(32398, '73718', 218, 42, 7089, 36.2306, 0.632343259973058, -98.181, -1.71358171290055),
(32399, '73719', 218, 42, 74991, 36.9523, 0.644939301184701, -98.2271, -1.71438630968572),
(32400, '73720', 218, 42, 31831, 36.1908, 0.631648618930764, -97.8846, -1.70840855699764),
(32401, '73722', 218, 42, 1239, 36.9168, 0.644319709300243, -98.4353, -1.71802008518837),
(32402, '73724', 218, 42, 19763, 36.0563, 0.629301151086831, -98.5896, -1.7207131282242),
(32403, '73726', 218, 42, 1362, 36.5791, 0.638425732416258, -98.4594, -1.7184407095381),
(32404, '73727', 218, 42, 75343, 36.5285, 0.637542595814749, -98.0155, -1.7106931929885),
(32405, '73728', 218, 42, 5, 36.7546, 0.641488785253508, -98.3529, -1.71658193388473),
(32406, '73729', 218, 42, 75465, 36.4075, 0.635430747419836, -98.4406, -1.71811258763873),
(32407, '73730', 218, 42, 15652, 36.2969, 0.63350041326713, -97.5433, -1.70245174826059),
(32408, '73731', 218, 42, 75599, 36.6624, 0.639879591683169, -98.5642, -1.7202698145942),
(32409, '73733', 218, 42, 2088, 36.2316, 0.632360713265578, -97.6893, -1.7049999289685),
(32410, '73734', 218, 42, 8583, 35.9801, 0.627971210196812, -97.9112, -1.70887281457867),
(32411, '73735', 218, 42, 2109, 36.3023, 0.633594661046738, -98.037, -1.71106843877768),
(32412, '73736', 218, 42, 27132, 36.3762, 0.634884459363961, -97.7018, -1.705218095125),
(32413, '73737', 218, 42, 500, 36.2721, 0.633067571612635, -98.4736, -1.71868854629189),
(32414, '73738', 218, 42, 9047, 36.4365, 0.635936892902914, -97.5814, -1.70311671870559),
(32415, '73739', 218, 42, 75940, 36.5354, 0.637663023533136, -98.1582, -1.7131837778311),
(32416, '73741', 218, 42, 3052, 36.5465, 0.637856755080108, -98.2734, -1.7151943971294),
(32417, '73742', 218, 42, 76066, 36.1062, 0.630172070383577, -97.8973, -1.70863021381264),
(32418, '73743', 218, 42, 3147, 36.563, 0.638144734406687, -97.9908, -1.71026209666326),
(32419, '73744', 218, 42, 30091, 35.9691, 0.627779223979092, -98.3511, -1.7165505179582),
(32420, '73746', 218, 42, 76130, 36.6877, 0.640321159983924, -98.6657, -1.72204132378497),
(32421, '73747', 218, 42, 3368, 36.2354, 0.632427035777153, -98.3406, -1.71636725838674),
(32422, '73749', 218, 42, 3427, 36.6706, 0.640022708681833, -98.1819, -1.71359742086382),
(32423, '73750', 218, 42, 76289, 35.8515, 0.625726716778747, -97.936, -1.70930565623317),
(32424, '73753', 218, 42, 76306, 36.5279, 0.637532123839237, -97.8365, -1.70756905362743),
(32425, '73754', 218, 42, 76318, 36.3877, 0.635085172227941, -98.0922, -1.71203186052478),
(32426, '73755', 218, 42, 16939, 36.1146, 0.630318678040744, -98.5564, -1.72013367891254),
(32427, '73756', 218, 42, 76463, 35.9634, 0.627679740211729, -98.1122, -1.71238092637518),
(32428, '73757', 218, 42, 60712, 36.2684, 0.633002994430311, -97.4496, -1.70081637475147),
(32429, '73758', 218, 42, 585, 36.9553, 0.64499166106226, -98.01, -1.71059719987964),
(32430, '73759', 218, 42, 49404, 36.8052, 0.642371921855017, -97.7432, -1.70594066143532),
(32431, '73760', 218, 42, 76581, 36.3877, 0.635085172227941, -98.1775, -1.71352062637673),
(32432, '73761', 218, 42, 17236, 36.6653, 0.639930206231477, -98.0516, -1.71132325684847),
(32433, '73762', 218, 42, 76791, 35.7294, 0.623595669762062, -97.9762, -1.71000727859247),
(32434, '73763', 218, 42, 0, 36.1173, 0.630365801930548, -98.3278, -1.71614385624248),
(32435, '73764', 218, 42, 4787, 35.8478, 0.625662139596423, -98.18, -1.71356425960803),
(32436, '73766', 218, 42, 17697, 36.667, 0.639959876828761, -97.7996, -1.70692502713345),
(32437, '73768', 218, 42, 42810, 36.3814, 0.634975216485065, -98.2427, -1.71465858104903),
(32438, '73770', 218, 42, 57647, 36.0767, 0.629657198254238, -98.4579, -1.71841452959932),
(32439, '73771', 218, 42, 77572, 36.8814, 0.643701862745037, -97.9235, -1.70908749007667),
(32440, '73772', 218, 42, 77611, 35.8533, 0.625758132705283, -98.4115, -1.7176046968264),
(32441, '73773', 218, 42, 77619, 36.2809, 0.633221160586811, -97.9003, -1.7086825736902),
(32442, '73801', 218, 42, 6955, 36.4296, 0.635816465184526, -99.3996, -1.73485029516536),
(32443, '73802', 218, 42, 6955, 36.419, 0.635631460283815, -99.3851, -1.73459722242382),
(32444, '73832', 218, 42, 7164, 36.0606, 0.629376200244667, -99.7072, -1.74021892794449),
(32445, '73834', 218, 42, 26642, 36.8336, 0.642867595362583, -99.6343, -1.73894658291979),
(32446, '73835', 218, 42, 26683, 36.0297, 0.628836893505801, -99.2804, -1.73276986269698),
(32447, '73838', 218, 42, 8056, 36.3289, 0.634058918627768, -98.873, -1.72565939132435),
(32448, '73840', 218, 42, 8846, 36.3735, 0.634837335474157, -99.6225, -1.73874063406805),
(32449, '73841', 218, 42, 75862, 36.5698, 0.638263416795822, -99.5702, -1.73782782686926),
(32450, '73842', 218, 42, 29850, 36.8804, 0.643684409452517, -99.1671, -1.73079240465447),
(32451, '73843', 218, 42, 2641, 36.318, 0.633868677739301, -99.7586, -1.74111602718002),
(32452, '73844', 218, 42, 192953, 36.9132, 0.644256877447171, -100.1281, -1.74756501876613),
(32453, '73847', 218, 42, 48750, 36.8327, 0.642851887399315, -100.233, -1.74939586915148),
(32454, '73848', 218, 42, 76341, 36.7174, 0.640839522771766, -99.8806, -1.74324532886745),
(32455, '73851', 218, 42, 37104, 36.6341, 0.639385663504855, -99.6834, -1.73980353958252),
(32456, '73852', 218, 42, 30555, 36.4391, 0.635982271463466, -99.205, -1.73145388444097),
(32457, '73853', 218, 42, 17223, 36.1439, 0.630830059511579, -99.3005, -1.73312067387663),
(32458, '73855', 218, 42, 11696, 36.8968, 0.643970643449844, -99.8888, -1.74338844586611),
(32459, '73857', 218, 42, 24789, 36.2594, 0.632845914797632, -99.3911, -1.73470194217894),
(32460, '73858', 218, 42, 77231, 36.2718, 0.633062335624879, -99.8792, -1.74322089425792),
(32461, '73859', 218, 42, 77554, 36.1472, 0.630887655376894, -99.2994, -1.73310147525486),
(32462, '73860', 218, 42, 77624, 36.5867, 0.638558377439409, -98.8814, -1.72580599898152),
(32463, '73901', 218, 42, 14941, 36.8312, 0.642825707460536, -101.1556, -1.76549827683038),
(32464, '73931', 218, 42, 190952, 36.5859, 0.638544414805393, -100.6795, -1.75718876426163),
(32465, '73932', 218, 42, 7346, 36.8124, 0.642497585561161, -100.5216, -1.75443288937273),
(32466, '73933', 218, 42, 190958, 36.7297, 0.641054198269761, -102.5099, -1.78913527089014),
(32467, '73937', 218, 42, 190971, 36.5571, 0.638041759980819, -102.8403, -1.79490183873872),
(32468, '73938', 218, 42, 190973, 36.9095, 0.644192300264847, -100.5351, -1.75466850882175),
(32469, '73939', 218, 42, 190978, 36.5865, 0.638554886780905, -101.6443, -1.77402770088487),
(32470, '73942', 218, 42, 190984, 36.6857, 0.640286253398884, -101.4811, -1.77117932354562),
(32471, '73944', 218, 42, 36279, 36.5845, 0.638519980195865, -101.1622, -1.76561346856101),
(32472, '73945', 218, 42, 9557, 36.8586, 0.643303927675582, -101.2183, -1.76659259827138),
(32473, '73946', 218, 42, 14041, 36.8548, 0.643237605164006, -102.9071, -1.79606771867906),
(32474, '73947', 218, 42, 182468, 36.8082, 0.642424281732577, -102.2513, -1.78462184944448),
(32475, '73949', 218, 42, 191020, 36.5107, 0.637231927207894, -101.7785, -1.77636993274105),
(32476, '73950', 218, 42, 28816, 36.8676, 0.643461007308262, -100.8775, -1.76064451618058),
(32477, '73951', 218, 42, 25631, 36.9528, 0.644948027830961, -101.0262, -1.7632398207783),
(32478, '74001', 218, 42, 7204, 36.4887, 0.636847954772455, -96.0602, -1.67656677012426),
(32479, '74002', 218, 42, 39228, 36.56, 0.638092374529127, -96.1619, -1.67834176997354),
(32480, '74003', 218, 42, 75073, 36.7462, 0.64134217759634, -95.983, -1.67521937594172),
(32481, '74004', 218, 42, 75073, 36.738, 0.641199060597677, -95.948, -1.67460851070352);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(32482, '74005', 218, 42, 75073, 36.7471, 0.641357885559608, -95.9807, -1.67517923336892),
(32483, '74006', 218, 42, 75073, 36.7365, 0.641172880658897, -95.9316, -1.67432227670619),
(32484, '74008', 218, 42, 732, 35.9502, 0.627449356750466, -95.8887, -1.67357353045709),
(32485, '74009', 218, 42, 75190, 36.6658, 0.639938932877737, -96.3978, -1.68245900167899),
(32486, '74010', 218, 42, 1144, 35.8291, 0.6253357630263, -96.3894, -1.68231239402182),
(32487, '74011', 218, 42, 75226, 35.9905, 0.628152724439019, -95.8084, -1.67217203106774),
(32488, '74012', 218, 42, 75226, 36.0442, 0.62908996624734, -95.8082, -1.67216854040923),
(32489, '74013', 218, 42, 75226, 36.0436, 0.629079494271828, -95.7913, -1.67187357976564),
(32490, '74014', 218, 42, 75226, 36.0561, 0.629297660428327, -95.7171, -1.67057854546066),
(32491, '74015', 218, 42, 75366, 36.1849, 0.631545644504896, -95.7445, -1.67105676567571),
(32492, '74016', 218, 42, 1509, 36.5283, 0.637539105156245, -95.4431, -1.6657963433102),
(32493, '74017', 218, 42, 75454, 36.3182, 0.633872168397805, -95.6198, -1.66888034009847),
(32494, '74018', 218, 42, 75454, 36.3221, 0.633940236238632, -95.5902, -1.66836372263988),
(32495, '74020', 218, 42, 1620, 36.3033, 0.633612114339257, -96.4592, -1.68353063383971),
(32496, '74021', 218, 42, 1706, 36.3605, 0.634610442671398, -95.8491, -1.6728823800733),
(32497, '74022', 218, 42, 75523, 36.899, 0.644009040693388, -95.9254, -1.67421406629257),
(32498, '74023', 218, 42, 75594, 35.9788, 0.627948520916536, -96.762, -1.68881549081475),
(32499, '74026', 218, 42, 1977, 35.707, 0.623204716009615, -96.7642, -1.6888538880583),
(32500, '74027', 218, 42, 8461, 36.7775, 0.641888465652215, -95.6402, -1.66923638726588),
(32501, '74028', 218, 42, 54420, 35.8014, 0.624852306823498, -96.5069, -1.68436315589292),
(32502, '74029', 218, 42, 2037, 36.7963, 0.64221658755159, -95.938, -1.67443397777832),
(32503, '74030', 218, 42, 75692, 35.9889, 0.628124799170987, -96.6005, -1.68599678407278),
(32504, '74031', 218, 42, 75874, 36.4338, 0.63588976901311, -95.5207, -1.66715071880975),
(32505, '74032', 218, 42, 2739, 36.2265, 0.632271701473726, -96.9289, -1.69172844533633),
(32506, '74033', 218, 42, 75933, 35.9567, 0.627562803151845, -95.9987, -1.67549339263428),
(32507, '74034', 218, 42, 76008, 36.2319, 0.632365949253334, -96.5668, -1.68540860811486),
(32508, '74035', 218, 42, 65723, 36.4127, 0.635521504540939, -96.3941, -1.68239442449667),
(32509, '74036', 218, 42, 76183, 36.1506, 0.630946996571462, -95.5087, -1.66694127929951),
(32510, '74037', 218, 42, 76222, 36.0119, 0.628526224898946, -95.9776, -1.67512512816211),
(32511, '74038', 218, 42, 16612, 36.1938, 0.631700978808324, -96.5892, -1.68579956186731),
(32512, '74039', 218, 42, 36686, 35.9475, 0.627402232860662, -96.2081, -1.67914811208796),
(32513, '74041', 218, 42, 76287, 35.9462, 0.627379543580386, -96.0585, -1.67653709952697),
(32514, '74042', 218, 42, 76367, 36.8513, 0.643176518640186, -95.6351, -1.66914737547403),
(32515, '74043', 218, 42, 3733, 35.9447, 0.627353363641606, -95.7858, -1.67177758665678),
(32516, '74044', 218, 42, 76494, 36.1187, 0.630390236540076, -96.3481, -1.68159157304075),
(32517, '74045', 218, 42, 76500, 36.2173, 0.632111131182542, -96.677, -1.68733196095056),
(32518, '74046', 218, 42, 76605, 35.7551, 0.624044219379824, -96.5651, -1.68537893751758),
(32519, '74047', 218, 42, 10622, 35.8747, 0.62613163316521, -96.0592, -1.67654931683174),
(32520, '74048', 218, 42, 76753, 36.6975, 0.640492202250619, -95.6376, -1.66919100870533),
(32521, '74050', 218, 42, 4709, 36.0764, 0.629651962266482, -96.0667, -1.67668021652564),
(32522, '74051', 218, 42, 76778, 36.6029, 0.638841120778232, -95.9842, -1.67524031989274),
(32523, '74052', 218, 42, 37499, 36.0861, 0.629821259203926, -96.5843, -1.68571404073396),
(32524, '74053', 218, 42, 76832, 36.4455, 0.636093972535593, -95.7096, -1.67044764576676),
(32525, '74054', 218, 42, 11002, 36.294, 0.633449798718822, -96.3817, -1.68217800366942),
(32526, '74055', 218, 42, 76867, 36.2799, 0.633203707294291, -95.8484, -1.67287016276853),
(32527, '74056', 218, 42, 76903, 36.8254, 0.64272447836392, -96.3666, -1.68191445895237),
(32528, '74058', 218, 42, 23789, 36.3303, 0.634083353237296, -96.7754, -1.68904936493452),
(32529, '74059', 218, 42, 11143, 35.9805, 0.62797819151382, -97.0255, -1.69341443339376),
(32530, '74060', 218, 42, 77010, 36.2837, 0.633270029805867, -96.2422, -1.67974326936289),
(32531, '74061', 218, 42, 33718, 36.5632, 0.638148225065191, -95.9065, -1.67388419906394),
(32532, '74062', 218, 42, 5404, 35.9873, 0.628096873902955, -96.8868, -1.69099366172124),
(32533, '74063', 218, 42, 24641, 36.1228, 0.630461795039408, -96.1516, -1.67816200106058),
(32534, '74066', 218, 42, 77183, 35.9999, 0.628316785388707, -96.1127, -1.67748306798155),
(32535, '74067', 218, 42, 77183, 35.9859, 0.628072439293427, -96.1197, -1.67760524102919),
(32536, '74068', 218, 42, 18053, 35.9108, 0.62676169702518, -96.5777, -1.68559884900333),
(32537, '74070', 218, 42, 77261, 36.3612, 0.634622659976162, -95.9826, -1.67521239462471),
(32538, '74071', 218, 42, 77266, 35.7768, 0.624422955827507, -96.2664, -1.68016563904187),
(32539, '74072', 218, 42, 77285, 36.9873, 0.645550166422899, -95.6196, -1.66887684943997),
(32540, '74073', 218, 42, 77306, 36.2899, 0.63337824021949, -95.9663, -1.67492790595663),
(32541, '74074', 218, 42, 12131, 36.108, 0.630203486310112, -97.0769, -1.69431153262928),
(32542, '74075', 218, 42, 12131, 36.1406, 0.630772463646263, -97.0606, -1.69402704396121),
(32543, '74076', 218, 42, 12131, 36.1234, 0.63047226701492, -97.0327, -1.6935400970999),
(32544, '74077', 218, 42, 12131, 36.1197, 0.630407689832596, -97.0662, -1.69412478239932),
(32545, '74078', 218, 42, 12131, 36.1129, 0.63028900744346, -97.0574, -1.69397119342514),
(32546, '74079', 218, 42, 6118, 35.7519, 0.623988368843761, -96.6706, -1.68722025987843),
(32547, '74080', 218, 42, 77404, 36.5306, 0.637579247729041, -95.6958, -1.67020679032999),
(32548, '74081', 218, 42, 77429, 36.1928, 0.631683525515804, -96.4842, -1.68396696615271),
(32549, '74082', 218, 42, 71, 36.4504, 0.636179493668941, -95.8811, -1.67344088543394),
(32550, '74083', 218, 42, 77586, 36.9296, 0.644543111444498, -95.7725, -1.67154545786627),
(32551, '74084', 218, 42, 77733, 36.5493, 0.637905624299164, -96.3208, -1.68111509815495),
(32552, '74085', 218, 42, 12986, 36.1151, 0.630327404687004, -96.7001, -1.68773513200777),
(32553, '74101', 218, 42, 77495, 36.0711, 0.629559459816127, -95.9048, -1.67385452846666),
(32554, '74102', 218, 42, 77495, 36.2428, 0.632556190141801, -95.8297, -1.67254378619841),
(32555, '74103', 218, 42, 77495, 36.1565, 0.63104997099733, -95.994, -1.67541136215944),
(32556, '74104', 218, 42, 77495, 36.1455, 0.63085798477961, -95.9528, -1.67469228650762),
(32557, '74105', 218, 42, 77495, 36.0975, 0.630020226738653, -95.9611, -1.67483714883553),
(32558, '74106', 218, 42, 77495, 36.1849, 0.631545644504896, -95.9823, -1.67520715863695),
(32559, '74107', 218, 42, 77495, 36.1008, 0.630077822603969, -96.0309, -1.67605538865342),
(32560, '74108', 218, 42, 77495, 36.1476, 0.630894636693902, -95.8024, -1.67206731131262),
(32561, '74110', 218, 42, 77495, 36.1829, 0.631510737919856, -95.952, -1.6746783238736),
(32562, '74112', 218, 42, 77495, 36.1482, 0.630905108669414, -95.9053, -1.67386325511292),
(32563, '74114', 218, 42, 77495, 36.126, 0.630517645575471, -95.9482, -1.67461200136202),
(32564, '74115', 218, 42, 77495, 36.1802, 0.631463614030052, -95.9084, -1.67391736031973),
(32565, '74116', 218, 42, 77495, 36.1747, 0.631367620921193, -95.8443, -1.6727986042692),
(32566, '74117', 218, 42, 77495, 36.2355, 0.632428781106405, -95.8866, -1.67353687854279),
(32567, '74119', 218, 42, 77495, 36.1418, 0.630793407597287, -95.9859, -1.67526999049003),
(32568, '74120', 218, 42, 77495, 36.1487, 0.630913835315674, -95.9764, -1.67510418421109),
(32569, '74121', 218, 42, 77495, 36.1494, 0.630926052620438, -95.9762, -1.67510069355258),
(32570, '74126', 218, 42, 77495, 36.238, 0.632472414337705, -95.9836, -1.67522984791723),
(32571, '74127', 218, 42, 77495, 36.1514, 0.630960959205478, -96.0272, -1.6759908114711),
(32572, '74128', 218, 42, 77495, 36.145, 0.63084925813335, -95.8505, -1.67290681468282),
(32573, '74129', 218, 42, 77495, 36.1259, 0.63051590024622, -95.8632, -1.67312847149783),
(32574, '74130', 218, 42, 77495, 36.2394, 0.632496848947233, -95.9575, -1.67477431698246),
(32575, '74131', 218, 42, 77495, 36.0494, 0.629180723368444, -96.0664, -1.67667498053788),
(32576, '74132', 218, 42, 77495, 36.0596, 0.629358746952147, -96.0158, -1.67579184393637),
(32577, '74133', 218, 42, 77495, 36.0477, 0.62915105277116, -95.883, -1.67347404668972),
(32578, '74134', 218, 42, 77495, 36.1137, 0.630302970077476, -95.8228, -1.67242335848002),
(32579, '74135', 218, 42, 77495, 36.0972, 0.630014990750897, -95.9215, -1.67414599845174),
(32580, '74136', 218, 42, 77495, 36.0602, 0.629369218927659, -95.9378, -1.67443048711982),
(32581, '74137', 218, 42, 77495, 36.0251, 0.628756608360209, -95.9251, -1.67420883030481),
(32582, '74141', 218, 42, 77495, 36.1313, 0.630610148025827, -95.8753, -1.67333965633732),
(32583, '74145', 218, 42, 77495, 36.0956, 0.629987065482865, -95.8836, -1.67348451866524),
(32584, '74146', 218, 42, 77495, 36.1034, 0.630123201164521, -95.8531, -1.67295219324338),
(32585, '74147', 218, 42, 77495, 36.0971, 0.630013245421645, -95.8863, -1.67353164255504),
(32586, '74148', 218, 42, 77495, 36.1903, 0.631639892284504, -96.0052, -1.67560683903566),
(32587, '74149', 218, 42, 77495, 36.1604, 0.631118038838158, -96.0361, -1.67614614577453),
(32588, '74150', 218, 42, 77495, 36.1592, 0.631097094887134, -95.9582, -1.67478653428722),
(32589, '74152', 218, 42, 77495, 36.1263, 0.630522881563227, -95.9465, -1.67458233076474),
(32590, '74153', 218, 42, 77495, 36.0975, 0.630020226738653, -95.9228, -1.67416868773202),
(32591, '74155', 218, 42, 77495, 36.098, 0.630028953384913, -95.8779, -1.67338503489787),
(32592, '74156', 218, 42, 77495, 36.2454, 0.632601568702353, -95.9936, -1.67540438084243),
(32593, '74157', 218, 42, 77495, 36.0772, 0.629665924900498, -96.0566, -1.67650393827119),
(32594, '74158', 218, 42, 77495, 36.1656, 0.631208795959261, -95.9175, -1.67407618528166),
(32595, '74159', 218, 42, 77495, 36.1464, 0.630873692742878, -95.9536, -1.67470624914163),
(32596, '74169', 218, 42, 77495, 36.1271, 0.630536844197243, -95.8694, -1.67323668191145),
(32597, '74170', 218, 42, 77495, 36.0423, 0.629056804991552, -95.9465, -1.67458233076474),
(32598, '74171', 218, 42, 77495, 36.1509, 0.630952232559218, -95.9957, -1.67544103275672),
(32599, '74172', 218, 42, 77495, 36.1488, 0.630915580644926, -95.9757, -1.67509196690632),
(32600, '74182', 218, 42, 77495, 36.1531, 0.630990629802762, -95.9946, -1.67542183413495),
(32601, '74183', 218, 42, 77495, 36.0693, 0.629528043889591, -95.9222, -1.6741582157565),
(32602, '74184', 218, 42, 77495, 36.0692, 0.629526298560339, -95.9225, -1.67416345174426),
(32603, '74186', 218, 42, 77495, 36.1501, 0.630938269925202, -95.9948, -1.67542532479345),
(32604, '74187', 218, 42, 77495, 36.15, 0.63093652459595, -95.995, -1.67542881545196),
(32605, '74189', 218, 42, 77495, 36.1498, 0.630933033937446, -95.9759, -1.67509545756483),
(32606, '74192', 218, 42, 77495, 36.1536, 0.630999356449022, -95.9944, -1.67541834347644),
(32607, '74193', 218, 42, 77495, 36.0623, 0.629405870841951, -95.923, -1.67417217839052),
(32608, '74194', 218, 42, 77495, 36.0626, 0.629411106829707, -95.9221, -1.67415647042725),
(32609, '74301', 218, 42, 77562, 36.6422, 0.639527035174266, -95.156, -1.66078550302772),
(32610, '74330', 218, 42, 34502, 36.4379, 0.635961327512442, -95.2671, -1.66272456382669),
(32611, '74331', 218, 42, 570, 36.6928, 0.640410171775775, -94.9603, -1.65736989368157),
(32612, '74332', 218, 42, 75123, 36.6743, 0.640087285864156, -95.3017, -1.66332844774788),
(32613, '74333', 218, 42, 75161, 36.8051, 0.642370176525765, -95.1231, -1.66021128970382),
(32614, '74335', 218, 42, 75331, 36.9758, 0.645349453558919, -94.8514, -1.65546923012615),
(32615, '74337', 218, 42, 32071, 36.1898, 0.631631165638244, -95.3349, -1.66390789705954),
(32616, '74338', 218, 42, 75498, 36.2483, 0.632652183250661, -94.6722, -1.65234160010658),
(32617, '74339', 218, 42, 1726, 36.9294, 0.644539620785994, -94.8702, -1.65579735202552),
(32618, '74340', 218, 42, 75664, 36.4811, 0.636715309749303, -95.0151, -1.65832633411166),
(32619, '74342', 218, 42, 75789, 36.3735, 0.634837335474157, -94.9144, -1.65656878755491),
(32620, '74343', 218, 42, 8820, 36.7494, 0.641398028132404, -94.8488, -1.6554238515656),
(32621, '74344', 218, 42, 32640, 36.5891, 0.638600265341457, -94.7724, -1.65409042001707),
(32622, '74345', 218, 42, 32640, 36.5953, 0.638708475755081, -94.7874, -1.65435221940487),
(32623, '74346', 218, 42, 9722, 36.4193, 0.635636696271571, -94.7969, -1.65451802568381),
(32624, '74347', 218, 42, 3481, 36.2381, 0.632474159666957, -94.8205, -1.65492992338728),
(32625, '74349', 218, 42, 76278, 36.5247, 0.637476273303173, -95.0258, -1.65851308434163),
(32626, '74350', 218, 42, 9983, 36.4634, 0.6364063864717, -95.0475, -1.65889182078931),
(32627, '74352', 218, 42, 901, 36.1989, 0.631789990600175, -95.1666, -1.66097050792844),
(32628, '74354', 218, 42, 17102, 36.882, 0.643712334720549, -94.8743, -1.65586891052486),
(32629, '74355', 218, 42, 17102, 36.8932, 0.643907811596772, -94.8753, -1.65588636381738),
(32630, '74358', 218, 42, 17308, 36.9169, 0.644321454629495, -94.8817, -1.6559980648895),
(32631, '74359', 218, 42, 37485, 36.1688, 0.631264646495325, -94.8605, -1.65562805508808),
(32632, '74360', 218, 42, 76943, 36.9841, 0.645494315886835, -94.8328, -1.65514459888528),
(32633, '74361', 218, 42, 11420, 36.2978, 0.633516121230398, -95.3094, -1.66346283810028),
(32634, '74362', 218, 42, 11420, 36.2927, 0.633427109438546, -95.3187, -1.66362515372072),
(32635, '74363', 218, 42, 77024, 36.9536, 0.644961990464977, -94.7884, -1.65436967269739),
(32636, '74364', 218, 42, 17851, 36.2182, 0.63212683914581, -94.9876, -1.65784636856737),
(32637, '74365', 218, 42, 31053, 36.295, 0.633467252011342, -95.1533, -1.66073837913792),
(32638, '74366', 218, 42, 77298, 36.4286, 0.635799011892006, -95.0112, -1.65825826627084),
(32639, '74367', 218, 42, 77355, 36.4551, 0.636261524143785, -95.0841, -1.65953061129554),
(32640, '74368', 218, 42, 12426, 36.1953, 0.631727158747104, -94.8657, -1.65571881220918),
(32641, '74369', 218, 42, 6684, 36.8754, 0.643597142989917, -95.0927, -1.65968070961121),
(32642, '74370', 218, 42, 31570, 36.7953, 0.642199134259069, -94.722, -1.65321077407407),
(32643, '74401', 218, 42, 76669, 35.7537, 0.624019784770297, -95.3894, -1.66485910150188),
(32644, '74402', 218, 42, 76669, 35.7607, 0.624141957817936, -95.3769, -1.66464093534538),
(32645, '74403', 218, 42, 76669, 35.7398, 0.623777184004269, -95.3492, -1.66415747914258),
(32646, '74421', 218, 42, 39312, 35.7419, 0.623813835918561, -96.0677, -1.67669766981816),
(32647, '74422', 218, 42, 7637, 35.6675, 0.622515310955077, -95.6705, -1.66976522202924),
(32648, '74423', 218, 42, 214, 35.6747, 0.622640974661221, -95.1748, -1.6611136249271),
(32649, '74425', 218, 42, 75313, 35.1565, 0.613596678477387, -95.6212, -1.668904774708),
(32650, '74426', 218, 42, 75413, 35.4692, 0.619054323048373, -95.5248, -1.66722227730908),
(32651, '74427', 218, 42, 75516, 35.81, 0.625002405139169, -95.0774, -1.65941367423566),
(32652, '74428', 218, 42, 75542, 35.5361, 0.620221948317957, -95.7153, -1.67054712953413),
(32653, '74429', 218, 42, 75551, 35.956, 0.627550585847081, -95.6565, -1.66952087593396),
(32654, '74430', 218, 42, 46143, 35.1238, 0.613025955811984, -95.67, -1.66975649538298),
(32655, '74431', 218, 42, 75648, 35.448, 0.61868431324695, -95.9633, -1.67487554607907),
(32656, '74432', 218, 42, 2331, 35.2873, 0.615879569138995, -95.5824, -1.66822758695823),
(32657, '74434', 218, 42, 75861, 35.7995, 0.62481914556771, -95.248, -1.66239120593956),
(32658, '74435', 218, 42, 811, 35.5297, 0.620110247245829, -95.1184, -1.66012925922897),
(32659, '74436', 218, 42, 9374, 35.8174, 0.625131559503817, -95.6722, -1.66979489262652),
(32660, '74437', 218, 42, 76069, 35.4407, 0.618556904211554, -95.9858, -1.67526824516077),
(32661, '74438', 218, 42, 76099, 35.5195, 0.619932223662126, -95.7522, -1.67119115602811),
(32662, '74440', 218, 42, 9600, 35.272, 0.61561253376344, -95.3012, -1.66331972110162),
(32663, '74441', 218, 42, 9611, 35.9463, 0.627381288909638, -95.2298, -1.6620735560157),
(32664, '74442', 218, 42, 16542, 35.0965, 0.61254948092619, -95.799, -1.67200797011805),
(32665, '74444', 218, 42, 76625, 36.0312, 0.628863073444581, -94.9573, -1.65731753380401),
(32666, '74445', 218, 42, 4333, 35.6088, 0.621490802684157, -95.8587, -1.67304993168149),
(32667, '74446', 218, 42, 10931, 35.85, 0.625700536839967, -95.3183, -1.66361817240371),
(32668, '74447', 218, 42, 76805, 35.6239, 0.621754347401208, -95.967, -1.6749401232614),
(32669, '74450', 218, 42, 76808, 35.6292, 0.621846849851564, -95.5141, -1.66703552707912),
(32670, '74451', 218, 42, 4867, 35.6494, 0.622199406360467, -95.0236, -1.65847468709808),
(32671, '74452', 218, 42, 76919, 36.08, 0.629714794119554, -94.9819, -1.6577468848),
(32672, '74454', 218, 42, 5186, 35.8504, 0.625707518156975, -95.5135, -1.6670250551036),
(32673, '74455', 218, 42, 76985, 35.3662, 0.617256633918819, -95.2483, -1.66239644192731),
(32674, '74456', 218, 42, 5220, 35.7117, 0.623286746484459, -95.9917, -1.67537121958664),
(32675, '74457', 218, 42, 5236, 35.9706, 0.627805403917872, -94.7455, -1.65362092644829),
(32676, '74458', 218, 42, 37881, 35.8868, 0.626342818004701, -95.5882, -1.66832881605484),
(32677, '74459', 218, 42, 77078, 35.5202, 0.61994444096689, -95.4927, -1.66666202661919),
(32678, '74460', 218, 42, 77195, 35.5144, 0.619843211870274, -95.9559, -1.67474639171443),
(32679, '74461', 218, 42, 38382, 35.3888, 0.617651078329769, -95.709, -1.67043717379125),
(32680, '74462', 218, 42, 77340, 35.2577, 0.615362951680405, -95.1222, -1.66019558174055),
(32681, '74463', 218, 42, 6212, 35.7641, 0.624201299012504, -95.5447, -1.66756959783023),
(32682, '74464', 218, 42, 77400, 35.9129, 0.626798348939472, -94.9686, -1.65751475600949),
(32683, '74465', 218, 42, 77400, 35.9033, 0.62663079733128, -94.9844, -1.6577905180313),
(32684, '74466', 218, 42, 77494, 35.842, 0.625560910499808, -95.4405, -1.66575096474965),
(32685, '74467', 218, 42, 58096, 35.9584, 0.627592473749129, -95.3729, -1.6645711221753),
(32686, '74468', 218, 42, 6596, 35.6129, 0.621562361183489, -95.5655, -1.66793262631464),
(32687, '74469', 218, 42, 12662, 35.4891, 0.61940164356952, -95.3049, -1.66338429828394),
(32688, '74470', 218, 42, 77632, 35.5128, 0.619815286602242, -95.1293, -1.66031950011744),
(32689, '74471', 218, 42, 77639, 35.9186, 0.626897832706835, -94.8546, -1.65552508066221),
(32690, '74472', 218, 42, 12825, 35.2479, 0.615191909413709, -95.2282, -1.66204563074766),
(32691, '74477', 218, 42, 58096, 35.9608, 0.627634361651177, -95.3681, -1.6644873463712),
(32692, '74501', 218, 42, 76541, 34.9344, 0.609720302208707, -95.7638, -1.67139361422135),
(32693, '74502', 218, 42, 76541, 34.9293, 0.609631290416855, -95.7666, -1.6714424834404),
(32694, '74521', 218, 42, 7043, 34.6621, 0.604967770655527, -95.0992, -1.65979415601259),
(32695, '74522', 218, 42, 74956, 34.9007, 0.609132126250785, -95.691, -1.67012301452589),
(32696, '74523', 218, 42, 75000, 34.2338, 0.597492525469235, -95.6156, -1.66880703626989),
(32697, '74525', 218, 42, 34614, 34.3833, 0.600101792700966, -96.1339, -1.67785307778298),
(32698, '74528', 218, 42, 7529, 34.7682, 0.606819564991892, -95.7961, -1.67195735556974),
(32699, '74529', 218, 42, 371, 35.0643, 0.611987484907048, -95.5686, -1.66798673152145),
(32700, '74530', 218, 42, 75230, 34.4188, 0.600721384585424, -96.4967, -1.68418513230921),
(32701, '74531', 218, 42, 7856, 34.8347, 0.607980208944469, -96.2925, -1.68062116997664),
(32702, '74533', 218, 42, 7883, 34.2083, 0.597047466509976, -96.2684, -1.68020054562691),
(32703, '74534', 218, 42, 75395, 34.5984, 0.603855995922006, -96.3262, -1.68120934593456),
(32704, '74535', 218, 42, 75458, 34.4827, 0.601836649977449, -96.4331, -1.68307510290494),
(32705, '74536', 218, 42, 608, 34.5754, 0.603454570194047, -95.482, -1.66647527638923),
(32706, '74538', 218, 42, 807, 34.5362, 0.602770401127266, -96.2197, -1.67935057028119),
(32707, '74540', 218, 42, 1947, 34.5514, 0.603035691173569, -95.7354, -1.67089794071378),
(32708, '74542', 218, 42, 34614, 34.3287, 0.599148842929377, -96.1794, -1.67864720259263),
(32709, '74543', 218, 42, 2445, 34.3461, 0.599452530219224, -95.5515, -1.66768828021936),
(32710, '74545', 218, 42, 41140, 34.8813, 0.608793532375898, -95.4768, -1.66638451926812),
(32711, '74546', 218, 42, 76003, 34.8478, 0.60820884707648, -95.5662, -1.6679448436194),
(32712, '74547', 218, 42, 76038, 34.8454, 0.608166959174432, -95.5595, -1.66782790655952),
(32713, '74549', 218, 42, 76123, 35.0262, 0.611322514462038, -94.6185, -1.65140435829825),
(32714, '74552', 218, 42, 76293, 35.1777, 0.613966688278809, -95.2972, -1.66324990793154),
(32715, '74553', 218, 42, 3553, 34.7258, 0.606079545389047, -95.9051, -1.67385976445441),
(32716, '74554', 218, 42, 36759, 34.9335, 0.609704594245439, -95.7206, -1.67063963198448),
(32717, '74555', 218, 42, 3658, 34.3863, 0.600154152578526, -96.1255, -1.67770647012581),
(32718, '74556', 218, 42, 3725, 34.4693, 0.601602775857681, -96.2201, -1.6793575515982),
(32719, '74557', 218, 42, 76655, 34.3495, 0.599511871413792, -95.6719, -1.66978965663876),
(32720, '74558', 218, 42, 112507, 34.53, 0.602662190713642, -95.1818, -1.66123579797474),
(32721, '74559', 218, 42, 4851, 34.9283, 0.609613837124335, -95.2126, -1.66177335938435),
(32722, '74560', 218, 42, 5099, 34.6567, 0.604873522875919, -95.8146, -1.67228024148136),
(32723, '74561', 218, 42, 5264, 35.1068, 0.612729249839145, -95.5121, -1.66700062049408),
(32724, '74562', 218, 42, 42743, 34.3081, 0.598789305103467, -95.2672, -1.66272630915594),
(32725, '74563', 218, 42, 5318, 34.9458, 0.609919269743434, -95.0802, -1.65946254345471),
(32726, '74565', 218, 42, 77189, 34.8297, 0.607892942481869, -95.8384, -1.67269562984333),
(32727, '74567', 218, 42, 12014, 34.4434, 0.601150735581415, -95.4276, -1.66552581727614),
(32728, '74569', 218, 42, 12157, 34.4678, 0.601576595918901, -96.0507, -1.67640096384532),
(32729, '74570', 218, 42, 12169, 34.8939, 0.609013443861649, -96.1579, -1.67827195680346),
(32730, '74571', 218, 42, 77406, 34.7514, 0.606526349677557, -95.035, -1.65867365463281),
(32731, '74572', 218, 42, 6408, 34.6049, 0.603969442323386, -96.4179, -1.68280981285864),
(32732, '74574', 218, 42, 77505, 34.7407, 0.606339599447594, -95.2632, -1.66265649598586),
(32733, '74576', 218, 42, 44028, 34.6083, 0.604028783517954, -95.9985, -1.67548990197578),
(32734, '74577', 218, 42, 6799, 34.69, 0.605454717516833, -94.8603, -1.65562456442958),
(32735, '74578', 218, 42, 77681, 34.9127, 0.609341565761024, -95.3101, -1.66347505540505),
(32736, '74601', 218, 42, 76975, 36.7097, 0.640705132419362, -97.0859, -1.69446861226196),
(32737, '74602', 218, 42, 76975, 36.7201, 0.64088664666157, -97.0812, -1.69438658178712),
(32738, '74603', 218, 42, 76975, 36.7241, 0.64095645983165, -97.0688, -1.69417016095987),
(32739, '74604', 218, 42, 76975, 36.7252, 0.640975658453422, -97.043, -1.69371986601286),
(32740, '74630', 218, 42, 53485, 36.5286, 0.637544341144001, -97.4456, -1.70074656158139),
(32741, '74631', 218, 42, 7523, 36.7998, 0.642277674075409, -97.2887, -1.69800813998501),
(32742, '74632', 218, 42, 75204, 36.9237, 0.64444013701863, -97.3337, -1.6987935381484),
(32743, '74633', 218, 42, 1232, 36.696, 0.640466022311839, -96.7291, -1.68824127749085),
(32744, '74636', 218, 42, 8452, 36.8031, 0.642335269940725, -97.5067, -1.70181295775435),
(32745, '74637', 218, 42, 13733, 36.5714, 0.638291342063854, -96.7087, -1.68788523032344),
(32746, '74640', 218, 42, 3284, 36.5696, 0.638259926137318, -97.6005, -1.70345007659273),
(32747, '74641', 218, 42, 76250, 36.7632, 0.641638883569179, -96.8619, -1.6905590747375),
(32748, '74643', 218, 42, 9971, 36.6904, 0.640368283873727, -97.5576, -1.70270133034362),
(32749, '74644', 218, 42, 17033, 36.5615, 0.638118554467907, -97.1523, -1.69562751088529),
(32750, '74646', 218, 42, 76680, 36.8052, 0.642371921855017, -97.4469, -1.70076925086166),
(32751, '74647', 218, 42, 73686, 36.8825, 0.643721061366809, -97.0536, -1.69390487091357),
(32752, '74650', 218, 42, 965, 36.4949, 0.636956165186079, -96.7853, -1.68922215253047),
(32753, '74651', 218, 42, 5319, 36.4767, 0.636638515262216, -97.1692, -1.69592247152887),
(32754, '74652', 218, 42, 77240, 36.7885, 0.642080451869934, -96.6618, -1.68706667090425),
(32755, '74653', 218, 42, 77462, 36.6813, 0.640209458911796, -97.3038, -1.69827168470206),
(32756, '74701', 218, 42, 15836, 34.0035, 0.593473032201892, -96.3823, -1.68218847564493),
(32757, '74702', 218, 42, 15836, 33.9302, 0.59219370586018, -96.4329, -1.68307161224644),
(32758, '74720', 218, 42, 74929, 33.9261, 0.592122147360848, -96.2632, -1.68010978850581),
(32759, '74721', 218, 42, 18772, 33.8811, 0.591336749197451, -96.1623, -1.67834875129054),
(32760, '74722', 218, 42, 75075, 34.3937, 0.600283306943174, -94.9248, -1.65675030179711),
(32761, '74723', 218, 42, 26498, 33.9758, 0.592989575999089, -96.0017, -1.67554575251184),
(32762, '74724', 218, 42, 220, 34.3547, 0.599602628534896, -94.8448, -1.65535403839552),
(32763, '74726', 218, 42, 75166, 34.0185, 0.593734831589691, -96.1403, -1.6779647788551),
(32764, '74727', 218, 42, 7613, 34.0317, 0.593965215050954, -95.8328, -1.67259789140522),
(32765, '74728', 218, 42, 75227, 34.0267, 0.593877948588355, -94.7375, -1.65348130010813),
(32766, '74729', 218, 42, 1272, 34.1257, 0.595605824547829, -96.2648, -1.68013771377384),
(32767, '74730', 218, 42, 1293, 33.9344, 0.592267009688764, -96.43, -1.68302099769813),
(32768, '74731', 218, 42, 1387, 33.8854, 0.591411798355286, -96.5499, -1.68511364747127),
(32769, '74733', 218, 42, 1683, 33.8573, 0.590921360835476, -96.5048, -1.68432650397862),
(32770, '74734', 218, 42, 64330, 34.0726, 0.59467905471502, -94.5594, -1.65037286871033),
(32771, '74735', 218, 42, 75863, 34.046, 0.594214797133989, -95.2564, -1.66253781359673),
(32772, '74736', 218, 42, 32532, 33.9195, 0.592006955630217, -94.9313, -1.65686374819849),
(32773, '74737', 218, 42, 54988, 34.0341, 0.594007102953002, -94.8951, -1.65623193900927),
(32774, '74738', 218, 42, 104, 33.9136, 0.591903981204349, -95.4684, -1.66623791161095),
(32775, '74740', 218, 42, 76048, 33.8438, 0.590685741386457, -94.6501, -1.65195588234188),
(32776, '74741', 218, 42, 3060, 33.7942, 0.589820058077468, -96.3115, -1.68095278253452),
(32777, '74743', 218, 42, 3275, 34.0091, 0.593570770640004, -95.5136, -1.66702680043286),
(32778, '74745', 218, 42, 76164, 33.8945, 0.591570623317218, -94.8251, -1.65501020853288),
(32779, '74747', 218, 42, 22339, 33.7691, 0.589381980435217, -96.3544, -1.68170152878362),
(32780, '74748', 218, 42, 76268, 34.1224, 0.595548228682513, -96.4061, -1.68260386400691),
(32781, '74750', 218, 42, 33288, 33.9898, 0.593233922094369, -95.0193, -1.65839963794025),
(32782, '74752', 218, 42, 11179, 34.3959, 0.600321704186718, -95.0117, -1.6582669929171),
(32783, '74753', 218, 42, 76964, 33.9069, 0.591787044144465, -96.5344, -1.68484312143721),
(32784, '74754', 218, 42, 77097, 34.1938, 0.596794393768437, -95.0704, -1.65929150118802),
(32785, '74755', 218, 42, 77144, 34.1584, 0.596176547213231, -95.1256, -1.66025492293512),
(32786, '74756', 218, 42, 33898, 34.0437, 0.594174654561194, -95.366, -1.66445069445691),
(32787, '74759', 218, 42, 77281, 34.0205, 0.593769738174731, -95.689, -1.67008810794085),
(32788, '74760', 218, 42, 51592, 34.133, 0.595733233583225, -95.3938, -1.66493589598897),
(32789, '74761', 218, 42, 6198, 34.0177, 0.593720868955675, -95.2019, -1.66158660915439),
(32790, '74764', 218, 42, 52361, 34.0029, 0.59346256022638, -95.0923, -1.6596737282942),
(32791, '74766', 218, 42, 58369, 34.1527, 0.596077063445867, -94.9775, -1.65767009031291),
(32792, '74801', 218, 42, 5783, 35.3471, 0.616923276031688, -96.9265, -1.69168655743428),
(32793, '74802', 218, 42, 5783, 35.3277, 0.616584682156801, -96.9202, -1.69157660169141),
(32794, '74804', 218, 42, 5783, 35.3267, 0.616567228864281, -96.9245, -1.69165165084924),
(32795, '74818', 218, 42, 5735, 35.2243, 0.614780011710239, -96.6703, -1.68721502389067),
(32796, '74820', 218, 42, 7026, 34.7731, 0.60690508612524, -96.6686, -1.68718535329339),
(32797, '74821', 218, 42, 7026, 34.774, 0.606920794088508, -96.6778, -1.68734592358457),
(32798, '74824', 218, 42, 31607, 35.8946, 0.626478953686357, -96.8749, -1.69078596754025),
(32799, '74825', 218, 42, 18798, 34.878, 0.608735936510582, -96.4147, -1.68275396232258),
(32800, '74826', 218, 42, 7175, 34.9933, 0.610748301138132, -96.9236, -1.69163594288598),
(32801, '74827', 218, 42, 7189, 34.9291, 0.609627799758351, -96.3479, -1.68158808238224),
(32802, '74829', 218, 42, 39427, 35.4956, 0.619515089970899, -96.4872, -1.68401932603027),
(32803, '74830', 218, 42, 75187, 35.1475, 0.613439598844707, -96.669, -1.6871923346104),
(32804, '74831', 218, 42, 75281, 34.8731, 0.608650415377235, -97.0468, -1.69378618852443),
(32805, '74832', 218, 42, 1363, 35.8067, 0.624944809273854, -97.0167, -1.69326084441958),
(32806, '74833', 218, 42, 75361, 35.4826, 0.61928819716814, -96.3712, -1.68199474409796),
(32807, '74834', 218, 42, 656, 35.7051, 0.623171554753827, -96.8834, -1.69093432052667),
(32808, '74836', 218, 42, 75510, 34.3545, 0.599599137876392, -96.6579, -1.68699860306343),
(32809, '74837', 218, 42, 1893, 35.3484, 0.616945965311964, -96.4601, -1.68354634180298),
(32810, '74839', 218, 42, 75711, 35.2249, 0.614790483685751, -96.0689, -1.67671861376918),
(32811, '74840', 218, 42, 75723, 35.2492, 0.615214598693985, -96.8039, -1.68954678377134),
(32812, '74842', 218, 42, 75829, 34.6242, 0.604306290869021, -96.6729, -1.68726040245123),
(32813, '74843', 218, 42, 8895, 34.6586, 0.604906684131707, -96.7664, -1.68889228530184),
(32814, '74844', 218, 42, 2591, 34.8747, 0.608678340645266, -96.5924, -1.68585541240337),
(32815, '74845', 218, 42, 9318, 35.2154, 0.614624677406811, -95.8818, -1.6734531027387),
(32816, '74848', 218, 42, 76111, 35.0827, 0.612308625489415, -96.3975, -1.68245376569123),
(32817, '74849', 218, 42, 76301, 34.9586, 0.61014267188769, -96.7517, -1.6886357219018),
(32818, '74850', 218, 42, 244, 35.1043, 0.612685616607845, -96.0967, -1.67720381530123),
(32819, '74851', 218, 42, 76564, 35.4203, 0.618200857044148, -97.0972, -1.69466583446744),
(32820, '74852', 218, 42, 56039, 35.1187, 0.612936944020133, -97.035, -1.6935802396727),
(32821, '74854', 218, 42, 4040, 35.1316, 0.61316209149364, -96.7794, -1.6891191781046),
(32822, '74855', 218, 42, 42058, 35.5017, 0.619621555055271, -96.8969, -1.69116993997569),
(32823, '74856', 218, 42, 429, 34.3396, 0.599339083817845, -96.8242, -1.68990108560949),
(32824, '74857', 218, 42, 76704, 35.3285, 0.616598644790817, -97.2009, -1.69647574090176),
(32825, '74859', 218, 42, 76794, 35.4332, 0.618426004517655, -96.3027, -1.68079919356034),
(32826, '74860', 218, 42, 61206, 35.5084, 0.619738492115155, -96.5681, -1.68543129739514),
(32827, '74864', 218, 42, 11363, 35.4869, 0.619363246325976, -96.688, -1.68752394716828),
(32828, '74865', 218, 42, 543, 34.633, 0.604459879843196, -96.8384, -1.69014892236328),
(32829, '74866', 218, 42, 24604, 35.0794, 0.612251029624099, -96.8523, -1.6903915231293),
(32830, '74867', 218, 42, 77186, 34.9519, 0.610025734827806, -96.5433, -1.68499845574064),
(32831, '74868', 218, 42, 5735, 35.2352, 0.614970252598706, -96.6743, -1.68728483706075),
(32832, '74869', 218, 42, 25000, 35.6239, 0.621754347401208, -96.8107, -1.68966546616047),
(32833, '74871', 218, 42, 6104, 34.6557, 0.604856069583399, -96.523, -1.68464415390249),
(32834, '74872', 218, 42, 14683, 34.7959, 0.607303021194695, -96.956, -1.69220142956362),
(32835, '74873', 218, 42, 6262, 35.2589, 0.615383895631429, -96.937, -1.69186981700574),
(32836, '74875', 218, 42, 18385, 35.8609, 0.625890777728434, -97.0421, -1.69370415804959),
(32837, '74878', 218, 42, 77585, 34.9618, 0.610198522423754, -97.0305, -1.69350169985636),
(32838, '74880', 218, 42, 77637, 35.3368, 0.616743507118732, -96.1301, -1.6777867552714),
(32839, '74881', 218, 42, 58192, 35.6917, 0.62293768063406, -97.0648, -1.69410034778979),
(32840, '74883', 218, 42, 77663, 35.2384, 0.61502610313477, -96.2407, -1.67971708942411),
(32841, '74884', 218, 42, 77665, 35.1493, 0.613471014771243, -96.4946, -1.68414848039492),
(32842, '74901', 218, 42, 75012, 35.3537, 0.617038467762319, -94.4381, -1.64825578432766),
(32843, '74902', 218, 42, 76972, 35.276, 0.61568234693352, -94.4492, -1.64844951587463),
(32844, '74930', 218, 42, 75168, 35.1259, 0.613062607726276, -94.8029, -1.65462274543893),
(32845, '74931', 218, 42, 75263, 35.7178, 0.623393211568831, -94.7426, -1.65357031189998),
(32846, '74932', 218, 42, 806, 35.1485, 0.613457052137227, -94.4953, -1.6492541126598),
(32847, '74935', 218, 42, 75817, 34.951, 0.610010026864538, -94.9077, -1.65645185049502),
(32848, '74936', 218, 42, 75897, 35.3893, 0.617659804976029, -94.6918, -1.65268368463997),
(32849, '74937', 218, 42, 76059, 34.8858, 0.608872072192238, -94.6028, -1.65113034160569),
(32850, '74939', 218, 42, 76108, 34.7568, 0.606620597457165, -94.6015, -1.65110765232542),
(32851, '74940', 218, 42, 3253, 34.9273, 0.609596383831815, -94.7, -1.65282680163863),
(32852, '74941', 218, 42, 55657, 35.2903, 0.615931929016555, -94.9011, -1.65633665876439),
(32853, '74942', 218, 42, 60610, 34.8986, 0.609095474336493, -94.9801, -1.65771546887347),
(32854, '74943', 218, 42, 76376, 35.1045, 0.612689107266349, -95.1077, -1.65994250899901),
(32855, '74944', 218, 42, 76549, 35.1306, 0.61314463820112, -95.0235, -1.65847294176883),
(32856, '74945', 218, 42, 76501, 35.5801, 0.620989893188834, -94.8209, -1.65493690470429),
(32857, '74946', 218, 42, 76619, 35.39, 0.617672022280793, -94.4474, -1.64841809994809),
(32858, '74947', 218, 42, 10560, 34.992, 0.610725611857856, -94.5167, -1.64962761311972),
(32859, '74948', 218, 42, 60990, 35.4091, 0.618005380167924, -94.5971, -1.65103085783833),
(32860, '74949', 218, 42, 76667, 34.6788, 0.60525924064061, -94.692, -1.65268717529847),
(32861, '74951', 218, 42, 28181, 35.1652, 0.61374852212231, -94.6704, -1.65231018418004),
(32862, '74953', 218, 42, 76989, 35.0637, 0.611977012931536, -94.6181, -1.65139737698125),
(32863, '74954', 218, 42, 5513, 35.4152, 0.618111845252296, -94.5105, -1.6495194027061),
(32864, '74955', 218, 42, 77165, 35.4601, 0.618895498086441, -94.7879, -1.65436094605113),
(32865, '74956', 218, 42, 77224, 35.1272, 0.613085297006552, -94.6714, -1.65232763747256),
(32866, '74957', 218, 42, 12002, 34.4824, 0.601831413989693, -94.5803, -1.65073764252399),
(32867, '74959', 218, 42, 38325, 35.2456, 0.615151766840913, -94.6104, -1.65126298662884),
(32868, '74960', 218, 42, 34058, 35.8171, 0.625126323516061, -94.6272, -1.65155620194318),
(32869, '74962', 218, 42, 77552, 35.5282, 0.620084067307049, -94.9636, -1.65742748954689),
(32870, '74963', 218, 42, 6657, 34.3157, 0.598921950126618, -94.5668, -1.65050202307497),
(32871, '74964', 218, 42, 877, 36.1161, 0.630344857979524, -94.6627, -1.65217579382764),
(32872, '74965', 218, 42, 12776, 35.99, 0.628143997792759, -94.5721, -1.65059452552533),
(32873, '74966', 218, 42, 77706, 34.9235, 0.60953006132024, -94.8616, -1.65564725370985),
(32874, '75001', 218, 51, 34507, 32.9598, 0.575257030798827, -96.8292, -1.68998835207209),
(32875, '75002', 218, 51, 18798, 33.0926, 0.577574828045475, -96.6247, -1.68641915375177),
(32876, '75006', 218, 51, 1380, 32.9616, 0.575288446725363, -96.8916, -1.69107743752534),
(32877, '75007', 218, 51, 1380, 33.0067, 0.576075590218012, -96.8902, -1.69105300291581),
(32878, '75008', 218, 51, 1380, 33.0354, 0.576576499713335, -96.8849, -1.69096050046545),
(32879, '75009', 218, 51, 29423, 33.3391, 0.581877064651642, -96.7593, -1.68876836692495),
(32880, '75010', 218, 51, 1380, 33.0286, 0.576457817324199, -96.8763, -1.69081040214978),
(32881, '75011', 218, 51, 1380, 32.9536, 0.575148820385203, -96.8903, -1.69105474824506),
(32882, '75013', 218, 51, 18798, 33.1142, 0.577951819163906, -96.6958, -1.68766008284993),
(32883, '75014', 218, 51, 27519, 32.842, 0.573201032939978, -96.9722, -1.69248417290245),
(32884, '75015', 218, 51, 27519, 32.8974, 0.574167945345583, -96.9761, -1.69255224074327),
(32885, '75016', 218, 51, 27519, 32.9017, 0.574242994503418, -96.9775, -1.6925766753528),
(32886, '75017', 218, 51, 27519, 32.8123, 0.572682670152135, -96.9475, -1.6920530765772),
(32887, '75019', 218, 51, 93435, 32.9656, 0.575358259895443, -96.9863, -1.69273026432698),
(32888, '75020', 218, 51, 32227, 33.7484, 0.589020697280054, -96.5611, -1.6853091243475),
(32889, '75021', 218, 51, 32227, 33.7559, 0.589151596973954, -96.5369, -1.68488675466851),
(32890, '75022', 218, 51, 94249, 33.015, 0.576220452545928, -97.1317, -1.69526797305938),
(32891, '75023', 218, 51, 5105, 33.0555, 0.576927310892986, -96.7371, -1.68838090383101),
(32892, '75024', 218, 51, 5105, 33.0737, 0.577244960816849, -96.804, -1.68954852910059),
(32893, '75025', 218, 51, 5105, 33.0848, 0.57743869236382, -96.7516, -1.68863397657255),
(32894, '75026', 218, 51, 5105, 33.0375, 0.576613151627627, -96.7331, -1.68831109066093),
(32895, '75027', 218, 51, 94249, 33.0278, 0.576443854690183, -97.0928, -1.69458903998035),
(32896, '75028', 218, 51, 94249, 33.0351, 0.576571263725579, -97.0825, -1.69440927106739),
(32897, '75029', 218, 51, 10065, 33.0458, 0.576758013955542, -97.0073, -1.6930967834699),
(32898, '75030', 218, 51, 97670, 32.9024, 0.574255211808182, -96.5633, -1.68534752159104),
(32899, '75032', 218, 51, 97584, 32.8582, 0.573483776278801, -96.4261, -1.6829529298573),
(32900, '75034', 218, 51, 2620, 33.1526, 0.578622025596672, -96.85, -1.69035138055651),
(32901, '75035', 218, 51, 2620, 33.1663, 0.578861135704195, -96.776, -1.68905983691003),
(32902, '75037', 218, 51, 27519, 32.8299, 0.572989848100486, -96.9803, -1.69262554457186),
(32903, '75038', 218, 51, 27519, 32.8705, 0.573698451776796, -96.9779, -1.69258365666981),
(32904, '75039', 218, 51, 27519, 32.8896, 0.574031809663927, -96.943, -1.69197453676086),
(32905, '75040', 218, 51, 2663, 32.9251, 0.574651401548385, -96.62, -1.68633712327692),
(32906, '75041', 218, 51, 2663, 32.8808, 0.573878220689751, -96.6415, -1.6867123690661),
(32907, '75042', 218, 51, 2663, 32.9137, 0.574452434013658, -96.6724, -1.68725167580497),
(32908, '75043', 218, 51, 2663, 32.8577, 0.573475049632541, -96.5989, -1.68596885880475),
(32909, '75044', 218, 51, 2663, 32.9679, 0.575398402468239, -96.661, -1.68705270827024),
(32910, '75045', 218, 51, 2663, 32.9453, 0.575003958057288, -96.6821, -1.68742097274241),
(32911, '75046', 218, 51, 2663, 32.9165, 0.574501303232713, -96.6422, -1.68672458637086),
(32912, '75047', 218, 51, 2663, 32.8766, 0.573804916861168, -96.648, -1.68682581546748),
(32913, '75048', 218, 51, 97719, 32.9731, 0.575489159589342, -96.5896, -1.68580654318432),
(32914, '75049', 218, 51, 2663, 32.8567, 0.573457596340021, -96.6031, -1.68604216263333),
(32915, '75050', 218, 51, 41157, 32.7726, 0.571989774439094, -97.0042, -1.69304267826308),
(32916, '75051', 218, 51, 41157, 32.7151, 0.570986210119197, -96.9964, -1.69290654258143),
(32917, '75052', 218, 51, 41157, 32.6786, 0.570349164942219, -97.0107, -1.69315612466446),
(32918, '75053', 218, 51, 41157, 32.7512, 0.571616273979167, -97.0283, -1.69346330261281),
(32919, '75054', 218, 51, 41157, 32.7455, 0.571516790211803, -96.9975, -1.6929257412032),
(32920, '75056', 218, 51, 283, 33.068, 0.577145477049485, -96.8978, -1.69118564793896),
(32921, '75057', 218, 51, 10065, 33.0504, 0.576838299101134, -96.9991, -1.69295366647123),
(32922, '75058', 218, 51, 94661, 33.4486, 0.583788200182575, -96.7482, -1.68857463537798),
(32923, '75060', 218, 51, 27519, 32.8, 0.57246799465414, -96.9489, -1.69207751118673),
(32924, '75061', 218, 51, 27519, 32.8254, 0.572911308284147, -96.9555, -1.69219270291736),
(32925, '75062', 218, 51, 27519, 32.8475, 0.573297026048837, -96.965, -1.6923585091963),
(32926, '75063', 218, 51, 27519, 32.9186, 0.574537955147005, -96.9719, -1.69247893691469),
(32927, '75065', 218, 51, 95508, 33.1234, 0.57811238945509, -97.0261, -1.69342490536927),
(32928, '75067', 218, 51, 10065, 33.0545, 0.576909857600466, -97.0363, -1.69360292895297),
(32929, '75068', 218, 51, 95741, 33.2212, 0.57981932146354, -96.907, -1.69134621823014),
(32930, '75069', 218, 51, 10412, 33.1807, 0.579112463116483, -96.6101, -1.68616433568097),
(32931, '75070', 218, 51, 10412, 33.169, 0.578908259593999, -96.6903, -1.68756408974107),
(32932, '75071', 218, 51, 10412, 33.1659, 0.578854154387187, -96.5974, -1.68594267886597),
(32933, '75074', 218, 51, 5105, 33.0293, 0.576470034628963, -96.673, -1.68726214778048),
(32934, '75075', 218, 51, 5105, 33.0161, 0.5762396511677, -96.7371, -1.68838090383101),
(32935, '75076', 218, 51, 97204, 33.7735, 0.589458774922305, -96.6686, -1.68718535329339),
(32936, '75077', 218, 51, 10065, 33.0457, 0.57675626862629, -96.9935, -1.69285592803312),
(32937, '75078', 218, 51, 67989, 33.2465, 0.580260889764295, -96.8073, -1.68960612496591),
(32938, '75080', 218, 51, 5371, 32.9627, 0.575307645347135, -96.7452, -1.68852227550042),
(32939, '75081', 218, 51, 5371, 32.9496, 0.575079007215124, -96.7087, -1.68788523032344),
(32940, '75082', 218, 51, 5371, 32.9923, 0.575824262805725, -96.6818, -1.68741573675465),
(32941, '75083', 218, 51, 5371, 32.9715, 0.57546123432131, -96.7434, -1.68849085957388),
(32942, '75085', 218, 51, 5371, 32.9531, 0.575140093738943, -96.704, -1.6878031998486),
(32943, '75086', 218, 51, 5105, 33.0239, 0.576375786849355, -96.6983, -1.68770371608123),
(32944, '75087', 218, 51, 97584, 32.9533, 0.575143584397447, -96.4374, -1.68315015206278),
(32945, '75088', 218, 51, 97670, 32.8909, 0.574054498944203, -96.5539, -1.68518346064135),
(32946, '75089', 218, 51, 97670, 32.93, 0.574736922681733, -96.5523, -1.68515553537332),
(32947, '75090', 218, 51, 18065, 33.6415, 0.587154940309672, -96.6089, -1.68614339172995),
(32948, '75091', 218, 51, 18065, 33.6358, 0.587055456542309, -96.6091, -1.68614688238845),
(32949, '75092', 218, 51, 18065, 33.6467, 0.587245697430776, -96.6309, -1.68652736416539),
(32950, '75093', 218, 51, 5105, 33.0312, 0.576503195884751, -96.8003, -1.68948395191827),
(32951, '75094', 218, 51, 5105, 33.0086, 0.5761087514738, -96.6075, -1.68611895712042),
(32952, '75097', 218, 51, 6746, 33.3455, 0.581988765723769, -96.5756, -1.68556219708904),
(32953, '75098', 218, 51, 58373, 33.0205, 0.576316445654788, -96.5397, -1.68493562388757),
(32954, '75099', 218, 51, 93435, 32.9539, 0.575154056372959, -97.0144, -1.69322070184679),
(32955, '75101', 218, 51, 34674, 32.3101, 0.56391762664862, -96.798, -1.68944380934547),
(32956, '75102', 218, 51, 26454, 32.0834, 0.559960965234349, -96.7097, -1.68790268361596),
(32957, '75103', 218, 51, 19763, 32.552, 0.568139578109194, -95.8701, -1.67324889921622),
(32958, '75104', 218, 51, 1419, 32.5901, 0.568804548554204, -96.9436, -1.69198500873638),
(32959, '75105', 218, 51, 8043, 32.2913, 0.563589504749245, -96.368, -1.6819388935619),
(32960, '75106', 218, 51, 1419, 32.5883, 0.568773132627668, -96.9553, -1.69218921225886),
(32961, '75109', 218, 51, 54209, 32.0933, 0.560133752830296, -96.4771, -1.68384304777582),
(32962, '75110', 218, 51, 54209, 32.0933, 0.560133752830296, -96.4765, -1.68383257580031),
(32963, '75114', 218, 51, 15660, 32.6168, 0.569270551464486, -96.4445, -1.68327407043967),
(32964, '75115', 218, 51, 20496, 32.5972, 0.568928466931096, -96.8669, -1.6906463412001),
(32965, '75116', 218, 51, 2133, 32.6583, 0.569994863104064, -96.9141, -1.69147013660704),
(32966, '75117', 218, 51, 2230, 32.6979, 0.570686013487854, -95.885, -1.67350895327476),
(32967, '75118', 218, 51, 8744, 32.6876, 0.570506244574899, -96.2163, -1.67929122908662),
(32968, '75119', 218, 51, 20908, 32.3404, 0.564446461411974, -96.568, -1.68542955206588),
(32969, '75120', 218, 51, 20908, 32.3541, 0.564685571519497, -96.6263, -1.6864470790198),
(32970, '75121', 218, 51, 93434, 33.171, 0.578943166179039, -96.3716, -1.68200172541497),
(32971, '75123', 218, 51, 20496, 32.5868, 0.568746952688888, -96.8565, -1.69046482695789),
(32972, '75124', 218, 51, 94114, 32.307, 0.563863521441808, -95.9923, -1.67538169156215),
(32973, '75125', 218, 51, 94200, 32.5181, 0.567547911492768, -96.6177, -1.68629698070413),
(32974, '75126', 218, 51, 2552, 32.745, 0.571508063565543, -96.4562, -1.68347827396215),
(32975, '75127', 218, 51, 87166, 32.684, 0.570443412721827, -95.7966, -1.671966082216),
(32976, '75132', 218, 51, 94184, 32.9676, 0.575393166480483, -96.3723, -1.68201394271973),
(32977, '75134', 218, 51, 16841, 32.6192, 0.569312439366534, -96.7837, -1.68919422726244),
(32978, '75135', 218, 51, 92958, 33.0712, 0.577201327585549, -96.2298, -1.67952684853564),
(32979, '75137', 218, 51, 2133, 32.6343, 0.569575984083586, -96.9107, -1.69141079541247),
(32980, '75138', 218, 51, 2133, 32.6754, 0.570293314406155, -96.9186, -1.69154867642338),
(32981, '75140', 218, 51, 94571, 32.6789, 0.570354400929975, -95.717, -1.67057680013141),
(32982, '75141', 218, 51, 22118, 32.6435, 0.569736554374769, -96.7047, -1.68781541715336),
(32983, '75142', 218, 51, 27617, 32.5868, 0.568746952688888, -96.3005, -1.6807607963168),
(32984, '75143', 218, 51, 22339, 32.3495, 0.564605286373906, -96.2639, -1.68012200581057),
(32985, '75144', 218, 51, 95298, 32.1293, 0.560762071361014, -96.2295, -1.67952161254788),
(32986, '75146', 218, 51, 16841, 32.5756, 0.568551475812665, -96.7467, -1.6885484554392),
(32987, '75147', 218, 51, 95931, 32.3345, 0.564343486986106, -96.118, -1.67757557043191),
(32988, '75148', 218, 51, 95966, 32.1844, 0.561723747778863, -96.0273, -1.67599255680035),
(32989, '75149', 218, 51, 96160, 32.7696, 0.571937414561534, -96.613, -1.68621495022928),
(32990, '75150', 218, 51, 96160, 32.816, 0.572747247334459, -96.6261, -1.68644358836129),
(32991, '75151', 218, 51, 54209, 32.055, 0.559465291726782, -96.5235, -1.68465288054875),
(32992, '75152', 218, 51, 337, 32.4274, 0.565964897861209, -96.6659, -1.68713822940359),
(32993, '75153', 218, 51, 5200, 32.21, 0.562170552067374, -96.3598, -1.68179577656323),
(32994, '75154', 218, 51, 5318, 32.5257, 0.56768055651592, -96.8168, -1.68977193124485),
(32995, '75155', 218, 51, 5367, 32.2146, 0.562250837212965, -96.4152, -1.68276268896884),
(32996, '75156', 218, 51, 95931, 32.2972, 0.563692479175113, -96.1186, -1.67758604240742),
(32997, '75157', 218, 51, 68400, 32.5852, 0.568719027420856, -96.448, -1.68333515696349),
(32998, '75158', 218, 51, 83535, 32.465, 0.566621141659959, -96.4051, -1.68258641071439),
(32999, '75159', 218, 51, 97937, 32.651, 0.569867454068669, -96.5599, -1.68528818039647),
(33000, '75160', 218, 51, 18311, 32.7472, 0.571546460809087, -96.3158, -1.68102783169235),
(33001, '75161', 218, 51, 18311, 32.7224, 0.571113619154592, -96.1655, -1.67840460182661),
(33002, '75163', 218, 51, 13233, 32.1997, 0.561990783154418, -96.1087, -1.67741325481147),
(33003, '75164', 218, 51, 3466, 33.0585, 0.576979670770545, -96.3799, -1.68214658774288),
(33004, '75165', 218, 51, 98945, 32.3774, 0.565092233235212, -96.7901, -1.68930592833456),
(33005, '75166', 218, 51, 95636, 33.0195, 0.576298992362268, -96.4306, -1.68303146967364),
(33006, '75167', 218, 51, 98945, 32.3322, 0.564303344413311, -96.9122, -1.69143697535125),
(33007, '75168', 218, 51, 98945, 32.3049, 0.563826869527516, -96.7697, -1.68894988116716),
(33008, '75169', 218, 51, 44169, 32.7322, 0.571284661421288, -96.0153, -1.67578311729011),
(33009, '75172', 218, 51, 6852, 32.5988, 0.568956392199127, -96.6794, -1.68737384885261),
(33010, '75173', 218, 51, 37398, 33.0585, 0.576979670770545, -96.3805, -1.68215705971839),
(33011, '75180', 218, 51, 96160, 32.7171, 0.571021116704237, -96.6197, -1.68633188728917),
(33012, '75181', 218, 51, 96160, 32.7233, 0.57112932711786, -96.5507, -1.68512761010529),
(33013, '75182', 218, 51, 57792, 32.7845, 0.572197468620081, -96.5564, -1.68522709387265),
(33014, '75185', 218, 51, 96160, 32.7693, 0.571932178573778, -96.6175, -1.68629349004562),
(33015, '75187', 218, 51, 96160, 32.7707, 0.571956613183306, -96.6134, -1.68622193154629),
(33016, '75189', 218, 51, 97675, 32.9667, 0.575377458517215, -96.3041, -1.68082362816987),
(33017, '75201', 218, 51, 1953, 32.7871, 0.572242847180633, -96.7982, -1.68944730000397),
(33018, '75202', 218, 51, 1953, 32.7813, 0.572141618084017, -96.8036, -1.68954154778358),
(33019, '75203', 218, 51, 1953, 32.7447, 0.571502827577787, -96.8029, -1.68952933047882),
(33020, '75204', 218, 51, 1953, 32.8004, 0.572474975971148, -96.7886, -1.68927974839578),
(33021, '75205', 218, 51, 1953, 32.8364, 0.573103294501866, -96.7955, -1.68940017611417),
(33022, '75206', 218, 51, 1953, 32.8297, 0.572986357441982, -96.772, -1.68899002373995),
(33023, '75207', 218, 51, 1953, 32.7859, 0.572221903229609, -96.8205, -1.68983650842717),
(33024, '75208', 218, 51, 1953, 32.7534, 0.571654671222711, -96.8391, -1.69016113966804),
(33025, '75209', 218, 51, 1953, 32.8469, 0.573286554073325, -96.8275, -1.68995868147481),
(33026, '75210', 218, 51, 1953, 32.7712, 0.571965339829566, -96.7483, -1.68857638070723),
(33027, '75211', 218, 51, 1953, 32.739, 0.571403343810423, -96.9006, -1.69123451715802),
(33028, '75212', 218, 51, 1953, 32.7801, 0.572120674132993, -96.8768, -1.69081912879604),
(33029, '75214', 218, 51, 1953, 32.826, 0.572921780259659, -96.7473, -1.68855892741471),
(33030, '75215', 218, 51, 1953, 32.75, 0.571595330028143, -96.7613, -1.68880327350999),
(33031, '75216', 218, 51, 1953, 32.7057, 0.570822149169509, -96.7889, -1.68928498438354),
(33032, '75217', 218, 51, 1953, 32.7204, 0.571078712569553, -96.6748, -1.68729356370701),
(33033, '75218', 218, 51, 1953, 32.8441, 0.57323768485427, -96.7009, -1.68774909464178),
(33034, '75219', 218, 51, 1953, 32.8118, 0.572673943505875, -96.8143, -1.68972829801355),
(33035, '75220', 218, 51, 1953, 32.8635, 0.573576278729157, -96.8747, -1.69078247688175),
(33036, '75221', 218, 51, 1953, 32.6911, 0.570567331098718, -96.8231, -1.68988188698772),
(33037, '75222', 218, 51, 1953, 32.7536, 0.571658161881215, -96.8402, -1.69018033828981),
(33038, '75223', 218, 51, 1953, 32.7909, 0.572309169692209, -96.7506, -1.68861652328003),
(33039, '75224', 218, 51, 1953, 32.7119, 0.570930359583133, -96.8386, -1.69015241302178),
(33040, '75225', 218, 51, 1953, 32.8646, 0.573595477350929, -96.7878, -1.68926578576177),
(33041, '75226', 218, 51, 1953, 32.7821, 0.572155580718033, -96.7774, -1.68908427151956),
(33042, '75227', 218, 51, 1953, 32.7693, 0.571932178573778, -96.6848, -1.68746809663221),
(33043, '75228', 218, 51, 1953, 32.8242, 0.572890364333123, -96.6814, -1.68740875543765),
(33044, '75229', 218, 51, 1953, 32.8942, 0.574112094809519, -96.8612, -1.69054685743273),
(33045, '75230', 218, 51, 1953, 32.9008, 0.57422728654015, -96.7914, -1.68932861761484);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(33046, '75231', 218, 51, 1953, 32.8783, 0.573834587458452, -96.7517, -1.6886357219018),
(33047, '75232', 218, 51, 1953, 32.6548, 0.569933776580244, -96.8434, -1.69023618882588),
(33048, '75233', 218, 51, 1953, 32.7057, 0.570822149169509, -96.8752, -1.69079120352801),
(33049, '75234', 218, 51, 1953, 32.9229, 0.574613004304841, -96.8966, -1.69116470398794),
(33050, '75235', 218, 51, 1953, 32.8287, 0.572968904149462, -96.8462, -1.69028505804493),
(33051, '75236', 218, 51, 1953, 32.6849, 0.570459120685095, -96.9366, -1.69186283568874),
(33052, '75237', 218, 51, 1953, 32.6693, 0.570186849321784, -96.8751, -1.69078945819876),
(33053, '75238', 218, 51, 1953, 32.8767, 0.57380666219042, -96.7093, -1.68789570229895),
(33054, '75239', 218, 51, 1953, 32.6788, 0.570352655600723, -96.7378, -1.68839312113577),
(33055, '75240', 218, 51, 1953, 32.9359, 0.5748398971076, -96.7898, -1.68930069234681),
(33056, '75241', 218, 51, 1953, 32.6557, 0.569949484543512, -96.7488, -1.68858510735349),
(33057, '75242', 218, 51, 1953, 32.7786, 0.572094494194213, -96.8034, -1.68953805712508),
(33058, '75243', 218, 51, 1953, 32.9109, 0.574403564794602, -96.7316, -1.68828491072215),
(33059, '75244', 218, 51, 1953, 32.9249, 0.574647910889881, -96.8368, -1.69012099709524),
(33060, '75245', 218, 51, 1953, 32.778, 0.572084022218701, -96.8039, -1.68954678377134),
(33061, '75246', 218, 51, 1953, 32.7965, 0.57240690813032, -96.7733, -1.68901271302023),
(33062, '75247', 218, 51, 1953, 32.8154, 0.572736775358947, -96.8792, -1.69086101669809),
(33063, '75248', 218, 51, 1953, 32.9656, 0.575358259895443, -96.7992, -1.6894647532965),
(33064, '75249', 218, 51, 1953, 32.6488, 0.569829056825125, -96.9567, -1.69221364686839),
(33065, '75250', 218, 51, 1953, 32.7801, 0.572120674132993, -96.8014, -1.68950315054004),
(33066, '75251', 218, 51, 1953, 32.9166, 0.574503048561966, -96.7703, -1.68896035314267),
(33067, '75252', 218, 51, 1953, 32.9954, 0.575878368012537, -96.7854, -1.68922389785972),
(33068, '75253', 218, 51, 1953, 32.6854, 0.570467847331355, -96.6013, -1.6860107467068),
(33069, '75254', 218, 51, 1953, 32.9355, 0.574832915790592, -96.7894, -1.6892937110298),
(33070, '75258', 218, 51, 1953, 32.8047, 0.572550025128984, -96.8365, -1.69011576110749),
(33071, '75260', 218, 51, 1953, 32.7739, 0.57201246371937, -96.8275, -1.68995868147481),
(33072, '75261', 218, 51, 1953, 32.8726, 0.573735103691088, -96.9668, -1.69238992512284),
(33073, '75262', 218, 51, 1953, 32.7522, 0.571633727271687, -96.8397, -1.69017161164355),
(33074, '75263', 218, 51, 1953, 32.7532, 0.571651180564207, -96.8395, -1.69016812098505),
(33075, '75264', 218, 51, 1953, 32.7538, 0.571661652539719, -96.8406, -1.69018731960682),
(33076, '75265', 218, 51, 1953, 32.744, 0.571490610273023, -97.0015, -1.69299555437328),
(33077, '75266', 218, 51, 1953, 32.7827, 0.572166052693545, -96.8787, -1.69085229005183),
(33078, '75267', 218, 51, 1953, 32.7529, 0.571645944576451, -96.8405, -1.69018557427757),
(33079, '75270', 218, 51, 1953, 32.7786, 0.572094494194213, -96.8036, -1.68954154778358),
(33080, '75275', 218, 51, 1953, 32.8406, 0.57317659833045, -96.7817, -1.6891593206774),
(33081, '75277', 218, 51, 1953, 32.7387, 0.571398107822668, -96.7473, -1.68855892741471),
(33082, '75283', 218, 51, 1953, 32.7684, 0.57191647061051, -96.8284, -1.68997438943808),
(33083, '75284', 218, 51, 1953, 32.7683, 0.571914725281258, -96.8281, -1.68996915345032),
(33084, '75285', 218, 51, 1953, 32.7677, 0.571904253305746, -96.8284, -1.68997438943808),
(33085, '75286', 218, 51, 1953, 32.7681, 0.571911234622754, -96.8281, -1.68996915345032),
(33086, '75287', 218, 51, 1953, 33.0027, 0.576005777047933, -96.8404, -1.69018382894832),
(33087, '75295', 218, 51, 1953, 32.7837, 0.572183505986065, -96.7997, -1.68947347994276),
(33088, '75301', 218, 51, 1953, 32.6601, 0.5700262790306, -96.8825, -1.69091861256341),
(33089, '75303', 218, 51, 1953, 32.7831, 0.572173034010553, -96.777, -1.68907729020255),
(33090, '75310', 218, 51, 1953, 32.7896, 0.572286480411933, -96.8099, -1.68965150352646),
(33091, '75312', 218, 51, 1953, 32.7677, 0.571904253305746, -96.8279, -1.68996566279182),
(33092, '75313', 218, 51, 1953, 32.7873, 0.572246337839137, -96.7975, -1.68943508269921),
(33093, '75315', 218, 51, 1953, 32.7743, 0.572019445036377, -96.7689, -1.68893591853314),
(33094, '75320', 218, 51, 1953, 32.7805, 0.572127655450001, -96.8012, -1.68949965988153),
(33095, '75323', 218, 51, 1953, 32.9709, 0.575450762345798, -96.801, -1.68949616922303),
(33096, '75326', 218, 51, 1953, 32.8641, 0.573586750704668, -96.9808, -1.69263427121812),
(33097, '75336', 218, 51, 1953, 32.6717, 0.570228737223831, -96.6199, -1.68633537794767),
(33098, '75339', 218, 51, 1953, 32.7147, 0.570979228802189, -96.7846, -1.6892099352257),
(33099, '75342', 218, 51, 1953, 32.7702, 0.571947886537046, -96.8638, -1.69059223599328),
(33100, '75346', 218, 51, 1953, 32.7835, 0.572180015327561, -96.8005, -1.68948744257677),
(33101, '75353', 218, 51, 1953, 32.7179, 0.571035079338253, -96.6826, -1.68742969938867),
(33102, '75354', 218, 51, 1953, 32.8606, 0.573525664180849, -96.888, -1.69101460567227),
(33103, '75355', 218, 51, 1953, 32.8796, 0.573857276738728, -96.7084, -1.68787999433568),
(33104, '75356', 218, 51, 1953, 32.8139, 0.572710595420167, -96.8797, -1.69086974334435),
(33105, '75357', 218, 51, 1953, 32.8239, 0.572885128345367, -96.6795, -1.68737559418186),
(33106, '75359', 218, 51, 1953, 32.8132, 0.572698378115403, -96.7563, -1.68871600704739),
(33107, '75360', 218, 51, 1953, 32.9379, 0.57487480369264, -96.7931, -1.68935828821212),
(33108, '75363', 218, 51, 1953, 32.9375, 0.574867822375632, -96.7914, -1.68932861761484),
(33109, '75364', 218, 51, 1953, 32.7684, 0.57191647061051, -96.8279, -1.68996566279182),
(33110, '75367', 218, 51, 1953, 32.9029, 0.574263938454442, -96.7927, -1.68935130689512),
(33111, '75368', 218, 51, 1953, 32.923, 0.574614749634093, -96.9742, -1.69251907948749),
(33112, '75369', 218, 51, 1953, 32.9589, 0.575241322835559, -96.9954, -1.69288908928891),
(33113, '75370', 218, 51, 1953, 33.0011, 0.575977851779901, -96.8425, -1.69022048086261),
(33114, '75371', 218, 51, 1953, 32.7935, 0.57235454825276, -96.7732, -1.68901096769098),
(33115, '75372', 218, 51, 1953, 32.8417, 0.573195796952222, -96.7723, -1.68899525972771),
(33116, '75373', 218, 51, 1953, 32.786, 0.572223648558861, -96.8279, -1.68996566279182),
(33117, '75374', 218, 51, 1953, 32.9122, 0.574426254074878, -96.7366, -1.68837217718475),
(33118, '75376', 218, 51, 1953, 32.7117, 0.570926868924629, -96.8393, -1.69016463032654),
(33119, '75378', 218, 51, 1953, 32.8951, 0.574127802772787, -96.8703, -1.69070568239466),
(33120, '75379', 218, 51, 1953, 32.9907, 0.575796337537693, -96.8013, -1.68950140521079),
(33121, '75380', 218, 51, 1953, 32.934, 0.574806735851812, -96.8174, -1.68978240322036),
(33122, '75381', 218, 51, 1953, 32.9436, 0.574974287460004, -96.89, -1.69104951225731),
(33123, '75382', 218, 51, 1953, 32.8785, 0.573838078116956, -96.7497, -1.68860081531676),
(33124, '75386', 218, 51, 1953, 32.7677, 0.571904253305746, -96.8278, -1.68996391746257),
(33125, '75387', 218, 51, 1953, 32.7823, 0.572159071376537, -96.8786, -1.69085054472258),
(33126, '75388', 218, 51, 1953, 32.7829, 0.572169543352049, -96.7976, -1.68943682802846),
(33127, '75389', 218, 51, 1953, 32.7708, 0.571958358512558, -96.687, -1.68750649387576),
(33128, '75390', 218, 51, 1953, 32.8434, 0.573225467549506, -96.7015, -1.6877595666173),
(33129, '75391', 218, 51, 1953, 32.9487, 0.575063299251856, -96.8251, -1.68991679357276),
(33130, '75392', 218, 51, 1953, 32.7685, 0.571918215939762, -96.8282, -1.68997089877957),
(33131, '75393', 218, 51, 1953, 32.8024, 0.572509882556188, -96.7901, -1.68930592833456),
(33132, '75394', 218, 51, 1953, 32.8317, 0.573021264027022, -96.7064, -1.68784508775064),
(33133, '75395', 218, 51, 1953, 32.7114, 0.570921632936873, -96.8398, -1.6901733569728),
(33134, '75396', 218, 51, 1953, 32.723, 0.571124091130104, -96.8742, -1.69077375023549),
(33135, '75397', 218, 51, 1953, 32.7676, 0.571902507976494, -96.8284, -1.68997438943808),
(33136, '75398', 218, 51, 1953, 32.7647, 0.571851893428186, -96.8574, -1.69048053492116),
(33137, '75401', 218, 51, 2868, 33.1831, 0.57915435101853, -96.1026, -1.6773067897271),
(33138, '75402', 218, 51, 2868, 33.0717, 0.577210054231809, -96.0882, -1.67705546231482),
(33139, '75403', 218, 51, 2868, 33.1935, 0.579335865260738, -96.1056, -1.67735914960466),
(33140, '75404', 218, 51, 2868, 33.1935, 0.579335865260738, -96.1059, -1.67736438559242),
(33141, '75407', 218, 51, 5231, 33.1713, 0.578948402166795, -96.4928, -1.68411706446838),
(33142, '75409', 218, 51, 26375, 33.3454, 0.581987020394517, -96.5753, -1.68555696110128),
(33143, '75410', 218, 51, 53143, 32.7931, 0.572347566935753, -95.6358, -1.66915959277879),
(33144, '75411', 218, 51, 92348, 33.8472, 0.590745082581025, -95.4611, -1.66611050257556),
(33145, '75412', 218, 51, 92401, 33.8289, 0.59042568732791, -95.1475, -1.6606371500413),
(33146, '75413', 218, 51, 7216, 33.4347, 0.583545599416548, -96.1639, -1.67837667655858),
(33147, '75414', 218, 51, 58616, 33.6122, 0.586643558838838, -96.423, -1.68289882465049),
(33148, '75415', 218, 51, 92561, 33.3788, 0.582569960364683, -95.8586, -1.67304818635224),
(33149, '75416', 218, 51, 7546, 33.6501, 0.587305038625344, -95.4192, -1.66537920961897),
(33150, '75417', 218, 51, 92728, 33.4702, 0.584165191301006, -95.2134, -1.66178732201837),
(33151, '75418', 218, 51, 53560, 33.5866, 0.586196754550327, -96.1769, -1.67860356936133),
(33152, '75420', 218, 51, 92800, 33.1172, 0.578004179041466, -95.7272, -1.67075482371512),
(33153, '75421', 218, 51, 63225, 33.6553, 0.587395795746448, -95.6463, -1.66934285235025),
(33154, '75422', 218, 51, 1317, 33.1332, 0.578283431721785, -95.9471, -1.67459280274025),
(33155, '75423', 218, 51, 1438, 33.2935, 0.581081194512732, -96.1965, -1.67894565389473),
(33156, '75424', 218, 51, 992, 33.3036, 0.581257472767184, -96.3834, -1.6822076742667),
(33157, '75425', 218, 51, 93216, 33.7737, 0.589462265580809, -95.7128, -1.67050349630283),
(33158, '75426', 218, 51, 848, 33.6096, 0.586598180278286, -95.0523, -1.65897559659341),
(33159, '75428', 218, 51, 1726, 33.2572, 0.580447639994258, -95.9288, -1.67427340748714),
(33160, '75429', 218, 51, 1726, 33.2498, 0.580318485629611, -95.8982, -1.67373933673603),
(33161, '75431', 218, 51, 39860, 33.0791, 0.577339208596456, -95.3679, -1.6644838557127),
(33162, '75432', 218, 51, 1748, 33.3711, 0.58243557001228, -95.6893, -1.67009334392861),
(33163, '75433', 218, 51, 93586, 33.1356, 0.578325319623833, -95.8407, -1.67273577241613),
(33164, '75434', 218, 51, 1923, 33.5011, 0.584704498039872, -95.3779, -1.6646583886379),
(33165, '75435', 218, 51, 93708, 33.5016, 0.584713224686132, -95.3769, -1.66464093534538),
(33166, '75436', 218, 51, 2034, 33.664, 0.587547639391371, -95.2316, -1.66210497194223),
(33167, '75437', 218, 51, 93743, 33.1927, 0.579321902626722, -95.4659, -1.66619427837965),
(33168, '75438', 218, 51, 8541, 33.5756, 0.586004768332608, -96.0746, -1.67681809753654),
(33169, '75439', 218, 51, 93912, 33.5775, 0.586037929588396, -96.2711, -1.68024766951671),
(33170, '75440', 218, 51, 2293, 32.8782, 0.5738328421292, -95.7568, -1.67127144117371),
(33171, '75441', 218, 51, 94072, 33.3981, 0.582906808910318, -95.5926, -1.66840561054193),
(33172, '75442', 218, 51, 2418, 33.1706, 0.578936184862031, -96.3717, -1.68200347074422),
(33173, '75443', 218, 51, 21457, 33.5549, 0.585643485177445, -96.0451, -1.67630322540721),
(33174, '75444', 218, 51, 54988, 32.7757, 0.572043879645906, -95.5879, -1.66832358006709),
(33175, '75446', 218, 51, 36486, 33.5842, 0.58615486664828, -95.9081, -1.67391212433197),
(33176, '75447', 218, 51, 3375, 33.6816, 0.587854817339722, -96.1708, -1.67849710427696),
(33177, '75448', 218, 51, 3564, 33.2989, 0.58117544229234, -95.803, -1.67207778328813),
(33178, '75449', 218, 51, 3593, 33.4217, 0.583318706613789, -95.9695, -1.6749837564927),
(33179, '75450', 218, 51, 22457, 33.4668, 0.584105850106438, -95.6142, -1.66878260166036),
(33180, '75451', 218, 51, 3721, 32.9643, 0.575335570615167, -95.1076, -1.65994076366976),
(33181, '75452', 218, 51, 3733, 33.3849, 0.582676425449055, -96.2435, -1.67976595864316),
(33182, '75453', 218, 51, 22731, 32.9972, 0.575909783939073, -95.9422, -1.6745072816069),
(33183, '75454', 218, 51, 96138, 33.2804, 0.580852556380721, -96.5841, -1.68571055007546),
(33184, '75455', 218, 51, 118, 33.1574, 0.578705801400768, -94.9683, -1.65750952002173),
(33185, '75456', 218, 51, 118, 33.1565, 0.5786900934375, -94.9682, -1.65750777469248),
(33186, '75457', 218, 51, 4411, 33.1829, 0.579150860360026, -95.2251, -1.66199152554085),
(33187, '75458', 218, 51, 60870, 33.2818, 0.580876990990249, -96.2075, -1.67913764011244),
(33188, '75459', 218, 51, 3253, 33.5459, 0.585486405544766, -96.708, -1.68787301301868),
(33189, '75460', 218, 51, 11069, 33.6628, 0.587526695440347, -95.5437, -1.66755214453771),
(33190, '75461', 218, 51, 11069, 33.6616, 0.587505751489323, -95.5544, -1.66773889476767),
(33191, '75462', 218, 51, 11069, 33.6692, 0.587638396512475, -95.4899, -1.66661315740013),
(33192, '75468', 218, 51, 11102, 33.5631, 0.585786602176109, -95.3926, -1.66491495203794),
(33193, '75469', 218, 51, 96976, 33.4037, 0.58300454734843, -95.8029, -1.67207603795888),
(33194, '75470', 218, 51, 97028, 33.6169, 0.586725589313682, -95.7926, -1.67189626904592),
(33195, '75471', 218, 51, 97044, 33.0265, 0.576421165409907, -95.4541, -1.66598832952792),
(33196, '75472', 218, 51, 42627, 32.8905, 0.574047517627195, -95.8675, -1.67320352065566),
(33197, '75473', 218, 51, 5198, 33.7758, 0.589498917495101, -95.5352, -1.66740379155129),
(33198, '75474', 218, 51, 17746, 32.914, 0.574457670001414, -96.1328, -1.6778338791612),
(33199, '75475', 218, 51, 5293, 33.5546, 0.585638249189689, -96.1994, -1.67899626844303),
(33200, '75476', 218, 51, 37869, 33.6692, 0.587638396512475, -96.2396, -1.67969789080233),
(33201, '75477', 218, 51, 11711, 33.5469, 0.585503858837286, -95.7253, -1.67072166245933),
(33202, '75478', 218, 51, 11788, 33.1946, 0.57935506388251, -95.3454, -1.664091156631),
(33203, '75479', 218, 51, 11814, 33.5699, 0.585905284565244, -96.3297, -1.68127043245838),
(33204, '75480', 218, 51, 97929, 33.0649, 0.577091371842673, -95.2046, -1.66163373304419),
(33205, '75481', 218, 51, 98349, 33.3358, 0.581819468786326, -95.3611, -1.66436517332356),
(33206, '75482', 218, 51, 6137, 33.1302, 0.578231071844225, -95.6004, -1.66854174622359),
(33207, '75483', 218, 51, 6137, 33.139, 0.578384660818401, -95.6009, -1.66855047286985),
(33208, '75485', 218, 51, 13249, 33.3042, 0.581267944742696, -96.3838, -1.68221465558371),
(33209, '75486', 218, 51, 18216, 33.7736, 0.589460520251557, -95.7137, -1.6705192042661),
(33210, '75487', 218, 51, 98418, 33.3621, 0.5822784903796, -95.103, -1.65986047852417),
(33211, '75488', 218, 51, 98450, 33.8069, 0.590041714892471, -96.005, -1.67560334837716),
(33212, '75489', 218, 51, 98580, 33.5217, 0.585064035865783, -96.4772, -1.68384479310507),
(33213, '75490', 218, 51, 6381, 33.4268, 0.583407718405641, -96.332, -1.68131057503118),
(33214, '75491', 218, 51, 99089, 33.512, 0.58489473892834, -96.3999, -1.68249565359328),
(33215, '75492', 218, 51, 31547, 33.5632, 0.585788347505361, -95.9988, -1.67549513796353),
(33216, '75493', 218, 51, 6882, 33.1664, 0.578862881033447, -95.1084, -1.65995472630378),
(33217, '75494', 218, 51, 44187, 32.9495, 0.575077261885872, -95.2939, -1.66319231206622),
(33218, '75495', 218, 51, 98761, 33.437, 0.583585741989344, -96.516, -1.68452198085485),
(33219, '75496', 218, 51, 99179, 33.342, 0.581927679199949, -96.0342, -1.67611298451874),
(33220, '75497', 218, 51, 99228, 32.8921, 0.574075442895227, -95.53, -1.66731303443018),
(33221, '75501', 218, 51, 12287, 33.4245, 0.583367575832845, -94.1019, -1.64238798738245),
(33222, '75503', 218, 51, 12287, 33.4634, 0.58404650891187, -94.0736, -1.64189405920414),
(33223, '75504', 218, 51, 12287, 33.3553, 0.582159807990465, -94.2212, -1.64447016518008),
(33224, '75505', 218, 51, 12287, 33.3952, 0.58285619436201, -94.2531, -1.64502692521147),
(33225, '75507', 218, 51, 12287, 33.3561, 0.582173770624481, -94.2204, -1.64445620254607),
(33226, '75550', 218, 51, 92279, 33.5256, 0.585132103706611, -94.8948, -1.65622670302152),
(33227, '75551', 218, 51, 7187, 33.1172, 0.578004179041466, -94.1683, -1.64354688600578),
(33228, '75554', 218, 51, 7205, 33.488, 0.584475859907861, -94.7956, -1.65449533640354),
(33229, '75555', 218, 51, 92655, 32.9549, 0.575171509665479, -94.1462, -1.64316116824109),
(33230, '75556', 218, 51, 92692, 33.1344, 0.578304375672809, -94.0667, -1.64177363148575),
(33231, '75558', 218, 51, 32143, 33.1843, 0.579175294969554, -94.861, -1.65563678173434),
(33232, '75559', 218, 51, 54366, 33.5068, 0.584803981807236, -94.6165, -1.65136945171321),
(33233, '75560', 218, 51, 93803, 33.1901, 0.57927652406617, -94.3564, -1.64682985032878),
(33234, '75561', 218, 51, 3234, 33.4699, 0.58415995531325, -94.2749, -1.6454074069884),
(33235, '75562', 218, 51, 22366, 33.0105, 0.576141912729588, -94.3634, -1.64695202337642),
(33236, '75563', 218, 51, 3784, 33.0119, 0.576166347339116, -94.3637, -1.64695725936417),
(33237, '75564', 218, 51, 112, 32.7409, 0.571436505066211, -94.3097, -1.6460147815681),
(33238, '75565', 218, 51, 42042, 32.9484, 0.5750580632641, -94.0807, -1.64201797758103),
(33239, '75566', 218, 51, 3993, 33.1958, 0.579376007833534, -94.538, -1.6499993682504),
(33240, '75567', 218, 51, 4040, 33.3314, 0.581742674299238, -94.3454, -1.64663786411106),
(33241, '75568', 218, 51, 17231, 33.1901, 0.57927652406617, -94.6839, -1.65254580362906),
(33242, '75569', 218, 51, 17236, 33.4406, 0.583648573842416, -94.1239, -1.64277195981789),
(33243, '75570', 218, 51, 30620, 33.4578, 0.583948770473759, -94.4185, -1.64791369979427),
(33244, '75571', 218, 51, 4786, 33.1814, 0.579124680421246, -94.7431, -1.65357903854624),
(33245, '75572', 218, 51, 97278, 33.1483, 0.578546976438836, -94.1474, -1.64318211219211),
(33246, '75573', 218, 51, 61502, 33.3582, 0.582210422538772, -94.254, -1.64504263317474),
(33247, '75574', 218, 51, 43083, 33.487, 0.584458406615341, -94.5821, -1.65076905845053),
(33248, '75599', 218, 51, 12287, 33.4458, 0.583739330963519, -94.078, -1.64197085369123),
(33249, '75601', 218, 51, 3859, 32.5229, 0.567631687296864, -94.7341, -1.65342195891356),
(33250, '75602', 218, 51, 3859, 32.4734, 0.566767749317127, -94.7222, -1.65321426473257),
(33251, '75603', 218, 51, 3859, 32.4368, 0.566128958810897, -94.725, -1.65326313395163),
(33252, '75604', 218, 51, 3859, 32.5215, 0.567607252687336, -94.8006, -1.65458260286614),
(33253, '75605', 218, 51, 3859, 32.5546, 0.568184956669746, -94.7805, -1.65423179168649),
(33254, '75606', 218, 51, 3859, 32.496, 0.567162193728077, -94.7391, -1.65350922537616),
(33255, '75607', 218, 51, 3859, 32.5772, 0.568579401080697, -94.7792, -1.65420910240621),
(33256, '75608', 218, 51, 3859, 32.556, 0.568209391279274, -94.7996, -1.65456514957362),
(33257, '75615', 218, 51, 3859, 32.4627, 0.566580999087163, -94.7309, -1.6533661083775),
(33258, '75630', 218, 51, 92385, 32.8684, 0.573661799862504, -94.5818, -1.65076382246277),
(33259, '75631', 218, 51, 53385, 32.2505, 0.562877410414431, -94.4522, -1.64850187575219),
(33260, '75633', 218, 51, 7932, 32.1572, 0.561249018222321, -94.3427, -1.64659074022125),
(33261, '75636', 218, 51, 39675, 32.9423, 0.574951598179728, -94.706, -1.65293152139375),
(33262, '75637', 218, 51, 608, 32.0977, 0.560210547317384, -94.4742, -1.64888584818763),
(33263, '75638', 218, 51, 93614, 33.0294, 0.576471779958215, -94.7262, -1.65328407790265),
(33264, '75639', 218, 51, 93654, 32.217, 0.562292725115013, -94.1481, -1.64319432949687),
(33265, '75640', 218, 51, 26950, 32.7, 0.570722665402146, -94.6695, -1.65229447621677),
(33266, '75641', 218, 51, 2193, 32.3731, 0.565017184077376, -94.5882, -1.6508755235349),
(33267, '75642', 218, 51, 94043, 32.3683, 0.564933408273281, -94.1827, -1.64379821341806),
(33268, '75643', 218, 51, 16182, 32.0315, 0.559055139352564, -94.3975, -1.64754718065135),
(33269, '75644', 218, 51, 94473, 32.7207, 0.571083948557309, -94.9313, -1.65686374819849),
(33270, '75645', 218, 51, 94473, 32.7209, 0.571087439215813, -94.9313, -1.65686374819849),
(33271, '75647', 218, 51, 94478, 32.5256, 0.567678811186668, -94.9384, -1.65698766657538),
(33272, '75650', 218, 51, 2943, 32.5002, 0.567235497556661, -94.5755, -1.6506538667199),
(33273, '75651', 218, 51, 94733, 32.6402, 0.569678958509453, -94.542, -1.65006918142048),
(33274, '75652', 218, 51, 23, 32.1565, 0.561236800917557, -94.7995, -1.65456340424436),
(33275, '75653', 218, 51, 23, 32.1603, 0.561303123429132, -94.8056, -1.65466986932874),
(33276, '75654', 218, 51, 23, 32.1572, 0.561249018222321, -94.7972, -1.65452326167157),
(33277, '75656', 218, 51, 95041, 32.9408, 0.574925418240948, -94.7072, -1.65295246534477),
(33278, '75657', 218, 51, 3409, 32.765, 0.571857129415942, -94.3482, -1.64668673333011),
(33279, '75658', 218, 51, 95208, 32.1779, 0.561610301377483, -94.9084, -1.65646406779979),
(33280, '75659', 218, 51, 3455, 32.4975, 0.567188373666857, -94.1109, -1.64254506701513),
(33281, '75660', 218, 51, 3470, 32.5827, 0.568675394189556, -94.7529, -1.65375008081294),
(33282, '75661', 218, 51, 95248, 32.6295, 0.56949220827949, -94.1671, -1.64352594205475),
(33283, '75662', 218, 51, 3520, 32.3934, 0.565371485915531, -94.8699, -1.65579211603777),
(33284, '75663', 218, 51, 3520, 32.3781, 0.565104450539976, -94.8639, -1.65568739628265),
(33285, '75666', 218, 51, 95499, 32.3529, 0.564664627568473, -94.9058, -1.65641868923923),
(33286, '75667', 218, 51, 3661, 31.9446, 0.557538448232581, -94.8555, -1.65554078862548),
(33287, '75668', 218, 51, 10175, 32.9433, 0.574969051472248, -94.7091, -1.65298562660056),
(33288, '75669', 218, 51, 113, 32.0465, 0.559316938740363, -94.5027, -1.64938326702445),
(33289, '75670', 218, 51, 4011, 32.5406, 0.567940610574467, -94.3626, -1.6469380607424),
(33290, '75671', 218, 51, 4011, 32.5444, 0.568006933086043, -94.3669, -1.64701310990024),
(33291, '75672', 218, 51, 4011, 32.5362, 0.567863816087379, -94.3504, -1.64672513057366),
(33292, '75680', 218, 51, 42112, 32.149, 0.561105901223657, -94.7995, -1.65456340424436),
(33293, '75681', 218, 51, 96363, 31.9073, 0.556887440421587, -94.6117, -1.65128567590912),
(33294, '75682', 218, 51, 4547, 32.2441, 0.562765709342304, -94.9429, -1.65706620639172),
(33295, '75683', 218, 51, 96814, 32.7939, 0.572361529569768, -94.6504, -1.65196111832964),
(33296, '75684', 218, 51, 4818, 32.2736, 0.563280581471642, -94.9718, -1.65757060654555),
(33297, '75685', 218, 51, 4851, 32.442, 0.566219715932, -93.9746, -1.64016618324466),
(33298, '75686', 218, 51, 5099, 32.997, 0.575906293280569, -94.9679, -1.65750253870472),
(33299, '75687', 218, 51, 11399, 32.0981, 0.560217528634392, -94.9409, -1.65703129980668),
(33300, '75688', 218, 51, 5699, 32.5357, 0.567855089441119, -94.2411, -1.64481748570123),
(33301, '75689', 218, 51, 97966, 32.1841, 0.561718511791107, -94.9475, -1.65714649153732),
(33302, '75691', 218, 51, 18288, 32.3289, 0.564245748547995, -94.5327, -1.64990686580004),
(33303, '75692', 218, 51, 98927, 32.4764, 0.566820109194686, -94.0642, -1.64172999825445),
(33304, '75693', 218, 51, 903, 32.5375, 0.567886505367655, -94.8587, -1.65559663916155),
(33305, '75694', 218, 51, 6936, 32.6681, 0.57016590537076, -94.346, -1.64664833608657),
(33306, '75701', 218, 51, 6437, 32.3251, 0.564179426036419, -95.2943, -1.66319929338323),
(33307, '75702', 218, 51, 6437, 32.3605, 0.564797272591625, -95.3095, -1.66346458342954),
(33308, '75703', 218, 51, 6437, 32.2753, 0.563310252068926, -95.3017, -1.66332844774788),
(33309, '75704', 218, 51, 6437, 32.4032, 0.565542528182227, -95.4297, -1.66556246919043),
(33310, '75705', 218, 51, 6437, 32.3596, 0.564781564628357, -95.0863, -1.65956900853908),
(33311, '75706', 218, 51, 6437, 32.4637, 0.566598452379683, -95.28, -1.6629497113002),
(33312, '75707', 218, 51, 6437, 32.3018, 0.563772764320704, -95.2523, -1.66246625509739),
(33313, '75708', 218, 51, 6437, 32.3997, 0.565481441658407, -95.2428, -1.66230044881846),
(33314, '75709', 218, 51, 6437, 32.3302, 0.564268437828271, -95.365, -1.66443324116439),
(33315, '75710', 218, 51, 6437, 32.3647, 0.564870576420209, -95.3178, -1.66360944575745),
(33316, '75711', 218, 51, 6437, 32.3948, 0.565395920525059, -95.4083, -1.66518896873051),
(33317, '75712', 218, 51, 6437, 32.3231, 0.564144519451379, -95.294, -1.66319405739548),
(33318, '75713', 218, 51, 6437, 32.3231, 0.564144519451379, -95.2932, -1.66318009476146),
(33319, '75750', 218, 51, 18919, 32.2524, 0.562910571670219, -95.0722, -1.65932291711455),
(33320, '75751', 218, 51, 7182, 32.1633, 0.561355483306692, -95.8903, -1.67360145572512),
(33321, '75752', 218, 51, 7182, 32.2751, 0.563306761410422, -95.8072, -1.67215108711671),
(33322, '75754', 218, 51, 92563, 32.5277, 0.56771546310096, -95.6257, -1.66898331452434),
(33323, '75755', 218, 51, 85069, 32.5842, 0.568701574128336, -95.1143, -1.66005770072964),
(33324, '75756', 218, 51, 1189, 32.3146, 0.56399616646496, -95.5945, -1.66843877179772),
(33325, '75757', 218, 51, 19635, 32.1505, 0.561132081162437, -95.3727, -1.6645676315168),
(33326, '75758', 218, 51, 656, 32.2406, 0.562704622818484, -95.5345, -1.66739157424652),
(33327, '75759', 218, 51, 93590, 31.8736, 0.556299264463665, -95.2283, -1.66204737607692),
(33328, '75760', 218, 51, 75594, 31.7659, 0.554419544859267, -94.8581, -1.65558616718603),
(33329, '75762', 218, 51, 21143, 32.2025, 0.562039652373474, -95.4253, -1.66548567470334),
(33330, '75763', 218, 51, 94325, 32.0447, 0.559285522813827, -95.5068, -1.66690811804372),
(33331, '75764', 218, 51, 9037, 31.8952, 0.556676255582095, -95.1527, -1.66072790716241),
(33332, '75765', 218, 51, 9384, 32.6569, 0.569970428494536, -95.1968, -1.66149759736254),
(33333, '75766', 218, 51, 3395, 31.9594, 0.557796756961876, -95.2651, -1.66268965724165),
(33334, '75770', 218, 51, 9990, 32.1441, 0.561020380090309, -95.6413, -1.66925558588765),
(33335, '75771', 218, 51, 22681, 32.518, 0.567546166163516, -95.4298, -1.66556421451968),
(33336, '75772', 218, 51, 96067, 31.8008, 0.555028664768213, -95.3023, -1.66333891972339),
(33337, '75773', 218, 51, 4236, 32.669, 0.570181613334028, -95.4872, -1.66656603351033),
(33338, '75778', 218, 51, 67075, 32.3272, 0.564216077950711, -95.8009, -1.67204113137384),
(33339, '75779', 218, 51, 96453, 31.8666, 0.556177091416025, -95.4957, -1.66671438649675),
(33340, '75780', 218, 51, 96518, 31.9852, 0.55824705190889, -95.1049, -1.65989363977996),
(33341, '75782', 218, 51, 57015, 32.076, 0.559831810869701, -95.5949, -1.66844575311473),
(33342, '75783', 218, 51, 11443, 32.7922, 0.572331858972485, -95.4484, -1.66588884576056),
(33343, '75784', 218, 51, 97460, 31.9034, 0.556819372580759, -95.0195, -1.65840312859875),
(33344, '75785', 218, 51, 31022, 31.7974, 0.554969323573645, -95.1482, -1.66064936734607),
(33345, '75788', 218, 51, 97720, 31.8247, 0.555445798459439, -94.9184, -1.65663860072499),
(33346, '75789', 218, 51, 98636, 32.1601, 0.561299632770628, -95.1169, -1.66010307929019),
(33347, '75790', 218, 51, 12520, 32.5261, 0.567687537832928, -95.6345, -1.66913690349852),
(33348, '75791', 218, 51, 6785, 32.2255, 0.562441078101433, -95.2229, -1.66195312829731),
(33349, '75792', 218, 51, 904, 32.4592, 0.566519912563343, -95.126, -1.66026190425213),
(33350, '75797', 218, 51, 85069, 32.5831, 0.568682375506564, -95.109, -1.65996519827929),
(33351, '75798', 218, 51, 6437, 32.3341, 0.564336505669099, -95.2841, -1.66302126979953),
(33352, '75799', 218, 51, 6437, 32.3281, 0.564231785913979, -95.3036, -1.66336160900367),
(33353, '75801', 218, 51, 4839, 31.7566, 0.554257229238831, -95.6371, -1.66918228205907),
(33354, '75802', 218, 51, 4839, 31.7612, 0.554337514384423, -95.6313, -1.66908105296245),
(33355, '75803', 218, 51, 4839, 31.7566, 0.554257229238831, -95.6377, -1.66919275403458),
(33356, '75831', 218, 51, 26642, 31.4584, 0.549052657409384, -96.072, -1.67677271897599),
(33357, '75832', 218, 51, 29419, 31.9571, 0.55775661438908, -95.9742, -1.67506578696754),
(33358, '75833', 218, 51, 1459, 31.2522, 0.545453788491772, -95.972, -1.675027389724),
(33359, '75834', 218, 51, 26746, 31.2581, 0.54555676291764, -95.0392, -1.65874695846139),
(33360, '75835', 218, 51, 92, 31.3175, 0.546593488493324, -95.4537, -1.66598134821091),
(33361, '75838', 218, 51, 93785, 31.478, 0.549394741942775, -96.2517, -1.67990907564183),
(33362, '75839', 218, 51, 94006, 31.6105, 0.551707303201668, -95.4686, -1.66624140226946),
(33363, '75840', 218, 51, 2367, 31.724, 0.553688251902681, -96.1562, -1.67824228620617),
(33364, '75844', 218, 51, 60090, 31.4899, 0.549602436123762, -95.4813, -1.66646305908446),
(33365, '75845', 218, 51, 94633, 31.059, 0.542081812376919, -95.1278, -1.66029332017866),
(33366, '75846', 218, 51, 27563, 31.3759, 0.547612760776489, -96.2219, -1.67938896752473),
(33367, '75847', 218, 51, 30237, 31.3483, 0.547131049902938, -95.1271, -1.6602811028739),
(33368, '75848', 218, 51, 95333, 31.7668, 0.554435252822535, -96.33, -1.68127566844614),
(33369, '75849', 218, 51, 95629, 31.3948, 0.547942628005116, -95.474, -1.66633565004907),
(33370, '75850', 218, 51, 33030, 31.1329, 0.543371610694143, -95.9092, -1.67393132295375),
(33371, '75851', 218, 51, 95888, 31.1025, 0.542841030601536, -95.521, -1.6671559547975),
(33372, '75852', 218, 51, 41, 31.0128, 0.541275470262497, -95.7517, -1.67118242938185),
(33373, '75853', 218, 51, 96286, 31.9349, 0.557369151295137, -95.767, -1.67144946475741),
(33374, '75855', 218, 51, 4723, 31.582, 0.551209884364849, -95.8921, -1.67363287165165),
(33375, '75856', 218, 51, 4945, 31.158, 0.543809688336393, -95.1621, -1.6608919681121),
(33376, '75858', 218, 51, 11471, 31.3918, 0.547890268127556, -95.1395, -1.66049752370115),
(33377, '75859', 218, 51, 98323, 31.9022, 0.556798428629735, -96.278, -1.6803680972351),
(33378, '75860', 218, 51, 91260, 31.627, 0.551995282528247, -96.2808, -1.68041696645416),
(33379, '75861', 218, 51, 98461, 31.8842, 0.556484269364376, -95.9194, -1.67410934653745),
(33380, '75862', 218, 51, 398, 30.9029, 0.539357353414556, -95.3766, -1.66463569935762),
(33381, '75865', 218, 51, 26207, 31.029, 0.541558213601321, -95.0329, -1.65863700271852),
(33382, '75880', 218, 51, 98461, 31.8352, 0.555629058030899, -95.8385, -1.67269737517259),
(33383, '75882', 218, 51, 4839, 31.7566, 0.554257229238831, -95.6466, -1.66934808833801),
(33384, '75884', 218, 51, 98461, 31.8352, 0.555629058030899, -95.8404, -1.67273053642837),
(33385, '75886', 218, 51, 98461, 31.835, 0.555625567372395, -95.84, -1.67272355511137),
(33386, '75901', 218, 51, 95902, 31.3296, 0.546804673332815, -94.722, -1.65321077407407),
(33387, '75902', 218, 51, 95902, 31.3217, 0.546666792321908, -94.8026, -1.65461750945118),
(33388, '75903', 218, 51, 95902, 31.3558, 0.547261949596838, -94.7661, -1.6539804642742),
(33389, '75904', 218, 51, 95902, 31.2858, 0.546040219120442, -94.8077, -1.65470652124303),
(33390, '75915', 218, 51, 95902, 31.3332, 0.546867505185887, -94.726, -1.65328058724415),
(33391, '75925', 218, 51, 18828, 31.6381, 0.552189014075218, -95.0765, -1.65939796627239),
(33392, '75926', 218, 51, 92298, 31.2612, 0.545610868124451, -94.9722, -1.65757758786256),
(33393, '75928', 218, 51, 92740, 30.6821, 0.535503666426152, -93.7585, -1.6363945267311),
(33394, '75929', 218, 51, 92828, 31.3314, 0.546836089259351, -94.2242, -1.64452252505764),
(33395, '75930', 218, 51, 15335, 31.3221, 0.546673773638916, -94.0148, -1.64086780560396),
(33396, '75931', 218, 51, 92837, 31.1036, 0.542860229223308, -93.9846, -1.64034071616986),
(33397, '75932', 218, 51, 92927, 30.9994, 0.54104159614273, -93.6368, -1.63427046103143),
(33398, '75933', 218, 51, 53795, 30.5189, 0.532655289086897, -93.8091, -1.63727766333261),
(33399, '75934', 218, 51, 1304, 30.9169, 0.539601699509835, -94.7339, -1.65341846825506),
(33400, '75935', 218, 51, 1440, 31.7934, 0.554899510403565, -94.1781, -1.64371792827247),
(33401, '75936', 218, 51, 8056, 30.766, 0.536967997668575, -94.4613, -1.64866070071412),
(33402, '75937', 218, 51, 93230, 31.4841, 0.549501207027147, -94.4115, -1.64779152674663),
(33403, '75938', 218, 51, 93348, 30.8751, 0.538872151882501, -94.4476, -1.6484215906066),
(33404, '75939', 218, 51, 93455, 31.0006, 0.541062540093754, -94.8181, -1.65488803548524),
(33405, '75941', 218, 51, 93736, 31.1842, 0.544266964600416, -94.7851, -1.65431207683208),
(33406, '75942', 218, 51, 93800, 30.8179, 0.537873823550361, -94.4283, -1.64808474206096),
(33407, '75943', 218, 51, 32253, 31.6598, 0.552567750522901, -94.8741, -1.65586541986635),
(33408, '75944', 218, 51, 35801, 31.3742, 0.547583090179205, -94.4328, -1.6481632818773),
(33409, '75946', 218, 51, 27246, 31.8235, 0.555424854508416, -94.4946, -1.64924189535503),
(33410, '75947', 218, 51, 2687, 31.4769, 0.549375543321003, -93.9174, -1.63916785491252),
(33411, '75948', 218, 51, 36364, 31.361, 0.547352706717942, -93.6908, -1.6352129388275),
(33412, '75949', 218, 51, 9621, 31.2835, 0.546000076547646, -94.5795, -1.65072367988998),
(33413, '75951', 218, 51, 738, 30.9258, 0.539757033813262, -94.0054, -1.64070374465428),
(33414, '75954', 218, 51, 95188, 31.919, 0.55709164394407, -94.0662, -1.64176490483949),
(33415, '75956', 218, 51, 55700, 30.6579, 0.53508129674717, -93.8966, -1.63880482642811),
(33416, '75958', 218, 51, 27817, 31.6429, 0.552272789879314, -94.4139, -1.64783341464867),
(33417, '75959', 218, 51, 96212, 31.4902, 0.549607672111518, -93.8609, -1.63818174388515),
(33418, '75960', 218, 51, 4344, 30.9209, 0.539671512679915, -94.9338, -1.65690738142979),
(33419, '75961', 218, 51, 96429, 31.6114, 0.551723011164936, -94.651, -1.65197159030515),
(33420, '75962', 218, 51, 96429, 31.615, 0.551785843018007, -94.6521, -1.65199078892693),
(33421, '75963', 218, 51, 96429, 31.6334, 0.552106983600374, -94.6402, -1.65178309474594),
(33422, '75964', 218, 51, 96429, 31.5984, 0.551496118362176, -94.6654, -1.65222291771744),
(33423, '75965', 218, 51, 96429, 31.611, 0.551716029847928, -94.651, -1.65197159030515),
(33424, '75966', 218, 51, 4570, 30.8423, 0.538299683887847, -93.7588, -1.63639976271886),
(33425, '75968', 218, 51, 17628, 31.2478, 0.545376994004684, -93.9779, -1.64022377910998),
(33426, '75969', 218, 51, 97156, 31.4259, 0.548485425402486, -94.8651, -1.65570834023367),
(33427, '75972', 218, 51, 97776, 31.5298, 0.550298822495308, -94.1123, -1.64256950162466),
(33428, '75973', 218, 51, 11899, 31.7026, 0.553314751442754, -93.9594, -1.63990089319836),
(33429, '75974', 218, 51, 98455, 31.9377, 0.557418020514193, -94.2541, -1.64504437850399),
(33430, '75975', 218, 51, 98552, 31.9057, 0.556859515153555, -94.4038, -1.64765713639422),
(33431, '75976', 218, 51, 34376, 31.5069, 0.549899142096601, -94.9885, -1.65786207653063),
(33432, '75977', 218, 51, 99103, 31.0763, 0.542383754337514, -93.8089, -1.63727417267411),
(33433, '75978', 218, 51, 99177, 31.5033, 0.54983631024353, -94.5259, -1.64978818341091),
(33434, '75979', 218, 51, 6954, 30.7559, 0.536791719414124, -94.3929, -1.64746689550576),
(33435, '75980', 218, 51, 99258, 31.1933, 0.544425789562347, -94.3601, -1.6468944275111),
(33436, '75990', 218, 51, 6954, 30.7746, 0.537118095984247, -94.4219, -1.64797304098883),
(33437, '76001', 218, 51, 15026, 32.6211, 0.569345600622322, -97.1541, -1.69565892681182),
(33438, '76002', 218, 51, 15026, 32.6319, 0.569534096181538, -97.0773, -1.69431851394629),
(33439, '76003', 218, 51, 15026, 32.6576, 0.5699826457993, -97.1726, -1.69598181272344),
(33440, '76004', 218, 51, 15026, 32.7339, 0.571314332018572, -97.1039, -1.69478277152732),
(33441, '76005', 218, 51, 15026, 32.7527, 0.571642453917947, -97.0591, -1.69400086402243),
(33442, '76006', 218, 51, 15026, 32.7766, 0.572059587609173, -97.0815, -1.69439181777488),
(33443, '76007', 218, 51, 15026, 32.72, 0.571071731252545, -97.0827, -1.6944127617259),
(33444, '76008', 218, 51, 74958, 32.7016, 0.570750590670178, -97.6267, -1.70390735285675),
(33445, '76009', 218, 51, 92229, 32.4307, 0.566022493726525, -97.1943, -1.69636054917112),
(33446, '76010', 218, 51, 15026, 32.7222, 0.571110128496089, -97.0828, -1.69441450705515),
(33447, '76011', 218, 51, 15026, 32.7579, 0.571733211039051, -97.0881, -1.69450700950551),
(33448, '76012', 218, 51, 15026, 32.7562, 0.571703540441767, -97.1353, -1.69533080491245),
(33449, '76013', 218, 51, 15026, 32.7192, 0.571057768618529, -97.1512, -1.69560831226352),
(33450, '76014', 218, 51, 15026, 32.6955, 0.570644125585806, -97.0883, -1.69451050016401),
(33451, '76015', 218, 51, 15026, 32.6921, 0.570584784391238, -97.1321, -1.69527495437638),
(33452, '76016', 218, 51, 15026, 32.688, 0.570513225891906, -97.19, -1.69628550001329),
(33453, '76017', 218, 51, 15026, 32.6549, 0.569935521909496, -97.159, -1.69574444794517),
(33454, '76018', 218, 51, 15026, 32.6541, 0.56992155927548, -97.0947, -1.69462220123614),
(33455, '76019', 218, 51, 15026, 32.7296, 0.571239282860736, -97.1134, -1.69494857780626),
(33456, '76020', 218, 51, 92391, 32.9078, 0.57434945958779, -97.526, -1.70214980629999),
(33457, '76021', 218, 51, 146, 32.8524, 0.573382547182185, -97.1399, -1.69541109005804),
(33458, '76022', 218, 51, 146, 32.8276, 0.57294970552769, -97.1455, -1.69550882849615),
(33459, '76023', 218, 51, 1069, 33.1364, 0.578339282257849, -97.646, -1.70424420140238),
(33460, '76028', 218, 51, 92929, 32.529, 0.567738152381235, -97.3114, -1.69840432972521),
(33461, '76031', 218, 51, 1617, 32.3496, 0.564607031703158, -97.3924, -1.69981804641933),
(33462, '76033', 218, 51, 1617, 32.3479, 0.564577361105874, -97.3863, -1.69971158133495),
(33463, '76034', 218, 51, 93342, 32.8869, 0.573984685774123, -97.1456, -1.6955105738254),
(33464, '76035', 218, 51, 112625, 32.5664, 0.568390905521481, -97.6796, -1.70483063203105),
(33465, '76036', 218, 51, 8340, 32.5878, 0.568764405981408, -97.3703, -1.69943232865463),
(33466, '76039', 218, 51, 94107, 32.8527, 0.573387783169941, -97.0887, -1.69451748148102),
(33467, '76040', 218, 51, 94107, 32.826, 0.572921780259659, -97.1038, -1.69478102619807),
(33468, '76041', 218, 51, 59946, 32.2363, 0.562629573660648, -96.8575, -1.69048228025041),
(33469, '76043', 218, 51, 9133, 32.235, 0.562606884380372, -97.7529, -1.70610995837277),
(33470, '76044', 218, 51, 94509, 32.4509, 0.566375050235428, -97.5276, -1.70217773156802),
(33471, '76048', 218, 51, 94566, 32.4292, 0.565996313787745, -97.7607, -1.70624609405442),
(33472, '76049', 218, 51, 94566, 32.4498, 0.566355851613656, -97.7358, -1.70581150707067),
(33473, '76050', 218, 51, 534, 32.265, 0.56313048315597, -97.1774, -1.69606558852754),
(33474, '76051', 218, 51, 9184, 32.9316, 0.574764847949765, -97.0957, -1.69463965452866),
(33475, '76052', 218, 51, 94775, 32.9564, 0.575197689604259, -97.3443, -1.69897854304912),
(33476, '76053', 218, 51, 22117, 32.8239, 0.572885128345367, -97.1796, -1.69610398577108),
(33477, '76054', 218, 51, 22117, 32.8601, 0.573516937534589, -97.1757, -1.69603591793025),
(33478, '76055', 218, 51, 95120, 32.1589, 0.561278688819605, -97.1472, -1.69553849909344),
(33479, '76058', 218, 51, 16677, 32.4622, 0.566572272440903, -97.3979, -1.69991403952819),
(33480, '76059', 218, 51, 16697, 32.3944, 0.565388939208051, -97.329, -1.69871150767356),
(33481, '76060', 218, 51, 95286, 32.6425, 0.569719101082249, -97.2108, -1.6966485284977),
(33482, '76061', 218, 51, 3772, 32.506, 0.567336726653277, -97.1872, -1.69623663079423),
(33483, '76063', 218, 51, 3975, 32.5803, 0.568633506287509, -97.1385, -1.69538665544851),
(33484, '76064', 218, 51, 96075, 32.3049, 0.563826869527516, -97.0261, -1.69342490536927),
(33485, '76065', 218, 51, 49469, 32.4799, 0.566881195718506, -96.981, -1.69263776187662),
(33486, '76066', 218, 51, 96232, 32.757, 0.571717503075783, -98.0046, -1.71050295210003),
(33487, '76067', 218, 51, 60906, 32.8061, 0.572574459738512, -98.1098, -1.71233903847313),
(33488, '76068', 218, 51, 60906, 32.8083, 0.572612856982056, -98.1125, -1.71238616236294),
(33489, '76070', 218, 51, 10750, 32.2848, 0.563476058347865, -97.6471, -1.70426340002415),
(33490, '76071', 218, 51, 10792, 33.0091, 0.57611747812006, -97.5347, -1.70230164994491),
(33491, '76073', 218, 51, 11064, 33.0996, 0.577697001093115, -97.7781, -1.70654978134427),
(33492, '76077', 218, 51, 5276, 32.2895, 0.563558088822709, -97.6983, -1.70515700860118),
(33493, '76078', 218, 51, 97483, 33.0483, 0.576801647186842, -97.4727, -1.70121954580868),
(33494, '76082', 218, 51, 12093, 32.9615, 0.575286701396111, -97.6833, -1.70489520921338),
(33495, '76084', 218, 51, 12548, 32.4438, 0.566251131858536, -97.1033, -1.69477229955181),
(33496, '76085', 218, 51, 25862, 32.7595, 0.571761136307082, -97.7971, -1.70688139390215),
(33497, '76086', 218, 51, 25862, 32.7896, 0.572286480411933, -97.8142, -1.70717984520424),
(33498, '76087', 218, 51, 25862, 32.6969, 0.570668560195334, -97.7745, -1.7064869494912),
(33499, '76088', 218, 51, 25862, 32.7681, 0.571911234622754, -97.8063, -1.70704196419333),
(33500, '76092', 218, 51, 5973, 32.9548, 0.575169764336227, -97.1475, -1.69554373508119),
(33501, '76093', 218, 51, 11592, 32.2462, 0.562802361256596, -97.3869, -1.69972205331047),
(33502, '76094', 218, 51, 15026, 32.7233, 0.57112932711786, -97.1484, -1.69555944304446),
(33503, '76095', 218, 51, 146, 32.8523, 0.573380801852933, -97.1475, -1.69554373508119),
(33504, '76096', 218, 51, 15026, 32.6731, 0.570253171833359, -97.0898, -1.69453668010279),
(33505, '76097', 218, 51, 92929, 32.542, 0.567965045183995, -97.321, -1.6985718813334),
(33506, '76098', 218, 51, 92391, 32.8992, 0.574199361272118, -97.5397, -1.70238891640751),
(33507, '76099', 218, 51, 9184, 32.9341, 0.574808481181065, -97.0777, -1.6943254952633),
(33508, '76101', 218, 51, 94289, 32.7592, 0.571755900319326, -97.329, -1.69871150767356),
(33509, '76102', 218, 51, 94289, 32.7589, 0.57175066433157, -97.3235, -1.6986155145647),
(33510, '76103', 218, 51, 94289, 32.7484, 0.571567404760111, -97.2659, -1.69761020491555),
(33511, '76104', 218, 51, 94289, 32.7306, 0.571256736153256, -97.3182, -1.69852301211435),
(33512, '76105', 218, 51, 94289, 32.7243, 0.57114678041038, -97.2695, -1.69767303676862),
(33513, '76106', 218, 51, 94289, 32.7974, 0.572422616093588, -97.3569, -1.69919845453487),
(33514, '76107', 218, 51, 94289, 32.7425, 0.571464430334243, -97.3883, -1.69974648791999),
(33515, '76108', 218, 51, 94289, 32.7617, 0.571799533550626, -97.484, -1.70141676801415),
(33516, '76109', 218, 51, 94289, 32.6995, 0.570713938755886, -97.382, -1.69963653217712),
(33517, '76110', 218, 51, 94289, 32.7085, 0.570871018388565, -97.337, -1.69885113401372),
(33518, '76111', 218, 51, 94289, 32.78, 0.572118928803741, -97.302, -1.69824026877552),
(33519, '76112', 218, 51, 94289, 32.7514, 0.571619764637671, -97.209, -1.69661711257117),
(33520, '76113', 218, 51, 94289, 32.7469, 0.571541224821331, -97.3267, -1.69867136510077),
(33521, '76114', 218, 51, 94289, 32.7771, 0.572068314255433, -97.4026, -1.69999607000303),
(33522, '76115', 218, 51, 94289, 32.6806, 0.570384071527259, -97.3317, -1.69875863156336),
(33523, '76116', 218, 51, 94289, 32.7217, 0.571101401849828, -97.462, -1.70103279557871),
(33524, '76117', 218, 51, 94698, 32.8048, 0.572551770458236, -97.2684, -1.69765383814685),
(33525, '76118', 218, 51, 94289, 32.8198, 0.572813569846035, -97.2216, -1.69683702405692),
(33526, '76119', 218, 51, 94289, 32.68, 0.570373599551747, -97.2533, -1.6973902934298),
(33527, '76120', 218, 51, 94289, 32.7645, 0.571848402769682, -97.1835, -1.69617205361191),
(33528, '76121', 218, 51, 94289, 32.7237, 0.571136308434868, -97.4498, -1.70081986540997),
(33529, '76122', 218, 51, 94289, 32.6848, 0.570457375355843, -97.346, -1.6990082136464),
(33530, '76123', 218, 51, 94289, 32.6252, 0.569417159121654, -97.3698, -1.69942360200837),
(33531, '76124', 218, 51, 94289, 32.7593, 0.571757645648578, -97.2043, -1.69653508209632),
(33532, '76126', 218, 51, 94289, 32.5851, 0.568717282091604, -97.5365, -1.70233306587145),
(33533, '76127', 218, 51, 0, 32.7602, 0.571773353611846, -97.4255, -1.70039575040174),
(33534, '76129', 218, 51, 94289, 32.7095, 0.570888471681085, -97.3575, -1.69920892651038),
(33535, '76130', 218, 51, 94289, 32.7071, 0.570846583779037, -97.3638, -1.69931888225326),
(33536, '76131', 218, 51, 94289, 32.8589, 0.573495993583565, -97.3303, -1.69873419695384),
(33537, '76132', 218, 51, 94289, 32.6684, 0.570171141358516, -97.4205, -1.70030848393914),
(33538, '76133', 218, 51, 94289, 32.6519, 0.569883162031936, -97.3768, -1.69954577505601),
(33539, '76134', 218, 51, 94289, 32.6449, 0.569760988984297, -97.3292, -1.69871499833207),
(33540, '76135', 218, 51, 94289, 32.8248, 0.572900836308635, -97.4534, -1.70088269726304),
(33541, '76136', 218, 51, 94289, 32.897, 0.574160964028575, -97.4583, -1.70096821839639),
(33542, '76137', 218, 51, 94289, 32.8587, 0.573492502925061, -97.2907, -1.69804304657005),
(33543, '76140', 218, 51, 94289, 32.6121, 0.569188520989643, -97.2701, -1.69768350874414),
(33544, '76147', 218, 51, 94289, 32.7507, 0.571607547332907, -97.3635, -1.6993136462655),
(33545, '76148', 218, 51, 94289, 32.8623, 0.573555334778132, -97.2498, -1.69732920690598),
(33546, '76150', 218, 51, 94289, 32.7542, 0.571668633856727, -97.3358, -1.6988301900627),
(33547, '76155', 218, 51, 94289, 32.8254, 0.572911308284147, -97.0533, -1.69389963492581),
(33548, '76161', 218, 51, 94289, 32.8077, 0.572602385006544, -97.3538, -1.69914434932806),
(33549, '76162', 218, 51, 94289, 32.6628, 0.570073402920404, -97.3763, -1.69953704840975),
(33550, '76163', 218, 51, 94289, 32.663, 0.570076893578908, -97.3765, -1.69954053906826),
(33551, '76164', 218, 51, 94289, 32.7827, 0.572166052693545, -97.3493, -1.69906580951172),
(33552, '76177', 218, 51, 94289, 32.9745, 0.57551359419887, -97.3354, -1.69882320874569),
(33553, '76178', 218, 51, 94289, 32.8984, 0.574185398638103, -97.3046, -1.69828564733607),
(33554, '76179', 218, 51, 94289, 32.8758, 0.573790954227152, -97.4092, -1.70011126173366),
(33555, '76180', 218, 51, 96608, 32.8594, 0.573504720229825, -97.2166, -1.69674975759432),
(33556, '76181', 218, 51, 94289, 32.8103, 0.572647763567095, -97.2275, -1.69693999848279),
(33557, '76182', 218, 51, 96608, 32.7973, 0.572420870764336, -97.193, -1.69633785989085),
(33558, '76185', 218, 51, 94289, 32.8652, 0.57360594932644, -97.2162, -1.69674277627731),
(33559, '76191', 218, 51, 94289, 32.808, 0.5726076209943, -97.3525, -1.69912166004778),
(33560, '76192', 218, 51, 94289, 32.9302, 0.574740413340237, -97.4358, -1.70057551931469),
(33561, '76193', 218, 51, 94289, 32.7469, 0.571541224821331, -97.3293, -1.69871674366132),
(33562, '76195', 218, 51, 94289, 32.7288, 0.57122532022672, -97.3181, -1.69852126678509),
(33563, '76196', 218, 51, 94289, 32.7559, 0.57169830445401, -97.3352, -1.69881971808718),
(33564, '76197', 218, 51, 94289, 32.7798, 0.572115438145237, -97.3001, -1.69820710751973),
(33565, '76198', 218, 51, 94289, 32.753, 0.571647689905703, -97.3328, -1.69877783018514),
(33566, '76199', 218, 51, 94289, 32.7499, 0.571593584698891, -97.3351, -1.69881797275793),
(33567, '76201', 218, 51, 8484, 33.2206, 0.579808849488028, -97.1465, -1.69552628178867),
(33568, '76202', 218, 51, 8484, 33.1747, 0.579007743361363, -97.1804, -1.6961179484051),
(33569, '76203', 218, 51, 8484, 33.2144, 0.579700639074405, -97.1323, -1.69527844503489),
(33570, '76204', 218, 51, 8484, 33.2142, 0.579697148415901, -97.1306, -1.6952487744376),
(33571, '76205', 218, 51, 8484, 33.1881, 0.57924161748113, -97.1282, -1.69520688653556),
(33572, '76206', 218, 51, 8484, 33.1979, 0.579412659747826, -97.1223, -1.69510391210969),
(33573, '76207', 218, 51, 8484, 33.2367, 0.580089847497599, -97.1783, -1.69608129649081),
(33574, '76208', 218, 51, 8484, 33.2112, 0.579644788538341, -97.0643, -1.69409162114353),
(33575, '76209', 218, 51, 8484, 33.2303, 0.579978146425472, -97.11, -1.69488923661169),
(33576, '76210', 218, 51, 8484, 33.1421, 0.578438766025213, -97.0846, -1.69444592298169),
(33577, '76225', 218, 51, 92231, 33.3605, 0.582250565111568, -97.6947, -1.7050941767481),
(33578, '76226', 218, 51, 15022, 33.1223, 0.578093190833318, -97.1399, -1.69541109005804),
(33579, '76227', 218, 51, 7206, 33.2701, 0.580672787467765, -96.9764, -1.69255747673103),
(33580, '76228', 218, 51, 270, 33.5914, 0.586280530354423, -98.1674, -1.71334434812228),
(33581, '76230', 218, 51, 39466, 33.5611, 0.585751695591069, -97.8424, -1.7076720280533),
(33582, '76233', 218, 51, 1706, 33.56, 0.585732496969297, -96.9092, -1.69138461547369),
(33583, '76234', 218, 51, 2007, 33.2299, 0.579971165108464, -97.5901, -1.70326856235052),
(33584, '76238', 218, 51, 35787, 33.498, 0.58465039283306, -97.3029, -1.69825597673879),
(33585, '76239', 218, 51, 64824, 33.5451, 0.58547244291075, -97.5995, -1.70343262330021),
(33586, '76240', 218, 51, 2644, 33.6198, 0.58677620386199, -97.1212, -1.69508471348792),
(33587, '76241', 218, 51, 2644, 33.6238, 0.586846017032069, -97.15, -1.69558736831249),
(33588, '76244', 218, 51, 22331, 32.9344, 0.57481371716882, -97.2513, -1.69735538684476),
(33589, '76245', 218, 51, 659, 33.8555, 0.59088994490894, -96.8104, -1.68966023017272),
(33590, '76246', 218, 51, 2869, 33.3804, 0.582597885632715, -97.4743, -1.70124747107671),
(33591, '76247', 218, 51, 95238, 33.0708, 0.577194346268541, -97.303, -1.69825772206804),
(33592, '76248', 218, 51, 22331, 32.9289, 0.574717724059961, -97.2485, -1.69730651762571),
(33593, '76249', 218, 51, 95369, 33.2588, 0.58047556526229, -97.2353, -1.69707613416444),
(33594, '76250', 218, 51, 41807, 33.6394, 0.58711828839538, -97.2119, -1.69666772711948),
(33595, '76251', 218, 51, 4275, 33.6765, 0.58776580554787, -97.7294, -1.70569980599855),
(33596, '76252', 218, 51, 96397, 33.6517, 0.587332963893376, -97.3754, -1.69952134044649),
(33597, '76253', 218, 51, 37347, 33.624, 0.586849507690573, -97.3141, -1.69845145361501),
(33598, '76255', 218, 51, 96560, 33.7979, 0.589884635259792, -97.7127, -1.70540833601346),
(33599, '76258', 218, 51, 97055, 33.3838, 0.582657226827283, -96.9493, -1.69208449250374),
(33600, '76259', 218, 51, 56990, 33.1897, 0.579269542749162, -97.2783, -1.6978266257428),
(33601, '76261', 218, 51, 5403, 33.8044, 0.589998081661171, -97.95, -1.70955000232845),
(33602, '76262', 218, 51, 5436, 33.0056, 0.57605639159624, -97.1972, -1.69641116371943),
(33603, '76263', 218, 51, 11696, 33.4802, 0.584339724226206, -97.4531, -1.70087746127529),
(33604, '76264', 218, 51, 38058, 33.736, 0.588804276452807, -96.8327, -1.69004943859591),
(33605, '76265', 218, 51, 97730, 33.7002, 0.588179448580593, -97.5251, -1.70213409833672),
(33606, '76266', 218, 51, 97847, 33.3589, 0.582222639843536, -97.1781, -1.6960778058323),
(33607, '76267', 218, 51, 43093, 33.3596, 0.5822348571483, -97.3917, -1.69980582911456),
(33608, '76268', 218, 51, 98214, 33.6212, 0.586800638471518, -96.7197, -1.68807721654116),
(33609, '76270', 218, 51, 12218, 33.4586, 0.583962733107775, -97.7742, -1.70648171350344),
(33610, '76271', 218, 51, 25513, 33.4695, 0.584152973996242, -96.8879, -1.69101286034301),
(33611, '76272', 218, 51, 6510, 33.4768, 0.584280383031638, -97.1039, -1.69478277152732);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(33612, '76273', 218, 51, 6799, 33.6571, 0.587427211672984, -96.9049, -1.69130956631585),
(33613, '76299', 218, 51, 5436, 32.9818, 0.575641003234266, -97.169, -1.69591898087037),
(33614, '76301', 218, 51, 99098, 33.9084, 0.591813224083245, -98.4991, -1.71913360525115),
(33615, '76302', 218, 51, 99098, 33.8676, 0.591101129748432, -98.4907, -1.71898699759398),
(33616, '76305', 218, 51, 99098, 33.9363, 0.592300170944552, -98.5407, -1.71985966221998),
(33617, '76306', 218, 51, 99098, 33.9786, 0.593038445218145, -98.5214, -1.71952281367434),
(33618, '76307', 218, 51, 99098, 33.9087, 0.591818460071001, -98.4913, -1.71899746956949),
(33619, '76308', 218, 51, 99098, 33.867, 0.59109065777292, -98.5393, -1.71983522761045),
(33620, '76309', 218, 51, 99098, 33.8934, 0.591551424695446, -98.5361, -1.71977937707438),
(33621, '76310', 218, 51, 99098, 33.8618, 0.590999900651816, -98.5773, -1.72049845272621),
(33622, '76311', 218, 51, 0, 33.9669, 0.592834241695662, -98.5041, -1.71922087171375),
(33623, '76351', 218, 51, 92309, 33.5893, 0.586243878440131, -98.6258, -1.72134493741342),
(33624, '76352', 218, 51, 92707, 33.6737, 0.587716936328815, -98.2299, -1.71443517890478),
(33625, '76354', 218, 51, 92925, 34.0887, 0.594960052724591, -98.5785, -1.72051939667723),
(33626, '76357', 218, 51, 19679, 34.0621, 0.594495795143561, -98.1934, -1.7137981337278),
(33627, '76360', 218, 51, 15915, 34.0188, 0.593740067577447, -98.8926, -1.72600147585774),
(33628, '76363', 218, 51, 94549, 33.4947, 0.584592796967745, -99.5262, -1.73705988199838),
(33629, '76364', 218, 51, 94760, 33.9933, 0.593295008618188, -99.0465, -1.72868753757656),
(33630, '76365', 218, 51, 16406, 33.8173, 0.590223229134679, -98.1896, -1.71373181121622),
(33631, '76366', 218, 51, 27457, 33.814, 0.590165633269363, -98.6936, -1.72252827064628),
(33632, '76367', 218, 51, 95105, 33.9471, 0.592488666503767, -98.6899, -1.72246369346395),
(33633, '76369', 218, 51, 95243, 33.8635, 0.5910295712491, -98.8032, -1.72444115150646),
(33634, '76370', 218, 51, 4149, 33.3611, 0.58226103708708, -98.7606, -1.72369764124511),
(33635, '76371', 218, 51, 96405, 33.4492, 0.583798672158087, -99.6254, -1.73879124861636),
(33636, '76372', 218, 51, 10795, 33.1919, 0.579307939992706, -98.7343, -1.72323861965184),
(33637, '76373', 218, 51, 96723, 34.0858, 0.594909438176283, -99.1601, -1.73067023160683),
(33638, '76374', 218, 51, 4784, 33.3671, 0.5823657568422, -98.7598, -1.7236836786111),
(33639, '76377', 218, 51, 28229, 34.0177, 0.593720868955675, -98.2341, -1.71450848273336),
(33640, '76379', 218, 51, 5690, 33.6564, 0.58741499436822, -98.4697, -1.71862047845106),
(33641, '76380', 218, 51, 5745, 33.5921, 0.586292747659187, -99.2614, -1.7324382501391),
(33642, '76384', 218, 51, 6535, 34.15, 0.596029939556064, -99.2927, -1.73298453819497),
(33643, '76385', 218, 51, 6535, 34.1542, 0.596103243384647, -99.2647, -1.73249584600442),
(33644, '76388', 218, 51, 98967, 33.3282, 0.581686823763174, -99.6123, -1.73856261048435),
(33645, '76389', 218, 51, 99156, 33.5816, 0.586109488087728, -98.4334, -1.71798692393259),
(33646, '76401', 218, 51, 43214, 32.2198, 0.562341594334069, -98.2149, -1.71417337951698),
(33647, '76402', 218, 51, 43214, 32.2189, 0.562325886370801, -98.2152, -1.71417861550473),
(33648, '76424', 218, 51, 26597, 32.7544, 0.571672124515231, -98.9104, -1.7263121444646),
(33649, '76426', 218, 51, 1130, 33.1549, 0.578662168169468, -97.8221, -1.70731772621515),
(33650, '76427', 218, 51, 53706, 33.132, 0.578262487770761, -98.343, -1.71640914628878),
(33651, '76429', 218, 51, 1272, 32.6849, 0.570459120685095, -98.6432, -1.72164862470327),
(33652, '76430', 218, 51, 18772, 32.7281, 0.571213102921956, -99.2936, -1.73300024615824),
(33653, '76431', 218, 51, 1548, 33.346, 0.581997492370029, -97.8152, -1.70719729849676),
(33654, '76432', 218, 51, 92680, 31.825, 0.555451034447195, -98.7877, -1.7241706254724),
(33655, '76433', 218, 51, 92712, 32.351, 0.564631466312686, -98.0208, -1.71078569543886),
(33656, '76435', 218, 51, 26706, 32.095, 0.56016342342758, -98.964, -1.72724764094367),
(33657, '76436', 218, 51, 1361, 31.9053, 0.556852533836547, -98.1337, -1.71275617216436),
(33658, '76437', 218, 51, 8084, 32.385, 0.565224878258364, -98.9782, -1.72749547769745),
(33659, '76439', 218, 51, 20549, 32.619, 0.56930894870803, -97.9263, -1.70913635929572),
(33660, '76442', 218, 51, 75505, 31.9034, 0.556819372580759, -98.6008, -1.72090860510043),
(33661, '76443', 218, 51, 473, 32.1272, 0.560725419446722, -99.165, -1.73075575274018),
(33662, '76444', 218, 51, 93659, 32.1077, 0.560385080242583, -98.537, -1.71979508503765),
(33663, '76445', 218, 51, 93713, 32.3027, 0.563788472283972, -98.564, -1.72026632393569),
(33664, '76446', 218, 51, 2113, 32.0878, 0.560037759721437, -98.3415, -1.71638296635),
(33665, '76448', 218, 51, 35690, 32.3984, 0.565458752378131, -98.8226, -1.72477974538135),
(33666, '76449', 218, 51, 94562, 32.9273, 0.574689798791929, -98.306, -1.71576337446555),
(33667, '76450', 218, 51, 2802, 33.0658, 0.577107079805941, -98.6339, -1.72148630908284),
(33668, '76452', 218, 51, 27103, 31.7648, 0.554400346237495, -98.3687, -1.71685769590655),
(33669, '76453', 218, 51, 2785, 32.5767, 0.568570674434437, -98.3533, -1.71658891520174),
(33670, '76454', 218, 51, 47553, 32.2124, 0.562212439969422, -98.6707, -1.72212859024757),
(33671, '76455', 218, 51, 94664, 31.86, 0.556061899685393, -98.3611, -1.71672505088339),
(33672, '76457', 218, 51, 9481, 31.9921, 0.558367479627278, -98.023, -1.7108240926824),
(33673, '76458', 218, 51, 88129, 33.3064, 0.581306341986239, -98.1556, -1.71313839927055),
(33674, '76459', 218, 51, 95178, 33.2601, 0.580498254542566, -98.3989, -1.71738478534065),
(33675, '76460', 218, 51, 22758, 33.272, 0.580705948723553, -98.4885, -1.71894860035044),
(33676, '76461', 218, 51, 95731, 32.2442, 0.562767454671556, -98.3771, -1.71700430356371),
(33677, '76462', 218, 51, 95736, 32.4806, 0.56689341302327, -98.0504, -1.71130231289745),
(33678, '76463', 218, 51, 96251, 32.652, 0.569884907361188, -98.4323, -1.71796772531081),
(33679, '76464', 218, 51, 10585, 32.5454, 0.568024386378563, -99.1672, -1.73079414998372),
(33680, '76465', 218, 51, 96333, 32.3878, 0.565273747477419, -98.1667, -1.71333213081752),
(33681, '76466', 218, 51, 56673, 32.4183, 0.565806072899278, -98.7506, -1.72352310831991),
(33682, '76467', 218, 51, 96897, 32.271, 0.56323520291109, -97.9072, -1.70880300140859),
(33683, '76468', 218, 51, 5236, 31.9876, 0.558288939810938, -98.4296, -1.71792060142101),
(33684, '76469', 218, 51, 5256, 32.3729, 0.565013693418872, -99.1979, -1.73132996606408),
(33685, '76470', 218, 51, 11465, 32.4581, 0.566500713941572, -98.6904, -1.72247242011021),
(33686, '76471', 218, 51, 97524, 32.0971, 0.560200075341872, -98.9641, -1.72724938627292),
(33687, '76472', 218, 51, 97874, 32.5887, 0.568780113944676, -98.1846, -1.71364454475362),
(33688, '76474', 218, 51, 5844, 31.9295, 0.557274903515529, -98.7766, -1.72397689392543),
(33689, '76475', 218, 51, 51765, 32.5567, 0.568221608584038, -98.4968, -1.71909346267835),
(33690, '76476', 218, 51, 98573, 32.4093, 0.565648993266598, -97.837, -1.70757778027369),
(33691, '76481', 218, 51, 12027, 32.959, 0.575243068164811, -98.7604, -1.72369415058661),
(33692, '76483', 218, 51, 91332, 33.1904, 0.579281760053926, -99.2765, -1.73270179485615),
(33693, '76484', 218, 51, 56779, 32.7517, 0.571625000625427, -98.286, -1.71541430861515),
(33694, '76485', 218, 51, 96967, 32.8718, 0.573721141057072, -97.8664, -1.70809090707378),
(33695, '76486', 218, 51, 56847, 33.0825, 0.577398549791024, -98.054, -1.71136514475052),
(33696, '76487', 218, 51, 61391, 32.9707, 0.575447271687294, -97.8836, -1.70839110370512),
(33697, '76490', 218, 51, 99094, 32.9647, 0.575342551932175, -98.0227, -1.71081885669465),
(33698, '76491', 218, 51, 12950, 33.3074, 0.581323795278759, -99.0261, -1.72833149040916),
(33699, '76501', 218, 51, 12281, 31.1074, 0.542926551734884, -97.347, -1.69902566693892),
(33700, '76502', 218, 51, 12281, 31.0896, 0.542615883128029, -97.3801, -1.69960337092133),
(33701, '76503', 218, 51, 12281, 31.1547, 0.543752092471077, -97.4421, -1.70068547505757),
(33702, '76504', 218, 51, 12281, 31.0952, 0.542713621566141, -97.3673, -1.69937996877707),
(33703, '76505', 218, 51, 12281, 31.0191, 0.541385426005373, -97.3283, -1.6986992903688),
(33704, '76508', 218, 51, 12281, 31.094, 0.542692677615117, -97.3643, -1.69932760889952),
(33705, '76511', 218, 51, 19076, 30.7983, 0.53753173901697, -97.4273, -1.70042716632827),
(33706, '76513', 218, 51, 19183, 31.0953, 0.542715366895393, -97.4706, -1.70118289389439),
(33707, '76518', 218, 51, 92883, 30.8953, 0.539224708391404, -97.1266, -1.69517896126752),
(33708, '76519', 218, 51, 1239, 30.9587, 0.540331247137169, -96.8675, -1.69065681317561),
(33709, '76520', 218, 51, 806, 30.8538, 0.538500396751826, -96.9776, -1.69257842068205),
(33710, '76522', 218, 51, 93437, 31.1216, 0.543174388488667, -97.9047, -1.70875936817729),
(33711, '76523', 218, 51, 93646, 30.7661, 0.536969742997827, -97.1847, -1.69619299756293),
(33712, '76524', 218, 51, 2216, 31.6296, 0.552040661088798, -97.1565, -1.69570081471387),
(33713, '76525', 218, 51, 94117, 31.4119, 0.548241079307207, -98.1032, -1.7122238467425),
(33714, '76526', 218, 51, 8900, 31.3104, 0.546469570116433, -97.5717, -1.70294742176815),
(33715, '76527', 218, 51, 2502, 30.8384, 0.538231616047019, -97.7903, -1.70676271151301),
(33716, '76528', 218, 51, 29876, 31.4307, 0.548569201206582, -97.7397, -1.7058795749115),
(33717, '76530', 218, 51, 94574, 30.7152, 0.536081370408562, -97.4404, -1.70065580446028),
(33718, '76531', 218, 51, 2950, 31.7014, 0.55329380749173, -98.1211, -1.71253626067861),
(33719, '76533', 218, 51, 94820, 31.0786, 0.54242389691031, -97.3279, -1.69869230905179),
(33720, '76534', 218, 51, 9533, 30.879, 0.538940219723329, -97.4043, -1.70002574060031),
(33721, '76537', 218, 51, 22232, 30.8252, 0.538001232585756, -97.6104, -1.70362286418867),
(33722, '76538', 218, 51, 3452, 31.5976, 0.55148215572816, -97.7584, -1.70620595148162),
(33723, '76539', 218, 51, 95287, 31.0786, 0.54242389691031, -97.9999, -1.71042092162519),
(33724, '76540', 218, 51, 95310, 31.1238, 0.543212785732211, -97.7179, -1.70549909313457),
(33725, '76541', 218, 51, 95310, 31.1171, 0.543095848672328, -97.7245, -1.7056142848652),
(33726, '76542', 218, 51, 95310, 31.0811, 0.54246753014161, -97.7292, -1.70569631534004),
(33727, '76543', 218, 51, 95310, 31.1025, 0.542841030601536, -97.6826, -1.70488299190861),
(33728, '76544', 218, 51, 95310, 31.1285, 0.543294816207055, -97.7522, -1.706097741068),
(33729, '76545', 218, 51, 95310, 31.1175, 0.543102829989335, -97.7275, -1.70566664474276),
(33730, '76546', 218, 51, 95310, 31.117, 0.543094103343076, -97.7278, -1.70567188073051),
(33731, '76547', 218, 51, 95310, 31.119, 0.543129009928115, -97.7258, -1.70563697414547),
(33732, '76548', 218, 51, 94730, 31.073, 0.542326158472198, -97.6538, -1.70438033708404),
(33733, '76549', 218, 51, 95310, 31.1167, 0.54308886735532, -97.7273, -1.70566315408425),
(33734, '76550', 218, 51, 95565, 31.0634, 0.542158606864007, -98.1834, -1.7136236008026),
(33735, '76552', 218, 51, 95681, 31.3108, 0.546476551433441, -97.5712, -1.70293869512189),
(33736, '76554', 218, 51, 95748, 30.985, 0.540790268730443, -97.3635, -1.6993136462655),
(33737, '76555', 218, 51, 96077, 30.958, 0.540319029832405, -96.8665, -1.69063935988309),
(33738, '76556', 218, 51, 96213, 30.7394, 0.536503740087545, -96.7935, -1.68936526952913),
(33739, '76557', 218, 51, 4301, 31.3092, 0.546448626165409, -97.3571, -1.69920194519337),
(33740, '76558', 218, 51, 42190, 31.3103, 0.546467824787181, -97.5722, -1.70295614841441),
(33741, '76559', 218, 51, 96562, 31.0799, 0.542446586190586, -97.6026, -1.70348672850702),
(33742, '76561', 218, 51, 23610, 31.4523, 0.548946192325013, -97.5684, -1.70288982590284),
(33743, '76564', 218, 51, 11133, 31.1584, 0.543816669653401, -97.2577, -1.69746708791689),
(33744, '76565', 218, 51, 11354, 31.6886, 0.553070405347475, -98.3586, -1.71668141765209),
(33745, '76566', 218, 51, 97271, 31.4659, 0.549183557103284, -97.9061, -1.70878380278682),
(33746, '76567', 218, 51, 5473, 30.6549, 0.53502893686961, -97.0105, -1.69315263400596),
(33747, '76569', 218, 51, 874, 30.9284, 0.539802412373814, -97.2273, -1.69693650782428),
(33748, '76570', 218, 51, 5545, 31.0746, 0.54235408374023, -96.9736, -1.69250860751197),
(33749, '76571', 218, 51, 97739, 30.9458, 0.540106099663661, -97.5182, -1.70201367061833),
(33750, '76573', 218, 51, 97918, 30.7249, 0.536250667346006, -97.4328, -1.70052315943713),
(33751, '76574', 218, 51, 6252, 30.5759, 0.533650126760534, -97.4167, -1.70024216142756),
(33752, '76577', 218, 51, 6318, 30.6134, 0.534304625230032, -97.2031, -1.6965141381453),
(33753, '76578', 218, 51, 34129, 30.5881, 0.533863056929277, -97.2949, -1.69811635039863),
(33754, '76579', 218, 51, 199, 31.2024, 0.544584614524279, -97.3064, -1.69831706326261),
(33755, '76596', 218, 51, 29876, 31.4886, 0.549579746843487, -97.7383, -1.70585514030197),
(33756, '76597', 218, 51, 29876, 31.4345, 0.548635523718157, -97.7476, -1.70601745592241),
(33757, '76598', 218, 51, 29876, 31.4468, 0.548850199216153, -97.7435, -1.70594589742308),
(33758, '76599', 218, 51, 29876, 31.4737, 0.549319692784939, -97.737, -1.7058324510217),
(33759, '76621', 218, 51, 7015, 31.9042, 0.556833335214775, -97.0535, -1.69390312558432),
(33760, '76622', 218, 51, 53209, 31.8699, 0.556234687281341, -97.2073, -1.69658744197388),
(33761, '76623', 218, 51, 13310, 32.3106, 0.56392635329488, -96.7979, -1.68944206401622),
(33762, '76624', 218, 51, 31713, 31.6547, 0.552478738731049, -96.9789, -1.69260110996233),
(33763, '76626', 218, 51, 933, 32.095, 0.56016342342758, -96.719, -1.6880649992364),
(33764, '76627', 218, 51, 92716, 32.1057, 0.560350173657543, -97.3769, -1.69954752038527),
(33765, '76628', 218, 51, 7653, 32.0493, 0.559365807959419, -97.1045, -1.69479324350283),
(33766, '76629', 218, 51, 39485, 31.166, 0.543949314676553, -96.6765, -1.6873232343043),
(33767, '76630', 218, 51, 1199, 31.3306, 0.546822126625335, -97.2469, -1.69727859235767),
(33768, '76631', 218, 51, 1267, 31.9868, 0.558274977176922, -96.9686, -1.69242134104937),
(33769, '76632', 218, 51, 1552, 31.2984, 0.546260130606193, -97.1115, -1.69491541655047),
(33770, '76633', 218, 51, 0, 31.6423, 0.552262317903802, -97.2954, -1.69812507704489),
(33771, '76634', 218, 51, 15559, 31.7852, 0.554756393404902, -97.5786, -1.70306784948654),
(33772, '76635', 218, 51, 20230, 31.6345, 0.552126182222146, -96.5132, -1.68447311163579),
(33773, '76636', 218, 51, 15652, 32.1598, 0.561294396782872, -97.2488, -1.69731175361346),
(33774, '76637', 218, 51, 93526, 31.783, 0.554717996161358, -97.763, -1.70628623662722),
(33775, '76638', 218, 51, 1860, 31.6116, 0.55172650182344, -97.3199, -1.69855268271163),
(33776, '76639', 218, 51, 1989, 31.8829, 0.5564615800841, -96.7115, -1.6879340995425),
(33777, '76640', 218, 51, 94022, 31.6722, 0.552784171350148, -97.0977, -1.6946745611137),
(33778, '76641', 218, 51, 162, 32.0266, 0.558969618219216, -96.78, -1.68912965008011),
(33779, '76642', 218, 51, 72767, 31.5225, 0.550171413459913, -96.5311, -1.6847855255719),
(33780, '76643', 218, 51, 65527, 31.4585, 0.549054402738636, -97.1962, -1.69639371042691),
(33781, '76644', 218, 51, 95495, 31.8582, 0.556030483758858, -97.3796, -1.69959464427507),
(33782, '76645', 218, 51, 3145, 32.0075, 0.558636260332085, -97.1235, -1.69512485606071),
(33783, '76648', 218, 51, 3261, 31.8479, 0.555850714845902, -96.7964, -1.68941588407744),
(33784, '76649', 218, 51, 65873, 31.9755, 0.558077754971447, -97.872, -1.70818864551189),
(33785, '76650', 218, 51, 41492, 31.9908, 0.558344790347002, -96.8733, -1.69075804227222),
(33786, '76651', 218, 51, 81749, 32.1825, 0.561690586523075, -96.8867, -1.69099191639199),
(33787, '76652', 218, 51, 95358, 32.1197, 0.560594519752823, -97.5835, -1.70315337061989),
(33788, '76653', 218, 51, 95360, 31.3066, 0.546403247604857, -96.6338, -1.6865779787137),
(33789, '76654', 218, 51, 3734, 31.6544, 0.552473502743293, -96.9794, -1.69260983660859),
(33790, '76655', 218, 51, 33137, 31.4065, 0.548146831527599, -97.2287, -1.69696094243381),
(33791, '76656', 218, 51, 3872, 31.1912, 0.544389137648055, -97.071, -1.69420855820342),
(33792, '76657', 218, 51, 10403, 31.4409, 0.548747224790285, -97.3975, -1.69990705821118),
(33793, '76660', 218, 51, 3960, 31.9348, 0.557367405965885, -96.8842, -1.69094828316069),
(33794, '76661', 218, 51, 96012, 31.3084, 0.546434663531393, -96.8919, -1.69108267351309),
(33795, '76664', 218, 51, 96022, 31.5463, 0.550586801821887, -96.8387, -1.69015415835103),
(33796, '76665', 218, 51, 10448, 31.9254, 0.557203345016198, -97.6547, -1.70439604504731),
(33797, '76666', 218, 51, 96159, 32.0235, 0.558915513012404, -96.9005, -1.69123277182877),
(33798, '76667', 218, 51, 4178, 31.6814, 0.552944741641332, -96.4813, -1.68391635160441),
(33799, '76670', 218, 51, 10480, 32.1419, 0.560981982846765, -96.9605, -1.69227996937996),
(33800, '76671', 218, 51, 4319, 32.0415, 0.559229672277763, -97.6289, -1.70394575010029),
(33801, '76673', 218, 51, 96362, 31.7609, 0.554332278396667, -96.9122, -1.69143697535125),
(33802, '76675', 218, 51, 11013, 31.4327, 0.548604107791622, -96.8691, -1.69068473844364),
(33803, '76676', 218, 51, 67677, 31.8556, 0.555985105198306, -96.9429, -1.69197279143161),
(33804, '76677', 218, 51, 11148, 31.4335, 0.548618070425638, -96.8688, -1.69067950245588),
(33805, '76678', 218, 51, 57018, 31.6522, 0.552435105499749, -96.7854, -1.68922389785972),
(33806, '76679', 218, 51, 97269, 31.9455, 0.557554156195849, -96.5731, -1.68551856385774),
(33807, '76680', 218, 51, 77050, 31.2395, 0.545232131676769, -96.7531, -1.68866015651133),
(33808, '76681', 218, 51, 5374, 31.88, 0.556410965535792, -96.4487, -1.68334737426826),
(33809, '76682', 218, 51, 97511, 31.4756, 0.549352854040727, -96.9196, -1.6915661297159),
(33810, '76684', 218, 51, 11692, 31.6692, 0.552731811472588, -97.1013, -1.69473739296677),
(33811, '76685', 218, 51, 97893, 31.2986, 0.546263621264697, -97.111, -1.69490668990421),
(33812, '76686', 218, 51, 98448, 31.6879, 0.553058188042711, -96.5107, -1.68442947840449),
(33813, '76687', 218, 51, 351, 31.4032, 0.548089235662283, -96.4921, -1.68410484716362),
(33814, '76689', 218, 51, 31363, 31.6579, 0.552534589267113, -97.4737, -1.7012369991012),
(33815, '76690', 218, 51, 12635, 32.0719, 0.559760252370369, -97.7739, -1.70647647751568),
(33816, '76691', 218, 51, 6702, 31.8016, 0.555042627402229, -97.0932, -1.69459602129736),
(33817, '76692', 218, 51, 6800, 31.9501, 0.55763444134144, -97.3199, -1.69855268271163),
(33818, '76693', 218, 51, 58367, 31.7869, 0.554786064002186, -96.4635, -1.68360568299755),
(33819, '76701', 218, 51, 6587, 31.5517, 0.550681049601495, -97.1395, -1.69540410874103),
(33820, '76702', 218, 51, 6587, 31.5473, 0.550604255114407, -97.1446, -1.69549312053288),
(33821, '76703', 218, 51, 6587, 31.5552, 0.550742136125315, -97.1285, -1.69521212252331),
(33822, '76704', 218, 51, 6587, 31.5717, 0.551030115451894, -97.1222, -1.69510216678044),
(33823, '76705', 218, 51, 6587, 31.6032, 0.551579894166272, -97.0974, -1.69466932512594),
(33824, '76706', 218, 51, 6587, 31.5197, 0.550122544240857, -97.1227, -1.6951108934267),
(33825, '76707', 218, 51, 6587, 31.5527, 0.550698502894015, -97.1594, -1.69575142926218),
(33826, '76708', 218, 51, 6587, 31.5729, 0.551051059402918, -97.1755, -1.69603242727175),
(33827, '76710', 218, 51, 6587, 31.5254, 0.55022202800822, -97.2015, -1.69648621287727),
(33828, '76711', 218, 51, 6587, 31.5126, 0.549998625863965, -97.1621, -1.69579855315198),
(33829, '76712', 218, 51, 99209, 31.4882, 0.549572765526478, -97.2265, -1.69692254519027),
(33830, '76714', 218, 51, 6587, 31.5281, 0.550269151898024, -97.1913, -1.69630818929356),
(33831, '76715', 218, 51, 6587, 31.6035, 0.551585130154028, -97.0809, -1.69438134579936),
(33832, '76716', 218, 51, 6587, 31.4554, 0.549000297531824, -97.096, -1.69464489051641),
(33833, '76795', 218, 51, 6587, 31.5694, 0.550989972879098, -97.183, -1.69616332696565),
(33834, '76797', 218, 51, 6587, 31.5321, 0.550338965068104, -97.1894, -1.69627502803778),
(33835, '76798', 218, 51, 6587, 31.4548, 0.548989825556312, -97.0977, -1.6946745611137),
(33836, '76799', 218, 51, 6587, 31.5313, 0.550325002434088, -97.1919, -1.69631866126908),
(33837, '76801', 218, 51, 19595, 31.7099, 0.55344216047815, -98.9776, -1.72748500572194),
(33838, '76802', 218, 51, 15851, 31.7512, 0.554162981459224, -98.9252, -1.72657045319389),
(33839, '76803', 218, 51, 19595, 31.7206, 0.553628910708113, -98.9755, -1.72744835380765),
(33840, '76804', 218, 51, 19595, 31.607, 0.551646216677848, -99.0198, -1.72822153466628),
(33841, '76820', 218, 51, 29116, 30.7759, 0.537140785264523, -99.0666, -1.72903834875621),
(33842, '76821', 218, 51, 92417, 31.7427, 0.554014628472804, -99.9545, -1.74453512718467),
(33843, '76823', 218, 51, 92425, 31.715, 0.553531172270002, -99.1291, -1.73012917953871),
(33844, '76824', 218, 51, 7406, 31.0824, 0.542490219421885, -98.5015, -1.71917549315319),
(33845, '76825', 218, 51, 34957, 31.1319, 0.543354157401623, -99.3368, -1.7337542283951),
(33846, '76827', 218, 51, 92834, 31.5176, 0.550085892326565, -99.1406, -1.73032989240269),
(33847, '76828', 218, 51, 31920, 32.0092, 0.558665930929369, -99.3088, -1.73326553620454),
(33848, '76831', 218, 51, 93100, 30.6923, 0.535681690009856, -98.9214, -1.72650413068232),
(33849, '76832', 218, 51, 5, 30.9785, 0.540676822329063, -98.7116, -1.72284242991163),
(33850, '76834', 218, 51, 1693, 31.8293, 0.555526083605031, -99.4254, -1.73530059011237),
(33851, '76836', 218, 51, 93787, 31.4142, 0.548281221880003, -99.5518, -1.73750668628689),
(33852, '76837', 218, 51, 2217, 31.2164, 0.544828960619558, -99.8359, -1.74246516669181),
(33853, '76841', 218, 51, 191489, 30.9315, 0.539856517580626, -99.8269, -1.74230808705913),
(33854, '76842', 218, 51, 2600, 30.9175, 0.539612171485347, -99.1408, -1.73033338306119),
(33855, '76844', 218, 51, 94516, 31.4529, 0.548956664300524, -98.5728, -1.72041991290987),
(33856, '76845', 218, 51, 94555, 31.5162, 0.550061457717037, -99.5309, -1.73714191247322),
(33857, '76848', 218, 51, 76076, 30.8836, 0.539020504868921, -99.5443, -1.73737578659299),
(33858, '76849', 218, 51, 27584, 30.489, 0.532133435640551, -99.7723, -1.74135513728754),
(33859, '76852', 218, 51, 95774, 31.3405, 0.546994914221283, -99.3833, -1.73456580649728),
(33860, '76853', 218, 51, 95795, 31.2111, 0.544736458169202, -98.4004, -1.71741096527943),
(33861, '76854', 218, 51, 3852, 30.6246, 0.534500102106255, -99.6567, -1.73933753667223),
(33862, '76855', 218, 51, 191806, 31.45, 0.548906049752217, -100.0607, -1.74638866685029),
(33863, '76856', 218, 51, 17048, 30.7455, 0.536610205171917, -99.2348, -1.73197399255807),
(33864, '76857', 218, 51, 37104, 31.9757, 0.558081245629951, -98.9984, -1.72784803420635),
(33865, '76858', 218, 51, 4160, 31.1409, 0.543511237034302, -99.5219, -1.73698483284054),
(33866, '76859', 218, 51, 27873, 30.9116, 0.539509197059479, -99.7859, -1.74159250206581),
(33867, '76861', 218, 51, 42092, 31.5962, 0.551457721118632, -100.1862, -1.74857905506154),
(33868, '76862', 218, 51, 96225, 31.4476, 0.548864161850169, -99.7081, -1.74023463590776),
(33869, '76864', 218, 51, 96402, 31.5711, 0.551019643476382, -98.7034, -1.72269931291297),
(33870, '76865', 218, 51, 4646, 31.887, 0.556533138583432, -100.1347, -1.74768021049677),
(33871, '76866', 218, 51, 4837, 31.5026, 0.549824092938766, -99.8936, -1.74347222167021),
(33872, '76867', 218, 51, 96958, 31.2934, 0.546172864143593, -99.5042, -1.73667590956294),
(33873, '76869', 218, 51, 61389, 30.8769, 0.538903567809037, -99.0224, -1.72826691322683),
(33874, '76870', 218, 51, 97236, 31.6953, 0.553187342407359, -98.5021, -1.71918596512871),
(33875, '76871', 218, 51, 97496, 31.3041, 0.546359614373557, -98.819, -1.72471691352828),
(33876, '76872', 218, 51, 17824, 31.3302, 0.546815145308327, -99.1426, -1.73036479898773),
(33877, '76873', 218, 51, 5481, 31.4874, 0.549558802892463, -99.3743, -1.7344087268646),
(33878, '76874', 218, 51, 5534, 30.545, 0.533110820021668, -99.9604, -1.74463810161054),
(33879, '76875', 218, 51, 24549, 31.6366, 0.552162834136438, -99.9667, -1.74474805735342),
(33880, '76877', 218, 51, 97815, 31.1956, 0.544465932135143, -98.7269, -1.72310946528719),
(33881, '76878', 218, 51, 97850, 31.7427, 0.554014628472804, -99.3276, -1.73359365810392),
(33882, '76880', 218, 51, 6054, 31.4776, 0.549387760625767, -98.4168, -1.71769719927676),
(33883, '76882', 218, 51, 98420, 31.7788, 0.554644692332774, -99.6632, -1.73945098307361),
(33884, '76883', 218, 51, 98449, 30.3373, 0.529485771165276, -99.9806, -1.74499065811944),
(33885, '76884', 218, 51, 98726, 31.7724, 0.554532991260646, -99.5433, -1.73735833330047),
(33886, '76885', 218, 51, 98748, 30.8389, 0.538240342693279, -98.8419, -1.72511659392698),
(33887, '76886', 218, 51, 25710, 31.3496, 0.547153739183214, -100.4959, -1.75398433975497),
(33888, '76887', 218, 51, 98853, 30.9853, 0.540795504718199, -99.1465, -1.73043286682856),
(33889, '76888', 218, 51, 98856, 31.6348, 0.552131418209902, -99.588, -1.73813849547611),
(33890, '76890', 218, 51, 70442, 31.6542, 0.552470012084789, -98.8314, -1.72493333435552),
(33891, '76901', 218, 51, 192158, 31.4651, 0.549169594469268, -100.4914, -1.75390579993863),
(33892, '76902', 218, 51, 192158, 31.4541, 0.548977608251548, -100.4242, -1.75273293868129),
(33893, '76903', 218, 51, 192158, 31.4702, 0.549258606261119, -100.4379, -1.75297204878881),
(33894, '76904', 218, 51, 192158, 31.4176, 0.54834056307457, -100.4772, -1.75365796318485),
(33895, '76905', 218, 51, 192158, 31.4664, 0.549192283749544, -100.3948, -1.7522198118812),
(33896, '76906', 218, 51, 192158, 31.4633, 0.549138178542732, -100.4365, -1.75294761417928),
(33897, '76908', 218, 51, 0, 31.385, 0.54777158573842, -100.561, -1.75512054909802),
(33898, '76909', 218, 51, 192158, 31.4462, 0.548839727240641, -100.4528, -1.75323210284736),
(33899, '76930', 218, 51, 53338, 31.1875, 0.544324560465732, -101.1901, -1.76610041542231),
(33900, '76932', 218, 51, 7472, 31.2133, 0.544774855412746, -101.4667, -1.77092799613333),
(33901, '76933', 218, 51, 191179, 31.8864, 0.55652266660792, -100.2936, -1.75045353867818),
(33902, '76934', 218, 51, 180533, 31.5917, 0.551379181302293, -100.7109, -1.75773679764676),
(33903, '76935', 218, 51, 191262, 31.2006, 0.544553198597743, -100.5374, -1.75470865139455),
(33904, '76936', 218, 51, 15909, 30.8615, 0.53863478710423, -100.5944, -1.75570348906818),
(33905, '76937', 218, 51, 40825, 31.4499, 0.548904304422965, -100.0602, -1.74637994020403),
(33906, '76939', 218, 51, 163409, 31.2661, 0.545696389257799, -100.6223, -1.75619043592949),
(33907, '76940', 218, 51, 191863, 31.491, 0.549621634745534, -100.1839, -1.74853891248875),
(33908, '76941', 218, 51, 191866, 31.2639, 0.545657992014255, -100.818, -1.75960604527564),
(33909, '76943', 218, 51, 17470, 30.711, 0.536008066579979, -101.2121, -1.76648438785775),
(33910, '76945', 218, 51, 192119, 31.8959, 0.556688472886859, -100.4851, -1.75379584419575),
(33911, '76949', 218, 51, 11947, 32.0433, 0.559261088204299, -100.6784, -1.75716956563986),
(33912, '76950', 218, 51, 12023, 30.5669, 0.533493047127855, -100.6433, -1.75655695507241),
(33913, '76951', 218, 51, 114126, 31.8367, 0.555655237969679, -100.9822, -1.76247187590742),
(33914, '76953', 218, 51, 31300, 31.74, 0.553967504583, -100.2886, -1.75036627221559),
(33915, '76955', 218, 51, 192367, 31.2234, 0.544951133667198, -100.2071, -1.74894382887521),
(33916, '76957', 218, 51, 168429, 31.3143, 0.54653763795726, -100.3379, -1.75122671953682),
(33917, '76958', 218, 51, 6647, 31.6671, 0.552695159558296, -100.7162, -1.75782930009711),
(33918, '77001', 218, 51, 3246, 29.7194, 0.518701381717203, -95.2227, -1.6619496376388),
(33919, '77002', 218, 51, 3246, 29.7612, 0.519430929344536, -95.3629, -1.6643965892501),
(33920, '77003', 218, 51, 3246, 29.7488, 0.519214508517289, -95.347, -1.66411908189903),
(33921, '77004', 218, 51, 3246, 29.7291, 0.518870678654646, -95.3642, -1.66441927853038),
(33922, '77005', 218, 51, 3246, 29.717, 0.518659493815155, -95.4234, -1.66545251344756),
(33923, '77006', 218, 51, 3246, 29.7422, 0.519099316786657, -95.3912, -1.66489051742841),
(33924, '77007', 218, 51, 3246, 29.7727, 0.519631642208516, -95.4031, -1.6650982116094),
(33925, '77008', 218, 51, 3246, 29.7993, 0.520095899789546, -95.4197, -1.66538793626523),
(33926, '77009', 218, 51, 3246, 29.7943, 0.520008633326947, -95.3687, -1.66449781834672),
(33927, '77010', 218, 51, 3246, 29.7539, 0.519303520309141, -95.3596, -1.66433899338478),
(33928, '77011', 218, 51, 3246, 29.7423, 0.519101062115909, -95.3081, -1.66344014882001),
(33929, '77012', 218, 51, 3246, 29.7174, 0.518666475132163, -95.2, -1.6615534478986),
(33930, '77013', 218, 51, 3246, 29.7941, 0.520005142668443, -95.2388, -1.66223063564838),
(33931, '77014', 218, 51, 3246, 29.982, 0.52328461633294, -95.4675, -1.66622220364769),
(33932, '77015', 218, 51, 3246, 29.7678, 0.519546121075168, -95.1702, -1.66103333978151),
(33933, '77016', 218, 51, 3246, 29.8578, 0.521116917401963, -95.3036, -1.66336160900367),
(33934, '77017', 218, 51, 3246, 29.6852, 0.518104479113021, -95.255, -1.6625133789872),
(33935, '77018', 218, 51, 3246, 29.8282, 0.520600299943373, -95.4254, -1.6654874200326),
(33936, '77019', 218, 51, 3246, 29.7528, 0.519284321687369, -95.413, -1.66527099920535),
(33937, '77020', 218, 51, 3246, 29.7729, 0.51963513286702, -95.3118, -1.66350472600233),
(33938, '77021', 218, 51, 3246, 29.6965, 0.518301701318496, -95.3572, -1.66429710548274),
(33939, '77022', 218, 51, 3246, 29.8279, 0.520595063955617, -95.3776, -1.66465315265014),
(33940, '77023', 218, 51, 3246, 29.7239, 0.518779921533543, -95.32, -1.66364784300099),
(33941, '77024', 218, 51, 3246, 29.7697, 0.519579282330956, -95.5171, -1.66708788695668),
(33942, '77025', 218, 51, 3246, 29.6882, 0.518156838990581, -95.4334, -1.66562704637276),
(33943, '77026', 218, 51, 3246, 29.7946, 0.520013869314703, -95.331, -1.66383982921871),
(33944, '77027', 218, 51, 3246, 29.7392, 0.519046956909098, -95.4446, -1.66582252324898),
(33945, '77028', 218, 51, 3246, 29.8258, 0.520558412041325, -95.2868, -1.66306839368933),
(33946, '77029', 218, 51, 3246, 29.7604, 0.519416966710521, -95.2609, -1.66261635341307),
(33947, '77030', 218, 51, 3246, 29.7067, 0.5184797249022, -95.3991, -1.66502839843932),
(33948, '77031', 218, 51, 3246, 29.6577, 0.517624513568722, -95.5441, -1.66755912585471),
(33949, '77032', 218, 51, 3246, 29.9414, 0.52257601265663, -95.3443, -1.66407195800923),
(33950, '77033', 218, 51, 3246, 29.6658, 0.517765885238134, -95.3401, -1.66399865418065),
(33951, '77034', 218, 51, 3246, 29.6149, 0.516877512648869, -95.2003, -1.66155868388636),
(33952, '77035', 218, 51, 3246, 29.6513, 0.517512812496595, -95.4818, -1.66647178573072),
(33953, '77036', 218, 51, 3246, 29.7011, 0.518381986464088, -95.5393, -1.66747535005062),
(33954, '77037', 218, 51, 3246, 29.8899, 0.521677168091853, -95.3916, -1.66489749874542),
(33955, '77038', 218, 51, 3246, 29.9173, 0.5221553883069, -95.4404, -1.6657492194204),
(33956, '77039', 218, 51, 3246, 29.9097, 0.522022743283748, -95.3367, -1.66393931298608),
(33957, '77040', 218, 51, 3246, 29.8824, 0.521546268397954, -95.5405, -1.66749629400164),
(33958, '77041', 218, 51, 3246, 29.8571, 0.521104700097199, -95.5742, -1.66808446995956),
(33959, '77042', 218, 51, 3246, 29.745, 0.519148186005713, -95.56, -1.66783663320578),
(33960, '77043', 218, 51, 3246, 29.8071, 0.520232035471202, -95.5623, -1.66787677577858),
(33961, '77044', 218, 51, 3246, 29.896, 0.521783633176225, -95.1824, -1.66124626995025),
(33962, '77045', 218, 51, 3246, 29.6339, 0.517209125206748, -95.4266, -1.66550836398362),
(33963, '77046', 218, 51, 3246, 29.7302, 0.518889877276418, -95.434, -1.66563751834827),
(33964, '77047', 218, 51, 3246, 29.6047, 0.516699489065165, -95.3879, -1.6648329215631),
(33965, '77048', 218, 51, 3246, 29.6196, 0.516959543123712, -95.3335, -1.66388346245001),
(33966, '77049', 218, 51, 3246, 29.8353, 0.520724218320264, -95.149, -1.66066332998008),
(33967, '77050', 218, 51, 3246, 29.8996, 0.521846465029297, -95.27, -1.662775178375),
(33968, '77051', 218, 51, 3246, 29.6525, 0.517533756447619, -95.3781, -1.6646618792964),
(33969, '77052', 218, 51, 3246, 29.7579, 0.519373333479221, -95.361, -1.66436342799431),
(33970, '77053', 218, 51, 3246, 29.5967, 0.516559862725006, -95.4546, -1.66599705617418),
(33971, '77054', 218, 51, 3246, 29.6848, 0.518097497796013, -95.3991, -1.66502839843932),
(33972, '77055', 218, 51, 3246, 29.7961, 0.520040049253482, -95.4973, -1.66674231176478),
(33973, '77056', 218, 51, 3246, 29.7486, 0.519211017858785, -95.4677, -1.66622569430619),
(33974, '77057', 218, 51, 3246, 29.7459, 0.519163893968981, -95.49, -1.66661490272939),
(33975, '77058', 218, 51, 3246, 29.555, 0.515832060426924, -95.0981, -1.65977495739082),
(33976, '77059', 218, 51, 3246, 29.6065, 0.516730904991701, -95.1132, -1.66003850210787),
(33977, '77060', 218, 51, 3246, 29.9292, 0.522363082487887, -95.3961, -1.66497603856176),
(33978, '77061', 218, 51, 3246, 29.6559, 0.517593097642186, -95.2836, -1.66301254315327),
(33979, '77062', 218, 51, 3246, 29.5757, 0.516193343582087, -95.1403, -1.66051148633516),
(33980, '77063', 218, 51, 3246, 29.7346, 0.518966671763506, -95.5208, -1.667152464139),
(33981, '77064', 218, 51, 3246, 29.9197, 0.522197276208947, -95.5539, -1.66773016812141),
(33982, '77065', 218, 51, 3246, 29.9314, 0.522401479731431, -95.6055, -1.66863075801544),
(33983, '77066', 218, 51, 3246, 29.9582, 0.522869227970965, -95.4995, -1.66678070900832),
(33984, '77067', 218, 51, 3246, 29.9541, 0.522797669471633, -95.4559, -1.66601974545446),
(33985, '77068', 218, 51, 3246, 30.0048, 0.523682551402395, -95.4885, -1.66658872279061),
(33986, '77069', 218, 51, 3246, 29.9859, 0.523352684173768, -95.5234, -1.66719784269955),
(33987, '77070', 218, 51, 3246, 29.9732, 0.523131027358764, -95.5769, -1.66813159384937),
(33988, '77071', 218, 51, 3246, 29.6474, 0.517444744655767, -95.5251, -1.66722751329684),
(33989, '77072', 218, 51, 3246, 29.6987, 0.51834009856204, -95.5869, -1.66830612677457),
(33990, '77073', 218, 51, 3246, 30.0027, 0.523645899488103, -95.3997, -1.66503887041483),
(33991, '77074', 218, 51, 3246, 29.6799, 0.518011976662665, -95.5166, -1.66707916031042),
(33992, '77075', 218, 51, 3246, 29.6207, 0.516978741745484, -95.2686, -1.66275074376547),
(33993, '77076', 218, 51, 3246, 29.8598, 0.521151823987003, -95.3843, -1.66477008971003),
(33994, '77077', 218, 51, 3246, 29.7508, 0.519249415102329, -95.6115, -1.66873547777056),
(33995, '77078', 218, 51, 3246, 29.8571, 0.521104700097199, -95.257, -1.66254828557224),
(33996, '77079', 218, 51, 3246, 29.78, 0.519759051243911, -95.6054, -1.66862901268619),
(33997, '77080', 218, 51, 3246, 29.8168, 0.520401332408645, -95.5214, -1.66716293611451),
(33998, '77081', 218, 51, 3246, 29.7121, 0.518573972681807, -95.4814, -1.66646480441371),
(33999, '77082', 218, 51, 3246, 29.7213, 0.518734542972991, -95.6314, -1.66908279829171),
(34000, '77083', 218, 51, 3246, 29.6928, 0.518237124136172, -95.6514, -1.6694318641421),
(34001, '77084', 218, 51, 3246, 29.8246, 0.520537468090301, -95.6416, -1.66926082187541),
(34002, '77085', 218, 51, 3246, 29.6221, 0.517003176355012, -95.4925, -1.66665853596069),
(34003, '77086', 218, 51, 3246, 29.9193, 0.522190294891939, -95.4917, -1.66664457332667),
(34004, '77087', 218, 51, 3246, 29.6824, 0.518055609893965, -95.3037, -1.66336335433292),
(34005, '77088', 218, 51, 3246, 29.8773, 0.521457256606102, -95.4559, -1.66601974545446),
(34006, '77089', 218, 51, 3246, 29.5865, 0.516381839141302, -95.2199, -1.66190076841975),
(34007, '77090', 218, 51, 3246, 30.01, 0.523773308523498, -95.4472, -1.66586790180953),
(34008, '77091', 218, 51, 3246, 29.8536, 0.521043613573379, -95.4394, -1.66573176612788),
(34009, '77092', 218, 51, 3246, 29.8314, 0.520656150479436, -95.4745, -1.66634437669533),
(34010, '77093', 218, 51, 3246, 29.8632, 0.521211165181571, -95.3418, -1.66402832477793),
(34011, '77094', 218, 51, 3246, 29.7547, 0.519317482943157, -95.6794, -1.66992055633266),
(34012, '77095', 218, 51, 3246, 29.9102, 0.522031469930008, -95.6536, -1.66947026138565),
(34013, '77096', 218, 51, 3246, 29.6711, 0.517858387688489, -95.4772, -1.66639150058513),
(34014, '77097', 218, 51, 3246, 29.7649, 0.51949550652686, -95.3616, -1.66437389996982),
(34015, '77098', 218, 51, 3246, 29.7352, 0.518977143739018, -95.4164, -1.66533034039992),
(34016, '77099', 218, 51, 3246, 29.6704, 0.517846170383726, -95.5866, -1.66830089078681),
(34017, '77201', 218, 51, 3246, 29.7644, 0.5194867798806, -95.3653, -1.66443847715215),
(34018, '77202', 218, 51, 3246, 29.758, 0.519375078808473, -95.366, -1.66445069445691),
(34019, '77203', 218, 51, 3246, 29.7583, 0.519380314796229, -95.3661, -1.66445243978616),
(34020, '77204', 218, 51, 3246, 29.7687, 0.519561829038436, -95.3867, -1.66481197761208),
(34021, '77205', 218, 51, 3246, 29.9584, 0.522872718629469, -95.338, -1.66396200226635),
(34022, '77206', 218, 51, 3246, 29.8271, 0.520581101321601, -95.4268, -1.66551185464212),
(34023, '77207', 218, 51, 3246, 29.687, 0.518135895039557, -95.3035, -1.66335986367442),
(34024, '77208', 218, 51, 3246, 29.757, 0.519357625515953, -95.3655, -1.66444196781065),
(34025, '77209', 218, 51, 3246, 29.6207, 0.516978741745484, -95.1889, -1.66135971635163),
(34026, '77210', 218, 51, 3246, 29.7578, 0.519371588149969, -95.3657, -1.66444545846916),
(34027, '77212', 218, 51, 3246, 29.7654, 0.51950423317312, -95.3643, -1.66442102385963),
(34028, '77213', 218, 51, 3246, 29.7951, 0.520022595960963, -95.2385, -1.66222539966062),
(34029, '77215', 218, 51, 3246, 29.7358, 0.51898761571453, -95.5205, -1.66714722815124),
(34030, '77216', 218, 51, 3246, 29.617, 0.516914164563161, -95.2151, -1.66181699261565),
(34031, '77217', 218, 51, 3246, 29.7015, 0.518388967781096, -95.263, -1.66265300532736),
(34032, '77218', 218, 51, 3246, 29.8258, 0.520558412041325, -95.6502, -1.66941092019108),
(34033, '77219', 218, 51, 3246, 29.7539, 0.519303520309141, -95.4121, -1.66525529124208),
(34034, '77220', 218, 51, 3246, 29.7725, 0.519628151550012, -95.3121, -1.66350996199009),
(34035, '77221', 218, 51, 3246, 29.704, 0.518432601012396, -95.355, -1.66425870823919),
(34036, '77222', 218, 51, 3246, 29.8292, 0.520617753235893, -95.3736, -1.66458333948006),
(34037, '77223', 218, 51, 3246, 29.7269, 0.518832281411102, -95.3209, -1.66366355096426),
(34038, '77224', 218, 51, 3246, 29.7711, 0.519603716940484, -95.5162, -1.66707217899341),
(34039, '77225', 218, 51, 3246, 29.6926, 0.518233633477668, -95.4169, -1.66533906704618),
(34040, '77226', 218, 51, 3246, 29.8006, 0.520118589069822, -95.3297, -1.66381713993844),
(34041, '77227', 218, 51, 3246, 29.7382, 0.519029503616578, -95.4477, -1.66587662845579),
(34042, '77228', 218, 51, 3246, 29.875, 0.521417114033306, -95.2628, -1.66264951466885),
(34043, '77229', 218, 51, 3246, 29.7632, 0.519465835929576, -95.2673, -1.66272805448519),
(34044, '77230', 218, 51, 3246, 29.6958, 0.518289484013732, -95.3869, -1.66481546827058),
(34045, '77231', 218, 51, 3246, 29.6534, 0.517549464410887, -95.4782, -1.66640895387765),
(34046, '77233', 218, 51, 3246, 29.655, 0.517577389678918, -95.3553, -1.66426394422695),
(34047, '77234', 218, 51, 3246, 29.6201, 0.516968269769972, -95.1899, -1.66137716964415),
(34048, '77235', 218, 51, 3246, 29.6528, 0.517538992435374, -95.4784, -1.66641244453615),
(34049, '77236', 218, 51, 3246, 29.7068, 0.518481470231452, -95.4964, -1.66672660380151),
(34050, '77237', 218, 51, 3246, 29.734, 0.518956199787994, -95.4988, -1.66676849170356),
(34051, '77238', 218, 51, 3246, 29.9218, 0.522233928123239, -95.4436, -1.66580506995646),
(34052, '77240', 218, 51, 3246, 29.8745, 0.521408387387046, -95.5264, -1.66725020257711),
(34053, '77241', 218, 51, 3246, 29.8571, 0.521104700097199, -95.5372, -1.66743869813633),
(34054, '77242', 218, 51, 3246, 29.7315, 0.518912566556694, -95.5591, -1.66782092524251),
(34055, '77243', 218, 51, 3246, 29.796, 0.52003830392423, -95.4903, -1.66662013871714),
(34056, '77244', 218, 51, 3246, 29.7757, 0.519684002086076, -95.6019, -1.66856792616237),
(34057, '77245', 218, 51, 3246, 29.6406, 0.517326062266631, -95.4345, -1.66564624499453),
(34058, '77248', 218, 51, 3246, 29.799, 0.52009066380179, -95.4172, -1.66534430303393),
(34059, '77249', 218, 51, 3246, 29.8033, 0.520165712959626, -95.3724, -1.66456239552904),
(34060, '77251', 218, 51, 3246, 29.7012, 0.51838373179334, -95.5376, -1.66744567945333),
(34061, '77252', 218, 51, 3246, 29.7571, 0.519359370845205, -95.3661, -1.66445243978616),
(34062, '77253', 218, 51, 3246, 29.7573, 0.519362861503709, -95.3661, -1.66445243978616),
(34063, '77254', 218, 51, 3246, 29.7328, 0.51893525583697, -95.4129, -1.6652692538761),
(34064, '77255', 218, 51, 3246, 29.8014, 0.520132551703838, -95.4931, -1.6666690079362),
(34065, '77256', 218, 51, 3246, 29.7388, 0.51903997559209, -95.436, -1.66567242493331),
(34066, '77257', 218, 51, 3246, 29.7462, 0.519169129956737, -95.4887, -1.66659221344911),
(34067, '77258', 218, 51, 3246, 29.571, 0.516111313107243, -95.0774, -1.65941367423566),
(34068, '77259', 218, 51, 3246, 29.5763, 0.516203815557599, -95.1403, -1.66051148633516),
(34069, '77261', 218, 51, 3246, 29.6744, 0.517915983553805, -95.2478, -1.66238771528105),
(34070, '77262', 218, 51, 3246, 29.7237, 0.518776430875039, -95.2784, -1.66292178603217),
(34071, '77263', 218, 51, 3246, 29.7301, 0.518888131947166, -95.5174, -1.66709312294443),
(34072, '77265', 218, 51, 3246, 29.7188, 0.518690909741691, -95.4282, -1.66553628925165),
(34073, '77266', 218, 51, 3246, 29.7469, 0.519181347261501, -95.3935, -1.66493066000121),
(34074, '77267', 218, 51, 3246, 29.9549, 0.522811632105649, -95.4417, -1.66577190870067),
(34075, '77268', 218, 51, 3246, 30.0072, 0.523724439304442, -95.4883, -1.6665852321321),
(34076, '77269', 218, 51, 3246, 29.9791, 0.523234001784632, -95.5698, -1.66800767547248),
(34077, '77270', 218, 51, 3246, 29.7989, 0.520088918472538, -95.4179, -1.6653565203387),
(34078, '77271', 218, 51, 3246, 29.6617, 0.517694326738802, -95.5282, -1.66728161850365),
(34079, '77272', 218, 51, 3246, 29.7001, 0.518364533171568, -95.585, -1.66827296551878),
(34080, '77273', 218, 51, 3246, 30.0002, 0.523602266256803, -95.3984, -1.66501618113456),
(34081, '77274', 218, 51, 3246, 29.6887, 0.518165565636841, -95.5157, -1.66706345234715),
(34082, '77275', 218, 51, 3246, 29.7565, 0.519348898869693, -95.3659, -1.66444894912766),
(34083, '77277', 218, 51, 3246, 29.7187, 0.518689164412439, -95.4283, -1.6655380345809),
(34084, '77279', 218, 51, 3246, 29.7705, 0.519593244964972, -95.5115, -1.66699014851856),
(34085, '77280', 218, 51, 3246, 29.8618, 0.521186730572043, -95.5835, -1.66824678558),
(34086, '77281', 218, 51, 3246, 29.7007, 0.51837500514708, -95.5374, -1.66744218879483),
(34087, '77282', 218, 51, 3246, 29.7455, 0.519156912651973, -95.6099, -1.66870755250253),
(34088, '77284', 218, 51, 3246, 29.7569, 0.519355880186701, -95.3658, -1.66444720379841),
(34089, '77287', 218, 51, 3246, 29.6765, 0.517952635468097, -95.2474, -1.66238073396405),
(34090, '77288', 218, 51, 3246, 29.7254, 0.518806101472322, -95.3622, -1.66438437194534),
(34091, '77289', 218, 51, 3246, 29.6083, 0.516762320918237, -95.1274, -1.66028633886165),
(34092, '77290', 218, 51, 3246, 29.9822, 0.523288106991444, -95.4634, -1.66615064514835),
(34093, '77291', 218, 51, 3246, 29.8695, 0.521321120924446, -95.4125, -1.66526227255909),
(34094, '77292', 218, 51, 3246, 29.8275, 0.520588082638609, -95.4271, -1.66551709062988),
(34095, '77293', 218, 51, 3246, 29.8625, 0.521198947876807, -95.3406, -1.66400738082691),
(34096, '77297', 218, 51, 3246, 29.7634, 0.51946932658808, -95.363, -1.66439833457935),
(34097, '77298', 218, 51, 3246, 29.7577, 0.519369842820717, -95.3609, -1.66436168266506),
(34098, '77299', 218, 51, 3246, 29.7727, 0.519631642208516, -95.415, -1.66530590579039),
(34099, '77301', 218, 51, 93417, 30.3088, 0.528988352328457, -95.4316, -1.66559563044622),
(34100, '77302', 218, 51, 93417, 30.2466, 0.527902757533717, -95.4058, -1.66514533549921),
(34101, '77303', 218, 51, 93417, 30.3701, 0.53005823915993, -95.3671, -1.66446989307868),
(34102, '77304', 218, 51, 93417, 30.3334, 0.529417703324448, -95.5196, -1.66713152018798),
(34103, '77305', 218, 51, 93417, 30.3244, 0.529260623691769, -95.461, -1.66610875724631),
(34104, '77306', 218, 51, 93417, 30.2836, 0.528548529356955, -95.3157, -1.66357279384316),
(34105, '77315', 218, 51, 96598, 29.9282, 0.522345629195367, -95.3172, -1.66359897378194),
(34106, '77316', 218, 51, 4289, 30.3231, 0.529237934411493, -95.6866, -1.67004622003881),
(34107, '77318', 218, 51, 12872, 30.4491, 0.531437049269005, -95.5351, -1.66740204622203),
(34108, '77320', 218, 51, 3297, 30.8181, 0.537877314208865, -95.5792, -1.66817173642216),
(34109, '77325', 218, 51, 36524, 30.0799, 0.524993293670642, -95.3451, -1.66408592064325),
(34110, '77326', 218, 51, 92100, 30.5215, 0.532700667647449, -94.8119, -1.65477982507161),
(34111, '77327', 218, 51, 1620, 30.3455, 0.529628888163939, -95.0835, -1.65952013932003),
(34112, '77328', 218, 51, 1620, 30.3408, 0.529546857689096, -95.0857, -1.65955853656357),
(34113, '77331', 218, 51, 54138, 30.6215, 0.534445996899444, -95.1794, -1.66119391007269),
(34114, '77332', 218, 51, 93619, 30.6283, 0.534564679288579, -94.6311, -1.65162426978401),
(34115, '77333', 218, 51, 93765, 30.3657, 0.529981444672842, -95.7758, -1.67160305373159),
(34116, '77334', 218, 51, 75669, 30.7456, 0.536611950501169, -95.3981, -1.6650109451468),
(34117, '77335', 218, 51, 9157, 30.5515, 0.533224266423048, -94.8782, -1.65593697836568),
(34118, '77336', 218, 51, 3271, 30.045, 0.524384173761696, -95.1034, -1.65986745984118),
(34119, '77337', 218, 51, 95038, 30.1218, 0.525724586627228, -95.5941, -1.66843179048071),
(34120, '77338', 218, 51, 36524, 30.0038, 0.523665098109875, -95.2783, -1.66292004070291),
(34121, '77339', 218, 51, 36524, 30.0545, 0.524549980040636, -95.2103, -1.66173321681156),
(34122, '77340', 218, 51, 3297, 30.7266, 0.53628033794329, -95.5479, -1.66762544836629),
(34123, '77341', 218, 51, 3297, 30.716, 0.536095333042578, -95.5466, -1.66760275908601),
(34124, '77342', 218, 51, 3297, 30.7232, 0.536220996748722, -95.5307, -1.66732525173495),
(34125, '77343', 218, 51, 3297, 30.7238, 0.536231468724234, -95.55, -1.66766210028058),
(34126, '77344', 218, 51, 3297, 30.7238, 0.536231468724234, -95.5504, -1.66766908159759),
(34127, '77345', 218, 51, 36524, 30.0572, 0.52459710393044, -95.1703, -1.66103508511076),
(34128, '77346', 218, 51, 36524, 29.9882, 0.523392826746564, -95.1823, -1.661244524621),
(34129, '77347', 218, 51, 36524, 29.992, 0.523459149258139, -95.2504, -1.66243309384161),
(34130, '77348', 218, 51, 3297, 30.7231, 0.53621925141947, -95.5502, -1.66766559093909),
(34131, '77349', 218, 51, 3297, 30.7238, 0.536231468724234, -95.5509, -1.66767780824385),
(34132, '77350', 218, 51, 60612, 30.8178, 0.537872078221109, -94.8706, -1.65580433334253),
(34133, '77351', 218, 51, 3825, 30.705, 0.535903346824859, -94.9384, -1.65698766657538),
(34134, '77353', 218, 51, 3947, 30.2093, 0.527251749722723, -95.7555, -1.67124875189343),
(34135, '77354', 218, 51, 3947, 30.2191, 0.527422791989418, -95.6788, -1.66991008435715),
(34136, '77355', 218, 51, 3947, 30.1499, 0.526215024147038, -95.7442, -1.67105152968795),
(34137, '77356', 218, 51, 4289, 30.4574, 0.531581911596921, -95.6727, -1.66980361927278),
(34138, '77357', 218, 51, 96483, 30.1672, 0.526516966107633, -95.1999, -1.66155170256935),
(34139, '77358', 218, 51, 96524, 30.549, 0.533180633191748, -95.4936, -1.66667773458246),
(34140, '77359', 218, 51, 4709, 30.6976, 0.535774192460211, -95.3014, -1.66332321176012),
(34141, '77360', 218, 51, 96794, 30.8054, 0.537655657393861, -95.1159, -1.66008562599767),
(34142, '77362', 218, 51, 23951, 30.1643, 0.526466351559326, -95.6797, -1.66992579232042),
(34143, '77363', 218, 51, 5108, 30.2693, 0.52829894727392, -95.8662, -1.67318083137539),
(34144, '77364', 218, 51, 97153, 30.7669, 0.536983705631843, -95.2504, -1.66243309384161),
(34145, '77365', 218, 51, 5186, 30.1045, 0.525422644666633, -95.2578, -1.66256224820625),
(34146, '77367', 218, 51, 5423, 30.8429, 0.538310155863359, -95.3743, -1.66459555678483),
(34147, '77368', 218, 51, 97624, 30.4516, 0.531480682500305, -94.8432, -1.65532611312749),
(34148, '77369', 218, 51, 11742, 30.4525, 0.531496390463573, -94.7684, -1.65402060684699),
(34149, '77371', 218, 51, 28589, 30.4787, 0.531953666727596, -94.9884, -1.65786033120138),
(34150, '77372', 218, 51, 98235, 30.2351, 0.527702044669737, -95.1773, -1.6611572581584),
(34151, '77373', 218, 51, 98236, 30.0559, 0.524574414650164, -95.3824, -1.66473692845424),
(34152, '77374', 218, 51, 98489, 30.396, 0.530510279436196, -94.6304, -1.65161205247924),
(34153, '77375', 218, 51, 98581, 30.0801, 0.524996784329146, -95.6171, -1.66883321620867),
(34154, '77376', 218, 51, 98857, 30.4348, 0.53118746718597, -94.6729, -1.65235381741134),
(34155, '77377', 218, 51, 98581, 30.0967, 0.525286508984977, -95.6155, -1.66880529094064),
(34156, '77378', 218, 51, 12872, 30.4194, 0.530918686481163, -95.4089, -1.66519944070602),
(34157, '77379', 218, 51, 98236, 30.0252, 0.524038598569802, -95.5284, -1.66728510916215),
(34158, '77380', 218, 51, 98236, 30.1393, 0.526030019246327, -95.4718, -1.66629725280552),
(34159, '77381', 218, 51, 98236, 30.1689, 0.526546636704917, -95.502, -1.66682434223962),
(34160, '77382', 218, 51, 98236, 30.2133, 0.527321562892803, -95.5259, -1.66724147593085),
(34161, '77383', 218, 51, 98236, 30.0742, 0.524893809903279, -95.4271, -1.66551709062988),
(34162, '77384', 218, 51, 93417, 30.2308, 0.527626995511902, -95.4922, -1.66665329997293),
(34163, '77385', 218, 51, 93417, 30.1858, 0.526841597348504, -95.4315, -1.66559388511697),
(34164, '77386', 218, 51, 98236, 30.1302, 0.525871194284395, -95.4202, -1.66539666291149),
(34165, '77387', 218, 51, 98236, 30.0801, 0.524996784329146, -95.4154, -1.6653128871074),
(34166, '77388', 218, 51, 98236, 30.052, 0.524506346809336, -95.4658, -1.6661925330504),
(34167, '77389', 218, 51, 98236, 30.1054, 0.525438352629901, -95.5113, -1.66698665786006),
(34168, '77391', 218, 51, 98236, 30.0239, 0.524015909289526, -95.5686, -1.66798673152145),
(34169, '77393', 218, 51, 98236, 30.1785, 0.526714188313109, -95.5027, -1.66683655954439),
(34170, '77396', 218, 51, 36524, 29.9511, 0.522745309594074, -95.2669, -1.66272107316819),
(34171, '77399', 218, 51, 3825, 30.7109, 0.536006321250727, -94.9325, -1.65688469214952),
(34172, '77401', 218, 51, 7382, 29.7044, 0.518439582329404, -95.4605, -1.66610003060005),
(34173, '77402', 218, 51, 7382, 29.7057, 0.51846227160968, -95.4735, -1.66632692340281),
(34174, '77404', 218, 51, 15113, 28.9665, 0.505560797778937, -95.8643, -1.6731476701196),
(34175, '77406', 218, 51, 5381, 29.6235, 0.51702761096454, -95.6493, -1.66939521222781),
(34176, '77410', 218, 51, 1938, 29.9689, 0.523055978200929, -95.697, -1.67022773428101);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(34177, '77411', 218, 51, 92189, 29.7303, 0.51889162260567, -95.5925, -1.66840386521268),
(34178, '77412', 218, 51, 92213, 29.6397, 0.517310354303363, -96.5117, -1.68444693169701),
(34179, '77413', 218, 51, 19053, 29.7715, 0.519610698257492, -95.7014, -1.6703045287681),
(34180, '77414', 218, 51, 15113, 28.9621, 0.50548400329185, -95.9464, -1.67458058543549),
(34181, '77415', 218, 51, 85653, 28.945, 0.505185551989759, -95.7383, -1.67094855526209),
(34182, '77417', 218, 51, 83, 29.4668, 0.514292680026665, -95.9694, -1.67498201116345),
(34183, '77418', 218, 51, 7390, 29.9691, 0.523059468859433, -96.2543, -1.67995445420238),
(34184, '77419', 218, 51, 71841, 28.8517, 0.503557159797648, -96.231, -1.67954779248666),
(34185, '77420', 218, 51, 92734, 29.2675, 0.51081423882744, -95.9712, -1.67501342708998),
(34186, '77422', 218, 51, 92801, 29.0429, 0.506894229327461, -95.5698, -1.66800767547248),
(34187, '77423', 218, 51, 92840, 29.8273, 0.520584591980105, -95.991, -1.67535900228188),
(34188, '77426', 218, 51, 1497, 30.0517, 0.52450111082158, -96.2082, -1.67914985741721),
(34189, '77428', 218, 51, 93341, 28.725, 0.501345827635371, -96.1746, -1.67856342678854),
(34190, '77429', 218, 51, 1938, 29.9952, 0.523514999794203, -95.6672, -1.66970762616392),
(34191, '77430', 218, 51, 54332, 29.2903, 0.511212173896895, -95.6864, -1.6700427293803),
(34192, '77431', 218, 51, 93630, 29.1695, 0.509103816160486, -95.8131, -1.67225406154258),
(34193, '77432', 218, 51, 93631, 29.0808, 0.507555709113967, -96.1763, -1.67859309738582),
(34194, '77433', 218, 51, 1938, 29.9151, 0.522116991063356, -95.7334, -1.67086303412874),
(34195, '77434', 218, 51, 15848, 29.5881, 0.516409764409334, -96.3314, -1.68130010305567),
(34196, '77435', 218, 51, 93870, 29.5287, 0.51537303883365, -96.0623, -1.67660342203855),
(34197, '77436', 218, 51, 2242, 29.4045, 0.513205339902673, -96.2371, -1.67965425757103),
(34198, '77437', 218, 51, 93951, 29.1984, 0.509608216314312, -96.2733, -1.68028606676026),
(34199, '77440', 218, 51, 94025, 28.8293, 0.503166206045201, -96.1206, -1.67762094899246),
(34200, '77441', 218, 51, 94383, 29.6822, 0.518052119235461, -95.925, -1.67420708497556),
(34201, '77442', 218, 51, 54919, 29.4483, 0.513969794115046, -96.3969, -1.68244329371572),
(34202, '77443', 218, 51, 94492, 29.3474, 0.512208756899784, -96.1936, -1.67889503934642),
(34203, '77444', 218, 51, 322, 29.3154, 0.511650251539146, -95.7875, -1.67180725725407),
(34204, '77445', 218, 51, 94830, 30.0915, 0.525195751863874, -96.0752, -1.67682856951206),
(34205, '77446', 218, 51, 505, 30.0804, 0.525002020316902, -95.9916, -1.67536947425739),
(34206, '77447', 218, 51, 94941, 30.0309, 0.524138082337165, -95.8196, -1.67236750794396),
(34207, '77448', 218, 51, 78493, 29.3105, 0.511564730405798, -96.0959, -1.67718985266722),
(34208, '77449', 218, 51, 41569, 29.8377, 0.520766106222312, -95.7348, -1.67088746873827),
(34209, '77450', 218, 51, 41569, 29.7492, 0.519221489834297, -95.7434, -1.67103756705394),
(34210, '77451', 218, 51, 95281, 29.4494, 0.513988992736818, -96.0023, -1.67555622448735),
(34211, '77452', 218, 51, 95289, 30.0484, 0.524443514956264, -96.3214, -1.68112557013047),
(34212, '77453', 218, 51, 95573, 29.2135, 0.509871761031363, -96.0195, -1.6758564211187),
(34213, '77454', 218, 51, 95738, 29.5558, 0.51584602306094, -96.2247, -1.67943783674379),
(34214, '77455', 218, 51, 10204, 29.1801, 0.509288821061197, -96.4229, -1.68289707932124),
(34215, '77456', 218, 51, 469, 28.9642, 0.505520655206142, -96.0931, -1.67714098344816),
(34216, '77457', 218, 51, 60793, 28.6947, 0.500816992872017, -95.9679, -1.67495583122467),
(34217, '77458', 218, 51, 4186, 28.9412, 0.505119229478183, -96.2432, -1.67976072265541),
(34218, '77459', 218, 51, 56308, 29.5255, 0.515317188297586, -95.5302, -1.66731652508869),
(34219, '77460', 218, 51, 96432, 29.4045, 0.513205339902673, -96.3861, -1.68225479815651),
(34220, '77461', 218, 51, 96457, 29.3957, 0.513051750928497, -95.8178, -1.67233609201742),
(34221, '77462', 218, 51, 96533, 29.2104, 0.509817655824552, -95.8928, -1.67364508895642),
(34222, '77463', 218, 51, 96747, 29.0793, 0.507529529175187, -95.7491, -1.6711370508213),
(34223, '77464', 218, 51, 4799, 29.6028, 0.516666327809377, -95.9649, -1.67490347134711),
(34224, '77465', 218, 51, 96856, 28.7097, 0.501078792259816, -96.2163, -1.67929122908662),
(34225, '77466', 218, 51, 61246, 29.8161, 0.520389115103881, -95.9895, -1.6753328223431),
(34226, '77467', 218, 51, 181, 29.2393, 0.510322055978378, -96.1996, -1.67899975910154),
(34227, '77468', 218, 51, 97136, 29.1817, 0.509316746329229, -95.9083, -1.67391561499048),
(34228, '77469', 218, 51, 5381, 29.5889, 0.51642372704335, -95.7532, -1.67120860932063),
(34229, '77470', 218, 51, 17831, 29.5306, 0.515406200089437, -96.5753, -1.68555696110128),
(34230, '77471', 218, 51, 97643, 29.5534, 0.515804135158892, -95.8544, -1.67297488252365),
(34231, '77473', 218, 51, 97785, 29.7958, 0.520034813265726, -96.0938, -1.67715320075293),
(34232, '77474', 218, 51, 77201, 29.7837, 0.519823628426235, -96.1583, -1.67827893812046),
(34233, '77475', 218, 51, 11906, 29.4932, 0.514753446949192, -96.671, -1.68722724119544),
(34234, '77476', 218, 51, 98099, 29.6797, 0.518008486004161, -95.9751, -1.67508149493081),
(34235, '77477', 218, 51, 12102, 29.6223, 0.517006667013516, -95.5641, -1.66790819170511),
(34236, '77478', 218, 51, 98346, 29.6283, 0.517111386768636, -95.6331, -1.66911246888899),
(34237, '77479', 218, 51, 98346, 29.5766, 0.516209051545355, -95.6289, -1.66903916506041),
(34238, '77480', 218, 51, 98399, 29.0583, 0.507163010032268, -95.7049, -1.67036561529192),
(34239, '77481', 218, 51, 98499, 29.4893, 0.514685379108364, -95.5958, -1.668461461078),
(34240, '77482', 218, 51, 98763, 29.0268, 0.50661323131789, -95.8835, -1.67348277333598),
(34241, '77483', 218, 51, 6590, 28.5808, 0.498829062853995, -96.0471, -1.67633813199225),
(34242, '77484', 218, 51, 43530, 30.0744, 0.524897300561783, -95.8913, -1.67361890901764),
(34243, '77485', 218, 51, 62201, 29.604, 0.516687271760401, -96.028, -1.67600477410511),
(34244, '77486', 218, 51, 84280, 29.1488, 0.508742533005323, -95.6445, -1.66931143642372),
(34245, '77487', 218, 51, 98346, 29.6193, 0.516954307135956, -95.6346, -1.66913864882777),
(34246, '77488', 218, 51, 12778, 29.3062, 0.511489681247962, -96.0747, -1.6768198428658),
(34247, '77489', 218, 51, 56308, 29.5956, 0.516540664103234, -95.5153, -1.66705647103014),
(34248, '77491', 218, 51, 41569, 29.7859, 0.519862025669779, -95.8245, -1.67245302907731),
(34249, '77492', 218, 51, 41569, 29.7448, 0.519144695347209, -95.82, -1.67237448926097),
(34250, '77493', 218, 51, 41569, 29.8487, 0.520958092440031, -95.8317, -1.67257869278345),
(34251, '77494', 218, 51, 41569, 29.7429, 0.519111534091421, -95.8205, -1.67238321590723),
(34252, '77496', 218, 51, 98346, 29.6195, 0.51695779779446, -95.6345, -1.66913690349852),
(34253, '77497', 218, 51, 12102, 29.6158, 0.516893220612137, -95.5577, -1.66779649063299),
(34254, '77501', 218, 51, 17543, 29.6811, 0.518032920613689, -95.17, -1.661029849123),
(34255, '77502', 218, 51, 17543, 29.6792, 0.517999759357901, -95.2012, -1.66157439184963),
(34256, '77503', 218, 51, 17543, 29.6908, 0.518202217551132, -95.1638, -1.66092163870938),
(34257, '77504', 218, 51, 17543, 29.65, 0.517490123216319, -95.1842, -1.66127768587679),
(34258, '77505', 218, 51, 17543, 29.654, 0.517559936386399, -95.1466, -1.66062144207804),
(34259, '77506', 218, 51, 17543, 29.7039, 0.518430855683144, -95.2013, -1.66157613717888),
(34260, '77507', 218, 51, 17543, 29.6274, 0.517095678805368, -95.0567, -1.65905239108049),
(34261, '77508', 218, 51, 17543, 29.6652, 0.517755413262622, -95.1478, -1.66064238602906),
(34262, '77510', 218, 51, 17977, 29.3734, 0.512662542505302, -95.0905, -1.65964231236767),
(34263, '77511', 218, 51, 18831, 29.4132, 0.513357183547596, -95.253, -1.66247847240216),
(34264, '77512', 218, 51, 18831, 29.422, 0.513510772521772, -95.2466, -1.66236677133003),
(34265, '77514', 218, 51, 92255, 29.7531, 0.519289557675125, -94.566, -1.65048806044096),
(34266, '77515', 218, 51, 92271, 29.17, 0.509112542806746, -95.4244, -1.66546996674008),
(34267, '77516', 218, 51, 92271, 29.1692, 0.50909858017273, -95.4311, -1.66558690379996),
(34268, '77517', 218, 51, 17977, 29.3838, 0.51284405674751, -95.1272, -1.66028284820315),
(34269, '77518', 218, 51, 92397, 29.5055, 0.514968122447187, -94.9884, -1.65786033120138),
(34270, '77519', 218, 51, 7299, 30.2329, 0.527663647426194, -94.6023, -1.65112161495943),
(34271, '77520', 218, 51, 92500, 29.7229, 0.518762468241023, -94.9188, -1.65664558204199),
(34272, '77521', 218, 51, 92500, 29.7962, 0.520041794582734, -94.9754, -1.65763343839862),
(34273, '77522', 218, 51, 92500, 29.7601, 0.519411730722764, -94.9647, -1.65744668816866),
(34274, '77530', 218, 51, 93185, 29.79, 0.519933584169111, -95.1186, -1.66013274988748),
(34275, '77531', 218, 51, 93314, 29.0355, 0.506765074962814, -95.4013, -1.66506679568287),
(34276, '77532', 218, 51, 1897, 29.9249, 0.522288033330051, -95.0706, -1.65929499184652),
(34277, '77533', 218, 51, 93615, 30.1139, 0.52558670561632, -94.6429, -1.65183021863574),
(34278, '77534', 218, 51, 64114, 29.2246, 0.510065492578335, -95.3368, -1.66394105831533),
(34279, '77535', 218, 51, 1992, 30.0245, 0.524026381265037, -94.8859, -1.65607136871809),
(34280, '77536', 218, 51, 2011, 29.698, 0.518327881257276, -95.1146, -1.6600629367174),
(34281, '77538', 218, 51, 93719, 29.989, 0.52340678938058, -94.5302, -1.64986323256874),
(34282, '77539', 218, 51, 2041, 29.4656, 0.514271736075641, -95.0374, -1.65871554253486),
(34283, '77541', 218, 51, 16142, 28.9738, 0.505688206814333, -95.3387, -1.66397421957112),
(34284, '77542', 218, 51, 16142, 28.9517, 0.505302489049642, -95.3643, -1.66442102385963),
(34285, '77545', 218, 51, 8997, 29.5455, 0.515666254147985, -95.4698, -1.66626234622048),
(34286, '77546', 218, 51, 29861, 29.5167, 0.51516359932341, -95.2029, -1.66160406244691),
(34287, '77547', 218, 51, 94395, 29.7379, 0.519024267628822, -95.236, -1.66218176642932),
(34288, '77549', 218, 51, 29861, 29.5311, 0.515414926735697, -95.2006, -1.66156391987411),
(34289, '77550', 218, 51, 36036, 29.2961, 0.511313402993511, -94.7959, -1.65450057239129),
(34290, '77551', 218, 51, 36036, 29.278, 0.5109974983989, -94.8392, -1.65525629995741),
(34291, '77552', 218, 51, 36036, 29.2816, 0.511060330251972, -94.8148, -1.65483043961992),
(34292, '77553', 218, 51, 36036, 29.2137, 0.509875251689867, -94.933, -1.65689341879578),
(34293, '77554', 218, 51, 36036, 29.207, 0.509758314629984, -94.967, -1.65748683074146),
(34294, '77555', 218, 51, 36036, 29.3088, 0.511535059808514, -94.7821, -1.65425971695452),
(34295, '77560', 218, 51, 94712, 29.8745, 0.521408387387046, -94.5789, -1.65071320791447),
(34296, '77561', 218, 51, 9325, 30.1502, 0.526220260134794, -94.7361, -1.6534568654986),
(34297, '77562', 218, 51, 3119, 29.8201, 0.520458928273961, -95.0453, -1.65885342354577),
(34298, '77563', 218, 51, 30091, 29.345, 0.512166868997736, -95.0032, -1.65811863993068),
(34299, '77564', 218, 51, 3279, 30.1345, 0.525946243442231, -94.6539, -1.65202220485346),
(34300, '77565', 218, 51, 95277, 29.5402, 0.515573751697629, -95.0309, -1.65860209613348),
(34301, '77566', 218, 51, 16791, 29.0422, 0.506882012022697, -95.445, -1.66582950456599),
(34302, '77568', 218, 51, 95433, 29.3644, 0.512505462872623, -94.976, -1.65764391037413),
(34303, '77571', 218, 51, 95453, 29.6575, 0.517621022910218, -95.0462, -1.65886913150903),
(34304, '77572', 218, 51, 95453, 29.6647, 0.517746686616362, -95.0046, -1.6581430745402),
(34305, '77573', 218, 51, 95649, 29.5037, 0.514936706520651, -95.0924, -1.65967547362346),
(34306, '77574', 218, 51, 95649, 29.5123, 0.515086804836323, -95.059, -1.65909253365329),
(34307, '77575', 218, 51, 3751, 30.0342, 0.524195678202481, -94.7461, -1.6536313984238),
(34308, '77577', 218, 51, 3824, 29.2739, 0.510925939899568, -95.2542, -1.66249941635318),
(34309, '77578', 218, 51, 95989, 29.478, 0.514488156902889, -95.3544, -1.66424823626368),
(34310, '77580', 218, 51, 96282, 29.8728, 0.521378716789762, -94.8532, -1.65550064605269),
(34311, '77581', 218, 51, 96961, 29.5624, 0.515961214791572, -95.2748, -1.66285895417909),
(34312, '77582', 218, 51, 97396, 30.0416, 0.524324832567128, -94.6715, -1.65232938280181),
(34313, '77583', 218, 51, 97647, 29.4059, 0.513229774512201, -95.4407, -1.66575445540815),
(34314, '77584', 218, 51, 96961, 29.545, 0.515657527501725, -95.3288, -1.66380143197517),
(34315, '77585', 218, 51, 5658, 30.3611, 0.52990115952725, -94.5576, -1.65034145278379),
(34316, '77586', 218, 51, 24727, 29.5749, 0.516179380948071, -95.033, -1.65863874804777),
(34317, '77587', 218, 51, 98187, 29.6616, 0.51769258140955, -95.2307, -1.66208926397896),
(34318, '77588', 218, 51, 96961, 29.5503, 0.51575002995208, -95.2766, -1.66289037010563),
(34319, '77590', 218, 51, 28768, 29.3955, 0.513048260269993, -94.9215, -1.6566927059318),
(34320, '77591', 218, 51, 28768, 29.3858, 0.51287896333255, -94.9871, -1.65783764192111),
(34321, '77592', 218, 51, 28768, 29.5087, 0.515023972983251, -95.1436, -1.66056908220048),
(34322, '77597', 218, 51, 98884, 29.8642, 0.521228618474091, -94.6912, -1.65267321266445),
(34323, '77598', 218, 51, 18520, 29.5418, 0.515601676965661, -95.1405, -1.66051497699367),
(34324, '77611', 218, 51, 39496, 30.0297, 0.524117138386141, -93.8364, -1.63775413821841),
(34325, '77612', 218, 51, 92915, 30.2939, 0.52872829826991, -94.0847, -1.64208779075111),
(34326, '77613', 218, 51, 1555, 30.0499, 0.524469694895044, -94.3069, -1.64596591234904),
(34327, '77614', 218, 51, 93723, 30.491, 0.532168342225591, -93.7444, -1.63614843530657),
(34328, '77615', 218, 51, 8794, 30.3547, 0.529789458455123, -94.0729, -1.64188184189937),
(34329, '77616', 218, 51, 40994, 30.6087, 0.534222594755188, -94.1855, -1.64384708263712),
(34330, '77617', 218, 51, 16213, 29.5144, 0.515123456750614, -94.4898, -1.64915811955094),
(34331, '77619', 218, 51, 65270, 29.9449, 0.52263709918045, -93.9161, -1.63914516563225),
(34332, '77622', 218, 51, 94707, 29.8779, 0.521467728581614, -94.3117, -1.64604968815314),
(34333, '77623', 218, 51, 41332, 29.5671, 0.516043245266415, -94.3935, -1.64747736748127),
(34334, '77624', 218, 51, 94909, 30.6833, 0.535524610377176, -94.4133, -1.64782294267316),
(34335, '77625', 218, 51, 95364, 30.3135, 0.529070382803301, -94.2831, -1.64555052398707),
(34336, '77626', 218, 51, 96058, 30.202, 0.527124340687327, -93.8861, -1.63862156685665),
(34337, '77627', 218, 51, 96454, 29.9735, 0.52313626334652, -93.9987, -1.64058680759439),
(34338, '77629', 218, 51, 96569, 30.0425, 0.524340540530396, -94.3779, -1.64720509611796),
(34339, '77630', 218, 51, 4797, 30.1011, 0.525363303472065, -93.7725, -1.63663887282638),
(34340, '77631', 218, 51, 4797, 30.0939, 0.525237639765922, -93.7332, -1.63595295843035),
(34341, '77632', 218, 51, 4797, 30.1626, 0.526436680962042, -93.7849, -1.63685529365363),
(34342, '77639', 218, 51, 96809, 30.0533, 0.524529036089612, -93.8552, -1.63808226011778),
(34343, '77640', 218, 51, 97173, 29.8974, 0.521808067785753, -93.9548, -1.63982060805277),
(34344, '77641', 218, 51, 97173, 29.792, 0.519968490754151, -93.9339, -1.6394558342391),
(34345, '77642', 218, 51, 97173, 29.9207, 0.522214729501467, -93.9312, -1.6394087103493),
(34346, '77643', 218, 51, 97173, 29.8983, 0.521823775749021, -93.9284, -1.63935984113024),
(34347, '77650', 218, 51, 97174, 29.4506, 0.514009936687842, -94.6363, -1.65171502690511),
(34348, '77651', 218, 51, 97182, 29.9789, 0.523230511126128, -93.9597, -1.63990612918612),
(34349, '77655', 218, 51, 97717, 29.7283, 0.51885671602063, -93.8891, -1.63867392673421),
(34350, '77656', 218, 51, 98084, 30.3188, 0.529162885253657, -94.1888, -1.64390467850244),
(34351, '77657', 218, 51, 16965, 30.2517, 0.527991769325569, -94.1954, -1.64401987023307),
(34352, '77659', 218, 51, 98175, 30.1538, 0.526283091987866, -94.3646, -1.64697296732744),
(34353, '77660', 218, 51, 98260, 30.724, 0.536234959382738, -94.1727, -1.64362368049286),
(34354, '77661', 218, 51, 98317, 29.7898, 0.519930093510607, -94.3847, -1.64732377850709),
(34355, '77662', 218, 51, 98812, 30.1483, 0.526187098879006, -94.0097, -1.64077879381211),
(34356, '77663', 218, 51, 98837, 30.5336, 0.532911852486941, -94.4407, -1.64830116288821),
(34357, '77664', 218, 51, 12663, 30.6352, 0.534685107006967, -94.3783, -1.64721207743496),
(34358, '77665', 218, 51, 99160, 29.7947, 0.520015614643955, -94.3497, -1.64671291326889),
(34359, '77670', 218, 51, 98812, 30.1247, 0.525775201175536, -94.0142, -1.64085733362845),
(34360, '77701', 218, 51, 31761, 30.0731, 0.524874611281507, -94.1042, -1.64242812995525),
(34361, '77702', 218, 51, 31761, 30.0841, 0.525066597499226, -94.1342, -1.64295172873085),
(34362, '77703', 218, 51, 31761, 30.1113, 0.525541327055769, -94.119, -1.64268643868454),
(34363, '77704', 218, 51, 31761, 30.0729, 0.524871120623003, -94.1007, -1.64236704343143),
(34364, '77705', 218, 51, 31761, 30.0421, 0.524333559213389, -94.1041, -1.642426384626),
(34365, '77706', 218, 51, 31761, 30.0948, 0.52525334772919, -94.1674, -1.64353117804251),
(34366, '77707', 218, 51, 31761, 30.0672, 0.524771636855639, -94.173, -1.64362891648062),
(34367, '77708', 218, 51, 31761, 30.1443, 0.526117285708927, -94.168, -1.64354165001802),
(34368, '77709', 218, 51, 98858, 30.1736, 0.526628667179761, -94.1956, -1.64402336089157),
(34369, '77710', 218, 51, 31761, 30.0716, 0.524848431342727, -94.1001, -1.64235657145592),
(34370, '77713', 218, 51, 31761, 30.1464, 0.526153937623219, -94.2208, -1.64446318386307),
(34371, '77720', 218, 51, 31761, 30.038, 0.524262000714057, -94.1581, -1.64336886242207),
(34372, '77725', 218, 51, 31761, 30.0863, 0.52510499474277, -94.1013, -1.64237751540694),
(34373, '77726', 218, 51, 31761, 30.093, 0.525221931802654, -94.1466, -1.64316814955809),
(34374, '77801', 218, 51, 1206, 30.6625, 0.535161581892761, -96.3641, -1.68187082572107),
(34375, '77802', 218, 51, 1206, 30.66, 0.535117948661461, -96.3307, -1.6812878857509),
(34376, '77803', 218, 51, 1206, 30.6811, 0.535486213133632, -96.3776, -1.68210644517009),
(34377, '77805', 218, 51, 1206, 30.6715, 0.535318661525441, -96.3434, -1.68150954256591),
(34378, '77806', 218, 51, 1206, 30.6743, 0.535367530744497, -96.37, -1.68197380014694),
(34379, '77807', 218, 51, 1206, 30.6221, 0.534456468874956, -96.3832, -1.6822041836082),
(34380, '77808', 218, 51, 1206, 30.7057, 0.535915564129623, -96.3346, -1.68135595359173),
(34381, '77830', 218, 51, 7099, 30.5563, 0.533308042227143, -96.0335, -1.67610076721397),
(34382, '77831', 218, 51, 92525, 30.7493, 0.536676527683492, -95.9196, -1.67411283719595),
(34383, '77833', 218, 51, 31885, 30.165, 0.52647856886409, -96.3968, -1.68244154838647),
(34384, '77834', 218, 51, 31885, 30.1696, 0.526558854009681, -96.3964, -1.68243456706946),
(34385, '77835', 218, 51, 7796, 30.1772, 0.526691499032833, -96.6098, -1.68615909969322),
(34386, '77836', 218, 51, 1290, 30.5656, 0.533470357847579, -96.7493, -1.68859383399975),
(34387, '77837', 218, 51, 1300, 30.9735, 0.540589555866464, -96.6674, -1.68716440934237),
(34388, '77838', 218, 51, 93238, 30.5988, 0.534049807159241, -96.7705, -1.68896384380117),
(34389, '77839', 218, 51, 1601, 30.3432, 0.529588745591143, -96.5286, -1.6847418923406),
(34390, '77840', 218, 51, 8181, 30.6052, 0.534161508231369, -96.3106, -1.68093707457125),
(34391, '77841', 218, 51, 8181, 30.5727, 0.53359427622447, -96.3271, -1.68122505389783),
(34392, '77842', 218, 51, 8181, 30.6275, 0.534550716654563, -96.3345, -1.68135420826248),
(34393, '77843', 218, 51, 8181, 30.6111, 0.534264482657236, -96.3488, -1.68160379034551),
(34394, '77844', 218, 51, 8181, 30.6114, 0.534269718644992, -96.3551, -1.68171374608839),
(34395, '77845', 218, 51, 8181, 30.5843, 0.533796734417702, -96.2924, -1.68061942464739),
(34396, '77850', 218, 51, 698, 31.2572, 0.545541054954372, -96.1159, -1.67753891851762),
(34397, '77852', 218, 51, 15756, 30.4317, 0.531133361979158, -96.7553, -1.68869855375487),
(34398, '77853', 218, 51, 93748, 30.1703, 0.526571071314445, -96.9782, -1.69258889265757),
(34399, '77855', 218, 51, 8917, 31.1504, 0.543677043313242, -96.1242, -1.67768378084553),
(34400, '77856', 218, 51, 2595, 31.0302, 0.541579157552344, -96.4843, -1.68396871148197),
(34401, '77857', 218, 51, 87213, 30.7849, 0.537297864897202, -96.7211, -1.68810165115069),
(34402, '77859', 218, 51, 94810, 30.8771, 0.538907058467541, -96.5969, -1.68593395221971),
(34403, '77861', 218, 51, 16556, 30.6749, 0.535378002720009, -96.128, -1.67775010335711),
(34404, '77862', 218, 51, 95371, 30.7871, 0.537336262140746, -96.2643, -1.68012898712758),
(34405, '77863', 218, 51, 764, 30.3859, 0.530334001181745, -96.5635, -1.68535101224954),
(34406, '77864', 218, 51, 37022, 30.9501, 0.540181148821497, -95.9144, -1.67402208007485),
(34407, '77865', 218, 51, 96015, 31.2206, 0.544902264448142, -96.237, -1.67965251224178),
(34408, '77866', 218, 51, 96228, 30.4673, 0.531754699192868, -96.2045, -1.67908528023488),
(34409, '77867', 218, 51, 56427, 30.7341, 0.536411237637189, -96.5646, -1.68537021087132),
(34410, '77868', 218, 51, 96446, 30.3876, 0.530363671779029, -96.0849, -1.6769978664495),
(34411, '77869', 218, 51, 96446, 30.3887, 0.530382870400801, -96.0884, -1.67705895297332),
(34412, '77870', 218, 51, 28015, 31.0511, 0.541943931366011, -96.4286, -1.6829965630886),
(34413, '77871', 218, 51, 96574, 31.0738, 0.542340121106214, -96.1941, -1.67890376599268),
(34414, '77872', 218, 51, 96626, 30.9376, 0.539962982664998, -96.0895, -1.67707815159509),
(34415, '77873', 218, 51, 57154, 30.5484, 0.533170161216236, -95.8652, -1.67316337808287),
(34416, '77875', 218, 51, 97552, 30.5842, 0.53379498908845, -95.9433, -1.67452648022868),
(34417, '77876', 218, 51, 98058, 30.6133, 0.53430287990078, -95.8875, -1.67355258650606),
(34418, '77878', 218, 51, 98152, 30.4886, 0.532126454323543, -96.4639, -1.68361266431456),
(34419, '77879', 218, 51, 5947, 30.337, 0.52948053517752, -96.5708, -1.68547842128494),
(34420, '77880', 218, 51, 12671, 30.3331, 0.529412467336692, -96.2288, -1.67950939524312),
(34421, '77881', 218, 51, 6685, 30.5345, 0.532927560450209, -96.3016, -1.68077999493857),
(34422, '77882', 218, 51, 99058, 30.8975, 0.539263105634948, -96.3892, -1.68230890336332),
(34423, '77901', 218, 51, 6554, 28.8038, 0.502721147085943, -97.0151, -1.69323291915155),
(34424, '77902', 218, 51, 6554, 28.7837, 0.502370335906292, -96.9954, -1.69288908928891),
(34425, '77903', 218, 51, 6554, 28.7966, 0.502595483379799, -97.007, -1.69309154748214),
(34426, '77904', 218, 51, 6554, 28.8586, 0.503677587516036, -97.0014, -1.69299380904403),
(34427, '77905', 218, 51, 6554, 28.8856, 0.504148826414074, -97.1735, -1.69599752068671),
(34428, '77950', 218, 51, 92380, 28.3954, 0.495593222420798, -96.9722, -1.69248417290245),
(34429, '77951', 218, 51, 29235, 28.6482, 0.50000541476984, -96.8927, -1.69109663614711),
(34430, '77954', 218, 51, 93582, 29.0928, 0.507765148624206, -97.2911, -1.69805002788706),
(34431, '77957', 218, 51, 13, 28.9766, 0.505737076033389, -96.646, -1.68679090888244),
(34432, '77960', 218, 51, 35851, 28.6566, 0.500152022427007, -97.4256, -1.70039749573099),
(34433, '77961', 218, 51, 94320, 28.8189, 0.502984691802994, -96.4428, -1.68324439984239),
(34434, '77962', 218, 51, 94407, 29.0389, 0.506824416157381, -96.5112, -1.68443820505075),
(34435, '77963', 218, 51, 94518, 28.6685, 0.500359716607994, -97.3886, -1.69975172390775),
(34436, '77964', 218, 51, 94690, 29.4457, 0.513924415554494, -96.9429, -1.69197279143161),
(34437, '77967', 218, 51, 94940, 29.2418, 0.510365689209678, -97.0688, -1.69417016095987),
(34438, '77968', 218, 51, 36567, 28.8808, 0.504065050609978, -96.8291, -1.68998660674284),
(34439, '77969', 218, 51, 95463, 29.0105, 0.506328742649815, -96.6851, -1.68747333261997),
(34440, '77970', 218, 51, 95470, 28.8186, 0.502979455815238, -96.443, -1.68324789050089),
(34441, '77971', 218, 51, 95779, 28.8181, 0.502970729168978, -96.4433, -1.68325312648865),
(34442, '77973', 218, 51, 96095, 28.7229, 0.501309175721079, -97.0503, -1.69384727504825),
(34443, '77974', 218, 51, 96170, 28.9289, 0.504904553980188, -97.3023, -1.69824550476328),
(34444, '77975', 218, 51, 4358, 29.5736, 0.516156691667795, -97.1503, -1.69559260430025),
(34445, '77976', 218, 51, 96644, 28.9516, 0.50530074372039, -96.9839, -1.69268837642493),
(34446, '77977', 218, 51, 97097, 28.6967, 0.500851899457057, -96.8286, -1.68997788009658),
(34447, '77978', 218, 51, 11314, 28.6793, 0.50054821216721, -96.5571, -1.68523931117742),
(34448, '77979', 218, 51, 97179, 28.6158, 0.499439928092193, -96.6311, -1.68653085482389),
(34449, '77982', 218, 51, 97183, 28.2283, 0.492676777240715, -96.6437, -1.68675076630964),
(34450, '77983', 218, 51, 97936, 28.401, 0.49569096085891, -96.6594, -1.68702478300221),
(34451, '77984', 218, 51, 98054, 29.4327, 0.513697522751735, -97.1757, -1.69603591793025),
(34452, '77985', 218, 51, 98227, 29.3982, 0.513095384159797, -96.8258, -1.68992901087753),
(34453, '77986', 218, 51, 98343, 29.3984, 0.513098874818301, -96.8254, -1.68992202956052),
(34454, '77987', 218, 51, 6194, 29.2421, 0.510370925197434, -97.0692, -1.69417714227688),
(34455, '77988', 218, 51, 98451, 28.8508, 0.50354145183438, -96.8887, -1.69102682297703),
(34456, '77989', 218, 51, 6315, 29.0942, 0.507789583233734, -97.1906, -1.6962959719888),
(34457, '77990', 218, 51, 98560, 28.4579, 0.496684053203294, -96.8949, -1.69113503339065),
(34458, '77991', 218, 51, 6518, 29.0114, 0.506344450613083, -96.6855, -1.68748031393698),
(34459, '77993', 218, 51, 98963, 28.6564, 0.500148531768503, -97.4262, -1.7004079677065),
(34460, '77994', 218, 51, 112605, 29.0812, 0.507562690430975, -97.3599, -1.69925081441243),
(34461, '77995', 218, 51, 99230, 29.2947, 0.511288968383983, -97.1432, -1.69546868592336),
(34462, '78001', 218, 51, 92347, 28.28, 0.493579112463996, -99.2845, -1.73284142119631),
(34463, '78002', 218, 51, 92358, 29.2846, 0.511112690129531, -98.7314, -1.72318800510353),
(34464, '78003', 218, 51, 92422, 29.7348, 0.51897016242201, -99.037, -1.72852173129762),
(34465, '78004', 218, 51, 92586, 29.841, 0.520823702087628, -98.5823, -1.72058571918881),
(34466, '78005', 218, 51, 92646, 29.2157, 0.509910158274907, -98.7069, -1.72276039943679),
(34467, '78006', 218, 51, 92727, 29.7187, 0.518689164412439, -98.652, -1.72180221367745),
(34468, '78007', 218, 51, 92984, 28.3465, 0.494739756416573, -98.4231, -1.71780715501963),
(34469, '78008', 218, 51, 15420, 28.7914, 0.502504726258695, -98.2449, -1.71469697829258),
(34470, '78009', 218, 51, 93104, 29.3477, 0.51221399288754, -98.8847, -1.72586359484684),
(34471, '78010', 218, 51, 655, 29.9409, 0.52256728601037, -99.0402, -1.72857758183369),
(34472, '78011', 218, 51, 8042, 28.82, 0.503003890424766, -98.7118, -1.72284592057014),
(34473, '78012', 218, 51, 35243, 28.7928, 0.502529160868223, -98.51, -1.71932384613961),
(34474, '78013', 218, 51, 63857, 29.9846, 0.523329994893492, -98.8373, -1.72503630878139),
(34475, '78014', 218, 51, 93476, 28.4218, 0.496053989343324, -99.2368, -1.73200889914311),
(34476, '78015', 218, 51, 92727, 29.8018, 0.520139533020846, -98.738, -1.72330319683416),
(34477, '78016', 218, 51, 112584, 29.1451, 0.508677955822999, -98.9081, -1.7262720018918),
(34478, '78017', 218, 51, 112583, 28.6722, 0.500424293790318, -99.1685, -1.730816839264),
(34479, '78019', 218, 51, 94058, 28.0406, 0.489400794234722, -99.3563, -1.73409456759924),
(34480, '78021', 218, 51, 94310, 28.5305, 0.497951162240242, -98.8324, -1.72495078764804),
(34481, '78022', 218, 51, 94452, 28.3318, 0.494483193016529, -98.1183, -1.71248739145955),
(34482, '78023', 218, 51, 94827, 29.5932, 0.516498776201186, -98.7149, -1.72290002577695),
(34483, '78024', 218, 51, 9616, 30.0758, 0.524921735171311, -99.3266, -1.7335762048114),
(34484, '78025', 218, 51, 539, 30.0868, 0.52511372138903, -99.2435, -1.73212583620299),
(34485, '78026', 218, 51, 95226, 28.9197, 0.504743983689004, -98.5434, -1.71990678610978),
(34486, '78027', 218, 51, 95279, 29.9398, 0.522548087388598, -98.5076, -1.71928195823757),
(34487, '78028', 218, 51, 55660, 30.0377, 0.524256764726301, -99.1548, -1.73057772915647),
(34488, '78029', 218, 51, 55660, 30.0605, 0.524654699795755, -99.1555, -1.73058994646124),
(34489, '78039', 218, 51, 95396, 29.3187, 0.511707847404462, -98.8325, -1.7249525329773),
(34490, '78040', 218, 51, 95591, 27.5118, 0.480171493150176, -99.4901, -1.73642981813841),
(34491, '78041', 218, 51, 95591, 27.5485, 0.480812028985658, -99.4907, -1.73644029011392),
(34492, '78042', 218, 51, 95591, 27.5059, 0.480068518724308, -99.5106, -1.73678761063507),
(34493, '78043', 218, 51, 95591, 27.4914, 0.479815445982769, -99.4707, -1.73609122426352),
(34494, '78044', 218, 51, 95591, 27.4616, 0.479295337865675, -99.4884, -1.73640014754113),
(34495, '78045', 218, 51, 95591, 27.5944, 0.481613135112323, -99.5125, -1.73682077189086),
(34496, '78046', 218, 51, 95591, 27.4386, 0.478893912137716, -99.4729, -1.73612962150707),
(34497, '78049', 218, 51, 95591, 27.5299, 0.480487397744787, -99.4686, -1.73605457234923),
(34498, '78050', 218, 51, 48903, 29.0723, 0.507407356127547, -98.4839, -1.71886831520484),
(34499, '78052', 218, 51, 3923, 29.2241, 0.510056765932075, -98.7863, -1.72414619086287),
(34500, '78053', 218, 51, 30470, 28.8052, 0.502745581695471, -98.3625, -1.71674948549292),
(34501, '78054', 218, 51, 95934, 29.3263, 0.511840492427613, -98.6958, -1.72256666788982),
(34502, '78055', 218, 51, 10432, 29.9395, 0.522542851400842, -99.2285, -1.73186403681519),
(34503, '78056', 218, 51, 96173, 29.4996, 0.514865148021319, -98.9665, -1.72729127417497),
(34504, '78057', 218, 51, 10581, 29.0003, 0.506150719066112, -98.9399, -1.72682701659394),
(34505, '78058', 218, 51, 4432, 30.2411, 0.527806764424857, -99.3473, -1.73393748796656),
(34506, '78059', 218, 51, 46, 29.1853, 0.509379578182301, -98.857, -1.72538013864403),
(34507, '78060', 218, 51, 4721, 28.458, 0.496685798532546, -98.0444, -1.71119759314233),
(34508, '78061', 218, 51, 96962, 28.8941, 0.504297179400494, -99.0953, -1.72953925825154),
(34509, '78062', 218, 51, 96988, 28.7395, 0.50159890037691, -98.1783, -1.71353458901075),
(34510, '78063', 218, 51, 97090, 29.6532, 0.517545973752383, -98.933, -1.72670658887555),
(34511, '78064', 218, 51, 820, 28.9673, 0.505574760412953, -98.4878, -1.71893638304567),
(34512, '78065', 218, 51, 97201, 29.1312, 0.508435355056972, -98.5324, -1.71971479989206),
(34513, '78066', 218, 51, 0, 29.4975, 0.514828496107027, -98.8691, -1.72559132348353),
(34514, '78067', 218, 51, 97818, 27.0378, 0.471898632495723, -99.4235, -1.73526742885658),
(34515, '78069', 218, 51, 5946, 29.2257, 0.510084691200107, -98.6609, -1.72195754798087),
(34516, '78070', 218, 51, 25019, 29.8523, 0.521020924293103, -98.3749, -1.71696590632017),
(34517, '78071', 218, 51, 62020, 28.3577, 0.494935233292796, -98.1322, -1.71272999222558),
(34518, '78072', 218, 51, 6338, 28.3475, 0.494757209709093, -98.6543, -1.72184235625024),
(34519, '78073', 218, 51, 98855, 29.2313, 0.510182429638218, -98.6238, -1.72131003082838),
(34520, '78074', 218, 51, 25803, 29.8235, 0.520518269468529, -98.7525, -1.7235562695757),
(34521, '78075', 218, 51, 70151, 28.6232, 0.499569082456841, -98.2482, -1.71475457415789),
(34522, '78076', 218, 51, 99251, 26.8955, 0.469415028970135, -99.2627, -1.73246093941938),
(34523, '78101', 218, 51, 92120, 29.3863, 0.51288768997881, -98.2707, -1.71514727323959),
(34524, '78102', 218, 51, 92532, 28.4036, 0.495736339419461, -97.7496, -1.70605236250745),
(34525, '78104', 218, 51, 92532, 28.4112, 0.495868984442613, -97.7614, -1.70625831135918),
(34526, '78107', 218, 51, 58638, 28.5306, 0.497952907569494, -97.5906, -1.70327728899678),
(34527, '78108', 218, 51, 93247, 29.5662, 0.516027537303147, -98.2282, -1.71440550830749),
(34528, '78109', 218, 51, 39874, 29.5134, 0.515106003458094, -98.314, -1.71590300080571),
(34529, '78111', 218, 51, 93910, 29.0383, 0.506813944181869, -97.7512, -1.70608028777548),
(34530, '78112', 218, 51, 94027, 29.2335, 0.510220826881762, -98.3686, -1.71685595057729),
(34531, '78113', 218, 51, 2413, 28.9328, 0.504972621821015, -98.0629, -1.71152047905395),
(34532, '78114', 218, 51, 94244, 29.1597, 0.508932773893791, -98.1799, -1.71356251427878),
(34533, '78115', 218, 51, 75920, 29.6102, 0.516795482174025, -98.0248, -1.71085550860894),
(34534, '78116', 218, 51, 9113, 29.078, 0.507506839894911, -97.7907, -1.70676969283002),
(34535, '78117', 218, 51, 3173, 28.9375, 0.505054652295859, -97.9811, -1.71009279972582),
(34536, '78118', 218, 51, 95249, 28.8899, 0.50422387557191, -97.8992, -1.70866337506843),
(34537, '78119', 218, 51, 95282, 28.8142, 0.50290266132815, -97.8495, -1.70779594643019),
(34538, '78121', 218, 51, 95467, 29.3356, 0.512002808048049, -98.0957, -1.7120929470486),
(34539, '78122', 218, 51, 30315, 29.4073, 0.513254209121728, -97.7415, -1.70591099083804),
(34540, '78123', 218, 51, 96117, 29.6073, 0.516744867625717, -98.0353, -1.7110387681804),
(34541, '78124', 218, 51, 630, 29.5746, 0.516174144960315, -98.1499, -1.71303891550318),
(34542, '78125', 218, 51, 10518, 28.5486, 0.498267066834853, -97.9039, -1.70874540554328),
(34543, '78130', 218, 51, 96480, 29.702, 0.518397694427356, -98.1219, -1.71255022331262),
(34544, '78131', 218, 51, 96480, 29.714, 0.518607133937595, -98.1431, -1.71292023311405),
(34545, '78132', 218, 51, 96480, 29.7424, 0.519102807445161, -98.1676, -1.71334783878079),
(34546, '78133', 218, 51, 93038, 29.8682, 0.52129843164417, -98.2779, -1.71527293694574),
(34547, '78135', 218, 51, 96480, 29.7042, 0.5184360916709, -98.1179, -1.71248041014254),
(34548, '78140', 218, 51, 17283, 29.2698, 0.510854381400236, -97.762, -1.7062687833347),
(34549, '78141', 218, 51, 96570, 28.8972, 0.504351284607305, -97.5608, -1.70275718087968),
(34550, '78142', 218, 51, 96575, 28.5294, 0.49793196361847, -97.7817, -1.70661261319734),
(34551, '78143', 218, 51, 89753, 29.2498, 0.510505315549837, -97.8375, -1.70758650691995),
(34552, '78144', 218, 51, 96903, 28.9577, 0.505407208804762, -97.8972, -1.70862846848339),
(34553, '78145', 218, 51, 23789, 28.6525, 0.500080463927675, -98.0029, -1.71047328150275),
(34554, '78146', 218, 51, 11165, 28.6173, 0.499466108030973, -97.8019, -1.70696516970624),
(34555, '78147', 218, 51, 97202, 29.0383, 0.506813944181869, -98.1013, -1.71219068548671),
(34556, '78148', 218, 51, 98700, 29.5532, 0.515800644500388, -98.3046, -1.71573893985602),
(34557, '78150', 218, 51, 98700, 29.5271, 0.515345113565618, -98.2786, -1.7152851542505),
(34558, '78151', 218, 51, 97689, 28.8765, 0.503990001452143, -97.7054, -1.70528092697807),
(34559, '78152', 218, 51, 97728, 29.4359, 0.513753373287799, -98.2056, -1.71401106389654),
(34560, '78154', 218, 51, 97906, 29.5672, 0.516044990595667, -98.2693, -1.71512283863006),
(34561, '78155', 218, 51, 97958, 29.5696, 0.516086878497715, -97.9659, -1.70982750967951),
(34562, '78156', 218, 51, 97958, 29.5666, 0.516034518620155, -97.9326, -1.7092463150386),
(34563, '78159', 218, 51, 79143, 29.241, 0.510351726575662, -97.5964, -1.70337851809339),
(34564, '78160', 218, 51, 6092, 29.235, 0.510247006820542, -97.961, -1.70974198854617),
(34565, '78161', 218, 51, 98393, 29.2709, 0.510873580022008, -98.0604, -1.71147684582265),
(34566, '78162', 218, 51, 98648, 28.571, 0.4986580205873, -97.797, -1.70687964857289),
(34567, '78163', 218, 51, 92911, 29.6788, 0.517992778040893, -98.4119, -1.71761167814341),
(34568, '78164', 218, 51, 143, 28.9826, 0.505841795788509, -97.5066, -1.7018112124251),
(34569, '78201', 218, 51, 17931, 29.4734, 0.514407871757297, -98.5356, -1.71977065042812),
(34570, '78202', 218, 51, 17931, 29.4241, 0.513547424436063, -98.4636, -1.71851401336669),
(34571, '78203', 218, 51, 17931, 29.4147, 0.513383363486376, -98.4596, -1.71844420019661),
(34572, '78204', 218, 51, 17931, 29.3972, 0.513077930867277, -98.5012, -1.71917025716544),
(34573, '78205', 218, 51, 17931, 29.4251, 0.513564877728584, -98.4892, -1.7189608176552),
(34574, '78206', 218, 51, 17931, 29.4144, 0.51337812749862, -98.4991, -1.71913360525115),
(34575, '78207', 218, 51, 17931, 29.4211, 0.513495064558504, -98.5226, -1.71954375762537),
(34576, '78208', 218, 51, 17931, 29.4395, 0.513816205140871, -98.4591, -1.71843547355035),
(34577, '78209', 218, 51, 17931, 29.4892, 0.514683633779112, -98.4469, -1.71822254338161),
(34578, '78210', 218, 51, 17931, 29.399, 0.513109346793813, -98.469, -1.7186082611463),
(34579, '78211', 218, 51, 17931, 29.3586, 0.512404233776007, -98.5464, -1.71995914598734),
(34580, '78212', 218, 51, 17931, 29.4602, 0.514177488296033, -98.4929, -1.71902539483752),
(34581, '78213', 218, 51, 17931, 29.5118, 0.515078078190063, -98.5222, -1.71953677630836),
(34582, '78214', 218, 51, 17931, 29.3637, 0.512493245567859, -98.489, -1.7189573269967),
(34583, '78215', 218, 51, 17931, 29.4374, 0.513779553226579, -98.4832, -1.71885609790008),
(34584, '78216', 218, 51, 17931, 29.5354, 0.515489975893533, -98.4907, -1.71898699759398),
(34585, '78217', 218, 51, 17931, 29.5447, 0.515652291513969, -98.4199, -1.71775130448357),
(34586, '78218', 218, 51, 17931, 29.5001, 0.514873874667579, -98.3996, -1.71739700264541),
(34587, '78219', 218, 51, 17931, 29.4509, 0.514015172675598, -98.3863, -1.7171648738549),
(34588, '78220', 218, 51, 17931, 29.411, 0.513318786304052, -98.4044, -1.71748077844951),
(34589, '78221', 218, 51, 17931, 29.3191, 0.511714828721469, -98.4975, -1.71910567998311),
(34590, '78222', 218, 51, 17931, 29.3856, 0.512875472674046, -98.393, -1.71728181091478),
(34591, '78223', 218, 51, 17931, 29.3558, 0.512355364556951, -98.4294, -1.71791711076251),
(34592, '78224', 218, 51, 17931, 29.3342, 0.511978373438521, -98.5368, -1.71979159437915),
(34593, '78225', 218, 51, 17931, 29.3948, 0.513036042965229, -98.5327, -1.71972003587982),
(34594, '78226', 218, 51, 17931, 29.3962, 0.513060477574757, -98.5483, -1.71999230724313),
(34595, '78227', 218, 51, 17931, 29.4045, 0.513205339902673, -98.639, -1.72157532087469),
(34596, '78228', 218, 51, 17931, 29.4625, 0.514217630868829, -98.5756, -1.72046878212892),
(34597, '78229', 218, 51, 17931, 29.5004, 0.514879110655335, -98.5734, -1.72043038488538),
(34598, '78230', 218, 51, 17931, 29.5399, 0.515568515709873, -98.5527, -1.72006910173022),
(34599, '78231', 218, 51, 17931, 29.5882, 0.516411509738586, -98.5501, -1.72002372316966),
(34600, '78232', 218, 51, 17931, 29.5824, 0.51631028064197, -98.4734, -1.71868505563338),
(34601, '78233', 218, 51, 17931, 29.5549, 0.515830315097672, -98.3636, -1.71676868411469),
(34602, '78234', 218, 51, 17931, 29.4583, 0.514144327040246, -98.4935, -1.71903586681304),
(34603, '78235', 218, 51, 17931, 29.3424, 0.512121490437184, -98.439, -1.7180846623707),
(34604, '78236', 218, 51, 17931, 29.4046, 0.513207085231925, -98.6125, -1.72111280862291),
(34605, '78237', 218, 51, 17931, 29.4216, 0.513503791204764, -98.5645, -1.72027505058195),
(34606, '78238', 218, 51, 17931, 29.48, 0.514523063487928, -98.6098, -1.7210656847331),
(34607, '78239', 218, 51, 17931, 29.5124, 0.515088550165575, -98.366, -1.71681057201674),
(34608, '78240', 218, 51, 17931, 29.5181, 0.515188033932938, -98.6089, -1.72104997676984),
(34609, '78241', 218, 51, 17931, 29.3737, 0.512667778493058, -98.5486, -1.71999754323088),
(34610, '78242', 218, 51, 17931, 29.3522, 0.51229253270388, -98.6109, -1.72108488335488),
(34611, '78243', 218, 51, 17931, 29.3816, 0.512805659503966, -98.5792, -1.72053161398199),
(34612, '78244', 218, 51, 17931, 29.4739, 0.514416598403557, -98.3241, -1.71607927906016),
(34613, '78245', 218, 51, 17931, 29.4069, 0.513247227804721, -98.736, -1.72326829024912),
(34614, '78246', 218, 51, 17931, 29.5368, 0.515514410503061, -98.4888, -1.71895383633819),
(34615, '78247', 218, 51, 17931, 29.5888, 0.516421981714098, -98.4001, -1.71740572929167),
(34616, '78248', 218, 51, 17931, 29.5834, 0.516327733934491, -98.5224, -1.71954026696686),
(34617, '78249', 218, 51, 17931, 29.5662, 0.516027537303147, -98.6058, -1.72099587156302),
(34618, '78250', 218, 51, 17931, 29.5075, 0.515003029032227, -98.667, -1.72206401306525),
(34619, '78251', 218, 51, 17931, 29.4622, 0.514212394881073, -98.6707, -1.72212859024757),
(34620, '78252', 218, 51, 17931, 29.3488, 0.512233191509312, -98.695, -1.7225527052558),
(34621, '78253', 218, 51, 17931, 29.4626, 0.514219376198081, -98.7473, -1.7234655124546),
(34622, '78254', 218, 51, 17931, 29.5362, 0.515503938527549, -98.7239, -1.72305710540963),
(34623, '78255', 218, 51, 17931, 29.6433, 0.517373186156435, -98.6629, -1.72199245456591),
(34624, '78256', 218, 51, 17931, 29.6228, 0.517015393659776, -98.6249, -1.72132922945016),
(34625, '78257', 218, 51, 17931, 29.6546, 0.51757040836191, -98.6161, -1.72117564047598),
(34626, '78258', 218, 51, 17931, 29.6649, 0.517750177274866, -98.4995, -1.71914058656815),
(34627, '78259', 218, 51, 17931, 29.627, 0.51708869748836, -98.4479, -1.71823999667413),
(34628, '78260', 218, 51, 17931, 29.7038, 0.518429110353892, -98.4823, -1.71884038993681),
(34629, '78261', 218, 51, 17931, 29.7091, 0.518521612804247, -98.3991, -1.71738827599915),
(34630, '78262', 218, 51, 17931, 29.4651, 0.514263009429381, -98.4923, -1.71901492286201),
(34631, '78263', 218, 51, 17931, 29.3528, 0.512303004679391, -98.3309, -1.71619796144929),
(34632, '78264', 218, 51, 17931, 29.192, 0.509496515242185, -98.5177, -1.71945823649202),
(34633, '78265', 218, 51, 17931, 29.5398, 0.515566770380621, -98.4222, -1.71779144705636),
(34634, '78266', 218, 51, 17931, 29.6334, 0.517200398560488, -98.3069, -1.71577908242881),
(34635, '78268', 218, 51, 17931, 29.471, 0.514365983855249, -98.6172, -1.72119483909775),
(34636, '78269', 218, 51, 17931, 29.567, 0.516041499937163, -98.6132, -1.72112502592767),
(34637, '78270', 218, 51, 17931, 29.588, 0.516408019080082, -98.4735, -1.71868680096264),
(34638, '78275', 218, 51, 17931, 29.5397, 0.515565025051369, -98.4223, -1.71779319238562),
(34639, '78278', 218, 51, 17931, 29.5615, 0.515945506828304, -98.5611, -1.72021570938738),
(34640, '78279', 218, 51, 17931, 29.5332, 0.515451578649989, -98.4925, -1.71901841352052),
(34641, '78280', 218, 51, 17931, 29.5641, 0.515990885388856, -98.3586, -1.71668141765209),
(34642, '78283', 218, 51, 17931, 29.4134, 0.5133606742061, -98.5032, -1.71920516375048),
(34643, '78284', 218, 51, 17931, 29.4701, 0.514350275891981, -98.5183, -1.71946870846753),
(34644, '78285', 218, 51, 17931, 29.4206, 0.513486337912244, -98.5278, -1.71963451474647),
(34645, '78286', 218, 51, 17931, 29.5347, 0.515477758588769, -98.4112, -1.71759946083864),
(34646, '78287', 218, 51, 17931, 29.4906, 0.51470806838864, -98.4574, -1.71840580295307),
(34647, '78288', 218, 51, 17931, 29.4234, 0.5135352071313, -98.4933, -1.71903237615453),
(34648, '78289', 218, 51, 17931, 29.5336, 0.515458559966997, -98.4106, -1.71758898886313),
(34649, '78291', 218, 51, 17931, 29.426, 0.513580585691851, -98.4857, -1.71889973113138),
(34650, '78292', 218, 51, 17931, 29.426, 0.513580585691851, -98.4858, -1.71890147646063),
(34651, '78293', 218, 51, 17931, 29.4265, 0.513589312338111, -98.4856, -1.71889798580213),
(34652, '78294', 218, 51, 17931, 29.4261, 0.513582331021103, -98.4862, -1.71890845777764),
(34653, '78295', 218, 51, 17931, 29.4262, 0.513584076350355, -98.4857, -1.71889973113138),
(34654, '78296', 218, 51, 17931, 29.4259, 0.513578840362599, -98.4858, -1.71890147646063),
(34655, '78297', 218, 51, 17931, 29.4256, 0.513573604374843, -98.4863, -1.71891020310689),
(34656, '78298', 218, 51, 17931, 29.4582, 0.514142581710994, -98.5052, -1.71924007033552),
(34657, '78299', 218, 51, 17931, 29.4264, 0.513587567008859, -98.4864, -1.71891194843614),
(34658, '78330', 218, 51, 92126, 27.8168, 0.485494747368759, -97.5415, -1.70242033233405),
(34659, '78332', 218, 51, 39065, 27.7502, 0.48433235808693, -98.0736, -1.71170722928391),
(34660, '78333', 218, 51, 39065, 27.7453, 0.484246836953583, -98.0764, -1.71175609850297),
(34661, '78335', 218, 51, 92302, 27.9096, 0.487114412914609, -97.15, -1.69558736831249),
(34662, '78336', 218, 51, 92302, 27.9041, 0.48701841980575, -97.1598, -1.69575841057919),
(34663, '78338', 218, 51, 7163, 26.8266, 0.468212497115511, -97.7505, -1.70606807047072),
(34664, '78339', 218, 51, 92428, 27.9156, 0.487219132669729, -97.7799, -1.7065811972708),
(34665, '78340', 218, 51, 25, 28.1001, 0.490439265139659, -97.2049, -1.69654555407184),
(34666, '78341', 218, 51, 92564, 27.5294, 0.480478671098527, -98.3815, -1.7170810980508),
(34667, '78342', 218, 51, 92560, 27.682, 0.48314204353707, -98.1041, -1.71223955470577),
(34668, '78343', 218, 51, 812, 27.5844, 0.481438602187124, -97.7977, -1.70689186587766),
(34669, '78344', 218, 51, 92862, 27.421, 0.478586734189365, -98.8534, -1.72531730679096),
(34670, '78347', 218, 51, 93195, 27.6353, 0.482326974776389, -97.4517, -1.70085302666576),
(34671, '78349', 218, 51, 93402, 27.5294, 0.480478671098527, -98.3811, -1.71707411673379),
(34672, '78350', 218, 51, 93752, 28.2247, 0.492613945387644, -98.1476, -1.71299877293039),
(34673, '78351', 218, 51, 93823, 27.6434, 0.482468346445801, -97.7698, -1.70640491901635),
(34674, '78352', 218, 51, 93932, 27.9523, 0.487859668505211, -97.5801, -1.70309402942532),
(34675, '78353', 218, 51, 94059, 26.9834, 0.470949173382638, -98.2109, -1.7141035663469),
(34676, '78355', 218, 51, 94165, 27.2255, 0.475174615501716, -98.1455, -1.71296212101609),
(34677, '78357', 218, 51, 94337, 27.8631, 0.486302834812432, -98.5628, -1.72024537998467),
(34678, '78358', 218, 51, 2628, 28.0785, 0.490062274021228, -97.0303, -1.69349820919785),
(34679, '78359', 218, 51, 9237, 27.9201, 0.487297672486069, -97.2928, -1.69807969848434),
(34680, '78360', 218, 51, 94644, 26.9245, 0.469921174453213, -98.8841, -1.72585312287133),
(34681, '78361', 218, 51, 94814, 27.3098, 0.476645928061147, -98.6812, -1.72231184981903),
(34682, '78362', 218, 51, 9660, 27.8686, 0.486398827921292, -97.2053, -1.69655253538884),
(34683, '78363', 218, 51, 41617, 27.5128, 0.480188946442696, -97.8637, -1.70804378318397),
(34684, '78364', 218, 51, 41617, 27.5211, 0.480333808770611, -97.8702, -1.70815722958535),
(34685, '78368', 218, 51, 56124, 28.0916, 0.490290912153239, -97.8326, -1.7075009857866),
(34686, '78369', 218, 51, 96257, 27.4425, 0.478961979978544, -99.0259, -1.72832799975065),
(34687, '78370', 218, 51, 96711, 27.948, 0.487784619347375, -97.5858, -1.70319351319268),
(34688, '78371', 218, 51, 37499, 27.4208, 0.478583243530861, -98.8538, -1.72532428810797),
(34689, '78372', 218, 51, 61184, 27.9522, 0.487857923175959, -98.0732, -1.7117002479669),
(34690, '78373', 218, 51, 97172, 27.8273, 0.485678006940218, -97.0658, -1.69411780108231),
(34691, '78374', 218, 51, 5188, 27.8834, 0.486657136650587, -97.3188, -1.69853348408986),
(34692, '78375', 218, 51, 97230, 27.3534, 0.477406891615017, -98.1284, -1.712663669714),
(34693, '78376', 218, 51, 97400, 27.5169, 0.480260504942028, -98.6392, -1.72157881153319),
(34694, '78377', 218, 51, 97445, 28.2996, 0.493921196997387, -97.28, -1.69785629634008),
(34695, '78379', 218, 51, 97547, 27.3191, 0.476808243681583, -97.884, -1.70839808502213),
(34696, '78380', 218, 51, 97562, 27.7938, 0.4850933216408, -97.6933, -1.70506974213858),
(34697, '78381', 218, 51, 11639, 28.0085, 0.488840543544832, -97.0601, -1.69401831731495),
(34698, '78382', 218, 51, 11639, 28.0283, 0.489186118736727, -97.0613, -1.69403926126597),
(34699, '78383', 218, 51, 97831, 28.0223, 0.489081398981607, -97.8776, -1.70828638395),
(34700, '78384', 218, 51, 97784, 27.7597, 0.48449816436587, -98.2411, -1.714630655781),
(34701, '78385', 218, 51, 97884, 27.1551, 0.473945903708312, -97.6912, -1.70503309022428),
(34702, '78387', 218, 51, 98111, 28.0321, 0.489252441248302, -97.5057, -1.70179550446184),
(34703, '78389', 218, 51, 33981, 28.2566, 0.49317070541903, -97.6496, -1.70430703325545),
(34704, '78390', 218, 51, 6212, 27.9763, 0.48827854752569, -97.3957, -1.69987564228464),
(34705, '78391', 218, 51, 98673, 28.174, 0.491729063456882, -97.7508, -1.70607330645847),
(34706, '78393', 218, 51, 53027, 28.2371, 0.492830366214891, -97.326, -1.698659147796),
(34707, '78401', 218, 51, 93453, 27.7956, 0.485124737567336, -97.4023, -1.69999083401527),
(34708, '78402', 218, 51, 93453, 27.8249, 0.48563611903817, -97.3876, -1.69973427061523),
(34709, '78403', 218, 51, 93453, 27.787, 0.484974639251664, -97.3946, -1.69985644366287),
(34710, '78404', 218, 51, 93453, 27.7679, 0.484641281364533, -97.4001, -1.69995243677173),
(34711, '78405', 218, 51, 93453, 27.7771, 0.484801851655717, -97.4292, -1.70046032758406),
(34712, '78406', 218, 51, 93453, 27.7753, 0.484770435729181, -97.5184, -1.70201716127684),
(34713, '78407', 218, 51, 93453, 27.8033, 0.485259127919739, -97.4353, -1.70056679266843),
(34714, '78408', 218, 51, 93453, 27.7953, 0.48511950157958, -97.4376, -1.70060693524123),
(34715, '78409', 218, 51, 93453, 27.8107, 0.485388282284387, -97.5168, -1.70198923600881),
(34716, '78410', 218, 51, 93453, 27.8387, 0.485876974474945, -97.5947, -1.70334884749611),
(34717, '78411', 218, 51, 93453, 27.7404, 0.484161315820235, -97.3881, -1.69974299726149),
(34718, '78412', 218, 51, 93453, 27.7069, 0.483576630520817, -97.35, -1.69907802681648),
(34719, '78413', 218, 51, 93453, 27.6881, 0.483248508621442, -97.4, -1.69995069144248),
(34720, '78414', 218, 51, 93453, 27.673, 0.482984963904391, -97.3681, -1.69939393141109),
(34721, '78415', 218, 51, 93453, 27.7314, 0.484004236187556, -97.4143, -1.70020027352551),
(34722, '78416', 218, 51, 93453, 27.7541, 0.484400425927758, -97.4349, -1.70055981135142),
(34723, '78417', 218, 51, 93453, 27.729, 0.483962348285508, -97.4453, -1.70074132559363),
(34724, '78418', 218, 51, 93453, 27.6404, 0.482415986568241, -97.277, -1.69780393646252),
(34725, '78419', 218, 51, 93453, 27.6945, 0.48336020969357, -97.2649, -1.69759275162303),
(34726, '78426', 218, 51, 93453, 27.8441, 0.485971222254553, -97.5958, -1.70336804611788),
(34727, '78427', 218, 51, 93453, 27.7971, 0.485150917506116, -97.4004, -1.69995767275949),
(34728, '78460', 218, 51, 93453, 27.8284, 0.48569720556199, -97.5986, -1.70341691533694),
(34729, '78461', 218, 51, 93453, 27.7976, 0.485159644152376, -97.3996, -1.69994371012547),
(34730, '78463', 218, 51, 93453, 27.7741, 0.484749491778157, -97.398, -1.69991578485744),
(34731, '78465', 218, 51, 93453, 27.7764, 0.484789634350953, -97.4195, -1.70029103064662),
(34732, '78466', 218, 51, 93453, 27.7438, 0.484220657014803, -97.3804, -1.69960860690909),
(34733, '78467', 218, 51, 93453, 27.7508, 0.484342830062442, -97.4192, -1.70028579465886),
(34734, '78468', 218, 51, 93453, 27.7049, 0.483541723935777, -97.3592, -1.69923859710766),
(34735, '78469', 218, 51, 93453, 27.794, 0.485096812299304, -97.4474, -1.70077797750792),
(34736, '78470', 218, 51, 93453, 27.7966, 0.485142190859856, -97.3994, -1.69994021946697),
(34737, '78471', 218, 51, 93453, 27.7963, 0.4851369548721, -97.3992, -1.69993672880846),
(34738, '78472', 218, 51, 93453, 27.6963, 0.483391625620106, -97.3963, -1.69988611426015),
(34739, '78473', 218, 51, 93453, 27.7962, 0.485135209542848, -97.3962, -1.6998843689309),
(34740, '78474', 218, 51, 93453, 27.7963, 0.4851369548721, -97.3994, -1.69994021946697);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(34741, '78475', 218, 51, 93453, 27.7963, 0.4851369548721, -97.3986, -1.69992625683295),
(34742, '78476', 218, 51, 93453, 27.7971, 0.485150917506116, -97.3994, -1.69994021946697),
(34743, '78477', 218, 51, 93453, 27.7971, 0.485150917506116, -97.3989, -1.69993149282071),
(34744, '78478', 218, 51, 93453, 27.7963, 0.4851369548721, -97.3994, -1.69994021946697),
(34745, '78480', 218, 51, 93453, 27.7997, 0.485196296066668, -97.3964, -1.69988785958941),
(34746, '78501', 218, 51, 96079, 26.2142, 0.457524100776298, -98.2349, -1.71452244536738),
(34747, '78502', 218, 51, 96079, 26.1946, 0.457182016242907, -98.2476, -1.71474410218238),
(34748, '78503', 218, 51, 96079, 26.1777, 0.45688705559932, -98.2423, -1.71465159973203),
(34749, '78504', 218, 51, 96079, 26.2541, 0.458220487147843, -98.2275, -1.71439329100273),
(34750, '78505', 218, 51, 96079, 26.1998, 0.45727277336401, -98.2329, -1.71448753878234),
(34751, '78516', 218, 51, 7039, 26.184, 0.456997011342195, -98.1176, -1.71247517415479),
(34752, '78520', 218, 51, 1191, 25.9274, 0.452518496481578, -97.5133, -1.70192814948499),
(34753, '78521', 218, 51, 1191, 25.9409, 0.452754115930597, -97.4482, -1.70079194014194),
(34754, '78522', 218, 51, 1191, 26.002, 0.453820512103566, -97.5719, -1.70295091242666),
(34755, '78523', 218, 51, 1191, 26.0018, 0.453817021445062, -97.5735, -1.70297883769469),
(34756, '78526', 218, 51, 1191, 25.931, 0.45258132833465, -97.4991, -1.7016803127312),
(34757, '78535', 218, 51, 93394, 26.25, 0.458148928648512, -97.7311, -1.70572947659583),
(34758, '78536', 218, 51, 93691, 26.6432, 0.465011563267353, -98.4022, -1.71744238120596),
(34759, '78537', 218, 51, 93786, 26.1682, 0.45672124932038, -98.0549, -1.71138085271379),
(34760, '78538', 218, 51, 93913, 26.2935, 0.458908146873129, -97.9639, -1.70979260309447),
(34761, '78539', 218, 51, 27051, 26.2959, 0.458950034775177, -98.1641, -1.71328675225697),
(34762, '78540', 218, 51, 27051, 26.3018, 0.459053009201045, -98.159, -1.71319774046511),
(34763, '78541', 218, 51, 27051, 26.2962, 0.458955270762933, -98.1645, -1.71329373357397),
(34764, '78543', 218, 51, 94037, 26.2975, 0.458977960043209, -97.9926, -1.7102935125898),
(34765, '78545', 218, 51, 94158, 26.5813, 0.463931204460369, -98.9863, -1.72763684936686),
(34766, '78547', 218, 51, 94411, 26.3741, 0.460314882250236, -98.6531, -1.72182141229922),
(34767, '78548', 218, 51, 0, 26.2715, 0.45852417443769, -98.6417, -1.72162244476449),
(34768, '78549', 218, 51, 94728, 26.4211, 0.461135186998674, -97.9805, -1.7100823277503),
(34769, '78550', 218, 51, 94734, 26.1934, 0.457161072291883, -97.6861, -1.70494407843243),
(34770, '78551', 218, 51, 94734, 26.2102, 0.457454287606218, -97.7374, -1.70583943233871),
(34771, '78552', 218, 51, 94734, 26.186, 0.457031917927235, -97.7315, -1.70573645791284),
(34772, '78553', 218, 51, 94734, 26.2077, 0.457410654374918, -97.6986, -1.70516224458893),
(34773, '78557', 218, 51, 27432, 26.1036, 0.455593766623592, -98.2473, -1.71473886619462),
(34774, '78558', 218, 51, 95383, 26.3118, 0.459227542126244, -97.9398, -1.70937197874474),
(34775, '78559', 218, 51, 95400, 26.1558, 0.456504828493133, -97.8241, -1.70735263280018),
(34776, '78560', 218, 51, 95426, 26.3131, 0.45925023140652, -98.3922, -1.71726784828076),
(34777, '78561', 218, 51, 95625, 26.4653, 0.461906622528055, -97.9116, -1.70887979589568),
(34778, '78562', 218, 51, 95469, 26.3015, 0.459047773213289, -97.927, -1.70914857660049),
(34779, '78563', 218, 51, 33091, 26.6051, 0.464346592822343, -98.1939, -1.71380686037406),
(34780, '78564', 218, 51, 95831, 26.8993, 0.469481351481711, -99.1402, -1.73032291108568),
(34781, '78565', 218, 51, 95847, 26.3131, 0.45925023140652, -98.3925, -1.71727308426852),
(34782, '78566', 218, 51, 95853, 26.0769, 0.455127763713309, -97.4839, -1.7014150226849),
(34783, '78567', 218, 51, 95857, 26.0945, 0.45543494166166, -97.6707, -1.70467529772763),
(34784, '78568', 218, 51, 95895, 26.11, 0.455705467695719, -97.4782, -1.70131553891754),
(34785, '78569', 218, 51, 30387, 26.3427, 0.45976684886511, -97.8247, -1.7073631047757),
(34786, '78570', 218, 51, 96150, 26.1482, 0.456372183469981, -97.9199, -1.7090246582236),
(34787, '78572', 218, 51, 14256, 26.2184, 0.457597404604881, -98.3273, -1.71613512959622),
(34788, '78573', 218, 51, 14256, 26.2157, 0.457550280715077, -98.3255, -1.71610371366968),
(34789, '78574', 218, 51, 14256, 26.2178, 0.457586932629369, -98.3268, -1.71612640294996),
(34790, '78575', 218, 51, 96784, 26.0063, 0.453895561261401, -97.5324, -1.70226150737212),
(34791, '78576', 218, 51, 96999, 26.3134, 0.459255467394276, -98.3924, -1.71727133893927),
(34792, '78577', 218, 51, 97035, 26.1864, 0.457038899244243, -98.1859, -1.7136672340339),
(34793, '78578', 218, 51, 97178, 26.0824, 0.455223756822169, -97.2425, -1.69720179787059),
(34794, '78579', 218, 51, 97246, 26.1703, 0.456757901234672, -97.9914, -1.71027256863877),
(34795, '78580', 218, 51, 57107, 26.4807, 0.462175403232862, -97.7828, -1.70663181181911),
(34796, '78582', 218, 51, 97518, 26.3822, 0.460456253919648, -98.8252, -1.7248251239419),
(34797, '78583', 218, 51, 97519, 26.237, 0.457922035845752, -97.5793, -1.7030800667913),
(34798, '78584', 218, 51, 184657, 26.3799, 0.460416111346852, -98.8142, -1.72463313772418),
(34799, '78585', 218, 51, 97758, 26.5811, 0.463927713801865, -98.9865, -1.72764034002537),
(34800, '78586', 218, 51, 97778, 26.1323, 0.456094676118914, -97.6315, -1.70399112866084),
(34801, '78588', 218, 51, 97790, 26.7371, 0.466650427434976, -98.4, -1.71740398396242),
(34802, '78589', 218, 51, 97796, 26.1929, 0.457152345645623, -98.1624, -1.71325708165968),
(34803, '78590', 218, 51, 97811, 26.4661, 0.461920585162071, -97.5772, -1.70304341487701),
(34804, '78591', 218, 51, 97859, 26.6086, 0.464407679346163, -98.6142, -1.72114247922019),
(34805, '78592', 218, 51, 17980, 26.0945, 0.45543494166166, -97.6704, -1.70467006173987),
(34806, '78593', 218, 51, 57422, 26.2496, 0.458141947331504, -97.8244, -1.70735786878794),
(34807, '78594', 218, 51, 18022, 26.3455, 0.459815718084166, -97.7882, -1.70672605959872),
(34808, '78595', 218, 51, 98348, 26.2626, 0.458368840134263, -98.5585, -1.72017033082683),
(34809, '78596', 218, 51, 98986, 26.1597, 0.456572896333961, -97.989, -1.71023068073672),
(34810, '78597', 218, 51, 98196, 26.1107, 0.455717685000483, -97.1676, -1.69589454626084),
(34811, '78598', 218, 51, 97180, 26.5636, 0.463622281182766, -97.4287, -1.7004516009378),
(34812, '78599', 218, 51, 98986, 26.1587, 0.456555443041441, -97.9906, -1.71025860600476),
(34813, '78602', 218, 51, 39240, 30.1077, 0.525478495202697, -97.2994, -1.69819489021497),
(34814, '78603', 218, 51, 92520, 29.4216, 0.513503791204764, -97.6182, -1.70375899987033),
(34815, '78604', 218, 51, 303, 29.5234, 0.515280536383294, -97.6839, -1.70490568118889),
(34816, '78605', 218, 51, 92597, 30.7446, 0.536594497208649, -98.0558, -1.71139656067706),
(34817, '78606', 218, 51, 7529, 30.1051, 0.525433116642145, -98.4214, -1.71777748442235),
(34818, '78607', 218, 51, 1018, 30.8327, 0.538132132279656, -98.4958, -1.71907600938583),
(34819, '78608', 218, 51, 71896, 30.933, 0.539882697519406, -97.9706, -1.70990954015436),
(34820, '78609', 218, 51, 92879, 30.7996, 0.537554428297246, -98.4691, -1.71861000647555),
(34821, '78610', 218, 51, 993, 30.0837, 0.525059616182218, -97.8433, -1.70768773601657),
(34822, '78611', 218, 51, 92932, 30.7601, 0.536865023242708, -98.2257, -1.71436187507619),
(34823, '78612', 218, 51, 7973, 30.0761, 0.524926971159067, -97.5247, -1.70212711701971),
(34824, '78613', 218, 51, 26738, 30.4975, 0.532281788626971, -97.8271, -1.70740499267774),
(34825, '78614', 218, 51, 9, 29.4205, 0.513484592582992, -97.5546, -1.70264897046606),
(34826, '78615', 218, 51, 93501, 30.4568, 0.531571439621409, -97.3907, -1.69978837582204),
(34827, '78616', 218, 51, 847, 30.0285, 0.524096194435117, -97.5713, -1.70294044045114),
(34828, '78617', 218, 51, 93684, 30.1723, 0.526605977899485, -97.6179, -1.70375376388257),
(34829, '78618', 218, 51, 54469, 30.2489, 0.527942900106513, -98.9161, -1.72641162823196),
(34830, '78619', 218, 51, 2103, 30.0731, 0.524874611281507, -98.0235, -1.71083281932866),
(34831, '78620', 218, 51, 2106, 30.2268, 0.527557182341822, -98.0617, -1.71149953510292),
(34832, '78621', 218, 51, 2254, 30.3368, 0.529477044519016, -97.3691, -1.69941138470361),
(34833, '78622', 218, 51, 59895, 29.7558, 0.519336681564929, -97.7761, -1.70651487475923),
(34834, '78623', 218, 51, 17, 29.9751, 0.523164188614552, -98.2798, -1.71530609820152),
(34835, '78624', 218, 51, 29848, 30.2796, 0.528478716186875, -98.8726, -1.72565241000735),
(34836, '78626', 218, 51, 2693, 30.6371, 0.534718268262755, -97.6758, -1.70476430951948),
(34837, '78627', 218, 51, 2693, 30.6388, 0.534747938860039, -97.6743, -1.7047381295807),
(34838, '78628', 218, 51, 2693, 30.6648, 0.535201724465557, -97.7048, -1.70527045500256),
(34839, '78629', 218, 51, 41120, 29.5092, 0.515032699629511, -97.4505, -1.70083208271473),
(34840, '78630', 218, 51, 26738, 30.5049, 0.532410942991618, -97.8204, -1.70728805561786),
(34841, '78631', 218, 51, 16368, 30.3175, 0.529140195973381, -99.2247, -1.73179771430362),
(34842, '78632', 218, 51, 9373, 29.6585, 0.517638476202738, -97.4817, -1.70137662544136),
(34843, '78634', 218, 51, 95062, 30.5521, 0.53323473839856, -97.5492, -1.70255472268645),
(34844, '78635', 218, 51, 95065, 30.2228, 0.527487369171742, -98.533, -1.71972527186757),
(34845, '78636', 218, 51, 55594, 30.2775, 0.528442064272583, -98.4102, -1.71758200754612),
(34846, '78638', 218, 51, 73117, 29.646, 0.517420310046239, -97.8059, -1.70703498287632),
(34847, '78639', 218, 51, 9871, 30.6688, 0.535271537635637, -98.4328, -1.71797645195707),
(34848, '78640', 218, 51, 22439, 29.9982, 0.523567359671763, -97.8559, -1.70790764750232),
(34849, '78641', 218, 51, 36822, 30.563, 0.533424979287027, -97.8479, -1.70776802116216),
(34850, '78642', 218, 51, 3761, 30.6858, 0.535568243608476, -97.912, -1.70888677721269),
(34851, '78643', 218, 51, 95760, 30.7163, 0.536100569030334, -98.6066, -1.72100983419704),
(34852, '78644', 218, 51, 3836, 29.8819, 0.521537541751694, -97.675, -1.70475034688546),
(34853, '78645', 218, 51, 36822, 30.4485, 0.531426577293493, -97.9818, -1.71010501703058),
(34854, '78646', 218, 51, 36822, 30.5782, 0.53369026933333, -97.8531, -1.70785877828326),
(34855, '78648', 218, 51, 41903, 29.6803, 0.518018957979673, -97.6475, -1.70427038134116),
(34856, '78650', 218, 51, 4084, 30.3041, 0.528906321853614, -97.221, -1.69682655208141),
(34857, '78651', 218, 51, 10420, 30.4533, 0.531510353097589, -97.7199, -1.70553399971961),
(34858, '78652', 218, 51, 95972, 30.1309, 0.525883411589159, -97.8247, -1.7073631047757),
(34859, '78653', 218, 51, 22847, 30.3274, 0.529312983569328, -97.568, -1.70288284458583),
(34860, '78654', 218, 51, 95995, 30.5821, 0.533758337174158, -98.3389, -1.71633758778945),
(34861, '78655', 218, 51, 10335, 29.8492, 0.520966819086291, -97.848, -1.70776976649141),
(34862, '78656', 218, 51, 4045, 29.8592, 0.521141352011491, -97.8592, -1.70796524336763),
(34863, '78657', 218, 51, 95995, 30.5794, 0.533711213284354, -98.272, -1.71516996251987),
(34864, '78658', 218, 51, 96828, 29.5977, 0.516577316017526, -97.5836, -1.70315511594914),
(34865, '78659', 218, 51, 67568, 30.1715, 0.526592015265469, -97.2151, -1.69672357765554),
(34866, '78660', 218, 51, 97032, 30.4438, 0.53134454681865, -97.6287, -1.70394225944179),
(34867, '78661', 218, 51, 97218, 29.7319, 0.518919547873702, -97.753, -1.70611170370202),
(34868, '78662', 218, 51, 5319, 29.9481, 0.522692949716514, -97.4414, -1.7006732577528),
(34869, '78663', 218, 51, 5565, 30.4393, 0.53126600700231, -98.4705, -1.71863444108508),
(34870, '78664', 218, 51, 973, 30.5115, 0.53252613472225, -97.67, -1.70466308042286),
(34871, '78665', 218, 51, 11802, 30.3431, 0.529587000261891, -98.5206, -1.71950885104033),
(34872, '78666', 218, 51, 97802, 29.8828, 0.521553249714962, -97.9455, -1.70947146251211),
(34873, '78667', 218, 51, 97802, 29.8586, 0.521130880035979, -97.942, -1.70941037598829),
(34874, '78669', 218, 51, 98231, 30.4151, 0.530843637323327, -98.0546, -1.71137561672603),
(34875, '78670', 218, 51, 43197, 29.7811, 0.519778249865683, -97.8356, -1.70755334566416),
(34876, '78671', 218, 51, 6104, 30.2091, 0.527248259064219, -98.6576, -1.72189995211556),
(34877, '78672', 218, 51, 98589, 30.8741, 0.538854698589981, -98.5152, -1.71941460326072),
(34878, '78673', 218, 51, 98869, 30.7389, 0.536495013441285, -97.5771, -1.70304166954776),
(34879, '78674', 218, 51, 28929, 30.6731, 0.535346586793473, -97.5857, -1.70319176786343),
(34880, '78675', 218, 51, 99130, 30.4457, 0.531377708074438, -98.7252, -1.72307979468991),
(34881, '78676', 218, 51, 99147, 30.0276, 0.524080486471849, -98.1266, -1.71263225378747),
(34882, '78677', 218, 51, 26269, 29.3525, 0.512297768691636, -97.5037, -1.70176059787679),
(34883, '78680', 218, 51, 973, 30.4493, 0.531440539927509, -97.6683, -1.70463340982558),
(34884, '78681', 218, 51, 973, 30.512, 0.53253486136851, -97.7113, -1.70538390140394),
(34885, '78682', 218, 51, 973, 30.5171, 0.532623873160362, -97.6718, -1.7046944963494),
(34886, '78683', 218, 51, 973, 30.5082, 0.532468538856934, -97.6782, -1.70480619742153),
(34887, '78691', 218, 51, 97032, 30.4387, 0.531255535026798, -97.6201, -1.70379216112612),
(34888, '78701', 218, 51, 7197, 30.271, 0.528328617871204, -97.7413, -1.70590750017953),
(34889, '78702', 218, 51, 7197, 30.2649, 0.528222152786832, -97.7154, -1.70545545990327),
(34890, '78703', 218, 51, 7197, 30.2913, 0.528682919709358, -97.7646, -1.70631416189525),
(34891, '78704', 218, 51, 7197, 30.2451, 0.527876577594937, -97.7652, -1.70632463387076),
(34892, '78705', 218, 51, 7197, 30.2932, 0.528716080965146, -97.7375, -1.70584117766796),
(34893, '78708', 218, 51, 7197, 30.3874, 0.530360181120525, -97.7055, -1.70528267230732),
(34894, '78709', 218, 51, 7197, 30.2341, 0.527684591377218, -97.8492, -1.70779071044244),
(34895, '78710', 218, 51, 7197, 30.354, 0.529777241150359, -97.6551, -1.70440302636431),
(34896, '78711', 218, 51, 7197, 30.2779, 0.528449045589591, -97.7379, -1.70584815898497),
(34897, '78712', 218, 51, 7197, 30.2863, 0.528595653246759, -97.7353, -1.70580278042441),
(34898, '78713', 218, 51, 7197, 30.2846, 0.528565982649475, -97.7414, -1.70590924550879),
(34899, '78714', 218, 51, 7197, 30.2715, 0.528337344517464, -97.7436, -1.70594764275233),
(34900, '78715', 218, 51, 7197, 30.2074, 0.527218588466935, -97.7974, -1.7068866298899),
(34901, '78716', 218, 51, 7197, 30.3197, 0.529178593216925, -97.8652, -1.70806996312275),
(34902, '78717', 218, 51, 7197, 30.4994, 0.532314949882759, -97.7424, -1.70592669880131),
(34903, '78718', 218, 51, 7197, 30.3873, 0.530358435791273, -97.7058, -1.70528790829508),
(34904, '78719', 218, 51, 7197, 30.1277, 0.525827561053096, -97.6734, -1.70472242161743),
(34905, '78720', 218, 51, 7197, 30.4034, 0.530639433800844, -97.7552, -1.70615010094556),
(34906, '78721', 218, 51, 7197, 30.2739, 0.528379232419511, -97.6856, -1.70493535178617),
(34907, '78722', 218, 51, 7197, 30.2866, 0.528600889234515, -97.7176, -1.70549385714681),
(34908, '78723', 218, 51, 7197, 30.3079, 0.528972644365189, -97.6835, -1.70489869987188),
(34909, '78724', 218, 51, 7197, 30.293, 0.528712590306642, -97.6316, -1.7039928739901),
(34910, '78725', 218, 51, 7197, 30.2334, 0.527672374072454, -97.5986, -1.70341691533694),
(34911, '78726', 218, 51, 7197, 30.4253, 0.531021660907031, -97.8473, -1.70775754918665),
(34912, '78727', 218, 51, 7197, 30.4228, 0.530978027675731, -97.7142, -1.70543451595224),
(34913, '78728', 218, 51, 7197, 30.4436, 0.531341056160146, -97.6789, -1.70481841472629),
(34914, '78729', 218, 51, 7197, 30.4527, 0.531499881122077, -97.7702, -1.70641190033336),
(34915, '78730', 218, 51, 7197, 30.3643, 0.529957010063314, -97.8283, -1.70742593662877),
(34916, '78731', 218, 51, 7197, 30.3458, 0.529634124151695, -97.7674, -1.7063630311143),
(34917, '78732', 218, 51, 7197, 30.3495, 0.529698701334019, -97.8809, -1.70834397981532),
(34918, '78733', 218, 51, 7197, 30.3325, 0.52940199536118, -97.8664, -1.70809090707378),
(34919, '78734', 218, 51, 7197, 30.3771, 0.53018041220757, -97.9541, -1.70962156082778),
(34920, '78735', 218, 51, 7197, 30.2534, 0.528021439922852, -97.8558, -1.70790590217307),
(34921, '78736', 218, 51, 7197, 30.2477, 0.527921956155489, -97.9233, -1.70908399941816),
(34922, '78737', 218, 51, 7197, 30.2168, 0.527382649416623, -97.9166, -1.70896706235828),
(34923, '78738', 218, 51, 7197, 30.3344, 0.529435156616968, -97.9919, -1.71028129528503),
(34924, '78739', 218, 51, 7197, 30.1738, 0.526632157838265, -97.875, -1.70824100538945),
(34925, '78741', 218, 51, 7197, 30.2337, 0.52767761006021, -97.7196, -1.70552876373185),
(34926, '78742', 218, 51, 7197, 30.234, 0.527682846047966, -97.675, -1.70475034688546),
(34927, '78744', 218, 51, 7197, 30.1881, 0.5268817399213, -97.7379, -1.70584815898497),
(34928, '78745', 218, 51, 7197, 30.2067, 0.527206371162171, -97.8007, -1.70694422575522),
(34929, '78746', 218, 51, 7197, 30.2953, 0.528752732879438, -97.8105, -1.70711526802191),
(34930, '78747', 218, 51, 7197, 30.1283, 0.525838033028608, -97.7577, -1.70619373417686),
(34931, '78748', 218, 51, 7197, 30.1712, 0.526586779277713, -97.8246, -1.70736135944645),
(34932, '78749', 218, 51, 7197, 30.2173, 0.527391376062883, -97.8533, -1.70786226894177),
(34933, '78750', 218, 51, 7197, 30.414, 0.530824438701555, -97.7977, -1.70689186587766),
(34934, '78751', 218, 51, 7197, 30.3086, 0.528984861669953, -97.727, -1.7056579180965),
(34935, '78752', 218, 51, 7197, 30.3311, 0.529377560751652, -97.7018, -1.705218095125),
(34936, '78753', 218, 51, 7197, 30.3734, 0.530115835025246, -97.6754, -1.70475732820247),
(34937, '78754', 218, 51, 7197, 30.3475, 0.529663794748979, -97.6626, -1.70453392605821),
(34938, '78755', 218, 51, 7197, 30.357, 0.529829601027919, -97.7611, -1.70625307537143),
(34939, '78756', 218, 51, 7197, 30.3209, 0.529199537167949, -97.7391, -1.70586910293599),
(34940, '78757', 218, 51, 7197, 30.3495, 0.529698701334019, -97.7331, -1.70576438318087),
(34941, '78758', 218, 51, 7197, 30.3779, 0.530194374841585, -97.7089, -1.70534201350189),
(34942, '78759', 218, 51, 7197, 30.4035, 0.530641179130096, -97.7573, -1.70618675285985),
(34943, '78760', 218, 51, 7197, 30.2136, 0.527326798880559, -97.7344, -1.70578707246115),
(34944, '78761', 218, 51, 7197, 30.3394, 0.529522423079568, -97.6788, -1.70481666939704),
(34945, '78762', 218, 51, 7197, 30.2618, 0.52816804758002, -97.7221, -1.70557239696315),
(34946, '78763', 218, 51, 7197, 30.2971, 0.528784148805974, -97.7678, -1.70637001243131),
(34947, '78764', 218, 51, 7197, 30.4458, 0.53137945340369, -97.6597, -1.70448331150991),
(34948, '78765', 218, 51, 7197, 30.3062, 0.528942973767906, -97.7294, -1.70569980599855),
(34949, '78766', 218, 51, 7197, 30.3517, 0.529737098577563, -97.7329, -1.70576089252237),
(34950, '78767', 218, 51, 7197, 30.2708, 0.5283251272127, -97.7434, -1.70594415209383),
(34951, '78768', 218, 51, 7197, 30.2712, 0.528332108529707, -97.7428, -1.70593368011831),
(34952, '78769', 218, 51, 7197, 30.3059, 0.52893773778015, -97.7507, -1.70607156112922),
(34953, '78772', 218, 51, 7197, 30.223, 0.527490859830246, -97.7467, -1.70600174795914),
(34954, '78773', 218, 51, 7197, 30.331, 0.5293758154224, -97.7043, -1.7052617283563),
(34955, '78774', 218, 51, 7197, 30.2785, 0.528459517565103, -97.7393, -1.70587259359449),
(34956, '78778', 218, 51, 7197, 30.2775, 0.528442064272583, -97.7399, -1.70588306557001),
(34957, '78779', 218, 51, 7197, 30.3462, 0.529641105468703, -97.768, -1.70637350308982),
(34958, '78780', 218, 51, 7197, 30.2747, 0.528393195053527, -97.8004, -1.70693898976746),
(34959, '78781', 218, 51, 7197, 30.14, 0.526042236551091, -97.7947, -1.7068395060001),
(34960, '78783', 218, 51, 7197, 30.2446, 0.527867850948677, -97.766, -1.70633859650478),
(34961, '78785', 218, 51, 7197, 30.3218, 0.529215245131217, -97.7197, -1.7055305090611),
(34962, '78786', 218, 51, 7197, 30.3549, 0.529792949113627, -97.6562, -1.70442222498609),
(34963, '78788', 218, 51, 7197, 30.33, 0.52935836212988, -97.6672, -1.70461421120381),
(34964, '78789', 218, 51, 7197, 30.306, 0.528939483109402, -97.7509, -1.70607505178773),
(34965, '78799', 218, 51, 7197, 30.2664, 0.528248332725612, -97.7431, -1.70593891610607),
(34966, '78801', 218, 51, 98712, 29.2138, 0.509876997019119, -99.7901, -1.74166580589439),
(34967, '78802', 218, 51, 98712, 29.2083, 0.50978100391026, -99.7903, -1.7416692965529),
(34968, '78827', 218, 51, 92352, 28.4559, 0.496649146618254, -99.7572, -1.74109159257049),
(34969, '78828', 218, 51, 44600, 29.6691, 0.51782348110345, -100.0094, -1.74549331294402),
(34970, '78829', 218, 51, 7298, 28.9356, 0.505021491040071, -99.6207, -1.73870921814152),
(34971, '78830', 218, 51, 92645, 28.5526, 0.498336880004933, -99.5578, -1.73761140604201),
(34972, '78832', 218, 51, 191167, 29.3079, 0.511519351845246, -100.4182, -1.75262821892617),
(34973, '78833', 218, 51, 191214, 29.6687, 0.517816499786442, -100.0123, -1.74554392749232),
(34974, '78834', 218, 51, 93074, 28.5263, 0.497877858411658, -99.8609, -1.74290149900481),
(34975, '78836', 218, 51, 93107, 28.3457, 0.494725793782557, -99.6139, -1.73859053575238),
(34976, '78837', 218, 51, 130316, 29.9583, 0.522870973300217, -101.3882, -1.76955791267051),
(34977, '78838', 218, 51, 93401, 29.5052, 0.514962886459431, -99.6847, -1.73982622886279),
(34978, '78839', 218, 51, 54290, 28.6844, 0.500637223959062, -99.8257, -1.7422871431081),
(34979, '78840', 218, 51, 15768, 29.3676, 0.512561313408687, -100.893, -1.76091504221464),
(34980, '78841', 218, 51, 15768, 29.3456, 0.512177340973248, -100.9107, -1.76122396549224),
(34981, '78842', 218, 51, 15768, 29.382, 0.512812640820974, -100.9013, -1.76105990454255),
(34982, '78843', 218, 51, 0, 29.3625, 0.512472301616835, -100.8961, -1.76096914742145),
(34983, '78847', 218, 51, 15768, 29.3765, 0.512716647712114, -100.8961, -1.76096914742145),
(34984, '78850', 218, 51, 0, 29.3498, 0.512250644801832, -99.3118, -1.7333178960821),
(34985, '78851', 218, 51, 8610, 30.2253, 0.527531002403042, -102.0763, -1.78156752325349),
(34986, '78852', 218, 51, 191408, 28.7144, 0.50116082273466, -100.4915, -1.75390754526788),
(34987, '78853', 218, 51, 191408, 28.6853, 0.500652931922329, -100.4835, -1.75376791892772),
(34988, '78860', 218, 51, 191423, 28.5156, 0.497691108181695, -100.3114, -1.75076420728504),
(34989, '78861', 218, 51, 94977, 29.3462, 0.51218781294876, -99.1405, -1.73032814707344),
(34990, '78870', 218, 51, 95342, 29.2902, 0.511210428567643, -99.6337, -1.73893611094427),
(34991, '78871', 218, 51, 191728, 29.8087, 0.520259960739234, -101.5583, -1.77252671772816),
(34992, '78872', 218, 51, 95456, 28.9515, 0.505298998391138, -99.8491, -1.74269555015307),
(34993, '78873', 218, 51, 95651, 29.8615, 0.521181494584287, -99.7981, -1.74180543223455),
(34994, '78877', 218, 51, 189301, 28.9577, 0.505407208804762, -100.3919, -1.7521691973329),
(34995, '78879', 218, 51, 97517, 29.6542, 0.517563427044902, -99.7752, -1.74140575183585),
(34996, '78880', 218, 51, 17837, 30.0055, 0.523694768707159, -100.3119, -1.7507729339313),
(34997, '78881', 218, 51, 97714, 29.3169, 0.511676431477926, -99.473, -1.73613136683632),
(34998, '78883', 218, 51, 6245, 29.648, 0.517455216631279, -99.2246, -1.73179596897437),
(34999, '78884', 218, 51, 18415, 29.5673, 0.516046735924919, -99.5686, -1.73779990160123),
(35000, '78885', 218, 51, 98767, 29.7853, 0.519851553694267, -99.5493, -1.73746305305559),
(35001, '78886', 218, 51, 38986, 29.1374, 0.508543565470596, -99.1419, -1.73035258168297),
(35002, '78931', 218, 51, 92687, 29.9395, 0.522542851400842, -96.4048, -1.68258117472663),
(35003, '78932', 218, 51, 93061, 30.1283, 0.525838033028608, -96.6958, -1.68766008284993),
(35004, '78933', 218, 51, 93106, 29.7403, 0.51906615553087, -96.3854, -1.68224258085174),
(35005, '78934', 218, 51, 1718, 29.7086, 0.518512886157987, -96.5499, -1.68511364747127),
(35006, '78935', 218, 51, 92198, 29.7485, 0.519209272529533, -96.455, -1.68345733001113),
(35007, '78938', 218, 51, 94009, 29.8396, 0.5207992674781, -96.7002, -1.68773687733702),
(35008, '78940', 218, 51, 2428, 29.8843, 0.521579429653741, -96.6478, -1.68682232480898),
(35009, '78941', 218, 51, 94226, 29.6878, 0.518149857673573, -97.1075, -1.69484560338039),
(35010, '78942', 218, 51, 94463, 30.1823, 0.526780510824685, -96.9335, -1.69180873048192),
(35011, '78943', 218, 51, 94502, 29.7077, 0.518497178194719, -96.5438, -1.6850071823869),
(35012, '78944', 218, 51, 3343, 29.9924, 0.523466130575147, -96.5286, -1.6847418923406),
(35013, '78945', 218, 51, 3584, 29.912, 0.522062885856544, -96.8716, -1.69072837167494),
(35014, '78946', 218, 51, 761, 30.2371, 0.527736951254777, -96.7684, -1.68892719188688),
(35015, '78947', 218, 51, 3748, 30.4283, 0.531074020784591, -97.0744, -1.69426789939798),
(35016, '78948', 218, 51, 3781, 30.3171, 0.529133214656373, -96.9745, -1.69252431547524),
(35017, '78949', 218, 51, 96401, 29.8006, 0.520118589069822, -97.0926, -1.69458554932185),
(35018, '78950', 218, 51, 96522, 29.8885, 0.521652733482325, -96.4862, -1.68400187273775),
(35019, '78951', 218, 51, 4710, 29.6013, 0.516640147870597, -96.8298, -1.68999882404761),
(35020, '78952', 218, 51, 37731, 29.9347, 0.522459075596747, -96.9675, -1.6924021424276),
(35021, '78953', 218, 51, 97632, 29.8802, 0.52150787115441, -97.3234, -1.69861376923545),
(35022, '78954', 218, 51, 79060, 30.0537, 0.52453601740662, -96.758, -1.68874567764467),
(35023, '78956', 218, 51, 97913, 29.6794, 0.518003250016405, -96.9075, -1.6913549448764),
(35024, '78957', 218, 51, 12002, 30.014, 0.523843121693578, -97.1593, -1.69574968393293),
(35025, '78959', 218, 51, 98865, 29.6957, 0.51828773868448, -97.2925, -1.69807446249658),
(35026, '78960', 218, 51, 98906, 30.0553, 0.524563942674652, -96.9141, -1.69147013660704),
(35027, '78961', 218, 51, 6633, 30.0645, 0.524724512965835, -96.6954, -1.68765310153293),
(35028, '78962', 218, 51, 98966, 29.7034, 0.518422129036884, -96.7804, -1.68913663139712),
(35029, '78963', 218, 51, 6722, 29.9611, 0.522919842519273, -97.0361, -1.69359943829447),
(35030, '79001', 218, 51, 18746, 35.3843, 0.61757253851343, -102.8548, -1.79515491148026),
(35031, '79002', 218, 51, 191056, 35.4316, 0.618398079249623, -100.7465, -1.75835813486047),
(35032, '79003', 218, 51, 7064, 35.5469, 0.620410443877172, -100.1446, -1.74785299809271),
(35033, '79005', 218, 51, 7598, 36.4541, 0.636244070851265, -100.525, -1.7544922305673),
(35034, '79007', 218, 51, 191156, 35.6663, 0.622494367004054, -101.4108, -1.76995235708147),
(35035, '79008', 218, 51, 191156, 35.6711, 0.622578142808149, -101.3899, -1.7695875832678),
(35036, '79009', 218, 51, 58749, 34.5153, 0.602405627313599, -102.8883, -1.79573959677968),
(35037, '79010', 218, 51, 191166, 35.4351, 0.618459165773443, -102.4402, -1.7879187764015),
(35038, '79011', 218, 51, 1143, 35.5472, 0.620415679864928, -100.1448, -1.74785648875122),
(35039, '79012', 218, 51, 191202, 35.1131, 0.612839205582021, -102.0526, -1.78115388022077),
(35040, '79013', 218, 51, 92955, 36.0525, 0.629234828575256, -102.0003, -1.78024107302197),
(35041, '79014', 218, 51, 75313, 35.9084, 0.626719809123132, -100.3824, -1.75200339105396),
(35042, '79015', 218, 51, 108480, 34.9817, 0.6105458429449, -101.9258, -1.77894080272924),
(35043, '79016', 218, 51, 108480, 34.9796, 0.610509191030608, -101.9304, -1.77902108787483),
(35044, '79018', 218, 51, 130156, 35.6855, 0.622829470220436, -102.3277, -1.785955280993),
(35045, '79019', 218, 51, 8099, 35.1191, 0.612943925337141, -101.4011, -1.76978306014402),
(35046, '79021', 218, 51, 93463, 34.0732, 0.594689526690532, -101.9335, -1.77907519308164),
(35047, '79022', 218, 51, 191354, 36.0634, 0.629425069463723, -102.5179, -1.78927489723029),
(35048, '79024', 218, 51, 191357, 36.4442, 0.636071283255317, -100.3266, -1.75102949733134),
(35049, '79025', 218, 51, 54354, 34.9616, 0.610195031765249, -102.6117, -1.79091201606867),
(35050, '79027', 218, 51, 191382, 34.5493, 0.602999039259277, -102.3193, -1.78580867333583),
(35051, '79029', 218, 51, 8621, 35.8631, 0.625929174971978, -101.9661, -1.77964417041779),
(35052, '79031', 218, 51, 191409, 34.2304, 0.597433184274667, -102.4463, -1.78802524148587),
(35053, '79032', 218, 51, 54570, 34.1979, 0.596865952267769, -101.7866, -1.77651130441046),
(35054, '79033', 218, 51, 161554, 36.3911, 0.635144513422508, -100.7607, -1.75860597161425),
(35055, '79034', 218, 51, 191476, 36.4331, 0.635877551708346, -100.1405, -1.74778143959338),
(35056, '79035', 218, 51, 191508, 34.6396, 0.604575071573828, -102.7227, -1.79284933153838),
(35057, '79036', 218, 51, 191509, 35.6368, 0.621979494874715, -101.5945, -1.77315852691738),
(35058, '79039', 218, 51, 191559, 35.2078, 0.61449203238366, -101.1126, -1.76474778525202),
(35059, '79040', 218, 51, 115890, 36.2617, 0.632886057370428, -101.403, -1.76981622139981),
(35060, '79041', 218, 51, 191573, 34.0623, 0.594499285802065, -101.8464, -1.77755501130315),
(35061, '79042', 218, 51, 9320, 34.7434, 0.606386723337398, -101.8583, -1.77776270548414),
(35062, '79043', 218, 51, 9362, 34.3893, 0.600206512456086, -102.1149, -1.78224122034476),
(35063, '79044', 218, 51, 9365, 35.8807, 0.626236352920329, -102.3994, -1.78720668206668),
(35064, '79045', 218, 51, 48009, 34.8227, 0.607770769434229, -102.4014, -1.78724158865172),
(35065, '79046', 218, 51, 9486, 36.1208, 0.630426888454368, -100.0245, -1.74575685766107),
(35066, '79051', 218, 51, 120207, 36.2605, 0.632865113419404, -102.5332, -1.78954193260585),
(35067, '79052', 218, 51, 81923, 34.3656, 0.599792869423363, -101.7481, -1.77583935264844),
(35068, '79053', 218, 51, 191751, 34.3944, 0.600295524247938, -102.8929, -1.79581988192527),
(35069, '79054', 218, 51, 191754, 35.439, 0.61852723361427, -100.8061, -1.75939835109466),
(35070, '79056', 218, 51, 3797, 36.2216, 0.632186180340378, -100.289, -1.75037325353259),
(35071, '79057', 218, 51, 73416, 35.2345, 0.614958035293942, -100.6001, -1.75580297283555),
(35072, '79058', 218, 51, 191836, 35.8055, 0.62492386532283, -101.9525, -1.77940680563952),
(35073, '79059', 218, 51, 17102, 35.6923, 0.622948152609572, -100.6362, -1.75643303669552),
(35074, '79061', 218, 51, 191890, 35.5338, 0.620181805745161, -100.4405, -1.75301742734936),
(35075, '79062', 218, 51, 33346, 36.0761, 0.629646726278726, -101.5193, -1.77184603931988),
(35076, '79063', 218, 51, 37361, 34.5532, 0.603067107100105, -102.113, -1.78220805908897),
(35077, '79064', 218, 51, 191984, 34.1808, 0.596567500965678, -102.1337, -1.78256934224413),
(35078, '79065', 218, 51, 105046, 35.5427, 0.620337140048589, -100.9647, -1.76216644328832),
(35079, '79066', 218, 51, 105046, 35.5325, 0.620159116464885, -100.9768, -1.76237762812781),
(35080, '79068', 218, 51, 4850, 35.3478, 0.616935493336452, -101.3823, -1.76945493824465),
(35081, '79070', 218, 51, 157113, 36.3901, 0.635127060129988, -100.8076, -1.75942453103344),
(35082, '79072', 218, 51, 5102, 34.1946, 0.596808356402453, -101.7182, -1.7753174992021),
(35083, '79073', 218, 51, 5102, 34.1911, 0.596747269878633, -101.6933, -1.77488291221835),
(35084, '79077', 218, 51, 192156, 34.8404, 0.608079692711832, -100.2046, -1.74890019564391),
(35085, '79078', 218, 51, 188, 35.7035, 0.623143629485795, -101.5309, -1.77204849751311),
(35086, '79079', 218, 51, 18053, 35.2176, 0.614663074650355, -100.2462, -1.74962625261274),
(35087, '79080', 218, 51, 192223, 35.573, 0.620865974811943, -101.1726, -1.76579498280322),
(35088, '79081', 218, 51, 61839, 36.1949, 0.631720177430096, -101.1953, -1.76619117254342),
(35089, '79082', 218, 51, 38339, 34.2486, 0.59775083419853, -102.3153, -1.78573886016575),
(35090, '79083', 218, 51, 38386, 35.8257, 0.625276421831732, -101.4436, -1.77052482507612),
(35091, '79084', 218, 51, 14683, 36.3371, 0.634202035626432, -102.0722, -1.78149596475416),
(35092, '79085', 218, 51, 6148, 34.7136, 0.605866615220304, -102.4816, -1.78864134271182),
(35093, '79086', 218, 51, 77381, 36.0202, 0.628671087226861, -101.8239, -1.77716231222145),
(35094, '79087', 218, 51, 192317, 36.3785, 0.634924601936757, -103.0202, -1.79804168606306),
(35095, '79088', 218, 51, 192339, 34.5425, 0.602880356870141, -101.7671, -1.77617096520632),
(35096, '79091', 218, 51, 192348, 34.8897, 0.608940140033066, -101.9044, -1.77856730226931),
(35097, '79092', 218, 51, 25704, 35.2453, 0.615146530853157, -102.4246, -1.78764650503818),
(35098, '79093', 218, 51, 177747, 36.2787, 0.633182763343267, -100.8154, -1.75956066671509),
(35099, '79094', 218, 51, 290, 34.8123, 0.607589255192022, -101.5421, -1.77224397438933),
(35100, '79095', 218, 51, 902, 34.8527, 0.608294368209828, -100.2147, -1.74907647389836),
(35101, '79096', 218, 51, 6759, 35.4412, 0.618565630857814, -100.2727, -1.75008876486452),
(35102, '79097', 218, 51, 168898, 35.4309, 0.618385861944859, -101.1755, -1.76584559735152),
(35103, '79098', 218, 51, 192436, 35.2167, 0.614647366687087, -102.2444, -1.78450142172609),
(35104, '79101', 218, 51, 191069, 35.2059, 0.614458871127872, -101.8366, -1.77738396903646),
(35105, '79102', 218, 51, 191069, 35.1999, 0.614354151372752, -101.8429, -1.77749392477933),
(35106, '79103', 218, 51, 191069, 35.1871, 0.614130749228497, -101.8045, -1.77682371834657),
(35107, '79104', 218, 51, 191069, 35.2, 0.614355896702004, -101.7894, -1.77656017362952),
(35108, '79105', 218, 51, 191069, 35.064, 0.611982248919292, -101.7858, -1.77649734177644),
(35109, '79106', 218, 51, 191069, 35.2112, 0.614551373578227, -101.9009, -1.77850621574549),
(35110, '79107', 218, 51, 191069, 35.2281, 0.614846334221814, -101.8088, -1.7768987675044),
(35111, '79108', 218, 51, 191069, 35.2778, 0.615713762860056, -101.8331, -1.77732288251264),
(35112, '79109', 218, 51, 191069, 35.162, 0.613692671586246, -101.8905, -1.77832470150328),
(35113, '79110', 218, 51, 191069, 35.1519, 0.613516393331795, -101.8703, -1.77797214499438),
(35114, '79111', 218, 51, 191069, 35.2179, 0.614668310638111, -101.6899, -1.77482357102378),
(35115, '79114', 218, 51, 191069, 35.1638, 0.613724087512782, -101.8818, -1.77817285785836),
(35116, '79116', 218, 51, 191069, 35.2142, 0.614603733455787, -101.8835, -1.77820252845564),
(35117, '79117', 218, 51, 191069, 35.2222, 0.614743359795947, -101.8122, -1.77695810869897),
(35118, '79118', 218, 51, 191069, 35.066, 0.612017155504332, -101.8498, -1.77761435249772),
(35119, '79119', 218, 51, 191069, 35.0688, 0.612066024723387, -101.9249, -1.77892509476597),
(35120, '79120', 218, 51, 191069, 35.1956, 0.614279102214916, -101.76, -1.77604704682943),
(35121, '79121', 218, 51, 191069, 35.1726, 0.613877676486958, -101.9304, -1.77902108787483),
(35122, '79123', 218, 51, 191069, 35.1929, 0.614231978325112, -101.7996, -1.77673819721322),
(35123, '79124', 218, 51, 191069, 35.2505, 0.615237287974261, -101.9087, -1.77864235142715),
(35124, '79159', 218, 51, 191069, 35.2352, 0.614970252598706, -102.0349, -1.78084495694316),
(35125, '79163', 218, 51, 191069, 35.1887, 0.614158674496529, -101.817, -1.77704188450307),
(35126, '79165', 218, 51, 191069, 35.2065, 0.614469343103384, -101.8398, -1.77743981957252),
(35127, '79166', 218, 51, 191069, 35.2041, 0.614427455201336, -101.8319, -1.77730193856161),
(35128, '79167', 218, 51, 191069, 35.2218, 0.614736378478939, -101.8308, -1.77728273993984),
(35129, '79168', 218, 51, 191069, 35.1551, 0.613572243867858, -101.7983, -1.77671550793294),
(35130, '79170', 218, 51, 191069, 35.2074, 0.614485051066652, -101.8379, -1.77740665831673),
(35131, '79171', 218, 51, 191069, 35.1542, 0.613556535904591, -102.0191, -1.78056919492135),
(35132, '79172', 218, 51, 191069, 35.204, 0.614425709872084, -101.832, -1.77730368389087),
(35133, '79174', 218, 51, 191069, 35.204, 0.614425709872084, -101.8326, -1.77731415586638),
(35134, '79175', 218, 51, 191069, 35.2023, 0.6143960392748, -102.0022, -1.78027423427776),
(35135, '79178', 218, 51, 191069, 35.1885, 0.614155183838025, -101.847, -1.77756548327866),
(35136, '79180', 218, 51, 191069, 35.2062, 0.614464107115628, -101.8355, -1.77736477041469),
(35137, '79181', 218, 51, 191069, 35.209, 0.614512976334683, -101.8355, -1.77736477041469),
(35138, '79182', 218, 51, 191069, 35.2224, 0.614746850454451, -101.8308, -1.77728273993984),
(35139, '79184', 218, 51, 191069, 35.2043, 0.61443094585984, -101.8362, -1.77737698771945),
(35140, '79185', 218, 51, 191069, 35.0835, 0.612322588123431, -101.9201, -1.77884131896187),
(35141, '79186', 218, 51, 191069, 35.2042, 0.614429200530588, -101.8327, -1.77731590119563),
(35142, '79187', 218, 51, 191069, 35.2683, 0.615547956581116, -101.7175, -1.77530528189733),
(35143, '79189', 218, 51, 191069, 35.2021, 0.614392548616296, -101.8187, -1.77707155510035),
(35144, '79201', 218, 51, 8069, 34.425, 0.600829594999048, -100.2113, -1.74901713270379),
(35145, '79220', 218, 51, 570, 33.7871, 0.589696139700576, -100.7347, -1.75815218600873),
(35146, '79221', 218, 51, 58423, 34.1205, 0.595515067426725, -101.4459, -1.77056496764892),
(35147, '79222', 218, 51, 1354, 34.5213, 0.602510347068718, -100.2114, -1.74901887803305),
(35148, '79223', 218, 51, 191246, 34.0679, 0.594597024240176, -100.278, -1.75018126731487),
(35149, '79224', 218, 51, 191251, 33.8783, 0.591287879978395, -100.2233, -1.74922657221403),
(35150, '79225', 218, 51, 54027, 34.2527, 0.597822392697862, -99.5142, -1.73685044248814),
(35151, '79226', 218, 51, 8087, 34.935, 0.609730774184219, -100.8895, -1.76085395569082),
(35152, '79227', 218, 51, 93564, 33.9869, 0.593183307546061, -99.724, -1.74051214325883),
(35153, '79229', 218, 51, 46303, 33.6206, 0.586790166496006, -100.8355, -1.75991147789474),
(35154, '79230', 218, 51, 8544, 34.732, 0.60618775580267, -100.0647, -1.74645848002037),
(35155, '79231', 218, 51, 20649, 33.9418, 0.592396164053411, -101.2995, -1.768009805624),
(35156, '79232', 218, 51, 115345, 33.6163, 0.58671511733817, -100.2625, -1.74991074128081),
(35157, '79233', 218, 51, 170258, 34.4485, 0.601239747373267, -100.6895, -1.75736329718683),
(35158, '79234', 218, 51, 191468, 34.2012, 0.596923548133085, -100.9987, -1.762759855234),
(35159, '79235', 218, 51, 191474, 33.9828, 0.593111749046729, -101.3371, -1.76866604942275),
(35160, '79236', 218, 51, 29968, 33.6141, 0.586676720094626, -100.2625, -1.74991074128081),
(35161, '79237', 218, 51, 191595, 34.8622, 0.608460174488767, -100.6791, -1.75718178294462),
(35162, '79238', 218, 51, 3558, 34.5217, 0.602517328385726, -100.2108, -1.74900840605753),
(35163, '79239', 218, 51, 3619, 34.6628, 0.60497998796029, -100.7627, -1.75864087819929),
(35164, '79240', 218, 51, 191756, 34.8622, 0.608460174488767, -100.6786, -1.75717305629836),
(35165, '79241', 218, 51, 110157, 34.121, 0.595523794072985, -101.4427, -1.77050911711285),
(35166, '79243', 218, 51, 164332, 33.7764, 0.589509389470613, -100.9615, -1.76211059275226),
(35167, '79244', 218, 51, 191838, 34.0121, 0.593623130517563, -100.8213, -1.75966364114096),
(35168, '79245', 218, 51, 4163, 34.7265, 0.606091762693811, -100.5407, -1.75476624725986),
(35169, '79247', 218, 51, 10922, 34.1171, 0.595455726232157, -99.341, -1.73382753222369),
(35170, '79248', 218, 51, 552, 34.0133, 0.593644074468587, -100.3041, -1.75063679824964),
(35171, '79250', 218, 51, 14402, 33.8711, 0.591162216272251, -101.5967, -1.77319692416092),
(35172, '79251', 218, 51, 37835, 34.9297, 0.609638271733863, -100.4455, -1.75310469381196),
(35173, '79252', 218, 51, 97275, 34.2943, 0.598548449666691, -99.7432, -1.74084724647521),
(35174, '79255', 218, 51, 192094, 34.3654, 0.599789378764859, -101.0528, -1.76370407835933),
(35175, '79256', 218, 51, 90387, 33.9037, 0.591731193608402, -100.8549, -1.76025007176963),
(35176, '79257', 218, 51, 57571, 34.4721, 0.601651645076737, -101.305, -1.76810579873286),
(35177, '79258', 218, 51, 12039, 34.1815, 0.596579718270442, -101.3055, -1.76811452537912),
(35178, '79259', 218, 51, 25368, 34.3594, 0.59968465900974, -100.3941, -1.75220759457644),
(35179, '79261', 218, 51, 12408, 34.3956, 0.600316468198962, -100.8931, -1.76091678754389),
(35180, '79311', 218, 51, 112672, 33.9251, 0.592104694068328, -101.9098, -1.77866155004892),
(35181, '79312', 218, 51, 62514, 34.0142, 0.593659782431855, -102.4137, -1.78745626414972),
(35182, '79313', 218, 51, 34573, 33.812, 0.590130726684323, -102.1616, -1.78305628910544),
(35183, '79314', 218, 51, 7536, 33.6395, 0.587120033724633, -102.8731, -1.79547430673338),
(35184, '79316', 218, 51, 26621, 33.1779, 0.579063593897427, -102.2706, -1.78495869799011),
(35185, '79320', 218, 51, 154, 33.8757, 0.591242501417843, -102.6596, -1.79174802878037),
(35186, '79322', 218, 51, 191340, 33.6562, 0.587411503709716, -101.2428, -1.76702020393812),
(35187, '79323', 218, 51, 191374, 32.9681, 0.575401893126743, -102.8278, -1.79468367258223),
(35188, '79324', 218, 51, 191435, 33.8485, 0.590767771861301, -102.7671, -1.79362425772626),
(35189, '79325', 218, 51, 75816, 30.2502, 0.527965589386789, -103.2501, -1.8020541980134),
(35190, '79326', 218, 51, 191458, 34.0886, 0.594958307395339, -102.2782, -1.78509134301326),
(35191, '79329', 218, 51, 191654, 33.6612, 0.587498770172315, -101.6848, -1.77473455923193),
(35192, '79330', 218, 51, 191679, 33.1796, 0.579093264494711, -101.2981, -1.76798537101447),
(35193, '79331', 218, 51, 191726, 32.7346, 0.571326549323336, -101.9583, -1.77950803473613),
(35194, '79336', 218, 51, 191761, 33.585, 0.586168829282296, -102.3681, -1.78666039401081),
(35195, '79338', 218, 51, 191761, 33.5903, 0.586261331732651, -102.36, -1.7865190223414),
(35196, '79339', 218, 51, 112459, 33.9192, 0.592001719642461, -102.3342, -1.78606872739438),
(35197, '79342', 218, 51, 110188, 32.6727, 0.570246190516351, -102.6442, -1.79147924807556),
(35198, '79343', 218, 51, 22743, 33.6712, 0.587673303097515, -101.537, -1.77215496259748),
(35199, '79344', 218, 51, 10294, 33.8598, 0.590964994066776, -102.9459, -1.79674490642883),
(35200, '79345', 218, 51, 23000, 33.3263, 0.581653662507386, -102.333, -1.78604778344336),
(35201, '79346', 218, 51, 10614, 33.7239, 0.588593091613316, -102.7577, -1.79346019677658),
(35202, '79347', 218, 51, 187096, 34.2259, 0.597354644458327, -102.7293, -1.79296452326901),
(35203, '79350', 218, 51, 89363, 33.7178, 0.588486626528944, -101.8407, -1.77745552753579),
(35204, '79351', 218, 51, 0, 32.9669, 0.575380949175719, -101.8281, -1.77723561605004),
(35205, '79353', 218, 51, 189214, 33.7953, 0.58983925669924, -102.5801, -1.79036049202504),
(35206, '79355', 218, 51, 17647, 33.1961, 0.57938124382129, -102.8296, -1.79471508850876),
(35207, '79356', 218, 51, 37777, 33.1917, 0.579304449334202, -101.3824, -1.7694566835739),
(35208, '79357', 218, 51, 57092, 33.68, 0.58782689207169, -101.3829, -1.76946541022016),
(35209, '79358', 218, 51, 192133, 33.4135, 0.583175589615125, -102.1534, -1.78291317210678),
(35210, '79359', 218, 51, 24729, 32.9415, 0.574937635545712, -102.5624, -1.79005156874743),
(35211, '79360', 218, 51, 5735, 32.7176, 0.571029843350497, -102.6737, -1.7919941202049),
(35212, '79363', 218, 51, 192198, 33.6912, 0.588022368947914, -101.9939, -1.78012937194984),
(35213, '79364', 218, 51, 192225, 33.4341, 0.583535127441036, -101.6451, -1.77404166351889),
(35214, '79366', 218, 51, 192101, 33.5317, 0.585238568790983, -101.6807, -1.7746630007326),
(35215, '79367', 218, 51, 5928, 33.5855, 0.586177555928556, -102.1624, -1.78307025173946),
(35216, '79369', 218, 51, 192250, 33.9336, 0.592253047054748, -102.24, -1.784424627239),
(35217, '79370', 218, 51, 897, 33.4777, 0.584296090994906, -100.8569, -1.76028497835467),
(35218, '79371', 218, 51, 167710, 34.0623, 0.594499285802065, -102.5251, -1.78940056093644),
(35219, '79372', 218, 51, 57789, 33.4563, 0.583922590534979, -102.489, -1.78877049707647),
(35220, '79373', 218, 51, 192301, 33.1698, 0.578922222228015, -101.8037, -1.77680975571255),
(35221, '79376', 218, 51, 12338, 33.179, 0.579082792519199, -102.5628, -1.79005855006444),
(35222, '79377', 218, 51, 6684, 32.8372, 0.573117257135882, -102.1027, -1.78202829017601),
(35223, '79378', 218, 51, 62252, 33.0456, 0.576754523297038, -102.4269, -1.78768664761098),
(35224, '79379', 218, 51, 138821, 33.508, 0.58482492575826, -102.7071, -1.79257706017507),
(35225, '79380', 218, 51, 192430, 33.7361, 0.588806021782059, -102.3252, -1.7859116477617),
(35226, '79381', 218, 51, 565, 33.3218, 0.581575122691047, -101.7249, -1.77543443626198),
(35227, '79382', 218, 51, 192451, 33.5033, 0.584742895283416, -102.0092, -1.7803964073254),
(35228, '79383', 218, 51, 4531, 33.2026, 0.579494690222669, -101.8436, -1.7775061420841),
(35229, '79401', 218, 51, 191810, 33.5862, 0.586189773233319, -101.8471, -1.77756722860792),
(35230, '79402', 218, 51, 191810, 33.5907, 0.586268313049659, -101.8458, -1.77754453932764),
(35231, '79403', 218, 51, 191810, 33.6045, 0.586509168486435, -101.8149, -1.77700523258877),
(35232, '79404', 218, 51, 191810, 33.5524, 0.585599851946145, -101.8227, -1.77714136827043),
(35233, '79405', 218, 51, 191810, 33.5739, 0.585975097735324, -101.8485, -1.77759166321744),
(35234, '79406', 218, 51, 191810, 33.5835, 0.586142649343516, -101.8803, -1.77814667791958),
(35235, '79407', 218, 51, 191810, 33.5696, 0.585900048577488, -101.9487, -1.77934048312794),
(35236, '79408', 218, 51, 191810, 33.5791, 0.586065854856428, -101.9802, -1.77989026184232),
(35237, '79409', 218, 51, 191810, 33.5866, 0.586196754550327, -101.8521, -1.77765449507052),
(35238, '79410', 218, 51, 191810, 33.57, 0.585907029894496, -101.8949, -1.77840149599037),
(35239, '79411', 218, 51, 191810, 33.5698, 0.585903539235992, -101.8627, -1.77783949997123),
(35240, '79412', 218, 51, 191810, 33.5427, 0.585430555008702, -101.8553, -1.77771034560658),
(35241, '79413', 218, 51, 191810, 33.5456, 0.58548116955701, -101.8898, -1.77831248419852),
(35242, '79414', 218, 51, 191810, 33.549, 0.585540510751578, -101.9223, -1.77887971620542),
(35243, '79415', 218, 51, 191810, 33.6058, 0.58653185776671, -101.8767, -1.77808384606651),
(35244, '79416', 218, 51, 191810, 33.5917, 0.586285766342179, -101.9346, -1.77909439170341),
(35245, '79423', 218, 51, 191810, 33.5156, 0.584957570781412, -101.8813, -1.7781641312121),
(35246, '79424', 218, 51, 191810, 33.5212, 0.585055309219523, -101.9271, -1.77896349200951),
(35247, '79430', 218, 51, 191810, 33.5908, 0.586270058378911, -101.8961, -1.77842243994139),
(35248, '79452', 218, 51, 191810, 33.5483, 0.585528293446814, -101.848, -1.77758293657118),
(35249, '79453', 218, 51, 191810, 33.5772, 0.58603269360064, -101.8549, -1.77770336428957),
(35250, '79457', 218, 51, 191810, 33.5878, 0.586217698501351, -101.8532, -1.77767369369229),
(35251, '79464', 218, 51, 191810, 33.534, 0.585278711363778, -101.9177, -1.77879943105982),
(35252, '79490', 218, 51, 191810, 33.5742, 0.58598033372308, -101.9798, -1.77988328052531),
(35253, '79491', 218, 51, 191810, 33.5033, 0.584742895283416, -101.8755, -1.77806290211548),
(35254, '79493', 218, 51, 191810, 33.5487, 0.585535274763822, -101.8828, -1.77819031115088),
(35255, '79499', 218, 51, 191810, 33.6094, 0.586594689619782, -101.9052, -1.77858126490333),
(35256, '79501', 218, 51, 31652, 32.7574, 0.57172448439279, -99.894, -1.74347920298722),
(35257, '79502', 218, 51, 191093, 33.1372, 0.578353244891865, -100.2277, -1.74930336670112),
(35258, '79503', 218, 51, 7207, 32.8935, 0.574099877504755, -99.6939, -1.73998679915397),
(35259, '79504', 218, 51, 15079, 32.3962, 0.565420355134587, -99.3963, -1.73479269930004),
(35260, '79505', 218, 51, 92574, 33.6359, 0.587057201871561, -99.7972, -1.74178972427129),
(35261, '79506', 218, 51, 7523, 32.0842, 0.559974927868365, -100.3216, -1.75094223086874),
(35262, '79508', 218, 51, 92900, 32.3409, 0.564455188058234, -99.7522, -1.74100432610789),
(35263, '79510', 218, 51, 8151, 32.4062, 0.565594888059786, -99.4986, -1.73657817112483),
(35264, '79511', 218, 51, 59048, 32.2935, 0.563627901992789, -101.3136, -1.76825589704853),
(35265, '79512', 218, 51, 177980, 32.3962, 0.565420355134587, -100.8604, -1.76034606487849),
(35266, '79516', 218, 51, 2135, 32.5672, 0.568404868155497, -100.886, -1.760792869167),
(35267, '79517', 218, 51, 148870, 32.819, 0.572799607212019, -101.0859, -1.76428178234174),
(35268, '79518', 218, 51, 2718, 33.2305, 0.579981637083976, -100.5601, -1.75510484113475),
(35269, '79519', 218, 51, 13828, 32.0477, 0.559337882691387, -99.6516, -1.73924852488038),
(35270, '79520', 218, 51, 9306, 32.8835, 0.573925344579555, -100.1277, -1.74755803744913),
(35271, '79521', 218, 51, 9374, 33.1595, 0.57874245331506, -99.7365, -1.74073030941532),
(35272, '79525', 218, 51, 76047, 32.5957, 0.568902286992316, -99.8678, -1.74302192672319),
(35273, '79526', 218, 51, 191598, 32.6356, 0.569598673363861, -100.7581, -1.7585605930537),
(35274, '79527', 218, 51, 55479, 32.6205, 0.56933512864681, -101.0689, -1.7639850763689),
(35275, '79528', 218, 51, 191668, 33.2636, 0.580559341066386, -100.5847, -1.75553419213074),
(35276, '79529', 218, 51, 95347, 33.4168, 0.583233185480441, -99.8142, -1.74208643024412),
(35277, '79530', 218, 51, 95640, 32.128, 0.560739382080738, -99.7067, -1.74021020129823),
(35278, '79532', 218, 51, 60695, 32.4084, 0.56563328530333, -100.717, -1.75784326273113),
(35279, '79533', 218, 51, 95900, 32.7596, 0.571762881636334, -99.6876, -1.7398768434111),
(35280, '79534', 218, 51, 191848, 32.7985, 0.57244181471536, -100.2259, -1.74927195077458),
(35281, '79535', 218, 51, 191835, 32.1657, 0.56139737120874, -100.5499, -1.75492681755105),
(35282, '79536', 218, 51, 191864, 32.468, 0.566673501537519, -100.0105, -1.74551251156579),
(35283, '79537', 218, 51, 33441, 32.284, 0.563462095713849, -100.2481, -1.74965941386853),
(35284, '79538', 218, 51, 96629, 32.0066, 0.558620552368817, -99.5669, -1.73777023100394),
(35285, '79539', 218, 51, 17333, 33.3675, 0.582372738159208, -99.8546, -1.74279154326193),
(35286, '79540', 218, 51, 89650, 33.2666, 0.580611700943946, -100.1439, -1.74784078078795),
(35287, '79541', 218, 51, 96837, 32.132, 0.560809195250818, -99.8327, -1.74240931615574),
(35288, '79543', 218, 51, 28432, 32.744, 0.571490610273023, -100.3803, -1.75196673913966),
(35289, '79544', 218, 51, 28433, 33.3006, 0.581205112889624, -99.8469, -1.74265715290953),
(35290, '79545', 218, 51, 24518, 32.4412, 0.566205753297985, -100.5321, -1.75461614894419),
(35291, '79546', 218, 51, 11694, 32.8564, 0.573452360352265, -100.4619, -1.75339092780929),
(35292, '79547', 218, 51, 11727, 33.1799, 0.579098500482467, -99.8908, -1.74342335245115),
(35293, '79548', 218, 51, 11727, 33.037, 0.576604424981367, -99.8732, -1.7431161745028),
(35294, '79549', 218, 51, 12018, 32.7148, 0.570980974131441, -100.9159, -1.76131472261335),
(35295, '79550', 218, 51, 12018, 32.7178, 0.571033334009001, -100.9173, -1.76133915722287),
(35296, '79553', 218, 51, 98270, 32.9426, 0.574956834167484, -99.7946, -1.74174434571073),
(35297, '79556', 218, 51, 6196, 32.4693, 0.566696190817795, -100.4054, -1.75240481678191),
(35298, '79560', 218, 51, 25305, 32.7142, 0.570970502155929, -100.2266, -1.74928416807935),
(35299, '79561', 218, 51, 38578, 32.4883, 0.567027803375674, -100.1227, -1.74747077098653),
(35300, '79562', 218, 51, 28817, 32.2026, 0.562041397702726, -99.9082, -1.743727039741);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(35301, '79563', 218, 51, 98670, 32.4512, 0.566380286223184, -99.8652, -1.74297654816264),
(35302, '79565', 218, 51, 6730, 32.3579, 0.564751894031073, -101.013, -1.76300943731703),
(35303, '79566', 218, 51, 34455, 32.0189, 0.558835227866812, -100.1497, -1.74794200988457),
(35304, '79567', 218, 51, 99170, 31.96, 0.557807228937388, -99.9628, -1.74467998951259),
(35305, '79601', 218, 51, 18716, 32.4671, 0.566657793574251, -99.719, -1.74042487679623),
(35306, '79602', 218, 51, 18716, 32.43, 0.566010276421761, -99.722, -1.74047723667379),
(35307, '79603', 218, 51, 18716, 32.4692, 0.566694445488543, -99.7652, -1.74123121891065),
(35308, '79604', 218, 51, 18716, 32.4517, 0.566389012869444, -99.7328, -1.740665732233),
(35309, '79605', 218, 51, 18716, 32.4315, 0.566036456360541, -99.7774, -1.74144414907939),
(35310, '79606', 218, 51, 18716, 32.3885, 0.565285964782183, -99.7712, -1.74133593866577),
(35311, '79607', 218, 51, 0, 32.4313, 0.566032965702037, -99.8135, -1.74207421293936),
(35312, '79608', 218, 51, 18716, 32.4188, 0.565814799545538, -99.7488, -1.74094498491332),
(35313, '79697', 218, 51, 18716, 32.4298, 0.566006785763257, -99.751, -1.74098338215686),
(35314, '79698', 218, 51, 18716, 32.4754, 0.566802655902167, -99.7347, -1.74069889348879),
(35315, '79699', 218, 51, 18716, 32.4692, 0.566694445488543, -99.7092, -1.74025383452953),
(35316, '79701', 218, 51, 10461, 31.9888, 0.558309883761962, -102.083, -1.78168446031337),
(35317, '79702', 218, 51, 10461, 31.9766, 0.558096953593219, -102.0768, -1.78157624989975),
(35318, '79703', 218, 51, 10461, 31.9786, 0.558131860178259, -102.1185, -1.78230405219783),
(35319, '79704', 218, 51, 10461, 31.9093, 0.556922347006627, -102.1177, -1.78229008956381),
(35320, '79705', 218, 51, 10461, 32.0313, 0.55905164869406, -102.0906, -1.78181710533652),
(35321, '79706', 218, 51, 10461, 31.992, 0.558365734298026, -102.0747, -1.78153959798546),
(35322, '79707', 218, 51, 10461, 32.0215, 0.558880606427364, -102.1448, -1.7827630737911),
(35323, '79708', 218, 51, 10461, 32.0199, 0.558852681159332, -102.1258, -1.78243146123323),
(35324, '79710', 218, 51, 10461, 32.06, 0.559552558189382, -102.0221, -1.78062155479891),
(35325, '79711', 218, 51, 10461, 31.9968, 0.558449510102122, -102.0772, -1.78158323121676),
(35326, '79712', 218, 51, 10461, 31.9491, 0.55761698804892, -102.1718, -1.78323431268914),
(35327, '79713', 218, 51, 191036, 32.6328, 0.569549804144806, -101.8023, -1.77678532110302),
(35328, '79714', 218, 51, 7102, 32.3241, 0.564161972743899, -102.5501, -1.78983689324944),
(35329, '79718', 218, 51, 191107, 31.0339, 0.541643734734668, -103.644, -1.808929049937),
(35330, '79719', 218, 51, 44611, 31.4794, 0.549419176552303, -103.3299, -1.80344697075649),
(35331, '79720', 218, 51, 34816, 32.2419, 0.56272731209876, -101.4732, -1.77104144253471),
(35332, '79721', 218, 51, 34816, 32.2491, 0.562852975804903, -101.458, -1.77077615248841),
(35333, '79730', 218, 51, 191332, 31.2027, 0.544589850512035, -103.066, -1.79884104686048),
(35334, '79731', 218, 51, 29571, 31.394, 0.5479286653711, -102.3516, -1.78637241468423),
(35335, '79733', 218, 51, 191480, 32.1096, 0.560418241498371, -101.3643, -1.76914077897929),
(35336, '79734', 218, 51, 2554, 30.7078, 0.535952216043915, -103.9153, -1.81366412819766),
(35337, '79735', 218, 51, 191491, 30.8904, 0.539139187258056, -102.8837, -1.79565931163409),
(35338, '79738', 218, 51, 191515, 32.7447, 0.571502827577787, -101.4313, -1.77031014957812),
(35339, '79739', 218, 51, 2657, 31.8692, 0.556222469976577, -101.5198, -1.77185476596614),
(35340, '79740', 218, 51, 191529, 31.063, 0.542151625546999, -102.3878, -1.78700422387345),
(35341, '79741', 218, 51, 122700, 31.9813, 0.558178984068063, -102.6145, -1.79096088528772),
(35342, '79742', 218, 51, 191545, 31.3736, 0.547572618203693, -102.8862, -1.79570294486539),
(35343, '79743', 218, 51, 22138, 31.1719, 0.54405228910242, -102.7615, -1.79352651928815),
(35344, '79744', 218, 51, 191662, 30.9138, 0.539547594303023, -101.899, -1.7784730544897),
(35345, '79745', 218, 51, 103301, 31.854, 0.555957179930274, -103.0937, -1.79932450306328),
(35346, '79748', 218, 51, 22431, 32.4031, 0.565540782852975, -101.6427, -1.77399977561684),
(35347, '79749', 218, 51, 191758, 32.408, 0.565626303986322, -101.7836, -1.7764589445329),
(35348, '79752', 218, 51, 191847, 31.1303, 0.543326232133591, -102.22, -1.7840755613886),
(35349, '79754', 218, 51, 4169, 31.7857, 0.554765120051162, -103.6297, -1.80867946785397),
(35350, '79755', 218, 51, 110428, 31.3866, 0.547799511006452, -101.9583, -1.77950803473613),
(35351, '79756', 218, 51, 191893, 31.5823, 0.551215120352605, -102.8982, -1.79591238437563),
(35352, '79758', 218, 51, 2659, 32.0242, 0.558927730317168, -102.3858, -1.78696931728841),
(35353, '79759', 218, 51, 191954, 31.9174, 0.557063718676038, -102.755, -1.79341307288677),
(35354, '79760', 218, 51, 14343, 31.8267, 0.555480705044479, -102.4326, -1.78778613137834),
(35355, '79761', 218, 51, 14343, 31.855, 0.555974633222794, -102.3541, -1.78641604791553),
(35356, '79762', 218, 51, 14343, 31.8888, 0.556564554509968, -102.3652, -1.7866097794625),
(35357, '79763', 218, 51, 14343, 31.8395, 0.555704107188735, -102.4277, -1.787700610245),
(35358, '79764', 218, 51, 14343, 31.8807, 0.556423182840556, -102.4382, -1.78788386981646),
(35359, '79765', 218, 51, 14343, 31.9335, 0.557344716685609, -102.3891, -1.78702691315373),
(35360, '79766', 218, 51, 14343, 31.8091, 0.555173527096128, -102.3369, -1.78611585128419),
(35361, '79768', 218, 51, 14343, 31.8459, 0.555815808260862, -102.3667, -1.78663595940128),
(35362, '79769', 218, 51, 14343, 31.8466, 0.555828025565626, -102.3667, -1.78663595940128),
(35363, '79770', 218, 51, 56702, 31.8287, 0.555515611629519, -103.9138, -1.81363794825888),
(35364, '79772', 218, 51, 189203, 31.4173, 0.548335327086815, -103.4992, -1.80640181318012),
(35365, '79776', 218, 51, 146018, 31.7378, 0.553929107339456, -102.5918, -1.79056469554752),
(35366, '79777', 218, 51, 192091, 31.5361, 0.550408778238184, -103.1255, -1.79987951776541),
(35367, '79778', 218, 51, 52, 31.2251, 0.544980804264481, -101.9432, -1.77924449001908),
(35368, '79779', 218, 51, 192146, 31.5386, 0.550452411469484, -102.9559, -1.79691943935403),
(35369, '79780', 218, 51, 192178, 31.0239, 0.541469201809469, -103.6606, -1.80921877459283),
(35370, '79781', 218, 51, 5785, 30.6887, 0.535618858156784, -101.846, -1.77754802998615),
(35371, '79782', 218, 51, 6052, 32.1298, 0.560770798007274, -101.7948, -1.77665442140912),
(35372, '79783', 218, 51, 192305, 32.3978, 0.565448280402619, -102.031, -1.78077688910233),
(35373, '79785', 218, 51, 192334, 31.3127, 0.546509712689228, -103.7934, -1.81153657183948),
(35374, '79786', 218, 51, 192335, 30.9446, 0.540085155712637, -103.7671, -1.81107755024621),
(35375, '79788', 218, 51, 192432, 31.568, 0.55096553826957, -103.0059, -1.79779210398003),
(35376, '79789', 218, 51, 192447, 31.7531, 0.554196142715012, -103.1568, -1.80042580582129),
(35377, '79821', 218, 51, 15007, 31.9743, 0.558056811020423, -106.5961, -1.86045291478513),
(35378, '79830', 218, 51, 7073, 30.3486, 0.529682993370751, -103.6586, -1.80918386800779),
(35379, '79831', 218, 51, 7073, 30.3655, 0.529977954014338, -103.6672, -1.80933396632347),
(35380, '79832', 218, 51, 7073, 30.3631, 0.52993606611229, -103.6716, -1.80941076081055),
(35381, '79834', 218, 51, 0, 29.2889, 0.511187739287367, -103.1848, -1.80091449801184),
(35382, '79835', 218, 51, 191219, 31.9286, 0.557259195552261, -106.5913, -1.86036913898103),
(35383, '79836', 218, 51, 180772, 31.5926, 0.551394889265561, -106.2386, -1.85421336270925),
(35384, '79837', 218, 51, 191372, 31.9583, 0.557777558340104, -105.2007, -1.8360985904028),
(35385, '79838', 218, 51, 191447, 31.4988, 0.54975777042719, -106.1526, -1.85271237955253),
(35386, '79839', 218, 51, 145244, 31.4824, 0.549471536429863, -106.1725, -1.85305970007368),
(35387, '79842', 218, 51, 17017, 30.1232, 0.525749021236756, -103.1397, -1.8001273545192),
(35388, '79843', 218, 51, 191830, 30.3134, 0.529068637474049, -104.0245, -1.81557002774084),
(35389, '79845', 218, 51, 192077, 29.5672, 0.516044990595667, -104.3744, -1.82167693479357),
(35390, '79846', 218, 51, 57124, 29.4534, 0.514058805906898, -104.1954, -1.8185527954325),
(35391, '79847', 218, 51, 192154, 31.7517, 0.554171708105484, -104.7642, -1.82848022821784),
(35392, '79848', 218, 51, 17964, 30.1394, 0.526031764575579, -102.3884, -1.78701469584896),
(35393, '79849', 218, 51, 192159, 31.5844, 0.551251772266897, -106.2711, -1.85478059471615),
(35394, '79850', 218, 51, 28572, 29.8203, 0.520462418932465, -104.3028, -1.82042727904914),
(35395, '79851', 218, 51, 192213, 31.229, 0.545048872105309, -105.1878, -1.83587344292929),
(35396, '79852', 218, 51, 192310, 29.3304, 0.511912050926945, -103.592, -1.80802147872597),
(35397, '79853', 218, 51, 192332, 31.4358, 0.548658212998433, -106.0759, -1.85137371201625),
(35398, '79854', 218, 51, 6493, 30.7258, 0.536266375309274, -104.452, -1.82303131029312),
(35399, '79855', 218, 51, 192365, 31.0422, 0.541788597062584, -104.833, -1.82968101474322),
(35400, '79901', 218, 51, 8705, 31.759, 0.554299117140879, -106.486, -1.85853130727868),
(35401, '79902', 218, 51, 8705, 31.788, 0.554805262623957, -106.5007, -1.85878787067872),
(35402, '79903', 218, 51, 8705, 31.7864, 0.554777337355926, -106.4445, -1.8578069956391),
(35403, '79904', 218, 51, 8705, 31.8547, 0.555969397235038, -106.4386, -1.85770402121324),
(35404, '79905', 218, 51, 8705, 31.7697, 0.554485867370842, -106.4264, -1.85749109104449),
(35405, '79906', 218, 51, 8705, 31.815, 0.555276501521996, -106.4342, -1.85762722672615),
(35406, '79907', 218, 51, 8705, 31.7088, 0.553422961856378, -106.331, -1.85582604693809),
(35407, '79908', 218, 51, 8705, 31.8408, 0.55572679646901, -106.3759, -1.85660969977224),
(35408, '79910', 218, 51, 8705, 31.7689, 0.554471904736827, -106.4268, -1.8574980723615),
(35409, '79911', 218, 51, 8705, 31.8389, 0.555693635213223, -106.5638, -1.85988917343673),
(35410, '79912', 218, 51, 8705, 31.8421, 0.555749485749286, -106.5387, -1.85945109579448),
(35411, '79913', 218, 51, 8705, 31.8404, 0.555719815152003, -106.5664, -1.85993455199729),
(35412, '79914', 218, 51, 8705, 31.9024, 0.556801919288239, -106.4139, -1.85727292488799),
(35413, '79915', 218, 51, 8705, 31.7522, 0.554180434751744, -106.3821, -1.85671791018586),
(35414, '79916', 218, 51, 8705, 31.9464, 0.557569864159116, -106.1809, -1.85320630773085),
(35415, '79917', 218, 51, 8705, 31.7054, 0.55336362066181, -106.3262, -1.85574227113399),
(35416, '79918', 218, 51, 8705, 31.8452, 0.555803590956098, -106.3785, -1.85665507833279),
(35417, '79920', 218, 51, 8705, 31.8215, 0.555389947923376, -106.4621, -1.85811417358746),
(35418, '79922', 218, 51, 8705, 31.8222, 0.55540216522814, -106.568, -1.85996247726532),
(35419, '79923', 218, 51, 8705, 31.7821, 0.55470228819809, -106.4593, -1.8580653043684),
(35420, '79924', 218, 51, 8705, 31.9016, 0.556787956654223, -106.4161, -1.85731132213154),
(35421, '79925', 218, 51, 8705, 31.7804, 0.554672617600806, -106.3652, -1.85642294954227),
(35422, '79926', 218, 51, 8705, 31.7234, 0.553677779927169, -106.2962, -1.8552186723584),
(35423, '79927', 218, 51, 8705, 31.6579, 0.552534589267113, -106.2569, -1.85453275796236),
(35424, '79928', 218, 51, 8705, 31.7588, 0.554295626482375, -106.4864, -1.85853828859569),
(35425, '79929', 218, 51, 8705, 31.6929, 0.553145454505311, -106.1586, -1.85281709930765),
(35426, '79930', 218, 51, 8705, 31.8093, 0.555177017754632, -106.4677, -1.85821191202557),
(35427, '79931', 218, 51, 8705, 31.8125, 0.555232868290696, -106.4446, -1.85780874096836),
(35428, '79932', 218, 51, 8705, 31.8634, 0.556121240879961, -106.5975, -1.86047734939466),
(35429, '79934', 218, 51, 8705, 31.9406, 0.557468635062501, -106.4017, -1.85705999471925),
(35430, '79935', 218, 51, 8705, 31.7725, 0.554534736589898, -106.3346, -1.85588887879116),
(35431, '79936', 218, 51, 8705, 31.785, 0.554752902746398, -106.2616, -1.85461478843721),
(35432, '79937', 218, 51, 8705, 31.7847, 0.554747666758642, -106.3363, -1.85591854938845),
(35433, '79938', 218, 51, 8705, 31.8241, 0.555435326483927, -106.1878, -1.85332673544923),
(35434, '79940', 218, 51, 8705, 31.7688, 0.554470159407574, -106.4271, -1.85750330834926),
(35435, '79941', 218, 51, 8705, 31.7583, 0.554286899836115, -106.4821, -1.85846323943785),
(35436, '79942', 218, 51, 8705, 31.7608, 0.554330533067415, -106.4805, -1.85843531416982),
(35437, '79943', 218, 51, 8705, 31.7608, 0.554330533067415, -106.4809, -1.85844229548683),
(35438, '79944', 218, 51, 8705, 31.7613, 0.554339259713675, -106.4807, -1.85843880482833),
(35439, '79945', 218, 51, 8705, 31.7606, 0.554327042408911, -106.4804, -1.85843356884057),
(35440, '79946', 218, 51, 8705, 31.7605, 0.554325297079659, -106.4807, -1.85843880482833),
(35441, '79947', 218, 51, 8705, 31.7615, 0.554342750372179, -106.4806, -1.85843705949907),
(35442, '79948', 218, 51, 8705, 31.7607, 0.554328787738163, -106.4806, -1.85843705949907),
(35443, '79949', 218, 51, 8705, 31.7608, 0.554330533067415, -106.4805, -1.85843531416982),
(35444, '79950', 218, 51, 8705, 31.7613, 0.554339259713675, -106.4807, -1.85843880482833),
(35445, '79951', 218, 51, 8705, 31.7601, 0.554318315762651, -106.4873, -1.85855399655896),
(35446, '79952', 218, 51, 8705, 31.7612, 0.554337514384423, -106.48, -1.85842658752356),
(35447, '79953', 218, 51, 8705, 31.7612, 0.554337514384423, -106.4802, -1.85843007818207),
(35448, '79954', 218, 51, 8705, 31.7597, 0.554311334445643, -106.4878, -1.85856272320522),
(35449, '79955', 218, 51, 8705, 31.7612, 0.554337514384423, -106.4803, -1.85843182351132),
(35450, '79958', 218, 51, 8705, 31.7575, 0.554272937202099, -106.4883, -1.85857144985148),
(35451, '79960', 218, 51, 8705, 31.7602, 0.554320061091903, -106.4878, -1.85856272320522),
(35452, '79961', 218, 51, 8705, 31.7739, 0.554559171199426, -106.3754, -1.85660097312598),
(35453, '79966', 218, 51, 8705, 31.793, 0.554892529086557, -106.3776, -1.85663937036952),
(35454, '79968', 218, 51, 8705, 31.7712, 0.554512047309622, -106.5033, -1.85883324923928),
(35455, '79973', 218, 51, 8705, 31.7937, 0.554904746391321, -106.3773, -1.85663413438176),
(35456, '79974', 218, 51, 8705, 31.7933, 0.554897765074313, -106.3779, -1.85664460635728),
(35457, '79975', 218, 51, 8705, 31.7698, 0.554487612700095, -106.4265, -1.85749283637375),
(35458, '79976', 218, 51, 8705, 31.8172, 0.55531489876554, -106.4429, -1.85777907037107),
(35459, '79977', 218, 51, 8705, 31.7932, 0.554896019745061, -106.3773, -1.85663413438176),
(35460, '79978', 218, 51, 8705, 31.7594, 0.554306098457887, -106.4865, -1.85854003392494),
(35461, '79980', 218, 51, 8705, 31.7477, 0.554101894935404, -106.3764, -1.8566184264185),
(35462, '79982', 218, 51, 8705, 31.8493, 0.55587514945543, -106.437, -1.8576760959452),
(35463, '79983', 218, 51, 8705, 31.8493, 0.55587514945543, -106.438, -1.85769354923772),
(35464, '79984', 218, 51, 8705, 31.849, 0.555869913467674, -106.437, -1.8576760959452),
(35465, '79985', 218, 51, 8705, 31.7694, 0.554480631383087, -106.4264, -1.85749109104449),
(35466, '79986', 218, 51, 8705, 31.5319, 0.5503354744096, -106.2347, -1.85414529486842),
(35467, '79987', 218, 51, 8705, 31.8491, 0.555871658796926, -106.4373, -1.85768133193296),
(35468, '79988', 218, 51, 8705, 31.7686, 0.554466668749071, -106.4278, -1.85751552565402),
(35469, '79989', 218, 51, 8705, 31.7688, 0.554470159407574, -106.4272, -1.85750505367851),
(35470, '79990', 218, 51, 8705, 31.8489, 0.555868168138422, -106.4376, -1.85768656792072),
(35471, '79991', 218, 51, 8705, 31.8489, 0.555868168138422, -106.4376, -1.85768656792072),
(35472, '79992', 218, 51, 8705, 31.8497, 0.555882130772438, -106.4372, -1.85767958660371),
(35473, '79993', 218, 51, 8705, 31.8493, 0.55587514945543, -106.4373, -1.85768133193296),
(35474, '79994', 218, 51, 8705, 31.8495, 0.555878640113934, -106.4371, -1.85767784127446),
(35475, '79995', 218, 51, 8705, 31.7669, 0.554436998151787, -106.4245, -1.85745792978871),
(35476, '79996', 218, 51, 8705, 31.8494, 0.555876894784682, -106.4371, -1.85767784127446),
(35477, '79997', 218, 51, 8705, 31.7666, 0.554431762164031, -106.4245, -1.85745792978871),
(35478, '79998', 218, 51, 8705, 31.7688, 0.554470159407574, -106.4275, -1.85751028966627),
(35479, '79999', 218, 51, 8705, 31.7686, 0.554466668749071, -106.4273, -1.85750679900776),
(35480, '80001', 218, 7, 186362, 39.8037, 0.694705619476067, -105.0864, -1.83410367906777),
(35481, '80002', 218, 7, 186362, 39.7952, 0.694557266489647, -105.0987, -1.83431835456576),
(35482, '80003', 218, 7, 186362, 39.8271, 0.695114026521034, -105.0638, -1.83370923465682),
(35483, '80004', 218, 7, 186362, 39.8145, 0.694894115035282, -105.125, -1.83477737615904),
(35484, '80005', 218, 7, 186362, 39.8412, 0.695360117945565, -105.1162, -1.83462378718486),
(35485, '80006', 218, 7, 186362, 39.8467, 0.695456111054425, -105.0818, -1.83402339392218),
(35486, '80007', 218, 7, 186362, 39.8206, 0.695000580119654, -105.1064, -1.83445274491817),
(35487, '80010', 218, 7, 474, 39.7367, 0.693536248877231, -104.8622, -1.8301906508848),
(35488, '80011', 218, 7, 474, 39.7395, 0.693585118096287, -104.7916, -1.82895844843289),
(35489, '80012', 218, 7, 474, 39.6985, 0.692869533102969, -104.8316, -1.82965658013369),
(35490, '80013', 218, 7, 474, 39.6586, 0.692173146731423, -104.7815, -1.82878217017844),
(35491, '80014', 218, 7, 474, 39.6676, 0.692330226364103, -104.8349, -1.829714175999),
(35492, '80015', 218, 7, 474, 39.6247, 0.691581480114997, -104.7909, -1.82894623112813),
(35493, '80016', 218, 7, 474, 39.5877, 0.690935708291759, -104.7604, -1.82841390570627),
(35494, '80017', 218, 7, 474, 39.6932, 0.692777030652613, -104.7861, -1.82886245532403),
(35495, '80018', 218, 7, 474, 39.7117, 0.693099916564232, -104.7086, -1.82750982515373),
(35496, '80019', 218, 7, 474, 39.7708, 0.694131406152161, -104.6793, -1.8269984436829),
(35497, '80020', 218, 7, 7706, 39.9379, 0.697047851332243, -105.0633, -1.83370050801056),
(35498, '80021', 218, 7, 7706, 39.8824, 0.696079193597386, -105.1061, -1.83444750893041),
(35499, '80022', 218, 7, 186566, 39.8316, 0.695192566337373, -104.8943, -1.83075090157469),
(35500, '80024', 218, 7, 13687, 39.8443, 0.695414223152377, -104.9183, -1.83116978059517),
(35501, '80025', 218, 7, 186677, 39.9332, 0.6969658208574, -105.2794, -1.83747216452412),
(35502, '80026', 218, 7, 3594, 40.0004, 0.69813868211474, -105.0997, -1.83433580785828),
(35503, '80027', 218, 7, 3876, 39.9745, 0.697686641838473, -105.1463, -1.83514913128971),
(35504, '80028', 218, 7, 3876, 39.9775, 0.697739001716033, -105.1309, -1.83488035058491),
(35505, '80030', 218, 7, 13249, 39.8588, 0.695667295893916, -105.0394, -1.83328337431933),
(35506, '80031', 218, 7, 13249, 39.8614, 0.695712674454468, -105.0397, -1.83328861030709),
(35507, '80033', 218, 7, 74798, 39.7736, 0.694180275371217, -105.1009, -1.83435675180931),
(35508, '80034', 218, 7, 74798, 39.774, 0.694187256688225, -105.0809, -1.83400768595891),
(35509, '80035', 218, 7, 13249, 39.8618, 0.695719655771476, -105.0396, -1.83328686497784),
(35510, '80036', 218, 7, 13249, 39.862, 0.69572314642998, -105.0386, -1.83326941168532),
(35511, '80037', 218, 7, 186566, 39.8203, 0.694995344131898, -104.9148, -1.83110869407135),
(35512, '80038', 218, 7, 7706, 39.9207, 0.6967476547009, -105.0858, -1.83409320709226),
(35513, '80040', 218, 7, 474, 39.7243, 0.693319828049983, -104.7664, -1.82851862546139),
(35514, '80041', 218, 7, 474, 39.6985, 0.692869533102969, -104.8374, -1.8297578092303),
(35515, '80042', 218, 7, 474, 39.7401, 0.693595590071799, -104.809, -1.82926213572274),
(35516, '80044', 218, 7, 474, 39.7532, 0.69382422820381, -104.825, -1.82954138840306),
(35517, '80045', 218, 7, 474, 39.7468, 0.693712527131682, -104.8367, -1.82974559192554),
(35518, '80046', 218, 7, 474, 39.6278, 0.691635585321809, -104.7966, -1.82904571489549),
(35519, '80047', 218, 7, 474, 39.7008, 0.692909675675765, -104.7674, -1.82853607875391),
(35520, '80101', 218, 7, 129435, 39.4044, 0.687736519772854, -104.0199, -1.81548974259525),
(35521, '80102', 218, 7, 15192, 39.7517, 0.69379804826503, -104.4503, -1.82300163969583),
(35522, '80103', 218, 7, 19679, 39.6647, 0.692279611815795, -104.1365, -1.81752479650308),
(35523, '80104', 218, 7, 77985, 39.391, 0.687502645653086, -104.8593, -1.83014003633649),
(35524, '80105', 218, 7, 186609, 39.6154, 0.691419164494562, -104.043, -1.81589291365246),
(35525, '80106', 218, 7, 94000, 39.0585, 0.681699425890205, -104.5943, -1.82551491381871),
(35526, '80107', 218, 7, 8719, 39.3843, 0.687385708593203, -104.59, -1.82543986466087),
(35527, '80108', 218, 7, 77985, 39.3913, 0.687507881640842, -104.8591, -1.83013654567799),
(35528, '80109', 218, 7, 77985, 39.3913, 0.687507881640842, -104.8593, -1.83014003633649),
(35529, '80110', 218, 7, 2297, 39.6404, 0.69185549680756, -104.9613, -1.83192027217352),
(35530, '80111', 218, 7, 2297, 39.6131, 0.691379021921766, -104.8841, -1.83057287799098),
(35531, '80112', 218, 7, 2297, 39.5748, 0.690710560818252, -104.8612, -1.83017319759228),
(35532, '80116', 218, 7, 102110, 39.3542, 0.686860364488352, -104.7116, -1.82756218503129),
(35533, '80117', 218, 7, 3553, 39.3286, 0.686413560199842, -104.4502, -1.82299989436658),
(35534, '80118', 218, 7, 103530, 39.2044, 0.684245861268865, -104.8911, -1.83069505103862),
(35535, '80120', 218, 7, 3815, 39.5999, 0.691148638460502, -105.0068, -1.83271439698318),
(35536, '80121', 218, 7, 3815, 39.6119, 0.691358077970742, -104.9563, -1.83183300571092),
(35537, '80122', 218, 7, 3815, 39.5809, 0.690817025902624, -104.9542, -1.83179635379663),
(35538, '80123', 218, 7, 3815, 39.5955, 0.691071843973415, -105.0874, -1.83412113236029),
(35539, '80124', 218, 7, 3815, 39.5467, 0.690220123298442, -104.8968, -1.83079453480599),
(35540, '80125', 218, 7, 3815, 39.4845, 0.689134528503701, -105.0572, -1.83359404292619),
(35541, '80126', 218, 7, 3815, 39.552, 0.690312625748797, -104.9613, -1.83192027217352),
(35542, '80127', 218, 7, 3815, 39.5926, 0.691021229425107, -105.1383, -1.83500950494955),
(35543, '80128', 218, 7, 3815, 39.5995, 0.691141657143495, -105.1281, -1.83483148136585),
(35544, '80129', 218, 7, 3815, 39.5422, 0.690141583482102, -105.0083, -1.83274057692196),
(35545, '80130', 218, 7, 3815, 39.5426, 0.69014856479911, -104.9229, -1.83125006574076),
(35546, '80131', 218, 7, 187006, 39.4756, 0.688979194200274, -105.0059, -1.83269868901991),
(35547, '80132', 218, 7, 164754, 39.0999, 0.682421992200531, -104.8505, -1.82998644736231),
(35548, '80133', 218, 7, 187158, 39.1177, 0.682732660807386, -104.9131, -1.83107902347406),
(35549, '80134', 218, 7, 4872, 39.5052, 0.689495811658864, -104.738, -1.82802295195382),
(35550, '80135', 218, 7, 38144, 39.2547, 0.685123761882618, -105.2263, -1.83654539469131),
(35551, '80136', 218, 7, 28710, 39.7541, 0.693839936167078, -104.3286, -1.82087757399616),
(35552, '80137', 218, 7, 6653, 39.7616, 0.693970835860977, -104.6524, -1.82652895011411),
(35553, '80138', 218, 7, 4872, 39.5188, 0.689733176437135, -104.7607, -1.82841914169402),
(35554, '80150', 218, 7, 2297, 39.644, 0.691918328660632, -104.9836, -1.83230948059672),
(35555, '80151', 218, 7, 2297, 39.6442, 0.691921819319136, -104.9841, -1.83231820724298),
(35556, '80154', 218, 7, 2297, 39.6441, 0.691920073989884, -104.9841, -1.83231820724298),
(35557, '80155', 218, 7, 2297, 39.5935, 0.691036937388375, -104.8758, -1.83042801566307),
(35558, '80160', 218, 7, 3815, 39.6125, 0.691368549946254, -105.0152, -1.83286100464035),
(35559, '80161', 218, 7, 3815, 39.5952, 0.691066607985659, -104.9627, -1.83194470678305),
(35560, '80162', 218, 7, 3815, 39.6, 0.691150383789755, -105.1076, -1.83447368886919),
(35561, '80163', 218, 7, 3815, 39.5464, 0.690214887310685, -104.9707, -1.83208433312321),
(35562, '80165', 218, 7, 3815, 39.5939, 0.691043918705383, -105.0068, -1.83271439698318),
(35563, '80166', 218, 7, 3815, 39.5934, 0.691035192059123, -105.0068, -1.83271439698318),
(35564, '80201', 218, 7, 2033, 39.6941, 0.692792738615881, -105.0843, -1.83406702715348),
(35565, '80202', 218, 7, 2033, 39.75, 0.693768377667746, -104.9952, -1.83251193878995),
(35566, '80203', 218, 7, 2033, 39.7313, 0.693442001097623, -104.9813, -1.83226933802392),
(35567, '80204', 218, 7, 2033, 39.7347, 0.693501342292191, -105.0216, -1.83297270571248),
(35568, '80205', 218, 7, 2033, 39.76, 0.693942910592945, -104.9706, -1.83208258779396),
(35569, '80206', 218, 7, 2033, 39.7309, 0.693435019780615, -104.9551, -1.8318120617599),
(35570, '80207', 218, 7, 2033, 39.7593, 0.693930693288182, -104.9148, -1.83110869407135),
(35571, '80208', 218, 7, 2033, 39.678, 0.69251174060631, -104.9626, -1.8319429614538),
(35572, '80209', 218, 7, 2033, 39.7054, 0.692989960821356, -104.961, -1.83191503618577),
(35573, '80210', 218, 7, 2033, 39.6785, 0.69252046725257, -104.9618, -1.83192899881978),
(35574, '80211', 218, 7, 2033, 39.7677, 0.694077300945349, -105.0149, -1.83285576865259),
(35575, '80212', 218, 7, 2033, 39.7723, 0.694157586090941, -105.0493, -1.83345616191528),
(35576, '80214', 218, 7, 2033, 39.7453, 0.693686347192902, -105.0624, -1.83368480004729),
(35577, '80215', 218, 7, 2033, 39.7447, 0.69367587521739, -105.1067, -1.83445798090592),
(35578, '80216', 218, 7, 2033, 39.7821, 0.694328628357636, -104.9641, -1.83196914139258),
(35579, '80217', 218, 7, 2033, 39.751, 0.693785830960266, -104.9967, -1.83253811872873),
(35580, '80218', 218, 7, 2033, 39.7317, 0.693448982414631, -104.9693, -1.83205989851368),
(35581, '80219', 218, 7, 2033, 39.6964, 0.692832881188677, -105.0354, -1.83321356114925),
(35582, '80220', 218, 7, 2033, 39.7332, 0.693475162353411, -104.9136, -1.83108775012032),
(35583, '80221', 218, 7, 2033, 39.8394, 0.695328702019029, -105.0087, -1.83274755823897),
(35584, '80222', 218, 7, 2033, 39.681, 0.69256410048387, -104.9255, -1.83129544430131),
(35585, '80223', 218, 7, 2033, 39.6986, 0.692871278432221, -105.0017, -1.83262538519133),
(35586, '80224', 218, 7, 2033, 39.687, 0.69266882023899, -104.9121, -1.83106157018154),
(35587, '80225', 218, 7, 2033, 39.7247, 0.693326809366991, -105.1092, -1.83450161413722),
(35588, '80226', 218, 7, 2033, 39.7025, 0.692939346273049, -105.0905, -1.8341752375671),
(35589, '80227', 218, 7, 2033, 39.6682, 0.692340698339615, -105.0861, -1.83409844308001),
(35590, '80228', 218, 7, 2033, 39.6915, 0.692747360055329, -105.1438, -1.83510549805841),
(35591, '80229', 218, 7, 2033, 39.8589, 0.695669041223168, -104.9596, -1.83189060157624),
(35592, '80230', 218, 7, 2033, 39.7284, 0.693391386549315, -104.9075, -1.83098128503595),
(35593, '80231', 218, 7, 2033, 39.6763, 0.692482070009026, -104.8856, -1.83059905792976),
(35594, '80232', 218, 7, 2033, 39.6881, 0.692688018860761, -105.0828, -1.8340408472147),
(35595, '80233', 218, 7, 2033, 39.9003, 0.696391607533494, -104.9495, -1.83171432332179),
(35596, '80234', 218, 7, 2033, 39.9043, 0.696461420703573, -105.0074, -1.83272486895869),
(35597, '80235', 218, 7, 2033, 39.6481, 0.691989887159964, -105.0828, -1.8340408472147),
(35598, '80236', 218, 7, 2033, 39.6554, 0.692117296195359, -105.0221, -1.83298143235874),
(35599, '80237', 218, 7, 2033, 39.6444, 0.69192530997764, -104.9025, -1.83089401857335),
(35600, '80238', 218, 7, 2033, 39.7393, 0.693581627437783, -104.9846, -1.83232693388924),
(35601, '80239', 218, 7, 2033, 39.7878, 0.694428112125, -104.8262, -1.82956233235408),
(35602, '80241', 218, 7, 2033, 39.9285, 0.696883790382556, -104.9459, -1.83165149146872),
(35603, '80243', 218, 7, 2033, 39.6884, 0.692693254848518, -104.9619, -1.83193074414904),
(35604, '80244', 218, 7, 2033, 39.7493, 0.693756160362982, -104.9936, -1.83248401352192),
(35605, '80246', 218, 7, 2033, 39.7021, 0.692932364956041, -104.9311, -1.83139318273942),
(35606, '80247', 218, 7, 2033, 39.6766, 0.692487305996782, -104.8856, -1.83059905792976),
(35607, '80248', 218, 7, 2033, 39.7519, 0.693801538923534, -105.0013, -1.83261840387432),
(35608, '80249', 218, 7, 2033, 39.7785, 0.694265796504564, -104.7548, -1.82831616726816),
(35609, '80250', 218, 7, 2033, 39.6797, 0.692541411203594, -104.9433, -1.83160611290817),
(35610, '80251', 218, 7, 2033, 39.6617, 0.692227251938235, -104.8507, -1.82998993802082),
(35611, '80252', 218, 7, 2033, 39.7931, 0.694520614575356, -104.8996, -1.83084340402504),
(35612, '80254', 218, 7, 2033, 39.7352, 0.693510068938451, -105.0209, -1.83296048840771),
(35613, '80255', 218, 7, 2033, 39.7425, 0.693637477973846, -104.9931, -1.83247528687566),
(35614, '80256', 218, 7, 2033, 39.7477, 0.69372823509495, -104.9931, -1.83247528687566),
(35615, '80257', 218, 7, 2033, 39.751, 0.693785830960266, -104.9967, -1.83253811872873),
(35616, '80259', 218, 7, 2033, 39.7409, 0.693609552705815, -104.9879, -1.83238452975455),
(35617, '80260', 218, 7, 2033, 39.8669, 0.695808667563327, -105.006, -1.83270043434917),
(35618, '80261', 218, 7, 2033, 39.6923, 0.692761322689345, -104.9858, -1.83234787784026),
(35619, '80262', 218, 7, 2033, 39.7307, 0.693431529122111, -104.9378, -1.83151011979931),
(35620, '80263', 218, 7, 2033, 39.8326, 0.695210019629893, -105.0087, -1.83274755823897),
(35621, '80264', 218, 7, 2033, 39.732, 0.693454218402387, -104.9818, -1.83227806467018),
(35622, '80265', 218, 7, 2033, 39.7515, 0.693794557606526, -104.9968, -1.83253986405798),
(35623, '80266', 218, 7, 2033, 39.7518, 0.693799793594282, -104.997, -1.83254335471649),
(35624, '80270', 218, 7, 2033, 39.7453, 0.693686347192902, -104.9911, -1.83244038029062),
(35625, '80271', 218, 7, 2033, 39.7454, 0.693688092522154, -104.991, -1.83243863496137),
(35626, '80273', 218, 7, 2033, 39.726, 0.693349498647267, -104.9883, -1.83239151107156),
(35627, '80274', 218, 7, 2033, 39.7432, 0.69364969527861, -104.9885, -1.83239500173007),
(35628, '80275', 218, 7, 2033, 39.6716, 0.692400039534182, -104.9284, -1.83134605884962),
(35629, '80279', 218, 7, 2033, 39.7284, 0.693391386549315, -104.9071, -1.83097430371894),
(35630, '80280', 218, 7, 2033, 39.7289, 0.693400113195575, -104.9078, -1.83098652102371),
(35631, '80281', 218, 7, 2033, 39.7438, 0.693660167254122, -104.9883, -1.83239151107156),
(35632, '80285', 218, 7, 2033, 39.7389, 0.693574646120775, -104.9847, -1.83232867921849),
(35633, '80290', 218, 7, 2033, 39.7515, 0.693794557606526, -104.9964, -1.83253288274097),
(35634, '80291', 218, 7, 2033, 39.7434, 0.693653185937114, -104.988, -1.83238627508381),
(35635, '80292', 218, 7, 2033, 39.7478, 0.693729980424202, -104.993, -1.83247354154641),
(35636, '80293', 218, 7, 2033, 39.7511, 0.693787576289518, -104.9966, -1.83253637339948),
(35637, '80294', 218, 7, 2033, 39.7516, 0.693796302935778, -104.9973, -1.83254859070424),
(35638, '80295', 218, 7, 2033, 39.7516, 0.693796302935778, -104.997, -1.83254335471649),
(35639, '80299', 218, 7, 2033, 39.7472, 0.69371950844869, -104.9922, -1.83245957891239),
(35640, '80301', 218, 7, 26581, 40.0465, 0.698943278899909, -105.2125, -1.83630453925453),
(35641, '80302', 218, 7, 26581, 40.0341, 0.698726858072662, -105.306, -1.83793642210515),
(35642, '80303', 218, 7, 26581, 39.9901, 0.697958913201784, -105.2254, -1.83652968672804),
(35643, '80304', 218, 7, 26581, 40.0355, 0.69875129268219, -105.2837, -1.83754721368195),
(35644, '80305', 218, 7, 26581, 40.0155, 0.698402226831791, -105.2699, -1.83730635824518),
(35645, '80306', 218, 7, 26581, 40.0438, 0.698896155010105, -105.307, -1.83795387539767),
(35646, '80307', 218, 7, 26581, 39.9861, 0.697889100031705, -105.2366, -1.83672516360426),
(35647, '80308', 218, 7, 26581, 39.9593, 0.69742135179217, -105.5103, -1.84150212976697),
(35648, '80309', 218, 7, 26581, 40.0077, 0.698266091150135, -105.2658, -1.83723479974585),
(35649, '80310', 218, 7, 26581, 40.0069, 0.69825212851612, -105.2662, -1.83724178106286),
(35650, '80314', 218, 7, 26581, 40.0885, 0.699676317185747, -105.1998, -1.83608288243953),
(35651, '80321', 218, 7, 26581, 40.0149, 0.698391754856279, -105.2088, -1.83623996207221),
(35652, '80322', 218, 7, 26581, 40.0143, 0.698381282880767, -105.209, -1.83624345273071),
(35653, '80323', 218, 7, 26581, 40.0148, 0.698390009527027, -105.209, -1.83624345273071),
(35654, '80328', 218, 7, 26581, 40.0145, 0.698384773539271, -105.2086, -1.83623647141371),
(35655, '80329', 218, 7, 26581, 40.0144, 0.698383028210019, -105.2088, -1.83623996207221),
(35656, '80401', 218, 7, 54988, 39.7441, 0.693665403241878, -105.2192, -1.83642147631442),
(35657, '80402', 218, 7, 54988, 39.7564, 0.693880078739874, -105.2193, -1.83642322164367),
(35658, '80403', 218, 7, 54988, 39.8184, 0.69496218287611, -105.2517, -1.83698870832132),
(35659, '80419', 218, 7, 54988, 39.7391, 0.693578136779279, -105.2152, -1.83635166314434),
(35660, '80420', 218, 7, 7066, 39.2984, 0.68588647076574, -106.0649, -1.85118172579853),
(35661, '80421', 218, 7, 7216, 39.46, 0.688706922836962, -105.4827, -1.84102041889342),
(35662, '80422', 218, 7, 34832, 39.8213, 0.695012797424418, -105.5012, -1.84134330480504),
(35663, '80423', 218, 7, 19391, 39.906, 0.696491091300857, -106.6321, -1.86108123331585),
(35664, '80424', 218, 7, 26597, 39.4712, 0.688902399713186, -106.0437, -1.85081171599711),
(35665, '80425', 218, 7, 108413, 39.368, 0.687101219925128, -105.2699, -1.83730635824518),
(35666, '80426', 218, 7, 1244, 39.8813, 0.696059994975615, -106.967, -1.86692634098077),
(35667, '80427', 218, 7, 1465, 39.7988, 0.694620098342719, -105.5156, -1.84159463221733),
(35668, '80428', 218, 7, 1590, 40.7372, 0.710998268043434, -106.9159, -1.86603447773301),
(35669, '80429', 218, 7, 20102, 39.3208, 0.686277424518186, -106.2392, -1.85422383468476),
(35670, '80430', 218, 7, 1664, 40.483, 0.706561641084864, -106.4246, -1.85745967511796),
(35671, '80432', 218, 7, 39860, 39.2211, 0.684537331253948, -105.7465, -1.84562459746018),
(35672, '80433', 218, 7, 147986, 39.5128, 0.689628456682015, -105.3122, -1.83804463251877),
(35673, '80434', 218, 7, 194147, 40.8597, 0.713136296377127, -106.3127, -1.85550665168498),
(35674, '80435', 218, 7, 20585, 39.6188, 0.691478505689129, -106.0407, -1.85075935611955),
(35675, '80436', 218, 7, 115345, 39.7901, 0.694468254697796, -105.6433, -1.84382341767213),
(35676, '80437', 218, 7, 2343, 39.6337, 0.691738559747677, -105.3425, -1.83857346728213),
(35677, '80438', 218, 7, 2294, 39.7632, 0.693998761129009, -105.7121, -1.8450242041975),
(35678, '80439', 218, 7, 2343, 39.6108, 0.69133887934897, -105.3348, -1.83843907692972),
(35679, '80440', 218, 7, 20999, 39.2114, 0.684368034316505, -105.9981, -1.8500158458582),
(35680, '80442', 218, 7, 115636, 39.9534, 0.697318377366303, -105.8121, -1.84676953344949),
(35681, '80443', 218, 7, 2620, 39.577, 0.690748958061796, -106.0737, -1.85133531477271),
(35682, '80444', 218, 7, 2693, 39.7085, 0.693044066028168, -105.6953, -1.84473098888316),
(35683, '80446', 218, 7, 55021, 40.0917, 0.699732167721811, -105.9282, -1.84879586071106),
(35684, '80447', 218, 7, 9174, 40.2133, 0.701854488092236, -105.8564, -1.84754271430813),
(35685, '80448', 218, 7, 104, 39.485, 0.689143255149961, -105.743, -1.84556351093636),
(35686, '80449', 218, 7, 186823, 38.8632, 0.67829079786106, -105.8046, -1.84663863375559),
(35687, '80451', 218, 7, 194241, 40.0723, 0.699393573846924, -106.1037, -1.85185891354831),
(35688, '80452', 218, 7, 186875, 39.7352, 0.693510068938451, -105.5254, -1.84176567448402),
(35689, '80453', 218, 7, 186877, 39.6676, 0.692330226364103, -105.2514, -1.83698347233356),
(35690, '80454', 218, 7, 537, 39.6319, 0.691707143821141, -105.2508, -1.83697300035805),
(35691, '80455', 218, 7, 3399, 40.1, 0.699877030049726, -105.4063, -1.8396869873449),
(35692, '80456', 218, 7, 3409, 39.2955, 0.685835856217432, -105.7471, -1.8456350694357),
(35693, '80457', 218, 7, 81907, 39.6549, 0.692108569549099, -105.2989, -1.83781250372826),
(35694, '80459', 218, 7, 194277, 40.0744, 0.699430225761216, -106.4058, -1.85713155321858),
(35695, '80461', 218, 7, 186970, 39.2502, 0.685045222066278, -106.2973, -1.85523787098017),
(35696, '80463', 218, 7, 30470, 39.8746, 0.695943057915731, -106.7568, -1.86325765889308),
(35697, '80465', 218, 7, 42178, 39.6035, 0.691211470313574, -105.1992, -1.83607241046402),
(35698, '80466', 218, 7, 96454, 39.9658, 0.69753479819355, -105.493, -1.84120018780638),
(35699, '80467', 218, 7, 23502, 40.264, 0.702739370022997, -106.8883, -1.86555276685945),
(35700, '80468', 218, 7, 194365, 39.9413, 0.697107192526811, -106.1535, -1.8527280875158),
(35701, '80469', 218, 7, 128533, 40.2169, 0.701917319945308, -106.9658, -1.86690539702975),
(35702, '80470', 218, 7, 42563, 39.459, 0.688689469544443, -105.367, -1.83900107294887),
(35703, '80471', 218, 7, 187201, 39.9397, 0.697079267258779, -105.4613, -1.8406469184335),
(35704, '80473', 218, 7, 97363, 40.4681, 0.706301587026317, -106.1843, -1.85326564892541),
(35705, '80474', 218, 7, 187277, 39.8779, 0.696000653781047, -105.4827, -1.84102041889342),
(35706, '80475', 218, 7, 5783, 39.4348, 0.68826709986546, -105.5839, -1.84278669209644),
(35707, '80476', 218, 7, 187359, 39.6954, 0.692815427896157, -105.7346, -1.8454169032792),
(35708, '80477', 218, 7, 194434, 40.4784, 0.706481355939273, -106.8456, -1.86480751126885),
(35709, '80478', 218, 7, 187425, 40.003, 0.698184060675292, -105.8822, -1.84799300925514),
(35710, '80479', 218, 7, 194453, 40.0499, 0.699002620094477, -106.8343, -1.86461028906338),
(35711, '80480', 218, 7, 25769, 40.6444, 0.709378602497583, -106.3003, -1.85529023085773),
(35712, '80481', 218, 7, 861, 40.0959, 0.699805471550394, -105.4763, -1.84090871782129),
(35713, '80482', 218, 7, 18658, 39.9409, 0.697100211209803, -105.7956, -1.84648155412291),
(35714, '80483', 218, 7, 118539, 40.1509, 0.700765402638991, -106.9225, -1.86614966946364),
(35715, '80487', 218, 7, 194434, 40.4911, 0.706703012754276, -106.8675, -1.86518973837504),
(35716, '80488', 218, 7, 194434, 40.4763, 0.706444704024981, -106.8509, -1.86490001371921),
(35717, '80497', 218, 7, 187362, 39.637, 0.691796155612992, -106.0614, -1.85112063927471),
(35718, '80498', 218, 7, 187362, 39.625, 0.691586716102753, -106.076, -1.8513754573455),
(35719, '80501', 218, 7, 194299, 40.1652, 0.701014984722026, -105.1365, -1.83497808902302),
(35720, '80502', 218, 7, 194299, 40.0269, 0.698601194366518, -105.3, -1.83783170235003),
(35721, '80503', 218, 7, 194299, 40.1525, 0.700793327907023, -105.169, -1.83554532102992),
(35722, '80504', 218, 7, 194299, 40.1614, 0.700948662210451, -104.9658, -1.83199881198986),
(35723, '80510', 218, 7, 194083, 40.2201, 0.701973170481371, -105.5254, -1.84176567448402),
(35724, '80511', 218, 7, 194176, 40.3384, 0.704037894986481, -105.5645, -1.84244809822155),
(35725, '80512', 218, 7, 75101, 40.636, 0.709231994840416, -105.3261, -1.8382872332848),
(35726, '80513', 218, 7, 194106, 40.295, 0.703280422091115, -105.1227, -1.83473723358624),
(35727, '80514', 218, 7, 194153, 40.0852, 0.699618721320431, -104.9305, -1.83138271076391),
(35728, '80515', 218, 7, 35626, 40.4419, 0.705844310762295, -105.3716, -1.83908135809446),
(35729, '80516', 218, 7, 15943, 40.0519, 0.699037526679517, -105.0273, -1.83307218947984),
(35730, '80517', 218, 7, 194176, 40.3639, 0.704482953945739, -105.5147, -1.84157892425406),
(35731, '80520', 218, 7, 194182, 40.1119, 0.700084724230713, -104.9357, -1.83147346788501),
(35732, '80521', 218, 7, 194184, 40.5851, 0.708343622251151, -105.1131, -1.83456968197805),
(35733, '80522', 218, 7, 194184, 40.5967, 0.708546080444382, -105.1277, -1.83482450004884),
(35734, '80523', 218, 7, 194184, 40.5734, 0.708139418728667, -105.0857, -1.83409146176301),
(35735, '80524', 218, 7, 194184, 40.6369, 0.709247702803684, -105.049, -1.83345092592752),
(35736, '80525', 218, 7, 194184, 40.5341, 0.707453504332634, -105.0449, -1.83337936742819),
(35737, '80526', 218, 7, 194184, 40.5419, 0.707589640014289, -105.1137, -1.83458015395356),
(35738, '80527', 218, 7, 194184, 40.5315, 0.707408125772082, -105.0729, -1.83386805961875),
(35739, '80528', 218, 7, 194184, 40.5854, 0.708348858238907, -105.0841, -1.83406353649497),
(35740, '80530', 218, 7, 32485, 40.1019, 0.699910191305514, -104.9361, -1.83148044920202),
(35741, '80532', 218, 7, 21412, 40.4592, 0.70614625272289, -105.4442, -1.8403484671314),
(35742, '80533', 218, 7, 194248, 40.1982, 0.701590943375185, -105.185, -1.83582457371024),
(35743, '80534', 218, 7, 3440, 40.3306, 0.703901759304825, -104.8914, -1.83070028702638),
(35744, '80535', 218, 7, 122986, 40.66, 0.709650873860894, -105.1601, -1.83538998672649),
(35745, '80536', 218, 7, 36928, 40.7439, 0.711115205103318, -105.4062, -1.83968524201565),
(35746, '80537', 218, 7, 73286, 40.3886, 0.704914050270982, -105.1048, -1.83442481965014),
(35747, '80538', 218, 7, 73286, 40.4272, 0.705587747362252, -105.0928, -1.8342153801399),
(35748, '80539', 218, 7, 73286, 40.3981, 0.705079856549921, -105.0741, -1.83388900356977),
(35749, '80540', 218, 7, 764, 40.2183, 0.701941754554835, -105.3001, -1.83783344767928),
(35750, '80541', 218, 7, 10349, 40.5529, 0.707781626232008, -105.3907, -1.83941471598159),
(35751, '80542', 218, 7, 76572, 40.2405, 0.702329217648778, -104.9978, -1.8325573173505),
(35752, '80543', 218, 7, 110457, 40.3374, 0.704020441693961, -104.8531, -1.83003182592287),
(35753, '80544', 218, 7, 194345, 40.1029, 0.699927644598034, -105.1761, -1.83566923940681),
(35754, '80545', 218, 7, 194393, 40.8056, 0.712192073251798, -105.5906, -1.84290362915632),
(35755, '80546', 218, 7, 504, 40.5253, 0.707299915358458, -104.8502, -1.82998121137456),
(35756, '80547', 218, 7, 194450, 40.5296, 0.707374964516294, -104.9815, -1.83227282868243),
(35757, '80549', 218, 7, 902, 40.7463, 0.711157093005365, -105.0294, -1.83310884139413),
(35758, '80550', 218, 7, 18652, 40.4808, 0.706523243841321, -104.9006, -1.83086085731756),
(35759, '80551', 218, 7, 18652, 40.4851, 0.706598292999156, -104.9069, -1.83097081306044),
(35760, '80553', 218, 7, 194184, 40.5672, 0.708031208315044, -105.0443, -1.83336889545268),
(35761, '80601', 218, 7, 212, 39.9608, 0.69744753173095, -104.8192, -1.82944015930644),
(35762, '80602', 218, 7, 212, 39.9601, 0.697435314426186, -104.9095, -1.83101619162099),
(35763, '80603', 218, 7, 212, 39.9775, 0.697739001716033, -104.7651, -1.82849593618111),
(35764, '80610', 218, 7, 34621, 40.6174, 0.708907363599545, -104.7016, -1.8273876521061),
(35765, '80611', 218, 7, 71897, 40.6366, 0.709242466815928, -104.3483, -1.8212214038588),
(35766, '80612', 218, 7, 63471, 40.8509, 0.712982707402952, -104.8573, -1.83010512975145),
(35767, '80614', 218, 7, 155118, 39.9342, 0.696983274149919, -104.9571, -1.83184696834494),
(35768, '80615', 218, 7, 8676, 40.5224, 0.70724930081015, -104.6893, -1.8271729766081),
(35769, '80620', 218, 7, 15, 40.3787, 0.704741262675034, -104.698, -1.82732482025302),
(35770, '80621', 218, 7, 194186, 40.0994, 0.699866558074214, -104.8074, -1.82923421045471),
(35771, '80622', 218, 7, 161946, 40.5042, 0.706931650886287, -104.6247, -1.82604549391131),
(35772, '80623', 218, 7, 194200, 40.2851, 0.703107634495168, -104.7761, -1.82868792239883),
(35773, '80624', 218, 7, 9111, 40.4753, 0.706427250732461, -104.5251, -1.82430714597632),
(35774, '80631', 218, 7, 32621, 40.4194, 0.705451611680596, -104.7057, -1.82745921060543),
(35775, '80632', 218, 7, 32621, 40.4232, 0.705517934192172, -104.6963, -1.82729514965574),
(35776, '80633', 218, 7, 32621, 40.4235, 0.705523170179928, -104.6964, -1.82729689498499),
(35777, '80634', 218, 7, 32621, 40.4092, 0.705273588096893, -104.7619, -1.82844008564505),
(35778, '80638', 218, 7, 32621, 40.4216, 0.70549000892414, -104.7439, -1.82812592637969),
(35779, '80639', 218, 7, 32621, 40.4004, 0.705119999122717, -104.7026, -1.82740510539861),
(35780, '80640', 218, 7, 23, 39.8686, 0.695838338160611, -104.8852, -1.83059207661276),
(35781, '80642', 218, 7, 16505, 40.076, 0.699458151029247, -104.6405, -1.82632125593313),
(35782, '80643', 218, 7, 194265, 40.0965, 0.699815943525906, -104.5048, -1.82395284413817),
(35783, '80644', 218, 7, 122953, 40.3455, 0.704161813363372, -104.5301, -1.82439441243892),
(35784, '80645', 218, 7, 95463, 40.3331, 0.703945392536125, -104.6857, -1.82711014475503),
(35785, '80646', 218, 7, 10223, 40.4821, 0.706545933121597, -104.6978, -1.82732132959452),
(35786, '80648', 218, 7, 37467, 40.7512, 0.711242614138713, -104.7405, -1.82806658518512),
(35787, '80649', 218, 7, 4799, 40.3713, 0.704612108310387, -104.0984, -1.81685982605807),
(35788, '80650', 218, 7, 181, 40.6413, 0.709324497290772, -104.7587, -1.82838423510898),
(35789, '80651', 218, 7, 117318, 40.2248, 0.702055200956215, -104.8219, -1.82948728319624),
(35790, '80652', 218, 7, 194404, 40.1152, 0.700142320096029, -104.3177, -1.82068733310769),
(35791, '80653', 218, 7, 194472, 40.3626, 0.704460264665463, -104.0209, -1.81550719588777),
(35792, '80654', 218, 7, 6808, 40.1598, 0.700920736942419, -104.075, -1.8164514190131),
(35793, '80701', 218, 7, 2559, 40.2546, 0.702575309073309, -103.8091, -1.81181058853205),
(35794, '80705', 218, 7, 194297, 40.2703, 0.702849325765872, -103.8282, -1.81214394641918),
(35795, '80720', 218, 7, 215, 40.0523, 0.699044507996525, -103.2062, -1.80128799847177),
(35796, '80721', 218, 7, 62514, 40.6835, 0.710061026235113, -102.1662, -1.78313657425103),
(35797, '80722', 218, 7, 7189, 40.5302, 0.707385436491806, -103.2655, -1.8023229787182),
(35798, '80723', 218, 7, 194122, 40.2504, 0.702502005244726, -103.6166, -1.80845082972196),
(35799, '80726', 218, 7, 54268, 40.907, 0.71396183711332, -102.811, -1.79439045726789),
(35800, '80727', 218, 7, 155131, 40.0302, 0.698658790231834, -102.5191, -1.78929584118132),
(35801, '80728', 218, 7, 21138, 40.6211, 0.708971940781869, -102.8543, -1.795146184834),
(35802, '80729', 218, 7, 2894, 40.8542, 0.713040303268267, -104.1117, -1.81709195484858),
(35803, '80731', 218, 7, 194228, 40.6419, 0.709334969266283, -102.628, -1.79119650473674),
(35804, '80732', 218, 7, 48009, 40.9756, 0.715159132980189, -104.3045, -1.82045694964643),
(35805, '80733', 218, 7, 87836, 40.3321, 0.703927939243605, -103.5129, -1.80664092328764),
(35806, '80734', 218, 7, 125098, 40.5828, 0.708303479678355, -102.2995, -1.78546309814394),
(35807, '80735', 218, 7, 55455, 39.6865, 0.69266009359273, -102.2478, -1.78456076292066),
(35808, '80736', 218, 7, 194252, 40.8062, 0.71220254522731, -103.0446, -1.79846754640055),
(35809, '80737', 218, 7, 139248, 40.8842, 0.713563902043866, -102.1848, -1.7834612054919),
(35810, '80740', 218, 7, 186990, 39.7503, 0.693773613655502, -103.3867, -1.80443831777162),
(35811, '80741', 218, 7, 169483, 40.5007, 0.706870564362467, -103.3793, -1.80430916340697),
(35812, '80742', 218, 7, 194341, 40.6407, 0.70931402531526, -103.8739, -1.81294156188734),
(35813, '80743', 218, 7, 17462, 40.21, 0.70179689222692, -102.9608, -1.79700496048738),
(35814, '80744', 218, 7, 132491, 40.9339, 0.714431330682107, -102.3817, -1.78689775878908),
(35815, '80745', 218, 7, 194363, 40.841, 0.712809919807004, -103.2934, -1.80280992557951),
(35816, '80746', 218, 7, 23730, 40.6065, 0.708717122711077, -102.5488, -1.78981420396916),
(35817, '80747', 218, 7, 194368, 40.9523, 0.714752471264474, -103.0698, -1.79890736937205),
(35818, '80749', 218, 7, 11850, 40.914, 0.71408401016096, -102.5344, -1.78956287655687),
(35819, '80750', 218, 7, 12018, 40.3865, 0.70487739835669, -103.6123, -1.80837578056412),
(35820, '80751', 218, 7, 25116, 40.6342, 0.70920057891388, -103.213, -1.80140668086091),
(35821, '80754', 218, 7, 98312, 40.597, 0.708551316432138, -103.6497, -1.80902853370437),
(35822, '80755', 218, 7, 6535, 39.9288, 0.696889026370312, -102.3589, -1.78649982371962),
(35823, '80757', 218, 7, 12945, 39.7316, 0.693447237085379, -103.5045, -1.80649431563047),
(35824, '80758', 218, 7, 26266, 40.0333, 0.698712895438646, -102.2141, -1.78397258696274),
(35825, '80759', 218, 7, 144, 40.1331, 0.700454734032136, -102.6936, -1.79234144072605),
(35826, '80801', 218, 7, 34573, 39.7112, 0.693091189917972, -103.2816, -1.80260397672778),
(35827, '80802', 218, 7, 62553, 38.9182, 0.679250728949657, -102.2298, -1.7842466036553),
(35828, '80804', 218, 7, 186361, 39.2848, 0.685649105987468, -103.2971, -1.80287450276183),
(35829, '80805', 218, 7, 79788, 39.3151, 0.686177940750823, -102.4391, -1.78789957777972),
(35830, '80807', 218, 7, 1239, 39.305, 0.686001662496371, -102.2463, -1.78453458298188),
(35831, '80808', 218, 7, 186477, 38.9781, 0.680296181171602, -104.3158, -1.8206541718519),
(35832, '80809', 218, 7, 26723, 38.9113, 0.67913030123127, -104.9846, -1.83232693388924),
(35833, '80810', 218, 7, 186533, 38.8495, 0.678051687753537, -102.3797, -1.78686285220404),
(35834, '80812', 218, 7, 29548, 39.6893, 0.692708962811786, -102.8784, -1.79556680918373),
(35835, '80813', 218, 7, 13617, 38.7747, 0.676746181473045, -105.1867, -1.83585424430752),
(35836, '80814', 218, 7, 20592, 38.942, 0.679666117311632, -105.1796, -1.83573032593063),
(35837, '80815', 218, 7, 115577, 39.3237, 0.686328039066494, -103.0572, -1.7986874578863),
(35838, '80816', 218, 7, 54791, 38.8894, 0.678748074125083, -105.2646, -1.83721385579482),
(35839, '80817', 218, 7, 2573, 38.6973, 0.675395296632002, -104.6968, -1.827303876302),
(35840, '80818', 218, 7, 9080, 39.2773, 0.685518206293569, -103.4989, -1.80639657719236),
(35841, '80819', 218, 7, 186793, 38.9346, 0.679536962946984, -105.0149, -1.83285576865259),
(35842, '80820', 218, 7, 94649, 38.7775, 0.676795050692101, -105.5083, -1.84146722318193),
(35843, '80821', 218, 7, 3275, 39.1336, 0.683010168158453, -103.4676, -1.80585028913648),
(35844, '80822', 218, 7, 186898, 39.7462, 0.69370205515617, -102.6244, -1.79113367288367),
(35845, '80823', 218, 7, 186906, 38.6989, 0.675423221900034, -103.4217, -1.80504918300982),
(35846, '80824', 218, 7, 3556, 39.6675, 0.692328481034851, -102.4182, -1.78753480396606),
(35847, '80825', 218, 7, 182497, 38.8011, 0.677206948395572, -102.7751, -1.79376388406642),
(35848, '80826', 218, 7, 182800, 39.2665, 0.685329710734353, -103.6893, -1.80971968408816),
(35849, '80827', 218, 7, 131640, 38.9887, 0.680481186072313, -105.4613, -1.8406469184335),
(35850, '80828', 218, 7, 182800, 39.2646, 0.685296549478566, -103.6891, -1.80971619342965),
(35851, '80829', 218, 7, 187024, 38.8557, 0.678159898167161, -104.9085, -1.83099873832847),
(35852, '80830', 218, 7, 193056, 39.0954, 0.682343452384191, -103.9184, -1.81371823340448),
(35853, '80831', 218, 7, 61292, 38.9735, 0.68021589602601, -104.5305, -1.82440139375593),
(35854, '80832', 218, 7, 5287, 39.0877, 0.682209062031788, -104.0829, -1.81658930002401),
(35855, '80833', 218, 7, 11732, 38.9208, 0.679296107510209, -104.0337, -1.81573059803202),
(35856, '80834', 218, 7, 43002, 39.2856, 0.685663068621484, -102.8874, -1.79572388881641),
(35857, '80835', 218, 7, 187364, 39.1834, 0.683879342125946, -104.082, -1.81657359206074),
(35858, '80836', 218, 7, 132, 39.3092, 0.686074966324955, -102.5803, -1.79036398268354),
(35859, '80840', 218, 7, 0, 38.9983, 0.680648737680505, -104.6944, -1.82726198839995),
(35860, '80841', 218, 7, 0, 39.0136, 0.68091577305606, -104.8693, -1.83031456926169),
(35861, '80860', 218, 7, 12551, 38.7404, 0.676147533539611, -105.1249, -1.83477563082979),
(35862, '80861', 218, 7, 187504, 39.3505, 0.686795787306029, -102.7366, -1.79309193230441);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(35863, '80862', 218, 7, 187547, 38.9144, 0.679184406438081, -103.0439, -1.79845532909578),
(35864, '80863', 218, 7, 38949, 38.996, 0.680608595107709, -105.0737, -1.83388202225277),
(35865, '80864', 218, 7, 13008, 38.7507, 0.676327302452567, -104.2004, -1.8186400618951),
(35866, '80866', 218, 7, 38949, 38.9914, 0.680528309962117, -105.0642, -1.83371621597383),
(35867, '80901', 218, 7, 186560, 38.8341, 0.67778290704873, -104.821, -1.82947157523298),
(35868, '80903', 218, 7, 186560, 38.8299, 0.677709603220146, -104.8198, -1.82945063128195),
(35869, '80904', 218, 7, 186560, 38.8534, 0.678119755594365, -104.8634, -1.83021159483582),
(35870, '80905', 218, 7, 186560, 38.8378, 0.677847484231054, -104.8381, -1.82977002653507),
(35871, '80906', 218, 7, 186560, 38.7923, 0.677053359421396, -104.8264, -1.82956582301258),
(35872, '80907', 218, 7, 186560, 38.8791, 0.678568305212127, -104.8173, -1.82940699805065),
(35873, '80908', 218, 7, 186560, 39.0529, 0.681601687452094, -104.6936, -1.82724802576594),
(35874, '80909', 218, 7, 186560, 38.8502, 0.678063905058301, -104.7586, -1.82838248977973),
(35875, '80910', 218, 7, 186560, 38.8152, 0.677453039820103, -104.7782, -1.82872457431312),
(35876, '80911', 218, 7, 186560, 38.7583, 0.676459947475718, -104.7173, -1.82766166879866),
(35877, '80912', 218, 7, 186560, 39.0496, 0.681544091586778, -104.6953, -1.82727769636322),
(35878, '80913', 218, 7, 186560, 38.608, 0.673836717609971, -104.8101, -1.82928133434451),
(35879, '80914', 218, 7, 186560, 38.7866, 0.676953875654033, -104.7131, -1.82758836497007),
(35880, '80915', 218, 7, 186560, 38.857, 0.678182587447437, -104.7146, -1.82761454490885),
(35881, '80916', 218, 7, 186560, 38.8018, 0.677219165700336, -104.7105, -1.82754298640952),
(35882, '80917', 218, 7, 186560, 38.8857, 0.678683496942759, -104.7392, -1.82804389590484),
(35883, '80918', 218, 7, 186560, 38.9144, 0.679184406438081, -104.7713, -1.82860414659473),
(35884, '80919', 218, 7, 186560, 38.928, 0.679421771216353, -104.8474, -1.8299323421555),
(35885, '80920', 218, 7, 186560, 38.9572, 0.679931407357935, -104.7562, -1.82834060187768),
(35886, '80921', 218, 7, 186560, 39.0463, 0.681486495721462, -104.8181, -1.82942096068467),
(35887, '80922', 218, 7, 186560, 38.8997, 0.678927843038038, -104.7021, -1.82739637875235),
(35888, '80925', 218, 7, 186560, 38.74, 0.676140552222603, -104.6378, -1.82627413204332),
(35889, '80926', 218, 7, 186560, 38.6644, 0.674821083308096, -104.9065, -1.83096383174343),
(35890, '80928', 218, 7, 186560, 38.5882, 0.673491142418076, -104.4441, -1.82289342928221),
(35891, '80929', 218, 7, 186560, 38.814, 0.677432095869079, -104.6203, -1.82596869942422),
(35892, '80930', 218, 7, 186560, 38.8309, 0.677727056512666, -104.5142, -1.82411690508786),
(35893, '80931', 218, 7, 186560, 38.7522, 0.676353482391347, -104.7337, -1.82794790279599),
(35894, '80932', 218, 7, 186560, 38.8487, 0.678037725119521, -104.7788, -1.82873504628863),
(35895, '80933', 218, 7, 186560, 38.9334, 0.67951601899596, -105.0033, -1.83265331045936),
(35896, '80934', 218, 7, 186560, 38.846, 0.677990601229717, -104.8632, -1.83020810417732),
(35897, '80935', 218, 7, 186560, 38.834, 0.677781161719478, -104.818, -1.82941921535542),
(35898, '80936', 218, 7, 186560, 38.9036, 0.678995910878866, -104.7542, -1.82830569529264),
(35899, '80937', 218, 7, 186560, 38.796, 0.67711793660372, -104.8369, -1.82974908258404),
(35900, '80940', 218, 7, 186560, 38.8137, 0.677426859881323, -104.7584, -1.82837899912123),
(35901, '80941', 218, 7, 186560, 38.8628, 0.678283816544052, -104.7547, -1.8283144219389),
(35902, '80942', 218, 7, 186560, 38.8338, 0.677777671060974, -104.8242, -1.82952742576904),
(35903, '80943', 218, 7, 186560, 38.8336, 0.67777418040247, -104.8238, -1.82952044445203),
(35904, '80944', 218, 7, 186560, 38.8343, 0.677786397707234, -104.8204, -1.82946110325746),
(35905, '80945', 218, 7, 186560, 38.8359, 0.677814322975266, -104.7947, -1.8290125536397),
(35906, '80946', 218, 7, 186560, 38.8466, 0.678001073205229, -104.8249, -1.8295396430738),
(35907, '80947', 218, 7, 186560, 38.8337, 0.677775925731722, -104.8208, -1.82946808457447),
(35908, '80949', 218, 7, 186560, 38.9277, 0.679416535228597, -104.8563, -1.83008767645893),
(35909, '80950', 218, 7, 186560, 38.8387, 0.677863192194322, -104.7942, -1.82900382699344),
(35910, '80960', 218, 7, 186560, 38.8079, 0.677325630784707, -104.8188, -1.82943317798943),
(35911, '80962', 218, 7, 186560, 38.9544, 0.679882538138879, -104.7338, -1.82794964812524),
(35912, '80970', 218, 7, 186560, 38.8465, 0.677999327875977, -104.7184, -1.82768086742043),
(35913, '80977', 218, 7, 186560, 38.7747, 0.676746181473045, -104.6632, -1.82671744567333),
(35914, '80995', 218, 7, 186560, 38.9642, 0.680053580405575, -104.7922, -1.8289689204084),
(35915, '80997', 218, 7, 186560, 38.878, 0.678549106590355, -104.8199, -1.8294523766112),
(35916, '81001', 218, 7, 30903, 38.2853, 0.668204540113785, -104.5796, -1.82525835041866),
(35917, '81002', 218, 7, 30903, 38.2541, 0.667659997387163, -104.6087, -1.82576624123099),
(35918, '81003', 218, 7, 30903, 38.2798, 0.668108547004925, -104.6261, -1.82606992852084),
(35919, '81004', 218, 7, 30903, 38.226, 0.667169559867352, -104.6586, -1.82663716052774),
(35920, '81005', 218, 7, 30903, 38.2333, 0.667296968902748, -104.7114, -1.82755869437279),
(35921, '81006', 218, 7, 30903, 38.2423, 0.667454048535427, -104.5263, -1.82432808992735),
(35922, '81007', 218, 7, 30903, 38.3234, 0.668869510558795, -104.7507, -1.82824460876882),
(35923, '81008', 218, 7, 30903, 38.3259, 0.668913143790095, -104.6257, -1.82606294720383),
(35924, '81009', 218, 7, 30903, 38.2776, 0.668070149761381, -104.4935, -1.82375562193269),
(35925, '81010', 218, 7, 30903, 38.2742, 0.668010808566814, -104.6087, -1.82576624123099),
(35926, '81011', 218, 7, 30903, 38.2742, 0.668010808566814, -104.6089, -1.8257697318895),
(35927, '81012', 218, 7, 30903, 38.2746, 0.668017789883822, -104.6088, -1.82576798656024),
(35928, '81013', 218, 7, 30903, 38.2705, 0.66794623138449, -104.6091, -1.825773222548),
(35929, '81014', 218, 7, 30903, 38.2707, 0.667949722042994, -104.6088, -1.82576798656024),
(35930, '81015', 218, 7, 30903, 38.2712, 0.667958448689254, -104.6094, -1.82577845853576),
(35931, '81019', 218, 7, 177980, 37.9446, 0.66225820335224, -104.8439, -1.82987125563168),
(35932, '81020', 218, 7, 186317, 37.4009, 0.652768848209147, -104.6449, -1.82639805042021),
(35933, '81021', 218, 7, 15026, 38.3873, 0.669984775950819, -103.368, -1.8041119412015),
(35934, '81022', 218, 7, 15065, 38.1788, 0.666345764460411, -104.3911, -1.82196840477865),
(35935, '81023', 218, 7, 616, 38.0718, 0.664478262160777, -104.9523, -1.83176319254084),
(35936, '81024', 218, 7, 186430, 37.2167, 0.649553951726974, -104.6969, -1.82730562163125),
(35937, '81025', 218, 7, 7601, 38.2831, 0.668166142870241, -104.2154, -1.8189018612829),
(35938, '81027', 218, 7, 53626, 37.1302, 0.648044241923999, -103.7737, -1.81119274197684),
(35939, '81029', 218, 7, 180457, 37.0902, 0.647346110223201, -102.5697, -1.79017897778283),
(35940, '81030', 218, 7, 58977, 38.1084, 0.665117052667007, -103.5075, -1.80654667550803),
(35941, '81033', 218, 7, 8340, 38.1889, 0.666522042714862, -103.8607, -1.81271117842607),
(35942, '81034', 218, 7, 8340, 38.1934, 0.666600582531202, -103.8581, -1.81266579986552),
(35943, '81036', 218, 7, 86647, 38.4797, 0.671597460179662, -102.7811, -1.79386860382154),
(35944, '81038', 218, 7, 127509, 37.9095, 0.66164559278479, -103.0986, -1.79941002419663),
(35945, '81039', 218, 7, 2578, 38.1244, 0.665396305347326, -104.0224, -1.81553337582655),
(35946, '81040', 218, 7, 9048, 37.787, 0.659507564451097, -105.1822, -1.83577570449118),
(35947, '81041', 218, 7, 21520, 37.9131, 0.661708424637862, -102.3502, -1.7863479800747),
(35948, '81043', 218, 7, 9366, 38.0878, 0.664757514841096, -102.1705, -1.78321162340887),
(35949, '81044', 218, 7, 325, 38.0445, 0.664001787274983, -102.9297, -1.79646216309001),
(35950, '81045', 218, 7, 186825, 38.4371, 0.670853949918312, -103.1248, -1.79986730046065),
(35951, '81046', 218, 7, 186858, 37.1694, 0.64872841099078, -104.5027, -1.82391619222388),
(35952, '81047', 218, 7, 41376, 37.9847, 0.66295808038229, -102.1395, -1.78267057134075),
(35953, '81049', 218, 7, 178450, 37.3064, 0.651119512066012, -103.3861, -1.80442784579611),
(35954, '81050', 218, 7, 95427, 37.9928, 0.663099452051702, -103.5368, -1.80705805697887),
(35955, '81052', 218, 7, 244, 38.0803, 0.664626615147197, -102.6139, -1.79095041331221),
(35956, '81054', 218, 7, 186960, 38.047, 0.664045420506282, -103.2082, -1.80132290505681),
(35957, '81055', 218, 7, 186947, 37.4635, 0.653861424320896, -105.0511, -1.83348757784182),
(35958, '81057', 218, 7, 187039, 38.1318, 0.665525459711974, -102.8727, -1.79546732541637),
(35959, '81058', 218, 7, 187026, 38.1061, 0.665076910094211, -103.8719, -1.8129066553023),
(35960, '81059', 218, 7, 187068, 37.4986, 0.654474034888346, -104.1504, -1.8177673972691),
(35961, '81062', 218, 7, 187135, 38.2082, 0.666858891260497, -103.9394, -1.81408475254739),
(35962, '81063', 218, 7, 171015, 38.2368, 0.667358055426568, -103.7819, -1.8113358589755),
(35963, '81064', 218, 7, 97242, 37.2374, 0.649915234882137, -103.1639, -1.80054972419818),
(35964, '81067', 218, 7, 24475, 38.0453, 0.664015749908999, -103.7167, -1.8101979043032),
(35965, '81069', 218, 7, 11742, 37.9279, 0.661966733367157, -104.9005, -1.83085911198831),
(35966, '81071', 218, 7, 187349, 38.4437, 0.670969141648944, -102.2204, -1.78408254270561),
(35967, '81073', 218, 7, 349, 37.3962, 0.652686817734303, -102.6222, -1.79109527564013),
(35968, '81074', 218, 7, 61874, 37.1167, 0.647808622474979, -104.5245, -1.82429667400081),
(35969, '81076', 218, 7, 187413, 38.2488, 0.667567494936807, -103.6634, -1.80926764381189),
(35970, '81077', 218, 7, 6198, 38.014, 0.663469461853125, -103.6262, -1.80861838133015),
(35971, '81081', 218, 7, 187456, 37.0149, 0.646031877296449, -103.8813, -1.81307071625199),
(35972, '81082', 218, 7, 13233, 37.1731, 0.648792988173104, -104.5154, -1.82413784903888),
(35973, '81084', 218, 7, 187470, 37.6946, 0.657894880222255, -102.3545, -1.78642302923254),
(35974, '81087', 218, 7, 18451, 37.3899, 0.652576861991428, -102.436, -1.78784547257291),
(35975, '81089', 218, 7, 187509, 37.6168, 0.656537014064203, -104.8198, -1.82945063128195),
(35976, '81090', 218, 7, 28899, 37.3478, 0.651842078376338, -102.2579, -1.78473704117511),
(35977, '81091', 218, 7, 6746, 37.1715, 0.648765062905072, -104.9592, -1.83188362025923),
(35978, '81092', 218, 7, 6820, 38.1617, 0.66604731315832, -102.7155, -1.79272366783224),
(35979, '81101', 218, 7, 186321, 37.4744, 0.654051665209363, -105.8664, -1.84771724723333),
(35980, '81102', 218, 7, 186321, 37.4703, 0.653980106710031, -105.8641, -1.84767710466053),
(35981, '81120', 218, 7, 186345, 37.066, 0.646923740544218, -106.1487, -1.85264431171171),
(35982, '81121', 218, 7, 186352, 37.0259, 0.646223863514169, -107.4862, -1.87598809045713),
(35983, '81122', 218, 7, 122197, 37.2886, 0.650808843459158, -107.5948, -1.8778835180248),
(35984, '81123', 218, 7, 186422, 37.4303, 0.653281975009234, -105.5231, -1.84172553191123),
(35985, '81124', 218, 7, 186485, 37.2839, 0.650726812984314, -106.1037, -1.85185891354831),
(35986, '81125', 218, 7, 1440, 37.7792, 0.659371428769442, -106.0963, -1.85172975918366),
(35987, '81126', 218, 7, 186522, 37.1706, 0.648749354941804, -105.3925, -1.83944613190812),
(35988, '81127', 218, 7, 63665, 37.2099, 0.649435269337838, -107.3031, -1.87279239259673),
(35989, '81128', 218, 7, 186538, 37.0366, 0.646410613744132, -106.843, -1.8647621327083),
(35990, '81129', 218, 7, 186570, 37.1774, 0.64886803733094, -105.9402, -1.8490053002213),
(35991, '81130', 218, 7, 186589, 37.8407, 0.660444806259418, -106.9248, -1.86618981203643),
(35992, '81131', 218, 7, 186593, 37.9965, 0.663164029234025, -105.6992, -1.84479905672399),
(35993, '81132', 218, 7, 80650, 37.6838, 0.657706384663039, -106.3804, -1.85668823958858),
(35994, '81133', 218, 7, 186722, 37.4113, 0.652950362451355, -105.3929, -1.83945311322513),
(35995, '81134', 218, 7, 186745, 37.0053, 0.645864325688258, -105.5373, -1.84197336866501),
(35996, '81135', 218, 7, 186862, 37.5796, 0.655887751582461, -106.1475, -1.85262336776068),
(35997, '81136', 218, 7, 16490, 37.7427, 0.658734383592464, -105.9044, -1.84838047234908),
(35998, '81137', 218, 7, 182262, 37.103, 0.647569512367456, -107.5949, -1.87788526335405),
(35999, '81138', 218, 7, 186894, 37.0032, 0.645827673773966, -105.6232, -1.84347260649247),
(36000, '81140', 218, 7, 186939, 37.2671, 0.650433597669979, -105.9885, -1.84984829425001),
(36001, '81141', 218, 7, 187021, 37.1741, 0.648810441465624, -105.9352, -1.8489180337587),
(36002, '81143', 218, 7, 4263, 38.0808, 0.664635341793457, -105.8924, -1.84817103283884),
(36003, '81144', 218, 7, 4281, 37.5681, 0.655687038718482, -106.1454, -1.85258671584639),
(36004, '81146', 218, 7, 187086, 37.6501, 0.657118208705117, -105.7003, -1.84481825534576),
(36005, '81147', 218, 7, 187155, 37.256, 0.650239866123007, -107.0869, -1.86901899075392),
(36006, '81148', 218, 7, 17848, 37.1726, 0.648784261526844, -105.9843, -1.84977499042143),
(36007, '81149', 218, 7, 187300, 38.0811, 0.664640577781213, -106.1312, -1.85233887909261),
(36008, '81151', 218, 7, 188, 37.2681, 0.650451050962499, -105.8481, -1.84739785198021),
(36009, '81152', 218, 7, 179064, 37.2021, 0.649299133656183, -105.4236, -1.83998892930549),
(36010, '81153', 218, 7, 17951, 37.1535, 0.648450903639713, -105.2925, -1.83770080265613),
(36011, '81154', 218, 7, 38288, 37.6729, 0.657516143774572, -106.6323, -1.86108472397435),
(36012, '81155', 218, 7, 28869, 38.247, 0.667536079010271, -106.0814, -1.85146970512511),
(36013, '81157', 218, 7, 187155, 37.2682, 0.650452796291751, -107.0896, -1.86906611464372),
(36014, '81201', 218, 7, 137969, 38.5463, 0.67275984946149, -106.0325, -1.85061623912089),
(36015, '81210', 218, 7, 112747, 38.7576, 0.676447730170954, -106.6867, -1.86203418308743),
(36016, '81211', 218, 7, 1223, 38.8481, 0.678027253144009, -106.155, -1.85275426745458),
(36017, '81212', 218, 7, 186482, 38.4491, 0.671063389428552, -105.2316, -1.83663789714166),
(36018, '81215', 218, 7, 186482, 38.447, 0.67102673751426, -105.2252, -1.83652619606954),
(36019, '81220', 218, 7, 177943, 38.3201, 0.668811914693479, -107.4572, -1.87548194497405),
(36020, '81221', 218, 7, 75482, 38.3606, 0.669518773040537, -105.1452, -1.83512993266794),
(36021, '81222', 218, 7, 1663, 38.3866, 0.669972558646055, -105.773, -1.84608710971196),
(36022, '81223', 218, 7, 186582, 38.3649, 0.669593822198372, -105.6481, -1.84390719347622),
(36023, '81224', 218, 7, 186592, 38.8603, 0.678240183312752, -106.9576, -1.86676228003109),
(36024, '81225', 218, 7, 186592, 38.9008, 0.67894704165981, -106.9663, -1.86691412367601),
(36025, '81226', 218, 7, 2502, 38.3897, 0.670026663852867, -105.1228, -1.8347389789155),
(36026, '81227', 218, 7, 10558, 38.5327, 0.672522484683219, -105.9969, -1.84999490190718),
(36027, '81228', 218, 7, 0, 39.0475, 0.681507439672486, -106.2615, -1.85461304310795),
(36028, '81230', 218, 7, 60144, 38.5629, 0.673049574117321, -106.9503, -1.86663487099569),
(36029, '81231', 218, 7, 60144, 38.549, 0.672806973351294, -106.9184, -1.86607811096431),
(36030, '81232', 218, 7, 36430, 38.5336, 0.672538192646487, -105.9907, -1.84988669149355),
(36031, '81233', 218, 7, 3251, 38.4233, 0.670613094481537, -105.8303, -1.84708718337335),
(36032, '81235', 218, 7, 9930, 38.0208, 0.66358814424226, -107.3177, -1.87304721066752),
(36033, '81236', 218, 7, 0, 38.7009, 0.675458128485073, -106.1405, -1.85250119471304),
(36034, '81237', 218, 7, 156915, 38.5823, 0.673388167992208, -106.5782, -1.86014050084902),
(36035, '81239', 218, 7, 145998, 38.5049, 0.672037283151165, -106.6339, -1.86111264924238),
(36036, '81240', 218, 7, 11139, 38.4326, 0.670775410101973, -105.0066, -1.83271090632468),
(36037, '81241', 218, 7, 42595, 38.608, 0.673836717609971, -106.5166, -1.85906537802979),
(36038, '81242', 218, 7, 187218, 38.5144, 0.672203089430104, -106.0754, -1.85136498536999),
(36039, '81243', 218, 7, 187224, 38.2722, 0.667975901981774, -107.1888, -1.8707974812617),
(36040, '81244', 218, 7, 37980, 38.3687, 0.669660144709948, -105.1642, -1.83546154522582),
(36041, '81246', 218, 7, 186482, 38.5365, 0.672588807194795, -105.3062, -1.83793991276365),
(36042, '81247', 218, 7, 60144, 38.493, 0.671829588970177, -107.0735, -1.86878511663415),
(36043, '81248', 218, 7, 74214, 38.5413, 0.672672582998891, -106.3957, -1.85695527496413),
(36044, '81251', 218, 7, 18397, 39.0797, 0.682069435691628, -106.4023, -1.85707046669476),
(36045, '81252', 218, 7, 84300, 38.1166, 0.665260169665671, -105.4304, -1.84010761169463),
(36046, '81253', 218, 7, 34399, 38.1763, 0.666302131229111, -105.1062, -1.83444925425966),
(36047, '81290', 218, 7, 2502, 38.3903, 0.670037135828379, -105.1171, -1.83463949514813),
(36048, '81301', 218, 7, 93851, 37.2921, 0.650869929982977, -107.8438, -1.88222938786226),
(36049, '81302', 218, 7, 93851, 37.3161, 0.651288809003456, -107.8796, -1.88285421573447),
(36050, '81303', 218, 7, 93851, 37.2754, 0.650578459997894, -107.8799, -1.88285945172223),
(36051, '81320', 218, 7, 186476, 37.6949, 0.65790011621001, -108.7561, -1.89815202662821),
(36052, '81321', 218, 7, 15632, 37.3558, 0.651981704716498, -108.6081, -1.89556893933525),
(36053, '81323', 218, 7, 181173, 37.455, 0.653713071334476, -108.5181, -1.89399814300846),
(36054, '81324', 218, 7, 20658, 37.7666, 0.65915151728369, -108.9045, -1.90074209523816),
(36055, '81325', 218, 7, 186668, 38.016, 0.663504368438164, -108.6834, -1.89688317226201),
(36056, '81326', 218, 7, 186843, 37.2133, 0.649494610532406, -108.0868, -1.88647053794461),
(36057, '81327', 218, 7, 3744, 37.4999, 0.654496724168621, -108.6736, -1.89671212999531),
(36058, '81328', 218, 7, 187022, 37.3683, 0.652199870872997, -108.3477, -1.89102410196306),
(36059, '81329', 218, 7, 4024, 37.113, 0.647744045292656, -108.1264, -1.8871616883284),
(36060, '81330', 218, 7, 0, 37.2987, 0.650985121713609, -108.4195, -1.89227724836599),
(36061, '81331', 218, 7, 5152, 37.5525, 0.655414767355171, -108.807, -1.89904039921747),
(36062, '81332', 218, 7, 24313, 37.688, 0.657779688491623, -108.0312, -1.8855001348805),
(36063, '81334', 218, 7, 187451, 37.1937, 0.649152525999015, -108.7398, -1.89786753796013),
(36064, '81335', 218, 7, 18689, 37.4975, 0.654454836266574, -108.7734, -1.8984539685888),
(36065, '81401', 218, 7, 4299, 38.473, 0.671480523119778, -107.8854, -1.88295544483109),
(36066, '81402', 218, 7, 4299, 38.4872, 0.671728359873562, -107.8382, -1.88213164942415),
(36067, '81410', 218, 7, 7197, 38.793, 0.67706557672616, -107.9745, -1.88451053319462),
(36068, '81411', 218, 7, 186398, 38.3348, 0.669068478093522, -108.8863, -1.9004244453143),
(36069, '81413', 218, 7, 186513, 38.9103, 0.67911284793875, -107.9192, -1.88354536611826),
(36070, '81414', 218, 7, 29556, 38.7904, 0.677020198165608, -107.989, -1.88476360593616),
(36071, '81415', 218, 7, 1860, 38.7106, 0.675627425422517, -107.6176, -1.87828145309425),
(36072, '81416', 218, 7, 2022, 38.7367, 0.676082956357287, -108.0501, -1.88583000210913),
(36073, '81418', 218, 7, 93909, 38.8511, 0.678079613021569, -107.9647, -1.88433949092792),
(36074, '81419', 218, 7, 102968, 38.8185, 0.677510635685419, -107.7475, -1.88054863579259),
(36075, '81420', 218, 7, 186968, 38.7798, 0.676835193264897, -107.7822, -1.88115426504303),
(36076, '81421', 218, 7, 110252, 38.5666, 0.673114151299645, -107.5563, -1.87721156626278),
(36077, '81422', 218, 7, 187101, 38.2309, 0.6672550810007, -108.5856, -1.89517624025355),
(36078, '81423', 218, 7, 4648, 38.1245, 0.665398050676578, -108.2796, -1.88983553274245),
(36079, '81424', 218, 7, 187122, 38.2653, 0.667855474263386, -108.5533, -1.89461249890516),
(36080, '81425', 218, 7, 33490, 38.6056, 0.673794829707923, -108.002, -1.88499049873892),
(36081, '81426', 218, 7, 4792, 37.861, 0.660799108097573, -107.8751, -1.88277567591814),
(36082, '81427', 218, 7, 187149, 38.0577, 0.664232170736246, -107.7016, -1.87974752966592),
(36083, '81428', 218, 7, 192924, 38.8667, 0.67835188438488, -107.5942, -1.87787304604928),
(36084, '81429', 218, 7, 151545, 38.3688, 0.6696618900392, -108.9614, -1.90173518758255),
(36085, '81430', 218, 7, 184159, 38.0407, 0.663935464763407, -108.0638, -1.88606911221665),
(36086, '81431', 218, 7, 192925, 38.1881, 0.666508080080847, -108.4266, -1.89240116674288),
(36087, '81432', 218, 7, 28416, 38.1596, 0.666010661244028, -107.7504, -1.8805992503409),
(36088, '81433', 218, 7, 57571, 37.8124, 0.659950878081104, -107.6624, -1.87906336059914),
(36089, '81434', 218, 7, 5946, 38.9625, 0.680023909808291, -107.2968, -1.87268243685385),
(36090, '81435', 218, 7, 187430, 37.9815, 0.662902229846226, -107.9428, -1.88395726382174),
(36091, '81501', 218, 7, 87355, 39.0805, 0.682083398325644, -108.5426, -1.8944257486752),
(36092, '81502', 218, 7, 87355, 39.0758, 0.6820013678508, -108.6307, -1.8959633837462),
(36093, '81503', 218, 7, 87355, 39.0395, 0.681367813332326, -108.4973, -1.89363511452404),
(36094, '81504', 218, 7, 87355, 39.0831, 0.682128776886196, -108.4877, -1.89346756291585),
(36095, '81505', 218, 7, 87355, 39.1079, 0.68256161854069, -108.6069, -1.89554799538423),
(36096, '81506', 218, 7, 87355, 39.1049, 0.682509258663131, -108.5484, -1.89452697777181),
(36097, '81520', 218, 7, 15559, 39.086, 0.682179391434504, -108.4465, -1.89274848726403),
(36098, '81521', 218, 7, 16148, 39.1663, 0.683580890823855, -108.7184, -1.8974940375002),
(36099, '81522', 218, 7, 9075, 38.7863, 0.676948639666277, -108.749, -1.89802810825131),
(36100, '81523', 218, 7, 0, 38.9948, 0.680587651156685, -108.7394, -1.89786055664312),
(36101, '81524', 218, 7, 95783, 39.2279, 0.684656013643084, -108.8033, -1.89897582203515),
(36102, '81525', 218, 7, 41921, 39.2398, 0.684863707824071, -108.8484, -1.8997629655278),
(36103, '81526', 218, 7, 137363, 39.0998, 0.682420246871279, -108.3631, -1.89129288266787),
(36104, '81527', 218, 7, 26032, 38.9601, 0.679982021906243, -108.3644, -1.89131557194814),
(36105, '81601', 218, 7, 186774, 39.5269, 0.689874548106547, -107.341, -1.87345387238323),
(36106, '81602', 218, 7, 186774, 39.4945, 0.6893090614289, -107.3272, -1.87321301694646),
(36107, '81610', 218, 7, 194158, 40.3345, 0.703969827145653, -108.8214, -1.89929172662976),
(36108, '81611', 218, 7, 44490, 39.1938, 0.684060856368154, -106.8259, -1.86446368140621),
(36109, '81612', 218, 7, 44490, 39.2067, 0.684286003841661, -106.8508, -1.86489826838996),
(36110, '81615', 218, 7, 187375, 39.2108, 0.684357562340993, -106.936, -1.86638528891266),
(36111, '81620', 218, 7, 7208, 39.6391, 0.691832807527284, -106.5536, -1.85971114985303),
(36112, '81621', 218, 7, 186387, 39.3756, 0.687233864948279, -106.9921, -1.86736441862302),
(36113, '81623', 218, 7, 19772, 39.4148, 0.687918034015061, -107.1915, -1.8708446051515),
(36114, '81624', 218, 7, 1696, 39.2351, 0.684781677349227, -107.949, -1.88406547423536),
(36115, '81625', 218, 7, 29568, 40.549, 0.707713558391181, -107.565, -1.8773634099077),
(36116, '81626', 218, 7, 29568, 40.5587, 0.707882855328624, -107.5693, -1.87743845906554),
(36117, '81630', 218, 7, 186607, 39.3313, 0.686460684089646, -108.214, -1.88869059675314),
(36118, '81631', 218, 7, 2149, 39.648, 0.691988141830712, -106.8365, -1.86464868630692),
(36119, '81632', 218, 7, 8695, 39.6427, 0.691895639380356, -106.6079, -1.86065886363686),
(36120, '81633', 218, 7, 194158, 40.3143, 0.70361727063675, -108.3515, -1.89109042447464),
(36121, '81635', 218, 7, 187162, 39.4607, 0.688719140141726, -108.0081, -1.88509696382329),
(36122, '81636', 218, 7, 186389, 39.4413, 0.688380546266839, -108.0247, -1.88538668847912),
(36123, '81637', 218, 7, 32652, 39.6325, 0.691717615796653, -106.9535, -1.86669072153176),
(36124, '81638', 218, 7, 2950, 40.332, 0.703926193914353, -107.5503, -1.87710684650766),
(36125, '81639', 218, 7, 3019, 40.486, 0.706614000962424, -107.2669, -1.87216058340751),
(36126, '81640', 218, 7, 194316, 40.5318, 0.707413361759838, -108.144, -1.88746886627675),
(36127, '81641', 218, 7, 42058, 40.0445, 0.698908372314869, -107.9443, -1.88398344376052),
(36128, '81642', 218, 7, 37168, 39.3457, 0.686712011501933, -106.6816, -1.86194517129558),
(36129, '81643', 218, 7, 10451, 39.1475, 0.68325276892448, -108.1332, -1.88728037071753),
(36130, '81645', 218, 7, 10526, 39.5712, 0.69064772896518, -106.4172, -1.85733052075331),
(36131, '81646', 218, 7, 187071, 39.1894, 0.683984061881066, -108.0597, -1.88599755371732),
(36132, '81647', 218, 7, 4520, 39.5596, 0.690445270771949, -107.5465, -1.87704052399608),
(36133, '81648', 218, 7, 194390, 40.091, 0.699719950417047, -108.8004, -1.89892520748684),
(36134, '81649', 218, 7, 176030, 39.4851, 0.689145000479213, -106.3797, -1.85667602228381),
(36135, '81650', 218, 7, 187259, 39.5398, 0.690099695580054, -107.789, -1.88127294743217),
(36136, '81652', 218, 7, 185157, 39.5066, 0.689520246268392, -107.6523, -1.87888708234469),
(36137, '81653', 218, 7, 60, 40.916, 0.714118916746, -107.5056, -1.87632668433202),
(36138, '81654', 218, 7, 187374, 39.286, 0.685670049938492, -106.9795, -1.86714450713727),
(36139, '81655', 218, 7, 34461, 39.6841, 0.692618205690682, -106.6726, -1.8617880916629),
(36140, '81656', 218, 7, 187561, 39.2678, 0.685352400014629, -106.8636, -1.86512167053421),
(36141, '81657', 218, 7, 12506, 39.6363, 0.691783938308228, -106.3741, -1.8565782838457),
(36142, '81658', 218, 7, 12506, 39.6243, 0.691574498797989, -106.4996, -1.85876867205695),
(36143, '82001', 218, 59, 32059, 41.1414, 0.718052888879995, -104.7917, -1.82896019376214),
(36144, '82002', 218, 59, 32059, 41.1398, 0.718024963611963, -104.8222, -1.829492519184),
(36145, '82003', 218, 59, 32059, 41.1684, 0.718524127778034, -104.7883, -1.82890085256757),
(36146, '82005', 218, 59, 0, 41.139, 0.718011000977947, -104.8619, -1.83018541489704),
(36147, '82006', 218, 59, 32059, 41.4068, 0.722684992714788, -104.8583, -1.83012258304397),
(36148, '82007', 218, 59, 32059, 41.1113, 0.717527544775145, -104.8611, -1.83017145226303),
(36149, '82008', 218, 59, 32059, 41.1121, 0.717541507409161, -104.8322, -1.8296670521092),
(36150, '82009', 218, 59, 32059, 41.2056, 0.719173390259775, -104.8278, -1.82959025762211),
(36151, '82010', 218, 59, 32059, 41.1021, 0.717366974483961, -104.7829, -1.82880660478797),
(36152, '82050', 218, 59, 58428, 41.4194, 0.722904904200539, -104.357, -1.82137324750372),
(36153, '82051', 218, 59, 209321, 41.577, 0.725655543101682, -105.5595, -1.84236083175895),
(36154, '82052', 218, 59, 7769, 41.1115, 0.717531035433649, -105.3105, -1.83801496192149),
(36155, '82053', 218, 59, 1244, 41.2177, 0.719384575099267, -104.3599, -1.82142386205203),
(36156, '82054', 218, 59, 1369, 41.0595, 0.716623464222612, -104.3658, -1.8215268364779),
(36157, '82055', 218, 59, 19896, 41.3038, 0.720887303585234, -106.135, -1.85240520160418),
(36158, '82058', 218, 59, 9065, 42.1974, 0.736483565781055, -105.6796, -1.8444569721906),
(36159, '82059', 218, 59, 0, 41.0182, 0.715902643241538, -105.2489, -1.83693983910226),
(36160, '82060', 218, 59, 3147, 41.2125, 0.719293817978163, -104.4773, -1.82347287859387),
(36161, '82061', 218, 59, 81643, 41.3956, 0.722489515838565, -105.3658, -1.83898012899784),
(36162, '82063', 218, 59, 209533, 41.0866, 0.717096448449902, -106.0117, -1.85025321063647),
(36163, '82070', 218, 59, 209561, 41.2744, 0.720374176785148, -105.692, -1.84467339301785),
(36164, '82071', 218, 59, 209561, 41.4219, 0.722948537431839, -105.6059, -1.84317066453188),
(36165, '82072', 218, 59, 209561, 41.311, 0.721012967291377, -105.5901, -1.84289490251006),
(36166, '82073', 218, 59, 209561, 41.3106, 0.721005985974369, -105.5825, -1.84276225748691),
(36167, '82081', 218, 59, 33252, 41.562, 0.725393743713883, -104.3694, -1.82158966833097),
(36168, '82082', 218, 59, 125811, 41.2399, 0.719772038193209, -104.0826, -1.81658406403625),
(36169, '82083', 218, 59, 132867, 41.7825, 0.729242194714531, -105.8834, -1.84801395320616),
(36170, '82084', 218, 59, 209788, 41.0546, 0.716537943089264, -105.4384, -1.84024723803479),
(36171, '82190', 218, 59, 0, 44.575, 0.777980514076472, -110.5174, -1.92889251074358),
(36172, '82201', 218, 59, 31509, 42.0341, 0.733633443112549, -104.9772, -1.83219777952459),
(36173, '82210', 218, 59, 209365, 41.7281, 0.728292735601446, -104.8462, -1.82991139820448),
(36174, '82212', 218, 59, 209459, 42.2137, 0.73676805444913, -104.5178, -1.82417973694093),
(36175, '82213', 218, 59, 209474, 42.4986, 0.741740497488062, -104.8991, -1.83083467737878),
(36176, '82214', 218, 59, 9256, 42.2728, 0.737799544037059, -104.7675, -1.82853782408316),
(36177, '82215', 218, 59, 55196, 42.301, 0.738291726886121, -104.7319, -1.82791648686945),
(36178, '82217', 218, 59, 209499, 41.7332, 0.728381747393298, -104.3652, -1.82151636450239),
(36179, '82218', 218, 59, 13999, 41.9332, 0.731872405897286, -104.1458, -1.81768711212351),
(36180, '82219', 218, 59, 209530, 42.3855, 0.739766530104057, -104.3329, -1.82095262315399),
(36181, '82221', 218, 59, 103428, 41.6361, 0.726687032689611, -104.3533, -1.8213086703214),
(36182, '82222', 218, 59, 209558, 43.1791, 0.753617463047884, -104.5998, -1.82561090692756),
(36183, '82223', 218, 59, 60648, 42.131, 0.735324667157731, -104.3403, -1.82108177751864),
(36184, '82224', 218, 59, 33141, 42.7796, 0.746644872686166, -105.3757, -1.83915291659379),
(36185, '82225', 218, 59, 3907, 42.8075, 0.747131819547473, -104.3377, -1.82103639895809),
(36186, '82227', 218, 59, 30417, 42.7774, 0.746606475442622, -104.6164, -1.8259006315834),
(36187, '82229', 218, 59, 5783, 42.6764, 0.744843692898108, -105.0213, -1.83296746972472),
(36188, '82240', 218, 59, 114179, 42.0676, 0.734218128411967, -104.1837, -1.81834859191002),
(36189, '82242', 218, 59, 209806, 42.6929, 0.745131672224687, -104.1173, -1.81718969328669),
(36190, '82243', 218, 59, 153378, 41.9741, 0.732586245561352, -104.3613, -1.82144829666156),
(36191, '82244', 218, 59, 13008, 41.9559, 0.732268595637489, -104.4605, -1.82317966327954),
(36192, '82301', 218, 59, 97385, 41.7912, 0.729394038359454, -107.1975, -1.87094932490662),
(36193, '82310', 218, 59, 209532, 42.5139, 0.742007532863617, -107.8911, -1.88305492859845),
(36194, '82321', 218, 59, 209286, 41.0312, 0.716129536044297, -107.6085, -1.87812262813232),
(36195, '82322', 218, 59, 209287, 42.2394, 0.737216604066893, -107.5598, -1.8772726527866),
(36196, '82323', 218, 59, 828, 41.0923, 0.717195932217266, -107.5348, -1.8768363204736),
(36197, '82324', 218, 59, 64481, 41.6885, 0.727601585217656, -106.413, -1.85725721692473),
(36198, '82325', 218, 59, 209439, 41.208, 0.719215278161823, -106.7901, -1.863838853534),
(36199, '82327', 218, 59, 9318, 41.8718, 0.730800773736562, -106.5532, -1.85970416853602),
(36200, '82329', 218, 59, 209597, 41.8984, 0.731265031317592, -106.2006, -1.85355013759349),
(36201, '82331', 218, 59, 5658, 41.4519, 0.723472136207438, -106.8126, -1.8642315526157),
(36202, '82332', 218, 59, 209725, 41.0833, 0.717038852584586, -107.3479, -1.87357430010162),
(36203, '82334', 218, 59, 28619, 41.7808, 0.729212524117247, -107.1179, -1.86956004282203),
(36204, '82335', 218, 59, 354, 41.7601, 0.728851240962084, -106.8455, -1.8648057659396),
(36205, '82336', 218, 59, 209815, 41.6691, 0.727262991342769, -107.9762, -1.8845402037919),
(36206, '82401', 218, 59, 58368, 44.025, 0.768381203190504, -107.9537, -1.8841475047102),
(36207, '82410', 218, 59, 108107, 44.3808, 0.774591084669099, -108.0376, -1.88561183595263),
(36208, '82411', 218, 59, 1239, 44.4355, 0.77554577976994, -108.4279, -1.89242385602316),
(36209, '82412', 218, 59, 7810, 44.7951, 0.781821983760112, -108.5076, -1.893814883437),
(36210, '82414', 218, 59, 8158, 44.5151, 0.776935061854528, -109.1328, -1.90472668192047),
(36211, '82420', 218, 59, 93508, 44.8843, 0.783378817452891, -108.4659, -1.89308708113892),
(36212, '82421', 218, 59, 209402, 44.8915, 0.783504481159034, -108.5959, -1.89535600916651),
(36213, '82422', 218, 59, 94046, 44.5055, 0.776767510246336, -108.391, -1.89177982952917),
(36214, '82423', 218, 59, 209466, 44.9715, 0.78490074456063, -108.6207, -1.895788850821),
(36215, '82426', 218, 59, 209485, 44.4938, 0.776563306723853, -108.0451, -1.88574273564653),
(36216, '82427', 218, 59, 209490, 43.7564, 0.763693248819647, -108.6585, -1.89644858527826),
(36217, '82428', 218, 59, 209521, 44.2727, 0.772704383747694, -107.5899, -1.87779799689145),
(36218, '82430', 218, 59, 9881, 43.8038, 0.764520534885092, -108.1782, -1.88806576888093),
(36219, '82431', 218, 59, 73289, 44.8004, 0.781914486210468, -108.3452, -1.89098046873176),
(36220, '82432', 218, 59, 202339, 44.27, 0.77265725985789, -107.9471, -1.88403231297957),
(36221, '82433', 218, 59, 209598, 44.2144, 0.771686856793781, -108.8298, -1.89943833428693),
(36222, '82434', 218, 59, 11013, 44.4097, 0.775095484822926, -108.2898, -1.89001355632616),
(36223, '82435', 218, 59, 5200, 44.7548, 0.781118616071558, -108.7605, -1.89822882111529),
(36224, '82440', 218, 59, 965, 44.7171, 0.780460626943556, -108.8669, -1.90008585143941),
(36225, '82441', 218, 59, 5791, 44.613, 0.77864373919223, -107.8121, -1.88167611848938),
(36226, '82442', 218, 59, 209774, 44.0349, 0.768553990786451, -107.4473, -1.8753091573781),
(36227, '82443', 218, 59, 209782, 43.6447, 0.761743716045169, -108.2141, -1.8886923420824),
(36228, '82450', 218, 59, 209816, 44.4792, 0.776308488653062, -109.7239, -1.91504332312901),
(36229, '82501', 218, 59, 5429, 43.0691, 0.75169760087069, -108.4211, -1.89230517363402),
(36230, '82510', 218, 59, 62553, 42.9877, 0.750276902859566, -108.5402, -1.89438386077315),
(36231, '82512', 218, 59, 209394, 43.3794, 0.757113357539628, -109.1878, -1.90568661300906),
(36232, '82513', 218, 59, 20689, 43.5427, 0.759963480208135, -109.6633, -1.9139856536023),
(36233, '82514', 218, 59, 209461, 42.9973, 0.750444454467758, -108.8796, -1.90030750825442),
(36234, '82515', 218, 59, 16505, 42.9104, 0.748927763347775, -108.5643, -1.89480448512288),
(36235, '82516', 218, 59, 209547, 43.2361, 0.75461230072152, -108.8147, -1.89917478956987),
(36236, '82520', 218, 59, 48813, 42.8278, 0.747486121385628, -108.7112, -1.89736837379406),
(36237, '82523', 218, 59, 120979, 43.2584, 0.755001509144715, -108.6513, -1.89632292157212),
(36238, '82524', 218, 59, 5615, 42.9838, 0.750208835018739, -108.4156, -1.89220918052516),
(36239, '82601', 218, 59, 209359, 42.841, 0.747716504846891, -106.3206, -1.85564453269588),
(36240, '82602', 218, 59, 209359, 42.8452, 0.747789808675475, -106.3399, -1.85598138124152),
(36241, '82604', 218, 59, 209359, 42.828, 0.747489612044132, -106.3835, -1.85674234479539),
(36242, '82605', 218, 59, 209359, 42.8661, 0.748154582489141, -106.3127, -1.85550665168498),
(36243, '82609', 218, 59, 209359, 42.8457, 0.747798535321734, -106.2719, -1.85479455735016),
(36244, '82615', 218, 59, 0, 42.0295, 0.733553157966957, -106.5458, -1.85957501417137),
(36245, '82620', 218, 59, 209260, 42.5275, 0.742244897641889, -106.7764, -1.86359974342647),
(36246, '82630', 218, 59, 209277, 43.1198, 0.752582482801451, -107.371, -1.87397747115883),
(36247, '82633', 218, 59, 2088, 42.782, 0.746686760588214, -105.4049, -1.83966255273537),
(36248, '82635', 218, 59, 32304, 43.4113, 0.757670117571014, -106.257, -1.85453450329161),
(36249, '82636', 218, 59, 2341, 42.8619, 0.748081278660558, -106.2037, -1.8536042428003),
(36250, '82637', 218, 59, 141915, 42.8341, 0.747596077128503, -105.8423, -1.84729662288359),
(36251, '82638', 218, 59, 209506, 43.115, 0.752498706997355, -107.3483, -1.87358128141863),
(36252, '82639', 218, 59, 209540, 43.7487, 0.763558858467243, -106.5531, -1.85970242320677),
(36253, '82640', 218, 59, 209567, 43.6037, 0.761028131051852, -106.1921, -1.85340178460707),
(36254, '82642', 218, 59, 209583, 43.2995, 0.755718839467285, -107.6358, -1.87859910301811),
(36255, '82643', 218, 59, 209603, 43.4089, 0.757628229668967, -106.2768, -1.85488007848351),
(36256, '82644', 218, 59, 10509, 42.8655, 0.748144110513629, -106.4083, -1.85717518644988),
(36257, '82646', 218, 59, 33383, 43.1416, 0.752962964578386, -106.3603, -1.85633742840892),
(36258, '82648', 218, 59, 209674, 43.1105, 0.752420167181015, -107.0151, -1.86776584435098),
(36259, '82649', 218, 59, 209734, 43.2154, 0.754251017566357, -108.2066, -1.8885614423885),
(36260, '82701', 218, 59, 10795, 43.8325, 0.765021444380415, -104.292, -1.82023878348993),
(36261, '82710', 218, 59, 26342, 44.8227, 0.782303694633662, -104.2054, -1.8187273283577),
(36262, '82711', 218, 59, 14980, 44.6949, 0.780073163849614, -104.4408, -1.82283583341689),
(36263, '82712', 218, 59, 616, 44.5569, 0.777664609481861, -104.1336, -1.81747418195477),
(36264, '82713', 218, 59, 209355, 44.521, 0.777038036280395, -104.7492, -1.82821842883004),
(36265, '82714', 218, 59, 209405, 44.6453, 0.779207480540624, -104.8439, -1.82987125563168),
(36266, '82715', 218, 59, 16110, 44.1245, 0.770117805796238, -104.1195, -1.81722809053024),
(36267, '82716', 218, 59, 16211, 44.254, 0.772378007177571, -105.5071, -1.84144627923091),
(36268, '82717', 218, 59, 16211, 44.2572, 0.772433857713634, -105.3836, -1.8392907976047),
(36269, '82718', 218, 59, 16211, 44.2655, 0.77257872004155, -105.5225, -1.84171505993572),
(36270, '82720', 218, 59, 209519, 44.6972, 0.78011330642241, -104.7464, -1.82816955961099),
(36271, '82721', 218, 59, 209616, 44.3324, 0.773746345311134, -104.8593, -1.83014003633649),
(36272, '82723', 218, 59, 11002, 43.9886, 0.767745903342778, -104.4191, -1.82245709696921),
(36273, '82725', 218, 59, 193268, 44.8999, 0.783651088816202, -105.6719, -1.8443225818382),
(36274, '82727', 218, 59, 209711, 44.2477, 0.772268051434695, -105.2551, -1.83704804951588),
(36275, '82729', 218, 59, 83907, 44.4011, 0.774945386507254, -104.3743, -1.82167518946432),
(36276, '82730', 218, 59, 6489, 44.0791, 0.769325426315832, -104.6958, -1.82728642300948),
(36277, '82731', 218, 59, 6746, 44.6874, 0.779942264155714, -105.3259, -1.8382837426263),
(36278, '82732', 218, 59, 6964, 43.7373, 0.763359890932516, -105.4451, -1.84036417509467),
(36279, '82801', 218, 59, 11906, 44.7878, 0.781694574724716, -106.9668, -1.86692285032227),
(36280, '82831', 218, 59, 186362, 44.7054, 0.780256423421073, -106.1008, -1.851808299),
(36281, '82832', 218, 59, 7249, 44.6456, 0.77921271652838, -106.7971, -1.86396102658164),
(36282, '82833', 218, 59, 188142, 44.6685, 0.779612396927087, -107.0062, -1.86761051004756),
(36283, '82834', 218, 59, 26642, 44.3427, 0.77392611422409, -106.7144, -1.86251763929024),
(36284, '82835', 218, 59, 80354, 44.6709, 0.779654284829135, -106.4229, -1.85743000452067),
(36285, '82836', 218, 59, 1992, 44.8783, 0.783274097697771, -107.2557, -1.87196510653128),
(36286, '82837', 218, 59, 209566, 44.7485, 0.781008660328683, -106.2171, -1.85383811692007),
(36287, '82838', 218, 59, 128476, 44.9681, 0.784841403366062, -107.317, -1.87303499336275),
(36288, '82839', 218, 59, 209682, 44.9003, 0.78365807013321, -107.1434, -1.87000510178129),
(36289, '82840', 218, 59, 209714, 44.3451, 0.773968002126137, -106.6218, -1.86090146440289),
(36290, '82842', 218, 59, 12146, 44.5747, 0.777975278088716, -106.8991, -1.86574126241867),
(36291, '82844', 218, 59, 38931, 44.7033, 0.780219771506781, -107.3048, -1.87282206319401),
(36292, '82845', 218, 59, 209846, 44.8098, 0.782078547160155, -106.7708, -1.86350200498836),
(36293, '82901', 218, 59, 5469, 41.5969, 0.726002863622829, -109.2341, -1.90649470045274),
(36294, '82902', 218, 59, 5469, 41.587, 0.725830076026882, -109.2024, -1.90594143107986),
(36295, '82922', 218, 59, 34906, 43.1612, 0.753305049111777, -110.3437, -1.92586087383287),
(36296, '82923', 218, 59, 26581, 42.7292, 0.745765226743161, -109.6853, -1.91436962603774),
(36297, '82925', 218, 59, 498, 43.1127, 0.752458564424559, -109.9888, -1.91966670031754),
(36298, '82929', 218, 59, 120382, 41.5438, 0.72507609379002, -109.8584, -1.91739079097294),
(36299, '82930', 218, 59, 20954, 41.2506, 0.719958788423173, -110.9566, -1.93655799681834),
(36300, '82931', 218, 59, 20954, 41.2863, 0.720581870966135, -110.9666, -1.93673252974354),
(36301, '82932', 218, 59, 115548, 42.1083, 0.734928477417528, -109.4501, -1.91026461163705),
(36302, '82933', 218, 59, 209457, 41.3007, 0.720833198378422, -110.3882, -1.92663754535),
(36303, '82934', 218, 59, 94574, 41.5941, 0.725953994403773, -109.9664, -1.91927574656509),
(36304, '82935', 218, 59, 60111, 41.5139, 0.724554240343674, -109.4694, -1.91060146018268),
(36305, '82936', 218, 59, 110173, 41.03, 0.716108592093273, -110.1362, -1.92223931563498),
(36306, '82937', 218, 59, 60722, 41.3182, 0.721138630997521, -110.3002, -1.92510165560825),
(36307, '82938', 218, 59, 17071, 41.2183, 0.719395047074779, -109.7961, -1.91630345084895),
(36308, '82939', 218, 59, 4440, 41.2147, 0.719332215221707, -110.3695, -1.92631116877988),
(36309, '82941', 218, 59, 5064, 42.8652, 0.748138874525873, -109.8704, -1.91760023048318),
(36310, '82942', 218, 59, 50500, 41.6804, 0.727460213548245, -108.7848, -1.89865293612353),
(36311, '82943', 218, 59, 14477, 41.6697, 0.727273463318281, -109.193, -1.90577737013017),
(36312, '82944', 218, 59, 57220, 41.0864, 0.717092957791398, -110.5584, -1.9296080957369),
(36313, '82945', 218, 59, 6182, 41.7633, 0.728907091498148, -108.9676, -1.90184339799617),
(36314, '83001', 218, 59, 3384, 43.4716, 0.758722551109967, -110.7667, -1.9332436165688),
(36315, '83002', 218, 59, 3384, 43.4741, 0.758766184341267, -110.7639, -1.93319474734975),
(36316, '83011', 218, 59, 3492, 43.6056, 0.761061292307639, -110.3292, -1.92560780109133),
(36317, '83012', 218, 59, 209617, 43.5997, 0.760958317881772, -110.7413, -1.9328003029388),
(36318, '83013', 218, 59, 10585, 43.9391, 0.766881965363041, -110.3117, -1.92530236847223),
(36319, '83014', 218, 59, 565, 43.4765, 0.758808072243315, -110.8587, -1.93484931948064),
(36320, '83025', 218, 59, 209778, 43.5544, 0.760167683730618, -110.8214, -1.93419831166964),
(36321, '83101', 218, 59, 209544, 41.7948, 0.729456870212526, -110.5397, -1.92928171916678),
(36322, '83110', 218, 59, 570, 42.7176, 0.74556276854993, -110.942, -1.93630317874755),
(36323, '83111', 218, 59, 13306, 42.7922, 0.746864784171917, -110.961, -1.93663479130543),
(36324, '83112', 218, 59, 146, 42.9581, 0.749760285400976, -110.9399, -1.93626652683326),
(36325, '83113', 218, 59, 53476, 42.5981, 0.743477100093797, -110.0872, -1.9213841043015),
(36326, '83114', 218, 59, 209374, 42.2934, 0.73815908186297, -111.0917, -1.93891593663778),
(36327, '83115', 218, 59, 20453, 42.8945, 0.748650255996708, -110.176, -1.92293395667727),
(36328, '83116', 218, 59, 160777, 41.7794, 0.729188089507719, -110.538, -1.92925204856949),
(36329, '83118', 218, 59, 314, 43.0507, 0.751376460288323, -111.0102, -1.93749349329741),
(36330, '83119', 218, 59, 500, 42.681, 0.7449239780437, -111, -1.93731546971371),
(36331, '83120', 218, 59, 29850, 43.0442, 0.751263013886943, -111.0307, -1.93785128579407),
(36332, '83121', 218, 59, 130915, 41.8143, 0.729797209416665, -110.5358, -1.92921365132595),
(36333, '83122', 218, 59, 2894, 42.7995, 0.746992193207313, -110.9401, -1.93627001749176),
(36334, '83123', 218, 59, 209553, 42.2592, 0.737562179258788, -110.206, -1.92345755545287),
(36335, '83124', 218, 59, 10987, 41.7698, 0.729020537899527, -110.3207, -1.92545944810491),
(36336, '83126', 218, 59, 98144, 42.6076, 0.743642906372736, -110.9077, -1.93570453081412),
(36337, '83127', 218, 59, 209780, 42.9734, 0.750027320776531, -110.9719, -1.9368250321939),
(36338, '83128', 218, 59, 7073, 43.1221, 0.752622625374247, -111.0227, -1.93771165945391),
(36339, '83201', 218, 17, 195484, 42.8848, 0.748480959059264, -112.4258, -1.96220037418864),
(36340, '83202', 218, 17, 195484, 42.9278, 0.749231450637622, -112.4811, -1.96316554126499),
(36341, '83203', 218, 17, 194943, 42.9915, 0.750343225371142, -112.4255, -1.96219513820088),
(36342, '83204', 218, 17, 195484, 42.84, 0.747699051554371, -112.4288, -1.9622527340662),
(36343, '83205', 218, 17, 195484, 42.8453, 0.747791554004727, -112.4637, -1.96286185397515),
(36344, '83206', 218, 17, 195484, 42.8622, 0.748086514648314, -112.4556, -1.96272048230574),
(36345, '83209', 218, 17, 195484, 42.8757, 0.748322134097333, -112.4686, -1.96294737510849),
(36346, '83210', 218, 17, 7017, 42.9515, 0.749645093670344, -112.8406, -1.96943999992591),
(36347, '83211', 218, 17, 194518, 42.7752, 0.746568078199078, -112.8847, -1.97020969012604),
(36348, '83212', 218, 17, 194528, 42.5514, 0.742662031333115, -112.522, -1.96387938092906),
(36349, '83213', 218, 17, 18899, 43.636, 0.761591872400246, -113.2902, -1.97728700024288),
(36350, '83214', 218, 17, 194532, 42.5519, 0.742670757979375, -112.2303, -1.95878825550099),
(36351, '83215', 218, 17, 194541, 43.4438, 0.758237349577913, -112.8121, -1.9689425810891),
(36352, '83217', 218, 17, 19038, 42.7415, 0.745979902241156, -111.8852, -1.95276512425236),
(36353, '83218', 218, 17, 186387, 43.3173, 0.75602950807414, -112.1635, -1.95762237556066),
(36354, '83220', 218, 17, 31807, 42.3974, 0.739974224285044, -111.3784, -1.94391979560325),
(36355, '83221', 218, 17, 7518, 43.2008, 0.753996199495566, -112.3612, -1.96107289149185),
(36356, '83223', 218, 17, 29235, 42.1871, 0.7363037968681, -111.4009, -1.94431249468495),
(36357, '83226', 218, 17, 194716, 44.5027, 0.776718641027281, -114.2253, -1.99360757407828),
(36358, '83227', 218, 17, 608, 44.2967, 0.773123262768172, -114.4116, -1.99685912247474),
(36359, '83228', 218, 17, 15559, 42.2292, 0.737038580483189, -112.0122, -1.95498169240239),
(36360, '83229', 218, 17, 177613, 45.1107, 0.787330242879406, -114.4356, -1.99727800149522),
(36361, '83230', 218, 17, 194770, 42.7339, 0.745847257218005, -111.5153, -1.94630915134923),
(36362, '83232', 218, 17, 1992, 42.1252, 0.735223438061115, -112.0135, -1.95500438168267),
(36363, '83233', 218, 17, 194843, 42.2303, 0.737057779104961, -111.2784, -1.94217446635126),
(36364, '83234', 218, 17, 78140, 42.452, 0.740927174056633, -112.158, -1.9575263824518),
(36365, '83235', 218, 17, 2268, 44.8495, 0.782771442873197, -114.0903, -1.99125137958809),
(36366, '83236', 218, 17, 141822, 43.2876, 0.755511145286297, -112.1299, -1.95703594493199),
(36367, '83237', 218, 17, 2595, 42.0268, 0.733506034077153, -111.7949, -1.95118909193781),
(36368, '83238', 218, 17, 2687, 42.3169, 0.738569234237188, -111.0601, -1.93836441259415),
(36369, '83239', 218, 17, 2693, 42.4727, 0.741288457211796, -111.3969, -1.94424268151487),
(36370, '83241', 218, 17, 2798, 42.5252, 0.742204755069093, -111.7597, -1.95057473604111),
(36371, '83243', 218, 17, 21986, 42.2685, 0.737724494879223, -112.6159, -1.96551824509668),
(36372, '83244', 218, 17, 3253, 43.7985, 0.764428032434736, -113.0924, -1.97383473898244),
(36373, '83245', 218, 17, 195136, 42.7964, 0.746938088000501, -112.2343, -1.95885806867107),
(36374, '83246', 218, 17, 195219, 42.6095, 0.743676067628524, -112.0259, -1.95522080250992),
(36375, '83250', 218, 17, 195301, 42.6438, 0.744274715561958, -112.197, -1.95820706086008),
(36376, '83251', 218, 17, 95940, 43.908, 0.76633916796567, -113.6267, -1.98316003317584),
(36377, '83252', 218, 17, 195281, 42.1598, 0.735827321982305, -112.2873, -1.95978309317463),
(36378, '83253', 218, 17, 37104, 44.5773, 0.778020656649268, -113.8113, -1.98638191097502),
(36379, '83254', 218, 17, 23162, 42.3151, 0.738537818310653, -111.2948, -1.94246070034859),
(36380, '83255', 218, 17, 10581, 43.8664, 0.765613110996841, -113.0785, -1.97359213821641),
(36381, '83256', 218, 17, 4318, 43.2232, 0.754387153248013, -112.4417, -1.96247788153971),
(36382, '83261', 218, 17, 11069, 42.2296, 0.737045561800197, -111.407, -1.94441895976932),
(36383, '83262', 218, 17, 140703, 43.1497, 0.753104336247797, -112.6298, -1.96576084586271),
(36384, '83263', 218, 17, 5220, 42.1907, 0.736366628721172, -111.7913, -1.95112626008474),
(36385, '83271', 218, 17, 187, 42.5217, 0.742143668545273, -112.846, -1.96953424770552),
(36386, '83272', 218, 17, 11748, 42.0806, 0.734445021214726, -111.3124, -1.94276787829694),
(36387, '83274', 218, 17, 195602, 43.3793, 0.757111612210376, -112.1247, -1.95694518781089),
(36388, '83276', 218, 17, 98159, 42.7029, 0.745306205149887, -111.5706, -1.94727431842559),
(36389, '83277', 218, 17, 349, 43.0602, 0.751542266567262, -112.6625, -1.96633156852811),
(36390, '83278', 218, 17, 196, 44.33, 0.773704457409086, -114.8632, -2.00474102937675),
(36391, '83281', 218, 17, 195679, 42.3249, 0.738708860577348, -111.9965, -1.95470767570983),
(36392, '83283', 218, 17, 179326, 42.3874, 0.739799691359844, -111.719, -1.94986438703555),
(36393, '83285', 218, 17, 195781, 42.9551, 0.749707925523416, -111.1745, -1.94036106925844),
(36394, '83286', 218, 17, 6746, 42.0356, 0.733659623051328, -112.0148, -1.95502707096294),
(36395, '83287', 218, 17, 194932, 42.0217, 0.733417022285301, -111.4256, -1.94474359101019),
(36396, '83301', 218, 17, 179411, 42.5641, 0.742883688148118, -114.4642, -1.99777716566129),
(36397, '83302', 218, 17, 195553, 42.208, 0.736668570681767, -114.5932, -2.00002864039637),
(36398, '83303', 218, 17, 179411, 42.562, 0.742847036233827, -114.4628, -1.99775273105177),
(36399, '83311', 218, 17, 7043, 42.3935, 0.739906156444216, -113.5514, -1.98184580024909),
(36400, '83312', 218, 17, 34540, 42.3104, 0.738455787835809, -113.3213, -1.97782979764025),
(36401, '83313', 218, 17, 270, 43.4124, 0.757689316192786, -114.2025, -1.99320963900882),
(36402, '83314', 218, 17, 34861, 42.8979, 0.748709597191276, -114.9244, -2.00580917087897),
(36403, '83316', 218, 17, 1226, 42.6043, 0.74358531050742, -114.7626, -2.00298522814924),
(36404, '83318', 218, 17, 194662, 42.5301, 0.74229027620244, -113.7901, -1.9860119011736),
(36405, '83320', 218, 17, 1354, 43.3491, 0.756584522776274, -113.9063, -1.98803997376442),
(36406, '83321', 218, 17, 194701, 42.5213, 0.742136687228265, -114.8708, -2.0048736743999),
(36407, '83322', 218, 17, 196280, 43.3202, 0.756080122622448, -114.9969, -2.00707453458667),
(36408, '83323', 218, 17, 194824, 42.5185, 0.742087818009209, -113.6295, -1.9832089023949),
(36409, '83324', 218, 17, 160794, 42.911, 0.748938235323287, -114.2692, -1.9943737736199),
(36410, '83325', 218, 17, 2217, 42.6004, 0.743517242666592, -114.223, -1.99356743150548),
(36411, '83327', 218, 17, 2367, 43.4871, 0.758993077144026, -114.7734, -2.00317372370846),
(36412, '83328', 218, 17, 54754, 42.5777, 0.74312105292639, -114.6054, -2.00024157056511),
(36413, '83330', 218, 17, 194210, 42.9364, 0.749381548953293, -114.7164, -2.00217888603482),
(36414, '83332', 218, 17, 149373, 42.8191, 0.747334277740704, -114.8843, -2.00510929384892),
(36415, '83333', 218, 17, 55134, 43.5211, 0.759586489089704, -114.3067, -1.9950282720894),
(36416, '83334', 218, 17, 131199, 42.5141, 0.742011023522121, -114.3041, -1.99498289352885),
(36417, '83335', 218, 17, 32727, 42.5885, 0.743309548485605, -114.0814, -1.99109604528466),
(36418, '83336', 218, 17, 76077, 42.5614, 0.742836564258315, -113.7627, -1.98553368095855),
(36419, '83337', 218, 17, 21935, 43.3009, 0.755743274076813, -115.0507, -2.00801352172424),
(36420, '83338', 218, 17, 9752, 42.7097, 0.745424887539022, -114.4611, -1.99772306045448);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(36421, '83340', 218, 17, 76278, 43.664, 0.762080564590804, -114.367, -1.99608070562835),
(36422, '83341', 218, 17, 3526, 42.5421, 0.74249971571268, -114.362, -1.99599343916576),
(36423, '83342', 218, 17, 3962, 42.3028, 0.738323142812657, -113.3685, -1.97865359304719),
(36424, '83343', 218, 17, 195333, 42.7867, 0.746768791063058, -113.6311, -1.98323682766293),
(36425, '83344', 218, 17, 137028, 42.4927, 0.741637523062194, -114.1637, -1.99253245125905),
(36426, '83346', 218, 17, 818, 42.2339, 0.737120610958033, -113.868, -1.9873715126609),
(36427, '83347', 218, 17, 4904, 42.6187, 0.743836637919707, -113.7521, -1.98534867605784),
(36428, '83348', 218, 17, 195464, 43.2994, 0.755717094138033, -114.0937, -1.99131072078265),
(36429, '83349', 218, 17, 24305, 43.0516, 0.751392168251591, -114.1512, -1.99231428510255),
(36430, '83350', 218, 17, 11731, 42.6213, 0.743882016480259, -113.6742, -1.98398906457054),
(36431, '83352', 218, 17, 185128, 42.9379, 0.749407728892073, -114.4058, -1.99675789337813),
(36432, '83353', 218, 17, 6157, 43.7258, 0.763159178068537, -114.262, -1.99424810991376),
(36433, '83354', 218, 17, 6157, 43.726, 0.763162668727041, -114.2617, -1.99424287392601),
(36434, '83355', 218, 17, 69974, 42.7579, 0.746266136238483, -114.7046, -2.00197293718309),
(36435, '83401', 218, 17, 195125, 43.5102, 0.759396248201237, -111.9756, -1.95434290189616),
(36436, '83402', 218, 17, 195125, 43.4969, 0.759164119410721, -112.1144, -1.95676541889793),
(36437, '83403', 218, 17, 195125, 43.4779, 0.758832506852843, -111.983, -1.95447205626081),
(36438, '83404', 218, 17, 195125, 43.4726, 0.758740004402487, -112.013, -1.95499565503641),
(36439, '83405', 218, 17, 195125, 43.4914, 0.759068126301862, -112.1103, -1.9566938603986),
(36440, '83406', 218, 17, 195125, 43.4497, 0.75834032400378, -111.9642, -1.95414393436144),
(36441, '83414', 218, 59, 29092, 43.7368, 0.763351164286256, -111.2235, -1.94121628059191),
(36442, '83415', 218, 17, 195125, 43.4931, 0.759097796899146, -112.0346, -1.95537264615484),
(36443, '83420', 218, 17, 7180, 44.085, 0.7694284007417, -111.437, -1.94494255854492),
(36444, '83421', 218, 17, 8056, 43.9996, 0.767937889560497, -111.5693, -1.94725162914531),
(36445, '83422', 218, 17, 8598, 43.736, 0.76333720165224, -111.2227, -1.9412023179579),
(36446, '83423', 218, 17, 20689, 44.1758, 0.771013159702511, -112.229, -1.95876556622072),
(36447, '83424', 218, 17, 190971, 43.8867, 0.765967412834995, -111.1795, -1.94044833572104),
(36448, '83425', 218, 17, 21686, 43.9026, 0.766244920186062, -112.1408, -1.95722618582046),
(36449, '83427', 218, 17, 16558, 43.4565, 0.758459006392916, -111.8672, -1.952450964987),
(36450, '83428', 218, 17, 36581, 43.4078, 0.757609031047195, -111.2935, -1.94243801106831),
(36451, '83429', 218, 17, 122876, 44.4576, 0.775931497534631, -111.3455, -1.94334558227935),
(36452, '83431', 218, 17, 10065, 43.6959, 0.76263732462219, -112.0132, -1.95499914569491),
(36453, '83433', 218, 17, 0, 44.2859, 0.772934767208957, -111.5262, -1.9464993922377),
(36454, '83434', 218, 17, 195316, 43.7211, 0.763077147593693, -111.9898, -1.95459073864995),
(36455, '83435', 218, 17, 195338, 43.8729, 0.76572655739822, -112.5438, -1.96425986270599),
(36456, '83436', 218, 17, 67190, 43.8625, 0.765545043156013, -111.5188, -1.94637023787305),
(36457, '83438', 218, 17, 4872, 43.9568, 0.767190888640643, -111.7616, -1.95060789729689),
(36458, '83440', 218, 17, 61521, 43.8292, 0.764963848515099, -111.783, -1.95098139775682),
(36459, '83441', 218, 17, 61521, 43.7635, 0.763817167196538, -111.6101, -1.94796372348012),
(36460, '83442', 218, 17, 195529, 43.672, 0.762220190930964, -111.9028, -1.95307230220071),
(36461, '83443', 218, 17, 195532, 43.5967, 0.760905958004212, -111.6598, -1.94883115211836),
(36462, '83444', 218, 17, 5442, 43.7344, 0.763309276384208, -112.1256, -1.95696089577415),
(36463, '83445', 218, 17, 31028, 43.9708, 0.767435234735923, -111.6805, -1.94919243527353),
(36464, '83446', 218, 17, 5995, 44.3533, 0.774111119124801, -112.0029, -1.95481937678196),
(36465, '83447', 218, 17, 195645, 44.0267, 0.768410873787788, -111.2985, -1.94252527753091),
(36466, '83448', 218, 17, 187413, 43.8746, 0.765756227995504, -111.7345, -1.9501349130696),
(36467, '83449', 218, 17, 195678, 43.4363, 0.758106449884013, -111.2935, -1.94243801106831),
(36468, '83450', 218, 17, 195703, 43.8138, 0.764695067810292, -112.446, -1.96255293069754),
(36469, '83451', 218, 17, 195704, 43.9089, 0.766354875928938, -111.6603, -1.94883987876462),
(36470, '83452', 218, 17, 195706, 43.7969, 0.764400107166704, -111.1801, -1.94045880769655),
(36471, '83454', 218, 17, 195750, 43.5903, 0.760794256932084, -111.9628, -1.95411949975191),
(36472, '83455', 218, 17, 12551, 43.6056, 0.761061292307639, -111.1294, -1.93957392576579),
(36473, '83460', 218, 17, 61521, 43.8186, 0.764778843614387, -111.7828, -1.95097790709832),
(36474, '83462', 218, 17, 1362, 45.2714, 0.790134986987361, -113.8422, -1.98692121771389),
(36475, '83463', 218, 17, 194987, 45.5182, 0.794442459581283, -113.9834, -1.9893856226177),
(36476, '83464', 218, 17, 195221, 44.5986, 0.778392411779943, -113.3539, -1.9783987749764),
(36477, '83465', 218, 17, 195226, 44.8522, 0.782818566763001, -113.619, -1.98302564282344),
(36478, '83466', 218, 17, 56566, 45.3766, 0.791971073360459, -113.8699, -1.98740467391669),
(36479, '83467', 218, 17, 97759, 45.1725, 0.788408856357139, -113.8983, -1.98790034742426),
(36480, '83468', 218, 17, 195700, 44.9598, 0.784696541038147, -113.6441, -1.98346372046569),
(36481, '83469', 218, 17, 195609, 45.1103, 0.787323261562398, -114.4351, -1.99726927484896),
(36482, '83501', 218, 17, 3747, 46.391, 0.809675693292689, -116.9875, -2.04181705867687),
(36483, '83520', 218, 17, 194499, 46.5786, 0.812949930969431, -116.2525, -2.02898888867471),
(36484, '83522', 218, 17, 1802, 46.026, 0.80330524152291, -116.271, -2.02931177458633),
(36485, '83523', 218, 17, 194791, 46.2416, 0.80706817139021, -116.4717, -2.03281465039508),
(36486, '83524', 218, 17, 194802, 46.3572, 0.809085772005515, -116.6352, -2.03566826372209),
(36487, '83525', 218, 17, 32320, 45.8038, 0.799427119924979, -115.4212, -2.01447996660288),
(36488, '83526', 218, 17, 29787, 46.1301, 0.805122129274236, -116.4202, -2.0319158058303),
(36489, '83530', 218, 17, 41167, 45.9301, 0.801631470770248, -116.1189, -2.02665712879404),
(36490, '83531', 218, 17, 194922, 45.9266, 0.801570384246428, -116.1224, -2.02671821531786),
(36491, '83533', 218, 17, 195028, 46.1182, 0.804914435093249, -116.2807, -2.02948107152377),
(36492, '83535', 218, 17, 195166, 46.5727, 0.812846956543563, -116.7499, -2.03767015637413),
(36493, '83536', 218, 17, 195170, 46.2248, 0.806774956075875, -116.0299, -2.02510378575977),
(36494, '83537', 218, 17, 60474, 46.6452, 0.814112320251259, -116.5445, -2.03408525009053),
(36495, '83539', 218, 17, 195198, 46.1363, 0.80523033968786, -115.9682, -2.02402691761129),
(36496, '83540', 218, 17, 195215, 46.403, 0.809885132802929, -116.804, -2.03861437949946),
(36497, '83541', 218, 17, 36846, 46.5301, 0.812103446282214, -116.4032, -2.03161909985746),
(36498, '83542', 218, 17, 22766, 45.5358, 0.794749637529634, -116.3158, -2.03009368209122),
(36499, '83543', 218, 17, 195385, 46.2181, 0.806658019015991, -116.2485, -2.02891907550463),
(36500, '83544', 218, 17, 195420, 46.4808, 0.81124299896098, -116.2176, -2.02837976876576),
(36501, '83545', 218, 17, 17560, 46.4703, 0.811059739389521, -116.4167, -2.03185471930648),
(36502, '83546', 218, 17, 181, 46.4923, 0.81144371182496, -115.8114, -2.02129024134416),
(36503, '83547', 218, 17, 42644, 45.2836, 0.790347917156104, -116.3494, -2.03068011271989),
(36504, '83548', 218, 17, 195521, 46.3219, 0.808469670779561, -116.5401, -2.03400845560344),
(36505, '83549', 218, 17, 61543, 45.3642, 0.791754652533212, -116.3929, -2.03143933094451),
(36506, '83551', 218, 17, 24994, 46.4226, 0.81022721733632, -116.7581, -2.03781327337279),
(36507, '83552', 218, 17, 38389, 46.1198, 0.804942360361281, -115.9733, -2.02411592940314),
(36508, '83553', 218, 17, 195785, 46.3799, 0.809481961745718, -115.9447, -2.02361676523707),
(36509, '83554', 218, 17, 195793, 45.7514, 0.798512567396934, -116.2076, -2.02820523584056),
(36510, '83555', 218, 17, 12894, 46.2403, 0.807045482109934, -116.6088, -2.03520749679956),
(36511, '83601', 218, 17, 7187, 43.8373, 0.76510522018451, -115.2826, -2.01206094025962),
(36512, '83602', 218, 17, 7248, 44.1709, 0.770927638569163, -116.0299, -2.02510378575977),
(36513, '83604', 218, 17, 194648, 42.6797, 0.744901288763424, -115.93, -2.02336020183703),
(36514, '83605', 218, 17, 1290, 43.6591, 0.761995043457456, -116.7164, -2.03708547107471),
(36515, '83606', 218, 17, 1290, 43.7176, 0.763016061069873, -116.7417, -2.03752703937546),
(36516, '83607', 218, 17, 1290, 43.6634, 0.762070092615292, -116.6867, -2.03656710828687),
(36517, '83610', 218, 17, 1302, 44.5824, 0.77810966844112, -116.658, -2.03606619879154),
(36518, '83611', 218, 17, 26723, 44.764, 0.781279186362742, -115.6931, -2.01922551683905),
(36519, '83612', 218, 17, 8249, 44.6975, 0.780118542410165, -116.4606, -2.03262091884811),
(36520, '83615', 218, 17, 130518, 44.71, 0.780336708566665, -116.0964, -2.02626442971234),
(36521, '83616', 218, 17, 2149, 43.7103, 0.762888652034477, -116.3758, -2.03114087964242),
(36522, '83617', 218, 17, 32360, 43.8856, 0.765948214213223, -116.5263, -2.03376760016667),
(36523, '83619', 218, 17, 16149, 43.9965, 0.767883784353685, -116.9119, -2.04049758976236),
(36524, '83620', 218, 17, 87166, 44.8152, 0.782172794939763, -116.4388, -2.03224043707117),
(36525, '83622', 218, 17, 21343, 44.0814, 0.769365568888628, -115.4742, -2.01540499110644),
(36526, '83623', 218, 17, 195000, 42.9518, 0.7496503296581, -115.2985, -2.01233844761068),
(36527, '83624', 218, 17, 47582, 42.9857, 0.750241996274527, -116.0912, -2.02617367259124),
(36528, '83626', 218, 17, 32626, 43.6705, 0.762194010992184, -116.8205, -2.03890235882604),
(36529, '83627', 218, 17, 21692, 42.979, 0.750125059214643, -115.5607, -2.01691470090941),
(36530, '83628', 218, 17, 195105, 43.6038, 0.761029876381103, -116.9109, -2.04048013646984),
(36531, '83629', 218, 17, 9583, 43.9293, 0.766710923096345, -116.2913, -2.02966607642448),
(36532, '83630', 218, 17, 78496, 43.5949, 0.760874542077676, -116.7828, -2.03824436969803),
(36533, '83631', 218, 17, 195123, 43.8687, 0.765653253569636, -115.7734, -2.0206270162284),
(36534, '83632', 218, 17, 22157, 44.5331, 0.777249221119887, -116.3484, -2.03066265942737),
(36535, '83633', 218, 17, 41609, 42.861, 0.74806557069729, -115.2424, -2.01135931790031),
(36536, '83634', 218, 17, 195199, 43.4795, 0.758860432120875, -116.3915, -2.03141489633498),
(36537, '83635', 218, 17, 27657, 44.8329, 0.782481718217366, -116.0844, -2.02605499020211),
(36538, '83636', 218, 17, 195236, 43.8966, 0.766140200430943, -116.6478, -2.03588817520784),
(36539, '83637', 218, 17, 150418, 44.1421, 0.770424983744589, -115.5513, -2.01675063995972),
(36540, '83638', 218, 17, 42022, 44.9118, 0.783858782997189, -116.0978, -2.02628886432187),
(36541, '83639', 218, 17, 195291, 43.5161, 0.759499222627104, -116.7769, -2.03814139527217),
(36542, '83641', 218, 17, 60862, 43.3809, 0.757139537478408, -116.5535, -2.03424232972321),
(36543, '83642', 218, 17, 10448, 43.6089, 0.761118888172955, -116.3988, -2.03154230537038),
(36544, '83643', 218, 17, 10451, 44.6702, 0.779642067524371, -116.3803, -2.03121941945876),
(36545, '83644', 218, 17, 4185, 43.7222, 0.763096346215465, -116.604, -2.03512372099547),
(36546, '83645', 218, 17, 117, 44.391, 0.774769108252803, -116.6114, -2.03525287536012),
(36547, '83647', 218, 17, 4432, 43.136, 0.752865226140274, -115.6973, -2.01929882066764),
(36548, '83648', 218, 17, 0, 43.0559, 0.751467217409427, -115.8541, -2.02203549693476),
(36549, '83650', 218, 17, 23277, 42.9916, 0.750344970700394, -116.7048, -2.03688301288148),
(36550, '83651', 218, 17, 195370, 43.5821, 0.760651139933421, -116.5904, -2.0348863562172),
(36551, '83652', 218, 17, 195370, 43.7071, 0.762832801498414, -116.6195, -2.03539424702953),
(36552, '83653', 218, 17, 195370, 43.6343, 0.761562201802962, -116.4995, -2.03329985192713),
(36553, '83654', 218, 17, 195379, 44.9952, 0.785314387593352, -116.2903, -2.02964862313196),
(36554, '83655', 218, 17, 73673, 43.9602, 0.767250229835211, -116.8042, -2.03861787015796),
(36555, '83656', 218, 17, 195397, 43.7299, 0.763230736567868, -116.8042, -2.03861787015796),
(36556, '83657', 218, 17, 10934, 44.25, 0.772308194007491, -116.299, -2.02980046677689),
(36557, '83660', 218, 17, 11084, 43.7759, 0.764033588023786, -116.9357, -2.04091297812433),
(36558, '83661', 218, 17, 195447, 44.0736, 0.769229433206973, -116.9027, -2.04033701947118),
(36559, '83666', 218, 17, 184159, 43.9425, 0.766941306557608, -115.9453, -2.02362723721258),
(36560, '83669', 218, 17, 6054, 43.7047, 0.762790913596366, -116.4884, -2.03310612038016),
(36561, '83670', 218, 17, 195682, 43.9948, 0.767854113756401, -116.3269, -2.03028741363819),
(36562, '83671', 218, 17, 12663, 45.2642, 0.790009323281217, -115.6751, -2.01891135757369),
(36563, '83672', 218, 17, 195786, 44.2584, 0.772454801664658, -116.9479, -2.04112590829308),
(36564, '83676', 218, 17, 511, 43.6571, 0.761960136872416, -116.9093, -2.04045221120181),
(36565, '83677', 218, 17, 6982, 45.0459, 0.786199269524114, -115.3696, -2.01357937670885),
(36566, '83680', 218, 17, 10448, 43.611, 0.761155540087247, -116.4, -2.0315632493214),
(36567, '83686', 218, 17, 195370, 43.5316, 0.759769748661164, -116.5724, -2.03457219695184),
(36568, '83687', 218, 17, 195370, 43.5961, 0.7608954860287, -116.5371, -2.03395609572588),
(36569, '83701', 218, 17, 191146, 43.623, 0.761364979597486, -116.3205, -2.03017571256606),
(36570, '83702', 218, 17, 191146, 43.6281, 0.761453991389338, -116.2068, -2.02819127320655),
(36571, '83703', 218, 17, 191146, 43.6259, 0.761415594145794, -116.2623, -2.0291599309414),
(36572, '83704', 218, 17, 191146, 43.6309, 0.761502860608394, -116.2975, -2.02977428683811),
(36573, '83705', 218, 17, 191146, 43.5827, 0.760661611908933, -116.2181, -2.02838849541202),
(36574, '83706', 218, 17, 191146, 43.5899, 0.760787275615076, -116.1915, -2.02792423783099),
(36575, '83707', 218, 17, 191146, 43.6625, 0.762054384652024, -116.1682, -2.02751757611528),
(36576, '83708', 218, 17, 191146, 43.6139, 0.761206154635555, -116.2161, -2.02835358882698),
(36577, '83709', 218, 17, 191146, 43.574, 0.760509768264009, -116.2904, -2.02965036846121),
(36578, '83711', 218, 17, 191146, 43.6546, 0.761916503641117, -116.2794, -2.02945838224349),
(36579, '83712', 218, 17, 191146, 43.6015, 0.760989733808308, -116.1645, -2.02745299893295),
(36580, '83713', 218, 17, 191146, 43.6358, 0.761588381741742, -116.3033, -2.02987551593472),
(36581, '83714', 218, 17, 2657, 43.6382, 0.761630269643789, -116.2612, -2.02914073231963),
(36582, '83715', 218, 17, 191146, 43.5607, 0.760277639473494, -116.2164, -2.02835882481474),
(36583, '83716', 218, 17, 191146, 43.5322, 0.759780220636676, -116.1423, -2.02706553583901),
(36584, '83717', 218, 17, 191146, 43.6133, 0.761195682660043, -116.203, -2.02812495069497),
(36585, '83719', 218, 17, 191146, 43.5488, 0.760069945292507, -116.2882, -2.02961197121767),
(36586, '83720', 218, 17, 191146, 43.6157, 0.761237570562091, -116.2166, -2.02836231547324),
(36587, '83721', 218, 17, 191146, 43.6192, 0.761298657085911, -116.2079, -2.02821047182832),
(36588, '83722', 218, 17, 191146, 43.6138, 0.761204409306303, -116.2158, -2.02834835283923),
(36589, '83723', 218, 17, 191146, 43.614, 0.761207899964807, -116.2155, -2.02834311685147),
(36590, '83724', 218, 17, 191146, 43.6198, 0.761309129061423, -116.1955, -2.02799405100107),
(36591, '83725', 218, 17, 191146, 43.6038, 0.761029876381103, -116.2006, -2.02808306279292),
(36592, '83726', 218, 17, 191146, 43.4347, 0.758078524615981, -116.0043, -2.02465698147126),
(36593, '83727', 218, 17, 191146, 43.6149, 0.761223607928075, -116.2028, -2.02812146003647),
(36594, '83728', 218, 17, 191146, 43.6195, 0.761303893073667, -116.205, -2.02815985728001),
(36595, '83729', 218, 17, 191146, 43.6058, 0.761064782966143, -116.193, -2.02795041776977),
(36596, '83730', 218, 17, 191146, 43.6163, 0.761248042537603, -116.205, -2.02815985728001),
(36597, '83731', 218, 17, 191146, 43.7445, 0.76348555463866, -116.2007, -2.02808480812217),
(36598, '83732', 218, 17, 191146, 43.5489, 0.760071690621759, -116.2879, -2.02960673522991),
(36599, '83733', 218, 17, 191146, 43.6138, 0.761204409306303, -116.2154, -2.02834137152222),
(36600, '83735', 218, 17, 191146, 43.6122, 0.761176484038271, -116.1989, -2.02805339219564),
(36601, '83744', 218, 17, 191146, 43.6073, 0.761090962904923, -116.2869, -2.02958928193739),
(36602, '83756', 218, 17, 191146, 43.6144, 0.761214881281815, -116.2158, -2.02834835283923),
(36603, '83757', 218, 17, 191146, 43.6624, 0.762052639322772, -116.1674, -2.02750361348126),
(36604, '83788', 218, 17, 191146, 43.6298, 0.761483661986622, -116.2975, -2.02977428683811),
(36605, '83799', 218, 17, 191146, 43.6141, 0.761209645294059, -116.2025, -2.02811622404871),
(36606, '83801', 218, 17, 31693, 47.9366, 0.836651502211514, -116.678, -2.03641526464194),
(36607, '83802', 218, 17, 7205, 47.2196, 0.824137491474714, -115.8161, -2.021372271819),
(36608, '83803', 218, 17, 15138, 47.9825, 0.837452608338179, -116.5635, -2.03441686264841),
(36609, '83804', 218, 17, 13397, 48.0137, 0.837997151064801, -116.9552, -2.04125331732847),
(36610, '83805', 218, 17, 194627, 48.6982, 0.849943929794703, -116.3172, -2.03011811670075),
(36611, '83806', 218, 17, 194635, 46.8628, 0.817910156703599, -116.3944, -2.03146551088329),
(36612, '83808', 218, 17, 194672, 47.2559, 0.824771045993188, -116.2123, -2.02828726631541),
(36613, '83809', 218, 17, 194691, 48.0495, 0.838621978937015, -116.5725, -2.03457394228109),
(36614, '83810', 218, 17, 194703, 47.5531, 0.829958164530116, -116.4411, -2.03228057964397),
(36615, '83811', 218, 17, 194735, 48.1465, 0.84031494831145, -116.1762, -2.02765720245544),
(36616, '83812', 218, 17, 194737, 47.041, 0.821020333430653, -116.261, -2.02913724166113),
(36617, '83813', 218, 17, 194757, 48.1138, 0.839744225646048, -116.6506, -2.0359370444269),
(36618, '83814', 218, 17, 194758, 47.6844, 0.832249781837984, -116.7793, -2.03818328317421),
(36619, '83815', 218, 17, 194758, 47.7273, 0.83299852808709, -116.788, -2.03833512681914),
(36620, '83816', 218, 17, 194758, 47.67, 0.831998454425697, -116.7803, -2.03820073646673),
(36621, '83821', 218, 17, 194774, 48.4985, 0.84645850727847, -116.8383, -2.03921302743289),
(36622, '83822', 218, 17, 28129, 48.1786, 0.84087519900134, -117.035, -2.04264609007156),
(36623, '83823', 218, 17, 194823, 46.8042, 0.81688739376193, -116.5393, -2.03399449296943),
(36624, '83824', 218, 17, 0, 47.147, 0.822870382437767, -116.9159, -2.04056740293244),
(36625, '83825', 218, 17, 8583, 48.2533, 0.84217895995258, -116.6004, -2.0350608891424),
(36626, '83826', 218, 17, 8671, 48.9898, 0.855033309893518, -116.1781, -2.02769036371122),
(36627, '83827', 218, 17, 135184, 46.7829, 0.816515638631255, -116.1791, -2.02770781700374),
(36628, '83830', 218, 17, 13762, 47.119, 0.822381690247208, -116.3672, -2.03099078132675),
(36629, '83832', 218, 17, 130966, 46.5565, 0.81256421320474, -116.9425, -2.04103166051347),
(36630, '83833', 218, 17, 9353, 47.4517, 0.828188400668593, -116.7773, -2.03814837658917),
(36631, '83834', 218, 17, 9370, 46.9404, 0.819264532203146, -116.5819, -2.03473800323078),
(36632, '83835', 218, 17, 3019, 47.777, 0.833865956725331, -116.7639, -2.03791450246941),
(36633, '83836', 218, 17, 665, 48.2403, 0.841952067149821, -116.2942, -2.02971669097279),
(36634, '83837', 218, 17, 27611, 47.5352, 0.829645750594009, -116.1178, -2.02663793017227),
(36635, '83839', 218, 17, 3542, 47.5619, 0.830111753504291, -116.2934, -2.02970272833877),
(36636, '83840', 218, 17, 195196, 48.3391, 0.843676452450791, -116.4664, -2.03272214794472),
(36637, '83841', 218, 17, 32957, 48.188, 0.841039259951028, -116.906, -2.04039461533649),
(36638, '83842', 218, 17, 195313, 47.4393, 0.827971979841346, -116.5338, -2.03389849986057),
(36639, '83843', 218, 17, 4344, 46.7305, 0.81560108610321, -116.9678, -2.04147322881422),
(36640, '83844', 218, 17, 4344, 46.7301, 0.815594104786202, -116.9968, -2.0419793742973),
(36641, '83845', 218, 17, 195357, 48.6966, 0.849916004526671, -116.3044, -2.02989471455649),
(36642, '83846', 218, 17, 195361, 47.4678, 0.828469398678164, -115.7965, -2.02103018728561),
(36643, '83847', 218, 17, 17231, 48.6953, 0.849893315246395, -116.3032, -2.02987377060547),
(36644, '83848', 218, 17, 195390, 48.6644, 0.849354008507529, -116.9477, -2.04112241763457),
(36645, '83849', 218, 17, 42453, 47.5071, 0.829155313074198, -116.0004, -2.02458891363043),
(36646, '83850', 218, 17, 23951, 47.5359, 0.829657967898772, -116.2362, -2.02870440000663),
(36647, '83851', 218, 17, 17672, 47.3378, 0.826200470650572, -116.8805, -2.03994955637723),
(36648, '83852', 218, 17, 195487, 48.3075, 0.843124928407161, -116.5271, -2.03378156280068),
(36649, '83853', 218, 17, 195489, 48.9769, 0.854808162420011, -116.4816, -2.03298743799103),
(36650, '83854', 218, 17, 195491, 47.7183, 0.83284144845441, -116.9458, -2.04108925637878),
(36651, '83855', 218, 17, 195492, 47.0118, 0.82051069728907, -116.9302, -2.04081698501547),
(36652, '83856', 218, 17, 195501, 48.1848, 0.840983409414964, -116.9102, -2.04046791916507),
(36653, '83857', 218, 17, 5231, 46.9121, 0.818770604024832, -116.8121, -2.03875575116887),
(36654, '83858', 218, 17, 193153, 47.8176, 0.83457456040164, -116.8739, -2.0398343646466),
(36655, '83860', 218, 17, 209868, 48.2026, 0.841294078021819, -116.5723, -2.03457045162259),
(36656, '83861', 218, 17, 195575, 47.3157, 0.825814752885881, -116.5732, -2.03458615958585),
(36657, '83862', 218, 17, 38088, 48.3796, 0.844383310797849, -116.4616, -2.03263837214063),
(36658, '83864', 218, 17, 195584, 48.3005, 0.843002755359521, -116.5337, -2.03389675453132),
(36659, '83865', 218, 17, 113375, 48.3977, 0.84469921539246, -116.534, -2.03390199051907),
(36660, '83866', 218, 17, 195587, 47.241, 0.824510991934641, -116.5459, -2.03410968470006),
(36661, '83867', 218, 17, 57571, 47.4952, 0.828947618893211, -115.9558, -2.02381049678404),
(36662, '83868', 218, 17, 195625, 47.542, 0.829764432983144, -116.1822, -2.02776192221056),
(36663, '83869', 218, 17, 117859, 47.9644, 0.837136703743568, -116.857, -2.03953940400301),
(36664, '83870', 218, 17, 195702, 47.1848, 0.82353011689502, -116.8708, -2.03978025943979),
(36665, '83871', 218, 17, 199, 46.7393, 0.815754675077386, -116.7694, -2.03801049557827),
(36666, '83872', 218, 17, 12571, 46.8634, 0.817920628679111, -116.9777, -2.04164601641017),
(36667, '83873', 218, 17, 721, 47.468, 0.828472889336668, -115.9293, -2.02334798453226),
(36668, '83874', 218, 17, 10715, 47.6267, 0.831242726859583, -115.8571, -2.02208785681232),
(36669, '83876', 218, 17, 38969, 47.4445, 0.82806273696245, -116.9123, -2.04050457107937),
(36670, '83877', 218, 17, 195491, 47.7125, 0.832740219357794, -116.9441, -2.0410595857815),
(36671, '83888', 218, 17, 195584, 48.2756, 0.842568168375775, -116.5478, -2.03414284595585),
(36672, '84001', 218, 52, 26361, 40.4019, 0.705146179061497, -110.4683, -1.92803555408085),
(36673, '84002', 218, 52, 158662, 40.4649, 0.706245736490253, -110.4654, -1.92798493953254),
(36674, '84003', 218, 52, 209908, 40.3838, 0.704830274466886, -111.7927, -1.95115069469426),
(36675, '84004', 218, 52, 7073, 40.458, 0.706125308771866, -111.7691, -1.95073879699079),
(36676, '84006', 218, 52, 0, 40.5818, 0.708286026385835, -112.1127, -1.95673574830065),
(36677, '84007', 218, 52, 71858, 40.3338, 0.703957609840889, -110.3316, -1.92564968899338),
(36678, '84008', 218, 52, 7590, 40.4558, 0.706086911528322, -109.5354, -1.911753377489),
(36679, '84010', 218, 52, 186436, 40.8758, 0.713417294386698, -111.8718, -1.95253125013259),
(36680, '84011', 218, 52, 186436, 40.8759, 0.71341903971595, -111.8654, -1.95241954906046),
(36681, '84013', 218, 52, 19889, 40.3241, 0.703788312903445, -112.0494, -1.95563095488413),
(36682, '84014', 218, 52, 1459, 40.9232, 0.714244580452143, -111.8773, -1.95262724324145),
(36683, '84015', 218, 52, 13564, 41.1197, 0.717674152432312, -112.0281, -1.95525919975346),
(36684, '84016', 218, 52, 13564, 41.1046, 0.717410607715261, -112.0223, -1.95515797065684),
(36685, '84017', 218, 52, 59051, 40.874, 0.713385878460162, -111.3919, -1.94415541505227),
(36686, '84018', 218, 52, 143681, 41.1004, 0.717337303886677, -111.5013, -1.94606480525395),
(36687, '84020', 218, 52, 35628, 40.5235, 0.707268499431922, -111.8765, -1.95261328060744),
(36688, '84021', 218, 52, 203762, 40.1697, 0.701093524538366, -110.3981, -1.92681033294595),
(36689, '84022', 218, 52, 148349, 40.2427, 0.702367614892322, -112.7242, -1.96740843667659),
(36690, '84023', 218, 52, 203775, 40.9304, 0.714370244158287, -109.3919, -1.90924883001239),
(36691, '84024', 218, 52, 2207, 40.9657, 0.714986345384241, -111.4206, -1.94465632454759),
(36692, '84025', 218, 52, 8849, 40.9896, 0.715403479075468, -111.8974, -1.9529780544211),
(36693, '84026', 218, 52, 204004, 40.2957, 0.703292639395879, -109.8386, -1.91704521578104),
(36694, '84027', 218, 52, 16149, 40.2123, 0.701837034799716, -110.8384, -1.93449501764248),
(36695, '84028', 218, 52, 2657, 41.9126, 0.731512868071375, -111.4006, -1.9443072586972),
(36696, '84029', 218, 52, 47588, 40.6027, 0.708650800199502, -112.46, -1.96279727679282),
(36697, '84030', 218, 52, 204188, 40.3024, 0.703409576455763, -109.8181, -1.91668742328438),
(36698, '84031', 218, 52, 9318, 40.4363, 0.705746572324183, -110.8276, -1.93430652208327),
(36699, '84032', 218, 52, 204252, 40.5055, 0.706954340166563, -111.4043, -1.94437183587952),
(36700, '84033', 218, 52, 204263, 41.0201, 0.715935804497326, -111.5005, -1.94605084261994),
(36701, '84034', 218, 52, 204438, 40.0351, 0.698744311365182, -113.9845, -1.98940482123948),
(36702, '84035', 218, 52, 192639, 40.3801, 0.704765697284562, -109.3163, -1.90792936109788),
(36703, '84036', 218, 52, 204512, 40.6448, 0.709385583814591, -111.2837, -1.94226696880161),
(36704, '84037', 218, 52, 204519, 41.0347, 0.716190622568117, -111.9284, -1.95351910648922),
(36705, '84038', 218, 52, 204618, 41.8471, 0.730369677411319, -111.3475, -1.94338048886439),
(36706, '84039', 218, 52, 204645, 40.3858, 0.704865181051926, -109.7959, -1.91629996019044),
(36707, '84040', 218, 52, 16862, 41.0812, 0.717002200670295, -111.9259, -1.95347547325792),
(36708, '84041', 218, 52, 16862, 41.0764, 0.716918424866199, -111.96, -1.95407063053285),
(36709, '84042', 218, 52, 186990, 40.3459, 0.70416879468038, -111.7321, -1.95009302516756),
(36710, '84043', 218, 52, 10026, 40.3927, 0.704985608770313, -111.8454, -1.95207048321007),
(36711, '84044', 218, 52, 204768, 40.7019, 0.71038216681748, -112.0789, -1.95614582701347),
(36712, '84046', 218, 52, 3968, 40.9927, 0.71545758428228, -109.7145, -1.91487926217932),
(36713, '84047', 218, 52, 117, 40.6145, 0.708856749051237, -111.8813, -1.95269705641153),
(36714, '84049', 218, 52, 41, 40.5198, 0.707203922249598, -111.4702, -1.94552200785658),
(36715, '84050', 218, 52, 4319, 41.0605, 0.716640917515132, -111.7178, -1.94984344308452),
(36716, '84051', 218, 52, 4432, 40.1801, 0.701275038780574, -110.7456, -1.93287535209663),
(36717, '84052', 218, 52, 205077, 40.1981, 0.701589198045933, -110.059, -1.92089192145244),
(36718, '84053', 218, 52, 33393, 40.5101, 0.707034625312155, -110.0966, -1.92154816525119),
(36719, '84054', 218, 52, 205147, 40.8473, 0.71291987554988, -111.9035, -1.95308451950547),
(36720, '84055', 218, 52, 818, 40.7129, 0.710574153035199, -111.2919, -1.94241008580028),
(36721, '84056', 218, 52, 0, 41.1107, 0.717517072799633, -111.995, -1.95468149577105),
(36722, '84057', 218, 52, 205258, 40.3138, 0.70360854399049, -111.6966, -1.9494734332831),
(36723, '84058', 218, 52, 205258, 40.2811, 0.703037821325088, -111.6959, -1.94946121597833),
(36724, '84059', 218, 52, 205258, 40.3151, 0.703631233270766, -111.7233, -1.94993943619338),
(36725, '84060', 218, 52, 4864, 40.6973, 0.710301881671888, -111.527, -1.94651335487172),
(36726, '84061', 218, 52, 205335, 40.7133, 0.710581134352207, -111.3348, -1.94315883204938),
(36727, '84062', 218, 52, 5115, 40.3632, 0.704470736640975, -111.7265, -1.94999528672944),
(36728, '84063', 218, 52, 77040, 40.2082, 0.701765476300384, -109.7286, -1.91512535360385),
(36729, '84064', 218, 52, 5293, 41.6955, 0.727723758265296, -111.1501, -1.93993520892095),
(36730, '84065', 218, 52, 5429, 40.5351, 0.707470957625153, -111.9631, -1.95412473573966),
(36731, '84066', 218, 52, 5534, 40.299, 0.703350235261195, -109.9983, -1.91983250659648),
(36732, '84067', 218, 52, 11712, 41.1719, 0.718585214301853, -112.0444, -1.95554368842153),
(36733, '84068', 218, 52, 4864, 40.6689, 0.709806208164322, -111.5029, -1.94609273052199),
(36734, '84069', 218, 52, 205643, 40.3474, 0.70419497461916, -112.456, -1.96272746362274),
(36735, '84070', 218, 52, 11802, 40.5842, 0.708327914287883, -111.859, -1.95230784798834),
(36736, '84071', 218, 52, 510, 40.4512, 0.70600662638273, -112.3604, -1.96105892885784),
(36737, '84072', 218, 52, 206021, 40.3735, 0.704650505553931, -110.678, -1.93169550952228),
(36738, '84073', 218, 52, 34112, 40.1768, 0.701217442915258, -110.3926, -1.92671433983709),
(36739, '84074', 218, 52, 206135, 40.5593, 0.707893327304136, -112.2947, -1.95991224753928),
(36740, '84075', 218, 52, 57818, 41.0884, 0.717127864376438, -112.0527, -1.95568855074945),
(36741, '84076', 218, 52, 206157, 40.4658, 0.706261444453521, -109.812, -1.91658095820001),
(36742, '84078', 218, 52, 62160, 40.4717, 0.706364418879389, -109.5683, -1.9123275908129),
(36743, '84079', 218, 52, 62160, 40.4523, 0.706025825004502, -109.5357, -1.91175861347675),
(36744, '84080', 218, 52, 6535, 40.0362, 0.698763509986954, -112.3859, -1.9615039878171),
(36745, '84082', 218, 52, 206320, 40.3736, 0.704652250883183, -111.4033, -1.944354382587),
(36746, '84083', 218, 52, 38798, 40.7368, 0.710991286726426, -114.0218, -1.99005582905047),
(36747, '84084', 218, 52, 206389, 40.6203, 0.708957978147853, -111.9673, -1.95419803956825),
(36748, '84085', 218, 52, 206476, 40.4841, 0.706580839706636, -109.9192, -1.91845195115815),
(36749, '84086', 218, 52, 513, 41.4906, 0.724147578627959, -111.1608, -1.94012195915091),
(36750, '84087', 218, 52, 206602, 40.8825, 0.713534231446582, -111.9038, -1.95308975549323),
(36751, '84088', 218, 52, 206389, 40.5944, 0.708505937871586, -111.9699, -1.9542434181288),
(36752, '84089', 218, 52, 13564, 41.1109, 0.717520563458137, -112.0251, -1.9552068398759),
(36753, '84090', 218, 52, 11802, 40.5692, 0.708066114900084, -111.8541, -1.95222232685499),
(36754, '84091', 218, 52, 11802, 40.5859, 0.708357584885167, -111.8203, -1.95163240556782),
(36755, '84092', 218, 52, 11802, 40.5755, 0.708176070642959, -111.8254, -1.95172141735967),
(36756, '84093', 218, 52, 11802, 40.5941, 0.70850070188383, -111.8288, -1.95178075855423),
(36757, '84094', 218, 52, 11802, 40.5655, 0.70800153771776, -111.8611, -1.95234449990263),
(36758, '84095', 218, 52, 205826, 40.5693, 0.708067860229336, -111.9676, -1.954203275556),
(36759, '84097', 218, 52, 205258, 40.3069, 0.703488116272102, -111.6765, -1.94912262210345),
(36760, '84098', 218, 52, 4864, 40.6565, 0.709589787337075, -111.4928, -1.94591645226753),
(36761, '84101', 218, 52, 205657, 40.7553, 0.711314172638045, -111.8984, -1.95299550771362),
(36762, '84102', 218, 52, 205657, 40.7594, 0.711385731137377, -111.8647, -1.9524073317557),
(36763, '84103', 218, 52, 205657, 40.7787, 0.711722579683012, -111.8754, -1.95259408198566),
(36764, '84104', 218, 52, 205657, 40.7489, 0.711202471565917, -111.9325, -1.95359066498855),
(36765, '84105', 218, 52, 205657, 40.737, 0.71099477738493, -111.8571, -1.95227468673255),
(36766, '84106', 218, 52, 205657, 40.7049, 0.71043452669504, -111.8556, -1.95224850679377),
(36767, '84107', 218, 52, 205657, 40.6596, 0.709643892543886, -111.8808, -1.95268832976527),
(36768, '84108', 218, 52, 205657, 40.7412, 0.711068081213514, -111.8115, -1.95147881659364),
(36769, '84109', 218, 52, 205657, 40.7031, 0.710403110768504, -111.8152, -1.95154339377596),
(36770, '84110', 218, 52, 205657, 40.7561, 0.711328135272061, -111.9002, -1.95302692364016),
(36771, '84111', 218, 52, 205657, 40.7541, 0.711293228687021, -111.8822, -1.9527127643748),
(36772, '84112', 218, 52, 205657, 40.7611, 0.711415401734661, -111.8345, -1.9518802423216),
(36773, '84113', 218, 52, 205657, 40.7588, 0.711375259161865, -111.8367, -1.95191863956514),
(36774, '84114', 218, 52, 205657, 40.799, 0.712076881521167, -111.8595, -1.9523165746346),
(36775, '84115', 218, 52, 205657, 40.7162, 0.710631748900515, -111.8896, -1.95284191873945),
(36776, '84116', 218, 52, 205657, 40.7876, 0.711877913986439, -111.9308, -1.95356099439127),
(36777, '84117', 218, 52, 205657, 40.6625, 0.709694507092194, -111.8363, -1.95191165824813),
(36778, '84118', 218, 52, 205657, 40.6532, 0.709532191471759, -111.9847, -1.95450172685809),
(36779, '84119', 218, 52, 205657, 40.6934, 0.71023381383106, -111.95, -1.95389609760765),
(36780, '84120', 218, 52, 205657, 40.6883, 0.710144802039209, -112.0097, -1.95493805917109),
(36781, '84121', 218, 52, 205657, 40.6245, 0.709031281976436, -111.8245, -1.9517057093964),
(36782, '84122', 218, 52, 205657, 40.8002, 0.71209782547219, -111.9594, -1.95406015855734),
(36783, '84123', 218, 52, 205657, 40.6593, 0.70963865655613, -111.9207, -1.95338471613682),
(36784, '84124', 218, 52, 205657, 40.6833, 0.710057535576609, -111.829, -1.95178424921274),
(36785, '84125', 218, 52, 205657, 40.7004, 0.7103559868787, -111.946, -1.95382628443757),
(36786, '84126', 218, 52, 205657, 40.7008, 0.710362968195708, -111.9463, -1.95383152042533),
(36787, '84127', 218, 52, 205657, 40.7004, 0.7103559868787, -111.9455, -1.95381755779131),
(36788, '84128', 218, 52, 205657, 40.7047, 0.710431036036536, -112.0438, -1.95553321644602),
(36789, '84130', 218, 52, 205657, 40.7007, 0.710361222866456, -111.9461, -1.95382802976682),
(36790, '84131', 218, 52, 205657, 40.7009, 0.71036471352496, -111.9457, -1.95382104844982),
(36791, '84132', 218, 52, 205657, 40.7662, 0.711504413526512, -111.8418, -1.95200765135699),
(36792, '84133', 218, 52, 205657, 40.7559, 0.711324644613557, -111.8824, -1.9527162550333),
(36793, '84134', 218, 52, 205657, 40.7719, 0.711603897293876, -111.9442, -1.95379486851104),
(36794, '84135', 218, 52, 205657, 40.7263, 0.710808027154967, -111.94, -1.95372156468245),
(36795, '84136', 218, 52, 205657, 40.7686, 0.71154630142856, -111.8875, -1.95280526682516),
(36796, '84138', 218, 52, 205657, 40.7551, 0.711310681979541, -111.8826, -1.95271974569181),
(36797, '84139', 218, 52, 205657, 40.7664, 0.711507904185016, -111.8865, -1.95278781353264),
(36798, '84140', 218, 52, 205657, 40.7643, 0.711471252270725, -111.891, -1.95286635334898),
(36799, '84141', 218, 52, 205657, 40.6681, 0.709792245530306, -111.864, -1.95239511445094),
(36800, '84142', 218, 52, 205657, 40.7658, 0.711497432209504, -111.8907, -1.95286111736122),
(36801, '84143', 218, 52, 205657, 40.778, 0.711710362378248, -111.88, -1.95267436713126),
(36802, '84144', 218, 52, 205657, 40.7547, 0.711303700662533, -111.8966, -1.95296409178709),
(36803, '84145', 218, 52, 205657, 40.7551, 0.711310681979541, -111.8995, -1.95301470633539),
(36804, '84147', 218, 52, 205657, 40.7556, 0.711319408625801, -111.8845, -1.9527529069476),
(36805, '84148', 218, 52, 205657, 40.7565, 0.711335116589069, -111.8347, -1.9518837329801),
(36806, '84150', 218, 52, 205657, 40.7715, 0.711596915976868, -111.889, -1.95283144676394),
(36807, '84151', 218, 52, 205657, 40.7878, 0.711881404644943, -111.9404, -1.95372854599946),
(36808, '84152', 218, 52, 205657, 40.7279, 0.710835952422998, -111.8598, -1.95232181062235),
(36809, '84153', 218, 52, 205657, 40.777, 0.711692909085728, -111.9298, -1.95354354109875),
(36810, '84157', 218, 52, 205657, 40.6582, 0.709619457934359, -111.8844, -1.95275116161834),
(36811, '84158', 218, 52, 205657, 40.7363, 0.710982560080166, -111.8173, -1.95158004569026),
(36812, '84165', 218, 52, 205657, 40.7148, 0.710607314290987, -111.8928, -1.95289776927551),
(36813, '84170', 218, 52, 205657, 40.7, 0.710349005561692, -112.0139, -1.95501136299968),
(36814, '84171', 218, 52, 205657, 40.6228, 0.709001611379153, -111.809, -1.95143518336234),
(36815, '84180', 218, 52, 205657, 40.7548, 0.711305445991785, -111.8964, -1.95296060112858),
(36816, '84184', 218, 52, 205657, 40.6771, 0.709949325162985, -111.9575, -1.95402699730155),
(36817, '84189', 218, 52, 205657, 40.7684, 0.711542810770056, -111.8904, -1.95285588137346),
(36818, '84190', 218, 52, 205657, 40.7267, 0.710815008471975, -111.8871, -1.95279828550815),
(36819, '84194', 218, 52, 205657, 40.7612, 0.711417147063913, -111.8902, -1.95285239071496),
(36820, '84199', 218, 52, 205657, 40.7265, 0.710811517813471, -111.9392, -1.95370760204844),
(36821, '84201', 218, 52, 10927, 41.2441, 0.719845342021793, -111.9976, -1.9547268743316),
(36822, '84244', 218, 52, 10927, 41.2627, 0.720169973262664, -111.9691, -1.95422945549478),
(36823, '84301', 218, 52, 202991, 41.5974, 0.726011590269089, -112.1276, -1.95699580235919),
(36824, '84302', 218, 52, 203145, 41.5193, 0.724648488123282, -112.0215, -1.95514400802283),
(36825, '84304', 218, 52, 203230, 41.8359, 0.730174200535096, -112.0015, -1.95479494217243),
(36826, '84305', 218, 52, 20075, 41.9206, 0.731652494411535, -112.0355, -1.95538835411811),
(36827, '84306', 218, 52, 39850, 41.7899, 0.729371349079178, -112.072, -1.95602539929509),
(36828, '84307', 218, 52, 75531, 41.4251, 0.723004387967903, -112.2963, -1.95994017280731),
(36829, '84308', 218, 52, 59112, 41.9691, 0.732498979098752, -112.0036, -1.95483159408672),
(36830, '84309', 218, 52, 93723, 41.707, 0.727924471129275, -112.0915, -1.95636573849922),
(36831, '84310', 218, 52, 2217, 41.3147, 0.721077544473701, -111.8349, -1.95188722363861),
(36832, '84311', 218, 52, 115566, 41.8149, 0.729807681392177, -112.1207, -1.95687537464081),
(36833, '84312', 218, 52, 2663, 41.7474, 0.728629584147081, -112.151, -1.95740420940416),
(36834, '84313', 218, 52, 204184, 41.4415, 0.72329062196523, -113.768, -1.98562618340891),
(36835, '84314', 218, 52, 16487, 41.6418, 0.726786516456975, -112.0907, -1.95635177586521),
(36836, '84315', 218, 52, 16490, 41.1748, 0.718635828850161, -112.0823, -1.95620516820804),
(36837, '84316', 218, 52, 9597, 41.7811, 0.729217760105003, -112.4299, -1.96227193268797),
(36838, '84317', 218, 52, 3297, 41.2906, 0.720656920123971, -111.6865, -1.94929715502865),
(36839, '84318', 218, 52, 3310, 41.7999, 0.729545882004378, -111.8142, -1.95152594048344),
(36840, '84319', 218, 52, 204437, 41.6314, 0.726605002214767, -111.8379, -1.95193958351617),
(36841, '84320', 218, 52, 3747, 41.9693, 0.732502469757256, -111.8328, -1.95185057172431),
(36842, '84321', 218, 52, 3843, 41.7323, 0.72836603943003, -111.8218, -1.9516585855066),
(36843, '84322', 218, 52, 3843, 41.7469, 0.728620857500821, -111.8094, -1.95144216467935),
(36844, '84323', 218, 52, 3843, 41.6854, 0.727547480010844, -111.6486, -1.94863567524214),
(36845, '84324', 218, 52, 3977, 41.4971, 0.724261025029339, -111.9378, -1.95368316743891),
(36846, '84325', 218, 52, 56203, 41.7032, 0.727858148617699, -111.9739, -1.95431323129888),
(36847, '84326', 218, 52, 4227, 41.6838, 0.727519554742812, -111.8199, -1.95162542425081),
(36848, '84327', 218, 52, 4570, 41.8612, 0.73061576883585, -111.9896, -1.95458724799144),
(36849, '84328', 218, 52, 11064, 41.5614, 0.725383271738371, -111.8334, -1.95186104369983),
(36850, '84329', 218, 52, 205296, 41.5037, 0.724376216759971, -113.2489, -1.97656617926181),
(36851, '84330', 218, 52, 14433, 41.9069, 0.731413384304012, -112.1564, -1.95749845718377),
(36852, '84331', 218, 52, 42669, 41.9761, 0.732621152146392, -112.1897, -1.95807965182468),
(36853, '84332', 218, 52, 966, 41.7004, 0.727809279398643, -111.807, -1.9514002767773),
(36854, '84333', 218, 52, 5381, 41.9203, 0.731647258423779, -111.8056, -1.95137584216777),
(36855, '84334', 218, 52, 5423, 41.7841, 0.729270119982563, -112.1336, -1.95710052211431),
(36856, '84335', 218, 52, 5916, 41.8375, 0.730202125803128, -111.8511, -1.95216996697743),
(36857, '84336', 218, 52, 74329, 41.8389, 0.730226560412656, -112.5925, -1.96510983805172),
(36858, '84337', 218, 52, 206150, 41.7028, 0.727851167300691, -112.2221, -1.95864513850233),
(36859, '84338', 218, 52, 6381, 41.9295, 0.731807828714962, -111.9354, -1.95364127953686),
(36860, '84339', 218, 52, 34380, 41.6599, 0.727102421051586, -111.9403, -1.95372680067021),
(36861, '84340', 218, 52, 26074, 41.4032, 0.722622160861716, -112.034, -1.95536217417933),
(36862, '84341', 218, 52, 3843, 41.7794, 0.729188089507719, -111.8207, -1.95163938688482),
(36863, '84401', 218, 52, 10927, 41.2192, 0.719410755038047, -111.9837, -1.95448427356557),
(36864, '84402', 218, 52, 10927, 41.2253, 0.719517220122418, -112.0213, -1.95514051736432),
(36865, '84403', 218, 52, 10927, 41.1874, 0.718855740335912, -111.9429, -1.95377217923076),
(36866, '84404', 218, 52, 10927, 41.2769, 0.720417810016447, -111.9874, -1.9545488507479),
(36867, '84405', 218, 52, 10927, 41.1813, 0.718749275251541, -111.9703, -1.95425039944581),
(36868, '84407', 218, 52, 10927, 41.2441, 0.719845342021793, -111.9673, -1.95419803956825),
(36869, '84408', 218, 52, 10927, 41.1909, 0.718916826859732, -111.9431, -1.95377566988926),
(36870, '84409', 218, 52, 10927, 41.1909, 0.718916826859732, -111.9476, -1.9538542097056),
(36871, '84412', 218, 52, 10927, 41.303, 0.720873340951218, -111.9478, -1.95385770036411),
(36872, '84414', 218, 52, 10927, 41.3162, 0.721103724412481, -111.9781, -1.95438653512746),
(36873, '84415', 218, 52, 10927, 41.2231, 0.719478822878875, -111.9733, -1.95430275932337),
(36874, '84501', 218, 52, 11399, 39.5976, 0.691108495887707, -110.8023, -1.93386495378251),
(36875, '84510', 218, 52, 192467, 37.2082, 0.649405598740554, -109.2915, -1.90749651944338),
(36876, '84511', 218, 52, 118844, 37.6434, 0.657001271645233, -109.4657, -1.91053688300036),
(36877, '84512', 218, 52, 217, 37.2818, 0.650690161070022, -109.5668, -1.91230141087412),
(36878, '84513', 218, 52, 192508, 39.2146, 0.684423884852568, -111.027, -1.93778670861174),
(36879, '84515', 218, 52, 8084, 38.9706, 0.680165281477702, -109.3187, -1.90797124899993),
(36880, '84516', 218, 52, 93282, 39.1379, 0.683085217316289, -111.0967, -1.93900320310038),
(36881, '84518', 218, 52, 1620, 39.3494, 0.686776588684257, -110.8523, -1.93473761840851),
(36882, '84520', 218, 52, 0, 39.5436, 0.69016601809163, -110.4133, -1.92707562299226),
(36883, '84521', 218, 52, 8744, 39.3896, 0.687478211043558, -110.8193, -1.93416165975535),
(36884, '84522', 218, 52, 27099, 38.9211, 0.679301343497965, -111.2529, -1.941729407392),
(36885, '84523', 218, 52, 192566, 39.0884, 0.682221279336552, -111.1257, -1.93950934858346),
(36886, '84525', 218, 52, 60111, 39.0026, 0.68072378683834, -110.162, -1.92268961058199),
(36887, '84526', 218, 52, 192616, 39.6798, 0.692543156532846, -110.8519, -1.9347306370915),
(36888, '84527', 218, 52, 32748, 39.484, 0.689125801857441, -111.0125, -1.93753363587021),
(36889, '84528', 218, 52, 9621, 39.3384, 0.686584602466537, -110.9681, -1.93675870968232),
(36890, '84529', 218, 52, 13136, 39.689, 0.692703726824029, -110.806, -1.93392953096484),
(36891, '84530', 218, 52, 192660, 38.3109, 0.668651344402296, -109.2566, -1.90688739953444),
(36892, '84531', 218, 52, 192695, 37.0907, 0.647354836869461, -109.9634, -1.91922338668753),
(36893, '84532', 218, 52, 192703, 38.5549, 0.672909947777162, -109.5261, -1.91159106186856),
(36894, '84533', 218, 52, 0, 37.6707, 0.657477746531028, -110.6992, -1.93206551932371),
(36895, '84534', 218, 52, 192708, 37.2605, 0.650318405939347, -109.3134, -1.90787874654957),
(36896, '84535', 218, 52, 588, 37.8707, 0.660968405035017, -109.3468, -1.90846168651974),
(36897, '84536', 218, 52, 0, 37.1547, 0.648471847590737, -110.7434, -1.93283695485309),
(36898, '84537', 218, 52, 30739, 39.2308, 0.684706628191392, -111.0539, -1.93825620218053),
(36899, '84539', 218, 52, 6166, 39.5474, 0.690232340603205, -110.3904, -1.92667594259355),
(36900, '84540', 218, 52, 6317, 39.036, 0.681306726808506, -109.6971, -1.91457557488947),
(36901, '84542', 218, 52, 902, 39.5491, 0.690262011200489, -110.7282, -1.93257166480679),
(36902, '84601', 218, 52, 341, 40.2203, 0.701976661139875, -111.6931, -1.94941234675928),
(36903, '84602', 218, 52, 341, 40.2262, 0.702079635565743, -111.6931, -1.94941234675928),
(36904, '84603', 218, 52, 341, 40.2284, 0.702118032809287, -111.6995, -1.94952404783141),
(36905, '84604', 218, 52, 341, 40.2621, 0.702706208767209, -111.6263, -1.94824646681895),
(36906, '84605', 218, 52, 341, 40.2231, 0.702025530358931, -111.6755, -1.94910516881093),
(36907, '84606', 218, 52, 341, 40.2139, 0.701864960067748, -111.6336, -1.94837387585434),
(36908, '84620', 218, 52, 474, 38.9302, 0.679460168459896, -111.9171, -1.95332188428375),
(36909, '84621', 218, 52, 31713, 39.116, 0.682702990210102, -111.773, -1.95080686483162),
(36910, '84622', 218, 52, 35195, 39.1177, 0.682732660807386, -111.8197, -1.9516219335923),
(36911, '84623', 218, 52, 8056, 39.4758, 0.688982684858778, -111.5625, -1.94713294675617),
(36912, '84624', 218, 52, 2022, 39.3643, 0.687036642742804, -112.5783, -1.96486200129793),
(36913, '84626', 218, 52, 2250, 40.1613, 0.700946916881199, -112.0296, -1.95528537969224),
(36914, '84627', 218, 52, 177414, 39.3252, 0.686354219005274, -111.6161, -1.94806844323524),
(36915, '84628', 218, 52, 2334, 39.9541, 0.697330594671066, -112.1163, -1.95679858015372),
(36916, '84629', 218, 52, 500, 39.6551, 0.692112060207603, -111.4338, -1.94488670800886),
(36917, '84630', 218, 52, 2426, 39.2189, 0.684498934010404, -111.8675, -1.95245620097476),
(36918, '84631', 218, 52, 27166, 38.9005, 0.678941805672054, -112.6323, -1.96580447909401),
(36919, '84632', 218, 52, 47170, 39.5383, 0.690073515641274, -111.6802, -1.94918719928577),
(36920, '84633', 218, 52, 419, 39.9523, 0.697299178744531, -111.9012, -1.95304437693268),
(36921, '84634', 218, 52, 60144, 39.1441, 0.683193427729912, -111.8422, -1.952014632674),
(36922, '84635', 218, 52, 94928, 39.2255, 0.684614125741036, -112.8316, -1.96928292029323),
(36923, '84636', 218, 52, 27452, 39.1038, 0.682490060041359, -112.2703, -1.95948638720179),
(36924, '84637', 218, 52, 192651, 38.8049, 0.677273270907148, -112.4381, -1.96241504968664),
(36925, '84638', 218, 52, 27688, 39.5264, 0.689865821460287, -112.2877, -1.95979007449164),
(36926, '84639', 218, 52, 192672, 39.554, 0.690347532333837, -111.8612, -1.95234624523188),
(36927, '84640', 218, 52, 192680, 39.5192, 0.689740157754143, -112.3718, -1.96125789639256),
(36928, '84642', 218, 52, 192686, 39.2645, 0.685294804149314, -111.6377, -1.94844543435367),
(36929, '84643', 218, 52, 10367, 39.1137, 0.682662847637306, -111.7028, -1.94958164369672),
(36930, '84644', 218, 52, 23000, 38.8865, 0.678697459576775, -112.4061, -1.961856544326),
(36931, '84645', 218, 52, 89097, 39.8174, 0.69494472958359, -111.8526, -1.95219614691621),
(36932, '84646', 218, 52, 192711, 39.5283, 0.689898982716075, -111.5848, -1.94752215517937),
(36933, '84647', 218, 52, 118, 39.5571, 0.690401637540649, -111.493, -1.94591994292604),
(36934, '84648', 218, 52, 192720, 39.71, 0.693070245966948, -111.8471, -1.95210015380735),
(36935, '84649', 218, 52, 67322, 39.3759, 0.687239100936035, -112.3362, -1.96063655917885),
(36936, '84650', 218, 52, 23588, 39.2919, 0.68577302436436, -112.6279, -1.96572768460692),
(36937, '84651', 218, 52, 28207, 40.0271, 0.698604685025022, -111.7048, -1.94961655028176),
(36938, '84652', 218, 52, 111080, 39.0033, 0.680736004143104, -111.8703, -1.95250507019381),
(36939, '84653', 218, 52, 126, 40.0311, 0.698674498195102, -111.6607, -1.94884686008163),
(36940, '84654', 218, 52, 31053, 38.9531, 0.679859848858603, -111.8613, -1.95234799056113),
(36941, '84655', 218, 52, 192771, 40.0139, 0.698374301563759, -111.7685, -1.95072832501528),
(36942, '84656', 218, 52, 11824, 39.2521, 0.685078383322066, -112.1033, -1.95657168735096),
(36943, '84657', 218, 52, 192783, 38.8433, 0.677943477339913, -111.9679, -1.95420851154376),
(36944, '84660', 218, 52, 205866, 40.0972, 0.69982816083067, -111.6515, -1.94868628979045),
(36945, '84662', 218, 52, 57670, 39.4808, 0.689069951321377, -111.4944, -1.94594437753557),
(36946, '84663', 218, 52, 6035, 40.1618, 0.700955643527459, -111.6022, -1.94782584246922),
(36947, '84664', 218, 52, 30422, 40.1399, 0.700573416421272, -111.5748, -1.94734762225417),
(36948, '84665', 218, 52, 25116, 39.1963, 0.684104489599453, -111.6824, -1.94922559652932),
(36949, '84667', 218, 52, 38725, 39.4886, 0.689206087003033, -111.6331, -1.94836514920808),
(36950, '84701', 218, 52, 24305, 38.7692, 0.676650188364186, -112.0699, -1.95598874738079),
(36951, '84710', 218, 52, 14977, 37.4754, 0.654069118501883, -112.5832, -1.96494752243128),
(36952, '84711', 218, 52, 192469, 38.7076, 0.675575065544957, -112.0621, -1.95585261169914),
(36953, '84712', 218, 52, 192470, 37.9416, 0.662205843474681, -112.136, -1.95714241001636),
(36954, '84713', 218, 52, 7346, 38.2986, 0.6684366689043, -112.7181, -1.96730197159222),
(36955, '84714', 218, 52, 7424, 37.7031, 0.658043233208674, -113.6556, -1.98366443332967),
(36956, '84715', 218, 52, 29212, 38.3469, 0.669279662933014, -111.5543, -1.94698982975751),
(36957, '84716', 218, 52, 26581, 37.8291, 0.660242348066187, -111.2044, -1.94088292270478),
(36958, '84717', 218, 52, 192500, 37.6216, 0.656620789868299, -112.1108, -1.95670258704486),
(36959, '84718', 218, 52, 19758, 37.5666, 0.655660858779702, -112.0546, -1.95572171200524),
(36960, '84719', 218, 52, 192498, 37.6974, 0.65794374944131, -112.8496, -1.96959707955859),
(36961, '84720', 218, 52, 53925, 37.711, 0.658181114219582, -113.0858, -1.9737195472518),
(36962, '84721', 218, 52, 53925, 37.6637, 0.657355573483388, -113.1949, -1.97562370146573),
(36963, '84722', 218, 52, 1462, 37.4024, 0.652795028147927, -113.5615, -1.98202207850354),
(36964, '84723', 218, 52, 29475, 38.1719, 0.666225336742023, -112.2727, -1.95952827510384),
(36965, '84724', 218, 52, 35761, 38.6765, 0.675032268147587, -112.144, -1.95728203635652),
(36966, '84725', 218, 52, 2311, 37.5723, 0.655760342547066, -113.7171, -1.98473781081964),
(36967, '84726', 218, 52, 186690, 37.7653, 0.659128828003415, -111.5918, -1.94764432822701),
(36968, '84728', 218, 52, 27246, 39.0617, 0.681755276426269, -113.4142, -1.97945120851535),
(36969, '84729', 218, 52, 2741, 37.3176, 0.651314988942236, -112.5966, -1.96518139655105),
(36970, '84730', 218, 52, 2749, 38.7647, 0.676571648547846, -111.9751, -1.9543341752499),
(36971, '84731', 218, 52, 2868, 38.2645, 0.66784151162937, -112.7271, -1.9674590512249),
(36972, '84732', 218, 52, 32630, 38.2857, 0.668211521430793, -112.0653, -1.9559084622352),
(36973, '84733', 218, 52, 36228, 37.2873, 0.650786154178882, -113.7613, -1.98550924634903),
(36974, '84734', 218, 52, 172096, 38.3247, 0.668892199839071, -110.6919, -1.93193811028831),
(36975, '84735', 218, 52, 55206, 37.6501, 0.657118208705117, -112.4325, -1.96231731124852);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(36976, '84736', 218, 52, 192617, 37.5643, 0.655620716206906, -111.9948, -1.95467800511255),
(36977, '84737', 218, 52, 3302, 37.1516, 0.648417742383925, -113.2805, -1.97711770330544),
(36978, '84738', 218, 52, 192638, 37.1668, 0.648683032430229, -113.6657, -1.98384071158412),
(36979, '84739', 218, 52, 60454, 38.6195, 0.67403743047395, -112.2174, -1.95856310802748),
(36980, '84740', 218, 52, 27584, 38.2419, 0.66744706721842, -112.2208, -1.95862244922205),
(36981, '84741', 218, 52, 192648, 37.0428, 0.646518824157756, -112.4879, -1.96328422365413),
(36982, '84742', 218, 52, 192649, 37.5377, 0.655156458625875, -113.1794, -1.97535317543167),
(36983, '84743', 218, 52, 3542, 38.2056, 0.666813512699945, -112.1867, -1.95802729194712),
(36984, '84744', 218, 52, 192658, 38.5147, 0.67220832541786, -111.881, -1.95269182042378),
(36985, '84745', 218, 52, 192662, 37.2082, 0.649405598740554, -113.2734, -1.97699378492854),
(36986, '84746', 218, 52, 3719, 37.2377, 0.649920470869892, -113.3646, -1.97858552520636),
(36987, '84747', 218, 52, 192674, 38.4426, 0.670949943027172, -111.5932, -1.94766876283654),
(36988, '84749', 218, 52, 60722, 38.4327, 0.670777155431225, -111.6134, -1.94802131934544),
(36989, '84750', 218, 52, 192690, 38.4334, 0.670789372735989, -112.2209, -1.9586241945513),
(36990, '84751', 218, 52, 10480, 38.3532, 0.669389618675889, -112.9868, -1.97199167129233),
(36991, '84752', 218, 52, 73497, 38.2154, 0.666984554966641, -112.9218, -1.97085720727853),
(36992, '84753', 218, 52, 78755, 37.7971, 0.659683842705549, -113.9078, -1.9880661537032),
(36993, '84754', 218, 52, 10560, 38.6459, 0.674498197396477, -112.1341, -1.95710924876057),
(36994, '84755', 218, 52, 4363, 37.2205, 0.649620274238549, -112.7408, -1.96769816133242),
(36995, '84756', 218, 52, 10795, 37.8232, 0.660139373640319, -113.7239, -1.98485649320878),
(36996, '84757', 218, 52, 4526, 37.4851, 0.654238415439326, -113.3108, -1.97764653806879),
(36997, '84758', 218, 52, 192736, 37.2701, 0.650485957547539, -112.7456, -1.96778193713652),
(36998, '84759', 218, 52, 192738, 37.7755, 0.659306851587118, -112.5925, -1.96510983805172),
(36999, '84760', 218, 52, 192740, 37.8869, 0.66125114837384, -112.7729, -1.96825841202231),
(37000, '84761', 218, 52, 192743, 37.8481, 0.660573960624066, -112.8266, -1.96919565383063),
(37001, '84762', 218, 52, 192544, 37.5316, 0.655049993541504, -112.6655, -1.96638392840567),
(37002, '84763', 218, 52, 5479, 37.1535, 0.648450903639713, -113.0593, -1.97325703500002),
(37003, '84764', 218, 52, 92876, 37.6736, 0.657528361079336, -112.1583, -1.95753161843956),
(37004, '84765', 218, 52, 17976, 37.1326, 0.648086129826046, -113.6457, -1.98349164573372),
(37005, '84766', 218, 52, 68665, 38.5933, 0.673580154209928, -112.2439, -1.95902562027926),
(37006, '84767', 218, 52, 6023, 37.1837, 0.648977993073816, -112.9995, -1.97221332810733),
(37007, '84770', 218, 52, 14538, 37.0873, 0.647295495674893, -113.5852, -1.98243572153626),
(37008, '84771', 218, 52, 14538, 37.1346, 0.648121036411086, -113.4883, -1.98074449749108),
(37009, '84772', 218, 52, 6151, 37.7974, 0.659689078693305, -112.9433, -1.97123245306771),
(37010, '84773', 218, 52, 18296, 38.2849, 0.668197558796777, -111.4748, -1.94560229300217),
(37011, '84774', 218, 52, 192825, 37.2493, 0.650122929063124, -113.2846, -1.97718926180477),
(37012, '84775', 218, 52, 18361, 38.3052, 0.668551860634932, -111.3703, -1.94377842393384),
(37013, '84776', 218, 52, 18379, 37.6243, 0.656667913758103, -112.0876, -1.9562976706584),
(37014, '84779', 218, 52, 192844, 37.2014, 0.649286916351419, -113.1875, -1.97549454710108),
(37015, '84780', 218, 52, 12671, 37.1329, 0.648091365813802, -113.5097, -1.98111799795101),
(37016, '84781', 218, 52, 443, 37.3256, 0.651454615282395, -113.4052, -1.97929412888267),
(37017, '84782', 218, 52, 192842, 37.3532, 0.651936326155946, -113.6772, -1.9840414244481),
(37018, '84783', 218, 52, 0, 37.3089, 0.651163145297312, -113.6577, -1.98370108524396),
(37019, '84784', 218, 52, 192619, 37.0079, 0.645909704248809, -112.9681, -1.97166529472221),
(37020, '84790', 218, 52, 14538, 37.0782, 0.647136670712962, -113.5785, -1.98231878447638),
(37021, '84791', 218, 52, 14538, 37.0896, 0.647335638247689, -113.5579, -1.98195924665047),
(37022, '85001', 218, 5, 23865, 33.4507, 0.583824852096867, -112.0684, -1.95596256744201),
(37023, '85002', 218, 5, 23865, 33.4523, 0.583852777364899, -112.0685, -1.95596431277127),
(37024, '85003', 218, 5, 23865, 33.4496, 0.583805653475095, -112.0776, -1.9561231377332),
(37025, '85004', 218, 5, 23865, 33.4492, 0.583798672158087, -112.0698, -1.95598700205154),
(37026, '85005', 218, 5, 23865, 33.4467, 0.583755038926787, -112.1267, -1.95698009439593),
(37027, '85006', 218, 5, 23865, 33.4662, 0.584095378130926, -112.0482, -1.95561001093311),
(37028, '85007', 218, 5, 23865, 33.4504, 0.583819616109111, -112.0907, -1.95635177586521),
(37029, '85008', 218, 5, 23865, 33.4676, 0.584119812740454, -111.9947, -1.95467625978329),
(37030, '85009', 218, 5, 23865, 33.4584, 0.583959242449271, -112.1251, -1.95695216912789),
(37031, '85010', 218, 5, 23865, 33.4646, 0.584067452862894, -111.9873, -1.95454710541865),
(37032, '85011', 218, 5, 23865, 33.5096, 0.584852851026292, -112.0569, -1.95576185457803),
(37033, '85012', 218, 5, 23865, 33.5116, 0.584887757611332, -112.0692, -1.95597653007603),
(37034, '85013', 218, 5, 23865, 33.51, 0.5848598323433, -112.0817, -1.95619469623253),
(37035, '85014', 218, 5, 23865, 33.512, 0.58489473892834, -112.0555, -1.95573741996851),
(37036, '85015', 218, 5, 23865, 33.5084, 0.584831907075268, -112.1021, -1.95655074339994),
(37037, '85016', 218, 5, 23865, 33.5072, 0.584810963124244, -112.0307, -1.95530457831401),
(37038, '85017', 218, 5, 23865, 33.5123, 0.584899974916096, -112.1238, -1.95692947984762),
(37039, '85018', 218, 5, 23865, 33.4993, 0.584673082113336, -111.9837, -1.95448427356557),
(37040, '85019', 218, 5, 23865, 33.5123, 0.584899974916096, -112.1419, -1.95724538444223),
(37041, '85020', 218, 5, 23865, 33.5601, 0.585734242298549, -112.0555, -1.95573741996851),
(37042, '85021', 218, 5, 23865, 33.5584, 0.585704571701265, -112.0911, -1.95635875718222),
(37043, '85022', 218, 5, 23865, 33.6279, 0.586917575531401, -112.0524, -1.95568331476169),
(37044, '85023', 218, 5, 23865, 33.6313, 0.586976916725969, -112.112, -1.95672353099588),
(37045, '85024', 218, 5, 23865, 33.6868, 0.587945574460826, -112.0503, -1.9556466628474),
(37046, '85025', 218, 5, 23865, 33.4531, 0.583866739998915, -112.0744, -1.95606728719713),
(37047, '85026', 218, 5, 23865, 33.4554, 0.583906882571711, -111.9773, -1.95437257249345),
(37048, '85027', 218, 5, 23865, 33.6887, 0.587978735716614, -112.1083, -1.95665895381356),
(37049, '85028', 218, 5, 23865, 33.5826, 0.586126941380248, -112.0059, -1.95487173665952),
(37050, '85029', 218, 5, 23865, 33.598, 0.586395722085055, -112.1186, -1.95683872272651),
(37051, '85030', 218, 5, 23865, 33.4525, 0.583856268023403, -112.0782, -1.95613360970871),
(37052, '85031', 218, 5, 23865, 33.4951, 0.584599778284753, -112.1695, -1.95772709531578),
(37053, '85032', 218, 5, 23865, 33.6215, 0.586805874459273, -112.0029, -1.95481937678196),
(37054, '85033', 218, 5, 23865, 33.492, 0.584545673077941, -112.2118, -1.95846536958937),
(37055, '85034', 218, 5, 23865, 33.44, 0.583638101866904, -112.0259, -1.95522080250992),
(37056, '85035', 218, 5, 23865, 33.4731, 0.584215805849314, -112.1848, -1.95799413069133),
(37057, '85036', 218, 5, 23865, 33.6334, 0.587013568640261, -112.1552, -1.95747751323274),
(37058, '85037', 218, 5, 23865, 33.4956, 0.584608504931013, -112.255, -1.95921935182623),
(37059, '85038', 218, 5, 23865, 33.465, 0.584074434179902, -111.9878, -1.95455583206491),
(37060, '85039', 218, 5, 23865, 33.4922, 0.584549163736445, -112.2892, -1.95981625443042),
(37061, '85040', 218, 5, 23865, 33.4084, 0.583086577823274, -112.0267, -1.95523476514393),
(37062, '85041', 218, 5, 23865, 33.386, 0.582695624070827, -112.1003, -1.9565193274734),
(37063, '85042', 218, 5, 23865, 33.3757, 0.582515855157872, -112.0347, -1.95537439148409),
(37064, '85043', 218, 5, 23865, 33.4393, 0.58362588456214, -112.1913, -1.95810757709271),
(37065, '85044', 218, 5, 23865, 33.327, 0.58166587981215, -111.9987, -1.95474607295337),
(37066, '85045', 218, 5, 23865, 33.3003, 0.581199876901868, -112.1159, -1.95679159883671),
(37067, '85046', 218, 5, 23865, 33.6258, 0.586880923617109, -112.0055, -1.95486475534251),
(37068, '85048', 218, 5, 23865, 33.3308, 0.581732202323726, -112.0496, -1.95563444554264),
(37069, '85050', 218, 5, 23865, 33.6912, 0.588022368947914, -111.9974, -1.9547233836731),
(37070, '85051', 218, 5, 23865, 33.5593, 0.585720279664533, -112.1326, -1.95708306882179),
(37071, '85053', 218, 5, 23865, 33.6321, 0.586990879359985, -112.1327, -1.95708481415105),
(37072, '85054', 218, 5, 23865, 33.6789, 0.587807693449918, -111.9375, -1.95367793145115),
(37073, '85055', 218, 5, 23865, 33.4513, 0.583835324072379, -111.975, -1.95433242992065),
(37074, '85060', 218, 5, 23865, 33.5001, 0.584687044747352, -111.9824, -1.9544615842853),
(37075, '85061', 218, 5, 23865, 33.5167, 0.584976769403183, -112.1268, -1.95698183972518),
(37076, '85062', 218, 5, 23865, 33.4652, 0.584077924838406, -111.9872, -1.95454536008939),
(37077, '85063', 218, 5, 23865, 33.501, 0.58470275271062, -112.1718, -1.95776723788858),
(37078, '85064', 218, 5, 23865, 33.508, 0.58482492575826, -112.0315, -1.95531854094803),
(37079, '85065', 218, 5, 23865, 33.4371, 0.583587487318596, -112.0508, -1.95565538949366),
(37080, '85066', 218, 5, 23865, 33.394, 0.582835250410986, -112.029, -1.95527490771673),
(37081, '85067', 218, 5, 23865, 33.5103, 0.584865068331056, -112.0824, -1.95620691353729),
(37082, '85068', 218, 5, 23865, 33.6752, 0.587743116267594, -112.0642, -1.95588926361343),
(37083, '85069', 218, 5, 23865, 33.5612, 0.585753440920321, -112.0947, -1.95642158903529),
(37084, '85070', 218, 5, 23865, 33.3053, 0.581287143364468, -112.046, -1.95557161368957),
(37085, '85071', 218, 5, 23865, 33.5963, 0.586366051487771, -112.1095, -1.95667989776458),
(37086, '85072', 218, 5, 23865, 33.453, 0.583864994669663, -112.0125, -1.95498692839015),
(37087, '85073', 218, 5, 23865, 33.4497, 0.583807398804347, -112.0736, -1.95605332456312),
(37088, '85074', 218, 5, 23865, 33.4536, 0.583875466645175, -112.0912, -1.95636050251147),
(37089, '85075', 218, 5, 23865, 33.4953, 0.584603268943257, -112.212, -1.95846886024788),
(37090, '85076', 218, 5, 23865, 33.3278, 0.581679842446166, -111.9921, -1.95463088122274),
(37091, '85077', 218, 5, 23865, 33.4504, 0.583819616109111, -111.9737, -1.95430974064037),
(37092, '85078', 218, 5, 23865, 33.6258, 0.586880923617109, -112.0049, -1.954854283367),
(37093, '85079', 218, 5, 23865, 33.5099, 0.584858087014048, -112.1182, -1.95683174140951),
(37094, '85080', 218, 5, 23865, 33.6317, 0.586983898042977, -112.1102, -1.95669211506935),
(37095, '85082', 218, 5, 23865, 33.4647, 0.584069198192146, -111.9879, -1.95455757739416),
(37096, '85085', 218, 5, 23865, 33.7575, 0.589179522241986, -112.1315, -1.95706387020002),
(37097, '85086', 218, 5, 23865, 33.8343, 0.590519935107517, -112.0869, -1.95628545335363),
(37098, '85087', 218, 5, 17264, 33.9163, 0.591951105094153, -112.1348, -1.95712146606534),
(37099, '85098', 218, 5, 23865, 33.4457, 0.583737585634267, -112.1261, -1.95696962242041),
(37100, '85099', 218, 5, 23865, 33.4522, 0.583851032035647, -112.0697, -1.95598525672229),
(37101, '85201', 218, 5, 10451, 33.4303, 0.58346880492946, -111.8435, -1.95203732195428),
(37102, '85202', 218, 5, 10451, 33.3821, 0.582627556229999, -111.8658, -1.95242653037747),
(37103, '85203', 218, 5, 10451, 33.4384, 0.583610176598872, -111.8003, -1.95128333971742),
(37104, '85204', 218, 5, 10451, 33.3997, 0.58293473417835, -111.7886, -1.95107913619493),
(37105, '85205', 218, 5, 10451, 33.4407, 0.583650319171668, -111.7127, -1.94975443129267),
(37106, '85206', 218, 5, 10451, 33.4014, 0.582964404775634, -111.7283, -1.95002670265598),
(37107, '85207', 218, 5, 10451, 33.4539, 0.583880702632931, -111.6482, -1.94862869392513),
(37108, '85208', 218, 5, 10451, 33.3907, 0.582777654545671, -111.6473, -1.94861298596187),
(37109, '85210', 218, 5, 10451, 33.3894, 0.582754965265395, -111.8442, -1.95204953925904),
(37110, '85211', 218, 5, 10451, 33.4407, 0.583650319171668, -111.848, -1.95211586177062),
(37111, '85212', 218, 5, 10451, 33.3407, 0.581904989919673, -111.6222, -1.94817490831961),
(37112, '85213', 218, 5, 10451, 33.4407, 0.583650319171668, -111.7723, -1.95079464752686),
(37113, '85214', 218, 5, 10451, 33.3979, 0.582903318251814, -111.7891, -1.95108786284119),
(37114, '85215', 218, 5, 10451, 33.4689, 0.58414250202073, -111.7037, -1.94959735165999),
(37115, '85216', 218, 5, 10451, 33.3974, 0.582894591605554, -111.7201, -1.94988358565732),
(37116, '85217', 218, 5, 193024, 33.3286, 0.581693805080182, -111.3273, -1.94302793235548),
(37117, '85218', 218, 5, 193024, 33.3386, 0.581868338005382, -111.3547, -1.94350615257053),
(37118, '85219', 218, 5, 193024, 33.409, 0.583097049798786, -111.2184, -1.94112726880006),
(37119, '85220', 218, 5, 193024, 33.4235, 0.583350122540325, -111.563, -1.94714167340243),
(37120, '85221', 218, 5, 193109, 33.1363, 0.578337536928597, -111.872, -1.9525347407911),
(37121, '85222', 218, 5, 177855, 32.7139, 0.570965266168173, -111.9031, -1.95307753818847),
(37122, '85223', 218, 5, 193039, 32.7654, 0.57186411073295, -111.6557, -1.94875959361903),
(37123, '85224', 218, 5, 656, 33.3225, 0.58158733999581, -111.8767, -1.95261677126594),
(37124, '85225', 218, 5, 656, 33.3184, 0.581515781496479, -111.8327, -1.95184882639506),
(37125, '85226', 218, 5, 656, 33.3087, 0.581346484559035, -111.9211, -1.95339169745383),
(37126, '85227', 218, 5, 177903, 33.2121, 0.579660496501609, -111.6972, -1.94948390525861),
(37127, '85228', 218, 5, 20230, 32.9726, 0.575480432943082, -111.5169, -1.94633707661726),
(37128, '85230', 218, 5, 177855, 32.8921, 0.574075442895227, -111.7359, -1.95015934767913),
(37129, '85231', 218, 5, 178156, 32.7285, 0.571220084238964, -111.5824, -1.94748026727732),
(37130, '85232', 218, 5, 2502, 33.0281, 0.576449090677939, -111.3702, -1.94377667860459),
(37131, '85233', 218, 5, 2713, 33.3522, 0.582105702783653, -111.8031, -1.95133220893647),
(37132, '85234', 218, 5, 2713, 33.3609, 0.582257546428576, -111.7501, -1.95040718443292),
(37133, '85235', 218, 5, 3019, 33.0785, 0.577328736620944, -110.7973, -1.93377768731991),
(37134, '85236', 218, 5, 178369, 33.3318, 0.581749655616246, -111.7005, -1.94954150112393),
(37135, '85237', 218, 5, 95258, 33.1274, 0.57818220262517, -110.9387, -1.93624558288223),
(37136, '85239', 218, 5, 178592, 32.9746, 0.575515339528122, -112.0906, -1.95635003053596),
(37137, '85241', 218, 5, 178857, 32.714, 0.570967011497425, -111.5019, -1.94607527722947),
(37138, '85242', 218, 5, 178932, 33.2532, 0.580377826824178, -111.5243, -1.94646623098191),
(37139, '85244', 218, 5, 656, 33.2343, 0.580047959595551, -111.7641, -1.95065153052819),
(37140, '85245', 218, 5, 5319, 32.5683, 0.568424066777269, -111.3748, -1.94385696375018),
(37141, '85246', 218, 5, 656, 33.2945, 0.581098647805252, -111.8666, -1.95244049301149),
(37142, '85247', 218, 5, 179036, 33.0765, 0.577293830035905, -111.7477, -1.95036529653087),
(37143, '85248', 218, 5, 656, 33.2208, 0.579812340146532, -111.8677, -1.95245969163326),
(37144, '85249', 218, 5, 656, 33.2444, 0.580224237850003, -111.7897, -1.95109833481671),
(37145, '85250', 218, 5, 179107, 33.5196, 0.585027383951491, -111.9097, -1.9531927299191),
(37146, '85251', 218, 5, 179107, 33.4934, 0.584570107687469, -111.9227, -1.95341962272186),
(37147, '85252', 218, 5, 179107, 33.4868, 0.584454915956837, -111.926, -1.95347721858717),
(37148, '85253', 218, 5, 165684, 33.5381, 0.58535026986311, -111.9436, -1.95378439653552),
(37149, '85254', 218, 5, 179107, 33.6155, 0.586701154704154, -111.9543, -1.95397114676549),
(37150, '85255', 218, 5, 179107, 33.6787, 0.587804202791414, -111.8072, -1.9514037674358),
(37151, '85256', 218, 5, 179107, 33.5249, 0.585119886401847, -111.7832, -1.95098488841533),
(37152, '85257', 218, 5, 179107, 33.4684, 0.58413377537447, -111.9185, -1.95334631889327),
(37153, '85258', 218, 5, 179107, 33.5703, 0.585912265882252, -111.9021, -1.95306008489595),
(37154, '85259', 218, 5, 179107, 33.6007, 0.586442845974859, -111.8124, -1.95149452455691),
(37155, '85260', 218, 5, 179107, 33.6017, 0.586460299267379, -111.8878, -1.95281050281291),
(37156, '85261', 218, 5, 179107, 33.4953, 0.584603268943257, -111.9222, -1.9534108960756),
(37157, '85262', 218, 5, 179107, 33.8157, 0.590195303866647, -111.7837, -1.95099361506159),
(37158, '85263', 218, 5, 178983, 33.7568, 0.589167304937222, -111.6895, -1.94934951490621),
(37159, '85264', 218, 5, 178205, 33.6251, 0.586868706312345, -111.6663, -1.94894459851974),
(37160, '85266', 218, 5, 179107, 33.4875, 0.584467133261601, -111.9258, -1.95347372792867),
(37161, '85267', 218, 5, 179107, 33.6114, 0.586629596204822, -111.8917, -1.95287857065374),
(37162, '85268', 218, 5, 178215, 33.6082, 0.586573745668758, -111.7279, -1.95001972133897),
(37163, '85269', 218, 5, 178215, 33.6037, 0.586495205852419, -111.7189, -1.94986264170629),
(37164, '85271', 218, 5, 179107, 33.4652, 0.584077924838406, -111.9168, -1.95331664829599),
(37165, '85272', 218, 5, 69057, 32.9276, 0.574695034779685, -111.9771, -1.95436908183494),
(37166, '85273', 218, 5, 6182, 33.2056, 0.579547050100229, -111.1683, -1.94025285884481),
(37167, '85274', 218, 5, 10451, 33.3841, 0.582662462815039, -111.8749, -1.9525853553394),
(37168, '85275', 218, 5, 10451, 33.4504, 0.583819616109111, -111.7686, -1.95073007034453),
(37169, '85277', 218, 5, 10451, 33.4591, 0.583971459754035, -111.7208, -1.94989580296208),
(37170, '85278', 218, 5, 193024, 33.4051, 0.583028981957958, -111.5465, -1.94685369407585),
(37171, '85279', 218, 5, 2502, 33.0379, 0.576620132944635, -111.3742, -1.94384649177467),
(37172, '85280', 218, 5, 179318, 33.4053, 0.583032472616462, -111.9257, -1.95347198259942),
(37173, '85281', 218, 5, 179318, 33.4238, 0.583355358528081, -111.9237, -1.95343707601438),
(37174, '85282', 218, 5, 179318, 33.3921, 0.582802089155198, -111.9267, -1.95348943589194),
(37175, '85283', 218, 5, 179318, 33.3652, 0.582332595586412, -111.9294, -1.95353655978174),
(37176, '85284', 218, 5, 179318, 33.3361, 0.581824704774082, -111.9221, -1.95340915074635),
(37177, '85285', 218, 5, 179318, 33.3934, 0.582824778435474, -111.9312, -1.95356797570828),
(37178, '85287', 218, 5, 179318, 33.4276, 0.583421681039657, -111.933, -1.95359939163481),
(37179, '85289', 218, 5, 179318, 33.3937, 0.58283001442323, -111.9316, -1.95357495702528),
(37180, '85290', 218, 5, 179371, 33.5265, 0.585147811669879, -111.3892, -1.94410829116247),
(37181, '85291', 218, 5, 98741, 32.983, 0.57566194718529, -111.4431, -1.94504902362929),
(37182, '85292', 218, 5, 179553, 32.9143, 0.57446290598917, -110.7187, -1.93240585852785),
(37183, '85296', 218, 5, 2713, 33.3106, 0.581379645814823, -111.7724, -1.95079639285611),
(37184, '85297', 218, 5, 2713, 33.3183, 0.581514036167227, -111.7111, -1.94972650602464),
(37185, '85299', 218, 5, 2713, 33.3316, 0.581746164957742, -111.7645, -1.9506585118452),
(37186, '85301', 218, 5, 2741, 33.5345, 0.585287438010038, -112.1742, -1.95780912579062),
(37187, '85302', 218, 5, 2741, 33.5683, 0.585877359297213, -112.1761, -1.95784228704641),
(37188, '85303', 218, 5, 2741, 33.5243, 0.585109414426335, -112.2198, -1.95860499592953),
(37189, '85304', 218, 5, 2741, 33.5933, 0.586313691610211, -112.1756, -1.95783356040015),
(37190, '85305', 218, 5, 2741, 33.527, 0.585156538316139, -112.2505, -1.9591408120099),
(37191, '85306', 218, 5, 2741, 33.6236, 0.586842526373565, -112.1793, -1.95789813758247),
(37192, '85307', 218, 5, 2741, 33.5332, 0.585264748729763, -112.3121, -1.96021593482912),
(37193, '85308', 218, 5, 2741, 33.6545, 0.587381833112432, -112.1706, -1.95774629393755),
(37194, '85309', 218, 5, 0, 33.5382, 0.585352015192362, -112.3699, -1.96122473513678),
(37195, '85310', 218, 5, 2741, 33.7038, 0.588242280433665, -112.163, -1.9576136489144),
(37196, '85311', 218, 5, 2741, 33.5322, 0.585247295437243, -112.179, -1.95789290159472),
(37197, '85312', 218, 5, 2741, 33.6244, 0.586856489007581, -112.1801, -1.95791210021649),
(37198, '85313', 218, 5, 2741, 33.6058, 0.58653185776671, -112.1599, -1.95755954370759),
(37199, '85318', 218, 5, 2741, 33.6606, 0.587488298196803, -112.1847, -1.95799238536208),
(37200, '85320', 218, 5, 192993, 33.9308, 0.592204177835692, -113.1778, -1.97532525016364),
(37201, '85321', 218, 5, 192995, 32.3843, 0.5652126609536, -112.8684, -1.96992520145797),
(37202, '85322', 218, 5, 15026, 33.3029, 0.58124525546242, -112.78, -1.96838233039921),
(37203, '85323', 218, 5, 15065, 33.4307, 0.583475786246468, -112.3452, -1.96079363881153),
(37204, '85324', 218, 5, 177684, 34.0857, 0.594907692847031, -112.1413, -1.95723491246672),
(37205, '85325', 218, 5, 177772, 33.933, 0.592242575079236, -114.0054, -1.98976959505314),
(37206, '85326', 218, 5, 7746, 33.3866, 0.582706096046339, -112.5708, -1.96473110160403),
(37207, '85327', 218, 5, 7966, 33.8267, 0.590387290084366, -111.9652, -1.95416138765396),
(37208, '85328', 218, 5, 177939, 33.5347, 0.585290928668542, -114.4351, -1.99726927484896),
(37209, '85329', 218, 5, 75359, 33.4286, 0.583439134332177, -112.305, -1.96009201645223),
(37210, '85331', 218, 5, 7966, 33.8204, 0.59027733434149, -111.9523, -1.95393624018045),
(37211, '85332', 218, 5, 154830, 34.1663, 0.596314428224139, -112.8563, -1.96971401661848),
(37212, '85333', 218, 5, 178057, 32.8759, 0.573792699556404, -113.4263, -1.97966239335484),
(37213, '85334', 218, 5, 178136, 33.6226, 0.586825073081045, -114.4935, -1.99828854713213),
(37214, '85335', 218, 5, 178141, 33.6057, 0.586530112437458, -112.3263, -1.96046377158291),
(37215, '85336', 218, 5, 2640, 32.5511, 0.568123870145926, -114.7759, -2.00321735693976),
(37216, '85337', 218, 5, 178242, 32.9845, 0.57568812712407, -112.6825, -1.96668063437851),
(37217, '85338', 218, 5, 2783, 33.437, 0.583585741989344, -112.3814, -1.96142544800076),
(37218, '85339', 218, 5, 178512, 33.3525, 0.582110938771409, -112.1981, -1.95822625948185),
(37219, '85340', 218, 5, 178541, 33.5008, 0.584699262052116, -112.3763, -1.9613364362089),
(37220, '85341', 218, 5, 41900, 31.8823, 0.556451108108588, -112.8155, -1.96900192228366),
(37221, '85342', 218, 5, 30565, 33.8577, 0.590928342152484, -112.5764, -1.96482884004214),
(37222, '85343', 218, 5, 178785, 33.3283, 0.581688569092426, -112.7041, -1.96705762549694),
(37223, '85344', 218, 5, 4872, 34.1575, 0.596160839249963, -114.2629, -1.99426381787703),
(37224, '85345', 218, 5, 30800, 33.5701, 0.585908775223748, -112.2477, -1.95909194279084),
(37225, '85346', 218, 5, 178931, 33.6664, 0.587589527293419, -114.2168, -1.99345922109186),
(37226, '85347', 218, 5, 77127, 32.7514, 0.571619764637671, -113.9873, -1.98945369045853),
(37227, '85348', 218, 5, 179052, 33.8469, 0.590739846593269, -113.6048, -1.98277780606965),
(37228, '85349', 218, 5, 179064, 32.4976, 0.567190118996109, -114.7791, -2.00327320747582),
(37229, '85350', 218, 5, 74338, 32.5979, 0.56894068423586, -114.6894, -2.00170764713678),
(37230, '85351', 218, 5, 18219, 33.6036, 0.586493460523167, -112.2774, -1.95961030557868),
(37231, '85352', 218, 5, 179300, 32.7022, 0.57076106264569, -113.9654, -1.98907146335235),
(37232, '85353', 218, 5, 179358, 33.4132, 0.583170353627369, -112.2751, -1.95957016300589),
(37233, '85354', 218, 5, 177642, 33.4753, 0.584254203092858, -112.8752, -1.9700438838471),
(37234, '85355', 218, 5, 43511, 33.5675, 0.585863396663197, -112.4333, -1.96233127388254),
(37235, '85356', 218, 5, 179488, 32.6872, 0.57049926325789, -114.086, -1.99117633043025),
(37236, '85357', 218, 5, 179489, 33.8226, 0.590315731585034, -113.5408, -1.98166079534838),
(37237, '85358', 218, 5, 179524, 33.9644, 0.592790608464362, -112.7472, -1.96780986240455),
(37238, '85359', 218, 5, 178931, 33.6888, 0.587980481045866, -114.2217, -1.99354474222521),
(37239, '85360', 218, 5, 179528, 34.6553, 0.604849088266391, -113.7575, -1.98544292383745),
(37240, '85361', 218, 5, 179560, 33.7525, 0.589092255779386, -112.5124, -1.96371182932087),
(37241, '85362', 218, 5, 169191, 34.2421, 0.59763738779715, -112.752, -1.96789363820865),
(37242, '85363', 218, 5, 6995, 33.5888, 0.586235151793871, -112.3019, -1.96003791124542),
(37243, '85364', 218, 5, 144, 32.7003, 0.570727901389902, -114.6465, -2.00095890088768),
(37244, '85365', 218, 5, 144, 32.6735, 0.570260153150367, -114.5025, -1.99844562676481),
(37245, '85366', 218, 5, 144, 32.6867, 0.570490536611631, -114.5929, -2.00002340440861),
(37246, '85367', 218, 5, 144, 32.6572, 0.569975664482292, -114.3844, -1.9963843929182),
(37247, '85369', 218, 5, 144, 32.699, 0.570705212109626, -114.675, -2.0014563197245),
(37248, '85371', 218, 5, 73968, 33.9588, 0.59269287002625, -114.4154, -1.99692544498632),
(37249, '85372', 218, 5, 18219, 33.6163, 0.58671511733817, -112.2815, -1.95968186407801),
(37250, '85373', 218, 5, 18219, 33.7828, 0.58962109054274, -112.3649, -1.96113746867418),
(37251, '85374', 218, 5, 31269, 33.633, 0.587006587323253, -112.3503, -1.96088265060339),
(37252, '85375', 218, 5, 179244, 33.6623, 0.587517968794087, -112.3468, -1.96082156407957),
(37253, '85376', 218, 5, 179244, 33.6649, 0.587563347354639, -112.3545, -1.96095595443197),
(37254, '85377', 218, 5, 29393, 33.8205, 0.590279079670742, -111.9018, -1.95305484890819),
(37255, '85378', 218, 5, 31269, 33.6357, 0.587053711213057, -112.3422, -1.96074127893397),
(37256, '85379', 218, 5, 31269, 33.6163, 0.58671511733817, -112.4088, -1.9619036682158),
(37257, '85380', 218, 5, 30800, 33.6889, 0.587982226375118, -112.2445, -1.95903609225478),
(37258, '85381', 218, 5, 30800, 33.6104, 0.586612142912302, -112.2368, -1.95890170190237),
(37259, '85382', 218, 5, 30800, 33.65, 0.587303293296092, -112.2481, -1.95909892410785),
(37260, '85383', 218, 5, 30800, 33.6591, 0.587462118258023, -112.2476, -1.95909019746159),
(37261, '85385', 218, 5, 30800, 33.5825, 0.586125196050996, -112.2382, -1.9589261365119),
(37262, '85387', 218, 5, 31269, 33.678, 0.58779198548665, -112.4699, -1.96297006438877),
(37263, '85390', 218, 5, 179524, 33.9684, 0.592860421634442, -112.7433, -1.96774179456372),
(37264, '85501', 218, 5, 32562, 33.3953, 0.582857939691262, -110.782, -1.93351065194436),
(37265, '85502', 218, 5, 32562, 33.3924, 0.582807325142955, -110.7828, -1.93352461457837),
(37266, '85530', 218, 5, 177813, 33.1066, 0.577819174140755, -110.2254, -1.92379614932776),
(37267, '85531', 218, 5, 1462, 32.8627, 0.573562316095141, -109.7874, -1.91615160720402),
(37268, '85532', 218, 5, 35265, 33.4111, 0.583133701713077, -110.8319, -1.9343815712411),
(37269, '85533', 218, 5, 15559, 33.0484, 0.576803392516094, -109.2969, -1.90759076722299),
(37270, '85534', 218, 5, 2130, 32.716, 0.571001918082465, -109.1028, -1.90420308314487),
(37271, '85535', 218, 5, 2217, 32.9766, 0.575550246113162, -109.8968, -1.9180609974057),
(37272, '85536', 218, 5, 35964, 32.9947, 0.575866150707773, -109.9762, -1.91944678883179),
(37273, '85539', 218, 5, 17102, 33.4091, 0.583098795128038, -110.8681, -1.93501338043033),
(37274, '85540', 218, 5, 132168, 33.0473, 0.576784193894322, -109.323, -1.90804629815776),
(37275, '85541', 218, 5, 28207, 34.2453, 0.597693238333214, -111.3179, -1.9428638714058),
(37276, '85542', 218, 5, 178843, 33.6604, 0.587484807538299, -110.3982, -1.9268120782752),
(37277, '85543', 218, 5, 178862, 32.8821, 0.573900909970027, -109.8325, -1.91693875069667),
(37278, '85544', 218, 5, 42563, 34.3958, 0.600319958857466, -111.4574, -1.94529860571233),
(37279, '85545', 218, 5, 5534, 33.6154, 0.586699409374902, -111.0008, -1.93732943234772),
(37280, '85546', 218, 5, 5600, 32.8071, 0.572591913031032, -109.7163, -1.91491067810585),
(37281, '85547', 218, 5, 28207, 34.2564, 0.597886969880186, -111.2797, -1.94219715563153),
(37282, '85548', 218, 5, 5600, 32.7703, 0.571949631866298, -109.7122, -1.91483911960652),
(37283, '85550', 218, 5, 97779, 33.3657, 0.582341322232672, -110.4562, -1.92782436924136),
(37284, '85551', 218, 5, 33996, 32.8158, 0.572743756675955, -109.6283, -1.9133747883641),
(37285, '85552', 218, 5, 179326, 32.83, 0.572991593429738, -109.7612, -1.91569433094),
(37286, '85553', 218, 5, 179362, 34.0869, 0.594928636798055, -111.1681, -1.94024936818631),
(37287, '85554', 218, 5, 13005, 34.0872, 0.594933872785811, -111.1688, -1.94026158549107),
(37288, '85601', 218, 5, 193035, 31.5784, 0.551147052511777, -111.3308, -1.9430890188793),
(37289, '85602', 218, 5, 642, 31.9654, 0.557901476716995, -110.2978, -1.9250597677062),
(37290, '85603', 218, 5, 31829, 31.4167, 0.548324855111302, -109.9079, -1.91825472895268),
(37291, '85605', 218, 5, 39466, 32.1641, 0.561369445940708, -109.3349, -1.90825399233875),
(37292, '85606', 218, 5, 177967, 32.0037, 0.558569937820509, -109.8805, -1.91777650873763),
(37293, '85607', 218, 5, 2088, 31.3517, 0.547190391097506, -109.5455, -1.91192965574345),
(37294, '85608', 218, 5, 2088, 31.3532, 0.547216571036286, -109.553, -1.91206055543735),
(37295, '85609', 218, 5, 178108, 32.0326, 0.559074337974336, -110.0458, -1.92066153799118),
(37296, '85610', 218, 5, 178150, 31.7189, 0.553599240110829, -109.4613, -1.91046008851327),
(37297, '85611', 218, 5, 2254, 31.6146, 0.551778861700999, -110.5147, -1.92884538685378),
(37298, '85613', 218, 5, 0, 31.5502, 0.550654869662715, -110.3449, -1.92588181778389),
(37299, '85614', 218, 5, 13848, 31.8601, 0.556063645014645, -111.0004, -1.93732245103071),
(37300, '85615', 218, 5, 48009, 31.4422, 0.548769914070561, -110.1915, -1.92320448271133),
(37301, '85616', 218, 5, 178395, 31.6835, 0.552981393555623, -110.3158, -1.92537392697156),
(37302, '85617', 218, 5, 60842, 31.5255, 0.550223773337472, -109.6827, -1.91432424747718),
(37303, '85618', 218, 5, 56059, 32.7067, 0.570839602462029, -110.6536, -1.9312696491848),
(37304, '85619', 218, 5, 0, 32.4298, 0.566006785763257, -110.7992, -1.9338108485757),
(37305, '85620', 218, 5, 178694, 31.3433, 0.547043783440339, -109.9424, -1.91885686754461),
(37306, '85621', 218, 5, 178719, 31.3802, 0.547687809934325, -110.9407, -1.93628048946727),
(37307, '85622', 218, 5, 13848, 31.8465, 0.555826280236374, -111.0098, -1.9374865119804),
(37308, '85623', 218, 5, 178753, 32.6177, 0.569286259427754, -110.7913, -1.93367296756479),
(37309, '85624', 218, 5, 165729, 31.536, 0.550407032908932, -110.7474, -1.93290676802317),
(37310, '85625', 218, 5, 4922, 31.9351, 0.557372641953641, -109.805, -1.91645878515237),
(37311, '85626', 218, 5, 178894, 31.3591, 0.547319545462154, -109.5721, -1.91239391332448),
(37312, '85627', 218, 5, 178907, 32.1787, 0.561624264011499, -110.2588, -1.92437908929792),
(37313, '85628', 218, 5, 178719, 31.4126, 0.548253296611971, -110.8927, -1.93544273142632),
(37314, '85629', 218, 5, 179044, 31.9523, 0.557672838584984, -110.9984, -1.93728754444567),
(37315, '85630', 218, 5, 121342, 31.9193, 0.557096879931826, -110.2351, -1.9239654462652),
(37316, '85631', 218, 5, 57, 32.5932, 0.568858653761016, -110.6147, -1.93059071610577),
(37317, '85632', 218, 5, 179076, 32.1634, 0.561357228635944, -109.3351, -1.90825748299725),
(37318, '85633', 218, 5, 179101, 31.4899, 0.549602436123762, -111.5426, -1.94678562623503),
(37319, '85634', 218, 5, 24736, 32.0054, 0.558599608417793, -112.3043, -1.96007979914747),
(37320, '85635', 218, 5, 179149, 31.5293, 0.550290095849048, -110.2585, -1.92437385331017),
(37321, '85636', 218, 5, 179149, 31.4683, 0.549225445005332, -110.1862, -1.92311198026098),
(37322, '85637', 218, 5, 179190, 31.621, 0.551890562773127, -110.7044, -1.93215627644481),
(37323, '85638', 218, 5, 179360, 31.71, 0.553443905807402, -110.0645, -1.9209879145613),
(37324, '85639', 218, 5, 179367, 32.0827, 0.559948747929585, -112.0671, -1.95593987816174),
(37325, '85640', 218, 5, 179399, 31.5962, 0.551457721118632, -111.0496, -1.93818115302269),
(37326, '85641', 218, 5, 12506, 31.9853, 0.558248797238142, -110.6886, -1.931880514423),
(37327, '85643', 218, 5, 179533, 32.256, 0.562973403523291, -109.8374, -1.91702427183002),
(37328, '85644', 218, 5, 179533, 32.2562, 0.562976894181795, -109.8355, -1.91699111057423),
(37329, '85645', 218, 5, 193011, 31.7285, 0.553766791719021, -111.0835, -1.93877281963912),
(37330, '85646', 218, 5, 179393, 31.6096, 0.5516915952384, -111.0493, -1.93817591703494),
(37331, '85648', 218, 5, 97520, 31.4788, 0.549408704576791, -111.0675, -1.9384935669588),
(37332, '85650', 218, 5, 179149, 31.4963, 0.54971413719589, -110.2626, -1.9244454118095),
(37333, '85652', 218, 5, 178013, 32.3855, 0.565233604904624, -111.1142, -1.93930863571948),
(37334, '85653', 218, 5, 178589, 32.4165, 0.565774656972742, -111.2942, -1.94245022837307),
(37335, '85654', 218, 5, 178979, 32.4215, 0.565861923435342, -111.104, -1.93913061213578),
(37336, '85655', 218, 5, 2088, 31.3427, 0.547033311464827, -109.528, -1.91162422312435),
(37337, '85662', 218, 5, 178719, 31.3636, 0.547398085278494, -110.9328, -1.93614260845637),
(37338, '85670', 218, 5, 0, 31.5551, 0.550740390796063, -110.2754, -1.92466881395375),
(37339, '85671', 218, 5, 179149, 31.5648, 0.550909687733506, -110.3229, -1.92549784534845),
(37340, '85701', 218, 5, 74577, 32.2163, 0.562280507810249, -110.9714, -1.93681630554764),
(37341, '85702', 218, 5, 74577, 32.2177, 0.562304942419777, -110.9717, -1.93682154153539),
(37342, '85703', 218, 5, 74577, 32.2737, 0.563282326800894, -110.9936, -1.93720376864158),
(37343, '85704', 218, 5, 74577, 32.3528, 0.564662882239221, -111.0193, -1.93765231825934),
(37344, '85705', 218, 5, 74577, 32.2591, 0.563027508730103, -111.0006, -1.93732594168922),
(37345, '85706', 218, 5, 74577, 32.1415, 0.560975001529757, -110.9775, -1.93692277063201),
(37346, '85707', 218, 5, 74577, 32.1813, 0.561669642572051, -110.8685, -1.93502036174733),
(37347, '85708', 218, 5, 74577, 32.1852, 0.561737710412879, -110.8649, -1.93495752989426),
(37348, '85709', 218, 5, 74577, 32.2331, 0.562573723124584, -111.0135, -1.93755108916273),
(37349, '85710', 218, 5, 74577, 32.2135, 0.562231638591193, -110.817, -1.93412151718256),
(37350, '85711', 218, 5, 74577, 32.2154, 0.562264799846981, -110.8841, -1.93529263311064),
(37351, '85712', 218, 5, 74577, 32.2511, 0.562887882389943, -110.8873, -1.93534848364671),
(37352, '85713', 218, 5, 74577, 32.1944, 0.561898280704062, -110.9898, -1.93713744613),
(37353, '85714', 218, 5, 74577, 32.1732, 0.56152827090264, -110.9666, -1.93673252974354),
(37354, '85715', 218, 5, 74577, 32.2723, 0.563257892191366, -110.8291, -1.93433270202205),
(37355, '85716', 218, 5, 74577, 32.2449, 0.56277967197632, -110.9217, -1.93594887690939),
(37356, '85717', 218, 5, 74577, 32.2468, 0.562812833232108, -110.948, -1.93640789850267),
(37357, '85718', 218, 5, 74577, 32.3128, 0.563964750538424, -110.9187, -1.93589651703183),
(37358, '85719', 218, 5, 74577, 32.2434, 0.56275349203754, -110.9457, -1.93636775592987),
(37359, '85720', 218, 5, 74577, 32.1958, 0.56192271531359, -110.8912, -1.93541655148754),
(37360, '85721', 218, 5, 74577, 32.2311, 0.562538816539544, -110.9494, -1.9364323331122),
(37361, '85722', 218, 5, 74577, 32.2362, 0.562627828331396, -110.9402, -1.93627176282101),
(37362, '85723', 218, 5, 74577, 32.1941, 0.561893044716306, -111.0054, -1.93740971749331),
(37363, '85724', 218, 5, 74577, 32.247, 0.562816323890611, -110.9449, -1.93635379329586),
(37364, '85725', 218, 5, 74577, 32.198, 0.561961112557134, -111.0143, -1.93756505179674),
(37365, '85726', 218, 5, 74577, 32.2057, 0.562095502909538, -110.9441, -1.93633983066184),
(37366, '85728', 218, 5, 74577, 32.3108, 0.563929843953384, -110.9154, -1.93583892116652),
(37367, '85730', 218, 5, 74577, 32.1794, 0.561636481316263, -110.8034, -1.93388415240428),
(37368, '85731', 218, 5, 74577, 32.2193, 0.562332867687809, -110.7597, -1.93312144352116),
(37369, '85732', 218, 5, 74577, 32.2163, 0.562280507810249, -110.8829, -1.93527168915962),
(37370, '85733', 218, 5, 74577, 32.0859, 0.560004598465649, -111.0712, -1.93855814414113),
(37371, '85734', 218, 5, 74577, 32.1149, 0.560510743948727, -110.8956, -1.93549334597462),
(37372, '85735', 218, 5, 74577, 31.954, 0.557702509182268, -111.3467, -1.94336652623037),
(37373, '85736', 218, 5, 74577, 31.6626, 0.552616619741957, -111.3927, -1.94416937768629),
(37374, '85737', 218, 5, 74577, 32.4225, 0.565879376727861, -110.955, -1.93653007155031),
(37375, '85738', 218, 5, 159867, 32.478, 0.566848034462718, -110.9119, -1.9357778346427),
(37376, '85739', 218, 5, 74577, 32.324, 0.564160227414647, -110.9448, -1.93635204796661),
(37377, '85740', 218, 5, 74577, 32.3608, 0.564802508579381, -111.0782, -1.93868031718877),
(37378, '85741', 218, 5, 74577, 32.3544, 0.564690807507253, -111.0436, -1.93807643326758),
(37379, '85742', 218, 5, 74577, 32.4203, 0.565840979484318, -111.0579, -1.93832601535061),
(37380, '85743', 218, 5, 74577, 32.2974, 0.563695969833617, -111.1509, -1.93994917155497),
(37381, '85744', 218, 5, 74577, 32.046, 0.559308212094103, -110.6735, -1.93161696970594),
(37382, '85745', 218, 5, 74577, 32.2494, 0.562858211792659, -111.0303, -1.93784430447706),
(37383, '85746', 218, 5, 74577, 32.0806, 0.559912096015293, -111.0953, -1.93897876849086),
(37384, '85747', 218, 5, 74577, 32.0443, 0.559278541496819, -110.7352, -1.93269383785442),
(37385, '85748', 218, 5, 74577, 32.2156, 0.562268290505485, -110.7711, -1.93332041105589),
(37386, '85749', 218, 5, 74577, 32.273, 0.56327010949613, -110.7661, -1.93323314459329),
(37387, '85750', 218, 5, 74577, 32.2951, 0.563655827260821, -110.8421, -1.93455959482481),
(37388, '85751', 218, 5, 74577, 32.2489, 0.562849485146399, -110.8313, -1.93437109926559),
(37389, '85752', 218, 5, 74577, 32.3506, 0.564624484995678, -111.0476, -1.93814624643766),
(37390, '85754', 218, 5, 74577, 32.2345, 0.562598157734112, -111.0034, -1.93737481090827),
(37391, '85775', 218, 5, 74577, 32.2171, 0.562294470444265, -110.9717, -1.93682154153539),
(37392, '85777', 218, 5, 74577, 32.0918, 0.560107572891516, -110.8576, -1.93483012085887),
(37393, '85901', 218, 5, 179144, 34.2528, 0.597824138027114, -110.0589, -1.92089017612319),
(37394, '85902', 218, 5, 179144, 34.2539, 0.597843336648886, -110.029, -1.92036832267684),
(37395, '85911', 218, 5, 177937, 34.0465, 0.594223523780249, -110.4834, -1.9282990987979),
(37396, '85912', 218, 5, 0, 34.3236, 0.599059831137526, -110.0752, -1.92117466479126),
(37397, '85920', 218, 5, 7073, 33.8186, 0.590245918414954, -109.2015, -1.90592572311659),
(37398, '85922', 218, 5, 29238, 33.5785, 0.586055382880916, -109.096, -1.90408440075573),
(37399, '85923', 218, 5, 177953, 34.3621, 0.599731782899543, -110.2945, -1.92500217184089),
(37400, '85924', 218, 5, 75509, 34.434, 0.600986674631727, -109.6486, -1.91372909020225),
(37401, '85925', 218, 5, 178124, 34.1193, 0.595494123475701, -109.2886, -1.90744590489507),
(37402, '85926', 218, 5, 178201, 33.7905, 0.589755480895144, -109.9884, -1.91965971900053),
(37403, '85927', 218, 5, 2874, 34.0104, 0.593593459920279, -109.4584, -1.91040947396496),
(37404, '85928', 218, 5, 142024, 34.4294, 0.600906389486136, -110.5425, -1.92933058838583),
(37405, '85929', 218, 5, 9948, 34.1236, 0.595569172633537, -109.9488, -1.91896856861674),
(37406, '85930', 218, 5, 37135, 34.0753, 0.594726178604824, -109.8535, -1.91730526983959),
(37407, '85931', 218, 5, 21197, 34.6263, 0.604342942783313, -111.1092, -1.93922136925688),
(37408, '85932', 218, 5, 178731, 33.953, 0.592591640929635, -109.2084, -1.90604615083498),
(37409, '85933', 218, 5, 178768, 34.3904, 0.600225711077858, -110.553, -1.92951384795729),
(37410, '85934', 218, 5, 5064, 34.3077, 0.598782323786459, -110.2511, -1.92424469894552),
(37411, '85935', 218, 5, 137499, 34.1211, 0.595525539402237, -109.9263, -1.91857586953504),
(37412, '85936', 218, 5, 28504, 34.5067, 0.602255528997927, -109.3755, -1.90896259601506),
(37413, '85937', 218, 5, 106379, 34.511, 0.602330578155763, -110.0961, -1.92153943860493),
(37414, '85938', 218, 5, 179206, 34.1309, 0.595696581668933, -109.2779, -1.90725915466511),
(37415, '85939', 218, 5, 6252, 34.459, 0.601423006944726, -110.0804, -1.92126542191237),
(37416, '85940', 218, 5, 6535, 34.2538, 0.597841591319634, -109.6932, -1.91450750704864),
(37417, '85941', 218, 5, 179518, 33.8016, 0.589949212442115, -109.9929, -1.91973825881687),
(37418, '85942', 218, 5, 513, 34.7812, 0.607046457794652, -110.0433, -1.92061790475988),
(37419, '86001', 218, 5, 178187, 35.1884, 0.614153438508773, -111.6602, -1.94883813343537),
(37420, '86002', 218, 5, 178187, 35.2352, 0.614970252598706, -111.5676, -1.94722195854803),
(37421, '86003', 218, 5, 178187, 35.2281, 0.614846334221814, -111.5698, -1.94726035579157),
(37422, '86004', 218, 5, 178187, 35.2272, 0.614830626258547, -111.571, -1.94728129974259),
(37423, '86011', 218, 5, 178187, 35.1895, 0.614172637130545, -111.6198, -1.94813302041757),
(37424, '86015', 218, 5, 62844, 35.2377, 0.615013885830006, -111.8328, -1.95185057172431),
(37425, '86016', 218, 5, 178284, 35.746, 0.623885394417893, -111.4728, -1.94556738641714),
(37426, '86017', 218, 5, 178692, 34.9429, 0.609868655195127, -111.6373, -1.94843845303667),
(37427, '86018', 218, 5, 11080, 35.2604, 0.615410075570209, -111.9481, -1.95386293635186),
(37428, '86020', 218, 5, 806, 35.8485, 0.625674356901187, -111.4322, -1.94485878274083),
(37429, '86021', 218, 5, 177980, 36.9891, 0.645581582349435, -112.9788, -1.97185204495217),
(37430, '86022', 218, 5, 2600, 36.9481, 0.644865997356117, -112.5286, -1.96399457265969),
(37431, '86023', 218, 5, 178270, 35.9423, 0.627311475739558, -112.13, -1.95703769026124),
(37432, '86024', 218, 5, 41257, 34.6603, 0.604936354728991, -111.4809, -1.94570875808655),
(37433, '86025', 218, 5, 21986, 34.9089, 0.609275243249449, -110.1581, -1.92262154274117),
(37434, '86028', 218, 5, 0, 34.7939, 0.607268114609655, -109.8778, -1.91772938484783),
(37435, '86029', 218, 5, 6157, 34.9803, 0.610521408335373, -110.0578, -1.92087097750142),
(37436, '86030', 218, 5, 178391, 36.2229, 0.632208869620654, -110.581, -1.93000254014785),
(37437, '86031', 218, 5, 178412, 35.4061, 0.617953020290364, -110.0839, -1.92132650843619),
(37438, '86032', 218, 5, 178429, 34.9623, 0.610207249070013, -110.3301, -1.9256235090546),
(37439, '86033', 218, 5, 178444, 36.6669, 0.639958131499509, -110.2334, -1.92393577566792),
(37440, '86034', 218, 5, 178445, 35.782, 0.624513712948611, -110.1848, -1.92308754565145),
(37441, '86035', 218, 5, 178528, 35.2861, 0.615858625187971, -111.0375, -1.9379699681832),
(37442, '86036', 218, 5, 178590, 36.9226, 0.644420938396858, -111.4495, -1.94516072470142),
(37443, '86038', 218, 5, 178677, 34.9455, 0.609914033755678, -111.4263, -1.94475580831496),
(37444, '86039', 218, 5, 178483, 35.6532, 0.622265728872042, -110.4942, -1.92848759435712),
(37445, '86040', 218, 5, 678, 36.9133, 0.644258622776423, -111.464, -1.94541379744296),
(37446, '86042', 218, 5, 178903, 35.9649, 0.627705920150509, -110.4313, -1.92738978225761),
(37447, '86043', 218, 5, 179112, 35.929, 0.627079346949043, -110.6372, -1.93098341518747),
(37448, '86044', 218, 5, 179361, 35.9677, 0.627754789369565, -110.8747, -1.93512857216096),
(37449, '86045', 218, 5, 179392, 36.1336, 0.630650290598623, -111.243, -1.94155661979605),
(37450, '86046', 218, 5, 878, 35.291, 0.615944146321319, -112.1609, -1.95757699700011),
(37451, '86047', 218, 5, 567, 35.0301, 0.611390582302866, -110.6998, -1.93207599129922),
(37452, '86052', 218, 5, 178726, 36.213, 0.632036082024707, -112.0577, -1.95577581721205),
(37453, '86053', 218, 5, 178436, 36.4971, 0.636994562429622, -111.3163, -1.94283594613776),
(37454, '86054', 218, 5, 179142, 36.5931, 0.638670078511537, -110.6544, -1.93128361181881),
(37455, '86301', 218, 5, 5219, 34.5751, 0.603449334206291, -112.472, -1.96300671630306),
(37456, '86302', 218, 5, 5219, 34.5831, 0.603588960546451, -112.4301, -1.96227542334648),
(37457, '86303', 218, 5, 5219, 34.5263, 0.602597613531318, -112.4749, -1.96305733085137),
(37458, '86304', 218, 5, 5219, 34.5756, 0.603458060852551, -112.4495, -1.96261401722136),
(37459, '86305', 218, 5, 5219, 34.5399, 0.602834978309589, -112.4679, -1.96293515780373),
(37460, '86312', 218, 5, 178919, 34.6159, 0.604161428541105, -112.3249, -1.96043933697338),
(37461, '86313', 218, 5, 5219, 34.5395, 0.602827996992581, -112.4673, -1.96292468582822),
(37462, '86314', 218, 5, 178919, 34.6064, 0.603995622262166, -112.3214, -1.96037825044956),
(37463, '86320', 218, 5, 193049, 35.1838, 0.614073153363181, -112.6281, -1.96573117526543),
(37464, '86321', 218, 5, 15071, 34.5765, 0.603473768815819, -113.1752, -1.97527987160309),
(37465, '86322', 218, 5, 93008, 34.5574, 0.603140410928688, -111.8355, -1.95189769561412),
(37466, '86323', 218, 5, 177922, 34.7671, 0.606800366370121, -112.4719, -1.96300497097381),
(37467, '86324', 218, 5, 1594, 34.7563, 0.606611870810905, -112.1159, -1.95679159883671),
(37468, '86325', 218, 5, 127162, 34.7229, 0.606028930840739, -111.9075, -1.95315433267555),
(37469, '86326', 218, 5, 1802, 34.7191, 0.605962608329163, -112.0038, -1.95483508474522),
(37470, '86327', 218, 5, 2037, 34.5558, 0.603112485660656, -112.2702, -1.95948464187254),
(37471, '86329', 218, 5, 27486, 34.5034, 0.602197933132612, -112.2225, -1.95865211981934),
(37472, '86330', 218, 5, 9669, 34.5483, 0.602981585966757, -112.478, -1.96311143605818),
(37473, '86331', 218, 5, 9752, 34.751, 0.606519368360549, -112.1071, -1.95663800986254),
(37474, '86332', 218, 5, 3558, 34.4324, 0.600958749363696, -112.6004, -1.96524771906262),
(37475, '86333', 218, 5, 136771, 34.3162, 0.598930676772878, -112.1226, -1.95690853589659),
(37476, '86334', 218, 5, 178827, 34.9122, 0.609332839114764, -112.4725, -1.96301544294932),
(37477, '86335', 218, 5, 178981, 34.6417, 0.60461172348812, -111.7823, -1.95096918045206),
(37478, '86336', 218, 5, 179115, 34.8405, 0.608081438041084, -111.798, -1.95124319714462),
(37479, '86337', 218, 5, 57473, 35.3287, 0.616602135449321, -112.8757, -1.97005261049336),
(37480, '86338', 218, 5, 179174, 34.553, 0.603063616441601, -112.712, -1.96719550650785),
(37481, '86339', 218, 5, 179115, 34.8674, 0.608550931609871, -111.7653, -1.95067247447922),
(37482, '86340', 218, 5, 179115, 34.8414, 0.608097146004352, -111.8307, -1.95181391981002),
(37483, '86341', 218, 5, 179115, 34.7763, 0.606960936661304, -111.7635, -1.95064105855268),
(37484, '86342', 218, 5, 178500, 34.6332, 0.6044633705017, -111.7756, -1.95085224339217),
(37485, '86343', 218, 5, 178044, 34.2197, 0.597246434044704, -112.3071, -1.96012866836652),
(37486, '86351', 218, 5, 179115, 34.7843, 0.607100563001464, -111.7638, -1.95064629454044),
(37487, '86401', 218, 5, 27631, 35.2296, 0.614872514160594, -114.055, -1.99063527836213),
(37488, '86402', 218, 5, 27631, 35.2029, 0.614406511250312, -114.0671, -1.99084646320162),
(37489, '86403', 218, 5, 178499, 34.4907, 0.601976276317608, -114.3123, -1.99512601052751),
(37490, '86404', 218, 5, 178499, 34.5189, 0.602468459166671, -114.3242, -1.9953337047085),
(37491, '86405', 218, 5, 178499, 34.5031, 0.602192697144856, -114.3139, -1.99515393579555),
(37492, '86406', 218, 5, 178499, 34.4755, 0.601710986271305, -114.2834, -1.99462161037369),
(37493, '86411', 218, 5, 41234, 35.3695, 0.617314229784134, -113.7264, -1.98490012644008),
(37494, '86412', 218, 5, 0, 35.5061, 0.619698349542359, -113.8803, -1.9875861881589),
(37495, '86413', 218, 5, 135600, 35.2104, 0.614537410944211, -114.2328, -1.99373847377218),
(37496, '86426', 218, 5, 0, 35.0015, 0.610891418136795, -114.5629, -1.99949980563301),
(37497, '86427', 218, 5, 0, 35.015, 0.611127037585815, -114.5828, -1.99984712615416),
(37498, '86429', 218, 5, 177801, 35.162, 0.613692671586246, -114.4768, -1.99799707714704),
(37499, '86430', 218, 5, 177801, 35.0667, 0.612029372809096, -114.5797, -1.99979302094735),
(37500, '86431', 218, 5, 54034, 35.1959, 0.614284338202672, -114.0311, -1.99021814467091),
(37501, '86432', 218, 5, 112459, 36.3746, 0.634856534095929, -113.5486, -1.98179693103003),
(37502, '86433', 218, 5, 178738, 35.0264, 0.611326005120542, -114.3825, -1.99635123166241),
(37503, '86434', 218, 5, 178831, 35.5406, 0.620300488134297, -113.4166, -1.9794930964174),
(37504, '86435', 218, 5, 179289, 36.1143, 0.630313442052988, -112.5268, -1.96396315673316),
(37505, '86436', 218, 5, 179368, 34.7774, 0.606980135283076, -114.4838, -1.99811925019468),
(37506, '86437', 218, 5, 6493, 35.3874, 0.617626643720241, -113.6564, -1.98367839596368),
(37507, '86438', 218, 5, 6996, 34.8741, 0.608667868669754, -114.1491, -1.99227763318826),
(37508, '86439', 218, 5, 177801, 34.9239, 0.609537042637248, -114.1314, -1.99196870991066),
(37509, '86440', 218, 5, 178661, 34.8876, 0.608903488118774, -114.5751, -1.99971273580176),
(37510, '86441', 218, 5, 178100, 35.5981, 0.621304052454194, -114.2555, -1.99413466351238),
(37511, '86442', 218, 5, 177801, 35.0954, 0.612530282304418, -114.6046, -2.00022760793109),
(37512, '86443', 218, 5, 0, 36.0235, 0.628728683092177, -114.2958, -1.99483803120093),
(37513, '86444', 218, 5, 178619, 35.9826, 0.628014843428112, -114.0746, -1.99097736289552),
(37514, '86445', 218, 5, 153832, 35.9046, 0.626653486611556, -114.5921, -2.00000944177459),
(37515, '86446', 218, 5, 178661, 34.9103, 0.609299677858976, -114.5463, -1.99921008097718),
(37516, '86502', 218, 5, 1475, 35.0172, 0.611165434829358, -109.4467, -1.91020527044248),
(37517, '86503', 218, 5, 177921, 36.1209, 0.63042863378362, -109.5234, -1.91154393797876),
(37518, '86504', 218, 5, 64837, 35.6049, 0.621422734843329, -109.4583, -1.91040772863571),
(37519, '86505', 218, 5, 94407, 35.6054, 0.621431461489589, -109.458, -1.91040249264795),
(37520, '86506', 218, 5, 55382, 35.3919, 0.617705183536581, -109.2848, -1.9073795823835),
(37521, '86507', 218, 5, 178571, 36.3992, 0.63528588509192, -109.2582, -1.90691532480247),
(37522, '86508', 218, 5, 3905, 35.3391, 0.616783649691528, -109.069, -1.9036131618577),
(37523, '86510', 218, 5, 178886, 35.962, 0.627655305602201, -110.3076, -1.9252308099729),
(37524, '86511', 218, 5, 51180, 35.8502, 0.625704027498471, -109.2986, -1.90762043782027),
(37525, '86512', 218, 5, 11797, 35.208, 0.614495523042163, -109.3317, -1.90819814180268),
(37526, '86514', 218, 5, 179316, 36.7519, 0.641441661363704, -109.3642, -1.90876537380958),
(37527, '86515', 218, 5, 179547, 35.6603, 0.622389647248934, -109.1037, -1.90421879110814),
(37528, '86520', 218, 5, 34870, 36.0673, 0.629493137304551, -110.083, -1.92131080047292),
(37529, '86535', 218, 5, 178069, 36.7398, 0.641230476524213, -109.8535, -1.91730526983959),
(37530, '86538', 218, 5, 178586, 36.454, 0.636242325522013, -109.5802, -1.91253528499389),
(37531, '86540', 218, 5, 178705, 35.6051, 0.621426225501833, -109.458, -1.91040249264795),
(37532, '86544', 218, 5, 125, 36.7514, 0.641432934717444, -109.365, -1.9087793364436),
(37533, '86545', 218, 5, 50945, 36.7176, 0.64084301343027, -109.625, -1.91331719249878),
(37534, '86547', 218, 5, 973, 36.5135, 0.63728079642695, -109.4727, -1.910659056048),
(37535, '86556', 218, 5, 0, 36.3239, 0.633971652165168, -109.2685, -1.90709509371542),
(37536, '87001', 218, 38, 188019, 35.3801, 0.617499234684846, -106.4799, -1.85842484219431);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(37537, '87002', 218, 38, 58606, 34.6548, 0.604840361620131, -106.7616, -1.86334143469718),
(37538, '87004', 218, 38, 188137, 35.3086, 0.61625132426967, -106.5471, -1.85959770345165),
(37539, '87005', 218, 38, 177759, 35.1743, 0.613907347084242, -107.894, -1.88310554314676),
(37540, '87006', 218, 38, 92761, 34.5632, 0.603241640025304, -106.7815, -1.86368875521833),
(37541, '87007', 218, 38, 93088, 35.0024, 0.610907126100063, -107.4125, -1.87470178279841),
(37542, '87008', 218, 38, 70629, 35.1333, 0.613191762090924, -106.3628, -1.85638106164022),
(37543, '87009', 218, 38, 93133, 34.4462, 0.601199604800471, -105.7349, -1.84542213926695),
(37544, '87010', 218, 38, 188276, 35.4016, 0.617874480474025, -106.1399, -1.85249072273753),
(37545, '87011', 218, 38, 8100, 34.1431, 0.595909511837676, -105.9936, -1.84993730604186),
(37546, '87012', 218, 38, 180924, 36.1771, 0.631409508823241, -106.6539, -1.86146171509278),
(37547, '87013', 218, 38, 1912, 36.0818, 0.62974621004609, -107.2559, -1.87196859718979),
(37548, '87014', 218, 38, 188386, 34.9393, 0.609805823342055, -107.8531, -1.8823917034827),
(37549, '87015', 218, 38, 2230, 35.0395, 0.611554643252553, -106.1865, -1.85330404616896),
(37550, '87016', 218, 38, 188535, 34.7623, 0.606716590566025, -106.0571, -1.85104559011688),
(37551, '87017', 218, 38, 0, 36.1644, 0.631187852008237, -106.6088, -1.86067457160013),
(37552, '87018', 218, 38, 188369, 36.1404, 0.630768972987759, -106.9392, -1.86644113944872),
(37553, '87020', 218, 38, 9182, 35.1564, 0.613594933148134, -107.8365, -1.88210197882687),
(37554, '87021', 218, 38, 23084, 35.1738, 0.613898620437981, -107.8922, -1.88307412722023),
(37555, '87022', 218, 38, 155860, 34.9204, 0.609475956113428, -106.6993, -1.86225409457319),
(37556, '87023', 218, 38, 188734, 34.6004, 0.603890902507046, -106.7616, -1.86334143469718),
(37557, '87024', 218, 38, 188738, 35.6083, 0.621482076037897, -106.7414, -1.86298887818828),
(37558, '87025', 218, 38, 188740, 35.7646, 0.624210025658764, -106.9209, -1.86612174419561),
(37559, '87026', 218, 38, 178496, 34.8737, 0.608660887352746, -107.2841, -1.87246078003885),
(37560, '87027', 218, 38, 186939, 36.1102, 0.630241883553656, -106.9971, -1.86745168508562),
(37561, '87028', 218, 38, 95426, 34.3924, 0.600260617662898, -106.8034, -1.86407098232451),
(37562, '87029', 218, 38, 188879, 36.3723, 0.634816391523134, -106.9242, -1.86617934006092),
(37563, '87031', 218, 38, 188919, 34.7834, 0.607084855038196, -106.6969, -1.86221220667114),
(37564, '87032', 218, 38, 4100, 34.7472, 0.606453045848974, -106.1564, -1.85277870206411),
(37565, '87034', 218, 38, 0, 35.0831, 0.612315606806423, -107.5958, -1.87790097131731),
(37566, '87035', 218, 38, 189069, 34.958, 0.610132199912178, -106.0535, -1.85098275826381),
(37567, '87036', 218, 38, 189078, 34.5238, 0.602553980300018, -106.2399, -1.85423605198952),
(37568, '87037', 218, 38, 189087, 36.42, 0.635648913576335, -107.8651, -1.88260114299294),
(37569, '87038', 218, 38, 189106, 35.0019, 0.610898399453803, -107.4133, -1.87471574543243),
(37570, '87040', 218, 38, 189187, 34.8741, 0.608667868669754, -107.2843, -1.87246427069735),
(37571, '87041', 218, 38, 189208, 35.6135, 0.621572833159001, -106.3279, -1.85577194173128),
(37572, '87042', 218, 38, 189215, 34.8277, 0.607858035896829, -106.6878, -1.86205338170921),
(37573, '87043', 218, 38, 189244, 35.3125, 0.616319392110498, -106.4419, -1.85776161707855),
(37574, '87044', 218, 38, 24064, 35.6624, 0.622426299163226, -106.6657, -1.86166766394452),
(37575, '87045', 218, 38, 37800, 35.3427, 0.6168464815446, -108.1122, -1.88691385157461),
(37576, '87046', 218, 38, 57132, 36.2018, 0.631840605148483, -107.0589, -1.86853029856336),
(37577, '87047', 218, 38, 189494, 35.1563, 0.613593187818883, -106.3098, -1.85545603713667),
(37578, '87048', 218, 38, 188361, 35.2333, 0.614937091342918, -106.621, -1.86088750176887),
(37579, '87049', 218, 38, 189428, 35.082, 0.612296408184651, -107.6079, -1.87811215615681),
(37580, '87051', 218, 38, 179072, 35.1511, 0.613502430697779, -107.8764, -1.88279836519841),
(37581, '87052', 218, 38, 189524, 35.5354, 0.620209731013193, -106.3899, -1.85685404586752),
(37582, '87053', 218, 38, 177682, 35.6311, 0.621880011107352, -106.8874, -1.86553705889619),
(37583, '87056', 218, 38, 196, 35.1363, 0.613244121968484, -105.9385, -1.84897562962401),
(37584, '87059', 218, 38, 187438, 35.0479, 0.611701250909721, -106.3083, -1.85542985719789),
(37585, '87060', 218, 38, 189687, 34.7419, 0.606360543398618, -106.7335, -1.86285099717737),
(37586, '87061', 218, 38, 189695, 34.7478, 0.606463517824486, -106.1565, -1.85278044739336),
(37587, '87062', 218, 38, 189780, 34.4891, 0.601948351049576, -106.7239, -1.86268344556918),
(37588, '87063', 218, 38, 26074, 34.4499, 0.601264181982795, -106.009, -1.85020608674667),
(37589, '87064', 218, 38, 70438, 36.1889, 0.631615457674976, -106.5587, -1.85980016164488),
(37590, '87068', 218, 38, 188175, 34.8541, 0.608318802819356, -106.6999, -1.8622645665487),
(37591, '87070', 218, 38, 188330, 34.9641, 0.610238664996549, -105.5608, -1.84238352103923),
(37592, '87072', 218, 38, 188339, 35.6093, 0.621499529330417, -106.3437, -1.85604770375309),
(37593, '87083', 218, 38, 188338, 35.6465, 0.622148791812159, -106.335, -1.85589586010817),
(37594, '87101', 218, 38, 188014, 35.1995, 0.614347170055744, -106.6448, -1.86130289013085),
(37595, '87102', 218, 38, 188014, 35.0762, 0.612195179088035, -106.6505, -1.86140237389821),
(37596, '87103', 218, 38, 188014, 35.2109, 0.614546137590471, -106.6316, -1.86107250666959),
(37597, '87104', 218, 38, 188014, 35.1033, 0.612668163315325, -106.672, -1.86177761968739),
(37598, '87105', 218, 38, 188014, 35.0449, 0.611648891032161, -106.6955, -1.86218777206161),
(37599, '87106', 218, 38, 188014, 35.0808, 0.612275464233627, -106.6192, -1.86085608584234),
(37600, '87107', 218, 38, 188014, 35.1351, 0.61322317801746, -106.6428, -1.86126798354581),
(37601, '87108', 218, 38, 188014, 35.0736, 0.612149800527483, -106.579, -1.86015446348304),
(37602, '87109', 218, 38, 188014, 35.1538, 0.613549554587583, -106.563, -1.85987521080272),
(37603, '87110', 218, 38, 188014, 35.1086, 0.612760665765681, -106.5768, -1.86011606623949),
(37604, '87111', 218, 38, 188014, 35.1345, 0.613212706041948, -106.5188, -1.85910377527334),
(37605, '87112', 218, 38, 188014, 35.1012, 0.612631511401034, -106.5141, -1.85902174479849),
(37606, '87113', 218, 38, 188014, 35.1762, 0.613940508340029, -106.5981, -1.86048782137017),
(37607, '87114', 218, 38, 188014, 35.1911, 0.614200562398576, -106.7852, -1.86375333240065),
(37608, '87115', 218, 38, 188014, 34.9794, 0.610505700372105, -106.5186, -1.85910028461483),
(37609, '87116', 218, 38, 188014, 35.0581, 0.611879274493424, -106.5534, -1.85970765919453),
(37610, '87117', 218, 38, 0, 35.0498, 0.611734412165509, -106.5464, -1.85958548614689),
(37611, '87118', 218, 38, 188014, 35.0585, 0.611886255810432, -106.5989, -1.86050178400418),
(37612, '87119', 218, 38, 188014, 35.0542, 0.611811206652596, -106.618, -1.86083514189131),
(37613, '87120', 218, 38, 188014, 35.1412, 0.613329643101831, -106.7029, -1.86231692642626),
(37614, '87121', 218, 38, 188014, 35.0193, 0.61120208674365, -106.7561, -1.86324544158832),
(37615, '87122', 218, 38, 188014, 35.1812, 0.614027774802629, -106.4887, -1.85857843116849),
(37616, '87123', 218, 38, 188014, 35.0701, 0.612088714003663, -106.5044, -1.85885244786105),
(37617, '87124', 218, 38, 189354, 35.2524, 0.615270449230049, -106.6766, -1.86185790483298),
(37618, '87125', 218, 38, 188014, 35.0936, 0.612498866377882, -106.6418, -1.86125053025329),
(37619, '87131', 218, 38, 188014, 35.0904, 0.612443015841818, -106.6188, -1.86084910452533),
(37620, '87144', 218, 38, 189354, 35.2522, 0.615266958571545, -106.6761, -1.86184917818672),
(37621, '87151', 218, 38, 188014, 35.0226, 0.611259682608966, -106.8556, -1.86498204419405),
(37622, '87153', 218, 38, 188014, 35.0648, 0.611996211553308, -106.5055, -1.85887164648282),
(37623, '87154', 218, 38, 188014, 35.1447, 0.613390729625651, -106.4877, -1.85856097787597),
(37624, '87158', 218, 38, 188014, 35.0837, 0.612326078781935, -106.6467, -1.86133605138664),
(37625, '87174', 218, 38, 189354, 35.2788, 0.615731216152575, -106.6501, -1.8613953925812),
(37626, '87176', 218, 38, 188014, 34.9965, 0.610804151674196, -106.3395, -1.85597439992451),
(37627, '87181', 218, 38, 188014, 35.102, 0.61264547403505, -106.5168, -1.8590688686883),
(37628, '87184', 218, 38, 188014, 35.199, 0.614338443409484, -106.6625, -1.86161181340845),
(37629, '87185', 218, 38, 188014, 34.9826, 0.610561550908168, -106.5165, -1.85906363270054),
(37630, '87187', 218, 38, 188014, 35.1703, 0.613837533914162, -106.8345, -1.86461377972188),
(37631, '87190', 218, 38, 188014, 35.1071, 0.612734485826901, -106.596, -1.86045116945588),
(37632, '87191', 218, 38, 188014, 35.1367, 0.613251103285492, -106.5198, -1.85912122856586),
(37633, '87192', 218, 38, 188014, 35.1015, 0.61263674738879, -106.516, -1.85905490605428),
(37634, '87193', 218, 38, 188014, 35.1877, 0.614141221204009, -106.6863, -1.86202720177043),
(37635, '87194', 218, 38, 188014, 35.1044, 0.612687361937097, -106.6755, -1.86183870621121),
(37636, '87195', 218, 38, 188014, 35.0653, 0.612004938199568, -106.6742, -1.86181601693094),
(37637, '87196', 218, 38, 188014, 35.0805, 0.612270228245871, -106.6191, -1.86085434051309),
(37638, '87197', 218, 38, 188014, 35.1214, 0.612984067909936, -106.6457, -1.86131859809412),
(37639, '87198', 218, 38, 188014, 35.084, 0.612331314769691, -106.6505, -1.86140237389821),
(37640, '87199', 218, 38, 188014, 35.1596, 0.613650783684198, -106.5787, -1.86014922749528),
(37641, '87301', 218, 38, 36034, 35.5235, 0.620002036832206, -108.7284, -1.8976685704254),
(37642, '87302', 218, 38, 36034, 35.4315, 0.618396333920371, -108.727, -1.89764413581587),
(37643, '87305', 218, 38, 36034, 35.4712, 0.619089229633413, -108.8211, -1.899286490642),
(37644, '87310', 218, 38, 0, 35.8085, 0.62497622520039, -108.5769, -1.89502439660863),
(37645, '87311', 218, 38, 188315, 35.5337, 0.620180060415909, -108.6066, -1.89554275939647),
(37646, '87312', 218, 38, 188347, 35.47, 0.619068285682389, -108.4522, -1.89284797103139),
(37647, '87313', 218, 38, 188381, 35.8015, 0.62485405215275, -107.9265, -1.88367277515366),
(37648, '87315', 218, 38, 188548, 34.7659, 0.606779422419097, -108.7815, -1.89859534025821),
(37649, '87316', 218, 38, 188564, 35.4318, 0.618401569908127, -108.7262, -1.89763017318186),
(37650, '87317', 218, 38, 188590, 35.5693, 0.620801397629619, -108.7638, -1.89828641698061),
(37651, '87319', 218, 38, 189015, 35.4941, 0.619488910032119, -108.8548, -1.89987466659992),
(37652, '87320', 218, 38, 189028, 35.775, 0.624391539900971, -108.8427, -1.89966348176043),
(37653, '87321', 218, 38, 5287, 35.1364, 0.613245867297736, -108.5037, -1.89374681559617),
(37654, '87322', 218, 38, 5345, 35.431, 0.618387607274111, -108.7258, -1.89762319186485),
(37655, '87323', 218, 38, 189660, 35.5468, 0.62040869854792, -107.7545, -1.88067080884023),
(37656, '87325', 218, 38, 189682, 35.8606, 0.625885541740678, -108.7617, -1.89824976506632),
(37657, '87326', 218, 38, 189774, 35.3503, 0.616979126567751, -108.6927, -1.89704548788244),
(37658, '87327', 218, 38, 107897, 35.0873, 0.612388910635006, -108.7897, -1.89873845725688),
(37659, '87328', 218, 38, 178699, 35.9019, 0.626606362721752, -109.0303, -1.90293771943717),
(37660, '87347', 218, 38, 3399, 35.431, 0.618387607274111, -108.726, -1.89762668252335),
(37661, '87357', 218, 38, 83008, 35.1364, 0.613245867297736, -108.5038, -1.89374856092542),
(37662, '87364', 218, 38, 189554, 36.1427, 0.630809115560555, -108.7071, -1.89729681529473),
(37663, '87365', 218, 38, 138154, 35.7736, 0.624367105291443, -107.9888, -1.88476011527765),
(37664, '87375', 218, 38, 0, 35.4313, 0.618392843261867, -108.7257, -1.8976214465356),
(37665, '87401', 218, 38, 8849, 36.7435, 0.641295053706536, -108.1897, -1.88826648174491),
(37666, '87402', 218, 38, 8849, 36.773, 0.641809925835875, -108.1417, -1.88742872370395),
(37667, '87410', 218, 38, 188097, 36.838, 0.642944389849671, -107.9939, -1.8848491270695),
(37668, '87412', 218, 38, 7529, 36.7801, 0.641933844212766, -107.734, -1.88031301634357),
(37669, '87413', 218, 38, 7544, 36.7143, 0.640785417564954, -107.9709, -1.88444770134155),
(37670, '87415', 218, 38, 188553, 36.8122, 0.642494094902657, -108.0839, -1.8864199233963),
(37671, '87416', 218, 38, 16149, 36.7437, 0.64129854436504, -108.3982, -1.89190549323532),
(37672, '87417', 218, 38, 156003, 36.7474, 0.641363121547364, -108.3557, -1.89116372830322),
(37673, '87418', 218, 38, 48763, 36.9643, 0.64514874069494, -108.1689, -1.88790345326049),
(37674, '87419', 218, 38, 189098, 36.9059, 0.644129468411775, -107.6504, -1.8788539210889),
(37675, '87420', 218, 38, 189560, 36.5739, 0.638334975295154, -108.5919, -1.89528619599643),
(37676, '87421', 218, 38, 0, 36.7442, 0.6413072710113, -108.4712, -1.89317958358927),
(37677, '87455', 218, 38, 49796, 36.2837, 0.633270029805867, -108.7065, -1.89728634331922),
(37678, '87461', 218, 38, 189501, 36.4345, 0.635901986317874, -108.8726, -1.90018533520678),
(37679, '87499', 218, 38, 8849, 36.7308, 0.641073396891533, -108.1529, -1.88762420058018),
(37680, '87500', 218, 38, 17977, 35.6784, 0.622705551843545, -105.9537, -1.84924091967032),
(37681, '87501', 218, 38, 17977, 35.6761, 0.622665409270749, -105.9582, -1.84931945948666),
(37682, '87502', 218, 38, 17977, 35.6609, 0.622400119224446, -105.9804, -1.8497069225806),
(37683, '87503', 218, 38, 17977, 35.6821, 0.622770129025869, -105.9397, -1.84899657357504),
(37684, '87504', 218, 38, 17977, 35.8104, 0.625009386456177, -105.9866, -1.84981513299422),
(37685, '87505', 218, 38, 17977, 35.6187, 0.621663590280104, -105.9657, -1.84945035918056),
(37686, '87506', 218, 38, 17977, 35.5848, 0.621071923663678, -106.0211, -1.85041727158616),
(37687, '87507', 218, 38, 17977, 35.6761, 0.622665409270749, -105.9589, -1.84933167679142),
(37688, '87508', 218, 38, 17977, 35.6183, 0.621656608963096, -105.9655, -1.84944686852205),
(37689, '87509', 218, 38, 17977, 35.6735, 0.622620030710197, -105.9537, -1.84924091967032),
(37690, '87510', 218, 38, 187977, 36.1542, 0.631009828424534, -106.2359, -1.85416623881944),
(37691, '87511', 218, 38, 34521, 36.1443, 0.630837040828586, -105.9959, -1.84997744861466),
(37692, '87512', 218, 38, 188031, 36.8023, 0.642321307306709, -105.5844, -1.8427954187427),
(37693, '87513', 218, 38, 188081, 36.5332, 0.637624626289592, -105.6652, -1.84420564477831),
(37694, '87514', 218, 38, 188083, 36.5036, 0.637108008831002, -105.6169, -1.8433626507496),
(37695, '87515', 218, 38, 188218, 36.6739, 0.640080304547148, -106.5532, -1.85970416853602),
(37696, '87516', 218, 38, 188230, 36.1549, 0.631022045729298, -106.2361, -1.85416972947795),
(37697, '87517', 218, 38, 572, 36.6369, 0.63943453272391, -105.8443, -1.84733152946863),
(37698, '87518', 218, 38, 188260, 36.6735, 0.64007332323014, -106.553, -1.85970067787752),
(37699, '87519', 218, 38, 180641, 36.7357, 0.641158918024881, -105.4763, -1.84090871782129),
(37700, '87520', 218, 38, 186522, 36.8571, 0.643277747736802, -106.6031, -1.86057508783277),
(37701, '87521', 218, 38, 188282, 36.1546, 0.631016809741542, -105.7285, -1.84531043819482),
(37702, '87522', 218, 38, 188307, 36.0273, 0.628795005603753, -105.7692, -1.84602078720039),
(37703, '87523', 218, 38, 924, 36.0269, 0.628788024286745, -105.7692, -1.84602078720039),
(37704, '87524', 218, 38, 188365, 36.9145, 0.644279566727447, -105.4582, -1.84059281322668),
(37705, '87525', 218, 38, 189634, 36.4064, 0.635411548798064, -105.5757, -1.84264357509778),
(37706, '87527', 218, 38, 828, 36.1649, 0.631196578654497, -105.8641, -1.84767710466053),
(37707, '87528', 218, 38, 188444, 36.945, 0.644811892149305, -106.9898, -1.86732427605023),
(37708, '87529', 218, 38, 188492, 36.4054, 0.635394095505544, -105.5752, -1.84263484845152),
(37709, '87530', 218, 38, 188497, 36.3227, 0.633950708214144, -106.2812, -1.8549568729706),
(37710, '87531', 218, 38, 188516, 36.1444, 0.630838786157838, -105.9962, -1.84998268460241),
(37711, '87532', 218, 38, 15948, 36.0083, 0.628463393045874, -106.0708, -1.8512847002244),
(37712, '87533', 218, 38, 15948, 36.0121, 0.62852971555745, -106.0618, -1.85112762059172),
(37713, '87535', 218, 38, 188617, 35.6064, 0.621448914782109, -105.7832, -1.84626513329567),
(37714, '87537', 218, 38, 188676, 36.0696, 0.629533279877347, -106.1624, -1.85288342181923),
(37715, '87538', 218, 38, 188716, 35.6901, 0.622909755366028, -105.9374, -1.84895643100224),
(37716, '87539', 218, 38, 188810, 36.2924, 0.63342187345079, -106.1072, -1.85192000007213),
(37717, '87540', 218, 38, 188840, 35.396, 0.617776742035913, -105.85, -1.847431013236),
(37718, '87543', 218, 38, 95760, 36.1671, 0.631234975898041, -105.6852, -1.84455471062871),
(37719, '87544', 218, 38, 182922, 35.8676, 0.626007714788318, -106.2682, -1.85472998016784),
(37720, '87545', 218, 38, 182922, 35.8937, 0.626463245723089, -106.2844, -1.85501272350666),
(37721, '87548', 218, 38, 189011, 36.1546, 0.631016809741542, -106.2365, -1.85417671079496),
(37722, '87549', 218, 38, 189143, 36.7353, 0.641151936707873, -105.8677, -1.8477399365136),
(37723, '87551', 218, 38, 188924, 36.6734, 0.640071577900888, -106.5525, -1.85969195123126),
(37724, '87552', 218, 38, 189203, 35.5935, 0.621223767308602, -105.5693, -1.84253187402565),
(37725, '87553', 218, 38, 189210, 36.1723, 0.631325733019145, -105.7, -1.84481301935801),
(37726, '87554', 218, 38, 189221, 36.6965, 0.640474748958099, -106.1344, -1.85239472962867),
(37727, '87556', 218, 38, 189302, 36.7169, 0.640830796125506, -105.5967, -1.8430100942407),
(37728, '87557', 218, 38, 189317, 36.3724, 0.634818136852386, -105.5985, -1.84304151016723),
(37729, '87558', 218, 38, 83233, 36.7348, 0.641143210061613, -105.5921, -1.8429298090951),
(37730, '87560', 218, 38, 189337, 35.2346, 0.614959780623194, -105.5202, -1.84167491736292),
(37731, '87562', 218, 38, 105922, 35.5085, 0.619740237444406, -105.6695, -1.84428069393615),
(37732, '87564', 218, 38, 189422, 36.6289, 0.639294906383751, -105.6065, -1.84318113650739),
(37733, '87565', 218, 38, 17939, 35.4838, 0.619309141119164, -105.409, -1.8397341112347),
(37734, '87566', 218, 38, 189446, 36.0536, 0.629254027197028, -106.0714, -1.85129517219991),
(37735, '87567', 218, 38, 97854, 35.9946, 0.628224282938351, -106.0505, -1.85093039838625),
(37736, '87569', 218, 38, 189546, 35.4836, 0.61930565046066, -105.409, -1.8397341112347),
(37737, '87571', 218, 38, 688, 36.4042, 0.63537315155452, -105.5819, -1.8427517855114),
(37738, '87573', 218, 38, 189652, 35.776, 0.624408993193491, -105.6256, -1.84351449439452),
(37739, '87574', 218, 38, 189653, 35.8077, 0.624962262566373, -105.9173, -1.84860561982259),
(37740, '87575', 218, 38, 189664, 36.6739, 0.640080304547148, -106.5527, -1.85969544188976),
(37741, '87576', 218, 38, 189710, 36.1553, 0.631029027046306, -105.6245, -1.84349529577275),
(37742, '87577', 218, 38, 189714, 36.6368, 0.639432787394659, -105.8443, -1.84733152946863),
(37743, '87578', 218, 38, 189717, 36.0377, 0.62897651984596, -105.8077, -1.8466927389624),
(37744, '87579', 218, 38, 189754, 36.1889, 0.631615457674976, -105.6885, -1.84461230649403),
(37745, '87580', 218, 38, 18418, 36.5735, 0.638327993978146, -105.5027, -1.84136948474382),
(37746, '87581', 218, 38, 189765, 36.6957, 0.640460786324083, -106.1347, -1.85239996561643),
(37747, '87582', 218, 38, 189781, 36.1446, 0.630842276816342, -105.9954, -1.8499687219684),
(37748, '87583', 218, 38, 189788, 35.2347, 0.614961525952446, -105.5195, -1.84166270005816),
(37749, '87592', 218, 38, 17977, 35.7954, 0.624747587068378, -105.9938, -1.84994079670037),
(37750, '87594', 218, 38, 17977, 35.7954, 0.624747587068378, -105.9936, -1.84993730604186),
(37751, '87701', 218, 38, 95621, 35.6021, 0.621373865624273, -105.2245, -1.83651397876477),
(37752, '87710', 218, 38, 188043, 36.3989, 0.635280649104164, -105.2874, -1.83761179086428),
(37753, '87711', 218, 38, 188055, 35.0868, 0.612380183988746, -105.0632, -1.83369876268131),
(37754, '87712', 218, 38, 1223, 35.9133, 0.62680533025648, -105.2484, -1.836931112456),
(37755, '87713', 218, 38, 188278, 36.1546, 0.631016809741542, -105.3847, -1.83930999622647),
(37756, '87714', 218, 38, 177943, 36.5752, 0.63835766457543, -105.0501, -1.8334701245493),
(37757, '87715', 218, 38, 1620, 35.9706, 0.627805403917872, -105.5457, -1.84211997632218),
(37758, '87718', 218, 38, 46744, 36.59, 0.638615973304725, -105.2769, -1.83742853129282),
(37759, '87722', 218, 38, 188643, 36.1482, 0.630905108669414, -105.1368, -1.83498332501077),
(37760, '87723', 218, 38, 328, 36.0388, 0.628995718467733, -105.383, -1.83928032562918),
(37761, '87724', 218, 38, 188808, 35.1942, 0.614254667605388, -105.0864, -1.83410367906777),
(37762, '87728', 218, 38, 4045, 36.541, 0.637760761971248, -104.5402, -1.82457069069338),
(37763, '87729', 218, 38, 17102, 36.2869, 0.63332588034193, -104.7704, -1.82858843863147),
(37764, '87730', 218, 38, 10509, 36.1324, 0.630629346647599, -104.2762, -1.81996302146811),
(37765, '87731', 218, 38, 23157, 35.6707, 0.622571161491141, -105.414, -1.8398213776973),
(37766, '87732', 218, 38, 23175, 36.0589, 0.629346529647383, -105.2879, -1.83762051751054),
(37767, '87733', 218, 38, 189072, 35.7178, 0.623393211568831, -103.5939, -1.80805463998175),
(37768, '87734', 218, 38, 189135, 36.0174, 0.628622218007806, -105.0017, -1.83262538519133),
(37769, '87735', 218, 38, 189147, 36.0577, 0.629325585696359, -105.1183, -1.83466043909916),
(37770, '87736', 218, 38, 5285, 35.9781, 0.627936303611772, -105.2081, -1.83622774476745),
(37771, '87740', 218, 38, 189320, 36.8866, 0.64379261986614, -104.4416, -1.82284979605091),
(37772, '87742', 218, 38, 189367, 35.8176, 0.625135050162321, -105.337, -1.83847747417327),
(37773, '87743', 218, 38, 11712, 35.9406, 0.627281805142274, -104.1949, -1.81854406878624),
(37774, '87745', 218, 38, 189531, 35.782, 0.624513712948611, -105.165, -1.83547550785984),
(37775, '87746', 218, 38, 189582, 35.8381, 0.62549284265898, -104.1645, -1.81801348869363),
(37776, '87747', 218, 38, 77316, 36.4179, 0.635612261662043, -104.6068, -1.8257330799752),
(37777, '87749', 218, 38, 189753, 36.5604, 0.638099355846135, -105.1036, -1.83440387569911),
(37778, '87750', 218, 38, 189771, 35.8082, 0.624970989212634, -104.9231, -1.83125355639926),
(37779, '87752', 218, 38, 189796, 36.0105, 0.628501790289418, -104.7019, -1.82739288809385),
(37780, '87753', 218, 38, 189800, 36.0178, 0.628629199324814, -105.0018, -1.83262713052058),
(37781, '87801', 218, 38, 189578, 34.0587, 0.594436453948993, -106.8978, -1.86571857313839),
(37782, '87820', 218, 38, 18889, 33.9507, 0.592551498356839, -108.6785, -1.89679765112866),
(37783, '87821', 218, 38, 188403, 33.8629, 0.591019099273588, -108.0851, -1.88644086734732),
(37784, '87823', 218, 38, 188872, 34.1595, 0.596195745835003, -106.9088, -1.86591055935611),
(37785, '87824', 218, 38, 10230, 33.6524, 0.58734518119814, -108.7647, -1.89830212494388),
(37786, '87825', 218, 38, 188966, 34.0616, 0.5944870684973, -107.3452, -1.87352717621182),
(37787, '87827', 218, 38, 189228, 34.3328, 0.599220401428709, -108.2799, -1.88984076873021),
(37788, '87828', 218, 38, 189261, 34.2157, 0.597176620874624, -106.9146, -1.86601178845273),
(37789, '87829', 218, 38, 189301, 34.3179, 0.598960347370162, -108.7983, -1.89888855557255),
(37790, '87830', 218, 38, 33745, 33.6525, 0.587346926527392, -108.7645, -1.89829863428537),
(37791, '87831', 218, 38, 189413, 34.2354, 0.597520450737267, -106.9138, -1.86599782581871),
(37792, '87832', 218, 38, 17931, 33.8738, 0.591209340162055, -106.8865, -1.86552135093292),
(37793, '87901', 218, 38, 189719, 33.1312, 0.578248525136745, -107.2535, -1.87192670928774),
(37794, '87930', 218, 38, 188079, 32.7375, 0.571377163871644, -107.418, -1.87479777590727),
(37795, '87931', 218, 38, 188205, 33.0166, 0.57624837781396, -107.4149, -1.87474367070046),
(37796, '87933', 218, 38, 40058, 32.8503, 0.573345895267893, -107.0375, -1.86815679810343),
(37797, '87935', 218, 38, 188508, 33.1968, 0.579393461126054, -107.2203, -1.87134725997608),
(37798, '87936', 218, 38, 9050, 32.7481, 0.571562168772355, -107.2641, -1.87211171418845),
(37799, '87937', 218, 38, 55206, 32.6678, 0.570160669383004, -107.1538, -1.8701866160235),
(37800, '87939', 218, 38, 588, 33.3477, 0.582027162967313, -107.4141, -1.87472970806644),
(37801, '87940', 218, 38, 24340, 32.6676, 0.5701571787245, -107.155, -1.87020755997452),
(37802, '87941', 218, 38, 126, 32.7149, 0.570982719460693, -107.237, -1.87163872996116),
(37803, '87942', 218, 38, 6831, 33.1069, 0.577824410128511, -107.3111, -1.87293201893689),
(37804, '87943', 218, 38, 18654, 33.325, 0.58163097322711, -107.7658, -1.88086803104571),
(37805, '88001', 218, 38, 182711, 32.3153, 0.564008383769724, -106.7464, -1.86307614465087),
(37806, '88002', 218, 38, 0, 32.2603, 0.563048452681127, -106.4709, -1.85826776256163),
(37807, '88003', 218, 38, 182711, 32.2775, 0.56334864931247, -106.7579, -1.86327685751485),
(37808, '88004', 218, 38, 182711, 32.3332, 0.564320797705831, -106.72, -1.86261537772835),
(37809, '88005', 218, 38, 182711, 32.3222, 0.564128811488111, -106.8039, -1.86407970897077),
(37810, '88006', 218, 38, 182711, 32.32, 0.564090414244567, -106.767, -1.86343568247679),
(37811, '88007', 218, 38, 182711, 32.3219, 0.564123575500355, -106.8041, -1.86408319962928),
(37812, '88008', 218, 38, 189520, 31.8589, 0.556042701063621, -106.6426, -1.86126449288731),
(37813, '88009', 218, 38, 189249, 32.0295, 0.559020232767524, -108.6856, -1.89692156950555),
(37814, '88011', 218, 38, 182711, 32.33, 0.564264947169767, -106.7094, -1.86243037282764),
(37815, '88012', 218, 38, 182711, 32.4075, 0.565617577340062, -106.7051, -1.8623553236698),
(37816, '88020', 218, 38, 188049, 31.6272, 0.551998773186751, -108.6411, -1.89614489798841),
(37817, '88021', 218, 38, 15007, 32.0112, 0.558700837514409, -106.5717, -1.86002705444764),
(37818, '88022', 218, 38, 188074, 32.6297, 0.569495698937994, -108.172, -1.88795755846731),
(37819, '88023', 218, 38, 360, 32.7641, 0.571841421452674, -108.1351, -1.88731353197332),
(37820, '88024', 218, 38, 188132, 32.0715, 0.559753271053361, -106.632, -1.86107948798659),
(37821, '88025', 218, 38, 1213, 32.8677, 0.57364958255774, -108.7226, -1.89756734132879),
(37822, '88026', 218, 38, 17976, 32.7782, 0.572087512877205, -108.1492, -1.88755962339785),
(37823, '88027', 218, 38, 188280, 32.0339, 0.559097027254612, -106.661, -1.86158563346967),
(37824, '88028', 218, 38, 35278, 32.9639, 0.575328589298159, -108.6136, -1.89566493244411),
(37825, '88029', 218, 38, 1718, 31.8337, 0.555602878092119, -107.6424, -1.87871429474874),
(37826, '88030', 218, 38, 122497, 32.2611, 0.563062415315143, -107.7555, -1.88068826213275),
(37827, '88031', 218, 38, 122497, 32.2546, 0.562948968913763, -107.7551, -1.88068128081574),
(37828, '88032', 218, 38, 188435, 32.3888, 0.565291200769939, -106.7802, -1.86366606593805),
(37829, '88033', 218, 38, 188540, 32.314, 0.563985694489448, -107.0368, -1.86814458079867),
(37830, '88034', 218, 38, 35865, 32.5868, 0.568746952688888, -107.9318, -1.88376527760402),
(37831, '88036', 218, 38, 188560, 32.7704, 0.57195137719555, -108.1443, -1.8874741022645),
(37832, '88038', 218, 38, 27256, 33.0176, 0.57626583110648, -108.283, -1.88989487393702),
(37833, '88039', 218, 38, 2749, 33.2962, 0.581128318402536, -108.6649, -1.89656028635039),
(37834, '88040', 218, 38, 188650, 32.2753, 0.563310252068926, -108.3435, -1.89095079813448),
(37835, '88041', 218, 38, 2963, 32.8022, 0.572506391897684, -107.9185, -1.8835331488135),
(37836, '88042', 218, 38, 3145, 32.9168, 0.574506539220469, -107.6594, -1.87901100072158),
(37837, '88043', 218, 38, 3300, 32.6989, 0.570703466780374, -108.1298, -1.88722102952296),
(37838, '88044', 218, 38, 182564, 32.1006, 0.560261161865692, -106.6872, -1.86204290973369),
(37839, '88045', 218, 38, 188902, 32.3474, 0.564568634459614, -108.7096, -1.89734044852603),
(37840, '88046', 218, 38, 189020, 32.2492, 0.562854721134155, -106.7618, -1.86334492535568),
(37841, '88047', 218, 38, 189024, 32.2379, 0.56265749892868, -106.7376, -1.8629225556767),
(37842, '88048', 218, 38, 96160, 32.1043, 0.560325739048016, -106.6507, -1.86140586455672),
(37843, '88049', 218, 38, 189041, 32.8694, 0.573679253155024, -107.9703, -1.88443722936603),
(37844, '88051', 218, 38, 189081, 32.8678, 0.573651327886992, -108.722, -1.89755686935327),
(37845, '88052', 218, 38, 189173, 32.4225, 0.565879376727861, -106.605, -1.86060824908856),
(37846, '88053', 218, 38, 189241, 32.783, 0.572171288681301, -108.2702, -1.88967147179276),
(37847, '88054', 218, 38, 24197, 32.6407, 0.569687685155713, -107.0725, -1.86876766334163),
(37848, '88055', 218, 38, 189329, 32.867, 0.573637365252976, -108.7223, -1.89756210534103),
(37849, '88056', 218, 38, 184644, 31.8372, 0.555663964615939, -109.0302, -1.90293597410792),
(37850, '88058', 218, 38, 179068, 32.1087, 0.560402533535103, -106.6791, -1.86190153806428),
(37851, '88061', 218, 38, 24871, 32.7768, 0.572063078267677, -108.2684, -1.88964005586623),
(37852, '88062', 218, 38, 24871, 32.759, 0.571752409660822, -108.2763, -1.88977793687714),
(37853, '88063', 218, 38, 189615, 31.7998, 0.555011211475693, -106.5784, -1.86014399150752),
(37854, '88065', 218, 38, 25631, 32.6706, 0.570209538602059, -108.2902, -1.89002053764316),
(37855, '88072', 218, 38, 189755, 32.1153, 0.560517725265735, -106.6762, -1.86185092351597),
(37856, '88081', 218, 38, 177906, 32.0116, 0.558707818831417, -106.5717, -1.86002705444764),
(37857, '88101', 218, 38, 180781, 34.4114, 0.600592230220777, -103.2153, -1.8014468234337),
(37858, '88102', 218, 38, 180781, 34.3912, 0.600239673711874, -103.2147, -1.80143635145819),
(37859, '88103', 218, 38, 0, 34.518, 0.602452751203403, -103.254, -1.80212226585423),
(37860, '88112', 218, 38, 29300, 34.8067, 0.60749151675391, -103.1257, -1.79988300842392),
(37861, '88113', 218, 38, 35174, 33.8611, 0.590987683347052, -103.1391, -1.80011688254368),
(37862, '88114', 218, 38, 1901, 33.5079, 0.584823180429008, -103.3392, -1.80360928637692),
(37863, '88115', 218, 38, 746, 33.9383, 0.592335077529591, -103.3357, -1.8035481998531),
(37864, '88116', 218, 38, 155158, 33.8956, 0.59158982193899, -103.6188, -1.8084892269655),
(37865, '88118', 218, 38, 2508, 34.2914, 0.598497835118384, -103.7536, -1.81084193079719),
(37866, '88119', 218, 38, 188563, 34.4736, 0.601677825015517, -104.2377, -1.81929106970609),
(37867, '88120', 218, 38, 2800, 34.8209, 0.607739353507693, -103.3166, -1.80321484196597),
(37868, '88121', 218, 38, 60331, 34.7364, 0.606264550289758, -103.982, -1.81482826280874),
(37869, '88122', 218, 38, 109932, 33.8419, 0.590652580130669, -103.775, -1.81121543125712),
(37870, '88123', 218, 38, 55929, 33.6525, 0.587346926527392, -103.1395, -1.80012386386069),
(37871, '88124', 218, 38, 4153, 34.429, 0.600899408169128, -103.6297, -1.80867946785397),
(37872, '88125', 218, 38, 189040, 33.6299, 0.586952482116441, -103.2851, -1.8026650632516),
(37873, '88126', 218, 38, 189214, 33.7844, 0.589649015810772, -103.3593, -1.80396009755658),
(37874, '88130', 218, 38, 189268, 34.1827, 0.596600662221466, -103.3383, -1.80359357841366),
(37875, '88132', 218, 38, 874, 34.0345, 0.59401408427001, -103.1416, -1.80016051577498),
(37876, '88133', 218, 38, 189405, 34.4841, 0.601861084586977, -103.4555, -1.80563910429699),
(37877, '88134', 218, 38, 189624, 34.3528, 0.599569467279108, -104.0342, -1.81573932467828),
(37878, '88135', 218, 38, 28770, 34.3904, 0.600225711077858, -103.0489, -1.79854259555838),
(37879, '88136', 218, 38, 189840, 34.3539, 0.59958866590088, -104.6005, -1.82562312423233),
(37880, '88201', 218, 38, 5564, 33.3908, 0.582779399874923, -104.5222, -1.82425653142802),
(37881, '88202', 218, 38, 5564, 33.3487, 0.582044616259833, -104.4934, -1.82375387660344),
(37882, '88203', 218, 38, 5564, 33.3941, 0.582836995740238, -104.5225, -1.82426176741577),
(37883, '88210', 218, 38, 58490, 32.8351, 0.57308060522159, -104.4143, -1.82237332116512),
(37884, '88211', 218, 38, 58490, 32.8396, 0.57315914503793, -104.426, -1.8225775246876),
(37885, '88213', 218, 38, 188238, 33.4041, 0.583011528665438, -103.6592, -1.80919433998331),
(37886, '88220', 218, 38, 180533, 32.3983, 0.565457007048879, -104.2429, -1.8193818268272),
(37887, '88221', 218, 38, 180533, 32.4231, 0.565889848703373, -104.2752, -1.81994556817559),
(37888, '88230', 218, 38, 2038, 33.2251, 0.579887389304368, -104.41, -1.82229827200728),
(37889, '88231', 218, 38, 661, 32.4393, 0.566172592042197, -103.1616, -1.80050958162538),
(37890, '88232', 218, 38, 149373, 33.1119, 0.57791167659111, -104.3523, -1.82129121702888),
(37891, '88240', 218, 38, 36458, 32.7259, 0.571174705678412, -103.1401, -1.8001343358362),
(37892, '88241', 218, 38, 36458, 32.7503, 0.571600566015899, -103.1658, -1.80058288545397),
(37893, '88242', 218, 38, 36458, 32.8145, 0.572721067395679, -103.1433, -1.80019018637227),
(37894, '88244', 218, 38, 36458, 32.6268, 0.569445084389686, -103.3322, -1.80348711332928),
(37895, '88250', 218, 38, 665, 32.7535, 0.571656416551963, -104.7465, -1.82817130494024),
(37896, '88252', 218, 38, 188733, 32.1123, 0.560465365388175, -103.1951, -1.8010942669248),
(37897, '88253', 218, 38, 41669, 32.9876, 0.575742232330882, -104.4119, -1.82233143326307),
(37898, '88254', 218, 38, 3637, 32.6378, 0.569637070607405, -104.3752, -1.82169089742759),
(37899, '88255', 218, 38, 188894, 32.8189, 0.572797861882767, -103.9769, -1.81473925101689),
(37900, '88256', 218, 38, 22758, 32.2835, 0.563453369067589, -104.0949, -1.81679873953425),
(37901, '88260', 218, 38, 27759, 32.9456, 0.575009194045044, -103.351, -1.80381523522866),
(37902, '88262', 218, 38, 815, 33.1411, 0.578421312732693, -103.3173, -1.80322705927074),
(37903, '88263', 218, 38, 37031, 32.2119, 0.562203713323161, -104.0674, -1.81631877398995),
(37904, '88264', 218, 38, 188967, 32.828, 0.572956686844699, -103.7364, -1.81054173416585),
(37905, '88265', 218, 38, 164754, 32.6393, 0.569663250546185, -103.1238, -1.79984984716813),
(37906, '88267', 218, 38, 18288, 33.2521, 0.580358628202406, -103.3141, -1.80317120873467),
(37907, '88268', 218, 38, 189816, 32.1751, 0.561561432158428, -104.3765, -1.82171358670786),
(37908, '88301', 218, 38, 188248, 33.6441, 0.587200318870224, -105.8771, -1.84790399746329),
(37909, '88310', 218, 38, 188010, 32.8981, 0.574180162650347, -105.9487, -1.84915365320772),
(37910, '88311', 218, 38, 188010, 32.8236, 0.572879892357611, -105.9788, -1.84967899731257),
(37911, '88312', 218, 38, 18828, 33.3967, 0.58288237430079, -105.6675, -1.84424578735111),
(37912, '88314', 218, 38, 34777, 33.1534, 0.578635988230688, -105.8829, -1.8480052265599),
(37913, '88316', 218, 38, 39643, 33.7257, 0.588624507539852, -105.243, -1.83683686467639),
(37914, '88317', 218, 38, 188331, 32.9533, 0.575143584397447, -105.7412, -1.84553209500983),
(37915, '88318', 218, 38, 1779, 32.808, 0.5726076209943, -105.9784, -1.84967201599556),
(37916, '88321', 218, 38, 94059, 34.5941, 0.60378094676417, -105.4984, -1.84129443558599),
(37917, '88323', 218, 38, 188562, 33.4955, 0.584606759601761, -105.5225, -1.84171505993572),
(37918, '88324', 218, 38, 2739, 33.4032, 0.58299582070217, -105.5155, -1.84159288688808),
(37919, '88325', 218, 38, 0, 33.0786, 0.577330481950196, -106.0269, -1.85051850068278),
(37920, '88330', 218, 38, 0, 32.8197, 0.572811824516783, -105.9374, -1.84895643100224),
(37921, '88336', 218, 38, 94977, 33.4443, 0.58371315102474, -105.3669, -1.83899932761961),
(37922, '88337', 218, 38, 188809, 32.9696, 0.575428073065522, -105.9482, -1.84914492656146),
(37923, '88338', 218, 38, 3781, 33.4898, 0.584507275834397, -105.5354, -1.84194020740922),
(37924, '88339', 218, 38, 96076, 32.9076, 0.574345968929286, -105.467, -1.84074640220086),
(37925, '88340', 218, 38, 189019, 33.2641, 0.580568067712646, -105.727, -1.84528425825604),
(37926, '88341', 218, 38, 10820, 33.5013, 0.584707988698376, -105.7402, -1.84551464171731),
(37927, '88342', 218, 38, 189174, 32.3773, 0.56509048790596, -106.0914, -1.85164423805031),
(37928, '88343', 218, 38, 178857, 33.4261, 0.583395501100877, -105.033, -1.8331716732472),
(37929, '88344', 218, 38, 178886, 32.6553, 0.569942503226504, -105.4246, -1.84000638259801),
(37930, '88345', 218, 38, 189394, 33.3419, 0.581925933870697, -105.6678, -1.84425102333886),
(37931, '88346', 218, 38, 189395, 33.323, 0.58159606664207, -105.6204, -1.84342373727342),
(37932, '88347', 218, 38, 28490, 32.7841, 0.572190487303073, -105.6437, -1.84383039898913),
(37933, '88348', 218, 38, 97805, 33.3643, 0.582316887623144, -105.3559, -1.83880734140189),
(37934, '88349', 218, 38, 0, 32.7907, 0.572305679033705, -105.8181, -1.84687425320461),
(37935, '88350', 218, 38, 189671, 32.8383, 0.573136455757654, -105.6884, -1.84461056116478),
(37936, '88351', 218, 38, 189677, 33.2769, 0.580791469856901, -105.1366, -1.83497983435227),
(37937, '88352', 218, 38, 189723, 33.0753, 0.57727288608488, -106.0164, -1.85033524111132),
(37938, '88353', 218, 38, 6529, 34.6862, 0.605388395005257, -105.1345, -1.83494318243798),
(37939, '88354', 218, 38, 12718, 32.8023, 0.572508137226936, -105.4613, -1.8406469184335),
(37940, '88355', 218, 38, 189394, 33.3657, 0.582341322232672, -105.6429, -1.84381643635512),
(37941, '88401', 218, 38, 189722, 35.1712, 0.61385324187743, -103.7211, -1.81027469879029),
(37942, '88410', 218, 38, 188034, 35.8942, 0.626471972369349, -103.2146, -1.80143460612894),
(37943, '88411', 218, 38, 7259, 35.125, 0.613046899763008, -103.3039, -1.80299318515097),
(37944, '88414', 218, 38, 186485, 36.7282, 0.641028018330981, -103.9753, -1.81471132574886),
(37945, '88415', 218, 38, 608, 36.4503, 0.636177748339689, -103.1801, -1.800832467537),
(37946, '88416', 218, 38, 0, 35.3537, 0.617038467762319, -104.0479, -1.81597843478581),
(37947, '88417', 218, 38, 188390, 34.9893, 0.610678487968052, -104.3764, -1.82171184137861),
(37948, '88418', 218, 38, 115259, 36.6386, 0.639464203321194, -103.8828, -1.81309689619077),
(37949, '88419', 218, 38, 2511, 36.9101, 0.644202772240359, -103.8075, -1.81178266326401),
(37950, '88421', 218, 38, 0, 35.3598, 0.617144932846691, -104.487, -1.82364217553132),
(37951, '88422', 218, 38, 2726, 36.3187, 0.633880895044065, -103.8668, -1.81281764351045),
(37952, '88424', 218, 38, 170434, 36.7354, 0.641153682037125, -103.4581, -1.80568448285755),
(37953, '88426', 218, 38, 3843, 35.4366, 0.618485345712223, -103.2662, -1.80233519602297),
(37954, '88427', 218, 38, 188991, 34.745, 0.60641464860543, -103.6599, -1.80920655728807),
(37955, '88429', 218, 38, 17201, 36.5177, 0.637354100255533, -103.4224, -1.80506140031458),
(37956, '88430', 218, 38, 189092, 35.6383, 0.622005674813495, -103.2138, -1.80142064349492),
(37957, '88431', 218, 38, 73686, 35.1207, 0.612971850605172, -104.2346, -1.81923696449928),
(37958, '88433', 218, 38, 77027, 34.962, 0.610202013082258, -103.8097, -1.81182106050756),
(37959, '88434', 218, 38, 189437, 35.2626, 0.615448472813752, -103.2651, -1.8023159974012),
(37960, '88435', 218, 38, 57422, 34.9394, 0.609807568671307, -104.6837, -1.82707523816999),
(37961, '88436', 218, 38, 33915, 36.2503, 0.632687089835701, -103.1465, -1.80024603690833),
(37962, '88437', 218, 38, 18037, 36.7171, 0.64083428678401, -103.1219, -1.79981668591234),
(37963, '88439', 218, 38, 189711, 35.6112, 0.621532690586205, -104.5964, -1.825551565733),
(37964, '88510', 218, 51, 8705, 31.8109, 0.555204943022664, -106.4176, -1.85733750207032),
(37965, '88511', 218, 51, 8705, 31.8108, 0.555203197693412, -106.4174, -1.85733401141181),
(37966, '88512', 218, 51, 8705, 31.8104, 0.555196216376404, -106.4178, -1.85734099272882),
(37967, '88513', 218, 51, 8705, 31.8114, 0.555213669668924, -106.4173, -1.85733226608256),
(37968, '88514', 218, 51, 8705, 31.8111, 0.555208433681168, -106.4182, -1.85734797404583),
(37969, '88515', 218, 51, 8705, 31.8107, 0.55520145236416, -106.4182, -1.85734797404583),
(37970, '88516', 218, 51, 8705, 31.8114, 0.555213669668924, -106.4179, -1.85734273805807),
(37971, '88517', 218, 51, 8705, 31.811, 0.555206688351916, -106.4182, -1.85734797404583),
(37972, '88518', 218, 51, 8705, 31.8106, 0.555199707034908, -106.4173, -1.85733226608256),
(37973, '88519', 218, 51, 8705, 31.8108, 0.555203197693412, -106.4174, -1.85733401141181),
(37974, '88520', 218, 51, 8705, 31.8109, 0.555204943022664, -106.4182, -1.85734797404583),
(37975, '88521', 218, 51, 8705, 31.8109, 0.555204943022664, -106.4178, -1.85734099272882),
(37976, '88523', 218, 51, 8705, 31.811, 0.555206688351916, -106.4192, -1.85736542733835),
(37977, '88524', 218, 51, 8705, 31.8109, 0.555204943022664, -106.4175, -1.85733575674107),
(37978, '88525', 218, 51, 8705, 31.8105, 0.555197961705656, -106.4182, -1.85734797404583),
(37979, '88526', 218, 51, 8705, 31.8109, 0.555204943022664, -106.4182, -1.85734797404583),
(37980, '88527', 218, 51, 8705, 31.8109, 0.555204943022664, -106.4174, -1.85733401141181),
(37981, '88528', 218, 51, 8705, 31.8105, 0.555197961705656, -106.4178, -1.85734099272882),
(37982, '88529', 218, 51, 8705, 31.8105, 0.555197961705656, -106.4178, -1.85734099272882),
(37983, '88530', 218, 51, 8705, 31.8109, 0.555204943022664, -106.4178, -1.85734099272882),
(37984, '88531', 218, 51, 8705, 31.8109, 0.555204943022664, -106.4183, -1.85734971937508),
(37985, '88532', 218, 51, 8705, 31.811, 0.555206688351916, -106.4173, -1.85733226608256),
(37986, '88533', 218, 51, 8705, 31.8111, 0.555208433681168, -106.4177, -1.85733924739957),
(37987, '88534', 218, 51, 8705, 31.8112, 0.55521017901042, -106.4185, -1.85735321003359),
(37988, '88535', 218, 51, 8705, 31.8112, 0.55521017901042, -106.4175, -1.85733575674107),
(37989, '88536', 218, 51, 8705, 31.8109, 0.555204943022664, -106.4173, -1.85733226608256),
(37990, '88538', 218, 51, 8705, 31.8114, 0.555213669668924, -106.418, -1.85734448338733),
(37991, '88539', 218, 51, 8705, 31.8106, 0.555199707034908, -106.4176, -1.85733750207032),
(37992, '88540', 218, 51, 8705, 31.8493, 0.55587514945543, -106.437, -1.8576760959452),
(37993, '88541', 218, 51, 8705, 31.7694, 0.554480631383087, -106.4277, -1.85751378032477),
(37994, '88542', 218, 51, 8705, 31.7696, 0.55448412204159, -106.4275, -1.85751028966627),
(37995, '88543', 218, 51, 8705, 31.7691, 0.554475395395331, -106.4279, -1.85751727098327),
(37996, '88544', 218, 51, 8705, 31.7691, 0.554475395395331, -106.4283, -1.85752425230028),
(37997, '88545', 218, 51, 8705, 31.7685, 0.554464923419819, -106.3299, -1.85580684831632),
(37998, '88546', 218, 51, 8705, 31.7682, 0.554459687432063, -106.3297, -1.85580335765781),
(37999, '88547', 218, 51, 8705, 31.7676, 0.554449215456551, -106.3302, -1.85581208430407),
(38000, '88548', 218, 51, 8705, 31.7686, 0.554466668749071, -106.33, -1.85580859364557),
(38001, '88549', 218, 51, 8705, 31.7684, 0.554463178090567, -106.3302, -1.85581208430407),
(38002, '88550', 218, 51, 8705, 31.769, 0.554473650066079, -106.4277, -1.85751378032477),
(38003, '88553', 218, 51, 8705, 31.7682, 0.554459687432063, -106.3302, -1.85581208430407),
(38004, '88554', 218, 51, 8705, 31.7683, 0.554461432761315, -106.3304, -1.85581557496258),
(38005, '88555', 218, 51, 8705, 31.7682, 0.554459687432063, -106.3305, -1.85581732029183),
(38006, '88556', 218, 51, 8705, 31.7686, 0.554466668749071, -106.3304, -1.85581557496258),
(38007, '88557', 218, 51, 8705, 31.7679, 0.554454451444307, -106.3302, -1.85581208430407),
(38008, '88558', 218, 51, 8705, 31.7683, 0.554461432761315, -106.3299, -1.85580684831632),
(38009, '88559', 218, 51, 8705, 31.7683, 0.554461432761315, -106.3307, -1.85582081095033),
(38010, '88560', 218, 51, 8705, 31.7681, 0.554457942102811, -106.3302, -1.85581208430407),
(38011, '88561', 218, 51, 8705, 31.7682, 0.554459687432063, -106.3304, -1.85581557496258),
(38012, '88562', 218, 51, 8705, 31.7678, 0.554452706115055, -106.3303, -1.85581382963333),
(38013, '88563', 218, 51, 8705, 31.7677, 0.554450960785803, -106.3301, -1.85581033897482),
(38014, '88565', 218, 51, 8705, 31.7678, 0.554452706115055, -106.3301, -1.85581033897482),
(38015, '88566', 218, 51, 8705, 31.7678, 0.554452706115055, -106.3303, -1.85581382963333),
(38016, '88567', 218, 51, 8705, 31.7685, 0.554464923419819, -106.33, -1.85580859364557),
(38017, '88568', 218, 51, 8705, 31.7684, 0.554463178090567, -106.3302, -1.85581208430407),
(38018, '88569', 218, 51, 8705, 31.7684, 0.554463178090567, -106.3302, -1.85581208430407),
(38019, '88570', 218, 51, 8705, 31.7684, 0.554463178090567, -106.3301, -1.85581033897482),
(38020, '88571', 218, 51, 8705, 31.7682, 0.554459687432063, -106.3303, -1.85581382963333),
(38021, '88572', 218, 51, 8705, 31.7686, 0.554466668749071, -106.3301, -1.85581033897482),
(38022, '88573', 218, 51, 8705, 31.768, 0.554456196773559, -106.3305, -1.85581732029183),
(38023, '88574', 218, 51, 8705, 31.7684, 0.554463178090567, -106.3306, -1.85581906562108),
(38024, '88575', 218, 51, 8705, 31.7684, 0.554463178090567, -106.3303, -1.85581382963333),
(38025, '88576', 218, 51, 8705, 31.7683, 0.554461432761315, -106.3299, -1.85580684831632),
(38026, '88577', 218, 51, 8705, 31.7683, 0.554461432761315, -106.3305, -1.85581732029183),
(38027, '88578', 218, 51, 8705, 31.7678, 0.554452706115055, -106.3299, -1.85580684831632),
(38028, '88579', 218, 51, 8705, 31.7678, 0.554452706115055, -106.3307, -1.85582081095033),
(38029, '88580', 218, 51, 8705, 31.7676, 0.554449215456551, -106.33, -1.85580859364557),
(38030, '88581', 218, 51, 8705, 31.7685, 0.554464923419819, -106.3308, -1.85582255627959),
(38031, '88582', 218, 51, 8705, 31.7682, 0.554459687432063, -106.3301, -1.85581033897482),
(38032, '88583', 218, 51, 8705, 31.7676, 0.554449215456551, -106.3303, -1.85581382963333),
(38033, '88584', 218, 51, 8705, 31.7684, 0.554463178090567, -106.3306, -1.85581906562108),
(38034, '88585', 218, 51, 8705, 31.7684, 0.554463178090567, -106.3307, -1.85582081095033),
(38035, '88586', 218, 51, 8705, 31.7685, 0.554464923419819, -106.33, -1.85580859364557),
(38036, '88587', 218, 51, 8705, 31.811, 0.555206688351916, -106.4178, -1.85734099272882),
(38037, '88588', 218, 51, 8705, 31.7689, 0.554471904736827, -106.4273, -1.85750679900776),
(38038, '88589', 218, 51, 8705, 31.8108, 0.555203197693412, -106.4174, -1.85733401141181),
(38039, '88590', 218, 51, 8705, 31.7694, 0.554480631383087, -106.4275, -1.85751028966627),
(38040, '88595', 218, 51, 8705, 31.7687, 0.554468414078323, -106.4275, -1.85751028966627),
(38041, '88901', 218, 39, 52022, 36.1441, 0.630833550170082, -115.2818, -2.0120469776256),
(38042, '88905', 218, 39, 52022, 36.1441, 0.630833550170082, -115.2813, -2.01203825097934),
(38043, '89001', 218, 39, 7039, 37.4067, 0.652870077305763, -115.0919, -2.00873259737606),
(38044, '89003', 218, 39, 58588, 36.8792, 0.643663465501493, -116.7306, -2.03733330782849),
(38045, '89004', 218, 39, 34868, 36.0785, 0.629688614180774, -115.4148, -2.01436826553075),
(38046, '89005', 218, 39, 53589, 35.9799, 0.627967719538308, -114.8347, -2.00424361053993),
(38047, '89006', 218, 39, 53589, 35.9661, 0.627726864101533, -114.8381, -2.0043029517345),
(38048, '89007', 218, 39, 189982, 36.7736, 0.641820397811387, -114.1268, -1.99188842476506),
(38049, '89008', 218, 39, 180390, 37.6532, 0.657172313911929, -114.5055, -1.99849798664237),
(38050, '89009', 218, 39, 23, 36.0565, 0.629304641745335, -114.9608, -2.0064444707267),
(38051, '89010', 218, 39, 8642, 37.6783, 0.657610391554179, -118.0841, -2.06095633925424),
(38052, '89011', 218, 39, 23, 36.0874, 0.629843948484202, -114.9447, -2.00616347271713),
(38053, '89012', 218, 39, 23, 35.9697, 0.627789695954604, -115.0716, -2.00837829553791),
(38054, '89013', 218, 39, 115760, 37.7683, 0.659181187880974, -117.4232, -2.04942145822781),
(38055, '89014', 218, 39, 23, 36.0517, 0.62922086594124, -115.0851, -2.00861391498693),
(38056, '89015', 218, 39, 23, 36.037, 0.628964302541197, -114.9947, -2.00703613734312),
(38057, '89016', 218, 39, 23, 36.0947, 0.629971357519597, -114.9452, -2.00617219936339),
(38058, '89017', 218, 39, 190306, 37.5924, 0.656111153726716, -115.2249, -2.01105388528121),
(38059, '89018', 218, 39, 3334, 36.5708, 0.638280870088342, -115.6703, -2.0188275817696),
(38060, '89019', 218, 39, 95167, 35.8056, 0.624925610652082, -115.6344, -2.01820100856813),
(38061, '89020', 218, 39, 189869, 37.1782, 0.648881999964956, -116.4888, -2.03311310169717),
(38062, '89021', 218, 39, 182873, 36.5968, 0.638734655693861, -114.4835, -1.99811401420693),
(38063, '89022', 218, 39, 17009, 38.5386, 0.672625459109087, -117.0752, -2.04334771243087),
(38064, '89023', 218, 39, 4165, 36.6598, 0.639834213122617, -115.9989, -2.02456273369165),
(38065, '89024', 218, 39, 96160, 36.8052, 0.642371921855017, -114.072, -1.99093198433497),
(38066, '89025', 218, 39, 190493, 36.6899, 0.640359557227468, -114.5918, -2.00000420578684),
(38067, '89026', 218, 39, 95167, 35.7785, 0.624452626424791, -115.3226, -2.01275907196041),
(38068, '89027', 218, 39, 96160, 36.8028, 0.642330033952969, -114.1068, -1.99153935891467),
(38069, '89028', 218, 39, 9993, 35.1503, 0.613488468063763, -114.6267, -2.00061332569578),
(38070, '89029', 218, 39, 9993, 35.14, 0.613308699150807, -114.6229, -2.00054700318421),
(38071, '89030', 218, 39, 190553, 36.2144, 0.632060516634234, -115.1369, -2.00951799553946),
(38072, '89031', 218, 39, 190553, 36.2486, 0.632657419238417, -115.1521, -2.00978328558576),
(38073, '89032', 218, 39, 190553, 36.2277, 0.63229264542475, -115.1429, -2.00962271529458),
(38074, '89033', 218, 39, 190553, 36.3005, 0.633563245120202, -115.1413, -2.00959479002655),
(38075, '89036', 218, 39, 190553, 36.3711, 0.63479544757211, -114.8832, -2.00509009522715),
(38076, '89039', 218, 39, 0, 35.3148, 0.616359534683293, -114.883, -2.00508660456865),
(38077, '89040', 218, 39, 4818, 36.2627, 0.632903510662948, -114.6235, -2.00055747515972),
(38078, '89041', 218, 39, 190582, 36.2015, 0.631835369160727, -116.0194, -2.02492052618831),
(38079, '89042', 218, 39, 190586, 37.7906, 0.659570396304169, -114.3882, -1.99645071542978),
(38080, '89043', 218, 39, 190616, 38.2546, 0.667668724033423, -114.4944, -1.9983042550954),
(38081, '89045', 218, 39, 5565, 38.8684, 0.678381554982164, -117.1713, -2.04502497384203),
(38082, '89046', 218, 39, 190721, 35.4655, 0.618989745866049, -114.9165, -2.00567128986806),
(38083, '89047', 218, 39, 0, 37.8044, 0.659811251740944, -117.8773, -2.05734699836111),
(38084, '89048', 218, 39, 190582, 36.2528, 0.632730723067, -116.0181, -2.02489783690803),
(38085, '89049', 218, 39, 177642, 38.0711, 0.664466044856013, -117.2309, -2.04606519007622),
(38086, '89052', 218, 39, 23, 35.9944, 0.628220792279847, -115.1192, -2.00920907226186),
(38087, '89053', 218, 39, 23, 35.9812, 0.627990408818584, -115.0599, -2.00817409201542),
(38088, '89060', 218, 39, 190582, 36.2699, 0.633029174369091, -116.0265, -2.0250444445652),
(38089, '89061', 218, 39, 190582, 36.1251, 0.630501937612204, -115.9278, -2.02332180459348),
(38090, '89070', 218, 39, 3334, 36.5705, 0.638275634100586, -115.6669, -2.01876824057503),
(38091, '89074', 218, 39, 23, 36.0523, 0.629231337916752, -115.0855, -2.00862089630393),
(38092, '89077', 218, 39, 23, 36.0353, 0.628934631943913, -114.9767, -2.00672197807776);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(38093, '89084', 218, 39, 190553, 36.2998, 0.633551027815438, -115.1414, -2.0095965353558),
(38094, '89086', 218, 39, 190553, 36.1984, 0.631781263953915, -115.1168, -2.00916718435981),
(38095, '89101', 218, 39, 95621, 36.1727, 0.631332714336153, -115.1254, -2.00931728267548),
(38096, '89102', 218, 39, 95621, 36.1455, 0.63085798477961, -115.2036, -2.01068213015054),
(38097, '89103', 218, 39, 95621, 36.1153, 0.630330895345508, -115.2168, -2.0109125136118),
(38098, '89104', 218, 39, 95621, 36.1517, 0.630966195193234, -115.1147, -2.00913053244552),
(38099, '89106', 218, 39, 95621, 36.1828, 0.631508992590604, -115.1631, -2.00997527180348),
(38100, '89107', 218, 39, 95621, 36.171, 0.631303043738869, -115.2117, -2.01082350181995),
(38101, '89108', 218, 39, 95621, 36.2071, 0.631933107598839, -115.2249, -2.01105388528121),
(38102, '89109', 218, 39, 95621, 36.1242, 0.630486229648936, -115.1465, -2.00968554714765),
(38103, '89110', 218, 39, 95621, 36.1719, 0.631318751702137, -115.0594, -2.00816536536916),
(38104, '89111', 218, 39, 95621, 36.0857, 0.629814277886918, -115.147, -2.00969427379391),
(38105, '89112', 218, 39, 95621, 36.1146, 0.630318678040744, -115.016, -2.0074078924738),
(38106, '89113', 218, 39, 95621, 36.0666, 0.629480919999787, -115.2554, -2.01158621070307),
(38107, '89114', 218, 39, 95621, 36.1518, 0.630967940522486, -115.154, -2.00981644684155),
(38108, '89115', 218, 39, 95621, 36.2129, 0.632034336695455, -115.0574, -2.00813045878412),
(38109, '89116', 218, 39, 95621, 36.1518, 0.630967940522486, -115.1098, -2.00904501131217),
(38110, '89117', 218, 39, 95621, 36.1317, 0.630617129342835, -115.283, -2.01206792157662),
(38111, '89118', 218, 39, 95621, 36.0511, 0.629210393965728, -115.1668, -2.01003984898581),
(38112, '89119', 218, 39, 95621, 36.0895, 0.629880600398494, -115.1383, -2.00954243014899),
(38113, '89120', 218, 39, 95621, 36.0873, 0.62984220315495, -115.0904, -2.00870641743728),
(38114, '89121', 218, 39, 95621, 36.1191, 0.630397217857084, -115.0908, -2.00871339875429),
(38115, '89122', 218, 39, 95621, 36.1193, 0.630400708515588, -115.0494, -2.00799083244396),
(38116, '89123', 218, 39, 95621, 36.0197, 0.628662360580602, -115.15, -2.00974663367147),
(38117, '89124', 218, 39, 95621, 36.2539, 0.632749921688772, -115.5267, -2.01632128896373),
(38118, '89125', 218, 39, 95621, 36.1731, 0.631339695653161, -115.1224, -2.00926492279792),
(38119, '89126', 218, 39, 95621, 36.1445, 0.63084053148709, -115.2048, -2.01070307410156),
(38120, '89127', 218, 39, 95621, 36.1854, 0.631554371151156, -115.1649, -2.01000668773002),
(38121, '89128', 218, 39, 95621, 36.1729, 0.631336204994657, -115.2931, -2.01224419983107),
(38122, '89129', 218, 39, 95621, 36.2496, 0.632674872530936, -115.2737, -2.01190560595619),
(38123, '89130', 218, 39, 95621, 36.255, 0.632769120310544, -115.2259, -2.01107133857373),
(38124, '89131', 218, 39, 95621, 36.3115, 0.633755231337921, -115.2531, -2.01154606813028),
(38125, '89132', 218, 39, 95621, 36.0858, 0.62981602321617, -115.147, -2.00969427379391),
(38126, '89133', 218, 39, 95621, 36.2064, 0.631920890294075, -115.2523, -2.01153210549626),
(38127, '89134', 218, 39, 95621, 36.215, 0.632070988609747, -115.2846, -2.01209584684465),
(38128, '89135', 218, 39, 95621, 36.1438, 0.630828314182326, -115.3615, -2.01343800503944),
(38129, '89137', 218, 39, 95621, 36.1896, 0.63162767497974, -115.3141, -2.01261071897399),
(38130, '89138', 218, 39, 95621, 36.1855, 0.631556116480408, -115.3869, -2.01388131866945),
(38131, '89139', 218, 39, 95621, 36.0401, 0.629018407748008, -115.198, -2.01058439171243),
(38132, '89141', 218, 39, 95621, 35.9901, 0.628145743122011, -115.2121, -2.01083048313696),
(38133, '89142', 218, 39, 95621, 36.1586, 0.631086622911622, -115.0326, -2.00769761712963),
(38134, '89143', 218, 39, 95621, 36.3222, 0.633941981567884, -115.283, -2.01206792157662),
(38135, '89144', 218, 39, 95621, 36.1779, 0.631423471457257, -115.3149, -2.01262468160801),
(38136, '89145', 218, 39, 95621, 36.1695, 0.631276863800089, -115.2791, -2.0119998537358),
(38137, '89146', 218, 39, 95621, 36.1419, 0.630795152926539, -115.2247, -2.01105039462271),
(38138, '89147', 218, 39, 95621, 36.1246, 0.630493210965944, -115.2783, -2.01198589110178),
(38139, '89148', 218, 39, 95621, 36.0577, 0.629325585696359, -115.3197, -2.01270845741211),
(38140, '89149', 218, 39, 95621, 36.292, 0.633414892133782, -115.2919, -2.01222325588005),
(38141, '89150', 218, 39, 95621, 36.1266, 0.630528117550983, -115.2139, -2.01086189906349),
(38142, '89151', 218, 39, 95621, 36.144, 0.63083180484083, -115.2286, -2.01111846246354),
(38143, '89152', 218, 39, 95621, 36.1706, 0.631296062421861, -115.209, -2.01077637793015),
(38144, '89153', 218, 39, 95621, 36.1591, 0.631095349557882, -115.2023, -2.01065944087026),
(38145, '89154', 218, 39, 95621, 36.0858, 0.62981602321617, -115.1471, -2.00969601912316),
(38146, '89155', 218, 39, 95621, 36.1728, 0.631334459665405, -115.1219, -2.00925619615166),
(38147, '89156', 218, 39, 95621, 36.2244, 0.632235049559434, -115.0285, -2.0076260586303),
(38148, '89159', 218, 39, 95621, 36.0724, 0.629582149096403, -115.1415, -2.00959828068505),
(38149, '89160', 218, 39, 95621, 36.1225, 0.630456559051652, -115.0918, -2.00873085204681),
(38150, '89162', 218, 39, 95621, 36.1753, 0.631378092896705, -115.1363, -2.00950752356395),
(38151, '89163', 218, 39, 52022, 36.1767, 0.631402527506233, -115.1354, -2.00949181560068),
(38152, '89164', 218, 39, 95621, 36.1291, 0.630571750782283, -115.2799, -2.01201381636981),
(38153, '89170', 218, 39, 95621, 36.0861, 0.629821259203926, -115.1473, -2.00969950978167),
(38154, '89173', 218, 39, 95621, 36.1746, 0.631365875591941, -115.136, -2.00950228757619),
(38155, '89177', 218, 39, 95621, 36.0858, 0.62981602321617, -115.1469, -2.00969252846466),
(38156, '89180', 218, 39, 95621, 36.1523, 0.630976667168746, -115.11, -2.00904850197067),
(38157, '89185', 218, 39, 95621, 36.1523, 0.630976667168746, -115.1095, -2.00903977532441),
(38158, '89191', 218, 39, 0, 36.2429, 0.632557935471053, -115.0418, -2.00785818742081),
(38159, '89193', 218, 39, 95621, 36.0861, 0.629821259203926, -115.1472, -2.00969776445241),
(38160, '89195', 218, 39, 95621, 36.2054, 0.631903437001555, -115.2233, -2.01102596001318),
(38161, '89199', 218, 39, 95621, 36.1511, 0.630955723217722, -115.1087, -2.0090258126904),
(38162, '89301', 218, 39, 54625, 39.2508, 0.68505569404179, -114.8808, -2.0050482073251),
(38163, '89310', 218, 39, 7197, 39.7358, 0.693520540913963, -117.1963, -2.04546130615503),
(38164, '89311', 218, 39, 7221, 39.0019, 0.680711569533576, -114.1623, -1.99250801664952),
(38165, '89314', 218, 39, 190136, 38.8933, 0.678816141965911, -115.6774, -2.01895150014649),
(38166, '89315', 218, 39, 54625, 39.2615, 0.685242444271754, -114.8646, -2.00476546398628),
(38167, '89316', 218, 39, 2334, 39.516, 0.689684307218079, -115.9647, -2.02396583108747),
(38168, '89317', 218, 39, 95911, 38.9071, 0.679056997402686, -115.1337, -2.0094621450034),
(38169, '89318', 218, 39, 156399, 39.3927, 0.68753231625037, -114.7867, -2.00340585249897),
(38170, '89319', 218, 39, 5588, 39.2787, 0.685542640903097, -114.9888, -2.00693316291726),
(38171, '89402', 218, 39, 134878, 39.2835, 0.685626416707192, -119.9512, -2.09354338171822),
(38172, '89403', 218, 39, 1992, 39.2725, 0.685434430489473, -119.5362, -2.08630026532245),
(38173, '89404', 218, 39, 199914, 41.4752, 0.723878797923152, -118.8916, -2.07504987296409),
(38174, '89405', 218, 39, 2294, 40.5757, 0.708179561301463, -119.3429, -2.08292654387834),
(38175, '89406', 218, 39, 75809, 39.4726, 0.688926834322714, -118.2727, -2.0642480302235),
(38176, '89407', 218, 39, 75809, 39.5821, 0.690837969853647, -118.3362, -2.06535631429851),
(38177, '89408', 218, 39, 190197, 39.5981, 0.691117222533967, -119.2319, -2.08098922840863),
(38178, '89409', 218, 39, 190221, 38.8638, 0.678301269836572, -117.9268, -2.05821093634085),
(38179, '89410', 218, 39, 54909, 38.892, 0.678793452685635, -119.7246, -2.0895884656332),
(38180, '89411', 218, 39, 9080, 39.0092, 0.680838978568972, -119.8395, -2.09159384894374),
(38181, '89412', 218, 39, 75919, 40.6517, 0.709506011532979, -119.3555, -2.08314645536409),
(38182, '89413', 218, 39, 41094, 39.081, 0.682092124971904, -119.9397, -2.09334266885424),
(38183, '89414', 218, 39, 27279, 41.0098, 0.715756035584371, -117.2972, -2.04722234337029),
(38184, '89415', 218, 39, 13124, 38.547, 0.672772066766254, -118.6485, -2.07080697755249),
(38185, '89418', 218, 39, 200006, 40.5434, 0.707615819953069, -117.9773, -2.05909232761311),
(38186, '89419', 218, 39, 182981, 40.1769, 0.70121918824451, -118.4771, -2.06781548321457),
(38187, '89420', 218, 39, 190440, 38.417, 0.670503138738662, -118.1904, -2.06281162424911),
(38188, '89421', 218, 39, 200065, 41.9902, 0.732867243570923, -117.7119, -2.05446022377831),
(38189, '89422', 218, 39, 37220, 38.3858, 0.669958596012039, -118.1061, -2.06134031168967),
(38190, '89423', 218, 39, 42112, 39.005, 0.680765674740388, -119.7378, -2.08981884909447),
(38191, '89424', 218, 39, 17283, 39.8405, 0.695347900640801, -119.3624, -2.08326688308248),
(38192, '89425', 218, 39, 200110, 41.7381, 0.728467268526645, -118.0915, -2.06108549361888),
(38193, '89426', 218, 39, 165684, 41.6029, 0.726107583377949, -117.3815, -2.04869365592972),
(38194, '89427', 218, 39, 190715, 38.9457, 0.679730694493956, -118.8178, -2.07376181997612),
(38195, '89428', 218, 39, 24871, 39.2651, 0.685305276124825, -119.6391, -2.08809620912275),
(38196, '89429', 218, 39, 14623, 39.371, 0.687153579802688, -119.2695, -2.08164547220738),
(38197, '89430', 218, 39, 343, 38.7639, 0.67655768591383, -119.3255, -2.08262285658849),
(38198, '89431', 218, 39, 25000, 39.5485, 0.690251539224977, -119.736, -2.08978743316793),
(38199, '89432', 218, 39, 25000, 39.5404, 0.690110167555566, -119.7477, -2.08999163669041),
(38200, '89433', 218, 39, 6157, 39.5948, 0.691059626668651, -119.7755, -2.09047683822247),
(38201, '89434', 218, 39, 25000, 39.5524, 0.690319607065805, -119.7168, -2.08945232995155),
(38202, '89435', 218, 39, 25000, 39.5437, 0.690167763420882, -119.7373, -2.08981012244821),
(38203, '89436', 218, 39, 25000, 39.6459, 0.69195148991642, -119.6975, -2.08911548140591),
(38204, '89438', 218, 39, 176801, 40.7928, 0.711968671107543, -117.1259, -2.04423259436163),
(38205, '89439', 218, 39, 34259, 39.5179, 0.689717468473867, -119.9835, -2.09410712306662),
(38206, '89440', 218, 39, 107183, 39.3459, 0.686715502160437, -119.6462, -2.08822012749964),
(38207, '89442', 218, 39, 6590, 39.6427, 0.691895639380356, -119.2817, -2.08185840237612),
(38208, '89444', 218, 39, 902, 38.7886, 0.676988782239073, -119.3562, -2.08315867266886),
(38209, '89445', 218, 39, 200287, 40.9803, 0.715241163455032, -117.7394, -2.05494018932261),
(38210, '89446', 218, 39, 200287, 40.9684, 0.715033469274045, -117.7253, -2.05469409789808),
(38211, '89447', 218, 39, 190946, 38.9944, 0.680580669839677, -119.1572, -2.07968546745739),
(38212, '89448', 218, 39, 190949, 39.0016, 0.68070633354582, -119.9321, -2.09321002383109),
(38213, '89449', 218, 39, 185365, 38.9741, 0.680226368001522, -119.9078, -2.09278590882286),
(38214, '89450', 218, 39, 190331, 39.2559, 0.685144705833642, -119.9535, -2.09358352429102),
(38215, '89451', 218, 39, 190331, 39.2543, 0.68511678056561, -119.9529, -2.09357305231551),
(38216, '89452', 218, 39, 190331, 39.2462, 0.684975408896199, -119.9617, -2.09372664128968),
(38217, '89460', 218, 39, 54909, 38.8917, 0.678788216697879, -119.7242, -2.0895814843162),
(38218, '89496', 218, 39, 75809, 39.5809, 0.690817025902624, -118.3366, -2.06536329561552),
(38219, '89501', 218, 39, 13196, 39.526, 0.689858840143279, -119.8127, -2.09112610070421),
(38220, '89502', 218, 39, 13196, 39.4999, 0.689403309208508, -119.7659, -2.09030928661428),
(38221, '89503', 218, 39, 13196, 39.5354, 0.690022901092966, -119.8368, -2.09154672505394),
(38222, '89504', 218, 39, 13196, 39.6821, 0.692583299105642, -119.8443, -2.09167762474784),
(38223, '89505', 218, 39, 13196, 39.5264, 0.689865821460287, -119.8036, -2.09096727574228),
(38224, '89506', 218, 39, 13196, 39.6633, 0.692255177206267, -119.8813, -2.09232339657108),
(38225, '89507', 218, 39, 13196, 39.5467, 0.690220123298442, -119.8154, -2.09117322459401),
(38226, '89509', 218, 39, 13196, 39.4775, 0.689012355456061, -119.8967, -2.09259217727589),
(38227, '89510', 218, 39, 13196, 39.7696, 0.694110462201137, -119.6173, -2.08771572734581),
(38228, '89511', 218, 39, 13196, 39.382, 0.687345566020407, -119.755, -2.09011904572581),
(38229, '89512', 218, 39, 13196, 39.5478, 0.690239321920214, -119.7972, -2.09085557467015),
(38230, '89513', 218, 39, 13196, 39.5041, 0.689476613037092, -119.8589, -2.09193244281863),
(38231, '89515', 218, 39, 13196, 39.4965, 0.68934396801394, -119.7458, -2.08995847543463),
(38232, '89520', 218, 39, 13196, 39.4933, 0.689288117477877, -119.7459, -2.08996022076388),
(38233, '89521', 218, 39, 13196, 39.3819, 0.687343820691155, -119.7543, -2.09010682842105),
(38234, '89523', 218, 39, 13196, 39.5245, 0.689832660204499, -119.8898, -2.0924717495575),
(38235, '89533', 218, 39, 13196, 39.5291, 0.689912945350091, -119.8806, -2.09231117926631),
(38236, '89555', 218, 39, 13196, 39.5297, 0.689923417325602, -119.8132, -2.09113482735047),
(38237, '89557', 218, 39, 13196, 39.5381, 0.69007002498277, -119.8172, -2.09120464052055),
(38238, '89570', 218, 39, 13196, 39.4961, 0.689336986696932, -119.7469, -2.0899776740564),
(38239, '89595', 218, 39, 13196, 39.5277, 0.689888510740563, -119.7808, -2.09056934067282),
(38240, '89599', 218, 39, 13196, 39.5298, 0.689925162654854, -119.8133, -2.09113657267972),
(38241, '89701', 218, 39, 58901, 39.152, 0.68333130874082, -119.7473, -2.08998465537341),
(38242, '89702', 218, 39, 58901, 39.0708, 0.681914101388201, -119.7936, -2.09079274281708),
(38243, '89703', 218, 39, 58901, 39.17, 0.683645468006179, -119.7804, -2.09056235935582),
(38244, '89704', 218, 39, 0, 39.2837, 0.685629907365697, -119.7919, -2.0907630722198),
(38245, '89705', 218, 39, 58901, 39.0908, 0.682263167238599, -119.7861, -2.09066184312318),
(38246, '89706', 218, 39, 58901, 39.187, 0.683942173979018, -119.7471, -2.0899811647149),
(38247, '89711', 218, 39, 58901, 39.1635, 0.683532021604799, -119.7662, -2.09031452260203),
(38248, '89712', 218, 39, 58901, 39.1635, 0.683532021604799, -119.7658, -2.09030754128502),
(38249, '89713', 218, 39, 58901, 39.1636, 0.683533766934051, -119.7664, -2.09031801326054),
(38250, '89714', 218, 39, 58901, 39.1352, 0.683038093426485, -119.6661, -2.08856744802079),
(38251, '89721', 218, 39, 58901, 38.9785, 0.68030316248861, -119.7281, -2.08964955215702),
(38252, '89801', 218, 39, 2260, 40.8003, 0.712099570801442, -115.7069, -2.01946637227583),
(38253, '89802', 218, 39, 2260, 40.8587, 0.713118843084607, -115.7151, -2.01960948927449),
(38254, '89803', 218, 39, 2260, 40.8593, 0.713129315060119, -115.7149, -2.01960599861599),
(38255, '89815', 218, 39, 6001, 40.5528, 0.707779880902756, -115.5774, -2.01720617089449),
(38256, '89820', 218, 39, 199825, 40.6196, 0.708945760843089, -116.9379, -2.04095137536788),
(38257, '89821', 218, 39, 199900, 40.5325, 0.707425579064602, -116.3194, -2.03015651394429),
(38258, '89822', 218, 39, 199864, 40.7152, 0.710614295607995, -116.1058, -2.02642849066203),
(38259, '89823', 218, 39, 199912, 41.4507, 0.723451192256414, -115.4611, -2.01517635297442),
(38260, '89824', 218, 39, 603, 40.9509, 0.714728036654946, -115.4522, -2.015021018671),
(38261, '89825', 218, 39, 200018, 41.7008, 0.727816260715651, -115.194, -2.01051457854235),
(38262, '89826', 218, 39, 200022, 41.8517, 0.730449962556911, -115.4165, -2.01439793612804),
(38263, '89828', 218, 39, 116353, 40.7198, 0.710694580753587, -115.5623, -2.01694262617744),
(38264, '89830', 218, 39, 125464, 41.262, 0.7201577559579, -114.192, -1.99302637943736),
(38265, '89831', 218, 39, 23241, 41.5723, 0.725573512626839, -116.2932, -2.02969923768027),
(38266, '89832', 218, 39, 195427, 41.7482, 0.728643546781097, -116.0112, -2.02477740918965),
(38267, '89833', 218, 39, 200177, 40.3044, 0.703444483040803, -115.2831, -2.01206966690587),
(38268, '89834', 218, 39, 52241, 41.1174, 0.717634009859517, -116.6448, -2.03583581533028),
(38269, '89835', 218, 39, 34376, 41.1566, 0.718318178926298, -114.9489, -2.00623677654571),
(38270, '89883', 218, 39, 200277, 40.6911, 0.710193671258265, -114.1448, -1.99220258403042),
(38271, '90001', 218, 6, 36, 33.9737, 0.592952924084798, -118.2448, -2.06376108336219),
(38272, '90002', 218, 6, 36, 33.9495, 0.592530554405815, -118.2437, -2.06374188474042),
(38273, '90003', 218, 6, 36, 33.9641, 0.592785372476606, -118.2739, -2.06426897417452),
(38274, '90004', 218, 6, 36, 34.0768, 0.594752358543604, -118.3095, -2.06489031138823),
(38275, '90005', 218, 6, 36, 34.0595, 0.594450416583009, -118.3127, -2.0649461619243),
(38276, '90006', 218, 6, 36, 34.0477, 0.594244467731273, -118.2908, -2.06456393481811),
(38277, '90007', 218, 6, 36, 34.028, 0.59390063786863, -118.2808, -2.06438940189291),
(38278, '90008', 218, 6, 36, 34.0112, 0.593607422554295, -118.3426, -2.06546801537064),
(38279, '90009', 218, 6, 36, 33.9451, 0.592453759918727, -118.3836, -2.06618360036396),
(38280, '90010', 218, 6, 36, 34.0629, 0.594509757777576, -118.3141, -2.06497059653382),
(38281, '90011', 218, 6, 36, 34.0086, 0.593562043993744, -118.258, -2.06399146682345),
(38282, '90012', 218, 6, 36, 34.0607, 0.594471360534033, -118.2394, -2.06366683558258),
(38283, '90013', 218, 6, 36, 34.0448, 0.594193853182966, -118.2413, -2.06369999683837),
(38284, '90014', 218, 6, 36, 34.0432, 0.594165927914934, -118.2514, -2.06387627509282),
(38285, '90015', 218, 6, 36, 34.0392, 0.594096114744854, -118.2651, -2.06411538520035),
(38286, '90016', 218, 6, 36, 34.0296, 0.593928563136662, -118.3543, -2.06567221889312),
(38287, '90017', 218, 6, 36, 34.0535, 0.594345696827889, -118.2637, -2.06409095059082),
(38288, '90018', 218, 6, 36, 34.0291, 0.593919836490402, -118.3172, -2.06502470174063),
(38289, '90019', 218, 6, 36, 34.0486, 0.594260175694541, -118.3407, -2.06543485411485),
(38290, '90020', 218, 6, 36, 34.0665, 0.594572589630648, -118.3097, -2.06489380204674),
(38291, '90021', 218, 6, 36, 34.0288, 0.593914600502646, -118.2392, -2.06366334492408),
(38292, '90022', 218, 6, 36, 34.0218, 0.593792427455007, -118.1512, -2.06212745518232),
(38293, '90023', 218, 6, 36, 34.0226, 0.593806390089023, -118.2021, -2.06301582777159),
(38294, '90024', 218, 6, 36, 34.0625, 0.594502776460568, -118.4361, -2.06709989822126),
(38295, '90025', 218, 6, 36, 34.0437, 0.594174654561194, -118.4499, -2.06734075365803),
(38296, '90026', 218, 6, 36, 34.0786, 0.59478377447014, -118.2616, -2.06405429867653),
(38297, '90027', 218, 6, 36, 34.1075, 0.595288174623966, -118.2885, -2.06452379224531),
(38298, '90028', 218, 6, 36, 34.1016, 0.595185200198098, -118.3277, -2.06520796131209),
(38299, '90029', 218, 6, 36, 34.0895, 0.594974015358607, -118.2936, -2.06461280403716),
(38300, '90030', 218, 6, 36, 34.0636, 0.594521975082341, -118.2398, -2.06367381689959),
(38301, '90031', 218, 6, 36, 34.0791, 0.594792501116399, -118.214, -2.06322352195258),
(38302, '90032', 218, 6, 36, 34.0807, 0.594820426384431, -118.1769, -2.06257600480009),
(38303, '90033', 218, 6, 36, 34.0497, 0.594279374316313, -118.2104, -2.06316069009951),
(38304, '90034', 218, 6, 36, 34.0313, 0.593958233733946, -118.3977, -2.06642969178849),
(38305, '90035', 218, 6, 36, 34.0519, 0.594317771559857, -118.3857, -2.06622025227825),
(38306, '90036', 218, 6, 36, 34.0691, 0.5946179681912, -118.3503, -2.06560240572305),
(38307, '90037', 218, 6, 36, 34.003, 0.593464305555632, -118.2856, -2.064473177697),
(38308, '90038', 218, 6, 36, 34.089, 0.594965288712347, -118.3249, -2.06515909209304),
(38309, '90039', 218, 6, 36, 34.1087, 0.59530911857499, -118.2601, -2.06402811873775),
(38310, '90040', 218, 6, 36, 33.9963, 0.593347368495748, -118.1527, -2.0621536351211),
(38311, '90041', 218, 6, 36, 34.1358, 0.59578210280228, -118.207, -2.06310134890494),
(38312, '90042', 218, 6, 36, 34.1177, 0.595466198207669, -118.1918, -2.06283605885863),
(38313, '90043', 218, 6, 36, 33.99, 0.593237412752873, -118.3385, -2.06539645687131),
(38314, '90044', 218, 6, 36, 33.9536, 0.592602112905147, -118.2929, -2.0646005867324),
(38315, '90045', 218, 6, 36, 33.9599, 0.592712068648022, -118.3949, -2.06638082256943),
(38316, '90046', 218, 6, 36, 34.1106, 0.595342279830778, -118.3643, -2.06584675181832),
(38317, '90047', 218, 6, 36, 33.9568, 0.59265796344121, -118.3095, -2.06489031138823),
(38318, '90048', 218, 6, 36, 34.074, 0.594703489324548, -118.3744, -2.06602303007278),
(38319, '90049', 218, 6, 36, 34.0799, 0.594806463750416, -118.488, -2.06800572410304),
(38320, '90050', 218, 6, 36, 34.1215, 0.595532520719245, -118.2052, -2.0630699329784),
(38321, '90051', 218, 6, 36, 34.0639, 0.594527211070096, -118.24, -2.0636773075581),
(38322, '90052', 218, 6, 36, 33.9745, 0.592966886718813, -118.2506, -2.06386231245881),
(38323, '90053', 218, 6, 36, 34.0531, 0.594338715510881, -118.2387, -2.06365461827782),
(38324, '90054', 218, 6, 36, 34.0619, 0.594492304485057, -118.2357, -2.06360225840026),
(38325, '90055', 218, 6, 36, 34.0458, 0.594211306475485, -118.2586, -2.06400193879897),
(38326, '90056', 218, 6, 36, 33.9927, 0.593284536642676, -118.3713, -2.06596892486596),
(38327, '90057', 218, 6, 36, 34.0623, 0.594499285802065, -118.2751, -2.06428991812555),
(38328, '90058', 218, 6, 36, 34.0011, 0.593431144299844, -118.2213, -2.06335093098797),
(38329, '90059', 218, 6, 36, 33.9272, 0.59214134598262, -118.244, -2.06374712072818),
(38330, '90060', 218, 6, 36, 33.9981, 0.593378784422284, -118.4221, -2.06685555212598),
(38331, '90061', 218, 6, 36, 33.9223, 0.592055824849272, -118.274, -2.06427071950377),
(38332, '90062', 218, 6, 36, 34.0036, 0.593474777531144, -118.309, -2.06488158474197),
(38333, '90063', 218, 6, 36, 34.0413, 0.594132766659146, -118.1859, -2.06273308443277),
(38334, '90064', 218, 6, 36, 34.0361, 0.594042009538042, -118.4224, -2.06686078811373),
(38335, '90065', 218, 6, 36, 34.1047, 0.59523930540491, -118.2276, -2.06346088673085),
(38336, '90066', 218, 6, 36, 33.997, 0.593359585800512, -118.431, -2.0670108864294),
(38337, '90067', 218, 6, 36, 34.0588, 0.594438199278245, -118.4146, -2.06672465243208),
(38338, '90068', 218, 6, 36, 34.1241, 0.595577899279797, -118.3381, -2.0653894755543),
(38339, '90069', 218, 6, 186077, 34.0926, 0.595028120565419, -118.3811, -2.06613996713266),
(38340, '90070', 218, 6, 36, 34.0608, 0.594473105863285, -118.3105, -2.06490776468075),
(38341, '90071', 218, 6, 36, 34.0521, 0.594321262218361, -118.254, -2.06392165365337),
(38342, '90072', 218, 6, 36, 34.0961, 0.595089207089239, -118.3082, -2.06486762210796),
(38343, '90073', 218, 6, 36, 34.0529, 0.594335224852377, -118.4564, -2.06745420005941),
(38344, '90074', 218, 6, 36, 34.0539, 0.594352678144897, -118.2657, -2.06412585717586),
(38345, '90075', 218, 6, 36, 34.0601, 0.594460888558521, -118.3108, -2.06491300066851),
(38346, '90076', 218, 6, 36, 34.0608, 0.594473105863285, -118.3105, -2.06490776468075),
(38347, '90077', 218, 6, 36, 34.1023, 0.595197417502862, -118.4497, -2.06733726299953),
(38348, '90078', 218, 6, 36, 34.0997, 0.59515203894231, -118.3277, -2.06520796131209),
(38349, '90079', 218, 6, 36, 34.0414, 0.594134511988398, -118.2542, -2.06392514431188),
(38350, '90080', 218, 6, 36, 33.9546, 0.592619566197667, -118.3985, -2.06644365442251),
(38351, '90081', 218, 6, 36, 34.0538, 0.594350932815645, -118.2655, -2.06412236651735),
(38352, '90082', 218, 6, 36, 34.0004, 0.59341892699508, -118.277, -2.06432307938133),
(38353, '90083', 218, 6, 36, 33.954, 0.592609094222155, -118.3994, -2.06645936238577),
(38354, '90084', 218, 6, 36, 34.0537, 0.594349187486393, -118.2655, -2.06412236651735),
(38355, '90086', 218, 6, 36, 34.0633, 0.594516739094584, -118.2391, -2.06366159959483),
(38356, '90087', 218, 6, 36, 34.0645, 0.594537683045608, -118.2391, -2.06366159959483),
(38357, '90088', 218, 6, 36, 34.0539, 0.594352678144897, -118.2648, -2.06411014921259),
(38358, '90089', 218, 6, 36, 34.019, 0.593743558235951, -118.2811, -2.06439463788066),
(38359, '90091', 218, 6, 36, 33.9926, 0.593282791313425, -118.15, -2.0621065112313),
(38360, '90093', 218, 6, 36, 34.0966, 0.595097933735499, -118.335, -2.06533537034749),
(38361, '90094', 218, 6, 36, 33.9761, 0.592994811986845, -118.4267, -2.06693583727157),
(38362, '90095', 218, 6, 36, 34.0705, 0.594642402800728, -118.4476, -2.06730061108524),
(38363, '90096', 218, 6, 36, 33.9686, 0.592863912292946, -118.1712, -2.06247652103272),
(38364, '90097', 218, 6, 36, 34.0399, 0.594108332049618, -118.2654, -2.0641206211881),
(38365, '90099', 218, 6, 36, 34.0632, 0.594514993765332, -118.2383, -2.06364763696081),
(38366, '90101', 218, 6, 36, 33.9949, 0.59332293388622, -118.1658, -2.06238227325312),
(38367, '90102', 218, 6, 36, 34.0186, 0.593736576918943, -118.2, -2.0629791758573),
(38368, '90103', 218, 6, 36, 33.9951, 0.593326424544724, -118.1663, -2.06239099989938),
(38369, '90174', 218, 6, 36, 34.0531, 0.594338715510881, -118.2509, -2.06386754844656),
(38370, '90185', 218, 6, 36, 33.976, 0.592993066657593, -118.2563, -2.06396179622617),
(38371, '90189', 218, 6, 36, 34.0517, 0.594314280901353, -118.2424, -2.06371919546014),
(38372, '90201', 218, 6, 219, 33.9706, 0.592898818877986, -118.1713, -2.06247826636198),
(38373, '90202', 218, 6, 180010, 33.9677, 0.592848204329678, -118.1527, -2.0621536351211),
(38374, '90209', 218, 6, 15219, 34.0727, 0.594680800044272, -118.3923, -2.06633544400888),
(38375, '90210', 218, 6, 15219, 34.0889, 0.594963543383095, -118.4109, -2.06666007524975),
(38376, '90211', 218, 6, 15219, 34.0652, 0.594549900350372, -118.38, -2.06612076851089),
(38377, '90212', 218, 6, 15219, 34.0616, 0.5944870684973, -118.4008, -2.0664837969953),
(38378, '90213', 218, 6, 15219, 34.0541, 0.594356168803401, -118.4007, -2.06648205166605),
(38379, '90220', 218, 6, 1738, 33.8818, 0.591348966502215, -118.2379, -2.0636406556438),
(38380, '90221', 218, 6, 1738, 33.8944, 0.591568877987966, -118.2024, -2.06302106375935),
(38381, '90222', 218, 6, 1738, 33.9107, 0.591853366656041, -118.2343, -2.06357782379073),
(38382, '90223', 218, 6, 1738, 33.896, 0.591596803255998, -118.2237, -2.06339281889002),
(38383, '90224', 218, 6, 1738, 33.8732, 0.591198868186543, -118.2652, -2.0641171305296),
(38384, '90230', 218, 6, 180985, 33.9951, 0.593326424544724, -118.3973, -2.06642271047148),
(38385, '90231', 218, 6, 180985, 33.9977, 0.593371803105276, -118.3944, -2.06637209592317),
(38386, '90232', 218, 6, 180985, 34.0174, 0.593715632967919, -118.3931, -2.0663494066429),
(38387, '90233', 218, 6, 180985, 33.9841, 0.593134438327005, -118.3884, -2.06626737616805),
(38388, '90239', 218, 6, 78140, 33.9317, 0.59221988579896, -118.1143, -2.06148342868834),
(38389, '90240', 218, 6, 78140, 33.9566, 0.592654472782707, -118.1172, -2.06153404323665),
(38390, '90241', 218, 6, 78140, 33.9408, 0.592378710760891, -118.1292, -2.06174348274689),
(38391, '90242', 218, 6, 78140, 33.925, 0.592102948739076, -118.1457, -2.06203146207346),
(38392, '90245', 218, 6, 181383, 33.9227, 0.59206280616628, -118.4054, -2.06656408214089),
(38393, '90247', 218, 6, 119746, 33.8894, 0.591481611525366, -118.2939, -2.06461804002492),
(38394, '90248', 218, 6, 119746, 33.8814, 0.591341985185207, -118.2819, -2.06440860051468),
(38395, '90249', 218, 6, 119746, 33.8992, 0.591652653792062, -118.3182, -2.06504215503315),
(38396, '90250', 218, 6, 13124, 33.9136, 0.591903981204349, -118.3526, -2.06564254829584),
(38397, '90251', 218, 6, 13124, 33.9176, 0.591973794374429, -118.36, -2.06577170266049),
(38398, '90254', 218, 6, 182095, 33.8655, 0.59106447783414, -118.3958, -2.0663965305327),
(38399, '90255', 218, 6, 22108, 33.9773, 0.593015755937869, -118.2099, -2.06315196345325),
(38400, '90260', 218, 6, 14097, 33.8884, 0.591464158232846, -118.3492, -2.06558320710127),
(38401, '90261', 218, 6, 14097, 33.8893, 0.591479866196114, -118.352, -2.06563207632033),
(38402, '90262', 218, 6, 49133, 33.9244, 0.592092476763564, -118.2018, -2.06301059178383),
(38403, '90263', 218, 6, 22835, 34.0096, 0.593579497286263, -118.8093, -2.0736134669897),
(38404, '90264', 218, 6, 22835, 34.0438, 0.594176399890446, -118.7728, -2.07297642181272),
(38405, '90265', 218, 6, 22835, 34.0447, 0.594192107853713, -118.7547, -2.07266051721811),
(38406, '90266', 218, 6, 17010, 33.89, 0.591492083500878, -118.4016, -2.06649775962932),
(38407, '90267', 218, 6, 17010, 33.8763, 0.591252973393355, -118.3955, -2.06639129454495),
(38408, '90270', 218, 6, 30467, 33.9892, 0.593223450118857, -118.1867, -2.06274704706678),
(38409, '90272', 218, 6, 183940, 34.05, 0.594284610304069, -118.5357, -2.06883824615624),
(38410, '90274', 218, 6, 0, 33.7706, 0.589408160373997, -118.3712, -2.06596717953671),
(38411, '90275', 218, 6, 184404, 33.744, 0.588943902792967, -118.3655, -2.06586769576935),
(38412, '90277', 218, 6, 184460, 33.8319, 0.590478047205469, -118.3787, -2.06609807923061),
(38413, '90278', 218, 6, 184460, 33.8701, 0.591144762979731, -118.3731, -2.0660003407925),
(38414, '90280', 218, 6, 24961, 33.9419, 0.592397909382663, -118.1933, -2.06286223879741),
(38415, '90290', 218, 6, 185691, 34.1029, 0.595207889478374, -118.6052, -2.07005124998638),
(38416, '90291', 218, 6, 12543, 33.9931, 0.593291517959684, -118.4645, -2.06759557172882),
(38417, '90292', 218, 6, 183106, 33.9775, 0.593019246596373, -118.4543, -2.06741754814512),
(38418, '90293', 218, 6, 184173, 33.9578, 0.59267541673373, -118.4411, -2.06718716468386),
(38419, '90294', 218, 6, 12543, 33.9882, 0.593205996826337, -118.4701, -2.06769331016693),
(38420, '90295', 218, 6, 183106, 33.9786, 0.593038445218145, -118.4384, -2.06714004079405),
(38421, '90296', 218, 6, 184173, 33.9593, 0.59270159667251, -118.447, -2.06729013910972),
(38422, '90301', 218, 6, 41483, 33.9555, 0.592635274160935, -118.3499, -2.06559542440604),
(38423, '90302', 218, 6, 41483, 33.975, 0.592975613365074, -118.3543, -2.06567221889312),
(38424, '90303', 218, 6, 41483, 33.9342, 0.59226351903026, -118.3282, -2.06521668795835),
(38425, '90304', 218, 6, 41483, 33.9369, 0.592310642920064, -118.3559, -2.06570014416116),
(38426, '90305', 218, 6, 41483, 33.9605, 0.592722540623534, -118.3302, -2.06525159454339),
(38427, '90306', 218, 6, 41483, 33.9599, 0.592712068648022, -118.3514, -2.06562160434482),
(38428, '90307', 218, 6, 41483, 33.955, 0.592626547514675, -118.3726, -2.06599161414624),
(38429, '90308', 218, 6, 41483, 33.9591, 0.592698106014006, -118.3516, -2.06562509500332),
(38430, '90309', 218, 6, 41483, 33.9729, 0.592938961450782, -118.3569, -2.06571759745368),
(38431, '90310', 218, 6, 41483, 33.9305, 0.592198941847936, -118.3219, -2.06510673221548),
(38432, '90311', 218, 6, 41483, 33.9565, 0.592652727453454, -118.3593, -2.06575948535572),
(38433, '90312', 218, 6, 41483, 33.962, 0.592748720562314, -118.3518, -2.06562858566183),
(38434, '90313', 218, 6, 41483, 33.9589, 0.592694615355502, -118.3515, -2.06562334967407),
(38435, '90397', 218, 6, 41483, 33.9746, 0.592968632048065, -118.4247, -2.06690093068653),
(38436, '90398', 218, 6, 41483, 33.9563, 0.592649236794951, -118.3436, -2.06548546866316),
(38437, '90401', 218, 6, 97864, 34.015, 0.593673745065871, -118.4917, -2.06807030128536),
(38438, '90402', 218, 6, 97864, 34.0361, 0.594042009538042, -118.502, -2.06825007019832),
(38439, '90403', 218, 6, 97864, 34.0315, 0.59396172439245, -118.4882, -2.06800921476155),
(38440, '90404', 218, 6, 97864, 34.0263, 0.593870967271347, -118.4729, -2.06774217938599),
(38441, '90405', 218, 6, 97864, 34.0091, 0.593570770640004, -118.4687, -2.06766887555741),
(38442, '90406', 218, 6, 97864, 34.0203, 0.593766247516227, -118.4966, -2.06815582241871),
(38443, '90407', 218, 6, 97864, 34.0153, 0.593678981053627, -118.4928, -2.06808949990714),
(38444, '90408', 218, 6, 97864, 34.0255, 0.593857004637331, -118.4886, -2.06801619607855),
(38445, '90409', 218, 6, 97864, 34.0006, 0.593422417653584, -118.4821, -2.06790274967717),
(38446, '90410', 218, 6, 97864, 34.0126, 0.593631857163823, -118.4693, -2.06767934753292),
(38447, '90411', 218, 6, 97864, 34.0118, 0.593617894529807, -118.4692, -2.06767760220367),
(38448, '90501', 218, 6, 168004, 33.8267, 0.590387290084366, -118.3146, -2.06497932318008),
(38449, '90502', 218, 6, 168004, 33.8369, 0.590565313668069, -118.2929, -2.0646005867324),
(38450, '90503', 218, 6, 168004, 33.8415, 0.590645598813661, -118.3574, -2.06572632409994),
(38451, '90504', 218, 6, 168004, 33.8705, 0.591151744296739, -118.3276, -2.06520621598284),
(38452, '90505', 218, 6, 168004, 33.8105, 0.590104546745543, -118.3494, -2.06558669775978),
(38453, '90506', 218, 6, 168004, 33.8848, 0.591401326379775, -118.3294, -2.06523763190938),
(38454, '90507', 218, 6, 168004, 33.8343, 0.590519935107517, -118.3154, -2.0649932858141),
(38455, '90508', 218, 6, 168004, 33.8342, 0.590518189778266, -118.3158, -2.06500026713111),
(38456, '90509', 218, 6, 168004, 33.8444, 0.590696213361969, -118.327, -2.06519574400733),
(38457, '90510', 218, 6, 168004, 33.829, 0.590427432657162, -118.3285, -2.06522192394611),
(38458, '90601', 218, 6, 18607, 34.0039, 0.5934800135189, -118.0358, -2.06011334522552),
(38459, '90602', 218, 6, 18607, 33.972, 0.592923253487514, -118.0326, -2.06005749468946),
(38460, '90603', 218, 6, 18607, 33.9436, 0.592427579979947, -117.9912, -2.05933492837913),
(38461, '90604', 218, 6, 18607, 33.9329, 0.592240829749984, -118.0209, -2.05985329116698),
(38462, '90605', 218, 6, 18607, 33.9556, 0.592637019490187, -118.0261, -2.05994404828808),
(38463, '90606', 218, 6, 18607, 33.9775, 0.593019246596373, -118.0653, -2.06062821735486),
(38464, '90607', 218, 6, 18607, 33.9602, 0.592717304635778, -118.0253, -2.05993008565406),
(38465, '90608', 218, 6, 18607, 33.9785, 0.593036699888893, -118.0289, -2.05999291750714),
(38466, '90609', 218, 6, 18607, 33.979, 0.593045426535153, -118.0317, -2.06004178672619),
(38467, '90610', 218, 6, 18607, 33.9686, 0.592863912292946, -118.0703, -2.06071548381746),
(38468, '90612', 218, 6, 18607, 33.9663, 0.59282376972015, -118.0221, -2.059874235118),
(38469, '90620', 218, 6, 173352, 33.8426, 0.590664797435433, -118.0072, -2.05961418105945),
(38470, '90621', 218, 6, 173352, 33.8762, 0.591251228064103, -117.9915, -2.05934016436689),
(38471, '90622', 218, 6, 173352, 33.846, 0.590724138630001, -118.004, -2.05955833052339),
(38472, '90623', 218, 6, 178490, 33.8478, 0.590755554556537, -118.0412, -2.06020759300513),
(38473, '90624', 218, 6, 173352, 33.8578, 0.590930087481736, -118.0028, -2.05953738657236),
(38474, '90630', 218, 6, 1938, 33.8149, 0.590181341232631, -118.0366, -2.06012730785954),
(38475, '90631', 218, 6, 182547, 33.9309, 0.592205923164944, -117.9501, -2.05861759805656),
(38476, '90632', 218, 6, 182547, 33.9167, 0.591958086411161, -117.9526, -2.05866123128786),
(38477, '90633', 218, 6, 182547, 33.9321, 0.592226867115968, -117.9449, -2.05852684093546),
(38478, '90637', 218, 6, 182565, 33.8954, 0.591586331280486, -118.0024, -2.05953040525536),
(38479, '90638', 218, 6, 182565, 33.9062, 0.591774826839701, -118.0071, -2.0596124357302),
(38480, '90639', 218, 6, 182565, 33.9068, 0.591785298815213, -118.0174, -2.05979220464316),
(38481, '90640', 218, 6, 104350, 34.0157, 0.593685962370635, -118.111, -2.06142583282302),
(38482, '90650', 218, 6, 17325, 33.9072, 0.591792280132221, -118.081, -2.06090223404742),
(38483, '90651', 218, 6, 17325, 33.9046, 0.59174690157167, -118.077, -2.06083242087734),
(38484, '90652', 218, 6, 17325, 33.9189, 0.591996483654705, -118.0716, -2.06073817309774),
(38485, '90659', 218, 6, 17325, 33.9069, 0.591787044144465, -118.0821, -2.0609214326692),
(38486, '90660', 218, 6, 184095, 33.988, 0.593202506167833, -118.087, -2.06100695380254),
(38487, '90661', 218, 6, 184095, 34.0014, 0.5934363802876, -118.0825, -2.0609284139862),
(38488, '90662', 218, 6, 184095, 33.9689, 0.592869148280702, -118.0985, -2.06120766666652),
(38489, '90665', 218, 6, 184095, 33.9882, 0.593205996826337, -118.0912, -2.06108025763113),
(38490, '90670', 218, 6, 184937, 33.9357, 0.59228969896904, -118.0681, -2.06067708657392),
(38491, '90671', 218, 6, 184937, 33.9339, 0.592258283042504, -118.0616, -2.06056364017254),
(38492, '90680', 218, 6, 6052, 33.8003, 0.589926523161839, -117.997, -2.05943615747575),
(38493, '90701', 218, 6, 58490, 33.8674, 0.591097639089928, -118.0816, -2.06091270602294),
(38494, '90702', 218, 6, 58490, 33.866, 0.5910732044804, -118.0834, -2.06094412194947),
(38495, '90703', 218, 6, 180640, 33.8606, 0.590978956700792, -118.0635, -2.06059680142833),
(38496, '90704', 218, 6, 13310, 33.3418, 0.581924188541445, -118.3282, -2.06521668795835),
(38497, '90706', 218, 6, 53413, 33.89, 0.591492083500878, -118.1259, -2.06168588688157),
(38498, '90707', 218, 6, 53413, 33.8821, 0.591354202489971, -118.1231, -2.06163701766251),
(38499, '90710', 218, 6, 182014, 33.7983, 0.589891616576799, -118.2992, -2.06471054247528),
(38500, '90711', 218, 6, 3637, 33.8494, 0.590783479824569, -118.1471, -2.06205589668299),
(38501, '90712', 218, 6, 3637, 33.8503, 0.590799187787836, -118.1463, -2.06204193404898),
(38502, '90713', 218, 6, 3637, 33.8489, 0.590774753178309, -118.1085, -2.06138219959172),
(38503, '90714', 218, 6, 3637, 33.8522, 0.590832349043624, -118.1346, -2.06183773052649),
(38504, '90715', 218, 6, 3637, 33.841, 0.590636872167401, -118.0789, -2.06086558213313),
(38505, '90716', 218, 6, 182052, 33.8291, 0.590429177986414, -118.0718, -2.06074166375624),
(38506, '90717', 218, 6, 182889, 33.7945, 0.589825294065224, -118.3163, -2.06500899377737),
(38507, '90720', 218, 6, 182918, 33.7955, 0.589842747357744, -118.0682, -2.06067883190317),
(38508, '90721', 218, 6, 182918, 33.8036, 0.589984119027155, -118.0698, -2.0607067571712),
(38509, '90723', 218, 6, 4860, 33.8985, 0.591640436487298, -118.1606, -2.06229151613201),
(38510, '90731', 218, 6, 97807, 33.7355, 0.588795549806547, -118.2898, -2.06454648152559),
(38511, '90732', 218, 6, 97807, 33.7642, 0.589296459301869, -118.3066, -2.06483969683992),
(38512, '90733', 218, 6, 97807, 33.7066, 0.588291149652721, -118.2918, -2.06458138811063),
(38513, '90734', 218, 6, 97807, 33.7554, 0.589142870327694, -118.3081, -2.0648658767787),
(38514, '90740', 218, 6, 185027, 33.7611, 0.589242354095058, -118.0808, -2.06089874338892),
(38515, '90742', 218, 6, 18241, 33.717, 0.588472663894928, -118.0707, -2.06072246513447),
(38516, '90743', 218, 6, 18252, 33.7265, 0.588638470173868, -118.0822, -2.06092317799845),
(38517, '90744', 218, 6, 14869, 33.7908, 0.5897607168829, -118.2529, -2.0639024550316),
(38518, '90745', 218, 6, 572, 33.8227, 0.590317476914286, -118.264, -2.06409618657857),
(38519, '90746', 218, 6, 572, 33.8598, 0.590964994066776, -118.2547, -2.06393387095814),
(38520, '90747', 218, 6, 572, 33.867, 0.59109065777292, -118.2542, -2.06392514431188),
(38521, '90748', 218, 6, 14869, 33.7849, 0.589657742457032, -118.2616, -2.06405429867653),
(38522, '90749', 218, 6, 572, 33.8216, 0.590298278292514, -118.2634, -2.06408571460306),
(38523, '90755', 218, 6, 28613, 33.7774, 0.589526842763133, -118.1474, -2.06206113267075),
(38524, '90801', 218, 6, 49041, 33.7759, 0.589500662824353, -118.1859, -2.06273308443277),
(38525, '90802', 218, 6, 49041, 33.7698, 0.589394197739981, -118.1922, -2.06284304017564),
(38526, '90803', 218, 6, 49041, 33.761, 0.589240608765806, -118.1284, -2.06172952011287),
(38527, '90804', 218, 6, 49041, 33.777, 0.589519861446125, -118.148, -2.06207160464626),
(38528, '90805', 218, 6, 49041, 33.8651, 0.591057496517132, -118.1825, -2.0626737432382),
(38529, '90806', 218, 6, 49041, 33.8019, 0.589954448429871, -118.1813, -2.06265279928717),
(38530, '90807', 218, 6, 49041, 33.8289, 0.59042568732791, -118.1827, -2.0626772338967),
(38531, '90808', 218, 6, 49041, 33.8231, 0.590324458231294, -118.104, -2.06130365977538),
(38532, '90809', 218, 6, 49041, 33.7612, 0.58924409942431, -118.1212, -2.06160385640673),
(38533, '90810', 218, 6, 49041, 33.8152, 0.590186577220386, -118.2159, -2.06325668320836),
(38534, '90813', 218, 6, 49041, 33.7811, 0.589591419945457, -118.1937, -2.06286922011442),
(38535, '90814', 218, 6, 49041, 33.7718, 0.589429104325021, -118.1513, -2.06212920051158),
(38536, '90815', 218, 6, 49041, 33.7947, 0.589828784723728, -118.1169, -2.06152880724889),
(38537, '90822', 218, 6, 49041, 33.8285, 0.590418706010902, -118.2387, -2.06365461827782),
(38538, '90831', 218, 6, 49041, 33.768, 0.589362781813445, -118.202, -2.06301408244234),
(38539, '90832', 218, 6, 49041, 33.7682, 0.589366272471949, -118.1986, -2.06295474124777),
(38540, '90833', 218, 6, 49041, 33.7686, 0.589373253788957, -118.2014, -2.06300361046683),
(38541, '90834', 218, 6, 49041, 33.768, 0.589362781813445, -118.2019, -2.06301233711309),
(38542, '90835', 218, 6, 49041, 33.7683, 0.589368017801201, -118.2011, -2.06299837447907),
(38543, '90840', 218, 6, 49041, 33.7801, 0.589573966652936, -118.1197, -2.06157767646795),
(38544, '90842', 218, 6, 49041, 33.8193, 0.590258135719718, -118.1698, -2.0624520864232),
(38545, '90844', 218, 6, 49041, 33.775, 0.589484954861085, -118.1927, -2.0628517668219),
(38546, '90845', 218, 6, 49041, 33.771, 0.589415141691005, -118.1899, -2.06280289760285),
(38547, '90846', 218, 6, 49041, 33.8232, 0.590326203560546, -118.1195, -2.06157418580944),
(38548, '90847', 218, 6, 49041, 33.8349, 0.590530407083029, -118.1895, -2.06279591628584),
(38549, '90848', 218, 6, 49041, 33.8304, 0.59045186726669, -118.1834, -2.06268945120147),
(38550, '90853', 218, 6, 49041, 33.7586, 0.589198720863758, -118.1302, -2.06176093603941),
(38551, '90888', 218, 6, 49041, 33.8043, 0.589996336331919, -118.1825, -2.0626737432382),
(38552, '90899', 218, 6, 49041, 33.7666, 0.589338347203917, -118.1881, -2.06277148167631),
(38553, '91001', 218, 6, 179716, 34.1922, 0.596766468500405, -118.1382, -2.06190056237957),
(38554, '91003', 218, 6, 179716, 34.1853, 0.596646040782018, -118.1304, -2.06176442669791),
(38555, '91006', 218, 6, 7137, 34.1377, 0.595815264058068, -118.0252, -2.05992834032481),
(38556, '91007', 218, 6, 7137, 34.1271, 0.595630259157357, -118.0498, -2.0603576913208),
(38557, '91009', 218, 6, 181211, 34.1389, 0.595836208009092, -117.9654, -2.05888463343212),
(38558, '91010', 218, 6, 181211, 34.1378, 0.59581700938732, -117.9639, -2.05885845349334),
(38559, '91011', 218, 6, 182532, 34.2068, 0.597021286571196, -118.1977, -2.0629390332845),
(38560, '91012', 218, 6, 182532, 34.2006, 0.596913076157573, -118.1908, -2.06281860556611),
(38561, '91016', 218, 6, 4274, 34.1428, 0.59590427584992, -117.9991, -2.05947280939004),
(38562, '91017', 218, 6, 4274, 34.1318, 0.595712289632201, -117.9873, -2.05926686053831),
(38563, '91020', 218, 6, 4299, 34.2109, 0.597092845070528, -118.2285, -2.06347659469412),
(38564, '91021', 218, 6, 4299, 34.2074, 0.597031758546708, -118.2245, -2.06340678152404),
(38565, '91023', 218, 6, 49679, 34.2274, 0.597380824397107, -118.0912, -2.06108025763113),
(38566, '91024', 218, 6, 185143, 34.1681, 0.596345844150675, -118.052, -2.06039608856435),
(38567, '91025', 218, 6, 185143, 34.1602, 0.596207963139767, -118.0519, -2.06039434323509),
(38568, '91030', 218, 6, 18143, 34.1114, 0.595356242464794, -118.1557, -2.06220599499866),
(38569, '91031', 218, 6, 18143, 34.1152, 0.59542256497637, -118.1527, -2.0621536351211),
(38570, '91040', 218, 6, 185457, 34.2603, 0.597955037721013, -118.331, -2.06526555717741),
(38571, '91041', 218, 6, 185457, 34.2622, 0.597988198976801, -118.3186, -2.06504913635016),
(38572, '91042', 218, 6, 185766, 34.2551, 0.59786428059991, -118.2835, -2.06443652578271),
(38573, '91043', 218, 6, 185766, 34.2512, 0.597796212759082, -118.2904, -2.0645569535011),
(38574, '91046', 218, 6, 185920, 34.2114, 0.597101571716788, -118.2401, -2.06367905288735),
(38575, '91050', 218, 6, 17543, 34.1554, 0.596124187335671, -118.2552, -2.0639425976044),
(38576, '91051', 218, 6, 17543, 34.1551, 0.596118951347915, -118.2559, -2.06395481490916),
(38577, '91066', 218, 6, 7137, 34.1409, 0.595871114594132, -118.0291, -2.05999640816564),
(38578, '91077', 218, 6, 7137, 34.1259, 0.595609315206333, -118.0548, -2.0604449577834),
(38579, '91101', 218, 6, 17543, 34.1471, 0.595979325007756, -118.1393, -2.06191976100134),
(38580, '91102', 218, 6, 17543, 34.1456, 0.595953145068976, -118.1437, -2.06199655548842),
(38581, '91103', 218, 6, 17543, 34.1664, 0.596316173553391, -118.1631, -2.06233514936331),
(38582, '91104', 218, 6, 17543, 34.1686, 0.596354570796934, -118.1204, -2.06158989377271),
(38583, '91105', 218, 6, 17543, 34.1378, 0.59581700938732, -118.166, -2.06238576391162),
(38584, '91106', 218, 6, 17543, 34.1408, 0.59586936926488, -118.1277, -2.06171730280811),
(38585, '91107', 218, 6, 17543, 34.152, 0.596064846141103, -118.0873, -2.0610121897903),
(38586, '91108', 218, 6, 184854, 34.1219, 0.595539502036253, -118.1137, -2.06147295671283),
(38587, '91109', 218, 6, 17543, 34.1673, 0.596331881516659, -118.1651, -2.06237005594835),
(38588, '91110', 218, 6, 17543, 34.1562, 0.596138149969687, -118.1538, -2.06217283374288),
(38589, '91114', 218, 6, 17543, 34.1697, 0.596373769418706, -118.1299, -2.06175570005165),
(38590, '91115', 218, 6, 17543, 34.1355, 0.595776866814524, -118.1531, -2.06216061643811),
(38591, '91116', 218, 6, 17543, 34.1464, 0.595967107702992, -118.1295, -2.06174871873464),
(38592, '91117', 218, 6, 17543, 34.1463, 0.59596536237374, -118.0956, -2.06115705211822),
(38593, '91118', 218, 6, 184854, 34.1262, 0.595614551194089, -118.0906, -2.06106978565562),
(38594, '91121', 218, 6, 17543, 34.1499, 0.596028194226812, -118.0899, -2.06105756835085),
(38595, '91123', 218, 6, 17543, 34.1413, 0.59587809591114, -118.1551, -2.06219552302315),
(38596, '91124', 218, 6, 17543, 34.1494, 0.596019467580552, -118.151, -2.06212396452382),
(38597, '91125', 218, 6, 17543, 34.1363, 0.59579082944854, -118.1238, -2.06164923496728),
(38598, '91126', 218, 6, 17543, 34.136, 0.595785593460784, -118.1246, -2.06166319760129),
(38599, '91129', 218, 6, 17543, 34.1451, 0.595944418422716, -118.1568, -2.06222519362044),
(38600, '91131', 218, 6, 17543, 34.1127, 0.59537893174507, -118.1269, -2.06170334017409),
(38601, '91175', 218, 6, 17543, 34.1304, 0.595687855022673, -118.1481, -2.06207334997551),
(38602, '91182', 218, 6, 17543, 34.1494, 0.596019467580552, -118.1404, -2.06193895962311),
(38603, '91184', 218, 6, 17543, 34.1393, 0.5958431893261, -118.1598, -2.062277553498),
(38604, '91185', 218, 6, 17543, 34.1677, 0.596338862833667, -117.9836, -2.05920228335598),
(38605, '91186', 218, 6, 17543, 34.1506, 0.596040411531576, -118.0716, -2.06073817309774),
(38606, '91187', 218, 6, 17543, 34.1076, 0.595289919953218, -118.1343, -2.06183249453874),
(38607, '91188', 218, 6, 17543, 34.1495, 0.596021212909804, -118.142, -2.06196688489114),
(38608, '91189', 218, 6, 17543, 34.1263, 0.595616296523341, -118.1637, -2.06234562133882),
(38609, '91191', 218, 6, 17543, 34.1121, 0.595368459769558, -118.1268, -2.06170159484484),
(38610, '91201', 218, 6, 2741, 34.1701, 0.596380750735714, -118.2898, -2.06454648152559),
(38611, '91202', 218, 6, 2741, 34.1673, 0.596331881516659, -118.2673, -2.06415378244389),
(38612, '91203', 218, 6, 2741, 34.1533, 0.596087535421379, -118.2653, -2.06411887585885),
(38613, '91204', 218, 6, 2741, 34.1345, 0.595759413522004, -118.2602, -2.064029864067),
(38614, '91205', 218, 6, 2741, 34.1363, 0.59579082944854, -118.2417, -2.06370697815538),
(38615, '91206', 218, 6, 2741, 34.16, 0.596204472481263, -118.2179, -2.0632915897934),
(38616, '91207', 218, 6, 2741, 34.1684, 0.596351080138431, -118.2432, -2.06373315809416),
(38617, '91208', 218, 6, 2741, 34.1907, 0.596740288561625, -118.2309, -2.06351848259616),
(38618, '91209', 218, 6, 2741, 34.1466, 0.595970598361496, -118.2515, -2.06387802042207),
(38619, '91210', 218, 6, 2741, 34.1446, 0.595935691776456, -118.2589, -2.06400717478672),
(38620, '91214', 218, 6, 182535, 34.2332, 0.597482053493723, -118.2463, -2.06378726330097),
(38621, '91221', 218, 6, 2741, 34.1647, 0.596286502956107, -118.2889, -2.06453077356232),
(38622, '91222', 218, 6, 2741, 34.1597, 0.596199236493507, -118.264, -2.06409618657857),
(38623, '91224', 218, 6, 182535, 34.2313, 0.597448892237935, -118.2501, -2.06385358581255),
(38624, '91225', 218, 6, 2741, 34.124, 0.595576153950545, -118.2545, -2.06393038029963),
(38625, '91226', 218, 6, 2741, 34.1614, 0.596228907090791, -118.2143, -2.06322875794033),
(38626, '91301', 218, 6, 179624, 34.1305, 0.595689600351925, -118.7624, -2.07279490757051),
(38627, '91302', 218, 6, 177823, 34.1295, 0.595672147059405, -118.677, -2.07130439638931),
(38628, '91303', 218, 6, 180499, 34.1987, 0.596879914901785, -118.6033, -2.07001808873059),
(38629, '91304', 218, 6, 180499, 34.2183, 0.597221999435176, -118.6278, -2.07044569439733),
(38630, '91305', 218, 6, 180499, 34.2016, 0.596930529450093, -118.6015, -2.06998667280405),
(38631, '91306', 218, 6, 122028, 34.2096, 0.597070155790252, -118.5759, -2.06953986851554),
(38632, '91307', 218, 6, 18548, 34.2056, 0.597000342620172, -118.6907, -2.07154350649683),
(38633, '91308', 218, 6, 18548, 34.1998, 0.596899113523557, -118.6286, -2.07045965703135),
(38634, '91309', 218, 6, 180499, 34.2181, 0.597218508776672, -118.5961, -2.06989242502445),
(38635, '91310', 218, 6, 180588, 34.4955, 0.602060052121704, -118.6143, -2.07021007494831),
(38636, '91311', 218, 6, 19964, 34.2549, 0.597860789941406, -118.5979, -2.06992384095098),
(38637, '91312', 218, 6, 19964, 34.2572, 0.597900932514201, -118.6004, -2.06996747418228),
(38638, '91313', 218, 6, 19964, 34.2382, 0.597569319956323, -118.5889, -2.0697667613183),
(38639, '91316', 218, 6, 94059, 34.1644, 0.596281266968351, -118.5146, -2.06846998168407),
(38640, '91319', 218, 6, 183612, 34.1834, 0.59661287952623, -118.9138, -2.07543733605803),
(38641, '91320', 218, 6, 183612, 34.1766, 0.596494197137094, -118.9323, -2.07576022196965),
(38642, '91321', 218, 6, 56522, 34.3803, 0.600049432823407, -118.5198, -2.06856073880518),
(38643, '91322', 218, 6, 56522, 34.385, 0.60013146329825, -118.5297, -2.06873352640112),
(38644, '91324', 218, 6, 23458, 34.2399, 0.597598990553606, -118.5491, -2.06907212027601),
(38645, '91325', 218, 6, 23458, 34.2378, 0.597562338639315, -118.518, -2.06852932287864),
(38646, '91326', 218, 6, 23458, 34.2754, 0.598218582438064, -118.5449, -2.06899881644743),
(38647, '91327', 218, 6, 23458, 34.2749, 0.598209855791805, -118.5547, -2.06916985871412),
(38648, '91328', 218, 6, 23458, 34.2209, 0.597267377995727, -118.5327, -2.06878588627868),
(38649, '91329', 218, 6, 23458, 34.2427, 0.597647859772662, -118.5354, -2.06883301016849),
(38650, '91330', 218, 6, 23458, 34.2434, 0.597660077077426, -118.5006, -2.06822563558879),
(38651, '91331', 218, 6, 183946, 34.2559, 0.597878243233925, -118.4244, -2.06689569469877),
(38652, '91333', 218, 6, 183946, 34.2627, 0.597996925623061, -118.4271, -2.06694281858858),
(38653, '91334', 218, 6, 183946, 34.2414, 0.597625170492386, -118.4241, -2.06689045871102),
(38654, '91335', 218, 6, 184498, 34.2, 0.596902604182061, -118.5385, -2.0688871153753),
(38655, '91337', 218, 6, 184498, 34.2028, 0.596951473401117, -118.5349, -2.06882428352223);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(38656, '91340', 218, 6, 184790, 34.2858, 0.598400096680272, -118.4347, -2.06707546361173),
(38657, '91341', 218, 6, 184790, 34.2823, 0.598339010156452, -118.4418, -2.06719938198862),
(38658, '91342', 218, 6, 51908, 34.3041, 0.598719491933387, -118.4205, -2.06682762685795),
(38659, '91343', 218, 6, 14309, 34.2389, 0.597581537261087, -118.4807, -2.06787831506765),
(38660, '91344', 218, 6, 181866, 34.2792, 0.59828490494964, -118.5015, -2.06824134355206),
(38661, '91345', 218, 6, 33304, 34.2652, 0.598040558854361, -118.4591, -2.06750132394922),
(38662, '91346', 218, 6, 33304, 34.168, 0.596344098821422, -118.4992, -2.06820120097926),
(38663, '91350', 218, 6, 184934, 34.4833, 0.601847121952961, -118.4286, -2.06696899852736),
(38664, '91351', 218, 6, 180506, 34.425, 0.600829594999048, -118.4446, -2.06724825120768),
(38665, '91352', 218, 6, 6157, 34.225, 0.597338936495059, -118.3593, -2.06575948535572),
(38666, '91353', 218, 6, 6157, 34.2175, 0.59720803680116, -118.3679, -2.0659095836714),
(38667, '91354', 218, 6, 34233, 34.4452, 0.601182151507951, -118.5468, -2.06903197770321),
(38668, '91355', 218, 6, 34233, 34.4063, 0.600503218428925, -118.5349, -2.06882428352223),
(38669, '91356', 218, 6, 185567, 34.1617, 0.596234143078547, -118.5463, -2.06902325105695),
(38670, '91357', 218, 6, 185567, 34.1723, 0.596419147979258, -118.5397, -2.06890805932632),
(38671, '91358', 218, 6, 57890, 34.1806, 0.596564010307174, -118.8754, -2.07476712962527),
(38672, '91359', 218, 6, 52668, 34.1931, 0.596782176463673, -118.8196, -2.07379323590265),
(38673, '91360', 218, 6, 57890, 34.2106, 0.597087609082772, -118.875, -2.07476014830826),
(38674, '91361', 218, 6, 52668, 34.1515, 0.596056119494843, -118.8461, -2.07425574815443),
(38675, '91362', 218, 6, 57890, 34.1947, 0.596810101731705, -118.8323, -2.07401489271766),
(38676, '91363', 218, 6, 52668, 34.1929, 0.596778685805169, -118.8198, -2.07379672656116),
(38677, '91364', 218, 6, 12938, 34.1552, 0.596120696677167, -118.6017, -2.06999016346256),
(38678, '91365', 218, 6, 12938, 34.1698, 0.596375514747958, -118.608, -2.07010011920543),
(38679, '91367', 218, 6, 12938, 34.1765, 0.596492451807842, -118.6202, -2.07031304937418),
(38680, '91371', 218, 6, 12938, 34.1842, 0.596626842160246, -118.5703, -2.06944213007743),
(38681, '91372', 218, 6, 177823, 34.1545, 0.596108479372403, -118.6414, -2.0706830591756),
(38682, '91376', 218, 6, 179624, 34.142, 0.595890313215904, -118.7532, -2.07263433727933),
(38683, '91377', 218, 6, 4691, 34.1471, 0.595979325007756, -118.7542, -2.07265179057185),
(38684, '91380', 218, 6, 184934, 34.4998, 0.60213510127954, -118.3977, -2.06642969178849),
(38685, '91381', 218, 6, 0, 34.3824, 0.600086084737698, -118.5718, -2.06946831001621),
(38686, '91382', 218, 6, 184934, 34.4135, 0.600628882135069, -118.5104, -2.06839667785549),
(38687, '91383', 218, 6, 184934, 34.3603, 0.599700366973008, -118.4588, -2.06749608796146),
(38688, '91384', 218, 6, 180588, 34.4646, 0.601520745382838, -118.6408, -2.07067258720009),
(38689, '91385', 218, 6, 34233, 34.3886, 0.600194295151322, -118.56, -2.06926236116448),
(38690, '91386', 218, 6, 180506, 34.4158, 0.600669024707864, -118.4525, -2.06738613221858),
(38691, '91387', 218, 6, 180506, 34.4265, 0.600855774937828, -118.4223, -2.06685904278448),
(38692, '91388', 218, 6, 31371, 34.2012, 0.596923548133085, -118.448, -2.06730759240224),
(38693, '91390', 218, 6, 184934, 34.4928, 0.6020129282319, -118.3726, -2.06599161414624),
(38694, '91392', 218, 6, 51908, 34.3085, 0.598796286420475, -118.4305, -2.06700215978314),
(38695, '91393', 218, 6, 14309, 34.23, 0.597426202957659, -118.4671, -2.06764095028937),
(38696, '91394', 218, 6, 181866, 34.2647, 0.598031832208101, -118.5244, -2.06864102395077),
(38697, '91395', 218, 6, 33304, 34.2569, 0.597895696526445, -118.4642, -2.06759033574107),
(38698, '91396', 218, 6, 122028, 34.2089, 0.597057938485488, -118.57, -2.06943689408968),
(38699, '91399', 218, 6, 12938, 34.1686, 0.596354570796934, -118.6055, -2.07005648597413),
(38700, '91401', 218, 6, 31371, 34.178, 0.596518631746622, -118.4295, -2.06698470649062),
(38701, '91402', 218, 6, 183984, 34.2248, 0.597335445836555, -118.4419, -2.06720112731787),
(38702, '91403', 218, 6, 18067, 34.15, 0.596029939556064, -118.4622, -2.06755542915603),
(38703, '91404', 218, 6, 31371, 34.1786, 0.596529103722134, -118.4328, -2.06704230235594),
(38704, '91405', 218, 6, 31371, 34.1997, 0.596897368194305, -118.4459, -2.06727094048795),
(38705, '91406', 218, 6, 31371, 34.2021, 0.596939256096353, -118.4917, -2.06807030128536),
(38706, '91407', 218, 6, 31371, 34.1944, 0.596804865743949, -118.4489, -2.06732330036551),
(38707, '91408', 218, 6, 31371, 34.1789, 0.59653433970989, -118.4325, -2.06703706636818),
(38708, '91409', 218, 6, 31371, 34.2034, 0.596961945376629, -118.4912, -2.06806157463911),
(38709, '91410', 218, 6, 31371, 34.2029, 0.596953218730369, -118.491, -2.0680580839806),
(38710, '91411', 218, 6, 31371, 34.1776, 0.596511650429614, -118.4594, -2.06750655993697),
(38711, '91412', 218, 6, 183984, 34.2244, 0.597328464519547, -118.4461, -2.06727443114646),
(38712, '91413', 218, 6, 18067, 34.1642, 0.596277776309847, -118.4565, -2.06745594538866),
(38713, '91416', 218, 6, 94059, 34.1758, 0.596480234503078, -118.5173, -2.06851710557388),
(38714, '91423', 218, 6, 18067, 34.1525, 0.596073572787364, -118.4321, -2.06703008505118),
(38715, '91426', 218, 6, 94059, 34.1553, 0.596122442006419, -118.5174, -2.06851885090313),
(38716, '91436', 218, 6, 94059, 34.1479, 0.595993287641772, -118.497, -2.06816280373572),
(38717, '91470', 218, 6, 31371, 34.1767, 0.596495942466346, -118.6164, -2.0702467268626),
(38718, '91482', 218, 6, 31371, 34.2011, 0.596921802803833, -118.4751, -2.06778057662953),
(38719, '91495', 218, 6, 18067, 34.1646, 0.596284757626855, -118.4583, -2.0674873613152),
(38720, '91496', 218, 6, 31371, 34.1652, 0.596295229602367, -118.458, -2.06748212532744),
(38721, '91497', 218, 6, 31371, 34.1899, 0.596726325927609, -118.4496, -2.06733551767028),
(38722, '91499', 218, 6, 31371, 34.2009, 0.596918312145329, -118.455, -2.06742976544988),
(38723, '91501', 218, 6, 1232, 34.1885, 0.596701891318081, -118.298, -2.06468959852425),
(38724, '91502', 218, 6, 1232, 34.176, 0.596483725161582, -118.3079, -2.0648623861202),
(38725, '91503', 218, 6, 1232, 34.18, 0.596553538331662, -118.308, -2.06486413144945),
(38726, '91504', 218, 6, 1232, 34.2034, 0.596961945376629, -118.3292, -2.06523414125087),
(38727, '91505', 218, 6, 1232, 34.1687, 0.596356316126186, -118.3427, -2.06546976069989),
(38728, '91506', 218, 6, 1232, 34.1729, 0.59642961995477, -118.3225, -2.06511720419099),
(38729, '91507', 218, 6, 1232, 34.1672, 0.596330136187407, -118.3468, -2.06554131919923),
(38730, '91508', 218, 6, 1232, 34.1914, 0.596752505866389, -118.3255, -2.06516956406855),
(38731, '91510', 218, 6, 1232, 34.1768, 0.596497687795598, -118.3484, -2.06556924446726),
(38732, '91521', 218, 6, 1232, 34.1554, 0.596124187335671, -118.3245, -2.06515211077603),
(38733, '91522', 218, 6, 1232, 34.1479, 0.595993287641772, -118.3386, -2.06539820220056),
(38734, '91523', 218, 6, 1232, 34.1661, 0.596310937565635, -118.3379, -2.0653859848958),
(38735, '91526', 218, 6, 1232, 34.1909, 0.596743779220129, -118.3258, -2.06517480005631),
(38736, '91601', 218, 6, 183686, 34.1676, 0.596337117504415, -118.369, -2.06592878229317),
(38737, '91602', 218, 6, 183686, 34.1515, 0.596056119494843, -118.3646, -2.06585198780608),
(38738, '91603', 218, 6, 183686, 34.1676, 0.596337117504415, -118.3774, -2.06607538995034),
(38739, '91604', 218, 6, 185415, 34.1415, 0.595881586569644, -118.3894, -2.06628482946057),
(38740, '91605', 218, 6, 183686, 34.2081, 0.597043975851472, -118.4021, -2.06650648627558),
(38741, '91606', 218, 6, 183686, 34.1858, 0.596654767428278, -118.3891, -2.06627959347282),
(38742, '91607', 218, 6, 91540, 34.1659, 0.596307446907131, -118.4002, -2.06647332501979),
(38743, '91608', 218, 6, 98700, 34.1381, 0.595822245375076, -118.3541, -2.06566872823462),
(38744, '91609', 218, 6, 183686, 34.1887, 0.596705381976585, -118.3866, -2.06623596024152),
(38745, '91610', 218, 6, 0, 34.1578, 0.596166075237719, -118.3795, -2.06611204186463),
(38746, '91611', 218, 6, 183686, 34.1864, 0.596665239403789, -118.398, -2.06643492777625),
(38747, '91612', 218, 6, 183686, 34.187, 0.596675711379301, -118.3978, -2.06643143711774),
(38748, '91614', 218, 6, 185415, 34.1418, 0.5958868225574, -118.3933, -2.0663528973014),
(38749, '91615', 218, 6, 183686, 34.1985, 0.596876424243281, -118.3961, -2.06640176652046),
(38750, '91616', 218, 6, 183686, 34.1835, 0.596614624855482, -118.3959, -2.06639827586195),
(38751, '91617', 218, 6, 91540, 34.1642, 0.596277776309847, -118.4032, -2.06652568489735),
(38752, '91618', 218, 6, 183686, 34.1137, 0.59539638503759, -118.3671, -2.06589562103738),
(38753, '91701', 218, 6, 184390, 34.14, 0.595855406630864, -117.5863, -2.05226809023781),
(38754, '91702', 218, 6, 179885, 34.1262, 0.595614551194089, -117.903, -2.05779554797887),
(38755, '91706', 218, 6, 53323, 34.0856, 0.594905947517779, -117.9694, -2.0589544466022),
(38756, '91708', 218, 6, 180697, 34.0256, 0.593858749966583, -117.6864, -2.05401516481905),
(38757, '91709', 218, 6, 180698, 33.9811, 0.593082078449445, -117.7362, -2.05488433878655),
(38758, '91710', 218, 6, 180697, 34.0153, 0.593678981053627, -117.6851, -2.05399247553878),
(38759, '91711', 218, 6, 26794, 34.1128, 0.595380677074322, -117.7175, -2.05455796221642),
(38760, '91714', 218, 6, 0, 34.0197, 0.593755775540715, -117.9581, -2.05875722439672),
(38761, '91715', 218, 6, 0, 34.0133, 0.593644074468587, -117.9693, -2.05895270127295),
(38762, '91716', 218, 6, 0, 34.0015, 0.593438125616852, -117.9759, -2.05906789300358),
(38763, '91722', 218, 6, 180919, 34.0974, 0.595111896369515, -117.9046, -2.05782347324691),
(38764, '91723', 218, 6, 180919, 34.085, 0.594895475542267, -117.8853, -2.05748662470127),
(38765, '91724', 218, 6, 180919, 34.09, 0.594982742004867, -117.8565, -2.0569839698767),
(38766, '91729', 218, 6, 184390, 34.099, 0.595139821637546, -117.5661, -2.05191553372891),
(38767, '91730', 218, 6, 184390, 34.1067, 0.59527421198995, -117.5902, -2.05233615807864),
(38768, '91731', 218, 6, 181360, 34.0768, 0.594752358543604, -118.0405, -2.06019537570037),
(38769, '91732', 218, 6, 181360, 34.0733, 0.594691272019784, -118.0123, -2.0597031928513),
(38770, '91733', 218, 6, 185272, 34.0522, 0.594323007547613, -118.045, -2.06027391551671),
(38771, '91734', 218, 6, 181360, 34.0737, 0.594698253336792, -118.0321, -2.0600487680432),
(38772, '91735', 218, 6, 181360, 34.0751, 0.59472268794632, -118.028, -2.05997720954387),
(38773, '91737', 218, 6, 184390, 34.1456, 0.595953145068976, -117.5731, -2.05203770677655),
(38774, '91739', 218, 6, 184390, 34.126, 0.595611060535585, -117.5217, -2.05114060754102),
(38775, '91740', 218, 6, 29901, 34.1157, 0.595431291622629, -117.8566, -2.05698571520595),
(38776, '91741', 218, 6, 29901, 34.1452, 0.595946163751968, -117.8532, -2.05692637401138),
(38777, '91743', 218, 6, 181952, 34.0661, 0.59456560831364, -117.5798, -2.05215464383643),
(38778, '91744', 218, 6, 182579, 34.0311, 0.593954743075442, -117.9365, -2.05838023327829),
(38779, '91745', 218, 6, 181970, 33.9977, 0.593371803105276, -117.9651, -2.05887939744436),
(38780, '91746', 218, 6, 182579, 34.0485, 0.594258430365289, -117.9821, -2.0591761034172),
(38781, '91747', 218, 6, 182579, 34.0196, 0.593754030211463, -117.9491, -2.05860014476404),
(38782, '91748', 218, 6, 184688, 33.9833, 0.593120475692989, -117.8958, -2.05766988427273),
(38783, '91749', 218, 6, 182579, 34.0329, 0.593986159001978, -117.9524, -2.05865774062936),
(38784, '91750', 218, 6, 182591, 34.1178, 0.595467943536921, -117.7705, -2.05548298671998),
(38785, '91752', 218, 6, 183310, 33.9964, 0.593349113825, -117.5297, -2.05128023388118),
(38786, '91754', 218, 6, 66936, 34.0499, 0.594282864974817, -118.1492, -2.06209254859728),
(38787, '91755', 218, 6, 66936, 34.0506, 0.594295082279581, -118.1162, -2.06151658994413),
(38788, '91756', 218, 6, 66936, 34.0463, 0.594220033121745, -118.1305, -2.06176617202716),
(38789, '91758', 218, 6, 33502, 34.0546, 0.594364895449661, -117.6063, -2.05261715608821),
(38790, '91759', 218, 6, 183474, 34.2556, 0.59787300724617, -117.6347, -2.05311282959577),
(38791, '91761', 218, 6, 33502, 34.0342, 0.594008848282254, -117.6058, -2.05260842944195),
(38792, '91762', 218, 6, 33502, 34.057, 0.594406783351709, -117.671, -2.05374638411425),
(38793, '91763', 218, 6, 17169, 34.0747, 0.594715706629312, -117.6978, -2.05421413235378),
(38794, '91764', 218, 6, 33502, 34.0782, 0.594776793153132, -117.617, -2.05280390631817),
(38795, '91765', 218, 6, 181142, 34.002, 0.593446852263112, -117.8135, -2.05623347829834),
(38796, '91766', 218, 6, 24061, 34.0412, 0.594131021329894, -117.7623, -2.05533986972132),
(38797, '91767', 218, 6, 24061, 34.0816, 0.594836134347699, -117.7387, -2.05492797201785),
(38798, '91768', 218, 6, 24061, 34.0682, 0.594602260227932, -117.7774, -2.05560341443837),
(38799, '91769', 218, 6, 24061, 34.0602, 0.594462633887773, -117.7577, -2.05525958457573),
(38800, '91770', 218, 6, 68384, 34.0654, 0.594553391008876, -118.0842, -2.06095808458349),
(38801, '91771', 218, 6, 68384, 34.0641, 0.5945307017286, -118.0837, -2.06094935793723),
(38802, '91772', 218, 6, 68384, 34.0644, 0.594535937716356, -118.0833, -2.06094237662022),
(38803, '91773', 218, 6, 184784, 34.1013, 0.595179964210342, -117.8175, -2.05630329146842),
(38804, '91775', 218, 6, 97787, 34.1147, 0.59541383833011, -118.0887, -2.06103662439983),
(38805, '91776', 218, 6, 97787, 34.0904, 0.594989723321875, -118.0937, -2.06112389086243),
(38806, '91778', 218, 6, 97787, 34.1025, 0.595200908161366, -118.1054, -2.06132809438491),
(38807, '91780', 218, 6, 185589, 34.1008, 0.595171237564082, -118.0583, -2.06050604430722),
(38808, '91784', 218, 6, 34227, 34.136, 0.595785593460784, -117.665, -2.05364166435913),
(38809, '91785', 218, 6, 34227, 34.0994, 0.595146802954554, -117.646, -2.05331005180125),
(38810, '91786', 218, 6, 34227, 34.1198, 0.595502850121961, -117.6613, -2.0535770871768),
(38811, '91788', 218, 6, 12616, 34.0176, 0.593719123626423, -117.8634, -2.05710439759508),
(38812, '91789', 218, 6, 12616, 34.0153, 0.593678981053627, -117.8582, -2.05701364047398),
(38813, '91790', 218, 6, 186070, 34.0666, 0.5945743349599, -117.9383, -2.05841164920483),
(38814, '91791', 218, 6, 186070, 34.0639, 0.594527211070096, -117.8922, -2.05760705241966),
(38815, '91792', 218, 6, 186070, 34.0299, 0.593933799124418, -117.907, -2.05786536114895),
(38816, '91793', 218, 6, 186070, 34.0692, 0.594619713520452, -117.9294, -2.0582563149014),
(38817, '91795', 218, 6, 12616, 34.0289, 0.593916345831898, -117.8578, -2.05700665915697),
(38818, '91797', 218, 6, 24061, 34.0833, 0.594865804944983, -117.9704, -2.05897189989472),
(38819, '91798', 218, 6, 33502, 34.0357, 0.594035028221034, -117.5918, -2.05236408334667),
(38820, '91799', 218, 6, 24061, 34.0588, 0.594438199278245, -117.7609, -2.05531543511179),
(38821, '91801', 218, 6, 26347, 34.0899, 0.594980996675615, -118.1301, -2.06175919071015),
(38822, '91802', 218, 6, 26347, 34.0934, 0.595042083199435, -118.125, -2.0616701789183),
(38823, '91803', 218, 6, 26347, 34.0739, 0.594701743995296, -118.1448, -2.0620157541102),
(38824, '91804', 218, 6, 26347, 34.0936, 0.595045573857939, -118.1262, -2.06169112286933),
(38825, '91841', 218, 6, 26347, 34.0932, 0.595038592540931, -118.1254, -2.06167716023531),
(38826, '91896', 218, 6, 26347, 34.0918, 0.595014157931403, -118.1286, -2.06173301077137),
(38827, '91899', 218, 6, 26347, 34.0837, 0.594872786261991, -118.1351, -2.06184645717275),
(38828, '91901', 218, 6, 7073, 32.8292, 0.572977630795722, -116.7554, -2.03776614948299),
(38829, '91902', 218, 6, 1041, 32.6708, 0.570213029260563, -117.0046, -2.04211550997896),
(38830, '91903', 218, 6, 7073, 32.8353, 0.573084095880094, -116.7656, -2.03794417306669),
(38831, '91905', 218, 6, 154405, 32.7267, 0.571188668312428, -116.3015, -2.02984410000819),
(38832, '91906', 218, 6, 180457, 32.6962, 0.57065634289057, -116.5113, -2.03350580077887),
(38833, '91908', 218, 6, 1041, 32.6576, 0.5699826457993, -117.0295, -2.0425500969627),
(38834, '91909', 218, 6, 180718, 32.6108, 0.569165831709367, -117.0689, -2.04323775668799),
(38835, '91910', 218, 6, 180718, 32.6248, 0.569410177804646, -117.0148, -2.04229353356266),
(38836, '91911', 218, 6, 180718, 32.6063, 0.569087291893027, -117.0519, -2.04294105071515),
(38837, '91912', 218, 6, 180718, 32.6401, 0.569677213180201, -117.0834, -2.04349082942953),
(38838, '91913', 218, 6, 180718, 32.6414, 0.569699902460477, -116.9814, -2.04171059359249),
(38839, '91914', 218, 6, 180718, 32.6548, 0.569933776580244, -116.9519, -2.04119572146316),
(38840, '91915', 218, 6, 180718, 32.628, 0.56946602834071, -116.9396, -2.04098104596516),
(38841, '91916', 218, 6, 181111, 32.925, 0.574649656219133, -116.6333, -2.0356351024663),
(38842, '91917', 218, 6, 181218, 32.6075, 0.569108235844051, -116.7871, -2.03831941885587),
(38843, '91921', 218, 6, 180718, 32.6562, 0.569958211189772, -116.9559, -2.04126553463324),
(38844, '91931', 218, 6, 181953, 32.8486, 0.573316224670609, -116.5565, -2.03429468960077),
(38845, '91932', 218, 6, 182268, 32.5734, 0.568513078569121, -117.1196, -2.04412263861875),
(38846, '91933', 218, 6, 182268, 32.5836, 0.568691102152824, -117.1119, -2.04398824826635),
(38847, '91934', 218, 6, 182347, 32.6182, 0.569294986074014, -116.1871, -2.0278474433439),
(38848, '91935', 218, 6, 182359, 32.689, 0.570530679184426, -116.8132, -2.03877494979064),
(38849, '91941', 218, 6, 182564, 32.7609, 0.57178557091661, -116.998, -2.04200031824833),
(38850, '91942', 218, 6, 182564, 32.7839, 0.572186996644569, -117.0163, -2.04231971350144),
(38851, '91943', 218, 6, 182564, 32.7793, 0.572106711498977, -117.0115, -2.04223593769734),
(38852, '91944', 218, 6, 182564, 32.7665, 0.571883309354722, -117.0228, -2.04243315990282),
(38853, '91945', 218, 6, 16884, 32.7336, 0.571309096030816, -117.0337, -2.04262340079129),
(38854, '91946', 218, 6, 16884, 32.7426, 0.571466175663495, -117.0303, -2.04256405959672),
(38855, '91947', 218, 6, 182804, 32.6673, 0.570151942736744, -117.0724, -2.04329884321181),
(38856, '91948', 218, 6, 183484, 32.8706, 0.573700197106048, -116.4163, -2.03184773798947),
(38857, '91950', 218, 6, 28003, 32.6694, 0.570188594651036, -117.092, -2.0436409277452),
(38858, '91951', 218, 6, 28003, 32.6776, 0.570331711649699, -117.0983, -2.04375088348808),
(38859, '91962', 218, 6, 443, 32.8181, 0.572783899248751, -116.4546, -2.03251619909299),
(38860, '91963', 218, 6, 184253, 32.6393, 0.569663250546185, -116.6099, -2.03522669542134),
(38861, '91976', 218, 6, 826, 32.7488, 0.571574386077119, -116.9851, -2.04177517077482),
(38862, '91977', 218, 6, 826, 32.7227, 0.571118855142349, -116.9916, -2.0418886171762),
(38863, '91978', 218, 6, 826, 32.7032, 0.57077851593821, -116.9384, -2.04096010201414),
(38864, '91979', 218, 6, 826, 32.7316, 0.571274189445776, -116.973, -2.04156398593533),
(38865, '91980', 218, 6, 185579, 32.5866, 0.568743462030384, -116.662, -2.03613601196163),
(38866, '91987', 218, 6, 185579, 32.5932, 0.568858653761016, -116.6398, -2.03574854886768),
(38867, '91990', 218, 6, 184253, 32.6044, 0.569054130637239, -116.6121, -2.03526509266488),
(38868, '92003', 218, 6, 180188, 33.2846, 0.580925860209305, -117.1935, -2.04541243693597),
(38869, '92004', 218, 6, 180198, 33.2565, 0.580435422689494, -116.326, -2.03027170567492),
(38870, '92007', 218, 6, 0, 33.0243, 0.576382768166363, -117.269, -2.04673016052123),
(38871, '92008', 218, 6, 180533, 33.1486, 0.578552212426592, -117.3056, -2.04736895102746),
(38872, '92009', 218, 6, 180533, 33.0966, 0.577644641215555, -117.2695, -2.04673888716749),
(38873, '92013', 218, 6, 180533, 33.1578, 0.578712782717776, -117.3497, -2.04813864122759),
(38874, '92014', 218, 6, 93677, 32.9971, 0.575908038609821, -117.2266, -2.04599014091838),
(38875, '92018', 218, 6, 180533, 33.1626, 0.578796558521872, -117.3488, -2.04812293326432),
(38876, '92019', 218, 6, 181330, 32.7804, 0.572125910120749, -116.9064, -2.0404015966535),
(38877, '92020', 218, 6, 181330, 32.7912, 0.572314405679965, -116.9664, -2.0414487942047),
(38878, '92021', 218, 6, 181330, 32.8187, 0.572794371224263, -116.9016, -2.0403178208494),
(38879, '92022', 218, 6, 181330, 32.7301, 0.571248009506996, -116.9117, -2.04049409910385),
(38880, '92023', 218, 6, 181455, 33.0375, 0.576613151627627, -117.2933, -2.04715427552946),
(38881, '92024', 218, 6, 181455, 33.0531, 0.576885422990938, -117.2663, -2.04668303663143),
(38882, '92025', 218, 6, 181476, 33.0804, 0.577361897876732, -117.0402, -2.04273684719267),
(38883, '92026', 218, 6, 181476, 33.1755, 0.579021705995379, -117.1033, -2.04383814995068),
(38884, '92027', 218, 6, 181476, 33.138, 0.578367207525881, -117.0464, -2.04284505760629),
(38885, '92028', 218, 6, 181529, 33.3699, 0.582414626061256, -117.2187, -2.04585225990748),
(38886, '92029', 218, 6, 181476, 33.0931, 0.577583554691736, -117.1103, -2.04396032299832),
(38887, '92030', 218, 6, 181476, 33.1367, 0.578344518245605, -117.0543, -2.0429829386172),
(38888, '92033', 218, 6, 181476, 33.1235, 0.578114134784342, -117.0863, -2.04354144397784),
(38889, '92036', 218, 6, 95234, 33.0673, 0.577133259744721, -116.5522, -2.03421964044293),
(38890, '92037', 218, 6, 182551, 32.8397, 0.573160890367182, -117.2522, -2.0464369452069),
(38891, '92038', 218, 6, 182551, 32.856, 0.573445379035257, -117.2498, -2.04639505730485),
(38892, '92039', 218, 6, 182551, 32.8473, 0.573293535390333, -117.2757, -2.04684709758111),
(38893, '92040', 218, 6, 9948, 32.8586, 0.573490757595809, -116.9173, -2.04059183754197),
(38894, '92046', 218, 6, 181476, 33.1253, 0.578145550710878, -117.102, -2.0438154606704),
(38895, '92049', 218, 6, 151350, 33.1947, 0.579356809211762, -117.3776, -2.0486255880889),
(38896, '92051', 218, 6, 151350, 33.1991, 0.579433603698849, -117.368, -2.0484580364807),
(38897, '92052', 218, 6, 151350, 33.1995, 0.579440585015857, -117.3676, -2.0484510551637),
(38898, '92054', 218, 6, 151350, 33.2043, 0.579524360819953, -117.3526, -2.0481892557759),
(38899, '92055', 218, 6, 0, 33.2935, 0.581081194512732, -117.3005, -2.04727993923561),
(38900, '92056', 218, 6, 151350, 33.2046, 0.579529596807709, -117.2977, -2.04723107001655),
(38901, '92057', 218, 6, 151350, 33.2402, 0.580150934021419, -117.2978, -2.0472328153458),
(38902, '92058', 218, 6, 151350, 33.1822, 0.579138643055262, -117.2951, -2.047185691456),
(38903, '92059', 218, 6, 183952, 33.3841, 0.582662462815039, -117.0664, -2.04319412345669),
(38904, '92060', 218, 6, 183974, 33.3368, 0.581836922078846, -116.7987, -2.0385218770491),
(38905, '92061', 218, 6, 184041, 33.3093, 0.581356956534547, -116.9745, -2.04159016587411),
(38906, '92064', 218, 6, 184266, 32.9779, 0.575572935393438, -117.0355, -2.04265481671782),
(38907, '92065', 218, 6, 33718, 33.03, 0.576482251933727, -116.8607, -2.03960398118534),
(38908, '92066', 218, 6, 184378, 33.2678, 0.58063264489497, -116.5538, -2.03424756571097),
(38909, '92067', 218, 6, 178950, 33.0123, 0.576173328656124, -117.2009, -2.04554159130062),
(38910, '92068', 218, 6, 184848, 33.2754, 0.580765289918121, -117.2738, -2.04681393632533),
(38911, '92069', 218, 6, 97802, 33.1497, 0.578571411048364, -117.1697, -2.044997048574),
(38912, '92070', 218, 6, 184973, 33.1429, 0.578452728659229, -116.7093, -2.03696155269782),
(38913, '92071', 218, 6, 61670, 32.8478, 0.573302262036593, -116.9882, -2.04182927598163),
(38914, '92072', 218, 6, 61670, 32.8316, 0.57301951869777, -117.0383, -2.04270368593688),
(38915, '92074', 218, 6, 184266, 32.957, 0.575208161579771, -117.0362, -2.04266703402259),
(38916, '92075', 218, 6, 185223, 32.9964, 0.575895821305057, -117.254, -2.04646836113343),
(38917, '92078', 218, 6, 97802, 33.1171, 0.578002433712214, -117.1668, -2.04494643402569),
(38918, '92079', 218, 6, 97802, 33.143, 0.578454473988481, -117.1657, -2.04492723540392),
(38919, '92082', 218, 6, 34235, 33.2537, 0.580386553470438, -117.0368, -2.0426775059981),
(38920, '92083', 218, 6, 18458, 33.1919, 0.579307939992706, -117.2358, -2.04615071120957),
(38921, '92084', 218, 6, 18458, 33.2128, 0.579672713806373, -117.2144, -2.04577721074964),
(38922, '92085', 218, 6, 18458, 33.192, 0.579309685321958, -117.2327, -2.04609660600276),
(38923, '92086', 218, 6, 186026, 33.2989, 0.58117544229234, -116.6698, -2.03627214764328),
(38924, '92088', 218, 6, 181529, 33.3664, 0.582353539537436, -117.2494, -2.04638807598784),
(38925, '92090', 218, 6, 181330, 32.7948, 0.572377237533036, -116.962, -2.04137199971761),
(38926, '92091', 218, 6, 178950, 33.0142, 0.576206489911912, -117.2414, -2.04624844964768),
(38927, '92092', 218, 6, 182551, 32.876, 0.573794444885656, -117.2311, -2.04606868073472),
(38928, '92093', 218, 6, 182551, 32.8763, 0.573799680873412, -117.2317, -2.04607915271024),
(38929, '92096', 218, 6, 97802, 33.1364, 0.578339282257849, -117.1735, -2.04506337108558),
(38930, '92101', 218, 6, 97784, 32.7209, 0.571087439215813, -117.1645, -2.0449062914529),
(38931, '92102', 218, 6, 97784, 32.7142, 0.570970502155929, -117.1145, -2.0440336268269),
(38932, '92103', 218, 6, 97784, 32.7461, 0.571527262187315, -117.1691, -2.04498657659849),
(38933, '92104', 218, 6, 97784, 32.7416, 0.571448722370975, -117.1284, -2.04427622759293),
(38934, '92105', 218, 6, 97784, 32.7376, 0.571378909200896, -117.0915, -2.04363220109894),
(38935, '92106', 218, 6, 97784, 32.7281, 0.571213102921956, -117.2316, -2.04607740738098),
(38936, '92107', 218, 6, 97784, 32.7398, 0.57141730644444, -117.2407, -2.04623623234292),
(38937, '92108', 218, 6, 97784, 32.7742, 0.572017699707126, -117.1365, -2.04441759926234),
(38938, '92109', 218, 6, 97784, 32.7934, 0.572352802923508, -117.2372, -2.0461751458191),
(38939, '92110', 218, 6, 97784, 32.7649, 0.57185538408669, -117.1999, -2.0455241380081),
(38940, '92111', 218, 6, 97784, 32.8002, 0.572471485312644, -117.1709, -2.04501799252502),
(38941, '92112', 218, 6, 97784, 32.7256, 0.571169469690656, -117.1657, -2.04492723540392),
(38942, '92113', 218, 6, 97784, 32.6977, 0.57068252282935, -117.1191, -2.04411391197249),
(38943, '92114', 218, 6, 97784, 32.707, 0.570844838449785, -117.0496, -2.04290090814235),
(38944, '92115', 218, 6, 97784, 32.7615, 0.571796042892122, -117.0697, -2.04325171932201),
(38945, '92116', 218, 6, 97784, 32.7629, 0.57182047750165, -117.1222, -2.0441680171793),
(38946, '92117', 218, 6, 97784, 32.8237, 0.572881637686863, -117.1966, -2.04546654214279),
(38947, '92118', 218, 6, 101079, 32.6893, 0.570535915172182, -117.1801, -2.04517856281621),
(38948, '92119', 218, 6, 97784, 32.8044, 0.572544789141228, -117.0279, -2.04252217169467),
(38949, '92120', 218, 6, 97784, 32.794, 0.57236327489902, -117.0703, -2.04326219129752),
(38950, '92121', 218, 6, 97784, 32.8946, 0.574119076126527, -117.2013, -2.04554857261763),
(38951, '92122', 218, 6, 97784, 32.8563, 0.573450615023013, -117.2091, -2.04568470829929),
(38952, '92123', 218, 6, 97784, 32.7994, 0.572457522678628, -117.1374, -2.04443330722561),
(38953, '92124', 218, 6, 97784, 32.823, 0.572869420382099, -117.0947, -2.043688051635),
(38954, '92126', 218, 6, 97784, 32.9149, 0.574473377964682, -117.1465, -2.04459213218754),
(38955, '92127', 218, 6, 97784, 33.0211, 0.5763269176303, -117.1017, -2.04381022468264),
(38956, '92128', 218, 6, 97784, 33.0095, 0.576124459437068, -117.0731, -2.04331106051657),
(38957, '92129', 218, 6, 97784, 32.9666, 0.575375713187963, -117.1213, -2.04415230921604),
(38958, '92130', 218, 6, 97784, 32.9515, 0.575112168470912, -117.2006, -2.04553635531287),
(38959, '92131', 218, 6, 97784, 32.9106, 0.574398328806846, -117.0859, -2.04353446266083),
(38960, '92132', 218, 6, 97784, 32.7167, 0.571014135387229, -117.1675, -2.04495865133046),
(38961, '92133', 218, 6, 97784, 32.7137, 0.570961775509669, -117.2347, -2.0461315125878),
(38962, '92134', 218, 6, 97784, 32.7248, 0.57115550705664, -117.1466, -2.04459387751679),
(38963, '92135', 218, 6, 97784, 32.7005, 0.570731392048406, -117.1818, -2.04520823341349),
(38964, '92136', 218, 6, 97784, 32.6793, 0.570361382246983, -117.1187, -2.04410693065548),
(38965, '92137', 218, 6, 97784, 32.8846, 0.573944543201327, -117.1022, -2.0438189513289),
(38966, '92138', 218, 6, 97784, 32.7656, 0.571867601391454, -117.2005, -2.04553460998361),
(38967, '92139', 218, 6, 97784, 32.6786, 0.570349164942219, -117.0489, -2.04288869083759),
(38968, '92140', 218, 6, 97784, 32.7414, 0.571445231712471, -117.1973, -2.04547875944755),
(38969, '92142', 218, 6, 97784, 32.8398, 0.573162635696434, -117.0973, -2.04373343019556),
(38970, '92143', 218, 6, 177682, 32.5675, 0.568410104143253, -116.973, -2.04156398593533),
(38971, '92145', 218, 6, 97784, 32.8753, 0.573782227580892, -117.1501, -2.04465496404061),
(38972, '92147', 218, 6, 97784, 32.7004, 0.570729646719154, -117.2057, -2.04562536710472),
(38973, '92149', 218, 6, 97784, 32.6764, 0.570310767698675, -117.0656, -2.04318016082267),
(38974, '92150', 218, 6, 97784, 32.9848, 0.575693363111826, -117.0803, -2.04343672422272),
(38975, '92152', 218, 6, 97784, 32.6917, 0.57057780307423, -117.2465, -2.04633746143953),
(38976, '92153', 218, 6, 97784, 32.566, 0.568383924204473, -117.0815, -2.04345766817374),
(38977, '92154', 218, 6, 97784, 32.5755, 0.568549730483413, -117.0151, -2.04229876955042),
(38978, '92155', 218, 6, 97784, 32.6753, 0.570291569076903, -117.1605, -2.04483647828282),
(38979, '92158', 218, 6, 97784, 32.5673, 0.568406613484749, -116.9731, -2.04156573126458),
(38980, '92159', 218, 6, 97784, 32.8092, 0.572628564945324, -117.0301, -2.04256056893822),
(38981, '92160', 218, 6, 97784, 32.7835, 0.572180015327561, -117.0939, -2.04367408900099),
(38982, '92161', 218, 6, 97784, 32.8822, 0.573902655299279, -117.2271, -2.04599886756464),
(38983, '92162', 218, 6, 97784, 32.718, 0.571036824667505, -117.1247, -2.0442116504106),
(38984, '92163', 218, 6, 97784, 32.7481, 0.571562168772355, -117.1682, -2.04497086863522),
(38985, '92164', 218, 6, 97784, 32.7473, 0.571548206138339, -117.1278, -2.04426575561741),
(38986, '92165', 218, 6, 97784, 32.7493, 0.571583112723379, -117.1044, -2.04385734857245),
(38987, '92166', 218, 6, 97784, 32.7212, 0.571092675203569, -117.2302, -2.04605297277146),
(38988, '92167', 218, 6, 97784, 32.7455, 0.571516790211803, -117.2464, -2.04633571611028),
(38989, '92168', 218, 6, 97784, 32.7653, 0.571862365403698, -117.1533, -2.04471081457667),
(38990, '92169', 218, 6, 97784, 32.7993, 0.572455777349376, -117.2518, -2.04642996388989),
(38991, '92170', 218, 6, 97784, 32.697, 0.570670305524586, -117.1336, -2.04436698471403),
(38992, '92171', 218, 6, 97784, 32.7834, 0.572178269998309, -117.1698, -2.04499879390325),
(38993, '92172', 218, 6, 97784, 32.9627, 0.575307645347135, -117.1339, -2.04437222070179),
(38994, '92173', 218, 6, 177682, 32.5561, 0.568211136608526, -117.0321, -2.04259547552326),
(38995, '92174', 218, 6, 97784, 32.7064, 0.570834366474273, -117.0846, -2.04351177338055),
(38996, '92175', 218, 6, 97784, 32.7651, 0.571858874745194, -117.06, -2.04308242238456),
(38997, '92176', 218, 6, 97784, 32.7631, 0.571823968160154, -117.123, -2.04418197981332),
(38998, '92177', 218, 6, 97784, 32.8257, 0.572916544271903, -117.1984, -2.04549795806932),
(38999, '92178', 218, 6, 101079, 32.6843, 0.570448648709583, -117.1775, -2.04513318425566),
(39000, '92179', 218, 6, 97784, 32.5666, 0.568394396179985, -116.9716, -2.0415395513258),
(39001, '92182', 218, 6, 97784, 32.7632, 0.571825713489406, -117.0714, -2.04328138991929),
(39002, '92184', 218, 6, 97784, 32.7182, 0.571040315326009, -117.1668, -2.04494643402569),
(39003, '92186', 218, 6, 97784, 32.7478, 0.571556932784599, -117.2029, -2.04557649788566),
(39004, '92187', 218, 6, 97784, 32.7249, 0.571157252385892, -117.1658, -2.04492898073317),
(39005, '92190', 218, 6, 97784, 32.784, 0.572188741973821, -117.0937, -2.04367059834248),
(39006, '92191', 218, 6, 97784, 32.9029, 0.574263938454442, -117.2184, -2.04584702391972),
(39007, '92192', 218, 6, 97784, 32.8506, 0.573351131255649, -117.2135, -2.04576150278637),
(39008, '92193', 218, 6, 97784, 32.8016, 0.572495919922172, -117.1399, -2.04447694045691),
(39009, '92194', 218, 6, 97784, 32.8018, 0.572499410580676, -117.139, -2.04446123249364),
(39010, '92195', 218, 6, 97784, 32.7437, 0.571485374285267, -117.0524, -2.04294977736141),
(39011, '92196', 218, 6, 97784, 32.9166, 0.574503048561966, -117.1288, -2.04428320890993),
(39012, '92197', 218, 6, 97784, 32.8333, 0.573049189295054, -117.2012, -2.04554682728838),
(39013, '92198', 218, 6, 97784, 32.9966, 0.575899311963561, -117.0733, -2.04331455117508),
(39014, '92199', 218, 6, 97784, 32.9956, 0.575881858671041, -117.0737, -2.04332153249209),
(39015, '92201', 218, 6, 182292, 33.7232, 0.588580874308552, -116.2405, -2.02877944916447),
(39016, '92202', 218, 6, 182292, 33.662, 0.587512732806331, -116.2988, -2.02979697611838),
(39017, '92203', 218, 6, 182292, 33.7439, 0.588942157463714, -116.2277, -2.02855604702021),
(39018, '92210', 218, 6, 178412, 33.7155, 0.588446483956148, -116.3344, -2.03041831333209),
(39019, '92211', 218, 6, 183958, 33.7458, 0.588975318719502, -116.3309, -2.03035722680827),
(39020, '92220', 218, 6, 19043, 33.9319, 0.592223376457464, -116.8852, -2.04003158685208),
(39021, '92222', 218, 6, 7259, 32.7935, 0.57235454825276, -114.5302, -1.99892908296761),
(39022, '92223', 218, 6, 31761, 33.9526, 0.592584659612627, -116.9733, -2.04156922192308),
(39023, '92225', 218, 6, 19370, 33.6109, 0.586620869558562, -114.616, -2.00042657546582),
(39024, '92226', 218, 6, 19370, 33.6078, 0.58656676435175, -114.5855, -1.99989425004396),
(39025, '92227', 218, 6, 7659, 32.9892, 0.575770157598913, -115.5213, -2.01622704118413),
(39026, '92230', 218, 6, 180356, 33.914, 0.591910962521357, -116.7807, -2.03820771778374),
(39027, '92231', 218, 6, 180386, 32.6908, 0.570562095110962, -115.5066, -2.01597047778408),
(39028, '92232', 218, 6, 180386, 32.6792, 0.570359636917731, -115.501, -2.01587273934597),
(39029, '92233', 218, 6, 180401, 33.1326, 0.578272959746273, -115.5104, -2.01603680029566),
(39030, '92234', 218, 6, 180600, 33.8013, 0.589943976454359, -116.4672, -2.03273611057874),
(39031, '92235', 218, 6, 180600, 33.78, 0.589572221323685, -116.4612, -2.03263139082362),
(39032, '92236', 218, 6, 180785, 33.6777, 0.587786749498894, -116.1785, -2.02769734502823),
(39033, '92239', 218, 6, 181116, 33.789, 0.589729300956364, -115.3674, -2.01354097946531),
(39034, '92240', 218, 6, 181120, 33.9428, 0.592413617345931, -116.4745, -2.03286351961414),
(39035, '92241', 218, 6, 181120, 33.9, 0.591666616426078, -116.3903, -2.03139395238396),
(39036, '92242', 218, 6, 181253, 34.1343, 0.5957559228635, -114.3731, -1.99618717071273),
(39037, '92243', 218, 6, 93959, 32.7847, 0.572200959278585, -115.5701, -2.0170787618591),
(39038, '92244', 218, 6, 93959, 32.7933, 0.572351057594257, -115.5774, -2.01720617089449),
(39039, '92249', 218, 6, 142024, 32.7256, 0.571169469690656, -115.4968, -2.01579943551739),
(39040, '92250', 218, 6, 3209, 32.8081, 0.572609366323552, -115.3742, -2.01365966185444),
(39041, '92251', 218, 6, 22138, 32.8481, 0.573307498024349, -115.5867, -2.01736848651493),
(39042, '92252', 218, 6, 182403, 34.159, 0.596187019188743, -116.2951, -2.02973239893606),
(39043, '92253', 218, 6, 182581, 33.6732, 0.587708209682555, -116.2949, -2.02972890827755),
(39044, '92254', 218, 6, 17078, 33.5527, 0.585605087933901, -116.0512, -2.02547554089044),
(39045, '92255', 218, 6, 183958, 33.7471, 0.588998007999778, -116.3648, -2.0309488934247),
(39046, '92256', 218, 6, 183454, 34.0819, 0.594841370335455, -116.5507, -2.03419346050415),
(39047, '92257', 218, 6, 183643, 33.2938, 0.581086430500488, -115.5882, -2.01739466645371),
(39048, '92258', 218, 6, 183695, 33.9226, 0.592061060837028, -116.5485, -2.03415506326061),
(39049, '92259', 218, 6, 178739, 32.7276, 0.571204376275696, -115.9551, -2.02379827947928),
(39050, '92260', 218, 6, 183958, 33.7265, 0.588638470173868, -116.3704, -2.03104663186281),
(39051, '92261', 218, 6, 183958, 33.6178, 0.58674129727695, -116.4284, -2.03205892282897),
(39052, '92262', 218, 6, 17503, 33.8431, 0.590673524081693, -116.5412, -2.03402765422522),
(39053, '92263', 218, 6, 17503, 33.8771, 0.591266936027371, -116.5645, -2.03443431594093),
(39054, '92264', 218, 6, 17503, 33.801, 0.589938740466603, -116.517, -2.03360528454623),
(39055, '92266', 218, 6, 178785, 33.4281, 0.583430407685916, -114.7286, -2.00239181620357),
(39056, '92267', 218, 6, 184008, 34.2976, 0.598606045532007, -114.2236, -1.993577903481),
(39057, '92268', 218, 6, 184144, 34.1852, 0.596644295452766, -116.5167, -2.03360004855848),
(39058, '92270', 218, 6, 184402, 33.7635, 0.589284241997106, -116.4241, -2.03198387367113),
(39059, '92273', 218, 6, 71375, 32.7891, 0.572277753765673, -115.6894, -2.01916093965673),
(39060, '92274', 218, 6, 185626, 33.6095, 0.586596434949034, -116.1621, -2.02741111103091),
(39061, '92275', 218, 6, 184746, 33.6417, 0.587158430968176, -116.1426, -2.02707077182677),
(39062, '92276', 218, 6, 185639, 33.8124, 0.590137708001331, -116.3761, -2.03114611563017),
(39063, '92277', 218, 6, 185788, 34.16, 0.596204472481263, -116.0472, -2.02540572772036),
(39064, '92278', 218, 6, 185788, 34.234, 0.597496016127739, -116.0584, -2.02560120459659),
(39065, '92280', 218, 6, 185933, 34.1918, 0.596759487183397, -114.5535, -1.99933574468332),
(39066, '92281', 218, 6, 186106, 33.035, 0.576569518396327, -115.6135, -2.01783623475446),
(39067, '92282', 218, 6, 6783, 33.9331, 0.592244320408488, -116.6937, -2.03668928133451),
(39068, '92283', 218, 6, 186200, 32.7771, 0.572068314255433, -114.6002, -2.00015081344401),
(39069, '92284', 218, 6, 186290, 34.1754, 0.59647325318607, -116.4301, -2.03208859342625),
(39070, '92285', 218, 6, 9976, 34.2956, 0.598571138946967, -116.4232, -2.03196816570786),
(39071, '92286', 218, 6, 186290, 34.1818, 0.596584954258198, -116.4087, -2.03171509296632),
(39072, '92292', 218, 6, 17503, 33.7761, 0.589504153482857, -116.5287, -2.03380948806872),
(39073, '92301', 218, 6, 179613, 34.5917, 0.603739058862123, -117.4763, -2.05034822806061),
(39074, '92304', 218, 6, 7087, 34.6334, 0.604466861160204, -115.7534, -2.020277950378),
(39075, '92305', 218, 6, 179750, 34.1101, 0.595333553184518, -117.0275, -2.04251519037766),
(39076, '92307', 218, 6, 18883, 34.524, 0.602557470958522, -117.199, -2.04550843004483),
(39077, '92308', 218, 6, 18883, 34.4593, 0.601428242932482, -117.193, -2.04540371028971),
(39078, '92309', 218, 6, 7221, 35.2801, 0.615753905432851, -116.0711, -2.02582286141159),
(39079, '92310', 218, 6, 181648, 35.3436, 0.616862189507868, -116.6165, -2.03534188715197),
(39080, '92311', 218, 6, 44611, 34.887, 0.608893016143262, -117.0347, -2.04264085408381),
(39081, '92312', 218, 6, 44611, 34.9774, 0.610470793787065, -117.059, -2.04306496909204),
(39082, '92313', 218, 6, 181868, 34.0592, 0.594445180595253, -117.3218, -2.04765169436628),
(39083, '92314', 218, 6, 180075, 34.2542, 0.597848572636642, -116.8355, -2.03916415821383),
(39084, '92315', 218, 6, 180076, 34.2444, 0.597677530369946, -116.8879, -2.04007871074188),
(39085, '92316', 218, 6, 29235, 34.0664, 0.594570844301396, -117.396, -2.04894672867126),
(39086, '92317', 218, 6, 71855, 34.2751, 0.598213346450308, -117.2039, -2.04559395117818),
(39087, '92318', 218, 6, 19614, 34.0478, 0.594246213060525, -117.2317, -2.04607915271024),
(39088, '92320', 218, 6, 180404, 33.9916, 0.593265338020905, -117.0426, -2.04277873509472),
(39089, '92321', 218, 6, 180613, 34.2563, 0.597885224550934, -117.1695, -2.0449935579155),
(39090, '92322', 218, 6, 180626, 34.2552, 0.597866025929162, -117.3246, -2.04770056358534),
(39091, '92323', 218, 6, 93249, 35.2379, 0.61501737648851, -115.4979, -2.01581863413916),
(39092, '92324', 218, 6, 93382, 34.0564, 0.594396311376197, -117.3194, -2.04760980646424),
(39093, '92325', 218, 6, 32179, 34.2511, 0.59779446742983, -117.2875, -2.04705304643285),
(39094, '92326', 218, 6, 180944, 34.2433, 0.597658331748174, -117.2035, -2.04558696986117),
(39095, '92327', 218, 6, 8382, 34.8579, 0.608385125330931, -116.8507, -2.03942944826014),
(39096, '92328', 218, 6, 0, 36.4246, 0.635729198721927, -117.0921, -2.04364267307445),
(39097, '92329', 218, 6, 4980, 34.3554, 0.59961484583966, -117.6086, -2.052657298661),
(39098, '92332', 218, 6, 8781, 34.8212, 0.607744589495449, -115.0731, -2.00840447547669),
(39099, '92333', 218, 6, 181546, 34.2677, 0.598084192085661, -116.944, -2.04105784045225),
(39100, '92334', 218, 6, 32455, 34.0718, 0.594665092081004, -117.4691, -2.05022256435447),
(39101, '92335', 218, 6, 32455, 34.0944, 0.595059536491955, -117.4618, -2.05009515531908),
(39102, '92336', 218, 6, 32455, 34.1202, 0.595509831438969, -117.4486, -2.04986477185781),
(39103, '92337', 218, 6, 32455, 34.0435, 0.59417116390269, -117.4864, -2.05052450631507),
(39104, '92338', 218, 6, 37000, 34.9161, 0.609400906955592, -116.3475, -2.0306469514641),
(39105, '92339', 218, 6, 181629, 34.0636, 0.594521975082341, -117.0386, -2.04270892192464),
(39106, '92340', 218, 6, 131291, 34.4184, 0.600714403268416, -117.2782, -2.04689073081241),
(39107, '92341', 218, 6, 181903, 34.241, 0.597618189175378, -117.0742, -2.04333025913835),
(39108, '92342', 218, 6, 182080, 34.7493, 0.606489697763266, -117.3263, -2.04773023418262),
(39109, '92345', 218, 6, 131291, 34.4167, 0.600684732671132, -117.3076, -2.0474038576125),
(39110, '92346', 218, 6, 3108, 34.1274, 0.595635495145113, -117.198, -2.04549097675231),
(39111, '92347', 218, 6, 182159, 34.9394, 0.609807568671307, -117.1944, -2.04542814489924),
(39112, '92350', 218, 6, 55970, 34.0525, 0.594328243535369, -117.2619, -2.04660624214434),
(39113, '92352', 218, 6, 127902, 34.2578, 0.597911404489713, -117.1913, -2.04537403969243),
(39114, '92354', 218, 6, 55970, 34.0505, 0.594293336950329, -117.2493, -2.04638633065859),
(39115, '92356', 218, 6, 182995, 34.4535, 0.601327013835866, -116.92, -2.04063896143177),
(39116, '92357', 218, 6, 55970, 34.0521, 0.594321262218361, -117.2517, -2.04642821856064),
(39117, '92358', 218, 6, 183014, 34.2405, 0.597609462529118, -117.4873, -2.05054021427833),
(39118, '92359', 218, 6, 4169, 34.0733, 0.594691272019784, -117.1024, -2.04382244198741),
(39119, '92363', 218, 6, 183575, 34.8313, 0.607920867749901, -114.6047, -2.00022935326035),
(39120, '92364', 218, 6, 183654, 35.3131, 0.61632986408601, -115.3841, -2.01383244945039),
(39121, '92365', 218, 6, 183611, 34.8724, 0.608638198072471, -116.659, -2.03608365208407),
(39122, '92366', 218, 6, 183497, 35.4728, 0.619117154901444, -115.5287, -2.01635619554877),
(39123, '92368', 218, 6, 183896, 34.6339, 0.604475587806464, -117.3368, -2.04791349375408),
(39124, '92369', 218, 6, 4902, 34.1356, 0.595778612143776, -117.2232, -2.04593079972382),
(39125, '92371', 218, 6, 4980, 34.4763, 0.601724948905321, -117.5338, -2.05135179238051),
(39126, '92372', 218, 6, 184155, 34.4426, 0.601136772947399, -117.6108, -2.05269569590455),
(39127, '92373', 218, 6, 184457, 34.0491, 0.594268902340801, -117.1724, -2.0450441724638),
(39128, '92374', 218, 6, 184457, 34.0642, 0.594532447057852, -117.1655, -2.04492374474542),
(39129, '92375', 218, 6, 184457, 34.0593, 0.594446925924505, -117.1962, -2.04545956082578),
(39130, '92376', 218, 6, 74057, 34.1162, 0.595440018268889, -117.378, -2.0486325694059),
(39131, '92377', 218, 6, 74057, 34.1487, 0.596007250275788, -117.3755, -2.0485889361746),
(39132, '92378', 218, 6, 184540, 34.2143, 0.597152186265096, -117.2425, -2.04626764826945),
(39133, '92382', 218, 6, 184699, 34.2081, 0.597043975851472, -117.1078, -2.04391668976702),
(39134, '92384', 218, 6, 185128, 36.1895, 0.631625929650488, -116.4132, -2.03179363278266),
(39135, '92385', 218, 6, 185182, 34.2339, 0.597494270798487, -117.1841, -2.04524837598629),
(39136, '92386', 218, 6, 138334, 34.2436, 0.59766356773593, -116.8238, -2.03895995469135),
(39137, '92389', 218, 6, 185580, 35.952, 0.627480772677001, -115.8982, -2.02280518713489),
(39138, '92391', 218, 6, 185799, 34.2453, 0.597693238333214, -117.2284, -2.04602155684492),
(39139, '92392', 218, 6, 185932, 34.5105, 0.602321851509503, -117.3184, -2.04759235317172),
(39140, '92393', 218, 6, 185932, 34.4852, 0.601880283208749, -117.3117, -2.04747541611183),
(39141, '92394', 218, 6, 185932, 34.5831, 0.603588960546451, -117.3696, -2.04848596174874),
(39142, '92397', 218, 6, 186247, 34.3684, 0.599841738642419, -117.6096, -2.05267475195352),
(39143, '92398', 218, 6, 186262, 34.9116, 0.609322367139252, -116.8093, -2.03870688194981),
(39144, '92399', 218, 6, 186287, 34.0322, 0.593973941697214, -117.0391, -2.0427176485709),
(39145, '92401', 218, 6, 184770, 34.1054, 0.595251522709674, -117.2914, -2.04712111427368),
(39146, '92402', 218, 6, 184770, 34.0795, 0.594799482433408, -117.4608, -2.05007770202656),
(39147, '92403', 218, 6, 184770, 34.1015, 0.595183454868846, -117.2703, -2.04675284980151),
(39148, '92404', 218, 6, 184770, 34.147, 0.595977579678504, -117.2564, -2.04651024903548),
(39149, '92405', 218, 6, 184770, 34.148, 0.595995032971024, -117.3257, -2.04771976220711),
(39150, '92406', 218, 6, 184770, 34.1347, 0.595762904180508, -117.2895, -2.04708795301789),
(39151, '92407', 218, 6, 184770, 34.1852, 0.596644295452766, -117.3407, -2.04798156159491),
(39152, '92408', 218, 6, 184770, 34.0809, 0.594823917042935, -117.2736, -2.04681044566682),
(39153, '92410', 218, 6, 184770, 34.106, 0.595261994685186, -117.2946, -2.04717696480974),
(39154, '92411', 218, 6, 184770, 34.1233, 0.595563936645781, -117.3228, -2.0476691476588),
(39155, '92412', 218, 6, 184770, 34.086, 0.594912928834787, -117.2609, -2.04658878885182),
(39156, '92413', 218, 6, 184770, 34.1488, 0.59600899560504, -117.2591, -2.04655737292528),
(39157, '92414', 218, 6, 184770, 34.1881, 0.596694910001073, -117.2639, -2.04664114872938),
(39158, '92415', 218, 6, 184770, 34.1274, 0.595635495145113, -117.2671, -2.04669699926544),
(39159, '92418', 218, 6, 184770, 34.1048, 0.595241050734162, -117.2919, -2.04712984091994),
(39160, '92420', 218, 6, 184770, 34.1781, 0.596520377075874, -117.2775, -2.04687851350765),
(39161, '92423', 218, 6, 184770, 34.1079, 0.595295155940974, -117.2886, -2.04707224505462),
(39162, '92424', 218, 6, 184770, 34.1478, 0.59599154231252, -117.3056, -2.04736895102746),
(39163, '92427', 218, 6, 184770, 34.1984, 0.596874678914029, -117.3418, -2.04800076021668),
(39164, '92501', 218, 6, 5423, 33.9938, 0.593303735264448, -117.3677, -2.04845280049295),
(39165, '92502', 218, 6, 5423, 33.9805, 0.593071606473933, -117.3722, -2.04853134030929),
(39166, '92503', 218, 6, 5423, 33.9145, 0.591919689167617, -117.4565, -2.05000265286872),
(39167, '92504', 218, 6, 5423, 33.9145, 0.591919689167617, -117.4076, -2.04914918686449),
(39168, '92505', 218, 6, 5423, 33.9197, 0.592010446288721, -117.4864, -2.05052450631507),
(39169, '92506', 218, 6, 5423, 33.9413, 0.592387437407151, -117.3624, -2.04836029804259),
(39170, '92507', 218, 6, 5423, 33.9782, 0.593031463901137, -117.3307, -2.04780702866971),
(39171, '92508', 218, 6, 5423, 33.8871, 0.59144146895257, -117.3134, -2.04750508670912),
(39172, '92509', 218, 6, 5423, 33.9978, 0.593373548434528, -117.4451, -2.04980368533399),
(39173, '92513', 218, 6, 5423, 33.9152, 0.591931906472381, -117.4594, -2.05005326741703),
(39174, '92514', 218, 6, 5423, 33.946, 0.592469467881995, -117.4153, -2.0492835772169),
(39175, '92515', 218, 6, 5423, 33.9185, 0.591989502337697, -117.4887, -2.05056464888786),
(39176, '92516', 218, 6, 5423, 33.9547, 0.592621311526919, -117.3933, -2.04889960478146),
(39177, '92517', 218, 6, 5423, 33.9642, 0.592787117805858, -117.4342, -2.04961344444553),
(39178, '92518', 218, 6, 0, 33.8958, 0.591593312597494, -117.2675, -2.04670398058245),
(39179, '92519', 218, 6, 5423, 33.9956, 0.593335151190984, -117.4131, -2.04924517997335),
(39180, '92521', 218, 6, 5423, 33.9718, 0.59291976282901, -117.3473, -2.04809675332554),
(39181, '92522', 218, 6, 5423, 33.9401, 0.592366493456127, -117.3974, -2.04897116328079),
(39182, '92530', 218, 6, 182637, 33.6059, 0.586533603095962, -117.3743, -2.04856799222358),
(39183, '92531', 218, 6, 182637, 33.6083, 0.58657549099801, -117.3923, -2.04888215148894),
(39184, '92532', 218, 6, 182637, 33.6621, 0.587514478135583, -117.2779, -2.04688549482466),
(39185, '92536', 218, 6, 179637, 33.4257, 0.583388519783869, -116.8016, -2.03857249159741),
(39186, '92539', 218, 6, 179765, 33.5863, 0.586191518562572, -116.74, -2.03749736877818),
(39187, '92543', 218, 6, 182085, 33.7028, 0.588224827141145, -116.9807, -2.04169837628773),
(39188, '92544', 218, 6, 182085, 33.6519, 0.58733645455188, -116.8994, -2.04027942360586),
(39189, '92545', 218, 6, 182085, 33.7321, 0.588736208611979, -117.0501, -2.04290963478861),
(39190, '92546', 218, 6, 182085, 33.7475, 0.589004989316786, -116.9711, -2.04153082467954),
(39191, '92548', 218, 6, 16482, 33.7588, 0.589202211522262, -117.1057, -2.04388003785272),
(39192, '92549', 218, 6, 182260, 33.7365, 0.588813003099067, -116.6964, -2.03673640522431),
(39193, '92551', 218, 6, 183446, 33.9039, 0.591734684266905, -117.1904, -2.04535833172916),
(39194, '92552', 218, 6, 183446, 33.9245, 0.592094222092816, -117.2472, -2.0463496787443),
(39195, '92553', 218, 6, 183446, 33.9084, 0.591813224083245, -117.2388, -2.04620307108713),
(39196, '92554', 218, 6, 183446, 33.9178, 0.591977285032933, -117.2513, -2.04642123724363),
(39197, '92555', 218, 6, 183446, 33.9158, 0.591942378447893, -117.1664, -2.04493945270868),
(39198, '92556', 218, 6, 183446, 33.9636, 0.592776645830346, -117.2497, -2.0463933119756),
(39199, '92557', 218, 6, 183446, 33.959, 0.592696360684754, -117.2866, -2.04703733846958),
(39200, '92561', 218, 6, 183491, 33.5149, 0.584945353476648, -116.4241, -2.03198387367113),
(39201, '92562', 218, 6, 183527, 33.5418, 0.585414847045434, -117.2865, -2.04703559314033),
(39202, '92563', 218, 6, 183527, 33.5659, 0.585835471395165, -117.1713, -2.04502497384203),
(39203, '92564', 218, 6, 183527, 33.6408, 0.587142723004908, -117.1873, -2.04530422652235),
(39204, '92567', 218, 6, 183730, 33.8341, 0.590516444449013, -117.1085, -2.04392890707178),
(39205, '92570', 218, 6, 184073, 33.7843, 0.58964727048152, -117.3377, -2.04792920171735),
(39206, '92571', 218, 6, 184073, 33.824, 0.590340166194562, -117.2031, -2.04557998854417),
(39207, '92572', 218, 6, 184073, 33.7866, 0.589687413054316, -117.2289, -2.04603028349118),
(39208, '92581', 218, 6, 31063, 33.7836, 0.589635053176756, -116.9577, -2.04129695055977),
(39209, '92582', 218, 6, 31063, 33.8177, 0.590230210451686, -117.0157, -2.04230924152593),
(39210, '92583', 218, 6, 31063, 33.794, 0.589816567418964, -116.9199, -2.04063721610252),
(39211, '92584', 218, 6, 10445, 33.6508, 0.587317255930108, -117.1657, -2.04492723540392),
(39212, '92585', 218, 6, 18219, 33.7469, 0.588994517341274, -117.1712, -2.04502322851278),
(39213, '92586', 218, 6, 18219, 33.7034, 0.588235299116657, -117.2024, -2.0455677712394),
(39214, '92587', 218, 6, 18219, 33.6939, 0.588069492837717, -117.2523, -2.04643869053615),
(39215, '92589', 218, 6, 185585, 33.5149, 0.584945353476648, -117.109, -2.04393763371804);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(39216, '92590', 218, 6, 185585, 33.4809, 0.584351941530969, -117.2259, -2.04597792361362),
(39217, '92591', 218, 6, 185585, 33.5315, 0.585235078132479, -117.1032, -2.04383640462142),
(39218, '92592', 218, 6, 185585, 33.5082, 0.584828416416764, -117.0034, -2.04209456602793),
(39219, '92593', 218, 6, 185585, 33.5033, 0.584742895283416, -117.1547, -2.0447352491862),
(39220, '92595', 218, 6, 186153, 33.5958, 0.586357324841511, -117.2567, -2.04651548502323),
(39221, '92596', 218, 6, 12894, 33.6275, 0.586910594214393, -117.0695, -2.0432482286635),
(39222, '92599', 218, 6, 184073, 33.8319, 0.590478047205469, -117.1976, -2.04548399543531),
(39223, '92602', 218, 6, 16560, 33.7427, 0.588921213512691, -117.7475, -2.05508156099202),
(39224, '92603', 218, 6, 16560, 33.6244, 0.586856489007581, -117.7963, -2.055933281667),
(39225, '92604', 218, 6, 16560, 33.6878, 0.587963027753346, -117.7881, -2.05579016466833),
(39226, '92605', 218, 6, 149768, 33.7152, 0.588441247968392, -118.0086, -2.05963861566898),
(39227, '92606', 218, 6, 16560, 33.6927, 0.588048548886694, -117.8194, -2.05633645272421),
(39228, '92607', 218, 6, 182617, 33.525, 0.585121631731099, -117.7085, -2.05440088258375),
(39229, '92609', 218, 6, 93987, 33.6258, 0.586880923617109, -117.6925, -2.05412162990343),
(39230, '92610', 218, 6, 181621, 33.6728, 0.587701228365547, -117.6641, -2.05362595639586),
(39231, '92612', 218, 6, 16560, 33.6488, 0.587282349345068, -117.8219, -2.05638008595551),
(39232, '92614', 218, 6, 16560, 33.6806, 0.587837364047202, -117.8316, -2.05654938289295),
(39233, '92615', 218, 6, 149768, 33.6576, 0.587435938319243, -117.9675, -2.05892128534641),
(39234, '92616', 218, 6, 16560, 33.6489, 0.58728409467432, -117.8354, -2.05661570540453),
(39235, '92618', 218, 6, 16560, 33.7051, 0.588264969713941, -117.7054, -2.05434677737693),
(39236, '92619', 218, 6, 16560, 33.6696, 0.587645377829483, -117.7643, -2.05537477630636),
(39237, '92620', 218, 6, 16560, 33.7009, 0.588191665885357, -117.7562, -2.05523340463695),
(39238, '92623', 218, 6, 16560, 33.6909, 0.588017132960158, -117.8123, -2.05621253434732),
(39239, '92624', 218, 6, 180518, 33.4598, 0.583983677058799, -117.6638, -2.0536207204081),
(39240, '92625', 218, 6, 180874, 33.6023, 0.586470771242891, -117.864, -2.0571148695706),
(39241, '92626', 218, 6, 180894, 33.6798, 0.587823401413186, -117.9086, -2.05789328641699),
(39242, '92627', 218, 6, 180894, 33.647, 0.587250933418532, -117.9135, -2.05797880755033),
(39243, '92628', 218, 6, 180894, 33.6411, 0.587147958992664, -117.918, -2.05805734736667),
(39244, '92629', 218, 6, 181016, 33.4774, 0.58429085500715, -117.6989, -2.05423333097555),
(39245, '92630', 218, 6, 16779, 33.6411, 0.587147958992664, -117.6852, -2.05399422086803),
(39246, '92637', 218, 6, 182614, 33.6121, 0.586641813509586, -117.7124, -2.05446895042457),
(39247, '92646', 218, 6, 149768, 33.6685, 0.587626179207711, -117.9697, -2.05895968258995),
(39248, '92647', 218, 6, 149768, 33.7227, 0.588572147662292, -118.0039, -2.05955658519414),
(39249, '92648', 218, 6, 149768, 33.6756, 0.587750097584603, -118.0044, -2.0595653118404),
(39250, '92649', 218, 6, 149768, 33.7197, 0.588519787784732, -118.0488, -2.06034023802828),
(39251, '92650', 218, 6, 181267, 33.6761, 0.587758824230862, -117.758, -2.05526482056348),
(39252, '92651', 218, 6, 16762, 33.5414, 0.585407865728426, -117.7794, -2.05563832102341),
(39253, '92652', 218, 6, 16762, 33.5435, 0.585444517642718, -117.7821, -2.05568544491321),
(39254, '92653', 218, 6, 182614, 33.602, 0.586465535255135, -117.7103, -2.05443229851028),
(39255, '92654', 218, 6, 182614, 33.6048, 0.58651440447419, -117.7181, -2.05456843419194),
(39256, '92655', 218, 6, 183267, 33.7438, 0.588940412134463, -117.9828, -2.05918832072197),
(39257, '92656', 218, 6, 179676, 33.5713, 0.585929719174772, -117.7098, -2.05442357186402),
(39258, '92657', 218, 6, 0, 33.5852, 0.5861723199408, -117.8089, -2.05615319315275),
(39259, '92658', 218, 6, 183619, 33.6402, 0.587132251029396, -117.8646, -2.05712534154611),
(39260, '92659', 218, 6, 183619, 33.6211, 0.586798893142266, -117.9234, -2.05815159514628),
(39261, '92660', 218, 6, 183619, 33.6321, 0.586990879359985, -117.8715, -2.0572457692645),
(39262, '92661', 218, 6, 183619, 33.6022, 0.586469025913639, -117.8993, -2.05773097079655),
(39263, '92662', 218, 6, 183619, 33.6046, 0.586510913815686, -117.8926, -2.05761403373667),
(39264, '92663', 218, 6, 183619, 33.6215, 0.586805874459273, -117.9301, -2.05826853220616),
(39265, '92672', 218, 6, 184779, 33.4382, 0.583606685940368, -117.6227, -2.05290339008553),
(39266, '92673', 218, 6, 184779, 33.4606, 0.583997639692815, -117.6357, -2.05313028288829),
(39267, '92674', 218, 6, 184779, 33.4382, 0.583606685940368, -117.6214, -2.05288070080526),
(39268, '92675', 218, 6, 184829, 33.5054, 0.584779547197708, -117.6573, -2.05350727400672),
(39269, '92676', 218, 6, 185166, 33.7466, 0.588989281353518, -117.6158, -2.05278296236715),
(39270, '92677', 218, 6, 182617, 33.5141, 0.584931390842632, -117.7084, -2.05439913725449),
(39271, '92678', 218, 6, 185711, 33.6646, 0.587558111366883, -117.5905, -2.05234139406639),
(39272, '92679', 218, 6, 185711, 33.6406, 0.587139232346404, -117.5874, -2.05228728885958),
(39273, '92683', 218, 6, 13249, 33.7497, 0.58904338656033, -117.9888, -2.05929304047709),
(39274, '92684', 218, 6, 13249, 33.7625, 0.589266788704586, -118.0077, -2.05962290770571),
(39275, '92685', 218, 6, 13249, 33.7528, 0.589097491767142, -117.9943, -2.05938903358595),
(39276, '92688', 218, 6, 184413, 33.6492, 0.587289330662076, -117.5929, -2.05238328196844),
(39277, '92690', 218, 6, 183346, 33.6115, 0.586631341534074, -117.6445, -2.05328387186247),
(39278, '92691', 218, 6, 183346, 33.6139, 0.586673229436122, -117.663, -2.05360675777409),
(39279, '92692', 218, 6, 183346, 33.6167, 0.586722098655178, -117.6422, -2.05324372928967),
(39280, '92693', 218, 6, 184829, 33.4974, 0.584639920857549, -117.6653, -2.05364690034688),
(39281, '92694', 218, 6, 182601, 33.5587, 0.585709807689021, -117.6699, -2.05372718549248),
(39282, '92697', 218, 6, 16560, 33.6486, 0.587278858686564, -117.8402, -2.05669948120862),
(39283, '92698', 218, 6, 179676, 33.6712, 0.587673303097515, -117.8386, -2.05667155594059),
(39284, '92701', 218, 6, 184921, 33.7533, 0.589106218413402, -117.8518, -2.05690193940185),
(39285, '92702', 218, 6, 184921, 33.7376, 0.588832201720839, -117.8736, -2.05728242117879),
(39286, '92703', 218, 6, 184921, 33.7482, 0.58901720662155, -117.9103, -2.05792295701427),
(39287, '92704', 218, 6, 184921, 33.7258, 0.588626252869104, -117.9114, -2.05794215563604),
(39288, '92705', 218, 6, 184921, 33.7548, 0.589132398352182, -117.7895, -2.05581459927786),
(39289, '92706', 218, 6, 184921, 33.7666, 0.589338347203917, -117.884, -2.057463935421),
(39290, '92707', 218, 6, 184921, 33.7102, 0.588353981505792, -117.8734, -2.05727893052028),
(39291, '92708', 218, 6, 47178, 33.7098, 0.588347000188785, -117.9504, -2.05862283404432),
(39292, '92709', 218, 6, 16560, 33.6832, 0.587882742607754, -117.7325, -2.05481976160422),
(39293, '92710', 218, 6, 16560, 33.7048, 0.588259733726185, -117.8407, -2.05670820785488),
(39294, '92711', 218, 6, 184921, 33.7674, 0.589352309837933, -117.8046, -2.05607814399491),
(39295, '92712', 218, 6, 184921, 33.7507, 0.58906083985285, -117.8751, -2.05730860111757),
(39296, '92725', 218, 6, 184921, 33.7454, 0.588968337402494, -117.8669, -2.0571654841189),
(39297, '92728', 218, 6, 47178, 33.7127, 0.588397614737092, -117.9279, -2.05823013496262),
(39298, '92735', 218, 6, 184921, 33.717, 0.588472663894928, -117.8534, -2.05692986466989),
(39299, '92780', 218, 6, 133461, 33.7362, 0.588807767111311, -117.8205, -2.05635565134598),
(39300, '92781', 218, 6, 133461, 33.7379, 0.588837437708595, -117.8174, -2.05630154613917),
(39301, '92782', 218, 6, 133461, 33.7364, 0.588811257769815, -117.7895, -2.05581459927786),
(39302, '92799', 218, 6, 184921, 33.7202, 0.588528514430992, -117.9089, -2.05789852240474),
(39303, '92801', 218, 6, 179737, 33.8451, 0.590708430666733, -117.9533, -2.05867344859263),
(39304, '92802', 218, 6, 179737, 33.8081, 0.590062658843495, -117.9231, -2.05814635915853),
(39305, '92803', 218, 6, 179737, 33.8415, 0.590645598813661, -117.9369, -2.0583872145953),
(39306, '92804', 218, 6, 179737, 33.8178, 0.590231955780938, -117.9745, -2.05904345839405),
(39307, '92805', 218, 6, 179737, 33.8336, 0.590507717802753, -117.908, -2.05788281444147),
(39308, '92806', 218, 6, 179737, 33.8381, 0.590586257619093, -117.8677, -2.05717944675292),
(39309, '92807', 218, 6, 179737, 33.8515, 0.590820131738861, -117.7859, -2.05575176742479),
(39310, '92808', 218, 6, 179737, 33.8598, 0.590964994066776, -117.7537, -2.05518977140565),
(39311, '92809', 218, 6, 179737, 33.8417, 0.590649089472165, -117.936, -2.05837150663203),
(39312, '92811', 218, 6, 7189, 33.8657, 0.591067968492644, -117.83, -2.05652145762492),
(39313, '92812', 218, 6, 179737, 33.8178, 0.590231955780938, -117.9269, -2.0582126816701),
(39314, '92814', 218, 6, 179737, 33.8177, 0.590230210451686, -117.96, -2.05879038565251),
(39315, '92815', 218, 6, 179737, 33.8336, 0.590507717802753, -117.9128, -2.05796659024557),
(39316, '92816', 218, 6, 179737, 33.8401, 0.590621164204133, -117.8847, -2.05747615272576),
(39317, '92817', 218, 6, 179737, 33.8524, 0.590835839702129, -117.7923, -2.05586346849692),
(39318, '92821', 218, 6, 180234, 33.9297, 0.59218497921392, -117.8879, -2.05753200326182),
(39319, '92822', 218, 6, 180234, 33.9181, 0.591982521020689, -117.8903, -2.05757389116387),
(39320, '92823', 218, 6, 180234, 33.9238, 0.592082004788052, -117.8008, -2.05601182148334),
(39321, '92825', 218, 6, 179737, 33.8349, 0.590530407083029, -117.9132, -2.05797357156258),
(39322, '92831', 218, 6, 2627, 33.8863, 0.591427506318554, -117.8946, -2.05764894032171),
(39323, '92832', 218, 6, 2627, 33.8658, 0.591069713821896, -117.9278, -2.05822838963337),
(39324, '92833', 218, 6, 2627, 33.8765, 0.591256464051859, -117.9582, -2.05875896972598),
(39325, '92834', 218, 6, 2627, 33.879, 0.591300097283159, -117.8975, -2.05769955487001),
(39326, '92835', 218, 6, 2627, 33.9016, 0.59169454169411, -117.9065, -2.05785663450269),
(39327, '92836', 218, 6, 2627, 33.874, 0.591212830820559, -117.9035, -2.05780427462513),
(39328, '92837', 218, 6, 2627, 33.8706, 0.591153489625991, -117.9648, -2.05887416145661),
(39329, '92838', 218, 6, 2627, 33.8918, 0.591523499427414, -117.9308, -2.05828074951093),
(39330, '92840', 218, 6, 16176, 33.7869, 0.589692649042072, -117.9287, -2.05824409759664),
(39331, '92841', 218, 6, 16176, 33.7808, 0.5895861839577, -117.9764, -2.05907661964984),
(39332, '92842', 218, 6, 16176, 33.7794, 0.589561749348173, -117.9489, -2.05859665410554),
(39333, '92843', 218, 6, 16176, 33.7651, 0.589312167265137, -117.9299, -2.05826504154766),
(39334, '92844', 218, 6, 16176, 33.7672, 0.589348819179429, -117.9734, -2.05902425977228),
(39335, '92845', 218, 6, 16176, 33.7819, 0.589605382579472, -118.0265, -2.05995102960509),
(39336, '92846', 218, 6, 16176, 33.7864, 0.589683922395812, -118.0355, -2.06010810923777),
(39337, '92850', 218, 6, 179737, 33.8448, 0.590703194678977, -117.9526, -2.05866123128786),
(39338, '92856', 218, 6, 4797, 33.7854, 0.589666469103292, -117.8453, -2.05678849300047),
(39339, '92857', 218, 6, 4797, 33.8343, 0.590519935107517, -117.8482, -2.05683910754878),
(39340, '92859', 218, 6, 4797, 33.8004, 0.589928268491091, -117.789, -2.0558058726316),
(39341, '92860', 218, 6, 42305, 33.9196, 0.592008700959469, -117.5595, -2.05180034199827),
(39342, '92861', 218, 6, 121817, 33.8181, 0.590237191768694, -117.8101, -2.05617413710377),
(39343, '92862', 218, 6, 4797, 33.7913, 0.58976944352916, -117.7157, -2.05452654628989),
(39344, '92863', 218, 6, 4797, 33.8151, 0.590184831891135, -117.8277, -2.05648131505212),
(39345, '92864', 218, 6, 4797, 33.8148, 0.590179595903379, -117.8282, -2.05649004169838),
(39346, '92865', 218, 6, 4797, 33.8283, 0.590415215352398, -117.8492, -2.0568565608413),
(39347, '92866', 218, 6, 4797, 33.7871, 0.589696139700576, -117.8445, -2.05677453036646),
(39348, '92867', 218, 6, 4797, 33.81, 0.590095820099283, -117.8471, -2.05681990892701),
(39349, '92868', 218, 6, 4797, 33.7883, 0.5897170836516, -117.8779, -2.05735747033662),
(39350, '92869', 218, 6, 4797, 33.7898, 0.58974326359038, -117.7949, -2.05590884705747),
(39351, '92870', 218, 6, 184156, 33.8726, 0.591188396211031, -117.8544, -2.0569473179624),
(39352, '92871', 218, 6, 184156, 33.8807, 0.591329767880443, -117.856, -2.05697524323044),
(39353, '92877', 218, 6, 1779, 33.875, 0.591230284113079, -117.5652, -2.05189982576564),
(39354, '92878', 218, 6, 1779, 33.8756, 0.591240756088591, -117.5654, -2.05190331642414),
(39355, '92879', 218, 6, 1779, 33.8799, 0.591315805246427, -117.5347, -2.05136750034378),
(39356, '92880', 218, 6, 1779, 33.9237, 0.5920802594588, -117.6124, -2.05272362117258),
(39357, '92881', 218, 6, 1779, 33.8519, 0.590827113055868, -117.4725, -2.05028190554904),
(39358, '92882', 218, 6, 1779, 33.8308, 0.590458848583698, -117.6104, -2.05268871458754),
(39359, '92883', 218, 6, 1779, 33.7598, 0.589219664814782, -117.4894, -2.05057686619263),
(39360, '92885', 218, 6, 186269, 33.8914, 0.591516518110406, -117.8201, -2.05634867002897),
(39361, '92886', 218, 6, 186269, 33.9058, 0.591767845522693, -117.788, -2.05578841933908),
(39362, '92887', 218, 6, 186269, 33.8832, 0.591373401111743, -117.7308, -2.05479009100694),
(39363, '92899', 218, 6, 179737, 33.8389, 0.590600220253109, -117.872, -2.05725449591076),
(39364, '93001', 218, 6, 98786, 34.293, 0.598525760386415, -119.2936, -2.08206609655711),
(39365, '93002', 218, 6, 98786, 34.2793, 0.598286650278892, -119.289, -2.08198581141152),
(39366, '93003', 218, 6, 98786, 34.271, 0.598141787950977, -119.2166, -2.08072219303307),
(39367, '93004', 218, 6, 98786, 34.2794, 0.598288395608144, -119.168, -2.0798739630166),
(39368, '93005', 218, 6, 98786, 34.2505, 0.597783995454318, -119.2059, -2.08053544280311),
(39369, '93006', 218, 6, 98786, 34.2785, 0.598272687644876, -119.292, -2.08203817128908),
(39370, '93007', 218, 6, 98786, 34.2919, 0.598506561764643, -119.1574, -2.07968895811589),
(39371, '93009', 218, 6, 98786, 34.2674, 0.598078956097905, -119.2125, -2.08065063453374),
(39372, '93010', 218, 6, 180416, 34.2314, 0.597450637567187, -119.0223, -2.07733101829645),
(39373, '93011', 218, 6, 180416, 34.2167, 0.597194074167144, -119.037, -2.07758758169649),
(39374, '93012', 218, 6, 180416, 34.2272, 0.597377333738603, -118.9766, -2.07653340282829),
(39375, '93013', 218, 6, 180553, 34.4006, 0.600403734661561, -119.5173, -2.08597039809382),
(39376, '93014', 218, 6, 180553, 34.395, 0.60030599622345, -119.5129, -2.08589360360673),
(39377, '93015', 218, 6, 27166, 34.3999, 0.600391517356797, -118.9133, -2.07542860941177),
(39378, '93016', 218, 6, 27166, 34.4004, 0.600400244003057, -118.9128, -2.07541988276551),
(39379, '93020', 218, 6, 183436, 34.2851, 0.598387879375508, -118.8812, -2.07486835872188),
(39380, '93021', 218, 6, 183436, 34.2804, 0.598305848900664, -118.8863, -2.07495737051373),
(39381, '93022', 218, 6, 82700, 34.4017, 0.600422933283333, -119.2973, -2.08213067373943),
(39382, '93023', 218, 6, 183800, 34.446, 0.601196114141967, -119.2531, -2.08135923821005),
(39383, '93024', 218, 6, 183800, 34.4414, 0.601115828996375, -119.2593, -2.08146744862367),
(39384, '93030', 218, 6, 183926, 34.2151, 0.597166148899112, -119.1759, -2.08001184402751),
(39385, '93031', 218, 6, 183926, 34.2203, 0.597256906020216, -119.1797, -2.08007816653909),
(39386, '93032', 218, 6, 183926, 34.2008, 0.596916566816077, -119.1779, -2.08004675061255),
(39387, '93033', 218, 6, 183926, 34.1691, 0.596363297443195, -119.1636, -2.07979716852951),
(39388, '93034', 218, 6, 183926, 34.1761, 0.596485470490834, -119.1765, -2.08002231600302),
(39389, '93035', 218, 6, 183926, 34.1801, 0.596555283660914, -119.2184, -2.08075360895961),
(39390, '93036', 218, 6, 183926, 34.2148, 0.597160912911356, -119.1762, -2.08001708001527),
(39391, '93040', 218, 6, 184147, 34.4225, 0.600785961767748, -118.786, -2.07320680527398),
(39392, '93041', 218, 6, 184234, 34.1619, 0.596237633737051, -119.1903, -2.0802631714398),
(39393, '93042', 218, 6, 0, 34.1234, 0.595565681975033, -119.0938, -2.07857892871162),
(39394, '93043', 218, 6, 0, 34.1624, 0.596246360383311, -119.2002, -2.08043595903574),
(39395, '93044', 218, 6, 184234, 34.1547, 0.596111970030907, -119.1915, -2.08028411539082),
(39396, '93060', 218, 6, 184951, 34.3572, 0.599646261766196, -119.0722, -2.07820193759319),
(39397, '93061', 218, 6, 184951, 34.3541, 0.599592156559384, -119.0586, -2.07796457281492),
(39398, '93062', 218, 6, 185170, 34.2878, 0.598435003265312, -118.7435, -2.07246504034189),
(39399, '93063', 218, 6, 185170, 34.2798, 0.598295376925152, -118.6998, -2.07170233145877),
(39400, '93064', 218, 6, 0, 34.283, 0.598351227461216, -118.6898, -2.07152779853357),
(39401, '93065', 218, 6, 185170, 34.2669, 0.598070229451645, -118.7677, -2.07288741002087),
(39402, '93066', 218, 6, 185235, 34.2728, 0.598173203877512, -119.0118, -2.07714775872499),
(39403, '93067', 218, 6, 61923, 34.4212, 0.600763272487472, -119.5947, -2.08732128293486),
(39404, '93093', 218, 6, 185170, 34.2721, 0.598160986572749, -118.7125, -2.07192398827377),
(39405, '93094', 218, 6, 185170, 34.2704, 0.598131315975465, -118.7958, -2.07337784754068),
(39406, '93099', 218, 6, 185170, 34.2631, 0.598003906940069, -118.7518, -2.0726099026698),
(39407, '93101', 218, 6, 184928, 34.4195, 0.600733601890188, -119.7072, -2.08928477834336),
(39408, '93102', 218, 6, 184928, 34.4205, 0.600751055182708, -119.7079, -2.08929699564812),
(39409, '93103', 218, 6, 184928, 34.4304, 0.600923842778656, -119.6807, -2.08882226609158),
(39410, '93105', 218, 6, 184928, 34.4467, 0.601208331446731, -119.7432, -2.08991309687407),
(39411, '93106', 218, 6, 184928, 34.4327, 0.600963985351451, -119.8349, -2.09151356379815),
(39412, '93107', 218, 6, 184928, 34.4203, 0.600747564524204, -119.8609, -2.09196734940367),
(39413, '93108', 218, 6, 184928, 34.4339, 0.600984929302475, -119.6326, -2.08798276272137),
(39414, '93109', 218, 6, 184928, 34.4042, 0.600466566514633, -119.7219, -2.0895413417434),
(39415, '93110', 218, 6, 184928, 34.4388, 0.601070450435823, -119.7684, -2.09035291984558),
(39416, '93111', 218, 6, 184928, 34.4431, 0.601145499593659, -119.8019, -2.09093760514499),
(39417, '93116', 218, 6, 181846, 34.4903, 0.6019692950006, -120.0401, -2.09509497942325),
(39418, '93117', 218, 6, 181846, 34.4377, 0.601051251814051, -119.8682, -2.09209475843907),
(39419, '93118', 218, 6, 181846, 34.4361, 0.601023326546019, -119.8263, -2.09136346548248),
(39420, '93120', 218, 6, 184928, 34.4199, 0.600740583207196, -119.709, -2.08931619426989),
(39421, '93121', 218, 6, 184928, 34.4193, 0.600730111231684, -119.7092, -2.0893196849284),
(39422, '93130', 218, 6, 184928, 34.4403, 0.601096630374603, -119.734, -2.08975252658289),
(39423, '93140', 218, 6, 184928, 34.4213, 0.600765017816724, -119.6762, -2.08874372627524),
(39424, '93150', 218, 6, 184928, 34.4357, 0.601016345229011, -119.6415, -2.0881380970248),
(39425, '93160', 218, 6, 184928, 34.4346, 0.600997146607239, -119.8029, -2.09095505843751),
(39426, '93190', 218, 6, 184928, 34.4233, 0.600799924401764, -119.7039, -2.08922718247804),
(39427, '93199', 218, 6, 181846, 34.4904, 0.601971040329852, -120.0398, -2.09508974343549),
(39428, '93201', 218, 6, 179691, 35.96, 0.627620399017161, -119.4559, -2.08489876593309),
(39429, '93202', 218, 6, 84712, 36.3122, 0.633767448642685, -119.7091, -2.08931793959914),
(39430, '93203', 218, 6, 179832, 35.2151, 0.614619441419055, -118.8528, -2.07437268521432),
(39431, '93204', 218, 6, 179878, 36.0056, 0.62841626915607, -120.1299, -2.09666228509154),
(39432, '93205', 218, 6, 126908, 35.5818, 0.621019563786118, -118.4809, -2.06788180572615),
(39433, '93206', 218, 6, 180352, 35.4014, 0.617870989815521, -119.4443, -2.08469630773986),
(39434, '93207', 218, 6, 180396, 35.905, 0.626660467928564, -118.7228, -2.07210375718672),
(39435, '93208', 218, 6, 180442, 36.1399, 0.630760246341499, -118.6099, -2.07013328046122),
(39436, '93210', 218, 6, 180786, 36.1681, 0.631252429190561, -120.3614, -2.1007027223099),
(39437, '93212', 218, 6, 1765, 36.0959, 0.629992301470621, -119.5712, -2.08691113056064),
(39438, '93215', 218, 6, 72302, 35.7718, 0.624335689364908, -119.245, -2.08121786654064),
(39439, '93216', 218, 6, 72302, 35.7563, 0.624065163330848, -119.2768, -2.08177288124277),
(39440, '93218', 218, 6, 181213, 35.8895, 0.626389941894505, -119.0961, -2.07861907128442),
(39441, '93219', 218, 6, 181252, 35.8848, 0.626307911419661, -119.2777, -2.08178858920604),
(39442, '93220', 218, 6, 15893, 35.3285, 0.616598644790817, -118.8589, -2.07447915029869),
(39443, '93221', 218, 6, 27125, 36.3004, 0.63356149979095, -119.1277, -2.07917059532805),
(39444, '93222', 218, 6, 181681, 34.8484, 0.608219319051992, -119.1642, -2.07980764050503),
(39445, '93223', 218, 6, 2418, 36.301, 0.633571971766462, -119.2064, -2.08054416944937),
(39446, '93224', 218, 6, 181555, 35.2053, 0.61444839915236, -119.5524, -2.08658300866127),
(39447, '93225', 218, 6, 181681, 34.8314, 0.607922613079153, -119.0389, -2.07762074295228),
(39448, '93226', 218, 6, 21431, 35.7292, 0.623592179103558, -118.693, -2.07158364906963),
(39449, '93227', 218, 6, 419, 36.3476, 0.634385295197891, -119.4137, -2.08416223698875),
(39450, '93230', 218, 6, 60167, 36.3293, 0.634065899944776, -119.6429, -2.08816253163432),
(39451, '93232', 218, 6, 60167, 36.2326, 0.632378166558097, -119.7076, -2.08929175966036),
(39452, '93234', 218, 6, 30131, 36.1866, 0.63157531510218, -120.0956, -2.0960636371581),
(39453, '93235', 218, 6, 3375, 36.3699, 0.634774503621086, -119.2093, -2.08059478399768),
(39454, '93237', 218, 6, 182427, 36.4696, 0.636514596885324, -118.9172, -2.0754966772526),
(39455, '93238', 218, 6, 163309, 35.7521, 0.623991859502265, -118.4257, -2.06691838397905),
(39456, '93239', 218, 6, 182465, 36.0247, 0.628749627043201, -119.9769, -2.09399193133598),
(39457, '93240', 218, 6, 182642, 35.6269, 0.621806707278768, -118.4424, -2.06720985396413),
(39458, '93241', 218, 6, 9971, 35.2563, 0.615338517070877, -118.9138, -2.07543733605803),
(39459, '93242', 218, 6, 33003, 36.4374, 0.635952600866182, -119.7142, -2.089406951391),
(39460, '93243', 218, 6, 182753, 34.8521, 0.608283896234316, -118.8898, -2.07501845703755),
(39461, '93244', 218, 6, 0, 36.3803, 0.634956017863293, -119.0237, -2.07735545290597),
(39462, '93245', 218, 6, 182771, 36.3058, 0.633655747570557, -119.7934, -2.09078925215858),
(39463, '93246', 218, 6, 182771, 36.2901, 0.633381730877994, -119.848, -2.09174220193016),
(39464, '93247', 218, 6, 41807, 36.2092, 0.631969759513131, -119.0859, -2.07844104770072),
(39465, '93249', 218, 6, 182977, 35.6556, 0.62230761677409, -119.7709, -2.09039655307688),
(39466, '93250', 218, 6, 33228, 35.6791, 0.622717769148309, -119.2253, -2.080874036678),
(39467, '93251', 218, 6, 56180, 35.471, 0.619085738974909, -119.6735, -2.08869660238543),
(39468, '93252', 218, 6, 178592, 35.0589, 0.61189323712744, -119.4016, -2.08395105214926),
(39469, '93254', 218, 6, 183607, 34.942, 0.609852947231859, -119.6654, -2.08855523071602),
(39470, '93255', 218, 6, 10989, 35.7002, 0.62308603362048, -118.1916, -2.06283256820013),
(39471, '93256', 218, 6, 33633, 35.9717, 0.627824602539644, -119.2903, -2.08200850069179),
(39472, '93257', 218, 6, 28307, 36.0698, 0.629536770535851, -119.0205, -2.07729960236991),
(39473, '93258', 218, 6, 28307, 36.0661, 0.629472193353527, -119.1319, -2.07924389915663),
(39474, '93260', 218, 6, 11345, 35.8055, 0.62492386532283, -118.6287, -2.0704614023606),
(39475, '93261', 218, 6, 184524, 35.7969, 0.624773767007158, -119.1061, -2.07879360420962),
(39476, '93262', 218, 6, 0, 36.5976, 0.638748618327877, -118.839, -2.07413182977754),
(39477, '93263', 218, 6, 28572, 35.4939, 0.619485419373615, -119.287, -2.08195090482648),
(39478, '93265', 218, 6, 6035, 36.1188, 0.630391981869328, -118.8302, -2.07397824080337),
(39479, '93266', 218, 6, 14683, 36.1808, 0.631474086005564, -119.8178, -2.09121511249606),
(39480, '93267', 218, 6, 51758, 36.1455, 0.63085798477961, -119.0674, -2.0781181617891),
(39481, '93268', 218, 6, 6212, 35.1713, 0.613854987206682, -119.4281, -2.08441356440104),
(39482, '93270', 218, 6, 185599, 35.9616, 0.627648324285193, -119.0405, -2.07764866822031),
(39483, '93271', 218, 6, 62020, 36.4441, 0.636069537926065, -118.8901, -2.07502369302531),
(39484, '93272', 218, 6, 12332, 36.0589, 0.629346529647383, -119.3104, -2.08235931187144),
(39485, '93274', 218, 6, 171445, 36.2084, 0.631955796879115, -119.3401, -2.08287767465929),
(39486, '93275', 218, 6, 171445, 36.2085, 0.631957542208367, -119.3432, -2.0829317798661),
(39487, '93276', 218, 6, 185775, 35.2896, 0.615919711711791, -119.3387, -2.08285324004976),
(39488, '93277', 218, 6, 38706, 36.3131, 0.633783156605953, -119.3087, -2.08232964127416),
(39489, '93278', 218, 6, 38706, 36.309, 0.633711598106621, -119.3143, -2.08242737971227),
(39490, '93279', 218, 6, 38706, 36.3292, 0.634064154615524, -119.292, -2.08203817128908),
(39491, '93280', 218, 6, 121863, 35.5892, 0.621148718150766, -119.3373, -2.08282880544023),
(39492, '93282', 218, 6, 186040, 36.1488, 0.630915580644926, -119.5043, -2.08574350529106),
(39493, '93283', 218, 6, 635, 35.6326, 0.621906191046131, -118.2873, -2.06450284829429),
(39494, '93285', 218, 6, 186209, 35.7123, 0.623297218459971, -118.4754, -2.06778581261729),
(39495, '93286', 218, 6, 26207, 36.4218, 0.635680329502871, -119.0981, -2.07865397786946),
(39496, '93287', 218, 6, 29032, 35.6994, 0.623072070986464, -118.8148, -2.07370946009856),
(39497, '93290', 218, 6, 38706, 36.3302, 0.634081607908044, -119.2911, -2.08202246332581),
(39498, '93291', 218, 6, 38706, 36.3401, 0.634254395503991, -119.3025, -2.08222143086053),
(39499, '93292', 218, 6, 38706, 36.3316, 0.634106042517572, -119.2567, -2.08142207006312),
(39500, '93301', 218, 6, 44555, 35.3831, 0.617551594562406, -119.0074, -2.0770709642379),
(39501, '93302', 218, 6, 44555, 35.3755, 0.617418949539254, -119.0201, -2.0772926210529),
(39502, '93303', 218, 6, 44555, 35.5528, 0.62051341830304, -118.9198, -2.07554205581315),
(39503, '93304', 218, 6, 44555, 35.3477, 0.6169337480072, -119.0252, -2.07738163284475),
(39504, '93305', 218, 6, 44555, 35.3873, 0.617624898390989, -118.984, -2.07666255719293),
(39505, '93306', 218, 6, 44555, 35.3889, 0.617652823659021, -118.9325, -2.07576371262816),
(39506, '93307', 218, 6, 44555, 35.3174, 0.616404913243845, -118.9748, -2.07650198690175),
(39507, '93308', 218, 6, 44555, 35.4193, 0.618183403751628, -119.0425, -2.07768357480535),
(39508, '93309', 218, 6, 44555, 35.3375, 0.616755724423496, -119.0679, -2.07812688843536),
(39509, '93311', 218, 6, 44555, 35.29, 0.615926693028799, -119.1171, -2.07898559042734),
(39510, '93312', 218, 6, 44555, 35.3865, 0.617610935756973, -119.17, -2.07990886960164),
(39511, '93313', 218, 6, 44555, 35.254, 0.615298374498081, -119.0622, -2.07802740466799),
(39512, '93380', 218, 6, 44555, 35.553, 0.620516908961544, -118.9207, -2.07555776377642),
(39513, '93381', 218, 6, 44555, 35.3841, 0.617569047854926, -119.0188, -2.07726993177263),
(39514, '93382', 218, 6, 44555, 35.26, 0.615403094253201, -119.0019, -2.07697497112904),
(39515, '93383', 218, 6, 44555, 35.267, 0.61552526730084, -119.0325, -2.07750904188015),
(39516, '93384', 218, 6, 44555, 35.3728, 0.61737182564945, -119.0177, -2.07725073315086),
(39517, '93385', 218, 6, 44555, 35.3782, 0.617466073429058, -118.9906, -2.07677774892356),
(39518, '93386', 218, 6, 44555, 35.3764, 0.617434657502522, -118.9542, -2.07614244907584),
(39519, '93387', 218, 6, 44555, 35.354, 0.617043703750075, -118.9598, -2.07624018751395),
(39520, '93388', 218, 6, 44555, 35.4183, 0.618165950459108, -119.0205, -2.07729960236991),
(39521, '93389', 218, 6, 44555, 35.3538, 0.617040213091571, -119.062, -2.07802391400949),
(39522, '93390', 218, 6, 44555, 35.358, 0.617113516920155, -119.005, -2.07702907633585),
(39523, '93401', 218, 6, 184846, 35.2606, 0.615413566228712, -120.6538, -2.10580606504273),
(39524, '93402', 218, 6, 182959, 35.3142, 0.616349062707782, -120.83, -2.10888133518475),
(39525, '93403', 218, 6, 184846, 35.2826, 0.615797538664151, -120.6584, -2.10588635018833),
(39526, '93405', 218, 6, 184846, 35.2753, 0.615670129628756, -120.6902, -2.10644136489046),
(39527, '93406', 218, 6, 184846, 35.2455, 0.615150021511661, -120.6406, -2.10557568158147),
(39528, '93407', 218, 6, 184846, 35.2982, 0.616069810027462, -120.6596, -2.10590729413935),
(39529, '93408', 218, 6, 184846, 35.2206, 0.614715434527915, -120.6348, -2.10547445248486),
(39530, '93409', 218, 6, 184846, 35.221, 0.614722415844923, -120.6347, -2.1054727071556),
(39531, '93410', 218, 6, 184846, 35.2753, 0.615670129628756, -120.7389, -2.10729134023618),
(39532, '93412', 218, 6, 182959, 35.3028, 0.616150095173054, -120.8215, -2.10873298219833),
(39533, '93420', 218, 6, 179821, 35.1178, 0.612921236056865, -120.5641, -2.1042405047037),
(39534, '93421', 218, 6, 179821, 35.1217, 0.612989303897692, -120.5767, -2.10446041618945),
(39535, '93422', 218, 6, 179850, 35.4804, 0.619249799924596, -120.671, -2.10610626167408),
(39536, '93423', 218, 6, 179850, 35.4862, 0.619351029021212, -120.6449, -2.10565073073931),
(39537, '93424', 218, 6, 179881, 35.1865, 0.614120277252985, -120.7261, -2.10706793809193),
(39538, '93426', 218, 6, 694, 35.755, 0.624042474050573, -120.9765, -2.11143824253892),
(39539, '93427', 218, 6, 180306, 34.6246, 0.604313272186029, -120.2549, -2.09884394665653),
(39540, '93428', 218, 6, 26686, 35.5577, 0.620598939436388, -121.0837, -2.11330923549706),
(39541, '93429', 218, 6, 180584, 34.8368, 0.608016860858761, -120.5317, -2.10367501802605),
(39542, '93430', 218, 6, 180608, 35.445, 0.61863195336939, -120.884, -2.10982381298083),
(39543, '93432', 218, 6, 35429, 35.4929, 0.619467966081095, -120.4945, -2.10302575554431),
(39544, '93433', 218, 6, 181941, 35.1197, 0.612954397312653, -120.6175, -2.10517251052426),
(39545, '93434', 218, 6, 94639, 34.9608, 0.610181069131234, -120.5711, -2.10436267775134),
(39546, '93435', 218, 6, 745, 35.5119, 0.619799578638974, -121.008, -2.1119880212533),
(39547, '93436', 218, 6, 182894, 34.6527, 0.604803709705839, -120.4349, -2.10198553931012),
(39548, '93437', 218, 6, 182894, 34.7455, 0.60642337525169, -120.5161, -2.10340274666274),
(39549, '93438', 218, 6, 182894, 34.6397, 0.60457681690308, -120.468, -2.10256324329253),
(39550, '93440', 218, 6, 182922, 34.7464, 0.606439083214958, -120.3009, -2.09964679811245),
(39551, '93441', 218, 6, 182957, 34.6687, 0.605082962386158, -120.1103, -2.09632020055815),
(39552, '93442', 218, 6, 183457, 35.3844, 0.617574283842682, -120.8468, -2.10917455049908),
(39553, '93443', 218, 6, 183457, 35.3676, 0.617281068528347, -120.8496, -2.10922341971814),
(39554, '93444', 218, 6, 183652, 35.033, 0.611441196851173, -120.4941, -2.1030187742273),
(39555, '93445', 218, 6, 183784, 35.1033, 0.612668163315325, -120.6116, -2.10506953609839),
(39556, '93446', 218, 6, 184025, 35.6365, 0.621974258886959, -120.6939, -2.10650594207278),
(39557, '93447', 218, 6, 184025, 35.6589, 0.622365212639406, -120.698, -2.10657750057212),
(39558, '93448', 218, 6, 184150, 35.1431, 0.613362804357619, -120.6404, -2.10557219092297),
(39559, '93449', 218, 6, 184150, 35.1492, 0.613469269441991, -120.6499, -2.10573799720191),
(39560, '93450', 218, 6, 184763, 36.022, 0.628702503153397, -120.905, -2.11019033212374),
(39561, '93451', 218, 6, 179068, 35.7439, 0.623848742503601, -120.6569, -2.10586017024955),
(39562, '93452', 218, 6, 184887, 35.5519, 0.620497710339772, -120.9484, -2.11094780501911),
(39563, '93453', 218, 6, 97862, 35.3677, 0.617282813857599, -120.3928, -2.10125075569503),
(39564, '93454', 218, 6, 17980, 34.9449, 0.609903561780166, -120.39, -2.10120188647597),
(39565, '93455', 218, 6, 17980, 34.8844, 0.60884763758271, -120.4292, -2.10188605554276),
(39566, '93456', 218, 6, 17980, 34.9387, 0.609795351366543, -120.4644, -2.10250041143946),
(39567, '93457', 218, 6, 17980, 34.9528, 0.610041442791074, -120.4352, -2.10199077529787),
(39568, '93458', 218, 6, 17980, 34.9531, 0.61004667877883, -120.4349, -2.10198553931012),
(39569, '93460', 218, 6, 184969, 34.6381, 0.604548891635048, -120.0741, -2.09568839136892),
(39570, '93461', 218, 6, 74268, 35.5652, 0.620729839130287, -120.2943, -2.09953160638181),
(39571, '93463', 218, 6, 185232, 34.6253, 0.604325489490793, -120.1156, -2.0964127030085),
(39572, '93464', 218, 6, 185232, 34.5574, 0.603140410928688, -120.1414, -2.09686299795552),
(39573, '93465', 218, 6, 91273, 35.5438, 0.62035633867036, -120.6955, -2.10653386734082),
(39574, '93483', 218, 6, 181941, 35.1222, 0.612998030543952, -120.6203, -2.10522137974332),
(39575, '93501', 218, 6, 183368, 35.0239, 0.611282371889242, -118.1754, -2.06254982486131),
(39576, '93502', 218, 6, 183368, 35.057, 0.611860075871652, -118.1736, -2.06251840893477),
(39577, '93504', 218, 6, 180394, 35.1458, 0.613409928247423, -118.0107, -2.05967526758327),
(39578, '93505', 218, 6, 180394, 35.1331, 0.61318827143242, -117.9571, -2.0587397711042),
(39579, '93510', 218, 6, 29062, 34.4844, 0.601866320574733, -118.2183, -2.06329857111041),
(39580, '93512', 218, 6, 358, 37.8096, 0.659902008862048, -118.6708, -2.07119618597569),
(39581, '93513', 218, 6, 13381, 37.1776, 0.648871527989444, -118.3022, -2.06476290235284),
(39582, '93514', 218, 6, 812, 37.3608, 0.652068971179097, -118.4162, -2.06675257770011),
(39583, '93515', 218, 6, 812, 37.3612, 0.652075952496105, -118.3997, -2.06646459837353),
(39584, '93516', 218, 6, 180194, 35.0063, 0.610975193940891, -117.6567, -2.05349680203121),
(39585, '93517', 218, 6, 1130, 38.2323, 0.667279515610228, -119.2757, -2.081753682621),
(39586, '93518', 218, 6, 180390, 35.3872, 0.617623153061737, -118.4678, -2.06765316759414),
(39587, '93519', 218, 6, 180501, 35.3062, 0.616209436367622, -117.9558, -2.05871708182393),
(39588, '93522', 218, 6, 26915, 35.6281, 0.621827651229792, -117.6702, -2.05373242148023),
(39589, '93523', 218, 6, 8695, 34.9534, 0.610051914766586, -117.9021, -2.05777984001561),
(39590, '93524', 218, 6, 8695, 34.923, 0.60952133467398, -117.9473, -2.05856872883751),
(39591, '93526', 218, 6, 3320, 36.8314, 0.642829198119039, -118.2334, -2.06356211582746),
(39592, '93527', 218, 6, 182308, 35.6863, 0.622843432854452, -117.832, -2.05655636420996),
(39593, '93528', 218, 6, 131505, 35.37, 0.617322956430394, -117.6361, -2.0531372642053),
(39594, '93529', 218, 6, 182411, 37.8146, 0.659989275324648, -119.0063, -2.07705176561613),
(39595, '93530', 218, 6, 32903, 36.4886, 0.636846209443203, -117.8733, -2.05727718519103),
(39596, '93531', 218, 6, 16697, 35.235, 0.614966761940202, -118.6049, -2.07004601399862),
(39597, '93532', 218, 6, 182641, 34.6726, 0.605151030226986, -118.4254, -2.06691314799129),
(39598, '93534', 218, 6, 16841, 34.7133, 0.605861379232548, -118.1489, -2.06208731260953),
(39599, '93535', 218, 6, 16841, 34.7126, 0.605849161927784, -117.9039, -2.05781125594214),
(39600, '93536', 218, 6, 16841, 34.7785, 0.606999333904848, -118.469, -2.06767411154516),
(39601, '93539', 218, 6, 16841, 34.7371, 0.606276767594522, -118.6428, -2.07070749378513),
(39602, '93541', 218, 6, 182755, 37.9607, 0.662539201361812, -119.1051, -2.0787761509171),
(39603, '93542', 218, 6, 131801, 35.9358, 0.627198029338178, -117.9049, -2.05782870923466),
(39604, '93543', 218, 6, 182842, 34.5216, 0.602515583056474, -117.9511, -2.05863505134908),
(39605, '93544', 218, 6, 95760, 34.49, 0.601964059012844, -117.7851, -2.05573780479077),
(39606, '93545', 218, 6, 10167, 36.5861, 0.638547905463897, -118.0582, -2.06050429897797),
(39607, '93546', 218, 6, 183065, 37.64, 0.656941930450666, -118.9774, -2.0765473654623),
(39608, '93549', 218, 6, 183805, 36.2527, 0.632728977737748, -117.994, -2.05938379759819),
(39609, '93550', 218, 6, 17514, 34.5771, 0.603484240791331, -118.0948, -2.0611430894842),
(39610, '93551', 218, 6, 17514, 34.6017, 0.603913591787322, -118.1895, -2.06279591628584),
(39611, '93552', 218, 6, 17514, 34.5597, 0.603180553501484, -118.0423, -2.0602267916269),
(39612, '93553', 218, 6, 184046, 34.4706, 0.601625465137957, -117.8966, -2.05768384690675),
(39613, '93554', 218, 6, 184434, 35.373, 0.617375316307954, -117.6636, -2.0536172297496),
(39614, '93555', 218, 6, 11586, 35.6246, 0.621766564705972, -117.6882, -2.05404658074559),
(39615, '93556', 218, 6, 11586, 35.6226, 0.621731658120932, -117.6697, -2.05372369483397),
(39616, '93558', 218, 6, 68124, 35.3535, 0.617034977103815, -117.6246, -2.05293655134132),
(39617, '93560', 218, 6, 24517, 34.862, 0.608456683830263, -118.2593, -2.06401415610373),
(39618, '93561', 218, 6, 185581, 35.1371, 0.6132580846025, -118.5253, -2.06865673191404),
(39619, '93562', 218, 6, 185755, 35.7547, 0.624037238062817, -117.386, -2.04877219574606),
(39620, '93563', 218, 6, 185889, 34.4223, 0.600782471109244, -117.8394, -2.05668551857461),
(39621, '93581', 218, 6, 185581, 35.1316, 0.61316209149364, -118.4465, -2.06728141246346),
(39622, '93584', 218, 6, 16841, 34.6987, 0.605606561161756, -118.1392, -2.06191801567208),
(39623, '93586', 218, 6, 16841, 34.6475, 0.604712952584735, -118.2191, -2.06331253374443),
(39624, '93590', 218, 6, 17514, 34.5786, 0.603510420730111, -118.0868, -2.06100346314404),
(39625, '93591', 218, 6, 17514, 34.6027, 0.603931045079842, -117.8298, -2.05651796696641),
(39626, '93592', 218, 6, 185755, 35.7629, 0.62418035506148, -117.3715, -2.04851912300452),
(39627, '93596', 218, 6, 180194, 35.0049, 0.610950759331363, -117.6501, -2.05338161030058),
(39628, '93599', 218, 6, 17514, 34.579, 0.603517402047119, -118.1152, -2.06149913665161),
(39629, '93601', 218, 6, 179639, 37.3835, 0.6524651609193, -119.7196, -2.0895011991706),
(39630, '93602', 218, 6, 179863, 37.0758, 0.647094782810914, -119.4544, -2.08487258599431),
(39631, '93603', 218, 6, 31716, 36.5853, 0.638533942829881, -119.0159, -2.07721931722432),
(39632, '93604', 218, 6, 122194, 37.3163, 0.65129229966196, -119.5489, -2.08652192213745),
(39633, '93605', 218, 6, 707, 37.2101, 0.649438759996342, -119.2432, -2.0811864506141),
(39634, '93606', 218, 6, 180101, 36.8026, 0.642326543294465, -120.0175, -2.09470053501229),
(39635, '93607', 218, 6, 180338, 36.4805, 0.636704837773791, -119.9775, -2.0940024033115),
(39636, '93608', 218, 6, 180502, 36.5166, 0.637334901633761, -120.3489, -2.1004845561534),
(39637, '93609', 218, 6, 180562, 36.5365, 0.637682222154908, -119.845, -2.0916898420526),
(39638, '93610', 218, 6, 180710, 37.11, 0.647691685415096, -120.2607, -2.09894517575314),
(39639, '93611', 218, 6, 180781, 36.8428, 0.643028165653767, -119.6513, -2.08830913929149),
(39640, '93612', 218, 6, 180781, 36.8297, 0.642799527521756, -119.6676, -2.08859362795957),
(39641, '93613', 218, 6, 180781, 36.7987, 0.642258475453637, -119.6395, -2.08810319043976),
(39642, '93614', 218, 6, 180787, 37.2127, 0.649484138556894, -119.7308, -2.08969667604683),
(39643, '93615', 218, 6, 15698, 36.5278, 0.637530378509985, -119.2964, -2.08211496577616),
(39644, '93616', 218, 6, 181087, 36.659, 0.639820250488601, -119.5844, -2.08714151402191),
(39645, '93618', 218, 6, 181153, 36.544, 0.637813121848808, -119.3883, -2.08371892335875),
(39646, '93620', 218, 6, 181189, 37.0218, 0.646152305014837, -120.6431, -2.10561931481277),
(39647, '93621', 218, 6, 8626, 36.7337, 0.641124011439841, -119.1049, -2.07877266025859),
(39648, '93622', 218, 6, 181577, 36.8275, 0.642761130278212, -120.538, -2.10378497376892),
(39649, '93623', 218, 6, 181580, 37.48, 0.654149403647475, -119.6383, -2.08808224648873),
(39650, '93624', 218, 6, 2458, 36.3976, 0.635257959823888, -120.1268, -2.09660817988472),
(39651, '93625', 218, 6, 2578, 36.6257, 0.639239055847687, -119.6702, -2.08863900652012),
(39652, '93626', 218, 6, 181705, 36.9893, 0.645585073007939, -119.6918, -2.08901599763855),
(39653, '93627', 218, 6, 27409, 36.575, 0.638354173916926, -120.0817, -2.09582103639207),
(39654, '93628', 218, 6, 109, 36.7851, 0.642021110675366, -118.9133, -2.07542860941177),
(39655, '93630', 218, 6, 182455, 36.7393, 0.641221749877953, -120.0756, -2.0957145713077),
(39656, '93631', 218, 6, 81888, 36.5192, 0.637380280194313, -119.5558, -2.08664234985584),
(39657, '93633', 218, 6, 0, 36.7337, 0.641124011439841, -118.955, -2.07615641170985),
(39658, '93634', 218, 6, 36786, 37.1167, 0.647808622474979, -119.2907, -2.0820154820088),
(39659, '93635', 218, 6, 182930, 37.0541, 0.646716046363231, -120.852, -2.10926530762019),
(39660, '93637', 218, 6, 164112, 36.9575, 0.645030058305804, -120.0687, -2.09559414358932),
(39661, '93638', 218, 6, 164112, 36.9758, 0.645349453558919, -120.0057, -2.09449458616056),
(39662, '93639', 218, 6, 164112, 36.9613, 0.64509638081738, -120.0816, -2.09581929106282),
(39663, '93640', 218, 6, 104190, 36.7299, 0.641057688928265, -120.3905, -2.10121061312223),
(39664, '93641', 218, 6, 183322, 36.6903, 0.640366538544475, -119.0357, -2.07756489241621),
(39665, '93642', 218, 6, 183391, 37.2696, 0.650477230901279, -119.1263, -2.07914616071852),
(39666, '93643', 218, 6, 56566, 37.2329, 0.649836695065797, -119.4999, -2.08566671080397),
(39667, '93644', 218, 6, 4709, 37.3389, 0.651686744072911, -119.6455, -2.08820791019488),
(39668, '93645', 218, 6, 183734, 37.0976, 0.647475264587848, -119.719, -2.08949072719509),
(39669, '93646', 218, 6, 183871, 36.6255, 0.639235565189183, -119.3217, -2.08255653407692),
(39670, '93647', 218, 6, 183899, 36.5503, 0.637923077591683, -119.2611, -2.08149886455021),
(39671, '93648', 218, 6, 184018, 36.6157, 0.639064522922488, -119.5319, -2.08622521616461),
(39672, '93649', 218, 6, 178860, 36.8255, 0.642726223693172, -119.3545, -2.08312900207157),
(39673, '93650', 218, 6, 8997, 36.8412, 0.643000240385735, -119.7999, -2.09090269855995),
(39674, '93651', 218, 6, 24121, 37.0004, 0.64577880455491, -119.5243, -2.08609257114146),
(39675, '93652', 218, 6, 97314, 36.608, 0.638930132570084, -119.8737, -2.09219075154793),
(39676, '93653', 218, 6, 24225, 37.3189, 0.651337678222512, -120.0069, -2.09451553011158),
(39677, '93654', 218, 6, 184479, 36.6107, 0.638977256459888, -119.4357, -2.08454620942419),
(39678, '93656', 218, 6, 5416, 36.4381, 0.635964818170946, -119.9097, -2.09281907007864),
(39679, '93657', 218, 6, 97847, 36.7314, 0.641083868867045, -119.5155, -2.08593898216728),
(39680, '93660', 218, 6, 184811, 36.6128, 0.63901390837418, -120.1763, -2.09747211786446),
(39681, '93661', 218, 6, 184956, 37.11, 0.647691685415096, -120.596, -2.10479726473508),
(39682, '93662', 218, 6, 5731, 36.5437, 0.637807885861052, -119.6411, -2.08813111570779),
(39683, '93664', 218, 6, 185092, 37.0956, 0.647440358002808, -119.3017, -2.08220746822652),
(39684, '93665', 218, 6, 185271, 36.9655, 0.645169684645964, -120.6522, -2.1057781397747),
(39685, '93666', 218, 6, 185441, 36.5449, 0.637828829812076, -119.338, -2.08284102274499),
(39686, '93667', 218, 6, 185679, 36.9857, 0.645522241154867, -119.3936, -2.0838114258091),
(39687, '93668', 218, 6, 91403, 36.6464, 0.63960033900285, -120.2589, -2.09891375982661),
(39688, '93669', 218, 6, 0, 37.2604, 0.650316660610095, -119.5373, -2.08631946394422),
(39689, '93670', 218, 6, 186263, 36.482, 0.636731017712571, -119.2241, -2.08085309272697),
(39690, '93673', 218, 6, 185737, 36.4551, 0.636261524143785, -119.4843, -2.08539443944066),
(39691, '93675', 218, 6, 185346, 36.7064, 0.640647536554047, -119.1812, -2.08010434647787),
(39692, '93701', 218, 6, 8997, 36.7495, 0.641399773461656, -119.7875, -2.09068627773271),
(39693, '93702', 218, 6, 8997, 36.7406, 0.641244439158229, -119.7586, -2.09018187757888),
(39694, '93703', 218, 6, 8997, 36.7687, 0.641734876678039, -119.7621, -2.0902429641027),
(39695, '93704', 218, 6, 8997, 36.7997, 0.642275928746157, -119.7989, -2.09088524526743),
(39696, '93705', 218, 6, 8997, 36.7916, 0.642134557076746, -119.8305, -2.09143676931106),
(39697, '93706', 218, 6, 8997, 36.7014, 0.640560270091447, -119.8408, -2.09161653822402),
(39698, '93707', 218, 6, 8997, 36.7334, 0.641118775452085, -119.7842, -2.09062868186739),
(39699, '93708', 218, 6, 8997, 36.7334, 0.641118775452085, -119.7842, -2.09062868186739),
(39700, '93709', 218, 6, 8997, 36.7337, 0.641124011439841, -119.7839, -2.09062344587964),
(39701, '93710', 218, 6, 8997, 36.8259, 0.64273320501018, -119.7599, -2.09020456685916),
(39702, '93711', 218, 6, 8997, 36.8203, 0.642635466572068, -119.8433, -2.09166017145532),
(39703, '93712', 218, 6, 8997, 36.6131, 0.639019144361936, -119.775, -2.09046811157621),
(39704, '93714', 218, 6, 8997, 36.733, 0.641111794135077, -119.7837, -2.09061995522113),
(39705, '93715', 218, 6, 8997, 36.7336, 0.641122266110589, -119.7838, -2.09062170055038),
(39706, '93716', 218, 6, 8997, 36.7335, 0.641120520781337, -119.7842, -2.09062868186739),
(39707, '93717', 218, 6, 8997, 36.7371, 0.641183352634409, -119.7888, -2.09070896701298),
(39708, '93718', 218, 6, 8997, 36.7333, 0.641117030122833, -119.7837, -2.09061995522113),
(39709, '93720', 218, 6, 8997, 36.8612, 0.643349306236134, -119.7657, -2.09030579595577),
(39710, '93721', 218, 6, 8997, 36.7348, 0.641143210061613, -119.7832, -2.09061122857487),
(39711, '93722', 218, 6, 8997, 36.7924, 0.642148519710762, -119.8859, -2.09240368171667),
(39712, '93724', 218, 6, 8997, 36.7251, 0.64097391312417, -119.7957, -2.09082939473137),
(39713, '93725', 218, 6, 8997, 36.6663, 0.639947659523997, -119.739, -2.08983979304549),
(39714, '93726', 218, 6, 8997, 36.7904, 0.642113613125722, -119.7634, -2.09026565338298),
(39715, '93727', 218, 6, 8997, 36.7537, 0.64147307729024, -119.6972, -2.08911024541816),
(39716, '93728', 218, 6, 8997, 36.7585, 0.641556853094336, -119.8153, -2.09117147926476),
(39717, '93729', 218, 6, 8997, 36.8519, 0.643186990615698, -119.7674, -2.09033546655306),
(39718, '93740', 218, 6, 8997, 36.8239, 0.64269829842514, -119.7603, -2.09021154817616),
(39719, '93741', 218, 6, 8997, 36.7993, 0.642268947429149, -119.7999, -2.09090269855995),
(39720, '93744', 218, 6, 8997, 36.7588, 0.641562089082092, -119.7992, -2.09089048125519),
(39721, '93745', 218, 6, 8997, 36.7057, 0.640635319249283, -119.7534, -2.09009112045778),
(39722, '93747', 218, 6, 8997, 36.8036, 0.642343996586985, -119.6791, -2.08879434082355),
(39723, '93750', 218, 6, 8997, 36.8398, 0.642975805776207, -119.7886, -2.09070547635448),
(39724, '93755', 218, 6, 8997, 36.7895, 0.642097905162454, -119.7901, -2.09073165629326),
(39725, '93760', 218, 6, 8997, 36.7359, 0.641162408683385, -119.7807, -2.09056759534357),
(39726, '93761', 218, 6, 8997, 36.7505, 0.641417226754176, -119.788, -2.09069500437897),
(39727, '93762', 218, 6, 8997, 36.6392, 0.639474675296706, -119.9048, -2.0927335489453),
(39728, '93764', 218, 6, 8997, 36.7356, 0.641157172695629, -119.7825, -2.09059901127011),
(39729, '93765', 218, 6, 8997, 36.8353, 0.642897265959867, -119.8313, -2.09145073194508),
(39730, '93771', 218, 6, 8997, 36.7496, 0.641401518790908, -119.7892, -2.09071594832999),
(39731, '93772', 218, 6, 8997, 36.7492, 0.6413945374739, -119.7897, -2.09072467497625),
(39732, '93773', 218, 6, 8997, 36.7191, 0.64086919336905, -119.8589, -2.09193244281863),
(39733, '93774', 218, 6, 8997, 36.7496, 0.641401518790908, -119.79, -2.09072991096401),
(39734, '93775', 218, 6, 8997, 36.7353, 0.641151936707873, -119.75, -2.09003177926321),
(39735, '93776', 218, 6, 8997, 36.7496, 0.641401518790908, -119.788, -2.09069500437897),
(39736, '93777', 218, 6, 8997, 36.7491, 0.641392792144648, -119.7893, -2.09071769365924),
(39737, '93778', 218, 6, 8997, 36.7493, 0.641396282803152, -119.7891, -2.09071420300074),
(39738, '93779', 218, 6, 8997, 36.7495, 0.641399773461656, -119.7897, -2.09072467497625),
(39739, '93780', 218, 6, 8997, 36.8585, 0.64330218234633, -119.7856, -2.09065311647692),
(39740, '93784', 218, 6, 8997, 36.8248, 0.642714006388408, -119.7637, -2.09027088937073),
(39741, '93786', 218, 6, 8997, 36.6394, 0.63947816595521, -119.905, -2.0927370396038),
(39742, '93790', 218, 6, 8997, 36.7878, 0.64206823456517, -119.8282, -2.09139662673827),
(39743, '93791', 218, 6, 8997, 36.788, 0.642071725223674, -119.8284, -2.09140011739677),
(39744, '93792', 218, 6, 8997, 36.7848, 0.64201587468761, -119.8289, -2.09140884404303),
(39745, '93793', 218, 6, 8997, 36.7871, 0.642056017260406, -119.8286, -2.09140360805528),
(39746, '93794', 218, 6, 8997, 36.7885, 0.642080451869934, -119.8287, -2.09140535338453),
(39747, '93844', 218, 6, 8997, 36.7532, 0.64146435064398, -119.6748, -2.08871929166571),
(39748, '93888', 218, 6, 8997, 36.7532, 0.64146435064398, -119.6771, -2.08875943423851),
(39749, '93901', 218, 6, 184738, 36.6681, 0.639979075450533, -121.6559, -2.12329600947697),
(39750, '93902', 218, 6, 184738, 36.6732, 0.640068087242385, -121.6569, -2.12331346276949),
(39751, '93905', 218, 6, 184738, 36.6798, 0.640183278973016, -121.6177, -2.12262929370271),
(39752, '93906', 218, 6, 184738, 36.7121, 0.64074702032141, -121.6401, -2.12302024745515),
(39753, '93907', 218, 6, 184738, 36.7792, 0.641918136249498, -121.6652, -2.1234583250974),
(39754, '93908', 218, 6, 184738, 36.607, 0.638912679277564, -121.6575, -2.123323934745),
(39755, '93912', 218, 6, 184738, 36.7395, 0.641225240536457, -121.6821, -2.12375328574099),
(39756, '93915', 218, 6, 184738, 36.6801, 0.640188514960772, -121.6259, -2.12277241070137),
(39757, '93920', 218, 6, 180089, 36.1369, 0.630707886463939, -121.6565, -2.12330648145248),
(39758, '93921', 218, 6, 7911, 36.5657, 0.638191858296491, -121.8992, -2.12754239554707),
(39759, '93922', 218, 6, 7911, 36.4898, 0.636867153394227, -121.7479, -2.1249017123888),
(39760, '93923', 218, 6, 7911, 36.5385, 0.637717128739948, -121.8857, -2.12730677609805),
(39761, '93924', 218, 6, 180538, 36.4756, 0.636619316640444, -121.7205, -2.12442349217376),
(39762, '93925', 218, 6, 180715, 36.5917, 0.638645643902009, -121.467, -2.11999908251995),
(39763, '93926', 218, 6, 41120, 36.5172, 0.637345373609273, -121.4295, -2.11934458405045),
(39764, '93927', 218, 6, 2861, 36.3091, 0.633713343435873, -121.3213, -2.1174561377998),
(39765, '93928', 218, 6, 182395, 36.0487, 0.62916850606368, -121.2018, -2.11537046934366),
(39766, '93930', 218, 6, 22375, 36.1997, 0.631803953234191, -121.1356, -2.11421506137884),
(39767, '93932', 218, 6, 16930, 35.9469, 0.62739176088515, -121.1925, -2.11520815372323),
(39768, '93933', 218, 6, 183102, 36.6841, 0.640258328130852, -121.793, -2.12568885588145),
(39769, '93940', 218, 6, 4284, 36.5942, 0.638689277133309, -121.8745, -2.12711129922183),
(39770, '93942', 218, 6, 4284, 36.6149, 0.639050560288472, -121.8989, -2.12753715955932),
(39771, '93943', 218, 6, 4284, 36.579, 0.638423987087006, -121.8317, -2.12636429830198),
(39772, '93944', 218, 6, 4284, 36.5792, 0.63842747774551, -121.832, -2.12636953428973),
(39773, '93950', 218, 6, 183944, 36.6185, 0.639113392141544, -121.9196, -2.12789844271448),
(39774, '93953', 218, 6, 71247, 36.5796, 0.638434459062518, -121.9468, -2.12837317227102),
(39775, '93954', 218, 6, 184845, 36.1278, 0.630549061502007, -121.0197, -2.11219222477578),
(39776, '93955', 218, 6, 18021, 36.609, 0.638947585862604, -121.8368, -2.12645331009383);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(39777, '93960', 218, 6, 185226, 36.4138, 0.635540703162711, -121.3175, -2.11738981528822),
(39778, '93962', 218, 6, 185328, 36.6243, 0.639214621238159, -121.6468, -2.12313718451504),
(39779, '94002', 218, 6, 303, 37.5168, 0.654791684812209, -122.2941, -2.1344347007632),
(39780, '94003', 218, 6, 303, 37.7055, 0.658085121110722, -122.4073, -2.13641041347646),
(39781, '94005', 218, 6, 118910, 37.6894, 0.657804123101151, -122.4055, -2.13637899754992),
(39782, '94010', 218, 6, 26656, 37.5703, 0.655725435962026, -122.3636, -2.13564770459333),
(39783, '94011', 218, 6, 26656, 37.5778, 0.655856335655925, -122.3452, -2.13532656401097),
(39784, '94012', 218, 6, 26656, 37.59, 0.656069265824669, -122.3631, -2.13563897794707),
(39785, '94013', 218, 6, 181015, 37.7203, 0.658343429840017, -122.5262, -2.13848560995708),
(39786, '94014', 218, 6, 181015, 37.6977, 0.657948985429066, -122.4628, -2.13737907121131),
(39787, '94015', 218, 6, 181015, 37.676, 0.657570248981384, -122.4823, -2.13771941041545),
(39788, '94016', 218, 6, 181015, 37.708, 0.658128754342022, -122.4545, -2.1372342088834),
(39789, '94017', 218, 6, 181015, 37.6925, 0.657858228307963, -122.4711, -2.13752393353923),
(39790, '94018', 218, 6, 181353, 37.5048, 0.654582245301969, -122.4707, -2.13751695222222),
(39791, '94019', 218, 6, 181986, 37.4956, 0.654421675010786, -122.4094, -2.13644706539075),
(39792, '94020', 218, 6, 182549, 37.2837, 0.65072332232581, -122.2265, -2.13325485818885),
(39793, '94021', 218, 6, 182880, 37.2419, 0.649993774698476, -122.2554, -2.13375925834268),
(39794, '94022', 218, 6, 182925, 37.3661, 0.652161473629453, -122.1125, -2.13126518284158),
(39795, '94023', 218, 6, 182925, 37.3744, 0.652306335957369, -122.1153, -2.13131405206063),
(39796, '94024', 218, 6, 182925, 37.3528, 0.651929344838938, -122.0879, -2.13083583184559),
(39797, '94025', 218, 6, 145732, 37.4594, 0.653789865821564, -122.168, -2.13223384057643),
(39798, '94026', 218, 6, 145732, 37.4781, 0.654116242391687, -122.1815, -2.13246946002545),
(39799, '94027', 218, 6, 29125, 37.4561, 0.653732269956248, -122.2046, -2.13287263108266),
(39800, '94028', 218, 6, 184247, 37.3801, 0.652405819724732, -122.2112, -2.13298782281329),
(39801, '94029', 218, 6, 145732, 37.4783, 0.654119733050191, -122.1786, -2.13241884547714),
(39802, '94030', 218, 6, 183275, 37.6001, 0.65624554407912, -122.4008, -2.13629696707508),
(39803, '94031', 218, 6, 183275, 37.5996, 0.65623681743286, -122.4006, -2.13629347641657),
(39804, '94035', 218, 6, 4440, 37.4105, 0.652936399817339, -122.0527, -2.13022147594888),
(39805, '94037', 218, 6, 178667, 37.5409, 0.655212309161939, -122.5064, -2.13814003476518),
(39806, '94038', 218, 6, 183465, 37.5469, 0.655317028917059, -122.4983, -2.13799866309577),
(39807, '94039', 218, 6, 4440, 37.3931, 0.652632712527492, -122.0767, -2.13064035496936),
(39808, '94040', 218, 6, 4440, 37.3779, 0.652367422481188, -122.0821, -2.13073460274897),
(39809, '94041', 218, 6, 4440, 37.3886, 0.652554172711152, -122.0756, -2.13062115634759),
(39810, '94042', 218, 6, 4440, 37.4093, 0.652915455866315, -122.0889, -2.1308532851381),
(39811, '94043', 218, 6, 4440, 37.4056, 0.652850878683991, -122.078, -2.13066304424964),
(39812, '94044', 218, 6, 183943, 37.6016, 0.6562717240179, -122.486, -2.13778398759777),
(39813, '94045', 218, 6, 183943, 37.6111, 0.656437530296839, -122.4759, -2.13760770934332),
(39814, '94059', 218, 6, 184463, 37.5159, 0.654775976848941, -122.2055, -2.13288833904593),
(39815, '94060', 218, 6, 184078, 37.2085, 0.64941083472831, -122.3807, -2.13594615589542),
(39816, '94061', 218, 6, 184463, 37.4631, 0.653854443003888, -122.2326, -2.13336132327322),
(39817, '94062', 218, 6, 184463, 37.4195, 0.653093479450018, -122.2873, -2.13431601837406),
(39818, '94063', 218, 6, 184463, 37.491, 0.654341389865194, -122.2046, -2.13287263108266),
(39819, '94064', 218, 6, 184463, 37.4635, 0.653861424320896, -122.255, -2.13375227702567),
(39820, '94065', 218, 6, 184463, 37.5321, 0.655058720187764, -122.249, -2.13364755727055),
(39821, '94066', 218, 6, 184776, 37.6246, 0.656673149745859, -122.4308, -2.13682056585067),
(39822, '94067', 218, 6, 184776, 37.6246, 0.656673149745859, -122.437, -2.1369287762643),
(39823, '94070', 218, 6, 97779, 37.4965, 0.654437382974054, -122.2718, -2.13404549234),
(39824, '94071', 218, 6, 97779, 37.4976, 0.654456581595826, -122.2679, -2.13397742449917),
(39825, '94074', 218, 6, 184806, 37.2972, 0.650958941774829, -122.3648, -2.13566864854436),
(39826, '94080', 218, 6, 185293, 37.6525, 0.657160096607165, -122.4296, -2.13679962189965),
(39827, '94083', 218, 6, 185293, 37.6454, 0.657036178230273, -122.4111, -2.13647673598803),
(39828, '94085', 218, 6, 57792, 37.3689, 0.652210342848509, -122.0358, -2.1299265153053),
(39829, '94086', 218, 6, 57792, 37.3762, 0.652337751883905, -122.0214, -2.12967518789301),
(39830, '94087', 218, 6, 57792, 37.3502, 0.651883966278386, -122.0328, -2.12987415542774),
(39831, '94088', 218, 6, 57792, 37.3937, 0.652643184503004, -122.0367, -2.12994222326856),
(39832, '94089', 218, 6, 57792, 37.4011, 0.652772338867651, -122.0079, -2.12943956844399),
(39833, '94090', 218, 6, 57792, 37.3854, 0.652498322175088, -122.0255, -2.12974674639234),
(39834, '94096', 218, 6, 184776, 37.6409, 0.656957638413934, -122.4173, -2.13658494640165),
(39835, '94098', 218, 6, 184776, 37.6253, 0.656685367050623, -122.4285, -2.13678042327788),
(39836, '94099', 218, 6, 185293, 37.7404, 0.658694241019668, -122.3837, -2.13599851577298),
(39837, '94101', 218, 6, 184792, 37.7747, 0.659292888953102, -122.4187, -2.13660938101118),
(39838, '94102', 218, 6, 184792, 37.7802, 0.659388882061962, -122.4176, -2.13659018238941),
(39839, '94103', 218, 6, 184792, 37.7743, 0.659285907636094, -122.4099, -2.13645579203701),
(39840, '94104', 218, 6, 184792, 37.7916, 0.659587849596689, -122.4008, -2.13629696707508),
(39841, '94105', 218, 6, 184792, 37.7885, 0.659533744389877, -122.3948, -2.13619224731996),
(39842, '94106', 218, 6, 184792, 37.7891, 0.659544216365389, -122.396, -2.13621319127098),
(39843, '94107', 218, 6, 184792, 37.7678, 0.659172461234714, -122.3942, -2.13618177534444),
(39844, '94108', 218, 6, 184792, 37.7919, 0.659593085584445, -122.407, -2.1364051774887),
(39845, '94109', 218, 6, 184792, 37.7934, 0.659619265523225, -122.419, -2.13661461699894),
(39846, '94110', 218, 6, 184792, 37.7489, 0.658842594006087, -122.4136, -2.13652036921933),
(39847, '94111', 218, 6, 184792, 37.7979, 0.659697805339565, -122.399, -2.13626555114854),
(39848, '94112', 218, 6, 184792, 37.7202, 0.658341684510765, -122.4409, -2.13699684410513),
(39849, '94114', 218, 6, 184792, 37.7578, 0.658997928309515, -122.4364, -2.13691830428879),
(39850, '94115', 218, 6, 184792, 37.7858, 0.659486620500073, -122.4362, -2.13691481363028),
(39851, '94116', 218, 6, 184792, 37.7445, 0.658765799519, -122.4829, -2.13772988239096),
(39852, '94117', 218, 6, 184792, 37.7698, 0.659207367819754, -122.4409, -2.13699684410513),
(39853, '94118', 218, 6, 184792, 37.7818, 0.659416807329994, -122.4594, -2.13731973001674),
(39854, '94119', 218, 6, 184792, 37.7858, 0.659486620500073, -122.4544, -2.13723246355414),
(39855, '94120', 218, 6, 184792, 37.7929, 0.659610538876965, -122.4031, -2.13633710964787),
(39856, '94121', 218, 6, 184792, 37.7788, 0.659364447452434, -122.4911, -2.13787299938963),
(39857, '94122', 218, 6, 184792, 37.7615, 0.659062505491839, -122.4804, -2.13768624915966),
(39858, '94123', 218, 6, 184792, 37.8002, 0.659737947912361, -122.435, -2.13689386967926),
(39859, '94124', 218, 6, 184792, 37.7333, 0.658570322642776, -122.3907, -2.13612068882062),
(39860, '94125', 218, 6, 184792, 37.7312, 0.658533670728484, -122.3867, -2.13605087565054),
(39861, '94126', 218, 6, 184792, 37.7952, 0.659650681449761, -122.3928, -2.13615734073492),
(39862, '94127', 218, 6, 184792, 37.7354, 0.658606974557068, -122.458, -2.13729529540722),
(39863, '94128', 218, 6, 184792, 37.6093, 0.656406114370303, -122.3874, -2.13606309295531),
(39864, '94129', 218, 6, 184792, 37.7975, 0.659690824022557, -122.4623, -2.13737034456505),
(39865, '94130', 218, 6, 184792, 37.8205, 0.660092249750516, -122.3691, -2.13574369770219),
(39866, '94131', 218, 6, 184792, 37.7433, 0.658744855567976, -122.4395, -2.1369724094956),
(39867, '94132', 218, 6, 184792, 37.7236, 0.658401025705333, -122.4788, -2.13765832389163),
(39868, '94133', 218, 6, 184792, 37.8007, 0.65974667455862, -122.4088, -2.13643659341524),
(39869, '94134', 218, 6, 184792, 37.721, 0.658355647144781, -122.4091, -2.13644182940299),
(39870, '94135', 218, 6, 184792, 37.7313, 0.658535416057736, -122.3863, -2.13604389433354),
(39871, '94136', 218, 6, 184792, 37.7402, 0.658690750361164, -122.3826, -2.13597931715121),
(39872, '94137', 218, 6, 184792, 37.7922, 0.659598321572201, -122.4032, -2.13633885497712),
(39873, '94138', 218, 6, 184792, 37.7916, 0.659587849596689, -122.402, -2.1363179110261),
(39874, '94139', 218, 6, 184792, 37.7934, 0.659619265523225, -122.4031, -2.13633710964787),
(39875, '94140', 218, 6, 184792, 37.756, 0.658966512382979, -122.4154, -2.13655178514587),
(39876, '94141', 218, 6, 184792, 37.7671, 0.65916024392995, -122.4098, -2.13645404670776),
(39877, '94142', 218, 6, 184792, 37.7819, 0.659418552659246, -122.4146, -2.13653782251185),
(39878, '94143', 218, 6, 184792, 37.7613, 0.659059014833335, -122.4586, -2.13730576738273),
(39879, '94144', 218, 6, 184792, 37.7822, 0.659423788647002, -122.4617, -2.13735987258954),
(39880, '94145', 218, 6, 184792, 37.793, 0.659612284206217, -122.4009, -2.13629871240433),
(39881, '94146', 218, 6, 184792, 37.7582, 0.659004909626523, -122.4357, -2.13690608698402),
(39882, '94147', 218, 6, 184792, 37.8001, 0.659736202583109, -122.435, -2.13689386967926),
(39883, '94150', 218, 6, 184792, 37.7864, 0.659497092475585, -122.392, -2.1361433781009),
(39884, '94151', 218, 6, 184792, 37.7916, 0.659587849596689, -122.3978, -2.13624460719752),
(39885, '94152', 218, 6, 184792, 37.7918, 0.659591340255193, -122.3971, -2.13623238989275),
(39886, '94153', 218, 6, 184792, 37.7747, 0.659292888953102, -122.4185, -2.13660589035268),
(39887, '94154', 218, 6, 184792, 37.7753, 0.659303360928614, -122.4184, -2.13660414502343),
(39888, '94155', 218, 6, 184792, 37.7398, 0.658683769044156, -122.3824, -2.13597582649271),
(39889, '94156', 218, 6, 184792, 37.7899, 0.659558178999405, -122.4016, -2.13631092970909),
(39890, '94157', 218, 6, 184792, 37.7931, 0.659614029535469, -122.5548, -2.13898477412315),
(39891, '94159', 218, 6, 184792, 37.7809, 0.659401099366726, -122.4528, -2.13720453828611),
(39892, '94160', 218, 6, 184792, 37.7189, 0.658318995230489, -122.4022, -2.1363214016846),
(39893, '94161', 218, 6, 184792, 37.7987, 0.659711767973581, -122.3999, -2.13628125911181),
(39894, '94162', 218, 6, 184792, 37.7898, 0.659556433670153, -122.4018, -2.1363144203676),
(39895, '94163', 218, 6, 184792, 37.7896, 0.659552943011649, -122.4017, -2.13631267503834),
(39896, '94164', 218, 6, 184792, 37.7893, 0.659547707023893, -122.421, -2.13664952358398),
(39897, '94165', 218, 6, 184792, 37.7205, 0.658346920498521, -122.4429, -2.13703175069017),
(39898, '94166', 218, 6, 184792, 37.7591, 0.659020617589791, -122.436, -2.13691132297178),
(39899, '94167', 218, 6, 184792, 37.7705, 0.659219585124518, -122.4437, -2.13704571332418),
(39900, '94168', 218, 6, 184792, 37.7806, 0.65939586337897, -122.4947, -2.1379358312427),
(39901, '94169', 218, 6, 184792, 37.7352, 0.658603483898564, -122.4602, -2.13733369265076),
(39902, '94170', 218, 6, 184792, 37.7188, 0.658317249901237, -122.4113, -2.13648022664653),
(39903, '94171', 218, 6, 184792, 37.7749, 0.659296379611606, -122.4184, -2.13660414502343),
(39904, '94172', 218, 6, 184792, 37.7632, 0.659092176089123, -122.4852, -2.13777002496376),
(39905, '94175', 218, 6, 184792, 37.7701, 0.65921260380751, -122.4271, -2.13675598866835),
(39906, '94177', 218, 6, 184792, 37.7913, 0.659582613608933, -122.3966, -2.13622366324649),
(39907, '94188', 218, 6, 184792, 37.7403, 0.658692495690416, -122.383, -2.13598629846822),
(39908, '94203', 218, 6, 28490, 38.5853, 0.673440527869768, -121.4921, -2.1204371601622),
(39909, '94204', 218, 6, 28490, 38.6007, 0.673709308574575, -121.442, -2.11956275020695),
(39910, '94205', 218, 6, 28490, 38.4751, 0.67151717503407, -121.4436, -2.11959067547499),
(39911, '94206', 218, 6, 28490, 38.4965, 0.671890675493997, -121.4492, -2.1196884139131),
(39912, '94207', 218, 6, 28490, 38.5808, 0.673361988053428, -121.4905, -2.12040923489417),
(39913, '94208', 218, 6, 28490, 38.5859, 0.67345099984528, -121.4921, -2.1204371601622),
(39914, '94209', 218, 6, 28490, 38.5851, 0.673437037211264, -121.4922, -2.12043890549145),
(39915, '94211', 218, 6, 28490, 38.5854, 0.67344227319902, -121.4931, -2.12045461345472),
(39916, '94229', 218, 6, 28490, 38.5851, 0.673437037211264, -121.4931, -2.12045461345472),
(39917, '94230', 218, 6, 28490, 38.4751, 0.67151717503407, -121.4432, -2.11958369415798),
(39918, '94232', 218, 6, 28490, 38.5556, 0.672922165081926, -121.4972, -2.12052617195405),
(39919, '94234', 218, 6, 28490, 38.5851, 0.673437037211264, -121.493, -2.12045286812547),
(39920, '94235', 218, 6, 28490, 38.5849, 0.67343354655276, -121.4927, -2.12044763213771),
(39921, '94236', 218, 6, 28490, 38.5855, 0.673444018528272, -121.4926, -2.12044588680846),
(39922, '94237', 218, 6, 28490, 38.5859, 0.67345099984528, -121.4927, -2.12044763213771),
(39923, '94239', 218, 6, 28490, 38.5548, 0.67290820244791, -121.4976, -2.12053315327106),
(39924, '94240', 218, 6, 28490, 38.5852, 0.673438782540516, -121.4928, -2.12044937746697),
(39925, '94243', 218, 6, 28490, 38.5387, 0.672627204438339, -121.556, -2.12155242555423),
(39926, '94244', 218, 6, 28490, 38.5856, 0.673445763857524, -121.4924, -2.12044239614996),
(39927, '94245', 218, 6, 28490, 38.5851, 0.673437037211264, -121.4922, -2.12043890549145),
(39928, '94246', 218, 6, 28490, 38.5851, 0.673437037211264, -121.4931, -2.12045461345472),
(39929, '94247', 218, 6, 28490, 38.5859, 0.67345099984528, -121.493, -2.12045286812547),
(39930, '94248', 218, 6, 28490, 38.5855, 0.673444018528272, -121.4922, -2.12043890549145),
(39931, '94249', 218, 6, 28490, 38.576, 0.673278212249333, -121.4665, -2.11999035587369),
(39932, '94250', 218, 6, 28490, 38.5844, 0.6734248199065, -121.4929, -2.12045112279622),
(39933, '94252', 218, 6, 28490, 38.5852, 0.673438782540516, -121.4926, -2.12044588680846),
(39934, '94253', 218, 6, 28490, 38.5672, 0.673124623275157, -121.4677, -2.12001129982472),
(39935, '94254', 218, 6, 28490, 38.5858, 0.673449254516028, -121.4924, -2.12044239614996),
(39936, '94256', 218, 6, 28490, 38.5851, 0.673437037211264, -121.4926, -2.12044588680846),
(39937, '94257', 218, 6, 28490, 38.5856, 0.673445763857524, -121.4928, -2.12044937746697),
(39938, '94258', 218, 6, 28490, 38.585, 0.673435291882012, -121.4927, -2.12044763213771),
(39939, '94259', 218, 6, 28490, 38.5554, 0.672918674423422, -121.4966, -2.12051569997854),
(39940, '94261', 218, 6, 28490, 38.5856, 0.673445763857524, -121.493, -2.12045286812547),
(39941, '94262', 218, 6, 28490, 38.5847, 0.673430055894256, -121.4927, -2.12044763213771),
(39942, '94263', 218, 6, 28490, 38.5854, 0.67344227319902, -121.4925, -2.12044414147921),
(39943, '94267', 218, 6, 28490, 38.5853, 0.673440527869768, -121.4926, -2.12044588680846),
(39944, '94268', 218, 6, 28490, 38.5851, 0.673437037211264, -121.4923, -2.12044065082071),
(39945, '94269', 218, 6, 28490, 38.5554, 0.672918674423422, -121.4975, -2.12053140794181),
(39946, '94271', 218, 6, 28490, 38.5846, 0.673428310565004, -121.4932, -2.12045635878397),
(39947, '94273', 218, 6, 28490, 38.5851, 0.673437037211264, -121.4924, -2.12044239614996),
(39948, '94274', 218, 6, 28490, 38.585, 0.673435291882012, -121.4926, -2.12044588680846),
(39949, '94277', 218, 6, 28490, 38.5853, 0.673440527869768, -121.4921, -2.1204371601622),
(39950, '94278', 218, 6, 28490, 38.5761, 0.673279957578585, -121.4665, -2.11999035587369),
(39951, '94279', 218, 6, 28490, 38.5859, 0.67345099984528, -121.4927, -2.12044763213771),
(39952, '94280', 218, 6, 28490, 38.585, 0.673435291882012, -121.4923, -2.12044065082071),
(39953, '94282', 218, 6, 28490, 38.585, 0.673435291882012, -121.4924, -2.12044239614996),
(39954, '94283', 218, 6, 28490, 38.4751, 0.67151717503407, -121.4432, -2.11958369415798),
(39955, '94284', 218, 6, 28490, 38.553, 0.672876786521374, -121.4988, -2.12055409722209),
(39956, '94285', 218, 6, 28490, 38.556, 0.672929146398934, -121.4967, -2.12051744530779),
(39957, '94286', 218, 6, 28490, 38.5559, 0.672927401069682, -121.4976, -2.12053315327106),
(39958, '94287', 218, 6, 28490, 38.5855, 0.673444018528272, -121.4924, -2.12044239614996),
(39959, '94288', 218, 6, 28490, 38.585, 0.673435291882012, -121.493, -2.12045286812547),
(39960, '94289', 218, 6, 28490, 38.5853, 0.673440527869768, -121.4928, -2.12044937746697),
(39961, '94290', 218, 6, 28490, 38.5556, 0.672922165081926, -121.4971, -2.1205244266248),
(39962, '94291', 218, 6, 28490, 38.5558, 0.67292565574043, -121.4977, -2.12053489860031),
(39963, '94293', 218, 6, 28490, 38.5557, 0.672923910411178, -121.4968, -2.12051919063705),
(39964, '94294', 218, 6, 28490, 38.556, 0.672929146398934, -121.4973, -2.12052791728331),
(39965, '94295', 218, 6, 28490, 38.5855, 0.673444018528272, -121.4923, -2.12044065082071),
(39966, '94296', 218, 6, 28490, 38.5732, 0.673229343030277, -121.5062, -2.12068325158673),
(39967, '94297', 218, 6, 28490, 38.5557, 0.672923910411178, -121.4974, -2.12052966261256),
(39968, '94298', 218, 6, 28490, 38.5851, 0.673437037211264, -121.4926, -2.12044588680846),
(39969, '94299', 218, 6, 28490, 38.5669, 0.673119387287401, -121.4677, -2.12001129982472),
(39970, '94301', 218, 6, 42482, 37.4431, 0.653505377153489, -122.1494, -2.13190920933556),
(39971, '94302', 218, 6, 42482, 37.4455, 0.653547265055537, -122.1585, -2.13206803429749),
(39972, '94303', 218, 6, 42482, 37.4371, 0.653400657398369, -122.1202, -2.13139957319398),
(39973, '94304', 218, 6, 42482, 37.4099, 0.652925927841827, -122.1599, -2.13209246890702),
(39974, '94305', 218, 6, 12107, 37.4213, 0.653124895376554, -122.1644, -2.13217100872336),
(39975, '94306', 218, 6, 42482, 37.4169, 0.653048100889466, -122.1292, -2.13155665282666),
(39976, '94307', 218, 6, 42482, 37.4526, 0.653671183432428, -122.1223, -2.13143622510827),
(39977, '94308', 218, 6, 42482, 37.4541, 0.653697363371208, -122.12, -2.13139608253548),
(39978, '94309', 218, 6, 42482, 37.4416, 0.653479197214709, -122.1419, -2.13177830964166),
(39979, '94310', 218, 6, 42482, 37.4159, 0.653030647596946, -122.1296, -2.13156363414367),
(39980, '94401', 218, 6, 17947, 37.5708, 0.655734162608286, -122.3186, -2.13486230642994),
(39981, '94402', 218, 6, 17947, 37.5471, 0.655320519575563, -122.3305, -2.13507000061092),
(39982, '94403', 218, 6, 17947, 37.5387, 0.655173911918395, -122.3034, -2.13459701638363),
(39983, '94404', 218, 6, 17947, 37.5514, 0.655395568733399, -122.2678, -2.13397567916992),
(39984, '94405', 218, 6, 17947, 37.5746, 0.655800485119861, -122.3193, -2.1348745237347),
(39985, '94406', 218, 6, 17947, 37.5421, 0.655233253112963, -122.3306, -2.13507174594018),
(39986, '94407', 218, 6, 17947, 37.5385, 0.655170421259891, -122.3053, -2.13463017763942),
(39987, '94408', 218, 6, 17947, 37.5552, 0.655461891244974, -122.2723, -2.13405421898626),
(39988, '94409', 218, 6, 17947, 37.5748, 0.655803975778365, -122.3201, -2.13488848636872),
(39989, '94497', 218, 6, 17947, 37.5626, 0.655591045609622, -122.3241, -2.1349582995388),
(39990, '94501', 218, 6, 14955, 37.7637, 0.659100902735383, -122.2587, -2.13381685420799),
(39991, '94502', 218, 6, 14955, 37.7388, 0.658666315751636, -122.2421, -2.13352712955216),
(39992, '94503', 218, 6, 179730, 38.1719, 0.666225336742023, -122.2505, -2.13367373720933),
(39993, '94506', 218, 6, 1964, 37.8133, 0.659966586044372, -121.9143, -2.12780594026412),
(39994, '94507', 218, 6, 7039, 37.8525, 0.660650755111154, -122.0193, -2.12963853597872),
(39995, '94508', 218, 6, 179752, 38.5755, 0.673269485603073, -122.4462, -2.13708934655548),
(39996, '94509', 218, 6, 147, 37.9944, 0.663127377319733, -121.801, -2.12582848222161),
(39997, '94510', 218, 6, 180042, 38.0691, 0.664431138270973, -122.1622, -2.13213261147982),
(39998, '94511', 218, 6, 180061, 38.0207, 0.663586398913008, -121.6501, -2.12319478038035),
(39999, '94512', 218, 6, 180105, 38.1229, 0.665370125408546, -121.827, -2.12628226782713),
(40000, '94513', 218, 6, 1106, 37.9353, 0.662095887731805, -121.6931, -2.12394527195871),
(40001, '94514', 218, 6, 7810, 37.8972, 0.661430917286795, -121.6043, -2.12239541958294),
(40002, '94515', 218, 6, 180402, 38.5831, 0.673402130626224, -122.5675, -2.13920643093815),
(40003, '94516', 218, 6, 108480, 37.8321, 0.660294707943747, -122.1866, -2.1325584718173),
(40004, '94517', 218, 6, 608, 37.9295, 0.661994658635189, -121.9191, -2.12788971606822),
(40005, '94518', 218, 6, 698, 37.9508, 0.662366413765864, -122.023, -2.12970311316104),
(40006, '94519', 218, 6, 698, 37.9822, 0.66291444715099, -122.01, -2.12947622035828),
(40007, '94520', 218, 6, 698, 37.9838, 0.662942372419022, -122.0368, -2.12994396859782),
(40008, '94521', 218, 6, 698, 37.9626, 0.662572362617599, -121.9632, -2.12865940626835),
(40009, '94522', 218, 6, 698, 38.0135, 0.663460735206864, -122.0205, -2.12965947992974),
(40010, '94523', 218, 6, 268, 37.9536, 0.66241528298492, -122.0757, -2.13062290167684),
(40011, '94524', 218, 6, 698, 37.9772, 0.662827180688391, -122.056, -2.1302790718142),
(40012, '94525', 218, 6, 92, 38.0525, 0.664141413615142, -122.2206, -2.13315188376298),
(40013, '94526', 218, 6, 1964, 37.8158, 0.660010219275672, -121.9709, -2.12879379662075),
(40014, '94527', 218, 6, 698, 37.9782, 0.662844633980911, -122.0552, -2.13026510918018),
(40015, '94528', 218, 6, 181140, 37.8368, 0.66037673841859, -121.9556, -2.1285267612452),
(40016, '94529', 218, 6, 698, 37.8765, 0.661069634131632, -122.0481, -2.13014119080329),
(40017, '94530', 218, 6, 181338, 37.9189, 0.661809653734478, -122.3024, -2.13457956309111),
(40018, '94531', 218, 6, 147, 37.9966, 0.663165774563277, -121.8066, -2.12592622065972),
(40019, '94533', 218, 6, 2367, 38.2857, 0.668211521430793, -122.0107, -2.12948843766305),
(40020, '94534', 218, 6, 2367, 38.2855, 0.668208030772289, -122.0103, -2.12948145634604),
(40021, '94535', 218, 6, 0, 38.2772, 0.668063168444374, -121.9438, -2.12832081239346),
(40022, '94536', 218, 6, 2605, 37.5624, 0.655587554951118, -122.0004, -2.12930866875009),
(40023, '94537', 218, 6, 2605, 37.5565, 0.65548458052525, -122.0151, -2.12956523215013),
(40024, '94538', 218, 6, 2605, 37.5267, 0.654964472408156, -121.9652, -2.12869431285339),
(40025, '94539', 218, 6, 2605, 37.518, 0.654812628763233, -121.9295, -2.12807123031043),
(40026, '94540', 218, 6, 36333, 37.6566, 0.657231655106497, -122.0955, -2.13096847686874),
(40027, '94541', 218, 6, 36333, 37.6748, 0.65754930503036, -122.0817, -2.13072762143196),
(40028, '94542', 218, 6, 36333, 37.6583, 0.657261325703781, -122.044, -2.13006963230396),
(40029, '94543', 218, 6, 36333, 37.6706, 0.657476001201776, -122.0825, -2.13074158406598),
(40030, '94544', 218, 6, 36333, 37.6341, 0.656838956024798, -122.0619, -2.13038204624007),
(40031, '94545', 218, 6, 36333, 37.6359, 0.656870371951334, -122.1023, -2.13108715925787),
(40032, '94546', 218, 6, 180596, 37.7016, 0.658017053269894, -122.0737, -2.1305879950918),
(40033, '94547', 218, 6, 55260, 38.0086, 0.663375214073517, -122.2646, -2.13391982863386),
(40034, '94548', 218, 6, 182504, 37.9724, 0.662743404884295, -121.6584, -2.12333964270827),
(40035, '94549', 218, 6, 3594, 37.8984, 0.661451861237819, -122.1155, -2.13131754271914),
(40036, '94550', 218, 6, 36928, 37.6808, 0.657654024785479, -121.7514, -2.12496279891262),
(40037, '94551', 218, 6, 36928, 37.7288, 0.658491782826437, -121.6912, -2.12391211070292),
(40038, '94552', 218, 6, 180596, 37.7035, 0.658050214525682, -122.0301, -2.12982703153793),
(40039, '94553', 218, 6, 22906, 37.9935, 0.663111669356466, -122.1073, -2.13117442572047),
(40040, '94555', 218, 6, 2605, 37.5737, 0.655784777156593, -122.0474, -2.13012897349853),
(40041, '94556', 218, 6, 183439, 37.8422, 0.660470986198198, -122.1236, -2.13145891438855),
(40042, '94557', 218, 6, 36333, 37.6273, 0.656720273635662, -122.1041, -2.13111857518441),
(40043, '94558', 218, 6, 183546, 38.3456, 0.669256973652738, -122.3057, -2.13463715895643),
(40044, '94559', 218, 6, 183546, 38.2913, 0.668309259868905, -122.2868, -2.1343072917278),
(40045, '94560', 218, 6, 10792, 37.5378, 0.655158203955127, -122.0309, -2.12984099417195),
(40046, '94561', 218, 6, 818, 37.9911, 0.663069781454418, -121.7143, -2.12431528176013),
(40047, '94562', 218, 6, 4721, 38.4298, 0.670726540882917, -122.4019, -2.13631616569685),
(40048, '94563', 218, 6, 183888, 37.8808, 0.661144683289468, -122.1761, -2.13237521224584),
(40049, '94564', 218, 6, 184136, 37.9971, 0.663174501209537, -122.2856, -2.13428634777678),
(40050, '94565', 218, 6, 5099, 38.0159, 0.663502623108912, -121.9107, -2.12774310841105),
(40051, '94566', 218, 6, 820, 37.6713, 0.65748821850654, -121.8838, -2.12727361484226),
(40052, '94567', 218, 6, 184230, 38.6779, 0.675056702757115, -122.408, -2.13642263078122),
(40053, '94568', 218, 6, 2113, 37.7146, 0.658243946072653, -121.9328, -2.12812882617574),
(40054, '94569', 218, 6, 184233, 38.046, 0.664027967213763, -122.1865, -2.13255672648805),
(40055, '94570', 218, 6, 183439, 38.1141, 0.665216536434371, -122.139, -2.13172769509335),
(40056, '94571', 218, 6, 11592, 38.1725, 0.666235808717535, -121.7178, -2.12437636828395),
(40057, '94572', 218, 6, 184644, 38.0303, 0.663753950521199, -122.2607, -2.13385176079303),
(40058, '94573', 218, 6, 5589, 38.4558, 0.671180326488435, -122.4101, -2.13645928269551),
(40059, '94574', 218, 6, 51154, 38.5087, 0.67210360566274, -122.448, -2.13712076248202),
(40060, '94575', 218, 6, 183439, 37.8435, 0.660493675478474, -122.1236, -2.13145891438855),
(40061, '94576', 218, 6, 2011, 38.5298, 0.672471870134911, -122.4669, -2.13745062971064),
(40062, '94577', 218, 6, 184835, 37.7208, 0.658352156486277, -122.157, -2.13204185435871),
(40063, '94578', 218, 6, 184835, 37.7032, 0.658044978537926, -122.1249, -2.13148160366882),
(40064, '94579', 218, 6, 184835, 37.6882, 0.657783179150127, -122.1501, -2.13192142664033),
(40065, '94580', 218, 6, 184839, 37.6776, 0.657598174249415, -122.1313, -2.13159330474095),
(40066, '94581', 218, 6, 183546, 38.2971, 0.66841048896552, -122.2858, -2.13428983843528),
(40067, '94583', 218, 6, 97813, 37.7552, 0.658952549748963, -121.9526, -2.12847440136764),
(40068, '94585', 218, 6, 185431, 38.2382, 0.667382490036096, -122.0522, -2.13021274930262),
(40069, '94586', 218, 6, 113346, 37.6036, 0.65630663060294, -121.894, -2.12745163842597),
(40070, '94587', 218, 6, 12457, 37.5907, 0.656081483129432, -122.046, -2.130104538889),
(40071, '94588', 218, 6, 820, 37.685, 0.657727328614063, -121.8948, -2.12746560105998),
(40072, '94589', 218, 6, 185869, 38.1423, 0.665708719283433, -122.247, -2.13361265068551),
(40073, '94590', 218, 6, 185869, 38.1043, 0.665045494167675, -122.2469, -2.13361090535626),
(40074, '94591', 218, 6, 185869, 38.1012, 0.664991388960864, -122.2099, -2.13296513353302),
(40075, '94592', 218, 6, 185869, 38.0996, 0.664963463692832, -122.2755, -2.13411006952233),
(40076, '94595', 218, 6, 25789, 37.8702, 0.660959678388757, -122.0707, -2.13053563521424),
(40077, '94596', 218, 6, 25789, 37.9051, 0.661568798297703, -122.0557, -2.13027383582644),
(40078, '94597', 218, 6, 25789, 37.8982, 0.661448370579315, -122.0597, -2.13034364899652),
(40079, '94598', 218, 6, 25789, 37.9185, 0.66180267241747, -122.0254, -2.12974500106309),
(40080, '94599', 218, 6, 186281, 38.4053, 0.670298935216178, -122.3588, -2.13556392878924),
(40081, '94601', 218, 6, 4710, 37.7784, 0.659357466135426, -122.2169, -2.13308730658066),
(40082, '94602', 218, 6, 4710, 37.803, 0.659786817131416, -122.2086, -2.13294244425274),
(40083, '94603', 218, 6, 4710, 37.7389, 0.658668061080888, -122.1729, -2.13231936170978),
(40084, '94604', 218, 6, 4710, 37.8021, 0.659771109168149, -122.2652, -2.13393030060937),
(40085, '94605', 218, 6, 4710, 37.7629, 0.659086940101367, -122.1572, -2.13204534501722),
(40086, '94606', 218, 6, 4710, 37.7933, 0.659617520193973, -122.2428, -2.13353934685692),
(40087, '94607', 218, 6, 4710, 37.8067, 0.65985139431374, -122.2864, -2.13430031041079),
(40088, '94608', 218, 6, 148684, 37.836, 0.660362775784574, -122.2757, -2.13411356018083),
(40089, '94609', 218, 6, 4710, 37.8361, 0.660364521113827, -122.2639, -2.1339076113291),
(40090, '94610', 218, 6, 4710, 37.8125, 0.659952623410356, -122.2394, -2.13348000566236),
(40091, '94611', 218, 6, 4710, 37.8303, 0.660263292017211, -122.221, -2.13315886507999),
(40092, '94612', 218, 6, 4710, 37.8106, 0.659919462154568, -122.2687, -2.13399138713319),
(40093, '94613', 218, 6, 4710, 37.7827, 0.659432515293262, -122.1858, -2.13254450918329),
(40094, '94614', 218, 6, 4710, 37.7276, 0.658470838875413, -122.2026, -2.13283772449762),
(40095, '94615', 218, 6, 4710, 37.8091, 0.659893282215788, -122.2974, -2.13449229662851),
(40096, '94617', 218, 6, 4710, 37.7596, 0.659029344236051, -122.1469, -2.13186557610426),
(40097, '94618', 218, 6, 4710, 37.8439, 0.660500656795482, -122.2391, -2.1334747696746),
(40098, '94619', 218, 6, 4710, 37.7894, 0.659549452353145, -122.1822, -2.13248167733022),
(40099, '94620', 218, 6, 4996, 37.7764, 0.659322559550386, -122.2131, -2.13302098406908),
(40100, '94621', 218, 6, 4710, 37.7559, 0.658964767053727, -122.1882, -2.13258639708534),
(40101, '94622', 218, 6, 4710, 37.7515, 0.658887972566639, -122.1941, -2.1326893715112),
(40102, '94623', 218, 6, 4710, 37.8095, 0.659900263532796, -122.2991, -2.1345219672258),
(40103, '94624', 218, 6, 4710, 37.7481, 0.658828631372071, -122.1727, -2.13231587105128),
(40104, '94625', 218, 6, 4710, 37.8007, 0.65974667455862, -122.3105, -2.13472093476052),
(40105, '94626', 218, 6, 4710, 37.8226, 0.660128901664807, -122.305, -2.13462494165166),
(40106, '94627', 218, 6, 4710, 37.7655, 0.659132318661919, -122.1492, -2.13190571867706),
(40107, '94643', 218, 6, 4710, 37.8071, 0.659858375630748, -122.2635, -2.13390063001209),
(40108, '94649', 218, 6, 4710, 37.8061, 0.659840922338228, -122.2658, -2.13394077258488),
(40109, '94659', 218, 6, 4710, 37.8105, 0.659917716825316, -122.2665, -2.13395298988965),
(40110, '94660', 218, 6, 4710, 37.7962, 0.659668134742281, -122.2704, -2.13402105773047),
(40111, '94661', 218, 6, 4710, 37.8285, 0.660231876090675, -122.2094, -2.13295640688676),
(40112, '94662', 218, 6, 148684, 37.8428, 0.66048145817371, -122.291, -2.13438059555639),
(40113, '94666', 218, 6, 4710, 37.8076, 0.659867102277008, -122.2635, -2.13390063001209),
(40114, '94701', 218, 6, 15198, 37.8687, 0.660933498449977, -122.2695, -2.13400534976721),
(40115, '94702', 218, 6, 15198, 37.8659, 0.660884629230921, -122.2852, -2.13427936645977),
(40116, '94703', 218, 6, 15198, 37.8635, 0.660842741328873, -122.2742, -2.13408738024205),
(40117, '94704', 218, 6, 15198, 37.8674, 0.660910809169701, -122.2592, -2.13382558085425),
(40118, '94705', 218, 6, 15198, 37.8572, 0.660732785585997, -122.2448, -2.13357425344196),
(40119, '94706', 218, 6, 18772, 37.889, 0.661287800288132, -122.2935, -2.13442422878769),
(40120, '94707', 218, 6, 15198, 37.8941, 0.661376812079983, -122.2752, -2.13410483353457),
(40121, '94708', 218, 6, 15198, 37.8903, 0.661310489568408, -122.2583, -2.13380987289098),
(40122, '94709', 218, 6, 15198, 37.8795, 0.661121994009192, -122.2652, -2.13393030060937),
(40123, '94710', 218, 6, 15198, 37.8682, 0.660924771803717, -122.2982, -2.13450625926253),
(40124, '94712', 218, 6, 15198, 37.8694, 0.660945715754741, -122.2681, -2.13398091515768),
(40125, '94720', 218, 6, 15198, 37.869, 0.660938734437733, -122.2567, -2.13378194762295),
(40126, '94801', 218, 6, 5381, 37.9404, 0.662184899523657, -122.3528, -2.13545920903412),
(40127, '94802', 218, 6, 5381, 37.9369, 0.662123812999837, -122.3589, -2.13556567411849),
(40128, '94803', 218, 6, 181386, 37.9709, 0.662717224945515, -122.2904, -2.13437012358087),
(40129, '94804', 218, 6, 5381, 37.9264, 0.661940553428377, -122.3341, -2.135132832464),
(40130, '94805', 218, 6, 5381, 37.9404, 0.662184899523657, -122.32, -2.13488674103946),
(40131, '94806', 218, 6, 17951, 37.9724, 0.662743404884295, -122.3345, -2.135139813781),
(40132, '94807', 218, 6, 5381, 37.9293, 0.661991167976685, -122.3563, -2.13552029555794),
(40133, '94808', 218, 6, 5381, 37.9335, 0.662064471805269, -122.3432, -2.13529165742593),
(40134, '94820', 218, 6, 181386, 37.9794, 0.662865577931934, -122.2959, -2.13446611668973),
(40135, '94850', 218, 6, 5381, 37.9454, 0.662272165986256, -122.3818, -2.1359653545172),
(40136, '94901', 218, 6, 179072, 37.9755, 0.662797510091107, -122.5097, -2.1381976306305),
(40137, '94903', 218, 6, 179072, 38.0152, 0.663490405804148, -122.5457, -2.13882594916122),
(40138, '94904', 218, 6, 0, 37.9552, 0.662443208252952, -122.5527, -2.13894812220885),
(40139, '94912', 218, 6, 179072, 37.9766, 0.662816708712879, -122.5053, -2.13812083614341),
(40140, '94913', 218, 6, 179072, 38.0237, 0.663638758790568, -122.5471, -2.13885038377074),
(40141, '94914', 218, 6, 48628, 37.9471, 0.66230183658354, -122.5386, -2.13870203078432),
(40142, '94915', 218, 6, 179072, 37.9588, 0.662506040106024, -122.5068, -2.13814701608219),
(40143, '94920', 218, 6, 0, 37.8906, 0.661315725556163, -122.4728, -2.13755360413651),
(40144, '94922', 218, 6, 180157, 38.3776, 0.669815479013376, -122.984, -2.14647572727271),
(40145, '94923', 218, 6, 180158, 38.3479, 0.669297116225534, -123.0476, -2.14758575667697),
(40146, '94924', 218, 6, 180164, 37.9148, 0.661738095235146, -122.7054, -2.14161323997665),
(40147, '94925', 218, 6, 180887, 37.9231, 0.661882957563062, -122.5175, -2.13833376631215),
(40148, '94926', 218, 6, 180901, 38.328, 0.668949795704387, -122.7091, -2.14167781715897),
(40149, '94927', 218, 6, 184649, 38.3495, 0.669325041493565, -122.6974, -2.14147361363649),
(40150, '94928', 218, 6, 184649, 38.3439, 0.669227303055454, -122.7, -2.14151899219704),
(40151, '94929', 218, 6, 181151, 38.2521, 0.667625090802123, -122.9634, -2.1461161894468),
(40152, '94930', 218, 6, 13733, 37.964, 0.662596797227127, -122.6206, -2.14013320077096),
(40153, '94931', 218, 6, 180901, 38.3254, 0.668904417143835, -122.7078, -2.1416551278787),
(40154, '94933', 218, 6, 148887, 38.0168, 0.66351833107218, -122.6918, -2.14137587519838),
(40155, '94937', 218, 6, 3357, 38.0963, 0.664905867827516, -122.8569, -2.14425741379342),
(40156, '94938', 218, 6, 182625, 38.0131, 0.663453753889857, -122.6944, -2.14142125375893),
(40157, '94939', 218, 6, 103530, 37.9374, 0.662132539646097, -122.5362, -2.13866014288228),
(40158, '94940', 218, 6, 4011, 38.195, 0.666628507799234, -122.8889, -2.14481591915406),
(40159, '94941', 218, 6, 125429, 37.8974, 0.661434407945299, -122.536, -2.13865665222377),
(40160, '94942', 218, 6, 125429, 37.9026, 0.661525165066403, -122.5228, -2.13842626876251),
(40161, '94945', 218, 6, 183725, 38.1257, 0.665418994627602, -122.5497, -2.13889576233129),
(40162, '94946', 218, 6, 183633, 38.0586, 0.664247878699514, -122.6798, -2.14116643568814),
(40163, '94947', 218, 6, 183725, 38.1032, 0.665026295545903, -122.6174, -2.1400773502349),
(40164, '94948', 218, 6, 183725, 38.1375, 0.665624943479337, -122.5628, -2.13912440046331),
(40165, '94949', 218, 6, 183725, 38.0604, 0.66427929462605, -122.5427, -2.13877358928366),
(40166, '94950', 218, 6, 183833, 38.0417, 0.663952918055927, -122.7715, -2.14276690261222),
(40167, '94951', 218, 6, 184061, 38.3148, 0.668719412243123, -122.6612, -2.14084180444727),
(40168, '94952', 218, 6, 184079, 38.2458, 0.667515135059247, -122.661, -2.14083831378876),
(40169, '94953', 218, 6, 184079, 38.261, 0.66778042510555, -122.637, -2.14041943476829),
(40170, '94954', 218, 6, 184079, 38.2518, 0.667619854814367, -122.6149, -2.1400337170036),
(40171, '94955', 218, 6, 184079, 38.2255, 0.667160833221092, -122.5566, -2.13901619004968),
(40172, '94956', 218, 6, 184203, 38.0648, 0.664356089113137, -122.8112, -2.14345979832526),
(40173, '94957', 218, 6, 11692, 37.9644, 0.662603778544135, -122.5581, -2.13904236998846),
(40174, '94960', 218, 6, 184753, 37.9822, 0.66291444715099, -122.5687, -2.13922737488917),
(40175, '94963', 218, 6, 97788, 38.0132, 0.663455499219108, -122.6621, -2.14085751241054),
(40176, '94964', 218, 6, 184876, 37.942, 0.662212824791689, -122.4825, -2.13772290107395),
(40177, '94965', 218, 6, 184991, 37.8617, 0.660811325402337, -122.5043, -2.13810338285089),
(40178, '94966', 218, 6, 184991, 37.8681, 0.660923026474465, -122.4984, -2.13800040842502),
(40179, '94970', 218, 6, 185380, 37.9046, 0.661560071651443, -122.6459, -2.14057476907171),
(40180, '94971', 218, 6, 185680, 38.2481, 0.667555277632043, -122.9004, -2.14501663201804),
(40181, '94972', 218, 6, 74628, 38.2971, 0.66841048896552, -122.9432, -2.14576363293789),
(40182, '94973', 218, 6, 186215, 38.0075, 0.663356015451745, -122.6392, -2.14045783201183),
(40183, '94974', 218, 6, 184876, 37.9562, 0.662460661545472, -122.542, -2.13876137197889),
(40184, '94975', 218, 6, 184079, 38.3218, 0.668841585290763, -122.644, -2.14054160781593),
(40185, '94976', 218, 6, 180887, 37.9258, 0.661930081452865, -122.5261, -2.13848386462782),
(40186, '94977', 218, 6, 103530, 37.9357, 0.662102869048813, -122.5353, -2.13864443491901),
(40187, '94978', 218, 6, 13733, 37.9852, 0.66296680702855, -122.582, -2.13945950367969),
(40188, '94979', 218, 6, 184753, 37.9707, 0.662713734287011, -122.561, -2.13909298453677),
(40189, '94998', 218, 6, 183725, 38.1014, 0.664994879619367, -122.5711, -2.13926926279122),
(40190, '94999', 218, 6, 184079, 38.3225, 0.668853802595527, -122.6438, -2.14053811715742),
(40191, '95001', 218, 6, 179774, 36.979, 0.645405304094983, -121.8979, -2.1275197062668),
(40192, '95002', 218, 6, 179724, 37.427, 0.653224379143918, -121.9697, -2.12877285266973),
(40193, '95003', 218, 6, 179774, 36.9795, 0.645414030741243, -121.8876, -2.12733993735384),
(40194, '95004', 218, 6, 179808, 36.8805, 0.643686154781769, -121.622, -2.12270434286054),
(40195, '95005', 218, 6, 7399, 37.0863, 0.647278042382373, -122.0843, -2.13077299999251),
(40196, '95006', 218, 6, 180205, 37.147, 0.648337457238334, -122.1293, -2.13155839815591),
(40197, '95007', 218, 6, 45136, 37.1059, 0.647620126915764, -122.1076, -2.13117966170823),
(40198, '95008', 218, 6, 1317, 37.2803, 0.650663981131242, -121.9564, -2.12854072387921),
(40199, '95009', 218, 6, 1317, 37.2868, 0.650777427532622, -121.9485, -2.1284028428683),
(40200, '95010', 218, 6, 15428, 36.9767, 0.645365161522187, -121.9524, -2.12847091070913),
(40201, '95011', 218, 6, 1317, 37.2943, 0.650908327226521, -121.9568, -2.12854770519622),
(40202, '95012', 218, 6, 93104, 36.7776, 0.641890210981467, -121.7365, -2.12470274485408),
(40203, '95013', 218, 6, 180924, 37.2007, 0.649274699046654, -121.7257, -2.12451424929486),
(40204, '95014', 218, 6, 180990, 37.3166, 0.651297535649716, -122.0463, -2.13010977487676),
(40205, '95015', 218, 6, 180990, 37.3227, 0.651404000734088, -122.0529, -2.13022496660739),
(40206, '95017', 218, 6, 1977, 37.0484, 0.646616562595867, -122.2208, -2.13315537442149),
(40207, '95018', 218, 6, 8869, 37.0645, 0.646897560605438, -122.061, -2.1303663382768),
(40208, '95019', 218, 6, 29850, 36.9359, 0.644653067187373, -121.7771, -2.12541134853039),
(40209, '95020', 218, 6, 181780, 37.0197, 0.646115653100545, -121.5724, -2.12183865955155),
(40210, '95021', 218, 6, 181780, 37.0145, 0.646024895979441, -121.5506, -2.12145817777462),
(40211, '95023', 218, 6, 16470, 36.8496, 0.643146848042902, -121.3874, -2.11860980043536),
(40212, '95024', 218, 6, 16470, 36.84, 0.642979296434711, -121.3927, -2.11870230288572),
(40213, '95026', 218, 6, 182186, 37.1573, 0.648517226151289, -121.9839, -2.12902068942351),
(40214, '95030', 218, 6, 182943, 37.2226, 0.649656926152841, -121.9773, -2.12890549769288),
(40215, '95031', 218, 6, 182943, 37.1295, 0.648032024619235, -121.9396, -2.12824750856488),
(40216, '95032', 218, 6, 182943, 37.2313, 0.649808769797765, -121.9463, -2.12836444562476),
(40217, '95033', 218, 6, 182943, 37.2308, 0.649800043151505, -121.9593, -2.12859133842752),
(40218, '95035', 218, 6, 183297, 37.4375, 0.653407638715377, -121.8907, -2.12739404256065),
(40219, '95036', 218, 6, 183297, 37.2446, 0.65004089858828, -121.9738, -2.12884441116906),
(40220, '95037', 218, 6, 150853, 37.1249, 0.647951739473643, -121.6503, -2.12319827103886),
(40221, '95038', 218, 6, 150853, 37.0857, 0.647267570406861, -121.6093, -2.12248268604554),
(40222, '95039', 218, 6, 183466, 36.795, 0.642193898271314, -121.7846, -2.12554224822429),
(40223, '95041', 218, 6, 37293, 37.0505, 0.646653214510159, -122.054, -2.13024416522916),
(40224, '95042', 218, 6, 183593, 37.1773, 0.648866292001688, -121.821, -2.12617754807201),
(40225, '95043', 218, 6, 183947, 36.5608, 0.638106337163143, -121.029, -2.11235454039622),
(40226, '95044', 218, 6, 184466, 37.1589, 0.648545151419321, -121.9864, -2.12906432265481),
(40227, '95045', 218, 6, 184825, 36.8497, 0.643148593372154, -121.5386, -2.12124873826438),
(40228, '95046', 218, 6, 184855, 37.0911, 0.647361818186469, -121.5965, -2.12225928390128),
(40229, '95050', 218, 6, 17976, 37.3522, 0.651918872863426, -121.9548, -2.12851279861118),
(40230, '95051', 218, 6, 17976, 37.3481, 0.651847314364094, -121.9854, -2.12904686936229),
(40231, '95052', 218, 6, 17976, 37.3529, 0.65193109016819, -121.9536, -2.12849185466016),
(40232, '95053', 218, 6, 17976, 37.3494, 0.65187000364437, -121.9392, -2.12824052724787),
(40233, '95054', 218, 6, 17976, 37.3525, 0.651924108851182, -121.9582, -2.12857213980575),
(40234, '95055', 218, 6, 17976, 37.3349, 0.651616930902831, -121.9847, -2.12903465205753),
(40235, '95056', 218, 6, 17976, 37.3999, 0.652751394916627, -121.962, -2.12863846231732),
(40236, '95060', 218, 6, 97854, 36.9911, 0.645616488934475, -122.057, -2.13029652510672),
(40237, '95061', 218, 6, 97854, 36.9765, 0.645361670863683, -122.0254, -2.12974500106309),
(40238, '95062', 218, 6, 97854, 36.9718, 0.64527964038884, -121.9872, -2.12907828528883),
(40239, '95063', 218, 6, 97854, 36.9789, 0.645403558765731, -122.0085, -2.1294500404195),
(40240, '95064', 218, 6, 97854, 36.9892, 0.645583327678687, -122.0596, -2.13034190366727),
(40241, '95065', 218, 6, 97854, 37.0148, 0.646030131967197, -121.9787, -2.12892993230241),
(40242, '95066', 218, 6, 185012, 37.0579, 0.646782368874807, -122.02, -2.12965075328348),
(40243, '95067', 218, 6, 185012, 37.0508, 0.646658450497915, -122.0138, -2.12954254286986),
(40244, '95070', 218, 6, 5658, 37.271, 0.650501665510807, -122.0229, -2.12970136783179),
(40245, '95071', 218, 6, 5658, 37.2534, 0.650194487562456, -122.0297, -2.12982005022092),
(40246, '95073', 218, 6, 185247, 37.0095, 0.645937629516841, -121.9503, -2.12843425879484),
(40247, '95075', 218, 6, 185745, 36.7787, 0.641909409603239, -121.2968, -2.11702853213306),
(40248, '95076', 218, 6, 6659, 36.9422, 0.644763022930249, -121.7833, -2.12551955894401),
(40249, '95077', 218, 6, 6659, 36.9119, 0.644234188166895, -121.7575, -2.125069263997),
(40250, '95101', 218, 6, 17939, 37.3865, 0.65251752079686, -121.8971, -2.12750574363278),
(40251, '95102', 218, 6, 17939, 37.3882, 0.652547191394144, -121.8876, -2.12733993735384),
(40252, '95103', 218, 6, 17939, 37.3374, 0.651660564134131, -121.8908, -2.1273957878899),
(40253, '95106', 218, 6, 17939, 37.3378, 0.651667545451139, -121.8926, -2.12742720381644),
(40254, '95108', 218, 6, 17939, 37.3337, 0.651595986951807, -122.0877, -2.13083234118708),
(40255, '95109', 218, 6, 17939, 37.3375, 0.651662309463383, -121.8919, -2.12741498651168),
(40256, '95110', 218, 6, 17939, 37.3353, 0.651623912219839, -121.8983, -2.1275266875838),
(40257, '95111', 218, 6, 17939, 37.2823, 0.650698887716282, -121.8237, -2.12622467196182),
(40258, '95112', 218, 6, 17939, 37.3454, 0.65180019047429, -121.8852, -2.12729804945179),
(40259, '95113', 218, 6, 17939, 37.3336, 0.651594241622555, -121.8895, -2.12737309860963),
(40260, '95114', 218, 6, 17939, 37.3865, 0.65251752079686, -121.8984, -2.12752843291306),
(40261, '95115', 218, 6, 17939, 37.3042, 0.651081114822469, -121.8908, -2.1273957878899),
(40262, '95116', 218, 6, 17939, 37.3522, 0.651918872863426, -121.8499, -2.12668194822584),
(40263, '95117', 218, 6, 17939, 37.3107, 0.651194561223848, -121.9625, -2.12864718896358),
(40264, '95118', 218, 6, 17939, 37.258, 0.650274772708047, -121.8889, -2.12736262663412),
(40265, '95119', 218, 6, 17939, 37.2294, 0.649775608541977, -121.7863, -2.12557191882157),
(40266, '95120', 218, 6, 17939, 37.2168, 0.649555697056226, -121.8568, -2.12680237594423),
(40267, '95121', 218, 6, 17939, 37.3051, 0.651096822785737, -121.8069, -2.12593145664748),
(40268, '95122', 218, 6, 17939, 37.3285, 0.651505229830703, -121.8339, -2.12640269554552),
(40269, '95123', 218, 6, 17939, 37.2446, 0.65004089858828, -121.8344, -2.12641142219178),
(40270, '95124', 218, 6, 17939, 37.2565, 0.650248592769267, -121.9246, -2.12798570917708),
(40271, '95125', 218, 6, 17939, 37.2954, 0.650927525848293, -121.8952, -2.12747258237699),
(40272, '95126', 218, 6, 17939, 37.3234, 0.651416218038852, -121.9142, -2.12780419493487),
(40273, '95127', 218, 6, 17939, 37.369, 0.652212088177761, -121.8193, -2.12614787747473),
(40274, '95128', 218, 6, 17939, 37.3159, 0.651285318344952, -121.933, -2.12813231683425),
(40275, '95129', 218, 6, 17939, 37.3071, 0.651131729370776, -121.9992, -2.12928772479907),
(40276, '95130', 218, 6, 17939, 37.288, 0.650798371483646, -121.9791, -2.12893691361942),
(40277, '95131', 218, 6, 17939, 37.3856, 0.652501812833592, -121.8853, -2.12729979478104),
(40278, '95132', 218, 6, 17939, 37.4042, 0.652826444074463, -121.8549, -2.12676921468844),
(40279, '95133', 218, 6, 17939, 37.3746, 0.652309826615873, -121.856, -2.12678841331021),
(40280, '95134', 218, 6, 17939, 37.4123, 0.652967815743875, -121.9447, -2.12833652035673),
(40281, '95135', 218, 6, 17939, 37.2966, 0.650948469799317, -121.7574, -2.12506751866774),
(40282, '95136', 218, 6, 17939, 37.2679, 0.650447560303995, -121.8464, -2.12662086170202),
(40283, '95137', 218, 6, 17939, 37.2147, 0.649519045141934, -121.7361, -2.12469576353707),
(40284, '95138', 218, 6, 17939, 37.2478, 0.650096749124344, -121.7759, -2.12539040457936),
(40285, '95139', 218, 6, 17939, 37.2256, 0.649709286030401, -121.7662, -2.12522110764192),
(40286, '95140', 218, 6, 0, 37.3766, 0.652344733200913, -121.768, -2.12525252356846),
(40287, '95141', 218, 6, 17939, 37.1783, 0.648883745294208, -121.75, -2.1249383643031),
(40288, '95142', 218, 6, 17939, 37.2246, 0.649691832737881, -121.7479, -2.1249017123888),
(40289, '95148', 218, 6, 17939, 37.3316, 0.651559335037515, -121.7892, -2.12562253336988),
(40290, '95150', 218, 6, 17939, 37.2905, 0.650842004714945, -121.9119, -2.12776405236208),
(40291, '95151', 218, 6, 17939, 37.2933, 0.650890873934001, -121.7828, -2.12551083229775),
(40292, '95152', 218, 6, 17939, 37.4162, 0.653035883584702, -121.8223, -2.12620023735229),
(40293, '95153', 218, 6, 17939, 37.2492, 0.650121183733872, -121.8458, -2.12661038972651),
(40294, '95154', 218, 6, 17939, 37.2651, 0.650398691084939, -121.9142, -2.12780419493487),
(40295, '95155', 218, 6, 17939, 37.3101, 0.651184089248336, -121.9016, -2.12758428344912),
(40296, '95156', 218, 6, 17939, 37.3571, 0.652004393996774, -121.8413, -2.12653184991017),
(40297, '95157', 218, 6, 17939, 37.3004, 0.651014792310893, -121.9772, -2.12890375236363),
(40298, '95158', 218, 6, 17939, 37.2628, 0.650358548512143, -121.8783, -2.1271776217334),
(40299, '95159', 218, 6, 17939, 37.3175, 0.651313243612984, -121.9348, -2.12816373276078),
(40300, '95160', 218, 6, 17939, 37.2183, 0.649581876995006, -121.8597, -2.12685299049253),
(40301, '95161', 218, 6, 17939, 37.3872, 0.652529738101624, -121.8984, -2.12752843291306),
(40302, '95164', 218, 6, 17939, 37.3917, 0.652608277917964, -121.9203, -2.12791066001924),
(40303, '95170', 218, 6, 17939, 37.3099, 0.651180598589832, -122.0095, -2.12946749371202),
(40304, '95171', 218, 6, 17939, 37.3043, 0.651082860151721, -121.8501, -2.12668543888434),
(40305, '95172', 218, 6, 17939, 37.334, 0.651601222939563, -121.8851, -2.12729630412254),
(40306, '95173', 218, 6, 17939, 37.3357, 0.651630893536847, -121.8941, -2.12745338375522),
(40307, '95190', 218, 6, 17939, 37.378, 0.652369167810441, -121.9016, -2.12758428344912),
(40308, '95191', 218, 6, 17939, 37.3268, 0.651475559233419, -121.9176, -2.12786353612944),
(40309, '95192', 218, 6, 17939, 37.3437, 0.651770519877006, -121.8906, -2.1273922972314),
(40310, '95193', 218, 6, 17939, 37.2447, 0.650042643917532, -121.8298, -2.12633113704619),
(40311, '95194', 218, 6, 17939, 37.3446, 0.651786227840274, -121.8832, -2.12726314286675),
(40312, '95196', 218, 6, 17939, 37.3345, 0.651609949585823, -121.8909, -2.12739753321916),
(40313, '95201', 218, 6, 510, 37.9051, 0.661568798297703, -121.2242, -2.11576142309611),
(40314, '95202', 218, 6, 510, 37.9584, 0.662499058789015, -121.2863, -2.1168452725616),
(40315, '95203', 218, 6, 510, 37.9543, 0.662427500289684, -121.3068, -2.11720306505826),
(40316, '95204', 218, 6, 510, 37.9738, 0.662767839493823, -121.3158, -2.11736014469094),
(40317, '95205', 218, 6, 510, 37.9611, 0.662546182678819, -121.2253, -2.11578062171788),
(40318, '95206', 218, 6, 510, 37.9225, 0.66187248558755, -121.3147, -2.11734094606916),
(40319, '95207', 218, 6, 510, 38.0023, 0.663265258330641, -121.3244, -2.11751024300661),
(40320, '95208', 218, 6, 510, 37.9544, 0.662429245618936, -121.4397, -2.11952260763416),
(40321, '95209', 218, 6, 510, 38.0264, 0.663685882680372, -121.3509, -2.11797275525839),
(40322, '95210', 218, 6, 510, 38.0262, 0.663682392021868, -121.2968, -2.11702853213306),
(40323, '95211', 218, 6, 510, 37.981, 0.662893503199966, -121.3082, -2.11722749966779),
(40324, '95212', 218, 6, 510, 38.0379, 0.663886595544351, -121.2369, -2.11598307991111),
(40325, '95213', 218, 6, 510, 37.9546, 0.66243273627744, -121.4399, -2.11952609829266),
(40326, '95215', 218, 6, 510, 37.9702, 0.662705007640751, -121.2042, -2.11541235724571),
(40327, '95219', 218, 6, 510, 38.0035, 0.663286202281665, -121.3583, -2.11810190962303),
(40328, '95220', 218, 6, 92099, 38.1946, 0.666621526482226, -121.233, -2.11591501207029),
(40329, '95221', 218, 6, 179718, 38.0758, 0.664548075330857, -120.5691, -2.1043277711663),
(40330, '95222', 218, 6, 179749, 38.0736, 0.664509678087313, -120.6235, -2.10527723027938),
(40331, '95223', 218, 6, 26395, 38.2678, 0.667899107494686, -120.3145, -2.09988416289072),
(40332, '95224', 218, 6, 7205, 38.2117, 0.666919977784317, -120.3681, -2.10081965936979),
(40333, '95225', 218, 6, 180339, 38.1882, 0.666509825410099, -120.883, -2.10980635968831),
(40334, '95226', 218, 6, 180458, 38.2245, 0.667143379928573, -120.858, -2.10937002737531),
(40335, '95227', 218, 6, 461, 38.2045, 0.666794314078174, -121.0688, -2.11304918143851),
(40336, '95228', 218, 6, 177998, 37.9596, 0.66252000274004, -120.6407, -2.10557742691072),
(40337, '95229', 218, 6, 181195, 38.115, 0.665232244397639, -120.4562, -2.10235729444079);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(40338, '95230', 218, 6, 8849, 37.9105, 0.66166304607731, -120.98, -2.11149932906274),
(40339, '95231', 218, 6, 59979, 37.8768, 0.661074870119388, -121.2821, -2.11677196873301),
(40340, '95232', 218, 6, 2739, 38.3282, 0.668953286362891, -120.5402, -2.10382337101247),
(40341, '95233', 218, 6, 182048, 38.1853, 0.666459210861791, -120.3738, -2.10091914313715),
(40342, '95234', 218, 6, 3208, 37.9344, 0.662080179768537, -121.426, -2.11928349752663),
(40343, '95236', 218, 6, 3784, 38.0244, 0.663650976095332, -121.0651, -2.11298460425619),
(40344, '95237', 218, 6, 182862, 38.1587, 0.66599495328076, -121.1482, -2.11443497286459),
(40345, '95240', 218, 6, 112, 38.124, 0.665389324030318, -121.2703, -2.11656601988128),
(40346, '95241', 218, 6, 112, 38.1518, 0.665874525562373, -121.306, -2.11718910242424),
(40347, '95242', 218, 6, 112, 38.1296, 0.66548706246843, -121.3243, -2.11750849767736),
(40348, '95245', 218, 6, 183372, 38.3071, 0.66858502189072, -120.5985, -2.10484089796638),
(40349, '95246', 218, 6, 183498, 38.2415, 0.667440085901412, -120.5321, -2.10368199934306),
(40350, '95247', 218, 6, 156661, 38.1418, 0.665699992637173, -120.4449, -2.10216007223532),
(40351, '95248', 218, 6, 184352, 38.3152, 0.668726393560131, -120.5186, -2.10344637989404),
(40352, '95249', 218, 6, 184751, 38.2001, 0.666717519591086, -120.6539, -2.10580781037199),
(40353, '95250', 218, 6, 177685, 38.2179, 0.667028188197941, -120.4618, -2.10245503287891),
(40354, '95251', 218, 6, 185868, 38.0834, 0.664680720354008, -120.47, -2.10259814987757),
(40355, '95252', 218, 6, 12510, 38.1497, 0.665837873648081, -120.8547, -2.10931243150999),
(40356, '95253', 218, 6, 12551, 38.1421, 0.665705228624929, -121.2042, -2.11541235724571),
(40357, '95254', 218, 6, 721, 38.1708, 0.666206138120252, -120.9355, -2.1107226575456),
(40358, '95255', 218, 6, 6722, 38.404, 0.670276245935902, -120.5157, -2.10339576534573),
(40359, '95257', 218, 6, 186180, 38.3751, 0.669771845782076, -120.4856, -2.10287042124088),
(40360, '95258', 218, 6, 26188, 38.1556, 0.665940848073948, -121.3048, -2.11716815847322),
(40361, '95267', 218, 6, 510, 38.0005, 0.663233842404105, -121.3177, -2.11739330594672),
(40362, '95269', 218, 6, 510, 38.0183, 0.66354451101096, -121.3224, -2.11747533642157),
(40363, '95290', 218, 6, 510, 37.9579, 0.662490332142756, -121.2898, -2.11690635908542),
(40364, '95296', 218, 6, 183013, 38.0283, 0.66371904393616, -121.3, -2.11708438266912),
(40365, '95297', 218, 6, 510, 37.9699, 0.662699771652995, -121.3069, -2.11720481038751),
(40366, '95298', 218, 6, 510, 37.9306, 0.662013857256961, -121.4405, -2.11953657026817),
(40367, '95301', 218, 6, 18960, 37.3474, 0.65183509705933, -120.6135, -2.10510269735418),
(40368, '95303', 218, 6, 179915, 37.4488, 0.653604860920852, -120.6842, -2.10633664513534),
(40369, '95304', 218, 6, 38571, 37.753, 0.658914152505419, -121.3728, -2.11835498236457),
(40370, '95305', 218, 6, 180083, 37.8221, 0.660120175018547, -120.2146, -2.09814057896798),
(40371, '95306', 218, 6, 180601, 37.4372, 0.653402402727621, -120.0926, -2.09601127728054),
(40372, '95307', 218, 6, 19923, 37.5868, 0.656013415288605, -120.9539, -2.11104379812797),
(40373, '95309', 218, 6, 180696, 37.8619, 0.660814816060841, -120.4431, -2.10212865630878),
(40374, '95310', 218, 6, 1716, 38.043, 0.663975607336203, -120.39, -2.10120188647597),
(40375, '95311', 218, 6, 26866, 37.728, 0.658477820192421, -120.1978, -2.09784736365364),
(40376, '95312', 218, 6, 130367, 37.3983, 0.652723469648595, -120.6168, -2.1051602932195),
(40377, '95313', 218, 6, 180968, 37.426, 0.653206925851398, -121.0435, -2.11260761313776),
(40378, '95314', 218, 6, 8399, 38.3432, 0.66921508575069, -119.836, -2.09153276241992),
(40379, '95315', 218, 6, 20537, 37.4266, 0.65321739782691, -120.7721, -2.10787078954784),
(40380, '95316', 218, 6, 181106, 37.5445, 0.655275141015011, -120.7903, -2.10818843947171),
(40381, '95317', 218, 6, 101674, 37.1276, 0.647998863363447, -120.4789, -2.102753484181),
(40382, '95318', 218, 6, 15906, 37.6465, 0.657055376852045, -119.8529, -2.09182772306351),
(40383, '95319', 218, 6, 2294, 37.6438, 0.657008252962241, -120.9025, -2.11014669889244),
(40384, '95320', 218, 6, 181475, 37.8001, 0.659736202583109, -121.0066, -2.11196358664377),
(40385, '95321', 218, 6, 16295, 37.8452, 0.660523346075758, -120.1939, -2.09777929581281),
(40386, '95322', 218, 6, 94664, 37.2108, 0.649450977301106, -121.0028, -2.11189726413219),
(40387, '95323', 218, 6, 9453, 37.6213, 0.656615553880543, -120.7332, -2.10719185646882),
(40388, '95324', 218, 6, 182156, 37.3986, 0.652728705636351, -120.872, -2.10961437347059),
(40389, '95325', 218, 6, 182210, 37.5073, 0.654625878533269, -120.2149, -2.09814581495573),
(40390, '95326', 218, 6, 182232, 37.5959, 0.656172240250536, -120.8588, -2.10938399000932),
(40391, '95327', 218, 6, 3399, 37.9197, 0.661823616368494, -120.4384, -2.10204662583394),
(40392, '95328', 218, 6, 182468, 37.5595, 0.65553694040281, -120.9136, -2.11034043043942),
(40393, '95329', 218, 6, 3584, 37.6915, 0.657840775015443, -120.3508, -2.10051771740919),
(40394, '95330', 218, 6, 3680, 37.819, 0.660066069811736, -121.2866, -2.11685050854935),
(40395, '95333', 218, 6, 3703, 37.2416, 0.64998853871072, -120.2641, -2.09900451694771),
(40396, '95334', 218, 6, 3825, 37.3747, 0.652311571945125, -120.7277, -2.10709586335996),
(40397, '95335', 218, 6, 182903, 38.0824, 0.664663267061489, -120.1538, -2.09707941878276),
(40398, '95336', 218, 6, 183074, 37.8051, 0.659823469045708, -121.2202, -2.11569160992603),
(40399, '95337', 218, 6, 183074, 37.7831, 0.659439496610269, -121.2311, -2.1158818508145),
(40400, '95338', 218, 6, 66625, 37.4832, 0.654205254183538, -119.9075, -2.0927806728351),
(40401, '95340', 218, 6, 183223, 37.2992, 0.650993848359869, -120.4717, -2.10262782047485),
(40402, '95341', 218, 6, 183223, 37.3391, 0.651690234731415, -120.4873, -2.10290009183816),
(40403, '95342', 218, 6, 18960, 37.3512, 0.651901419570906, -120.5568, -2.1041130956683),
(40404, '95343', 218, 6, 183223, 37.2962, 0.650941488482309, -120.4841, -2.1028442413021),
(40405, '95344', 218, 6, 183223, 37.3788, 0.652383130444456, -120.617, -2.105163783878),
(40406, '95345', 218, 6, 183263, 37.5627, 0.655592790938874, -119.9468, -2.09346658723113),
(40407, '95346', 218, 6, 0, 38.0647, 0.664354343783886, -120.1809, -2.09755240301005),
(40408, '95347', 218, 6, 27924, 37.7893, 0.659547707023893, -120.3055, -2.09972708325804),
(40409, '95348', 218, 6, 183223, 37.3289, 0.651512211147711, -120.4978, -2.10308335140962),
(40410, '95350', 218, 6, 27927, 37.6656, 0.657388734739176, -120.992, -2.11170876857298),
(40411, '95351', 218, 6, 27927, 37.6281, 0.656734236269678, -121.0074, -2.11197754927779),
(40412, '95352', 218, 6, 27927, 37.6656, 0.657388734739176, -120.9945, -2.11175240180428),
(40413, '95353', 218, 6, 27927, 37.6646, 0.657371281446656, -120.9445, -2.11087973717828),
(40414, '95354', 218, 6, 27927, 37.6439, 0.657009998291493, -120.9699, -2.11132305080829),
(40415, '95355', 218, 6, 27927, 37.6774, 0.657594683590911, -120.9457, -2.11090068112931),
(40416, '95356', 218, 6, 27927, 37.7014, 0.65801356261139, -121.0297, -2.11236675770098),
(40417, '95357', 218, 6, 27927, 37.6561, 0.657222928460237, -120.9119, -2.11031075984213),
(40418, '95358', 218, 6, 27927, 37.6276, 0.656725509623418, -121.0509, -2.1127367675024),
(40419, '95360', 218, 6, 28051, 37.3461, 0.651812407779054, -121.079, -2.11322720502221),
(40420, '95361', 218, 6, 4701, 37.7815, 0.659411571342238, -120.8339, -2.10894940302558),
(40421, '95363', 218, 6, 428, 37.4828, 0.654198272866531, -121.1284, -2.1140893976727),
(40422, '95364', 218, 6, 14421, 38.3215, 0.668836349303007, -119.823, -2.09130586961717),
(40423, '95365', 218, 6, 184168, 37.292, 0.650868184653725, -120.3165, -2.09991906947576),
(40424, '95366', 218, 6, 176106, 37.78, 0.659385391403458, -121.1223, -2.11398293258833),
(40425, '95367', 218, 6, 113984, 37.7328, 0.658561595996516, -120.943, -2.1108535572395),
(40426, '95368', 218, 6, 137969, 37.7095, 0.658154934280802, -121.0902, -2.11342268189844),
(40427, '95369', 218, 6, 83693, 37.5115, 0.654699182361853, -120.4718, -2.1026295658041),
(40428, '95370', 218, 6, 12023, 38, 0.663225115757845, -120.3305, -2.10016341557104),
(40429, '95372', 218, 6, 185261, 37.9915, 0.663076762771426, -120.2616, -2.09896088371641),
(40430, '95373', 218, 6, 6044, 38.0078, 0.663361251439501, -120.2711, -2.09912668999535),
(40431, '95374', 218, 6, 185375, 37.3295, 0.651522683123223, -120.8717, -2.10960913748283),
(40432, '95375', 218, 6, 6113, 38.1963, 0.66665119707951, -120.0113, -2.09459232459867),
(40433, '95376', 218, 6, 38571, 37.7332, 0.658568577313524, -121.4222, -2.11921717501506),
(40434, '95377', 218, 6, 38571, 37.7171, 0.658287579303953, -121.4545, -2.11978091636345),
(40435, '95378', 218, 6, 38571, 37.8001, 0.659736202583109, -121.5497, -2.12144246981135),
(40436, '95379', 218, 6, 185771, 37.966, 0.662631703812167, -120.2421, -2.09862054451227),
(40437, '95380', 218, 6, 185777, 37.4976, 0.654456581595826, -120.8573, -2.10935781007054),
(40438, '95381', 218, 6, 185777, 37.4962, 0.654432146986298, -120.8567, -2.10934733809503),
(40439, '95382', 218, 6, 185777, 37.52, 0.654847535348272, -120.8501, -2.1092321463644),
(40440, '95383', 218, 6, 185786, 38.0438, 0.663989569970219, -120.2273, -2.09836223578298),
(40441, '95385', 218, 6, 185921, 37.6223, 0.656633007173063, -121.2466, -2.11615237684856),
(40442, '95386', 218, 6, 790, 37.6555, 0.657212456484725, -120.735, -2.10722327239535),
(40443, '95387', 218, 6, 186102, 37.5666, 0.655660858779702, -121.2143, -2.11558863550016),
(40444, '95388', 218, 6, 6892, 37.3982, 0.652721724319343, -120.6113, -2.10506430011064),
(40445, '95389', 218, 6, 0, 37.5828, 0.655943602118525, -119.6607, -2.08847320024118),
(40446, '95391', 218, 6, 38571, 37.7616, 0.659064250821091, -121.5472, -2.12139883658005),
(40447, '95397', 218, 6, 27927, 37.6595, 0.657282269654805, -120.9935, -2.11173494851176),
(40448, '95401', 218, 6, 57422, 38.4514, 0.671103532001348, -122.7611, -2.14258538837001),
(40449, '95402', 218, 6, 57422, 38.4697, 0.671422927254463, -122.6065, -2.13988710934643),
(40450, '95403', 218, 6, 57422, 38.4786, 0.67157826155789, -122.7505, -2.1424003834693),
(40451, '95404', 218, 6, 57422, 38.4575, 0.671209997085719, -122.6871, -2.14129384472354),
(40452, '95405', 218, 6, 57422, 38.444, 0.6709743776367, -122.6572, -2.14077199127719),
(40453, '95406', 218, 6, 57422, 38.4592, 0.671239667683003, -122.7288, -2.14202164702162),
(40454, '95407', 218, 6, 57422, 38.4062, 0.670314643179446, -122.7359, -2.14214556539851),
(40455, '95408', 218, 6, 57422, 38.511, 0.672143748235536, -122.7816, -2.14294318086667),
(40456, '95409', 218, 6, 57422, 38.4607, 0.671265847621783, -122.6398, -2.14046830398734),
(40457, '95410', 218, 6, 7043, 39.2111, 0.684362798328749, -123.7061, -2.15907874980136),
(40458, '95412', 218, 6, 26382, 38.6936, 0.675330719449678, -123.3296, -2.1525075851676),
(40459, '95415', 218, 6, 29261, 39.0041, 0.68074996677712, -123.3576, -2.15299627735816),
(40460, '95416', 218, 6, 180220, 38.3128, 0.668684505658084, -122.4854, -2.13777351562226),
(40461, '95417', 218, 6, 180230, 39.6622, 0.692235978584495, -123.6327, -2.15779767813039),
(40462, '95418', 218, 6, 180408, 39.225, 0.684605399094776, -123.204, -2.15031545162709),
(40463, '95419', 218, 6, 180441, 38.4253, 0.670648001066577, -122.9589, -2.14603764963046),
(40464, '95420', 218, 6, 180586, 39.3678, 0.687097729266624, -123.8084, -2.16086422162615),
(40465, '95421', 218, 6, 180609, 38.5324, 0.672517248695463, -123.1362, -2.14913211839424),
(40466, '95422', 218, 6, 180759, 38.9565, 0.679919190053171, -122.6401, -2.1404735399751),
(40467, '95423', 218, 6, 180761, 39.0276, 0.681160119151339, -122.6684, -2.14096746815341),
(40468, '95424', 218, 6, 180762, 38.9723, 0.680194952074986, -122.6617, -2.14085053109353),
(40469, '95425', 218, 6, 1638, 38.7939, 0.677081284689428, -123.0069, -2.14687540767141),
(40470, '95426', 218, 6, 20127, 38.8379, 0.677849229560306, -122.7262, -2.14197626846107),
(40471, '95427', 218, 6, 180833, 39.2598, 0.68521277367447, -123.5838, -2.15694421212617),
(40472, '95428', 218, 6, 180918, 39.7963, 0.694576465111419, -123.248, -2.15108339649797),
(40473, '95429', 218, 6, 181191, 39.7135, 0.693131332490768, -123.3247, -2.15242206403425),
(40474, '95430', 218, 6, 181223, 38.4965, 0.671890675493997, -123.1463, -2.14930839664869),
(40475, '95431', 218, 6, 2252, 38.3299, 0.668982956960175, -122.5227, -2.13842452343326),
(40476, '95432', 218, 6, 29713, 39.1437, 0.683186446412904, -123.7131, -2.159200922849),
(40477, '95433', 218, 6, 181396, 38.2988, 0.668440159562804, -122.4865, -2.13779271424403),
(40478, '95435', 218, 6, 2445, 39.0065, 0.680791854679168, -122.8703, -2.14449128791319),
(40479, '95436', 218, 6, 35957, 38.4933, 0.671834824957933, -122.915, -2.14527145008883),
(40480, '95437', 218, 6, 181646, 39.4413, 0.688380546266839, -123.7868, -2.16048723050772),
(40481, '95439', 218, 6, 2628, 38.4926, 0.671822607653169, -122.7758, -2.14284195177005),
(40482, '95441', 218, 6, 181769, 38.7053, 0.675534922972161, -122.886, -2.14476530460575),
(40483, '95442', 218, 6, 47454, 38.371, 0.669700287282744, -122.5274, -2.1385065539081),
(40484, '95443', 218, 6, 81238, 39.0327, 0.681249130943191, -122.741, -2.14223457719036),
(40485, '95444', 218, 6, 181888, 38.4345, 0.670808571357761, -122.8667, -2.14442845606012),
(40486, '95445', 218, 6, 181950, 38.8046, 0.677268034919392, -123.5593, -2.15651660645943),
(40487, '95446', 218, 6, 181957, 38.4934, 0.671836570287185, -122.9818, -2.14643733002916),
(40488, '95448', 218, 6, 182069, 38.62, 0.67404615712021, -122.8613, -2.14433420828051),
(40489, '95449', 218, 6, 182208, 38.9807, 0.680341559732154, -123.1129, -2.14872545667853),
(40490, '95450', 218, 6, 182370, 38.4979, 0.671915110103525, -123.1953, -2.15016360798217),
(40491, '95451', 218, 6, 182438, 38.9672, 0.680105940283134, -122.7791, -2.14289954763537),
(40492, '95452', 218, 6, 9842, 38.4126, 0.670426344251574, -122.554, -2.13897081148913),
(40493, '95453', 218, 6, 9947, 39.0514, 0.681575507513314, -122.9131, -2.14523828883304),
(40494, '95454', 218, 6, 182749, 39.7345, 0.693497851633687, -123.5063, -2.15559158195587),
(40495, '95456', 218, 6, 3805, 39.2651, 0.685305276124825, -123.7629, -2.16007009681649),
(40496, '95457', 218, 6, 182985, 38.9038, 0.67899940153737, -122.6122, -2.13998659311379),
(40497, '95458', 218, 6, 10223, 39.0753, 0.68199264120454, -122.7823, -2.14295539817143),
(40498, '95459', 218, 6, 585, 38.9867, 0.680446279487273, -123.666, -2.15837887277131),
(40499, '95460', 218, 6, 183213, 39.3164, 0.686200630031099, -123.787, -2.16049072116622),
(40500, '95461', 218, 6, 14224, 38.7899, 0.677011471519348, -122.6053, -2.1398661653954),
(40501, '95462', 218, 6, 183407, 38.4687, 0.671405473961943, -123.0112, -2.14695045682925),
(40502, '95463', 218, 6, 96443, 39.1643, 0.683545984238815, -123.5569, -2.15647471855738),
(40503, '95464', 218, 6, 183635, 39.122, 0.682807709965222, -122.8425, -2.14400608638113),
(40504, '95465', 218, 6, 183774, 38.4012, 0.670227376716847, -122.9649, -2.14614236938558),
(40505, '95466', 218, 6, 73882, 39.1098, 0.682594779796478, -123.514, -2.15572597230828),
(40506, '95468', 218, 6, 184199, 38.896, 0.678863265855714, -123.6527, -2.15814674398079),
(40507, '95469', 218, 6, 184264, 39.3462, 0.686720738148193, -123.1129, -2.14872545667853),
(40508, '95470', 218, 6, 184476, 39.2816, 0.685593255451404, -123.2109, -2.15043587934548),
(40509, '95471', 218, 6, 184572, 38.5237, 0.67236540505054, -122.9802, -2.14640940476113),
(40510, '95472', 218, 6, 28559, 38.3923, 0.670072042413419, -122.8441, -2.14403401164917),
(40511, '95473', 218, 6, 28559, 38.4024, 0.67024832066787, -122.8227, -2.14366051118924),
(40512, '95476', 218, 6, 5950, 38.2933, 0.668344166453945, -122.4702, -2.13750822557596),
(40513, '95480', 218, 6, 185378, 38.6225, 0.67408979035151, -123.3776, -2.15334534320856),
(40514, '95481', 218, 6, 34112, 39.1278, 0.682908939061837, -123.1643, -2.14962255591405),
(40515, '95482', 218, 6, 185812, 39.1533, 0.683353998021096, -123.2034, -2.15030497965158),
(40516, '95485', 218, 6, 185840, 39.1567, 0.683413339215664, -122.9056, -2.14510738913914),
(40517, '95486', 218, 6, 185951, 38.4748, 0.671511939046314, -123.0216, -2.14713197107146),
(40518, '95487', 218, 6, 185955, 38.2517, 0.667618109485115, -122.4533, -2.13721326493237),
(40519, '95488', 218, 6, 25961, 39.6423, 0.691888658063348, -123.7818, -2.16039996404512),
(40520, '95490', 218, 6, 186163, 39.4364, 0.688295025133492, -123.3717, -2.15324236878269),
(40521, '95492', 218, 6, 18652, 38.5392, 0.672635931084599, -122.8061, -2.14337078653341),
(40522, '95493', 218, 6, 0, 39.1846, 0.68390028607697, -122.9632, -2.14611269878829),
(40523, '95494', 218, 6, 26297, 38.8964, 0.678870247172722, -123.2287, -2.15074654795234),
(40524, '95497', 218, 6, 0, 38.741, 0.676158005515123, -123.4824, -2.15517444826465),
(40525, '95501', 218, 6, 2334, 40.7817, 0.711774939560571, -124.1471, -2.16677565180265),
(40526, '95502', 218, 6, 2334, 40.7828, 0.711794138182343, -124.1905, -2.16753312469802),
(40527, '95503', 218, 6, 2334, 40.7607, 0.711408420417653, -124.1558, -2.16692749544758),
(40528, '95511', 218, 6, 193339, 40.1576, 0.700882339698875, -123.5851, -2.15696690140644),
(40529, '95514', 218, 6, 193386, 40.2934, 0.703252496823083, -123.6358, -2.15785178333721),
(40530, '95518', 218, 6, 193350, 40.8677, 0.713275922717287, -124.0805, -2.16561326252082),
(40531, '95519', 218, 6, 49360, 40.933, 0.714415622718839, -124.0498, -2.16507744644046),
(40532, '95521', 218, 6, 193350, 40.9102, 0.714017687649384, -124.0821, -2.16564118778886),
(40533, '95524', 218, 6, 25, 40.8252, 0.712534157785189, -124.0506, -2.16509140907448),
(40534, '95525', 218, 6, 15260, 40.9076, 0.713972309088832, -123.9395, -2.16315234827551),
(40535, '95526', 218, 6, 1134, 40.4872, 0.706634944913448, -123.6956, -2.1588954902299),
(40536, '95527', 218, 6, 193413, 40.7742, 0.711644039866672, -123.4295, -2.15425116909034),
(40537, '95528', 218, 6, 193431, 40.4875, 0.706640180901204, -123.8842, -2.16218718119916),
(40538, '95531', 218, 6, 15666, 41.7832, 0.729254412019295, -124.1689, -2.16715613357959),
(40539, '95532', 218, 6, 15666, 41.7558, 0.728776191804248, -124.2001, -2.16770067630621),
(40540, '95534', 218, 6, 193477, 40.7943, 0.711994851046323, -124.1587, -2.16697810999588),
(40541, '95536', 218, 6, 8879, 40.5676, 0.708038189632052, -124.2436, -2.16845989453083),
(40542, '95537', 218, 6, 21075, 40.7254, 0.710792319191699, -124.2152, -2.16796422102326),
(40543, '95538', 218, 6, 193564, 41.869, 0.730751904517506, -124.149, -2.16680881305844),
(40544, '95540', 218, 6, 54818, 40.582, 0.708289517044339, -124.1394, -2.16664126145025),
(40545, '95542', 218, 6, 193581, 40.1755, 0.701194753634982, -123.9129, -2.16268809069448),
(40546, '95543', 218, 6, 193582, 41.8838, 0.731010213246801, -123.8732, -2.16199519498144),
(40547, '95545', 218, 6, 193646, 40.2442, 0.702393794831102, -124.1159, -2.16623110907603),
(40548, '95546', 218, 6, 193649, 41.1664, 0.718489221192994, -123.726, -2.1594260703225),
(40549, '95547', 218, 6, 149793, 40.5491, 0.707715303720433, -124.0902, -2.16578255945827),
(40550, '95548', 218, 6, 193708, 41.539, 0.724992317985925, -124.0303, -2.16473710723632),
(40551, '95549', 218, 6, 131601, 40.7302, 0.710876094995795, -123.9571, -2.16345952622386),
(40552, '95550', 218, 6, 182513, 40.7753, 0.711663238488444, -123.8849, -2.16219939850392),
(40553, '95551', 218, 6, 163941, 40.652, 0.709511247520735, -124.2266, -2.16816318855799),
(40554, '95552', 218, 6, 73319, 40.5015, 0.706884526996483, -123.5516, -2.15638221610703),
(40555, '95553', 218, 6, 170894, 40.2112, 0.701817836177944, -123.8449, -2.16150126680313),
(40556, '95554', 218, 6, 193812, 40.2941, 0.703264714127847, -123.8045, -2.16079615378532),
(40557, '95555', 218, 6, 193836, 41.2874, 0.720601069587907, -124.0678, -2.16539160570582),
(40558, '95556', 218, 6, 28158, 41.2879, 0.720609796234167, -123.5512, -2.15637523479002),
(40559, '95558', 218, 6, 28229, 40.2611, 0.702688755474689, -124.1906, -2.16753487002727),
(40560, '95559', 218, 6, 4988, 40.2129, 0.701847506775228, -123.7842, -2.16044185194716),
(40561, '95560', 218, 6, 193902, 40.1218, 0.700257511826661, -123.8695, -2.16193061779912),
(40562, '95562', 218, 6, 184568, 40.5034, 0.706917688252271, -124.107, -2.1660757747726),
(40563, '95563', 218, 6, 193926, 40.8854, 0.71358484599489, -123.5404, -2.1561867392308),
(40564, '95564', 218, 6, 57408, 40.8027, 0.71214145870349, -124.1928, -2.16757326727081),
(40565, '95565', 218, 6, 11826, 40.4511, 0.706004881053478, -124.0025, -2.16425190570427),
(40566, '95567', 218, 6, 193966, 41.9274, 0.731771176800671, -124.1644, -2.16707759376325),
(40567, '95568', 218, 6, 193969, 41.4334, 0.723149250295819, -123.4866, -2.15524775209323),
(40568, '95569', 218, 6, 193900, 40.3915, 0.70496466481929, -123.9196, -2.16280502775437),
(40569, '95570', 218, 6, 13233, 41.0704, 0.716813705111079, -124.1251, -2.16639167936721),
(40570, '95571', 218, 6, 194047, 40.322, 0.703751660989154, -123.9228, -2.16286087829043),
(40571, '95573', 218, 6, 26094, 40.952, 0.714747235276718, -123.6458, -2.1580263162624),
(40572, '95585', 218, 6, 60612, 39.848, 0.6954788003347, -123.6339, -2.15781862208142),
(40573, '95587', 218, 6, 184103, 39.9474, 0.697213657611183, -123.7488, -2.15982400539196),
(40574, '95589', 218, 6, 194058, 40.0857, 0.699627447966691, -124.0516, -2.165108862367),
(40575, '95595', 218, 6, 194078, 40.1835, 0.701334379975141, -123.4175, -2.1540417295801),
(40576, '95601', 218, 6, 179722, 38.4238, 0.670621821127797, -120.8277, -2.10884119261195),
(40577, '95602', 218, 6, 13306, 38.9712, 0.680175753453214, -121.096, -2.11352391099505),
(40578, '95603', 218, 6, 13306, 38.9198, 0.679278654217689, -121.0843, -2.11331970747257),
(40579, '95604', 218, 6, 13306, 38.9599, 0.679978531247739, -121.0362, -2.11248020410236),
(40580, '95605', 218, 6, 186087, 38.5921, 0.673559210258904, -121.5241, -2.12099566552284),
(40581, '95606', 218, 6, 1162, 38.7382, 0.676109136296067, -122.1488, -2.13189873736005),
(40582, '95607', 218, 6, 180511, 38.6883, 0.675238216999322, -122.1379, -2.13170849647158),
(40583, '95608', 218, 6, 45406, 38.6283, 0.674191019448126, -121.328, -2.11757307485968),
(40584, '95609', 218, 6, 45406, 38.6261, 0.674152622204582, -121.3272, -2.11755911222566),
(40585, '95610', 218, 6, 180736, 38.6947, 0.67534991807145, -121.2651, -2.11647526276018),
(40586, '95611', 218, 6, 180736, 38.7071, 0.675566338898697, -121.2796, -2.11672833550172),
(40587, '95612', 218, 6, 26799, 38.4142, 0.670454269519606, -121.5303, -2.12110387593646),
(40588, '95613', 218, 6, 29534, 38.828, 0.677676441964358, -120.8832, -2.10980985034681),
(40589, '95614', 218, 6, 93427, 38.9057, 0.679032562793158, -120.958, -2.1111153566273),
(40590, '95615', 218, 6, 1839, 38.3169, 0.668756064157415, -121.5578, -2.12158384148076),
(40591, '95616', 218, 6, 20476, 38.5551, 0.672913438435666, -121.7454, -2.1248580791575),
(40592, '95617', 218, 6, 20476, 38.5498, 0.67282093598531, -121.7254, -2.12450901330711),
(40593, '95618', 218, 6, 181355, 38.5434, 0.672709234913182, -121.6851, -2.12380564561855),
(40594, '95619', 218, 6, 32238, 38.6649, 0.674829809954356, -120.8242, -2.10878010608813),
(40595, '95620', 218, 6, 828, 38.44, 0.67090456446662, -121.8232, -2.12621594531556),
(40596, '95621', 218, 6, 180736, 38.696, 0.675372607351726, -121.3101, -2.11726066092357),
(40597, '95623', 218, 6, 8703, 38.673, 0.674971181623767, -120.8466, -2.10917105984058),
(40598, '95624', 218, 6, 119505, 38.4121, 0.670417617605314, -121.3643, -2.11820662937815),
(40599, '95625', 218, 6, 54613, 38.3499, 0.669332022810573, -121.9029, -2.1276069727294),
(40600, '95626', 218, 6, 181434, 38.7167, 0.675733890506889, -121.4318, -2.11938472662325),
(40601, '95627', 218, 6, 181483, 38.6933, 0.675325483461922, -122.0164, -2.12958792143041),
(40602, '95628', 218, 6, 2362, 38.6554, 0.674664003675416, -121.2567, -2.11632865510301),
(40603, '95629', 218, 6, 161612, 38.5005, 0.671960488664077, -120.7251, -2.10705048479941),
(40604, '95630', 218, 6, 2511, 38.6835, 0.675154441195227, -121.1583, -2.11461125111905),
(40605, '95631', 218, 6, 181643, 39.0101, 0.68085468653224, -120.8548, -2.10931417683924),
(40606, '95632', 218, 6, 32508, 38.2755, 0.66803349784709, -121.2923, -2.11694999231672),
(40607, '95633', 218, 6, 21343, 38.8491, 0.678044706436529, -120.8432, -2.10911171864601),
(40608, '95634', 218, 6, 2693, 38.9158, 0.679208841047609, -120.7916, -2.10821112875198),
(40609, '95635', 218, 6, 2869, 38.9145, 0.679186151767333, -120.9009, -2.11011877362441),
(40610, '95636', 218, 6, 0, 38.6317, 0.674250360642693, -120.547, -2.1039420534016),
(40611, '95637', 218, 6, 181963, 38.8114, 0.677386717308527, -122.2221, -2.13317806370176),
(40612, '95638', 218, 6, 27414, 38.3077, 0.668595493866232, -121.1754, -2.11490970242114),
(40613, '95639', 218, 6, 3219, 38.3674, 0.669637455429672, -121.5197, -2.12091887103575),
(40614, '95640', 218, 6, 9667, 38.329, 0.668967248996907, -120.9355, -2.1107226575456),
(40615, '95641', 218, 6, 182332, 38.1645, 0.666096182377376, -121.6118, -2.12252631927684),
(40616, '95642', 218, 6, 3384, 38.3614, 0.669532735674553, -120.741, -2.10732799215047),
(40617, '95644', 218, 6, 182497, 38.4558, 0.671180326488435, -120.5297, -2.10364011144101),
(40618, '95645', 218, 6, 22422, 38.86, 0.678234947324996, -121.7344, -2.12466609293979),
(40619, '95646', 218, 6, 14059, 38.6913, 0.675290576876882, -120.0794, -2.09578089381928),
(40620, '95648', 218, 6, 3781, 38.9168, 0.679226294340129, -121.2911, -2.11692904836569),
(40621, '95650', 218, 6, 131833, 38.808, 0.677327376113959, -121.1681, -2.11478229338574),
(40622, '95651', 218, 6, 16948, 38.8383, 0.677856210877314, -120.9271, -2.11057604988843),
(40623, '95652', 218, 6, 0, 38.6653, 0.674836791271364, -121.3888, -2.11863423504489),
(40624, '95653', 218, 6, 3938, 38.6799, 0.675091609342155, -121.9693, -2.12876587135272),
(40625, '95654', 218, 6, 142362, 38.3669, 0.669628728783412, -120.7947, -2.10826523395879),
(40626, '95655', 218, 6, 78703, 38.5468, 0.67276857610775, -121.2784, -2.11670739155069),
(40627, '95656', 218, 6, 0, 38.5623, 0.673039102141809, -120.715, -2.10687420654495),
(40628, '95658', 218, 6, 10795, 38.8747, 0.67849151072504, -121.1448, -2.11437563167003),
(40629, '95659', 218, 6, 183640, 38.8737, 0.67847405743252, -121.5673, -2.1217496477597),
(40630, '95660', 218, 6, 4615, 38.6848, 0.675177130475502, -121.3772, -2.11843177685166),
(40631, '95661', 218, 6, 11688, 38.7342, 0.676039323125988, -121.2251, -2.11577713105938),
(40632, '95662', 218, 6, 183876, 38.6845, 0.675171894487746, -121.2259, -2.11579109369339),
(40633, '95663', 218, 6, 165836, 38.8543, 0.678135463557633, -121.1762, -2.11492366505515),
(40634, '95664', 218, 6, 184109, 38.82, 0.677536815624199, -121.0259, -2.11230043518941),
(40635, '95665', 218, 6, 557, 38.4049, 0.67029195389917, -120.6566, -2.10585493426179),
(40636, '95666', 218, 6, 42592, 38.4636, 0.671316462170091, -120.5345, -2.10372388724511),
(40637, '95667', 218, 6, 184159, 38.7232, 0.675847336908268, -120.8026, -2.1084031149697),
(40638, '95668', 218, 6, 5115, 38.8198, 0.677533324965695, -121.5042, -2.12064834500169),
(40639, '95669', 218, 6, 14433, 38.4896, 0.67177024777561, -120.8611, -2.10942413258212),
(40640, '95670', 218, 6, 184388, 38.6074, 0.673826245634459, -121.278, -2.11670041023368),
(40641, '95671', 218, 6, 0, 38.6758, 0.675020050842823, -121.1487, -2.11444369951085),
(40642, '95672', 218, 6, 57140, 38.7185, 0.675765306433424, -120.9875, -2.11163022875664),
(40643, '95673', 218, 6, 184571, 38.6897, 0.67526265160885, -121.4538, -2.11976869905869),
(40644, '95674', 218, 6, 184573, 38.9604, 0.679987257893999, -121.4937, -2.12046508543023),
(40645, '95675', 218, 6, 83307, 38.5458, 0.67275112281523, -120.7414, -2.10733497346748),
(40646, '95676', 218, 6, 14501, 38.8813, 0.678606702455671, -121.7166, -2.12435542433293),
(40647, '95677', 218, 6, 184637, 38.7917, 0.677042887445884, -121.2387, -2.11601449583765),
(40648, '95678', 218, 6, 11688, 38.7488, 0.676294141196779, -121.2959, -2.11701282416979),
(40649, '95679', 218, 6, 38037, 38.9004, 0.678940060342802, -122.2918, -2.1343945581904),
(40650, '95680', 218, 6, 166761, 38.238, 0.667378999377592, -121.5593, -2.12161002141954),
(40651, '95681', 218, 6, 11906, 38.9996, 0.680671426960781, -121.3552, -2.11804780441622),
(40652, '95682', 218, 6, 185114, 38.658, 0.674709382235968, -120.9629, -2.11120087776065),
(40653, '95683', 218, 6, 185194, 38.5047, 0.672033792492661, -121.1025, -2.11363735739643),
(40654, '95684', 218, 6, 5946, 38.6076, 0.673829736292963, -120.6503, -2.10574497851891),
(40655, '95685', 218, 6, 185500, 38.4261, 0.670661963700593, -120.7826, -2.1080540491193),
(40656, '95686', 218, 6, 351, 38.224, 0.667134653282312, -121.4386, -2.11950340901239),
(40657, '95687', 218, 6, 185846, 38.3445, 0.669237775030966, -121.9541, -2.12850058130642),
(40658, '95688', 218, 6, 185846, 38.3679, 0.669646182075932, -121.9797, -2.12894738559493),
(40659, '95689', 218, 6, 185976, 38.4755, 0.671524156351078, -120.6035, -2.10492816442898),
(40660, '95690', 218, 6, 72, 38.2479, 0.667551786973539, -121.5384, -2.12124524760588),
(40661, '95691', 218, 6, 186087, 38.5648, 0.673082735373109, -121.5412, -2.12129411682493),
(40662, '95692', 218, 6, 31509, 39.0252, 0.681118231249291, -121.4216, -2.11920670303955),
(40663, '95693', 218, 6, 287, 38.4071, 0.670330351142714, -121.2265, -2.11580156566891),
(40664, '95694', 218, 6, 99170, 38.526, 0.672405547623335, -121.9736, -2.12884092051056),
(40665, '95695', 218, 6, 6917, 38.6733, 0.674976417611523, -121.7757, -2.12538691392086),
(40666, '95696', 218, 6, 185846, 38.3174, 0.668764790803675, -121.9227, -2.12795254792129),
(40667, '95697', 218, 6, 58383, 38.7326, 0.676011397857956, -121.8081, -2.1259524005985),
(40668, '95698', 218, 6, 186294, 38.7907, 0.677025434153364, -121.9234, -2.12796476522605),
(40669, '95699', 218, 6, 78147, 38.4434, 0.670963905661188, -120.8496, -2.10922341971814),
(40670, '95701', 218, 6, 29092, 39.2137, 0.6844081768893, -120.8003, -2.10836297239691),
(40671, '95703', 218, 6, 26384, 38.995, 0.680591141815189, -120.9932, -2.111729712524),
(40672, '95709', 218, 6, 180434, 38.7589, 0.67647041945123, -120.6175, -2.10517251052426),
(40673, '95712', 218, 6, 0, 39.1628, 0.683519804300035, -120.9577, -2.11111012063955),
(40674, '95713', 218, 6, 8175, 39.0779, 0.682038019765092, -120.963, -2.1112026230899),
(40675, '95714', 218, 6, 181238, 39.2003, 0.684174302769533, -120.8268, -2.10882548464868),
(40676, '95715', 218, 6, 181446, 39.2826, 0.685610708743924, -120.6946, -2.10651815937755),
(40677, '95717', 218, 6, 181827, 39.1635, 0.683532021604799, -120.8565, -2.10934384743653),
(40678, '95720', 218, 6, 182523, 38.7768, 0.676782833387337, -120.2811, -2.09930122292055),
(40679, '95721', 218, 6, 119465, 38.9173, 0.679235020986389, -120.0122, -2.09460803256194),
(40680, '95722', 218, 6, 14197, 39.0044, 0.680755202764876, -121.0273, -2.11232486979893),
(40681, '95724', 218, 6, 10824, 39.3178, 0.686225064640626, -120.3233, -2.10003775186489),
(40682, '95726', 218, 6, 184211, 38.7481, 0.676281923892015, -120.5841, -2.10458957055409),
(40683, '95728', 218, 6, 98159, 39.3215, 0.68628964182295, -120.4094, -2.10154048035086),
(40684, '95735', 218, 6, 12421, 38.7892, 0.676999254214585, -120.1917, -2.09774089856927),
(40685, '95736', 218, 6, 98966, 39.0355, 0.681298000162247, -120.9597, -2.11114502722458),
(40686, '95741', 218, 6, 184388, 38.5886, 0.673498123735084, -121.3021, -2.11712103458341),
(40687, '95742', 218, 6, 184388, 38.5853, 0.673440527869768, -121.2028, -2.11538792263618),
(40688, '95743', 218, 6, 184388, 38.595, 0.673609824807211, -121.3007, -2.11709659997389),
(40689, '95746', 218, 6, 181872, 38.7463, 0.676250507965479, -121.1917, -2.11519419108921),
(40690, '95747', 218, 6, 11688, 38.7664, 0.67660131914513, -121.3913, -2.11867786827619),
(40691, '95758', 218, 6, 119505, 38.4085, 0.670354785752242, -121.429, -2.11933585740419),
(40692, '95759', 218, 6, 119505, 38.407, 0.670328605813462, -121.3752, -2.11839687026662),
(40693, '95762', 218, 6, 181348, 38.6968, 0.675386569985742, -121.0779, -2.11320800640044),
(40694, '95763', 218, 6, 2511, 38.6775, 0.675049721440107, -121.1748, -2.11489923044563),
(40695, '95765', 218, 6, 184637, 38.8063, 0.677297705516676, -121.2882, -2.11687843381739),
(40696, '95776', 218, 6, 6917, 38.6782, 0.675061938744871, -121.6796, -2.12370965250969),
(40697, '95798', 218, 6, 186087, 38.5748, 0.673257268298309, -121.5634, -2.12168157991887),
(40698, '95799', 218, 6, 186087, 38.5392, 0.672635931084599, -121.5568, -2.12156638818824),
(40699, '95812', 218, 6, 28490, 38.5817, 0.673377696016696, -121.4948, -2.12048428405201),
(40700, '95813', 218, 6, 28490, 38.5055, 0.672047755126676, -121.4145, -2.11908278466266),
(40701, '95814', 218, 6, 28490, 38.582, 0.673382932004452, -121.4896, -2.1203935269309),
(40702, '95815', 218, 6, 28490, 38.612, 0.673906530780051, -121.4425, -2.11957147685321),
(40703, '95816', 218, 6, 28490, 38.5714, 0.673197927103741, -121.4662, -2.11998511988594),
(40704, '95817', 218, 6, 28490, 38.5504, 0.672831407960822, -121.4579, -2.11984025755802),
(40705, '95818', 218, 6, 28490, 38.5559, 0.672927401069682, -121.4935, -2.12046159477173),
(40706, '95819', 218, 6, 28490, 38.5678, 0.673135095250669, -121.4392, -2.1195138809879),
(40707, '95820', 218, 6, 28490, 38.5346, 0.672555645939007, -121.4457, -2.11962732738928),
(40708, '95821', 218, 6, 28490, 38.6244, 0.674122951607298, -121.3799, -2.11847890074147),
(40709, '95822', 218, 6, 28490, 38.5132, 0.67218214547908, -121.4964, -2.12051220932004),
(40710, '95823', 218, 6, 28490, 38.4792, 0.671588733533402, -121.4447, -2.11960987409676),
(40711, '95824', 218, 6, 28490, 38.5181, 0.672267666612428, -121.4407, -2.11954006092668),
(40712, '95825', 218, 6, 28490, 38.5932, 0.673578408880676, -121.4023, -2.11886985449391),
(40713, '95826', 218, 6, 28490, 38.5514, 0.672848861253342, -121.3705, -2.11831483979178),
(40714, '95827', 218, 6, 28490, 38.5664, 0.673110660641141, -121.3278, -2.11756958420118),
(40715, '95828', 218, 6, 28490, 38.4841, 0.67167425466675, -121.3986, -2.11880527731159),
(40716, '95829', 218, 6, 28490, 38.4811, 0.67162189478919, -121.3525, -2.11800068052642),
(40717, '95830', 218, 6, 28490, 38.4944, 0.671854023579705, -121.273, -2.11661314377108),
(40718, '95831', 218, 6, 28490, 38.4953, 0.671869731542973, -121.531, -2.12111609324123),
(40719, '95832', 218, 6, 28490, 38.4712, 0.671449107193243, -121.4835, -2.12028706184653),
(40720, '95833', 218, 6, 28490, 38.6177, 0.674006014547414, -121.496, -2.12050522800303),
(40721, '95834', 218, 6, 28490, 38.6364, 0.674332391117537, -121.4971, -2.1205244266248),
(40722, '95835', 218, 6, 28490, 38.6713, 0.674941511026483, -121.5076, -2.12070768619626),
(40723, '95836', 218, 6, 28490, 38.7161, 0.675723418531377, -121.5142, -2.12082287792689),
(40724, '95837', 218, 6, 28490, 38.6938, 0.675334210108182, -121.6063, -2.12243032616798),
(40725, '95838', 218, 6, 28490, 38.6417, 0.674424893567893, -121.4427, -2.11957496751172),
(40726, '95840', 218, 6, 28490, 38.5851, 0.673437037211264, -121.4928, -2.12044937746697),
(40727, '95841', 218, 6, 28490, 38.6623, 0.674784431393804, -121.3415, -2.1178086943087),
(40728, '95842', 218, 6, 28490, 38.6961, 0.675374352680978, -121.3531, -2.11801115250193),
(40729, '95843', 218, 6, 31653, 38.708, 0.675582046861965, -121.3687, -2.11828342386524),
(40730, '95851', 218, 6, 28490, 38.6058, 0.673798320366427, -121.4439, -2.11959591146274),
(40731, '95852', 218, 6, 28490, 38.6059, 0.673800065695679, -121.4423, -2.11956798619471),
(40732, '95853', 218, 6, 28490, 38.6057, 0.673796575037175, -121.4431, -2.11958194882873),
(40733, '95857', 218, 6, 28490, 38.5812, 0.673368969370436, -121.4934, -2.12045984944248),
(40734, '95860', 218, 6, 28490, 38.6103, 0.673876860182767, -121.3795, -2.11847191942446),
(40735, '95864', 218, 6, 28490, 38.5865, 0.673461471820792, -121.3767, -2.1184230502054),
(40736, '95865', 218, 6, 28490, 38.5909, 0.67353826630788, -121.4065, -2.1189431583225),
(40737, '95866', 218, 6, 28490, 38.5901, 0.673524303673864, -121.4077, -2.11896410227352),
(40738, '95867', 218, 6, 28490, 38.5853, 0.673440527869768, -121.4929, -2.12045112279622),
(40739, '95873', 218, 6, 28490, 38.5816, 0.673375950687444, -121.4938, -2.12046683075949),
(40740, '95887', 218, 6, 28490, 38.6175, 0.67400252388891, -121.3689, -2.11828691452375),
(40741, '95894', 218, 6, 28490, 38.556, 0.672929146398934, -121.4972, -2.12052617195405),
(40742, '95899', 218, 6, 28490, 38.5792, 0.673334062785396, -121.5294, -2.1210881679732),
(40743, '95901', 218, 6, 10343, 39.1738, 0.683711790517755, -121.5228, -2.12097297624257),
(40744, '95903', 218, 6, 0, 39.1033, 0.682481333395099, -121.342, -2.11781742095496),
(40745, '95910', 218, 6, 99354, 39.5148, 0.689663363267055, -120.746, -2.10741525861307),
(40746, '95912', 218, 6, 108004, 39.0303, 0.681207243041143, -122.017, -2.12959839340592),
(40747, '95913', 218, 6, 179829, 39.7269, 0.693365206610535, -122.1446, -2.13182543353147),
(40748, '95914', 218, 6, 34662, 39.4072, 0.687785388991909, -121.3903, -2.11866041498367),
(40749, '95915', 218, 6, 58605, 39.944, 0.697154316416615, -121.0242, -2.11227076459212),
(40750, '95916', 218, 6, 180054, 39.6375, 0.691804882259252, -121.3905, -2.11866390564218),
(40751, '95917', 218, 6, 34819, 39.415, 0.687921524673565, -121.6916, -2.12391909201993),
(40752, '95918', 218, 6, 29320, 39.2844, 0.68564212467046, -121.365, -2.11821884668292),
(40753, '95919', 218, 6, 1191, 39.4486, 0.688507955302235, -121.2682, -2.11652936796699),
(40754, '95920', 218, 6, 180348, 39.4621, 0.688743574751254, -121.944, -2.12832430305197),
(40755, '95922', 218, 6, 180461, 39.4376, 0.688315969084516, -121.0746, -2.11315041053513),
(40756, '95923', 218, 6, 193428, 40.2275, 0.702102324846019, -121.1749, -2.11490097577488),
(40757, '95924', 218, 6, 19882, 39.198, 0.684134160196737, -121.0206, -2.11220793273905),
(40758, '95925', 218, 6, 159960, 39.4669, 0.68882735055535, -121.2077, -2.11547344376953),
(40759, '95926', 218, 6, 1548, 39.7584, 0.693914985324914, -121.8518, -2.12671510948163),
(40760, '95927', 218, 6, 1548, 39.7518, 0.693799793594282, -121.81, -2.12598556185429),
(40761, '95928', 218, 6, 1548, 39.7253, 0.693337281342503, -121.8125, -2.12602919508559),
(40762, '95929', 218, 6, 1548, 39.754, 0.693838190837826, -121.8071, -2.12593494730599),
(40763, '95930', 218, 6, 72152, 39.528, 0.689893746728319, -121.2272, -2.11581378297367),
(40764, '95931', 218, 6, 8176, 39.0079, 0.680816289288696, -122.0062, -2.12940989784671),
(40765, '95932', 218, 6, 119205, 39.2085, 0.684317419768197, -122.0123, -2.12951636293108),
(40766, '95934', 218, 6, 124600, 40.0878, 0.699664099880983, -120.8948, -2.11001230854004),
(40767, '95935', 218, 6, 35596, 39.3749, 0.687221647643515, -121.2158, -2.11561481543894),
(40768, '95936', 218, 6, 160878, 39.5608, 0.690466214722973, -120.8252, -2.10879755938065),
(40769, '95937', 218, 6, 181233, 38.8884, 0.678730620832563, -121.9896, -2.12912017319087),
(40770, '95938', 218, 6, 8632, 39.6419, 0.69188167674634, -121.7853, -2.12555446552905),
(40771, '95939', 218, 6, 35733, 39.6035, 0.691211470313574, -122.5649, -2.1391610523776),
(40772, '95940', 218, 6, 181548, 39.5937, 0.691040428046879, -121.2547, -2.11629374851797),
(40773, '95941', 218, 6, 181625, 39.4844, 0.689132783174449, -121.2846, -2.11681560196431),
(40774, '95942', 218, 6, 181639, 39.9398, 0.697081012588031, -121.6273, -2.1227968453109),
(40775, '95943', 218, 6, 21427, 39.611, 0.691342370007474, -122.0362, -2.1299334966223),
(40776, '95944', 218, 6, 177661, 39.585, 0.690888584401955, -120.8178, -2.10866840501601),
(40777, '95945', 218, 6, 181887, 39.2035, 0.684230153305597, -121.0277, -2.11233185111594),
(40778, '95946', 218, 6, 165796, 39.2168, 0.684462282096112, -121.1925, -2.11520815372323),
(40779, '95947', 218, 6, 2868, 40.1537, 0.700814271858047, -120.9243, -2.11052718066938),
(40780, '95948', 218, 6, 32637, 39.3576, 0.68691970568292, -121.6959, -2.12399414117777),
(40781, '95949', 218, 6, 181887, 39.1197, 0.682767567392426, -121.0798, -2.11324116765623),
(40782, '95950', 218, 6, 2885, 39.0555, 0.681647066012645, -121.8846, -2.12728757747628),
(40783, '95951', 218, 6, 181996, 39.7419, 0.693627005998334, -122.0108, -2.1294901829923),
(40784, '95953', 218, 6, 3822, 39.2589, 0.685197065711202, -121.692, -2.12392607333694),
(40785, '95954', 218, 6, 183032, 39.8347, 0.695246671544185, -121.598, -2.12228546384006),
(40786, '95955', 218, 6, 4045, 39.2765, 0.685504243659553, -122.1356, -2.13166835389879),
(40787, '95956', 218, 6, 175237, 39.9386, 0.697060068637007, -121.0637, -2.11296016964666),
(40788, '95957', 218, 6, 10448, 39.1063, 0.682533693272658, -121.8659, -2.12696120090616),
(40789, '95958', 218, 6, 4506, 39.5588, 0.690431308137933, -121.774, -2.12535724332357),
(40790, '95959', 218, 6, 183588, 39.2769, 0.685511224976561, -121.0218, -2.11222887669007),
(40791, '95960', 218, 6, 183703, 39.3384, 0.686584602466537, -121.1309, -2.114133030904),
(40792, '95961', 218, 6, 183843, 39.0867, 0.682191608739268, -121.5504, -2.12145468711612),
(40793, '95962', 218, 6, 183884, 39.3558, 0.686888289756384, -121.2605, -2.11639497761458),
(40794, '95963', 218, 6, 23671, 39.7479, 0.693731725753454, -122.1913, -2.13264050229215),
(40795, '95965', 218, 6, 183900, 39.5656, 0.690549990527069, -121.5574, -2.12157686016376),
(40796, '95966', 218, 6, 183900, 39.4872, 0.689181652393505, -121.4877, -2.12036036567512),
(40797, '95967', 218, 6, 11064, 39.7424, 0.693635732644594, -121.6026, -2.12236574898566),
(40798, '95968', 218, 6, 28171, 39.4373, 0.68831073309676, -121.545, -2.12136043933651),
(40799, '95969', 218, 6, 11064, 39.7592, 0.693928947958929, -121.604, -2.12239018359518),
(40800, '95970', 218, 6, 5231, 39.4062, 0.687767935699389, -122.0112, -2.12949716430931),
(40801, '95971', 218, 6, 17745, 39.9358, 0.697011199417951, -120.9065, -2.11021651206252),
(40802, '95972', 218, 6, 184346, 39.4361, 0.688289789145736, -121.3292, -2.1175940188107),
(40803, '95973', 218, 6, 1548, 39.7346, 0.693499596962939, -121.8326, -2.12638000626524),
(40804, '95974', 218, 6, 166462, 39.4968, 0.689349204001696, -121.7479, -2.1249017123888),
(40805, '95975', 218, 6, 152241, 39.2267, 0.68463506969206, -121.1469, -2.11441228358432),
(40806, '95976', 218, 6, 1548, 39.7529, 0.693818992216054, -121.8685, -2.12700657946671),
(40807, '95977', 218, 6, 152616, 39.1982, 0.684137650855241, -121.2541, -2.11628327654246),
(40808, '95978', 218, 6, 185381, 39.9542, 0.697332340000318, -121.515, -2.12083684056091),
(40809, '95979', 218, 6, 185395, 39.3092, 0.686074966324955, -122.5124, -2.1382447545203),
(40810, '95980', 218, 6, 185397, 39.9185, 0.696709257457356, -121.3311, -2.11762718006649),
(40811, '95981', 218, 6, 185408, 39.6842, 0.692619951019934, -120.9874, -2.11162848342739),
(40812, '95982', 218, 6, 121638, 39.1672, 0.683596598787123, -121.7677, -2.1252472875807),
(40813, '95983', 218, 6, 25360, 40.0724, 0.699395319176176, -120.8226, -2.1087521808201),
(40814, '95984', 218, 6, 194023, 40.0287, 0.698632610293054, -121.0421, -2.11258317852823),
(40815, '95986', 218, 6, 12671, 39.3518, 0.686818476586305, -120.7773, -2.10796154666895),
(40816, '95987', 218, 6, 878, 39.147, 0.68324404227822, -122.1475, -2.13187604807977),
(40817, '95988', 218, 6, 52843, 39.523, 0.689806480265719, -122.1981, -2.13275918468128),
(40818, '95991', 218, 6, 186283, 38.9962, 0.680612085766213, -121.6193, -2.12265721897074),
(40819, '95992', 218, 6, 186283, 39.025, 0.681114740590787, -121.6102, -2.12249839400881),
(40820, '95993', 218, 6, 186283, 39.1235, 0.682833889904002, -121.6651, -2.12345657976815),
(40821, '96001', 218, 6, 11513, 40.5622, 0.707943941852444, -122.4224, -2.13667395819351),
(40822, '96002', 218, 6, 11513, 40.5427, 0.707603602648305, -122.3259, -2.13498971546533),
(40823, '96003', 218, 6, 11513, 40.6401, 0.709303553339747, -122.3286, -2.13503683935514),
(40824, '96006', 218, 6, 193336, 41.2012, 0.719096595772688, -120.938, -2.1107662907769),
(40825, '96007', 218, 6, 7099, 40.4592, 0.70614625272289, -122.3343, -2.1351363231225),
(40826, '96008', 218, 6, 7379, 40.6683, 0.70979573618881, -122.1958, -2.13271904210849),
(40827, '96009', 218, 6, 193379, 41.1221, 0.71771604033436, -121.1381, -2.11425869461014),
(40828, '96010', 218, 6, 180073, 40.9147, 0.714096227465724, -123.2573, -2.15124571211841),
(40829, '96011', 218, 6, 39380, 40.9718, 0.715092810468613, -122, -2.12930168743308),
(40830, '96013', 218, 6, 29355, 40.8939, 0.713733198981309, -121.6597, -2.12336233198855),
(40831, '96014', 218, 6, 15400, 41.3368, 0.721463262238392, -122.8125, -2.14348248760554),
(40832, '96015', 218, 6, 35123, 41.5632, 0.725414687664907, -121.023, -2.1122498206411),
(40833, '96016', 218, 6, 193434, 40.909, 0.71399674369836, -121.4984, -2.12054711590508),
(40834, '96017', 218, 6, 193435, 41.1456, 0.718126192708579, -122.3172, -2.13483787182041),
(40835, '96019', 218, 6, 193946, 40.6808, 0.710013902345309, -122.365, -2.13567213920286),
(40836, '96020', 218, 6, 8056, 40.2964, 0.703304856700643, -121.2269, -2.11580854698591),
(40837, '96021', 218, 6, 8235, 39.9263, 0.696845393139012, -122.1894, -2.13260734103636),
(40838, '96022', 218, 6, 1802, 40.3268, 0.703835436793249, -122.3501, -2.13541208514431),
(40839, '96023', 218, 6, 193504, 41.9694, 0.732504215086508, -121.9356, -2.1281776953948),
(40840, '96024', 218, 6, 15811, 40.6692, 0.709811444152078, -122.8994, -2.14499917872552),
(40841, '96025', 218, 6, 193510, 41.2148, 0.719333960550959, -122.2729, -2.13406469096177),
(40842, '96027', 218, 6, 314, 41.4562, 0.723547185365273, -122.914, -2.14525399679631),
(40843, '96028', 218, 6, 193543, 41.0583, 0.716602520271588, -121.4934, -2.12045984944248),
(40844, '96029', 218, 6, 35938, 39.9111, 0.696580103092709, -122.4697, -2.1374994989297),
(40845, '96031', 218, 6, 0, 41.2199, 0.719422972342811, -123.2442, -2.1510170739864),
(40846, '96032', 218, 6, 181649, 41.6089, 0.726212303133069, -122.881, -2.14467803814315),
(40847, '96033', 218, 6, 193574, 40.7341, 0.710944162836622, -122.6209, -2.14013843675871),
(40848, '96034', 218, 6, 193584, 41.4578, 0.723575110633305, -122.6368, -2.14041594410978),
(40849, '96035', 218, 6, 193586, 40.0389, 0.698810633876758, -122.1728, -2.13231761638053),
(40850, '96037', 218, 6, 13861, 41.5469, 0.725130198996832, -122.9101, -2.14518592895548),
(40851, '96038', 218, 6, 60122, 41.6213, 0.726428723960316, -122.5224, -2.1384192874455),
(40852, '96039', 218, 6, 193616, 41.7247, 0.728233394406878, -123.4158, -2.15401205898282),
(40853, '96040', 218, 6, 102655, 40.8161, 0.712375332823257, -121.5051, -2.12066405296496),
(40854, '96041', 218, 6, 193629, 40.5477, 0.707690869110905, -123.1791, -2.14988086464335),
(40855, '96044', 218, 6, 162844, 41.9131, 0.731521594717635, -122.5049, -2.1381138548264),
(40856, '96046', 218, 6, 193666, 40.3508, 0.704254315813728, -123.2094, -2.1504096994067),
(40857, '96047', 218, 6, 193670, 40.4572, 0.70611134613785, -122.5919, -2.13963229127564),
(40858, '96048', 218, 6, 9806, 40.7785, 0.711719089024508, -123.052, -2.14766255116406),
(40859, '96049', 218, 6, 11513, 40.5635, 0.70796663113272, -122.2952, -2.13445389938497),
(40860, '96050', 218, 6, 193710, 41.8359, 0.730174200535096, -122.8584, -2.1442835937322),
(40861, '96051', 218, 6, 193719, 40.8757, 0.713415549057446, -122.3695, -2.1357506790192),
(40862, '96052', 218, 6, 3747, 40.7038, 0.710415328073268, -122.8014, -2.14328875605856),
(40863, '96054', 218, 6, 10194, 41.1187, 0.717656699139792, -121.1389, -2.11427265724416),
(40864, '96055', 218, 6, 193751, 40.057, 0.699126538471369, -122.1012, -2.1310679606361),
(40865, '96056', 218, 6, 10379, 41.1654, 0.718471767900474, -121.3562, -2.11806525770874),
(40866, '96057', 218, 6, 88892, 41.2436, 0.719836615375533, -122.1377, -2.13170500581308),
(40867, '96058', 218, 6, 193756, 41.753, 0.728727322585192, -121.9755, -2.12887408176634),
(40868, '96059', 218, 6, 37048, 40.4454, 0.705905397286115, -121.8453, -2.12660166308025),
(40869, '96061', 218, 6, 429, 40.3279, 0.703854635415021, -121.5181, -2.12089094576772),
(40870, '96062', 218, 6, 4227, 40.5503, 0.707736247671457, -122.1434, -2.13180448958044),
(40871, '96063', 218, 6, 10518, 40.3611, 0.704434084726683, -121.5628, -2.12167110794336),
(40872, '96064', 218, 6, 4275, 41.7349, 0.728411417990582, -122.442, -2.1370160427269),
(40873, '96065', 218, 6, 193798, 40.9716, 0.715089319810109, -122.0006, -2.12931215940859),
(40874, '96067', 218, 6, 193806, 41.3582, 0.721836762698319, -122.3472, -2.13536147059601),
(40875, '96068', 218, 6, 193823, 40.9549, 0.714797849825026, -121.1165, -2.11388170349171),
(40876, '96069', 218, 6, 120857, 40.6984, 0.71032108029366, -122.0146, -2.12955650550387),
(40877, '96070', 218, 6, 17333, 40.9716, 0.715089319810109, -122.0006, -2.12931215940859),
(40878, '96071', 218, 6, 193831, 40.6573, 0.709603749971091, -121.4575, -2.11983327624101),
(40879, '96073', 218, 6, 193844, 40.5681, 0.708046916278312, -122.2337, -2.13338052189499),
(40880, '96074', 218, 6, 184024, 39.9285, 0.696883790382556, -122.5321, -2.13858858438294),
(40881, '96075', 218, 6, 193855, 40.3367, 0.704008224389197, -121.8032, -2.12586687946516),
(40882, '96076', 218, 6, 193881, 40.3686, 0.704564984420583, -122.936, -2.14563796923175),
(40883, '96078', 218, 6, 193891, 40.0802, 0.699531454857831, -122.1717, -2.13229841775876),
(40884, '96079', 218, 6, 193946, 40.6876, 0.710132584734445, -122.3475, -2.13536670658376),
(40885, '96080', 218, 6, 11487, 40.1775, 0.701229660220022, -122.2601, -2.13384128881752),
(40886, '96084', 218, 6, 5565, 40.7767, 0.711687673097972, -121.9847, -2.12903465205753),
(40887, '96085', 218, 6, 193935, 41.7584, 0.7288215703648, -123.0147, -2.14701154335307),
(40888, '96086', 218, 6, 193939, 41.8445, 0.730324298850767, -123.2139, -2.15048823922304),
(40889, '96087', 218, 6, 193944, 40.5993, 0.708591459004934, -122.4871, -2.13780318621955),
(40890, '96088', 218, 6, 90797, 40.5095, 0.707024153336643, -121.8767, -2.12714969646537),
(40891, '96089', 218, 6, 193946, 40.6844, 0.710076734198381, -122.4005, -2.13629173108732),
(40892, '96090', 218, 6, 194004, 40.0243, 0.698555815805966, -122.1218, -2.13142749846201),
(40893, '96091', 218, 6, 194016, 41.0885, 0.71712960970569, -122.7167, -2.14181046218213),
(40894, '96092', 218, 6, 6567, 39.9365, 0.697023416722716, -122.0119, -2.12950938161407),
(40895, '96093', 218, 6, 69946, 40.733, 0.71092496421485, -122.9338, -2.14559957198821),
(40896, '96094', 218, 6, 12718, 41.4678, 0.723749643558505, -122.382, -2.1359688451757),
(40897, '96095', 218, 6, 194054, 40.7086, 0.710499103877364, -122.6023, -2.13981380551784),
(40898, '96096', 218, 6, 12839, 40.6463, 0.709411763753371, -121.9148, -2.12781466691038),
(40899, '96097', 218, 6, 194077, 41.7289, 0.728306698235462, -122.6232, -2.14017857933151);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(40900, '96099', 218, 6, 11513, 40.6405, 0.709310534656756, -122.5062, -2.13813654410668),
(40901, '96101', 218, 6, 14979, 41.5136, 0.724549004355918, -120.5504, -2.10400139459617),
(40902, '96103', 218, 6, 0, 39.8185, 0.694963928205362, -120.6643, -2.10598932461419),
(40903, '96104', 218, 6, 1435, 41.5208, 0.724674668062062, -120.1682, -2.09733074619505),
(40904, '96105', 218, 6, 180686, 39.814, 0.694885388389022, -120.2123, -2.09810043639518),
(40905, '96106', 218, 6, 1632, 39.729, 0.693401858524827, -120.5523, -2.10403455585196),
(40906, '96107', 218, 6, 54146, 38.5834, 0.67340736661398, -119.5187, -2.08599483270335),
(40907, '96108', 218, 6, 108803, 41.827, 0.730018866231668, -120.3093, -2.09979340576961),
(40908, '96109', 218, 6, 2098, 40.0387, 0.698807143218254, -120.117, -2.09643713761803),
(40909, '96110', 218, 6, 86657, 41.3162, 0.721103724412481, -120.1151, -2.09640397636224),
(40910, '96111', 218, 6, 181604, 39.3945, 0.687563732176906, -120.021, -2.09476162153611),
(40911, '96112', 218, 6, 193563, 41.8735, 0.730830444333846, -120.116, -2.09641968432551),
(40912, '96113', 218, 6, 193635, 40.1394, 0.700564689775012, -120.1585, -2.09716144925761),
(40913, '96114', 218, 6, 27546, 40.285, 0.703105889165916, -120.4769, -2.10271857759596),
(40914, '96115', 218, 6, 9930, 41.7186, 0.728126929322506, -120.1907, -2.09772344527675),
(40915, '96116', 218, 6, 193736, 41.2307, 0.719611467902026, -120.5026, -2.10316712721372),
(40916, '96117', 218, 6, 27727, 40.3831, 0.704818057162122, -120.271, -2.0991249446661),
(40917, '96118', 218, 6, 164039, 39.6671, 0.692321499717843, -120.2375, -2.09854025936668),
(40918, '96119', 218, 6, 174, 40.9779, 0.715199275552984, -120.5503, -2.10399964926692),
(40919, '96120', 218, 6, 183113, 38.7782, 0.676807267996865, -119.8016, -2.09093236915724),
(40920, '96121', 218, 6, 10480, 40.1943, 0.701522875534357, -120.407, -2.10149859244881),
(40921, '96122', 218, 6, 184243, 39.8103, 0.694820811206699, -120.4766, -2.1027133416082),
(40922, '96123', 218, 6, 193897, 40.8297, 0.712612697601529, -120.2742, -2.09918079520216),
(40923, '96124', 218, 6, 180409, 39.6338, 0.691740305076929, -120.4115, -2.10157713226515),
(40924, '96125', 218, 6, 185136, 39.5706, 0.690637256989668, -120.6487, -2.10571705325088),
(40925, '96126', 218, 6, 185153, 39.594, 0.691045664034635, -120.2812, -2.0993029682498),
(40926, '96127', 218, 6, 193992, 40.4164, 0.705399251803036, -120.6521, -2.10577639444545),
(40927, '96128', 218, 6, 57699, 40.3535, 0.704301439703532, -120.4316, -2.1019279434448),
(40928, '96129', 218, 6, 180001, 39.8203, 0.694995344131898, -120.3775, -2.10098372031947),
(40929, '96130', 218, 6, 193992, 40.4061, 0.705219482890081, -120.6533, -2.10579733839647),
(40930, '96132', 218, 6, 194008, 40.9217, 0.714218400513364, -120.611, -2.10505906412288),
(40931, '96133', 218, 6, 12356, 38.6371, 0.674344608422301, -119.549, -2.0865236674667),
(40932, '96134', 218, 6, 194021, 41.952, 0.732200527796661, -121.4739, -2.12011951023834),
(40933, '96135', 218, 6, 34282, 39.7154, 0.693164493746556, -120.2156, -2.0981580322605),
(40934, '96136', 218, 6, 111961, 40.3397, 0.704060584266757, -120.3304, -2.10016167024178),
(40935, '96137', 218, 6, 6753, 40.2623, 0.702709699425713, -121.1209, -2.1139584979788),
(40936, '96140', 218, 6, 180548, 39.2271, 0.684642051009068, -120.0806, -2.0958018377703),
(40937, '96141', 218, 6, 3214, 39.0965, 0.682362651005963, -120.1683, -2.0973324915243),
(40938, '96142', 218, 6, 25308, 39.0637, 0.681790183011309, -120.1367, -2.09678096748067),
(40939, '96143', 218, 6, 182485, 39.2578, 0.68517786708943, -120.0362, -2.09502691158242),
(40940, '96145', 218, 6, 185540, 39.1769, 0.683765895724567, -120.1542, -2.09708640009977),
(40941, '96146', 218, 6, 0, 39.181, 0.683837454223898, -120.2155, -2.09815628693124),
(40942, '96148', 218, 6, 185536, 39.2404, 0.684874179799583, -120.0706, -2.0956273048451),
(40943, '96150', 218, 6, 185283, 38.8852, 0.678674770296499, -120.0353, -2.09501120361915),
(40944, '96151', 218, 6, 185283, 38.9415, 0.679657390665372, -119.9778, -2.09400763929925),
(40945, '96152', 218, 6, 185283, 38.942, 0.679666117311632, -119.978, -2.09401112995776),
(40946, '96154', 218, 6, 185283, 38.9423, 0.679671353299388, -119.9782, -2.09401462061626),
(40947, '96155', 218, 6, 185283, 39.0174, 0.680982095567636, -120.125, -2.09657676395819),
(40948, '96156', 218, 6, 185283, 38.9444, 0.67970800521368, -119.9708, -2.09388546625161),
(40949, '96157', 218, 6, 185283, 38.9422, 0.679669607970136, -119.9773, -2.09399891265299),
(40950, '96158', 218, 6, 185283, 38.9288, 0.679435733850369, -119.9648, -2.09378074649649),
(40951, '96160', 218, 6, 185760, 39.3275, 0.68639436157807, -120.1826, -2.09758207360734),
(40952, '96161', 218, 6, 185760, 39.3543, 0.686862109817604, -120.1935, -2.0977723144958),
(40953, '96162', 218, 6, 185760, 39.3076, 0.686047041056923, -120.3152, -2.09989638019548),
(40954, '96201', 218, 0, 0, 0, 0, 0, 0),
(40955, '96202', 218, 0, 0, 0, 0, 0, 0),
(40956, '96203', 218, 0, 0, 0, 0, 0, 0),
(40957, '96204', 218, 0, 0, 0, 0, 0, 0),
(40958, '96205', 218, 0, 0, 0, 0, 0, 0),
(40959, '96206', 218, 0, 0, 0, 0, 0, 0),
(40960, '96207', 218, 0, 0, 0, 0, 0, 0),
(40961, '96208', 218, 0, 0, 0, 0, 0, 0),
(40962, '96212', 218, 0, 0, 0, 0, 0, 0),
(40963, '96213', 218, 0, 0, 0, 0, 0, 0),
(40964, '96214', 218, 0, 0, 0, 0, 0, 0),
(40965, '96215', 218, 0, 0, 0, 0, 0, 0),
(40966, '96217', 218, 0, 0, 0, 0, 0, 0),
(40967, '96218', 218, 0, 0, 0, 0, 0, 0),
(40968, '96219', 218, 0, 0, 0, 0, 0, 0),
(40969, '96220', 218, 0, 0, 0, 0, 0, 0),
(40970, '96221', 218, 0, 0, 0, 0, 0, 0),
(40971, '96224', 218, 0, 0, 0, 0, 0, 0),
(40972, '96251', 218, 0, 0, 0, 0, 0, 0),
(40973, '96257', 218, 0, 0, 0, 0, 0, 0),
(40974, '96258', 218, 0, 0, 0, 0, 0, 0),
(40975, '96259', 218, 0, 0, 0, 0, 0, 0),
(40976, '96260', 218, 0, 0, 0, 0, 0, 0),
(40977, '96262', 218, 0, 0, 0, 0, 0, 0),
(40978, '96264', 218, 0, 0, 0, 0, 0, 0),
(40979, '96266', 218, 0, 0, 0, 0, 0, 0),
(40980, '96267', 218, 0, 0, 0, 0, 0, 0),
(40981, '96269', 218, 0, 0, 0, 0, 0, 0),
(40982, '96271', 218, 0, 0, 0, 0, 0, 0),
(40983, '96275', 218, 0, 0, 0, 0, 0, 0),
(40984, '96276', 218, 0, 0, 0, 0, 0, 0),
(40985, '96278', 218, 0, 0, 0, 0, 0, 0),
(40986, '96283', 218, 0, 0, 0, 0, 0, 0),
(40987, '96284', 218, 0, 0, 0, 0, 0, 0),
(40988, '96297', 218, 0, 0, 0, 0, 0, 0),
(40989, '96306', 218, 0, 0, 0, 0, 0, 0),
(40990, '96309', 218, 0, 0, 0, 0, 0, 0),
(40991, '96310', 218, 0, 0, 0, 0, 0, 0),
(40992, '96311', 218, 0, 0, 0, 0, 0, 0),
(40993, '96313', 218, 0, 0, 0, 0, 0, 0),
(40994, '96319', 218, 0, 0, 0, 0, 0, 0),
(40995, '96321', 218, 0, 0, 0, 0, 0, 0),
(40996, '96322', 218, 0, 0, 0, 0, 0, 0),
(40997, '96323', 218, 0, 0, 0, 0, 0, 0),
(40998, '96325', 218, 0, 0, 0, 0, 0, 0),
(40999, '96326', 218, 0, 0, 0, 0, 0, 0),
(41000, '96328', 218, 0, 0, 0, 0, 0, 0),
(41001, '96330', 218, 0, 0, 0, 0, 0, 0),
(41002, '96336', 218, 0, 0, 0, 0, 0, 0),
(41003, '96337', 218, 0, 0, 0, 0, 0, 0),
(41004, '96338', 218, 0, 0, 0, 0, 0, 0),
(41005, '96343', 218, 0, 0, 0, 0, 0, 0),
(41006, '96347', 218, 0, 0, 0, 0, 0, 0),
(41007, '96348', 218, 0, 0, 0, 0, 0, 0),
(41008, '96349', 218, 0, 0, 0, 0, 0, 0),
(41009, '96350', 218, 0, 0, 0, 0, 0, 0),
(41010, '96351', 218, 0, 0, 0, 0, 0, 0),
(41011, '96362', 218, 0, 0, 0, 0, 0, 0),
(41012, '96364', 218, 0, 0, 0, 0, 0, 0),
(41013, '96365', 218, 0, 0, 0, 0, 0, 0),
(41014, '96367', 218, 0, 0, 0, 0, 0, 0),
(41015, '96368', 218, 0, 0, 0, 0, 0, 0),
(41016, '96370', 218, 0, 0, 0, 0, 0, 0),
(41017, '96372', 218, 0, 0, 0, 0, 0, 0),
(41018, '96373', 218, 0, 0, 0, 0, 0, 0),
(41019, '96374', 218, 0, 0, 0, 0, 0, 0),
(41020, '96375', 218, 0, 0, 0, 0, 0, 0),
(41021, '96376', 218, 0, 0, 0, 0, 0, 0),
(41022, '96377', 218, 0, 0, 0, 0, 0, 0),
(41023, '96378', 218, 0, 0, 0, 0, 0, 0),
(41024, '96379', 218, 0, 0, 0, 0, 0, 0),
(41025, '96384', 218, 0, 0, 0, 0, 0, 0),
(41026, '96386', 218, 0, 0, 0, 0, 0, 0),
(41027, '96387', 218, 0, 0, 0, 0, 0, 0),
(41028, '96388', 218, 0, 0, 0, 0, 0, 0),
(41029, '96401', 218, 0, 0, 0, 0, 0, 0),
(41030, '96402', 218, 0, 0, 0, 0, 0, 0),
(41031, '96403', 218, 0, 0, 0, 0, 0, 0),
(41032, '96490', 218, 0, 0, 0, 0, 0, 0),
(41033, '96505', 218, 0, 0, 0, 0, 0, 0),
(41034, '96506', 218, 0, 0, 0, 0, 0, 0),
(41035, '96507', 218, 0, 0, 0, 0, 0, 0),
(41036, '96508', 218, 0, 0, 0, 0, 0, 0),
(41037, '96511', 218, 0, 0, 0, 0, 0, 0),
(41038, '96512', 218, 0, 0, 0, 0, 0, 0),
(41039, '96515', 218, 0, 0, 0, 0, 0, 0),
(41040, '96517', 218, 0, 0, 0, 0, 0, 0),
(41041, '96518', 218, 0, 0, 0, 0, 0, 0),
(41042, '96520', 218, 0, 0, 0, 0, 0, 0),
(41043, '96521', 218, 0, 0, 0, 0, 0, 0),
(41044, '96522', 218, 0, 0, 0, 0, 0, 0),
(41045, '96529', 218, 0, 0, 0, 0, 0, 0),
(41046, '96530', 218, 0, 0, 0, 0, 0, 0),
(41047, '96531', 218, 0, 0, 0, 0, 0, 0),
(41048, '96534', 218, 0, 0, 0, 0, 0, 0),
(41049, '96535', 218, 0, 0, 0, 0, 0, 0),
(41050, '96536', 218, 0, 0, 0, 0, 0, 0),
(41051, '96537', 218, 0, 0, 0, 0, 0, 0),
(41052, '96538', 218, 0, 0, 0, 0, 0, 0),
(41053, '96539', 218, 0, 0, 0, 0, 0, 0),
(41054, '96540', 218, 0, 0, 0, 0, 0, 0),
(41055, '96541', 218, 0, 0, 0, 0, 0, 0),
(41056, '96542', 218, 0, 0, 0, 0, 0, 0),
(41057, '96543', 218, 0, 0, 0, 0, 0, 0),
(41058, '96544', 218, 0, 0, 0, 0, 0, 0),
(41059, '96545', 218, 0, 0, 0, 0, 0, 0),
(41060, '96546', 218, 0, 0, 0, 0, 0, 0),
(41061, '96548', 218, 0, 0, 0, 0, 0, 0),
(41062, '96549', 218, 0, 0, 0, 0, 0, 0),
(41063, '96551', 218, 0, 0, 0, 0, 0, 0),
(41064, '96552', 218, 0, 0, 0, 0, 0, 0),
(41065, '96553', 218, 0, 0, 0, 0, 0, 0),
(41066, '96554', 218, 0, 0, 0, 0, 0, 0),
(41067, '96555', 218, 0, 0, 0, 0, 0, 0),
(41068, '96557', 218, 0, 0, 0, 0, 0, 0),
(41069, '96558', 218, 0, 0, 0, 0, 0, 0),
(41070, '96575', 218, 0, 0, 0, 0, 0, 0),
(41071, '96580', 218, 0, 0, 0, 0, 0, 0),
(41072, '96594', 218, 0, 0, 0, 0, 0, 0),
(41073, '96595', 218, 0, 0, 0, 0, 0, 0),
(41074, '96596', 218, 0, 0, 0, 0, 0, 0),
(41075, '96597', 218, 0, 0, 0, 0, 0, 0),
(41076, '96598', 218, 0, 0, 0, 0, 0, 0),
(41077, '96599', 218, 0, 0, 0, 0, 0, 0),
(41078, '96601', 218, 0, 0, 0, 0, 0, 0),
(41079, '96602', 218, 0, 0, 0, 0, 0, 0),
(41080, '96603', 218, 0, 0, 0, 0, 0, 0),
(41081, '96604', 218, 0, 0, 0, 0, 0, 0),
(41082, '96605', 218, 0, 0, 0, 0, 0, 0),
(41083, '96606', 218, 0, 0, 0, 0, 0, 0),
(41084, '96607', 218, 0, 0, 0, 0, 0, 0),
(41085, '96608', 218, 0, 0, 0, 0, 0, 0),
(41086, '96609', 218, 0, 0, 0, 0, 0, 0),
(41087, '96610', 218, 0, 0, 0, 0, 0, 0),
(41088, '96611', 218, 0, 0, 0, 0, 0, 0),
(41089, '96612', 218, 0, 0, 0, 0, 0, 0),
(41090, '96614', 218, 0, 0, 0, 0, 0, 0),
(41091, '96615', 218, 0, 0, 0, 0, 0, 0),
(41092, '96617', 218, 0, 0, 0, 0, 0, 0),
(41093, '96619', 218, 0, 0, 0, 0, 0, 0),
(41094, '96620', 218, 0, 0, 0, 0, 0, 0),
(41095, '96621', 218, 0, 0, 0, 0, 0, 0),
(41096, '96622', 218, 0, 0, 0, 0, 0, 0),
(41097, '96623', 218, 0, 0, 0, 0, 0, 0),
(41098, '96624', 218, 0, 0, 0, 0, 0, 0),
(41099, '96626', 218, 0, 0, 0, 0, 0, 0),
(41100, '96627', 218, 0, 0, 0, 0, 0, 0),
(41101, '96628', 218, 0, 0, 0, 0, 0, 0),
(41102, '96629', 218, 0, 0, 0, 0, 0, 0),
(41103, '96634', 218, 0, 0, 0, 0, 0, 0),
(41104, '96635', 218, 0, 0, 0, 0, 0, 0),
(41105, '96642', 218, 0, 0, 0, 0, 0, 0),
(41106, '96643', 218, 0, 0, 0, 0, 0, 0),
(41107, '96644', 218, 0, 0, 0, 0, 0, 0),
(41108, '96647', 218, 0, 0, 0, 0, 0, 0),
(41109, '96648', 218, 0, 0, 0, 0, 0, 0),
(41110, '96649', 218, 0, 0, 0, 0, 0, 0),
(41111, '96657', 218, 0, 0, 0, 0, 0, 0),
(41112, '96660', 218, 0, 0, 0, 0, 0, 0),
(41113, '96661', 218, 0, 0, 0, 0, 0, 0),
(41114, '96662', 218, 0, 0, 0, 0, 0, 0),
(41115, '96663', 218, 0, 0, 0, 0, 0, 0),
(41116, '96664', 218, 0, 0, 0, 0, 0, 0),
(41117, '96665', 218, 0, 0, 0, 0, 0, 0),
(41118, '96666', 218, 0, 0, 0, 0, 0, 0),
(41119, '96667', 218, 0, 0, 0, 0, 0, 0),
(41120, '96668', 218, 0, 0, 0, 0, 0, 0),
(41121, '96669', 218, 0, 0, 0, 0, 0, 0),
(41122, '96670', 218, 0, 0, 0, 0, 0, 0),
(41123, '96671', 218, 0, 0, 0, 0, 0, 0),
(41124, '96672', 218, 0, 0, 0, 0, 0, 0),
(41125, '96673', 218, 0, 0, 0, 0, 0, 0),
(41126, '96674', 218, 0, 0, 0, 0, 0, 0),
(41127, '96675', 218, 0, 0, 0, 0, 0, 0),
(41128, '96676', 218, 0, 0, 0, 0, 0, 0),
(41129, '96677', 218, 0, 0, 0, 0, 0, 0),
(41130, '96678', 218, 0, 0, 0, 0, 0, 0),
(41131, '96679', 218, 0, 0, 0, 0, 0, 0),
(41132, '96681', 218, 0, 0, 0, 0, 0, 0),
(41133, '96682', 218, 0, 0, 0, 0, 0, 0),
(41134, '96683', 218, 0, 0, 0, 0, 0, 0),
(41135, '96684', 218, 0, 0, 0, 0, 0, 0),
(41136, '96686', 218, 0, 0, 0, 0, 0, 0),
(41137, '96687', 218, 0, 0, 0, 0, 0, 0),
(41138, '96698', 218, 0, 0, 0, 0, 0, 0),
(41139, '96701', 218, 15, 0, 21.3879, 0.373289275087295, -157.9304, -2.75640546899165),
(41140, '96703', 218, 15, 211670, 22.1288, 0.386220419515321, -159.3439, -2.78107569796859),
(41141, '96704', 218, 15, 211677, 19.4156, 0.338866146250211, -155.8758, -2.72054593418018),
(41142, '96705', 218, 15, 211323, 21.9185, 0.382549992098377, -159.5976, -2.7855035982809),
(41143, '96706', 218, 15, 0, 21.3305, 0.37228745609665, -158.022, -2.75800419058648),
(41144, '96707', 218, 15, 0, 21.3351, 0.372367741242242, -158.0915, -2.75921719441662),
(41145, '96708', 218, 15, 211344, 20.9092, 0.364934383957998, -156.3006, -2.72796009284265),
(41146, '96709', 218, 15, 0, 21.3236, 0.372167028378263, -158.006, -2.75772493790616),
(41147, '96710', 218, 15, 211351, 19.88, 0.346971455296473, -155.1499, -2.70787658913995),
(41148, '96712', 218, 15, 0, 21.6054, 0.377085366210383, -158.0918, -2.75922243040437),
(41149, '96713', 218, 15, 211387, 20.7451, 0.362070298655476, -156.1222, -2.72484642545709),
(41150, '96714', 218, 15, 211411, 22.2176, 0.387770271891092, -159.4829, -2.78350170562886),
(41151, '96715', 218, 15, 211417, 21.9982, 0.383941019512217, -159.3573, -2.78130957208836),
(41152, '96716', 218, 15, 211418, 21.9192, 0.382562209403141, -159.5917, -2.78540062385503),
(41153, '96717', 218, 15, 0, 21.6206, 0.377350656256686, -157.9179, -2.75618730283515),
(41154, '96718', 218, 15, 0, 19.4083, 0.338738737214815, -155.2745, -2.71005126938794),
(41155, '96719', 218, 15, 211454, 20.2346, 0.353160392824045, -155.8489, -2.72007644061139),
(41156, '96720', 218, 15, 9512, 19.7036, 0.343892694495955, -155.0933, -2.70688873278332),
(41157, '96721', 218, 15, 9512, 19.5355, 0.340958796023352, -154.9583, -2.70453253829313),
(41158, '96722', 218, 15, 67980, 22.2242, 0.387885463621724, -159.4812, -2.78347203503158),
(41159, '96725', 218, 15, 211484, 19.6175, 0.342389966009988, -155.9525, -2.72188460171646),
(41160, '96726', 218, 15, 211493, 19.4459, 0.339394981013565, -155.8911, -2.72081296955573),
(41161, '96727', 218, 15, 0, 20.0881, 0.350603485469873, -155.521, -2.7143535059941),
(41162, '96728', 218, 15, 211525, 19.8582, 0.346590973519538, -155.1345, -2.70760780843514),
(41163, '96729', 218, 15, 0, 21.1645, 0.36939020953834, -157.0885, -2.74171154201911),
(41164, '96730', 218, 15, 211596, 21.5565, 0.376231900206158, -157.8562, -2.75511043468667),
(41165, '96731', 218, 15, 210021, 21.6786, 0.378362947222843, -157.9552, -2.75683831064615),
(41166, '96732', 218, 15, 210024, 20.8828, 0.364473617035472, -156.4749, -2.73100220172888),
(41167, '96733', 218, 15, 210024, 20.8913, 0.364621970021891, -156.4685, -2.73089050065675),
(41168, '96734', 218, 15, 210037, 21.3992, 0.373486497292771, -157.7457, -2.75318184586322),
(41169, '96737', 218, 15, 365, 19.0602, 0.332663246088623, -155.7161, -2.71775864336474),
(41170, '96738', 218, 15, 211213, 19.8297, 0.34609355468272, -155.8363, -2.71985652912564),
(41171, '96739', 218, 15, 210360, 19.6487, 0.34293450873661, -155.9993, -2.72270141580639),
(41172, '96740', 218, 15, 0, 19.6656, 0.343229469380197, -155.9803, -2.72236980324851),
(41173, '96741', 218, 15, 210064, 21.9224, 0.382618059939205, -159.5298, -2.78432026504805),
(41174, '96742', 218, 15, 210099, 21.1793, 0.369648518267635, -156.9762, -2.73975153726912),
(41175, '96743', 218, 15, 0, 19.9741, 0.348613810122599, -155.7618, -2.7185562588329),
(41176, '96744', 218, 15, 0, 21.4201, 0.373851271106437, -157.8119, -2.75433725382804),
(41177, '96745', 218, 15, 0, 19.6843, 0.34355584595032, -155.9713, -2.72221272361583),
(41178, '96746', 218, 15, 210193, 22.0799, 0.385366953511096, -159.3506, -2.78119263502848),
(41179, '96747', 218, 15, 210254, 21.9328, 0.382799574181412, -159.6295, -2.78606035831229),
(41180, '96748', 218, 15, 210263, 21.1159, 0.368541979521871, -156.8792, -2.73805856789469),
(41181, '96749', 218, 15, 0, 19.5733, 0.341618530480606, -154.9622, -2.70460060613396),
(41182, '96750', 218, 15, 210335, 19.5263, 0.340798225732169, -155.9281, -2.72145874137897),
(41183, '96751', 218, 15, 210339, 22.1062, 0.385825975104371, -159.3083, -2.78045436075488),
(41184, '96752', 218, 15, 210381, 21.9691, 0.383433128699886, -159.709, -2.78744789506762),
(41185, '96753', 218, 15, 210415, 20.7332, 0.361862604474488, -156.4476, -2.73052572684308),
(41186, '96754', 218, 15, 210425, 22.2129, 0.387688241416248, -159.4043, -2.7821298768368),
(41187, '96755', 218, 15, 210203, 20.1669, 0.351978804920444, -155.8019, -2.71925613586295),
(41188, '96756', 218, 15, 210464, 21.9097, 0.382396403124202, -159.4887, -2.78360293472548),
(41189, '96757', 218, 15, 0, 21.155, 0.3692244032594, -157.0402, -2.7408685479904),
(41190, '96759', 218, 15, 0, 21.4573, 0.374500533588179, -158.0614, -2.75869185031177),
(41191, '96760', 218, 15, 210529, 19.582, 0.34177037412553, -155.0363, -2.70589389510969),
(41192, '96761', 218, 15, 48769, 20.9178, 0.36508448227367, -156.6783, -2.73455220142743),
(41193, '96762', 218, 15, 0, 21.6484, 0.37783585778874, -157.9266, -2.75633914648008),
(41194, '96763', 218, 15, 0, 20.8277, 0.363511940617623, -156.9214, -2.73879509683903),
(41195, '96764', 218, 15, 210557, 19.9641, 0.3484392771974, -155.2332, -2.70933044840686),
(41196, '96765', 218, 15, 210563, 21.9277, 0.382710562389561, -159.5119, -2.78400785111194),
(41197, '96766', 218, 15, 210572, 21.9802, 0.383626860246858, -159.3695, -2.7815225022571),
(41198, '96767', 218, 15, 48769, 20.9116, 0.364976271860046, -156.6885, -2.73473022501113),
(41199, '96768', 218, 15, 210629, 20.8474, 0.363855770480266, -156.3289, -2.72845402102096),
(41200, '96769', 218, 15, 0, 21.951, 0.383117224105275, -159.667, -2.78671485678179),
(41201, '96770', 218, 15, 210685, 21.1363, 0.368898026689277, -157.2127, -2.74387924095009),
(41202, '96771', 218, 15, 4440, 19.5417, 0.341067006436976, -155.0902, -2.70683462757651),
(41203, '96772', 218, 15, 0, 19.086, 0.333113541035638, -155.7091, -2.7176364703171),
(41204, '96773', 218, 15, 210770, 19.8676, 0.346755034469225, -155.2099, -2.70892378669115),
(41205, '96774', 218, 15, 0, 20.002, 0.349100756983906, -155.2754, -2.7100669773512),
(41206, '96776', 218, 15, 0, 19.9234, 0.347728928191838, -155.4378, -2.71290139205644),
(41207, '96777', 218, 15, 210868, 19.2015, 0.335129396321691, -155.523, -2.71438841257914),
(41208, '96778', 218, 15, 210872, 19.5265, 0.340801716390673, -154.9081, -2.70365638300863),
(41209, '96779', 218, 15, 210880, 20.9146, 0.365028631737606, -156.3818, -2.72937730019527),
(41210, '96780', 218, 15, 0, 19.9198, 0.347666096338766, -155.1958, -2.70867769526662),
(41211, '96781', 218, 15, 0, 19.793, 0.345453018847238, -155.1919, -2.70860962742579),
(41212, '96782', 218, 15, 89822, 21.4083, 0.373645322254702, -157.966, -2.75702680620536),
(41213, '96783', 218, 15, 210954, 19.8317, 0.346128461267759, -155.1134, -2.70723954396297),
(41214, '96784', 218, 15, 211075, 20.7736, 0.362567717492294, -156.3308, -2.72848718227675),
(41215, '96785', 218, 15, 185976, 19.4438, 0.339358329099273, -155.2844, -2.71022405698388),
(41216, '96786', 218, 15, 211140, 21.5018, 0.375277205105317, -158.0316, -2.75817174219467),
(41217, '96788', 218, 15, 211011, 20.8384, 0.363698690847586, -156.3384, -2.7286198272999),
(41218, '96789', 218, 15, 0, 21.4476, 0.374331236650736, -158.0221, -2.75800593591573),
(41219, '96790', 218, 15, 0, 20.7709, 0.36252059360249, -156.3256, -2.72839642515565),
(41220, '96791', 218, 15, 211170, 21.5803, 0.376647288568132, -158.1278, -2.75985074893509),
(41221, '96792', 218, 15, 0, 21.4378, 0.37416019438404, -158.1845, -2.76084035062097),
(41222, '96793', 218, 15, 211235, 20.8969, 0.364719708460003, -156.5037, -2.73150485655345),
(41223, '96795', 218, 15, 211244, 21.342, 0.37248816896063, -157.7136, -2.75262159517333),
(41224, '96796', 218, 15, 211251, 21.963, 0.383326663615515, -159.6713, -2.78678990593962),
(41225, '96797', 218, 15, 211278, 21.3926, 0.373371305562139, -158.0111, -2.75781394969801),
(41226, '96799', 218, 3, 0, 14.2417, 0.248564556081276, -170.7197, -2.97962086301696),
(41227, '96801', 218, 15, 65731, 21.3283, 0.372249058853107, -157.8299, -2.7546514130934),
(41228, '96802', 218, 15, 65731, 21.3059, 0.37185810510066, -157.8588, -2.75515581324722),
(41229, '96803', 218, 15, 65731, 21.3065, 0.371868577076172, -157.8589, -2.75515755857648),
(41230, '96804', 218, 15, 65731, 21.3058, 0.371856359771408, -157.8583, -2.75514708660097),
(41231, '96805', 218, 15, 65731, 21.3065, 0.371868577076172, -157.8584, -2.75514883193022),
(41232, '96806', 218, 15, 65731, 21.3063, 0.371865086417668, -157.8584, -2.75514883193022),
(41233, '96807', 218, 15, 65731, 21.3058, 0.371856359771408, -157.8583, -2.75514708660097),
(41234, '96808', 218, 15, 65731, 21.3062, 0.371863341088416, -157.8582, -2.75514534127171),
(41235, '96809', 218, 15, 65731, 21.3067, 0.371872067734676, -157.8584, -2.75514883193022),
(41236, '96810', 218, 15, 65731, 21.3065, 0.371868577076172, -157.8582, -2.75514534127171),
(41237, '96811', 218, 15, 65731, 21.3281, 0.372245568194603, -157.8291, -2.75463745045938),
(41238, '96812', 218, 15, 65731, 21.3065, 0.371868577076172, -157.8583, -2.75514708660097),
(41239, '96813', 218, 15, 65731, 21.314, 0.371999476770071, -157.8532, -2.75505807480911),
(41240, '96814', 218, 15, 65731, 21.303, 0.371807490552352, -157.847, -2.75494986439549),
(41241, '96815', 218, 15, 65731, 21.2783, 0.371376394227109, -157.8209, -2.75449433346072),
(41242, '96816', 218, 15, 65731, 21.2873, 0.371533473859789, -157.8021, -2.75416621156134),
(41243, '96817', 218, 15, 65731, 21.3316, 0.372306654718422, -157.8571, -2.75512614264994),
(41244, '96818', 218, 15, 65731, 21.3538, 0.372694117812365, -157.9315, -2.75642466761342),
(41245, '96819', 218, 15, 65731, 21.3471, 0.372577180752482, -157.8806, -2.75553629502416),
(41246, '96820', 218, 15, 65731, 21.3507, 0.372640012605553, -157.8796, -2.75551884173164),
(41247, '96821', 218, 15, 65731, 21.2891, 0.371564889786325, -157.7564, -2.75336859609318),
(41248, '96822', 218, 15, 65731, 21.3131, 0.371983768806803, -157.8226, -2.754524004058),
(41249, '96823', 218, 15, 65731, 21.3076, 0.371887775697944, -157.8465, -2.75494113774923),
(41250, '96824', 218, 15, 65731, 21.2813, 0.371428754104669, -157.7547, -2.7533389254959),
(41251, '96825', 218, 15, 65731, 21.2954, 0.3716748455292, -157.697, -2.7523318705175),
(41252, '96826', 218, 15, 65731, 21.2947, 0.371662628224436, -157.8293, -2.75464094111789),
(41253, '96827', 218, 15, 65731, 21.3168, 0.372048345989127, -157.8646, -2.75525704234384),
(41254, '96828', 218, 15, 65731, 21.2936, 0.371643429602665, -157.8224, -2.7545205133995),
(41255, '96830', 218, 15, 65731, 21.2841, 0.371477623323725, -157.8336, -2.75471599027572),
(41256, '96835', 218, 15, 65731, 21.2871, 0.371529983201285, -157.8164, -2.75441579364438),
(41257, '96836', 218, 15, 65731, 21.2896, 0.371573616432585, -157.8386, -2.75480325673832),
(41258, '96837', 218, 15, 65731, 21.3148, 0.372013439404087, -157.8633, -2.75523435306356),
(41259, '96838', 218, 15, 65731, 21.3493, 0.372615577996025, -157.8752, -2.75544204724455),
(41260, '96839', 218, 15, 65731, 21.3203, 0.372109432512947, -157.8131, -2.75435819777906),
(41261, '96840', 218, 15, 65731, 21.3067, 0.371872067734676, -157.8612, -2.75519770114927),
(41262, '96841', 218, 15, 65731, 21.3098, 0.371926172941488, -157.8598, -2.75517326653974),
(41263, '96842', 218, 15, 65731, 21.307, 0.371877303722432, -157.8603, -2.755181993186),
(41264, '96843', 218, 15, 65731, 21.3055, 0.371851123783652, -157.8527, -2.75504934816285),
(41265, '96844', 218, 15, 65731, 21.2952, 0.371671354870696, -157.816, -2.75440881232737),
(41266, '96845', 218, 15, 65731, 21.3062, 0.371863341088416, -157.8605, -2.75518548384451),
(41267, '96846', 218, 15, 65731, 21.3203, 0.372109432512947, -157.8703, -2.7553565261112),
(41268, '96847', 218, 15, 65731, 21.3022, 0.371793527918336, -157.8444, -2.75490448583494),
(41269, '96848', 218, 15, 65731, 21.3204, 0.372111177842199, -157.8129, -2.75435470712056),
(41270, '96849', 218, 15, 65731, 21.3341, 0.372350287949722, -157.9176, -2.7561820668474),
(41271, '96850', 218, 15, 65731, 21.3092, 0.371915700965976, -157.8625, -2.75522039042955),
(41272, '96853', 218, 15, 0, 21.3382, 0.372421846449054, -157.9437, -2.75663759778217),
(41273, '96854', 218, 15, 0, 21.488, 0.375036349668542, -158.0352, -2.75823457404774),
(41274, '96857', 218, 15, 0, 21.496, 0.375175976008701, -158.065, -2.75875468216484),
(41275, '96858', 218, 15, 0, 21.3445, 0.37253180219193, -157.8893, -2.75568813866908),
(41276, '96859', 218, 15, 0, 21.349, 0.372610342008269, -157.8754, -2.75544553790306),
(41277, '96860', 218, 15, 0, 21.3525, 0.372671428532089, -157.9686, -2.75707218476591),
(41278, '96861', 218, 15, 0, 21.3971, 0.373449845378479, -157.8994, -2.75586441692353),
(41279, '96862', 218, 15, 0, 21.3193, 0.372091979220427, -158.0747, -2.75892397910228),
(41280, '96863', 218, 15, 0, 21.3915, 0.373352106940367, -157.7524, -2.7532987829231),
(41281, '96898', 218, 15, 0, 21.3123, 0.371969806172788, -157.8633, -2.75523435306356),
(41282, '96910', 218, 14, 0, 13.4751, 0.235184862035488, 144.7487, 2.52634140298152),
(41283, '96911', 218, 14, 0, 13.4936, 0.235507747947107, 144.7767, 2.52683009517207),
(41284, '96912', 218, 14, 0, 13.5174, 0.235923136309082, 144.8361, 2.52786682074776),
(41285, '96913', 218, 14, 0, 13.4619, 0.234954478574225, 144.7942, 2.52713552779117),
(41286, '96914', 218, 14, 0, 13.4145, 0.234127192508779, 144.7734, 2.52677249930676),
(41287, '96915', 218, 14, 184954, 13.3873, 0.233652462952237, 144.6693, 2.52495561155543),
(41288, '96916', 218, 14, 0, 13.2675, 0.231561558508348, 144.67, 2.5249678288602),
(41289, '96917', 218, 14, 0, 13.2761, 0.231711656824019, 144.7379, 2.5261529074223),
(41290, '96918', 218, 14, 0, 13.2971, 0.232078175966938, 144.6622, 2.52483169317854),
(41291, '96919', 218, 14, 0, 13.4625, 0.234964950549737, 144.7439, 2.52625762717742),
(41292, '96921', 218, 14, 0, 13.4614, 0.234945751927965, 144.7944, 2.52713901844968),
(41293, '96922', 218, 14, 0, 13.4673, 0.235048726353832, 144.7153, 2.52575846301135),
(41294, '96923', 218, 14, 0, 13.4418, 0.234603667394574, 144.8021, 2.52727340880208),
(41295, '96925', 218, 14, 0, 13.465, 0.235008583781036, 144.6958, 2.52541812380721),
(41296, '96926', 218, 14, 0, 13.4599, 0.234919571989185, 144.7526, 2.52640947082234),
(41297, '96927', 218, 14, 0, 13.4701, 0.235097595572888, 144.7649, 2.52662414632034),
(41298, '96928', 218, 14, 0, 13.3819, 0.233558215172629, 144.6581, 2.52476013467921),
(41299, '96929', 218, 14, 0, 13.538, 0.236282674134992, 144.8984, 2.52895416087175),
(41300, '96930', 218, 14, 0, 13.356, 0.233106174896363, 144.7534, 2.52642343345636),
(41301, '96931', 218, 14, 0, 13.4939, 0.235512983934863, 144.7762, 2.52682136852581),
(41302, '96932', 218, 14, 0, 13.4752, 0.23518660736474, 144.7485, 2.52633791232301),
(41303, '96940', 218, 44, 0, 7.4986, 0.130875259290047, 134.5718, 2.34872099033531),
(41304, '96941', 218, 11, 0, 6.8906, 0.120263657437921, 158.2101, 2.76128715490948),
(41305, '96942', 218, 11, 0, 7.3269, 0.127878528964373, 151.6495, 2.64678308400314),
(41306, '96943', 218, 11, 0, 9.537, 0.166452050762699, 138.125, 2.41073602931717),
(41307, '96944', 218, 11, 0, 5.3066, 0.0926176420863311, 162.9649, 2.84427407018331),
(41308, '96950', 218, 32, 0, 15.1825, 0.264984613684039, 145.7554, 2.54391163256134),
(41309, '96951', 218, 32, 0, 14.151, 0.246981542449718, 145.2444, 2.53499300008365),
(41310, '96952', 218, 32, 189676, 15.084, 0.263265464370825, 145.6516, 2.54209998079777),
(41311, '96960', 218, 24, 0, 7.3667, 0.128573170006666, 170.855, 2.98198229349491),
(41312, '96970', 218, 24, 0, 7.1194, 0.124256970766484, 171.0617, 2.98558988905878),
(41313, '97001', 218, 43, 31653, 44.9207, 0.784014117300617, -120.732, -2.10717091251779),
(41314, '97002', 218, 43, 474, 45.2306, 0.789422892652547, -122.805, -2.14335158791164),
(41315, '97004', 218, 43, 71766, 45.2534, 0.789820827722002, -122.4783, -2.13764959724537),
(41316, '97005', 218, 43, 134, 45.4746, 0.793681496027413, -122.8037, -2.14332889863136),
(41317, '97006', 218, 43, 134, 45.5184, 0.794445950239787, -122.8592, -2.14429755636622),
(41318, '97007', 218, 43, 134, 45.4724, 0.79364309878387, -122.857, -2.14425915912267),
(41319, '97008', 218, 43, 134, 45.4609, 0.79344238591989, -122.798, -2.143229414864),
(41320, '97009', 218, 43, 44944, 45.4269, 0.792848973974212, -122.3812, -2.13595488254168),
(41321, '97010', 218, 43, 200450, 45.551, 0.795014927575937, -122.2737, -2.13407865359579),
(41322, '97011', 218, 43, 13042, 45.3639, 0.791749416545456, -122.0005, -2.12931041407934),
(41323, '97013', 218, 43, 35123, 45.2416, 0.789614878870267, -122.6766, -2.14111058515208),
(41324, '97014', 218, 43, 200534, 45.6694, 0.797081397410298, -121.8883, -2.1273521546586),
(41325, '97015', 218, 43, 200578, 45.4158, 0.792655242427241, -122.5238, -2.13844372205503),
(41326, '97016', 218, 43, 200583, 46.0982, 0.80456536924285, -123.1863, -2.15000652834949),
(41327, '97017', 218, 43, 93382, 45.1808, 0.788553718685054, -122.4032, -2.13633885497712),
(41328, '97018', 218, 43, 122416, 45.8935, 0.800992680264018, -122.8125, -2.14348248760554),
(41329, '97019', 218, 43, 45996, 45.5203, 0.794479111495575, -122.2619, -2.13387270474406),
(41330, '97020', 218, 43, 2074, 45.2216, 0.789265813019868, -122.839, -2.14394499985731),
(41331, '97021', 218, 43, 200728, 45.423, 0.792780906133384, -121.1616, -2.11466884698436),
(41332, '97022', 218, 43, 2152, 45.3532, 0.791562666315492, -122.3394, -2.13522533491435),
(41333, '97023', 218, 43, 200786, 45.2817, 0.790314755900316, -122.3131, -2.13476631332108),
(41334, '97024', 218, 43, 500, 45.5379, 0.794786289443926, -122.436, -2.13691132297178),
(41335, '97026', 218, 43, 200879, 45.1138, 0.787384348086218, -122.9216, -2.14538664181946),
(41336, '97027', 218, 43, 2726, 45.3907, 0.79221716478499, -122.5888, -2.13957818606882),
(41337, '97028', 218, 43, 193599, 45.3061, 0.790740616237803, -121.7459, -2.12486680580376),
(41338, '97029', 218, 43, 181887, 45.276, 0.790215272132953, -120.7608, -2.10767356734237),
(41339, '97030', 218, 43, 36207, 45.499, 0.7941073563649, -122.4204, -2.13663905160847),
(41340, '97031', 218, 43, 200994, 45.6679, 0.797055217471519, -121.5407, -2.12128539017867),
(41341, '97032', 218, 43, 3261, 45.185, 0.788627022513638, -122.8041, -2.14333587994837),
(41342, '97033', 218, 43, 3501, 45.0834, 0.786853767993612, -120.6648, -2.10599805126045),
(41343, '97034', 218, 43, 201095, 45.4096, 0.792547032013617, -122.6888, -2.14132351532082),
(41344, '97035', 218, 43, 201095, 45.4112, 0.792574957281649, -122.7243, -2.14194310720528),
(41345, '97036', 218, 43, 201192, 45.3958, 0.792306176576842, -122.6486, -2.14062189296152),
(41346, '97037', 218, 43, 56131, 45.0763, 0.78672984961672, -121.3793, -2.11846842876595),
(41347, '97038', 218, 43, 201250, 45.1206, 0.787503030475354, -122.569, -2.13923261087693),
(41348, '97039', 218, 43, 10602, 45.4849, 0.793861264940369, -120.7342, -2.10720930976134),
(41349, '97040', 218, 43, 190508, 45.664, 0.796987149630691, -121.3734, -2.11836545434009),
(41350, '97041', 218, 43, 0, 45.5226, 0.794519254068371, -121.5853, -2.12206380702506),
(41351, '97042', 218, 43, 201273, 45.2091, 0.789047646863368, -122.5416, -2.13875439066188),
(41352, '97044', 218, 43, 10922, 45.6248, 0.796302980563909, -121.5402, -2.12127666353241),
(41353, '97045', 218, 43, 183883, 45.3397, 0.791327046866473, -122.5591, -2.13905982328098),
(41354, '97048', 218, 43, 201451, 46.0578, 0.803860256225044, -122.9641, -2.14612840675156),
(41355, '97049', 218, 43, 201467, 45.3568, 0.791625498168564, -121.9527, -2.12847614669689),
(41356, '97050', 218, 43, 38036, 45.6819, 0.797299563566798, -120.7011, -2.10663160577893),
(41357, '97051', 218, 43, 38065, 45.8631, 0.800462100171411, -122.8412, -2.14398339710086),
(41358, '97053', 218, 43, 12663, 45.8238, 0.799776185775378, -122.8642, -2.14438482282882),
(41359, '97054', 218, 43, 40032, 45.9475, 0.801935158060095, -122.9127, -2.14523130751603),
(41360, '97055', 218, 43, 11802, 45.39, 0.792204947480226, -122.2308, -2.13332990734669),
(41361, '97056', 218, 43, 201537, 45.7917, 0.799215935085487, -122.9256, -2.14545645498954),
(41362, '97057', 218, 43, 201554, 45.0597, 0.786440124960889, -120.8076, -2.1084903814323),
(41363, '97058', 218, 43, 201648, 45.598, 0.795835232324374, -121.1938, -2.1152308430035),
(41364, '97060', 218, 43, 129106, 45.5279, 0.794611756518726, -122.3979, -2.13624635252677),
(41365, '97062', 218, 43, 201684, 45.3708, 0.791869844263843, -122.7702, -2.14274421333194),
(41366, '97063', 218, 43, 201694, 45.2385, 0.789560773663455, -121.3106, -2.11726938756983),
(41367, '97064', 218, 43, 201727, 45.8623, 0.800448137537395, -123.2, -2.15024563845701),
(41368, '97065', 218, 43, 121863, 45.5933, 0.795753201849531, -120.6986, -2.10658797254763),
(41369, '97067', 218, 43, 201764, 45.3386, 0.791307848244701, -121.9633, -2.1286611515976),
(41370, '97068', 218, 43, 201770, 45.3672, 0.791807012410771, -122.6496, -2.14063934625404),
(41371, '97070', 218, 43, 6863, 45.3012, 0.790655095104455, -122.7644, -2.14264298423533),
(41372, '97071', 218, 43, 29018, 45.1469, 0.787962052068628, -122.8569, -2.14425741379342),
(41373, '97075', 218, 43, 134, 45.4928, 0.793999145951276, -122.8013, -2.14328701072931),
(41374, '97076', 218, 43, 134, 45.4929, 0.794000891280528, -122.8012, -2.14328526540006),
(41375, '97077', 218, 43, 134, 45.4924, 0.793992164634268, -122.8009, -2.1432800294123),
(41376, '97078', 218, 43, 134, 45.4611, 0.793445876578394, -122.8023, -2.14330446402183),
(41377, '97080', 218, 43, 36207, 45.4838, 0.793842066318597, -122.4167, -2.13657447442614),
(41378, '97101', 218, 43, 7091, 45.117, 0.787440198622282, -123.185, -2.14998383906921),
(41379, '97102', 218, 43, 200337, 45.8856, 0.80085479925311, -123.9442, -2.16323437875036),
(41380, '97103', 218, 43, 18949, 46.1825, 0.806036681802281, -123.8285, -2.1612150328058),
(41381, '97106', 218, 43, 7248, 45.6202, 0.796222695418317, -123.1127, -2.14872196602002),
(41382, '97107', 218, 43, 15113, 45.5273, 0.794601284543214, -123.8811, -2.16213307599235),
(41383, '97108', 218, 43, 7346, 45.2821, 0.790321737217324, -123.7519, -2.15987811059877),
(41384, '97109', 218, 43, 31939, 45.6883, 0.797411264638925, -123.1908, -2.15008506816583),
(41385, '97110', 218, 43, 200518, 45.8881, 0.80089843248441, -123.9596, -2.16350315945516),
(41386, '97111', 218, 43, 1361, 45.2903, 0.790464854215988, -123.1867, -2.1500135096665),
(41387, '97112', 218, 43, 1638, 45.2195, 0.789229161105576, -123.9302, -2.16299003265508),
(41388, '97113', 218, 43, 29550, 45.5201, 0.794475620837071, -123.0474, -2.14758226601847),
(41389, '97114', 218, 43, 1992, 45.2023, 0.788928964474233, -123.0826, -2.14819662191517),
(41390, '97115', 218, 43, 2134, 45.2764, 0.790222253449961, -123.0193, -2.14709182849866),
(41391, '97116', 218, 43, 8927, 45.5224, 0.794515763409867, -123.107, -2.14862248225266),
(41392, '97117', 218, 43, 200863, 45.5858, 0.795622302155631, -123.2554, -2.15121255086262),
(41393, '97118', 218, 43, 200870, 45.5612, 0.795192951159641, -123.9105, -2.16264620279243),
(41394, '97119', 218, 43, 2675, 45.404, 0.792449293575505, -123.1488, -2.14935202987999),
(41395, '97121', 218, 43, 421, 46.1963, 0.806277537239056, -123.9513, -2.16335829712725),
(41396, '97122', 218, 43, 200961, 45.1943, 0.788789338134073, -123.8327, -2.16128833663438),
(41397, '97123', 218, 43, 3145, 45.5066, 0.794240001388052, -122.9462, -2.14581599281545),
(41398, '97124', 218, 43, 3145, 45.5347, 0.794730438907862, -122.9564, -2.14599401639916),
(41399, '97125', 218, 43, 10288, 45.6587, 0.796894647180335, -123.205, -2.15033290491961),
(41400, '97127', 218, 43, 3594, 45.2459, 0.789689928028102, -123.1117, -2.1487045127275),
(41401, '97128', 218, 43, 88922, 45.2069, 0.789009249619825, -123.2167, -2.1505371084421),
(41402, '97130', 218, 43, 183079, 45.7168, 0.797908683475744, -123.9349, -2.16307206312992),
(41403, '97131', 218, 43, 201288, 45.7087, 0.797767311806332, -123.8836, -2.16217670922365),
(41404, '97132', 218, 43, 201302, 45.312, 0.790843590663671, -122.9745, -2.14630992099377),
(41405, '97133', 218, 43, 201316, 45.5968, 0.79581428837335, -122.999, -2.14673752666051),
(41406, '97134', 218, 43, 151350, 45.461, 0.793444131249142, -123.9663, -2.16362009651505),
(41407, '97135', 218, 43, 117207, 45.2044, 0.788965616388525, -123.9604, -2.16351712208918),
(41408, '97136', 218, 43, 50954, 45.6147, 0.796126702309457, -123.9397, -2.16315583893402),
(41409, '97137', 218, 43, 11759, 45.2201, 0.789239633081088, -122.9532, -2.14593816586309),
(41410, '97138', 218, 43, 18021, 46.0018, 0.802882871843928, -123.9212, -2.1628329530224),
(41411, '97140', 218, 43, 14604, 45.3548, 0.791590591583524, -122.8334, -2.1438472614192),
(41412, '97141', 218, 43, 201660, 45.4564, 0.79336384610355, -123.8264, -2.16117838089151),
(41413, '97143', 218, 43, 201294, 45.4372, 0.793028742887167, -123.9456, -2.16325881335988),
(41414, '97144', 218, 43, 57906, 45.757, 0.798610305835045, -123.2993, -2.15197875040424),
(41415, '97145', 218, 43, 201670, 45.8698, 0.800579037231295, -123.9592, -2.16349617813815),
(41416, '97146', 218, 43, 6633, 46.1452, 0.805385673991287, -123.9231, -2.16286611427818),
(41417, '97147', 218, 43, 6759, 45.6888, 0.797419991285185, -123.8818, -2.16214529329711),
(41418, '97148', 218, 43, 201836, 45.3515, 0.791532995718208, -123.2164, -2.15053187245434),
(41419, '97149', 218, 43, 201293, 45.1063, 0.787253448392318, -123.9731, -2.16373877890418),
(41420, '97201', 218, 43, 5188, 45.4979, 0.794088157743128, -122.6911, -2.14136365789361),
(41421, '97202', 218, 43, 5188, 45.4843, 0.793850792964857, -122.6377, -2.14043165207305),
(41422, '97203', 218, 43, 5188, 45.5896, 0.795688624667207, -122.7391, -2.14220141593457),
(41423, '97204', 218, 43, 5188, 45.5183, 0.794444204910535, -122.6715, -2.14102157336022),
(41424, '97205', 218, 43, 5188, 45.5204, 0.794480856824827, -122.6855, -2.1412659194555),
(41425, '97206', 218, 43, 5188, 45.4848, 0.793859519611117, -122.5985, -2.13974748300627),
(41426, '97207', 218, 43, 5188, 45.5213, 0.794496564788095, -122.6858, -2.14127115544326),
(41427, '97208', 218, 43, 5188, 45.5326, 0.79469378699357, -122.5633, -2.13913312710957),
(41428, '97209', 218, 43, 5188, 45.5293, 0.794636191128254, -122.6807, -2.14118214365141),
(41429, '97210', 218, 43, 5188, 45.5357, 0.794747892200382, -122.7152, -2.14178428224335),
(41430, '97211', 218, 43, 5188, 45.568, 0.795311633548776, -122.6421, -2.14050844656014),
(41431, '97212', 218, 43, 5188, 45.5441, 0.794894499857549, -122.639, -2.14045434135333),
(41432, '97213', 218, 43, 5188, 45.5378, 0.794784544114674, -122.6002, -2.13977715360355),
(41433, '97214', 218, 43, 5188, 45.5141, 0.794370901081951, -122.6425, -2.14051542787715),
(41434, '97215', 218, 43, 5188, 45.5157, 0.794398826349983, -122.5998, -2.13977017228654),
(41435, '97216', 218, 43, 5188, 45.5147, 0.794381373057463, -122.5561, -2.13900746340342),
(41436, '97217', 218, 43, 5188, 45.5749, 0.795432061267164, -122.686, -2.14127464610176),
(41437, '97218', 218, 43, 5188, 45.5625, 0.795215640439916, -122.5992, -2.13975970031103),
(41438, '97219', 218, 43, 5188, 45.4592, 0.793412715322606, -122.703, -2.1415713520746),
(41439, '97220', 218, 43, 5188, 45.5423, 0.794863083931013, -122.5574, -2.1390301526837),
(41440, '97221', 218, 43, 5188, 45.4947, 0.794032307207064, -122.7271, -2.14199197642433),
(41441, '97222', 218, 43, 5188, 45.4384, 0.793049686838191, -122.6129, -2.13999881041856),
(41442, '97223', 218, 43, 5188, 45.4408, 0.793091574740239, -122.7745, -2.14281926248978),
(41443, '97224', 218, 43, 5188, 45.4077, 0.792513870757829, -122.7899, -2.14308804319459),
(41444, '97225', 218, 43, 5188, 45.5006, 0.794135281632932, -122.7705, -2.1427494493197),
(41445, '97227', 218, 43, 5188, 45.5447, 0.794904971833061, -122.6744, -2.14107218790853),
(41446, '97228', 218, 43, 5188, 45.5311, 0.79466760705479, -122.685, -2.14125719280924),
(41447, '97229', 218, 43, 5188, 45.5407, 0.794835158662982, -122.8301, -2.14378966555389),
(41448, '97230', 218, 43, 5188, 45.5412, 0.794843885309242, -122.4979, -2.13799168177876),
(41449, '97231', 218, 43, 5188, 45.6368, 0.796512420074148, -122.854, -2.14420679924511),
(41450, '97232', 218, 43, 5188, 45.5283, 0.794618737835734, -122.6348, -2.14038103752474),
(41451, '97233', 218, 43, 5188, 45.5145, 0.794377882398959, -122.5051, -2.13811734548491),
(41452, '97236', 218, 43, 5188, 45.49, 0.793950276732221, -122.5096, -2.13819588530125),
(41453, '97238', 218, 43, 5188, 45.5778, 0.795482675815472, -122.6002, -2.13977715360355),
(41454, '97239', 218, 43, 5188, 45.4983, 0.794095139060136, -122.6908, -2.14135842190586),
(41455, '97240', 218, 43, 5188, 45.5003, 0.794130045645176, -122.6571, -2.14077024594794),
(41456, '97242', 218, 43, 5188, 45.4818, 0.793807159733557, -122.6403, -2.1404770306336),
(41457, '97251', 218, 43, 5188, 45.5201, 0.794475620837071, -122.6722, -2.14103379066499),
(41458, '97253', 218, 43, 5188, 45.5214, 0.794498310117347, -122.6767, -2.14111233048133),
(41459, '97254', 218, 43, 5188, 45.5421, 0.79485959327251, -122.711, -2.14171097841476),
(41460, '97255', 218, 43, 5188, 45.5241, 0.794545434007151, -122.672, -2.14103030000648),
(41461, '97256', 218, 43, 5188, 45.5174, 0.794428496947267, -122.6796, -2.14116294502964),
(41462, '97258', 218, 43, 5188, 45.5126, 0.794344721143171, -122.6742, -2.14106869725003),
(41463, '97259', 218, 43, 5188, 45.5381, 0.79478978010243, -122.657, -2.14076850061868),
(41464, '97266', 218, 43, 5188, 45.4844, 0.793852538294109, -122.5558, -2.13900222741567),
(41465, '97267', 218, 43, 5188, 45.4083, 0.792524342733341, -122.6108, -2.13996215850426),
(41466, '97268', 218, 43, 5188, 45.4476, 0.793210257129375, -122.6455, -2.14056778775471),
(41467, '97269', 218, 43, 5188, 45.4412, 0.793098556057247, -122.6147, -2.14003022634509),
(41468, '97271', 218, 43, 5188, 45.4783, 0.793746073209737, -122.6944, -2.14142125375893),
(41469, '97272', 218, 43, 5188, 45.5161, 0.794405807666991, -122.6792, -2.14115596371263),
(41470, '97280', 218, 43, 5188, 45.453, 0.793304504908983, -122.7008, -2.14153295483106),
(41471, '97281', 218, 43, 5188, 45.4406, 0.793088084081735, -122.778, -2.1428803490136),
(41472, '97282', 218, 43, 5188, 45.4815, 0.793801923745801, -122.64, -2.14047179464585),
(41473, '97283', 218, 43, 5188, 45.5386, 0.79479850674869, -122.6565, -2.14075977397242),
(41474, '97286', 218, 43, 5188, 45.4815, 0.793801923745801, -122.5985, -2.13974748300627),
(41475, '97290', 218, 43, 5188, 45.5759, 0.795449514559684, -122.6447, -2.14055382512069),
(41476, '97291', 218, 43, 5188, 45.5456, 0.794920679796329, -122.7281, -2.14200942971685),
(41477, '97292', 218, 43, 5188, 45.5137, 0.794363919764943, -122.5558, -2.13900222741567),
(41478, '97293', 218, 43, 5188, 45.5145, 0.794377882398959, -122.6434, -2.14053113584041),
(41479, '97294', 218, 43, 5188, 45.543, 0.794875301235778, -122.4985, -2.13800215375427),
(41480, '97296', 218, 43, 5188, 45.5322, 0.794686805676562, -122.7765, -2.14285416907482),
(41481, '97298', 218, 43, 5188, 45.5022, 0.794163206900964, -122.7711, -2.14275992129521),
(41482, '97299', 218, 43, 5188, 45.5387, 0.794800252077942, -122.6565, -2.14075977397242),
(41483, '97301', 218, 43, 126, 44.9261, 0.784108365080224, -122.9627, -2.14610397214203),
(41484, '97302', 218, 43, 126, 44.9025, 0.783696467376754, -123.0476, -2.14758575667697),
(41485, '97303', 218, 43, 126, 44.9854, 0.785143345326657, -123.0117, -2.14695918347551),
(41486, '97304', 218, 43, 126, 44.9604, 0.784707013013659, -123.085, -2.14823850981722),
(41487, '97305', 218, 43, 126, 44.9903, 0.785228866460005, -122.9529, -2.14593292987534),
(41488, '97306', 218, 43, 126, 44.8657, 0.78305418621202, -123.0537, -2.14769222176135),
(41489, '97307', 218, 43, 201057, 45.0045, 0.785476703213788, -123.0208, -2.14711800843744),
(41490, '97308', 218, 43, 126, 44.8989, 0.783633635523682, -122.9265, -2.14547216295281),
(41491, '97309', 218, 43, 126, 44.9283, 0.784146762323768, -123.0106, -2.14693998485374),
(41492, '97310', 218, 43, 126, 44.912, 0.783862273655693, -123.007, -2.14687715300067),
(41493, '97311', 218, 43, 126, 44.9435, 0.784412052370072, -123.0287, -2.14725588944835),
(41494, '97312', 218, 43, 126, 44.8898, 0.783474810561751, -123.0594, -2.14779170552871),
(41495, '97313', 218, 43, 126, 44.9846, 0.785129382692641, -122.9991, -2.14673927198976),
(41496, '97314', 218, 43, 126, 44.966, 0.78480475145177, -123.007, -2.14687715300067),
(41497, '97321', 218, 43, 18772, 44.6273, 0.778893321275265, -123.0783, -2.14812157275734),
(41498, '97322', 218, 43, 18772, 44.6262, 0.778874122653493, -123.0583, -2.14777250690694),
(41499, '97324', 218, 43, 200318, 44.3659, 0.774331030610552, -123.6145, -2.15748002820653),
(41500, '97325', 218, 43, 200352, 44.8357, 0.782530587436422, -122.858, -2.14427661241519),
(41501, '97326', 218, 43, 31844, 44.6386, 0.779090543480741, -123.5538, -2.15642061335057),
(41502, '97327', 218, 43, 1191, 44.3873, 0.774704531070479, -122.9674, -2.14618600261688),
(41503, '97329', 218, 43, 200535, 44.3915, 0.774777834899063, -122.5055, -2.13812432680191),
(41504, '97330', 218, 43, 196282, 44.6013, 0.778439535669747, -123.2729, -2.15151798348172),
(41505, '97331', 218, 43, 196282, 44.5649, 0.777804235822021, -123.2811, -2.15166110048038),
(41506, '97333', 218, 43, 196282, 44.5173, 0.776973459098072, -123.2981, -2.15195780645322),
(41507, '97335', 218, 43, 8275, 44.6349, 0.779025966298417, -122.8982, -2.1449782347745),
(41508, '97336', 218, 43, 8287, 44.3582, 0.774196640258149, -122.8527, -2.14418410996484),
(41509, '97338', 218, 43, 1953, 44.9241, 0.784073458495185, -123.3282, -2.15248315055807),
(41510, '97339', 218, 43, 196282, 44.5654, 0.777812962468281, -123.2664, -2.15140453708034),
(41511, '97341', 218, 43, 200689, 44.8204, 0.782263552060867, -124.0568, -2.1651996194881),
(41512, '97342', 218, 43, 2034, 44.7341, 0.780757332916395, -122.1479, -2.13188302939678),
(41513, '97343', 218, 43, 27042, 44.6022, 0.778455243633015, -123.7634, -2.16007882346275),
(41514, '97344', 218, 43, 2413, 44.8666, 0.783069894175288, -123.4412, -2.15445537261282),
(41515, '97345', 218, 43, 35967, 44.425, 0.775362520198481, -122.5702, -2.13925355482795),
(41516, '97346', 218, 43, 865, 44.756, 0.781139560022582, -122.3818, -2.1359653545172),
(41517, '97347', 218, 43, 200908, 45.0563, 0.786380783766321, -123.6287, -2.15772786496031),
(41518, '97348', 218, 43, 27362, 44.3832, 0.774632972571147, -123.1229, -2.14889998960373),
(41519, '97350', 218, 43, 201012, 44.6998, 0.780158684982961, -122.0745, -2.13060195772582),
(41520, '97351', 218, 43, 3320, 44.8422, 0.782644033837801, -123.1859, -2.14999954703248),
(41521, '97352', 218, 43, 3409, 44.7422, 0.780898704585807, -123.0217, -2.14713371640071),
(41522, '97355', 218, 43, 3708, 44.5308, 0.777209078547091, -122.8712, -2.14450699587646),
(41523, '97357', 218, 43, 201152, 44.751, 0.781052293559982, -123.8124, -2.16093403479623),
(41524, '97358', 218, 43, 764, 44.7697, 0.781378670130105, -122.6064, -2.13988536401718),
(41525, '97359', 218, 43, 630, 44.7723, 0.781424048690657, -123.0065, -2.14686842635441),
(41526, '97360', 218, 43, 164576, 44.7504, 0.78104182158447, -122.4782, -2.13764785191612),
(41527, '97361', 218, 43, 4270, 44.8098, 0.782078547160155, -123.2953, -2.15190893723416),
(41528, '97362', 218, 43, 201264, 45.0666, 0.786560552679276, -122.784, -2.14298506876872),
(41529, '97364', 218, 43, 201291, 44.9992, 0.785384200763432, -123.9832, -2.16391505715863),
(41530, '97365', 218, 43, 10799, 44.6863, 0.779923065533942, -124.0063, -2.16431822821584),
(41531, '97366', 218, 43, 18123, 44.5549, 0.777629702896822, -124.0458, -2.16500763327038),
(41532, '97367', 218, 43, 30345, 44.9523, 0.784565641344247, -124.0043, -2.1642833216308),
(41533, '97368', 218, 43, 17462, 45.0061, 0.78550462848182, -123.9418, -2.16319249084831),
(41534, '97369', 218, 43, 201361, 44.747, 0.780982480389903, -124.0598, -2.16525197936566),
(41535, '97370', 218, 43, 23864, 44.5507, 0.777556399068238, -123.4107, -2.15392304719097),
(41536, '97371', 218, 43, 201471, 44.9835, 0.785110184070869, -123.2014, -2.15027007306654),
(41537, '97372', 218, 43, 201502, 44.8518, 0.782811585445993, -124.0457, -2.16500588794113),
(41538, '97373', 218, 43, 33852, 45.0573, 0.786398237058841, -122.7825, -2.14295888882994),
(41539, '97374', 218, 43, 133027, 44.6947, 0.78006967319111, -122.8035, -2.14332540797286),
(41540, '97375', 218, 43, 201540, 45.0062, 0.785506373811072, -122.6421, -2.14050844656014),
(41541, '97376', 218, 43, 201542, 44.4999, 0.776669771808225, -124.0561, -2.16518740218334),
(41542, '97377', 218, 43, 201557, 44.467, 0.776095558484319, -123.1118, -2.14870625805675),
(41543, '97378', 218, 43, 11906, 45.1138, 0.787384348086218, -123.3956, -2.15365950247392),
(41544, '97380', 218, 43, 201564, 44.7316, 0.780713699685096, -123.9117, -2.16266714674346),
(41545, '97381', 218, 43, 57571, 44.8953, 0.78357080367061, -122.5664, -2.13918723231638),
(41546, '97383', 218, 43, 91027, 44.8036, 0.781970336746531, -122.7589, -2.14254699112647),
(41547, '97384', 218, 43, 201214, 44.7902, 0.781736462626764, -122.6021, -2.13981031485934),
(41548, '97385', 218, 43, 201605, 44.8599, 0.782952957115404, -122.7615, -2.14259236968702),
(41549, '97386', 218, 43, 6194, 44.3929, 0.774802269508591, -122.7333, -2.14210018683796),
(41550, '97388', 218, 43, 200895, 44.8836, 0.783366600148127, -124.0313, -2.16475456052884),
(41551, '97389', 218, 43, 201640, 44.5375, 0.777326015606975, -123.0985, -2.14847412926624),
(41552, '97390', 218, 43, 18341, 44.3852, 0.774667879156187, -123.8949, -2.16237393142912),
(41553, '97391', 218, 43, 12339, 44.6279, 0.778903793250777, -123.929, -2.16296908870405),
(41554, '97392', 218, 43, 6415, 44.8113, 0.782104727098935, -122.9459, -2.1458107568277),
(41555, '97394', 218, 43, 201737, 44.4222, 0.775313650979425, -124.0497, -2.16507570111121),
(41556, '97396', 218, 43, 201808, 45.1048, 0.787227268453538, -123.4897, -2.15530185730004),
(41557, '97401', 218, 43, 346, 44.081, 0.76935858757162, -123.0704, -2.14798369174643),
(41558, '97402', 218, 43, 346, 44.0581, 0.768958907172914, -123.1883, -2.15004143493453),
(41559, '97403', 218, 43, 346, 44.0366, 0.768583661383735, -123.0529, -2.14767825912733),
(41560, '97404', 218, 43, 346, 44.1008, 0.769704162763515, -123.1326, -2.14906928654117),
(41561, '97405', 218, 43, 346, 44.0043, 0.768019920035341, -123.1219, -2.14888253631121),
(41562, '97406', 218, 43, 200297, 42.61, 0.743684794274784, -124.0724, -2.16547189085141),
(41563, '97407', 218, 43, 146758, 43.4256, 0.75791969965405, -124.032, -2.16476677783361),
(41564, '97408', 218, 43, 346, 44.0525, 0.768861168734802, -123.1124, -2.14871673003227);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(41565, '97409', 218, 43, 200323, 44.1284, 0.770185873637066, -123.265, -2.15138010247081),
(41566, '97410', 218, 43, 724, 42.7918, 0.74685780285491, -123.2197, -2.15058946831966),
(41567, '97411', 218, 43, 29146, 43.1166, 0.752526632265387, -124.4088, -2.17134317845512),
(41568, '97412', 218, 43, 200417, 44.1867, 0.771203400590978, -123.5487, -2.15633160155872),
(41569, '97413', 218, 43, 29245, 44.1658, 0.770838626777312, -122.2143, -2.13304192802011),
(41570, '97414', 218, 43, 200457, 42.9822, 0.750180909750707, -124.1214, -2.16632710218489),
(41571, '97415', 218, 43, 7700, 42.0663, 0.734195439131691, -124.2706, -2.16893113342887),
(41572, '97416', 218, 43, 200509, 43.039, 0.75117225676584, -123.6817, -2.15865288946387),
(41573, '97417', 218, 43, 200520, 42.9334, 0.749329189075733, -123.2709, -2.15148307689668),
(41574, '97419', 218, 43, 72084, 44.1728, 0.770960799824951, -123.3722, -2.15325109542895),
(41575, '97420', 218, 43, 200618, 43.3534, 0.75665957193411, -124.2286, -2.16819809514303),
(41576, '97423', 218, 43, 200624, 43.1813, 0.753655860291427, -124.1859, -2.16745283955243),
(41577, '97424', 218, 43, 1788, 43.7843, 0.764180195680953, -123.0589, -2.14778297888245),
(41578, '97425', 218, 43, 54255, 43.5245, 0.759645830284272, -121.9553, -2.12852152525744),
(41579, '97426', 218, 43, 1884, 43.9067, 0.766316478685394, -123.0342, -2.14735188255721),
(41580, '97427', 218, 43, 200655, 43.6857, 0.762459301038487, -122.7966, -2.14320498025447),
(41581, '97428', 218, 43, 108771, 43.7547, 0.763663578222363, -123.4225, -2.1541289960427),
(41582, '97429', 218, 43, 193204, 42.9841, 0.750214071006495, -123.1004, -2.14850729052203),
(41583, '97430', 218, 43, 93665, 44.1095, 0.769856006408439, -123.712, -2.15918172422723),
(41584, '97431', 218, 43, 2038, 43.907, 0.76632171467315, -122.8251, -2.14370239909129),
(41585, '97432', 218, 43, 2042, 43.1673, 0.753411514196148, -123.4503, -2.15461419757476),
(41586, '97434', 218, 43, 35609, 43.7385, 0.76338083488354, -122.8901, -2.14483686310508),
(41587, '97435', 218, 43, 200717, 43.6532, 0.761892069031589, -123.3629, -2.15308877980851),
(41588, '97436', 218, 43, 15918, 43.6358, 0.761588381741742, -123.5923, -2.15709256511259),
(41589, '97437', 218, 43, 54613, 44.0908, 0.769529629838316, -123.3798, -2.1533837404521),
(41590, '97438', 218, 43, 27138, 43.9585, 0.767220559237927, -122.7819, -2.14294841685443),
(41591, '97439', 218, 43, 2502, 43.9906, 0.767780809927818, -124.0904, -2.16578605011677),
(41592, '97440', 218, 43, 346, 44.0587, 0.768969379148426, -123.1134, -2.14873418332479),
(41593, '97441', 218, 43, 115683, 43.7291, 0.763216773933852, -124.1089, -2.16610893602839),
(41594, '97442', 218, 43, 2741, 42.7548, 0.746212031031672, -123.3843, -2.15346228026844),
(41595, '97443', 218, 43, 200898, 43.2772, 0.75532963104409, -123.0741, -2.14804826892875),
(41596, '97444', 218, 43, 209893, 42.4476, 0.740850379569545, -124.3922, -2.17105345379929),
(41597, '97446', 218, 43, 2994, 44.2736, 0.772720091710962, -123.1149, -2.14876036326357),
(41598, '97447', 218, 43, 201014, 43.328, 0.756216258304103, -123.0261, -2.1472105108878),
(41599, '97448', 218, 43, 9806, 44.1945, 0.771339536272634, -123.2534, -2.15117764427758),
(41600, '97449', 218, 43, 9948, 43.5819, 0.760647649274917, -124.1599, -2.16699905394691),
(41601, '97450', 218, 43, 201106, 42.9155, 0.749016775139627, -124.4276, -2.1716713003545),
(41602, '97451', 218, 43, 22742, 43.8178, 0.764764880980371, -123.244, -2.15101358332789),
(41603, '97452', 218, 43, 10211, 43.9146, 0.766454359696302, -122.7648, -2.14264996555233),
(41604, '97453', 218, 43, 30422, 44.0359, 0.768571444078971, -123.8627, -2.16181193540998),
(41605, '97454', 218, 43, 201182, 44.2115, 0.771636242245473, -122.8174, -2.14356800873888),
(41606, '97455', 218, 43, 268, 43.9685, 0.767395092163127, -122.9154, -2.14527843140584),
(41607, '97456', 218, 43, 10560, 44.3353, 0.773796959859442, -123.3337, -2.15257914366693),
(41608, '97457', 218, 43, 201278, 43.0251, 0.750929655999812, -123.2848, -2.15172567766271),
(41609, '97458', 218, 43, 49737, 43.0654, 0.751633023688366, -124.1335, -2.16653828702438),
(41610, '97459', 218, 43, 23407, 43.435, 0.758083760603737, -124.2127, -2.16792058779196),
(41611, '97460', 218, 43, 33458, 43.101, 0.752254360902076, -123.9833, -2.16391680248789),
(41612, '97461', 218, 43, 209898, 44.0968, 0.769634349593436, -123.4676, -2.15491613953535),
(41613, '97462', 218, 43, 4710, 43.4813, 0.75889184804741, -123.3994, -2.15372582498549),
(41614, '97463', 218, 43, 50015, 43.748, 0.763546641162479, -122.466, -2.13743492174738),
(41615, '97464', 218, 43, 4792, 42.5014, 0.741789366707118, -124.4137, -2.17142869958847),
(41616, '97465', 218, 43, 184235, 42.7585, 0.746276608213995, -124.4834, -2.17264519407711),
(41617, '97466', 218, 43, 5205, 42.8831, 0.74845128846198, -124.0723, -2.16547014552216),
(41618, '97467', 218, 43, 201462, 43.679, 0.762342363978603, -124.0747, -2.16551203342421),
(41619, '97469', 218, 43, 5382, 42.9503, 0.74962414971932, -123.3728, -2.15326156740446),
(41620, '97470', 218, 43, 31008, 43.2245, 0.754409842528289, -123.3686, -2.15318826357588),
(41621, '97472', 218, 43, 5602, 43.8321, 0.765014463063406, -123.045, -2.14754037811642),
(41622, '97473', 218, 43, 31093, 43.6627, 0.762057875310528, -123.794, -2.16061289421386),
(41623, '97476', 218, 43, 201574, 42.8183, 0.747320315106688, -124.4571, -2.17218617248383),
(41624, '97477', 218, 43, 349, 44.0649, 0.769077589562049, -123.0105, -2.14693823952448),
(41625, '97478', 218, 43, 349, 44.0595, 0.768983341782442, -122.8981, -2.14497648944524),
(41626, '97479', 218, 43, 106753, 43.3921, 0.757335014354631, -123.2953, -2.15190893723416),
(41627, '97480', 218, 43, 201632, 44.0517, 0.768847206100786, -123.7406, -2.1596808883933),
(41628, '97481', 218, 43, 43308, 43.0931, 0.752116479891168, -123.5682, -2.15667194076286),
(41629, '97482', 218, 43, 6335, 44.0941, 0.769587225703632, -122.8682, -2.1444546359989),
(41630, '97484', 218, 43, 209901, 42.9222, 0.74913371219951, -122.9228, -2.14540758577049),
(41631, '97486', 218, 43, 201699, 43.3881, 0.757265201184552, -123.5144, -2.15573295362528),
(41632, '97487', 218, 43, 201724, 44.0424, 0.768684890480351, -123.352, -2.15289853892005),
(41633, '97488', 218, 43, 285, 44.1358, 0.770315028001713, -122.4918, -2.13788521669439),
(41634, '97489', 218, 43, 201742, 44.1239, 0.770107333820726, -122.634, -2.14036707489073),
(41635, '97490', 218, 43, 18491, 44.0315, 0.768494649591883, -123.5941, -2.15712398103912),
(41636, '97491', 218, 43, 201763, 42.4597, 0.741061564409036, -124.4015, -2.17121576941973),
(41637, '97492', 218, 43, 201782, 43.7543, 0.763656596905355, -122.5015, -2.13805451363183),
(41638, '97493', 218, 43, 637, 43.9096, 0.766367093233702, -124.0684, -2.16540207768133),
(41639, '97494', 218, 43, 31532, 43.3196, 0.756069650646936, -123.3405, -2.15269782605607),
(41640, '97495', 218, 43, 12894, 43.2788, 0.755357556312122, -123.3539, -2.15293170017583),
(41641, '97496', 218, 43, 18654, 43.1022, 0.7522753048531, -123.4541, -2.15468052008633),
(41642, '97497', 218, 43, 6896, 42.6619, 0.744590620156569, -123.3697, -2.15320746219765),
(41643, '97498', 218, 43, 201835, 44.3229, 0.773580539032195, -124.0891, -2.1657633608365),
(41644, '97499', 218, 43, 201841, 43.5946, 0.76086930608992, -123.2407, -2.15095598746258),
(41645, '97501', 218, 43, 49404, 42.3156, 0.738546544956913, -122.8825, -2.14470421808193),
(41646, '97502', 218, 43, 100658, 42.4023, 0.740059745418392, -122.915, -2.14527145008883),
(41647, '97503', 218, 43, 6770, 42.4215, 0.740394848634775, -122.8179, -2.14357673538514),
(41648, '97504', 218, 43, 49404, 42.3368, 0.738916554758335, -122.8342, -2.14386122405322),
(41649, '97520', 218, 43, 13301, 42.1868, 0.736298560880344, -122.6724, -2.14103728132349),
(41650, '97522', 218, 43, 200493, 42.5369, 0.742408958591576, -122.5484, -2.13887307305102),
(41651, '97523', 218, 43, 200537, 42.1392, 0.735467784156395, -123.6252, -2.15766677843649),
(41652, '97524', 218, 43, 80792, 42.4848, 0.741499642051287, -122.7712, -2.14276166662446),
(41653, '97525', 218, 43, 2759, 42.4405, 0.740726461192653, -123.0667, -2.14791911456411),
(41654, '97526', 218, 43, 200913, 42.4659, 0.74116977482266, -123.3483, -2.15283396173772),
(41655, '97527', 218, 43, 200913, 42.4008, 0.740033565479612, -123.3553, -2.15295613478536),
(41656, '97528', 218, 43, 200913, 42.4395, 0.740709007900134, -123.327, -2.15246220660705),
(41657, '97530', 218, 43, 3395, 42.2396, 0.737220094725397, -123.0406, -2.14746358362934),
(41658, '97531', 218, 43, 131563, 42.1947, 0.736436441891251, -123.6474, -2.15805424153044),
(41659, '97532', 218, 43, 584, 42.5316, 0.74231645614122, -123.4321, -2.15429654765089),
(41660, '97533', 218, 43, 23277, 42.3389, 0.738953206672627, -123.2881, -2.15178327352802),
(41661, '97534', 218, 43, 17333, 42.0657, 0.734184967156179, -123.7036, -2.15903511657006),
(41662, '97535', 218, 43, 23865, 42.2718, 0.737782090744539, -122.8184, -2.1435854620314),
(41663, '97536', 218, 43, 5238, 42.7447, 0.74603575277722, -122.5254, -2.13847164732306),
(41664, '97537', 218, 43, 201500, 42.5034, 0.741824273292158, -123.1502, -2.14937646448952),
(41665, '97538', 218, 43, 5731, 42.2692, 0.737736712183987, -123.5844, -2.15695468410168),
(41666, '97539', 218, 43, 201551, 42.6127, 0.743731918164588, -122.8142, -2.14351215820282),
(41667, '97540', 218, 43, 201638, 42.2339, 0.737120610958033, -122.7912, -2.14311073247486),
(41668, '97541', 218, 43, 57935, 42.6781, 0.744873363495392, -122.7581, -2.14253302849245),
(41669, '97543', 218, 43, 99111, 42.3684, 0.739468078801966, -123.5137, -2.15572073632052),
(41670, '97544', 218, 43, 878, 42.2283, 0.737022872519921, -123.2802, -2.15164539251711),
(41671, '97601', 218, 43, 201080, 42.2194, 0.736867538216494, -121.7961, -2.12574296108827),
(41672, '97602', 218, 43, 201080, 42.194, 0.736424224586487, -121.6566, -2.12330822678173),
(41673, '97603', 218, 43, 201080, 42.1785, 0.736153698552428, -121.7087, -2.12421754332202),
(41674, '97604', 218, 43, 0, 43.0728, 0.751762178053014, -121.8638, -2.12692454899187),
(41675, '97620', 218, 43, 18743, 42.1919, 0.736387572672195, -119.7212, -2.08952912443864),
(41676, '97621', 218, 43, 58588, 42.4247, 0.740450699170838, -121.1821, -2.11502663948102),
(41677, '97622', 218, 43, 180147, 42.4246, 0.740448953841586, -121.1811, -2.1150091861885),
(41678, '97623', 218, 43, 7590, 42.2944, 0.73817653515549, -121.1856, -2.11508772600484),
(41679, '97624', 218, 43, 200570, 42.5928, 0.743384597643441, -121.8752, -2.12712351652659),
(41680, '97625', 218, 43, 72261, 42.2419, 0.737260237298193, -121.6365, -2.12295741560208),
(41681, '97626', 218, 43, 200839, 42.3882, 0.73981365399386, -122.1046, -2.13112730183067),
(41682, '97627', 218, 43, 36693, 42.1262, 0.735240891353635, -121.9651, -2.12869256752414),
(41683, '97630', 218, 43, 3619, 42.1869, 0.736300306209596, -120.3509, -2.10051946273844),
(41684, '97632', 218, 43, 201175, 42.0221, 0.733424003602309, -121.4269, -2.1192992054899),
(41685, '97633', 218, 43, 49421, 42.0244, 0.733464146175105, -121.5698, -2.121793280991),
(41686, '97634', 218, 43, 10461, 42.1303, 0.735312449852967, -121.8189, -2.12614089615772),
(41687, '97635', 218, 43, 193814, 42.0496, 0.733903969146608, -120.2374, -2.09853851403743),
(41688, '97636', 218, 43, 17481, 42.7101, 0.74543186885603, -120.5172, -2.10342194528451),
(41689, '97637', 218, 43, 201418, 42.6081, 0.743651633018996, -119.9706, -2.09388197559311),
(41690, '97638', 218, 43, 18083, 43.2813, 0.755401189543422, -120.6228, -2.10526501297462),
(41691, '97639', 218, 43, 201588, 42.7084, 0.745402198258746, -121.5647, -2.12170426919915),
(41692, '97640', 218, 43, 201606, 42.9, 0.748746249105567, -121.1695, -2.11480672799527),
(41693, '97641', 218, 43, 200574, 43.2434, 0.754739709756916, -120.6794, -2.10625286933124),
(41694, '97701', 218, 43, 7406, 44.0977, 0.769650057556704, -121.2904, -2.11691683106093),
(41695, '97702', 218, 43, 7406, 44.0207, 0.768306154032668, -121.2962, -2.11701806015755),
(41696, '97707', 218, 43, 7406, 43.8446, 0.765232629219906, -121.5086, -2.12072513948878),
(41697, '97708', 218, 43, 7406, 44.0752, 0.769257358475005, -121.3018, -2.11711579859566),
(41698, '97709', 218, 43, 7406, 44.0656, 0.769089806866813, -121.3106, -2.11726938756983),
(41699, '97710', 218, 43, 21073, 42.2695, 0.737741948171743, -118.8606, -2.07450882089597),
(41700, '97711', 218, 43, 58501, 44.6923, 0.780027785289062, -120.6542, -2.10581304635974),
(41701, '97712', 218, 43, 118932, 43.7179, 0.763021297057629, -120.4717, -2.10262782047485),
(41702, '97720', 218, 43, 1244, 43.5279, 0.75970517147884, -118.7656, -2.07285075810658),
(41703, '97721', 218, 43, 5231, 42.7387, 0.745931033022101, -118.661, -2.07102514370899),
(41704, '97722', 218, 43, 2039, 43.0125, 0.750709744514061, -118.6657, -2.07110717418383),
(41705, '97730', 218, 43, 200513, 44.4452, 0.775715076707384, -121.6592, -2.12335360534229),
(41706, '97731', 218, 43, 200562, 43.0731, 0.75176741404077, -121.8632, -2.12691407701635),
(41707, '97732', 218, 43, 29571, 43.3949, 0.757383883573687, -118.4376, -2.06712607816004),
(41708, '97733', 218, 43, 8292, 43.509, 0.759375304250213, -121.7389, -2.12474463275613),
(41709, '97734', 218, 43, 32191, 44.5089, 0.776826851440904, -121.211, -2.11553103963485),
(41710, '97735', 218, 43, 200840, 43.5247, 0.759649320942776, -121.17, -2.11481545464153),
(41711, '97736', 218, 43, 200854, 42.8252, 0.747440742825076, -118.9142, -2.07544431737504),
(41712, '97737', 218, 43, 16213, 43.4247, 0.757903991690782, -121.7021, -2.12410235159139),
(41713, '97738', 218, 43, 3160, 43.5645, 0.76034396198507, -119.0837, -2.07840265045717),
(41714, '97739', 218, 43, 201086, 43.7049, 0.76279440425487, -121.5298, -2.1210951492902),
(41715, '97741', 218, 43, 22817, 44.6491, 0.7792738030522, -121.1374, -2.11424647730538),
(41716, '97750', 218, 43, 4252, 44.5448, 0.77745342464237, -120.0087, -2.09454694603812),
(41717, '97751', 218, 43, 42514, 44.1958, 0.77136222555291, -119.8527, -2.09182423240501),
(41718, '97752', 218, 43, 37777, 43.9965, 0.767883784353685, -120.2308, -2.0984233223068),
(41719, '97753', 218, 43, 201431, 44.2288, 0.771938184206068, -121.0017, -2.11187806551042),
(41720, '97754', 218, 43, 201440, 44.3004, 0.773187839950496, -120.8359, -2.10898430961062),
(41721, '97756', 218, 43, 111080, 44.2764, 0.772768960930017, -121.2027, -2.11538617730693),
(41722, '97758', 218, 43, 5401, 43.1337, 0.752825083567478, -119.6861, -2.08891651387119),
(41723, '97759', 218, 43, 201570, 44.3271, 0.773653842860778, -121.5763, -2.12190672739238),
(41724, '97760', 218, 43, 138419, 44.3556, 0.774151261697597, -121.1869, -2.11511041528512),
(41725, '97761', 218, 43, 6631, 44.762, 0.781244279777702, -121.3023, -2.11712452524192),
(41726, '97801', 218, 43, 11133, 45.6666, 0.797032528191243, -118.7965, -2.07339006484544),
(41727, '97810', 218, 43, 14941, 45.7683, 0.798807528040521, -118.5616, -2.06929028643251),
(41728, '97812', 218, 43, 15026, 45.6869, 0.797386830029397, -120.1875, -2.09766759474068),
(41729, '97813', 218, 43, 15046, 45.8138, 0.799601652850178, -118.4888, -2.06801968673706),
(41730, '97814', 218, 43, 200360, 44.7787, 0.781535749762785, -117.8342, -2.0565947614535),
(41731, '97817', 218, 43, 7296, 44.5139, 0.776914117903504, -118.5033, -2.0682727594786),
(41732, '97818', 218, 43, 15277, 45.8105, 0.799544056984862, -119.6956, -2.08908232015012),
(41733, '97819', 218, 43, 1130, 44.4854, 0.776416699066685, -117.7438, -2.0550169838097),
(41734, '97820', 218, 43, 93036, 44.3911, 0.774770853582055, -118.9479, -2.07603249333296),
(41735, '97821', 218, 43, 0, 45.6129, 0.796095286382922, -118.731, -2.07224687418539),
(41736, '97823', 218, 43, 85989, 45.2356, 0.789510159115147, -120.1923, -2.09775137054478),
(41737, '97824', 218, 43, 91, 45.3327, 0.791204873818834, -117.8538, -2.05693684598689),
(41738, '97825', 218, 43, 29612, 44.4677, 0.776107775789083, -119.5309, -2.08620776287209),
(41739, '97826', 218, 43, 2207, 45.7405, 0.798322326508466, -119.192, -2.08029284203708),
(41740, '97827', 218, 43, 2254, 45.5906, 0.795706077959727, -117.893, -2.05762101505367),
(41741, '97828', 218, 43, 2311, 45.4202, 0.792732036914328, -117.2682, -2.04671619788721),
(41742, '97830', 218, 43, 200844, 44.9988, 0.785377219446424, -120.2134, -2.09811963501695),
(41743, '97831', 218, 43, 8963, 44.6269, 0.778886339958257, -119.3312, -2.08272234035586),
(41744, '97833', 218, 43, 162364, 44.9125, 0.783871000301953, -117.9388, -2.05842037585109),
(41745, '97834', 218, 43, 9292, 44.9608, 0.784713994330666, -117.1267, -2.04424655699564),
(41746, '97835', 218, 43, 200963, 45.9087, 0.801257970310321, -118.848, -2.07428890941022),
(41747, '97836', 218, 43, 200968, 45.3588, 0.791660404753604, -119.558, -2.08668074709938),
(41748, '97837', 218, 43, 48009, 44.5916, 0.778270238732304, -117.99, -2.05931398442811),
(41749, '97838', 218, 43, 200970, 45.8396, 0.800051947797193, -119.284, -2.08189854494892),
(41750, '97839', 218, 43, 3748, 45.3894, 0.792194475504714, -119.8069, -2.09102487160759),
(41751, '97840', 218, 43, 42466, 44.9558, 0.784626727868067, -116.9213, -2.04066165071205),
(41752, '97841', 218, 43, 201017, 45.4708, 0.793615173515838, -117.9631, -2.05884449085932),
(41753, '97842', 218, 43, 201018, 45.7529, 0.798538747335714, -116.865, -2.03967903034317),
(41754, '97843', 218, 43, 9667, 45.5004, 0.794131790974428, -119.8232, -2.09130936027567),
(41755, '97844', 218, 43, 201028, 45.8982, 0.801074710738861, -119.4952, -2.08558468032913),
(41756, '97845', 218, 43, 201045, 44.4295, 0.775441060014821, -118.9488, -2.07604820129623),
(41757, '97846', 218, 43, 60454, 45.3507, 0.791519033084192, -117.2281, -2.04601632085716),
(41758, '97848', 218, 43, 3526, 44.695, 0.780074909178866, -119.5806, -2.08707519151033),
(41759, '97850', 218, 43, 201085, 45.3291, 0.791142041965762, -118.0778, -2.06084638351136),
(41760, '97856', 218, 43, 27747, 44.7135, 0.780397795090485, -119.1026, -2.0787325176858),
(41761, '97857', 218, 43, 201162, 45.4845, 0.793854283623361, -117.4421, -2.04975132545643),
(41762, '97859', 218, 43, 88932, 45.5061, 0.794231274741792, -118.4199, -2.06681715488243),
(41763, '97861', 218, 43, 201228, 45.7175, 0.797920900780508, -120.2019, -2.09791892215297),
(41764, '97862', 218, 43, 0, 45.9357, 0.801729209208359, -118.3893, -2.06628308413132),
(41765, '97864', 218, 43, 164754, 44.8691, 0.783113527406588, -119.4486, -2.0847713568977),
(41766, '97865', 218, 43, 4411, 44.4191, 0.775259545772613, -119.1132, -2.07891752258651),
(41767, '97867', 218, 43, 201318, 45.0385, 0.786070115159466, -117.9374, -2.05839594124156),
(41768, '97868', 218, 43, 117296, 45.483, 0.793828103684581, -118.8318, -2.0740061660714),
(41769, '97869', 218, 43, 30889, 44.4595, 0.775964658790419, -118.7091, -2.0718646470792),
(41770, '97870', 218, 43, 5374, 44.768, 0.781348999532821, -117.1681, -2.04496912330597),
(41771, '97872', 218, 43, 50847, 44.9372, 0.784302096627196, -118.9463, -2.07600456806493),
(41772, '97873', 218, 43, 18037, 44.1307, 0.770226016209862, -118.9893, -2.07675505964329),
(41773, '97874', 218, 43, 18171, 44.8141, 0.782153596317991, -119.8669, -2.09207206915879),
(41774, '97875', 218, 43, 69057, 45.783, 0.799064091440564, -119.2181, -2.08074837297185),
(41775, '97876', 218, 43, 6150, 45.5151, 0.794388354374471, -118.0195, -2.05982885655745),
(41776, '97877', 218, 43, 12208, 44.7313, 0.780708463697339, -118.2647, -2.06410840388334),
(41777, '97880', 218, 43, 185812, 45.1339, 0.787735159265869, -118.9322, -2.0757584766404),
(41778, '97882', 218, 43, 18403, 45.9136, 0.801343491443669, -119.2965, -2.08211671110542),
(41779, '97883', 218, 43, 455, 45.1903, 0.788719524963994, -117.836, -2.05662617738004),
(41780, '97884', 218, 43, 6476, 44.4388, 0.775603375635256, -118.1911, -2.06282384155387),
(41781, '97885', 218, 43, 193219, 45.5696, 0.795339558816808, -117.5278, -2.05124707262539),
(41782, '97886', 218, 43, 6746, 45.8135, 0.799596416862422, -118.4225, -2.06686253344298),
(41783, '97901', 218, 43, 18746, 43.6797, 0.762354581283367, -117.0608, -2.04309638501858),
(41784, '97902', 218, 43, 200342, 42.9137, 0.748985359213091, -117.4811, -2.05043200386471),
(41785, '97903', 218, 43, 200460, 44.2459, 0.772236635508159, -117.5159, -2.0510393784444),
(41786, '97904', 218, 43, 200722, 43.8792, 0.765836513141096, -118.5351, -2.06882777418073),
(41787, '97905', 218, 43, 200735, 44.5827, 0.778114904428876, -117.4632, -2.0501195899286),
(41788, '97906', 218, 43, 16368, 43.8748, 0.765759718654008, -117.5919, -2.05236582867592),
(41789, '97907', 218, 43, 9621, 44.3496, 0.774046541942477, -117.2641, -2.04664463938788),
(41790, '97908', 218, 43, 201027, 44.3593, 0.774215838879921, -117.8338, -2.05658778013649),
(41791, '97909', 218, 43, 16600, 44.2221, 0.771821247146184, -117.4874, -2.05054195960759),
(41792, '97910', 218, 43, 163188, 42.9606, 0.749803918632276, -117.2873, -2.04704955577435),
(41793, '97911', 218, 43, 201053, 43.7474, 0.763536169186967, -118.0768, -2.06082893021884),
(41794, '97913', 218, 43, 56608, 43.8383, 0.76512267347703, -117.06, -2.04308242238456),
(41795, '97914', 218, 43, 33502, 44.0519, 0.76885069675929, -116.9842, -2.04175946281155),
(41796, '97917', 218, 43, 5423, 43.5091, 0.759377049579465, -118.0986, -2.06120941199578),
(41797, '97918', 218, 43, 52327, 44.0135, 0.768180490326524, -117.2874, -2.0470513011036),
(41798, '97920', 218, 43, 34389, 43.9469, 0.767018101044696, -117.7497, -2.05511995823557),
(41799, '98001', 218, 56, 13306, 47.3102, 0.825718759777021, -122.2631, -2.13389364869508),
(41800, '98002', 218, 56, 13306, 47.3027, 0.825587860083122, -122.1865, -2.13255672648805),
(41801, '98003', 218, 56, 207400, 47.3164, 0.825826970190645, -122.3208, -2.13490070367348),
(41802, '98004', 218, 56, 270, 47.6193, 0.831113572494936, -122.2091, -2.132951170899),
(41803, '98005', 218, 56, 270, 47.6145, 0.83102979669084, -122.1681, -2.13223558590568),
(41804, '98006', 218, 56, 270, 47.5612, 0.830099536199527, -122.1532, -2.13197553184714),
(41805, '98007', 218, 56, 270, 47.6125, 0.8309948901058, -122.1432, -2.13180099892194),
(41806, '98008', 218, 56, 270, 47.6107, 0.830963474179264, -122.1135, -2.1312826361341),
(41807, '98009', 218, 56, 270, 47.6197, 0.831120553811944, -122.2039, -2.1328604137779),
(41808, '98010', 218, 56, 855, 47.3112, 0.825736213069541, -121.9982, -2.12927027150655),
(41809, '98011', 218, 56, 206872, 47.754, 0.833464530997372, -122.1929, -2.13266842756018),
(41810, '98012', 218, 56, 206872, 47.842, 0.835000420739127, -122.2037, -2.13285692311939),
(41811, '98013', 218, 56, 7796, 47.4622, 0.828371660240053, -122.476, -2.13760945467258),
(41812, '98014', 218, 56, 200526, 47.6582, 0.831792505573962, -121.9131, -2.1277849963131),
(41813, '98015', 218, 56, 270, 47.6192, 0.831111827165684, -122.2047, -2.13287437641191),
(41814, '98019', 218, 56, 2143, 47.7374, 0.833174806341541, -121.8483, -2.12665402295781),
(41815, '98020', 218, 56, 64441, 47.8016, 0.834295307721321, -122.3759, -2.13586238009133),
(41816, '98021', 218, 56, 206872, 47.791, 0.83411030282061, -122.2182, -2.13310999586093),
(41817, '98022', 218, 56, 207346, 47.2515, 0.824694251506101, -121.669, -2.12352464760898),
(41818, '98023', 218, 56, 207400, 47.3118, 0.825746685045053, -122.3637, -2.13564944992259),
(41819, '98024', 218, 56, 86928, 47.5642, 0.830151896077087, -121.9014, -2.12758079279062),
(41820, '98025', 218, 56, 844, 47.4202, 0.827638621954215, -121.9696, -2.12877110734048),
(41821, '98026', 218, 56, 64441, 47.8404, 0.834972495471095, -122.3346, -2.13514155911025),
(41822, '98027', 218, 56, 207732, 47.5315, 0.829581173411685, -122.0674, -2.13047803934893),
(41823, '98028', 218, 56, 41584, 47.7538, 0.833461040338868, -122.2422, -2.13352887488141),
(41824, '98029', 218, 56, 207732, 47.5583, 0.830048921651219, -122.0048, -2.12938546323718),
(41825, '98030', 218, 56, 3501, 47.3863, 0.827046955337789, -122.2109, -2.13298258682554),
(41826, '98031', 218, 56, 3501, 47.3871, 0.827060917971805, -122.1969, -2.13273824073026),
(41827, '98032', 218, 56, 3501, 47.3934, 0.827170873714681, -122.2578, -2.13380114624472),
(41828, '98033', 218, 56, 3558, 47.6869, 0.832293415069284, -122.1901, -2.13261955834112),
(41829, '98034', 218, 56, 3558, 47.7191, 0.832855411088426, -122.1988, -2.13277140198605),
(41830, '98035', 218, 56, 3501, 47.3877, 0.827071389947317, -122.1988, -2.13277140198605),
(41831, '98036', 218, 56, 114, 47.8143, 0.834516964536325, -122.2792, -2.13417464670465),
(41832, '98037', 218, 56, 114, 47.8497, 0.835134811091531, -122.2823, -2.13422875191146),
(41833, '98038', 218, 56, 30419, 47.3946, 0.827191817665704, -122.0285, -2.1297991062699),
(41834, '98039', 218, 56, 10432, 47.6158, 0.831052485971116, -122.2369, -2.13343637243106),
(41835, '98040', 218, 56, 208102, 47.5634, 0.830137933443071, -122.2265, -2.13325485818885),
(41836, '98041', 218, 56, 206872, 47.7531, 0.833448823034104, -122.2158, -2.13306810795889),
(41837, '98042', 218, 56, 3501, 47.3629, 0.826638548292822, -122.1065, -2.13116046308646),
(41838, '98043', 218, 56, 208197, 47.792, 0.83412775611313, -122.3047, -2.13461970566391),
(41839, '98045', 218, 56, 23407, 47.4769, 0.828628223640096, -121.7586, -2.12508846261877),
(41840, '98046', 218, 56, 114, 47.8273, 0.834743857339084, -122.3039, -2.13460574302989),
(41841, '98047', 218, 56, 56766, 47.2659, 0.824945578918388, -122.2464, -2.13360217871),
(41842, '98050', 218, 56, 5220, 47.5358, 0.829656222569521, -121.9243, -2.12798047318932),
(41843, '98051', 218, 56, 208526, 47.3634, 0.826647274939082, -121.8953, -2.12747432770624),
(41844, '98052', 218, 56, 111080, 47.6831, 0.832227092557708, -122.1212, -2.1314170264865),
(41845, '98053', 218, 56, 111080, 47.667, 0.831946094548137, -122.0133, -2.1295338162236),
(41846, '98054', 218, 56, 208532, 47.3515, 0.826439580758095, -122.3232, -2.13494259157553),
(41847, '98055', 218, 56, 166408, 47.461, 0.828350716289029, -122.2099, -2.13296513353302),
(41848, '98056', 218, 56, 166408, 47.5089, 0.829186729000734, -122.1819, -2.13247644134246),
(41849, '98057', 218, 56, 166408, 47.4823, 0.828722471419704, -122.1963, -2.13272776875475),
(41850, '98058', 218, 56, 166408, 47.4457, 0.828083680913474, -122.1408, -2.13175911101989),
(41851, '98059', 218, 56, 166408, 47.4989, 0.829012196075535, -122.1505, -2.13192840795733),
(41852, '98061', 218, 56, 208597, 47.6505, 0.831658115221558, -122.5496, -2.13889401700204),
(41853, '98062', 218, 56, 208690, 47.469, 0.828490342629188, -122.3604, -2.13559185405727),
(41854, '98063', 218, 56, 207400, 47.3067, 0.825657673253202, -122.3196, -2.13487975972246),
(41855, '98064', 218, 56, 3501, 47.3938, 0.827177855031689, -122.2381, -2.13345731638208),
(41856, '98065', 218, 56, 208771, 47.527, 0.829502633595345, -121.821, -2.12617754807201),
(41857, '98068', 218, 56, 208773, 47.4137, 0.827525175552835, -121.4176, -2.11913688986947),
(41858, '98070', 218, 56, 209038, 47.4053, 0.827378567895668, -122.4713, -2.13752742419773),
(41859, '98071', 218, 56, 13306, 47.2503, 0.824673307555077, -122.1189, -2.1313768839137),
(41860, '98072', 218, 56, 153906, 47.7499, 0.83339297249804, -122.0987, -2.1310243274048),
(41861, '98073', 218, 56, 111080, 47.6739, 0.832066522266525, -122.1146, -2.13130183475587),
(41862, '98074', 218, 56, 208657, 47.6259, 0.831228764225567, -122.0462, -2.1301080295475),
(41863, '98075', 218, 56, 208657, 47.5859, 0.83053063252477, -122.0342, -2.12989859003726),
(41864, '98082', 218, 56, 206872, 47.8542, 0.83521335090787, -122.2209, -2.13315711975074),
(41865, '98083', 218, 56, 3558, 47.6844, 0.832249781837984, -122.1941, -2.1326893715112),
(41866, '98092', 218, 56, 13306, 47.2872, 0.825317334049063, -122.1315, -2.13159679539945),
(41867, '98093', 218, 56, 207400, 47.3011, 0.82555993481509, -122.3585, -2.13555869280148),
(41868, '98101', 218, 56, 208694, 47.6113, 0.830973946154776, -122.3334, -2.13512061515923),
(41869, '98102', 218, 56, 208694, 47.636, 0.831405042480019, -122.3214, -2.13491117564899),
(41870, '98103', 218, 56, 208694, 47.6715, 0.832024634364477, -122.3413, -2.13525849617014),
(41871, '98104', 218, 56, 208694, 47.6025, 0.830820357180601, -122.3264, -2.13499844211159),
(41872, '98105', 218, 56, 208694, 47.664, 0.831893734670577, -122.2923, -2.13440328483666),
(41873, '98106', 218, 56, 208694, 47.5362, 0.829663203886528, -122.3515, -2.13543651975384),
(41874, '98107', 218, 56, 208694, 47.6704, 0.832005435742705, -122.3822, -2.1359723358342),
(41875, '98108', 218, 56, 208694, 47.5363, 0.82966494921578, -122.3099, -2.13471046278501),
(41876, '98109', 218, 56, 208694, 47.6276, 0.831258434822851, -122.3464, -2.13534750796199),
(41877, '98110', 218, 56, 0, 47.6497, 0.831644152587542, -122.5329, -2.13860254701696),
(41878, '98111', 218, 56, 208694, 47.6122, 0.830989654118044, -122.3352, -2.13515203108577),
(41879, '98112', 218, 56, 208694, 47.63, 0.831300322724899, -122.2943, -2.1344381914217),
(41880, '98114', 218, 56, 208694, 47.5799, 0.83042591276965, -122.3125, -2.13475584134556),
(41881, '98115', 218, 56, 208694, 47.6855, 0.832268980459756, -122.2923, -2.13440328483666),
(41882, '98116', 218, 56, 208694, 47.5747, 0.830335155648546, -122.3954, -2.13620271929547),
(41883, '98117', 218, 56, 208694, 47.6878, 0.832309123032552, -122.3815, -2.13596011852944),
(41884, '98118', 218, 56, 208694, 47.542, 0.829764432983144, -122.2742, -2.13408738024205),
(41885, '98119', 218, 56, 208694, 47.6389, 0.831455657028327, -122.3672, -2.13571053644641),
(41886, '98121', 218, 56, 208694, 47.6159, 0.831054231300368, -122.3443, -2.1353108560477),
(41887, '98122', 218, 56, 208694, 47.6106, 0.830961728850012, -122.3015, -2.13456385512785),
(41888, '98124', 218, 56, 208694, 47.5776, 0.830385770196854, -122.334, -2.13513108713474),
(41889, '98125', 218, 56, 208694, 47.7161, 0.832803051210866, -122.3009, -2.13455338315233),
(41890, '98126', 218, 56, 208694, 47.5495, 0.829895332677044, -122.3732, -2.13581525620152),
(41891, '98129', 218, 56, 208694, 47.6169, 0.831071684592888, -122.3382, -2.13520439096333),
(41892, '98131', 218, 56, 208694, 47.4667, 0.828450200056392, -122.2925, -2.13440677549517),
(41893, '98132', 218, 56, 208694, 47.467, 0.828455436044148, -122.2922, -2.13440153950741),
(41894, '98133', 218, 56, 208694, 47.7429, 0.833270799450401, -122.3414, -2.13526024149939),
(41895, '98134', 218, 56, 208694, 47.5777, 0.830387515526106, -122.332, -2.1350961805497),
(41896, '98136', 218, 56, 208694, 47.5363, 0.82966494921578, -122.3885, -2.13608229157708),
(41897, '98138', 218, 56, 208694, 47.4634, 0.828392604191077, -122.2488, -2.13364406661204),
(41898, '98144', 218, 56, 208694, 47.5854, 0.83052190587851, -122.2976, -2.13449578728702),
(41899, '98145', 218, 56, 208694, 47.6593, 0.831811704195734, -122.3135, -2.13477329463808),
(41900, '98146', 218, 56, 208694, 47.5015, 0.829057574636086, -122.3556, -2.13550807825317),
(41901, '98148', 218, 56, 208694, 47.4332, 0.827865514756974, -122.3239, -2.13495480888029),
(41902, '98151', 218, 56, 208694, 47.4669, 0.828453690714897, -122.2926, -2.13440852082442),
(41903, '98154', 218, 56, 208694, 47.6065, 0.83089017035068, -122.3333, -2.13511886982998),
(41904, '98155', 218, 56, 208694, 47.7549, 0.83348023896064, -122.3005, -2.13454640183532),
(41905, '98158', 218, 56, 208694, 47.4441, 0.828055755645442, -122.3117, -2.13474187871155),
(41906, '98160', 218, 56, 208694, 47.7709, 0.833759491640959, -122.3836, -2.13599677044373),
(41907, '98161', 218, 56, 208694, 47.6074, 0.830905878313948, -122.3347, -2.13514330443951),
(41908, '98164', 218, 56, 208694, 47.6055, 0.830872717058161, -122.3324, -2.13510316186671),
(41909, '98166', 218, 56, 208694, 47.4554, 0.828252977850917, -122.3499, -2.13540859448581),
(41910, '98168', 218, 56, 208694, 47.4888, 0.828835917821083, -122.2991, -2.1345219672258),
(41911, '98170', 218, 56, 208694, 47.6059, 0.830879698375169, -122.3312, -2.13508221791569),
(41912, '98171', 218, 56, 208694, 47.6022, 0.830815121192845, -122.3266, -2.1350019327701),
(41913, '98174', 218, 56, 208694, 47.6048, 0.830860499753397, -122.3345, -2.135139813781),
(41914, '98177', 218, 56, 208694, 47.7466, 0.833335376632725, -122.3695, -2.1357506790192),
(41915, '98178', 218, 56, 208694, 47.4936, 0.828919693625179, -122.2503, -2.13367024655082),
(41916, '98181', 218, 56, 208694, 47.6112, 0.830972200825524, -122.3381, -2.13520264563407),
(41917, '98184', 218, 56, 208694, 47.6066, 0.830891915679932, -122.3305, -2.13507000061092),
(41918, '98185', 218, 56, 208694, 47.6657, 0.831923405267861, -122.2927, -2.13441026615367),
(41919, '98188', 218, 56, 208694, 47.4434, 0.828043538340678, -122.27, -2.13401407641347),
(41920, '98190', 218, 56, 208694, 47.5034, 0.829090735891874, -122.2963, -2.13447309800674),
(41921, '98191', 218, 56, 208694, 47.6132, 0.831007107410564, -122.3338, -2.13512759647624),
(41922, '98195', 218, 56, 208694, 47.6534, 0.831708729769866, -122.2987, -2.13451498590879),
(41923, '98198', 218, 56, 208694, 47.4044, 0.8273628599324, -122.3123, -2.13475235068706),
(41924, '98199', 218, 56, 208694, 47.6472, 0.831600519356242, -122.4, -2.13628300444106),
(41925, '98201', 218, 56, 20957, 47.9877, 0.837543365459283, -122.2004, -2.13279932725408),
(41926, '98203', 218, 56, 20957, 47.9452, 0.836801600527185, -122.2271, -2.13326533016436),
(41927, '98204', 218, 56, 20957, 47.8997, 0.836007475717528, -122.2542, -2.13373831439165),
(41928, '98205', 218, 56, 20957, 47.9876, 0.837541620130031, -122.1135, -2.1312826361341),
(41929, '98206', 218, 56, 20957, 48.0038, 0.837824363468854, -122.2561, -2.13377147564744),
(41930, '98207', 218, 56, 20957, 47.9629, 0.837110523804788, -122.1983, -2.13276267533979),
(41931, '98208', 218, 56, 20957, 47.8937, 0.835902755962408, -122.196, -2.13272253276699),
(41932, '98220', 218, 56, 726, 48.6881, 0.849767651540251, -122.1962, -2.1327260234255),
(41933, '98221', 218, 56, 206689, 48.4878, 0.846271757048507, -122.623, -2.14017508867301),
(41934, '98222', 218, 56, 0, 48.6118, 0.84843596532098, -122.9202, -2.14536220720993),
(41935, '98223', 218, 56, 15026, 48.1909, 0.841089874499335, -122.0927, -2.13091960764968),
(41936, '98224', 218, 56, 126824, 47.7653, 0.833661753202848, -121.4797, -2.12022073933496),
(41937, '98225', 218, 56, 79738, 48.7469, 0.850793905140424, -122.4959, -2.13795677519372),
(41938, '98226', 218, 56, 79738, 48.7646, 0.851102828418027, -122.4433, -2.13703873200717),
(41939, '98227', 218, 56, 79738, 48.8004, 0.851727656290241, -122.4073, -2.13641041347646),
(41940, '98228', 218, 56, 79738, 48.744, 0.850743290592116, -122.4674, -2.1374593563569),
(41941, '98229', 218, 56, 79738, 48.7637, 0.851087120454759, -122.4436, -2.13704396799493),
(41942, '98230', 218, 56, 19318, 48.9582, 0.854481785849888, -122.7401, -2.14221886922709),
(41943, '98231', 218, 56, 19318, 48.9891, 0.855021092588754, -122.7586, -2.14254175513871),
(41944, '98232', 218, 56, 34937, 48.5628, 0.847580753987502, -122.4249, -2.13671759142481),
(41945, '98233', 218, 56, 1239, 48.4882, 0.846278738365514, -122.3349, -2.13514679509801),
(41946, '98235', 218, 56, 180759, 48.4606, 0.845797027491964, -122.2357, -2.13341542848003),
(41947, '98236', 218, 56, 1630, 47.9588, 0.837038965305456, -122.4021, -2.13631965635535),
(41948, '98237', 218, 56, 8, 48.5205, 0.846842479713909, -121.7538, -2.12500468681467),
(41949, '98238', 218, 56, 8215, 48.3406, 0.843702632389571, -122.3454, -2.13533005466947),
(41950, '98239', 218, 56, 207118, 48.1871, 0.84102355198776, -122.6121, -2.13998484778454),
(41951, '98240', 218, 56, 35479, 48.9403, 0.854169371913781, -122.629, -2.14027980842813),
(41952, '98241', 218, 56, 59207, 48.2567, 0.842238301147148, -121.5968, -2.12226451988904),
(41953, '98243', 218, 56, 0, 48.6215, 0.848605262258423, -123.0064, -2.14686668102515),
(41954, '98244', 218, 56, 122497, 48.8332, 0.852300124284895, -122.1454, -2.13183939616548),
(41955, '98245', 218, 56, 207286, 48.7056, 0.85007308415935, -122.9155, -2.14528017673509),
(41956, '98247', 218, 56, 109132, 48.9072, 0.853591667931371, -122.3319, -2.13509443522045),
(41957, '98248', 218, 56, 8879, 48.8617, 0.852797543121713, -122.607, -2.13989583599269),
(41958, '98249', 218, 56, 40997, 48.0225, 0.838150740038977, -122.5457, -2.13882594916122),
(41959, '98250', 218, 56, 207468, 48.5409, 0.847198526881315, -123.0658, -2.14790340660084),
(41960, '98251', 218, 56, 207518, 47.8319, 0.834824142484676, -121.6268, -2.12278811866464),
(41961, '98252', 218, 56, 65139, 48.0531, 0.838684810790087, -121.6844, -2.12379342831379),
(41962, '98253', 218, 56, 13849, 48.0873, 0.839281713394269, -122.579, -2.13940714380213),
(41963, '98255', 218, 56, 2950, 48.5236, 0.846896584920721, -121.9899, -2.12912540917863),
(41964, '98256', 218, 56, 9651, 47.8197, 0.834611212315932, -121.5484, -2.12141978053108),
(41965, '98257', 218, 56, 207832, 48.3908, 0.844578787674072, -122.514, -2.13827267978833),
(41966, '98258', 218, 56, 207856, 48.0268, 0.838225789196813, -122.0661, -2.13045535006865),
(41967, '98259', 218, 56, 0, 48.1639, 0.840618635601297, -122.3014, -2.13456210979859),
(41968, '98260', 218, 56, 9983, 48.0333, 0.838339235598192, -122.4485, -2.13712948912828),
(41969, '98261', 218, 56, 0, 48.4464, 0.845549190738181, -122.8421, -2.14399910506413),
(41970, '98262', 218, 56, 207971, 48.7081, 0.85011671739065, -122.6761, -2.14110185850582),
(41971, '98263', 218, 56, 60722, 48.5282, 0.846976870066312, -122.0657, -2.13044836875164),
(41972, '98264', 218, 56, 207974, 48.9407, 0.854176353230789, -122.4579, -2.13729355007796),
(41973, '98266', 218, 56, 208013, 48.9303, 0.853994838988582, -122.1492, -2.13190571867706),
(41974, '98267', 218, 56, 208026, 48.5355, 0.847104279101708, -121.4168, -2.11912292723545),
(41975, '98270', 218, 56, 10343, 48.0595, 0.838796511862215, -122.1531, -2.13197378651789),
(41976, '98271', 218, 56, 10343, 48.0964, 0.839440538356201, -122.2384, -2.13346255236984),
(41977, '98272', 218, 56, 10560, 47.8559, 0.835243021505154, -121.9359, -2.12818293138255),
(41978, '98273', 218, 56, 4411, 48.4067, 0.844856295025139, -122.3219, -2.13491990229525),
(41979, '98274', 218, 56, 4411, 48.4216, 0.845116349083686, -122.3145, -2.1347907479306),
(41980, '98275', 218, 56, 208201, 47.9085, 0.836161064691703, -122.3066, -2.1346528669197),
(41981, '98276', 218, 56, 208253, 48.928, 0.853954696415785, -122.3204, -2.13489372235647),
(41982, '98277', 218, 56, 17342, 48.3053, 0.843086531163617, -122.6424, -2.14051368254789),
(41983, '98278', 218, 56, 17342, 48.282, 0.842679869447902, -122.6284, -2.14026933645261),
(41984, '98279', 218, 56, 17411, 48.6604, 0.849284195337449, -122.827, -2.14373556034707),
(41985, '98280', 218, 56, 208340, 48.6083, 0.84837487879716, -122.8805, -2.14466931149689),
(41986, '98281', 218, 56, 208460, 48.9902, 0.855040291210526, -123.0548, -2.14771142038312),
(41987, '98282', 218, 56, 0, 48.1761, 0.84083156577004, -122.5208, -2.13839136217747),
(41988, '98283', 218, 56, 11639, 48.4726, 0.846006467002203, -121.5782, -2.12193988864817),
(41989, '98284', 218, 56, 0, 48.5232, 0.846889603603713, -122.1813, -2.13246596936695),
(41990, '98286', 218, 56, 208714, 48.5847, 0.847962981093689, -122.9278, -2.14549485223309),
(41991, '98287', 218, 56, 208736, 48.1927, 0.841121290425871, -122.2522, -2.13370340780661),
(41992, '98288', 218, 56, 208759, 47.7094, 0.832686114150983, -121.3562, -2.11806525770874),
(41993, '98290', 218, 56, 208769, 47.9384, 0.83668291813805, -122.0195, -2.12964202663722),
(41994, '98291', 218, 56, 208769, 47.9283, 0.836506639883598, -122.0992, -2.13103305405106),
(41995, '98292', 218, 56, 117893, 48.2144, 0.841500026873554, -122.3085, -2.13468602817548),
(41996, '98293', 218, 56, 208825, 47.8688, 0.835468168978662, -121.7464, -2.12487553245002),
(41997, '98294', 218, 56, 138336, 47.8668, 0.835433262393622, -121.7735, -2.12534851667731),
(41998, '98295', 218, 56, 208852, 48.9657, 0.854612685543787, -122.1997, -2.13278710994932),
(41999, '98296', 218, 56, 208769, 47.8226, 0.83466182686424, -122.1166, -2.13133674134091),
(42000, '98297', 218, 56, 12596, 48.6876, 0.849758924893991, -123.0354, -2.14737282650823),
(42001, '98303', 218, 56, 0, 47.1635, 0.823158361764346, -122.6941, -2.14141601777117),
(42002, '98304', 218, 56, 728, 46.7398, 0.815763401723646, -121.978, -2.12891771499764),
(42003, '98305', 218, 56, 7346, 48.0209, 0.838122814770945, -124.3825, -2.17088415686185),
(42004, '98310', 218, 56, 45032, 47.6071, 0.830900642326193, -122.6322, -2.14033565896419),
(42005, '98311', 218, 56, 45032, 47.6273, 0.831253198835095, -122.6369, -2.14041768943903),
(42006, '98312', 218, 56, 45032, 47.5743, 0.830328174331538, -122.7429, -2.14226773844615),
(42007, '98314', 218, 56, 45032, 47.5592, 0.830064629614487, -122.6478, -2.1406079303275),
(42008, '98315', 218, 56, 31129, 47.6647, 0.831905951975341, -122.7621, -2.14260284166253),
(42009, '98320', 218, 56, 206894, 47.6918, 0.832378936202632, -122.921, -2.14537616984395),
(42010, '98321', 218, 56, 118947, 47.1543, 0.822997791473162, -122.0751, -2.13061242970133),
(42011, '98322', 218, 56, 194662, 47.4134, 0.82751993956508, -122.6302, -2.14030075237915),
(42012, '98323', 218, 56, 206959, 47.0701, 0.821528224242983, -122.0483, -2.1301446814618),
(42013, '98324', 218, 56, 206964, 48.1051, 0.839592382001124, -123.1757, -2.14982152344878),
(42014, '98325', 218, 56, 207033, 47.98, 0.837408975106879, -122.7794, -2.14290478362313),
(42015, '98326', 218, 56, 207045, 48.1736, 0.84078793253874, -124.2819, -2.16912835563434),
(42016, '98327', 218, 56, 13687, 47.0947, 0.821957575238974, -122.6415, -2.14049797458463),
(42017, '98328', 218, 56, 15876, 46.9011, 0.818578617807113, -122.3074, -2.13466682955371),
(42018, '98329', 218, 56, 207496, 47.373, 0.826814826547274, -122.713, -2.1417458849998),
(42019, '98330', 218, 56, 207314, 46.764, 0.816185771402628, -122.1337, -2.131635192643),
(42020, '98331', 218, 56, 148898, 47.9538, 0.836951698842857, -124.3877, -2.17097491398295),
(42021, '98332', 218, 56, 207496, 47.3592, 0.826573971110499, -122.5947, -2.13968116049469),
(42022, '98333', 218, 56, 59963, 47.2482, 0.824636655640785, -122.6246, -2.14020301394104),
(42023, '98335', 218, 56, 207496, 47.337, 0.826186508016556, -122.6361, -2.14040372680502),
(42024, '98336', 218, 56, 207510, 46.5283, 0.812072030355678, -122.1198, -2.13139259187697),
(42025, '98337', 218, 56, 45032, 47.569, 0.830235671881183, -122.6361, -2.14040372680502),
(42026, '98338', 218, 56, 2802, 47.0351, 0.820917359004785, -122.2948, -2.13444691806796),
(42027, '98339', 218, 56, 208474, 48.0305, 0.838290366379137, -122.7633, -2.14262378561355),
(42028, '98340', 218, 56, 207587, 47.909, 0.836169791337963, -122.5735, -2.13931115069327),
(42029, '98342', 218, 56, 16542, 47.76, 0.833569250752492, -122.5312, -2.13857287641968),
(42030, '98343', 218, 56, 41554, 48.1366, 0.840142160715502, -123.733, -2.15954824337014),
(42031, '98344', 218, 56, 207767, 46.9863, 0.820065638329812, -122.2279, -2.13327929279838),
(42032, '98345', 218, 56, 145529, 47.7026, 0.832567431761847, -122.6249, -2.14020824992879),
(42033, '98346', 218, 56, 3542, 47.8069, 0.834387810171677, -122.5255, -2.13847339265231),
(42034, '98348', 218, 56, 201085, 46.8224, 0.817205043685793, -122.2794, -2.13417813736315),
(42035, '98349', 218, 56, 207857, 47.2597, 0.824837368504764, -122.7744, -2.14281751716053),
(42036, '98350', 218, 56, 207835, 47.9088, 0.836166300679459, -124.6355, -2.17529983986939),
(42037, '98351', 218, 56, 207948, 47.2074, 0.823924561305971, -122.7633, -2.14262378561355),
(42038, '98352', 218, 56, 18216, 47.1616, 0.823125200508558, -122.2421, -2.13352712955216),
(42039, '98353', 218, 56, 585, 47.5554, 0.829998307102911, -122.5462, -2.13883467580748),
(42040, '98354', 218, 56, 4232, 47.2486, 0.824643636957793, -122.315, -2.13479947457686),
(42041, '98355', 218, 56, 10518, 46.7156, 0.815341032044663, -122.1839, -2.1325113479275),
(42042, '98356', 218, 56, 10614, 46.5603, 0.812630535716316, -122.2841, -2.134260167838),
(42043, '98357', 218, 56, 208220, 48.3678, 0.844177361946113, -124.6235, -2.17509040035915),
(42044, '98358', 218, 56, 208255, 48.0678, 0.83894137419013, -122.6961, -2.14145092435621),
(42045, '98359', 218, 56, 201345, 47.4271, 0.827759049672603, -122.5751, -2.1393390759613),
(42046, '98360', 218, 56, 208351, 47.0873, 0.821828420874326, -122.1841, -2.132514838586),
(42047, '98361', 218, 56, 117212, 46.6393, 0.814009345825391, -121.667, -2.12348974102394),
(42048, '98362', 218, 56, 208468, 48.1062, 0.839611580622896, -123.4235, -2.15414644933522),
(42049, '98363', 218, 56, 208468, 48.1906, 0.841084638511579, -123.4598, -2.1547800038537),
(42050, '98364', 218, 56, 208473, 47.8394, 0.834955042178575, -122.5946, -2.13967941516544),
(42051, '98365', 218, 56, 208476, 47.916, 0.836291964385603, -122.6865, -2.14128337274802),
(42052, '98366', 218, 56, 208479, 47.5014, 0.829055829306834, -122.6214, -2.14014716340497),
(42053, '98367', 218, 56, 208479, 47.5295, 0.829546266826645, -122.6408, -2.14048575727986),
(42054, '98368', 218, 56, 208481, 48.0334, 0.838340980927444, -122.824, -2.14368320046952),
(42055, '98370', 218, 56, 208488, 47.7423, 0.833260327474889, -122.6331, -2.14035136692746),
(42056, '98371', 218, 56, 208506, 47.1913, 0.8236435632964, -122.3042, -2.13461097901765),
(42057, '98372', 218, 56, 208506, 47.2064, 0.823907108013451, -122.2708, -2.13402803904748),
(42058, '98373', 218, 56, 208506, 47.1332, 0.822629527000991, -122.3213, -2.13490943031974),
(42059, '98374', 218, 56, 208506, 47.1424, 0.822790097292175, -122.27, -2.13401407641347),
(42060, '98375', 218, 56, 208506, 47.0998, 0.822046587030825, -122.3255, -2.13498273414832),
(42061, '98376', 218, 56, 208511, 47.8153, 0.834534417828845, -122.8416, -2.14399037841787),
(42062, '98377', 218, 56, 157284, 46.5222, 0.811965565271306, -121.9044, -2.12763315266818),
(42063, '98378', 218, 56, 208544, 47.5449, 0.829815047531452, -122.6171, -2.14007211424714),
(42064, '98380', 218, 56, 208687, 47.636, 0.831405042480019, -122.8446, -2.14404273829543),
(42065, '98381', 218, 56, 208698, 48.2642, 0.842369200841047, -124.3088, -2.16959784920313),
(42066, '98382', 218, 56, 208705, 48.08, 0.839154304358874, -123.1074, -2.14862946356967),
(42067, '98383', 218, 56, 31129, 47.6651, 0.831912933292349, -122.7077, -2.14165338254945),
(42068, '98384', 218, 56, 208791, 47.5212, 0.829401404498729, -122.538, -2.13869155880881),
(42069, '98385', 218, 56, 198927, 47.1361, 0.822680141549299, -122.0981, -2.13101385542929),
(42070, '98386', 218, 56, 157742, 47.5115, 0.829232107561286, -122.4996, -2.13802135237605),
(42071, '98387', 218, 56, 208804, 47.0753, 0.821618981364087, -122.3963, -2.13621842725874),
(42072, '98388', 218, 56, 208830, 47.1693, 0.823259590860961, -122.5886, -2.13957469541032),
(42073, '98390', 218, 56, 18216, 47.1935, 0.823681960539944, -122.1875, -2.13257417978057),
(42074, '98392', 218, 56, 208889, 47.7353, 0.833138154427249, -122.559, -2.13905807795173),
(42075, '98393', 218, 56, 208970, 47.6232, 0.831181640335763, -122.65, -2.14064632757105),
(42076, '98394', 218, 56, 6529, 47.3262, 0.82599801245734, -122.7688, -2.14271977872241),
(42077, '98395', 218, 56, 201758, 47.3644, 0.826664728231602, -122.6976, -2.14147710429499),
(42078, '98396', 218, 56, 209189, 47.1072, 0.822175741395473, -122.0407, -2.13001203643864),
(42079, '98397', 218, 56, 207949, 46.7499, 0.815939679978097, -121.8113, -2.12600825113457),
(42080, '98398', 218, 56, 0, 46.7804, 0.816472005399955, -121.743, -2.12481619125546),
(42081, '98401', 218, 56, 18269, 47.2534, 0.824727412761889, -122.443, -2.13703349601942),
(42082, '98402', 218, 56, 18269, 47.2485, 0.824641891628541, -122.4393, -2.13696891883709),
(42083, '98403', 218, 56, 18269, 47.265, 0.82492987095512, -122.4574, -2.1372848234317),
(42084, '98404', 218, 56, 18269, 47.2113, 0.823992629146799, -122.4106, -2.13646800934177),
(42085, '98405', 218, 56, 18269, 47.2485, 0.824641891628541, -122.4675, -2.13746110168616),
(42086, '98406', 218, 56, 18269, 47.2632, 0.824898455028584, -122.5093, -2.13819064931349),
(42087, '98407', 218, 56, 18269, 47.2832, 0.825247520878983, -122.5039, -2.13809640153388),
(42088, '98408', 218, 56, 18269, 47.2075, 0.823926306635223, -122.4492, -2.13714170643304),
(42089, '98409', 218, 56, 18269, 47.208, 0.823935033281483, -122.4777, -2.13763912526986),
(42090, '98411', 218, 56, 18269, 47.2204, 0.82415145410873, -122.4731, -2.13755884012427),
(42091, '98412', 218, 56, 18269, 47.1734, 0.823331149360293, -122.4428, -2.13703000536091),
(42092, '98413', 218, 56, 18269, 47.2078, 0.823931542622979, -122.4807, -2.13769148514742),
(42093, '98415', 218, 56, 18269, 47.2512, 0.824689015518345, -122.452, -2.1371905756521),
(42094, '98416', 218, 56, 18269, 47.2652, 0.824933361613624, -122.482, -2.13771417442769),
(42095, '98418', 218, 56, 18269, 47.2229, 0.82419508734003, -122.4411, -2.13700033476363),
(42096, '98421', 218, 56, 18269, 47.2513, 0.824690760847597, -122.4134, -2.13651687856083),
(42097, '98422', 218, 56, 18269, 47.2926, 0.82541158182867, -122.3942, -2.13618177534444),
(42098, '98424', 218, 56, 18269, 47.2441, 0.824565097141453, -122.3546, -2.13549062496065),
(42099, '98430', 218, 56, 0, 47.2555, 0.82476406467618, -122.4414, -2.13700557075139),
(42100, '98431', 218, 56, 18269, 47.0578, 0.821313548744988, -122.551, -2.13891845161157),
(42101, '98433', 218, 56, 18269, 47.1306, 0.822584148440439, -122.5369, -2.13867236018704),
(42102, '98438', 218, 56, 0, 47.1263, 0.822509099282604, -122.5554, -2.13899524609866),
(42103, '98439', 218, 56, 3637, 47.1271, 0.82252306191662, -122.5205, -2.13838612618971),
(42104, '98442', 218, 56, 18269, 47.1462, 0.822856419803751, -122.436, -2.13691132297178),
(42105, '98443', 218, 56, 18269, 47.2046, 0.823875692086915, -122.3733, -2.13581700153078),
(42106, '98444', 218, 56, 18269, 47.1534, 0.822982083509894, -122.4478, -2.13711727182351),
(42107, '98445', 218, 56, 18269, 47.1383, 0.822718538792843, -122.4098, -2.13645404670776),
(42108, '98446', 218, 56, 18269, 47.1478, 0.822884345071782, -122.3777, -2.13589379601786),
(42109, '98447', 218, 56, 18269, 47.1466, 0.822863401120759, -122.4443, -2.13705618529969),
(42110, '98450', 218, 56, 18269, 47.2212, 0.824165416742746, -122.4738, -2.13757105742903),
(42111, '98455', 218, 56, 18269, 47.221, 0.824161926084242, -122.4732, -2.13756058545352),
(42112, '98460', 218, 56, 18269, 47.2207, 0.824156690096486, -122.4725, -2.13754836814876),
(42113, '98464', 218, 56, 18269, 47.2251, 0.824233484583574, -122.5379, -2.13868981347956),
(42114, '98465', 218, 56, 18269, 47.2485, 0.824641891628541, -122.5303, -2.13855716845641),
(42115, '98466', 218, 56, 18269, 47.2266, 0.824259664522354, -122.5355, -2.13864792557751),
(42116, '98467', 218, 56, 43436, 47.204, 0.823865220111403, -122.5351, -2.1386409442605),
(42117, '98471', 218, 56, 18269, 47.2547, 0.824750102042164, -122.4733, -2.13756233078277),
(42118, '98477', 218, 56, 18269, 47.2493, 0.824655854262557, -122.4437, -2.13704571332418),
(42119, '98481', 218, 56, 18269, 47.221, 0.824161926084242, -122.4729, -2.13755534946576);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(42120, '98492', 218, 56, 3637, 47.128, 0.822538769879888, -122.5606, -2.13908600321976),
(42121, '98493', 218, 56, 18269, 47.0511, 0.821196611685104, -122.5499, -2.1388992529898),
(42122, '98497', 218, 56, 3637, 47.1807, 0.823458558395689, -122.5482, -2.13886958239251),
(42123, '98498', 218, 56, 3637, 47.1636, 0.823160107093598, -122.5578, -2.13903713400071),
(42124, '98499', 218, 56, 3637, 47.1631, 0.823151380447338, -122.5109, -2.13821857458152),
(42125, '98501', 218, 56, 37528, 47.0112, 0.820500225313558, -122.8723, -2.14452619449823),
(42126, '98502', 218, 56, 37528, 47.0358, 0.820929576309549, -122.973, -2.14628374105499),
(42127, '98503', 218, 56, 9912, 47.0238, 0.82072013679931, -122.7767, -2.14285765973332),
(42128, '98504', 218, 56, 37528, 47.0234, 0.820713155482302, -122.8694, -2.14447557994992),
(42129, '98505', 218, 56, 37528, 47.0707, 0.821538696218495, -122.9811, -2.1464251127244),
(42130, '98506', 218, 56, 37528, 47.0777, 0.821660869266134, -122.8413, -2.14398514243011),
(42131, '98507', 218, 56, 37528, 47.0313, 0.820851036493209, -122.8707, -2.1444982692302),
(42132, '98508', 218, 56, 37528, 47.0368, 0.820947029602069, -122.9394, -2.14569731042632),
(42133, '98509', 218, 56, 9912, 47.0366, 0.820943538943565, -122.809, -2.14342140108172),
(42134, '98511', 218, 56, 208990, 47.0382, 0.820971464211597, -122.899, -2.14499219740851),
(42135, '98512', 218, 56, 37528, 46.9493, 0.819419866506574, -123.0143, -2.14700456203606),
(42136, '98513', 218, 56, 37528, 47.0067, 0.820421685497219, -122.748, -2.142356750238),
(42137, '98516', 218, 56, 37528, 47.0902, 0.821879035422634, -122.7823, -2.14295539817143),
(42138, '98520', 218, 56, 7017, 46.9759, 0.819884124087604, -123.7859, -2.16047152254445),
(42139, '98522', 218, 56, 193242, 46.5713, 0.812822521934035, -123.2962, -2.15192464519743),
(42140, '98524', 218, 56, 206671, 47.3674, 0.826717088109162, -122.8624, -2.14435340690228),
(42141, '98526', 218, 56, 206683, 47.431, 0.82782711751343, -124.0206, -2.16456781029888),
(42142, '98527', 218, 56, 206781, 46.6397, 0.814016327142399, -123.9392, -2.16314711228776),
(42143, '98528', 218, 56, 206803, 47.4425, 0.82802783037741, -122.866, -2.14441623875535),
(42144, '98530', 218, 56, 53724, 46.8003, 0.816819325921102, -122.8669, -2.14443194671862),
(42145, '98531', 218, 56, 26746, 46.722, 0.815452733116791, -122.9581, -2.14602368699644),
(42146, '98532', 218, 56, 207015, 46.6289, 0.813827831583184, -122.9641, -2.14612840675156),
(42147, '98533', 218, 56, 207043, 46.5809, 0.812990073542227, -122.5407, -2.13873868269862),
(42148, '98535', 218, 56, 207100, 47.1168, 0.822343293003664, -124.1558, -2.16692749544758),
(42149, '98536', 218, 56, 207101, 47.14, 0.822748209390127, -124.1008, -2.16596756435898),
(42150, '98537', 218, 56, 207108, 46.9538, 0.819498406322913, -123.7766, -2.16030920692401),
(42151, '98538', 218, 56, 1933, 46.5208, 0.811941130661778, -123.1231, -2.14890348026223),
(42152, '98539', 218, 56, 11, 46.6378, 0.813983165886611, -123.2785, -2.15161572191983),
(42153, '98540', 218, 56, 207269, 46.9611, 0.819625815358309, -122.8251, -2.14370239909129),
(42154, '98541', 218, 56, 101709, 47.0091, 0.820463573399266, -123.4077, -2.15387068731341),
(42155, '98542', 218, 56, 8784, 46.5305, 0.812110427599222, -122.7461, -2.14232358898221),
(42156, '98544', 218, 56, 207477, 46.7415, 0.81579307232093, -123.0265, -2.1472174922048),
(42157, '98546', 218, 56, 207546, 47.332, 0.826099241553956, -122.9065, -2.14512309710241),
(42158, '98547', 218, 56, 207551, 46.7454, 0.815861140161757, -124.0845, -2.1656830756909),
(42159, '98548', 218, 56, 207681, 47.4079, 0.82742394645622, -123.1551, -2.14946198562287),
(42160, '98550', 218, 56, 207687, 46.9831, 0.820009787793748, -123.892, -2.16232331688081),
(42161, '98552', 218, 56, 207697, 47.1972, 0.823746537722268, -123.9418, -2.16319249084831),
(42162, '98554', 218, 56, 207906, 46.5592, 0.812611337094544, -123.5478, -2.15631589359545),
(42163, '98555', 218, 56, 207923, 47.5521, 0.829940711237596, -123.1871, -2.15002049098351),
(42164, '98556', 218, 56, 182842, 46.9016, 0.818587344453373, -123.0205, -2.14711277244968),
(42165, '98557', 218, 56, 164349, 47.054, 0.821247226233412, -123.2698, -2.15146387827491),
(42166, '98558', 218, 56, 208080, 46.937, 0.819205191008578, -122.5395, -2.13871773874759),
(42167, '98559', 218, 56, 3960, 46.9587, 0.819583927456261, -123.3334, -2.15257390767917),
(42168, '98560', 218, 56, 37091, 47.2236, 0.824207304644794, -123.4696, -2.15495104612039),
(42169, '98561', 218, 56, 23043, 46.6211, 0.813691695901528, -123.6461, -2.15803155225016),
(42170, '98562', 218, 56, 208154, 47.2381, 0.824460377386333, -124.0977, -2.16591345915217),
(42171, '98563', 218, 56, 183418, 46.9955, 0.820226208620995, -123.6012, -2.15724789941602),
(42172, '98564', 218, 56, 208184, 46.5123, 0.811792777675359, -122.5046, -2.13810861883865),
(42173, '98565', 218, 56, 208213, 46.5752, 0.812890589774863, -122.914, -2.14525399679631),
(42174, '98566', 218, 56, 208222, 47.4129, 0.827511212918819, -123.8792, -2.16209991473656),
(42175, '98568', 218, 56, 4721, 46.8448, 0.81759599743824, -123.2455, -2.15103976326667),
(42176, '98569', 218, 56, 208303, 46.9701, 0.819782894990989, -124.1514, -2.16685070096049),
(42177, '98570', 218, 56, 96794, 46.5814, 0.812998800188487, -122.6838, -2.14123624885822),
(42178, '98571', 218, 56, 183936, 47.2123, 0.824010082439319, -124.2016, -2.16772685624499),
(42179, '98572', 218, 56, 208407, 46.566, 0.81273001948368, -123.3045, -2.15206950752535),
(42180, '98575', 218, 56, 208513, 47.4121, 0.827497250284804, -123.7404, -2.15967739773479),
(42181, '98576', 218, 56, 201451, 46.8818, 0.818241769261478, -122.6796, -2.14116294502964),
(42182, '98577', 218, 56, 24225, 46.6818, 0.814751110757489, -123.7364, -2.15960758456471),
(42183, '98579', 218, 56, 28433, 46.8245, 0.817241695600085, -123.053, -2.14768000445658),
(42184, '98580', 218, 56, 11712, 46.9601, 0.819608362065789, -122.4815, -2.13770544778143),
(42185, '98581', 218, 56, 208638, 46.3776, 0.809441819172922, -123.0445, -2.14753165147016),
(42186, '98582', 218, 56, 208653, 46.5247, 0.812009198502606, -122.6284, -2.14026933645261),
(42187, '98583', 218, 56, 208667, 47.0016, 0.820332673705367, -123.4823, -2.15517270293539),
(42188, '98584', 218, 56, 38184, 47.2047, 0.823877437416167, -123.0978, -2.14846191196148),
(42189, '98585', 218, 56, 24872, 46.5344, 0.812178495440049, -122.577, -2.13937223721709),
(42190, '98586', 218, 56, 12027, 46.661, 0.814388082273074, -123.8092, -2.16087818426016),
(42191, '98587', 218, 56, 208910, 47.3882, 0.827080116593577, -124.2089, -2.16785426528038),
(42192, '98588', 218, 56, 208911, 47.4031, 0.827340170652124, -123.0385, -2.14742693171504),
(42193, '98589', 218, 56, 208921, 46.858, 0.817826380899503, -122.8472, -2.14408811685598),
(42194, '98590', 218, 56, 208952, 46.7171, 0.815367211983443, -124.0046, -2.16428855761856),
(42195, '98591', 218, 56, 12339, 46.4403, 0.810536140613923, -122.8166, -2.14355404610487),
(42196, '98592', 218, 56, 455, 47.3454, 0.826333115673723, -123.0758, -2.14807793952604),
(42197, '98593', 218, 56, 209022, 46.4058, 0.809934002021985, -122.9741, -2.14630293967676),
(42198, '98595', 218, 56, 25961, 46.8825, 0.818253986566242, -124.1071, -2.16607752010185),
(42199, '98596', 218, 56, 209204, 46.4999, 0.811576356848111, -122.9225, -2.14540234978273),
(42200, '98597', 218, 56, 209238, 46.8974, 0.818514040624789, -122.5625, -2.13911916447555),
(42201, '98599', 218, 56, 37528, 46.9954, 0.820224463291743, -122.8762, -2.14459426233906),
(42202, '98601', 218, 56, 7087, 45.8617, 0.800437665561883, -122.5034, -2.13808767488762),
(42203, '98602', 218, 56, 7132, 45.8367, 0.800001333248885, -121.285, -2.11682258328132),
(42204, '98603', 218, 56, 15024, 45.9963, 0.802786878735068, -122.4519, -2.13718883032284),
(42205, '98604', 218, 56, 122196, 45.7942, 0.799259568316787, -122.5216, -2.13840532481148),
(42206, '98605', 218, 56, 7485, 45.7399, 0.798311854532954, -121.4768, -2.12017012478665),
(42207, '98606', 218, 56, 206912, 45.7331, 0.798193172143819, -122.4741, -2.13757629341679),
(42208, '98607', 218, 56, 194675, 45.6111, 0.796063870456386, -122.4123, -2.13649767993905),
(42209, '98609', 218, 56, 19815, 46.0713, 0.804095875674064, -122.8631, -2.14436562420705),
(42210, '98610', 218, 56, 572, 45.7469, 0.798434027580594, -121.8429, -2.1265597751782),
(42211, '98611', 218, 56, 77985, 46.286, 0.807843097578095, -122.9015, -2.14503583063981),
(42212, '98612', 218, 56, 206985, 46.2077, 0.806476504773784, -123.3636, -2.15310099711328),
(42213, '98613', 218, 56, 1459, 45.7535, 0.798549219311226, -120.9351, -2.11071567622859),
(42214, '98614', 218, 56, 196213, 46.2725, 0.807607478129076, -123.9441, -2.1632326334211),
(42215, '98616', 218, 56, 193470, 46.0534, 0.803783461737957, -122.2964, -2.13447484333599),
(42216, '98617', 218, 56, 207161, 45.622, 0.796254111344853, -121.181, -2.11500744085925),
(42217, '98619', 218, 56, 2749, 46.0108, 0.803039951476607, -121.2868, -2.11685399920786),
(42218, '98620', 218, 56, 207519, 45.8402, 0.800062419772705, -120.8242, -2.10878010608813),
(42219, '98621', 218, 56, 207555, 46.3552, 0.809050865420476, -123.5845, -2.15695642943093),
(42220, '98622', 218, 56, 193248, 45.8232, 0.799765713799866, -122.4868, -2.13779795023179),
(42221, '98623', 218, 56, 207702, 45.809, 0.799517877046082, -121.4679, -2.12001479048322),
(42222, '98624', 218, 56, 207708, 46.3134, 0.808321317793142, -124.0373, -2.16485928028396),
(42223, '98625', 218, 56, 207762, 46.0086, 0.803001554233063, -122.8073, -2.14339173048443),
(42224, '98626', 218, 56, 9828, 46.147, 0.805417089917823, -122.8804, -2.14466756616764),
(42225, '98628', 218, 56, 207812, 45.8236, 0.799772695116874, -121.1255, -2.11403878312439),
(42226, '98629', 218, 56, 36765, 45.8633, 0.800465590829915, -122.6672, -2.14094652420239),
(42227, '98631', 218, 56, 49041, 46.3488, 0.808939164348348, -124.0508, -2.16509489973298),
(42228, '98632', 218, 56, 3859, 46.1581, 0.805610821464795, -122.9845, -2.14648445391897),
(42229, '98635', 218, 56, 3912, 45.7288, 0.798118122985983, -121.2589, -2.11636705234655),
(42230, '98637', 218, 56, 208212, 46.4991, 0.811562394214095, -124.0321, -2.16476852316286),
(42231, '98638', 218, 56, 208214, 46.4085, 0.809981125911788, -123.7108, -2.1591607802762),
(42232, '98639', 218, 56, 208264, 45.6433, 0.796625866475528, -121.9695, -2.12876936201122),
(42233, '98640', 218, 56, 104895, 46.5303, 0.812106936940717, -124.0496, -2.16507395578196),
(42234, '98641', 218, 56, 201365, 46.5503, 0.812456002791116, -124.053, -2.16513329697653),
(42235, '98642', 218, 56, 24320, 45.7901, 0.799188009817456, -122.6884, -2.14131653400381),
(42236, '98643', 218, 56, 208608, 46.3157, 0.808361460365938, -123.6567, -2.15821655715087),
(42237, '98644', 218, 56, 51267, 46.33, 0.808611042448973, -124.0524, -2.16512282500101),
(42238, '98645', 218, 56, 0, 46.3108, 0.80827593923259, -122.7687, -2.14271803339316),
(42239, '98647', 218, 56, 208756, 46.2948, 0.807996686552271, -123.4474, -2.15456358302645),
(42240, '98648', 218, 56, 6080, 45.6899, 0.797439189906957, -121.8962, -2.12749003566951),
(42241, '98649', 218, 56, 208966, 46.3182, 0.808405093597238, -122.693, -2.1413968191494),
(42242, '98650', 218, 56, 133438, 45.9836, 0.802565221920065, -121.5126, -2.12079495265886),
(42243, '98651', 218, 56, 6443, 45.7321, 0.798175718851299, -121.5451, -2.12136218466576),
(42244, '98660', 218, 56, 209033, 45.6405, 0.796576997256472, -122.677, -2.14111756646908),
(42245, '98661', 218, 56, 209033, 45.6428, 0.796617139829268, -122.6233, -2.14018032466076),
(42246, '98662', 218, 56, 209033, 45.6693, 0.797079652081046, -122.5587, -2.13905284196397),
(42247, '98663', 218, 56, 209033, 45.6515, 0.796768983474191, -122.6555, -2.1407423206799),
(42248, '98664', 218, 56, 209033, 45.6221, 0.796255856674105, -122.5654, -2.13916977902386),
(42249, '98665', 218, 56, 209033, 45.6917, 0.797470605833493, -122.6628, -2.1408697297153),
(42250, '98666', 218, 56, 209033, 45.7156, 0.79788773952472, -122.5981, -2.13974050168926),
(42251, '98667', 218, 56, 209033, 45.6396, 0.796561289293204, -122.626, -2.14022744855057),
(42252, '98668', 218, 56, 209033, 45.7174, 0.797919155451256, -122.6288, -2.14027631776962),
(42253, '98670', 218, 56, 209072, 45.8276, 0.799842508286953, -121.2744, -2.11663757838061),
(42254, '98671', 218, 56, 209107, 45.5982, 0.795838722982878, -122.3321, -2.13509792587896),
(42255, '98672', 218, 56, 209170, 45.7699, 0.798835453308553, -121.4781, -2.12019281406692),
(42256, '98673', 218, 56, 209212, 45.6629, 0.796967951008919, -120.9712, -2.11134574008856),
(42257, '98674', 218, 56, 6917, 45.9268, 0.801573874904932, -122.7152, -2.14178428224335),
(42258, '98675', 218, 56, 209231, 45.8645, 0.800486534780939, -122.4348, -2.13689037902075),
(42259, '98682', 218, 56, 209033, 45.6696, 0.797084888068802, -122.509, -2.13818541332573),
(42260, '98683', 218, 56, 209033, 45.6022, 0.795908536152958, -122.5257, -2.13847688331082),
(42261, '98684', 218, 56, 209033, 45.6198, 0.796215714101309, -122.5244, -2.13845419403054),
(42262, '98685', 218, 56, 209033, 45.7097, 0.797784765098852, -122.6826, -2.1412153049072),
(42263, '98686', 218, 56, 209033, 45.7147, 0.797872031561452, -122.6309, -2.14031296968391),
(42264, '98687', 218, 56, 209033, 45.6314, 0.79641817229454, -122.5194, -2.13836692756794),
(42265, '98801', 218, 56, 209131, 47.4286, 0.827785229611383, -120.3309, -2.10017039688804),
(42266, '98802', 218, 56, 207279, 47.4189, 0.827615932673939, -120.2595, -2.09892423180212),
(42267, '98807', 218, 56, 209131, 47.3714, 0.826786901279242, -120.2928, -2.09950542644303),
(42268, '98811', 218, 56, 206704, 47.743, 0.833272544779653, -120.3827, -2.10107447744058),
(42269, '98812', 218, 56, 15318, 48.056, 0.838735425338395, -119.6947, -2.08906661218686),
(42270, '98813', 218, 56, 1130, 48.0105, 0.837941300528738, -119.6605, -2.08846970958267),
(42271, '98814', 218, 56, 1361, 48.2176, 0.841555877409618, -120.1749, -2.09744768325493),
(42272, '98815', 218, 56, 108509, 47.5271, 0.829504378924597, -120.478, -2.10273777621773),
(42273, '98816', 218, 56, 207017, 47.8511, 0.835159245701059, -120.0431, -2.09514733930081),
(42274, '98817', 218, 56, 207019, 47.8008, 0.834281345087306, -119.9866, -2.09416122827343),
(42275, '98819', 218, 56, 207094, 48.5212, 0.846854697018673, -119.7175, -2.08946454725631),
(42276, '98821', 218, 56, 8610, 47.5448, 0.8298133022022, -120.5596, -2.10416196488736),
(42277, '98822', 218, 56, 207345, 47.7218, 0.83290253497823, -120.2946, -2.09953684236957),
(42278, '98823', 218, 56, 161392, 47.3181, 0.825856640787929, -119.5451, -2.08645559962587),
(42279, '98824', 218, 56, 9085, 47.0786, 0.821676577229402, -119.8549, -2.09186262964855),
(42280, '98826', 218, 56, 30314, 47.6673, 0.831951330535893, -120.6651, -2.10600328724821),
(42281, '98827', 218, 56, 131833, 48.8606, 0.852778344499941, -119.6762, -2.08874372627524),
(42282, '98828', 218, 56, 37031, 47.3552, 0.826504157940419, -120.2027, -2.09793288478699),
(42283, '98829', 218, 56, 207998, 48.284, 0.842714776032942, -119.7979, -2.09086779197491),
(42284, '98830', 218, 56, 3975, 47.7921, 0.834129501442382, -119.6399, -2.08811017175676),
(42285, '98831', 218, 56, 10293, 47.8916, 0.835866104048116, -120.1458, -2.0969397924426),
(42286, '98832', 218, 56, 96012, 47.4594, 0.828322791020997, -118.9225, -2.07558917970296),
(42287, '98833', 218, 56, 208064, 48.6425, 0.848971781401342, -120.212, -2.09809520040742),
(42288, '98834', 218, 56, 208114, 48.0713, 0.83900246071395, -120.0379, -2.0950565821797),
(42289, '98836', 218, 56, 37242, 47.4917, 0.828886532369391, -120.4322, -2.10193841542031),
(42290, '98837', 218, 56, 208183, 47.1279, 0.822537024550636, -119.2951, -2.08209227649589),
(42291, '98840', 218, 56, 208315, 48.3659, 0.844144200690325, -119.5803, -2.08706995552258),
(42292, '98841', 218, 56, 208331, 48.409, 0.844896437597935, -119.5267, -2.08613445904351),
(42293, '98843', 218, 56, 208349, 47.7892, 0.834078886894074, -120.0362, -2.09502691158242),
(42294, '98844', 218, 56, 183900, 48.9337, 0.854054180183149, -119.3813, -2.08359675031111),
(42295, '98845', 218, 56, 11056, 47.4616, 0.828361188264541, -119.7606, -2.09021678416392),
(42296, '98846', 218, 56, 209924, 48.232, 0.841807204821905, -119.8122, -2.09111737405795),
(42297, '98847', 218, 56, 208423, 47.5547, 0.829986089798147, -120.5989, -2.10484787928339),
(42298, '98848', 218, 56, 17745, 47.2094, 0.823959467891011, -119.8637, -2.09201621862273),
(42299, '98849', 218, 56, 5423, 48.4818, 0.846167037293387, -119.6146, -2.08766860345601),
(42300, '98850', 218, 56, 17831, 47.3707, 0.826774683974478, -120.139, -2.09682111005347),
(42301, '98851', 218, 56, 208778, 47.3932, 0.827167383056177, -119.4807, -2.08533160758759),
(42302, '98852', 218, 56, 208829, 48.2381, 0.841913669906277, -120.5335, -2.10370643395259),
(42303, '98853', 218, 56, 14683, 47.3667, 0.826704870804398, -119.2765, -2.08176764525502),
(42304, '98855', 218, 56, 208957, 48.6975, 0.849931712489939, -119.2978, -2.08213940038569),
(42305, '98856', 218, 56, 208997, 48.373, 0.844268119067217, -120.1235, -2.09655058401941),
(42306, '98857', 218, 56, 44025, 46.9696, 0.819774168344729, -119.0796, -2.07833109195784),
(42307, '98858', 218, 56, 25838, 47.6468, 0.831593538039234, -120.07, -2.09561683286959),
(42308, '98859', 218, 56, 121880, 48.7182, 0.850292995645102, -118.9483, -2.07603947464997),
(42309, '98860', 218, 56, 79424, 47.4245, 0.827713671112051, -119.121, -2.07905365826817),
(42310, '98862', 218, 56, 12913, 48.4762, 0.846069298855275, -120.1787, -2.09751400576651),
(42311, '98901', 218, 56, 209233, 46.6079, 0.813461312440265, -120.4676, -2.10255626197552),
(42312, '98902', 218, 56, 209233, 46.5938, 0.813215221015734, -120.5356, -2.10374308586688),
(42313, '98903', 218, 56, 209233, 46.5583, 0.812595629131276, -120.6225, -2.10525977698686),
(42314, '98904', 218, 56, 209233, 46.6894, 0.814883755780641, -120.6421, -2.10560186152025),
(42315, '98907', 218, 56, 209233, 46.5931, 0.81320300371097, -120.5294, -2.10363487545325),
(42316, '98908', 218, 56, 209233, 46.6076, 0.813456076452509, -120.6211, -2.10523534237733),
(42317, '98909', 218, 56, 209233, 46.5447, 0.812358264353005, -120.6458, -2.10566643870257),
(42318, '98920', 218, 56, 1190, 46.4042, 0.809906076753953, -120.6074, -2.10499623226981),
(42319, '98921', 218, 56, 70589, 46.4218, 0.810213254702304, -120.2937, -2.0995211344063),
(42320, '98922', 218, 56, 207055, 47.1955, 0.823716867124984, -120.9401, -2.11080294269119),
(42321, '98923', 218, 56, 207125, 46.665, 0.814457895443154, -120.7322, -2.1071744031763),
(42322, '98925', 218, 56, 2193, 47.2387, 0.824470849361845, -121.1783, -2.11496031696944),
(42323, '98926', 218, 56, 207323, 47.0009, 0.820320456400603, -120.5432, -2.10387573089003),
(42324, '98929', 218, 56, 207525, 46.8956, 0.818482624698253, -121.2655, -2.11648224407718),
(42325, '98930', 218, 56, 534, 46.2556, 0.807312517485489, -119.9186, -2.09297440438207),
(42326, '98932', 218, 56, 94574, 46.3558, 0.809061337395987, -120.1774, -2.09749131648623),
(42327, '98933', 218, 56, 76027, 46.3873, 0.809611116110366, -120.5105, -2.10330500822463),
(42328, '98934', 218, 56, 207805, 46.9863, 0.820065638329812, -120.4204, -2.10173246656858),
(42329, '98935', 218, 56, 207979, 46.2306, 0.806876185172491, -120.0121, -2.09460628723269),
(42330, '98936', 218, 56, 0, 46.5466, 0.812391425608793, -120.3289, -2.100135490303),
(42331, '98937', 218, 56, 208207, 46.767, 0.816238131280188, -120.7838, -2.10807499307033),
(42332, '98938', 218, 56, 197201, 46.3658, 0.809235870321187, -120.1004, -2.0961474129622),
(42333, '98939', 218, 56, 4872, 46.5007, 0.811590319482127, -120.4642, -2.10249692078095),
(42334, '98940', 218, 56, 33814, 47.2336, 0.824381837569994, -121.0219, -2.11223062201933),
(42335, '98941', 218, 56, 28468, 47.2207, 0.824156690096486, -120.9926, -2.11171924054849),
(42336, '98942', 218, 56, 208699, 46.6929, 0.81494484230446, -120.5546, -2.10407469842476),
(42337, '98943', 218, 56, 208790, 47.1873, 0.82357375012632, -120.9517, -2.11100540088443),
(42338, '98944', 218, 56, 6166, 46.3271, 0.808560427900665, -120.0029, -2.0944457169415),
(42339, '98946', 218, 56, 176675, 47.0345, 0.820906887029273, -120.9311, -2.11064586305851),
(42340, '98947', 218, 56, 208944, 46.7028, 0.815117629900408, -120.7394, -2.10730006688244),
(42341, '98948', 218, 56, 208960, 46.3738, 0.809375496661346, -120.3197, -2.09997492001182),
(42342, '98950', 218, 56, 209927, 46.9457, 0.819357034653502, -119.9856, -2.09414377498091),
(42343, '98951', 218, 56, 209093, 46.4575, 0.810836337245266, -120.411, -2.10156840561889),
(42344, '98952', 218, 56, 209171, 46.3753, 0.809401676600126, -120.7013, -2.10663509643743),
(42345, '98953', 218, 56, 209248, 46.4195, 0.810173112129508, -120.2597, -2.09892772246062),
(42346, '99001', 218, 56, 206654, 47.6491, 0.83163368061203, -117.6159, -2.0527847076964),
(42347, '99003', 218, 56, 108553, 47.9149, 0.836272765763831, -117.3056, -2.04736895102746),
(42348, '99004', 218, 56, 32046, 47.4825, 0.828725962078208, -117.5952, -2.05242342454124),
(42349, '99005', 218, 56, 1683, 47.8401, 0.834967259483339, -117.3642, -2.04839171396913),
(42350, '99006', 218, 56, 2011, 47.9526, 0.836930754891833, -117.459, -2.05004628610002),
(42351, '99008', 218, 56, 207311, 47.4928, 0.828905730991163, -117.814, -2.0562422049446),
(42352, '99009', 218, 56, 29713, 48.0133, 0.837990169747794, -117.2687, -2.04672492453347),
(42353, '99011', 218, 56, 0, 47.6366, 0.831415514455531, -117.6495, -2.05337113832507),
(42354, '99012', 218, 56, 2367, 47.3901, 0.827113277849365, -117.2045, -2.04560442315369),
(42355, '99013', 218, 56, 32456, 47.809, 0.834424462085969, -117.7712, -2.05549520402475),
(42356, '99014', 218, 56, 207454, 47.5611, 0.830097790870275, -117.5928, -2.05238153663919),
(42357, '99015', 218, 56, 21295, 47.5188, 0.829359516596682, -117.1947, -2.045433380887),
(42358, '99016', 218, 56, 21563, 47.6457, 0.831574339417462, -117.1546, -2.04473350385695),
(42359, '99017', 218, 56, 9971, 47.1946, 0.823701159161716, -117.8022, -2.05603625609286),
(42360, '99018', 218, 56, 207886, 47.2953, 0.825458705718474, -117.1345, -2.0443826926773),
(42361, '99019', 218, 56, 207921, 47.6534, 0.831708729769866, -117.0827, -2.04347861212477),
(42362, '99020', 218, 56, 4011, 47.5676, 0.830211237271655, -117.4916, -2.05061526343617),
(42363, '99021', 218, 56, 76572, 47.7942, 0.834166153356674, -117.2972, -2.04722234337029),
(42364, '99022', 218, 56, 208092, 47.6017, 0.830806394546585, -117.689, -2.05406054337961),
(42365, '99023', 218, 56, 23062, 47.5454, 0.829823774177712, -117.2131, -2.04575452146937),
(42366, '99025', 218, 56, 208241, 47.7311, 0.833064850598665, -117.0804, -2.04343846955197),
(42367, '99026', 218, 56, 208248, 47.7843, 0.833993365760726, -117.5997, -2.05250196435758),
(42368, '99027', 218, 56, 208360, 47.7025, 0.832565686432595, -117.1081, -2.04392192575477),
(42369, '99029', 218, 56, 208529, 47.7342, 0.833118955805477, -117.7633, -2.05535732301384),
(42370, '99030', 218, 56, 5475, 47.479, 0.828664875554388, -117.1144, -2.04403188149765),
(42371, '99031', 218, 56, 208805, 47.4329, 0.827860278769218, -117.3732, -2.04854879360181),
(42372, '99032', 218, 56, 5999, 47.2984, 0.825512810925286, -117.9789, -2.05912025288114),
(42373, '99033', 218, 56, 91263, 47.2246, 0.824224757937314, -117.0718, -2.0432883712363),
(42374, '99034', 218, 56, 208989, 47.8908, 0.8358521414141, -117.7753, -2.05556676252408),
(42375, '99036', 218, 56, 209026, 47.5302, 0.829558484131409, -117.2643, -2.04664813004639),
(42376, '99037', 218, 56, 209048, 47.6432, 0.831530706186162, -117.1976, -2.04548399543531),
(42377, '99039', 218, 56, 6664, 47.3127, 0.825762393008321, -117.2467, -2.04634095209804),
(42378, '99040', 218, 56, 209129, 47.881, 0.835681099147405, -118.03, -2.06001211612891),
(42379, '99101', 218, 56, 206641, 48.3222, 0.843381491807204, -117.9553, -2.05870835517767),
(42380, '99102', 218, 56, 7043, 46.7923, 0.816679699580943, -117.2491, -2.04638284000008),
(42381, '99103', 218, 56, 18819, 47.7143, 0.83277163528433, -118.9394, -2.07588414034654),
(42382, '99104', 218, 56, 303, 47.0883, 0.821845874166846, -117.161, -2.04484520492908),
(42383, '99105', 218, 56, 34771, 46.8863, 0.818320309077817, -117.9989, -2.05946931873154),
(42384, '99107', 218, 56, 1070, 48.9958, 0.855138029648638, -118.2119, -2.06318687003828),
(42385, '99109', 218, 56, 207030, 48.277, 0.842592602985302, -117.7275, -2.05473249514162),
(42386, '99110', 218, 56, 608, 48.012, 0.837967480467517, -117.5233, -2.05116853280905),
(42387, '99111', 218, 56, 8175, 46.8798, 0.818206862676438, -117.3563, -2.04825383295822),
(42388, '99113', 218, 56, 93382, 46.5691, 0.812784124690491, -117.1273, -2.04425702897115),
(42389, '99114', 218, 56, 35337, 48.5875, 0.848011850312745, -117.8396, -2.05668900923311),
(42390, '99115', 218, 56, 207114, 47.6365, 0.831413769126279, -119.2544, -2.08138192749033),
(42391, '99116', 218, 56, 207115, 47.9719, 0.837267603437468, -118.9708, -2.07643217373167),
(42392, '99117', 218, 56, 35429, 47.7566, 0.833509909557924, -118.5183, -2.0685345588664),
(42393, '99118', 218, 56, 15694, 48.9179, 0.853778418161334, -118.6267, -2.07042649577556),
(42394, '99119', 218, 56, 86192, 48.4383, 0.845407819068769, -117.321, -2.04763773173227),
(42395, '99121', 218, 56, 1964, 48.9818, 0.854893683553358, -118.5177, -2.06852408689088),
(42396, '99122', 218, 56, 1977, 47.6527, 0.831696512465102, -118.1474, -2.06206113267075),
(42397, '99123', 218, 56, 191427, 47.932, 0.836571217065922, -119.0259, -2.07739385014952),
(42398, '99124', 218, 56, 207331, 47.9974, 0.837712662396726, -118.9539, -2.07613721308808),
(42399, '99125', 218, 56, 35772, 46.9241, 0.818980043535071, -117.7035, -2.05431361612115),
(42400, '99126', 218, 56, 15, 48.7281, 0.850465783241049, -117.9714, -2.05898935318724),
(42401, '99127', 218, 56, 31032, 47.0888, 0.821854600813106, -117.5811, -2.0521773331167),
(42402, '99128', 218, 56, 8849, 47.09, 0.82187554476413, -117.044, -2.04280316970424),
(42403, '99129', 218, 56, 16149, 48.0463, 0.838566128400952, -118.1953, -2.06289714538245),
(42404, '99130', 218, 56, 9050, 47.0095, 0.820470554716274, -117.1378, -2.04444028854261),
(42405, '99131', 218, 56, 9105, 48.277, 0.842592602985302, -118.1365, -2.06187089178228),
(42406, '99133', 218, 56, 207537, 47.9338, 0.836602632992458, -119.0009, -2.07695751783652),
(42407, '99134', 218, 56, 13897, 47.419, 0.827617678003191, -118.3262, -2.06518178137331),
(42408, '99135', 218, 56, 207607, 47.6899, 0.832345774946844, -119.1075, -2.07881803881915),
(42409, '99136', 218, 56, 207617, 46.7265, 0.81553127293313, -117.8367, -2.0566383946848),
(42410, '99137', 218, 56, 22095, 48.1543, 0.840451083993105, -118.1296, -2.06175046406389),
(42411, '99138', 218, 56, 207711, 48.2908, 0.842833458422078, -118.5244, -2.06864102395077),
(42412, '99139', 218, 56, 9667, 48.7447, 0.85075550789688, -117.396, -2.04894672867126),
(42413, '99140', 218, 56, 22331, 48.0047, 0.837840071432122, -118.5606, -2.06927283313999),
(42414, '99141', 218, 56, 136223, 48.6348, 0.848837391048938, -118.0623, -2.0605758574773),
(42415, '99143', 218, 56, 9910, 46.816, 0.817093342613665, -117.8793, -2.05738190494615),
(42416, '99144', 218, 56, 207876, 47.3591, 0.826572225781246, -118.4817, -2.06789576836017),
(42417, '99146', 218, 56, 207893, 48.9984, 0.855183408209189, -118.2229, -2.063378856256),
(42418, '99147', 218, 56, 3781, 47.8228, 0.834665317522744, -118.473, -2.06774392471524),
(42419, '99148', 218, 56, 120428, 48.0527, 0.838677829473079, -117.6157, -2.05278121703789),
(42420, '99149', 218, 56, 56057, 47.1959, 0.823723848441992, -117.4818, -2.05044422116947),
(42421, '99150', 218, 56, 207996, 48.8032, 0.851776525509297, -118.6079, -2.07009837387618),
(42422, '99151', 218, 56, 37055, 48.6651, 0.849366225812292, -118.0668, -2.06065439729364),
(42423, '99152', 218, 56, 208111, 48.8514, 0.852617774208758, -117.3886, -2.04881757430662),
(42424, '99153', 218, 56, 208112, 48.855, 0.85268060606183, -117.3463, -2.04807930003302),
(42425, '99154', 218, 56, 195337, 47.4054, 0.82738031322492, -118.3286, -2.06522366927536),
(42426, '99155', 218, 56, 208229, 48.2545, 0.842199903903604, -119.2396, -2.08112361876103),
(42427, '99156', 218, 56, 10799, 48.1647, 0.840632598235313, -117.1807, -2.04518903479172),
(42428, '99157', 218, 56, 4635, 48.9247, 0.85389710055047, -117.7867, -2.05576573005881),
(42429, '99158', 218, 56, 208297, 47.1288, 0.822552732513904, -117.2445, -2.04630255485449),
(42430, '99159', 218, 56, 14343, 47.3334, 0.826123676163484, -118.6841, -2.0714283147662),
(42431, '99160', 218, 56, 28156, 48.8657, 0.852867356291793, -118.2014, -2.06300361046683),
(42432, '99161', 218, 56, 209926, 46.9118, 0.818765368037076, -117.0747, -2.04333898578461),
(42433, '99163', 218, 56, 11428, 46.7638, 0.816182280744124, -117.1911, -2.04537054903393),
(42434, '99164', 218, 56, 11428, 46.7291, 0.815576651493682, -117.1553, -2.04474572116171),
(42435, '99165', 218, 56, 11428, 46.7205, 0.815426553178011, -117.1854, -2.04527106526656),
(42436, '99166', 218, 56, 5356, 48.6897, 0.849795576808283, -118.6878, -2.07149289194853),
(42437, '99167', 218, 56, 5367, 48.4281, 0.845229795485066, -118.1328, -2.06180631459996),
(42438, '99169', 218, 56, 208576, 47.1261, 0.8225056086241, -118.3769, -2.06606666330408),
(42439, '99170', 218, 56, 33818, 47.3023, 0.825580878766114, -117.356, -2.04824859697047),
(42440, '99171', 218, 56, 31032, 47.09, 0.82187554476413, -117.583, -2.05221049437249),
(42441, '99173', 218, 56, 6023, 48.0606, 0.838815710483987, -117.7418, -2.05498207722466),
(42442, '99174', 218, 56, 190779, 47.0056, 0.820402486875447, -117.3555, -2.04823987032421),
(42443, '99176', 218, 56, 351, 47.1197, 0.822393907551972, -117.3754, -2.04858719084535),
(42444, '99179', 218, 56, 6475, 46.5369, 0.812222128671349, -117.0863, -2.04354144397784),
(42445, '99180', 218, 56, 209020, 48.2803, 0.842650198850618, -117.3081, -2.04741258425876),
(42446, '99181', 218, 56, 6497, 48.171, 0.840742553978188, -117.7829, -2.05569940754723),
(42447, '99185', 218, 56, 31532, 47.7567, 0.833511654887176, -118.7084, -2.07185242977444),
(42448, '99201', 218, 56, 43170, 47.6658, 0.831925150597113, -117.4328, -2.049589009836),
(42449, '99202', 218, 56, 43170, 47.6566, 0.83176458030593, -117.3804, -2.04867445730795),
(42450, '99203', 218, 56, 43170, 47.6305, 0.831309049371159, -117.3909, -2.04885771687941),
(42451, '99204', 218, 56, 43170, 47.6384, 0.831446930382067, -117.4803, -2.05041804123069),
(42452, '99205', 218, 56, 43170, 47.6942, 0.83242082410468, -117.4421, -2.04975132545643),
(42453, '99206', 218, 56, 43170, 47.6545, 0.831727928391638, -117.2744, -2.04682440830084),
(42454, '99207', 218, 56, 43170, 47.6942, 0.83242082410468, -117.387, -2.04878964903858),
(42455, '99208', 218, 56, 43170, 47.7371, 0.833169570353785, -117.4442, -2.04978797737072),
(42456, '99209', 218, 56, 43170, 47.6968, 0.832466202665231, -117.446, -2.04981939329726),
(42457, '99210', 218, 56, 43170, 47.6521, 0.83168604048959, -117.4227, -2.04941273158155),
(42458, '99211', 218, 56, 43170, 47.6664, 0.831935622572625, -117.3124, -2.0474876334166),
(42459, '99212', 218, 56, 43170, 47.6603, 0.831829157488253, -117.3134, -2.04750508670912),
(42460, '99213', 218, 56, 43170, 47.6574, 0.831778542939946, -117.2917, -2.04712635026143),
(42461, '99214', 218, 56, 43170, 47.7103, 0.832701822114251, -117.2059, -2.04562885776322),
(42462, '99215', 218, 56, 43170, 47.6945, 0.832426060092435, -117.2084, -2.04567249099452),
(42463, '99216', 218, 56, 43170, 47.6652, 0.831914678621601, -117.2143, -2.04577546542039),
(42464, '99217', 218, 56, 43170, 47.659, 0.831806468207978, -117.4246, -2.04944589283733),
(42465, '99218', 218, 56, 43170, 47.7526, 0.833440096387844, -117.4133, -2.04924867063186),
(42466, '99219', 218, 56, 43170, 47.6315, 0.831326502663679, -117.5404, -2.05146698411114),
(42467, '99220', 218, 56, 43170, 47.648, 0.831614481990258, -117.4122, -2.04922947201009),
(42468, '99223', 218, 56, 43170, 47.6104, 0.830958238191508, -117.3578, -2.048280012897),
(42469, '99224', 218, 56, 43170, 47.6938, 0.832413842787672, -117.622, -2.05289117278077),
(42470, '99228', 218, 56, 43170, 47.7989, 0.834248183831518, -117.3854, -2.04876172377055),
(42471, '99251', 218, 56, 43170, 47.7521, 0.833431369741584, -117.4202, -2.04936909835025),
(42472, '99252', 218, 56, 43170, 47.6565, 0.831762834976678, -117.3776, -2.0486255880889),
(42473, '99256', 218, 56, 43170, 47.6602, 0.831827412159001, -117.4234, -2.04942494888631),
(42474, '99258', 218, 56, 43170, 47.6685, 0.831972274486917, -117.4035, -2.04907762836516),
(42475, '99260', 218, 56, 43170, 47.6634, 0.831883262695065, -117.4231, -2.04941971289855),
(42476, '99299', 218, 56, 43170, 47.6588, 0.831802977549474, -117.4214, -2.04939004230127),
(42477, '99301', 218, 56, 17545, 46.2864, 0.807850078895103, -119.0944, -2.07858940068713),
(42478, '99302', 218, 56, 17545, 46.2562, 0.807322989461001, -119.0804, -2.07834505459186),
(42479, '99320', 218, 56, 53430, 46.2602, 0.807392802631081, -119.4708, -2.08515881999164),
(42480, '99321', 218, 56, 7444, 46.8637, 0.817925864666867, -119.8654, -2.09204588922001),
(42481, '99322', 218, 56, 206835, 45.9638, 0.80221964672817, -120.3216, -2.10000808126761),
(42482, '99323', 218, 56, 1232, 46.1995, 0.80633338777512, -119.0111, -2.07713554142022),
(42483, '99324', 218, 56, 207083, 46.0444, 0.803626382105277, -118.3842, -2.06619407233947),
(42484, '99326', 218, 56, 32139, 46.6654, 0.814464876760162, -118.9167, -2.07548795060634),
(42485, '99327', 218, 56, 1923, 46.8244, 0.817239950270833, -118.8119, -2.07365884555025),
(42486, '99328', 218, 56, 1992, 46.3234, 0.808495850718341, -117.9778, -2.05910105425937),
(42487, '99329', 218, 56, 2047, 46.1401, 0.805296662199436, -118.154, -2.06217632440138),
(42488, '99330', 218, 56, 207332, 46.4802, 0.811232526985468, -119.0864, -2.07844977434698),
(42489, '99332', 218, 56, 3007, 46.7795, 0.816456297436687, -118.8288, -2.07395380619384),
(42490, '99333', 218, 56, 16490, 46.7574, 0.816070579671997, -118.1448, -2.0620157541102),
(42491, '99335', 218, 56, 207760, 46.6779, 0.814683042916661, -118.5441, -2.06898485381341),
(42492, '99336', 218, 56, 207777, 46.2039, 0.806410182262208, -119.1623, -2.07977447924924),
(42493, '99337', 218, 56, 207777, 46.1873, 0.806120457606377, -119.1657, -2.07983382044381),
(42494, '99338', 218, 56, 207777, 46.211, 0.8065341006391, -119.1365, -2.07932418430222),
(42495, '99341', 218, 56, 174994, 46.9648, 0.819690392540633, -118.6437, -2.0707232017484),
(42496, '99343', 218, 56, 10451, 46.5781, 0.812941204323171, -119.1416, -2.07941319609408),
(42497, '99344', 218, 56, 67541, 46.8155, 0.817084615967405, -119.1649, -2.07981985780979),
(42498, '99345', 218, 56, 146006, 46.0207, 0.803212739072554, -119.7771, -2.0905047634905),
(42499, '99346', 218, 56, 14433, 46.0172, 0.803151652548735, -119.585, -2.08715198599742),
(42500, '99347', 218, 56, 33663, 46.4742, 0.811127807230349, -117.6017, -2.05253687094262),
(42501, '99348', 218, 56, 5219, 46.3002, 0.808090934331879, -118.3127, -2.0649461619243),
(42502, '99349', 218, 56, 208050, 46.7362, 0.815700569870574, -119.9003, -2.09265500912896),
(42503, '99350', 218, 56, 142809, 46.2026, 0.806387492981932, -119.7689, -2.09036164649184),
(42504, '99352', 218, 56, 5374, 46.2801, 0.807740123152228, -119.2904, -2.08201024602104),
(42505, '99353', 218, 56, 209151, 46.3242, 0.808509813352357, -119.3968, -2.08386727634517),
(42506, '99356', 218, 56, 5534, 45.8049, 0.799446318546751, -120.3132, -2.09986147361044),
(42507, '99357', 218, 56, 105927, 46.9103, 0.818739188098296, -119.5698, -2.08688669595112),
(42508, '99359', 218, 56, 138270, 46.5176, 0.811885280125714, -118.1235, -2.06164399897952),
(42509, '99360', 218, 56, 208964, 46.1008, 0.804610747803402, -118.7168, -2.0719990374316),
(42510, '99361', 218, 56, 209077, 46.2677, 0.80752370232498, -118.1507, -2.06211872853606),
(42511, '99362', 218, 56, 28892, 46.0618, 0.803930069395124, -118.3287, -2.06522541460461),
(42512, '99363', 218, 56, 34307, 46.0854, 0.804341967098595, -118.905, -2.07528374708386),
(42513, '99371', 218, 56, 209108, 46.7529, 0.815992039855657, -118.3135, -2.06496012455831),
(42514, '99401', 218, 56, 206691, 46.1397, 0.805289680882428, -117.0671, -2.04320634076145),
(42515, '99402', 218, 56, 206721, 46.3383, 0.808755904776888, -117.0419, -2.04276651778995),
(42516, '99403', 218, 56, 20075, 46.3985, 0.809806592986589, -117.0667, -2.04319935944445),
(42517, '99501', 218, 1, 34559, 61.2157, 1.06841551891309, -149.8693, -2.61571273265914),
(42518, '99502', 218, 1, 34559, 61.1515, 1.06729501753331, -149.9442, -2.61701998426888),
(42519, '99503', 218, 1, 34559, 61.1906, 1.06797744127084, -149.8909, -2.61608972377757),
(42520, '99504', 218, 1, 34559, 61.2033, 1.06819909808585, -149.7484, -2.61360262959348),
(42521, '99505', 218, 1, 211833, 61.255, 1.06910143330913, -149.6908, -2.61259731994433),
(42522, '99506', 218, 1, 0, 61.2848, 1.06962154142622, -149.7959, -2.61443166098817),
(42523, '99507', 218, 1, 34559, 61.1545, 1.06734737741087, -149.8285, -2.61500063832432),
(42524, '99508', 218, 1, 34559, 61.2022, 1.06817989946407, -149.816, -2.61478247216782),
(42525, '99509', 218, 1, 34559, 61.1784, 1.0677645111021, -149.8798, -2.6158959922306),
(42526, '99510', 218, 1, 34559, 61.2205, 1.06849929471719, -149.884, -2.61596929605918),
(42527, '99511', 218, 1, 34559, 61.1153, 1.06666320834409, -149.8627, -2.61559754092851),
(42528, '99512', 218, 1, 34559, 61.2174, 1.06844518951038, -149.9006, -2.61625902071501),
(42529, '99513', 218, 1, 34559, 61.2159, 1.0684190095716, -149.8673, -2.6156778260741),
(42530, '99514', 218, 1, 34559, 61.2088, 1.06829509119471, -149.829, -2.61500936497058),
(42531, '99515', 218, 1, 34559, 61.1212, 1.06676618276996, -149.8939, -2.61614208365513),
(42532, '99516', 218, 1, 34559, 61.1042, 1.06646947679712, -149.7789, -2.61413495501533),
(42533, '99517', 218, 1, 34559, 61.1894, 1.06795649731982, -149.938, -2.61691177385526),
(42534, '99518', 218, 1, 34559, 61.1574, 1.06739799195918, -149.8817, -2.61592915348638),
(42535, '99519', 218, 1, 34559, 61.1905, 1.06797569594159, -149.9882, -2.61778792913976),
(42536, '99520', 218, 1, 34559, 61.2152, 1.06840679226683, -149.8649, -2.61563593817205),
(42537, '99521', 218, 1, 34559, 61.2054, 1.06823575000014, -149.745, -2.61354328839891),
(42538, '99522', 218, 1, 34559, 61.152, 1.06730374417957, -149.9222, -2.61663601183344),
(42539, '99523', 218, 1, 34559, 61.1684, 1.0675899781769, -149.8392, -2.61518738855429),
(42540, '99524', 218, 1, 34559, 61.1882, 1.06793555336879, -149.8918, -2.61610543174084),
(42541, '99540', 218, 1, 9653, 61.1172, 1.06669636959988, -149.9016, -2.61627647400753),
(42542, '99546', 218, 1, 212251, 51.8803, 0.905482051922414, -176.6585, -3.0832724766344),
(42543, '99547', 218, 1, 212288, 52.1222, 0.909704003382988, -174.43, -3.04437781425371),
(42544, '99548', 218, 1, 211744, 56.1883, 0.98067083609833, -158.4455, -2.76539565996868),
(42545, '99549', 218, 1, 212101, 56.943, 0.993842835963131, -158.6313, -2.76863848171888),
(42546, '99550', 218, 1, 212104, 57.821, 1.00916682679564, -153.077, -2.67169765907536),
(42547, '99551', 218, 1, 212255, 60.8749, 1.0624674368223, -161.4033, -2.81701900858416),
(42548, '99552', 218, 1, 212256, 60.8809, 1.06257215657742, -161.189, -2.81327876799714),
(42549, '99553', 218, 1, 212260, 54.1289, 0.944727525482759, -165.9164, -2.89578746305592),
(42550, '99554', 218, 1, 212261, 62.5326, 1.09139975983261, -162.8587, -2.84242053051769),
(42551, '99555', 218, 1, 212266, 59.3236, 1.03539214413611, -158.6411, -2.76880952398558),
(42552, '99556', 218, 1, 212279, 59.7597, 1.04300352500406, -151.7673, -2.64883908186199),
(42553, '99557', 218, 1, 212281, 61.4759, 1.07295686562678, -156.7235, -2.73534109024933),
(42554, '99558', 218, 1, 212284, 62.9939, 1.09945096367206, -160.401, -2.79952557349142),
(42555, '99559', 218, 1, 220, 60.7493, 1.06027530328179, -161.7268, -2.82266514871437),
(42556, '99561', 218, 1, 211732, 60.1545, 1.04989408489093, -164.1982, -2.86579921584815),
(42557, '99563', 218, 1, 211739, 61.3519, 1.07079265735431, -164.6596, -2.87385216501686),
(42558, '99564', 218, 1, 211743, 56.2989, 0.982601170251036, -158.4095, -2.76476734143796),
(42559, '99565', 218, 1, 0, 56.1882, 0.980669090769078, -158.4452, -2.76539042398092),
(42560, '99566', 218, 1, 211749, 61.6605, 1.07617874342596, -143.8687, -2.51098250556397),
(42561, '99567', 218, 1, 211752, 61.4037, 1.07169673790684, -149.4619, -2.60860226128651),
(42562, '99568', 218, 1, 211758, 60.1864, 1.05045084492232, -151.3899, -2.64225220926496),
(42563, '99569', 218, 1, 80346, 58.8361, 1.02688366403264, -157.984, -2.75734096547072),
(42564, '99571', 218, 1, 211763, 55.8368, 0.97453600377757, -161.1113, -2.81192264716834),
(42565, '99572', 218, 1, 35370, 60.4461, 1.05498346498974, -149.9168, -2.61654176405384),
(42566, '99573', 218, 1, 211768, 61.92, 1.08070787283489, -145.3816, -2.53738759181739),
(42567, '99574', 218, 1, 924, 60.5455, 1.05671832226623, -145.7548, -2.54390116058583),
(42568, '99575', 218, 1, 86119, 61.8061, 1.07871994281687, -157.9372, -2.75652415138079),
(42569, '99576', 218, 1, 64215, 59.3242, 1.03540261611162, -160.2006, -2.79602793367043),
(42570, '99577', 218, 1, 130569, 61.3187, 1.07021320804265, -149.536, -2.60989555026224),
(42571, '99578', 218, 1, 211804, 59.8312, 1.04425143541923, -162.0141, -2.82767947965535),
(42572, '99579', 218, 1, 211806, 58.1613, 1.01510618224018, -157.194, -2.74355286437997),
(42573, '99580', 218, 1, 211809, 59.375, 1.03628924337163, -157.6003, -2.75064413713082),
(42574, '99581', 218, 1, 211814, 62.9056, 1.09790983794254, -164.3333, -2.8681571556676),
(42575, '99583', 218, 1, 211825, 54.8442, 0.957211865622274, -163.4305, -2.85240032318059),
(42576, '99584', 218, 1, 8900, 61.5083, 1.07352235230443, -156.6602, -2.73423629683282),
(42577, '99585', 218, 1, 4011, 61.7372, 1.07751741096224, -161.9689, -2.82689059083344),
(42578, '99586', 218, 1, 211840, 62.3575, 1.08834368831236, -143.0017, -2.49585050094917),
(42579, '99587', 218, 1, 211847, 60.9636, 1.06401554386882, -149.1241, -2.60270653907328),
(42580, '99588', 218, 1, 211848, 62.048, 1.08294189427744, -146.3599, -2.55446214788965),
(42581, '99589', 218, 1, 211851, 59.0839, 1.03120858991908, -161.2167, -2.81376222419994),
(42582, '99590', 218, 1, 131103, 64.0779, 1.11837033276367, -159.6844, -2.78701854407163),
(42583, '99591', 218, 1, 51151, 56.5944, 0.987758618190679, -169.6183, -2.9603978066355),
(42584, '99599', 218, 1, 34559, 61.2164, 1.06842773621786, -149.8686, -2.61570051535437),
(42585, '99602', 218, 1, 36481, 62.2311, 1.08613759213784, -160.432, -2.80006662555954),
(42586, '99603', 218, 1, 22029, 59.6739, 1.04150603250584, -151.4809, -2.64384045888428),
(42587, '99604', 218, 1, 211878, 61.4979, 1.07334083806222, -165.7103, -2.89219033946756),
(42588, '99605', 218, 1, 665, 60.9162, 1.06318825780337, -149.6358, -2.61163738885573),
(42589, '99606', 218, 1, 0, 59.7531, 1.04288833327342, -154.8232, -2.70217459847369),
(42590, '99607', 218, 1, 211907, 61.5429, 1.07412623622562, -160.3312, -2.79830733367353),
(42591, '99608', 218, 1, 211912, 60.8809, 1.06257215657742, -162.0429, -2.82818213447992),
(42592, '99609', 218, 1, 211915, 60.8802, 1.06255993927265, -162.0428, -2.82818038915067),
(42593, '99610', 218, 1, 211916, 60.4201, 1.05452967938423, -151.0704, -2.63667588230484),
(42594, '99611', 218, 1, 211920, 60.5519, 1.05683002333835, -151.2038, -2.639004151527),
(42595, '99612', 218, 1, 211927, 55.3774, 0.966517961193908, -161.9432, -2.82644204121568),
(42596, '99613', 218, 1, 193705, 58.7085, 1.02465662390709, -156.6554, -2.73415252102872),
(42597, '99614', 218, 1, 211929, 59.9215, 1.04582746773378, -164.0578, -2.86334877357835),
(42598, '99615', 218, 1, 55724, 57.8053, 1.00889281010308, -152.4571, -2.66087836304225),
(42599, '99619', 218, 1, 55724, 57.4149, 1.00207904470329, -153.5349, -2.67968952172024),
(42600, '99620', 218, 1, 211946, 63.0984, 1.10127483274039, -164.0366, -2.86297876377693),
(42601, '99621', 218, 1, 211953, 60.7733, 1.06069418230227, -161.3876, -2.8167449918916),
(42602, '99622', 218, 1, 211954, 59.8714, 1.04495305777853, -162.998, -2.84485177416572),
(42603, '99624', 218, 1, 212250, 57.4156, 1.00209126200806, -153.5318, -2.67963541651343),
(42604, '99625', 218, 1, 211967, 59.7803, 1.04336306282997, -154.806, -2.70187440184234),
(42605, '99626', 218, 1, 211974, 61.5173, 1.07367943193711, -160.3541, -2.79870701407224),
(42606, '99627', 218, 1, 60831, 62.9134, 1.0980459736242, -154.9448, -2.70429691884411),
(42607, '99628', 218, 1, 211979, 58.8618, 1.0273322136504, -159.1266, -2.77728309750401),
(42608, '99630', 218, 1, 211992, 60.0999, 1.04894113511934, -166.3787, -2.90385612018789),
(42609, '99631', 218, 1, 212002, 60.6111, 1.05786325825554, -149.2488, -2.60488296465051),
(42610, '99632', 218, 1, 49699, 62.0874, 1.08362955400273, -163.7171, -2.85740243681681),
(42611, '99633', 218, 1, 212013, 58.8618, 1.0273322136504, -156.7092, -2.7350915081663),
(42612, '99634', 218, 1, 212016, 60.6748, 1.05897503298906, -161.7356, -2.82281873768854),
(42613, '99635', 218, 1, 212032, 60.7294, 1.05992798276064, -151.2439, -2.63970402855705),
(42614, '99636', 218, 1, 212026, 59.4034, 1.0367849168792, -157.2809, -2.74506955549995),
(42615, '99637', 218, 1, 212193, 60.603, 1.05772188658612, -164.7599, -2.87560273025661),
(42616, '99638', 218, 1, 212036, 52.8383, 0.92220230615652, -169.8562, -2.96454994492599),
(42617, '99639', 218, 1, 212038, 59.9875, 1.0469793850401, -151.6983, -2.64763480467811),
(42618, '99640', 218, 1, 212044, 59.9668, 1.04661810188494, -154.852, -2.70267725329826),
(42619, '99641', 218, 1, 212060, 61.0127, 1.06487250053154, -162.0579, -2.82844393386772),
(42620, '99643', 218, 1, 125728, 57.4153, 1.0020860260203, -153.5325, -2.67964763381819),
(42621, '99644', 218, 1, 212076, 57.4146, 1.00207380871554, -153.5316, -2.67963192585493),
(42622, '99645', 218, 1, 337, 61.6179, 1.07543523316461, -149.1193, -2.60262276326918),
(42623, '99647', 218, 1, 212082, 59.8441, 1.04447658289274, -154.2002, -2.69130119723376),
(42624, '99648', 218, 1, 4963, 55.9286, 0.976138216030901, -159.3329, -2.78088371175087),
(42625, '99649', 218, 1, 97055, 57.5923, 1.00517525879633, -157.4846, -2.74862479118626),
(42626, '99650', 218, 1, 212090, 61.6817, 1.07654875322739, -163.1849, -2.84811379453769),
(42627, '99651', 218, 1, 212092, 58.7909, 1.02609477521073, -161.4802, -2.81836116677895),
(42628, '99652', 218, 1, 7472, 61.5338, 1.07396741126369, -149.8357, -2.61512630203047),
(42629, '99653', 218, 1, 212098, 60.3611, 1.05349993512555, -154.5373, -2.69718470214223),
(42630, '99654', 218, 1, 212225, 61.5947, 1.07503031677815, -149.4087, -2.60767374612445),
(42631, '99655', 218, 1, 212118, 59.4809, 1.0381375470495, -161.1504, -2.81260507090587),
(42632, '99656', 218, 1, 212120, 61.751, 1.07775826639902, -157.2607, -2.74471699899105),
(42633, '99657', 218, 1, 212125, 61.7689, 1.07807068033513, -160.9764, -2.8095681980074),
(42634, '99658', 218, 1, 24606, 62.2686, 1.08679209060734, -163.3439, -2.85088886804837),
(42635, '99659', 218, 1, 113341, 63.2793, 1.10443213335725, -161.7726, -2.82346450951178),
(42636, '99660', 218, 1, 0, 57.1843, 0.998054315448193, -170.2764, -2.97188381844287),
(42637, '99661', 218, 1, 61659, 55.27, 0.964643477577266, -160.6825, -2.80443867533579),
(42638, '99662', 218, 1, 212135, 61.7932, 1.07849479534336, -165.0724, -2.88105688416909),
(42639, '99663', 218, 1, 212137, 59.4392, 1.03740974475141, -151.7095, -2.64783028155434),
(42640, '99664', 218, 1, 33926, 60.138, 1.04960610556435, -149.4381, -2.60818687292454),
(42641, '99665', 218, 1, 212142, 62.6478, 1.0934103791309, -159.7949, -2.78894713289509),
(42642, '99666', 218, 1, 212059, 62.5829, 1.09227766044636, -164.7916, -2.87615599962949),
(42643, '99667', 218, 1, 212150, 61.6952, 1.07678437267641, -152.0804, -2.65430370774998),
(42644, '99668', 218, 1, 212152, 61.5964, 1.07505998737544, -157.0446, -2.74094534247749),
(42645, '99669', 218, 1, 212154, 60.4924, 1.05579155243342, -151.0809, -2.6368591418763),
(42646, '99670', 218, 1, 212157, 58.7103, 1.02468803983363, -156.9086, -2.73857169469477),
(42647, '99671', 218, 1, 212162, 63.469, 1.10774302294828, -162.2569, -2.83191713907919),
(42648, '99672', 218, 1, 25116, 60.5288, 1.05642685228114, -150.8315, -2.63250629072183),
(42649, '99674', 218, 1, 12229, 61.7096, 1.07703570008869, -148.8776, -2.59840430246711),
(42650, '99675', 218, 1, 212176, 62.9749, 1.09911935111418, -156.1253, -2.7249005306639),
(42651, '99676', 218, 1, 212178, 62.1744, 1.08514799045196, -149.9005, -2.61625727538576),
(42652, '99677', 218, 1, 212182, 61.1047, 1.06647820344338, -147.1109, -2.56756957057213),
(42653, '99678', 218, 1, 212190, 59.2096, 1.03340246878883, -160.5007, -2.80126566675566),
(42654, '99679', 218, 1, 212198, 61.1093, 1.06655848858897, -160.9508, -2.80912139371889),
(42655, '99680', 218, 1, 212200, 60.5703, 1.05715116392072, -162.3046, -2.83274966113239),
(42656, '99681', 218, 1, 212201, 60.6031, 1.05772363191538, -164.7606, -2.87561494756137),
(42657, '99682', 218, 1, 212205, 60.065, 1.04833201521039, -152.8579, -2.66787364268424),
(42658, '99683', 218, 1, 212197, 61.7509, 1.07775652106977, -150.0459, -2.61879498411816),
(42659, '99684', 218, 1, 212211, 63.723, 1.11217615924835, -160.5432, -2.80200743168776),
(42660, '99685', 218, 1, 212212, 53.8645, 0.940112874940486, -166.7201, -2.9098146742542),
(42661, '99686', 218, 1, 18418, 61.2399, 1.06883788859208, -145.9946, -2.54808646013211),
(42662, '99687', 218, 1, 212225, 61.5934, 1.07500762749788, -149.4148, -2.60778021120882),
(42663, '99688', 218, 1, 12874, 61.6456, 1.07591868936742, -150.672, -2.6297224905649),
(42664, '99689', 218, 1, 193331, 59.8114, 1.04390586022734, -139.5535, -2.43566805768191),
(42665, '99690', 218, 1, 212031, 60.7088, 1.05956844493473, -163.1002, -2.84663550066126),
(42666, '99691', 218, 1, 212035, 62.9976, 1.09951554085438, -154.3881, -2.69458067089826),
(42667, '99692', 218, 1, 211799, 53.5625, 0.934841980599463, -166.9675, -2.91413261882363),
(42668, '99693', 218, 1, 18607, 60.7859, 1.06091409378802, -148.6247, -2.59399036478882),
(42669, '99694', 218, 1, 3246, 61.4928, 1.07325182627037, -149.7931, -2.61438279176912),
(42670, '99695', 218, 1, 34559, 61.2146, 1.06839632029132, -149.8634, -2.61560975823327),
(42671, '99697', 218, 1, 55724, 57.4144, 1.00207031805703, -153.5355, -2.67969999369575),
(42672, '99701', 218, 1, 8817, 64.8367, 1.13161389112781, -147.7144, -2.57810263260791),
(42673, '99702', 218, 1, 0, 64.651, 1.12837281470685, -147.0833, -2.56708785969858),
(42674, '99703', 218, 1, 0, 64.8253, 1.13141492359308, -147.6358, -2.57673080381584),
(42675, '99704', 218, 1, 0, 64.4925, 1.12560646784244, -148.6781, -2.59492237060938),
(42676, '99705', 218, 1, 76748, 64.7821, 1.13066094135622, -147.3682, -2.57206030273751),
(42677, '99706', 218, 1, 8817, 64.8343, 1.13157200322576, -147.8832, -2.58104874838528);
INSERT INTO `dsb_loc_zips` (`zip_id`, `zipcode`, `fk_country_id`, `fk_state_id`, `fk_city_id`, `latitude`, `rad_latitude`, `longitude`, `rad_longitude`) VALUES
(42678, '99707', 218, 1, 8817, 64.8369, 1.13161738178631, -147.6998, -2.57784781453712),
(42679, '99708', 218, 1, 8817, 64.8764, 1.13230678684085, -147.8994, -2.5813314917241),
(42680, '99709', 218, 1, 8817, 64.8564, 1.13195772099045, -147.8773, -2.58094577395941),
(42681, '99710', 218, 1, 8817, 64.9164, 1.13300491854165, -147.5686, -2.5755579425585),
(42682, '99711', 218, 1, 8817, 64.8186, 1.1312979865332, -147.5685, -2.57555619722925),
(42683, '99712', 218, 1, 8817, 65.1094, 1.136373403998, -146.504, -2.55697716734177),
(42684, '99714', 218, 1, 0, 64.7287, 1.12972893553565, -145.5905, -2.5410335846248),
(42685, '99716', 218, 1, 52271, 64.8782, 1.13233820276739, -146.877, -2.56348724545171),
(42686, '99720', 218, 1, 212272, 66.5447, 1.16142411475187, -152.7375, -2.66577226626484),
(42687, '99721', 218, 1, 212277, 68.2399, 1.19101093623168, -151.8922, -2.65101899809773),
(42688, '99722', 218, 1, 212285, 68.1389, 1.18924815368716, -145.5501, -2.540328471607),
(42689, '99723', 218, 1, 26453, 69.6607, 1.21580857424401, -153.6715, -2.68207364147847),
(42690, '99724', 218, 1, 7346, 66.6588, 1.1634155354284, -147.5747, -2.57566440764288),
(42691, '99725', 218, 1, 211817, 64.9463, 1.13352677198799, -148.2474, -2.58740523752104),
(42692, '99726', 218, 1, 0, 67.381, 1.1760203032863, -150.7228, -2.63060911782491),
(42693, '99727', 218, 1, 63266, 65.8416, 1.1491527047811, -160.7045, -2.80482264777123),
(42694, '99729', 218, 1, 53844, 63.4345, 1.10714088435634, -148.6971, -2.59525398316726),
(42695, '99730', 218, 1, 1462, 65.3442, 1.14047143708168, -145.1383, -2.53314120574729),
(42696, '99732', 218, 1, 211742, 63.8252, 1.11395988574388, -142.1607, -2.4811722819399),
(42697, '99733', 218, 1, 93252, 65.8261, 1.14888217874704, -144.0664, -2.51443302149516),
(42698, '99734', 218, 1, 212116, 70.0154, 1.22199925710084, -148.8852, -2.59853694749026),
(42699, '99736', 218, 1, 54395, 65.7837, 1.14814215914419, -163.0175, -2.84519211336986),
(42700, '99737', 218, 1, 207194, 64.0073, 1.11713813031177, -145.3528, -2.53688493699281),
(42701, '99738', 218, 1, 2149, 64.7867, 1.13074122650181, -141.2025, -2.46444853704729),
(42702, '99739', 218, 1, 20842, 64.7594, 1.13026475161602, -162.0714, -2.82867955331674),
(42703, '99740', 218, 1, 211834, 66.4352, 1.15951297922094, -145.8282, -2.5451822322568),
(42704, '99741', 218, 1, 9031, 65.557, 1.14418549772992, -151.1005, -2.63720122640969),
(42705, '99742', 218, 1, 211842, 63.5086, 1.10843417333207, -171.4322, -2.99205633393742),
(42706, '99743', 218, 1, 187712, 63.8957, 1.11519034286654, -148.5276, -2.59229565008513),
(42707, '99744', 218, 1, 7099, 64.2908, 1.12208613874117, -149.1274, -2.60276413493859),
(42708, '99745', 218, 1, 9609, 65.9753, 1.15148620999102, -154.1946, -2.69120345879565),
(42709, '99746', 218, 1, 211883, 65.561, 1.1442553109, -156.4751, -2.73100569238738),
(42710, '99747', 218, 1, 211902, 69.8774, 1.21959070273309, -143.6808, -2.50770303189947),
(42711, '99748', 218, 1, 211908, 64.3417, 1.12297451133044, -158.7246, -2.77026687391099),
(42712, '99749', 218, 1, 211925, 67.554, 1.17903972289225, -160.3189, -2.79809265817554),
(42713, '99750', 218, 1, 211930, 67.6315, 1.18039235306255, -163.7276, -2.85758569638827),
(42714, '99751', 218, 1, 211938, 66.9791, 1.16900582502253, -155.881, -2.72063669130128),
(42715, '99752', 218, 1, 211947, 66.9226, 1.16801971399516, -162.0325, -2.82800062023771),
(42716, '99753', 218, 1, 211948, 65.1522, 1.13712040491785, -160.7773, -2.80609324746668),
(42717, '99754', 218, 1, 211949, 64.8901, 1.13254589694837, -157.6781, -2.75200200328887),
(42718, '99755', 218, 1, 0, 63.6234, 1.11043781131336, -150.9034, -2.63376118245401),
(42719, '99756', 218, 1, 211978, 65.1483, 1.13705233707702, -150.8726, -2.6332236210444),
(42720, '99757', 218, 1, 211959, 63.8041, 1.11359162127171, -152.4189, -2.66021164726799),
(42721, '99758', 218, 1, 140517, 65.0454, 1.13525639327672, -149.6458, -2.61181192178093),
(42722, '99759', 218, 1, 212094, 69.5402, 1.21370545249536, -163.2492, -2.84923604124673),
(42723, '99760', 218, 1, 212022, 64.5518, 1.12664144808888, -149.1032, -2.60234176525961),
(42724, '99761', 218, 1, 212039, 67.2958, 1.1745332827636, -163.01, -2.84506121367596),
(42725, '99762', 218, 1, 96569, 64.5137, 1.12597647764387, -164.846, -2.87710545874257),
(42726, '99763', 218, 1, 212045, 66.8579, 1.16689048596912, -159.8709, -2.7902735831266),
(42727, '99764', 218, 1, 212049, 62.9451, 1.09859924299708, -141.9454, -2.47741458806036),
(42728, '99765', 218, 1, 212055, 64.6133, 1.12771482557885, -159.2075, -2.77869506886887),
(42729, '99766', 218, 1, 212096, 68.5304, 1.19608111770872, -165.7978, -2.89371750256305),
(42730, '99767', 218, 1, 184371, 65.4912, 1.14303707108211, -149.8566, -2.61549107584413),
(42731, '99768', 218, 1, 42889, 64.3526, 1.1231647522189, -155.9834, -2.72242390845532),
(42732, '99769', 218, 1, 212134, 63.2482, 1.10388933595988, -169.5943, -2.95997892761502),
(42733, '99770', 218, 1, 212136, 66.2936, 1.15704159300011, -158.9651, -2.77446439076204),
(42734, '99771', 218, 1, 212143, 64.5147, 1.12599393093639, -160.4793, -2.80089216629574),
(42735, '99772', 218, 1, 212146, 66.0411, 1.15263463663883, -165.5097, -2.88868920898806),
(42736, '99773', 218, 1, 212147, 66.7174, 1.16443829837006, -156.9962, -2.74010060311952),
(42737, '99774', 218, 1, 212164, 66.0225, 1.15231000539796, -149.1866, -2.60379736985577),
(42738, '99775', 218, 1, 8817, 64.817, 1.13127006126516, -147.8782, -2.58096148192268),
(42739, '99776', 218, 1, 212179, 63.3555, 1.10576207424727, -143.3633, -2.50216161152439),
(42740, '99777', 218, 1, 212181, 65.3178, 1.14001067015915, -151.892, -2.65101550743923),
(42741, '99778', 218, 1, 212186, 65.178, 1.13757069986486, -166.2879, -2.90227136122708),
(42742, '99779', 218, 1, 0, 63.1153, 1.10156979338398, -142.5178, -2.48740485269877),
(42743, '99780', 218, 1, 212191, 63.8377, 1.11417805190038, -143.0113, -2.49601805255737),
(42744, '99781', 218, 1, 212220, 67.0108, 1.16955909439542, -146.4099, -2.55533481251565),
(42745, '99782', 218, 1, 6596, 70.5663, 1.23161427595007, -159.43, -2.78257842645456),
(42746, '99783', 218, 1, 38725, 65.6658, 1.14608441595609, -167.4335, -2.92226585313793),
(42747, '99784', 218, 1, 212228, 64.8655, 1.13211654595238, -163.2592, -2.84941057417193),
(42748, '99785', 218, 1, 211710, 65.4599, 1.14249078302624, -166.8263, -2.91166821391982),
(42749, '99786', 218, 1, 122135, 67.6627, 1.18093689578917, -156.8668, -2.73784214706744),
(42750, '99788', 218, 1, 211725, 66.6346, 1.16299316574941, -143.7591, -2.50906962470378),
(42751, '99789', 218, 1, 212054, 70.2359, 1.22584770810149, -151.1261, -2.6376480306982),
(42752, '99790', 218, 1, 8817, 64.5129, 1.12596251500985, -147.6654, -2.57724742127443),
(42753, '99791', 218, 1, 212290, 70.4712, 1.22995446783143, -157.428, -2.74763693482963),
(42754, '99801', 218, 1, 163198, 58.3565, 1.01851306494007, -134.5272, -2.34794257348892),
(42755, '99802', 218, 1, 163198, 58.3028, 1.01757582313175, -134.4261, -2.34617804561515),
(42756, '99803', 218, 1, 163198, 58.3732, 1.01880453492515, -134.5958, -2.34913986935578),
(42757, '99811', 218, 1, 163198, 58.4776, 1.02062665866424, -134.1578, -2.34149532723205),
(42758, '99820', 218, 1, 209933, 57.6853, 1.00679841500069, -134.3817, -2.34540311942726),
(42759, '99821', 218, 1, 209935, 58.4044, 1.01934907765178, -134.6891, -2.35076826154789),
(42760, '99824', 218, 1, 2088, 58.2762, 1.01711156555072, -134.3927, -2.34559510564498),
(42761, '99825', 218, 1, 209952, 58.1857, 1.01553204257766, -136.3156, -2.37915604183158),
(42762, '99826', 218, 1, 155572, 58.8252, 1.02669342314417, -136.9723, -2.39061761902943),
(42763, '99827', 218, 1, 162364, 59.2463, 1.03404300462432, -135.4733, -2.36445513354203),
(42764, '99829', 218, 1, 209977, 58.1251, 1.01447437305096, -135.6494, -2.3675286583548),
(42765, '99830', 218, 1, 193165, 56.9745, 0.994392614677509, -133.9455, -2.33778999323006),
(42766, '99832', 218, 1, 42533, 58.1248, 1.0144691370632, -135.6489, -2.36751993170854),
(42767, '99833', 218, 1, 14402, 56.8082, 0.991490132131443, -132.9701, -2.32076605170611),
(42768, '99835', 218, 1, 11963, 57.0603, 0.99589010717572, -135.3383, -2.36209893905184),
(42769, '99836', 218, 1, 193286, 57.0388, 0.995514861386542, -132.562, -2.31364336302872),
(42770, '99840', 218, 1, 193308, 59.5652, 1.03960885960893, -135.328, -2.36191917013889),
(42771, '99841', 218, 1, 193314, 57.781, 1.00846869509484, -135.1864, -2.35944778391806),
(42772, '99850', 218, 1, 163198, 58.478, 1.02063363998124, -134.1568, -2.34147787393953),
(42773, '99901', 218, 1, 193181, 55.375, 0.96647607329186, -131.6921, -2.29846074386562),
(42774, '99903', 218, 1, 193273, 55.7223, 0.972537601784036, -132.2295, -2.30784014326584),
(42775, '99918', 218, 1, 209944, 55.5652, 0.969795689529153, -131.3883, -2.29315843359807),
(42776, '99919', 218, 1, 193317, 55.7626, 0.97324096947259, -132.6217, -2.31468532459216),
(42777, '99921', 218, 1, 29568, 55.4762, 0.968242346494878, -133.142, -2.32376627269029),
(42778, '99922', 218, 1, 193137, 55.1595, 0.962714888753812, -132.4377, -2.31147391876849),
(42779, '99923', 218, 1, 178404, 55.9649, 0.976771770549375, -130.393, -2.27578717155297),
(42780, '99925', 218, 1, 193197, 55.5556, 0.969628137920962, -133.0941, -2.32293025997858),
(42781, '99926', 218, 1, 193271, 55.1317, 0.962229687221758, -131.4915, -2.29495961338612),
(42782, '99927', 218, 1, 17681, 56.2479, 0.981711052332519, -133.3567, -2.32751349459432),
(42783, '99928', 218, 1, 193323, 55.4551, 0.967874082022708, -131.7906, -2.30017989317884),
(42784, '99929', 218, 1, 193329, 56.4684, 0.985559503333166, -132.3833, -2.31052445965541),
(42785, '99950', 218, 1, 193181, 55.8077, 0.974028112965239, -132.9733, -2.32082190224218);

CREATE TABLE `dsb_memberships` (
  `m_id` int(2) unsigned NOT NULL AUTO_INCREMENT,
  `m_name` varchar(64) NOT NULL,
  `m_value` int(10) unsigned NOT NULL DEFAULT '0',
  `is_custom` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`m_id`),
  UNIQUE KEY `m_name` (`m_name`),
  UNIQUE KEY `m_value` (`m_value`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 PACK_KEYS=0 ;

INSERT INTO `dsb_memberships` (`m_id`, `m_name`, `m_value`, `is_custom`) VALUES
(1, 'Non Member', 1, 0),
(2, 'Free Member', 2, 0),
(3, 'Paid Member', 4, 1);

CREATE TABLE `dsb_message_filters` (
  `filter_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `filter_type` tinyint(2) unsigned NOT NULL DEFAULT '1',
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `field` varchar(32) NOT NULL,
  `field_value` varchar(255) NOT NULL,
  `fk_folder_id` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`filter_id`),
  UNIQUE KEY `filter_type` (`filter_type`,`fk_user_id`,`field_value`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_modules` (
  `module_code` varchar(32) NOT NULL,
  `module_name` varchar(100) NOT NULL,
  `module_diz` text NOT NULL,
  `module_type` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `version` float(4,2) unsigned NOT NULL DEFAULT '0.00',
  `sort` tinyint(3) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`module_code`),
  KEY `module_type` (`module_type`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_modules` (`module_code`, `module_name`, `module_diz`, `module_type`, `version`, `sort`) VALUES
('core', 'Basic Features', '', 0, 2.80, 1),
('core_blog', 'Blogs', '', 0, 1.01, 3),
('core_photo', 'Photo Album', '', 0, 1.02, 3),
('paypal', 'Paypal', '', 1, 1.01, 4),
('maxmind', 'Maxmind', 'Fraud checking module. Compares credit card country with  buyer''s IP country.', 2, 1.01, 5),
('skin_def', 'Default Skin', 'Official default skin', 4, 1.03, 6),
('def_user_prefs', 'Default User Preferences', 'The default user preferences', 0, 1.02, 2),
('adv_features', 'Advanced Features', '', 0, 1.01, 3),
('latest_blog_comments', 'Latest Blog Comments', 'Small widget to display the latest comments on any blog post.', 3, 1.01, 7),
('rand_items_widget', 'Random Items', '', 0, 1.04, 8),
('field_loc_req', 'Required Location Field', '', 0, 1.02, 9);

CREATE TABLE `dsb_networks` (
  `net_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `network` varchar(100) NOT NULL,
  `is_bidi` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `max_users` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`net_id`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_networks` (`net_id`, `network`, `is_bidi`, `max_users`) VALUES
(1, 'Friends', 1, 0),
(2, 'Blocked Members', 0, 0),
(3, 'Favorites', 0, 0);

CREATE TABLE `dsb_online` (
  `fk_user_id` int(10) unsigned DEFAULT NULL,
  `last_activity` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `sess` varchar(32) NOT NULL,
  `sess_data` text NOT NULL,
  UNIQUE KEY `sess` (`sess`),
  UNIQUE KEY `fk_user_id` (`fk_user_id`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_online` (`fk_user_id`, `last_activity`, `sess`, `sess_data`) VALUES
(0, '2015-05-21 17:00:47', 'lc3clu3jradfnbkrjlfthgsg00', '');

CREATE TABLE `dsb_payments` (
  `payment_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `is_active` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `_user` varchar(32) NOT NULL,
  `gateway` varchar(32) NOT NULL,
  `is_subscr` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `fk_subscr_id` int(2) unsigned NOT NULL DEFAULT '0',
  `is_recurring` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `gw_txn` varchar(30) NOT NULL,
  `name` varchar(100) NOT NULL,
  `country` varchar(200) NOT NULL,
  `state` varchar(100) NOT NULL,
  `city` varchar(100) NOT NULL,
  `zip` varchar(20) NOT NULL,
  `street_address` varchar(255) NOT NULL,
  `email` varchar(128) NOT NULL,
  `phone` varchar(30) NOT NULL,
  `m_value_to` int(10) unsigned NOT NULL DEFAULT '0',
  `amount_paid` float(10,2) unsigned NOT NULL DEFAULT '0.00',
  `refunded` float(10,2) NOT NULL DEFAULT '0.00',
  `paid_from` date NOT NULL DEFAULT '0000-00-00',
  `paid_until` date NOT NULL DEFAULT '0000-00-00',
  `is_suspect` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `suspect_reason` text NOT NULL,
  `date` datetime DEFAULT NULL,
  PRIMARY KEY (`payment_id`),
  KEY `date` (`date`),
  KEY `fk_subscr_id` (`fk_subscr_id`),
  KEY `uid_until` (`fk_user_id`,`paid_until`),
  KEY `active_until` (`is_active`,`paid_until`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_profile_categories` (
  `pcat_id` int(5) unsigned NOT NULL AUTO_INCREMENT,
  `fk_lk_id_pcat` int(5) unsigned NOT NULL DEFAULT '0',
  `access_level` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`pcat_id`),
  KEY `access_level` (`access_level`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_profile_categories` (`pcat_id`, `fk_lk_id_pcat`, `access_level`) VALUES
(6, 2275, 7),
(7, 2276, 7),
(8, 2277, 7),
(9, 2278, 7),
(10, 2279, 7);

CREATE TABLE `dsb_profile_fields` (
  `pfield_id` int(5) unsigned NOT NULL AUTO_INCREMENT,
  `fk_lk_id_label` int(5) unsigned NOT NULL DEFAULT '0',
  `field_type` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `searchable` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `search_type` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `for_basic` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `fk_lk_id_search` int(5) unsigned NOT NULL DEFAULT '0',
  `at_registration` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `reg_page` tinyint(2) unsigned NOT NULL DEFAULT '1',
  `required` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `editable` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `visible` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `dbfield` varchar(32) NOT NULL,
  `fk_lk_id_help` int(5) unsigned NOT NULL DEFAULT '0',
  `fk_pcat_id` int(5) unsigned NOT NULL DEFAULT '0',
  `access_level` int(10) unsigned NOT NULL DEFAULT '0',
  `accepted_values` text NOT NULL,
  `default_value` varchar(255) NOT NULL,
  `default_search` varchar(255) NOT NULL,
  `fn_on_change` varchar(100) NOT NULL,
  `order_num` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`pfield_id`),
  KEY `order_num` (`order_num`),
  KEY `fk_lk_id_help` (`fk_lk_id_help`),
  KEY `fk_lk_id_label` (`fk_lk_id_label`),
  KEY `fk_lk_id_search` (`fk_lk_id_search`),
  KEY `fk_pcat_id` (`fk_pcat_id`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_profile_fields` (`pfield_id`, `fk_lk_id_label`, `field_type`, `searchable`, `search_type`, `for_basic`, `fk_lk_id_search`, `at_registration`, `reg_page`, `required`, `editable`, `visible`, `dbfield`, `fk_lk_id_help`, `fk_pcat_id`, `access_level`, `accepted_values`, `default_value`, `default_search`, `fn_on_change`, `order_num`) VALUES
(16, 2282, 3, 1, 10, 1, 2283, 1, 1, 1, 1, 1, 'f1', 2284, 6, 0, '|2280|2281|', '|0|', '|1|', '', 1),
(17, 2287, 10, 1, 10, 1, 2288, 1, 1, 1, 1, 1, 'f2', 2289, 6, 0, '|2285|2286|', '|1|', '|0|', '', 2),
(18, 2290, 103, 1, 108, 1, 2291, 1, 1, 0, 1, 1, 'f3', 2292, 6, 0, '|1930|1989|', '', '|18|75|', '', 3),
(19, 2293, 107, 1, 107, 1, 2294, 1, 1, 0, 1, 1, 'f4', 2295, 6, 0, '', '|218|', '', 'update_location', 4),
(20, 2296, 4, 0, 1, 0, 2297, 1, 2, 0, 1, 1, 'f5', 2298, 6, 0, '', '', '', '', 5),
(21, 2308, 3, 1, 10, 0, 2309, 1, 2, 0, 1, 1, 'f6', 2310, 7, 0, '|2299|2300|2301|2302|2303|2304|2305|2306|2307|', '', '', '', 6),
(22, 2323, 3, 1, 108, 0, 2324, 1, 2, 0, 1, 1, 'f7', 2325, 7, 0, '|2311|2312|2313|2314|2315|2316|2317|2318|2319|2320|2321|2322|2326|2327|', '', '|0|13|', '', 7),
(23, 2337, 3, 1, 10, 0, 2338, 1, 2, 0, 1, 1, 'f8', 2339, 7, 0, '|2328|2329|2330|2331|2332|2333|2334|2335|2336|', '', '', '', 8),
(24, 2346, 3, 1, 3, 0, 2347, 1, 2, 0, 1, 1, 'f9', 2348, 7, 0, '|2340|2341|2342|2343|2344|2345|', '', '', '', 9),
(25, 2358, 3, 1, 10, 0, 2359, 1, 2, 0, 1, 1, 'f10', 2360, 7, 0, '|2349|2350|2351|2352|2353|2354|2355|2356|2357|', '', '', '', 10),
(26, 2364, 3, 1, 10, 0, 2365, 1, 2, 0, 1, 1, 'f11', 2366, 8, 0, '|2361|2362|2363|', '', '', '', 11),
(27, 2370, 3, 1, 10, 0, 2371, 1, 2, 0, 1, 1, 'f12', 2372, 8, 0, '|2367|2368|2369|', '', '', '', 12),
(28, 2378, 3, 1, 3, 0, 2379, 1, 2, 0, 1, 1, 'f13', 2380, 8, 0, '|2373|2374|2375|2376|2377|', '', '', '', 13),
(29, 2385, 3, 1, 3, 0, 2386, 1, 2, 0, 1, 1, 'f14', 2387, 9, 0, '|2381|2382|2383|2384|', '', '', '', 14),
(30, 2395, 10, 1, 10, 0, 2396, 1, 2, 0, 1, 1, 'f15', 2397, 9, 0, '|2388|2389|2390|2391|2392|2393|2394|', '', '', '', 15);

CREATE TABLE `dsb_profile_fields2` (
  `pfield_id` int(5) unsigned NOT NULL AUTO_INCREMENT,
  `fk_lk_id_label` int(5) unsigned NOT NULL DEFAULT '0',
  `field_type` varchar(100) NOT NULL,
  `searchable` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `search_type` varchar(100) NOT NULL,
  `for_basic` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `fk_lk_id_search` int(5) unsigned NOT NULL DEFAULT '0',
  `at_registration` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `reg_page` tinyint(2) unsigned NOT NULL DEFAULT '1',
  `required` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `editable` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `visible` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `dbfield` varchar(32) NOT NULL,
  `fk_lk_id_help` int(5) unsigned NOT NULL DEFAULT '0',
  `fk_pcat_id` int(5) unsigned NOT NULL DEFAULT '0',
  `search_access_level` int(10) unsigned NOT NULL DEFAULT '0',
  `custom_config` text NOT NULL,
  `fn_on_change` varchar(100) NOT NULL,
  `order_num` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`pfield_id`),
  KEY `order_num` (`order_num`),
  KEY `fk_lk_id_help` (`fk_lk_id_help`),
  KEY `fk_lk_id_label` (`fk_lk_id_label`),
  KEY `fk_lk_id_search` (`fk_lk_id_search`),
  KEY `fk_pcat_id` (`fk_pcat_id`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_profile_fields2` (`pfield_id`, `fk_lk_id_label`, `field_type`, `searchable`, `search_type`, `for_basic`, `fk_lk_id_search`, `at_registration`, `reg_page`, `required`, `editable`, `visible`, `dbfield`, `fk_lk_id_help`, `fk_pcat_id`, `search_access_level`, `custom_config`, `fn_on_change`, `order_num`) VALUES
(16, 2282, 'field_select', 1, 'field_mchecks', 1, 2283, 1, 1, 1, 1, 1, 'f1', 2284, 6, 0, 'a:2:{s:15:"accepted_values";s:59:"array('''',&$GLOBALS[''_lang''][2280],&$GLOBALS[''_lang''][2281])";s:13:"default_value";i:0;}', '', 1),
(17, 2287, 'field_mchecks', 1, 'field_mchecks', 1, 2288, 1, 1, 1, 1, 1, 'f2', 2289, 6, 0, 'a:3:{s:15:"accepted_values";s:59:"array('''',&$GLOBALS[''_lang''][2285],&$GLOBALS[''_lang''][2286])";s:13:"default_value";s:7:"array()";s:14:"search_default";s:7:"array()";}', '', 2),
(18, 2290, 'field_birthdate', 1, 'field_age_range', 1, 2291, 1, 1, 0, 1, 1, 'f3', 2292, 6, 0, 'a:2:{s:15:"accepted_values";a:2:{s:3:"min";i:18;s:3:"max";i:80;}s:14:"search_default";a:2:{s:3:"min";i:18;s:3:"max";i:80;}}', '', 3),
(19, 2293, 'field_location', 1, 'field_location', 1, 2294, 1, 1, 0, 1, 1, 'f4', 2295, 6, 0, 'a:1:{s:11:"def_country";i:0;}', 'update_location', 4),
(20, 2296, 'field_textarea', 0, '', 0, 2297, 1, 2, 0, 1, 1, 'f5', 2298, 6, 0, 'a:4:{s:10:"use_bbcode";i:1;s:11:"use_smilies";i:1;s:14:"changes_status";i:0;s:6:"ta_len";i:1000;}', '', 5),
(21, 2308, 'field_select', 1, 'field_mchecks', 0, 2309, 1, 2, 0, 1, 1, 'f6', 2310, 7, 0, 'a:1:{s:15:"accepted_values";s:234:"array('''',&$GLOBALS[''_lang''][2299],&$GLOBALS[''_lang''][2300],&$GLOBALS[''_lang''][2301],&$GLOBALS[''_lang''][2302],&$GLOBALS[''_lang''][2303],&$GLOBALS[''_lang''][2304],&$GLOBALS[''_lang''][2305],&$GLOBALS[''_lang''][2306],&$GLOBALS[''_lang''][2307])";}', '', 6),
(22, 2323, 'field_select', 1, 'field_range', 0, 2324, 1, 2, 0, 1, 1, 'f7', 2325, 7, 0, 'a:3:{s:15:"accepted_values";s:359:"array('''',&$GLOBALS[''_lang''][2311],&$GLOBALS[''_lang''][2312],&$GLOBALS[''_lang''][2313],&$GLOBALS[''_lang''][2314],&$GLOBALS[''_lang''][2315],&$GLOBALS[''_lang''][2316],&$GLOBALS[''_lang''][2317],&$GLOBALS[''_lang''][2318],&$GLOBALS[''_lang''][2319],&$GLOBALS[''_lang''][2320],&$GLOBALS[''_lang''][2321],&$GLOBALS[''_lang''][2322],&$GLOBALS[''_lang''][2326],&$GLOBALS[''_lang''][2327])";s:13:"default_value";i:0;s:14:"search_default";s:7:"array()";}', '', 7),
(23, 2337, 'field_select', 1, 'field_mchecks', 0, 2338, 1, 2, 0, 1, 1, 'f8', 2339, 7, 0, 'a:3:{s:15:"accepted_values";s:234:"array('''',&$GLOBALS[''_lang''][2328],&$GLOBALS[''_lang''][2329],&$GLOBALS[''_lang''][2330],&$GLOBALS[''_lang''][2331],&$GLOBALS[''_lang''][2332],&$GLOBALS[''_lang''][2333],&$GLOBALS[''_lang''][2334],&$GLOBALS[''_lang''][2335],&$GLOBALS[''_lang''][2336])";s:13:"default_value";i:0;s:14:"search_default";s:7:"array()";}', '', 8),
(24, 2346, 'field_select', 1, 'field_select', 0, 2347, 1, 2, 0, 1, 1, 'f9', 2348, 7, 0, 'a:1:{s:15:"accepted_values";s:159:"array('''',&$GLOBALS[''_lang''][2340],&$GLOBALS[''_lang''][2341],&$GLOBALS[''_lang''][2342],&$GLOBALS[''_lang''][2343],&$GLOBALS[''_lang''][2344],&$GLOBALS[''_lang''][2345])";}', '', 9),
(25, 2358, 'field_select', 1, 'field_mchecks', 0, 2359, 1, 2, 0, 1, 1, 'f10', 2360, 7, 0, 'a:1:{s:15:"accepted_values";s:234:"array('''',&$GLOBALS[''_lang''][2349],&$GLOBALS[''_lang''][2350],&$GLOBALS[''_lang''][2351],&$GLOBALS[''_lang''][2352],&$GLOBALS[''_lang''][2353],&$GLOBALS[''_lang''][2354],&$GLOBALS[''_lang''][2355],&$GLOBALS[''_lang''][2356],&$GLOBALS[''_lang''][2357])";}', '', 10),
(26, 2364, 'field_select', 1, 'field_mchecks', 0, 2365, 1, 2, 0, 1, 1, 'f11', 2366, 8, 0, 'a:1:{s:15:"accepted_values";s:84:"array('''',&$GLOBALS[''_lang''][2361],&$GLOBALS[''_lang''][2362],&$GLOBALS[''_lang''][2363])";}', '', 11),
(27, 2370, 'field_select', 1, 'field_mchecks', 0, 2371, 1, 2, 0, 1, 1, 'f12', 2372, 8, 0, 'a:1:{s:15:"accepted_values";s:84:"array('''',&$GLOBALS[''_lang''][2367],&$GLOBALS[''_lang''][2368],&$GLOBALS[''_lang''][2369])";}', '', 12),
(28, 2378, 'field_select', 1, 'field_select', 0, 2379, 1, 2, 0, 1, 1, 'f13', 2380, 8, 0, 'a:1:{s:15:"accepted_values";s:134:"array('''',&$GLOBALS[''_lang''][2373],&$GLOBALS[''_lang''][2374],&$GLOBALS[''_lang''][2375],&$GLOBALS[''_lang''][2376],&$GLOBALS[''_lang''][2377])";}', '', 13),
(29, 2385, 'field_select', 1, 'field_select', 0, 2386, 1, 2, 0, 1, 1, 'f14', 2387, 9, 0, 'a:1:{s:15:"accepted_values";s:109:"array('''',&$GLOBALS[''_lang''][2381],&$GLOBALS[''_lang''][2382],&$GLOBALS[''_lang''][2383],&$GLOBALS[''_lang''][2384])";}', '', 14),
(30, 2395, 'field_mchecks', 1, 'field_mchecks', 0, 2396, 1, 2, 0, 1, 1, 'f15', 2397, 9, 0, 'a:1:{s:15:"accepted_values";s:184:"array('''',&$GLOBALS[''_lang''][2388],&$GLOBALS[''_lang''][2389],&$GLOBALS[''_lang''][2390],&$GLOBALS[''_lang''][2391],&$GLOBALS[''_lang''][2392],&$GLOBALS[''_lang''][2393],&$GLOBALS[''_lang''][2394])";}', '', 15);

CREATE TABLE `dsb_profile_field_accvals` (
  `accval_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fk_lk_id_name` int(5) unsigned NOT NULL DEFAULT '0',
  `fk_pfield_id` int(5) unsigned NOT NULL DEFAULT '0',
  `def_value` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `search_value` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `sort` smallint(5) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`accval_id`),
  UNIQUE KEY `pfield_sort` (`fk_pfield_id`,`sort`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_profile_field_accvals` (`accval_id`, `fk_lk_id_name`, `fk_pfield_id`, `def_value`, `search_value`, `sort`) VALUES
(1, 2280, 16, 1, 0, 0),
(2, 2281, 16, 0, 0, 1),
(3, 2299, 21, 0, 0, 0),
(4, 2300, 21, 0, 0, 1),
(5, 2301, 21, 0, 0, 2),
(6, 2302, 21, 0, 0, 3),
(7, 2303, 21, 0, 0, 4),
(8, 2304, 21, 0, 0, 5),
(9, 2305, 21, 0, 0, 6),
(10, 2306, 21, 0, 0, 7),
(11, 2307, 21, 0, 0, 8),
(12, 2311, 22, 0, 0, 0),
(13, 2312, 22, 0, 0, 1),
(14, 2313, 22, 0, 0, 2),
(15, 2314, 22, 0, 0, 3),
(16, 2315, 22, 0, 0, 4),
(17, 2316, 22, 0, 0, 5),
(18, 2317, 22, 0, 1, 6),
(19, 2318, 22, 0, 0, 7),
(20, 2319, 22, 0, 0, 8),
(21, 2320, 22, 0, 0, 9),
(22, 2321, 22, 0, 0, 10),
(23, 2322, 22, 0, 0, 11),
(24, 2326, 22, 0, 0, 12),
(25, 2327, 22, 0, 0, 13),
(26, 2328, 23, 0, 0, 0),
(27, 2329, 23, 0, 0, 1),
(28, 2330, 23, 0, 0, 2),
(29, 2331, 23, 0, 0, 3),
(30, 2332, 23, 0, 0, 4),
(31, 2333, 23, 0, 0, 5),
(32, 2334, 23, 0, 0, 6),
(33, 2335, 23, 0, 0, 7),
(34, 2336, 23, 0, 0, 8),
(35, 2340, 24, 0, 0, 0),
(36, 2341, 24, 0, 0, 1),
(37, 2342, 24, 0, 0, 2),
(38, 2343, 24, 0, 0, 3),
(39, 2344, 24, 0, 0, 4),
(40, 2345, 24, 0, 0, 5),
(41, 2349, 25, 0, 0, 0),
(42, 2350, 25, 0, 0, 1),
(43, 2351, 25, 0, 0, 2),
(44, 2352, 25, 0, 0, 3),
(45, 2353, 25, 0, 0, 4),
(46, 2354, 25, 0, 0, 5),
(47, 2355, 25, 0, 0, 6),
(48, 2356, 25, 0, 0, 7),
(49, 2357, 25, 0, 0, 8),
(50, 2361, 26, 0, 0, 0),
(51, 2362, 26, 0, 0, 1),
(52, 2363, 26, 0, 0, 2),
(53, 2367, 27, 0, 0, 0),
(54, 2368, 27, 0, 0, 1),
(55, 2369, 27, 0, 0, 2),
(56, 2373, 28, 0, 0, 0),
(57, 2374, 28, 0, 0, 1),
(58, 2375, 28, 0, 0, 2),
(59, 2376, 28, 0, 0, 3),
(60, 2377, 28, 0, 0, 4),
(61, 2381, 29, 0, 0, 0),
(62, 2382, 29, 0, 0, 1),
(63, 2383, 29, 0, 0, 2),
(64, 2384, 29, 0, 0, 3),
(65, 2285, 17, 1, 0, 0),
(66, 2286, 17, 0, 0, 1),
(67, 2388, 30, 0, 0, 0),
(68, 2389, 30, 0, 0, 1),
(69, 2390, 30, 0, 0, 2),
(70, 2391, 30, 0, 0, 3),
(71, 2392, 30, 0, 0, 4),
(72, 2393, 30, 0, 0, 5),
(73, 2394, 30, 0, 0, 6);
 
CREATE TABLE `dsb_queue_email` (
  `mail_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `to` varchar(100) NOT NULL,
  `subject` varchar(100) NOT NULL,
  `message_body` text NOT NULL,
  `date_added` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`mail_id`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_queue_message` (
  `mail_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `fk_user_id_other` int(10) unsigned NOT NULL DEFAULT '0',
  `_user_other` varchar(48) NOT NULL,
  `subject` varchar(100) NOT NULL,
  `message_body` text NOT NULL,
  `date_sent` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `message_type` tinyint(2) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`mail_id`),
  KEY `from_id` (`fk_user_id_other`),
  KEY `to_id` (`fk_user_id`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_rate_limiter` (
  `rate_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `level_code` varchar(30) NOT NULL,
  `m_value` int(10) unsigned NOT NULL DEFAULT '0',
  `limit` int(5) unsigned NOT NULL DEFAULT '0',
  `interval` int(10) unsigned NOT NULL DEFAULT '0',
  `punishment` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `fk_lk_id_error_message` int(5) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`rate_id`),
  KEY `lcode_mval` (`level_code`,`m_value`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_rating_blog` (
  `fk_parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `vote` int(2) unsigned NOT NULL DEFAULT '0',
  `date_voted` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  KEY `uid_date` (`fk_user_id`,`date_voted`),
  KEY `fk_parent_id` (`fk_parent_id`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_rating_photo` (
  `fk_parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `vote` int(2) unsigned NOT NULL DEFAULT '0',
  `date_voted` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  KEY `uid_date` (`fk_user_id`,`date_voted`),
  KEY `fk_parent_id` (`fk_parent_id`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_rating_profile` (
  `fk_parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `vote` int(2) unsigned NOT NULL DEFAULT '0',
  `date_voted` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  KEY `uid_date` (`fk_user_id`,`date_voted`),
  KEY `fk_parent_id` (`fk_parent_id`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_site_bans` (
  `ban_id` int(5) unsigned NOT NULL AUTO_INCREMENT,
  `ban_type` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `what` varchar(32) NOT NULL,
  `fk_lk_id_reason` int(5) unsigned NOT NULL DEFAULT '0',
  `since` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`ban_id`),
  UNIQUE KEY `btype_what` (`ban_type`,`what`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_site_log` (
  `log_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `user` varchar(64) NOT NULL,
  `m_value` int(10) unsigned NOT NULL DEFAULT '0',
  `level_code` varchar(30) NOT NULL,
  `ip` int(12) unsigned NOT NULL DEFAULT '0',
  `time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `sess` varchar(32) NOT NULL,
  PRIMARY KEY (`log_id`),
  KEY `uid_code_time` (`fk_user_id`,`level_code`,`time`),
  KEY `sess_ip` (`sess`,`ip`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_site_news` (
  `news_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `news_title` varchar(255) NOT NULL,
  `news_body` text NOT NULL,
  `date_posted` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`news_id`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_site_options3` (
  `config_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `config_option` varchar(50) NOT NULL,
  `config_value` varchar(100) NOT NULL,
  `config_diz` text NOT NULL,
  `option_type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `choices` text NOT NULL,
  `fk_module_code` varchar(32) NOT NULL,
  `per_user` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`config_id`),
  UNIQUE KEY `copt_mcode` (`config_option`,`fk_module_code`),
  KEY `per_user` (`per_user`),
  KEY `fk_module_code` (`fk_module_code`)
) ENGINE=MyISAM ;

INSERT INTO `dsb_site_options3` (`config_id`, `config_option`, `config_value`, `config_diz`, `option_type`, `choices`, `fk_module_code`, `per_user`) VALUES
(1, 'dbfield_index', '16', 'The last index of the custom profile fields (f**)', 0, '', 'core', 0),
(89, 'use_captcha', '0', 'Enable Google reCaptcha to keep spam bots out?', 9, '', 'core', 0),
(3, 'manual_profile_approval', '0', 'New profiles or changes to existing profiles require manual approval from an administrator before being displayed on site?', 9, '', 'core', 0),
(4, 'date_format', '%m/%d/%Y', 'Default date format', 2, '', 'def_user_prefs', 1),
(5, 't1_width', '100', 'The width in pixels of the smallest thumbnail generated for each user photo', 104, '', 'core_photo', 0),
(6, 't2_width', '500', 'The width in pixels of the larger thumbnail generated for each user photo', 104, '', 'core_photo', 0),
(7, 'pic_width', '800', 'The maximum width in pixels of any picture uploaded by a member', 104, '', 'core_photo', 0),
(8, 'manual_photo_approval', '0', 'New uploaded photos require manual approval before being displayed on the site?', 9, '', 'core_photo', 0),
(9, 'manual_blog_approval', '1', 'New blog posts or changes to existing posts require manual approval from an administrator before being displayed on site?', 9, '', 'core_blog', 0),
(10, 'manual_com_approval', '0', 'Comments to profiles, photos, blogs require manual approval from an administrator before being displayed on site?', 9, '', 'core', 0),
(11, 'watermark_text', '', 'The text to stamp the user photos with', 2, '', 'core_photo', 0),
(12, 'watermark_text_color', '', 'Color of the text watermark', 2, '', 'core_photo', 0),
(13, 'enabled', '1', 'Module enabled?', 9, '', 'paypal', 0),
(14, 'paypal_email', '', 'Your paypal email address', 2, '', 'paypal', 0),
(18, 'demo_mode', '1', 'Enable test mode? Don''t enable this on a live site!', 9, '', 'paypal', 0),
(20, 'license_key', '1234', 'Your Maxmind license key', 2, '', 'maxmind', 0),
(21, 'use_queue', '1', 'Use the message queue (recommended) or send the messages directly?', 9, '', 'core', 0),
(22, 'mail_from', '', 'Email address used to communicate with members', 2, '', 'core', 0),
(24, 'bbcode_comments', '1', 'Use BBcode in comments?', 9, '', 'core', 0),
(32, 'min_size', '0', 'Minimum photo file size in bytes (use 0 for not limited).', 104, '', 'core_photo', 0),
(33, 'max_size', '0', 'Maximum photo file size in bytes (use 0 for server default).', 104, '', 'core_photo', 0),
(34, 'bbcode_message', '1', 'Allow BBCode in member to member messages?', 9, '', 'core', 0),
(35, 'datetime_format', '%m/%d/%Y %I:%M %p', 'Date and time format', 2, '', 'def_user_prefs', 1),
(36, 'round_corners', '0', 'Use round corners for user photos?', 9, '', 'core_photo', 0),
(39, 'skin_dir', 'def', '', 0, '', 'skin_def', 0),
(40, 'skin_name', 'Default', '', 0, '', 'skin_def', 0),
(41, 'fk_locale_id', '11', '', 0, '', 'skin_def', 0),
(42, 'is_default', '1', '', 0, '', 'skin_def', 0),
(43, 'inactive_time', '5', 'Time of inactivity in minutes after a member is considered offline', 104, '', 'core', 0),
(44, 'bbcode_blogs', '1', 'Allow bbcode in blog posts?', 9, '', 'core_blog', 0),
(45, 'send_alert_interval', '2', 'How often do you want to receive your search matches? (days)', 104, '', 'def_user_prefs', 1),
(47, 'rate_my_photos', '1', 'Allow my photos to be rated?', 9, '', 'def_user_prefs', 1),
(48, 'purge_unverified', '7', 'Purge unverified accounts after how many days?', 104, '', 'core', 0),
(50, 'notify_me', '1', 'Send me email notifications when I receive messages?', 9, '', 'def_user_prefs', 1),
(51, 'mail_crlf', '1', 'Check or uncheck this option if you can''t send emails out to members or they look garbled', 9, '', 'core', 0),
(53, 'smilies_comm', '1', 'Allow smilies in user comments?', 9, '', 'core', 0),
(54, 'use_smilies', '1', 'Allow smilies in blogs?', 9, '', 'core_blog', 0),
(55, 'profile_comments', '1', 'Allow comments on my profile?', 9, '', 'def_user_prefs', 1),
(59, 'purge_inbox', '30', 'Purge old messages from member inboxes after how many days? (0 for never)', 104, '', 'core', 0),
(60, 'purge_trash', '14', 'Purge old messages from member spam boxes and trash after how many days? (0 for never)', 104, '', 'core', 0),
(61, 'purge_folders', '30', 'Purge old messages from member personal folders after how many days? (0 for never)', 104, '', 'core', 0),
(62, 'purge_outbox', '7', 'Purge old messages from member outboxes after how many days? (0 for never)', 104, '', 'core', 0),
(63, 'time_offset', '0', 'Select your timezone (<a href="javascript:;" id="auto_detect_tz">auto detect</a>)', 3, 'a:26:{i:-43200;s:7:"GMT -12";i:-39600;s:7:"GMT -11";i:-36000;s:7:"GMT -10";i:-32400;s:6:"GMT -9";i:-28800;s:6:"GMT -8";i:-25200;s:6:"GMT -7";i:-21600;s:6:"GMT -6";i:-18000;s:6:"GMT -5";i:-14400;s:6:"GMT -4";i:-10800;s:6:"GMT -3";i:-7200;s:6:"GMT -2";i:-3600;s:6:"GMT -1";i:0;s:3:"GMT";i:3600;s:6:"GMT +1";i:7200;s:6:"GMT +2";i:10800;s:6:"GMT +3";i:1440;s:6:"GMT +4";i:18000;s:6:"GMT +5";i:21600;s:6:"GMT +6";i:25200;s:6:"GMT +7";i:28800;s:6:"GMT +8";i:32400;s:6:"GMT +9";i:36000;s:7:"GMT +10";i:39600;s:7:"GMT +11";i:43200;s:7:"GMT +12";i:46800;s:7:"GMT +13";}', 'def_user_prefs', 1),
(64, 'collect_errors', '1', 'Send reports about errors in your site to Datemill? This helps us improve the application.', 9, '', 'adv_features', 0),
(70, 'items', '5', 'How many comments to display in the list?', 2, '', 'latest_blog_comments', 0),
(69, 'enabled', '1', 'Enabled?', 9, '', 'latest_blog_comments', 0),
(71, 'enabled', '0', 'Module Enabled?', 9, '', 'maxmind', 0),
(72, 'pdt_token', '', 'Payment Data Transfer Identity Token: ', 2, '', 'paypal', 0),
(73, 'max_user_photos', '-1', 'Maximum number of photos a member is allowed to have (use -1 for unlimited).<br />Note that most of existing members will not be affected, only new ones.', 104, '', 'core_photo', 0),
(82, 'allow_news', '1', 'I want to receive occasional newsletters', 9, '', 'def_user_prefs', 1),
(84, 'watermark_image', '', 'The image used to stamp user photos with. (must be a .png file)', 101, '/images', 'core_photo', 0),
(75, 'alert_email', '', 'Send alerts to this email address', 2, '', 'core', 0),
(76, 'alert_on_join', '0', 'Send me alerts when a new user joins?', 9, '', 'core', 0),
(77, 'alert_on_cancel', '0', 'Send me alerts when a user cancels?', 9, '', 'core', 0),
(85, 'google_sec_key', '', 'Your Google reCaptcha secret key', 2, '', 'core', 0),
(86, 'google_site_key', '', 'Your Google reCaptcha site key', 2, '', 'core', 0),
(87, 'google_webmaster', '', 'Your Google webmaster code', 2, '', 'core', 0),
(88, 'google_analytics', '', 'Your Google analytics code', 2, '', 'core', 0),
(66, 'purge_spambox', '14', 'Purge old messages from member spam boxes after how many days? (0 for never)', 104, '', 'core', 0);

CREATE TABLE `dsb_site_searches` (
  `search_md5` varchar(32) NOT NULL,
  `search_type` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `search` text NOT NULL,
  `results` text NOT NULL,
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `date_posted` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  UNIQUE KEY `search_md5` (`search_md5`,`search_type`),
  KEY `fk_user_id` (`fk_user_id`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_stats_dot` (
  `dot_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `dataset` varchar(48) NOT NULL,
  `value` int(10) NOT NULL DEFAULT '0',
  `time` int(8) NOT NULL DEFAULT '0',
  PRIMARY KEY (`dot_id`),
  UNIQUE KEY `dset_time` (`dataset`,`time`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_subscriptions` (
  `subscr_id` int(2) unsigned NOT NULL AUTO_INCREMENT,
  `subscr_name` varchar(200) NOT NULL,
  `subscr_diz` text NOT NULL,
  `price` float(10,2) unsigned NOT NULL DEFAULT '0.00',
  `currency` char(3) NOT NULL,
  `is_recurent` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `m_value_to` int(10) unsigned NOT NULL DEFAULT '0',
  `duration` int(4) unsigned NOT NULL DEFAULT '0',
  `is_visible` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`subscr_id`),
  KEY `is_visible` (`is_visible`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_subscriptions_auto` (
  `asubscr_id` int(3) unsigned NOT NULL AUTO_INCREMENT,
  `dbfield` varchar(32) NOT NULL,
  `field_value` int(5) NOT NULL DEFAULT '0',
  `fk_subscr_id` int(2) unsigned NOT NULL DEFAULT '0',
  `date_start` date NOT NULL DEFAULT '0000-00-00',
  PRIMARY KEY (`asubscr_id`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_user_accounts` (
  `user_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user` varchar(32) NOT NULL,
  `pass` varchar(32) NOT NULL,
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `membership` int(10) unsigned NOT NULL DEFAULT '0',
  `email` varchar(128) NOT NULL,
  `skin` varchar(32) NOT NULL,
  `temp_pass` varchar(32) NOT NULL,
  `last_activity` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`user_id`),
  UNIQUE KEY `user` (`user`),
  KEY `email` (`email`),
  KEY `stat_temp` (`status`,`temp_pass`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_user_blogs` (
  `blog_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `blog_name` varchar(100) NOT NULL,
  `blog_diz` varchar(255) NOT NULL,
  `stat_posts` int(4) unsigned NOT NULL DEFAULT '0',
  `blog_skin` varchar(32) NOT NULL,
  `alt_url` varchar(255) NOT NULL,
  PRIMARY KEY (`blog_id`),
  KEY `fk_user_id` (`fk_user_id`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_user_folders` (
  `folder_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `folder` varchar(32) NOT NULL,
  PRIMARY KEY (`folder_id`),
  UNIQUE KEY `fk_user_id` (`fk_user_id`,`folder`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_user_inbox` (
  `mail_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `is_read` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `fk_user_id_other` int(10) unsigned NOT NULL DEFAULT '0',
  `_user_other` varchar(32) NOT NULL,
  `subject` varchar(100) NOT NULL,
  `message_body` text NOT NULL,
  `date_sent` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `message_type` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `fk_folder_id` int(10) unsigned NOT NULL DEFAULT '0',
  `del` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`mail_id`),
  KEY `uid_fid_del` (`fk_user_id`,`fk_folder_id`,`del`),
  KEY `from_to` (`fk_user_id_other`,`fk_user_id`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_user_mtpls` (
  `mtpl_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(100) NOT NULL,
  `message_body` text NOT NULL,
  PRIMARY KEY (`mtpl_id`),
  KEY `fk_user_id` (`fk_user_id`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_user_networks` (
  `nconn_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `fk_net_id` int(10) unsigned NOT NULL DEFAULT '0',
  `fk_user_id_other` int(10) unsigned NOT NULL DEFAULT '0',
  `nconn_status` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`nconn_id`),
  UNIQUE KEY `uid_nid_uido` (`fk_user_id`,`fk_net_id`,`fk_user_id_other`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_user_outbox` (
  `mail_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `is_read` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `fk_user_id_other` int(10) unsigned NOT NULL DEFAULT '0',
  `_user_other` varchar(32) NOT NULL,
  `subject` varchar(100) NOT NULL,
  `message_body` text NOT NULL,
  `date_sent` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `message_type` tinyint(2) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`mail_id`),
  KEY `from_id` (`fk_user_id_other`),
  KEY `user_id_2` (`fk_user_id`)) ENGINE=MyISAM ;
  
CREATE TABLE `dsb_user_photos` (
  `photo_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `_user` varchar(48) NOT NULL,
  `photo` varchar(128) NOT NULL,
  `is_main` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `is_private` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `allow_comments` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `allow_rating` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `caption` varchar(255) NOT NULL,
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `del` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `flagged` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `reject_reason` text NOT NULL,
  `stat_views` int(10) unsigned NOT NULL DEFAULT '0',
  `stat_votes` int(4) unsigned NOT NULL DEFAULT '0',
  `stat_votes_total` int(5) unsigned NOT NULL DEFAULT '0',
  `stat_comments` int(5) unsigned NOT NULL DEFAULT '0',
  `date_posted` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `last_changed` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `processed` tinyint(2) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`photo_id`),
  KEY `fk_user_id` (`fk_user_id`),
  KEY `is_main` (`is_main`),
  KEY `is_private` (`is_private`),
  KEY `date_posted` (`date_posted`),
  KEY `flagged` (`flagged`),
  KEY `stat_del` (`status`,`del`),
  FULLTEXT KEY `caption` (`caption`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_user_profiles` (
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `del` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `last_changed` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `date_added` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reject_reason` text NOT NULL,
  `_user` varchar(32) NOT NULL,
  `_photo` varchar(128) NOT NULL,
  `alt_url` text NOT NULL,
  `rad_longitude` double NOT NULL DEFAULT '0',
  `rad_latitude` double NOT NULL DEFAULT '0',
  `score` float(10,2) NOT NULL DEFAULT '0.00',
  `f1` int(5) NOT NULL DEFAULT '0',
  `f2` text NOT NULL,
  `f3` date NOT NULL DEFAULT '0000-00-00',
  `f4_country` int(3) NOT NULL DEFAULT '0',
  `f4_state` int(10) NOT NULL DEFAULT '0',
  `f4_city` int(10) NOT NULL DEFAULT '0',
  `f4_zip` varchar(10) NOT NULL,
  `f5` text NOT NULL,
  `f6` int(5) NOT NULL DEFAULT '0',
  `f7` int(5) NOT NULL DEFAULT '0',
  `f8` int(5) NOT NULL DEFAULT '0',
  `f9` int(5) NOT NULL DEFAULT '0',
  `f10` int(5) NOT NULL DEFAULT '0',
  `f11` int(5) NOT NULL DEFAULT '0',
  `f12` int(5) NOT NULL DEFAULT '0',
  `f13` int(5) NOT NULL DEFAULT '0',
  `f14` int(5) NOT NULL DEFAULT '0',
  `f15` text NOT NULL,
  PRIMARY KEY (`fk_user_id`),
  KEY `fk_user_id` (`fk_user_id`),
  KEY `score` (`score`),
  KEY `longitude` (`rad_longitude`,`rad_latitude`),
  KEY `_user_score` (`_user`,`score`),
  KEY `status_del` (`status`,`del`),
  KEY `searchkey` (`f1`,`f3`,`f4_country`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_user_searches` (
  `search_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(100) NOT NULL,
  `is_default` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `search_qs` text NOT NULL,
  `search` text NOT NULL,
  `alert` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `alert_last_id` int(10) unsigned NOT NULL DEFAULT '0',
  `alert_last_sent` date NOT NULL DEFAULT '0000-00-00',
  PRIMARY KEY (`search_id`),
  KEY `alert` (`alert`),
  KEY `uid_isdef` (`fk_user_id`,`is_default`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_user_settings2` (
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `config_option` varchar(50) NOT NULL,
  `config_value` varchar(100) NOT NULL,
  `fk_module_code` varchar(32) NOT NULL,
  UNIQUE KEY `uid_copt_mcode` (`fk_user_id`,`config_option`,`fk_module_code`),
  KEY `fk_module_code` (`fk_module_code`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_user_spambox` (
  `mail_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `is_read` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `fk_user_id_other` int(10) unsigned NOT NULL DEFAULT '0',
  `_user_other` varchar(32) NOT NULL,
  `subject` varchar(100) NOT NULL,
  `message_body` text NOT NULL,
  `date_sent` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `message_type` tinyint(2) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`mail_id`),
  KEY `from_id` (`fk_user_id_other`),
  KEY `user_id_2` (`fk_user_id`)
) ENGINE=MyISAM ;

CREATE TABLE `dsb_user_stats` (
  `fk_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `stat` varchar(50) NOT NULL,
  `value` int(10) NOT NULL DEFAULT '0',
  UNIQUE KEY `uid_stat` (`fk_user_id`,`stat`)
) ENGINE=MyISAM ;